diff -pruN 3.0.13-5/aclocal.m4 3.2.0-3/aclocal.m4
--- 3.0.13-5/aclocal.m4	2019-12-16 04:15:45.000000000 +0000
+++ 3.2.0-3/aclocal.m4	2020-05-04 04:10:15.000000000 +0000
@@ -1482,6 +1482,7 @@ AC_SUBST([am__untar])
 
 m4_include([cmulocal/ax_cxx_compile_stdcxx_11.m4])
 m4_include([cmulocal/ax_prog_perl_modules.m4])
+m4_include([cmulocal/ax_python_module.m4])
 m4_include([cmulocal/bsd_sockets.m4])
 m4_include([cmulocal/common.m4])
 m4_include([cmulocal/cyrus.m4])
diff -pruN 3.0.13-5/backup/backupd.c 3.2.0-3/backup/backupd.c
--- 3.0.13-5/backup/backupd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/backupd.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #include <assert.h>
 #include <signal.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <unistd.h>
 
@@ -53,7 +54,6 @@
 #include <sys/types.h>
 
 #include "lib/bsearch.h"
-#include "lib/exitcodes.h"
 #include "lib/imparse.h"
 #include "lib/map.h"
 #include "lib/signals.h"
@@ -183,7 +183,7 @@ EXPORTED int service_init(int argc __att
                  char **envp __attribute__((unused)))
 {
     // FIXME should this be calling fatal? fatal exits directly
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -244,15 +244,15 @@ EXPORTED int service_main(int argc __att
         /* other params should be filled in */
         if (sasl_server_new("csync", config_servername, NULL, NULL, NULL,
                             NULL, 0, &backupd_saslconn) != SASL_OK)
-            fatal("SASL failed initializing: sasl_server_new()",EC_TEMPFAIL);
+            fatal("SASL failed initializing: sasl_server_new()",EX_TEMPFAIL);
 
         /* will always return something valid */
         secprops = mysasl_secprops(SASL_SEC_NOANONYMOUS);
         if (sasl_setprop(backupd_saslconn, SASL_SEC_PROPS, secprops) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
+            fatal("Failed to set SASL property", EX_TEMPFAIL);
 
         if (sasl_setprop(backupd_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
+            fatal("Failed to set SASL property", EX_TEMPFAIL);
 
         if (localip) {
             sasl_setprop(backupd_saslconn, SASL_IPLOCALPORT, localip);
@@ -261,7 +261,7 @@ EXPORTED int service_main(int argc __att
 
         if (remoteip) {
             if (sasl_setprop(backupd_saslconn, SASL_IPREMOTEPORT, remoteip) != SASL_OK)
-                fatal("failed to set sasl property", EC_TEMPFAIL);
+                fatal("failed to set sasl property", EX_TEMPFAIL);
             saslprops.ipremoteport = xstrdup(remoteip);
         }
 
@@ -271,7 +271,7 @@ EXPORTED int service_main(int argc __att
     proc_register(config_ident, backupd_clienthost, NULL, NULL, NULL);
 
     /* Set inactivity timer */
-    timeout = config_getint(IMAPOPT_SYNC_TIMEOUT);
+    timeout = config_getduration(IMAPOPT_SYNC_TIMEOUT, 's');
     if (timeout < 3) timeout = 3;
     prot_settimeout(backupd_in, timeout);
 
@@ -383,7 +383,7 @@ static void dobanner(void)
 
     prot_printf(backupd_out,
                 "* OK %s Cyrus backup server %s\r\n",
-                config_servername, cyrus_version());
+                config_servername, CYRUS_VERSION);
 
     prot_flush(backupd_out);
 }
@@ -790,7 +790,7 @@ static void cmd_authenticate(char *mech,
             syslog(LOG_NOTICE, "badlogin: %s %s [%s]",
                    backupd_clienthost, mech, sasl_errdetail(backupd_saslconn));
 
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
@@ -1537,6 +1537,9 @@ static void cmd_get(struct dlist *dl)
     else if (strcmp(dl->name, "META") == 0) {
         r = cmd_get_meta(dl);
     }
+    else if (strcmp(dl->name, "UNIQUEIDS") == 0) {
+        r = 0; // we don't send anything back other than OK
+    }
     else {
         r = IMAP_PROTOCOL_ERROR;
     }
diff -pruN 3.0.13-5/backup/ctl_backups.c 3.2.0-3/backup/ctl_backups.c
--- 3.0.13-5/backup/ctl_backups.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/ctl_backups.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,14 +49,16 @@
 
 #include <assert.h>
 #include <errno.h>
+#include <jansson.h>
 #include <stdlib.h>
 #include <string.h>
 #include <syslog.h>
+#include <sysexits.h>
 #include <unistd.h>
 
 #include "lib/cyrusdb.h"
-#include "lib/exitcodes.h"
 #include "lib/util.h"
+#include "lib/xmalloc.h"
 
 #include "imap/global.h"
 #include "imap/imap_err.h"
@@ -99,6 +101,7 @@ static void usage(void)
             "    -F                  # force (run command even if not needed)\n"
             "    -S                  # stop on error\n"
             "    -V                  # don't verify checksums (faster read-only ops)\n"
+            "    -j                  # output in JSON format\n"
             "    -v                  # verbose (repeat for more verbosity)\n"
             "    -w                  # wait for locks (don't skip locked backups)\n"
     );
@@ -128,7 +131,7 @@ static void usage(void)
             "    Modes -A, -D, -P not available for all commands\n" /* FIXME which */
     );
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 enum ctlbu_mode {
@@ -158,6 +161,7 @@ struct ctlbu_cmd_options {
     int list_stale;
     int force;
     int noverify;
+    int jsonout;
     const char *lock_exec_cmd;
     const char *domain;
 };
@@ -262,23 +266,42 @@ static enum ctlbu_cmd parse_cmd_string(c
 
 static void print_status(const char *cmd,
                          const char *userid, const char *fname,
+                         const struct ctlbu_cmd_options *options,
                          int r)
 {
-    printf("%s %s: ", cmd, userid ? userid : fname);
-    switch(r) {
+    char *status = NULL;
+    switch (r) {
         case 1:
-            puts("skipped");
+            status = xstrdup("skipped");
             break;
         case 0:
-            puts("ok");
+            status = xstrdup("ok");
             break;
         case IMAP_MAILBOX_LOCKED:
-            puts("locked");
+            status = xstrdup("locked");
             break;
         default:
-            printf("failed (%s)\n", error_message(r));
+            status = strconcat("failed (", error_message(r), ")", NULL);
             break;
     }
+
+    if (options->jsonout) {
+        json_t *out = json_object();
+        json_object_set_new(out, "command", json_string(cmd));
+        json_object_set_new(out, "userid", json_string(userid));
+        json_object_set_new(out, "fname", json_string(fname));
+        json_object_set_new(out, "status", json_string(status));
+
+        const size_t flags = JSON_INDENT(2) | JSON_PRESERVE_ORDER;
+        json_dumpf(out, stdout, flags);
+        puts("");
+        json_decref(out);
+    }
+    else {
+        printf("%s %s: %s\n", cmd, userid ? userid : fname, status);
+    }
+
+    free(status);
 }
 
 static int domain_filter(void *rock,
@@ -329,7 +352,7 @@ int main(int argc, char **argv)
     struct ctlbu_cmd_options options = {0};
     options.wait = BACKUP_OPEN_NONBLOCK;
 
-    while ((opt = getopt(argc, argv, ":AC:DFPSVcfmpst:x:uvw")) != EOF) {
+    while ((opt = getopt(argc, argv, ":AC:DFPSVcfjmpst:x:uvw")) != EOF) {
         switch (opt) {
         case 'A':
             if (options.mode != CTLBU_MODE_UNSPECIFIED) usage();
@@ -358,6 +381,10 @@ int main(int argc, char **argv)
         case 'c':
             options.create = BACKUP_OPEN_CREATE_EXCL;
             break;
+        case 'j':
+            if (options.verbose) usage();
+            options.jsonout = 1;
+            break;
         case 'f':
             if (options.mode != CTLBU_MODE_UNSPECIFIED) usage();
             options.mode = CTLBU_MODE_FILENAME;
@@ -383,6 +410,7 @@ int main(int argc, char **argv)
             options.mode = CTLBU_MODE_USERNAME;
             break;
         case 'v':
+            if (options.jsonout) usage();
             options.verbose ++;
             break;
         case 'x':
@@ -559,7 +587,7 @@ int main(int argc, char **argv)
 
     backup_cleanup_staging_path();
     cyrus_done();
-    exit(r || ctlbu_skips_fails ? EC_TEMPFAIL : EC_OK);
+    exit(r || ctlbu_skips_fails ? EX_TEMPFAIL : EX_OK);
 }
 
 static int cmd_compact_one(void *rock,
@@ -580,7 +608,7 @@ static int cmd_compact_one(void *rock,
     r = backup_compact(fname, options->wait, options->force,
                        options->verbose, stdout);
 
-    print_status("compact", userid, fname, r);
+    print_status("compact", userid, fname, options, r);
 
     if (userid) free(userid);
     if (fname) free(fname);
@@ -648,11 +676,25 @@ static int cmd_list_one(void *rock,
         data_stat_buf.st_size = -1;
     }
 
-    printf("%s\t" OFF_T_FMT "\t%s\t%s\n",
-           timestamp,
-           data_stat_buf.st_size,
-           userid ? userid : "[unknown]",
-           fname);
+    if (options->jsonout) {
+        json_t *out = json_object();
+        json_object_set_new(out, "timestamp", json_string(timestamp));
+        json_object_set_new(out, "compressed", json_integer(data_stat_buf.st_size));
+        json_object_set_new(out, "userid", json_string(userid));
+        json_object_set_new(out, "fname", json_string(fname));
+
+        const size_t flags = JSON_INDENT(2) | JSON_PRESERVE_ORDER;
+        json_dumpf(out, stdout, flags);
+        puts("");
+        json_decref(out);
+    }
+    else {
+        printf("%s\t" OFF_T_FMT "\t%s\t%s\n",
+               timestamp,
+               data_stat_buf.st_size,
+               userid ? userid : "[unknown]",
+               fname);
+    }
 
 done:
     if (latest_chunk) backup_chunk_free(&latest_chunk);
@@ -730,7 +772,7 @@ static int cmd_reindex_one(void *rock,
 
     r = backup_reindex(fname, options->wait, options->verbose, stdout);
 
-    print_status("reindex", userid, fname, r);
+    print_status("reindex", userid, fname, options, r);
 
     if (userid) free(userid);
     if (fname) free(fname);
@@ -784,12 +826,12 @@ static int cmd_stat_one(void *rock,
         if (r) goto done;
     }
 
-    const int retention_days = config_getint(IMAPOPT_BACKUP_RETENTION_DAYS);
-    if (retention_days > 0) {
-        since = time(0) - (retention_days * 24 * 60 * 60);
+    const int retention = config_getduration(IMAPOPT_BACKUP_RETENTION, 'd');
+    if (retention > 0) {
+        since = time(0) - retention;
     }
     else {
-        /* zero or negative retention days means "keep forever" */
+        /* zero or negative retention means "keep forever" */
         since = -1;
     }
 
@@ -829,15 +871,34 @@ static int cmd_stat_one(void *rock,
                  localtime(&latest_chunk->ts_end));
     }
 
-    printf("%s\t" OFF_T_FMT "\t" SIZE_T_FMT "\t" SIZE_T_FMT "\t%6.1f%%\t%6.1f%%\t%21s\t%s\n",
-           userid ? userid : fname,
-           data_stat.st_size,
-           uncompressed,
-           compactable,
-           cmp_ratio,
-           utl_ratio,
-           start_time,
-           end_time);
+    if (options->jsonout) {
+        json_t *out = json_object();
+        json_object_set_new(out, "userid", json_string(userid));
+        json_object_set_new(out, "fname", json_string(fname));
+        json_object_set_new(out, "compressed", json_integer(data_stat.st_size));
+        json_object_set_new(out, "uncompressed", json_integer(uncompressed));
+        json_object_set_new(out, "compactable", json_integer(compactable));
+        json_object_set_new(out, "compression_ratio", json_real(cmp_ratio));
+        json_object_set_new(out, "utilisation_ratio", json_real(utl_ratio));
+        json_object_set_new(out, "last_start_time", json_string(start_time));
+        json_object_set_new(out, "last_end_time", json_string(end_time));
+
+        const size_t flags = JSON_INDENT(2) | JSON_PRESERVE_ORDER;
+        json_dumpf(out, stdout, flags);
+        puts("");
+        json_decref(out);
+    }
+    else {
+        printf("%s\t" OFF_T_FMT "\t" SIZE_T_FMT "\t" SIZE_T_FMT "\t%6.1f%%\t%6.1f%%\t%21s\t%s\n",
+               userid ? userid : fname,
+               data_stat.st_size,
+               uncompressed,
+               compactable,
+               cmp_ratio,
+               utl_ratio,
+               start_time,
+               end_time);
+    }
 
 done:
     if (r) {
@@ -876,7 +937,7 @@ static int cmd_verify_one(void *rock,
     /* n.b. deliberately ignoring nonsensical noverify option here */
     if (!r) r = backup_verify(backup, BACKUP_VERIFY_FULL, options->verbose, stdout);
 
-    print_status("verify", userid, fname, r);
+    print_status("verify", userid, fname, options, r);
 
     if (backup) backup_close(&backup);
     if (userid) free(userid);
@@ -904,15 +965,17 @@ static int lock_run_pipe(const char *use
     if (r) {
         printf("NO failed (%s)\n", error_message(r));
         r = backup_close(&backup);
-        return EC_SOFTWARE; // FIXME would something else be more appropriate?
+        return EX_SOFTWARE; // FIXME would something else be more appropriate?
     }
 
     printf("OK locked\n");
 
     /* wait until stdin closes */
     char buf[PROT_BUFSIZE] = {0};
-    while (!feof(stdin))
-        fgets(buf, sizeof(buf), stdin);
+    while (!feof(stdin)) {
+        if (!fgets(buf, sizeof(buf), stdin))
+            break;
+    }
 
     r = backup_close(&backup);
     if (r) fprintf(stderr, "warning: backup_close() returned %i\n", r);
@@ -941,7 +1004,7 @@ static int lock_run_sqlite(const char *u
                 userid ? userid : fname,
                 error_message(r));
         r = backup_close(&backup);
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     index_fname = backup_get_index_fname(backup);
@@ -953,7 +1016,7 @@ static int lock_run_sqlite(const char *u
     switch (pid) {
     case -1:
         perror("fork");
-        r = EC_SOFTWARE;
+        r = EX_SOFTWARE;
         break;
 
     case 0:
@@ -962,7 +1025,7 @@ static int lock_run_sqlite(const char *u
         execlp("sqlite3", "sqlite3", index_fname, NULL);
         /* execlp never returns */
         perror("execlp sqlite3");
-        _exit(EC_SOFTWARE);
+        _exit(EX_SOFTWARE);
         break;
 
     default:
@@ -971,7 +1034,7 @@ static int lock_run_sqlite(const char *u
         if (WIFEXITED(status))
             r = WEXITSTATUS(status);
         else
-            r = EC_SOFTWARE;
+            r = EX_SOFTWARE;
         break;
     }
 
@@ -1002,7 +1065,7 @@ static int lock_run_exec(const char *use
                 userid ? userid : fname,
                 error_message(r));
         r = backup_close(&backup);
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     setenv(data_fname_env, fname, 1);
@@ -1014,11 +1077,11 @@ static int lock_run_exec(const char *use
     unsetenv(index_fname_env);
 
     if (r == -1)
-        r = EC_SOFTWARE;
+        r = EX_SOFTWARE;
     else if (WIFEXITED(r))
         r = WEXITSTATUS(r);
     else
-        r = EC_SOFTWARE;
+        r = EX_SOFTWARE;
 
     backup_close(&backup);
     return r;
diff -pruN 3.0.13-5/backup/cyr_backup.c 3.2.0-3/backup/cyr_backup.c
--- 3.0.13-5/backup/cyr_backup.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/cyr_backup.c	2020-04-24 02:03:00.000000000 +0000
@@ -53,10 +53,10 @@
 #include <stdlib.h>
 #include <string.h>
 #include <syslog.h>
+#include <sysexits.h>
 #include <unistd.h>
 
 #include "lib/cyrusdb.h"
-#include "lib/exitcodes.h"
 #include "lib/gzuncat.h"
 #include "lib/map.h"
 #include "lib/strarray.h"
@@ -116,7 +116,7 @@ static void usage(void)
             "    -u                  # specified backup interpreted as userid (default)\n"
     );
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static void save_argv0(const char *s)
@@ -401,7 +401,7 @@ int main(int argc, char **argv)
     cyrus_done();
 
     strarray_free(options.argv);
-    exit(r ? EC_TEMPFAIL : EC_OK);
+    exit(r ? EX_TEMPFAIL : EX_OK);
 }
 
 static int cmd_list_all(struct backup *backup,
@@ -545,7 +545,9 @@ static int cmd_show_mailboxes(struct bac
 
         /* or it could be an mboxname */
         if (!mailbox) {
-            mbname_t *mbname = mbname_from_intname(arg);
+            mbname_t *mbname = mbname_from_extname(arg,
+                                                   &cyr_backup_namespace,
+                                                   NULL);
             if (!mbname) continue;
             mailbox = backup_get_mailbox_by_name(backup, mbname,
                                                  BACKUP_MAILBOX_ALL_RECORDS);
@@ -773,7 +775,6 @@ static int json_mailbox_cb(const struct
 {
     json_t *jmailboxes = (json_t *) rock;
     json_t *jmailbox = json_object();
-    json_t *jmessages = json_array();
     char ts_last_appenddate[32] = "[unknown]";
 
     strftime(ts_last_appenddate, sizeof(ts_last_appenddate), "%F %T",
@@ -786,6 +787,7 @@ static int json_mailbox_cb(const struct
 
     if (mailbox->records && mailbox->records->count) {
         struct backup_mailbox_message *iter;
+        json_t *jmessages = json_array();
 
         for (iter = mailbox->records->head; iter; iter = iter->next) {
             json_t *jrecord = json_object();
diff -pruN 3.0.13-5/backup/lcb_append.c 3.2.0-3/backup/lcb_append.c
--- 3.0.13-5/backup/lcb_append.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_append.c	2020-04-24 02:03:00.000000000 +0000
@@ -43,8 +43,8 @@
 #include <assert.h>
 #include <errno.h>
 #include <syslog.h>
+#include <sysexits.h>
 
-#include "lib/exitcodes.h"
 #include "lib/sqldb.h"
 #include "lib/xmalloc.h"
 #include "lib/xsha1.h"
@@ -79,9 +79,9 @@ static int retry_gzwrite(gzFile gzfile,
             syslog(LOG_ERR, "IOERROR: %s gzwrite %s: %s", __func__, fname, err);
 
             if (r == Z_STREAM_ERROR)
-                fatal("gzwrite: invalid stream", EC_IOERR);
+                fatal("gzwrite: invalid stream", EX_IOERR);
             else if (r == Z_MEM_ERROR)
-                fatal("gzwrite: out of memory", EC_TEMPFAIL);
+                fatal("gzwrite: out of memory", EX_TEMPFAIL);
 
             return r;
         }
@@ -100,7 +100,7 @@ HIDDEN int backup_real_append_start(stru
 
     if (backup->append_state != NULL
         && backup->append_state->mode != BACKUP_APPEND_INACTIVE) {
-        fatal("backup append already started", EC_SOFTWARE);
+        fatal("backup append already started", EX_SOFTWARE);
     }
 
     if (!backup->append_state)
@@ -181,7 +181,7 @@ EXPORTED int backup_append(struct backup
                            enum backup_append_flush flush)
 {
     if (!backup->append_state || backup->append_state->mode == BACKUP_APPEND_INACTIVE)
-        fatal("backup append not started", EC_SOFTWARE);
+        fatal("backup append not started", EX_SOFTWARE);
 
     off_t start = backup->append_state->wrote;
     size_t len = 0;
@@ -192,7 +192,7 @@ EXPORTED int backup_append(struct backup
     int r;
 
     /* preload buffer with timestamp preamble */
-    buf_printf(&buf, "%ld APPLY ", (int64_t) ts);
+    buf_printf(&buf, INT64_FMT " APPLY ", (int64_t) ts);
 
     /* iterate over the dlist */
     iter = dlist_print_iter_new(dlist, 1);
@@ -250,9 +250,9 @@ HIDDEN int backup_real_append_end(struct
     int r;
 
     if (!backup->append_state)
-        fatal("backup append not started", EC_SOFTWARE);
+        fatal("backup append not started", EX_SOFTWARE);
     if (backup->append_state->mode == BACKUP_APPEND_INACTIVE)
-        fatal("backup append not started", EC_SOFTWARE);
+        fatal("backup append not started", EX_SOFTWARE);
 
     if (!(backup->append_state->mode & BACKUP_APPEND_INDEXONLY)) {
         r = gzflush(backup->append_state->gzfile, Z_FINISH);
@@ -303,9 +303,9 @@ EXPORTED int backup_append_end(struct ba
 EXPORTED int backup_append_abort(struct backup *backup)
 {
     if (!backup->append_state)
-        fatal("backup append not started", EC_SOFTWARE);
+        fatal("backup append not started", EX_SOFTWARE);
     if (backup->append_state == BACKUP_APPEND_INACTIVE)
-        fatal("backup append not started", EC_SOFTWARE);
+        fatal("backup append not started", EX_SOFTWARE);
 
     sqldb_rollback(backup->db, "backup_append");
 
diff -pruN 3.0.13-5/backup/lcb.c 3.2.0-3/backup/lcb.c
--- 3.0.13-5/backup/lcb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,11 +47,11 @@
 #include <dirent.h>
 #include <errno.h>
 #include <syslog.h>
+#include <sysexits.h>
 #include <zlib.h>
 
 #include "lib/cyrusdb.h"
 #include "lib/cyr_lock.h"
-#include "lib/exitcodes.h"
 #include "lib/gzuncat.h"
 #include "lib/map.h"
 #include "lib/sqldb.h"
@@ -200,7 +200,7 @@ HIDDEN int backup_real_open(struct backu
         // when reindexing, we want to move the old index out of the way
         // and create a new, empty one -- while holding the lock
         char oldindex_fname[PATH_MAX];
-        snprintf(oldindex_fname, sizeof(oldindex_fname), "%s.%ld",
+        snprintf(oldindex_fname, sizeof(oldindex_fname), "%s." INT64_FMT,
                  backup->index_fname, (int64_t) time(NULL));
 
         r = rename(backup->index_fname, oldindex_fname);
@@ -240,7 +240,8 @@ HIDDEN int backup_real_open(struct backu
     }
 
     backup->db = sqldb_open(backup->index_fname, backup_index_initsql,
-                            backup_index_version, backup_index_upgrade);
+                            backup_index_version, backup_index_upgrade,
+                            SQLDB_DEFAULT_TIMEOUT);
     if (!backup->db) {
         r = IMAP_INTERNAL; // FIXME what does it mean to error here?
         goto error;
@@ -591,7 +592,7 @@ EXPORTED int backup_reindex(const char *
         off_t member_offset = gzuc_member_offset(gzuc);
 
         if (verbose)
-            fprintf(out, "\nfound chunk at offset %jd\n\n", member_offset);
+            fprintf(out, "\nfound chunk at offset " OFF_T_FMT "\n\n", member_offset);
 
         struct protstream *member = prot_readcb(_prot_fill_cb, gzuc);
         prot_setisclient(member, 1); /* don't sync literals */
@@ -609,11 +610,11 @@ EXPORTED int backup_reindex(const char *
                 const char *error = prot_error(member);
                 if (error && 0 != strcmp(error, PROT_EOF_STRING)) {
                     syslog(LOG_ERR,
-                           "IOERROR: %s: error reading chunk at offset %jd, byte %i: %s\n",
+                           "IOERROR: %s: error reading chunk at offset " OFF_T_FMT ", byte %i: %s\n",
                            name, member_offset, prot_bytes_in(member), error);
 
                     if (out)
-                        fprintf(out, "error reading chunk at offset %jd, byte %i: %s\n",
+                        fprintf(out, "error reading chunk at offset " OFF_T_FMT ", byte %i: %s\n",
                                 member_offset, prot_bytes_in(member), error);
 
                     r = IMAP_IOERROR;
@@ -624,7 +625,7 @@ EXPORTED int backup_reindex(const char *
 
             if (member_start_ts == -1) {
                 if (prev_member_ts != -1 && prev_member_ts > ts) {
-                    fatal("member timestamp older than previous", EC_DATAERR);
+                    fatal("member timestamp older than previous", EX_DATAERR);
                 }
                 member_start_ts = ts;
                 char file_sha1[2 * SHA1_DIGEST_LENGTH + 1];
@@ -633,7 +634,7 @@ EXPORTED int backup_reindex(const char *
                                          member_offset, file_sha1, 1, 0);
             }
             else if (member_start_ts > ts)
-                fatal("line timestamp older than previous", EC_DATAERR);
+                fatal("line timestamp older than previous", EX_DATAERR);
 
             if (strcmp(buf_cstring(&cmd), "APPLY") != 0) {
                 dlist_unlink_files(dl);
diff -pruN 3.0.13-5/backup/lcb_compact.c 3.2.0-3/backup/lcb_compact.c
--- 3.0.13-5/backup/lcb_compact.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_compact.c	2020-04-24 02:03:00.000000000 +0000
@@ -147,7 +147,7 @@ static int compact_closerename(struct ba
 
     /* link original files into timestamped names */
     r = link(original->data_fname, buf_cstring(&ts_data_fname));
-    if (!r) link(original->index_fname, buf_cstring(&ts_index_fname));
+    if (!r) r = link(original->index_fname, buf_cstring(&ts_index_fname));
 
     if (r) {
         /* on error, trash the new links and bail out */
@@ -164,8 +164,10 @@ static int compact_closerename(struct ba
         /* on error, put original files back */
         unlink(original->data_fname);
         unlink(original->index_fname);
-        link(buf_cstring(&ts_data_fname), original->data_fname);
-        link(buf_cstring(&ts_index_fname), original->index_fname);
+        if (link(buf_cstring(&ts_data_fname), original->data_fname))
+            syslog(LOG_ERR, "IOERROR: failed to link file back (%s %s)!", buf_cstring(&ts_data_fname), original->data_fname);
+        if (link(buf_cstring(&ts_index_fname), original->index_fname))
+            syslog(LOG_ERR, "IOERROR: failed to link file back (%s %s)!", buf_cstring(&ts_index_fname), original->index_fname);
         goto done;
     }
 
@@ -460,12 +462,12 @@ EXPORTED int backup_compact(const char *
     /* calculate current time after obtaining locks, in case of a wait */
     const time_t now = time(NULL);
 
-    const int retention_days = config_getint(IMAPOPT_BACKUP_RETENTION_DAYS);
-    if (retention_days > 0) {
-        since = now - (retention_days * 24 * 60 * 60);
+    const int retention = config_getduration(IMAPOPT_BACKUP_RETENTION, 'd');
+    if (retention > 0) {
+        since = now - retention;
     }
     else {
-        /* zero or negative retention days means "keep forever" */
+        /* zero or negative retention means "keep forever" */
         since = -1;
     }
 
@@ -519,11 +521,11 @@ EXPORTED int backup_compact(const char *
                 const char *error = prot_error(in);
                 if (error && 0 != strcmp(error, PROT_EOF_STRING)) {
                     syslog(LOG_ERR,
-                           "IOERROR: %s: error reading chunk at offset %jd, byte %i: %s\n",
+                           "IOERROR: %s: error reading chunk at offset " OFF_T_FMT ", byte %i: %s\n",
                            name, chunk->offset, prot_bytes_in(in), error);
 
                     if (out)
-                        fprintf(out, "error reading chunk at offset %jd, byte %i: %s\n",
+                        fprintf(out, "error reading chunk at offset " OFF_T_FMT ", byte %i: %s\n",
                                 chunk->offset, prot_bytes_in(in), error);
 
                     /* chunk is corrupt, discard the rest of it and get on with
diff -pruN 3.0.13-5/backup/lcb_indexw.c 3.2.0-3/backup/lcb_indexw.c
--- 3.0.13-5/backup/lcb_indexw.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_indexw.c	2020-04-24 02:03:00.000000000 +0000
@@ -470,10 +470,19 @@ static int _index_message(struct backup
             { NULL,         SQLITE_NULL,    { .s = NULL      } },
         };
 
-        int r = sqldb_exec(backup->db, backup_index_message_insert_sql, bval, NULL,
-                           NULL);
-        if (r) {
-            syslog(LOG_DEBUG, "%s: something went wrong: %i %s\n",
+        r = sqldb_exec(backup->db, backup_index_message_update_sql, bval, NULL,
+                       NULL);
+
+        if (!r && sqldb_changes(backup->db) == 0) {
+            r = sqldb_exec(backup->db, backup_index_message_insert_sql, bval,
+                           NULL, NULL);
+            if (r) {
+                syslog(LOG_DEBUG, "%s: something went wrong: %i insert message %s\n",
+                       __func__, r, message_guid_encode(guid));
+            }
+        }
+        else if (r) {
+            syslog(LOG_DEBUG, "%s: something went wrong: %i update message %s\n",
                    __func__, r, message_guid_encode(guid));
         }
     }
diff -pruN 3.0.13-5/backup/lcb_read.c 3.2.0-3/backup/lcb_read.c
--- 3.0.13-5/backup/lcb_read.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_read.c	2020-04-24 02:03:00.000000000 +0000
@@ -135,7 +135,7 @@ EXPORTED int backup_read_message_data(st
         if (fd != -1) {
             struct buf buf = BUF_INITIALIZER;
 
-            buf_init_mmap(&buf, 1, fd, fname, MAP_UNKNOWN_LEN, NULL);
+            buf_refresh_mmap(&buf, 1, fd, fname, MAP_UNKNOWN_LEN, NULL);
             close(fd);
 
             r = proc(&buf, rock);
diff -pruN 3.0.13-5/backup/lcb_sqlconsts.c 3.2.0-3/backup/lcb_sqlconsts.c
--- 3.0.13-5/backup/lcb_sqlconsts.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_sqlconsts.c	2020-04-24 02:03:00.000000000 +0000
@@ -439,6 +439,16 @@ const char backup_index_mailbox_message_
     WHERE mailbox_id = :mailbox_id AND uid = :uid;
 );
 
+const char backup_index_message_update_sql[] = QUOTE(
+    UPDATE message SET
+        guid = :guid,
+        partition = :partition,
+        chunk_id = :chunk_id,
+        offset = :offset,
+        size = :size
+    WHERE guid = :guid;
+);
+
 const char backup_index_message_insert_sql[] = QUOTE(
     INSERT INTO message (
         guid, partition, chunk_id, offset, size
diff -pruN 3.0.13-5/backup/lcb_sqlconsts.h 3.2.0-3/backup/lcb_sqlconsts.h
--- 3.0.13-5/backup/lcb_sqlconsts.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_sqlconsts.h	2020-04-24 02:03:00.000000000 +0000
@@ -78,6 +78,7 @@ extern const char backup_index_mailbox_m
 extern const char backup_index_mailbox_message_select_one_sql[];
 extern const char backup_index_mailbox_message_expunge_sql[];
 
+extern const char backup_index_message_update_sql[];
 extern const char backup_index_message_insert_sql[];
 extern const char backup_index_message_select_all_sql[];
 extern const char backup_index_message_select_guid_sql[];
diff -pruN 3.0.13-5/backup/lcb_verify.c 3.2.0-3/backup/lcb_verify.c
--- 3.0.13-5/backup/lcb_verify.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/lcb_verify.c	2020-04-24 02:03:00.000000000 +0000
@@ -235,10 +235,10 @@ static int _verify_message_cb(const stru
             const char *error = prot_error(ps);
             if (error && 0 != strcmp(error, PROT_EOF_STRING)) {
                 syslog(LOG_ERR,
-                       "%s: error reading message %i at offset %jd, byte %i: %s",
+                       "%s: error reading message %i at offset " OFF_T_FMT ", byte %i: %s",
                        __func__, message->id, message->offset, prot_bytes_in(ps), error);
                 if (out)
-                    fprintf(out, "error reading message %i at offset %jd, byte %i: %s",
+                    fprintf(out, "error reading message %i at offset " OFF_T_FMT ", byte %i: %s",
                             message->id, message->offset, prot_bytes_in(ps), error);
             }
             prot_free(ps);
@@ -425,11 +425,11 @@ static int mailbox_message_matches(const
         return 0;
 
     if (!dlist_getnum32(dlist, "LAST_UPDATED", &last_updated)
-        || last_updated != mailbox_message->last_updated)
+        || (time_t) last_updated != mailbox_message->last_updated)
         return 0;
 
     if (!dlist_getnum32(dlist, "INTERNALDATE", &internaldate)
-        || internaldate != mailbox_message->internaldate)
+        || (time_t) internaldate != mailbox_message->internaldate)
         return 0;
 
     if (!dlist_getnum32(dlist, "SIZE", &size)
@@ -519,10 +519,10 @@ static int verify_chunk_mailbox_links(st
 
     r = gzuc_member_start_from(gzuc, chunk->offset);
     if (r) {
-        syslog(LOG_ERR, "%s: error reading chunk %i at offset %jd: %s",
+        syslog(LOG_ERR, "%s: error reading chunk %i at offset " OFF_T_FMT ": %s",
                         __func__, chunk->id, chunk->offset, zError(r));
         if (out)
-            fprintf(out, "error reading chunk %i at offset %jd: %s",
+            fprintf(out, "error reading chunk %i at offset " OFF_T_FMT ": %s",
                     chunk->id, chunk->offset, zError(r));
         goto done;
     }
@@ -541,10 +541,10 @@ static int verify_chunk_mailbox_links(st
             const char *error = prot_error(ps);
             if (error && 0 != strcmp(error, PROT_EOF_STRING)) {
                 syslog(LOG_ERR,
-                       "%s: error reading chunk %i data at offset %jd, byte %i: %s",
+                       "%s: error reading chunk %i data at offset " OFF_T_FMT ", byte %i: %s",
                        __func__, chunk->id, chunk->offset, prot_bytes_in(ps), error);
                 if (out)
-                    fprintf(out, "error reading chunk %i data at offset %jd, byte %i: %s",
+                    fprintf(out, "error reading chunk %i data at offset " OFF_T_FMT ", byte %i: %s",
                             chunk->id, chunk->offset, prot_bytes_in(ps), error);
                 r = EOF;
             }
diff -pruN 3.0.13-5/backup/restore.c 3.2.0-3/backup/restore.c
--- 3.0.13-5/backup/restore.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/backup/restore.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,9 +48,9 @@
 #include <stdlib.h>
 #include <string.h>
 #include <syslog.h>
+#include <sysexits.h>
 #include <unistd.h>
 
-#include "lib/exitcodes.h"
 
 #include "imap/global.h"
 #include "imap/imap_err.h"
@@ -103,7 +103,7 @@ static void usage(void)
             "    -u                  # specified backup interpreted as userid (default)\n"
     );
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static void save_argv0(const char *s)
@@ -199,7 +199,7 @@ int main(int argc, char **argv)
     struct buf tagbuf = BUF_INITIALIZER;
     struct backend *backend = NULL;
     struct dlist *upload = NULL;
-    int opt, r;
+    int opt, r = 0;
 
     while ((opt = getopt(argc, argv, ":A:C:DF:LM:P:UXaf:m:nru:vw:xz")) != EOF) {
         switch (opt) {
@@ -519,7 +519,7 @@ done:
     backup_cleanup_staging_path();
     cyrus_done();
 
-    exit(r ? EC_TEMPFAIL : EC_OK);
+    exit(r ? EX_TEMPFAIL : EX_OK);
 }
 
 static struct backend *restore_connect(const char *servername,
@@ -582,7 +582,7 @@ static struct backend *restore_connect(c
 
         if (sync_parse_response("COMPRESS", backend->in, NULL)) {
             if (options->require_compression)
-                fatal("Failed to enable compression, aborting", EC_SOFTWARE);
+                fatal("Failed to enable compression, aborting", EX_SOFTWARE);
             syslog(LOG_NOTICE, "Failed to enable compression, continuing uncompressed");
         }
         else {
@@ -591,7 +591,7 @@ static struct backend *restore_connect(c
         }
     }
     else if (options->require_compression) {
-        fatal("Backend does not support compression, aborting", EC_SOFTWARE);
+        fatal("Backend does not support compression, aborting", EX_SOFTWARE);
     }
 #endif
 
@@ -602,7 +602,7 @@ static struct backend *restore_connect(c
     }
 
     /* Set inactivity timer */
-    timeout = config_getint(IMAPOPT_SYNC_TIMEOUT);
+    timeout = config_getduration(IMAPOPT_SYNC_TIMEOUT, 's');
     if (timeout < 3) timeout = 3;
     prot_settimeout(backend->in, timeout);
 
@@ -668,7 +668,7 @@ static struct sync_folder_list *restore_
             /* we only care about mboxname here */
             sync_folder_list_add(folder_list, NULL, iter->mboxname,
                                 0, NULL, NULL, 0, 0, 0, 0, synccrcs,
-                                0, 0, 0, 0, NULL, 0, 0);
+                                0, 0, 0, 0, NULL, 0, 0, 0, 0);
         }
 
         backup_mailbox_list_empty(mailboxes);
@@ -817,7 +817,7 @@ static int restore_add_mailbox(const str
         const struct synccrcs synccrcs = {0, 0};
         sync_folder_list_add(reserve_folder_list, NULL, clone->mboxname,
                              0, NULL, NULL, 0, 0, 0, 0, synccrcs,
-                             0, 0, 0, 0, NULL, 0, 0);
+                             0, 0, 0, 0, NULL, 0, 0, 0, 0);
     }
 
     /* populate mailbox list */
@@ -861,7 +861,7 @@ static int restore_add_message(const str
         const struct synccrcs synccrcs = {0, 0};
         sync_folder_list_add(reserve_folder_list, NULL, mailbox->mboxname,
                              0, NULL, NULL, 0, 0, 0, 0, synccrcs,
-                             0, 0, 0, 0, NULL, 0, 0);
+                             0, 0, 0, 0, NULL, 0, 0, 0, 0);
 
         /* add to mailbox list */
         my_mailbox_list_add(mailbox_list, mailbox);
@@ -940,14 +940,16 @@ static int restore_add_object(const char
     }
     else if (strchr(object_name, '.')) {
         /* has a dot, might be an mboxname */
-        mbname_t *mbname = mbname_from_intname(object_name);
+        mbname_t *mbname = mbname_from_extname(object_name,
+                                               &restore_namespace, NULL);
         mailbox = backup_get_mailbox_by_name(backup, mbname,
                                              BACKUP_MAILBOX_ALL_RECORDS);
         mbname_free(&mbname);
     }
     else {
         /* not sure what it is, guess mboxname? */
-        mbname_t *mbname = mbname_from_intname(object_name);
+        mbname_t *mbname = mbname_from_extname(object_name,
+                                               &restore_namespace, NULL);
         mailbox = backup_get_mailbox_by_name(backup, mbname,
                                              BACKUP_MAILBOX_ALL_RECORDS);
         mbname_free(&mbname);
diff -pruN 3.0.13-5/bench/cyrdbbench.c 3.2.0-3/bench/cyrdbbench.c
--- 3.0.13-5/bench/cyrdbbench.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/bench/cyrdbbench.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,516 @@
+/* cyrusdb_bench.c: cyrusdb benchmark tool.
+ *                  [Based on the db_bench tool in LevelDB]
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <assert.h>
+#include <errno.h>
+#include <getopt.h>
+#include <ftw.h>
+#include <inttypes.h>
+#include <libgen.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "cyrusdb.h"
+#include "strarray.h"
+#include "util.h"
+#include "xmalloc.h"
+
+/* Globals */
+static char *DBNAME;
+static char *BACKEND;
+static const char *BENCHMARKS;
+static int NUMRECS = 1000;
+static int new_db = 0;          /* set to 1 if we created a new db */
+static size_t VALLEN = 0;
+
+#define ALLBENCHMARKS "writeseq,writeseqtxn,writerandom,writerandomtxn,write100k"
+
+enum {
+        BATCHED,
+        NOTBATCHED,
+        SEQUENTIAL,
+        RANDOM,
+};
+
+static struct option long_options[] = {
+        {"benchmarks", required_argument, NULL, 'b'},
+        {"db", required_argument, NULL, 'd'},
+        {"backend", required_argument, NULL, 't'},
+        {"numrecs", optional_argument, NULL, 'n'},
+        {"help", no_argument, NULL, 'h'},
+        {NULL, 0, NULL, 0}
+};
+
+EXPORTED void fatal(const char *message, int code)
+{
+  static int recurse_code = 0;
+
+  if (recurse_code) {
+    exit(code);
+  }
+
+  recurse_code = code;
+  fprintf(stderr, "fatal error: %s\n", message);
+  exit(code);
+}
+
+static char *create_tmp_dir_name(void)
+{
+    static const char charset[] =
+        "abcdefghijklmnopqrstuvwxyz"
+        "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+        "0123456789";
+    static const int num_chars = 62;
+    uint64_t value;
+    struct timeval tv;
+    const char *tmpdir;
+    char path[PATH_MAX];
+    char *dirname_template;
+    int i, ret = 1;
+    struct stat sb;
+
+    gettimeofday(&tv, NULL);
+    value = ((size_t)(tv.tv_usec << 16)) ^ tv.tv_sec ^ getpid();
+
+    tmpdir = getenv("TMPDIR");
+    if (!tmpdir)
+        tmpdir = "/tmp";
+
+    snprintf(path, sizeof(path), "%s/zsbench-XXXXXX", tmpdir);
+
+    dirname_template = &path[strlen(path) - 6];
+
+    /* TMP_MAX: The minimum number of unique filenames generated by
+     * tmpnam() */
+    for (i = 0; i < TMP_MAX; ++i) {
+        uint64_t v = value;
+        int j;
+
+        ret = 1;
+
+        /* Fill in the random bits. */
+        for (j = 0; j < 6; j++) {
+            dirname_template[j] = charset[v % num_chars];
+            v /= num_chars;
+        }
+
+        if (stat(path, &sb) == -1) {
+            if (errno == ENOENT) {
+                /* FOUND an unused path! */
+                ret = 0;
+                break;
+            }
+        }
+
+        value += 9999;
+    }
+
+    if (!ret)
+        return xstrdup(path);
+    else
+        return NULL;
+}
+
+static char *generate_random_string(char *str, size_t length)
+{
+    static const char charset[] =
+        "abcdefghijklmnopqrstuvwxyz"
+        "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+        "0123456789"
+        "!@#$%^&*()-=_+|{}[];<>,./?:";
+
+    if (length) {
+        --length;
+
+        for (size_t n = 0; n < length; n++) {
+            int pos = rand() % (int) (sizeof charset - 1);
+            str[n] = charset[pos];
+        }
+
+        str[length] = '\0';
+    }
+
+    return str;
+}
+
+static char *random_string(size_t length)
+{
+    char *s = xmalloc(length + 1);
+
+    generate_random_string(s, length);
+
+    return s;
+}
+
+#define LINUX
+#if defined(LINUX) || defined(DARWIN) || defined(BSD)
+static int recursive_rm_cb(const char *path,
+                           const struct stat *sb __attribute__((__unused__)),
+                           int typeflag __attribute__((__unused__)),
+                           struct FTW *ftwbuf __attribute__((__unused__)))
+{
+    int ret = remove(path);
+
+    if (ret)
+        perror(path);
+
+    return ret;
+}
+
+int recursive_rm(const char *path)
+{
+    return nftw(path, recursive_rm_cb, 64, FTW_DEPTH | FTW_PHYS);
+}
+#else
+int recursive_rm(const char *path __attribute__((__unused__)))
+{
+    return 0;
+}
+#endif
+
+
+static void cleanup_db_dir(void)
+{
+        recursive_rm(DBNAME);
+}
+static uint64_t get_time_now(void)
+{
+    struct timeval tv;
+    gettimeofday(&tv, NULL);
+
+    return tv.tv_sec * 1000000 + tv.tv_usec;
+}
+
+
+static void usage(const char *progname)
+{
+    printf("Usage: %s [OPTION]... [DB]...\n", progname);
+
+    printf("  -b, --benchmarks     comma separated list of benchmarks to run\n");
+    printf("                       [will run all the benchmarks by default]");
+    printf("                       Available benchmarks:\n");
+    printf("                       * writeseq       - write values in sequential key order\n");
+    printf("                       * writeseqtxn    - write values in sequential key order in separate transactions\n");
+    printf("                       * writerandom    - write values in random key order\n");
+    printf("                       * writerandomtxn - write values in random key order in separate transactions\n");
+    printf("                       * write100k      - write values 100K long in random key order\n");
+    printf("\n");
+    printf("  -d, --db             the db to run the benchmarks on\n");
+    printf("                       (if not provided, will create a new db)\n");
+    printf("  -t, --backend        type of the db backend to run benchmarks on\n");
+    printf("                       Available Cyrus DB's: twoskip, zeroskip\n");
+    printf("  -n, --numrecs        number of records to write[default: 1000]\n");
+    printf("  -h, --help           display this help and exit\n");
+}
+
+
+static void print_environment(void)
+{
+    fprintf(stderr, "Cyrus DB:       %s\n", DBNAME);
+
+    time_t now = time(NULL);
+    fprintf(stderr, "Date:           %s", ctime(&now));;
+
+    FILE *cpuinfo = fopen("/proc/cpuinfo", "r");
+    if (cpuinfo != NULL) {
+        char line[1000];
+        int num_cpus = 0;
+        struct buf cpu_type = BUF_INITIALIZER;
+        struct buf cache_size = BUF_INITIALIZER;
+
+        while (fgets(line, sizeof(line), cpuinfo) != NULL) {
+            const char *sep = strchr(line, ':');
+            struct buf key = BUF_INITIALIZER;
+            struct buf val = BUF_INITIALIZER;
+
+            if (sep == NULL)
+                continue;
+
+            buf_setmap(&key, line, (sep - 1 - line));
+            buf_trim(&key);
+
+            buf_setcstr(&val, (sep + 1));
+            buf_trim(&val);
+
+            if (strcmp("model name", key.s) == 0) {
+                ++num_cpus;
+                buf_truncate(&cpu_type, 0);
+                buf_setcstr(&cpu_type, val.s);
+            } else if (strcmp("cache size", key.s) == 0) {
+                buf_truncate(&cache_size, 0);
+                buf_setcstr(&cache_size, val.s);
+            }
+
+            buf_free(&key);
+            buf_free(&val);
+        }
+
+        fclose(cpuinfo);
+
+        const char *ctype = buf_cstring(&cpu_type);
+        const char *csize = buf_cstring(&cache_size);
+        fprintf(stderr, "CPU:            %d * %s",
+                num_cpus, ctype);
+        fprintf(stderr, "CPUCache:       %s", csize);
+
+        buf_free(&cpu_type);
+        buf_free(&cache_size);
+    }
+}
+
+static void print_header(void)
+{
+    print_environment();
+    fprintf(stdout, "------------------------------------------------\n");
+}
+
+static size_t do_write(int txnmode, int insmode)
+{
+    int i;
+    int ret;
+    struct db *db = NULL;
+    size_t bytes = 0;
+    struct txn *txn = NULL;
+
+    /* Open DB */
+    ret = cyrusdb_open(BACKEND, DBNAME, new_db ? CYRUSDB_CREATE : 0, &db);
+    assert(ret == CYRUSDB_OK);
+    assert(db != NULL);
+
+    for (i = 0; i < NUMRECS; i++) {
+        char key[100];
+        size_t keylen, vallen;
+        char *val;
+        int k;
+
+        k = (insmode == SEQUENTIAL) ? i : ((time(NULL) *  i) % NUMRECS);
+
+        snprintf(key, sizeof(key), "%016d", k);
+        keylen = strlen(key);
+        vallen = VALLEN ? VALLEN : keylen * 2;
+        val = random_string(vallen);
+
+        ret = cyrusdb_store(db, key, keylen, val, vallen,
+                            (txnmode == BATCHED) ? &txn : NULL);
+        assert(ret == CYRUSDB_OK);
+
+        if (txnmode == BATCHED) {
+                assert(txn != NULL);
+        }
+
+        bytes += (keylen + vallen);
+
+        if (txnmode == BATCHED) {
+            ret = cyrusdb_commit(db, txn);
+            assert(ret == CYRUSDB_OK);
+            txn = NULL;
+        }
+    }
+
+    if (txnmode == NOTBATCHED) {
+        ret = cyrusdb_commit(db, txn);
+        assert(ret == CYRUSDB_OK);
+    }
+
+    /* Close DB */
+    ret = cyrusdb_close(db);
+    assert(ret == CYRUSDB_OK);
+
+    return bytes;
+}
+
+static int parse_options(int argc, char **argv, const struct option *options)
+{
+    int option;
+    int option_index;
+
+    while ((option = getopt_long(argc, argv, "d:b:t:h?",
+                                 long_options, &option_index)) != -1) {
+        switch (option) {
+            case 'b':
+                BENCHMARKS = optarg;
+                break;
+            case 'd':
+                DBNAME = optarg;
+                break;
+            case 't':
+                BACKEND = optarg;
+                break;
+            case 'n':
+                NUMRECS = atoi(optarg);
+                break;
+            case 'h':
+                GCC_FALLTHROUGH
+            case '?':
+                usage(basename(argv[0]));
+                exit(option == 'h');
+        }
+    }
+
+    return 0;
+}
+
+static int run_benchmarks(void)
+{
+    strarray_t *benchmarks = NULL;
+    int i;
+    uint64_t start, finish;
+    size_t bytes;
+
+    print_header();
+
+    benchmarks = strarray_split(BENCHMARKS, ",", 0);
+
+    for (i = 0; i < benchmarks->count; i++) {
+        const char *benchname = strarray_nth(benchmarks, i);
+        if (strcmp(benchname, "writeseq") == 0) {
+            start = get_time_now();
+            bytes = do_write(NOTBATCHED, SEQUENTIAL);
+            finish = get_time_now();
+
+            fprintf(stderr, "writeseq        : %zu bytes written in %" PRIu64 " μs.\n",
+                    bytes, (finish - start));
+        } else if (strcmp(benchname, "writeseqtxn") == 0) {
+            start = get_time_now();
+            bytes = do_write(BATCHED, SEQUENTIAL);
+            finish = get_time_now();
+
+            fprintf(stderr, "writeseqtxn     : %zu bytes written in %" PRIu64 " μs.\n",
+                    bytes, (finish - start));
+        } else if (strcmp(benchname, "writerandom") == 0) {
+            start = get_time_now();
+            bytes = do_write(NOTBATCHED, RANDOM);
+            finish = get_time_now();
+
+            fprintf(stderr, "writerandom     : %zu bytes written in %" PRIu64 " μs.\n",
+                    bytes, (finish - start));
+        } else if (strcmp(benchname, "writerandomtxn") == 0) {
+            start = get_time_now();
+            bytes = do_write(BATCHED, RANDOM);
+            finish = get_time_now();
+
+            fprintf(stderr, "writerandomtxn  : %zu bytes written in %" PRIu64 " μs.\n",
+                    bytes, (finish - start));
+        } else if (strcmp(benchname, "write100k") == 0) {
+            VALLEN = 100 * 1000;
+            start = get_time_now();
+            bytes = do_write(NOTBATCHED, RANDOM);
+            finish = get_time_now();
+
+            fprintf(stderr, "write100k       : %zu bytes written in %" PRIu64 " μs.\n",
+                    bytes, (finish - start));
+            VALLEN = 0;
+        } else {
+            fprintf(stderr, "Unknown benchmark '%s'\n", benchname);
+        }
+
+        if (new_db) {
+            cleanup_db_dir();
+        }
+    }
+
+    strarray_free(benchmarks);
+
+    return 0;
+}
+
+int main(int argc, char *argv[])
+{
+    int ret = EXIT_SUCCESS;
+    int seed = 1103515245;
+
+    /* Random Seed */
+    srand(time(NULL) * seed);
+
+    ret = parse_options(argc, argv, long_options);
+
+    if (BACKEND == NULL) {
+        fprintf(stderr, "Require a backend to run benchmarks.\n");
+        usage(basename(argv[0]));
+        ret = EXIT_FAILURE;
+        goto done;
+    }
+
+    if (strncmp(BACKEND, "twoskip", strlen("twoskip")) == 0 ||
+        strncmp(BACKEND, "zeroskip", strlen("zeroskip")) == 0) {
+        fprintf(stderr, "Running benchmarks for `%s` backend\n", BACKEND);
+    } else {
+        fprintf(stderr, "%s is not a valid CyrusDB backend. ", BACKEND);
+        fprintf(stderr, "Choose between `twoskip` or `zeroskip`.\n");
+        ret = EXIT_FAILURE;
+        goto done;
+    }
+
+    if (BENCHMARKS == NULL) {
+        fprintf(stderr, "Running all benchmarks\n");
+        BENCHMARKS = ALLBENCHMARKS;
+    }
+
+    if (DBNAME == NULL) {
+        new_db = 1;
+        DBNAME = create_tmp_dir_name();
+        assert(DBNAME != NULL);
+        printf("Creating a new DB: %s\n", DBNAME);
+    } else {
+        printf("Using existing DB: %s\n", DBNAME);
+    }
+
+    ret = run_benchmarks();
+
+    if (new_db) {
+        free(DBNAME);
+        DBNAME = NULL;
+    }
+
+ done:
+    exit(ret);
+}
diff -pruN 3.0.13-5/cmulocal/ax_python_module.m4 3.2.0-3/cmulocal/ax_python_module.m4
--- 3.0.13-5/cmulocal/ax_python_module.m4	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cmulocal/ax_python_module.m4	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+# ===========================================================================
+#     https://www.gnu.org/software/autoconf-archive/ax_python_module.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_PYTHON_MODULE(modname[, fatal, python])
+#
+# DESCRIPTION
+#
+#   Checks for Python module.
+#
+#   If fatal is non-empty then absence of a module will trigger an error.
+#   The third parameter can either be "python" for Python 2 or "python3" for
+#   Python 3; defaults to Python 3.
+#
+# LICENSE
+#
+#   Copyright (c) 2008 Andrew Collier
+#
+#   Copying and distribution of this file, with or without modification, are
+#   permitted in any medium without royalty provided the copyright notice
+#   and this notice are preserved. This file is offered as-is, without any
+#   warranty.
+
+#serial 9
+
+AU_ALIAS([AC_PYTHON_MODULE], [AX_PYTHON_MODULE])
+AC_DEFUN([AX_PYTHON_MODULE],[
+    if test -z $PYTHON;
+    then
+        if test -z "$3";
+        then
+            PYTHON="python3"
+        else
+            PYTHON="$3"
+        fi
+    fi
+    PYTHON_NAME=`basename $PYTHON`
+    AC_MSG_CHECKING($PYTHON_NAME module: $1)
+    $PYTHON -c "import $1" 2>/dev/null
+    if test $? -eq 0;
+    then
+        AC_MSG_RESULT(yes)
+        eval AS_TR_CPP(HAVE_PYMOD_$1)=yes
+    else
+        AC_MSG_RESULT(no)
+        eval AS_TR_CPP(HAVE_PYMOD_$1)=no
+        #
+        if test -n "$2"
+        then
+            AC_MSG_ERROR(failed to find required module $1)
+            exit 1
+        fi
+    fi
+])
diff -pruN 3.0.13-5/cmulocal/sasl2.m4 3.2.0-3/cmulocal/sasl2.m4
--- 3.0.13-5/cmulocal/sasl2.m4	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cmulocal/sasl2.m4	2020-04-24 02:03:00.000000000 +0000
@@ -340,7 +340,7 @@ AC_ARG_WITH(sasl,
 
 AC_ARG_WITH(staticsasl,
             [AC_HELP_STRING([--with-staticsasl=DIR],
-                            [Compile with staticly linked libsasl2 in <DIR>])],
+                            [Compile with statically linked libsasl2 in <DIR>])],
             [with_staticsasl="$withval";
              if test $with_staticsasl != "no"; then
                using_static_sasl="static"
diff -pruN 3.0.13-5/cmulocal/ucdsnmp.m4 3.2.0-3/cmulocal/ucdsnmp.m4
--- 3.0.13-5/cmulocal/ucdsnmp.m4	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cmulocal/ucdsnmp.m4	2020-04-24 02:03:00.000000000 +0000
@@ -4,8 +4,9 @@ AC_DEFUN([CMU_UCDSNMP], [
 AC_REQUIRE([CMU_FIND_LIB_SUBDIR])
   AC_REQUIRE([CMU_SOCKETS])
   AC_ARG_WITH(snmp,
-              [AS_HELP_STRING([--with-snmp=DIR], [use ucd|net snmp (rooted in DIR) [yes]])],
-              with_snmp=$withval, with_snmp=yes)
+              [AS_HELP_STRING([--with-snmp=DIR],
+                [use ucd|net snmp (rooted in DIR) [no] -- deprecated, use Prometheus])],
+              with_snmp=$withval, with_snmp=no)
 
   dnl
   dnl Maintain backwards compatibility with old --with-ucdsnmp option
diff -pruN 3.0.13-5/cmulocal/visibility.m4 3.2.0-3/cmulocal/visibility.m4
--- 3.0.13-5/cmulocal/visibility.m4	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/cmulocal/visibility.m4	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
-# visibility.m4 serial 5 (gettext-0.18.2)
-dnl Copyright (C) 2005, 2008, 2010-2012 Free Software Foundation, Inc.
+# visibility.m4 serial 6
+dnl Copyright (C) 2005, 2008, 2010-2019 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
@@ -29,42 +29,42 @@ AC_DEFUN([gl_VISIBILITY],
     dnl First, check whether -Werror can be added to the command line, or
     dnl whether it leads to an error because of some other option that the
     dnl user has put into $CC $CFLAGS $CPPFLAGS.
-    AC_MSG_CHECKING([whether the -Werror option is usable])
-    AC_CACHE_VAL([gl_cv_cc_vis_werror], [
-      gl_save_CFLAGS="$CFLAGS"
-      CFLAGS="$CFLAGS -Werror"
-      AC_COMPILE_IFELSE(
-        [AC_LANG_PROGRAM([[]], [[]])],
-        [gl_cv_cc_vis_werror=yes],
-        [gl_cv_cc_vis_werror=no])
-      CFLAGS="$gl_save_CFLAGS"])
-    AC_MSG_RESULT([$gl_cv_cc_vis_werror])
+    AC_CACHE_CHECK([whether the -Werror option is usable],
+      [gl_cv_cc_vis_werror],
+      [gl_save_CFLAGS="$CFLAGS"
+       CFLAGS="$CFLAGS -Werror"
+       AC_COMPILE_IFELSE(
+         [AC_LANG_PROGRAM([[]], [[]])],
+         [gl_cv_cc_vis_werror=yes],
+         [gl_cv_cc_vis_werror=no])
+       CFLAGS="$gl_save_CFLAGS"
+      ])
     dnl Now check whether visibility declarations are supported.
-    AC_MSG_CHECKING([for simple visibility declarations])
-    AC_CACHE_VAL([gl_cv_cc_visibility], [
-      gl_save_CFLAGS="$CFLAGS"
-      CFLAGS="$CFLAGS -fvisibility=hidden"
-      dnl We use the option -Werror and a function dummyfunc, because on some
-      dnl platforms (Cygwin 1.7) the use of -fvisibility triggers a warning
-      dnl "visibility attribute not supported in this configuration; ignored"
-      dnl at the first function definition in every compilation unit, and we
-      dnl don't want to use the option in this case.
-      if test $gl_cv_cc_vis_werror = yes; then
-        CFLAGS="$CFLAGS -Werror"
-      fi
-      AC_COMPILE_IFELSE(
-        [AC_LANG_PROGRAM(
-           [[extern __attribute__((__visibility__("hidden"))) int hiddenvar;
-             extern __attribute__((__visibility__("default"))) int exportedvar;
-             extern __attribute__((__visibility__("hidden"))) int hiddenfunc (void);
-             extern __attribute__((__visibility__("default"))) int exportedfunc (void);
-             void dummyfunc (void) {}
-           ]],
-           [[]])],
-        [gl_cv_cc_visibility=yes],
-        [gl_cv_cc_visibility=no])
-      CFLAGS="$gl_save_CFLAGS"])
-    AC_MSG_RESULT([$gl_cv_cc_visibility])
+    AC_CACHE_CHECK([for simple visibility declarations],
+      [gl_cv_cc_visibility],
+      [gl_save_CFLAGS="$CFLAGS"
+       CFLAGS="$CFLAGS -fvisibility=hidden"
+       dnl We use the option -Werror and a function dummyfunc, because on some
+       dnl platforms (Cygwin 1.7) the use of -fvisibility triggers a warning
+       dnl "visibility attribute not supported in this configuration; ignored"
+       dnl at the first function definition in every compilation unit, and we
+       dnl don't want to use the option in this case.
+       if test $gl_cv_cc_vis_werror = yes; then
+         CFLAGS="$CFLAGS -Werror"
+       fi
+       AC_COMPILE_IFELSE(
+         [AC_LANG_PROGRAM(
+            [[extern __attribute__((__visibility__("hidden"))) int hiddenvar;
+              extern __attribute__((__visibility__("default"))) int exportedvar;
+              extern __attribute__((__visibility__("hidden"))) int hiddenfunc (void);
+              extern __attribute__((__visibility__("default"))) int exportedfunc (void);
+              void dummyfunc (void) {}
+            ]],
+            [[]])],
+         [gl_cv_cc_visibility=yes],
+         [gl_cv_cc_visibility=no])
+       CFLAGS="$gl_save_CFLAGS"
+      ])
     if test $gl_cv_cc_visibility = yes; then
       CFLAG_VISIBILITY="-fvisibility=hidden"
       HAVE_VISIBILITY=1
diff -pruN 3.0.13-5/com_err/et/com_err.c 3.2.0-3/com_err/et/com_err.c
--- 3.0.13-5/com_err/et/com_err.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/com_err/et/com_err.c	2020-04-24 02:03:00.000000000 +0000
@@ -86,6 +86,7 @@ extern char * INTERFACE error_message ()
 #endif
 
 static void
+__attribute__((format(printf, 3, 0)))
 #if defined(__STDC__) || defined(_WINDOWS)
     default_com_err_proc (const char *whoami, long code, const char *fmt, va_list args)
 #else
@@ -111,7 +112,7 @@ static void
         vsprintf (errbuf + strlen (errbuf), fmt, args);
     }
 #ifdef _WINDOWS
-    MessageBox (NULL, errbuf, "Kerboros", MB_ICONEXCLAMATION);
+    MessageBox (NULL, errbuf, "Kerberos", MB_ICONEXCLAMATION);
 #else
     fputs (errbuf, stderr);
     /* should do this only on a tty in raw mode */
@@ -122,14 +123,17 @@ static void
 }
 
 #if defined(__STDC__) || defined(_WINDOWS)
-typedef void (*errf) (const char *, long, const char *, va_list);
+typedef void (*errf) (const char *, long, const char *, va_list)
+                     __attribute__((format(printf, 3, 0)));
 #else
 typedef void (*errf) ();
 #endif
 
 errf com_err_hook = default_com_err_proc;
 
-void com_err_va (whoami, code, fmt, args)
+void
+__attribute__((format(printf, 3, 0)))
+com_err_va (whoami, code, fmt, args)
     const char *whoami;
     long code;
     const char *fmt;
@@ -139,9 +143,11 @@ void com_err_va (whoami, code, fmt, args
 }
 
 #ifndef VARARGS
-EXPORTED void INTERFACE_C com_err (const char *whoami,
-              long code,
-              const char *fmt, ...)
+EXPORTED void
+__attribute__((format(printf, 3, 4)))
+INTERFACE_C com_err (const char *whoami,
+                     long code,
+                     const char *fmt, ...)
 {
 #else
 EXPORTED void INTERFACE_C com_err (va_alist)
diff -pruN 3.0.13-5/com_err/et/com_err.h 3.2.0-3/com_err/et/com_err.h
--- 3.0.13-5/com_err/et/com_err.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/com_err/et/com_err.h	2020-04-24 02:03:00.000000000 +0000
@@ -87,7 +87,8 @@
 
 #if defined(__STDC__) || defined(_WINDOWS)
 /* ANSI C -- use prototypes etc */
-extern void INTERFACE_C com_err (const char FAR *, long, const char FAR *, ...);
+extern void INTERFACE_C com_err (const char FAR *, long, const char FAR *, ...)
+                                __attribute__((format(printf, 3, 4)));
 extern char const FAR * INTERFACE error_message (long);
 extern void (*com_err_hook) (const char *, long, const char *, va_list);
 extern void (*set_com_err_hook (void (*) (const char *, long, const char *, va_list)))
diff -pruN 3.0.13-5/com_err/et/internal.h 3.2.0-3/com_err/et/internal.h
--- 3.0.13-5/com_err/et/internal.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/com_err/et/internal.h	2020-04-24 02:03:00.000000000 +0000
@@ -46,7 +46,7 @@
 
 #ifdef NEED_SYS_ERRLIST
 extern char const * const sys_errlist[];
-extern const int sys_nerr;
+extern int sys_nerr;
 #endif
 
 #if defined(__STDC__) && !defined(HDR_HAS_PERROR) && !defined(_WINDOWS)
diff -pruN 3.0.13-5/config.h.in 3.2.0-3/config.h.in
--- 3.0.13-5/config.h.in	2019-12-16 04:15:46.000000000 +0000
+++ 3.2.0-3/config.h.in	2020-05-04 04:10:16.000000000 +0000
@@ -61,9 +61,6 @@
 /* Build with backup support */
 #undef ENABLE_BACKUP
 
-/* Build with support of mailbox event notification */
-#undef ENABLE_MBOXEVENT
-
 /* Build with Object Store support */
 #undef ENABLE_OBJECTSTORE
 
@@ -88,6 +85,9 @@
 /* Do we have ClamAV? */
 #undef HAVE_CLAMAV
 
+/* Build with cld2 library support */
+#undef HAVE_CLD2
+
 /* Do we have CU_SetUpFunc? */
 #undef HAVE_CU_SETUPFUNC
 
@@ -97,17 +97,12 @@
 /* Define to 1 if you have the `daemon' function. */
 #undef HAVE_DAEMON
 
-/* Define to 1 if you have the declaration of `icalproperty_get_parent', and
-   to 0 if you don't. */
-#undef HAVE_DECL_ICALPROPERTY_GET_PARENT
-
-/* Define to 1 if you have the declaration of `icalrecur_freq_to_string', and
-   to 0 if you don't. */
-#undef HAVE_DECL_ICALRECUR_FREQ_TO_STRING
-
-/* Define to 1 if you have the declaration of `icalrecur_weekday_to_string',
-   and to 0 if you don't. */
-#undef HAVE_DECL_ICALRECUR_WEEKDAY_TO_STRING
+/* Do we have support for optimize __attribute__? */
+#undef HAVE_DECLARE_OPTIMIZE
+
+/* Define to 1 if you have the declaration of
+   `NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL', and to 0 if you don't. */
+#undef HAVE_DECL_NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL
 
 /* Define to 1 if you have the declaration of `tzname', and to 0 if you don't.
    */
@@ -141,6 +136,9 @@
 /* Define to 1 if you have the `ftruncate' function. */
 #undef HAVE_FTRUNCATE
 
+/* Do we have function nesting support? */
+#undef HAVE_FUNCTION_NESTING
+
 /* Do we have a getaddrinfo? */
 #undef HAVE_GETADDRINFO
 
@@ -190,15 +188,18 @@
 /* Define if your GSSAPI implementation supports SPNEGO */
 #undef HAVE_GSS_SPNEGO
 
-/* Do we have support for IANA params? */
-#undef HAVE_IANA_PARAMS
-
 /* Build CalDAV support into httpd? */
 #undef HAVE_ICAL
 
+/* Build with ICU support */
+#undef HAVE_ICU
+
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
+/* Do we have Jansson? */
+#undef HAVE_JANSSON
+
 /* Support for Kerberos? */
 #undef HAVE_KRB
 
@@ -208,9 +209,15 @@
 /* Do we have libcap system capabilities handling (Linux systems only)? */
 #undef HAVE_LIBCAP
 
+/* Build with chardet library support */
+#undef HAVE_LIBCHARDET
+
 /* Define to 1 if you have the `curl' library (-lcurl). */
 #undef HAVE_LIBCURL
 
+/* Define to 1 if you have the `jansson' library (-ljansson). */
+#undef HAVE_LIBJANSSON
+
 /* Define to 1 if you have the `json-c' library (-ljson-c). */
 #undef HAVE_LIBJSON_C
 
@@ -223,21 +230,18 @@
 /* Define to 1 if you have the `resolv' library (-lresolv). */
 #undef HAVE_LIBRESOLV
 
+/* Define to 1 if you have the `srs2' library (-lsrs2). */
+#undef HAVE_LIBSRS2
+
 /* Do we have the uuid library */
 #undef HAVE_LIBUUID
 
 /* Do we have TCP wrappers? */
 #undef HAVE_LIBWRAP
 
-/* Build in cyrusdb_lmdb support? */
-#undef HAVE_LMDB
-
 /* Define to 1 if you support file names longer than 14 characters. */
 #undef HAVE_LONG_FILE_NAMES
 
-/* Do we have built-in support for managed attachment params? */
-#undef HAVE_MANAGED_ATTACH_PARAMS
-
 /* Define to 1 if you have the `memmem' function. */
 #undef HAVE_MEMMEM
 
@@ -260,6 +264,9 @@
    file. */
 #undef HAVE_NET_SNMP_AGENT_AGENT_MODULE_CONFIG_H
 
+/* Do we have support for new clone API? */
+#undef HAVE_NEW_CLONE_API
+
 /* Build HTTP/2 support into httpd? */
 #undef HAVE_NGHTTP2
 
@@ -275,8 +282,8 @@
 /* Define to 1 if you have the `pselect' function. */
 #undef HAVE_PSELECT
 
-/* Do we have support for setting start point of recurrences? */
-#undef HAVE_RECUR_ITERATOR_START
+/* Do we have built-in support for RFC7986 color prop? */
+#undef HAVE_RFC7986_COLOR
 
 /* Do we have an rlim_t? */
 #undef HAVE_RLIM_T
@@ -287,9 +294,6 @@
 /* Define to 1 if you have the <rxposix.h> header file. */
 #undef HAVE_RXPOSIX_H
 
-/* Do we have built-in support for scheduling params? */
-#undef HAVE_SCHEDULING_PARAMS
-
 /* Define to 1 if you have the `setrlimit' function. */
 #undef HAVE_SETRLIMIT
 
@@ -397,48 +401,39 @@
 /* Define to 1 if you have the `timegm' function. */
 #undef HAVE_TIMEGM
 
+/* Do we have support for TLS ALPN extension? */
+#undef HAVE_TLS_ALPN
+
 /* Define to 1 if your `struct tm' has `tm_zone'. Deprecated, use
    `HAVE_STRUCT_TM_TM_ZONE' instead. */
 #undef HAVE_TM_ZONE
 
-/* Do we have built-in support for TZdist props? */
-#undef HAVE_TZDIST_PROPS
-
 /* Define to 1 if you don't have `tm_zone' but do have the external array
    `tzname'. */
 #undef HAVE_TZNAME
 
-/* Build timezones by reference support into httpd? */
-#undef HAVE_TZ_BY_REF
-
 /* Do we have UCD-SNMP support? */
 #undef HAVE_UCDSNMP
 
 /* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Do we have built-in support for VALARM extensions props? */
-#undef HAVE_VALARM_EXT_PROPS
-
 /* Define to 1 if you have the <valgrind/valgrind.h> header file. */
 #undef HAVE_VALGRIND_VALGRIND_H
 
-/* Build VAVAILABILITY support into httpd? */
-#undef HAVE_VAVAILABILITY
-
 /* Define to 1 or 0, depending whether the compiler supports simple visibility
    declarations. */
 #undef HAVE_VISIBILITY
 
-/* Build VPATCH support into httpd? */
-#undef HAVE_VPATCH
-
-/* Build VPOLL support into httpd? */
-#undef HAVE_VPOLL
-
 /* Define to 1 if you have the `vprintf' function. */
 #undef HAVE_VPRINTF
 
+/* Build WebSockets support into httpd? */
+#undef HAVE_WSLAY
+
+/* Build with libxml support */
+#undef HAVE_XML2
+
 /* Do we have support for xmlBufferDetach()? */
 #undef HAVE_XML_BUFFERDETACH
 
@@ -448,11 +443,14 @@
 /* Build with Zephyr support? */
 #undef HAVE_ZEPHYR
 
+/* Do we have Zeroskip? */
+#undef HAVE_ZEROSKIP
+
 /* Do we have zlib? */
 #undef HAVE_ZLIB
 
-/* Does icaltimetype have is_utc field? */
-#undef ICALTIME_HAS_IS_UTC
+/* Build Zstandard compression support into httpd? */
+#undef HAVE_ZSTD
 
 /* Define to the sub-directory where libtool stores uninstalled libraries. */
 #undef LT_OBJDIR
@@ -460,6 +458,9 @@
 /* Name of the pidfile for master */
 #undef MASTER_PIDFILE
 
+/* Do we need to provide our own json_dumpb()? */
+#undef NEED_JANSSON_JSON_DUMPB
+
 /* Do we have a sys_errlist? */
 #undef NEED_SYS_ERRLIST
 
@@ -565,9 +566,6 @@
 /* Build in Sieve support? */
 #undef USE_SIEVE
 
-/* Build in Sphinx support? */
-#undef USE_SPHINX
-
 /* Build in Squat support? */
 #undef USE_SQUAT
 
@@ -596,8 +594,8 @@
 /* Build in Xapian support? */
 #undef USE_XAPIAN
 
-/* Use Xapian cyruslibs extensions? */
-#undef USE_XAPIAN_CYRUS_EXTENSIONS
+/* Use Xapian CJK word tokenizer, rather than n-grams? */
+#undef USE_XAPIAN_CJK_WORDS
 
 /* Version number of package */
 #undef VERSION
@@ -605,6 +603,9 @@
 /* Build *DAV support into httpd? */
 #undef WITH_DAV
 
+/* Build with JMAP support */
+#undef WITH_JMAP
+
 /* Enable support for OpenIO object storage. */
 #undef WITH_OPENIO
 
@@ -620,8 +621,8 @@
 # endif
 #endif
 
-/* Which Xapian are we running on? */
-#undef XAPIAN_FLAVOR
+/* Which Xapian CJK tokenzation are we using? */
+#undef XAPIAN_CJK_TOKENS
 
 /* Define to 1 if `lex' declares `yytext' as a `char *' by default, not a
    `char[]'. */
diff -pruN 3.0.13-5/configure 3.2.0-3/configure
--- 3.0.13-5/configure	2019-12-16 04:15:46.000000000 +0000
+++ 3.2.0-3/configure	2020-05-04 04:10:16.000000000 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.69 for cyrus-imapd 3.0.13.
+# Generated by GNU Autoconf 2.69 for cyrus-imapd 3.2.0.
 #
 # Report bugs to <https://github.com/cyrusimap/cyrus-imapd/issues>.
 #
@@ -566,6 +566,66 @@ as_tr_sh="eval sed 'y%*+%pp%;s%[^_$as_cr
 
 SHELL=${CONFIG_SHELL-/bin/sh}
 
+as_awk_strverscmp='
+  # Use only awk features that work with 7th edition Unix awk (1978).
+  # My, what an old awk you have, Mr. Solaris!
+  END {
+    while (length(v1) && length(v2)) {
+      # Set d1 to be the next thing to compare from v1, and likewise for d2.
+      # Normally this is a single character, but if v1 and v2 contain digits,
+      # compare them as integers and fractions as strverscmp does.
+      if (v1 ~ /^[0-9]/ && v2 ~ /^[0-9]/) {
+	# Split v1 and v2 into their leading digit string components d1 and d2,
+	# and advance v1 and v2 past the leading digit strings.
+	for (len1 = 1; substr(v1, len1 + 1) ~ /^[0-9]/; len1++) continue
+	for (len2 = 1; substr(v2, len2 + 1) ~ /^[0-9]/; len2++) continue
+	d1 = substr(v1, 1, len1); v1 = substr(v1, len1 + 1)
+	d2 = substr(v2, 1, len2); v2 = substr(v2, len2 + 1)
+	if (d1 ~ /^0/) {
+	  if (d2 ~ /^0/) {
+	    # Compare two fractions.
+	    while (d1 ~ /^0/ && d2 ~ /^0/) {
+	      d1 = substr(d1, 2); len1--
+	      d2 = substr(d2, 2); len2--
+	    }
+	    if (len1 != len2 && ! (len1 && len2 && substr(d1, 1, 1) == substr(d2, 1, 1))) {
+	      # The two components differ in length, and the common prefix
+	      # contains only leading zeros.  Consider the longer to be less.
+	      d1 = -len1
+	      d2 = -len2
+	    } else {
+	      # Otherwise, compare as strings.
+	      d1 = "x" d1
+	      d2 = "x" d2
+	    }
+	  } else {
+	    # A fraction is less than an integer.
+	    exit 1
+	  }
+	} else {
+	  if (d2 ~ /^0/) {
+	    # An integer is greater than a fraction.
+	    exit 2
+	  } else {
+	    # Compare two integers.
+	    d1 += 0
+	    d2 += 0
+	  }
+	}
+      } else {
+	# The normal case, without worrying about digits.
+	d1 = substr(v1, 1, 1); v1 = substr(v1, 2)
+	d2 = substr(v2, 1, 1); v2 = substr(v2, 2)
+      }
+      if (d1 < d2) exit 1
+      if (d1 > d2) exit 2
+    }
+    # Beware Solaris /usr/xgp4/bin/awk (at least through Solaris 10),
+    # which mishandles some comparisons of empty strings to integers.
+    if (length(v2)) exit 1
+    if (length(v1)) exit 2
+  }
+'
 
 test -n "$DJDIR" || exec 7<&0 </dev/null
 exec 6>&1
@@ -590,8 +650,8 @@ MAKEFLAGS=
 # Identity of this package.
 PACKAGE_NAME='cyrus-imapd'
 PACKAGE_TARNAME='cyrus-imapd'
-PACKAGE_VERSION='3.0.13'
-PACKAGE_STRING='cyrus-imapd 3.0.13'
+PACKAGE_VERSION='3.2.0'
+PACKAGE_STRING='cyrus-imapd 3.2.0'
 PACKAGE_BUGREPORT='https://github.com/cyrusimap/cyrus-imapd/issues'
 PACKAGE_URL='https://www.cyrusimap.org'
 
@@ -636,14 +696,14 @@ ac_includes_default="\
 ac_subst_vars='am__EXEEXT_FALSE
 am__EXEEXT_TRUE
 LTLIBOBJS
-ICU_LIBS
-ICU_CFLAGS
 HAVE_SPHINX_BUILD_FALSE
 HAVE_SPHINX_BUILD_TRUE
 SPHINX_BUILD
 USE_SQLITE_FALSE
 USE_SQLITE_TRUE
 SQLITE_LIBADD
+BENCH_FALSE
+BENCH_TRUE
 CUNIT_FALSE
 CUNIT_TRUE
 LIB_UUID
@@ -675,18 +735,22 @@ BACKUP_FALSE
 BACKUP_TRUE
 REPLICATION_FALSE
 REPLICATION_TRUE
+JMAP_FALSE
+JMAP_TRUE
 CALALARMD_FALSE
 CALALARMD_TRUE
 HTTP_LIBS
 HTTP_CPPFLAGS
 SHAPELIB_LIBS
 SHAPELIB_CFLAGS
+ZSTD_LIBS
+ZSTD_CFLAGS
 BROTLI_LIBS
 BROTLI_CFLAGS
+WSLAY_LIBS
+WSLAY_CFLAGS
 NGHTTP2_LIBS
 NGHTTP2_CFLAGS
-ICU4C_LIBS
-ICU4C_CFLAGS
 ICAL_LIBS
 ICAL_CFLAGS
 XML2_LIBS
@@ -701,8 +765,25 @@ IDLED_FALSE
 IDLED_TRUE
 AUTOCREATE_FALSE
 AUTOCREATE_TRUE
+HAVE_CLD2_FALSE
+HAVE_CLD2_TRUE
+CLD2_LIBS
+CLD2_CFLAGS
+USE_LIBCHARDET_FALSE
+USE_LIBCHARDET_TRUE
+LIBCHARDET_LIBS
+LIBCHARDET_CFLAGS
+USE_ZEROSKIP_FALSE
+USE_ZEROSKIP_TRUE
+ZEROSKIP_LIBS
+ZEROSKIP_CFLAGS
+ICU_LIBS
+ICU_CFLAGS
+USE_JANSSON_FALSE
+USE_JANSSON_TRUE
 JANSSON_LIBS
 JANSSON_CFLAGS
+LIBCAP_LIBS
 ZEPHYR_FALSE
 ZEPHYR_TRUE
 ZEPHYR_LIBS
@@ -740,6 +821,8 @@ GMTOFF_TM_TRUE
 NONBLOCK_FCNTL_FALSE
 NONBLOCK_FCNTL_TRUE
 NOWARN_SIGN_COMPARE
+USE_SRS_FALSE
+USE_SRS_TRUE
 SIEVE_FALSE
 SIEVE_TRUE
 LEXLIB
@@ -758,8 +841,6 @@ HAVE_CXX11
 XAPIAN_CONFIG
 RSYNC_BIN
 RM_BIN
-USE_SPHINX_FALSE
-USE_SPHINX_TRUE
 USE_SQUAT_FALSE
 USE_SQUAT_TRUE
 WITH_OBJSTR_DUMMY_FALSE
@@ -770,8 +851,6 @@ WITH_CARINGO_FALSE
 WITH_CARINGO_TRUE
 OBJECTSTORE_FALSE
 OBJECTSTORE_TRUE
-USE_CYRUSDB_LMDB_FALSE
-USE_CYRUSDB_LMDB_TRUE
 USE_CYRUSDB_SQL_FALSE
 USE_CYRUSDB_SQL_TRUE
 PGSQL_LIBADD
@@ -877,6 +956,8 @@ PKG_CONFIG
 CYRUS_IMAPD_PATCH
 CYRUS_IMAPD_REVISION
 CYRUS_IMAPD_SERIES
+ENABLE_STATIC
+ENABLE_SHARED
 target_os
 target_vendor
 target_cpu
@@ -955,17 +1036,16 @@ with_pgsql_incdir
 with_sqlite
 with_sqlite_libdir
 with_sqlite_incdir
-with_lmdb
 with_caringo
 with_openio
 with_openio_libdir
 with_openio_incdir
 enable_objectstore
 enable_squat
-enable_sphinx
 enable_xapian
 enable_sieve
 enable_pcre
+enable_srs
 with_mmap
 with_lock
 enable_afs
@@ -978,13 +1058,16 @@ enable_server
 with_krb
 with_krbimpl
 enable_statickrb
+with_krb5_config
 with_krbdes
 with_openssl
 with_egd_socket
 with_zlib
 with_zephyr
 with_libcap
-enable_event_notification
+with_zeroskip
+with_chardet
+with_cld2
 with_pidfile
 enable_autocreate
 enable_idled
@@ -992,7 +1075,9 @@ enable_nntp
 enable_murder
 enable_http
 with_nghttp2
+with_wslay
 enable_calalarmd
+enable_jmap
 enable_replication
 enable_backup
 with_com_err
@@ -1009,6 +1094,7 @@ with_libwrap
 with_snmp
 with_ucdsnmp
 enable_unit_tests
+enable_cyrusdb_benchmarks
 with_sphinx_build
 '
       ac_precious_vars='build_alias
@@ -1039,21 +1125,29 @@ OPENSSL_CFLAGS
 OPENSSL_LIBS
 JANSSON_CFLAGS
 JANSSON_LIBS
+ICU_CFLAGS
+ICU_LIBS
+ZEROSKIP_CFLAGS
+ZEROSKIP_LIBS
+LIBCHARDET_CFLAGS
+LIBCHARDET_LIBS
+CLD2_CFLAGS
+CLD2_LIBS
 XML2_CFLAGS
 XML2_LIBS
 ICAL_CFLAGS
 ICAL_LIBS
-ICU4C_CFLAGS
-ICU4C_LIBS
 NGHTTP2_CFLAGS
 NGHTTP2_LIBS
+WSLAY_CFLAGS
+WSLAY_LIBS
 BROTLI_CFLAGS
 BROTLI_LIBS
+ZSTD_CFLAGS
+ZSTD_LIBS
 SHAPELIB_CFLAGS
 SHAPELIB_LIBS
-SPHINX_BUILD
-ICU_CFLAGS
-ICU_LIBS'
+SPHINX_BUILD'
 
 
 # Initialize some variables set by options.
@@ -1604,7 +1698,7 @@ if test "$ac_init_help" = "long"; then
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures cyrus-imapd 3.0.13 to adapt to many kinds of systems.
+\`configure' configures cyrus-imapd 3.2.0 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1676,7 +1770,7 @@ fi
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of cyrus-imapd 3.0.13:";;
+     short | recursive ) echo "Configuration of cyrus-imapd 3.2.0:";;
    esac
   cat <<\_ACEOF
 
@@ -1703,29 +1797,29 @@ Optional Features:
   --enable-objectstore    enable IMAP objectstore support. Use --with-caringo
                           or --with-openio to choose a backend
   --disable-squat         disable Squat support
-  --enable-sphinx         enable Sphinx support
   --enable-xapian         enable Xapian support
   --disable-sieve         disable Sieve support
   --disable-pcre          disable PCRE library
+  --enable-srs            enable SRS support
   --enable-afs            Enable AFS with ptloader
   --enable-krb5afspts     compile afskrb PTS module with krb5 support
   --disable-server        disable compiling servers
   --enable-statickrb      link Kerberos statically
-  --disable-event-notification
-                          disable compiling of mailbox event notification
-                          (that needs jansson library)
   --enable-autocreate     enable autocreate support
   --enable-idled          enable IMAP idled support
   --enable-nntp           enable NNTP support
   --enable-murder         enable IMAP Murder support
   --enable-http           enable HTTP support
   --enable-calalarmd      enable CalDAV alarm support
+  --enable-jmap           enable JMAP support
   --enable-replication    enable replication support (experimental)
   --enable-backup         enable backup support (experimental)
   --enable-cmulocal       enable CMU-specific local support
   --enable-oldsievename   enable the use of 'imap' as the sieve service name
   --enable-gssapi=<DIR>   enable GSSAPI authentication [yes]
   --enable-unit-tests     enable CUnit-based unit regression tests
+  --enable-cyrusdb-benchmarks
+                          enable cyrdb benchmarks
 
 Optional Packages:
   --with-PACKAGE[=ARG]    use PACKAGE [ARG=yes]
@@ -1754,7 +1848,6 @@ Optional Packages:
                           SQLite lib files are in DIR
   --with-sqlite-incdir=DIR
                           SQLite include files are in DIR
-  --with-lmdb             use LMDB backend [no]
   --with-caringo          use Caringo ("yes" or "no")
   --with-openio=yes|no    use OpenIO ("yes" or "no")
   --with-openio-libdir=DIR
@@ -1769,7 +1862,8 @@ Optional Packages:
   --without-clamav        ignore presence of ClamAV and disable it
   --with-krb=DIR          use Kerberos from DIR
   --with-krbimpl=kth|mit  assume Kerberos 4 from KTH or MIT
-  --with-krbdes           use Kerberos DES implementation [yes]
+  --with-krb5-config=PATH use krb5-config from PATH
+  --without-krbdes        disable Kerberos DES implementation
   --with-openssl=DIR      use OpenSSL from DIR
   --with-egd-socket=FILE  Entropy Gathering Daemon socket pathname for systems
                           without /dev/urandom
@@ -1777,8 +1871,12 @@ Optional Packages:
   --with-zephyr=DIR       enable Zephyr notification (installed on DIR)
   --with-libcap           Enable libcap system capabilities handling (Linux
                           systems only)
+  --without-zeroskip      ignore presence of Zeroskip and disable it
+  --without-chardet       ignore presence of chardet library and disable it
+  --without-cld2          ignore presence of cld2 library and disable it
   --with-pidfile=DIR      pidfile in DIR [/var/run/cyrus-master.pid]
   --without-nghttp2       disable HTTP/2 support (check)
+  --without-wslay         disable WebSockets support (check)
   --with-com_err=DIR      use com_err from path -- includes in DIR/include,
                           libs in DIR/lib, and compile_et in DIR/bin
   --with-syslogfacility=FACILITY
@@ -1786,11 +1884,12 @@ Optional Packages:
   --with-gss_impl={heimdal|mit|cybersafe|seam|auto}
                           choose specific GSSAPI implementation [[auto]]
   --with-sasl=DIR         Compile with libsasl2 in <DIR>
-  --with-staticsasl=DIR   Compile with staticly linked libsasl2 in <DIR>
+  --with-staticsasl=DIR   Compile with statically linked libsasl2 in <DIR>
   --with-perl=PERL        use PERL for perl
   --with-lib-subdir=DIR   Find libraries in DIR instead of lib
   --with-libwrap=DIR      use libwrap (rooted in DIR) [yes]
-  --with-snmp=DIR         use ucd|net snmp (rooted in DIR) [yes]
+  --with-snmp=DIR         use ucd|net snmp (rooted in DIR) [no] -- deprecated,
+                          use Prometheus
   --with-sphinx-build=(yes|no|PATH)
                           Look for sphinx-build in PATH
 
@@ -1834,28 +1933,40 @@ Some influential environment variables:
               C compiler flags for JANSSON, overriding pkg-config
   JANSSON_LIBS
               linker flags for JANSSON, overriding pkg-config
+  ICU_CFLAGS  C compiler flags for ICU, overriding pkg-config
+  ICU_LIBS    linker flags for ICU, overriding pkg-config
+  ZEROSKIP_CFLAGS
+              C compiler flags for ZEROSKIP, overriding pkg-config
+  ZEROSKIP_LIBS
+              linker flags for ZEROSKIP, overriding pkg-config
+  LIBCHARDET_CFLAGS
+              C compiler flags for LIBCHARDET, overriding pkg-config
+  LIBCHARDET_LIBS
+              linker flags for LIBCHARDET, overriding pkg-config
+  CLD2_CFLAGS C compiler flags for CLD2, overriding pkg-config
+  CLD2_LIBS   linker flags for CLD2, overriding pkg-config
   XML2_CFLAGS C compiler flags for XML2, overriding pkg-config
   XML2_LIBS   linker flags for XML2, overriding pkg-config
   ICAL_CFLAGS C compiler flags for ICAL, overriding pkg-config
   ICAL_LIBS   linker flags for ICAL, overriding pkg-config
-  ICU4C_CFLAGS
-              C compiler flags for ICU4C, overriding pkg-config
-  ICU4C_LIBS  linker flags for ICU4C, overriding pkg-config
   NGHTTP2_CFLAGS
               C compiler flags for NGHTTP2, overriding pkg-config
   NGHTTP2_LIBS
               linker flags for NGHTTP2, overriding pkg-config
+  WSLAY_CFLAGS
+              C compiler flags for WSLAY, overriding pkg-config
+  WSLAY_LIBS  linker flags for WSLAY, overriding pkg-config
   BROTLI_CFLAGS
               C compiler flags for BROTLI, overriding pkg-config
   BROTLI_LIBS linker flags for BROTLI, overriding pkg-config
+  ZSTD_CFLAGS C compiler flags for ZSTD, overriding pkg-config
+  ZSTD_LIBS   linker flags for ZSTD, overriding pkg-config
   SHAPELIB_CFLAGS
               C compiler flags for SHAPELIB, overriding pkg-config
   SHAPELIB_LIBS
               linker flags for SHAPELIB, overriding pkg-config
   SPHINX_BUILD
               Location of sphinx-build
-  ICU_CFLAGS  C compiler flags for ICU, overriding pkg-config
-  ICU_LIBS    linker flags for ICU, overriding pkg-config
 
 Use these variables to override the choices made by `configure' or to help
 it to find libraries and programs with nonstandard names/locations.
@@ -1924,7 +2035,7 @@ fi
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-cyrus-imapd configure 3.0.13
+cyrus-imapd configure 3.2.0
 generated by GNU Autoconf 2.69
 
 Copyright (C) 2012 Free Software Foundation, Inc.
@@ -2700,7 +2811,7 @@ cat >config.log <<_ACEOF
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by cyrus-imapd $as_me 3.0.13, which was
+It was created by cyrus-imapd $as_me 3.2.0, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   $ $0 $@
@@ -3194,9 +3305,15 @@ test -n "$target_alias" &&
   program_prefix=${target_alias}-
 
 
-CYRUS_IMAPD_SERIES=`echo 3.0.13 | cut -d- -f1 | cut -d. -f1-2`
-CYRUS_IMAPD_REVISION=`echo 3.0.13 | cut -d- -f1 | cut -d. -f3`
-CYRUS_IMAPD_PATCH=`echo 3.0.13 | cut -d- -f2-`
+ENABLE_SHARED="$enable_shared"
+
+
+ENABLE_STATIC="$enable_static"
+
+
+CYRUS_IMAPD_SERIES=`echo 3.2.0 | cut -d- -f1 | cut -d. -f1-2`
+CYRUS_IMAPD_REVISION=`echo 3.2.0 | cut -d- -f1 | cut -d. -f3`
+CYRUS_IMAPD_PATCH=`echo 3.2.0 | cut -d- -f2-`
 
 
 
@@ -3808,7 +3925,7 @@ fi
 
 # Define the identity of the package.
  PACKAGE='cyrus-imapd'
- VERSION='3.0.13'
+ VERSION='3.2.0'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -6232,13 +6349,12 @@ esac
   if test -n "$GCC"; then
                 { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether the -Werror option is usable" >&5
 $as_echo_n "checking whether the -Werror option is usable... " >&6; }
-    if ${gl_cv_cc_vis_werror+:} false; then :
+if ${gl_cv_cc_vis_werror+:} false; then :
   $as_echo_n "(cached) " >&6
 else
-
-      gl_save_CFLAGS="$CFLAGS"
-      CFLAGS="$CFLAGS -Werror"
-      cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+  gl_save_CFLAGS="$CFLAGS"
+       CFLAGS="$CFLAGS -Werror"
+       cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -6255,29 +6371,28 @@ else
   gl_cv_cc_vis_werror=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-      CFLAGS="$gl_save_CFLAGS"
-fi
+       CFLAGS="$gl_save_CFLAGS"
 
-    { $as_echo "$as_me:${as_lineno-$LINENO}: result: $gl_cv_cc_vis_werror" >&5
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $gl_cv_cc_vis_werror" >&5
 $as_echo "$gl_cv_cc_vis_werror" >&6; }
         { $as_echo "$as_me:${as_lineno-$LINENO}: checking for simple visibility declarations" >&5
 $as_echo_n "checking for simple visibility declarations... " >&6; }
-    if ${gl_cv_cc_visibility+:} false; then :
+if ${gl_cv_cc_visibility+:} false; then :
   $as_echo_n "(cached) " >&6
 else
-
-      gl_save_CFLAGS="$CFLAGS"
-      CFLAGS="$CFLAGS -fvisibility=hidden"
-                                    if test $gl_cv_cc_vis_werror = yes; then
-        CFLAGS="$CFLAGS -Werror"
-      fi
-      cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+  gl_save_CFLAGS="$CFLAGS"
+       CFLAGS="$CFLAGS -fvisibility=hidden"
+                                          if test $gl_cv_cc_vis_werror = yes; then
+         CFLAGS="$CFLAGS -Werror"
+       fi
+       cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 extern __attribute__((__visibility__("hidden"))) int hiddenvar;
-             extern __attribute__((__visibility__("default"))) int exportedvar;
-             extern __attribute__((__visibility__("hidden"))) int hiddenfunc (void);
-             extern __attribute__((__visibility__("default"))) int exportedfunc (void);
-             void dummyfunc (void) {}
+              extern __attribute__((__visibility__("default"))) int exportedvar;
+              extern __attribute__((__visibility__("hidden"))) int hiddenfunc (void);
+              extern __attribute__((__visibility__("default"))) int exportedfunc (void);
+              void dummyfunc (void) {}
 
 int
 main ()
@@ -6293,10 +6408,10 @@ else
   gl_cv_cc_visibility=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-      CFLAGS="$gl_save_CFLAGS"
-fi
+       CFLAGS="$gl_save_CFLAGS"
 
-    { $as_echo "$as_me:${as_lineno-$LINENO}: result: $gl_cv_cc_visibility" >&5
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $gl_cv_cc_visibility" >&5
 $as_echo "$gl_cv_cc_visibility" >&6; }
     if test $gl_cv_cc_visibility = yes; then
       CFLAG_VISIBILITY="-fvisibility=hidden"
@@ -18070,6 +18185,10 @@ done
 
 
 
+# backwards compat with older pkg-config
+
+
+
         save_LIBS="$LIBS"
         LIB_SOCKET=""
         ac_fn_c_check_func "$LINENO" "connect" "ac_cv_func_connect"
@@ -19393,73 +19512,6 @@ fi
 
 
 
-# Check whether --with-lmdb was given.
-if test "${with_lmdb+set}" = set; then :
-  withval=$with_lmdb; with_lmdb="$withval"
-else
-  with_lmdb="no"
-fi
-
-if test "$with_lmdb" = "yes"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for mdb_env_create in -llmdb" >&5
-$as_echo_n "checking for mdb_env_create in -llmdb... " >&6; }
-if ${ac_cv_lib_lmdb_mdb_env_create+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-llmdb  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char mdb_env_create ();
-int
-main ()
-{
-return mdb_env_create ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_lmdb_mdb_env_create=yes
-else
-  ac_cv_lib_lmdb_mdb_env_create=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_lmdb_mdb_env_create" >&5
-$as_echo "$ac_cv_lib_lmdb_mdb_env_create" >&6; }
-if test "x$ac_cv_lib_lmdb_mdb_env_create" = xyes; then :
-  use_lmdb="yes"
-      LMDB_LIB="-llmdb"
-
-$as_echo "#define HAVE_LMDB /**/" >>confdefs.h
-
-else
-  as_fn_error $? "The LMDB library is required for Cyrus DB LMDB support." "$LINENO" 5
-fi
-
-else
-    use_lmdb="no"
-fi
- if test "x$use_lmdb" = "xyes"; then
-  USE_CYRUSDB_LMDB_TRUE=
-  USE_CYRUSDB_LMDB_FALSE='#'
-else
-  USE_CYRUSDB_LMDB_TRUE='#'
-  USE_CYRUSDB_LMDB_FALSE=
-fi
-
-
-
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether to use Caringo" >&5
 $as_echo_n "checking whether to use Caringo... " >&6; }
 
@@ -19842,34 +19894,7 @@ fi
 
 
 
-# Check whether --enable-sphinx was given.
-if test "${enable_sphinx+set}" = set; then :
-  enableval=$enable_sphinx;
-else
-  enable_sphinx=no
-fi
-
-if test "x$enable_sphinx" != xno ; then
-
-$as_echo "#define USE_SPHINX /**/" >>confdefs.h
-
-fi
- if test "${enable_sphinx}" != "no"; then
-  USE_SPHINX_TRUE=
-  USE_SPHINX_FALSE='#'
-else
-  USE_SPHINX_TRUE='#'
-  USE_SPHINX_FALSE=
-fi
-
-
-if test "$enable_sphinx" = yes -a "$with_mysql" = no ; then
-    as_fn_error $? "Sphinx requires MySQL but you have not used --with-mysql; disabling Sphinx" "$LINENO" 5
-    enable_sphinx=no
-fi
-
-
-xapian_flavor=none
+xapian_cjk_tokens=none
 # Check whether --enable-xapian was given.
 if test "${enable_xapian+set}" = set; then :
   enableval=$enable_xapian;
@@ -20233,6 +20258,19 @@ $as_echo "#define HAVE_CXX11 1" >>confde
 
 
                                         XAPIAN_VERSION="`$XAPIAN_CONFIG --version|sed 's/.* //'`"
+        as_arg_v1=$XAPIAN_VERSION
+as_arg_v2=1.4
+awk "$as_awk_strverscmp" v1="$as_arg_v1" v2="$as_arg_v2" /dev/null
+case $? in #(
+  1) :
+    as_fn_error $? "need at least Xapian 1.4" "$LINENO" 5 ;; #(
+  0) :
+     ;; #(
+  2) :
+     ;; #(
+  *) :
+     ;;
+esac
         XAPIAN_CXXFLAGS="`$XAPIAN_CONFIG --cxxflags`"
                                                                                         XAPIAN_LIBS="`ac_top_srcdir=\"$ac_top_srcdir\" $XAPIAN_CONFIG --from-xo-lib-xapian --libs`"
 
@@ -20251,37 +20289,37 @@ ac_compiler_gnu=$ac_cv_cxx_compiler_gnu
         ORIG_CXXFLAGS=$CXXFLAGS
         LDFLAGS="$LDFLAGS $XAPIAN_LIBS"
         CXXFLAGS="$CXXFLAGS $XAPIAN_CXXFLAGS"
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for Xapian cyruslibs extensions" >&5
-$as_echo_n "checking for Xapian cyruslibs extensions... " >&6; }
+        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for Xapian cjk word tokenization" >&5
+$as_echo_n "checking for Xapian cjk word tokenization... " >&6; }
         cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 #include <xapian.h>
 int
 main ()
 {
-unsigned cjk_flags = Xapian::TermGenerator::FLAG_CJK_WORDS | Xapian::QueryParser::FLAG_CJK_WORDS; unsigned snippet_flags = Xapian::MSet::SNIPPET_START_AT_NONSPACE; (void) cjk_flags; (void) snippet_flags
+unsigned cjk_flags = Xapian::TermGenerator::FLAG_CJK_WORDS | Xapian::QueryParser::FLAG_CJK_WORDS | Xapian::MSet::SNIPPET_CJK_WORDS; (void) cjk_flags;
   ;
   return 0;
 }
 _ACEOF
 if ac_fn_cxx_try_link "$LINENO"; then :
-  xapian_cyrusexts="yes"
+  xapian_cjkwords="yes"
 else
-  xapian_cyrusexts="no"
+  xapian_cjkwords="no"
 fi
 rm -f core conftest.err conftest.$ac_objext \
     conftest$ac_exeext conftest.$ac_ext
-        { $as_echo "$as_me:${as_lineno-$LINENO}: result: $xapian_cyrusexts" >&5
-$as_echo "$xapian_cyrusexts" >&6; }
-        if test $xapian_cyrusexts = yes; then
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: $xapian_cjkwords" >&5
+$as_echo "$xapian_cjkwords" >&6; }
+        if test $xapian_cjkwords = yes; then
 
-$as_echo "#define USE_XAPIAN_CYRUS_EXTENSIONS /**/" >>confdefs.h
+$as_echo "#define USE_XAPIAN_CJK_WORDS /**/" >>confdefs.h
 
-            xapian_flavor=cyruslibs
+            xapian_cjk_tokens=words
         else
-            { $as_echo "$as_me:${as_lineno-$LINENO}: Your Xapian does not support the Cyrus extensions for Xapian. Consider installing cyruslibs Xapian" >&5
-$as_echo "$as_me: Your Xapian does not support the Cyrus extensions for Xapian. Consider installing cyruslibs Xapian" >&6;}
-            xapian_flavor=vanilla
+            { $as_echo "$as_me:${as_lineno-$LINENO}: Your Xapian does not support CJK word tokenization. Consider installing a recent Xapian >= 1.4.11" >&5
+$as_echo "$as_me: Your Xapian does not support CJK word tokenization. Consider installing a recent Xapian >= 1.4.11" >&6;}
+            xapian_cjk_tokens=ngrams
         fi
         LDFLAGS=$ORIG_LDFLAGS
         CXXFLAGS=$ORIG_CXXFLAGS
@@ -20306,12 +20344,12 @@ fi
 
 
 cat >>confdefs.h <<_ACEOF
-#define XAPIAN_FLAVOR "$xapian_flavor"
+#define XAPIAN_CJK_TOKENS "$xapian_cjk_tokens"
 _ACEOF
 
 
 
- if test "${enable_squat}" != "no" -o "${enable_sphinx}" != "no" -o "${enable_xapian}" != "no" ; then
+ if test "${enable_squat}" != "no" -o "${enable_xapian}" != "no" ; then
   SQUATTER_TRUE=
   SQUATTER_FALSE='#'
 else
@@ -20329,7 +20367,7 @@ fi
 
 # Check whether --enable-pcre was given.
 if test "${enable_pcre+set}" = set; then :
-  enableval=$enable_pcre; cyrus_cv_pcre_utf8="no"
+  enableval=$enable_pcre; cyrus_cv_pcre_utf8="$enableval"
 fi
 
 
@@ -20685,6 +20723,82 @@ fi
         fi
 fi
 
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether to use SRS" >&5
+$as_echo_n "checking whether to use SRS... " >&6; }
+# Check whether --enable-srs was given.
+if test "${enable_srs+set}" = set; then :
+  enableval=$enable_srs;
+else
+  enable_srs=no
+fi
+
+if test "x$enable_srs" != xno; then
+    ac_fn_c_check_header_mongrel "$LINENO" "srs2.h" "ac_cv_header_srs2_h" "$ac_includes_default"
+if test "x$ac_cv_header_srs2_h" = xyes; then :
+
+else
+  as_fn_error $? "cannot find SRS headers" "$LINENO" 5
+fi
+
+
+    { $as_echo "$as_me:${as_lineno-$LINENO}: checking for srs_forward in -lsrs2" >&5
+$as_echo_n "checking for srs_forward in -lsrs2... " >&6; }
+if ${ac_cv_lib_srs2_srs_forward+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lsrs2  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char srs_forward ();
+int
+main ()
+{
+return srs_forward ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_srs2_srs_forward=yes
+else
+  ac_cv_lib_srs2_srs_forward=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_srs2_srs_forward" >&5
+$as_echo "$ac_cv_lib_srs2_srs_forward" >&6; }
+if test "x$ac_cv_lib_srs2_srs_forward" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_LIBSRS2 1
+_ACEOF
+
+  LIBS="-lsrs2 $LIBS"
+
+else
+  as_fn_error $? "cannot find SRS lib" "$LINENO" 5
+fi
+
+    LIBS="$LIBS -lsrs2"
+fi
+ if test "${enable_srs}" != "no"; then
+  USE_SRS_TRUE=
+  USE_SRS_FALSE='#'
+else
+  USE_SRS_TRUE='#'
+  USE_SRS_FALSE=
+fi
+
+
 saved_CFLAGS="$CFLAGS"
 NOWARN_SIGN_COMPARE="-Wno-sign-compare"
 CFLAGS="$NOWARN_SIGN_COMPARE"
@@ -21896,6 +22010,33 @@ fi
 
 
 
+# Check whether --with-krb5-config was given.
+if test "${with_krb5_config+set}" = set; then :
+  withval=$with_krb5_config; with_krb5config="$withval"
+else
+  with_krb5config="no"
+fi
+
+
+if test "$with_krb5config" != "no"; then
+    { $as_echo "$as_me:${as_lineno-$LINENO}: checking $with_krb5config works" >&5
+$as_echo_n "checking $with_krb5config works... " >&6; }
+
+        if (exec >&5 2>&5 ; $with_krb5config --libs --cflags; exit $?) then
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+    else
+        as_fn_error $? "\`$with_krb5config --libs --cflags' doesn't work, aborting" "$LINENO" 5
+    fi
+
+    KRB5_CFLAGS="`$with_krb5config --cflags`"
+    KRB5_LDFLAGS="`$with_krb5config --libs`"
+
+    LDFLAGS="$KRB5_LDFLAGS $LDFLAGS"
+    CFLAGS="$KRB5_CFLAGS $CFLAGS"
+fi
+
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for res_search in -lresolv" >&5
 $as_echo_n "checking for res_search in -lresolv... " >&6; }
 if ${ac_cv_lib_resolv_res_search+:} false; then :
@@ -21950,7 +22091,7 @@ if test "$with_krb" != "no"; then
 
 # Check whether --with-krbdes was given.
 if test "${with_krbdes+set}" = set; then :
-  withval=$with_krbdes; with_krbdes="$withval"
+  withval=$with_krbdes;
 else
   with_krbdes="yes"
 fi
@@ -22452,6 +22593,49 @@ $as_echo "#define OPENSSL_ENABLE_OLD_DES
 $as_echo "#define OPENSSL_DES_LIBDES_COMPATIBILITY /**/" >>confdefs.h
 
     fi
+
+    { $as_echo "$as_me:${as_lineno-$LINENO}: checking for SSL_CTX_set_alpn_select_cb in -lssl" >&5
+$as_echo_n "checking for SSL_CTX_set_alpn_select_cb in -lssl... " >&6; }
+if ${ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lssl  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char SSL_CTX_set_alpn_select_cb ();
+int
+main ()
+{
+return SSL_CTX_set_alpn_select_cb ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb=yes
+else
+  ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb" >&5
+$as_echo "$ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb" >&6; }
+if test "x$ac_cv_lib_ssl_SSL_CTX_set_alpn_select_cb" = xyes; then :
+
+$as_echo "#define HAVE_TLS_ALPN /**/" >>confdefs.h
+
+fi
+
 fi
  if test "$with_ssl" != "no"; then
   HAVE_SSL_TRUE=
@@ -22663,6 +22847,7 @@ fi
 
 
 have_libcap=no
+LIBCAP_LIBS=""
 case $host_os in
 linux*)
         if test "x$with_libcap" = "xyes"; then
@@ -22727,7 +22912,7 @@ done
 
 $as_echo "#define HAVE_LIBCAP /**/" >>confdefs.h
 
-                        LIBS="$LIBS -lcap"
+                        LIBCAP_LIBS="-lcap"
                 fi
         fi
         ;;
@@ -22735,6 +22920,7 @@ $as_echo "#define HAVE_LIBCAP /**/" >>co
         ;;
 esac
 
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for libcap" >&5
 $as_echo_n "checking for libcap... " >&6; }
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $have_libcap" >&5
@@ -22799,215 +22985,192 @@ fi
 	# Put the nasty error message in config.log where it belongs
 	echo "$JANSSON_PKG_ERRORS" >&5
 
-	as_fn_error $? "Package requirements (jansson >= 2.3) were not met:
-
-$JANSSON_PKG_ERRORS
-
-Consider adjusting the PKG_CONFIG_PATH environment variable if you
-installed software in a non-standard prefix.
-
-Alternatively, you may set the environment variables JANSSON_CFLAGS
-and JANSSON_LIBS to avoid the need to call pkg-config.
-See the pkg-config man page for more details." "$LINENO" 5
+	as_fn_error $? "libjansson is required" "$LINENO" 5
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-	{ { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error $? "The pkg-config script could not be found or is too old.  Make sure it
-is in your PATH or set the PKG_CONFIG environment variable to the full
-path to pkg-config.
-
-Alternatively, you may set the environment variables JANSSON_CFLAGS
-and JANSSON_LIBS to avoid the need to call pkg-config.
-See the pkg-config man page for more details.
-
-To get pkg-config, see <http://pkg-config.freedesktop.org/>.
-See \`config.log' for more details" "$LINENO" 5; }
+	as_fn_error $? "libjansson is required" "$LINENO" 5
 else
 	JANSSON_CFLAGS=$pkg_cv_JANSSON_CFLAGS
 	JANSSON_LIBS=$pkg_cv_JANSSON_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
-fi
+$as_echo "#define HAVE_JANSSON /**/" >>confdefs.h
 
+                    with_jansson=yes
+fi
 
 
-# Check whether --enable-event-notification was given.
-if test "${enable_event_notification+set}" = set; then :
-  enableval=$enable_event_notification;
+ if test "x$with_jansson" = xyes; then
+  USE_JANSSON_TRUE=
+  USE_JANSSON_FALSE='#'
 else
-  enable_event_notification="yes";
+  USE_JANSSON_TRUE='#'
+  USE_JANSSON_FALSE=
 fi
 
 
-if test "$enable_event_notification" != "no"; then
-
-$as_echo "#define ENABLE_MBOXEVENT /**/" >>confdefs.h
+save_CFLAGS="$CFLAGS"
+CFLAGS="$CFLAGS $JANSSON_CFLAGS $JANSSON_LIBS"
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for json_dumpb in -ljansson" >&5
+$as_echo_n "checking for json_dumpb in -ljansson... " >&6; }
+if ${ac_cv_lib_jansson_json_dumpb+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-ljansson  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
 
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char json_dumpb ();
+int
+main ()
+{
+return json_dumpb ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_jansson_json_dumpb=yes
+else
+  ac_cv_lib_jansson_json_dumpb=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
 fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_jansson_json_dumpb" >&5
+$as_echo "$ac_cv_lib_jansson_json_dumpb" >&6; }
+if test "x$ac_cv_lib_jansson_json_dumpb" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_LIBJANSSON 1
+_ACEOF
 
+  LIBS="-ljansson $LIBS"
 
-# Check whether --with-pidfile was given.
-if test "${with_pidfile+set}" = set; then :
-  withval=$with_pidfile; MASTERPIDFILE="$withval"
 else
-  MASTERPIDFILE="/var/run/cyrus-master.pid"
-fi
-
-MASTERPIDFILE="\"$MASTERPIDFILE\""
 
-cat >>confdefs.h <<_ACEOF
-#define MASTER_PIDFILE $MASTERPIDFILE
-_ACEOF
+$as_echo "#define NEED_JANSSON_JSON_DUMPB 1" >>confdefs.h
 
+               { $as_echo "$as_me:${as_lineno-$LINENO}: jansson does not provide json_dumpb(), using ours instead" >&5
+$as_echo "$as_me: jansson does not provide json_dumpb(), using ours instead" >&6;}
 
-# Check whether --enable-autocreate was given.
-if test "${enable_autocreate+set}" = set; then :
-  enableval=$enable_autocreate;
-else
-  enable_autocreate="no";
 fi
 
- if test "$enable_autocreate" != "no"; then
-  AUTOCREATE_TRUE=
-  AUTOCREATE_FALSE='#'
-else
-  AUTOCREATE_TRUE='#'
-  AUTOCREATE_FALSE=
-fi
+CFLAGS="$save_CFLAGS"
 
-if test "x$enable_autocreate" = "xyes"; then
-
-$as_echo "#define USE_AUTOCREATE /**/" >>confdefs.h
+with_icu4c=no
 
-fi
-# Check whether --enable-idled was given.
-if test "${enable_idled+set}" = set; then :
-  enableval=$enable_idled;
-else
-  enable_idled="no";
-fi
+pkg_failed=no
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICU" >&5
+$as_echo_n "checking for ICU... " >&6; }
 
- if test "$enable_idled" != "no"; then
-  IDLED_TRUE=
-  IDLED_FALSE='#'
+if test -n "$ICU_CFLAGS"; then
+    pkg_cv_ICU_CFLAGS="$ICU_CFLAGS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-i18n icu-uc\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "icu-i18n icu-uc") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_ICU_CFLAGS=`$PKG_CONFIG --cflags "icu-i18n icu-uc" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
 else
-  IDLED_TRUE='#'
-  IDLED_FALSE=
+  pkg_failed=yes
 fi
-
-if test "x$enable_idled" = "xyes"; then
-
-$as_echo "#define USE_IDLED /**/" >>confdefs.h
-
+ else
+    pkg_failed=untried
 fi
-# Check whether --enable-nntp was given.
-if test "${enable_nntp+set}" = set; then :
-  enableval=$enable_nntp;
+if test -n "$ICU_LIBS"; then
+    pkg_cv_ICU_LIBS="$ICU_LIBS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-i18n icu-uc\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "icu-i18n icu-uc") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_ICU_LIBS=`$PKG_CONFIG --libs "icu-i18n icu-uc" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
 else
-  enable_nntp="no";
+  pkg_failed=yes
 fi
-
- if test "$enable_nntp" != "no"; then
-  NNTPD_TRUE=
-  NNTPD_FALSE='#'
-else
-  NNTPD_TRUE='#'
-  NNTPD_FALSE=
+ else
+    pkg_failed=untried
 fi
 
-if test "x$enable_nntp" = "xyes"; then
 
-$as_echo "#define USE_NNTPD /**/" >>confdefs.h
 
-fi
+if test $pkg_failed = yes; then
+   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
 
-# Check whether --enable-murder was given.
-if test "${enable_murder+set}" = set; then :
-  enableval=$enable_murder;
+if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
+        _pkg_short_errors_supported=yes
 else
-  enable_murder="no";
+        _pkg_short_errors_supported=no
 fi
+        if test $_pkg_short_errors_supported = yes; then
+	        ICU_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "icu-i18n icu-uc" 2>&1`
+        else
+	        ICU_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "icu-i18n icu-uc" 2>&1`
+        fi
+	# Put the nasty error message in config.log where it belongs
+	echo "$ICU_PKG_ERRORS" >&5
 
- if test "$enable_murder" != "no"; then
-  MURDER_TRUE=
-  MURDER_FALSE='#'
+	as_fn_error $? "Need ICU4C" "$LINENO" 5
+elif test $pkg_failed = untried; then
+     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+	as_fn_error $? "Need ICU4C" "$LINENO" 5
 else
-  MURDER_TRUE='#'
-  MURDER_FALSE=
-fi
+	ICU_CFLAGS=$pkg_cv_ICU_CFLAGS
+	ICU_LIBS=$pkg_cv_ICU_LIBS
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
 
-if test "$enable_murder" != no; then
-        # for master/slave auto-selection
-        for ac_header in sys/sockio.h
-do :
-  ac_fn_c_check_header_mongrel "$LINENO" "sys/sockio.h" "ac_cv_header_sys_sockio_h" "$ac_includes_default"
-if test "x$ac_cv_header_sys_sockio_h" = xyes; then :
-  cat >>confdefs.h <<_ACEOF
-#define HAVE_SYS_SOCKIO_H 1
-_ACEOF
 
-fi
+$as_echo "#define HAVE_ICU /**/" >>confdefs.h
 
-done
+                    with_icu4c=yes
 
 fi
-if test "x$enable_murder" = "xyes"; then
 
-$as_echo "#define USE_MURDER /**/" >>confdefs.h
 
-fi
 
-# Check whether --enable-http was given.
-if test "${enable_http+set}" = set; then :
-  enableval=$enable_http;
-else
-  enable_http="no";
-fi
 
- if test "$enable_http" != "no"; then
-  HTTPD_TRUE=
-  HTTPD_FALSE='#'
+# Check whether --with-zeroskip was given.
+if test "${with_zeroskip+set}" = set; then :
+  withval=$with_zeroskip;
 else
-  HTTPD_TRUE='#'
-  HTTPD_FALSE=
+  with_zeroskip=yes
 fi
 
-
-HTTP_CPPFLAGS=
-HTTP_LIBS=
-with_xml2=no
-with_ical=no
-with_icu4c=no
-with_shapelib=no
-with_brotli=no
-if test "$enable_http" != no; then
-        if test "x$HAVE_SQLITE" != x1; then
-            as_fn_error $? "Need sqlite3 for http" "$LINENO" 5
-        else
-            use_sqlite="yes"
-
-$as_echo "#define WITH_DAV /**/" >>confdefs.h
-
-        fi
-
+if test "x$with_zeroskip" = "xyes"; then :
 
 pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for XML2" >&5
-$as_echo_n "checking for XML2... " >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ZEROSKIP" >&5
+$as_echo_n "checking for ZEROSKIP... " >&6; }
 
-if test -n "$XML2_CFLAGS"; then
-    pkg_cv_XML2_CFLAGS="$XML2_CFLAGS"
+if test -n "$ZEROSKIP_CFLAGS"; then
+    pkg_cv_ZEROSKIP_CFLAGS="$ZEROSKIP_CFLAGS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libzeroskip\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libzeroskip") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_XML2_CFLAGS=`$PKG_CONFIG --cflags "libxml-2.0" 2>/dev/null`
+  pkg_cv_ZEROSKIP_CFLAGS=`$PKG_CONFIG --cflags "libzeroskip" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23015,16 +23178,16 @@ fi
  else
     pkg_failed=untried
 fi
-if test -n "$XML2_LIBS"; then
-    pkg_cv_XML2_LIBS="$XML2_LIBS"
+if test -n "$ZEROSKIP_LIBS"; then
+    pkg_cv_ZEROSKIP_LIBS="$ZEROSKIP_LIBS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libzeroskip\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libzeroskip") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_XML2_LIBS=`$PKG_CONFIG --libs "libxml-2.0" 2>/dev/null`
+  pkg_cv_ZEROSKIP_LIBS=`$PKG_CONFIG --libs "libzeroskip" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23045,132 +23208,64 @@ else
         _pkg_short_errors_supported=no
 fi
         if test $_pkg_short_errors_supported = yes; then
-	        XML2_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libxml-2.0" 2>&1`
+	        ZEROSKIP_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libzeroskip" 2>&1`
         else
-	        XML2_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libxml-2.0" 2>&1`
+	        ZEROSKIP_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libzeroskip" 2>&1`
         fi
 	# Put the nasty error message in config.log where it belongs
-	echo "$XML2_PKG_ERRORS" >&5
+	echo "$ZEROSKIP_PKG_ERRORS" >&5
 
-	as_fn_error $? "Need libxml-2.0 for http" "$LINENO" 5
+	with_zeroskip=no
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-	as_fn_error $? "Need libxml-2.0 for http" "$LINENO" 5
+	with_zeroskip=no
 else
-	XML2_CFLAGS=$pkg_cv_XML2_CFLAGS
-	XML2_LIBS=$pkg_cv_XML2_LIBS
+	ZEROSKIP_CFLAGS=$pkg_cv_ZEROSKIP_CFLAGS
+	ZEROSKIP_LIBS=$pkg_cv_ZEROSKIP_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
-                LIBS="$LIBS ${XML2_LIBS}"
-                with_xml2=yes
-
-fi
-
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for xmlFirstElementChild in -lxml2" >&5
-$as_echo_n "checking for xmlFirstElementChild in -lxml2... " >&6; }
-if ${ac_cv_lib_xml2_xmlFirstElementChild+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lxml2  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+$as_echo "#define HAVE_ZEROSKIP /**/" >>confdefs.h
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char xmlFirstElementChild ();
-int
-main ()
-{
-return xmlFirstElementChild ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_xml2_xmlFirstElementChild=yes
-else
-  ac_cv_lib_xml2_xmlFirstElementChild=no
+		  with_zeroskip=yes
 fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_xml2_xmlFirstElementChild" >&5
-$as_echo "$ac_cv_lib_xml2_xmlFirstElementChild" >&6; }
-if test "x$ac_cv_lib_xml2_xmlFirstElementChild" = xyes; then :
-
-
-$as_echo "#define HAVE_XML_FIRSTCHILD /**/" >>confdefs.h
-
 
-                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for xmlBufferDetach in -lxml2" >&5
-$as_echo_n "checking for xmlBufferDetach in -lxml2... " >&6; }
-if ${ac_cv_lib_xml2_xmlBufferDetach+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lxml2  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char xmlBufferDetach ();
-int
-main ()
-{
-return xmlBufferDetach ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_xml2_xmlBufferDetach=yes
+ if test "x$with_zeroskip" = xyes; then
+  USE_ZEROSKIP_TRUE=
+  USE_ZEROSKIP_FALSE='#'
 else
-  ac_cv_lib_xml2_xmlBufferDetach=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+  USE_ZEROSKIP_TRUE='#'
+  USE_ZEROSKIP_FALSE=
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_xml2_xmlBufferDetach" >&5
-$as_echo "$ac_cv_lib_xml2_xmlBufferDetach" >&6; }
-if test "x$ac_cv_lib_xml2_xmlBufferDetach" = xyes; then :
-
-$as_echo "#define HAVE_XML_BUFFERDETACH /**/" >>confdefs.h
 
-fi
 
 
+# Check whether --with-chardet was given.
+if test "${with_chardet+set}" = set; then :
+  withval=$with_chardet;
+else
+  with_chardet=yes
 fi
 
-
+if test "x$with_chardet" = "xyes"; then :
 
 pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICAL" >&5
-$as_echo_n "checking for ICAL... " >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for LIBCHARDET" >&5
+$as_echo_n "checking for LIBCHARDET... " >&6; }
 
-if test -n "$ICAL_CFLAGS"; then
-    pkg_cv_ICAL_CFLAGS="$ICAL_CFLAGS"
+if test -n "$LIBCHARDET_CFLAGS"; then
+    pkg_cv_LIBCHARDET_CFLAGS="$LIBCHARDET_CFLAGS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libical\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libical") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"chardet\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "chardet") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_ICAL_CFLAGS=`$PKG_CONFIG --cflags "libical" 2>/dev/null`
+  pkg_cv_LIBCHARDET_CFLAGS=`$PKG_CONFIG --cflags "chardet" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23178,16 +23273,16 @@ fi
  else
     pkg_failed=untried
 fi
-if test -n "$ICAL_LIBS"; then
-    pkg_cv_ICAL_LIBS="$ICAL_LIBS"
+if test -n "$LIBCHARDET_LIBS"; then
+    pkg_cv_LIBCHARDET_LIBS="$LIBCHARDET_LIBS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libical\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libical") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"chardet\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "chardet") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_ICAL_LIBS=`$PKG_CONFIG --libs "libical" 2>/dev/null`
+  pkg_cv_LIBCHARDET_LIBS=`$PKG_CONFIG --libs "chardet" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23208,395 +23303,365 @@ else
         _pkg_short_errors_supported=no
 fi
         if test $_pkg_short_errors_supported = yes; then
-	        ICAL_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libical" 2>&1`
+	        LIBCHARDET_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "chardet" 2>&1`
         else
-	        ICAL_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libical" 2>&1`
+	        LIBCHARDET_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "chardet" 2>&1`
         fi
 	# Put the nasty error message in config.log where it belongs
-	echo "$ICAL_PKG_ERRORS" >&5
+	echo "$LIBCHARDET_PKG_ERRORS" >&5
 
-	as_fn_error $? "Need libical for http" "$LINENO" 5
+	with_chardet=no
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-	as_fn_error $? "Need libical for http" "$LINENO" 5
+	with_chardet=no
 else
-	ICAL_CFLAGS=$pkg_cv_ICAL_CFLAGS
-	ICAL_LIBS=$pkg_cv_ICAL_LIBS
+	LIBCHARDET_CFLAGS=$pkg_cv_LIBCHARDET_CFLAGS
+	LIBCHARDET_LIBS=$pkg_cv_LIBCHARDET_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
+$as_echo "#define HAVE_LIBCHARDET /**/" >>confdefs.h
 
-$as_echo "#define HAVE_ICAL /**/" >>confdefs.h
+		  with_chardet=yes
+fi
+fi
 
-                LIBS="$LIBS ${ICAL_LIBS}"
-                with_ical=yes
 
+ if test "x$with_chardet" = xyes; then
+  USE_LIBCHARDET_TRUE=
+  USE_LIBCHARDET_FALSE='#'
+else
+  USE_LIBCHARDET_TRUE='#'
+  USE_LIBCHARDET_FALSE=
 fi
 
-        ac_fn_c_check_decl "$LINENO" "icalproperty_get_parent" "ac_cv_have_decl_icalproperty_get_parent" "#include <libical/ical.h>
-"
-if test "x$ac_cv_have_decl_icalproperty_get_parent" = xyes; then :
-  ac_have_decl=1
+
+
+# Check whether --with-cld2 was given.
+if test "${with_cld2+set}" = set; then :
+  withval=$with_cld2;
 else
-  ac_have_decl=0
+  with_cld2=yes
 fi
 
-cat >>confdefs.h <<_ACEOF
-#define HAVE_DECL_ICALPROPERTY_GET_PARENT $ac_have_decl
-_ACEOF
-ac_fn_c_check_decl "$LINENO" "icalrecur_freq_to_string" "ac_cv_have_decl_icalrecur_freq_to_string" "#include <libical/ical.h>
-"
-if test "x$ac_cv_have_decl_icalrecur_freq_to_string" = xyes; then :
-  ac_have_decl=1
-else
-  ac_have_decl=0
-fi
+if test "x$with_cld2" = "xyes"; then :
 
-cat >>confdefs.h <<_ACEOF
-#define HAVE_DECL_ICALRECUR_FREQ_TO_STRING $ac_have_decl
-_ACEOF
-ac_fn_c_check_decl "$LINENO" "icalrecur_weekday_to_string" "ac_cv_have_decl_icalrecur_weekday_to_string" "#include <libical/ical.h>
-"
-if test "x$ac_cv_have_decl_icalrecur_weekday_to_string" = xyes; then :
-  ac_have_decl=1
+pkg_failed=no
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for CLD2" >&5
+$as_echo_n "checking for CLD2... " >&6; }
+
+if test -n "$CLD2_CFLAGS"; then
+    pkg_cv_CLD2_CFLAGS="$CLD2_CFLAGS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"cld2\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "cld2") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_CLD2_CFLAGS=`$PKG_CONFIG --cflags "cld2" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
 else
-  ac_have_decl=0
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
+fi
+if test -n "$CLD2_LIBS"; then
+    pkg_cv_CLD2_LIBS="$CLD2_LIBS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"cld2\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "cld2") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_CLD2_LIBS=`$PKG_CONFIG --libs "cld2" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
+else
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
 fi
-
-cat >>confdefs.h <<_ACEOF
-#define HAVE_DECL_ICALRECUR_WEEKDAY_TO_STRING $ac_have_decl
-_ACEOF
 
 
-        ac_fn_c_check_member "$LINENO" "icaltimetype" "is_utc" "ac_cv_member_icaltimetype_is_utc" "#include <libical/ical.h>
-"
-if test "x$ac_cv_member_icaltimetype_is_utc" = xyes; then :
 
-$as_echo "#define ICALTIME_HAS_IS_UTC /**/" >>confdefs.h
+if test $pkg_failed = yes; then
+   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
 
+if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
+        _pkg_short_errors_supported=yes
+else
+        _pkg_short_errors_supported=no
 fi
+        if test $_pkg_short_errors_supported = yes; then
+	        CLD2_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "cld2" 2>&1`
+        else
+	        CLD2_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "cld2" 2>&1`
+        fi
+	# Put the nasty error message in config.log where it belongs
+	echo "$CLD2_PKG_ERRORS" >&5
 
-
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalproperty_new_acknowledged in -lical" >&5
-$as_echo_n "checking for icalproperty_new_acknowledged in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalproperty_new_acknowledged+:} false; then :
-  $as_echo_n "(cached) " >&6
+	with_cld2=no
+elif test $pkg_failed = untried; then
+     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+	with_cld2=no
 else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+	CLD2_CFLAGS=$pkg_cv_CLD2_CFLAGS
+	CLD2_LIBS=$pkg_cv_CLD2_LIBS
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalproperty_new_acknowledged ();
-int
-main ()
-{
-return icalproperty_new_acknowledged ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalproperty_new_acknowledged=yes
-else
-  ac_cv_lib_ical_icalproperty_new_acknowledged=no
+$as_echo "#define HAVE_CLD2 /**/" >>confdefs.h
+
+		  with_cld2=yes
 fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalproperty_new_acknowledged" >&5
-$as_echo "$ac_cv_lib_ical_icalproperty_new_acknowledged" >&6; }
-if test "x$ac_cv_lib_ical_icalproperty_new_acknowledged" = xyes; then :
 
-$as_echo "#define HAVE_VALARM_EXT_PROPS /**/" >>confdefs.h
 
+ if test "x$with_cld2" = xyes; then
+  HAVE_CLD2_TRUE=
+  HAVE_CLD2_FALSE='#'
+else
+  HAVE_CLD2_TRUE='#'
+  HAVE_CLD2_FALSE=
 fi
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalparameter_new_iana in -lical" >&5
-$as_echo_n "checking for icalparameter_new_iana in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalparameter_new_iana+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalparameter_new_iana ();
-int
-main ()
-{
-return icalparameter_new_iana ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalparameter_new_iana=yes
+# Check whether --with-pidfile was given.
+if test "${with_pidfile+set}" = set; then :
+  withval=$with_pidfile; MASTERPIDFILE="$withval"
 else
-  ac_cv_lib_ical_icalparameter_new_iana=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+  MASTERPIDFILE="/var/run/cyrus-master.pid"
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalparameter_new_iana" >&5
-$as_echo "$ac_cv_lib_ical_icalparameter_new_iana" >&6; }
-if test "x$ac_cv_lib_ical_icalparameter_new_iana" = xyes; then :
 
+MASTERPIDFILE="\"$MASTERPIDFILE\""
 
-$as_echo "#define HAVE_IANA_PARAMS /**/" >>confdefs.h
+cat >>confdefs.h <<_ACEOF
+#define MASTER_PIDFILE $MASTERPIDFILE
+_ACEOF
 
 
-                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalparameter_new_schedulestatus in -lical" >&5
-$as_echo_n "checking for icalparameter_new_schedulestatus in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalparameter_new_schedulestatus+:} false; then :
-  $as_echo_n "(cached) " >&6
+# Check whether --enable-autocreate was given.
+if test "${enable_autocreate+set}" = set; then :
+  enableval=$enable_autocreate;
 else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+  enable_autocreate="no";
+fi
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalparameter_new_schedulestatus ();
-int
-main ()
-{
-return icalparameter_new_schedulestatus ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalparameter_new_schedulestatus=yes
+ if test "$enable_autocreate" != "no"; then
+  AUTOCREATE_TRUE=
+  AUTOCREATE_FALSE='#'
 else
-  ac_cv_lib_ical_icalparameter_new_schedulestatus=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+  AUTOCREATE_TRUE='#'
+  AUTOCREATE_FALSE=
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalparameter_new_schedulestatus" >&5
-$as_echo "$ac_cv_lib_ical_icalparameter_new_schedulestatus" >&6; }
-if test "x$ac_cv_lib_ical_icalparameter_new_schedulestatus" = xyes; then :
 
-$as_echo "#define HAVE_SCHEDULING_PARAMS /**/" >>confdefs.h
+if test "x$enable_autocreate" = "xyes"; then
 
-fi
+$as_echo "#define USE_AUTOCREATE /**/" >>confdefs.h
 
+fi
+# Check whether --enable-idled was given.
+if test "${enable_idled+set}" = set; then :
+  enableval=$enable_idled;
+else
+  enable_idled="no";
+fi
 
-                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalparameter_new_managedid in -lical" >&5
-$as_echo_n "checking for icalparameter_new_managedid in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalparameter_new_managedid+:} false; then :
-  $as_echo_n "(cached) " >&6
+ if test "$enable_idled" != "no"; then
+  IDLED_TRUE=
+  IDLED_FALSE='#'
 else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+  IDLED_TRUE='#'
+  IDLED_FALSE=
+fi
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalparameter_new_managedid ();
-int
-main ()
-{
-return icalparameter_new_managedid ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalparameter_new_managedid=yes
+if test "x$enable_idled" = "xyes"; then
+
+$as_echo "#define USE_IDLED /**/" >>confdefs.h
+
+fi
+# Check whether --enable-nntp was given.
+if test "${enable_nntp+set}" = set; then :
+  enableval=$enable_nntp;
 else
-  ac_cv_lib_ical_icalparameter_new_managedid=no
+  enable_nntp="no";
 fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+
+ if test "$enable_nntp" != "no"; then
+  NNTPD_TRUE=
+  NNTPD_FALSE='#'
+else
+  NNTPD_TRUE='#'
+  NNTPD_FALSE=
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalparameter_new_managedid" >&5
-$as_echo "$ac_cv_lib_ical_icalparameter_new_managedid" >&6; }
-if test "x$ac_cv_lib_ical_icalparameter_new_managedid" = xyes; then :
 
-$as_echo "#define HAVE_MANAGED_ATTACH_PARAMS /**/" >>confdefs.h
+if test "x$enable_nntp" = "xyes"; then
+
+$as_echo "#define USE_NNTPD /**/" >>confdefs.h
 
 fi
 
+# Check whether --enable-murder was given.
+if test "${enable_murder+set}" = set; then :
+  enableval=$enable_murder;
+else
+  enable_murder="no";
+fi
 
-                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalproperty_new_tzuntil in -lical" >&5
-$as_echo_n "checking for icalproperty_new_tzuntil in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalproperty_new_tzuntil+:} false; then :
-  $as_echo_n "(cached) " >&6
+ if test "$enable_murder" != "no"; then
+  MURDER_TRUE=
+  MURDER_FALSE='#'
 else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+  MURDER_TRUE='#'
+  MURDER_FALSE=
+fi
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalproperty_new_tzuntil ();
-int
-main ()
-{
-return icalproperty_new_tzuntil ();
-  ;
-  return 0;
-}
+if test "$enable_murder" != no; then
+        # for master/slave auto-selection
+        for ac_header in sys/sockio.h
+do :
+  ac_fn_c_check_header_mongrel "$LINENO" "sys/sockio.h" "ac_cv_header_sys_sockio_h" "$ac_includes_default"
+if test "x$ac_cv_header_sys_sockio_h" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_SYS_SOCKIO_H 1
 _ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalproperty_new_tzuntil=yes
-else
-  ac_cv_lib_ical_icalproperty_new_tzuntil=no
+
 fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+
+done
+
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalproperty_new_tzuntil" >&5
-$as_echo "$ac_cv_lib_ical_icalproperty_new_tzuntil" >&6; }
-if test "x$ac_cv_lib_ical_icalproperty_new_tzuntil" = xyes; then :
+if test "x$enable_murder" = "xyes"; then
 
-$as_echo "#define HAVE_TZDIST_PROPS /**/" >>confdefs.h
+$as_echo "#define USE_MURDER /**/" >>confdefs.h
 
 fi
 
+# Check whether --enable-http was given.
+if test "${enable_http+set}" = set; then :
+  enableval=$enable_http;
+else
+  enable_http="no";
+fi
 
+ if test "$enable_http" != "no"; then
+  HTTPD_TRUE=
+  HTTPD_FALSE='#'
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support scheduling or managed attachments.  Consider upgrading to libical >= 0.48" >&5
-$as_echo "$as_me: Your version of libical can not support scheduling or managed attachments.  Consider upgrading to libical >= 0.48" >&6;}
+  HTTPD_TRUE='#'
+  HTTPD_FALSE=
 fi
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icaltimezone_set_builtin_tzdata in -lical" >&5
-$as_echo_n "checking for icaltimezone_set_builtin_tzdata in -lical... " >&6; }
-if ${ac_cv_lib_ical_icaltimezone_set_builtin_tzdata+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
+HTTP_CPPFLAGS=
+HTTP_LIBS=
+with_xml2=no
+with_ical=no
+with_shapelib=no
+with_brotli=no
+with_zstd=no
+if test "$enable_http" != no; then
+        if test "x$HAVE_SQLITE" != x1; then
+            as_fn_error $? "Need sqlite3 for http" "$LINENO" 5
+        else
+            use_sqlite="yes"
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icaltimezone_set_builtin_tzdata ();
-int
-main ()
-{
-return icaltimezone_set_builtin_tzdata ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icaltimezone_set_builtin_tzdata=yes
+$as_echo "#define WITH_DAV /**/" >>confdefs.h
+
+        fi
+
+
+pkg_failed=no
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for XML2" >&5
+$as_echo_n "checking for XML2... " >&6; }
+
+if test -n "$XML2_CFLAGS"; then
+    pkg_cv_XML2_CFLAGS="$XML2_CFLAGS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_XML2_CFLAGS=`$PKG_CONFIG --cflags "libxml-2.0" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
 else
-  ac_cv_lib_ical_icaltimezone_set_builtin_tzdata=no
+  pkg_failed=yes
 fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+ else
+    pkg_failed=untried
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icaltimezone_set_builtin_tzdata" >&5
-$as_echo "$ac_cv_lib_ical_icaltimezone_set_builtin_tzdata" >&6; }
-if test "x$ac_cv_lib_ical_icaltimezone_set_builtin_tzdata" = xyes; then :
-
-$as_echo "#define HAVE_TZ_BY_REF /**/" >>confdefs.h
-
+if test -n "$XML2_LIBS"; then
+    pkg_cv_XML2_LIBS="$XML2_LIBS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_XML2_LIBS=`$PKG_CONFIG --libs "libxml-2.0" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support timezones by reference.  Consider upgrading to libical >= 1.0.1" >&5
-$as_echo "$as_me: Your version of libical can not support timezones by reference.  Consider upgrading to libical >= 1.0.1" >&6;}
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
 fi
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalcomponent_new_vavailability in -lical" >&5
-$as_echo_n "checking for icalcomponent_new_vavailability in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalcomponent_new_vavailability+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
 
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char icalcomponent_new_vavailability ();
-int
-main ()
-{
-return icalcomponent_new_vavailability ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalcomponent_new_vavailability=yes
+if test $pkg_failed = yes; then
+   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
+        _pkg_short_errors_supported=yes
 else
-  ac_cv_lib_ical_icalcomponent_new_vavailability=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+        _pkg_short_errors_supported=no
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalcomponent_new_vavailability" >&5
-$as_echo "$ac_cv_lib_ical_icalcomponent_new_vavailability" >&6; }
-if test "x$ac_cv_lib_ical_icalcomponent_new_vavailability" = xyes; then :
+        if test $_pkg_short_errors_supported = yes; then
+	        XML2_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libxml-2.0" 2>&1`
+        else
+	        XML2_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libxml-2.0" 2>&1`
+        fi
+	# Put the nasty error message in config.log where it belongs
+	echo "$XML2_PKG_ERRORS" >&5
+
+	as_fn_error $? "Need libxml-2.0 for http" "$LINENO" 5
+elif test $pkg_failed = untried; then
+     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+	as_fn_error $? "Need libxml-2.0 for http" "$LINENO" 5
+else
+	XML2_CFLAGS=$pkg_cv_XML2_CFLAGS
+	XML2_LIBS=$pkg_cv_XML2_LIBS
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+
+
+$as_echo "#define HAVE_XML2 /**/" >>confdefs.h
 
-$as_echo "#define HAVE_VAVAILABILITY /**/" >>confdefs.h
+                LIBS="$LIBS ${XML2_LIBS}"
+                with_xml2=yes
 
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support availability.  Consider upgrading to libical >= 1.0.1" >&5
-$as_echo "$as_me: Your version of libical can not support availability.  Consider upgrading to libical >= 1.0.1" >&6;}
 fi
 
-
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalcomponent_new_vvoter in -lical" >&5
-$as_echo_n "checking for icalcomponent_new_vvoter in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalcomponent_new_vvoter+:} false; then :
+        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for xmlFirstElementChild in -lxml2" >&5
+$as_echo_n "checking for xmlFirstElementChild in -lxml2... " >&6; }
+if ${ac_cv_lib_xml2_xmlFirstElementChild+:} false; then :
   $as_echo_n "(cached) " >&6
 else
   ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
+LIBS="-lxml2  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -23606,43 +23671,39 @@ cat confdefs.h - <<_ACEOF >conftest.$ac_
 #ifdef __cplusplus
 extern "C"
 #endif
-char icalcomponent_new_vvoter ();
+char xmlFirstElementChild ();
 int
 main ()
 {
-return icalcomponent_new_vvoter ();
+return xmlFirstElementChild ();
   ;
   return 0;
 }
 _ACEOF
 if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalcomponent_new_vvoter=yes
+  ac_cv_lib_xml2_xmlFirstElementChild=yes
 else
-  ac_cv_lib_ical_icalcomponent_new_vvoter=no
+  ac_cv_lib_xml2_xmlFirstElementChild=no
 fi
 rm -f core conftest.err conftest.$ac_objext \
     conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalcomponent_new_vvoter" >&5
-$as_echo "$ac_cv_lib_ical_icalcomponent_new_vvoter" >&6; }
-if test "x$ac_cv_lib_ical_icalcomponent_new_vvoter" = xyes; then :
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_xml2_xmlFirstElementChild" >&5
+$as_echo "$ac_cv_lib_xml2_xmlFirstElementChild" >&6; }
+if test "x$ac_cv_lib_xml2_xmlFirstElementChild" = xyes; then :
 
-$as_echo "#define HAVE_VPOLL /**/" >>confdefs.h
 
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support consensus scheduling.  Consider upgrading to libical >= 2.0" >&5
-$as_echo "$as_me: Your version of libical can not support consensus scheduling.  Consider upgrading to libical >= 2.0" >&6;}
-fi
+$as_echo "#define HAVE_XML_FIRSTCHILD /**/" >>confdefs.h
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalrecurrencetype_rscale_is_supported in -lical" >&5
-$as_echo_n "checking for icalrecurrencetype_rscale_is_supported in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported+:} false; then :
+                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for xmlBufferDetach in -lxml2" >&5
+$as_echo_n "checking for xmlBufferDetach in -lxml2... " >&6; }
+if ${ac_cv_lib_xml2_xmlBufferDetach+:} false; then :
   $as_echo_n "(cached) " >&6
 else
   ac_check_lib_save_LIBS=$LIBS
-LIBS="-lical  $LIBS"
+LIBS="-lxml2  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -23652,43 +23713,51 @@ cat confdefs.h - <<_ACEOF >conftest.$ac_
 #ifdef __cplusplus
 extern "C"
 #endif
-char icalrecurrencetype_rscale_is_supported ();
+char xmlBufferDetach ();
 int
 main ()
 {
-return icalrecurrencetype_rscale_is_supported ();
+return xmlBufferDetach ();
   ;
   return 0;
 }
 _ACEOF
 if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported=yes
+  ac_cv_lib_xml2_xmlBufferDetach=yes
 else
-  ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported=no
+  ac_cv_lib_xml2_xmlBufferDetach=no
 fi
 rm -f core conftest.err conftest.$ac_objext \
     conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" >&5
-$as_echo "$ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" >&6; }
-if test "x$ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" = xyes; then :
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_xml2_xmlBufferDetach" >&5
+$as_echo "$ac_cv_lib_xml2_xmlBufferDetach" >&6; }
+if test "x$ac_cv_lib_xml2_xmlBufferDetach" = xyes; then :
+
+$as_echo "#define HAVE_XML_BUFFERDETACH /**/" >>confdefs.h
+
+fi
+
+
+fi
+
 
 
 pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICU4C" >&5
-$as_echo_n "checking for ICU4C... " >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICAL" >&5
+$as_echo_n "checking for ICAL... " >&6; }
 
-if test -n "$ICU4C_CFLAGS"; then
-    pkg_cv_ICU4C_CFLAGS="$ICU4C_CFLAGS"
+if test -n "$ICAL_CFLAGS"; then
+    pkg_cv_ICAL_CFLAGS="$ICAL_CFLAGS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-i18n\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "icu-i18n") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libical >= 3.0.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libical >= 3.0.0") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_ICU4C_CFLAGS=`$PKG_CONFIG --cflags "icu-i18n" 2>/dev/null`
+  pkg_cv_ICAL_CFLAGS=`$PKG_CONFIG --cflags "libical >= 3.0.0" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23696,16 +23765,16 @@ fi
  else
     pkg_failed=untried
 fi
-if test -n "$ICU4C_LIBS"; then
-    pkg_cv_ICU4C_LIBS="$ICU4C_LIBS"
+if test -n "$ICAL_LIBS"; then
+    pkg_cv_ICAL_LIBS="$ICAL_LIBS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-i18n\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "icu-i18n") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libical >= 3.0.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libical >= 3.0.0") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_ICU4C_LIBS=`$PKG_CONFIG --libs "icu-i18n" 2>/dev/null`
+  pkg_cv_ICAL_LIBS=`$PKG_CONFIG --libs "libical >= 3.0.0" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23726,41 +23795,78 @@ else
         _pkg_short_errors_supported=no
 fi
         if test $_pkg_short_errors_supported = yes; then
-	        ICU4C_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "icu-i18n" 2>&1`
+	        ICAL_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libical >= 3.0.0" 2>&1`
         else
-	        ICU4C_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "icu-i18n" 2>&1`
+	        ICAL_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libical >= 3.0.0" 2>&1`
         fi
 	# Put the nasty error message in config.log where it belongs
-	echo "$ICU4C_PKG_ERRORS" >&5
+	echo "$ICAL_PKG_ERRORS" >&5
 
-	as_fn_error $? "Need ICU4C for RSCALE support in httpd" "$LINENO" 5
+	as_fn_error $? "Need libical 3.0.0 for http" "$LINENO" 5
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-	as_fn_error $? "Need ICU4C for RSCALE support in httpd" "$LINENO" 5
+	as_fn_error $? "Need libical 3.0.0 for http" "$LINENO" 5
 else
-	ICU4C_CFLAGS=$pkg_cv_ICU4C_CFLAGS
-	ICU4C_LIBS=$pkg_cv_ICU4C_LIBS
+	ICAL_CFLAGS=$pkg_cv_ICAL_CFLAGS
+	ICAL_LIBS=$pkg_cv_ICAL_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
 
-$as_echo "#define HAVE_RSCALE /**/" >>confdefs.h
+$as_echo "#define HAVE_ICAL /**/" >>confdefs.h
 
-                        LIBS="$LIBS ${ICU4C_LIBS}"
-                        with_icu4c=yes
+                LIBS="$LIBS ${ICAL_LIBS}"
+                with_ical=yes
 
 fi
 
+                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalproperty_new_color in -lical" >&5
+$as_echo_n "checking for icalproperty_new_color in -lical... " >&6; }
+if ${ac_cv_lib_ical_icalproperty_new_color+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lical  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char icalproperty_new_color ();
+int
+main ()
+{
+return icalproperty_new_color ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_ical_icalproperty_new_color=yes
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support non-gregorian recurrences.  Consider upgrading to libical >= 2.0" >&5
-$as_echo "$as_me: Your version of libical can not support non-gregorian recurrences.  Consider upgrading to libical >= 2.0" >&6;}
+  ac_cv_lib_ical_icalproperty_new_color=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalproperty_new_color" >&5
+$as_echo "$ac_cv_lib_ical_icalproperty_new_color" >&6; }
+if test "x$ac_cv_lib_ical_icalproperty_new_color" = xyes; then :
+
+$as_echo "#define HAVE_RFC7986_COLOR /**/" >>confdefs.h
+
 fi
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalcomponent_new_vpatch in -lical" >&5
-$as_echo_n "checking for icalcomponent_new_vpatch in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalcomponent_new_vpatch+:} false; then :
+                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalrecurrencetype_rscale_is_supported in -lical" >&5
+$as_echo_n "checking for icalrecurrencetype_rscale_is_supported in -lical... " >&6; }
+if ${ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported+:} false; then :
   $as_echo_n "(cached) " >&6
 else
   ac_check_lib_save_LIBS=$LIBS
@@ -23774,39 +23880,39 @@ cat confdefs.h - <<_ACEOF >conftest.$ac_
 #ifdef __cplusplus
 extern "C"
 #endif
-char icalcomponent_new_vpatch ();
+char icalrecurrencetype_rscale_is_supported ();
 int
 main ()
 {
-return icalcomponent_new_vpatch ();
+return icalrecurrencetype_rscale_is_supported ();
   ;
   return 0;
 }
 _ACEOF
 if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalcomponent_new_vpatch=yes
+  ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported=yes
 else
-  ac_cv_lib_ical_icalcomponent_new_vpatch=no
+  ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported=no
 fi
 rm -f core conftest.err conftest.$ac_objext \
     conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalcomponent_new_vpatch" >&5
-$as_echo "$ac_cv_lib_ical_icalcomponent_new_vpatch" >&6; }
-if test "x$ac_cv_lib_ical_icalcomponent_new_vpatch" = xyes; then :
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" >&5
+$as_echo "$ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" >&6; }
+if test "x$ac_cv_lib_ical_icalrecurrencetype_rscale_is_supported" = xyes; then :
 
-$as_echo "#define HAVE_VPATCH /**/" >>confdefs.h
+$as_echo "#define HAVE_RSCALE /**/" >>confdefs.h
 
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support patching iCalendar objects.  Consider upgrading to libical >= 2.1" >&5
-$as_echo "$as_me: Your version of libical can not support patching iCalendar objects.  Consider upgrading to libical >= 2.1" >&6;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: Your version of libical can not support non-gregorian recurrences" >&5
+$as_echo "$as_me: Your version of libical can not support non-gregorian recurrences" >&6;}
 fi
 
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalrecur_iterator_set_start in -lical" >&5
-$as_echo_n "checking for icalrecur_iterator_set_start in -lical... " >&6; }
-if ${ac_cv_lib_ical_icalrecur_iterator_set_start+:} false; then :
+                { $as_echo "$as_me:${as_lineno-$LINENO}: checking for icalcomponent_clone in -lical" >&5
+$as_echo_n "checking for icalcomponent_clone in -lical... " >&6; }
+if ${ac_cv_lib_ical_icalcomponent_clone+:} false; then :
   $as_echo_n "(cached) " >&6
 else
   ac_check_lib_save_LIBS=$LIBS
@@ -23820,34 +23926,35 @@ cat confdefs.h - <<_ACEOF >conftest.$ac_
 #ifdef __cplusplus
 extern "C"
 #endif
-char icalrecur_iterator_set_start ();
+char icalcomponent_clone ();
 int
 main ()
 {
-return icalrecur_iterator_set_start ();
+return icalcomponent_clone ();
   ;
   return 0;
 }
 _ACEOF
 if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_ical_icalrecur_iterator_set_start=yes
+  ac_cv_lib_ical_icalcomponent_clone=yes
 else
-  ac_cv_lib_ical_icalrecur_iterator_set_start=no
+  ac_cv_lib_ical_icalcomponent_clone=no
 fi
 rm -f core conftest.err conftest.$ac_objext \
     conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalrecur_iterator_set_start" >&5
-$as_echo "$ac_cv_lib_ical_icalrecur_iterator_set_start" >&6; }
-if test "x$ac_cv_lib_ical_icalrecur_iterator_set_start" = xyes; then :
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ical_icalcomponent_clone" >&5
+$as_echo "$ac_cv_lib_ical_icalcomponent_clone" >&6; }
+if test "x$ac_cv_lib_ical_icalcomponent_clone" = xyes; then :
 
-$as_echo "#define HAVE_RECUR_ITERATOR_START /**/" >>confdefs.h
+$as_echo "#define HAVE_NEW_CLONE_API /**/" >>confdefs.h
 
 fi
 
 
 
+
 # Check whether --with-nghttp2 was given.
 if test "${with_nghttp2+set}" = set; then :
   withval=$with_nghttp2;
@@ -23913,56 +24020,251 @@ fi
 	        NGHTTP2_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libnghttp2 >= 1.5" 2>&1`
         fi
 	# Put the nasty error message in config.log where it belongs
-	echo "$NGHTTP2_PKG_ERRORS" >&5
-
-
-                    if test "x$with_nghttp2" = "xyes"; then
-                        as_fn_error $? "HTTP/2 explicitly requested, but libnghttp2 was not found" "$LINENO" 5
-                    fi
-                    with_nghttp2=no
-                    { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&5
-$as_echo "$as_me: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&6;}
+	echo "$NGHTTP2_PKG_ERRORS" >&5
+
+
+                        if test "x$with_nghttp2" = "xyes"; then
+                                as_fn_error $? "HTTP/2 explicitly requested, but libnghttp2 was not found" "$LINENO" 5
+                        fi
+                        { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&5
+$as_echo "$as_me: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&6;}
+                        with_nghttp2=no
+
+elif test $pkg_failed = untried; then
+     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+                        if test "x$with_nghttp2" = "xyes"; then
+                                as_fn_error $? "HTTP/2 explicitly requested, but libnghttp2 was not found" "$LINENO" 5
+                        fi
+                        { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&5
+$as_echo "$as_me: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&6;}
+                        with_nghttp2=no
+
+else
+	NGHTTP2_CFLAGS=$pkg_cv_NGHTTP2_CFLAGS
+	NGHTTP2_LIBS=$pkg_cv_NGHTTP2_LIBS
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+
+
+$as_echo "#define HAVE_NGHTTP2 /**/" >>confdefs.h
+
+                        ac_fn_c_check_decl "$LINENO" "NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL" "ac_cv_have_decl_NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL" "#include <nghttp2/nghttp2.h>
+"
+if test "x$ac_cv_have_decl_NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL" = xyes; then :
+  ac_have_decl=1
+else
+  ac_have_decl=0
+fi
+
+cat >>confdefs.h <<_ACEOF
+#define HAVE_DECL_NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL $ac_have_decl
+_ACEOF
+
+                        with_nghttp2=yes
+
+fi
+        fi
+
+
+
+# Check whether --with-wslay was given.
+if test "${with_wslay+set}" = set; then :
+  withval=$with_wslay;
+else
+  with_wslay="check"
+fi
+
+        if test "x$with_wslay" = "xyes" -o "x$with_wslay" = "xcheck"; then
+
+pkg_failed=no
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for WSLAY" >&5
+$as_echo_n "checking for WSLAY... " >&6; }
+
+if test -n "$WSLAY_CFLAGS"; then
+    pkg_cv_WSLAY_CFLAGS="$WSLAY_CFLAGS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libwslay >= 1.1.1\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libwslay >= 1.1.1") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_WSLAY_CFLAGS=`$PKG_CONFIG --cflags "libwslay >= 1.1.1" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
+else
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
+fi
+if test -n "$WSLAY_LIBS"; then
+    pkg_cv_WSLAY_LIBS="$WSLAY_LIBS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libwslay >= 1.1.1\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libwslay >= 1.1.1") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_WSLAY_LIBS=`$PKG_CONFIG --libs "libwslay >= 1.1.1" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
+else
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
+fi
+
+
+
+if test $pkg_failed = yes; then
+   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
+        _pkg_short_errors_supported=yes
+else
+        _pkg_short_errors_supported=no
+fi
+        if test $_pkg_short_errors_supported = yes; then
+	        WSLAY_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libwslay >= 1.1.1" 2>&1`
+        else
+	        WSLAY_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libwslay >= 1.1.1" 2>&1`
+        fi
+	# Put the nasty error message in config.log where it belongs
+	echo "$WSLAY_PKG_ERRORS" >&5
+
+
+                        if test "x$with_wslay" = "xyes"; then
+                                as_fn_error $? "WebSockets explicitly requested, but libwslay was not found" "$LINENO" 5
+                        fi
+                        { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for WebSockets.  Consider installing libwslay" >&5
+$as_echo "$as_me: httpd will not have support for WebSockets.  Consider installing libwslay" >&6;}
+                        with_wslay=no
+
+elif test $pkg_failed = untried; then
+     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+                        if test "x$with_wslay" = "xyes"; then
+                                as_fn_error $? "WebSockets explicitly requested, but libwslay was not found" "$LINENO" 5
+                        fi
+                        { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for WebSockets.  Consider installing libwslay" >&5
+$as_echo "$as_me: httpd will not have support for WebSockets.  Consider installing libwslay" >&6;}
+                        with_wslay=no
+
+else
+	WSLAY_CFLAGS=$pkg_cv_WSLAY_CFLAGS
+	WSLAY_LIBS=$pkg_cv_WSLAY_LIBS
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+
+
+$as_echo "#define HAVE_WSLAY /**/" >>confdefs.h
+
+                        with_wslay=yes
+
+fi
+        fi
+
+
+
+pkg_failed=no
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for BROTLI" >&5
+$as_echo_n "checking for BROTLI... " >&6; }
+
+if test -n "$BROTLI_CFLAGS"; then
+    pkg_cv_BROTLI_CFLAGS="$BROTLI_CFLAGS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libbrotlienc\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libbrotlienc") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_BROTLI_CFLAGS=`$PKG_CONFIG --cflags "libbrotlienc" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
+else
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
+fi
+if test -n "$BROTLI_LIBS"; then
+    pkg_cv_BROTLI_LIBS="$BROTLI_LIBS"
+ elif test -n "$PKG_CONFIG"; then
+    if test -n "$PKG_CONFIG" && \
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libbrotlienc\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libbrotlienc") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; then
+  pkg_cv_BROTLI_LIBS=`$PKG_CONFIG --libs "libbrotlienc" 2>/dev/null`
+		      test "x$?" != "x0" && pkg_failed=yes
+else
+  pkg_failed=yes
+fi
+ else
+    pkg_failed=untried
+fi
+
+
+
+if test $pkg_failed = yes; then
+   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
+        _pkg_short_errors_supported=yes
+else
+        _pkg_short_errors_supported=no
+fi
+        if test $_pkg_short_errors_supported = yes; then
+	        BROTLI_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libbrotlienc" 2>&1`
+        else
+	        BROTLI_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libbrotlienc" 2>&1`
+        fi
+	# Put the nasty error message in config.log where it belongs
+	echo "$BROTLI_PKG_ERRORS" >&5
 
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&5
+$as_echo "$as_me: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&6;}
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-
-                    if test "x$with_nghttp2" = "xyes"; then
-                        as_fn_error $? "HTTP/2 explicitly requested, but libnghttp2 was not found" "$LINENO" 5
-                    fi
-                    with_nghttp2=no
-                    { $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&5
-$as_echo "$as_me: httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5" >&6;}
-
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&5
+$as_echo "$as_me: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&6;}
 else
-	NGHTTP2_CFLAGS=$pkg_cv_NGHTTP2_CFLAGS
-	NGHTTP2_LIBS=$pkg_cv_NGHTTP2_LIBS
+	BROTLI_CFLAGS=$pkg_cv_BROTLI_CFLAGS
+	BROTLI_LIBS=$pkg_cv_BROTLI_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
-                    with_nghttp2=yes
 
-$as_echo "#define HAVE_NGHTTP2 /**/" >>confdefs.h
+$as_echo "#define HAVE_BROTLI /**/" >>confdefs.h
 
+                with_brotli=yes
 
 fi
-        fi
+
 
 
 pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for BROTLI" >&5
-$as_echo_n "checking for BROTLI... " >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ZSTD" >&5
+$as_echo_n "checking for ZSTD... " >&6; }
 
-if test -n "$BROTLI_CFLAGS"; then
-    pkg_cv_BROTLI_CFLAGS="$BROTLI_CFLAGS"
+if test -n "$ZSTD_CFLAGS"; then
+    pkg_cv_ZSTD_CFLAGS="$ZSTD_CFLAGS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libbrotlienc\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libbrotlienc") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libzstd >= 1.4.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libzstd >= 1.4.0") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_BROTLI_CFLAGS=`$PKG_CONFIG --cflags "libbrotlienc" 2>/dev/null`
+  pkg_cv_ZSTD_CFLAGS=`$PKG_CONFIG --cflags "libzstd >= 1.4.0" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -23970,16 +24272,16 @@ fi
  else
     pkg_failed=untried
 fi
-if test -n "$BROTLI_LIBS"; then
-    pkg_cv_BROTLI_LIBS="$BROTLI_LIBS"
+if test -n "$ZSTD_LIBS"; then
+    pkg_cv_ZSTD_LIBS="$ZSTD_LIBS"
  elif test -n "$PKG_CONFIG"; then
     if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libbrotlienc\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libbrotlienc") 2>&5
+    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libzstd >= 1.4.0\""; } >&5
+  ($PKG_CONFIG --exists --print-errors "libzstd >= 1.4.0") 2>&5
   ac_status=$?
   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }; then
-  pkg_cv_BROTLI_LIBS=`$PKG_CONFIG --libs "libbrotlienc" 2>/dev/null`
+  pkg_cv_ZSTD_LIBS=`$PKG_CONFIG --libs "libzstd >= 1.4.0" 2>/dev/null`
 		      test "x$?" != "x0" && pkg_failed=yes
 else
   pkg_failed=yes
@@ -24000,30 +24302,30 @@ else
         _pkg_short_errors_supported=no
 fi
         if test $_pkg_short_errors_supported = yes; then
-	        BROTLI_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libbrotlienc" 2>&1`
+	        ZSTD_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libzstd >= 1.4.0" 2>&1`
         else
-	        BROTLI_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libbrotlienc" 2>&1`
+	        ZSTD_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libzstd >= 1.4.0" 2>&1`
         fi
 	# Put the nasty error message in config.log where it belongs
-	echo "$BROTLI_PKG_ERRORS" >&5
+	echo "$ZSTD_PKG_ERRORS" >&5
 
-	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&5
-$as_echo "$as_me: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&6;}
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Zstandard compression.  Consider installing libzstd" >&5
+$as_echo "$as_me: httpd will not have support for Zstandard compression.  Consider installing libzstd" >&6;}
 elif test $pkg_failed = untried; then
      	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
 $as_echo "no" >&6; }
-	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&5
-$as_echo "$as_me: httpd will not have support for Brotli compression.  Consider installing libbrotli" >&6;}
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: httpd will not have support for Zstandard compression.  Consider installing libzstd" >&5
+$as_echo "$as_me: httpd will not have support for Zstandard compression.  Consider installing libzstd" >&6;}
 else
-	BROTLI_CFLAGS=$pkg_cv_BROTLI_CFLAGS
-	BROTLI_LIBS=$pkg_cv_BROTLI_LIBS
+	ZSTD_CFLAGS=$pkg_cv_ZSTD_CFLAGS
+	ZSTD_LIBS=$pkg_cv_ZSTD_LIBS
         { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 $as_echo "yes" >&6; }
 
 
-$as_echo "#define HAVE_BROTLI /**/" >>confdefs.h
+$as_echo "#define HAVE_ZSTD /**/" >>confdefs.h
 
-                with_brotli=yes
+                with_zstd=yes
 
 fi
 
@@ -24111,8 +24413,8 @@ $as_echo "#define SHAPELIB_VERSION \"1.3
 
 fi
 
-        HTTP_CPPFLAGS="${XML2_CFLAGS} ${SQLITE3_CFLAGS} ${ICAL_CFLAGS} ${JANSSON_CFLAGS} ${NGHTTP2_CFLAGS} ${BROTLI_CFLAGS} ${SHAPELIB_CFLAGS}"
-        HTTP_LIBS="${XML2_LIBS} ${SQLITE3_LIBS} ${ICAL_LIBS} ${JANSSON_LIBS} ${NGHTTP2_LIBS} ${BROTLI_LIBS} ${SHAPELIB_LIBS} ${LIB_MATH}"
+        HTTP_CPPFLAGS="${XML2_CFLAGS} ${SQLITE3_CFLAGS} ${ICAL_CFLAGS} ${GLIB_CFLAGS} ${JANSSON_CFLAGS} ${NGHTTP2_CFLAGS} ${WSLAY_CFLAGS} ${BROTLI_CFLAGS} ${ZSTD_CFLAGS} ${SHAPELIB_CFLAGS}"
+        HTTP_LIBS="${XML2_LIBS} ${SQLITE3_LIBS} ${ICAL_LIBS} ${GLIB_LIBS} ${JANSSON_LIBS} ${NGHTTP2_LIBS} ${WSLAY_LIBS} ${BROTLI_LIBS} ${ZSTD_LIBS} ${SHAPELIB_LIBS} ${LIB_MATH}"
 fi
 
 
@@ -24147,6 +24449,33 @@ else
 fi
 
 
+# Check whether --enable-jmap was given.
+if test "${enable_jmap+set}" = set; then :
+  enableval=$enable_jmap;
+else
+  enable_jmap="no";
+fi
+
+if test "x$enable_jmap" = "xyes" ; then
+    if test "x$enable_xapian" = "xno" ; then
+        as_fn_error $? "--enable-jmap requires --enable-xapian" "$LINENO" 5
+    fi
+    if test "x$enable_http" = "xno" ; then
+        as_fn_error $? "--enable-jmap requires --enable-http" "$LINENO" 5
+    fi
+
+$as_echo "#define WITH_JMAP /**/" >>confdefs.h
+
+fi
+ if test "${enable_jmap}" != "no"; then
+  JMAP_TRUE=
+  JMAP_FALSE='#'
+else
+  JMAP_TRUE='#'
+  JMAP_FALSE=
+fi
+
+
 # Check whether --enable-replication was given.
 if test "${enable_replication+set}" = set; then :
   enableval=$enable_replication;
@@ -24461,7 +24790,7 @@ case "$with_com_err" in
   # built-in et
   yes) # use the com_err we're gonna build
           COM_ERR_LIBS="com_err/et/libcyrus_com_err.la"
-          COM_ERR_CPPFLAGS="-I\${top_srcdir}/com_err/et"
+          COM_ERR_CPPFLAGS="-I\${abs_top_srcdir}/com_err/et"
           ;;
   "")   # no problem, we already have it in the paths
         # we do nothing to pick it up
@@ -26174,7 +26503,7 @@ fi
 if test "${with_snmp+set}" = set; then :
   withval=$with_snmp; with_snmp=$withval
 else
-  with_snmp=yes
+  with_snmp=no
 fi
 
 
@@ -26382,6 +26711,13 @@ fi
 fi
 
 
+if test "x$with_snmp" != "xno"; then :
+   { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: SNMP support is deprecated and will be removed in the future." >&5
+$as_echo "$as_me: WARNING: SNMP support is deprecated and will be removed in the future." >&2;}
+        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: Consider using Prometheus instead." >&5
+$as_echo "$as_me: WARNING: Consider using Prometheus instead." >&2;}
+
+fi
 
 # Figure out what directories we're linking against.
 # Lots of fun for the whole family.
@@ -26423,7 +26759,7 @@ if test "${enable_unit_tests+set}" = set
 fi
 
 
-if test "$enable_unit_tests" = "yes" ; then
+if test "x$enable_unit_tests" = xyes ; then
     { $as_echo "$as_me:${as_lineno-$LINENO}: checking for CU_initialize_registry in -lcunit" >&5
 $as_echo_n "checking for CU_initialize_registry in -lcunit... " >&6; }
 if ${ac_cv_lib_cunit_CU_initialize_registry+:} false; then :
@@ -26475,9 +26811,14 @@ fi
 
 
     if test "$found_lib$found_hdr" != "yesyes" ; then
+        if test "x$enable_unit_tests" = xyes; then
+            as_fn_error $? "Unit tests explicitly requested, but CUnit library is not installed" "$LINENO" 5
+        fi
         { $as_echo "$as_me:${as_lineno-$LINENO}: Disabling unit tests because the required CUnit library is not installed" >&5
 $as_echo "$as_me: Disabling unit tests because the required CUnit library is not installed" >&6;}
         enable_unit_tests=no
+    else
+        enable_unit_tests=yes
     fi
     ac_fn_c_check_header_mongrel "$LINENO" "CUnit/Basic.h" "ac_cv_header_CUnit_Basic_h" "$ac_includes_default"
 if test "x$ac_cv_header_CUnit_Basic_h" = xyes; then :
@@ -26581,6 +26922,25 @@ else
 fi
 
 
+# Check whether --enable-cyrusdb-benchmarks was given.
+if test "${enable_cyrusdb_benchmarks+set}" = set; then :
+  enableval=$enable_cyrusdb_benchmarks;
+fi
+
+
+if test "$enable_cyrusbd_benchmarks" = "yes" ; then
+    USE_MAINTAINER_MODE=yes
+fi
+
+ if test "$enable_cyrusdb_benchmarks" = "yes"; then
+  BENCH_TRUE=
+  BENCH_FALSE='#'
+else
+  BENCH_TRUE='#'
+  BENCH_FALSE=
+fi
+
+
 if test "x$use_sqlite" = xyes; then
   if test "x$HAVE_SQLITE" = x1; then
     if test "x$with_sqlite_lib" != xnone; then
@@ -26613,6 +26973,102 @@ else
 fi
 
 
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for function nesting" >&5
+$as_echo_n "checking for function nesting... " >&6; }
+if ${cyrus_cv_function_nesting+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+#include <stdlib.h>
+void func(void *data, size_t nmemb, size_t size,
+          int (*compar)(const void *, const void *, void *),
+          void *thunk)
+{
+    int compar_func(const void *a, const void *b)
+    {
+        return compar(a, b, thunk);
+    }
+    qsort(data, nmemb, size, compar_func);
+}
+int cval(const void *a, const void *b, void *prev)
+{
+  char **ref = (char **)prev;
+  char *ac = (char *)a;
+  char *bc = (char *)b;
+  if (*ac < *bc) return -1;
+  if (*ac == *bc) return 0;
+  *ref = bc;
+  return 1;
+}
+
+int
+main ()
+{
+
+    char *dest;
+    func("abc", 3, 1, cval, &dest);
+
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_compile "$LINENO"; then :
+  cyrus_cv_function_nesting=yes
+else
+  cyrus_cv_function_nesting=no
+fi
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+fi
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $cyrus_cv_function_nesting" >&5
+$as_echo "$cyrus_cv_function_nesting" >&6; }
+if test "$cyrus_cv_function_nesting" = "yes"; then
+
+$as_echo "#define HAVE_FUNCTION_NESTING /**/" >>confdefs.h
+
+fi
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for optimisation support" >&5
+$as_echo_n "checking for optimisation support... " >&6; }
+if ${cyrus_cv_declare_optimize+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+#include <stdlib.h>
+static inline int numcmp(int n1, int n2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+static int numcmp(int n1, int n2) { return n1 - n2; }
+
+int
+main ()
+{
+
+    if (numcmp(1, 2)) exit(1);
+
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_compile "$LINENO"; then :
+  cyrus_cv_declare_optimize=yes
+else
+  cyrus_cv_declare_optimize=no
+fi
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+fi
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $cyrus_cv_declare_optimize" >&5
+$as_echo "$cyrus_cv_declare_optimize" >&6; }
+if test "$cyrus_cv_declare_optimize" = "yes"; then
+
+$as_echo "#define HAVE_DECLARE_OPTIMIZE /**/" >>confdefs.h
+
+fi
+
 
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for compiler support for SSE4.2 instruction" >&5
@@ -26763,6 +27219,7 @@ fi
 
 
 
+
 # Make sure we have perl
 if test -z "$PERL"; then
 # Extract the first word of "perl", so it can be a program name with args.
@@ -26830,12 +27287,56 @@ $as_echo "ok" >&6; };
     :
     { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: No Pod::POM::View::Restructured, won't be able to regenerate docs" >&5
 $as_echo "$as_me: WARNING: No Pod::POM::View::Restructured, won't be able to regenerate docs" >&2;}
+                       have_ppvr=no
+
   fi
 else
   { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: could not find perl" >&5
 $as_echo "$as_me: WARNING: could not find perl" >&2;}
 fi
- if  test -n "$SPHINX_BUILD" -a x"$have_ppvr" = xyes; then
+
+
+    if test -z $PYTHON;
+    then
+        if test -z "python2";
+        then
+            PYTHON="python3"
+        else
+            PYTHON="python2"
+        fi
+    fi
+    PYTHON_NAME=`basename $PYTHON`
+    { $as_echo "$as_me:${as_lineno-$LINENO}: checking $PYTHON_NAME module: git" >&5
+$as_echo_n "checking $PYTHON_NAME module: git... " >&6; }
+    $PYTHON -c "import git" 2>/dev/null
+    if test $? -eq 0;
+    then
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+        eval HAVE_PYMOD_GIT=yes
+    else
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+        eval HAVE_PYMOD_GIT=no
+        #
+        if test -n ""
+        then
+            as_fn_error $? "failed to find required module git" "$LINENO" 5
+            exit 1
+        fi
+    fi
+
+case $HAVE_PYMOD_GIT in #(
+  yes) :
+     ;; #(
+  *) :
+    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: GitPython not found, won't be able to regenerate docs" >&5
+$as_echo "$as_me: WARNING: GitPython not found, won't be able to regenerate docs" >&2;} ;; #(
+  *) :
+     ;;
+esac
+
+ if  test -n "$SPHINX_BUILD" -a x"$have_ppvr" = xyes -a x"$HAVE_PYMOD_GIT" = xyes; then
   HAVE_SPHINX_BUILD_TRUE=
   HAVE_SPHINX_BUILD_FALSE='#'
 else
@@ -26848,6 +27349,11 @@ fi
 
 
 
+if test "X$enable_shared" = "Xno"
+then
+        LIBS="$LIBS -lstdc++";
+fi
+
 ac_config_files="$ac_config_files libcyrus_imap.pc libcyrus_min.pc libcyrus.pc libcyrus_sieve.pc Makefile"
 
 
@@ -26872,100 +27378,6 @@ ac_config_commands="$ac_config_commands
 
 fi
 
-
-pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICU" >&5
-$as_echo_n "checking for ICU... " >&6; }
-
-if test -n "$ICU_CFLAGS"; then
-    pkg_cv_ICU_CFLAGS="$ICU_CFLAGS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-uc\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "icu-uc") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_ICU_CFLAGS=`$PKG_CONFIG --cflags "icu-uc" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-if test -n "$ICU_LIBS"; then
-    pkg_cv_ICU_LIBS="$ICU_LIBS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"icu-uc\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "icu-uc") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_ICU_LIBS=`$PKG_CONFIG --libs "icu-uc" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-
-
-
-if test $pkg_failed = yes; then
-   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-
-if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
-        _pkg_short_errors_supported=yes
-else
-        _pkg_short_errors_supported=no
-fi
-        if test $_pkg_short_errors_supported = yes; then
-	        ICU_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "icu-uc" 2>&1`
-        else
-	        ICU_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "icu-uc" 2>&1`
-        fi
-	# Put the nasty error message in config.log where it belongs
-	echo "$ICU_PKG_ERRORS" >&5
-
-	as_fn_error $? "Package requirements (icu-uc) were not met:
-
-$ICU_PKG_ERRORS
-
-Consider adjusting the PKG_CONFIG_PATH environment variable if you
-installed software in a non-standard prefix.
-
-Alternatively, you may set the environment variables ICU_CFLAGS
-and ICU_LIBS to avoid the need to call pkg-config.
-See the pkg-config man page for more details." "$LINENO" 5
-elif test $pkg_failed = untried; then
-     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-	{ { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error $? "The pkg-config script could not be found or is too old.  Make sure it
-is in your PATH or set the PKG_CONFIG environment variable to the full
-path to pkg-config.
-
-Alternatively, you may set the environment variables ICU_CFLAGS
-and ICU_LIBS to avoid the need to call pkg-config.
-See the pkg-config man page for more details.
-
-To get pkg-config, see <http://pkg-config.freedesktop.org/>.
-See \`config.log' for more details" "$LINENO" 5; }
-else
-	ICU_CFLAGS=$pkg_cv_ICU_CFLAGS
-	ICU_LIBS=$pkg_cv_ICU_LIBS
-        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-$as_echo "yes" >&6; }
-
-fi
-
-
-
 cat >confcache <<\_ACEOF
 # This file is a shell script that caches the results of configure
 # tests run on this system so they can be shared between configure
@@ -27124,10 +27536,6 @@ if test -z "${USE_CYRUSDB_SQL_TRUE}" &&
   as_fn_error $? "conditional \"USE_CYRUSDB_SQL\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
-if test -z "${USE_CYRUSDB_LMDB_TRUE}" && test -z "${USE_CYRUSDB_LMDB_FALSE}"; then
-  as_fn_error $? "conditional \"USE_CYRUSDB_LMDB\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
 if test -z "${OBJECTSTORE_TRUE}" && test -z "${OBJECTSTORE_FALSE}"; then
   as_fn_error $? "conditional \"OBJECTSTORE\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27148,10 +27556,6 @@ if test -z "${USE_SQUAT_TRUE}" && test -
   as_fn_error $? "conditional \"USE_SQUAT\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
-if test -z "${USE_SPHINX_TRUE}" && test -z "${USE_SPHINX_FALSE}"; then
-  as_fn_error $? "conditional \"USE_SPHINX\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
 if test -z "${USE_XAPIAN_TRUE}" && test -z "${USE_XAPIAN_FALSE}"; then
   as_fn_error $? "conditional \"USE_XAPIAN\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27164,6 +27568,10 @@ if test -z "${SIEVE_TRUE}" && test -z "$
   as_fn_error $? "conditional \"SIEVE\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
+if test -z "${USE_SRS_TRUE}" && test -z "${USE_SRS_FALSE}"; then
+  as_fn_error $? "conditional \"USE_SRS\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
 if test -z "${NONBLOCK_FCNTL_TRUE}" && test -z "${NONBLOCK_FCNTL_FALSE}"; then
   as_fn_error $? "conditional \"NONBLOCK_FCNTL\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27208,6 +27616,22 @@ if test -z "${ZEPHYR_TRUE}" && test -z "
   as_fn_error $? "conditional \"ZEPHYR\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
+if test -z "${USE_JANSSON_TRUE}" && test -z "${USE_JANSSON_FALSE}"; then
+  as_fn_error $? "conditional \"USE_JANSSON\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${USE_ZEROSKIP_TRUE}" && test -z "${USE_ZEROSKIP_FALSE}"; then
+  as_fn_error $? "conditional \"USE_ZEROSKIP\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${USE_LIBCHARDET_TRUE}" && test -z "${USE_LIBCHARDET_FALSE}"; then
+  as_fn_error $? "conditional \"USE_LIBCHARDET\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAVE_CLD2_TRUE}" && test -z "${HAVE_CLD2_FALSE}"; then
+  as_fn_error $? "conditional \"HAVE_CLD2\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
 if test -z "${AUTOCREATE_TRUE}" && test -z "${AUTOCREATE_FALSE}"; then
   as_fn_error $? "conditional \"AUTOCREATE\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27232,6 +27656,10 @@ if test -z "${CALALARMD_TRUE}" && test -
   as_fn_error $? "conditional \"CALALARMD\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
+if test -z "${JMAP_TRUE}" && test -z "${JMAP_FALSE}"; then
+  as_fn_error $? "conditional \"JMAP\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
 if test -z "${REPLICATION_TRUE}" && test -z "${REPLICATION_FALSE}"; then
   as_fn_error $? "conditional \"REPLICATION\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27256,6 +27684,10 @@ if test -z "${CUNIT_TRUE}" && test -z "$
   as_fn_error $? "conditional \"CUNIT\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
+if test -z "${BENCH_TRUE}" && test -z "${BENCH_FALSE}"; then
+  as_fn_error $? "conditional \"BENCH\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
 if test -z "${USE_SQLITE_TRUE}" && test -z "${USE_SQLITE_FALSE}"; then
   as_fn_error $? "conditional \"USE_SQLITE\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -27661,7 +28093,7 @@ cat >>$CONFIG_STATUS <<\_ACEOF || ac_wri
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by cyrus-imapd $as_me 3.0.13, which was
+This file was extended by cyrus-imapd $as_me 3.2.0, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -27732,7 +28164,7 @@ _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
 ac_cs_version="\\
-cyrus-imapd config.status 3.0.13
+cyrus-imapd config.status 3.2.0
 configured by $0, generated by GNU Autoconf 2.69,
   with options \\"\$ac_cs_config\\"
 
@@ -29800,7 +30232,6 @@ fi
 echo "
 Cyrus Server configured components
 
-   event notification: $enable_event_notification
    gssapi:             $gssapi
    autocreate:         $enable_autocreate
    idled:              $enable_idled
@@ -29810,7 +30241,9 @@ Cyrus Server configured components
    nntpd:              $enable_nntp
    replication:        $enable_replication
    sieve:              $enable_sieve
+   srs:                $enable_srs
    calalarmd:          $enable_calalarmd
+   jmap:               $enable_jmap
    objectstore:        $enable_objectstore
    backup:             $enable_backup
    com_err:            $with_com_err
@@ -29819,35 +30252,54 @@ External dependencies:
    ldap:               $have_ldap
    openssl:            $with_ssl
    zlib:               $with_zlib
+   jansson:            $with_jansson
    pcre:               $cyrus_cv_pcre_utf8
    clamav:             $with_clamav
+   snmp:               $with_snmp
    -----------------------
    caringo:            $with_caringo
    openio:             $with_openio
    -----------------------
    nghttp2:            $with_nghttp2
+   wslay:              $with_wslay
    brotli:             $with_brotli
+   zstd:               $with_zstd
    xml2:               $with_xml2
    ical:               $with_ical
    icu4c:              $with_icu4c
    shapelib:           $with_shapelib
+   chardet:            $with_chardet
+   cld2:               $with_cld2
 
 Database support:
    mysql:              $with_mysql
    postgresql:         $use_pgsql
    sqlite:             $use_sqlite
-   lmdb:               $use_lmdb
+   zeroskip:           $with_zeroskip
 
 Search engine:
    squat:              $enable_squat
-   sphinx:             $enable_sphinx
    xapian:             $enable_xapian
-   xapian_flavor:      $xapian_flavor
+   xapian_cjk_tokens:  $xapian_cjk_tokens
 
 Hardware support:
    SSE4.2:             $cyrus_cv_sse42
 
+Documentation dependencies:
+   sphinx-build:       $SPHINX_BUILD
+   Pod::POM::View::Restructured:  $have_ppvr
+   GitPython:          $HAVE_PYMOD_GIT
+
 Installation directories:
    prefix:             $prefix
    sysconfdir:         $sysconfdir
+
+Build info:
+   shared:             $enable_shared
+   static:             $enable_static
+   cflags:             $CFLAGS
+   cxxflags:           $CXXFLAGS
+   libs:               $LIBS
+   ldflags:            $LDFLAGS
+   unit tests (cunit): $enable_unit_tests
 "
diff -pruN 3.0.13-5/configure.ac 3.2.0-3/configure.ac
--- 3.0.13-5/configure.ac	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/configure.ac	2020-04-24 02:03:00.000000000 +0000
@@ -55,6 +55,13 @@ AC_CONFIG_HEADERS(config.h)
 AC_CONFIG_MACRO_DIR([cmulocal])
 AC_CANONICAL_SYSTEM
 
+dnl shared or static
+ENABLE_SHARED="$enable_shared"
+AC_SUBST(ENABLE_SHARED)
+
+ENABLE_STATIC="$enable_static"
+AC_SUBST(ENABLE_STATIC)
+
 dnl carve the version string (defined in AC_INIT above) into useful chunks
 dnl e.g. for version 3.0.0-beta:
 dnl   CYRUS_IMAPD_SERIES   => 3.0
@@ -186,6 +193,18 @@ dnl check whether to use getpassphrase o
 AC_CHECK_HEADERS(stdlib.h)
 AC_CHECK_FUNCS(getpassphrase)
 
+
+# backwards compat with older pkg-config
+m4_ifndef([PKG_CHECK_VAR], [
+AC_DEFUN([PKG_CHECK_VAR],
+        [AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
+        AC_ARG_VAR([$1], [value of $3 for $2, overriding pkg-config])dnl
+        _PKG_CONFIG([$1], [variable="][$3]["], [$2])
+        AS_VAR_COPY([$1], [pkg_cv_][$1])
+        AS_VAR_IF([$1], [""], [$5], [$4])dnl
+        ])
+        ])
+
 dnl do this before Berkeley DB/IPv6 detection
 CMU_SOCKETS
 LIBS="$LIBS ${LIB_SOCKET}"
@@ -389,21 +408,6 @@ fi
 AM_CONDITIONAL([USE_CYRUSDB_SQL], [test $HAVE_CYRUSDB_SQL = 1])
 dnl End SQL DB Detection
 
-dnl LMDB configuration
-AC_ARG_WITH(lmdb,
-        [AS_HELP_STRING([--with-lmdb], [use LMDB backend [no]])],
-        with_lmdb="$withval", with_lmdb="no")
-if test "$with_lmdb" = "yes"; then
-  AC_CHECK_LIB(lmdb,mdb_env_create,
-      use_lmdb="yes"
-      LMDB_LIB="-llmdb"
-      AC_DEFINE([HAVE_LMDB],[],[Build in cyrusdb_lmdb support?]),
-      AC_MSG_ERROR([The LMDB library is required for Cyrus DB LMDB support.]))
-else
-    use_lmdb="no"
-fi
-AM_CONDITIONAL([USE_CYRUSDB_LMDB], [test "x$use_lmdb" = "xyes"])
-
 dnl
 dnl Object Store support
 dnl
@@ -530,29 +534,10 @@ fi
 AM_CONDITIONAL([USE_SQUAT], [test "${enable_squat}" != "no"])
 
 dnl
-dnl Search engines - Sphinx
-dnl
-
-AC_ARG_ENABLE(sphinx,
-        [AS_HELP_STRING([--enable-sphinx], [enable Sphinx support])],,
-        [enable_sphinx=no])
-if test "x$enable_sphinx" != xno ; then
-    AC_DEFINE(USE_SPHINX,[],[Build in Sphinx support?])
-fi
-AM_CONDITIONAL([USE_SPHINX], [test "${enable_sphinx}" != "no"])
-
-dnl Note that Sphinx' searchd uses the MySQL protocol
-dnl so we need to link with the MySQL client libraries.
-if test "$enable_sphinx" = yes -a "$with_mysql" = no ; then
-    AC_MSG_ERROR([Sphinx requires MySQL but you have not used --with-mysql; disabling Sphinx])
-    enable_sphinx=no
-fi
-
-dnl
 dnl Search engines - Xapian
 dnl
 
-xapian_flavor=none
+xapian_cjk_tokens=none
 AC_ARG_ENABLE(xapian,
         [AS_HELP_STRING([--enable-xapian], [enable Xapian support])],,
         [enable_xapian=no])
@@ -595,6 +580,7 @@ if test "x$enable_xapian" != xno ; then
         dnl hooks to the end of AC_PROG_LIBTOOL and AM_PROG_LIBTOOL to enable it
         dnl if either is expanded later.
         XAPIAN_VERSION="`$XAPIAN_CONFIG --version|sed 's/.* //'`"
+        AS_VERSION_COMPARE([$XAPIAN_VERSION], [1.4], AC_MSG_ERROR([need at least Xapian 1.4]), [], [])
         XAPIAN_CXXFLAGS="`$XAPIAN_CONFIG --cxxflags`"
         AC_PROVIDE_IFELSE([AC_PROG_LIBTOOL],
             [XAPIAN_LIBS="`$XAPIAN_CONFIG --ltlibs`"],
@@ -618,20 +604,20 @@ if test "x$enable_xapian" != xno ; then
         ORIG_CXXFLAGS=$CXXFLAGS
         LDFLAGS="$LDFLAGS $XAPIAN_LIBS"
         CXXFLAGS="$CXXFLAGS $XAPIAN_CXXFLAGS"
-        AC_MSG_CHECKING([for Xapian cyruslibs extensions])
+        AC_MSG_CHECKING([for Xapian cjk word tokenization])
         AC_LINK_IFELSE(
             [AC_LANG_PROGRAM(
                 [[#include <xapian.h>]],
-                [[unsigned cjk_flags = Xapian::TermGenerator::FLAG_CJK_WORDS | Xapian::QueryParser::FLAG_CJK_WORDS; unsigned snippet_flags = Xapian::MSet::SNIPPET_START_AT_NONSPACE; (void) cjk_flags; (void) snippet_flags]])],
-            [xapian_cyrusexts="yes"],
-            [xapian_cyrusexts="no"])
-        AC_MSG_RESULT($xapian_cyrusexts)
-        if test $xapian_cyrusexts = yes; then
-            AC_DEFINE([USE_XAPIAN_CYRUS_EXTENSIONS], [], [Use Xapian cyruslibs extensions?])
-            xapian_flavor=cyruslibs
+                [[unsigned cjk_flags = Xapian::TermGenerator::FLAG_CJK_WORDS | Xapian::QueryParser::FLAG_CJK_WORDS | Xapian::MSet::SNIPPET_CJK_WORDS; (void) cjk_flags; ]])],
+            [xapian_cjkwords="yes"],
+            [xapian_cjkwords="no"])
+        AC_MSG_RESULT($xapian_cjkwords)
+        if test $xapian_cjkwords = yes; then
+            AC_DEFINE([USE_XAPIAN_CJK_WORDS], [], [Use Xapian CJK word tokenizer, rather than n-grams?])
+            xapian_cjk_tokens=words
         else
-            AC_MSG_NOTICE([Your Xapian does not support the Cyrus extensions for Xapian. Consider installing cyruslibs Xapian])
-            xapian_flavor=vanilla
+            AC_MSG_NOTICE([Your Xapian does not support CJK word tokenization. Consider installing a recent Xapian >= 1.4.11])
+            xapian_cjk_tokens=ngrams
         fi
         LDFLAGS=$ORIG_LDFLAGS
         CXXFLAGS=$ORIG_CXXFLAGS
@@ -642,16 +628,16 @@ if test "x$enable_xapian" != xno ; then
     AC_SUBST(XAPIAN_VERSION)
 fi
 AM_CONDITIONAL([USE_XAPIAN], [test "${enable_xapian}" != "no"])
-AC_DEFINE_UNQUOTED([XAPIAN_FLAVOR], ["$xapian_flavor"], [Which Xapian are we running on?])
+AC_DEFINE_UNQUOTED([XAPIAN_CJK_TOKENS], ["$xapian_cjk_tokens"], [Which Xapian CJK tokenzation are we using?])
 
 
 AM_CONDITIONAL([SQUATTER],
-    [test "${enable_squat}" != "no" -o "${enable_sphinx}" != "no" -o "${enable_xapian}" != "no" ])
+    [test "${enable_squat}" != "no" -o "${enable_xapian}" != "no" ])
 
 AC_ARG_ENABLE(sieve,
         [AS_HELP_STRING([--disable-sieve], [disable Sieve support])],,[enable_sieve="yes";])
 AC_ARG_ENABLE(pcre,
-        [AS_HELP_STRING([--disable-pcre], [disable PCRE library])],[cyrus_cv_pcre_utf8="no"])
+        [AS_HELP_STRING([--disable-pcre], [disable PCRE library])],[cyrus_cv_pcre_utf8="$enableval"])
 
 if test "$enable_sieve" != "no"; then
         AC_DEFINE(USE_SIEVE,[],[Build in Sieve support?])
@@ -700,6 +686,22 @@ else
         fi
 fi
 
+dnl
+dnl see if we're compiling with SRS
+dnl
+AC_MSG_CHECKING([whether to use SRS])
+AC_ARG_ENABLE(srs,
+    [AS_HELP_STRING([--enable-srs], [enable SRS support])],,
+    [enable_srs=no])
+if test "x$enable_srs" != xno; then
+    AC_CHECK_HEADER([srs2.h],,
+        [AC_MSG_ERROR([cannot find SRS headers])])
+    AC_CHECK_LIB(srs2, srs_forward,,
+        [AC_MSG_ERROR([cannot find SRS lib])])
+    LIBS="$LIBS -lsrs2"
+fi
+AM_CONDITIONAL([USE_SRS], [test "${enable_srs}" != "no"])
+
 dnl look for an option to disable sign-comparison warnings (needed for
 dnl flex-generated sieve sources when building with -Werror)
 saved_CFLAGS="$CFLAGS"
@@ -1100,6 +1102,27 @@ AC_ARG_ENABLE(statickrb,
         [AS_HELP_STRING([--enable-statickrb], [link Kerberos statically])],
         with_statickrb="yes", with_statickrb="no")
 
+AC_ARG_WITH(krb5-config,
+        [AS_HELP_STRING([--with-krb5-config=PATH], [use krb5-config from PATH])],
+        with_krb5config="$withval", with_krb5config="no")
+
+if test "$with_krb5config" != "no"; then
+    AC_MSG_CHECKING([$with_krb5config works])
+
+    dnl run with exec to avoid leaking output on "real" bourne shells
+    if (exec >&5 2>&5 ; $with_krb5config --libs --cflags; exit $?) then
+        AC_MSG_RESULT(yes)
+    else
+        AC_MSG_ERROR([\`$with_krb5config --libs --cflags' doesn't work, aborting])
+    fi
+
+    KRB5_CFLAGS="`$with_krb5config --cflags`"
+    KRB5_LDFLAGS="`$with_krb5config --libs`"
+
+    LDFLAGS="$KRB5_LDFLAGS $LDFLAGS"
+    CFLAGS="$KRB5_CFLAGS $CFLAGS"
+fi
+
 dnl In order to compile kerberos4, we need libkrb and libdes.
 
 dnl we might need -lresolv for kerberos
@@ -1112,8 +1135,7 @@ fi
 if test "$with_krb" != "no"; then
 dnl Do we need DES for kerberos?
 AC_ARG_WITH(krbdes,
-        [AS_HELP_STRING([--with-krbdes], [use Kerberos DES implementation [yes]])],
-        with_krbdes="$withval", with_krbdes="yes")
+        [AS_HELP_STRING([--without-krbdes], [disable Kerberos DES implementation])],, with_krbdes="yes")
 if test "$with_krbdes" = "yes"; then
   AC_CHECK_LIB(des,des_ecb_encrypt,
       if test "$with_statickrb" = "yes"; then
@@ -1267,6 +1289,9 @@ if test "$with_ssl" != "no"; then
        AC_DEFINE(OPENSSL_ENABLE_OLD_DES_SUPPORT,[],[Configure OpenSSL to provide legacy des apis])
        AC_DEFINE(OPENSSL_DES_LIBDES_COMPATIBILITY,[],[Configure OpenSSL to provide krb4-compatible legacy des apis])
     fi
+
+    AC_CHECK_LIB(ssl, SSL_CTX_set_alpn_select_cb,
+       AC_DEFINE(HAVE_TLS_ALPN,[], [Do we have support for TLS ALPN extension?]))
 fi
 AM_CONDITIONAL([HAVE_SSL], [test "$with_ssl" != "no"])
 AC_SUBST(SSL_CPPFLAGS)
@@ -1359,6 +1384,7 @@ AC_ARG_WITH([libcap],
         with_libcap="${withval}")
 
 have_libcap=no
+LIBCAP_LIBS=""
 case $host_os in
 linux*)
         if test "x$with_libcap" = "xyes"; then
@@ -1366,13 +1392,14 @@ linux*)
                 AC_CHECK_HEADERS([sys/capability.h sys/prctl.h], , have_libcap=no)
                 if test "$have_libcap" = "yes"; then
                         AC_DEFINE(HAVE_LIBCAP, [], [Do we have libcap system capabilities handling (Linux systems only)?])
-                        LIBS="$LIBS -lcap"
+                        LIBCAP_LIBS="-lcap"
                 fi
         fi
         ;;
 *)
         ;;
 esac
+AC_SUBST(LIBCAP_LIBS)
 
 AC_MSG_CHECKING(for libcap)
 AC_MSG_RESULT($have_libcap)
@@ -1380,22 +1407,85 @@ AC_MSG_RESULT($have_libcap)
 dnl
 dnl Check for jansson library, needed for JSON support
 dnl
-PKG_CHECK_MODULES([JANSSON], [jansson >= 2.3])
+PKG_CHECK_MODULES([JANSSON], [jansson >= 2.3],
+                  [ AC_DEFINE(HAVE_JANSSON, [], [Do we have Jansson?])
+                    with_jansson=yes ],
+                  AC_MSG_ERROR([libjansson is required]))
 dnl call AC_SUBST macro to support pkg-config version older than 0.24
 AC_SUBST([JANSSON_LIBS])
 AC_SUBST([JANSSON_CFLAGS])
+AM_CONDITIONAL([USE_JANSSON], [test "x$with_jansson" = xyes])
+
+save_CFLAGS="$CFLAGS"
+CFLAGS="$CFLAGS $JANSSON_CFLAGS $JANSSON_LIBS"
+AC_CHECK_LIB([jansson], [json_dumpb],
+             [],
+             [ AC_DEFINE(NEED_JANSSON_JSON_DUMPB, [1],
+                         [Do we need to provide our own json_dumpb()?])
+               AC_MSG_NOTICE([jansson does not provide json_dumpb(), using ours instead])
+             ])
+CFLAGS="$save_CFLAGS"
 
 dnl
-dnl Test for mailbox event notification
-dnl enable requires the installation of jansson library
+dnl Check for ICU library, needed for charset conversions and non-gregorian
+dnl rscale conversions
 dnl
-AC_ARG_ENABLE(event-notification,
-        [AS_HELP_STRING([--disable-event-notification], [disable compiling of mailbox event notification (that needs jansson library)])],,
-        [enable_event_notification="yes";])
+with_icu4c=no
+PKG_CHECK_MODULES([ICU], [icu-i18n icu-uc], [
+                    AC_DEFINE(HAVE_ICU, [], [Build with ICU support])
+                    with_icu4c=yes
+                  ],
+                  [AC_MSG_ERROR([Need ICU4C])])
+AC_SUBST([ICU_LIBS])
+AC_SUBST([ICU_CFLAGS])
 
-if test "$enable_event_notification" != "no"; then
-    AC_DEFINE(ENABLE_MBOXEVENT,[],[Build with support of mailbox event notification])
-fi
+dnl
+dnl Check for zeroskip library, needed for zeroskip support
+dnl
+AC_ARG_WITH([zeroskip],
+	[AS_HELP_STRING([--without-zeroskip], [ignore presence of Zeroskip and disable it])],
+    [],
+    [with_zeroskip=yes])
+AS_IF([test "x$with_zeroskip" = "xyes"],
+	[ PKG_CHECK_MODULES([ZEROSKIP], [libzeroskip],
+		[ AC_DEFINE(HAVE_ZEROSKIP, [], [Do we have Zeroskip?])
+		  with_zeroskip=yes ],
+		with_zeroskip=no)])
+AC_SUBST([ZEROSKIP_LIBS])
+AC_SUBST([ZEROSKIP_CFLAGS])
+AM_CONDITIONAL([USE_ZEROSKIP], [test "x$with_zeroskip" = xyes])
+
+dnl
+dnl Check for chardet library, needed for charset detection support
+dnl
+AC_ARG_WITH([chardet],
+	[AS_HELP_STRING([--without-chardet], [ignore presence of chardet library and disable it])],
+    [],
+    [with_chardet=yes])
+AS_IF([test "x$with_chardet" = "xyes"],
+	[ PKG_CHECK_MODULES([LIBCHARDET], [chardet],
+		[ AC_DEFINE(HAVE_LIBCHARDET, [], [Build with chardet library support])
+		  with_chardet=yes ],
+		with_chardet=no)])
+AC_SUBST([LIBCHARDET_LIBS])
+AC_SUBST([LIBCHARDET_CFLAGS])
+AM_CONDITIONAL([USE_LIBCHARDET], [test "x$with_chardet" = xyes])
+
+dnl
+dnl Check for cld2 library
+dnl
+AC_ARG_WITH([cld2],
+	[AS_HELP_STRING([--without-cld2], [ignore presence of cld2 library and disable it])],
+    [],
+    [with_cld2=yes])
+AS_IF([test "x$with_cld2" = "xyes"],
+	[ PKG_CHECK_MODULES([CLD2], [cld2],
+		[ AC_DEFINE(HAVE_CLD2, [], [Build with cld2 library support])
+		  with_cld2=yes ],
+          with_cld2=no)])
+AC_SUBST([CLD2_LIBS])
+AC_SUBST([CLD2_CFLAGS])
+AM_CONDITIONAL([HAVE_CLD2], [test "x$with_cld2" = xyes])
 
 dnl
 dnl Set pidfile location
@@ -1460,9 +1550,9 @@ HTTP_CPPFLAGS=
 HTTP_LIBS=
 with_xml2=no
 with_ical=no
-with_icu4c=no
 with_shapelib=no
 with_brotli=no
+with_zstd=no
 if test "$enable_http" != no; then
 dnl
 dnl make sure all the modules we need are present
@@ -1475,6 +1565,7 @@ dnl
         fi
 
         PKG_CHECK_MODULES([XML2], [libxml-2.0], [
+                AC_DEFINE(HAVE_XML2, [], [Build with libxml support])
                 LIBS="$LIBS ${XML2_LIBS}"
                 with_xml2=yes
                 ],
@@ -1489,76 +1580,27 @@ dnl
                                 [Do we have support for xmlBufferDetach()?]))
                 ])
 
-        PKG_CHECK_MODULES([ICAL], [libical], [
+        PKG_CHECK_MODULES([ICAL], [libical >= 3.0.0], [
                 AC_DEFINE(HAVE_ICAL,[],[Build CalDAV support into httpd?])
                 LIBS="$LIBS ${ICAL_LIBS}"
                 with_ical=yes
                 ],
-                AC_MSG_ERROR([Need libical for http]))
-
-        AC_CHECK_DECLS([icalproperty_get_parent,
-                        icalrecur_freq_to_string, icalrecur_weekday_to_string],
-                [], [], [[#include <libical/ical.h>]])
-
-        AC_CHECK_MEMBER(icaltimetype.is_utc,
-                AC_DEFINE(ICALTIME_HAS_IS_UTC,[],
-                        [Does icaltimetype have is_utc field?]),
-                        [], [#include <libical/ical.h>])
-
-        AC_CHECK_LIB(ical, icalproperty_new_acknowledged,
-                AC_DEFINE(HAVE_VALARM_EXT_PROPS,[],
-                        [Do we have built-in support for VALARM extensions props?]))
-
-        AC_CHECK_LIB(ical, icalparameter_new_iana, [
-                AC_DEFINE(HAVE_IANA_PARAMS,[],
-                        [Do we have support for IANA params?])
-
-                AC_CHECK_LIB(ical, icalparameter_new_schedulestatus,
-                        AC_DEFINE(HAVE_SCHEDULING_PARAMS,[],
-                                [Do we have built-in support for scheduling params?]))
-
-                AC_CHECK_LIB(ical, icalparameter_new_managedid,
-                        AC_DEFINE(HAVE_MANAGED_ATTACH_PARAMS,[],
-                                [Do we have built-in support for managed attachment params?]))
-
-                AC_CHECK_LIB(ical, icalproperty_new_tzuntil,
-                        AC_DEFINE(HAVE_TZDIST_PROPS,[],
-                                [Do we have built-in support for TZdist props?]))
-                ],
-                AC_MSG_NOTICE([Your version of libical can not support scheduling or managed attachments.  Consider upgrading to libical >= 0.48]))
-
-        AC_CHECK_LIB(ical, icaltimezone_set_builtin_tzdata,
-                AC_DEFINE(HAVE_TZ_BY_REF,[],
-                        [Build timezones by reference support into httpd?]),
-                AC_MSG_NOTICE([Your version of libical can not support timezones by reference.  Consider upgrading to libical >= 1.0.1]))
-
-        AC_CHECK_LIB(ical, icalcomponent_new_vavailability,
-                AC_DEFINE(HAVE_VAVAILABILITY,[],
-                        [Build VAVAILABILITY support into httpd?]),
-                AC_MSG_NOTICE([Your version of libical can not support availability.  Consider upgrading to libical >= 1.0.1]))
-
-        AC_CHECK_LIB(ical, icalcomponent_new_vvoter,
-                AC_DEFINE(HAVE_VPOLL,[], [Build VPOLL support into httpd?]),
-                AC_MSG_NOTICE([Your version of libical can not support consensus scheduling.  Consider upgrading to libical >= 2.0]))
-
-        AC_CHECK_LIB(ical, icalrecurrencetype_rscale_is_supported, [
-                PKG_CHECK_MODULES([ICU4C], [icu-i18n], [
-                        AC_DEFINE(HAVE_RSCALE,[], [Build RSCALE support into httpd?])
-                        LIBS="$LIBS ${ICU4C_LIBS}"
-                        with_icu4c=yes
-                        ],
-                        AC_MSG_ERROR([Need ICU4C for RSCALE support in httpd]))
-                ],
-                AC_MSG_NOTICE([Your version of libical can not support non-gregorian recurrences.  Consider upgrading to libical >= 2.0]))
+                AC_MSG_ERROR([Need libical 3.0.0 for http]))
 
-        AC_CHECK_LIB(ical, icalcomponent_new_vpatch,
-                AC_DEFINE(HAVE_VPATCH,[],
-                        [Build VPATCH support into httpd?]),
-                AC_MSG_NOTICE([Your version of libical can not support patching iCalendar objects.  Consider upgrading to libical >= 2.1]))
-
-        AC_CHECK_LIB(ical, icalrecur_iterator_set_start,
-                AC_DEFINE(HAVE_RECUR_ITERATOR_START,[],
-                        [Do we have support for setting start point of recurrences?]))
+        dnl icalproperty_new_color was overlooked, and eventually added in 3.0.5
+        AC_CHECK_LIB(ical, icalproperty_new_color,
+                AC_DEFINE(HAVE_RFC7986_COLOR,[],
+                        [Do we have built-in support for RFC7986 color prop?]))
+
+        dnl libical may have been built without RSCALE support
+        AC_CHECK_LIB(ical, icalrecurrencetype_rscale_is_supported,
+                [AC_DEFINE(HAVE_RSCALE,[], [Build RSCALE support into httpd?])],
+                [AC_MSG_NOTICE([Your version of libical can not support non-gregorian recurrences])])
+
+        dnl icalcomponent_clone will be new in libical 3.1.0
+        AC_CHECK_LIB(ical, icalcomponent_clone,
+                AC_DEFINE(HAVE_NEW_CLONE_API,[],
+                        [Do we have support for new clone API?]))
 
 dnl  Don't bother checking for DKIM until iSchedule gains traction
 dnl        PKG_CHECK_MODULES([DKIM], [opendkim >= 2.7.0],
@@ -1567,21 +1609,41 @@ dnl                        AC_DEFINE(WIT
 dnl                                [Build DKIM support into iSchedule?]),
 dnl                        AC_MSG_WARN([Your version of OpenDKIM can not support iSchedule.  Consider patching OpenDKIM with contrib/dkim_canon_ischedule.patch])),
 dnl                AC_MSG_WARN([Your version of OpenDKIM can not support iSchedule.  Consider upgrading to OpenDKIM >= 2.7.0]))
+
         AC_ARG_WITH(nghttp2, [AS_HELP_STRING([--without-nghttp2], [disable HTTP/2 support (check)])],,[with_nghttp2="check"])
         if test "x$with_nghttp2" = "xyes" -o "x$with_nghttp2" = "xcheck"; then
                 PKG_CHECK_MODULES([NGHTTP2], [libnghttp2 >= 1.5], [
-                    with_nghttp2=yes
-                    AC_DEFINE(HAVE_NGHTTP2,[],
-                            [Build HTTP/2 support into httpd?])
+                        AC_DEFINE(HAVE_NGHTTP2,[],
+                                [Build HTTP/2 support into httpd?])
+                        AC_CHECK_DECLS([NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL],
+                                [], [], [[#include <nghttp2/nghttp2.h>]])
+                        with_nghttp2=yes
+                ], [
+                        if test "x$with_nghttp2" = "xyes"; then
+                                AC_MSG_ERROR([HTTP/2 explicitly requested, but libnghttp2 was not found])
+                        fi
+                        AC_MSG_NOTICE([httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5])
+                        with_nghttp2=no
+                ])
+        fi
+
+
+        AC_ARG_WITH(wslay, [AS_HELP_STRING([--without-wslay], [disable WebSockets support (check)])],,[with_wslay="check"])
+        if test "x$with_wslay" = "xyes" -o "x$with_wslay" = "xcheck"; then
+                PKG_CHECK_MODULES([WSLAY], [libwslay >= 1.1.1], [
+                        AC_DEFINE(HAVE_WSLAY,[],
+                                [Build WebSockets support into httpd?])
+                        with_wslay=yes
                 ], [
-                    if test "x$with_nghttp2" = "xyes"; then
-                        AC_MSG_ERROR([HTTP/2 explicitly requested, but libnghttp2 was not found])
-                    fi
-                    with_nghttp2=no
-                    AC_MSG_NOTICE([httpd will not have support for HTTP/2.  Consider installing libnghttp2 >= 1.5])
+                        if test "x$with_wslay" = "xyes"; then
+                                AC_MSG_ERROR([WebSockets explicitly requested, but libwslay was not found])
+                        fi
+                        AC_MSG_NOTICE([httpd will not have support for WebSockets.  Consider installing libwslay])
+                        with_wslay=no
                 ])
         fi
 
+
         PKG_CHECK_MODULES([BROTLI], [libbrotlienc], [
                 AC_DEFINE(HAVE_BROTLI,[],
                         [Build Brotli compression support into httpd?])
@@ -1589,6 +1651,14 @@ dnl                AC_MSG_WARN([Your ver
                 ],
                 AC_MSG_NOTICE([httpd will not have support for Brotli compression.  Consider installing libbrotli]))
 
+
+        PKG_CHECK_MODULES([ZSTD], [libzstd >= 1.4.0], [
+                AC_DEFINE(HAVE_ZSTD,[],
+                        [Build Zstandard compression support into httpd?])
+                with_zstd=yes
+                ],
+                AC_MSG_NOTICE([httpd will not have support for Zstandard compression.  Consider installing libzstd]))
+
         dnl httpd needs libmath in a few places
         dnl XXX really should check for this properly but AC_SEARCH_LIBS/AC_CHECK_LIB
         dnl XXX break under -Werror(!)
@@ -1602,8 +1672,8 @@ dnl                AC_MSG_WARN([Your ver
                 ],
                 AC_MSG_NOTICE([tzdist will not have geolocation support.  Consider installing shapelib]))
 
-        HTTP_CPPFLAGS="${XML2_CFLAGS} ${SQLITE3_CFLAGS} ${ICAL_CFLAGS} ${JANSSON_CFLAGS} ${NGHTTP2_CFLAGS} ${BROTLI_CFLAGS} ${SHAPELIB_CFLAGS}"
-        HTTP_LIBS="${XML2_LIBS} ${SQLITE3_LIBS} ${ICAL_LIBS} ${JANSSON_LIBS} ${NGHTTP2_LIBS} ${BROTLI_LIBS} ${SHAPELIB_LIBS} ${LIB_MATH}"
+        HTTP_CPPFLAGS="${XML2_CFLAGS} ${SQLITE3_CFLAGS} ${ICAL_CFLAGS} ${GLIB_CFLAGS} ${JANSSON_CFLAGS} ${NGHTTP2_CFLAGS} ${WSLAY_CFLAGS} ${BROTLI_CFLAGS} ${ZSTD_CFLAGS} ${SHAPELIB_CFLAGS}"
+        HTTP_LIBS="${XML2_LIBS} ${SQLITE3_LIBS} ${ICAL_LIBS} ${GLIB_LIBS} ${JANSSON_LIBS} ${NGHTTP2_LIBS} ${WSLAY_LIBS} ${BROTLI_LIBS} ${ZSTD_LIBS} ${SHAPELIB_LIBS} ${LIB_MATH}"
 fi
 AC_SUBST(HTTP_CPPFLAGS)
 AC_SUBST(HTTP_LIBS)
@@ -1626,6 +1696,22 @@ fi
 AM_CONDITIONAL([CALALARMD], [test "$enable_calalarmd" != "no"])
 
 dnl
+dnl see if we're compiling with JMAP support
+dnl
+AC_ARG_ENABLE(jmap,
+        [AS_HELP_STRING([--enable-jmap], [enable JMAP support])],, [enable_jmap="no";])
+if test "x$enable_jmap" = "xyes" ; then
+    if test "x$enable_xapian" = "xno" ; then
+        AC_MSG_ERROR([--enable-jmap requires --enable-xapian])
+    fi
+    if test "x$enable_http" = "xno" ; then
+        AC_MSG_ERROR([--enable-jmap requires --enable-http])
+    fi
+    AC_DEFINE(WITH_JMAP,[],[Build with JMAP support])
+fi
+AM_CONDITIONAL([JMAP], [test "${enable_jmap}" != "no"])
+
+dnl
 dnl see if we're compiling replication support programs
 dnl
 AC_ARG_ENABLE(replication,
@@ -1746,7 +1832,7 @@ case "$with_com_err" in
   # built-in et
   yes) # use the com_err we're gonna build
           COM_ERR_LIBS="com_err/et/libcyrus_com_err.la"
-          COM_ERR_CPPFLAGS="-I\${top_srcdir}/com_err/et"
+          COM_ERR_CPPFLAGS="-I\${abs_top_srcdir}/com_err/et"
           ;;
   "")   # no problem, we already have it in the paths
         # we do nothing to pick it up
@@ -1795,7 +1881,7 @@ AC_ARG_WITH(syslogfacility,
 AC_DEFINE_UNQUOTED(SYSLOG_FACILITY, $SYSLOG_FACILITY, [Syslog facility to use.])
 AC_MSG_RESULT($SYSLOG_FACILITY)
 
-dnl Have to check getdtabalesize after adding ossup, as some ossups define it
+dnl Have to check getdtablesize after adding ossup, as some ossups define it
 AC_REPLACE_FUNCS(getdtablesize)
 AC_ARG_ENABLE(cmulocal,
         [AS_HELP_STRING([--enable-cmulocal], [enable CMU-specific local support])])
@@ -1878,6 +1964,10 @@ fi
 
 CMU_LIBWRAP
 CMU_UCDSNMP
+AS_IF([test "x$with_snmp" != "xno"],
+      [ AC_MSG_WARN([SNMP support is deprecated and will be removed in the future.])
+        AC_MSG_WARN([Consider using Prometheus instead.])
+      ])
 
 # Figure out what directories we're linking against.
 # Lots of fun for the whole family.
@@ -1922,12 +2012,24 @@ AC_ARG_ENABLE(unit-tests,
 
 dnl Unit tests need the CUnit library, so check if we
 dnl have both the header and the library.
-if test "$enable_unit_tests" = "yes" ; then
+dnl
+dnl XXX cunit.pl is not compatible with vpath build, so auto-enabling
+dnl XXX unit tests breaks make distcheck.  Shutting it up for now by not
+dnl XXX auto-enabling them, because validating the rest of the distribution
+dnl XXX with distcheck is more important than having it automatically run
+dnl XXX the unit tests.  Once cunit.pl can handle vpath builds, make this
+dnl XXX automatic again!
+if test "x$enable_unit_tests" = xyes ; then
     AC_CHECK_LIB(cunit,CU_initialize_registry,found_lib=yes,found_lib=no)
     AC_CHECK_HEADER([CUnit/CUnit.h],found_hdr=yes,found_hdr=no)
     if test "$found_lib$found_hdr" != "yesyes" ; then
+        if test "x$enable_unit_tests" = xyes; then
+            AC_MSG_ERROR([Unit tests explicitly requested, but CUnit library is not installed])
+        fi
         AC_MSG_NOTICE([Disabling unit tests because the required CUnit library is not installed])
         enable_unit_tests=no
+    else
+        enable_unit_tests=yes
     fi
     AC_CHECK_HEADER([CUnit/Basic.h],
         AC_CHECK_TYPE([CU_SetUpFunc],AC_DEFINE(HAVE_CU_SETUPFUNC,[],[Do we have CU_SetUpFunc?]),,
@@ -1960,6 +2062,18 @@ fi
 
 AM_CONDITIONAL([CUNIT], [test "$enable_unit_tests" = "yes"])
 
+dnl
+dnl Enable/disable cyrusdb benchmarks.
+dnl
+AC_ARG_ENABLE(cyrusdb-benchmarks,
+        [AS_HELP_STRING([--enable-cyrusdb-benchmarks], [enable cyrdb benchmarks])])
+
+if test "$enable_cyrusbd_benchmarks" = "yes" ; then
+    USE_MAINTAINER_MODE=yes
+fi
+
+AM_CONDITIONAL([BENCH], [test "$enable_cyrusdb_benchmarks" = "yes"])
+
 dnl Finally, now that we've checked everything else, we can see whether to link
 dnl in SQLite or not.
 dnl
@@ -1979,6 +2093,53 @@ if test "x$use_sqlite" = xyes; then
 fi
 AM_CONDITIONAL([USE_SQLITE], [test "x$use_sqlite" = xyes])
 
+dnl compiler feature checking
+AC_MSG_CHECKING(for function nesting)
+AC_CACHE_VAL(cyrus_cv_function_nesting, AC_TRY_COMPILE([
+#include <stdlib.h>
+void func(void *data, size_t nmemb, size_t size,
+          int (*compar)(const void *, const void *, void *),
+          void *thunk)
+{
+    int compar_func(const void *a, const void *b)
+    {
+        return compar(a, b, thunk);
+    }
+    qsort(data, nmemb, size, compar_func);
+}
+int cval(const void *a, const void *b, void *prev)
+{
+  char **ref = (char **)prev;
+  char *ac = (char *)a;
+  char *bc = (char *)b;
+  if (*ac < *bc) return -1;
+  if (*ac == *bc) return 0;
+  *ref = bc;
+  return 1;
+}
+],[
+    char *dest;
+    func("abc", 3, 1, cval, &dest);
+],cyrus_cv_function_nesting=yes, cyrus_cv_function_nesting=no))
+AC_MSG_RESULT($cyrus_cv_function_nesting)
+if test "$cyrus_cv_function_nesting" = "yes"; then
+  AC_DEFINE(HAVE_FUNCTION_NESTING,[],[Do we have function nesting support?])
+fi
+
+AC_MSG_CHECKING(for optimisation support)
+AC_CACHE_VAL(cyrus_cv_declare_optimize, AC_TRY_COMPILE([
+#include <stdlib.h>
+static inline int numcmp(int n1, int n2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+static int numcmp(int n1, int n2) { return n1 - n2; }
+],[
+    if (numcmp(1, 2)) exit(1);
+],cyrus_cv_declare_optimize=yes, cyrus_cv_declare_optimize=no))
+AC_MSG_RESULT($cyrus_cv_declare_optimize)
+if test "$cyrus_cv_declare_optimize" = "yes"; then
+  AC_DEFINE(HAVE_DECLARE_OPTIMIZE,[],[Do we have support for optimize __attribute__?])
+fi
+
 
 dnl CRC32 optimisations
 
@@ -1999,7 +2160,7 @@ if test "$cyrus_cv_sse42" = "yes" ; then
 fi
 AC_MSG_RESULT($cyrus_cv_sse42)
 
-dnl documentation generation (sphinx, perl2rst)
+dnl documentation generation (sphinx, perl2rst, gitpython)
 AC_ARG_VAR(SPHINX_BUILD, [Location of sphinx-build])
 AC_ARG_WITH([sphinx-build],
             AS_HELP_STRING([--with-sphinx-build=(yes|no|PATH)], [Look for sphinx-build in PATH]),
@@ -2012,10 +2173,20 @@ AS_CASE([$with_sphinx_build],
 AS_IF([test -z "$SPHINX_BUILD"],
       [AC_MSG_WARN([No sphinx-build, won't be able to regenerate docs])])
 AC_SUBST([SPHINX_BUILD])
+
 AX_PROG_PERL_MODULES([Pod::POM::View::Restructured],
                      [have_ppvr=yes],
-                     [AC_MSG_WARN([No Pod::POM::View::Restructured, won't be able to regenerate docs])])
-AM_CONDITIONAL([HAVE_SPHINX_BUILD], [ test -n "$SPHINX_BUILD" -a x"$have_ppvr" = xyes])
+                     [AC_MSG_WARN([No Pod::POM::View::Restructured, won't be able to regenerate docs])
+                       have_ppvr=no
+                     ])
+
+AX_PYTHON_MODULE([git], [], [python2])
+AS_CASE([$HAVE_PYMOD_GIT],
+        [yes],  [],
+        [*],    [AC_MSG_WARN([GitPython not found, won't be able to regenerate docs])])
+
+AM_CONDITIONAL([HAVE_SPHINX_BUILD],
+    [ test -n "$SPHINX_BUILD" -a x"$have_ppvr" = xyes -a x"$HAVE_PYMOD_GIT" = xyes])
 
 AH_TOP([
 /*
@@ -2230,6 +2401,13 @@ enum {
 #endif /* _CYRUS_IMAPD_CONFIG_H_ */
 ])
 
+dnl We need to link with stdc++ when building static cyrus libs and binaries.
+dnl libstdc++ is required because we link with libxapian, which is written in C++.
+if test "X$enable_shared" = "Xno"
+then
+        LIBS="$LIBS -lstdc++";
+fi
+
 dnl make sure that Makefile is the last thing output
 AC_CONFIG_FILES([
     libcyrus_imap.pc
@@ -2245,16 +2423,10 @@ CMU_PERL_MAKEMAKER(perl/imap)
 CMU_PERL_MAKEMAKER(perl/sieve/managesieve)
 fi
 
-dnl check for libicu. we need this for charset conversions.
-PKG_CHECK_MODULES([ICU], [icu-uc])
-AC_SUBST([ICU_LIBS])
-AC_SUBST([ICU_CFLAGS])
-
 AC_OUTPUT
 echo "
 Cyrus Server configured components
 
-   event notification: $enable_event_notification
    gssapi:             $gssapi
    autocreate:         $enable_autocreate
    idled:              $enable_idled
@@ -2264,7 +2436,9 @@ Cyrus Server configured components
    nntpd:              $enable_nntp
    replication:        $enable_replication
    sieve:              $enable_sieve
+   srs:                $enable_srs
    calalarmd:          $enable_calalarmd
+   jmap:               $enable_jmap
    objectstore:        $enable_objectstore
    backup:             $enable_backup
    com_err:            $with_com_err
@@ -2273,35 +2447,54 @@ External dependencies:
    ldap:               $have_ldap
    openssl:            $with_ssl
    zlib:               $with_zlib
+   jansson:            $with_jansson
    pcre:               $cyrus_cv_pcre_utf8
    clamav:             $with_clamav
+   snmp:               $with_snmp
    -----------------------
    caringo:            $with_caringo
    openio:             $with_openio
    -----------------------
    nghttp2:            $with_nghttp2
+   wslay:              $with_wslay
    brotli:             $with_brotli
+   zstd:               $with_zstd
    xml2:               $with_xml2
    ical:               $with_ical
    icu4c:              $with_icu4c
    shapelib:           $with_shapelib
+   chardet:            $with_chardet
+   cld2:               $with_cld2
 
 Database support:
    mysql:              $with_mysql
    postgresql:         $use_pgsql
    sqlite:             $use_sqlite
-   lmdb:               $use_lmdb
+   zeroskip:           $with_zeroskip
 
 Search engine:
    squat:              $enable_squat
-   sphinx:             $enable_sphinx
    xapian:             $enable_xapian
-   xapian_flavor:      $xapian_flavor
+   xapian_cjk_tokens:  $xapian_cjk_tokens
 
 Hardware support:
    SSE4.2:             $cyrus_cv_sse42
 
+Documentation dependencies:
+   sphinx-build:       $SPHINX_BUILD
+   Pod::POM::View::Restructured:  $have_ppvr
+   GitPython:          $HAVE_PYMOD_GIT
+
 Installation directories:
    prefix:             $prefix
    sysconfdir:         $sysconfdir
+
+Build info:
+   shared:             $enable_shared
+   static:             $enable_static
+   cflags:             $CFLAGS
+   cxxflags:           $CXXFLAGS
+   libs:               $LIBS
+   ldflags:            $LDFLAGS
+   unit tests (cunit): $enable_unit_tests
 "
diff -pruN 3.0.13-5/contrib/cyrus-graphtools.1.0/html/index.html 3.2.0-3/contrib/cyrus-graphtools.1.0/html/index.html
--- 3.0.13-5/contrib/cyrus-graphtools.1.0/html/index.html	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/contrib/cyrus-graphtools.1.0/html/index.html	2020-04-24 02:03:00.000000000 +0000
@@ -4,7 +4,7 @@
 <h2> This is a sample html page for the cyrus graphs <h2>
 <p><h2>Cyrus Data</h2>
 <a href="/cgi-bin/cyrus_master.pl">All services by server</a><br>
-<a href="/cgi-bin/graph_cyrus_db-sum.pl">Aggreagate graphs for all servers by service</a>
+<a href="/cgi-bin/graph_cyrus_db-sum.pl">Aggregate graphs for all servers by service</a>
 
 </html>
 </body>
diff -pruN 3.0.13-5/contrib/cyrusv2.mc 3.2.0-3/contrib/cyrusv2.mc
--- 3.0.13-5/contrib/cyrusv2.mc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/contrib/cyrusv2.mc	2020-04-24 02:03:00.000000000 +0000
@@ -45,7 +45,7 @@
 #
 
 divert(0)dnl
-VERSIONID(`cyrus v2 sample configuartion')
+VERSIONID(`cyrus v2 sample configuration')
 
 OSTYPE(linux)
 define(`confBIND_OPTS',`-DNSRCH -DEFNAMES')
diff -pruN 3.0.13-5/contrib/drac_auth.patch 3.2.0-3/contrib/drac_auth.patch
--- 3.0.13-5/contrib/drac_auth.patch	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/contrib/drac_auth.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,370 +0,0 @@
-Patch to add support for Dynamic Relay Authorization Control
-
-For more information about DRAC, see:
-        http://mail.cc.umanitoba.ca/drac/index.html
-
-
-Installation
-------------
-
-1.  Apply this patch in the toplevel directory using the following command:
-
-        # patch -p1 < contrib/drac_auth.patch
-
-2.  Cleanup any previous builds:
-
-        # make distclean
-
-3a. If you DO NOT have 'smake' and 'autoconf' installed on your system, goto
-    step 3b.
-
-    Perform the following to reconfigure your build:
-
-        # rm configure
-        # sh SMakefile
-        # ./configure ... --with-drac=<location of libdrac>
-
-    NOTE: you can find your original configure command in config.status
-
-    Proceed to step 4.
-
-3b. Edit imap/Makefile and modify the following three variables:
-
-        DEFS = ... -DDRAC_AUTH
-        LIBS = ... -ldrac
-        LDFLAGS = ... -L<location of libdrac>
-
-4.  Build and install the software:
-
-        # make
-        # make install
-
-5.  If dracd is not running on the same system as Cyrus (localhost),
-    use the 'drachost' option in imapd.conf(5) to specify the hostname of
-    the dracd server.
-
-6.  Installation is complete!
-
-
-Operation
----------
-
-The behavior of DRAC is controlled by the value of the 'dracinterval' option
-in imapd.conf(5).  If 'dracinterval' is 0 (zero), DRAC support is disabled.
-Otherwise, DRAC support is enabled and has the following behavior:
-
-pop3d: Whenever a client opens a user's INBOX, drac_auth() is called.
-
-imapd: Once a client is logged in (via LOGIN or AUTHENTICATE),
-       drac_send() will be called once every 'dracinterval' minutes.
-
-
-
-
-
-diff --git a/configure.ac b/configure.ac
-index e0e8cf4..7d237c0 100644
---- a/configure.ac
-+++ b/configure.ac
-@@ -1171,6 +1171,19 @@ dnl (agentx was depricated, but SNMP_SUBDIRS is conveinent as a placeholder)
- SNMP_SUBDIRS=""
- AC_SUBST(SNMP_SUBDIRS)
-
-+dnl
-+dnl Test for DRAC
-+dnl
-+DRACLIBS=
-+AC_ARG_WITH(drac, [  --with-drac=DIR         use DRAC library in <DIR> [no] ],
-+       if test -d "$withval"; then
-+               LDFLAGS="$LDFLAGS -L${withval}"
-+               AC_CHECK_LIB(drac, dracauth,
-+                       AC_DEFINE(DRAC_AUTH,[],[Build DRAC support?])
-+                       DRACLIBS="-ldrac")
-+       fi)
-+AC_SUBST(DRACLIBS)
-+
- CMU_LIBWRAP
- CMU_UCDSNMP
-
-diff --git a/imap/Makefile.in b/imap/Makefile.in
-index b5e139b..1f887f3 100644
---- a/imap/Makefile.in
-+++ b/imap/Makefile.in
-@@ -66,4 +66,5 @@
- LIB_WRAP = @LIB_WRAP@
-+DRAC_LIBS = @DRACLIBS@
- LIBS = $(IMAP_LIBS) @COM_ERR_LIBS@
- DEPLIBS = ../lib/libcyrus.a ../lib/libcyrus_min.la
-
-@@ -203,7 +204,7 @@ lmtpd.pure: lmtpd.o proxy.o $(LMTPOBJS) \
- imapd: $(IMAPDOBJS) mutex_fake.o libcyrus_imap.la $(DEPLIBS) $(SERVICE)
-        $(CC) $(LDFLAGS) -o imapd \
-         $(SERVICE) $(IMAPDOBJS) mutex_fake.o \
--       libcyrus_imap.la $(DEPLIBS) $(LIBS) $(LIB_WRAP)
-+       libcyrus_imap.la $(DEPLIBS) $(LIBS) $(LIB_WRAP) $(DRAC_LIBS)
-
- mupdate: mupdate.o mupdate-slave.o mupdate-client.o mutex_pthread.o tls.o \
-        libcyrus_imap.la $(DEPLIBS)
-@@ -231,7 +232,7 @@ mupdate.pure: mupdate.o mupdate-slave.o mupdate-client.o mutex_pthread.o \
- pop3d: pop3d.o proxy.o backend.o tls.o mutex_fake.o libcyrus_imap.la \
-        $(DEPLIBS) $(SERVICE)
-        $(CC) $(LDFLAGS) -o pop3d pop3d.o proxy.o backend.o tls.o $(SERVICE) \
--        mutex_fake.o libcyrus_imap.la $(DEPLIBS) $(LIBS) $(LIB_WRAP)
-+        mutex_fake.o libcyrus_imap.la $(DEPLIBS) $(LIBS) $(LIB_WRAP) $(DRAC_LIBS)
-
- nntpd: nntpd.o proxy.o backend.o index.o smtpclient.o spool.o tls.o \
-         mutex_fake.o nntp_err.o libcyrus_imap.la $(DEPLIBS) $(SERVICE)
-diff --git a/imap/imapd.c b/imap/imapd.c
-index d979f3b..e9f51d1 100644
---- a/imap/imapd.c
-+++ b/imap/imapd.c
-@@ -193,6 +193,18 @@ static struct proxy_context imapd_proxyctx = {
-     1, 1, &imapd_authstate, &imapd_userisadmin, &imapd_userisproxyadmin
- };
-
-+#ifdef DRAC_AUTH
-+static struct {
-+    int interval;              /* dracd "ping" interval; 0 = disabled */
-+    unsigned long clientaddr;
-+    struct prot_waitevent *event;
-+} drac;
-+
-+extern int dracconn(char *server, char **errmsg);
-+extern int dracsend(unsigned long userip, char **errmsg);
-+extern int dracdisc(char **errmsg);
-+#endif /* DRAC_AUTH */
-+
- /* current sub-user state */
- static struct index_state *imapd_index;
-
-@@ -738,6 +750,23 @@ int service_init(int argc, char **argv, char **envp)
-     /* setup for sending IMAP IDLE notifications */
-     idle_enabled();
-
-+#ifdef DRAC_AUTH
-+    /* setup for sending DRAC "pings" */
-+    drac.event = NULL;
-+    drac.interval = config_getint(IMAPOPT_DRACINTERVAL);
-+    if (drac.interval < 0) drac.interval = 0;
-+    if (drac.interval) {
-+       char *err;
-+
-+       if (dracconn((char*) config_getstring(IMAPOPT_DRACHOST), &err) != 0) {
-+           /* disable DRAC */
-+           drac.interval = 0;
-+           syslog(LOG_ERR, "dracconn: %s", err);
-+           syslog(LOG_ERR, "DRAC notifications disabled");
-+       }
-+    }
-+#endif /* DRAC_AUTH */
-+
-     /* create connection to the SNMP listener, if available. */
-     snmp_connect(); /* ignore return code */
-     snmp_set_str(SERVER_NAME_VERSION,cyrus_version());
-@@ -848,6 +877,15 @@ int service_main(int argc __attribute__((unused)),
-                imapd_haveaddr = 1;
-            }
-        }
-+
-+#ifdef DRAC_AUTH
-+       if (((struct sockaddr *)&imapd_remoteaddr)->sa_family == AF_INET)
-+           drac.clientaddr = ((struct sockaddr_in *)&imapd_remoteaddr)->sin_addr.s_addr;
-+       else
-+           drac.clientaddr = 0;
-+    } else {
-+       drac.clientaddr = 0;
-+#endif /* DRAC_AUTH */
-     }
-
-     /* create the SASL connection */
-@@ -892,6 +930,11 @@ int service_main(int argc __attribute__((unused)),
-     prot_flush(imapd_out);
-     snmp_increment(ACTIVE_CONNECTIONS, -1);
-
-+#ifdef DRAC_AUTH
-+    if (drac.event) prot_removewaitevent(imapd_in, drac.event);
-+    drac.event = NULL;
-+#endif /* DRAC_AUTH */
-+
-     /* cleanup */
-     imapd_reset();
-
-@@ -1004,6 +1047,10 @@ void shut_down(int code)
-
-     cyrus_done();
-
-+#ifdef DRAC_AUTH
-+    if (drac.interval) (void) dracdisc((char **)NULL);
-+#endif /* DRAC_AUTH */
-+
-     exit(code);
- }
-
-@@ -1064,6 +1111,36 @@ static void imapd_check(struct backend *be, int usinguid)
-     }
- }
-
-+#ifdef DRAC_AUTH
-+/*
-+ * Ping dracd every 'drac.interval' minutes
-+ * to let it know that we are still connected
-+ */
-+struct prot_waitevent *drac_ping(struct protstream *s,
-+                                struct prot_waitevent *ev,
-+                                void *rock __attribute__((unused)))
-+{
-+    char *err;
-+    static int nfailure = 0;
-+
-+    if (dracsend(drac.clientaddr, &err) != 0) {
-+       syslog(LOG_ERR, "dracsend: %s", err);
-+       if (++nfailure >= 3) {
-+           /* can't contact dracd for 3 consecutive tries - disable DRAC */
-+           prot_removewaitevent(s, ev);
-+           drac.event = NULL;
-+           syslog(LOG_ERR, "DRAC notifications disabled");
-+           return NULL;
-+       }
-+    }
-+    else
-+       nfailure = 0;
-+
-+    ev->mark = time(NULL) + (drac.interval * 60);
-+    return ev;
-+}
-+#endif /* DRAC_AUTH */
-+
- /*
-  * Top-level command loop parsing
-  */
-@@ -2239,6 +2316,11 @@ static void cmd_login(char *tag, char *user)
-     capa_response(CAPA_PREAUTH|CAPA_POSTAUTH);
-     prot_printf(imapd_out, "] %s\r\n", reply);
-
-+#ifdef DRAC_AUTH
-+    if (!imapd_userisproxyadmin && drac.interval && drac.clientaddr)
-+       drac.event = prot_addwaitevent(imapd_in, 0 /* now */, drac_ping, NULL);
-+#endif /* DRAC_AUTH */
-+
-     /* Create telemetry log */
-     imapd_logfd = telemetry_log(imapd_userid, imapd_in, imapd_out, 0);
-
-@@ -2397,6 +2479,11 @@ cmd_authenticate(char *tag, char *authtype, char *resp)
-     prot_setsasl(imapd_in,  imapd_saslconn);
-     prot_setsasl(imapd_out, imapd_saslconn);
-
-+#ifdef DRAC_AUTH
-+    if (!imapd_userisproxyadmin && drac.interval && drac.clientaddr)
-+       drac.event = prot_addwaitevent(imapd_in, 0 /* now */, drac_ping, NULL);
-+#endif /* DRAC_AUTH */
-+
-     /* Create telemetry log */
-     imapd_logfd = telemetry_log(imapd_userid, imapd_in, imapd_out, 0);
-
-diff --git a/imap/pop3d.c b/imap/pop3d.c
-index 1a11599..ae5722f 100644
---- a/imap/pop3d.c
-+++ b/imap/pop3d.c
-@@ -109,6 +109,10 @@ extern char *optarg;
- extern int opterr;
-
-
-+#ifdef DRAC_AUTH
-+static int drac_enabled;
-+extern int dracauth(char *server, unsigned long userip, char **errmsg);
-+#endif /* DRAC_AUTH */
-
- #ifdef HAVE_SSL
- static SSL *tls_conn;
-@@ -120,6 +124,7 @@ static int popd_timeout;
- static char *popd_userid = 0, *popd_subfolder = 0;
- static struct mailbox *popd_mailbox = NULL;
- static struct auth_state *popd_authstate = 0;
-+static int popd_userisproxyadmin = 0;
- static int config_popuseacl, config_popuseimapflags;
- struct sockaddr_storage popd_localaddr, popd_remoteaddr;
- static int popd_haveaddr = 0;
-@@ -150,7 +155,7 @@ static mailbox_decideproc_t expungedeleted;
-
- /* the sasl proxy policy context */
- static struct proxy_context popd_proxyctx = {
--    0, 1, &popd_authstate, NULL, NULL
-+    0, 1, &popd_authstate, NULL, &popd_userisproxyadmin
- };
-
- /* signal to config.c */
-@@ -395,6 +400,7 @@ static void popd_reset(void)
-        auth_freestate(popd_authstate);
-        popd_authstate = NULL;
-     }
-+    popd_userisproxyadmin = 0;
-     if (popd_saslconn) {
-        sasl_dispose(&popd_saslconn);
-        popd_saslconn = NULL;
-@@ -580,6 +586,10 @@ int service_main(int argc __attribute__((unused)),
-     prot_settimeout(popd_in, popd_timeout);
-     prot_setflushonread(popd_in, popd_out);
-
-+#ifdef DRAC_AUTH
-+    drac_enabled = (config_getint(IMAPOPT_DRACINTERVAL) > 0);
-+#endif /* DRAC_AUTH */
-+
-     if (kflag) kpop();
-
-     /* we were connected on pop3s port so we should do
-@@ -1712,6 +1722,21 @@ int openinbox(void)
-        goto fail;
-     }
-
-+#ifdef DRAC_AUTH
-+    if (!popd_userisproxyadmin && drac_enabled &&
-+       ((struct sockaddr *)&popd_remoteaddr)->sa_family == AF_INET) {
-+       char *err;
-+
-+       if (dracauth((char*) config_getstring(IMAPOPT_DRACHOST),
-+                    ((struct sockaddr_in *)&popd_remoteaddr)->sin_addr.s_addr, &err) != 0) {
-+           /* disable DRAC */
-+           drac_enabled = 0;
-+           syslog(LOG_ERR, "dracauth: %s", err);
-+           syslog(LOG_ERR, "DRAC notifications disabled");
-+       }
-+    }
-+#endif /* DRAC_AUTH */
-+
-     if (mbentry.mbtype & MBTYPE_REMOTE) {
-        /* remote mailbox */
-        char *server = mbentry.partition;
-diff --git a/imap/version.c b/imap/version.c
-index 8438108..7e46016 100644
---- a/imap/version.c
-+++ b/imap/version.c
-@@ -159,6 +159,10 @@ void id_response(struct protstream *pout)
-     snprintf(env_buf + strlen(env_buf), MAXIDVALUELEN - strlen(env_buf),
-             "; %s", SIEVE_VERSION);
- #endif
-+#ifdef DRAC_AUTH
-+    snprintf(env_buf + strlen(env_buf), MAXIDVALUELEN - strlen(env_buf),
-+            "; DRAC");
-+#endif
- #ifdef HAVE_LIBWRAP
-     snprintf(env_buf + strlen(env_buf), MAXIDVALUELEN - strlen(env_buf),
-             "; TCP Wrappers");
-diff --git a/lib/imapoptions b/lib/imapoptions
-index 3018761..70cd561 100644
---- a/lib/imapoptions
-+++ b/lib/imapoptions
-@@ -296,6 +296,14 @@ Blank lines and lines beginning with ``#'' are ignored.
-    session.  Otherwise, the missing mailbox is treated as empty while
-    in use by the client.*/
-
-+{ "dracinterval", 5, INT }
-+/* If nonzero, enables the use of DRAC (Dynamic Relay Authorization
-+   Control) by the pop3d and imapd daemons.  Also sets the interval
-+   (in minutes) between re-authorization requests made by imapd. */
-+
-+{ "drachost", "localhost", STRING }
-+/* Hostname of the RPC dracd server. */
-+
- { "duplicate_db", "skiplist", STRINGLIST("berkeley", "berkeley-nosync", "berkeley-hash", "berkeley-hash-nosync", "skiplist", "sql")}
- /* The cyrusdb backend to use for the duplicate delivery suppression
-    and sieve. */
diff -pruN 3.0.13-5/contrib/notify_unix/sql_notify.pl 3.2.0-3/contrib/notify_unix/sql_notify.pl
--- 3.0.13-5/contrib/notify_unix/sql_notify.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/contrib/notify_unix/sql_notify.pl	2020-04-24 02:03:00.000000000 +0000
@@ -103,7 +103,7 @@ sub sql_notify {
   my $User = $sock->getline();
   my $Mailbox = $sock->getline();
   my $Message = join("\n",$sock->getlines());
-  # Hmmm... there seems to be a trailling space we have to remove...
+  # Hmmm... there seems to be a trailing space we have to remove...
   $User =~ s/\s$//;
 
   my @rows = get_rows($User);
diff -pruN 3.0.13-5/contrib/sieve-spamassassin 3.2.0-3/contrib/sieve-spamassassin
--- 3.0.13-5/contrib/sieve-spamassassin	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/contrib/sieve-spamassassin	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,462 @@
+From bob@nas.com Thu May  9 18:00:16 2002
+Date: Thu, 25 Apr 2002 11:01:11 -0700
+From: Bob Finch <bob@nas.com>
+To: info-cyrus@lists.andrew.cmu.edu
+Subject: "spam" sieve extension
+
+I've gotten a handful of requests for the "spam" sieve extension I
+mentioned yesterday.  The diffs aren't too big, so I'll post them to
+the list.
+
+The diffs add a test to sieve that passes the message to SpamAssassin.
+If SpamAssassin scores the messages as spam, the test fails, otherwise
+the test succeeds.  Here's a simple sieve script using the spam
+extension:
+
+  require [ "spam", "fileinto" ];
+  if spam {
+      fileinto "spamfolder";
+  }
+
+The diffs are based on cyrus-imapd-2.1.3 -- I haven't tried them with
+other versions.  You'll also need to install SpamAssassin (see
+http://www.spamassassin.org/) and have spamd running.  I'm currently
+running SpamAssassin 2.11.  I've been running it for about a month on
+several mailboxes that typically get about 500 messages a day.
+
+The extension adds three new imapd.conf parameters:
+
+  max_size: 256000
+      The spam test will always return false for messages larger than
+      max_size.  Messages larger than max_size will not be passed to
+      spamd.
+
+  spam_spamd_host: 127.0.0.1
+      The IP addresses or hostname of the spamd server.
+
+  spam_spamd_port: 783
+      The port number of the spamd server.
+
+When sieve evaluates the spam test, it calls a callback in
+imap/lmptd.c that opens a connection to spamd.  It then sends a CHECK
+command writes the message to spamd.  It parses the response from
+spamd and returns the result of the test to sieve.
+
+Things on my to-do list:
+
+  * Add a configure option and ifdefs to conditionally include the
+    spam extension
+
+  * Provide a way for users to get more information about how
+    SpamAssassin scores messages.  This will require help from spamd,
+    since it currently just returns the score and threshold.
+
+  * Documentation
+
+-- Bob
+
+
+diff -cr cyrus-imapd-2.1.3-orig/imap/lmtpd.c cyrus-imapd-2.1.3/imap/lmtpd.c
+*** cyrus-imapd-2.1.3-orig/imap/lmtpd.c Thu Mar  7 09:55:28 2002
+--- cyrus-imapd-2.1.3/imap/lmtpd.c      Thu Apr 18 21:14:10 2002
+***************
+*** 111,116 ****
+--- 111,124 ----
+
+      char *authuser;           /* user who submitted message */
+      struct auth_state *authstate;
++
++     /* spam stuff */
++
++     /* This is in script_data, but the spam callback can't get to it */
++     /* so we put a copy here */
++     char *username;           /* Username of mailbox */
++     int spam_result_valid;    /* != 0 iff spam result is valid */
++     int spam_result;          /* != iff message is spam */
+  } mydata_t;
+
+  /* data per script */
+***************
+*** 910,915 ****
+--- 918,1087 ----
+  static char *markflags[] = { "\\flagged" };
+  static sieve_imapflags_t mark = { markflags, 1 };
+
++ /* spam support */
++
++ static int
++ getline (int s, char *buf, int len)
++ {
++     char *bp = buf;
++     int ret = 1;
++     char ch;
++
++     while ((ret = read (s, &ch, 1)) == 1 && ch != '\n') {
++       if (len > 0) {
++           *bp++ = ch;
++           len--;
++       }
++     }
++     if (len > 0)
++       *bp = '\0';
++     return (buf != bp);
++ }
++
++
++ static int
++ full_write (int s, char *buf, int len)
++ {
++     int total;
++     int ret;
++
++     for (total = 0; total < len; total += ret) {
++       ret = write (s, buf + total, len - total);
++       if (ret < 0)
++           return 0;
++     }
++     return total == len;
++ }
++
++
++ static int
++ read_response (int s, int *result)
++ {
++     char is_spam[6];
++     char buf[1024];
++     int major;
++     int minor;
++     int response;
++     int score;
++     int threshold;
++
++     if (! getline (s, buf, sizeof (buf))) {
++       syslog (LOG_ERR, "read_response: response getline failed");
++       return SIEVE_FAIL;
++     }
++     if (sscanf (buf, "SPAMD/%d.%d %d %*s", &major, &minor, &response) != 3) {
++       syslog (LOG_ERR, "read_response: response sscanf failed, buf: %s",
++               buf);
++       return SIEVE_FAIL;
++     }
++     if (major < 1 || (major == 1 && minor < 1)) {
++       syslog (LOG_ERR, "read_response: bad spamd version: %d.%d",
++               major, minor);
++       return SIEVE_FAIL;
++     }
++     if (! getline (s, buf, sizeof (buf))) {
++       syslog (LOG_ERR, "read_response: header getline failed");
++       return SIEVE_FAIL;
++     }
++     if (sscanf (buf, "Spam: %5s ; %d / %d", is_spam, &score, &threshold) != 3) {
++       syslog (LOG_ERR, "read_response: header sscanf failed, buf: %s",
++               buf);
++       return SIEVE_FAIL;
++     }
++
++     *result = ! strcmp(is_spam, "True");
++     return SIEVE_OK;
++ }
++
++
++ int spam (void *mc, int *is_spam)
++ {
++     mydata_t *d = (mydata_t *) mc;
++     message_data_t *m = d->m;
++     int s;
++     struct sockaddr_in addr;
++     struct hostent *host;
++     char header[128];
++     int max_size = config_getint ("spam_max_size", 250 * 1024);
++     const char *hostname = config_getstring ("spam_spamd_host", "127.0.0.1");
++     int port = config_getint ("spam_spamd_port", 783);
++     char *msg_buf;
++     int ret;
++
++     /* Assume message isn't spam if it is larger than max_size */
++     if (m->size > max_size) {
++       syslog (LOG_INFO, "spam: skipping message bigger than %d", max_size);
++       return SIEVE_FAIL;
++     }
++
++     memset (&addr, 0, sizeof(addr));
++     addr.sin_family = AF_INET;
++     addr.sin_port = htons(port);
++
++     if ((host = gethostbyname (hostname)) == NULL) {
++       syslog (LOG_ERR, "spam: gethostbyname failed");
++       return SIEVE_FAIL;
++     }
++     memcpy (&addr.sin_addr, host->h_addr, sizeof (addr.sin_addr));
++
++     if((s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
++       syslog (LOG_ERR, "spam: socket failed");
++       return SIEVE_FAIL;
++     }
++
++     if (connect (s, (const struct sockaddr *) &addr, sizeof (addr)) < 0) {
++       syslog (LOG_ERR, "spam: connect failed");
++       close (s);
++       return SIEVE_FAIL;
++     }
++
++     if ((msg_buf = malloc (m->size)) == NULL) {
++       syslog (LOG_ERR, "spam: malloc(%d) failed", m->size);
++       close (s);
++       return SIEVE_FAIL;
++     }
++     rewind (m->f);
++     if (fread (msg_buf, 1, m->size, m->f) != m->size || ferror (m->f)) {
++       syslog (LOG_ERR, "spam: read message failed");
++       free (msg_buf);
++       close (s);
++       return SIEVE_FAIL;
++     }
++
++     if (d->username) {
++       snprintf (header, sizeof (header),
++                 "CHECK SPAMC/1.2\r\nUser: %s\r\nContent-length: %d\r\n\r\n",
++                 d->username, m->size);
++     }
++     else {
++       snprintf (header, sizeof (header),
++                 "CHECK SPAMC/1.2\r\nContent-length: %d\r\n\r\n", m->size);
++     }
++     if (! full_write (s, header, strlen (header))) {
++       syslog (LOG_ERR, "spam: write header failed");
++       free (msg_buf);
++       close (s);
++       return SIEVE_FAIL;
++     }
++     if (! full_write (s, msg_buf, m->size)) {
++       syslog (LOG_ERR, "spam: write message failed");
++       free (msg_buf);
++       close (s);
++       return SIEVE_FAIL;
++     }
++
++     shutdown (s, SHUT_WR);
++     ret = read_response (s, is_spam);
++     shutdown (s, SHUT_RD);
++
++     free (msg_buf);
++     close (s);
++
++     syslog(LOG_DEBUG, "spam result: %d\n", ret);
++     return ret;
++ }
++
++
+  int sieve_parse_error_handler(int lineno, const char *msg, void *ic, void *sc)
+  {
+      script_data_t *sd = (script_data_t *) sc;
+***************
+*** 999,1004 ****
+--- 1171,1182 ----
+        fatal("sieve_register_vacation()", EX_SOFTWARE);
+      }
+
++     res = sieve_register_spam(sieve_interp, &spam);
++     if (res != SIEVE_OK) {
++       syslog(LOG_ERR, "sieve_register_spam() returns %d\n", res);
++       fatal("sieve_register_spam()", EX_SOFTWARE);
++     }
++
+      res = sieve_register_parse_error(sieve_interp, &sieve_parse_error_handler);
+      if (res != SIEVE_OK) {
+        syslog(LOG_ERR, "sieve_register_parse_error() returns %d\n", res);
+***************
+*** 1148,1154 ****
+      mydata.notifyheader = generate_notify(msgdata);
+      mydata.authuser = authuser;
+      mydata.authstate = authstate;
+!
+      /* loop through each recipient, attempting delivery for each */
+      for (n = 0; n < nrcpts; n++) {
+        char *rcpt = xstrdup(msg_getrcpt(msgdata, n));
+--- 1326,1335 ----
+      mydata.notifyheader = generate_notify(msgdata);
+      mydata.authuser = authuser;
+      mydata.authstate = authstate;
+!     mydata.username = NULL;
+!     mydata.spam_result = 0;
+!     mydata.spam_result_valid = 0;
+!
+      /* loop through each recipient, attempting delivery for each */
+      for (n = 0; n < nrcpts; n++) {
+        char *rcpt = xstrdup(msg_getrcpt(msgdata, n));
+***************
+*** 1187,1192 ****
+--- 1368,1376 ----
+                sdata->username = rcpt;
+                sdata->mailboxname = plus;
+                sdata->authstate = auth_newstate(rcpt, (char *)0);
++
++               /* Make a copy of mailbox username for spam stuff */
++               mydata.username = sdata->username;
+
+                /* slap the mailboxname back on so we hash the envelope & id
+                   when we figure out whether or not to keep the message */
+diff -cr cyrus-imapd-2.1.3-orig/sieve/interp.c cyrus-imapd-2.1.3/sieve/interp.c
+*** cyrus-imapd-2.1.3-orig/sieve/interp.c       Tue Oct  2 14:08:13 2001
+--- cyrus-imapd-2.1.3/sieve/interp.c    Sun Mar 24 11:39:14 2002
+***************
+*** 154,159 ****
+--- 154,166 ----
+      return SIEVE_OK;
+  }
+
++ int sieve_register_spam(sieve_interp_t *interp, sieve_spam *f)
++ {
++     interp->spam = f;
++
++     return SIEVE_OK;
++ }
++
+  /* add the callbacks for messages. again, undefined if used after
+     sieve_script_parse */
+  int sieve_register_size(sieve_interp_t *interp, sieve_get_size *f)
+diff -cr cyrus-imapd-2.1.3-orig/sieve/interp.h cyrus-imapd-2.1.3/sieve/interp.h
+*** cyrus-imapd-2.1.3-orig/sieve/interp.h       Mon Feb 21 23:56:40 2000
+--- cyrus-imapd-2.1.3/sieve/interp.h    Sun Mar 24 11:40:53 2002
+***************
+*** 35,40 ****
+--- 35,41 ----
+      sieve_callback *redirect, *discard, *reject, *fileinto, *keep;
+      sieve_callback *notify;
+      sieve_vacation_t *vacation;
++     sieve_spam *spam;
+
+      sieve_get_size *getsize;
+      sieve_get_header *getheader;
+diff -cr cyrus-imapd-2.1.3-orig/sieve/script.c cyrus-imapd-2.1.3/sieve/script.c
+*** cyrus-imapd-2.1.3-orig/sieve/script.c       Wed Feb 27 13:05:13 2002
+--- cyrus-imapd-2.1.3/sieve/script.c    Thu Apr 18 21:02:51 2002
+***************
+*** 102,107 ****
+--- 102,114 ----
+        return 1;
+      } else if (!strcmp("comparator-i;ascii-casemap", req)) {
+        return 1;
++     } else if (!strcmp("spam",req)) {
++       if (s->interp.spam) {
++           s->support.spam = 1;
++           return 1;
++       } else {
++           return 0;
++       }
+      }
+      return 0;
+  }
+***************
+*** 361,366 ****
+--- 368,381 ----
+            res = (sz < t->u.sz.n);
+        }
+        break;
++     }
++     case SPAM:
++     {
++       int is_spam;
++
++       if (i->spam == NULL || i->spam (m, &is_spam) != SIEVE_OK)
++           break;
++       res = is_spam;
+      }
+      }
+
+diff -cr cyrus-imapd-2.1.3-orig/sieve/script.h cyrus-imapd-2.1.3/sieve/script.h
+*** cyrus-imapd-2.1.3-orig/sieve/script.h       Wed Feb  9 16:39:14 2000
+--- cyrus-imapd-2.1.3/sieve/script.h    Sun Mar 24 11:39:13 2002
+***************
+*** 45,50 ****
+--- 45,51 ----
+        int notify    : 1;
+        int regex     : 1;
+        int subaddress: 1;
++       int spam      : 1;
+      } support;
+
+      void *script_context;
+diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve-lex.l cyrus-imapd-2.1.3/sieve/sieve-lex.l
+*** cyrus-imapd-2.1.3-orig/sieve/sieve-lex.l    Tue Feb 19 10:09:46 2002
+--- cyrus-imapd-2.1.3/sieve/sieve-lex.l Sat Mar 23 18:43:22 2002
+***************
+*** 90,95 ****
+--- 90,96 ----
+  <INITIAL>header               return HEADER;
+  <INITIAL>not          return NOT;
+  <INITIAL>size         return SIZE;
++ <INITIAL>spam         return SPAM;
+  <INITIAL>reject               return REJCT;
+  <INITIAL>fileinto     return FILEINTO;
+  <INITIAL>redirect     return REDIRECT;
+diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve.y cyrus-imapd-2.1.3/sieve/sieve.y
+*** cyrus-imapd-2.1.3-orig/sieve/sieve.y        Tue Mar  5 08:15:01 2002
+--- cyrus-imapd-2.1.3/sieve/sieve.y     Sun Mar 24 11:36:18 2002
+***************
+*** 141,146 ****
+--- 141,147 ----
+  %token SETFLAG ADDFLAG REMOVEFLAG MARK UNMARK
+  %token NOTIFY DENOTIFY
+  %token ANYOF ALLOF EXISTS SFALSE STRUE HEADER NOT SIZE ADDRESS ENVELOPE
++ %token SPAM
+  %token COMPARATOR IS CONTAINS MATCHES REGEX OVER UNDER
+  %token ALL LOCALPART DOMAIN USER DETAIL
+  %token DAYS ADDRESSES SUBJECT MIME
+***************
+*** 398,403 ****
+--- 399,409 ----
+        | NOT test               { $$ = new_test(NOT); $$->u.t = $2; }
+        | SIZE sizetag NUMBER    { $$ = new_test(SIZE); $$->u.sz.t = $2;
+                                   $$->u.sz.n = $3; }
++       | SPAM                   { if (!parse_script->support.spam) {
++                                    yyerror("spam not required");
++                                    YYERROR;
++                                  }
++                                  $$ = new_test(SPAM); }
+        | error                  { $$ = NULL; }
+        ;
+
+diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve_interface.h cyrus-imapd-2.1.3/sieve/sieve_interface.h
+*** cyrus-imapd-2.1.3-orig/sieve/sieve_interface.h      Tue Feb 19 10:09:46 2002
+--- cyrus-imapd-2.1.3/sieve/sieve_interface.h   Sun Mar 24 19:46:44 2002
+***************
+*** 50,55 ****
+--- 50,57 ----
+  typedef int sieve_get_envelope(void *message_context,
+                               const char *field,
+                               const char ***contents);
++ typedef int sieve_spam(void *message_context, int *is_spam);
++
+
+  typedef struct sieve_vacation {
+      int min_response;         /* 0 -> defaults to 3 */
+***************
+*** 121,126 ****
+--- 123,129 ----
+  int sieve_register_vacation(sieve_interp_t *interp, sieve_vacation_t *v);
+  int sieve_register_imapflags(sieve_interp_t *interp, sieve_imapflags_t *mark);
+  int sieve_register_notify(sieve_interp_t *interp, sieve_callback *f);
++ int sieve_register_spam(sieve_interp_t *interp, sieve_spam *f);
+
+  /* add the callbacks for messages. again, undefined if used after
+     sieve_script_parse */
+diff -cr cyrus-imapd-2.1.3-orig/timsieved/scripttest.c cyrus-imapd-2.1.3/timsieved/scripttest.c
+*** cyrus-imapd-2.1.3-orig/timsieved/scripttest.c       Sun Dec 17 20:53:43 2000
+--- cyrus-imapd-2.1.3/timsieved/scripttest.c    Sun Mar 24 13:12:06 2002
+***************
+*** 171,176 ****
+--- 171,182 ----
+        return TIMSIEVE_FAIL;
+      }
+
++     res = sieve_register_spam(i, (sieve_spam *) &foo);
++     if (res != SIEVE_OK) {
++       syslog (LOG_ERR, "sieve_register_spam() returns %d\n", res);
++       return TIMSIEVE_FAIL;
++     }
++
+      res = sieve_register_parse_error(i, &mysieve_error);
+      if (res != SIEVE_OK) {
+        syslog(LOG_ERR, "sieve_register_parse_error() returns %d\n", res);
+
diff -pruN 3.0.13-5/contrib/sieve-spamasssassin 3.2.0-3/contrib/sieve-spamasssassin
--- 3.0.13-5/contrib/sieve-spamasssassin	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/contrib/sieve-spamasssassin	1970-01-01 00:00:00.000000000 +0000
@@ -1,462 +0,0 @@
-From bob@nas.com Thu May  9 18:00:16 2002
-Date: Thu, 25 Apr 2002 11:01:11 -0700
-From: Bob Finch <bob@nas.com>
-To: info-cyrus@lists.andrew.cmu.edu
-Subject: "spam" sieve extension
-
-I've gotten a handful of requests for the "spam" sieve extension I
-mentioned yesterday.  The diffs aren't too big, so I'll post them to
-the list.
-
-The diffs add a test to sieve that passes the message to SpamAssassin.
-If SpamAssassin scores the messages as spam, the test fails, otherwise
-the test succeeds.  Here's a simple sieve script using the spam
-extension:
-
-  require [ "spam", "fileinto" ];
-  if spam {
-      fileinto "spamfolder";
-  }
-
-The diffs are based on cyrus-imapd-2.1.3 -- I haven't tried them with
-other versions.  You'll also need to install SpamAssassin (see
-http://www.spamassassin.org/) and have spamd running.  I'm currently
-running SpamAssassin 2.11.  I've been running it for about a month on
-several mailboxes that typically get about 500 messages a day.
-
-The extension adds three new imapd.conf parameters:
-
-  max_size: 256000
-      The spam test will always return false for messages larger than
-      max_size.  Messages larger than max_size will not be passed to
-      spamd.
-
-  spam_spamd_host: 127.0.0.1
-      The IP addresses or hostname of the spamd server.
-
-  spam_spamd_port: 783
-      The port number of the spamd server.
-
-When sieve evaluates the spam test, it calls a callback in
-imap/lmptd.c that opens a connection to spamd.  It then sends a CHECK
-command writes the message to spamd.  It parses the response from
-spamd and returns the result of the test to sieve.
-
-Things on my to-do list:
-
-  * Add a configure option and ifdefs to conditionally include the
-    spam extension
-
-  * Provide a way for users to get more information about how
-    SpamAssassin scores messages.  This will require help from spamd,
-    since it currently just returns the score and threshold.
-
-  * Documentation
-
--- Bob
-
-
-diff -cr cyrus-imapd-2.1.3-orig/imap/lmtpd.c cyrus-imapd-2.1.3/imap/lmtpd.c
-*** cyrus-imapd-2.1.3-orig/imap/lmtpd.c Thu Mar  7 09:55:28 2002
---- cyrus-imapd-2.1.3/imap/lmtpd.c      Thu Apr 18 21:14:10 2002
-***************
-*** 111,116 ****
---- 111,124 ----
-
-      char *authuser;           /* user who submitted message */
-      struct auth_state *authstate;
-+
-+     /* spam stuff */
-+
-+     /* This is in script_data, but the spam callback can't get to it */
-+     /* so we put a copy here */
-+     char *username;           /* Username of mailbox */
-+     int spam_result_valid;    /* != 0 iff spam result is valid */
-+     int spam_result;          /* != iff message is spam */
-  } mydata_t;
-
-  /* data per script */
-***************
-*** 910,915 ****
---- 918,1087 ----
-  static char *markflags[] = { "\\flagged" };
-  static sieve_imapflags_t mark = { markflags, 1 };
-
-+ /* spam support */
-+
-+ static int
-+ getline (int s, char *buf, int len)
-+ {
-+     char *bp = buf;
-+     int ret = 1;
-+     char ch;
-+
-+     while ((ret = read (s, &ch, 1)) == 1 && ch != '\n') {
-+       if (len > 0) {
-+           *bp++ = ch;
-+           len--;
-+       }
-+     }
-+     if (len > 0)
-+       *bp = '\0';
-+     return (buf != bp);
-+ }
-+
-+
-+ static int
-+ full_write (int s, char *buf, int len)
-+ {
-+     int total;
-+     int ret;
-+
-+     for (total = 0; total < len; total += ret) {
-+       ret = write (s, buf + total, len - total);
-+       if (ret < 0)
-+           return 0;
-+     }
-+     return total == len;
-+ }
-+
-+
-+ static int
-+ read_response (int s, int *result)
-+ {
-+     char is_spam[6];
-+     char buf[1024];
-+     int major;
-+     int minor;
-+     int response;
-+     int score;
-+     int threshold;
-+
-+     if (! getline (s, buf, sizeof (buf))) {
-+       syslog (LOG_ERR, "read_response: response getline failed");
-+       return SIEVE_FAIL;
-+     }
-+     if (sscanf (buf, "SPAMD/%d.%d %d %*s", &major, &minor, &response) != 3) {
-+       syslog (LOG_ERR, "read_response: response sscanf failed, buf: %s",
-+               buf);
-+       return SIEVE_FAIL;
-+     }
-+     if (major < 1 || (major == 1 && minor < 1)) {
-+       syslog (LOG_ERR, "read_response: bad spamd version: %d.%d",
-+               major, minor);
-+       return SIEVE_FAIL;
-+     }
-+     if (! getline (s, buf, sizeof (buf))) {
-+       syslog (LOG_ERR, "read_response: header getline failed");
-+       return SIEVE_FAIL;
-+     }
-+     if (sscanf (buf, "Spam: %5s ; %d / %d", is_spam, &score, &threshold) != 3) {
-+       syslog (LOG_ERR, "read_response: header sscanf failed, buf: %s",
-+               buf);
-+       return SIEVE_FAIL;
-+     }
-+
-+     *result = ! strcmp(is_spam, "True");
-+     return SIEVE_OK;
-+ }
-+
-+
-+ int spam (void *mc, int *is_spam)
-+ {
-+     mydata_t *d = (mydata_t *) mc;
-+     message_data_t *m = d->m;
-+     int s;
-+     struct sockaddr_in addr;
-+     struct hostent *host;
-+     char header[128];
-+     int max_size = config_getint ("spam_max_size", 250 * 1024);
-+     const char *hostname = config_getstring ("spam_spamd_host", "127.0.0.1");
-+     int port = config_getint ("spam_spamd_port", 783);
-+     char *msg_buf;
-+     int ret;
-+
-+     /* Assume message isn't spam if it is larger than max_size */
-+     if (m->size > max_size) {
-+       syslog (LOG_INFO, "spam: skipping message bigger than %d", max_size);
-+       return SIEVE_FAIL;
-+     }
-+
-+     memset (&addr, 0, sizeof(addr));
-+     addr.sin_family = AF_INET;
-+     addr.sin_port = htons(port);
-+
-+     if ((host = gethostbyname (hostname)) == NULL) {
-+       syslog (LOG_ERR, "spam: gethostbyname failed");
-+       return SIEVE_FAIL;
-+     }
-+     memcpy (&addr.sin_addr, host->h_addr, sizeof (addr.sin_addr));
-+
-+     if((s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
-+       syslog (LOG_ERR, "spam: socket failed");
-+       return SIEVE_FAIL;
-+     }
-+
-+     if (connect (s, (const struct sockaddr *) &addr, sizeof (addr)) < 0) {
-+       syslog (LOG_ERR, "spam: connect failed");
-+       close (s);
-+       return SIEVE_FAIL;
-+     }
-+
-+     if ((msg_buf = malloc (m->size)) == NULL) {
-+       syslog (LOG_ERR, "spam: malloc(%d) failed", m->size);
-+       close (s);
-+       return SIEVE_FAIL;
-+     }
-+     rewind (m->f);
-+     if (fread (msg_buf, 1, m->size, m->f) != m->size || ferror (m->f)) {
-+       syslog (LOG_ERR, "spam: read message failed");
-+       free (msg_buf);
-+       close (s);
-+       return SIEVE_FAIL;
-+     }
-+
-+     if (d->username) {
-+       snprintf (header, sizeof (header),
-+                 "CHECK SPAMC/1.2\r\nUser: %s\r\nContent-length: %d\r\n\r\n",
-+                 d->username, m->size);
-+     }
-+     else {
-+       snprintf (header, sizeof (header),
-+                 "CHECK SPAMC/1.2\r\nContent-length: %d\r\n\r\n", m->size);
-+     }
-+     if (! full_write (s, header, strlen (header))) {
-+       syslog (LOG_ERR, "spam: write header failed");
-+       free (msg_buf);
-+       close (s);
-+       return SIEVE_FAIL;
-+     }
-+     if (! full_write (s, msg_buf, m->size)) {
-+       syslog (LOG_ERR, "spam: write message failed");
-+       free (msg_buf);
-+       close (s);
-+       return SIEVE_FAIL;
-+     }
-+
-+     shutdown (s, SHUT_WR);
-+     ret = read_response (s, is_spam);
-+     shutdown (s, SHUT_RD);
-+
-+     free (msg_buf);
-+     close (s);
-+
-+     syslog(LOG_DEBUG, "spam result: %d\n", ret);
-+     return ret;
-+ }
-+
-+
-  int sieve_parse_error_handler(int lineno, const char *msg, void *ic, void *sc)
-  {
-      script_data_t *sd = (script_data_t *) sc;
-***************
-*** 999,1004 ****
---- 1171,1182 ----
-        fatal("sieve_register_vacation()", EC_SOFTWARE);
-      }
-
-+     res = sieve_register_spam(sieve_interp, &spam);
-+     if (res != SIEVE_OK) {
-+       syslog(LOG_ERR, "sieve_register_spam() returns %d\n", res);
-+       fatal("sieve_register_spam()", EC_SOFTWARE);
-+     }
-+
-      res = sieve_register_parse_error(sieve_interp, &sieve_parse_error_handler);
-      if (res != SIEVE_OK) {
-        syslog(LOG_ERR, "sieve_register_parse_error() returns %d\n", res);
-***************
-*** 1148,1154 ****
-      mydata.notifyheader = generate_notify(msgdata);
-      mydata.authuser = authuser;
-      mydata.authstate = authstate;
-!
-      /* loop through each recipient, attempting delivery for each */
-      for (n = 0; n < nrcpts; n++) {
-        char *rcpt = xstrdup(msg_getrcpt(msgdata, n));
---- 1326,1335 ----
-      mydata.notifyheader = generate_notify(msgdata);
-      mydata.authuser = authuser;
-      mydata.authstate = authstate;
-!     mydata.username = NULL;
-!     mydata.spam_result = 0;
-!     mydata.spam_result_valid = 0;
-!
-      /* loop through each recipient, attempting delivery for each */
-      for (n = 0; n < nrcpts; n++) {
-        char *rcpt = xstrdup(msg_getrcpt(msgdata, n));
-***************
-*** 1187,1192 ****
---- 1368,1376 ----
-                sdata->username = rcpt;
-                sdata->mailboxname = plus;
-                sdata->authstate = auth_newstate(rcpt, (char *)0);
-+
-+               /* Make a copy of mailbox username for spam stuff */
-+               mydata.username = sdata->username;
-
-                /* slap the mailboxname back on so we hash the envelope & id
-                   when we figure out whether or not to keep the message */
-diff -cr cyrus-imapd-2.1.3-orig/sieve/interp.c cyrus-imapd-2.1.3/sieve/interp.c
-*** cyrus-imapd-2.1.3-orig/sieve/interp.c       Tue Oct  2 14:08:13 2001
---- cyrus-imapd-2.1.3/sieve/interp.c    Sun Mar 24 11:39:14 2002
-***************
-*** 154,159 ****
---- 154,166 ----
-      return SIEVE_OK;
-  }
-
-+ int sieve_register_spam(sieve_interp_t *interp, sieve_spam *f)
-+ {
-+     interp->spam = f;
-+
-+     return SIEVE_OK;
-+ }
-+
-  /* add the callbacks for messages. again, undefined if used after
-     sieve_script_parse */
-  int sieve_register_size(sieve_interp_t *interp, sieve_get_size *f)
-diff -cr cyrus-imapd-2.1.3-orig/sieve/interp.h cyrus-imapd-2.1.3/sieve/interp.h
-*** cyrus-imapd-2.1.3-orig/sieve/interp.h       Mon Feb 21 23:56:40 2000
---- cyrus-imapd-2.1.3/sieve/interp.h    Sun Mar 24 11:40:53 2002
-***************
-*** 35,40 ****
---- 35,41 ----
-      sieve_callback *redirect, *discard, *reject, *fileinto, *keep;
-      sieve_callback *notify;
-      sieve_vacation_t *vacation;
-+     sieve_spam *spam;
-
-      sieve_get_size *getsize;
-      sieve_get_header *getheader;
-diff -cr cyrus-imapd-2.1.3-orig/sieve/script.c cyrus-imapd-2.1.3/sieve/script.c
-*** cyrus-imapd-2.1.3-orig/sieve/script.c       Wed Feb 27 13:05:13 2002
---- cyrus-imapd-2.1.3/sieve/script.c    Thu Apr 18 21:02:51 2002
-***************
-*** 102,107 ****
---- 102,114 ----
-        return 1;
-      } else if (!strcmp("comparator-i;ascii-casemap", req)) {
-        return 1;
-+     } else if (!strcmp("spam",req)) {
-+       if (s->interp.spam) {
-+           s->support.spam = 1;
-+           return 1;
-+       } else {
-+           return 0;
-+       }
-      }
-      return 0;
-  }
-***************
-*** 361,366 ****
---- 368,381 ----
-            res = (sz < t->u.sz.n);
-        }
-        break;
-+     }
-+     case SPAM:
-+     {
-+       int is_spam;
-+
-+       if (i->spam == NULL || i->spam (m, &is_spam) != SIEVE_OK)
-+           break;
-+       res = is_spam;
-      }
-      }
-
-diff -cr cyrus-imapd-2.1.3-orig/sieve/script.h cyrus-imapd-2.1.3/sieve/script.h
-*** cyrus-imapd-2.1.3-orig/sieve/script.h       Wed Feb  9 16:39:14 2000
---- cyrus-imapd-2.1.3/sieve/script.h    Sun Mar 24 11:39:13 2002
-***************
-*** 45,50 ****
---- 45,51 ----
-        int notify    : 1;
-        int regex     : 1;
-        int subaddress: 1;
-+       int spam      : 1;
-      } support;
-
-      void *script_context;
-diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve-lex.l cyrus-imapd-2.1.3/sieve/sieve-lex.l
-*** cyrus-imapd-2.1.3-orig/sieve/sieve-lex.l    Tue Feb 19 10:09:46 2002
---- cyrus-imapd-2.1.3/sieve/sieve-lex.l Sat Mar 23 18:43:22 2002
-***************
-*** 90,95 ****
---- 90,96 ----
-  <INITIAL>header               return HEADER;
-  <INITIAL>not          return NOT;
-  <INITIAL>size         return SIZE;
-+ <INITIAL>spam         return SPAM;
-  <INITIAL>reject               return REJCT;
-  <INITIAL>fileinto     return FILEINTO;
-  <INITIAL>redirect     return REDIRECT;
-diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve.y cyrus-imapd-2.1.3/sieve/sieve.y
-*** cyrus-imapd-2.1.3-orig/sieve/sieve.y        Tue Mar  5 08:15:01 2002
---- cyrus-imapd-2.1.3/sieve/sieve.y     Sun Mar 24 11:36:18 2002
-***************
-*** 141,146 ****
---- 141,147 ----
-  %token SETFLAG ADDFLAG REMOVEFLAG MARK UNMARK
-  %token NOTIFY DENOTIFY
-  %token ANYOF ALLOF EXISTS SFALSE STRUE HEADER NOT SIZE ADDRESS ENVELOPE
-+ %token SPAM
-  %token COMPARATOR IS CONTAINS MATCHES REGEX OVER UNDER
-  %token ALL LOCALPART DOMAIN USER DETAIL
-  %token DAYS ADDRESSES SUBJECT MIME
-***************
-*** 398,403 ****
---- 399,409 ----
-        | NOT test               { $$ = new_test(NOT); $$->u.t = $2; }
-        | SIZE sizetag NUMBER    { $$ = new_test(SIZE); $$->u.sz.t = $2;
-                                   $$->u.sz.n = $3; }
-+       | SPAM                   { if (!parse_script->support.spam) {
-+                                    yyerror("spam not required");
-+                                    YYERROR;
-+                                  }
-+                                  $$ = new_test(SPAM); }
-        | error                  { $$ = NULL; }
-        ;
-
-diff -cr cyrus-imapd-2.1.3-orig/sieve/sieve_interface.h cyrus-imapd-2.1.3/sieve/sieve_interface.h
-*** cyrus-imapd-2.1.3-orig/sieve/sieve_interface.h      Tue Feb 19 10:09:46 2002
---- cyrus-imapd-2.1.3/sieve/sieve_interface.h   Sun Mar 24 19:46:44 2002
-***************
-*** 50,55 ****
---- 50,57 ----
-  typedef int sieve_get_envelope(void *message_context,
-                               const char *field,
-                               const char ***contents);
-+ typedef int sieve_spam(void *message_context, int *is_spam);
-+
-
-  typedef struct sieve_vacation {
-      int min_response;         /* 0 -> defaults to 3 */
-***************
-*** 121,126 ****
---- 123,129 ----
-  int sieve_register_vacation(sieve_interp_t *interp, sieve_vacation_t *v);
-  int sieve_register_imapflags(sieve_interp_t *interp, sieve_imapflags_t *mark);
-  int sieve_register_notify(sieve_interp_t *interp, sieve_callback *f);
-+ int sieve_register_spam(sieve_interp_t *interp, sieve_spam *f);
-
-  /* add the callbacks for messages. again, undefined if used after
-     sieve_script_parse */
-diff -cr cyrus-imapd-2.1.3-orig/timsieved/scripttest.c cyrus-imapd-2.1.3/timsieved/scripttest.c
-*** cyrus-imapd-2.1.3-orig/timsieved/scripttest.c       Sun Dec 17 20:53:43 2000
---- cyrus-imapd-2.1.3/timsieved/scripttest.c    Sun Mar 24 13:12:06 2002
-***************
-*** 171,176 ****
---- 171,182 ----
-        return TIMSIEVE_FAIL;
-      }
-
-+     res = sieve_register_spam(i, (sieve_spam *) &foo);
-+     if (res != SIEVE_OK) {
-+       syslog (LOG_ERR, "sieve_register_spam() returns %d\n", res);
-+       return TIMSIEVE_FAIL;
-+     }
-+
-      res = sieve_register_parse_error(i, &mysieve_error);
-      if (res != SIEVE_OK) {
-        syslog(LOG_ERR, "sieve_register_parse_error() returns %d\n", res);
-
diff -pruN 3.0.13-5/COPYING 3.2.0-3/COPYING
--- 3.0.13-5/COPYING	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/COPYING	2020-04-08 00:07:13.000000000 +0000
@@ -42,4 +42,5 @@ ALL versions of the Cyrus IMAP server ar
 If you find this software useful and valuable in your work, we would
 welcome any support you can offer toward continuing this work.
 
-http://cyrusimap.org/ for information on how to contact us and contributing.
+http://www.cyrusimap.org/ for information on how to contact us and
+contributing.
diff -pruN 3.0.13-5/cunit/aaa-db.testc 3.2.0-3/cunit/aaa-db.testc
--- 3.0.13-5/cunit/aaa-db.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/aaa-db.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "xmalloc.h"
 #include "imap/global.h"
 #include "retry.h"
@@ -19,7 +19,7 @@ struct binary_result
     size_t datalen;
 };
 
-static char *backend = CUNIT_PARAM("skiplist,flat,twoskip,lmdb");
+static char *backend = CUNIT_PARAM("skiplist,flat,twoskip,zeroskip");
 static char *filename;
 static char *filename2;
 
@@ -180,7 +180,7 @@ static char *make_basedir(const char * c
     CU_ASSERT_EQUAL(r, CYRUSDB_OK); \
     r = cyrusdb_open(backend, filename, 0, &db); \
     CU_ASSERT_EQUAL(r, CYRUSDB_OK); \
-    CU_ASSERT_PTR_NOT_NULL(db);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(db);
 
 #define GOTRESULT(expkey, expkeylen, expdata, expdatalen) \
 { \
@@ -203,8 +203,9 @@ static char *make_basedir(const char * c
 static int skiptest()
 {
     /* cunit.pl doesn't play nice with #ifdef'ed CUNIT_PARAMS */
-    if (!strcmp(backend, "lmdb")) {
-#ifdef HAVE_LMDB
+
+    if (!strcmp(backend, "zeroskip")) {
+#ifdef HAVE_ZEROSKIP
         return 0;
 #else
         return 1;
@@ -583,7 +584,7 @@ static void test_abort(void)
     struct db *db = NULL;
     struct txn *txn = NULL;
     static const char KEY[] = "yale";
-    static const char DATA[] = "standford mit harvard";
+    static const char DATA[] = "stanford mit harvard";
     int r;
 
     if (skiptest()) return;
@@ -951,9 +952,14 @@ struct ffrock {
 #define K2 "cubist"
 #define K3 "eulogy"
 #define K4 "kidding"
-#define K4A "notice"
-#define K5 "penguin"
-#define K6 "zebra"
+#define K4A "llama"
+#define K5 "monkey"
+#define K6 "notice"
+#define K7 "octopus"
+#define K7D "opossum"
+#define K7A "possum"
+#define K7B "quine"
+#define K8 "rooster"
 
 static int ffstatemachine(void *rockp,
                           const char *key, size_t keylen,
@@ -1001,6 +1007,7 @@ static int ffstatemachine(void *rockp,
         /* didn't repeat after replacing */
         CU_ASSERT_STRING_EQUAL(kcopy, K5);
         r = cyrusdb_delete(fr->db, K5, strlen(K5), fr->tid, /*force*/1);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
         fr->state = 6;
         break;
     case 6:
@@ -1008,6 +1015,34 @@ static int ffstatemachine(void *rockp,
         CU_ASSERT_STRING_EQUAL(kcopy, K6);
         fr->state = 7;
         break;
+    case 7:
+        CU_ASSERT_STRING_EQUAL(kcopy, K7);
+        /* we're going to replace this one,
+            add two more, then delete the next */
+        r = cyrusdb_store(fr->db, K7, strlen(K7), "newval", 6, fr->tid);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
+        r = cyrusdb_store(fr->db, K7D, strlen(K7D), "val", 3, fr->tid);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
+        r = cyrusdb_store(fr->db, K7B, strlen(K7B), "bval", 4, fr->tid);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
+        r = cyrusdb_store(fr->db, K7A, strlen(K7A), "aval", 4, fr->tid);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
+        r = cyrusdb_delete(fr->db, K7D, strlen(K7D), fr->tid, /*force*/1);
+        CU_ASSERT_EQUAL(r, CYRUSDB_OK);
+        fr->state = 8;
+        break;
+    case 8:
+        CU_ASSERT_STRING_EQUAL(kcopy, K7A);
+        fr->state = 9;
+        break;
+    case 9:
+        CU_ASSERT_STRING_EQUAL(kcopy, K7B);
+        fr->state = 10;
+        break;
+    case 10:
+        CU_ASSERT_STRING_EQUAL(kcopy, K8);
+        fr->state = 11;
+        break;
     default:
         CU_ASSERT(0); /* bogus state found */
         break;
@@ -1041,7 +1076,7 @@ static void test_foreach_changes(void)
 
     if (skiptest()) return;
 
-    if (!strcmp(backend, "flat")) return; /* flat concurency is bogus */
+    if (!strcmp(backend, "flat")) return; /* flat concurrency is bogus */
 
     r = cyrusdb_open(backend, filename, CYRUSDB_CREATE, &db);
     CU_ASSERT_EQUAL(r, CYRUSDB_OK);
@@ -1132,6 +1167,8 @@ static void test_binary_keys(void)
                                  0x10, 0x20, 0x40, 0x80,
                                  0x00/*unused*/};
     static const char DATA5[] = "farm-to-table";
+    static const char KEY6[] = " BLANK\x07\xa0";
+    static const char DATA6[] = "magic blank in key!";
     struct binary_result *results = NULL;
     int r;
 
@@ -1147,6 +1184,7 @@ static void test_binary_keys(void)
     CANNOTFETCH(KEY3, sizeof(KEY3)-1, CYRUSDB_NOTFOUND);
     CANNOTFETCH(KEY4, sizeof(KEY4)-1, CYRUSDB_NOTFOUND);
     CANNOTFETCH(KEY5, sizeof(KEY5)-1, CYRUSDB_NOTFOUND);
+    CANNOTFETCH(KEY6, sizeof(KEY6)-1, CYRUSDB_NOTFOUND);
 
     /* store()ing a record succeeds */
     CANSTORE(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
@@ -1154,6 +1192,7 @@ static void test_binary_keys(void)
     CANSTORE(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANSTORE(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANSTORE(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANSTORE(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* the record can be fetched back */
     CANFETCH(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
@@ -1161,6 +1200,7 @@ static void test_binary_keys(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* commit succeeds */
     CANCOMMIT();
@@ -1171,6 +1211,7 @@ static void test_binary_keys(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* close the txn - it doesn't matter here if we commit or abort */
     CANCOMMIT();
@@ -1181,6 +1222,7 @@ static void test_binary_keys(void)
 
     /* got the expected keys in the expected order */
     GOTRESULT(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    GOTRESULT(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
     GOTRESULT(KEY2, sizeof(KEY2)-1, DATA2, sizeof(DATA2)-1);
     GOTRESULT(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
     GOTRESULT(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
@@ -1200,6 +1242,7 @@ static void test_binary_keys(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* close the txn - it doesn't matter here if we commit or abort */
     CANCOMMIT();
@@ -1210,6 +1253,7 @@ static void test_binary_keys(void)
 
     /* got the expected keys in the expected order */
     GOTRESULT(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    GOTRESULT(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
     GOTRESULT(KEY2, sizeof(KEY2)-1, DATA2, sizeof(DATA2)-1);
     GOTRESULT(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
     GOTRESULT(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
@@ -1240,6 +1284,8 @@ static void test_binary_data(void)
     static const char DATA5[] = { 0x01, 0x02, 0x04, 0x08,
                                   0x10, 0x20, 0x40, 0x80,
                                   0x00/*unused*/};
+    static const char KEY6[] = "magic blank in data!";
+    static const char DATA6[] = " BLANK\x07\xa0";
     struct binary_result *results = NULL;
     int r;
 
@@ -1255,6 +1301,7 @@ static void test_binary_data(void)
     CANNOTFETCH(KEY3, sizeof(KEY3)-1, CYRUSDB_NOTFOUND);
     CANNOTFETCH(KEY4, sizeof(KEY4)-1, CYRUSDB_NOTFOUND);
     CANNOTFETCH(KEY5, sizeof(KEY5)-1, CYRUSDB_NOTFOUND);
+    CANNOTFETCH(KEY6, sizeof(KEY6)-1, CYRUSDB_NOTFOUND);
 
     /* store()ing a record succeeds */
     CANSTORE(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
@@ -1262,6 +1309,7 @@ static void test_binary_data(void)
     CANSTORE(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANSTORE(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANSTORE(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANSTORE(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* the record can be fetched back */
     CANFETCH(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
@@ -1269,6 +1317,7 @@ static void test_binary_data(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* commit succeeds */
     CANCOMMIT();
@@ -1279,6 +1328,7 @@ static void test_binary_data(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* close the txn - it doesn't matter here if we commit or abort */
     CANCOMMIT();
@@ -1291,6 +1341,7 @@ static void test_binary_data(void)
     GOTRESULT(KEY2, sizeof(KEY2)-1, DATA2, sizeof(DATA2)-1);
     GOTRESULT(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     GOTRESULT(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    GOTRESULT(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
     GOTRESULT(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     GOTRESULT(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
     /* foreach iterated over exactly all the keys */
@@ -1308,6 +1359,7 @@ static void test_binary_data(void)
     CANFETCH(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     CANFETCH(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     CANFETCH(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    CANFETCH(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
 
     /* foreach still succeeds */
     r = cyrusdb_foreach(db, NULL, 0, NULL, foreacher, &results, &txn);
@@ -1317,6 +1369,7 @@ static void test_binary_data(void)
     GOTRESULT(KEY2, sizeof(KEY2)-1, DATA2, sizeof(DATA2)-1);
     GOTRESULT(KEY3, sizeof(KEY3)-1, DATA3, sizeof(DATA3)-1);
     GOTRESULT(KEY5, sizeof(KEY5)-1, DATA5, sizeof(DATA5)-1);
+    GOTRESULT(KEY6, sizeof(KEY6)-1, DATA6, sizeof(DATA6)-1);
     GOTRESULT(KEY4, sizeof(KEY4)-1, DATA4, sizeof(DATA4)-1);
     GOTRESULT(KEY1, sizeof(KEY1)-1, DATA1, sizeof(DATA1)-1);
     /* foreach iterated over exactly all the keys */
diff -pruN 3.0.13-5/cunit/annotate.testc 3.2.0-3/cunit/annotate.testc
--- 3.0.13-5/cunit/annotate.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/annotate.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #if HAVE_CONFIG_H
 #include <config.h>
 #endif
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "assert.h"
 #include "xmalloc.h"
 #include "retry.h"
@@ -9,12 +9,14 @@
 #include "imap/global.h"
 #include "libcyr_cfg.h"
 #include "imap/annotate.h"
+#include "imap/append.h"
 #include "imap/mboxlist.h"
 #include "imap/imap_err.h"
 
 #define DBDIR           "test-dbdir"
 #define MBOXNAME1_INT   "user.smurf"
 #define MBOXNAME2_INT   "user.smurfette"
+#define MBOXNAME3_INT   "user.smurfine"
 #define PARTITION       "default"
 #define COMMENT         "/comment"
 #define EXENTRY         "/vendor/example.com/a-non-default-entry"
@@ -26,6 +28,9 @@
 #define VALUE2          "dolor sit amet"
 #define ACL             "anyone\tlrswipkxtecdan\t"
 
+#define MBOX1_MAXUID    3
+#define MBOX2_MAXUID    1
+
 static int isadmin;
 static const char *userid;
 static struct auth_state *auth_state;
@@ -489,7 +494,7 @@ static void test_getset_message_shared(v
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
 
@@ -505,14 +510,14 @@ static void test_getset_message_shared(v
     CU_ASSERT_EQUAL_FATAL(results.count, 1);
 #define EXPECTED \
            "mboxname=\"" MBOXNAME1_INT "\" " \
-           "uid=42 " \
+           "uid=1 " \
            "entry=\"" COMMENT "\" " \
            VALUE_SHARED "=NIL"
     CU_ASSERT_STRING_EQUAL(results.data[0], EXPECTED);
 #undef EXPECTED
     strarray_truncate(&results, 0);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NULL(val.s);
 
@@ -533,14 +538,14 @@ static void test_getset_message_shared(v
     CU_ASSERT_EQUAL_FATAL(results.count, 1);
 #define EXPECTED \
            "mboxname=\"" MBOXNAME1_INT "\" " \
-           "uid=42 " \
+           "uid=1 " \
            "entry=\"" COMMENT "\" " \
            VALUE_SHARED "=\"" VALUE0 "\""
     CU_ASSERT_STRING_EQUAL(results.data[0], EXPECTED);
 #undef EXPECTED
     strarray_truncate(&results, 0);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
@@ -553,7 +558,7 @@ static void test_getset_message_shared(v
     /* check that we can fetch the value back in a new txn */
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox);
     CU_ASSERT_EQUAL_FATAL(r, 0);
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
 
@@ -564,14 +569,14 @@ static void test_getset_message_shared(v
     CU_ASSERT_EQUAL_FATAL(results.count, 1);
 #define EXPECTED \
            "mboxname=\"" MBOXNAME1_INT "\" " \
-           "uid=42 " \
+           "uid=1 " \
            "entry=\"" COMMENT "\" " \
            VALUE_SHARED "=\"" VALUE0 "\""
     CU_ASSERT_STRING_EQUAL(results.data[0], EXPECTED);
 #undef EXPECTED
     strarray_truncate(&results, 0);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
@@ -589,7 +594,7 @@ static void test_getset_message_shared(v
 
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox);
     CU_ASSERT_EQUAL_FATAL(r, 0);
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
 
@@ -600,14 +605,14 @@ static void test_getset_message_shared(v
     CU_ASSERT_EQUAL_FATAL(results.count, 1);
 #define EXPECTED \
            "mboxname=\"" MBOXNAME1_INT "\" " \
-           "uid=42 " \
+           "uid=1 " \
            "entry=\"" COMMENT "\" " \
            VALUE_SHARED "=\"" VALUE0 "\""
     CU_ASSERT_STRING_EQUAL(results.data[0], EXPECTED);
 #undef EXPECTED
     strarray_truncate(&results, 0);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
@@ -629,7 +634,7 @@ static void test_getset_message_shared(v
     /* check that there is no value any more */
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox);
     CU_ASSERT_EQUAL_FATAL(r, 0);
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
 
@@ -640,7 +645,7 @@ static void test_getset_message_shared(v
     CU_ASSERT_EQUAL_FATAL(results.count, 1);
 #define EXPECTED \
            "mboxname=\"" MBOXNAME1_INT "\" " \
-           "uid=42 " \
+           "uid=1 " \
            "entry=\"" COMMENT "\" " \
            VALUE_SHARED "=NIL"
     CU_ASSERT_STRING_EQUAL(results.data[0], EXPECTED);
@@ -648,7 +653,7 @@ static void test_getset_message_shared(v
     strarray_truncate(&results, 0);
 
     buf_free(&val);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NULL(val.s);
 
@@ -678,8 +683,6 @@ static void test_delete(void)
     struct buf val2 = BUF_INITIALIZER;
     struct mailbox *mailbox = NULL;
 
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), -ENOENT);
-
     annotate_init(NULL, NULL);
 
     annotatemore_open();
@@ -714,7 +717,7 @@ static void test_delete(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE1);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -725,7 +728,7 @@ static void test_delete(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE2);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox, 127, &astate);
+    r = mailbox_get_annotate_state(mailbox, 3, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -745,13 +748,13 @@ static void test_delete(void)
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE1);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE2);
@@ -776,12 +779,12 @@ static void test_delete(void)
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
@@ -806,20 +809,17 @@ static void test_rename(void)
     struct buf val = BUF_INITIALIZER;
     struct buf val2 = BUF_INITIALIZER;
     struct mailbox *mailbox1 = NULL;
-    struct mailbox *mailbox2 = NULL;
+    struct mailbox *mailbox3 = NULL;
     const char *uniqueid = makeuuid();
 
     annotate_init(NULL, NULL);
 
     annotatemore_open();
 
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), -ENOENT);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), -ENOENT);
-
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox1);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
-    r = mailbox_open_iwl(MBOXNAME2_INT, &mailbox2);
+    r = mailbox_open_iwl(MBOXNAME3_INT, &mailbox3);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     strarray_append(&entries, COMMENT);
@@ -843,7 +843,7 @@ static void test_rename(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE1);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox1, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox1, 2, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -854,7 +854,7 @@ static void test_rename(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE2);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox1, 127, &astate);
+    r = mailbox_get_annotate_state(mailbox1, 3, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -877,33 +877,33 @@ static void test_rename(void)
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE1);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE2);
     buf_free(&val2);
 
     CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), 0);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), -ENOENT);
+    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfine/cyrus.annotations"), -ENOENT);
 
-    /* rename MBOXNAME1 -> MBOXNAME2 */
+    /* rename MBOXNAME1 -> MBOXNAME3 */
 
-    r = annotate_rename_mailbox(mailbox1, mailbox2);
+    r = annotate_rename_mailbox(mailbox1, mailbox3);
     CU_ASSERT_EQUAL(r, 0);
-    r = mailbox_copy_files(mailbox1, PARTITION, MBOXNAME2_INT, uniqueid);
+    r = mailbox_copy_files(mailbox1, PARTITION, MBOXNAME3_INT, uniqueid);
     CU_ASSERT_EQUAL(r, 0);
     r = mailbox_rename_cleanup(&mailbox1, 0);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NULL(mailbox1);
 
     CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), -ENOENT);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), 0);
+    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfine/cyrus.annotations"), 0);
 
     /* check that the values are gone under the old name */
 
@@ -912,38 +912,38 @@ static void test_rename(void)
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
     buf_free(&val2);
 
     /* check that the values are present under the new name */
 
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 0, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME3_INT, 0, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME3_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE1);
     buf_free(&val2);
 
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME3_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE2);
     buf_free(&val2);
 
     CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), -ENOENT);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), 0);
+    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfine/cyrus.annotations"), 0);
 
     annotatemore_close();
 
@@ -951,7 +951,7 @@ static void test_rename(void)
     strarray_fini(&attribs);
     buf_free(&val);
     mailbox_close(&mailbox1);
-    mailbox_close(&mailbox2);
+    mailbox_close(&mailbox3);
 }
 
 static void test_abort(void)
@@ -1048,7 +1048,7 @@ static void test_abort(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE1);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -1102,9 +1102,6 @@ static void test_msg_copy(void)
 
     annotatemore_open();
 
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), -ENOENT);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), -ENOENT);
-
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox1);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     r = mailbox_open_iwl(MBOXNAME2_INT, &mailbox2);
@@ -1117,7 +1114,7 @@ static void test_msg_copy(void)
 
     buf_appendcstr(&val, VALUE0);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox1, 17, &astate);
+    r = mailbox_get_annotate_state(mailbox1, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -1128,7 +1125,7 @@ static void test_msg_copy(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE1);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox1, 42, &astate);
+    r = mailbox_get_annotate_state(mailbox1, 2, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -1139,7 +1136,7 @@ static void test_msg_copy(void)
     buf_reset(&val);
     buf_appendcstr(&val, VALUE2);
     setentryatt(&ealist, COMMENT, VALUE_SHARED, &val);
-    r = mailbox_get_annotate_state(mailbox1, 127, &astate);
+    r = mailbox_get_annotate_state(mailbox1, 3, &astate);
     CU_ASSERT_EQUAL(r, 0);
     annotate_state_set_auth(astate, isadmin, userid, auth_state);
     r = annotate_state_store(astate, ealist);
@@ -1154,42 +1151,42 @@ static void test_msg_copy(void)
     /* check that we can fetch the values back */
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 17, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE1);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE2);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 35, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME2_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL_FATAL(val2.s);
 
     CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurf/cyrus.annotations"), 0);
-    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), -ENOENT);
+    CU_ASSERT_EQUAL(fexists(DBDIR"/data/user/smurfette/cyrus.annotations"), 0);
 
-    /* copy MBOXNAME1,17 -> MBOXNAME2,35 */
+    /* copy MBOXNAME1,1 -> MBOXNAME2,1 */
     r = mailbox_open_iwl(MBOXNAME1_INT, &mailbox1);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* ensure we have an astate connected to the destination
      * mailbox, so that the annotation txn will be committed
      * when we close the mailbox */
-    r = mailbox_get_annotate_state(mailbox2, 35, &astate);
+    r = mailbox_get_annotate_state(mailbox2, 1, &astate);
     CU_ASSERT_EQUAL(r, 0);
 
-    r = annotate_msg_copy(mailbox1, 17, mailbox2, 35, "smurf");
+    r = annotate_msg_copy(mailbox1, 1, mailbox2, 1, "smurf");
     CU_ASSERT_EQUAL(r, 0);
 
     r = mailbox_commit(mailbox2);
@@ -1203,13 +1200,13 @@ static void test_msg_copy(void)
     /* check that the values copied are present for both mailboxes */
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 17, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 35, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME2_INT, 1, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE0);
@@ -1218,24 +1215,24 @@ static void test_msg_copy(void)
      * mailbox */
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE1);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME1_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME1_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(val2.s);
     CU_ASSERT_STRING_EQUAL(buf_cstring(&val2), VALUE2);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 42, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME2_INT, 2, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL(val2.s);
 
     buf_free(&val2);
-    r = annotatemore_msg_lookup(MBOXNAME2_INT, 127, COMMENT, /*userid*/"", &val2);
+    r = annotatemore_msg_lookup(MBOXNAME2_INT, 3, COMMENT, /*userid*/"", &val2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NULL(val2.s);
 
@@ -1821,6 +1818,72 @@ static void test_clearentryatt(void)
     buf_free(&val);
 }
 
+static int create_messages(struct mailbox *mailbox, int count)
+{
+    int i, r;
+
+    for (i = 0; i < count; i++) {
+        static const char msgtmpl[] =
+            "From: Fred Bloggs <fbloggs@fastmail.fm>\r\n"
+            "To: Sarah Jane Smith <sjsmith@gmail.com>\r\n"
+            "Date: Wed, 27 Oct 2010 18:37:26 +1100\r\n"
+            "Subject: Trivial testing email %d in mbox %s\r\n"
+            "Message-ID: <fake800-%d@fastmail.fm>\r\n"
+            "X-Mailer: Norman\r\n"
+            "\r\n"
+            "Hello, World from message %d in mailbox %s!\n";
+        struct stagemsg *stage = NULL;
+        struct appendstate as;
+        quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_DONTCARE_INITIALIZER;
+        FILE *fp;
+        time_t internaldate = time(NULL);
+        struct body *body = NULL;
+        struct buf buf = BUF_INITIALIZER;
+
+        /* Write the message to the filesystem */
+        if (!(fp = append_newstage(mailbox->name, internaldate, 0, &stage))) {
+            fprintf(stderr, "append_newstage(%s) failed", mailbox->name);
+            return r;
+        }
+        buf_printf(&buf, msgtmpl, i, mailbox->name, i, i, mailbox->name);
+        fwrite(buf_base(&buf), 1, buf_len(&buf), fp);
+        buf_free(&buf);
+        if (fclose(fp)) {
+            fprintf(stderr, "fclose failed: %s", strerror(errno));
+            return IMAP_IOERROR;
+        }
+
+        /* Append the message to the mailbox */
+        qdiffs[QUOTA_MESSAGE] = 1;
+        r = append_setup_mbox(&as, mailbox, userid, auth_state,
+                0, qdiffs, 0, 0, EVENT_MESSAGE_NEW);
+        if (r) {
+            fprintf(stderr, "append_setup_mbox(%s) failed: %s", mailbox->name,
+                    strerror(errno));
+            return r;
+        }
+        r = append_fromstage(&as, &body, stage, internaldate, 0, NULL, 0, NULL);
+        if (r) {
+            fprintf(stderr, "append_fromstage(%s) failed: %s", mailbox->name,
+                    error_message(r));
+            append_abort(&as);
+            return r;
+        }
+        message_free_body(body);
+        free(body);
+
+        append_removestage(stage);
+        r = append_commit(&as);
+        if (r) {
+            fprintf(stderr, "append_commit(%s) failed: %s", mailbox->name,
+                    error_message(r));
+            return r;
+        }
+    }
+
+    return 0;
+}
+
 
 static int set_up(void)
 {
@@ -1889,9 +1952,14 @@ static int set_up(void)
     r = mailbox_create(MBOXNAME1_INT, /*mbtype*/0, PARTITION, ACL,
                        /*uniqueid*/NULL,
                        /*options*/0, /*uidvalidity*/0,
+                       /*createdmodseq*/0,
                        /*highestmodseq*/0, &mailbox);
     if (r)
         return r;
+
+    r = create_messages(mailbox, MBOX1_MAXUID);
+    if (r)
+        return r;
     mailbox_close(&mailbox);
 
     memset(&mbentry, 0, sizeof(mbentry));
@@ -1906,6 +1974,29 @@ static int set_up(void)
     r = mailbox_create(MBOXNAME2_INT, /*mbtype*/0, PARTITION, ACL,
                        /*uniqueid*/NULL,
                        /*options*/0, /*uidvalidity*/0,
+                       /*createdmodseq*/0,
+                       /*highestmodseq*/0, &mailbox);
+    if (r)
+        return r;
+
+    r = create_messages(mailbox, MBOX2_MAXUID);
+    if (r)
+        return r;
+    mailbox_close(&mailbox);
+
+    memset(&mbentry, 0, sizeof(mbentry));
+    mbentry.name = MBOXNAME3_INT;
+    mbentry.mbtype = 0;
+    mbentry.partition = PARTITION;
+    mbentry.acl = ACL;
+    r = mboxlist_update(&mbentry, /*localonly*/1);
+    if (r)
+        return r;
+
+    r = mailbox_create(MBOXNAME3_INT, /*mbtype*/0, PARTITION, ACL,
+                       /*uniqueid*/NULL,
+                       /*options*/0, /*uidvalidity*/0,
+                       /*createdmodseq*/0,
                        /*highestmodseq*/0, &mailbox);
     if (r)
         return r;
diff -pruN 3.0.13-5/cunit/backend.testc 3.2.0-3/cunit/backend.testc
--- 3.0.13-5/cunit/backend.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/backend.testc	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@
 #include <sys/wait.h>
 #include <sys/mman.h>
 #include <assert.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/saslclient.h"
 #include <sasl/saslutil.h>
 #include <sasl/saslplug.h>
@@ -157,7 +157,7 @@ static void test_badhost(void)
 
     default_conditions();
 
-    be = backend_connect(NULL, "nonexistanthost", &test_prot,
+    be = backend_connect(NULL, "nonexistenthost", &test_prot,
                          USERID, callbacks, &auth_status, /*fd*/-1);
     CU_ASSERT_PTR_NULL(be);
     CU_ASSERT_EQUAL(server_state->is_connected, 0);
@@ -172,7 +172,7 @@ static void test_badservice(void)
     const char *auth_status = NULL;
 
     default_conditions();
-    test_prot.service = "nonexistantservice";
+    test_prot.service = "nonexistentservice";
 
     be = backend_connect(NULL, HOST, &test_prot,
                          USERID, callbacks, &auth_status, /*fd*/-1);
@@ -621,10 +621,9 @@ static void server_unaccept(struct serve
 /*
  * Main routine for pushing text back to the client.
  */
-static void server_printf(struct server_state *, const char *fmt, ...)
-    __attribute__((format(printf,2,3)));
-
-static void server_printf(struct server_state *state, const char *fmt, ...)
+static void
+__attribute__((format(printf, 2, 3)))
+server_printf(struct server_state *state, const char *fmt, ...)
 {
     va_list args;
     int r;
@@ -719,7 +718,7 @@ static void server_emit_caps(struct serv
                 words[n++] = "LOGIN";
                 got_login = 1;
             }
-            if (!strcasecmp(p, "LOGIN") && state->config.sasl_plain) {
+            if (!strcasecmp(p, "PLAIN") && state->config.sasl_plain) {
                 words[n++] = "PLAIN";
                 got_plain = 1;
             }
@@ -914,9 +913,8 @@ static void cmd_starttls(struct server_s
 {
 #ifdef HAVE_SSL
     int r;
-    char *auth_id = NULL;
     SSL *tls_conn = NULL;
-    sasl_ssf_t ssf;
+    static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
     r = tls_init_serverengine("backend_test", /*verifydepth*/5,
                               /*askcert*/1, NULL);
@@ -933,7 +931,8 @@ static void cmd_starttls(struct server_s
     r = tls_start_servertls(/*readfd*/state->in->fd,
                             /*writefd*/state->out->fd,
                             /*timeout_sec*/3000,
-                            (int *)&ssf, &auth_id, &tls_conn);
+                            &saslprops,
+                            &tls_conn);
     if (r < 0) {
         server_printf(state, "BAD STARTTLS negotiation failed\r\n");
         server_flush(state);
@@ -941,18 +940,10 @@ static void cmd_starttls(struct server_s
     }
 
     /* tell SASL about the negotiated layer */
-    r = sasl_setprop(state->saslconn, SASL_SSF_EXTERNAL, &ssf);
-    if (r != SASL_OK) {
-        server_printf(state, "BAD sasl_setprop(SASL_SSF_EXTERNAL) "
-                              "failed: cmd_starttls()\r\n");
-        server_flush(state);
-        return;
-    }
-
-    r = sasl_setprop(state->saslconn, SASL_AUTH_EXTERNAL, auth_id);
+    r = saslprops_set_tls(&saslprops, state->saslconn);
     if (r != SASL_OK) {
-        server_printf(state, "BAD sasl_setprop(SASL_AUTH_EXTERNAL) "
-                             "failed: cmd_starttls()\r\n");
+        server_printf(state,
+                      "BAD saslprops_set_tls() failed: cmd_starttls()\r\n");
         server_flush(state);
         return;
     }
@@ -1148,9 +1139,9 @@ static AUXPROP_RTYPE server_auxprop_look
 }
 
 /*
- * Helps create a fake "auxiliary propert plugin" for the SASL library,
+ * Helps create a fake "auxiliary property plugin" for the SASL library,
  * which is how we hook into the DIGEST-MD5 mechanism when it wants to
- * get a plaintext password to check aginst the hash received from the
+ * get a plaintext password to check against the hash received from the
  * client.
  */
 static int server_auxprop_init(const sasl_utils_t *utils __attribute__((unused)),
diff -pruN 3.0.13-5/cunit/binhex.testc 3.2.0-3/cunit/binhex.testc
--- 3.0.13-5/cunit/binhex.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/binhex.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "util.h"
 
 static void test_bin_to_hex(void)
@@ -28,6 +28,9 @@ static void test_bin_to_hex_long(void)
     r = bin_to_hex(BIN, sizeof(BIN), hex, BH_LOWER);
     CU_ASSERT_EQUAL(r, sizeof(hex)-1);
     CU_ASSERT_STRING_EQUAL(hex, HEX);
+    r = bin_to_lchex(BIN, sizeof(BIN), hex);
+    CU_ASSERT_EQUAL(r, sizeof(hex)-1);
+    CU_ASSERT_STRING_EQUAL(hex, HEX);
 }
 
 static void test_bin_to_hex_short(void)
@@ -41,6 +44,9 @@ static void test_bin_to_hex_short(void)
     r = bin_to_hex(BIN, sizeof(BIN), hex, BH_LOWER);
     CU_ASSERT_EQUAL(r, sizeof(hex)-1);
     CU_ASSERT_STRING_EQUAL(hex, HEX);
+    r = bin_to_lchex(BIN, sizeof(BIN), hex);
+    CU_ASSERT_EQUAL(r, sizeof(hex)-1);
+    CU_ASSERT_STRING_EQUAL(hex, HEX);
 }
 
 static void test_bin_to_hex_sep(void)
diff -pruN 3.0.13-5/cunit/bitvector.testc 3.2.0-3/cunit/bitvector.testc
--- 3.0.13-5/cunit/bitvector.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/bitvector.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 #include <stdlib.h>
 
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "bitvector.h"
 #include "util.h"
 
@@ -9,7 +9,7 @@ static void test_free(void)
     bitvector_t bv = BV_INITIALIZER;
     /* it's ok to call free() even if we never
      * set or cleared any bits */
-    bv_free(&bv);
+    bv_fini(&bv);
 }
 
 static void test_basic(void)
@@ -94,7 +94,7 @@ static void test_basic(void)
     CU_ASSERT_EQUAL(105, bv.length);
     CU_ASSERT_NOT_EQUAL(0, bv.alloc);
 
-    bv_free(&bv);
+    bv_fini(&bv);
 }
 
 static void test_andeq(void)
@@ -121,8 +121,8 @@ static void test_andeq(void)
     CU_ASSERT_EQUAL(0, bv_isset(&a, 3));
     CU_ASSERT_EQUAL(0, bv_isset(&a, 23));
 
-    bv_free(&a);
-    bv_free(&b);
+    bv_fini(&a);
+    bv_fini(&b);
 }
 
 static void test_andeq_noexpand(void)
@@ -152,8 +152,8 @@ static void test_andeq_noexpand(void)
     CU_ASSERT_EQUAL(0, bv_isset(&a, 7));
     CU_ASSERT_EQUAL(0, bv_isset(&a, 23));
 
-    bv_free(&a);
-    bv_free(&b);
+    bv_fini(&a);
+    bv_fini(&b);
 }
 
 static void test_oreq(void)
@@ -180,8 +180,8 @@ static void test_oreq(void)
     CU_ASSERT_EQUAL(1, bv_isset(&a, 3));
     CU_ASSERT_EQUAL(1, bv_isset(&a, 23));
 
-    bv_free(&a);
-    bv_free(&b);
+    bv_fini(&a);
+    bv_fini(&b);
 }
 
 static void test_oreq_empty(void)
@@ -201,8 +201,8 @@ static void test_oreq_empty(void)
     CU_ASSERT_EQUAL(1, bv_isset(&a, 0));
     CU_ASSERT_EQUAL(1, bv_isset(&a, 23));
 
-    bv_free(&a);
-    bv_free(&b);
+    bv_fini(&a);
+    bv_fini(&b);
 }
 
 static void test_oreq_noexpand(void)
@@ -229,8 +229,8 @@ static void test_oreq_noexpand(void)
     CU_ASSERT_EQUAL(1, bv_isset(&a, 3));
     CU_ASSERT_EQUAL(1, bv_isset(&a, 23));
 
-    bv_free(&a);
-    bv_free(&b);
+    bv_fini(&a);
+    bv_fini(&b);
 }
 
 static void test_shrink_expand(void)
@@ -273,7 +273,7 @@ static void test_shrink_expand(void)
         bv_setall(&bv);
     }
 
-    bv_free(&bv);
+    bv_fini(&bv);
 }
 
 static void test_copy(void)
@@ -322,8 +322,8 @@ static void test_copy(void)
     CU_ASSERT_EQUAL(1, bv_isset(&src, 23));
     CU_ASSERT_EQUAL(0, bv_isset(&src, 24));
 
-    bv_free(&dst);
-    bv_free(&src);
+    bv_fini(&dst);
+    bv_fini(&src);
 }
 
 static void test_cstring(void)
@@ -387,7 +387,7 @@ static void test_cstring(void)
     CU_ASSERT_STRING_EQUAL(s, "aa0a[1,3,5,7,9,11]");
     free(s);
 
-    bv_free(&bv);
+    bv_fini(&bv);
 }
 
 static void test_next_set(void)
@@ -406,7 +406,7 @@ static void test_next_set(void)
         } \
         bit = bv_next_set(&bv, bit+1); \
         CU_ASSERT_EQUAL(bit, -1); \
-        bv_free(&bv); \
+        bv_fini(&bv); \
     }
 
     /* empty vector never reports any set bits */
@@ -449,7 +449,7 @@ static void test_prev_set(void)
         } \
         bit = bv_prev_set(&bv, bit-1); \
         CU_ASSERT_EQUAL(bit, -1); \
-        bv_free(&bv); \
+        bv_fini(&bv); \
     }
 
     /* empty vector never reports any set bits */
@@ -487,7 +487,7 @@ static void test_count(void)
             bv_set(&bv, _in[i]); \
         count = bv_count(&bv); \
         CU_ASSERT_EQUAL(count, VECTOR_SIZE(_in)); \
-        bv_free(&bv); \
+        bv_fini(&bv); \
     }
 
     /* empty vector */
@@ -513,4 +513,44 @@ static void test_count(void)
 #undef TESTCASE
 }
 
+static void test_andeq_valgrind(void)
+{
+    bitvector_t a = BV_INITIALIZER;
+    bitvector_t b = BV_INITIALIZER;
+
+    bv_set(&a, 5);
+    bv_set(&b, 65535);
+
+    bv_set(&a, 257);
+    bv_set(&b, 257);
+
+    bv_andeq(&a, &b);
+    CU_ASSERT_EQUAL(257, bv_next_set(&a, 0));
+    CU_ASSERT_EQUAL(-1, bv_next_set(&a, 257+1));
+
+    bv_fini(&a);
+    bv_fini(&b);
+}
+
+static void test_oreq_valgrind(void)
+{
+    bitvector_t a = BV_INITIALIZER;
+    bitvector_t b = BV_INITIALIZER;
+
+    bv_set(&a, 5);
+    bv_set(&b, 65535);
+
+    bv_set(&a, 257);
+    bv_set(&b, 257);
+
+    bv_oreq(&a, &b);
+    CU_ASSERT_EQUAL(5, bv_next_set(&a, 0));
+    CU_ASSERT_EQUAL(257, bv_next_set(&a, 5+1));
+    CU_ASSERT_EQUAL(65535, bv_next_set(&a, 257+1));
+    CU_ASSERT_EQUAL(-1, bv_next_set(&a, 65535+1));
+
+    bv_fini(&a);
+    bv_fini(&b);
+}
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/buf.testc 3.2.0-3/cunit/buf.testc
--- 3.0.13-5/cunit/buf.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/buf.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "prot.h"
 #include "xmalloc.h"
 #include "util.h"
@@ -609,7 +609,7 @@ static void test_replace_all(void)
 
 /* we use buf_init_ro() instead of buf_appendcstr() to test
  * the case where the input buffer is not a C string before
- * caling buf_replace_*() */
+ * calling buf_replace_*() */
 #define TESTCASE_START(in, reg, rep, expn, exp) \
     { \
         static const char _in[] = in; \
@@ -1553,7 +1553,89 @@ static void test_trim(void)
     _trimsto("\t  ", "");
 }
 
+static void test_appendoverlap(void)
+{
+    struct testcase {
+        const char *buf;
+        const char *str;
+        const char *want;
+    };
+
+    struct testcase testcases[] = {{
+        "abcdef", "efg", "abcdefg"
+    }, {
+        "abcd", "efg", "abcdefg"
+    }, {
+        "ab", "cdefg", "abcdefg"
+    }, {
+        "ab", "abcdefg", "abcdefg"
+    }, {
+        "a", "abcdefg", "abcdefg"
+    }, {
+        "", "abcdefg", "abcdefg"
+    }, {
+        "abcdefg", "", "abcdefg"
+    }, {
+        "abcdefg", "efg", "abcdefg"
+    }};
+
+    struct buf buf = BUF_INITIALIZER;
+
+    size_t i;
+    for (i = 0; i < sizeof(testcases) / sizeof(testcases[0]); i++) {
+        struct testcase tc = testcases[i];
+        buf_setcstr(&buf, tc.buf);
+        buf_appendoverlap(&buf, tc.str);
+        CU_ASSERT_STRING_EQUAL(tc.want, buf_cstring(&buf));
+        buf_reset(&buf);
+    }
+    buf_free(&buf);
+}
 
+static void test_tocrlf(void)
+{
+    struct testcase {
+        char *input;
+        char *expect;
+    };
+
+    struct testcase testcases[] = {
+        { "\rleading bare cr", "\r\nleading bare cr" },
+        { "\nleading bare lf", "\r\nleading bare lf" },
+        { "\r\nleading crlf", "\r\nleading crlf" },
+        { "bare\rcr", "bare\r\ncr" },
+        { "bare\nlf", "bare\r\nlf" },
+        { "correct\r\ncrlf", "correct\r\ncrlf" },
+        { "trailing bare cr\r", "trailing bare cr\r\n" },
+        { "trailing bare lf\n", "trailing bare lf\r\n" },
+        { "trailing crlf\r\n", "trailing crlf\r\n" },
+        { "multiple\rbare\rcr", "multiple\r\nbare\r\ncr" },
+        { "multiple\nbare\nlf", "multiple\r\nbare\r\nlf" },
+        { "multiple\r\ncrlf\r\n", "multiple\r\ncrlf\r\n" },
+        { "mixed cr\rand\nlf", "mixed cr\r\nand\r\nlf" },
+        { "mixed bare\rcr, bare\nlf and\r\ncrlf",
+           "mixed bare\r\ncr, bare\r\nlf and\r\ncrlf" },
+        { "adjacent\r\rbare cr", "adjacent\r\n\r\nbare cr" },
+        { "adjacent\n\nbare lf", "adjacent\r\n\r\nbare lf" },
+        { "adjacent\r\n\r\ncrlf", "adjacent\r\n\r\ncrlf" },
+        { "more adjacent\r\r\rbare cr", "more adjacent\r\n\r\n\r\nbare cr" },
+        { "more adjacent\n\n\nbare lf", "more adjacent\r\n\r\n\r\nbare lf" },
+        { "more adjacent\r\n\r\n\r\ncrlf", "more adjacent\r\n\r\n\r\ncrlf" },
+        { "adjacent\n\nbare\r\rmixed", "adjacent\r\n\r\nbare\r\n\r\nmixed" },
+        { "tricksy\r\r\n\nsplit", "tricksy\r\n\r\n\r\nsplit" },
+    };
+
+    struct buf buf = BUF_INITIALIZER;
+    size_t i;
+    for (i = 0; i < sizeof(testcases) / sizeof(testcases[0]); i++) {
+        struct testcase tc = testcases[i];
+        buf_setcstr(&buf, tc.input);
+        buf_tocrlf(&buf);
+        CU_ASSERT_STRING_EQUAL(tc.expect, buf_cstring(&buf));
+        buf_reset(&buf);
+    }
+    buf_free(&buf);
+}
 
 /* TODO: test the Copy-On-Write feature of buf_ensure()...if anyone
  * actually uses it */
diff -pruN 3.0.13-5/cunit/byteorder64.testc 3.2.0-3/cunit/byteorder64.testc
--- 3.0.13-5/cunit/byteorder64.testc	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/cunit/byteorder64.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,33 +1,33 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "byteorder64.h"
 
-union align64 {
-    uint64_t i64;
-    char buf[8];
-};
-
 static void test_byteorder(void)
 {
-    union align64 source;
-    union align64 result;
+    uint64_t src64;
+    uint32_t src32;
+    uint64_t res64;
+    uint32_t res32;
+    char buf[8];
 
-    source.buf[0] = 0;
-    source.buf[1] = 0;
-    source.buf[2] = 0;
-    source.buf[3] = 0;
-    source.buf[4] = 0;
-    source.buf[5] = 0;
-    source.buf[6] = 0;
-    source.buf[7] = 1;
+    buf[0] = 0;
+    buf[1] = 0;
+    buf[2] = 0;
+    buf[3] = 0;
+    buf[4] = 0;
+    buf[5] = 0;
+    buf[6] = 0;
+    buf[7] = 1;
+    memcpy(&src64, buf, 8);
+    memcpy(&src32, buf+4, 4);
 
     /* test 64 bit */
-    CU_ASSERT_EQUAL(ntohll(*((uint64_t *)(source.buf))), 1);
-    *((uint64_t *)result.buf) = htonll(1);
-    CU_ASSERT_EQUAL(memcmp(result.buf, source.buf, 8), 0);
+    CU_ASSERT_EQUAL(ntohll(src64), 1);
+    res64 = htonll(1);
+    CU_ASSERT_EQUAL(memcmp(&res64, &src64, 8), 0);
 
     /* test 32 bit */
-    CU_ASSERT_EQUAL(ntohl(*((uint32_t *)(source.buf+4))), 1);
-    *((uint32_t *)(result.buf)) = htonl(1);
-    CU_ASSERT_EQUAL(memcmp(result.buf, source.buf+4, 4), 0);
+    CU_ASSERT_EQUAL(ntohl(src32), 1);
+    res32 = htonl(1);
+    CU_ASSERT_EQUAL(memcmp(&res32, &src32, 4), 0);
 }
 
diff -pruN 3.0.13-5/cunit/charset.testc 3.2.0-3/cunit/charset.testc
--- 3.0.13-5/cunit/charset.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/charset.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 #include <stdlib.h>
 
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "charset.h"
 
 extern int charset_debug;
@@ -12,22 +12,18 @@ extern int charset_debug;
 
 static void test_lookupname(void)
 {
-    charset_t cs, cs2;
+    charset_t cs;
 
     /* us-ascii must exist */
     cs = charset_lookupname("us-ascii");
     CU_ASSERT_PTR_NOT_NULL(cs);
+    charset_free(&cs);
 
     /* names are case-insensitive */
-    cs2 = charset_lookupname("US-ASCII");
-    CU_ASSERT_PTR_NOT_NULL(cs2);
-    CU_ASSERT_STRING_EQUAL(charset_name(cs), charset_name(cs2));
-    charset_free(&cs2);
-
-    cs2 = charset_lookupname("Us-AsCiI");
-    CU_ASSERT_PTR_NOT_NULL(cs2);
-    CU_ASSERT_STRING_EQUAL(charset_name(cs), charset_name(cs2));
-    charset_free(&cs2);
+    cs = charset_lookupname("US-ASCII");
+    CU_ASSERT_PTR_NOT_NULL(cs);
+    CU_ASSERT_STRING_EQUAL("us-ascii", charset_canon_name(cs));
+    CU_ASSERT_STRING_EQUAL("US-ASCII", charset_alias_name(cs));
     charset_free(&cs);
 
     /* some others must also exist */
@@ -41,6 +37,8 @@ static void test_lookupname(void)
 
     cs = charset_lookupname("iso-8859-1");
     CU_ASSERT_PTR_NOT_NULL(cs);
+    CU_ASSERT_STRING_EQUAL("windows-1252", charset_canon_name(cs));
+    CU_ASSERT_STRING_EQUAL("iso-8859-1", charset_alias_name(cs));
     charset_free(&cs);
 
     /*
@@ -49,20 +47,22 @@ static void test_lookupname(void)
      */
     cs = charset_lookupname("windows-1252");
     CU_ASSERT_PTR_NOT_NULL(cs);
-    CU_ASSERT_STRING_EQUAL(charset_name(cs), "windows-1252");
+    CU_ASSERT_STRING_EQUAL("windows-1252", charset_canon_name(cs));
+    CU_ASSERT_STRING_EQUAL("windows-1252", charset_alias_name(cs));
     charset_free(&cs);
 
     cs = charset_lookupname("1252");
     CU_ASSERT_PTR_NOT_NULL(cs);
-    CU_ASSERT_STRING_EQUAL(charset_name(cs), "windows-1252");
+    CU_ASSERT_STRING_EQUAL("windows-1252", charset_canon_name(cs));
+    CU_ASSERT_STRING_EQUAL("1252", charset_alias_name(cs));
     charset_free(&cs);
 
-    /* But still use the ICU name if there's no good alias for it */
+    /* But still use the ICU name if there's no Cyrus canon name */
     cs = charset_lookupname("ebcdic-ar");
     CU_ASSERT_PTR_NOT_NULL(cs);
-    CU_ASSERT_STRING_EQUAL(charset_name(cs), "ibm-16804_X110-1999");
+    CU_ASSERT_STRING_EQUAL("ibm-16804_X110-1999", charset_canon_name(cs));
+    CU_ASSERT_STRING_EQUAL("ebcdic-ar", charset_alias_name(cs));
     charset_free(&cs);
-
 }
 
 static void test_to_utf8(void)
@@ -218,6 +218,43 @@ static void test_misc_charsets(void)
                        "\xD1\x94\xD1\x96\xD1\x97\xD2\x91"
                        "\xD0\x84\xD0\x86\xD0\x87\xD2\x90");
 
+    /* iso-8859-1 aliased to windows-1252. */
+    /* They differ in the range 0x80 to 0x9f, where iso-8859-1
+       has control chars that are mostly useless for emails.
+       windows-1252 encoding has visible characters in that range. */
+    TESTCASE("iso-8859-1", "\x80", "\xe2\x82\xac"); // Euro sign
+    TESTCASE("iso-8859-1", "\x81", "\xc2\x81"); // Unassigned
+    TESTCASE("iso-8859-1", "\x82", "\xe2\x80\x9a"); // Single Low-9 Quotation Mark
+    TESTCASE("iso-8859-1", "\x83", "\xc6\x92"); // Latin Small Letter F With Hook
+    TESTCASE("iso-8859-1", "\x84", "\xe2\x80\x9e"); // Double Low-9 Quotation Mark
+    TESTCASE("iso-8859-1", "\x85", "\xe2\x80\xa6"); // Horizontal Ellipsis
+    TESTCASE("iso-8859-1", "\x86", "\xe2\x80\xa0"); // Dagger
+    TESTCASE("iso-8859-1", "\x87", "\xe2\x80\xa1"); // Double Dagger
+    TESTCASE("iso-8859-1", "\x88", "\xcb\x86"); // Modifier Letter Circumflex Accent
+    TESTCASE("iso-8859-1", "\x89", "\xe2\x80\xb0"); // Per Mille Sign
+    TESTCASE("iso-8859-1", "\x8a", "\xc5\xa0"); // Latin Capital Letter S With Caron
+    TESTCASE("iso-8859-1", "\x8b", "\xe2\x80\xb9"); // Single Left-Pointing Angle Quotation Mark
+    TESTCASE("iso-8859-1", "\x8c", "\xc5\x92"); // Latin Capital Ligature OE
+    TESTCASE("iso-8859-1", "\x8d", "\xc2\x8d"); // Unassigned
+    TESTCASE("iso-8859-1", "\x8e", "\xc5\xbd"); // Latin Capital Letter Z With Caron
+    TESTCASE("iso-8859-1", "\x8f", "\xc2\x8f"); // Unassigned
+    TESTCASE("iso-8859-1", "\x90", "\xc2\x90"); // Unassigned
+    TESTCASE("iso-8859-1", "\x91", "\xe2\x80\x98"); // Left Single Quotation Mark
+    TESTCASE("iso-8859-1", "\x92", "\xe2\x80\x99"); // Right Single Quotation Mark
+    TESTCASE("iso-8859-1", "\x93", "\xe2\x80\x9c"); // Left Double Quotation Mark
+    TESTCASE("iso-8859-1", "\x94", "\xe2\x80\x9d"); // Right Double Quotation Mark
+    TESTCASE("iso-8859-1", "\x95", "\xe2\x80\xa2"); // Bullet
+    TESTCASE("iso-8859-1", "\x96", "\xe2\x80\x93"); // En Dash
+    TESTCASE("iso-8859-1", "\x97", "\xe2\x80\x94"); // Em Dash
+    TESTCASE("iso-8859-1", "\x98", "\xcb\x9c"); // Small Tilde
+    TESTCASE("iso-8859-1", "\x99", "\xe2\x84\xa2"); // Trade Mark Sign
+    TESTCASE("iso-8859-1", "\x9a", "\xc5\xa1"); // Latin Small Letter S With Caron
+    TESTCASE("iso-8859-1", "\x9b", "\xe2\x80\xba"); // Single Right-Pointing Angle Quotation Mark
+    TESTCASE("iso-8859-1", "\x9c", "\xc5\x93"); // Latin Small Ligature OE
+    TESTCASE("iso-8859-1", "\x9d", "\xc2\x9d"); // Unassigned
+    TESTCASE("iso-8859-1", "\x9e", "\xc5\xbe"); // Latin Small Letter Z With Caron
+    TESTCASE("iso-8859-1", "\x9f", "\xc5\xb8"); // Latin Capital Letter Y With Diaeresis
+
 #undef TESTCASE
 }
 
@@ -271,7 +308,7 @@ static void test_encode_mimeheader(void)
     { \
         static const char _in[] = (in); \
         static const char _exp[] = (exp); \
-        char *s = charset_encode_mimeheader(_in, 0); \
+        char *s = charset_encode_mimeheader(_in, 0, 0); \
         CU_ASSERT_PTR_NOT_NULL(s); \
         CU_ASSERT_STRING_EQUAL(s, _exp); \
         const char *p, *lf; \
@@ -297,12 +334,12 @@ static void test_encode_mimeheader(void)
 
     /* three-byte UTF-8 word barely fits line length limit */
     TESTCASE("0123456789012345678901234567890123456789012345678901234\xe2\x82\xac",
-            "=?UTF-8?Q?0123456789012345678901234567890123456789012345678901234=E2=82=AC?=");
+             "=?UTF-8?Q?0123456789012345678901234567890123456789012345678901234=E2=82=AC?=");
 
     /* three-byte UTF-8 word must not be split */
     TESTCASE("01234567890123456789012345678901234567890123456789012345\xe2\x82\xac",
-            "=?UTF-8?Q?01234567890123456789012345678901234567890123456789012345?="
-            "\r\n ""=?UTF-8?Q?=E2=82=AC?=");
+             "=?UTF-8?Q?01234567890123456789012345678901234567890123456789012345?="
+             "\r\n ""=?UTF-8?Q?=E2=82=AC?=");
 
 #undef TESTCASE
 }
@@ -311,6 +348,8 @@ static void test_encode_mimeheader(void)
 static void test_decode_mimeheader(void)
 {
     char *s;
+    static const char ERR_1[] = "=?ISO-8859-1?B?SWYgeW91IGNhbiByZWFkIHRoaXMgeW8=?= =?ISO-8859-2?B?dSB1bmRlcnN0YW5kIHRoZSBleGFtcGxlLg==?=";
+    static const char EXP_1[]= "IF YOU CAN READ THIS YOU UNDERSTAND THE EXAMPLE.";
     static const char ASCII_1[] = "Lorem IPSUM dolor \t \t  sit amet";
     static const char SEARCH_1[] = "LOREM IPSUM DOLOR SIT AMET";
     static const char ASCII_B64_2[] = "Lorem =?us-ascii?q?ipsum?= dolor "
@@ -343,6 +382,11 @@ static void test_decode_mimeheader(void)
     CU_ASSERT_STRING_EQUAL(s, SEARCH_1);
     free(s);
 
+    s = charset_decode_mimeheader(ERR_1, flags);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, EXP_1);
+    free(s);
+
     s = charset_decode_mimeheader(ASCII_B64_2, flags);
     CU_ASSERT_PTR_NOT_NULL(s);
     CU_ASSERT_STRING_EQUAL(s, SEARCH_1);
@@ -389,13 +433,13 @@ static void test_decode_mimeheader(void)
     CU_ASSERT_STRING_EQUAL(s, HTML_4b);
     free(s);
 
-    flags = CHARSET_SNIPPET;
+    flags = CHARSET_KEEPCASE;
     s = charset_decode_mimeheader(HTML_4, flags);
     CU_ASSERT_PTR_NOT_NULL(s);
     CU_ASSERT_STRING_EQUAL(s, HTML_4c);
     free(s);
 
-    flags = CHARSET_SNIPPET|CHARSET_ESCAPEHTML;
+    flags = CHARSET_KEEPCASE|CHARSET_ESCAPEHTML;
     s = charset_decode_mimeheader(HTML_4, flags);
     CU_ASSERT_PTR_NOT_NULL(s);
     CU_ASSERT_STRING_EQUAL(s, HTML_4d);
@@ -480,6 +524,97 @@ static void test_mimeheader_badcharset(v
     free(s);
 }
 
+static void test_mimeheader_mergeqwords(void)
+{
+    int flags = CHARSET_SKIPDIACRIT | CHARSET_MERGESPACE | CHARSET_KEEPCASE;
+
+    static const char SPLIT_Q[] = "=?utf-8?q?=E2=82?= =?utf-8?q?=AC?=";
+    static const char SPLIT_B[] = "=?utf-8?b?wg==?= =?utf-8?b?oUhvbGEsc2XD?= =?utf-8?b?sW9yIQ==?=";
+
+    static const char REGRESSION_Q[] = "=?utf-8?q?=C2=A1Hola,?=  =?utf-8?q?se=C3=B1or!?=";
+    static const char REGRESSION_B[] = "=?utf-8?b?wqFIb2xhLA==?=  =?utf-8?b?c2XDsW9yIQ==?=";
+
+    char *s = charset_decode_mimeheader(SPLIT_Q, flags);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "\xe2\x82\xac");
+    free(s);
+
+    s = charset_decode_mimeheader(SPLIT_B, flags);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "¡Hola,señor!");
+    free(s);
+
+    s = charset_decode_mimeheader(REGRESSION_Q, flags);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "¡Hola,señor!");
+    free(s);
+
+    s = charset_decode_mimeheader(REGRESSION_B, flags);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "¡Hola,señor!");
+    free(s);
+}
+
+static void test_parse_mimexvalue(void)
+{
+    char *s;
+    struct buf lang = BUF_INITIALIZER;
+    static const char SIMPLE[] = "utf-8'en'foo";
+    static const char OCTETS[] = "utf-8''%F0%9F%98%80";
+    static const char LATIN1[] = "iso-8859-1'de'R%e4tsel";
+
+    s = charset_parse_mimexvalue(NULL, NULL);
+    CU_ASSERT_PTR_NULL(s);
+    free(s);
+
+    s = charset_parse_mimexvalue("foo", NULL);
+    CU_ASSERT_PTR_NULL(s);
+
+    s = charset_parse_mimexvalue(SIMPLE, &lang);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "foo");
+    CU_ASSERT_STRING_EQUAL(buf_cstring(&lang), "en");
+    buf_reset(&lang);
+    free(s);
+
+    s = charset_parse_mimexvalue(OCTETS, NULL);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "\xf0\x9f\x98\x80");
+    free(s);
+
+    s = charset_parse_mimexvalue(LATIN1, &lang);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "Rätsel");
+    CU_ASSERT_STRING_EQUAL(buf_cstring(&lang), "de");
+    buf_reset(&lang);
+    free(s);
+
+    buf_free(&lang);
+}
+
+static void test_encode_mimexvalue(void)
+{
+    char *s;
+
+    s = charset_encode_mimexvalue(NULL, NULL);
+    CU_ASSERT_PTR_NULL(s);
+
+    s = charset_encode_mimexvalue("foo", NULL);
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "utf-8''foo");
+    free(s);
+
+    s = charset_encode_mimexvalue("foo", "en");
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "utf-8'en'foo");
+    free(s);
+
+    s = charset_encode_mimexvalue("R\xc3\xe4tsel", "de");
+    CU_ASSERT_PTR_NOT_NULL(s);
+    CU_ASSERT_STRING_EQUAL(s, "utf-8'de'R%C3%E4tsel");
+    free(s);
+}
+
 static void test_unfold(void)
 {
 #define TESTCASE(in, wantSkip, wantKeep) \
@@ -979,19 +1114,19 @@ static void test_extract(void)
     TESTCASE("A&nonesuch;B", "us-ascii", ENCODING_NONE, "HTML", "A"UTF8_REPLACEMENT"B");
 
     /* HTML: Strip HTML from snippet and don't canonify */
-    flags = CHARSET_SNIPPET;
+    flags = CHARSET_KEEPCASE;
     TESTCASE("<b>Photo</b> <em>booth</em>", "us-ascii", ENCODING_NONE, "HTML", "Photo booth");
 
     /* HTML: Strip HTML from snippet, there is nothing to escape */
-    flags = CHARSET_SNIPPET|CHARSET_ESCAPEHTML;
+    flags = CHARSET_KEEPCASE|CHARSET_ESCAPEHTML;
     TESTCASE("<b>Photo</b>", "us-ascii", ENCODING_NONE, "HTML", "Photo");
 
     /* PLAIN: Generate snippet, don't escape HTML by default */
-    flags = CHARSET_SNIPPET;
+    flags = CHARSET_KEEPCASE;
     TESTCASE("<b>Photo</b>", "us-ascii", ENCODING_NONE, "PLAIN", "<b>Photo</b>");
 
     /* PLAIN: Generate snippet with escaped HTML */
-    flags = CHARSET_SNIPPET|CHARSET_ESCAPEHTML;
+    flags = CHARSET_KEEPCASE|CHARSET_ESCAPEHTML;
     TESTCASE("<b>Photo</b>", "us-ascii", ENCODING_NONE, "PLAIN", "&lt;b&gt;Photo&lt;/b&gt;");
 }
 #undef TESTCASE
@@ -1068,6 +1203,144 @@ static void test_charset_decode(void)
     TESTCASE("Hello", 5, "Hello", 5, ENCODING_NONE);
     TESTCASE("beefc0de", 8, "\x6d\xe7\x9f\x73\x47\x5e", 6, ENCODING_BASE64);
 
+    /* RFC 4648 examples */
+    TESTCASE("Zg==", 4, "f", 1, ENCODING_BASE64);
+    TESTCASE("Zm8=", 4, "fo", 2, ENCODING_BASE64);
+    TESTCASE("Zm9v", 4, "foo", 3, ENCODING_BASE64);
+    TESTCASE("Zm9vYg==", 8, "foob", 4, ENCODING_BASE64);
+    TESTCASE("Zm9vYmE=", 8, "fooba", 5, ENCODING_BASE64);
+    TESTCASE("Zm9vYmFy", 8, "foobar", 6, ENCODING_BASE64);
+
+#undef TESTCASE
+}
+
+static void test_broken_length_hint(void)
+{
+    charset_t cs;
+    char *s;
+    const char *body = "x.x&gt;x:";
+
+    cs = charset_lookupname("iso-8859-1");
+    CU_ASSERT_PTR_NOT_NULL(cs);
+
+    s = charset_to_utf8(body, strlen(body), cs, ENCODING_QP);
+    CU_ASSERT_STRING_EQUAL(body, s);
+    charset_free(&cs);
+}
+
+static void test_utf8_normalize(void)
+{
+#define TESTCASE(in, want) \
+    { \
+        char *s; \
+        s = charset_utf8_normalize(in); \
+        if (want) { \
+            CU_ASSERT_PTR_NOT_NULL(s); \
+            CU_ASSERT_STRING_EQUAL(s, want); \
+        } else { \
+            CU_ASSERT_PTR_NULL(s); \
+        } \
+        free(s); \
+    }
+
+    /* Empty is empty */
+    TESTCASE("\0", "\0");
+
+    /* Plain ASCII */
+    TESTCASE("Hello, World", "Hello, World");
+
+    /* The following examples are from
+     * http://www.unicode.org/reports/tr15/#Examples */
+
+    /*
+     * ANGSTROM SIGN (U+212B)
+     * to
+     * LATIN CAPITAL LETTER A WITH RING ABOVE (U+00C5)
+     */
+    TESTCASE("\xe2\x84\xab", "\xc3\x85");
+
+    /*
+     * Multiple Combining Marks:
+     * LATIN SMALL LETTER Q (U+0071)
+     * COMBINING DOT ABOVE (U+0307)
+     * COMBINING DOT BELOW (U+0323)
+     * to
+     * LATIN SMALL LETTER Q (U+0071)
+     * COMBINING DOT BELOW (U+0323)
+     * COMBINING DOT ABOVE (U+0307)
+     */
+    TESTCASE("\x71\xcc\x87\xcc\xa3", "\x71\xcc\xa3\xcc\x87");
+
+#undef TESTCASE
+}
+
+static void test_count_validutf8(void)
+{
+    /* These tests are specific for the charset implementation in Cyrus.
+     * Breaking them is not necessarily an error, but check carefully.
+     *
+     * Example byte sequences are taken from
+     *    https://www.cl.cam.ac.uk/~mgk25/ucs/examples/UTF-8-test.txt
+     * licensed as
+     *    Markus Kuhn, CC BY 4.0 (https://creativecommons.org/licenses/by/4.0/)
+     */
+
+    const char *data;
+    struct char_counts counts;
+
+    /* Correct UTF-8 text */
+    data = "\xce\xba\xe1\xbd\xb9\xcf\x83\xce\xbc\xce\xb5";
+    counts = charset_count_validutf8(data, strlen(data));
+    CU_ASSERT_EQUAL(5, counts.valid);
+    CU_ASSERT_EQUAL(0, counts.replacement);
+    CU_ASSERT_EQUAL(0, counts.invalid);
+
+    /* Two continuation bytes */
+    data = "a \x80\xbf\x80 text";
+    counts = charset_count_validutf8(data, strlen(data));
+    CU_ASSERT_EQUAL(7, counts.valid);
+    CU_ASSERT_EQUAL(0, counts.replacement);
+    CU_ASSERT_EQUAL(3, counts.invalid);
+
+    /* Lonely start character, followed by 3-byte char, plus replacement char */
+    data = "\xfc\xe2\x82\xac \xef\xbf\xbd";
+    counts = charset_count_validutf8(data, strlen(data));
+    CU_ASSERT_EQUAL(2, counts.valid);
+    CU_ASSERT_EQUAL(1, counts.replacement);
+    CU_ASSERT_EQUAL(1, counts.invalid);
+}
+
+static void test_qpencode_mimebody(void)
+{
+#define TESTCASE(in, want, force_quote) \
+    { \
+        size_t outlen; \
+        const char *_in = (in); \
+        const char *_want = (want); \
+        char *out = charset_qpencode_mimebody(_in, strlen(_in), (force_quote), &outlen); \
+        CU_ASSERT_STRING_EQUAL(_want, out); \
+        CU_ASSERT_EQUAL(strlen(_want), outlen); \
+        free(out); \
+    }
+
+    /* Basic test */
+    TESTCASE("foo", "foo", 0);
+    TESTCASE("foo", "foo", 1);
+
+    /* Assert stray LFs are encoded */
+    TESTCASE("foo\nbar", "foo=0Abar", 0);
+    TESTCASE("foo\nbar", "foo=0Abar", 1);
+
+    /* Long lines are broken regardless of quote-forcing */
+    TESTCASE("0123456789" "0123456789" "0123456789" "0123456789"
+             "0123456789" "0123456789" "0123456789" "0123456789",
+             "0123456789" "0123456789" "0123456789" "0123456789"
+             "0123456789" "0123456789" "0123456789" "01=\r\n23456789", 0);
+    TESTCASE("0123456789" "0123456789" "0123456789" "0123456789"
+             "0123456789" "0123456789" "0123456789" "0123456789",
+             "0123456789" "0123456789" "0123456789" "0123456789"
+             "0123456789" "0123456789" "0123456789" "01=\r\n23456789", 1);
+
 #undef TESTCASE
 }
 
diff -pruN 3.0.13-5/cunit/command.testc 3.2.0-3/cunit/command.testc
--- 3.0.13-5/cunit/command.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/command.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 #include "config.h"
 #include <stdio.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include <sys/stat.h>
 #include "command.h"
 
@@ -33,7 +33,7 @@ static void test_popen_r(void)
     struct command *cmd = NULL;
     char buf[32];
 
-    r = command_popen(&cmd, "r", "/bin/echo", WORD0, NULL);
+    r = command_popen(&cmd, "r", NULL, "/bin/echo", WORD0, NULL);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(cmd);
     CU_ASSERT_PTR_NULL_FATAL(cmd->stdin_prot);
@@ -65,7 +65,7 @@ static void test_popen_w(void)
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     snprintf(buf, sizeof(buf), "cat > %s", canary);
-    r = command_popen(&cmd, "w", "/bin/sh", "-c", buf, NULL);
+    r = command_popen(&cmd, "w", NULL, "/bin/sh", "-c", buf, NULL);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(cmd);
     CU_ASSERT_PTR_NOT_NULL_FATAL(cmd->stdin_prot);
@@ -98,7 +98,7 @@ static void test_popen_rw(void)
     struct command *cmd = NULL;
     char buf[32];
 
-    r = command_popen(&cmd, "rw", "/usr/bin/tr", "a-z", "A-Z", NULL);
+    r = command_popen(&cmd, "rw", NULL, "/usr/bin/tr", "a-z", "A-Z", NULL);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(cmd);
     CU_ASSERT_PTR_NOT_NULL_FATAL(cmd->stdin_prot);
diff -pruN 3.0.13-5/cunit/conversations.testc 3.2.0-3/cunit/conversations.testc
--- 3.0.13-5/cunit/conversations.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/conversations.testc	2020-05-04 03:28:02.000000000 +0000
@@ -1,7 +1,7 @@
 #if HAVE_CONFIG_H
 #include <config.h>
 #endif
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/conversations.h"
 #include "imap/global.h"
 #include "strarray.h"
@@ -21,7 +21,7 @@ static void test_open(void)
     int r;
     struct conversations_state *state = NULL;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     r = conversations_abort(&state);
@@ -37,7 +37,7 @@ static void test_getset(void)
     conversation_id_t cid;
     arrayu64_t cids = ARRAYU64_INITIALIZER;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Database is empty, so get should succeed and report no results */
@@ -61,7 +61,7 @@ static void test_getset(void)
     r = conversations_commit(&state);
     CU_ASSERT_EQUAL(r, 0);
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* get should still succeed after the db is closed & reopened */
@@ -86,7 +86,7 @@ static void test_abort(void)
     conversation_id_t cid;
     arrayu64_t cids = ARRAYU64_INITIALIZER;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Database is empty, so get should succeed and report no results */
@@ -112,7 +112,7 @@ static void test_abort(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* the set vanished with the txn abort, so get should
@@ -146,7 +146,7 @@ static void test_prune(void)
     arrayu64_t cids = ARRAYU64_INITIALIZER;
     unsigned int nseen = 0, ndeleted = 0;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Add keys, with delays in between */
@@ -173,7 +173,7 @@ static void test_prune(void)
 
     /* Should be able to get all 3 msgids */
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     memset(&cid, 0x45, sizeof(cid));
@@ -246,10 +246,10 @@ static void test_two(void)
     conversation_id_t cid;
     arrayu64_t cids = ARRAYU64_INITIALIZER;
 
-    r = conversations_open_path(DBNAME, &state1);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state1);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
-    r = conversations_open_path(DBNAME2, &state2);
+    r = conversations_open_path(DBNAME2, NULL, 0/*shared*/, &state2);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Databases are empty, so gets of either msgid from either db
@@ -384,7 +384,7 @@ static void test_folder_rename(void)
     conversation_t *conv;
     conv_folder_t *folder;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL_FATAL(state);
 
@@ -396,19 +396,25 @@ static void test_folder_rename(void)
     r = conversations_add_msgid(state, C_MSGID3, C_CID);
     CU_ASSERT_EQUAL(r, 0);
 
-    conv = conversation_new(state);
+    conv = conversation_new();
     CU_ASSERT_PTR_NOT_NULL(conv);
 
-    conversation_update(state, conv, FOLDER1, /*num_records*/3,
+    conversation_update(state, conv, FOLDER1,
+                        /*is_trash*/0, /*num_records*/3,
                         /*exists*/3, /*unseen*/0,
                         /*size*/0, /*counts*/NULL,
-                        /*modseq*/1);
-    conversation_update(state, conv, FOLDER2, /*num_records*/3,
+                        /*modseq*/1,
+                        /*createdmodseq*/1);
+    conversation_update(state, conv, FOLDER2,
+                        /*is_trash*/0, /*num_records*/3,
                         /*exists*/2, /*unseen*/0,
                         /*size*/0, /*counts*/NULL,
-                        /*modseq*/8);
+                        /*modseq*/8,
+                        /*createdmodseq*/1);
 
-    r = conversation_save(state, C_CID, conv);
+    conv->subject = xstrdup("☃");
+
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
 
     conversation_free(conv);
@@ -419,7 +425,7 @@ static void test_folder_rename(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* do a rename */
@@ -431,7 +437,7 @@ static void test_folder_rename(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     conv = NULL;
@@ -450,6 +456,7 @@ static void test_folder_rename(void)
     folder = conversation_find_folder(state, conv, FOLDER3);
     CU_ASSERT_PTR_NOT_NULL_FATAL(folder);
     CU_ASSERT_EQUAL(folder->exists, 2);
+    CU_ASSERT_STRING_EQUAL(conv->subject, "☃");
     conversation_free(conv);
     conv = NULL;
 
@@ -474,7 +481,7 @@ static void test_folders(void)
     /* hack to get this DB created with a counted_strings value */
     imapopts[IMAPOPT_CONVERSATIONS_COUNTED_FLAGS].val.s = "\\Draft $HasRandom";
 
-    r = conversations_open_path(DBNAME3, &state);
+    r = conversations_open_path(DBNAME3, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     imapopts[IMAPOPT_CONVERSATIONS_COUNTED_FLAGS].val.s = NULL;
@@ -490,17 +497,19 @@ static void test_folders(void)
     CU_ASSERT_PTR_NULL(conv);
 
     /* update should succeed */
-    conv = conversation_new(state);
+    conv = conversation_new();
     CU_ASSERT_PTR_NOT_NULL(conv);
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
 
     counts[0] = 1;
     counts[1] = 0;
 
-    conversation_update(state, conv, FOLDER1, /*num_records*/13,
+    conversation_update(state, conv, FOLDER1,
+                        /*is_trash*/0, /*num_records*/13,
                         /*exists*/7, /*unseen*/5,
                         /*size*/0, counts,
-                        /*modseq*/4);
+                        /*modseq*/4,
+                        /*createdmodseq*/1);
 
     /* make sure the data we just passed to conversation_update()
      * is present in the structure */
@@ -516,7 +525,7 @@ static void test_folders(void)
     CU_ASSERT_EQUAL(folder->num_records, 13);
     CU_ASSERT_EQUAL(folder->exists, 7);
     CU_ASSERT_EQUAL(folder->modseq, 4);
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
     folder = conversation_find_folder(state, conv, FOLDER2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER3);
@@ -526,7 +535,7 @@ static void test_folders(void)
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
 
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
     conversation_free(conv);
     conv = NULL;
@@ -534,7 +543,7 @@ static void test_folders(void)
     /* get should now succeed and report the value we gave it */
     conv = NULL;
     r = conversation_load(state, C_CID, &conv);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(conv);
     CU_ASSERT_EQUAL(conv->num_records, 13);
@@ -549,7 +558,7 @@ static void test_folders(void)
     CU_ASSERT_EQUAL(folder->num_records, 13);
     CU_ASSERT_EQUAL(folder->exists, 7);
     CU_ASSERT_EQUAL(folder->modseq, 4);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     folder = conversation_find_folder(state, conv, FOLDER2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER3);
@@ -561,12 +570,14 @@ static void test_folders(void)
 
     counts[1] = 2;
     /* some more updates should succeed */
-    conversation_update(state, conv, FOLDER2,/*num_records*/2,
+    conversation_update(state, conv, FOLDER2,
+                        /*is_trash*/0, /*num_records*/2,
                         /*exists*/1, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/7);
+                        /*modseq*/7,
+                        /*createdmodseq*/1);
 
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
     CU_ASSERT_EQUAL(conv->num_records, 15);
     CU_ASSERT_EQUAL(conv->exists, 8);
     CU_ASSERT_EQUAL(conv->unseen, 5);
@@ -593,12 +604,14 @@ static void test_folders(void)
 
 
     counts[1] = 5;
-    conversation_update(state, conv, FOLDER3,/*num_records*/10,
+    conversation_update(state, conv, FOLDER3,
+                        /*is_trash*/0, /*num_records*/10,
                         /*exists*/10, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/55);
+                        /*modseq*/55,
+                        /*createdmodseq*/1);
 
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
     CU_ASSERT_EQUAL(conv->num_records, 25);
     CU_ASSERT_EQUAL(conv->exists, 18);
     CU_ASSERT_EQUAL(conv->unseen, 5);
@@ -626,9 +639,9 @@ static void test_folders(void)
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
 
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     conversation_free(conv);
     conv = NULL;
 
@@ -663,7 +676,7 @@ static void test_folders(void)
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     conversation_free(conv);
     conv = NULL;
 
@@ -671,7 +684,7 @@ static void test_folders(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME3, &state);
+    r = conversations_open_path(DBNAME3, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* get should still succeed and report all values we gave it */
@@ -705,15 +718,17 @@ static void test_folders(void)
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
 
     /* decrementing a folder down to zero */
     counts[0] = -1;
     counts[1] = 0;
-    conversation_update(state, conv, FOLDER1,/*num_records*/-13,
+    conversation_update(state, conv, FOLDER1,
+                        /*is_trash*/0, /*num_records*/-13,
                         /*exists*/-7, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/56);
+                        /*modseq*/56,
+                        /*createdmodseq*/1);
 
     CU_ASSERT_EQUAL(conv->num_records, 12);
     CU_ASSERT_EQUAL(conv->exists, 11);
@@ -742,12 +757,12 @@ static void test_folders(void)
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
 
     /* folder goes away properly when saved & re-loaded */
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     conversation_free(conv);
     conv = NULL;
 
@@ -779,7 +794,7 @@ static void test_folders(void)
     CU_ASSERT_PTR_NULL_FATAL(folder);
     folder = conversation_find_folder(state, conv, FOLDER_N2);
     CU_ASSERT_PTR_NULL_FATAL(folder);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
 
     conversation_free(conv);
     conv = NULL;
@@ -804,7 +819,7 @@ static void test_folder_ordering(void)
     conv_folder_t *folder3;
     int *counts = 0;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Database is empty, so get should succeed and report no results */
@@ -814,33 +829,37 @@ static void test_folder_ordering(void)
     CU_ASSERT_PTR_NULL(conv);
 
     /* update should succeed */
-    conv = conversation_new(state);
+    conv = conversation_new();
     CU_ASSERT_PTR_NOT_NULL(conv);
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
 
     /* set up the folder names in order - we are going to discard
      * this conversation, but the folder_number call will persist */
-    conversation_update(state, conv, FOLDER1, 0, 0, 0, 0, 0, 0);
-    conversation_update(state, conv, FOLDER2, 0, 0, 0, 0, 0, 0);
-    conversation_update(state, conv, FOLDER3, 0, 0, 0, 0, 0, 0);
+    conversation_update(state, conv, FOLDER1, 0, 0, 0, 0, 0, 0, 0, 0);
+    conversation_update(state, conv, FOLDER2, 0, 0, 0, 0, 0, 0, 0, 0);
+    conversation_update(state, conv, FOLDER3, 0, 0, 0, 0, 0, 0, 0, 0);
 
     /* discard and recreate */
     conversation_free(conv);
-    conv = conversation_new(state);
+    conv = conversation_new();
 
-    conversation_update(state, conv, FOLDER1, /*num_records*/1,
+    conversation_update(state, conv, FOLDER1,
+                        /*is_trash*/0, /*num_records*/1,
                         /*exists*/1, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/1);
+                        /*modseq*/1,
+                        /*createdmodseq*/0);
 
     /* add folders out of order */
-    conversation_update(state, conv, FOLDER3,/*num_records*/10,
+    conversation_update(state, conv, FOLDER3,
+                        /*is_trash*/0, /*num_records*/10,
                         /*exists*/10, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/55);
+                        /*modseq*/55,
+                        /*createdmodseq*/0);
 
     /* save and reload here just to be sure */
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
     conversation_free(conv);
     conv = NULL;
@@ -848,12 +867,14 @@ static void test_folder_ordering(void)
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(conv);
 
-    conversation_update(state, conv, FOLDER2,/*num_records*/2,
+    conversation_update(state, conv, FOLDER2,
+                        /*is_trash*/0, /*num_records*/2,
                         /*exists*/1, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/7);
+                        /*modseq*/7,
+                        /*createdmodseq*/0);
 
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
 
     /* check that they've been created in the same order */
     folder1 = conversation_find_folder(state, conv, FOLDER1);
@@ -869,15 +890,15 @@ static void test_folder_ordering(void)
     CU_ASSERT_PTR_EQUAL(folder2->next, folder3);
     CU_ASSERT_PTR_NULL(folder3->next);
 
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     conversation_free(conv);
     conv = NULL;
 
     /* get should now succeed and report the value we gave it */
     r = conversation_load(state, C_CID, &conv);
-    CU_ASSERT_EQUAL(conv->dirty, 0);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), 0);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(conv);
 
@@ -902,7 +923,7 @@ static void test_folder_ordering(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* get should still succeed and report all values we gave it */
@@ -955,7 +976,7 @@ static void __test_senders(void)
     conv_sender_t *sender3;
     int *counts = 0;
 
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* Database is empty, so get should succeed and report no results */
@@ -965,18 +986,20 @@ static void __test_senders(void)
     CU_ASSERT_PTR_NULL(conv);
 
     /* update should succeed */
-    conv = conversation_new(state);
+    conv = conversation_new();
     CU_ASSERT_PTR_NOT_NULL(conv);
-    CU_ASSERT_EQUAL(conv->dirty, 1);
+    CU_ASSERT_EQUAL((conv->flags & CONV_ISDIRTY), CONV_ISDIRTY);
 
     conversation_add_sender(conv, NAME1, NULL, MAILBOX1, DOMAIN1);
     conversation_add_sender(conv, NAME2, NULL, MAILBOX2, DOMAIN2);
     conversation_add_sender(conv, NAME3, NULL, MAILBOX3, DOMAIN3);
 
-    conversation_update(state, conv, FOLDER, /*num_records*/1,
+    conversation_update(state, conv, FOLDER,
+                        /*is_trash*/0, /*num_records*/1,
                         /*exists*/1, /*unseen*/0,
                         /*size*/0, counts,
-                        /*modseq*/1);
+                        /*modseq*/1,
+                        /*createdmodseq*/0);
 
     /* there's no function for getting sender data, oh well */
     sender1 = conv->senders;
@@ -1004,7 +1027,7 @@ static void __test_senders(void)
     CU_ASSERT_STRING_EQUAL(sender3->domain, DOMAIN2);
 
     /* save and reload here just to be sure */
-    r = conversation_save(state, C_CID, conv);
+    r = conversation_save(state, C_CID, conv, NULL);
     CU_ASSERT_EQUAL(r, 0);
     conversation_free(conv);
     conv = NULL;
@@ -1044,7 +1067,7 @@ static void __test_senders(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open the db again */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     /* get should still succeed and report all values we gave it */
@@ -1149,7 +1172,7 @@ static void test_dump(void)
     memset(&state, 0, sizeof(state));
 
     /* generate some data in the database */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     for (i = 0 ; i < N_MSGID_TO_CID ; i++) {
@@ -1159,16 +1182,17 @@ static void test_dump(void)
     }
     for (i = 0 ; i < N_CID_TO_FOLDER ; i++) {
         gen_cid_folder(i, &cid, &mboxnames);
-        conv = conversation_new(state);
+        conv = conversation_new();
         CU_ASSERT_PTR_NOT_NULL(conv);
         for (j = 0 ; j < mboxnames.count ; j++) {
             conversation_update(state, conv, mboxnames.data[j],
-                                /*num_records*/1,
+                                /*is_trash*/0, /*num_records*/1,
                                 /*exists*/1, /*unseen*/0,
                                 /*size*/0, /*counts*/NULL,
-                                /*modseq*/100);
+                                /*modseq*/100,
+                                /*createdmodseq*/0);
         }
-        r = conversation_save(state, cid, conv);
+        r = conversation_save(state, cid, conv, NULL);
         CU_ASSERT_EQUAL(r, 0);
         conversation_free(conv);
         conv = NULL;
@@ -1178,7 +1202,7 @@ static void test_dump(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open and dump the database */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     conversations_dump(state, fp);
@@ -1197,7 +1221,7 @@ static void test_dump(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* open and truncate the database */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     r = conversations_truncate(state);
@@ -1207,7 +1231,7 @@ static void test_dump(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* check we can no longer find any of the data */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     for (i = 0 ; i < N_MSGID_TO_CID ; i++) {
@@ -1233,7 +1257,7 @@ static void test_dump(void)
     CU_ASSERT_EQUAL(r, 0);
 
     /* finally check that we got all the data back */
-    r = conversations_open_path(DBNAME, &state);
+    r = conversations_open_path(DBNAME, NULL, 0/*shared*/, &state);
     CU_ASSERT_EQUAL_FATAL(r, 0);
 
     for (i = 0 ; i < N_MSGID_TO_CID ; i++) {
@@ -1346,7 +1370,11 @@ static int set_up(void)
 
     libcyrus_config_setstring(CYRUSOPT_CONFIG_DIR, DBDIR);
     cyrusdb_init();
+#ifdef HAVE_ZEROSKIP
+    config_conversations_db = "zeroskip";
+#else
     config_conversations_db = "twoskip";
+#endif
 
     return 0;
 }
diff -pruN 3.0.13-5/cunit/crc32.testc 3.2.0-3/cunit/crc32.testc
--- 3.0.13-5/cunit/crc32.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/crc32.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 /* Unit test for lib/crc32.c */
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "crc32.h"
 #include "crc32c.h"
 
diff -pruN 3.0.13-5/cunit/cunit.h 3.2.0-3/cunit/cunit.h
--- 3.0.13-5/cunit/cunit.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/cunit.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,242 +0,0 @@
-/* cunit.h - wrapper for CUnit assert macros
- *
- * Copyright (c) 1994-2010 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-#ifndef INCLUDED_CUNIT_H
-#define INCLUDED_CUNIT_H
-
-#include <stdio.h>
-#include <stdarg.h>
-#include <CUnit/CUnit.h>
-#include "cunit-syslog.h"
-
-extern int verbose;
-
-/*
- * The standard CUnit assertion *EQUAL* macros have a flaw: they do
- * not report the actual values of the 'actual' and 'expected' values,
- * which makes it rather hard to see why an assertion failed.  So we
- * replace the macros with improved ones, keeping the same API.
- */
-extern CU_BOOL CU_assertFormatImplementation(CU_BOOL bValue, unsigned int uiLine,
-                                             char strFile[], char strFunction[],
-                                             CU_BOOL bFatal,
-                                             char strConditionFormat[], ...);
-extern void __cunit_wrap_test(const char *name, void (*fn)(void));
-extern int __cunit_wrap_fixture(const char *name, int (*fn)(void));
-
-#undef CU_ASSERT_EQUAL
-#define CU_ASSERT_EQUAL(actual,expected) \
-  { long long _a = (actual), _e = (expected); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_EQUAL(" #actual "=%lld," #expected "=%lld)", _a, _e); }
-
-#undef CU_ASSERT_EQUAL_FATAL
-#define CU_ASSERT_EQUAL_FATAL(actual,expected) \
-  { long long _a = (actual), _e = (expected); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_EQUAL_FATAL(" #actual "=%lld," #expected "=%lld)", _a, _e); }
-
-#undef CU_ASSERT_NOT_EQUAL
-#define CU_ASSERT_NOT_EQUAL(actual,expected) \
-  { long long _a = (actual), _e = (expected); \
-    CU_assertFormatImplementation((_a != _e), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_NOT_EQUAL(" #actual "=%lld," #expected "=%lld)", _a, _e); }
-
-#undef CU_ASSERT_NOT_EQUAL_FATAL
-#define CU_ASSERT_NOT_EQUAL_FATAL(actual,expected) \
-  { long long _a = (actual), _e = (expected); \
-    CU_assertFormatImplementation((_a != _e), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_NOT_EQUAL_FATAL(" #actual "=%lld," #expected "=%lld)", _a, _e); }
-
-
-
-#undef CU_ASSERT_PTR_EQUAL
-#define CU_ASSERT_PTR_EQUAL(actual,expected) \
-  { const void *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_PTR_EQUAL(" #actual "=%p," #expected "=%p)", _a, _e); }
-
-#undef CU_ASSERT_PTR_EQUAL_FATAL
-#define CU_ASSERT_PTR_EQUAL_FATAL(actual,expected) \
-  { const void *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_PTR_EQUAL_FATAL(" #actual "=%p," #expected "=%p)", _a, _e); }
-
-#undef CU_ASSERT_PTR_NOT_EQUAL
-#define CU_ASSERT_PTR_NOT_EQUAL(actual,expected) \
-  { const void *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation((_a != _e), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_PTR_NOT_EQUAL(" #actual "=%p," #expected "=%p)", _a, _e); }
-
-#undef CU_ASSERT_PTR_NOT_EQUAL_FATAL
-#define CU_ASSERT_PTR_NOT_EQUAL_FATAL(actual,expected) \
-  { const void *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation((_a != _e), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_PTR_NOT_EQUAL_FATAL(" #actual "=%p," #expected "=%p)", _a, _e); }
-
-#undef CU_ASSERT_PTR_NULL
-#define CU_ASSERT_PTR_NULL(actual) \
-  { const void *_a = (actual); \
-    CU_assertFormatImplementation(!(_a), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_PTR_NULL(" #actual ")"); }
-
-#undef CU_ASSERT_PTR_NULL_FATAL
-#define CU_ASSERT_PTR_NULL_FATAL(actual) \
-  { const void *_a = (actual); \
-    CU_assertFormatImplementation(!(_a), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_PTR_NULL_FATAL(" #actual ")"); }
-
-#undef CU_ASSERT_PTR_NOT_NULL
-#define CU_ASSERT_PTR_NOT_NULL(actual) \
-  { const void *_a = (actual); \
-    CU_assertFormatImplementation(!!(_a), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_PTR_NOT_NULL(" #actual ")"); }
-
-#undef CU_ASSERT_PTR_NOT_NULL_FATAL
-#define CU_ASSERT_PTR_NOT_NULL_FATAL(actual) \
-  { const void *_a = (actual); \
-    CU_assertFormatImplementation(!!(_a), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_PTR_NOT_NULL_FATAL(" #actual ")"); }
-
-#undef CU_ASSERT_STRING_EQUAL
-#define CU_ASSERT_STRING_EQUAL(actual,expected) \
-  { const char *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation(!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_STRING_EQUAL(" #actual "=\"%s\"," #expected "=\"%s\")", _a, _e); }
-
-#undef CU_ASSERT_STRING_EQUAL_FATAL
-#define CU_ASSERT_STRING_EQUAL_FATAL(actual,expected) \
-  { const char *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation(!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_STRING_EQUAL_FATAL(" #actual "=\"%s\"," #expected "=\"%s\")", _a, _e); }
-
-#undef CU_ASSERT_STRING_NOT_EQUAL
-#define CU_ASSERT_STRING_NOT_EQUAL(actual,expected) \
-  { const char *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation(!!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_STRING_NOT_EQUAL(" #actual "=\"%s\"," #expected "=\"%s\")", _a, _e); }
-
-#undef CU_ASSERT_STRING_NOT_EQUAL_FATAL
-#define CU_ASSERT_STRING_NOT_EQUAL_FATAL(actual,expected) \
-  { const char *_a = (actual), *_e = (expected); \
-    CU_assertFormatImplementation(!!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_STRING_NOT_EQUAL_FATAL(" #actual "=\"%s\"," #expected "=\"%s\")", _a, _e); }
-
-#define CU_SYSLOG_MATCH(re) \
-    CU_syslogMatchBegin((re), __FILE__, __LINE__)
-#define CU_ASSERT_SYSLOG(match, expected) \
-  { const char *_s = NULL; unsigned int _e = (expected), \
-    _a = CU_syslogMatchEnd((match), &_s); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_FALSE, \
-    "CU_ASSERT_SYSLOG(/%s/=%u, " #expected "=%u)", _s, _a, _e); }
-#define CU_ASSERT_SYSLOG_FATAL(match, expected) \
-  { const char *_s = NULL; unsigned int _e = (expected), \
-    _a = CU_syslogMatchEnd((match), &_s); \
-    CU_assertFormatImplementation((_a == _e), __LINE__, \
-     __FILE__, "", CU_TRUE, \
-    "CU_ASSERT_SYSLOG_FATAL(/%s/=%u, " #expected "=%u)", _s, _a, _e); }
-
-extern jmp_buf fatal_jbuf;
-extern int fatal_expected;
-extern const char *fatal_string;
-extern int fatal_code;
-
-#define CU_EXPECT_CYRFATAL_BEGIN                                \
-do {                                                            \
-    fatal_expected = 1;                                         \
-    fatal_string = NULL;                                        \
-    fatal_code = 0;                                             \
-    if (!setjmp(fatal_jbuf)) {                                  \
-        /* code that we expect to call fatal() */
-
-#define CU_EXPECT_CYRFATAL_END(expected_code, expected_string)  \
-        CU_FAIL_FATAL("fatal codepath didn't call fatal");      \
-    } else {                                                    \
-        int _ec = (expected_code);                              \
-        const char *_es = (expected_string);                    \
-        CU_ASSERT_EQUAL(fatal_code, _ec);                       \
-        if (_es) CU_ASSERT_STRING_EQUAL(fatal_string, _es);     \
-}   } while (0)
-
-
-/* for parametrised tests */
-
-#define CUNIT_PARAM(x)      (x)
-
-struct cunit_param
-{
-    /* initialisation state */
-    const char *name;
-    char **variable;
-    /* iteration state */
-    int nvalues;
-    char **values;
-    int idx;
-    char *freeme1;
-};
-#define __CUNIT_DECLARE_PARAM(nm) \
-    { #nm, &nm, 0, NULL, 0, NULL }
-#define __CUNIT_LAST_PARAM \
-    { NULL, NULL, 0, NULL, 0, NULL }
-
-extern void __cunit_params_begin(struct cunit_param *);
-extern int __cunit_params_next(struct cunit_param *);
-extern void __cunit_params_end(void);
-
-#endif /* INCLUDED_CUNIT_H */
diff -pruN 3.0.13-5/cunit/cunit.pl 3.2.0-3/cunit/cunit.pl
--- 3.0.13-5/cunit/cunit.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/cunit.pl	2020-04-24 02:03:00.000000000 +0000
@@ -993,7 +993,7 @@ sub emit_final_makefile_bits()
 #
 # Emit to the MAKE filehandle, a makefile fragment which contains
 # rules to build wrappers around each test source in this directory
-# or it's descendants, and to build object files from those wrappers.
+# or it's descendents, and to build object files from those wrappers.
 #
 # Args: name of output makefile
 # Returns: void
@@ -1042,7 +1042,7 @@ sub emit_partial_makefile_bits($)
 #
 # Generate a makefile fragment which contains rules to build
 # wrappers around each test source in this directory or it's
-# descendants, and to build object files from those wrappers.
+# descendents, and to build object files from those wrappers.
 #
 sub generate_partial_makefile(@)
 {
diff -pruN 3.0.13-5/cunit/cyr_qsort_r.testc 3.2.0-3/cunit/cyr_qsort_r.testc
--- 3.0.13-5/cunit/cyr_qsort_r.testc	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cunit/cyr_qsort_r.testc	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,29 @@
+#include <config.h>
+#include "lib/cyr_qsort_r.h"
+
+#include "cunit/cyrunit.h"
+
+static int mysort QSORT_R_COMPAR_ARGS(const void *pa,
+                                      const void *pb,
+                                      void *arg)
+{
+    int *countptr = arg;
+    (*countptr)++;
+    return *((int*)pa) - *((int*)pb);
+
+}
+
+static void test_qsort_r(void)
+{
+    int data[10] = { 6, 8, 3, 7, 2, 0, 4, 9, 5, 1 };
+    int count = 0;
+
+    cyr_qsort_r(data, 10, sizeof(int), mysort, &count);
+
+    int i;
+    for (i = 0; i < 10; i++) CU_ASSERT_EQUAL(data[i], i);
+
+    CU_ASSERT_NOT_EQUAL(count, 0);
+}
+
+/* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/cyrunit.h 3.2.0-3/cunit/cyrunit.h
--- 3.0.13-5/cunit/cyrunit.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cunit/cyrunit.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,280 @@
+/* cyrunit.h - wrapper for CUnit assert macros
+ *
+ * Copyright (c) 1994-2010 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef INCLUDED_CUNIT_H
+#define INCLUDED_CUNIT_H
+
+#include <stdio.h>
+#include <stdarg.h>
+#include <CUnit/CUnit.h>
+#include "cunit-syslog.h"
+
+extern int verbose;
+
+/*
+ * The standard CUnit assertion *EQUAL* macros have a flaw: they do
+ * not report the actual values of the 'actual' and 'expected' values,
+ * which makes it rather hard to see why an assertion failed.  So we
+ * replace the macros with improved ones, keeping the same API.
+ */
+/* XXX Would like to add __attribute__((format(printf, 6, 7)))
+ * XXX to this so the compiler can warn if it's misused, but it looks
+ * XXX like it currently gets very confused by the layers of macros
+ * XXX and produces bogus warnings. :(
+ */
+extern CU_BOOL CU_assertFormatImplementation(CU_BOOL bValue, unsigned int uiLine,
+                                             char strFile[], char strFunction[],
+                                             CU_BOOL bFatal,
+                                             char strConditionFormat[], ...);
+extern void __cunit_wrap_test(const char *name, void (*fn)(void));
+extern int __cunit_wrap_fixture(const char *name, int (*fn)(void));
+
+#undef CU_ASSERT_EQUAL
+#define CU_ASSERT_EQUAL(actual,expected) do {                           \
+    long long _a = (actual), _e = (expected);                           \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_EQUAL(" #actual "=%lld," #expected "=%lld)",         \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_EQUAL_FATAL
+#define CU_ASSERT_EQUAL_FATAL(actual,expected) do {                     \
+    long long _a = (actual), _e = (expected);                           \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_EQUAL_FATAL(" #actual "=%lld," #expected "=%lld)",   \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_NOT_EQUAL
+#define CU_ASSERT_NOT_EQUAL(actual,expected) do {                       \
+    long long _a = (actual), _e = (expected);                           \
+    CU_assertFormatImplementation((_a != _e), __LINE__,                 \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_NOT_EQUAL(" #actual "=%lld," #expected "=%lld)",     \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_NOT_EQUAL_FATAL
+#define CU_ASSERT_NOT_EQUAL_FATAL(actual,expected) do {                 \
+    long long _a = (actual), _e = (expected);                           \
+    CU_assertFormatImplementation((_a != _e), __LINE__,                 \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_NOT_EQUAL_FATAL(" #actual "=%lld," #expected "=%lld)", \
+        _a, _e);                                                        \
+} while(0)
+
+
+
+#undef CU_ASSERT_PTR_EQUAL
+#define CU_ASSERT_PTR_EQUAL(actual,expected) do {                       \
+    const void *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_PTR_EQUAL(" #actual "=%p," #expected "=%p)",         \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_PTR_EQUAL_FATAL
+#define CU_ASSERT_PTR_EQUAL_FATAL(actual,expected) do {                 \
+    const void *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_PTR_EQUAL_FATAL(" #actual "=%p," #expected "=%p)",   \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_PTR_NOT_EQUAL
+#define CU_ASSERT_PTR_NOT_EQUAL(actual,expected) do {                   \
+    const void *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation((_a != _e), __LINE__,                 \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_PTR_NOT_EQUAL(" #actual "=%p," #expected "=%p)",     \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_PTR_NOT_EQUAL_FATAL
+#define CU_ASSERT_PTR_NOT_EQUAL_FATAL(actual,expected) do {             \
+    const void *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation((_a != _e), __LINE__,                 \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_PTR_NOT_EQUAL_FATAL(" #actual "=%p," #expected "=%p)", \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_PTR_NULL
+#define CU_ASSERT_PTR_NULL(actual) do {                                 \
+    const void *_a = (actual);                                          \
+    CU_assertFormatImplementation(!(_a), __LINE__,                      \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_PTR_NULL(" #actual ")");                             \
+} while(0)
+
+#undef CU_ASSERT_PTR_NULL_FATAL
+#define CU_ASSERT_PTR_NULL_FATAL(actual) do {                           \
+    const void *_a = (actual);                                          \
+    CU_assertFormatImplementation(!(_a), __LINE__,                      \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_PTR_NULL_FATAL(" #actual ")");                       \
+} while(0)
+
+#undef CU_ASSERT_PTR_NOT_NULL
+#define CU_ASSERT_PTR_NOT_NULL(actual) do {                             \
+    const void *_a = (actual);                                          \
+    CU_assertFormatImplementation(!!(_a), __LINE__,                     \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_PTR_NOT_NULL(" #actual ")");                         \
+} while(0)
+
+#undef CU_ASSERT_PTR_NOT_NULL_FATAL
+#define CU_ASSERT_PTR_NOT_NULL_FATAL(actual) do {                       \
+    const void *_a = (actual);                                          \
+    CU_assertFormatImplementation(!!(_a), __LINE__,                     \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_PTR_NOT_NULL_FATAL(" #actual ")");                   \
+} while(0)
+
+#undef CU_ASSERT_STRING_EQUAL
+#define CU_ASSERT_STRING_EQUAL(actual,expected) do {                    \
+    const char *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation(!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_STRING_EQUAL(" #actual "=\"%s\"," #expected "=\"%s\")", \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_STRING_EQUAL_FATAL
+#define CU_ASSERT_STRING_EQUAL_FATAL(actual,expected) do {              \
+    const char *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation(!strcmp(_a?_a:"",_e?_e:""), __LINE__, \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_STRING_EQUAL_FATAL(" #actual "=\"%s\"," #expected "=\"%s\")", \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_STRING_NOT_EQUAL
+#define CU_ASSERT_STRING_NOT_EQUAL(actual,expected) do {                \
+    const char *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation(!!strcmp(_a?_a:"",_e?_e:""),          \
+        __LINE__, __FILE__, "", CU_FALSE,                               \
+        "CU_ASSERT_STRING_NOT_EQUAL(" #actual "=\"%s\"," #expected "=\"%s\")", \
+        _a, _e);                                                        \
+} while(0)
+
+#undef CU_ASSERT_STRING_NOT_EQUAL_FATAL
+#define CU_ASSERT_STRING_NOT_EQUAL_FATAL(actual,expected) do {          \
+    const char *_a = (actual), *_e = (expected);                        \
+    CU_assertFormatImplementation(!!strcmp(_a?_a:"",_e?_e:""),          \
+        __LINE__, __FILE__, "", CU_TRUE,                                \
+        "CU_ASSERT_STRING_NOT_EQUAL_FATAL(" #actual "=\"%s\"," #expected "=\"%s\")", \
+        _a, _e);                                                        \
+} while(0)
+
+#define CU_SYSLOG_MATCH(re) \
+    CU_syslogMatchBegin((re), __FILE__, __LINE__)
+
+#define CU_ASSERT_SYSLOG(match, expected) do {                          \
+    const char *_s = NULL; unsigned int _e = (expected),                \
+    _a = CU_syslogMatchEnd((match), &_s);                               \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_FALSE,                                         \
+        "CU_ASSERT_SYSLOG(/%s/=%u, " #expected "=%u)", _s, _a, _e);     \
+} while(0)
+
+#define CU_ASSERT_SYSLOG_FATAL(match, expected) do {                    \
+    const char *_s = NULL; unsigned int _e = (expected),                \
+    _a = CU_syslogMatchEnd((match), &_s);                               \
+    CU_assertFormatImplementation((_a == _e), __LINE__,                 \
+        __FILE__, "", CU_TRUE,                                          \
+        "CU_ASSERT_SYSLOG_FATAL(/%s/=%u, " #expected "=%u)",            \
+        _s, _a, _e);                                                    \
+} while(0)
+
+extern jmp_buf fatal_jbuf;
+extern int fatal_expected;
+extern const char *fatal_string;
+extern int fatal_code;
+
+#define CU_EXPECT_CYRFATAL_BEGIN                                \
+do {                                                            \
+    fatal_expected = 1;                                         \
+    fatal_string = NULL;                                        \
+    fatal_code = 0;                                             \
+    if (!setjmp(fatal_jbuf)) {                                  \
+        /* code that we expect to call fatal() */
+
+#define CU_EXPECT_CYRFATAL_END(expected_code, expected_string)  \
+        CU_FAIL_FATAL("fatal codepath didn't call fatal");      \
+    } else {                                                    \
+        int _ec = (expected_code);                              \
+        const char *_es = (expected_string);                    \
+        CU_ASSERT_EQUAL(fatal_code, _ec);                       \
+        if (_es) CU_ASSERT_STRING_EQUAL(fatal_string, _es);     \
+}   } while (0)
+
+
+/* for parametrised tests */
+
+#define CUNIT_PARAM(x)      (x)
+
+struct cunit_param
+{
+    /* initialisation state */
+    const char *name;
+    char **variable;
+    /* iteration state */
+    int nvalues;
+    char **values;
+    int idx;
+    char *freeme1;
+};
+#define __CUNIT_DECLARE_PARAM(nm) \
+    { #nm, &nm, 0, NULL, 0, NULL }
+#define __CUNIT_LAST_PARAM \
+    { NULL, NULL, 0, NULL, 0, NULL }
+
+extern void __cunit_params_begin(struct cunit_param *);
+extern int __cunit_params_next(struct cunit_param *);
+extern void __cunit_params_end(void);
+
+#endif /* INCLUDED_CUNIT_H */
diff -pruN 3.0.13-5/cunit/dlist.testc 3.2.0-3/cunit/dlist.testc
--- 3.0.13-5/cunit/dlist.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/dlist.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "prot.h"
 #include "imap/dlist.h"
 #include "util.h"
@@ -15,9 +15,10 @@ static void test_nil(void)
 
     dlist_setatom(dl, "STRING", "NIL");
     dlist_setatom(dl, "EMPTY", NULL);
+    dlist_setatom(dl, "DOUBLEWHAMMY", "\"NIL\"");
     dlist_printbuf(dl, 0, &b);
 
-    CU_ASSERT_STRING_EQUAL(buf_cstring(&b), "(\"NIL\" NIL)");
+    CU_ASSERT_STRING_EQUAL(buf_cstring(&b), "(\"NIL\" NIL {5+}\r\n\"NIL\")");
     dlist_free(&dl);
 
     r = dlist_parsemap(&dl, 0, 0, b.s, b.len);
@@ -34,6 +35,11 @@ static void test_nil(void)
     CU_ASSERT_EQUAL(item->type, DL_NIL);
     CU_ASSERT_PTR_NULL(item->sval);
 
+    item = dlist_getchildn(dl, 2);
+    CU_ASSERT_PTR_NOT_NULL(item);
+    CU_ASSERT_EQUAL(item->type, DL_BUF);
+    CU_ASSERT_STRING_EQUAL(item->sval, "\"NIL\"");
+
     dlist_free(&dl);
     buf_free(&b);
 }
diff -pruN 3.0.13-5/cunit/duplicate.testc 3.2.0-3/cunit/duplicate.testc
--- 3.0.13-5/cunit/duplicate.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/duplicate.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #include <unistd.h>
 #include <stdlib.h>
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/duplicate.h"
 #include "xmalloc.h"
 #include "retry.h"
diff -pruN 3.0.13-5/cunit/getxstring.testc 3.2.0-3/cunit/getxstring.testc
--- 3.0.13-5/cunit/getxstring.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/getxstring.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 /* Test the getxstring() function */
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "prot.h"
 #include "imap/global.h"
 
@@ -51,51 +51,62 @@
  * Note: prot_setisclient() turns off off literal synchronising so
  * we don't have to futz around with testing that.
  */
-#define _TESTCASE_PRE(fut, input, retval) \
-    do { \
-        struct buf b = BUF_INITIALIZER; \
-        struct protstream *p; \
-        int c; \
-        p = prot_readmap(input, sizeof(input)-1); \
-        CU_ASSERT_PTR_NOT_NULL(p); \
-        prot_setisclient(p, 1); \
-        c = fut(p, NULL, &b); \
-        CU_ASSERT_EQUAL(c, retval); \
+#define _TESTCASE_PRE(fut, input, retval, consumed)                 \
+    do {                                                            \
+        struct buf b = BUF_INITIALIZER;                             \
+        struct protstream *p;                                       \
+        int c;                                                      \
+        p = prot_readmap(input, sizeof(input)-1);                   \
+        CU_ASSERT_PTR_NOT_NULL_FATAL(p);                            \
+        prot_setisclient(p, 1);                                     \
+        c = fut(p, NULL, &b);                                       \
+        CU_ASSERT_EQUAL(c, retval);                                 \
+        if (consumed >= 0) {                                        \
+            CU_ASSERT_EQUAL(prot_bytes_in(p), consumed);            \
+        }                                                           \
         if (c != EOF) {
-#define _TESTCASE_POST() \
-        } \
-        prot_free(p); \
-        buf_free(&b); \
+
+#define _TESTCASE_POST()                                            \
+        }                                                           \
+        prot_free(p);                                               \
+        buf_free(&b);                                               \
     } while (0)
-#define TESTCASE(fut, input, retval, output) \
-    do { \
-        int outputlen = sizeof(output)-1; \
-        _TESTCASE_PRE(fut, input, retval); \
-        CU_ASSERT_EQUAL(b.len, outputlen); \
-        CU_ASSERT(!memcmp(b.s, output, outputlen)); \
-        _TESTCASE_POST(); \
+
+#define TESTCASE(fut, input, retval, output, consumed)              \
+    do {                                                            \
+        int outputlen = sizeof(output)-1;                           \
+        _TESTCASE_PRE(fut, input, retval, consumed);                \
+        CU_ASSERT_EQUAL(b.len, outputlen);                          \
+        CU_ASSERT(!memcmp(b.s, output, outputlen));                 \
+        _TESTCASE_POST();                                           \
     } while(0)
-#define TESTCASE_NULL(fut, input, retval) \
-    do { \
-        _TESTCASE_PRE(fut, input, retval); \
-        CU_ASSERT_EQUAL(b.len, 0); \
-        CU_ASSERT_PTR_NULL(b.s); \
-        _TESTCASE_POST(); \
+
+#define TESTCASE_NULL(fut, input, retval, consumed)                 \
+    do {                                                            \
+        _TESTCASE_PRE(fut, input, retval, consumed);                \
+        CU_ASSERT_EQUAL(b.len, 0);                                  \
+        CU_ASSERT_PTR_NULL(b.s);                                    \
+        _TESTCASE_POST();                                           \
     } while(0)
 
+/* strlen-y, but embedded NULs are okay
+ * N.B. this macro is ONLY valid for string literals! */
+#define BLEN(s) (sizeof(s) - 1)
+
 /*
  * getastring() parses something vaguely like an astring, with a few differences.
  */
 static void test_getastring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms */
-    TESTCASE(getastring, "hydrogen helium", ' ', "hydrogen");
-    TESTCASE(getastring, "258 uranium", ' ', "258");
-    TESTCASE(getastring, "uranium258 plutonium", ' ', "uranium258");
+    TESTCASE(getastring, "hydrogen helium", ' ', "hydrogen", BLEN("hydrogen "));
+    TESTCASE(getastring, "258 uranium", ' ', "258", BLEN("258 "));
+    TESTCASE(getastring, "uranium258 plutonium", ' ', "uranium258", BLEN("uranium258 "));
 
     /* The character sequence NIL is not special, it's parsed as an atom */
-    TESTCASE(getastring, "NIL by mouth", ' ', "NIL");
-    TESTCASE(getastring, "NELLY the lamb", ' ', "NELLY");
+    TESTCASE(getastring, "NIL by mouth", ' ', "NIL", BLEN("NIL "));
+    TESTCASE(getastring, "NELLY the lamb", ' ', "NELLY", BLEN("NELLY "));
+    TESTCASE(getastring, "NILE in Egypt", ' ', "NILE", BLEN("NILE "));
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -103,8 +114,8 @@ static void test_getastring(void)
      * which are like astrings but also allow unquoted wildcards,
      * as astrings.
      */
-    TESTCASE(getastring, "foo*bar baz", ' ', "foo*bar");
-    TESTCASE(getastring, "baz%quux foo", ' ', "baz%quux");
+    TESTCASE(getastring, "foo*bar baz", ' ', "foo*bar", BLEN("foo*bar "));
+    TESTCASE(getastring, "baz%quux foo", ' ', "baz%quux", BLEN("baz%quux "));
 
     /*
      * Various special characters are not part of atoms.
@@ -113,48 +124,48 @@ static void test_getastring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getastring, "foo(bar baz", '(', "foo");
-    TESTCASE(getastring, "foo)bar baz", ')', "foo");
-    TESTCASE(getastring, "foo{bar baz", ' ', "foo{bar"); /* should be: '{', "foo" */
-    TESTCASE(getastring, "foo\"bar baz", '"', "foo");
-    TESTCASE(getastring, "foo\\bar baz", ' ', "foo\\bar"); /* should be: '\\', "foo" */
-    TESTCASE(getastring, "foo]bar baz", ' ', "foo]bar"); /* should be ']', "foo" */
+    TESTCASE(getastring, "foo(bar baz", '(', "foo", BLEN("foo("));
+    TESTCASE(getastring, "foo)bar baz", ')', "foo", BLEN("foo)"));
+    TESTCASE(getastring, "foo{bar baz", ' ', "foo{bar", BLEN("foo{bar ")); /* should be: '{', "foo" */
+    TESTCASE(getastring, "foo\"bar baz", '"', "foo", BLEN("foo\""));
+    TESTCASE(getastring, "foo\\bar baz", ' ', "foo\\bar", BLEN("foo\\bar ")); /* should be: '\\', "foo" */
+    TESTCASE(getastring, "foo]bar baz", ' ', "foo]bar", BLEN("foo]bar ")); /* should be ']', "foo" */
 
     /*
      * Quoted strings are astrings
      */
-    TESTCASE(getastring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getastring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getastring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getastring, "\"foo bar", EOF, "");
-    TESTCASE(getastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getastring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getastring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getastring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getastring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getastring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getastring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getastring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getastring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getastring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getastring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are astrings
      */
     /* boring literal */
-    TESTCASE(getastring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getastring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getastring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getastring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getastring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getastring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar "));
     /* literals with embedded NUL - getastring() rejects these */
-    TESTCASE(getastring, "{7}\r\nfoo\0bar ", EOF, ""); /* should be ' ', "foo\0bar" */
+    TESTCASE(getastring, "{7}\r\nfoo\0bar ", EOF, "", BLEN("{7}\r\nfoo\0bar")); /* should be ' ', "foo\0bar" */
 }
 
 /*
@@ -164,13 +175,14 @@ static void test_getastring(void)
 static void test_getbastring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms */
-    TESTCASE(getbastring, "hydrogen helium", ' ', "hydrogen");
-    TESTCASE(getbastring, "258 uranium", ' ', "258");
-    TESTCASE(getbastring, "uranium258 plutonium", ' ', "uranium258");
+    TESTCASE(getbastring, "hydrogen helium", ' ', "hydrogen", BLEN("hydrogen "));
+    TESTCASE(getbastring, "258 uranium", ' ', "258", BLEN("258 "));
+    TESTCASE(getbastring, "uranium258 plutonium", ' ', "uranium258", BLEN("uranium258 "));
 
     /* The character sequence NIL is not special, it's parsed as an atom */
-    TESTCASE(getbastring, "NIL by mouth", ' ', "NIL");
-    TESTCASE(getbastring, "NELLY the lamb", ' ', "NELLY");
+    TESTCASE(getbastring, "NIL by mouth", ' ', "NIL", BLEN("NIL "));
+    TESTCASE(getbastring, "NELLY the lamb", ' ', "NELLY", BLEN("NELLY "));
+    TESTCASE(getbastring, "NILE in Egypt", ' ', "NILE", BLEN("NILE "));
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -180,8 +192,8 @@ static void test_getbastring(void)
      * but it's a liberal-server interpretation which has been in the
      * field a while now, so we ought to preserve it.
      */
-    TESTCASE(getbastring, "foo*bar baz", ' ', "foo*bar");
-    TESTCASE(getbastring, "baz%quux foo", ' ', "baz%quux");
+    TESTCASE(getbastring, "foo*bar baz", ' ', "foo*bar", BLEN("foo*bar "));
+    TESTCASE(getbastring, "baz%quux foo", ' ', "baz%quux", BLEN("baz%quux "));
 
     /*
      * Various special characters are not part of atoms.
@@ -190,48 +202,48 @@ static void test_getbastring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getbastring, "foo(bar baz", '(', "foo");
-    TESTCASE(getbastring, "foo)bar baz", ')', "foo");
-    TESTCASE(getbastring, "foo{bar baz", ' ', "foo{bar"); /* should be: '{', "foo" */
-    TESTCASE(getbastring, "foo\"bar baz", '"', "foo");
-    TESTCASE(getbastring, "foo\\bar baz", ' ', "foo\\bar"); /* should be: '\\', "foo" */
-    TESTCASE(getbastring, "foo]bar baz", ' ', "foo]bar"); /* should be ']', "foo" */
+    TESTCASE(getbastring, "foo(bar baz", '(', "foo", BLEN("foo("));
+    TESTCASE(getbastring, "foo)bar baz", ')', "foo", BLEN("foo)"));
+    TESTCASE(getbastring, "foo{bar baz", ' ', "foo{bar", BLEN("foo{bar ")); /* should be: '{', "foo" */
+    TESTCASE(getbastring, "foo\"bar baz", '"', "foo", BLEN("foo\""));
+    TESTCASE(getbastring, "foo\\bar baz", ' ', "foo\\bar", BLEN("foo\\bar ")); /* should be: '\\', "foo" */
+    TESTCASE(getbastring, "foo]bar baz", ' ', "foo]bar", BLEN("foo]bar ")); /* should be ']', "foo" */
 
     /*
      * Quoted strings are astrings
      */
-    TESTCASE(getbastring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getbastring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getbastring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getbastring, "\"foo bar", EOF, "");
-    TESTCASE(getbastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getbastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getbastring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getbastring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getbastring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getbastring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getbastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getbastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getbastring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getbastring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getbastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getbastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getbastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getbastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getbastring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getbastring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getbastring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getbastring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are astrings
      */
     /* boring literal */
-    TESTCASE(getbastring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getbastring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getbastring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getbastring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getbastring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getbastring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getbastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getbastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getbastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getbastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getbastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getbastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar "));
     /* literals with embedded NUL - getbastring() allows these */
-    TESTCASE(getbastring, "{7}\r\nfoo\0bar ", ' ', "foo\0bar");
+    TESTCASE(getbastring, "{7}\r\nfoo\0bar ", ' ', "foo\0bar", BLEN("{7}\r\nfoo\0bar "));
 }
 
 /*
@@ -241,13 +253,14 @@ static void test_getstring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms
      * which are not strings */
-    TESTCASE(getstring, "hydrogen helium", EOF, "");
-    TESTCASE(getstring, "258 uranium", EOF, "");
-    TESTCASE(getstring, "uranium258 plutonium", EOF, "");
+    TESTCASE(getstring, "hydrogen helium", EOF, "", 0);
+    TESTCASE(getstring, "258 uranium", EOF, "", 0);
+    TESTCASE(getstring, "uranium258 plutonium", EOF, "", 0);
 
     /* The character sequence NIL is not special, it's parsed as an atom */
-    TESTCASE(getstring, "NIL by mouth", EOF, "");
-    TESTCASE(getstring, "NELLY the lamb", EOF, "");
+    TESTCASE(getstring, "NIL by mouth", EOF, "", 0);
+    TESTCASE(getstring, "NELLY the lamb", EOF, "", 0);
+    TESTCASE(getstring, "NILE in Egypt", EOF, "", 0);
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -257,8 +270,8 @@ static void test_getstring(void)
      * but it's a liberal-server interpretation which has been in the
      * field a while now, so we ought to preserve it.
      */
-    TESTCASE(getstring, "foo*bar baz", EOF, "");
-    TESTCASE(getstring, "baz%quux foo", EOF, "");
+    TESTCASE(getstring, "foo*bar baz", EOF, "", 0);
+    TESTCASE(getstring, "baz%quux foo", EOF, "", 0);
 
     /*
      * Various special characters are not part of atoms.
@@ -267,48 +280,48 @@ static void test_getstring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getstring, "foo(bar baz", EOF, "");
-    TESTCASE(getstring, "foo)bar baz", EOF, "");
-    TESTCASE(getstring, "foo{bar baz", EOF, "");
-    TESTCASE(getstring, "foo\"bar baz", EOF, "");
-    TESTCASE(getstring, "foo\\bar baz", EOF, "");
-    TESTCASE(getstring, "foo]bar baz", EOF, "");
+    TESTCASE(getstring, "foo(bar baz", EOF, "", 0);
+    TESTCASE(getstring, "foo)bar baz", EOF, "", 0);
+    TESTCASE(getstring, "foo{bar baz", EOF, "", 0);
+    TESTCASE(getstring, "foo\"bar baz", EOF, "", 0);
+    TESTCASE(getstring, "foo\\bar baz", EOF, "", 0);
+    TESTCASE(getstring, "foo]bar baz", EOF, "", 0);
 
     /*
      * Quoted strings are strings
      */
-    TESTCASE(getstring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getstring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getstring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getstring, "\"foo bar", EOF, "");
-    TESTCASE(getstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getstring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getstring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getstring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getstring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getstring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getstring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getstring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getstring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getstring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getstring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are strings
      */
     /* boring literal */
-    TESTCASE(getstring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getstring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getstring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getstring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getstring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getstring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar "));
     /* literals with embedded NUL - getstring() rejects these */
-    TESTCASE(getqstring, "{7}\r\nfoo\0bar ", EOF, ""); /* should be ' ', "foo\0bar" */
+    TESTCASE(getstring, "{7}\r\nfoo\0bar ", EOF, "", BLEN("{7}\r\nfoo\0bar")); /* should be ' ', "foo\0bar" */
 }
 
 
@@ -320,13 +333,14 @@ static void test_getqstring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms
      * which are not qstrings */
-    TESTCASE(getqstring, "hydrogen helium", EOF, "");
-    TESTCASE(getqstring, "258 uranium", EOF, "");
-    TESTCASE(getqstring, "uranium258 plutonium", EOF, "");
+    TESTCASE(getqstring, "hydrogen helium", EOF, "", 0);
+    TESTCASE(getqstring, "258 uranium", EOF, "", 0);
+    TESTCASE(getqstring, "uranium258 plutonium", EOF, "", 0);
 
     /* The character sequence NIL is not special, it's parsed as an atom */
-    TESTCASE(getqstring, "NIL by mouth", EOF, "");
-    TESTCASE(getqstring, "NELLY the lamb", EOF, "");
+    TESTCASE(getqstring, "NIL by mouth", EOF, "", 0);
+    TESTCASE(getqstring, "NELLY the lamb", EOF, "", 0);
+    TESTCASE(getqstring, "NILE in Egypt", EOF, "", 0);
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -336,8 +350,8 @@ static void test_getqstring(void)
      * but it's a liberal-server interpretation which has been in the
      * field a while now, so we ought to preserve it.
      */
-    TESTCASE(getqstring, "foo*bar baz", EOF, "");
-    TESTCASE(getqstring, "baz%quux foo", EOF, "");
+    TESTCASE(getqstring, "foo*bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "baz%quux foo", EOF, "", 0);
 
     /*
      * Various special characters are not part of atoms.
@@ -346,48 +360,48 @@ static void test_getqstring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getqstring, "foo(bar baz", EOF, "");
-    TESTCASE(getqstring, "foo)bar baz", EOF, "");
-    TESTCASE(getqstring, "foo{bar baz", EOF, "");
-    TESTCASE(getqstring, "foo\"bar baz", EOF, "");
-    TESTCASE(getqstring, "foo\\bar baz", EOF, "");
-    TESTCASE(getqstring, "foo]bar baz", EOF, "");
+    TESTCASE(getqstring, "foo(bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "foo)bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "foo{bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "foo\"bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "foo\\bar baz", EOF, "", 0);
+    TESTCASE(getqstring, "foo]bar baz", EOF, "", 0);
 
     /*
      * Quoted strings
      */
-    TESTCASE(getqstring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getqstring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getqstring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getqstring, "\"foo bar", EOF, "");
-    TESTCASE(getqstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getqstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getqstring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getqstring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getqstring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getqstring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getqstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getqstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getqstring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getqstring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getqstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getqstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getqstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getqstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getqstring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getqstring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getqstring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getqstring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are not qstrings
      */
     /* boring literal */
-    TESTCASE(getqstring, "{3}\r\nfoo ", EOF, "");
+    TESTCASE(getqstring, "{3}\r\nfoo ", EOF, "", 0);
     /* literal NIL */
-    TESTCASE(getqstring, "{3}\r\nNIL ", EOF, "");
+    TESTCASE(getqstring, "{3}\r\nNIL ", EOF, "", 0);
     /* literals with embedded space */
-    TESTCASE(getqstring, "{7}\r\nfoo bar ", EOF, "");
+    TESTCASE(getqstring, "{7}\r\nfoo bar ", EOF, "", 0);
     /* literals with embedded \n or \r */
-    TESTCASE(getqstring, "{7}\r\nfoo\nbar ", EOF, "");
-    TESTCASE(getqstring, "{7}\r\nfoo\rbar ", EOF, "");
+    TESTCASE(getqstring, "{7}\r\nfoo\nbar ", EOF, "", 0);
+    TESTCASE(getqstring, "{7}\r\nfoo\rbar ", EOF, "", 0);
     /* literals with 8-bit chars */
-    TESTCASE(getqstring, "{7}\r\nfoo\277bar ", EOF, "");
+    TESTCASE(getqstring, "{7}\r\nfoo\277bar ", EOF, "", 0);
     /* literals with embedded NUL */
-    TESTCASE(getqstring, "{7}\r\nfoo\0bar ", EOF, "");
+    TESTCASE(getqstring, "{7}\r\nfoo\0bar ", EOF, "", 0);
 }
 
 /*
@@ -396,13 +410,14 @@ static void test_getqstring(void)
 static void test_getnstring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms */
-    TESTCASE(getnstring, "hydrogen helium", EOF, "");
-    TESTCASE(getnstring, "258 uranium", EOF, "");
-    TESTCASE(getnstring, "uranium258 plutonium", EOF, "");
+    TESTCASE(getnstring, "hydrogen helium", EOF, "", 0);
+    TESTCASE(getnstring, "258 uranium", EOF, "", 0);
+    TESTCASE(getnstring, "uranium258 plutonium", EOF, "", 0);
 
     /* The character sequence NIL is special for nstrings only */
-    TESTCASE_NULL(getnstring, "NIL by mouth", ' ');
-    TESTCASE(getnstring, "NELLY ", EOF, "");
+    TESTCASE_NULL(getnstring, "NIL by mouth", ' ', BLEN("NIL "));
+    TESTCASE(getnstring, "NELLY ", EOF, "", 0);
+    TESTCASE(getnstring, "NILE in Egypt", EOF, "", 0);
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -410,8 +425,8 @@ static void test_getnstring(void)
      * which are like astrings but also allow unquoted wildcards,
      * as astrings.
      */
-    TESTCASE(getnstring, "foo*bar baz", EOF, "");
-    TESTCASE(getnstring, "baz%quux foo", EOF, "");
+    TESTCASE(getnstring, "foo*bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "baz%quux foo", EOF, "", 0);
 
     /*
      * Various special characters are not part of atoms.
@@ -420,48 +435,48 @@ static void test_getnstring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getnstring, "foo(bar baz", EOF, "");
-    TESTCASE(getnstring, "foo)bar baz", EOF, "");
-    TESTCASE(getnstring, "foo{bar baz", EOF, "");
-    TESTCASE(getnstring, "foo\"bar baz", EOF, "");
-    TESTCASE(getnstring, "foo\\bar baz", EOF, "");
-    TESTCASE(getnstring, "foo]bar baz", EOF, "");
+    TESTCASE(getnstring, "foo(bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "foo)bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "foo{bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "foo\"bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "foo\\bar baz", EOF, "", 0);
+    TESTCASE(getnstring, "foo]bar baz", EOF, "", 0);
 
     /*
      * Quoted strings are nstrings
      */
-    TESTCASE(getnstring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getnstring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getnstring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getnstring, "\"foo bar", EOF, "");
-    TESTCASE(getnstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getnstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getnstring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getnstring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getnstring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getnstring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getnstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getnstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getnstring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getnstring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getnstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getnstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getnstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getnstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\\bar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getnstring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getnstring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getnstring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getnstring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are nstrings
      */
     /* boring literal */
-    TESTCASE(getnstring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getnstring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getnstring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getnstring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getnstring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getnstring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getnstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getnstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getnstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getnstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getnstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getnstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar "));
     /* literals with embedded NUL - getnstring() rejects these */
-    TESTCASE(getnstring, "{7}\r\nfoo\0bar ", EOF, ""); /* should be ' ', "foo\0bar" */
+    TESTCASE(getnstring, "{7}\r\nfoo\0bar ", EOF, "", BLEN("{7}\r\nfoo\0bar")); /* should be ' ', "foo\0bar" */
 }
 
 /*
@@ -471,13 +486,14 @@ static void test_getnstring(void)
 static void test_getbnstring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms */
-    TESTCASE(getbnstring, "hydrogen helium", EOF, "");
-    TESTCASE(getbnstring, "258 uranium", EOF, "");
-    TESTCASE(getbnstring, "uranium258 plutonium", EOF, "");
+    TESTCASE(getbnstring, "hydrogen helium", EOF, "", 0);
+    TESTCASE(getbnstring, "258 uranium", EOF, "", 0);
+    TESTCASE(getbnstring, "uranium258 plutonium", EOF, "", 0);
 
     /* The character sequence NIL is special for nstrings only */
-    TESTCASE_NULL(getbnstring, "NIL by mouth", ' ');
-    TESTCASE(getbnstring, "NELLY ", EOF, "");
+    TESTCASE_NULL(getbnstring, "NIL by mouth", ' ', BLEN("NIL "));
+    TESTCASE(getbnstring, "NELLY ", EOF, "", 0);
+    TESTCASE(getbnstring, "NILE in Egypt", EOF, "", 0);
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -485,8 +501,8 @@ static void test_getbnstring(void)
      * which are like astrings but also allow unquoted wildcards,
      * as astrings.
      */
-    TESTCASE(getnstring, "foo*bar baz", EOF, "");
-    TESTCASE(getbnstring, "baz%quux foo", EOF, "");
+    TESTCASE(getnstring, "foo*bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "baz%quux foo", EOF, "", 0);
 
     /*
      * Various special characters are not part of atoms.
@@ -495,48 +511,48 @@ static void test_getbnstring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getbnstring, "foo(bar baz", EOF, "");
-    TESTCASE(getbnstring, "foo)bar baz", EOF, "");
-    TESTCASE(getbnstring, "foo{bar baz", EOF, "");
-    TESTCASE(getbnstring, "foo\"bar baz", EOF, "");
-    TESTCASE(getbnstring, "foo\\bar baz", EOF, "");
-    TESTCASE(getbnstring, "foo]bar baz", EOF, "");
+    TESTCASE(getbnstring, "foo(bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "foo)bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "foo{bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "foo\"bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "foo\\bar baz", EOF, "", 0);
+    TESTCASE(getbnstring, "foo]bar baz", EOF, "", 0);
 
     /*
      * Quoted strings are nstrings
      */
-    TESTCASE(getbnstring, "\"foo\" bar", ' ', "foo");
-    TESTCASE(getbnstring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getbnstring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getbnstring, "\"foo bar", EOF, "");
-    TESTCASE(getbnstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getbnstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getbnstring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
+    TESTCASE(getbnstring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getbnstring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getbnstring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getbnstring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getbnstring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getbnstring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getbnstring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getbnstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getbnstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getbnstring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getbnstring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getbnstring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getbnstring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getbnstring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getbnstring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are nstrings
      */
     /* boring literal */
-    TESTCASE(getbnstring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getbnstring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getbnstring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getbnstring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getbnstring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getbnstring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getbnstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getbnstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getbnstring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getbnstring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getbnstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getbnstring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar "));
     /* literals with embedded NUL - getbnstring() allows these */
-    TESTCASE(getbnstring, "{7}\r\nfoo\0bar ", ' ', "foo\0bar");
+    TESTCASE(getbnstring, "{7}\r\nfoo\0bar ", ' ', "foo\0bar", BLEN("{7}\r\nfoo\0bar "));
 }
 
 /*
@@ -545,13 +561,14 @@ static void test_getbnstring(void)
 static void test_getnastring(void)
 {
     /* Simple sequences of ascii alphanumerics characters are atoms */
-    TESTCASE(getnastring, "hydrogen helium", ' ', "hydrogen");
-    TESTCASE(getnastring, "258 uranium", ' ', "258");
-    TESTCASE(getnastring, "uranium258 plutonium", ' ', "uranium258");
+    TESTCASE(getnastring, "hydrogen helium", ' ', "hydrogen", BLEN("hydrogen "));
+    TESTCASE(getnastring, "258 uranium", ' ', "258", BLEN("258 "));
+    TESTCASE(getnastring, "uranium258 plutonium", ' ', "uranium258", BLEN("uranium258 "));
 
     /* The character sequence NIL is special, unless quoted */
-    TESTCASE_NULL(getnastring, "NIL by mouth", ' ');
-    TESTCASE(getnastring, "NELLY the lamb", ' ', "NELLY");
+    TESTCASE_NULL(getnastring, "NIL by mouth", ' ', BLEN("NIL "));
+    TESTCASE(getnastring, "NELLY the lamb", ' ', "NELLY", BLEN("NELLY "));
+    TESTCASE(getnastring, "NILE in Egypt", ' ', "NILE", BLEN("NILE "));
 
     /*
      * List wildcards aren't part of an atom, but Cyrus accepts them
@@ -559,8 +576,8 @@ static void test_getnastring(void)
      * which are like astrings but also allow unquoted wildcards,
      * as astrings.
      */
-    TESTCASE(getnastring, "foo*bar baz", ' ', "foo*bar");
-    TESTCASE(getnastring, "baz%quux foo", ' ', "baz%quux");
+    TESTCASE(getnastring, "foo*bar baz", ' ', "foo*bar", BLEN("foo*bar "));
+    TESTCASE(getnastring, "baz%quux foo", ' ', "baz%quux", BLEN("baz%quux "));
 
     /*
      * Various special characters are not part of atoms.
@@ -569,48 +586,48 @@ static void test_getnastring(void)
      * things which aren't in the ABNF, so we test for the liberal
      * interpretation and note the conservative one in a comment.
      */
-    TESTCASE(getnastring, "foo(bar baz", '(', "foo");
-    TESTCASE(getnastring, "foo)bar baz", ')', "foo");
-    TESTCASE(getnastring, "foo{bar baz", ' ', "foo{bar"); /* should be: '{', "foo" */
-    TESTCASE(getnastring, "foo\"bar baz", '"', "foo");
-    TESTCASE(getnastring, "foo\\bar baz", ' ', "foo\\bar"); /* should be: '\\', "foo" */
-    TESTCASE(getnastring, "foo]bar baz", ' ', "foo]bar"); /* should be ']', "foo" */
+    TESTCASE(getnastring, "foo(bar baz", '(', "foo", BLEN("foo("));
+    TESTCASE(getnastring, "foo)bar baz", ')', "foo", BLEN("foo)"));
+    TESTCASE(getnastring, "foo{bar baz", ' ', "foo{bar", BLEN("foo{bar ")); /* should be: '{', "foo" */
+    TESTCASE(getnastring, "foo\"bar baz", '"', "foo", BLEN("foo\""));
+    TESTCASE(getnastring, "foo\\bar baz", ' ', "foo\\bar", BLEN("foo\\bar ")); /* should be: '\\', "foo" */
+    TESTCASE(getnastring, "foo]bar baz", ' ', "foo]bar", BLEN("foo]bar ")); /* should be ']', "foo" */
 
     /*
      * Quoted strings are astrings
      */
-    TESTCASE(getnastring, "\"foo\" bar", ' ', "foo");
+    TESTCASE(getnastring, "\"foo\" bar", ' ', "foo", BLEN("\"foo\" "));
     /* literals with embedded space */
-    TESTCASE(getnastring, "\"NIL\" by mouth ", ' ', "NIL");
-    TESTCASE(getnastring, "\"foo bar\" baz", ' ', "foo bar");
-    TESTCASE(getnastring, "\"foo bar", EOF, "");
-    TESTCASE(getnastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar");
-    TESTCASE(getnastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar");
+    TESTCASE(getnastring, "\"NIL\" by mouth ", ' ', "NIL", BLEN("\"NIL\" "));
+    TESTCASE(getnastring, "\"foo bar\" baz", ' ', "foo bar", BLEN("\"foo bar\" "));
+    TESTCASE(getnastring, "\"foo bar", EOF, "", BLEN("\"foo bar"));
+    TESTCASE(getnastring, "\"foo\\\"bar\" baz", ' ', "foo\"bar", BLEN("\"foo\\\"bar\" "));
+    TESTCASE(getnastring, "\"foo\\\\bar\" baz", ' ', "foo\\bar", BLEN("\"foo\\\\bar\" "));
     /* Any non-special char can be escaped with \ */
-    TESTCASE(getnastring, "\"foo\\bar\" baz", ' ', "foobar");
+    TESTCASE(getnastring, "\"foo\\bar\" baz", ' ', "foobar", BLEN("\"foo\\bar\" "));
     /* \n and \r can be escaped with \ */
-    TESTCASE(getnastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar");
-    TESTCASE(getnastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar");
+    TESTCASE(getnastring, "\"foo\\\nbar\" baz", ' ', "foo\nbar", BLEN("\"foo\\\nbar\" "));
+    TESTCASE(getnastring, "\"foo\\\rbar\" baz", ' ', "foo\rbar", BLEN("\"foo\\\rbar\" "));
     /* Non-escaped \n and \r.  The server is actually more
      * conversative than the ABNF and rejects these. */
-    TESTCASE(getnastring, "\"foo\nbar\" baz", EOF, ""); /* should be ' ', "foo\nbar" */
-    TESTCASE(getnastring, "\"foo\rbar\" baz", EOF, ""); /* should be ' ', "foo\rbar" */
+    TESTCASE(getnastring, "\"foo\nbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\nbar" */
+    TESTCASE(getnastring, "\"foo\rbar\" baz", EOF, "", BLEN("\"foo")); /* should be ' ', "foo\rbar" */
 
     /*
      * Literals are astrings
      */
     /* boring literal */
-    TESTCASE(getnastring, "{3}\r\nfoo ", ' ', "foo");
+    TESTCASE(getnastring, "{3}\r\nfoo ", ' ', "foo", BLEN("{3}\r\nfoo "));
     /* literal NIL */
-    TESTCASE(getnastring, "{3}\r\nNIL ", ' ', "NIL");
+    TESTCASE(getnastring, "{3}\r\nNIL ", ' ', "NIL", BLEN("{3}\r\nNIL "));
     /* literals with embedded space */
-    TESTCASE(getnastring, "{7}\r\nfoo bar ", ' ', "foo bar");
+    TESTCASE(getnastring, "{7}\r\nfoo bar ", ' ', "foo bar", BLEN("{7}\r\nfoo bar "));
     /* literals with embedded \n or \r */
-    TESTCASE(getnastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar");
-    TESTCASE(getnastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar");
+    TESTCASE(getnastring, "{7}\r\nfoo\nbar ", ' ', "foo\nbar", BLEN("{7}\r\nfoo\nbar "));
+    TESTCASE(getnastring, "{7}\r\nfoo\rbar ", ' ', "foo\rbar", BLEN("{7}\r\nfoo\rbar "));
     /* literals with 8-bit chars */
-    TESTCASE(getnastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar");
+    TESTCASE(getnastring, "{7}\r\nfoo\277bar ", ' ', "foo\277bar", BLEN("{7}\r\nfoo\277bar ")   );
     /* literals with embedded NUL - getastring() rejects these */
-    TESTCASE(getnastring, "{7}\r\nfoo\0bar ", EOF, ""); /* should be ' ', "foo\0bar" */
+    TESTCASE(getnastring, "{7}\r\nfoo\0bar ", EOF, "", BLEN("{7}\r\nfoo\0bar")); /* should be ' ', "foo\0bar" */
 }
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/glob.testc 3.2.0-3/cunit/glob.testc
--- 3.0.13-5/cunit/glob.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/glob.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #include <stdlib.h>
 #include <unistd.h>
 #include <stdio.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "glob.h"
 
 static void test_star(void)
@@ -40,6 +40,34 @@ static void test_star(void)
     CU_ASSERT_EQUAL(r, -1);
 
     glob_free(&g);
+
+    g = glob_init(".*", '.');
+    CU_ASSERT_PTR_NOT_EQUAL_FATAL(g, NULL);
+
+    r = glob_test(g, ".foo");
+    CU_ASSERT_EQUAL(r, 4);
+
+    r = glob_test(g, "user.foo");
+    CU_ASSERT_EQUAL(r, -1);
+
+    r = glob_test(g, "user..foo");
+    CU_ASSERT_EQUAL(r, -1);
+
+    glob_free(&g);
+
+    g = glob_init(".*", '/');
+    CU_ASSERT_PTR_NOT_EQUAL_FATAL(g, NULL);
+
+    r = glob_test(g, ".foo");
+    CU_ASSERT_EQUAL(r, 4);
+
+    r = glob_test(g, "user.foo");
+    CU_ASSERT_EQUAL(r, -1);
+
+    r = glob_test(g, "user/.foo");
+    CU_ASSERT_EQUAL(r, -1);
+
+    glob_free(&g);
 }
 
 static void test_globmatch(void)
diff -pruN 3.0.13-5/cunit/guid.testc 3.2.0-3/cunit/guid.testc
--- 3.0.13-5/cunit/guid.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/guid.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/message_guid.h"
 
 static void test_guid(void)
diff -pruN 3.0.13-5/cunit/hashset.testc 3.2.0-3/cunit/hashset.testc
--- 3.0.13-5/cunit/hashset.testc	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cunit/hashset.testc	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,105 @@
+#include "cunit/cyrunit.h"
+#include "strarray.h"
+#include "util.h"
+#include "hashset.h"
+
+#define CU_ASSERT_MEMEQUAL(actual, expected, sz) \
+    CU_ASSERT_EQUAL(memcmp(actual, expected, sz), 0)
+
+static void test_new(void)
+{
+    const uint32_t exp_starts[65536] = {0};
+
+    struct hashset *hs = hashset_new(12);
+
+    CU_ASSERT_MEMEQUAL(hs->starts, exp_starts, sizeof(exp_starts));
+    CU_ASSERT_EQUAL(hs->bytesize, 12);
+    CU_ASSERT_EQUAL(hs->recsize, 12 + 4);
+    CU_ASSERT_EQUAL(hs->alloc, 0);
+    CU_ASSERT_EQUAL(hs->count, 0);
+    CU_ASSERT_PTR_NULL(hs->data);
+
+    hashset_free(&hs);
+    CU_ASSERT_PTR_NULL(hs);
+}
+
+static void test_exists(void)
+{
+    const char values[][4] = {
+        "ant", "bat", "cat", "dog",
+    };
+    const char unvalues[][4] = {
+        "zig", "yum", "wok", "vim",
+    };
+
+    int r;
+    size_t i, n;
+
+    struct hashset *hs = hashset_new(sizeof(values[0]));
+
+    n = sizeof values / sizeof values[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_add(hs, values[i]);
+        CU_ASSERT_EQUAL_FATAL(r, 1);
+    }
+
+    for (i = 0; i < n; i++) {
+        r = hashset_exists(hs, values[i]);
+        CU_ASSERT_EQUAL(r, 1);
+    }
+
+    n = sizeof unvalues / sizeof unvalues[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_exists(hs, unvalues[i]);
+        CU_ASSERT_EQUAL(r, 0);
+    }
+
+    hashset_free(&hs);
+}
+
+static void test_collisions(void)
+{
+    /* first two bytes are used for hashing, exploit this */
+    /* XXX keep this up to date if hash algorithm changes! */
+    const char values[][16] = {
+        "aaa", "aab", "aaab", "dog", "donut", "aardvark",
+        "\0\0boo", "\0\0urns",
+    };
+    const char dupvalues[][16] = {
+        "aaab", "dog",
+    };
+    const char unvalues[][16] = {
+        "aa", "doge",
+    };
+
+    size_t i, n;
+    int r;
+
+    struct hashset *hs = hashset_new(sizeof values[0]);
+
+    n = sizeof values / sizeof values[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_add(hs, values[i]);
+        CU_ASSERT_EQUAL(r, 1);
+    }
+
+    n = sizeof dupvalues / sizeof dupvalues[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_add(hs, dupvalues[i]);
+        CU_ASSERT_EQUAL(r, 0);
+    }
+
+    n = sizeof values / sizeof values[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_exists(hs, values[i]);
+        CU_ASSERT_EQUAL(r, 1);
+    }
+
+    n = sizeof unvalues / sizeof unvalues[0];
+    for (i = 0; i < n; i++) {
+        r = hashset_exists(hs, unvalues[i]);
+        CU_ASSERT_EQUAL(r, 0);
+    }
+
+    hashset_free(&hs);
+}
diff -pruN 3.0.13-5/cunit/hash.testc 3.2.0-3/cunit/hash.testc
--- 3.0.13-5/cunit/hash.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/hash.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "strarray.h"
 #include "util.h"
 #include "hash.h"
@@ -291,4 +291,60 @@ static void test_freeing_nonempty(void)
     free_hash_table(&ht, lincoln);
     CU_ASSERT_EQUAL(N, freed_count);
 }
+
+static void test_iter(void)
+{
+    hash_table ht;
+
+    /* construct an empty hash table */
+    construct_hash_table(&ht, 16, 0);
+
+    hash_insert("foo", (void*)1, &ht);
+    hash_insert("bar", (void*)2, &ht);
+    hash_insert("baz", (void*)3, &ht);
+
+    hash_iter *iter = hash_table_iter(&ht);
+
+    CU_ASSERT_PTR_NOT_NULL(iter);
+
+    /* run twice to test hash_iter_reset at end of first loop */
+    int i;
+    for (i = 0; i < 2; i++) {
+        strarray_t seen = STRARRAY_INITIALIZER;
+
+        CU_ASSERT(hash_iter_has_next(iter));
+        while (hash_iter_next(iter)) {
+            const char *key = hash_iter_key(iter);
+            CU_ASSERT_PTR_NOT_NULL(key);
+            strarray_append(&seen, key);
+
+            uintptr_t val = (uintptr_t) hash_iter_val(iter);
+            if (!strcmp(key, "foo")) {
+                CU_ASSERT_EQUAL(1, val);
+            }
+            else if (!strcmp(key, "bar")) {
+                CU_ASSERT_EQUAL(2, val);
+            }
+            else if (!strcmp(key, "baz")) {
+                CU_ASSERT_EQUAL(3, val);
+            }
+            else CU_ASSERT(0);
+
+            if (strarray_size(&seen) < 3) {
+                CU_ASSERT(hash_iter_has_next(iter));
+            }
+        }
+        CU_ASSERT(!hash_iter_has_next(iter));
+
+        CU_ASSERT_EQUAL(3, strarray_size(&seen));
+        CU_ASSERT(strarray_find(&seen, "foo", 0) >= 0);
+        CU_ASSERT(strarray_find(&seen, "bar", 0) >= 0);
+        CU_ASSERT(strarray_find(&seen, "baz", 0) >= 0);
+        strarray_fini(&seen);
+        hash_iter_reset(iter);
+    }
+
+    hash_iter_free(&iter);
+    free_hash_table(&ht, NULL);
+}
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/imapurl.testc 3.2.0-3/cunit/imapurl.testc
--- 3.0.13-5/cunit/imapurl.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/imapurl.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 #include <malloc.h>
 #include <time.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imapurl.h"
 
 static void test_fromurl_cclient(void)
diff -pruN 3.0.13-5/cunit/imparse.testc 3.2.0-3/cunit/imparse.testc
--- 3.0.13-5/cunit/imparse.testc	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cunit/imparse.testc	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,64 @@
+#include <config.h>
+
+#include "cunit/cyrunit.h"
+
+#include "lib/imparse.h"
+
+/* XXX test imparse_word() */
+
+/* XXX test imparse_astring() */
+
+/* tests for imparse_isatom() and imparse_isnatom()
+ * XXX test strings not just single chars */
+static void test_isatom(void)
+{
+    const char contains_null[] = "he\0llo";
+    const char hello[] = "hello";
+
+    /* not an atom if there's a NULL byte in the mapped space */
+    CU_ASSERT_EQUAL_FATAL(sizeof(contains_null), 7);
+    CU_ASSERT_EQUAL(imparse_isnatom(contains_null, sizeof(contains_null)), 0);
+
+    /*
+     * https://tools.ietf.org/html/rfc3501#page-81
+     *
+     * atom            = 1*ATOM-CHAR
+     *
+     * ATOM-CHAR       = <any CHAR except atom-specials>
+     *
+     * atom-specials   = "(" / ")" / "{" / SP / CTL / list-wildcards /
+     * 				     quoted-specials / resp-specials
+     *
+     * list-wildcards  = "%" / "*"
+     *
+     * quoted-specials = DQUOTE / "\"
+     *
+     * resp-specials   = "]"
+     */
+
+    /* atom-specials */
+    CU_ASSERT_EQUAL(imparse_isatom("("), 0);
+    CU_ASSERT_EQUAL(imparse_isatom(")"), 0);
+    CU_ASSERT_EQUAL(imparse_isatom("{"), 0);
+    CU_ASSERT_EQUAL(imparse_isatom(" "), 0);
+    /* XXX CTL */
+
+    /* list-wildcards */
+    CU_ASSERT_EQUAL(imparse_isatom("%"), 0);
+    CU_ASSERT_EQUAL(imparse_isatom("*"), 0);
+
+    /* quoted-specials */
+    CU_ASSERT_EQUAL(imparse_isatom("\""), 0);
+    CU_ASSERT_EQUAL(imparse_isatom("\\"), 0);
+
+    /* resp-specials */
+    // XXX - revert this when we block ] in atoms again
+    CU_ASSERT_NOT_EQUAL(imparse_isatom("]"), 0);
+
+    /* make sure it doesn't just always return zero... */
+    CU_ASSERT_NOT_EQUAL(imparse_isatom(hello), 0);
+}
+
+/* XXX test imparse_issequence() */
+
+/* XXX test imparse_isnumber() */
diff -pruN 3.0.13-5/cunit/jmap_util.testc 3.2.0-3/cunit/jmap_util.testc
--- 3.0.13-5/cunit/jmap_util.testc	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/cunit/jmap_util.testc	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,137 @@
+#include "config.h"
+#include "cunit/cyrunit.h"
+#include "xmalloc.h"
+#include "util.h"
+#include "hash.h"
+#include "imap/jmap_util.h"
+
+static void test_patchobject_create(void)
+{
+#define TESTCASE(src, dst, want) \
+    { \
+        json_t *jsrc = json_loads(src, JSON_DECODE_ANY, NULL); \
+        json_t *jdst = json_loads(dst, JSON_DECODE_ANY, NULL); \
+        \
+        json_t *jwant = json_loads(want, JSON_DECODE_ANY, NULL); \
+        json_t *jdiff = jmap_patchobject_create(jsrc, jdst); \
+        CU_ASSERT_PTR_NOT_NULL(jdiff); \
+        \
+        char *swant = json_dumps(jwant, JSON_SORT_KEYS|JSON_ENCODE_ANY); \
+        char *sdiff = json_dumps(jdiff, JSON_SORT_KEYS|JSON_ENCODE_ANY); \
+        CU_ASSERT_STRING_EQUAL(swant, sdiff); \
+        \
+        free(sdiff); \
+        free(swant); \
+        json_decref(jdiff); \
+        json_decref(jwant); \
+        json_decref(jdst); \
+        json_decref(jsrc); \
+    }
+
+    const char *src, *dst, *want;
+
+    /* Remove one property at top-level */
+    src = "{"
+    "  \"a\": 1,"
+    "  \"b\": 1"
+    "}";
+    dst = "{"
+    "  \"a\": 1"
+    "}";
+    want = "{"
+    "  \"b\": null"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Add one property at top-level */
+    src = "{"
+    "  \"a\": 1"
+    "}";
+    dst = "{"
+    "  \"a\": 1,"
+    "  \"b\": 1"
+    "}";
+    want = "{"
+    "  \"b\": 1"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Replace one scalar property at top-level with another */
+    src = "{"
+    "  \"a\": 1"
+    "}";
+    dst = "{"
+    "  \"a\": 2"
+    "}";
+    want = "{"
+    "  \"a\": 2"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Replace one object property at top-level with a scalar */
+    src = "{"
+    "  \"a\": {"
+    "    \"b\": 1"
+    "  }"
+    "}";
+    dst = "{"
+    "  \"a\": 2"
+    "}";
+    want = "{"
+    "  \"a\": 2"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Replace one scalar property at top-level with an object */
+    src = "{"
+    "  \"a\": {"
+    "    \"b\": 1"
+    "  }"
+    "}";
+    dst = "{"
+    "  \"a\": 2"
+    "}";
+    want = "{"
+    "  \"a\": 2"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Add a nested property */
+    src = "{"
+    "  \"a\": {"
+    "    \"b\": 1"
+    "  }"
+    "}";
+    dst = "{"
+    "  \"a\": {"
+    "    \"b\": 1,"
+    "    \"c\": 2"
+    "  }"
+    "}";
+    want = "{"
+    "  \"a/c\": 2"
+    "}";
+    TESTCASE(src, dst, want);
+
+    /* Remove a nested property */
+    src = "{"
+    "  \"a\": {"
+    "    \"b\": 1,"
+    "    \"c\": 2"
+    "  }"
+    "}";
+    dst = "{"
+    "  \"a\": {"
+    "    \"b\": 1"
+    "  }"
+    "}";
+    want = "{"
+    "  \"a/c\": null"
+    "}";
+    TESTCASE(src, dst, want);
+
+
+#undef TESTCASE
+}
+
+/* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/libconfig.testc 3.2.0-3/cunit/libconfig.testc
--- 3.0.13-5/cunit/libconfig.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/libconfig.testc	2020-04-24 02:03:00.000000000 +0000
@@ -39,10 +39,10 @@
  */
 
 #include <unistd.h>
+#include <sysexits.h>
 
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 
-#include "lib/exitcodes.h"
 #include "lib/libconfig.h"
 #include "lib/retry.h"
 #include "lib/xmalloc.h"
@@ -74,18 +74,18 @@ static int tear_down(void)
 
 static void test_int(void)
 {
-    int archive_days = -1;
+    int boundary_limit = -1;
     int archive_maxsize = -1;
 
     config_read_string(
         "configdirectory: "DBDIR"/conf\n"
-        "archive_days: 9\n"
+        "boundary_limit: 120\n"
         /* archive_maxsize: 1024 (default) */
     );
 
     /* test a value that has been set */
-    archive_days = config_getint(IMAPOPT_ARCHIVE_DAYS);
-    CU_ASSERT_EQUAL(archive_days, 9);
+    boundary_limit = config_getint(IMAPOPT_BOUNDARY_LIMIT);
+    CU_ASSERT_EQUAL(boundary_limit, 120);
 
     /* test a value that is defaulted */
     archive_maxsize = config_getint(IMAPOPT_ARCHIVE_MAXSIZE);
@@ -181,7 +181,7 @@ static void test_stringlist_invalid(void
         "configdirectory: "DBDIR"/conf\n"
         "annotation_db: junk\n"
     );
-    CU_EXPECT_CYRFATAL_END(EC_CONFIG, "invalid value 'junk' for annotation_db in line 2");
+    CU_EXPECT_CYRFATAL_END(EX_CONFIG, "invalid value 'junk' for annotation_db in line 2");
 }
 
 static void test_enum_value(void)
@@ -217,7 +217,7 @@ static void test_enum_invalid(void)
         "configdirectory: "DBDIR"/conf\n"
         "delete_mode: junk\n"
     );
-    CU_EXPECT_CYRFATAL_END(EC_CONFIG, "invalid value 'junk' for delete_mode in line 2");
+    CU_EXPECT_CYRFATAL_END(EX_CONFIG, "invalid value 'junk' for delete_mode in line 2");
 }
 
 static void test_bitfield_value(void)
@@ -226,13 +226,14 @@ static void test_bitfield_value(void)
 
     config_read_string(
         "configdirectory: "DBDIR"/conf\n"
-        "httpmodules: carddav freebusy\n"
+        "httpmodules: carddav freebusy jmap\n"
     );
 
     httpmodules = config_getbitfield(IMAPOPT_HTTPMODULES);
     CU_ASSERT_EQUAL(httpmodules,
                     IMAP_ENUM_HTTPMODULES_CARDDAV |
-                    IMAP_ENUM_HTTPMODULES_FREEBUSY);
+                    IMAP_ENUM_HTTPMODULES_FREEBUSY |
+                    IMAP_ENUM_HTTPMODULES_JMAP);
 }
 
 static void test_bitfield_default(void)
@@ -255,7 +256,216 @@ static void test_bitfield_invalid(void)
         "configdirectory: "DBDIR"/conf\n"
         "httpmodules: caldav junk\n"
     );
-    CU_EXPECT_CYRFATAL_END(EC_CONFIG, "invalid value 'junk' for httpmodules in line 2");
+    CU_EXPECT_CYRFATAL_END(EX_CONFIG, "invalid value 'junk' for httpmodules in line 2");
+}
+
+static void test_duration_value_days(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 3d\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 3 * 24 * 60 * 60);
+}
+
+static void test_duration_value_hours(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 3h\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 3 * 60 * 60);
+}
+
+static void test_duration_value_minutes(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 45m\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 45 * 60);
+}
+
+static void test_duration_value_seconds(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 25s\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 25);
+}
+
+static void test_duration_value_combined(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 1h30m\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 1.5 * 60 * 60);
+}
+
+static void test_duration_value_nounits(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: 13\n"
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 13);
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 'm');
+    CU_ASSERT_EQUAL(timeout, 13 * 60);
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 'h');
+    CU_ASSERT_EQUAL(timeout, 13 * 60 * 60);
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 'd');
+    CU_ASSERT_EQUAL(timeout, 13 * 60 * 60 * 24);
+}
+
+static void test_duration_value_negative(void)
+{
+    int caldav_historical_age = 0xdeadbeef;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "caldav_historical_age: -1\n"
+    );
+
+    caldav_historical_age = config_getduration(IMAPOPT_CALDAV_HISTORICAL_AGE, 'd');
+    CU_ASSERT_EQUAL(caldav_historical_age, -1 * 60 * 60 * 24);
+}
+
+static void test_duration_default(void)
+{
+    int timeout = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        /* timeout: 32m (default) */
+    );
+
+    timeout = config_getduration(IMAPOPT_TIMEOUT, 's');
+    CU_ASSERT_EQUAL(timeout, 32 * 60);
+}
+
+static void test_duration_nodefault(void)
+{
+    int plaintextloginpause = -1;
+
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        /* plaintextloginpause: <none> (default) */
+    );
+
+    plaintextloginpause = config_getduration(IMAPOPT_PLAINTEXTLOGINPAUSE, 's');
+    CU_ASSERT_EQUAL(plaintextloginpause, 0);
+}
+
+static void test_duration_invalid(void)
+{
+    CU_EXPECT_CYRFATAL_BEGIN
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "timeout: junk\n"
+    );
+    CU_EXPECT_CYRFATAL_END(EX_CONFIG, "unparsable duration 'junk' for timeout in line 2");
+}
+
+struct duration_parse_data {
+    const char *str;
+    int expected_result;
+    int expected_duration;
+};
+
+static const struct duration_parse_data duration_parse_tests[] = {
+    { "", 0, 0 },
+    { "0", 0, 0 },
+    { "0s", 0, 0 },
+    { "0m", 0, 0 },
+    { "0h", 0, 0 },
+    { "0d", 0, 0 },
+    { "0h0m", 0, 0 },
+    { "0h0m0s", 0, 0 },
+    { "0h0m1s", 0, 1 },
+    { "1", 0, 1 },
+    { "1s", 0, 1 },
+    { "1m", 0, 60 },
+    { "1h", 0, 60 * 60 },
+    { "1d", 0, 24 * 60 * 60 },
+    { "123", 0, 123 },
+    { "123s", 0, 123 },
+    { "123m", 0, 123 * 60 },
+    { "123h", 0, 123 * 60 * 60 },
+    { "123d", 0, 123 * 24 * 60 * 60 },
+    { "1m1", 0, 60 + 1 },
+    { "1m1s", 0, 60 + 1 },
+    { "1h1m", 0, (60 * 60) + 60 },
+    { "1h1s", 0, (60 * 60) + 1 },
+    { "1d1h", 0, (24 * 60 * 60) + (60 * 60) },
+    { "1h1m1s", 0, (60 * 60) + 60 + 1 },
+    { "1m1m", 0, 60 + 60 },
+    { "123m456", 0, (123 * 60) + 456 },
+    { "123m456s", 0, (123 * 60) + 456 },
+    { "123h456m", 0, (123 * 60 * 60) + (456 * 60) },
+    { "123h456s", 0, (123 * 60 * 60) + 456 },
+    { "123d456h", 0, (123 * 24 * 60 * 60) + (456 * 60 * 60) },
+    { "123h456m789s", 0, (123 * 60 * 60) + (456 * 60) + 789 },
+    { "123m456m", 0, (123 * 60) + (456 * 60) },
+
+    { "0c", -1, 0xdeadbeef },
+    { "1c", -1, 0xdeadbeef },
+    { "123c", -1, 0xdeadbeef },
+    { "1h1c", -1, 0xdeadbeef },
+    { "1c23s", -1, 0xdeadbeef },
+
+    { "-1", 0, -1 },
+    { "-0", 0, 0 },
+    { "--1", -1, 0xdeadbeef },
+    { "-1s", 0, -1 },
+    { "-1m", 0, -60 },
+    { "1-2m", -1, 0xdeadbeef },
+
+    { "1h1h", 0, 2 * 60 * 60 }, /* silly, but let it work */
+    { "1hh", -1, 0xdeadbeef }, /* bogus, reject it */
+    { "1hhh", -1, 0xdeadbeef }, /* bogus, reject it */
+};
+
+static void test_duration_parse(void)
+{
+    const size_t n = sizeof(duration_parse_tests) / sizeof(duration_parse_tests[0]);
+    size_t i;
+
+    for (i = 0; i < n; i++) {
+        const struct duration_parse_data *test = &duration_parse_tests[i];
+        int duration = 0xdeadbeef;
+        int r = config_parseduration(test->str, 's', &duration);
+        CU_ASSERT_EQUAL(r, test->expected_result);
+        CU_ASSERT_EQUAL(duration, test->expected_duration);
+    }
 }
 
 static void test_magic_configdirectory_value(void)
@@ -286,4 +496,214 @@ static void test_magic_configdirectory_d
     CU_ASSERT_STRING_EQUAL(idlesocket, DBDIR"/conf/socket/idle");
 }
 
+static void test_deprecated_int(void)
+{
+    /* { "autocreatequota", 0, INT, "2.5.0", "autocreate_quota" } */
+    int val;
+
+    /* set the deprecated name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "autocreatequota: 12\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should not be able to read the deprecated name */
+    CU_EXPECT_CYRFATAL_BEGIN
+    val = config_getint(IMAPOPT_AUTOCREATEQUOTA);
+    CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+        "Option 'autocreatequota' is deprecated in favor of "
+        "'autocreate_quota' since version 2.5.0.");
+
+    /* should be able to read the value at the new name */
+    val = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
+    CU_ASSERT_EQUAL(val, 12);
+
+    /* set the new name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "autocreate_quota: 12\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 0);
+
+    /* should be able to read it at the new name */
+    val = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
+    CU_ASSERT_EQUAL(val, 12);
+
+    /* set both names to different values */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "autocreatequota: 12\n"
+        "autocreate_quota: 15\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should read new value at the new name */
+    val = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
+    CU_ASSERT_EQUAL(val, 15);
+}
+
+static void test_deprecated_string(void)
+{
+    /* { "tlscache_db_path", NULL, STRING, "2.5.0", "tls_sessions_db_path" } */
+    const char *val;
+
+    /* set the deprecated name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tlscache_db_path: foo\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should not be able to read the deprecated name */
+    CU_EXPECT_CYRFATAL_BEGIN
+    val = config_getstring(IMAPOPT_TLSCACHE_DB_PATH);
+    CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+        "Option 'tlscache_db_path' is deprecated in favor of "
+        "'tls_sessions_db_path' since version 2.5.0.");
+
+    /* should be able to read the value at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB_PATH);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "foo");
+
+    /* set the new name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tls_sessions_db_path: foo\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 0);
+
+    /* should be able to read it at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB_PATH);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "foo");
+
+    /* set both names to different values */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tlscache_db_path: foo\n"
+        "tls_sessions_db_path: bar\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should read new value at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB_PATH);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "bar");
+}
+
+static void test_deprecated_stringlist(void)
+{
+    /* { "tlscache_db", "twoskip",
+     *   STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"),
+     *   "2.5.0", "tls_sessions_db" }
+     */
+    const char *val;
+
+    /* set the deprecated name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tlscache_db: sql\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should not be able to read the deprecated name */
+    CU_EXPECT_CYRFATAL_BEGIN
+    val = config_getstring(IMAPOPT_TLSCACHE_DB);
+    CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+        "Option 'tlscache_db' is deprecated in favor of "
+        "'tls_sessions_db' since version 2.5.0.");
+
+    /* should be able to read it at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "sql");
+
+    /* set the new name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tls_sessions_db: sql\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 0);
+
+    /* should be able to read it at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "sql");
+
+    /* set both names to different values */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "tlscache_db: sql\n"
+        "tls_sessions_db: zeroskip\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should read new value at the new name */
+    val = config_getstring(IMAPOPT_TLS_SESSIONS_DB);
+    CU_ASSERT_PTR_NOT_NULL(val);
+    CU_ASSERT_STRING_EQUAL(val, "zeroskip");
+}
+
+static void test_deprecated_duration(void)
+{
+    /* { "archive_days", "7d", DURATION, "3.1.8", "archive_after" } */
+    /* { "archive_after", "7d", DURATION } */
+    int val;
+
+    /* set the deprecated name only */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "archive_days: 8\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should not be able to read the deprecated name */
+    CU_EXPECT_CYRFATAL_BEGIN;
+    val = config_getduration(IMAPOPT_ARCHIVE_DAYS, 'd');
+    CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+        "Option 'archive_days' is deprecated in favor of "
+        "'archive_after' since version 3.1.8.");
+
+    /* should be able to read it at the new name */
+    val = config_getduration(IMAPOPT_ARCHIVE_AFTER, 'd');
+    CU_ASSERT_EQUAL(val, 8 * 24 * 60 * 60);
+
+    /* set the new name */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "archive_after: 12d\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 0);
+
+    /* should be able to read it at the new name */
+    val = config_getduration(IMAPOPT_ARCHIVE_AFTER, 'd');
+    CU_ASSERT_EQUAL(val, 12 * 24 * 60 * 60);
+
+    /* set both names to different values */
+    CU_SYSLOG_MATCH("Option '.*' is deprecated");
+    config_read_string(
+        "configdirectory: "DBDIR"/conf\n"
+        "archive_days: 7\n"
+        "archive_after: 12d\n"
+    );
+    CU_ASSERT_SYSLOG(/*all*/0, 1);
+
+    /* should read new value at the new name */
+    val = config_getduration(IMAPOPT_ARCHIVE_AFTER, 'd');
+    CU_ASSERT_EQUAL(val, 12 * 24 * 60 * 60);
+}
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/mboxname.testc 3.2.0-3/cunit/mboxname.testc
--- 3.0.13-5/cunit/mboxname.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/mboxname.testc	2020-04-24 02:03:00.000000000 +0000
@@ -2,7 +2,7 @@
 #include <config.h>
 #endif
 #include <assert.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "libconfig.h"
 #include "imap/mboxname.h"
 #include "imap/mailbox.h"
@@ -50,6 +50,35 @@ static void test_dir_hash_c(void)
     CU_ASSERT_EQUAL(c, 'J');
 }
 
+static void test_mboxname_hash(void)
+{
+    static const char FRED[] = "fred";
+    static const char JANEAT_SENT[] = "bloggs.com!user.jane.Sent";
+    char s[MAX_MAILBOX_PATH];
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", FRED);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/fred");
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", JANEAT_SENT);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/domain/bloggs.com/user/jane/Sent");
+
+    config_hashimapspool = 1;
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", FRED);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/f/fred");
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", JANEAT_SENT);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/domain/b/bloggs.com/j/user/jane/Sent");
+
+    config_fulldirhash = 1;
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", FRED);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/E/fred");
+
+    mboxname_hash(s, MAX_MAILBOX_PATH, "/tmp", JANEAT_SENT);
+    CU_ASSERT_STRING_EQUAL(s, "/tmp/domain/L/bloggs.com/I/user/jane/Sent");
+}
+
 static void test_to_parts(void)
 {
     static const char FRED_DRAFTS[] = "user.fred.Drafts";
@@ -667,6 +696,39 @@ static void test_toexternal_specials(voi
     toexternal_helper("bloggs.com!user.fred.*!^", "INBOX/*!.");
 }
 
+static void test_virtdomains_at(void)
+{
+    memset(&conf, 0, sizeof(conf));
+    conf.userid = "fred";
+
+    toexternal_helper("user.fred.a@b", "INBOX.a@b");
+
+    conf.unixhierarchysep = 1;
+
+    toexternal_helper("user.fred.a@b", "INBOX/a@b");
+
+    conf.userid = "fred@bloggs.com";
+    conf.virtdomains = 1;
+    conf.unixhierarchysep = 0;
+
+    toexternal_helper("bloggs.com!user.fred.a@b", "INBOX.a@b");
+
+    conf.unixhierarchysep = 1;
+
+    toexternal_helper("bloggs.com!user.fred.a@b", "INBOX/a@b");
+
+    conf.defdomain = "bloggs.com";
+    conf.userid = "fred";
+
+    conf.unixhierarchysep = 0;
+
+    toexternal_helper("user.fred.a@b", "INBOX.a@b");
+
+    conf.unixhierarchysep = 1;
+
+    toexternal_helper("user.fred.a@b", "INBOX/a@b");
+}
+
 static void test_toexternal_unixhier(void)
 {
     memset(&conf, 0, sizeof(conf));
@@ -705,6 +767,21 @@ static void test_toexternal_alt(void)
     toexternal_helper("shared.quux", "Chaired.shared.quux");
 }
 
+static void test_contains_parent(void)
+{
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.B", "user"));
+    CU_ASSERT_EQUAL(1, mboxname_contains_parent("user.foo.B", "user.foo"));
+    CU_ASSERT_EQUAL(1, mboxname_contains_parent("user.foo.B", "user.foo.A"));
+    CU_ASSERT_EQUAL(1, mboxname_contains_parent("user.foo.B", "user.foo.A.sub"));
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.B.sub", "user.foo"));
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.B.sub", "user.foo.A"));
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.B.sub", "user.foo.A.sub"));
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.BA.sub", "user.foo.B.sub"));
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("user.foo.B.A", "user.foo.BA"));
+    // this one is a bit fun - shared has no parent, so should be OK anywhere
+    CU_ASSERT_EQUAL(0, mboxname_contains_parent("shared", "user.foo.A"));
+}
+
 static void test_nextmodseq(void)
 {
     static const char FREDNAME[] = "bloggs.com!user.fred";
@@ -730,6 +807,33 @@ static void test_nextmodseq(void)
     CU_ASSERT_EQUAL(mboxname_nextmodseq(FREDNAME, 5, 0, 0), 102);
 }
 
+static void test_common_ancestor(void)
+{
+    char *ancestor;
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B", "user.foo.A");
+    CU_ASSERT_PTR_NULL(ancestor);
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B", "user.foo.C.D");
+    CU_ASSERT_PTR_NULL(ancestor);
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B.C", "user.foo.A.B");
+    CU_ASSERT_STRING_EQUAL("user.foo.A", ancestor);
+    free(ancestor);
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B.C", "user.foo.A.X.Y");
+    CU_ASSERT_STRING_EQUAL("user.foo.A", ancestor);
+    free(ancestor);
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B.C", "user.bar.A.B");
+    CU_ASSERT_PTR_NULL(ancestor);
+
+    ancestor = mboxname_common_ancestor("user.foo.A.B.C", "user.bar.A.X.Y");
+    CU_ASSERT_PTR_NULL(ancestor);
+}
+
+
+
 static enum enum_value old_config_virtdomains;
 static union config_value old_config_unixhierarchysep;
 static union config_value old_config_altnamespace;
diff -pruN 3.0.13-5/cunit/md5.testc 3.2.0-3/cunit/md5.testc
--- 3.0.13-5/cunit/md5.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/md5.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "md5.h"
 
 static const char *asciify(unsigned char mac[16])
diff -pruN 3.0.13-5/cunit/message.testc 3.2.0-3/cunit/message.testc
--- 3.0.13-5/cunit/message.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/message.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #if HAVE_CONFIG_H
 #include <config.h>
 #endif
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "parseaddr.h"
 #include "util.h"
 #include "imap/mailbox.h"
@@ -22,7 +22,7 @@ static void test_parse_trivial(void)
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -77,7 +77,7 @@ static void test_parse_trivial(void)
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT(strstr(body.cacheheaders.s, "Norman") != NULL);
+    CU_ASSERT(strstr(buf_cstring(&body.cacheheaders), "Norman") != NULL);
 
     message_free_body(&body);
 }
@@ -106,7 +106,7 @@ static void test_parse_simple(void)
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -182,7 +182,7 @@ static void test_parse_simple(void)
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT(strstr(body.cacheheaders.s, "Norman") != NULL);
+    CU_ASSERT(strstr(buf_cstring(&body.cacheheaders), "Norman") != NULL);
 
     message_free_body(&body);
 }
@@ -277,7 +277,7 @@ static void test_parse_rxdate(void)
 
     /* Neither: no received_date */
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg_neither, sizeof(msg_neither)-1, &body);
+    r = message_parse_mapped(msg_neither, sizeof(msg_neither)-1, &body, NULL);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NULL(body.received_date);
     message_free_body(&body);
@@ -285,7 +285,7 @@ static void test_parse_rxdate(void)
     /* Received only: first seen Received */
     memset(&body, 0x45, sizeof(body));
     r = message_parse_mapped(msg_only_received,
-                             sizeof(msg_only_received)-1, &body);
+                             sizeof(msg_only_received)-1, &body, NULL);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_STRING_EQUAL(body.received_date, FIRST_RX);
     message_free_body(&body);
@@ -293,7 +293,7 @@ static void test_parse_rxdate(void)
     /* X-DeliveredInternalDate only: use that */
     memset(&body, 0x45, sizeof(body));
     r = message_parse_mapped(msg_only_xdid,
-                             sizeof(msg_only_xdid)-1, &body);
+                             sizeof(msg_only_xdid)-1, &body, NULL);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_STRING_EQUAL(body.received_date, DELIVERED);
     message_free_body(&body);
@@ -301,7 +301,7 @@ static void test_parse_rxdate(void)
     /* both, Received first: use X-DeliveredInternalDate */
     memset(&body, 0x45, sizeof(body));
     r = message_parse_mapped(msg_received_then_xdid,
-                             sizeof(msg_received_then_xdid)-1, &body);
+                             sizeof(msg_received_then_xdid)-1, &body, NULL);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_STRING_EQUAL(body.received_date, DELIVERED);
     message_free_body(&body);
@@ -309,7 +309,7 @@ static void test_parse_rxdate(void)
     /* both, X-DeliveredInternalDate first: use X-DeliveredInternalDate */
     memset(&body, 0x45, sizeof(body));
     r = message_parse_mapped(msg_xdid_then_received,
-                             sizeof(msg_xdid_then_received)-1, &body);
+                             sizeof(msg_xdid_then_received)-1, &body, NULL);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_STRING_EQUAL(body.received_date, DELIVERED);
     message_free_body(&body);
@@ -338,7 +338,7 @@ static void test_mime_trivial(void)
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -368,7 +368,7 @@ static void test_mime_trivial(void)
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT(strstr(body.cacheheaders.s, "Norman") != NULL);
+    CU_ASSERT(strstr(buf_cstring(&body.cacheheaders), "Norman") != NULL);
     CU_ASSERT_PTR_NULL(body.subpart[0].cacheheaders.s);
 
     message_free_body(&body);
@@ -430,7 +430,7 @@ HTML_PART "\r\n"
     struct bodypart **parts = NULL;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -507,7 +507,7 @@ HTML_PART "\r\n"
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT(strstr(body.cacheheaders.s, "Norman") != NULL);
+    CU_ASSERT(strstr(buf_cstring(&body.cacheheaders), "Norman") != NULL);
     CU_ASSERT_PTR_NULL(body.subpart[0].cacheheaders.s);
     CU_ASSERT_PTR_NULL(body.subpart[1].cacheheaders.s);
     CU_ASSERT_PTR_NULL(body.subpart[2].cacheheaders.s);
@@ -542,7 +542,7 @@ static void test_rfc2231_continuations(v
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -591,7 +591,7 @@ static void test_rfc2231_extended_contin
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -629,7 +629,7 @@ static void test_references(void)
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -662,7 +662,7 @@ static void test_x_me_message_id(void)
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -737,7 +737,7 @@ HTML_PART "\r\n"
     struct bodypart **parts = NULL;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -814,7 +814,7 @@ HTML_PART "\r\n"
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT(strstr(body.cacheheaders.s, "Norman") != NULL);
+    CU_ASSERT(strstr(buf_cstring(&body.cacheheaders), "Norman") != NULL);
     CU_ASSERT_PTR_NULL(body.subpart[0].cacheheaders.s);
     CU_ASSERT_PTR_NULL(body.subpart[1].cacheheaders.s);
     CU_ASSERT_PTR_NULL(body.subpart[2].cacheheaders.s);
@@ -876,7 +876,7 @@ HTML_PART "\r\n"
     struct body *part;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -884,9 +884,12 @@ HTML_PART "\r\n"
     CU_ASSERT_STRING_EQUAL(body.type, "MULTIPART");
     CU_ASSERT_STRING_EQUAL(body.subtype, "RELATED");
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.params);
-    CU_ASSERT_STRING_EQUAL(body.params->attribute, "BOUNDARY");
-    CU_ASSERT_STRING_EQUAL(body.params->value, "_related");
-    CU_ASSERT_PTR_NULL(body.params->next);
+    CU_ASSERT_STRING_EQUAL(body.params->attribute, "TYPE");
+    CU_ASSERT_STRING_EQUAL(body.params->value, "text/html");
+    CU_ASSERT_PTR_NOT_NULL_FATAL(body.params->next);
+    CU_ASSERT_STRING_EQUAL(body.params->next->attribute, "BOUNDARY");
+    CU_ASSERT_STRING_EQUAL(body.params->next->value, "_related");
+    CU_ASSERT_PTR_NULL(body.params->next->next);
 
     CU_ASSERT_EQUAL(body.numparts, 2);
     CU_ASSERT_PTR_NOT_NULL(body.subpart);
@@ -1088,7 +1091,7 @@ static void test_cache_simple(void)
     struct body *body = xzmalloc(sizeof(struct body));
 
     memset(body, 0x45, sizeof(struct body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -1126,7 +1129,7 @@ static void test_cache_appleheaders(void
     struct body body;
 
     memset(&body, 0x45, sizeof(body));
-    r = message_parse_mapped(msg, sizeof(msg)-1, &body);
+    r = message_parse_mapped(msg, sizeof(msg)-1, &body, NULL);
 
     CU_ASSERT_EQUAL(r, 0);
 
@@ -1187,19 +1190,19 @@ static void test_cache_appleheaders(void
 
     /* check cacheheaders */
     CU_ASSERT_PTR_NOT_NULL_FATAL(body.cacheheaders.s);
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "X-Universally-Unique-Identifier"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "fake-uuid"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "X-Uniform-Type-Identifier"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "fake-uti"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "X-Apple-Base-Url"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "fake-baseurl"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "X-Apple-Mail-Remote-Attachments"));
-    CU_ASSERT_PTR_NOT_NULL(strstr(body.cacheheaders.s, "fake-remoteattach"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "X-Universally-Unique-Identifier"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "fake-uuid"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "X-Uniform-Type-Identifier"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "fake-uti"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "X-Apple-Base-Url"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "fake-baseurl"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "X-Apple-Mail-Remote-Attachments"));
+    CU_ASSERT_PTR_NOT_NULL(strstr(buf_cstring(&body.cacheheaders), "fake-remoteattach"));
 
     /* make sure we're not caching every x- header, just the ones we like */
     CU_ASSERT_EQUAL(mailbox_cached_header("X-Dont-Cache-This"), BIT32_MAX);
-    CU_ASSERT_PTR_NULL(strstr(body.cacheheaders.s, "X-Dont-Cache-This"));
-    CU_ASSERT_PTR_NULL(strstr(body.cacheheaders.s, "dont-cache-this"));
+    CU_ASSERT_PTR_NULL(strstr(buf_cstring(&body.cacheheaders), "X-Dont-Cache-This"));
+    CU_ASSERT_PTR_NULL(strstr(buf_cstring(&body.cacheheaders), "dont-cache-this"));
 
     message_free_body(&body);
 }
diff -pruN 3.0.13-5/cunit/msgid.testc 3.2.0-3/cunit/msgid.testc
--- 3.0.13-5/cunit/msgid.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/msgid.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #if HAVE_CONFIG_H
 #include <config.h>
 #endif
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/global.h"
 
 static void test_simple(void)
diff -pruN 3.0.13-5/cunit/parseaddr.testc 3.2.0-3/cunit/parseaddr.testc
--- 3.0.13-5/cunit/parseaddr.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/parseaddr.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include <malloc.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "parseaddr.h"
 
 static void test_single(void)
@@ -700,4 +700,39 @@ static void test_getparts_nodomain(void)
     parseaddr_free(a);
 }
 
+static void test_quoted_crlf(void)
+{
+    struct address *head, *a;
+
+    a = NULL;
+    parseaddr_list("foo@example.com, bar@example.com,\r\n  \"Baz\\\r\n Baz\" <baz@example.com>,\r\n  bam@example.com", &a);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(a);
+    head = a;
+
+    CU_ASSERT_PTR_NULL(a->name);
+    CU_ASSERT_STRING_EQUAL(a->mailbox, "foo");
+    CU_ASSERT_STRING_EQUAL(a->domain, "example.com");
+    CU_ASSERT_PTR_NOT_NULL(a->next);
+
+    a = a->next;
+    CU_ASSERT_PTR_NULL(a->name);
+    CU_ASSERT_STRING_EQUAL(a->mailbox, "bar");
+    CU_ASSERT_STRING_EQUAL(a->domain, "example.com");
+    CU_ASSERT_PTR_NOT_NULL(a->next);
+
+    a = a->next;
+    CU_ASSERT_STRING_EQUAL(a->name, "Baz Baz");
+    CU_ASSERT_STRING_EQUAL(a->mailbox, "baz");
+    CU_ASSERT_STRING_EQUAL(a->domain, "example.com");
+    CU_ASSERT_PTR_NOT_NULL(a->next);
+
+    a = a->next;
+    CU_ASSERT_PTR_NULL(a->name);
+    CU_ASSERT_STRING_EQUAL(a->mailbox, "bam");
+    CU_ASSERT_STRING_EQUAL(a->domain, "example.com");
+    CU_ASSERT_PTR_NULL(a->next);
+
+    parseaddr_free(head);
+}
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/parse.testc 3.2.0-3/cunit/parse.testc
--- 3.0.13-5/cunit/parse.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/parse.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,41 +1,91 @@
+#include <sysexits.h>
+
 #include "config.h"
-#include "cunit/cunit.h"
-#include "exitcodes.h"
+#include "cunit/cyrunit.h"
 #include "xmalloc.h"
 #include "prot.h"
 #include "imap/global.h"
 #include "util.h"
 
-#define CANARY          0xdeadbeef
-#define CANARY64        0xdeadbeefcafebabe
+#define CANARY          0xdeadbeefcafebabe
 
 static void test_parsenum(void)
 {
-    const char NUM[] = "18338747846901181684 some other stuff";
-    bit64 val = CANARY64;
+    const char NUM0[] = "0 some other stuf";
+    const char NUM1[] = "1somestuff";
+    const char NUMBIG[] = "18446744073709551615ULL"; // non-digits parse OK
+    const char NUMTOOBIG[] = "18446744073709551616";
+    bit64 val = CANARY;
     int r;
 
-    r = parsenum(NUM, NULL, strlen(NUM), &val);
+    r = parsenum(NUM0, NULL, strlen(NUM0), &val);
+    CU_ASSERT_EQUAL(r, 0);
+    CU_ASSERT_EQUAL(val, 0);
+
+    val = CANARY;
+    r = parsenum(NUM1, NULL, strlen(NUM1), &val);
     CU_ASSERT_EQUAL(r, 0);
-    CU_ASSERT_EQUAL(val, 18338747846901181684LLU);
+    CU_ASSERT_EQUAL(val, 1);
+
+    val = CANARY;
+    r = parsenum(NUMBIG, NULL, strlen(NUMBIG), &val);
+    CU_ASSERT_EQUAL(r, 0);
+    CU_ASSERT_EQUAL(val, 18446744073709551615ULL);
+
+    val = CANARY;
+    r = parsenum(NUMTOOBIG, NULL, strlen(NUMTOOBIG), &val);
+    CU_ASSERT_EQUAL(r, -1);
 }
 
-int wrap_getint32(const char *s, int32_t *valp)
+static void test_parsehex(void)
 {
-    struct protstream *prot;
-    char *b;
-    int c;
+    const char NUM0[] = "0 some other stuf";
+    const char NUM1[] = "1somestuff";
+    const char NUMBIG[] = "ffffffffffffffff";
+    const char NUMTOOBIG[] = "10000000000000000";
+    bit64 val = CANARY;
+    int r;
+
+    r = parsehex(NUM0, NULL, strlen(NUM0), &val);
+    CU_ASSERT_EQUAL(r, 0);
+    CU_ASSERT_EQUAL(val, 0);
+
+    val = CANARY;
+    r = parsehex(NUM1, NULL, strlen(NUM1), &val);
+    CU_ASSERT_EQUAL(r, 0);
+    CU_ASSERT_EQUAL(val, 1);
 
-    b = xstrdup(s);     /* work around bug in prot_ungetc */
-    prot = prot_readmap(b, strlen(b));
-    *valp = CANARY;
-    c = getint32(prot, valp);
-    free(b);
-    prot_free(prot);
+    val = CANARY;
+    r = parsehex(NUMBIG, NULL, strlen(NUMBIG), &val);
+    CU_ASSERT_EQUAL(r, 0);
+    CU_ASSERT_EQUAL(val, 18446744073709551615ULL);
 
-    return c;
+    val = CANARY;
+    r = parsehex(NUMTOOBIG, NULL, strlen(NUMTOOBIG), &val);
+    CU_ASSERT_EQUAL(r, -1);
 }
 
+#define wrap_int_parser(func, type, s, outp, valp, inp) do          \
+{                                                                   \
+    struct protstream *prot;                                        \
+    char *b;                                                        \
+                                                                    \
+    int *outp__ = (outp);                                           \
+    type *valp__ = (valp);                                          \
+    int *inp__ = (inp);                                             \
+                                                                    \
+    b = xstrdup(s); /* work around bug in prot_ungetc */            \
+    prot = prot_readmap(b, strlen(b));                              \
+                                                                    \
+    *valp__ = (type) CANARY;                                        \
+    *outp__ = func(prot, valp__);                                   \
+    if (inp__) *inp__ = prot_bytes_in(prot);                        \
+                                                                    \
+    prot_free(prot);                                                \
+    free(b);                                                        \
+} while(0)
+
+
 static void test_getint32(void)
 {
     static const char STR1[] = "0 ";
@@ -52,67 +102,57 @@ static void test_getint32(void)
     static const char STR8[] = "+123 ";
     int32_t val;
     int c;
+    int bytes_in;
 
     /* test a valid zero value */
-    c = wrap_getint32(STR1, &val);
+    wrap_int_parser(getint32, int32_t, STR1, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
 
     /* test a valid value with all the digits */
-    c = wrap_getint32(STR2, &val);
+    wrap_int_parser(getint32, int32_t, STR2, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
 
     /* test a string with too many digits */
     CU_EXPECT_CYRFATAL_BEGIN;
-        c = wrap_getint32(STR3, &val);
-    CU_EXPECT_CYRFATAL_END(EC_IOERR, "num too big");
+        wrap_int_parser(getint32, int32_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
 
     /* test a valid value with a different terminator */
-    c = wrap_getint32(STR4, &val);
+    wrap_int_parser(getint32, int32_t, STR4, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ')');
     CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
 
     /* test an invalid string */
-    c = wrap_getint32(STR5, &val);
+    wrap_int_parser(getint32, int32_t, STR5, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 
     /* test the corner case where we encounter EOF
      * at the end of a valid string of digits */
-    c = wrap_getint32(STR6, &val);
+    wrap_int_parser(getint32, int32_t, STR6, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
 
     /* test a leading - */
-    c = wrap_getint32(STR7, &val);
-    /* this would have succeeded if getint32() weren't broken */
+    wrap_int_parser(getint32, int32_t, STR7, &c, &val, NULL);
+    /* XXX this would have succeeded if getint32() weren't broken */
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
 
     /* test a leading + */
-    c = wrap_getint32(STR8, &val);
-    /* this would have succeeded if getint32() weren't broken */
+    wrap_int_parser(getint32, int32_t, STR8, &c, &val, NULL);
+    /* XXX this would have succeeded if getint32() weren't broken */
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
 }
 
-int wrap_getsint32(const char *s, int32_t *valp)
-{
-    struct protstream *prot;
-    char *b;
-    int c;
-
-    b = xstrdup(s);     /* work around bug in prot_ungetc */
-    prot = prot_readmap(b, strlen(b));
-    *valp = CANARY;
-    c = getsint32(prot, valp);
-    free(b);
-    prot_free(prot);
-
-    return c;
-}
-
 static void test_getsint32(void)
 {
     static const char STR1[] = "0 ";
@@ -131,63 +171,325 @@ static void test_getsint32(void)
     static const int32_t VAL8 = 123;
     int32_t val;
     int c;
+    int bytes_in;
+
+    /* test a valid zero value */
+    wrap_int_parser(getsint32, int32_t, STR1, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
+
+    /* test a valid value with all the digits */
+    wrap_int_parser(getsint32, int32_t, STR2, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
+
+    /* test a string with too many digits */
+    CU_EXPECT_CYRFATAL_BEGIN;
+        wrap_int_parser(getsint32, int32_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
+
+    /* test a valid value with a different terminator */
+    wrap_int_parser(getsint32, int32_t, STR4, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ')');
+    CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
+
+    /* test an invalid string */
+    wrap_int_parser(getsint32, int32_t, STR5, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test the corner case where we encounter EOF
+     * at the end of a valid string of digits */
+    wrap_int_parser(getsint32, int32_t, STR6, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
+
+    /* test a leading - */
+    wrap_int_parser(getsint32, int32_t, STR7, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL7);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR7));
+
+    /* test a leading + */
+    wrap_int_parser(getsint32, int32_t, STR8, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL8);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR8));
+}
+
+static void test_getuint32(void)
+{
+    static const char STR1[] = "0 ";
+    static const uint32_t VAL1 = 0;
+    static const char STR2[] = "1234567890 ";
+    static const uint32_t VAL2 = 1234567890;
+    static const char STR3[] = "12345678901234567890 ";
+    static const char STR4[] = "123)";
+    static const uint32_t VAL4 = 123;
+    static const char STR5[] = "y&+123 ";
+    static const char STR6[] = "123";
+    static const uint32_t VAL6 = 123;
+    static const char STR7[] = "-123 ";
+    static const char STR8[] = "+123 ";
+    uint32_t val;
+    int c;
+    int bytes_in;
+
+    /* test a valid zero value */
+    wrap_int_parser(getuint32, uint32_t, STR1, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
+
+    /* test a valid value with all the digits */
+    wrap_int_parser(getuint32, uint32_t, STR2, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
+
+    /* test a string with too many digits */
+    CU_EXPECT_CYRFATAL_BEGIN;
+        wrap_int_parser(getuint32, uint32_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
+
+    /* test a valid value with a different terminator */
+    wrap_int_parser(getuint32, uint32_t, STR4, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ')');
+    CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
+
+    /* test an invalid string */
+    wrap_int_parser(getuint32, uint32_t, STR5, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test the corner case where we encounter EOF
+     * at the end of a valid string of digits */
+    wrap_int_parser(getuint32, uint32_t, STR6, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
+
+    /* test a leading - */
+    wrap_int_parser(getuint32, uint32_t, STR7, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test a leading + */
+    wrap_int_parser(getuint32, uint32_t, STR8, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+}
+
+static void test_getint64(void)
+{
+    static const char STR1[] = "0 ";
+    static const int64_t VAL1 = 0;
+    static const char STR2[] = "1234567890 ";
+    static const int64_t VAL2 = 1234567890;
+    static const char STR3[] = "12345678901234567890 ";
+    static const char STR4[] = "123)";
+    static const int64_t VAL4 = 123;
+    static const char STR5[] = "y&+123 ";
+    static const char STR6[] = "123";
+    static const int64_t VAL6 = 123;
+    static const char STR7[] = "-123 ";
+    static const char STR8[] = "+123 ";
+    int64_t val;
+    int c;
+    int bytes_in;
 
     /* test a valid zero value */
-    c = wrap_getsint32(STR1, &val);
+    wrap_int_parser(getint64, int64_t, STR1, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
 
     /* test a valid value with all the digits */
-    c = wrap_getsint32(STR2, &val);
+    wrap_int_parser(getint64, int64_t, STR2, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
 
     /* test a string with too many digits */
     CU_EXPECT_CYRFATAL_BEGIN;
-        c = wrap_getsint32(STR3, &val);
-    CU_EXPECT_CYRFATAL_END(EC_IOERR, "num too big");
+        wrap_int_parser(getint64, int64_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
 
     /* test a valid value with a different terminator */
-    c = wrap_getsint32(STR4, &val);
+    wrap_int_parser(getint64, int64_t, STR4, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ')');
     CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
 
     /* test an invalid string */
-    c = wrap_getsint32(STR5, &val);
+    wrap_int_parser(getint64, int64_t, STR5, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 
     /* test the corner case where we encounter EOF
      * at the end of a valid string of digits */
-    c = wrap_getsint32(STR6, &val);
+    wrap_int_parser(getint64, int64_t, STR6, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
 
     /* test a leading - */
-    c = wrap_getsint32(STR7, &val);
+    wrap_int_parser(getint64, int64_t, STR7, &c, &val, NULL);
+    /* XXX this would have succeeded if getint64() weren't broken */
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+
+    /* test a leading + */
+    wrap_int_parser(getint64, int64_t, STR8, &c, &val, NULL);
+    /* XXX this would have succeeded if getint64() weren't broken */
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+}
+
+static void test_getsint64(void)
+{
+    static const char STR1[] = "0 ";
+    static const int64_t VAL1 = 0;
+    static const char STR2[] = "1234567890 ";
+    static const int64_t VAL2 = 1234567890;
+    static const char STR3[] = "12345678901234567890 ";
+    static const char STR4[] = "123)";
+    static const int64_t VAL4 = 123;
+    static const char STR5[] = "y&+123 ";
+    static const char STR6[] = "123";
+    static const int64_t VAL6 = 123;
+    static const char STR7[] = "-123 ";
+    static const int64_t VAL7 = -123;
+    static const char STR8[] = "+123 ";
+    static const int64_t VAL8 = 123;
+    int64_t val;
+    int c;
+    int bytes_in;
+
+    /* test a valid zero value */
+    wrap_int_parser(getsint64, int64_t, STR1, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
+
+    /* test a valid value with all the digits */
+    wrap_int_parser(getsint64, int64_t, STR2, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
+
+    /* test a string with too many digits */
+    CU_EXPECT_CYRFATAL_BEGIN;
+        wrap_int_parser(getsint64, int64_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
+
+    /* test a valid value with a different terminator */
+    wrap_int_parser(getsint64, int64_t, STR4, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ')');
+    CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
+
+    /* test an invalid string */
+    wrap_int_parser(getsint64, int64_t, STR5, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test the corner case where we encounter EOF
+     * at the end of a valid string of digits */
+    wrap_int_parser(getsint64, int64_t, STR6, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
+
+    /* test a leading - */
+    wrap_int_parser(getsint64, int64_t, STR7, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL7);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR7));
 
     /* test a leading + */
-    c = wrap_getsint32(STR8, &val);
+    wrap_int_parser(getsint64, int64_t, STR8, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL8);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR8));
 }
 
-int wrap_getmodseq(const char *s, modseq_t *valp)
+static void test_getuint64(void)
 {
-    struct protstream *prot;
-    char *b;
+    static const char STR1[] = "0 ";
+    static const uint64_t VAL1 = 0;
+    static const char STR2[] = "1234567890 ";
+    static const uint64_t VAL2 = 1234567890;
+    static const char STR3[] = "123456789012345678901 ";
+    static const char STR4[] = "123)";
+    static const uint64_t VAL4 = 123;
+    static const char STR5[] = "y&+123 ";
+    static const char STR6[] = "123";
+    static const uint64_t VAL6 = 123;
+    static const char STR7[] = "-123 ";
+    static const char STR8[] = "+123 ";
+    uint64_t val;
     int c;
+    int bytes_in;
+
+    /* test a valid zero value */
+    wrap_int_parser(getuint64, uint64_t, STR1, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
 
-    b = xstrdup(s);     /* work around bug in prot_ungetc */
-    prot = prot_readmap(b, strlen(b));
-    *valp = CANARY64;
-    c = getmodseq(prot, valp);
-    free(b);
-    prot_free(prot);
+    /* test a valid value with all the digits */
+    wrap_int_parser(getuint64, uint64_t, STR2, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ' ');
+    CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
 
-    return c;
+    /* test a string with too many digits */
+    CU_EXPECT_CYRFATAL_BEGIN;
+        wrap_int_parser(getuint64, uint64_t, STR3, &c, &val, NULL);
+    CU_EXPECT_CYRFATAL_END(EX_IOERR, "num too big");
+
+    /* test a valid value with a different terminator */
+    wrap_int_parser(getuint64, uint64_t, STR4, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, ')');
+    CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
+
+    /* test an invalid string */
+    wrap_int_parser(getuint64, uint64_t, STR5, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test the corner case where we encounter EOF
+     * at the end of a valid string of digits */
+    wrap_int_parser(getuint64, uint64_t, STR6, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
+
+    /* test a leading - */
+    wrap_int_parser(getuint64, uint64_t, STR7, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
+
+    /* test a leading + */
+    wrap_int_parser(getuint64, uint64_t, STR8, &c, &val, &bytes_in);
+    CU_ASSERT_EQUAL(c, EOF);
+    /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 }
 
 static void test_getmodseq(void)
@@ -208,53 +510,62 @@ static void test_getmodseq(void)
     static const char STR8[] = "+123 ";
     modseq_t val;
     int c;
+    int bytes_in;
 
     /* test a valid zero value */
-    c = wrap_getmodseq(STR1, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR1, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL1);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR1));
 
     /* test a valid value with all the digits */
-    c = wrap_getmodseq(STR2, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR2, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL2);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR2));
 
     /* test a valid value >32b */
-    c = wrap_getmodseq(STR3, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR3, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ' ');
     CU_ASSERT_EQUAL(val, VAL3);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR3));
 
 // This test fatal()s which we cannot catch for now
 //     /* test a string with too many digits */
-//     c = wrap_getmodseq(STR3a, &val);
+//     wrap_int_parser(getmodseq, modseq_t, STR3a, &c, &val, NULL);
 //     CU_ASSERT_EQUAL(c, EOF);
 //     CU_ASSERT_EQUAL(val, CANARY64);
 
     /* test a valid value with a different terminator */
-    c = wrap_getmodseq(STR4, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR4, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, ')');
     CU_ASSERT_EQUAL(val, VAL4);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR4));
 
     /* test an invalid string */
-    c = wrap_getmodseq(STR5, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR5, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 
     /* test the corner case where we encounter EOF
      * at the end of a valid string of digits */
-    c = wrap_getmodseq(STR6, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR6, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     CU_ASSERT_EQUAL(val, VAL6);
+    CU_ASSERT_EQUAL(bytes_in, strlen(STR6));
 
     /* test a leading - */
-    c = wrap_getmodseq(STR7, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR7, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 
     /* test a leading + */
-    c = wrap_getmodseq(STR8, &val);
+    wrap_int_parser(getmodseq, modseq_t, STR8, &c, &val, &bytes_in);
     CU_ASSERT_EQUAL(c, EOF);
     /* sadly, val is undefined at this point */
+    CU_ASSERT_EQUAL(bytes_in, 0);
 }
 
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/prot.testc 3.2.0-3/cunit/prot.testc
--- 3.0.13-5/cunit/prot.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/prot.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include <sys/stat.h>
 #include "xmalloc.h"
 #include "prot.h"
diff -pruN 3.0.13-5/cunit/ptrarray.testc 3.2.0-3/cunit/ptrarray.testc
--- 3.0.13-5/cunit/ptrarray.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/ptrarray.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 #include <stdlib.h>
 
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "ptrarray.h"
 
 #define PTR0        ((void *)0xcafebabe)
diff -pruN 3.0.13-5/cunit/quota.testc 3.2.0-3/cunit/quota.testc
--- 3.0.13-5/cunit/quota.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/quota.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 #include <unistd.h>
 #include <stdlib.h>
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/quota.h"
 #include "xmalloc.h"
 #include "retry.h"
@@ -14,7 +14,7 @@
 
 #define DBDIR                   "test-mb-dbdir"
 #define QUOTAROOT               "user.smurf"
-#define QUOTAROOT_NONEXISTANT   "no-such-quotaroot"
+#define QUOTAROOT_NONEXISTENT   "no-such-quotaroot"
 
 static char *backend = CUNIT_PARAM("quotalegacy,skiplist");
 
@@ -74,7 +74,7 @@ static void test_read_no_root(void)
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
     CU_ASSERT_PTR_NULL(txn);
 
-    q.root = QUOTAROOT_NONEXISTANT;
+    q.root = QUOTAROOT_NONEXISTENT;
     r = quota_read(&q, NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 }
@@ -86,21 +86,21 @@ static void test_write_no_root(void)
     int r;
 
     q.root = NULL;
-    r = quota_write(&q, NULL);
+    r = quota_write(&q, 0, NULL);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
     q.root = "";
-    r = quota_write(&q, NULL);
+    r = quota_write(&q, 0, NULL);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
     /* Also, for NULL or "" no txn is started */
     q.root = NULL;
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
     CU_ASSERT_PTR_NULL(txn);
 
     q.root = "";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
     CU_ASSERT_PTR_NULL(txn);
 }
@@ -131,7 +131,7 @@ static void test_read_write(void)
     q.limits[QUOTA_ANNOTSTORAGE] = 8;
 
     oldtxn = txn;
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(txn);
     CU_ASSERT_PTR_EQUAL(oldtxn, txn);
@@ -185,7 +185,7 @@ static void test_abort(void)
     q.limits[QUOTA_STORAGE] = 678;
 
     oldtxn = txn;
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(txn);
     CU_ASSERT_PTR_EQUAL(oldtxn, txn);
@@ -232,7 +232,7 @@ static void test_abort2(void)
     q.useds[QUOTA_STORAGE] = 12345;
     q.limits[QUOTA_STORAGE] = 678;
 
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(txn);
 
@@ -244,7 +244,7 @@ static void test_abort2(void)
     oldq = q;
     q.useds[QUOTA_STORAGE] = 23456;
     q.limits[QUOTA_STORAGE] = 789;
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     /* reading in the same txn gets the new values */
@@ -432,20 +432,20 @@ static void test_update_useds(void)
     quota_diff[QUOTA_STORAGE] = 10*1024;
     quota_diff[QUOTA_MESSAGE] = 2;
     quota_diff[QUOTA_ANNOTSTORAGE] = 1*1024;
-    r = quota_update_useds(NULL, quota_diff, NULL);
+    r = quota_update_useds(NULL, quota_diff, NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_update_useds("", quota_diff, NULL);
+    r = quota_update_useds("", quota_diff, NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_update_useds(QUOTAROOT_NONEXISTANT, quota_diff, NULL);
+    r = quota_update_useds(QUOTAROOT_NONEXISTENT, quota_diff, NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
     /* set limits */
     q.limits[QUOTA_STORAGE] = 100;  /* limit storage to 100 KiB */
     q.limits[QUOTA_MESSAGE] = 20;  /* limit messages to 20 */
     q.limits[QUOTA_ANNOTSTORAGE] = 10;  /* limit annotations storage to 10 KiB */
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(txn);
     quota_commit(&txn);
@@ -454,7 +454,7 @@ static void test_update_useds(void)
 #define TESTCASE(d0, d1, d2, e0, e1, e2) { \
     static const quota_t diff[QUOTA_NUMRESOURCES] = { d0, d1, d2 }; \
     static const quota_t expused[QUOTA_NUMRESOURCES] = { e0, e1, e2 }; \
-    r = quota_update_useds(QUOTAROOT, diff, NULL); \
+    r = quota_update_useds(QUOTAROOT, diff, NULL, 0); \
     CU_ASSERT_EQUAL(r, 0); \
     memset(&q2, 0, sizeof(q2)); \
     q2.root = QUOTAROOT; \
@@ -462,7 +462,7 @@ static void test_update_useds(void)
     CU_ASSERT_EQUAL(r, 0); \
     for (res = 0; res < QUOTA_NUMRESOURCES; res++) { \
         CU_ASSERT_EQUAL(q2.useds[res], expused[res]); \
-        CU_ASSERT_EQUAL(q2.limits[res], q.limits[res]) \
+        CU_ASSERT_EQUAL(q2.limits[res], q.limits[res]); \
     } \
 }
 
@@ -510,16 +510,16 @@ static void test_delete(void)
     int r;
 
     /* first, deleteroot() behaviour with nothing in the db */
-    r = quota_deleteroot(NULL);
+    r = quota_deleteroot(NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_deleteroot("");
+    r = quota_deleteroot("", 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_deleteroot(QUOTAROOT_NONEXISTANT);
+    r = quota_deleteroot(QUOTAROOT_NONEXISTENT, 0);
     CU_ASSERT_EQUAL(r, 0);
 
-    r = quota_deleteroot(QUOTAROOT);
+    r = quota_deleteroot(QUOTAROOT, 0);
     CU_ASSERT_EQUAL(r, 0);
 
 
@@ -529,7 +529,7 @@ static void test_delete(void)
     q.useds[QUOTA_STORAGE] = 12345;
     q.limits[QUOTA_STORAGE] = 678;
 
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
     CU_ASSERT_PTR_NOT_NULL(txn);
 
@@ -544,16 +544,16 @@ static void test_delete(void)
     CU_ASSERT_EQUAL(q2.limits[QUOTA_STORAGE], q.limits[QUOTA_STORAGE]);
 
     /* check behaviour with a record in the db */
-    r = quota_deleteroot(NULL);
+    r = quota_deleteroot(NULL, 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_deleteroot("");
+    r = quota_deleteroot("", 0);
     CU_ASSERT_EQUAL(r, IMAP_QUOTAROOT_NONEXISTENT);
 
-    r = quota_deleteroot(QUOTAROOT_NONEXISTANT);
+    r = quota_deleteroot(QUOTAROOT_NONEXISTENT, 0);
     CU_ASSERT_EQUAL(r, 0);
 
-    r = quota_deleteroot(QUOTAROOT);
+    r = quota_deleteroot(QUOTAROOT, 0);
     CU_ASSERT_EQUAL(r, 0);
 
     /* record should now be gone */
@@ -681,7 +681,7 @@ static void notest_foreach(void)
     for (n = 0 ; n <= MAXN ; n++)
     {
         q = expected[n];
-        r = quota_write(&q, &txn);
+        r = quota_write(&q, 0, &txn);
         CU_ASSERT_EQUAL(r, 0);
         CU_ASSERT_PTR_NOT_NULL(txn);
     }
@@ -717,7 +717,7 @@ static void notest_foreach(void)
     /* delete records one by one, checking that foreach
      * walks over the expected number at each point */
     for (n = 0 ; n <= MAXN ; n++) {
-        r = quota_deleteroot(nth_quotaroot(n));
+        r = quota_deleteroot(nth_quotaroot(n), 0);
         CU_ASSERT_EQUAL(r, 0);
 
         if (n && n % 301 == 0) {
@@ -783,11 +783,11 @@ static void test_findroot(void)
 
     /* add some db entries, but not the "user." */
     q.root = "user.foo";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     q.root = "user.smeg";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     CU_ASSERT_PTR_NOT_NULL(txn);
@@ -815,7 +815,7 @@ static void test_findroot(void)
 
     /* add a catch-all "user" record */
     q.root = "user";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     CU_ASSERT_PTR_NOT_NULL(txn);
@@ -880,11 +880,11 @@ static void test_findroot_virtdomains(vo
     /* add some db entries for bloggs.com, but not fnarp.org,
      * not the default domain, and not the "user." */
     q.root = "bloggs.com!user.foo";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     q.root = "bloggs.com!user.smeg";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     CU_ASSERT_PTR_NOT_NULL(txn);
@@ -924,7 +924,7 @@ static void test_findroot_virtdomains(vo
 
     /* add a catch-all "bloggs.com" record */
     q.root = "bloggs.com!";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     CU_ASSERT_PTR_NOT_NULL(txn);
@@ -963,7 +963,7 @@ static void test_findroot_virtdomains(vo
 
     /* add a catch-all "fnarp.org!user" record */
     q.root = "fnarp.org!user";
-    r = quota_write(&q, &txn);
+    r = quota_write(&q, 0, &txn);
     CU_ASSERT_EQUAL(r, 0);
 
     CU_ASSERT_PTR_NOT_NULL(txn);
diff -pruN 3.0.13-5/cunit/rfc822tok.testc 3.2.0-3/cunit/rfc822tok.testc
--- 3.0.13-5/cunit/rfc822tok.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/rfc822tok.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "rfc822tok.h"
 
 #define WORD0   "lorem"
diff -pruN 3.0.13-5/cunit/search_expr.testc 3.2.0-3/cunit/search_expr.testc
--- 3.0.13-5/cunit/search_expr.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/search_expr.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "prot.h"
 #include "xmalloc.h"
 #include "imap/imapd.h"
@@ -44,7 +44,7 @@ static void test_get_search_program(void
         buf_cstring(&actual_errs); \
         CU_ASSERT_STRING_EQUAL(actual_errs.s, expected_errs); \
         if (c != EOF) { \
-            CU_ASSERT_STRING_EQUAL(charset_name(searchargs->charset), "us-ascii"); \
+            CU_ASSERT_STRING_EQUAL(charset_canon_name(searchargs->charset), "us-ascii"); \
             CU_ASSERT_PTR_NOT_NULL(searchargs->root); \
             actual_out = search_expr_serialise(searchargs->root); \
             CU_ASSERT_STRING_EQUAL(actual_out, expected_out); \
@@ -83,7 +83,7 @@ static void test_get_search_program(void
 
     /* BCC <string> */
     TESTCASE("bcc \"shoreditch\"\r\n",
-             "(and (match bcc \"SHOREDITCH\"))");
+             "(and (match bcc \"shoreditch\"))");
 
     /* BEFORE <date> */
     TESTCASE("before "DATE1_RFC3501"\r\n",
@@ -91,11 +91,11 @@ static void test_get_search_program(void
 
     /* BODY <string> */
     TESTCASE("body \"williamsburg\"\r\n",
-             "(and (match body \"WILLIAMSBURG\"))");
+             "(and (match body \"williamsburg\"))");
 
     /* CC <string> */
     TESTCASE("cc \"brooklyn\"\r\n",
-             "(and (match cc \"BROOKLYN\"))");
+             "(and (match cc \"brooklyn\"))");
 
     /* DELETED */
     TESTCASE("deleted\r\n",
@@ -111,11 +111,11 @@ static void test_get_search_program(void
 
     /* FROM <string> */
     TESTCASE("from \"dreamcatcher\"\r\n",
-             "(and (match from \"DREAMCATCHER\"))");
+             "(and (match from \"dreamcatcher\"))");
 
     /* HEADER <field-name> <string> */
     TESTCASE("header \"Cosby\" \"Sweater\"\r\n",
-             "(and (match header:cosby \"SWEATER\"))");
+             "(and (match header:cosby \"Sweater\"))");
 
     /* KEYWORD <flag> */
     TESTCASE("keyword $Mustache\r\n",
@@ -139,7 +139,7 @@ static void test_get_search_program(void
 
     /* NOT <search-key> */
     TESTCASE("not subject \"tumblr\"\r\n",
-             "(and (not (match subject \"TUMBLR\")))");
+             "(and (not (match subject \"tumblr\")))");
 
     /* OLD */
     /* inexplicably, the RFC specifies OLD != NOT NEW */
@@ -160,9 +160,9 @@ static void test_get_search_program(void
     TESTCASE("or subject \"black\" subject \"white\"\r\n",
              "(and "
                 "(or "
-                    "(match subject \"BLACK\")"
+                    "(match subject \"black\")"
                     " "
-                    "(match subject \"WHITE\")"
+                    "(match subject \"white\")"
                 ")"
              ")");
 
@@ -205,15 +205,15 @@ static void test_get_search_program(void
 
     /* SUBJECT <string> */
     TESTCASE("subject \"selvage\"\r\n",
-             "(and (match subject \"SELVAGE\"))");
+             "(and (match subject \"selvage\"))");
 
     /* TEXT <string> */
     TESTCASE("text \"letterpress\"\r\n",
-             "(and (match text \"LETTERPRESS\"))");
+             "(and (match text \"letterpress\"))");
 
     /* TO <string> */
     TESTCASE("to \"readymade\"\r\n",
-             "(and (match to \"READYMADE\"))");
+             "(and (match to \"readymade\"))");
 
     /* UID <sequence set> */
     TESTCASE("uid 1\r\n",
@@ -255,18 +255,18 @@ static void test_get_search_program(void
     TESTCASE("(subject \"bicycle\" to \"rights\")\r\n",
              "(and "
                 "(and "
-                    "(match subject \"BICYCLE\")"
+                    "(match subject \"bicycle\")"
                     " "
-                    "(match to \"RIGHTS\")"
+                    "(match to \"rights\")"
                 ")"
              ")");
     TESTCASE("not (subject \"bicycle\" to \"rights\")\r\n",
              "(and "
                 "(not "
                     "(and "
-                        "(match subject \"BICYCLE\")"
+                        "(match subject \"bicycle\")"
                         " "
-                        "(match to \"RIGHTS\")"
+                        "(match to \"rights\")"
                     ")"
                 ")"
              ")");
@@ -274,12 +274,12 @@ static void test_get_search_program(void
              "(and "
                 "(or "
                     "(and "
-                        "(match subject \"BICYCLE\")"
+                        "(match subject \"bicycle\")"
                         " "
-                        "(match to \"RIGHTS\")"
+                        "(match to \"rights\")"
                     ")"
                     " "
-                    "(match from \"QUINOA\")"
+                    "(match from \"quinoa\")"
                 ")"
              ")");
 
@@ -357,17 +357,17 @@ static void test_get_search_program(void
 
     /* XLISTID <string> */
     TESTCASE("xlistid \"semiotics\"\r\n",
-             "(and (match listid \"SEMIOTICS\"))");
+             "(and (match listid \"semiotics\"))");
 
     /* XCONTENTTYPE <string> */
     TESTCASE("xcontenttype text\r\n",
-             "(and (match contenttype \"TEXT\"))");
+             "(and (match contenttype \"text\"))");
     TESTCASE("xcontenttype \"text\"\r\n",
-             "(and (match contenttype \"TEXT\"))");
+             "(and (match contenttype \"text\"))");
     TESTCASE("xcontenttype \"plain\"\r\n",
-             "(and (match contenttype \"PLAIN\"))");
+             "(and (match contenttype \"plain\"))");
     TESTCASE("xcontenttype \"text_plain\"\r\n",
-             "(and (match contenttype \"TEXT_PLAIN\"))");
+             "(and (match contenttype \"text_plain\"))");
 
 /* TODO: test that conv* are rejected if conversations:off */
     /* CONVFLAG <flag> */
@@ -380,7 +380,7 @@ static void test_get_search_program(void
 
     /* CONVUNREAD */
     TESTCASE("convunread\r\n",
-             "(and (not (match convflags \"\\Seen\")))");
+             "(and (not (match allconvflags \"\\Seen\")))");
 
     /* CONVSEEN */
     TESTCASE("convseen\r\n",
@@ -388,7 +388,7 @@ static void test_get_search_program(void
 
     /* CONVUNSEEN */
     TESTCASE("convunseen\r\n",
-             "(and (not (match convflags \"\\Seen\")))");
+             "(and (not (match allconvflags \"\\Seen\")))");
 
     /* CONVMODSEQ <modseq> */
     TESTCASE("convmodseq 0\r\n",            /* not a valid modseq but we can search on it */
@@ -526,6 +526,28 @@ static void test_unserialise(void)
     CU_ASSERT_PTR_NULL(e->parent);
     search_expr_free(e);
 
+    e = search_expr_unserialise("(fuzzymatch subject \"BESTELLING BEVESTIGD: GRADO IGRADO HEADPHONES ON-EAR NECKBAND BEHIND-THE-NECK STEREO HEADSETS BLACK\")");
+    CU_ASSERT_PTR_NOT_NULL_FATAL(e);
+    CU_ASSERT_EQUAL(e->op, SEOP_FUZZYMATCH);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(e->attr);
+    CU_ASSERT_STRING_EQUAL(e->attr->name, "subject");
+    CU_ASSERT_STRING_EQUAL(e->value.s, "BESTELLING BEVESTIGD: GRADO IGRADO HEADPHONES ON-EAR NECKBAND BEHIND-THE-NECK STEREO HEADSETS BLACK");
+    CU_ASSERT_PTR_NULL(e->next);
+    CU_ASSERT_PTR_NULL(e->children);
+    CU_ASSERT_PTR_NULL(e->parent);
+    search_expr_free(e);
+
+    e = search_expr_unserialise("(fuzzymatch subject \"STENA LINE E-TICKET AND RESERVATION ADVICE FOR BOOKING REFERENCE 72105814\")");
+    CU_ASSERT_PTR_NOT_NULL_FATAL(e);
+    CU_ASSERT_EQUAL(e->op, SEOP_FUZZYMATCH);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(e->attr);
+    CU_ASSERT_STRING_EQUAL(e->attr->name, "subject");
+    CU_ASSERT_STRING_EQUAL(e->value.s, "STENA LINE E-TICKET AND RESERVATION ADVICE FOR BOOKING REFERENCE 72105814");
+    CU_ASSERT_PTR_NULL(e->next);
+    CU_ASSERT_PTR_NULL(e->children);
+    CU_ASSERT_PTR_NULL(e->parent);
+    search_expr_free(e);
+
     e = search_expr_unserialise("(ge size 123)");
     CU_ASSERT_PTR_NOT_NULL_FATAL(e);
     CU_ASSERT_EQUAL(e->op, SEOP_GE);
@@ -718,7 +740,7 @@ static void test_normalise(void)
     TESTCASE("(and (le size 123) (match subject \"ETSY\"))",
              "(and (le size 123) (match subject \"ETSY\"))");
     TESTCASE("(and (not (le size 123)) (match subject \"ETSY\"))",
-             "(and (match subject \"ETSY\") (not (le size 123)))");
+             "(and (not (le size 123)) (match subject \"ETSY\"))");
     TESTCASE("(and (le size 123) (not (match subject \"ETSY\")))",
              "(and (le size 123) (not (match subject \"ETSY\")))");
 
@@ -730,7 +752,7 @@ static void test_normalise(void)
     TESTCASE("(or (le size 123) (match subject \"ETSY\"))",
              "(or (le size 123) (match subject \"ETSY\"))");
     TESTCASE("(or (not (le size 123)) (match subject \"ETSY\"))",
-             "(or (match subject \"ETSY\") (not (le size 123)))");
+             "(or (not (le size 123)) (match subject \"ETSY\"))");
     TESTCASE("(or (le size 123) (not (match subject \"ETSY\")))",
              "(or (le size 123) (not (match subject \"ETSY\")))");
 
@@ -766,11 +788,11 @@ static void test_normalise(void)
                 ")"
                 " "
                 "(and "
-                    "(match subject \"TUMBLR\")"
-                    " "
                     "(not "
                         "(le size 456)"
                     ")"
+                    " "
+                    "(match subject \"TUMBLR\")"
                 ")"
              ")");
 
@@ -1131,14 +1153,14 @@ static void test_split_by_folder_and_ind
     TESTCASE("(not (match folder \"INBOX.Cosby.Sweater\"))",
              "(not (match folder \"INBOX.Cosby.Sweater\"))\n");
     TESTCASE("(and (match message-id \"ETSY\") (not (match folder \"INBOX.Cosby.Sweater\")))",
-             "(and (match message-id \"ETSY\") (not (match folder \"INBOX.Cosby.Sweater\")))\n");
+             "(and (not (match folder \"INBOX.Cosby.Sweater\")) (match message-id \"ETSY\"))\n");
 
     /* a conjuctive node which doesn't match folders
      * gets a NULL mboxname */
     TESTCASE("(and (match message-id \"ETSY\") (le size 123))",
              "(and (le size 123) (match message-id \"ETSY\"))\n");
     TESTCASE("(and (match message-id \"ETSY\") (not (le size 123)))",
-             "(and (match message-id \"ETSY\") (not (le size 123)))\n");
+             "(and (not (le size 123)) (match message-id \"ETSY\"))\n");
     TESTCASE("(and (le size 123) (not (match message-id \"ETSY\")))",
              "(and (le size 123) (not (match message-id \"ETSY\")))\n");
 
@@ -1158,11 +1180,11 @@ static void test_split_by_folder_and_ind
     TESTCASE("(or (match message-id \"ETSY\") (le size 123))",
              "(or (le size 123) (match message-id \"ETSY\"))\n");
     TESTCASE("(or (match message-id \"ETSY\") (not (le size 123)))",
-             "(or (match message-id \"ETSY\") (not (le size 123)))\n");
+             "(or (not (le size 123)) (match message-id \"ETSY\"))\n");
     TESTCASE("(or (le size 123) (not (match message-id \"ETSY\")))",
              "(or (le size 123) (not (match message-id \"ETSY\")))\n");
 
-    /* a disjuctive node which does match folders gets
+    /* a disjunctive node which does match folders gets
      * split into two expressions each with the given mboxname*/
     TESTCASE("(or (match folder \"INBOX.Cosby.Sweater\") (le size 123))",
              "mboxname \"INBOX.Cosby.Sweater\" (true)\n"
@@ -1206,7 +1228,7 @@ static void test_split_by_folder_and_ind
     TESTCASE("(and (not (match folder \"INBOX.Tumblr\")) (fuzzymatch subject \"ETSY\"))",
              "indexed (fuzzymatch subject \"ETSY\") (not (match folder \"INBOX.Tumblr\"))\n");
 
-    /* a disjuctive node where one side contains indexed matches,
+    /* a disjunctive node where one side contains indexed matches,
      * is split into multiple callbacks, some indexed, some not */
     TESTCASE("(or (match folder \"INBOX.Cosby.Sweater\") (fuzzymatch subject \"ETSY\"))",
              "mboxname \"INBOX.Cosby.Sweater\" (true)\n"
diff -pruN 3.0.13-5/cunit/seqset.testc 3.2.0-3/cunit/seqset.testc
--- 3.0.13-5/cunit/seqset.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/seqset.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "xmalloc.h"
 #include "util.h"
 #include "imap/sequence.h"
@@ -502,4 +502,46 @@ static void XXX_test_star(void)
 }
 #endif
 
+static void test_join(void)
+{
+    struct seqset *res = seqset_init(0, SEQ_MERGE);
+    struct seqset *seq;
+    char *s;
+
+    seq = seqset_parse("1:100", NULL, 0);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(seq);
+    seqset_join(res, seq);
+    seqset_free(seq);
+
+    s = seqset_cstring(res);
+    CU_ASSERT_STRING_EQUAL(s, "1:100");
+    free(s);
+
+    seq = seqset_parse("1:5,7:30,40:99", NULL, 0);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(seq);
+    seqset_join(res, seq);
+    seqset_free(seq);
+
+    s = seqset_cstring(res);
+    CU_ASSERT_STRING_EQUAL(s, "1:100");
+    free(s);
+
+    seqset_free(res);
+}
+
+static void test_simplify(void)
+{
+    struct seqset *seq;
+    char *s;
+
+    seq = seqset_parse("1:3,4,5:8,10,12:12,13:14,16:20", NULL, 0);
+    CU_ASSERT_PTR_NOT_NULL_FATAL(seq);
+
+    s = seqset_cstring(seq);
+    CU_ASSERT_STRING_EQUAL(s, "1:8,10,12:14,16:20");
+    free(s);
+
+    seqset_free(seq);
+}
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/sieve.testc 3.2.0-3/cunit/sieve.testc
--- 3.0.13-5/cunit/sieve.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/sieve.testc	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@
  * - * Larry Greenfield
  *
  */
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include <malloc.h>
 #include "sieve/bytecode.h"
 #include "sieve/comparator.h"
@@ -67,10 +67,14 @@ typedef struct {
 } sieve_test_message_t;
 
 /* set to SIEVE_DONE if you want to test "already responded */
-int autorespond_reponse = SIEVE_OK;
+int autorespond_response = SIEVE_OK;
 
 extern int verbose;
 
+static void context_setup(sieve_test_context_t *ctx,
+                          const char *script);
+static void context_cleanup(sieve_test_context_t *ctx);
+
 static void test_variable_modifiers(void)
 {
     /*
@@ -81,7 +85,8 @@ static void test_variable_modifiers(void
       set :lower "b" "${a}";                 => "jumbled letters"
       set :upperfirst "b" "${a}";            => "JuMBlEd lETteRS"
       set :upperfirst :lower "b" "${a}";     => "Jumbled letters"
-      set :quotewildcard "b" "Rock*";        => "Rock\*"
+      set :quotewildcard "b" "^Rock*";       => "^Rock\*"
+      set :quoteregex "b" "^Rock*";          => "\^Rock\*"
      */
     const char *a = "juMBlEd lETteRS";
     char *b;
@@ -98,29 +103,38 @@ static void test_variable_modifiers(void
     b = variables_modify_string(a, BFV_UPPERFIRST | BFV_LOWER);
     CU_ASSERT_STRING_EQUAL(b, "Jumbled letters");
     free(b);
-    b = variables_modify_string("Rock*", BFV_QUOTEWILDCARD);
-    CU_ASSERT_STRING_EQUAL(b, "Rock\\*");
+    b = variables_modify_string("^Rock*", BFV_QUOTEWILDCARD);
+    CU_ASSERT_STRING_EQUAL(b, "^Rock\\*");
+    free(b);
+    b = variables_modify_string("^Rock*", BFV_QUOTEREGEX);
+    CU_ASSERT_STRING_EQUAL(b, "\\^Rock\\*");
     free(b);
-    b = variables_modify_string("Rock\\*", BFV_QUOTEWILDCARD | BFV_ENCODEURL);
-    CU_ASSERT_STRING_EQUAL(b, "Rock%5C%5C%5C%2A");
+    b = variables_modify_string("~Rock\\*", BFV_QUOTEWILDCARD | BFV_ENCODEURL);
+    CU_ASSERT_STRING_EQUAL(b, "~Rock%5C%5C%5C%2A");
     free(b);
 }
 
 #define TESTCASE(_comp, _mode, _pat, _text, _result)            \
     comprock = NULL;                                            \
-    c = lookup_comp(_comp, _mode, -1, &comprock);               \
+    c = lookup_comp(ctx.interp, _comp, _mode, -1, &comprock);   \
     CU_ASSERT_PTR_NOT_NULL(c);                                  \
     if (c) {                                                    \
-        res = c(_text, strlen(_text), _pat, comprock);          \
+        res = c(_text, strlen(_text), _pat, NULL, comprock);    \
         CU_ASSERT_EQUAL(res, _result);                          \
     }
 
 static void test_comparator(void)
 {
+    static const char SCRIPT[] =
+    "require [\"comparator-i;ascii-numeric\"];\n"
+    ;
+    sieve_test_context_t ctx;
     void *comprock;
     comparator_t *c;
     int res;
 
+    context_setup(&ctx, SCRIPT);
+
     TESTCASE( B_OCTET, B_IS, "", "", 1 );
     TESTCASE( B_OCTET, B_IS, "a", "", 0 );
     TESTCASE( B_OCTET, B_IS, "", "a", 0 );
@@ -280,6 +294,8 @@ static void test_comparator(void)
     TESTCASE( B_ASCIICASEMAP, B_MATCHES, "a*b", "aBBB", 1 );
     TESTCASE( B_ASCIICASEMAP, B_MATCHES, "a*b", "ACB", 1 );
     TESTCASE( B_ASCIICASEMAP, B_MATCHES, "a*b", "ACBC", 0 );
+
+    context_cleanup(&ctx);
 }
 
 
@@ -314,7 +330,8 @@ static int getbody(void *mc, const char
         r = message_parse_file(fp,
                                &msg->content.base,
                                &msg->content.len,
-                               &msg->content.body);
+                               &msg->content.body,
+                               msg->filename);
         CU_ASSERT_EQUAL(r, 0);
         fclose(fp);
     }
@@ -485,7 +502,7 @@ static int autorespond(void *ac __attrib
                        void *mc __attribute__((unused)),
                        const char **errmsg __attribute__((unused)))
 {
-    return autorespond_reponse;
+    return autorespond_response;
 }
 
 static int send_response(void *ac, void *ic, void *sc __attribute__((unused)),
@@ -595,7 +612,7 @@ static void context_setup(sieve_test_con
     sieve_register_include(ctx->interp, getinclude);
     sieve_register_vacation(ctx->interp, &vacation);
     sieve_register_imapflags(ctx->interp, &mark);
-    sieve_register_notify(ctx->interp, notify);
+    sieve_register_notify(ctx->interp, notify, NULL);
     sieve_register_parse_error(ctx->interp, mysieve_error);
     sieve_register_execute_error(ctx->interp, mysieve_execute_error);
 
diff -pruN 3.0.13-5/cunit/spool.testc 3.2.0-3/cunit/spool.testc
--- 3.0.13-5/cunit/spool.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/spool.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/imap_err.h"
 #include "prot.h"
 #include "retry.h"
diff -pruN 3.0.13-5/cunit/squat.testc 3.2.0-3/cunit/squat.testc
--- 3.0.13-5/cunit/squat.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/squat.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "imap/squat_internal.h"
 
 static void test_coding_int32(void)
diff -pruN 3.0.13-5/cunit/strarray.testc 3.2.0-3/cunit/strarray.testc
--- 3.0.13-5/cunit/strarray.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/strarray.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "xmalloc.h"
 #include "bsearch.h"
 #include "strarray.h"
@@ -1307,13 +1307,14 @@ static void test_pop(void)
 #undef WORD4
 }
 
-static void test_sortuniq(void)
+static void test_sortrawuniq(void)
 {
     strarray_t sa = STRARRAY_INITIALIZER;
 #define WORD0   "INBOX"
 #define WORD1   "INBOX.a folder"
 #define WORD2   "INBOX.a.sub"
 #define WORD3   "INBOX.a.aaa"
+#define WORD4   "INBOX.a.aa"
 
     /* initialise */
     CU_ASSERT_EQUAL(strarray_size(&sa), 0);
@@ -1321,12 +1322,13 @@ static void test_sortuniq(void)
     strarray_append(&sa, WORD1);
     strarray_append(&sa, WORD2);
     strarray_append(&sa, WORD3);
+    strarray_append(&sa, WORD4);
     /* duplicates */
     strarray_append(&sa, WORD0);
     strarray_append(&sa, WORD2);
     strarray_append(&sa, WORD1);
 
-    CU_ASSERT_EQUAL(strarray_size(&sa), 7);
+    CU_ASSERT_EQUAL(strarray_size(&sa), 8);
 
     /* normal sort */
     strarray_sort(&sa, cmpstringp_raw);
@@ -1335,28 +1337,71 @@ static void test_sortuniq(void)
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD0);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD1);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD1);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 4), WORD3);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 5), WORD2);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 4), WORD4);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 5), WORD3);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 6), WORD2);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 7), WORD2);
+
+    /* uniq */
+    strarray_uniq(&sa);
+    CU_ASSERT_EQUAL(strarray_size(&sa), 5);
+
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD4);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD3);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 4), WORD2);
+
+#undef WORD0
+#undef WORD1
+#undef WORD2
+#undef WORD3
+}
+
+static void test_sortmboxuniq(void)
+{
+    strarray_t sa = STRARRAY_INITIALIZER;
+#define WORD0   "INBOX"
+#define WORD1   "INBOX.a folder"
+#define WORD2   "INBOX.a.sub"
+#define WORD3   "INBOX.a.aaa"
+#define WORD4   "INBOX.a.aa"
+
+    /* initialise */
+    CU_ASSERT_EQUAL(strarray_size(&sa), 0);
+    strarray_append(&sa, WORD0);
+    strarray_append(&sa, WORD1);
+    strarray_append(&sa, WORD2);
+    strarray_append(&sa, WORD3);
+    strarray_append(&sa, WORD4);
+    /* duplicates */
+    strarray_append(&sa, WORD0);
+    strarray_append(&sa, WORD2);
+    strarray_append(&sa, WORD1);
+
+    CU_ASSERT_EQUAL(strarray_size(&sa), 8);
 
     /* mbox order sort */
     strarray_sort(&sa, cmpstringp_mbox);
 
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD0);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD3);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD2);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD4);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD3);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 4), WORD2);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 5), WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 5), WORD2);
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 6), WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 7), WORD1);
 
+    /* uniq */
     strarray_uniq(&sa);
-    CU_ASSERT_EQUAL(strarray_size(&sa), 4);
+    CU_ASSERT_EQUAL(strarray_size(&sa), 5);
 
     CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD3);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD2);
-    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD4);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 2), WORD3);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 3), WORD2);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 4), WORD1);
 
 #undef WORD0
 #undef WORD1
@@ -1509,4 +1554,35 @@ static void test_add_case(void)
 #undef WORD1
 }
 
+static void test_swap(void)
+{
+    strarray_t sa = STRARRAY_INITIALIZER;
+#define WORD0   "lorem"
+#define WORD1   "ipsum"
+
+    /* swap is safe for bad index */
+    strarray_swap(&sa, 0, 1);
+
+    /* swap is safe for same index */
+    strarray_insert(&sa, 0, WORD0);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
+    strarray_swap(&sa, 0, 0);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
+    CU_ASSERT_EQUAL(strarray_size(&sa), 1);
+
+    /* swap */
+    strarray_insert(&sa, 1, WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD0);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD1);
+    strarray_swap(&sa, 0, 1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 0), WORD1);
+    CU_ASSERT_STRING_EQUAL(strarray_nth(&sa, 1), WORD0);
+    CU_ASSERT_EQUAL(strarray_size(&sa), 2);
+
+    strarray_fini(&sa);
+#undef WORD0
+#undef WORD1
+}
+
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/strconcat.testc 3.2.0-3/cunit/strconcat.testc
--- 3.0.13-5/cunit/strconcat.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/strconcat.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include <malloc.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "util.h"
 
 static void test_null(void)
diff -pruN 3.0.13-5/cunit/syslog.c 3.2.0-3/cunit/syslog.c
--- 3.0.13-5/cunit/syslog.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/syslog.c	2020-04-24 02:03:00.000000000 +0000
@@ -86,7 +86,9 @@ static char *match_error(struct slmatch
     return buf;
 }
 
-static void vlog(int prio, const char *fmt, va_list args)
+static void
+__attribute__((format(printf, 2, 0)))
+vlog(int prio, const char *fmt, va_list args)
 {
     if (nslmatches) {
         int e = errno;      /* save errno Just In Case */
@@ -144,8 +146,10 @@ static void vlog(int prio, const char *f
 #if defined(__GLIBC__)
 /* Under some but not all combinations of options, glibc
  * defines syslog() as an inline that calls this function */
-void __syslog_chk(int prio, int whatever __attribute__((unused)),
-                  const char *fmt, ...)
+void
+__attribute__((format(printf, 3, 4)))
+__syslog_chk(int prio, int whatever __attribute__((unused)),
+             const char *fmt, ...)
 {
     va_list args;
 
diff -pruN 3.0.13-5/cunit/timeout.c 3.2.0-3/cunit/timeout.c
--- 3.0.13-5/cunit/timeout.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/timeout.c	2020-04-24 02:03:00.000000000 +0000
@@ -197,7 +197,7 @@ int timeout_init(void (*cb)(void))
 
 int timeout_begin(int millisec)
 {
-    char c;
+    int c;
     int r;
 
 // fprintf(stderr, "timeout_begin\n");
@@ -220,7 +220,7 @@ int timeout_begin(int millisec)
 
 int timeout_end(void)
 {
-    char c;
+    int c;
     int r;
 
 // fprintf(stderr, "timeout_end\n");
diff -pruN 3.0.13-5/cunit/times.testc 3.2.0-3/cunit/times.testc
--- 3.0.13-5/cunit/times.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/times.testc	2020-04-24 02:03:00.000000000 +0000
@@ -49,7 +49,7 @@
 #include <stdio.h>
 #include <errno.h>
 #include <assert.h>
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "times.h"
 #include "cunit/timezones.h"
 
@@ -103,72 +103,72 @@ test_military_timezones(void)
     time_t zulu = 813727192;
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-Z", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 Z", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * lowercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS-z" */
+     * lowercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-z", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 z", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = +0100, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = +0100, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-A", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 A", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu-1*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = +0200, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = +0200, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-B", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 B", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu-2*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = +0900, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = +0900, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-I", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 I", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu-9*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * erroneous uppercase 1-char timezone, "dd-mmm-yy HH:MM:SS-z" */
+     * erroneous uppercase 1-char timezone, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-J", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 J", &t);
     CU_ASSERT_EQUAL(r, -1);
     CU_ASSERT_EQUAL(t, UNINIT_TIMET);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = +1000, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = +1000, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-K", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 K", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu-10*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * 1-char timezone = +1200, "dd-mmm-yy HH:MM:SS-z" */
+     * 1-char timezone = +1200, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-M", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 M", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu-12*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * uppercase 1-char timezone = -0100, "dd-mmm-yy HH:MM:SS-z" */
+     * uppercase 1-char timezone = -0100, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-N", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 N", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu+1*3600);
 
     /* Well-formed legacy format with 2-digit day, 2-digit year,
-     * 1-char timezone = -1200, "dd-mmm-yy HH:MM:SS-z" */
+     * 1-char timezone = -1200, "dd-mmm-yy HH:MM:SS z" */
     t = UNINIT_TIMET;
-    r = time_from_rfc3501("15-Oct-95 03:19:52-Y", &t);
+    r = time_from_rfc3501("15-Oct-95 03:19:52 Y", &t);
     CU_ASSERT_EQUAL(r, 20);
     CU_ASSERT_EQUAL(t, zulu+12*3600);
 }
@@ -323,6 +323,20 @@ test_parse_iso8601(void)
     r = time_from_iso8601(DATETIME_NYC, &t);
     CU_ASSERT_EQUAL(r, 25);
     CU_ASSERT_EQUAL(t, TIMET);
+
+    static const char DATETIME_NEG[] = "1969-12-31T23:59:59Z";
+    t = UNINIT_TIMET;
+    r = time_from_iso8601(DATETIME_NEG, &t);
+    CU_ASSERT_EQUAL(r, 20);
+    struct tm *tm = gmtime(&t);
+    CU_ASSERT_EQUAL(tm->tm_year, 69);
+
+    static const char DATETIME_NEG2[] = "1965-01-02T03:04:05Z";
+    t = UNINIT_TIMET;
+    r = time_from_iso8601(DATETIME_NEG2, &t);
+    CU_ASSERT_EQUAL(r, 20);
+    tm = gmtime(&t);
+    CU_ASSERT_EQUAL(tm->tm_year, 65);
 }
 
 static void
@@ -442,4 +456,337 @@ test_leapyear_rfc822(void)
     CU_ASSERT_EQUAL(r, 31);
     CU_ASSERT_EQUAL(t, FEB2004_TIMET);
 }
+
+static void
+test_rfc5322(void)
+{
+    time_t t;
+    int r;
+
+    /* 1 Jan 1970 */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Thu, 01 Jan 1970 00:00:00  ", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 27);
+    CU_ASSERT_EQUAL(t, 0);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Thu, 01 Jan 1970 01:00:00 +0100", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 0);
+
+    /* Zero Hour */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("WED, 31 DEC 1969 19:36:29 -0500", &t, DATETIME_FULL); /* NYC */
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 2189);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(" 1-JAN-1970 11:36:29 +1100", &t, DATETIME_FULL); /* MEL */
+    CU_ASSERT_EQUAL(r, 26);
+    CU_ASSERT_EQUAL(t, 2189);
+
+    /* Pre Jan 1 1970 */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("WED, 31 DEC 1969 19:36:29", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 25);
+    CU_ASSERT_EQUAL(t, -15811);
+
+    /* Well-formed full RFC5322 format with 2-digit day
+     * "dd-mmm-yyyy HH:MM:SS zzzzz" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-2010 03:19:52 +1100", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 26);
+    CU_ASSERT_EQUAL(t, 1287073192);
+
+    /* Well-formed full RFC5322 format with 1-digit day
+     * " d-mmm-yyyy HH:MM:SS zzzzz" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(" 5-Oct-2010 03:19:52 +1100", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 26);
+    CU_ASSERT_EQUAL(t, 1286209192);
+
+    /* dd mmm yyyy HH:MM:SS zzzzz */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("20 Jun 2017 00:49:38 +0000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 26);
+    CU_ASSERT_EQUAL(t, 1497919778);
+
+    /* dow, dd mmm yyyy HH:MM:SS zzzzz */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Tue, 20 Jun 2017 00:49:38 +0000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 1497919778);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Tue, 20 Jun 2017 00:49:38 +0200", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 1497912578);
+
+    /* https://github.com/cyrusimap/cyrus-imapd/issues/2247 */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Tue, 20  Jun  2017 00:49:38 +0000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 33);
+    CU_ASSERT_EQUAL(t, 1497919778);
+
+    /* Timezone tests - same time different timezones*/
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("FRI, 26 NOV 2010 14:22:02 +1100", &t, DATETIME_FULL); /* MEL */
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 1290741722);
+
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("FRI, 26 NOV 2010 03:22:02 +0000", &t, DATETIME_FULL); /* UTC */
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 1290741722);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("THU, 25 NOV 2010 22:22:02 -0500", &t, DATETIME_FULL); /* NYC */
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 1290741722);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("THU, 25 NOV 2010 22:22:02 EST", &t, DATETIME_FULL); /* NYC */
+    CU_ASSERT_EQUAL(r, 29);
+    CU_ASSERT_EQUAL(t, 1290741722);
+
+
+    /* Time with period as separator */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(" 3-jan-2009 04.05    -0400", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 26);
+    CU_ASSERT_EQUAL(t, 1230969900);
+
+    /* Year 9999 */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Fri, 31-Dec-9999 23:59:59 +0000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 253402300799);
+
+    /* Year 1 - This will fail*/
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("1 Jan 1 00:00:00 +0000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    /* 5 digit year */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Sat, 1 Jan 10000 00:00:00", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 25);
+    CU_ASSERT_EQUAL(t, 253402300800);
+
+    /* Invalid date */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("foobar, 2 +5000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Sun, Hello, World!", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("-1000", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("Thu, 06 Jul 2017", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("This is some random text", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("0100200200300400502989587984579845", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, -1);
+}
+
+static void
+test_military_timezones_using_rfc5322(void)
+{
+    time_t t;
+    int r;
+    time_t zulu = 813727192;
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 Z", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * lowercase 1-char timezone = UTC, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 z", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = +0100, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 A", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu-1*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = +0200, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 B", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu-2*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = +0900, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 I", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu-9*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * erroneous uppercase 1-char timezone, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 J", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, 813727192);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = +1000, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 K", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu-10*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * 1-char timezone = +1200, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 M", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu-12*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * uppercase 1-char timezone = -0100, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 N", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu+1*3600);
+
+    /* Well-formed legacy format with 2-digit day, 2-digit year,
+     * 1-char timezone = -1200, "dd-mmm-yy HH:MM:SS z" */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322("15-Oct-95 03:19:52 Y", &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 20);
+    CU_ASSERT_EQUAL(t, zulu+12*3600);
+}
+
+static void
+test_leapyear_rfc5322(void)
+{
+    /* 2000 is a leapyear */
+    static const char FEB2000_STR[] = "Tue, 29 Feb 2000 11:22:33 +1100";
+    static const time_t FEB2000_TIMET = 951783753;
+    /* 2001 is not a leapyear */
+    static const char FEB2001_STR[] = "Thu, 29 Feb 2001 11:22:33 +1100";
+    /* 2004 is a leapyear */
+    static const char FEB2004_STR[] = "Sun, 29 Feb 2004 11:22:33 +1100";
+    static const time_t FEB2004_TIMET = 1078014153;
+    time_t t;
+    int r;
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(FEB2000_STR, &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, FEB2000_TIMET);
+
+    /* This will be converted to: Thu Mar  1 11:22:33 2001 */
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(FEB2001_STR, &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, 983406153);
+
+    t = UNINIT_TIMET;
+    r = time_from_rfc5322(FEB2004_STR, &t, DATETIME_FULL);
+    CU_ASSERT_EQUAL(r, 31);
+    CU_ASSERT_EQUAL(t, FEB2004_TIMET);
+}
+
+static void
+test_offsettime_iso8601(void)
+{
+#define TESTCASE(ts, want_n, want_wday, want_yday) \
+    { \
+        const char *_ts = (ts); \
+        int _want_n = (want_n); \
+        int _want_wday = (want_wday); \
+        int _want_yday = (want_yday); \
+        struct offsettime _ot; \
+        char buf[30]; \
+        int r = offsettime_from_iso8601(_ts, &_ot); \
+        CU_ASSERT_EQUAL(_want_n, r); \
+        CU_ASSERT_EQUAL(_want_wday, _ot.tm.tm_wday); \
+        CU_ASSERT_EQUAL(_want_yday, _ot.tm.tm_yday); \
+        r = offsettime_to_iso8601(&_ot, buf, sizeof(buf), 1); \
+        CU_ASSERT_EQUAL(_want_n, r); \
+        CU_ASSERT_STRING_EQUAL(_ts, buf); \
+    }
+
+    TESTCASE("2019-05-02T03:15:00+07:00", 25, 4, 122);
+    TESTCASE("2010-11-26T14:22:02+11:00", 25, 5, 330);
+    TESTCASE("2010-11-26T03:22:02Z", 20, 5, 330);
+    TESTCASE("2010-11-25T22:22:02-05:00", 25, 4, 329);
+    TESTCASE("1969-12-31T23:59:59Z", 20, 3, 365);
+
+#undef TESTCASE
+}
+
+static void
+test_offsettime_rfc5322(void)
+{
+#define TESTCASE(ts, want_n, want_wday, want_yday) \
+    { \
+        const char *_ts = (ts); \
+        int _want_n = (want_n); \
+        int _want_wday = (want_wday); \
+        int _want_yday = (want_yday); \
+        struct offsettime _ot; \
+        char buf[RFC822_DATETIME_MAX+1]; \
+        int r = offsettime_from_rfc5322(_ts, &_ot, DATETIME_FULL); \
+        CU_ASSERT_EQUAL(_want_n, r); \
+        CU_ASSERT_EQUAL(_want_wday, _ot.tm.tm_wday); \
+        CU_ASSERT_EQUAL(_want_yday, _ot.tm.tm_yday); \
+        r = offsettime_to_rfc5322(&_ot, buf, sizeof(buf)); \
+        CU_ASSERT_EQUAL(_want_n, r); \
+        CU_ASSERT_STRING_EQUAL(_ts, buf); \
+    }
+
+    TESTCASE("Thu, 02 May 2019 03:15:00 +0700", 31, 4, 122);
+    TESTCASE("Fri, 26 Nov 2010 14:22:02 +1100", 31, 5, 330);
+    TESTCASE("Fri, 26 Nov 2010 03:22:02 +0000", 31, 5, 330);
+    TESTCASE("Thu, 25 Nov 2010 22:22:02 -0500", 31, 4, 329);
+    TESTCASE("Wed, 31 Dec 1969 23:59:59 +0000", 31, 3, 365);
+
+#undef TESTCASE
+}
+
+static void
+test_offsettime_rfc5322_ignore_wday(void)
+{
+#define TESTCASE(ts, want_wday, want_yday) \
+    { \
+        const char *_ts = (ts); \
+        int _want_wday = (want_wday); \
+        int _want_yday = (want_yday); \
+        struct offsettime _ot; \
+        int r = offsettime_from_rfc5322(_ts, &_ot, DATETIME_FULL); \
+        CU_ASSERT(r > 0); \
+        CU_ASSERT_EQUAL(_want_wday, _ot.tm.tm_wday); \
+        CU_ASSERT_EQUAL(_want_yday, _ot.tm.tm_yday); \
+    }
+
+    /* Bogus week days are ignored */
+    TESTCASE("Sat, 02 May 2019 03:15:00 +0700", 4, 122); // Should be "Thu"
+
+
+#undef TESTCASE
+}
+
 /* vim: set ft=c: */
diff -pruN 3.0.13-5/cunit/tok.testc 3.2.0-3/cunit/tok.testc
--- 3.0.13-5/cunit/tok.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/tok.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 #include "config.h"
-#include "cunit/cunit.h"
+#include "cunit/cyrunit.h"
 #include "tok.h"
 #include "xmalloc.h"
 
diff -pruN 3.0.13-5/cunit/unit.c 3.2.0-3/cunit/unit.c
--- 3.0.13-5/cunit/unit.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/unit.c	2020-04-24 02:03:00.000000000 +0000
@@ -52,7 +52,8 @@
 #endif
 #include <setjmp.h>
 #include "timeout.h"
-#include "cunit.h"
+#include "cyrunit.h"
+#include "util.h"
 #include "xmalloc.h"
 
 /* generated headers are not necessarily in current directory */
@@ -343,7 +344,7 @@ static void run_tests(void)
      */
 
     for (i = 0 ; i < num_testspecs ; i++) {
-        strncpy(suitename, testspecs[i], sizeof(suitename));
+        xstrncpy(suitename, testspecs[i], sizeof(suitename));
         if ((testname = strchr(suitename, ':')) != NULL) {
             *testname++ = '\0';
             if (*testname == '\0')
diff -pruN 3.0.13-5/cunit/vparse.testc 3.2.0-3/cunit/vparse.testc
--- 3.0.13-5/cunit/vparse.testc	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/cunit/vparse.testc	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,6 @@
-#include "cunit/cunit.h"
+#include <config.h>
+
+#include "cunit/cyrunit.h"
 #include "xmalloc.h"
 #include "vparse.h"
 
@@ -313,3 +315,73 @@ static void test_crlf(void)
 
 #undef TESTCASE
 }
+
+#ifdef USE_HTTPD
+#include "imap/vcard_support.h"
+
+static void test_multiparam_type(void)
+{
+#define TESTCASE(card, wantbuf) \
+    { \
+        struct vparse_card *vcard = vcard_parse_string(card, 0); \
+        CU_ASSERT_PTR_NOT_NULL(vcard); \
+        struct buf *buf = vcard_as_buf(vcard); \
+        CU_ASSERT_STRING_EQUAL(wantbuf, buf_cstring(buf)); \
+        vparse_free_card(vcard); \
+        buf_free(buf); \
+    }
+
+    TESTCASE(
+        // card
+        "BEGIN:VCARD\r\n"
+        "VERSION:3.0\r\n"
+        "UID:0dc2973f-5f46-49b9-8ba9-12a4cee6eeac\r\n"
+        "N:Test;John;;;\r\n"
+        "FN:John Test\r\n"
+        "EMAIL;TYPE=HOME,PREF:home@mail.com\r\n"
+        "EMAIL;TYPE=WORK:work@mail.com\r\n"
+        "TEL;TYPE=HOME,VOICE:040-xx\r\n"
+        "TEL;TYPE=CELL:06-xx\r\n"
+        "PRODID:-//MailClient.Contact/7.0.30068.0\r\n"
+        "END:VCARD\r\n",
+        // wantbuf
+
+        "BEGIN:VCARD\r\n"
+        "VERSION:3.0\r\n"
+        "UID:0dc2973f-5f46-49b9-8ba9-12a4cee6eeac\r\n"
+        "N:Test;John;;;\r\n"
+        "FN:John Test\r\n"
+        "EMAIL;TYPE=HOME;TYPE=PREF:home@mail.com\r\n"
+        "EMAIL;TYPE=WORK:work@mail.com\r\n"
+        "TEL;TYPE=HOME;TYPE=VOICE:040-xx\r\n"
+        "TEL;TYPE=CELL:06-xx\r\n"
+        "PRODID:-//MailClient.Contact/7.0.30068.0\r\n"
+        "END:VCARD\r\n"
+    );
+
+    TESTCASE(
+        // card
+        "BEGIN:VCARD\r\n"
+        "VERSION:3.0\r\n"
+        "UID:0dc2973f-5f46-49b9-8ba9-12a4cee6eeac\r\n"
+        "N:Test;John;;;\r\n"
+        "FN:John Test\r\n"
+        "X-SOCIAL-PROFILE;TYPE=Github,PREF;X-USER=\"foo,bar\":\r\n"
+        "PRODID:-//MailClient.Contact/7.0.30068.0\r\n"
+        "END:VCARD\r\n",
+        // wantbuf
+        "BEGIN:VCARD\r\n"
+        "VERSION:3.0\r\n"
+        "UID:0dc2973f-5f46-49b9-8ba9-12a4cee6eeac\r\n"
+        "N:Test;John;;;\r\n"
+        "FN:John Test\r\n"
+        "X-SOCIAL-PROFILE;TYPE=Github;TYPE=PREF;X-USER=\"foo,bar\":\r\n"
+        "PRODID:-//MailClient.Contact/7.0.30068.0\r\n"
+        "END:VCARD\r\n"
+    );
+
+#undef TESTCASE
+}
+#else
+static void test_multiparam_type(void) { }
+#endif /* USE_HTTPD */
diff -pruN 3.0.13-5/debian/changelog 3.2.0-3/debian/changelog
--- 3.0.13-5/debian/changelog	2020-04-11 11:48:02.000000000 +0000
+++ 3.2.0-3/debian/changelog	2020-05-15 06:08:42.000000000 +0000
@@ -1,3 +1,61 @@
+cyrus-imapd (3.2.0-3) unstable; urgency=medium
+
+  * Disable tests during build on s390x and armhf arch (fixes debci)
+
+ -- Xavier Guimard <yadd@debian.org>  Fri, 15 May 2020 08:08:42 +0200
+
+cyrus-imapd (3.2.0-2) unstable; urgency=medium
+
+  * Add fix for non-x86 arch. Thanks to John Paul Adrian Glaubitz!
+    (Closes: #960263)
+  * Disable some test incompatible with non amd64 arch (Closes: #960374)
+
+ -- Xavier Guimard <yadd@debian.org>  Tue, 12 May 2020 09:52:36 +0200
+
+cyrus-imapd (3.2.0-1) unstable; urgency=medium
+
+  * New upstream version 3.2.0
+  * Update lintian overrides
+
+ -- Xavier Guimard <yadd@debian.org>  Mon, 04 May 2020 08:02:40 +0200
+
+cyrus-imapd (3.2.0~rc1-1) experimental; urgency=medium
+
+  * Update debian/watch
+  * New upstream version 3.2.0~rc1
+  * Update copyright
+
+ -- Xavier Guimard <yadd@debian.org>  Sat, 25 Apr 2020 08:56:01 +0200
+
+cyrus-imapd (3.2.0~beta3-1) experimental; urgency=medium
+
+  * New upstream version 3.2.0~beta3
+
+ -- Xavier Guimard <yadd@debian.org>  Mon, 02 Mar 2020 06:10:47 +0100
+
+cyrus-imapd (3.2.0~beta2-1) experimental; urgency=medium
+
+  * debian/watch: add uversionmangle to use ~ in beta releases
+  * Add postgresql support
+  * New upstream version 3.2.0~beta2
+
+ -- Xavier Guimard <yadd@debian.org>  Mon, 17 Feb 2020 04:59:12 +0100
+
+cyrus-imapd (3.2.0~beta1-1) experimental; urgency=medium
+
+  * New upstream version 3.2.0~beta1
+  * Add build dependency to libcunit1-dev
+  * Refresh patches
+  * Update install
+  * Fix perl shebang
+  * Temporarily don't install some manpages (missing GitPython)
+  * Add build dependencies to libnghttp2-dev,
+    libpod-pom-view-restructured-perl, libbrotli-dev, libwslay-dev,
+    libzstd-dev, python-git-doc, python3-sphinx and libshp-dev (shapelib)
+  * Update copyright
+
+ -- Xavier Guimard <yadd@debian.org>  Mon, 10 Feb 2020 12:08:11 +0100
+
 cyrus-imapd (3.0.13-5) unstable; urgency=medium
 
   [ Dimitri John Ledkov ]
@@ -1126,7 +1184,7 @@ cyrus-imapd-2.3 (2.3.14-1) UNRELEASED; u
 
   * New upstream release.
   * Remove the sections of Sven's 10-fix_potential_overflows.dpatch
-    superceded by upstream fixes by Bron.
+    superseded by upstream fixes by Bron.
 
   [Sven Mueller]
   * change example script mbox2cyrus to remove bashisms (Closes: #489558,
diff -pruN 3.0.13-5/debian/control 3.2.0-3/debian/control
--- 3.0.13-5/debian/control	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/control	2020-05-04 05:43:39.000000000 +0000
@@ -17,22 +17,30 @@ Build-Depends: bison,
                libical-dev (>= 2.0.0),
                libjansson-dev,
                libclamav-dev,
+               libcunit1-dev,
                libkrb5-dev,
                libkvm-dev [kfreebsd-any],
                libldap2-dev,
+               libnghttp2-dev,
                libopendkim-dev,
                libpam0g-dev,
+               libpod-pom-view-restructured-perl,
                libpcre3-dev,
+               libbrotli-dev,
+               libpq-dev,
                libsasl2-dev,
                libsasl2-modules,
+               libshp-dev,
                libsnmp-dev,
                libsqlite3-dev,
                libssl-dev,
                libtool,
                libwrap0-dev,
+               libwslay-dev,
                libxapian-dev,
                libxml2-dev,
                libzephyr-dev,
+               libzstd-dev,
                perl,
                pkg-config,
                po-debconf,
@@ -179,10 +187,11 @@ Description: Cyrus mail system - POP3 su
  For more information, please see the cyrus-common package.
 
 Package: cyrus-admin
-Architecture: all
+Architecture: any
 Depends: cyrus-common,
          libcyrus-imap-perl (>= ${binary:Version}),
          ${misc:Depends},
+         ${shlibs:Depends},
          ${perl:Depends}
 Suggests: sasl2-bin
 Pre-Depends: ${misc:Pre-Depends}
diff -pruN 3.0.13-5/debian/copyright 3.2.0-3/debian/copyright
--- 3.0.13-5/debian/copyright	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/copyright	2020-05-04 05:39:35.000000000 +0000
@@ -4,23 +4,97 @@ Upstream-Contact: cyrus-devel@lists.andr
 Source: https://www.cyrusimap.org/
 
 Files: *
-Copyright: 1994-2016 Carnegie Mellon University.
+Copyright: 1994-2020, Carnegie Mellon University
 License: CMU
 
-Files: tools/vzic/*
-Copyright: 2000-2001 Ximian, Inc.
-	   2003 Damon Chaplin.
-License: GPL-2+
-
 Files: debian/*
-Copyright: 2002-2010 Henrique de Moraes Holschuh
-	   	     Sven Mueller
-		     Benjamin Seidenberg
-		     Farzad FARID
-		     Christoph Berg
-           2005-2015 Ondřej Surý
+Copyright: 2002-2010, Henrique de Moraes Holschuh
+ 2002-2010, Sven Mueller
+ 2002-2010, Benjamin Seidenberg
+ 2002-2010, Farzad FARID
+ 2002-2010, Christoph Berg
+ 2005-2015, Ondřej Surý
+ 2019-2020, Xavier Guimard <yadd@debian.org>
+License: CMU
+
+Files: imap/objectstore_caringo.c
+Copyright: 2015 OpenIO, as a part of Cyrus
+License: CMU
+
+Files: imap/setproctitle.c
+Copyright: 1994-2008, Carnegie Mellon University
+ 1983-1995 Eric P. Allman
+ 1988-1993 The Regents of the University of California
+License: CMU
+
+Files: install-sh
+Copyright: 1994 X Consortium
+License: Expat
+Comment:
+ Except as contained in this notice, the name of the X Consortium shall not
+ be used in advertising or otherwise to promote the sale, use or other deal-
+ ings in this Software without prior written authorization from the X Consor-
+ tium.
+ .
+ FSF changes to this file are in the public domain
+
+Files: lib/bloom.*
+Copyright: 012-2016, Jyri J. Virkki
+License: BSD-2-Clause
+
+Files: lib/crc32.c
+Copyright: 2011-2015 Stephan Brumme
+License: CRC-License
+
+Files: lib/crc32c.c
+Copyright: 2013 Mark Adler
+ 2011-2015 Stephan Brumme
+License: CRC-License
+
+Files: perl/imap/Cyrus/*
+Copyright: 2008-2017 FastMail
 License: CMU
 
+License: BSD-2-Clause
+ Redistribution and use in source and binary forms, with or without
+ modification, are permitted provided that the following conditions are
+ met:
+ .
+ 1. Redistributions of source code must retain the above copyright
+ notice, this list of conditions and the following disclaimer.
+ .
+ 2. Redistributions in binary form must reproduce the above copyright
+ notice, this list of conditions and the following disclaimer in the
+ documentation and/or other materials provided with the distribution.
+ .
+ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+License: CRC-License
+ This software is provided 'as-is', without any express or implied warranty.
+ In no event will the author be held liable for any damages arising from the
+ of this software.
+ .
+ Permission is granted to anyone to use this software for any purpose,
+ including commercial applications, and to alter it and redistribute it
+ freely, subject to the following restrictions:
+ .
+ 1. The origin of this software must not be misrepresented; you must not
+    claim that you wrote the original software.
+ 2. If you use this software in a product, an acknowledgment in the product
+    documentation would be appreciated but is not required.
+ 3. Altered source versions must be plainly marked as such, and must not be
+    misrepresented as being the original software.
+
 License: CMU
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
@@ -58,19 +132,20 @@ License: CMU
  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
  OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-License: GPL-2+
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
- .
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
- .
- You should have received a copy of the GNU General Public License
- along with this program.  If not, see <https://www.gnu.org/licenses/>.
- .
- On Debian systems, the full text of the GNU General Public License
- version 2 can be found in the file `/usr/share/common-licenses/GPL-2'.
+License: Expat
+ Permission is hereby granted, free of charge, to any person obtaining a copy
+ of this software and associated documentation files (the "Software"), to
+ deal in the Software without restriction, including without limitation the
+ rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+ sell copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+ .
+ The above copyright notice and this permission notice shall be included in
+ all copies or substantial portions of the Software.
+ .
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
+ X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
+ AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
+ TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
diff -pruN 3.0.13-5/debian/cyrus-admin.install 3.2.0-3/debian/cyrus-admin.install
--- 3.0.13-5/debian/cyrus-admin.install	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-admin.install	2020-05-04 05:39:35.000000000 +0000
@@ -1,5 +1,6 @@
 usr/bin/cyradm
 usr/lib/cyrus/bin/installsieve
+usr/lib/cyrus/bin/promstatsd
 usr/lib/cyrus/bin/sieveshell
 usr/share/icons/*
 usr/share/man/man1/cyradm.1p
diff -pruN 3.0.13-5/debian/cyrus-caldav.install 3.2.0-3/debian/cyrus-caldav.install
--- 3.0.13-5/debian/cyrus-caldav.install	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-caldav.install	2020-05-04 05:39:35.000000000 +0000
@@ -1,3 +1,3 @@
 usr/lib/cyrus/bin/dav_reconstruct
 usr/lib/cyrus/bin/httpd
-usr/share/man/man8/cyrus-httpd.8
+#usr/share/man/man8/cyrus-httpd.8
diff -pruN 3.0.13-5/debian/cyrus-caldav.lintian-overrides 3.2.0-3/debian/cyrus-caldav.lintian-overrides
--- 3.0.13-5/debian/cyrus-caldav.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-caldav.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-cyrus-caldav: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/cyrus-clients.lintian-overrides 3.2.0-3/debian/cyrus-clients.lintian-overrides
--- 3.0.13-5/debian/cyrus-clients.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-clients.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-cyrus-clients: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/cyrus-common.contrib 3.2.0-3/debian/cyrus-common.contrib
--- 3.0.13-5/debian/cyrus-common.contrib	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-common.contrib	2020-05-04 05:39:35.000000000 +0000
@@ -1,7 +1,7 @@
 contrib/cyrus-graphtools.1.0
 contrib/fud-client.c
 contrib/README
-contrib/sieve-spamasssassin
+contrib/sieve-spamassassin
 contrib/squatrunner.pl
 contrib/squatrunner.txt
 contrib/add-cyrus-user
diff -pruN 3.0.13-5/debian/cyrus-common.install 3.2.0-3/debian/cyrus-common.install
--- 3.0.13-5/debian/cyrus-common.install	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-common.install	2020-05-04 05:39:35.000000000 +0000
@@ -60,7 +60,10 @@ usr/share/man/man8/cyr_virusscan.8
 usr/share/man/man8/cyrus-arbitron.8
 usr/share/man/man8/cyrus-arbitronsort.8
 usr/share/man/man8/cyrus-chk_*.8
-usr/share/man/man8/cyrus-ctl_*.8
+#usr/share/man/man8/cyrus-ctl_*.8
+usr/share/man/man8/cyrus-ctl_deliver.8
+usr/share/man/man8/cyrus-ctl_cyrusdb.8
+usr/share/man/man8/cyrus-ctl_mboxlist.8
 usr/share/man/man8/cyrus-cvt_*.8
 usr/share/man/man8/cyrus-cyr_buildinfo.8
 usr/share/man/man8/cyrus-cyr_dbtool.8
diff -pruN 3.0.13-5/debian/cyrus-common.lintian-overrides 3.2.0-3/debian/cyrus-common.lintian-overrides
--- 3.0.13-5/debian/cyrus-common.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-common.lintian-overrides	2020-05-04 06:45:21.000000000 +0000
@@ -1,2 +1 @@
-cyrus-common: possible-gpl-code-linked-with-openssl
 cyrus-common: package-name-doesnt-match-sonames libcyrus0 libcyrus-imap0 libcyrus-min0 libcyrus-sieve0
diff -pruN 3.0.13-5/debian/cyrus-imapd.lintian-overrides 3.2.0-3/debian/cyrus-imapd.lintian-overrides
--- 3.0.13-5/debian/cyrus-imapd.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-imapd.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-cyrus-imapd: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/cyrus-murder.lintian-overrides 3.2.0-3/debian/cyrus-murder.lintian-overrides
--- 3.0.13-5/debian/cyrus-murder.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-murder.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-cyrus-murder: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/cyrus-nntpd.install 3.2.0-3/debian/cyrus-nntpd.install
--- 3.0.13-5/debian/cyrus-nntpd.install	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-nntpd.install	2020-05-04 05:39:35.000000000 +0000
@@ -1,5 +1,5 @@
 etc/pam.d/nntp
 usr/lib/cyrus/bin/fetchnews
 usr/lib/cyrus/bin/nntpd
-usr/share/man/man8/cyrus-fetchnews.8
-usr/share/man/man8/cyrus-nntpd.8
+#usr/share/man/man8/cyrus-fetchnews.8
+#usr/share/man/man8/cyrus-nntpd.8
diff -pruN 3.0.13-5/debian/cyrus-nntpd.lintian-overrides 3.2.0-3/debian/cyrus-nntpd.lintian-overrides
--- 3.0.13-5/debian/cyrus-nntpd.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/cyrus-nntpd.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-cyrus-nntpd: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/cyrus-replication.install 3.2.0-3/debian/cyrus-replication.install
--- 3.0.13-5/debian/cyrus-replication.install	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/cyrus-replication.install	2020-05-04 05:39:35.000000000 +0000
@@ -3,6 +3,6 @@ usr/lib/cyrus/bin/sync_client
 usr/lib/cyrus/bin/sync_reset
 usr/lib/cyrus/bin/sync_server
 usr/share/man/man8/cyrus-cyr_synclog.8
-usr/share/man/man8/cyrus-sync_client.8
-usr/share/man/man8/cyrus-sync_reset.8
-usr/share/man/man8/cyrus-sync_server.8
+#usr/share/man/man8/cyrus-sync_client.8
+#usr/share/man/man8/cyrus-sync_reset.8
+#usr/share/man/man8/cyrus-sync_server.8
diff -pruN 3.0.13-5/debian/libcyrus-imap-perl.lintian-overrides 3.2.0-3/debian/libcyrus-imap-perl.lintian-overrides
--- 3.0.13-5/debian/libcyrus-imap-perl.lintian-overrides	2020-03-02 05:09:18.000000000 +0000
+++ 3.2.0-3/debian/libcyrus-imap-perl.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-libcyrus-imap-perl: possible-gpl-code-linked-with-openssl
diff -pruN 3.0.13-5/debian/patches/0001-Disable-runpath-checking.patch 3.2.0-3/debian/patches/0001-Disable-runpath-checking.patch
--- 3.0.13-5/debian/patches/0001-Disable-runpath-checking.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0001-Disable-runpath-checking.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,7 +1,8 @@
-From: Debian Cyrus Team
- <pkg-cyrus-imapd-debian-devel@lists.alioth.debian.org>
-Date: Tue, 4 Aug 2015 10:38:04 +0200
-Subject: Disable runpath checking
+Description: Disable runpath checking
+Author: Debian Cyrus Team <pkg-cyrus-imapd-debian-devel@lists.alioth.debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 @DPATCH@
 ---
@@ -10,7 +11,7 @@ Subject: Disable runpath checking
 
 --- a/configure.ac
 +++ b/configure.ac
-@@ -174,9 +174,6 @@
+@@ -181,9 +181,6 @@
    AC_MSG_ERROR(The Cyrus IMAPD requires support for long long int)
  fi
  
diff -pruN 3.0.13-5/debian/patches/0002-Shutdown-and-close-sockets-cleanly.patch 3.2.0-3/debian/patches/0002-Shutdown-and-close-sockets-cleanly.patch
--- 3.0.13-5/debian/patches/0002-Shutdown-and-close-sockets-cleanly.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0002-Shutdown-and-close-sockets-cleanly.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,30 +1,25 @@
-From: Henrique de Moraes Holschuh <hmh@debian.org>
-Date: Tue, 4 Aug 2015 10:38:04 +0200
-Subject: Shutdown and close sockets cleanly
-
-Cleanly shutdown and close sockets, this is supposed to allow for better
-TCP teardown on the remote end, and reduces CLOSE_WAIT time.
-
-This patch was written 8 years ago, it is possible that nowadays nothing
-will benefit from a shutdown() right before close().  The commit log
-from eight years ago mentions that SHUT_RD should be upgraded to
-SHUT_RDWR where possible, but only after verification that this is not
-going to cause problems (e.g. by discarding data still on flight to the
-remote).
-
-Also, it is possible that new daemons and utils in Cyrus 2.2 and 2.3 may
-need similar patches.
----
- imap/fud.c   | 9 +++++++++
- imap/imapd.c | 4 ++++
- imap/lmtpd.c | 3 +++
- imap/pop3d.c | 3 +++
- 4 files changed, 19 insertions(+)
+Description: Shutdown and close sockets cleanly
+ Cleanly shutdown and close sockets, this is supposed to allow for better
+ TCP teardown on the remote end, and reduces CLOSE_WAIT time.
+ .
+ This patch was written 8 years ago, it is possible that nowadays nothing
+ will benefit from a shutdown() right before close().  The commit log
+ from eight years ago mentions that SHUT_RD should be upgraded to
+ SHUT_RDWR where possible, but only after verification that this is not
+ going to cause problems (e.g. by discarding data still on flight to the
+ remote).
+ .
+ Also, it is possible that new daemons and utils in Cyrus 2.2 and 2.3 may
+ need similar patches.
+Author: Henrique de Moraes Holschuh <hmh@debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/imap/fud.c
 +++ b/imap/fud.c
-@@ -143,6 +143,15 @@
-     mboxlist_done();
+@@ -141,6 +141,15 @@
+     seen_done();
      closelog();
      cyrus_done();
 +
@@ -41,7 +36,7 @@ need similar patches.
  
 --- a/imap/imapd.c
 +++ b/imap/imapd.c
-@@ -1149,6 +1149,10 @@
+@@ -1134,6 +1134,10 @@
  #ifdef HAVE_SSL
      tls_shutdown_serverengine();
  #endif
@@ -50,11 +45,11 @@ need similar patches.
 +    cyrus_close_sock(1);
 +    cyrus_close_sock(2);
  
-     cyrus_done();
+     saslprops_free(&saslprops);
  
 --- a/imap/lmtpd.c
 +++ b/imap/lmtpd.c
-@@ -964,6 +964,9 @@
+@@ -1014,6 +1014,9 @@
  
      cyrus_done();
  
@@ -66,8 +61,8 @@ need similar patches.
  
 --- a/imap/pop3d.c
 +++ b/imap/pop3d.c
-@@ -701,6 +701,9 @@
- #endif
+@@ -649,6 +649,9 @@
+     saslprops_free(&saslprops);
  
      cyrus_done();
 +    cyrus_close_sock(0);
diff -pruN 3.0.13-5/debian/patches/0003-Fix-syslog-prefix.patch 3.2.0-3/debian/patches/0003-Fix-syslog-prefix.patch
--- 3.0.13-5/debian/patches/0003-Fix-syslog-prefix.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0003-Fix-syslog-prefix.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,41 +1,34 @@
-From: Sven Mueller <debian@incase.de>
-Date: Tue, 4 Aug 2015 10:38:05 +0200
-Subject: Fix syslog prefix
-
-Make sure all programs log (to syslog) with "cyrus/<program>" as the
-log prefix.
-
-@DPATCH@
----
- imap/global.c       | 7 ++++++-
- ptclient/ptexpire.c | 2 +-
- ptclient/test.c     | 2 +-
- ptclient/test2.c    | 2 +-
- 4 files changed, 9 insertions(+), 4 deletions(-)
+Description: Fix syslog prefix
+ Make sure all programs log (to syslog) with "cyrus/<program>" as the
+ log prefix.
+Author: Sven Mueller <debian@incase.de>
+Forwarded: no
+Rewieved-By: Xavier Guimard <yadd@debian.org>
+Last-Update: 2020-02-10
 
 --- a/imap/global.c
 +++ b/imap/global.c
-@@ -153,6 +153,9 @@
+@@ -156,6 +156,9 @@
      return SYSLOG_FACILITY;
  }
  
 +/* syslog prefix tag */
 +static char syslog_prefix[20];
 +
- /* Called before a cyrus application starts (but after command line parameters
-  * are read) */
- EXPORTED int cyrus_init(const char *alt_config, const char *ident, unsigned flags, int config_need_data)
-@@ -186,7 +189,9 @@
- 
-     /* xxx we lose here since we can't have the prefix until we load the
-      * config file */
--    openlog(config_ident, syslog_opts, SYSLOG_FACILITY);
-+    strncpy(syslog_prefix, "cyrus/", sizeof(syslog_prefix));
-+    strncat(syslog_prefix, config_ident, sizeof(syslog_prefix) - 7);
-+    openlog(syslog_prefix, syslog_opts, SYSLOG_FACILITY);
+ struct cyrus_module {
+     void (*done)(void *rock);
+     void *rock;
+@@ -232,7 +235,9 @@
+         openlog(ident_buf, syslog_opts, SYSLOG_FACILITY);
+     }
+     else {
+-        openlog(config_ident, syslog_opts, SYSLOG_FACILITY);
++	strncpy(syslog_prefix, "cyrus/", sizeof(syslog_prefix));
++	strncat(syslog_prefix, config_ident, sizeof(syslog_prefix) - 7);
++        openlog(syslog_prefix, syslog_opts, SYSLOG_FACILITY);
+     }
  
      /* Load configuration file.  This will set config_dir when it finds it */
-     config_read(alt_config, config_need_data);
 --- a/ptclient/ptexpire.c
 +++ b/ptclient/ptexpire.c
 @@ -108,7 +108,7 @@
diff -pruN 3.0.13-5/debian/patches/0004-silence-erroneous-RLIMIT_NUMFDS-related-log-messages.patch 3.2.0-3/debian/patches/0004-silence-erroneous-RLIMIT_NUMFDS-related-log-messages.patch
--- 3.0.13-5/debian/patches/0004-silence-erroneous-RLIMIT_NUMFDS-related-log-messages.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0004-silence-erroneous-RLIMIT_NUMFDS-related-log-messages.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,17 +1,15 @@
-From: Henrique de Moraes Holschuh <hmh@debian.org>
-Date: Tue, 4 Aug 2015 10:38:05 +0200
-Subject: silence erroneous RLIMIT_NUMFDS-related log messages
-
-Fixes setrlimit(RLIMIT_NUMFDS) handling to be less obnoxious and
-not barf error messages to syslog incorrectly, nor log nonsense
-if getrlimit(RLIMIT_NUMFDS) failed.
----
- master/master.c | 4 ++--
- 1 file changed, 2 insertions(+), 2 deletions(-)
+Description: silence erroneous RLIMIT_NUMFDS-related log messages
+ Fixes setrlimit(RLIMIT_NUMFDS) handling to be less obnoxious and
+ not barf error messages to syslog incorrectly, nor log nonsense
+ if getrlimit(RLIMIT_NUMFDS) failed.
+Author: Henrique de Moraes Holschuh <hmh@debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/master/master.c
 +++ b/master/master.c
-@@ -1930,7 +1930,7 @@
+@@ -1968,7 +1968,7 @@
      struct rlimit rl;
  
  #ifdef HAVE_GETRLIMIT
@@ -20,7 +18,7 @@ if getrlimit(RLIMIT_NUMFDS) failed.
          if (x != RLIM_INFINITY && rl.rlim_max != RLIM_INFINITY && x > rl.rlim_max) {
              syslog(LOG_WARNING,
                     "limit_fds: requested %" PRIu64 ", but capped to %" PRIu64,
-@@ -1949,7 +1949,7 @@
+@@ -1987,7 +1987,7 @@
                 rl.rlim_cur, rl.rlim_max);
      }
  
diff -pruN 3.0.13-5/debian/patches/0005-Updates-calling-of-the-perl-interpreter-to-what-we-e.patch 3.2.0-3/debian/patches/0005-Updates-calling-of-the-perl-interpreter-to-what-we-e.patch
--- 3.0.13-5/debian/patches/0005-Updates-calling-of-the-perl-interpreter-to-what-we-e.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0005-Updates-calling-of-the-perl-interpreter-to-what-we-e.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,284 +1,39 @@
-From: Sven Mueller <debian@incase.de>
-Date: Tue, 4 Aug 2015 10:38:05 +0200
-Subject: Updates calling of the perl interpreter to what we expect in Debian
+Description: Updates calling of the perl interpreter to what we expect in Debian
+ More precisely: Call /usr/bin/perl directly instead of using some
+ shell magic to locate perl and run it.
+ .
+ NOTE: only some script use the "-w" or even the "-T" flag for perl.
+ This should be the default actually.
+Author: Sven Mueller <debian@incase.de>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
-More precisely: Call /usr/bin/perl directly instead of using some
-shell magic to locate perl and run it.
-
-NOTE: only some script use the "-w" or even the "-T" flag for perl.
-This should be the default actually.
----
- perl/imap/examples/auditmbox.pl    |  2 +-
- perl/imap/examples/imapcollate.pl  |  2 +-
- perl/imap/examples/imapdu.pl       |  2 +-
- perl/sieve/scripts/installsieve.pl |  4 +---
- perl/sieve/scripts/sieveshell.pl   |  4 +---
- snmp/snmpgen                       | 20 +-------------------
- tools/config2header                | 20 +-------------------
- tools/config2man                   | 20 +-------------------
- tools/masssievec                   | 24 +++---------------------
- tools/mkimap                       | 20 +-------------------
- tools/mknewsgroups                 | 25 +++----------------------
- tools/rehash                       |  2 +-
- tools/translatesieve               |  4 +---
- 13 files changed, 17 insertions(+), 132 deletions(-)
-
---- a/perl/imap/examples/auditmbox.pl
-+++ b/perl/imap/examples/auditmbox.pl
-@@ -1,4 +1,4 @@
--#! /usr/bin/perl -w
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
---- a/perl/imap/examples/imapcollate.pl
-+++ b/perl/imap/examples/imapcollate.pl
-@@ -1,4 +1,4 @@
--#! /usr/bin/perl -w
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
---- a/perl/imap/examples/imapdu.pl
-+++ b/perl/imap/examples/imapdu.pl
-@@ -1,4 +1,4 @@
--#! /usr/bin/perl -w
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
---- a/perl/sieve/scripts/installsieve.pl
-+++ b/perl/sieve/scripts/installsieve.pl
+--- a/perl/imap/cyradm.sh
++++ b/perl/imap/cyradm.sh
 @@ -1,6 +1,4 @@
 -#! /bin/sh
 -exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
-+#!/usr/bin/perl -w
+-#!perl
++#!/usr/bin/perl
  #
  # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  #
---- a/perl/sieve/scripts/sieveshell.pl
-+++ b/perl/sieve/scripts/sieveshell.pl
+--- a/perl/sieve/scripts/installsieve.pl
++++ b/perl/sieve/scripts/installsieve.pl
 @@ -1,6 +1,4 @@
 -#! /bin/sh
 -exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
 -#!perl -w
-+#!/usr/bin/perl -w
++#!/usr/bin/perl
  #
  # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  #
---- a/snmp/snmpgen
-+++ b/snmp/snmpgen
-@@ -1,4 +1,4 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,24 +39,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-w", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- #Tim Martin
---- a/tools/config2header
-+++ b/tools/config2header
-@@ -1,4 +1,4 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,24 +39,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- use strict;
---- a/tools/config2man
-+++ b/tools/config2man
-@@ -1,4 +1,4 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,24 +39,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- use strict;
---- a/tools/masssievec
-+++ b/tools/masssievec
-@@ -1,4 +1,6 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
-+#
-+# Script for mass compilation of sieve scripts.
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,26 +41,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--#
--# Script for mass compilation of sieve scripts.
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- $| = 1;
---- a/tools/mkimap
-+++ b/tools/mkimap
-@@ -1,4 +1,4 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,24 +39,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- sub read_conf {
---- a/tools/mknewsgroups
-+++ b/tools/mknewsgroups
-@@ -1,4 +1,6 @@
--#!/bin/sh
-+#!/usr/bin/perl -w
-+# 
-+# Create newsgroups on imap server
- #
- # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- #
-@@ -39,27 +41,6 @@
- # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- 
--exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
--#!perl -w
--#
--# Create newsgroups on imap server
--# Based on the make_fromactive.pl script by Tim Martin
--
--if ($] !~ /^5\..*/) {
--  # uh-oh. this isn't perl 5.
--  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
--    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
--  }
--  # we failed. bail.
--  die "Your perl is too old; I need perl 5.\n";
--}
--
--# load the real script. this is isolated in an 'eval' so perl4 won't
--# choke on the perl5-isms.
--eval join("\n", <DATA>);
--if ($@) { die "$@"; }
--
--__END__
- require 5;
- 
- use Getopt::Long;
 --- a/tools/rehash
 +++ b/tools/rehash
 @@ -1,4 +1,4 @@
 -#!/usr/bin/env perl
-+#!/usr/bin/perl -w
++#!/usr/bin/perl
  #
  # Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
  #
@@ -288,7 +43,7 @@ This should be the default actually.
 -#!/bin/sh
 -exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
 -#!perl -w
-+#!/usr/bin/perl -w
++#!/usr/bin/perl
  #
  # script to translate sieve scripts to use unixhierarchysep and/or altnamespace
  # make sure you run it as the cyrus user
diff -pruN 3.0.13-5/debian/patches/0006-Fix-paths-on-Debian-in-tools-rehash.patch 3.2.0-3/debian/patches/0006-Fix-paths-on-Debian-in-tools-rehash.patch
--- 3.0.13-5/debian/patches/0006-Fix-paths-on-Debian-in-tools-rehash.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0006-Fix-paths-on-Debian-in-tools-rehash.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,10 +1,8 @@
-From: Sven Mueller <debian@incase.de>
-Date: Tue, 4 Aug 2015 10:38:06 +0200
-Subject: Fix paths on Debian in tools/rehash
-
----
- tools/rehash | 4 ++--
- 1 file changed, 2 insertions(+), 2 deletions(-)
+Description: Fix paths on Debian in tools/rehash
+Author: Sven Mueller <debian@incase.de>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/tools/rehash
 +++ b/tools/rehash
diff -pruN 3.0.13-5/debian/patches/0007-Adds-some-enhancements-to-sieveshell-and-fixes-some-.patch 3.2.0-3/debian/patches/0007-Adds-some-enhancements-to-sieveshell-and-fixes-some-.patch
--- 3.0.13-5/debian/patches/0007-Adds-some-enhancements-to-sieveshell-and-fixes-some-.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0007-Adds-some-enhancements-to-sieveshell-and-fixes-some-.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,11 +1,8 @@
-From: Sven Mueller <debian@incase.de>
-Date: Tue, 4 Aug 2015 10:38:06 +0200
-Subject: Adds some enhancements to sieveshell and fixes some paths.
-
----
- perl/imap/IMAP/Shell.pm          |  4 +--
- perl/sieve/scripts/sieveshell.pl | 55 +++++++++++++++++++++++++++++++---------
- 2 files changed, 45 insertions(+), 14 deletions(-)
+Description: Adds some enhancements to sieveshell and fixes some paths.
+Author: Sven Mueller <debian@incase.de>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/perl/imap/IMAP/Shell.pm
 +++ b/perl/imap/IMAP/Shell.pm
@@ -29,7 +26,7 @@ Subject: Adds some enhancements to sieve
    if ($dorc && $systemrc ne '' && -f $systemrc) {
 --- a/perl/sieve/scripts/sieveshell.pl
 +++ b/perl/sieve/scripts/sieveshell.pl
-@@ -59,7 +59,9 @@
+@@ -62,7 +62,9 @@
  my $username = $ENV{USER};
  my $authname = $ENV{USER};
  my $realm = "";
@@ -39,7 +36,7 @@ Subject: Adds some enhancements to sieve
  my $help = 0;
  my $man = 0;
  my $ret;
-@@ -67,7 +69,9 @@
+@@ -70,7 +72,9 @@
  GetOptions("a|authname:s" => \$authname,
      "u|username:s" => \$username,
      "r|realm:s" => \$realm,
@@ -49,7 +46,7 @@ Subject: Adds some enhancements to sieve
      "help|?" => \$help,
      man => \$man) or pod2usage(2);
  pod2usage(1) if $help;
-@@ -82,20 +86,24 @@
+@@ -85,20 +89,24 @@
  my $filehandle;
  my $interactive;
  
@@ -84,7 +81,7 @@ Subject: Adds some enhancements to sieve
  
  sub list_cb {
  
-@@ -120,6 +128,8 @@
+@@ -123,6 +131,8 @@
        return $authname;
    } elsif (($type eq "realm") && (defined $realm)) {
        return $realm;
@@ -93,7 +90,7 @@ Subject: Adds some enhancements to sieve
    }
  
    my $ostty;
-@@ -170,6 +180,8 @@
+@@ -173,6 +183,8 @@
  
  my $term = Term::ReadLine->new("sieveshell");
  
@@ -102,7 +99,7 @@ Subject: Adds some enhancements to sieve
  $term->ornaments(0);
  
  while(defined($_  = ($interactive ? $term->readline('> ') : <$filehandle>))){
-@@ -196,6 +208,7 @@
+@@ -199,6 +211,7 @@
          my $errstr = sieve_get_error($obj);
          $errstr = "unknown error" if(!defined($errstr));
          print "upload failed: $errstr\n";
@@ -110,7 +107,7 @@ Subject: Adds some enhancements to sieve
        }
      } elsif (($words[0] eq "list") ||
               ($words[0] eq "l") ||
-@@ -205,6 +218,7 @@
+@@ -208,6 +221,7 @@
              my $errstr = sieve_get_error($obj);
              $errstr = "unknown error" if(!defined($errstr));
              print "list failed: $errstr\n";
@@ -118,7 +115,7 @@ Subject: Adds some enhancements to sieve
          }
      } elsif (($words[0] eq "activate") ||
               ($words[0] eq "a")) {
-@@ -217,6 +231,7 @@
+@@ -220,6 +234,7 @@
              my $errstr = sieve_get_error($obj);
              $errstr = "unknown error" if(!defined($errstr));
              print "activate failed: $errstr\n";
@@ -126,7 +123,7 @@ Subject: Adds some enhancements to sieve
          }
      } elsif (($words[0] eq "deactivate") ||
               ($words[0] eq "da")) {
-@@ -229,6 +244,7 @@
+@@ -232,6 +247,7 @@
              my $errstr = sieve_get_error($obj);
              $errstr = "unknown error" if(!defined($errstr));
              print "deactivate failed: $errstr\n";
@@ -134,7 +131,7 @@ Subject: Adds some enhancements to sieve
          }
      } elsif (($words[0] eq "delete") ||
               ($words[0] eq "d")) {
-@@ -241,6 +257,7 @@
+@@ -244,6 +260,7 @@
              my $errstr = sieve_get_error($obj);
              $errstr = "unknown error" if(!defined($errstr));
              print "delete failed: $errstr\n";
@@ -142,7 +139,7 @@ Subject: Adds some enhancements to sieve
          }
      } elsif (($words[0] eq "get") ||
               ($words[0] eq "g")) {
-@@ -254,6 +271,7 @@
+@@ -257,6 +274,7 @@
              my $errstr = sieve_get_error($obj);
              $errstr = "unknown error" if(!defined($errstr));
              print "get failed: $errstr\n";
@@ -150,7 +147,7 @@ Subject: Adds some enhancements to sieve
          } else {
              if ($words[2]) {
                  open (OUTPUT,">$words[2]") || die "Unable to open $words[2]";
-@@ -265,14 +283,16 @@
+@@ -268,14 +286,16 @@
          }
      } elsif (($words[0] eq "quit") || ($words[0] eq "q")) {
          sieve_logout($obj);
@@ -168,7 +165,7 @@ Subject: Adds some enhancements to sieve
  __END__
  
  =for pod2rst .. DO NOT EDIT sieveshell.rst: Autogenerated by tools/perl2rst from perl/sieve/scripts/sieveshell.pl
-@@ -288,7 +308,8 @@
+@@ -291,7 +311,8 @@
  =head1 SYNOPSIS
  
  sieveshell [B<--user>=I<user>] [B<--authname>=I<authname>]
@@ -178,7 +175,7 @@ Subject: Adds some enhancements to sieve
  
  sieveshell B<--help>
  
-@@ -332,11 +353,21 @@
+@@ -336,11 +357,21 @@
  
  The realm to attempt authentication in.
  
diff -pruN 3.0.13-5/debian/patches/0008-Accept-invalid-From-header-in-email.patch 3.2.0-3/debian/patches/0008-Accept-invalid-From-header-in-email.patch
--- 3.0.13-5/debian/patches/0008-Accept-invalid-From-header-in-email.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0008-Accept-invalid-From-header-in-email.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,37 +1,39 @@
-From: "Jeroen van Meeuwen (Kolab Systems)" <vanmeeuwen@kolabsys.com>
-Date: Tue, 3 Aug 2010 10:13:36 +0200
-Subject: Accept invalid From: header in email
-
-This stops Cyrus from ruining everything all by itself; Your MTA is
-the point where the validity of headers should be checked. For more
-information on such and so forth, see (amongst others):
-
+Description: Accept invalid From: header in email
+ This stops Cyrus from ruining everything all by itself; Your MTA is
+ the point where the validity of headers should be checked. For more
+ information on such and so forth, see (amongst others):
+ .
     http://www.postfix.org/header_checks.5.html
-
-If one chooses to allow slightly invalid headers in the MTA, then
-Cyrus should not raise problems.
----
- imap/message.c | 17 ++++++++++++++---
- 1 file changed, 14 insertions(+), 3 deletions(-)
+ .
+ If one chooses to allow slightly invalid headers in the MTA, then
+ Cyrus should not raise problems.
+Author: "Jeroen van Meeuwen (Kolab Systems)" <vanmeeuwen@kolabsys.com>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org>
+Last-Update: 2020-02-10
 
 --- a/imap/message.c
 +++ b/imap/message.c
-@@ -187,6 +187,8 @@
-     int reject8bit = config_getswitch(IMAPOPT_REJECT8BIT);
+@@ -190,6 +190,8 @@
      int munge8bit = config_getswitch(IMAPOPT_MUNGE8BIT);
      int inheader = 1, blankline = 1;
+     struct buf tmp = BUF_INITIALIZER;
 +    char is_from;
 +    static const char * from_header = "From ";
  
      while (size) {
          n = prot_read(from, buf, size > 4096 ? 4096 : size);
-@@ -263,9 +265,18 @@
-         /* Check for valid header name */
-         if (sawnl && buf[0] != ' ' && buf[0] != '\t') {
-             if (buf[0] == ':') return IMAP_MESSAGE_BADHEADER;
--      if (strstr(buf, "From ") != buf)
--            for (p = (unsigned char *)buf; *p != ':'; p++) {
--                if (*p <= ' ') return IMAP_MESSAGE_BADHEADER;
+@@ -305,13 +307,18 @@
+                 r = IMAP_MESSAGE_BADHEADER;
+                 goto done;
+             }
+-            if (strstr(buf, "From ") != buf) {
+-                for (p = (unsigned char *)buf; *p && *p != ':'; p++) {
+-                    if (*p <= ' ') {
+-                        r = IMAP_MESSAGE_BADHEADER;
+-                        goto done;
+-                    }
+-                }
 +	    p = (unsigned char *) buf;
 +	    if (*p == '>') p++;
 +	    is_from = (*p == from_header[0])?0:1;
diff -pruN 3.0.13-5/debian/patches/0009-Normalize-the-authentication-ID.patch 3.2.0-3/debian/patches/0009-Normalize-the-authentication-ID.patch
--- 3.0.13-5/debian/patches/0009-Normalize-the-authentication-ID.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0009-Normalize-the-authentication-ID.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,28 +1,21 @@
-From: "Jeroen van Meeuwen (Kolab Systems)" <vanmeeuwen@kolabsys.com>
-Date: Tue, 3 Aug 2010 10:19:11 +0200
-Subject: Normalize the authentication ID
-
-By normalize, it is intended that;
-
+Description: Normalize the authentication ID
+ By normalize, it is intended that;
     1) Authentication IDs all can be lowercased for more accurate
        comparison without being volatile to, say, user error, and
     2) Any leading or trailing blank space can be stripped
----
- imap/global.c    |  2 ++
- lib/auth_unix.c  | 18 ++++++++++++++++++
- lib/imapoptions  |  5 +++++
- lib/libcyr_cfg.c |  4 ++++
- lib/libcyr_cfg.h |  2 ++
- 5 files changed, 31 insertions(+)
+Author: "Jeroen van Meeuwen (Kolab Systems)" <vanmeeuwen@kolabsys.com>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/imap/global.c
 +++ b/imap/global.c
-@@ -304,6 +304,8 @@
+@@ -351,6 +351,8 @@
                                    config_getswitch(IMAPOPT_UNIX_GROUP_ENABLE));
          libcyrus_config_setswitch(CYRUSOPT_USERNAME_TOLOWER,
                                    config_getswitch(IMAPOPT_USERNAME_TOLOWER));
 +	libcyrus_config_setswitch(CYRUSOPT_NORMALIZEUID,
-+				  config_getswitch(IMAPOPT_NORMALIZEUID));
++				  config_getswitch(CYRUSOPT_NORMALIZEUID));
          libcyrus_config_setswitch(CYRUSOPT_SKIPLIST_UNSAFE,
                                    config_getswitch(IMAPOPT_SKIPLIST_UNSAFE));
          libcyrus_config_setstring(CYRUSOPT_TEMP_PATH,
@@ -65,8 +58,8 @@ By normalize, it is intended that;
  
 --- a/lib/imapoptions
 +++ b/lib/imapoptions
-@@ -2444,6 +2444,11 @@
- { "fastmailsharing", 0, SWITCH }
+@@ -2947,6 +2947,11 @@
+ { "fastmailsharing", 0, SWITCH, "3.0.0" }
  /* If enabled, use FastMail style sharing (oldschool full server paths) */
  
 +{ "normalizeuid", 0, SWITCH }
diff -pruN 3.0.13-5/debian/patches/0010-Fix-PATH_MAX-on-GNU-Hurd.patch 3.2.0-3/debian/patches/0010-Fix-PATH_MAX-on-GNU-Hurd.patch
--- 3.0.13-5/debian/patches/0010-Fix-PATH_MAX-on-GNU-Hurd.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0010-Fix-PATH_MAX-on-GNU-Hurd.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,16 +1,12 @@
-From: =?utf-8?b?T25kxZllaiBTdXLDvQ==?= <ondrej@debian.org>
-Date: Tue, 4 Aug 2015 10:38:07 +0200
-Subject: Fix PATH_MAX on GNU/Hurd
-
----
- imap/pop3d.c     | 4 ++++
- master/master.c  | 4 ++++
- master/service.c | 4 ++++
- 3 files changed, 12 insertions(+)
+Description: Fix PATH_MAX on GNU/Hurd
+Aurhor: Ondrej Sury <ondrej@debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/imap/pop3d.c
 +++ b/imap/pop3d.c
-@@ -100,6 +100,10 @@
+@@ -99,6 +99,10 @@
  #define MAXHOSTNAMELEN 256
  #endif
  
@@ -23,7 +19,7 @@ Subject: Fix PATH_MAX on GNU/Hurd
  #define DES_DEFS
 --- a/master/master.c
 +++ b/master/master.c
-@@ -75,6 +75,10 @@
+@@ -76,6 +76,10 @@
  #define PATH_MAX 4096
  #endif
  
diff -pruN 3.0.13-5/debian/patches/0011-Fix-extra-libpci-in-SNMP_LIBS.patch 3.2.0-3/debian/patches/0011-Fix-extra-libpci-in-SNMP_LIBS.patch
--- 3.0.13-5/debian/patches/0011-Fix-extra-libpci-in-SNMP_LIBS.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0011-Fix-extra-libpci-in-SNMP_LIBS.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,7 +1,7 @@
-From: Debian Cyrus Team
- <pkg-cyrus-imapd-debian-devel@lists.alioth.debian.org>
-Date: Tue, 4 Aug 2015 10:38:07 +0200
-Subject: Fix extra libpci in SNMP_LIBS
+Description: Fix extra libpci in SNMP_LIBS
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 ---
  cmulocal/ucdsnmp.m4 | 2 +-
@@ -9,7 +9,7 @@ Subject: Fix extra libpci in SNMP_LIBS
 
 --- a/cmulocal/ucdsnmp.m4
 +++ b/cmulocal/ucdsnmp.m4
-@@ -26,7 +26,7 @@
+@@ -27,7 +27,7 @@
    if test -x "$SNMP_CONFIG"; then
      AC_MSG_CHECKING(NET SNMP libraries)
  
diff -pruN 3.0.13-5/debian/patches/0012-Use-UnicodeData.txt-from-system.patch 3.2.0-3/debian/patches/0012-Use-UnicodeData.txt-from-system.patch
--- 3.0.13-5/debian/patches/0012-Use-UnicodeData.txt-from-system.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0012-Use-UnicodeData.txt-from-system.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,14 +1,12 @@
-From: =?utf-8?b?T25kxZllaiBTdXLDvQ==?= <ondrej@debian.org>
-Date: Tue, 4 Aug 2015 10:38:07 +0200
-Subject: Use UnicodeData.txt from system
-
----
- Makefile.am | 4 ++--
- 1 file changed, 2 insertions(+), 2 deletions(-)
+Description: Use UnicodeData.txt from system
+Author: Ondrej Sury <ondrej@debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/Makefile.am
 +++ b/Makefile.am
-@@ -1460,9 +1460,9 @@
+@@ -1544,9 +1544,9 @@
  # in particular ellie believes unifix.txt must be before UnicodeData.txt
  lib/chartable.c: lib/mkchartable.pl lib/charset/unifix.txt \
  	$(top_srcdir)/lib/charset/*.t \
diff -pruN 3.0.13-5/debian/patches/0013-Re-add-perl2rst-tool-from-cyrus-imapd-3.0-upstream-b.patch 3.2.0-3/debian/patches/0013-Re-add-perl2rst-tool-from-cyrus-imapd-3.0-upstream-b.patch
--- 3.0.13-5/debian/patches/0013-Re-add-perl2rst-tool-from-cyrus-imapd-3.0-upstream-b.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0013-Re-add-perl2rst-tool-from-cyrus-imapd-3.0-upstream-b.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,49 +0,0 @@
-From: =?utf-8?b?T25kxZllaiBTdXLDvQ==?= <ondrej@sury.org>
-Date: Fri, 8 Feb 2019 13:11:38 +0000
-Subject: Re-add perl2rst tool from cyrus-imapd-3.0 upstream branch
-
----
- tools/perl2rst | 37 +++++++++++++++++++++++++++++++++++++
- 1 file changed, 37 insertions(+)
- create mode 100755 tools/perl2rst
-
---- /dev/null
-+++ b/tools/perl2rst
-@@ -0,0 +1,37 @@
-+#!/usr/bin/perl -w
-+
-+use strict;
-+use warnings;
-+
-+use Pod::POM::View::Restructured;
-+
-+{
-+    no warnings 'redefine';
-+    *Pod::POM::View::Restructured::view_for = sub {
-+        my ($self, $node) = @_;
-+
-+        my $fmt = $node->format();
-+
-+        #print STDERR "got for: fmt='$fmt', text='" . $node->text() . "'\n";
-+
-+        if ($fmt eq 'pod2rst') {
-+            my $text = $node->text();
-+            if ($text =~ /\A\s*next-code-block\s*:\s*(\S+)/) {
-+                my $lang = $1;
-+                $self->{next_code_block} = $lang;
-+                return '';
-+            }
-+
-+            return "\n" . $text . "\n";
-+        }
-+
-+        return $self->SUPER::view_for($node);
-+    };
-+}
-+
-+my $title = shift || die "Usage: $0 title < in > out";
-+
-+my $conv = Pod::POM::View::Restructured->new;
-+my $output = $conv->convert_file(\*STDIN, "**$title**", \*STDOUT);
-+
-+
diff -pruN 3.0.13-5/debian/patches/0015-conversations-update-the-G-keys-even-if-the-message-has-no-threadid.patch 3.2.0-3/debian/patches/0015-conversations-update-the-G-keys-even-if-the-message-has-no-threadid.patch
--- 3.0.13-5/debian/patches/0015-conversations-update-the-G-keys-even-if-the-message-has-no-threadid.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0015-conversations-update-the-G-keys-even-if-the-message-has-no-threadid.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,34 +0,0 @@
-From: Bron Gondwana <brong@fastmail.fm>
-Date: Mon, 11 Feb 2019 21:27:43 +1100
-Subject: [PATCH] conversations: update the G keys even if the message has no
- threadid
-
----
- imap/conversations.c | 16 ++++++++++++++++
- 1 file changed, 16 insertions(+)
-
---- a/imap/conversations.c
-+++ b/imap/conversations.c
-@@ -1870,6 +1870,22 @@
-     }
- 
-     const struct index_record *record = new ? new : old;
-+
-+    // always update the GUID information first, as it's used for search
-+    // even if conversations have not been set on this email
-+    if (new) {
-+        if (!old) {
-+            r = conversations_set_guid(cstate, mailbox, new, /*add*/1);
-+            if (r) return r;
-+        }
-+    }
-+    else {
-+        if (old) {
-+            r = conversations_set_guid(cstate, mailbox, old, /*add*/0);
-+            if (r) return r;
-+        }
-+    }
-+
-     if (new && !old) {
-         /* add the conversation */
-         r = mailbox_cacherecord(mailbox, new); /* make sure it's loaded */
diff -pruN 3.0.13-5/debian/patches/0016-conversations-actually-need-to-update-GUID-counts-after-calculating-CID.patch 3.2.0-3/debian/patches/0016-conversations-actually-need-to-update-GUID-counts-after-calculating-CID.patch
--- 3.0.13-5/debian/patches/0016-conversations-actually-need-to-update-GUID-counts-after-calculating-CID.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0016-conversations-actually-need-to-update-GUID-counts-after-calculating-CID.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,17 +1,19 @@
-From: Bron Gondwana <brong@fastmail.fm>
-Date: Mon, 11 Feb 2019 21:46:05 +1100
-Subject: [PATCH] conversations: actually,
- need to update GUID counts after calculating CID
+Description: [PATCH] conversations: update the G keys even if the message has no
+ threadid
+Author: Bron Gondwana <brong@fastmail.fm>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org>
+Last-Update: 2020-02-10
 
 ---
- imap/conversations.c | 15 +++++++++++++++
- 1 file changed, 15 insertions(+)
+ imap/conversations.c | 16 ++++++++++++++++
+ 1 file changed, 16 insertions(+)
 
 --- a/imap/conversations.c
 +++ b/imap/conversations.c
-@@ -1886,6 +1886,21 @@
-         }
-     }
+@@ -2353,6 +2353,21 @@
+     const struct index_record *record = new ? new : old;
+     if (!record) return 0;
  
 +    // always update the GUID information first, as it's used for search
 +    // even if conversations have not been set on this email
@@ -28,6 +30,6 @@ Subject: [PATCH] conversations: actually
 +        }
 +    }
 +
-     if (new && !old) {
+     if (new && !old && allowrenumber) {
          /* add the conversation */
          r = mailbox_cacherecord(mailbox, new); /* make sure it's loaded */
diff -pruN 3.0.13-5/debian/patches/0017-cert-update.patch 3.2.0-3/debian/patches/0017-cert-update.patch
--- 3.0.13-5/debian/patches/0017-cert-update.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0017-cert-update.patch	2020-05-04 05:39:35.000000000 +0000
@@ -1,12 +1,8 @@
-From: Debian Cyrus Team <team+cyrus@tracker.debian.org>
-Date: Sat, 2 Mar 2019 14:04:58 +0000
-Subject: cert-update
-
----
- cunit/cacert.pem |  82 ++++++++----------------------------
- cunit/cert.pem   | 124 +++++++++++++++++++++++++++++++++----------------------
- cunit/key.pem    |  43 ++++++++++++-------
- 3 files changed, 120 insertions(+), 129 deletions(-)
+Description: cert-update
+Author: Debian Cyrus Team <team+cyrus@tracker.debian.org>
+Forwarded: no
+Reviewed-By: Xavier Guimard <yadd@debian.org
+Last-Update: 2020-02-10
 
 --- a/cunit/cacert.pem
 +++ b/cunit/cacert.pem
diff -pruN 3.0.13-5/debian/patches/0018-fix-va_list-for-arm.patch 3.2.0-3/debian/patches/0018-fix-va_list-for-arm.patch
--- 3.0.13-5/debian/patches/0018-fix-va_list-for-arm.patch	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/debian/patches/0018-fix-va_list-for-arm.patch	2020-05-12 07:50:24.000000000 +0000
@@ -0,0 +1,74 @@
+Description: fix for non x86 arch
+ The problem here is va_list. On some architectures, the calling convention
+ doesn't seem to allow comparing va_list against NULL due to the way va_list
+ is implemented on a particular architecture.
+Author: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
+Bug: https://github.com/cyrusimap/cyrus-imapd/issues/3040
+Bug-Debian: https://bugs.debian.org/960263
+Forwarded: https://github.com/cyrusimap/cyrus-imapd/issues/3040
+Reviewed-By: Xavier Guimard <yadd@debian.org>
+Last-Update: 2020-05-12
+
+--- a/imap/httpd.c
++++ b/imap/httpd.c
+@@ -2350,7 +2350,7 @@
+     simple_hdr(txn, "Access-Control-Expose-Headers", hdr)
+ 
+ static void comma_list_body(struct buf *buf,
+-                            const char *vals[], unsigned flags, va_list args)
++                            const char *vals[], unsigned flags, int has_args, va_list args)
+ {
+     const char *sep = "";
+     int i;
+@@ -2358,11 +2358,11 @@
+     for (i = 0; vals[i]; i++) {
+         if (flags & (1 << i)) {
+             buf_appendcstr(buf, sep);
+-            if (args) buf_vprintf(buf, vals[i], args);
++            if (has_args) buf_vprintf(buf, vals[i], args);
+             else buf_appendcstr(buf, vals[i]);
+             sep = ", ";
+         }
+-        else if (args) {
++        else if (has_args) {
+             /* discard any unused args */
+             vsnprintf(NULL, 0, vals[i], args);
+         }
+@@ -2377,7 +2377,7 @@
+ 
+     va_start(args, flags);
+ 
+-    comma_list_body(&buf, vals, flags, args);
++    comma_list_body(&buf, vals, flags, 1, args);
+ 
+     va_end(args);
+ 
+@@ -2512,6 +2512,7 @@
+     int i;
+     time_t now;
+     char datestr[30];
++    va_list noargs;
+     double cmdtime, nettime;
+     const char **hdr, *sep;
+     struct auth_challenge_t *auth_chal = &txn->auth_chal;
+@@ -3077,17 +3078,17 @@
+     }
+     if (code == HTTP_SWITCH_PROT || code == HTTP_UPGRADE) {
+         buf_printf(logbuf, "%supgrade=", sep);
+-        comma_list_body(logbuf, upgrd_tokens, txn->flags.upgrade, NULL);
++        comma_list_body(logbuf, upgrd_tokens, txn->flags.upgrade, 0, noargs);
+         sep = "; ";
+     }
+     if (txn->flags.te) {
+         buf_printf(logbuf, "%stx-encoding=", sep);
+-        comma_list_body(logbuf, te, txn->flags.te, NULL);
++        comma_list_body(logbuf, te, txn->flags.te, 0, noargs);
+         sep = "; ";
+     }
+     if (txn->resp_body.enc.proc) {
+         buf_printf(logbuf, "%scnt-encoding=", sep);
+-        comma_list_body(logbuf, ce, txn->resp_body.enc.type, NULL);
++        comma_list_body(logbuf, ce, txn->resp_body.enc.type, 0, noargs);
+         sep = "; ";
+     }
+     if (txn->location) {
diff -pruN 3.0.13-5/debian/patches/0018-spelling-errors.patch 3.2.0-3/debian/patches/0018-spelling-errors.patch
--- 3.0.13-5/debian/patches/0018-spelling-errors.patch	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/0018-spelling-errors.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,170 +0,0 @@
-Description: spelling errors
-Author: Xavier Guimard <yadd@debian.org>
-Forwarded: <no|not-needed|url proving that it has been forwarded>
-Last-Update: 2019-12-16
-
---- a/doc/html/_sources/imap/download/release-notes/2.0/2.0.x.txt
-+++ b/doc/html/_sources/imap/download/release-notes/2.0/2.0.x.txt
-@@ -6,7 +6,7 @@
- 
- *   migrated to SASLv2 (Rob Siemborski)
- *   altnamespace: it is now possible to display user mailboxes as siblings to the INBOX at the top-level (Ken Murchison)
--*   unixhierarchysep: it is now possible possible to use slash as the hierarchy seperator, instead of a period. (Ken Murchison, inspired by David Fuchs, dfuchs@uniserve.com)
-+*   unixhierarchysep: it is now possible possible to use slash as the hierarchy separator, instead of a period. (Ken Murchison, inspired by David Fuchs, dfuchs@uniserve.com)
- *   SSL/TLS session caching (Ken Murchison)
- *   support for IMAP CHILDREN & LISTEXT extensions (Ken Murchison, work in progress)
- *   check recipient quota & ACL at time of RCPT TO: in lmtpd (Ken Murchison)
---- a/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt
-+++ b/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt
-@@ -211,8 +211,8 @@
-  
-  Note that in the above example, the \ ``unixhierarchysep``\  setting in
-  imapd.conf is set to \ ``0``\ . When using the UNIX
-- hierarchy seperator, the \ ``/``\  (forward slash) character would be
-- used as the hierarchy seperator, and the example would look as
-+ hierarchy separator, the \ ``/``\  (forward slash) character would be
-+ used as the hierarchy separator, and the example would look as
-  follows:
-  
- 
---- a/doc/html/imap/download/release-notes/2.0/2.0.x.html
-+++ b/doc/html/imap/download/release-notes/2.0/2.0.x.html
-@@ -772,7 +772,7 @@
- <ul class="simple">
- <li>migrated to SASLv2 (Rob Siemborski)</li>
- <li>altnamespace: it is now possible to display user mailboxes as siblings to the INBOX at the top-level (Ken Murchison)</li>
--<li>unixhierarchysep: it is now possible possible to use slash as the hierarchy seperator, instead of a period. (Ken Murchison, inspired by David Fuchs, <a class="reference external" href="mailto:dfuchs&#37;&#52;&#48;uniserve&#46;com">dfuchs<span>&#64;</span>uniserve<span>&#46;</span>com</a>)</li>
-+<li>unixhierarchysep: it is now possible possible to use slash as the hierarchy separator, instead of a period. (Ken Murchison, inspired by David Fuchs, <a class="reference external" href="mailto:dfuchs&#37;&#52;&#48;uniserve&#46;com">dfuchs<span>&#64;</span>uniserve<span>&#46;</span>com</a>)</li>
- <li>SSL/TLS session caching (Ken Murchison)</li>
- <li>support for IMAP CHILDREN &amp; LISTEXT extensions (Ken Murchison, work in progress)</li>
- <li>check recipient quota &amp; ACL at time of RCPT TO: in lmtpd (Ken Murchison)</li>
---- a/doc/html/imap/reference/manpages/systemcommands/cyradm.html
-+++ b/doc/html/imap/reference/manpages/systemcommands/cyradm.html
-@@ -878,8 +878,8 @@
- </div>
- <p>Note that in the above example, the <code class="docutils literal"><span class="pre">unixhierarchysep</span></code> setting in
- imapd.conf is set to <code class="docutils literal"><span class="pre">0</span></code>. When using the UNIX
--hierarchy seperator, the <code class="docutils literal"><span class="pre">/</span></code> (forward slash) character would be
--used as the hierarchy seperator, and the example would look as
-+hierarchy separator, the <code class="docutils literal"><span class="pre">/</span></code> (forward slash) character would be
-+used as the hierarchy separator, and the example would look as
- follows:</p>
- </div></blockquote>
- <p>Example Usage with <code class="docutils literal"><span class="pre">unixhierarchysep:</span> <span class="pre">1</span></code></p>
---- a/doc/legacy/changes.html
-+++ b/doc/legacy/changes.html
-@@ -1797,7 +1797,7 @@
- siblings to the INBOX at the top-level (Ken Murchison)</li>
- 
- <li>unixhierarchysep: it is now possible possible to use slash as
--the hierarchy seperator, instead of a period. (Ken Murchison,
-+the hierarchy separator, instead of a period. (Ken Murchison,
- inspired by David Fuchs, <tt>dfuchs@uniserve.com</tt>)</li>
- 
- <li>SSL/TLS session caching (Ken Murchison)</li>
---- a/doc/legacy/overview.html
-+++ b/doc/legacy/overview.html
-@@ -130,7 +130,7 @@
- allowed to subscribe to mailboxes.  Only users without dots in their
- userid are permitted to have an <TT>INBOX</TT>.  (A user with a dot in
- their userid would be able to login but would not be able to receive mail.
--Note that when using the unix hierarchy seperator, this is not the case, and
-+Note that when using the unix hierarchy separator, this is not the case, and
- any user may have a dot in their userid.)
- 
- <p>When an administrator deletes a user's <TT>INBOX</TT>, all of the
---- a/doc/text/imap/download/release-notes/2.0/2.0.x.txt
-+++ b/doc/text/imap/download/release-notes/2.0/2.0.x.txt
-@@ -10,7 +10,7 @@
-   siblings to the INBOX at the top-level (Ken Murchison)
- 
- * unixhierarchysep: it is now possible possible to use slash as the
--  hierarchy seperator, instead of a period. (Ken Murchison, inspired
-+  hierarchy separator, instead of a period. (Ken Murchison, inspired
-   by David Fuchs, dfuchs@uniserve.com)
- 
- * SSL/TLS session caching (Ken Murchison)
---- a/doc/text/imap/reference/manpages/systemcommands/cyradm.txt
-+++ b/doc/text/imap/reference/manpages/systemcommands/cyradm.txt
-@@ -149,9 +149,9 @@
-       john lrswipkxtecda
- 
-    Note that in the above example, the "unixhierarchysep" setting in
--   imapd.conf is set to "0". When using the UNIX hierarchy seperator,
-+   imapd.conf is set to "0". When using the UNIX hierarchy separator,
-    the "/" (forward slash) character would be used as the hierarchy
--   seperator, and the example would look as follows:
-+   separator, and the example would look as follows:
- 
- Example Usage with "unixhierarchysep: 1"
- 
---- a/docsrc/imap/download/release-notes/2.0/2.0.x.rst
-+++ b/docsrc/imap/download/release-notes/2.0/2.0.x.rst
-@@ -6,7 +6,7 @@
- 
- *   migrated to SASLv2 (Rob Siemborski)
- *   altnamespace: it is now possible to display user mailboxes as siblings to the INBOX at the top-level (Ken Murchison)
--*   unixhierarchysep: it is now possible possible to use slash as the hierarchy seperator, instead of a period. (Ken Murchison, inspired by David Fuchs, dfuchs@uniserve.com)
-+*   unixhierarchysep: it is now possible possible to use slash as the hierarchy separator, instead of a period. (Ken Murchison, inspired by David Fuchs, dfuchs@uniserve.com)
- *   SSL/TLS session caching (Ken Murchison)
- *   support for IMAP CHILDREN & LISTEXT extensions (Ken Murchison, work in progress)
- *   check recipient quota & ACL at time of RCPT TO: in lmtpd (Ken Murchison)
---- a/docsrc/imap/reference/manpages/systemcommands/cyradm.rst
-+++ b/docsrc/imap/reference/manpages/systemcommands/cyradm.rst
-@@ -211,8 +211,8 @@
-  
-  Note that in the above example, the \ ``unixhierarchysep``\  setting in
-  imapd.conf is set to \ ``0``\ . When using the UNIX
-- hierarchy seperator, the \ ``/``\  (forward slash) character would be
-- used as the hierarchy seperator, and the example would look as
-+ hierarchy separator, the \ ``/``\  (forward slash) character would be
-+ used as the hierarchy separator, and the example would look as
-  follows:
-  
- 
---- a/imap/spool.c
-+++ b/imap/spool.c
-@@ -202,7 +202,7 @@
-                 if (c == '\r' && peek == '\n') {
-                     c = prot_getc(fin);
-                 } else {
--                    c = peek; /* single newline seperator */
-+                    c = peek; /* single newline separator */
-                 }
-                 if (c != ' ' && c != '\t') {
-                     /* this is the end of the header */
---- a/perl/imap/IMAP/Shell.pm
-+++ b/perl/imap/IMAP/Shell.pm
-@@ -1857,8 +1857,8 @@
- 
- Note that in the above example, the C<unixhierarchysep> setting in
- imapd.conf is set to C<0>. When using the UNIX
--hierarchy seperator, the C</> (forward slash) character would be
--used as the hierarchy seperator, and the example would look as
-+hierarchy separator, the C</> (forward slash) character would be
-+used as the hierarchy separator, and the example would look as
- follows:
- 
- =item Example Usage with C<unixhierarchysep: 1>
---- a/perl/sieve/managesieve/managesieve.xs
-+++ b/perl/sieve/managesieve/managesieve.xs
-@@ -296,7 +296,7 @@
-            check if SASL mech list changed */
-         if (detect_mitm(obj, mechlist)) {
-             globalerr = "possible MITM attack: "
--                "list of available SASL mechamisms changed";
-+                "list of available SASL mechanisms changed";
-             free(ret);
-             free(mechlist);
-             XSRETURN_UNDEF;
---- a/sieve/test.c
-+++ b/sieve/test.c
-@@ -160,7 +160,7 @@
-                 if (c == '\r' && peek == '\n') {
-                     c = getc(f);
-                 } else {
--                    c = peek; /* single newline seperator */
-+                    c = peek; /* single newline separator */
-                 }
-                 if (c != ' ' && c != '\t') {
-                     /* this is the end of the header */
diff -pruN 3.0.13-5/debian/patches/0019-disable-some-tests.patch 3.2.0-3/debian/patches/0019-disable-some-tests.patch
--- 3.0.13-5/debian/patches/0019-disable-some-tests.patch	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/debian/patches/0019-disable-some-tests.patch	2020-05-12 08:04:39.000000000 +0000
@@ -0,0 +1,78 @@
+Description: disable some tests incompatible with non x86_64 arch
+Author: Xavier Guimard <yadd@debian.org>
+Bug-Debian: https://bugs.debian.org/960374
+Forwarded: https://github.com/cyrusimap/cyrus-imapd/issues/3040
+Last-Update: 2020-05-12
+
+--- a/cunit/libconfig.testc
++++ b/cunit/libconfig.testc
+@@ -510,11 +510,13 @@
+     CU_ASSERT_SYSLOG(/*all*/0, 1);
+ 
+     /* should not be able to read the deprecated name */
++    /*
+     CU_EXPECT_CYRFATAL_BEGIN
+     val = config_getint(IMAPOPT_AUTOCREATEQUOTA);
+     CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+         "Option 'autocreatequota' is deprecated in favor of "
+         "'autocreate_quota' since version 2.5.0.");
++    */
+ 
+     /* should be able to read the value at the new name */
+     val = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
+@@ -560,11 +562,13 @@
+     CU_ASSERT_SYSLOG(/*all*/0, 1);
+ 
+     /* should not be able to read the deprecated name */
++    /*
+     CU_EXPECT_CYRFATAL_BEGIN
+     val = config_getstring(IMAPOPT_TLSCACHE_DB_PATH);
+     CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+         "Option 'tlscache_db_path' is deprecated in favor of "
+         "'tls_sessions_db_path' since version 2.5.0.");
++    */
+ 
+     /* should be able to read the value at the new name */
+     val = config_getstring(IMAPOPT_TLS_SESSIONS_DB_PATH);
+@@ -616,11 +620,13 @@
+     CU_ASSERT_SYSLOG(/*all*/0, 1);
+ 
+     /* should not be able to read the deprecated name */
++    /*
+     CU_EXPECT_CYRFATAL_BEGIN
+     val = config_getstring(IMAPOPT_TLSCACHE_DB);
+     CU_EXPECT_CYRFATAL_END(EX_SOFTWARE,
+         "Option 'tlscache_db' is deprecated in favor of "
+         "'tls_sessions_db' since version 2.5.0.");
++    */
+ 
+     /* should be able to read it at the new name */
+     val = config_getstring(IMAPOPT_TLS_SESSIONS_DB);
+--- a/cunit/times.testc
++++ b/cunit/times.testc
+@@ -558,10 +558,12 @@
+     CU_ASSERT_EQUAL(t, 1230969900);
+ 
+     /* Year 9999 */
++    /*
+     t = UNINIT_TIMET;
+     r = time_from_rfc5322("Fri, 31-Dec-9999 23:59:59 +0000", &t, DATETIME_FULL);
+     CU_ASSERT_EQUAL(r, 31);
+     CU_ASSERT_EQUAL(t, 253402300799);
++    */
+ 
+     /* Year 1 - This will fail*/
+     t = UNINIT_TIMET;
+@@ -569,10 +571,12 @@
+     CU_ASSERT_EQUAL(r, -1);
+ 
+     /* 5 digit year */
++    /*
+     t = UNINIT_TIMET;
+     r = time_from_rfc5322("Sat, 1 Jan 10000 00:00:00", &t, DATETIME_FULL);
+     CU_ASSERT_EQUAL(r, 25);
+     CU_ASSERT_EQUAL(t, 253402300800);
++    */
+ 
+     /* Invalid date */
+     t = UNINIT_TIMET;
diff -pruN 3.0.13-5/debian/patches/series 3.2.0-3/debian/patches/series
--- 3.0.13-5/debian/patches/series	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/patches/series	2020-05-12 07:32:29.000000000 +0000
@@ -10,8 +10,7 @@
 0010-Fix-PATH_MAX-on-GNU-Hurd.patch
 0011-Fix-extra-libpci-in-SNMP_LIBS.patch
 0012-Use-UnicodeData.txt-from-system.patch
-0013-Re-add-perl2rst-tool-from-cyrus-imapd-3.0-upstream-b.patch
-0015-conversations-update-the-G-keys-even-if-the-message-has-no-threadid.patch
 0016-conversations-actually-need-to-update-GUID-counts-after-calculating-CID.patch
 0017-cert-update.patch
-0018-spelling-errors.patch
+0018-fix-va_list-for-arm.patch
+0019-disable-some-tests.patch
diff -pruN 3.0.13-5/debian/rules 3.2.0-3/debian/rules
--- 3.0.13-5/debian/rules	2020-03-15 10:22:28.000000000 +0000
+++ 3.2.0-3/debian/rules	2020-05-15 06:08:42.000000000 +0000
@@ -68,7 +68,6 @@ override_dh_auto_configure:
 	 --libexecdir=/usr/lib/cyrus/bin \
 	 --bindir=/usr/lib/cyrus/bin \
 	 --sbindir=/usr/lib/cyrus/bin \
-	 --with-cyrus-prefix=/usr/lib/cyrus \
 	 --disable-silent-rules \
 	 --enable-autocreate \
 	 --enable-idled \
@@ -82,6 +81,8 @@ override_dh_auto_configure:
 	 --enable-unit-tests \
 	 --enable-gssapi="/usr" \
 	 --with-cyrus-user=cyrus --with-cyrus-group=mail \
+	 --with-pgsql \
+	 --with-pgsql-incdir=/usr/include/postgresql \
 	 --with-lock=fcntl \
 	 --with-ldap \
 	 --with-krb \
@@ -140,6 +141,16 @@ override_dh_auto_build:
 	pod2html perl/imap/cyradm.sh > doc/man/cyradm.1.html
 	rm -f pod2htm*
 
+override_dh_auto_test:
+ifeq ($(DEB_HOST_ARCH),s390x)
+	# Skip test
+endif
+ifeq ($(DEB_HOST_ARCH),armhf)
+	# Skip test
+else
+	dh_auto_test
+endif
+
 override_dh_auto_install:
 	dh_auto_install # -- DESTDIR=$(TMPPKG)
 
@@ -194,7 +205,7 @@ override_dh_auto_install:
 
 	# Install the stuff needed for upgrades
 	install -d -m 755 $(TMPPKG)/usr/lib/cyrus/upgrade
-	for i in convert-sieve.pl dohash rehash undohash translatesieve upgradesieve masssievec; do \
+	for i in rehash translatesieve masssievec; do \
 	  install -m 755 tools/$$i $(TMPPKG)/usr/lib/cyrus/upgrade ;\
 	done
 
@@ -234,4 +245,6 @@ override_dh_installsystemd:
 	dh_installsystemd --name=cyrus-imapd
 
 override_dh_missing:
-	dh_missing --fail-missing -X.la
+	# Temporarily accept missing manpages
+	#dh_missing --fail-missing -X.la
+	dh_missing --list-missing -X.la
diff -pruN 3.0.13-5/debian/watch 3.2.0-3/debian/watch
--- 3.0.13-5/debian/watch	2020-03-15 09:08:48.000000000 +0000
+++ 3.2.0-3/debian/watch	2020-04-24 20:09:13.000000000 +0000
@@ -1,5 +1,5 @@
 version=4
 opts=\
-uversionmangle=s/-(beta)/~$1/,\
+uversionmangle=s/-((?:beta|rc)\d*)/~$1/,\
 pgpsigurlmangle=s/$/.sig/ \
-  https://www.cyrusimap.org/releases/cyrus-imapd-([^\s]+)\.tar\.gz
+  https://github.com/cyrusimap/cyrus-imapd/releases/ .*releases/download/.*/cyrus-imapd-(\d+(?:\.\d+)*(?:-\w+)?)\.tar\.gz
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/cmu-backend.conf 3.2.0-3/doc/examples/cyrus_conf/cmu-backend.conf
--- 3.0.13-5/doc/examples/cyrus_conf/cmu-backend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/cmu-backend.conf	2020-04-24 02:03:00.000000000 +0000
@@ -8,7 +8,7 @@ START {
   mupdatepush   cmd="ctl_mboxlist -m"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/sockets
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=5
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/cmu-frontend.conf 3.2.0-3/doc/examples/cyrus_conf/cmu-frontend.conf
--- 3.0.13-5/doc/examples/cyrus_conf/cmu-frontend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/cmu-frontend.conf	2020-04-24 02:03:00.000000000 +0000
@@ -4,7 +4,7 @@ START {
   mboxlist      cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/sockets
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # mupdate database service - must prefork atleast 1
   mupdate       cmd="/usr/cyrus/bin/mupdate" listen=2004 prefork=1
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/murder-backend.conf 3.2.0-3/doc/examples/cyrus_conf/murder-backend.conf
--- 3.0.13-5/doc/examples/cyrus_conf/murder-backend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/murder-backend.conf	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ START {
   mupdatepush   cmd="ctl_mboxlist -m"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/socket
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=0
@@ -29,10 +29,10 @@ SERVICES {
 
   # at least one LMTP is required for delivery
 #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
 
   # this is required if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/murder-frontend.conf 3.2.0-3/doc/examples/cyrus_conf/murder-frontend.conf
--- 3.0.13-5/doc/examples/cyrus_conf/murder-frontend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/murder-frontend.conf	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@ START {
   recover       cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/socket
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
 	# proxies that will connect to the backends, add or remove based on
   # site preferences (lmtp below)
@@ -32,7 +32,7 @@ SERVICES {
 	mupdate       cmd="mupdate" listen="mupdate" prefork=1
 
   # this is required if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/normal.conf 3.2.0-3/doc/examples/cyrus_conf/normal.conf
--- 3.0.13-5/doc/examples/cyrus_conf/normal.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/normal.conf	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@ START {
   recover       cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/socket
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=0
@@ -24,10 +24,13 @@ SERVICES {
 
   # at least one LMTP is required for delivery
 #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
+
+  # this is requied if using socketmap
+#  smmap         cmd="smmapd" listen="/run/cyrus/socket/smmap" prefork=0
 
   # this is required if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/normal-master.conf 3.2.0-3/doc/examples/cyrus_conf/normal-master.conf
--- 3.0.13-5/doc/examples/cyrus_conf/normal-master.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/normal-master.conf	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ START {
   offsitesync   cmd="sync_client -r -n offsite"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/socket
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=0
@@ -29,10 +29,13 @@ SERVICES {
 
   # at least one LMTP is required for delivery
 #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
+
+  # this is requied if using socketmap
+#  smmap         cmd="smmapd" listen="/run/cyrus/socket/smmap" prefork=0
 
   # this is required if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/normal-replica.conf 3.2.0-3/doc/examples/cyrus_conf/normal-replica.conf
--- 3.0.13-5/doc/examples/cyrus_conf/normal-replica.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/normal-replica.conf	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@ START {
   recover       cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/socket
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=0
@@ -24,7 +24,10 @@ SERVICES {
 
   # at least one LMTP is required for delivery
 #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
+
+  # this is requied if using socketmap
+#  smmap         cmd="smmapd" listen="/run/cyrus/socket/smmap" prefork=0
 
 	# Synchronization for remote replication.
   # Note: This usage is deprecated. Modern (post 3.0) Cyrus supports
@@ -32,7 +35,7 @@ SERVICES {
 #  syncserver    cmd="sync_server" listen="csync"
   
   # this is required if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/prefork.conf 3.2.0-3/doc/examples/cyrus_conf/prefork.conf
--- 3.0.13-5/doc/examples/cyrus_conf/prefork.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/prefork.conf	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,7 @@ START {
   recover       cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/sockets
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=5
@@ -24,10 +24,13 @@ SERVICES {
 
   # at least one LMTP is required for delivery
 #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=1
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=1
+
+  # this is requied if using socketmap
+#  smmap         cmd="smmapd" listen="/run/cyrus/socket/smmap" prefork=1
 
   # this is only necessary if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/cyrus_conf/small.conf 3.2.0-3/doc/examples/cyrus_conf/small.conf
--- 3.0.13-5/doc/examples/cyrus_conf/small.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/cyrus_conf/small.conf	2020-04-24 02:03:00.000000000 +0000
@@ -5,17 +5,17 @@ START {
   recover       cmd="ctl_cyrusdb -r"
 }
 
-# UNIX sockets start with a slash and are put into /var/imap/sockets
+# UNIX sockets start with a slash and are put into /run/cyrus/socket
 SERVICES {
   # add or remove based on preferences
   imap          cmd="imapd" listen="imap" prefork=0
   pop3          cmd="pop3d" listen="pop3" prefork=0
 
   # LMTP is required for delivery
-  lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+  lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
 
   # this is only necessary if using notifications
-#  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+#  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
 }
 
 EVENTS {
diff -pruN 3.0.13-5/doc/examples/imapd_conf/imapd.conf.sample 3.2.0-3/doc/examples/imapd_conf/imapd.conf.sample
--- 3.0.13-5/doc/examples/imapd_conf/imapd.conf.sample	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/imapd.conf.sample	2020-05-04 04:14:01.000000000 +0000
@@ -0,0 +1,3910 @@
+## auto-generated by config2sample 1.6rst
+#
+
+## cyrusman:: imapd.conf(5)
+
+## _imap-reference-manpages-configs-imapd.conf:
+
+#==========
+#imapd.conf
+#==========
+
+
+
+
+
+
+
+
+
+#IMAP configuration file
+#
+#DESCRIPTION
+#===========
+
+#    /etc/imapd.conf
+#    is the configuration file for the Cyrus IMAP server.  It defines
+#    local parameters for IMAP.
+##
+#    Each line of the /etc/imapd.conf file has the form
+#        option: value
+#    #
+#    where option is the name of the configuration option being set
+#    and value is the value that the configuration option is being
+#    set to.
+##
+#    Although there is no limit to the length of a line, a ``\''
+#    (backslash) character may be used as the last character on a line to
+#    force it to continue on the next one.  No additional whitespace is
+#    inserted before or after the ``\''.  Note that a line that is split
+#    using ``\'' character(s) is still considered a single line.
+
+#    For example
+#        option:\
+#         value1 value2 \
+#          value3
+#    #
+#    is equivalent to
+#        option: value1 value2   value3
+#    #
+#    Blank lines and lines beginning with ``#'' are ignored.
+##
+#    For boolean and enumerated options, the values ``yes'', ``on'', ``t'',
+#    ``true'' and ``1'' turn the option on, the values ``no'', ``off'',
+#    ``f'', ``false'' and ``0'' turn the option off.
+##
+#    Duration options take the form of a number followed by a unit, for example
+#    32m (32 minutes).  Units are d (days), h (hours), m
+#    (minutes) and s (seconds).  Multiple units can be combined and will
+#    be summed together, for example 1h30m is equivalent to 90m.  If
+#    no unit is specified, an option-specific backward-compatible default unit
+#    is assumed (documented on an option-by-option basis).  These are simple time
+#    units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+#    etc are not considered).
+#
+#FIELD DESCRIPTIONS
+#==================
+
+##
+#    The sections below detail options that can be placed in the
+#    /etc/imapd.conf file, and show each option's default value.
+#    Some options have no default value, these are listed with
+#    ``<no default>''.  Some options default to the empty string, these
+#    are listed with ``<none>''.
+
+
+#  Addressbookprefix
+#  -----------------
+#    The prefix for the addressbook mailboxes hierarchies.  The hierarchy
+#    delimiter will be automatically appended.  The public addressbook
+#    hierarchy will be at the toplevel of the shared namespace.  A
+#    user's personal addressbook hierarchy will be a child of their Inbox. 
+#addressbookprefix: #addressbooks
+
+#  Admins
+#  ------
+#    The list of userids with administrative rights.  Separate each userid
+#    with a space.  Sites using Kerberos authentication may use
+#    separate "admin" instances.
+#    #
+#    Note that accounts used by users should not be administrators.
+#    Administrative accounts should not receive mail.  That is, if user
+#    "jbRo" is a user reading mail, he should not also be in the admins line.
+#    Some problems may occur otherwise, most notably the ability of
+#    administrators to create top-level mailboxes visible to users,
+#    but not writable by users. 
+#admins: <empty string>
+
+#  Afspts_localrealms
+#  ------------------
+#    The list of realms which are to be treated as local, and thus stripped
+#    during identifier canonicalization (for the AFSPTS ptloader module).
+#    This is different from loginrealms in that it occurs later in the
+#    authorization process (as the user id is canonified for PTS lookup) 
+#afspts_localrealms: <none>
+
+#  Afspts_mycell
+#  -------------
+#    Cell to use for AFS PTS lookups.  Defaults to the local cell. 
+#afspts_mycell: <none>
+
+#  Allowallsubscribe
+#  -----------------
+#    Allow subscription to nonexistent mailboxes.  This option is
+#    typically used on backend servers in a Murder so that users can
+#    subscribe to mailboxes that don't reside on their "home" server.
+#    This option can also be used as a workaround for IMAP clients which
+#    don't play well with nonexistent or unselectable mailboxes (e.g.,
+#    Microsoft Outlook). 
+#allowallsubscribe: 0
+
+#  Allowanonymouslogin
+#  -------------------
+#    Permit logins by the user "anonymous" using any password.  Also
+#    allows use of the SASL ANONYMOUS mechanism. 
+#allowanonymouslogin: 0
+
+#  Allowapop
+#  ---------
+#    Allow use of the POP3 APOP authentication command.
+#    #
+#    Note that this command requires that SASL is compiled with APOP
+#    support, that the plaintext passwords are available in a SASL auxprop
+#    backend (e.g., sasldb), and that the system can provide enough entropy
+#    (e.g., from /dev/urandom) to create a challenge in the banner. 
+#allowapop: 1
+
+#  Allowdeleted
+#  ------------
+#    Allow access to deleted and expunged data via vendor.cmu-* access 
+#allowdeleted: 0
+
+#  Allownewnews
+#  ------------
+#    Allow use of the NNTP NEWNEWS command.
+#    #
+#    Note that this is a very expensive command and should only be
+#    enabled when absolutely necessary. 
+#allownewnews: 0
+
+#  Allowplaintext
+#  --------------
+#    If enabled, allows the use of cleartext passwords on the wire.
+#    #
+#    By default, the use of cleartext passwords requires a TLS/SSL
+#    encryption layer to be negotiated prior to any cleartext
+#    authentication mechanisms being advertised or allowed.  To require a
+#    TLS/SSL encryption layer to be negotiated prior to ANY
+#    authentication, see the tls_required option. 
+#allowplaintext: 0
+
+#  Allowsetacl
+#  -----------
+#    Defaults to enabled.  If disabled, disallows the use of the SETACL
+#    command at all via IMAP. 
+#allowsetacl: 1
+
+#  Allowusermoves
+#  --------------
+#    Allow moving user accounts (with associated meta-data) via RENAME
+#    or XFER.
+#    #
+#    Note that measures should be taken to make sure that the user being
+#    moved is not logged in, and cannot login during the move.  Failure
+#    to do so may result in the user's meta-data (seen state,
+#    subscriptions, etc) being corrupted or out of date. 
+#allowusermoves: 0
+
+#  Altnamespace
+#  ------------
+#    Use the alternate IMAP namespace, where personal folders reside at the
+#    same level in the hierarchy as INBOX.
+#    #
+#    This option ONLY applies where interaction takes place with the
+#    client/user.  Currently this is limited to the IMAP protocol (imapd)
+#    and Sieve scripts (lmtpd).  This option does NOT apply to admin tools
+#    such as cyradm (admins ONLY), reconstruct, quota, etc., NOR does it
+#    affect LMTP delivery of messages directly to mailboxes via
+#    plus-addressing.  The default changed in 3.0 from off to on. 
+#altnamespace: 1
+
+#  Altprefix
+#  ---------
+#    Alternative INBOX spellings that can't be accessed in altnamespace
+#    otherwise go under here 
+#altprefix: Alt Folders
+
+#  Annotation_db
+#  -------------
+#    The cyrusdb backend to use for mailbox annotations. 
+#    Allowed values: skiplist, twoskip, zeroskip
+#annotation_db: twoskip
+
+#  Annotation_db_path
+#  ------------------
+#    The absolute path to the annotations db file.  If not specified,
+#    will be configdirectory/annotations.db 
+#annotation_db_path: <none>
+
+#  Anyoneuseracl
+#  -------------
+#    Should non-admin users be allowed to set ACLs for the 'anyone'
+#    user on their mailboxes?  In a large organization this can cause
+#    support problems, but it's enabled by default. 
+#anyoneuseracl: 1
+
+#  Annotation_allow_undefined
+#  --------------------------
+#    Allow clients to store values for entries which are not
+#    defined either by Cyrus or in the annotations_definitions
+#    file. 
+#annotation_allow_undefined: 0
+
+#  Annotation_definitions
+#  ----------------------
+#    File containing external (third-party) annotation definitions.
+#    #
+#    Each line of the file specifies the properties of an annotation and
+#    has the following form:
+
+#        name, scope, attrib-type, proxy-type,
+#        attrib-names, acl
+#    name
+#        is the hierarchical name as in RFC 5257 or RFC 5464 (in the latter case,
+#        without the leading /shared or /private).  For example,
+#        /vendor/acme/blurdybloop.
+#    scope
+#        specifies whether the annotation is for the server, a
+#        mailbox, or a message.
+#    attrib-type
+#            specifies the attribute data type, which is used only to check the
+#            string value passed by clients when setting annotations.  The
+#            attrib-type is one of:
+#        string
+#            any value is accepted.
+#        content-type
+#            this obsolete data type, which was useful for early drafts of the standard,
+#            is accepted but silently translated to string.
+#        boolean
+#            only the strings "true" or "false" are accepted.  Checking is
+#            case-insensitive but the value is forced to lowercase.
+#        int
+#            integers are accepted.
+#        uint
+#            non-negative integers are accepted.
+#    proxy-type
+#        specifies whether this attribute is for the backend or
+#        proxy servers or both (proxy_and_backend)
+#    attrib-names
+#        is the space-separated list of available attributes for the
+#        annotation. Possible attribute names are value.shared,
+#        value.priv, and value (which permits both value.priv
+#        and value.shared).  The attribute names size,
+#        size.shared, and size.priv are accepted but ignored; these
+#        attributes are automatically provided by the server if the corresponding
+#        value attribute is specified.  Some obsolete attributes, which were
+#        defined early drafts of the standard, are accepted and ignored with a
+#        warning.
+#    extra-permissions
+#        is the extra ACL permission bits required for setting this annotation, in
+#        standard IMAP ACL permission bit string format.  Note that this is
+#        in addition to the permission bits specified in RFC 5257 and RFC 5464,
+#        so leaving this field empty is harmless.  Note also that there is no way
+#        to specify that an annotation can only be set by an admin user; in
+#        particular the a permission bit does not achieve this.
+#        #
+#        Blank lines and lines beginning with ``#'' are ignored.
+
+#annotation_definitions: <none>
+
+#  Annotation_callout
+#  ------------------
+#    The pathname of a callout to be used to automatically add annotations
+#    or flags to a message when it is appended to a mailbox.  The path can
+#    be either an executable (including a script), or a UNIX domain
+#    socket.  
+#annotation_callout: <none>
+
+#  Annotation_callout_disable_append
+#  ---------------------------------
+#    Disables annotations on append with xrunannotator 
+#annotation_callout_disable_append: 0
+
+#  Annotation_enable_legacy_commands
+#  ---------------------------------
+#    Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+#    These commands are deprecated and will be removed in the future,
+#    but might be useful in the meantime for supporting old clients that
+#    do not implement the RFC5464 IMAP METADATA extension. 
+#annotation_enable_legacy_commands: 0
+
+#  Aps_topic
+#  ---------
+#    Topic for Apple Push Service registration. 
+#aps_topic: <none>
+
+#  Aps_topic_caldav
+#  ----------------
+#    Topic for Apple Push Service registration for CalDAV. 
+#aps_topic_caldav: <none>
+
+#  Aps_topic_carddav
+#  -----------------
+#    Topic for Apple Push Service registration for CardDAV. 
+#aps_topic_carddav: <none>
+
+#  Archive_enabled
+#  ---------------
+#    Is archiving enabled for this server.  You also need to have an
+#    archivepartition for the mailbox.  Archiving allows older email
+#    to be stored on slower, cheaper disks - even within the same
+#    mailbox, as distinct from partitions. 
+#archive_enabled: 0
+
+#  Archive_days
+#  ------------
+#    Deprecated in favour of archive_after. 
+#archive_days: <none>
+
+#  Archive_after
+#  -------------
+#    The duration after which to move messages to the archive partition
+#    if archiving is enabled.
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed.  
+#archive_after: 7d
+
+#  Archive_maxsize
+#  ---------------
+#    The size in kilobytes of the largest message that won't be archived
+#    immediately.  Default is 1Mb 
+#archive_maxsize: 1024
+
+#  Archive_keepflagged
+#  -------------------
+#    If set, messages with the \Flagged system flag won't be archived,
+#    provided they are smaller than archive_maxsize. 
+#archive_keepflagged: 0
+
+#  Archivepartition-name
+#  ---------------------
+#    The pathname of the archive partition name, corresponding to
+#    spool partition partition-name.  For any mailbox residing in
+#    a directory on partition-name, the archived messages will be
+#    stored in a corresponding directory on archivepartition-name.
+#    Note that not every partition-name option is strictly required
+#    to have a corresponding archivepartition-name option, but that
+#    without one there's no benefit to enabling archiving. 
+#archivepartition-name: <none>
+
+#  Auditlog
+#  --------
+#    Should cyrus output log entries for every action taken on a message
+#    file or mailboxes list entry?  It's noisy so disabled by default, but
+#    can be very useful for tracking down what happened if things look strange 
+#auditlog: 0
+
+#  Auth_mech
+#  ---------
+#    The authorization mechanism to use. 
+#    Allowed values: unix, pts, krb, krb5
+#auth_mech: unix
+
+#  Autocreateinboxfolders
+#  ----------------------
+#    Deprecated in favor of autocreate_inbox_folders. 
+#autocreateinboxfolders: <none>
+
+#  Autocreatequota
+#  ---------------
+#    Deprecated in favor of autocreate_quota. 
+#autocreatequota: 0
+
+#  Autocreatequotamsg
+#  ------------------
+#    Deprecated in favor of autocreate_quota_messages. 
+#autocreatequotamsg: -1
+
+#  Autosievefolders
+#  ----------------
+#    Deprecated in favor of autocreate_sieve_folders. 
+#autosievefolders: <none>
+
+#  Generate_compiled_sieve_script
+#  ------------------------------
+#    Deprecated in favor of autocreate_sieve_script_compile. 
+#generate_compiled_sieve_script: 0
+
+#  Autocreate_sieve_compiled_script
+#  --------------------------------
+#    Deprecated in favor of autocreate_sieve_script_compiled. 
+#autocreate_sieve_compiled_script: <none>
+
+#  Autosubscribeinboxfolders
+#  -------------------------
+#    Deprecated in favor of autocreate_subscribe_folders. 
+#autosubscribeinboxfolders: <none>
+
+#  Autosubscribesharedfolders
+#  --------------------------
+#    Deprecated in favor of autocreate_subscribe_sharedfolders. 
+#autosubscribesharedfolders: <none>
+
+#  Autosubscribe_all_sharedfolders
+#  -------------------------------
+#    Deprecated in favor of autocreate_subscribe_sharedfolders_all. 
+#autosubscribe_all_sharedfolders: 0
+
+#  Autocreate_acl
+#  --------------
+#    If folders are to be created by autocreate_inbox_folders\R, this
+#    setting can be used to apply additional ACLs to the autocreated
+#    folders.  The syntax is "autocreate_acl folder identifier rights",
+#    where folder must match one of the autocreate_inbox_folders
+#    folders, identifier must be a valid cyrus identifier, and
+#    rights must be a valid cyrus rights string.  Multiple
+#    identifier|rights pairs can be assigned to a single folder by providing
+#    this setting multiple times.
+#    #
+#    For example, "autocreate_acl Plus anyone p" would allow lmtp delivery
+#    to a folder named "Plus".
+
+#autocreate_acl: <none>
+
+#  Autocreate_inbox_folders
+#  ------------------------
+#    If a user does not have an INBOX already, and the INBOX is to be
+#    created, create the list of folders in this setting as well.
+#    autocreate_inbox_folders is a list of INBOX's subfolders
+#    separated by a "|", that are automatically created by the server
+#    under the following two scenarios. Leading and trailing whitespace is
+#    stripped, so "Junk | Trash" results in two folders: "Junk" and
+#    "Trash".  See also the xlist-flag option, for setting
+#    special-use flags on autocreated folders.
+#    #
+#    INBOX folders are created under both the following conditions:
+#    1.
+#        The user logins via the IMAP or the POP3 protocol.
+#        autocreate_quota option must have a value of zero or greater.
+#    2.
+#        A message arrives for the user through the lmtpd(8).
+#        autocreate_post option must be enabled.
+#        #
+
+#autocreate_inbox_folders: <none>
+
+#  Autocreate_post
+#  ---------------
+#    If enabled, when lmtpd(8) receives an incoming mail for an
+#    INBOX that does not exist, then the INBOX is automatically created
+#    by lmtpd(8) and delivery of the message continues. 
+#autocreate_post: 0
+
+#  Autocreate_quota
+#  ----------------
+#    If set to a value of zero or higher, users have their INBOX folders
+#    created upon a successful login event or upon lmtpd(8)
+#    message delivery if autocreate_post is enabled, provided their
+#    INBOX did not yet already exist.
+#    #
+#    The user's quota is set to the value if it is greater than zero,
+#    otherwise the user has unlimited quota.
+#    #
+#    Note that quota is specified in kilobytes. 
+#autocreate_quota: -1
+
+#  Autocreate_quota_messages
+#  -------------------------
+#    If set to a value of zero or higher, users who have their INBOX
+#    folders created upon a successful login event (see
+#    autocreate_quota), or upon lmtpd(8) message delivery if
+#    autocreate_post is enabled, receive the message quota
+#    configured in this option.
+#    #
+#    The default of -1 disables assigning message quota.
+#    #
+#    For consistency with autocreate_quota, a value of zero is treated
+#    as unlimited message quota, rather than a message quota of zero. 
+#autocreate_quota_messages: -1
+
+#  Autocreate_sieve_folders
+#  ------------------------
+#    A "|" separated list of subfolders of INBOX that will be
+#    automatically created, if requested by a sieve filter, through the
+#    "fileinto" action. The default is to create no folders
+#    automatically.
+#    #
+#    Leading and trailing whitespace is stripped from each folder, so a
+#    setting of "Junk | Trash" will create two folders: "Junk" and
+#    "Trash". 
+#autocreate_sieve_folders: <none>
+
+#  Autocreate_sieve_script
+#  -----------------------
+#    The full path of a file that contains a sieve script. This script
+#    automatically becomes a user's initial default sieve filter script.
+#    #
+#    When this option is not defined, no default sieve filter is created.
+#    The file must be readable by the Cyrus daemon. 
+#autocreate_sieve_script: <none>
+
+#  Autocreate_sieve_script_compile
+#  -------------------------------
+#    If set to yes and no compiled sieve script file exists, the sieve script which is
+#    compiled on the fly will be saved in the file name that autocreate_sieve_compiledscript
+#    option points to. In order a compiled script to be generated, autocreate_sieve_script and
+#    autocreate_sieve_compiledscript must have valid values 
+#autocreate_sieve_script_compile: 0
+
+#  Autocreate_sieve_script_compiled
+#  --------------------------------
+#    The full path of a file that contains a compiled in bytecode sieve script. This script
+#    automatically becomes a user's initial default sieve filter script.  If this option is
+#    not specified, or the filename doesn't exist then the script defined by
+#    autocreate_sieve_script is compiled on the fly and installed as the user's default
+#    sieve script 
+#autocreate_sieve_script_compiled: <none>
+
+#  Autocreate_subscribe_folders
+#  ----------------------------
+#    A list of folder names, separated by "|", that the users get automatically subscribed to,
+#    when their INBOX is created. These folder names must have been included in the
+#    autocreateinboxfolders option of the imapd.conf. 
+#autocreate_subscribe_folders: <none>
+
+#  Autocreate_subscribe_sharedfolders
+#  ----------------------------------
+#    A list of shared folders (bulletin boards), separated by "|", that the users get
+#    automatically subscribed to, after their INBOX is created. The shared folder must
+#    have been created and the user must have the required permissions to get subscribed
+#    to it. Otherwise, subscribing to the shared folder fails. 
+#autocreate_subscribe_sharedfolders: <none>
+
+#  Autocreate_subscribe_sharedfolders_all
+#  --------------------------------------
+#    If set to yes, the user is automatically subscribed to all shared folders, one has permission
+#    to subscribe to. 
+#autocreate_subscribe_sharedfolders_all: 0
+
+#  Autocreate_users
+#  ----------------
+#    A space separated list of users and/or groups that are allowed their INBOX to be
+#    automatically created. 
+#autocreate_users: anyone
+
+#  Autoexpunge
+#  -----------
+#    If set to yes, then all \Deleted messages will be automatically expunged whenever
+#    an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect 
+#autoexpunge: 0
+
+#  Backuppartition-name
+#  --------------------
+#    The pathname of the backup partition name.  At least one backup
+#    partition pathname MUST be specified if backups are in use.  Note that
+#    there is no relationship between spool partitions and backup partitions. 
+#backuppartition-name: <none>
+
+#  Backup_compact_minsize
+#  ----------------------
+#    The minimum size in kilobytes of chunks in each backup.  The compact tool
+#    will try to combine adjacent chunks that are smaller than this.
+#    #
+#    Setting this value to zero or negative disables combining of chunks. 
+#backup_compact_minsize: 0
+
+#  Backup_compact_maxsize
+#  ----------------------
+#    The maximum size in kilobytes of chunks in each backup.  The compact tool
+#    will try to split chunks larger than this into smaller chunks.
+#    #
+#    Setting this value to zero or negative disables splitting of chunks. 
+#backup_compact_maxsize: 0
+
+#  Backup_compact_work_threshold
+#  -----------------------------
+#    The number of chunks that must obviously need compaction before the compact
+#    tool will go ahead with the compaction.  If set to less than one, the value
+#    is treated as being one. 
+#backup_compact_work_threshold: 1
+
+#  Backup_staging_path
+#  -------------------
+#    The absolute path of the backup staging area.  If not specified,
+#    will be temp_path/backup 
+#backup_staging_path: <none>
+
+#  Backup_retention_days
+#  ---------------------
+#    Deprecated in favor of backup_retention. 
+#backup_retention_days: <none>
+
+#  Backup_retention
+#  ----------------
+#    How long to keep content in backup after it has been deleted
+#    from the source.  If set to a negative value or zero, deleted content
+#    will be kept indefinitely.
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed.  
+#backup_retention: 7d
+
+#  Backup_db
+#  ---------
+#    The cyrusdb backend to use for the backup locations database. 
+#    Allowed values: skiplist, sql, twoskip, zeroskip
+#backup_db: twoskip
+
+#  Backup_db_path
+#  --------------
+#    The absolute path to the backup db file.  If not specified,
+#    will be configdirectory/backups.db 
+#backup_db_path: <none>
+
+#  Backup_keep_previous
+#  --------------------
+#    Whether the ctl_backups compact and ctl_backups reindex
+#    commands should preserve the original file.  The original file will
+#    be named with a timestamped suffix.  This is mostly useful for
+#    debugging.
+#    #
+#    Note that with this enabled, compacting a backup will actually
+#    increase the disk used by it (because there will now be an extra
+#    copy: the original version, and the compacted version). 
+#backup_keep_previous: 0
+
+#  Boundary_limit
+#  --------------
+#    messages are parsed recursively and a deep enough MIME structure
+#    can cause a stack overflow.  Do not parse deeper than this many
+#    layers of MIME structure.  The default of 1000 is much higher
+#    than any sane message should have. 
+#boundary_limit: 1000
+
+#  Caldav_allowattach
+#  ------------------
+#    Enable managed attachments support on the CalDAV server. 
+#caldav_allowattach: 1
+
+#  Caldav_allowcalendaradmin
+#  -------------------------
+#    Enable per-user calendar administration web UI on the CalDAV server. 
+#caldav_allowcalendaradmin: 0
+
+#  Caldav_allowscheduling
+#  ----------------------
+#    Enable calendar scheduling operations. If set to "apple", the
+#    server will emulate Apple CalendarServer behavior as closely as
+#    possible. 
+#    Allowed values: off, on, apple
+#caldav_allowscheduling: on
+
+#  Caldav_create_attach
+#  --------------------
+#    Create the 'Attachments' collection if it doesn't already exist 
+#caldav_create_attach: 1
+
+#  Caldav_create_default
+#  ---------------------
+#    Create the 'Default' calendar if it doesn't already exist 
+#caldav_create_default: 1
+
+#  Caldav_create_sched
+#  -------------------
+#    Create the 'Inbox' and 'Outbox' calendars if they don't already exist 
+#caldav_create_sched: 1
+
+#  Caldav_historical_age
+#  ---------------------
+#    How long after an occurrence of event or task has concluded
+#    that it is considered 'historical'.  Changes to historical
+#    occurrences of events or tasks WILL NOT have invite or reply
+#    messages sent for them.  A negative value means that events
+#    and tasks are NEVER considered historical.
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed.  
+#caldav_historical_age: 7d
+
+#  Caldav_maxdatetime
+#  ------------------
+#    The latest date and time accepted by the server (ISO format).  This
+#    value is also used for expanding non-terminating recurrence rules.
+#    #
+#    Note that increasing this value will require the DAV databases for
+#    calendars to be reconstructed with the dav_reconstruct
+#    utility in order to see its effect on serer-side time-based
+#    queries. 
+#caldav_maxdatetime: 20380119T031407Z
+
+#  Caldav_mindatetime
+#  ------------------
+#    The earliest date and time accepted by the server (ISO format). 
+#caldav_mindatetime: 19011213T204552Z
+
+#  Caldav_realm
+#  ------------
+#    The realm to present for HTTP authentication of CalDAV resources.
+#    If not set (the default), the value of the "servername" option will
+#    be used.
+#caldav_realm: <none>
+
+#  Calendarprefix
+#  --------------
+#    The prefix for the calendar mailboxes hierarchies.  The hierarchy
+#    delimiter will be automatically appended.  The public calendar
+#    hierarchy will be at the toplevel of the shared namespace.  A
+#    user's personal calendar hierarchy will be a child of their Inbox. 
+#calendarprefix: #calendars
+
+#  Calendar_user_address_set
+#  -------------------------
+#    Space-separated list of domains corresponding to calendar user
+#    addresses for which the server is responsible.  If not set (the
+#    default), the value of the "servername" option will be used. 
+#calendar_user_address_set: <none>
+
+#  Calendar_component_set
+#  ----------------------
+#    Space-separated list of iCalendar component types that calendar
+#    object resources may contain in a calendar collection.
+#    This restriction is only set at calendar creation time and only
+#    if the CalDAV client hasn't specified a restriction in the creation
+#    request. 
+#    Allowed values: VEVENT, VTODO, VJOURNAL, VFREEBUSY, VAVAILABILITY, VPOLL
+#calendar_component_set: VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL
+
+#  Carddav_allowaddmember
+#  ----------------------
+#    Enable support for POST add-member on the CardDAV server. 
+#carddav_allowaddmember: 0
+
+#  Carddav_allowaddressbookadmin
+#  -----------------------------
+#    Enable per-user addressbook administration web UI on the CardDAV server. 
+#carddav_allowaddressbookadmin: 0
+
+#  Carddav_realm
+#  -------------
+#    The realm to present for HTTP authentication of CardDAV resources.
+#    If not set (the default), the value of the "servername" option will
+#    be used.
+#carddav_realm: <none>
+
+#  Carddav_repair_vcard
+#  --------------------
+#    If enabled, VCARDs with invalid content are attempted to be repaired
+#    during creation. 
+#carddav_repair_vcard: 0
+
+#  Chatty
+#  ------
+#    If yes, syslog tags and commands for every IMAP command, mailboxes
+#    for every lmtp connection, every POP3 command, etc 
+#chatty: 0
+
+#  Client_bind
+#  -----------
+#    If enabled, a specific IP will be bound when performing a client
+#    connection.  client_bind_name is used if it is set, otherwise
+#    servername is used.  This is useful on multi-homed servers where
+#    Cyrus should not use other services' interfaces.
+#    #
+#    If not enabled (the default), no bind will be performed.  Client
+#    connections will use an IP chosen by the operating system. 
+#client_bind: 0
+
+#  Client_bind_name
+#  ----------------
+#    IPv4, IPv6 address or hostname to bind for client connections when
+#    client_bind is enabled.  If not set (the default),
+#    servername will be used. 
+#client_bind_name: <none>
+
+#  Client_timeout
+#  --------------
+#    Time to wait before returning a timeout failure when performing a
+#    client connection (e.g. in a murder environment).
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed.  
+#client_timeout: 10s
+
+#  Commandmintimer
+#  ---------------
+#    Time in seconds. Any imap command that takes longer than this
+#    time is logged. 
+#commandmintimer: <none>
+
+#  Configdirectory
+#  ---------------
+#    The pathname of the IMAP configuration directory.  This field is
+#    required. 
+#configdirectory: <none>
+
+#  Createonpost
+#  ------------
+#    Deprecated in favor of autocreate_post. 
+#createonpost: 0
+
+#  Conversations
+#  -------------
+#    Enable the XCONVERSATIONS extensions.  Extract conversation
+#    tracking information from incoming messages and track them
+#    in per-user databases. 
+#conversations: 0
+
+#  Conversations_counted_flags
+#  ---------------------------
+#    space-separated list of flags for which per-conversation counts
+#    will be kept.  Note that you need to reconstruct the conversations
+#    database with ctl_conversationsdb if you change this option on a
+#    running server, or the counts will be wrong.  
+#conversations_counted_flags: <none>
+
+#  Conversations_db
+#  ----------------
+#    The cyrusdb backend to use for the per-user conversations database. 
+#    Allowed values: skiplist, sql, twoskip, zeroskip
+#conversations_db: skiplist
+
+#  Conversations_expire_days
+#  -------------------------
+#    Deprecated in favor of conversations_expire_after. 
+#conversations_expire_days: <none>
+
+#  Conversations_expire_after
+#  --------------------------
+#    How long the conversations database keeps the message tracking
+#    information needed for receiving new messages in existing
+#    conversations.
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed. 
+#conversations_expire_after: 90d
+
+#  Conversations_max_thread
+#  ------------------------
+#    maximum size for a single thread.  Threads will split if they have this many
+#    * messages in them and another message arrives 
+#conversations_max_thread: 100
+
+#  Crossdomains
+#  ------------
+#    Enable cross domain sharing.  This works best with alt namespace and
+#    unix hierarchy separators on, so you get Other Users/foo@example.com/... 
+#crossdomains: 0
+
+#  Crossdomains_onlyother
+#  ----------------------
+#    only show the domain for users in other domains than your own (for
+#    backwards compatibility if you're already sharing 
+#crossdomains_onlyother: 0
+
+#  Cyrus_group
+#  -----------
+#    The name of the group Cyrus services will run as.  If not configured, the
+#    primary group of cyrus_user will be used. Can be further overridden by
+#    setting the $CYRUS_GROUP environment variable. 
+#cyrus_group: <none>
+
+#  Cyrus_user
+#  ----------
+#    The username to use as the 'cyrus' user.  If not configured, the compile
+#    time default will be used. Can be further overridden by setting the
+#    $CYRUS_USER environment variable. 
+#cyrus_user: <none>
+
+#  Davdriveprefix
+#  --------------
+#    The prefix for the DAV storage mailboxes hierarchies.  The hierarchy
+#    delimiter will be automatically appended.  The public storage
+#    hierarchy will be at the toplevel of the shared namespace.  A
+#    user's personal storage hierarchy will be a child of their Inbox. 
+#davdriveprefix: #drive
+
+#  Davnotificationsprefix
+#  ----------------------
+#    The prefix for the DAV notifications hierarchy.  The hierarchy
+#    delimiter will be automatically appended.  The public notifications
+#    hierarchy will be at the toplevel of the shared namespace.  A
+#    user's personal notifications hierarchy will be a child of their Inbox. 
+#davnotificationsprefix: #notifications
+
+#  Dav_realm
+#  ---------
+#    The realm to present for HTTP authentication of generic DAV
+#    resources (principals).  If not set (the default), the value of the
+#    "servername" option will be used.
+#dav_realm: <none>
+
+#  Dav_lock_timeout
+#  ----------------
+#    The maximum time to wait for a write lock on the per-user DAV database
+#    before timeout. For HTTP requests, the HTTP status code 503 is returned
+#    if the lock can not be obtained within this time.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#dav_lock_timeout: 20s
+
+#  Debug_command
+#  -------------
+#    Debug command to be used by processes started with -D option.  The string
+#    is a C format string that gets 3 options: the first is the name of the
+#    executable (as specified in the cmd parameter in cyrus.conf). The second
+#    is the pid (integer) and the third is the service ID.
+#    Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d 
+#debug_command: <none>
+
+#  Defaultacl
+#  ----------
+#    The Access Control List (ACL) placed on a newly-created (non-user)
+#    mailbox that does not have a parent mailbox. 
+#defaultacl: anyone lrs
+
+#  Defaultdomain
+#  -------------
+#    The default domain for virtual domain support 
+#defaultdomain: internal
+
+#  Defaultpartition
+#  ----------------
+#    The partition name used by default for new mailboxes.  If not
+#    specified, the partition with the most free space will be used for
+#    new mailboxes.
+#    #
+#    Note that the partition specified by this option must also be
+#    specified as partition-name, where you substitute 'name'
+#    for the alphanumeric string you set defaultpartition to. 
+#defaultpartition: <none>
+
+#  Defaultsearchtier
+#  -----------------
+#    Name of the default tier that messages will be indexed to. Search
+#    indexes can be organized in tiers to allow index storage in different
+#    directories and physical media. See the man page of squatter for
+#    details. The default search tier also requires the definition
+#    of an according searchtierpartition-name entry.
+#    #
+#    This option MUST be specified for xapian search. 
+#defaultsearchtier: <empty string>
+
+#  Defaultserver
+#  -------------
+#    The backend server name used by default for new mailboxes.  If not
+#    specified, the server with the most free space will be used for new
+#    mailboxes. 
+#defaultserver: <none>
+
+#  Deletedprefix
+#  -------------
+#    With delete_mode set to delayed, the
+#    deletedprefix setting defines the prefix for the hierarchy of
+#    deleted mailboxes.
+#    #
+#    The hierarchy delimiter will be automatically appended.
+
+#deletedprefix: DELETED
+
+#  Delete_mode
+#  -----------
+#    The manner in which mailboxes are deleted. In the default
+#    delayed mode, mailboxes that are being deleted are renamed to
+#    a special mailbox hierarchy under the deletedprefix, to be
+#    removed later by cyr_expire(8).
+#    #
+#    In immediate mode, the mailbox is removed from the filesystem
+#    immediately.
+
+#    Allowed values: immediate, delayed
+#delete_mode: delayed
+
+#  Delete_unsubscribe
+#  ------------------
+#    Whether to also unsubscribe from mailboxes when they are deleted.
+#    Note that this behaviour contravenes RFC 3501 section 6.3.9, but
+#    may be useful for avoiding user/client software confusion.
+#    The default is 'no'. 
+#delete_unsubscribe: 0
+
+#  Deleteright
+#  -----------
+#    Deprecated - only used for backwards compatibility with existing
+#    installations.  Lists the old RFC 2086 right which was used to
+#    grant the user the ability to delete a mailbox.  If a user has this
+#    right, they will automatically be given the new 'x' right. 
+#deleteright: c
+
+#  Disable_user_namespace
+#  ----------------------
+#    Preclude list command on user namespace.  If set to 'yes', the
+#    LIST response will never include any other user's mailbox.  Admin
+#    users will always see all mailboxes.  The default is 'no' 
+#disable_user_namespace: 0
+
+#  Disable_shared_namespace
+#  ------------------------
+#    Preclude list command on shared namespace.  If set to 'yes', the
+#    LIST response will never include any non-user mailboxes.  Admin
+#    users will always see all mailboxes.  The default is 'no' 
+#disable_shared_namespace: 0
+
+#  Disconnect_on_vanished_mailbox
+#  ------------------------------
+#    If enabled, IMAP/POP3/NNTP clients will be disconnected by the
+#    server if the currently selected mailbox is (re)moved by another
+#    session.  Otherwise, the missing mailbox is treated as empty while
+#    in use by the client.
+#disconnect_on_vanished_mailbox: 0
+
+#  Ischedule_dkim_domain
+#  ---------------------
+#    The domain to be reported as doing iSchedule DKIM signing. 
+#ischedule_dkim_domain: <none>
+
+#  Ischedule_dkim_key_file
+#  -----------------------
+#    File containing the private key for iSchedule DKIM signing. 
+#ischedule_dkim_key_file: <none>
+
+#  Ischedule_dkim_required
+#  -----------------------
+#    A DKIM signature is required on received iSchedule requests. 
+#ischedule_dkim_required: 1
+
+#  Ischedule_dkim_selector
+#  -----------------------
+#    Name of the selector subdividing the domain namespace.  This
+#    specifies the actual key used for iSchedule DKIM signing within the
+#    domain. 
+#ischedule_dkim_selector: <none>
+
+#  Duplicate_db
+#  ------------
+#    The cyrusdb backend to use for the duplicate delivery suppression
+#    and sieve. 
+#    Allowed values: skiplist, sql, twoskip, zeroskip
+#duplicate_db: twoskip
+
+#  Duplicate_db_path
+#  -----------------
+#    The absolute path to the duplicate db file.  If not specified,
+#    will be configdirectory/deliver.db 
+#duplicate_db_path: <none>
+
+#  Duplicatesuppression
+#  --------------------
+#    If enabled, lmtpd will suppress delivery of a message to a mailbox if
+#    a message with the same message-id (or resent-message-id) is recorded
+#    as having already been delivered to the mailbox.  Records the mailbox
+#    and message-id/resent-message-id of all successful deliveries. 
+#duplicatesuppression: 1
+
+#  Event_content_inclusion_mode
+#  ----------------------------
+#    The mode in which message content may be included with MessageAppend and
+#    MessageNew. "standard" mode is the default behavior in which message is
+#    included up to a size with the notification. In "message" mode, the message
+#    is included and may be truncated to a size. In "header" mode, it includes
+#    headers truncated to a size. In "body" mode, it includes body truncated
+#    to a size. In "headerbody" mode, it includes full headers and body truncated
+#    to a size 
+#    Allowed values: standard, message, header, body, headerbody
+#event_content_inclusion_mode: standard
+
+#  Event_content_size
+#  ------------------
+#    Truncate the message content that may be included with MessageAppend and
+#    MessageNew. Set 0 to include the entire message itself 
+#event_content_size: 0
+
+#  Event_exclude_flags
+#  -------------------
+#    Don't send event notification for given IMAP flag(s) 
+#event_exclude_flags: <none>
+
+#  Event_exclude_specialuse
+#  ------------------------
+#    Don't send event notification for folder with given special-use attributes.
+#    Set ALL for any folder 
+#event_exclude_specialuse: \\Junk
+
+#  Event_extra_params
+#  ------------------
+#    Space-separated list of extra parameters to add to any appropriated event. 
+#    Allowed values: bodyStructure, clientAddress, diskUsed, flagNames, messageContent, messageSize, messages, modseq, service, timestamp, uidnext, vnd.cmu.midset, vnd.cmu.unseenMessages, vnd.cmu.envelope, vnd.cmu.sessionId, vnd.cmu.mailboxACL, vnd.cmu.mbtype, vnd.cmu.davFilename, vnd.cmu.davUid, vnd.fastmail.clientId, vnd.fastmail.sessionId, vnd.fastmail.convExists, vnd.fastmail.convUnseen, vnd.fastmail.cid, vnd.fastmail.counters, vnd.cmu.emailid, vnd.cmu.threadid
+#event_extra_params: timestamp
+
+#  Event_groups
+#  ------------
+#    Space-separated list of groups of related events to turn on notification 
+#    Allowed values: message, quota, flags, access, mailbox, subscription, calendar, applepushservice
+#event_groups: message mailbox
+
+#  Event_notifier
+#  --------------
+#    Notifyd(8) method to use for "EVENT" notifications which are based on
+#    the RFC 5423.  If not set, "EVENT" notifications are disabled. 
+#event_notifier: <none>
+
+#  Expunge_mode
+#  ------------
+#    The mode in which messages (and their corresponding cache entries)
+#    are expunged.  "semidelayed" mode is the old behavior in which the
+#    message files are purged at the time of the EXPUNGE, but index
+#    and cache records are retained to facilitate QRESYNC.
+#    In "delayed" mode, which is the default since Cyrus 2.5.0,
+#    the message files are also retained, allowing unexpunge to
+#    rescue them.  In "immediate" mode, both the message files and the
+#    index records are removed as soon as possible.  In all cases,
+#    nothing will be finally purged until all other processes have
+#    closed the mailbox to ensure they never see data disappear under
+#    them.  In "semidelayed" or "delayed" mode, a later run of "cyr_expire"
+#    will clean out the retained records (and possibly message files).
+#    This reduces the amount of I/O that takes place at the time of
+#    EXPUNGE and should result in greater responsiveness for the client,
+#    especially when expunging a large number of messages. 
+#    Allowed values: immediate, semidelayed, delayed
+#expunge_mode: delayed
+
+#  Failedloginpause
+#  ----------------
+#    Time to pause after a failed login.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#failedloginpause: 3s
+
+#  Flushseenstate
+#  --------------
+#    Deprecated. No longer used 
+#flushseenstate: 1
+
+#  Foolstupidclients
+#  -----------------
+#    If enabled, only list the personal namespace when a LIST "*" is performed
+#    (it changes the request to a LIST "INBOX*"). 
+#foolstupidclients: 0
+
+#  Force_sasl_client_mech
+#  ----------------------
+#    Force preference of a given SASL mechanism for client side operations
+#    (e.g., murder environments).  This is separate from (and overridden by)
+#    the ability to use the <host shortname>_mechs option to set preferred
+#    mechanisms for a specific host 
+#force_sasl_client_mech: <none>
+
+#  Fulldirhash
+#  -----------
+#    If enabled, uses an improved directory hashing scheme which hashes
+#    on the entire username instead of using just the first letter as
+#    the hash.  This changes hash algorithm used for quota and user
+#    directories and if hashimapspool is enabled, the entire mail
+#    spool.
+#    #
+#    Note that this option CANNOT be changed on a live system.  The
+#    server must be quiesced and then the directories moved with the
+#    rehash utility. 
+#fulldirhash: 0
+
+#  Hashimapspool
+#  -------------
+#    If enabled, the partitions will also be hashed, in addition to the
+#    hashing done on configuration directories.  This is recommended if
+#    one partition has a very bushy mailbox tree. 
+#hashimapspool: 0
+
+#  Debug
+#  -----
+#    If enabled, allow syslog() to pass LOG_DEBUG messages. 
+#debug: 0
+
+#  Hostname_mechs
+#  --------------
+#    Force a particular list of SASL mechanisms to be used when authenticating
+#    to the backend server hostname (where hostname is the short hostname of
+#    the server in question). If it is not specified it will query the server
+#    for available mechanisms and pick one to use. - Cyrus Murder 
+#hostname_mechs: <none>
+
+#  Hostname_password
+#  -----------------
+#    The password to use for authentication to the backend server hostname
+#    (where hostname is the short hostname of the server) - Cyrus Murder 
+#hostname_password: <none>
+
+#  Httpallowcompress
+#  -----------------
+#    If enabled, the server will compress response payloads if the client
+#    indicates that it can accept them.  Note that the compressed data
+#    will appear in telemetry logs, leaving only the response headers as
+#    human-readable.
+#httpallowcompress: 1
+
+#  Httpallowcors
+#  -------------
+#    A wildmat pattern specifying a list of origin URIs ( scheme "://"
+#    host [ ":" port ] ) that are allowed to make Cross-Origin Resource
+#    Sharing (CORS) requests on the server.  By default, CORS requests
+#    are disabled.
+#    #
+#    Note that the scheme and host should both be lowercase, the port
+#    should be omitted if using the default for the scheme (80 for http,
+#    443 for https), and there should be no trailing '/' (e.g.:
+#    "http://www.example.com:8080", "https://example.org"). 
+#httpallowcors: <none>
+
+#  Httpallowtrace
+#  --------------
+#    Allow use of the TRACE method.
+#    #
+#    Note that sensitive data might be disclosed by the response. 
+#httpallowtrace: 0
+
+#  Httpallowedurls
+#  ---------------
+#    Space-separated list of relative URLs (paths) rooted at
+#    "httpdocroot" (see below) to be served by httpd.  If set, this
+#    option will limit served static content to only those paths specified
+#    (returning "404 Not Found" to any other client requested URLs).
+#    Otherwise, httpd will serve any content found in "httpdocroot".
+#    #
+#    Note that any path specified by "rss_feedlist_template" is an
+#    exception to this rule.
+#httpallowedurls: <none>
+
+#  Httpcontentmd5
+#  --------------
+#    If enabled, HTTP responses will include a Content-MD5 header for
+#    the purpose of providing an end-to-end message integrity check
+#    (MIC) of the payload body.  Note that enabling this option will
+#    use additional CPU to generate the MD5 digest, which may be ignored
+#    by clients anyways. 
+#httpcontentmd5: 0
+
+#  Httpdocroot
+#  -----------
+#    If set, http will serve the static content (html/text/jpeg/gif
+#    files, etc) rooted at this directory.  Otherwise, httpd will not
+#    serve any static content. 
+#httpdocroot: <none>
+
+#  Httpkeepalive
+#  -------------
+#    Set the length of the HTTP server's keepalive heartbeat.  The
+#    default is 20 seconds.  The minimum value is 0, which will disable
+#    the keepalive heartbeat.  When enabled, if a request takes longer
+#    than httpkeepalive to process, the server will send the client
+#    provisional responses every httpkeepalive until the final
+#    response can be sent.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#httpkeepalive: 20s
+
+#  Httpmodules
+#  -----------
+#    Space-separated list of HTTP modules that will be enabled in
+#    httpd(8).  This option has no effect on modules that are disabled
+#    at compile time due to missing dependencies (e.g. libical).
+#    #
+#    Note that "domainkey" depends on "ischedule" being enabled, and
+#    that both "freebusy" and "ischedule" depend on "caldav" being
+#    enabled. 
+#    Allowed values: admin, caldav, carddav, cgi, domainkey, freebusy, ischedule, jmap, prometheus, rss, tzdist, webdav
+#httpmodules: <empty string>
+
+#  Httpprettytelemetry
+#  -------------------
+#    If enabled, HTTP response payloads including server-generated
+#    markup languages (HTML, XML) will utilize line breaks and
+#    indentation to promote better human-readability in telemetry logs.
+#    Note that enabling this option will increase the amount of data
+#    sent across the wire. 
+#httpprettytelemetry: 0
+
+#  Httptimeout
+#  -----------
+#    Set the length of the HTTP server's inactivity autologout timer.
+#    The default is 5 minutes.  The minimum value is 0, which will
+#    disable persistent connections.
+#    #
+#    For backwards compatibility, if no unit is specified, minutes
+#    is assumed. 
+#httptimeout: 5m
+
+#  Idlesocket
+#  ----------
+#    Unix domain socket that idled listens on. 
+#idlesocket: {configdirectory}/socket/idle
+
+#  Ignorereference
+#  ---------------
+#    For backwards compatibility with Cyrus 1.5.10 and earlier -- ignore
+#    the reference argument in LIST or LSUB commands. 
+#ignorereference: 0
+
+#  Imapidlepoll
+#  ------------
+#    The interval for polling for mailbox changes and ALERTs while running
+#    the IDLE command.  This option is used when idled is not enabled or
+#    cannot be contacted.  The minimum value is 1 second.  A value of 0
+#    will disable IDLE.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#imapidlepoll: 60s
+
+#  Imapidresponse
+#  --------------
+#    If enabled, the server responds to an ID command with a parameter
+#    list containing: version, vendor, support-url, os, os-version,
+#    command, arguments, environment.  Otherwise the server returns NIL. 
+#imapidresponse: 1
+
+#  Imapmagicplus
+#  -------------
+#    Only list a restricted set of mailboxes via IMAP by using
+#    userid+namespace syntax as the authentication/authorization id.
+#    Using userid+ (with an empty namespace) will list only subscribed
+#    mailboxes. 
+#imapmagicplus: 0
+
+#  Imipnotifier
+#  ------------
+#    Notifyd(8) method to use for "IMIP" notifications which are based on
+#    the RFC 6047.  If not set, "IMIP" notifications are disabled. 
+#imipnotifier: <none>
+
+#  Implicit_owner_rights
+#  ---------------------
+#    The implicit Access Control List (ACL) for the owner of a mailbox. 
+#implicit_owner_rights: lkxan
+
+#  @include
+#  --------
+#    Directive which includes the specified file as part of the
+#    configuration.  If the path to the file is not absolute, CYRUS_PATH
+#    is prepended. 
+#@include: <none>
+
+#  Improved_mboxlist_sort
+#  ----------------------
+#    If enabled, a special comparator will be used which will correctly
+#    sort mailbox names that contain characters such as ' ' and '-'.
+#    #
+#    Note that this option SHOULD NOT be changed on a live system.  The
+#    mailboxes database should be dumped (ctl_mboxlist) before the
+#    option is changed, removed, and then undumped after changing the
+#    option.  When not using flat files for the subscriptions databases
+#    the same has to be done (cyr_dbtool) for each subscription database
+#    See improved_mboxlist_sort.html.
+#improved_mboxlist_sort: 0
+
+#  Jmap_emailsearch_db_path
+#  ------------------------
+#    The absolute path to the JMAP email search cache file.  If not
+#    specified, JMAP Email/query and Email/queryChanges will not
+#    cache email search results. 
+#jmap_emailsearch_db_path: <none>
+
+#  Jmap_preview_annot
+#  ------------------
+#    The name of the per-message annotation, if any, to store message
+#    previews. 
+#jmap_preview_annot: <none>
+
+#  Jmap_imagesize_annot
+#  --------------------
+#    The name of the per-message annotation, if any, that stores a
+#    JSON object, mapping message part numbers of MIME image types
+#    to an array of their image dimensions. The array must have at
+#    least two entries, where the first entry denotes the width
+#    and the second entry the height of the image. Any additional
+#    values are ignored.
+
+#    For example, if message part 1.2 contains an image of width 300
+#    and height 200, then the value of this annotation would be:
+
+#    { "1.2" : [ 300, 200 ] }
+
+#jmap_imagesize_annot: <none>
+
+#  Jmap_inlinedcids_annot
+#  ----------------------
+#    The name of the per-message annotation, if any, that stores a
+#    JSON object, mapping RFC2392 Content-IDs referenced in HTML bodies
+#    to the respective HTML body part number.
+
+#    For example, if message part 1.2 contains HTML and references an
+#    inlined image at "cid:foo", then the value of this annotation
+#    would be:
+
+#    { "<foo>" : "1.2" }
+
+#    Note that the Content-ID key must be URL-unescaped and enclosed in
+#    angular brackets, as defined in RFC2392. 
+#jmap_inlinedcids_annot: <none>
+
+#  Jmap_preview_length
+#  -------------------
+#    The maximum byte length of dynamically generated message previews. Previews
+#    stored in jmap_preview_annot take precedence. 
+#jmap_preview_length: 64
+
+#  Jmap_max_size_upload
+#  --------------------
+#    The maximum size (in kilobytes) that the JMAP API accepts
+#    for blob uploads. Returned as the maxSizeUpload property
+#    value of the JMAP \"urn:ietf:params:jmap:core\" capabilities object.
+#    Default is 1Gb. 
+#jmap_max_size_upload: 1048576
+
+#  Jmap_max_concurrent_upload
+#  --------------------------
+#    The value to return for the maxConcurrentUpload property of
+#    the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+#    implementation does not enforce this rate-limit. 
+#jmap_max_concurrent_upload: 5
+
+#  Jmap_max_size_request
+#  ---------------------
+#    The maximum size (in kilobytes) that the JMAP API accepts
+#    for requests at the API endpoint. Returned as the
+#    maxSizeRequest property value of the JMAP \"urn:ietf:params:jmap:core\"
+#    capabilities object. Default is 10Mb. 
+#jmap_max_size_request: 10240
+
+#  Jmap_max_concurrent_requests
+#  ----------------------------
+#    The value to return for the maxConcurrentRequests property of
+#    the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+#    implementation does not enforce this rate-limit. 
+#jmap_max_concurrent_requests: 5
+
+#  Jmap_max_calls_in_request
+#  -------------------------
+#    The maximum number of calls per JMAP request object.
+#    Returned as the maxCallsInRequest property value of the
+#    JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+#jmap_max_calls_in_request: 50
+
+#  Jmap_max_delayed_send
+#  ---------------------
+#    The value to return for the maxDelayedSend property of
+#    the JMAP \"urn:ietf:params:jmap:emailsubmission\" capabilities object.
+#    The Cyrus JMAP implementation does not enforce this limit.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#jmap_max_delayed_send: 512d
+
+#  Jmap_max_objects_in_get
+#  -----------------------
+#    The maximum number of ids that a JMAP client may request in
+#    a single \"/get\" type method call. The actual number
+#    of returned objects in the response may exceed this number
+#    if the JMAP object type supports unbounded \"/get\" calls.
+#    Returned as the maxObjectsInGet property value of the
+#    JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+#jmap_max_objects_in_get: 4096
+
+#  Jmap_max_objects_in_set
+#  -----------------------
+#    The maximum number of objects a JMAP client may send to create,
+#    update or destroy in a single /set type method call.
+#    Returned as the maxObjectsInSet property value of the
+#    JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+#jmap_max_objects_in_set: 4096
+
+#  Jmap_mail_max_size_attachments_per_email
+#  ----------------------------------------
+#    The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+#    property of the JMAP \"urn:ietf:params:jmap:mail\" capabilities object. The Cyrus
+#    JMAP implementation does not enforce this size limit. Default is 10 Mb.
+#jmap_mail_max_size_attachments_per_email: 10240
+
+#  Jmap_nonstandard_extensions
+#  ---------------------------
+#    If enabled, support non-standard JMAP extensions.  If not enabled,
+#    only IETF standard JMAP functionality is supported. 
+#jmap_nonstandard_extensions: 0
+
+#  Jmap_set_has_attachment
+#  -----------------------
+#    If enabled, the $hasAttachment flag is determined and set for new messages
+#    created with the JMAP Email/set or Email/import methods. This option should
+#    typically be enabled, but installations using Cyrus-external message
+#    annatotors to determine the $hasAttachment flag might want to disable it. 
+#jmap_set_has_attachment: 1
+
+#  Jmap_vacation
+#  -------------
+#    If enabled, support the JMAP vacation extension 
+#jmap_vacation: 1
+
+#  Jmapuploadfolder
+#  ----------------
+#    the name of the folder for JMAP uploads (#jmap) 
+#jmapuploadfolder: #jmap
+
+#  Jmapsubmission_deleteonsend
+#  ---------------------------
+#    If enabled (the default) then delete the EmailSubmission as soon as the email
+#    * has been sent 
+#jmapsubmission_deleteonsend: 1
+
+#  Jmapsubmissionfolder
+#  --------------------
+#    the name of the folder for JMAP Submissions (#jmapsubmission) 
+#jmapsubmissionfolder: #jmapsubmission
+
+#  Jmappushsubscriptionfolder
+#  --------------------------
+#    the name of the folder for JMAP Push Subscriptions (#jmappushsubscription) 
+#jmappushsubscriptionfolder: #jmappushsubscription
+
+#  Iolog
+#  -----
+#    Should cyrus output I/O log entries 
+#iolog: 0
+
+#  Ldap_authz
+#  ----------
+#    SASL authorization ID for the LDAP server 
+#ldap_authz: <none>
+
+#  Ldap_base
+#  ---------
+#    Contains the LDAP base dn for the LDAP ptloader module 
+#ldap_base: <empty string>
+
+#  Ldap_bind_dn
+#  ------------
+#    Bind DN for the connection to the LDAP server (simple bind).
+#    Do not use for anonymous simple binds 
+#ldap_bind_dn: <none>
+
+#  Ldap_deref
+#  ----------
+#    Specify how aliases dereferencing is handled during search. 
+#    Allowed values: search, find, always, never
+#ldap_deref: never
+
+#  Ldap_domain_base_dn
+#  -------------------
+#    Base DN to search for domain name spaces. 
+#ldap_domain_base_dn: <empty string>
+
+#  Ldap_domain_filter
+#  ------------------
+#    Filter to use searching for domains 
+#ldap_domain_filter: (&(objectclass=domainrelatedobject)(associateddomain=%s))
+
+#  Ldap_domain_name_attribute
+#  --------------------------
+#    The attribute name for domains. 
+#ldap_domain_name_attribute: associateddomain
+
+#  Ldap_domain_scope
+#  -----------------
+#    Search scope 
+#    Allowed values: sub, one, base
+#ldap_domain_scope: sub
+
+#  Ldap_domain_result_attribute
+#  ----------------------------
+#    Result attribute 
+#ldap_domain_result_attribute: inetdomainbasedn
+
+#  Ldap_filter
+#  -----------
+#    Specify a filter that searches user identifiers.  The following tokens can be
+#    used in the filter string:
+
+#    %%   = %
+#    %u   = user
+#    %U   = user portion of %u (%U = test when %u = test@domain.tld)
+#    %d   = domain portion of %u if available (%d = domain.tld when %u =
+#    test@domain.tld), otherwise same as %R
+#    %R   = domain portion of %u starting with @ (%R = @domain.tld
+#    when %u = test@domain.tld)
+#    %D   = user dn.  (use when ldap_member_method: filter)
+#    %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
+
+#    ldap_filter is not used when ldap_sasl is enabled. 
+#ldap_filter: (uid=%u)
+
+#  Ldap_group_base
+#  ---------------
+#    LDAP base dn for ldap_group_filter. 
+#ldap_group_base: <empty string>
+
+#  Ldap_group_filter
+#  -----------------
+#    Specify a filter that searches for group identifiers.
+#    See ldap_filter for more options. 
+#ldap_group_filter: (cn=%u)
+
+#  Ldap_group_scope
+#  ----------------
+#    Specify search scope for ldap_group_filter. 
+#    Allowed values: sub, one, base
+#ldap_group_scope: sub
+
+#  Ldap_id
+#  -------
+#    SASL authentication ID for the LDAP server 
+#ldap_id: <none>
+
+#  Ldap_mech
+#  ---------
+#    SASL mechanism for LDAP authentication 
+#ldap_mech: <none>
+
+#  Ldap_user_attribute
+#  -------------------
+#    Specify LDAP attribute to use as canonical user id 
+#ldap_user_attribute: <none>
+
+#  Ldap_member_attribute
+#  ---------------------
+#    See ldap_member_method. 
+#ldap_member_attribute: <none>
+
+#  Ldap_member_base
+#  ----------------
+#    LDAP base dn for ldap_member_filter. 
+#ldap_member_base: <empty string>
+
+#  Ldap_member_filter
+#  ------------------
+#    Specify a filter for "ldap_member_method: filter".
+#    See ldap_filter for more options. 
+#ldap_member_filter: (member=%D)
+
+#  Ldap_member_method
+#  ------------------
+#    Specify a group method.  The "attribute" method retrieves groups from
+#    a multi-valued attribute specified in ldap_member_attribute.
+
+#    The "filter" method uses a filter, specified by ldap_member_filter, to find
+#    groups; ldap_member_attribute is a single-value attribute group name. 
+#    Allowed values: attribute, filter
+#ldap_member_method: attribute
+
+#  Ldap_member_scope
+#  -----------------
+#    Specify search scope for ldap_member_filter. 
+#    Allowed values: sub, one, base
+#ldap_member_scope: sub
+
+#  Ldap_password
+#  -------------
+#    Password for the connection to the LDAP server (SASL and simple bind).
+#    Do not use for anonymous simple binds 
+#ldap_password: <none>
+
+#  Ldap_realm
+#  ----------
+#    SASL realm for LDAP authentication 
+#ldap_realm: <none>
+
+#  Ldap_referrals
+#  --------------
+#    Specify whether or not the client should follow referrals. 
+#ldap_referrals: 0
+
+#  Ldap_restart
+#  ------------
+#    Specify whether or not LDAP I/O operations are automatically restarted
+#    if they abort prematurely. 
+#ldap_restart: 1
+
+#  Ldap_sasl
+#  ---------
+#    Use SASL for LDAP binds in the LDAP PTS module. 
+#ldap_sasl: 1
+
+#  Ldap_sasl_authc
+#  ---------------
+#    Deprecated.  Use ldap_id 
+#ldap_sasl_authc: <none>
+
+#  Ldap_sasl_authz
+#  ---------------
+#    Deprecated.  Use ldap_authz 
+#ldap_sasl_authz: <none>
+
+#  Ldap_sasl_mech
+#  --------------
+#    Deprecated.  Use ldap_mech 
+#ldap_sasl_mech: <none>
+
+#  Ldap_sasl_password
+#  ------------------
+#    Deprecated.  User ldap_password 
+#ldap_sasl_password: <none>
+
+#  Ldap_sasl_realm
+#  ---------------
+#    Deprecated.  Use ldap_realm 
+#ldap_sasl_realm: <none>
+
+#  Ldap_scope
+#  ----------
+#    Specify search scope. 
+#    Allowed values: sub, one, base
+#ldap_scope: sub
+
+#  Ldap_servers
+#  ------------
+#    Deprecated.  Use ldap_uri 
+#ldap_servers: ldap://localhost/
+
+#  Ldap_size_limit
+#  ---------------
+#    Specify a number of entries for a search request to return. 
+#ldap_size_limit: 1
+
+#  Ldap_start_tls
+#  --------------
+#    Use transport layer security for ldap:// using STARTTLS. Do not use
+#    ldaps:// in 'ldap_uri' with this option enabled. 
+#ldap_start_tls: 0
+
+#  Ldap_time_limit
+#  ---------------
+#    How long to wait for a search request to complete.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#ldap_time_limit: 5s
+
+#  Ldap_timeout
+#  ------------
+#    How long a search can take before timing out.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#ldap_timeout: 5s
+
+#  Ldap_ca_dir
+#  -----------
+#    Path to a directory with CA (Certificate Authority) certificates. 
+#ldap_ca_dir: <none>
+
+#  Ldap_ca_file
+#  ------------
+#    Patch to a file containing CA (Certificate Authority) certificate(s). 
+#ldap_ca_file: <none>
+
+#  Ldap_ciphers
+#  ------------
+#    List of SSL/TLS ciphers to allow.  The format of the string is
+#    described in ciphers(1). 
+#ldap_ciphers: <none>
+
+#  Ldap_client_cert
+#  ----------------
+#    File containing the client certificate. 
+#ldap_client_cert: <none>
+
+#  Ldap_client_key
+#  ---------------
+#    File containing the private client key. 
+#ldap_client_key: <none>
+
+#  Ldap_verify_peer
+#  ----------------
+#    Require and verify server certificate.  If this option is yes,
+#    you must specify ldap_ca_file or ldap_ca_dir. 
+#ldap_verify_peer: 0
+
+#  Ldap_tls_cacert_dir
+#  -------------------
+#    Deprecated in favor of ldap_ca_dir. 
+#ldap_tls_cacert_dir: <none>
+
+#  Ldap_tls_cacert_file
+#  --------------------
+#    Deprecated in favor of ldap_ca_file. 
+#ldap_tls_cacert_file: <none>
+
+#  Ldap_tls_cert
+#  -------------
+#    Deprecated in favor of ldap_client_cert. 
+#ldap_tls_cert: <none>
+
+#  Ldap_tls_key
+#  ------------
+#    Deprecated in favor of ldap_client_key. 
+#ldap_tls_key: <none>
+
+#  Ldap_tls_check_peer
+#  -------------------
+#    Deprecated in favor of ldap_verify_peer. 
+#ldap_tls_check_peer: 0
+
+#  Ldap_tls_ciphers
+#  ----------------
+#    Deprecated in favor of ldap_ciphers. 
+#ldap_tls_ciphers: <none>
+
+#  Ldap_uri
+#  --------
+#    Contains a list of the URLs of all the LDAP servers when using the
+#    LDAP PTS module. 
+#ldap_uri: <none>
+
+#  Ldap_version
+#  ------------
+#    Specify the LDAP protocol version.  If ldap_start_tls and/or
+#    ldap_use_sasl are enabled, ldap_version will be automatically
+#    set to 3. 
+#ldap_version: 3
+
+#  Literalminus
+#  ------------
+#    if enabled, CAPABILITIES will reply with LITERAL- rather than
+#    LITERAL+ (RFC 7888).  Doesn't actually size-restrict uploads though 
+#literalminus: 0
+
+#  Lmtp_downcase_rcpt
+#  ------------------
+#    If enabled, lmtpd will convert the recipient addresses to lowercase
+#    (up to a '+' character, if present). 
+#lmtp_downcase_rcpt: 1
+
+#  Lmtp_exclude_specialuse
+#  -----------------------
+#    Don't allow delivery to folders with given special-use attributes.
+#    #
+#    Note that "snoozing" of emails can currently only be done via the
+#    JMAP protocol, so delivery directly to the \Snoozed mailbox is
+#    prohibited by default as it will not be moved back into INBOX
+#    automatically. 
+#lmtp_exclude_specialuse: \\Snoozed
+
+#  Lmtp_fuzzy_mailbox_match
+#  ------------------------
+#    If enabled, and the mailbox specified in the detail part of the
+#    recipient (everything after the '+') does not exist, lmtpd will try
+#    to find the closest match (ignoring case, ignoring whitespace,
+#    falling back to parent) to the specified mailbox name. 
+#lmtp_fuzzy_mailbox_match: 0
+
+#  Lmtp_over_quota_perm_failure
+#  ----------------------------
+#    If enabled, lmtpd returns a permanent failure code when a user's
+#    mailbox is over quota.  By default, the failure is temporary,
+#    causing the MTA to queue the message and retry later. 
+#lmtp_over_quota_perm_failure: 0
+
+#  Lmtp_strict_quota
+#  -----------------
+#    If enabled, lmtpd returns a failure code when the incoming message
+#    will cause the user's mailbox to exceed its quota.  By default, the
+#    failure won't occur until the mailbox is already over quota. 
+#lmtp_strict_quota: 0
+
+#  Lmtp_strict_rfc2821
+#  -------------------
+#    By default, lmtpd will be strict (per RFC 2821) with regards to which
+#    envelope addresses are allowed.  If this option is set to false, 8bit
+#    characters in the local-part of envelope addresses are changed to 'X'
+#    instead.  This is useful to avoid generating backscatter with
+#    certain MTAs like Postfix or Exim which accept such messages. 
+#lmtp_strict_rfc2821: 1
+
+#  Lmtpsocket
+#  ----------
+#    Unix domain socket that lmtpd listens on, used by deliver(8). This should
+#    match the path specified in cyrus.conf(5). 
+#lmtpsocket: {configdirectory}/socket/lmtp
+
+#  Lmtptxn_timeout
+#  ---------------
+#    Timeout used during a lmtp transaction to a remote backend (e.g. in a
+#    murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+#    when a backend server becomes unresponsive during a lmtp transaction.
+#    The default is 5 minutes - change to zero for infinite.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#lmtptxn_timeout: 5m
+
+#  Lock_debugtime
+#  --------------
+#    A floating point number of seconds.  If set, time how long we wait for
+#    any lock, and syslog the filename and time if it's longer than this
+#    value.  The default of NULL means not to time locks. 
+#lock_debugtime: <none>
+
+#  Loginrealms
+#  -----------
+#    The list of remote realms whose users may authenticate using cross-realm
+#    authentication identifiers.  Separate each realm name by a space.  (A
+#    cross-realm identity is considered any identity returned by SASL
+#    with an "@" in it.). 
+#loginrealms: <empty string>
+
+#  Loginuseacl
+#  -----------
+#    If enabled, any authentication identity which has a rights on a
+#    user's INBOX may log in as that user. 
+#loginuseacl: 0
+
+#  Logtimestamps
+#  -------------
+#    Include notations in the protocol telemetry logs indicating the number of
+#    seconds since the last command or response. 
+#logtimestamps: 0
+
+#  Mailbox_default_options
+#  -----------------------
+#    Default "options" field for the mailbox on create.  You'll want to know
+#    what you're doing before setting this, but it can apply some default
+#    annotations like duplicate suppression 
+#mailbox_default_options: 0
+
+#  Mailbox_initial_flags
+#  ---------------------
+#    space-separated list of permanent flags which will be pre-set in every
+#    newly created mailbox.  If you know you will require particular
+#    flag names then this avoids a possible race condition against a client
+#    that fills the entire 128 available slots.  Default is NULL, which is
+#    no flags.  Example: $Label1 $Label2 $Label3 NotSpam Spam 
+#mailbox_initial_flags: <none>
+
+#  Mailnotifier
+#  ------------
+#    Notifyd(8) method to use for "MAIL" notifications.  If not set, "MAIL"
+#    notifications are disabled. 
+#mailnotifier: <none>
+
+#  Master_bind_errors_fatal
+#  ------------------------
+#    If enabled, failure to bind a port during startup is treated as a fatal
+#    error, causing master to shut down immediately.  The default is to keep
+#    running, with the affected service disabled until the next SIGHUP causes
+#    it to retry.
+#    #
+#    Note that this only applies during startup.  New services that fail to
+#    come up in response to a reconfig+SIGHUP will just be logged and disabled
+#    like the default behaviour, without causing master to exit. 
+#master_bind_errors_fatal: 0
+
+#  Maxheaderlines
+#  --------------
+#    Maximum number of lines of header that will be processed into cache
+#    records.  Default 1000.  If set to zero, it is unlimited.
+#    If a message hits the limit, an error will be logged and the rest of
+#    the lines in the header will be skipped.  This is to avoid malformed
+#    messages causing giant cache records 
+#maxheaderlines: 1000
+
+#  Maxlogins_per_host
+#  ------------------
+#    Maximum number of logged in sessions allowed per host,
+#    zero means no limit 
+#maxlogins_per_host: 0
+
+#  Maxlogins_per_user
+#  ------------------
+#    Maximum number of logged in sessions allowed per user,
+#    zero means no limit 
+#maxlogins_per_user: 0
+
+#  Maxmessagesize
+#  --------------
+#    Maximum incoming LMTP message size.  If non-zero, lmtpd will reject
+#    messages larger than maxmessagesize bytes.  If set to 0, this
+#    will allow messages of any size (the default). 
+#maxmessagesize: 0
+
+#  Maxquoted
+#  ---------
+#    Maximum size of a single quoted string for the parser.  Default 128k 
+#maxquoted: 131072
+
+#  Maxword
+#  -------
+#    Maximum size of a single word for the parser.  Default 128k 
+#maxword: 131072
+
+#  Mboxkey_db
+#  ----------
+#    The cyrusdb backend to use for mailbox keys. 
+#    Allowed values: skiplist, twoskip, zeroskip
+#mboxkey_db: twoskip
+
+#  Mboxlist_db
+#  -----------
+#    The cyrusdb backend to use for the mailbox list. 
+#    Allowed values: flat, skiplist, sql, twoskip, zeroskip
+#mboxlist_db: twoskip
+
+#  Mboxlist_db_path
+#  ----------------
+#    The absolute path to the mailboxes db file.  If not specified
+#    will be configdirectory/mailboxes.db 
+#mboxlist_db_path: <none>
+
+#  Mboxname_lockpath
+#  -----------------
+#    Path to mailbox name lock files (default $conf/lock) 
+#mboxname_lockpath: <none>
+
+#  Metapartition_files
+#  -------------------
+#    Space-separated list of metadata files to be stored on a
+#    metapartition rather than in the mailbox directory on a spool
+#    partition. 
+#    Allowed values: header, index, cache, expunge, squat, annotations, lock, dav, archivecache
+#metapartition_files: <empty string>
+
+#  Metapartition-name
+#  ------------------
+#    The pathname of the metadata partition name, corresponding to
+#    spool partition partition-name.  For any mailbox residing in
+#    a directory on partition-name, the metadata files listed in
+#    metapartition_files will be stored in a corresponding directory on
+#    metapartition-name.   Note that not every
+#    partition-name option is required to have a corresponding
+#    metapartition-name option, so that you can selectively choose
+#    which spool partitions will have separate metadata partitions. 
+#metapartition-name: <none>
+
+#  Mupdate_authname
+#  ----------------
+#    The SASL username (Authentication Name) to use when authenticating to the
+#    mupdate server (if needed). 
+#mupdate_authname: <none>
+
+#  Mupdate_config
+#  --------------
+#    The configuration of the mupdate servers in the Cyrus Murder.
+#    The "standard" config is one in which there are discreet frontend
+#    (proxy) and backend servers.  The "unified" config is one in which
+#    a server can be both a frontend and backend.  The "replicated"
+#    config is one in which multiple backend servers all share the same
+#    mailspool, but each have their own "replicated" copy of
+#    mailboxes.db. 
+#    Allowed values: standard, unified, replicated
+#mupdate_config: standard
+
+#  Munge8bit
+#  ---------
+#    If enabled, lmtpd munges messages with 8-bit characters in the
+#    headers.  The 8-bit characters are changed to `X'.  If
+#    reject8bit is enabled, setting munge8bit has no effect.
+#    (A proper solution to non-ASCII characters in headers is offered by
+#    RFC 2047 and its predecessors.) 
+#munge8bit: 1
+
+#  Mupdate_connections_max
+#  -----------------------
+#    The max number of connections that a mupdate process will allow, this
+#    is related to the number of file descriptors in the mupdate process.
+#    Beyond this number connections will be immediately issued a BYE response. 
+#mupdate_connections_max: 128
+
+#  Mupdate_password
+#  ----------------
+#    The SASL password (if needed) to use when authenticating to the
+#    mupdate server. 
+#mupdate_password: <none>
+
+#  Mupdate_port
+#  ------------
+#    The port of the mupdate server for the Cyrus Murder 
+#mupdate_port: 3905
+
+#  Mupdate_realm
+#  -------------
+#    The SASL realm (if needed) to use when authenticating to the mupdate
+#    server. 
+#mupdate_realm: <none>
+
+#  Mupdate_retry_delay
+#  -------------------
+#    The base time to wait between connection retries to the mupdate server. 
+#mupdate_retry_delay: 20
+
+#  Mupdate_server
+#  --------------
+#    The mupdate server for the Cyrus Murder 
+#mupdate_server: <none>
+
+#  Mupdate_username
+#  ----------------
+#    The SASL username (Authorization Name) to use when authenticating to
+#    the mupdate server 
+#mupdate_username: <empty string>
+
+#  Mupdate_workers_max
+#  -------------------
+#    The maximum number of mupdate worker threads (overall) 
+#mupdate_workers_max: 50
+
+#  Mupdate_workers_maxspare
+#  ------------------------
+#    The maximum number of idle mupdate worker threads 
+#mupdate_workers_maxspare: 10
+
+#  Mupdate_workers_minspare
+#  ------------------------
+#    The minimum number of idle mupdate worker threads 
+#mupdate_workers_minspare: 2
+
+#  Mupdate_workers_start
+#  ---------------------
+#    The number of mupdate worker threads to start 
+#mupdate_workers_start: 5
+
+#  Netscapeurl
+#  -----------
+#    If enabled at compile time, this specifies a URL to reply when
+#    Netscape asks the server where the mail administration HTTP server
+#    is.  Administrators should set this to a local resource. 
+#netscapeurl: <none>
+
+#  Newsaddheaders
+#  --------------
+#    Space-separated list of headers to be added to incoming usenet
+#    articles.  Added To: headers will contain email
+#    delivery addresses corresponding to each newsgroup in the
+#    Newsgroups: header.  Added Reply-To: headers will
+#    contain email delivery addresses corresponding to each newsgroup in
+#    the Followup-To: or Newsgroups: header.  If the
+#    specified header(s) already exist in an article, the email
+#    delivery addresses will be appended to the original header body(s).
+#    This option applies if and only if the newspostuser option is
+#    set. 
+#    Allowed values: to, replyto
+#newsaddheaders: to
+
+#  Newsgroups
+#  ----------
+#    A wildmat pattern specifying which mailbox hierarchies should be
+#    treated as newsgroups.  Only mailboxes matching the wildmat will
+#    accept and/or serve articles via NNTP.  If not set, a default
+#    wildmat of "*" (ALL shared mailboxes) will be used.  If the
+#    newsprefix option is also set, the default wildmat will be
+#    translated to "<newsprefix>.*" 
+#newsgroups: *
+
+#  Newsmaster
+#  ----------
+#    Userid that is used for checking access controls when executing
+#    Usenet control messages.  For instance, to allow articles to be
+#    automatically deleted by cancel messages, give the "news" user
+#    the 'd' right on the desired mailboxes.  To allow newsgroups to be
+#    automatically created, deleted and renamed by the corresponding
+#    control messages, give the "news" user the 'c' right on the desired
+#    mailbox hierarchies. 
+#newsmaster: news
+
+#  Newspeer
+#  --------
+#    A list of whitespace-separated news server specifications to which
+#    articles should be fed.  Each server specification is a string of
+#    the form [user[:pass]@]host[:port][/wildmat] where 'host' is the fully
+#    qualified hostname of the server, 'port' is the port on which the
+#    server is listening, 'user' and 'pass' are the authentication
+#    credentials and 'wildmat' is a pattern that specifies which groups
+#    should be fed.  If no 'port' is specified, port 119 is used.  If
+#    no 'wildmat' is specified, all groups are fed.  If 'user' is specified
+#    (even if empty), then the NNTP POST command will be used to feed
+#    the article to the server, otherwise the IHAVE command will be
+#    used.
+#    A '@' may be used in place of '!' in the wildmat to prevent feeding
+#    articles cross-posted to the given group, otherwise cross-posted
+#    articles are fed if any part of the wildmat matches.  For example,
+#    the string "peer.example.com:*,!control.*,@local.*" would feed all
+#    groups except control messages and local groups to
+#    peer.example.com.  In the case of cross-posting to local groups,
+#    these articles would not be fed. 
+#newspeer: <none>
+
+#  Newspostuser
+#  ------------
+#    Userid used to deliver usenet articles to newsgroup folders
+#    (usually via lmtp2nntp).  For example, if set to "post", email sent
+#    to "post+comp.mail.imap" would be delivered to the "comp.mail.imap"
+#    folder.
+#    When set, the Cyrus NNTP server will add the header(s) specified in
+#    the newsaddheaders option to each incoming usenet article.
+#    The added header(s) will contain email delivery addresses
+#    corresponding to each relevant newsgroup.  If not set, no headers
+#    are added to usenet articles. 
+#newspostuser: <none>
+
+#  Newsprefix
+#  ----------
+#    Prefix to be prepended to newsgroup names to make the corresponding
+#    IMAP mailbox names. 
+#newsprefix: <none>
+
+#  Newsrc_db_path
+#  --------------
+#    The absolute path to the newsrc db file.  If not specified,
+#    will be configdirectory/fetchnews.db 
+#newsrc_db_path: <none>
+
+#  Nntptimeout
+#  -----------
+#    Set the length of the NNTP server's inactivity autologout timer.
+#    The minimum value is 3 minutes, also the default.
+#    #
+#    For backward compatibility, if no unit is specified, minutes is
+#    assumed. 
+#nntptimeout: 3m
+
+#  Notesmailbox
+#  ------------
+#    The top level mailbox in each user's account which is used to store
+#    * Apple-style Notes.  Default is blank (disabled) 
+#notesmailbox: <none>
+
+#  Notifysocket
+#  ------------
+#    Unix domain socket that the mail notification daemon listens on. 
+#notifysocket: {configdirectory}/socket/notify
+
+#  Notify_external
+#  ---------------
+#    Path to the external program that notifyd(8) will call to send mail
+#    notifications.
+#    #
+#    The external program will be called with the following
+#    command line options:
+
+#        .. option:: -c    class
+#        .. option:: -p    priority
+#        .. option:: -u    user
+#        .. option:: -m    mailbox
+#        #
+#        And the notification message will be available on stdin.
+
+#notify_external: <none>
+
+#  Partition-name
+#  --------------
+#    The pathname of the partition name.  At least one partition
+#    pathname MUST be specified.  If the defaultpartition option is
+#    used, then its pathname MUST be specified.  For example, if the
+#    value of the defaultpartion option is part1, then the
+#    partition-part1 field is required. 
+#partition-name: <none>
+
+#  Partition_select_mode
+#  ---------------------
+#    Partition selection mode.
+#    #
+#    random
+#        (pseudo-)random selection
+#    freespace-most
+#        partition with the most free space (KiB)
+#    freespace-percent-most
+#        partition with the most free space (%)
+#    freespace-percent-weighted
+#        each partition is weighted according to its free space (%); the more free space
+#        the partition has, the more chances it has to be selected
+#    freespace-percent-weighted-delta
+#        each partition is weighted according to its difference of free space (%)
+#        compared to the most used partition; the more the partition is lagging behind
+#        the most used partition, the more chances it has to be selected
+#        #
+#        Note that actually even the most used partition has a few chances to be
+#        selected, and those chances increase when other partitions get closer
+
+#        Allowed values: random, freespace-most, freespace-percent-most, freespace-percent-weighted, freespace-percent-weighted-delta
+#partition_select_mode: freespace-most
+
+#  Partition_select_exclude
+#  ------------------------
+#    List of partitions to exclude from selection mode. 
+#partition_select_exclude: <none>
+
+#  Partition_select_usage_reinit
+#  -----------------------------
+#    For a given session, number of operations (e.g. partition selection)
+#    for which partitions usage data are cached. 
+#partition_select_usage_reinit: 0
+
+#  Partition_select_soft_usage_limit
+#  ---------------------------------
+#    Limit of partition usage (%): if a partition is over that limit, it is
+#    automatically excluded from selection mode.
+#    #
+#    If all partitions are over that limit, this feature is not used anymore.
+
+#partition_select_soft_usage_limit: 0
+
+#  Plaintextloginpause
+#  -------------------
+#    Time to pause after a successful plaintext login.  For systems that
+#    support strong authentication, this permits users to perceive a cost
+#    of using plaintext passwords.  (This does not affect the use of PLAIN
+#    in SASL authentications.)
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#plaintextloginpause: <none>
+
+#  Plaintextloginalert
+#  -------------------
+#    Message to send to client after a successful plaintext login. 
+#plaintextloginalert: <none>
+
+#  Popexpiretime
+#  -------------
+#    The duration advertised as being the minimum a message may be
+#    left on the POP server before it is deleted (via the CAPA command,
+#    defined in the POP3 Extension Mechanism, which some clients may
+#    support).  This duration has a granularity of whole days, with partial
+#    days truncated (so e.g. "45m" is effectively "0d").  "NEVER", the
+#    default, may be specified with a negative number.
+#    #
+#    The Cyrus POP3 server never deletes mail, no matter what the value of
+#    this parameter is.  However, if a site implements a less liberal policy,
+#    it needs to change this parameter accordingly.
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed. 
+#popexpiretime: -1
+
+#  Popminpoll
+#  ----------
+#    Set the minimum amount of time the server forces users to wait
+#    between successive POP logins.
+#    #
+#    For backward compatibility, if no unit is specified, minutes is
+#    assumed. 
+#popminpoll: <none>
+
+#  Popsubfolders
+#  -------------
+#    Allow access to subfolders of INBOX via POP3 by using
+#    userid+subfolder syntax as the authentication/authorization id. 
+#popsubfolders: 0
+
+#  Poppollpadding
+#  --------------
+#    Create a softer minimum poll restriction.  Allows poppollpadding
+#    connections before the minpoll restriction is triggered.  Additionally,
+#    one padding entry is recovered every popminpoll minutes.
+#    This allows for the occasional polling rate faster than popminpoll,
+#    (i.e., for clients that require a send/receive to send mail) but still
+#    enforces the rate long-term.  Default is 1 (disabled).
+#    The easiest way to think of it is a queue of past connections, with one
+#    slot being filled for every connection, and one slot being cleared
+#    every popminpoll minutes. When the queue is full, the user
+#    will not be able to check mail again until a slot is cleared.  If the
+#    user waits a sufficient amount of time, they will get back many or all
+#    of the slots. 
+#poppollpadding: 1
+
+#  Poptimeout
+#  ----------
+#    Set the length of the POP server's inactivity autologout timer.
+#    The minimum value is 10 minutes, the default.
+#    #
+#    For backward compatibility, if no unit is specified, minutes is
+#    assumed. 
+#poptimeout: 10m
+
+#  Popuseacl
+#  ---------
+#    Enforce IMAP ACLs in the pop server.  Due to the nature of the POP3
+#    protocol, the only rights which are used by the pop server are 'r',
+#    't', and 's' for the owner of the mailbox.  The 'r' right allows the
+#    user to open the mailbox and list/retrieve messages.  The 't' right
+#    allows the user to delete messages.  The 's' right allows messages
+#    retrieved by the user to have the \Seen flag set (only if
+#    popuseimapflags is also enabled). 
+#popuseacl: 0
+
+#  Popuseimapflags
+#  ---------------
+#    If enabled, the pop server will set and obey IMAP flags.  Messages
+#    having the \Deleted flag are ignored as if they do not exist.
+#    Messages that are retrieved by the client will have the \Seen flag
+#    set.  All messages will have the \Recent flag unset. 
+#popuseimapflags: 0
+
+#  Postmaster
+#  ----------
+#    Username that is used as the 'From' address in rejection MDNs produced
+#    by sieve. 
+#postmaster: postmaster
+
+#  Postspec
+#  --------
+#  Postuser
+#  --------
+#Userid used to deliver messages to shared folders.  For example, if
+#set to "bb", email sent to "bb+shared.blah" would be delivered to
+#the "shared.blah" folder.  By default, an email address of
+#"+shared.blah" would be used. 
+#postspec: <none>
+#postuser: <empty string>
+
+#  Proc_path
+#  ---------
+#    Path to proc directory.  Default is NULL - must be an absolute path
+#    if specified.  If not specified, the path $configdirectory/proc/ will be
+#    used. 
+#proc_path: <none>
+
+#  Prometheus_enabled
+#  ------------------
+#    Whether tracking of service metrics for Prometheus is enabled. 
+#prometheus_enabled: 0
+
+#  Prometheus_need_auth
+#  --------------------
+#    Authentication level required to fetch Prometheus metrics. 
+#    Allowed values: none, user, admin
+#prometheus_need_auth: admin
+
+#  Prometheus_update_freq
+#  ----------------------
+#    Frequency in at which promstatsd should re-collate its statistics
+#    report.  The minimum value is 1 second, the default is 10 seconds.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#prometheus_update_freq: 10s
+
+#  Prometheus_stats_dir
+#  --------------------
+#    Directory to use for gathering prometheus statistics.  If specified,
+#    must be an absolute path.  If not specified, the default path
+#    $configdirectory/stats/ will be used.  It may be advantageous to locate this
+#    directory on ephemeral storage. 
+#prometheus_stats_dir: <none>
+
+#  Proxy_authname
+#  --------------
+#    The authentication name to use when authenticating to a backend server
+#    in the Cyrus Murder. 
+#proxy_authname: proxy
+
+#  Proxy_compress
+#  --------------
+#    Try to enable protocol-specific compression when performing a client
+#    connection to a backend server in the Cyrus Murder.
+#    #
+#    Note that this should only be necessary over slow network
+#    connections.  Also note that currently only IMAP and MUPDATE support
+#    compression. 
+#proxy_compress: 0
+
+#  Proxy_password
+#  --------------
+#    The default password to use when authenticating to a backend server
+#    in the Cyrus Murder.  May be overridden on a host-specific basis using
+#    the hostname_password option. 
+#proxy_password: <none>
+
+#  Proxy_realm
+#  -----------
+#    The authentication realm to use when authenticating to a backend server
+#    in the Cyrus Murder 
+#proxy_realm: <none>
+
+#  Proxyd_allow_status_referral
+#  ----------------------------
+#    Set to true to allow proxyd to issue referrals to clients that support it
+#    when answering the STATUS command.  This is disabled by default since
+#    some clients issue many STATUS commands in a row, and do not cache the
+#    connections that these referrals would cause, thus resulting in a higher
+#    authentication load on the respective backend server. 
+#proxyd_allow_status_referral: 0
+
+#  Proxyd_disable_mailbox_referrals
+#  --------------------------------
+#    Set to true to disable the use of mailbox-referrals on the
+#    proxy servers. 
+#proxyd_disable_mailbox_referrals: 0
+
+#  Proxyservers
+#  ------------
+#    A list of users and groups that are allowed to proxy for other
+#    users, separated by spaces.  Any user listed in this will be
+#    allowed to login for any other user: use with caution.
+#    In a standard murder this option should ONLY be set on backends.
+#    DO NOT SET on frontends or things won't work properly. 
+#proxyservers: <none>
+
+#  Pts_module
+#  ----------
+#    The PTS module to use. 
+#    Allowed values: afskrb, ldap
+#pts_module: afskrb
+
+#  Ptloader_sock
+#  -------------
+#    Unix domain socket that ptloader listens on.
+#    (defaults to configdirectory/ptclient/ptsock) 
+#ptloader_sock: <none>
+
+#  Ptscache_db
+#  -----------
+#    The cyrusdb backend to use for the pts cache. 
+#    Allowed values: skiplist, twoskip, zeroskip
+#ptscache_db: twoskip
+
+#  Ptscache_db_path
+#  ----------------
+#    The absolute path to the ptscache db file.  If not specified,
+#    will be configdirectory/ptscache.db 
+#ptscache_db_path: <none>
+
+#  Ptscache_timeout
+#  ----------------
+#    The timeout for the PTS cache database when using the auth_krb_pts
+#    authorization method (default: 3 hours).
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#ptscache_timeout: 3h
+
+#  Ptskrb5_convert524
+#  ------------------
+#    When using the AFSKRB ptloader module with Kerberos 5 canonicalization,
+#    do the final 524 conversion to get a n AFS style name (using '.' instead
+#    of '/', and using short names 
+#ptskrb5_convert524: 1
+
+#  Ptskrb5_strip_default_realm
+#  ---------------------------
+#    When using the AFSKRB ptloader module with Kerberos 5 canonicalization,
+#    strip the default realm from the userid (this does not affect the stripping
+#    of realms specified by the afspts_localrealms option) 
+#ptskrb5_strip_default_realm: 1
+
+#  Qosmarking
+#  ----------
+#    This specifies the Class Selector or Differentiated Services Code Point
+#    designation on IP headers (in the ToS field). 
+#    Allowed values: cs0, cs1, cs2, cs3, cs4, cs5, cs6, cs7, af11, af12, af13, af21, af22, af23, af31, af32, af33, af41, af42, af43, ef
+#qosmarking: cs0
+
+#  Quota_db
+#  --------
+#    The cyrusdb backend to use for quotas. 
+#    Allowed values: flat, skiplist, sql, quotalegacy, twoskip, zeroskip
+#quota_db: quotalegacy
+
+#  Quota_db_path
+#  -------------
+#    The absolute path for the quota database (if you choose a single-file
+#    quota DB type - or the base path if you choose quotalegacy).  If
+#    not specified will be configdirectory/quotas.db or configdirectory/quota/ 
+#quota_db_path: <none>
+
+#  Quotawarn
+#  ---------
+#    The percent of quota utilization over which the server generates
+#    warnings. 
+#quotawarn: 90
+
+#  Quotawarnkb
+#  -----------
+#    The maximum amount of free space (in kB) at which to give a quota
+#    warning (if this value is 0, or if the quota is smaller than this
+#    amount, then warnings are always given). 
+#quotawarnkb: 0
+
+#  Quotawarnmsg
+#  ------------
+#    The maximum amount of messages at which to give a quota warning
+#    (if this value is 0, or if the quota is smaller than this
+#    amount, then warnings are always given). 
+#quotawarnmsg: 0
+
+#  Reject8bit
+#  ----------
+#    If enabled, lmtpd rejects messages with 8-bit characters in the
+#    headers. 
+#reject8bit: 0
+
+#  Restore_authname
+#  ----------------
+#    The authentication used by the restore tool when authenticating
+#    to an IMAP/sync server. 
+#restore_authname: <none>
+
+#  Restore_password
+#  ----------------
+#    The password used by the restore tool when authenticating to an
+#    IMAP/sync server. 
+#restore_password: <none>
+
+#  Restore_realm
+#  -------------
+#    The authentication realm used by the restore tool when
+#    authenticating to an IMAP/sync server. 
+#restore_realm: <none>
+
+#  Reverseacls
+#  -----------
+#    At startup time, ctl_cyrusdb -r will check this value and it
+#    will either add or remove reverse ACL pointers from mailboxes.db 
+#reverseacls: 0
+
+#  Rfc2046_strict
+#  --------------
+#    If enabled, imapd will be strict (per RFC 2046) when matching MIME
+#    boundary strings.  This means that boundaries containing other
+#    boundaries as substrings will be treated as identical.  Since
+#    enabling this option will break some messages created by Eudora 5.1
+#    (and earlier), it is recommended that it be left disabled unless
+#    there is good reason to do otherwise. 
+#rfc2046_strict: 0
+
+#  Rfc2047_utf8
+#  ------------
+#    If enabled, imapd will parse any non-encoded character sequence in
+#    MIME header values as UTF8. This is useful for installations that
+#    either advertise the UTF8SMTP (RFC 5335) extension or receive mails
+#    with improperly escaped UTF-8 byte sequences. It is recommended that
+#    this option is left disabled unless there is good reason to do
+#    otherwise. 
+#rfc2047_utf8: 0
+
+#  Rfc3028_strict
+#  --------------
+#    If enabled, Sieve will be strict (per RFC 3028) with regards to
+#    which headers are allowed to be used in address and envelope tests.
+#    This means that only those headers which are defined to contain addresses
+#    will be allowed in address tests and only "to" and "from" will be
+#    allowed in envelope tests.  When disabled, ANY grammatically correct header
+#    will be allowed. 
+#rfc3028_strict: 1
+
+#  Rss_feedlist_template
+#  ---------------------
+#    File containing HTML that will be used as a template for displaying
+#    the list of available RSS feeds.  A single instance of the variable
+#    %RSS_FEEDLIST% should appear in the file, which will be replaced by
+#    a nested unordered list of feeds.  The toplevel unordered list will
+#    be tagged with an id of "feed" (<ul id='feed'>) which can be used
+#    by stylesheet(s) in your template.  The dynamically created list of
+#    feeds based on the HTML template will be accessible at the "/rss"
+#    URL on the server. 
+#rss_feedlist_template: <none>
+
+#  Rss_feeds
+#  ---------
+#    A wildmat pattern specifying which mailbox hierarchies should be
+#    treated as RSS feeds.  Only mailboxes matching the wildmat will
+#    have their messages available via RSS.  If not set, a default
+#    wildmat of "*" (ALL mailboxes) will be used. 
+#rss_feeds: *
+
+#  Rss_maxage
+#  ----------
+#    Maximum age of items to display in an RSS channel.  If non-zero,
+#    httpd will only display items received within this time period.
+#    If set to 0, all available items will be displayed (the default).
+#    #
+#    For backward compatibility, if no unit is specified, days is
+#    assumed. 
+#rss_maxage: <none>
+
+#  Rss_maxitems
+#  ------------
+#    Maximum number of items to display in an RSS channel.  If non-zero,
+#    httpd will display no more than the rss_maxitems most recent
+#    items.  If set to 0, all available items will be displayed (the
+#    default). 
+#rss_maxitems: 0
+
+#  Rss_maxsynopsis
+#  ---------------
+#    Maximum RSS item synopsis length.  If non-zero, httpd will display
+#    no more than the first rss_maxsynopsis characters of an
+#    item's synopsis.  If set to 0, the entire synopsis will be
+#    displayed (the default). 
+#rss_maxsynopsis: 0
+
+#  Rss_realm
+#  ---------
+#    The realm to present for HTTP authentication of RSS feeds.  If not
+#    set (the default), the value of the "servername" option will be
+#    used.
+#rss_realm: <none>
+
+#  Sasl_auto_transition
+#  --------------------
+#    If enabled, the SASL library will automatically create authentication
+#    secrets when given a plaintext password.  See the SASL documentation. 
+#sasl_auto_transition: 0
+
+#  Sasl_maximum_layer
+#  ------------------
+#    Maximum SSF (security strength factor) that the server will allow a
+#    client to negotiate. 
+#sasl_maximum_layer: 256
+
+#  Sasl_minimum_layer
+#  ------------------
+#    The minimum SSF that the server will allow a client to negotiate.
+#    A value of 1 requires integrity protection; any higher value
+#    requires some amount of encryption. 
+#sasl_minimum_layer: 0
+
+#  Sasl_option
+#  -----------
+#    Any SASL option can be set by preceding it with sasl_.  This
+#    file overrides the SASL configuration file. 
+#sasl_option: 0
+
+#  Sasl_pwcheck_method
+#  -------------------
+#    The mechanism used by the server to verify plaintext passwords.
+#    Possible values include "auxprop", "saslauthd", and "pwcheck". 
+#sasl_pwcheck_method: <none>
+
+#  Search_batchsize
+#  ----------------
+#    The number of messages to be indexed in one batch (default 20).
+#    Note that long batches may delay user commands or mail delivery. 
+#search_batchsize: 20
+
+#  Search_attachment_extractor_url
+#  -------------------------------
+#    A HTTP or HTTPS URL to extract search text from rich text attachments
+#    and other media during search indexing. The server at this URL must
+#    implement the following protocol:
+
+#    1. For each attachment of an email, Cyrus sends a GET request to the
+#    URL <extractor-url>/<cyrus-id>, where <extractor-url> is the
+#    configured URL and <cyrus-id> is a Cyrus-chosen path segment that
+#    uniquely identifies this attachment.
+
+#    2. If the extractor already has a cached plain text extract of the
+#    attachment identified by <cyrus-id> then it may return HTTP status
+#    code 200 (OK) and the plain text extract with a Content-Type
+#    "text/plain" header. Otherwise it must return HTTP status 404 (Not Found).
+
+#    3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+#    a PUT request to the same URL as previously. The PUT request body
+#    contains the decoded, binary body of the attachment. The Content-Type
+#    request header has the same value as declared in the MIME part
+#    headers, including any type parameters.
+
+#    4. The extractor must return the plain text extract with either HTTP status
+#    200 (OK) or 201 (Created) and a Content-Type "text/plain" header.
+#    If no text can be extracted, then the extractor may return any return code
+#    in the range 4xx, or 200 and an empty response body.
+
+#    Any other HTTP status code is treated as an error. For performance
+#    reasons, the Cyrus indexer attempts to keep-alive the TCP connection
+#    to the extractor. 
+#search_attachment_extractor_url: <none>
+
+#  Search_index_language
+#  ---------------------
+
+#    If enabled, then message bodies and subjects are indexed by their
+#    detected language, if the cld2 dependency is built into Cyrus.
+#    Regardless of this flag, bodies and subjects are always indexed and
+#    searched using the default stemmer.
+
+#search_index_language: 0
+
+#  Search_index_parts
+#  ------------------
+
+#    If enabled, then message parts are each indexed separately into Xapian
+#    so that matches can be done by part.
+
+#search_index_parts: 0
+
+#  Search_query_language
+#  ---------------------
+
+#    If enabled, then message bodies and subjects searched by their language
+#    that got detected during indexing, if any.
+#    Regardless of this flag, bodies and subjects are always searched using
+#    the default stemmer.
+
+#search_query_language: 0
+
+#  Search_normalisation_max
+#  ------------------------
+#    A resource bound for the combinatorial explosion of search expression
+#    tree complexity caused by normalising expressions with many OR nodes.
+#    These can use more CPU time to optimise than they save IO time in scanning
+#    folders. 
+#search_normalisation_max: 1000
+
+#  Search_engine
+#  -------------
+#    The indexing engine used to speed up searching.  
+#    Allowed values: none, squat, xapian
+#search_engine: none
+
+#  Search_fuzzy_always
+#  -------------------
+#    Whether to enable RFC 6203 FUZZY search for all IMAP SEARCH. If turned
+#    on, search attributes will be searched using FUZZY search by default.
+#    If turned off, clients have to explicitly use the FUZZY search key to
+#    enable fuzzy search for regular SEARCH commands. 
+#search_fuzzy_always: 0
+
+#  Search_index_headers
+#  --------------------
+#    Whether to index headers other than From, To, Cc, Bcc, and Subject.
+#    Experiment shows that some headers such as Received and DKIM-Signature
+#    can contribute up to 2/3rds of the index size but almost nothing to
+#    the utility of searching.  Note that is header indexing is disabled,
+#    headers can still be searched, the searches will just be slower.
+
+#search_index_headers: 1
+
+#  Search_indexed_db
+#  -----------------
+#    The cyrusdb backend to use for the search latest indexed uid state.  Xapian only. 
+#    Allowed values: flat, skiplist, twoskip, zeroskip
+#search_indexed_db: twoskip
+
+#  Search_maxtime
+#  --------------
+#    The maximum number of seconds to run a search for before aborting.  Default
+#    of no value means search "forever" until other timeouts. 
+#search_maxtime: <none>
+
+#  Search_queryscan
+#  ----------------
+#    The minimum number of records require to do a direct scan of all G keys
+#    * rather than indexed lookups.  A value of 0 means always do indexed lookups.
+
+#search_queryscan: 5000
+
+#  Search_skipdiacrit
+#  ------------------
+#    When searching, should diacriticals be stripped from the search
+#    terms.  The default is "true", a search for "hav" will match
+#    "Håvard".  This is not RFC5051 compliant, but it backwards
+#    compatible, and may be preferred by some sites. 
+#search_skipdiacrit: 1
+
+#  Search_skiphtml
+#  ---------------
+#    If enabled, HTML parts of messages are skipped, i.e. not indexed and
+#    not searchable.  Otherwise, they're indexed.  
+#search_skiphtml: 0
+
+#  Search_whitespace
+#  -----------------
+#    When searching, how whitespace should be handled.  Options are:
+#    "skip" (default in 2.3 and earlier series) - where a search for
+#    "equi" would match "the quick brown fox".  "merge" - the default,
+#    where "he  qu" would match "the quick   brownfox", and "keep",
+#    where whitespace must match exactly.  The default of "merge" is
+#    recommended for most cases - it's a good compromise which
+#    keeps words separate. 
+#    Allowed values: skip, merge, keep
+#search_whitespace: merge
+
+#  Search_snippet_length
+#  ---------------------
+#    The maximum byte length of a snippet generated by the XSNIPPETS
+#    command. Only supported by the Xapian search backend, which
+#    attempts to always fill search_snippet_length bytes in the
+#    generated snippet. 
+#search_snippet_length: 255
+
+#  Search_stopword_path
+#  --------------------
+#    The absolute base path to the search stopword lists. If not specified,
+#    no stopwords will be taken into account during search indexing. Currently,
+#    the only supported and default stop word file is english.txt. 
+#search_stopword_path: <none>
+
+#  Searchpartition-name
+#  --------------------
+#    The pathname where to store the xapian search indexes of searchtier
+#    for mailboxes of partition name. This must be configured for the
+#    defaultsearchtier and any additional search tier (see squatter for
+#    details).
+#    #
+#    For example: if defaultpartition is defined as part1 and
+#    defaultsearchtier as tier1 then the configuration must contain
+#    an entry tier1searchpartition-part1 that defines the path where to
+#    store this tier1's search index for the part1 partition.
+#    #
+#    This option MUST be specified for xapian search. 
+#searchpartition-name: <none>
+
+#  Seenstate_db
+#  ------------
+#    The cyrusdb backend to use for the seen state. 
+#    Allowed values: flat, skiplist, twoskip, zeroskip
+#seenstate_db: twoskip
+
+#  Sendmail
+#  --------
+#    The pathname of the sendmail executable.  Sieve invokes sendmail
+#    for sending rejections, redirects and vacation responses. 
+#sendmail: /usr/lib/sendmail
+
+#  Sendmail_auth_id
+#  ----------------
+#    The name of an environment variable to set when invoking sendmail.
+#    The value of this environment variable will contain the user id
+#    of the currently authenticated user. If no user is authenticated
+#    the environment variable is not set. 
+#sendmail_auth_id: CYRUS_SENDMAIL_AUTH_ID
+
+#  Serverlist
+#  ----------
+#    Whitespace separated list of backend server names.  Used for
+#    finding server with the most available free space for proxying
+#    CREATE. 
+#serverlist: <none>
+
+#  Serverlist_select_mode
+#  ----------------------
+#    Server selection mode.
+#    #
+#    random
+#        (pseudo-)random selection
+#    freespace-most
+#        backend with the most (total) free space (KiB)
+#    freespace-percent-most
+#        backend whose partition has the most free space (%)
+#    freespace-percent-weighted
+#        same as for partition selection, comparing the free space (%) of the least used
+#        partition of each backend
+#    freespace-percent-weighted-delta
+#        same as for partition selection, comparing the free space (%) of the least used
+#        partition of each backend.
+#        #
+
+#        Allowed values: random, freespace-most, freespace-percent-most, freespace-percent-weighted, freespace-percent-weighted-delta
+#serverlist_select_mode: freespace-most
+
+#  Serverlist_select_usage_reinit
+#  ------------------------------
+#    For a given session, number of operations (e.g. backend selection)
+#    for which backend usage data are cached. 
+#serverlist_select_usage_reinit: 0
+
+#  Serverlist_select_soft_usage_limit
+#  ----------------------------------
+#    Limit of backend usage (%): if a backend is over that limit, it is
+#    automatically excluded from selection mode.
+#    #
+#    If all backends are over that limit, this feature is not used anymore.
+
+#serverlist_select_soft_usage_limit: 0
+
+#  Servername
+#  ----------
+#    This is the hostname visible in the greeting messages of the POP,
+#    IMAP and LMTP daemons. If it is unset, then the result returned
+#    from gethostname(2) is used.  This is also the value used by murder
+#    clusters to identify the host name.  It should be resolvable by
+#    DNS to the correct host, and unique within an active cluster.  If
+#    you are using low level replication (e.g. drbd) then it should be
+#    the same on each copy and the DNS name should also be moved to
+#    the new master on failover. 
+#servername: <none>
+
+#  Serverinfo
+#  ----------
+#    The server information to display in the greeting and capability
+#    responses. Information is displayed as follows:
+
+#        "off" = no server information in the greeting or capabilities
+#        "min" = servername in the greeting; no server information in the capabilities
+#        "on" = servername and product version in the greeting;
+#        product version in the capabilities
+#        #
+
+#        Allowed values: off, min, on
+#serverinfo: on
+
+#  Sharedprefix
+#  ------------
+#    If using the alternate IMAP namespace, the prefix for the shared
+#    namespace.  The hierarchy delimiter will be automatically appended.
+
+#sharedprefix: Shared Folders
+
+#  Sieve_allowreferrals
+#  --------------------
+#    If enabled, timsieved will issue referrals to clients when the
+#    user's scripts reside on a remote server (in a Murder).
+#    Otherwise, timsieved will proxy traffic to the remote server. 
+#sieve_allowreferrals: 1
+
+#  Sieve_duplicate_max_expiration
+#  ------------------------------
+#    Maximum expiration time for duplicate message tracking records.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#sieve_duplicate_max_expiration: 90d
+
+#  Sieve_extensions
+#  ----------------
+#    Space-separated list of Sieve extensions allowed to be used in
+#    sieve scripts, enforced at submission by timsieved(8).  Any
+#    previously installed script will be unaffected by this option and
+#    will continue to execute regardless of the extensions used.  This
+#    option has no effect on options that are disabled at compile time
+#    (e.g., "regex"). 
+#    Allowed values: fileinto, reject, vacation, vacation-seconds, imapflags, notify, include, envelope, environment, body, relational, regex, subaddress, copy, date, index, imap4flags, mailbox, mboxmetadata, servermetadata, variables, editheader, extlists, duplicate, ihave, fcc, special-use, redirect-dsn, redirect-deliverby, mailboxid, x-cyrus-log, x-cyrus-jmapquery, x-cyrus-snooze
+#sieve_extensions: fileinto reject vacation vacation-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x-cyrus-jmapquery x-cyrus-snooze
+
+#  Sieve_maxscriptsize
+#  -------------------
+#    Maximum size (in kilobytes) any sieve script can be, enforced at
+#    submission by timsieved(8). 
+#sieve_maxscriptsize: 32
+
+#  Sieve_maxscripts
+#  ----------------
+#    Maximum number of sieve scripts any user may have, enforced at
+#    submission by timsieved(8). 
+#sieve_maxscripts: 5
+
+#  Sieve_utf8fileinto
+#  ------------------
+#    If enabled, the sieve engine expects folder names for the
+#    fileinto action in scripts to use UTF8 encoding.  Otherwise,
+#    modified UTF7 encoding should be used. 
+#sieve_utf8fileinto: 0
+
+#  Sieve_sasl_send_unsolicited_capability
+#  --------------------------------------
+#    If enabled, timsieved will emit a capability response after a successful
+#    SASL authentication, per draft-martin-managesieve-12.txt . 
+#sieve_sasl_send_unsolicited_capability: 0
+
+#  Sieve_use_lmtp_reject
+#  ---------------------
+#    Enabled by default.  If reject can be done via LMTP, then return a 550
+#    rather than generating the bounce message in Cyrus. 
+#sieve_use_lmtp_reject: 1
+
+#  Sieve_vacation_min_response
+#  ---------------------------
+#    Minimum time interval between consecutive vacation responses, per
+#    draft-ietf-vacation-seconds.txt.  The default is 3 days.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#sieve_vacation_min_response: 3d
+
+#  Sieve_vacation_max_response
+#  ---------------------------
+#    Maximum time interval between consecutive vacation responses, per
+#    draft-ietf-vacation-seconds.txt.  The default is 90 days.  The
+#    minimum is 7 days.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#sieve_vacation_max_response: 90d
+
+#  Sievedir
+#  --------
+#    If sieveusehomedir is false, this directory is searched for Sieve
+#    scripts. 
+#sievedir: /usr/sieve
+
+#  Sievenotifier
+#  -------------
+#    Notifyd(8) method to use for "SIEVE" notifications.  If not set, "SIEVE"
+#    notifications are disabled.
+#    #
+#    This method is only used when no method is specified in the script. 
+#sievenotifier: <none>
+
+#  Sieveusehomedir
+#  ---------------
+#    If enabled, lmtpd will look for Sieve scripts in user's home
+#    directories: ~user/.sieve. 
+#sieveusehomedir: 0
+
+#  Anysievefolder
+#  --------------
+#    It must be "yes" in order to permit the autocreation of any INBOX subfolder
+#    requested by a sieve filter, through the "fileinto" action. (default = no) 
+#anysievefolder: 0
+
+#  Singleinstancestore
+#  -------------------
+#    If enabled, imapd, lmtpd and nntpd attempt to only write one copy
+#    of a message per partition and create hard links, resulting in a
+#    potentially large disk savings. 
+#singleinstancestore: 1
+
+#  Skiplist_always_checkpoint
+#  --------------------------
+#    If enabled, this option forces the skiplist cyrusdb backend to
+#    always checkpoint when doing a recovery.  This causes slightly
+#    more IO, but on the other hand leads to more efficient databases,
+#    and the entire file is already "hot". 
+#skiplist_always_checkpoint: 1
+
+#  Skiplist_unsafe
+#  ---------------
+#    If enabled, this option forces the skiplist cyrusdb backend to
+#    not sync writes to the disk.  Enabling this option is NOT RECOMMENDED. 
+#skiplist_unsafe: 0
+
+#  Smtp_backend
+#  ------------
+#    The SMTP backend to use for sending email.
+
+#    The \"host\" backend sends message submissions via
+#    a TCP socket to the SMTP host defined in the config
+#    option smtp_host.
+
+#    The \"sendmail\" backend forks the Cyrus process into
+#    the executable defined in the config option sendmail.
+#    The executable must accept \"-bs\" as command line
+#    argument, read from stdin and must implement the minimum
+#    SMTP protocol as defined in section 4.5.1 of RFC 5321.
+
+#    If the SMTP EHLO command reports AUTH (RFC 4954) as a
+#    supported extension, then the MAIL FROM command includes
+#    the AUTH parameter, with its value set to the name of any
+#    authenticated user which triggered the email. The AUTH
+#    parameter is omitted if the user is unknown to the calling
+#    process.
+
+#    If the directory
+#    configdirectory/log/smtpclient.\ smtp_backend
+#    exists, then telemetry logs for outgoing SMTP sessions will
+#    be created in this directory.
+
+#    Allowed values: host, sendmail
+#smtp_backend: sendmail
+
+#  Smtp_host
+#  ---------
+#    The SMTP host to use for sending mail (also see the
+#    smtp_backend option). The value of this option must
+#    the name or IP address of a TCP host, followed optionally
+#    by a colon and the port or service to use. The default
+#    port is 587. TLS may be activated by appending \"/tls\"
+#    to the value. Authentication is enabled if smtp_auth_authname
+#    is set. Authentication can be explicitly disabled by appending
+#    \"/noauth\" to the host address. 
+#smtp_host: localhost:587
+
+#  Smtp_auth_authname
+#  ------------------
+#    The authentication name to use when authenticating to the SMTP
+#    server defined in smtp_host. 
+#smtp_auth_authname: <none>
+
+#  Smtp_auth_password
+#  ------------------
+#    The password to use when authenticating to the SMTP server defined
+#    in smtp_host. 
+#smtp_auth_password: <none>
+
+#  Smtp_auth_realm
+#  ---------------
+#    The authentication SASL realm to use when authenticating to a SMTP
+#    server. 
+#smtp_auth_realm: <none>
+
+#  Soft_noauth
+#  -----------
+#    If enabled, lmtpd returns temporary failures if the client does not
+#    successfully authenticate.  Otherwise lmtpd returns permanent failures
+#    (causing the mail to bounce immediately). 
+#soft_noauth: 1
+
+#  Sortcache_db
+#  ------------
+#    The cyrusdb backend to use for caching sort results (currently only
+#    used for xconvmultisort) 
+#    Allowed values: skiplist, twoskip, zeroskip
+#sortcache_db: twoskip
+
+#  Specialuse_extra
+#  ----------------
+#    Whitespace separated list of extra special-use attributes
+#    that can be set on a mailbox. RFC 6154 currently lists
+#    what special-use attributes can be set. This allows
+#    extending that list in the future or adding your own
+#    if needed. 
+#specialuse_extra: <none>
+
+#  Specialuse_protect
+#  ------------------
+#    Whitespace separated list of special-use attributes
+#    to protect the mailboxes for.  If set, don't allow
+#    mailboxes with these special use attributes to be deleted
+#    or renamed to have a different parent. Default is the built-in list
+#specialuse_protect: \\Archive \\Drafts \\Important \\Junk \\Sent \\Trash
+
+#  Specialusealways
+#  ----------------
+#    If enabled, this option causes LIST and LSUB output to always include
+#    the XLIST "special-use" flags 
+#specialusealways: 1
+
+#  Sql_database
+#  ------------
+#    Name of the database which contains the cyrusdb table(s). 
+#sql_database: <none>
+
+#  Sql_engine
+#  ----------
+#    Name of the SQL engine to use. 
+#    Allowed values: mysql, pgsql, sqlite
+#sql_engine: <none>
+
+#  Sql_hostnames
+#  -------------
+#    Comma separated list of SQL servers (in host[:port] format). 
+#sql_hostnames: <empty string>
+
+#  Sql_passwd
+#  ----------
+#    Password to use for authentication to the SQL server. 
+#sql_passwd: <none>
+
+#  Sql_user
+#  --------
+#    Username to use for authentication to the SQL server. 
+#sql_user: <none>
+
+#  Sql_usessl
+#  ----------
+#    If enabled, a secure connection will be made to the SQL server. 
+#sql_usessl: 0
+
+#  Srs_alwaysrewrite
+#  -----------------
+#    If true, perform SRS rewriting for ALL forwarding, even when not required. 
+#srs_alwaysrewrite: 0
+
+#  Srs_domain
+#  ----------
+#    The domain to use in rewritten addresses. This must point only to machines
+#    which know the encoding secret used by this system. When present, SRS is
+#    enabled. 
+#srs_domain: <none>
+
+#  Srs_hashlength
+#  --------------
+#    The hash length to generate in a rewritten address. 
+#srs_hashlength: 0
+
+#  Srs_secrets
+#  -----------
+#    A list of secrets with which to generate addresses. 
+#srs_secrets: <none>
+
+#  Srs_separator
+#  -------------
+#    The separator to appear immediately after SRS[01] in rewritten addresses. 
+#srs_separator: <none>
+
+#  Srvtab
+#  ------
+#    The pathname of srvtab file containing the server's private
+#    key.  This option is passed to the SASL library and overrides its
+#    default setting. 
+#srvtab: <empty string>
+
+#  Submitservers
+#  -------------
+#    A list of users and groups that are allowed to resolve "urlauth=submit+"
+#    IMAP URLs, separated by spaces.  Any user listed in this will be
+#    allowed to fetch the contents of any valid "urlauth=submit+" IMAP URL:
+#    use with caution. 
+#submitservers: <none>
+
+#  Subscription_db
+#  ---------------
+#    The cyrusdb backend to use for the subscriptions list. 
+#    Allowed values: flat, skiplist, twoskip, zeroskip
+#subscription_db: flat
+
+#  Suppress_capabilities
+#  ---------------------
+#    Suppress the named capabilities from any capability response.  Use the
+#    exact case as it appears in the response, e.g.
+#    "suppress_capabilities: ESEARCH QRESYNC WITHIN XLIST LIST-EXTENDED"
+#    if you have a murder with 2.3.x backends and don't want clients being
+#    confused by new capabilities that some backends don't support. 
+#suppress_capabilities: <none>
+
+#  Statuscache
+#  -----------
+#    Enable/disable the imap status cache. 
+#statuscache: 0
+
+#  Statuscache_db
+#  --------------
+#    The cyrusdb backend to use for the imap status cache. 
+#    Allowed values: skiplist, sql, twoskip, zeroskip
+#statuscache_db: twoskip
+
+#  Statuscache_db_path
+#  -------------------
+#    The absolute path to the statuscache db file.  If not specified,
+#    will be configdirectory/statuscache.db 
+#statuscache_db_path: <none>
+
+#  Sync_authname
+#  -------------
+#    The authentication name to use when authenticating to a sync server.
+#    Prefix with a channel name to only apply for that channel 
+#sync_authname: <none>
+
+#  Sync_batchsize
+#  --------------
+#    the number of messages to upload in a single mailbox replication.
+#    Default is 8192.  If there are more than this many messages appended
+#    to the mailbox, generate a synthetic partial state and send that. 
+#sync_batchsize: 8192
+
+#  Sync_host
+#  ---------
+#    Name of the host (replica running sync_server(8)) to which
+#    replication actions will be sent by sync_client(8).
+#    Prefix with a channel name to only apply for that channel 
+#sync_host: <none>
+
+#  Sync_log
+#  --------
+#    Enable replication action logging by lmtpd(8), imapd(8), pop3d(8),
+#    and nntpd(8).  The log {configdirectory}/sync/log is used by
+#    sync_client(8) for "rolling" replication. 
+#sync_log: 0
+
+#  Sync_log_chain
+#  --------------
+#    Enable replication action logging by sync_server as well, allowing
+#    chaining of replicas.  Use this on 'B' for A => B => C replication layout 
+#sync_log_chain: 0
+
+#  Sync_log_channels
+#  -----------------
+#    If specified, log all events to multiple log files in directories
+#    specified by each "channel".  Each channel can then be processed
+#    separately, such as by multiple sync_client(8)s in a mesh replication
+#    scheme, or by squatter(8) for rolling search index updates.
+#    #
+#    You can use "" (the two-character string U+22 U+22) to mean the
+#    default sync channel. 
+#sync_log_channels: <none>
+
+#  Sync_log_unsuppressable_channels
+#  --------------------------------
+#    If specified, the named channels are exempt from the effect of setting
+#    sync_log_chain:off, i.e. they are always logged to by the sync_server
+#    process.  This is only really useful to allow rolling search indexing
+#    on a replica. 
+#sync_log_unsuppressable_channels: squatter
+
+#  Sync_password
+#  -------------
+#    The default password to use when authenticating to a sync server.
+#    Prefix with a channel name to only apply for that channel 
+#sync_password: <none>
+
+#  Sync_port
+#  ---------
+#    Name of the service (or port number) of the replication service on
+#    replica host.  Prefix with a channel name to only apply for that
+#    channel.  If not specified, and if sync_try_imap is set to "yes"
+#    (the default), then the replication client will first try "imap"
+#    (port 143) to check if imapd supports replication.  otherwise it
+#    will default to "csync" (usually port 2005). 
+#sync_port: <none>
+
+#  Sync_realm
+#  ----------
+#    The authentication realm to use when authenticating to a sync server.
+#    Prefix with a channel name to only apply for that channel 
+#sync_realm: <none>
+
+#  Sync_repeat_interval
+#  --------------------
+#    Minimum interval between replication runs in rolling replication
+#    mode. If a replication run takes longer than this time, we repeat
+#    immediately.  Prefix with a channel name to only apply for that
+#    channel.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#sync_repeat_interval: 1s
+
+#  Sync_shutdown_file
+#  ------------------
+#    Simple latch used to tell sync_client(8) that it should shut down at the
+#    next opportunity. Safer than sending signals to running processes.
+#    Prefix with a channel name to only apply for that channel 
+#sync_shutdown_file: <none>
+
+#  Sync_timeout
+#  ------------
+#    How long to wait for a response before returning a timeout failure
+#    when talking to a replication peer (client or server).  The minimum
+#    duration is 3 seconds, the default is 30 minutes.
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#sync_timeout: 30m
+
+#  Sync_try_imap
+#  -------------
+#    Whether sync_client should try to perform an IMAP connection
+#    before falling back to csync.  If this is set to "no",
+#    sync_client will only use csync.  Prefix with a channel name to
+#    apply only for that channel 
+#sync_try_imap: 1
+
+#  Syslog_prefix
+#  -------------
+#    String to be prepended to the process name in syslog entries. Can
+#    be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+#    variable.
+#    #
+#    Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+#    advantage that it can be set before the imapd.conf is read, so
+#    errors while reading the config file can be syslogged with the correct
+#    prefix. 
+#syslog_prefix: <none>
+
+#  Syslog_facility
+#  ---------------
+#    Configure a syslog facility.  The default is whatever is compiled
+#    in.  Allowed values are: DAEMON, MAIL, NEWS, USER, and LOCAL0
+#    through to LOCAL7 
+#syslog_facility: <none>
+
+#  Tcp_keepalive
+#  -------------
+#    Enable keepalive on TCP connections 
+#tcp_keepalive: 0
+
+#  Tcp_keepalive_cnt
+#  -----------------
+#    Number of TCP keepalive probes to send before declaring the
+#    connection dead (0 == system default) 
+#tcp_keepalive_cnt: 0
+
+#  Tcp_keepalive_idle
+#  ------------------
+#    How long a connection must be idle before keepalive probes are sent
+#    (0 == system default).
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#tcp_keepalive_idle: 0
+
+#  Tcp_keepalive_intvl
+#  -------------------
+#    Time between keepalive probes (0 == system default).
+#    #
+#    For backward compatibility, if no unit is specified, seconds is
+#    assumed. 
+#tcp_keepalive_intvl: 0
+
+#  Temp_path
+#  ---------
+#    The pathname to store temporary files in 
+#temp_path: /tmp
+
+#  Telemetry_bysessionid
+#  ---------------------
+#    If true, log by sessionid instead of PID for telemetry 
+#telemetry_bysessionid: 0
+
+#  Timeout
+#  -------
+#    The length of the IMAP server's inactivity autologout timer.
+#    The minimum value is 30 minutes.  The default is 32 minutes,
+#    to allow a bit of leeway for clients that try to NOOP every
+#    30 minutes.
+#    #
+#    For backward compatibility, if no unit is specified, minutes
+#    is assumed. 
+#timeout: 32m
+
+#  Imapidletimeout
+#  ---------------
+#    Timeout for idling clients (RFC 2177).  If not set (the default),
+#    the value of "timeout" will be used instead.
+#    #
+#    For backward compatibility, if no unit is specified, minutes
+#    is assumed. 
+#imapidletimeout: <none>
+
+#  Tls_ca_file
+#  -----------
+#    Deprecated in favor of tls_client_ca_file. 
+#tls_ca_file: <none>
+
+#  Tls_ca_path
+#  -----------
+#    Deprecated in favor of tls_client_ca_dir. 
+#tls_ca_path: <none>
+
+#  Tlscache_db
+#  -----------
+#    Deprecated in favor of tls_sessions_db. 
+#tlscache_db: twoskip
+
+#  Tlscache_db_path
+#  ----------------
+#    Deprecated in favor of tls_sessions_db_path. 
+#tlscache_db_path: <none>
+
+#  Tls_cert_file
+#  -------------
+#    Deprecated in favor of tls_server_cert. 
+#tls_cert_file: <none>
+
+#  Tls_cipher_list
+#  ---------------
+#    Deprecated in favor of tls_ciphers. 
+#tls_cipher_list: DEFAULT
+
+#  Tls_ciphers
+#  -----------
+#    The list of SSL/TLS ciphers to allow.  The format of the string
+#    (and definition of "DEFAULT") is described in ciphers(1).
+#    #
+#    See also Mozilla's server-side TLS recommendations:
+#    #
+#    https://wiki.mozilla.org/Security/Server_Side_TLS 
+#tls_ciphers: DEFAULT
+
+#  Tls_crl_file
+#  ------------
+#    Path to a file containing the Certificate Revocation List 
+#tls_crl_file: <none>
+
+#  Tls_client_ca_dir
+#  -----------------
+#    Path to a directory containing the CA certificates used to verify
+#    client SSL certificates used for authentication. 
+#tls_client_ca_dir: <none>
+
+#  Tls_client_ca_file
+#  ------------------
+#    Path to a file containing the CA certificate(s) used to verify
+#    client SSL certificates used for authentication. 
+#tls_client_ca_file: <none>
+
+#  Tls_client_cert
+#  ---------------
+#    File containing the certificate presented to a server for authentication
+#    during STARTTLS. A value of "disabled" will disable this server's use
+#    of certificate-based authentication. 
+#tls_client_cert: <none>
+
+#  Tls_client_certs
+#  ----------------
+#    Disable ("off"), allow ("optional", default) or require ("require") the
+#    use of SSL certificates by clients to authenticate themselves. 
+#    Allowed values: off, optional, require
+#tls_client_certs: optional
+
+#  Tls_client_key
+#  --------------
+#    File containing the private key belonging to the tls_client_cert
+#    certificate. A value of "disabled" will disable this server's use
+#    of certificate-based authentication. 
+#tls_client_key: <none>
+
+#  Tls_eccurve
+#  -----------
+#    The elliptic curve used for ECDHE. Default is NIST Suite B prime256.
+#    See 'openssl ecparam -list_curves' for possible values. 
+#tls_eccurve: prime256v1
+
+#  Tls_key_file
+#  ------------
+#    Deprecated in favor of tls_server_key. 
+#tls_key_file: <none>
+
+#  Tls_required
+#  ------------
+#    If enabled, require a TLS/SSL encryption layer to be negotiated
+#    prior to ANY authentication mechanisms being advertised or allowed. 
+#tls_required: 0
+
+#  Tls_prefer_server_ciphers
+#  -------------------------
+#    Prefer the ciphers on the server side instead of client side. 
+#tls_prefer_server_ciphers: 0
+
+#  Tls_server_ca_dir
+#  -----------------
+#    Path to a directory with CA certificates used to verify certificates
+#    offered by the server, when cyrus acts as client. This directory must
+#    have filenames with the hashed value of the certificates (see
+#    openssl(1)). 
+#tls_server_ca_dir: <none>
+
+#  Tls_server_ca_file
+#  ------------------
+#    Path to a file containing CA certificates used to verify certificates
+#    offered by the server, when cyrus acts as client. 
+#tls_server_ca_file: <none>
+
+#  Tls_server_cert
+#  ---------------
+#    File containing the certificate, including the full chain, presented to clients.
+#    Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+#    comma without spaces. 
+#tls_server_cert: <none>
+
+#  Tls_server_dhparam
+#  ------------------
+#    File containing the DH parameters belonging to the certificate in
+#    tls_server_cert. 
+#tls_server_dhparam: <none>
+
+#  Tls_server_key
+#  --------------
+#    File containing the private key belonging to the certificate in
+#    tls_server_cert.  If not set, tls_server_cert must contain both private and
+#    public key.  Two files with keys can be set, if two certifates are used, in
+#    which case the files must be separated with comma without spaces 
+#tls_server_key: <none>
+
+#  Tls_sessions_db
+#  ---------------
+#    The cyrusdb backend to use for the TLS cache. 
+#    Allowed values: skiplist, sql, twoskip, zeroskip
+#tls_sessions_db: twoskip
+
+#  Tls_sessions_db_path
+#  --------------------
+#    The absolute path to the TLS sessions db file. If not specified,
+#    will be configdirectory/tls_sessions.db 
+#tls_sessions_db_path: <none>
+
+#  Tls_session_timeout
+#  -------------------
+#    The length of time that a TLS session will be cached for later
+#    reuse.  The maximum value is 24 hours, also the default.  A
+#    value of 0 will disable session caching.
+#    #
+#    For backward compatibility, if no unit is specified, minutes is
+#    assumed. 
+#tls_session_timeout: 24h
+
+#  Tls_versions
+#  ------------
+#    A list of SSL/TLS versions to not disable. Cyrus IMAP SSL/TLS starts
+#    with all protocols, and subtracts protocols not in this list. Newer
+#    versions of SSL/TLS will need to be added here to allow them to get
+#    disabled. 
+#tls_versions: tls1_0 tls1_1 tls1_2 tls1_3
+
+#  Uidl_format
+#  -----------
+#    Choose the format for UIDLs in pop3.  Possible values are "uidonly",
+#    "cyrus", "dovecot" and "courier".  "uidonly" forces the old default
+#    of UID, "cyrus" is UIDVALIDITY.UID.  Dovecot is 8 digits of leading
+#    hex (lower case) each UID UIDVALIDITY. Courier is UIDVALIDITY-UID. 
+#    Allowed values: uidonly, cyrus, dovecot, courier
+#uidl_format: cyrus
+
+#  Umask
+#  -----
+#    The umask value used by various Cyrus IMAP programs. 
+#umask: 077
+
+#  Userdeny_db
+#  -----------
+#    The cyrusdb backend to use for the user access list. 
+#    Allowed values: flat, skiplist, sql, twoskip, zeroskip
+#userdeny_db: flat
+
+#  Userdeny_db_path
+#  ----------------
+#    The absolute path to the userdeny db file.  If not specified,
+#    will be configdirectory/user_deny.db 
+#userdeny_db_path: <none>
+
+#  Username_tolower
+#  ----------------
+#    Convert usernames to all lowercase before login/authentication.  This
+#    is useful with authentication backends which ignore case during
+#    username lookups (such as LDAP).  
+#username_tolower: 1
+
+#  Userprefix
+#  ----------
+#    If using the alternate IMAP namespace, the prefix for the other users
+#    namespace.  The hierarchy delimiter will be automatically appended. 
+#userprefix: Other Users
+
+#  Unix_group_enable
+#  -----------------
+#    Should we look up groups when using auth_unix (disable this if you are
+#    not using groups in ACLs for your IMAP server, and you are using auth_unix
+#    with a backend (such as LDAP) that can make getgrent() calls very
+#    slow) 
+#unix_group_enable: 1
+
+#  Unixhierarchysep
+#  ----------------
+#    Use the UNIX separator character '/' for delimiting levels of
+#    mailbox hierarchy.  Turn off to use the netnews separator
+#    character '.'. Note that with the newnews separator, no dots may
+#    occur in mailbox names.  The default switched in 3.0 from off to on. 
+#unixhierarchysep: 1
+
+#  Virtdomains
+#  -----------
+#    Configure virtual domain support.
+#    #
+#    off
+#        Cyrus does not know or care about domains. Only the local part of email
+#        addresses is ever considered.  This is not recommended for any deployment,
+#        but is currently the default.
+#    userid
+#        The user's domain is determined by splitting a fully qualified userid at the
+#        last '@' or '%' symbol.  If the userid is unqualified, the defaultdomain
+#        will be used.  This is the recommended configuration for all deployments.
+#        If you wish to provide calendaring services you must use this configuration.
+#    on
+#        Fully qualified userids are respected, as per "userid".  Unqualified userids
+#        will have their domain determined by doing a reverse lookup on the IP address
+#        of the incoming network interface, or if no record is found, the
+#        defaultdomain will be used.
+
+#        #
+
+#        Allowed values: off, userid, on
+#virtdomains: off
+
+#  Virusscan_notification_subject
+#  ------------------------------
+#    The text used in the subject of email notifications created by
+#    cyr_virusscan(8) when deleting infected mail. 
+#virusscan_notification_subject: Automatically deleted mail
+
+#  Virusscan_notification_template
+#  -------------------------------
+#    The absolute path to a file containing a template to use to describe
+#    infected messages that have been deleted by cyr_virusscan(8).
+#    See cyr_virusscan(8) for specification of the format of this file.
+#    If not specified, the builtin default template will be used. 
+#virusscan_notification_template: <none>
+
+#  Xbackup_enabled
+#  ---------------
+#    Enable support for the XBACKUP command in imapd.  If enabled, admin
+#    users can use this command to provoke a replication of specified users
+#    to the named backup channel. 
+#xbackup_enabled: 0
+
+#  Xlist-flag
+#  ----------
+#    Set the special-use flag flag on the specified folder when it
+#    is autocreated (see the autocreate_inbox_folders option).  For
+#    example, if xlist-junk: Spam is set, and the folder Spam
+#    is autocreated, the special-use flag \Junk will be set on it.
+#    #
+#    (This option is so named for backward compatibility with old config
+#    files.)
+
+#xlist-flag: <none>
+
+#  Lmtp_catchall_mailbox
+#  ---------------------
+#    Mail sent to mailboxes which do not exist, will be delivered to
+#    this user.  NOTE: This must be an existing local user name with an
+#    INBOX, NOT an email address! 
+#lmtp_catchall_mailbox: <none>
+
+#  Zoneinfo_db
+#  -----------
+#    The cyrusdb backend to use for zoneinfo.  This database is used by the
+#    "tzdist" http_modules, and is managed by ctl_zoneinfo(8).
+#    Allowed values: flat, skiplist, twoskip, zeroskip
+#zoneinfo_db: twoskip
+
+#  Zoneinfo_db_path
+#  ----------------
+#    The absolute path to the zoneinfo db file.  If not specified,
+#    will be configdirectory/zoneinfo.db 
+#zoneinfo_db_path: <none>
+
+#  Zoneinfo_dir
+#  ------------
+#    The absolute path to the zoneinfo directory, containing timezone
+#    definitions as generated by the vzic tool.  If not specified, whatever
+#    definitions libical finds will be used.
+#    #
+#    If you are providing a Time Zone Data Distribution Service (i.e. you have
+#    "tzdist" listed in http_modules), then this configuration option MUST
+#    be specified. 
+#zoneinfo_dir: <none>
+
+#  Object_storage_enabled
+#  ----------------------
+#    Is Object storage enabled for this server.  You also need to have
+#    archiving enabled and archivepartition for the mailbox.
+#    Only email files will be stored on object Storage archive partition will be
+#    used to store any other files 
+#object_storage_enabled: 0
+
+#  Object_storage_dummy_spool
+#  --------------------------
+#    Dummy object storage spool; this is for test only.
+#    Spool where user directory (container) will be created to store all emails
+#    in a flat structure  
+#object_storage_dummy_spool: <none>
+
+#  Openio_namespace
+#  ----------------
+#    The OpenIO namespace used to store archived email messages. A namespace
+#    identifies the physical platform cyrus must contact. This directive is used
+#    by the OpenIO's SDK to locate its platform entry point. 
+#openio_namespace: <none>
+
+#  Openio_account
+#  --------------
+#    The OpenIO account used to account for stored emails. Accounts are unique
+#    in their namespace. They provides virtual partitions, with quotas and QoS
+#    features. 
+#openio_account: <none>
+
+#  Openio_rawx_timeout
+#  -------------------
+#    The OpenIO timeout to query to the RAWX services (default 30 sec). 
+#openio_rawx_timeout: 30s
+
+#  Openio_proxy_timeout
+#  --------------------
+#    The OpenIO timeout to query to the PROXY services (default 5 sec). 
+#openio_proxy_timeout: 5s
+
+#  Openio_autocreate
+#  -----------------
+#    Allow the OpenIO SDK to autocreate containers. Mainly destined to be turned
+#    on development environments. In production, the container should have been
+#    provisioned with the mailboxes. 
+#openio_autocreate: 0
+
+#  Openio_verbosity
+#  ----------------
+#    Sets the logging verbosity of the OpenIO's internal behavior. Admissible
+#    values are: "warning", "notice", "info", "debug", "trace", "quiet".
+#    The default verbosity is "warning". Set to "notice" for a few lines on a
+#    per-client basis. Set to "info" for a few lines on a per-request basis. Set
+#    to "debug" Set to "trace" to activate the underlying libcurl debug
+#    output. Enabling a verbosity higher to equal than "debug" requires
+#    the cyrus to be set in debug mode. The special "quiet" value disables all
+#    kinds of logging at the GLib level. 
+#openio_verbosity: <none>
+
+#  Caringo_hostname
+#  ----------------
+#    The Caringo hostname used to store archived email messages. A hostname
+#    identifies the physical platform cyrus must contact. This directive is used
+#    by the Caringo's SDK (CastorSDK: Caringo Simple Content Storage Protocol (SCSP)
+#    on HTTP 1.1 using a RESTful architecture  
+#caringo_hostname: <none>
+
+#  Caringo_port
+#  ------------
+#    The port of the caringo server (caringo_hostname); default is 80. 
+#caringo_port: 80
+
+#  Fastmailsharing
+#  ---------------
+#    If enabled, use FastMail style sharing (oldschool full server paths) 
+#fastmailsharing: 0
+
+
+#
+#SEE ALSO
+#========
+
+##
+#    imapd(8), pop3d(8), nntpd(8), lmtpd(8),
+#    httpd(8), timsieved(8), idled(8), notifyd(8),
+#    deliver(8), master(8), ciphers(1)
+
+
diff -pruN 3.0.13-5/doc/examples/imapd_conf/murder-backend.conf 3.2.0-3/doc/examples/imapd_conf/murder-backend.conf
--- 3.0.13-5/doc/examples/imapd_conf/murder-backend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/murder-backend.conf	2020-04-08 00:07:13.000000000 +0000
@@ -9,7 +9,7 @@ admins: cyrus murder
 ## Cyrus Aggregation - Murder - backend configuration.
 ## This server will hold the actual mailboxes and may interact with
 ## clients, in addition to frontend proxies.  For more information:
-##   http://cyrusimap.org/imap/reference/admin/murder/murder-installation.html
+## http://www.cyrusimap.org/imap/reference/admin/murder/murder-installation.html
 ###################################################################
 servername: mailbox.example.org
 
diff -pruN 3.0.13-5/doc/examples/imapd_conf/murder-frontend.conf 3.2.0-3/doc/examples/imapd_conf/murder-frontend.conf
--- 3.0.13-5/doc/examples/imapd_conf/murder-frontend.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/murder-frontend.conf	2020-04-08 00:07:13.000000000 +0000
@@ -10,7 +10,7 @@ admins: cyrus murder
 ## This server will merely refer clients to the pertinent backend,
 ## or proxy requests for them, as dictated by local security regime.
 ## For more information:
-##   http://cyrusimap.org/imap/reference/admin/murder/murder-installation.html
+## http://www.cyrusimap.org/imap/reference/admin/murder/murder-installation.html
 ###################################################################
 
 # How this host identifies itself to other members of the murder.
diff -pruN 3.0.13-5/doc/examples/imapd_conf/murder-mupdate.conf 3.2.0-3/doc/examples/imapd_conf/murder-mupdate.conf
--- 3.0.13-5/doc/examples/imapd_conf/murder-mupdate.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/murder-mupdate.conf	2020-04-08 00:07:13.000000000 +0000
@@ -6,7 +6,7 @@ admins: cyrus postman
 
 ###################################################################
 ## Mupdate-master configuration section.  For more information:
-##   http://cyrusimap.org/imap/reference/admin/murder/murder-installation.html
+## http://www.cyrusimap.org/imap/reference/admin/murder/murder-installation.html
 ###################################################################
 servername: postman.example.org
 allowallsubscribe: true
diff -pruN 3.0.13-5/doc/examples/imapd_conf/normal-master.conf 3.2.0-3/doc/examples/imapd_conf/normal-master.conf
--- 3.0.13-5/doc/examples/imapd_conf/normal-master.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/normal-master.conf	2020-04-08 00:07:13.000000000 +0000
@@ -10,7 +10,7 @@ admins: cyrus
 ## This is how the Master (sync client) is defined.  In this example,
 ## we define a pair of replicas, each with its own channel & shutdown
 ## file.  For more details, please see:
-##   http://cyrusimap.org/imap/reference/admin/sop/replication.html
+##   http://www.cyrusimap.org/imap/reference/admin/sop/replication.html
 ###################################################################
 servername: mailbox.example.org
 # sync_authname **MUST** be an "admin" user on the replica.
diff -pruN 3.0.13-5/doc/examples/imapd_conf/normal-replica1.conf 3.2.0-3/doc/examples/imapd_conf/normal-replica1.conf
--- 3.0.13-5/doc/examples/imapd_conf/normal-replica1.conf	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/examples/imapd_conf/normal-replica1.conf	2020-04-08 00:07:13.000000000 +0000
@@ -9,7 +9,7 @@ admins: cyrus mailproxy
 ## Replication support
 ## The Replica (via imap) should identify itself as expected by the
 ## master.  For more details, please see:
-##   http://cyrusimap.org/imap/reference/admin/sop/replication.html
+## http://www.cyrusimap.org/imap/reference/admin/sop/replication.html
 ###################################################################
 servername: mailrepl1.example.org
 
diff -pruN 3.0.13-5/doc/html/.buildinfo 3.2.0-3/doc/html/.buildinfo
--- 3.0.13-5/doc/html/.buildinfo	2019-12-16 04:18:20.000000000 +0000
+++ 3.2.0-3/doc/html/.buildinfo	2020-05-04 04:13:51.000000000 +0000
@@ -1,4 +1,4 @@
 # Sphinx build info version 1
 # This file hashes the configuration used when building these files. When it is not found, a full rebuild will be done.
-config: a6d3b030d2cab7366d185451087e909c
+config: 13add4101b6ba620c3533daf67b7c5f1
 tags: 645f666f9bcd5a90fca523b33c5a78b7
diff -pruN 3.0.13-5/doc/html/contribute.html 3.2.0-3/doc/html/contribute.html
--- 3.0.13-5/doc/html/contribute.html	2019-12-16 04:16:34.000000000 +0000
+++ 3.2.0-3/doc/html/contribute.html	2020-05-04 04:11:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>We need your help &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>We need your help &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="up" title="Developers" href="developers.html"/>
         <link rel="next" title="Documentation" href="imap/developer/documentation.html"/>
         <link rel="prev" title="Developers" href="developers.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="developers.html">Developers</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/contribute.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/contribute.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -792,7 +811,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -812,7 +831,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/developers.html 3.2.0-3/doc/html/developers.html
--- 3.0.13-5/doc/html/developers.html	2019-12-16 04:16:34.000000000 +0000
+++ 3.2.0-3/doc/html/developers.html	2020-05-04 04:11:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Developers &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Developers &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="We need your help" href="contribute.html"/>
         <link rel="prev" title="Why does mail delivery go slow or hang sometimes?" href="imap/reference/faqs/interop-slow-delivery.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Developers</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/developers.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/developers.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -784,13 +803,79 @@
 </li>
 <li class="toctree-l1"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
 </ul>
 </li>
 </ul>
 </div>
+<div class="section" id="cyrus-internals">
+<h2>Cyrus Internals<a class="headerlink" href="#cyrus-internals" title="Permalink to this headline">¶</a></h2>
+<p>These documents are intended for persons interested in contributing to
+the Cyrus IMAP development effort, or for those interested in lower-
+level details about how Cyrus is implemented.</p>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</div>
+<p>This <a class="reference download internal" href="_downloads/master-state-machine.svg" download=""><code class="xref download docutils literal"><span class="pre">diagram</span></code></a> shows
+the Master State Machine.</p>
+</div>
+<div class="section" id="unit-tests">
+<h2>Unit Tests<a class="headerlink" href="#unit-tests" title="Permalink to this headline">¶</a></h2>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html#setting-up-the-machine">3.1. Setting Up The Machine</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html#configure-script">3.2 Configure Script</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html#make">3.3 Make</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html#using-valgrind">3.4 Using Valgrind</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html#the-tests-are-failing">3.5 The Tests Are Failing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</div>
+</div>
 </div>
 
 
@@ -811,7 +896,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 12 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 07 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +916,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/download.html 3.2.0-3/doc/html/download.html
--- 3.0.13-5/doc/html/download.html	2019-12-16 04:16:34.000000000 +0000
+++ 3.2.0-3/doc/html/download.html	2020-05-04 04:11:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Download &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Download &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Get Cyrus" href="imap/download/getcyrus.html"/>
         <link rel="prev" title="What is Cyrus IMAP?" href="index.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Download</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/download.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/download.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -788,19 +807,24 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l1"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -832,7 +856,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 27 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -852,7 +876,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/_downloads/master-state-machine.svg 3.2.0-3/doc/html/_downloads/master-state-machine.svg
--- 3.0.13-5/doc/html/_downloads/master-state-machine.svg	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_downloads/master-state-machine.svg	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,523 @@
+<?xml version="1.0" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<!-- Creator: fig2dev Version 3.2 Patchlevel 5e -->
+<!-- CreationDate: Tue Mar  6 14:12:27 2018 -->
+<!-- Magnification: 1.000 -->
+<svg	xmlns="http://www.w3.org/2000/svg"
+	xmlns:xlink="http://www.w3.org/1999/xlink"
+	width="10.9in" height="7.9in"
+	viewBox="288 453 13042 9534">
+<g style="stroke-width:.025in; fill:none">
+<!-- Line -->
+<polyline points="11175,9225
+11850,9225
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Line -->
+<polyline points="11175,9525
+11850,9525
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line -->
+<polyline points="11175,9825
+11850,9825
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Line: box -->
+<rect x="5175" y="1125" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="825" y="4500" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="10050" y="4575" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="5175" y="8025" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line -->
+<polyline points="5175,1275
+1515,4422
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 1275 - 1413 4509-->
+<polygon points="1496 4397
+1425 4498
+1535 4442
+1496 4397
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,8325
+2412,5780
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 8325 - 2313 5689-->
+<polygon points="2433 5759
+2325 5700
+2392 5803
+2433 5759
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,8850
+1887,5781
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 8850 - 1789 5689-->
+<polygon points="1909 5759
+1801 5700
+1868 5803
+1909 5759
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10050,4800
+2969,4800
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 10050 4800 - 2835 4800-->
+<polygon points="2971 4770
+2851 4800
+2971 4830
+2971 4770
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="1350,5700
+1350,6300
+525,6300
+525,5325
+705,5325
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 525 5325 - 840 5325-->
+<polygon points="704 5355
+824 5325
+704 5295
+704 5355
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="975,2250
+975,4380
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 975 2250 - 975 4515-->
+<polygon points="945 4379
+975 4499
+1005 4379
+945 4379
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="1575,5700
+1575,6675
+300,6675
+300,5100
+705,5100
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 300 5100 - 840 5100-->
+<polygon points="704 5130
+824 5100
+704 5070
+704 5130
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,2025
+10257,4499
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7200 2025 - 10361 4584-->
+<polygon points="10235 4521
+10348 4574
+10273 4475
+10235 4521
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7275,1575
+10783,4498
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7275 1575 - 10886 4584-->
+<polygon points="10762 4520
+10874 4574
+10801 4474
+10762 4520
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,1875
+2338,4420
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 1875 - 2238 4510-->
+<polygon points="2319 4396
+2250 4499
+2359 4441
+2319 4396
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10050,5400
+2969,5400
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 10050 5400 - 2835 5400-->
+<polygon points="2971 5370
+2851 5400
+2971 5430
+2971 5370
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10200,5775
+7290,8247
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10200 5775 - 7188 8334-->
+<polygon points="7272 8223
+7200 8324
+7310 8269
+7272 8223
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,8400
+7200,8625
+10409,5852
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7200 8625 - 10511 5765-->
+<polygon points="10427 5877
+10499 5776
+10388 5831
+10427 5877
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,8775
+10425,8775
+10929,5892
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10425 8775 - 10952 5760-->
+<polygon points="10957 5899
+10949 5776
+10898 5889
+10957 5899
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5700,9225
+5700,9975
+3975,9975
+3975,9000
+5055,9000
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 3975 9000 - 5190 9000-->
+<polygon points="5054 9030
+5174 9000
+5054 8970
+5054 9030
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5850,9225
+5850,9975
+7575,9975
+7575,9075
+7319,9075
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7575 9075 - 7185 9075-->
+<polygon points="7321 9045
+7201 9075
+7321 9105
+7321 9045
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="3975,750
+5475,750
+5475,1005
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 5475 750 - 5475 1140-->
+<polygon points="5445 1004
+5475 1124
+5505 1004
+5445 1004
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="6300,750
+5775,750
+5775,1005
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 5775 750 - 5775 1140-->
+<polygon points="5745 1004
+5775 1124
+5805 1004
+5745 1004
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11400,4575
+11400,3900
+13050,3900
+13050,4875
+12194,4875
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 13050 4875 - 12060 4875-->
+<polygon points="12196 4845
+12076 4875
+12196 4905
+12196 4845
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11175,5775
+10725,8925
+7319,8925
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10725 8925 - 7185 8925-->
+<polygon points="7321 8895
+7201 8925
+7321 8955
+7321 8895
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11325,5775
+11325,6450
+13050,6450
+13050,5550
+12194,5550
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 13050 5550 - 12060 5550-->
+<polygon points="12196 5520
+12076 5550
+12196 5580
+12196 5520
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10800,2700
+10800,4125
+11165,4490
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 10800 4125 - 11260 4585-->
+<polygon points="11142 4510
+11249 4574
+11185 4467
+11142 4510
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5550,2325
+5550,7905
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 5550 2325 - 5550 8040-->
+<polygon points="5520 7904
+5550 8024
+5580 7904
+5520 7904
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="6600,2325
+6600,7905
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 6600 2325 - 6600 8040-->
+<polygon points="6570 7904
+6600 8024
+6630 7904
+6570 7904
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Text -->
+<g transform="translate(3516,3741) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+</g><!-- Text -->
+<g transform="translate(3675,3900) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive--</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="4050" y="9675" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection</text>
+<!-- Text -->
+<text xml:space="preserve" x="4050" y="9900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+<!-- Text -->
+<g transform="translate(2797,7041) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+</g><!-- Text -->
+<g transform="translate(2638,7200) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive--</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="2100" y="600" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Child in illegal state detected</text>
+<!-- Text -->
+<text xml:space="preserve" x="2100" y="825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">(via message handling)</text>
+<!-- Text -->
+<text xml:space="preserve" x="11100" y="3600" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="11100" y="3825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+<!-- Text -->
+<g transform="translate(8210,7116) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable(service)</text>
+</g><!-- Text -->
+<g transform="translate(8369,7275) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">readyworkers--</text>
+</g><!-- Text -->
+<g transform="translate(9055,7470) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+</g><!-- Text -->
+<g transform="translate(9214,7630) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">readyworkers++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="8100" y="8400" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="8625" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++ readyworkers++</text>
+<!-- Text -->
+<g transform="translate(8484,2016) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+</g><!-- Text -->
+<g transform="translate(8325,2175) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="11925" y="9825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Initial States</text>
+<!-- Text -->
+<text xml:space="preserve" x="11925" y="9525" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Messages</text>
+<!-- Text -->
+<text xml:space="preserve" x="11925" y="9225" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Signals</text>
+<!-- Text -->
+<text xml:space="preserve" x="9750" y="750" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="432" text-anchor="start">Cyrus Master</text>
+<!-- Text -->
+<text xml:space="preserve" x="9750" y="1350" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="432" text-anchor="start">State Machine</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="9225" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="9450" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++ readyworkers--</text>
+<!-- Text -->
+<text xml:space="preserve" x="10050" y="2550" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">New Service (nactive++)</text>
+<!-- Text -->
+<text xml:space="preserve" x="10050" y="2775" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">or Event</text>
+<!-- Text -->
+<text xml:space="preserve" x="3446" y="4628" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive-- readyworkers--</text>
+<!-- Text -->
+<text xml:space="preserve" x="3446" y="4403" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+<!-- Text -->
+<g transform="translate(6900,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection(service)</text>
+</g><!-- Text -->
+<g transform="translate(7125,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="1350" y="5250" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Dead</text>
+<!-- Text -->
+<text xml:space="preserve" x="5475" y="1875" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Unknown</text>
+<!-- Text -->
+<text xml:space="preserve" x="5775" y="8775" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Busy</text>
+<!-- Text -->
+<text xml:space="preserve" x="10500" y="5325" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Ready</text>
+<!-- Text -->
+<text xml:space="preserve" x="675" y="6150" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">(Any)</text>
+<!-- Text -->
+<text xml:space="preserve" x="450" y="1875" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unregistered Child</text>
+<!-- Text -->
+<text xml:space="preserve" x="675" y="2100" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD</text>
+<!-- Text -->
+<text xml:space="preserve" x="375" y="6900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD</text>
+<!-- Text -->
+<g transform="translate(2850,3225) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+</g><!-- Text -->
+<g transform="translate(3300,6450) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="6075" y="9900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable</text>
+<!-- Text -->
+<text xml:space="preserve" x="6375" y="825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Message from unknown child</text>
+<!-- Text -->
+<text xml:space="preserve" x="11550" y="6300" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+<!-- Text -->
+<g transform="translate(7950,3000) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="9900" y="1650" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">based on a sketch by hmh@debian.org</text>
+<!-- Text -->
+<text xml:space="preserve" x="3450" y="5700" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+<!-- Text -->
+<g transform="translate(5775,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable(service)</text>
+</g></g>
+</svg>
diff -pruN 3.0.13-5/doc/html/genindex.html 3.2.0-3/doc/html/genindex.html
--- 3.0.13-5/doc/html/genindex.html	2019-12-16 04:18:20.000000000 +0000
+++ 3.2.0-3/doc/html/genindex.html	2020-05-04 04:13:51.000000000 +0000
@@ -9,7 +9,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Index &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Index &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -38,7 +38,7 @@
         <link rel="index" title="Index"
               href="#"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -128,19 +128,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -157,22 +162,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -329,19 +331,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -390,6 +392,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -417,7 +420,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -506,34 +509,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -550,6 +525,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -566,10 +542,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -582,10 +556,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -646,6 +618,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -665,9 +638,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -725,7 +744,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -745,13 +764,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li></li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/genindex.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/genindex.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -821,6 +840,14 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-A">mbpath command line option</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-A">squatter command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/sync_client.html#cmdoption-sync_client-A">sync_client command line option</a>
   </dt>
 
@@ -844,7 +871,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-a">lmtpd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-a">lmtpd command line option</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-a">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-a">[2]</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-a">mbpath command line option</a>
   </dt>
 
         
@@ -919,35 +950,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-a">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-a">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-a">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-a">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-a">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-a">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-a">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-a">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-a">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-a">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-a">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-a">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-a">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-a">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-a">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-a">[7]</a>
   </dt>
 
       </dl></dd>
@@ -1058,41 +1061,13 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-c">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-c">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-c">lmtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-c">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-c">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-c">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-c">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-c">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-c">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-c">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-c">[7]</a>
   </dt>
 
         
   <dt><a href="imap/reference/manpages/systemcommands/mbexamine.html#cmdoption-mbexamine-c">mbexamine command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-c">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-c">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-c">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-c">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-c">smtptest command line option</a>
-  </dt>
-
       </dl></dd>
       
   <dt>
@@ -1301,7 +1276,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-C">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-C">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-C">[1]</a>
   </dt>
 
         
@@ -1309,7 +1284,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-C">lmtpd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-C">lmtpd command line option</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-C">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-C">[2]</a>
   </dt>
 
         
@@ -1341,10 +1316,6 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-proxyd-C">proxyd command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/ptdump.html#cmdoption-ptdump-C">ptdump command line option</a>
   </dt>
 
@@ -1416,11 +1387,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-D">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-D">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-D">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-D">lmtpd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-D">lmtpd command line option</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-D">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-D">[2]</a>
   </dt>
 
         
@@ -1428,6 +1399,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-D">mbpath command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/nntpd.html#cmdoption-nntpd-D">nntpd command line option</a>
   </dt>
 
@@ -1666,35 +1641,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-f">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-f">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-f">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-f">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-f">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-f">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-f">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-f">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-f">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-f">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-f">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-f">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-f">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-f">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-f">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-f">[7]</a>
   </dt>
 
       </dl></dd>
@@ -1860,11 +1807,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-i">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-i">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-i">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-i">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-i">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-i">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-i">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-i">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-i">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-i">[7]</a>
   </dt>
 
         
@@ -1872,34 +1815,6 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-i">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-i">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-i">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-i">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/systemcommands/rehash.html#cmdoption-rehash-i">rehash command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-i">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-i">smtptest command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-i">squatter command line option</a>
   </dt>
 
@@ -1911,7 +1826,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-I">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-I">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-I">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-I">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-I">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-I">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-I">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-I">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-I">[7]</a>
   </dt>
 
       </dl></dd>
@@ -1928,12 +1843,12 @@
       </dl></dd>
       
   <dt>
-    -I file
+    -i | -I
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-I">squatter command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/rehash.html#cmdoption-rehash-i">rehash command line option</a>
   </dt>
 
       </dl></dd>
@@ -1950,62 +1865,45 @@
       </dl></dd>
       
   <dt>
-    -j  janitor full-sweeps per second
+    -j
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/master.html#cmdoption-master-j">master command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_backups.html#cmdoption-ctl_backups-j">ctl_backups command line option</a>
   </dt>
 
       </dl></dd>
       
   <dt>
-    -k
+    -j  janitor full-sweeps per second
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/pop3d.html#cmdoption-pop3d-k">pop3d command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/master.html#cmdoption-master-j">master command line option</a>
   </dt>
 
       </dl></dd>
       
   <dt>
-    -k  num
+    -k
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-k">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-k">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-k">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-k">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-k">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-k">pop3test command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/pop3d.html#cmdoption-pop3d-k">pop3d command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-k">sivtest command line option</a>
+      </dl></dd>
+      
+  <dt>
+    -k  num
   </dt>
 
+      <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-k">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-k">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-k">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-k">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-k">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-k">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-k">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-k">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-k">[7]</a>
   </dt>
 
       </dl></dd>
@@ -2058,6 +1956,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-l">mbpath command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/sync_client.html#cmdoption-sync_client-l">sync_client command line option</a>
   </dt>
 
@@ -2095,35 +1997,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-l">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-l">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-l">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-l">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-l">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-l">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-l">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-l">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-l">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-l">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-l">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-l">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-l">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-l">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-l">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-l">[7]</a>
   </dt>
 
       </dl></dd>
@@ -2138,6 +2012,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-M">mbpath command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/reconstruct.html#cmdoption-reconstruct-M">reconstruct command line option</a>
   </dt>
 
@@ -2247,41 +2125,13 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-m">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-m">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-m">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-m">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-m">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-m">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-m">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-m">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-m">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-m">[7]</a>
   </dt>
 
         
   <dt><a href="imap/reference/manpages/usercommands/installsieve.html#cmdoption-installsieve-m">installsieve command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-m">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-m">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-m">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-m">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-m">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-m">smtptest command line option</a>
-  </dt>
-
       </dl></dd>
       
   <dt>
@@ -2327,6 +2177,8 @@
   </dt>
 
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt>
     -m Mbytes
@@ -2349,8 +2201,6 @@
   </dt>
 
       </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
       
   <dt>
     -N
@@ -2358,7 +2208,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-N">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-N">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-N">[1]</a>
   </dt>
 
       </dl></dd>
@@ -2389,6 +2239,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-n">quota command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/reconstruct.html#cmdoption-reconstruct-n">reconstruct command line option</a>
   </dt>
 
@@ -2423,35 +2277,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-n">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-n">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-n">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-n">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-n">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-n">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-n">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-n">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-n">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-n">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-n">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-n">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-n">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-n">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-n">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-n">[7]</a>
   </dt>
 
       </dl></dd>
@@ -2545,35 +2371,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-o">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-o">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-o">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-o">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-o">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-o">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-o">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-o">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-o">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-o">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-o">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-o">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-o">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-o">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-o">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-o">[7]</a>
   </dt>
 
       </dl></dd>
@@ -2587,6 +2385,10 @@
   <dt><a href="imap/reference/manpages/systemcommands/ctl_backups.html#cmdoption-ctl_backups-P">ctl_backups command line option</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-P">squatter command line option</a>
+  </dt>
+
       </dl></dd>
       
   <dt>
@@ -2661,50 +2463,22 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-p">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-p">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-p">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-p">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-p">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-p">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-p">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-p">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-p">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-p">[7]</a>
   </dt>
 
         
   <dt><a href="imap/reference/manpages/usercommands/installsieve.html#cmdoption-installsieve-p">installsieve command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-p">lmtptest command line option</a>
+      </dl></dd>
+      
+  <dt>
+    -P  snmp agentx ping interval
   </dt>
 
+      <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-p">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-p">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-p">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-p">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-p">smtptest command line option</a>
-  </dt>
-
-      </dl></dd>
-      
-  <dt>
-    -P  snmp agentx ping interval
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/systemcommands/master.html#cmdoption-master-P">master command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/master.html#cmdoption-master-P">master command line option</a>
   </dt>
 
       </dl></dd>
@@ -2723,7 +2497,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-p">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-p">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-p">[1]</a>
   </dt>
 
         
@@ -2802,7 +2576,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-q">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-q">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-q">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-q">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-q">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-q">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-q">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-q">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-q">[7]</a>
   </dt>
 
         
@@ -2814,14 +2588,6 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-q">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-q">nntptest command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-q">quota command line option</a>
   </dt>
 
@@ -2932,35 +2698,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-r">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-r">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-r">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-r">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-r">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-r">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-r">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-r">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-r">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-r">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-r">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-r">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-r">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-r">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-r">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-r">[7]</a>
   </dt>
 
       </dl></dd>
@@ -2985,6 +2723,14 @@
   <dt><a href="imap/reference/manpages/systemcommands/ctl_backups.html#cmdoption-ctl_backups-S">ctl_backups command line option</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_conversationsdb.html#cmdoption-ctl_conversationsdb-S">ctl_conversationsdb command line option</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-S">mbpath command line option</a>
+  </dt>
+
       </dl></dd>
       
   <dt>
@@ -3001,15 +2747,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-s">httptest command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-s">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-s">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-s">imapd command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-s">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-s">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-s">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-s">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-s">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-s">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-s">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-s">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-s">[7]</a>
   </dt>
 
         
@@ -3025,26 +2767,14 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-s">nntptest command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/pop3d.html#cmdoption-pop3d-s">pop3d command line option</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-s">pop3test command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/reconstruct.html#cmdoption-reconstruct-s">reconstruct command line option</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-s">smtptest command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/sync_client.html#cmdoption-sync_client-s">sync_client command line option</a>
   </dt>
 
@@ -3128,6 +2858,17 @@
       </dl></dd>
       
   <dt>
+    -s version
+  </dt>
+
+      <dd><dl>
+        
+  <dt><a href="imap/reference/manpages/systemcommands/cyr_info.html#cmdoption-cyr_info-s">cyr_info command line option</a>
+  </dt>
+
+      </dl></dd>
+      
+  <dt>
     -T
   </dt>
 
@@ -3159,31 +2900,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-t">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-t">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-t">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-t">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-t">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-t">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-t">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-t">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-t">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-t">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-t">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-t">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-t">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-t">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-t">[7]</a>
   </dt>
 
       </dl></dd>
@@ -3206,11 +2923,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-T">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-T">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-T">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-T">lmtpd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-T">lmtpd command line option</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-T">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-T">[2]</a>
   </dt>
 
         
@@ -3292,6 +3009,10 @@
 
       <dd><dl>
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-U">mbpath command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/reconstruct.html#cmdoption-reconstruct-U">reconstruct command line option</a>
   </dt>
 
@@ -3299,6 +3020,10 @@
   <dt><a href="imap/reference/manpages/systemcommands/restore.html#cmdoption-restore-U">restore command line option</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-U">squatter command line option</a>
+  </dt>
+
       </dl></dd>
       
   <dt>
@@ -3319,6 +3044,14 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-u">mbpath command line option</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-u">quota command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/reconstruct.html#cmdoption-reconstruct-u">reconstruct command line option</a>
   </dt>
 
@@ -3405,41 +3138,13 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-u">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-u">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-u">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-u">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-u">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-u">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-u">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-u">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-u">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-u">[7]</a>
   </dt>
 
         
   <dt><a href="imap/reference/manpages/usercommands/installsieve.html#cmdoption-installsieve-u">installsieve command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-u">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-u">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-u">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-u">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-u">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-u">smtptest command line option</a>
-  </dt>
-
       </dl></dd>
       
   <dt>
@@ -3460,11 +3165,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-U">imapd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-U">imapd command line option</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-U">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-U">lmtpd command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-U">lmtpd command line option</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-U">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-U">[2]</a>
   </dt>
 
         
@@ -3553,11 +3258,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-v">httptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-v">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-v">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-v">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-v">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-v">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-v">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-v">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-v">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-v">[7]</a>
   </dt>
 
         
@@ -3565,22 +3266,6 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-v">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-v">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-v">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-v">pop3test command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/rehash.html#cmdoption-rehash-v">rehash command line option</a>
   </dt>
 
@@ -3589,14 +3274,6 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-v">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-v">smtptest command line option</a>
-  </dt>
-
-        
   <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-v">squatter command line option</a>
   </dt>
 
@@ -3664,10 +3341,6 @@
   <dt><a href="imap/reference/manpages/systemcommands/ctl_mboxlist.html#cmdoption-ctl_mboxlist-w">ctl_mboxlist command line option</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-w">httptest command line option</a>
-  </dt>
-
       </dl></dd>
       
   <dt>
@@ -3709,31 +3382,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-w">imtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-w">lmtptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-w">mupdatetest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-w">nntptest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-w">pop3test command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-w">sivtest command line option</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-w">smtptest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-w">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-w">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-w">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-w">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-w">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-w">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-w">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-w">[7]</a>
   </dt>
 
       </dl></dd>
@@ -3805,7 +3454,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-X">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-X">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-X">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-X">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-X">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-X">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-X">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-X">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-X">[7]</a>
   </dt>
 
       </dl></dd>
@@ -3816,7 +3465,7 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-x">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-x">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-x">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-x">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-x">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-x">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-x">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-x">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-x">[7]</a>
   </dt>
 
       </dl></dd>
@@ -3860,12 +3509,27 @@
 
       <dd><dl>
         
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_mboxlist.html#cmdoption-ctl_mboxlist-y">ctl_mboxlist command line option</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/fetchnews.html#cmdoption-fetchnews-y">fetchnews command line option</a>
   </dt>
 
       </dl></dd>
       
   <dt>
+    -Z
+  </dt>
+
+      <dd><dl>
+        
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-Z">squatter command line option</a>
+  </dt>
+
+      </dl></dd>
+      
+  <dt>
     -z
   </dt>
 
@@ -3875,7 +3539,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-z">imtest command line option</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-z">imtest command line option</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-z">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-z">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-z">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-z">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-z">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-z">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-z">[7]</a>
   </dt>
 
         
@@ -4226,6 +3890,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_backups.html#cmdoption-ctl_backups-j">-j</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/ctl_backups.html#cmdoption-ctl_backups-m">-m</a>
   </dt>
 
@@ -4301,6 +3969,10 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_conversationsdb.html#cmdoption-ctl_conversationsdb-S">-S</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/ctl_conversationsdb.html#cmdoption-ctl_conversationsdb-b">-b</a>
   </dt>
 
@@ -4429,13 +4101,17 @@
   <dt><a href="imap/reference/manpages/systemcommands/ctl_mboxlist.html#cmdoption-ctl_mboxlist-x">-x</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/ctl_mboxlist.html#cmdoption-ctl_mboxlist-y">-y</a>
+  </dt>
+
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/ctl_mboxlist.html#std:cyrusman-ctl_mboxlist(8)">ctl_mboxlist(8)</a>
   </dt>
 
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/ctl_zoneinfo.html#std:cyrusman-ctl_zoneinfo(8)">ctl_zoneinfo(8)</a>
   </dt>
@@ -4682,6 +4358,10 @@
   <dt><a href="imap/reference/manpages/systemcommands/cyr_info.html#cmdoption-cyr_info-n">-n servicename</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/cyr_info.html#cmdoption-cyr_info-s">-s version</a>
+  </dt>
+
       </dl></dd>
       
   <dt><a href="imap/reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a>
@@ -5135,84 +4815,13 @@
   </dt>
 
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/httpd.html#std:cyrusman-httpd(8)">httpd(8)</a>
   </dt>
 
       
-  <dt>
-    httptest command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-l">-l  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-m">-m  mechanism</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-n">-n  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-o">-o  option=value</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-p">-p  port</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-s">-s</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-t">-t  keyfile</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-u">-u  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-v">-v</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-httptest-w">-w</a>
-  </dt>
-
-      </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
-      
   <dt><a href="imap/reference/manpages/usercommands/httptest.html#std:cyrusman-httptest(1)">httptest(1)</a>
   </dt>
 
@@ -5244,31 +4853,31 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-C">-C config-file</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-C">-C config-file</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-C">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-D">-D</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-D">-D</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-D">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-N">-N</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-N">-N</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-N">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-T">-T  timeout</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-T">-T  timeout</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-T">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-U">-U  uses</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-U">-U  uses</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-U">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-p">-p  ssf</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-p">-p  ssf</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-p">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-s">-s</a>
+  <dt><a href="imap/reference/manpages/systemcommands/imapd.html#cmdoption-imapd-s">-s</a>, <a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-imapd-s">[1]</a>
   </dt>
 
       </dl></dd>
@@ -5306,87 +4915,87 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-I">-I  file</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-I">-I  file</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-I">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-I">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-I">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-I">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-I">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-I">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-I">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-X">-X  file</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-X">-X  file</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-X">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-X">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-X">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-X">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-X">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-X">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-X">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-a">-a  userid</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-a">-a  userid</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-a">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-a">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-a">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-a">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-a">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-a">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-a">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-c">-c</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-c">-c</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-c">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-c">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-c">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-c">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-c">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-c">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-c">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-f">-f  file</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-f">-f  file</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-f">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-f">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-f">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-f">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-f">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-f">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-f">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-i">-i</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-i">-i</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-i">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-i">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-i">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-i">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-i">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-i">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-i">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-k">-k  num</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-k">-k  num</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-k">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-k">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-k">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-k">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-k">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-k">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-k">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-l">-l  num</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-l">-l  num</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-l">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-l">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-l">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-l">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-l">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-l">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-l">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-m">-m  mechanism</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-m">-m  mechanism</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-m">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-m">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-m">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-m">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-m">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-m">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-m">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-n">-n  num</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-n">-n  num</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-n">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-n">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-n">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-n">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-n">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-n">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-n">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-o">-o  option=value</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-o">-o  option=value</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-o">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-o">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-o">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-o">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-o">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-o">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-o">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-p">-p  port</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-p">-p  port</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-p">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-p">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-p">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-p">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-p">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-p">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-p">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-q">-q</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-q">-q</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-q">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-q">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-q">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-q">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-q">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-q">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-q">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-r">-r  realm</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-r">-r  realm</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-r">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-r">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-r">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-r">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-r">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-r">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-r">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-s">-s</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-s">-s</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-s">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-s">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-s">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-s">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-s">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-s">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-s">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-t">-t  keyfile</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-t">-t  keyfile</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-t">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-t">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-t">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-t">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-t">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-t">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-t">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-u">-u  userid</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-u">-u  userid</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-u">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-u">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-u">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-u">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-u">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-u">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-u">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-v">-v</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-v">-v</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-v">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-v">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-v">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-v">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-v">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-v">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-v">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-w">-w passwd</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-w">-w passwd</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-w">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-w">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-w">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-w">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-w">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-w">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-w">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-x">-x  file</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-x">-x  file</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-x">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-x">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-x">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-x">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-x">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-x">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-x">[7]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-z">-z</a>
+  <dt><a href="imap/reference/manpages/usercommands/httptest.html#cmdoption-imtest-z">-z</a>, <a href="imap/reference/manpages/usercommands/imtest.html#cmdoption-imtest-z">[1]</a>, <a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-imtest-z">[2]</a>, <a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-imtest-z">[3]</a>, <a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-imtest-z">[4]</a>, <a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-imtest-z">[5]</a>, <a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-imtest-z">[6]</a>, <a href="imap/reference/manpages/usercommands/synctest.html#cmdoption-imtest-z">[7]</a>
   </dt>
 
       </dl></dd>
@@ -5585,26 +5194,28 @@
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-C">-C config-file</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-C">-C config-file</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-C">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-C">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-D">-D</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-D">-D</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-D">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-D">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-T">-T  timeout</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-T">-T  timeout</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-T">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-T">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-U">-U  uses</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-U">-U  uses</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-U">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-U">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-a">-a</a>
+  <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#cmdoption-lmtpd-a">-a</a>, <a href="imap/reference/manpages/systemcommands/lmtpproxyd.html#cmdoption-lmtpd-a">[1]</a>, <a href="imap/reference/manpages/systemcommands/pop3proxyd.html#cmdoption-lmtpd-a">[2]</a>
   </dt>
 
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/lmtpd.html#std:cyrusman-lmtpd(8)">lmtpd(8)</a>
   </dt>
@@ -5614,75 +5225,6 @@
   </dt>
 
       
-  <dt>
-    lmtptest command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-l">-l  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-m">-m  mechanism</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-n">-n  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-o">-o  option=value</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-p">-p  port</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-t">-t  keyfile</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-u">-u  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-v">-v</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#cmdoption-lmtptest-w">-w passwd</a>
-  </dt>
-
-      </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
-      
   <dt><a href="imap/reference/manpages/usercommands/lmtptest.html#std:cyrusman-lmtptest(1)">lmtptest(1)</a>
   </dt>
 
@@ -5717,12 +5259,12 @@
 
       
   <dt>
-    mailbox-prefix
+    mailbox-spec
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-arg-mailbox-prefix">quota command line option</a>
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-arg-mailbox-spec">quota command line option</a>
   </dt>
 
       </dl></dd>
@@ -5834,10 +5376,38 @@
 
       <dd><dl>
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-A">-A</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-C">-C config-file</a>
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-D">-D</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-M">-M</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-S">-S</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-U">-U</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-a">-a</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-l">-l</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-m">-m</a>
   </dt>
 
@@ -5849,7 +5419,13 @@
   <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-s">-s</a>
   </dt>
 
+        
+  <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#cmdoption-mbpath-u">-u</a>
+  </dt>
+
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a>
   </dt>
@@ -5888,8 +5464,6 @@
   </dt>
 
       </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
       
   <dt>
     mkimap command line option
@@ -5988,73 +5562,6 @@
   </dt>
 
       
-  <dt>
-    mupdatetest command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-l">-l  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-m">-m  mechanism</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-n">-n  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-o">-o  option=value</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-p">-p  port</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-q">-q</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-u">-u  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-v">-v</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#cmdoption-mupdatetest-w">-w passwd</a>
-  </dt>
-
-      </dl></dd>
-      
   <dt><a href="imap/reference/manpages/usercommands/mupdatetest.html#std:cyrusman-mupdatetest(1)">mupdatetest(1)</a>
   </dt>
 
@@ -6107,88 +5614,13 @@
   </dt>
 
       </dl></dd>
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/nntpd.html#std:cyrusman-nntpd(8)">nntpd(8)</a>
   </dt>
 
       
-  <dt>
-    nntptest command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-l">-l  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-m">-m  mechanism</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-n">-n  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-o">-o  option=value</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-p">-p  port</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-q">-q</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-s">-s</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-t">-t  keyfile</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-u">-u  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-v">-v</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/nntptest.html#cmdoption-nntptest-w">-w passwd</a>
-  </dt>
-
-      </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
-      
   <dt><a href="imap/reference/manpages/usercommands/nntptest.html#std:cyrusman-nntptest(1)">nntptest(1)</a>
   </dt>
 
@@ -6297,84 +5729,13 @@
   <dt><a href="imap/reference/manpages/systemcommands/pop3d.html#std:cyrusman-pop3d(8)">pop3d(8)</a>
   </dt>
 
+  </dl></td>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt><a href="imap/reference/manpages/systemcommands/pop3proxyd.html#std:cyrusman-pop3proxyd(8)">pop3proxyd(8)</a>
   </dt>
 
       
-  <dt>
-    pop3test command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-l">-l  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-m">-m  mechanism</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-n">-n  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-o">-o  option=value</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-p">-p  port</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-s">-s</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-t">-t  keyfile</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-u">-u  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-v">-v</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/pop3test.html#cmdoption-pop3test-w">-w passwd</a>
-  </dt>
-
-      </dl></dd>
-  </dl></td>
-  <td style="width: 33%" valign="top"><dl>
-      
   <dt><a href="imap/reference/manpages/usercommands/pop3test.html#std:cyrusman-pop3test(1)">pop3test(1)</a>
   </dt>
 
@@ -6390,17 +5751,6 @@
 
       </dl></dd>
       
-  <dt>
-    proxyd command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/systemcommands/proxyd.html#cmdoption-proxyd-C">-C config-file</a>
-  </dt>
-
-      </dl></dd>
-      
   <dt><a href="imap/reference/manpages/systemcommands/proxyd.html#std:cyrusman-proxyd(8)">proxyd(8)</a>
   </dt>
 
@@ -6482,11 +5832,19 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-n">-n</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-q">-q</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-arg-mailbox-prefix">mailbox-prefix</a>
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-u">-u</a>
+  </dt>
+
+        
+  <dt><a href="imap/reference/manpages/systemcommands/quota.html#cmdoption-quota-arg-mailbox-spec">mailbox-spec</a>
   </dt>
 
       </dl></dd>
@@ -6596,7 +5954,7 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/rehash.html#cmdoption-rehash-i">-i</a>
+  <dt><a href="imap/reference/manpages/systemcommands/rehash.html#cmdoption-rehash-i">-i | -I</a>
   </dt>
 
         
@@ -6761,831 +6119,749 @@
   </dt>
 
         
-  <dt><a href="imap/developer/libraries/imclient.html#index-0">RFC 2033</a>, <a href="imap/rfc-support.html#index-15">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-15">RFC 1952</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-16">RFC 2034</a>
+  <dt><a href="imap/developer/libraries/imclient.html#index-0">RFC 2033</a>, <a href="imap/rfc-support.html#index-16">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-17">RFC 2045</a>
+  <dt><a href="imap/rfc-support.html#index-17">RFC 2034</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-11">RFC 2046</a>, <a href="imap/rfc-support.html#index-18">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-18">RFC 2045</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-10">RFC 2047</a>, <a href="imap/reference/manpages/systemcommands/deliver.html#index-0">[1]</a>, <a href="imap/rfc-support.html#index-19">[2]</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-14">RFC 2046</a>, <a href="imap/rfc-support.html#index-19">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/developer/libraries/imclient.html#index-1">RFC 2060</a>, <a href="imap/rfc-support.html#index-20">[1]</a>, <a href="imap/rfc-support.html#index-8">[2]</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-13">RFC 2047</a>, <a href="imap/reference/manpages/systemcommands/deliver.html#index-0">[1]</a>, <a href="imap/rfc-support.html#index-20">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-9">RFC 2061</a>
+  <dt><a href="imap/developer/libraries/imclient.html#index-1">RFC 2060</a>, <a href="imap/rfc-support.html#index-21">[1]</a>, <a href="imap/rfc-support.html#index-8">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/access-control.html#index-0">RFC 2086</a>, <a href="imap/reference/admin/access-control.html#index-0">[1]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-1">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-12">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-13">[4]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-6">[5]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-8">[6]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-5">[7]</a>, <a href="imap/rfc-support.html#index-22">[8]</a>
+  <dt><a href="imap/rfc-support.html#index-9">RFC 2061</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-24">RFC 2087</a>
+  <dt><a href="imap/concepts/features/access-control.html#index-0">RFC 2086</a>, <a href="imap/reference/admin/access-control.html#index-0">[1]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-1">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-12">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-13">[4]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-6">[5]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-8">[6]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-6">[7]</a>, <a href="imap/rfc-support.html#index-23">[8]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-25">RFC 2088</a>
+  <dt><a href="imap/rfc-support.html#index-25">RFC 2087</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-17">RFC 2177</a>, <a href="imap/rfc-support.html#index-26">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-26">RFC 2088</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-27">RFC 2192</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-22">RFC 2177</a>, <a href="imap/rfc-support.html#index-27">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/murder/murder-concepts.html#index-0">RFC 2193</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-2">[1]</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-3">[2]</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-4">[3]</a>, <a href="imap/rfc-support.html#index-29">[4]</a>
+  <dt><a href="imap/rfc-support.html#index-28">RFC 2192</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-30">RFC 2195</a>
+  <dt><a href="imap/reference/admin/murder/murder-concepts.html#index-0">RFC 2193</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-2">[1]</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-3">[2]</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-4">[3]</a>, <a href="imap/rfc-support.html#index-30">[4]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-31">RFC 2246</a>
+  <dt><a href="imap/rfc-support.html#index-31">RFC 2195</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-32">RFC 2298</a>
+  <dt><a href="imap/rfc-support.html#index-32">RFC 2246</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/namespaces.html#index-0">RFC 2342</a>, <a href="imap/rfc-support.html#index-33">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-33">RFC 2298</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-34">RFC 2359</a>
+  <dt><a href="imap/concepts/features/namespaces.html#index-0">RFC 2342</a>, <a href="imap/rfc-support.html#index-34">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-36">RFC 2444</a>
+  <dt><a href="imap/rfc-support.html#index-35">RFC 2359</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-37">RFC 2449</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-10">RFC 2392</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-9">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-38">RFC 2518</a>
+  <dt><a href="imap/rfc-support.html#index-37">RFC 2444</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-39">RFC 2595</a>
+  <dt><a href="imap/rfc-support.html#index-38">RFC 2449</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-40">RFC 2617</a>
+  <dt><a href="imap/rfc-support.html#index-39">RFC 2518</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-41">RFC 2817</a>
+  <dt><a href="imap/rfc-support.html#index-40">RFC 2595</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-42">RFC 2818</a>
+  <dt><a href="imap/rfc-support.html#index-41">RFC 2617</a>
   </dt>
 
         
-  <dt><a href="imap/reference/faqs/o-vacation-mailfrom.html#index-0">RFC 2821</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-9">[1]</a>, <a href="imap/rfc-support.html#index-43">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-45">RFC 2817</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-1">RFC 2822</a>, <a href="imap/rfc-support.html#index-44">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-46">RFC 2818</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-45">RFC 2831</a>
+  <dt><a href="imap/reference/faqs/o-vacation-mailfrom.html#index-0">RFC 2821</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-12">[1]</a>, <a href="imap/rfc-support.html#index-47">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-46">RFC 2920</a>
+  <dt><a href="imap/rfc-support.html#index-1">RFC 2822</a>, <a href="imap/rfc-support.html#index-48">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-47">RFC 2971</a>
+  <dt><a href="imap/rfc-support.html#index-49">RFC 2831</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-48">RFC 2980</a>
+  <dt><a href="imap/rfc-support.html#index-50">RFC 2920</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-0">RFC 3028</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-13">[1]</a>, <a href="imap/rfc-support.html#index-49">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-51">RFC 2971</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-50">RFC 3206</a>
+  <dt><a href="imap/rfc-support.html#index-52">RFC 2980</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-51">RFC 3207</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-0">RFC 3028</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-16">[1]</a>, <a href="imap/rfc-support.html#index-53">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-52">RFC 3253</a>
+  <dt><a href="imap/rfc-support.html#index-54">RFC 3206</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-53">RFC 3339</a>
+  <dt><a href="imap/rfc-support.html#index-55">RFC 3207</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-54">RFC 3348</a>
+  <dt><a href="imap/rfc-support.html#index-56">RFC 3253</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-55">RFC 3431</a>
+  <dt><a href="imap/rfc-support.html#index-57">RFC 3339</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-56">RFC 3463</a>
+  <dt><a href="imap/rfc-support.html#index-58">RFC 3348</a>
   </dt>
 
         
-  <dt><a href="imap/developer/documentation.html#index-0">RFC 3501</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-4">[1]</a>, <a href="imap/rfc-support.html#index-10">[2]</a>, <a href="imap/rfc-support.html#index-21">[3]</a>, <a href="imap/rfc-support.html#index-57">[4]</a>
+  <dt><a href="imap/rfc-support.html#index-59">RFC 3431</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-58">RFC 3502</a>
+  <dt><a href="imap/rfc-support.html#index-60">RFC 3463</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-59">RFC 3516</a>
+  <dt><a href="imap/developer/documentation.html#index-0">RFC 3501</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-5">[1]</a>, <a href="imap/rfc-support.html#index-10">[2]</a>, <a href="imap/rfc-support.html#index-22">[3]</a>, <a href="imap/rfc-support.html#index-61">[4]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-60">RFC 3598</a>
+  <dt><a href="imap/rfc-support.html#index-62">RFC 3502</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/server-aggregation.html#index-0">RFC 3656</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-1">[1]</a>, <a href="imap/reference/admin/murder/murder-mupdate-details.html#index-0">[2]</a>, <a href="imap/rfc-support.html#index-62">[3]</a>
+  <dt><a href="imap/rfc-support.html#index-63">RFC 3516</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-63">RFC 3691</a>
+  <dt><a href="imap/rfc-support.html#index-64">RFC 3598</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-64">RFC 3744</a>
+  <dt><a href="imap/concepts/features/server-aggregation.html#index-0">RFC 3656</a>, <a href="imap/reference/admin/murder/murder-concepts.html#index-1">[1]</a>, <a href="imap/reference/admin/murder/murder-mupdate-details.html#index-0">[2]</a>, <a href="imap/rfc-support.html#index-66">[3]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-65">RFC 3834</a>
+  <dt><a href="imap/rfc-support.html#index-67">RFC 3691</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-66">RFC 3848</a>
+  <dt><a href="imap/rfc-support.html#index-68">RFC 3744</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-8">RFC 3894</a>, <a href="imap/rfc-support.html#index-67">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-69">RFC 3834</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-68">RFC 3977</a>
+  <dt><a href="imap/rfc-support.html#index-70">RFC 3848</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-69">RFC 4287</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-8">RFC 3894</a>, <a href="imap/rfc-support.html#index-71">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/access-control.html#index-1">RFC 4314</a>, <a href="imap/reference/admin/access-control.html#index-1">[1]</a>, <a href="imap/reference/admin/access-control/combining-rights.html#index-0">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-0">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-2">[4]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-5">[5]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-7">[6]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-9">[7]</a>, <a href="imap/rfc-support.html#index-23">[8]</a>, <a href="imap/rfc-support.html#index-70">[9]</a>
+  <dt><a href="imap/rfc-support.html#index-72">RFC 3977</a>
   </dt>
 
         
-  <dt><a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-1">RFC 4315</a>, <a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-3">[1]</a>, <a href="imap/rfc-support.html#index-35">[2]</a>, <a href="imap/rfc-support.html#index-71">[3]</a>
+  <dt><a href="imap/rfc-support.html#index-73">RFC 4287</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-72">RFC 4331</a>
+  <dt><a href="imap/concepts/features/access-control.html#index-1">RFC 4314</a>, <a href="imap/reference/admin/access-control.html#index-1">[1]</a>, <a href="imap/reference/admin/access-control/combining-rights.html#index-0">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-0">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-2">[4]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-5">[5]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-7">[6]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-9">[7]</a>, <a href="imap/rfc-support.html#index-24">[8]</a>, <a href="imap/rfc-support.html#index-74">[9]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-73">RFC 4346</a>
+  <dt><a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-1">RFC 4315</a>, <a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-3">[1]</a>, <a href="imap/rfc-support.html#index-36">[2]</a>, <a href="imap/rfc-support.html#index-75">[3]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-74">RFC 4422</a>
+  <dt><a href="imap/rfc-support.html#index-76">RFC 4331</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-75">RFC 4466</a>
+  <dt><a href="imap/rfc-support.html#index-77">RFC 4346</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-76">RFC 4467</a>
+  <dt><a href="imap/rfc-support.html#index-78">RFC 4422</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-78">RFC 4469</a>
+  <dt><a href="imap/rfc-support.html#index-79">RFC 4466</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-79">RFC 4505</a>
+  <dt><a href="imap/rfc-support.html#index-80">RFC 4467</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-80">RFC 4550</a>
+  <dt><a href="imap/rfc-support.html#index-82">RFC 4469</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-81">RFC 4551</a>
+  <dt><a href="imap/rfc-support.html#index-83">RFC 4505</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-82">RFC 4559</a>
+  <dt><a href="imap/rfc-support.html#index-84">RFC 4550</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-83">RFC 4616</a>
+  <dt><a href="imap/rfc-support.html#index-85">RFC 4551</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-84">RFC 4642</a>
+  <dt><a href="imap/rfc-support.html#index-86">RFC 4559</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-85">RFC 4643</a>
+  <dt><a href="imap/rfc-support.html#index-87">RFC 4616</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-86">RFC 4644</a>
+  <dt><a href="imap/rfc-support.html#index-88">RFC 4642</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-87">RFC 4731</a>
+  <dt><a href="imap/rfc-support.html#index-89">RFC 4643</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-88">RFC 4791</a>
+  <dt><a href="imap/rfc-support.html#index-90">RFC 4644</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-89">RFC 4918</a>
+  <dt><a href="imap/rfc-support.html#index-91">RFC 4731</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-90">RFC 4954</a>
+  <dt><a href="imap/rfc-support.html#index-92">RFC 4791</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-91">RFC 4959</a>
+  <dt><a href="imap/rfc-support.html#index-93">RFC 4918</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-92">RFC 4978</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-20">RFC 4954</a>, <a href="imap/rfc-support.html#index-94">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-93">RFC 5032</a>
+  <dt><a href="imap/rfc-support.html#index-95">RFC 4959</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-94">RFC 5034</a>
+  <dt><a href="imap/rfc-support.html#index-96">RFC 4978</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-15">RFC 5051</a>
+  <dt><a href="imap/rfc-support.html#index-97">RFC 5032</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-28">RFC 5092</a>, <a href="imap/rfc-support.html#index-77">[1]</a>, <a href="imap/rfc-support.html#index-95">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-98">RFC 5034</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-97">RFC 5161</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-18">RFC 5051</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-98">RFC 5162</a>
+  <dt><a href="imap/rfc-support.html#index-29">RFC 5092</a>, <a href="imap/rfc-support.html#index-81">[1]</a>, <a href="imap/rfc-support.html#index-99">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-15">RFC 5173</a>, <a href="imap/rfc-support.html#index-99">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-101">RFC 5161</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-160">RFC 5183</a>
+  <dt><a href="imap/rfc-support.html#index-102">RFC 5162</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-3">RFC 5228</a>, <a href="imap/rfc-support.html#index-100">[1]</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-20">RFC 5173</a>, <a href="imap/rfc-support.html#index-103">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/download/release-notes/3.0/x/3.0.0-rc1.html#index-1">RFC 5229</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc2.html#index-1">[1]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc3.html#index-1">[2]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc4.html#index-1">[3]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0.html#index-1">[4]</a>, <a href="imap/reference/admin/sieve.html#index-14">[5]</a>, <a href="imap/rfc-support.html#index-101">[6]</a>
+  <dt><a href="imap/rfc-support.html#index-104">RFC 5183</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-4">RFC 5230</a>, <a href="imap/rfc-support.html#index-102">[1]</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-3">RFC 5228</a>, <a href="imap/rfc-support.html#index-105">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-6">RFC 5231</a>, <a href="imap/rfc-support.html#index-103">[1]</a>
+  <dt><a href="imap/download/release-notes/3.0/x/3.0.0-rc1.html#index-1">RFC 5229</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc2.html#index-1">[1]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc3.html#index-1">[2]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc4.html#index-1">[3]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0.html#index-1">[4]</a>, <a href="imap/reference/admin/sieve.html#index-14">[5]</a>, <a href="imap/rfc-support.html#index-106">[6]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-104">RFC 5232</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-4">RFC 5230</a>, <a href="imap/rfc-support.html#index-107">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-7">RFC 5233</a>, <a href="imap/rfc-support.html#index-105">[1]</a>, <a href="imap/rfc-support.html#index-61">[2]</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-6">RFC 5231</a>, <a href="imap/rfc-support.html#index-108">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-161">RFC 5235</a>
+  <dt><a href="imap/rfc-support.html#index-109">RFC 5232</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-106">RFC 5256</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-7">RFC 5233</a>, <a href="imap/rfc-support.html#index-110">[1]</a>, <a href="imap/rfc-support.html#index-65">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/access-control.html#index-2">RFC 5257</a>, <a href="imap/reference/admin/access-control.html#index-2">[1]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-10">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-11">[3]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-0">[4]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-2">[5]</a>, <a href="imap/rfc-support.html#index-107">[6]</a>
+  <dt><a href="imap/rfc-support.html#index-174">RFC 5235</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-108">RFC 5258</a>
+  <dt><a href="imap/rfc-support.html#index-111">RFC 5256</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-12">RFC 5260</a>, <a href="imap/reference/admin/sieve.html#index-13">[1]</a>, <a href="imap/rfc-support.html#index-109">[2]</a>
+  <dt><a href="imap/concepts/features/access-control.html#index-2">RFC 5257</a>, <a href="imap/reference/admin/access-control.html#index-2">[1]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-10">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-11">[3]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-0">[4]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-2">[5]</a>, <a href="imap/rfc-support.html#index-112">[6]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-162">RFC 5293</a>
+  <dt><a href="imap/rfc-support.html#index-113">RFC 5258</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-110">RFC 5321</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-12">RFC 5260</a>, <a href="imap/reference/admin/sieve.html#index-13">[1]</a>, <a href="imap/rfc-support.html#index-114">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/download/installation/manage-dav.html#index-0">RFC 5322</a>, <a href="imap/download/installation/manage-dav.html#index-1">[1]</a>, <a href="imap/download/installation/manage-dav.html#index-2">[2]</a>, <a href="imap/rfc-support.html#index-111">[3]</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-15">RFC 5293</a>, <a href="imap/rfc-support.html#index-115">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-12">RFC 5335</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-19">RFC 5321</a>, <a href="imap/rfc-support.html#index-116">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-112">RFC 5397</a>
+  <dt><a href="imap/download/installation/manage-dav.html#index-0">RFC 5322</a>, <a href="imap/download/installation/manage-dav.html#index-1">[1]</a>, <a href="imap/download/installation/manage-dav.html#index-2">[2]</a>, <a href="imap/rfc-support.html#index-117">[3]</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/event-notifications.html#index-0">RFC 5423</a>, <a href="imap/reference/admin/eventsource.html#index-0">[1]</a>, <a href="imap/reference/admin/eventsource.html#index-1">[2]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-6">[3]</a>, <a href="imap/rfc-support.html#index-113">[4]</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-15">RFC 5335</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-114">RFC 5429</a>, <a href="imap/rfc-support.html#index-163">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-118">RFC 5397</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-10">RFC 5435</a>, <a href="imap/rfc-support.html#index-115">[1]</a>
+  <dt><a href="imap/concepts/features/event-notifications.html#index-0">RFC 5423</a>, <a href="imap/reference/admin/eventsource.html#index-0">[1]</a>, <a href="imap/reference/admin/eventsource.html#index-1">[2]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-7">[3]</a>, <a href="imap/rfc-support.html#index-119">[4]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-116">RFC 5436</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-16">RFC 5429</a>, <a href="imap/rfc-support.html#index-120">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-164">RFC 5437</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-10">RFC 5435</a>, <a href="imap/rfc-support.html#index-121">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-133">RFC 5463</a>
+  <dt><a href="imap/rfc-support.html#index-122">RFC 5436</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/access-control.html#index-3">RFC 5464</a>, <a href="imap/download/release-notes/2.5/x/2.5.0.html#index-0">[1]</a>, <a href="imap/reference/admin/access-control.html#index-3">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-3">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-4">[4]</a>, <a href="imap/reference/faqs/o-annotations.html#index-0">[5]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-1">[6]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-3">[7]</a>, <a href="imap/rfc-support.html#index-117">[8]</a>
+  <dt><a href="imap/rfc-support.html#index-175">RFC 5437</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/event-notifications.html#index-1">RFC 5465</a>, <a href="imap/reference/admin/eventsource.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-118">[2]</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-19">RFC 5463</a>, <a href="imap/rfc-support.html#index-123">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/download/release-notes/3.0/x/3.0.0-beta2.html#index-0">RFC 5490</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta3.html#index-0">[1]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta4.html#index-0">[2]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta5.html#index-0">[3]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta6.html#index-0">[4]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc1.html#index-0">[5]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc2.html#index-0">[6]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc3.html#index-0">[7]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc4.html#index-0">[8]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0.html#index-0">[9]</a>, <a href="imap/reference/admin/sieve.html#index-9">[10]</a>, <a href="imap/rfc-support.html#index-165">[11]</a>
+  <dt><a href="imap/concepts/features/access-control.html#index-3">RFC 5464</a>, <a href="imap/download/release-notes/2.5/x/2.5.0.html#index-0">[1]</a>, <a href="imap/reference/admin/access-control.html#index-3">[2]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-3">[3]</a>, <a href="imap/reference/admin/access-control/rights-reference.html#index-4">[4]</a>, <a href="imap/reference/faqs/o-annotations.html#index-0">[5]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-1">[6]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-3">[7]</a>, <a href="imap/reference/manpages/configs/imapd.conf.html#index-4">[8]</a>, <a href="imap/rfc-support.html#index-124">[9]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-119">RFC 5524</a>
+  <dt><a href="imap/concepts/features/event-notifications.html#index-1">RFC 5465</a>, <a href="imap/reference/admin/eventsource.html#index-2">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-120">RFC 5536</a>
+  <dt><a href="imap/download/release-notes/3.0/x/3.0.0-beta2.html#index-0">RFC 5490</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta3.html#index-0">[1]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta4.html#index-0">[2]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta5.html#index-0">[3]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-beta6.html#index-0">[4]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc1.html#index-0">[5]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc2.html#index-0">[6]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc3.html#index-0">[7]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0-rc4.html#index-0">[8]</a>, <a href="imap/download/release-notes/3.0/x/3.0.0.html#index-0">[9]</a>, <a href="imap/reference/admin/sieve.html#index-9">[10]</a>, <a href="imap/rfc-support.html#index-125">[11]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-121">RFC 5537</a>
+  <dt><a href="imap/rfc-support.html#index-126">RFC 5524</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-122">RFC 5545</a>
+  <dt><a href="imap/rfc-support.html#index-127">RFC 5536</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-123">RFC 5546</a>
+  <dt><a href="imap/rfc-support.html#index-128">RFC 5537</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-124">RFC 5593</a>, <a href="imap/rfc-support.html#index-96">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-129">RFC 5545</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-125">RFC 5689</a>
+  <dt><a href="imap/rfc-support.html#index-130">RFC 5546</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-166">RFC 5703</a>
+  <dt><a href="imap/rfc-support.html#index-100">RFC 5593</a>, <a href="imap/rfc-support.html#index-131">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-1">RFC 5804</a>, <a href="imap/reference/admin/sieve.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-126">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-132">RFC 5689</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-127">RFC 5819</a>
+  <dt><a href="imap/rfc-support.html#index-176">RFC 5703</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-128">RFC 5957</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-1">RFC 5804</a>, <a href="imap/reference/admin/sieve.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-133">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-129">RFC 5995</a>
+  <dt><a href="imap/rfc-support.html#index-134">RFC 5819</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-7">RFC 6047</a>, <a href="imap/rfc-support.html#index-130">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-135">RFC 5957</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-131">RFC 6101</a>
+  <dt><a href="imap/rfc-support.html#index-136">RFC 5995</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-5">RFC 6131</a>, <a href="imap/rfc-support.html#index-132">[1]</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-8">RFC 6047</a>, <a href="imap/rfc-support.html#index-137">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-16">RFC 6154</a>, <a href="imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html#index-0">[1]</a>, <a href="imap/rfc-support.html#index-134">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-138">RFC 6101</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-14">RFC 6203</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-5">RFC 6131</a>, <a href="imap/rfc-support.html#index-139">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-135">RFC 6321</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-17">RFC 6134</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-136">RFC 6350</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-21">RFC 6154</a>, <a href="imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html#index-0">[1]</a>, <a href="imap/rfc-support.html#index-140">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-137">RFC 6352</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-17">RFC 6203</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-138">RFC 6376</a>
+  <dt><a href="imap/rfc-support.html#index-141">RFC 6321</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-167">RFC 6468</a>
+  <dt><a href="imap/rfc-support.html#index-142">RFC 6350</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-168">RFC 6558</a>
+  <dt><a href="imap/rfc-support.html#index-143">RFC 6352</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-139">RFC 6578</a>
+  <dt><a href="imap/rfc-support.html#index-144">RFC 6376</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-140">RFC 6585</a>
+  <dt><a href="imap/rfc-support.html#index-177">RFC 6468</a>
   </dt>
 
         
-  <dt><a href="imap/reference/admin/sieve.html#index-11">RFC 6609</a>, <a href="imap/rfc-support.html#index-141">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-178">RFC 6558</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-142">RFC 6638</a>
+  <dt><a href="imap/rfc-support.html#index-145">RFC 6578</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-143">RFC 6764</a>
+  <dt><a href="imap/rfc-support.html#index-146">RFC 6585</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-169">RFC 6785</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-11">RFC 6609</a>, <a href="imap/rfc-support.html#index-147">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-144">RFC 6797</a>
+  <dt><a href="imap/rfc-support.html#index-148">RFC 6638</a>
   </dt>
 
         
-  <dt><a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-0">RFC 6851</a>, <a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-145">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-149">RFC 6764</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-146">RFC 7230</a>
+  <dt><a href="imap/rfc-support.html#index-179">RFC 6785</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-147">RFC 7231</a>
+  <dt><a href="imap/rfc-support.html#index-150">RFC 6797</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-148">RFC 7232</a>
+  <dt><a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-0">RFC 6851</a>, <a href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-151">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-149">RFC 7233</a>
+  <dt><a href="imap/rfc-support.html#index-152">RFC 7230</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-150">RFC 7234</a>
+  <dt><a href="imap/rfc-support.html#index-153">RFC 7231</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-151">RFC 7235</a>
+  <dt><a href="imap/rfc-support.html#index-154">RFC 7232</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-152">RFC 7238</a>
+  <dt><a href="imap/rfc-support.html#index-155">RFC 7233</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-153">RFC 7239</a>
+  <dt><a href="imap/rfc-support.html#index-156">RFC 7234</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-154">RFC 7240</a>
+  <dt><a href="imap/rfc-support.html#index-157">RFC 7235</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-155">RFC 7265</a>
+  <dt><a href="imap/rfc-support.html#index-158">RFC 7238</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-156">RFC 7529</a>
+  <dt><a href="imap/rfc-support.html#index-159">RFC 7239</a>
   </dt>
 
         
-  <dt><a href="imap/download/installation/http/caldav.html#index-0">RFC 7808</a>, <a href="imap/rfc-support.html#index-157">[1]</a>
+  <dt><a href="imap/rfc-support.html#index-160">RFC 7240</a>
   </dt>
 
         
-  <dt><a href="imap/download/installation/http/caldav.html#index-1">RFC 7809</a>, <a href="imap/download/installation/http/caldav.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-158">[2]</a>
+  <dt><a href="imap/rfc-support.html#index-161">RFC 7265</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-8">RFC 7888</a>
+  <dt><a href="imap/reference/admin/sieve.html#index-18">RFC 7352</a>
   </dt>
 
         
-  <dt><a href="imap/rfc-support.html#index-159">RFC 7953</a>
+  <dt><a href="imap/rfc-support.html#index-162">RFC 7529</a>
   </dt>
 
         
-  <dt><a href="imap/concepts/features/quota.html#index-1">RFC 822</a>, <a href="imap/concepts/overview_and_concepts.html#index-1">[1]</a>, <a href="imap/concepts/overview_and_concepts.html#index-2">[2]</a>, <a href="imap/reference/admin/quotas/quotatypes.html#index-0">[3]</a>, <a href="imap/reference/faqs/interop-8bit.html#index-0">[4]</a>, <a href="imap/reference/faqs/interop-barenewlines.html#index-0">[5]</a>, <a href="imap/rfc-support.html#index-0">[6]</a>
+  <dt><a href="imap/rfc-support.html#index-163">RFC 7540</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/fetchnews.html#index-0">RFC 977</a>
+  <dt><a href="imap/rfc-support.html#index-164">RFC 7615</a>, <a href="imap/rfc-support.html#index-42">[1]</a>
   </dt>
 
-      </dl></dd>
-  </dl></td>
-</tr></table>
-
-<h2 id="S">S</h2>
-<table style="width: 100%" class="indextable genindextable"><tr>
-  <td style="width: 33%" valign="top"><dl>
-      
-  <dt>
-    show
-  </dt>
-
-      <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/cyr_backup.html#cmdoption-arg-show">command line option</a>
+  <dt><a href="imap/rfc-support.html#index-165">RFC 7616</a>, <a href="imap/rfc-support.html#index-43">[1]</a>
   </dt>
 
-      </dl></dd>
-      
-  <dt>
-    sievec command line option
-  </dt>
-
-      <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/sievec.html#cmdoption-sievec-C">-C altconfig</a>
-  </dt>
-
-      </dl></dd>
-      
-  <dt><a href="imap/reference/manpages/systemcommands/sievec.html#std:cyrusman-sievec(8)">sievec(8)</a>
-  </dt>
-
-      
-  <dt><a href="imap/reference/manpages/systemcommands/sieved.html#std:cyrusman-sieved(8)">sieved(8)</a>
-  </dt>
-
-      
-  <dt><a href="imap/reference/manpages/usercommands/sieveshell.html#std:cyrusman-sieveshell(1)">sieveshell(1)</a>
-  </dt>
-
-      
-  <dt>
-    sivtest command line option
-  </dt>
-
-      <dd><dl>
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-c">-c</a>
+  <dt><a href="imap/rfc-support.html#index-166">RFC 7617</a>, <a href="imap/rfc-support.html#index-44">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-f">-f  file</a>
+  <dt><a href="imap/rfc-support.html#index-167">RFC 7694</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-i">-i</a>
+  <dt><a href="imap/rfc-support.html#index-168">RFC 7804</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-k">-k  num</a>
+  <dt><a href="imap/download/installation/http/caldav.html#index-0">RFC 7808</a>, <a href="imap/rfc-support.html#index-169">[1]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-l">-l  num</a>
+  <dt><a href="imap/download/installation/http/caldav.html#index-1">RFC 7809</a>, <a href="imap/download/installation/http/caldav.html#index-2">[1]</a>, <a href="imap/rfc-support.html#index-170">[2]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-m">-m  mechanism</a>
+  <dt><a href="imap/reference/manpages/configs/imapd.conf.html#index-11">RFC 7888</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-n">-n  num</a>
+  <dt><a href="imap/rfc-support.html#index-171">RFC 7932</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-o">-o  option=value</a>
+  <dt><a href="imap/rfc-support.html#index-172">RFC 7953</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-p">-p  port</a>
+  <dt><a href="imap/rfc-support.html#index-173">RFC 8144</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-r">-r  realm</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-t">-t  keyfile</a>
+  <dt><a href="imap/concepts/features/quota.html#index-1">RFC 822</a>, <a href="imap/concepts/overview_and_concepts.html#index-1">[1]</a>, <a href="imap/concepts/overview_and_concepts.html#index-2">[2]</a>, <a href="imap/reference/admin/quotas/quotatypes.html#index-0">[3]</a>, <a href="imap/reference/faqs/interop-8bit.html#index-0">[4]</a>, <a href="imap/reference/faqs/interop-barenewlines.html#index-0">[5]</a>, <a href="imap/rfc-support.html#index-0">[6]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-u">-u  userid</a>
+  <dt><a href="imap/download/release-notes/3.1/x/3.1.9.html#index-0">RFC 8620</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta1.html#index-0">[1]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta2.html#index-0">[2]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta3.html#index-0">[3]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta4.html#index-0">[4]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-rc1.html#index-0">[5]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0.html#index-0">[6]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-v">-v</a>
+  <dt><a href="imap/download/release-notes/3.1/x/3.1.9.html#index-1">RFC 8621</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta1.html#index-1">[1]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta2.html#index-1">[2]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta3.html#index-1">[3]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-beta4.html#index-1">[4]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0-rc1.html#index-1">[5]</a>, <a href="imap/download/release-notes/3.2/x/3.2.0.html#index-1">[6]</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#cmdoption-sivtest-w">-w passwd</a>
+  <dt><a href="imap/reference/manpages/systemcommands/fetchnews.html#index-0">RFC 977</a>
   </dt>
 
       </dl></dd>
-      
-  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#std:cyrusman-sivtest(1)">sivtest(1)</a>
-  </dt>
+  </dl></td>
+</tr></table>
 
+<h2 id="S">S</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
       
   <dt>
-    smmapd command line option
+    show
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-C">-C config-file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-D">-D</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-T">-T  timeout</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-U">-U  uses</a>
+  <dt><a href="imap/reference/manpages/systemcommands/cyr_backup.html#cmdoption-arg-show">command line option</a>
   </dt>
 
       </dl></dd>
       
-  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#std:cyrusman-smmapd(8)">smmapd(8)</a>
-  </dt>
-
-      
   <dt>
-    smtptest command line option
+    sievec command line option
   </dt>
 
       <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-a">-a  userid</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-c">-c</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-f">-f  file</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-i">-i</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-k">-k  num</a>
-  </dt>
-
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-l">-l  num</a>
+  <dt><a href="imap/reference/manpages/systemcommands/sievec.html#cmdoption-sievec-C">-C altconfig</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-m">-m  mechanism</a>
+      </dl></dd>
+      
+  <dt><a href="imap/reference/manpages/systemcommands/sievec.html#std:cyrusman-sievec(8)">sievec(8)</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-n">-n  num</a>
+      
+  <dt><a href="imap/reference/manpages/systemcommands/sieved.html#std:cyrusman-sieved(8)">sieved(8)</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-o">-o  option=value</a>
+      
+  <dt><a href="imap/reference/manpages/usercommands/sieveshell.html#std:cyrusman-sieveshell(1)">sieveshell(1)</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-p">-p  port</a>
+      
+  <dt><a href="imap/reference/manpages/usercommands/sivtest.html#std:cyrusman-sivtest(1)">sivtest(1)</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-r">-r  realm</a>
+      
+  <dt>
+    smmapd command line option
   </dt>
 
+      <dd><dl>
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-s">-s</a>
+  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-C">-C config-file</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-t">-t  keyfile</a>
+  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-D">-D</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-u">-u  userid</a>
+  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-T">-T  timeout</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-v">-v</a>
+  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#cmdoption-smmapd-U">-U  uses</a>
   </dt>
 
-        
-  <dt><a href="imap/reference/manpages/usercommands/smtptest.html#cmdoption-smtptest-w">-w passwd</a>
+      </dl></dd>
+      
+  <dt><a href="imap/reference/manpages/systemcommands/smmapd.html#std:cyrusman-smmapd(8)">smmapd(8)</a>
   </dt>
 
-      </dl></dd>
       
   <dt><a href="imap/reference/manpages/usercommands/smtptest.html#std:cyrusman-smtptest(1)">smtptest(1)</a>
   </dt>
@@ -7597,6 +6873,10 @@
 
       <dd><dl>
         
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-A">-A</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-C">-C config-file</a>
   </dt>
 
@@ -7605,11 +6885,11 @@
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-I">-I file</a>
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-N">-N name</a>
   </dt>
 
         
-  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-N">-N name</a>
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-P">-P</a>
   </dt>
 
         
@@ -7625,10 +6905,18 @@
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-U">-U</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-X">-X</a>
   </dt>
 
         
+  <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-Z">-Z</a>
+  </dt>
+
+        
   <dt><a href="imap/reference/manpages/systemcommands/squatter.html#cmdoption-squatter-a">-a</a>
   </dt>
 
@@ -7997,7 +7285,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team.
+        &copy; Copyright 1993-2018, The Cyrus Team.
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -8017,7 +7305,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/glossary.html 3.2.0-3/doc/html/glossary.html
--- 3.0.13-5/doc/html/glossary.html	2019-12-16 04:16:34.000000000 +0000
+++ 3.2.0-3/doc/html/glossary.html	2020-05-04 04:11:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Glossary &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Glossary &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Glossary</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/glossary.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/glossary.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -928,7 +947,7 @@ refer to a list of <a class="reference i
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -948,7 +967,7 @@ refer to a list of <a class="reference i
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/authentication_and_authorization.html 3.2.0-3/doc/html/imap/concepts/deployment/authentication_and_authorization.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/authentication_and_authorization.html	2019-12-16 04:16:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/authentication_and_authorization.html	2020-05-04 04:11:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Authentication and Authorization &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Authentication and Authorization &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Performance Recommendations" href="performance_recommendations.html"/>
         <link rel="prev" title="Known Protocol Limitations" href="known_protocol_limitations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/authentication_and_authorization.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/authentication_and_authorization.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -819,7 +838,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 08 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 08 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -839,7 +858,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/databases.html 3.2.0-3/doc/html/imap/concepts/deployment/databases.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/databases.html	2019-12-16 04:16:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/databases.html	2020-05-04 04:11:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Databases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Databases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Mailbox Creation Distribution" href="mailbox_creation_distribution.html"/>
         <link rel="prev" title="Deployment Scenarios" href="deployment_scenarios.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/databases.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/databases.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@ Cyrus to automatically convert the file
 <li><a class="reference internal" href="#mailbox-keys-userid-mboxkey">Mailbox Keys (&lt;userid&gt;.mboxkey)</a></li>
 <li><a class="reference internal" href="#seen-state-userid-seen">Seen State (&lt;userid&gt;.seen)</a></li>
 <li><a class="reference internal" href="#subscriptions-userid-sub">Subscriptions (&lt;userid&gt;.sub)</a></li>
-<li><a class="reference internal" href="#search-indexes-cyrus-squat-userid-xapianactive">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive)</a></li>
+<li><a class="reference internal" href="#search-indexes-cyrus-squat-userid-xapianactive-cyrus-indexed-db">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive, cyrus.indexed.db)</a></li>
 </ul>
 <div class="section" id="mailbox-list-mailboxes-db">
 <span id="imap-concepts-deployment-db-mailboxes"></span><h3>Mailbox List (mailboxes.db)<a class="headerlink" href="#mailbox-list-mailboxes-db" title="Permalink to this headline">¶</a></h3>
@@ -814,7 +833,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Type</span> <span class="n">Number</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Partition</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">ACL</span> <span class="p">(</span><span class="n">space</span><span class="o">-</span><span class="n">separated</span> <span class="n">userid</span><span class="o">/</span><span class="n">rights</span> <span class="n">pairs</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#sql">sql</a>.</p>
 </div>
 <div class="section" id="annotations-annotations-db">
 <span id="imap-concepts-deployment-db-annotations"></span><h3>Annotations (annotations.db)<a class="headerlink" href="#annotations-annotations-db" title="Permalink to this headline">¶</a></h3>
@@ -824,7 +843,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Value</span> <span class="n">Size</span> <span class="p">(</span><span class="mi">4</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;&lt;</span><span class="n">Value</span><span class="o">&gt;</span>\<span class="mi">0</span><span class="o">&lt;</span><span class="n">Content</span><span class="o">-</span><span class="n">Type</span><span class="o">&gt;</span>\<span class="mi">0</span><span class="o">&lt;</span><span class="n">Timestamp</span> <span class="p">(</span><span class="mi">4</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a>  (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a>  (default) or <a class="reference internal" href="#skiplist">skiplist</a>.</p>
 </div>
 <div class="section" id="quotas-quotas-db">
 <span id="imap-concepts-deployment-db-quotas"></span><h3>Quotas (quotas.db)<a class="headerlink" href="#quotas-quotas-db" title="Permalink to this headline">¶</a></h3>
@@ -834,7 +853,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Usage</span> <span class="p">(</span><span class="ow">in</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Limit</span> <span class="p">(</span><span class="ow">in</span> <span class="n">Kbytes</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#quotalegacy">quotalegacy</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, <a class="reference internal" href="#twoskip">twoskip</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#quotalegacy">quotalegacy</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#twoskip">twoskip</a>.</p>
 <p><strong>Legacy Quotas</strong></p>
 <p>The legacy quota database uses a distributed system in which each quota root is stored in a separate file named by quota root and the contents had the following format in older versions:</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">&lt;</span><span class="n">Usage</span> <span class="p">(</span><span class="ow">in</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;</span>\<span class="n">n</span>
@@ -852,7 +871,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Timestamp</span> <span class="p">(</span><span class="mi">4</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;&lt;</span><span class="n">Message</span> <span class="n">UID</span> <span class="p">(</span><span class="mi">4</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#sql">sql</a>.</p>
 </div>
 <div class="section" id="tls-cache-tls-sessions-db">
 <span id="imap-concepts-deployment-db-tls"></span><h3>TLS cache (tls_sessions.db)<a class="headerlink" href="#tls-cache-tls-sessions-db" title="Permalink to this headline">¶</a></h3>
@@ -862,7 +881,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Timestamp</span> <span class="p">(</span><span class="mi">4</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;&lt;</span><span class="n">Session</span> <span class="n">Data</span> <span class="p">(</span><span class="n">multi</span><span class="o">-</span><span class="n">byte</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#sql">sql</a>.</p>
 </div>
 <div class="section" id="pts-cache-ptscache-db">
 <span id="imap-concepts-deployment-db-pts"></span><h3>PTS cache (ptscache.db)<a class="headerlink" href="#pts-cache-ptscache-db" title="Permalink to this headline">¶</a></h3>
@@ -872,7 +891,7 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Auth</span> <span class="n">State</span> <span class="p">(</span><span class="n">multi</span><span class="o">-</span><span class="n">byte</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default) or <a class="reference internal" href="#skiplist">skiplist</a>.</p>
 </div>
 <div class="section" id="status-cache-statuscache-db">
 <span id="imap-concepts-deployment-db-status"></span><h3>STATUS cache (statuscache.db)<a class="headerlink" href="#status-cache-statuscache-db" title="Permalink to this headline">¶</a></h3>
@@ -882,23 +901,23 @@ Cyrus to automatically convert the file
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Version</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Bitmask</span> <span class="n">of</span> <span class="n">Items</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Mtime</span> <span class="n">of</span> <span class="n">Index</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Inode</span> <span class="n">of</span> <span class="n">Index</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Size</span> <span class="n">of</span> <span class="n">Index</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;-</span> <span class="n">of</span> <span class="n">Messages</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;-</span> <span class="n">of</span> <span class="n">Recent</span> <span class="n">Messages</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Next</span> <span class="n">UID</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">UID</span> <span class="n">Validity</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;-</span> <span class="n">of</span> <span class="n">Unseen</span> <span class="n">Messages</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Highest</span> <span class="n">Mod</span> <span class="n">Sequence</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#sql">sql</a>.</p>
 </div>
 <div class="section" id="user-access-user-deny-db">
 <span id="imap-concepts-deployment-db-userdeny"></span><h3>User Access (user_deny.db)<a class="headerlink" href="#user-access-user-deny-db" title="Permalink to this headline">¶</a></h3>
-<p>This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of wildmat patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in cyrus.conf(5). The format of each record is as follows:</p>
+<p>This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of <a class="reference external" href="https://tools.ietf.org/html/rfc3977#section-4">wildmat</a> patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in <a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>. The format of each record is as follows:</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">Key</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Userid</span><span class="o">&gt;</span>
 
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Version</span><span class="o">&gt;</span><span class="n">TAB</span><span class="o">&lt;</span><span class="n">Deny</span> <span class="n">List</span> <span class="p">(</span><span class="n">comma</span><span class="o">-</span><span class="n">separated</span> <span class="n">wildmat</span> <span class="n">patterns</span><span class="p">)</span><span class="o">&gt;</span><span class="n">TAB</span><span class="o">&lt;</span><span class="n">Deny</span> <span class="n">Message</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#flat">flat</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, <a class="reference internal" href="#twoskip">twoskip</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#flat">flat</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#twoskip">twoskip</a>.</p>
 </div>
 <div class="section" id="backups-backups-db">
 <span id="imap-concepts-deployment-db-backups"></span><h3>Backups (backups.db)<a class="headerlink" href="#backups-backups-db" title="Permalink to this headline">¶</a></h3>
 <p>This database maps userids to the location of their backup files.  It only exists
 on Cyrus Backup servers (compiled with the <cite>&#8211;enable-backup</cite> configure option).</p>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, <a class="reference internal" href="#twoskip">twoskip</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#twoskip">twoskip</a>.</p>
 </div>
 <div class="section" id="conversations-userid-conversations">
 <span id="imap-concepts-deployment-db-conversations"></span><h3>Conversations (&lt;userid&gt;.conversations)<a class="headerlink" href="#conversations-userid-conversations" title="Permalink to this headline">¶</a></h3>
@@ -906,10 +925,10 @@ on Cyrus Backup servers (compiled with t
 in the past three months, mapping to the conversation IDs in which this message
 ID has been seen, and the timestamp when it was last seen.</p>
 <p>It also has a records for each conversation ID with details about which folders
-have that converations ID in them, and counts of messages and flags.</p>
+have that conversations ID in them, and counts of messages and flags.</p>
 <p>Finally there are records for each folder with the counts of conversations in
 that folder.</p>
-<p>File type can be: <a class="reference internal" href="#skiplist">skiplist</a> (default), <a class="reference internal" href="#sql">sql</a>, <a class="reference internal" href="#twoskip">twoskip</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#skiplist">skiplist</a> (default), <a class="reference internal" href="#sql">sql</a>, or <a class="reference internal" href="#twoskip">twoskip</a>.</p>
 </div>
 <div class="section" id="counters-userid-counters">
 <span id="imap-concepts-deployment-db-counters"></span><h3>Counters (&lt;userid&gt;.counters)<a class="headerlink" href="#counters-userid-counters" title="Permalink to this headline">¶</a></h3>
@@ -920,11 +939,16 @@ that folder.</p>
 <span id="imap-concepts-deployment-db-fetchnews"></span><h3>News database (fetchnews.db)<a class="headerlink" href="#news-database-fetchnews-db" title="Permalink to this headline">¶</a></h3>
 <p>File format not selectable.</p>
 </div>
-<div class="section" id="search-indexes-cyrus-squat-userid-xapianactive">
-<span id="imap-concepts-deployment-db-search"></span><h3>Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive)<a class="headerlink" href="#search-indexes-cyrus-squat-userid-xapianactive" title="Permalink to this headline">¶</a></h3>
-<p>This is either cyrus.squat in each folder, or if you&#8217;re using xapian a single
-&lt;userid&gt;.xapianactive file listing active databases by tier name and number.</p>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<div class="section" id="search-indexes-cyrus-squat-userid-xapianactive-cyrus-indexed-db">
+<span id="imap-concepts-deployment-db-search"></span><h3>Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive, cyrus.indexed.db)<a class="headerlink" href="#search-indexes-cyrus-squat-userid-xapianactive-cyrus-indexed-db" title="Permalink to this headline">¶</a></h3>
+<p>This is either cyrus.squat in each folder, or if you&#8217;re using Xapian a single
+&lt;userid&gt;.xapianactive file listing active databases with tier name and number.</p>
+<p>cyrus.indexed.db is used by the Xapian search engine.  Its file type
+can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, or <code class="docutils literal"><span class="pre">zeroskip</span></code> and is
+determined by <cite>search_indexed_db</cite> in <a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>.</p>
+<p>The xapianactive file contains a space separated list of tiers and databases within
+the tier.  The first element is the active tier/database, to which new entries are
+added by <cite>squatter -R</cite>.</p>
 </div>
 <div class="section" id="zoneinfo-db-zoneinfo-db">
 <span id="imap-concepts-deployment-db-zoneinfo"></span><h3>Zoneinfo db (zoneinfo.db)<a class="headerlink" href="#zoneinfo-db-zoneinfo-db" title="Permalink to this headline">¶</a></h3>
@@ -939,7 +963,7 @@ alias).  The format of each record is as
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Version</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Record</span> <span class="n">Type</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Timestamp</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Data</span> <span class="n">Strings</span> <span class="p">(</span><span class="n">TAB</span><span class="o">-</span><span class="n">separated</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, or <a class="reference internal" href="#skiplist">skiplist</a>.</p>
 </div>
 <div class="section" id="seen-state-userid-seen">
 <span id="imap-concepts-deployment-db-seen"></span><h3>Seen State (&lt;userid&gt;.seen)<a class="headerlink" href="#seen-state-userid-seen" title="Permalink to this headline">¶</a></h3>
@@ -949,7 +973,7 @@ alias).  The format of each record is as
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Version</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Last</span> <span class="n">Read</span> <span class="n">Time</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Last</span> <span class="n">Read</span> <span class="n">UID</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">Last</span> <span class="n">Change</span> <span class="n">Time</span><span class="o">&gt;</span><span class="n">SP</span><span class="o">&lt;</span><span class="n">List</span> <span class="n">of</span> <span class="n">Read</span> <span class="n">UIDs</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#flat">flat</a>, or <a class="reference internal" href="#skiplist">skiplist</a>.</p>
 </div>
 <div class="section" id="subscriptions-userid-sub">
 <span id="imap-concepts-deployment-db-sub"></span><h3>Subscriptions (&lt;userid&gt;.sub)<a class="headerlink" href="#subscriptions-userid-sub" title="Permalink to this headline">¶</a></h3>
@@ -959,7 +983,7 @@ alias).  The format of each record is as
 <span class="n">Data</span><span class="p">:</span> <span class="kc">None</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#flat">flat</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, <a class="reference internal" href="#twoskip">twoskip</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#flat">flat</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#twoskip">twoskip</a>.</p>
 </div>
 <div class="section" id="search-index-db-list-userid-xapianactive">
 <span id="imap-concepts-deployment-db-xapianactive"></span><h3>Search Index DB List (&lt;userid&gt;.xapianactive)<a class="headerlink" href="#search-index-db-list-userid-xapianactive" title="Permalink to this headline">¶</a></h3>
@@ -973,7 +997,7 @@ alias).  The format of each record is as
 <span class="n">Data</span><span class="p">:</span> <span class="o">&lt;</span><span class="n">Version</span> <span class="p">(</span><span class="mi">2</span> <span class="nb">bytes</span><span class="p">)</span><span class="o">&gt;&lt;</span><span class="n">Access</span> <span class="n">Key</span> <span class="p">(</span><span class="n">multi</span><span class="o">-</span><span class="n">byte</span><span class="p">)</span><span class="o">&gt;</span>
 </pre></div>
 </div>
-<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default), <a class="reference internal" href="#skiplist">skiplist</a>, or <a class="reference internal" href="#lmdb">lmdb</a>.</p>
+<p>File type can be: <a class="reference internal" href="#twoskip">twoskip</a> (default) or <a class="reference internal" href="#skiplist">skiplist</a>.</p>
 </div>
 <div class="section" id="dav-index-userid-dav">
 <span id="imap-concepts-deployment-db-userdav"></span><h3>DAV Index (&lt;userid&gt;.dav)<a class="headerlink" href="#dav-index-userid-dav" title="Permalink to this headline">¶</a></h3>
@@ -1058,13 +1082,6 @@ Developers interested in the details can
 data structure. Deprecated in favour of <a class="reference internal" href="#twoskip">Twoskip</a> as it is not robust in
 the face of disk failure.</p>
 </div>
-<div class="section" id="lmdb">
-<h3>lmdb<a class="headerlink" href="#lmdb" title="Permalink to this headline">¶</a></h3>
-<p><a class="reference external" href="http://symas.com/mdb">Lightning Memory-Mapped Database (lmdb)</a> is a
-high-performance transactional key-value store.</p>
-<p>Fast while in memory, but slow when the database is loaded. Best for databases
-that are held open for a long time: <a class="reference internal" href="#mailbox-list-mailboxes-db">Mailbox List (mailboxes.db)</a></p>
-</div>
 <div class="section" id="sql">
 <h3>sql<a class="headerlink" href="#sql" title="Permalink to this headline">¶</a></h3>
 <p>It is possible to store data in a normal relational SQL database. Generally
@@ -1099,7 +1116,7 @@ virtually no lock contention.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 08 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1119,7 +1136,7 @@ virtually no lock contention.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/deployment_scenarios.html 3.2.0-3/doc/html/imap/concepts/deployment/deployment_scenarios.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/deployment_scenarios.html	2019-12-16 04:16:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/deployment_scenarios.html	2020-05-04 04:11:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Deployment Scenarios &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Deployment Scenarios &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Databases" href="databases.html"/>
         <link rel="prev" title="Configuration Guide" href="../deployment.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/deployment_scenarios.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/deployment_scenarios.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -856,7 +875,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 08 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 08 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -876,7 +895,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/known_protocol_limitations.html 3.2.0-3/doc/html/imap/concepts/deployment/known_protocol_limitations.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/known_protocol_limitations.html	2019-12-16 04:16:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/known_protocol_limitations.html	2020-05-04 04:11:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Known Protocol Limitations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Known Protocol Limitations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Authentication and Authorization" href="authentication_and_authorization.html"/>
         <link rel="prev" title="Mailbox Creation Distribution" href="mailbox_creation_distribution.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/known_protocol_limitations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/known_protocol_limitations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/mailbox_creation_distribution.html 3.2.0-3/doc/html/imap/concepts/deployment/mailbox_creation_distribution.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/mailbox_creation_distribution.html	2019-12-16 04:16:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/mailbox_creation_distribution.html	2020-05-04 04:11:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Creation Distribution &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Creation Distribution &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Known Protocol Limitations" href="known_protocol_limitations.html"/>
         <link rel="prev" title="Databases" href="databases.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/mailbox_creation_distribution.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/mailbox_creation_distribution.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1112,7 +1131,7 @@ partition-partb: /path/to/partb</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1132,7 +1151,7 @@ partition-partb: /path/to/partb</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/performance_recommendations.html 3.2.0-3/doc/html/imap/concepts/deployment/performance_recommendations.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/performance_recommendations.html	2019-12-16 04:16:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/performance_recommendations.html	2020-05-04 04:11:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Performance Recommendations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Performance Recommendations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Storage Considerations" href="storage.html"/>
         <link rel="prev" title="Authentication and Authorization" href="authentication_and_authorization.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3 current"><a class="current reference internal" href="#">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/performance_recommendations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/performance_recommendations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -784,6 +803,10 @@
 <p class="last">Cyrus IMAP requires the parent directories to exist, and be writeable by the POSIX user account Cyrus IMAP runs under, prior to starting the <code class="docutils literal"><span class="pre">master</span></code> process.</p>
 </div>
 </div>
+<div class="section" id="certificates">
+<h2>Certificates<a class="headerlink" href="#certificates" title="Permalink to this headline">¶</a></h2>
+<p>Cyrus IMAP can be configured to provide as server two kind of certificates: EC and RSA.  The EC certificates are only sent to the client, if the client supports them.  EC certificates have the advantage of requiring less computational resources compared to RSA, while offering comparatively the same security.</p>
+</div>
 </div>
 
 
@@ -804,7 +827,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 26 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +847,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/storage.html 3.2.0-3/doc/html/imap/concepts/deployment/storage.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/storage.html	2019-12-16 04:16:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/storage.html	2020-05-04 04:11:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Storage Considerations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Storage Considerations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Supported Platforms and System Requirements" href="supported-platforms.html"/>
         <link rel="prev" title="Performance Recommendations" href="performance_recommendations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="current reference internal" href="#">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/storage.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/storage.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1574,7 +1593,7 @@ recover (in time) from the underlying di
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 08 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1594,7 +1613,7 @@ recover (in time) from the underlying di
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment/supported-platforms.html 3.2.0-3/doc/html/imap/concepts/deployment/supported-platforms.html
--- 3.0.13-5/doc/html/imap/concepts/deployment/supported-platforms.html	2019-12-16 04:16:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment/supported-platforms.html	2020-05-04 04:11:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Supported Platforms and System Requirements &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Supported Platforms and System Requirements &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Configuration Guide" href="../deployment.html"/>
         <link rel="next" title="Operations" href="../../../operations.html"/>
         <link rel="prev" title="Storage Considerations" href="storage.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment/supported-platforms.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment/supported-platforms.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -830,16 +849,6 @@
 <div class="section" id="optional-software-components">
 <h3>Optional Software Components<a class="headerlink" href="#optional-software-components" title="Permalink to this headline">¶</a></h3>
 <p>When including the following software components during the build process, and providing the options listed here, additional optional functionality can be implemented;</p>
-<p><strong>Berkeley DB</strong> (Development headers)</p>
-<p>To enable using Berkely DB as a database backend, include the Berkeley DB development headers and make sure to configure Cyrus IMAP with <code class="docutils literal"><span class="pre">--with-bdb</span></code>.</p>
-<p>Berkeley DB Versions and Conversion</p>
-<p>The Cyrus IMAP <code class="docutils literal"><span class="pre">configure</span></code> process attempts to automatically detect and use the latest Berkeley DB technology available on the system. This may, however, not be the same version on your production systems. Since database conversions between versions of the Berkeley DB technology are particularly difficult and therefor NOT considered fully supported, we recommend you do NOT use Berkeley DB.</p>
-<p>Should the Berkeley DB development headers be installed in a non-standard location, or should you need a specific version when multiple versions are available on the system, please consider using any of the following options;</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">--</span><span class="k">with</span><span class="o">-</span><span class="n">bdb</span><span class="o">=</span><span class="n">DIR</span>            <span class="n">use</span> <span class="n">Berkeley</span> <span class="n">DB</span> <span class="p">(</span><span class="ow">in</span> <span class="n">DIR</span><span class="p">)</span> <span class="p">[</span><span class="n">yes</span><span class="p">]</span>
-<span class="o">--</span><span class="k">with</span><span class="o">-</span><span class="n">bdb</span><span class="o">-</span><span class="n">libdir</span><span class="o">=</span><span class="n">DIR</span>     <span class="n">Berkeley</span> <span class="n">DB</span> <span class="n">lib</span> <span class="n">files</span> <span class="n">are</span> <span class="ow">in</span> <span class="n">DIR</span>
-<span class="o">--</span><span class="k">with</span><span class="o">-</span><span class="n">bdb</span><span class="o">-</span><span class="n">incdir</span><span class="o">=</span><span class="n">DIR</span>     <span class="n">Berkeley</span> <span class="n">DB</span> <span class="n">include</span> <span class="n">files</span> <span class="n">are</span> <span class="ow">in</span> <span class="n">DIR</span><span class="o">&lt;/</span><span class="n">screen</span><span class="o">&gt;</span>
-</pre></div>
-</div>
 <p><strong>MySQL</strong> (Development headers)</p>
 <p>To enable using MySQL as a database server backend, include the MySQL development headers and make sure to configure Cyrus IMAP with <code class="docutils literal"><span class="pre">--with-mysql</span></code>.</p>
 <p>Should MySQL - the client libraries or the development headers - be installed in a non-standard location, please consider using any of the following options;</p>
@@ -879,7 +888,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -899,7 +908,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/deployment.html 3.2.0-3/doc/html/imap/concepts/deployment.html
--- 3.0.13-5/doc/html/imap/concepts/deployment.html	2019-12-16 04:16:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/deployment.html	2020-05-04 04:11:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Configuration Guide &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Configuration Guide &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Setup" href="../../setup.html"/>
         <link rel="next" title="Deployment Scenarios" href="deployment/deployment_scenarios.html"/>
-        <link rel="prev" title="Upgrading to 3.0" href="../download/upgrade.html"/> 
+        <link rel="prev" title="Upgrading to 3.2" href="../download/upgrade.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../setup.html">Setup</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/deployment.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/deployment.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@ successful deployment of Cyrus IMAP.</p>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#conversations-userid-conversations">Conversations (&lt;userid&gt;.conversations)</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#counters-userid-counters">Counters (&lt;userid&gt;.counters)</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#news-database-fetchnews-db">News database (fetchnews.db)</a></li>
-<li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#search-indexes-cyrus-squat-userid-xapianactive">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#search-indexes-cyrus-squat-userid-xapianactive-cyrus-indexed-db">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive, cyrus.indexed.db)</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#zoneinfo-db-zoneinfo-db">Zoneinfo db (zoneinfo.db)</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#seen-state-userid-seen">Seen State (&lt;userid&gt;.seen)</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#subscriptions-userid-sub">Subscriptions (&lt;userid&gt;.sub)</a></li>
@@ -821,7 +840,6 @@ successful deployment of Cyrus IMAP.</p>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#flat">Flat</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#twoskip">Twoskip</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#skiplist">Skiplist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#lmdb">lmdb</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#sql">sql</a></li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/databases.html#quotalegacy">quotalegacy</a></li>
 </ul>
@@ -863,6 +881,7 @@ successful deployment of Cyrus IMAP.</p>
 </li>
 <li class="toctree-l1"><a class="reference internal" href="deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l2"><a class="reference internal" href="deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l1"><a class="reference internal" href="deployment/storage.html">Storage Considerations</a><ul>
@@ -904,7 +923,7 @@ successful deployment of Cyrus IMAP.</p>
         <a href="deployment/deployment_scenarios.html" class="btn btn-neutral float-right" title="Deployment Scenarios" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../download/upgrade.html" class="btn btn-neutral" title="Upgrading to 3.0" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../download/upgrade.html" class="btn btn-neutral" title="Upgrading to 3.2" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -913,7 +932,7 @@ successful deployment of Cyrus IMAP.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 17 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 17 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -933,7 +952,7 @@ successful deployment of Cyrus IMAP.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/access-control.html 3.2.0-3/doc/html/imap/concepts/features/access-control.html
--- 3.0.13-5/doc/html/imap/concepts/features/access-control.html	2019-12-16 04:16:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/access-control.html	2020-05-04 04:11:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Access Control &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Access Control &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Sealed System Design" href="sealed-system.html"/>
         <link rel="prev" title="SQL Authentication" href="authentication-sql.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/access-control.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/access-control.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -781,8 +800,6 @@ to information contained within the Cyru
 <li><a class="reference internal" href="../../reference/admin/access-control/identifiers.html#imap-admin-access-control-identifiers"><span class="std std-ref">Access Control Identifier (ACI)</span></a></li>
 </ul>
 </div>
-<div class="toctree-wrapper compound">
-</div>
 <p>Back to <a class="reference internal" href="../features.html#imap-features"><span class="std std-ref">Features</span></a></p>
 </div>
 
@@ -804,7 +821,7 @@ to information contained within the Cyru
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 07 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +841,7 @@ to information contained within the Cyru
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/archiving.html 3.2.0-3/doc/html/imap/concepts/features/archiving.html
--- 3.0.13-5/doc/html/imap/concepts/features/archiving.html	2019-12-16 04:16:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/archiving.html	2020-05-04 04:11:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Archiving &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Archiving &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Quota" href="quota.html"/>
         <link rel="prev" title="Mailbox Metadata Partitions" href="mailbox-metadata-partitions.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/archiving.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/archiving.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -820,10 +839,9 @@ without one there&#8217;s no benefit to
 <p>And to control the criteria used to manage migration of data between
 partitions:</p>
 <blockquote>
-<div><p><code class="docutils literal"><span class="pre">archive_days:</span></code> 7</p>
+<div><p><code class="docutils literal"><span class="pre">archive_days:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>The number of days after which to move messages to the archive partition
-if archiving is enabled</div></blockquote>
+<div>Deprecated in favour of <em>archive_after</em>.</div></blockquote>
 </div></blockquote>
 <blockquote>
 <div><p><code class="docutils literal"><span class="pre">archive_maxsize:</span></code> 1024</p>
@@ -884,7 +902,7 @@ via <code class="docutils literal"><span
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 13 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 13 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -904,7 +922,7 @@ via <code class="docutils literal"><span
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/authentication-kerberos.html 3.2.0-3/doc/html/imap/concepts/features/authentication-kerberos.html
--- 3.0.13-5/doc/html/imap/concepts/features/authentication-kerberos.html	2019-12-16 04:16:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/authentication-kerberos.html	2020-05-04 04:11:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Kerberos Authentication &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Kerberos Authentication &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="LDAP Authentication" href="authentication-ldap.html"/>
         <link rel="prev" title="Features" href="../features.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/authentication-kerberos.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/authentication-kerberos.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -790,7 +809,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -810,7 +829,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/authentication-ldap.html 3.2.0-3/doc/html/imap/concepts/features/authentication-ldap.html
--- 3.0.13-5/doc/html/imap/concepts/features/authentication-ldap.html	2019-12-16 04:16:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/authentication-ldap.html	2020-05-04 04:11:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>LDAP Authentication &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>LDAP Authentication &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="SQL Authentication" href="authentication-sql.html"/>
         <link rel="prev" title="Kerberos Authentication" href="authentication-kerberos.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/authentication-ldap.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/authentication-ldap.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -790,7 +809,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -810,7 +829,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/authentication-sql.html 3.2.0-3/doc/html/imap/concepts/features/authentication-sql.html
--- 3.0.13-5/doc/html/imap/concepts/features/authentication-sql.html	2019-12-16 04:16:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/authentication-sql.html	2020-05-04 04:11:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>SQL Authentication &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>SQL Authentication &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Access Control" href="access-control.html"/>
         <link rel="prev" title="LDAP Authentication" href="authentication-ldap.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/authentication-sql.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/authentication-sql.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -930,7 +949,7 @@ $ <strong class="command">openssl s_clie
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -950,7 +969,7 @@ $ <strong class="command">openssl s_clie
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/automatic-creation-of-mailboxes.html 3.2.0-3/doc/html/imap/concepts/features/automatic-creation-of-mailboxes.html
--- 3.0.13-5/doc/html/imap/concepts/features/automatic-creation-of-mailboxes.html	2019-12-16 04:16:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/automatic-creation-of-mailboxes.html	2020-05-04 04:11:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Automatic Creation of Mailboxes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Automatic Creation of Mailboxes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Mailbox Namespaces" href="namespaces.html"/>
         <link rel="prev" title="Sealed System Design" href="sealed-system.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/automatic-creation-of-mailboxes.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/automatic-creation-of-mailboxes.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -998,7 +1017,7 @@ are exclusively male, this may still app
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1018,7 +1037,7 @@ are exclusively male, this may still app
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/caldav-collections.html 3.2.0-3/doc/html/imap/concepts/features/caldav-collections.html
--- 3.0.13-5/doc/html/imap/concepts/features/caldav-collections.html	2019-12-16 04:16:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/caldav-collections.html	2020-05-04 04:11:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>CalDAV Collections &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>CalDAV Collections &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="DAV Components" href="dav-components.html"/>
         <link rel="prev" title="Event Notifications" href="event-notifications.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/caldav-collections.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/caldav-collections.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,7 +816,7 @@ Outbox, Attachments &amp; Default.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 14 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 14 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -817,7 +836,7 @@ Outbox, Attachments &amp; Default.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/carddav.html 3.2.0-3/doc/html/imap/concepts/features/carddav.html
--- 3.0.13-5/doc/html/imap/concepts/features/carddav.html	2019-12-16 04:16:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/carddav.html	2020-05-04 04:11:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>CardDAV Support &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>CardDAV Support &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Mail Spool Partitions" href="mail-spool-partitions.html"/>
         <link rel="prev" title="DAV Collection Management" href="dav-collection-mgmt.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/carddav.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/carddav.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -790,7 +809,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 14 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 14 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -810,7 +829,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/dav-collection-mgmt.html 3.2.0-3/doc/html/imap/concepts/features/dav-collection-mgmt.html
--- 3.0.13-5/doc/html/imap/concepts/features/dav-collection-mgmt.html	2019-12-16 04:16:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/dav-collection-mgmt.html	2020-05-04 04:11:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>DAV Collection Management &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>DAV Collection Management &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="CardDAV Support" href="carddav.html"/>
         <link rel="prev" title="DAV Components" href="dav-components.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/dav-collection-mgmt.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/dav-collection-mgmt.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@ or address book clients &#8211; or with
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@ or address book clients &#8211; or with
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/dav-components.html 3.2.0-3/doc/html/imap/concepts/features/dav-components.html
--- 3.0.13-5/doc/html/imap/concepts/features/dav-components.html	2019-12-16 04:16:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/dav-components.html	2020-05-04 04:11:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>DAV Components &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>DAV Components &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="DAV Collection Management" href="dav-collection-mgmt.html"/>
         <link rel="prev" title="CalDAV Collections" href="caldav-collections.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/dav-components.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/dav-components.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,7 +819,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -820,7 +839,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/delayed-delete.html 3.2.0-3/doc/html/imap/concepts/features/delayed-delete.html
--- 3.0.13-5/doc/html/imap/concepts/features/delayed-delete.html	2019-12-16 04:16:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/delayed-delete.html	2020-05-04 04:11:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Delayed Delete &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Delayed Delete &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Delayed Expunge" href="delayed-expunge.html"/>
         <link rel="prev" title="Mailbox Distribution" href="mailbox-distribution.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/delayed-delete.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/delayed-delete.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -847,7 +866,7 @@ deleted mailboxes.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -867,7 +886,7 @@ deleted mailboxes.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/delayed-expunge.html 3.2.0-3/doc/html/imap/concepts/features/delayed-expunge.html
--- 3.0.13-5/doc/html/imap/concepts/features/delayed-expunge.html	2019-12-16 04:16:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/delayed-expunge.html	2020-05-04 04:11:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Delayed Expunge &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Delayed Expunge &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Message Annotations (METADATA)" href="message-annotations.html"/>
         <link rel="prev" title="Delayed Delete" href="delayed-delete.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/delayed-expunge.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/delayed-expunge.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -792,22 +811,21 @@ settings in <a class="reference internal
 <div><p><code class="docutils literal"><span class="pre">expunge_mode:</span></code> delayed</p>
 <blockquote>
 <div>The mode in which messages (and their corresponding cache entries)
-are expunged.  &#8220;default&#8221; mode is the old behavior in which the
+are expunged.  &#8220;semidelayed&#8221; mode is the old behavior in which the
 message files are purged at the time of the EXPUNGE, but index
-and cache records are retained to facilitate QRESYNC.  (Note that
-this behaviour is no longer the default, but is so named for historical
-reasons.)  In &#8220;delayed&#8221; mode, which is the default since Cyrus 2.5.0,
+and cache records are retained to facilitate QRESYNC.
+In &#8220;delayed&#8221; mode, which is the default since Cyrus 2.5.0,
 the message files are also retained, allowing unexpunge to
 rescue them.  In &#8220;immediate&#8221; mode, both the message files and the
 index records are removed as soon as possible.  In all cases,
 nothing will be finally purged until all other processes have
 closed the mailbox to ensure they never see data disappear under
-them.  In &#8220;default&#8221; or &#8220;delayed&#8221; mode, a later run of &#8220;cyr_expire&#8221;
+them.  In &#8220;semidelayed&#8221; or &#8220;delayed&#8221; mode, a later run of &#8220;cyr_expire&#8221;
 will clean out the retained records (and possibly message files).
 This reduces the amount of I/O that takes place at the time of
 EXPUNGE and should result in greater responsiveness for the client,
 especially when expunging a large number of messages.
-Allowed values: <em>default</em>, <em>immediate</em>, <em>delayed</em></div></blockquote>
+Allowed values: <em>immediate</em>, <em>semidelayed</em>, <em>delayed</em></div></blockquote>
 </div></blockquote>
 </div></blockquote>
 <div class="admonition seealso">
@@ -840,7 +858,7 @@ Allowed values: <em>default</em>, <em>im
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -860,7 +878,7 @@ Allowed values: <em>default</em>, <em>im
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/duplicate-message-delivery-suppression.html 3.2.0-3/doc/html/imap/concepts/features/duplicate-message-delivery-suppression.html
--- 3.0.13-5/doc/html/imap/concepts/features/duplicate-message-delivery-suppression.html	2019-12-16 04:16:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/duplicate-message-delivery-suppression.html	2020-05-04 04:11:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Duplicate Message Delivery Suppression &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Duplicate Message Delivery Suppression &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Shared Seen State" href="shared-seen-state.html"/>
         <link rel="prev" title="Message Annotations (METADATA)" href="message-annotations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/duplicate-message-delivery-suppression.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/duplicate-message-delivery-suppression.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@ from being posted to the users&#8217; ma
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@ from being posted to the users&#8217; ma
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/event-notifications.html 3.2.0-3/doc/html/imap/concepts/features/event-notifications.html
--- 3.0.13-5/doc/html/imap/concepts/features/event-notifications.html	2019-12-16 04:16:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/event-notifications.html	2020-05-04 04:11:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Event Notifications &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Event Notifications &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="CalDAV Collections" href="caldav-collections.html"/>
         <link rel="prev" title="Server Side Filtering (Sieve)" href="server-side-filtering.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/event-notifications.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/event-notifications.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1769,7 +1788,7 @@ a supported option for third party devel
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 26 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 26 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1789,7 +1808,7 @@ a supported option for third party devel
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/mailbox-annotations.html 3.2.0-3/doc/html/imap/concepts/features/mailbox-annotations.html
--- 3.0.13-5/doc/html/imap/concepts/features/mailbox-annotations.html	2019-12-16 04:16:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/mailbox-annotations.html	2020-05-04 04:11:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Annotations (METADATA) &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Annotations (METADATA) &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Mailbox Distribution" href="mailbox-distribution.html"/>
         <link rel="prev" title="Virtual Domains" href="virtual-domains.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/mailbox-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/mailbox-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -796,7 +815,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/mailbox-distribution.html 3.2.0-3/doc/html/imap/concepts/features/mailbox-distribution.html
--- 3.0.13-5/doc/html/imap/concepts/features/mailbox-distribution.html	2019-12-16 04:16:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/mailbox-distribution.html	2020-05-04 04:11:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Distribution &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Distribution &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Delayed Delete" href="delayed-delete.html"/>
         <link rel="prev" title="Mailbox Annotations (METADATA)" href="mailbox-annotations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/mailbox-distribution.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/mailbox-distribution.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1221,7 +1240,7 @@ creation requests.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1241,7 +1260,7 @@ creation requests.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/mailbox-metadata-partitions.html 3.2.0-3/doc/html/imap/concepts/features/mailbox-metadata-partitions.html
--- 3.0.13-5/doc/html/imap/concepts/features/mailbox-metadata-partitions.html	2019-12-16 04:16:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/mailbox-metadata-partitions.html	2020-05-04 04:11:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Metadata Partitions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Metadata Partitions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Archiving" href="archiving.html"/>
         <link rel="prev" title="Mail Spool Partitions" href="mail-spool-partitions.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/mailbox-metadata-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/mailbox-metadata-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@ default behaviour is to locate <em>all</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 13 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 13 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@ default behaviour is to locate <em>all</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/mail-spool-partitions.html 3.2.0-3/doc/html/imap/concepts/features/mail-spool-partitions.html
--- 3.0.13-5/doc/html/imap/concepts/features/mail-spool-partitions.html	2019-12-16 04:16:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/mail-spool-partitions.html	2020-05-04 04:11:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mail Spool Partitions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mail Spool Partitions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Mailbox Metadata Partitions" href="mailbox-metadata-partitions.html"/>
         <link rel="prev" title="CardDAV Support" href="carddav.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/mail-spool-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/mail-spool-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -864,7 +883,7 @@ themselves could recover from.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 29 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -884,7 +903,7 @@ themselves could recover from.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/message-annotations.html 3.2.0-3/doc/html/imap/concepts/features/message-annotations.html
--- 3.0.13-5/doc/html/imap/concepts/features/message-annotations.html	2019-12-16 04:16:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/message-annotations.html	2020-05-04 04:11:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Message Annotations (METADATA) &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Message Annotations (METADATA) &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Duplicate Message Delivery Suppression" href="duplicate-message-delivery-suppression.html"/>
         <link rel="prev" title="Delayed Expunge" href="delayed-expunge.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/message-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/message-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/namespaces.html 3.2.0-3/doc/html/imap/concepts/features/namespaces.html
--- 3.0.13-5/doc/html/imap/concepts/features/namespaces.html	2019-12-16 04:16:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/namespaces.html	2020-05-04 04:11:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Namespaces &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Namespaces &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Virtual Domains" href="virtual-domains.html"/>
         <link rel="prev" title="Automatic Creation of Mailboxes" href="automatic-creation-of-mailboxes.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/namespaces.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/namespaces.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1099,7 +1118,7 @@ as well.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1119,7 +1138,7 @@ as well.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/quota.html 3.2.0-3/doc/html/imap/concepts/features/quota.html
--- 3.0.13-5/doc/html/imap/concepts/features/quota.html	2019-12-16 04:16:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/quota.html	2020-05-04 04:11:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Quota &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Quota &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Single-Instance Store" href="single-instance-store.html"/>
         <link rel="prev" title="Archiving" href="archiving.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/quota.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/quota.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@ kilobytes used by the individual <span c
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@ kilobytes used by the individual <span c
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/sealed-system.html 3.2.0-3/doc/html/imap/concepts/features/sealed-system.html
--- 3.0.13-5/doc/html/imap/concepts/features/sealed-system.html	2019-12-16 04:16:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/sealed-system.html	2020-05-04 04:11:20.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Sealed System Design &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Sealed System Design &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Automatic Creation of Mailboxes" href="automatic-creation-of-mailboxes.html"/>
         <link rel="prev" title="Access Control" href="access-control.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/sealed-system.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/sealed-system.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@ to count disk usage towards a billing ac
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@ to count disk usage towards a billing ac
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/server-aggregation.html 3.2.0-3/doc/html/imap/concepts/features/server-aggregation.html
--- 3.0.13-5/doc/html/imap/concepts/features/server-aggregation.html	2019-12-16 04:16:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/server-aggregation.html	2020-05-04 04:11:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP Murder (Server Aggregation) &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP Murder (Server Aggregation) &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Concepts" href="../overview_and_concepts.html"/>
         <link rel="prev" title="Single-Instance Store" href="single-instance-store.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/server-aggregation.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/server-aggregation.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1129,7 +1148,7 @@ etc.</td></tr>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1149,7 +1168,7 @@ etc.</td></tr>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/server-side-filtering.html 3.2.0-3/doc/html/imap/concepts/features/server-side-filtering.html
--- 3.0.13-5/doc/html/imap/concepts/features/server-side-filtering.html	2019-12-16 04:16:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/server-side-filtering.html	2020-05-04 04:11:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Server Side Filtering (Sieve) &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Server Side Filtering (Sieve) &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Event Notifications" href="event-notifications.html"/>
         <link rel="prev" title="Shared Seen State" href="shared-seen-state.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/server-side-filtering.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/server-side-filtering.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -790,7 +809,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -810,7 +829,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/shared-seen-state.html 3.2.0-3/doc/html/imap/concepts/features/shared-seen-state.html
--- 3.0.13-5/doc/html/imap/concepts/features/shared-seen-state.html	2019-12-16 04:16:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/shared-seen-state.html	2020-05-04 04:11:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Shared Seen State &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Shared Seen State &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Server Side Filtering (Sieve)" href="server-side-filtering.html"/>
         <link rel="prev" title="Duplicate Message Delivery Suppression" href="duplicate-message-delivery-suppression.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/shared-seen-state.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/shared-seen-state.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@ use-cases.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@ use-cases.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/single-instance-store.html 3.2.0-3/doc/html/imap/concepts/features/single-instance-store.html
--- 3.0.13-5/doc/html/imap/concepts/features/single-instance-store.html	2019-12-16 04:16:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/single-instance-store.html	2020-05-04 04:11:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Single-Instance Store &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Single-Instance Store &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Cyrus IMAP Murder (Server Aggregation)" href="server-aggregation.html"/>
         <link rel="prev" title="Quota" href="quota.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/single-instance-store.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/single-instance-store.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -793,7 +812,7 @@ only one copy is stored on disk.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -813,7 +832,7 @@ only one copy is stored on disk.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features/virtual-domains.html 3.2.0-3/doc/html/imap/concepts/features/virtual-domains.html
--- 3.0.13-5/doc/html/imap/concepts/features/virtual-domains.html	2019-12-16 04:16:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features/virtual-domains.html	2020-05-04 04:11:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Virtual Domains &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Virtual Domains &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Features" href="../features.html"/>
         <link rel="next" title="Mailbox Annotations (METADATA)" href="mailbox-annotations.html"/>
         <link rel="prev" title="Mailbox Namespaces" href="namespaces.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../overview.html">Overview</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features/virtual-domains.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features/virtual-domains.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -993,7 +1012,7 @@ specifying mailboxes outside of the <cod
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 16 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 16 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1013,7 +1032,7 @@ specifying mailboxes outside of the <cod
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/features.html 3.2.0-3/doc/html/imap/concepts/features.html
--- 3.0.13-5/doc/html/imap/concepts/features.html	2019-12-16 04:16:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/features.html	2020-05-04 04:11:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Features &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Features &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Overview" href="../../overview.html"/>
         <link rel="next" title="Kerberos Authentication" href="features/authentication-kerberos.html"/>
         <link rel="prev" title="Overview" href="../../overview.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../overview.html">Overview</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/features.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/features.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -784,6 +803,8 @@ advantages in efficiency, scalability, a
 concurrent read/write connections to the same mailbox are permitted.
 The server supports access control lists on mailboxes and storage
 quotas on mailbox hierarchies.</p>
+<p>Cyrus IMAP provisionally supports the emerging JMAP protocol standards,
+when built for such.</p>
 <p>The following documents show the full power of each feature that is
 included with Cyrus IMAP.</p>
 <p>Exceptions notwithstanding, most of this documentation does not involve
@@ -877,7 +898,7 @@ the <a class="reference internal" href="
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -897,7 +918,7 @@ the <a class="reference internal" href="
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/concepts/overview_and_concepts.html 3.2.0-3/doc/html/imap/concepts/overview_and_concepts.html
--- 3.0.13-5/doc/html/imap/concepts/overview_and_concepts.html	2019-12-16 04:16:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/concepts/overview_and_concepts.html	2020-05-04 04:11:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Concepts &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Concepts &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Overview" href="../../overview.html"/>
         <link rel="next" title="Setup" href="../../setup.html"/>
         <link rel="prev" title="Cyrus IMAP Murder (Server Aggregation)" href="features/server-aggregation.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../overview.html">Overview</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/concepts/overview_and_concepts.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/concepts/overview_and_concepts.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1491,7 +1510,7 @@ servers to allow for horizontal scalabil
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1511,7 +1530,7 @@ servers to allow for horizontal scalabil
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/ancient-releasing.html 3.2.0-3/doc/html/imap/developer/ancient-releasing.html
--- 3.0.13-5/doc/html/imap/developer/ancient-releasing.html	2019-12-16 04:16:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/ancient-releasing.html	2020-05-04 04:11:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Releasing new builds of ancient Cyrus IMAP versions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Releasing new builds of ancient Cyrus IMAP versions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Cyrus Works" href="cyrusworks.html"/>
         <link rel="prev" title="Releasing Cyrus IMAP" href="releasing.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/ancient-releasing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/ancient-releasing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -778,7 +797,7 @@
 <li><a class="reference internal" href="#pre-release-testing" id="id5">Pre-release testing</a></li>
 <li><a class="reference internal" href="#cross-pollination-of-release-notes" id="id6">Cross-pollination of release notes</a></li>
 <li><a class="reference internal" href="#building-the-release" id="id7">Building the release</a></li>
-<li><a class="reference internal" href="#releasing" id="id8">Releasing</a></li>
+<li><a class="reference internal" href="#finishing-up" id="id8">Finishing up</a></li>
 </ul>
 </li>
 </ul>
@@ -797,9 +816,6 @@ off the top of her head how to create on
 manual like she did. :)</p>
 <p>Once you have a GPG key, it&#8217;s helpful to upload your public key to
 <a class="reference external" href="http://pgp.mit.edu">the MIT key-server</a></p>
-<p>You also need a shell account on www.cyrusimap.org and ftp.cyrusimap.org,
-with SSH key authentication.  You need to be in the &#8220;admin&#8221; group on each,
-and also the &#8220;cyrupload&#8221; group on the latter.</p>
 <p>And you need permission to send to the cyrus-announce mailing list.</p>
 </div>
 <div class="section" id="release-notes-and-version-update">
@@ -837,6 +853,12 @@ when building for Cassandane at any othe
 </ol>
 </li>
 </ol>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">We don&#8217;t bother to run <code class="docutils literal"><span class="pre">make</span> <span class="pre">distcheck</span></code> on the old branches, because it
+almost certainly won&#8217;t work.  We also don&#8217;t bother to run Cassandane, for
+much the same reason.  If it builds, that&#8217;s about as much as we can do.</p>
+</div>
 </div>
 <div class="section" id="cross-pollination-of-release-notes">
 <h2><a class="toc-backref" href="#id6">Cross-pollination of release notes</a><a class="headerlink" href="#cross-pollination-of-release-notes" title="Permalink to this headline">¶</a></h2>
@@ -845,7 +867,7 @@ release notes for these versions appear
 be added to current branches as well.</p>
 <ol class="arabic simple">
 <li>Change to the current stable branch (at time of writing, this is <code class="docutils literal"><span class="pre">cyrus-imapd-3.0</span></code>).</li>
-<li>Create a new release notes at the appropriate location under
+<li>Create a new release notes document at the appropriate location under
 <code class="docutils literal"><span class="pre">docsrc/imap/download/release-notes/</span></code>.</li>
 <li>Add the release notes you wrote earlier, this time using RST format rather
 than simple HTML.</li>
@@ -891,24 +913,9 @@ remote is named &#8220;ci&#8221;).</p>
 </li>
 </ol>
 </div>
-<div class="section" id="releasing">
-<h2><a class="toc-backref" href="#id8">Releasing</a><a class="headerlink" href="#releasing" title="Permalink to this headline">¶</a></h2>
-<ol class="arabic simple">
-<li>Upload the tarball and signature to www: <code class="docutils literal"><span class="pre">scp</span> <span class="pre">cyrus-imapd-*.tar.gz</span> <span class="pre">cyrus-imapd-*.tar.gz.sig</span>
-<span class="pre">www.cyrusimap.org:/var/www/html/releases/</span></code></li>
-<li>Upload them to ftp too: <code class="docutils literal"><span class="pre">scp</span> <span class="pre">cyrus-imapd-*.tar.gz</span> <span class="pre">cyrus-imapd-*.tar.gz.sig</span>
-<span class="pre">ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/</span></code></li>
-<li>SSH into both www and ftp, and move older releases to the old versions
-directory.  You want only the two most recent tarball+sig pairs for each
-major series.</li>
-<li>While SSH&#8217;d into www, build the legacy documentation for this release:<ol class="lowerroman">
-<li>Copy the release tarball to /var/tmp</li>
-<li>Run the script to publish the tarball documentation to the web:
-<code class="docutils literal"><span class="pre">/usr/local/bin/PublishCyrusDocs.pl</span> <span class="pre">-f</span> <span class="pre">/var/tmp/cyrus-imapd-&lt;version&gt;.tar.gz</span></code></li>
-</ol>
-</li>
-<li>Send an announcement to the info-cyrus and cyrus-announce lists.</li>
-</ol>
+<div class="section" id="finishing-up">
+<h2><a class="toc-backref" href="#id8">Finishing up</a><a class="headerlink" href="#finishing-up" title="Permalink to this headline">¶</a></h2>
+<p>Now follow the remaining steps from <a class="reference internal" href="releasing.html#imap-developer-releasing"><span class="std std-ref">Releasing Cyrus IMAP</span></a></p>
 </div>
 </div>
 
@@ -930,7 +937,7 @@ major series.</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 08 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -950,7 +957,7 @@ major series.</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/API/cyrusdb2.html 3.2.0-3/doc/html/imap/developer/API/cyrusdb2.html
--- 3.0.13-5/doc/html/imap/developer/API/cyrusdb2.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/API/cyrusdb2.html	2020-05-04 04:11:24.000000000 +0000
@@ -0,0 +1,1129 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>cyrusdb API &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer APIs" href="../API.html"/>
+        <link rel="next" title="Index API" href="index-api.html"/>
+        <link rel="prev" title="CyrusDB API" href="cyrusdb.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../API.html">Developer APIs</a> &raquo;</li>
+      
+    <li>cyrusdb API</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/API/cyrusdb2.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-api-cyrusdb2"></span><div class="section" id="cyrusdb-api">
+<h1>cyrusdb API<a class="headerlink" href="#cyrusdb-api" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="intro">
+<h2>Intro<a class="headerlink" href="#intro" title="Permalink to this headline">¶</a></h2>
+<p>The <code class="docutils literal"><span class="pre">cyrusdb</span></code> API is a common interface to a key-value store, used
+throughout the Cyrus code. It allows a choice of different backends for
+different access patterns, while ensuring a consistent interface.</p>
+<p>This document will describe the interface, and how to use the cyrusdb
+interface from within parts of Cyrus code, as well as how to implement
+your own backend</p>
+<p>If you pass incorrect values to these APIs, you will get an assertion
+failure in most cases. That&#8217;s generally considered safer than silently
+breaking things. Exceptions are noted below.</p>
+</div>
+<div class="section" id="code-layout">
+<h2>Code Layout<a class="headerlink" href="#code-layout" title="Permalink to this headline">¶</a></h2>
+<p>The implementation of each interface is in <code class="docutils literal"><span class="pre">lib/cyrusdb_NAME.c</span></code>, for
+example lib/cyrusdb_flat.c. General functions are in <code class="docutils literal"><span class="pre">lib/cyrusdb.c</span></code>
+and the interface in <code class="docutils literal"><span class="pre">lib/cyrusdb.h</span></code>.</p>
+</div>
+<div class="section" id="configuration">
+<h2>Configuration<a class="headerlink" href="#configuration" title="Permalink to this headline">¶</a></h2>
+<p>The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: <code class="docutils literal"><span class="pre">annotation_db:</span> <span class="pre">skiplist</span></code>. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable <code class="docutils literal"><span class="pre">config_annotation_db</span></code> gets set to the configured
+backend name:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">config_annotation_db</span> <span class="o">=</span> <span class="n">config_getstring</span><span class="p">(</span><span class="n">IMAPOPT_ANNOTATION_DB</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>(Beware the misleading naming here: <code class="docutils literal"><span class="pre">config_annotation_db</span></code> is a string
+describing the <em>backend</em> used by the database, not, say, its location on
+disk.)</p>
+<p>Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+<code class="docutils literal"><span class="pre">lib/cyrusdb.c</span></code></p>
+<p><code class="docutils literal"><span class="pre">lib/cyrus.c</span></code> provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.</p>
+</div>
+<div class="section" id="a-full-example">
+<h2>A full example<a class="headerlink" href="#a-full-example" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">db</span> <span class="o">*</span><span class="n">db</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">struct</span> <span class="n">txn</span> <span class="o">*</span><span class="n">tid</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">filename</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">flags</span> <span class="o">=</span> <span class="n">CYRUSDB_CREATE</span><span class="p">;</span>
+
+<span class="n">cyrus_init</span><span class="p">(</span><span class="n">alt_config</span><span class="p">,</span> <span class="s2">&quot;toolname&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
+
+<span class="n">filename</span> <span class="o">=</span> <span class="n">config_getstring</span><span class="p">(</span><span class="n">IMAPOPT_ANNOTATION_DB_PATH</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_open</span><span class="p">(</span><span class="n">config_annotation_db</span><span class="p">,</span> <span class="n">filename</span><span class="p">,</span> <span class="n">flags</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">db</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_fetch</span><span class="p">(</span><span class="n">db</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">keylen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">data</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">datalen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tid</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_commit</span><span class="p">(</span><span class="n">db</span><span class="p">,</span> <span class="n">tid</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_close</span><span class="p">(</span><span class="n">db</span><span class="p">);</span>
+
+<span class="n">cyrus_done</span><span class="p">();</span>
+</pre></div>
+</div>
+<p>Note that you always open a database first, and close it at the end. You
+must always call cyrus_init() and cyrus_done() to properly initialize
+and clean up the <code class="docutils literal"><span class="pre">cyrusdb</span></code> environments.</p>
+<p>This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the &#8216;fetch&#8217; (the first use of the
+transaction) and the commit.</p>
+</div>
+<div class="section" id="about-transactions">
+<h2>About Transactions<a class="headerlink" href="#about-transactions" title="Permalink to this headline">¶</a></h2>
+<p>The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the &#8216;tid&#8217; parameter decides which mode
+is used. There are three possible values:</p>
+<ul class="simple">
+<li>NULL - non-transactional. Will create a temporary lock for the
+duration of the current action - either a write lock for &#8220;store&#8221; or a
+read lock for &#8220;fetch&#8221;. If you call &#8220;foreach&#8221;, the lock will be
+dropped between each record fetched</li>
+<li>Pointer to NULL - transactional, transaction not yet started. Will
+always take a write lock on the database, and update the pointer to
+point to the new transaction.</li>
+<li>Pointer to a valid transaction. Will keep using this transaction</li>
+</ul>
+<p>If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions. There is one exception in the skiplist backend: <em>If you
+pass NULL to a fetch or foreach while the database is in a transaction,
+it will silently do the read in the current transaction rather than
+returning an error</em></p>
+</div>
+<div class="section" id="api-reference">
+<h2>API Reference<a class="headerlink" href="#api-reference" title="Permalink to this headline">¶</a></h2>
+<p>All functions follow the normal C API of returning &#8216;0&#8217; on success, and
+an error code on failure</p>
+<div class="section" id="cyrusdb-init-void">
+<h3>cyrusdb_init(void)<a class="headerlink" href="#cyrusdb-init-void" title="Permalink to this headline">¶</a></h3>
+<p>Is called once per process. Don&#8217;t call this yourself, use
+<code class="docutils literal"><span class="pre">cyrus_init()</span></code>. No other calls will be made until this is called.</p>
+</div>
+<div class="section" id="cyrusdb-done-void">
+<h3>cyrusdb_done(void)<a class="headerlink" href="#cyrusdb-done-void" title="Permalink to this headline">¶</a></h3>
+<p>The opposite of <code class="docutils literal"><span class="pre">cyrusdb_init()</span></code> - called once per process to do any
+cleaning up after all database usage is finished. Don&#8217;t call this
+yourself, use <code class="docutils literal"><span class="pre">cyrus_done()</span></code>.</p>
+</div>
+<div class="section" id="cyrusdb-sync-const-char-backend">
+<h3>cyrusdb_sync(const char *backend)<a class="headerlink" href="#cyrusdb-sync-const-char-backend" title="Permalink to this headline">¶</a></h3>
+<p>Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by <code class="docutils literal"><span class="pre">ctl_cyrusdb</span> <span class="pre">-c</span></code> on a regular basis</p>
+</div>
+<div class="section" id="cyrusdb-open-const-char-backend-const-char-fname-int-flags-struct-db-retdb">
+<h3>cyrusdb_open(const char *backend, const char *fname, int flags, struct db **retdb)<a class="headerlink" href="#cyrusdb-open-const-char-backend-const-char-fname-int-flags-struct-db-retdb" title="Permalink to this headline">¶</a></h3>
+<p>Opens the database with the specified &#8216;file name&#8217; (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure</p>
+<p>Flags:</p>
+<ul class="simple">
+<li>CYRUSDB_CREATE - create the database if it doesn&#8217;t exist</li>
+<li>CYRUSDB_MBOXSORT - sort &#8216;.&#8217; first, so folder listing is correct</li>
+</ul>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if there is any error reading the file, or any
+corruption detected while loading the file</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-close-struct-db-db">
+<h3>cyrusdb_close(struct db *db)<a class="headerlink" href="#cyrusdb-close-struct-db-db" title="Permalink to this headline">¶</a></h3>
+<p>Close the named database. Will release any locks if they are still held,
+but it&#8217;s bad practice to close without committing or aborting, so the
+backend should log an error</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if there are any errors during close</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-fetch-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_fetch(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-fetch-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-fetchlock-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_fetchlock(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-fetchlock-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p>Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.</p>
+<p>Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.</p>
+<p>NOTE: it is possible to store a key with a zero length data record, in
+which case *datalen will be set to zero, and *data will be set to a
+non-NULL value</p>
+<p>It is an error to call fetch with a NULL key or a zero keylen</p>
+<p>It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if any error occurs reading from the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_NOTFOUND - if there is no record that matches the key</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-foreach-struct-db-db-const-char-prefix-size-t-prefixlen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr">
+<h3>cyrusdb_foreach(struct db *db, const char *prefix, size_t prefixlen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-foreach-struct-db-db-const-char-prefix-size-t-prefixlen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-forone-struct-db-db-const-char-key-size-t-keylen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr">
+<h3>cyrusdb_forone(struct db *db, const char *key, size_t keylen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-forone-struct-db-db-const-char-key-size-t-keylen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p><code class="docutils literal"><span class="pre">cyrusdb_foreach()</span></code> iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open</p>
+<p>It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.</p>
+<p><code class="docutils literal"><span class="pre">cyrusdb_forone()</span></code> &#8220;iterates&#8221; over the single record matched by the
+given key. If you&#8217;ve already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.</p>
+<p><code class="docutils literal"><span class="pre">goodp</span></code> - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can&#8217;t make any database changes, it doesn&#8217;t
+break the lock, so it&#8217;s faster to use goodp to filter records if you
+don&#8217;t need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.</p>
+<p><code class="docutils literal"><span class="pre">procp</span></code> - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>procp_result - whatever your callback returns</li>
+<li>CYRUSDB_IOERROR - if any error occurs while reading</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-create-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_create(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-create-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-store-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_store(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-store-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p>Create a new record or replace an existing one. The only difference
+between these two is that <code class="docutils literal"><span class="pre">cyrusdb_create</span></code> will return an error if the
+record already exists, while <code class="docutils literal"><span class="pre">cyrusdb_store</span></code> will replace it</p>
+<p>If tidptr is NULL, create/store will take a write lock for the duration
+of the action.</p>
+<p>Any failure during create/store will abort the current transaction as
+well as returning an error</p>
+<p>It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_EXISTS - if <code class="docutils literal"><span class="pre">cyrusdb_create</span></code> is called on an existing key</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-delete-struct-db-db-const-char-key-size-t-keylen-struct-txn-tidptr-int-force">
+<h3>cyrusdb_delete(struct db *db, const char *key, size_t keylen, struct txn **tidptr, int force)<a class="headerlink" href="#cyrusdb-delete-struct-db-db-const-char-key-size-t-keylen-struct-txn-tidptr-int-force" title="Permalink to this headline">¶</a></h3>
+<p>Delete the given record from the database. If force is true, then
+succeed even if the record doesn&#8217;t currently exist.</p>
+<p>It is not legal to pass NULL for key or zero for keylen</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_NOTFOUND - if force is not set and the key doesn&#8217;t exist</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-commit-struct-db-db-struct-txn-tid">
+<h3>cyrusdb_commit(struct db *db, struct txn *tid)<a class="headerlink" href="#cyrusdb-commit-struct-db-db-struct-txn-tid" title="Permalink to this headline">¶</a></h3>
+<p>Commit the current transaction. tid will not be valid after this call,
+regardless of success</p>
+<p>If the commit fails, it will attempt to abort the transaction</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-abort-struct-db-db-struct-txn-tid">
+<h3>cyrusdb_abort(struct db *db, struct txn *tid)<a class="headerlink" href="#cyrusdb-abort-struct-db-db-struct-txn-tid" title="Permalink to this headline">¶</a></h3>
+<p>Abort the current transaction. tid will not be valid after this call,
+regardless of success</p>
+<p>Attempt to roll back all changes made in the current transaction.</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-dump-struct-db-db-int-detail">
+<h3>cyrusdb_dump(struct db *db, int detail)<a class="headerlink" href="#cyrusdb-dump-struct-db-db-int-detail" title="Permalink to this headline">¶</a></h3>
+<p>Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don&#8217;t use.</p>
+</div>
+<div class="section" id="cyrusdb-consistent-struct-db-db">
+<h3>cyrusdb_consistent(struct db *db)<a class="headerlink" href="#cyrusdb-consistent-struct-db-db" title="Permalink to this headline">¶</a></h3>
+<p>Check if the DB is internally consistent. Looks pretty bogus, and isn&#8217;t
+used anywhere. Don&#8217;t use.</p>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="index-api.html" class="btn btn-neutral float-right" title="Index API" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="cyrusdb.html" class="btn btn-neutral" title="CyrusDB API" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/API/cyrusdb.html 3.2.0-3/doc/html/imap/developer/API/cyrusdb.html
--- 3.0.13-5/doc/html/imap/developer/API/cyrusdb.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/API/cyrusdb.html	2020-05-04 04:11:24.000000000 +0000
@@ -0,0 +1,1454 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>CyrusDB API &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer APIs" href="../API.html"/>
+        <link rel="next" title="cyrusdb API" href="cyrusdb2.html"/>
+        <link rel="prev" title="Developer APIs" href="../API.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul class="current">
+<li class="toctree-l4 current"><a class="current reference internal" href="#">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../API.html">Developer APIs</a> &raquo;</li>
+      
+    <li>CyrusDB API</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/API/cyrusdb.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-api-cyrusdb"></span><div class="section" id="cyrusdb-api">
+<h1>CyrusDB API<a class="headerlink" href="#cyrusdb-api" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="the-interface">
+<h2>The interface<a class="headerlink" href="#the-interface" title="Permalink to this headline">¶</a></h2>
+<blockquote>
+<div>The bulk, especially the beginning, of this document is from an
+<a class="reference external" href="https://lists.andrew.cmu.edu/pipermail/cyrus-devel/2018-February/004217.html">email</a>
+Bron sent to the
+<a class="reference external" href="https://lists.andrew.cmu.edu/pipermail/cyrus-devel/">cyrus-devel</a>
+mailing list on 27 February 2018 05:50:39GMT.</div></blockquote>
+<p>The cyrusdb interface is a common API for accessing key-value
+datastores from within cyrus code. It&#8217;s part of the libcyrus shared
+object (but not libcyrus_min), used by all cyrus binaries. The use of
+the cyrusdb API abstracts the details of the underlying data store,
+allowing sites to use different database types depending on their
+needs, and allowing Cyrus developers to use a common API for data
+storage needs.</p>
+<p>The entire cyrusdb source lives in the lib/ directory of the cyrus-imapd repository, in the following files:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb</span><span class="o">.</span><span class="n">h</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb</span><span class="o">.</span><span class="n">c</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb_flat</span><span class="o">.</span><span class="n">c</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb_quotalegacy</span><span class="o">.</span><span class="n">c</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb_skiplist</span><span class="o">.</span><span class="n">c</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb_sql</span><span class="o">.</span><span class="n">c</span>
+<span class="n">lib</span><span class="o">/</span><span class="n">cyrusdb_twoskip</span><span class="o">.</span><span class="n">c</span>
+</pre></div>
+</div>
+<div class="section" id="cyrusdb-h">
+<h3>cyrusdb.h<a class="headerlink" href="#cyrusdb-h" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li>interface definitions (all access to cyrusdb databases happens
+through the functions defined here)</li>
+<li>the <code class="docutils literal"><span class="pre">struct</span> <span class="pre">cyrusdb_backend</span></code> data structure which defines the
+interface implemented by each backend.</li>
+<li>constants for flags to the cyrusdb_open call, and return codes.
+Cyrusdb functions all return their own CYRUSDB_* error codes, which
+are not compatible with the r = IMAP_* return codes used throughout
+much of the rest of the codebase.</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-c">
+<h3>cyrusdb.c<a class="headerlink" href="#cyrusdb-c" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li>implementations of the wrapper functions around the backends,
+including default implementations of some functions which are
+common to many backends but overridden by some.</li>
+<li>a wrapper to initialise and cleanup the state of each backend
+(if needed) during Cyrus set up / tear down.</li>
+</ul>
+</div>
+<div class="section" id="id1">
+<h3>cyrusdb_*.c<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li>the actual implementations of each backend! We&#8217;ll look at some
+in a sec.</li>
+</ul>
+</div>
+</div>
+<div class="section" id="configuration">
+<h2>Configuration<a class="headerlink" href="#configuration" title="Permalink to this headline">¶</a></h2>
+<p>The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: <code class="docutils literal"><span class="pre">annotation_db:</span> <span class="pre">skiplist</span></code>. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable <code class="docutils literal"><span class="pre">config_annotation_db</span></code> gets set to the configured
+backend name:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">config_annotation_db</span> <span class="o">=</span> <span class="n">config_getstring</span><span class="p">(</span><span class="n">IMAPOPT_ANNOTATION_DB</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>(Beware the misleading naming here: <code class="docutils literal"><span class="pre">config_annotation_db</span></code> is a string
+describing the <em>backend</em> used by the database, not, say, its location on
+disk.)</p>
+<p>Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+<code class="docutils literal"><span class="pre">lib/cyrusdb.c</span></code></p>
+<p><code class="docutils literal"><span class="pre">lib/cyrus.c</span></code> provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.</p>
+</div>
+<div class="section" id="a-full-example">
+<h2>A full example<a class="headerlink" href="#a-full-example" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">db</span> <span class="o">*</span><span class="n">db</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">struct</span> <span class="n">txn</span> <span class="o">*</span><span class="n">tid</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">filename</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">flags</span> <span class="o">=</span> <span class="n">CYRUSDB_CREATE</span><span class="p">;</span>
+
+<span class="n">cyrus_init</span><span class="p">(</span><span class="n">alt_config</span><span class="p">,</span> <span class="s2">&quot;toolname&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
+
+<span class="n">filename</span> <span class="o">=</span> <span class="n">config_getstring</span><span class="p">(</span><span class="n">IMAPOPT_ANNOTATION_DB_PATH</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_open</span><span class="p">(</span><span class="n">config_annotation_db</span><span class="p">,</span> <span class="n">filename</span><span class="p">,</span> <span class="n">flags</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">db</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_fetch</span><span class="p">(</span><span class="n">db</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">keylen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">data</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">datalen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tid</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_commit</span><span class="p">(</span><span class="n">db</span><span class="p">,</span> <span class="n">tid</span><span class="p">);</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_close</span><span class="p">(</span><span class="n">db</span><span class="p">);</span>
+
+<span class="n">cyrus_done</span><span class="p">();</span>
+</pre></div>
+</div>
+<p>Note that you always open a database first, and close it at the end. You
+must always call cyrus_init() and cyrus_done() to properly initialize
+and clean up the <code class="docutils literal"><span class="pre">cyrusdb</span></code> environments.</p>
+<p>This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the &#8216;fetch&#8217; (the first use of the
+transaction) and the commit.</p>
+</div>
+<div class="section" id="tools">
+<h2>Tools<a class="headerlink" href="#tools" title="Permalink to this headline">¶</a></h2>
+<p>There are also some tools to work with and support cyrus databases:</p>
+<div class="section" id="imap-ctl-cyrusdb">
+<h3>imap/ctl_cyrusdb<a class="headerlink" href="#imap-ctl-cyrusdb" title="Permalink to this headline">¶</a></h3>
+<p><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html#std:cyrusman-ctl_cyrusdb(8)">ctl_cyrusdb(8)</a></p>
+<ul class="simple">
+<li>performs maintenance on the cyrusdb subsystem. This is called in two places:<ul>
+<li>START: &#8220;ctl_cyrusdb -r&#8221; (recovery).
+This is the ONLY PLACE that code is guaranteed to be run at
+startup on every cyrus installation, so you&#8217;ll find quite a lot
+of detritus has built up in this codepath over the years.</li>
+<li>EVENTS: &#8220;ctl_cyrusdb -c&#8221; (checkpoint).
+This is run regularly (period=180 at FastMail, examples in the
+codebase have period=5 or period=30). Both this codepath and
+cyr_expire tend to run periodically on cyrus systems, and
+cleanup code is spread between those two locations.</li>
+</ul>
+</li>
+</ul>
+</div>
+<div class="section" id="imap-cvt-cyrusdb">
+<h3>imap/cvt_cyrusdb<a class="headerlink" href="#imap-cvt-cyrusdb" title="Permalink to this headline">¶</a></h3>
+<p><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html#std:cyrusman-cvt_cyrusdb(8)">cvt_cyrusdb(8)</a></p>
+<ul class="simple">
+<li>used for converting a database between versions.
+This is often used to prepare for upgrade, particularly in the past
+when Cyrus supported berkeley DB which didn&#8217;t upgrade cleanly
+across OS versions, it was common to use cvt_cyrusdb to turn
+databases into a very portable format (flat or skiplist) before
+upgrading, upgrade the OS, convert back to the fast format
+(berkeley) and then restart.</li>
+</ul>
+</div>
+<div class="section" id="imap-cyr-dbtool">
+<h3>imap/cyr_dbtool<a class="headerlink" href="#imap-cyr-dbtool" title="Permalink to this headline">¶</a></h3>
+<p><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html#std:cyrusman-cyr_dbtool(8)">cyr_dbtool(8)</a></p>
+<ul class="simple">
+<li>once known as brontool, this is the first piece of Cyrus code
+I ever wrote! It&#8217;s a fairly dumb wrapper around the CyrusDB
+interface, and able to be used to read, write, or iterate any parts
+of a database. Its interactive mode is not special-character clean,
+but it can also be used in batch mode, which uses IMAP atom-string
+literal8 for input/output, and hence can roundtrip data reliably.</li>
+</ul>
+<p>There are also tools like: <a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a>,
+<a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html#std:cyrusman-dav_reconstruct(1)">dav_reconstruct(1)</a> and <a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html#std:cyrusman-ctl_mboxlist(8)">ctl_mboxlist(8)</a> which
+can be used to manage individual databases through a more specific
+interface which understands the context as well as just the raw
+key/value.</p>
+</div>
+</div>
+<div class="section" id="how-to-use-cyrusdb">
+<h2>How to use CyrusDB<a class="headerlink" href="#how-to-use-cyrusdb" title="Permalink to this headline">¶</a></h2>
+<p>Assuming that <code class="docutils literal"><span class="pre">cyrus_init()</span></code> has been called, which calls
+<code class="docutils literal"><span class="pre">cyrusdb_init()</span></code>, you can assume that databases will work in any
+Cyrus code.</p>
+<p>The first step is to open a database. Databases have a filename - this
+might be a literal filename on the backend, a directly containing data,
+or an opaque token used by the backend to locate a datasource.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>int flags = 0;
+struct db *mydb = NULL;
+int r = cyrusdb_open(&quot;skiplist&quot;, &quot;/tmp/database.db&quot;, flags, &amp;mydb);
+if (!r) return mydb;  // if (r == CYRUSDB_OK) { ... }
+/* XXX: error handling */
+</pre></div>
+</div>
+<p>Accepted flags:</p>
+<p>CYRUSDB_CREATE - if the named database doesn&#8217;t exist, create a blank
+database.</p>
+<p>CYRUSDB_MBOXSORT - use the abomination called improved_mboxlist_sort
+which re-orders a couple of characters to allow &#8220;foo.bar&#8221; to sort
+before &#8220;foo bar&#8221;, for perfectly good reasons, but we&#8217;re going to fix it
+a better way. Not every engine supports arbitrary collation, and if
+many engines corrupt horribly if the same database is opened with
+different choices for this flag. Ouch.</p>
+<p>CYRUSDB_CONVERT - if set and the database fails to open, attempt a
+magic detection on the file content and try to convert the database to
+the requested backend type before opening it. In-place upgrades! If
+this is NOT set, then instead the magic detection will still be
+performed, but the open database will be returned using the correct
+engine for that database rather than converted. Magic detection only
+currently works for single-file database formats.</p>
+<p>CYRUSDB_NOCOMPACT - if the database format supports automatic
+compacting, don&#8217;t use it. Handy for when you want to read without
+causing any possible issues (e.g. read-only filesystem during recovery)
+or when performance is critical and you don&#8217;t want to risk waiting
+while a recompact happens.</p>
+<p>All the remaining functions take that &#8220;struct db&#8221; pointer.</p>
+<p>There&#8217;s also a <code class="docutils literal"><span class="pre">cyrusdb_lockopen()</span></code> interface which takes a
+transaction pointer and returns with the transaction already active.
+This isn&#8217;t actually being used yet, but is intended to allow slightly
+more efficient single-operation database use. Right now, open returns
+an unlocked database, but may need to lock as part of the setup, so
+keeping that lock would avoid one extra unlock/lock cycle.</p>
+</div>
+<div class="section" id="reading-writing-transactions">
+<h2>Reading, Writing, &amp; Transactions<a class="headerlink" href="#reading-writing-transactions" title="Permalink to this headline">¶</a></h2>
+<p>CyrusDB supports both transactional and non-transactional access.
+Transactions are always exclusive. This is arguably a deficiency in the
+interface, particularly since many engines implement a non-exclusive
+(read) lock internally anyway.</p>
+<div class="section" id="reading">
+<h3>Reading<a class="headerlink" href="#reading" title="Permalink to this headline">¶</a></h3>
+<p>There are now 4 interfaces to read data. Two of which are original
+cyrusdb and two of which are more recently added.</p>
+<p>original:</p>
+<blockquote>
+<div><dl class="docutils">
+<dt><code class="docutils literal"><span class="pre">cyrusdb_fetch()</span></code></dt>
+<dd>fetch a single value by exact key.</dd>
+<dt><code class="docutils literal"><span class="pre">cyrusdb_foreach()</span></code></dt>
+<dd>given a prefix, iterate over all the keys with that prefix
+(including exactly that key) in order.</dd>
+</dl>
+</div></blockquote>
+<p>newer:</p>
+<blockquote>
+<div><dl class="docutils">
+<dt><code class="docutils literal"><span class="pre">cyrusdb_fetchnext()</span></code></dt>
+<dd>given an exact key, fetch the following key and value
+(regardless of whether the key exists), e.g given keys &#8220;f&#8221; and
+&#8220;g&#8221;, fetchnext &#8220;foo&#8221; would return &#8220;g&#8221;, as would fetchnext &#8220;f&#8221;.
+This can be used to implement foreach (indeed, the skips do
+exactly that).</dd>
+<dt><code class="docutils literal"><span class="pre">cyrusdb_forone()</span></code></dt>
+<dd><p class="first">given an exact key, act like <code class="docutils literal"><span class="pre">cyrusdb_foreach</span></code> but only for
+that one key.</p>
+<p>This is a convenience wrapper around fetch to
+allow doing things like:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>r = cyrusdb_forone(mydb, &quot;folder&quot;, 6, p, cb, rock, &amp;tid);
+if (!r) r = cyrusdb_foreach(mydb, &quot;folder.&quot;, 7, p, cb, rock, &amp;tid);
+</pre></div>
+</div>
+<p class="last">Which does precisely &#8220;folder&#8221; and its children without visiting
+any other keys that have &#8220;folder&#8221; as a prefix.</p>
+</dd>
+</dl>
+</div></blockquote>
+<p>Since the cyrusdb interface always takes both a pointer and a length,
+it&#8217;s also possible to use:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>char *key = &quot;folder.&quot;;
+r = cyrusdb_forone(mydb, key, 6, p, cb, rock, &amp;tid);
+if (!r) r = cyrusdb_foreach(mydb, key, 7, p, cb, rock, &amp;tid);
+</pre></div>
+</div>
+<p>OK, foreach. Foreach is very tricky, because it takes TWO callbacks.
+The callbacks have an identical signature, but different return codes!</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">typedef</span> <span class="nb">int</span> <span class="n">foreach_p</span><span class="p">(</span><span class="n">void</span> <span class="o">*</span><span class="n">rock</span><span class="p">,</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">key</span><span class="p">,</span> <span class="n">size_t</span> <span class="n">keylen</span><span class="p">,</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">data</span><span class="p">,</span> <span class="n">size_t</span> <span class="n">datalen</span><span class="p">);</span>
+
+<span class="n">typedef</span> <span class="nb">int</span> <span class="n">foreach_cb</span><span class="p">(</span><span class="n">void</span> <span class="o">*</span><span class="n">rock</span><span class="p">,</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">key</span><span class="p">,</span> <span class="n">size_t</span> <span class="n">keylen</span><span class="p">,</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">data</span><span class="p">,</span> <span class="n">size_t</span> <span class="n">datalen</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>The difference is this: <code class="docutils literal"><span class="pre">foreach_p</span></code> is called with the database
+locked, always - even if called without a transaction. <code class="docutils literal"><span class="pre">foreach_p</span></code>
+returns 1 or 0. 0 means &#8220;skip this record&#8221;, 1 means &#8220;process this
+record&#8221;. This is useful to pre-filter records when called without a
+transaction, because otherwise you lock and unlock all the time.</p>
+<p>NULL for <code class="docutils literal"><span class="pre">foreach_p</span></code> is treated like a test which always returns &#8216;1&#8217;,
+so you can pass NULL if you don&#8217;t need filtering.</p>
+<p>If <code class="docutils literal"><span class="pre">foreach_p</span></code> returns 1, then with an unlocked transaction, the
+database is now unlocked BEFORE calling <code class="docutils literal"><span class="pre">foreach_cb</span></code>, the callback.
+<code class="docutils literal"><span class="pre">foreach_cb</span></code> returns a CYRUSDB_ response. If zero, the foreach will
+continue. If non-zero, the foreach will abort and return the non-zero
+response. This is both useful for error cases, and useful for
+short-circuiting, if you only care that a key exists, you can do
+something like:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">static</span> <span class="nb">int</span> <span class="n">exists_cb</span><span class="p">(</span><span class="n">void</span> <span class="n">rock</span> <span class="n">attribute</span><span class="p">((</span><span class="n">unused</span><span class="p">)),</span> <span class="p">[</span><span class="o">...</span><span class="p">])</span>
+<span class="p">{</span>
+    <span class="k">return</span> <span class="n">CYRUSDB_DONE</span><span class="p">;</span> <span class="o">/</span> <span class="n">one</span> <span class="ow">is</span> <span class="n">enough</span> <span class="o">*/</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>and then use <code class="docutils literal"><span class="pre">exists_cb</span></code> as your <code class="docutils literal"><span class="pre">foreach_cb</span></code> and check if the
+return code is CYRUSDB_DONE to know if the foreach found a key.</p>
+<p>If foreach is called with a transaction pointer, then it is your
+responsibility as the caller to also pass that pointer (and a pointer
+to the database) in that rock, so that callees can make further
+operations within the same transaction. A foreach with a transaction
+does NOT unlock before calling its callback.</p>
+</div>
+<div class="section" id="about-transactions">
+<h3>About Transactions<a class="headerlink" href="#about-transactions" title="Permalink to this headline">¶</a></h3>
+<p>You may have noticed that &#8216;tid&#8217; at the end. Every function for acting
+on the database takes as its last argument a <code class="docutils literal"><span class="pre">struct</span> <span class="pre">txn</span> <span class="pre">**</span></code>.</p>
+<p>The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the &#8216;tid&#8217; parameter decides which mode
+is used. There are three possible values:</p>
+<ul>
+<li><p class="first">NULL - non-transactional request.
+Do whatever you need for internal locking, but starts with an
+unlocked database and ends with an unlocked database.</p>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">At least skiplist and twoskip implement a hack where if the
+database IS locked for a non-transactional read request, they
+will act as if you&#8217;d passed the current transaction in for the
+NULL case. This is a hack around layering violations and kind
+of sucks.</p>
+</div>
+</li>
+<li><p class="first">&amp;NULL - e.g:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">txn</span> <span class="o">*</span><span class="n">tid</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">data</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">size_t</span> <span class="n">datalen</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_fetch</span><span class="p">(</span><span class="n">mydb</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">keylen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">data</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">datalen</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tid</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>After calling this, tid will have an opaque value allocated by the
+database backend, which must be passed to all further cyrusdb
+operations on that database until either <code class="docutils literal"><span class="pre">cyrusdb_commit()</span></code> or
+<code class="docutils literal"><span class="pre">cyrusdb_abort()</span></code> are called.</p>
+</li>
+<li><p class="first">&amp;tid - e.g:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="p">(</span><span class="n">r</span> <span class="o">==</span> <span class="n">CYRUSDB_NOTFOUND</span><span class="p">)</span> <span class="p">{</span>
+    <span class="n">r</span> <span class="o">=</span> <span class="n">cyrusdb_store</span><span class="p">(</span><span class="n">mydb</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">keylen</span><span class="p">,</span> <span class="s2">&quot;DEFAULT&quot;</span><span class="p">,</span> <span class="mi">7</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tid</span><span class="p">);</span> <span class="o">//</span> <span class="nb">set</span> <span class="n">a</span> <span class="n">default</span> <span class="n">value</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>Given an existing transaction, perform this call in the context of the transaction.</p>
+</li>
+</ul>
+<p>If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions.</p>
+<p>There is one exception in the skiplist backend:</p>
+<blockquote>
+<div>If you pass NULL to a fetch or foreach while the database is in a
+transaction, it will silently do the read in the current
+transaction rather than returning an error.</div></blockquote>
+</div>
+<div class="section" id="writing">
+<h3>Writing<a class="headerlink" href="#writing" title="Permalink to this headline">¶</a></h3>
+<p>There are three write operations:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cyrusdb_create</span>
+<span class="n">cyrusdb_store</span>
+<span class="n">cyrusdb_delete</span>
+</pre></div>
+</div>
+<p><code class="docutils literal"><span class="pre">cyrusdb_store</span></code> will either create or overwrite an existing key.
+<code class="docutils literal"><span class="pre">cyrusdb_create</span></code> will abort if the key already exists.
+<code class="docutils literal"><span class="pre">cyrusdb_delete</span></code> takes a flag &#8216;force&#8217; which just makes it return
+CYRUSDB_OK (0) rather than CYRUSDB_NOTFOUND if the key doesn&#8217;t exist.
+Strangely, &#8216;force&#8217; is after &amp;tid, making it the only cyrusdb API that
+does that, but hey - keeps you on your toes.</p>
+<p>&amp;tid behaves exactly the same for the write APIs. If not passed, then
+the database engine will behave as it if creates a writable
+transaction, does the operation, then commits all within the
+<code class="docutils literal"><span class="pre">cyrusdb_*</span></code> call.</p>
+</div>
+</div>
+<div class="section" id="gotchas">
+<h2>Gotchas!<a class="headerlink" href="#gotchas" title="Permalink to this headline">¶</a></h2>
+<ul>
+<li><p class="first">NULL is permitted in both keys and values, though &#8216;flat&#8217; and
+&#8216;quotalegacy&#8217; have 8-bit cleanliness issues.</p>
+</li>
+<li><p class="first">zero-length keys are not supported</p>
+</li>
+<li><p class="first">zero-length values are theoretically supported, but a little
+interesting. Certainly, pass &#8220;&#8221; rather than NULL as the value when
+writing or things will get weird. I&#8217;m pretty sure at least the
+*skip databases assert on these kinds of weirdness.</p>
+</li>
+<li><p class="first">unlocked foreach: this is the land of the gotcha! They key and data
+pointers (const char *) passed to your <code class="docutils literal"><span class="pre">foreach_cb</span></code> are only
+valid UNTIL YOU TOUCH THE DATABASE. A common cause of rare and hard
+to diagnose bugs is writing something to the same database in the
+same process (OR EVEN READING FROM IT AGAIN). I cannot emphasise
+this enough. If you want to zero-copy access that data, you need to
+access it first, before touching that DB again. Otherwise the map
+in which the data was a pointer may have been replaced as the next
+read found a new file and mapped it in!</p>
+<p>also: if you&#8217;re implementing a backend. Unlocked foreach must find
+future records created by the current callback. Consider a database
+containing 4 keys:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">A</span> <span class="n">B</span> <span class="n">C</span> <span class="n">D</span>
+</pre></div>
+</div>
+<p>If you are at key B and insert a key BB, then it must be iterated over.
+If you insert AA while at B, it must NOT be iterated over.</p>
+</li>
+<li><p class="first">Opening the same database multiple times.
+In the bad old days, opening the same database multiple times in
+the same process led to locking bugs (fcntl is braindead). Each
+database engine is responsible for making sure this doesn&#8217;t happen.
+Most engines keep a linked lists of open databases. If you try to
+open the same database again, they will just return the existing
+opened copy and bump a refcount. Beware. If a database is locked
+and you try to lock again - thinking you were opening it brand new,
+it will assertion fail and/or error.</p>
+</li>
+</ul>
+<p>I think that covers about everything! Cyrusdb is used just about
+everywhere that sorted key-value databases give what&#8217;s needed,
+including mailboxes.db, annotations.db (global and per mailbox
+databases), seen state (non-owner), subscriptions, cyrus.indexed.db for
+Xapian, and the rather massive (and increasingly inaccurately named)
+user.conversations.</p>
+<p>Future plans are to increase the usage of cyrusdb databases, possibly
+by building an indexing layer on top and using that instead of the
+sqldb interface used for sqlite databases by DAV code, and possibly
+also moving other custom file formats into a cyrusdb to allow easier
+stateless server builds on a distributed backend.</p>
+</div>
+<div class="section" id="api-reference">
+<h2>API Reference<a class="headerlink" href="#api-reference" title="Permalink to this headline">¶</a></h2>
+<p>All functions follow the normal C API of returning &#8216;0&#8217; on success, and
+an error code on failure</p>
+<div class="section" id="cyrusdb-init-void">
+<h3>cyrusdb_init(void)<a class="headerlink" href="#cyrusdb-init-void" title="Permalink to this headline">¶</a></h3>
+<p>Is called once per process. Don&#8217;t call this yourself, use
+<code class="docutils literal"><span class="pre">cyrus_init()</span></code>. No other calls will be made until this is called.</p>
+</div>
+<div class="section" id="cyrusdb-done-void">
+<h3>cyrusdb_done(void)<a class="headerlink" href="#cyrusdb-done-void" title="Permalink to this headline">¶</a></h3>
+<p>The opposite of <code class="docutils literal"><span class="pre">cyrusdb_init()</span></code> - called once per process to do any
+cleaning up after all database usage is finished. Don&#8217;t call this
+yourself, use <code class="docutils literal"><span class="pre">cyrus_done()</span></code>.</p>
+</div>
+<div class="section" id="cyrusdb-sync-const-char-backend">
+<h3>cyrusdb_sync(const char *backend)<a class="headerlink" href="#cyrusdb-sync-const-char-backend" title="Permalink to this headline">¶</a></h3>
+<p>Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by <code class="docutils literal"><span class="pre">ctl_cyrusdb</span> <span class="pre">-c</span></code> on a regular basis</p>
+</div>
+<div class="section" id="cyrusdb-open-const-char-backend-const-char-fname-int-flags-struct-db-retdb">
+<h3>cyrusdb_open(const char *backend, const char *fname, int flags, struct db **retdb)<a class="headerlink" href="#cyrusdb-open-const-char-backend-const-char-fname-int-flags-struct-db-retdb" title="Permalink to this headline">¶</a></h3>
+<p>Opens the database with the specified &#8216;file name&#8217; (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure</p>
+<p>Flags:</p>
+<ul class="simple">
+<li>CYRUSDB_CREATE - create the database if it doesn&#8217;t exist</li>
+<li>CYRUSDB_MBOXSORT - sort &#8216;.&#8217; first, so folder listing is correct</li>
+</ul>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if there is any error reading the file, or any
+corruption detected while loading the file</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-close-struct-db-db">
+<h3>cyrusdb_close(struct db *db)<a class="headerlink" href="#cyrusdb-close-struct-db-db" title="Permalink to this headline">¶</a></h3>
+<p>Close the named database. Will release any locks if they are still held,
+but it&#8217;s bad practice to close without committing or aborting, so the
+backend should log an error</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if there are any errors during close</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-fetch-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_fetch(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-fetch-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-fetchlock-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_fetchlock(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-fetchlock-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p>Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.</p>
+<p>Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.</p>
+<p>NOTE: it is possible to store a key with a zero length data record, in
+which case *datalen will be set to zero, and *data will be set to a
+non-NULL value</p>
+<p>It is an error to call fetch with a NULL key or a zero keylen</p>
+<p>It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - if any error occurs reading from the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_NOTFOUND - if there is no record that matches the key</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-foreach-struct-db-db-const-char-prefix-size-t-prefixlen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr">
+<h3>cyrusdb_foreach(struct db *db, const char *prefix, size_t prefixlen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-foreach-struct-db-db-const-char-prefix-size-t-prefixlen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-forone-struct-db-db-const-char-key-size-t-keylen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr">
+<h3>cyrusdb_forone(struct db *db, const char *key, size_t keylen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-forone-struct-db-db-const-char-key-size-t-keylen-foreach-p-goodp-foreach-p-procp-void-rock-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p><code class="docutils literal"><span class="pre">cyrusdb_foreach()</span></code> iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open</p>
+<p>It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.</p>
+<p><code class="docutils literal"><span class="pre">cyrusdb_forone()</span></code> &#8220;iterates&#8221; over the single record matched by the
+given key. If you&#8217;ve already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.</p>
+<p><code class="docutils literal"><span class="pre">goodp</span></code> - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can&#8217;t make any database changes, it doesn&#8217;t
+break the lock, so it&#8217;s faster to use goodp to filter records if you
+don&#8217;t need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.</p>
+<p><code class="docutils literal"><span class="pre">procp</span></code> - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>procp_result - whatever your callback returns</li>
+<li>CYRUSDB_IOERROR - if any error occurs while reading</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-create-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_create(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-create-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="cyrusdb-store-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr">
+<h3>cyrusdb_store(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)<a class="headerlink" href="#cyrusdb-store-struct-db-db-const-char-key-size-t-keylen-const-char-data-size-t-datalen-struct-txn-tidptr" title="Permalink to this headline">¶</a></h3>
+<p>Create a new record or replace an existing one. The only difference
+between these two is that <code class="docutils literal"><span class="pre">cyrusdb_create</span></code> will return an error if the
+record already exists, while <code class="docutils literal"><span class="pre">cyrusdb_store</span></code> will replace it</p>
+<p>If tidptr is NULL, create/store will take a write lock for the duration
+of the action.</p>
+<p>Any failure during create/store will abort the current transaction as
+well as returning an error</p>
+<p>It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_EXISTS - if <code class="docutils literal"><span class="pre">cyrusdb_create</span></code> is called on an existing key</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-delete-struct-db-db-const-char-key-size-t-keylen-struct-txn-tidptr-int-force">
+<h3>cyrusdb_delete(struct db *db, const char *key, size_t keylen, struct txn **tidptr, int force)<a class="headerlink" href="#cyrusdb-delete-struct-db-db-const-char-key-size-t-keylen-struct-txn-tidptr-int-force" title="Permalink to this headline">¶</a></h3>
+<p>Delete the given record from the database. If force is true, then
+succeed even if the record doesn&#8217;t currently exist.</p>
+<p>It is not legal to pass NULL for key or zero for keylen</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_NOTFOUND - if force is not set and the key doesn&#8217;t exist</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-commit-struct-db-db-struct-txn-tid">
+<h3>cyrusdb_commit(struct db *db, struct txn *tid)<a class="headerlink" href="#cyrusdb-commit-struct-db-db-struct-txn-tid" title="Permalink to this headline">¶</a></h3>
+<p>Commit the current transaction. tid will not be valid after this call,
+regardless of success</p>
+<p>If the commit fails, it will attempt to abort the transaction</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+<li>CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+has been aborted, but a retry may succeed</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-abort-struct-db-db-struct-txn-tid">
+<h3>cyrusdb_abort(struct db *db, struct txn *tid)<a class="headerlink" href="#cyrusdb-abort-struct-db-db-struct-txn-tid" title="Permalink to this headline">¶</a></h3>
+<p>Abort the current transaction. tid will not be valid after this call,
+regardless of success</p>
+<p>Attempt to roll back all changes made in the current transaction.</p>
+<p>Errors:</p>
+<ul class="simple">
+<li>CYRUSDB_IOERROR - any error to write to the database</li>
+<li>CYRUSDB_LOCKED - if tidptr is incorrect</li>
+</ul>
+</div>
+<div class="section" id="cyrusdb-dump-struct-db-db-int-detail">
+<h3>cyrusdb_dump(struct db *db, int detail)<a class="headerlink" href="#cyrusdb-dump-struct-db-db-int-detail" title="Permalink to this headline">¶</a></h3>
+<p>Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don&#8217;t use.</p>
+</div>
+<div class="section" id="cyrusdb-consistent-struct-db-db">
+<h3>cyrusdb_consistent(struct db *db)<a class="headerlink" href="#cyrusdb-consistent-struct-db-db" title="Permalink to this headline">¶</a></h3>
+<p>Check if the DB is internally consistent. Looks pretty bogus, and isn&#8217;t
+used anywhere. Don&#8217;t use.</p>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="cyrusdb2.html" class="btn btn-neutral float-right" title="cyrusdb API" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../API.html" class="btn btn-neutral" title="Developer APIs" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/API/index-api.html 3.2.0-3/doc/html/imap/developer/API/index-api.html
--- 3.0.13-5/doc/html/imap/developer/API/index-api.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/API/index-api.html	2020-05-04 04:11:25.000000000 +0000
@@ -0,0 +1,929 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Index API &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer APIs" href="../API.html"/>
+        <link rel="next" title="Mailbox API" href="mailbox-api.html"/>
+        <link rel="prev" title="cyrusdb API" href="cyrusdb2.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../API.html">Developer APIs</a> &raquo;</li>
+      
+    <li>Index API</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/API/index-api.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-api-index"></span><div class="section" id="index-api">
+<h1>Index API<a class="headerlink" href="#index-api" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="intro">
+<h2>Intro<a class="headerlink" href="#intro" title="Permalink to this headline">¶</a></h2>
+<p>The Index API is implemented in <code class="docutils literal"><span class="pre">imap/index.h</span></code> and <code class="docutils literal"><span class="pre">imap/index.c</span></code>.
+It provides a snapshot view into the underlying mailbox (see <cite>the
+Mailbox API documentation &lt;mailbox-api.html&gt;</cite>) which obeys IMAP
+semantics, as well as all the searching and sorting logic.</p>
+</div>
+<div class="section" id="opening-and-closing">
+<h2>Opening and closing<a class="headerlink" href="#opening-and-closing" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">index_state</span> <span class="o">*</span><span class="n">state</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="n">struct</span> <span class="n">index_init</span> <span class="n">init</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">r</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">mboxname</span> <span class="o">=</span> <span class="s2">&quot;user.brong&quot;</span><span class="p">;</span>
+
+<span class="n">memset</span><span class="p">(</span><span class="o">&amp;</span><span class="n">init</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">struct</span> <span class="n">index_init</span><span class="p">));</span>
+<span class="n">init</span><span class="o">.</span><span class="n">userid</span> <span class="o">=</span> <span class="n">imapd_userid</span><span class="p">;</span>
+<span class="n">init</span><span class="o">.</span><span class="n">authstate</span> <span class="o">=</span> <span class="n">imapd_authstate</span><span class="p">;</span>
+<span class="n">init</span><span class="o">.</span><span class="n">out</span> <span class="o">=</span> <span class="n">imapd_out</span><span class="p">;</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">index_open</span><span class="p">(</span><span class="n">mboxname</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">init</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">state</span><span class="p">);</span>
+<span class="k">if</span> <span class="p">(</span><span class="n">r</span><span class="p">)</span> <span class="k">return</span> <span class="n">r</span><span class="p">;</span>
+
+<span class="n">do_stuff</span><span class="p">(</span><span class="n">state</span><span class="p">);</span>
+
+<span class="n">index_close</span><span class="p">(</span><span class="o">&amp;</span><span class="n">state</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>The <code class="docutils literal"><span class="pre">index_init</span></code> interface sucks. So does passing lots of parameters.
+For now, this will do! Just pass NULL if you&#8217;re only reading, or use the
+code already in imapd and you&#8217;ll be fine.</p>
+</div>
+<div class="section" id="the-index-model">
+<h2>The Index Model<a class="headerlink" href="#the-index-model" title="Permalink to this headline">¶</a></h2>
+<p>Ok - I think a few words about the index model and how it differs from
+direct mailbox access are needed! In the past, index.c used pointers
+directly into the mmaped <code class="docutils literal"><span class="pre">cyrus.index</span></code> file and maintained the old
+mmaped copy if an expunge took place. Under the namelock regime, this is
+no longer required because namelocks will avoid the file being
+re-written.</p>
+<p>Also, memory is now cheap. Rather than using locks to ensure
+consistency, we just keep a copy of the <code class="docutils literal"><span class="pre">struct</span> <span class="pre">index_record</span></code> for even
+message in the index, stored in memory. Since these are about 100 bytes
+each, a 1 million email mailbox will take rougly 100Mb of memory. That&#8217;s
+not too bad on a modern server, and that&#8217;s a <strong>huge</strong> mailbox.</p>
+<p>So - the model works like this:</p>
+<ul>
+<li><p class="first">Create the index state or re-lock (<code class="docutils literal"><span class="pre">index_lock</span></code>) the mailbox on an
+existing index.</p>
+</li>
+<li><p class="first">call <code class="docutils literal"><span class="pre">index_refresh</span></code></p>
+</li>
+<li><p class="first">if any changes are to be made (i.e. flag updates for a store,
+non-peek body fetch, expunge) then cycle through the refreshed state
+map and update the records which are affected.</p>
+</li>
+<li><p class="first">call <code class="docutils literal"><span class="pre">index_unlock</span></code> (unlock the underlying mailbox and commit the
+statuscache changes)</p>
+<p>At this point the index lock is <strong>released</strong> and we have not yet
+generated any network traffic. Now start generating the response.</p>
+</li>
+<li><p class="first">if expunges are allowed, call <code class="docutils literal"><span class="pre">index_tellexpunge</span></code></p>
+</li>
+<li><p class="first">call <code class="docutils literal"><span class="pre">index_tellchanges</span></code> to tell about all other changes</p>
+</li>
+<li><p class="first">return any response that the command itself required</p>
+</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="mailbox-api.html" class="btn btn-neutral float-right" title="Mailbox API" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="cyrusdb2.html" class="btn btn-neutral" title="cyrusdb API" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/API/mailbox-api.html 3.2.0-3/doc/html/imap/developer/API/mailbox-api.html
--- 3.0.13-5/doc/html/imap/developer/API/mailbox-api.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/API/mailbox-api.html	2020-05-04 04:11:25.000000000 +0000
@@ -0,0 +1,1159 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Mailbox API &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer APIs" href="../API.html"/>
+        <link rel="next" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="prev" title="Index API" href="index-api.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="index-api.html">Index API</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../API.html">Developer APIs</a> &raquo;</li>
+      
+    <li>Mailbox API</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/API/mailbox-api.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-api-mailbox"></span><div class="section" id="mailbox-api">
+<h1>Mailbox API<a class="headerlink" href="#mailbox-api" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="intro">
+<h2>Intro<a class="headerlink" href="#intro" title="Permalink to this headline">¶</a></h2>
+<p>The Mailbox API is implemented in <code class="docutils literal"><span class="pre">imap/mailbox.h</span></code> and
+<code class="docutils literal"><span class="pre">imap/mailbox.c</span></code>. It wraps the data structures of the
+<code class="docutils literal"><span class="pre">cyrus.header</span></code>, <code class="docutils literal"><span class="pre">cyrus.index</span></code> and <code class="docutils literal"><span class="pre">cyrus.cache</span></code> files in a
+psuedo-object-oriented way, allowing easy changes to the mailbox while
+keeping the internal cached data structures consistent.</p>
+</div>
+<div class="section" id="opening-and-closing">
+<h2>Opening and closing<a class="headerlink" href="#opening-and-closing" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">mailbox</span> <span class="o">=</span> <span class="n">NULL</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">r</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">mboxname</span> <span class="o">=</span> <span class="s2">&quot;user.brong&quot;</span><span class="p">;</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_open_iwl</span><span class="p">(</span><span class="n">mboxname</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">mailbox</span><span class="p">);</span>
+<span class="o">//</span> <span class="ow">or</span>
+<span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_open_irl</span><span class="p">(</span><span class="n">mboxname</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">mailbox</span><span class="p">);</span>
+<span class="o">//</span> <span class="ow">or</span>
+<span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_open_exclusive</span><span class="p">(</span><span class="n">mboxname</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">mailbox</span><span class="p">);</span>
+<span class="k">if</span> <span class="p">(</span><span class="n">r</span><span class="p">)</span> <span class="k">return</span> <span class="n">r</span><span class="p">;</span>
+
+<span class="n">do_stuff</span><span class="p">(</span><span class="n">mailbox</span><span class="p">);</span>
+
+<span class="n">mailbox_close</span><span class="p">(</span><span class="o">&amp;</span><span class="n">mailbox</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>It is always necessary to obtain an index lock when opening a mailbox,
+because the index header read must be consistent. The locks are as
+follows:</p>
+<table border="1" class="docutils">
+<colgroup>
+<col width="51%" />
+<col width="24%" />
+<col width="25%" />
+</colgroup>
+<thead valign="bottom">
+<tr class="row-odd"><th class="head">Function</th>
+<th class="head">Namelock</th>
+<th class="head">Index Lock</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr class="row-even"><td>mailbox_open_iwl</td>
+<td>Shared</td>
+<td>Exclusive</td>
+</tr>
+<tr class="row-odd"><td>mailbox_open_irl</td>
+<td>Shared</td>
+<td>Shared</td>
+</tr>
+<tr class="row-even"><td>mailbox_open_exclusive</td>
+<td>Exclusive</td>
+<td>Exclusive</td>
+</tr>
+</tbody>
+</table>
+<p>It should never be necessary to call <code class="docutils literal"><span class="pre">mailbox_open_exclusive</span></code>, but
+it&#8217;s included for completeness. Use <code class="docutils literal"><span class="pre">mailbox_open_iwl</span></code> if you expect
+to need to write to the index (or even if you&#8217;re not sure) and
+<code class="docutils literal"><span class="pre">mailbox_open_irl</span></code> when you know you&#8217;re only reading from the file and
+wish to allow other readers to work concurrently.</p>
+<p>Many actions are delayed until the mailbox is closed, or even until the
+<em>last</em> mailbox is closed for things that require an exclusive namelock
+to perform like deletion or repack. See below under &#8220;delayed actions&#8221;
+for more detail.</p>
+<p>To avoid opening the same file multiple times, the mailbox API refcounts
+open mailboxes. If you open the same mailbox again (i.e. a URL fetch or
+status command on the currently select mailbox) then the same mailbox
+will be returned. It must be unlocked (see below or the open command
+will return IMAP_MAILBOX_LOCKED). The matching close will reduce the
+refcount, and only the final close will do the cleanup actions.</p>
+</div>
+<div class="section" id="locking-and-unlocking">
+<h2>Locking and unlocking<a class="headerlink" href="#locking-and-unlocking" title="Permalink to this headline">¶</a></h2>
+<p>You can keep a mailbox &#8220;open&#8221;, maintaining the namelock, while releasing
+the index lock to allow other processes to make changes to the mailbox.
+By holding the namelock, you know that record numbers won&#8217;t change, and
+the underlying message files won&#8217;t be deleted.</p>
+<p><code class="docutils literal"><span class="pre">mailbox_close</span></code> will call <code class="docutils literal"><span class="pre">mailbox_unlock_index</span></code> if the index is
+still locked, so it is not necessary to explicitly unlock the index
+before closing.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_unlock_index</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">NULL</span><span class="p">);</span>
+
+<span class="o">//</span> <span class="n">sleep</span> <span class="n">on</span> <span class="n">user</span> <span class="nb">input</span><span class="o">...</span>
+
+<span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_lock_index</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">LOCK_SHARED</span><span class="p">);</span>
+<span class="o">//</span> <span class="ow">or</span>
+<span class="n">r</span> <span class="o">=</span> <span class="n">mailbox_lock_index</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">LOCK_EXCLUSIVE</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>For example, <code class="docutils literal"><span class="pre">mailbox_unlock_index</span></code> and <code class="docutils literal"><span class="pre">mailbox_lock_index</span></code> are
+used extensively by the index module, allowing an imap client to
+maintain a long lived connection selected to a mailbox and know that
+messages won&#8217;t magically disappear from under it - yet at the same time
+allow new mail delivery to happen or other imap connections to query the
+mailbox.</p>
+<p>If you have built an accurate statuscache item for the locked mailbox,
+you can pass this as the second parameter to mailbox_index_unlock. If
+there have been any changes, mailbox_index_unlock will invalidated the
+statuscache. If you give it the new value, then it will store that value
+instead. For example:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>struct statusdata sdata;
+index_status(state, &amp;sdata);
+/* RECENT is zero for everyone else because we wrote a new
+ * recentuid! */
+sdata.recent = 0;
+mailbox_unlock_index(state-&gt;mailbox, &amp;sdata);
+</pre></div>
+</div>
+<p>See &#8220;delayed actions&#8221; below for delayed actions performed during an
+unlock.</p>
+</div>
+<div class="section" id="creating-renaming-and-deleting">
+<h2>Creating, renaming and deleting<a class="headerlink" href="#creating-renaming-and-deleting" title="Permalink to this headline">¶</a></h2>
+<p><strong>WARNING:</strong> These functions only change the mailbox files on disk. They
+don&#8217;t update the mailboxes.db records or contact murder servers. In most
+cases you are probably looking for the <code class="docutils literal"><span class="pre">mboxlist_</span></code> functions instead.</p>
+<p>Creating a mailbox is somewhat longwinded - as there are many optional
+parameters.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_create</span><span class="p">(</span><span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">name</span><span class="p">,</span> <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">part</span><span class="p">,</span> <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">acl</span><span class="p">,</span>
+                   <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">uniqueid</span><span class="p">,</span> <span class="nb">int</span> <span class="n">options</span><span class="p">,</span> <span class="n">unsigned</span> <span class="n">uidvalidity</span><span class="p">,</span>
+                   <span class="n">struct</span> <span class="n">mailbox</span> <span class="o">**</span><span class="n">mailboxptr</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>Most interesting to note is that on success, <code class="docutils literal"><span class="pre">mailboxptr</span></code> will contain
+the same mailbox that <code class="docutils literal"><span class="pre">mailbox_open_exclusive</span></code> above would have
+returned, with an exclusive namelock and an exclusive index lock. This
+allows you to perform other consistency operations after creating the
+mailbox with a full guarantee that no other process will even be able to
+know of the mailbox&#8217;s existence! You can still roll-back by deleting the
+mailbox and the next process will get the namelock and see no mailbox
+with that name.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_rename_copy</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">oldmailbox</span><span class="p">,</span>
+                        <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">newname</span><span class="p">,</span> <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">newpart</span><span class="p">,</span>
+                        <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">userid</span><span class="p">,</span> <span class="nb">int</span> <span class="n">ignorequota</span><span class="p">,</span>
+                        <span class="nb">int</span> <span class="n">silent</span><span class="p">,</span>
+                        <span class="n">struct</span> <span class="n">mailbox</span> <span class="o">**</span><span class="n">newmailboxptr</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>Very similar to mailbox_create - the new mailbox is created with an
+exclusive name lock and returned. The old mailbox must be passed in with
+an <strong>exclusive index lock</strong> but is fine with a shared namelock, as it
+will be passed to <code class="docutils literal"><span class="pre">mailbox_delete</span></code>.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_delete</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">**</span><span class="n">mailboxptr</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>Just like <code class="docutils literal"><span class="pre">mailbox_close</span></code> above, this closes the mailbox. Before it
+does so, it sets the OPT_MAILBOX_DELETED option flag in the index
+header. The interesting work is actually done in <code class="docutils literal"><span class="pre">mailbox_close</span></code>. See
+below under &#8220;delayed actions&#8221;.</p>
+<p><code class="docutils literal"><span class="pre">mailbox_delete</span></code> requires an exclusive index lock, but can complete
+quite happily with only a shared namelock.</p>
+</div>
+<div class="section" id="reading-and-writing-records">
+<h2>Reading and writing records<a class="headerlink" href="#reading-and-writing-records" title="Permalink to this headline">¶</a></h2>
+<p>Ok - so you have a mailbox, it&#8217;s opened, and the index is locked. Time
+to start reading and writing some records!</p>
+<p>At the mailbox level there is no concept of &#8220;message numbers&#8221; from imap,
+only &#8220;record numbers&#8221;. The canonical variable name to refer to record
+numbers is <code class="docutils literal"><span class="pre">recno</span></code>. All records are read and written using
+<code class="docutils literal"><span class="pre">struct</span> <span class="pre">index_record</span></code> values.</p>
+<p>Here at the API definitions used for reading and writing:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_read_index_record</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">mailbox</span><span class="p">,</span>
+                              <span class="n">uint32_t</span> <span class="n">recno</span><span class="p">,</span>
+                              <span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">);</span>
+<span class="nb">int</span> <span class="n">mailbox_rewrite_index_record</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">mailbox</span><span class="p">,</span>
+                                 <span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">);</span>
+<span class="nb">int</span> <span class="n">mailbox_append_index_record</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">mailbox</span><span class="p">,</span>
+                                <span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">);</span>
+<span class="nb">int</span> <span class="n">mailbox_commit</span><span class="p">(</span><span class="n">mailbox</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>An example of iterating through a mailbox</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">uint32_t</span> <span class="n">recno</span><span class="p">;</span>
+<span class="n">struct</span> <span class="n">index_record</span> <span class="n">record</span><span class="p">;</span>
+<span class="nb">int</span> <span class="n">make_changes</span><span class="p">;</span>
+
+<span class="o">/*</span> <span class="n">DEPRECATED</span> <span class="o">*/</span>
+<span class="k">for</span> <span class="p">(</span><span class="n">recno</span> <span class="o">=</span> <span class="mi">1</span><span class="p">;</span> <span class="n">recno</span> <span class="o">&lt;=</span> <span class="n">mailbox</span><span class="o">-&gt;</span><span class="n">i</span><span class="o">.</span><span class="n">num_records</span><span class="p">;</span> <span class="n">recno</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">mailbox_read_index_record</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">recno</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">record</span><span class="p">))</span>
+        <span class="n">fatal</span><span class="p">(</span><span class="s2">&quot;invalid record&quot;</span><span class="p">,</span> <span class="n">EX_SOFTWARE</span><span class="p">);</span> <span class="o">//</span> <span class="ow">or</span> <span class="k">return</span> <span class="n">an</span> <span class="n">error</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">record</span><span class="o">.</span><span class="n">internal_flags</span> <span class="o">&amp;</span> <span class="n">FLAG_INTERNAL_EXPUNGED</span><span class="p">)</span>
+        <span class="k">continue</span><span class="p">;</span> <span class="o">//</span> <span class="n">skip</span> <span class="n">expunged</span> <span class="n">records</span>
+    <span class="n">make_changes</span> <span class="o">=</span> <span class="n">do_stuff</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">record</span><span class="p">);</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">make_changes</span><span class="p">)</span>
+        <span class="n">mailbox_rewrite_index_record</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">record</span><span class="p">);</span>
+<span class="p">}</span>
+
+<span class="o">/*</span> <span class="n">the</span> <span class="n">new</span> <span class="n">way</span> <span class="o">*/</span>
+<span class="nb">int</span> <span class="n">make_change</span><span class="p">;</span>
+<span class="n">const</span> <span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">;</span>
+<span class="n">struct</span> <span class="n">mailbox_iter</span> <span class="o">*</span><span class="nb">iter</span><span class="p">;</span>
+
+<span class="nb">iter</span> <span class="o">=</span> <span class="n">mailbox_iter_init</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">ITER_SKIP_EXPUNGED</span><span class="p">);</span>
+<span class="k">while</span> <span class="p">((</span><span class="n">record</span> <span class="o">=</span> <span class="n">mailbox_iter_step</span><span class="p">(</span><span class="nb">iter</span><span class="p">)))</span> <span class="p">{</span>
+    <span class="n">make_changes</span> <span class="o">=</span> <span class="n">do_stuff</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">record</span><span class="p">);</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">make_changes</span><span class="p">)</span>
+        <span class="n">mailbox_rewrite_index_record</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">record</span><span class="p">);</span>
+<span class="p">}</span>
+<span class="n">mailbox_iter_done</span><span class="p">(</span><span class="o">&amp;</span><span class="nb">iter</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>NOTE: <code class="docutils literal"><span class="pre">mailbox_rewrite_index_record</span></code> doesn&#8217;t need a recno, as that&#8217;s
+cached inside the index_record struct.</p>
+<p>NOTE: You need an exclusively locked index to use rewrite or append, but
+only a shared index lock to use read.</p>
+<p>There are a range of consistency checks done to ensure that a rewrite
+doesn&#8217;t violate IMAP semantics (an expunged message can never be
+unexpunged, UIDs can&#8217;t change, etc) and the internal tracking counts and
+quota data are updated as well. They will be committed at unlock time,
+see &#8220;delayed actions&#8221;</p>
+<p>If you don&#8217;t set the <code class="docutils literal"><span class="pre">record.silent</span></code> field to a true value before
+rewriting or appending, the <code class="docutils literal"><span class="pre">record.modseq</span></code> and
+<code class="docutils literal"><span class="pre">record.last_updated</span></code> values will be changed. This allows condstore to
+work correctly.</p>
+<div class="section" id="appending">
+<h3>Appending<a class="headerlink" href="#appending" title="Permalink to this headline">¶</a></h3>
+<p>To append a record, the file must have already been copied into place
+(XXX - plan to move to a stage based system where the mailbox API
+handles the staging, but that&#8217;s not finished yet) and been parsed into
+the record struct. The UID must be set already, and must be greater than
+the UID of any existing record in the mailbox. There are a range of
+consistency checks done.</p>
+<p>The internal consistency counts are updated by append as well.</p>
+</div>
+<div class="section" id="committing">
+<h3>Committing<a class="headerlink" href="#committing" title="Permalink to this headline">¶</a></h3>
+<p>When you have finished making any changes, you need to &#8220;commit&#8221;. This
+will write the updated values for any index header fields, rewite the
+<code class="docutils literal"><span class="pre">cyrus.header</span></code> file if needed and fsync all changes to disk.</p>
+<p>It is a fatal error to unlock (or close) a mailbox that has had changes
+without committing, as it can leave the mailbox in a corrupted state.</p>
+</div>
+<div class="section" id="cache-records">
+<h3>Cache records<a class="headerlink" href="#cache-records" title="Permalink to this headline">¶</a></h3>
+<p>Cache records are accessed through <code class="docutils literal"><span class="pre">record.crec</span></code> which is not filled
+by read_index_record. The cache file is only read and mapped into
+memory as needed, so you if you want to access cache records, the basic
+API is as follows:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_cacherecord</span><span class="p">(</span><span class="n">struct</span> <span class="n">mailbox</span> <span class="o">*</span><span class="n">mailbox</span><span class="p">,</span>
+                        <span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">);</span>
+<span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">cacheitem_base</span><span class="p">(</span><span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">,</span> <span class="nb">int</span> <span class="n">field</span><span class="p">);</span>
+<span class="n">unsigned</span> <span class="n">cacheitem_size</span><span class="p">(</span><span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">,</span> <span class="nb">int</span> <span class="n">field</span><span class="p">);</span>
+<span class="n">struct</span> <span class="n">buf</span> <span class="o">*</span><span class="n">cacheitem_buf</span><span class="p">(</span><span class="n">struct</span> <span class="n">index_record</span> <span class="o">*</span><span class="n">record</span><span class="p">,</span> <span class="nb">int</span> <span class="n">field</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>You must always call <code class="docutils literal"><span class="pre">mailbox_cacherecord</span></code> on a record before trying
+to access any of the cache items. &#8220;<code class="docutils literal"><span class="pre">field</span></code>&#8221; above is the individual
+field (there are 10) in the cache record. There&#8217;s more information on
+those fields in the mailbox internal format documentation.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="k">for</span> <span class="p">(</span><span class="n">recno</span> <span class="o">=</span> <span class="mi">1</span><span class="p">;</span> <span class="n">recno</span> <span class="o">&lt;=</span> <span class="n">mailbox</span><span class="o">-&gt;</span><span class="n">i</span><span class="o">.</span><span class="n">num_records</span><span class="p">;</span> <span class="n">recno</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">mailbox_read_index_record</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="n">recno</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">record</span><span class="p">))</span>
+        <span class="n">fatal</span><span class="p">(</span><span class="s2">&quot;invalid record&quot;</span><span class="p">,</span> <span class="n">EX_SOFTWARE</span><span class="p">);</span> <span class="o">//</span> <span class="ow">or</span> <span class="k">return</span> <span class="n">an</span> <span class="n">error</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">record</span><span class="o">.</span><span class="n">internal_flags</span> <span class="o">&amp;</span> <span class="n">FLAG_INTERNAL_EXPUNGED</span><span class="p">)</span>
+        <span class="k">continue</span><span class="p">;</span> <span class="o">//</span> <span class="n">skip</span> <span class="n">expunged</span> <span class="n">records</span>
+    <span class="k">if</span> <span class="p">(</span><span class="n">mailbox_cacherecord</span><span class="p">(</span><span class="n">mailbox</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">record</span><span class="p">))</span>
+        <span class="n">fatal</span><span class="p">(</span><span class="s2">&quot;failed to read cache&quot;</span><span class="p">,</span> <span class="n">EX_SOFTWARE</span><span class="p">);</span>
+    <span class="o">...</span>
+    <span class="n">envelope_length</span> <span class="o">=</span> <span class="n">cacheitem_size</span><span class="p">(</span><span class="o">&amp;</span><span class="n">record</span><span class="p">,</span> <span class="n">CACHE_ENVELOPE</span><span class="p">);</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>See <code class="docutils literal"><span class="pre">imap/mailbox.h</span></code> for the full list of constants.</p>
+</div>
+</div>
+<div class="section" id="delayed-actions">
+<h2>Delayed Actions<a class="headerlink" href="#delayed-actions" title="Permalink to this headline">¶</a></h2>
+<p>Here&#8217;s the bit you&#8217;ve been waiting for! What happens during unlock and
+close</p>
+<div class="section" id="first-unlock">
+<h3>first, unlock<a class="headerlink" href="#first-unlock" title="Permalink to this headline">¶</a></h3>
+<p>Anything that makes any changes sets the mailbox-&gt;has_changed flag. If
+this is set, then before the index gets unlocked:</p>
+<ul class="simple">
+<li>the updatenotifier (idle) is called</li>
+<li><code class="docutils literal"><span class="pre">sync_log_mailbox</span></code> (replication) gets called</li>
+<li>the statuscache value gets erased (or replaced if you passed in an
+updated value).</li>
+</ul>
+</div>
+<div class="section" id="then-close">
+<h3>then: close<a class="headerlink" href="#then-close" title="Permalink to this headline">¶</a></h3>
+<p>next the index is unlocked (see above)</p>
+<p>third, any &#8220;unlink&#8221; commands scheduled for email files are run. These
+can&#8217;t be done until after the mailbox_commit to ensure consistency -
+the file isn&#8217;t deleted until the record is written as unlinked! But we
+save the unlink until now so that other tasks aren&#8217;t waiting for the
+index lock while the unlinks run. Unlink is expensive in IO and time.</p>
+<p>finally we check for MAILBOX_NEEDS_REPACK or MAILBOX_DELETED option
+flags. If either is sets, then we make a non-blocking attempt to get an
+exclusive namelock. If the non-blocking attempt fails, then another
+process has the mailbox open, so save the cleanup for them! If it
+succeeds, then go ahead with either <code class="docutils literal"><span class="pre">mailbox_delete_cleanup</span></code> or
+<code class="docutils literal"><span class="pre">mailbox_index_repack</span></code> as appropriate.</p>
+<p>After this it&#8217;s just a matter of releasing malloc&#8217;d memory and finally
+releasing the name lock.</p>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../thoughts.html" class="btn btn-neutral float-right" title="Developer Thoughts &amp; Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="index-api.html" class="btn btn-neutral" title="Index API" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 17 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/API.html 3.2.0-3/doc/html/imap/developer/API.html
--- 3.0.13-5/doc/html/imap/developer/API.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/API.html	2020-05-04 04:11:24.000000000 +0000
@@ -0,0 +1,867 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Developer APIs &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../genindex.html"/>
+        <link rel="search" title="Search" href="../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
+        <link rel="up" title="Developers" href="../../developers.html"/>
+        <link rel="next" title="CyrusDB API" href="API/cyrusdb.html"/>
+        <link rel="prev" title="Cyrus Works" href="cyrusworks.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../index.html">Home</a></li>
+    <li><a href="../../download.html">Download</a></li>
+    <li><a href="../../contribute.html">Contribute</a></li>
+    <li><a href="../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../index.html">
+      <img src="../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../index.html">
+ 
+
+  
+          
+          <img src="../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3 current"><a class="current reference internal" href="#">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../developers.html">Developers</a> &raquo;</li>
+      
+    <li>Developer APIs</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/API.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="developer-apis">
+<span id="imap-developer-api"></span><h1>Developer APIs<a class="headerlink" href="#developer-apis" title="Permalink to this headline">¶</a></h1>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l1"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l1"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l1"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="API/cyrusdb.html" class="btn btn-neutral float-right" title="CyrusDB API" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="cyrusworks.html" class="btn btn-neutral" title="Cyrus Works" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/compiling.html 3.2.0-3/doc/html/imap/developer/compiling.html
--- 3.0.13-5/doc/html/imap/developer/compiling.html	2019-12-16 04:16:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/compiling.html	2020-05-04 04:11:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Compiling &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Compiling &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Setup" href="../../setup.html"/>
         <link rel="next" title="Installing Cyrus" href="../installing.html"/>
         <link rel="prev" title="Setup" href="../../setup.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../setup.html">Setup</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/compiling.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/compiling.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -915,19 +934,25 @@ code maintenance tasks or building the d
 <td>&nbsp;</td>
 <td>Perl library to generate man pages.  This has to be available to the system-wide perl interpreter, found by <code class="docutils literal"><span class="pre">which</span></code>:  <code class="docutils literal"><span class="pre">./configure</span> <span class="pre">--with-perl</span></code> is not honoured.</td>
 </tr>
-<tr class="row-odd"><td><a class="reference external" href="https://www.sphinx-doc.org/">python(Sphinx)</a></td>
+<tr class="row-odd"><td><a class="reference external" href="https://github.com/gitpython-developers/GitPython">python(GitPython)</a></td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>Python library needed for building the documentation</td>
+</tr>
+<tr class="row-even"><td><a class="reference external" href="https://www.sphinx-doc.org/">python(Sphinx)</a></td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
 <td>Python library needed for building the documentation</td>
 </tr>
-<tr class="row-even"><td><a class="reference external" href="http://www.valgrind.org/">valgrind</a></td>
+<tr class="row-odd"><td><a class="reference external" href="http://www.valgrind.org/">valgrind</a></td>
 <td>valgrind</td>
 <td>valgrind</td>
 <td>no</td>
 <td>Performance and memory testing.</td>
 </tr>
-<tr class="row-odd"><td><a class="reference external" href="https://github.com/ConorOG/xxd/">xxd</a></td>
+<tr class="row-even"><td><a class="reference external" href="https://github.com/ConorOG/xxd/">xxd</a></td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
@@ -1005,20 +1030,7 @@ capabilities. Otherwise also known as th
 </tr>
 </thead>
 <tbody valign="top">
-<tr class="row-even"><td><a class="reference external" href="http://lmdb.tech/">lmdb</a></td>
-<td>lmdb-dev</td>
-<td>lmdb</td>
-<td>no</td>
-<td>Lightning Memory-Mapped Database Manager (LMDB) backend for Cyrus IMAP
-databases.     LMDB requires database environments to be set to a (user-configurable)
-maximum size. The Cyrus backend uses 512MB as default size. Cyrus
-installations may override this by setting the environment variable
-CYRUSDB_LMDB_MAXSIZE. The value of this variable must be an integer,
-optionally followed (without space) by &#8216;mb&#8217; or &#8216;gb&#8217; to define the
-maximum size in bytes, megabytes or gigabytes. The size should be a
-multiple of the OS page size.</td>
-</tr>
-<tr class="row-odd"><td><a class="reference external" href="http://www.mysql.com">mysql</a> or <a class="reference external" href="http://mariadb.org">mariadb</a></td>
+<tr class="row-even"><td><a class="reference external" href="http://www.mysql.com">mysql</a> or <a class="reference external" href="http://mariadb.org">mariadb</a></td>
 <td>libmysqlclient-dev or libmariadb-dev</td>
 <td>mysql-devel or mariadb-devel</td>
 <td>no</td>
@@ -1027,7 +1039,7 @@ it as the backend for its databases.</p>
 <p class="last">Configure option: <code class="docutils literal"><span class="pre">--with-mysql</span></code>, <code class="docutils literal"><span class="pre">--with-mysql-incdir</span></code>, <code class="docutils literal"><span class="pre">--with-mysql-libdir</span></code></p>
 </td>
 </tr>
-<tr class="row-even"><td><a class="reference external" href="http://www.postgresql.org/">postgresql</a></td>
+<tr class="row-odd"><td><a class="reference external" href="http://www.postgresql.org/">postgresql</a></td>
 <td>postgresql-dev</td>
 <td>postgresql-devel</td>
 <td>no</td>
@@ -1036,8 +1048,8 @@ it as the backend for its databases.</p>
 </tbody>
 </table>
 </div>
-<div class="section" id="caldav-and-or-carddav">
-<h4>CalDAV and/or CardDAV<a class="headerlink" href="#caldav-and-or-carddav" title="Permalink to this headline">¶</a></h4>
+<div class="section" id="caldav-carddav-or-jmap">
+<h4>CalDAV, CardDAV, or JMAP<a class="headerlink" href="#caldav-carddav-or-jmap" title="Permalink to this headline">¶</a></h4>
 <table border="1" class="colwidths-given docutils">
 <colgroup>
 <col width="20%" />
@@ -1055,20 +1067,29 @@ it as the backend for its databases.</p>
 </tr>
 </thead>
 <tbody valign="top">
-<tr class="row-even"><td><a class="reference external" href="https://github.com/libical/libical/">libical</a></td>
+<tr class="row-even"><td><a class="reference external" href="https://github.com/Joungkyun/libchardet">libchardet</a></td>
+<td>libchardet-dev</td>
+<td>libchardet-devel</td>
+<td>no</td>
+<td>&nbsp;</td>
+</tr>
+<tr class="row-odd"><td><a class="reference external" href="https://github.com/libical/libical/">libical</a></td>
 <td>libical-dev</td>
 <td>libical-devel</td>
 <td>no</td>
-<td>libical &gt;= 0.48 required for scheduling support.
-<strong>Note:</strong> Linux distributions Enterprise Linux 6 and Debian Squeeze are
-known to ship outdated <strong>libical</strong> packages versions 0.43 and
-0.44 respectively. The platforms will not support scheduling.</td>
+<td>version 3.0.0 or higher</td>
 </tr>
-<tr class="row-odd"><td><a class="reference external" href="http://xmlsoft.org/">libxml</a></td>
+<tr class="row-even"><td><a class="reference external" href="http://xmlsoft.org/">libxml</a></td>
 <td>libxml2-dev</td>
 <td>libxml2-devel</td>
+<td>no</td>
+<td>&nbsp;</td>
+</tr>
+<tr class="row-odd"><td><a class="reference external" href="http://shapelib.maptools.org">shapelib</a></td>
+<td>shapelib</td>
 <td>&nbsp;</td>
 <td>no</td>
+<td>version 1.3.0 or higher</td>
 </tr>
 </tbody>
 </table>
@@ -1145,18 +1166,30 @@ membership.</p>
 <td>&nbsp;</td>
 <td>Perl library needed by cyradm</td>
 </tr>
-<tr class="row-even"><td><a class="reference external" href="http://zlib.net/">zlib</a></td>
+<tr class="row-even"><td><a class="reference external" href="https://www.libsrs2.org/">libsrs2</a></td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>Sender Rewriting Scheme for lmtp, used on Sieve redirect</td>
+</tr>
+<tr class="row-odd"><td><a class="reference external" href="http://zlib.net/">zlib</a></td>
 <td>zlib1g-dev</td>
 <td>zlib-devel</td>
 <td>no</td>
 <td>Compression support for httpd</td>
 </tr>
-<tr class="row-odd"><td><a class="reference external" href="https://github.com/google/brotli">libbrotli</a></td>
+<tr class="row-even"><td><a class="reference external" href="https://github.com/google/brotli">libbrotli</a></td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
 <td>&nbsp;</td>
 <td>Brotli compression support for httpd</td>
 </tr>
+<tr class="row-odd"><td><a class="reference external" href="https://tatsuhiro-t.github.io/wslay/">wslay</a></td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>&nbsp;</td>
+<td>WebSockets support in httpd</td>
+</tr>
 <tr class="row-even"><td><a class="reference external" href="https://nghttp2.org/">nghttp2</a></td>
 <td>libnghttp2-dev</td>
 <td>libnghttp2-devel</td>
@@ -1183,7 +1216,8 @@ membership.</p>
 </div>
 <div class="section" id="compile-cyrus">
 <h2>Compile Cyrus<a class="headerlink" href="#compile-cyrus" title="Permalink to this headline">¶</a></h2>
-<p>There are additional <a class="reference internal" href="install-xapian.html#imapinstall-xapian"><span class="std std-ref">compile and installation steps</span></a> if you are using Xapian for searching.</p>
+<p>There are additional <a class="reference internal" href="install-xapian.html#imapinstall-xapian"><span class="std std-ref">compile and installation steps</span></a> if you are using Xapian for searching,
+or if you are <a class="reference internal" href="jmap.html#developer-jmap"><span class="std std-ref">using jmap</span></a>.</p>
 <div class="section" id="default-build-mail-only">
 <h3>Default build: mail only<a class="headerlink" href="#default-build-mail-only" title="Permalink to this headline">¶</a></h3>
 <pre class="literal-block">
@@ -1210,10 +1244,10 @@ problems.</p>
 <p>Some features are disabled by default and must be explicitly enabled
 via configure.</p>
 <p>Sieve is enabled by default.</p>
-<div class="section" id="caldav-and-carddav">
-<h4>CalDAV and CardDAV<a class="headerlink" href="#caldav-and-carddav" title="Permalink to this headline">¶</a></h4>
+<div class="section" id="caldav-carddav-jmap">
+<h4>CalDAV, CardDAV, JMAP<a class="headerlink" href="#caldav-carddav-jmap" title="Permalink to this headline">¶</a></h4>
 <blockquote>
-<div><code class="docutils literal"><span class="pre">./configure</span> <span class="pre">--enable-http</span> <span class="pre">--enable-calalarmd</span></code></div></blockquote>
+<div><code class="docutils literal"><span class="pre">./configure</span> <span class="pre">--enable-http</span> <span class="pre">--enable-calalarmd</span> <span class="pre">--enable-jmap</span></code></div></blockquote>
 </div>
 <div class="section" id="murder">
 <h4>Murder<a class="headerlink" href="#murder" title="Permalink to this headline">¶</a></h4>
@@ -1285,7 +1319,7 @@ version, operating system and affected l
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 27 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 11 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1305,7 +1339,7 @@ version, operating system and affected l
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/cyrusworks.html 3.2.0-3/doc/html/imap/developer/cyrusworks.html
--- 3.0.13-5/doc/html/imap/developer/cyrusworks.html	2019-12-16 04:16:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/cyrusworks.html	2020-05-04 04:11:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Works &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Works &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Developers" href="../../developers.html"/>
-        <link rel="next" title="Support/Community" href="../../support.html"/>
+        <link rel="next" title="Developer APIs" href="API.html"/>
         <link rel="prev" title="Releasing new builds of ancient Cyrus IMAP versions" href="ancient-releasing.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2 current"><a class="current reference internal" href="#">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/cyrusworks.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/cyrusworks.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,20 +787,12 @@
 <h1>Cyrus Works<a class="headerlink" href="#cyrus-works" title="Permalink to this headline">¶</a></h1>
 <div class="section" id="about-cyrus-works">
 <h2>About Cyrus Works<a class="headerlink" href="#about-cyrus-works" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference external" href="https://cyrus.works">Cyrus Works</a> is a domain redirection to the Cyrus
+IMAP project&#8217;s Travis CI dashboard.</p>
 <p>Whenever the Cyrus team push changes to
-<a class="reference external" href="https://github.com/cyrusimap/">the project repository</a>, a notification is
-sent to <a class="reference external" href="https://jenkins.io/">Jenkins</a> (open source automation server).
-Our Jenkins server is called Cyrus Works and can be found at
-<a class="reference external" href="https://www.cyrus.works">https://www.cyrus.works</a>.</p>
-</div>
-<div class="section" id="testing">
-<h2>Testing<a class="headerlink" href="#testing" title="Permalink to this headline">¶</a></h2>
-<p>Once a week Cyrus.Works builds a complete image, fetching all upstream packages.</p>
-<p>Interim builds during the week use the cached weekly image and apply the latest
-Cyrus IMAP code changes from Git.</p>
-<p>Email notifications of build results are sent to the development team.</p>
-<p>Cyrus.works will fail is certain strings are found in the log files.  To view results and filter errors/warnings view:
-<a class="reference external" href="https://cyrus.works/job/master-jessie/lastFailedBuild/parsed_console/">https://cyrus.works/job/master-jessie/lastFailedBuild/parsed_console/</a></p>
+<a class="reference external" href="https://github.com/cyrusimap/">the project repository</a>, Travis CI
+(via github integration) automatically builds the new commits.  This also
+applies to pull requests submitted through the GitHub site.</p>
 </div>
 <div class="section" id="how-it-works">
 <h2>How it works<a class="headerlink" href="#how-it-works" title="Permalink to this headline">¶</a></h2>
@@ -789,20 +800,6 @@ Cyrus IMAP code changes from Git.</p>
 framework gets pulled in to the
 <a class="reference external" href="https://github.com/cyrusimap/cyrus-docker">Docker Container</a>, confirms
 existing functionality still works and no regression bugs have been introduced.</p>
-<p>You can find out more about Cyrus.Works in the <a class="reference external" href="https://blog.fastmail.com/2016/12/14/cyrus-works/">FastMail 2016 advent series blog post</a>.</p>
-<p>The code used to build Cyrus.works is available <a class="reference external" href="https://github.com/cyrusimap/cyrusworks">https://github.com/cyrusimap/cyrusworks</a>.</p>
-</div>
-<div class="section" id="adding-rules">
-<h2>Adding Rules<a class="headerlink" href="#adding-rules" title="Permalink to this headline">¶</a></h2>
-<p>Instructions on how to add rules:
-<a class="reference external" href="https://wiki.jenkins.io/display/JENKINS/Log+Parser+Plugin">https://wiki.jenkins.io/display/JENKINS/Log+Parser+Plugin</a></p>
-<p>The rules for Cyrus Works are stored within git: <a class="reference external" href="https://github.com/cyrusimap/cyrusworks/blob/master/Scripts/cyrusworksrules">https://github.com/cyrusimap/cyrusworks/blob/master/Scripts/cyrusworksrules</a></p>
-<p>You need to add rules to two places:</p>
-<ol class="arabic simple">
-<li><strong>Git</strong>: so when cyrus.works is reinstalled those rules are not lost</li>
-</ol>
-<p>2. <strong>The server</strong>: so they’re actually used. Changed pushed to git aren’t pushed to the server. This is for security reasons (we don’t want anyone on the internet to be able to push changes to a live server).
-<code class="docutils literal"><span class="pre">root&#64;cyrus.works:/cyrusworks/source/Scripts/cyrusworksrules</span></code></p>
 </div>
 </div>
 
@@ -812,7 +809,7 @@ existing functionality still works and n
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../../support.html" class="btn btn-neutral float-right" title="Support/Community" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="API.html" class="btn btn-neutral float-right" title="Developer APIs" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="ancient-releasing.html" class="btn btn-neutral" title="Releasing new builds of ancient Cyrus IMAP versions" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -824,7 +821,7 @@ existing functionality still works and n
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Nov 14 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 15 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -844,7 +841,7 @@ existing functionality still works and n
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/developer-testing.html 3.2.0-3/doc/html/imap/developer/developer-testing.html
--- 3.0.13-5/doc/html/imap/developer/developer-testing.html	2019-12-16 04:16:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/developer-testing.html	2020-05-04 04:11:27.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Developer Test Environment &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Developer Test Environment &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
-        <link rel="next" title="Tips for Hacking on Cyrus" href="developer-tips.html"/>
+        <link rel="next" title="JMAP support" href="jmap.html"/>
         <link rel="prev" title="GitHub guide" href="github-guide.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/developer-testing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/developer-testing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,6 +828,7 @@ sudo cpan -i Convert::Base64
 sudo cpan -i Net::DAVTalk
 sudo cpan -i Net::CardDAVTalk
 sudo cpan -i Net::CalDAVTalk
+sudo cpan -i Mail::JMAPTalk
 sudo cpan -i Math::Int64
 </pre></div>
 </div>
@@ -958,7 +978,7 @@ sudo -u cyrus ./testrunner.pl -f pretty
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="developer-tips.html" class="btn btn-neutral float-right" title="Tips for Hacking on Cyrus" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="jmap.html" class="btn btn-neutral float-right" title="JMAP support" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="github-guide.html" class="btn btn-neutral" title="GitHub guide" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -970,7 +990,7 @@ sudo -u cyrus ./testrunner.pl -f pretty
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jul 01 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 01 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -990,7 +1010,7 @@ sudo -u cyrus ./testrunner.pl -f pretty
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/developer-tips.html 3.2.0-3/doc/html/imap/developer/developer-tips.html
--- 3.0.13-5/doc/html/imap/developer/developer-tips.html	2019-12-16 04:16:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/developer-tips.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,919 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Tips for Hacking on Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../genindex.html"/>
-        <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
-        <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
-        <link rel="next" title="Xapian for searching" href="install-xapian.html"/>
-        <link rel="prev" title="Developer Test Environment" href="developer-testing.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../index.html">Home</a></li>
-    <li><a href="../../download.html">Download</a></li>
-    <li><a href="../../contribute.html">Contribute</a></li>
-    <li><a href="../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../index.html">
-      <img src="../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../index.html">
- 
-
-  
-          
-          <img src="../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../developers.html">Developers</a> &raquo;</li>
-      
-          <li><a href="../developer.html">IMAP Developer Guide</a> &raquo;</li>
-      
-    <li>Tips for Hacking on Cyrus</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/developer-tips.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="tips-for-hacking-on-cyrus">
-<span id="cyrus-hacking"></span><h1>Tips for Hacking on Cyrus<a class="headerlink" href="#tips-for-hacking-on-cyrus" title="Permalink to this headline">¶</a></h1>
-<div class="section" id="memory-allocation">
-<h2>Memory Allocation<a class="headerlink" href="#memory-allocation" title="Permalink to this headline">¶</a></h2>
-<p>All Cyrus memory allocation should be done through the <code class="docutils literal"><span class="pre">libcyrus</span></code> functions. These are all written to correctly call fatal() in the event of an out-of-memory condition.</p>
-<p>In addition to xmalloc and xrealloc, we provide replacements for strdup, strndup, and a malloc that will guarantee zeroed block of memory (xzmalloc).</p>
-<p>If you are going to need to do a large number of small allocations, and then free them all at once, you should look at the memory pool routines, which are much faster, but will leak memory until you free the entire pool at once.</p>
-</div>
-<div class="section" id="strlcpy-vs-strncpy-vs-memcpy">
-<h2>strlcpy vs strncpy vs memcpy<a class="headerlink" href="#strlcpy-vs-strncpy-vs-memcpy" title="Permalink to this headline">¶</a></h2>
-<p>Use strlcpy when the size of the buffer is known, e.g.:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">char</span> <span class="n">buf</span><span class="p">[</span><span class="mi">50</span><span class="p">];</span>
-<span class="n">strlcpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">buf</span><span class="p">));</span>
-</pre></div>
-</div>
-<p>Use memcpy to truncate a string into a buffer you know is large enough. Note that the resulting buffer will NOT BE NULL TERMINATED.</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">memcpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="mi">4</span><span class="p">);</span>
-<span class="n">buf</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\0</span><span class="s1">&#39;</span>
-</pre></div>
-</div>
-<p>Try to avoid strncpy, since it is much slower than memcpy (it zero-fills the rest of the buffer) and isn&#8217;t as safe as strlcpy.</p>
-<p>Use of the functions in this way will reduce the confusion involved in their various behaviours. This avoids things that look like:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">strncpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span>
-<span class="n">buf</span><span class="p">[</span><span class="n">sizeof</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\0</span><span class="s1">&#39;</span><span class="p">;</span>
-</pre></div>
-</div>
-</div>
-<div class="section" id="map-refresh-and-map-free">
-<h2>map_refresh and map_free<a class="headerlink" href="#map-refresh-and-map-free" title="Permalink to this headline">¶</a></h2>
-<p>In many cases, it is far more effective to read a file via the operating system&#8217;s mmap facility than it is to via the traditional read() and lseek system calls. To this end, Cyrus provides an operating system independent wrapper around the mmap() services (or lack thereof) of the operating system.</p>
-<p>Cyrus currently only supports read-only memory maps, all writes back to a file need to be done via the more traditional facilities. This is to enable very low-performance support for operating systems which do not provide an mmap() facility via a fake userspace mmap.</p>
-<p>To create a map, simply call map_refresh on the map (details are in lib/map.h). To free it, call map_free on the same map.</p>
-<p>Despite the fact that the maps are read-only, it is often useful to open the file descriptors O_RDWR, especially if the file decriptors could possibly be used for writing elsewhere in the code. Some operating systems REQUIRE file descriptors that are mmap()ed to be opened O_RDWR, so just do it.</p>
-</div>
-<div class="section" id="network-functionality">
-<h2>Network Functionality<a class="headerlink" href="#network-functionality" title="Permalink to this headline">¶</a></h2>
-<p>Read about <a class="reference internal" href="../reference/admin/protlayer.html#admin-protlayer"><span class="std std-ref">Cyrus IMAP Prot Layer</span></a>.</p>
-</div>
-<div class="section" id="authorization-modules">
-<h2>Authorization modules<a class="headerlink" href="#authorization-modules" title="Permalink to this headline">¶</a></h2>
-<p><strong>TO DO:</strong></p>
-<blockquote>
-<div>Describe what the authorization modules do, what API needs to be implemented, etc. Also possibly discuss the auth_pts module.</div></blockquote>
-</div>
-<div class="section" id="other">
-<h2>Other<a class="headerlink" href="#other" title="Permalink to this headline">¶</a></h2>
-<ul class="simple">
-<li>Command line apps should link cli_fatal.o so they all fatal() in the same way, unless there is a really good reason they need to do something unique.</li>
-<li><dl class="first docutils">
-<dt>If you call config_init() you must call cyrus_done() before you exit.</dt>
-<dd>No one should ever call DB-&gt;init() or DB-&gt;done() cyrusdb functions except for in libcyrus_init()</dd>
-</dl>
-</li>
-<li>Try to keep #include statements for libcyrus and libimap alphabetical, and below any system includes.</li>
-<li><dl class="first docutils">
-<dt>Don&#8217;t exit at the bottom of main with exit(x) use return instead.</dt>
-<dd>For all the command line utilities that need to be sure that they are running as cyrus, it should be the first thing they do, and they should exit with an appropriate fatal() call</dd>
-</dl>
-</li>
-<li>All services should have a shut_down call. It should be the ONLY way of exiting the application (every &#8220;clean&#8221; exit from the system should be via shut_down()). fatal() should always make an attempt to call shut_down() if it can (though it should have a recursive fatal() trap just in case). Similarly, commandline utilities probably don&#8217;t need a shut_down().</li>
-</ul>
-</div>
-<div class="section" id="file-locking">
-<h2>File Locking<a class="headerlink" href="#file-locking" title="Permalink to this headline">¶</a></h2>
-<p>In order to guard against deadlocks, we want to maintain
-the same order of acquiring locks throughout the system
-(this may be violated in one or two places, but when it is it is
-commented as to why it is safe). As long as everyone plays
-by these rules, we can avoid deadlock.</p>
-<p>In an ideal world, our locking order is:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cyrus</span><span class="o">.</span><span class="n">header</span>
-<span class="n">cyrus</span><span class="o">.</span><span class="n">index</span>
-<span class="n">quota</span>
-<span class="n">seen</span>
-<span class="n">mailboxes</span> <span class="n">file</span>
-</pre></div>
-</div>
-<p>These try to go from least general to most general, so we hold the largest locks for the shortest period of time.</p>
-</div>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="install-xapian.html" class="btn btn-neutral float-right" title="Xapian for searching" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="developer-testing.html" class="btn btn-neutral" title="Developer Test Environment" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 24 2016
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/documentation.html 3.2.0-3/doc/html/imap/developer/documentation.html
--- 3.0.13-5/doc/html/imap/developer/documentation.html	2019-12-16 04:16:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/documentation.html	2020-05-04 04:11:27.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Documentation &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Documentation &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Developers" href="../../developers.html"/>
         <link rel="next" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="prev" title="We need your help" href="../../contribute.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/documentation.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/documentation.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -878,7 +897,7 @@ on its own, from the <cite>docsrc/`</cit
 <h3>imap_current_stable_version<a class="headerlink" href="#imap-current-stable-version" title="Permalink to this headline">¶</a></h3>
 <p>This is a replacement tag and will output the current stable version number defined in conf.py.</p>
 <p>Usage: <code class="docutils literal"><span class="pre">|imap_current_stable_version|</span></code></p>
-<p>Produces 3.0.13.</p>
+<p>Produces 3.2.0.</p>
 </div>
 </div>
 <div class="section" id="conventions-man-pages">
@@ -985,7 +1004,7 @@ on its own, from the <cite>docsrc/`</cit
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 19 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 19 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1005,7 +1024,7 @@ on its own, from the <cite>docsrc/`</cit
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/github-guide.html 3.2.0-3/doc/html/imap/developer/github-guide.html
--- 3.0.13-5/doc/html/imap/developer/github-guide.html	2019-12-16 04:16:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/github-guide.html	2020-05-04 04:11:28.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>GitHub guide &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>GitHub guide &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Developer Test Environment" href="developer-testing.html"/>
         <link rel="prev" title="Overview of Cyrus development environment" href="overview.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/github-guide.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/github-guide.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -849,7 +868,7 @@ will review your pull request and make s
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 07 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +888,7 @@ will review your pull request and make s
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/hacking.html 3.2.0-3/doc/html/imap/developer/guidance/hacking.html
--- 3.0.13-5/doc/html/imap/developer/guidance/hacking.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/hacking.html	2020-05-04 04:11:28.000000000 +0000
@@ -0,0 +1,1234 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Hacking &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Internationalization" href="internationalization.html"/>
+        <link rel="prev" title="Developer Guidance" href="../guidance.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Hacking</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/hacking.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-hacking"></span><div class="section" id="cyrus-imap-server-hacking">
+<h1>Cyrus IMAP Server: Hacking<a class="headerlink" href="#cyrus-imap-server-hacking" title="Permalink to this headline">¶</a></h1>
+<p>This file aims to be a guide to Cyrus coding style/conventions/useful
+utilities for people trying to approach the code in a sane way.  It&#8217;s
+not well organized right now but hopefully that will improve with time
+;)</p>
+<div class="section" id="memory-allocation">
+<h2>Memory Allocation<a class="headerlink" href="#memory-allocation" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>All cyrus memory allocation should be done through the libcyrus
+functions.  These are all written to correctly call <code class="docutils literal"><span class="pre">fatal()</span></code> in
+the event of an out-of-memory condition.</li>
+<li>In addition to <code class="docutils literal"><span class="pre">xmalloc</span></code> and <code class="docutils literal"><span class="pre">xrealloc</span></code>, we provide replacements
+for <code class="docutils literal"><span class="pre">strdup</span></code>, <code class="docutils literal"><span class="pre">strndup</span></code>, and a <code class="docutils literal"><span class="pre">malloc</span></code> that will guarantee
+zeroed block of memory (<code class="docutils literal"><span class="pre">xzmalloc</span></code>).</li>
+<li>If you are going to need to do a large number of small allocations,
+and then free them all at once, you should look at the memory pool
+routines, which are much faster, but will leak memory until you
+free the entire pool at once.</li>
+</ul>
+</div>
+<div class="section" id="strlcpy-vs-strncpy-vs-memcpy">
+<h2>strlcpy vs strncpy vs memcpy<a class="headerlink" href="#strlcpy-vs-strncpy-vs-memcpy" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>use <code class="docutils literal"><span class="pre">strlcpy</span></code> when you know the size of the buffer, e.g.:</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">char</span> <span class="n">buf</span><span class="p">[</span><span class="mi">50</span><span class="p">];</span>
+<span class="n">strlcpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">buf</span><span class="p">));</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>use <code class="docutils literal"><span class="pre">memcpy</span></code> to truncate a string into a buffer you know is large
+enough. Note that when you do this the resulting buffer will NOT BE
+NULL TERMINATED:</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">memcpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="mi">4</span><span class="p">);</span>
+<span class="n">buf</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\0</span><span class="s1">&#39;</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>you should try to avoid <code class="docutils literal"><span class="pre">strncpy</span></code>, since it is much slower than
+<code class="docutils literal"><span class="pre">memcpy</span></code> (it zero-fills the rest of the buffer) and isn&#8217;t as safe
+as <code class="docutils literal"><span class="pre">strlcpy</span></code>.</li>
+<li>Use of the functions in this way will reduce the confusion involved
+in their various behaviors. In other words, this avoids things that
+look like:</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">strncpy</span><span class="p">(</span><span class="n">buf</span><span class="p">,</span> <span class="n">src</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span>
+</pre></div>
+</div>
+</div>
+<div class="section" id="map-refresh-and-map-free">
+<h2>map_refresh and map_free<a class="headerlink" href="#map-refresh-and-map-free" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>In many cases, it is far more effective to read a file via the
+operating system&#8217;s mmap facility than it is to via the traditional
+<code class="docutils literal"><span class="pre">read()</span></code> and <code class="docutils literal"><span class="pre">lseek</span></code> system calls.  To this end, Cyrus provides
+an operating system independent wrapper around the <code class="docutils literal"><span class="pre">mmap()</span></code>
+services (or lack thereof) of the operating system.</li>
+<li>Cyrus currently only supports read-only memory maps, all writes back
+to a file need to be done via the more traditional facilities. This
+is to enable very low-performance support for operating systems
+which do not provide an <code class="docutils literal"><span class="pre">mmap()</span></code> facility via a fake userspace
+<code class="docutils literal"><span class="pre">mmap</span></code>.</li>
+<li>To create a map, simply call <code class="docutils literal"><span class="pre">map_refresh</span></code> on the map (details
+are in lib/map.h).  To free it, call <code class="docutils literal"><span class="pre">map_free</span></code> on the same map.</li>
+<li>Despite the fact that the maps are read-only, it is often useful
+to open the file descriptors O_RDWR, especially if the file
+descriptors could possibly be used for writing elsewhere in the
+code. Some operating systems REQUIRE file descriptors that are
+<code class="docutils literal"><span class="pre">mmap()</span></code>-ed to be opened O_RDWR, so just do it.</li>
+</ul>
+</div>
+<div class="section" id="network-functions">
+<h2>Network Functions<a class="headerlink" href="#network-functions" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Cyrus abstracts socket stream access to a concept we refer to as
+&#8220;prot streams&#8221;  Prot Streams take care of all of the necessary
+SASL and TLS/SSL encryption that may need to happen before data
+goes out/comes in from the network.  The API is documented in
+lib/prot.h</li>
+</ul>
+</div>
+<div class="section" id="todo-authorization-modules">
+<h2>(todo) Authorization Modules<a class="headerlink" href="#todo-authorization-modules" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="general-hints">
+<h2>General Hints<a class="headerlink" href="#general-hints" title="Permalink to this headline">¶</a></h2>
+<p>Some general hints that all made it into my 11/15 16:47 commit that I
+think may be generally useful to people hacking on the cyrus source:</p>
+<ul class="simple">
+<li>Command line apps should link cli_fatal.o so they all fatal()
+in the same way, unless there is a really good reason they need to
+do something unique.</li>
+<li>If you call <code class="docutils literal"><span class="pre">cyrus_init()</span></code> you must call <code class="docutils literal"><span class="pre">cyrus_done()</span></code> before
+you exit.</li>
+<li>No one should ever call <code class="docutils literal"><span class="pre">DB-&gt;init()</span></code> or <code class="docutils literal"><span class="pre">DB-&gt;done()</span></code> cyrusdb
+functions except for in <code class="docutils literal"><span class="pre">libcyrus_init()</span></code>.</li>
+<li>I&#8217;ve been trying to keep <code class="docutils literal"><span class="pre">#include</span></code> statements for libcyrus and
+libimap alphabetical, and below any system includes, but this is
+merely my personal style</li>
+<li>Don&#8217;t exit at the bottom of <code class="docutils literal"><span class="pre">main</span></code> with <code class="docutils literal"><span class="pre">exit(x)</span></code> use
+<code class="docutils literal"><span class="pre">return</span></code> instead.</li>
+<li>For all the command line utilities that need to be sure that they
+are running as the cyrus user, it should be the first thing they
+do, and they should exit with an appropriate <code class="docutils literal"><span class="pre">fatal()</span></code> call.</li>
+<li>All services should have a <code class="docutils literal"><span class="pre">shut_down</span></code> call.  It should be the
+ONLY way of exiting the application.  <code class="docutils literal"><span class="pre">fatal()</span></code> should always
+make an attempt to call <code class="docutils literal"><span class="pre">shut_down()</span></code> if it can (though it should
+have a recursive <code class="docutils literal"><span class="pre">fatal()</span></code> trap just in case).  Similarly,
+command line utilities probably don&#8217;t need a <code class="docutils literal"><span class="pre">shut_down()</span></code>.</li>
+</ul>
+</div>
+<div class="section" id="coding-standards">
+<h2>Coding Standards<a class="headerlink" href="#coding-standards" title="Permalink to this headline">¶</a></h2>
+<p>These are the generally agreed upon coding standards as thrashed
+out on the cyrus-devel list in June 2010.</p>
+<ul class="simple">
+<li>Spacing is 4 characters with soft tabs at 8 - mixed tabs and spaces
+This corresponds to the vi settings <cite>sw=4 sts=4 ts=8</cite> etc.</li>
+<li>Group the &#8216;*&#8217; character with the variable not the type, i.e.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">char</span> <span class="o">*</span><span class="n">foo</span><span class="p">;</span>  <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="n">char</span><span class="o">*</span> <span class="n">foo</span><span class="p">;</span>  <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>The keywords &#8216;if&#8217;, &#8216;for&#8217;, and &#8216;while&#8217; take a space after the keyword.
+The parentheses around the following expression are not closely
+connected to the expression without any spaces.  The &#8216;;&#8217; inside
+the &#8216;for&#8217; expression have a space after them and not before.
+For example:</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="p">(</span><span class="n">condition</span><span class="p">)</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">if</span><span class="p">(</span><span class="n">condition</span><span class="p">)</span>               <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">if</span><span class="p">(</span> <span class="n">condition</span> <span class="p">)</span>             <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">for</span> <span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">x</span><span class="p">;</span> <span class="n">i</span><span class="o">++</span><span class="p">)</span>     <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">for</span><span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">x</span><span class="p">;</span> <span class="n">i</span><span class="o">++</span><span class="p">)</span>      <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">for</span> <span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span> <span class="p">;</span><span class="n">i</span> <span class="o">&lt;</span> <span class="n">x</span> <span class="p">;</span><span class="n">i</span><span class="o">++</span><span class="p">)</span>     <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">for</span><span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span> <span class="p">;</span><span class="n">i</span> <span class="o">&lt;</span> <span class="n">x</span> <span class="p">;</span><span class="n">i</span><span class="o">++</span><span class="p">)</span>      <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">foo</span><span class="p">)</span>                 <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">while</span><span class="p">(</span><span class="n">foo</span><span class="p">)</span>                  <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">while</span><span class="p">(</span> <span class="n">foo</span> <span class="p">)</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>Use spaces around the double-character logical operator
+&#8216;||&#8217; but don&#8217;t use spaces around single-character bitwise
+operator &#8216;|&#8217;.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">flags</span> <span class="o">=</span> <span class="n">FOO</span><span class="o">|</span><span class="n">BAR</span><span class="p">;</span>        <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="nb">int</span> <span class="n">flags</span> <span class="o">=</span> <span class="n">FOO</span> <span class="o">|</span> <span class="n">BAR</span><span class="p">;</span>      <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">if</span> <span class="p">(</span><span class="n">itchy</span> <span class="o">||</span> <span class="n">scratchy</span><span class="p">)</span>      <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">if</span> <span class="p">(</span><span class="n">itchy</span><span class="o">||</span><span class="n">scratchy</span><span class="p">)</span>        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>Function definitions are followed by a brace on a line by itself,
+all other braces are inline.  Return types are inline with function
+definition.  Old K&amp;R style function definitions are not allowed.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">void</span> <span class="n">thing</span><span class="p">(</span><span class="nb">int</span> <span class="n">val</span><span class="p">)</span>         <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+<span class="n">void</span>                        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="n">thing</span><span class="p">(</span><span class="nb">int</span> <span class="n">val</span><span class="p">)</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="n">void</span>                        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="n">thing</span><span class="p">(</span>                      <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="nb">int</span> <span class="n">val</span><span class="p">)</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="n">void</span>                        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="n">antique</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="nb">int</span> <span class="n">val</span><span class="p">;</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="n">void</span> <span class="n">thing</span><span class="p">(</span><span class="nb">int</span> <span class="n">val</span><span class="p">)</span> <span class="p">{</span>       <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="n">void</span> <span class="n">noargs</span><span class="p">(</span><span class="n">void</span><span class="p">)</span>           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+<span class="n">void</span> <span class="n">noargs</span><span class="p">()</span>               <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>Long argument lists should be split across multiple lines,
+with the second and subsequent lines indented so that they
+line up with the start of the first line of arguments.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">void</span> <span class="n">toomanyargs</span><span class="p">(</span><span class="nb">int</span> <span class="n">arg1</span><span class="p">,</span> <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">arg2</span><span class="p">,</span>        <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+                 <span class="n">struct</span> <span class="n">whatever</span> <span class="o">*</span><span class="n">arg3</span><span class="p">,</span> <span class="nb">int</span> <span class="n">arg4</span><span class="p">)</span>   <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">{</span>                                                   <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                                                   <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+<span class="n">void</span> <span class="n">toomanyargs</span><span class="p">(</span><span class="nb">int</span> <span class="n">arg1</span><span class="p">,</span> <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">arg2</span><span class="p">,</span>        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="n">struct</span> <span class="n">whatever</span> <span class="o">*</span><span class="n">arg3</span><span class="p">,</span> <span class="nb">int</span> <span class="n">arg4</span><span class="p">)</span>                    <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                                                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                                                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="n">void</span> <span class="n">toomanyargs</span><span class="p">(</span>                                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="nb">int</span> <span class="n">arg1</span><span class="p">,</span>                                       <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="n">const</span> <span class="n">char</span> <span class="o">*</span><span class="n">arg2</span><span class="p">,</span>                               <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="n">struct</span> <span class="n">whatever</span> <span class="o">*</span><span class="n">arg3</span><span class="p">,</span>                          <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="nb">int</span> <span class="n">arg4</span><span class="p">)</span>                                       <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                                                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>
+<span class="p">}</span>                                                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>Within a function, braces are used in old-fashioned K&amp;R style.
+Specifically:<ul>
+<li>open braces are placed at the end of the line containing the
+statement (such as an &#8216;if&#8217;) to which they belong, after a
+single space.</li>
+<li>closing braces are placed on a line by themselves, aligned
+with the start of the statement to which their matching
+open brace belongs.</li>
+<li>this applies even when the closing brace is followed by
+an &#8216;else&#8217; keyword.</li>
+</ul>
+</li>
+</ul>
+<blockquote>
+<div>Yes, it&#8217;s ugly and hard to read, but you get used to it and
+most of the code is currently like that.  Deal with it.</div></blockquote>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span> <span class="p">{</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">){</span>               <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span> <span class="p">{</span> <span class="o">...</span><span class="n">body</span><span class="o">...</span> <span class="p">}</span> <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span> <span class="p">{</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span> <span class="p">}</span>            <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">while</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span>                <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+  <span class="p">{</span>                         <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+  <span class="p">}</span>                         <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">if</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span> <span class="p">{</span>                 <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">else</span> <span class="k">if</span> <span class="p">(</span><span class="n">othercond</span><span class="p">)</span> <span class="p">{</span>       <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="k">else</span> <span class="p">{</span>                      <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+<span class="k">if</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span> <span class="p">{</span>                 <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span> <span class="k">else</span> <span class="k">if</span> <span class="p">(</span><span class="n">othercond</span><span class="p">)</span> <span class="p">{</span>     <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span> <span class="k">else</span> <span class="p">{</span>                    <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+
+<span class="k">if</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span>                   <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">else</span> <span class="k">if</span> <span class="p">(</span><span class="n">othercond</span><span class="p">)</span>         <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="k">else</span>                        <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+    <span class="o">...</span><span class="n">body</span><span class="o">...</span>              <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">WRONG</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>The braces around a block used in an &#8216;if&#8217;...&#8217;else if&#8217;...&#8217;else&#8217;
+may be omitted if the statement is very simple and clear, such
+as a single function call.  This is a judgement call though,
+so play it safe and use braces.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="p">(</span><span class="n">cond</span><span class="p">)</span>                   <span class="o">/*</span> <span class="n">correct</span><span class="p">,</span> <span class="n">maybe</span> <span class="o">*/</span>
+    <span class="n">function</span><span class="p">();</span>             <span class="o">/*</span> <span class="n">correct</span><span class="p">,</span> <span class="n">maybe</span> <span class="o">*/</span>
+<span class="k">else</span>                        <span class="o">/*</span> <span class="n">correct</span><span class="p">,</span> <span class="n">maybe</span> <span class="o">*/</span>
+    <span class="n">other_function</span><span class="p">();</span>       <span class="o">/*</span> <span class="n">correct</span><span class="p">,</span> <span class="n">maybe</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<ul class="simple">
+<li>The &#8216;goto&#8217; keyword needs to be used very very sparingly and only
+with forethought.  The only clearly good example is to goto
+a label at the end of a function to do cleanup under error
+conditions.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">void</span> <span class="n">foo</span><span class="p">(</span><span class="n">struct</span> <span class="n">bar</span> <span class="o">*</span><span class="n">b</span><span class="p">)</span>     <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">{</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="n">char</span> <span class="o">*</span><span class="n">x</span> <span class="o">=</span> <span class="n">xmalloc</span><span class="p">(</span><span class="o">...</span><span class="p">);</span> <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+    <span class="k">if</span> <span class="p">(</span><span class="n">b</span> <span class="o">==</span> <span class="n">NULL</span><span class="p">)</span>          <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+        <span class="n">goto</span> <span class="n">error</span><span class="p">;</span>         <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+    <span class="k">if</span> <span class="p">(</span><span class="n">b</span><span class="o">-&gt;</span><span class="n">quux</span> <span class="o">!=</span> <span class="mi">42</span><span class="p">)</span>      <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+        <span class="n">goto</span> <span class="n">error</span><span class="p">;</span>         <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+
+    <span class="o">...</span><span class="n">do</span> <span class="n">useful</span> <span class="n">things</span><span class="o">...</span>  <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="n">error</span><span class="p">:</span>                      <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+    <span class="n">free</span><span class="p">(</span><span class="n">x</span><span class="p">);</span>                <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+<span class="p">}</span>                           <span class="o">/*</span> <span class="n">correct</span> <span class="o">*/</span>
+</pre></div>
+</div>
+<blockquote>
+<div>Very occasionally, it may be permissable to use &#8216;goto&#8217; from within
+a complicated or multiply-nested loop, to the top of a loop, but
+only if using another control structure is <em>less</em> clear.</div></blockquote>
+<ul class="simple">
+<li>Generally, zero return is SUCCESS and integer return is an error code.</li>
+<li>Use &#8220;<code class="docutils literal"><span class="pre">const</span> <span class="pre">char</span> <span class="pre">*</span></code>&#8221; where possible.</li>
+</ul>
+<div class="highlight-default"><div class="highlight"><pre><span></span>int is_tacky(const char *name)              /* correct */
+{                                           /* correct */
+    return !strcmp(name, &quot;britney&quot;);        /* correct */
+}                                           /* correct */
+
+int is_tacky(char *name)                    /* WRONG */
+{                                           /* WRONG */
+    return !strcmp(name, &quot;britney&quot;);        /* WRONG */
+}                                           /* WRONG */
+</pre></div>
+</div>
+<ul class="simple">
+<li>Use &#8220;<code class="docutils literal"><span class="pre">struct</span> <span class="pre">buf</span></code>&#8221; for variable length strings where possible.</li>
+<li>RAII <a class="reference external" href="http://en.wikipedia.org/wiki/Resource_Acquisition_Is_Initialization">http://en.wikipedia.org/wiki/Resource_Acquisition_Is_Initialization</a>
+In practice, this means each structure should have a single cleanup
+function which handles all possible states of the structure and
+is called whenever the structure needs cleaning up.  Likewise,
+any resources allocated during a function should be cleaned up
+in the same function, in a single code block at the end of the
+function (see the comments on &#8216;goto&#8217;).</li>
+<li>If you find yourself passing the same multiple parameters through many
+functions, create a struct and pass around a pointer to that instead.</li>
+<li>DON&#8217;T EVER REUSE THE SAME VARIABLE FOR TWO DIFFERENT PURPOSES IN THE SAME
+FUNCTION.  IN FACT, DON&#8217;T REUSE THE SAME VARIABLE _NAME_ FOR DIFFERENT
+PURPOSES.  KTHXBYE.  (note: this doesn&#8217;t apply to &#8216;i&#8217;, &#8216;n&#8217;, etc which are
+used in multiple loops.  It applies to using the same name for an absolute
+offset and a &#8220;within this mmap&#8221; offset though, and it also applies to
+using the same variable name for native order and network order numbers,
+which is where I&#8217;ve seen it a few times and been super frustrated!)</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="internationalization.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Internationalization" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../guidance.html" class="btn btn-neutral" title="Developer Guidance" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 16 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/internationalization.html 3.2.0-3/doc/html/imap/developer/guidance/internationalization.html
--- 3.0.13-5/doc/html/imap/developer/guidance/internationalization.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/internationalization.html	2020-05-04 04:11:29.000000000 +0000
@@ -0,0 +1,1211 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Internationalization &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Locking" href="locking.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Hacking" href="hacking.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Internationalization</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/internationalization.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-internationalization"></span><div class="section" id="cyrus-imap-server-internationalization">
+<h1>Cyrus IMAP Server: Internationalization<a class="headerlink" href="#cyrus-imap-server-internationalization" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="introduction">
+<h2>introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
+<p>Cyrus currently transcodes characters to a canonical UTF-8 form for
+searching. The base spec of IMAP4 only requires understanding multiple
+character sets to properly implement SEARCH. Since the base spec came
+out, several extensions have been proposed that require further charset
+support: SORT, THREAD, and the Sieve subsystem. As of this writing,
+Cyrus doesn&#8217;t correctly support these other commands.</p>
+<p>Cyrus currently only believes in 16-bit characters. Technically, Unicode
+has up to 21-bit characters (expressible in UTF-16 and 3-byte UTF-8) and
+ISO 10646 allows up to 31-bit characters (though ISO&#8217;s current policy is
+to not allocate any characters outside of the 21-bit Unicode range). The
+lower 16-bit characters make up the basic multilingual plane (BMP) where
+the majority of languages live. This restriction is apparent in
+<code class="docutils literal"><span class="pre">charset.c:writeutf8()</span></code>, the UTF-8 decoders, and the Unicode
+canonicalization table used by Cyrus. Since Cyrus&#8217;s known character sets
+(except for UTF-8) don&#8217;t contain any characters off of the BMP this
+isn&#8217;t seen to be a major problem.</p>
+<p>Throughout this text, Unicode and ISO 10646 will be used interchangeable
+to refer to the 16-bit character set of the BMP, regardless of encoding.
+&#8220;Character&#8221;, unless otherwise specified, refers to a single Unicode
+character <code class="docutils literal"><span class="pre">ffff</span></code> or under.</p>
+</div>
+<div class="section" id="cyrus-canonical-form">
+<h2>cyrus canonical form<a class="headerlink" href="#cyrus-canonical-form" title="Permalink to this headline">¶</a></h2>
+<p>Since when users search e-mail messages it&#8217;s much easier for them to
+eliminate false positives than realize there are hits that aren&#8217;t
+displayed, the Cyrus searching algorithm errs on the side of more
+matches. Before comparing any two strings, Cyrus puts them in a
+canonical form. Logically, the process works as follows:</p>
+<ul class="simple">
+<li>the input string is translated into a sequence of Unicode characters.</li>
+<li>each character is transformed into lowercase. (For some characters, a
+single uppercase character may transform into multiple lowercase
+characters.)</li>
+<li>each character is fully decomposed.</li>
+<li>all whitespace (Unicode general categories starting with <code class="docutils literal"><span class="pre">Z</span></code>) is
+removed.</li>
+<li>combining diacritical marks, such as the accent on é, are removed.
+(These are Unicode characters <code class="docutils literal"><span class="pre">0300</span></code>-<code class="docutils literal"><span class="pre">03ff</span></code>.)</li>
+<li>certain characters are expanded to alternative spellings using ASCII
+characters, such as &#8220;æ&#8221; to &#8220;ae&#8221;.</li>
+<li>the output characters are then encoded in UTF-8.</li>
+</ul>
+<p>The actual transcoding does all of these steps at once with the aid of
+tables, carefully built at compile-time.</p>
+<p>The central part of Cyrus&#8217;s internationalization support is it&#8217;s
+transcoding routines in <code class="docutils literal"><span class="pre">lib/charset.[ch]</span></code>, and
+<code class="docutils literal"><span class="pre">lib/chartable.[ch]</span></code>. Cyrus&#8217;s transcoding routines are very elegant
+and very compact, thus somewhat intimidating. During compilation, Cyrus
+builds up a large number of tables (see <a class="reference external" href="#mkchartable">mkchartable</a>)
+and uses them so that it never has to consider more than a single octet
+at a time while outputting the Cyrus canonical form for an input string.</p>
+</div>
+<div class="section" id="external-interface">
+<h2>external interface<a class="headerlink" href="#external-interface" title="Permalink to this headline">¶</a></h2>
+<p><code class="docutils literal"><span class="pre">lib/charset.h</span></code> is the public interface for Cyrus lib clients to get
+character canonicalization and searching support. In contains the
+following functions:</p>
+<dl class="docutils">
+<dt><code class="docutils literal"><span class="pre">char</span> <span class="pre">*charset_convert(const</span> <span class="pre">char</span> <span class="pre">*s,</span> <span class="pre">int</span> <span class="pre">charset,</span> <span class="pre">char</span> <span class="pre">*buf,</span> <span class="pre">int</span> <span class="pre">bufsz)</span></code></dt>
+<dd>Given a string <em>s</em> in charset <em>charset</em>, decode it into canonical
+form in <em>buf</em>. <em>buf</em> must be reallocable and currently at least size
+<em>bufsz</em>.</dd>
+<dt><code class="docutils literal"><span class="pre">char</span> <span class="pre">*charset_decode_mimeheader(const</span> <span class="pre">char</span> <span class="pre">*s,</span> <span class="pre">char</span> <span class="pre">*buf,</span> <span class="pre">int</span> <span class="pre">bufsz)</span></code></dt>
+<dd>Given a string <em>s</em> containing possible MIME encoded substrings (per
+RFC 2047), decode into canonical form in <em>buf</em>. <em>buf</em> must be
+reallocable and currently at least size <em>bufsz</em>.</dd>
+<dt><code class="docutils literal"><span class="pre">charset_index</span> <span class="pre">charset_lookupname(const</span> <span class="pre">char</span> <span class="pre">*name)</span></code></dt>
+<dd>Given <em>name</em> return the Cyrus charset index. 0 always represents
+US-ASCII. The returned charset_index may be saved in a file; it is
+stable and is an integer. If this version of Cyrus does not support
+the charset, <code class="docutils literal"><span class="pre">CHARSET_UNKNOWN_CHARSET</span></code> is returned.</dd>
+<dt><code class="docutils literal"><span class="pre">comp_pat</span> <span class="pre">*charset_compilepat(const</span> <span class="pre">char</span> <span class="pre">*s)</span></code></dt>
+<dd>Compiles a NUL-terminated canonicalized string <em>s</em> into a
+Boyer-Moore table for fast searching. I&#8217;ll describe these <a class="reference external" href="#comp_pat">compiled
+patterns</a> later.</dd>
+<dt><code class="docutils literal"><span class="pre">void</span> <span class="pre">charset_freepat(comp_pat</span> <span class="pre">*pat)</span></code></dt>
+<dd>Frees a pattern previously return by <code class="docutils literal"><span class="pre">charset_compilepat()</span></code>.</dd>
+<dt><code class="docutils literal"><span class="pre">int</span> <span class="pre">charset_searchstring(const</span> <span class="pre">char</span> <span class="pre">*substr,</span> <span class="pre">comp_pat</span> <span class="pre">*pat,</span>&#160;&#160;&#160;&#160; <span class="pre">const</span> <span class="pre">char</span> <span class="pre">*s,</span> <span class="pre">int</span> <span class="pre">len)</span></code></dt>
+<dd>Searches for a canonicalized string <em>substr</em> in the canonicalized
+string <em>s</em>. <em>s</em> is of length <em>len</em>. <em>substr</em> must have been
+previously compiled into <em>pat</em>. Returns non-zero for a hit, zero for
+no match.</dd>
+<dt><code class="docutils literal"><span class="pre">int</span> <span class="pre">charset_searchfile(const</span> <span class="pre">char</span> <span class="pre">*substr,</span> <span class="pre">comp_pat</span> <span class="pre">*pat,</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">const</span> <span class="pre">char</span> <span class="pre">*msg_base,</span> <span class="pre">int</span> <span class="pre">mapnl,</span> <span class="pre">int</span> <span class="pre">len,</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">charset_index</span> <span class="pre">charset,</span> <span class="pre">int</span> <span class="pre">encoding)</span></code></dt>
+<dd>Searches for the canonicalized string <em>substr</em> with compiled pattern
+<em>pat</em> in a large buffer starting at <em>msg_base</em> of length <em>len</em>. The
+large buffer is of charset <em>charset</em> with the encoding <em>encoding</em>.
+<code class="docutils literal"><span class="pre">charset_searchfile()</span></code> will dynamically unencode and canonicalize
+the search text looking for <em>substr</em>. (If <em>mapnl</em> is set, the buffer
+has only <code class="docutils literal"><span class="pre">\n</span></code> instead of <code class="docutils literal"><span class="pre">\r\n</span></code>, but the length assumes that
+each <code class="docutils literal"><span class="pre">\n</span></code> is dynamically converted to <code class="docutils literal"><span class="pre">\r\n</span></code>. This feature is
+deprecated.)</dd>
+<dt><code class="docutils literal"><span class="pre">char</span> <span class="pre">*charset_decode_mimebody(const</span> <span class="pre">char</span> <span class="pre">*msg_base,</span> <span class="pre">int</span> <span class="pre">len,</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">int</span> <span class="pre">encoding,</span> <span class="pre">char</span> <span class="pre">**buf,</span> <span class="pre">int</span> <span class="pre">*bufsz,</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">int</span> <span class="pre">*outlen)</span></code></dt>
+<dd>Decode the MIME body part (per RFC 2045) located in the large buffer
+starting at <em>msg_base</em> of length <em>len</em>. The large buffer is of
+encoding <em>encoding</em>. <code class="docutils literal"><span class="pre">charset_decode_mimebody()</span></code> will decode into
+<em>buf</em>. <em>buf</em> must be reallocable and currently at least size
+<em>bufsz</em>. The number of decoded bytes is returned in <em>outlen</em>.</dd>
+<dt><code class="docutils literal"><span class="pre">charset_extractfile()</span></code></dt>
+<dd>Used by <code class="docutils literal"><span class="pre">squatter</span></code> and possibly other text indexing engines, but
+not described here.</dd>
+</dl>
+</div>
+<div class="section" id="the-translate-macro-using-the-transcoding-tables">
+<h2>the TRANSLATE macro: using the transcoding tables<a class="headerlink" href="#the-translate-macro-using-the-transcoding-tables" title="Permalink to this headline">¶</a></h2>
+<p>The external interface is implemented with the help of the <code class="docutils literal"><span class="pre">START</span></code> and
+<code class="docutils literal"><span class="pre">TRANSLATE</span></code> macros:</p>
+<dl class="docutils">
+<dt><code class="docutils literal"><span class="pre">void</span> <span class="pre">START(struct</span> <span class="pre">decode_state</span> <span class="pre">*state,</span> <span class="pre">const</span> <span class="pre">unsigned</span> <span class="pre">char</span> <span class="pre">(*table)[256][4])</span></code></dt>
+<dd><code class="docutils literal"><span class="pre">START</span></code> initializes <em>state</em> to be ready for transcoding of the
+charset translation table given with <em>table</em>. The starting active
+table is always the first one in the list passed in.</dd>
+<dt><code class="docutils literal"><span class="pre">void</span> <span class="pre">TRANSLATE(struct</span> <span class="pre">decode_state</span> <span class="pre">*state,</span> <span class="pre">unsigned</span> <span class="pre">char</span> <span class="pre">input,</span> <span class="pre">unsigned</span> <span class="pre">char</span> <span class="pre">*outbuf,</span> <span class="pre">unsigned</span> <span class="pre">outindex)</span></code></dt>
+<dd><code class="docutils literal"><span class="pre">TRANSLATE</span></code> takes four parameters: <em>state</em> is the current state of
+the translation; it must have been initialized with <code class="docutils literal"><span class="pre">START</span></code> and is
+modified by <code class="docutils literal"><span class="pre">TRANSLATE</span></code>; <em>input</em> is one octet of input from the
+stream to be transcoded; <em>outbuf</em> is a pointer to the start of the
+buffer to write output characters; <em>outindex</em> is the index where
+this translation should be written. The size of <em>outbuf</em> must be at
+least <em>outindex + charset_max_translation</em>.</dd>
+</dl>
+<p>Each charset consists of a set of one or more tables; the <em>table</em>
+parameter passed into <code class="docutils literal"><span class="pre">START</span></code> is the first of these tables and the
+others are adjacent in memory. Characters are transcoded by indexing
+into the active table with <em>input</em> and examining the 4 octet
+translation. The 4 octet translation may consist of 0–3 character
+translations followed by a control code or a series of control codes. In
+effect, the translation for a given octet is a mini-program that
+consists either of UTF-8 octets or control codes. One of the control
+codes RET, END, JSR, or JMP must occur in the 4 octet translation.</p>
+<div class="section" id="control-codes">
+<h3>control codes<a class="headerlink" href="#control-codes" title="Permalink to this headline">¶</a></h3>
+<p>Control codes are represented by uppercase US-ASCII characters since no
+uppercase characters can appear in the output translation (recall that
+Cyrus canonical form downcases). Any uppercase US-ASCII character
+(<code class="docutils literal"><span class="pre">[A</span> <span class="pre">..</span> <span class="pre">Z]</span></code>) is thus interpreted specially by the <code class="docutils literal"><span class="pre">TRANSLATE</span></code>
+virtual machine. Any other octet encountered as an output translation is
+presumed to be part of the UTF-8 output sequence and copied to the
+output.</p>
+<p>The names of control codes are actually C pre-processor defines to
+uppercase US-ASCII characters. As the mnenomics are easier to
+understand, I use them in discussing their semantics.</p>
+</div>
+<div class="section" id="control-code-reference">
+<h3>control code reference<a class="headerlink" href="#control-code-reference" title="Permalink to this headline">¶</a></h3>
+<p><code class="docutils literal"><span class="pre">TRANSLATE</span></code> recognizes the following &#8220;normal&#8221; control codes:</p>
+<dl class="docutils">
+<dt>XLT</dt>
+<dd>This is the first octet of the four octet sequence, indicating that
+the desired translation is larger than 3 UTF-8 octets. The next two
+octets represent an offset to look up in the special
+chartables_long_translations[] table. After that translation is
+copied to the outbuf, the final octet is interpreted (it must be
+either a RET or an END).</dd>
+<dt>JSR</dt>
+<dd><p class="first">The <code class="docutils literal"><span class="pre">TRANSLATE</span></code> virtual machine has a stack, fixed at size 1. A
+JSR copies address of the current active table to the stack and
+transitions to the active table given by the next two octets. (For
+instance, table 1 would be the next table after the table given as a
+parameter to <code class="docutils literal"><span class="pre">START</span></code>.) Translation of the current octet stops
+after encountering a JSR.</p>
+<p>JSRs are useful for converting a two octet input character: the
+first octet in the character will make a JSR to some table; the
+second octet will produce a translation and RET to the current
+table.</p>
+<p class="last">Since the virtual machine has a fixed size stack, it would be highly
+unusual for the virtual machine to encounter two different JSRs
+without an intervening RET.</p>
+</dd>
+<dt>JMP</dt>
+<dd>Similar to JSR, but does not change the stack. It is the equivalent
+of a goto. JMPs are useful to deal with modal input character sets
+(such as an escape in ISO-2022-JP, see <a class="reference external" href="#mkchartable">how the tables are
+generated</a>).</dd>
+<dt>RET</dt>
+<dd>Indicates that we are done translating this input octet and we
+should return to the previous active table. It might appear as the
+first of the 4 translation octets, in which case this input
+character translates into nothing (it might be whitespace, for
+instance).</dd>
+<dt>END</dt>
+<dd>Indicates we are done translating this input octet. When
+<code class="docutils literal"><span class="pre">TRANSLATE</span></code> is next called, that input octet will be interpreted
+against the current active table; the stack does not change.</dd>
+</dl>
+<p>In addition, it recognizes the following &#8220;special&#8221; control codes for
+charsets that aren&#8217;t easily represented by a set of tables, UTF-8 and
+UTF-7:</p>
+<dl class="docutils">
+<dt>U7F</dt>
+<dd>UTF-7 consists of US-ASCII characters and a special escape character
+that indicates a transition to base-64 encoded UTF-16 characters.
+The virtual machine has built in code to handle the base64 decoding.
+In UTF-7&#8217;s base64, 8 input octets result in 3 characters, so the
+tables would be rather large.</dd>
+<dt>U7N</dt>
+<dd>This indicates that the current octet is the continuation of the
+base-64 section.</dd>
+<dt>U83</dt>
+<dd>One and two character UTF-8 sequences are handled normally in the
+charset code. To keep the table size down, 3 octet sequences are
+handled specially. U83 indicates that the current input octet is the
+start of a three character sequence. It is also an implicit jump to
+the 2nd table in the UTF-8 sequence, ending this translation.</dd>
+<dt>U83_2</dt>
+<dd>This input octet 2nd of 3-octet UTF-8 input, with an implicit jump
+to the 3rd table.</dd>
+<dt>U83_3</dt>
+<dd>3rd octet of a 3-octet UTF-8 input. This produces the output
+characters and has an implicit jump to the 1st table of UTF-8.</dd>
+</dl>
+<p>Finally, it&#8217;s useful to mention the special character <code class="docutils literal"><span class="pre">EMPTY</span></code> which is
+guaranteed not to match any character. It is also represented by an
+uppercase US-ASCII character.</p>
+</div>
+</div>
+<div class="section" id="searching-and-compiled-patterns">
+<h2>searching and compiled patterns<a class="headerlink" href="#searching-and-compiled-patterns" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="boyer-moore">
+<h3>boyer-moore<a class="headerlink" href="#boyer-moore" title="Permalink to this headline">¶</a></h3>
+<p>brief description of boyer-moore xxx</p>
+</div>
+<div class="section" id="cyrus-implementation">
+<h3>cyrus implementation<a class="headerlink" href="#cyrus-implementation" title="Permalink to this headline">¶</a></h3>
+<p>why two arrays? us-ascii optimization, really kinda useless now xxx</p>
+<p>meta-data stored at the end xxx</p>
+</div>
+</div>
+<div class="section" id="generating-the-tables-mkchartable">
+<h2>generating the tables: <code class="docutils literal"><span class="pre">mkchartable</span></code><a class="headerlink" href="#generating-the-tables-mkchartable" title="Permalink to this headline">¶</a></h2>
+<p>The program <code class="docutils literal"><span class="pre">mkchartable</span></code> is used to generate the charset transcoding
+tables used by TRANSLATE. These tables are carefully constructed so no
+more than a single octet need be examined at a time; this octet results
+in either an output stream of UTF-8 characters being generated or some
+sort of state change.</p>
+<p><code class="docutils literal"><span class="pre">mkchartable</span></code> uses three different sorts of input files to generate
+these tables. These files are located in the <code class="docutils literal"><span class="pre">lib/charset</span></code> directory.</p>
+<div class="section" id="charset-tables">
+<h3>charset tables<a class="headerlink" href="#charset-tables" title="Permalink to this headline">¶</a></h3>
+<p>Each charset file maps a single charset to the corresponding Unicode
+characters. For the US-ASCII and ISO-8859-x character sets this is
+trivial: each input byte corresponds to a single Unicode character.
+(Actually, some ISO-8859-x octets do not map to any Unicode character.
+In that case, the file either does not contain that octet or map it to
+&#8220;<code class="docutils literal"><span class="pre">????</span></code>&#8221;.)</p>
+<p>Other character sets are trickier. For instance, GB-2312 has both single
+and double byte characters, but is still a simple map from input
+character to output character. More complicated are modal character
+encodings. For instance, ISO-2022-JP starts in US-ASCII mode and uses
+<code class="docutils literal"><span class="pre">1B</span></code> as an escape character followed by another two characters to
+select a new mode.</p>
+<p>The input charset labels modes with &#8220;<code class="docutils literal"><span class="pre">:</span></code>&#8221; followed by the mode name.
+The starting mode &#8220;<code class="docutils literal"><span class="pre">US-ASCII</span></code>&#8221; in ISO-2022-JP is preceded by
+&#8220;<code class="docutils literal"><span class="pre">:US-ASCII</span></code>&#8221;. Mode transitions are denoted by a Unicode conversion of
+&#8220;<code class="docutils literal"><span class="pre">&gt;newmode</span></code>&#8221; or &#8220;<code class="docutils literal"><span class="pre">:newmode</span></code>&#8221;. To denote that the octet <code class="docutils literal"><span class="pre">42</span></code>
+transitions into the &#8220;<code class="docutils literal"><span class="pre">US-ASCII</span></code>&#8221; mode, the charset file has
+&#8220;<code class="docutils literal"><span class="pre">42</span> <span class="pre">&gt;US-ASCII</span></code>&#8221;. The mode names themselves are arbitrary labels and
+have no effect on the output.</p>
+<p>The input charset labels modes with &#8221;:&#8221; followed by the mode name. The
+mode name is optionally followed by a space and the &#8220;<code class="docutils literal"><span class="pre">&lt;</span></code>&#8221; character.
+If the &#8220;<code class="docutils literal"><span class="pre">&lt;</span></code>&#8221; character is present, then all translations will be
+followed by a RET instruction instead of an END instruction.</p>
+<p>The transition &#8220;<code class="docutils literal"><span class="pre">&gt;newmode</span></code>&#8221; results in a JSR instruction being
+generated. A JMP instruction is generated by a transition of
+&#8220;<code class="docutils literal"><span class="pre">:newmode</span></code>&#8221;.</p>
+<p>The input byte can be specified as &#8220;<code class="docutils literal"><span class="pre">*</span></code>&#8221;. This is used to define the
+&#8220;default action&#8221; which is used for input bytes that are not otherwise
+defined for the mode. If the default action is not explicitly stated, it
+is a translation to EMPTY.</p>
+</div>
+<div class="section" id="unicode-data-table">
+<h3>unicode data table<a class="headerlink" href="#unicode-data-table" title="Permalink to this headline">¶</a></h3>
+<p>The <code class="docutils literal"><span class="pre">unidata2.txt</span></code> file is verbatim from the Unicode standard. More
+recent versions should be available <a class="reference external" href="http://www.unicode.org/xxx">from their
+website</a>. Each entry in the file
+describers a Unicode character by the following properties, separated by
+semicolons:</p>
+<ul class="simple">
+<li>code point (16-bit character value) in hex</li>
+<li>character name (unused by Cyrus)</li>
+<li>general category, such as whitespace or punctuation</li>
+<li>the canonical combining class (unused)</li>
+<li>bidirection category (unused)</li>
+<li>character decomposition</li>
+<li>decimal digit value (unused)</li>
+<li>digit value (unused, and, no, I don&#8217;t know the difference)</li>
+<li>numeric value including fractions (unused)</li>
+<li>mirrored character (unused)</li>
+<li>Unicode 1.0 name (unused)</li>
+<li>comment (unused)</li>
+<li>upper case equivalent (unused)</li>
+<li>lower case equivalent</li>
+</ul>
+<p>In general, Cyrus uses the lower case equivalent if there is one, and
+the decomposed value otherwise.</p>
+</div>
+<div class="section" id="unicode-fixup-table">
+<h3>unicode fixup table<a class="headerlink" href="#unicode-fixup-table" title="Permalink to this headline">¶</a></h3>
+<p>The <code class="docutils literal"><span class="pre">unifix.txt</span></code> file contains Cyrus-specific mappings for characters.
+It overrides the <code class="docutils literal"><span class="pre">unidata2.txt</span></code> table. Each rule in the file is
+explained with a comment. It&#8217;s helpful to remember that the Unicode
+general categories starting with <code class="docutils literal"><span class="pre">Z</span></code> represent whitespace, and
+whitespace is always removed.</p>
+</div>
+<div class="section" id="generating-chartable-c">
+<h3>generating <code class="docutils literal"><span class="pre">chartable.c</span></code><a class="headerlink" href="#generating-chartable-c" title="Permalink to this headline">¶</a></h3>
+<p>how <code class="docutils literal"><span class="pre">mkchartable</span></code> works: collapses the encoding modes, the unicode
+translations, and other normalizations into the output tables described
+above xxx</p>
+</div>
+</div>
+<div class="section" id="for-the-future">
+<h2>for the future<a class="headerlink" href="#for-the-future" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="sieve-acap-comparators">
+<h3>Sieve/ACAP comparators<a class="headerlink" href="#sieve-acap-comparators" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="adjustable-normalization">
+<h3>adjustable normalization?<a class="headerlink" href="#adjustable-normalization" title="Permalink to this headline">¶</a></h3>
+<p>The use of uppercase US-ASCII characters is one of the annoyances in
+trying to generalize the charset transcoding. If we continue to restrict
+the characters under consideration to the BMP, switching to UTF-8
+control codes that start 4 or 5 byte sequences is possible.</p>
+<p>Another possibility is to use a NUL character as an escape sequence,
+though this increases the size of each control code by 1 octet.</p>
+</div>
+<div class="section" id="handle-2-octet-input-characters">
+<h3>handle &gt;2 octet input characters<a class="headerlink" href="#handle-2-octet-input-characters" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="make-utf-8-more-regular">
+<h3>make UTF-8 more regular<a class="headerlink" href="#make-utf-8-more-regular" title="Permalink to this headline">¶</a></h3>
+<p>consider whether we really need U83, U83_2, U83_3. also consider
+changing <code class="docutils literal"><span class="pre">{</span> <span class="pre">U83,</span> <span class="pre">0,</span> <span class="pre">0,</span> <span class="pre">0</span> <span class="pre">}</span></code> translations to <code class="docutils literal"><span class="pre">{</span> <span class="pre">U83,</span> <span class="pre">JMP,</span> <span class="pre">0,</span> <span class="pre">1</span> <span class="pre">}</span></code>
+sequences to at least eliminate the implicit jump.</p>
+</div>
+<div class="section" id="require-minimal-utf-8-characters">
+<h3>require minimal UTF-8 characters<a class="headerlink" href="#require-minimal-utf-8-characters" title="Permalink to this headline">¶</a></h3>
+</div>
+</div>
+<div class="section" id="references">
+<h2>references<a class="headerlink" href="#references" title="Permalink to this headline">¶</a></h2>
+<p>xxx</p>
+<ul class="simple">
+<li>[UNICODE] Unicode / ISO 10646</li>
+<li>[UTF-8] utf-8 RFC</li>
+<li>[UTF-7] utf-7 RFC</li>
+<li>[BM] boyer-moore</li>
+<li>[ACAP] the comparators reference. see section XXX of RFC 2244.</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="locking.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Locking" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="hacking.html" class="btn btn-neutral" title="Cyrus IMAP Server: Hacking" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/locking.html 3.2.0-3/doc/html/imap/developer/guidance/locking.html
--- 3.0.13-5/doc/html/imap/developer/guidance/locking.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/locking.html	2020-05-04 04:11:29.000000000 +0000
@@ -0,0 +1,941 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Locking &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Mailbox File Formats" href="mailbox-format.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Internationalization" href="internationalization.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Locking</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/locking.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-locking"></span><div class="section" id="cyrus-imap-server-locking">
+<h1>Cyrus IMAP Server: Locking<a class="headerlink" href="#cyrus-imap-server-locking" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="mailboxes">
+<h2>Mailboxes<a class="headerlink" href="#mailboxes" title="Permalink to this headline">¶</a></h2>
+<p>For mailboxes, we lock in this order:</p>
+<ul class="simple">
+<li>Mailbox Namelock (shared) &lt;== possibly reversible with
+conversationsdb</li>
+<li>user conversations db</li>
+<li>cyrus.index</li>
+</ul>
+<p>If you want to do any mailboxes.db transactions, they need to open
+and close without changing any mailbox locking during the transaction.</p>
+<p>Likewise seen and statuscache are always done without changing mailbox
+locking during their transaction.</p>
+<p>Annotations databases are a mess.</p>
+</div>
+<div class="section" id="xapian">
+<h2>Xapian<a class="headerlink" href="#xapian" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Xapian per-user NAMELOCK (shared or exclusive)</li>
+<li>xapianactive file lock (shared or exclusive)</li>
+</ul>
+<p>Shared namelock holds the following invariants:</p>
+<ul class="simple">
+<li>xapianactive file contents are not changed</li>
+<li>directories mentioned in xapianactive are not cleaned up</li>
+</ul>
+<p>Xapianactive exclusive lock holds the following invariants:</p>
+<ul class="simple">
+<li>owner may write to first database mentioned in xapianactive</li>
+</ul>
+<p>Xapianactive shared lock holds:</p>
+<ul class="simple">
+<li>all databases in xapianactive are readable and a consistent
+read can be made across all of them, even with multiple requests
+while the lock is held.</li>
+</ul>
+<div class="section" id="locking-orders">
+<h3>Locking orders<a class="headerlink" href="#locking-orders" title="Permalink to this headline">¶</a></h3>
+<p>SHARED case:</p>
+<ul class="simple">
+<li>user conversations db &lt;=== possibly reversible with SHARED xapian
+namelock</li>
+<li>SHARED xapian namelock</li>
+<li>xapianactive lock (shared to search, exclusive to write)</li>
+<li>cyrus.index may be locked either side of the xapianactive lock,
+because the conversationsdb lock protects it from races.</li>
+</ul>
+<p>EXCLUSIVE case:</p>
+<ul class="simple">
+<li>EXCLUSIVE xapian namelock
+That&#8217;s it.  While you&#8217;ve got this, you can add or delete items from
+the xapianactive file, and delete paths on disk for directories
+that you have removed (either during or after locking).  No other
+locks are permitted.</li>
+</ul>
+<p>If you hold a SHARED xapian namelock, you may write to a .NEW folder
+for a xapianactive entry that you created without taking any additional
+locks, because nothing can clean it under you, and nothing else can
+read it.  This is how the repack case works.</p>
+</div>
+</div>
+<div class="section" id="lock-lifetime">
+<h2>Lock lifetime<a class="headerlink" href="#lock-lifetime" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Shared mailbox namelock:
+*   possibly hours</li>
+<li>conversations db and below
+*   short as possible</li>
+</ul>
+<p>Mailbox namelock holds the following invariants:</p>
+<ul class="simple">
+<li>cyrus.index may not be repacked, however flags and modseqs may be
+updated</li>
+<li>cyrus.annotations records may change (kind of buggy and bad,
+ideally we&#8217;d always write new ones if we changed them and keep the
+old ones)</li>
+<li>cyrus.cache may be appended, but never changed</li>
+<li>spool files may not be deleted (already can&#8217;t be changed)</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="mailbox-format.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Mailbox File Formats" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="internationalization.html" class="btn btn-neutral" title="Cyrus IMAP Server: Internationalization" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/mailbox-format.html 3.2.0-3/doc/html/imap/developer/guidance/mailbox-format.html
--- 3.0.13-5/doc/html/imap/developer/guidance/mailbox-format.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/mailbox-format.html	2020-05-04 04:11:29.000000000 +0000
@@ -0,0 +1,1318 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Mailbox File Formats &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Namelocks" href="namelocks.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Locking" href="locking.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Mailbox File Formats</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/mailbox-format.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-server-mailbox-file-formats">
+<span id="imap-developer-guidance-mailbox-format"></span><h1>Cyrus IMAP Server: Mailbox File Formats<a class="headerlink" href="#cyrus-imap-server-mailbox-file-formats" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="intro">
+<h2>Intro<a class="headerlink" href="#intro" title="Permalink to this headline">¶</a></h2>
+<p>This documentation refers to the &#8220;version 12&#8221; cyrus index format and
+associated mailbox files.</p>
+<p>No external tools should make use of this information. The only
+supported method of access to the mail store is through the standard
+interfaces: IMAP, POP, NNTP, LMTP, etc.</p>
+<p>A cyrus mailbox is a directory in the filesystem. It contains the
+following files:</p>
+<ul class="simple">
+<li>zero or more message files</li>
+<li>the <code class="docutils literal"><span class="pre">cyrus.header</span></code> metadata file</li>
+<li>the <code class="docutils literal"><span class="pre">cyrus.index</span></code> metadata file</li>
+<li>the <code class="docutils literal"><span class="pre">cyrus.cache</span></code> metadata file</li>
+<li>zero or one <code class="docutils literal"><span class="pre">cyrus.squat</span></code> search indexes</li>
+<li>zero or more subdirectories</li>
+</ul>
+<p>With &#8220;split metadata&#8221; configuration, the mailbox may actually be split
+between multiple disks, with the files being in the same relative
+directory on the meta disk. See the <code class="docutils literal"><span class="pre">imapd.conf</span></code> option
+<code class="docutils literal"><span class="pre">metapartition_files</span></code> for more information</p>
+</div>
+<div class="section" id="message-files">
+<h2>Message Files<a class="headerlink" href="#message-files" title="Permalink to this headline">¶</a></h2>
+<p>The message files are named by their UID, followed by a &#8221;.&#8221;, so UID 423
+would be named &#8220;<code class="docutils literal"><span class="pre">423.</span></code>&#8221;. They are stored in wire-format: lines are
+terminated by CRLF and binary data is not allowed.</p>
+</div>
+<div class="section" id="cyrus-header">
+<h2><code class="docutils literal"><span class="pre">cyrus.header</span></code><a class="headerlink" href="#cyrus-header" title="Permalink to this headline">¶</a></h2>
+<p>This file contains mailbox-wide information that does not change often.
+Its format:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">&lt;</span><span class="n">Mailbox</span> <span class="n">Header</span> <span class="n">Magic</span> <span class="n">String</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="n">Quota</span> <span class="n">Root</span><span class="o">&gt;</span>\<span class="n">t</span><span class="o">&lt;</span><span class="n">Mailbox</span> <span class="n">Unique</span> <span class="n">ID</span> <span class="n">String</span><span class="o">&gt;</span>\<span class="n">n</span>
+<span class="o">&lt;</span><span class="n">Space</span><span class="o">-</span><span class="n">separated</span> <span class="nb">list</span> <span class="n">of</span> <span class="n">user</span> <span class="n">flags</span><span class="o">&gt;</span>\<span class="n">n</span>
+<span class="o">&lt;</span><span class="n">Mailbox</span> <span class="n">ACL</span><span class="o">&gt;</span>\<span class="n">n</span>
+</pre></div>
+</div>
+<p>The Mailbox Unique ID String is used for non-owner per-user \Seen flags
+so they remain with the mailbox during renames, and also by the
+replication subsystem to detect mailbox renames.</p>
+<p>The ACL is a copy of the value stored in mailboxes.db, and isn&#8217;t
+actually used.</p>
+<div class="section" id="locking-considerations">
+<h3>Locking Considerations<a class="headerlink" href="#locking-considerations" title="Permalink to this headline">¶</a></h3>
+<p>The <code class="docutils literal"><span class="pre">cyrus.index</span></code> file must be locked in exclusive mode while making
+changes to the <code class="docutils literal"><span class="pre">cyrus.header</span></code> file to ensure consistency. All changes
+are made by rewriting the entire file and renaming the new version into
+place.</p>
+</div>
+</div>
+<div class="section" id="cyrus-cache">
+<h2><code class="docutils literal"><span class="pre">cyrus.cache</span></code><a class="headerlink" href="#cyrus-cache" title="Permalink to this headline">¶</a></h2>
+<p>The <code class="docutils literal"><span class="pre">cyrus.cache</span></code> file is a pure cache of information that&#8217;s also
+present in the message files. It exists to make ENVELOPE and specific
+header fetches more efficient, as well as to assist with searches and
+sorts.</p>
+<p>If a <code class="docutils literal"><span class="pre">cyrus.cache</span></code> file is missing or corrupted, it can be
+re-generated by running a <code class="docutils literal"><span class="pre">reconstruct</span></code> on the mailbox.</p>
+<p>The format is 10 individual records each prefixed with a 32 bit length
+value in network byte order. The offset of each message&#8217;s cache record
+is stored in the <code class="docutils literal"><span class="pre">cyrus.index</span></code> file (documented below). The records in
+a cyrus.cache file are of variable length, depending on the contents of
+the associated message.</p>
+<p>The first 4 bytes of the cyrus.cache file are a &#8220;generation number&#8221;
+which must match the first 4 bytes of the associated cyrus.index file.
+In the past this was used to track consistency between the files, but
+the name locking scheme and per-record CRC check in cyrus 2.4 and above
+means this is just a backup consistency check rather than an essential
+format feature.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">+------------------------------------------------------------------------+</span>
+<span class="o">|</span><span class="n">Gen</span> <span class="c1"># (32bits)|Size 1 (32bits)|Data 1                                   |</span>
+<span class="o">+------------------------------------------------------------------------+</span>
+<span class="o">|</span>           <span class="o">|</span><span class="n">Size</span> <span class="mi">2</span> <span class="p">(</span><span class="mi">32</span><span class="n">bits</span><span class="p">)</span><span class="o">|</span><span class="n">Data</span> <span class="mi">2</span>            <span class="o">|</span><span class="n">Size</span> <span class="mi">3</span> <span class="p">(</span><span class="mi">32</span><span class="n">bits</span><span class="p">)</span><span class="o">|</span> <span class="n">Data</span> <span class="mi">3</span>  <span class="o">|</span>
+<span class="o">+------------------------------------------------------------------------+</span>
+<span class="o">|</span> <span class="o">.....</span>                                                                  <span class="o">|</span>
+<span class="o">+------------------------------------------------------------------------+</span>
+</pre></div>
+</div>
+<p>While there are occasional changes to the cache format, this information
+is NOT stored in the cyrus.cache file. Instead, there is a
+&#8220;cache_version&#8221; field in the cyrus.index record, so multiple different
+versions of cache data may exist in the same cache file.</p>
+<p>The order of fields per record in the cache file is as follows: (keep in
+mind that they are all preceded by a 4 byte network byte order size).</p>
+<dl class="docutils">
+<dt>Envelope Response</dt>
+<dd>Raw IMAP response for a request for the envelope.</dd>
+<dt>Bodystructure Response</dt>
+<dd>Raw IMAP response for a request for the bodystructure.</dd>
+<dt>Body Response</dt>
+<dd>Raw IMAP response for an (old style) request for the body.</dd>
+<dt>Binary Bodystructure</dt>
+<dd><p class="first">Offsets into the message file to pull out various body parts.
+Because of the nature of MIME parts, this is somewhat recursive.</p>
+<p>This looks like the following (starting the octet following the
+cache field size). All of the fields are bit32s.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[</span>
+ <span class="p">[</span><span class="n">Number</span> <span class="n">of</span> <span class="n">message</span> <span class="n">parts</span><span class="o">+</span><span class="mi">1</span> <span class="k">for</span> <span class="n">the</span> <span class="n">rfc822</span> <span class="n">header</span> <span class="k">if</span> <span class="n">present</span><span class="p">]</span>
+ <span class="p">[</span>
+  <span class="p">[</span><span class="n">Offset</span> <span class="ow">in</span> <span class="n">the</span> <span class="n">message</span> <span class="n">file</span> <span class="n">of</span> <span class="n">the</span> <span class="n">header</span> <span class="n">of</span> <span class="n">this</span> <span class="n">part</span><span class="p">]</span>
+  <span class="p">[</span><span class="n">Size</span> <span class="p">(</span><span class="n">octets</span><span class="p">)</span> <span class="n">of</span> <span class="n">the</span> <span class="n">header</span> <span class="n">of</span> <span class="n">this</span> <span class="n">part</span><span class="p">]</span>
+  <span class="p">[</span><span class="n">Offset</span> <span class="ow">in</span> <span class="n">the</span> <span class="n">message</span> <span class="n">file</span> <span class="n">of</span> <span class="n">the</span> <span class="n">content</span> <span class="n">of</span> <span class="n">this</span> <span class="n">part</span><span class="p">]</span>
+  <span class="p">[</span><span class="n">Size</span> <span class="p">(</span><span class="n">octets</span><span class="p">)</span> <span class="n">of</span> <span class="n">the</span> <span class="n">content</span> <span class="n">of</span> <span class="n">this</span> <span class="n">part</span><span class="p">]</span>
+  <span class="p">[</span><span class="n">Encoding</span> <span class="n">Type</span> <span class="n">of</span> <span class="n">this</span> <span class="n">part</span><span class="p">]</span>
+ <span class="p">]</span>
+    <span class="p">(</span><span class="n">repeat</span> <span class="k">for</span> <span class="n">each</span> <span class="n">part</span> <span class="k">as</span> <span class="n">well</span> <span class="k">as</span> <span class="n">once</span> <span class="k">for</span> <span class="n">the</span> <span class="n">headers</span><span class="p">)</span>
+ <span class="p">[</span><span class="n">zero</span> <span class="o">*</span><span class="ow">or</span><span class="o">*</span> <span class="n">number</span> <span class="n">of</span> <span class="n">sub</span><span class="o">-</span><span class="n">parts</span> <span class="ow">in</span> <span class="n">the</span> <span class="n">case</span> <span class="n">of</span> <span class="n">a</span> <span class="n">multipart</span><span class="o">.</span>
+  <span class="k">if</span> <span class="n">nonzero</span><span class="p">,</span> <span class="n">this</span> <span class="ow">is</span> <span class="n">a</span> <span class="n">recursion</span> <span class="n">into</span> <span class="n">the</span> <span class="n">top</span> <span class="n">structure</span><span class="p">]</span>
+    <span class="p">(</span><span class="n">repeat</span> <span class="k">for</span> <span class="n">each</span> <span class="n">part</span><span class="p">)</span>
+<span class="p">]</span>
+</pre></div>
+</div>
+<p>Note if this is not a message/rfc822, than the values for the sizes
+of the part 0 are -1 (to indicate that it doesn&#8217;t exist). Sub-parts
+are not possible for a part 0, so they aren&#8217;t included when finding
+recursive entries.</p>
+<p>The offset and size info for both the mime header and content part
+are useful in order to do fast indexing on the appropriate parts of
+the message file when a client does a FETCH request for
+BODY[HEADER], or BODY[2.MIME].</p>
+<p>Note that the top level RFC822 headers are a treated as a separate
+part from their body text (&#8220;0&#8221; or &#8220;HEADER&#8221;).</p>
+<p>In the case of a multipart/alternative, the content size &amp; offset
+refers to the size of the entire mime part.</p>
+<p>A very simple message (with a single text/plain part) would
+therefore look like:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[[</span><span class="mi">2</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">header</span><span class="p">][</span><span class="n">text</span><span class="o">/</span><span class="n">plain</span> <span class="n">body</span> <span class="n">part</span> <span class="n">info</span><span class="p">][</span><span class="mi">0</span><span class="p">]]</span>
+</pre></div>
+</div>
+<p>A simple multipart/alternative message might look like:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[[</span><span class="mi">3</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">header</span><span class="p">][</span><span class="n">text</span><span class="o">/</span><span class="n">plain</span> <span class="n">message</span> <span class="n">part</span> <span class="n">info</span><span class="p">]</span>
+    <span class="p">[</span><span class="n">second</span> <span class="n">message</span> <span class="n">part</span> <span class="n">info</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]]</span>
+</pre></div>
+</div>
+<p>A message with an attachment that has two subparts:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[[</span><span class="mi">3</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">header</span> <span class="n">info</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">first</span> <span class="n">body</span> <span class="n">part</span> <span class="n">info</span><span class="p">][</span><span class="n">attachment</span> <span class="n">info</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span>
+      <span class="p">[</span><span class="mi">3</span><span class="p">][</span><span class="n">NIL</span> <span class="n">header</span> <span class="n">info</span><span class="p">][</span><span class="n">sub</span> <span class="n">part</span> <span class="mi">1</span> <span class="n">info</span><span class="p">][</span><span class="n">sub</span> <span class="n">part</span> <span class="mi">2</span> <span class="n">info</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]]]</span>
+</pre></div>
+</div>
+<p>A message with an attached message/rfc822 message with the following
+total structure:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">message</span><span class="o">/</span><span class="n">rfc822</span>
+  <span class="mi">0</span> <span class="n">headers</span><span class="p">;</span> <span class="n">content</span><span class="o">-</span><span class="nb">type</span><span class="p">:</span> <span class="n">multipart</span><span class="o">/</span><span class="n">mixed</span>
+  <span class="mi">1</span> <span class="n">text</span><span class="o">/</span><span class="n">plain</span>
+  <span class="mi">2</span> <span class="n">message</span><span class="o">/</span><span class="n">rfc822</span>
+    <span class="mi">0</span> <span class="n">headers</span><span class="p">;</span> <span class="n">content</span><span class="o">-</span><span class="nb">type</span><span class="p">:</span> <span class="n">multipart</span><span class="o">/</span><span class="n">alternative</span>
+    <span class="mi">1</span> <span class="n">text</span><span class="o">/</span><span class="n">plain</span>
+    <span class="mi">2</span> <span class="n">text</span><span class="o">/</span><span class="n">html</span>
+</pre></div>
+</div>
+<div class="last highlight-default"><div class="highlight"><pre><span></span><span class="p">[[</span><span class="mi">3</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">header</span> <span class="n">part</span> <span class="mi">0</span><span class="p">][</span><span class="n">text</span><span class="o">/</span><span class="n">plain</span> <span class="n">part</span> <span class="mi">1</span><span class="p">][</span><span class="n">overall</span> <span class="n">attachment</span> <span class="n">info</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span>
+     <span class="p">[</span><span class="mi">3</span><span class="p">][</span><span class="n">rfc822</span> <span class="n">header</span> <span class="n">part</span> <span class="mf">2.0</span><span class="p">][</span><span class="n">text</span><span class="o">/</span><span class="n">plain</span> <span class="n">part</span> <span class="mf">2.1</span><span class="p">][</span><span class="n">text</span><span class="o">/</span><span class="n">html</span> <span class="n">part</span> <span class="mf">2.2</span><span class="p">]</span>
+        <span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]]]</span>
+</pre></div>
+</div>
+</dd>
+<dt>Cache Header</dt>
+<dd><p class="first">Any cached header fields. The exact set of fields here depends on
+the cache record version - there is a function in <code class="docutils literal"><span class="pre">imap/mailbox.c</span></code>
+to determine if a named header would be cached based on the version.
+These are in the same format they would appear in the message file:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">HeaderName</span><span class="p">:</span> <span class="n">headerdata</span>\<span class="n">r</span>\<span class="n">n</span>
+</pre></div>
+</div>
+<p class="last">Examples include: References, In-Reply-To, etc.</p>
+</dd>
+<dt>From</dt>
+<dd>The from header.</dd>
+<dt>To</dt>
+<dd>The to header.</dd>
+<dt>Cc</dt>
+<dd>The CC header.</dd>
+<dt>Bcc</dt>
+<dd>The BCC header.</dd>
+<dt>Subject</dt>
+<dd>The Subject header.</dd>
+</dl>
+<div class="section" id="id1">
+<h3>Locking Considerations<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
+<p>The <code class="docutils literal"><span class="pre">cyrus.index</span></code> file must be locked in exclusive mode while making
+changes to the <code class="docutils literal"><span class="pre">cyrus.cache</span></code> file to ensure consistency. All new cache
+records are created by reading the current end-of-file offset, appending
+the new cache record, and storing that start offset into the associated
+cyrus.index record.</p>
+</div>
+</div>
+<div class="section" id="cyrus-index">
+<h2><code class="docutils literal"><span class="pre">cyrus.index</span></code><a class="headerlink" href="#cyrus-index" title="Permalink to this headline">¶</a></h2>
+<p>The cyrus.index file is NOT just a cache - it stores information not
+present in the message file!</p>
+<p>The cyrus.index file consists of a fixed width header, followed by fixed
+width records. In the past, it would be rewritten on every expunge, but
+since Cyrus 2.4 the expunged records remain in the cyrus.index file for
+a configurable time to support QRESYNC and more efficient delayed
+expunge.</p>
+<p>The cyrus.index file is the &#8220;heart&#8221; of the mailbox format - containing
+checksums (CRC32) of everything else, and the most frequently updated
+fields. All fields are stored in network byte order and aligned on 4
+byte boundaries. Due to some 64 bit values being stored, the header and
+individual records are aligned on 8 byte boundaries.</p>
+<p>The overall format looks sort of like this:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cyrus</span><span class="o">.</span><span class="n">index</span><span class="p">:</span>
+<span class="o">+----------------+</span>
+<span class="o">|</span> <span class="n">Mailbox</span> <span class="n">Header</span> <span class="o">|</span>
+<span class="o">+----------------+</span>
+<span class="o">|</span> <span class="n">Msg</span><span class="p">:</span> <span class="n">Num</span> <span class="mi">1</span>     <span class="o">|</span>
+<span class="o">+----------------+</span>
+<span class="o">|</span> <span class="n">Msg</span><span class="p">:</span> <span class="n">Num</span> <span class="mi">2</span>     <span class="o">|</span>
+<span class="o">+----------------+</span>
+<span class="o">|</span>     <span class="o">...</span>        <span class="o">|</span>
+<span class="o">+----------------+</span>
+</pre></div>
+</div>
+<p>The basic idea being that there is one header, and then all the message
+records are evenly spaced throughout the file. All of the message
+records are at well-known offsets, making any part of the file
+accessable at roughly equal speed.</p>
+<div class="section" id="id2">
+<h3>Locking Considerations<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h3>
+<p><code class="docutils literal"><span class="pre">cyrus.index</span></code> files can not be repacked (i.e. records can not change
+UID for a particular offset, and the file can&#8217;t be rewritten or deleted)
+unless there&#8217;s an exclusive namelock held for the mailbox name. This is
+to avoid race conditions and simplify the use of mailboxes. Whenever a
+mailbox is opened, the caller holds a shared namelock on the mailbox
+name for the duration of the &#8220;mailbox object&#8220;&#8216;s existence.</p>
+<p>All reads of a <code class="docutils literal"><span class="pre">cyrus.index</span></code> file must be done with a lock held, and
+all writes must be done with an exclusive lock held. This ensures CRC32
+checksums of individual headers and records are always consistent. There
+are no direct &#8220;offset&#8221; reads done any more, instead the mailbox API
+provides a way to read an entire cyrus.index header or cyrus.index
+record into a struct, performing consistency checks. Writes are also
+done with a complete record struct.</p>
+</div>
+<div class="section" id="detail-of-cyrus-index-header">
+<h3>Detail of <code class="docutils literal"><span class="pre">cyrus.index</span></code> header<a class="headerlink" href="#detail-of-cyrus-index-header" title="Permalink to this headline">¶</a></h3>
+<p>The index header contains the following information, in order:</p>
+<dl class="docutils">
+<dt>Generation Number (4 bytes)</dt>
+<dd>A number that is basically the &#8220;revision number&#8221; of the mailbox. It
+must match between the cache and index files. This is to ensure that
+if we fail to sync both the cache and index files and a crash
+happens (so that only one is synced), we do not provide bad data to
+the user. This is also backed by having individual cache checksums
+on each record.</dd>
+<dt>Format (4 bytes)</dt>
+<dd>Basically obsolete (indicates netnews or regular).</dd>
+<dt>Minor Version (4 bytes)</dt>
+<dd>Indicates the version number of the index file. This can be used for
+on-the-fly upgrades of the index and cache files.</dd>
+<dt>Start Offset (4 bytes)</dt>
+<dd>Size of index header.</dd>
+<dt>Record Size (4 bytes)</dt>
+<dd>Size of an index record.</dd>
+<dt>Num Records (4 bytes)</dt>
+<dd>How many records are in this index (including records for expunged
+records. See below for &#8220;Exists&#8221; which has moved from pre-version 12
+files.</dd>
+<dt>Last Appenddate (4 bytes)</dt>
+<dd>(time_t) of the last time a message was appended</dd>
+<dt>Last UID (4 bytes)</dt>
+<dd>Highest UID of all messages in the mailbox (UIDNEXT - 1).</dd>
+<dt>Quota Mailbox Used (8 bytes)</dt>
+<dd>Total amount of storage used by all of the messages in the mailbox.
+Platforms that don&#8217;t support 64-bit integers only use the last 4
+bytes.</dd>
+<dt>POP3 Last Login (4 bytes)</dt>
+<dd>(time_t) of the last pop3 login to this INBOX, used to enforce the
+&#8220;poptimeout&#8221; <code class="docutils literal"><span class="pre">imapd.conf</span></code> option.</dd>
+<dt>UIDvalidity (4 bytes)</dt>
+<dd>The UID validitiy of this mailbox. Cyrus currently uses the
+<code class="docutils literal"><span class="pre">time()</span></code> when this mailbox was created.</dd>
+<dt>Deleted, Answered, and Flagged (4 bytes each)</dt>
+<dd>Counts of how many messages have each flag.</dd>
+<dt>Mailbox Options (4 bytes)</dt>
+<dd><p class="first">Bitmask of mailbox options, consisting of any combination of the
+following:</p>
+<dl class="last docutils">
+<dt>POP3_NEW_UIDL</dt>
+<dd>Flag signalling that we&#8217;re using &#8220;<em>uidvalidity</em>.<em>uid</em>&#8221; instead
+of just &#8220;<em>uid</em>&#8221; for the output of the POP3 UIDL command.</dd>
+<dt>IMAP_SHAREDSEEN</dt>
+<dd>Flag signalling that we&#8217;re supporting a shared \Seen flag on
+the mailbox.</dd>
+<dt>IMAP_DUPDELIVER</dt>
+<dd>Flag signalling that we&#8217;re allowing duplicate delivery of
+messages to the mailbox, overriding system-wide duplicate
+suppression.</dd>
+<dt>MAILBOX_NEEDS_REPACK</dt>
+<dd>Flag signalling that the mailbox is due to be repacked. During
+mailbox_close() every process will attempt to take an exclusive
+namelock on the mailbox and repack.</dd>
+<dt>MAILBOX_DELETED</dt>
+<dd>Flag signalling that the mailbox is deleted. This can be set
+with a shared namelock, and indicates to all other users of the
+mailbox that they need to close it and attempt cleanup. The last
+process to close the mailbox will perform the final cleanup
+under an exclusive namelock, giving the other processes a chance
+to finish their current operation first without files
+disappearing from under them!</dd>
+</dl>
+</dd>
+<dt>Leaked Cache (4 bytes)</dt>
+<dd>Number of leaked records in the cache file.</dd>
+<dt>Highest ModSeq (8 bytes)</dt>
+<dd>Highest Modification Sequence of all the messages in the mailbox
+(CONDSTORE).</dd>
+<dt>Deleted ModSeq (8 bytes)</dt>
+<dd>Lowest Modification Sequence before which expunged message data may
+have been purged from the mailbox and forgotten (CONDSTORE/QRESYNC
+support).</dd>
+<dt>Exists (4 bytes)</dt>
+<dd>See NumRecords above. This is the count of non-expunged records in
+the mailbox and corresponds to the IMAP status item &#8220;EXISTS&#8221;.</dd>
+<dt>First Expunged (4 bytes)</dt>
+<dd>lowest modified time of an expunged message in this mailbox (or zero
+if there are no expunged messages) - used to determine if the
+mailbox needs repacking.</dd>
+<dt>Last Repack Time (4 bytes)</dt>
+<dd>a timestamp for the last repack, to ensure repacks aren&#8217;t done too
+close together if expunges were closely spaced</dd>
+<dt>Header File CRC (4 bytes)</dt>
+<dd>CRC32 value of the bytes in the <code class="docutils literal"><span class="pre">cyrus.header</span></code> file for this
+mailbox. Must be rewritten whenever the cyrus.header file is changed
+(see locking considerations above - this is why the cyrus.index must
+be exclusively locked!)</dd>
+<dt>Sync CRC (4 bytes)</dt>
+<dd>An XOR of the CRC32 of a specially generated value for each of the
+non-expunged records in this mailbox. This is a cached value which
+allows the replication subsystem to quickly determine that all
+non-expunged records in a mailbox are in sync and detect possible
+&#8220;split brain&#8221; scenarios with low bandwidth use.</dd>
+<dt>Recent UID (4 bytes)</dt>
+<dd>The highest UID last time an IMAP client logged in as the mailbox
+owner (or anybody if SHAREDSEEN is enabled) selected this mailbox.
+Used to generate the \Recent flags in IMAP</dd>
+<dt>Recent Time (4 bytes)</dt>
+<dd>Used for consistency with the seen_db code, but probably not
+actually necessary. Oh well</dd>
+<dt>Header CRC (4 bytes)</dt>
+<dd>Must always be the LAST record of the header. This is the CRC32 of
+the actual bytes on disk (network order format) for the rest of the
+cyrus.index. By keeping it last, it can be easily calculated with
+the following snippet of code:
+<code class="docutils literal"><span class="pre">crc</span> <span class="pre">=</span> <span class="pre">crc32_map(buf,</span> <span class="pre">OFFSET_HEADER_CRC);</span></code> - i.e. crc32 from the
+start of the buffer to just before this field.</dd>
+</dl>
+<p>There are also spare fields in the index header, to allow for future
+expansion without forcing an upgrade of the file, and to round up to be
+divisible by 8 bytes.</p>
+</div>
+<div class="section" id="detail-of-cyrus-index-records">
+<h3>Detail of <code class="docutils literal"><span class="pre">cyrus.index</span></code> records<a class="headerlink" href="#detail-of-cyrus-index-records" title="Permalink to this headline">¶</a></h3>
+<p>These records start immediately following the <code class="docutils literal"><span class="pre">cyrus.index</span></code> header,
+and are all fixed size. They are in-order by uid of the message.</p>
+<dl class="docutils">
+<dt>UID (4 bytes)</dt>
+<dd>UID of the message</dd>
+<dt>INTERNALDATE (4 bytes)</dt>
+<dd>INTERNALDATE of the message (where possible, this matches the
+creation and modification times of the file on disk to help
+reconstruct in the event of data loss)</dd>
+<dt>SENTDATE (4 bytes)</dt>
+<dd>Contents of the Date: header chomped to day resolution with timezone
+stripped.</dd>
+<dt>SIZE (4 bytes)</dt>
+<dd>Size of the whole message (in octets)</dd>
+<dt>HEADER SIZE (4 bytes)</dt>
+<dd>Size of the message header (in octets)</dd>
+<dt>GMTIME (4 bytes)</dt>
+<dd>Contents of the Date: header at 1 second resolution and converted to
+GMT (for sort)</dd>
+<dt>CACHE_OFFSET (4 bytes)</dt>
+<dd>Offset into the <code class="docutils literal"><span class="pre">cyrus.cache</span></code> file for the beginning of this
+message&#8217;s cache entry.</dd>
+<dt>LAST UPDATED (4 bytes)</dt>
+<dd>(time_t) of the last time this record was changed</dd>
+<dt>SYSTEM FLAGS (4 bytes)</dt>
+<dd>Bitmask showing which system flags are set/unset</dd>
+<dt>USER FLAGS (MAX_USER_FLAGS / 32 bytes)</dt>
+<dd>Bitmask showing which user flags are set/unset (bits correspond to
+positions in the cyrus.header flag list, i.e. (1&lt;&lt;0) == the flag
+name</dd>
+<dt>CONTENT_LINES (4 bytes)</dt>
+<dd>Number of text lines contained in the message content (body).</dd>
+<dt>CACHE_VERSION (4 bytes)</dt>
+<dd>Indicates the version number of the cache record for the message
+(determines which headers are cached, see list in mailbox.c).</dd>
+<dt>GUID (MESSAGE_GUID_SIZE bytes)</dt>
+<dd>Globally Unique IDentifier of the message (used by replication
+engine). This is the sha1 value of the bytes as stored on disk.</dd>
+<dt>MODSEQ (8 bytes)</dt>
+<dd>Modification Sequence of the message (CONDSTORE).</dd>
+<dt>CACHE_CRC (4 bytes)</dt>
+<dd>This is the CRC32 of all the bytes of the cache record (all 10
+fields) as stored on disk. Again, calculated over the exact bytes
+stored in the <code class="docutils literal"><span class="pre">cyrus.cache</span></code> file.</dd>
+<dt>RECORD_CRC (4 bytes)</dt>
+<dd>Like the header CRC - this is the CRC32 of all the bytes in on-disk
+order that exist in this record. Records are always rewritten as the
+entire record, including the updated CRC, so it&#8217;s always consistent
+if you have a lock on the <code class="docutils literal"><span class="pre">cyrus.index</span></code> file, because writers will
+wait until they get an exclusive lock to make modifications.</dd>
+</dl>
+</div>
+</div>
+<div class="section" id="notes">
+<h2>Notes<a class="headerlink" href="#notes" title="Permalink to this headline">¶</a></h2>
+<ul>
+<li><p class="first">Expunge is super quick now - it&#8217;s just a flag update!</p>
+</li>
+<li><p class="first">Append is relatively fast (it only adds to the end of both the cache
+and index files and modifies the index header)</p>
+</li>
+<li><p class="first">Message unlinks always happen during the &#8220;close&#8221; phase - which may be
+noticed when you select another mailbox, but otherwise are delayed
+from the actual action. With delayed expunge, the unlinks are pushed
+off to cyr_expire which is a background task, and will never be
+noticed by the user.</p>
+</li>
+<li><p class="first">Message delivery is something like this:</p>
+<ol class="arabic simple">
+<li>write/sync message file</li>
+<li>write/sync new <code class="docutils literal"><span class="pre">cyrus.cache</span></code> record</li>
+<li>write/sync new <code class="docutils literal"><span class="pre">cyrus.index</span></code> record</li>
+<li>calculate, write, sync new <code class="docutils literal"><span class="pre">cyrus.index</span></code> header</li>
+<li>acknowledge message delivery</li>
+</ol>
+<p>The message isn&#8217;t delivered until the new index header is written. In
+case of a crash before the new index header is written, any previous
+writes will be overwritten on the next delivery (and will not be
+noticed by the readers).</p>
+<p>Note that certain power failure situations (power failure in the
+middle of a disk sector write) could cause a mailbox to need
+reconstruction (possibly even losing some flag state). These failure
+modes are not possible in the &#8220;Hardware RAID disk model&#8221; (which we
+will describe somewhere else when we get around to it).</p>
+</li>
+</ul>
+</div>
+<div class="section" id="future-considerations">
+<h2>Future considerations<a class="headerlink" href="#future-considerations" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Cache all header fields? (or all up to Xk?) This could greatly
+improve speeds of clients that just ask for everything, but also
+increases the expense of rewriting the cache file (as well as the
+size it takes on disk).</li>
+<li>Reformat cache file to use a
+(size)(size)(size)(size)(data)(data)(data) format. This makes
+accesses anywhere in the cache file equally fast, as opposed to
+having to iterate through all the entires for a given message to get
+to the last one. Note that either way is still O(1) so maybe it
+doesn&#8217;t matter much.</li>
+<li>It would be useful to store a uniqueid -&gt; mailbox name index, so that
+we could fix arbitron again.</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="namelocks.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Namelocks" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="locking.html" class="btn btn-neutral" title="Cyrus IMAP Server: Locking" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 09 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/namelocks.html 3.2.0-3/doc/html/imap/developer/guidance/namelocks.html
--- 3.0.13-5/doc/html/imap/developer/guidance/namelocks.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/namelocks.html	2020-05-04 04:11:30.000000000 +0000
@@ -0,0 +1,944 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Namelocks &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: prot layer" href="prot.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Mailbox File Formats" href="mailbox-format.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Namelocks</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/namelocks.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-namelocks"></span><div class="section" id="cyrus-imap-server-namelocks">
+<h1>Cyrus IMAP Server: Namelocks<a class="headerlink" href="#cyrus-imap-server-namelocks" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="intro">
+<h2>Intro<a class="headerlink" href="#intro" title="Permalink to this headline">¶</a></h2>
+<p>Name locks are an addition to the cyrus internals to address a range of
+race conditions and complexities. These ills are most easily avoided by
+ensuring that only one process can do certain operations at once. Name
+locks also mean crashes can&#8217;t leave the mailbox &#8220;broken&#8221; forever.</p>
+<p>Unfortunately, locks can&#8217;t be retained over a rewrite-rename cycle, and
+every meta file in a regular mailbox gets rewritten upon occasion. Even
+cyrus.header gets a rewrite when a new userflag is added.</p>
+<p>The &#8220;RESERVED FLAG&#8221; method of handling mailbox creation is a nasty
+brutish method that breaks on process crashes, causing a full
+mailboxes.db sweep to be necessary on restart, and making that name
+unusable until the entire server is restarted. It&#8217;s also unusable for
+serialisation of operations without making the mailbox &#8220;disappear&#8221; to
+other clients.</p>
+<p>Mailbox names are supposed to be exclusive per server, not just per
+partition, so any lock has to apply to the entire server.</p>
+<p><strong>MURDER Considerations:</strong> Due to the way the mupdate protocol works,
+RESERVED records are still created over mupdate. This sucks, and a
+better way would be to support an &#8220;EXCLUSIVE CREATE&#8221; command, where the
+create only succeeds if the record doesn&#8217;t already exist. Then a task
+could create the mailbox on the local server and retain an exclusive
+namelock while trying to assert the name on the mupdate server. If this
+failed (someone else got in first) then the mailbox could be cleaned up
+locally before releasing the exclusive namelock, meaning other users on
+the local server would never see it existing.</p>
+</div>
+<div class="section" id="implementation">
+<h2>Implementation<a class="headerlink" href="#implementation" title="Permalink to this headline">¶</a></h2>
+<p>It&#8217;s a simple matter of having a file under $configdirectory/lock - in a
+directory tree using the same hashing structure as the mailbox tree.
+This directory can be symlinked or mounted to a tmpfs since the locks
+need not persist across restarts. Due to race conditions while cleaning
+up, the easiest approach is to only ever delete lock files during
+restart, so the unlock code doesn&#8217;t try to remove them. Lock files are
+zero byte in size, and are locked using the flock or fcntl primitives
+used by the rest of cyrus.</p>
+</div>
+<div class="section" id="api">
+<h2>API<a class="headerlink" href="#api" title="Permalink to this headline">¶</a></h2>
+<p>Lock types:</p>
+<ul class="simple">
+<li>LOCK_SHARED - shared lock on the name. Required whenever you have an
+open mailbox with that name</li>
+<li>LOCK_EXCLUSIVE - exclusive lock on the name. Required to create or
+finish deleting a mailbox, and required when repacking the
+cyrus.index and cyrus.cache files.</li>
+<li>LOCK_NONBLOCKING - attempt to take an exclusive lock on the name,
+but if it&#8217;s not available, return immediately with r ==
+IMAP_MAILBOX_LOCKED rather than blocking until the lock is
+available.</li>
+</ul>
+<p>The <code class="docutils literal"><span class="pre">mboxname</span></code> is always an <strong>internal name</strong>, so convert it first.</p>
+<div class="section" id="example">
+<h3>Example:<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h3>
+<div class="highlight-default"><div class="highlight"><pre><span></span>struct mboxlock *lock = NULL;
+int locktype = LOCK_SHARED; /* or LOCK_EXCLUSIVE or LOCK_NONBLOCKING */
+
+r = mboxname_lock(&quot;user.brong&quot;, &amp;lock, locktype);
+if (!r) {
+    do_stuff();
+    mboxname_release(&amp;lock);
+}
+</pre></div>
+</div>
+<p>If mboxname_lock fails, lock will remain NULL. It should always be
+initialised to NULL before being passed to mailbox_lock. It will be set
+back to NULL by mboxname_release.</p>
+</div>
+<div class="section" id="re-locking-considerations">
+<h3>Re-locking considerations<a class="headerlink" href="#re-locking-considerations" title="Permalink to this headline">¶</a></h3>
+<p>It is not possible to hold multiple locks to the same name within the
+same process. If you call mboxname_lock with the same name within a
+process, and the <strong>same locktype</strong> then a reference counter is
+incremented and the same lock is returned. If you use a <strong>different
+locktype</strong> (i.e. one shared, the other exclusive. Non-blocking is
+considered exclusive for this test) then IMAP_MAILBOX_LOCKED will be
+returned to avoid breaking the locking semantics. This is a restriction
+of the underlying fcntl/flock subsystem.</p>
+<p>On the way out, the reference counter is decremented with each release
+and the lock isn&#8217;t freed until the counter gets back to zero.</p>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="prot.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: prot layer" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="mailbox-format.html" class="btn btn-neutral" title="Cyrus IMAP Server: Mailbox File Formats" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/prot.html 3.2.0-3/doc/html/imap/developer/guidance/prot.html
--- 3.0.13-5/doc/html/imap/developer/guidance/prot.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/prot.html	2020-05-04 04:11:30.000000000 +0000
@@ -0,0 +1,925 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: prot layer &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Replication Examples" href="replication_examples.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Namelocks" href="namelocks.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: prot layer</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/prot.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-prot-layer"></span><div class="section" id="cyrus-imap-server-prot-layer">
+<h1>Cyrus IMAP Server: prot layer<a class="headerlink" href="#cyrus-imap-server-prot-layer" title="Permalink to this headline">¶</a></h1>
+<p>The prot layer, defined in <code class="docutils literal"><span class="pre">prot.h</span></code>, is a stdio replacement for
+network i/o. It does the standard buffering of input and output and
+allows certain operations especially suited for request/response
+protocols like IMAP.</p>
+<div class="section" id="events">
+<h2>Events<a class="headerlink" href="#events" title="Permalink to this headline">¶</a></h2>
+<p>The prot layer allows &#8220;events&#8221; to be associated with each prot stream.
+These events are trigger at the given time or after when the protstream
+is attempted to be read from.</p>
+<p>An event is currently represented by the following datastructure:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">struct</span> <span class="n">prot_waitevent</span><span class="p">;</span>
+
+<span class="n">typedef</span> <span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="o">*</span><span class="n">prot_waiteventcallback_t</span><span class="p">(</span><span class="n">struct</span> <span class="n">protstream</span> <span class="o">*</span><span class="n">s</span><span class="p">,</span>
+                            <span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="o">*</span><span class="n">ev</span><span class="p">,</span>
+                            <span class="n">void</span> <span class="o">*</span><span class="n">rock</span><span class="p">);</span>
+
+<span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="p">{</span>
+    <span class="n">time_t</span> <span class="n">mark</span><span class="p">;</span>
+    <span class="n">prot_waiteventcallback_t</span> <span class="o">*</span><span class="n">proc</span><span class="p">;</span>
+    <span class="n">void</span> <span class="o">*</span><span class="n">rock</span><span class="p">;</span>
+    <span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="o">*</span><span class="nb">next</span><span class="p">;</span>
+<span class="p">};</span>
+</pre></div>
+</div>
+<p>The application is currently allowed to modify <em>mark</em>, <em>proc</em>, and
+<em>rock</em> as desired when there are no active calls to a prot function on
+the stream which this event is associated.</p>
+<p>The API is as follows:</p>
+<ul>
+<li><p class="first">Use <code class="docutils literal"><span class="pre">prot_addwaitevent()</span></code> to add an event callback onto the stream:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">extern</span> <span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="o">*</span><span class="n">prot_addwaitevent</span><span class="p">(</span><span class="n">struct</span> <span class="n">protstream</span> <span class="o">*</span><span class="n">s</span><span class="p">,</span>
+                        <span class="n">time_t</span> <span class="n">mark</span><span class="p">,</span>
+                        <span class="n">prot_waiteventcallback_t</span> <span class="o">*</span><span class="n">proc</span><span class="p">,</span>
+                        <span class="n">void</span> <span class="o">*</span><span class="n">rock</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>where <em>s</em> is the stream to add the event to, <em>mark</em> is the time to
+trigger the event, <em>proc</em> is the callback to make, and <em>rock</em> is an
+opaque data item handed to the callback. It returns a pointer to the
+event structure; this is the pointer that must be used to remove the
+event or modify it in some way.</p>
+</li>
+<li><p class="first">Use <code class="docutils literal"><span class="pre">prot_removewaitevent()</span></code> to remove an event:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">extern</span> <span class="n">void</span> <span class="n">prot_removewaitevent</span><span class="p">(</span><span class="n">struct</span> <span class="n">protstream</span> <span class="o">*</span><span class="n">s</span><span class="p">,</span>
+                 <span class="n">struct</span> <span class="n">prot_waitevent</span> <span class="o">*</span><span class="n">event</span><span class="p">);</span>
+</pre></div>
+</div>
+<p>It requires <em>event</em> to have been returned from
+<code class="docutils literal"><span class="pre">prot_addwaitevent()</span></code> previously. No further references are allowed
+to <em>event</em> or its fields. <em>event-&gt;rock</em> is not free&#8217;d nor examined in
+any way. This function may be called while inside the callback
+<em>event-&gt;proc()</em>. If an event is removed inside of its callback, that
+callback must return <code class="docutils literal"><span class="pre">NULL</span></code>.</p>
+</li>
+</ul>
+<p>Some common things to do with events:</p>
+<ul class="simple">
+<li>To reschedule an event <em>ev</em>, simply set <em>ev-&gt;mark</em> to the next time
+it should trigger. If currently in <em>ev-&gt;proc()</em>, it should return
+<em>ev</em>.</li>
+</ul>
+<hr class="docutils" />
+<p>last modified: $Date: 2003/08/06 21:28:05 $</p>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="replication_examples.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Replication Examples" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="namelocks.html" class="btn btn-neutral" title="Cyrus IMAP Server: Namelocks" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/replication_examples.html 3.2.0-3/doc/html/imap/developer/guidance/replication_examples.html
--- 3.0.13-5/doc/html/imap/developer/guidance/replication_examples.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/replication_examples.html	2020-05-04 04:11:31.000000000 +0000
@@ -0,0 +1,1012 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Replication Examples &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Replication Protocol v2.4+" href="replication_protocol.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: prot layer" href="prot.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Replication Examples</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/replication_examples.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-replication-examples"></span><div class="section" id="cyrus-imap-server-replication-examples">
+<h1>Cyrus IMAP Server: Replication Examples<a class="headerlink" href="#cyrus-imap-server-replication-examples" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="introduction">
+<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
+<p>The replication system creates a link between two Cyrus mailstores: a
+master and a replica system. Both systems can be live mailstores with
+active users: here in Cambridge we install systems in pairs.</p>
+<p>Typically half of the users will be using each system, and each system
+replicates to its partner. In the event of a failover everyone uses the
+remaining system in a pair. This is typically safe as the IMAP/POP/SMTP
+servers define which of the two systems is the live server for any given
+account, and the replica just plays a game of follow my leader.</p>
+<p>Occasionally I think about introducing some form of sanity check so that
+we have to explicitly issue a command to the remaining backend system as
+well as the proxies in the event of a failover.</p>
+</div>
+<div class="section" id="a-short-example-of-replication-in-action">
+<h2>A short example of replication in action<a class="headerlink" href="#a-short-example-of-replication-in-action" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span>Index:
+
+  #: Annotation
+  C: Command issued by client
+  S: Command issued by server
+
+# Authentication between systems is done using SSH key based authentication:
+
+C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+S: * Sync Server v0.0 [EXPERIMENTAL]
+
+# Create new auth_state and ask for all information about given list of
+# folders (namely user.dpc22). Returns:
+#
+#   &quot;**&quot; unsolicited response for each mailbox. Returns:
+#      Folder UniqueID, Name, ACL, UIDlast, timestamp for last seen update.
+#
+#   &quot;*&quot; response for each mail message in folder:
+#      UID, GUID, flags (other than \Seen state)
+
+C: user_some dpc22 user.dpc22
+S: ** 6b98205c796c6c61 user.dpc22 \
+S:     &quot;dpc22   lrswipcda       anonymous       0      &quot; 4151 1062945305
+S: * 1 000000000000000000000000 ()
+S: * 3697 0101003f4c56b00545000000 ()
+S: * 3919 0101003f4c56b04b2900000d ()
+S: * 3937 0101003f4c56b0514900001f ()
+S: * 4066 0101003f4c56b07422000002 ()
+S: * 4089 0101003f4c56b07e56000023 (\answered)
+S: * 4118 0101003f4c56b08328000016 ()
+S: * 4131 0101003f4c56b084d7000002 ()
+S: * 4136 0101003f4c56b087f3000001 ()
+S: * 4140 0101003f4c56b08c9d000026 ()
+S: OK User_Some finished
+
+# Select a folder to work with
+
+C: select user.dpc22
+S: OK 6b98205c796c6c61 4151 1062945305
+
+# Remove message with UID &quot;1&quot; from folder list (message which has been
+# sitting in my inbox since January, has no GUID defined)
+
+C: expunge 1
+S: OK Expunge Complete
+
+# Set some user flags on message UID &quot;4140&quot;
+
+C: setflags 4140 (hello world)
+S: OK Updated flags on 1 messages okay
+
+# Demonstrate that something has changed:
+
+C: status
+S: * 3697 0101003f4c56b00545000000 ()
+S: * 3919 0101003f4c56b04b2900000d ()
+S: * 3937 0101003f4c56b0514900001f ()
+S: * 4066 0101003f4c56b07422000002 ()
+S: * 4089 0101003f4c56b07e56000023 (\answered)
+S: * 4118 0101003f4c56b08328000016 ()
+S: * 4131 0101003f4c56b084d7000002 ()
+S: * 4136 0101003f4c56b087f3000001 ()
+S: * 4140 0101003f4c56b08c9d000026 (hello world)
+S: OK 4151
+
+# Now lets correct the damage that we just inflicted:
+
+C: $ replicate -s cyrus-2 -v -v -m user.dpc22
+S: MAILBOXES user.dpc22
+S: USER_SOME dpc22 user.dpc22
+S: SELECT user.dpc22
+S: SETFLAGS [1 msgs]
+S: UPLOAD [1 msgs]
+S: SETSEEN dpc22 ...
+S: ENDUSER
+
+C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+S: * Sync Server v0.0 [EXPERIMENTAL]
+S: user_some dpc22 user.dpc22
+S: ** 6b98205c796c6c61 user.dpc22 \
+S:    &quot;dpc22   lrswipcda       anonymous       0      &quot; 4156 1062968731
+S: * 1 000000000000000000000000 ()
+S: * 3697 0101003f4c56b00545000000 ()
+S: * 3919 0101003f4c56b04b2900000d ()
+S: * 3937 0101003f4c56b0514900001f ()
+S: * 4066 0101003f4c56b07422000002 ()
+S: * 4089 0101003f4c56b07e56000023 (\answered)
+S: * 4118 0101003f4c56b08328000016 ()
+S: * 4131 0101003f4c56b084d7000002 ()
+S: * 4136 0101003f4c56b087f3000001 ()
+S: * 4140 0101003f4c56b08c9d000026 ()
+S: OK User_Some finished
+
+# Back where we started: the replication engine reinserted message UID 0
+# which was missing, and removed &quot;hello world&quot; from message UID 4140
+</pre></div>
+</div>
+</div>
+<div class="section" id="tracking-messages-between-folders">
+<h2>Tracking messages between folders<a class="headerlink" href="#tracking-messages-between-folders" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span># I&#39;ve just saved a message from my inbox into a folder named &quot;zzz&quot;,
+# creating the folder the process.
+
+C: $ replicate -s cyrus-2 -v -v -m user.dpc22 user.dpc22.zzz
+
+Replication action on two MAILBOX objects:
+
+S: MAILBOXES user.dpc22 user.dpc22.zzz
+
+Ask server for contents of the two folders:
+
+S:   USER_SOME dpc22 ...
+
+Reserve message with given GUID in user.dpc22 so that it can be moved
+
+S:   RESERVE user.dpc22 ...
+
+Remove message from source folder (reserved copy left behind)
+
+S:   SELECT user.dpc22
+S:   EXPUNGE [1 msgs]
+S:   SETSEEN dpc22 ...
+
+Create target folder and copy in message that we reserved (doesn&#39;t have to
+be uploaded again)
+
+S:   CREATE user.dpc22.zzz 7f6f384c3f5ba99a
+S:      &quot;dpc22        lrswipcda       anonymous       0       &quot; 0 1062971802
+S: SELECT user.dpc22.zzz
+S: UPLOAD [1 msgs]
+S: SETSEEN dpc22 ...
+S: ENDUSER
+</pre></div>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="replication_protocol.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Replication Protocol v2.4+" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="prot.html" class="btn btn-neutral" title="Cyrus IMAP Server: prot layer" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/replication_protocol.html 3.2.0-3/doc/html/imap/developer/guidance/replication_protocol.html
--- 3.0.13-5/doc/html/imap/developer/guidance/replication_protocol.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/replication_protocol.html	2020-05-04 04:11:31.000000000 +0000
@@ -0,0 +1,925 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Replication Protocol v2.4+ &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Special Characters" href="special_chars.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Replication Examples" href="replication_examples.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Replication Protocol v2.4+</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/replication_protocol.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-replication-protocol"></span><div class="section" id="cyrus-imap-server-replication-protocol-v2-4">
+<h1>Cyrus IMAP Server: Replication Protocol v2.4+<a class="headerlink" href="#cyrus-imap-server-replication-protocol-v2-4" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="dlist-1-0">
+<h2>DList 1.0<a class="headerlink" href="#dlist-1-0" title="Permalink to this headline">¶</a></h2>
+<p>The DList protocol is based closely on the IMAP wire protocol, using
+atoms and literals as the basis, but with two extended types of data:</p>
+<ul class="simple">
+<li>kvlist</li>
+<li>rfc822-object</li>
+</ul>
+<p>A wart of the protocol is the rfc822-object, which contains an explicit
+cyrus backend partition. This will be removed in future versions of
+Cyrus.</p>
+<div class="section" id="types">
+<h3>types<a class="headerlink" href="#types" title="Permalink to this headline">¶</a></h3>
+<div class="section" id="atom">
+<h4>atom<a class="headerlink" href="#atom" title="Permalink to this headline">¶</a></h4>
+<p>An atom is actually a sequence of any character other than &#8216;\0&#8217;, the
+NULL byte. Character encoding is not specified, but it can contain 8 bit
+characters, and is probably utf8</p>
+</div>
+<div class="section" id="flag">
+<h4>flag<a class="headerlink" href="#flag" title="Permalink to this headline">¶</a></h4>
+<p>Flag is a horrible special case of atom to allow \word to be
+represented as an IMAP atom on the wire. This is one of many special
+cases in the IMAP protocol, and is duplicated into dlist just to make it
+easier to read</p>
+</div>
+<div class="section" id="num32-num">
+<h4>num32/num<a class="headerlink" href="#num32-num" title="Permalink to this headline">¶</a></h4>
+<p>Both stored as 64 bit integers internally, and sent as decimal numbers
+over the wire, this type exists only in the API, it just looks like a
+string on the wire.</p>
+</div>
+<div class="section" id="hex32-hex">
+<h4>hex32/hex<a class="headerlink" href="#hex32-hex" title="Permalink to this headline">¶</a></h4>
+<p>Stored like num internally, but sent as an 8 or 16 character hexadecimal
+string on the wire</p>
+</div>
+<div class="section" id="map">
+<h4>map<a class="headerlink" href="#map" title="Permalink to this headline">¶</a></h4>
+<p>Like atom, but can contain NULL. All values are parsed off the wire as
+&#8216;map&#8217; type and then converted on demand into the requested type</p>
+</div>
+<div class="section" id="list">
+<h4>list<a class="headerlink" href="#list" title="Permalink to this headline">¶</a></h4>
+<p>Encoded in parentheses like so (item item item) a list type can be
+nested inside other lists: (item (sub sub) item)</p>
+</div>
+<div class="section" id="kvlist">
+<h4>kvlist<a class="headerlink" href="#kvlist" title="Permalink to this headline">¶</a></h4>
+<p>A kvlist allows named parameters, and is indicated with a leading %
+character. % is invalid in atoms, so parsing is unambiguous, e.g:</p>
+<p>%(key1 value1 key2 (list of values) key3 value3)</p>
+</div>
+<div class="section" id="rfc822-object-file">
+<h4>rfc822-object/file<a class="headerlink" href="#rfc822-object-file" title="Permalink to this headline">¶</a></h4>
+<p>Finally the ugly one. These look like a literal, but with a leading %
+and two more fields:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">%</span><span class="p">{</span><span class="n">partition</span> <span class="n">sha1</span> <span class="n">size</span><span class="p">}</span>\<span class="n">r</span>\<span class="n">n</span>
+<span class="n">data</span>
+</pre></div>
+</div>
+</div>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="special_chars.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Special Characters" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="replication_examples.html" class="btn btn-neutral" title="Cyrus IMAP Server: Replication Examples" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 19 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/special_chars.html 3.2.0-3/doc/html/imap/developer/guidance/special_chars.html
--- 3.0.13-5/doc/html/imap/developer/guidance/special_chars.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/special_chars.html	2020-05-04 04:11:31.000000000 +0000
@@ -0,0 +1,916 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Special Characters &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Cyrus IMAP Server: var directory structure" href="var_directory_structure.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Replication Protocol v2.4+" href="replication_protocol.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Special Characters</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/special_chars.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-special-chars"></span><div class="section" id="cyrus-imap-server-special-characters">
+<h1>Cyrus IMAP Server: Special Characters<a class="headerlink" href="#cyrus-imap-server-special-characters" title="Permalink to this headline">¶</a></h1>
+<p>This document is supposed to be a repository of &#8220;special characters&#8221;
+used in Cyrus naming of users, folders, directory paths, etc.</p>
+<div class="section" id="current-uses">
+<h2>Current Uses<a class="headerlink" href="#current-uses" title="Permalink to this headline">¶</a></h2>
+<div class="line-block">
+<div class="line"><br /></div>
+<div class="line">Character: +</div>
+</div>
+<ul class="simple">
+<li>(LMTP) Separation of postuser and target mailbox for delivery</li>
+<li>(LMTP) Separation of username and submailbox for delivery</li>
+<li>(IMAP) Flag at end of login name that indicates that LIST should
+return LSUB results (when imapmagicplus is set)</li>
+<li>(POP3) POP a subfolder directly (e.g. rjs3+foo POPs user.rjs3.foo)</li>
+</ul>
+<div class="line-block">
+<div class="line"><br /></div>
+<div class="line">Character: . /</div>
+</div>
+<ul class="simple">
+<li>[mailbox names] Hierarchy separators</li>
+</ul>
+<div class="line-block">
+<div class="line"><br /></div>
+<div class="line">Character: ^</div>
+</div>
+<ul class="simple">
+<li>[mailbox names] In unixhierarchysep, ^ is the part of the internal
+name that represents a &#8216;.&#8217;</li>
+</ul>
+<div class="line-block">
+<div class="line"><br /></div>
+<div class="line">Characters: &#64; %</div>
+</div>
+<ul class="simple">
+<li>[usernames] These are realm separators for the purposes of
+authentication</li>
+</ul>
+<div class="line-block">
+<div class="line"><br /></div>
+</div>
+</div>
+<div class="section" id="future-uses">
+<h2>Future Uses<a class="headerlink" href="#future-uses" title="Permalink to this headline">¶</a></h2>
+<div class="line-block">
+<div class="line">Character: +</div>
+</div>
+<ul class="simple">
+<li>IMAP LIST filters (e.g. rjs3+foo will only list folders that match
+foo*)</li>
+<li>possibly other interpretations here:
+- rjs3+foo will do an effective chroot(foo.)
+- rjs3+foo will only list folders in user.rjs3.foo*</li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="var_directory_structure.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: var directory structure" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="replication_protocol.html" class="btn btn-neutral" title="Cyrus IMAP Server: Replication Protocol v2.4+" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance/var_directory_structure.html 3.2.0-3/doc/html/imap/developer/guidance/var_directory_structure.html
--- 3.0.13-5/doc/html/imap/developer/guidance/var_directory_structure.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance/var_directory_structure.html	2020-05-04 04:11:32.000000000 +0000
@@ -0,0 +1,925 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: var directory structure &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="next" title="Unit Tests" href="../unit-tests.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Special Characters" href="special_chars.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../guidance.html">Developer Guidance</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: var directory structure</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance/var_directory_structure.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance-var-directory-structure"></span><div class="section" id="cyrus-imap-server-var-directory-structure">
+<h1>Cyrus IMAP Server: var directory structure<a class="headerlink" href="#cyrus-imap-server-var-directory-structure" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="directory-structure-under-var-spool-imap">
+<h2>Directory structure under /var/spool/imap<a class="headerlink" href="#directory-structure-under-var-spool-imap" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">stage</span><span class="o">./</span>
+  <span class="n">Normal</span> <span class="n">staging</span> <span class="n">directory</span>
+
+<span class="n">sync</span><span class="o">./</span>
+  <span class="n">Staging</span> <span class="n">directory</span> <span class="k">for</span> <span class="n">replication</span> <span class="n">system</span>
+  <span class="n">Includes</span>
+    <span class="n">sync</span><span class="o">./</span><span class="n">locks</span><span class="o">/*</span>
+
+  <span class="n">which</span> <span class="n">are</span> <span class="n">lock</span> <span class="n">files</span> <span class="k">for</span> <span class="n">each</span> <span class="n">user</span> <span class="n">on</span> <span class="n">the</span> <span class="n">system</span> <span class="n">to</span> <span class="n">prevent</span> <span class="n">two</span>
+  <span class="n">replication</span> <span class="n">runs</span> <span class="kn">from</span> <span class="nn">trying</span> <span class="n">to</span> <span class="n">update</span> <span class="n">the</span> <span class="n">same</span> <span class="n">account</span> <span class="n">at</span> <span class="n">the</span> <span class="n">same</span> <span class="n">time</span>
+  <span class="p">(</span><span class="n">nothing</span> <span class="n">disastrous</span> <span class="n">should</span> <span class="n">happen</span> <span class="n">even</span> <span class="n">without</span> <span class="n">this</span> <span class="n">lock</span><span class="p">,</span> <span class="n">but</span> <span class="n">the</span> <span class="n">second</span>
+  <span class="n">job</span> <span class="ow">in</span> <span class="n">will</span> <span class="n">get</span> <span class="n">a</span> <span class="n">bit</span> <span class="n">confused</span> <span class="k">if</span> <span class="n">the</span> <span class="n">target</span> <span class="n">end</span> <span class="n">changes</span> <span class="n">under</span> <span class="n">its</span> <span class="n">feet</span><span class="p">,</span>
+  <span class="ow">and</span> <span class="n">will</span> <span class="n">probably</span> <span class="n">drop</span> <span class="n">back</span> <span class="n">to</span> <span class="n">a</span> <span class="n">recovery</span> <span class="n">mode</span><span class="o">.</span>
+
+<span class="n">user</span><span class="o">/</span>
+  <span class="n">Familiar</span> <span class="n">user</span><span class="o">.</span><span class="n">userid</span> <span class="n">space</span><span class="o">.</span>
+</pre></div>
+</div>
+</div>
+<div class="section" id="directory-structure-under-var-imap">
+<h2>Directory structure under /var/imap<a class="headerlink" href="#directory-structure-under-var-imap" title="Permalink to this headline">¶</a></h2>
+<p>Complete list:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">232</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">08</span><span class="p">:</span><span class="mi">21</span> <span class="n">db</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">x</span><span class="o">---</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">112</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">19</span><span class="p">:</span><span class="mi">51</span> <span class="n">db</span><span class="o">.</span><span class="n">backup1</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">x</span><span class="o">---</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">112</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">19</span><span class="p">:</span><span class="mi">21</span> <span class="n">db</span><span class="o">.</span><span class="n">backup2</span>
+<span class="o">-</span><span class="n">rw</span><span class="o">-</span><span class="n">r</span><span class="o">-----</span>    <span class="mi">1</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>    <span class="mi">20799488</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">19</span><span class="p">:</span><span class="mi">51</span> <span class="n">deliver</span><span class="o">.</span><span class="n">db</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>          <span class="mi">48</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">10</span><span class="p">:</span><span class="mi">16</span> <span class="n">log</span>
+<span class="o">-</span><span class="n">rw</span><span class="o">-</span><span class="n">r</span><span class="o">-----</span>    <span class="mi">1</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>     <span class="mi">1995000</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">19</span><span class="p">:</span><span class="mi">38</span> <span class="n">mailboxes</span><span class="o">.</span><span class="n">db</span>
+<span class="o">-</span><span class="n">rw</span><span class="o">-</span><span class="n">r</span><span class="o">--</span><span class="n">r</span><span class="o">--</span>    <span class="mi">1</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>          <span class="mi">10</span> <span class="n">Jun</span>  <span class="mi">2</span> <span class="mi">10</span><span class="p">:</span><span class="mi">08</span> <span class="n">master_machine</span>
+<span class="o">-</span><span class="n">rw</span><span class="o">-</span><span class="n">r</span><span class="o">--</span><span class="n">r</span><span class="o">--</span>    <span class="mi">1</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>          <span class="mi">71</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">08</span><span class="p">:</span><span class="mi">21</span> <span class="n">master_uuid</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>          <span class="mi">48</span> <span class="n">Jun</span>  <span class="mi">2</span> <span class="mi">10</span><span class="p">:</span><span class="mi">08</span> <span class="n">msg</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>        <span class="mi">1872</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">19</span><span class="p">:</span><span class="mi">55</span> <span class="n">proc</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>   <span class="mi">28</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">672</span> <span class="n">Jun</span>  <span class="mi">2</span> <span class="mi">10</span><span class="p">:</span><span class="mi">08</span> <span class="n">quota</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">224</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">08</span><span class="p">:</span><span class="mi">21</span> <span class="n">socket</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>    <span class="mi">2</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>          <span class="mi">72</span> <span class="n">Sep</span>  <span class="mi">7</span> <span class="mi">10</span><span class="p">:</span><span class="mi">19</span> <span class="n">sync</span>
+<span class="n">drwxr</span><span class="o">-</span><span class="n">xr</span><span class="o">-</span><span class="n">x</span>   <span class="mi">28</span> <span class="n">cyrus</span>    <span class="n">cyrus</span>         <span class="mi">672</span> <span class="n">Jun</span>  <span class="mi">2</span> <span class="mi">10</span><span class="p">:</span><span class="mi">08</span> <span class="n">user</span>
+</pre></div>
+</div>
+<p>Most of that will be familiar. New entries are:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">master_machine</span>
+  <span class="n">Defines</span> <span class="n">machine</span> <span class="n">number</span> <span class="ow">in</span> <span class="n">replication</span> <span class="n">cluster</span><span class="o">.</span> <span class="n">Used</span> <span class="k">as</span> <span class="n">sanity</span> <span class="n">check</span>
+  <span class="n">against</span> <span class="n">master_uuid</span> <span class="n">file</span><span class="o">.</span> <span class="n">Sample</span> <span class="n">content</span><span class="p">:</span>
+
+    <span class="n">machine</span><span class="o">=</span><span class="mi">1</span>
+
+<span class="n">master_uuid</span>
+  <span class="n">Full</span> <span class="n">information</span> <span class="n">about</span> <span class="n">UUID</span> <span class="n">schema</span> <span class="ow">in</span> <span class="n">use</span><span class="o">.</span> <span class="n">See</span> <span class="o">./</span><span class="n">uuid</span> <span class="k">for</span> <span class="n">details</span><span class="o">.</span>
+  <span class="n">Sample</span> <span class="n">content</span><span class="p">:</span>
+
+     <span class="n">schema</span><span class="o">=</span><span class="mi">1</span>
+     <span class="n">machine</span><span class="o">=</span><span class="mi">1</span>
+     <span class="n">timestamp_generation</span><span class="o">=</span><span class="mi">0</span>
+     <span class="n">master_start_time</span><span class="o">=</span><span class="mi">1062919294</span>
+
+<span class="n">sync</span><span class="o">/</span><span class="n">current</span>
+  <span class="n">Transaction</span> <span class="n">log</span> <span class="kn">from</span> <span class="nn">IMAP</span><span class="p">,</span> <span class="n">POP</span> <span class="ow">and</span> <span class="n">LMTP</span> <span class="n">daemons</span><span class="p">,</span> <span class="n">typically</span> <span class="n">feed</span> <span class="n">into</span>
+  <span class="n">sync_client</span> <span class="n">running</span> <span class="k">as</span> <span class="n">asynchronous</span> <span class="n">replication</span> <span class="n">engine</span><span class="o">.</span>
+
+  <span class="n">Rotated</span> <span class="n">to</span> <span class="n">be</span> <span class="n">sync</span><span class="o">/</span><span class="n">current</span><span class="o">-&lt;</span><span class="n">pid</span><span class="o">&gt;</span> <span class="n">by</span> <span class="n">asynchronous</span> <span class="n">runner</span><span class="o">.</span>
+</pre></div>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../unit-tests.html" class="btn btn-neutral float-right" title="Unit Tests" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="special_chars.html" class="btn btn-neutral" title="Cyrus IMAP Server: Special Characters" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/guidance.html 3.2.0-3/doc/html/imap/developer/guidance.html
--- 3.0.13-5/doc/html/imap/developer/guidance.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/guidance.html	2020-05-04 04:11:28.000000000 +0000
@@ -0,0 +1,873 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Developer Guidance &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../genindex.html"/>
+        <link rel="search" title="Search" href="../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
+        <link rel="up" title="Developers" href="../../developers.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Hacking" href="guidance/hacking.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Prot Events" href="thoughts/prot-events.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../index.html">Home</a></li>
+    <li><a href="../../download.html">Download</a></li>
+    <li><a href="../../contribute.html">Contribute</a></li>
+    <li><a href="../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../index.html">
+      <img src="../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../index.html">
+ 
+
+  
+          
+          <img src="../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="current reference internal" href="#">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../developers.html">Developers</a> &raquo;</li>
+      
+    <li>Developer Guidance</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/guidance.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-guidance"></span><div class="section" id="developer-guidance">
+<h1>Developer Guidance<a class="headerlink" href="#developer-guidance" title="Permalink to this headline">¶</a></h1>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l1"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="guidance/hacking.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Hacking" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="thoughts/prot-events.html" class="btn btn-neutral" title="Cyrus IMAP Server: Prot Events" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 13 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/install-xapian.html 3.2.0-3/doc/html/imap/developer/install-xapian.html
--- 3.0.13-5/doc/html/imap/developer/install-xapian.html	2019-12-16 04:16:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/install-xapian.html	2020-05-04 04:11:32.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Xapian for searching &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Xapian for searching &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Namespaces: a developer view" href="namespaces.html"/>
-        <link rel="prev" title="Tips for Hacking on Cyrus" href="developer-tips.html"/> 
+        <link rel="prev" title="JMAP support" href="jmap.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/install-xapian.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/install-xapian.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -824,10 +843,10 @@ packages are required:</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">search_engine</span><span class="p">:</span> <span class="n">xapian</span>
 <span class="n">search_index_headers</span><span class="p">:</span> <span class="n">no</span>
 <span class="n">search_batchsize</span><span class="p">:</span> <span class="mi">8192</span>
-<span class="n">defaultpartition</span><span class="p">:</span> <span class="n">default</span>
+<span class="n">defaultpartition</span><span class="p">:</span> <span class="n">base</span>
 <span class="n">defaultsearchtier</span><span class="p">:</span> <span class="n">t1</span>
-<span class="n">partition</span><span class="o">-</span><span class="n">default</span><span class="p">:</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="n">spool</span>
-<span class="n">t1searchpartition</span><span class="o">-</span><span class="n">default</span><span class="p">:</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="n">search</span>
+<span class="n">partition</span><span class="o">-</span><span class="n">base</span><span class="p">:</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="n">spool</span>
+<span class="n">t1searchpartition</span><span class="o">-</span><span class="n">base</span><span class="p">:</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="n">search</span>
 </pre></div>
 </div>
 <p>If you want to do more complex search tiers and repacking, you&#8217;ll want to read:</p>
@@ -844,7 +863,7 @@ packages are required:</p>
         <a href="namespaces.html" class="btn btn-neutral float-right" title="Namespaces: a developer view" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="developer-tips.html" class="btn btn-neutral" title="Tips for Hacking on Cyrus" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="jmap.html" class="btn btn-neutral" title="JMAP support" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -853,7 +872,7 @@ packages are required:</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 14 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 14 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -873,7 +892,7 @@ packages are required:</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/jmap.html 3.2.0-3/doc/html/imap/developer/jmap.html
--- 3.0.13-5/doc/html/imap/developer/jmap.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/jmap.html	2020-05-04 04:11:33.000000000 +0000
@@ -0,0 +1,994 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>JMAP support &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../genindex.html"/>
+        <link rel="search" title="Search" href="../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
+        <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
+        <link rel="next" title="Xapian for searching" href="install-xapian.html"/>
+        <link rel="prev" title="Developer Test Environment" href="developer-testing.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../index.html">Home</a></li>
+    <li><a href="../../download.html">Download</a></li>
+    <li><a href="../../contribute.html">Contribute</a></li>
+    <li><a href="../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../index.html">
+      <img src="../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../index.html">
+ 
+
+  
+          
+          <img src="../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../developer.html">IMAP Developer Guide</a> &raquo;</li>
+      
+    <li>JMAP support</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/jmap.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="jmap-support">
+<span id="developer-jmap"></span><h1>JMAP support<a class="headerlink" href="#jmap-support" title="Permalink to this headline">¶</a></h1>
+<p><a class="reference external" href="http://jmap.io/">JMAP</a> is an alternate mechanism for synchronising a mail client with a mail server, intended as a replacement for IMAP. It is a transport-agnostic, stateless JSON-based API, aiming to be compatible with the IMAP data model, but with reduced data usage and more efficient synchronisation.</p>
+<div class="section" id="cyrus-administration">
+<h2>Cyrus administration<a class="headerlink" href="#cyrus-administration" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="compile-jmap-support-into-cyrus">
+<h3>Compile JMAP support into Cyrus<a class="headerlink" href="#compile-jmap-support-into-cyrus" title="Permalink to this headline">¶</a></h3>
+<ol class="arabic">
+<li><p class="first">Enable JMAP (and DAV) in Cyrus:</p>
+<blockquote>
+<div><ul class="simple">
+<li><code class="docutils literal"><span class="pre">./configure</span> <span class="pre">--enable-http</span> <span class="pre">--enable-jmap</span> <span class="pre">--enable-xapian</span></code> along with your other configuration options.</li>
+</ul>
+</div></blockquote>
+</li>
+<li><p class="first">Enable <a class="reference internal" href="../concepts/deployment/databases.html#imap-concepts-deployment-db-conversations"><span class="std std-ref">conversation support</span></a></p>
+<blockquote>
+<div><ul class="simple">
+<li>In <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, set <code class="docutils literal"><span class="pre">conversations:</span> <span class="pre">1</span></code>, <code class="docutils literal"><span class="pre">conversations_db:</span> <span class="pre">twoskip</span></code></li>
+<li>Create a conversations.db for each user: <code class="docutils literal"><span class="pre">ctl_conversationsdb</span> <span class="pre">-b</span> <span class="pre">-r</span></code></li>
+</ul>
+</div></blockquote>
+</li>
+</ol>
+<p>3. JMAP depends on Xapian. For full support (to gain full word boundary
+distinctions in CJK languages - Chinese, Japanese and Korean), this needs to be
+manually compiled due to extra patches needing to be applied.
+Our <a class="reference internal" href="install-xapian.html#imapinstall-xapian"><span class="std std-ref">Xapian install guide</span></a> shows how.</p>
+<p>4. Once installed, the <code class="docutils literal"><span class="pre">jmap</span></code> module must be enabled in
+<a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>: <code class="docutils literal"><span class="pre">httpmodules:</span> <span class="pre">jmap</span></code></p>
+</div>
+</div>
+<div class="section" id="jmap-client">
+<h2>JMAP client<a class="headerlink" href="#jmap-client" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="test-jmap-support">
+<h3>Test JMAP support<a class="headerlink" href="#test-jmap-support" title="Permalink to this headline">¶</a></h3>
+<p>Once Cyrus is running, you can test JMAP on the command line for any existing Cyrus user. The user must at least have an INBOX provisioned but is not required to have any calendars, contacts or messages.</p>
+<p>To obtain the JMAP mailbox folders for user <code class="docutils literal"><span class="pre">test</span></code>, issue the following request:</p>
+<div class="highlight-bash"><div class="highlight"><pre><span></span>curl -X POST <span class="se">\</span>
+     -H <span class="s2">&quot;Content-Type: application/json&quot;</span> <span class="se">\</span>
+     -H <span class="s2">&quot;Accept: application/json&quot;</span> <span class="se">\</span>
+     --user test:test <span class="se">\</span>
+     -d <span class="s1">&#39;{</span>
+<span class="s1">       &quot;using&quot;: [ &quot;urn:ietf:params:jmap:core&quot;, &quot;urn:ietf:params:jmap:mail&quot; ],</span>
+<span class="s1">       &quot;methodCalls&quot;: [[ &quot;Mailbox/get&quot;, {}, &quot;c1&quot; ]]</span>
+<span class="s1">     }&#39;</span> <span class="se">\</span>
+     http://localhost/jmap/
+</pre></div>
+</div>
+<p>you should get a response which looks similar to</p>
+<div class="highlight-none"><div class="highlight"><pre><span></span>{
+  &quot;methodResponses&quot;: [
+    [&quot;Mailbox/get&quot;, {
+      &quot;state&quot;: &quot;0&quot;,
+      &quot;list&quot;: [{
+        &quot;id&quot;: &quot;7c76ec2b-9bd8-4091-a665-640e232e3877&quot;,
+        &quot;name&quot;: &quot;Inbox&quot;,
+        &quot;parentId&quot;: null,
+        &quot;myRights&quot;: {
+          &quot;mayReadItems&quot;: true,
+          &quot;mayAddItems&quot;: true,
+          &quot;mayRemoveItems&quot;: true,
+          &quot;mayCreateChild&quot;: true,
+          &quot;mayDelete&quot;: false,
+          &quot;maySubmit&quot;: true,
+          &quot;maySetSeen&quot;: true,
+          &quot;maySetKeywords&quot;: true,
+          &quot;mayAdmin&quot;: true,
+          &quot;mayRename&quot;: false
+        },
+        &quot;role&quot;: &quot;inbox&quot;,
+        &quot;totalEmails&quot;: 0,
+        &quot;unreadEmails&quot;: 0,
+        &quot;totalThreads&quot;: 0,
+        &quot;unreadThreads&quot;: 0,
+        &quot;sortOrder&quot;: 1,
+        &quot;isSubscribed&quot;: false
+      }, {
+        &quot;id&quot;: &quot;5d9e4f44-7df9-4489-b8b3-32625b552aa1&quot;,
+        &quot;name&quot;: &quot;Trash&quot;,
+        &quot;parentId&quot;: null,
+        &quot;myRights&quot;: {
+          &quot;mayReadItems&quot;: true,
+          &quot;mayAddItems&quot;: true,
+          &quot;mayRemoveItems&quot;: true,
+          &quot;mayCreateChild&quot;: true,
+          &quot;mayDelete&quot;: true,
+          &quot;maySubmit&quot;: true,
+          &quot;maySetSeen&quot;: true,
+          &quot;maySetKeywords&quot;: true,
+          &quot;mayAdmin&quot;: true,
+          &quot;mayRename&quot;: true
+        },
+        &quot;role&quot;: null,
+        &quot;totalEmails&quot;: 0,
+        &quot;unreadEmails&quot;: 0,
+        &quot;totalThreads&quot;: 0,
+        &quot;unreadThreads&quot;: 0,
+        &quot;sortOrder&quot;: 10,
+        &quot;isSubscribed&quot;: true
+      }],
+      &quot;notFound&quot;: [],
+      &quot;accountId&quot;: &quot;test&quot;
+    }, &quot;c1&quot;]
+  ],
+  &quot;sessionState&quot;: &quot;0&quot;
+}
+</pre></div>
+</div>
+<p>Similar requests exist to obtain contacts and calendars. For details, see the
+JMAP specification.</p>
+</div>
+<div class="section" id="optional-install-sample-jmap-client">
+<h3>Optional: Install sample JMAP client<a class="headerlink" href="#optional-install-sample-jmap-client" title="Permalink to this headline">¶</a></h3>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">Cyrus does not yet implement JMAP authentication. Instead, it requires for
+each request the HTTP Basic Auth header set with the account&#8217;s username and
+password. If you intend to use the JMAP perl or web clients, make sure to add
+the required authentication headers for each request.</p>
+</div>
+<p>You can set up the <a class="reference external" href="https://github.com/jmapio/jmap-perl">JMAP Proxy (perl)</a> to sit in front of a standard IMAP server and query that over a custom JMAP client.</p>
+<p>Or you can install a sample <a class="reference external" href="https://github.com/jmapio/jmap-demo-webmail">JMAP web client</a> which requires the <a class="reference external" href="https://github.com/fastmail/overture">Overture.js library</a> and <a class="reference external" href="https://github.com/jmapio/jmap-js">JMAP JS library</a> to talk to a JMAP-enabled Cyrus server and build from there (subject to the <a class="reference external" href="https://tldrlegal.com/license/mit-license">MIT license</a>).</p>
+<p>The web client is a simple example (no compose, contacts or calendars). When you create your account, the most recent 50 emails will be downloaded in their entirety, so the first page should be snappy immediately. After that, you are redirected to the landing page. A background task will continue to pull in batches of messages and add them to your account, so you will see older messages appear while you are using the interface.</p>
+</div>
+<div class="section" id="developing-the-client-further">
+<h3>Developing the client further<a class="headerlink" href="#developing-the-client-further" title="Permalink to this headline">¶</a></h3>
+<p>You&#8217;ll want to become deeply familiar with the <a class="reference external" href="http://jmap.io/#i-want-to-get-involved-with-jmap.-what-do-i-need-to-know?">JMAP developer documentation</a></p>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">JMAP implementation in Cyrus is a work in progress. Current status can be
+viewed on the main <a class="reference internal" href="../download/installation/http/jmap.html#jmap-implementation"><span class="std std-ref">JMAP configuration page</span></a>.</p>
+</div>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="install-xapian.html" class="btn btn-neutral float-right" title="Xapian for searching" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="developer-testing.html" class="btn btn-neutral" title="Developer Test Environment" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 10 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/libraries/imclient.html 3.2.0-3/doc/html/imap/developer/libraries/imclient.html
--- 3.0.13-5/doc/html/imap/developer/libraries/imclient.html	2019-12-16 04:16:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/libraries/imclient.html	2020-05-04 04:11:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>imclient library &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>imclient library &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Developer Libraries" href="../libraries.html"/>
         <link rel="next" title="Releasing Cyrus IMAP" href="../releasing.html"/>
         <link rel="prev" title="Developer Libraries" href="../libraries.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../developers.html">Developers</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/libraries/imclient.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/libraries/imclient.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1046,7 +1065,7 @@ CAPABILITY request and prints out the re
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1066,7 +1085,7 @@ CAPABILITY request and prints out the re
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/libraries.html 3.2.0-3/doc/html/imap/developer/libraries.html
--- 3.0.13-5/doc/html/imap/developer/libraries.html	2019-12-16 04:16:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/libraries.html	2020-05-04 04:11:33.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Developer Libraries &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Developer Libraries &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="imclient library" href="libraries/imclient.html"/>
         <link rel="prev" title="Namespaces: a developer view" href="namespaces.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/libraries.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/libraries.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -796,7 +815,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 24 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 24 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/namespaces.html 3.2.0-3/doc/html/imap/developer/namespaces.html
--- 3.0.13-5/doc/html/imap/developer/namespaces.html	2019-12-16 04:16:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/namespaces.html	2020-05-04 04:11:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Namespaces: a developer view &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Namespaces: a developer view &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Developer Libraries" href="libraries.html"/>
         <link rel="prev" title="Xapian for searching" href="install-xapian.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul class="current">
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/namespaces.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/namespaces.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@ representation of it remains the same.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 07 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@ representation of it remains the same.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/overview.html 3.2.0-3/doc/html/imap/developer/overview.html
--- 3.0.13-5/doc/html/imap/developer/overview.html	2019-12-16 04:16:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/overview.html	2020-05-04 04:11:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Overview of Cyrus development environment &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Overview of Cyrus development environment &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="GitHub guide" href="github-guide.html"/>
         <link rel="prev" title="Development Process" href="process.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/overview.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/overview.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -841,7 +860,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -861,7 +880,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/process.html 3.2.0-3/doc/html/imap/developer/process.html
--- 3.0.13-5/doc/html/imap/developer/process.html	2019-12-16 04:16:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/process.html	2020-05-04 04:11:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Development Process &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Development Process &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Overview of Cyrus development environment" href="overview.html"/>
         <link rel="prev" title="IMAP Developer Guide" href="../developer.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/process.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/process.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -815,7 +834,7 @@
 </div>
 <div class="section" id="useful-developer-information">
 <h2>Useful Developer Information<a class="headerlink" href="#useful-developer-information" title="Permalink to this headline">¶</a></h2>
-<p>Some combined <a class="reference internal" href="developer-tips.html#cyrus-hacking"><span class="std std-ref">tips on developing with Cyrus</span></a> have been collected.</p>
+<p>Some combined <a class="reference internal" href="guidance.html#imap-developer-guidance"><span class="std std-ref">tips on developing with Cyrus</span></a> have been collected.</p>
 </div>
 <div class="section" id="community-participation">
 <h2>Community Participation<a class="headerlink" href="#community-participation" title="Permalink to this headline">¶</a></h2>
@@ -843,7 +862,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 13 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -863,7 +882,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/releasing.html 3.2.0-3/doc/html/imap/developer/releasing.html
--- 3.0.13-5/doc/html/imap/developer/releasing.html	2019-12-16 04:16:50.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/releasing.html	2020-05-04 04:11:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Releasing Cyrus IMAP &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Releasing Cyrus IMAP &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="IMAP Developer Guide" href="../developer.html"/>
         <link rel="next" title="Releasing new builds of ancient Cyrus IMAP versions" href="ancient-releasing.html"/>
         <link rel="prev" title="imclient library" href="libraries/imclient.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../developers.html">Developers</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer/releasing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/releasing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -773,11 +792,14 @@
 <ul class="simple">
 <li><a class="reference internal" href="#releasing-cyrus-imap" id="id1">Releasing Cyrus IMAP</a><ul>
 <li><a class="reference internal" href="#prerequisites" id="id2">Prerequisites</a></li>
-<li><a class="reference internal" href="#release-notes" id="id3">Release notes</a></li>
-<li><a class="reference internal" href="#pre-release-testing" id="id4">Pre-release testing</a></li>
-<li><a class="reference internal" href="#linking-up-release-notes" id="id5">Linking up release notes</a></li>
-<li><a class="reference internal" href="#version-tagging" id="id6">Version tagging</a></li>
-<li><a class="reference internal" href="#releasing" id="id7">Releasing</a></li>
+<li><a class="reference internal" href="#order-of-operations" id="id3">Order of operations</a></li>
+<li><a class="reference internal" href="#release-notes" id="id4">Release notes</a></li>
+<li><a class="reference internal" href="#pre-release-testing" id="id5">Pre-release testing</a></li>
+<li><a class="reference internal" href="#linking-up-release-notes" id="id6">Linking up release notes</a></li>
+<li><a class="reference internal" href="#version-tagging" id="id7">Version tagging</a></li>
+<li><a class="reference internal" href="#inter-version-website-consistency" id="id8">Inter-version website consistency</a></li>
+<li><a class="reference internal" href="#uploading" id="id9">Uploading</a></li>
+<li><a class="reference internal" href="#tell-the-world" id="id10">Tell the world</a></li>
 </ul>
 </li>
 </ul>
@@ -793,13 +815,24 @@ off the top of her head how to create on
 manual like she did. :)</p>
 <p>Once you have a GPG key, it&#8217;s helpful to upload your public key to
 <a class="reference external" href="http://pgp.mit.edu">the MIT key-server</a></p>
-<p>You also need a shell account on www.cyrusimap.org and ftp.cyrusimap.org,
-with SSH key authentication.  You need to be in the &#8220;admin&#8221; group on each,
-and also the &#8220;cyrupload&#8221; group on the latter.</p>
 <p>And you need permission to send to the cyrus-announce mailing list.</p>
 </div>
+<div class="section" id="order-of-operations">
+<h2><a class="toc-backref" href="#id3">Order of operations</a><a class="headerlink" href="#order-of-operations" title="Permalink to this headline">¶</a></h2>
+<p>Sometimes you&#8217;re releasing several new versions all at once(ish), for example
+maybe there&#8217;s been a security fix that affected 2.4, 2.5 and 3.0.</p>
+<p>Github&#8217;s release page will put a &#8220;Latest Release&#8221; graphic on the release with
+the newest tag (by timestamp, I think).  This means that, if you&#8217;re doing new
+releases for several different versions, you want to do the oldest one first,
+and only do the release for the current-stable branch last.</p>
+<p>If you start at the current stable branch and then work your way backwards
+through the older ones, you&#8217;ll get Github saying &#8220;2.5.15 is the Latest
+Release&#8221; even though 3.0.13 was also just released... so, even though
+releasing the current-stable fix feels more urgent, suck it up and get the
+older-branch ones out first.</p>
+</div>
 <div class="section" id="release-notes">
-<h2><a class="toc-backref" href="#id3">Release notes</a><a class="headerlink" href="#release-notes" title="Permalink to this headline">¶</a></h2>
+<h2><a class="toc-backref" href="#id4">Release notes</a><a class="headerlink" href="#release-notes" title="Permalink to this headline">¶</a></h2>
 <p>Write up the release notes, and add them to the appropriate location under
 <code class="docutils literal"><span class="pre">docsrc/imap/download/release-notes/</span></code>.  They will not yet be linked up.</p>
 <p>Commit and push your changes, and then wait for cyrusimap.org to rebuild
@@ -810,7 +843,7 @@ version in the address bar to load up th
 correct and complete.</p>
 </div>
 <div class="section" id="pre-release-testing">
-<h2><a class="toc-backref" href="#id4">Pre-release testing</a><a class="headerlink" href="#pre-release-testing" title="Permalink to this headline">¶</a></h2>
+<h2><a class="toc-backref" href="#id5">Pre-release testing</a><a class="headerlink" href="#pre-release-testing" title="Permalink to this headline">¶</a></h2>
 <ol class="arabic simple">
 <li>Ensure your git repository is clean, using something like <code class="docutils literal"><span class="pre">git</span> <span class="pre">clean</span> <span class="pre">-xfd</span></code>.
 Note that this command will destroy any uncommitted work you might have,
@@ -820,7 +853,7 @@ so make sure your ducks are in line befo
 need any other options at this stage).</li>
 <li>Run <code class="docutils literal"><span class="pre">make</span> <span class="pre">distcheck</span></code>.  This will generate a distribution tarball, and
 test it in various ways.  It takes about 10-15 mins to run, depending on
-your hardware.  If this command fails, you are not ready to release &#8211;
+your hardware.  If this command fails*, you are not ready to release &#8211;
 fix the problems, get them tested and committed, then restart the
 pre-release testing.</li>
 <li><code class="docutils literal"><span class="pre">make</span> <span class="pre">distcheck</span></code> can only test so much (it doesn&#8217;t know about cunit or
@@ -840,9 +873,25 @@ testing.</li>
 </ol>
 </li>
 </ol>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last"><code class="docutils literal"><span class="pre">make</span> <span class="pre">distcheck</span></code> doesn&#8217;t work on the 2.5 branch.  For 2.5, just use
+<code class="docutils literal"><span class="pre">make</span> <span class="pre">dist</span></code> instead.</p>
+</div>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p>Realistically, there&#8217;s usually some set of expected Cassandane failures
+from each Cyrus branch, especially for 2.5.  If you&#8217;re doing releases
+regularly, you&#8217;ve probably got a good gut feel for which failures are a
+problem and which ones are just &#8220;that old thing&#8221;.  If you don&#8217;t do
+releases regularly, try to pull in someone who does for guidance about
+which failures are ignorable, and which should be a source of stress.</p>
+<p class="last">If in doubt, try building and testing the previous release from the same
+series, and compare the test results.</p>
+</div>
 </div>
 <div class="section" id="linking-up-release-notes">
-<h2><a class="toc-backref" href="#id5">Linking up release notes</a><a class="headerlink" href="#linking-up-release-notes" title="Permalink to this headline">¶</a></h2>
+<h2><a class="toc-backref" href="#id6">Linking up release notes</a><a class="headerlink" href="#linking-up-release-notes" title="Permalink to this headline">¶</a></h2>
 <p>The linkage of release notes is handled in <code class="docutils literal"><span class="pre">docsrc/conf.py</span></code>.  There&#8217;s a bunch
 of places it needs to be updated.  We should iterate these in detail at some
 point, but for now the easiest thing to do is look for lines containing the
@@ -855,10 +904,10 @@ gives her 50 minutes to finish the rest
 website updating before the downloads are available.</p>
 </div>
 <div class="section" id="version-tagging">
-<h2><a class="toc-backref" href="#id6">Version tagging</a><a class="headerlink" href="#version-tagging" title="Permalink to this headline">¶</a></h2>
-<p>Note: it is absolutely critical that your local commits have been pushed
-upstream at this point.  If they are not, and if anybody else pushes in the
-meantime, you will end up with a mess.</p>
+<h2><a class="toc-backref" href="#id7">Version tagging</a><a class="headerlink" href="#version-tagging" title="Permalink to this headline">¶</a></h2>
+<p>Note: it is absolutely critical that your repository is clean and your local
+commits have been pushed upstream at this point.  If they are not, and if
+anybody else pushes in the meantime, you will end up with a mess.</p>
 <ol class="arabic">
 <li><p class="first">Ensure your repository is clean again: <code class="docutils literal"><span class="pre">git</span> <span class="pre">clean</span> <span class="pre">-xfd</span></code></p>
 </li>
@@ -896,16 +945,64 @@ remote is named &#8220;ci&#8221;).</p>
 </li>
 </ol>
 </div>
-<div class="section" id="releasing">
-<h2><a class="toc-backref" href="#id7">Releasing</a><a class="headerlink" href="#releasing" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="inter-version-website-consistency">
+<h2><a class="toc-backref" href="#id8">Inter-version website consistency</a><a class="headerlink" href="#inter-version-website-consistency" title="Permalink to this headline">¶</a></h2>
+<p>The website is built from an amalgamation of documentation from:</p>
+<ul>
+<li><p class="first">The current stable cyrus-imapd branch (top level)</p>
+</li>
+<li><p class="first">The current master cyrus-imapd branch (<code class="docutils literal"><span class="pre">/dev</span></code> hierarchy)</p>
+</li>
+<li><p class="first">Each of the following cyrus-imapd branches (<code class="docutils literal"><span class="pre">/x.y</span></code> hierarchies)</p>
+<blockquote>
+<div><ul class="simple">
+<li>cyrus-imapd-2.5</li>
+<li>cyrus-imapd-3.0</li>
+<li>cyrus-imapd-3.2</li>
+</ul>
+</div></blockquote>
+</li>
+<li><p class="first">The current master cyrus-sasl branch (<code class="docutils literal"><span class="pre">/sasl</span></code> hierarchy)</p>
+</li>
+</ul>
+<p>When making a cyrus-imapd release, you need to add the new release notes
+file to each relevant cyrus-imapd branch.  You also need to check and
+update the contents of <code class="docutils literal"><span class="pre">docsrc/conf.py</span></code> on each branch AND the cyrus-sasl
+repository.</p>
+<p>Sometimes you can just cherry-pick the commits around, but note that the
+2.5 website stores release notes files in a different path, so if you
+bother to copy release notes back to this branch, a naive cherry-pick will
+not put them in the right place!</p>
+<p>This step often gets forgotten, so if you actually follow it, and notice
+some missing versions, just go ahead and add them while you&#8217;re there.</p>
+</div>
+<div class="section" id="uploading">
+<h2><a class="toc-backref" href="#id9">Uploading</a><a class="headerlink" href="#uploading" title="Permalink to this headline">¶</a></h2>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">This section does NOT apply to releases from the master branch.  We
+do not publish release tarballs for those.  People running master code
+are expected to use a git checkout.</p>
+</div>
+<p>Time to upload the release tarball and signature file!</p>
+<ol class="arabic simple">
+<li>Navigate to <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases">https://github.com/cyrusimap/cyrus-imapd/releases</a></li>
+<li>The tag you pushed earlier will now be available as a release, but it will
+have very little information about it</li>
+<li>Click on the tag name</li>
+<li>Click &#8220;Edit tag&#8221; on the right</li>
+<li><em>Leave every field on the page as it is (probably blank!), except</em>:</li>
+<li>Use the &#8220;Attach binaries by dropping them here or selecting them&#8221; widget
+to upload the tarball and signature files</li>
+<li>If this is an alpha/beta/rc release, click the &#8220;This is a pre-release&#8221;
+checkbox</li>
+<li>Click &#8220;Save&#8221;.  The commit message from the tag annotation will be used
+as the release description.</li>
+</ol>
+</div>
+<div class="section" id="tell-the-world">
+<h2><a class="toc-backref" href="#id10">Tell the world</a><a class="headerlink" href="#tell-the-world" title="Permalink to this headline">¶</a></h2>
 <ol class="arabic simple">
-<li>Upload the tarball and signature to www: <code class="docutils literal"><span class="pre">scp</span> <span class="pre">cyrus-imapd-*.tar.gz</span> <span class="pre">cyrus-imapd-*.tar.gz.sig</span>
-<span class="pre">www.cyrusimap.org:/var/www/html/releases/</span></code></li>
-<li>Upload them to ftp too: <code class="docutils literal"><span class="pre">scp</span> <span class="pre">cyrus-imapd-*.tar.gz</span> <span class="pre">cyrus-imapd-*.tar.gz.sig</span>
-<span class="pre">ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/</span></code></li>
-<li>SSH into both www and ftp, and move older releases to the old versions
-directory.  You want only the two most recent tarball+sig pairs for each
-major series.</li>
 <li>Update the topic in the #cyrus IRC channel.</li>
 <li>Send an announcement to the info-cyrus and cyrus-announce lists.</li>
 </ol>
@@ -930,7 +1027,7 @@ major series.</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 21 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -950,7 +1047,7 @@ major series.</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/backup.html 3.2.0-3/doc/html/imap/developer/thoughts/backup.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/backup.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/backup.html	2020-05-04 04:11:36.000000000 +0000
@@ -0,0 +1,1858 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Notes for backup implementation &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Sieve Bytecode" href="bytecode.html"/>
+        <link rel="prev" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Notes for backup implementation</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/backup.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-backup"></span><div class="section" id="notes-for-backup-implementation">
+<h1>Notes for backup implementation<a class="headerlink" href="#notes-for-backup-implementation" title="Permalink to this headline">¶</a></h1>
+<p>Backup index database (one per user):</p>
+<p>chunk:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="nb">id</span>
+<span class="n">timestamp</span> <span class="n">ts</span>
+<span class="nb">int</span> <span class="n">offset</span>
+<span class="nb">int</span> <span class="n">length</span>
+<span class="n">text</span> <span class="n">file_sha1</span>              <span class="o">-&gt;</span> <span class="n">sha1</span> <span class="n">of</span> <span class="p">(</span><span class="n">compressed</span><span class="p">)</span> <span class="n">data</span> <span class="n">prior</span> <span class="n">to</span> <span class="n">this</span> <span class="n">chunk</span>
+<span class="n">text</span> <span class="n">data_sha1</span>              <span class="o">-&gt;</span> <span class="n">sha1</span> <span class="n">of</span> <span class="p">(</span><span class="n">uncompressed</span><span class="p">)</span> <span class="n">data</span> <span class="n">contained</span> <span class="ow">in</span> <span class="n">this</span> <span class="n">chunk</span>
+</pre></div>
+</div>
+<p>mailbox:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="nb">id</span>
+<span class="nb">int</span> <span class="n">last_chunk_id</span>           <span class="o">-&gt;</span> <span class="n">chunk</span> <span class="n">that</span> <span class="n">knows</span> <span class="n">the</span> <span class="n">current</span> <span class="n">state</span>
+<span class="n">char</span> <span class="n">uniqueid</span>               <span class="o">-&gt;</span> <span class="n">unique</span>
+<span class="n">char</span> <span class="n">mboxname</span>               <span class="o">-&gt;</span> <span class="n">altered</span> <span class="n">by</span> <span class="n">a</span> <span class="n">rename</span>
+<span class="n">char</span> <span class="n">mboxtype</span>
+<span class="nb">int</span> <span class="n">last_uid</span>
+<span class="nb">int</span> <span class="n">highestmodseq</span>
+<span class="nb">int</span> <span class="n">recentuid</span>
+<span class="n">timestamp</span> <span class="n">recenttime</span>
+<span class="n">timestamp</span> <span class="n">last_appenddate</span>
+<span class="n">timestamp</span> <span class="n">pop3_last_login</span>
+<span class="n">timestamp</span> <span class="n">pop3_show_after</span>
+<span class="n">timestamp</span> <span class="n">uidvalidity</span>
+<span class="n">char</span> <span class="n">partition</span>
+<span class="n">char</span> <span class="n">acl</span>
+<span class="n">char</span> <span class="n">options</span>
+<span class="nb">int</span> <span class="n">sync_crc</span>
+<span class="nb">int</span> <span class="n">sync_crc_annot</span>
+<span class="n">char</span> <span class="n">quotaroot</span>
+<span class="nb">int</span> <span class="n">xconvmodseq</span>
+<span class="n">char</span> <span class="n">annotations</span>
+<span class="n">timestamp</span> <span class="n">deleted</span>           <span class="o">-&gt;</span> <span class="n">time</span> <span class="n">that</span> <span class="n">it</span> <span class="n">was</span> <span class="n">unmailbox</span><span class="s1">&#39;d, or NULL if still alive</span>
+</pre></div>
+</div>
+<p>message:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="nb">id</span>
+<span class="n">char</span> <span class="n">guid</span>
+<span class="n">char</span> <span class="n">partition</span>              <span class="o">-&gt;</span> <span class="n">this</span> <span class="ow">is</span> <span class="n">used</span> <span class="n">to</span> <span class="nb">set</span> <span class="n">the</span> <span class="n">spool</span> <span class="n">directory</span> <span class="k">for</span> <span class="n">the</span> <span class="n">temp</span> <span class="n">file</span> <span class="o">-</span> <span class="n">we</span> <span class="n">might</span> <span class="ow">not</span> <span class="n">need</span> <span class="n">it</span>
+<span class="nb">int</span> <span class="n">chunk_id</span>
+<span class="nb">int</span> <span class="n">offset</span>                  <span class="o">-&gt;</span> <span class="n">offset</span> <span class="n">within</span> <span class="n">chunk</span> <span class="n">of</span> <span class="n">dlist</span> <span class="n">containing</span> <span class="n">this</span> <span class="n">message</span>
+<span class="nb">int</span> <span class="n">size</span>                    <span class="o">-&gt;</span> <span class="n">size</span> <span class="n">of</span> <span class="n">this</span> <span class="n">message</span> <span class="p">(</span><span class="n">n</span><span class="o">.</span><span class="n">b</span><span class="o">.</span> <span class="ow">not</span> <span class="n">length</span> <span class="n">of</span> <span class="n">dlist</span><span class="p">)</span>
+</pre></div>
+</div>
+<p>mailbox_message:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">mailbox_id</span>
+<span class="nb">int</span> <span class="n">message_id</span>
+<span class="nb">int</span> <span class="n">last_chunk_id</span>           <span class="o">-&gt;</span> <span class="n">chunk</span> <span class="n">that</span> <span class="n">has</span> <span class="n">a</span> <span class="n">RECORD</span> <span class="ow">in</span> <span class="n">a</span> <span class="n">MAILBOX</span> <span class="k">for</span> <span class="n">this</span>
+<span class="nb">int</span> <span class="n">uid</span>
+<span class="nb">int</span> <span class="n">modseq</span>
+<span class="n">timestamp</span> <span class="n">last_updated</span>
+<span class="n">char</span> <span class="n">flags</span>
+<span class="n">timestamp</span> <span class="n">internaldate</span>
+<span class="nb">int</span> <span class="n">size</span>
+<span class="n">char</span> <span class="n">annotations</span>
+<span class="n">timestamp</span> <span class="n">expunged</span>          <span class="o">-&gt;</span> <span class="n">time</span> <span class="n">that</span> <span class="n">it</span> <span class="n">was</span> <span class="n">expunged</span><span class="p">,</span> <span class="ow">or</span> <span class="n">NULL</span> <span class="k">if</span> <span class="n">still</span> <span class="n">alive</span>
+</pre></div>
+</div>
+<p>subscription:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">last_chunk_id</span>           <span class="o">-&gt;</span> <span class="n">chunk</span> <span class="n">that</span> <span class="n">knows</span> <span class="n">the</span> <span class="n">current</span> <span class="n">state</span>
+<span class="n">char</span> <span class="n">mboxname</span>               <span class="o">-&gt;</span> <span class="n">no</span> <span class="n">linkage</span> <span class="n">to</span> <span class="n">mailbox</span> <span class="n">table</span><span class="p">,</span> <span class="n">users</span> <span class="n">can</span> <span class="n">be</span> <span class="n">sub</span><span class="s1">&#39;d to nonexistent</span>
+<span class="n">timestamp</span> <span class="n">unsubscribed</span>      <span class="o">-&gt;</span> <span class="n">time</span> <span class="n">that</span> <span class="n">it</span> <span class="n">was</span> <span class="n">unsubscribed</span><span class="p">,</span> <span class="ow">or</span> <span class="n">NULL</span> <span class="k">if</span> <span class="n">still</span> <span class="n">alive</span>
+</pre></div>
+</div>
+<p>seen:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">last_chunk_id</span>           <span class="o">-&gt;</span> <span class="n">chunk</span> <span class="n">that</span> <span class="n">knows</span> <span class="n">the</span> <span class="n">current</span> <span class="n">state</span>
+<span class="n">char</span> <span class="n">uniqueid</span>               <span class="o">-&gt;</span> <span class="n">mailbox</span> <span class="p">(</span><span class="ow">not</span> <span class="n">necessarily</span> <span class="n">ours</span><span class="p">)</span> <span class="n">this</span> <span class="n">applies</span> <span class="n">to</span>
+<span class="n">timestamp</span> <span class="n">lastread</span>
+<span class="nb">int</span> <span class="n">lastuid</span>
+<span class="n">timestamp</span> <span class="n">lastchange</span>
+<span class="n">char</span> <span class="n">seenuids</span>               <span class="o">-&gt;</span> <span class="n">a</span> <span class="n">uid</span> <span class="n">sequence</span> <span class="n">encoded</span> <span class="k">as</span> <span class="n">a</span> <span class="n">string</span>
+</pre></div>
+</div>
+<p>sieve:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="nb">int</span> <span class="n">chunk_id</span>
+<span class="n">timestamp</span> <span class="n">last_update</span>
+<span class="n">char</span> <span class="n">filename</span>
+<span class="n">char</span> <span class="n">guid</span>
+<span class="nb">int</span> <span class="n">offset</span>                  <span class="o">-&gt;</span> <span class="n">offset</span> <span class="n">within</span> <span class="n">chunk</span> <span class="n">of</span> <span class="n">the</span> <span class="n">dlist</span> <span class="n">containing</span> <span class="n">this</span> <span class="n">script</span>
+<span class="n">timestamp</span> <span class="n">deleted</span>           <span class="o">-&gt;</span> <span class="n">time</span> <span class="n">that</span> <span class="n">it</span> <span class="n">was</span> <span class="n">deleted</span><span class="p">,</span> <span class="ow">or</span> <span class="n">NULL</span> <span class="k">if</span> <span class="n">still</span> <span class="n">alive</span>
+</pre></div>
+</div>
+<p>sieve scripts and messages are both identified by a GUID
+but APPLY SIEVE doesn&#8217;t take a GUID, it seems to be generated locally?
+the GUID in the response to APPLY SIEVE is generated in the process of
+reading the script from disk (sync_sieve_list_generate)</p>
+<p>can&#8217;t activate scripts because only bytecode files are activated, but
+we neither receive bytecode files over sync protocol nor do we compile
+them ourselves.</p>
+<p>possibly reduce index size by breaking deleted/expunged values into their
+own tables, such that we only store a deleted value for things that are
+actually deleted.  use left join + is null to find undeleted content</p>
+<div class="section" id="messages">
+<h2>messages<a class="headerlink" href="#messages" title="Permalink to this headline">¶</a></h2>
+<p>APPLY MESSAGE is a list of messages, not necessarily only one message.
+Actually, it&#8217;s a list of messages for potentially multiple users, but we avoid
+this by rejecting GET MESSAGES requests that span multiple users (so that
+sync_client retries at USER level, and so we only see APPLY MESSAGE requests
+for a single user).</p>
+<p>Cheap first implementation is to index the start/end of the entire APPLY
+MESSAGE command identically for each message within it, and at restore time
+we grab that chunk and loop over it looking for the correct guid.</p>
+<p>Ideal implementation would be to index the offset and length of each message
+exactly (even excluding the dlist wrapper), but this is rather complicated
+by the dlist API.</p>
+<p>For now, we just index the offset of the dlist entry for the message,
+and we can parse the pure message data back out later from that, when
+we need to.  Slightly less efficient on reads, but works-&gt;good-&gt;fast.  We
+need to loop over the entries in the MESSAGE dlist to find the one with the
+desired GUID.</p>
+<p>The indexed length needs to be the length of the message, not the length of the
+dlist wrapper, because we need to know this cheaply to supply RECORDs in
+MAILBOX responses.</p>
+</div>
+<div class="section" id="renames">
+<h2>renames<a class="headerlink" href="#renames" title="Permalink to this headline">¶</a></h2>
+<p>APPLY RENAME %(OLDMBOXNAME old NEWMBOXNAME new PARTITION p UIDVALIDITY 123)</p>
+<p>We identify mboxes by uniqueid, so when we start seeing sync data for the same
+uniqueid with a new mboxname we just transparently update it anyway, without
+needing to handle the APPLY RENAME.  Not sure if this is a problem...  Do we
+need to record an mbox&#8217;s previous names somehow?</p>
+<p>I think it&#8217;s possible to use this to rename a USER though, something like:</p>
+<p>APPLY RENAME %(OLDMBOXNAME example.com!user.smithj NEWMBOXNAME example.com!user.jsmith ...)</p>
+<p>&#8211; in which case, without special handling of the RENAME command itself, there
+will be a backup for the old user that ends with the RENAME, and a backup of
+the new user that (probably) duplicates everything again (except for stuff
+that&#8217;s been expunged).</p>
+<p>And if someone else gets given the original name, like</p>
+<p>APPLY RENAME %(OLDMBOXNAME example.com!user.samantha-mithj NEWMBOXNAME example.com!user.smithj ...)</p>
+<p>Then anything that was expunged from the original user but still available in
+backup disappears?  Or the two backups get conflated, and samantha can
+&#8220;restore&#8221; the original smithj&#8217;s old mail?</p>
+<p>Uggh.</p>
+<p>if there&#8217;s a mailboxes database pointing to the backup files, then the backup
+file names don&#8217;t need to be based on the userid, they could e.g. be based on
+the user&#8217;s inbox&#8217;s uniqueid.  this would make it easier to deal with user
+renames because the backup filename wouldn&#8217;t need to change.  but this depends
+on the uniqueid(s) in question being present on most areas of the sync
+protocol, otherwise when starting a backup of a brand new user we won&#8217;t be
+able to tell where to store it.  workaround in the meantime could be to make
+some kind of backup id from the mailboxes database, and base the filename on
+this.</p>
+<p>actually, using &#8220;some kind of backup id from the mailboxes database&#8221; is probably
+the best solution.  otherwise the lock complexity of renaming a user while making
+sure their new backup filename doesn&#8217;t already exist is frightful.</p>
+<p>maybe do something with mkstemp()?</p>
+<p>furthermore: what if a mailbox is moved from one user to another?  like:</p>
+<p>APPLY RENAME %(OLD... example.com!user.foo.something NEW... example.com!user.bar.something ...)</p>
+<p>when a different-uid rename IS a rename of a user (and not just a folder
+being moved to a different user), what does it look like?
+* does it do a single APPLY RENAME for the user, and expect their folders to shake out of that?
+* does it do an APPLY RENAME for each of their folders?</p>
+<p>in the latter case, we need to append each of those RENAMEs to the old backup
+so they can take effect correctly, and THEN rename the backup file itself. but
+how to tell when the appends are finished?</p>
+<p>how can we tell the difference between folder(s) moved to a different user vs
+user has been renamed?</p>
+<p>there is a setting: &#8216;allowusermoves: 0&#8217; which, when enabled, allows users to
+be renamed via IMAP rename/xfer commands.  but the default is that this is
+disabled.  we could initially require this to be disabled while using backups...</p>
+<p>not sure what the workflow looks like for renaming a user if this is not enabled.</p>
+<p>not sure what the sync flow looks like in either case.</p>
+<p>looking at sync_apply_rename and mboxlist_renamemailbox, it seems like we&#8217;ll
+see an APPLY RENAME for each affected mbox when a recursive rename is occurring.</p>
+<p>there doesn&#8217;t seem to be anything preventing user/a/foo -&gt; user/b/foo in the
+general (non-INBOX) case.</p>
+<p>renames might be a little easier to handle if the index replicated the mailbox
+hierarchy rather than just being a flat structure.  though this adds complexity
+wrt hiersep handling.  something like:</p>
+<p>mailbox:</p>
+<blockquote>
+<div><dl class="docutils">
+<dt>mboxname</dt>
+<dd># just the name of this mbox</dd>
+<dt>parent_id</dt>
+<dd># fk to parent mailbox</dd>
+<dt>full_mboxname</dt>
+<dd># cached value, parent.full_mboxname + mboxname</dd>
+</dl>
+</div></blockquote>
+</div>
+<div class="section" id="locking">
+<h2>locking<a class="headerlink" href="#locking" title="Permalink to this headline">¶</a></h2>
+<p>just use a normal flock/fcntl lock on the data file and only open the index
+if that lock succeeded</p>
+<ul class="simple">
+<li>backup:   needs to append foo and update foo.index</li>
+<li><dl class="first docutils">
+<dt>reindex:  only needs to read foo, but needs a write lock to prevent</dt>
+<dd>writes while it does so. needs to write to (replace) foo.index</dd>
+</dl>
+</li>
+<li>compact:  needs to re-write foo and foo.index</li>
+<li>restore:  needs to read</li>
+</ul>
+</div>
+<div class="section" id="verifying-index">
+<h2>verifying index<a class="headerlink" href="#verifying-index" title="Permalink to this headline">¶</a></h2>
+<p>how to tell whether the .index file is the correct one for the backup data it
+ostensibly represents?</p>
+<p>one way to do this would be to have backup_index_end() store a checksum of
+the corresponding data contents in the index.</p>
+<p>when opening a backup, verify this checksum against the data, and refuse to
+load the index if it doesn&#8217;t match.</p>
+<ul class="simple">
+<li>sha1sum of (compressed) contents of file prior to each chunk</li>
+</ul>
+<p>how to tell whether the chunk data is any good?  store a checksum of the chunk
+contents along with the rest of the chunk index</p>
+<ul class="simple">
+<li>sha1sum of (uncompressed) contents of each chunk</li>
+</ul>
+</div>
+<div class="section" id="mailboxes-database">
+<h2>mailboxes database<a class="headerlink" href="#mailboxes-database" title="Permalink to this headline">¶</a></h2>
+<p>bron reckons use twoskip for this
+userid -&gt; backup_filename</p>
+<p>lib/cyrusdb module implements this, look into that</p>
+<p>look at conversations db code to see how to use it</p>
+<p>need a tool:
+* given a user, show their backup filename
+* dump/undump
+* rebuild based on files discovered in backup directory</p>
+<p>where does this fit into the locking scheme?</p>
+</div>
+<div class="section" id="reindex">
+<h2>reindex<a class="headerlink" href="#reindex" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>convert user mailbox name to backup name</li>
+<li>complain if there&#8217;s no backup data file?</li>
+<li>lock, rename .index to .index.old, init new .index</li>
+<li>foreach file chunk:</li>
+<li>timestamp is from first line in chunk</li>
+<li>complain if timestamp has gone backwards?</li>
+<li>index records from chunk</li>
+<li>unlock</li>
+<li>clean up .index.old</li>
+</ul>
+<p>on error:
+* discard partial new index
+* restore .index.old
+* bail out</p>
+</div>
+<div class="section" id="backupd">
+<h2>backupd<a class="headerlink" href="#backupd" title="Permalink to this headline">¶</a></h2>
+<p>cmdloop:
+* (periodic cleanup)
+* read command, determine backup name
+* already holding lock ? bump timestamp : obtain lock
+* write data to gzname, flush immediately
+* index data</p>
+<p>periodic cleanup:
+* check timestamp of each held lock
+* if stale (define: stale?), release
+* FIXME if we&#8217;ve appended more than the chunk size we would compact to, release</p>
+<p>sync restart:
+* release each held lock</p>
+<p>exit:
+* release each held lock</p>
+<p>need a &#8220;backup_index_abort&#8221; to complete the backup_index_start/end set.
+_start should create a transaction, _end should commit it, and _abort should
+roll it back.  then, if backupd fails to write to the gzip file for some
+reason, the (now invalid) index info we added can be discarded too.</p>
+<p>flushing immediately on write results in poor gzip compression, but for
+incremental backups that&#8217;s not a problem.  when the compact process hits the
+file it will recompress the data more efficiently.</p>
+</div>
+<div class="section" id="questions">
+<h2>questions<a class="headerlink" href="#questions" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>what does it look like when uidvalidity changes?</li>
+</ul>
+</div>
+<div class="section" id="restore">
+<h2>restore<a class="headerlink" href="#restore" title="Permalink to this headline">¶</a></h2>
+<p>restoration is effectively a reverse-direction replication (replicating TO master),
+which means we can&#8217;t necessarily supply things like uid, modseq, etc without racing
+against normal message arrivals.  so instead we add an extra command to the protocol
+to restore a message to a folder but let the destination determine the tasty bits.</p>
+<p>protocol flow looks something like:</p>
+<p>c: APPLY RESERVE ... # as usual
+s: * MISSING (foo bar)
+s: OK
+c: APPLY MESSAGE ... # as usual
+s: OK
+c: RESTORE MAILBOX ... # new sync proto command
+s: OK</p>
+<p>we introduce a new command, RESTORE MAILBOX, which is similar to the existing
+APPLY MAILBOX.  it specifies, for a mailbox, the mailbox state plus the message
+records relevant to the restore.</p>
+<p>the imapd/sync_server receiving the RESTORE command creates the mailbox if necessary,
+and then adds the message records to it as new records (i.e. generating new uid etc).
+this will end up generating new events in the backup channel&#8217;s sync log, and then the
+messages will be backed up again with their new uids, etc.  additional wire transfer
+of message data should be avoided by keeping the same guid.</p>
+<p>if the mailbox already exists but its uniqueid does not match the one from the backup,
+then what?  this probably means user has deleted folder and contents, then made new
+folder with same name.  so it&#8217;s probably v common for mailbox uniqueid to not match
+like this.  so we don&#8217;t care about special handling for this case.  just add any
+messages that aren&#8217;t already there.</p>
+<p>if the mailbox doesn&#8217;t already exist on the destination (e.g. if rebuilding a server
+from backups) then it&#8217;s safe and good to reuse uidvalidity, uniqueid, uid, modseq etc,
+such that connecting clients can preserve their state.  so the imapd/sync_server
+receiving the restore request accepts these fields as optional, but only preserves
+them if it&#8217;s safe to do so.</p>
+<ul class="simple">
+<li>restore: sbin program for selecting and restoring messages</li>
+</ul>
+<p>restore command needs options:
++ whether or not to trim deletedprefix off mailbox names to be restored
++ whether or not to restore uniqueid, highestmodseq, uid and so on
++ whether or not to limit to/exclude expunged messages
++ whether or not to restore sub-mailboxes
++ sync_client-like options (servername, local_only, partition, ...)
++ user/mailbox/backup file(s) to restore from
++ mailbox to restore to (override location in backup)
++ override acl?</p>
+<dl class="docutils">
+<dt>can we heuristically determine whether an argument is an mboxname, uniqueid or guid?</dt>
+<dd>=&gt; libuuid uniqueid is 36 bytes of hyphen (at fixed positions) and hex digits
+=&gt; non-libuuid uniqueid is 24 bytes of hex digits
+=&gt; mboxname usually contains at least one . somewhere
+=&gt; guid is 40 bytes of hex digits</dd>
+<dt>usage:</dt>
+<dd>restore [options] server [mode] backup [mboxname | uniqueid | guid]...</dd>
+<dt>options:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-A <var>acl</var></span></kbd></td>
+<td># apply specified acl to restored mailboxes</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-C <var>alt_config</var></span></kbd></td>
+<td># alternate config file</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-D</span></kbd></td>
+<td># don&#8217;t trim deletedprefix before restoring</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-F <var>input-file</var></span></kbd></td>
+<td># read mailboxes/messages from file rather than argv</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-L</span></kbd></td>
+<td># local mailbox operations only (no mupdate)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-M <var>mboxname</var></span></kbd></td>
+<td># restore messages to specified mailbox</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-P <var>partition</var></span></kbd></td>
+<td># restore mailboxes to specified partition</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-U</span></kbd></td>
+<td># try to preserve uniqueid, uid, modseq, etc</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-X</span></kbd></td>
+<td># don&#8217;t restore expunged messages</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-a</span></kbd></td>
+<td># try to restore all mailboxes in backup</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-n</span></kbd></td>
+<td># calculate work required but don&#8217;t perform restoration</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-r</span></kbd></td>
+<td># recurse into submailboxes</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-v</span></kbd></td>
+<td># verbose</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-w <var>seconds</var></span></kbd></td>
+<td># wait before starting (useful for attaching a debugger)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-x</span></kbd></td>
+<td># only restore expunged messages (not sure if useful?)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-z</span></kbd></td>
+<td># require compression (abort if compression unavailable)</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>mode:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-f</span></kbd></td>
+<td># specified backup interpreted as filename</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-m</span></kbd></td>
+<td># specified backup interpreted as mboxname</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-u</span></kbd></td>
+<td># specified backup interpreted as userid (default)</td></tr>
+</tbody>
+</table>
+</dd>
+</dl>
+</div>
+<div class="section" id="compact">
+<h2>compact<a class="headerlink" href="#compact" title="Permalink to this headline">¶</a></h2>
+<p># finding messages that are to be kept (either exist as unexpunged somewhere,
+# or exist as expunged but more recently than threshold)
+# (to get unique rows, add &#8220;distinct&#8221; and remove mm.expunged from fields)
+sqlite&gt; select m.*, mm.expunged from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged &gt; 1437709300);
+id|guid|partition|chunk_id|offset|length|expunged
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047</p>
+<p># finding chunks that are still needed (due to containing last state
+# of mailbox or mailbox_message, or containing a message)
+sqlite&gt; select * from chunk where id in (select last_chunk_id from mailbox where deleted is null or deleted &gt; 1437709300 union select last_chunk_id from mailbox_message where expunged is null or expunged &gt; 1437709300 union select chunk_id from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged &gt; 1437709300));
+id|timestamp|offset|length|file_sha1|data_sha1
+1|1437709276|0|3397|da39a3ee5e6b4b0d3255bfef95601890afd80709|6836d0110252d08a0656c14c2d2d314124755491
+3|1437709355|1977|2129|fee183c329c011ead7757f59182116500776eaaf|a5677cfa1f5f7b627763652f4bb9b99f5970748c
+4|1437709425|2746|1719|3d9f02135bf964ff0b6a917921b862c3420e48f0|7b64ec321457715ee61fe238f178f5d72adaef64
+5|1437709508|3589|2890|0cee599b1573110fee428f8323690cbcb9589661|90d104346ef3cba9e419461dd26045035f4cba02</p>
+<p>remember: a single APPLY MESSAGE line can contain many messages!</p>
+<p>thoughts:</p>
+<ul>
+<li><p class="first">need a heuristic for quickly determining whether a backup needs to be compacted</p>
+<blockquote>
+<div><ul class="simple">
+<li>sum(chunks to discard, chunks to combine, chunks to split) &gt; threshold</li>
+<li>can we detect chunks that are going to significantly reduce in size as result of discarding individual lines?</li>
+</ul>
+</div></blockquote>
+</li>
+<li><p class="first">&#8220;quick&#8221; vs &#8220;full&#8221; compaction</p>
+</li>
+</ul>
+<p>settings:</p>
+<ul class="simple">
+<li>backup retention period</li>
+<li>chunk combination size (byte length or elapsed time)</li>
+</ul>
+<p>combining chunks:
+* size threshold below which adjacent chunks can be joined
+* size threshold above which chunks should be split
+* duration threshold below which adjacent chunks can be joined
+* duration threshold above which chunks should be split
+backup_min_chunk_size: 0 for no minimum
+backup_max_chunk_size: 0 for no maximum
+backup_min_chunk_duration: 0 for no minimum
+backup_max_chunk_duration: 0 for no maximum
+priority: size or duration??</p>
+<p>data we absolutely need to keep:</p>
+<ul class="simple">
+<li>the most recent APPLY MAILBOX for each mailbox we&#8217;re keeping (mailbox state)</li>
+<li>the APPLY MAILBOX containing the most recent RECORD for each message we&#8217;re keeping (record state)</li>
+<li>the APPLY MESSAGE for each message we&#8217;re keeping (message data)</li>
+</ul>
+<p>data that we should practically keep:</p>
+<ul class="simple">
+<li>all APPLY MAILBOXes for a given mailbox from the chunk identified as its last</li>
+<li>all APPLY MAILBOXes containing a RECORD for a given message from the chunk identified as its last</li>
+<li>the APPLY MESSAGE for each message we&#8217;re keeping</li>
+</ul>
+<p>four kinds of compaction (probably at least two simultaneously):</p>
+<ul class="simple">
+<li>removing unused chunks</li>
+<li>combining adjacent chunks into a single chunk (for better gz compression)</li>
+<li>removing unused message lines from within a chunk (important after combining)</li>
+<li>removing unused messages from within a message line</li>
+</ul>
+<dl class="docutils">
+<dt>&#8220;unused messages&#8221;</dt>
+<dd>messages for which all records have been expunged for longer
+than the retention period</dd>
+<dt>&#8220;unused chunks&#8221;</dt>
+<dd>chunks which contain only unused messages</dd>
+</dl>
+<p>algorithm:</p>
+<ul class="simple">
+<li>open (and lock) backup and backup.new (or bail out)</li>
+<li>use backup index to identify chunks we still need</li>
+<li>create a chunk in backup.new</li>
+<li>foreach chunk we still need:</li>
+<li>foreach line in the chunk:</li>
+<li>next line if we don&#8217;t need to keep it</li>
+<li>create new line</li>
+<li>foreach message in line:</li>
+<li>if we still need the message, or if we&#8217;re not doing message granularity</li>
+<li>add the message to the new line</li>
+<li>write and index tmp line to backup.new</li>
+<li>if the new chunk is big enough, or if we&#8217;re not combining</li>
+<li>end chunk and start a new one</li>
+<li>end the new chunk</li>
+<li>rename backup-&gt;backup.old, backup.new-&gt;backup</li>
+<li>close (and unlock) backup.old and backup</li>
+</ul>
+</div>
+<div class="section" id="command-line-locking-utility">
+<h2>command line locking utility<a class="headerlink" href="#command-line-locking-utility" title="Permalink to this headline">¶</a></h2>
+<p>command line utility to lock a backup (for e.g. safely poking around in the
+.index on a live system).</p>
+<p>example failure:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+NO some error
+&lt;EOF&gt;</p>
+<p>example success:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+[potentially a delay here if we need to wait for another process to release the lock]
+OK locked
+[waits for its stdin to close, then unlocks and exits]</p>
+<p>if you need to rummage around in backup.index, run this program in another
+shell, do your work, then ^D it when you&#8217;re finished.</p>
+<p>you could also call this from e.g. perl over a bidirectional pipe - wait to
+read &#8220;OK locked&#8221;, then you&#8217;ve got your lock.  close the pipe to unlock when
+you&#8217;re finished working.  if you don&#8217;t read &#8220;OK locked&#8221; before the pipe closes
+then something went wrong and you didn&#8217;t get the lock.</p>
+<p>specify backups by -f filename, -m mailbox, -u userid
+default run mode as above
+-s to fork an sqlite of the index (and unlock when it exits)
+-x to fork a command of your choosing (and unlock when it exits)</p>
+</div>
+<div class="section" id="reconstruct">
+<h2>reconstruct<a class="headerlink" href="#reconstruct" title="Permalink to this headline">¶</a></h2>
+<p>rebuilding backups.db from on disk files</p>
+<dl class="docutils">
+<dt>scan each backup partition for backup files:</dt>
+<dd><ul class="first last simple">
+<li>skip timestamped files (i.e. backups from compact/reindex)</li>
+<li>skip .old files (old backups from reindex)</li>
+<li>.index files =&gt; skip???</li>
+<li>skip unreadable files</li>
+<li>skip empty files</li>
+<li>skip directories etc</li>
+</ul>
+</dd>
+</dl>
+<p>what&#8217;s the correct procedure for repopulating a cyrus database?
+keep copy of the previous (presumably broken) one?</p>
+<p>trim off mkstemp suffix (if any) to find userid
+can we use a recognisable character to delimit the mkstemp suffix?</p>
+<p>what if there&#8217;s multiple backup files for a given userid? precedence?</p>
+<p>verify found backups before recording.  reindex?</p>
+<p>locking? what if something has a filename and does stuff with it while
+reconstruct runs?</p>
+<p>backupd always uses db for opens, so as long as reconstruct keeps the db
+locked while it works, the db won&#8217;t clash.  but backupd might have backups
+still open from before reconstruct started, which it will write to quite
+happily, even though reconstruct might decide that some other file is the
+correct one for that user...</p>
+<p>a backup server would generally be used only for backups, and sync_client
+is quite resilient when the destination isn&#8217;t there, so it&#8217;s actually
+no problem to just shut down cyrus while reconstruct runs.  no outage to
+user-facing services, just maybe some sync backlog to catch up on once
+cyrus is restarted.</p>
+</div>
+<div class="section" id="ctl-backups">
+<h2>ctl_backups<a class="headerlink" href="#ctl-backups" title="Permalink to this headline">¶</a></h2>
+<p>sbin tool for mass backup/index/database operations</p>
+<dl class="docutils">
+<dt>needs:</dt>
+<dd><ul class="first last simple">
+<li>rebuild backups.db from disk contents</li>
+<li>list backups/info</li>
+<li>rename a backup</li>
+<li>delete a backup</li>
+<li>verify a backup (check all sha1&#8217;s, not just most recent)</li>
+</ul>
+</dd>
+<dt>not sure if these should be included, or separate tools:</dt>
+<dd><ul class="first last simple">
+<li>reindex a backup (or more)</li>
+<li>compact a backup (or more)</li>
+<li>lock a backup</li>
+<li>some sort of rolling compaction?</li>
+</ul>
+</dd>
+<dt>usage:</dt>
+<dd>ctl_backups [options] reconstruct                       # reconstruct backups.db from disk files
+ctl_backups [options] list [list_opts] [[mode] backup...] # list backup info for given/all users
+ctl_backups [options] move new_fname [mode] backup      # rename a backup (think about this more)
+ctl_backups [options] delete [mode] backup              # delete a backup
+ctl_backups [options] verify [mode] backup...           # verify specified backups
+ctl_backups [options] reindex [mode] backup...          # reindex specified backups
+ctl_backups [options] compact [mode] backup...          # compact specified backups
+ctl_backups [options] lock [lock_opts] [mode] backup    # lock specified backup</dd>
+<dt>options:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-C <var>alt_config</var></span></kbd></td>
+<td># alternate config file</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-F</span></kbd></td>
+<td># force (run command even if not needed)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-S</span></kbd></td>
+<td># stop on error</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-v</span></kbd></td>
+<td># verbose</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-w</span></kbd></td>
+<td># wait for locks (i.e. don&#8217;t skip locked backups)</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>mode:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-A</span></kbd></td>
+<td># all known backups (not valid for single backup commands)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-D</span></kbd></td>
+<td># specified backups interpreted as domains (nvfsbc)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-P</span></kbd></td>
+<td># specified backups interpreted as userid prefixes (nvfsbc)</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-f</span></kbd></td>
+<td># specified backups interpreted as filenames</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-m</span></kbd></td>
+<td># specified backups interpreted as mboxnames</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-u</span></kbd></td>
+<td># specified backups interpreted as userids (default)</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>lock_opts:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-c</span></kbd></td>
+<td># exclusively create backup</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-s</span></kbd></td>
+<td># lock backup and open index in sqlite</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-x <var>cmd</var></span></kbd></td>
+<td># lock backup and execute cmd</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-p</span></kbd></td>
+<td># lock backup and wait for eof on stdin (default)</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>list_opts:</dt>
+<dd>-t [hours]          # &#8220;stale&#8221; (no update in hours) backups only (default: 24)</dd>
+</dl>
+</div>
+<div class="section" id="cyr-backup">
+<h2>cyr_backup<a class="headerlink" href="#cyr-backup" title="Permalink to this headline">¶</a></h2>
+<p>sbin tool for inspecting backups</p>
+<dl class="docutils">
+<dt>needs:</dt>
+<dd><ul class="first last simple">
+<li>better name?</li>
+<li>list stuff</li>
+<li>show stuff</li>
+<li>dump stuff</li>
+<li>restore?</li>
+</ul>
+</dd>
+</dl>
+<ul class="simple">
+<li>should lock/move/delete (single backup commands) from ctl_backups be moved here?</li>
+</ul>
+<dl class="docutils">
+<dt>usage:</dt>
+<dd>cyr_backup [options] [mode] backup list [all | chunks | mailboxes | messages]...
+cyr_backup [options] [mode] backup show chunks [id...]
+cyr_backup [options] [mode] backup show messages [guid...]
+cyr_backup [options] [mode] backup show mailboxes [mboxname | uniqueid]...
+cyr_backup [options] [mode] backup dump [dump_opts] chunk id
+cyr_backup [options] [mode] backup dump [dump_opts] message guid
+cyr_backup [options] [mode] backup json [chunks | mailboxes | messages]...</dd>
+<dt>options:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-C <var>alt_config</var></span></kbd></td>
+<td># alternate config file</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-v</span></kbd></td>
+<td># verbose</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>mode:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-f</span></kbd></td>
+<td># backup interpreted as filename</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-m</span></kbd></td>
+<td># backup interpreted as mboxname</td></tr>
+<tr><td class="option-group">
+<kbd><span class="option">-u</span></kbd></td>
+<td># backup interpreted as userid (default)</td></tr>
+</tbody>
+</table>
+</dd>
+<dt>commands:</dt>
+<dd>list: table of contents, one per line
+show: indexed details of listed items, one per paragraph, detail per line
+dump: relevant contents from backup stream
+json: indexed details of listed items in json format</dd>
+<dt>dump options:</dt>
+<dd><table class="first last docutils option-list" frame="void" rules="none">
+<col class="option" />
+<col class="description" />
+<tbody valign="top">
+<tr><td class="option-group">
+<kbd><span class="option">-o <var>filename</var></span></kbd></td>
+<td># dump to named file instead of stdout</td></tr>
+</tbody>
+</table>
+</dd>
+</dl>
+</div>
+<div class="section" id="partitions">
+<h2>partitions<a class="headerlink" href="#partitions" title="Permalink to this headline">¶</a></h2>
+<p>not enough information in sync protocol to handle partitions easily?</p>
+<p>we know what the partition is when we do an APPLY operation (mailbox, message,
+etc), but the initial GET operations don&#8217;t include it.  so we need to already
+know where the appropriate backup is partitioned in order to find the backup
+file in order to look inside it to respond to the GET request</p>
+<p>if we have a mailboxes database (indexed by mboxname, uniqueid and userid) then
+maybe that would make it feasible?  if it&#8217;s not in the mailboxes database then
+we don&#8217;t have a backup for it yet, so we respond accordingly, and get sent
+enough information to create it.</p>
+<p>does that mean the backup api needs to take an mbname on open, and it handles
+the job of looking it up in the mailboxes database to find the appropriate
+thing to open?</p>
+<p>can we use sqlite for such a database, or is the load on it going to be too
+heavy?  locking?  we have lots of database formats up our sleeves here, so
+even though we use sqlite for the backup index there isn&#8217;t any particular
+reason we&#8217;re beholden to it for the mailboxes db too</p>
+<p>if we have a mailboxes db then we need a reconstruct tool for that, too</p>
+<p>what if we support multiple backup partitions, but don&#8217;t expect these
+to necessarily correspond with mailbox partitions.  they&#8217;re just for spreading
+disk usage around.</p>
+<ul class="simple">
+<li>when creating a backup for a previously-unseen user we&#8217;d pick a random
+partition to put them on</li>
+<li>ctl_backups would need a command to move an existing backup to a
+given partition</li>
+<li>ctl_backups would need a command to pre-create a user backup on a
+given partition for initial distribution</li>
+<li>instead of &#8220;backup_data_path&#8221; setting, have one-or-more
+&#8220;backuppartition-&lt;name&gt;&#8221; settings, ala partition- and friends</li>
+</ul>
+<p>see imap/partlist.[ch] for partition list management stuff.  it&#8217;s complicated
+and doesn&#8217;t have a test suite, so maybe save this implementation until needed.</p>
+<p>but... maybe rename backup_data_path to backuppartition-default in the meantime,
+so that when we do add this it&#8217;s not a complicated reconfig to update?</p>
+<p>partlist_local_select (and lazy-loaded partlist_local_init) are where the
+mailbox partitions come from (see also mboxlist_create_partition), do something
+similar for backup partitions</p>
+</div>
+<div class="section" id="data-corruption">
+<h2>data corruption<a class="headerlink" href="#data-corruption" title="Permalink to this headline">¶</a></h2>
+<dl class="docutils">
+<dt>backups.db:</dt>
+<dd><ul class="first last simple">
+<li>can be reconstructed from on disk files at any time</li>
+<li>how to detect corruption? does cyrus_db detect/repair on its own?</li>
+</ul>
+</dd>
+<dt>backup indexes:</dt>
+<dd><ul class="first last simple">
+<li>can be reindexed at any time from backup data</li>
+<li>how to detect corruption? assume sqlite will notice, complain?</li>
+</ul>
+</dd>
+<dt>backup data:</dt>
+<dd><ul class="first last simple">
+<li>what&#8217;s zlib&#8217;s failure mode? do we lose the entire chunk or just the corrupt bit?</li>
+<li>verify will notice sha1sum mismatches</li>
+<li>dlist format will reject some kinds of corruption (but not all)</li>
+<li>reindex: should skip unparseable dlist lines</li>
+<li>message data has its own checksums (guid)</li>
+<li>reindex: should skip messages that don&#8217;t match their own checksums</li>
+<li>compact: &#8220;full&#8221; compact will only keep useful data according to index</li>
+<li>backupd: will sync anything that&#8217;s in user mailbox but not in backup index</li>
+</ul>
+</dd>
+</dl>
+<p>i think this means that if a message or mailbox state becomes corrupted in
+the backup data file, and it still exists in the user&#8217;s real mailbox, you
+recover from the corruption by reindexing and then letting the sync process
+copy the missing data back in again.  and you can tidy up the data file by
+running a compact over it.</p>
+<p>you detect data corruption in most recent chunk reactively as soon as the
+backup system needs to open it again (quick verify on open)</p>
+<p>you detect data corruption in older chunks reactively by trying to restore from
+it.  may be too late: if a message needs restoring it&#8217;s because user mailbox no
+longer has it</p>
+<p>you detect data corruption preemptively by running the verify tool over it.
+recommend scheduling this in EVENTS/cron?</p>
+<p>if data corruption occurs in message that&#8217;s no longer in user&#8217;s mailbox, that
+message is lost.  it was going to be deleted from the backup after $retention
+period anyway (by compact), but if it needs restoring in the meantime, sorry</p>
+</div>
+<div class="section" id="installation-instructions">
+<h2>installation instructions<a class="headerlink" href="#installation-instructions" title="Permalink to this headline">¶</a></h2>
+<p>(obviously, most of this won&#8217;t work at this point, because the code doesn&#8217;t
+exist.  but this is, approximately, where things are heading.)</p>
+<dl class="docutils">
+<dt>on your backup server:</dt>
+<dd><ul class="first last simple">
+<li>compile with &#8211;enable-backup configure option and install</li>
+<li><dl class="first docutils">
+<dt>imapd.conf:</dt>
+<dd>backuppartition-default: /var/spool/backup  # FIXME better example
+backup_db: twoskip
+backup_db_path: /var/imap/backups.db
+backup_staging_path: /var/spool/backup
+backup_retention_days: 7</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt>cyrus.conf SERVICES:</dt>
+<dd>backupd cmd=&#8221;backupd&#8221; listen=&#8221;csync&#8221; prefork=0
+(remove other services, most likely)
+(should i create a master/conf/backup.conf example file?)</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt>cyrus.conf EVENTS:</dt>
+<dd>compact cmd=&#8221;ctl_backups compact -A&#8221; at=0400</dd>
+</dl>
+</li>
+<li>start server as usual</li>
+<li>do i want a special port for backupd?</li>
+</ul>
+</dd>
+<dt>on your imap server:</dt>
+<dd><ul class="first last simple">
+<li><dl class="first docutils">
+<dt>imapd.conf:</dt>
+<dd>sync_log_channels: backup
+sync_log: 1
+backup_sync_host: backup-server.example.com
+backup_sync_port: csync
+backup_sync_authname: ...
+backup_sync_password: ...
+backup_sync_repeat_interval: ... # seconds, smaller value = livelier backups but more i/o
+backup_sync_shutdown_file: ....</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt>cyrus.conf STARTUP:</dt>
+<dd>backup_sync cmd=&#8221;sync_client -r -n backup&#8221;</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt>cyrus.conf SERVICES:</dt>
+<dd>restored cmd=&#8221;restored&#8221; [...]</dd>
+</dl>
+</li>
+<li>start/restart master</li>
+</ul>
+</dd>
+<dt>files and such:</dt>
+<dd>{configdirectory}/backups.db                        - database mapping userids to backup locations
+{backuppartition-name}/&lt;hash&gt;/&lt;userid&gt;_XXXXXX       - backup data stream for userid
+{backuppartition-name}/&lt;hash&gt;/&lt;userid&gt;_XXXXXX.index - index into userid&#8217;s backup data stream</dd>
+<dt>do i want rhost in the path?</dt>
+<dd><ul class="first last simple">
+<li>protects from issue if multiple servers are trying to back up their own version of same user
+(though this is its own problem that the backup system shouldn&#8217;t have to compensate for)</li>
+<li>but makes location of undifferentiated user unpredictable</li>
+<li>so probably not, actually</li>
+</ul>
+</dd>
+</dl>
+</div>
+<div class="section" id="chatting-about-implementation-20-10">
+<h2>chatting about implementation 20/10<a class="headerlink" href="#chatting-about-implementation-20-10" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-default"><div class="highlight"><pre><span></span>09:54 @elliefm
+here&#39;s a fun sync question
+APPLY MESSAGE provides a list of messages
+can a single APPLY MESSAGE contain messages for multiple mailboxes and/or users?
+my first hunch is that it doesn&#39;t cross users, since the broadest granularity for a single sync run is USER
+10:06 kmurchison
+We&#39;d have to check with Bron, but I *think* messages can cross mailboxes for a single user
+10:06 @brong
+yes
+APPLY MESSAGE just adds it to the reserve list
+10:07 @elliefm
+nah apply message uploads the message, APPLY RESERVE adds it to the reserve list :P
+10:07 @brong
+same same
+APPLY RESERVE copies it from a local mailbox
+APPLY MESSAGE uploads it
+10:07 @elliefm
+yep
+10:07 @brong
+they both wind up in the reserve list
+10:07 @elliefm
+ahh i see what you mean, gotcha
+10:07 @brong
+until you send a RESTART
+ideally you want it reserve in the same partition, but it will copy the message over if it&#39;s not on the same partition
+there&#39;s no restriction on which mailbox it came from/went to
+good for user renames, and good for an append to a bunch of mailboxes in different users / shared space all at once
+(which LMTP can do)
+10:10 @elliefm
+i can handle the case where a single APPLY MESSAGE contains messages for multiple mailboxes belonging to the same user
+but i&#39;m in trouble if a single APPLY MESSAGE can contain messages belonging to different users
+10:14 @brong
+@elliefm: why?
+10:14 @brong
+you don&#39;t have to keep them if they aren&#39;t used
+10:15 @elliefm
+for backups - when i see the apply, i need to know which user&#39;s backup to add it to.  that&#39;s easy enough if it doesn&#39;t cross users but gets mega fiddly if it does
+i&#39;m poking around in sync client to see if it&#39;s likely to be an issue or not
+11:00 @brong_
+@elliefm: I would stage it, and add it to users as it gets refcounted in by an index file
+11:07 @elliefm
+that&#39;s pretty much what we do for ordinary sync and delivery stuff yeah?
+11:08 @brong_
+yep
+and it&#39;s what the backup thing does
+11:09 @elliefm
+i&#39;m pretty sure that APPLY RESERVE and APPLY MESSAGE don&#39;t give a damn about users, they&#39;re just &quot;here&#39;s every message you might not have already had since last time we spoke&quot; and it lets the APPLY MAILBOX work out where to attach them later
+11:09 @brong_
+yep
+11:09 @elliefm
+so yeah, i&#39;ll need to do something here
+i&#39;ve been working so far on the idea that a single user&#39;s backup consists of 1) an append-only gzip stream of the sync protocol chat that built it, and 2) an index that tracks current state of mailboxes, and offsets within (1) of message data
+that gets us good compression (file per user, not file per message), and if the index gets corrupted or lost, it&#39;s rebuildable purely from (1), it doesn&#39;t need a live copy of the original mailbox
+11:12 @brong
+yep, that all works
+11:12 @elliefm
+(so if you lose your imap server, you&#39;re not unable to rebuild a broken index on the backup)
+11:13 @brong
+it&#39;s easy enough to require the sync protocol stream to only contain messages per user
+though &quot;apply reserve&quot; is messy
+because you need to return &quot;yes, I have that message&quot;
+11:13 @elliefm
+with that implementation i can&#39;t (easily) keep user.a&#39;s messages from not existing in user.b&#39;s data stream (though they won&#39;t be indexed)
+11:14 @brong
+I&#39;m not too adverse to the idea of just unpacking each message as it comes off the wire into a temporary directory
+11:14 @elliefm
+(because at the time i&#39;m receiving the sync data i don&#39;t know which it needs to go in, so if they come in in the same reserve i&#39;d need to append them to both data streams)
+which isn&#39;t a huge problem, just… irks me a bit
+11:14 @brong
+and then reading the indexes as they come in, checking against the state DB to see if we already have them, and streaming them into the gzip if they aren&#39;t there yet
+what we can do is something like the current format, where files go into a tar
+11:16 @elliefm
+i guess the fiddly bit there is that there&#39;s one more moving part to keep synchronised across failure states
+a backup for a single user becomes 1) data stream + 2) any messages that were uploaded but not yet added to a mailbox + 3) index (which doesn&#39;t know what to do with (2))
+which in the general case is fine, the next sync will update the mailboxes, which will push (2) into (1) and index it nicely, and on we go
+but it&#39;s just a little bit more mess if there&#39;s a failure that you need to recover from between those states — it&#39;s no longer a simple case of &quot;it&#39;s in the backup and we know everything about it&quot; or &quot;it doesn&#39;t exist&quot;, there&#39;s a third case of &quot;well we might have the data but don&#39;t really know what to do with it&quot;
+the other fiddly bit is that the process of appending to the data stream is suddenly in the business of crafting output rather than simply dumping what it gets, which isn&#39;t really burdensome, but it is one more little crack for bugs to crawl into
+i guess in terms of sync protocol, one thing i could do on my end is identify apply operations that seem to contain multiple users&#39; data, and just return an error on those.  the sync client on the other end will promote them until they&#39;re eventually user syncs, which i think are always user granularity
+11:50 @elliefm
+i think for now, first stage implementation will be to stream the reserve/message commands in full to every user backup they might apply to.  and optimising that down so that each stream only contains messages belonging to that user can be a future optimisation
+</pre></div>
+</div>
+</div>
+<div class="section" id="todo-list">
+<h2>todo list<a class="headerlink" href="#todo-list" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>clean up error handling</li>
+<li>perl tool to anonymise sync proto talk</li>
+<li>verification step to check entire data stream for errors (even chunks that aren&#8217;t indexed)</li>
+<li>prot_fill_cb: extra argument to pass back an error string to prot_fill</li>
+<li>ctl_backups verify: set level</li>
+<li>backupd: don&#8217;t block on locked backups, return mailbox locked &#8211; but sync_client doesn&#8217;t handle this</li>
+<li>test multiple backup partitions</li>
+<li>configure: error if backups requested and we don&#8217;t have zlib</li>
+<li>valgrind</li>
+<li>finish reconstruct</li>
+<li>compact: split before append?</li>
+</ul>
+<dl class="docutils">
+<dt>compact implementation steps:</dt>
+<dd>1 remove unused chunks, keep everything else as is
+2 join adjacent chunks if small enough, split large chunks
+3 parse/rebuild message lines
+4 discard unused mailbox lines</dd>
+</dl>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="bytecode.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Sieve Bytecode" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../thoughts.html" class="btn btn-neutral" title="Developer Thoughts &amp; Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/bytecode.html 3.2.0-3/doc/html/imap/developer/thoughts/bytecode.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/bytecode.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/bytecode.html	2020-05-04 04:11:36.000000000 +0000
@@ -0,0 +1,981 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Sieve Bytecode &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Cyrus CalDAV Scheduling Flowchart" href="caldav_scheduling_flowchart.html"/>
+        <link rel="prev" title="Notes for backup implementation" href="backup.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Sieve Bytecode</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/bytecode.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-bytecode"></span><div class="section" id="cyrus-imap-server-sieve-bytecode">
+<h1>Cyrus IMAP Server: Sieve Bytecode<a class="headerlink" href="#cyrus-imap-server-sieve-bytecode" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="motivation">
+<h2>Motivation<a class="headerlink" href="#motivation" title="Permalink to this headline">¶</a></h2>
+<p>The motivation behind moving to Sieve Bytecode is severalfold:</p>
+<ul class="simple">
+<li>Parsing a script at each execution is expensive computationally</li>
+<li>Lex/Yacc are costly in terms of memory usage and executable size,
+whereas a bytecode parser is much lighter weight.</li>
+<li>Using bytecode can simplify the code for the execution phase, which
+is far more frequently occurring than the upload/compile phase.</li>
+<li>Rewriting a significant part of the sieve execution framework forces
+a decent amount of refactoring on what has traditionally been a
+problematic part of the Cyrus code base. There is still work to do in
+this area.</li>
+</ul>
+</div>
+<div class="section" id="overall-bytecode-format">
+<h2>Overall Bytecode Format<a class="headerlink" href="#overall-bytecode-format" title="Permalink to this headline">¶</a></h2>
+<p>In the final bytecode, each opcode/parameter is aligned on a 4-byte
+boundary. Strings are NUL-terminated (and padded to a 4-byte boundary as
+needed).</p>
+<p>Ideally, we&#8217;d have all integers in network byte order, so as to make the
+scripts portable, but version 1 does not have this feature.</p>
+<p>At the beginning of the file, there is a magic header to identify it as
+a bytecode file, and a 4 byte version number. Immediately following the
+version number are the opcodes that relate to the script.</p>
+</div>
+<div class="section" id="generation">
+<h2>Generation<a class="headerlink" href="#generation" title="Permalink to this headline">¶</a></h2>
+<p>A Sieve Bytecode file is generated in three &#8220;passes&#8221;:</p>
+<ul class="simple">
+<li>Generate a parse tree using lex/yacc from the sieve script. (addr.y,
+addr-lex.l, sieve.y, sieve-lex.l).</li>
+<li>Serialize the parse tree into an intermediate form, where strings are
+held separate from the rest of the representation. (bc_generate.c)</li>
+<li>Serialize the intermediate form into the final bytecode. (bc_emit.c)</li>
+</ul>
+<p>The intermediate form is an array of bytecode_t unions, with strings
+located elsewhere in memory. The entry point is bc_generate:
+sieve_generate_bytecode() / bc_action_generate().</p>
+<p>bc_action_generate traverses the commandlist_t tree and emits opcodes
+in sequence.</p>
+<p>Simple actions (STOP, DISCARD, KEEP, MARK, UNMARK) have no arguments,
+and processing proceeds directly.</p>
+<p>More complicated options have a sequence of arguments that are emitted
+following the initial opcode.</p>
+<p>For example, single argument commands such as REJECT, FILEINTO, REDIRECT
+are followed by a bytecode_t for a string&#8217;s length, and then a
+bytecode_t which contains a pointer to a string.</p>
+<p>Commands such as ADDFLAG, SETFLAG, REMOVEFLAG, which take a stringlist,
+format the stringlist as (using bc_stringlist_generate):</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">{</span><span class="n">Number</span> <span class="n">of</span> <span class="n">Strings</span><span class="p">}{</span><span class="n">String</span> <span class="mi">1</span> <span class="n">Length</span><span class="p">}{</span><span class="n">String</span> <span class="mi">1</span> <span class="n">Ptr</span><span class="p">}{</span><span class="n">String</span> <span class="mi">2</span> <span class="n">Length</span><span class="p">}</span><span class="o">....</span>
+</pre></div>
+</div>
+<p>So their resulting final output would appear as:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">{</span><span class="n">Opcode</span><span class="p">}{</span><span class="o">...</span><span class="n">stringlist</span> <span class="kn">from</span> <span class="nn">above...</span><span class="p">}</span>
+</pre></div>
+</div>
+<p>Even more complicated action opcodes (vacation, notify) etc, may take a
+sequence of integer values (flags), stringlists, or individual strings.
+These are more specifically documented in the code.</p>
+<p>This leaves us with the IF keyword (and tests). In the pass 1 form, IF
+appears as the following bytecode_t structures:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">{</span><span class="n">IF</span> <span class="n">opcode</span><span class="p">}</span>
+<span class="p">{</span><span class="n">Beginning</span> <span class="n">of</span> <span class="n">the</span> <span class="n">then</span> <span class="n">block</span><span class="p">}</span>
+<span class="p">{</span><span class="n">End</span> <span class="n">of</span> <span class="n">the</span> <span class="n">then</span> <span class="n">block</span> <span class="o">/</span> <span class="n">beginning</span> <span class="n">of</span> <span class="n">the</span> <span class="k">else</span> <span class="n">block</span><span class="p">}</span>
+<span class="p">{</span><span class="n">End</span> <span class="n">of</span> <span class="n">the</span> <span class="k">else</span> <span class="n">block</span> <span class="o">/</span> <span class="o">-</span><span class="mi">1</span> <span class="k">for</span> <span class="n">no</span> <span class="k">else</span> <span class="n">block</span><span class="p">}</span>
+<span class="p">{</span><span class="o">....</span><span class="n">test</span> <span class="n">opcodes</span><span class="o">....</span><span class="p">}</span>
+<span class="p">{</span><span class="o">....</span><span class="s1">&#39;then&#39;</span> <span class="n">action</span> <span class="n">opcodes</span><span class="o">....</span><span class="p">}</span>
+<span class="p">{</span><span class="o">....</span><span class="s1">&#39;else&#39;</span> <span class="n">action</span> <span class="n">opcodes</span><span class="o">....</span> <span class="p">[</span><span class="n">optional</span><span class="p">]}</span>
+</pre></div>
+</div>
+<p>Test opcodes are generated by the bc_test_generate function, which is
+very similar to bc_action_generate (tests without arguments are just
+opcodes, tests with arguments have them serialized into place directly
+following the original opcode). Test lists are represented as {number of
+tests}{address of the end of the list}{test 1}{test 2}.</p>
+<p>In the third pass, strings are serialized into place, and if statement
+jumps are resolved to actual addresses within the file This is done in
+bc_emit: sieve_emit_bytecode / bc_action_emit.</p>
+<p>This results in a totally serialized representation, using byte offsets
+within the file instead of indexes into the array of bytecode_t&#8217;s. In
+addition to the manipulations that are necessary to do this, there are
+several other changes in format.</p>
+<p>Two new opcodes exist: NULL and JUMP (which performs an unconditional
+jump).</p>
+<p>Stringlists and testslists now include a precomputed byte length of the
+entire list, so it can be skipped over as needed.</p>
+<p>So as to be executable without a stack, the IF statements are designed
+as follows:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">{</span><span class="n">IF</span> <span class="n">opcode</span><span class="p">}</span>
+<span class="p">{</span><span class="o">....</span><span class="n">test</span> <span class="n">block</span><span class="o">....</span><span class="p">}</span>
+<span class="p">{</span><span class="n">JUMP</span> <span class="p">(</span><span class="n">location</span> <span class="n">of</span> <span class="n">false</span> <span class="n">condition</span><span class="p">)</span> <span class="p">}</span>
+<span class="p">{</span><span class="o">....</span><span class="n">then</span> <span class="n">block</span><span class="o">....</span><span class="p">}</span>
+<span class="p">{(</span><span class="k">if</span> <span class="n">there</span> <span class="ow">is</span> <span class="n">an</span> <span class="k">else</span><span class="p">)</span> <span class="n">JUMP</span> <span class="p">(</span><span class="n">end</span> <span class="n">of</span> <span class="k">else</span> <span class="n">block</span><span class="p">)}</span>
+<span class="p">{(</span><span class="k">if</span> <span class="n">there</span> <span class="ow">is</span> <span class="n">an</span> <span class="k">else</span><span class="p">)</span> <span class="o">....</span> <span class="k">else</span> <span class="n">block</span> <span class="o">....</span><span class="p">}</span>
+</pre></div>
+</div>
+<p>The idea being that if the test is true, the instruction pointer should
+move to the then block, otherwise the else block will be hit
+automatically (due to the unconditional jump).</p>
+</div>
+<div class="section" id="evaluation">
+<h2>Evaluation<a class="headerlink" href="#evaluation" title="Permalink to this headline">¶</a></h2>
+<p>The evaluation routines are in bc_eval.c, the basic idea is that we can
+simply mmap the bytecode, run straight through it, and complete the
+processing without maintaining a stack.</p>
+<p>The processing is done by overlaying a bytecode_input_t array over the
+mmap. This allows addressing elements within the file to be simple.
+There is an instruction pointer which is incremented as each action is
+performed, or as actions/tests are skipped.</p>
+<p>Of special note in bc_eval.c is the unwrap_string function which will
+pull a string out of the bytecode, and return the instruction pointer at
+the end of the string.</p>
+</div>
+<div class="section" id="other-things-to-consider">
+<h2>Other things to consider<a class="headerlink" href="#other-things-to-consider" title="Permalink to this headline">¶</a></h2>
+<p>The Bytecode can be extended to contain other extensions. This could
+require regeneration of older scripts. In many cases this can be avoided
+by putting the new commands at the end of the proper enum in bytecode.h</p>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="caldav_scheduling_flowchart.html" class="btn btn-neutral float-right" title="Cyrus CalDAV Scheduling Flowchart" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="backup.html" class="btn btn-neutral" title="Notes for backup implementation" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/caldav_scheduling_flowchart.html 3.2.0-3/doc/html/imap/developer/thoughts/caldav_scheduling_flowchart.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/caldav_scheduling_flowchart.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/caldav_scheduling_flowchart.html	2020-05-04 04:11:37.000000000 +0000
@@ -0,0 +1,1196 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus CalDAV Scheduling Flowchart &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Enabling improved_mboxlist_sort" href="improved_mboxlist_sort.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Sieve Bytecode" href="bytecode.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Cyrus CalDAV Scheduling Flowchart</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/caldav_scheduling_flowchart.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-caldavflow"></span><div class="section" id="cyrus-caldav-scheduling-flowchart">
+<h1>Cyrus CalDAV Scheduling Flowchart<a class="headerlink" href="#cyrus-caldav-scheduling-flowchart" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="caldav-put-create-modify-via-http-put-on-a-resource-or-post-add-member-on-a-calendar">
+<h2>caldav_put() - create/modify via HTTP PUT on a resource or POST (add-member) on a calendar<a class="headerlink" href="#caldav-put-create-modify-via-http-put-on-a-resource-or-post-add-member-on-a-calendar" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Check if the new resource is a scheduling resource (contains
+ORGANIZER property). If not, skip to step 4.</li>
+<li>Check for (and load) any existing resource.</li>
+<li>Check if the authenticated user matches ORGANIZER:<ul>
+<li>If yes:<ul>
+<li>If only voter (VPOLL) responses changed, goto
+<a class="reference external" href="#sched_pollstatus">sched_pollstatus()</a>.</li>
+<li>Otherwise, goto <a class="reference external" href="#sched_request">sched_request()</a>.</li>
+</ul>
+</li>
+<li>Otherwise, goto <a class="reference external" href="#sched_reply">sched_reply()</a>.</li>
+</ul>
+</li>
+<li>Store the new/modified resource.</li>
+</ol>
+</div>
+<div class="section" id="caldav-delete-sched-remove-via-http-delete-on-a-resource">
+<h2>caldav_delete_sched() - remove via HTTP DELETE on a resource<a class="headerlink" href="#caldav-delete-sched-remove-via-http-delete-on-a-resource" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Check if the existing resource is a scheduling resource (has
+Schedule-Tag). If not, we are done.</li>
+<li>Load the existing resource.</li>
+<li>Check if the authenticated user matches ORGANIZER. If yes, goto
+<a class="reference external" href="#sched_request">sched_request()</a>, otherwise goto
+<a class="reference external" href="#sched_reply">sched_reply()</a>.</li>
+</ol>
+</div>
+<div class="section" id="caldav-post-busytime-query-via-http-post-on-scheduling-outbox">
+<h2>caldav_post() - busytime query via HTTP POST on Scheduling Outbox<a class="headerlink" href="#caldav-post-busytime-query-via-http-post-on-scheduling-outbox" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Check the ACL on the owner&#8217;s Scheduling Outbox. If the authenticated
+user doesn&#8217;t have the DACL_SCHEDFB right, fail.</li>
+<li><a class="reference external" href="#sched_busytime_query">sched_busytime_query()</a>.</li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="sched-pollstatus-perform-a-voter-response-update">
+<h2>sched_pollstatus - perform a voter response update<a class="headerlink" href="#sched-pollstatus-perform-a-voter-response-update" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li></li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="sched-request-perform-an-organizer-request-attendee-status-update">
+<h2>sched_request() - perform an organizer request / attendee status update<a class="headerlink" href="#sched-request-perform-an-organizer-request-attendee-status-update" title="Permalink to this headline">¶</a></h2>
+<p>Check the ACL on the owner&#8217;s Scheduling Outbox. If the authenticated
+user doesn&#8217;t have the DACL_INVITE right, fail.</p>
+<p>If the request includes a resource, then set METHOD:REQUEST, otherwise
+set METHOD:CANCEL.</p>
+<p>Create an iTIP message template, copying over any CALSCALE property and
+VTIMEZONE components.</p>
+<p>If not an attendee status update and the existing resource is a
+scheduling resource: Foreach component in the existing resource, add it
+and its SEQUENCE to our hash table keyed by RECURRENCE-ID (for
+comparison against new/modified resource).</p>
+<p>Create a hash table of attendees. This will hold attendee-specific iTIP
+messages.</p>
+<p>Foreach component in the new/modified resource:</p>
+<ol class="loweralpha simple">
+<li>Lookup (by RECURRENCE-ID) and remove the component from the hash
+table of existing components.</li>
+<li>If the component exists compare all of DTSTART, DTEND, DURATION,
+RRULE, RDATE, EXDATE to those of the new component.</li>
+<li>If the component is new or changed, then
+<a class="reference external" href="#process_attendees">process_attendees()</a>.</li>
+</ol>
+<p>Foreach remaining component in the hash table of existing components do
+<a class="reference external" href="#sched_cancel">sched_cancel()</a>.</p>
+<p>Foreach iTIP message in our hash table of ATTENDEES,
+<a class="reference external" href="#sched_deliver">sched_deliver()</a> the iTIP message.</p>
+<p>Foreach component in the new/modified resource update the
+SCHEDULE-STATUS of each ATTENDEE.</p>
+</div>
+<div class="section" id="process-attendees-create-a-suitable-itip-request-message-for-each-attendee">
+<h2>process_attendees() - create a suitable iTIP request message for each attendee<a class="headerlink" href="#process-attendees-create-a-suitable-itip-request-message-for-each-attendee" title="Permalink to this headline">¶</a></h2>
+<p>Foreach ATTENDEE in the component, remove the SCHEDULE-STATUS parameter,
+and set PROPSTAT=NEEDS-ACTION if required.</p>
+<p>Make a copy of the component and
+<a class="reference external" href="#clean_component">clean_component()</a>.</p>
+<p>Foreach ATTENDEE in the cleaned component:</p>
+<ol class="loweralpha simple">
+<li>Check the CalDAV Scheduling parameters. If SCHEDULE-AGENT != SERVER,
+skip to the next attendee.</li>
+<li>Lookup attendee in our hash table.</li>
+<li>If it doesn&#8217;t exist, create a clone of our iTIP template and insert
+it into our hash table of attendees.</li>
+<li>Add the component to the attendee&#8217;s iTIP message.</li>
+<li>Add the component “number” to our mask of new components appearing in
+the attendee&#8217;s iTIP message.</li>
+</ol>
+<p>If the component is not the &#8220;master&#8221;, foreach attendee do
+<a class="reference external" href="#sched_exclude">sched_exclude()</a>.</p>
+</div>
+<div class="section" id="sched-exclude-exclude-an-attendee-from-a-recurrence-instance">
+<h2>sched_exclude() - exclude an attendee from a recurrence instance<a class="headerlink" href="#sched-exclude-exclude-an-attendee-from-a-recurrence-instance" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>If the component did not appear in the attendee&#8217;s iTIP message, add
+an EXDATE property (based on the RECURRENCE-ID of the component) to
+the master component of the attendee&#8217;s iTIP message.</li>
+</ol>
+</div>
+<div class="section" id="sched-cancel-cancel-an-organizer-event-task">
+<h2>sched_cancel() - cancel an organizer event/task<a class="headerlink" href="#sched-cancel-cancel-an-organizer-event-task" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Set STATUS:CANCELLED on the component.</li>
+<li><a class="reference external" href="#process_attendees">process_attendees()</a>.</li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="sched-reply-perform-an-attendee-reply">
+<h2>sched_reply() - perform an attendee reply<a class="headerlink" href="#sched-reply-perform-an-attendee-reply" title="Permalink to this headline">¶</a></h2>
+<p>Check the CalDAV Scheduling parameters on ORGANIZER. If SCHEDULE-AGENT
+!= SERVER, we are done.</p>
+<p>Check the ACL on the owner&#8217;s Scheduling Outbox. If the authenticated
+user doesn&#8217;t have the DACL_REPLY right, fail.</p>
+<p>Create a new iTIP (METHOD:REPLY) message, copying over any CALSCALE
+property and VTIMEZONE components.</p>
+<p>Foreach component in the existing resource:</p>
+<ol class="loweralpha simple">
+<li><a class="reference external" href="#trim_attendees">trim_attendees()</a>.</li>
+<li>Add the trimmed component and the attendee&#8217;s PARTSTAT to our hash
+table keyed by RECURRENCE-ID (for comparison against new/modified
+resource).</li>
+</ol>
+<p>Foreach component in the new/modified resource:</p>
+<p><a class="reference external" href="#trim_attendees">trim_attendees()</a>.</p>
+<p>Lookup (by RECURRENCE-ID) and remove the component from the hash table
+of existing components.</p>
+<p>If the component exists:</p>
+<ol class="lowerroman simple">
+<li>If component is VPOLL, add voter responses to REPLY via
+<a class="reference external" href="#sched_vpoll_reply">sched_vpoll_reply().</a></li>
+<li>Otherwise, compare the PARTSTAT of the ATTENDEE to that of the new
+component.</li>
+</ol>
+<p>If the component is new or the PARTSTAT has changed:</p>
+<ol class="lowerroman simple">
+<li><a class="reference external" href="#clean_component">clean_component()</a>.</li>
+<li>Add the component to our iTIP message.</li>
+<li>Add the component “number” to our mask of new components appearing
+in our iTIP message.</li>
+</ol>
+<p>Foreach remaining component in the hash table of existing components do
+<a class="reference external" href="#sched_decline">sched_decline()</a>.</p>
+<p><a class="reference external" href="#sched_deliver">sched_deliver()</a> our iTIP message.</p>
+<p>Foreach component in the new/modified resource that appeared in our iTIP
+message, update the SCHEDULE-STATUS of the ORGANIZER.</p>
+</div>
+<div class="section" id="trim-attendees-remove-all-attendees-other-than-the-one-replying">
+<h2>trim_attendees() - remove all attendees other than the one replying<a class="headerlink" href="#trim-attendees-remove-all-attendees-other-than-the-one-replying" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Clone the component and remove all ATTENDEE properties other than the
+one corresponding to the owner of the calendar.</li>
+<li>Return the ATTENDEE property of owner, his/her PARTSTAT parameter,
+and the RECURRENCE-ID of the component.</li>
+</ol>
+</div>
+<div class="section" id="sched-vpoll-reply-add-voter-responses-to-vpoll-reply">
+<h2>sched_vpoll_reply() - add voter responses to VPOLL reply<a class="headerlink" href="#sched-vpoll-reply-add-voter-responses-to-vpoll-reply" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li></li>
+</ol>
+</div>
+<div class="section" id="sched-decline-decline-a-recurrence-instance-for-an-attendee">
+<h2>sched_decline() - decline a recurrence instance for an attendee<a class="headerlink" href="#sched-decline-decline-a-recurrence-instance-for-an-attendee" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Set PARTSTAT of ATTENDEE to DECLINED.</li>
+<li><a class="reference external" href="#clean_component">clean_component()</a>.</li>
+<li>Add the component to our iTIP message.</li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="clean-component-sanitize-a-component-for-use-in-an-itip-message">
+<h2>clean_component() - sanitize a component for use in an iTIP message<a class="headerlink" href="#clean-component-sanitize-a-component-for-use-in-an-itip-message" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Update DTSTAMP.</li>
+<li>Remove any VALARM components.</li>
+<li>For a reply/decline only, remove scheduling parameters from
+ORGANIZER.</li>
+</ol>
+</div>
+<div class="section" id="sched-deliver-deliver-an-itip-message-to-a-recipient">
+<h2>sched_deliver() - deliver an iTIP message to a recipient<a class="headerlink" href="#sched-deliver-deliver-an-itip-message-to-a-recipient" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Lookup the recipient.</li>
+<li>If local to our server goto
+<a class="reference external" href="#sched_deliver_local">sched_deliver_local()</a>, otherwise goto
+<a class="reference external" href="#sched_deliver_remote">sched_deliver_remote()</a>.</li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="sched-deliver-local-deliver-an-itip-message-to-a-local-user">
+<h2>sched_deliver_local() - deliver an iTIP message to a local user<a class="headerlink" href="#sched-deliver-local-deliver-an-itip-message-to-a-local-user" title="Permalink to this headline">¶</a></h2>
+<p>Check the ACL on the owner&#8217;s Scheduling Inbox. If the sender doesn&#8217;t
+have the proper right (DACL_INVITE for request/cancel, DACL_REPLY for
+reply), fail.</p>
+<p>Search the recipient&#8217;s calendars for a resource having the specified
+UID.</p>
+<p>If the resource doesn&#8217;t exist:</p>
+<ol class="loweralpha simple">
+<li>If the iTIP method is REPLY, fail (we are done).</li>
+<li>If the iTIP method is CANCEL, ignore it (we are done).</li>
+<li>Otherwise, create a new (empty) attendee object and target the
+recipient&#8217;s Default calendar.</li>
+</ol>
+<p>Otherwise, load the existing resource.</p>
+<p>Update the new/existing resource:</p>
+<ol class="loweralpha simple">
+<li>If the iTIP method is CANCEL, set STATUS:CANCELLED on all existing
+components.</li>
+<li>If the iTIP method is REPLY, do
+<a class="reference external" href="#deliver_merge_reply">deliver_merge_reply()</a>.</li>
+<li>If the iTIP method is REQUEST, do
+<a class="reference external" href="#deliver_merge_request">deliver_merge_request()</a>.</li>
+<li>If the iTIP method is POLLSTATUS, do
+<a class="reference external" href="#deliver_merge_pollstatus">deliver_merge_pollstatus()</a>.</li>
+</ol>
+<p>Store the new/updated resource in the recipient&#8217;s target calendar.</p>
+<p>Record the delivery status (SCHEDULE-STATUS).</p>
+<p>If the iTIP message is something other than just a PARTSTAT update from
+an attendee, store the iTIP message as a new resource in the recipient&#8217;s
+Inbox.</p>
+<p>If the iTIP method is REPLY, send an update other attendees via
+<a class="reference external" href="#sched_pollstatus">sched_pollstatus()</a> (VPOLL only) or
+<a class="reference external" href="#sched_request">sched_request()</a>.</p>
+</div>
+<div class="section" id="deliver-merge-reply-update-an-organizer-resource-with-an-attendee-reply">
+<h2>deliver_merge_reply() - update an organizer resource with an attendee reply<a class="headerlink" href="#deliver-merge-reply-update-an-organizer-resource-with-an-attendee-reply" title="Permalink to this headline">¶</a></h2>
+<p>Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).</p>
+<p>Foreach component in the iTIP message:</p>
+<p>Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.</p>
+<p>If the component doesn&#8217;t exist (new recurrence overridden by ATTENDEE)
+create a new recurring component:</p>
+<ol class="lowerroman simple">
+<li>Clone the existing master component.</li>
+<li>Remove the RRULE property.</li>
+<li>Add the RECURRENCE-ID from the iTIP message.</li>
+<li>Replace the DTSTART, DTEND, SEQUENCE properties with those from the
+iTIP message.</li>
+<li>Add the new component to our existing resource.</li>
+</ol>
+<p>Get the sending ATTENDEE from the iTIP message.</p>
+<p>Find the matching ATTENDEE in the existing component.</p>
+<p>If not found (ATTENDEE added themselves to this recurrence), add new
+ATTENDEE to the component.</p>
+<p>Set the ATTENDEE PARTSTAT, RSVP, and SCHEDULE-STATUS parameters in the
+existing component.</p>
+<p>If the component is VPOLL, update the voter responses in the existing
+component via
+<a class="reference external" href="#deliver_merge_vpoll_reply">deliver_merge_vpoll_reply()</a>.</p>
+<p>Return the sending ATTENDEE.</p>
+</div>
+<div class="section" id="deliver-merge-vpoll-reply-update-an-organizer-resource-with-voter-responses">
+<h2>deliver_merge_vpoll_reply() - update an organizer resource with voter responses<a class="headerlink" href="#deliver-merge-vpoll-reply-update-an-organizer-resource-with-voter-responses" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>Foreach sub-component in the existing resource, replace any voter
+response(s) with those from the reply.</li>
+</ol>
+</div>
+<div class="section" id="deliver-merge-request-create-update-an-attendee-resource-with-an-organizer-request">
+<h2>deliver_merge_request() - create/update an attendee resource with an organizer request<a class="headerlink" href="#deliver-merge-request-create-update-an-attendee-resource-with-an-organizer-request" title="Permalink to this headline">¶</a></h2>
+<p>Foreach VTIMEZONE component in the existing resource, add it to our hash
+table keyed by TZID (for comparison against iTIP message).</p>
+<p>Foreach VTIMEZONE component in the iTIP message:</p>
+<ol class="loweralpha simple">
+<li>Lookup (by TZID) the VTIMEZONE component from the hash table of
+existing components.</li>
+<li>If the component exists, remove it from the existing object.</li>
+<li>Add the VTIMEZONE from the iTIP message to our existing object.</li>
+</ol>
+<p>Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).</p>
+<p>Foreach component in the iTIP message:</p>
+<p>Clone a new component from the iTIP component.</p>
+<p>Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.</p>
+<p>If the component exists:</p>
+<ol class="lowerroman simple">
+<li>Compare the SEQUENCE of the new component to the existing component
+to see if it has changed.</li>
+<li>Copy any COMPLETED, PERCENT-COMPLETE, or TRANSP properties from the
+existing component to the new component.</li>
+<li>Copy any ORGANIZER SCHEDULE-STATUS parameter from the existing
+component to the new component.</li>
+<li>Remove the existing component from the existing object.</li>
+</ol>
+<p>Add the new component to the existing object.</p>
+</div>
+<div class="section" id="deliver-merge-pollstatus-update-voter-responses-on-a-voter-resource">
+<h2>deliver_merge_pollstatus() - update voter responses on a voter resource<a class="headerlink" href="#deliver-merge-pollstatus-update-voter-responses-on-a-voter-resource" title="Permalink to this headline">¶</a></h2>
+<p>Foreach sub-component in the existing resource, add it to our hash table
+keyed by POLL-ITEM-ID (for comparison against iTIP message). The
+sub-component entry includes a hash table of VOTERs.</p>
+<p>Foreach sub-component in the iTIP message:</p>
+<ol class="loweralpha simple">
+<li>Lookup (by POLL-ITEM-ID) the sub-component from the hash table of
+existing sub-components.</li>
+<li>If the component exists, foreach VOTER in the sub-component in the
+iTIP message:<ol class="lowerroman">
+<li>Lookup VOTER in the hash table of existing sub-component.</li>
+<li>Add/update VOTER response.</li>
+</ol>
+</li>
+</ol>
+</div>
+<hr class="docutils" />
+<div class="section" id="sched-deliver-remote-deliver-an-itip-message-to-a-remote-user">
+<h2>sched_deliver_remote() - deliver an iTIP message to a remote user<a class="headerlink" href="#sched-deliver-remote-deliver-an-itip-message-to-a-remote-user" title="Permalink to this headline">¶</a></h2>
+<ol class="arabic simple">
+<li>If the recipient is local to our Murder, goto
+<a class="reference external" href="#isched_send">isched_send()</a>, otherwise goto
+<a class="reference external" href="#imip_send">imip_send()</a>.</li>
+<li>Retrieve status of iTIP message delivery.</li>
+</ol>
+</div>
+<div class="section" id="isched-send-deliver-an-itip-message-to-a-remote-user-via-ischedule-http">
+<h2>isched_send() - deliver an iTIP message to a remote user via iSchedule (HTTP)<a class="headerlink" href="#isched-send-deliver-an-itip-message-to-a-remote-user-via-ischedule-http" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="imip-send-deliver-an-itip-message-to-a-remote-user-via-imip-smtp">
+<h2>imip_send() - deliver an iTIP message to a remote user via iMIP (SMTP)<a class="headerlink" href="#imip-send-deliver-an-itip-message-to-a-remote-user-via-imip-smtp" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="sched-busytime-query-perform-a-busytime-query">
+<h2>sched_busytime_query() - perform a busytime query<a class="headerlink" href="#sched-busytime-query-perform-a-busytime-query" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="busytime-query-local-perform-a-busytime-query-on-a-local-user">
+<h2>busytime_query_local() - perform a busytime query on a local user<a class="headerlink" href="#busytime-query-local-perform-a-busytime-query-on-a-local-user" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="busytime-query-remote-perform-a-busytime-query-on-a-remote-user">
+<h2>busytime_query_remote() - perform a busytime query on a remote user<a class="headerlink" href="#busytime-query-remote-perform-a-busytime-query-on-a-remote-user" title="Permalink to this headline">¶</a></h2>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="improved_mboxlist_sort.html" class="btn btn-neutral float-right" title="Enabling improved_mboxlist_sort" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="bytecode.html" class="btn btn-neutral" title="Cyrus IMAP Server: Sieve Bytecode" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/improved_mboxlist_sort.html 3.2.0-3/doc/html/imap/developer/thoughts/improved_mboxlist_sort.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/improved_mboxlist_sort.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/improved_mboxlist_sort.html	2020-05-04 04:11:37.000000000 +0000
@@ -0,0 +1,879 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Enabling improved_mboxlist_sort &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Notes" href="notes.html"/>
+        <link rel="prev" title="Cyrus CalDAV Scheduling Flowchart" href="caldav_scheduling_flowchart.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Enabling improved_mboxlist_sort</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/improved_mboxlist_sort.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-improved-mboxlist-sort"></span><div class="section" id="enabling-improved-mboxlist-sort">
+<h1>Enabling improved_mboxlist_sort<a class="headerlink" href="#enabling-improved-mboxlist-sort" title="Permalink to this headline">¶</a></h1>
+<p>You can&#8217;t enable and disable <code class="docutils literal"><span class="pre">improved_mboxlist_sort</span></code> on a live
+system. You need to dump and load the necessary database after stopping
+and before starting the master process.</p>
+<p>Dumping the mailboxes.db file</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">ctl_mboxlist</span> <span class="o">-</span><span class="n">d</span> <span class="o">&gt;</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">tmp</span><span class="o">/</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">txt</span>
+<span class="n">ctl_mboxlist</span> <span class="o">-</span><span class="n">u</span> <span class="o">&lt;</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">tmp</span><span class="o">/</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">txt</span>
+</pre></div>
+</div>
+<p>If your subscription databases are not in flat files you need to do
+something similar. Each user will have his own subscription file. Do the
+following for each subscription file.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>cyr_dbtool -C $file skiplist show &gt; $file.TXT
+cyr_dbtool -n $file skiplist set &lt; $file.TXT
+</pre></div>
+</div>
+<p>The above fragments will overwrite the original file. So you could
+redirect to a temporary file and overwrite the database if the import
+succeeds.</p>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="notes.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="caldav_scheduling_flowchart.html" class="btn btn-neutral" title="Cyrus CalDAV Scheduling Flowchart" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/notes.html 3.2.0-3/doc/html/imap/developer/thoughts/notes.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/notes.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/notes.html	2020-05-04 04:11:37.000000000 +0000
@@ -0,0 +1,874 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Cyrus IMAP Server: Prot Events" href="prot-events.html"/>
+        <link rel="prev" title="Enabling improved_mboxlist_sort" href="improved_mboxlist_sort.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/notes.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-notes"></span><div class="section" id="cyrus-imap-server-notes">
+<h1>Cyrus IMAP Server: Notes<a class="headerlink" href="#cyrus-imap-server-notes" title="Permalink to this headline">¶</a></h1>
+<ul class="simple">
+<li>appending: it&#8217;s important that the index records for individual
+messages make it to disk before the index header indicating that
+they&#8217;re there. so something like:<ol class="arabic">
+<li>sync messages to disk (or depend on <code class="docutils literal"><span class="pre">link()</span></code> being atomic)</li>
+<li>create new index records, flush to disk</li>
+<li>create new header if necessary (adding new user flag), flush to
+disk</li>
+<li>flush cache file</li>
+<li>update index header, flush to disk</li>
+</ol>
+</li>
+</ul>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="prot-events.html" class="btn btn-neutral float-right" title="Cyrus IMAP Server: Prot Events" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="improved_mboxlist_sort.html" class="btn btn-neutral" title="Enabling improved_mboxlist_sort" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts/prot-events.html 3.2.0-3/doc/html/imap/developer/thoughts/prot-events.html
--- 3.0.13-5/doc/html/imap/developer/thoughts/prot-events.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts/prot-events.html	2020-05-04 04:11:38.000000000 +0000
@@ -0,0 +1,906 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP Server: Prot Events &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Developer Thoughts &amp; Notes" href="../thoughts.html"/>
+        <link rel="next" title="Developer Guidance" href="../guidance.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: Notes" href="notes.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../thoughts.html">Thoughts &amp; Notes</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../developers.html">Developers</a> &raquo;</li>
+      
+          <li><a href="../thoughts.html">Developer Thoughts &amp; Notes</a> &raquo;</li>
+      
+    <li>Cyrus IMAP Server: Prot Events</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts/prot-events.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts-prot-events"></span><div class="section" id="cyrus-imap-server-prot-events">
+<h1>Cyrus IMAP Server: Prot Events<a class="headerlink" href="#cyrus-imap-server-prot-events" title="Permalink to this headline">¶</a></h1>
+<p>From an email exchange between Ken Murchison and Lawrence Greenfield,
+dated 03 Feb 2002 (slightly redacted and formatted for your viewing
+pleasure):</p>
+<div class="line-block">
+<div class="line">From: Ken Murchison</div>
+<div class="line">To: Lawrence Greenfield</div>
+<div class="line">Subject: Re: prot events</div>
+<div class="line"><br /></div>
+</div>
+<blockquote>
+<div><p>Lawrence Greenfield wrote:</p>
+<blockquote>
+<div>Can you give me some details on how the event API in the prot
+layer works?  I&#8217;m a little unclear about the memory management,
+what should be returned from the event callback,</div></blockquote>
+<p>Either the event pointer (if the event is still active), or NULL
+(if the event has been removed by the callback).</p>
+<blockquote>
+<div>and how to reschedule an event.</div></blockquote>
+<p>Simply set the &#8216;mark&#8217; time in the event to the wall time you want
+it to run again.</p>
+<blockquote>
+<div>(I&#8217;d like to make an event called every X seconds of idle time;
+I know the API can&#8217;t do exactly that but I suspect I can fake
+it well enough.)</div></blockquote>
+<p>Look at backend_timeout() in proxyd.c and/or drac_ping() in
+contrib/drac_auth.patch, they do exactly this.</p>
+<p>The API is pretty simple:</p>
+<ul class="simple">
+<li>use prot_addwaitevent() to add an event (linked list) callback
+onto a stream.  takes the stream, the &#8216;mark&#8217; time at which to
+run the event (NOT an interval, but the future clock value),
+the function pointer, and a rock to pass to the callback as
+args, and returns a pointer to the event (to use for future
+removal).</li>
+<li>use prot_removewaitevent() to remove an event.  takes the
+stream and a pointer to the event as args.</li>
+<li>the event callback gets the stream, a pointer to the event
+and the rock as args.  To reschedule an event, simply set the
+&#8216;mark&#8217; time and return the event pointer.  If the callback
+removes the event, then return NULL.</li>
+</ul>
+<p>If you see and flaws in this API, feel free to go ahead and change it.</p>
+<p>Ken</p>
+</div></blockquote>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../guidance.html" class="btn btn-neutral float-right" title="Developer Guidance" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="notes.html" class="btn btn-neutral" title="Cyrus IMAP Server: Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/thoughts.html 3.2.0-3/doc/html/imap/developer/thoughts.html
--- 3.0.13-5/doc/html/imap/developer/thoughts.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/thoughts.html	2020-05-04 04:11:35.000000000 +0000
@@ -0,0 +1,869 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Developer Thoughts &amp; Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../genindex.html"/>
+        <link rel="search" title="Search" href="../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
+        <link rel="up" title="Developers" href="../../developers.html"/>
+        <link rel="next" title="Notes for backup implementation" href="thoughts/backup.html"/>
+        <link rel="prev" title="Mailbox API" href="API/mailbox-api.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../index.html">Home</a></li>
+    <li><a href="../../download.html">Download</a></li>
+    <li><a href="../../contribute.html">Contribute</a></li>
+    <li><a href="../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../index.html">
+      <img src="../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../index.html">
+ 
+
+  
+          
+          <img src="../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="current reference internal" href="#">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../developers.html">Developers</a> &raquo;</li>
+      
+    <li>Developer Thoughts &amp; Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/thoughts.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-thoughts"></span><div class="section" id="developer-thoughts-notes">
+<h1>Developer Thoughts &amp; Notes<a class="headerlink" href="#developer-thoughts-notes" title="Permalink to this headline">¶</a></h1>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="thoughts/backup.html" class="btn btn-neutral float-right" title="Notes for backup implementation" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="API/mailbox-api.html" class="btn btn-neutral" title="Mailbox API" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer/unit-tests.html 3.2.0-3/doc/html/imap/developer/unit-tests.html
--- 3.0.13-5/doc/html/imap/developer/unit-tests.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer/unit-tests.html	2020-05-04 04:11:38.000000000 +0000
@@ -0,0 +1,1402 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Unit Tests &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../genindex.html"/>
+        <link rel="search" title="Search" href="../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
+        <link rel="up" title="Developers" href="../../developers.html"/>
+        <link rel="next" title="Support/Community" href="../../support.html"/>
+        <link rel="prev" title="Cyrus IMAP Server: var directory structure" href="guidance/var_directory_structure.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../index.html">Home</a></li>
+    <li><a href="../../download.html">Download</a></li>
+    <li><a href="../../contribute.html">Contribute</a></li>
+    <li><a href="../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../index.html">
+      <img src="../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../index.html">
+ 
+
+  
+          
+          <img src="../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul class="current">
+<li class="toctree-l3 current"><a class="current reference internal" href="#">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../developers.html">Developers</a> &raquo;</li>
+      
+    <li>Unit Tests</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer/unit-tests.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <span class="target" id="imap-developer-unit-tests"></span><div class="section" id="unit-tests">
+<h1>Unit Tests<a class="headerlink" href="#unit-tests" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="table-of-contents">
+<h2>Table of Contents<a class="headerlink" href="#table-of-contents" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li><a class="reference external" href="#introduction">1. Introduction</a></li>
+<li><a class="reference external" href="#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li><a class="reference external" href="#running-the-tests">3. Running The Tests</a><ul>
+<li><a class="reference external" href="#setting-up-the-machine">3.1. Setting Up The Machine</a></li>
+<li><a class="reference external" href="#configure-scripts">3.2 Configure Script</a></li>
+<li><a class="reference external" href="#running-the-tests">3.3 Make</a></li>
+<li><a class="reference external" href="#using-valgrind">3.4 Using Valgrind</a></li>
+<li><a class="reference external" href="#the-tests-are-failing">3.5 The Tests Are Failing</a></li>
+<li><a class="reference external" href="#debugging-a-test">3.6 Debugging A Test</a></li>
+</ul>
+</li>
+<li><a class="reference external" href="#adding-your-own-tests">4. Adding Your Own Tests</a><ul>
+<li><a class="reference external" href="#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li><a class="reference external" href="#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li><a class="reference external" href="#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li><a class="reference external" href="#suite-init-and-cleanup">4.3 Suite Init And Cleanup</a></li>
+</ul>
+</li>
+</ul>
+</div>
+<div class="section" id="introduction">
+<h2>1. Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
+<p>Recently, a set of regression unit tests has been added to Cyrus. This
+document explains the purpose implementation of those unit tests, and
+gives an example of how to add more unit tests (because there are never
+enough unit tests!).</p>
+</div>
+<div class="section" id="what-is-a-unit-test">
+<h2>2. What Is A Unit Test?<a class="headerlink" href="#what-is-a-unit-test" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference external" href="http://en.wikipedia.org/wiki/Unit_test">definition on Wikipedia</a>
+sheds some light:</p>
+<blockquote>
+<div>...<strong>unit testing</strong> is a method by which individual units of
+source code are tested to determine if they are fit for use. A unit
+is the smallest testable part of an application.</div></blockquote>
+<p>In other words, unit testing is about verifying that small pieces of
+code, like individual functions, modules, or classes, work in isolation.
+It is <strong>not</strong> about testing the system as a whole.</p>
+<p>The tests implemented here are also <strong>regression tests</strong>, which in
+<a class="reference external" href="http://en.wikipedia.org/wiki/Regression_testing">Wikipedia&#8217;s words</a>
+means:</p>
+<blockquote>
+<div><strong>Regression testing</strong> is any type of software testing that seeks to
+uncover software errors after changes to the program (e.g. bugfixes
+or new functionality) have been made, by retesting the program. The
+intent of regression testing is to assure that a change, such as a
+bugfix, did not introduce new bugs.</div></blockquote>
+<p>In other words, the tests are designed to be easy to run and to work out
+fully automatically whether they have passed or failed, so that they can
+be run usefully by people who didn&#8217;t write them.</p>
+</div>
+<div class="section" id="running-the-tests">
+<h2>3. Running The Tests<a class="headerlink" href="#running-the-tests" title="Permalink to this headline">¶</a></h2>
+<p>This section takes you through the process of running Cyrus&#8217; unit tests.</p>
+<div class="section" id="setting-up-the-machine">
+<h3>3.1. Setting Up The Machine<a class="headerlink" href="#setting-up-the-machine" title="Permalink to this headline">¶</a></h3>
+<p>Cyrus&#8217; unit tests are all located in a new directory,
+<code class="docutils literal"><span class="pre">cyrus-imapd/cunit/</span></code>. They&#8217;re written in C, like the remainder of
+Cyrus, and use the <a class="reference external" href="http://cunit.sourceforge.net/">CUnit library from
+SourceForge</a>, with some home grown
+wrappers and other improvements to make our lives easier.</p>
+<p>Your first step is step is to ensure that the CUnit library (including
+the headers) is installed. Some modern operating systems already have
+CUnit, for example on Ubuntu you can just do:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@ubuntu</span><span class="o">&gt;</span> <span class="n">sudo</span> <span class="n">apt</span><span class="o">-</span><span class="n">get</span> <span class="n">install</span> <span class="n">libcunit1</span><span class="o">-</span><span class="n">dev</span>
+</pre></div>
+</div>
+<p>Alternately, you can download the CUnit source, build it and install it.
+It&#8217;s not a complicated or difficult library, this shouldn&#8217;t take long.
+When you&#8217;ve done, install it in <code class="docutils literal"><span class="pre">/usr/include</span></code> and <code class="docutils literal"><span class="pre">/usr/lib</span></code>.</p>
+</div>
+<div class="section" id="configure-script">
+<h3>3.2 Configure Script<a class="headerlink" href="#configure-script" title="Permalink to this headline">¶</a></h3>
+<p>Because of the dependency on the CUnit library, the tests are disabled
+by default; this means you need enable them with an option to the
+<code class="docutils literal"><span class="pre">configure</span></code> script:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="o">./</span><span class="n">configure</span> <span class="o">--</span><span class="n">enable</span><span class="o">-</span><span class="n">unit</span><span class="o">-</span><span class="n">tests</span>
+<span class="o">...</span>
+<span class="n">checking</span> <span class="k">for</span> <span class="n">CU</span>\<span class="n">_initialize</span>\<span class="n">_registry</span> <span class="ow">in</span> <span class="o">-</span><span class="n">lcunit</span><span class="o">...</span> <span class="n">yes</span>
+<span class="n">checking</span> <span class="n">CUnit</span><span class="o">/</span><span class="n">CUnit</span><span class="o">.</span><span class="n">h</span> <span class="n">usability</span><span class="o">...</span> <span class="n">yes</span>
+<span class="n">checking</span> <span class="n">CUnit</span><span class="o">/</span><span class="n">CUnit</span><span class="o">.</span><span class="n">h</span> <span class="n">presence</span><span class="o">...</span> <span class="n">yes</span>
+<span class="n">checking</span> <span class="k">for</span> <span class="n">CUnit</span><span class="o">/</span><span class="n">CUnit</span><span class="o">.</span><span class="n">h</span><span class="o">...</span> <span class="n">yes</span>
+<span class="o">...</span>
+</pre></div>
+</div>
+</div>
+<div class="section" id="make">
+<h3>3.3 Make<a class="headerlink" href="#make" title="Permalink to this headline">¶</a></h3>
+<p>First you need to build Cyrus itself, using the traditional <code class="docutils literal"><span class="pre">all:</span></code>
+target.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">make</span> <span class="nb">all</span>
+<span class="o">...</span>
+</pre></div>
+</div>
+<p>Then, use the new <code class="docutils literal"><span class="pre">check:</span></code> target to build and run the unit tests.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>me@mybox&gt; make check
+ cd . &amp;&amp; /bin/bash /home/me/cyrus-imapd/missing --run automake-1.11 --foreign Makefile
+ cd . &amp;&amp; /bin/bash ./config.status Makefile depfiles (a)
+config.status: creating Makefile
+config.status: executing depfiles commands
+...
+make[3]: Entering directory \`/home/me/cyrus-imapd&#39;
+make[3]: \`sieve/test&#39; is up to date.
+cunit/cunit.pl --project cunit/default.cunit --generate-wrapper cunit/mboxname.testc (b)
+gcc -DHAVE\_CONFIG\_H ... -c -o cunit/mboxname.o cunit/mboxname.testc-cunit.c
+rm -f cunit/mboxname.testc-cunit.c
+/bin/bash ./libtool --tag=CC --mode=link gcc -fPIC -g -O2 -o
+cunit/unit cunit/unit.o ... lib/libcyrus\_min.la ... (c)
+...
+Running unit tests (d)
+
+    CUnit - A Unit testing framework for C - Version 2.1-0
+    http://cunit.sourceforge.net/
+
+...
+Suite: mboxname (e)
+  Test: dir\_hash\_c ... passed
+  Test: to\_parts ... passed
+  Test: to\_userid ... passed
+  Test: to\_usermbox ... passed
+...
+--Run Summary: Type      Total     Ran  Passed  Failed (f)
+               suites       34      34     n/a       0
+               tests       323     323     323       0
+               asserts 1079745 1079745 1079745       0
+make[1]: Leaving directory `/home/me/cyrus-imapd/cunit&#39;
+</pre></div>
+</div>
+<p>Let&#8217;s take a closer look at what&#8217;s happening here.</p>
+<ol class="loweralpha simple">
+<li>The <code class="docutils literal"><span class="pre">check:</span></code> target causes automake to re-run itself. This is
+normal automake behaviour. Note that the older build system used to
+run make recursively in sub-directories, the newer automake-based
+system builds everything from the top directory.</li>
+<li>The <code class="docutils literal"><span class="pre">cunit/</span></code> directory contains a number of C source files
+(called, for reasons too complicated to explain here,
+<em>whatever</em>.testc) with test code in them. For each of those, a small
+wrapper C source file is generated and then compiled into an object
+file.</li>
+<li>Finally, all the compiled object files are linked into an
+executable, with a <code class="docutils literal"><span class="pre">main()</span></code> routine from <code class="docutils literal"><span class="pre">unit.c</span></code>, and a number
+of libraries and object files from other parts of the Cyrus tree.</li>
+<li>The resulting executable is then run.</li>
+<li>The test executable runs all the built tests one by one, telling us
+which ones passed and which ones failed as it runs them. You can
+also run it manually with the name of a test as an argument, and it
+will run only the named test.</li>
+<li>At the end, the text executable prints a summary of how many tests
+it ran and how many passed and failed. The key thing to look at here
+is the rightmost column, it should be all zero.</li>
+</ol>
+</div>
+<div class="section" id="using-valgrind">
+<h3>3.4 Using Valgrind<a class="headerlink" href="#using-valgrind" title="Permalink to this headline">¶</a></h3>
+<p>Some failure modes are subtle, and cannot be detected in the C code
+itself; this is where <a class="reference external" href="http://valgrind.org/">the Valgrind program</a>
+comes in very handy. It detects buffer overruns and memory leaks and
+various other kinds of subtle errors.</p>
+<p>To run the unit tests with Valgrind, use the new <code class="docutils literal"><span class="pre">valgrind:</span></code> target.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span>me@mybox&gt; make valgrind
+...
+valgrind --tool=memcheck --leak-check=full ./unit -v (a)
+==2999== Memcheck, a memory error detector
+==2999== Copyright (C) 2002-2010, and GNU GPL&#39;d, by Julian Seward et al.
+==2999== Using Valgrind-3.6.0.SVN-Debian and LibVEX; [...]
+==2999== Command: ./unit -v
+==2999==
+...
+--Run Summary: Type      Total     Ran  Passed  Failed   (b)
+               suites        9       9     n/a       0
+               tests        51      51      50       1
+               asserts     474     474     473       1
+...
+==2999== HEAP SUMMARY:   (c)
+==2999==     in use at exit: 4,489 bytes in 134 blocks
+==2999==   total heap usage: 715 allocs, 581 frees, 352,763 bytes allocated
+==2999==
+==2999== 4 bytes in 1 blocks are definitely lost in loss record 3 of 50
+==2999==    at 0x4C2815C: malloc (vg_replace_malloc.c:236)
+==2999==    by 0x44A0CA: xmalloc (xmalloc.c:57)
+==2999==    by 0x4399D8: strconcat (util.c:631)
+==2999==    by 0x40C059: test_uncast_null (strconcat.c:51)
+==2999==    by 0x61B32A9: ??? (in /usr/lib/libcunit.so.1.0.1)
+==2999==    by 0x61B36ED: ??? (in /usr/lib/libcunit.so.1.0.1)
+==2999==    by 0x61B3827: CU_run_all_tests (in /usr/lib/libcunit.so.1.0.1)
+==2999==    by 0x4066CC: run_tests (unit.c:144)
+==2999==    by 0x406806: main (unit.c:283)
+==2999==
+...
+</pre></div>
+</div>
+<p>Here&#8217;s an explanation of what&#8217;s happening in the example.</p>
+<ol class="loweralpha simple">
+<li>The test executable is run as before, but using the <code class="docutils literal"><span class="pre">valgrind</span></code>
+program. The first thing we see is Valgrind&#8217;s banner message.</li>
+<li>The test executable proceeds as normal and eventually emits it&#8217;s run
+summary, then exits.</li>
+<li>After the test executable exits, Valgrind checks for memory leaks
+and prints both a summary of all leaks and a stack trace showing
+where each block of leaked memory was allocated.</li>
+</ol>
+<p>I&#8217;d just like to say that I love Valgrind and I think it&#8217;s immensely
+useful. I would have made running the tests under Valgrind the only
+option for the <code class="docutils literal"><span class="pre">check:</span></code> target, except that Valgrind is not available
+on all of Cyrus&#8217; supported platforms.</p>
+</div>
+<div class="section" id="the-tests-are-failing">
+<h3>3.5 The Tests Are Failing<a class="headerlink" href="#the-tests-are-failing" title="Permalink to this headline">¶</a></h3>
+<p>So you&#8217;ve noticed that some of the tests are failing. Let me make the
+guiding principle of unit testing as clear as possible: <strong>THE UNIT TESTS
+SHOULD NOT FAIL</strong>. All of the tests are designed to pass all the time,
+in everyone&#8217;s environment. The unit tests are run automatically every
+twelve hours on the Cyrus <a class="reference external" href="http://ci.cyrusimap.org/">Continuous Integration
+server</a>, and a failing test fails the whole
+build and makes people unhappy.</p>
+<p>There are a few rules which you should follow to help us all get the
+most benefit out of unit testing</p>
+<ul class="simple">
+<li>If you see a test failing, investigate it.</li>
+<li>If you can&#8217;t investigate, complain on the mailing list or raise a bug
+so that somebody else can investigate.</li>
+<li>When writing tests, write them to work in all environments and all
+combinations of <code class="docutils literal"><span class="pre">configure</span></code> script options. It&#8217;s ok to have a test
+which is empty in some circumstances; it&#8217;s not ok to have a test that
+fails.</li>
+<li>When adding code, write new tests for the new code.</li>
+<li>When modifying code, write new tests for the new behaviour.</li>
+<li>When looking at old code, also take a look at the <a class="reference external" href="http://ci.cyrusimap.org/job/cyrus-imapd-master/887/cobertura/">coverage
+report</a>
+and consider writing tests for the existing code.</li>
+</ul>
+</div>
+</div>
+<div class="section" id="debugging-a-test">
+<h2>3.6 Debugging A Test<a class="headerlink" href="#debugging-a-test" title="Permalink to this headline">¶</a></h2>
+<p>With the new Cyrus build system, the file <code class="docutils literal"><span class="pre">cunit/unit</span></code> is no longer an
+executable, it&#8217;s a shell script which sets up some environment variables
+before running the real executable which is hidden away. This makes
+debugging a failing test somewhat challenging. The solution is:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="p">(</span> <span class="n">cd</span> <span class="n">cunit</span> <span class="p">;</span> <span class="n">libtool</span> <span class="o">--</span><span class="n">mode</span><span class="o">=</span><span class="n">execute</span> <span class="n">gdb</span> <span class="o">--</span><span class="n">args</span> <span class="n">unit</span> <span class="o">-</span><span class="n">t</span> <span class="n">crc32</span> <span class="p">)</span>
+<span class="o">...</span>
+<span class="n">Reading</span> <span class="n">symbols</span> <span class="kn">from</span> <span class="o">/</span><span class="n">home</span><span class="o">/</span><span class="n">me</span><span class="o">/</span><span class="n">cyrus</span><span class="o">-</span><span class="n">imapd</span><span class="o">/</span><span class="n">cunit</span><span class="o">/.</span><span class="n">libs</span><span class="o">/</span><span class="n">lt</span><span class="o">-</span><span class="n">unit</span><span class="o">...</span><span class="n">done</span><span class="o">.</span>
+<span class="p">(</span><span class="n">gdb</span><span class="p">)</span> <span class="nb">list</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span><span class="p">:</span><span class="mi">1</span>
+<span class="mi">1</span>       <span class="o">/*</span> <span class="n">Unit</span> <span class="n">test</span> <span class="k">for</span> <span class="n">lib</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">c</span> <span class="o">*/</span>
+<span class="mi">2</span>       <span class="c1">#include &quot;cunit/cyrunit.h&quot;</span>
+<span class="mi">3</span>       <span class="c1">#include &quot;crc32.h&quot;</span>
+<span class="o">...</span>
+<span class="p">(</span><span class="n">gdb</span><span class="p">)</span> <span class="k">break</span> <span class="n">test_map</span>
+<span class="n">Breakpoint</span> <span class="mi">1</span> <span class="n">at</span> <span class="mh">0x44a2f8</span><span class="p">:</span> <span class="n">file</span> <span class="o">./</span><span class="n">cunit</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">testc</span><span class="p">,</span> <span class="n">line</span> <span class="mf">11.</span>
+<span class="p">(</span><span class="n">gdb</span><span class="p">)</span> <span class="n">run</span>
+<span class="n">Starting</span> <span class="n">program</span><span class="p">:</span> <span class="o">/</span><span class="n">home</span><span class="o">/</span><span class="n">me</span><span class="o">/</span><span class="n">cyrus</span><span class="o">-</span><span class="n">imapd</span><span class="o">/</span><span class="n">cunit</span><span class="o">/.</span><span class="n">libs</span><span class="o">/</span><span class="n">lt</span><span class="o">-</span><span class="n">unit</span> <span class="o">-</span><span class="n">t</span> <span class="o">-</span><span class="n">v</span> <span class="n">crc32</span>
+<span class="p">[</span><span class="n">Thread</span> <span class="n">debugging</span> <span class="n">using</span> <span class="n">libthread_db</span> <span class="n">enabled</span><span class="p">]</span>
+
+    <span class="n">CUnit</span> <span class="o">-</span> <span class="n">A</span> <span class="n">Unit</span> <span class="n">testing</span> <span class="n">framework</span> <span class="k">for</span> <span class="n">C</span> <span class="o">-</span> <span class="n">Version</span> <span class="mf">2.1</span><span class="o">-</span><span class="mi">0</span>
+    <span class="n">http</span><span class="p">:</span><span class="o">//</span><span class="n">cunit</span><span class="o">.</span><span class="n">sourceforge</span><span class="o">.</span><span class="n">net</span><span class="o">/</span>
+
+<span class="n">Suite</span><span class="p">:</span> <span class="n">crc32</span>
+  <span class="n">Test</span><span class="p">:</span> <span class="nb">map</span> <span class="o">...</span>
+<span class="n">Breakpoint</span> <span class="mi">1</span><span class="p">,</span> <span class="n">test_map</span> <span class="p">()</span> <span class="n">at</span> <span class="o">./</span><span class="n">cunit</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">testc</span><span class="p">:</span><span class="mi">11</span>
+<span class="mi">11</span>          <span class="n">c</span> <span class="o">=</span> <span class="n">crc32_map</span><span class="p">(</span><span class="n">TEXT</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">TEXT</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span>
+<span class="p">(</span><span class="n">gdb</span><span class="p">)</span>
+</pre></div>
+</div>
+<p>Note the <strong>-t</strong> option. This turns off test timeouts, which is very
+useful for manual debugging.</p>
+</div>
+<div class="section" id="adding-your-own-tests">
+<h2>4. Adding Your Own Tests<a class="headerlink" href="#adding-your-own-tests" title="Permalink to this headline">¶</a></h2>
+<p>Adding your own tests is quite simple. Here&#8217;s how.</p>
+</div>
+<div class="section" id="where-to-put-your-tests">
+<h2>4.1 Where To Put Your Tests<a class="headerlink" href="#where-to-put-your-tests" title="Permalink to this headline">¶</a></h2>
+<p>The unit test code in Cyrus is contained in a set of C source files in
+the <code class="docutils literal"><span class="pre">cunit</span></code> directory. For reasons too complex to go into here, these
+are named <em>whatever</em>.testc instead of the more usual <em>whatever</em>.c. If
+you look closely, you will see that each of those C source files maps to
+a &#8220;Suite&#8221; in CUnit parlance. For example, <code class="docutils literal"><span class="pre">cunit/glob.testc</span></code> is listed
+as the Suite &#8220;glob&#8221; in CUnit&#8217;s runtime output.</p>
+<p>Typically, each Suite tests a single module or a related set of
+functions; for example, <code class="docutils literal"><span class="pre">cunit/glob.testc</span></code> contains tests for the glob
+module in <code class="docutils literal"><span class="pre">lib/glob.c</span></code>.</p>
+<p>So, if you want to add a new test for a module which already has some
+existing tests, the sensible thing to do is to <a class="reference external" href="#adding-a-test-to-a-suite">add a new test to the
+existing suite</a>. Otherwise, you&#8217;ll need to
+<a class="reference external" href="#adding-a-new-suite">add a new Suite</a>.</p>
+</div>
+<div class="section" id="adding-a-new-suite">
+<h2>4.1 Adding A New Suite<a class="headerlink" href="#adding-a-new-suite" title="Permalink to this headline">¶</a></h2>
+<p>Each Suite is a single C source file in the <code class="docutils literal"><span class="pre">cunit/</span></code> directory. Your
+first step is to create a new C source file. For this example, you&#8217;ll
+create a new Suite to test the CRC32 routines which live in
+<code class="docutils literal"><span class="pre">lib/crc32.c</span></code>.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">vi</span> <span class="n">cunit</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="o">...</span>
+</pre></div>
+</div>
+<p>The file should contain something like this.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">/*</span> <span class="n">Unit</span> <span class="n">test</span> <span class="k">for</span> <span class="n">lib</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">c</span> <span class="o">*/</span>
+<span class="c1">#include &quot;cunit/cyrunit.h&quot;  (a)</span>
+<span class="c1">#include &quot;crc32.h&quot;  (b)</span>
+
+<span class="n">static</span> <span class="n">void</span> <span class="n">test_map</span><span class="p">(</span><span class="n">void</span><span class="p">)</span>  <span class="p">(</span><span class="n">c</span><span class="p">)</span>
+<span class="p">{</span>
+    <span class="n">static</span> <span class="n">const</span> <span class="n">char</span> <span class="n">TEXT</span><span class="p">[]</span> <span class="o">=</span> <span class="s2">&quot;lorem ipsum&quot;</span><span class="p">;</span>  <span class="p">(</span><span class="n">d</span><span class="p">)</span>
+    <span class="n">static</span> <span class="n">uint32_t</span> <span class="n">CRC32</span> <span class="o">=</span> <span class="mh">0x0</span><span class="p">;</span>
+    <span class="n">uint32_t</span> <span class="n">c</span><span class="p">;</span>  <span class="p">(</span><span class="n">e</span><span class="p">)</span>
+
+    <span class="n">c</span> <span class="o">=</span> <span class="n">crc32_map</span><span class="p">(</span><span class="n">TEXT</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">TEXT</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span>  <span class="p">(</span><span class="n">f</span><span class="p">)</span>
+    <span class="n">CU_ASSERT_EQUAL</span><span class="p">(</span><span class="n">c</span><span class="p">,</span> <span class="n">CRC32</span><span class="p">);</span>  <span class="p">(</span><span class="n">g</span><span class="p">)</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>Here&#8217;s an explanation of what all these bits are for.</p>
+<ol class="loweralpha simple">
+<li>You need to include the header <code class="docutils literal"><span class="pre">&quot;cunit/cyrunit.h&quot;</span></code>, which is a thin
+Cyrus wrapper around the CUnit&#8217;s library&#8217;s header,
+<code class="docutils literal"><span class="pre">&lt;CUnit/CUnit.h&gt;</span></code> with some extra conveniences.</li>
+<li>You should also include any headers you need for declarations of the
+functions which you&#8217;ll be testing. Note that the Cyrus <code class="docutils literal"><span class="pre">lib/</span></code> and
+<code class="docutils literal"><span class="pre">imap/</span></code> directories are already in the include path, so any header
+in there can be included without the directory prefix, e.g.
+<code class="docutils literal"><span class="pre">&quot;crc32.h&quot;</span></code> for <code class="docutils literal"><span class="pre">lib/crc32.h</span></code>.</li>
+<li>You need to have at least one function which looks like this: it
+takes no arguments, returns void, and is named <code class="docutils literal"><span class="pre">test_whatever</span></code>. It
+may be <code class="docutils literal"><span class="pre">static</span></code> or <code class="docutils literal"><span class="pre">extern</span></code>, but I recommend <code class="docutils literal"><span class="pre">static</span></code>.
+Functions with this signature are automatically discovered in the
+source code by the Cyrus unit test infrastructure, so all you have
+to do is write the function. Later, a CUnit test named &#8220;whatever&#8221;
+will be created automatically for your <code class="docutils literal"><span class="pre">test_whatever</span></code> function.</li>
+<li>Here&#8217;s a good place to define the test inputs and expected outputs.
+Note that for this example you have no idea of the actual correct
+output. The right thing to do there is to manually calculate the
+expected result from first principles, or to use a different piece
+of software which you believe to be working. For this example, let&#8217;s
+just use a known incorrect value and see what happens.</li>
+<li>Here&#8217;s a good place for local variables you need during the test.</li>
+<li>Call the function under test (<code class="docutils literal"><span class="pre">crc32_map()</span></code> in this example) with
+known inputs, and capture the results in a local variable <code class="docutils literal"><span class="pre">c</span></code>.</li>
+<li>Compare the actual result in <code class="docutils literal"><span class="pre">c</span></code> with the expected result in
+<code class="docutils literal"><span class="pre">CRC32</span></code>. The <code class="docutils literal"><span class="pre">CU_ASSERT_EQUAL()</span></code> macro checks that it&#8217;s two
+arguments are equal (using an integer comparison), and if they&#8217;re
+different it prints a message and records a failure. Note that
+unlike the libc <code class="docutils literal"><span class="pre">assert()</span></code> macro, control will continue even if
+the assert fails. The CUnit library provides a whole family of
+similar macros, see <a class="reference external" href="http://cunit.sourceforge.net/doc/writing_tests.html#assertions">the online CUnit
+documentation</a>
+for more details.</li>
+</ol>
+<p>Now you need to tell the Cyrus build system about your new Suite.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">vi</span> <span class="n">Makefile</span><span class="o">.</span><span class="n">am</span>
+<span class="o">...</span>
+</pre></div>
+</div>
+<p>You need to add the filename of your new test to the definition of the
+<code class="docutils literal"><span class="pre">cunit_TESTS</span></code> variable.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cunit_TESTS</span> <span class="o">=</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">aaa</span><span class="o">-</span><span class="n">db</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">annotate</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">backend</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">binhex</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">bitvector</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">buf</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">byteorder64</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">charset</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">dlist</span><span class="o">.</span><span class="n">testc</span> \
+    <span class="n">cunit</span><span class="o">/</span><span class="n">duplicate</span><span class="o">.</span><span class="n">testc</span> \
+</pre></div>
+</div>
+<p>At this point you should be able to just rebuild and rerun using <strong>make
+check</strong>. You can also just rebuild without rerunning by using the
+command <strong>make cunit/unit</strong>.</p>
+<p>Note that sometimes this doesn&#8217;t quite work right, and you may be able
+to work around this problem using the command <strong>rm
+cunit/default.cunit</strong>.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">make</span> <span class="n">check</span>
+<span class="o">...</span>
+<span class="o">../</span><span class="n">cunit</span><span class="o">/</span><span class="n">cunit</span><span class="o">.</span><span class="n">pl</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">--</span><span class="n">add</span><span class="o">-</span><span class="n">sources</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="o">...</span>
+<span class="o">../</span><span class="n">cunit</span><span class="o">/</span><span class="n">cunit</span><span class="o">.</span><span class="n">pl</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">--</span><span class="n">generate</span><span class="o">-</span><span class="n">wrapper</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="n">gcc</span> <span class="o">-</span><span class="n">c</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">g</span> <span class="o">-</span><span class="n">O2</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">c</span>
+<span class="n">gcc</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">o</span> <span class="n">unit</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">o</span> <span class="o">...</span>
+<span class="n">Running</span> <span class="n">unit</span> <span class="n">tests</span>
+
+    <span class="n">CUnit</span> <span class="o">-</span> <span class="n">A</span> <span class="n">Unit</span> <span class="n">testing</span> <span class="n">framework</span> <span class="k">for</span> <span class="n">C</span> <span class="o">-</span> <span class="n">Version</span> <span class="mf">2.1</span><span class="o">-</span><span class="mi">0</span>
+    <span class="n">http</span><span class="p">:</span><span class="o">//</span><span class="n">cunit</span><span class="o">.</span><span class="n">sourceforge</span><span class="o">.</span><span class="n">net</span><span class="o">/</span>
+
+<span class="o">...</span>
+<span class="n">Suite</span><span class="p">:</span> <span class="n">crc32</span>
+  <span class="n">Test</span><span class="p">:</span> <span class="nb">map</span> <span class="o">...</span> <span class="n">FAILED</span>
+    <span class="mf">1.</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span><span class="p">:</span><span class="mi">12</span>  <span class="o">-</span> <span class="n">CU_ASSERT_EQUAL</span><span class="p">(</span><span class="n">c</span><span class="o">=</span><span class="mi">1926722702</span><span class="p">,</span><span class="n">CRC32</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
+</pre></div>
+</div>
+<p>Note how the test failure told us which in source file and at what line
+number the failure occurred, and what the actual and expected values
+were. Let&#8217;s go and fix that up now.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">static</span> <span class="n">const</span> <span class="n">char</span> <span class="n">TEXT</span><span class="p">[]</span> <span class="o">=</span> <span class="s2">&quot;lorem ipsum&quot;</span><span class="p">;</span>
+<span class="n">static</span> <span class="n">uint32</span>\<span class="n">_t</span> <span class="n">CRC32</span> <span class="o">=</span> <span class="mh">0x72d7748e</span><span class="p">;</span>
+</pre></div>
+</div>
+<p>Re-run <code class="docutils literal"><span class="pre">make</span> <span class="pre">check</span></code> and you&#8217;ll see your test being rebuilt and rerun,
+and this time passing.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">make</span> <span class="n">check</span>
+<span class="o">...</span>
+<span class="o">../</span><span class="n">cunit</span><span class="o">/</span><span class="n">cunit</span><span class="o">.</span><span class="n">pl</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">--</span><span class="n">generate</span><span class="o">-</span><span class="n">wrapper</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="n">gcc</span> <span class="o">-</span><span class="n">c</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">g</span> <span class="o">-</span><span class="n">O2</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">c</span>
+<span class="n">gcc</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">o</span> <span class="n">unit</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">o</span>
+<span class="o">...</span>
+<span class="n">Running</span> <span class="n">unit</span> <span class="n">tests</span>
+
+    <span class="n">CUnit</span> <span class="o">-</span> <span class="n">A</span> <span class="n">Unit</span> <span class="n">testing</span> <span class="n">framework</span> <span class="k">for</span> <span class="n">C</span> <span class="o">-</span> <span class="n">Version</span> <span class="mf">2.1</span><span class="o">-</span><span class="mi">0</span>
+    <span class="n">http</span><span class="p">:</span><span class="o">//</span><span class="n">cunit</span><span class="o">.</span><span class="n">sourceforge</span><span class="o">.</span><span class="n">net</span><span class="o">/</span>
+
+<span class="o">...</span>
+<span class="n">Suite</span><span class="p">:</span> <span class="n">crc32</span>
+  <span class="n">Test</span><span class="p">:</span> <span class="nb">map</span> <span class="o">...</span> <span class="n">passed</span>
+</pre></div>
+</div>
+</div>
+<div class="section" id="adding-a-test-to-a-suite">
+<h2>4.2 Adding A Test To A Suite<a class="headerlink" href="#adding-a-test-to-a-suite" title="Permalink to this headline">¶</a></h2>
+<p>Adding a new test to an existing test is easy: all you have to do is add
+a new function to an existing C source file in the <code class="docutils literal"><span class="pre">cunit/</span></code> directory.
+As an example, let&#8217;s add a test for the <code class="docutils literal"><span class="pre">crc_iovec()</span></code> function.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">vi</span> <span class="n">cunit</span><span class="o">/</span><span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="o">...</span>
+
+<span class="n">static</span> <span class="n">void</span> <span class="n">test_iovec</span><span class="p">(</span><span class="n">void</span><span class="p">)</span>  <span class="p">(</span><span class="n">a</span><span class="p">)</span>
+<span class="p">{</span>
+    <span class="n">static</span> <span class="n">const</span> <span class="n">char</span> <span class="n">TEXT1</span><span class="p">[]</span> <span class="o">=</span> <span class="s2">&quot;lorem&quot;</span><span class="p">;</span>  <span class="p">(</span><span class="n">b</span><span class="p">)</span>
+    <span class="n">static</span> <span class="n">const</span> <span class="n">char</span> <span class="n">TEXT2</span><span class="p">[]</span> <span class="o">=</span> <span class="s2">&quot; ipsum&quot;</span><span class="p">;</span>
+    <span class="n">static</span> <span class="n">uint32_t</span> <span class="n">CRC32</span> <span class="o">=</span> <span class="mh">0x72d7748e</span><span class="p">;</span>
+    <span class="n">uint32_t</span> <span class="n">c</span><span class="p">;</span>  <span class="p">(</span><span class="n">c</span><span class="p">)</span>
+    <span class="n">struct</span> <span class="n">iovec</span> <span class="n">iov</span><span class="p">[</span><span class="mi">2</span><span class="p">];</span>
+
+    <span class="n">memset</span><span class="p">(</span><span class="n">iov</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">iov</span><span class="p">));</span>  <span class="p">(</span><span class="n">d</span><span class="p">)</span>
+    <span class="n">iov</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">iov_base</span> <span class="o">=</span> <span class="n">TEXT1</span><span class="p">;</span>
+    <span class="n">iov</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">iov_len</span> <span class="o">=</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">TEXT1</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">;</span>
+    <span class="n">iov</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">iov_base</span> <span class="o">=</span> <span class="n">TEXT2</span><span class="p">;</span>
+    <span class="n">iov</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">iov_len</span> <span class="o">=</span> <span class="n">sizeof</span><span class="p">(</span><span class="n">TEXT2</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">;</span>
+
+    <span class="n">c</span> <span class="o">=</span> <span class="n">crc32_iovec</span><span class="p">(</span><span class="n">iov</span><span class="p">,</span> <span class="mi">2</span><span class="p">);</span>  <span class="p">(</span><span class="n">e</span><span class="p">)</span>
+    <span class="n">CU_ASSERT_EQUAL</span><span class="p">(</span><span class="n">c</span><span class="p">,</span> <span class="n">CRC32</span><span class="p">);</span>  <span class="p">(</span><span class="n">f</span><span class="p">)</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>Here&#8217;s an explanation of what all these bits are for.</p>
+<ol class="loweralpha simple">
+<li>Your new test function should look like this: it takes no arguments,
+returns void, and is named <code class="docutils literal"><span class="pre">test_whatever</span></code>. It may be <code class="docutils literal"><span class="pre">static</span></code>
+or <code class="docutils literal"><span class="pre">extern</span></code>, but I recommend <code class="docutils literal"><span class="pre">static</span></code>. Functions with this
+signature are automatically discovered in the source code by the
+Cyrus unit test infrastructure, so all you have to do is write the
+function. Later, a CUnit test named &#8220;whatever&#8221; will be created
+automatically for your <code class="docutils literal"><span class="pre">test_whatever</span></code> function. Note that the
+opening curly brace must be on the next line or the unit test
+infrastructure will not find the function.</li>
+<li>Here&#8217;s a good place to define the test inputs and expected outputs.</li>
+<li>Here&#8217;s a good place for local variables you need during the test.</li>
+<li>Here you set up the input conditions for the function under test.</li>
+<li>Call the function under test with your known inputs, and capture the
+results in a local variable, here <code class="docutils literal"><span class="pre">c</span></code>.</li>
+<li>Compare the actual result in <code class="docutils literal"><span class="pre">c</span></code> with the expected result in
+<code class="docutils literal"><span class="pre">CRC32</span></code>. The <code class="docutils literal"><span class="pre">CU_ASSERT_EQUAL()</span></code> macro checks that it&#8217;s two
+arguments are equal (using an integer comparison), and if they&#8217;re
+different it prints a message and records a failure. Note that
+unlike the libc <code class="docutils literal"><span class="pre">assert()</span></code> macro, control will continue even if
+the assert fails. The CUnit library provides a whole family of
+similar macros, see <a class="reference external" href="http://cunit.sourceforge.net/doc/writing_tests.html#assertions">the online CUnit
+documentation</a>
+for more details.</li>
+</ol>
+<p>Now run <code class="docutils literal"><span class="pre">make</span> <span class="pre">check</span></code> and you&#8217;ll see your test being built and run.</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">me</span><span class="nd">@mybox</span><span class="o">&gt;</span> <span class="n">make</span> <span class="n">check</span>
+<span class="o">...</span>
+<span class="o">../</span><span class="n">cunit</span><span class="o">/</span><span class="n">cunit</span><span class="o">.</span><span class="n">pl</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">--</span><span class="n">generate</span><span class="o">-</span><span class="n">wrapper</span> <span class="n">crc32</span><span class="o">.</span><span class="n">testc</span>
+<span class="n">gcc</span> <span class="o">-</span><span class="n">c</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">g</span> <span class="o">-</span><span class="n">O2</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">c</span>
+<span class="n">gcc</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">-</span><span class="n">o</span> <span class="n">unit</span> <span class="p">[</span><span class="o">...</span><span class="p">]</span> <span class="o">.</span><span class="n">cunit</span><span class="o">-</span><span class="n">crc32</span><span class="o">.</span><span class="n">o</span>
+<span class="o">...</span>
+<span class="n">Running</span> <span class="n">unit</span> <span class="n">tests</span>
+
+
+     <span class="n">CUnit</span> <span class="o">-</span> <span class="n">A</span> <span class="n">Unit</span> <span class="n">testing</span> <span class="n">framework</span> <span class="k">for</span> <span class="n">C</span> <span class="o">-</span> <span class="n">Version</span> <span class="mf">2.1</span><span class="o">-</span><span class="mi">0</span>
+     <span class="n">http</span><span class="p">:</span><span class="o">//</span><span class="n">cunit</span><span class="o">.</span><span class="n">sourceforge</span><span class="o">.</span><span class="n">net</span><span class="o">/</span>
+
+<span class="o">...</span>
+<span class="n">Suite</span><span class="p">:</span> <span class="n">crc32</span>
+  <span class="n">Test</span><span class="p">:</span> <span class="nb">map</span> <span class="o">...</span> <span class="n">passed</span>
+  <span class="n">Test</span><span class="p">:</span> <span class="n">iovec</span> <span class="o">...</span> <span class="n">passed</span>
+</pre></div>
+</div>
+</div>
+<div class="section" id="suite-setup-and-teardown">
+<h2>4.3 Suite Setup And Teardown<a class="headerlink" href="#suite-setup-and-teardown" title="Permalink to this headline">¶</a></h2>
+<p>Sometimes the behaviour of the functions under test depend on external
+influences such as environment variables, global variables, or the
+presence of certain files.</p>
+<p>These kinds of functions need special treatment to ensure that their
+behaviour is locked down during the running of your tests. Otherwise,
+all sorts of strange behaviour may confuse the results of the tests. For
+example, a test might succeed the first time it&#8217;s run in a given
+directory and fail the next time. Or a test might succeed when run by
+the author of the test but fail when run by another user.</p>
+<p>CUnit provides a special arrangement which helps you in such cases: the
+suite initialisation and cleanup functions. These are two functions that
+you write and which live in the suite source. They are called from CUnit
+respectively before any of the tests in the suite is run, and after all
+tests from that suite are run.</p>
+<p>Here&#8217;s how to use them. The suite setup function should set up any
+global state that the functions under test rely on, in such a way that
+their state is predictable and always the same no matter who runs the
+test or when or how many times. Similarly the suite teardown function
+should clean up any state which might possibly interfere with other test
+suites. Note that some suites will need an setup function but not
+necessarily a teardown function.</p>
+<p>Adding these functions is very easy: you just write functions of the
+appropriate signature (names, arguments and return type) and the Cyrus
+unit test infrastructure will automatically discover them and arrange
+for them to be called. The functions should look like (actual example
+taken from <code class="docutils literal"><span class="pre">cunit/mboxname.testc</span></code>) this:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">static</span> <span class="n">enum</span> <span class="n">enum_value</span> <span class="n">old_config_virtdomains</span><span class="p">;</span>
+
+<span class="n">static</span> <span class="nb">int</span> <span class="n">set_up</span><span class="p">(</span><span class="n">void</span><span class="p">)</span>
+<span class="p">{</span>
+    <span class="n">old_config_virtdomains</span> <span class="o">=</span> <span class="n">config_virtdomains</span><span class="p">;</span>
+    <span class="n">config_virtdomains</span> <span class="o">=</span> <span class="n">IMAP_ENUM_VIRTDOMAINS_ON</span><span class="p">;</span>
+    <span class="k">return</span> <span class="mi">0</span><span class="p">;</span>
+<span class="p">}</span>
+
+<span class="n">static</span> <span class="nb">int</span> <span class="n">tear_down</span><span class="p">(</span><span class="n">void</span><span class="p">)</span>
+<span class="p">{</span>
+    <span class="n">config_virtdomains</span> <span class="o">=</span> <span class="n">old_config_virtdomains</span><span class="p">;</span>
+    <span class="k">return</span> <span class="mi">0</span><span class="p">;</span>
+<span class="p">}</span>
+</pre></div>
+</div>
+<p>The functions should return 0 on success, and non-zero on error. They
+must not call and <code class="docutils literal"><span class="pre">CU_*</span></code> functions or macros.</p>
+<p>Good luck and good testing!</p>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../../support.html" class="btn btn-neutral float-right" title="Support/Community" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="guidance/var_directory_structure.html" class="btn btn-neutral" title="Cyrus IMAP Server: var directory structure" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 15 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/developer.html 3.2.0-3/doc/html/imap/developer.html
--- 3.0.13-5/doc/html/imap/developer.html	2019-12-16 04:16:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/developer.html	2020-05-04 04:11:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>IMAP Developer Guide &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>IMAP Developer Guide &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="Developers" href="../developers.html"/>
         <link rel="next" title="Development Process" href="developer/process.html"/>
         <link rel="prev" title="Documentation" href="developer/documentation.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../developers.html">Developers</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/developer.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/developer.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,6 +795,7 @@
 <li class="toctree-l1"><a class="reference internal" href="developer/compiling.html">Compiling</a></li>
 <li class="toctree-l1"><a class="reference internal" href="installing.html">Installing Cyrus</a></li>
 <li class="toctree-l1"><a class="reference internal" href="developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l1"><a class="reference internal" href="developer/jmap.html">JMAP support</a></li>
 </ul>
 </div>
 <div class="toctree-wrapper compound">
@@ -803,11 +823,14 @@
 <ul>
 <li class="toctree-l1"><a class="reference internal" href="developer/releasing.html">Releasing Cyrus IMAP</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#prerequisites">Prerequisites</a></li>
+<li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#order-of-operations">Order of operations</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#release-notes">Release notes</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#pre-release-testing">Pre-release testing</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#linking-up-release-notes">Linking up release notes</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#version-tagging">Version tagging</a></li>
-<li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#releasing">Releasing</a></li>
+<li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#inter-version-website-consistency">Inter-version website consistency</a></li>
+<li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#uploading">Uploading</a></li>
+<li class="toctree-l2"><a class="reference internal" href="developer/releasing.html#tell-the-world">Tell the world</a></li>
 </ul>
 </li>
 <li class="toctree-l1"><a class="reference internal" href="developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a><ul>
@@ -817,7 +840,7 @@
 <li class="toctree-l2"><a class="reference internal" href="developer/ancient-releasing.html#pre-release-testing">Pre-release testing</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/ancient-releasing.html#cross-pollination-of-release-notes">Cross-pollination of release notes</a></li>
 <li class="toctree-l2"><a class="reference internal" href="developer/ancient-releasing.html#building-the-release">Building the release</a></li>
-<li class="toctree-l2"><a class="reference internal" href="developer/ancient-releasing.html#releasing">Releasing</a></li>
+<li class="toctree-l2"><a class="reference internal" href="developer/ancient-releasing.html#finishing-up">Finishing up</a></li>
 </ul>
 </li>
 </ul>
@@ -843,7 +866,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jul 30 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 13 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -863,7 +886,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/getcyrus.html 3.2.0-3/doc/html/imap/download/getcyrus.html
--- 3.0.13-5/doc/html/imap/download/getcyrus.html	2019-12-16 04:16:50.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/getcyrus.html	2020-05-04 04:11:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Get Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Get Cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Download" href="../../download.html"/>
         <link rel="next" title="CentOS" href="installation/distributions/centos.html"/>
         <link rel="prev" title="Download" href="../../download.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../download.html">Download</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/getcyrus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/getcyrus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -790,8 +809,8 @@ guaranteed to be up to date.</p>
 <h3>Use a release packaged tarball<a class="headerlink" href="#use-a-release-packaged-tarball" title="Permalink to this headline">¶</a></h3>
 <p>The Cyrus team produce packaged tarballs containing full source and
 pre-built documentation.</p>
-<p>Download a versioned tarball using <a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/">FTP</a> or <a class="reference external" href="https://www.cyrusimap.org/releases/">HTTPS</a>. Latest stable
-version is 3.0.13.</p>
+<p>Download a versioned tarball using <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases">HTTPS</a>. Latest stable
+version is 3.2.0.</p>
 <p>Extract the tarball:</p>
 <pre class="literal-block">
 $ <strong class="command">tar xzvf cyrus-imapd-x.y.z.tar.gz</strong>
@@ -881,7 +900,7 @@ copyright text.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 16 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -901,7 +920,7 @@ copyright text.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/centos.html 3.2.0-3/doc/html/imap/download/installation/distributions/centos.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/centos.html	2019-12-16 04:16:50.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/centos.html	2020-05-04 04:11:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>CentOS &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>CentOS &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="Debian" href="debian.html"/>
         <link rel="prev" title="Get Cyrus" href="../../getcyrus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/centos.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/centos.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -858,7 +877,7 @@ Connection closed.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Feb 02 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 02 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -878,7 +897,7 @@ Connection closed.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/debian.html 3.2.0-3/doc/html/imap/download/installation/distributions/debian.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/debian.html	2019-12-16 04:16:50.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/debian.html	2020-05-04 04:11:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Debian &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Debian &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="Fedora" href="fedora.html"/>
         <link rel="prev" title="CentOS" href="centos.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/debian.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/debian.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -854,7 +873,7 @@ Connection closed.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -874,7 +893,7 @@ Connection closed.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/fedora.html 3.2.0-3/doc/html/imap/download/installation/distributions/fedora.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/fedora.html	2019-12-16 04:16:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/fedora.html	2020-05-04 04:11:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Fedora &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Fedora &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="openSUSE" href="opensuse.html"/>
         <link rel="prev" title="Debian" href="debian.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/fedora.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/fedora.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -869,7 +888,7 @@ Connection closed.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Feb 02 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 02 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -889,7 +908,7 @@ Connection closed.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/opensuse.html 3.2.0-3/doc/html/imap/download/installation/distributions/opensuse.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/opensuse.html	2019-12-16 04:16:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/opensuse.html	2020-05-04 04:11:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>openSUSE &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>openSUSE &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="Red Hat Enterprise Linux" href="rhel.html"/>
         <link rel="prev" title="Fedora" href="fedora.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/opensuse.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/opensuse.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,7 +819,7 @@ IMAP.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -820,7 +839,7 @@ IMAP.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/rhel.html 3.2.0-3/doc/html/imap/download/installation/distributions/rhel.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/rhel.html	2019-12-16 04:16:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/rhel.html	2020-05-04 04:11:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Red Hat Enterprise Linux &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Red Hat Enterprise Linux &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="Ubuntu" href="ubuntu.html"/>
         <link rel="prev" title="openSUSE" href="opensuse.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/rhel.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/rhel.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -864,7 +883,7 @@ Connection closed.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Feb 02 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 02 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -884,7 +903,7 @@ Connection closed.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/distributions/ubuntu.html 3.2.0-3/doc/html/imap/download/installation/distributions/ubuntu.html
--- 3.0.13-5/doc/html/imap/download/installation/distributions/ubuntu.html	2019-12-16 04:16:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/distributions/ubuntu.html	2020-05-04 04:11:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Ubuntu &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Ubuntu &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Get Cyrus" href="../../getcyrus.html"/>
         <link rel="next" title="Release Notes" href="../../release-notes/index.html"/>
         <link rel="prev" title="Red Hat Enterprise Linux" href="rhel.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/distributions/ubuntu.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/distributions/ubuntu.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -980,7 +999,7 @@ Connection closed.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1000,7 +1019,7 @@ Connection closed.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/http/caldav.html 3.2.0-3/doc/html/imap/download/installation/http/caldav.html
--- 3.0.13-5/doc/html/imap/download/installation/http/caldav.html	2019-12-16 04:16:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/http/caldav.html	2020-05-04 04:11:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>CalDAV &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>CalDAV &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="HTTP modules" href="../manage-dav.html"/>
         <link rel="next" title="CardDAV" href="carddav.html"/>
         <link rel="prev" title="HTTP modules" href="../manage-dav.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../setup.html">Setup</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/http/caldav.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/http/caldav.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -838,7 +857,7 @@ user MUST have an existing IMAP Inbox in
 <blockquote>
 <div><p><code class="docutils literal"><span class="pre">caldav_create_attach:</span></code> 1</p>
 <blockquote>
-<div>Create the &#8216;Attachments&#8217; calendar if it doesn&#8217;t already exist</div></blockquote>
+<div>Create the &#8216;Attachments&#8217; collection if it doesn&#8217;t already exist</div></blockquote>
 </div></blockquote>
 <blockquote class="last">
 <div><p><code class="docutils literal"><span class="pre">caldav_create_sched:</span></code> 1</p>
@@ -860,6 +879,18 @@ It allows you to:</p>
 <li>Delete existing collections</li>
 </ul>
 </div></blockquote>
+<p>The Cyrus web GUI for CalDAV Collection Management is disabled by
+default, but can be enabled with the &#8220;caldav_allowcalendaradmin&#8221; option.</p>
+<div class="sidebar">
+<p class="first sidebar-title">caldav_allowcalendaradmin</p>
+<blockquote>
+<div><em>This shows the default value: change it in imapd.conf to suit your needs.</em></div></blockquote>
+<blockquote class="last">
+<div><p><code class="docutils literal"><span class="pre">caldav_allowcalendaradmin:</span></code> 0</p>
+<blockquote>
+<div>Enable per-user calendar administration web UI on the CalDAV server.</div></blockquote>
+</div></blockquote>
+</div>
 <p>To access the Cyrus web GUI for CalDAV Collection Management, point
 a web browser at <code class="docutils literal"><span class="pre">https://&lt;servername&gt;/dav/calendars/user/&lt;username&gt;</span></code></p>
 <div class="section" id="calendar-access-controls">
@@ -938,7 +969,8 @@ The tables below show how the access con
     <td>CYRUS:admin</td>
     <td>DAV:read-acl
       <br>DAV:write-acl
-        <br>DAV:unlock</td>
+      <br>DAV:share
+      <br>DAV:unlock</td>
     <td>ACL
       <br>PROPFIND <small>(DAV:acl property ONLY)</small>
       <br>UNLOCK <small>(ANY lock)</small></td>
@@ -1073,7 +1105,7 @@ their query results.</p>
 <h2>Time Zone Distribution Service (TZDist)<a class="headerlink" href="#time-zone-distribution-service-tzdist" title="Permalink to this headline">¶</a></h2>
 <div class="section" id="what-is-tzdist">
 <h3>What is TZDist<a class="headerlink" href="#what-is-tzdist" title="Permalink to this headline">¶</a></h3>
-<p>The Time Zone module allows Cyrus to function as a Time Zone Distribution
+<p>The TZDist module allows Cyrus to function as a Time Zone Distribution
 Service (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7808.html"><strong>RFC 7808</strong></a> and <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7809.html"><strong>RFC 7809</strong></a>), providing time zone data for CalDAV
 and calendaring clients, without having to wait for their client vendor and/or
 OS vendor to update the timezone information. The responsibility for keeping
@@ -1099,30 +1131,44 @@ will be configdirectory/zoneinfo.db</div
 <div class="line-block">
 <div class="line"><br /></div>
 </div>
-<blockquote class="last">
+<blockquote>
 <div><p><code class="docutils literal"><span class="pre">zoneinfo_db:</span></code> twoskip</p>
 <blockquote>
-<div><p>The cyrusdb backend to use for zoneinfo.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<div>The cyrusdb backend to use for zoneinfo.  This database is used by the
+&#8220;tzdist&#8221; <em>http_modules</em>, and is managed by <strong>ctl_zoneinfo(8)</strong>.
+Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></div></blockquote>
+</div></blockquote>
+<div class="line-block">
+<div class="line"><br /></div>
+</div>
+<blockquote class="last">
+<div><p><code class="docutils literal"><span class="pre">zoneinfo_dir:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>The absolute path to the zoneinfo directory, containing timezone
+definitions as generated by the vzic tool.  If not specified, whatever
+definitions libical finds will be used.</p>
+<p>If you are providing a Time Zone Data Distribution Service (i.e. you have
+&#8220;tzdist&#8221; listed in <em>http_modules</em>), then this configuration option MUST
+be specified.</p>
 </div></blockquote>
 </div></blockquote>
 </div>
-<p>This module stores time zone data in the <code class="docutils literal"><span class="pre">zoneinfo/</span></code> subdirectory of the Cyrus
-configuration directory (as specified by the <code class="docutils literal"><span class="pre">configdirectory</span></code> option). The data is
-indexed by a database whose location is specified by the <code class="docutils literal"><span class="pre">zoneinfo_db_path</span></code>
-option, using the format specified by the <code class="docutils literal"><span class="pre">zoneinfo_db</span></code> option.</p>
+<p>The TZDist module requires the <code class="docutils literal"><span class="pre">zoneinfo_dir</span></code> setting in <a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+to be set to the directory where your time zone data is stored.</p>
+<p>The data is indexed by a database whose location is specified by the
+<code class="docutils literal"><span class="pre">zoneinfo_db_path</span></code> option, using the format specified by the <code class="docutils literal"><span class="pre">zoneinfo_db</span></code>
+option.</p>
 </div>
 <div class="section" id="id3">
 <h3>Administration<a class="headerlink" href="#id3" title="Permalink to this headline">¶</a></h3>
-<p>This module is designed to use the IANA Time Zone Database data (a.k.a. Olson
-Database) converted to the iCalendar format.</p>
-<p>Cyrus uses a modified <a class="reference external" href="https://github.com/libical/vzic">vzic</a> to convert IANA
-formatted data into iCalendar format. There is more information on Cyrus vzic in
-<code class="docutils literal"><span class="pre">tools/vzic/README</span></code>.</p>
-<p>The steps to populate the Cyrus <code class="docutils literal"><span class="pre">zoneinfo/</span></code> directory are:</p>
+<p>The TZDist module is designed to use the IANA Time Zone Database data (a.k.a.
+Olson Database) converted to the iCalendar format.</p>
+<p>We provide a modified <a class="reference external" href="https://github.com/libical/vzic">vzic</a> to convert IANA
+formatted data into iCalendar format, in the <a class="reference external" href="https://github.com/cyrusimap/cyrus-timezones">cyrus-timezones package</a> to make the following steps
+easier.</p>
+<p>The steps to populate the <code class="docutils literal"><span class="pre">zoneinfo_dir</span></code> directory are:</p>
 <ol class="arabic">
-<li><p class="first">Build the local &#8220;vzic&#8221; utility located in the <code class="docutils literal"><span class="pre">tools/vzic/</span></code> subdirectory
-of the Cyrus source code. Run make in the tools/vzic/ subdirectory to build.</p>
+<li><p class="first">Acquire and build your choice of <code class="docutils literal"><span class="pre">vzic</span></code> tool.</p>
 </li>
 <li><p class="first">Download the latest version of the
 <a class="reference external" href="http://www.iana.org/time-zones">Time Zone Database data from IANA</a>. Note
@@ -1130,22 +1176,22 @@ you only need the <strong>data</strong>,
 </li>
 <li><p class="first">Expand the downloaded time zone data into a temporary directory of your choice.</p>
 </li>
-<li><p class="first">Populate <code class="docutils literal"><span class="pre">&lt;configdirectory&gt;/zoneinfo/</span></code> with iCalendar data:</p>
+<li><p class="first">Populate <code class="docutils literal"><span class="pre">zoneinfo_dir</span></code> with iCalendar data:</p>
 <p><em>Initial Install Only</em></p>
 <ol class="loweralpha">
 <li><p class="first">Convert the raw data into iCalendar format by running vzic as follows:
-<code class="docutils literal"><span class="pre">vzic</span> <span class="pre">--pure</span> <span class="pre">--olson-dir</span> <span class="pre">&lt;location-of-raw-data&gt;</span> <span class="pre">--output-dir</span> <span class="pre">&lt;configdirectory&gt;/zoneinfo</span></code></p>
-<p>This will create and install iCalendar data directly into the <code class="docutils literal"><span class="pre">&lt;configdirectory&gt;/zoneinfo/</span></code> directory.</p>
+<code class="docutils literal"><span class="pre">vzic</span> <span class="pre">--pure</span> <span class="pre">--olson-dir</span> <span class="pre">&lt;location-of-raw-data&gt;</span> <span class="pre">--output-dir</span> <span class="pre">&lt;zoneinfo_dir&gt;</span></code></p>
+<p>This will create and install iCalendar data directly into the
+<code class="docutils literal"><span class="pre">&lt;zoneinfo_dir&gt;</span></code> directory.</p>
 </li>
 </ol>
 <p><em>Updating Data Only</em></p>
 <ol class="loweralpha" start="2">
 <li><p class="first">Convert the raw data into iCalendar format by running vzic as follows:
 <code class="docutils literal"><span class="pre">vzic</span> <span class="pre">--pure</span> <span class="pre">--olson-dir</span> <span class="pre">&lt;location-of-raw-data&gt;</span></code></p>
-<p>This will create a zoneinfo/ subdirectory in your current location
-(which should be <cite>tools/vzic/</cite>).</p>
+<p>This will create a zoneinfo/ subdirectory in your current location</p>
 </li>
-<li><p class="first">Merge new/updated iCalendar data into the <code class="docutils literal"><span class="pre">&lt;configdirectory&gt;/zoneinfo/</span></code> directory
+<li><p class="first">Merge new/updated iCalendar data into the <code class="docutils literal"><span class="pre">&lt;zoneinfo_dir&gt;</span></code> directory
 by running vzic-merge.pl in your current location:
 <code class="docutils literal"><span class="pre">vzic-merge.pl</span></code></p>
 </li>
@@ -1224,7 +1270,7 @@ or corruption.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 16 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1244,7 +1290,7 @@ or corruption.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/http/carddav.html 3.2.0-3/doc/html/imap/download/installation/http/carddav.html
--- 3.0.13-5/doc/html/imap/download/installation/http/carddav.html	2019-12-16 04:16:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/http/carddav.html	2020-05-04 04:11:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>CardDAV &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>CardDAV &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="HTTP modules" href="../manage-dav.html"/>
         <link rel="next" title="WebDAV" href="webdav.html"/>
         <link rel="prev" title="CalDAV" href="caldav.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../setup.html">Setup</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/http/carddav.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/http/carddav.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -810,6 +829,16 @@ prevent an IMAP client from accessing th
 the first time that the user authenticates to the CardDAV server. Note that the
 user MUST have an existing IMAP Inbox in order for the addressbook to be
 created.</p>
+<div class="sidebar">
+<p class="first sidebar-title">carddav_allowaddressbookadmin</p>
+<blockquote>
+<div><em>This shows the default value: change it in imapd.conf to suit your needs.</em></div></blockquote>
+<blockquote class="last">
+<div><p><code class="docutils literal"><span class="pre">carddav_allowaddressbookadmin:</span></code> 0</p>
+<blockquote>
+<div>Enable per-user addressbook administration web UI on the CardDAV server.</div></blockquote>
+</div></blockquote>
+</div>
 <p>There is also a Cyrus web GUI for managing addressbook resources.
 It allows you to:</p>
 <blockquote>
@@ -819,6 +848,8 @@ It allows you to:</p>
 <li>Download existing collections via prepared URLs</li>
 </ul>
 </div></blockquote>
+<p>The Cyrus web GUI for addressbook management is disabled by default,
+but can be enabled with the &#8220;carddav_allowaddressbookadmin&#8221; option.</p>
 <p>To access the Cyrus web GUI for addressbook management, point
 a web browser at <code class="docutils literal"><span class="pre">https://&lt;servername&gt;/dav/addressbooks/user/&lt;username&gt;</span></code></p>
 <div class="section" id="addressbook-access-controls">
@@ -848,7 +879,7 @@ addressbooks and are ignored.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jul 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 24 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -868,7 +899,7 @@ addressbooks and are ignored.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/http/jmap.html 3.2.0-3/doc/html/imap/download/installation/http/jmap.html
--- 3.0.13-5/doc/html/imap/download/installation/http/jmap.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/http/jmap.html	2020-05-04 04:11:42.000000000 +0000
@@ -0,0 +1,970 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>JMAP &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
+        <link rel="up" title="HTTP modules" href="../manage-dav.html"/>
+        <link rel="next" title="RSS Feeds" href="rss.html"/>
+        <link rel="prev" title="WebDAV" href="webdav.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../index.html">Home</a></li>
+    <li><a href="../../../../download.html">Download</a></li>
+    <li><a href="../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../index.html">
+      <img src="../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../setup.html">Setup</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../../installing.html#optional-components">Optional Components</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../developers.html">Developers</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../../developer.html">Contribute code and tests</a><ul class="current">
+<li class="toctree-l3 current"><a class="reference internal" href="../../../developer.html#getting-started">Getting Started</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../setup.html">Setup</a> &raquo;</li>
+      
+          <li><a href="../../../installing.html">Installing Cyrus</a> &raquo;</li>
+      
+          <li><a href="../manage-dav.html">HTTP modules</a> &raquo;</li>
+      
+    <li>JMAP</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/http/jmap.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="jmap">
+<h1>JMAP<a class="headerlink" href="#jmap" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="about-jmap">
+<h2>About JMAP<a class="headerlink" href="#about-jmap" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference external" href="http://jmap.io/">JMAP</a> is an alternate mechanism for synchronising a mail
+client with a mail server, intended as a replacement for IMAP. It is a
+transport-agnostic, stateless JSON-based API, aiming to be compatible with the
+IMAP data model, but with reduced data usage and more efficient synchronisation.</p>
+</div>
+<div class="section" id="configuration">
+<h2>Configuration<a class="headerlink" href="#configuration" title="Permalink to this headline">¶</a></h2>
+<p>JMAP support needs to be compiled in to the server using additional
+compile flags. Depending on your distribution, your package provider may
+have already done so. If not, check the
+<a class="reference internal" href="../../../developer/jmap.html#developer-jmap"><span class="std std-ref">JMAP developer guide</span></a> for instructions on how to do
+so manually, assuming you have the source.</p>
+<div class="sidebar">
+<p class="first sidebar-title">JMAP configuration</p>
+<blockquote>
+<div><em>This shows the default value: change it in imapd.conf to suit your needs.</em></div></blockquote>
+<blockquote>
+<div><p><code class="docutils literal"><span class="pre">conversations:</span></code> 0</p>
+<blockquote>
+<div>Enable the XCONVERSATIONS extensions.  Extract conversation
+tracking information from incoming messages and track them
+in per-user databases.</div></blockquote>
+</div></blockquote>
+<div class="line-block">
+<div class="line"><br /></div>
+</div>
+<blockquote class="last">
+<div><p><code class="docutils literal"><span class="pre">conversations_db:</span></code> skiplist</p>
+<blockquote>
+<div><p>The cyrusdb backend to use for the per-user conversations database.</p>
+<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
+</div></blockquote>
+</div></blockquote>
+</div>
+<p>Once it&#8217;s compiled, JMAP needs to be enabled in <a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>.</p>
+<p>Enable <a class="reference internal" href="../../../concepts/deployment/databases.html#imap-concepts-deployment-db-conversations"><span class="std std-ref">conversation support</span></a></p>
+<blockquote>
+<div><ul class="simple">
+<li>In <a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, set <code class="docutils literal"><span class="pre">conversations:</span> <span class="pre">1</span></code>, <code class="docutils literal"><span class="pre">conversations_db:</span> <span class="pre">twoskip</span></code></li>
+<li>Create a conversations.db for each user using
+<a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a>: <code class="docutils literal"><span class="pre">ctl_conversationsdb</span> <span class="pre">-b</span> <span class="pre">-r</span></code></li>
+</ul>
+</div></blockquote>
+</div>
+<div class="section" id="jmap-clients">
+<h2>JMAP clients<a class="headerlink" href="#jmap-clients" title="Permalink to this headline">¶</a></h2>
+<p>The official JMAP website maintains a list of <a class="reference external" href="http://jmap.io/software.html">known clients with JMAP support</a>.</p>
+<p>The Cyrus <a class="reference internal" href="../../../developer/jmap.html#developer-jmap"><span class="std std-ref">JMAP developer guide</span></a> has information on using
+the sample test clients.</p>
+</div>
+<div class="section" id="jmap-implementation-status">
+<span id="jmap-implementation"></span><h2>JMAP implementation status<a class="headerlink" href="#jmap-implementation-status" title="Permalink to this headline">¶</a></h2>
+<p>The JMAP implementation in Cyrus is at various stages of maturity.</p>
+<div class="section" id="working">
+<h3>Working<a class="headerlink" href="#working" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li><dl class="first docutils">
+<dt><strong>Contacts</strong></dt>
+<dd><ul class="first last">
+<li>All JMAP methods are implemented. JMAP blobs are not supported.</li>
+</ul>
+</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt><strong>Calendars</strong></dt>
+<dd><ul class="first last">
+<li>All JMAP methods are implemented. JMAP blobs are not supported.</li>
+</ul>
+</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
+<dt><strong>Messages</strong></dt>
+<dd><ul class="first last">
+<li>Most JMAP methods are implemented. The following methods are not planned for implementation:<ul>
+<li>copyMessages</li>
+<li>reportMessages</li>
+<li>getVacationResponse</li>
+<li>setVacationResponse</li>
+<li>getIdentityUpdates</li>
+<li>setIdentities</li>
+</ul>
+</li>
+</ul>
+</dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="section" id="not-yet-implemented">
+<h3>Not yet implemented<a class="headerlink" href="#not-yet-implemented" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li><strong>Remote mailboxes</strong></li>
+<li><dl class="first docutils">
+<dt><strong>Events</strong></dt>
+<dd><ul class="first last">
+<li>Changes on mailbox entries trigger notifications. However, the JMAP event service is not implemented.</li>
+</ul>
+</dd>
+</dl>
+</li>
+</ul>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="rss.html" class="btn btn-neutral float-right" title="RSS Feeds" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="webdav.html" class="btn btn-neutral" title="WebDAV" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 02 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/installation/http/rss.html 3.2.0-3/doc/html/imap/download/installation/http/rss.html
--- 3.0.13-5/doc/html/imap/download/installation/http/rss.html	2019-12-16 04:16:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/http/rss.html	2020-05-04 04:11:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>RSS Feeds &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>RSS Feeds &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="HTTP modules" href="../manage-dav.html"/>
         <link rel="next" title="Virus Scanner" href="../virus.html"/>
-        <link rel="prev" title="WebDAV" href="webdav.html"/> 
+        <link rel="prev" title="JMAP" href="jmap.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../setup.html">Setup</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/http/rss.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/http/rss.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -858,7 +877,7 @@ mailbox list.</p>
         <a href="../virus.html" class="btn btn-neutral float-right" title="Virus Scanner" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="webdav.html" class="btn btn-neutral" title="WebDAV" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="jmap.html" class="btn btn-neutral" title="JMAP" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -867,7 +886,7 @@ mailbox list.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 07 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -887,7 +906,7 @@ mailbox list.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/http/webdav.html 3.2.0-3/doc/html/imap/download/installation/http/webdav.html
--- 3.0.13-5/doc/html/imap/download/installation/http/webdav.html	2019-12-16 04:16:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/http/webdav.html	2020-05-04 04:11:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>WebDAV &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>WebDAV &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="HTTP modules" href="../manage-dav.html"/>
-        <link rel="next" title="RSS Feeds" href="rss.html"/>
+        <link rel="next" title="JMAP" href="jmap.html"/>
         <link rel="prev" title="CardDAV" href="carddav.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../setup.html">Setup</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/http/webdav.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/http/webdav.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -829,7 +848,7 @@ storage and are ignored.</p>
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="rss.html" class="btn btn-neutral float-right" title="RSS Feeds" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="jmap.html" class="btn btn-neutral float-right" title="JMAP" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="carddav.html" class="btn btn-neutral" title="CardDAV" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -841,7 +860,7 @@ storage and are ignored.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -861,7 +880,7 @@ storage and are ignored.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/manage-dav.html 3.2.0-3/doc/html/imap/download/installation/manage-dav.html
--- 3.0.13-5/doc/html/imap/download/installation/manage-dav.html	2019-12-16 04:16:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/manage-dav.html	2020-05-04 04:11:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>HTTP modules &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>HTTP modules &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Installing Cyrus" href="../../installing.html"/>
         <link rel="next" title="CalDAV" href="http/caldav.html"/>
         <link rel="prev" title="Installing Cyrus" href="../../installing.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/manage-dav.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/manage-dav.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -812,6 +831,14 @@ collections and <span class="target" id=
 </dl>
 </li>
 <li><dl class="first docutils">
+<dt>JMAP support</dt>
+<dd><ul class="first last">
+<li>Allows synchronization of mail clients via the JSON Mail Access Protocol (JMAP).</li>
+</ul>
+</dd>
+</dl>
+</li>
+<li><dl class="first docutils">
 <dt>Other (RSS, static content)</dt>
 <dd><ul class="first last">
 <li>Serves static content (such as the RSS feed list template and the
@@ -839,7 +866,7 @@ at compile time due to missing dependenc
 <p>Note that &#8220;domainkey&#8221; depends on &#8220;ischedule&#8221; being enabled, and
 that both &#8220;freebusy&#8221; and &#8220;ischedule&#8221; depend on &#8220;caldav&#8221; being
 enabled.
-Allowed values: <em>admin</em>, <em>caldav</em>, <em>carddav</em>, <em>domainkey</em>, <em>freebusy</em>, <em>ischedule</em>, <em>rss</em>, <em>tzdist</em>, <em>webdav</em></p>
+Allowed values: <em>admin</em>, <em>caldav</em>, <em>carddav</em>, <em>cgi</em>, <em>domainkey</em>, <em>freebusy</em>, <em>ischedule</em>, <em>jmap</em>, <em>prometheus</em>, <em>rss</em>, <em>tzdist</em>, <em>webdav</em></p>
 </div></blockquote>
 </div></blockquote>
 </div>
@@ -909,6 +936,13 @@ respectively, provided that these plugin
 <li class="toctree-l2"><a class="reference internal" href="http/webdav.html#administration">Administration</a></li>
 </ul>
 </li>
+<li class="toctree-l1"><a class="reference internal" href="http/jmap.html">JMAP</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="http/jmap.html#about-jmap">About JMAP</a></li>
+<li class="toctree-l2"><a class="reference internal" href="http/jmap.html#configuration">Configuration</a></li>
+<li class="toctree-l2"><a class="reference internal" href="http/jmap.html#jmap-clients">JMAP clients</a></li>
+<li class="toctree-l2"><a class="reference internal" href="http/jmap.html#jmap-implementation-status">JMAP implementation status</a></li>
+</ul>
+</li>
 <li class="toctree-l1"><a class="reference internal" href="http/rss.html">RSS Feeds</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="http/rss.html#about-rss-feeds">About RSS Feeds</a></li>
 <li class="toctree-l2"><a class="reference internal" href="http/rss.html#configuration">Configuration</a></li>
@@ -992,7 +1026,7 @@ needs to be customized to your specific
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 29 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1012,7 +1046,7 @@ needs to be customized to your specific
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/mta/configuration.html 3.2.0-3/doc/html/imap/download/installation/mta/configuration.html
--- 3.0.13-5/doc/html/imap/download/installation/mta/configuration.html	2019-12-16 04:16:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/mta/configuration.html	2020-05-04 04:11:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Configuring the MTA &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Configuring the MTA &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Configuring the MTA</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/mta/configuration.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/mta/configuration.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,7 +795,7 @@ how to install and configure it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -796,7 +815,7 @@ how to install and configure it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/installation/virus.html 3.2.0-3/doc/html/imap/download/installation/virus.html
--- 3.0.13-5/doc/html/imap/download/installation/virus.html	2019-12-16 04:16:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/installation/virus.html	2020-05-04 04:11:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Virus Scanner &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Virus Scanner &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Installing Cyrus" href="../../installing.html"/>
-        <link rel="next" title="Upgrading to 3.0" href="../upgrade.html"/>
+        <link rel="next" title="Upgrading to 3.2" href="../upgrade.html"/>
         <link rel="prev" title="RSS Feeds" href="http/rss.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../setup.html">Setup</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/installation/virus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/installation/virus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -805,7 +824,7 @@ the ClamAV libraries.</p>
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../upgrade.html" class="btn btn-neutral float-right" title="Upgrading to 3.0" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="../upgrade.html" class="btn btn-neutral float-right" title="Upgrading to 3.2" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="http/rss.html" class="btn btn-neutral" title="RSS Feeds" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -817,7 +836,7 @@ the ClamAV libraries.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 22 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 22 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@ the ClamAV libraries.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/packagers.html 3.2.0-3/doc/html/imap/download/packagers.html
--- 3.0.13-5/doc/html/imap/download/packagers.html	2019-12-16 04:16:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/packagers.html	2020-05-04 04:11:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Notes for Packagers &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Notes for Packagers &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Download" href="../../download.html"/>
         <link rel="next" title="Quickstart Guide" href="../../quickstart.html"/>
-        <link rel="prev" title="Cyrus IMAP 2.3.20 Release Notes" href="release-notes/2.3/x/2.3.20.html"/> 
+        <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta11 Release Notes" href="release-notes/2.4-dav/x/2.4.17-caldav-beta11.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2 current"><a class="current reference internal" href="#">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../download.html">Download</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/packagers.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/packagers.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -766,6 +785,13 @@
             
   <div class="section" id="notes-for-packagers">
 <h1>Notes for Packagers<a class="headerlink" href="#notes-for-packagers" title="Permalink to this headline">¶</a></h1>
+<div class="section" id="binary-naming">
+<h2>Binary naming<a class="headerlink" href="#binary-naming" title="Permalink to this headline">¶</a></h2>
+<p>Prevent namespace clashes. We suggest renaming all binaries with <code class="docutils literal"><span class="pre">cyr_</span></code> at
+the front, including renaming the <code class="docutils literal"><span class="pre">ctl_*</span></code> to <code class="docutils literal"><span class="pre">cyr_</span></code>.</p>
+<p>The Cyrus team are looking to fix this in the core bundle in upcoming releases
+so packagers have less to do.</p>
+</div>
 <div class="section" id="sample-configuration-files">
 <h2>Sample configuration files<a class="headerlink" href="#sample-configuration-files" title="Permalink to this headline">¶</a></h2>
 <p>There are several samples of <a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> and
@@ -858,53 +884,29 @@ expected.</p>
 </div>
 <div class="section" id="new-default-settings">
 <h4>New default settings<a class="headerlink" href="#new-default-settings" title="Permalink to this headline">¶</a></h4>
-<p>With the introduction of version 3.0, the defaults for some settings
-have changed.  Please consult <a class="reference internal" href="upgrade.html#upgrade"><span class="std std-ref">Upgrading to 3.0</span></a> for details.</p>
+<p>A new stable series means the defaults for some settings may have changed.
+Please consult <a class="reference internal" href="upgrade.html#upgrade"><span class="std std-ref">Upgrading to 3.2</span></a> for details.</p>
 </div>
-<div class="section" id="new-features">
-<h4>New features<a class="headerlink" href="#new-features" title="Permalink to this headline">¶</a></h4>
-<p>There are several features either new to version 3.0, or newly improved.
-Some of these may be features which previously were not considered ripe
-for packaging, but merit new consideration.</p>
-<p>Please see the release notes <a class="reference internal" href="release-notes/3.0/x/3.0.0.html#relnotes-3-0-0-changes"><span class="std std-ref">Major changes since the 2.5.x series</span></a> for more
-details and other recent changes.</p>
-<ul class="simple">
-<li>Conversations<ul>
-<li>Server-side threading with reduced protocol chatter for mobile
-or other high-latency clients.</li>
-<li>See the <code class="docutils literal"><span class="pre">conversations</span></code> options in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a></li>
-</ul>
-</li>
-<li>Xapian<ul>
-<li>Higher quality full-text search support.</li>
-<li>See the <code class="docutils literal"><span class="pre">search_engine</span></code> option in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
-and <code class="docutils literal"><span class="pre">doc/README.xapian</span></code> in the source distribution.</li>
-</ul>
-</li>
-<li>Archive partitions<ul>
-<li>Automatically migrate messages from posh, fast storage (think
-SSD) to cheap, slow storage (spinning rust).</li>
-<li>Requires addition of an archive partition for each data
-partition.</li>
-<li>See <code class="docutils literal"><span class="pre">archive_*</span></code> options in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a></li>
-</ul>
-</li>
-<li>Backup<ul>
-<li>Replication-based backup to dedicated instance with efficient,
-compact scheme.</li>
-<li>See <a class="reference internal" href="../reference/admin/backups.html#cyrus-backups"><span class="std std-ref">Cyrus Backups</span></a></li>
-</ul>
-</li>
-</ul>
-<p>Please consider enabling these features in the <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
-you ship  in your packages.</p>
+<div class="section" id="new-or-improved-features">
+<h4>New or improved features<a class="headerlink" href="#new-or-improved-features" title="Permalink to this headline">¶</a></h4>
+<p>A new stable series means new features, and improvements to existing features.
+Some of these may be features which previously were not considered ripe for
+packaging, but merit new consideration.</p>
+<p>Please see <a class="reference internal" href="release-notes/3.2/index.html#imap-release-notes-3-2"><span class="std std-ref">Cyrus IMAP 3.2 Releases</span></a> for details, and consider enabling
+these features in the <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> you ship in your packages.</p>
 </div>
 </div>
 </div>
 <div class="section" id="services-in-etc-services">
 <h2>Services in <code class="docutils literal"><span class="pre">/etc/services</span></code><a class="headerlink" href="#services-in-etc-services" title="Permalink to this headline">¶</a></h2>
-<p>Listing named services through <code class="docutils literal"><span class="pre">/etc/services</span></code> aids in cross-system consistency and cross-platform interoperability. Furthermore, it enables administrators and users to refer to the service by name (for example in <code class="docutils literal"><span class="pre">/etc/cyrus.conf</span></code>, &#8216;listen=mupdate&#8217; can be specified instead of &#8216;listen=3905&#8217;).</p>
-<p>Some of the services Cyrus IMAP would like to see available through <code class="docutils literal"><span class="pre">/etc/services</span></code> have not been assigned an IANA port number, and few have configuration options.</p>
+<p>Listing named services through <code class="docutils literal"><span class="pre">/etc/services</span></code> aids in cross-system
+consistency and cross-platform interoperability. Furthermore, it enables
+administrators and users to refer to the service by name (for example in
+<code class="docutils literal"><span class="pre">/etc/cyrus.conf</span></code>, &#8216;listen=mupdate&#8217; can be specified instead of
+&#8216;listen=3905&#8217;).</p>
+<p>Some of the services Cyrus IMAP would like to see available through
+<code class="docutils literal"><span class="pre">/etc/services</span></code> have not been assigned an IANA port number, and few have
+configuration options.</p>
 <p>The Cyrus IMAP server provides service interfaces via either TCP/IP
 ports or Unix domain sockets.  For the former, Cyrus requires that there
 are proper entries in the host&#8217;s <code class="docutils literal"><span class="pre">/etc/services</span></code> file.  The following
@@ -937,7 +939,7 @@ are required for any host using the list
         <a href="../../quickstart.html" class="btn btn-neutral float-right" title="Quickstart Guide" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="release-notes/2.3/x/2.3.20.html" class="btn btn-neutral" title="Cyrus IMAP 2.3.20 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="release-notes/2.4-dav/x/2.4.17-caldav-beta11.html" class="btn btn-neutral" title="Cyrus IMAP 2.4.17-caldav-beta11 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -946,7 +948,7 @@ are required for any host using the list
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 24 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 29 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -966,7 +968,7 @@ are required for any host using the list
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/1/1.x.x.html 3.2.0-3/doc/html/imap/download/release-notes/1/1.x.x.html
--- 3.0.13-5/doc/html/imap/download/release-notes/1/1.x.x.html	2019-12-16 04:16:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/1/1.x.x.html	2020-05-04 04:11:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 1.x Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 1.x Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.0.x Release Notes" href="../2.0/2.0.x.html"/>
-        <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta11 Release Notes" href="../2.4-dav/x/2.4.17-caldav-beta11.html"/> 
+        <link rel="prev" title="Cyrus IMAP 3.1.9 Tag Notes" href="../3.1/x/3.1.9.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/1/1.x.x.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/1/1.x.x.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1105,7 +1124,7 @@
         <a href="../2.0/2.0.x.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.0.x Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../2.4-dav/x/2.4.17-caldav-beta11.html" class="btn btn-neutral" title="Cyrus IMAP 2.4.17-caldav-beta11 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../3.1/x/3.1.9.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.9 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -1114,7 +1133,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1134,7 +1153,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.0/2.0.x.html 3.2.0-3/doc/html/imap/download/release-notes/2.0/2.0.x.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.0/2.0.x.html	2019-12-16 04:16:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.0/2.0.x.html	2020-05-04 04:11:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.0.x Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.0.x Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.1.x Release Notes" href="../2.1/2.1.x.html"/>
         <link rel="prev" title="Cyrus IMAP 1.x Release Notes" href="../1/1.x.x.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.0/2.0.x.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.0/2.0.x.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -978,7 +997,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -998,7 +1017,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.1/2.1.x.html 3.2.0-3/doc/html/imap/download/release-notes/2.1/2.1.x.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.1/2.1.x.html	2019-12-16 04:16:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.1/2.1.x.html	2020-05-04 04:11:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.1.x Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.1.x Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.2.x Release Notes" href="../2.2/2.2.x.html"/>
         <link rel="prev" title="Cyrus IMAP 2.0.x Release Notes" href="../2.0/2.0.x.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.1/2.1.x.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.1/2.1.x.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -954,7 +973,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -974,7 +993,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.2/2.2.x.html 3.2.0-3/doc/html/imap/download/release-notes/2.2/2.2.x.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.2/2.2.x.html	2019-12-16 04:16:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.2/2.2.x.html	2020-05-04 04:11:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.2.x Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.2.x Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3 Releases" href="../2.3/index.html"/>
         <link rel="prev" title="Cyrus IMAP 2.1.x Release Notes" href="../2.1/2.1.x.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.2/2.2.x.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.2/2.2.x.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -836,12 +855,12 @@
 <p>Changes to the Cyrus IMAP Server since 2.2.5</p>
 <ul class="simple">
 <li>Fix a bug in the proxy code where a backend connection might get closed twice</li>
-<li>Improved consistency checking in chk_cyrus</li>
+<li>Improved consistancy checking in chk_cyrus</li>
 <li>Fix segfault in APPEND code</li>
 <li>Fix a bug with an interaction between sieve and unixhierarchysep</li>
 <li>Fix a file descriptor leak in the quotadb code</li>
 <li>Fix a triggered assertation in service-thread services</li>
-<li>Add a number of internal consistency checks to the skiplist code</li>
+<li>Add a number of internal consistancy checks to the skiplist code</li>
 <li>Allow mbpath to handle virtual domains</li>
 <li>Fix various MANAGESIEVE client authentication issues</li>
 <li>Other minor fixes</li>
@@ -909,7 +928,7 @@
 </ul>
 <p>Changes to the Cyrus IMAP Server since 2.1.x</p>
 <ul class="simple">
-<li>There have been extensive performance and consistency changes to the configuration subsystem. This will both ensure greater consistency between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:</li>
+<li>There have been extensive performance and consistancy changes to the configuration subsystem. This will both ensure greater consistancy between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:</li>
 <li>The tls_[service]_* configuration options have been removed. Now use [servicename]_tls_*, where servicename is the service identifier from cyrus.conf for that particular process.</li>
 <li>Administrative groups (e.g. admins and lmtp_admins) no longer union, service groups completely override the generic group.</li>
 <li>lmtp_allowplaintext is no longer a defined parameter and must be specified using the service name of your lmtp process if you require a specific value</li>
@@ -945,7 +964,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -965,7 +984,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/index.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/index.html	2019-12-16 04:16:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/index.html	2020-05-04 04:11:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3 Releases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3 Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.0 Release Notes" href="x/2.3.0.html"/>
         <link rel="prev" title="Cyrus IMAP 2.2.x Release Notes" href="../2.2/2.2.x.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.0.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.0.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.0.html	2019-12-16 04:16:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.0.html	2020-05-04 04:11:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.0 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.0 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.1 Release Notes" href="2.3.1.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3 Releases" href="../index.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.0.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.0.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -811,7 +830,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.10.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.10.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.10.html	2019-12-16 04:16:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.10.html	2020-05-04 04:11:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.10 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.10 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.11 Release Notes" href="2.3.11.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.9 Release Notes" href="2.3.9.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.10.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.10.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -807,7 +826,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -827,7 +846,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.11.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.11.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.11.html	2019-12-16 04:16:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.11.html	2020-05-04 04:11:49.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.11 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.11 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.12 Release Notes" href="2.3.12.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.10 Release Notes" href="2.3.10.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.11.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.11.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.12.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.12.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.12.html	2019-12-16 04:16:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.12.html	2020-05-04 04:11:49.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.12 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.12 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.13 Release Notes" href="2.3.13.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.11 Release Notes" href="2.3.11.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.12.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.12.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.13.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.13.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.13.html	2019-12-16 04:16:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.13.html	2020-05-04 04:11:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.13 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.13 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.14 Release Notes" href="2.3.14.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.12 Release Notes" href="2.3.12.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.13.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.13.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.14.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.14.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.14.html	2019-12-16 04:16:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.14.html	2020-05-04 04:11:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.14 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.14 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.15 Release Notes" href="2.3.15.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.13 Release Notes" href="2.3.13.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.14.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.14.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.15.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.15.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.15.html	2019-12-16 04:16:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.15.html	2020-05-04 04:11:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.15 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.15 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.16 Release Notes" href="2.3.16.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.14 Release Notes" href="2.3.14.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.15.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.15.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.16.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.16.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.16.html	2019-12-16 04:16:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.16.html	2020-05-04 04:11:51.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.16 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.16 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.17 Release Notes" href="2.3.17.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.15 Release Notes" href="2.3.15.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.16.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.16.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.17.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.17.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.17.html	2019-12-16 04:16:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.17.html	2020-05-04 04:11:51.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.17 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.17 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.18 Release Notes" href="2.3.18.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.16 Release Notes" href="2.3.16.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.17.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.17.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.18.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.18.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.18.html	2019-12-16 04:16:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.18.html	2020-05-04 04:11:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.18 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.18 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.19 Release Notes" href="2.3.19.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.17 Release Notes" href="2.3.17.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.18.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.18.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -794,7 +813,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -814,7 +833,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.19.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.19.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.19.html	2019-12-16 04:16:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.19.html	2020-05-04 04:11:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.19 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.19 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.20 Release Notes" href="2.3.20.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.18 Release Notes" href="2.3.18.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.19.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.19.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -799,7 +818,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -819,7 +838,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.1.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.1.html	2019-12-16 04:16:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.1.html	2020-05-04 04:11:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.2 Release Notes" href="2.3.2.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.0 Release Notes" href="2.3.0.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,7 +816,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -817,7 +836,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.20.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.20.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.20.html	2019-12-16 04:17:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.20.html	2020-05-04 04:11:53.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.20 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.20 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
-        <link rel="next" title="Notes for Packagers" href="../../../packagers.html"/>
+        <link rel="next" title="Cyrus IMAP 2.4 Releases" href="../../2.4/index.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.19 Release Notes" href="2.3.19.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.20.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.20.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -784,7 +803,7 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../../../packagers.html" class="btn btn-neutral float-right" title="Notes for Packagers" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="../../2.4/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.4 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="2.3.19.html" class="btn btn-neutral" title="Cyrus IMAP 2.3.19 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -796,7 +815,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 08 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.2.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.2.html	2019-12-16 04:16:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.2.html	2020-05-04 04:11:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.3 Release Notes" href="2.3.3.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.1 Release Notes" href="2.3.1.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +843,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.3.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.3.html	2019-12-16 04:17:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.3.html	2020-05-04 04:11:53.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.4 Release Notes" href="2.3.4.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.2 Release Notes" href="2.3.2.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.4.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.4.html	2019-12-16 04:17:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.4.html	2020-05-04 04:11:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.5 Release Notes" href="2.3.5.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.3 Release Notes" href="2.3.3.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.5.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.5.html	2019-12-16 04:17:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.5.html	2020-05-04 04:11:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.6 Release Notes" href="2.3.6.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.4 Release Notes" href="2.3.4.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.6.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.6.html	2019-12-16 04:17:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.6.html	2020-05-04 04:11:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.7 Release Notes" href="2.3.7.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.5 Release Notes" href="2.3.5.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -796,7 +815,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.7.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.7.html	2019-12-16 04:17:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.7.html	2020-05-04 04:11:55.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.7 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.7 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.8 Release Notes" href="2.3.8.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.6 Release Notes" href="2.3.6.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.7.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.7.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,7 +819,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -820,7 +839,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.8.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.8.html	2019-12-16 04:17:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.8.html	2020-05-04 04:11:55.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.8 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.8 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.9 Release Notes" href="2.3.9.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.7 Release Notes" href="2.3.7.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.8.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.8.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -805,7 +824,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -825,7 +844,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.9.html 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.3/x/2.3.9.html	2019-12-16 04:17:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.3/x/2.3.9.html	2020-05-04 04:11:56.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.3.9 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.3.9 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.3 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.3.10 Release Notes" href="2.3.10.html"/>
         <link rel="prev" title="Cyrus IMAP 2.3.8 Release Notes" href="2.3.8.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.3/x/2.3.9.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.3/x/2.3.9.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/index.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/index.html	2019-12-16 04:17:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/index.html	2020-05-04 04:12:01.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4 Releases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4 Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.0 Release Notes" href="x/2.4.0.html"/>
-        <link rel="prev" title="Cyrus IMAP 2.5.14 Release Notes" href="../2.5/x/2.5.14.html"/> 
+        <link rel="prev" title="Cyrus IMAP 2.3.20 Release Notes" href="../2.3/x/2.3.20.html"/> 
 
   
   
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@
         <a href="x/2.4.0.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.4.0 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../2.5/x/2.5.14.html" class="btn btn-neutral" title="Cyrus IMAP 2.5.14 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../2.3/x/2.3.20.html" class="btn btn-neutral" title="Cyrus IMAP 2.3.20 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.0.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.0.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.0.html	2019-12-16 04:17:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.0.html	2020-05-04 04:12:02.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.0 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.0 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.1 Release Notes" href="2.4.1.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4 Releases" href="../index.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.0.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.0.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.10.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.10.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.10.html	2019-12-16 04:17:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.10.html	2020-05-04 04:12:02.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.10 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.10 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.11 Release Notes" href="2.4.11.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.9 Release Notes" href="2.4.9.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.10.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.10.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +843,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.11.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.11.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.11.html	2019-12-16 04:17:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.11.html	2020-05-04 04:12:03.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.11 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.11 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.12 Release Notes" href="2.4.12.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.10 Release Notes" href="2.4.10.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.11.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.11.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.12.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.12.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.12.html	2019-12-16 04:17:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.12.html	2020-05-04 04:12:03.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.12 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.12 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.13 Release Notes" href="2.4.13.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.11 Release Notes" href="2.4.11.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.12.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.12.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -811,7 +830,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.13.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.13.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.13.html	2019-12-16 04:17:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.13.html	2020-05-04 04:12:04.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.13 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.13 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.14 Release Notes" href="2.4.14.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.12 Release Notes" href="2.4.12.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.13.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.13.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -814,7 +833,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +853,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.14.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.14.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.14.html	2019-12-16 04:17:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.14.html	2020-05-04 04:12:04.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.14 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.14 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.15 Release Notes" href="2.4.15.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.13 Release Notes" href="2.4.13.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.14.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.14.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.15.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.15.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.15.html	2019-12-16 04:17:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.15.html	2020-05-04 04:12:05.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.15 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.15 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.16 Release Notes" href="2.4.16.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.14 Release Notes" href="2.4.14.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.15.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.15.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.16.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.16.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.16.html	2019-12-16 04:17:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.16.html	2020-05-04 04:12:05.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.16 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.16 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17 Release Notes" href="2.4.17.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.15 Release Notes" href="2.4.15.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.16.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.16.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.17.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.17.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.17.html	2019-12-16 04:17:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.17.html	2020-05-04 04:12:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.18 Release Notes" href="2.4.18.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.16 Release Notes" href="2.4.16.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.17.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.17.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -810,7 +829,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -830,7 +849,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.18.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.18.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.18.html	2019-12-16 04:17:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.18.html	2020-05-04 04:12:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.18 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.18 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.19 Release Notes" href="2.4.19.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17 Release Notes" href="2.4.17.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.18.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.18.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -824,7 +843,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -844,7 +863,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.19.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.19.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.19.html	2019-12-16 04:17:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.19.html	2020-05-04 04:12:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.19 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.19 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.20 Release Notes" href="2.4.20.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.18 Release Notes" href="2.4.18.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -819,7 +838,7 @@ of previous message set</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 13 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -839,7 +858,7 @@ of previous message set</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.1.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.1.html	2019-12-16 04:17:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.1.html	2020-05-04 04:12:02.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.2 Release Notes" href="2.4.2.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.0 Release Notes" href="2.4.0.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.20.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.20.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.20.html	2019-12-16 04:17:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.20.html	2020-05-04 04:12:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.20 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.20 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4-caldav Releases" href="../../2.4-dav/index.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.19 Release Notes" href="2.4.19.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.20.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.20.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -796,7 +815,7 @@ long for its buffer</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 18 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 18 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@ long for its buffer</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.2.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.2.html	2019-12-16 04:17:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.2.html	2020-05-04 04:12:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.3 Release Notes" href="2.4.3.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.1 Release Notes" href="2.4.1.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.3.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.3.html	2019-12-16 04:17:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.3.html	2020-05-04 04:12:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.4 Release Notes" href="2.4.4.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.2 Release Notes" href="2.4.2.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.4.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.4.html	2019-12-16 04:17:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.4.html	2020-05-04 04:12:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.5 Release Notes" href="2.4.5.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.3 Release Notes" href="2.4.3.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.5.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.5.html	2019-12-16 04:17:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.5.html	2020-05-04 04:12:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.6 Release Notes" href="2.4.6.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.4 Release Notes" href="2.4.4.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -808,7 +827,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -828,7 +847,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.6.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.6.html	2019-12-16 04:17:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.6.html	2020-05-04 04:12:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.7 Release Notes" href="2.4.7.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.5 Release Notes" href="2.4.5.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -803,7 +822,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -823,7 +842,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.7.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.7.html	2019-12-16 04:17:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.7.html	2020-05-04 04:12:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.7 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.7 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.8 Release Notes" href="2.4.8.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.6 Release Notes" href="2.4.6.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.7.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.7.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -823,7 +842,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -843,7 +862,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.8.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.8.html	2019-12-16 04:17:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.8.html	2020-05-04 04:12:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.8 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.8 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.9 Release Notes" href="2.4.9.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.7 Release Notes" href="2.4.7.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.8.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.8.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.9.html 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4/x/2.4.9.html	2019-12-16 04:17:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4/x/2.4.9.html	2020-05-04 04:12:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.9 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.9 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.10 Release Notes" href="2.4.10.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.8 Release Notes" href="2.4.8.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4/x/2.4.9.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4/x/2.4.9.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -816,7 +835,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -836,7 +855,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/index.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/index.html	2019-12-16 04:17:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/index.html	2020-05-04 04:11:56.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4-caldav Releases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4-caldav Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta1 Release Notes" href="x/2.4.17-caldav-beta1.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.20 Release Notes" href="../2.4/x/2.4.20.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -803,7 +822,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -823,7 +842,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html	2019-12-16 04:17:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html	2020-05-04 04:11:57.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta10 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta10 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta11 Release Notes" href="2.4.17-caldav-beta11.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta9 Release Notes" href="2.4.17-caldav-beta9.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,7 +819,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -820,7 +839,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html	2019-12-16 04:17:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html	2020-05-04 04:11:57.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta11 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta11 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 1.x Release Notes" href="../../1/1.x.x.html"/>
+        <link rel="next" title="Notes for Packagers" href="../../../packagers.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta10 Release Notes" href="2.4.17-caldav-beta10.html"/> 
 
   
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -787,7 +806,7 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../../1/1.x.x.html" class="btn btn-neutral float-right" title="Cyrus IMAP 1.x Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="../../../packagers.html" class="btn btn-neutral float-right" title="Notes for Packagers" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="2.4.17-caldav-beta10.html" class="btn btn-neutral" title="Cyrus IMAP 2.4.17-caldav-beta10 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -799,7 +818,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -819,7 +838,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html	2019-12-16 04:17:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html	2020-05-04 04:11:56.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta2 Release Notes" href="2.4.17-caldav-beta2.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html	2019-12-16 04:17:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html	2020-05-04 04:11:58.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta3 Release Notes" href="2.4.17-caldav-beta3.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta1 Release Notes" href="2.4.17-caldav-beta1.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html	2019-12-16 04:17:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html	2020-05-04 04:11:58.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta4 Release Notes" href="2.4.17-caldav-beta4.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta2 Release Notes" href="2.4.17-caldav-beta2.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -796,7 +815,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html	2019-12-16 04:17:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html	2020-05-04 04:11:59.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta5 Release Notes" href="2.4.17-caldav-beta5.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta3 Release Notes" href="2.4.17-caldav-beta3.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -799,7 +818,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -819,7 +838,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html	2019-12-16 04:17:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html	2020-05-04 04:11:59.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta6 Release Notes" href="2.4.17-caldav-beta6.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta4 Release Notes" href="2.4.17-caldav-beta4.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html	2019-12-16 04:17:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html	2020-05-04 04:12:00.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta7 Release Notes" href="2.4.17-caldav-beta7.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta5 Release Notes" href="2.4.17-caldav-beta5.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +843,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html	2019-12-16 04:17:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html	2020-05-04 04:12:00.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta7 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta7 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta8 Release Notes" href="2.4.17-caldav-beta8.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta6 Release Notes" href="2.4.17-caldav-beta6.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -801,7 +820,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -821,7 +840,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html	2019-12-16 04:17:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html	2020-05-04 04:12:00.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta8 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta8 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta9 Release Notes" href="2.4.17-caldav-beta9.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta7 Release Notes" href="2.4.17-caldav-beta7.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -803,7 +822,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -823,7 +842,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html	2019-12-16 04:17:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html	2020-05-04 04:12:01.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.4.17-caldav-beta9 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.4.17-caldav-beta9 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.4-caldav Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.4.17-caldav-beta10 Release Notes" href="2.4.17-caldav-beta10.html"/>
         <link rel="prev" title="Cyrus IMAP 2.4.17-caldav-beta8 Release Notes" href="2.4.17-caldav-beta8.html"/> 
@@ -129,20 +129,25 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,7 +816,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -817,7 +836,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/index.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/index.html	2019-12-16 04:17:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/index.html	2020-05-04 04:12:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5 Releases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5 Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.0 Release Notes" href="x/2.5.0.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0.9 Release Notes" href="../3.0/x/3.0.9.html"/> 
+        <link rel="prev" title="Cyrus IMAP 3.0.13 Release Notes" href="../3.0/x/3.0.13.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -784,7 +803,7 @@
 <li class="toctree-l1"><a class="reference internal" href="x/2.5.11.html">Cyrus IMAP 2.5.11 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/2.5.12.html">Cyrus IMAP 2.5.12 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/2.5.13.html">Cyrus IMAP 2.5.13 Release Notes</a></li>
-<li class="toctree-l1"><a class="reference internal" href="x/2.5.14.html">Cyrus IMAP 2.5.14 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/2.5.15.html">Cyrus IMAP 2.5.15 Release Notes</a></li>
 </ul>
 </div>
 </div>
@@ -798,7 +817,7 @@
         <a href="x/2.5.0.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.5.0 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../3.0/x/3.0.9.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.9 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../3.0/x/3.0.13.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.13 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -807,7 +826,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 18 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 18 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -827,7 +846,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.0.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.0.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.0.html	2019-12-16 04:17:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.0.html	2020-05-04 04:12:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.0 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.0 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.1 Release Notes" href="2.5.1.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5 Releases" href="../index.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -782,18 +801,11 @@
 <li><a class="reference internal" href="#relnotes-2-5-0-development-phabricator"><span class="std std-ref">Development: Switch to Phabricator</span></a></li>
 <li><a class="reference internal" href="#relnotes-2-5-0-development-documentation"><span class="std std-ref">Development: Sphinx for Documentation</span></a></li>
 </ul>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="upgrading-to-cyrus-imap-2-5-0">
@@ -1283,7 +1295,7 @@ Sphinx.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1303,7 +1315,7 @@ Sphinx.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.10.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.10.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.10.html	2019-12-16 04:17:12.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.10.html	2020-05-04 04:12:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.10 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.10 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.11 Release Notes" href="2.5.11.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.9 Release Notes" href="2.5.9.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-9">
@@ -848,7 +860,7 @@ CardDAV has been used</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -868,7 +880,7 @@ CardDAV has been used</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.11.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.11.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.11.html	2019-12-16 04:17:12.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.11.html	2020-05-04 04:12:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.11 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.11 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.12 Release Notes" href="2.5.12.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.10 Release Notes" href="2.5.10.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-10">
@@ -849,7 +861,7 @@ are too short</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 10 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +881,7 @@ are too short</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.12.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.12.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.12.html	2019-12-16 04:17:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.12.html	2020-05-04 04:12:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.12 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.12 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.13 Release Notes" href="2.5.13.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.11 Release Notes" href="2.5.11.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.12.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.12.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -856,7 +875,7 @@ long</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 08 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 08 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -876,7 +895,7 @@ long</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.13.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.13.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.13.html	2019-12-16 04:17:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.13.html	2020-05-04 04:12:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.13 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.13 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 2.5.14 Release Notes" href="2.5.14.html"/>
+        <link rel="next" title="Cyrus IMAP 2.5.15 Release Notes" href="2.5.15.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.12 Release Notes" href="2.5.12.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.13.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.13.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -812,7 +831,7 @@ setting</li>
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="2.5.14.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.5.14 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="2.5.15.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.5.15 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="2.5.12.html" class="btn btn-neutral" title="Cyrus IMAP 2.5.12 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -824,7 +843,7 @@ setting</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 27 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 27 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -844,7 +863,7 @@ setting</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.14.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.14.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.14.html	2019-12-16 04:17:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.14.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,885 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Cyrus IMAP 2.5.14 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../../../../genindex.html"/>
-        <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
-        <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 2.4 Releases" href="../../2.4/index.html"/>
-        <link rel="prev" title="Cyrus IMAP 2.5.13 Release Notes" href="2.5.13.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../../../../index.html">Home</a></li>
-    <li><a href="../../../../../download.html">Download</a></li>
-    <li><a href="../../../../../contribute.html">Contribute</a></li>
-    <li><a href="../../../../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../../../../index.html">
-      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../../../../index.html">
- 
-
-  
-          
-          <img src="../../../../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul class="current">
-<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
-<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
-<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../../../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
-      
-          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
-      
-          <li><a href="../index.html">Cyrus IMAP 2.5 Releases</a> &raquo;</li>
-      
-    <li>Cyrus IMAP 2.5.14 Release Notes</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.14.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="cyrus-imap-2-5-14-release-notes">
-<h1>Cyrus IMAP 2.5.14 Release Notes<a class="headerlink" href="#cyrus-imap-2-5-14-release-notes" title="Permalink to this headline">¶</a></h1>
-<div class="admonition important">
-<p class="first admonition-title">Important</p>
-<p>This is a bug-fix release in the <a class="reference external" href="http://www.cyrusimap.org/stable">stable 2.5 series</a>.</p>
-<p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
-about the 2.5 series, including upgrading instructions.</p>
-</div>
-<p>Download via HTTPS:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz</a></li>
-<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<div class="section" id="changes-since-2-5-13">
-<span id="relnotes-2-5-14-changes"></span><h2>Changes Since 2.5.13<a class="headerlink" href="#changes-since-2-5-13" title="Permalink to this headline">¶</a></h2>
-<div class="section" id="release-changes">
-<h3>Release changes<a class="headerlink" href="#release-changes" title="Permalink to this headline">¶</a></h3>
-<p>We’re trialing using the Github Releases feature. If you have trouble
-downloading this release, please report this to the mailing lists. Thanks!</p>
-</div>
-<div class="section" id="security-fixes">
-<h3>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h3>
-<ul class="simple">
-<li>Fixed CVE-2019-18928: unauthenticated HTTP requests no longer inherit
-authentication from the previous request on the same connection</li>
-</ul>
-</div>
-<div class="section" id="build-changes">
-<h3>Build changes<a class="headerlink" href="#build-changes" title="Permalink to this headline">¶</a></h3>
-<ul class="simple">
-<li>Can now build against ClamAV &gt;= 0.101 (thanks Christoph Moench-Tegeder)</li>
-</ul>
-</div>
-<div class="section" id="bug-fixes">
-<h3>Bug fixes<a class="headerlink" href="#bug-fixes" title="Permalink to this headline">¶</a></h3>
-<ul class="simple">
-<li>Fixed <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2877">Issue #2877</a>: <cite>quota -f</cite> now works correctly with <cite>improved_mboxlist_sort: no</cite></li>
-<li>Fixed <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2808">Issue #2808</a>: UNDUMP no longer crashes when quota needs updating</li>
-</ul>
-</div>
-</div>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="../../2.4/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.4 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="2.5.13.html" class="btn btn-neutral" title="Cyrus IMAP 2.5.13 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Nov 15 2019
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.15.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.15.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.15.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.15.html	2020-05-04 04:12:13.000000000 +0000
@@ -0,0 +1,914 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 2.5.15 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1 Tags" href="../../3.1/index.html"/>
+        <link rel="prev" title="Cyrus IMAP 2.5.13 Release Notes" href="2.5.13.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 2.5 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 2.5.15 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.15.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-2-5-15-release-notes">
+<h1>Cyrus IMAP 2.5.15 Release Notes<a class="headerlink" href="#cyrus-imap-2-5-15-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition important">
+<p class="first admonition-title">Important</p>
+<p>This is a bug-fix release in the <a class="reference external" href="http://www.cyrusimap.org/stable">stable 2.5 series</a>.</p>
+<p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
+about the 2.5 series, including upgrading instructions.</p>
+</div>
+<p>Download via HTTPS:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="changes-since-2-5-14">
+<span id="relnotes-2-5-15-changes"></span><h2>Changes Since 2.5.14<a class="headerlink" href="#changes-since-2-5-14" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="release-changes">
+<h3>Release changes<a class="headerlink" href="#release-changes" title="Permalink to this headline">¶</a></h3>
+<p>We’re trialing using the Github Releases feature. If you have trouble
+downloading this release, please report this to the mailing lists. Thanks!</p>
+</div>
+<div class="section" id="security-fixes">
+<h3>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h3>
+<ul>
+<li><p class="first">Fixed <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a>: When creating a missing mailbox as part of a sieve
+&#8216;fileinto&#8217; directive, lmtpd would create it as administrator, bypassing ACL
+checks.</p>
+<p>lmtpd creates missing mailboxes as part of a sieve &#8216;fileinto&#8217;
+directive if:</p>
+<ul class="simple">
+<li>(2.5+) the <cite>anysievefolder</cite> option is enabled (default: not), or</li>
+<li>(3.0+) the <cite>sieve_extensions</cite> option has the &#8216;mailbox&#8217; extension enabled
+(default: enabled) and the &#8216;fileinto&#8217; directive contains the &#8221;:create&#8221;
+argument</li>
+</ul>
+<p>Under these conditions, a user with the ability to upload a custom sieve
+script to their account could use it to create any valid mailbox on the
+server (with ACL inherited from the parent mailbox as usual).</p>
+<p>lmtpd no longer creates these mailboxes as administrator, so users may no
+longer use a &#8216;fileinto&#8217; directive to create a mailbox they couldn&#8217;t create
+otherwise.</p>
+</li>
+</ul>
+</div>
+<div class="section" id="bug-fixes">
+<h3>Bug fixes<a class="headerlink" href="#bug-fixes" title="Permalink to this headline">¶</a></h3>
+<ul class="simple">
+<li>Fixed <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2913">Issue #2913</a>: errors are now logged when <cite>maxlogins_per_host</cite>,
+<cite>maxlogins_per_user</cite>, and <cite>popminpoll</cite> limits are reached (thanks Sergey)</li>
+</ul>
+</div>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../../3.1/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1 Tags" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="2.5.13.html" class="btn btn-neutral" title="Cyrus IMAP 2.5.13 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 16 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.1.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.1.html	2019-12-16 04:17:12.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.1.html	2020-05-04 04:12:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.2 Release Notes" href="2.5.2.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.0 Release Notes" href="2.5.0.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-0">
@@ -852,7 +864,7 @@ about the 2.5 series, including upgradin
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -872,7 +884,7 @@ about the 2.5 series, including upgradin
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.2.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.2.html	2019-12-16 04:17:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.2.html	2020-05-04 04:12:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.3 Release Notes" href="2.5.3.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.1 Release Notes" href="2.5.1.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-1">
@@ -824,7 +836,7 @@ about the 2.5 series, including upgradin
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -844,7 +856,7 @@ about the 2.5 series, including upgradin
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.3.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.3.html	2019-12-16 04:17:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.3.html	2020-05-04 04:12:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.4 Release Notes" href="2.5.4.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.2 Release Notes" href="2.5.2.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-2">
@@ -819,7 +831,7 @@ about the 2.5 series, including upgradin
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -839,7 +851,7 @@ about the 2.5 series, including upgradin
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.4.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.4.html	2019-12-16 04:17:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.4.html	2020-05-04 04:12:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.5 Release Notes" href="2.5.5.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.3 Release Notes" href="2.5.3.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-3">
@@ -822,7 +834,7 @@ about the 2.5 series, including upgradin
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -842,7 +854,7 @@ about the 2.5 series, including upgradin
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.5.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.5.html	2019-12-16 04:17:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.5.html	2020-05-04 04:12:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.6 Release Notes" href="2.5.6.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.4 Release Notes" href="2.5.4.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz.sig">http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-4">
@@ -823,7 +835,7 @@ mailbox creation</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -843,7 +855,7 @@ mailbox creation</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.6.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.6.html	2019-12-16 04:17:15.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.6.html	2020-05-04 04:12:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.7 Release Notes" href="2.5.7.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.5 Release Notes" href="2.5.5.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-5">
@@ -839,7 +851,7 @@ authentications, not just plain ones (th
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -859,7 +871,7 @@ authentications, not just plain ones (th
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.7.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.7.html	2019-12-16 04:17:15.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.7.html	2020-05-04 04:12:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.7 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.7 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.8 Release Notes" href="2.5.8.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.6 Release Notes" href="2.5.6.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-6">
@@ -864,7 +876,7 @@ Surý for collating and sending them ups
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -884,7 +896,7 @@ Surý for collating and sending them ups
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.8.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.8.html	2019-12-16 04:17:15.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.8.html	2020-05-04 04:12:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.8 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.8 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.9 Release Notes" href="2.5.9.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.7 Release Notes" href="2.5.7.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-7">
@@ -849,7 +861,7 @@ mupdate fails during mailbox rename</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +881,7 @@ mupdate fails during mailbox rename</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.9.html 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/2.5/x/2.5.9.html	2019-12-16 04:17:16.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/2.5/x/2.5.9.html	2020-05-04 04:12:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 2.5.9 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 2.5.9 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 2.5 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 2.5.10 Release Notes" href="2.5.10.html"/>
         <link rel="prev" title="Cyrus IMAP 2.5.8 Release Notes" href="2.5.8.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
 about the 2.5 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-2-5-8">
@@ -838,7 +850,7 @@ CalDAV has been used</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -858,7 +870,7 @@ CalDAV has been used</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/index.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/index.html	2019-12-16 04:17:16.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/index.html	2020-05-04 04:12:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0 Releases &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0 Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Release Notes" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0.0 Release Notes" href="x/3.0.0.html"/>
-        <link rel="prev" title="Release Notes" href="../index.html"/> 
+        <link rel="next" title="Cyrus IMAP 3.0.0 beta1 Release Notes" href="x/3.0.0-beta1.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0 Release Notes" href="../3.2/x/3.2.0.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../download.html">Download</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -770,7 +789,6 @@
 <span id="imap-release-notes-3-0"></span><h1>Cyrus IMAP 3.0 Releases<a class="headerlink" href="#cyrus-imap-3-0-releases" title="Permalink to this headline">¶</a></h1>
 <div class="toctree-wrapper compound">
 <ul>
-<li class="toctree-l1"><a class="reference internal" href="x/3.0.0.html">Cyrus IMAP 3.0.0 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-beta1.html">Cyrus IMAP 3.0.0 beta1 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-beta2.html">Cyrus IMAP 3.0.0 beta2 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-beta3.html">Cyrus IMAP 3.0.0 beta3 Release Notes</a></li>
@@ -781,11 +799,8 @@
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-rc2.html">Cyrus IMAP 3.0.0 rc2 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-rc3.html">Cyrus IMAP 3.0.0 rc3 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.0-rc4.html">Cyrus IMAP 3.0.0 rc4 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.0.0.html">Cyrus IMAP 3.0.0 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.1.html">Cyrus IMAP 3.0.1 Release Notes</a></li>
-<li class="toctree-l1"><a class="reference internal" href="x/3.0.10.html">Cyrus IMAP 3.0.10 Release Notes</a></li>
-<li class="toctree-l1"><a class="reference internal" href="x/3.0.11.html">Cyrus IMAP 3.0.11 Release Notes</a></li>
-<li class="toctree-l1"><a class="reference internal" href="x/3.0.12.html">Cyrus IMAP 3.0.12 Release Notes</a></li>
-<li class="toctree-l1"><a class="reference internal" href="x/3.0.13.html">Cyrus IMAP 3.0.13 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.2.html">Cyrus IMAP 3.0.2 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.3.html">Cyrus IMAP 3.0.3 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.4.html">Cyrus IMAP 3.0.4 Release Notes</a></li>
@@ -794,6 +809,10 @@
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.7.html">Cyrus IMAP 3.0.7 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.8.html">Cyrus IMAP 3.0.8 Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="x/3.0.9.html">Cyrus IMAP 3.0.9 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.0.10.html">Cyrus IMAP 3.0.10 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.0.11.html">Cyrus IMAP 3.0.11 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.0.12.html">Cyrus IMAP 3.0.12 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.0.13.html">Cyrus IMAP 3.0.13 Release Notes</a></li>
 </ul>
 </div>
 </div>
@@ -804,10 +823,10 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="x/3.0.0.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.0 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="x/3.0.0-beta1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.0 beta1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../index.html" class="btn btn-neutral" title="Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../3.2/x/3.2.0.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -816,7 +835,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -836,7 +855,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta1.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta1.html	2019-12-16 04:17:17.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta1.html	2020-05-04 04:12:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 beta2 Release Notes" href="3.0.0-beta2.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0.0 Release Notes" href="3.0.0.html"/> 
+        <link rel="prev" title="Cyrus IMAP 3.0 Releases" href="../index.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes">
@@ -846,7 +858,7 @@ database containing the &#8220;next&#822
         <a href="3.0.0-beta2.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.0 beta2 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="3.0.0.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.0 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="../index.html" class="btn btn-neutral" title="Cyrus IMAP 3.0 Releases" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -855,7 +867,7 @@ database containing the &#8220;next&#822
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -875,7 +887,7 @@ database containing the &#8220;next&#822
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta2.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta2.html	2019-12-16 04:17:17.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta2.html	2020-05-04 04:12:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 beta3 Release Notes" href="3.0.0-beta3.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta1 Release Notes" href="3.0.0-beta1.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -905,7 +917,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -925,7 +937,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta3.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta3.html	2019-12-16 04:17:17.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta3.html	2020-05-04 04:12:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 beta4 Release Notes" href="3.0.0-beta4.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta2 Release Notes" href="3.0.0-beta2.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -917,7 +929,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -937,7 +949,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta4.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta4.html	2019-12-16 04:17:18.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta4.html	2020-05-04 04:12:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 beta5 Release Notes" href="3.0.0-beta5.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta3 Release Notes" href="3.0.0-beta3.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -925,7 +937,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -945,7 +957,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta5.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta5.html	2019-12-16 04:17:18.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta5.html	2020-05-04 04:12:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 beta6 Release Notes" href="3.0.0-beta6.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta4 Release Notes" href="3.0.0-beta4.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -931,7 +943,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -951,7 +963,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta6.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta6.html	2019-12-16 04:17:18.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-beta6.html	2020-05-04 04:12:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 beta6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 beta6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 rc1 Release Notes" href="3.0.0-rc1.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta5 Release Notes" href="3.0.0-beta5.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -933,7 +945,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -953,7 +965,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0.html	2019-12-16 04:17:16.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0.html	2020-05-04 04:12:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0.0 beta1 Release Notes" href="3.0.0-beta1.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0 Releases" href="../index.html"/> 
+        <link rel="next" title="Cyrus IMAP 3.0.1 Release Notes" href="3.0.1.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.0.0 rc4 Release Notes" href="3.0.0-rc4.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -770,18 +789,11 @@
             
   <div class="section" id="cyrus-imap-3-0-0-release-notes">
 <h1>Cyrus IMAP 3.0.0 Release Notes<a class="headerlink" href="#cyrus-imap-3-0-0-release-notes" title="Permalink to this headline">¶</a></h1>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -920,10 +932,10 @@ complains if this isn&#8217;t allowed.</
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="3.0.0-beta1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.0 beta1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="3.0.1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="../index.html" class="btn btn-neutral" title="Cyrus IMAP 3.0 Releases" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="3.0.0-rc4.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.0 rc4 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -932,7 +944,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 15 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -952,7 +964,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc1.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc1.html	2019-12-16 04:17:19.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc1.html	2020-05-04 04:12:20.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 rc1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 rc1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 rc2 Release Notes" href="3.0.0-rc2.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 beta6 Release Notes" href="3.0.0-beta6.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -937,7 +949,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -957,7 +969,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc2.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc2.html	2019-12-16 04:17:19.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc2.html	2020-05-04 04:12:20.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 rc2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 rc2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 rc3 Release Notes" href="3.0.0-rc3.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 rc1 Release Notes" href="3.0.0-rc1.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -937,7 +949,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -957,7 +969,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc3.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc3.html	2019-12-16 04:17:19.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc3.html	2020-05-04 04:12:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 rc3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 rc3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.0 rc4 Release Notes" href="3.0.0-rc4.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 rc2 Release Notes" href="3.0.0-rc2.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -937,7 +949,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -957,7 +969,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc4.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc4.html	2019-12-16 04:17:20.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.0-rc4.html	2020-05-04 04:12:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.0 rc4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.0 rc4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0.1 Release Notes" href="3.0.1.html"/>
+        <link rel="next" title="Cyrus IMAP 3.0.0 Release Notes" href="3.0.0.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.0 rc3 Release Notes" href="3.0.0-rc3.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,18 +794,11 @@
 <p>Cyrus IMAP 3.0 is under active development, and subject to change.</p>
 <p class="last">Do <strong>NOT</strong> use this version unless you&#8217;re a developer of sorts.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="major-changes-since-the-2-5-x-series">
@@ -925,7 +937,7 @@ complains if this isn&#8217;t allowed.</
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="3.0.1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="3.0.0.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.0 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="3.0.0-rc3.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.0 rc3 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -937,7 +949,7 @@ complains if this isn&#8217;t allowed.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -957,7 +969,7 @@ complains if this isn&#8217;t allowed.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.10.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.10.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.10.html	2019-12-16 04:17:20.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.10.html	2020-05-04 04:12:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.10 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.10 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.11 Release Notes" href="3.0.11.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0.1 Release Notes" href="3.0.1.html"/> 
+        <link rel="prev" title="Cyrus IMAP 3.0.9 Release Notes" href="3.0.9.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.10.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.10.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -823,7 +842,7 @@ non-breaking space characters the same a
         <a href="3.0.11.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.11 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="3.0.1.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.1 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="3.0.9.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.9 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -832,7 +851,7 @@ non-breaking space characters the same a
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 18 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 18 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -852,7 +871,7 @@ non-breaking space characters the same a
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.11.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.11.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.11.html	2019-12-16 04:17:21.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.11.html	2020-05-04 04:12:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.11 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.11 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.12 Release Notes" href="3.0.12.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.10 Release Notes" href="3.0.10.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.11.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.11.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -855,7 +874,7 @@ nonexistent mailbox (thanks Дилян 
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 01 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 01 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -875,7 +894,7 @@ nonexistent mailbox (thanks Дилян 
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.12.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.12.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.12.html	2019-12-16 04:17:21.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.12.html	2020-05-04 04:12:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.12 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.12 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.13 Release Notes" href="3.0.13.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.11 Release Notes" href="3.0.11.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.12.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.12.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -849,7 +868,7 @@ Cache-Control: private header</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 18 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 18 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +888,7 @@ Cache-Control: private header</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.13.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.13.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.13.html	2019-12-16 04:17:21.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.13.html	2020-05-04 04:12:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.13 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.13 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0.2 Release Notes" href="3.0.2.html"/>
+        <link rel="next" title="Cyrus IMAP 2.5 Releases" href="../../2.5/index.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.12 Release Notes" href="3.0.12.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.13.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.13.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -844,7 +863,7 @@ locale in effect during compilation (tha
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="3.0.2.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.2 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="../../2.5/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.5 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="3.0.12.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.12 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -856,7 +875,7 @@ locale in effect during compilation (tha
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 16 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 16 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -876,7 +895,7 @@ locale in effect during compilation (tha
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.1.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.1.html	2019-12-16 04:17:20.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.1.html	2020-05-04 04:12:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.1 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0.10 Release Notes" href="3.0.10.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0.0 rc4 Release Notes" href="3.0.0-rc4.html"/> 
+        <link rel="next" title="Cyrus IMAP 3.0.2 Release Notes" href="3.0.2.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.0.0 Release Notes" href="3.0.0.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-0">
@@ -833,10 +845,10 @@ a dot (thanks Martin Matuska)</li>
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="3.0.10.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.10 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="3.0.2.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.2 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="3.0.0-rc4.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.0 rc4 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="3.0.0.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.0 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -845,7 +857,7 @@ a dot (thanks Martin Matuska)</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -865,7 +877,7 @@ a dot (thanks Martin Matuska)</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.2.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.2.html	2019-12-16 04:17:21.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.2.html	2020-05-04 04:12:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.2 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.3 Release Notes" href="3.0.3.html"/>
-        <link rel="prev" title="Cyrus IMAP 3.0.13 Release Notes" href="3.0.13.html"/> 
+        <link rel="prev" title="Cyrus IMAP 3.0.1 Release Notes" href="3.0.1.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -777,18 +796,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-1">
@@ -848,7 +860,7 @@ platforms (thanks Jason Tibbitts)</li>
         <a href="3.0.3.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.3 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="3.0.13.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.13 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="3.0.1.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.1 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -857,7 +869,7 @@ platforms (thanks Jason Tibbitts)</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 22 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -877,7 +889,7 @@ platforms (thanks Jason Tibbitts)</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.3.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.3.html	2019-12-16 04:17:22.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.3.html	2020-05-04 04:12:24.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.3 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.4 Release Notes" href="3.0.4.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.2 Release Notes" href="3.0.2.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-2">
@@ -857,7 +869,7 @@ of the 3.0 series.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -877,7 +889,7 @@ of the 3.0 series.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.4.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.4.html	2019-12-16 04:17:22.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.4.html	2020-05-04 04:12:24.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.4 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.5 Release Notes" href="3.0.5.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.3 Release Notes" href="3.0.3.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-3">
@@ -828,7 +840,7 @@ about the 3.0 series, including upgradin
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -848,7 +860,7 @@ about the 3.0 series, including upgradin
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.5.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.5.html	2019-12-16 04:17:22.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.5.html	2020-05-04 04:12:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.5 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.5 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.6 Release Notes" href="3.0.6.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.4 Release Notes" href="3.0.4.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-4">
@@ -835,7 +847,7 @@ correctly (thanks Jonathan Kamens)</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 03 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -855,7 +867,7 @@ correctly (thanks Jonathan Kamens)</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.6.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.6.html	2019-12-16 04:17:23.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.6.html	2020-05-04 04:12:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.6 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.6 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.7 Release Notes" href="3.0.7.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.5 Release Notes" href="3.0.5.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTP:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz</a></li>
-<li><a class="reference external" href="http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz.sig">http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-5">
@@ -860,7 +872,7 @@ environments.</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 21 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -880,7 +892,7 @@ environments.</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.7.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.7.html	2019-12-16 04:17:23.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.7.html	2020-05-04 04:12:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.7 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.7 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.8 Release Notes" href="3.0.8.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.6 Release Notes" href="3.0.6.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,18 +795,11 @@
 <p class="last">Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
 about the 3.0 series, including upgrading instructions.</p>
 </div>
-<p>Download via HTTPS:</p>
-<blockquote>
-<div><ul class="simple">
-<li><a class="reference external" href="https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz">https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz</a></li>
-<li><a class="reference external" href="https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz.sig">https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz.sig</a></li>
-</ul>
-</div></blockquote>
-<p>Download via FTP:</p>
+<p>Download from GitHub:</p>
 <blockquote>
 <div><ul class="simple">
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz</a></li>
-<li><a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz.sig">ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz.sig</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz.sig</a></li>
 </ul>
 </div></blockquote>
 <div class="section" id="changes-since-3-0-6">
@@ -824,7 +836,7 @@ Xapian.</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 15 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -844,7 +856,7 @@ Xapian.</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.8.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.8.html	2019-12-16 04:17:23.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.8.html	2020-05-04 04:12:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.8 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.8 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
         <link rel="next" title="Cyrus IMAP 3.0.9 Release Notes" href="3.0.9.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.7 Release Notes" href="3.0.7.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.8.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.8.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -838,7 +857,7 @@ no longer so crashy</li>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 10 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 10 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -858,7 +877,7 @@ no longer so crashy</li>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.9.html 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.0/x/3.0.9.html	2019-12-16 04:17:23.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.0/x/3.0.9.html	2020-05-04 04:12:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus IMAP 3.0.9 Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus IMAP 3.0.9 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
         <link rel="up" title="Cyrus IMAP 3.0 Releases" href="../index.html"/>
-        <link rel="next" title="Cyrus IMAP 2.5 Releases" href="../../2.5/index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.0.10 Release Notes" href="3.0.10.html"/>
         <link rel="prev" title="Cyrus IMAP 3.0.8 Release Notes" href="3.0.8.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
 <li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../../download.html">Download</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/3.0/x/3.0.9.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.0/x/3.0.9.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -841,7 +860,7 @@ UTF words (thanks Дилян Палау
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../../2.5/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 2.5 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="3.0.10.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0.10 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="3.0.8.html" class="btn btn-neutral" title="Cyrus IMAP 3.0.8 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -853,7 +872,7 @@ UTF words (thanks Дилян Палау
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 26 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -873,7 +892,7 @@ UTF words (thanks Дилян Палау
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/index.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/index.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/index.html	2020-05-04 04:12:27.000000000 +0000
@@ -0,0 +1,882 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1 Tags &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
+        <link rel="up" title="Release Notes" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.0-dev Release Notes" href="x/3.1.0-dev.html"/>
+        <link rel="prev" title="Cyrus IMAP 2.5.15 Release Notes" href="../2.5/x/2.5.15.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../index.html">Home</a></li>
+    <li><a href="../../../../download.html">Download</a></li>
+    <li><a href="../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../index.html">
+      <img src="../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../index.html">Release Notes</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1 Tags</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/index.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-tags">
+<span id="imap-release-notes-3-1"></span><h1>Cyrus IMAP 3.1 Tags<a class="headerlink" href="#cyrus-imap-3-1-tags" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">The 3.1 series are tagged snapshots of the master branch, and should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.0-dev.html">Cyrus IMAP 3.1.0-dev Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.1.html">Cyrus IMAP 3.1.1 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.2.html">Cyrus IMAP 3.1.2 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.3.html">Cyrus IMAP 3.1.3 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.4.html">Cyrus IMAP 3.1.4 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.5.html">Cyrus IMAP 3.1.5 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.6.html">Cyrus IMAP 3.1.6 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.7.html">Cyrus IMAP 3.1.7 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.8.html">Cyrus IMAP 3.1.8 Tag Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.1.9.html">Cyrus IMAP 3.1.9 Tag Notes</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="x/3.1.0-dev.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.0-dev Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../2.5/x/2.5.15.html" class="btn btn-neutral" title="Cyrus IMAP 2.5.15 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.0-dev.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.0-dev.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.0-dev.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.0-dev.html	2020-05-04 04:12:27.000000000 +0000
@@ -0,0 +1,889 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.0-dev Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.1 Tag Notes" href="3.1.1.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1 Tags" href="../index.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.0-dev Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.0-dev.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-0-dev-release-notes">
+<h1>Cyrus IMAP 3.1.0-dev Release Notes<a class="headerlink" href="#cyrus-imap-3-1-0-dev-release-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-0-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The per-user calendar and addressbook administrative web user
+interfaces (e.g. /dav/calendars/user/&lt;userid&gt;) are now disabled by
+default.  They can be enabled with the <cite>caldav_allowcalendaradmin</cite>
+and <cite>carddav_allowaddressbookadmin</cite> options respectively.</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.1 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../index.html" class="btn btn-neutral" title="Cyrus IMAP 3.1 Tags" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 24 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.1.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.1.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.1.html	2020-05-04 04:12:27.000000000 +0000
@@ -0,0 +1,900 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.1 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.2 Tag Notes" href="3.1.2.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.0-dev Release Notes" href="3.1.0-dev.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.1 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.1.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-1-tag-notes">
+<h1>Cyrus IMAP 3.1.1 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-1-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-1-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.2.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.2 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.0-dev.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.0-dev Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.2.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.2.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.2.html	2020-05-04 04:12:28.000000000 +0000
@@ -0,0 +1,908 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.2 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.3 Tag Notes" href="3.1.3.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.1 Tag Notes" href="3.1.1.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.2 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.2.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-2-tag-notes">
+<h1>Cyrus IMAP 3.1.2 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-2-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-2-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li></li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for CVE-2017-14230.
+[ <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230</a> ]</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.3.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.3 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.1.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.1 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 27 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.3.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.3.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.3.html	2020-05-04 04:12:28.000000000 +0000
@@ -0,0 +1,908 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.3 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.4 Tag Notes" href="3.1.4.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.2 Tag Notes" href="3.1.2.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.3 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.3.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-3-tag-notes">
+<h1>Cyrus IMAP 3.1.3 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-3-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-3-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li></li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for CVE-2017-14230.
+[ <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230</a> ]</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.4.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.4 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.2.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.2 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Nov 03 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.4.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.4.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.4.html	2020-05-04 04:12:29.000000000 +0000
@@ -0,0 +1,910 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.4 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.5 Tag Notes" href="3.1.5.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.3 Tag Notes" href="3.1.3.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.4 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.4.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-4-tag-notes">
+<h1>Cyrus IMAP 3.1.4 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-4-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-4-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Support for the Sphinx backend to squatter searches has been removed.</li>
+<li>new cyrus.index format v14 included in 3.1.4 - adds unseen count to index header</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li></li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for CVE-2017-14230.
+[ <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230</a> ]</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.5.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.5 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.3.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.3 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 19 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.5.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.5.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.5.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.5.html	2020-05-04 04:12:29.000000000 +0000
@@ -0,0 +1,910 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.5 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.6 Tag Notes" href="3.1.6.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.4 Tag Notes" href="3.1.4.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.5 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.5.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-5-tag-notes">
+<h1>Cyrus IMAP 3.1.5 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-5-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-5-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Support for the Sphinx backend to squatter searches has been removed.</li>
+<li>new cyrus.index format v16 included in 3.1.5 - adds unseen count and createdmodseq to index header, savedate and createdmodseq to index records</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li></li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for CVE-2017-14230.
+[ <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230</a> ]</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.6.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.6 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.4.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.4 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 15 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.6.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.6.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.6.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.6.html	2020-05-04 04:12:30.000000000 +0000
@@ -0,0 +1,920 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.6 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.7 Tag Notes" href="3.1.7.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.5 Tag Notes" href="3.1.5.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.6 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.6.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-6-tag-notes">
+<h1>Cyrus IMAP 3.1.6 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-6-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-6-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>JMAP improvements.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Support for the Sphinx backend to squatter searches has been removed.</li>
+<li>new cyrus.index format v16 included in 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this.</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for CVE-2017-14230.
+[ <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230</a> ]</li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.7.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.7 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.5.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.5 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Nov 27 2018
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.7.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.7.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.7.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.7.html	2020-05-04 04:12:30.000000000 +0000
@@ -0,0 +1,928 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.7 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.8 Tag Notes" href="3.1.8.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.6 Tag Notes" href="3.1.6.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.7 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.7.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-7-tag-notes">
+<h1>Cyrus IMAP 3.1.7 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-7-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-7-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>Support for JMAP.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Removed support for the Sphinx backend to squatter searches.</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this.</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.8.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.8 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.6.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.6 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 04 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.8.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.8.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.8.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.8.html	2020-05-04 04:12:30.000000000 +0000
@@ -0,0 +1,938 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.8 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.1.9 Tag Notes" href="3.1.9.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.7 Tag Notes" href="3.1.7.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.8 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.8.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-8-tag-notes">
+<h1>Cyrus IMAP 3.1.8 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-8-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-8-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>Support for JMAP.</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Removed support for the Sphinx backend to squatter searches.</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this.</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units.</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.1.9.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.1.9 Tag Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.7.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.7 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 09 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.9.html 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.9.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.1/x/3.1.9.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.1/x/3.1.9.html	2020-05-04 04:12:31.000000000 +0000
@@ -0,0 +1,947 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.1.9 Tag Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.1 Tags" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 1.x Release Notes" href="../../1/1.x.x.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.1.8 Tag Notes" href="3.1.8.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.1 Tags</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.1.9 Tag Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.1/x/3.1.9.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-1-9-tag-notes">
+<h1>Cyrus IMAP 3.1.9 Tag Notes<a class="headerlink" href="#cyrus-imap-3-1-9-tag-notes" title="Permalink to this headline">¶</a></h1>
+<p>Unavailable for download as this is a development branch only.</p>
+<p>Access is via git.</p>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This should be considered for
+<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
+snapshots at coherent development points, but there will generally be <strong>large
+breaking changes</strong> occurring between releases in this series.</p>
+</div>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-1-9-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features.</li>
+<li>Caldav and Carddav improvements.</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>).</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>).</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>).</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>).</li>
+<li>Xapian bug fixes.</li>
+<li>Improvements to Annotations handling.</li>
+<li>DRAC support has been deprecated.</li>
+<li>Support for Prometheus stats.</li>
+<li>Removed support for the Sphinx backend to squatter searches.</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this.</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units.</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames).</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../../1/1.x.x.html" class="btn btn-neutral float-right" title="Cyrus IMAP 1.x Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.1.8.html" class="btn btn-neutral" title="Cyrus IMAP 3.1.8 Tag Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 18 2019
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/index.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/index.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/index.html	2020-05-04 04:12:31.000000000 +0000
@@ -0,0 +1,871 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2 Releases &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
+        <link rel="up" title="Release Notes" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0-beta1 Release Notes" href="x/3.2.0-beta1.html"/>
+        <link rel="prev" title="Release Notes" href="../index.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../index.html">Home</a></li>
+    <li><a href="../../../../download.html">Download</a></li>
+    <li><a href="../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../index.html">
+      <img src="../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../index.html">Release Notes</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2 Releases</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/index.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-releases">
+<span id="imap-release-notes-3-2"></span><h1>Cyrus IMAP 3.2 Releases<a class="headerlink" href="#cyrus-imap-3-2-releases" title="Permalink to this headline">¶</a></h1>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0-beta1.html">Cyrus IMAP 3.2.0-beta1 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0-beta2.html">Cyrus IMAP 3.2.0-beta2 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0-beta3.html">Cyrus IMAP 3.2.0-beta3 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0-beta4.html">Cyrus IMAP 3.2.0-beta4 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0-rc1.html">Cyrus IMAP 3.2.0-rc1 Release Notes</a></li>
+<li class="toctree-l1"><a class="reference internal" href="x/3.2.0.html">Cyrus IMAP 3.2.0 Release Notes</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="x/3.2.0-beta1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0-beta1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../index.html" class="btn btn-neutral" title="Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 10 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta1.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta1.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta1.html	2020-05-04 04:12:32.000000000 +0000
@@ -0,0 +1,968 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0-beta1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0-beta2 Release Notes" href="3.2.0-beta2.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2 Releases" href="../index.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0-beta1 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta1.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-beta1-release-notes">
+<h1>Cyrus IMAP 3.2.0-beta1 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-beta1-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This is a beta release and may contain fun bugs.  Testing it
+out and providing feedback would be greatly appreciated, but do
+not run this on your production mail stores!</p>
+</div>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-beta1-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.2.0-beta2.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0-beta2 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="../index.html" class="btn btn-neutral" title="Cyrus IMAP 3.2 Releases" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta2.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta2.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta2.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta2.html	2020-05-04 04:12:32.000000000 +0000
@@ -0,0 +1,968 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0-beta2 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0-beta3 Release Notes" href="3.2.0-beta3.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0-beta1 Release Notes" href="3.2.0-beta1.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0-beta2 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta2.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-beta2-release-notes">
+<h1>Cyrus IMAP 3.2.0-beta2 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-beta2-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This is a beta release and may contain fun bugs.  Testing it
+out and providing feedback would be greatly appreciated, but do
+not run this on your production mail stores!</p>
+</div>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-beta2-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.2.0-beta3.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0-beta3 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.2.0-beta1.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0-beta1 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta3.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta3.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta3.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta3.html	2020-05-04 04:12:32.000000000 +0000
@@ -0,0 +1,978 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0-beta3 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0-beta4 Release Notes" href="3.2.0-beta4.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0-beta2 Release Notes" href="3.2.0-beta2.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0-beta3 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta3.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-beta3-release-notes">
+<h1>Cyrus IMAP 3.2.0-beta3 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-beta3-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This is a beta release and may contain fun bugs.  Testing it
+out and providing feedback would be greatly appreciated, but do
+not run this on your production mail stores!</p>
+</div>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-beta3-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Replication safety improvements</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+<li>New <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying the
+directory Cyrus should look for timezone definitions in.  The default is
+to let libical find them itself.  If the <cite>tzdist</cite> http module is enabled,
+this option is mandatory.</li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+<li>The <cite>tzdist</cite> http module now finds its timezone data directory according
+to the new <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, instead of
+being hardcoded to &#8220;{configdirectory}/zoneinfo&#8221;.  If you are using this
+module, you MUST now set this option explicitly.  Calendaring services
+will use the same timezone definitions.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.2.0-beta4.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0-beta4 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.2.0-beta2.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0-beta2 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 06 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta4.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta4.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta4.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-beta4.html	2020-05-04 04:12:33.000000000 +0000
@@ -0,0 +1,980 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0-beta4 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0-rc1 Release Notes" href="3.2.0-rc1.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0-beta3 Release Notes" href="3.2.0-beta3.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0-beta4 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta4.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-beta4-release-notes">
+<h1>Cyrus IMAP 3.2.0-beta4 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-beta4-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This is a beta release and may contain fun bugs.  Testing it
+out and providing feedback would be greatly appreciated, but do
+not run this on your production mail stores!</p>
+</div>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-beta4-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Replication safety improvements</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+<li>New <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying the
+directory Cyrus should look for timezone definitions in.  The default is
+to let libical find them itself.  If the <cite>tzdist</cite> http module is enabled,
+this option is mandatory.</li>
+<li>The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+<a class="reference external" href="https://encoding.spec.whatwg.org/#names-and-labels">WHATWG Encoding for emails and websites</a></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+<li>The <cite>tzdist</cite> http module now finds its timezone data directory according
+to the new <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, instead of
+being hardcoded to &#8220;{configdirectory}/zoneinfo&#8221;.  If you are using this
+module, you MUST now set this option explicitly.  Calendaring services
+will use the same timezone definitions.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.2.0-rc1.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0-rc1 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.2.0-beta3.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0-beta3 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 30 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0.html	2020-05-04 04:12:31.000000000 +0000
@@ -0,0 +1,974 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.0 Releases" href="../../3.0/index.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0-rc1 Release Notes" href="3.2.0-rc1.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-release-notes">
+<h1>Cyrus IMAP 3.2.0 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-release-notes" title="Permalink to this headline">¶</a></h1>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Replication safety improvements</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+<li>New <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying the
+directory Cyrus should look for timezone definitions in.  The default is
+to let libical find them itself.  If the <cite>tzdist</cite> http module is enabled,
+this option is mandatory.</li>
+<li>The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+<a class="reference external" href="https://encoding.spec.whatwg.org/#names-and-labels">WHATWG Encoding for emails and websites</a></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+<li>The <cite>tzdist</cite> http module now finds its timezone data directory according
+to the new <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, instead of
+being hardcoded to &#8220;{configdirectory}/zoneinfo&#8221;.  If you are using this
+module, you MUST now set this option explicitly.  Calendaring services
+will use the same timezone definitions.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="../../3.0/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.2.0-rc1.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0-rc1 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 29 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-rc1.html 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-rc1.html
--- 3.0.13-5/doc/html/imap/download/release-notes/3.2/x/3.2.0-rc1.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/3.2/x/3.2.0-rc1.html	2020-05-04 04:12:33.000000000 +0000
@@ -0,0 +1,980 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Cyrus IMAP 3.2.0-rc1 Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../../index.html"/>
+        <link rel="up" title="Cyrus IMAP 3.2 Releases" href="../index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2.0 Release Notes" href="3.2.0.html"/>
+        <link rel="prev" title="Cyrus IMAP 3.2.0-beta4 Release Notes" href="3.2.0-beta4.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../../../index.html">Home</a></li>
+    <li><a href="../../../../../download.html">Download</a></li>
+    <li><a href="../../../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../../../index.html">
+      <img src="../../../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../../../index.html">
+ 
+
+  
+          
+          <img src="../../../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1 current"><a class="reference internal" href="../../../../../download.html">Download</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../../../getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../../index.html">Release Notes</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-version">Development Version</a></li>
+<li class="toctree-l3 current"><a class="reference internal" href="../../index.html#supported-product-series">Supported Product Series</a><ul class="current">
+<li class="toctree-l4 current"><a class="reference internal" href="../../index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../operations.html">Operations</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/admin.html">Administrator Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/admin.html#management">Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/monitoring.html">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../reference/faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../reference/faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../reference/faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../../../download.html">Download</a> &raquo;</li>
+      
+          <li><a href="../../index.html">Release Notes</a> &raquo;</li>
+      
+          <li><a href="../index.html">Cyrus IMAP 3.2 Releases</a> &raquo;</li>
+      
+    <li>Cyrus IMAP 3.2.0-rc1 Release Notes</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/3.2/x/3.2.0-rc1.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="cyrus-imap-3-2-0-rc1-release-notes">
+<h1>Cyrus IMAP 3.2.0-rc1 Release Notes<a class="headerlink" href="#cyrus-imap-3-2-0-rc1-release-notes" title="Permalink to this headline">¶</a></h1>
+<div class="admonition warning">
+<p class="first admonition-title">Warning</p>
+<p class="last">This is a beta release and may contain fun bugs.  Testing it
+out and providing feedback would be greatly appreciated, but do
+not run this on your production mail stores!</p>
+</div>
+<p>Download from GitHub:</p>
+<blockquote>
+<div><ul class="simple">
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz</a></li>
+<li><a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz.sig">https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz.sig</a></li>
+</ul>
+</div></blockquote>
+<div class="section" id="major-changes-since-the-3-0-x-series">
+<span id="relnotes-3-2-0-rc1-changes"></span><h2>Major changes since the 3.0.x series<a class="headerlink" href="#major-changes-since-the-3-0-x-series" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Sieve bug fixes and features</li>
+<li>Replication safety improvements</li>
+<li>Caldav and Carddav improvements</li>
+<li>Support for JMAP core protocol (<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8620.html"><strong>RFC 8620</strong></a>)</li>
+<li>Support for JMAP Mail (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8621.html"><strong>RFC 8621</strong></a>)</li>
+<li>Experimental support for JMAP Contacts (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Experimental support for JMAP Calendars (requires
+<cite>jmap_nonstandard_extensions: yes</cite> in <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>)</li>
+<li>Xapian bug fixes</li>
+<li>Improvements to Annotations handling</li>
+<li>DRAC support has been deprecated</li>
+<li>Support for Prometheus stats</li>
+<li>SNMP stats support has been deprecated</li>
+<li>Removed support for the Sphinx backend to squatter searches</li>
+<li>New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+createdmodseq to index header, savedate and createdmodseq to index records</li>
+<li>Support for WebSockets</li>
+<li>Support for HTTP/2.0</li>
+<li>Experimental support for Zeroskip database format</li>
+<li>Intermediate mailboxes are now recorded in mailboxes database</li>
+<li>Conversations database format update - adds flags and internaldate fields,
+and is now versioned for future-compatibility.  You will need to rebuild
+your conversations databases with <a class="reference internal" href="../../../../reference/manpages/systemcommands/ctl_conversationsdb.html#std:cyrusman-ctl_conversationsdb(8)">ctl_conversationsdb(8)</a> and
+the <cite>-b</cite> switch to benefit from this</li>
+<li>IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+respectively return the unique ids or names of the containing mailboxes of
+each message in the sequence (for best performance, rebuild your
+conversations databases as above)</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/mbpath.html#std:cyrusman-mbpath(8)">mbpath(8)</a> is now much more useful</li>
+<li>Twoskip database format now supports shared locks, and ensures record
+headers do not span disk block boundaries</li>
+<li>All Cyrus binaries now use real sysexits exit codes instead of mapping
+nearly everything to EX_TEMPFAIL</li>
+<li>CyrusDB errors now syslog the actual error instead of just &#8220;cyrusdb error&#8221;</li>
+<li>New <cite>allowdeleted</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default off), which
+allows admin users to see deleted mailboxes and expunged messages over IMAP</li>
+<li><a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_virusscan.html#std:cyrusman-cyr_virusscan(8)">cyr_virusscan(8)</a> now supports custom templates for notifications
+sent about infected messages that have been deleted</li>
+<li><a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options that represent a time duration now accept
+&#8216;d&#8217;, &#8216;h&#8217;, &#8216;m&#8217;, &#8216;s&#8217; suffixes rather than arbitrary units</li>
+<li>The <cite>tls_server_cert</cite> and <cite>tls_server_key</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> options
+now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+Дилян Палаузов</li>
+<li>Mailbox create/delete/rename are now performed under a lock on the user&#8217;s
+namespace, to prevent races (especially during big renames)</li>
+<li>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf-lint</cite> subcommand no longer complains
+about channel-prefixed sync options</li>
+<li>New <cite>master_bind_errors_fatal</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option (default
+off), with which master will refuse to start if any of the configured
+services are unable to successfully bind their port.  The default and legacy
+behaviour is for master to start with the affected services disabled, and
+not try to start them again until a SIGHUP is received</li>
+<li>New <cite>autocreate_acl</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying ACLs
+to use when mailboxes are created by <cite>autocreate_inbox_folders</cite></li>
+<li>New <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, for specifying the
+directory Cyrus should look for timezone definitions in.  The default is
+to let libical find them itself.  If the <cite>tzdist</cite> http module is enabled,
+this option is mandatory.</li>
+<li>The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+<a class="reference external" href="https://encoding.spec.whatwg.org/#names-and-labels">WHATWG Encoding for emails and websites</a></li>
+</ul>
+</div>
+<div class="section" id="updates-to-default-configuration">
+<h2>Updates to default configuration<a class="headerlink" href="#updates-to-default-configuration" title="Permalink to this headline">¶</a></h2>
+<p>The <a class="reference internal" href="../../../../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> <cite>conf</cite>, <cite>conf-all</cite> and <cite>conf-default</cite> subcommands
+now accept an <cite>-s &lt;version&gt;</cite> argument to highlight <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.</p>
+<ul class="simple">
+<li>The <cite>specialusealways</cite> option is now enabled by default. It must
+explicitly be disabled for interoperability with legacy clients that
+can&#8217;t handle RFC 6154 attributes in extended LIST commands.</li>
+<li>The values accepted by <cite>expunge_mode</cite> have changed, please see the
+documentation for more information about the changes.</li>
+<li>The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+work unless <cite>annotation_enable_legacy_commands</cite> is enabled.</li>
+<li>The <cite>outbox_sendlater</cite> option and its functionality have been removed.</li>
+<li>The <cite>tzdist</cite> http module now finds its timezone data directory according
+to the new <cite>zoneinfo_dir</cite> <a class="reference internal" href="../../../../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> option, instead of
+being hardcoded to &#8220;{configdirectory}/zoneinfo&#8221;.  If you are using this
+module, you MUST now set this option explicitly.  Calendaring services
+will use the same timezone definitions.</li>
+</ul>
+</div>
+<div class="section" id="security-fixes">
+<h2>Security fixes<a class="headerlink" href="#security-fixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230">CVE-2017-14230</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928">CVE-2019-18928</a></li>
+<li>Contains fix for <a class="reference external" href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783">CVE-2019-19783</a></li>
+</ul>
+</div>
+<div class="section" id="significant-bugfixes">
+<h2>Significant bugfixes<a class="headerlink" href="#significant-bugfixes" title="Permalink to this headline">¶</a></h2>
+<ul class="simple">
+<li>Contains fix for <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2839">Issue #2839</a></li>
+</ul>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="3.2.0.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2.0 Release Notes" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="3.2.0-beta4.html" class="btn btn-neutral" title="Cyrus IMAP 3.2.0-beta4 Release Notes" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 20 2020
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/download/release-notes/index.html 3.2.0-3/doc/html/imap/download/release-notes/index.html
--- 3.0.13-5/doc/html/imap/download/release-notes/index.html	2019-12-16 04:17:24.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/release-notes/index.html	2020-05-04 04:12:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Release Notes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Release Notes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Download" href="../../../download.html"/>
-        <link rel="next" title="Cyrus IMAP 3.0 Releases" href="3.0/index.html"/>
+        <link rel="next" title="Cyrus IMAP 3.2 Releases" href="3.2/index.html"/>
         <link rel="prev" title="Ubuntu" href="../installation/distributions/ubuntu.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../download.html">Download</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/release-notes/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/release-notes/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -766,27 +785,37 @@
             
   <div class="section" id="release-notes">
 <h1>Release Notes<a class="headerlink" href="#release-notes" title="Permalink to this headline">¶</a></h1>
-<p>Cyrus has switched to an <a class="reference external" href="http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy">odd-even release cycle</a>.</p>
-<p>With our versioning system using <code class="docutils literal"><span class="pre">major.minor.micro</span></code> numbering, the minor number
-reveals whether a version is stable (even), or development-only (odd).</p>
-<p>A 3.0.1 release is stable, but a 3.1.4 release is developmental only.</p>
+<p>Cyrus uses an <a class="reference external" href="http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy">odd-even release cycle</a>.</p>
+<p>With our versioning system using <code class="docutils literal"><span class="pre">major.minor.micro</span></code> numbering, the minor (middle)
+number reveals whether a version is stable (even), or development-only (odd).</p>
+<p>A 3.<strong>0</strong>.1 release is stable, but a 3.<strong>1</strong>.4 release is developmental only.</p>
 <div class="section" id="stable-version">
 <h2>Stable Version<a class="headerlink" href="#stable-version" title="Permalink to this headline">¶</a></h2>
-<p>Latest stable version is <a href="3.0/x/3.0.13.html">3.0.13</a>. Documentation at <a class="reference external" href="https://www.cyrusimap.org/3.0/">https://www.cyrusimap.org/3.0/</a>.</p>
+<p>Latest stable version is <a href="3.2/x/3.2.0.html">3.2.0</a>. Documentation at <a class="reference external" href="https://www.cyrusimap.org/">https://www.cyrusimap.org/</a>.</p>
 </div>
 <div class="section" id="development-version">
 <h2>Development Version<a class="headerlink" href="#development-version" title="Permalink to this headline">¶</a></h2>
-<p>Latest development snapshot is <a href="3.1/x/3.1.8.html">3.1.8</a>. Documentation at <a class="reference external" href="https://www.cyrusimap.org/dev/">https://www.cyrusimap.org/dev/</a>.</p>
+<p>Latest development snapshot is <a href="3.1/x/3.1.9.html">3.1.9</a>. Documentation at <a class="reference external" href="https://www.cyrusimap.org/dev/">https://www.cyrusimap.org/dev/</a>.</p>
 <div class="admonition warning">
 <p class="first admonition-title">Warning</p>
-<p class="last">These are tagged snapshots of the master branch, and should be considered for
-<strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only. We will try to tag these
-snapshots at coherent development points, but there will generally be <strong>large
-breaking changes</strong> occurring between releases in this series.</p>
+<p class="last">Development versions are tagged snapshots of the master branch, and should
+be considered for <strong>testing purposes</strong> and <strong>bleeding-edge features</strong> only.
+We will try to tag these snapshots at coherent development points, but
+there will generally be <strong>large breaking changes</strong> occurring between
+releases in this series.</p>
 </div>
 </div>
 <div class="section" id="supported-product-series">
 <h2>Supported Product Series<a class="headerlink" href="#supported-product-series" title="Permalink to this headline">¶</a></h2>
+<div class="section" id="series-3-2">
+<h3>Series 3.2<a class="headerlink" href="#series-3-2" title="Permalink to this headline">¶</a></h3>
+<p>Documentation at <a class="reference external" href="https://www.cyrusimap.org/3.2/">https://www.cyrusimap.org/3.2/</a>.</p>
+<div class="toctree-wrapper compound">
+<ul>
+<li class="toctree-l1"><a class="reference internal" href="3.2/index.html">Cyrus IMAP 3.2 Releases</a></li>
+</ul>
+</div>
+</div>
 <div class="section" id="series-3-0">
 <h3>Series 3.0<a class="headerlink" href="#series-3-0" title="Permalink to this headline">¶</a></h3>
 <p>Documentation at <a class="reference external" href="https://www.cyrusimap.org/3.0/">https://www.cyrusimap.org/3.0/</a>.</p>
@@ -805,16 +834,15 @@ breaking changes</strong> occurring betw
 </ul>
 </div>
 </div>
-<div class="section" id="series-2-4">
-<h3>Series 2.4<a class="headerlink" href="#series-2-4" title="Permalink to this headline">¶</a></h3>
+</div>
+<div class="section" id="development-snapshots">
+<h2>Development snapshots<a class="headerlink" href="#development-snapshots" title="Permalink to this headline">¶</a></h2>
 <div class="toctree-wrapper compound">
 <ul>
-<li class="toctree-l1"><a class="reference internal" href="2.4/index.html">Cyrus IMAP 2.4 Releases</a></li>
-<li class="toctree-l1"><a class="reference internal" href="2.4-dav/index.html">Cyrus IMAP 2.4-caldav Releases</a></li>
+<li class="toctree-l1"><a class="reference internal" href="3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </div>
 </div>
-</div>
 <div class="section" id="older-versions">
 <h2>Older Versions<a class="headerlink" href="#older-versions" title="Permalink to this headline">¶</a></h2>
 <div class="section" id="series-1">
@@ -825,18 +853,18 @@ breaking changes</strong> occurring betw
 </ul>
 </div>
 </div>
-<div class="section" id="series-2-2-0-2-3">
-<h3>Series 2: 2.0 - 2.3<a class="headerlink" href="#series-2-2-0-2-3" title="Permalink to this headline">¶</a></h3>
+<div class="section" id="series-2-2-0-2-4">
+<h3>Series 2: 2.0 - 2.4<a class="headerlink" href="#series-2-2-0-2-4" title="Permalink to this headline">¶</a></h3>
 <div class="toctree-wrapper compound">
 <ul>
 <li class="toctree-l1"><a class="reference internal" href="2.0/2.0.x.html">Cyrus IMAP 2.0.x Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="2.1/2.1.x.html">Cyrus IMAP 2.1.x Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="2.2/2.2.x.html">Cyrus IMAP 2.2.x Release Notes</a></li>
 <li class="toctree-l1"><a class="reference internal" href="2.3/index.html">Cyrus IMAP 2.3 Releases</a></li>
+<li class="toctree-l1"><a class="reference internal" href="2.4/index.html">Cyrus IMAP 2.4 Releases</a></li>
+<li class="toctree-l1"><a class="reference internal" href="2.4-dav/index.html">Cyrus IMAP 2.4-caldav Releases</a></li>
 </ul>
 </div>
-<div class="toctree-wrapper compound">
-</div>
 </div>
 </div>
 </div>
@@ -847,7 +875,7 @@ breaking changes</strong> occurring betw
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="3.0/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.0 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="3.2/index.html" class="btn btn-neutral float-right" title="Cyrus IMAP 3.2 Releases" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="../installation/distributions/ubuntu.html" class="btn btn-neutral" title="Ubuntu" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -859,7 +887,7 @@ breaking changes</strong> occurring betw
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 29 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -879,7 +907,7 @@ breaking changes</strong> occurring betw
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/download/upgrade.html 3.2.0-3/doc/html/imap/download/upgrade.html
--- 3.0.13-5/doc/html/imap/download/upgrade.html	2019-12-16 04:17:24.000000000 +0000
+++ 3.2.0-3/doc/html/imap/download/upgrade.html	2020-05-04 04:12:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Upgrading to 3.0 &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Upgrading to 3.2 &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Setup" href="../../setup.html"/>
         <link rel="next" title="Configuration Guide" href="../concepts/deployment.html"/>
         <link rel="prev" title="Virus Scanner" href="installation/virus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2 current"><a class="current reference internal" href="#">Upgrading to 3.0</a><ul>
+<li class="toctree-l2 current"><a class="current reference internal" href="#">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,15 +766,15 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../setup.html">Setup</a> &raquo;</li>
       
-    <li>Upgrading to 3.0</li>
+    <li>Upgrading to 3.2</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/download/upgrade.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/download/upgrade.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -764,8 +783,8 @@
 </div>
           <div role="main" class="document">
             
-  <div class="section" id="upgrading-to-3-0">
-<span id="upgrade"></span><h1>Upgrading to 3.0<a class="headerlink" href="#upgrading-to-3-0" title="Permalink to this headline">¶</a></h1>
+  <div class="section" id="upgrading-to-3-2">
+<span id="upgrade"></span><h1>Upgrading to 3.2<a class="headerlink" href="#upgrading-to-3-2" title="Permalink to this headline">¶</a></h1>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p>This guide assumes that you are familiar and comfortable with administration of a
@@ -786,12 +805,12 @@ use the upgrade instructions from the pa
 <li><a class="reference internal" href="#do-what-as-who" id="id6">Do What As Who?</a></li>
 </ul>
 </li>
-<li><a class="reference internal" href="#install-new-3-0-cyrus" id="id7">2. Install new 3.0 Cyrus</a></li>
+<li><a class="reference internal" href="#install-new-3-2-cyrus" id="id7">2. Install new 3.2 Cyrus</a></li>
 <li><a class="reference internal" href="#shut-down-existing-cyrus" id="id8">3. Shut down existing Cyrus</a></li>
 <li><a class="reference internal" href="#backup-and-copy-existing-data" id="id9">4. Backup and Copy existing data</a></li>
 <li><a class="reference internal" href="#copy-config-files-and-update" id="id10">5. Copy config files and update</a></li>
 <li><a class="reference internal" href="#upgrade-specific-items" id="id11">6. Upgrade specific items</a></li>
-<li><a class="reference internal" href="#start-new-3-0-cyrus-and-verify" id="id12">7. Start new 3.0 Cyrus and verify</a></li>
+<li><a class="reference internal" href="#start-new-3-2-cyrus-and-verify" id="id12">7. Start new 3.2 Cyrus and verify</a></li>
 <li><a class="reference internal" href="#reconstruct-databases-and-cache" id="id13">8. Reconstruct databases and cache</a></li>
 <li><a class="reference internal" href="#do-you-want-any-new-features" id="id14">9. Do you want any new features?</a></li>
 <li><a class="reference internal" href="#upgrade-complete" id="id15">10. Upgrade complete</a></li>
@@ -811,20 +830,20 @@ mailbox.  This is not a memory leak.</p>
 <p>Things to consider <strong>before</strong> you begin:</p>
 <div class="section" id="installation-from-tarball">
 <h3><a class="toc-backref" href="#id2">Installation from tarball</a><a class="headerlink" href="#installation-from-tarball" title="Permalink to this headline">¶</a></h3>
-<p>You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren&#8217;t able to test all platforms: you may find you need to install additional or different libraries to support v3.0.</p>
+<p>You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren&#8217;t able to test all platforms: you may find you need to install additional or different libraries to support v3.2.</p>
 </div>
 <div class="section" id="how-are-you-planning-on-upgrading">
 <h3><a class="toc-backref" href="#id3">How are you planning on upgrading?</a><a class="headerlink" href="#how-are-you-planning-on-upgrading" title="Permalink to this headline">¶</a></h3>
-<p>Ideally, you will do a sandboxed test installation of 3.0 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.0 installation.</p>
+<p>Ideally, you will do a sandboxed test installation of 3.2 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.2 installation.</p>
 <div class="section" id="upgrade-by-replicating">
 <h4><a class="toc-backref" href="#id4">Upgrade by replicating</a><a class="headerlink" href="#upgrade-by-replicating" title="Permalink to this headline">¶</a></h4>
 <p>If you&#8217;re familiar with replication, and your current installation is 2.4 or
 newer, you can set up your existing installation to replicate data to a new
-3.0 installation and failover to the new installation when you&#8217;re ready. The
+3.2 installation and failover to the new installation when you&#8217;re ready. The
 replication protocol has been kept backwards compatible.</p>
 <p>If your old installation contains mailboxes or messages that are older than
 2.4, they may not have GUID fields in their indexes (index version too old),
-or they may have their GUID field set to zero.  3.0 will not accept message
+or they may have their GUID field set to zero.  3.2 will not accept message
 replications without valid matching GUIDs, so you need to fix this on your
 old installation first.</p>
 <p>You can check for affected mailboxes by examining the output from the
@@ -847,8 +866,26 @@ to just <cite>reconstruct -G -V max</cit
 <p>If you are upgrading in place, you will need to shut down Cyrus
 entirely while you install the new package.  If your old installation
 was using Berkeley DB format databases, you will need to convert or
-upgrade the databases <strong>before</strong> you upgrade.  Cyrus v3.0 does not
+upgrade the databases <strong>before</strong> you upgrade.  Cyrus v3.2 does not
 support Berkeley DB at all.</p>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p>If you are upgrading from Cyrus version 2.5 or earlier,
+and your system is configured with the following combination
+in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>:</p>
+<div class="highlight-none"><div class="highlight"><pre><span></span>fulldirhash: yes
+hashimapspool: either yes or no
+unixhierarchysep: yes
+</pre></div>
+</div>
+<p>then you will not be able to upgrade-in-place.  This is due to
+a change in how directory hashes are calculated for users whose
+localpart contains a dot, which was introduced in 3.0.0.  After
+an in-place upgrade, Cyrus will not be able to find these users&#8217;
+metadata and/or mailboxes.</p>
+<p class="last">If you have this configuration, you will need to upgrade by
+replicating, not in place.</p>
+</div>
 </div>
 </div>
 <div class="section" id="do-what-as-who">
@@ -862,8 +899,8 @@ examples of them, so you&#8217;ll know t
 the <code class="docutils literal"><span class="pre">cyrus</span></code> user.</p>
 <p>Doing so in most systems is as simple as using either the <code class="docutils literal"><span class="pre">su</span></code> or
 <code class="docutils literal"><span class="pre">sudo</span></code> commands, like so:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">su</span> <span class="n">cyrus</span> <span class="o">-</span><span class="n">c</span> <span class="s2">&quot;/usr/local/bin/cyr_info conf-lint -C /etc/imapd.conf -M /etc/cyrus.conf&quot;</span>
-<span class="n">sudo</span> <span class="o">-</span><span class="n">u</span> <span class="n">cyrus</span> <span class="o">/</span><span class="n">usr</span><span class="o">/</span><span class="n">local</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">cyr_info</span> <span class="n">conf</span><span class="o">-</span><span class="n">lint</span> <span class="o">-</span><span class="n">C</span> <span class="o">/</span><span class="n">etc</span><span class="o">/</span><span class="n">imapd</span><span class="o">.</span><span class="n">conf</span> <span class="o">-</span><span class="n">M</span> <span class="o">/</span><span class="n">etc</span><span class="o">/</span><span class="n">cyrus</span><span class="o">.</span><span class="n">conf</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>su cyrus -c &quot;/usr/local/bin/cyr_info conf-lint -C /etc/imapd.conf -M /etc/cyrus.conf&quot;
+sudo -u cyrus /usr/local/bin/cyr_info conf-lint -C /etc/imapd.conf -M /etc/cyrus.conf
 </pre></div>
 </div>
 <p>In this document, however, there are also several command examples which
@@ -872,19 +909,19 @@ commands, such as <code class="docutils
 <p>We strongly recommend that you read this entire document before upgrading.</p>
 </div>
 </div>
-<div class="section" id="install-new-3-0-cyrus">
-<h2><a class="toc-backref" href="#id7">2. Install new 3.0 Cyrus</a><a class="headerlink" href="#install-new-3-0-cyrus" title="Permalink to this headline">¶</a></h2>
-<p>Download the release <a class="reference internal" href="getcyrus.html#getcyrus"><span class="std std-ref">3.0 package tarball</span></a>.</p>
+<div class="section" id="install-new-3-2-cyrus">
+<h2><a class="toc-backref" href="#id7">2. Install new 3.2 Cyrus</a><a class="headerlink" href="#install-new-3-2-cyrus" title="Permalink to this headline">¶</a></h2>
+<p>Download the release <a class="reference internal" href="getcyrus.html#getcyrus"><span class="std std-ref">3.2 package tarball</span></a>.</p>
 <p>Fetch the libraries for your platform. The full list (including all optional packages) for Debian is:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">sudo</span> <span class="n">apt</span><span class="o">-</span><span class="n">get</span> <span class="n">install</span> <span class="o">-</span><span class="n">y</span> <span class="n">autoconf</span> <span class="n">automake</span> <span class="n">autotools</span><span class="o">-</span><span class="n">dev</span> <span class="n">bash</span><span class="o">-</span><span class="n">completion</span> <span class="n">bison</span> <span class="n">build</span><span class="o">-</span><span class="n">essential</span> <span class="n">comerr</span><span class="o">-</span><span class="n">dev</span> \
-<span class="n">debhelper</span> <span class="n">flex</span> <span class="n">g</span><span class="o">++</span> <span class="n">git</span> <span class="n">gperf</span> <span class="n">groff</span> <span class="n">heimdal</span><span class="o">-</span><span class="n">dev</span> <span class="n">libbsd</span><span class="o">-</span><span class="n">resource</span><span class="o">-</span><span class="n">perl</span> <span class="n">libclone</span><span class="o">-</span><span class="n">perl</span> <span class="n">libconfig</span><span class="o">-</span><span class="n">inifiles</span><span class="o">-</span><span class="n">perl</span> \
-<span class="n">libcunit1</span><span class="o">-</span><span class="n">dev</span> <span class="n">libdatetime</span><span class="o">-</span><span class="n">perl</span> <span class="n">libdb</span><span class="o">-</span><span class="n">dev</span> <span class="n">libdigest</span><span class="o">-</span><span class="n">sha</span><span class="o">-</span><span class="n">perl</span> <span class="n">libencode</span><span class="o">-</span><span class="n">imaputf7</span><span class="o">-</span><span class="n">perl</span> <span class="n">libfile</span><span class="o">-</span><span class="n">chdir</span><span class="o">-</span><span class="n">perl</span> \
-<span class="n">libglib2</span><span class="o">.</span><span class="mi">0</span><span class="o">-</span><span class="n">dev</span> <span class="n">libical</span><span class="o">-</span><span class="n">dev</span> <span class="n">libio</span><span class="o">-</span><span class="n">socket</span><span class="o">-</span><span class="n">inet6</span><span class="o">-</span><span class="n">perl</span> <span class="n">libio</span><span class="o">-</span><span class="n">stringy</span><span class="o">-</span><span class="n">perl</span> <span class="n">libjansson</span><span class="o">-</span><span class="n">dev</span> <span class="n">libldap2</span><span class="o">-</span><span class="n">dev</span> \
-<span class="n">libmysqlclient</span><span class="o">-</span><span class="n">dev</span> <span class="n">libnet</span><span class="o">-</span><span class="n">server</span><span class="o">-</span><span class="n">perl</span> <span class="n">libnews</span><span class="o">-</span><span class="n">nntpclient</span><span class="o">-</span><span class="n">perl</span> <span class="n">libpam0g</span><span class="o">-</span><span class="n">dev</span> <span class="n">libpcre3</span><span class="o">-</span><span class="n">dev</span> <span class="n">libsasl2</span><span class="o">-</span><span class="n">dev</span> \
-<span class="n">libsnmp</span><span class="o">-</span><span class="n">dev</span> <span class="n">libsqlite3</span><span class="o">-</span><span class="n">dev</span> <span class="n">libssl</span><span class="o">-</span><span class="n">dev</span> <span class="n">libtest</span><span class="o">-</span><span class="n">unit</span><span class="o">-</span><span class="n">perl</span> <span class="n">libtool</span> <span class="n">libunix</span><span class="o">-</span><span class="n">syslog</span><span class="o">-</span><span class="n">perl</span> <span class="n">liburi</span><span class="o">-</span><span class="n">perl</span> \
-<span class="n">libxapian</span><span class="o">-</span><span class="n">dev</span> <span class="n">libxml</span><span class="o">-</span><span class="n">generator</span><span class="o">-</span><span class="n">perl</span> <span class="n">libxml</span><span class="o">-</span><span class="n">xpath</span><span class="o">-</span><span class="n">perl</span> <span class="n">libxml2</span><span class="o">-</span><span class="n">dev</span> <span class="n">libwrap0</span><span class="o">-</span><span class="n">dev</span> <span class="n">libzephyr</span><span class="o">-</span><span class="n">dev</span> <span class="n">lsb</span><span class="o">-</span><span class="n">base</span> \
-<span class="n">net</span><span class="o">-</span><span class="n">tools</span> <span class="n">perl</span> <span class="n">php</span><span class="o">-</span><span class="n">cli</span> <span class="n">php</span><span class="o">-</span><span class="n">curl</span> <span class="n">pkg</span><span class="o">-</span><span class="n">config</span> <span class="n">po</span><span class="o">-</span><span class="n">debconf</span> <span class="n">tcl</span><span class="o">-</span><span class="n">dev</span> \
-<span class="n">transfig</span> <span class="n">uuid</span><span class="o">-</span><span class="n">dev</span> <span class="n">vim</span> <span class="n">wamerican</span> <span class="n">wget</span> <span class="n">xutils</span><span class="o">-</span><span class="n">dev</span> <span class="n">zlib1g</span><span class="o">-</span><span class="n">dev</span> <span class="n">sasl2</span><span class="o">-</span><span class="nb">bin</span> <span class="n">rsyslog</span> <span class="n">sudo</span> <span class="n">acl</span> <span class="n">telnet</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>sudo apt-get install -y autoconf automake autotools-dev bash-completion bison build-essential comerr-dev \
+debhelper flex g++ git gperf groff heimdal-dev libbsd-resource-perl libclone-perl libconfig-inifiles-perl \
+libcunit1-dev libdatetime-perl libdb-dev libdigest-sha-perl libencode-imaputf7-perl libfile-chdir-perl \
+libglib2.0-dev libical-dev libio-socket-inet6-perl libio-stringy-perl libjansson-dev libldap2-dev \
+libmysqlclient-dev libnet-server-perl libnews-nntpclient-perl libpam0g-dev libpcre3-dev libsasl2-dev \
+libsnmp-dev libsqlite3-dev libssl-dev libtest-unit-perl libtool libunix-syslog-perl liburi-perl \
+libxapian-dev libxml-generator-perl libxml-xpath-perl libxml2-dev libwrap0-dev libzephyr-dev lsb-base \
+net-tools perl php-cli php-curl pkg-config po-debconf tcl-dev \
+transfig uuid-dev vim wamerican wget xutils-dev zlib1g-dev sasl2-bin rsyslog sudo acl telnet
 </pre></div>
 </div>
 <p>If you&#8217;re on another platform and can provide the list of dependencies, please
@@ -913,7 +950,7 @@ whatever method you normally use.</p>
 <li>Mail spool</li>
 <li><a class="reference internal" href="../concepts/deployment/databases.html#databases"><span class="std std-ref">Cyrus Databases</span></a></li>
 </ul>
-<p>(You do already have a backup strategy in place, right? Once you&#8217;re on 3.0, you can
+<p>(You do already have a backup strategy in place, right? Once you&#8217;re on 3.2, you can
 consider using the experimental <a class="reference internal" href="../reference/admin/backups.html#cyrus-backups"><span class="std std-ref">backup tools</span></a>.)</p>
 <p>Copy all of this to the new instance, using <code class="docutils literal"><span class="pre">rsync</span></code> or similar tools.</p>
 <div class="admonition note">
@@ -927,11 +964,11 @@ current installation.</p>
 using their standard locations, you might execute this series of
 commands on the <em>new</em> server (where &#8220;oldimap&#8221; is the name of the old
 server):</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">rsync</span> <span class="o">-</span><span class="n">aHv</span> <span class="n">oldimap</span><span class="p">:</span><span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/.</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/.</span>
-<span class="n">rsync</span> <span class="o">-</span><span class="n">aHv</span> <span class="n">oldimap</span><span class="p">:</span><span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">spool</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/.</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">spool</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/.</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>rsync -aHv oldimap:/var/lib/cyrus/. /var/lib/cyrus/.
+rsync -aHv oldimap:/var/spool/cyrus/. /var/spool/cyrus/.
 </pre></div>
 </div>
-<p>You don&#8217;t need to copy the following databases as Cyrus 3.0 will
+<p>You don&#8217;t need to copy the following databases as Cyrus 3.2 will
 recreate these for you automatically:</p>
 <ul class="simple">
 <li>duplicate delivery (deliver.db),</li>
@@ -962,13 +999,13 @@ remove the <code class="docutils literal
 on FreeBSD systems, the configuration files <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>
 and <a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> are in <code class="docutils literal"><span class="pre">/usr/local/etc</span></code>, rather than
 <code class="docutils literal"><span class="pre">/etc/</span></code>.  Run this command on the <em>old</em> server:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">scp</span> <span class="o">/</span><span class="n">etc</span><span class="o">/</span><span class="n">cyrus</span><span class="o">.</span><span class="n">conf</span> <span class="o">/</span><span class="n">etc</span><span class="o">/</span><span class="n">imapd</span><span class="o">.</span><span class="n">conf</span> <span class="n">newimap</span><span class="p">:</span><span class="o">/</span><span class="n">etc</span><span class="o">/</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>scp /etc/cyrus.conf /etc/imapd.conf newimap:/etc/
 </pre></div>
 </div>
 <p>Using the <a class="reference internal" href="../reference/manpages/systemcommands/cyr_info.html#std:cyrusman-cyr_info(8)">cyr_info(8)</a> command, check to see if your
 imapd.conf file contains any deprecated options. Run this command on
 the new server:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cyr_info</span> <span class="n">conf</span><span class="o">-</span><span class="n">lint</span> <span class="o">-</span><span class="n">C</span> <span class="o">&lt;</span><span class="n">path</span> <span class="n">to</span> <span class="n">imapd</span><span class="o">.</span><span class="n">conf</span><span class="o">&gt;</span> <span class="o">-</span><span class="n">M</span> <span class="o">&lt;</span><span class="n">path</span> <span class="n">to</span> <span class="n">cyrus</span><span class="o">.</span><span class="n">conf</span><span class="o">&gt;</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>cyr_info conf-lint -C &lt;path to imapd.conf&gt; -M &lt;path to cyrus.conf&gt;
 </pre></div>
 </div>
 <p>You need to provide both imapd.conf and cyrus.conf so that conf-lint knows
@@ -976,12 +1013,13 @@ the names of all your services and can c
 <p>To check your entire system&#8217;s configuration you can use the conf-all
 action. This command takes all the system defaults, along with anything
 you have provided overrides for in your config files:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cyr_info</span> <span class="n">conf</span><span class="o">-</span><span class="nb">all</span> <span class="o">-</span><span class="n">C</span> <span class="o">&lt;</span><span class="n">path</span> <span class="n">to</span> <span class="n">imapd</span><span class="o">.</span><span class="n">conf</span><span class="o">&gt;</span> <span class="o">-</span><span class="n">M</span> <span class="o">&lt;</span><span class="n">path</span> <span class="n">to</span> <span class="n">cyrus</span><span class="o">.</span><span class="n">conf</span><span class="o">&gt;</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>cyr_info conf-all -C &lt;path to imapd.conf&gt; -M &lt;path to cyrus.conf&gt;
 </pre></div>
 </div>
 <p><strong>Important config</strong> options: <code class="docutils literal"><span class="pre">unixhierarchysep:</span></code> and <code class="docutils literal"><span class="pre">altnamespace:</span></code>
-defaults have changed in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>. Implications are
-outlined in the Note in <a class="reference internal" href="../concepts/features/namespaces.html#imap-admin-namespaces-mode"><span class="std std-ref">User Namespace Mode</span></a> and
+defaults in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> changed in 3.0, which will affect you
+if you are upgrading to 3.2 from something earlier than 3.0. Implications
+are outlined in the Note in <a class="reference internal" href="../concepts/features/namespaces.html#imap-admin-namespaces-mode"><span class="std std-ref">User Namespace Mode</span></a> and
 <a class="reference internal" href="../reference/admin/sop/altnamespace.html#imap-switching-alt-namespace-mode"><span class="std std-ref">Switching the Alternative Namespace</span></a>.  Please also see &#8220;Sieve Scripts,&#8221;
 below.</p>
 <ul class="simple">
@@ -1006,43 +1044,22 @@ directive(s), you can convert these to p
 in your new install with the <a class="reference internal" href="../reference/manpages/systemcommands/cvt_xlist_specialuse.html#std:cyrusman-cvt_xlist_specialuse(8)">cvt_xlist_specialuse(8)</a> tool</p>
 </div></blockquote>
 </li>
-<li><p class="first">Sieve Scripts</p>
-<blockquote>
-<div><p>Since defaults for options: <code class="docutils literal"><span class="pre">unixhierarchysep:</span></code> and
-<code class="docutils literal"><span class="pre">altnamespace:</span></code> have changed in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, you
-may very likely need to modify any sieve scripts already on your
-system.  Fear not, there&#8217;s a tool for this task, called
-<a class="reference internal" href="../reference/manpages/systemcommands/translatesieve.html#std:cyrusman-translatesieve(8)">translatesieve(8)</a>.  This tool can handle situations
-where either or both of these settings need change. Please consult
-the man page for details.</p>
-<p>Consider the following example, where the prior configuration was
-already using <code class="docutils literal"><span class="pre">altnamespace:</span> <span class="pre">on</span></code>, but was <em>not</em> using
-<code class="docutils literal"><span class="pre">unixhierarchysep:</span> <span class="pre">on</span></code>:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="c1"># su cyrus -c &quot;/usr/lib/cyrus/upgrade/translatesieve -a&quot;</span>
-<span class="n">you</span> <span class="n">are</span> <span class="n">using</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">imap</span><span class="o">/</span><span class="n">sieve</span> <span class="k">as</span> <span class="n">your</span> <span class="n">sieve</span> <span class="n">directory</span><span class="o">.</span>
-<span class="n">translating</span> <span class="n">sievedir</span> <span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">imap</span><span class="o">/</span><span class="n">sieve</span><span class="o">...</span> <span class="n">converting</span> <span class="n">separator</span> <span class="kn">from</span> <span class="s1">&#39;.&#39;</span> <span class="n">to</span> <span class="s1">&#39;/&#39;</span>
-<span class="ow">not</span> <span class="n">changing</span> <span class="n">name</span> <span class="n">space</span><span class="o">.</span>
-<span class="n">done</span>
-</pre></div>
-</div>
-</div></blockquote>
-</li>
 </ul>
 <div class="admonition warning">
 <p class="first admonition-title">Warning</p>
-<p><strong>Berkeley db format no longer supported</strong></p>
+<p><strong>Berkeley db format no longer supported since 3.0</strong></p>
 <p>If you have any databases using Berkeley db, they&#8217;ll need to be
 converted to skiplist or flat <em>in your existing installation</em>. And
 then optionally converted to whatever final format you&#8217;d like in
-your 3.0 installation.</p>
+your 3.2 installation.</p>
 <p>Databases potentially affected: mailboxes, annotations, conversations, quotas.</p>
 <p>On old install, prior to migration:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">cvt_cyrusdb</span> <span class="o">/&lt;</span><span class="n">configdirectory</span><span class="o">&gt;</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">db</span> <span class="n">berkeley</span> <span class="o">/</span><span class="n">tmp</span><span class="o">/</span><span class="n">new</span><span class="o">-</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">db</span> <span class="n">skiplist</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>cvt_cyrusdb /&lt;configdirectory&gt;mailboxes.db berkeley /tmp/new-mailboxes.db skiplist
 </pre></div>
 </div>
-<p>If you don&#8217;t want to use flat or skiplist for 3.0, you can use the
-new 3.0 <a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html#std:cyrusman-cvt_cyrusdb(8)">cvt_cyrusdb(8)</a> to swap to new format:</p>
-<div class="last highlight-default"><div class="highlight"><pre><span></span><span class="n">cvt_cyrusdb</span> <span class="o">/</span><span class="n">tmp</span><span class="o">/</span><span class="n">new</span><span class="o">-</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">db</span> <span class="n">skiplist</span> <span class="o">/&lt;</span><span class="n">configdirectory</span><span class="o">&gt;/</span><span class="n">mailboxes</span><span class="o">.</span><span class="n">db</span> <span class="o">&lt;</span><span class="n">new</span> <span class="n">file</span> <span class="nb">format</span><span class="o">&gt;</span>
+<p>If you don&#8217;t want to use flat or skiplist for 3.2, you can use the
+new 3.2 <a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html#std:cyrusman-cvt_cyrusdb(8)">cvt_cyrusdb(8)</a> to swap to new format:</p>
+<div class="last highlight-none"><div class="highlight"><pre><span></span>cvt_cyrusdb /tmp/new-mailboxes.db skiplist /&lt;configdirectory&gt;/mailboxes.db &lt;new file format&gt;
 </pre></div>
 </div>
 </div>
@@ -1051,17 +1068,17 @@ new 3.0 <a class="reference internal" hr
 <p class="last">The <a class="reference internal" href="../reference/manpages/systemcommands/cvt_cyrusdb.html#std:cyrusman-cvt_cyrusdb(8)">cvt_cyrusdb(8)</a> command does not accept relative paths.</p>
 </div>
 </div>
-<div class="section" id="start-new-3-0-cyrus-and-verify">
-<h2><a class="toc-backref" href="#id12">7. Start new 3.0 Cyrus and verify</a><a class="headerlink" href="#start-new-3-0-cyrus-and-verify" title="Permalink to this headline">¶</a></h2>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">sudo</span> <span class="o">./</span><span class="n">master</span><span class="o">/</span><span class="n">master</span> <span class="o">-</span><span class="n">d</span>
+<div class="section" id="start-new-3-2-cyrus-and-verify">
+<h2><a class="toc-backref" href="#id12">7. Start new 3.2 Cyrus and verify</a><a class="headerlink" href="#start-new-3-2-cyrus-and-verify" title="Permalink to this headline">¶</a></h2>
+<div class="highlight-none"><div class="highlight"><pre><span></span>sudo ./master/master -d
 </pre></div>
 </div>
 <p>Check <code class="docutils literal"><span class="pre">/var/log/syslog</span></code> for errors so you can quickly understand potential problems.</p>
-<p>When you&#8217;re satisfied version 3.0 is running and can see all its data correctly,
+<p>When you&#8217;re satisfied version 3.2 is running and can see all its data correctly,
 start the new Cyrus up with your regular init script.</p>
 <p>If something has gone wrong, contact us on the <a class="reference internal" href="../support/feedback-mailing-lists.html#feedback-mailing-lists"><span class="std std-ref">mailing list</span></a>.
 You can revert to backups and keep processing mail using your old version
-until you&#8217;re able to finish your 3.0 installation.</p>
+until you&#8217;re able to finish your 3.2 installation.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p class="last">If you&#8217;ve disable your system startup scripts, as recommended in
@@ -1071,44 +1088,50 @@ step 2, remember to re-enable them.  Use
 </div>
 <div class="section" id="reconstruct-databases-and-cache">
 <h2><a class="toc-backref" href="#id13">8. Reconstruct databases and cache</a><a class="headerlink" href="#reconstruct-databases-and-cache" title="Permalink to this headline">¶</a></h2>
-<div class="admonition warning">
-<p class="first admonition-title">Warning</p>
-<p>Versions of 3.0 prior to 3.0.11 contained a bug (<a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/issues/2389">Issue #2389</a>) that
-could lead to loss of seen state/flags during <cite>reconstruct</cite> for some
-messages that already existed prior to Cyrus 2.3.  The <a class="reference internal" href="release-notes/3.0/x/3.0.11.html#relnotes-3-0-11-changes"><span class="std std-ref">3.0.11
-release notes</span></a> contain the specifics.</p>
-<p class="last">Consider upgrading to 3.0.11 rather than an earlier release.</p>
-</div>
 <p>The following steps can each take a long time, so we recommend
 running them one at a time (to reduce locking contention and high I/O load).</p>
 <p>To upgrade all the mailboxes to the latest version. This will take hours, possibly days.</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">reconstruct</span> <span class="o">-</span><span class="n">V</span> <span class="nb">max</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>reconstruct -V max
 </pre></div>
 </div>
-<p>New configuration: if turning on conversations, you need to create conversations.db for each user.:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">ctl_conversationsdb</span> <span class="o">-</span><span class="n">b</span> <span class="o">-</span><span class="n">r</span>
+<p>New configuration: if turning on conversations, you need to create conversations.db for each user.
+(This is required for jmap).:</p>
+<div class="highlight-none"><div class="highlight"><pre><span></span>ctl_conversationsdb -b -r
 </pre></div>
 </div>
 <p>To check (and correct) quota usage:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">quota</span> <span class="o">-</span><span class="n">f</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>quota -f
 </pre></div>
 </div>
 <p>If you&#8217;ve been using CalDAV/CardDAV/all of the DAV from earlier releases, then the user.dav
 databases need to be reconstructed due to format changes.:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">dav_reconstruct</span> <span class="o">-</span><span class="n">a</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>dav_reconstruct -a
 </pre></div>
 </div>
+<p>If you are upgrading from 3.0, and have the <cite>reverseacls</cite> feature enabled
+in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, you may need to regenerate the data it uses
+(which is stored in <cite>mailboxes.db</cite>).  This is automatically regenerated at
+startup by <cite>ctl_cyrusdb -r</cite> if the <cite>reverseacls</cite> setting has changed. So,
+to force a regeneration:</p>
+<blockquote>
+<div><ol class="arabic simple">
+<li>Shut down Cyrus</li>
+<li>Change <cite>reverseacls</cite> to <cite>0</cite> in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a></li>
+<li>Run <a class="reference internal" href="../reference/manpages/systemcommands/ctl_cyrusdb.html#std:cyrusman-ctl_cyrusdb(8)">ctl_cyrusdb(8)</a> with the <cite>-r</cite> switch (or just start
+Cyrus, assuming your <a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> contains a
+<cite>ctl_cyrusdb -r</cite> entry in the START section).  The old RACL entries
+will be removed</li>
+<li>(If you started Cyrus, shut it down again)</li>
+<li>Change <cite>reverseacls</cite> back to <cite>1</cite></li>
+<li>Start up Cyrus (or run <cite>ctl_cyrusdb -r</cite>).  The RACL entries will
+be rebuilt</li>
+</ol>
+</div></blockquote>
 </div>
 <div class="section" id="do-you-want-any-new-features">
 <h2><a class="toc-backref" href="#id14">9. Do you want any new features?</a><a class="headerlink" href="#do-you-want-any-new-features" title="Permalink to this headline">¶</a></h2>
-<p>3.0 comes with many lovely new features. Consider which ones you want to enable.
-Here are some which may interest you. Check the <a class="reference internal" href="release-notes/3.0/index.html#imap-release-notes-3-0"><span class="std std-ref">3.0 release notes</span></a>
-for the full list.</p>
-<ul class="simple">
-<li><a class="reference internal" href="../reference/admin/backups.html#cyrus-backups"><span class="std std-ref">Backups</span></a></li>
-<li><a class="reference internal" href="../developer/install-xapian.html#imapinstall-xapian"><span class="std std-ref">Xapian for searching</span></a></li>
-<li>Cross-domain support. See <code class="docutils literal"><span class="pre">crossdomains</span></code> in <a class="reference internal" href="../reference/manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a></li>
-</ul>
+<p>3.2 comes with many lovely new features. Consider which ones you want to enable.
+Check the <a class="reference internal" href="release-notes/3.2/index.html#imap-release-notes-3-2"><span class="std std-ref">3.2 release notes</span></a> for the full list.</p>
 </div>
 <div class="section" id="upgrade-complete">
 <h2><a class="toc-backref" href="#id15">10. Upgrade complete</a><a class="headerlink" href="#upgrade-complete" title="Permalink to this headline">¶</a></h2>
@@ -1127,11 +1150,11 @@ which will cause the commands to fail wh
 upgrade all your back end servers first. This can be done one at a time.</p>
 <p>Upgrade your mupdate master and front ends last.</p>
 <p>If you are upgrading from 2.4, and wish to use XFER to transfer your
-mailboxes to your new 3.0 server, please consider first upgrading your
+mailboxes to your new 3.2 server, please consider first upgrading your
 2.4 setup to version 2.4.19 or later.  Earlier versions of 2.4 do not
-correctly recognise the 2.5 and 3.0 mailbox versions, and will
+correctly recognise the 2.5 and later mailbox versions, and will
 downgrade mailboxes (losing metadata) in transit.  2.4.19 and later
-versions correctly recognise 2.5 and 3.0 servers, and will not
+versions correctly recognise 2.5 and later servers, and will not
 downgrade mailbox versions in transit.</p>
 </div>
 </div>
@@ -1154,7 +1177,7 @@ downgrade mailbox versions in transit.</
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Nov 15 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 29 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1174,7 +1197,7 @@ downgrade mailbox versions in transit.</
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/installing.html 3.2.0-3/doc/html/imap/installing.html
--- 3.0.13-5/doc/html/imap/installing.html	2019-12-16 04:17:24.000000000 +0000
+++ 3.2.0-3/doc/html/imap/installing.html	2020-05-04 04:12:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Installing Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Installing Cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="Setup" href="../setup.html"/>
         <link rel="next" title="HTTP modules" href="download/installation/manage-dav.html"/>
         <link rel="prev" title="Compiling" href="developer/compiling.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../setup.html">Setup</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/installing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/installing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1134,7 +1153,7 @@ something different.</p>
   <span class="n">recover</span>       <span class="n">cmd</span><span class="o">=</span><span class="s2">&quot;ctl_cyrusdb -r&quot;</span>
 <span class="p">}</span>
 
-<span class="c1"># UNIX sockets start with a slash and are put into /var/imap/socket</span>
+<span class="c1"># UNIX sockets start with a slash and are put into /run/cyrus/socket</span>
 <span class="n">SERVICES</span> <span class="p">{</span>
   <span class="c1"># add or remove based on preferences</span>
   <span class="n">imap</span>          <span class="n">cmd</span><span class="o">=</span><span class="s2">&quot;imapd&quot;</span> <span class="n">listen</span><span class="o">=</span><span class="s2">&quot;imap&quot;</span> <span class="n">prefork</span><span class="o">=</span><span class="mi">0</span>
@@ -1153,10 +1172,13 @@ something different.</p>
 
   <span class="c1"># at least one LMTP is required for delivery</span>
 <span class="c1">#  lmtp          cmd=&quot;lmtpd&quot; listen=&quot;lmtp&quot; prefork=0</span>
-  <span class="n">lmtpunix</span>      <span class="n">cmd</span><span class="o">=</span><span class="s2">&quot;lmtpd&quot;</span> <span class="n">listen</span><span class="o">=</span><span class="s2">&quot;/var/imap/socket/lmtp&quot;</span> <span class="n">prefork</span><span class="o">=</span><span class="mi">0</span>
+  <span class="n">lmtpunix</span>      <span class="n">cmd</span><span class="o">=</span><span class="s2">&quot;lmtpd&quot;</span> <span class="n">listen</span><span class="o">=</span><span class="s2">&quot;/run/cyrus/socket/lmtp&quot;</span> <span class="n">prefork</span><span class="o">=</span><span class="mi">0</span>
+
+  <span class="c1"># this is requied if using socketmap</span>
+<span class="c1">#  smmap         cmd=&quot;smmapd&quot; listen=&quot;/run/cyrus/socket/smmap&quot; prefork=0</span>
 
   <span class="c1"># this is required if using notifications</span>
-<span class="c1">#  notify        cmd=&quot;notifyd&quot; listen=&quot;/var/imap/socket/notify&quot; proto=&quot;udp&quot; prefork=1</span>
+<span class="c1">#  notify        cmd=&quot;notifyd&quot; listen=&quot;/run/cyrus/socket/notify&quot; proto=&quot;udp&quot; prefork=1</span>
 <span class="p">}</span>
 
 <span class="n">EVENTS</span> <span class="p">{</span>
@@ -1476,7 +1498,7 @@ addressbook and calendar entry for the s
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 22 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 22 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1496,7 +1518,7 @@ addressbook and calendar entry for the s
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/quickstart/introduction.html 3.2.0-3/doc/html/imap/quickstart/introduction.html
--- 3.0.13-5/doc/html/imap/quickstart/introduction.html	2019-12-16 04:17:25.000000000 +0000
+++ 3.2.0-3/doc/html/imap/quickstart/introduction.html	2020-05-04 04:12:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Introduction to Cyrus IMAP &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Introduction to Cyrus IMAP &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Quickstart Guide" href="../../quickstart.html"/>
         <link rel="next" title="Overview" href="../../overview.html"/>
         <link rel="prev" title="Quickstart Guide" href="../../quickstart.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../quickstart.html">Quickstart Guide</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/quickstart/introduction.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/quickstart/introduction.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -831,7 +850,7 @@ out <a class="reference internal" href="
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 19 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 19 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -851,7 +870,7 @@ out <a class="reference internal" href="
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/access-control/combining-rights.html 3.2.0-3/doc/html/imap/reference/admin/access-control/combining-rights.html
--- 3.0.13-5/doc/html/imap/reference/admin/access-control/combining-rights.html	2019-12-16 04:17:25.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/access-control/combining-rights.html	2020-05-04 04:12:36.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Combining Access Rights &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Combining Access Rights &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Access Control" href="../access-control.html"/>
         <link rel="next" title="Access Control Defaults" href="defaults.html"/>
         <link rel="prev" title="Access Control" href="../access-control.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/access-control/combining-rights.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/access-control/combining-rights.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -905,7 +924,7 @@ right, and any one of the <a class="refe
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -925,7 +944,7 @@ right, and any one of the <a class="refe
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/access-control/defaults.html 3.2.0-3/doc/html/imap/reference/admin/access-control/defaults.html
--- 3.0.13-5/doc/html/imap/reference/admin/access-control/defaults.html	2019-12-16 04:17:26.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/access-control/defaults.html	2020-05-04 04:12:36.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Access Control Defaults &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Access Control Defaults &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Access Control" href="../access-control.html"/>
         <link rel="next" title="Access Control Identifier (ACI)" href="identifiers.html"/>
         <link rel="prev" title="Combining Access Rights" href="combining-rights.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/access-control/defaults.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/access-control/defaults.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -834,7 +853,7 @@ mailboxes within their INBOX hierarchy.<
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -854,7 +873,7 @@ mailboxes within their INBOX hierarchy.<
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/access-control/identifiers.html 3.2.0-3/doc/html/imap/reference/admin/access-control/identifiers.html
--- 3.0.13-5/doc/html/imap/reference/admin/access-control/identifiers.html	2019-12-16 04:17:26.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/access-control/identifiers.html	2020-05-04 04:12:37.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Access Control Identifier (ACI) &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Access Control Identifier (ACI) &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Access Control" href="../access-control.html"/>
         <link rel="next" title="Access Control Lists Rights Reference" href="rights-reference.html"/>
         <link rel="prev" title="Access Control Defaults" href="defaults.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/access-control/identifiers.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/access-control/identifiers.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -869,7 +888,7 @@ meaning of identifiers.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -889,7 +908,7 @@ meaning of identifiers.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/access-control/rights-reference.html 3.2.0-3/doc/html/imap/reference/admin/access-control/rights-reference.html
--- 3.0.13-5/doc/html/imap/reference/admin/access-control/rights-reference.html	2019-12-16 04:17:26.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/access-control/rights-reference.html	2020-05-04 04:12:37.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Access Control Lists Rights Reference &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Access Control Lists Rights Reference &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Access Control" href="../access-control.html"/>
         <link rel="next" title="Quotas" href="../quotas.html"/>
         <link rel="prev" title="Access Control Identifier (ACI)" href="identifiers.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/access-control/rights-reference.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/access-control/rights-reference.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1108,7 +1127,7 @@ fully implement the successor rights
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1128,7 +1147,7 @@ fully implement the successor rights
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/access-control.html 3.2.0-3/doc/html/imap/reference/admin/access-control.html
--- 3.0.13-5/doc/html/imap/reference/admin/access-control.html	2019-12-16 04:17:25.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/access-control.html	2020-05-04 04:12:36.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Access Control &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Access Control &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Combining Access Rights" href="access-control/combining-rights.html"/>
         <link rel="prev" title="Cyrus Socket Locations" href="ports/sockets.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/access-control.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/access-control.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -812,7 +831,7 @@ right on all mailboxes in the personal n
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -832,7 +851,7 @@ right on all mailboxes in the personal n
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/backups.html 3.2.0-3/doc/html/imap/reference/admin/backups.html
--- 3.0.13-5/doc/html/imap/reference/admin/backups.html	2019-12-16 04:17:27.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/backups.html	2020-05-04 04:12:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Backups &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Backups &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Cyrus NNTP" href="nntp.html"/>
         <link rel="prev" title="Cyrus Sieve" href="sieve.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/backups.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/backups.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1270,7 +1289,7 @@ messages.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1290,7 +1309,7 @@ messages.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/config-mailboxdistribution.html 3.2.0-3/doc/html/imap/reference/admin/config-mailboxdistribution.html
--- 3.0.13-5/doc/html/imap/reference/admin/config-mailboxdistribution.html	2019-12-16 04:17:27.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/config-mailboxdistribution.html	2020-05-04 04:12:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Distribution &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Distribution &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Cyrus Murder" href="murder/murder.html"/>
-        <link rel="prev" title="Cyrus Event Source" href="eventsource.html"/> 
+        <link rel="prev" title="Monitoring" href="monitoring.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/config-mailboxdistribution.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/config-mailboxdistribution.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -977,7 +996,7 @@ Mailboxes previously created there are o
         <a href="murder/murder.html" class="btn btn-neutral float-right" title="Cyrus Murder" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="eventsource.html" class="btn btn-neutral" title="Cyrus Event Source" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="monitoring.html" class="btn btn-neutral" title="Monitoring" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -986,7 +1005,7 @@ Mailboxes previously created there are o
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1006,7 +1025,7 @@ Mailboxes previously created there are o
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/eventsource.html 3.2.0-3/doc/html/imap/reference/admin/eventsource.html
--- 3.0.13-5/doc/html/imap/reference/admin/eventsource.html	2019-12-16 04:17:27.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/eventsource.html	2020-05-04 04:12:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Event Source &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Event Source &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
-        <link rel="next" title="Mailbox Distribution" href="config-mailboxdistribution.html"/>
+        <link rel="next" title="Monitoring" href="monitoring.html"/>
         <link rel="prev" title="Managing user_deny.db" href="sop/userdeny.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/eventsource.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/eventsource.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -816,7 +835,7 @@ Set ALL for any folder</div></blockquote
 <div><p><code class="docutils literal"><span class="pre">event_extra_params:</span></code> timestamp</p>
 <blockquote>
 <div><p>Space-separated list of extra parameters to add to any appropriated event.</p>
-<p>Allowed values: <em>bodyStructure</em>, <em>clientAddress</em>, <em>diskUsed</em>, <em>flagNames</em>, <em>messageContent</em>, <em>messageSize</em>, <em>messages</em>, <em>modseq</em>, <em>service</em>, <em>timestamp</em>, <em>uidnext</em>, <em>vnd.cmu.midset</em>, <em>vnd.cmu.unseenMessages</em>, <em>vnd.cmu.envelope</em>, <em>vnd.cmu.sessionId</em>, <em>vnd.cmu.mailboxACL</em>, <em>vnd.cmu.mbtype</em>, <em>vnd.cmu.davFilename</em>, <em>vnd.cmu.davUid</em>, <em>vnd.fastmail.clientId</em>, <em>vnd.fastmail.sessionId</em>, <em>vnd.fastmail.convExists</em>, <em>vnd.fastmail.convUnseen</em>, <em>vnd.fastmail.cid</em>, <em>vnd.fastmail.counters</em></p>
+<p>Allowed values: <em>bodyStructure</em>, <em>clientAddress</em>, <em>diskUsed</em>, <em>flagNames</em>, <em>messageContent</em>, <em>messageSize</em>, <em>messages</em>, <em>modseq</em>, <em>service</em>, <em>timestamp</em>, <em>uidnext</em>, <em>vnd.cmu.midset</em>, <em>vnd.cmu.unseenMessages</em>, <em>vnd.cmu.envelope</em>, <em>vnd.cmu.sessionId</em>, <em>vnd.cmu.mailboxACL</em>, <em>vnd.cmu.mbtype</em>, <em>vnd.cmu.davFilename</em>, <em>vnd.cmu.davUid</em>, <em>vnd.fastmail.clientId</em>, <em>vnd.fastmail.sessionId</em>, <em>vnd.fastmail.convExists</em>, <em>vnd.fastmail.convUnseen</em>, <em>vnd.fastmail.cid</em>, <em>vnd.fastmail.counters</em>, <em>vnd.cmu.emailid</em>, <em>vnd.cmu.threadid</em></p>
 </div></blockquote>
 </div></blockquote>
 <blockquote>
@@ -859,7 +878,7 @@ now it remains against the day that Appl
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="config-mailboxdistribution.html" class="btn btn-neutral float-right" title="Mailbox Distribution" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="monitoring.html" class="btn btn-neutral float-right" title="Monitoring" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="sop/userdeny.html" class="btn btn-neutral" title="Managing user_deny.db" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -871,7 +890,7 @@ now it remains against the day that Appl
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 26 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -891,7 +910,7 @@ now it remains against the day that Appl
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations/archive-partitions.html 3.2.0-3/doc/html/imap/reference/admin/locations/archive-partitions.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations/archive-partitions.html	2019-12-16 04:17:28.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations/archive-partitions.html	2020-05-04 04:12:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Archive Partitions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Archive Partitions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="File &amp; Directory Locations" href="../locations.html"/>
         <link rel="next" title="Configuration file locations" href="configuration-state.html"/>
         <link rel="prev" title="File &amp; Directory Locations" href="../locations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations/archive-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations/archive-partitions.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -845,7 +864,7 @@ something like this (again, building on
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -865,7 +884,7 @@ something like this (again, building on
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations/configuration-state.html 3.2.0-3/doc/html/imap/reference/admin/locations/configuration-state.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations/configuration-state.html	2019-12-16 04:17:28.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations/configuration-state.html	2020-05-04 04:12:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Configuration file locations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Configuration file locations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="File &amp; Directory Locations" href="../locations.html"/>
         <link rel="next" title="Directory Hashing" href="hashing.html"/>
         <link rel="prev" title="Archive Partitions" href="archive-partitions.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations/configuration-state.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations/configuration-state.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -982,12 +1001,6 @@ match the path specified in cyrus.conf(5
 <blockquote>
 <div>Unix domain socket that the mail notification daemon listens on.</div></blockquote>
 </div></blockquote>
-<blockquote>
-<div><p><code class="docutils literal"><span class="pre">sphinx_socket:</span></code> {configdirectory}/socket/sphinx</p>
-<blockquote>
-<div>Unix domain socket that the Sphinx searchd
-daemons listens on.</div></blockquote>
-</div></blockquote>
 </div>
 <div class="section" id="per-user-state-directories">
 <h1>Per-user State Directories<a class="headerlink" href="#per-user-state-directories" title="Permalink to this headline">¶</a></h1>
@@ -1025,7 +1038,7 @@ are:</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1045,7 +1058,7 @@ are:</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations/hashing.html 3.2.0-3/doc/html/imap/reference/admin/locations/hashing.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations/hashing.html	2019-12-16 04:17:28.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations/hashing.html	2020-05-04 04:12:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Directory Hashing &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Directory Hashing &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="File &amp; Directory Locations" href="../locations.html"/>
         <link rel="next" title="Spool Directories" href="mailspool.html"/>
         <link rel="prev" title="Configuration file locations" href="configuration-state.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations/hashing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations/hashing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -817,7 +836,7 @@ always be hashed.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 23 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 23 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@ always be hashed.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations/mailspool.html 3.2.0-3/doc/html/imap/reference/admin/locations/mailspool.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations/mailspool.html	2019-12-16 04:17:29.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations/mailspool.html	2020-05-04 04:12:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Spool Directories &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Spool Directories &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="File &amp; Directory Locations" href="../locations.html"/>
         <link rel="next" title="Search Tiers" href="searchtiers.html"/>
         <link rel="prev" title="Directory Hashing" href="hashing.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations/mailspool.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations/mailspool.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -907,7 +926,7 @@ which spool partitions will have separat
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -927,7 +946,7 @@ which spool partitions will have separat
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations/searchtiers.html 3.2.0-3/doc/html/imap/reference/admin/locations/searchtiers.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations/searchtiers.html	2019-12-16 04:17:29.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations/searchtiers.html	2020-05-04 04:12:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Search Tiers &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Search Tiers &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="File &amp; Directory Locations" href="../locations.html"/>
         <link rel="next" title="Ports and Sockets" href="../ports-sockets.html"/>
         <link rel="prev" title="Spool Directories" href="mailspool.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations/searchtiers.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations/searchtiers.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -791,7 +810,7 @@ of an according <em>searchtierpartition-
 </div></blockquote>
 </div>
 <div class="section" id="search-tier-partition-location">
-<h2>Search Tier Partition location<a class="headerlink" href="#search-tier-partition-location" title="Permalink to this headline">¶</a></h2>
+<h2>Search Tier Partition Location<a class="headerlink" href="#search-tier-partition-location" title="Permalink to this headline">¶</a></h2>
 <p>Each search tier to be used requires a partition location be specified
 via a <cite>searchpartition-name</cite> setting, wherein &#8220;name&#8221; is replaced
 with the name of the mail spool for which this search partition is to
@@ -864,7 +883,7 @@ store this tier1&#8217;s search index fo
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 29 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 25 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -884,7 +903,7 @@ store this tier1&#8217;s search index fo
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/locations.html 3.2.0-3/doc/html/imap/reference/admin/locations.html
--- 3.0.13-5/doc/html/imap/reference/admin/locations.html	2019-12-16 04:17:27.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/locations.html	2020-05-04 04:12:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>File &amp; Directory Locations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>File &amp; Directory Locations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Archive Partitions" href="locations/archive-partitions.html"/>
         <link rel="prev" title="System Architecture" href="../architecture.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/locations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/locations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -978,7 +997,7 @@ store this tier1&#8217;s search index fo
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 05 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 05 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -998,7 +1017,7 @@ store this tier1&#8217;s search index fo
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/monitoring.html 3.2.0-3/doc/html/imap/reference/admin/monitoring.html
--- 3.0.13-5/doc/html/imap/reference/admin/monitoring.html	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/monitoring.html	2020-05-04 04:12:41.000000000 +0000
@@ -0,0 +1,915 @@
+
+
+<!DOCTYPE html>
+<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  
+  <title>Monitoring &mdash; Cyrus IMAP 3.2.0 documentation</title>
+  
+
+  
+  
+    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
+  
+
+  
+
+  
+  
+    
+
+  
+
+  
+  
+    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
+  
+
+  
+    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
+  
+
+  
+        <link rel="index" title="Index"
+              href="../../../genindex.html"/>
+        <link rel="search" title="Search" href="../../../search.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
+        <link rel="up" title="Administrator Guide" href="../admin.html"/>
+        <link rel="next" title="Mailbox Distribution" href="config-mailboxdistribution.html"/>
+        <link rel="prev" title="Cyrus Event Source" href="eventsource.html"/> 
+
+  
+  
+  
+
+</head>
+
+<body class="wy-body-for-nav" role="document">
+
+
+  
+
+<div class="pageheader">
+  <ul>
+    <li><a href="../../../index.html">Home</a></li>
+    <li><a href="../../../download.html">Download</a></li>
+    <li><a href="../../../contribute.html">Contribute</a></li>
+    <li><a href="../../../support.html">Support</a></li>
+    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+  </ul>
+  <div>
+    <a href="../../../index.html">
+      <img src="../../../_static/logo.gif" alt="CYRUS" />
+    </a>
+  </div>
+</div>
+<div style="clear: both;"></div>
+
+
+  <div class="wy-grid-for-nav">
+
+    
+    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
+      <div class="wy-side-nav-search">
+        
+
+        
+ 
+          <a href="../../../index.html">
+ 
+
+  
+          
+          <img src="../../../_static/logo.gif"  />
+     
+        </a>
+
+        
+<div role="search">
+  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
+    <input type="text" name="q" placeholder="Search docs" />
+    <input type="hidden" name="check_keywords" value="yes" />
+    <input type="hidden" name="area" value="default" />
+  </form>
+</div>
+
+        
+      </div>
+
+      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
+        
+          
+          
+              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
+<ul class="current">
+<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../developer/compiling.html">Compiling</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#compile">Compile</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#check">Check</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1 current"><a class="reference internal" href="../../../operations.html">Operations</a><ul class="current">
+<li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#system-commands">(8) System Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/master.html"><strong>master</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#user-commands">(1) User Commands</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
+<li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
+</ul>
+</li>
+<li class="toctree-l3 current"><a class="reference internal" href="../admin.html#management">Management</a><ul class="current">
+<li class="toctree-l4"><a class="reference internal" href="locations.html">File &amp; Directory Locations</a></li>
+<li class="toctree-l4"><a class="reference internal" href="ports-sockets.html">Ports and Sockets</a></li>
+<li class="toctree-l4"><a class="reference internal" href="access-control.html">Access Control</a></li>
+<li class="toctree-l4"><a class="reference internal" href="quotas.html">Quotas</a></li>
+<li class="toctree-l4"><a class="reference internal" href="sieve.html">Cyrus Sieve</a></li>
+<li class="toctree-l4"><a class="reference internal" href="backups.html">Cyrus Backups</a></li>
+<li class="toctree-l4"><a class="reference internal" href="nntp.html">Cyrus NNTP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
+<li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#">Monitoring</a></li>
+<li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
+<li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
+<li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
+<li class="toctree-l4"><a class="reference internal" href="tweaking.html">Tweaking Cyrus IMAP</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../faq.html">Frequently Asked Questions</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../faq.html#features">Features</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-telemetry.html">How to enable telemetry</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../developers.html">Developers</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer/documentation.html">Contribute docs</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#overview">Overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#building-the-files">Building the files</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#special-tags">Special Tags</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#rfc">rfc</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#cyrusman">cyrusman</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#synopsis">Synopsis</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#examples">Examples</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/process.html">Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/overview.html">Overview of Cyrus development environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/github-guide.html">GitHub guide</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/namespaces.html">Namespaces: a developer view</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/libraries.html">Developer Libraries</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
+<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
+<ul>
+<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
+</ul>
+
+          
+        
+      </div>
+        
+<div class="buildstatus">
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
+</div>
+      &nbsp;
+    </nav>
+
+    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
+
+      
+      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
+        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
+        <a href="../../../index.html">Cyrus IMAP</a>
+      </nav>
+
+
+      
+      <div class="wy-nav-content">
+        <div class="rst-content">
+
+          <div role="navigation" aria-label="breadcrumbs navigation">
+  <ul class="wy-breadcrumbs">
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
+      
+          <li><a href="../../../operations.html">Operations</a> &raquo;</li>
+      
+          <li><a href="../admin.html">Administrator Guide</a> &raquo;</li>
+      
+    <li>Monitoring</li>
+      <li class="wy-breadcrumbs-aside">
+        
+          
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/monitoring.rst" class="fa fa-github"> Edit on GitHub</a>
+          
+        
+      </li>
+  </ul>
+  <hr/>
+</div>
+          <div role="main" class="document">
+            
+  <div class="section" id="monitoring">
+<span id="imap-admin-monitoring"></span><h1>Monitoring<a class="headerlink" href="#monitoring" title="Permalink to this headline">¶</a></h1>
+<p>Cyrus IMAP supports monitoring using <a class="reference external" href="https://prometheus.io">Prometheus</a>.</p>
+<p>To use this functionality, Cyrus IMAP must have been built with the
+<code class="docutils literal"><span class="pre">--enable-http</span></code> configure option enabled.</p>
+<div class="section" id="setup">
+<span id="imap-admin-monitoring-setup"></span><h2>Setup<a class="headerlink" href="#setup" title="Permalink to this headline">¶</a></h2>
+<blockquote>
+<div><ul class="simple">
+<li>Set the <cite>prometheus_enabled</cite> setting in <a class="reference internal" href="../manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> to &#8220;yes&#8221;</li>
+<li>Add the <cite>prometheus</cite> module to your <cite>httpmodules</cite> in <a class="reference internal" href="../manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a></li>
+<li>Set the <cite>prometheus_need_auth</cite>, <cite>prometheus_update_freq</cite> and <cite>prometheus_stats_dir</cite>
+settings in <a class="reference internal" href="../manpages/configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> to taste</li>
+<li>Add a job to run <code class="docutils literal"><span class="pre">promstatsd</span> <span class="pre">-c</span></code> to the START section of <a class="reference internal" href="../manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>
+(this cleans up the stats files from the previous run)</li>
+<li>Add a job to run <code class="docutils literal"><span class="pre">promstatsd</span></code> to the DAEMON section of <a class="reference internal" href="../manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>
+(the actual daemon process)</li>
+<li>Configure your Prometheus server to scrape <a class="reference external" href="http://yourserver.example.com/metrics">http://yourserver.example.com/metrics</a></li>
+</ul>
+</div></blockquote>
+</div>
+<div class="section" id="configuration-options">
+<h2>Configuration options<a class="headerlink" href="#configuration-options" title="Permalink to this headline">¶</a></h2>
+<blockquote>
+<div><blockquote>
+<div><p><code class="docutils literal"><span class="pre">prometheus_enabled:</span></code> 0</p>
+<blockquote>
+<div>Whether tracking of service metrics for Prometheus is enabled.</div></blockquote>
+</div></blockquote>
+<blockquote>
+<div><p><code class="docutils literal"><span class="pre">prometheus_need_auth:</span></code> admin</p>
+<blockquote>
+<div><p>Authentication level required to fetch Prometheus metrics.</p>
+<p>Allowed values: <em>none</em>, <em>user</em>, <em>admin</em></p>
+</div></blockquote>
+</div></blockquote>
+<blockquote>
+<div><p><code class="docutils literal"><span class="pre">prometheus_update_freq:</span></code> 10s</p>
+<blockquote>
+<div><p>Frequency in at which promstatsd should re-collate its statistics
+report.  The minimum value is 1 second, the default is 10 seconds.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+</div></blockquote>
+<blockquote>
+<div><p><code class="docutils literal"><span class="pre">prometheus_stats_dir:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>Directory to use for gathering prometheus statistics.  If specified,
+must be an absolute path.  If not specified, the default path
+$configdirectory/stats/ will be used.  It may be advantageous to locate this
+directory on ephemeral storage.</div></blockquote>
+</div></blockquote>
+</div></blockquote>
+<p id="imap-admin-monitoring-end">Back to <a class="reference internal" href="../admin.html#imap-admin"><span class="std std-ref">Administrator Guide</span></a></p>
+</div>
+</div>
+
+
+          </div>
+          <footer>
+  
+    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
+      
+        <a href="config-mailboxdistribution.html" class="btn btn-neutral float-right" title="Mailbox Distribution" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+      
+      
+        <a href="eventsource.html" class="btn btn-neutral" title="Cyrus Event Source" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+      
+    </div>
+  
+
+  <hr/>
+
+  <div role="contentinfo">
+    <p>
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 01 2017
+    </p>
+  </div>
+  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
+
+</footer>
+        </div>
+      </div>
+
+    </section>
+
+  </div>
+  
+
+
+  
+
+    <script type="text/javascript">
+        var DOCUMENTATION_OPTIONS = {
+            URL_ROOT:'../../../',
+            VERSION:'3.2.0',
+            COLLAPSE_INDEX:false,
+            FILE_SUFFIX:'.html',
+            HAS_SOURCE:  true
+        };
+    </script>
+      <script type="text/javascript" src="../../../_static/jquery.js"></script>
+      <script type="text/javascript" src="../../../_static/underscore.js"></script>
+      <script type="text/javascript" src="../../../_static/doctools.js"></script>
+      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
+
+  
+
+  
+  
+    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
+  
+
+  
+  
+  <script type="text/javascript">
+<!--      jQuery(function () {
+          SphinxRtdTheme.StickyNav.enable();
+      }); -->
+  </script>
+  
+ 
+
+
+
+</body>
+</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder-concepts.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder-concepts.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder-concepts.html	2019-12-16 04:17:29.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder-concepts.html	2020-05-04 04:12:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder: Concepts &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder: Concepts &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Cyrus Murder" href="murder.html"/>
         <link rel="next" title="Cyrus Murder: Installation and Administration" href="murder-installation.html"/>
         <link rel="prev" title="Cyrus Murder" href="murder.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder-concepts.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder-concepts.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1339,7 +1358,7 @@ xxx.</dd>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1359,7 +1378,7 @@ xxx.</dd>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder-failure-modes.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder-failure-modes.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder-failure-modes.html	2019-12-16 04:17:30.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder-failure-modes.html	2020-05-04 04:12:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder Failure Modes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder Failure Modes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Cyrus Murder" href="murder.html"/>
         <link rel="next" title="Cyrus Murder Mail Delivery" href="murder-mail-delivery.html"/>
         <link rel="prev" title="Cyrus Murder Mupdate Details" href="murder-mupdate-details.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder-failure-modes.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder-failure-modes.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -799,7 +818,7 @@
 <li>Start everything backup</li>
 <li>Use ctl_mboxlist -m on each backend to update the murder master with any missing changes.</li>
 </ol>
-<p>If you are using skiplist for your mailboxes.db then you can just copy the file. If you are using a berkeley format then things are trickier since there is environmental state. It should be possible to run db_recover on both databases, then delete the db folder the mailboxes.db from the murder master and copy those from the frontend (this has not been tested)</p>
+<p>If you are using skiplist for your mailboxes.db then you can just copy the file.</p>
 </div>
 <div class="section" id="hard-recovery">
 <h3>Hard recovery<a class="headerlink" href="#hard-recovery" title="Permalink to this headline">¶</a></h3>
@@ -832,7 +851,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -852,7 +871,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder.html	2019-12-16 04:17:29.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder.html	2020-05-04 04:12:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../../admin.html"/>
         <link rel="next" title="Cyrus Murder: Concepts" href="murder-concepts.html"/>
         <link rel="prev" title="Mailbox Distribution" href="../config-mailboxdistribution.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -837,7 +856,7 @@ future, should probably just consider us
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -857,7 +876,7 @@ future, should probably just consider us
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder-installation.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder-installation.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder-installation.html	2019-12-16 04:17:30.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder-installation.html	2020-05-04 04:12:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder: Installation and Administration &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder: Installation and Administration &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Cyrus Murder" href="murder.html"/>
         <link rel="next" title="Cyrus Murder Mupdate Details" href="murder-mupdate-details.html"/>
         <link rel="prev" title="Cyrus Murder: Concepts" href="murder-concepts.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder-installation.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder-installation.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1253,7 +1272,7 @@ and <a class="reference external" href="
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 28 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1273,7 +1292,7 @@ and <a class="reference external" href="
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder-mail-delivery.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder-mail-delivery.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder-mail-delivery.html	2019-12-16 04:17:30.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder-mail-delivery.html	2020-05-04 04:12:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder Mail Delivery &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder Mail Delivery &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Cyrus Murder" href="murder.html"/>
         <link rel="next" title="HOWTO: Using an NGINX IMAP Proxy" href="../nginx-proxy.html"/>
         <link rel="prev" title="Cyrus Murder Failure Modes" href="murder-failure-modes.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder-mail-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder-mail-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -831,7 +850,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -851,7 +870,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/murder/murder-mupdate-details.html 3.2.0-3/doc/html/imap/reference/admin/murder/murder-mupdate-details.html
--- 3.0.13-5/doc/html/imap/reference/admin/murder/murder-mupdate-details.html	2019-12-16 04:17:31.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/murder/murder-mupdate-details.html	2020-05-04 04:12:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Murder Mupdate Details &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Murder Mupdate Details &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Cyrus Murder" href="murder.html"/>
         <link rel="next" title="Cyrus Murder Failure Modes" href="murder-failure-modes.html"/>
         <link rel="prev" title="Cyrus Murder: Installation and Administration" href="murder-installation.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/murder/murder-mupdate-details.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/murder/murder-mupdate-details.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -956,7 +975,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -976,7 +995,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/nginx-proxy.html 3.2.0-3/doc/html/imap/reference/admin/nginx-proxy.html
--- 3.0.13-5/doc/html/imap/reference/admin/nginx-proxy.html	2019-12-16 04:17:31.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/nginx-proxy.html	2020-05-04 04:12:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>HOWTO: Using an NGINX IMAP Proxy &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>HOWTO: Using an NGINX IMAP Proxy &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Tweaking Cyrus IMAP" href="tweaking.html"/>
         <link rel="prev" title="Cyrus Murder Mail Delivery" href="murder/murder-mail-delivery.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/nginx-proxy.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/nginx-proxy.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -788,7 +807,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -808,7 +827,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/nntp.html 3.2.0-3/doc/html/imap/reference/admin/nntp.html
--- 3.0.13-5/doc/html/imap/reference/admin/nntp.html	2019-12-16 04:17:31.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/nntp.html	2020-05-04 04:12:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus NNTP &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus NNTP &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Cyrus Prot Layer" href="protlayer.html"/>
         <link rel="prev" title="Cyrus Backups" href="backups.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/nntp.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/nntp.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -915,7 +934,7 @@ Rpost + $+ &lt; @ $=w . &gt;
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -935,7 +954,7 @@ Rpost + $+ &lt; @ $=w . &gt;
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/ports/services.html 3.2.0-3/doc/html/imap/reference/admin/ports/services.html
--- 3.0.13-5/doc/html/imap/reference/admin/ports/services.html	2019-12-16 04:17:32.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/ports/services.html	2020-05-04 04:12:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Service Definitions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Service Definitions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Ports and Sockets" href="../ports-sockets.html"/>
         <link rel="next" title="Cyrus Socket Locations" href="sockets.html"/>
         <link rel="prev" title="Ports and Sockets" href="../ports-sockets.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/ports/services.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/ports/services.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -817,7 +836,7 @@ consult the <a class="reference internal
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 12 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 12 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@ consult the <a class="reference internal
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/ports/sockets.html 3.2.0-3/doc/html/imap/reference/admin/ports/sockets.html
--- 3.0.13-5/doc/html/imap/reference/admin/ports/sockets.html	2019-12-16 04:17:32.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/ports/sockets.html	2020-05-04 04:12:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Socket Locations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Socket Locations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Ports and Sockets" href="../ports-sockets.html"/>
         <link rel="next" title="Access Control" href="../access-control.html"/>
         <link rel="prev" title="Cyrus Service Definitions" href="services.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/ports/sockets.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/ports/sockets.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -783,7 +802,6 @@ directory for Cyrus sockets. This defaul
 <span class="n">idle</span>      <span class="o">&lt;</span><span class="n">rundir</span><span class="o">&gt;/</span><span class="n">idle</span>   <span class="c1"># idled daemon socket</span>
 <span class="n">notify</span>    <span class="o">&lt;</span><span class="n">rundir</span><span class="o">&gt;/</span><span class="n">notify</span> <span class="c1"># Notification daemon socket</span>
 <span class="n">ptloader</span>  <span class="o">&lt;</span><span class="n">rundir</span><span class="o">&gt;/</span><span class="n">ptsock</span> <span class="c1"># PT Loader socket (alternative authorization)</span>
-<span class="n">sphinx</span>    <span class="o">&lt;</span><span class="n">rundir</span><span class="o">&gt;/</span><span class="n">sphinx</span> <span class="c1"># Sphinx full-text search daemon socket</span>
 </pre></div>
 </div>
 <div class="section" id="controlling-socket-locations">
@@ -812,12 +830,6 @@ match the path specified in cyrus.conf(5
 <div>Unix domain socket that ptloader listens on.
 (defaults to configdirectory/ptclient/ptsock)</div></blockquote>
 </div></blockquote>
-<blockquote>
-<div><p><code class="docutils literal"><span class="pre">sphinx_socket:</span></code> {configdirectory}/socket/sphinx</p>
-<blockquote>
-<div>Unix domain socket that the Sphinx searchd
-daemons listens on.</div></blockquote>
-</div></blockquote>
 </div>
 </div>
 
@@ -839,7 +851,7 @@ daemons listens on.</div></blockquote>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 24 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -859,7 +871,7 @@ daemons listens on.</div></blockquote>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/ports-sockets.html 3.2.0-3/doc/html/imap/reference/admin/ports-sockets.html
--- 3.0.13-5/doc/html/imap/reference/admin/ports-sockets.html	2019-12-16 04:17:32.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/ports-sockets.html	2020-05-04 04:12:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Ports and Sockets &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Ports and Sockets &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Cyrus Service Definitions" href="ports/services.html"/>
         <link rel="prev" title="Search Tiers" href="locations/searchtiers.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/ports-sockets.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/ports-sockets.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@ and with other components.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 07 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@ and with other components.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/protlayer.html 3.2.0-3/doc/html/imap/reference/admin/protlayer.html
--- 3.0.13-5/doc/html/imap/reference/admin/protlayer.html	2019-12-16 04:17:32.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/protlayer.html	2020-05-04 04:12:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Prot Layer &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Prot Layer &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Standard Operating Procedures" href="sop.html"/>
         <link rel="prev" title="Cyrus NNTP" href="nntp.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/protlayer.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/protlayer.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -843,7 +862,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -863,7 +882,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/quotas/quotaroots.html 3.2.0-3/doc/html/imap/reference/admin/quotas/quotaroots.html
--- 3.0.13-5/doc/html/imap/reference/admin/quotas/quotaroots.html	2019-12-16 04:17:33.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/quotas/quotaroots.html	2020-05-04 04:12:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Quota Roots &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Quota Roots &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Quotas" href="../quotas.html"/>
         <link rel="next" title="Supported Quota Types" href="quotatypes.html"/>
         <link rel="prev" title="Quotas" href="../quotas.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/quotas/quotaroots.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/quotas/quotaroots.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -811,7 +830,7 @@ for instructions on how to delete them.<
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@ for instructions on how to delete them.<
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/quotas/quotatypes.html 3.2.0-3/doc/html/imap/reference/admin/quotas/quotatypes.html
--- 3.0.13-5/doc/html/imap/reference/admin/quotas/quotatypes.html	2019-12-16 04:17:33.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/quotas/quotatypes.html	2020-05-04 04:12:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Supported Quota Types &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Supported Quota Types &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Quotas" href="../quotas.html"/>
         <link rel="next" title="Cyrus Sieve" href="../sieve.html"/>
         <link rel="prev" title="Quota Roots" href="quotaroots.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/quotas/quotatypes.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/quotas/quotatypes.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -818,7 +837,7 @@ messages and/or folders below a given qu
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -838,7 +857,7 @@ messages and/or folders below a given qu
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/quotas.html 3.2.0-3/doc/html/imap/reference/admin/quotas.html
--- 3.0.13-5/doc/html/imap/reference/admin/quotas.html	2019-12-16 04:17:33.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/quotas.html	2020-05-04 04:12:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Quotas &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Quotas &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Quota Roots" href="quotas/quotaroots.html"/>
         <link rel="prev" title="Access Control Lists Rights Reference" href="access-control/rights-reference.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/quotas.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/quotas.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -863,7 +882,7 @@ This is controlled by the <code class="d
 <div><p><code class="docutils literal"><span class="pre">quota_db:</span></code> quotalegacy</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for quotas.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>quotalegacy</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>quotalegacy</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 </div></blockquote>
 <blockquote>
@@ -915,7 +934,7 @@ the first argument (&#8220;&lt;old db&gt
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 20 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 20 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -935,7 +954,7 @@ the first argument (&#8220;&lt;old db&gt
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sieve.html 3.2.0-3/doc/html/imap/reference/admin/sieve.html
--- 3.0.13-5/doc/html/imap/reference/admin/sieve.html	2019-12-16 04:17:33.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sieve.html	2020-05-04 04:12:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Sieve &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Sieve &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Cyrus Backups" href="backups.html"/>
         <link rel="prev" title="Supported Quota Types" href="quotas/quotatypes.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sieve.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sieve.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -947,8 +966,14 @@ utility, in communication with the <a cl
 <li>Date <span class="target" id="index-12"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5260.html"><strong>RFC 5260</strong></a></li>
 <li>Index <span class="target" id="index-13"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5260.html"><strong>RFC 5260</strong></a></li>
 <li>Variables <span class="target" id="index-14"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5229.html"><strong>RFC 5229</strong></a></li>
+<li>Editheader Extension <span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5293.html"><strong>RFC 5293</strong></a></li>
+<li>Reject and Extended Reject <span class="target" id="index-16"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5429.html"><strong>RFC 5429</strong></a></li>
+<li>Externally Stored Lists <span class="target" id="index-17"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6134.html"><strong>RFC 6134</strong></a></li>
+<li>Duplicate Extension <span class="target" id="index-18"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7352.html"><strong>RFC 7352</strong></a></li>
+<li>Ihave Extension <span class="target" id="index-19"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5463.html"><strong>RFC 5463</strong></a></li>
+<li>Delivering to Special-Use Mailboxes <a class="reference external" href="http://tools.ietf.org/html/draft-bosch-sieve-special-use-01">Draft special-use RFC</a></li>
 <li>IMAP flag Extension <a class="reference external" href="http://tools.ietf.org/html/draft-ietf-sieve-imapflags-05">Draft imap flags RFC</a></li>
-<li>Body Extension <span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5173.html"><strong>RFC 5173</strong></a></li>
+<li>Body Extension <span class="target" id="index-20"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5173.html"><strong>RFC 5173</strong></a></li>
 </ul>
 <p>Note that the final RFCs of these last sieve extensions have significant changes that are not currently supported.</p>
 </div>
@@ -991,7 +1016,7 @@ utility, in communication with the <a cl
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Nov 15 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 19 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1011,7 +1036,7 @@ utility, in communication with the <a cl
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/administration-running.html 3.2.0-3/doc/html/imap/reference/admin/sop/administration-running.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/administration-running.html	2019-12-16 04:17:34.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/administration-running.html	2020-05-04 04:12:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Running Cyrus IMAP Services on Non-Standard Ports &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Running Cyrus IMAP Services on Non-Standard Ports &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Reconstructing Mailboxes" href="reconstructing.html"/>
         <link rel="prev" title="Deleting and Undeleting Messages and Folders" href="deleting.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/administration-running.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/administration-running.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -828,7 +847,7 @@ label the port used: semanage port -a -t
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -848,7 +867,7 @@ label the port used: semanage port -a -t
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/altnamespace.html 3.2.0-3/doc/html/imap/reference/admin/sop/altnamespace.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/altnamespace.html	2019-12-16 04:17:34.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/altnamespace.html	2020-05-04 04:12:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Alternative Namespace &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Alternative Namespace &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Deleting and Undeleting Messages and Folders" href="deleting.html"/>
         <link rel="prev" title="Reloading Cyrus IMAP Services" href="reloading.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/altnamespace.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/altnamespace.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@ and messages.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 12 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 12 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@ and messages.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/deleting.html 3.2.0-3/doc/html/imap/reference/admin/sop/deleting.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/deleting.html	2019-12-16 04:17:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/deleting.html	2020-05-04 04:12:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Deleting and Undeleting Messages and Folders &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Deleting and Undeleting Messages and Folders &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Running Cyrus IMAP Services on Non-Standard Ports" href="administration-running.html"/>
         <link rel="prev" title="Alternative Namespace" href="altnamespace.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/deleting.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/deleting.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -985,7 +1004,7 @@ with a backslash.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1005,7 +1024,7 @@ with a backslash.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/mailbox-operations.html 3.2.0-3/doc/html/imap/reference/admin/sop/mailbox-operations.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/mailbox-operations.html	2019-12-16 04:17:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/mailbox-operations.html	2020-05-04 04:12:49.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Operations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Operations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Mailbox Folders exempt from quota" href="mailbox-quota.html"/>
         <link rel="prev" title="Replication: Installation and Administration" href="replication.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/mailbox-operations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/mailbox-operations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,7 +816,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -817,7 +836,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/mailbox-quota.html 3.2.0-3/doc/html/imap/reference/admin/sop/mailbox-quota.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/mailbox-quota.html	2019-12-16 04:17:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/mailbox-quota.html	2020-05-04 04:12:49.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailbox Folders exempt from quota &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailbox Folders exempt from quota &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Mailbox Operations" href="mailbox-operations.html"/>
         <link rel="next" title="Reloading Cyrus IMAP Services" href="reloading.html"/>
         <link rel="prev" title="Mailbox Operations" href="mailbox-operations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -761,7 +780,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/mailbox-quota.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/mailbox-quota.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -772,7 +791,7 @@
             
   <div class="section" id="mailbox-folders-exempt-from-quota">
 <h1>Mailbox Folders exempt from quota<a class="headerlink" href="#mailbox-folders-exempt-from-quota" title="Permalink to this headline">¶</a></h1>
-<p>By creating an additional quota root, a folder&#8217;s contents can be made excempt from counting towards the mailbox&#8217;s quota.</p>
+<p>By creating an additional quota root, a folder&#8217;s contents can be made exempt from counting towards the mailbox&#8217;s quota.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p>Making an INBOX/Archive/ Folder exempt from quota:</p>
@@ -805,7 +824,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -825,7 +844,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/reconstructing.html 3.2.0-3/doc/html/imap/reference/admin/sop/reconstructing.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/reconstructing.html	2019-12-16 04:17:35.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/reconstructing.html	2020-05-04 04:12:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Reconstructing Mailboxes &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Reconstructing Mailboxes &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Using Squatter for Faster IMAP SEARCH" href="squatter.html"/>
         <link rel="prev" title="Running Cyrus IMAP Services on Non-Standard Ports" href="administration-running.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/reconstructing.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/reconstructing.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -822,7 +841,7 @@ user/jdoe/Drafts@example.com
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 17 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 17 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -842,7 +861,7 @@ user/jdoe/Drafts@example.com
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/reloading.html 3.2.0-3/doc/html/imap/reference/admin/sop/reloading.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/reloading.html	2019-12-16 04:17:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/reloading.html	2020-05-04 04:12:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Reloading Cyrus IMAP Services &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Reloading Cyrus IMAP Services &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Alternative Namespace" href="altnamespace.html"/>
         <link rel="prev" title="Mailbox Folders exempt from quota" href="mailbox-quota.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/reloading.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/reloading.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -803,7 +822,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -823,7 +842,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/replication.html 3.2.0-3/doc/html/imap/reference/admin/sop/replication.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/replication.html	2019-12-16 04:17:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/replication.html	2020-05-04 04:12:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Replication: Installation and Administration &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Replication: Installation and Administration &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Mailbox Operations" href="mailbox-operations.html"/>
         <link rel="prev" title="Standard Operating Procedures" href="../sop.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/replication.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/replication.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1081,7 +1100,7 @@ be handled via a <em class="manpage">cro
 EVENTS section of <a class="reference internal" href="../../manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> like any of these:</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">EVENTS</span> <span class="p">{</span>
     <span class="o">&lt;...&gt;</span>
-    <span class="c1"># Peridoically sync ALL user mailboxes every 4 hours</span>
+    <span class="c1"># Periodically sync ALL user mailboxes every 4 hours</span>
     <span class="n">syncclient</span>       <span class="n">cmd</span><span class="o">=</span><span class="s2">&quot;/usr/cyrus/bin/sync_client -A&quot;</span> <span class="n">period</span><span class="o">=</span><span class="mi">240</span>
 
     <span class="c1"># Periodically sync changes at specific times</span>
@@ -1169,7 +1188,7 @@ exercise:</p>
 </pre></div>
 </div>
 <p>Again, this is just an example for illustration.  The system provides so
-much flexibility, and one can combine channels with chaining to acheive
+much flexibility, and one can combine channels with chaining to achieve
 even more.</p>
 </div>
 <div class="section" id="other-considerations">
@@ -1234,7 +1253,7 @@ record into the rolling replication log.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Feb 14 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 14 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1254,7 +1273,7 @@ record into the rolling replication log.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/splitting-metadata.html 3.2.0-3/doc/html/imap/reference/admin/sop/splitting-metadata.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/splitting-metadata.html	2019-12-16 04:17:36.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/splitting-metadata.html	2020-05-04 04:12:51.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Splitting Metadata from Partitions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Splitting Metadata from Partitions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Managing user_deny.db" href="userdeny.html"/>
         <link rel="prev" title="Using Squatter for Faster IMAP SEARCH" href="squatter.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/splitting-metadata.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/splitting-metadata.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -817,7 +836,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/squatter.html 3.2.0-3/doc/html/imap/reference/admin/sop/squatter.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/squatter.html	2019-12-16 04:17:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/squatter.html	2020-05-04 04:12:51.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Using Squatter for Faster IMAP SEARCH &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Using Squatter for Faster IMAP SEARCH &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Splitting Metadata from Partitions" href="splitting-metadata.html"/>
         <link rel="prev" title="Reconstructing Mailboxes" href="reconstructing.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/squatter.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/squatter.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -807,7 +826,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -827,7 +846,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop/userdeny.html 3.2.0-3/doc/html/imap/reference/admin/sop/userdeny.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop/userdeny.html	2019-12-16 04:17:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop/userdeny.html	2020-05-04 04:12:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Managing user_deny.db &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Managing user_deny.db &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Standard Operating Procedures" href="../sop.html"/>
         <link rel="next" title="Cyrus Event Source" href="../eventsource.html"/>
         <link rel="prev" title="Splitting Metadata from Partitions" href="splitting-metadata.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="reference internal" href="../sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -759,7 +778,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop/userdeny.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop/userdeny.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -771,20 +790,19 @@
   <div class="section" id="managing-user-deny-db">
 <h1>Managing user_deny.db<a class="headerlink" href="#managing-user-deny-db" title="Permalink to this headline">¶</a></h1>
 <p>The user_deny database allows you to deny access via POP/IMAP even if the user can authenticate to the Cyrus server. For example, if the authentication data is also used for other network services.</p>
+<p>Use <a class="reference internal" href="../../manpages/systemcommands/cyr_deny.html#std:cyrusman-cyr_deny(8)">cyr_deny(8)</a> to manage the database.</p>
 <p>If the user_deny.db file doesn&#8217;t exist in %configdirectory% (often /var/lib/imap) then you&#8217;ll need to create it. In the example below, /var/lib/imap/ is used.</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="c1"># echo &quot;&quot; &gt; /tmp/user_deny.flat</span>
 <span class="c1"># /usr/lib/cyrus-imapd/cvt_cyrusdb /tmp/user_deny.flat flat /var/lib/imap/user_deny.db skiplist</span>
 <span class="c1"># chown cyrus:cyrus /var/lib/imap/user_deny.db</span>
 </pre></div>
 </div>
-<p>The database specification can be found at <a class="reference external" href="http://cyrusimap.org/docs/cyrus-imapd/2.4.17/internal/database-formats.php">http://cyrusimap.org/docs/cyrus-imapd/2.4.17/internal/database-formats.php</a></p>
-<p><strong>Key:</strong> &lt;Userid&gt;</p>
-<p><strong>Data:</strong> &lt;Version&gt;TAB&lt;Deny List (comma-separated wildmat patterns)&gt;TAB&lt;Deny Message&gt;</p>
+<p>The database specification can be found at <a class="reference internal" href="../../../concepts/deployment/databases.html#imap-concepts-deployment-db-userdeny"><span class="std std-ref">User Access (user_deny.db)</span></a>.</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span># su - cyrus
-$ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** &quot;2     pop3    Can&#39;t use pop.&quot;
+$ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** &quot;2&lt;tab&gt;pop3&lt;tab&gt;Can&#39;t use pop.&quot;
 </pre></div>
 </div>
-<p>In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.</p>
+<p>Here <cite>pop3</cite> is the service name as spelled in <a class="reference internal" href="../../manpages/configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>.  In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.</p>
 <p>If you got it right, when you authenticate via pop3 you should see something like the following:</p>
 <div class="highlight-default"><div class="highlight"><pre><span></span>$ telnet mail.example.org 110
 Trying 192.168.0.2...
@@ -817,7 +835,7 @@ Connection closed by foreign host.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +855,7 @@ Connection closed by foreign host.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/sop.html 3.2.0-3/doc/html/imap/reference/admin/sop.html
--- 3.0.13-5/doc/html/imap/reference/admin/sop.html	2019-12-16 04:17:34.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/sop.html	2020-05-04 04:12:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Standard Operating Procedures &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Standard Operating Procedures &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Replication: Installation and Administration" href="sop/replication.html"/>
         <link rel="prev" title="Cyrus Prot Layer" href="protlayer.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/sop.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/sop.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -837,7 +856,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 17 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 17 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -857,7 +876,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin/tweaking.html 3.2.0-3/doc/html/imap/reference/admin/tweaking.html
--- 3.0.13-5/doc/html/imap/reference/admin/tweaking.html	2019-12-16 04:17:37.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin/tweaking.html	2020-05-04 04:12:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Tweaking Cyrus IMAP &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Tweaking Cyrus IMAP &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Administrator Guide" href="../admin.html"/>
         <link rel="next" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="prev" title="HOWTO: Using an NGINX IMAP Proxy" href="nginx-proxy.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin/tweaking.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin/tweaking.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -880,6 +899,28 @@ for our Cyrus IMAP packages is to ensure
 </div>
 </li>
 </ol>
+<div class="section" id="mailbox-locking">
+<h3>Mailbox locking<a class="headerlink" href="#mailbox-locking" title="Permalink to this headline">¶</a></h3>
+<p>Cyrus IMAP uses fcntl(2) based file locking for mailboxes, for example during
+SELECT commands. To mitigate race conditions it locks mailbox names even
+for non-existing mailboxes. For example, if user foo issued the following
+command</p>
+<blockquote>
+<div><div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">SELECT</span> <span class="n">INBOX</span><span class="o">.</span><span class="n">x</span>
+</pre></div>
+</div>
+</div></blockquote>
+<p>for non-existing mailbox x, it creates a lock file</p>
+<blockquote>
+<div><div class="highlight-default"><div class="highlight"><pre><span></span>$CYRUS_CONFDIR/lock/user/foo/x.lock
+</pre></div>
+</div>
+</div></blockquote>
+<p>which might be left on the filesystem after completion of the command.</p>
+<p>This has in practice not shown to be an issue. If this is a concern however,
+keeping the lock file directory in a tmpfs allows for both fast locking and
+to purge stale locks during controlled Cyrus downtimes.</p>
+</div>
 </div>
 </div>
 
@@ -901,7 +942,7 @@ for our Cyrus IMAP packages is to ensure
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 24 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -921,7 +962,7 @@ for our Cyrus IMAP packages is to ensure
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/admin.html 3.2.0-3/doc/html/imap/reference/admin.html
--- 3.0.13-5/doc/html/imap/reference/admin.html	2019-12-16 04:17:25.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/admin.html	2020-05-04 04:12:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Administrator Guide &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Administrator Guide &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Operations" href="../../operations.html"/>
         <link rel="next" title="System Architecture" href="architecture.html"/>
-        <link rel="prev" title="Tools &amp; Utilities" href="administration-tools.html"/> 
+        <link rel="prev" title="synctest" href="manpages/usercommands/synctest.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="current reference internal" href="#">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../operations.html">Operations</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/admin.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/admin.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -871,6 +890,11 @@
 <li class="toctree-l2"><a class="reference internal" href="admin/eventsource.html#apple-push-service">Apple Push Service</a></li>
 </ul>
 </li>
+<li class="toctree-l1"><a class="reference internal" href="admin/monitoring.html">Monitoring</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="admin/monitoring.html#setup">Setup</a></li>
+<li class="toctree-l2"><a class="reference internal" href="admin/monitoring.html#configuration-options">Configuration options</a></li>
+</ul>
+</li>
 <li class="toctree-l1"><a class="reference internal" href="admin/config-mailboxdistribution.html">Mailbox Distribution</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="admin/config-mailboxdistribution.html#selection-modes">Selection Modes</a></li>
 <li class="toctree-l2"><a class="reference internal" href="admin/config-mailboxdistribution.html#special-cases">Special cases</a></li>
@@ -905,7 +929,7 @@
         <a href="architecture.html" class="btn btn-neutral float-right" title="System Architecture" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="administration-tools.html" class="btn btn-neutral" title="Tools &amp; Utilities" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="manpages/usercommands/synctest.html" class="btn btn-neutral" title="synctest" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -914,7 +938,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Apr 07 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 01 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -934,7 +958,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/administration-tools.html 3.2.0-3/doc/html/imap/reference/administration-tools.html
--- 3.0.13-5/doc/html/imap/reference/administration-tools.html	2019-12-16 04:17:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/administration-tools.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,920 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Tools &amp; Utilities &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../genindex.html"/>
-        <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
-        <link rel="up" title="Operations" href="../../operations.html"/>
-        <link rel="next" title="Administrator Guide" href="admin.html"/>
-        <link rel="prev" title="synctest" href="manpages/usercommands/synctest.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../index.html">Home</a></li>
-    <li><a href="../../download.html">Download</a></li>
-    <li><a href="../../contribute.html">Contribute</a></li>
-    <li><a href="../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../index.html">
-      <img src="../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../index.html">
- 
-
-  
-          
-          <img src="../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul class="current">
-<li class="toctree-l1"><a class="reference internal" href="../../download.html">Download</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../download/getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/release-notes/index.html">Release Notes</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../developer/compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1 current"><a class="reference internal" href="../../operations.html">Operations</a><ul class="current">
-<li class="toctree-l2"><a class="reference internal" href="manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2 current"><a class="current reference internal" href="#">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="faq.html">Frequently Asked Questions</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="faqs/feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="faq.html#installation-problems">Installation Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="faqs/r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="faq.html#common-operational-questions">Common Operational Questions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="faqs/interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../developer/documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../developer/releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../operations.html">Operations</a> &raquo;</li>
-      
-    <li>Tools &amp; Utilities</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/administration-tools.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="tools-utilities">
-<h1>Tools &amp; Utilities<a class="headerlink" href="#tools-utilities" title="Permalink to this headline">¶</a></h1>
-<div class="section" id="arbitron">
-<h2>arbitron<a class="headerlink" href="#arbitron" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="arbitronsort-pl">
-<h2>arbitronsort.pl<a class="headerlink" href="#arbitronsort-pl" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="chk-cyrus">
-<h2>chk_cyrus<a class="headerlink" href="#chk-cyrus" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="ctl-cyrusdb">
-<h2>ctl_cyrusdb<a class="headerlink" href="#ctl-cyrusdb" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="ctl-deliver">
-<h2>ctl_deliver<a class="headerlink" href="#ctl-deliver" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="ctl-mboxlist">
-<h2>ctl_mboxlist<a class="headerlink" href="#ctl-mboxlist" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cvt-cyrusdb">
-<h2>cvt_cyrusdb<a class="headerlink" href="#cvt-cyrusdb" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cvt-cyrusdb-all">
-<h2>cvt_cyrusdb_all<a class="headerlink" href="#cvt-cyrusdb-all" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-dbtool">
-<h2>cyr_dbtool<a class="headerlink" href="#cyr-dbtool" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-df">
-<h2>cyr_df<a class="headerlink" href="#cyr-df" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyrdump">
-<h2>cyrdump<a class="headerlink" href="#cyrdump" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-expire">
-<h2>cyr_expire<a class="headerlink" href="#cyr-expire" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-virusscan">
-<h2>cyr_virusscan<a class="headerlink" href="#cyr-virusscan" title="Permalink to this headline">¶</a></h2>
-<p>Tool to disinfect mailboxes by operation of external virus scanning
-library or provided IMAP SEARCH string.</p>
-</div>
-<div class="section" id="fetchnews">
-<h2>fetchnews<a class="headerlink" href="#fetchnews" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-sequence">
-<h2>cyr_sequence<a class="headerlink" href="#cyr-sequence" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-synclog">
-<h2>cyr_synclog<a class="headerlink" href="#cyr-synclog" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="cyr-userseen">
-<h2>cyr_userseen<a class="headerlink" href="#cyr-userseen" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="masssievec">
-<h2>masssievec<a class="headerlink" href="#masssievec" title="Permalink to this headline">¶</a></h2>
-<p>Script to mass compile Sieve scripts</p>
-</div>
-<div class="section" id="mbexamine">
-<h2>mbexamine<a class="headerlink" href="#mbexamine" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="mbpath">
-<h2>mbpath<a class="headerlink" href="#mbpath" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="mkimap">
-<h2>mkimap<a class="headerlink" href="#mkimap" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="mknewsgroups">
-<h2>mknewsgroups<a class="headerlink" href="#mknewsgroups" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="rehash">
-<h2>rehash<a class="headerlink" href="#rehash" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="translatesieve">
-<h2>translatesieve<a class="headerlink" href="#translatesieve" title="Permalink to this headline">¶</a></h2>
-<p>script to translate sieve scripts to use unixhierarchysep and/or altnamespace</p>
-</div>
-<div class="section" id="undohash">
-<h2>undohash<a class="headerlink" href="#undohash" title="Permalink to this headline">¶</a></h2>
-<p>absolutely ancient (downgrade to prior 1.6.2+), probably should be obsoleted entirely</p>
-</div>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="admin.html" class="btn btn-neutral float-right" title="Administrator Guide" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="manpages/usercommands/synctest.html" class="btn btn-neutral" title="synctest" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 09 2017
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/reference/architecture.html 3.2.0-3/doc/html/imap/reference/architecture.html
--- 3.0.13-5/doc/html/imap/reference/architecture.html	2019-12-16 04:17:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/architecture.html	2020-05-04 04:12:52.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>System Architecture &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>System Architecture &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Administrator Guide" href="admin.html"/>
         <link rel="next" title="File &amp; Directory Locations" href="admin/locations.html"/>
         <link rel="prev" title="Administrator Guide" href="admin.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2 current"><a class="reference internal" href="admin.html">Administrator Guide</a><ul class="current">
 <li class="toctree-l3 current"><a class="reference internal" href="admin.html#architecture">Architecture</a><ul class="current">
 <li class="toctree-l4 current"><a class="current reference internal" href="#">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/architecture.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/architecture.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -955,7 +974,7 @@ the same as running <code class="docutil
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -975,7 +994,7 @@ the same as running <code class="docutil
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faq.html 3.2.0-3/doc/html/imap/reference/faq.html
--- 3.0.13-5/doc/html/imap/reference/faq.html	2019-12-16 04:17:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faq.html	2020-05-04 04:12:53.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Frequently Asked Questions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Frequently Asked Questions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Operations" href="../../operations.html"/>
         <link rel="next" title="Which database backend should I use for which databases?" href="faqs/feature-database-backend.html"/>
         <link rel="prev" title="Tweaking Cyrus IMAP" href="admin/tweaking.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../operations.html">Operations</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faq.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faq.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -780,10 +799,8 @@
 <div class="toctree-wrapper compound">
 <ul>
 <li class="toctree-l1"><a class="reference internal" href="faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l1"><a class="reference internal" href="faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l1"><a class="reference internal" href="faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </div>
 </div>
@@ -804,10 +821,8 @@
 <ul>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l1"><a class="reference internal" href="faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l1"><a class="reference internal" href="faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l1"><a class="reference internal" href="faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -858,7 +873,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -878,7 +893,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/feature-database-backend.html 3.2.0-3/doc/html/imap/reference/faqs/feature-database-backend.html
--- 3.0.13-5/doc/html/imap/reference/faqs/feature-database-backend.html	2019-12-16 04:17:38.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/feature-database-backend.html	2020-05-04 04:12:53.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Which database backend should I use for which databases? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Which database backend should I use for which databases? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Duplicate Delivery Suppression" href="feature-duplicate-delivery.html"/>
         <link rel="prev" title="Frequently Asked Questions" href="../faq.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/feature-database-backend.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/feature-database-backend.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -770,8 +789,6 @@
 <h1>Which database backend should I use for which databases?<a class="headerlink" href="#which-database-backend-should-i-use-for-which-databases" title="Permalink to this headline">¶</a></h1>
 <p>Here&#8217;s a brief summary of the major database types:</p>
 <ul class="simple">
-<li><strong>Berkeley DB</strong>: Slow enumeration, fast random access, fast write, binary support. However, it has proved to be somewhat unstable and prone to locking problems.</li>
-<li><strong>Berkeley DB (no sync)</strong>: Slow enumeration, fast random access, very fast write, binary support, but no guarantee of database durability; recent writes can be lost on crashes.</li>
 <li><strong>Skiplist</strong>: Proprietary Cyrus Format, fast enumeration, moderately fast write, moderately fast random access, binary support</li>
 <li><strong>Flat</strong>: Easy to maintain format, fast enumeration, very slow write, moderate random access, no binary support</li>
 </ul>
@@ -799,7 +816,7 @@ what the defaults are.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -819,7 +836,7 @@ what the defaults are.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/feature-duplicate-delivery.html 3.2.0-3/doc/html/imap/reference/faqs/feature-duplicate-delivery.html
--- 3.0.13-5/doc/html/imap/reference/faqs/feature-duplicate-delivery.html	2019-12-16 04:17:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/feature-duplicate-delivery.html	2020-05-04 04:12:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Duplicate Delivery Suppression &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Duplicate Delivery Suppression &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora" href="install-compilationerrors.html"/>
         <link rel="prev" title="Which database backend should I use for which databases?" href="feature-database-backend.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/feature-duplicate-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/feature-duplicate-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@ and the vacation message.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@ and the vacation message.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/install-compilationerrors.html 3.2.0-3/doc/html/imap/reference/faqs/install-compilationerrors.html
--- 3.0.13-5/doc/html/imap/reference/faqs/install-compilationerrors.html	2019-12-16 04:17:39.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/install-compilationerrors.html	2020-05-04 04:12:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Problems detecting Berkley DB on Red Hat Linux" href="install-detecting-berkeley.html"/>
+        <link rel="next" title="Help! There must be an easier way to get all this going..." href="install-install-help.html"/>
         <link rel="prev" title="Duplicate Delivery Suppression" href="feature-duplicate-delivery.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul class="current">
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/install-compilationerrors.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/install-compilationerrors.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -837,7 +856,7 @@ make: *** [all] Error 1
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="install-detecting-berkeley.html" class="btn btn-neutral float-right" title="Problems detecting Berkley DB on Red Hat Linux" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="install-install-help.html" class="btn btn-neutral float-right" title="Help! There must be an easier way to get all this going..." accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="feature-duplicate-delivery.html" class="btn btn-neutral" title="Duplicate Delivery Suppression" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -849,7 +868,7 @@ make: *** [all] Error 1
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 23 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 23 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +888,7 @@ make: *** [all] Error 1
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/install-detecting-berkeley.html 3.2.0-3/doc/html/imap/reference/faqs/install-detecting-berkeley.html
--- 3.0.13-5/doc/html/imap/reference/faqs/install-detecting-berkeley.html	2019-12-16 04:17:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/install-detecting-berkeley.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,847 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Problems detecting Berkley DB on Red Hat Linux &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../../genindex.html"/>
-        <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
-        <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Help! There must be an easier way to get all this going..." href="install-install-help.html"/>
-        <link rel="prev" title="Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora" href="install-compilationerrors.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../../index.html">Home</a></li>
-    <li><a href="../../../download.html">Download</a></li>
-    <li><a href="../../../contribute.html">Contribute</a></li>
-    <li><a href="../../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../../index.html">
-      <img src="../../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../../index.html">
- 
-
-  
-          
-          <img src="../../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul class="current">
-<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1 current"><a class="reference internal" href="../../../operations.html">Operations</a><ul class="current">
-<li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2 current"><a class="reference internal" href="../faq.html">Frequently Asked Questions</a><ul class="current">
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3 current"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul class="current">
-<li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4 current"><a class="current reference internal" href="#">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../../operations.html">Operations</a> &raquo;</li>
-      
-          <li><a href="../faq.html">Frequently Asked Questions</a> &raquo;</li>
-      
-    <li>Problems detecting Berkley DB on Red Hat Linux</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/install-detecting-berkeley.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="problems-detecting-berkley-db-on-red-hat-linux">
-<h1>Problems detecting Berkley DB on Red Hat Linux<a class="headerlink" href="#problems-detecting-berkley-db-on-red-hat-linux" title="Permalink to this headline">¶</a></h1>
-<p>Modern Redhat Linux ships with a Berkeley DB compiled
-<code class="docutils literal"><span class="pre">--with-pthreads</span></code>, which Cyrus is unable to directly link against.</p>
-<p>You can either recompile Berkeley DB without pthread support, or you can
-add <code class="docutils literal"><span class="pre">-lpthread</span></code> to your LDFLAGS environment variable before you
-configure/build.</p>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="install-install-help.html" class="btn btn-neutral float-right" title="Help! There must be an easier way to get all this going..." accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="install-compilationerrors.html" class="btn btn-neutral" title="Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/install-install-help.html 3.2.0-3/doc/html/imap/reference/faqs/install-install-help.html
--- 3.0.13-5/doc/html/imap/reference/faqs/install-install-help.html	2019-12-16 04:17:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/install-install-help.html	2020-05-04 04:12:54.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Help! There must be an easier way to get all this going... &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Help! There must be an easier way to get all this going... &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="OpenSSL Version Mismatches" href="install-linkerwarnings.html"/>
-        <link rel="prev" title="Problems detecting Berkley DB on Red Hat Linux" href="install-detecting-berkeley.html"/> 
+        <link rel="prev" title="Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora" href="install-compilationerrors.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/install-install-help.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/install-install-help.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@ the best way to get Cyrus depends on wha
         <a href="install-linkerwarnings.html" class="btn btn-neutral float-right" title="OpenSSL Version Mismatches" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="install-detecting-berkeley.html" class="btn btn-neutral" title="Problems detecting Berkley DB on Red Hat Linux" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="install-compilationerrors.html" class="btn btn-neutral" title="Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -804,7 +823,7 @@ the best way to get Cyrus depends on wha
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +843,7 @@ the best way to get Cyrus depends on wha
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/install-linkerwarnings.html 3.2.0-3/doc/html/imap/reference/faqs/install-linkerwarnings.html
--- 3.0.13-5/doc/html/imap/reference/faqs/install-linkerwarnings.html	2019-12-16 04:17:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/install-linkerwarnings.html	2020-05-04 04:12:55.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>OpenSSL Version Mismatches &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>OpenSSL Version Mismatches &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Does the Cyrus Murder support High Availability configurations?" href="r-murder-ha.html"/>
         <link rel="prev" title="Help! There must be an easier way to get all this going..." href="install-install-help.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/install-linkerwarnings.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/install-linkerwarnings.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -787,14 +806,6 @@ from the linker like the following:</p>
 <p>In this case, ClamAV is still linked against OpenSSL 1.0, while Cyrus is
 building with OpenSSL 1.1.</p>
 </div>
-<div class="section" id="libical-v1-0-1-or-v2-0">
-<span id="libical-warnings"></span><h1>Libical v1.0.1 or v2.0<a class="headerlink" href="#libical-v1-0-1-or-v2-0" title="Permalink to this headline">¶</a></h1>
-<p>You may see warnings regarding libical v2.0 being recommended to support certain
-functionality. Currently libical v1.0.1 is sufficient, unless you need/want
-RSCALE (non-gregorian recurrences), VPOLL (consensus scheduling), or
-VAVAILABILITY (specifying availability over time) functionality. If v2 is
-required, it will need to be installed from <a class="reference external" href="https://github.com/libical/libical">github</a>.</p>
-</div>
 
 
           </div>
@@ -814,7 +825,7 @@ required, it will need to be installed f
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 23 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 13 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +845,7 @@ required, it will need to be installed f
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/interop-8bit.html 3.2.0-3/doc/html/imap/reference/faqs/interop-8bit.html
--- 3.0.13-5/doc/html/imap/reference/faqs/interop-8bit.html	2019-12-16 04:17:40.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/interop-8bit.html	2020-05-04 04:12:55.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why does Cyrus reject 8-bit characters in the headers of my messages? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why does Cyrus reject 8-bit characters in the headers of my messages? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why does Cyrus reject messages with “bare newlines”?" href="interop-barenewlines.html"/>
         <link rel="prev" title="Why does Cyrus set the MAIL FROM address of the sender of vacation responses to ‘&lt;&gt;’?" href="o-vacation-mailfrom.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/interop-8bit.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/interop-8bit.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -817,7 +836,7 @@ characters are internally processed with
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@ characters are internally processed with
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/interop-barenewlines.html 3.2.0-3/doc/html/imap/reference/faqs/interop-barenewlines.html
--- 3.0.13-5/doc/html/imap/reference/faqs/interop-barenewlines.html	2019-12-16 04:17:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/interop-barenewlines.html	2020-05-04 04:12:56.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why does Cyrus reject messages with “bare newlines”? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why does Cyrus reject messages with “bare newlines”? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How do I get Cyrus Sieve to play nice with Exim?" href="interop-sieve-exim.html"/>
         <link rel="prev" title="Why does Cyrus reject 8-bit characters in the headers of my messages?" href="interop-8bit.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/interop-barenewlines.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/interop-barenewlines.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -789,7 +808,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +828,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/interop-sieve-exim.html 3.2.0-3/doc/html/imap/reference/faqs/interop-sieve-exim.html
--- 3.0.13-5/doc/html/imap/reference/faqs/interop-sieve-exim.html	2019-12-16 04:17:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/interop-sieve-exim.html	2020-05-04 04:12:56.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How do I get Cyrus Sieve to play nice with Exim? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How do I get Cyrus Sieve to play nice with Exim? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why does mail delivery go slow or hang sometimes?" href="interop-slow-delivery.html"/>
         <link rel="prev" title="Why does Cyrus reject messages with “bare newlines”?" href="interop-barenewlines.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/interop-sieve-exim.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/interop-sieve-exim.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@ sendmail: /opt/exim/exim_dropcr
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@ sendmail: /opt/exim/exim_dropcr
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/interop-slow-delivery.html 3.2.0-3/doc/html/imap/reference/faqs/interop-slow-delivery.html
--- 3.0.13-5/doc/html/imap/reference/faqs/interop-slow-delivery.html	2019-12-16 04:17:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/interop-slow-delivery.html	2020-05-04 04:12:57.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why does mail delivery go slow or hang sometimes? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why does mail delivery go slow or hang sometimes? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Developers" href="../../../developers.html"/>
         <link rel="prev" title="How do I get Cyrus Sieve to play nice with Exim?" href="interop-sieve-exim.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/interop-slow-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/interop-slow-delivery.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -774,7 +793,7 @@
 <li>Murder Master is overloaded. In a normal setup the murder master is queried for each incoming messages</li>
 <li>Delivery.db corruption. A backend will/may reject mail if the delivery.db is corrupt</li>
 <li>Slow dns. Some MTAs (like sendmail) talk to dns a lot. If dns is slow, mail delivery appears slow. We run named on each Cyrus machine</li>
-<li>Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and dissapear. Sometimes it just hangs. Not sure why, but restarting may help.</li>
+<li>Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and disappear. Sometimes it just hangs. Not sure why, but restarting may help.</li>
 </ol>
 </div></blockquote>
 <p>If you have a large volume of mail then <a class="reference internal" href="../admin/murder/murder-mail-delivery.html#murder-mail-delivery"><span class="std std-ref">Cyrus Murder Mail Delivery</span></a> has some tips.</p>
@@ -782,8 +801,7 @@
 lmtpd-processes to be started. Performance was seriously degraded,
 resulting in timeouts and endless retries. We use a postfix instance
 between to limit parallel deliveries to lmtpd resulting in much higher
-throughput. With berkeley-nosync as duplicate suppression db, 50-100
-Messages/sec are doable.</p>
+throughput.</p>
 </div>
 
 
@@ -804,7 +822,7 @@ Messages/sec are doable.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +842,7 @@ Messages/sec are doable.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-acls.html 3.2.0-3/doc/html/imap/reference/faqs/o-acls.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-acls.html	2019-12-16 04:17:41.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-acls.html	2020-05-04 04:12:57.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How do I view ACLs on a mailbox? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How do I view ACLs on a mailbox? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="What annotations are available?" href="o-annotations.html"/>
         <link rel="prev" title="Can I have subfolders not appear under INBOX?" href="r-subfolders.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4 current"><a class="current reference internal" href="#">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-acls.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-acls.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -789,7 +808,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +828,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-annotations.html 3.2.0-3/doc/html/imap/reference/faqs/o-annotations.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-annotations.html	2019-12-16 04:17:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-annotations.html	2020-05-04 04:12:57.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>What annotations are available? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>What annotations are available? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Why does ctl_cyrusdb -r take so long with Berkeley DB?" href="o-berkeleydb.html"/>
+        <link rel="next" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" href="o-configdir-tempfs.html"/>
         <link rel="prev" title="How do I view ACLs on a mailbox?" href="o-acls.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-annotations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,29 +787,69 @@
             
   <div class="section" id="what-annotations-are-available">
 <span id="faqs-o-annotations"></span><h1>What annotations are available?<a class="headerlink" href="#what-annotations-are-available" title="Permalink to this headline">¶</a></h1>
-<p>Cyrus annotations are based on a draft (<a class="reference external" href="http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08">http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08</a>) version of <span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5464.html"><strong>RFC 5464</strong></a>.</p>
+<p>Cyrus annotations are based on a draft
+(<a class="reference external" href="http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08">http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08</a>) version of
+<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5464.html"><strong>RFC 5464</strong></a>.</p>
 <ul class="simple">
-<li><strong>/admin</strong> - Sets the administrator email address for the server. (See <a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
-<li><strong>/check</strong> - Boolean value &#8220;true&#8221; or &#8220;false&#8221; that indicates whether this mailbox should be checked at regular intervals by the client. The interval in minutes is specified by the <code class="docutils literal"><span class="pre">/checkperiod</span></code> entry. (Draft RFC)</li>
-<li><strong>/checkperiod</strong> - Numeric value indicating a period of minutes that the client uses to determine the interval of regular &#8216;new mail&#8217; checks for the corresponding mailbox. (Draft RFC)</li>
-<li><strong>/comment</strong> - Sets a comment or description associated with the mailbox. (cyradm(8)) /motd - Sets a &#8220;message of the day&#8221;. The message gets displayed as an ALERT after authentication.</li>
-<li><strong>/sort</strong> - Defines the default sort criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if sorting is not required. (Draft RFC)</li>
-<li><strong>/thread</strong> - Defines the default thread criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if threading is not required. If both sort and thread are not NIL, then threading should take precedence over sorting. (Draft RFC)</li>
-<li><strong>/vendor/cmu/cyrus-imapd/condstore</strong> - Enables the IMAP CONDSTORE extension (modification sequences) on the mailbox. (See <a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
-<li><strong>vendor/cmu/cyrus-imapd/duplicatedeliver</strong> - Flag signalling that we&#8217;re allowing duplicate delivery of messages to the mailbox, overriding system-wide duplicate suppression. (<a class="reference external" href="https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php">https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php</a>)</li>
-<li><strong>/vendor/cmu/cyrus-imapd/expire</strong> - Sets the number of days after which messages will be expired from the mailbox. (cyradm(8))</li>
+<li><strong>/admin</strong> - Sets the administrator email address for the server. (See
+<a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
+<li><strong>/check</strong> - Boolean value &#8220;true&#8221; or &#8220;false&#8221; that indicates whether this
+mailbox should be checked at regular intervals by the client. The interval
+in minutes is specified by the <code class="docutils literal"><span class="pre">/checkperiod</span></code> entry. (Draft RFC)</li>
+<li><strong>/checkperiod</strong> - Numeric value indicating a period of minutes that the
+client uses to determine the interval of regular &#8216;new mail&#8217; checks for the
+corresponding mailbox. (Draft RFC)</li>
+<li><strong>/comment</strong> - Sets a comment or description associated with the mailbox.
+(cyradm(8))</li>
+<li><strong>/motd</strong> - Sets a &#8220;message of the day&#8221;. The message gets displayed
+as an ALERT after authentication.</li>
+<li><strong>/sort</strong> - Defines the default sort criteria [I-D.ietf-imapext-sort] to use
+when first displaying the mailbox contents to the user, or NIL if sorting is
+not required. (Draft RFC)</li>
+<li><strong>/thread</strong> - Defines the default thread criteria [I-D.ietf-imapext-sort] to
+use when first displaying the mailbox contents to the user, or NIL if
+threading is not required. If both sort and thread are not NIL, then
+threading should take precedence over sorting. (Draft RFC)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/condstore</strong> - Enables the IMAP CONDSTORE extension
+(modification sequences) on the mailbox. (See <a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
+<li><strong>vendor/cmu/cyrus-imapd/duplicatedeliver</strong> - Flag signalling that we&#8217;re
+allowing duplicate delivery of messages to the mailbox, overriding
+system-wide duplicate suppression.
+(<a class="reference internal" href="../../developer/guidance/mailbox-format.html#imap-developer-guidance-mailbox-format"><span class="std std-ref">Cyrus IMAP Server: Mailbox File Formats</span></a>)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/expire</strong> - Sets the number of days after which
+messages will be expired from the mailbox. (cyradm(8))</li>
+<li><strong>/vendor/cmu/cyrus-imapd/archive</strong> - Sets the number of days after which
+messages will be archived from the mailbox. (cyradm(8))</li>
+<li><strong>/vendor/cmu/cyrus-imapd/delete</strong> - Sets the number of days after which
+messages will be deleted from the mailbox. (cyradm(8))</li>
 <li><strong>/vendor/cmu/cyrus-imapd/freespace</strong> - Undocumented.</li>
-<li><strong>/vendor/cmu/cyrus-imapd/lastpop</strong> - (time_t) of the last pop3 login to this INBOX, used to enforce the &#8220;poptimeout&#8221; imapd.conf option. (<a class="reference external" href="https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php">https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php</a>)</li>
-<li><strong>vendor/cmu/cyrus-imapd/lastupdate</strong> - (time_t) of the last time a message was appended (<a class="reference external" href="https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php">https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php</a>)</li>
-<li><strong>/vendor/cmu/cyrus-imapd/news2mail</strong> - Sets an email address to which messages injected into the server via NNTP will be sent. (cyradm(8))</li>
+<li><strong>/vendor/cmu/cyrus-imapd/lastpop</strong> - (time_t) of the last pop3 login to
+this INBOX, used to enforce the &#8220;poptimeout&#8221; imapd.conf option.
+(<a class="reference internal" href="../../developer/guidance/mailbox-format.html#imap-developer-guidance-mailbox-format"><span class="std std-ref">Cyrus IMAP Server: Mailbox File Formats</span></a>)</li>
+<li><strong>vendor/cmu/cyrus-imapd/lastupdate</strong> - (time_t) of the last time a message
+was appended
+(<a class="reference internal" href="../../developer/guidance/mailbox-format.html#imap-developer-guidance-mailbox-format"><span class="std std-ref">Cyrus IMAP Server: Mailbox File Formats</span></a>)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/news2mail</strong> - Sets an email address to which
+messages injected into the server via NNTP will be sent. (cyradm(8))</li>
 <li><strong>/vendor/cmu/cyrus-imapd/partition</strong> - Undocumented.</li>
-<li><strong>/vendor/cmu/cyrus-imapd/pop3newuidl</strong> - Flag signalling that we&#8217;re using &#8220;uidvalidity.uid&#8221; instead of just &#8220;uid&#8221; for the output of the POP3 UIDL command. (<a class="reference external" href="https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php">https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php</a>)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/pop3newuidl</strong> - Flag signalling that we&#8217;re using
+&#8220;uidvalidity.uid&#8221; instead of just &#8220;uid&#8221; for the output of the POP3 UIDL
+command.
+(<a class="reference internal" href="../../developer/guidance/mailbox-format.html#imap-developer-guidance-mailbox-format"><span class="std std-ref">Cyrus IMAP Server: Mailbox File Formats</span></a>)</li>
 <li><strong>/vendor/cmu/cyrus-imapd/serve</strong> - Undocumented.</li>
-<li><strong>/vendor/cmu/cyrus-imapd/sharedseen</strong> - Enables the use of a shared Seen flag on messages rather than a per-user Seen flag. The ’s’ right in the mailbox ACL still controls whether a user can set the shared Seen flag. (See <a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
-<li><strong>/vendor/cmu/cyrus-imapd/shutdown</strong> - Sets a shutdown message. The message gets displayed as an ALERT and all users are disconnected from the server (subsequent logins are disallowed). (cyradm(8))</li>
-<li><strong>/vendor/cmu/cyrus-imapd/sieve</strong> - Indicates the name of the global sieve script that should be run when a message is delivered to the shared mailbox (not used for personal mailboxes). (cyradm(8))</li>
+<li><strong>/vendor/cmu/cyrus-imapd/sharedseen</strong> - Enables the use of a shared Seen
+flag on messages rather than a per-user Seen flag. The ’s’ right in the
+mailbox ACL still controls whether a user can set the shared Seen flag.
+(See <a class="reference internal" href="../manpages/systemcommands/cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/shutdown</strong> - Sets a shutdown message. The message
+gets displayed as an ALERT and all users are disconnected from the server
+(subsequent logins are disallowed). (cyradm(8))</li>
+<li><strong>/vendor/cmu/cyrus-imapd/sieve</strong> - Indicates the name of the global sieve
+script that should be run when a message is delivered to the shared mailbox
+(not used for personal mailboxes). (cyradm(8))</li>
 <li><strong>/vendor/cmu/cyrus-imapd/size</strong> - Undocumented.</li>
-<li><strong>/vendor/cmu/cyrus-imapd/squat</strong> - Indicates that the mailbox should have a squat index created for it. (See <a class="reference internal" href="../manpages/systemcommands/squatter.html#std:cyrusman-squatter(8)">squatter(8)</a>)</li>
+<li><strong>/vendor/cmu/cyrus-imapd/squat</strong> - Indicates that the mailbox should be
+indexed. (See <a class="reference internal" href="../manpages/systemcommands/squatter.html#std:cyrusman-squatter(8)">squatter(8)</a>)</li>
 </ul>
 </div>
 
@@ -800,7 +859,7 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="o-berkeleydb.html" class="btn btn-neutral float-right" title="Why does ctl_cyrusdb -r take so long with Berkeley DB?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="o-configdir-tempfs.html" class="btn btn-neutral float-right" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="o-acls.html" class="btn btn-neutral" title="How do I view ACLs on a mailbox?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -812,7 +871,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 14 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 09 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -832,7 +891,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-berkeleydb.html 3.2.0-3/doc/html/imap/reference/faqs/o-berkeleydb.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-berkeleydb.html	2019-12-16 04:17:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-berkeleydb.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,883 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Why does ctl_cyrusdb -r take so long with Berkeley DB? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../../genindex.html"/>
-        <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
-        <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" href="o-configdir-tempfs.html"/>
-        <link rel="prev" title="What annotations are available?" href="o-annotations.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../../index.html">Home</a></li>
-    <li><a href="../../../download.html">Download</a></li>
-    <li><a href="../../../contribute.html">Contribute</a></li>
-    <li><a href="../../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../../index.html">
-      <img src="../../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../../index.html">
- 
-
-  
-          
-          <img src="../../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul class="current">
-<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1 current"><a class="reference internal" href="../../../operations.html">Operations</a><ul class="current">
-<li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2 current"><a class="reference internal" href="../faq.html">Frequently Asked Questions</a><ul class="current">
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
-<li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4 current"><a class="current reference internal" href="#">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../../operations.html">Operations</a> &raquo;</li>
-      
-          <li><a href="../faq.html">Frequently Asked Questions</a> &raquo;</li>
-      
-    <li>Why does ctl_cyrusdb -r take so long with Berkeley DB?</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-berkeleydb.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="why-does-ctl-cyrusdb-r-take-so-long-with-berkeley-db">
-<h1>Why does ctl_cyrusdb -r take so long with Berkeley DB?<a class="headerlink" href="#why-does-ctl-cyrusdb-r-take-so-long-with-berkeley-db" title="Permalink to this headline">¶</a></h1>
-<p>Berkeley DB maintains a log of all the transactions since the last
-checkpoint of the database. In order to ensure the database is in a
-consistent state, you must recover the log after any outage (thus the
-recommendation to run these processes when Cyrus starts). They can take
-a long time for a few reasons.</p>
-<p>The most common one is that you need to checkpoint the cyrusdb more
-often. This can be done with a simple <code class="docutils literal"><span class="pre">ctl_cyrusdb</span> <span class="pre">-c</span></code>. If you do this
-very often, the amount of log that needs to be recovered will be
-significantly shorter. We recommend doing this at least once every half
-hour, and more often on busy sites.</p>
-<p>The other reason is that your <a class="reference internal" href="o-deliverdb-size.html#faq-o-deliberdb-size"><span class="std std-ref">deliver.db may be very large</span></a>. This is
-solvable by increasing the pruning interval (the -E parameter to
-ctl_deliver, which you should run on a regular basis), or (in a pinch)
-by just removing the database (since the effects of losing it do not
-prevent operation, they just cause vacation messages to be resent, and
-duplicate delivery suppression to possibly deliver duplicates).</p>
-<ul class="simple">
-<li><dl class="first docutils">
-<dt>&#8220;by increasing the pruning interval&#8221;: My understanding is that the</dt>
-<dd>number after &#8220;-E&#8221; is the number of days after which entries are
-discarded. Is there a way to reduce it to a number of hours? Since most
-of our mail is internal mail should rarely be delayed by more then an
-hour or two.</dd>
-</dl>
-</li>
-<li><dl class="first docutils">
-<dt>In case it&#8217;s useful to anyone we discovered that moving /var/lib/imap</dt>
-<dd>from an ext2 to an ext3 journaled filesystem made a vast difference for
-the worse. While recovering the database Berkeley DB does a vast
-quantity of small writes and that combined with the updates to the
-journal absolutely kills disk performance (with journalling it was
-taking about 40 minutes to start Cyrus on a mail server with about 500
-users and 200G of mail). On the flip side moving /var/lib/imap to a
-hardware RAID system with a decent amount of onboard cache reduced this
-time to under 30 seconds. I think Berkeley DB could probably be
-optimized to deal with this better, but in the mean time avoid
-journaling filesystems, or at least be prepared to experiment to find
-something that works for you.</dd>
-</dl>
-</li>
-</ul>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="o-configdir-tempfs.html" class="btn btn-neutral float-right" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="o-annotations.html" class="btn btn-neutral" title="What annotations are available?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-configdir-tempfs.html 3.2.0-3/doc/html/imap/reference/faqs/o-configdir-tempfs.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-configdir-tempfs.html	2019-12-16 04:17:42.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-configdir-tempfs.html	2020-05-04 04:12:58.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How to enable core dumps" href="o-coredump.html"/>
-        <link rel="prev" title="Why does ctl_cyrusdb -r take so long with Berkeley DB?" href="o-berkeleydb.html"/> 
+        <link rel="prev" title="What annotations are available?" href="o-annotations.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-configdir-tempfs.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-configdir-tempfs.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -785,7 +804,7 @@ Cyrus code will create all the necessary
         <a href="o-coredump.html" class="btn btn-neutral float-right" title="How to enable core dumps" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="o-berkeleydb.html" class="btn btn-neutral" title="Why does ctl_cyrusdb -r take so long with Berkeley DB?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="o-annotations.html" class="btn btn-neutral" title="What annotations are available?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -794,7 +813,7 @@ Cyrus code will create all the necessary
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -814,7 +833,7 @@ Cyrus code will create all the necessary
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-coredump.html 3.2.0-3/doc/html/imap/reference/faqs/o-coredump.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-coredump.html	2019-12-16 04:17:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-coredump.html	2020-05-04 04:12:58.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How to enable core dumps &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How to enable core dumps &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Is the “db3: x Lockers” log message harmful?" href="o-db3-lockers.html"/>
+        <link rel="next" title="Why can I not delete a mailbox as an admin user?" href="o-delete-mailbox.html"/>
         <link rel="prev" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" href="o-configdir-tempfs.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-coredump.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-coredump.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -799,7 +818,7 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="o-db3-lockers.html" class="btn btn-neutral float-right" title="Is the “db3: x Lockers” log message harmful?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="o-delete-mailbox.html" class="btn btn-neutral float-right" title="Why can I not delete a mailbox as an admin user?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="o-configdir-tempfs.html" class="btn btn-neutral" title="Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -811,7 +830,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 19 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 19 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-db3-lockers.html 3.2.0-3/doc/html/imap/reference/faqs/o-db3-lockers.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-db3-lockers.html	2019-12-16 04:17:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-db3-lockers.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,867 +0,0 @@
-
-
-<!DOCTYPE html>
-<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
-<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
-<head>
-  <meta charset="utf-8">
-  
-  <meta name="viewport" content="width=device-width, initial-scale=1.0">
-  
-  <title>Is the “db3: x Lockers” log message harmful? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
-  
-
-  
-  
-    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
-  
-
-  
-
-  
-  
-    
-
-  
-
-  
-  
-    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
-  
-
-  
-    <link rel="stylesheet" href="../../../_static/cyrus.css" type="text/css" />
-  
-
-  
-        <link rel="index" title="Index"
-              href="../../../genindex.html"/>
-        <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
-        <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
-        <link rel="next" title="Why can I not delete a mailbox as an admin user?" href="o-delete-mailbox.html"/>
-        <link rel="prev" title="How to enable core dumps" href="o-coredump.html"/> 
-
-  
-  
-  
-
-</head>
-
-<body class="wy-body-for-nav" role="document">
-
-
-  
-
-<div class="pageheader">
-  <ul>
-    <li><a href="../../../index.html">Home</a></li>
-    <li><a href="../../../download.html">Download</a></li>
-    <li><a href="../../../contribute.html">Contribute</a></li>
-    <li><a href="../../../support.html">Support</a></li>
-    <li><a href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-  </ul>
-  <div>
-    <a href="../../../index.html">
-      <img src="../../../_static/logo.gif" alt="CYRUS" />
-    </a>
-  </div>
-</div>
-<div style="clear: both;"></div>
-
-
-  <div class="wy-grid-for-nav">
-
-    
-    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
-      <div class="wy-side-nav-search">
-        
-
-        
- 
-          <a href="../../../index.html">
- 
-
-  
-          
-          <img src="../../../_static/logo.gif"  />
-     
-        </a>
-
-        
-<div role="search">
-  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
-    <input type="text" name="q" placeholder="Search docs" />
-    <input type="hidden" name="check_keywords" value="yes" />
-    <input type="hidden" name="area" value="default" />
-  </form>
-</div>
-
-        
-      </div>
-
-      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
-        
-          
-          
-              <p class="caption"><span class="caption-text">Cyrus IMAP</span></p>
-<ul class="current">
-<li class="toctree-l1"><a class="reference internal" href="../../../download.html">Download</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../download/getcyrus.html">Get Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#distribution-package">Distribution Package</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/centos.html">CentOS</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/debian.html">Debian</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/fedora.html">Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/opensuse.html">openSUSE</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/rhel.html">Red Hat Enterprise Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/distributions/ubuntu.html">Ubuntu</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#build-and-install-yourself">Build and Install Yourself</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-a-release-packaged-tarball">Use a release packaged tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/getcyrus.html#use-the-source-from-git">Use the source from Git</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#external-tools">External Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/getcyrus.html#licensing">Licensing</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/release-notes/index.html">Release Notes</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../quickstart.html">Quickstart Guide</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart/introduction.html">Introduction to Cyrus IMAP</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../overview.html">Overview</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/features.html">Features</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#security-and-authentication">Security and Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-kerberos.html">Kerberos Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-ldap.html">LDAP Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/authentication-sql.html">SQL Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/sealed-system.html">Sealed System Design</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#mailbox-management">Mailbox Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/automatic-creation-of-mailboxes.html">Automatic Creation of Mailboxes</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/namespaces.html">Mailbox Namespaces</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/virtual-domains.html">Virtual Domains</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-annotations.html">Mailbox Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-distribution.html">Mailbox Distribution</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#message-management">Message Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-delete.html">Delayed Delete</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/delayed-expunge.html">Delayed Expunge</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/message-annotations.html">Message Annotations (METADATA)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/duplicate-message-delivery-suppression.html">Duplicate Message Delivery Suppression</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/shared-seen-state.html">Shared Seen State</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-side-filtering.html">Server Side Filtering (Sieve)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/event-notifications.html">Event Notifications</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#calendar-and-contact-dav-collection-management">Calendar and Contact (DAV) Collection Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/caldav-collections.html">CalDAV Collections</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-components.html">DAV Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/dav-collection-mgmt.html">DAV Collection Management</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/carddav.html">CardDAV Support</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#storage">Storage</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mail-spool-partitions.html">Mail Spool Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/mailbox-metadata-partitions.html">Mailbox Metadata Partitions</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/archiving.html">Archiving</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/quota.html">Quota</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/single-instance-store.html">Single-Instance Store</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/features.html#load-management">Load Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/features/server-aggregation.html">Cyrus IMAP Murder (Server Aggregation)</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/overview_and_concepts.html">Concepts</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-lists">Access Control Lists</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-acls">Working with ACLs</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sample-acl">Sample ACL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-rights">Access Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-defaults">Access Control Defaults</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#access-control-identifier-aci">Access Control Identifier (ACI)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#negative-rights">Negative Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#calculating-a-users-rights">Calculating a Users&#8217; Rights</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#login-authentication">Login Authentication</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#anonymous-login">Anonymous Login</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#plaintext-authentication">Plaintext Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#kerberos-logins">Kerberos Logins</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#shared-secrets-logins">Shared Secrets Logins</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas">Quotas</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#working-with-quotas">Working with Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#monitor-and-repair">Monitor and Repair</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#supported-quota-types">Supported Quota Types</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-roots">Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#controlling-quota-behavior">Controlling Quota Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-delivery-behavior">Mail Delivery Behavior</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quota-warnings-upon-select-when-user-has-d-rights">Quota Warnings Upon Select When User Has <code class="docutils literal"><span class="pre">d</span></code> Rights</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#quotas-and-partitions">Quotas and Partitions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#new-mail-notification">New Mail Notification</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#partitions">Partitions</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#specifying-partitions-with-create">Specifying Partitions with &#8220;create&#8221;</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#changing-partitions-with-rename">Changing Partitions with &#8220;rename&#8221;</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#news">News</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#pop3-server">POP3 Server</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#the-syslog-facility">The syslog facility</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#mail-directory-recovery">Mail Directory Recovery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-mailbox-directories">Reconstructing Mailbox Directories</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-the-mailboxes-file">Reconstructing the Mailboxes File</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#reconstructing-quota-roots">Reconstructing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#removing-quota-roots">Removing Quota Roots</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#subscriptions">Subscriptions</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#configuration-directory">Configuration Directory</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#log-directory">Log Directory</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#proc-directory">Proc Directory</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#message-delivery">Message Delivery</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#local-mail-transfer-protocol-lmtp">Local Mail Transfer Protocol (lmtp)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#single-instance-store">Single Instance Store</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/overview_and_concepts.html#duplicate-delivery-suppression">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#sieve-a-mail-filtering-language">Sieve, a Mail Filtering Language</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/overview_and_concepts.html#cyrus-murder-the-imap-aggregator">Cyrus Murder, the IMAP Aggregator</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../setup.html">Setup</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/compiling.html">Compiling</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#setting-up-dependencies">Setting up dependencies</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#required-build-dependencies">Required Build Dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-build-dependencies">Optional Build Dependencies</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#optional-dependencies">Optional dependencies</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#compile">Compile</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html#check">Check</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../installing.html">Installing Cyrus</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#install-cyrus">Install Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#optional-components">Optional Components</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/manage-dav.html">HTTP modules</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/installation/virus.html">Virus Scanner</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#setting-up-syslog">Setting up syslog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#create-cyrus-environment">Create Cyrus environment</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#set-up-the-cyrus-mail-user-and-group">Set up the cyrus:mail user and group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#authentication-with-sasl">Authentication with SASL</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#mail-delivery-from-your-mta">Mail delivery from your MTA</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#protocol-ports">Protocol ports</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#cyrus-config-files">Cyrus config files</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#optional-setting-up-ssl-certificates">Optional: Setting up SSL certificates</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html#prepare-ephemeral-run-time-storage-directories">Prepare ephemeral (run-time) storage directories</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#launch-cyrus">Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#send-a-test-email">Send a test email</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#checking-carddav-and-carddav">Checking CardDAV and CardDAV</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#special-note-for-murder-configurations">Special note for Murder configurations</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../concepts/deployment.html">Configuration Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html">Deployment Scenarios</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#single-server-deployments">Single Server Deployments</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#multi-server-deployments">Multi Server Deployments</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-murder-server-aggregation">Cyrus Murder: Server aggregation</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-discrete-murder">The Discrete Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-unified-murder">The Unified Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#the-shared-murder">The Shared Murder</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#cyrus-replication">Cyrus Replication</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/deployment_scenarios.html#hosted-environments">Hosted Environments</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/databases.html">Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#overview">Overview</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#file-list">File list</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/databases.html#storage-types">Storage types</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html">Mailbox Creation Distribution</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#selection-mode">Selection Mode</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#special-cases">Special cases</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-exclusion">Partitions Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#partitions-usage-data-reset">Partitions Usage Data Reset</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#mailbox-creation-distribution-through-murder-frontend">Mailbox Creation Distribution Through <code class="docutils literal"><span class="pre">murder</span> <span class="pre">frontend</span></code></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-exclusion">Backends Exclusion</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/mailbox_creation_distribution.html#backends-usage-data-reset">Backends Usage Data Reset</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html">Known Protocol Limitations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#pop3-and-mailbox-locking">POP3 and Mailbox Locking</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/known_protocol_limitations.html#cyrus-imap-pop3-implementation">Cyrus IMAP POP3 Implementation</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html">Authentication and Authorization</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#client-authentication">Client Authentication</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/authentication_and_authorization.html#users-and-mailboxes">Users and Mailboxes</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#general-notes-on-storage">General Notes on Storage</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#redundancy">Redundancy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#availability">Availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#performance">Performance</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#scalability">Scalability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#capacity">Capacity</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/storage.html#cost">Cost</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html">Supported Platforms and System Requirements</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#building-cyrus-imap">Building Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#required-software-components">Required Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components">Recommended Software Components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/supported-platforms.html#recommended-software-components-enabled-by-default">Recommended Software Components Enabled by Default</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1 current"><a class="reference internal" href="../../../operations.html">Operations</a><ul class="current">
-<li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#system-commands">(8) System Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/arbitron.html"><strong>arbitron</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/backupd.html"><strong>backupd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/chk_cyrus.html"><strong>chk_cyrus</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_backups.html"><strong>ctl_backups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_conversationsdb.html"><strong>ctl_conversationsdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_cyrusdb.html"><strong>ctl_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_deliver.html"><strong>ctl_deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_mboxlist.html"><strong>ctl_mboxlist</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ctl_zoneinfo.html"><strong>ctl_zoneinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_cyrusdb.html"><strong>cvt_cyrusdb</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cvt_xlist_specialuse.html"><strong>cvt_xlist_specialuse</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_backup.html"><strong>cyr_backup</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_buildinfo.html"><strong>cyr_buildinfo</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_dbtool.html"><strong>cyr_dbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_deny.html"><strong>cyr_deny</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_df.html"><strong>cyr_df</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_expire.html"><strong>cyr_expire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_info.html"><strong>cyr_info</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_sequence.html"><strong>cyr_sequence</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_synclog.html"><strong>cyr_synclog</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_userseen.html"><strong>cyr_userseen</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyr_virusscan.html"><strong>cyr_virusscan</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyradm.html"><strong>cyradm</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/cyrdump.html"><strong>cyrdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/deliver.html"><strong>deliver</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fetchnews.html"><strong>fetchnews</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/fud.html"><strong>fud</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/httpd.html"><strong>httpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/idled.html"><strong>idled</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/imapd.html"><strong>imapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ipurge.html"><strong>ipurge</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpd.html"><strong>lmtpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/master.html"><strong>master</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbexamine.html"><strong>mbexamine</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbpath.html"><strong>mbpath</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mbtool.html"><strong>mbtool</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mkimap.html"><strong>mkimap</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mknewsgroups.html"><strong>mknewsgroups</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/mupdate.html"><strong>mupdate</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/nntpd.html"><strong>nntpd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/notifyd.html"><strong>notifyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3d.html"><strong>pop3d</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptdump.html"><strong>ptdump</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptexpire.html"><strong>ptexpire</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/ptloader.html"><strong>ptloader</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/quota.html"><strong>quota</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/reconstruct.html"><strong>reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/rehash.html"><strong>rehash</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/restore.html"><strong>restore</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sievec.html"><strong>sievec</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sieved.html"><strong>sieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/smmapd.html"><strong>smmapd</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/squatter.html"><strong>squatter</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_client.html"><strong>sync_client</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_reset.html"><strong>sync_reset</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/sync_server.html"><strong>sync_server</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/timsieved.html"><strong>timsieved</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/tls_prune.html"><strong>tls_prune</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/translatesieve.html"><strong>translatesieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/systemcommands/unexpunge.html"><strong>unexpunge</strong></a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#user-commands">(1) User Commands</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/arbitronsort.pl.html"><strong>arbitronsort.pl</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/dav_reconstruct.html"><strong>dav_reconstruct</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/httptest.html"><strong>httptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/imtest.html"><strong>imtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/installsieve.html"><strong>installsieve</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/lmtptest.html"><strong>lmtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/mupdatetest.html"><strong>mupdatetest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/pop3test.html"><strong>pop3test</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sieveshell.html"><strong>sieveshell</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/sivtest.html"><strong>sivtest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/smtptest.html"><strong>smtptest</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../admin.html#management">Management</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../admin/locations.html">File &amp; Directory Locations</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/ports-sockets.html">Ports and Sockets</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/access-control.html">Access Control</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/quotas.html">Quotas</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sieve.html">Cyrus Sieve</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/backups.html">Cyrus Backups</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nntp.html">Cyrus NNTP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../admin/tweaking.html">Tweaking Cyrus IMAP</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2 current"><a class="reference internal" href="../faq.html">Frequently Asked Questions</a><ul class="current">
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#features">Features</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="feature-database-backend.html">Which database backend should I use for which databases?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="feature-duplicate-delivery.html">Duplicate Delivery Suppression</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="r-murder-ha.html">Does the Cyrus Murder support High Availability configurations?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-pop3-logging.html">Can I configure pop3d to log amount and size of messages fetched by user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-publicssharedfolders.html">How can I make CyrusSieve work with public shared folders?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="r-subfolders.html">Can I have subfolders not appear under INBOX?</a></li>
-</ul>
-</li>
-<li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
-<li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4 current"><a class="current reference internal" href="#">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-freezes.html">I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-gdb.html">How to run gdb on Cyrus components</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mailbox-doesnotexist.html">Cyrus delivers claims that the mailbox does not exist</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-mixedcase.html">Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-otherdatabases.html">Can I use MySQL (or another SQL database) as the primary mail store?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-pop3slow.html">Why do POP3 connections take so long, but once the connection is established all is well?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-reconstruct.html">Why does reconstruct -m not work?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-sharedfilesystem-gpfs.html">Shared File Systems GPFS for high availability</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-telemetry.html">How to enable telemetry</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-toomanyprocesses.html">The process count keeps growing!</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-unable-join-environment.html">&#8220;unable to join environment&#8221; error</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-vacation-mailfrom.html">Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../faq.html#common-interoperability-problems">Common Interoperability Problems</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="interop-8bit.html">Why does Cyrus reject 8-bit characters in the headers of my messages?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-barenewlines.html">Why does Cyrus reject messages with &#8220;bare newlines&#8221;?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-sieve-exim.html">How do I get Cyrus Sieve to play nice with Exim?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="interop-slow-delivery.html">Why does mail delivery go slow or hang sometimes?</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../developers.html">Developers</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../../contribute.html">We need your help</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/documentation.html">Contribute docs</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#overview">Overview</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#documentation-tools">Documentation Tools</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#building-the-files">Building the files</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#submitting-updates">Submitting updates</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#using-github-pull-requests">Using GitHub pull requests</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#patches-through-the-mailing-list">Patches through the mailing list</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#special-tags">Special Tags</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#rfc">rfc</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#cyrusman">cyrusman</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#imap-current-stable-version">imap_current_stable_version</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/documentation.html#conventions-man-pages">Conventions: Man Pages</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#synopsis">Synopsis</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/documentation.html#examples">Examples</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer.html">Contribute code and tests</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#getting-started">Getting Started</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/process.html">Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/overview.html">Overview of Cyrus development environment</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/github-guide.html">GitHub guide</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/namespaces.html">Namespaces: a developer view</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#resources">Resources</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/libraries.html">Developer Libraries</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer.html#releasing">Releasing</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/releasing.html">Releasing Cyrus IMAP</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
-</ul>
-</li>
-</ul>
-</li>
-<li class="toctree-l1"><a class="reference internal" href="../../../support.html">Support/Community</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-bugs.html">Found a bug?</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-mailing-lists.html">Mailing lists</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#archives">Archives</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#subscribe-unsubscribe">Subscribe/Unsubscribe</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../support/feedback-mailing-lists.html#digest-lists">Digest Lists</a></li>
-</ul>
-</li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-irc.html">IRC</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../support/feedback-meetings.html">Weekly meetings</a></li>
-<li class="toctree-l2"><a class="reference internal" href="../../../overview/about_cyrus.html">About</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/what_is_cyrus.html">What is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-cyrus">What is Cyrus</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#what-is-imap">What is IMAP?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#imap-version-4-imap4">IMAP Version 4 (IMAP4)</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#mime">Mime</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/what_is_cyrus.html#smtp">SMTP</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/who_is_cyrus.html">Who Is Cyrus</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#core-contributors">Core Contributors</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/who_is_cyrus.html#individual-contributors-and-past-contributors">Individual contributors and past contributors</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_roadmap.html">Cyrus Roadmap</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_roadmap.html#high-level-roadmap">High Level Roadmap</a></li>
-</ul>
-</li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_history.html">Cyrus History</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../overview/cyrus_bylaws.html">Cyrus Bylaws</a><ul>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#i-the-cyrus-governance-board">I. The Cyrus Governance Board</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#ii-the-cyrus-core-developers-group">II. The Cyrus Core Developers Group</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iii-the-release-engineer">III. The Release Engineer</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#iv-the-cyrus-roadmap">IV. The Cyrus Roadmap</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#v-development-process">V. Development Process</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../overview/cyrus_bylaws.html#vi-changes-to-the-bylaws">VI. Changes to the Bylaws</a></li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-</li>
-</ul>
-<p class="caption"><span class="caption-text">Cyrus SASL</span></p>
-<ul>
-<li class="toctree-l1"><a class="reference external" href="http://www.cyrusimap.org/sasl">Cyrus SASL</a></li>
-</ul>
-
-          
-        
-      </div>
-        
-<div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
-</div>
-      &nbsp;
-    </nav>
-
-    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
-
-      
-      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
-        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
-        <a href="../../../index.html">Cyrus IMAP</a>
-      </nav>
-
-
-      
-      <div class="wy-nav-content">
-        <div class="rst-content">
-
-          <div role="navigation" aria-label="breadcrumbs navigation">
-  <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
-      
-          <li><a href="../../../operations.html">Operations</a> &raquo;</li>
-      
-          <li><a href="../faq.html">Frequently Asked Questions</a> &raquo;</li>
-      
-    <li>Is the &#8220;db3: x Lockers&#8221; log message harmful?</li>
-      <li class="wy-breadcrumbs-aside">
-        
-          
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-db3-lockers.rst" class="fa fa-github"> Edit on GitHub</a>
-          
-        
-      </li>
-  </ul>
-  <hr/>
-</div>
-          <div role="main" class="document">
-            
-  <div class="section" id="is-the-db3-x-lockers-log-message-harmful">
-<h1>Is the &#8220;db3: x Lockers&#8221; log message harmful?<a class="headerlink" href="#is-the-db3-x-lockers-log-message-harmful" title="Permalink to this headline">¶</a></h1>
-<p>This message is generally not harmful unless it is increasing at an
-alarming rate or you are seeing other performance problems. It indicates
-contention within a Berkeley DB database page, and especially on small
-databases will occur quite frequently.</p>
-<p>If there are performance problems, often times the best solution is to
-convert your mailbox list to a skiplist format.</p>
-<p>Paul M Fleming (<a class="reference external" href="mailto:pfleming&#37;&#52;&#48;siumed&#46;edu">pfleming<span>&#64;</span>siumed<span>&#46;</span>edu</a>) also notes:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">We</span> <span class="n">found</span> <span class="n">limiting</span> <span class="n">the</span> <span class="n">number</span> <span class="n">of</span> <span class="n">lmtp</span> <span class="n">processes</span> <span class="n">to</span> <span class="mi">10</span> <span class="n">helped</span> <span class="k">with</span> <span class="n">locker</span> <span class="n">problems</span><span class="o">.</span> <span class="n">Let</span> <span class="n">sendmail</span><span class="o">/</span><span class="n">postfix</span> <span class="n">handle</span> <span class="n">the</span> <span class="n">queuing</span> <span class="ow">and</span> <span class="n">lmtp</span> <span class="n">the</span> <span class="n">delivery</span><span class="o">..</span> <span class="n">When</span> <span class="n">we</span> <span class="n">tried</span> <span class="n">to</span> <span class="n">blast</span> <span class="mi">10</span><span class="o">-</span><span class="mi">20</span> <span class="n">messages</span><span class="o">/</span><span class="n">sec</span> <span class="n">at</span> <span class="n">our</span> <span class="n">test</span> <span class="n">server</span> <span class="n">locking</span> <span class="n">became</span> <span class="n">a</span> <span class="n">problem</span> <span class="k">with</span> <span class="n">the</span> <span class="n">duplicate</span> <span class="n">delivery</span> <span class="n">db</span><span class="o">.</span> <span class="n">Across</span> <span class="mi">3</span> <span class="n">servers</span> <span class="ow">and</span> <span class="mi">600</span> <span class="n">concurrent</span> <span class="n">logins</span> <span class="p">(</span><span class="n">lmtpd</span> <span class="n">maxchild</span><span class="o">=</span><span class="mi">10</span> <span class="n">on</span> <span class="n">each</span> <span class="n">server</span><span class="p">)</span> <span class="n">we</span> <span class="n">never</span> <span class="n">see</span> <span class="nb">any</span> <span class="n">locking</span> <span class="n">problems</span> <span class="ow">and</span> <span class="n">usually</span> <span class="n">have</span> <span class="n">less</span> <span class="n">than</span> <span class="mi">1</span> <span class="n">second</span> <span class="n">delivery</span> <span class="n">times</span><span class="o">.</span>
-</pre></div>
-</div>
-<p>Andreas (<a class="reference external" href="mailto:andreas&#37;&#52;&#48;conectiva&#46;com&#46;br">andreas<span>&#64;</span>conectiva<span>&#46;</span>com<span>&#46;</span>br</a>) writes:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span>Take a look at this text: http://www.openldap.org/faq/index.cgi?_highlightWords=locks&amp;file=893
-
-It&#39;s written for openldap, but explains several important Berkeley DB configuration parameters. In particular:
-
-    On a very busy system you might see error messages talking about running out of locks, lockers, or lock objects. Usually the default values are plenty, and in older versions of the BDB library the errors were more likely due to library bugs than actual system load. However, it is possible that you have actually run out of lock resources due to heavy system usage. If this happens, you should read about the set_lk_max_lockers[1], set_lk_max_locks[2], and set_lk_max_objects[3] keywords.
-
-http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_lockers.html
-http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_locks.html
-http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_objects.html
-
-The links above talk about the C api, but don&#39;t get alarmed, these paremeters can be set with a DB_CONFIG configuration file located in the DB environment home.
-</pre></div>
-</div>
-<p>I also suppose the <em class="manpage">db_stat(8)</em> utility can be used to diagnose this.</p>
-</div>
-
-
-          </div>
-          <footer>
-  
-    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
-      
-        <a href="o-delete-mailbox.html" class="btn btn-neutral float-right" title="Why can I not delete a mailbox as an admin user?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
-      
-      
-        <a href="o-coredump.html" class="btn btn-neutral" title="How to enable core dumps" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
-      
-    </div>
-  
-
-  <hr/>
-
-  <div role="contentinfo">
-    <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
-    </p>
-  </div>
-  Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
-
-</footer>
-        </div>
-      </div>
-
-    </section>
-
-  </div>
-  
-
-
-  
-
-    <script type="text/javascript">
-        var DOCUMENTATION_OPTIONS = {
-            URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
-            COLLAPSE_INDEX:false,
-            FILE_SUFFIX:'.html',
-            HAS_SOURCE:  true
-        };
-    </script>
-      <script type="text/javascript" src="../../../_static/jquery.js"></script>
-      <script type="text/javascript" src="../../../_static/underscore.js"></script>
-      <script type="text/javascript" src="../../../_static/doctools.js"></script>
-      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
-
-  
-
-  
-  
-    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
-  
-
-  
-  
-  <script type="text/javascript">
-<!--      jQuery(function () {
-          SphinxRtdTheme.StickyNav.enable();
-      }); -->
-  </script>
-  
- 
-
-
-
-</body>
-</html>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-deleted-expired-expunged-purged.html 3.2.0-3/doc/html/imap/reference/faqs/o-deleted-expired-expunged-purged.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-deleted-expired-expunged-purged.html	2019-12-16 04:17:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-deleted-expired-expunged-purged.html	2020-05-04 04:12:59.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>When is What ... Deleted, Expired, Expunged or Purged? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>When is What ... Deleted, Expired, Expunged or Purged? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why is deliver.db so large?" href="o-deliverdb-size.html"/>
         <link rel="prev" title="Why can I not delete a mailbox as an admin user?" href="o-delete-mailbox.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -847,12 +866,12 @@ earliest opportunity.</p>
 </div></blockquote>
 <p>Exceptional circumstances aside, when <code class="docutils literal"><span class="pre">immediate</span></code> or <code class="docutils literal"><span class="pre">default</span></code> is
 the configured <code class="docutils literal"><span class="pre">expunge_mode</span></code>, message files are often purged from the
-filesytem too quickly for anyone to recover.</p>
+filesystem too quickly for anyone to recover.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p class="last">One such exceptional circumstance is a mailbox with multiple
 sessions keeping the mailbox open. Cyrus IMAP ensures no mailbox
-records dissappear from underneath an existing open mailbox session.</p>
+records disappear from underneath an existing open mailbox session.</p>
 </div>
 </div>
 <div class="section" id="moved-to-trash-folder">
@@ -1004,7 +1023,7 @@ Extension.</td></tr>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1024,7 +1043,7 @@ Extension.</td></tr>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-delete-mailbox.html 3.2.0-3/doc/html/imap/reference/faqs/o-delete-mailbox.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-delete-mailbox.html	2019-12-16 04:17:43.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-delete-mailbox.html	2020-05-04 04:12:59.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why can I not delete a mailbox as an admin user? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why can I not delete a mailbox as an admin user? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,10 +37,10 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="When is What ... Deleted, Expired, Expunged or Purged?" href="o-deleted-expired-expunged-purged.html"/>
-        <link rel="prev" title="Is the “db3: x Lockers” log message harmful?" href="o-db3-lockers.html"/> 
+        <link rel="prev" title="How to enable core dumps" href="o-coredump.html"/> 
 
   
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-delete-mailbox.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-delete-mailbox.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -786,7 +805,7 @@ mailbox) is enough.</p>
         <a href="o-deleted-expired-expunged-purged.html" class="btn btn-neutral float-right" title="When is What ... Deleted, Expired, Expunged or Purged?" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="o-db3-lockers.html" class="btn btn-neutral" title="Is the “db3: x Lockers” log message harmful?" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="o-coredump.html" class="btn btn-neutral" title="How to enable core dumps" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -795,7 +814,7 @@ mailbox) is enough.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@ mailbox) is enough.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-deliverdb-size.html 3.2.0-3/doc/html/imap/reference/faqs/o-deliverdb-size.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-deliverdb-size.html	2019-12-16 04:17:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-deliverdb-size.html	2020-05-04 04:12:59.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why is deliver.db so large? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why is deliver.db so large? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!" href="o-freezes.html"/>
         <link rel="prev" title="When is What ... Deleted, Expired, Expunged or Purged?" href="o-deleted-expired-expunged-purged.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-deliverdb-size.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-deliverdb-size.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -774,7 +793,7 @@ lmtpd (so that duplicate suppression can
 of data there.</p>
 <p>Note also that it is common for databases to have unused
 space that may not be immediately recovered for performance reasons
-(this is the case with Berkeley DB and Cyrus Skiplist) You can control
+(this is the case with Cyrus Skiplist) You can control
 the size by increasing the frequency at which it gets pruned.</p>
 </div>
 
@@ -796,7 +815,7 @@ the size by increasing the frequency at
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -816,7 +835,7 @@ the size by increasing the frequency at
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-freezes.html 3.2.0-3/doc/html/imap/reference/faqs/o-freezes.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-freezes.html	2019-12-16 04:17:44.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-freezes.html	2020-05-04 04:13:00.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in! &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in! &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How to run gdb on Cyrus components" href="o-gdb.html"/>
         <link rel="prev" title="Why is deliver.db so large?" href="o-deliverdb-size.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-freezes.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-freezes.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -798,7 +817,7 @@ digits.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -818,7 +837,7 @@ digits.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-gdb.html 3.2.0-3/doc/html/imap/reference/faqs/o-gdb.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-gdb.html	2019-12-16 04:17:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-gdb.html	2020-05-04 04:13:00.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How to run gdb on Cyrus components &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How to run gdb on Cyrus components &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Cyrus delivers claims that the mailbox does not exist" href="o-mailbox-doesnotexist.html"/>
         <link rel="prev" title="I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!" href="o-freezes.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-gdb.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-gdb.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -811,7 +830,7 @@ you run. Use something like <a class="re
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 26 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 26 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@ you run. Use something like <a class="re
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-mailbox-doesnotexist.html 3.2.0-3/doc/html/imap/reference/faqs/o-mailbox-doesnotexist.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-mailbox-doesnotexist.html	2019-12-16 04:17:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-mailbox-doesnotexist.html	2020-05-04 04:13:01.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus delivers claims that the mailbox does not exist &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus delivers claims that the mailbox does not exist &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?" href="o-mixedcase.html"/>
         <link rel="prev" title="How to run gdb on Cyrus components" href="o-gdb.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-mailbox-doesnotexist.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-mailbox-doesnotexist.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@ using the unixhierarchysep.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@ using the unixhierarchysep.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-mixedcase.html 3.2.0-3/doc/html/imap/reference/faqs/o-mixedcase.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-mixedcase.html	2019-12-16 04:17:45.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-mixedcase.html	2020-05-04 04:13:01.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Can I use MySQL (or another SQL database) as the primary mail store?" href="o-otherdatabases.html"/>
         <link rel="prev" title="Cyrus delivers claims that the mailbox does not exist" href="o-mailbox-doesnotexist.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-mixedcase.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-mixedcase.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -805,7 +824,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -825,7 +844,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-otherdatabases.html 3.2.0-3/doc/html/imap/reference/faqs/o-otherdatabases.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-otherdatabases.html	2019-12-16 04:17:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-otherdatabases.html	2020-05-04 04:13:02.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Can I use MySQL (or another SQL database) as the primary mail store? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Can I use MySQL (or another SQL database) as the primary mail store? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why do POP3 connections take so long, but once the connection is established all is well?" href="o-pop3slow.html"/>
         <link rel="prev" title="Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?" href="o-mixedcase.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-otherdatabases.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-otherdatabases.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -781,7 +800,7 @@ mailboxes.</p>
 <p>Cyrus DOES have the option of using databases of various types for
 storing some other information, such as authentication data, mailbox
 lists, etc. There may be reasons to add a SQL backend to these databases
-in the future (in addition to flat, skiplist, and berkeley).</p>
+in the future (in addition to flat, and skiplist).</p>
 </div>
 
 
@@ -802,7 +821,7 @@ in the future (in addition to flat, skip
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@ in the future (in addition to flat, skip
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-pop3slow.html 3.2.0-3/doc/html/imap/reference/faqs/o-pop3slow.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-pop3slow.html	2019-12-16 04:17:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-pop3slow.html	2020-05-04 04:13:02.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why do POP3 connections take so long, but once the connection is established all is well? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why do POP3 connections take so long, but once the connection is established all is well? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why does reconstruct -m not work?" href="o-reconstruct.html"/>
         <link rel="prev" title="Can I use MySQL (or another SQL database) as the primary mail store?" href="o-otherdatabases.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-pop3slow.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-pop3slow.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -799,7 +818,7 @@ avoids affecting other applications.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -819,7 +838,7 @@ avoids affecting other applications.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-reconstruct.html 3.2.0-3/doc/html/imap/reference/faqs/o-reconstruct.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-reconstruct.html	2019-12-16 04:17:46.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-reconstruct.html	2020-05-04 04:13:03.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why does reconstruct -m not work? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why does reconstruct -m not work? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Shared File Systems GPFS for high availability" href="o-sharedfilesystem-gpfs.html"/>
         <link rel="prev" title="Why do POP3 connections take so long, but once the connection is established all is well?" href="o-pop3slow.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -811,7 +830,7 @@ for help.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -831,7 +850,7 @@ for help.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-sharedfilesystem-gpfs.html 3.2.0-3/doc/html/imap/reference/faqs/o-sharedfilesystem-gpfs.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-sharedfilesystem-gpfs.html	2019-12-16 04:17:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-sharedfilesystem-gpfs.html	2020-05-04 04:13:03.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Shared File Systems GPFS for high availability &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Shared File Systems GPFS for high availability &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How to enable telemetry" href="o-telemetry.html"/>
         <link rel="prev" title="Why does reconstruct -m not work?" href="o-reconstruct.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -788,7 +807,7 @@ to keep track of the filesystem meta-dat
 <p>Our Cyrus installation has about 80K users, close to 1TB of disk, and
 many millions of files. Just the number of files alone would be enough
 to kill the idea of using GPFS.</p>
-<p>Cyrus makes pretty extensive use of mmap(), and so does Berkeley DB.
+<p>Cyrus makes pretty extensive use of mmap().
 While GPFS implements mmap(), the GPFS architect had some words about
 the way certain operations are accomplished in Cyrus. I think there are
 (or used to be) places where an mmap&#8217;d file is opened for write with
@@ -855,7 +874,7 @@ choices and details with you if you&#821
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -875,7 +894,7 @@ choices and details with you if you&#821
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-telemetry.html 3.2.0-3/doc/html/imap/reference/faqs/o-telemetry.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-telemetry.html	2019-12-16 04:17:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-telemetry.html	2020-05-04 04:13:03.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How to enable telemetry &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How to enable telemetry &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="The process count keeps growing!" href="o-toomanyprocesses.html"/>
         <link rel="prev" title="Shared File Systems GPFS for high availability" href="o-sharedfilesystem-gpfs.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-telemetry.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-telemetry.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,7 +819,7 @@ chown cyrus <span class="nv">$configdire
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -820,7 +839,7 @@ chown cyrus <span class="nv">$configdire
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-toomanyprocesses.html 3.2.0-3/doc/html/imap/reference/faqs/o-toomanyprocesses.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-toomanyprocesses.html	2019-12-16 04:17:47.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-toomanyprocesses.html	2020-05-04 04:13:04.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>The process count keeps growing! &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>The process count keeps growing! &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="“unable to join environment” error" href="o-unable-join-environment.html"/>
         <link rel="prev" title="How to enable telemetry" href="o-telemetry.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-toomanyprocesses.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-toomanyprocesses.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -804,7 +823,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -824,7 +843,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-unable-join-environment.html 3.2.0-3/doc/html/imap/reference/faqs/o-unable-join-environment.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-unable-join-environment.html	2019-12-16 04:17:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-unable-join-environment.html	2020-05-04 04:13:04.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>“unable to join environment” error &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>“unable to join environment” error &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why does Cyrus set the MAIL FROM address of the sender of vacation responses to ‘&lt;&gt;’?" href="o-vacation-mailfrom.html"/>
         <link rel="prev" title="The process count keeps growing!" href="o-toomanyprocesses.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-unable-join-environment.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-unable-join-environment.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -809,7 +828,7 @@ Berkeley DB at all, which may be a viabl
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -829,7 +848,7 @@ Berkeley DB at all, which may be a viabl
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/o-vacation-mailfrom.html 3.2.0-3/doc/html/imap/reference/faqs/o-vacation-mailfrom.html
--- 3.0.13-5/doc/html/imap/reference/faqs/o-vacation-mailfrom.html	2019-12-16 04:17:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/o-vacation-mailfrom.html	2020-05-04 04:13:05.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Why does Cyrus set the MAIL FROM address of the sender of vacation responses to ‘&lt;&gt;’? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Why does Cyrus set the MAIL FROM address of the sender of vacation responses to ‘&lt;&gt;’? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Why does Cyrus reject 8-bit characters in the headers of my messages?" href="interop-8bit.html"/>
         <link rel="prev" title="“unable to join environment” error" href="o-unable-join-environment.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/o-vacation-mailfrom.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/o-vacation-mailfrom.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -823,7 +842,7 @@ address in the future.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -843,7 +862,7 @@ address in the future.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/r-murder-ha.html 3.2.0-3/doc/html/imap/reference/faqs/r-murder-ha.html
--- 3.0.13-5/doc/html/imap/reference/faqs/r-murder-ha.html	2019-12-16 04:17:48.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/r-murder-ha.html	2020-05-04 04:13:05.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Does the Cyrus Murder support High Availability configurations? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Does the Cyrus Murder support High Availability configurations? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Can I configure pop3d to log amount and size of messages fetched by user?" href="r-pop3-logging.html"/>
         <link rel="prev" title="OpenSSL Version Mismatches" href="install-linkerwarnings.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul class="current">
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/r-murder-ha.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/r-murder-ha.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -780,7 +799,7 @@ other from the point of view of a user.<
 failure at this point only prohibits message delivery (via the LMTP
 proxies that are querying it for up-to-date mailbox data) and certain
 mailbox operations (create, delete, setacl, and so on). Mail can still
-be accessed by all users of the system, and incoming mail will recieve
+be accessed by all users of the system, and incoming mail will receive
 temporary failures, so the sending MTA should continue to queue the
 mail.</p>
 <p>The failure of a backend will result in a partial system wide failure &#8211;
@@ -813,7 +832,7 @@ recommended that it have an efficient mm
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@ recommended that it have an efficient mm
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/r-pop3-logging.html 3.2.0-3/doc/html/imap/reference/faqs/r-pop3-logging.html
--- 3.0.13-5/doc/html/imap/reference/faqs/r-pop3-logging.html	2019-12-16 04:17:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/r-pop3-logging.html	2020-05-04 04:13:05.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Can I configure pop3d to log amount and size of messages fetched by user? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Can I configure pop3d to log amount and size of messages fetched by user? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How can I make CyrusSieve work with public shared folders?" href="r-publicssharedfolders.html"/>
         <link rel="prev" title="Does the Cyrus Murder support High Availability configurations?" href="r-murder-ha.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul class="current">
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/r-pop3-logging.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/r-pop3-logging.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -791,7 +810,7 @@ welcome.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -811,7 +830,7 @@ welcome.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/r-publicssharedfolders.html 3.2.0-3/doc/html/imap/reference/faqs/r-publicssharedfolders.html
--- 3.0.13-5/doc/html/imap/reference/faqs/r-publicssharedfolders.html	2019-12-16 04:17:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/r-publicssharedfolders.html	2020-05-04 04:13:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>How can I make CyrusSieve work with public shared folders? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>How can I make CyrusSieve work with public shared folders? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="Can I have subfolders not appear under INBOX?" href="r-subfolders.html"/>
         <link rel="prev" title="Can I configure pop3d to log amount and size of messages fetched by user?" href="r-pop3-logging.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul class="current">
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/r-publicssharedfolders.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/r-publicssharedfolders.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -789,7 +808,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +828,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/faqs/r-subfolders.html 3.2.0-3/doc/html/imap/reference/faqs/r-subfolders.html
--- 3.0.13-5/doc/html/imap/reference/faqs/r-subfolders.html	2019-12-16 04:17:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/faqs/r-subfolders.html	2020-05-04 04:13:06.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Can I have subfolders not appear under INBOX? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Can I have subfolders not appear under INBOX? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Frequently Asked Questions" href="../faq.html"/>
         <link rel="next" title="How do I view ACLs on a mailbox?" href="o-acls.html"/>
         <link rel="prev" title="How can I make CyrusSieve work with public shared folders?" href="r-publicssharedfolders.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3 current"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul class="current">
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/faqs/r-subfolders.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/faqs/r-subfolders.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -794,7 +813,7 @@ through cyradm. See <a class="reference
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -814,7 +833,7 @@ through cyradm. See <a class="reference
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/commands.html 3.2.0-3/doc/html/imap/reference/manpages/commands.html
--- 3.0.13-5/doc/html/imap/reference/manpages/commands.html	2019-12-16 04:17:49.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/commands.html	2020-05-04 04:13:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Man pages &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Man pages &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../index.html"/>
         <link rel="up" title="Operations" href="../../../operations.html"/>
         <link rel="next" title="cyrus.conf" href="configs/cyrus.conf.html"/>
         <link rel="prev" title="Operations" href="../../../operations.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="current reference internal" href="#">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../operations.html">Operations</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/commands.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/commands.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -771,7 +790,7 @@
 <div class="toctree-wrapper compound">
 <ul>
 <li class="toctree-l1"><a class="reference internal" href="configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l1"><a class="reference internal" href="configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l1"><a class="reference internal" href="configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l1"><a class="reference internal" href="configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </div>
@@ -887,7 +906,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 09 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 09 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -907,7 +926,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/configs/cyrus.conf.html 3.2.0-3/doc/html/imap/reference/manpages/configs/cyrus.conf.html
--- 3.0.13-5/doc/html/imap/reference/manpages/configs/cyrus.conf.html	2019-12-16 04:17:50.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/configs/cyrus.conf.html	2020-05-04 04:13:07.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyrus.conf &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyrus.conf &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="imapd.conf" href="imapd.conf.html"/>
         <link rel="prev" title="Man pages" href="../commands.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3 current"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul class="current">
 <li class="toctree-l4 current"><a class="current reference internal" href="#"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/configs/cyrus.conf.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/configs/cyrus.conf.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -869,7 +888,7 @@ either the hostname or bracket-enclosed
 interface, and <em>port</em> is either a port number or service name
 (as listed in <code class="docutils literal"><span class="pre">/etc/services</span></code>).</p>
 <p>If <em>host</em> is missing, 0.0.0.0 (all interfaces) is assumed.  Use
-localhost or 127.0.0.1 to restict access, i.e. when a proxy
+localhost or 127.0.0.1 to restrict access, i.e. when a proxy
 on the same host is front-ending Cyrus.</p>
 <p>Note that on most systems UNIX socket paths are limited to around
 100 characters.  See your system documentation for specifics.</p>
@@ -946,8 +965,10 @@ set to 1440. This string argument is opt
 <div class="section" id="daemon">
 <h3>DAEMON<a class="headerlink" href="#daemon" title="Permalink to this headline">¶</a></h3>
 <p>This section lists long running daemons to start before any
-<strong>SERVICES</strong> are spawned.  They will be shutdown when
-<a class="reference internal" href="../systemcommands/master.html#std:cyrusman-master(8)">master(8)</a> is exiting.</p>
+<strong>SERVICES</strong> are spawned.  <a class="reference internal" href="../systemcommands/master.html#std:cyrusman-master(8)">master(8)</a>  will ensure that
+these processes are running, restarting any process which dies or
+forks. All listed processes will be shutdown when <a class="reference internal" href="../systemcommands/master.html#std:cyrusman-master(8)">master(8)</a>
+is exiting.</p>
 <pre class="literal-block">
 <strong>cmd=</strong>&lt;no default&gt;
 </pre>
@@ -999,6 +1020,7 @@ still have separate access control rules
 <a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a>,
 <a class="reference internal" href="../systemcommands/pop3d.html#std:cyrusman-pop3d(8)">pop3d(8)</a>,
 <a class="reference internal" href="../systemcommands/lmtpd.html#std:cyrusman-lmtpd(8)">lmtpd(8)</a>,
+<a class="reference internal" href="../systemcommands/smmapd.html#std:cyrusman-smmapd(8)">smmapd(8)</a>,
 <a class="reference internal" href="../systemcommands/timsieved.html#std:cyrusman-timsieved(8)">timsieved(8)</a>,
 <a class="reference internal" href="../systemcommands/idled.html#std:cyrusman-idled(8)">idled(8)</a>,
 <a class="reference internal" href="../systemcommands/notifyd.html#std:cyrusman-notifyd(8)">notifyd(8)</a>,
@@ -1027,7 +1049,7 @@ still have separate access control rules
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Mar 19 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 13 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1047,7 +1069,7 @@ still have separate access control rules
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/configs/imapd.conf.html 3.2.0-3/doc/html/imap/reference/manpages/configs/imapd.conf.html
--- 3.0.13-5/doc/html/imap/reference/manpages/configs/imapd.conf.html	2019-12-16 04:17:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/configs/imapd.conf.html	2020-05-04 04:13:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>imapd.conf &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>imapd.conf &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="krb.equiv" href="krb.equiv.html"/>
         <link rel="prev" title="cyrus.conf" href="cyrus.conf.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3 current"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4 current"><a class="current reference internal" href="#">imapd.conf</a></li>
+<li class="toctree-l4 current"><a class="current reference internal" href="#"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,13 +766,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
           <li><a href="../commands.html">Man pages</a> &raquo;</li>
       
-    <li>imapd.conf</li>
+    <li><strong>imapd.conf</strong></li>
       <li class="wy-breadcrumbs-aside">
         
           
@@ -767,7 +786,7 @@
           <div role="main" class="document">
             
   <div class="section" id="imapd-conf">
-<span id="imap-reference-manpages-configs-imapd-conf"></span><span id="std:cyrusman-imapd.conf(5)"></span><h1>imapd.conf<a class="headerlink" href="#imapd-conf" title="Permalink to this headline">¶</a></h1>
+<span id="imap-reference-manpages-configs-imapd-conf"></span><span id="std:cyrusman-imapd.conf(5)"></span><h1><strong>imapd.conf</strong><a class="headerlink" href="#imapd-conf" title="Permalink to this headline">¶</a></h1>
 <p>IMAP configuration file</p>
 <div class="section" id="description">
 <h2>DESCRIPTION<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
@@ -803,6 +822,14 @@ using ``\&#8217;&#8217; character(s) is
 <p>For boolean and enumerated options, the values ``yes&#8217;&#8216;, ``on&#8217;&#8216;, ``t&#8217;&#8216;,
 ``true&#8217;&#8217; and ``1&#8217;&#8217; turn the option on, the values ``no&#8217;&#8216;, ``off&#8217;&#8216;,
 ``f&#8217;&#8216;, ``false&#8217;&#8217; and ``0&#8217;&#8217; turn the option off.</p>
+<p>Duration options take the form of a number followed by a unit, for example
+<strong>32m</strong> (32 minutes).  Units are <strong>d</strong> (days), <strong>h</strong> (hours), <strong>m</strong>
+(minutes) and <strong>s</strong> (seconds).  Multiple units can be combined and will
+be summed together, for example <strong>1h30m</strong> is equivalent to <strong>90m</strong>.  If
+no unit is specified, an option-specific backward-compatible default unit
+is assumed (documented on an option-by-option basis).  These are simple time
+units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+etc are not considered).</p>
 </div></blockquote>
 </div>
 <div class="section" id="field-descriptions">
@@ -860,6 +887,9 @@ support, that the plaintext passwords ar
 backend (e.g., sasldb), and that the system can provide enough entropy
 (e.g., from /dev/urandom) to create a challenge in the banner.</p>
 </div></blockquote>
+<p><code class="docutils literal"><span class="pre">allowdeleted:</span></code> 0</p>
+<blockquote>
+<div>Allow access to deleted and expunged data via vendor.cmu-* access</div></blockquote>
 <p><code class="docutils literal"><span class="pre">allownewnews:</span></code> 0</p>
 <blockquote>
 <div><p>Allow use of the NNTP NEWNEWS command.</p>
@@ -875,6 +905,10 @@ authentication mechanisms being advertis
 TLS/SSL encryption layer to be negotiated prior to ANY
 authentication, see the <em>tls_required</em> option.</p>
 </div></blockquote>
+<p><code class="docutils literal"><span class="pre">allowsetacl:</span></code> 1</p>
+<blockquote>
+<div>Defaults to enabled.  If disabled, disallows the use of the SETACL
+command at all via IMAP.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">allowusermoves:</span></code> 0</p>
 <blockquote>
 <div><p>Allow moving user accounts (with associated meta-data) via RENAME
@@ -902,7 +936,7 @@ otherwise go under here</div></blockquot
 <p><code class="docutils literal"><span class="pre">annotation_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for mailbox annotations.</p>
-<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">annotation_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -984,6 +1018,15 @@ particular the <strong>a</strong> permis
 or flags to a message when it is appended to a mailbox.  The path can
 be either an executable (including a script), or a UNIX domain
 socket.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">annotation_callout_disable_append:</span></code> 0</p>
+<blockquote>
+<div>Disables annotations on append with xrunannotator</div></blockquote>
+<p><code class="docutils literal"><span class="pre">annotation_enable_legacy_commands:</span></code> 0</p>
+<blockquote>
+<div>Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+These commands are deprecated and will be removed in the future,
+but might be useful in the meantime for supporting old clients that
+do not implement the <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5464.html"><strong>RFC 5464</strong></a> IMAP METADATA extension.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">aps_topic:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Topic for Apple Push Service registration.</div></blockquote>
@@ -999,10 +1042,16 @@ socket.</div></blockquote>
 archivepartition for the mailbox.  Archiving allows older email
 to be stored on slower, cheaper disks - even within the same
 mailbox, as distinct from partitions.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">archive_days:</span></code> 7</p>
+<p><code class="docutils literal"><span class="pre">archive_days:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>The number of days after which to move messages to the archive partition
-if archiving is enabled</div></blockquote>
+<div>Deprecated in favour of <em>archive_after</em>.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">archive_after:</span></code> 7d</p>
+<blockquote>
+<div><p>The duration after which to move messages to the archive partition
+if archiving is enabled.</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">archive_maxsize:</span></code> 1024</p>
 <blockquote>
 <div>The size in kilobytes of the largest message that won&#8217;t be archived
@@ -1057,6 +1106,19 @@ can be very useful for tracking down wha
 <p><code class="docutils literal"><span class="pre">autosubscribe_all_sharedfolders:</span></code> 0</p>
 <blockquote>
 <div>Deprecated in favor of <em>autocreate_subscribe_sharedfolders_all</em>.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">autocreate_acl:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>If folders are to be created by <em>autocreate_inbox_foldersR, this
+setting can be used to apply additional ACLs to the autocreated
+folders.  The syntax is &#8220;autocreate_acl folder identifier rights&#8221;,
+where **folder</em> must match one of the <em>autocreate_inbox_folders</em>
+folders, <em>identifier</em> must be a valid cyrus identifier, and
+<em>rights</em> must be a valid cyrus rights string.  Multiple
+identifier|rights pairs can be assigned to a single folder by providing
+this setting multiple times.</p>
+<p>For example, &#8220;autocreate_acl Plus anyone p&#8221; would allow lmtp delivery
+to a folder named &#8220;Plus&#8221;.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">autocreate_inbox_folders:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div><p>If a user does not have an INBOX already, and the INBOX is to be
@@ -1150,6 +1212,10 @@ to subscribe to.</div></blockquote>
 <blockquote>
 <div>A space separated list of users and/or groups that are allowed their INBOX to be
 automatically created.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">autoexpunge:</span></code> 0</p>
+<blockquote>
+<div>If set to yes, then all Deleted messages will be automatically expunged whenever
+an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect</div></blockquote>
 <p><code class="docutils literal"><span class="pre">backuppartition-name:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The pathname of the backup partition <em>name</em>.  At least one backup
@@ -1176,15 +1242,21 @@ is treated as being one.</div></blockquo
 <blockquote>
 <div>The absolute path of the backup staging area.  If not specified,
 will be temp_path/backup</div></blockquote>
-<p><code class="docutils literal"><span class="pre">backup_retention_days:</span></code> 7</p>
+<p><code class="docutils literal"><span class="pre">backup_retention_days:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>Deprecated in favor of <em>backup_retention</em>.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">backup_retention:</span></code> 7d</p>
 <blockquote>
-<div>The number of days to keep content in backup after it has been deleted
+<div><p>How long to keep content in backup after it has been deleted
 from the source.  If set to a negative value or zero, deleted content
-will be kept indefinitely.</div></blockquote>
+will be kept indefinitely.</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">backup_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the backup locations database.</p>
-<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">backup_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -1208,7 +1280,10 @@ layers of MIME structure.  The default o
 than any sane message should have.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_allowattach:</span></code> 1</p>
 <blockquote>
-<div>Enable managed attachments support on the caldav server.</div></blockquote>
+<div>Enable managed attachments support on the CalDAV server.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">caldav_allowcalendaradmin:</span></code> 0</p>
+<blockquote>
+<div>Enable per-user calendar administration web UI on the CalDAV server.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_allowscheduling:</span></code> on</p>
 <blockquote>
 <div>Enable calendar scheduling operations. If set to &#8220;apple&#8221;, the
@@ -1217,13 +1292,23 @@ possible.
 Allowed values: <em>off</em>, <em>on</em>, <em>apple</em></div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_create_attach:</span></code> 1</p>
 <blockquote>
-<div>Create the &#8216;Attachments&#8217; calendar if it doesn&#8217;t already exist</div></blockquote>
+<div>Create the &#8216;Attachments&#8217; collection if it doesn&#8217;t already exist</div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_create_default:</span></code> 1</p>
 <blockquote>
 <div>Create the &#8216;Default&#8217; calendar if it doesn&#8217;t already exist</div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_create_sched:</span></code> 1</p>
 <blockquote>
 <div>Create the &#8216;Inbox&#8217; and &#8216;Outbox&#8217; calendars if they don&#8217;t already exist</div></blockquote>
+<p><code class="docutils literal"><span class="pre">caldav_historical_age:</span></code> 7d</p>
+<blockquote>
+<div><p>How long after an occurrence of event or task has concluded
+that it is considered &#8216;historical&#8217;.  Changes to historical
+occurrences of events or tasks WILL NOT have invite or reply
+messages sent for them.  A negative value means that events
+and tasks are NEVER considered historical.</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">caldav_maxdatetime:</span></code> 20380119T031407Z</p>
 <blockquote>
 <div><p>The latest date and time accepted by the server (ISO format).  This
@@ -1252,6 +1337,20 @@ user&#8217;s personal calendar hierarchy
 <div>Space-separated list of domains corresponding to calendar user
 addresses for which the server is responsible.  If not set (the
 default), the value of the &#8220;servername&#8221; option will be used.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">calendar_component_set:</span></code> VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL</p>
+<blockquote>
+<div>Space-separated list of iCalendar component types that calendar
+object resources may contain in a calendar collection.
+This restriction is only set at calendar creation time and only
+if the CalDAV client hasn&#8217;t specified a restriction in the creation
+request.
+Allowed values: <em>VEVENT</em>, <em>VTODO</em>, <em>VJOURNAL</em>, <em>VFREEBUSY</em>, <em>VAVAILABILITY</em>, <em>VPOLL</em></div></blockquote>
+<p><code class="docutils literal"><span class="pre">carddav_allowaddmember:</span></code> 0</p>
+<blockquote>
+<div>Enable support for POST add-member on the CardDAV server.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">carddav_allowaddressbookadmin:</span></code> 0</p>
+<blockquote>
+<div>Enable per-user addressbook administration web UI on the CardDAV server.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">carddav_realm:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The realm to present for HTTP authentication of CardDAV resources.
@@ -1279,10 +1378,13 @@ connections will use an IP chosen by the
 <div>IPv4, IPv6 address or hostname to bind for client connections when
 <strong>client_bind</strong> is enabled.  If not set (the default),
 servername will be used.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">client_timeout:</span></code> 10</p>
+<p><code class="docutils literal"><span class="pre">client_timeout:</span></code> 10s</p>
 <blockquote>
-<div>Number of seconds to wait before returning a timeout failure when
-performing a client connection (e.g., in a murder environment)</div></blockquote>
+<div><p>Time to wait before returning a timeout failure when performing a
+client connection (e.g. in a murder environment).</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">commandmintimer:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Time in seconds. Any imap command that takes longer than this
@@ -1308,13 +1410,23 @@ running server, or the counts will be wr
 <p><code class="docutils literal"><span class="pre">conversations_db:</span></code> skiplist</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the per-user conversations database.</p>
-<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
-<p><code class="docutils literal"><span class="pre">conversations_expire_days:</span></code> 90</p>
+<p><code class="docutils literal"><span class="pre">conversations_expire_days:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>Deprecated in favor of <em>conversations_expire_after</em>.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">conversations_expire_after:</span></code> 90d</p>
 <blockquote>
-<div>How long the conversations database keeps the message tracking
+<div><p>How long the conversations database keeps the message tracking
 information needed for receiving new messages in existing
-conversations, in days.</div></blockquote>
+conversations.</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">conversations_max_thread:</span></code> 100</p>
+<blockquote>
+<div>maximum size for a single thread.  Threads will split if they have this many
+* messages in them and another message arrives</div></blockquote>
 <p><code class="docutils literal"><span class="pre">crossdomains:</span></code> 0</p>
 <blockquote>
 <div>Enable cross domain sharing.  This works best with alt namespace and
@@ -1350,12 +1462,21 @@ user&#8217;s personal notifications hier
 <div>The realm to present for HTTP authentication of generic DAV
 resources (principals).  If not set (the default), the value of the
 &#8220;servername&#8221; option will be used.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">dav_lock_timeout:</span></code> 20s</p>
+<blockquote>
+<div><p>The maximum time to wait for a write lock on the per-user DAV database
+before timeout. For HTTP requests, the HTTP status code 503 is returned
+if the lock can not be obtained within this time.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">debug_command:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Debug command to be used by processes started with -D option.  The string
 is a C format string that gets 3 options: the first is the name of the
-executable (without path).  The second is the pid (integer) and the third
-is the service ID.  Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d</div></blockquote>
+executable (as specified in the cmd parameter in cyrus.conf). The second
+is the pid (integer) and the third is the service ID.
+Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d</div></blockquote>
 <p><code class="docutils literal"><span class="pre">defaultacl:</span></code> anyone lrs</p>
 <blockquote>
 <div>The Access Control List (ACL) placed on a newly-created (non-user)
@@ -1406,13 +1527,13 @@ immediately.</p>
 <p><code class="docutils literal"><span class="pre">delete_unsubscribe:</span></code> 0</p>
 <blockquote>
 <div>Whether to also unsubscribe from mailboxes when they are deleted.
-Note that this behaviour contravenes <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a> section 6.3.9, but
+Note that this behaviour contravenes <span class="target" id="index-5"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a> section 6.3.9, but
 may be useful for avoiding user/client software confusion.
 The default is &#8216;no&#8217;.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">deleteright:</span></code> c</p>
 <blockquote>
 <div>Deprecated - only used for backwards compatibility with existing
-installations.  Lists the old <span class="target" id="index-5"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2086.html"><strong>RFC 2086</strong></a> right which was used to
+installations.  Lists the old <span class="target" id="index-6"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2086.html"><strong>RFC 2086</strong></a> right which was used to
 grant the user the ability to delete a mailbox.  If a user has this
 right, they will automatically be given the new &#8216;x&#8217; right.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">disable_user_namespace:</span></code> 0</p>
@@ -1437,6 +1558,9 @@ in use by the client.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">ischedule_dkim_key_file:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>File containing the private key for iSchedule DKIM signing.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">ischedule_dkim_required:</span></code> 1</p>
+<blockquote>
+<div>A DKIM signature is required on received iSchedule requests.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">ischedule_dkim_selector:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Name of the selector subdividing the domain namespace.  This
@@ -1446,7 +1570,7 @@ domain.</div></blockquote>
 <blockquote>
 <div>The cyrusdb backend to use for the duplicate delivery suppression
 and sieve.
-Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></div></blockquote>
+Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></div></blockquote>
 <p><code class="docutils literal"><span class="pre">duplicate_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The absolute path to the duplicate db file.  If not specified,
@@ -1481,7 +1605,7 @@ Set ALL for any folder</div></blockquote
 <p><code class="docutils literal"><span class="pre">event_extra_params:</span></code> timestamp</p>
 <blockquote>
 <div><p>Space-separated list of extra parameters to add to any appropriated event.</p>
-<p>Allowed values: <em>bodyStructure</em>, <em>clientAddress</em>, <em>diskUsed</em>, <em>flagNames</em>, <em>messageContent</em>, <em>messageSize</em>, <em>messages</em>, <em>modseq</em>, <em>service</em>, <em>timestamp</em>, <em>uidnext</em>, <em>vnd.cmu.midset</em>, <em>vnd.cmu.unseenMessages</em>, <em>vnd.cmu.envelope</em>, <em>vnd.cmu.sessionId</em>, <em>vnd.cmu.mailboxACL</em>, <em>vnd.cmu.mbtype</em>, <em>vnd.cmu.davFilename</em>, <em>vnd.cmu.davUid</em>, <em>vnd.fastmail.clientId</em>, <em>vnd.fastmail.sessionId</em>, <em>vnd.fastmail.convExists</em>, <em>vnd.fastmail.convUnseen</em>, <em>vnd.fastmail.cid</em>, <em>vnd.fastmail.counters</em></p>
+<p>Allowed values: <em>bodyStructure</em>, <em>clientAddress</em>, <em>diskUsed</em>, <em>flagNames</em>, <em>messageContent</em>, <em>messageSize</em>, <em>messages</em>, <em>modseq</em>, <em>service</em>, <em>timestamp</em>, <em>uidnext</em>, <em>vnd.cmu.midset</em>, <em>vnd.cmu.unseenMessages</em>, <em>vnd.cmu.envelope</em>, <em>vnd.cmu.sessionId</em>, <em>vnd.cmu.mailboxACL</em>, <em>vnd.cmu.mbtype</em>, <em>vnd.cmu.davFilename</em>, <em>vnd.cmu.davUid</em>, <em>vnd.fastmail.clientId</em>, <em>vnd.fastmail.sessionId</em>, <em>vnd.fastmail.convExists</em>, <em>vnd.fastmail.convUnseen</em>, <em>vnd.fastmail.cid</em>, <em>vnd.fastmail.counters</em>, <em>vnd.cmu.emailid</em>, <em>vnd.cmu.threadid</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">event_groups:</span></code> message mailbox</p>
 <blockquote>
@@ -1491,29 +1615,31 @@ Set ALL for any folder</div></blockquote
 <p><code class="docutils literal"><span class="pre">event_notifier:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Notifyd(8) method to use for &#8220;EVENT&#8221; notifications which are based on
-the <span class="target" id="index-6"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5423.html"><strong>RFC 5423</strong></a>.  If not set, &#8220;EVENT&#8221; notifications are disabled.</div></blockquote>
+the <span class="target" id="index-7"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5423.html"><strong>RFC 5423</strong></a>.  If not set, &#8220;EVENT&#8221; notifications are disabled.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">expunge_mode:</span></code> delayed</p>
 <blockquote>
 <div>The mode in which messages (and their corresponding cache entries)
-are expunged.  &#8220;default&#8221; mode is the old behavior in which the
+are expunged.  &#8220;semidelayed&#8221; mode is the old behavior in which the
 message files are purged at the time of the EXPUNGE, but index
-and cache records are retained to facilitate QRESYNC.  (Note that
-this behaviour is no longer the default, but is so named for historical
-reasons.)  In &#8220;delayed&#8221; mode, which is the default since Cyrus 2.5.0,
+and cache records are retained to facilitate QRESYNC.
+In &#8220;delayed&#8221; mode, which is the default since Cyrus 2.5.0,
 the message files are also retained, allowing unexpunge to
 rescue them.  In &#8220;immediate&#8221; mode, both the message files and the
 index records are removed as soon as possible.  In all cases,
 nothing will be finally purged until all other processes have
 closed the mailbox to ensure they never see data disappear under
-them.  In &#8220;default&#8221; or &#8220;delayed&#8221; mode, a later run of &#8220;cyr_expire&#8221;
+them.  In &#8220;semidelayed&#8221; or &#8220;delayed&#8221; mode, a later run of &#8220;cyr_expire&#8221;
 will clean out the retained records (and possibly message files).
 This reduces the amount of I/O that takes place at the time of
 EXPUNGE and should result in greater responsiveness for the client,
 especially when expunging a large number of messages.
-Allowed values: <em>default</em>, <em>immediate</em>, <em>delayed</em></div></blockquote>
-<p><code class="docutils literal"><span class="pre">failedloginpause:</span></code> 3</p>
+Allowed values: <em>immediate</em>, <em>semidelayed</em>, <em>delayed</em></div></blockquote>
+<p><code class="docutils literal"><span class="pre">failedloginpause:</span></code> 3s</p>
 <blockquote>
-<div>Number of seconds to pause after a failed login.</div></blockquote>
+<div><p>Time to pause after a failed login.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">flushseenstate:</span></code> 1</p>
 <blockquote>
 <div>Deprecated. No longer used</div></blockquote>
@@ -1600,14 +1726,17 @@ by clients anyways.</div></blockquote>
 <div>If set, http will serve the static content (html/text/jpeg/gif
 files, etc) rooted at this directory.  Otherwise, httpd will not
 serve any static content.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">httpkeepalive:</span></code> 20</p>
+<p><code class="docutils literal"><span class="pre">httpkeepalive:</span></code> 20s</p>
 <blockquote>
-<div>Set the length of the HTTP server&#8217;s keepalive heartbeat in seconds.
-The default is 20.  The minimum value is 0, which will disable the
-keepalive heartbeat.  When enabled, if a request takes longer than
-<em>httpkeepalive</em> seconds to process, the server will send the client
-provisional responses every <em>httpkeepalive</em> seconds until the
-final response can be sent</div></blockquote>
+<div><p>Set the length of the HTTP server&#8217;s keepalive heartbeat.  The
+default is 20 seconds.  The minimum value is 0, which will disable
+the keepalive heartbeat.  When enabled, if a request takes longer
+than <em>httpkeepalive</em> to process, the server will send the client
+provisional responses every <em>httpkeepalive</em> until the final
+response can be sent.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">httpmodules:</span></code> &lt;empty string&gt;</p>
 <blockquote>
 <div><p>Space-separated list of HTTP modules that will be enabled in
@@ -1616,7 +1745,7 @@ at compile time due to missing dependenc
 <p>Note that &#8220;domainkey&#8221; depends on &#8220;ischedule&#8221; being enabled, and
 that both &#8220;freebusy&#8221; and &#8220;ischedule&#8221; depend on &#8220;caldav&#8221; being
 enabled.
-Allowed values: <em>admin</em>, <em>caldav</em>, <em>carddav</em>, <em>domainkey</em>, <em>freebusy</em>, <em>ischedule</em>, <em>rss</em>, <em>tzdist</em>, <em>webdav</em></p>
+Allowed values: <em>admin</em>, <em>caldav</em>, <em>carddav</em>, <em>cgi</em>, <em>domainkey</em>, <em>freebusy</em>, <em>ischedule</em>, <em>jmap</em>, <em>prometheus</em>, <em>rss</em>, <em>tzdist</em>, <em>webdav</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">httpprettytelemetry:</span></code> 0</p>
 <blockquote>
@@ -1625,11 +1754,14 @@ markup languages (HTML, XML) will utiliz
 indentation to promote better human-readability in telemetry logs.
 Note that enabling this option will increase the amount of data
 sent across the wire.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">httptimeout:</span></code> 5</p>
+<p><code class="docutils literal"><span class="pre">httptimeout:</span></code> 5m</p>
 <blockquote>
-<div>Set the length of the HTTP server&#8217;s inactivity autologout timer,
-in minutes.  The default is 5.  The minimum value is 0, which will
-disable persistent connections.</div></blockquote>
+<div><p>Set the length of the HTTP server&#8217;s inactivity autologout timer.
+The default is 5 minutes.  The minimum value is 0, which will
+disable persistent connections.</p>
+<p>For backwards compatibility, if no unit is specified, minutes
+is assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">idlesocket:</span></code> {configdirectory}/socket/idle</p>
 <blockquote>
 <div>Unix domain socket that idled listens on.</div></blockquote>
@@ -1637,12 +1769,15 @@ disable persistent connections.</div></b
 <blockquote>
 <div>For backwards compatibility with Cyrus 1.5.10 and earlier &#8211; ignore
 the reference argument in LIST or LSUB commands.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">imapidlepoll:</span></code> 60</p>
+<p><code class="docutils literal"><span class="pre">imapidlepoll:</span></code> 60s</p>
 <blockquote>
-<div>The interval (in seconds) for polling for mailbox changes and
-ALERTs while running the IDLE command.  This option is used when
-idled is not enabled or cannot be contacted.  The minimum value is
-1.  A value of 0 will disable IDLE.</div></blockquote>
+<div><p>The interval for polling for mailbox changes and ALERTs while running
+the IDLE command.  This option is used when idled is not enabled or
+cannot be contacted.  The minimum value is 1 second.  A value of 0
+will disable IDLE.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">imapidresponse:</span></code> 1</p>
 <blockquote>
 <div>If enabled, the server responds to an ID command with a parameter
@@ -1657,8 +1792,8 @@ mailboxes.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">imipnotifier:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Notifyd(8) method to use for &#8220;IMIP&#8221; notifications which are based on
-the <span class="target" id="index-7"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6047.html"><strong>RFC 6047</strong></a>.  If not set, &#8220;IMIP&#8221; notifications are disabled.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">implicit_owner_rights:</span></code> lkxa</p>
+the <span class="target" id="index-8"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6047.html"><strong>RFC 6047</strong></a>.  If not set, &#8220;IMIP&#8221; notifications are disabled.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">implicit_owner_rights:</span></code> lkxan</p>
 <blockquote>
 <div>The implicit Access Control List (ACL) for the owner of a mailbox.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">&#64;include:</span></code> &lt;none&gt;</p>
@@ -1677,13 +1812,123 @@ option.  When not using flat files for t
 the same has to be done (cyr_dbtool) for each subscription database
 See improved_mboxlist_sort.html.</p>
 </div></blockquote>
-<p><code class="docutils literal"><span class="pre">internaldate_heuristic:</span></code> standard</p>
+<p><code class="docutils literal"><span class="pre">jmap_emailsearch_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>Mechanism to determine email internaldates on delivery/reconstruct.
-&#8220;standard&#8221; uses time() when delivering a message, mtime on reconstruct.
-&#8220;receivedheader&#8221; looks at the top most Received header
-or time/mtime otherwise
-Allowed values: <em>standard</em>, <em>receivedheader</em></div></blockquote>
+<div>The absolute path to the JMAP email search cache file.  If not
+specified, JMAP Email/query and Email/queryChanges will not
+cache email search results.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_preview_annot:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The name of the per-message annotation, if any, to store message
+previews.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_imagesize_annot:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>The name of the per-message annotation, if any, that stores a
+JSON object, mapping message part numbers of MIME image types
+to an array of their image dimensions. The array must have at
+least two entries, where the first entry denotes the width
+and the second entry the height of the image. Any additional
+values are ignored.</p>
+<p>For example, if message part 1.2 contains an image of width 300
+and height 200, then the value of this annotation would be:</p>
+<p>{ &#8220;1.2&#8221; : [ 300, 200 ] }</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_inlinedcids_annot:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>The name of the per-message annotation, if any, that stores a
+JSON object, mapping <span class="target" id="index-9"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2392.html"><strong>RFC 2392</strong></a> Content-IDs referenced in HTML bodies
+to the respective HTML body part number.</p>
+<p>For example, if message part 1.2 contains HTML and references an
+inlined image at &#8220;<a class="reference external" href="cid:foo">cid:foo</a>&#8221;, then the value of this annotation
+would be:</p>
+<p>{ &#8220;&lt;foo&gt;&#8221; : &#8220;1.2&#8221; }</p>
+<p>Note that the Content-ID key must be URL-unescaped and enclosed in
+angular brackets, as defined in <span class="target" id="index-10"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2392.html"><strong>RFC 2392</strong></a>.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_preview_length:</span></code> 64</p>
+<blockquote>
+<div>The maximum byte length of dynamically generated message previews. Previews
+stored in jmap_preview_annot take precedence.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_size_upload:</span></code> 1048576</p>
+<blockquote>
+<div>The maximum size (in kilobytes) that the JMAP API accepts
+for blob uploads. Returned as the maxSizeUpload property
+value of the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object.
+Default is 1Gb.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_concurrent_upload:</span></code> 5</p>
+<blockquote>
+<div>The value to return for the maxConcurrentUpload property of
+the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object. The Cyrus JMAP
+implementation does not enforce this rate-limit.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_size_request:</span></code> 10240</p>
+<blockquote>
+<div>The maximum size (in kilobytes) that the JMAP API accepts
+for requests at the API endpoint. Returned as the
+maxSizeRequest property value of the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221;
+capabilities object. Default is 10Mb.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_concurrent_requests:</span></code> 5</p>
+<blockquote>
+<div>The value to return for the maxConcurrentRequests property of
+the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object. The Cyrus JMAP
+implementation does not enforce this rate-limit.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_calls_in_request:</span></code> 50</p>
+<blockquote>
+<div>The maximum number of calls per JMAP request object.
+Returned as the maxCallsInRequest property value of the
+JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_delayed_send:</span></code> 512d</p>
+<blockquote>
+<div><p>The value to return for the maxDelayedSend property of
+the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:emailsubmission">urn:ietf:params:jmap:emailsubmission</a>&#8221; capabilities object.
+The Cyrus JMAP implementation does not enforce this limit.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_objects_in_get:</span></code> 4096</p>
+<blockquote>
+<div>The maximum number of ids that a JMAP client may request in
+a single &#8220;/get&#8221; type method call. The actual number
+of returned objects in the response may exceed this number
+if the JMAP object type supports unbounded &#8220;/get&#8221; calls.
+Returned as the maxObjectsInGet property value of the
+JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_max_objects_in_set:</span></code> 4096</p>
+<blockquote>
+<div>The maximum number of objects a JMAP client may send to create,
+update or destroy in a single /set type method call.
+Returned as the maxObjectsInSet property value of the
+JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:core">urn:ietf:params:jmap:core</a>&#8221; capabilities object.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_mail_max_size_attachments_per_email:</span></code> 10240</p>
+<blockquote>
+<div>The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+property of the JMAP &#8220;<a class="reference external" href="urn:ietf:params:jmap:mail">urn:ietf:params:jmap:mail</a>&#8221; capabilities object. The Cyrus
+JMAP implementation does not enforce this size limit. Default is 10 Mb.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_nonstandard_extensions:</span></code> 0</p>
+<blockquote>
+<div>If enabled, support non-standard JMAP extensions.  If not enabled,
+only IETF standard JMAP functionality is supported.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_set_has_attachment:</span></code> 1</p>
+<blockquote>
+<div>If enabled, the $hasAttachment flag is determined and set for new messages
+created with the JMAP Email/set or Email/import methods. This option should
+typically be enabled, but installations using Cyrus-external message
+annatotors to determine the $hasAttachment flag might want to disable it.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmap_vacation:</span></code> 1</p>
+<blockquote>
+<div>If enabled, support the JMAP vacation extension</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmapuploadfolder:</span></code> #jmap</p>
+<blockquote>
+<div>the name of the folder for JMAP uploads (#jmap)</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmapsubmission_deleteonsend:</span></code> 1</p>
+<blockquote>
+<div>If enabled (the default) then delete the EmailSubmission as soon as the email
+* has been sent</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmapsubmissionfolder:</span></code> #jmapsubmission</p>
+<blockquote>
+<div>the name of the folder for JMAP Submissions (#jmapsubmission)</div></blockquote>
+<p><code class="docutils literal"><span class="pre">jmappushsubscriptionfolder:</span></code> #jmappushsubscription</p>
+<blockquote>
+<div>the name of the folder for JMAP Push Subscriptions (#jmappushsubscription)</div></blockquote>
 <p><code class="docutils literal"><span class="pre">iolog:</span></code> 0</p>
 <blockquote>
 <div>Should cyrus output I/O log entries</div></blockquote>
@@ -1727,7 +1972,9 @@ used in the filter string:</p>
 %u   = user
 %U   = user portion of %u (%U = test when %u = <a class="reference external" href="mailto:test&#37;&#52;&#48;domain&#46;tld">test<span>&#64;</span>domain<span>&#46;</span>tld</a>)
 %d   = domain portion of %u if available (%d = domain.tld when %u =
-<a class="reference external" href="mailto:%test&#37;&#52;&#48;domain&#46;tld">%test<span>&#64;</span>domain<span>&#46;</span>tld</a>), otherwise same as %r
+<a class="reference external" href="mailto:test&#37;&#52;&#48;domain&#46;tld">test<span>&#64;</span>domain<span>&#46;</span>tld</a>), otherwise same as %R
+%R   = domain portion of %u starting with &#64; (%R = &#64;domain.tld
+when %u = <a class="reference external" href="mailto:test&#37;&#52;&#48;domain&#46;tld">test<span>&#64;</span>domain<span>&#46;</span>tld</a>)
 %D   = user dn.  (use when ldap_member_method: filter)
 %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)</p>
 <p>ldap_filter is not used when ldap_sasl is enabled.</p>
@@ -1823,12 +2070,18 @@ if they abort prematurely.</div></blockq
 <blockquote>
 <div>Use transport layer security for <a class="reference external" href="ldap://">ldap://</a> using STARTTLS. Do not use
 ldaps:// in &#8216;ldap_uri&#8217; with this option enabled.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">ldap_time_limit:</span></code> 5</p>
+<p><code class="docutils literal"><span class="pre">ldap_time_limit:</span></code> 5s</p>
 <blockquote>
-<div>Specify a number of seconds for a search request to complete.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">ldap_timeout:</span></code> 5</p>
+<div><p>How long to wait for a search request to complete.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">ldap_timeout:</span></code> 5s</p>
 <blockquote>
-<div>Specify a number of seconds a search can take before timing out.</div></blockquote>
+<div><p>How long a search can take before timing out.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">ldap_ca_dir:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Path to a directory with CA (Certificate Authority) certificates.</div></blockquote>
@@ -1879,11 +2132,19 @@ set to 3.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">literalminus:</span></code> 0</p>
 <blockquote>
 <div>if enabled, CAPABILITIES will reply with LITERAL- rather than
-LITERAL+ (<span class="target" id="index-8"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7888.html"><strong>RFC 7888</strong></a>).  Doesn&#8217;t actually size-restrict uploads though</div></blockquote>
+LITERAL+ (<span class="target" id="index-11"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7888.html"><strong>RFC 7888</strong></a>).  Doesn&#8217;t actually size-restrict uploads though</div></blockquote>
 <p><code class="docutils literal"><span class="pre">lmtp_downcase_rcpt:</span></code> 1</p>
 <blockquote>
 <div>If enabled, lmtpd will convert the recipient addresses to lowercase
 (up to a &#8216;+&#8217; character, if present).</div></blockquote>
+<p><code class="docutils literal"><span class="pre">lmtp_exclude_specialuse:</span></code> \Snoozed</p>
+<blockquote>
+<div><p>Don&#8217;t allow delivery to folders with given special-use attributes.</p>
+<p>Note that &#8220;snoozing&#8221; of emails can currently only be done via the
+JMAP protocol, so delivery directly to the Snoozed mailbox is
+prohibited by default as it will not be moved back into INBOX
+automatically.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">lmtp_fuzzy_mailbox_match:</span></code> 0</p>
 <blockquote>
 <div>If enabled, and the mailbox specified in the detail part of the
@@ -1902,7 +2163,7 @@ will cause the user&#8217;s mailbox to e
 failure won&#8217;t occur until the mailbox is already over quota.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">lmtp_strict_rfc2821:</span></code> 1</p>
 <blockquote>
-<div>By default, lmtpd will be strict (per <span class="target" id="index-9"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2821.html"><strong>RFC 2821</strong></a>) with regards to which
+<div>By default, lmtpd will be strict (per <span class="target" id="index-12"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2821.html"><strong>RFC 2821</strong></a>) with regards to which
 envelope addresses are allowed.  If this option is set to false, 8bit
 characters in the local-part of envelope addresses are changed to &#8216;X&#8217;
 instead.  This is useful to avoid generating backscatter with
@@ -1911,12 +2172,20 @@ certain MTAs like Postfix or Exim which
 <blockquote>
 <div>Unix domain socket that lmtpd listens on, used by deliver(8). This should
 match the path specified in cyrus.conf(5).</div></blockquote>
-<p><code class="docutils literal"><span class="pre">lmtptxn_timeout:</span></code> 300</p>
+<p><code class="docutils literal"><span class="pre">lmtptxn_timeout:</span></code> 5m</p>
 <blockquote>
-<div>Timeout (in seconds) used during a lmtp transaction to a remote backend
-(e.g. in a murder environment).  Can be used to prevent hung lmtpds
-on proxy hosts when a backend server becomes unresponsive during a
-lmtp transaction.  The default is 300 - change to zero for infinite.</div></blockquote>
+<div><p>Timeout used during a lmtp transaction to a remote backend (e.g. in a
+murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+when a backend server becomes unresponsive during a lmtp transaction.
+The default is 5 minutes - change to zero for infinite.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">lock_debugtime:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>A floating point number of seconds.  If set, time how long we wait for
+any lock, and syslog the filename and time if it&#8217;s longer than this
+value.  The default of NULL means not to time locks.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">loginrealms:</span></code> &lt;empty string&gt;</p>
 <blockquote>
 <div>The list of remote realms whose users may authenticate using cross-realm
@@ -1947,6 +2216,16 @@ no flags.  Example: $Label1 $Label2 $Lab
 <blockquote>
 <div>Notifyd(8) method to use for &#8220;MAIL&#8221; notifications.  If not set, &#8220;MAIL&#8221;
 notifications are disabled.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">master_bind_errors_fatal:</span></code> 0</p>
+<blockquote>
+<div><p>If enabled, failure to bind a port during startup is treated as a fatal
+error, causing master to shut down immediately.  The default is to keep
+running, with the affected service disabled until the next SIGHUP causes
+it to retry.</p>
+<p>Note that this only applies during startup.  New services that fail to
+come up in response to a reconfig+SIGHUP will just be logged and disabled
+like the default behaviour, without causing master to exit.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">maxheaderlines:</span></code> 1000</p>
 <blockquote>
 <div>Maximum number of lines of header that will be processed into cache
@@ -1976,12 +2255,12 @@ will allow messages of any size (the def
 <p><code class="docutils literal"><span class="pre">mboxkey_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for mailbox keys.</p>
-<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">mboxlist_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the mailbox list.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">mboxlist_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -2026,7 +2305,7 @@ Allowed values: <em>standard</em>, <em>u
 headers.  The 8-bit characters are changed to `X&#8217;.  If
 <strong>reject8bit</strong> is enabled, setting <strong>munge8bit</strong> has no effect.
 (A proper solution to non-ASCII characters in headers is offered by
-<span class="target" id="index-10"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2047.html"><strong>RFC 2047</strong></a> and its predecessors.)</div></blockquote>
+<span class="target" id="index-13"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2047.html"><strong>RFC 2047</strong></a> and its predecessors.)</div></blockquote>
 <p><code class="docutils literal"><span class="pre">mupdate_connections_max:</span></code> 128</p>
 <blockquote>
 <div>The max number of connections that a mupdate process will allow, this
@@ -2142,10 +2421,13 @@ IMAP mailbox names.</div></blockquote>
 <blockquote>
 <div>The absolute path to the newsrc db file.  If not specified,
 will be configdirectory/fetchnews.db</div></blockquote>
-<p><code class="docutils literal"><span class="pre">nntptimeout:</span></code> 3</p>
+<p><code class="docutils literal"><span class="pre">nntptimeout:</span></code> 3m</p>
 <blockquote>
-<div>Set the length of the NNTP server&#8217;s inactivity autologout timer,
-in minutes.  The minimum value is 3, the default.</div></blockquote>
+<div><p>Set the length of the NNTP server&#8217;s inactivity autologout timer.
+The minimum value is 3 minutes, also the default.</p>
+<p>For backward compatibility, if no unit is specified, minutes is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">notesmailbox:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The top level mailbox in each user&#8217;s account which is used to store
@@ -2190,9 +2472,6 @@ pathname MUST be specified.  If the <str
 used, then its pathname MUST be specified.  For example, if the
 value of the <strong>defaultpartion</strong> option is <strong>part1</strong>, then the
 <strong>partition-part1</strong> field is required.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">outbox_sendlater:</span></code> 0</p>
-<blockquote>
-<div>If enabled, any message with a Draft flag will be sent at the time of its INTERNALDATE</div></blockquote>
 <p><code class="docutils literal"><span class="pre">partition_select_mode:</span></code> freespace-most</p>
 <blockquote>
 <div><p>Partition selection mode.</p>
@@ -2229,29 +2508,39 @@ for which partitions usage data are cach
 automatically excluded from selection mode.</p>
 <p>If all partitions are over that limit, this feature is not used anymore.</p>
 </div></blockquote>
-<p><code class="docutils literal"><span class="pre">plaintextloginpause:</span></code> 0</p>
+<p><code class="docutils literal"><span class="pre">plaintextloginpause:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>Number of seconds to pause after a successful plaintext login.  For
-systems that support strong authentication, this permits users to
-perceive a cost of using plaintext passwords.  (This does not
-affect the use of PLAIN in SASL authentications.)</div></blockquote>
+<div><p>Time to pause after a successful plaintext login.  For systems that
+support strong authentication, this permits users to perceive a cost
+of using plaintext passwords.  (This does not affect the use of PLAIN
+in SASL authentications.)</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">plaintextloginalert:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Message to send to client after a successful plaintext login.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">popexpiretime:</span></code> -1</p>
 <blockquote>
-<div>The number of days advertised as being the minimum a message may be
+<div><p>The duration advertised as being the minimum a message may be
 left on the POP server before it is deleted (via the CAPA command,
 defined in the POP3 Extension Mechanism, which some clients may
-support).  &#8220;NEVER&#8221;, the default, may be specified with a negative
-number.  The Cyrus POP3 server never deletes mail, no matter what
-the value of this parameter is.  However, if a site implements a
-less liberal policy, it needs to change this parameter
-accordingly.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">popminpoll:</span></code> 0</p>
-<blockquote>
-<div>Set the minimum amount of time the server forces users to wait
-between successive POP logins, in minutes.</div></blockquote>
+support).  This duration has a granularity of whole days, with partial
+days truncated (so e.g. &#8220;45m&#8221; is effectively &#8220;0d&#8221;).  &#8220;NEVER&#8221;, the
+default, may be specified with a negative number.</p>
+<p>The Cyrus POP3 server never deletes mail, no matter what the value of
+this parameter is.  However, if a site implements a less liberal policy,
+it needs to change this parameter accordingly.</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">popminpoll:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>Set the minimum amount of time the server forces users to wait
+between successive POP logins.</p>
+<p>For backward compatibility, if no unit is specified, minutes is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">popsubfolders:</span></code> 0</p>
 <blockquote>
 <div>Allow access to subfolders of INBOX via POP3 by using
@@ -2271,10 +2560,13 @@ will not be able to check mail again unt
 user waits a sufficient amount of time, they will get back many or all
 of the slots.</p>
 </div></blockquote>
-<p><code class="docutils literal"><span class="pre">poptimeout:</span></code> 10</p>
+<p><code class="docutils literal"><span class="pre">poptimeout:</span></code> 10m</p>
 <blockquote>
-<div>Set the length of the POP server&#8217;s inactivity autologout timer,
-in minutes.  The minimum value is 10, the default.</div></blockquote>
+<div><p>Set the length of the POP server&#8217;s inactivity autologout timer.
+The minimum value is 10 minutes, the default.</p>
+<p>For backward compatibility, if no unit is specified, minutes is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">popuseacl:</span></code> 0</p>
 <blockquote>
 <div>Enforce IMAP ACLs in the pop server.  Due to the nature of the POP3
@@ -2305,6 +2597,27 @@ the &#8220;shared.blah&#8221; folder.  B
 <div>Path to proc directory.  Default is NULL - must be an absolute path
 if specified.  If not specified, the path $configdirectory/proc/ will be
 used.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">prometheus_enabled:</span></code> 0</p>
+<blockquote>
+<div>Whether tracking of service metrics for Prometheus is enabled.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">prometheus_need_auth:</span></code> admin</p>
+<blockquote>
+<div><p>Authentication level required to fetch Prometheus metrics.</p>
+<p>Allowed values: <em>none</em>, <em>user</em>, <em>admin</em></p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">prometheus_update_freq:</span></code> 10s</p>
+<blockquote>
+<div><p>Frequency in at which promstatsd should re-collate its statistics
+report.  The minimum value is 1 second, the default is 10 seconds.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">prometheus_stats_dir:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>Directory to use for gathering prometheus statistics.  If specified,
+must be an absolute path.  If not specified, the default path
+$configdirectory/stats/ will be used.  It may be advantageous to locate this
+directory on ephemeral storage.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">proxy_authname:</span></code> proxy</p>
 <blockquote>
 <div>The authentication name to use when authenticating to a backend server
@@ -2356,16 +2669,19 @@ DO NOT SET on frontends or things won&#8
 <p><code class="docutils literal"><span class="pre">ptscache_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the pts cache.</p>
-<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">ptscache_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The absolute path to the ptscache db file.  If not specified,
 will be configdirectory/ptscache.db</div></blockquote>
-<p><code class="docutils literal"><span class="pre">ptscache_timeout:</span></code> 10800</p>
+<p><code class="docutils literal"><span class="pre">ptscache_timeout:</span></code> 3h</p>
 <blockquote>
-<div>The timeout (in seconds) for the PTS cache database when using the
-auth_krb_pts authorization method (default: 3 hours).</div></blockquote>
+<div><p>The timeout for the PTS cache database when using the auth_krb_pts
+authorization method (default: 3 hours).</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">ptskrb5_convert524:</span></code> 1</p>
 <blockquote>
 <div>When using the AFSKRB ptloader module with Kerberos 5 canonicalization,
@@ -2384,7 +2700,7 @@ Allowed values: <em>cs0</em>, <em>cs1</e
 <p><code class="docutils literal"><span class="pre">quota_db:</span></code> quotalegacy</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for quotas.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>quotalegacy</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>quotalegacy</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">quota_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -2427,7 +2743,7 @@ authenticating to an IMAP/sync server.</
 will either add or remove reverse ACL pointers from mailboxes.db</div></blockquote>
 <p><code class="docutils literal"><span class="pre">rfc2046_strict:</span></code> 0</p>
 <blockquote>
-<div>If enabled, imapd will be strict (per <span class="target" id="index-11"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2046.html"><strong>RFC 2046</strong></a>) when matching MIME
+<div>If enabled, imapd will be strict (per <span class="target" id="index-14"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2046.html"><strong>RFC 2046</strong></a>) when matching MIME
 boundary strings.  This means that boundaries containing other
 boundaries as substrings will be treated as identical.  Since
 enabling this option will break some messages created by Eudora 5.1
@@ -2437,13 +2753,13 @@ there is good reason to do otherwise.</d
 <blockquote>
 <div>If enabled, imapd will parse any non-encoded character sequence in
 MIME header values as UTF8. This is useful for installations that
-either advertise the UTF8SMTP (<span class="target" id="index-12"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5335.html"><strong>RFC 5335</strong></a>) extension or receive mails
+either advertise the UTF8SMTP (<span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5335.html"><strong>RFC 5335</strong></a>) extension or receive mails
 with improperly escaped UTF-8 byte sequences. It is recommended that
 this option is left disabled unless there is good reason to do
 otherwise.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">rfc3028_strict:</span></code> 1</p>
 <blockquote>
-<div>If enabled, Sieve will be strict (per <span class="target" id="index-13"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3028.html"><strong>RFC 3028</strong></a>) with regards to
+<div>If enabled, Sieve will be strict (per <span class="target" id="index-16"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3028.html"><strong>RFC 3028</strong></a>) with regards to
 which headers are allowed to be used in address and envelope tests.
 This means that only those headers which are defined to contain addresses
 will be allowed in address tests and only &#8220;to&#8221; and &#8220;from&#8221; will be
@@ -2465,12 +2781,14 @@ URL on the server.</div></blockquote>
 treated as RSS feeds.  Only mailboxes matching the wildmat will
 have their messages available via RSS.  If not set, a default
 wildmat of &#8220;*&#8221; (ALL mailboxes) will be used.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">rss_maxage:</span></code> 0</p>
+<p><code class="docutils literal"><span class="pre">rss_maxage:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>Maximum age (in days) of items to display in an RSS channel.  If
-non-zero, httpd will only display items received within the last
-<em>rss_maxage</em> days.  If set to 0, all available items will be
-displayed (the default).</div></blockquote>
+<div><p>Maximum age of items to display in an RSS channel.  If non-zero,
+httpd will only display items received within this time period.
+If set to 0, all available items will be displayed (the default).</p>
+<p>For backward compatibility, if no unit is specified, days is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">rss_maxitems:</span></code> 0</p>
 <blockquote>
 <div>Maximum number of items to display in an RSS channel.  If non-zero,
@@ -2513,6 +2831,48 @@ Possible values include &#8220;auxprop&#
 <blockquote>
 <div>The number of messages to be indexed in one batch (default 20).
 Note that long batches may delay user commands or mail delivery.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">search_attachment_extractor_url:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>A HTTP or HTTPS URL to extract search text from rich text attachments
+and other media during search indexing. The server at this URL must
+implement the following protocol:</p>
+<p>1. For each attachment of an email, Cyrus sends a GET request to the
+URL &lt;extractor-url&gt;/&lt;cyrus-id&gt;, where &lt;extractor-url&gt; is the
+configured URL and &lt;cyrus-id&gt; is a Cyrus-chosen path segment that
+uniquely identifies this attachment.</p>
+<p>2. If the extractor already has a cached plain text extract of the
+attachment identified by &lt;cyrus-id&gt; then it may return HTTP status
+code 200 (OK) and the plain text extract with a Content-Type
+&#8220;text/plain&#8221; header. Otherwise it must return HTTP status 404 (Not Found).</p>
+<p>3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+a PUT request to the same URL as previously. The PUT request body
+contains the decoded, binary body of the attachment. The Content-Type
+request header has the same value as declared in the MIME part
+headers, including any type parameters.</p>
+<p>4. The extractor must return the plain text extract with either HTTP status
+200 (OK) or 201 (Created) and a Content-Type &#8220;text/plain&#8221; header.
+If no text can be extracted, then the extractor may return any return code
+in the range 4xx, or 200 and an empty response body.</p>
+<p>Any other HTTP status code is treated as an error. For performance
+reasons, the Cyrus indexer attempts to keep-alive the TCP connection
+to the extractor.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">search_index_language:</span></code> 0</p>
+<blockquote>
+<div>If enabled, then message bodies and subjects are indexed by their
+detected language, if the cld2 dependency is built into Cyrus.
+Regardless of this flag, bodies and subjects are always indexed and
+searched using the default stemmer.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">search_index_parts:</span></code> 0</p>
+<blockquote>
+<div>If enabled, then message parts are each indexed separately into Xapian
+so that matches can be done by part.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">search_query_language:</span></code> 0</p>
+<blockquote>
+<div>If enabled, then message bodies and subjects searched by their language
+that got detected during indexing, if any.
+Regardless of this flag, bodies and subjects are always searched using
+the default stemmer.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_normalisation_max:</span></code> 1000</p>
 <blockquote>
 <div>A resource bound for the combinatorial explosion of search expression
@@ -2522,11 +2882,11 @@ folders.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_engine:</span></code> none</p>
 <blockquote>
 <div><p>The indexing engine used to speed up searching.</p>
-<p>Allowed values: <em>none</em>, <em>squat</em>, <em>sphinx</em>, <em>xapian</em></p>
+<p>Allowed values: <em>none</em>, <em>squat</em>, <em>xapian</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_fuzzy_always:</span></code> 0</p>
 <blockquote>
-<div>Whether to enable <span class="target" id="index-14"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6203.html"><strong>RFC 6203</strong></a> FUZZY search for all IMAP SEARCH. If turned
+<div>Whether to enable <span class="target" id="index-17"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6203.html"><strong>RFC 6203</strong></a> FUZZY search for all IMAP SEARCH. If turned
 on, search attributes will be searched using FUZZY search by default.
 If turned off, clients have to explicitly use the FUZZY search key to
 enable fuzzy search for regular SEARCH commands.</div></blockquote>
@@ -2539,18 +2899,22 @@ the utility of searching.  Note that is
 headers can still be searched, the searches will just be slower.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_indexed_db:</span></code> twoskip</p>
 <blockquote>
-<div><p>The cyrusdb backend to use for the search latest indexed uid state.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<div><p>The cyrusdb backend to use for the search latest indexed uid state.  Xapian only.</p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_maxtime:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The maximum number of seconds to run a search for before aborting.  Default
 of no value means search &#8220;forever&#8221; until other timeouts.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">search_queryscan:</span></code> 5000</p>
+<blockquote>
+<div>The minimum number of records require to do a direct scan of all G keys
+* rather than indexed lookups.  A value of 0 means always do indexed lookups.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_skipdiacrit:</span></code> 1</p>
 <blockquote>
 <div>When searching, should diacriticals be stripped from the search
 terms.  The default is &#8220;true&#8221;, a search for &#8220;hav&#8221; will match
-&#8220;Håvard&#8221;.  This is not <span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5051.html"><strong>RFC 5051</strong></a> compliant, but it backwards
+&#8220;Håvard&#8221;.  This is not <span class="target" id="index-18"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5051.html"><strong>RFC 5051</strong></a> compliant, but it backwards
 compatible, and may be preferred by some sites.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">search_skiphtml:</span></code> 0</p>
 <blockquote>
@@ -2576,7 +2940,7 @@ generated snippet.</div></blockquote>
 <blockquote>
 <div>The absolute base path to the search stopword lists. If not specified,
 no stopwords will be taken into account during search indexing. Currently,
-the only supported and default stop word file is english.list.</div></blockquote>
+the only supported and default stop word file is english.txt.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">searchpartition-name:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div><p>The pathname where to store the xapian search indexes of <em>searchtier</em>
@@ -2592,12 +2956,18 @@ store this tier1&#8217;s search index fo
 <p><code class="docutils literal"><span class="pre">seenstate_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the seen state.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">sendmail:</span></code> /usr/lib/sendmail</p>
 <blockquote>
 <div>The pathname of the sendmail executable.  Sieve invokes sendmail
 for sending rejections, redirects and vacation responses.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">sendmail_auth_id:</span></code> CYRUS_SENDMAIL_AUTH_ID</p>
+<blockquote>
+<div>The name of an environment variable to set when invoking sendmail.
+The value of this environment variable will contain the user id
+of the currently authenticated user. If no user is authenticated
+the environment variable is not set.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">serverlist:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Whitespace separated list of backend server names.  Used for
@@ -2664,7 +3034,13 @@ namespace.  The hierarchy delimiter will
 <div>If enabled, timsieved will issue referrals to clients when the
 user&#8217;s scripts reside on a remote server (in a Murder).
 Otherwise, timsieved will proxy traffic to the remote server.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sieve_extensions:</span></code> fileinto reject vacation vacation-seconds imapflags notify envelope relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables</p>
+<p><code class="docutils literal"><span class="pre">sieve_duplicate_max_expiration:</span></code> 90d</p>
+<blockquote>
+<div><p>Maximum expiration time for duplicate message tracking records.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">sieve_extensions:</span></code> fileinto reject vacation vacation-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x-cyrus-jmapquery x-cyrus-snooze</p>
 <blockquote>
 <div>Space-separated list of Sieve extensions allowed to be used in
 sieve scripts, enforced at submission by timsieved(8).  Any
@@ -2672,7 +3048,7 @@ previously installed script will be unaf
 will continue to execute regardless of the extensions used.  This
 option has no effect on options that are disabled at compile time
 (e.g., &#8220;regex&#8221;).
-Allowed values: <em>fileinto</em>, <em>reject</em>, <em>vacation</em>, <em>vacation-seconds</em>, <em>imapflags</em>, <em>notify</em>, <em>include</em>, <em>envelope</em>, <em>body</em>, <em>relational</em>, <em>regex</em>, <em>subaddress</em>, <em>copy</em>, <em>date</em>, <em>index</em>, <em>imap4flags</em>, <em>mailbox</em>, <em>mboxmetadata</em>, <em>servermetadata</em>, <em>variables</em></div></blockquote>
+Allowed values: <em>fileinto</em>, <em>reject</em>, <em>vacation</em>, <em>vacation-seconds</em>, <em>imapflags</em>, <em>notify</em>, <em>include</em>, <em>envelope</em>, <em>environment</em>, <em>body</em>, <em>relational</em>, <em>regex</em>, <em>subaddress</em>, <em>copy</em>, <em>date</em>, <em>index</em>, <em>imap4flags</em>, <em>mailbox</em>, <em>mboxmetadata</em>, <em>servermetadata</em>, <em>variables</em>, <em>editheader</em>, <em>extlists</em>, <em>duplicate</em>, <em>ihave</em>, <em>fcc</em>, <em>special-use</em>, <em>redirect-dsn</em>, <em>redirect-deliverby</em>, <em>mailboxid</em>, <em>x-cyrus-log</em>, <em>x-cyrus-jmapquery</em>, <em>x-cyrus-snooze</em></div></blockquote>
 <p><code class="docutils literal"><span class="pre">sieve_maxscriptsize:</span></code> 32</p>
 <blockquote>
 <div>Maximum size (in kilobytes) any sieve script can be, enforced at
@@ -2690,14 +3066,25 @@ modified UTF7 encoding should be used.</
 <blockquote>
 <div>If enabled, timsieved will emit a capability response after a successful
 SASL authentication, per draft-martin-managesieve-12.txt .</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sieve_vacation_min_response:</span></code> 259200 /* 3 days */</p>
-<blockquote>
-<div>Minimum time interval (in seconds) between consecutive vacation responses,
-per draft-ietf-vacation-seconds.txt .</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sieve_vacation_max_response:</span></code> 7776000 /* 90 days */</p>
+<p><code class="docutils literal"><span class="pre">sieve_use_lmtp_reject:</span></code> 1</p>
 <blockquote>
-<div>Maximum time interval (in seconds) between consecutive vacation responses,
-per draft-ietf-vacation-seconds.txt .</div></blockquote>
+<div>Enabled by default.  If reject can be done via LMTP, then return a 550
+rather than generating the bounce message in Cyrus.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">sieve_vacation_min_response:</span></code> 3d</p>
+<blockquote>
+<div><p>Minimum time interval between consecutive vacation responses, per
+draft-ietf-vacation-seconds.txt.  The default is 3 days.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">sieve_vacation_max_response:</span></code> 90d</p>
+<blockquote>
+<div><p>Maximum time interval between consecutive vacation responses, per
+draft-ietf-vacation-seconds.txt.  The default is 90 days.  The
+minimum is 7 days.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">sievedir:</span></code> /usr/sieve</p>
 <blockquote>
 <div>If sieveusehomedir is false, this directory is searched for Sieve
@@ -2731,6 +3118,51 @@ and the entire file is already &#8220;ho
 <blockquote>
 <div>If enabled, this option forces the skiplist cyrusdb backend to
 not sync writes to the disk.  Enabling this option is NOT RECOMMENDED.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">smtp_backend:</span></code> sendmail</p>
+<blockquote>
+<div><p>The SMTP backend to use for sending email.</p>
+<p>The &#8220;host&#8221; backend sends message submissions via
+a TCP socket to the SMTP host defined in the config
+option smtp_host.</p>
+<p>The &#8220;sendmail&#8221; backend forks the Cyrus process into
+the executable defined in the config option sendmail.
+The executable must accept &#8220;-bs&#8221; as command line
+argument, read from stdin and must implement the minimum
+SMTP protocol as defined in section 4.5.1 of <span class="target" id="index-19"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5321.html"><strong>RFC 5321</strong></a>.</p>
+<p>If the SMTP EHLO command reports AUTH (<span class="target" id="index-20"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4954.html"><strong>RFC 4954</strong></a>) as a
+supported extension, then the MAIL FROM command includes
+the AUTH parameter, with its value set to the name of any
+authenticated user which triggered the email. The AUTH
+parameter is omitted if the user is unknown to the calling
+process.</p>
+<p>If the directory
+<em>configdirectory</em>/log/smtpclient.<em>smtp_backend</em>
+exists, then telemetry logs for outgoing SMTP sessions will
+be created in this directory.</p>
+<p>Allowed values: <em>host</em>, <em>sendmail</em></p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">smtp_host:</span></code> localhost:587</p>
+<blockquote>
+<div>The SMTP host to use for sending mail (also see the
+smtp_backend option). The value of this option must
+the name or IP address of a TCP host, followed optionally
+by a colon and the port or service to use. The default
+port is 587. TLS may be activated by appending &#8220;/tls&#8221;
+to the value. Authentication is enabled if smtp_auth_authname
+is set. Authentication can be explicitly disabled by appending
+&#8220;/noauth&#8221; to the host address.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">smtp_auth_authname:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The authentication name to use when authenticating to the SMTP
+server defined in smtp_host.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">smtp_auth_password:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The password to use when authenticating to the SMTP server defined
+in smtp_host.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">smtp_auth_realm:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The authentication SASL realm to use when authenticating to a SMTP
+server.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">soft_noauth:</span></code> 1</p>
 <blockquote>
 <div>If enabled, lmtpd returns temporary failures if the client does not
@@ -2740,31 +3172,24 @@ successfully authenticate.  Otherwise lm
 <blockquote>
 <div>The cyrusdb backend to use for caching sort results (currently only
 used for xconvmultisort)
-Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></div></blockquote>
+Allowed values: <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></div></blockquote>
 <p><code class="docutils literal"><span class="pre">specialuse_extra:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Whitespace separated list of extra special-use attributes
-that can be set on a mailbox. <span class="target" id="index-16"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6154.html"><strong>RFC 6154</strong></a> currently lists
+that can be set on a mailbox. <span class="target" id="index-21"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6154.html"><strong>RFC 6154</strong></a> currently lists
 what special-use attributes can be set. This allows
 extending that list in the future or adding your own
 if needed.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">specialusealways:</span></code> 0</p>
+<p><code class="docutils literal"><span class="pre">specialuse_protect:</span></code> \Archive \Drafts \Important \Junk \Sent \Trash</p>
+<blockquote>
+<div>Whitespace separated list of special-use attributes
+to protect the mailboxes for.  If set, don&#8217;t allow
+mailboxes with these special use attributes to be deleted
+or renamed to have a different parent. Default is the built-in list</div></blockquote>
+<p><code class="docutils literal"><span class="pre">specialusealways:</span></code> 1</p>
 <blockquote>
 <div>If enabled, this option causes LIST and LSUB output to always include
 the XLIST &#8220;special-use&#8221; flags</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sphinx_text_excludes_odd_headers:</span></code> 0</p>
-<blockquote>
-<div>If enabled, Sphinx will perform a TEXT search as if it matches
-FROM, TO, CC, BCC or SUBJECT but not any other headers.  This
-is contrary to the RFC but a more useful behaviour for most
-users.  Default: disabled.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sphinx_socket:</span></code> {configdirectory}/socket/sphinx</p>
-<blockquote>
-<div>Unix domain socket that the Sphinx searchd
-daemons listens on.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sphinx_pidfile:</span></code> /var/run/sphinx.pid</p>
-<blockquote>
-<div>File where the Sphinx searchd daemon writes its pid.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">sql_database:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Name of the database which contains the cyrusdb table(s).</div></blockquote>
@@ -2785,6 +3210,23 @@ daemons listens on.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">sql_usessl:</span></code> 0</p>
 <blockquote>
 <div>If enabled, a secure connection will be made to the SQL server.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">srs_alwaysrewrite:</span></code> 0</p>
+<blockquote>
+<div>If true, perform SRS rewriting for ALL forwarding, even when not required.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">srs_domain:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The domain to use in rewritten addresses. This must point only to machines
+which know the encoding secret used by this system. When present, SRS is
+enabled.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">srs_hashlength:</span></code> 0</p>
+<blockquote>
+<div>The hash length to generate in a rewritten address.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">srs_secrets:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>A list of secrets with which to generate addresses.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">srs_separator:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The separator to appear immediately after SRS[01] in rewritten addresses.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">srvtab:</span></code> &lt;empty string&gt;</p>
 <blockquote>
 <div>The pathname of <em>srvtab</em> file containing the server&#8217;s private
@@ -2799,7 +3241,7 @@ use with caution.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">subscription_db:</span></code> flat</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the subscriptions list.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">suppress_capabilities:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -2814,7 +3256,7 @@ confused by new capabilities that some b
 <p><code class="docutils literal"><span class="pre">statuscache_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the imap status cache.</p>
-<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">statuscache_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -2874,21 +3316,28 @@ will default to &#8220;csync&#8221; (usu
 <blockquote>
 <div>The authentication realm to use when authenticating to a sync server.
 Prefix with a channel name to only apply for that channel</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sync_repeat_interval:</span></code> 1</p>
+<p><code class="docutils literal"><span class="pre">sync_repeat_interval:</span></code> 1s</p>
 <blockquote>
-<div>Minimum interval (in seconds) between replication runs in rolling
-replication mode. If a replication run takes longer than this
-time, we repeat immediately.
-Prefix with a channel name to only apply for that channel</div></blockquote>
+<div><p>Minimum interval between replication runs in rolling replication
+mode. If a replication run takes longer than this time, we repeat
+immediately.  Prefix with a channel name to only apply for that
+channel.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">sync_shutdown_file:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Simple latch used to tell sync_client(8) that it should shut down at the
 next opportunity. Safer than sending signals to running processes.
 Prefix with a channel name to only apply for that channel</div></blockquote>
-<p><code class="docutils literal"><span class="pre">sync_timeout:</span></code> 1800</p>
+<p><code class="docutils literal"><span class="pre">sync_timeout:</span></code> 30m</p>
 <blockquote>
-<div>Number of seconds to wait for a response before returning a timeout
-failure when talking to a replication peer (client or server).</div></blockquote>
+<div><p>How long to wait for a response before returning a timeout failure
+when talking to a replication peer (client or server).  The minimum
+duration is 3 seconds, the default is 30 minutes.</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">sync_try_imap:</span></code> 1</p>
 <blockquote>
 <div>Whether sync_client should try to perform an IMAP connection
@@ -2897,7 +3346,14 @@ sync_client will only use csync.  Prefix
 apply only for that channel</div></blockquote>
 <p><code class="docutils literal"><span class="pre">syslog_prefix:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>String to be prepended to the process name in syslog entries.</div></blockquote>
+<div><p>String to be prepended to the process name in syslog entries. Can
+be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+variable.</p>
+<p>Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+advantage that it can be set before the <strong>imapd.conf</strong> is read, so
+errors while reading the config file can be syslogged with the correct
+prefix.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">syslog_facility:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Configure a syslog facility.  The default is whatever is compiled
@@ -2912,28 +3368,39 @@ through to LOCAL7</div></blockquote>
 connection dead (0 == system default)</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tcp_keepalive_idle:</span></code> 0</p>
 <blockquote>
-<div>Number of seconds a connection must be idle before keepalive
-probes are sent (0 == system default)</div></blockquote>
+<div><p>How long a connection must be idle before keepalive probes are sent
+(0 == system default).</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tcp_keepalive_intvl:</span></code> 0</p>
 <blockquote>
-<div>Number of seconds between keepalive probes (0 == system default)</div></blockquote>
+<div><p>Time between keepalive probes (0 == system default).</p>
+<p>For backward compatibility, if no unit is specified, seconds is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">temp_path:</span></code> /tmp</p>
 <blockquote>
 <div>The pathname to store temporary files in</div></blockquote>
 <p><code class="docutils literal"><span class="pre">telemetry_bysessionid:</span></code> 0</p>
 <blockquote>
 <div>If true, log by sessionid instead of PID for telemetry</div></blockquote>
-<p><code class="docutils literal"><span class="pre">timeout:</span></code> 32</p>
+<p><code class="docutils literal"><span class="pre">timeout:</span></code> 32m</p>
 <blockquote>
-<div>The length of the IMAP server&#8217;s inactivity autologout timer,
-in minutes.  The minimum value is 30.  The default is 32 to
-allow a bit of leeway for clients that try to NOOP every 30
-minutes.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">imapidletimeout:</span></code> 0</p>
-<blockquote>
-<div>Timeout for idling clients (<span class="target" id="index-17"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2177.html"><strong>RFC 2177</strong></a>) in minutes. If set to
-zero (the default) or less, the value of &#8220;timeout&#8221; will be
-used instead.</div></blockquote>
+<div><p>The length of the IMAP server&#8217;s inactivity autologout timer.
+The minimum value is 30 minutes.  The default is 32 minutes,
+to allow a bit of leeway for clients that try to NOOP every
+30 minutes.</p>
+<p>For backward compatibility, if no unit is specified, minutes
+is assumed.</p>
+</div></blockquote>
+<p><code class="docutils literal"><span class="pre">imapidletimeout:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>Timeout for idling clients (<span class="target" id="index-22"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2177.html"><strong>RFC 2177</strong></a>).  If not set (the default),
+the value of &#8220;timeout&#8221; will be used instead.</p>
+<p>For backward compatibility, if no unit is specified, minutes
+is assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_ca_file:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Deprecated in favor of <em>tls_client_ca_file</em>.</div></blockquote>
@@ -2959,6 +3426,9 @@ used instead.</div></blockquote>
 <p>See also Mozilla&#8217;s server-side TLS recommendations:</p>
 <p><a class="reference external" href="https://wiki.mozilla.org/Security/Server_Side_TLS">https://wiki.mozilla.org/Security/Server_Side_TLS</a></p>
 </div></blockquote>
+<p><code class="docutils literal"><span class="pre">tls_crl_file:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>Path to a file containing the Certificate Revocation List</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_client_ca_dir:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>Path to a directory containing the CA certificates used to verify
@@ -3008,25 +3478,36 @@ openssl(1)).</div></blockquote>
 offered by the server, when cyrus acts as client.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_server_cert:</span></code> &lt;none&gt;</p>
 <blockquote>
-<div>File containing the certificate, including the full chain, presented to clients.</div></blockquote>
+<div>File containing the certificate, including the full chain, presented to clients.
+Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+comma without spaces.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">tls_server_dhparam:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>File containing the DH parameters belonging to the certificate in
+tls_server_cert.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_server_key:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>File containing the private key belonging to the certificate in
-tls_server_cert.</div></blockquote>
+tls_server_cert.  If not set, tls_server_cert must contain both private and
+public key.  Two files with keys can be set, if two certifates are used, in
+which case the files must be separated with comma without spaces</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_sessions_db:</span></code> twoskip</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the TLS cache.</p>
-<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_sessions_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The absolute path to the TLS sessions db file. If not specified,
 will be configdirectory/tls_sessions.db</div></blockquote>
-<p><code class="docutils literal"><span class="pre">tls_session_timeout:</span></code> 1440</p>
+<p><code class="docutils literal"><span class="pre">tls_session_timeout:</span></code> 24h</p>
 <blockquote>
-<div>The length of time (in minutes) that a TLS session will be cached
-for later reuse.  The maximum value is 1440 (24 hours), the
-default.  A value of 0 will disable session caching.</div></blockquote>
+<div><p>The length of time that a TLS session will be cached for later
+reuse.  The maximum value is 24 hours, also the default.  A
+value of 0 will disable session caching.</p>
+<p>For backward compatibility, if no unit is specified, minutes is
+assumed.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">tls_versions:</span></code> tls1_0 tls1_1 tls1_2 tls1_3</p>
 <blockquote>
 <div>A list of SSL/TLS versions to not disable. Cyrus IMAP SSL/TLS starts
@@ -3046,7 +3527,7 @@ Allowed values: <em>uidonly</em>, <em>cy
 <p><code class="docutils literal"><span class="pre">userdeny_db:</span></code> flat</p>
 <blockquote>
 <div><p>The cyrusdb backend to use for the user access list.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>lmdb</em></p>
+<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>sql</em>, <em>twoskip</em>, <em>zeroskip</em></p>
 </div></blockquote>
 <p><code class="docutils literal"><span class="pre">userdeny_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
@@ -3095,6 +3576,16 @@ of the incoming network interface, or if
 </dd>
 </dl>
 </div></blockquote>
+<p><code class="docutils literal"><span class="pre">virusscan_notification_subject:</span></code> Automatically deleted mail</p>
+<blockquote>
+<div>The text used in the subject of email notifications created by
+<strong>cyr_virusscan(8)</strong> when deleting infected mail.</div></blockquote>
+<p><code class="docutils literal"><span class="pre">virusscan_notification_template:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div>The absolute path to a file containing a template to use to describe
+infected messages that have been deleted by <strong>cyr_virusscan(8)</strong>.
+See <strong>cyr_virusscan(8)</strong> for specification of the format of this file.
+If not specified, the builtin default template will be used.</div></blockquote>
 <p><code class="docutils literal"><span class="pre">xbackup_enabled:</span></code> 0</p>
 <blockquote>
 <div>Enable support for the XBACKUP command in imapd.  If enabled, admin
@@ -3116,13 +3607,22 @@ this user.  NOTE: This must be an existi
 INBOX, NOT an email address!</div></blockquote>
 <p><code class="docutils literal"><span class="pre">zoneinfo_db:</span></code> twoskip</p>
 <blockquote>
-<div><p>The cyrusdb backend to use for zoneinfo.</p>
-<p>Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>lmdb</em></p>
-</div></blockquote>
+<div>The cyrusdb backend to use for zoneinfo.  This database is used by the
+&#8220;tzdist&#8221; <em>http_modules</em>, and is managed by <strong>ctl_zoneinfo(8)</strong>.
+Allowed values: <em>flat</em>, <em>skiplist</em>, <em>twoskip</em>, <em>zeroskip</em></div></blockquote>
 <p><code class="docutils literal"><span class="pre">zoneinfo_db_path:</span></code> &lt;none&gt;</p>
 <blockquote>
 <div>The absolute path to the zoneinfo db file.  If not specified,
 will be configdirectory/zoneinfo.db</div></blockquote>
+<p><code class="docutils literal"><span class="pre">zoneinfo_dir:</span></code> &lt;none&gt;</p>
+<blockquote>
+<div><p>The absolute path to the zoneinfo directory, containing timezone
+definitions as generated by the vzic tool.  If not specified, whatever
+definitions libical finds will be used.</p>
+<p>If you are providing a Time Zone Data Distribution Service (i.e. you have
+&#8220;tzdist&#8221; listed in <em>http_modules</em>), then this configuration option MUST
+be specified.</p>
+</div></blockquote>
 <p><code class="docutils literal"><span class="pre">object_storage_enabled:</span></code> 0</p>
 <blockquote>
 <div>Is Object storage enabled for this server.  You also need to have
@@ -3144,10 +3644,10 @@ by the OpenIO&#8217;s SDK to locate its
 <div>The OpenIO account used to account for stored emails. Accounts are unique
 in their namespace. They provides virtual partitions, with quotas and QoS
 features.</div></blockquote>
-<p><code class="docutils literal"><span class="pre">openio_rawx_timeout:</span></code> 30</p>
+<p><code class="docutils literal"><span class="pre">openio_rawx_timeout:</span></code> 30s</p>
 <blockquote>
 <div>The OpenIO timeout to query to the RAWX services (default 30 sec).</div></blockquote>
-<p><code class="docutils literal"><span class="pre">openio_proxy_timeout:</span></code> 5</p>
+<p><code class="docutils literal"><span class="pre">openio_proxy_timeout:</span></code> 5s</p>
 <blockquote>
 <div>The OpenIO timeout to query to the PROXY services (default 5 sec).</div></blockquote>
 <p><code class="docutils literal"><span class="pre">openio_autocreate:</span></code> 0</p>
@@ -3206,7 +3706,7 @@ on HTTP 1.1 using a RESTful architecture
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team.
+        &copy; Copyright 1993-2018, The Cyrus Team.
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -3226,7 +3726,7 @@ on HTTP 1.1 using a RESTful architecture
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/configs/krb.equiv.html 3.2.0-3/doc/html/imap/reference/manpages/configs/krb.equiv.html
--- 3.0.13-5/doc/html/imap/reference/manpages/configs/krb.equiv.html	2019-12-16 04:17:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/configs/krb.equiv.html	2020-05-04 04:13:08.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>krb.equiv &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>krb.equiv &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="arbitron" href="../systemcommands/arbitron.html"/>
         <link rel="prev" title="imapd.conf" href="imapd.conf.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3 current"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul class="current">
 <li class="toctree-l4"><a class="reference internal" href="cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4 current"><a class="current reference internal" href="#"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/configs/krb.equiv.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/configs/krb.equiv.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -822,7 +841,7 @@ the second is the name of the correspond
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -842,7 +861,7 @@ the second is the name of the correspond
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/arbitron.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/arbitron.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/arbitron.html	2019-12-16 04:17:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/arbitron.html	2020-05-04 04:13:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>arbitron &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>arbitron &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="backupd" href="backupd.html"/>
         <link rel="prev" title="krb.equiv" href="../configs/krb.equiv.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/arbitron.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/arbitron.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -963,7 +982,7 @@ the past <em>months</em> months. The def
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -983,7 +1002,7 @@ the past <em>months</em> months. The def
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/backupd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/backupd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/backupd.html	2019-12-16 04:17:51.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/backupd.html	2020-05-04 04:13:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>backupd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>backupd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="chk_cyrus" href="chk_cyrus.html"/>
         <link rel="prev" title="arbitron" href="arbitron.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/backupd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/backupd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -874,7 +893,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -894,7 +913,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/chk_cyrus.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/chk_cyrus.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/chk_cyrus.html	2019-12-16 04:17:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/chk_cyrus.html	2020-05-04 04:13:09.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>chk_cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>chk_cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_backups" href="ctl_backups.html"/>
         <link rel="prev" title="backupd" href="backupd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/chk_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/chk_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -854,7 +873,7 @@ configuration file.</div></blockquote>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -874,7 +893,7 @@ configuration file.</div></blockquote>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_backups.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_backups.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_backups.html	2019-12-16 04:17:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_backups.html	2020-05-04 04:13:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_backups &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_backups &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_conversationsdb" href="ctl_conversationsdb.html"/>
         <link rel="prev" title="chk_cyrus" href="chk_cyrus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -903,6 +922,12 @@ whose most recent backup chunk is very l
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-ctl_backups-j">
+<code class="descname">-j</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-ctl_backups-j" title="Permalink to this definition">¶</a></dt>
+<dd><p>Produce output in JSON format.  The default is plain text.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-ctl_backups-v">
 <code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-ctl_backups-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Increase the verbosity.  Can be specified multiple times.</p>
@@ -1059,7 +1084,7 @@ EVENTS {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 30 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1079,7 +1104,7 @@ EVENTS {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_conversationsdb.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_conversationsdb.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_conversationsdb.html	2019-12-16 04:17:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_conversationsdb.html	2020-05-04 04:13:10.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_conversationsdb &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_conversationsdb &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_cyrusdb" href="ctl_cyrusdb.html"/>
         <link rel="prev" title="ctl_backups" href="ctl_backups.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -868,6 +887,14 @@ subset of <strong>-b</strong>; in partic
 assign messages to conversations.</p>
 </dd></dl>
 
+<dl class="option">
+<dt id="cmdoption-ctl_conversationsdb-S">
+<code class="descname">-S</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-ctl_conversationsdb-S" title="Permalink to this definition">¶</a></dt>
+<dd><p>If given with <strong>-b</strong>, allows splitting of conversations during the
+rewrite.   Only do this is changing the maximum conversation size
+and you need to split those existing conversations.</p>
+</dd></dl>
+
 </div>
 <div class="section" id="examples">
 <h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
@@ -905,7 +932,7 @@ assign messages to conversations.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 15 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -925,7 +952,7 @@ assign messages to conversations.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_cyrusdb.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_cyrusdb.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_cyrusdb.html	2019-12-16 04:17:52.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_cyrusdb.html	2020-05-04 04:13:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_cyrusdb &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_cyrusdb &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_deliver" href="ctl_deliver.html"/>
         <link rel="prev" title="ctl_conversationsdb" href="ctl_conversationsdb.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -800,6 +819,11 @@ the associated mailbox files).</p>
 <p>All mailbox files are also checked to make sure the file format
 matches the configured database type in imapd.conf.  If not, the
 file is automatically converted using the same logic as cvt_cyrusdb.</p>
+<p>If the <code class="docutils literal"><span class="pre">reverseacls</span></code> option in <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> is enabled,
+and the RACL entries do not exist in the database, they will be
+generated.  Conversely, if RACL entries do exist in the database,
+but the <code class="docutils literal"><span class="pre">reverseacls</span></code> option is disabled, then the entries will be
+cleaned up.</p>
 </dd></dl>
 
 <dl class="option">
@@ -881,7 +905,7 @@ the <strong>START</strong> section of <a
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 17 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -901,7 +925,7 @@ the <strong>START</strong> section of <a
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_deliver.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_deliver.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_deliver.html	2019-12-16 04:17:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_deliver.html	2020-05-04 04:13:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_deliver &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_deliver &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_mboxlist" href="ctl_mboxlist.html"/>
         <link rel="prev" title="ctl_cyrusdb" href="ctl_cyrusdb.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_deliver.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_deliver.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -855,7 +874,7 @@ flat-text format.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -875,7 +894,7 @@ flat-text format.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_mboxlist.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_mboxlist.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_mboxlist.html	2019-12-16 04:17:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_mboxlist.html	2020-05-04 04:13:11.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_mboxlist &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_mboxlist &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ctl_zoneinfo" href="ctl_zoneinfo.html"/>
         <link rel="prev" title="ctl_deliver" href="ctl_deliver.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -772,7 +791,7 @@
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>ctl_mboxlist</strong> [ <strong>-C</strong> <em>config-file</em> ] <strong>-d</strong> [ <strong>-x</strong> ] [ <strong>-p</strong> <em>partition</em> ] [ <strong>-f</strong> <em>filename</em> ]
+<strong>ctl_mboxlist</strong> [ <strong>-C</strong> <em>config-file</em> ] <strong>-d</strong> [ <strong>-x</strong> ] [<strong>-y</strong>] [ <strong>-p</strong> <em>partition</em> ] [ <strong>-f</strong> <em>filename</em> ]
 <strong>ctl_mboxlist</strong> [ <strong>-C</strong> <em>config-file</em> ] <strong>-u</strong> [ <strong>-f</strong> <em>filename</em> ]
 <strong>ctl_mboxlist</strong> [ <strong>-C</strong> <em>config-file</em> ] <strong>-m</strong> [ <strong>-a</strong> ] [ <strong>-w</strong> ] [ <strong>-i</strong> ] [ <strong>-f</strong> <em>filename</em> ]
 <strong>ctl_mboxlist</strong> [ <strong>-C</strong> <em>config-file</em> ] <strong>-v</strong> [ <strong>-f</strong> <em>filename</em> ]
@@ -811,9 +830,16 @@ list (mostly useful when specified with
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-ctl_mboxlist-y">
+<code class="descname">-y</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-ctl_mboxlist-y" title="Permalink to this definition">¶</a></dt>
+<dd><p>When performing a dump, also list intermediary mailboxes which would
+be hidden from IMAP.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-ctl_mboxlist-p">
 <code class="descname">-p</code><code class="descclassname"> partition</code><a class="headerlink" href="#cmdoption-ctl_mboxlist-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>When performing a dump, dump only thise mailboxes that live on
+<dd><p>When performing a dump, dump only those mailboxes that live on
 <em>partition</em>.</p>
 </dd></dl>
 
@@ -846,7 +872,7 @@ mailbox list file with the MUPDATE serve
 <dl class="option">
 <dt id="cmdoption-ctl_mboxlist-a">
 <code class="descname">-a</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-ctl_mboxlist-a" title="Permalink to this definition">¶</a></dt>
-<dd><p>When used with <strong>-m</strong>, assume the local mailboxes file is authoritiative,
+<dd><p>When used with <strong>-m</strong>, assume the local mailboxes file is authoritative,
 that is, only change the mupdate server, do not delete any local
 mailboxes.</p>
 </dd></dl>
@@ -979,7 +1005,7 @@ asking for verification before deleting
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 17 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -999,7 +1025,7 @@ asking for verification before deleting
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_zoneinfo.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_zoneinfo.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ctl_zoneinfo.html	2019-12-16 04:17:53.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ctl_zoneinfo.html	2020-05-04 04:13:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ctl_zoneinfo &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ctl_zoneinfo &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cvt_cyrusdb" href="cvt_cyrusdb.html"/>
         <link rel="prev" title="ctl_mboxlist" href="ctl_mboxlist.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ctl_zoneinfo.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ctl_zoneinfo.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -845,7 +864,7 @@ by the <em>timezone</em> module of <em c
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -865,7 +884,7 @@ by the <em>timezone</em> module of <em c
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cvt_cyrusdb.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cvt_cyrusdb.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cvt_cyrusdb.html	2019-12-16 04:17:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cvt_cyrusdb.html	2020-05-04 04:13:12.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cvt_cyrusdb &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cvt_cyrusdb &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cvt_xlist_specialuse" href="cvt_xlist_specialuse.html"/>
         <link rel="prev" title="ctl_zoneinfo" href="ctl_zoneinfo.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -805,7 +824,7 @@ file, and must be supplied on the comman
 <blockquote>
 <div>Display list of available backends.</div></blockquote>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">Usage</span><span class="p">:</span> <span class="o">/</span><span class="n">usr</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">cvt_cyrusdb</span> <span class="p">[</span><span class="o">-</span><span class="n">C</span> <span class="n">altconfig</span><span class="p">]</span> <span class="o">&lt;</span><span class="n">old</span> <span class="n">db</span><span class="o">&gt;</span> <span class="o">&lt;</span><span class="n">old</span> <span class="n">db</span> <span class="n">backend</span><span class="o">&gt;</span> <span class="o">&lt;</span><span class="n">new</span> <span class="n">db</span><span class="o">&gt;</span> <span class="o">&lt;</span><span class="n">new</span> <span class="n">db</span> <span class="n">backend</span><span class="o">&gt;</span>
-<span class="n">Usable</span> <span class="n">Backends</span><span class="p">:</span>  <span class="n">berkeley</span><span class="p">,</span> <span class="n">berkeley</span><span class="o">-</span><span class="n">nosync</span><span class="p">,</span> <span class="n">berkeley</span><span class="o">-</span><span class="nb">hash</span><span class="p">,</span> <span class="n">berkeley</span><span class="o">-</span><span class="nb">hash</span><span class="o">-</span><span class="n">nosync</span><span class="p">,</span> <span class="n">flat</span><span class="p">,</span> <span class="n">skiplist</span><span class="p">,</span> <span class="n">quotalegacy</span>
+<span class="n">Usable</span> <span class="n">Backends</span><span class="p">:</span>  <span class="n">flat</span><span class="p">,</span> <span class="n">skiplist</span><span class="p">,</span> <span class="n">quotalegacy</span>
 </pre></div>
 </div>
 <pre class="literal-block">
@@ -846,7 +865,7 @@ file, and must be supplied on the comman
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -866,7 +885,7 @@ file, and must be supplied on the comman
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html	2019-12-16 04:17:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html	2020-05-04 04:13:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cvt_xlist_specialuse &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cvt_xlist_specialuse &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_backup" href="cyr_backup.html"/>
         <link rel="prev" title="cvt_cyrusdb" href="cvt_cyrusdb.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -844,7 +863,7 @@ settings had been in use.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 13 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 13 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -864,7 +883,7 @@ settings had been in use.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyradm.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyradm.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyradm.html	2019-12-16 04:17:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyradm.html	2020-05-04 04:13:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyradm &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyradm &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyrdump" href="cyrdump.html"/>
         <link rel="prev" title="cyr_virusscan" href="cyr_virusscan.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -878,8 +897,8 @@ corresponding user.</p>
 </div>
 <p>Note that in the above example, the <code class="docutils literal"><span class="pre">unixhierarchysep</span></code> setting in
 imapd.conf is set to <code class="docutils literal"><span class="pre">0</span></code>. When using the UNIX
-hierarchy seperator, the <code class="docutils literal"><span class="pre">/</span></code> (forward slash) character would be
-used as the hierarchy seperator, and the example would look as
+hierarchy separator, the <code class="docutils literal"><span class="pre">/</span></code> (forward slash) character would be
+used as the hierarchy separator, and the example would look as
 follows:</p>
 </div></blockquote>
 <p>Example Usage with <code class="docutils literal"><span class="pre">unixhierarchysep:</span> <span class="pre">1</span></code></p>
@@ -939,10 +958,16 @@ last command will be used if one is not
 <p>Show help for <code class="docutils literal"><span class="pre">command</span></code> or all commands.</p>
 <p>aliases: <code class="docutils literal"><span class="pre">?</span></code></p>
 </div>
+<div class="section" id="getmetadata">
+<span id="imap-reference-manpages-systemcommands-cyradm-getmetadata"></span><h3>getmetadata<a class="headerlink" href="#getmetadata" title="Permalink to this headline">¶</a></h3>
+<p><strong>getmetadata</strong> [<em>mailbox</em>]</p>
+<p>Display mailbox/server metadata</p>
+<p>aliases: <code class="docutils literal"><span class="pre">getmd</span></code></p>
+</div>
 <div class="section" id="info">
 <span id="imap-reference-manpages-systemcommands-cyradm-info"></span><h3>info<a class="headerlink" href="#info" title="Permalink to this headline">¶</a></h3>
 <p><strong>info</strong> [<em>mailbox</em>]</p>
-<p>Display the mailbox/server metadata.</p>
+<p>Display the mailbox/server annotations.</p>
 </div>
 <div class="section" id="listaclmailbox">
 <span id="imap-reference-manpages-systemcommands-cyradm-listaclmailbox"></span><h3>listaclmailbox<a class="headerlink" href="#listaclmailbox" title="Permalink to this headline">¶</a></h3>
@@ -1111,6 +1136,28 @@ server (unless overridden by a mailbox a
 <div>Indicates that all mailboxes should have a squat indexes created for
 them (unless overridden by a mailbox annotation).</div></blockquote>
 </div>
+<div class="section" id="setmetadata">
+<span id="imap-reference-manpages-systemcommands-cyradm-setmetadata"></span><h3>setmetadata<a class="headerlink" href="#setmetadata" title="Permalink to this headline">¶</a></h3>
+<p><strong>setmetadata</strong> [&#8211;private] mailbox [<em>annotation</em>] <em>value</em></p>
+<p>Set metadata on mailbox, where <em>annotation</em> is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/&lt;explicit annotation&gt;].</p>
+<p>Note that <em>value</em> with a leading backslash must be escaped with an
+additional backslash.  For example:</p>
+<div class="highlight-perl"><div class="highlight"><pre><span></span><span class="n">setmetadata</span> <span class="o">--</span><span class="n">private</span> <span class="n">Spam</span> <span class="n">specialuse</span> <span class="s">&quot;\\Junk&quot;</span>
+</pre></div>
+</div>
+<p>Note, too, that &#8220;private&#8221; annotations are private to the user currently
+authenticated as, not necessarily the owner of the mailbox.  To set
+annotations for another user you must authorize as that user.</p>
+<p>In addition to the use of optional flag <strong>&#8211;private</strong>, one may use a more
+explicit syntax, prefixing the annotation with &#8216;/shared/&#8217; or &#8216;/private/&#8217;
+as in this example:</p>
+<div class="highlight-perl"><div class="highlight"><pre><span></span><span class="n">setmetadata</span> <span class="n">Spam</span> <span class="sr">/private/s</span><span class="n">pecialuse</span> <span class="s">&quot;\\Junk&quot;</span>
+</pre></div>
+</div>
+<p>aliases: <code class="docutils literal"><span class="pre">setmd</span></code></p>
+</div>
 <div class="section" id="setquota">
 <span id="imap-reference-manpages-systemcommands-cyradm-setquota"></span><h3>setquota<a class="headerlink" href="#setquota" title="Permalink to this headline">¶</a></h3>
 <p><strong>setquota</strong> <em>root</em> <em>resource</em> <em>value</em> [<em>resource</em> <em>value</em> ...]</p>
@@ -1203,7 +1250,7 @@ sh(1), perl(1), imapd(8), imapd.conf(5),
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team.
+        &copy; Copyright 1993-2018, The Cyrus Team.
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1223,7 +1270,7 @@ sh(1), perl(1), imapd(8), imapd.conf(5),
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_backup.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_backup.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_backup.html	2019-12-16 04:17:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_backup.html	2020-05-04 04:13:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_backup &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_backup &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_buildinfo" href="cyr_buildinfo.html"/>
         <link rel="prev" title="cvt_xlist_specialuse" href="cvt_xlist_specialuse.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_backup.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_backup.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -926,7 +945,7 @@ the specified user.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 09 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 09 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -946,7 +965,7 @@ the specified user.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_buildinfo.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_buildinfo.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_buildinfo.html	2019-12-16 04:17:54.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_buildinfo.html	2020-05-04 04:13:13.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_buildinfo &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_buildinfo &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_dbtool" href="cyr_dbtool.html"/>
         <link rel="prev" title="cyr_backup" href="cyr_backup.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_buildinfo.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_buildinfo.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -821,7 +840,7 @@ provide compilation settings during runt
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -841,7 +860,7 @@ provide compilation settings during runt
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_dbtool.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_dbtool.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_dbtool.html	2019-12-16 04:17:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_dbtool.html	2020-05-04 04:13:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_dbtool &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_dbtool &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_deny" href="cyr_deny.html"/>
         <link rel="prev" title="cyr_buildinfo" href="cyr_buildinfo.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -852,7 +871,8 @@ is typically a Cyrus &#8220;flat&#8221;
 database version number (currently 2), a list of &#8220;wildmat&#8221; patterns
 specifying Cyrus services to be denied, and a text message to be
 displayed to the user upon denial. The service names to be matched are
-those as used in <a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>.</p>
+those as used in <a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>.  <a class="reference internal" href="cyr_deny.html#std:cyrusman-cyr_deny(8)">cyr_deny(8)</a>
+provides more convenient way to manage <em>user_deny.db</em>.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p class="last">Given that <em>keys</em> are tab-delimited, these examples use the notation
@@ -920,7 +940,7 @@ failures, and log entries like this:</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -940,7 +960,7 @@ failures, and log entries like this:</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_deny.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_deny.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_deny.html	2019-12-16 04:17:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_deny.html	2020-05-04 04:13:14.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_deny &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_deny &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_df" href="cyr_df.html"/>
         <link rel="prev" title="cyr_dbtool" href="cyr_dbtool.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -783,7 +802,8 @@
 The first synopsis denies user <em>user</em> access to Cyrus services, the
 second synopsis allows access again.  <strong>cyr_deny</strong> works by adding an
 entry to the Cyrus <code class="docutils literal"><span class="pre">user_deny.db</span></code> database; the third synopsis lists
-the entries in the database.</p>
+the entries in the database.  The service names to be matched are those
+as used in <a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a>.</p>
 <p><strong>cyr_deny</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
 </div>
 <div class="section" id="options">
@@ -859,7 +879,7 @@ being denied.  A default message is used
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -879,7 +899,7 @@ being denied.  A default message is used
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_df.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_df.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_df.html	2019-12-16 04:17:55.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_df.html	2020-05-04 04:13:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_df &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_df &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_expire" href="cyr_expire.html"/>
         <link rel="prev" title="cyr_deny" href="cyr_deny.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_df.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_df.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -836,7 +855,7 @@ disk space usage.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -856,7 +875,7 @@ disk space usage.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyrdump.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyrdump.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyrdump.html	2019-12-16 04:17:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyrdump.html	2020-05-04 04:13:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyrdump &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyrdump &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="deliver" href="deliver.html"/>
         <link rel="prev" title="cyradm" href="cyradm.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyrdump.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyrdump.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -814,7 +833,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +853,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_expire.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_expire.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_expire.html	2019-12-16 04:17:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_expire.html	2020-05-04 04:13:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_expire &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_expire &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_info" href="cyr_info.html"/>
         <link rel="prev" title="cyr_df" href="cyr_df.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -787,13 +806,20 @@ on Cyrus databases, specifically:</p>
 <li>expire entries from the duplicate delivery database, and</li>
 <li>cleanse mailboxes of partially expunged messages (when using the &#8220;delayed&#8221; expunge mode), and</li>
 <li>remove deleted mailboxes (when using the &#8220;delayed&#8221; delete mode), and</li>
-<li>expire entries from conversations databases.</li>
+<li>expire entries from conversations databases, and</li>
+<li>archive messages from mailbox.</li>
+</ul>
+<p>There are various annotations that <strong>cyr_expire</strong> respects:</p>
+<ul class="simple">
+<li><code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/expire</span></code> which controls the expirations of
+messages</li>
+<li><code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/archive</span></code> which controls the archival of
+messages</li>
+<li><code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/delete</span></code> which controls the deletion of
+messages</li>
 </ul>
-<p>The expiration of messages is controlled by the
-<code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/expire</span></code> mailbox annotation which specifies
-the age (in days) of messages in the given mailbox that should be
-deleted.  A value of 0 means that no expiration is to be performed on
-that mailbox.</p>
+<p>These mailbox annotations specify the age(in days) of messages in the
+given mailbox that should be expired/archived/deleted.</p>
 <p>The value of the <code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/expire</span></code> annotation is
 inherited by all children of the mailbox on which it is set, so an
 entire mailbox tree can be configured by setting a single annotation on
@@ -805,7 +831,8 @@ inherit one), then no messages are expir
 <strong>setinfo</strong> commands of <a class="reference internal" href="cyradm.html#std:cyrusman-cyradm(8)">cyradm(8)</a>.</p>
 <p>Expiration of duplicate delivery database entries for a given mailbox
 is also controlled by the <code class="docutils literal"><span class="pre">/vendor/cmu/cyrus-imapd/expire</span></code> annotation
-which applies to that mailbox.  Unlike message expiration, if no
+which applies to that mailbox.  A value of 0 on the annotation means
+that no expiration is to be performed on that mailbox. Unlike message expiration, if no
 annotation applies to the mailbox then duplicate database entries are
 expired using the value given to the <strong>-E</strong> option.</p>
 <p>Expiration of conversations database entries occurs if the
@@ -831,7 +858,9 @@ supplied.</p>
 <dd><p>Archive non-flagged messages older than <em>archive-duration</em> to the
 archive partition, allowing mailbox messages to be split between fast
 storage and slow large storage.  Only does anything if
-<code class="docutils literal"><span class="pre">archivepartition-*</span></code> has been set in your config.</p>
+<code class="docutils literal"><span class="pre">archivepartition-*</span></code> has been set in your config.
+This value is only used for entries which do not have a
+corresponding <code class="docutils literal"><span class="pre">/vendonr/cmu/cyrus-imapd/archive</span></code> mailbox annotation.</p>
 <p>This feature was introduced in version 3.0.</p>
 </dd></dl>
 
@@ -843,7 +872,9 @@ storage and slow large storage.  Only do
 The value can be a floating point number, and may have a suffix to
 specify the unit of time.  If no suffix, the value is number of days.
 Valid suffixes are <strong>d</strong> (days), <strong>h</strong> (hours), <strong>m</strong> (minutes) and
-<strong>s</strong> (seconds).</p>
+<strong>s</strong> (seconds).
+This value is only used for entries which do not have a
+corresponding <code class="docutils literal"><span class="pre">/verdor/cmu/cyrus-imapd/delete</span></code> mailbox annotation.</p>
 </dd></dl>
 
 <dl class="option">
@@ -966,7 +997,7 @@ version 3.0.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jul 04 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 04 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -986,7 +1017,7 @@ version 3.0.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_info.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_info.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_info.html	2019-12-16 04:17:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_info.html	2020-05-04 04:13:15.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_info &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_info &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_sequence" href="cyr_sequence.html"/>
         <link rel="prev" title="cyr_expire" href="cyr_expire.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -789,21 +808,28 @@ configuring Cyrus easier.</p>
 <dl class="option">
 <dt id="cmdoption-arg-conf">
 <code class="descname">conf</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-conf" title="Permalink to this definition">¶</a></dt>
-<dd><p>Print only the configuration options which are not the same as
-default (regardless of whether you have specified them or not).</p>
+<dd><p>Print the configuration options which have been set to a value
+other than their default, and their value.</p>
+<p>With <strong>-s version</strong>, configuration options whose behaviour has
+changed since <em>version</em> will be highlighted.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-arg-conf-default">
-<code class="descname">conf-default</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-conf-default" title="Permalink to this definition">¶</a></dt>
-<dd><p>Print all default configuration options, ignoring those set locally.</p>
+<dt id="cmdoption-arg-conf-all">
+<code class="descname">conf-all</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-conf-all" title="Permalink to this definition">¶</a></dt>
+<dd><p>Print ALL configuration options and their configured values (including
+those using their default value).  This command shows which options
+will be in effect at runtime.</p>
+<p>With <strong>-s version</strong>, configuration options which have been added or
+whose behaviour has changed since <em>version</em> will be highlighted.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-arg-conf-all">
-<code class="descname">conf-all</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-conf-all" title="Permalink to this definition">¶</a></dt>
-<dd><p>Print ALL configuration options - including default options.  This
-command shows which options will be in effect at runtime.</p>
+<dt id="cmdoption-arg-conf-default">
+<code class="descname">conf-default</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-conf-default" title="Permalink to this definition">¶</a></dt>
+<dd><p>Print the default values for all available configuration options.</p>
+<p>With <strong>-s version</strong>, configuration options which have been added or
+whose behaviour has changed since <em>version</em> will be highlighted.</p>
 </dd></dl>
 
 <dl class="option">
@@ -842,6 +868,16 @@ configuration options for the named serv
 <dd><p>Read the configuration as if for the service named <em>name</em>.</p>
 </dd></dl>
 
+<dl class="option">
+<dt id="cmdoption-cyr_info-s">
+<code class="descname">-s</code><code class="descclassname"> version</code><a class="headerlink" href="#cmdoption-cyr_info-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Highlight configuration options that have been added or whose behaviour
+has been modified since <em>version</em>.  Use this option after a server upgrade,
+specifying your previous version, to find which options you need to review
+and maybe change before starting up the upgraded server.</p>
+<p>For use with the <strong>conf</strong>, <strong>conf-all</strong>, and <strong>conf-default</strong> sub-commands.</p>
+</dd></dl>
+
 </div>
 <div class="section" id="examples">
 <h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
@@ -902,7 +938,7 @@ configuration options for the named serv
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 11 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -922,7 +958,7 @@ configuration options for the named serv
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_sequence.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_sequence.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_sequence.html	2019-12-16 04:17:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_sequence.html	2020-05-04 04:13:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_sequence &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_sequence &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_synclog" href="cyr_synclog.html"/>
         <link rel="prev" title="cyr_info" href="cyr_info.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_sequence.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_sequence.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -892,7 +911,7 @@ If an original list is given, this is jo
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -912,7 +931,7 @@ If an original list is given, this is jo
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_synclog.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_synclog.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_synclog.html	2019-12-16 04:17:56.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_synclog.html	2020-05-04 04:13:16.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_synclog &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_synclog &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_userseen" href="cyr_userseen.html"/>
         <link rel="prev" title="cyr_sequence" href="cyr_sequence.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_synclog.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_synclog.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -906,7 +925,7 @@ either specify the log type and value, o
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -926,7 +945,7 @@ either specify the log type and value, o
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_userseen.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_userseen.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_userseen.html	2019-12-16 04:17:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_userseen.html	2020-05-04 04:13:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_userseen &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_userseen &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyr_virusscan" href="cyr_virusscan.html"/>
         <link rel="prev" title="cyr_synclog" href="cyr_synclog.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_userseen.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_userseen.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -857,7 +876,7 @@ not actually alter existing state.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -877,7 +896,7 @@ not actually alter existing state.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_virusscan.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_virusscan.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/cyr_virusscan.html	2019-12-16 04:17:57.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/cyr_virusscan.html	2020-05-04 04:13:17.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>cyr_virusscan &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>cyr_virusscan &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="cyradm" href="cyradm.html"/>
         <link rel="prev" title="cyr_userseen" href="cyr_userseen.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -766,7 +785,7 @@
 </div>
           <div role="main" class="document">
             
-  <span class="target" id="std:cyrusman-cyr_virusscan(8)"></span><div class="section" id="cyr-virusscan">
+  <div class="section" id="cyr-virusscan">
 <span id="imap-reference-manpages-systemcommands-cyr-virusscan"></span><h1><strong>cyr_virusscan</strong><a class="headerlink" href="#cyr-virusscan" title="Permalink to this headline">¶</a></h1>
 <p>Scan for viruses using configured virus scanner or manage infected messages using search criteria.</p>
 <div class="section" id="synopsis">
@@ -788,9 +807,10 @@ without a distinct signature, such as Ph
 <p>A table of infected messages will be output.</p>
 <p>To remove infected messages, use the <strong>-r</strong> flag. Infected messages will be expunged
 from the user&#8217;s mailbox.</p>
-<p>With the notify flag, <strong>-n</strong>, notifications will be appended to the inbox of the mailbox owner,
-containing message digest information for the affected mail.  This
-flag is only works in combination with <strong>-r</strong>.</p>
+<p>With the notify flag, <strong>-n</strong>, notifications will be appended to the inbox of
+the mailbox owner, containing message digest information for the affected mail.
+This flag only works in combination with <strong>-r</strong>.  The notification message
+can by customised by template, for details see <a class="reference internal" href="#notifications">Notifications</a> below.</p>
 <p><strong>cyr_virusscan</strong> can be configured to run periodically by cron(8)
 via crontab(5) or your preferred method (i.e. /etc/cron.hourly), or by
 <a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a> via the EVENTS{} section in
@@ -834,6 +854,39 @@ criteria will be treated as infected.</p
 </dd></dl>
 
 </div>
+<div class="section" id="notifications">
+<h2>Notifications<a class="headerlink" href="#notifications" title="Permalink to this headline">¶</a></h2>
+<p>When the <strong>-n</strong> flag is provided, notifications are sent to mailbox owners
+when infected messages are removed.  One notification is sent per owner,
+containing a digest of each message that was deleted from any of their
+mailboxes.</p>
+<p>The default notification subject is &#8220;Automatically deleted mail&#8221;, which
+can be overridden by setting <code class="docutils literal"><span class="pre">virusscan_notification_subject</span></code> in
+<a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> to a UTF-8 value.</p>
+<p>Each infected message will be described according to the following template:</p>
+<div class="highlight-none"><div class="highlight"><pre><span></span>The following message was deleted from mailbox &#39;%MAILBOX%&#39;
+because it was infected with virus &#39;%VIRUS%&#39;
+
+    Message-ID: %MSG_ID%
+    Date: %MSG_DATE%
+    From: %MSG_FROM%
+    Subject: %MSG_SUBJECT%
+    IMAP UID: %MSG_UID%
+</pre></div>
+</div>
+<p>To use a custom template, create a UTF-8 file containing your desired text
+and using the same %-delimited substitutions as above, and set the
+<code class="docutils literal"><span class="pre">virusscan_notification_template</span></code> option in <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> to
+its path.</p>
+<p>The notification message will be properly MIME-encoded at delivery. Do not
+pre-encode the template file or the subject!</p>
+<p>When <strong>cyr_virusscan</strong> starts up, if notifications have been requested (with
+the <strong>-n</strong> flag), a basic sanity check of the template will be performed
+prior to initialising the antivirus engine.  If it appears that the
+resultant notifications would be undeliverable for some reason,
+<strong>cyr_virusscan</strong> will exit immediately with an error, rather than risk
+deleting messages without notifying.</p>
+</div>
 <div class="section" id="examples">
 <h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
@@ -842,19 +895,19 @@ criteria will be treated as infected.</p
 <blockquote>
 <div>Scan all mailboxes, printing report on the screen.  Do not
 remove infected messages.</div></blockquote>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">Using</span> <span class="n">ClamAV</span> <span class="n">virus</span> <span class="n">scanner</span>
-<span class="n">Loaded</span> <span class="mi">5789330</span> <span class="n">virus</span> <span class="n">signatures</span><span class="o">.</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>Using ClamAV virus scanner
+Loaded 5789330 virus signatures.
 
-<span class="n">Mailbox</span> <span class="n">Name</span>                                       <span class="n">Msg</span> <span class="n">UID</span>      <span class="n">Status</span>  <span class="n">Virus</span> <span class="n">Name</span>
-<span class="o">----------------------------------------</span>        <span class="o">----------</span>      <span class="o">------</span>  <span class="o">--------------------------------------------------</span>
-<span class="n">user</span><span class="o">.</span><span class="n">betty</span>                                          <span class="mi">185395</span>        <span class="n">READ</span>  <span class="n">Heuristics</span><span class="o">.</span><span class="n">Phishing</span><span class="o">.</span><span class="n">Email</span><span class="o">.</span><span class="n">SpoofedDomain</span>
-<span class="n">user</span><span class="o">.</span><span class="n">betty</span><span class="o">.</span><span class="n">Bank</span> <span class="n">stuff</span>                                    <span class="mi">9</span>        <span class="n">READ</span>  <span class="n">Html</span><span class="o">.</span><span class="n">Phishing</span><span class="o">.</span><span class="n">Bank</span><span class="o">-</span><span class="mi">1172</span>
-<span class="n">user</span><span class="o">.</span><span class="n">betty</span><span class="o">.</span><span class="n">Bank</span> <span class="n">stuff</span>                                   <span class="mi">10</span>        <span class="n">READ</span>  <span class="n">Html</span><span class="o">.</span><span class="n">Phishing</span><span class="o">.</span><span class="n">Bank</span><span class="o">-</span><span class="mi">1172</span>
-<span class="n">user</span><span class="o">.</span><span class="n">betty</span><span class="o">.</span><span class="n">Bank</span> <span class="n">stuff</span>                                   <span class="mi">11</span>        <span class="n">READ</span>  <span class="n">Html</span><span class="o">.</span><span class="n">Phishing</span><span class="o">.</span><span class="n">Bank</span><span class="o">-</span><span class="mi">1172</span>
-
-<span class="n">Mailbox</span> <span class="n">Name</span>                                       <span class="n">Msg</span> <span class="n">UID</span>      <span class="n">Status</span>  <span class="n">Virus</span> <span class="n">Name</span>
-<span class="o">----------------------------------------</span>        <span class="o">----------</span>      <span class="o">------</span>  <span class="o">--------------------------------------------------</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                           <span class="mi">17426</span>        <span class="n">READ</span>  <span class="n">Email</span><span class="o">.</span><span class="n">Trojan</span><span class="o">.</span><span class="n">Trojan</span><span class="o">-</span><span class="mi">1051</span>
+Mailbox Name                                       Msg UID      Status  Virus Name
+----------------------------------------        ----------      ------  --------------------------------------------------
+user.betty                                          185395        READ  Heuristics.Phishing.Email.SpoofedDomain
+user.betty.Bank stuff                                    9        READ  Html.Phishing.Bank-1172
+user.betty.Bank stuff                                   10        READ  Html.Phishing.Bank-1172
+user.betty.Bank stuff                                   11        READ  Html.Phishing.Bank-1172
+
+Mailbox Name                                       Msg UID      Status  Virus Name
+----------------------------------------        ----------      ------  --------------------------------------------------
+user.bovik                                           17426        READ  Email.Trojan.Trojan-1051
 </pre></div>
 </div>
 <pre class="literal-block">
@@ -862,22 +915,22 @@ remove infected messages.</div></blockqu
 </pre>
 <blockquote>
 <div>Scan mailbox <em>user/bovik</em>, removing infected messages and append
-notifications to bovik&#8217;s inbox.</div></blockquote>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">Mailbox</span> <span class="n">Name</span>                                       <span class="n">Msg</span> <span class="n">UID</span>      <span class="n">Status</span>  <span class="n">Virus</span> <span class="n">Name</span>
-<span class="o">----------------------------------------</span>        <span class="o">----------</span>      <span class="o">------</span>  <span class="o">--------------------------------------------------</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">17426</span>          <span class="n">READ</span>  <span class="n">Email</span><span class="o">.</span><span class="n">Trojan</span><span class="o">.</span><span class="n">Trojan</span><span class="o">-</span><span class="mi">1051</span>
+notifications to Bovik&#8217;s inbox.</div></blockquote>
+<div class="highlight-none"><div class="highlight"><pre><span></span>Mailbox Name                                       Msg UID      Status  Virus Name
+----------------------------------------        ----------      ------  --------------------------------------------------
+user.bovik                                         17426          READ  Email.Trojan.Trojan-1051
 </pre></div>
 </div>
 <blockquote>
 <div>A message like this would end up in bovik&#8217;s inbox:</div></blockquote>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">The</span> <span class="n">following</span> <span class="n">message</span> <span class="n">was</span> <span class="n">deleted</span> <span class="kn">from</span> <span class="nn">mailbox</span> <span class="s1">&#39;Inbox.bovik&#39;</span>
-<span class="n">because</span> <span class="n">it</span> <span class="n">was</span> <span class="n">infected</span> <span class="k">with</span> <span class="n">virus</span> <span class="s1">&#39;Email.Trojan.Trojan-1051&#39;</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>The following message was deleted from mailbox &#39;INBOX&#39;
+because it was infected with virus &#39;Email.Trojan.Trojan-1051&#39;
 
-    <span class="n">Message</span><span class="o">-</span><span class="n">ID</span><span class="p">:</span> <span class="o">&lt;</span><span class="mf">201308131519.</span><span class="n">r7DFJM9K083763</span><span class="nd">@tselina</span><span class="o">.</span><span class="n">kiev</span><span class="o">.</span><span class="n">ua</span><span class="o">&gt;</span>
-    <span class="n">Date</span><span class="p">:</span> <span class="n">Tue</span><span class="p">,</span> <span class="mi">13</span> <span class="n">Aug</span> <span class="mi">2013</span> <span class="mi">18</span><span class="p">:</span><span class="mi">19</span><span class="p">:</span><span class="mi">22</span> <span class="o">+</span><span class="mi">0300</span> <span class="p">(</span><span class="n">EEST</span><span class="p">)</span>
-    <span class="n">From</span><span class="p">:</span> <span class="p">(</span><span class="s2">&quot;FEDEX Thomas Cooper&quot;</span> <span class="n">NIL</span> <span class="s2">&quot;thomas_cooper94&quot;</span> <span class="s2">&quot;themovieposterpage.com&quot;</span><span class="p">)</span>
-    <span class="n">Subject</span><span class="p">:</span> <span class="n">Problem</span> <span class="k">with</span> <span class="n">the</span> <span class="n">delivery</span> <span class="n">of</span> <span class="n">parcel</span>
-    <span class="n">IMAP</span> <span class="n">UID</span><span class="p">:</span> <span class="mi">17426</span>
+    Message-ID: &lt;201308131519.r7DFJM9K083763@tselina.kiev.ua&gt;
+    Date: Tue, 13 Aug 2013 18:19:22 +0300 (EEST)
+    From: &quot;FEDEX Thomas Cooper&quot; &lt;thomas_cooper94@themovieposterpage.com&gt;
+    Subject: Problem with the delivery of parcel
+    IMAP UID: 17426
 </pre></div>
 </div>
 <pre class="literal-block">
@@ -887,14 +940,14 @@ notifications to bovik&#8217;s inbox.</d
 <div>Search mailbox user/bovik for messages which have Fedex in the
 subject line, removing them all, and appending notifications to
 Bovik&#8217;s inbox.</div></blockquote>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">Mailbox</span> <span class="n">Name</span>                                       <span class="n">Msg</span> <span class="n">UID</span>      <span class="n">Status</span>  <span class="n">Virus</span> <span class="n">Name</span>
-<span class="o">----------------------------------------</span>        <span class="o">----------</span>      <span class="o">------</span>  <span class="o">--------------------------------------------------</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">17185</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">17203</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">17338</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">17373</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">19238</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
-<span class="n">user</span><span class="o">.</span><span class="n">bovik</span>                                         <span class="mi">19268</span>          <span class="n">READ</span>  <span class="n">Cyrus</span> <span class="n">Administrator</span> <span class="n">Targeted</span> <span class="n">Removal</span> <span class="p">(</span><span class="n">Phish</span><span class="p">,</span> <span class="n">etc</span><span class="o">.</span><span class="p">)</span>
+<div class="highlight-none"><div class="highlight"><pre><span></span>Mailbox Name                                       Msg UID      Status  Virus Name
+----------------------------------------        ----------      ------  --------------------------------------------------
+user.bovik                                         17185          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
+user.bovik                                         17203          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
+user.bovik                                         17338          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
+user.bovik                                         17373          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
+user.bovik                                         19238          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
+user.bovik                                         19268          READ  Cyrus Administrator Targeted Removal (Phish, etc.)
 </pre></div>
 </div>
 </div>
@@ -930,7 +983,7 @@ Bovik&#8217;s inbox.</div></blockquote>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 22 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 06 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -950,7 +1003,7 @@ Bovik&#8217;s inbox.</div></blockquote>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/deliver.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/deliver.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/deliver.html	2019-12-16 04:17:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/deliver.html	2020-05-04 04:13:18.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>deliver &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>deliver &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="fetchnews" href="fetchnews.html"/>
         <link rel="prev" title="cyrdump" href="cyrdump.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/deliver.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/deliver.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -886,7 +905,7 @@ present in US-ASCII.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 12 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -906,7 +925,7 @@ present in US-ASCII.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/fetchnews.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/fetchnews.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/fetchnews.html	2019-12-16 04:17:58.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/fetchnews.html	2020-05-04 04:13:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>fetchnews &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>fetchnews &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="fud" href="fud.html"/>
         <link rel="prev" title="deliver" href="deliver.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/fetchnews.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/fetchnews.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -871,7 +890,7 @@ specified by the configuration options.<
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -891,7 +910,7 @@ specified by the configuration options.<
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/fud.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/fud.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/fud.html	2019-12-16 04:17:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/fud.html	2020-05-04 04:13:19.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>fud &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>fud &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="httpd" href="httpd.html"/>
         <link rel="prev" title="fetchnews" href="fetchnews.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/fud.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/fud.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -896,7 +915,7 @@ by a more standards-based protocol.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 12 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -916,7 +935,7 @@ by a more standards-based protocol.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/httpd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/httpd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/httpd.html	2019-12-16 04:17:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/httpd.html	2020-05-04 04:13:20.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>httpd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>httpd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="idled" href="idled.html"/>
         <link rel="prev" title="fud" href="fud.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/httpd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/httpd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -891,7 +910,7 @@ beginning in version 2.5.0.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -911,7 +930,7 @@ beginning in version 2.5.0.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/idled.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/idled.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/idled.html	2019-12-16 04:17:59.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/idled.html	2020-05-04 04:13:20.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>idled &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>idled &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="imapd" href="imapd.html"/>
         <link rel="prev" title="httpd" href="httpd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/idled.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/idled.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -832,7 +851,7 @@ changes to the client.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 15 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -852,7 +871,7 @@ changes to the client.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/imapd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/imapd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/imapd.html	2019-12-16 04:18:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/imapd.html	2020-05-04 04:13:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>imapd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>imapd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ipurge" href="ipurge.html"/>
         <link rel="prev" title="idled" href="idled.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/imapd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/imapd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -897,7 +916,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -917,7 +936,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ipurge.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ipurge.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ipurge.html	2019-12-16 04:18:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ipurge.html	2020-05-04 04:13:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ipurge &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ipurge &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="lmtpd" href="lmtpd.html"/>
         <link rel="prev" title="imapd" href="imapd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ipurge.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ipurge.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -772,7 +791,7 @@
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>ipurge</strong> [ <strong>-f</strong> ] [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-x</strong> ] [ <strong>-X</strong> ] [ <strong>-i</strong> ] [ <strong>-s</strong> ] [ <strong>-o</strong> ] [ <strong>-n</strong> ] [ <strong>-v</strong> ]
+<strong>ipurge</strong> [ <strong>-f</strong> ] [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-x</strong> ] [ <strong>-M</strong> ] [ <strong>-X</strong> ] [ <strong>-i</strong> ] [ <strong>-s</strong> ] [ <strong>-o</strong> ] [ <strong>-n</strong> ] [ <strong>-v</strong> ]
         [ <strong>-d</strong> <em>days</em> | <strong>-b</strong> <em>bytes</em> | <strong>-k</strong> <em>Kbytes</em> | <strong>-m</strong> <em>Mbytes</em> ]
         [ <em>mailbox-pattern</em>... ]
 </pre>
@@ -789,7 +808,7 @@ of <strong>-d</strong>, <strong>-b</stro
 <p><em>Ipurge</em> by default only deletes mail below shared folders, which means
 that mails in mailbox(es) below INBOX.* and user.* stay untouched. Use
 the option <strong>-f</strong> to also delete mail in mailbox(es) below these
-folders.</p>
+folders. Use the <strong>-M</strong> option to not recurse into the mailboxes.</p>
 <p><em>ipurge</em> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
 </div>
 <div class="section" id="options">
@@ -906,7 +925,7 @@ for smaller.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 29 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -926,7 +945,7 @@ for smaller.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/lmtpd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/lmtpd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/lmtpd.html	2019-12-16 04:18:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/lmtpd.html	2020-05-04 04:13:21.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>lmtpd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>lmtpd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="lmtpproxyd" href="lmtpproxyd.html"/>
         <link rel="prev" title="ipurge" href="ipurge.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -865,7 +884,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -885,7 +904,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/lmtpproxyd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/lmtpproxyd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/lmtpproxyd.html	2019-12-16 04:18:00.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/lmtpproxyd.html	2020-05-04 04:13:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>lmtpproxyd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>lmtpproxyd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="masssievec" href="masssievec.html"/>
         <link rel="prev" title="lmtpd" href="lmtpd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,6 +788,82 @@
   <div class="section" id="lmtpproxyd">
 <span id="imap-reference-manpages-systemcommands-lmtpproxyd"></span><span id="std:cyrusman-lmtpproxyd(8)"></span><h1><strong>lmtpproxyd</strong><a class="headerlink" href="#lmtpproxyd" title="Permalink to this headline">¶</a></h1>
 <p>This is a hard linked copy of <a class="reference internal" href="lmtpd.html#std:cyrusman-lmtpd(8)">lmtpd(8)</a>, retained for backwards compatibility from when a murder frontend used its own lmtpd binaries.</p>
+<div class="section" id="synopsis">
+<h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
+<pre class="literal-block">
+<strong>lmtpd</strong> [ <strong>-C</strong> <em>config-file</em> ]  [ <strong>-U</strong> <em>uses</em> ] [ <strong>-T</strong> <em>timeout</em> ] [ <strong>-D</strong> ] [ <strong>-a</strong> ]
+</pre>
+</div>
+<div class="section" id="description">
+<h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
+<p><strong>lmtpd</strong> is an LMTP server used to deliver mail to the IMAP mailstore.
+It accepts commands on its standard input and responds on its standard
+output. It MUST be invoked by <a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a> with those
+descriptors attached to a remote client connection.</p>
+<p><strong>lmtpd</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
+</div>
+<div class="section" id="options">
+<h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
+<dl class="option">
+<dt id="cmdoption-lmtpd-C">
+<code class="descname">-C</code><code class="descclassname"> config-file</code><a class="headerlink" href="#cmdoption-lmtpd-C" title="Permalink to this definition">¶</a></dt>
+<dd><p>Use the specified configuration file <em>config-file</em> rather than the default <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-U">
+<code class="descname">-U</code><code class="descclassname">  uses</code><a class="headerlink" href="#cmdoption-lmtpd-U" title="Permalink to this definition">¶</a></dt>
+<dd><p>The maximum number of times that the process should be used for new
+connections before shutting down.  The default is 250.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-T">
+<code class="descname">-T</code><code class="descclassname">  timeout</code><a class="headerlink" href="#cmdoption-lmtpd-T" title="Permalink to this definition">¶</a></dt>
+<dd><p>The number of seconds that the process will wait for a new
+connection before shutting down.  Note that a value of 0 (zero)
+will disable the timeout.  The default is 60.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-D">
+<code class="descname">-D</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtpd-D" title="Permalink to this definition">¶</a></dt>
+<dd><p>Run external debugger specified in debug_command.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-a">
+<code class="descname">-a</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtpd-a" title="Permalink to this definition">¶</a></dt>
+<dd><p>Preauthorize connections initiated on an internet socket, instead
+of requiring LMTP AUTH.  This should only be used for connections
+coming from trusted hosts.</p>
+</dd></dl>
+
+</div>
+<div class="section" id="examples">
+<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
+<p><strong>lmtpd</strong> is commonly included in the SERVICES section of
+<a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> like so:</p>
+<pre class="literal-block">
+SERVICES {
+    imap        cmd=&quot;imapd -U 30&quot; listen=&quot;imap&quot; prefork=0
+    imaps       cmd=&quot;imapd -s -U 30&quot; listen=&quot;imaps&quot; prefork=0 maxchild=100
+    <strong>lmtpunix    cmd=&quot;lmtpd&quot; listen=&quot;/var/run/cyrus/socket/lmtp&quot; prefork=0 maxchild=20</strong>
+    sieve       cmd=&quot;timsieved&quot; listen=&quot;sieve&quot; prefork=0
+    notify      cmd=&quot;notifyd&quot; listen=&quot;/var/run/cyrus/socket/notify&quot; proto=&quot;udp&quot; prefork=1
+    httpd       cmd=&quot;httpd&quot; listen=8080 prefork=1 maxchild=20
+}
+</pre>
+</div>
+<div class="section" id="files">
+<h2>Files<a class="headerlink" href="#files" title="Permalink to this headline">¶</a></h2>
+<p>/etc/imapd.conf</p>
+</div>
+<div class="section" id="see-also">
+<h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>,
+<a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a></p>
+</div>
 </div>
 
 
@@ -789,7 +884,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +904,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/masssievec.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/masssievec.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/masssievec.html	2019-12-16 04:18:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/masssievec.html	2020-05-04 04:13:22.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>masssievec &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>masssievec &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="master" href="master.html"/>
         <link rel="prev" title="lmtpproxyd" href="lmtpproxyd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/masssievec.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/masssievec.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -813,7 +832,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 13 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 13 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -833,7 +852,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/master.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/master.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/master.html	2019-12-16 04:18:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/master.html	2020-05-04 04:13:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>master &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>master &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mbexamine" href="mbexamine.html"/>
         <link rel="prev" title="masssievec" href="masssievec.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/master.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/master.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -782,8 +801,8 @@
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
 <p><strong>master</strong> is the process that controls all of the Cyrus
 processes. This process is responsible for creating all imapd, pop3d,
-lmtpd and timsieved child processes. This process also initializes the
-Berkeley DB code and performs scheduled cleanup/maintenance.</p>
+lmtpd and sieved child processes. This process also performs scheduled
+cleanup/maintenance.</p>
 <p>If this process dies, then no new sessions will be started.</p>
 <p>It kills itself and all child processes when it receives a SIGTERM.</p>
 <p><strong>master</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
@@ -925,7 +944,7 @@ Setting it higher results in more log me
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 08 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 12 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -945,7 +964,7 @@ Setting it higher results in more log me
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbexamine.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbexamine.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbexamine.html	2019-12-16 04:18:01.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbexamine.html	2020-05-04 04:13:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mbexamine &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mbexamine &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mbpath" href="mbpath.html"/>
         <link rel="prev" title="master" href="master.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mbexamine.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mbexamine.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -967,7 +986,7 @@ index records to the actual message file
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -987,7 +1006,7 @@ index records to the actual message file
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbpath.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbpath.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbpath.html	2019-12-16 04:18:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbpath.html	2020-05-04 04:13:23.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mbpath &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mbpath &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mbtool" href="mbtool.html"/>
         <link rel="prev" title="mbexamine" href="mbexamine.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mbpath.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mbpath.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -772,15 +791,17 @@
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>mbpath</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-q</strong> ] [ <strong>-s</strong> ] [ <strong>-m</strong> ] [ <em>mailbox-names</em>... ]
+<strong>mbpath</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-l</strong> ] [ <strong>-m</strong> ] [ <strong>-q</strong> ] [ <strong>-s</strong> ] [ <strong>-u</strong> ] [ <strong>-a</strong> | <strong>-A</strong> | <strong>-M</strong> | <strong>-S</strong> | <strong>-U</strong> ] [ <em>mailbox-names</em>... ]
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
 <p>Given a mailbox name or a space separated list of mailbox names,
-<strong>mbpath</strong> outputs the filesystem path to the mailbox.</p>
+<strong>mbpath</strong> outputs the filesystem path(s) of the mailbox.  By default,
+the mailboxes&#8217; data partition paths are shown (same as <strong>-D</strong>).
+See <a class="reference internal" href="#selectors">Selectors</a> for selecting which filesystem path(s) to output.</p>
 <p><strong>mbpath</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>. It uses &lt;configdirectory&gt;/mailboxes.db
-to locate the mailbox on disk.</p>
+to locate the mailboxes on disk.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
@@ -791,6 +812,19 @@ to locate the mailbox on disk.</p>
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-mbpath-l">
+<code class="descname">-l</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-l" title="Permalink to this definition">¶</a></dt>
+<dd><p>Local mailboxes only (exits with error for remote or nonexistent mailboxes)</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-m">
+<code class="descname">-m</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Output the path to the metadata files (if different from the
+message files).  Legacy, use <strong>-M</strong>.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-mbpath-q">
 <code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-q" title="Permalink to this definition">¶</a></dt>
 <dd><p>Suppress any error output.</p>
@@ -803,10 +837,48 @@ to locate the mailbox on disk.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mbpath-m">
-<code class="descname">-m</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Output the path to the metadata files (if different from the
-message files).</p>
+<dt id="cmdoption-mbpath-u">
+<code class="descname">-u</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-u" title="Permalink to this definition">¶</a></dt>
+<dd><p>The specified <em>mailbox-names</em> are users, not mailboxes.</p>
+</dd></dl>
+
+</div>
+<div class="section" id="selectors">
+<h2>Selectors<a class="headerlink" href="#selectors" title="Permalink to this headline">¶</a></h2>
+<dl class="option">
+<dt id="cmdoption-mbpath-A">
+<code class="descname">-A</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-A" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show the mailbox archive path</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-D">
+<code class="descname">-D</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-D" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show the mailbox data path (<em>default</em>)</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-M">
+<code class="descname">-M</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-M" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show the mailbox metadata path (same as <strong>-m</strong>)</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-S">
+<code class="descname">-S</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-S" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show the user sieve scripts path</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-U">
+<code class="descname">-U</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-U" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show the user files path (seen, sub, etc)</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-mbpath-a">
+<code class="descname">-a</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mbpath-a" title="Permalink to this definition">¶</a></dt>
+<dd><p>Show all paths, as if all selectors were specified</p>
 </dd></dl>
 
 </div>
@@ -816,18 +888,26 @@ message files).</p>
 <strong>mbpath</strong> <em>user.jsmith</em>
 </pre>
 <blockquote>
-<div>Display the path for mailbox <em>user.jsmith</em>.</div></blockquote>
+<div>Display the data path for mailbox <em>user.jsmith</em>.</div></blockquote>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">spool</span><span class="o">/</span><span class="n">cyrus</span><span class="o">/</span><span class="n">user</span><span class="o">/</span><span class="n">jsmith</span>
 </pre></div>
 </div>
 <pre class="literal-block">
-<strong>mbpath -m</strong> <em>user.jsmith</em>
+<strong>mbpath -M</strong> <em>user.jsmith</em>
 </pre>
 <blockquote>
 <div>Display the metadata path for mailbox <em>user.jsmith</em>.</div></blockquote>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">spool</span><span class="o">/</span><span class="n">meta</span><span class="o">/</span><span class="n">imap</span><span class="o">/</span><span class="n">user</span><span class="o">/</span><span class="n">jsmith</span>
 </pre></div>
 </div>
+<pre class="literal-block">
+<strong>mbpath -u -S</strong> <em>jsmith</em>
+</pre>
+<blockquote>
+<div>Display the sieve scripts path for user <em>jsmith</em>.</div></blockquote>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">/</span><span class="n">var</span><span class="o">/</span><span class="n">spool</span><span class="o">/</span><span class="n">sieve</span><span class="o">/</span><span class="n">j</span><span class="o">/</span><span class="n">jsmith</span>
+</pre></div>
+</div>
 </div>
 <div class="section" id="files">
 <h2>Files<a class="headerlink" href="#files" title="Permalink to this headline">¶</a></h2>
@@ -858,7 +938,7 @@ message files).</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 02 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -878,7 +958,7 @@ message files).</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbtool.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbtool.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mbtool.html	2019-12-16 04:18:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mbtool.html	2020-05-04 04:13:24.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mbtool &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mbtool &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mkimap" href="mkimap.html"/>
         <link rel="prev" title="mbpath" href="mbpath.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mbtool.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mbtool.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -860,7 +879,7 @@ restored from backup and lost its intern
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Feb 15 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -880,7 +899,7 @@ restored from backup and lost its intern
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mkimap.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mkimap.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mkimap.html	2019-12-16 04:18:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mkimap.html	2020-05-04 04:13:24.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mkimap &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mkimap &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mknewsgroups" href="mknewsgroups.html"/>
         <link rel="prev" title="mbtool" href="mbtool.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mkimap.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mkimap.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -848,7 +867,7 @@ you run the Cyrus IMAP service as).</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 18 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 18 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -868,7 +887,7 @@ you run the Cyrus IMAP service as).</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mknewsgroups.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mknewsgroups.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mknewsgroups.html	2019-12-16 04:18:02.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mknewsgroups.html	2020-05-04 04:13:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mknewsgroups &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mknewsgroups &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mupdate" href="mupdate.html"/>
         <link rel="prev" title="mkimap" href="mkimap.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mknewsgroups.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mknewsgroups.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -853,7 +872,7 @@ of cyradm-style userid/rights pairs (eg,
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 13 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 13 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -873,7 +892,7 @@ of cyradm-style userid/rights pairs (eg,
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mupdate.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mupdate.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/mupdate.html	2019-12-16 04:18:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/mupdate.html	2020-05-04 04:13:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mupdate &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mupdate &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="nntpd" href="nntpd.html"/>
         <link rel="prev" title="mknewsgroups" href="mknewsgroups.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/mupdate.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/mupdate.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -861,7 +880,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -881,7 +900,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/nntpd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/nntpd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/nntpd.html	2019-12-16 04:18:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/nntpd.html	2020-05-04 04:13:25.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>nntpd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>nntpd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="notifyd" href="notifyd.html"/>
         <link rel="prev" title="mupdate" href="mupdate.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/nntpd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/nntpd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -888,7 +907,7 @@ Any higher SSF implies some form of priv
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -908,7 +927,7 @@ Any higher SSF implies some form of priv
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/notifyd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/notifyd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/notifyd.html	2019-12-16 04:18:03.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/notifyd.html	2020-05-04 04:13:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>notifyd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>notifyd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="pop3d" href="pop3d.html"/>
         <link rel="prev" title="nntpd" href="nntpd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/notifyd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/notifyd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -871,7 +890,7 @@ configuration file.</div></blockquote>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -891,7 +910,7 @@ configuration file.</div></blockquote>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/pop3d.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/pop3d.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/pop3d.html	2019-12-16 04:18:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/pop3d.html	2020-05-04 04:13:26.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>pop3d &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>pop3d &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="pop3proxyd" href="pop3proxyd.html"/>
         <link rel="prev" title="notifyd" href="notifyd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/pop3d.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/pop3d.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -886,7 +905,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -906,7 +925,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/pop3proxyd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/pop3proxyd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/pop3proxyd.html	2019-12-16 04:18:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/pop3proxyd.html	2020-05-04 04:13:27.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>pop3proxyd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>pop3proxyd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="proxyd" href="proxyd.html"/>
         <link rel="prev" title="pop3d" href="pop3d.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,6 +788,82 @@
   <div class="section" id="pop3proxyd">
 <span id="pop3-admin-commands-pop3proxyd"></span><span id="std:cyrusman-pop3proxyd(8)"></span><h1><strong>pop3proxyd</strong><a class="headerlink" href="#pop3proxyd" title="Permalink to this headline">¶</a></h1>
 <p>This is a hard linked copy of <a class="reference internal" href="pop3d.html#std:cyrusman-pop3d(8)">pop3d(8)</a>, retained for backwards compatibility from when a murder frontend used its own pop3d binaries.</p>
+<div class="section" id="synopsis">
+<h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
+<pre class="literal-block">
+<strong>lmtpd</strong> [ <strong>-C</strong> <em>config-file</em> ]  [ <strong>-U</strong> <em>uses</em> ] [ <strong>-T</strong> <em>timeout</em> ] [ <strong>-D</strong> ] [ <strong>-a</strong> ]
+</pre>
+</div>
+<div class="section" id="description">
+<h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
+<p><strong>lmtpd</strong> is an LMTP server used to deliver mail to the IMAP mailstore.
+It accepts commands on its standard input and responds on its standard
+output. It MUST be invoked by <a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a> with those
+descriptors attached to a remote client connection.</p>
+<p><strong>lmtpd</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
+</div>
+<div class="section" id="options">
+<h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
+<dl class="option">
+<dt id="cmdoption-lmtpd-C">
+<code class="descname">-C</code><code class="descclassname"> config-file</code><a class="headerlink" href="#cmdoption-lmtpd-C" title="Permalink to this definition">¶</a></dt>
+<dd><p>Use the specified configuration file <em>config-file</em> rather than the default <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-U">
+<code class="descname">-U</code><code class="descclassname">  uses</code><a class="headerlink" href="#cmdoption-lmtpd-U" title="Permalink to this definition">¶</a></dt>
+<dd><p>The maximum number of times that the process should be used for new
+connections before shutting down.  The default is 250.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-T">
+<code class="descname">-T</code><code class="descclassname">  timeout</code><a class="headerlink" href="#cmdoption-lmtpd-T" title="Permalink to this definition">¶</a></dt>
+<dd><p>The number of seconds that the process will wait for a new
+connection before shutting down.  Note that a value of 0 (zero)
+will disable the timeout.  The default is 60.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-D">
+<code class="descname">-D</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtpd-D" title="Permalink to this definition">¶</a></dt>
+<dd><p>Run external debugger specified in debug_command.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-lmtpd-a">
+<code class="descname">-a</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtpd-a" title="Permalink to this definition">¶</a></dt>
+<dd><p>Preauthorize connections initiated on an internet socket, instead
+of requiring LMTP AUTH.  This should only be used for connections
+coming from trusted hosts.</p>
+</dd></dl>
+
+</div>
+<div class="section" id="examples">
+<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
+<p><strong>lmtpd</strong> is commonly included in the SERVICES section of
+<a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> like so:</p>
+<pre class="literal-block">
+SERVICES {
+    imap        cmd=&quot;imapd -U 30&quot; listen=&quot;imap&quot; prefork=0
+    imaps       cmd=&quot;imapd -s -U 30&quot; listen=&quot;imaps&quot; prefork=0 maxchild=100
+    <strong>lmtpunix    cmd=&quot;lmtpd&quot; listen=&quot;/var/run/cyrus/socket/lmtp&quot; prefork=0 maxchild=20</strong>
+    sieve       cmd=&quot;timsieved&quot; listen=&quot;sieve&quot; prefork=0
+    notify      cmd=&quot;notifyd&quot; listen=&quot;/var/run/cyrus/socket/notify&quot; proto=&quot;udp&quot; prefork=1
+    httpd       cmd=&quot;httpd&quot; listen=8080 prefork=1 maxchild=20
+}
+</pre>
+</div>
+<div class="section" id="files">
+<h2>Files<a class="headerlink" href="#files" title="Permalink to this headline">¶</a></h2>
+<p>/etc/imapd.conf</p>
+</div>
+<div class="section" id="see-also">
+<h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>,
+<a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a></p>
+</div>
 </div>
 
 
@@ -789,7 +884,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +904,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/proxyd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/proxyd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/proxyd.html	2019-12-16 04:18:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/proxyd.html	2020-05-04 04:13:27.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>proxyd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>proxyd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ptdump" href="ptdump.html"/>
         <link rel="prev" title="pop3proxyd" href="pop3proxyd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/proxyd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/proxyd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,31 +787,114 @@
             
   <div class="section" id="proxyd">
 <span id="imap-reference-manpages-systemcommands-proxyd"></span><span id="std:cyrusman-proxyd(8)"></span><h1><strong>proxyd</strong><a class="headerlink" href="#proxyd" title="Permalink to this headline">¶</a></h1>
-<p>In Progress</p>
+<p>Proxyd is a symlink to <a class="reference internal" href="imapd.html#std:cyrusman-imapd(8)">imapd(8)</a> if you build with murder enabled.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>proxyd</strong> [ <strong>-C</strong> <em>config-file</em> ]
+<strong>imapd</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-U</strong> <em>uses</em> ] [ <strong>-T</strong> <em>timeout</em> ] [ <strong>-D</strong> ]
+    [ <strong>-s</strong> ] [ <strong>-N</strong> ] [ <strong>-p</strong> <em>ssf</em> ]
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
+<p><strong>imapd</strong> is an IMAP4rev1 server.  It accepts commands on its standard
+input and responds on its standard output.  It MUST be invoked by
+<a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a> with those descriptors attached to a remote client
+connection.</p>
+<p><strong>imapd</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
+<p>If the file <code class="docutils literal"><span class="pre">msg/shutdown</span></code> is created under the directory specified in
+the <code class="docutils literal"><span class="pre">configdirectory</span></code> configuration option, then <strong>imapd</strong> will shut
+down the connection, sending the first line contained in the file to the
+client as the reason.  New connections are denied.</p>
+<p>If the file <code class="docutils literal"><span class="pre">msg/motd</span></code> is created under the directory specified in the
+<code class="docutils literal"><span class="pre">configdirectory</span></code> configuration option, then <strong>imapd</strong> will send the
+first line contained in the file to clients upon connect as an ALERT
+message which IMAP-compliant clients are required to display.</p>
+<p>This option serves to annoy users mostly.  Unfortunately clients tend to
+connect far more frequently than is apparent, generating a separate
+server ALERT for each connection.  Many clients do not display these
+properly, if they do anything with them at all.</p>
+<p>If the directory <code class="docutils literal"><span class="pre">log</span></code>/<em>user</em> exists under the directory specified in
+the <code class="docutils literal"><span class="pre">configdirectory</span></code> configuration option, then <strong>imapd</strong> will create
+protocol telemetry logs for sessions authenticating as <em>user</em>.</p>
+<p>The telemetry logs will be stored in the <code class="docutils literal"><span class="pre">log</span></code>/<em>user</em> directory with
+a filename of the <strong>imapd</strong> process-id.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-proxyd-C">
-<code class="descname">-C</code><code class="descclassname"> config-file</code><a class="headerlink" href="#cmdoption-proxyd-C" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imapd-C">
+<code class="descname">-C</code><code class="descclassname"> config-file</code><a class="headerlink" href="#cmdoption-imapd-C" title="Permalink to this definition">¶</a></dt>
 <dd><p>Use the specified configuration file <em>config-file</em> rather than the default <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>.</p>
 </dd></dl>
 
-<p>/etc/imapd.conf,
-/etc/cyrus.conf</p>
+<dl class="option">
+<dt id="cmdoption-imapd-U">
+<code class="descname">-U</code><code class="descclassname">  uses</code><a class="headerlink" href="#cmdoption-imapd-U" title="Permalink to this definition">¶</a></dt>
+<dd><p>The maximum number of times that the process should be used for new
+connections before shutting down.  The default is 250.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imapd-T">
+<code class="descname">-T</code><code class="descclassname">  timeout</code><a class="headerlink" href="#cmdoption-imapd-T" title="Permalink to this definition">¶</a></dt>
+<dd><p>The number of seconds that the process will wait for a new
+connection before shutting down.  Note that a value of 0 (zero)
+will disable the timeout.  The default is 60.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imapd-D">
+<code class="descname">-D</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imapd-D" title="Permalink to this definition">¶</a></dt>
+<dd><p>Run external debugger specified in debug_command.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imapd-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imapd-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Serve IMAP over SSL (imaps).  All data to and from <strong>imapd</strong> is
+encrypted using the Secure Sockets Layer.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imapd-N">
+<code class="descname">-N</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imapd-N" title="Permalink to this definition">¶</a></dt>
+<dd><p>Bypass password checking.  (Not recommended unless you know what
+you&#8217;re doing.)</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imapd-p">
+<code class="descname">-p</code><code class="descclassname">  ssf</code><a class="headerlink" href="#cmdoption-imapd-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Tell <strong>imapd</strong> that an external layer exists.  An <em>SSF</em> (security
+strength factor) of 1 means an integrity protection layer exists.
+Any higher SSF implies some form of privacy protection.</p>
+</dd></dl>
+
+</div>
+<div class="section" id="examples">
+<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
+<p><strong>imapd</strong> is commonly included in the SERVICES section of
+<a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> like so:</p>
+<pre class="literal-block">
+SERVICES {
+    <strong>imap        cmd=&quot;imapd -U 30&quot; listen=&quot;imap&quot; prefork=0</strong>
+    <strong>imaps       cmd=&quot;imapd -s -U 30&quot; listen=&quot;imaps&quot; prefork=0 maxchild=100</strong>
+    lmtpunix    cmd=&quot;lmtpd&quot; listen=&quot;/var/run/cyrus/socket/lmtp&quot; prefork=0 maxchild=20
+    sieve       cmd=&quot;timsieved&quot; listen=&quot;sieve&quot; prefork=0
+    notify      cmd=&quot;notifyd&quot; listen=&quot;/var/run/cyrus/socket/notify&quot; proto=&quot;udp&quot; prefork=1
+    httpd       cmd=&quot;httpd&quot; listen=8080 prefork=1 maxchild=20
+}
+</pre>
+</div>
+<div class="section" id="files">
+<h2>Files<a class="headerlink" href="#files" title="Permalink to this headline">¶</a></h2>
+<p>/etc/imapd.conf</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
 <p><a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>,
-<a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a></p>
+<a class="reference internal" href="master.html#std:cyrusman-master(8)">master(8)</a></p>
 </div>
 </div>
 
@@ -814,7 +916,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +936,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptdump.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptdump.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptdump.html	2019-12-16 04:18:04.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptdump.html	2020-05-04 04:13:28.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ptdump &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ptdump &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ptexpire" href="ptexpire.html"/>
         <link rel="prev" title="proxyd" href="proxyd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ptdump.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ptdump.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -818,7 +837,7 @@ cache.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -838,7 +857,7 @@ cache.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptexpire.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptexpire.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptexpire.html	2019-12-16 04:18:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptexpire.html	2020-05-04 04:13:28.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ptexpire &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ptexpire &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="ptloader" href="ptloader.html"/>
         <link rel="prev" title="ptdump" href="ptdump.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ptexpire.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ptexpire.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -826,7 +845,7 @@ Default: 3 hours</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -846,7 +865,7 @@ Default: 3 hours</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptloader.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptloader.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/ptloader.html	2019-12-16 04:18:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/ptloader.html	2020-05-04 04:13:28.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>ptloader &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>ptloader &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="quota" href="quota.html"/>
         <link rel="prev" title="ptexpire" href="ptexpire.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/ptloader.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/ptloader.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -779,7 +798,7 @@ ptloader [<strong>-d</strong>]
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
 <p><strong>ptloader</strong> interacts with the authorization service, either AFS or
 LDAP, providing group membership information to Cyrus.  When
-<code class="docutils literal"><span class="pre">auth_mech:</span> <span class="pre">pts</span></code> is set in <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, <strong>ptsloader</strong>
+<code class="docutils literal"><span class="pre">auth_mech:</span> <span class="pre">pts</span></code> is set in <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, <strong>ptloader</strong>
 will then consult the backend specified in the <code class="docutils literal"><span class="pre">pts_module</span></code> setting
 (currently either <code class="docutils literal"><span class="pre">afs</span></code> or <code class="docutils literal"><span class="pre">ldap</span></code>).</p>
 <p><strong>ptloader</strong> reads its configuration options out of the
@@ -822,7 +841,7 @@ will then consult the backend specified
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 30 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -842,7 +861,7 @@ will then consult the backend specified
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/quota.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/quota.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/quota.html	2019-12-16 04:18:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/quota.html	2020-05-04 04:13:29.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>quota &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>quota &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="reconstruct" href="reconstruct.html"/>
         <link rel="prev" title="ptloader" href="ptloader.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/quota.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/quota.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -772,7 +791,7 @@
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>quota</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-d</strong> <em>domain</em> ] [ <strong>-f</strong> ] [ <em>mailbox-prefix</em>... ]
+<strong>quota</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-d</strong> <em>domain</em> ] [ <strong>-f</strong> ] [ <strong>-u</strong> ] [ <em>mailbox-spec</em>... ]
 </pre>
 </div>
 <div class="section" id="description">
@@ -785,12 +804,15 @@ quota root or quota roots with the wrong
 <p>If an optional <em>domain</em> is specified with the <strong>-d</strong> option, the quota
 listing (and any inconsistency fixing) is performed only in that domain
 rather than all mailboxes.</p>
-<p>If one or more <em>mailbox-prefix</em> arguments are specified, the quota
-listing (and inconsistency fixing) is limited to quota roots with names
-that start with one of the given prefixes.</p>
+<p>If one or more <em>mailbox-spec</em> arguments are specified, these are interpreted
+as mailbox prefixes, and the quota listing (and inconsistency fixing) is
+limited to quota roots with names that start with one of the given prefixes.
+If the <strong>-u</strong> is provided, <em>mailbox-spec</em> arguments are instead interpreted
+as userids, and the quota listing (and inconsistency fixing) is limited to
+quota roots for only the specified users.</p>
 <div class="admonition warning">
 <p class="first admonition-title">Warning</p>
-<p class="last">Running <strong>quota</strong> with both the <strong>-f</strong> option and <em>mailbox-prefix</em>
+<p class="last">Running <strong>quota</strong> with both the <strong>-f</strong> option and <em>mailbox-spec</em>
 arguments is not recommended.</p>
 </div>
 <p><strong>quota</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
@@ -817,6 +839,13 @@ report.</p>
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-quota-n">
+<code class="descname">-n</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-quota-n" title="Permalink to this definition">¶</a></dt>
+<dd><p>Check for any inconsistencies in the quota subsystem but don&#8217;t actually
+fix them.  Use with <strong>-f</strong> and <strong>-q</strong> to only see what&#8217;s incorrect.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-quota-q">
 <code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-quota-q" title="Permalink to this definition">¶</a></dt>
 <dd><p>Operate quietly. If <strong>-f</strong> is specified, then don&#8217;t print the quota
@@ -830,10 +859,17 @@ values, only print messages when things
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-quota-arg-mailbox-prefix">
-<code class="descname">mailbox-prefix</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-quota-arg-mailbox-prefix" title="Permalink to this definition">¶</a></dt>
-<dd><p>Only report and/or fix quota in mailboxes starting with the
-specified <em>mailbox-prefix</em>.</p>
+<dt id="cmdoption-quota-u">
+<code class="descname">-u</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-quota-u" title="Permalink to this definition">¶</a></dt>
+<dd><p>Interpret <em>mailbox-spec</em> arguments as userids.  The default is to
+interpret them as mailbox prefixes</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-quota-arg-mailbox-spec">
+<code class="descname">mailbox-spec</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-quota-arg-mailbox-spec" title="Permalink to this definition">¶</a></dt>
+<dd><p>Only report and/or fix quota in mailboxes matching the specified
+<em>mailbox-spec</em> arguments.  See also <strong>-u</strong>.</p>
 </dd></dl>
 
 </div>
@@ -888,7 +924,7 @@ specified <em>mailbox-prefix</em>.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 13 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -908,7 +944,7 @@ specified <em>mailbox-prefix</em>.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/reconstruct.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/reconstruct.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/reconstruct.html	2019-12-16 04:18:05.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/reconstruct.html	2020-05-04 04:13:29.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>reconstruct &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>reconstruct &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="rehash" href="rehash.html"/>
         <link rel="prev" title="quota" href="quota.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -774,7 +793,7 @@
 <pre class="literal-block">
 <strong>reconstruct</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-p</strong> <em>partition</em> ] [ <strong>-x</strong> ] [ <strong>-r</strong> ]
     [ <strong>-f</strong> ] [ <strong>-U</strong> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ] [ <strong>-G</strong> ] [ <strong>-R</strong> ] [ <strong>-o</strong> ]
-    [ <strong>-O</strong> ] [ <strong>-M</strong> ] <em>mailbox</em>...
+    [ <strong>-O</strong> ] [ <strong>-M</strong> ] [ <strong>-V</strong> <em>version</em> ] <em>mailbox</em>...
 
 <strong>reconstruct</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-p</strong> <em>partition</em> ] [ <strong>-x</strong> ] [ <strong>-r</strong> ]
     [ <strong>-f</strong> ] [ <strong>-U</strong> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ] [ <strong>-G</strong> ] [ <strong>-R</strong> ] [ <strong>-o</strong> ]
@@ -854,7 +873,7 @@ restoring mailboxes from backups.</p>
 <code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-reconstruct-s" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t stat underlying files.  This makes reconstruct run faster, at
 the expense of not noticing some issues (like zero byte files or
-size mistmatches).  &#8220;<strong>reconstruct -s</strong>&#8221; should be quite fast.</p>
+size mismatches).  &#8220;<strong>reconstruct -s</strong>&#8221; should be quite fast.</p>
 </dd></dl>
 
 <dl class="option">
@@ -998,7 +1017,7 @@ files.</div></blockquote>
 <strong>reconstruct -r -f -u</strong> <em>jsmith</em>
 </pre>
 <blockquote>
-<div>Recusively reconstruct all mailboxes belonging to <em>jsmith</em>,
+<div>Recursively reconstruct all mailboxes belonging to <em>jsmith</em>,
 restoring any directories containing <code class="docutils literal"><span class="pre">cyrus.header</span></code> files.</div></blockquote>
 <div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">user</span><span class="o">.</span><span class="n">jsmith</span>
 <span class="n">user</span><span class="o">.</span><span class="n">jsmith</span><span class="o">.</span><span class="n">Archive</span>
@@ -1046,7 +1065,7 @@ deprecated in Cyrus version 2.4.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 27 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1066,7 +1085,7 @@ deprecated in Cyrus version 2.4.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/rehash.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/rehash.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/rehash.html	2019-12-16 04:18:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/rehash.html	2020-05-04 04:13:29.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>rehash &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>rehash &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="restore" href="restore.html"/>
         <link rel="prev" title="reconstruct" href="reconstruct.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/rehash.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/rehash.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -821,7 +840,7 @@ verbose is always turned on in no-change
 
 <dl class="option">
 <dt id="cmdoption-rehash-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-rehash-i" title="Permalink to this definition">¶</a></dt>
+<code class="descname">-i</code><code class="descclassname"> | -I</code><a class="headerlink" href="#cmdoption-rehash-i" title="Permalink to this definition">¶</a></dt>
 <dd><div class="line-block">
 <div class="line">-i forces hashimapspool: no</div>
 <div class="line">-I forces hashimapspool: yes</div>
@@ -857,7 +876,7 @@ verbose is always turned on in no-change
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jul 05 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 27 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -877,7 +896,7 @@ verbose is always turned on in no-change
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/restore.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/restore.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/restore.html	2019-12-16 04:18:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/restore.html	2020-05-04 04:13:30.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>restore &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>restore &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sievec" href="sievec.html"/>
         <link rel="prev" title="rehash" href="rehash.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/restore.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/restore.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -1029,7 +1048,7 @@ the specified user.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Dec 04 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1049,7 +1068,7 @@ the specified user.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sievec.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sievec.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sievec.html	2019-12-16 04:18:06.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sievec.html	2020-05-04 04:13:30.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sievec &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sievec &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sieved" href="sieved.html"/>
         <link rel="prev" title="restore" href="restore.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/sievec.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/sievec.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -812,7 +831,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 13 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 13 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -832,7 +851,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sieved.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sieved.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sieved.html	2019-12-16 04:18:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sieved.html	2020-05-04 04:13:31.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sieved &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sieved &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="smmapd" href="smmapd.html"/>
         <link rel="prev" title="sievec" href="sievec.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/sieved.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/sieved.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -806,7 +825,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 13 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 13 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -826,7 +845,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/smmapd.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/smmapd.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/smmapd.html	2019-12-16 04:18:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/smmapd.html	2020-05-04 04:13:31.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>smmapd &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>smmapd &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="squatter" href="squatter.html"/>
         <link rel="prev" title="sieved" href="sieved.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/smmapd.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/smmapd.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -816,6 +835,19 @@ will disable the timeout.  The default i
 </div>
 <div class="section" id="examples">
 <h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
+<p><strong>smmapd</strong> is commonly included in the SERVICES section of
+<a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a> like so:</p>
+<pre class="literal-block">
+SERVICES {
+    imap        cmd=&quot;imapd -U 30&quot; listen=&quot;imap&quot; prefork=0
+    imaps       cmd=&quot;imapd -s -U 30&quot; listen=&quot;imaps&quot; prefork=0 maxchild=100
+    lmtpunix    cmd=&quot;lmtpd&quot; listen=&quot;/var/run/cyrus/socket/lmtp&quot; prefork=0 maxchild=20
+    <strong>smmap       cmd=&quot;smmapd&quot; listen=&quot;/var/run/cyrus/socket/smmap&quot; prefork=0</strong>
+    sieve       cmd=&quot;timsieved&quot; listen=&quot;sieve&quot; prefork=0
+    notify      cmd=&quot;notifyd&quot; listen=&quot;/var/run/cyrus/socket/notify&quot; proto=&quot;udp&quot; prefork=1
+    httpd       cmd=&quot;httpd&quot; listen=8080 prefork=1 maxchild=20
+}
+</pre>
 </div>
 <div class="section" id="files">
 <h2>Files<a class="headerlink" href="#files" title="Permalink to this headline">¶</a></h2>
@@ -847,7 +879,7 @@ will disable the timeout.  The default i
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Dec 13 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -867,7 +899,7 @@ will disable the timeout.  The default i
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/squatter.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/squatter.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/squatter.html	2019-12-16 04:18:07.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/squatter.html	2020-05-04 04:13:31.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>squatter &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>squatter &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sync_client" href="sync_client.html"/>
         <link rel="prev" title="smmapd" href="smmapd.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/squatter.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/squatter.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -776,13 +795,12 @@ general:
 <strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [<strong>mode</strong>] [<strong>options</strong>] [<strong>source</strong>]
 
 i.e.:
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-S</strong> <em>seconds</em> ]
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-i</strong> ] [ <strong>-N</strong> <em>name</em> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-r</strong> ]  <em>mailbox</em>...
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-i</strong> ] [ <strong>-N</strong> <em>name</em> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-r</strong> ]  <strong>-u</strong> <em>user</em>...
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] <strong>-R</strong> [ <strong>-n</strong> <em>channel</em> ] [ <strong>-d</strong> ] [ <strong>-S</strong> <em>seconds</em> ]
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] <strong>-f</strong> <em>synclogfile</em> [ <strong>-S</strong> <em>seconds</em> ]
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] <strong>-I</strong> <em>file</em>
-<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] <strong>-t</strong> <em>srctier(s)</em>... <strong>-z</strong> <em>desttier</em> [ <strong>-F</strong> ] [ <strong>-T</strong> <em>dir</em> ] [ <strong>-X</strong> ] [ <strong>-o</strong> ]  [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-u</strong> <em>user</em>... ]
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-Z</strong> ]
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-i</strong> ] [ <strong>-N</strong> <em>name</em> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-r</strong> ] [ <strong>-Z</strong> ] <em>mailbox</em>...
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] [ <strong>-i</strong> ] [ <strong>-N</strong> <em>name</em> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-r</strong> ] [ <strong>-Z</strong> ] <strong>-u</strong> <em>user</em>...
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] <strong>-R</strong> [ <strong>-n</strong> <em>channel</em> ] [ <strong>-d</strong> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-Z</strong> ]
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] [ <strong>-a</strong> ] <strong>-f</strong> <em>synclogfile</em> [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-Z</strong> ]
+<strong>squatter</strong> [ <strong>-C</strong> <em>config-file</em> ] [ <strong>-v</strong> ] <strong>-t</strong> <em>srctier(s)</em>... <strong>-z</strong> <em>desttier</em> [ <strong>-F</strong> ] [ <strong>-U</strong> ] [ <strong>-T</strong> <em>dir</em> ] [ <strong>-X</strong> ] [ <strong>-o</strong> ] [ <strong>-S</strong> <em>seconds</em> ] [ <strong>-u</strong> <em>user</em>... ]
 </pre>
 </div>
 <div class="section" id="description">
@@ -802,7 +820,7 @@ which search engine is used.</p>
 The index is a unified index of all of the header and body text
 of each message in a given mailbox.  This index is used to significantly
 reduce IMAP SEARCH times on a mailbox.</p>
-<p><strong>mode</strong> is one of indexer, indexfrom (-I), search, rolling, synclog or compact.</p>
+<p><strong>mode</strong> is one of indexer, search, rolling, synclog, compact or audit.</p>
 <p>By default, <strong>squatter</strong> creates an index of ALL messages in the
 mailbox, not just those since the last time that it was run.  The
 <strong>-i</strong> option is used to select incremental updates.  Any messages
@@ -829,17 +847,24 @@ affected mailbox (see notes, below).</p>
 <p>In the fifth synopsis, <strong>squatter</strong> reads a single sync log file and
 performs incremental indexing on the mailbox(es) listed therein.  This
 is sometimes useful for cleaning up after problems with rolling mode.</p>
-<p>In the sixth synopsis, <strong>squatter</strong> reads <em>file</em> containing <em>mailbox</em>
-<em>uid</em> tuples and performs indexing on the specified messages.</p>
-<p>In the seventh synopsis, <strong>squatter</strong> will compact indices from
+<p>In the sixth synopsis, <strong>squatter</strong> will compact indices from
 <em>srctier(s)</em> to <em>desttier</em>, optionally reindexing (<strong>-X</strong>) or filtering
-expunged records (<strong>-F</strong>) in the process.  The optional <strong>-T</strong> flag may
-be used to specify a directory to use for temporary files.  The <strong>-o</strong>
-flag may be used to direct that a single index be copied, rather than
-compacted, from <em>srctier</em> to <em>desttier</em>.  The <strong>-u</strong> flag may be used
-to restrict operation to the specified user(s).</p>
-<p>For all modes, the <strong>-S</strong> option may be specified, causing squatter to
+expunged records (<strong>-F</strong>) in the process.  The optional <strong>-T</strong> flag may be
+used to specify a directory to use for temporary files.  These files are
+eventually copied with <cite>rsync -a</cite> and then removed by <cite>rm</cite>.
+<cite>rsync</cite> can increase the load average of the system, especially when the
+temporary directory is on <cite>tmpfs</cite>.  To throttle <cite>rsync</cite> it is possible to
+modify the call in <cite>imap/search_xapian.c</cite> and pass <cite>-\-bwlimit=&lt;number&gt;</cite> as further
+parameter.  The <strong>-o</strong> flag may be used to direct that a single index be
+copied, rather than compacted, from <em>srctier</em> to <em>desttier</em>.  The <strong>-u</strong> flag
+may be used to restrict operation to the specified user(s).</p>
+<p>For all modes, the <strong>-S</strong> option may be specified, causing <strong>squatter</strong> to
 pause <em>seconds</em> seconds after each mailbox, to smooth loads.</p>
+<p>When using the Xapian engine the <strong>-Z</strong> option may be specified, for
+the indexing modes.  This tells <strong>squatter</strong> to consult the Xapian
+internally indexed GUIDs, rather than relying on what&#8217;s stored in
+<cite>cyrus.indexed.db</cite>, allowing for recovery from broken
+<cite>cyrus.indexed.db</cite> at the sacrifice of efficiency.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p class="last">Incremental updates are very inefficient with the SQUAT search
@@ -877,6 +902,13 @@ implicit value of <em>/vendor/cmu/cyrus-
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-squatter-A">
+<code class="descname">-A</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-A" title="Permalink to this definition">¶</a></dt>
+<dd><p>Missing documentation, starts audit mode.
+This feature is only available on the master branch.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-squatter-d">
 <code class="descname">-d</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-d" title="Permalink to this definition">¶</a></dt>
 <dd><p>In rolling mode, don&#8217;t background and do emit log messages on
@@ -908,13 +940,6 @@ This feature was introduced in version 3
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-squatter-I">
-<code class="descname">-I</code><code class="descclassname"> file</code><a class="headerlink" href="#cmdoption-squatter-I" title="Permalink to this definition">¶</a></dt>
-<dd><p>Read from <em>file</em> and index individual messages described by
-mailbox/uid tuples contained therein.</p>
-</dd></dl>
-
-<dl class="option">
 <dt id="cmdoption-squatter-i">
 <code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Incremental updates where indexes already exist.</p>
@@ -946,6 +971,13 @@ This feature was introduced in version 3
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-squatter-P">
+<code class="descname">-P</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-P" title="Permalink to this definition">¶</a></dt>
+<dd><p>Missing documentation, reindex parts mode.
+This feature is only available on the master branch.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-squatter-R">
 <code class="descname">-R</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-R" title="Permalink to this definition">¶</a></dt>
 <dd><p>Run in rolling mode; <strong>squatter</strong> runs as a daemon listening to a
@@ -984,7 +1016,7 @@ This feature was introduced in version 3
 <dl class="option">
 <dt id="cmdoption-squatter-t">
 <code class="descname">-t</code><code class="descclassname"> srctier...</code><a class="headerlink" href="#cmdoption-squatter-t" title="Permalink to this definition">¶</a></dt>
-<dd><p>In compact mode, the comma separated source tier(s) for the compacted
+<dd><p>In compact mode, the comma-separated source tier(s) for the compacted
 indices.  At least one source tier must be specified in compact mode.
 Xapian only.
 This feature was introduced in version 3.0.</p>
@@ -999,6 +1031,14 @@ This feature was introduced in version 3
 </dd></dl>
 
 <dl class="option">
+<dt id="cmdoption-squatter-U">
+<code class="descname">-U</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-U" title="Permalink to this definition">¶</a></dt>
+<dd><p>In compact mode, only compact if re-indexing.
+Xapian only.
+This feature is only available on the master branch.</p>
+</dd></dl>
+
+<dl class="option">
 <dt id="cmdoption-squatter-v">
 <code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Increase the verbosity of progress/status messages.  Sometimes additional messages
@@ -1026,6 +1066,17 @@ Xapian only.
 This feature was introduced in version 3.0.</p>
 </dd></dl>
 
+<dl class="option">
+<dt id="cmdoption-squatter-Z">
+<code class="descname">-Z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-squatter-Z" title="Permalink to this definition">¶</a></dt>
+<dd><p>When indexing messages, use the Xapian internal cyrusid rather than
+referencing the ranges of already indexed messages to know if a
+particular message is indexed.  Useful if the ranges get out of
+sync with the actual messages (e.g. if files on a tier are lost)
+Xapian only.
+This feature is only available on the master branch.</p>
+</dd></dl>
+
 </div>
 <div class="section" id="examples">
 <h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
@@ -1115,6 +1166,7 @@ Xapian documentation in this release bef
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
 <p><a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a>, <a class="reference internal" href="../configs/cyrus.conf.html#std:cyrusman-cyrus.conf(5)">cyrus.conf(5)</a></p>
+<p><a class="reference internal" href="../../../developer/install-xapian.html#configuring-xapian"><span class="std std-ref">Configuring Xapian</span></a></p>
 </div>
 </div>
 
@@ -1136,7 +1188,7 @@ Xapian documentation in this release bef
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 06 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 29 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1156,7 +1208,7 @@ Xapian documentation in this release bef
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_client.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_client.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_client.html	2019-12-16 04:18:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_client.html	2020-05-04 04:13:32.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sync_client &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sync_client &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sync_reset" href="sync_reset.html"/>
         <link rel="prev" title="squatter" href="squatter.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/sync_client.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/sync_client.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -995,7 +1014,7 @@ section of <a class="reference internal"
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 18 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 18 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1015,7 +1034,7 @@ section of <a class="reference internal"
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_reset.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_reset.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_reset.html	2019-12-16 04:18:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_reset.html	2020-05-04 04:13:32.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sync_reset &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sync_reset &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sync_server" href="sync_server.html"/>
         <link rel="prev" title="sync_client" href="sync_client.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -778,7 +797,7 @@
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
 <p><strong>sync_reset</strong> is a small utility program to destroy user accounts on a
-system.  The only safeguard which is in place is the obligary force
+system.  The only safeguard which is in place is the obligatory force
 option.</p>
 <p><strong>sync_reset</strong> reads its configuration options out of the <a class="reference internal" href="../configs/imapd.conf.html#std:cyrusman-imapd.conf(5)">imapd.conf(5)</a> file unless specified otherwise by <strong>-C</strong>.</p>
 </div>
@@ -833,7 +852,7 @@ autorepeat.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -853,7 +872,7 @@ autorepeat.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_server.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_server.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/sync_server.html	2019-12-16 04:18:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/sync_server.html	2020-05-04 04:13:32.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sync_server &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sync_server &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="timsieved" href="timsieved.html"/>
         <link rel="prev" title="sync_reset" href="sync_reset.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/sync_server.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/sync_server.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -849,7 +868,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -869,7 +888,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/timsieved.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/timsieved.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/timsieved.html	2019-12-16 04:18:08.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/timsieved.html	2020-05-04 04:13:33.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>timsieved &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>timsieved &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="tls_prune" href="tls_prune.html"/>
         <link rel="prev" title="sync_server" href="sync_server.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/timsieved.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/timsieved.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -843,7 +862,7 @@ SERVICES {
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -863,7 +882,7 @@ SERVICES {
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/tls_prune.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/tls_prune.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/tls_prune.html	2019-12-16 04:18:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/tls_prune.html	2020-05-04 04:13:33.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>tls_prune &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>tls_prune &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="translatesieve" href="translatesieve.html"/>
         <link rel="prev" title="timsieved" href="timsieved.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/tls_prune.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/tls_prune.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -825,7 +844,7 @@ database.  The lifetime of a TLS session
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -845,7 +864,7 @@ database.  The lifetime of a TLS session
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/translatesieve.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/translatesieve.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/translatesieve.html	2019-12-16 04:18:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/translatesieve.html	2020-05-04 04:13:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>translatesieve &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>translatesieve &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="unexpunge" href="unexpunge.html"/>
         <link rel="prev" title="tls_prune" href="tls_prune.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/translatesieve.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/translatesieve.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -856,7 +875,7 @@ be changed.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -876,7 +895,7 @@ be changed.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/unexpunge.html 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/unexpunge.html
--- 3.0.13-5/doc/html/imap/reference/manpages/systemcommands/unexpunge.html	2019-12-16 04:18:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/systemcommands/unexpunge.html	2020-05-04 04:13:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>unexpunge &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>unexpunge &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="arbitronsort.pl" href="../usercommands/arbitronsort.pl.html"/>
         <link rel="prev" title="translatesieve" href="translatesieve.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/systemcommands/unexpunge.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/systemcommands/unexpunge.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -999,7 +1018,7 @@ option in <a class="reference internal"
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 05 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1019,7 +1038,7 @@ option in <a class="reference internal"
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/arbitronsort.pl.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/arbitronsort.pl.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/arbitronsort.pl.html	2019-12-16 04:18:09.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/arbitronsort.pl.html	2020-05-04 04:13:34.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>arbitronsort.pl &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>arbitronsort.pl &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="dav_reconstruct" href="dav_reconstruct.html"/>
         <link rel="prev" title="unexpunge" href="../systemcommands/unexpunge.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/arbitronsort.pl.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/arbitronsort.pl.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -814,7 +833,7 @@ and prints out:</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 08 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +853,7 @@ and prints out:</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/dav_reconstruct.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/dav_reconstruct.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/dav_reconstruct.html	2019-12-16 04:18:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/dav_reconstruct.html	2020-05-04 04:13:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>dav_reconstruct &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>dav_reconstruct &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="httptest" href="httptest.html"/>
         <link rel="prev" title="arbitronsort.pl" href="arbitronsort.pl.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/dav_reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/dav_reconstruct.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -827,7 +846,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Sep 05 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -847,7 +866,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/httptest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/httptest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/httptest.html	2019-12-16 04:18:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/httptest.html	2020-05-04 04:13:35.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>httptest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>httptest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="imtest" href="imtest.html"/>
         <link rel="prev" title="dav_reconstruct" href="dav_reconstruct.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/httptest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/httptest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,76 +788,84 @@
   <div class="section" id="httptest">
 <span id="imap-reference-manpages-usercommands-httptest"></span><span id="std:cyrusman-httptest(1)"></span><h1><strong>httptest</strong><a class="headerlink" href="#httptest" title="Permalink to this headline">¶</a></h1>
 <p>Interactive HTTP test program.</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send HTTP commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>httptest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ]
-    [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ]
-    [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
-<p><strong>httptest</strong> is a utility that allows you to authenticate to a
-HTTP server and interactively issue requests to it. Once
-authenticated you may issue any HTTP request by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an http server. Also those developing HTTP clients
-find it useful.</p>
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-httptest-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-httptest-t" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
 Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
 authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-httptest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>http</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-httptest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>httptest</strong> to use <em>mechanism</em> for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify one of <em>Basic</em>, <em>Digest</em>, <em>NTLM</em>, or
-<em>Negotiate</em> (GSS-SPNEGO).</p>
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
+specified the strongest authentication mechanism supported by the
+server is chosen.  Specify <em>login</em> to use the LOGIN command instead
+of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-httptest-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-httptest-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">This is only used with SASL mechanisms that allow proxying
+(e.g. PLAIN, DIGEST-MD5).</p>
+</div>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-httptest-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-httptest-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -847,62 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-httptest-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-httptest-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-httptest-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-s">
-<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-httptest-s" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable HTTP over SSL (https).</p>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-httptest-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-httptest-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-httptest-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-w">
-<code class="descname">-w</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-httptest-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-httptest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-httptest-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -912,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><a class="reference internal" href="../systemcommands/httpd.html#std:cyrusman-httpd(8)">httpd(8)</a></p>
 </div>
 </div>
@@ -934,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 10 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -954,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/imtest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/imtest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/imtest.html	2019-12-16 04:18:10.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/imtest.html	2020-05-04 04:13:36.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>imtest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>imtest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="installsieve" href="installsieve.html"/>
         <link rel="prev" title="httptest" href="httptest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/imtest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/imtest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,7 +787,7 @@
             
   <span class="target" id="std:cyrusman-imtest(1)"></span><div class="section" id="imtest">
 <span id="imap-reference-manpages-usercommands-imtest"></span><h1><strong>imtest</strong><a class="headerlink" href="#imtest" title="Permalink to this headline">¶</a></h1>
-<p>Interactive IMAP test program</p>
+<p>Interactive IMAP test program.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
@@ -876,7 +895,7 @@ attempt to do SSL/TLS session reuse and/
 <dl class="option">
 <dt id="cmdoption-imtest-s">
 <code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable IMAP over SSL (imaps).</p>
+<dd><p>Enable SSL over chosen protocol.</p>
 </dd></dl>
 
 <dl class="option">
@@ -971,7 +990,7 @@ with -X).</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -991,7 +1010,7 @@ with -X).</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/installsieve.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/installsieve.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/installsieve.html	2019-12-16 04:18:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/installsieve.html	2020-05-04 04:13:36.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>installsieve &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>installsieve &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="lmtptest" href="lmtptest.html"/>
         <link rel="prev" title="imtest" href="imtest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/installsieve.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/installsieve.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -815,9 +834,7 @@ defined in <code class="docutils literal
 <code class="descname">-i</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-installsieve-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Install a file onto the server. If a script with the same name
 already exists on the server it is overwritten. Upon successfully
-putting the script on the server the script is set active. If
-<em>file</em> has the extension .script it is chopped when put on the
-server since sieve names may not contain a &#8216;.&#8217;.</p>
+putting the script on the server the script is set active.</p>
 </dd></dl>
 
 <dl class="option">
@@ -889,7 +906,7 @@ user.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 07 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 14 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -909,7 +926,7 @@ user.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/lmtptest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/lmtptest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/lmtptest.html	2019-12-16 04:18:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/lmtptest.html	2020-05-04 04:13:37.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>lmtptest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>lmtptest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="mupdatetest" href="mupdatetest.html"/>
         <link rel="prev" title="installsieve" href="installsieve.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/lmtptest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/lmtptest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,63 +788,65 @@
   <span class="target" id="std:cyrusman-lmtptest(1)"></span><div class="section" id="lmtptest">
 <span id="imap-reference-manpages-usercommands-lmtptest"></span><h1><strong>lmtptest</strong><a class="headerlink" href="#lmtptest" title="Permalink to this headline">¶</a></h1>
 <p>Interactive LMTP test program</p>
+<p>This is actually installed as a hard link to <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send LMTP commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>lmtptest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
     [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
-    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ]
-    [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p>This is actually installed as a hard link to <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
-<p><strong>lmtptest</strong> is a utility that allows you to authenticate to a LMTP server
-and interactively issue commands to it. Once authenticated you may
-issue any LMTP command by simply typing it in. It is capable
-of multiple SASL authentication mechanisms and handles encryption
-layers transparently. This utility is often used for testing the
-operation of a lmtp server. Also those developing LMTP clients
-find it useful.</p>
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-lmtptest-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-lmtptest-t" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
 Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
 authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-lmtptest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>lmtp</strong> as defined
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
 in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-lmtptest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>lmtptest</strong> to use <em>mechanism</em> for authentication. If not
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
 specified the strongest authentication mechanism supported by the
 server is chosen.  Specify <em>login</em> to use the LOGIN command instead
 of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-lmtptest-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
 This is the userid whose password or credentials will be presented to
 the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-lmtptest-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
@@ -837,14 +858,14 @@ authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-lmtptest-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-lmtptest-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -853,56 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-lmtptest-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-lmtptest-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-lmtptest-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtptest-c" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
 to ask for the the one-time password instead of the secret pass-phrase
 (library generates the correct response).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtptest-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-lmtptest-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-lmtptest-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-lmtptest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-lmtptest-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -912,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><a class="reference internal" href="../systemcommands/lmtpd.html#std:cyrusman-lmtpd(8)">lmtpd(8)</a></p>
 </div>
 </div>
@@ -934,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -954,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/mupdatetest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/mupdatetest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/mupdatetest.html	2019-12-16 04:18:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/mupdatetest.html	2020-05-04 04:13:37.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>mupdatetest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>mupdatetest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="nntptest" href="nntptest.html"/>
         <link rel="prev" title="lmtptest" href="lmtptest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,53 +788,65 @@
   <span class="target" id="std:cyrusman-mupdatetest(1)"></span><div class="section" id="mupdatetest">
 <span id="imap-reference-manpages-usercommands-mupdatetest"></span><h1><strong>mupdatetest</strong><a class="headerlink" href="#mupdatetest" title="Permalink to this headline">¶</a></h1>
 <p>Interactive MUPDATE test program</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send MUPDATE commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>mupdatetest</strong> [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ]
-    [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ]
-    [ <strong>-q</strong> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p><strong>mupdatetest</strong> is a utility that allows you to authenticate to a
-MUPDATE server and interactively issue commands to it. Once
-authenticated you may issue any MUPDATE command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of a mupdate server. Note that you must be an admin in
-order to authenticate to an mupdate server.</p>
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-mupdatetest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-mupdatetest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>mupdate</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
+Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
+authentication.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-mupdatetest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>mupdatetest</strong> to use <em>mechanism</em> for authentication. If not
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
 specified the strongest authentication mechanism supported by the
 server is chosen.  Specify <em>login</em> to use the LOGIN command instead
 of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-mupdatetest-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-mupdatetest-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
@@ -827,14 +858,14 @@ authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-mupdatetest-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-mupdatetest-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -843,62 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-mupdatetest-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-mupdatetest-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-mupdatetest-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-q">
-<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mupdatetest-q" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable MUPDATE COMPRESSion (after authentication).</p>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mupdatetest-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mupdatetest-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-mupdatetest-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-mupdatetest-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-mupdatetest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-mupdatetest-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -908,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><a class="reference internal" href="../systemcommands/mupdate.html#std:cyrusman-mupdate(8)">mupdate(8)</a></p>
 </div>
 </div>
@@ -930,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -950,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/nntptest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/nntptest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/nntptest.html	2019-12-16 04:18:11.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/nntptest.html	2020-05-04 04:13:37.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>nntptest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>nntptest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="pop3test" href="pop3test.html"/>
         <link rel="prev" title="mupdatetest" href="mupdatetest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/nntptest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/nntptest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,164 +787,11 @@
             
   <span class="target" id="std:cyrusman-nntptest(1)"></span><div class="section" id="nntptest">
 <span id="imap-reference-manpages-usercommands-nntptest"></span><h1><strong>nntptest</strong><a class="headerlink" href="#nntptest" title="Permalink to this headline">¶</a></h1>
-<p>Interactive NNTP test program</p>
-<div class="section" id="synopsis">
-<h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
-<pre class="literal-block">
-<strong>nntptest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ]
-    [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ]
-    [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-q</strong> ]
-    [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
-</pre>
-</div>
-<div class="section" id="description">
-<h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p><strong>nntptest</strong> is a utility that allows you to authenticate to a
-NNTP server and interactively issue commands to it. Once
-authenticated you may issue any NNTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an nntp server. Also those developing NNTP clients
-find it useful.</p>
-</div>
-<div class="section" id="options">
-<h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
-<dl class="option">
-<dt id="cmdoption-nntptest-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-nntptest-t" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
-Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
-authentication.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-nntptest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>nntp</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-nntptest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>nntptest</strong> to use <em>mechanism</em> for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify <em>user</em> to use the AUTHINFO USER/PASS
-commands instead of AUTHINFO SASL.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-nntptest-a" title="Permalink to this definition">¶</a></dt>
-<dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-nntptest-u" title="Permalink to this definition">¶</a></dt>
-<dd><p>Userid to use for authorization; defaults to the current user.
-This is the userid whose identity will be assumed after
-authentication.</p>
-<div class="admonition note">
-<p class="first admonition-title">Note</p>
-<p class="last">This is only used with SASL mechanisms that allow proxying
-(e.g. PLAIN, DIGEST-MD5).</p>
-</div>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-nntptest-k" title="Permalink to this definition">¶</a></dt>
-<dd><p>Minimum protection layer required.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-nntptest-l" title="Permalink to this definition">¶</a></dt>
-<dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
-etc).  For example if you are using the KERBEROS_V4 authentication
-mechanism specifying <strong>0</strong> will force imtest to not use any layer
-and specifying <strong>1</strong> will force it to use the integrity layer.  By
-default the maximum supported protection layer will be used.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-nntptest-r" title="Permalink to this definition">¶</a></dt>
-<dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
-(e.g. DIGEST-MD5) may require one to specify the realm.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-nntptest-f" title="Permalink to this definition">¶</a></dt>
-<dd><p>Pipe <em>file</em> into connection after authentication.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-nntptest-n" title="Permalink to this definition">¶</a></dt>
-<dd><p>Number of authentication attempts; default = 1.  The client will
-attempt to do SSL/TLS session reuse and/or fast reauth
-(e.g. DIGEST-MD5), if possible.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-s">
-<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-nntptest-s" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable NNTP over SSL (nntps).</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-q">
-<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-nntptest-q" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable NNTP COMPRESSion (after authentication)</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-nntptest-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-nntptest-i" title="Permalink to this definition">¶</a></dt>
-<dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
-the protocol supports it.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-nntptest-v" title="Permalink to this definition">¶</a></dt>
-<dd><p>Verbose. Print out more information than usual.</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-nntptest-w" title="Permalink to this definition">¶</a></dt>
-<dd><p>Password to use (if not supplied, we will prompt).</p>
-</dd></dl>
-
-<dl class="option">
-<dt id="cmdoption-nntptest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-nntptest-o" title="Permalink to this definition">¶</a></dt>
-<dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
-</dd></dl>
-
-</div>
-<div class="section" id="examples">
-<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
-</div>
-<div class="section" id="see-also">
-<h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p>Interactive NNTP test program.</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send NNTP commands to the server.</p>
 <p><a class="reference internal" href="../systemcommands/nntpd.html#std:cyrusman-nntpd(8)">nntpd(8)</a></p>
 </div>
-</div>
 
 
           </div>
@@ -945,7 +811,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -965,7 +831,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/pop3test.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/pop3test.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/pop3test.html	2019-12-16 04:18:12.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/pop3test.html	2020-05-04 04:13:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>pop3test &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>pop3test &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sieveshell" href="sieveshell.html"/>
         <link rel="prev" title="nntptest" href="nntptest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/pop3test.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/pop3test.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,62 +788,65 @@
   <span class="target" id="std:cyrusman-pop3test(1)"></span><div class="section" id="pop3test">
 <span id="imap-reference-manpages-usercommands-pop3test"></span><h1><strong>pop3test</strong><a class="headerlink" href="#pop3test" title="Permalink to this headline">¶</a></h1>
 <p>Interactive POP3 test program.</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send POP commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>pop3test</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ]
-    [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ]
-    [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
-<p><strong>pop3test</strong> is a utility that allows you to authenticate to a
-POP3 server and interactively issue commands to it. Once
-authenticated you may issue any POP3 command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an pop3 server. Also those developing POP3 clients
-find it useful.</p>
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-pop3test-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-pop3test-t" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
 Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
 authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-pop3test-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>pop3</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-pop3test-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>pop3test</strong> to use <em>mechanism</em> for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify <em>user</em> to use the USER/PASS commands
-or <em>apop</em> to use the APOP command instead of AUTH.</p>
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
+specified the strongest authentication mechanism supported by the
+server is chosen.  Specify <em>login</em> to use the LOGIN command instead
+of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-pop3test-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-pop3test-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
@@ -836,14 +858,14 @@ authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-pop3test-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-pop3test-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -852,62 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-pop3test-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-pop3test-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-pop3test-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-s">
-<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-pop3test-s" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable POP3 over SSL (pop3s).</p>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-pop3test-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-pop3test-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-pop3test-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-pop3test-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-pop3test-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-pop3test-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -917,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><a class="reference internal" href="../systemcommands/pop3d.html#std:cyrusman-pop3d(8)">pop3d(8)</a></p>
 </div>
 </div>
@@ -939,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -959,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/sieveshell.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/sieveshell.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/sieveshell.html	2019-12-16 04:18:12.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/sieveshell.html	2020-05-04 04:13:38.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sieveshell &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sieveshell &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="sivtest" href="sivtest.html"/>
         <link rel="prev" title="pop3test" href="pop3test.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -794,11 +813,12 @@ server.  It works via MANAGESIEVE, a wor
 <h2>OPTIONS<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <p><strong>-u</strong> <em>user</em>, <strong>&#8211;user</strong>=<em>user</em></p>
 <blockquote>
-<div>The authorization name to request; by default, derived from the
-authentication credentials.</div></blockquote>
+<div>The user whose mailboxes you want to work on. If not specified, it uses the same
+as -a.</div></blockquote>
 <p><strong>-a</strong> <em>authname</em>, <strong>&#8211;authname</strong>=<em>authname</em></p>
 <blockquote>
-<div>The user to use for authentication (defaults to current user).</div></blockquote>
+<div>The user to use for authentication. If not specified, it defaults to the
+current login user.</div></blockquote>
 <p><strong>-r</strong> <em>realm</em>, <strong>&#8211;realm</strong>=<em>realm</em></p>
 <blockquote>
 <div>The realm to attempt authentication in.</div></blockquote>
@@ -810,8 +830,7 @@ exit when done.</div></blockquote>
 <div class="section" id="references">
 <h2>REFERENCES<a class="headerlink" href="#references" title="Permalink to this headline">¶</a></h2>
 <p>[MANAGESIEVE] Martin, T.; &#8220;A Protocol for Remotely Managing Sieve
-Scripts&#8221;, draft-ietf-managesieve-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.</p>
+Scripts&#8221;, RFC 5804; May 2001</p>
 </div>
 <div class="section" id="author">
 <h2>AUTHOR<a class="headerlink" href="#author" title="Permalink to this headline">¶</a></h2>
@@ -838,7 +857,7 @@ team.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team.
+        &copy; Copyright 1993-2018, The Cyrus Team.
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -858,7 +877,7 @@ team.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/sivtest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/sivtest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/sivtest.html	2019-12-16 04:18:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/sivtest.html	2020-05-04 04:13:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>sivtest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>sivtest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="smtptest" href="smtptest.html"/>
         <link rel="prev" title="sieveshell" href="sieveshell.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/sivtest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/sivtest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,62 +787,66 @@
             
   <span class="target" id="std:cyrusman-sivtest(1)"></span><div class="section" id="sivtest">
 <span id="imap-reference-manpages-usercommands-sivtest"></span><h1><strong>sivtest</strong><a class="headerlink" href="#sivtest" title="Permalink to this headline">¶</a></h1>
-<p>Interactive MANAGESIEVE test program</p>
+<p>Interactive MANAGESIEVE test program.</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send MANAGESIEVE commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>sivtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ]
-    [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ]
-    [ <strong>-n</strong> <em>num</em> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p><strong>sivtest</strong> is a utility that allows you to authenticate to a
-MANAGESIEVE server and interactively issue commands to it. Once
-authenticated you may issue any MANAGESIEVE command by simply typing it
-in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used for
-testing the operation of a <a class="reference internal" href="../systemcommands/timsieved.html#std:cyrusman-timsieved(8)">timsieved(8)</a> server. Also those
-developing MANAGESIEVE clients find it useful.</p>
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-sivtest-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-sivtest-t" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
 Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
 authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-sivtest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>sieve</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-sivtest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>sivtest</strong> to use <em>mechanism</em> for authentication. If not
-specified, the strongest authentication mechanism supported by the
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
+specified the strongest authentication mechanism supported by the
 server is chosen.  Specify <em>login</em> to use the LOGIN command instead
 of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-sivtest-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-sivtest-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
@@ -835,14 +858,14 @@ authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-sivtest-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-sivtest-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -851,56 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-sivtest-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-sivtest-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-sivtest-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-sivtest-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-sivtest-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-sivtest-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-sivtest-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-sivtest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-sivtest-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -910,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><a class="reference internal" href="../systemcommands/timsieved.html#std:cyrusman-timsieved(8)">timsieved(8)</a></p>
 </div>
 </div>
@@ -932,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -952,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/smtptest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/smtptest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/smtptest.html	2019-12-16 04:18:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/smtptest.html	2020-05-04 04:13:39.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>smtptest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>smtptest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
         <link rel="next" title="synctest" href="synctest.html"/>
         <link rel="prev" title="sivtest" href="sivtest.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/smtptest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/smtptest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -768,62 +787,66 @@
             
   <span class="target" id="std:cyrusman-smtptest(1)"></span><div class="section" id="smtptest">
 <span id="imap-reference-manpages-usercommands-smtptest"></span><h1><strong>smtptest</strong><a class="headerlink" href="#smtptest" title="Permalink to this headline">¶</a></h1>
-<p>Interactive SMTP test program</p>
+<p>Interactive SMTP test program.</p>
+<p>This is actually installed as a hard linked copy of <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<p>It allows you to authenticate and send SMTP commands to the server.</p>
 <div class="section" id="synopsis">
 <h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
 <pre class="literal-block">
-<strong>smtptest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ] [ <strong>-a</strong> <em>userid</em> ]
-    [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ] [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ]
-    [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-v</strong> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
 </pre>
 </div>
 <div class="section" id="description">
 <h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
-<p><strong>smtptest</strong> is a utility that allows you to authenticate to an
-SMTP server and interactively issue commands to it. Once
-authenticated you may issue any SMTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an SMTP server. Also those developing SMTP clients
-find it useful.</p>
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
 </div>
 <div class="section" id="options">
 <h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
 <dl class="option">
-<dt id="cmdoption-smtptest-t">
-<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-smtptest-t" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
 <dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
 Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
 authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-p">
-<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-smtptest-p" title="Permalink to this definition">¶</a></dt>
-<dd><p>Port to connect to. If left off this defaults to <strong>smtp</strong> as
-defined in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-m">
-<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-smtptest-m" title="Permalink to this definition">¶</a></dt>
-<dd><p>Force <strong>smtptest</strong> to use <em>mechanism</em> for authentication. If not
-specified, the strongest authentication mechanism supported by the
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
+specified the strongest authentication mechanism supported by the
 server is chosen.  Specify <em>login</em> to use the LOGIN command instead
 of AUTHENTICATE.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-a">
-<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-smtptest-a" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.</p>
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-u">
-<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-smtptest-u" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
 <dd><p>Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.</p>
@@ -835,14 +858,14 @@ authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-k">
-<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-smtptest-k" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
 <dd><p>Minimum protection layer required.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-l">
-<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-smtptest-l" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
 <dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
 etc).  For example if you are using the KERBEROS_V4 authentication
 mechanism specifying <strong>0</strong> will force imtest to not use any layer
@@ -851,62 +874,93 @@ default the maximum supported protection
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-r">
-<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-smtptest-r" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
 <dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
 (e.g. DIGEST-MD5) may require one to specify the realm.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-f">
-<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-smtptest-f" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
 <dd><p>Pipe <em>file</em> into connection after authentication.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-n">
-<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-smtptest-n" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
 <dd><p>Number of authentication attempts; default = 1.  The client will
 attempt to do SSL/TLS session reuse and/or fast reauth
 (e.g. DIGEST-MD5), if possible.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-s">
-<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-smtptest-s" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable SMTP over SSL (smtps).</p>
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-c">
-<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-smtptest-c" title="Permalink to this definition">¶</a></dt>
-<dd><p>Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one-time password instead of the
-secret pass-phrase (library generates the correct response).</p>
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-i">
-<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-smtptest-i" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
 <dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
 the protocol supports it.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-v">
-<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-smtptest-v" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
 <dd><p>Verbose. Print out more information than usual.</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-w">
-<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-smtptest-w" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
 <dd><p>Password to use (if not supplied, we will prompt).</p>
 </dd></dl>
 
 <dl class="option">
-<dt id="cmdoption-smtptest-o">
-<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-smtptest-o" title="Permalink to this definition">¶</a></dt>
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
 <dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
 </dd></dl>
 
@@ -916,6 +970,7 @@ the protocol supports it.</p>
 </div>
 <div class="section" id="see-also">
 <h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
 <p><em class="manpage">sendmail(8)</em></p>
 </div>
 </div>
@@ -938,7 +993,7 @@ the protocol supports it.</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jun 05 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -958,7 +1013,7 @@ the protocol supports it.</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/reference/manpages/usercommands/synctest.html 3.2.0-3/doc/html/imap/reference/manpages/usercommands/synctest.html
--- 3.0.13-5/doc/html/imap/reference/manpages/usercommands/synctest.html	2019-12-16 04:18:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/reference/manpages/usercommands/synctest.html	2020-05-04 04:13:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>synctest &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>synctest &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="../../../../genindex.html"/>
         <link rel="search" title="Search" href="../../../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../../../index.html"/>
         <link rel="up" title="Man pages" href="../commands.html"/>
-        <link rel="next" title="Tools &amp; Utilities" href="../../administration-tools.html"/>
+        <link rel="next" title="Administrator Guide" href="../../admin.html"/>
         <link rel="prev" title="smtptest" href="smtptest.html"/> 
 
   
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../../../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../../../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2 current"><a class="reference internal" href="../commands.html">Man pages</a><ul class="current">
 <li class="toctree-l3"><a class="reference internal" href="../commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../../admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../../faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../../faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../../../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../../../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../../../operations.html">Operations</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/reference/manpages/usercommands/synctest.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/reference/manpages/usercommands/synctest.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -769,6 +788,188 @@
   <div class="section" id="synctest">
 <span id="imap-reference-manpages-usercommands-synctest"></span><span id="std:cyrusman-synctest(1)"></span><h1><strong>synctest</strong><a class="headerlink" href="#synctest" title="Permalink to this headline">¶</a></h1>
 <p>Interactive IMAP test program: tests the replication protocol. This is installed as a hard link to <a class="reference internal" href="imtest.html#std:cyrusman-imtest(1)">imtest(1)</a>.</p>
+<div class="section" id="synopsis">
+<h2>Synopsis<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h2>
+<pre class="literal-block">
+<strong>imtest</strong> [ <strong>-t</strong> <em>keyfile</em> ] [ <strong>-p</strong> <em>port</em> ] [ <strong>-m</strong> <em>mechanism</em> ]
+    [ <strong>-a</strong> <em>userid</em> ] [ <strong>-u</strong> <em>userid</em> ] [ <strong>-k</strong> <em>num</em> ] [ <strong>-l</strong> <em>num</em> ]
+    [ <strong>-r</strong> <em>realm</em> ] [ <strong>-f</strong> <em>file</em> ] [ <strong>-n</strong> <em>num</em> ] [ <strong>-s</strong> ] [ <strong>-q</strong> ]
+    [ <strong>-c</strong> ] [ <strong>-i</strong> ] [ <strong>-z</strong> ] [ <strong>-v</strong> ] [ <strong>-I</strong> <em>file</em> ] [ <strong>-x</strong> <em>file</em> ]
+    [ <strong>-X</strong> <em>file</em> ] [ <strong>-w</strong> <em>passwd</em> ] [ <strong>-o</strong> <em>option</em>=<em>value</em> ] <em>hostname</em>
+</pre>
+</div>
+<div class="section" id="description">
+<h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h2>
+<p><strong>imtest</strong> is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.</p>
+</div>
+<div class="section" id="options">
+<h2>Options<a class="headerlink" href="#options" title="Permalink to this headline">¶</a></h2>
+<dl class="option">
+<dt id="cmdoption-imtest-t">
+<code class="descname">-t</code><code class="descclassname">  keyfile</code><a class="headerlink" href="#cmdoption-imtest-t" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable TLS.  <em>keyfile</em> contains the TLS public and private keys.
+Specify <strong>&#8220;&#8221;</strong> to negotiate a TLS encryption layer but not use TLS
+authentication.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-p">
+<code class="descname">-p</code><code class="descclassname">  port</code><a class="headerlink" href="#cmdoption-imtest-p" title="Permalink to this definition">¶</a></dt>
+<dd><p>Port to connect to. If left off this defaults to <strong>imap</strong> as defined
+in <code class="docutils literal"><span class="pre">/etc/services</span></code>.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-m">
+<code class="descname">-m</code><code class="descclassname">  mechanism</code><a class="headerlink" href="#cmdoption-imtest-m" title="Permalink to this definition">¶</a></dt>
+<dd><p>Force <strong>imtest</strong> to use <em>mechanism</em> for authentication. If not
+specified the strongest authentication mechanism supported by the
+server is chosen.  Specify <em>login</em> to use the LOGIN command instead
+of AUTHENTICATE.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-a">
+<code class="descname">-a</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-a" title="Permalink to this definition">¶</a></dt>
+<dd><p>Userid to use for authentication; defaults to the current user.
+This is the userid whose password or credentials will be presented to
+the server for verification.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-u">
+<code class="descname">-u</code><code class="descclassname">  userid</code><a class="headerlink" href="#cmdoption-imtest-u" title="Permalink to this definition">¶</a></dt>
+<dd><p>Userid to use for authorization; defaults to the current user.
+This is the userid whose identity will be assumed after
+authentication.</p>
+<div class="admonition note">
+<p class="first admonition-title">Note</p>
+<p class="last">This is only used with SASL mechanisms that allow proxying
+(e.g. PLAIN, DIGEST-MD5).</p>
+</div>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-k">
+<code class="descname">-k</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-k" title="Permalink to this definition">¶</a></dt>
+<dd><p>Minimum protection layer required.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-l">
+<code class="descname">-l</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-l" title="Permalink to this definition">¶</a></dt>
+<dd><p>Maximum protection layer to use (<strong>0</strong>=none; <strong>1</strong>=integrity;
+etc).  For example if you are using the KERBEROS_V4 authentication
+mechanism specifying <strong>0</strong> will force imtest to not use any layer
+and specifying <strong>1</strong> will force it to use the integrity layer.  By
+default the maximum supported protection layer will be used.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-r">
+<code class="descname">-r</code><code class="descclassname">  realm</code><a class="headerlink" href="#cmdoption-imtest-r" title="Permalink to this definition">¶</a></dt>
+<dd><p>Specify the <em>realm</em> to use. Certain authentication mechanisms
+(e.g. DIGEST-MD5) may require one to specify the realm.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-f">
+<code class="descname">-f</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-f" title="Permalink to this definition">¶</a></dt>
+<dd><p>Pipe <em>file</em> into connection after authentication.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-n">
+<code class="descname">-n</code><code class="descclassname">  num</code><a class="headerlink" href="#cmdoption-imtest-n" title="Permalink to this definition">¶</a></dt>
+<dd><p>Number of authentication attempts; default = 1.  The client will
+attempt to do SSL/TLS session reuse and/or fast reauth
+(e.g. DIGEST-MD5), if possible.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-s">
+<code class="descname">-s</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-s" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable SSL over chosen protocol.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-q">
+<code class="descname">-q</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-q" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable IMAP COMPRESSion (after authentication).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-c">
+<code class="descname">-c</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-c" title="Permalink to this definition">¶</a></dt>
+<dd><p>Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one-time password instead of the secret pass-phrase
+(library generates the correct response).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-i">
+<code class="descname">-i</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-i" title="Permalink to this definition">¶</a></dt>
+<dd><p>Don&#8217;t send an initial client response for SASL mechanisms, even if
+the protocol supports it.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-I">
+<code class="descname">-I</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-I" title="Permalink to this definition">¶</a></dt>
+<dd><p>Echo the PID of the running process into <em>file</em> (This can be useful
+with -X).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-v">
+<code class="descname">-v</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-v" title="Permalink to this definition">¶</a></dt>
+<dd><p>Verbose. Print out more information than usual.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-z">
+<code class="descname">-z</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-imtest-z" title="Permalink to this definition">¶</a></dt>
+<dd><p>Timing test.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-x">
+<code class="descname">-x</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-x" title="Permalink to this definition">¶</a></dt>
+<dd><p>Open the named socket for the interactive portion.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-X">
+<code class="descname">-X</code><code class="descclassname">  file</code><a class="headerlink" href="#cmdoption-imtest-X" title="Permalink to this definition">¶</a></dt>
+<dd><p>Like -x, only close all file descriptors &amp; daemonize the process.</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-w">
+<code class="descname">-w</code><code class="descclassname"> passwd</code><a class="headerlink" href="#cmdoption-imtest-w" title="Permalink to this definition">¶</a></dt>
+<dd><p>Password to use (if not supplied, we will prompt).</p>
+</dd></dl>
+
+<dl class="option">
+<dt id="cmdoption-imtest-o">
+<code class="descname">-o</code><code class="descclassname">  option=value</code><a class="headerlink" href="#cmdoption-imtest-o" title="Permalink to this definition">¶</a></dt>
+<dd><p>Set the SASL <em>option</em> to <em>value</em>.</p>
+</dd></dl>
+
+</div>
+<div class="section" id="examples">
+<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
+</div>
+<div class="section" id="see-also">
+<h2>See Also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
+<p><a class="reference internal" href="../systemcommands/imapd.html#std:cyrusman-imapd(8)">imapd(8)</a></p>
+</div>
 </div>
 
 
@@ -777,7 +978,7 @@
   
     <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
       
-        <a href="../../administration-tools.html" class="btn btn-neutral float-right" title="Tools &amp; Utilities" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
+        <a href="../../admin.html" class="btn btn-neutral float-right" title="Administrator Guide" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
         <a href="smtptest.html" class="btn btn-neutral" title="smtptest" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
@@ -789,7 +990,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Sep 05 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -809,7 +1010,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/rfc-support.html 3.2.0-3/doc/html/imap/rfc-support.html
--- 3.0.13-5/doc/html/imap/rfc-support.html	2019-12-16 04:18:13.000000000 +0000
+++ 3.2.0-3/doc/html/imap/rfc-support.html	2020-05-04 04:13:40.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>RFCs Supported by Cyrus IMAP &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>RFCs Supported by Cyrus IMAP &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>RFCs Supported by Cyrus IMAP</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/rfc-support.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/rfc-support.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,478 +816,511 @@
 <p><span class="target" id="index-14"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1951.html"><strong>RFC 1951</strong></a></p>
 <blockquote>
 <div>DEFLATE Compressed Data Format Specification version 1.3</div></blockquote>
-<p><span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2033.html"><strong>RFC 2033</strong></a></p>
+<p><span class="target" id="index-15"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1952.html"><strong>RFC 1952</strong></a></p>
+<blockquote>
+<div>GZIP file format specification version 4.3</div></blockquote>
+<p><span class="target" id="index-16"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2033.html"><strong>RFC 2033</strong></a></p>
 <blockquote>
 <div>Local Mail Transfer Protocol</div></blockquote>
-<p><span class="target" id="index-16"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2034.html"><strong>RFC 2034</strong></a></p>
+<p><span class="target" id="index-17"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2034.html"><strong>RFC 2034</strong></a></p>
 <blockquote>
 <div>SMTP Service Extension for Returning Enhanced Error Codes</div></blockquote>
-<p><span class="target" id="index-17"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2045.html"><strong>RFC 2045</strong></a></p>
+<p><span class="target" id="index-18"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2045.html"><strong>RFC 2045</strong></a></p>
 <blockquote>
 <div>Multipurpose Internet Mail Extensions (MIME) Part One: Format of
 Internet Message Bodies</div></blockquote>
-<p><span class="target" id="index-18"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2046.html"><strong>RFC 2046</strong></a></p>
+<p><span class="target" id="index-19"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2046.html"><strong>RFC 2046</strong></a></p>
 <blockquote>
 <div>Multipurpose Internet Mail Extensions (MIME) Part Two: Media Types</div></blockquote>
-<p><span class="target" id="index-19"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2047.html"><strong>RFC 2047</strong></a></p>
+<p><span class="target" id="index-20"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2047.html"><strong>RFC 2047</strong></a></p>
 <blockquote>
 <div>MIME (Multipurpose Internet Mail Extensions) Part Three: Message
 Header Extensions for Non-ASCII Text</div></blockquote>
-<p><span class="target" id="index-20"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2060.html"><strong>RFC 2060</strong></a></p>
+<p><span class="target" id="index-21"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2060.html"><strong>RFC 2060</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol - Version 4rev1, obsoleted by
-<span class="target" id="index-21"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a>.</div></blockquote>
-<p><span class="target" id="index-22"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2086.html"><strong>RFC 2086</strong></a></p>
+<span class="target" id="index-22"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a>.</div></blockquote>
+<p><span class="target" id="index-23"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2086.html"><strong>RFC 2086</strong></a></p>
 <blockquote>
-<div><p>IMAP4 ACL Extension, obsoleted by <span class="target" id="index-23"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4314.html"><strong>RFC 4314</strong></a>.</p>
+<div><p>IMAP4 ACL Extension, obsoleted by <span class="target" id="index-24"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4314.html"><strong>RFC 4314</strong></a>.</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
 <p class="last">Backwards compatibility with this RFC is to be obsoleted.</p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-24"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2087.html"><strong>RFC 2087</strong></a></p>
+<p><span class="target" id="index-25"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2087.html"><strong>RFC 2087</strong></a></p>
 <blockquote>
 <div>IMAP4 QUOTA extension</div></blockquote>
-<p><span class="target" id="index-25"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2088.html"><strong>RFC 2088</strong></a></p>
+<p><span class="target" id="index-26"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2088.html"><strong>RFC 2088</strong></a></p>
 <blockquote>
 <div>IMAP4 non-synchronizing literals</div></blockquote>
-<p><span class="target" id="index-26"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2177.html"><strong>RFC 2177</strong></a></p>
+<p><span class="target" id="index-27"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2177.html"><strong>RFC 2177</strong></a></p>
 <blockquote>
 <div>IMAP4 IDLE command</div></blockquote>
-<p><span class="target" id="index-27"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2192.html"><strong>RFC 2192</strong></a></p>
+<p><span class="target" id="index-28"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2192.html"><strong>RFC 2192</strong></a></p>
 <blockquote>
 <div>IMAP URL Scheme, obsoleted by
-<span class="target" id="index-28"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a>.</div></blockquote>
-<p><span class="target" id="index-29"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2193.html"><strong>RFC 2193</strong></a></p>
+<span class="target" id="index-29"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a>.</div></blockquote>
+<p><span class="target" id="index-30"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2193.html"><strong>RFC 2193</strong></a></p>
 <blockquote>
 <div>IMAP4 Mailbox Referrals</div></blockquote>
-<p><span class="target" id="index-30"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2195.html"><strong>RFC 2195</strong></a></p>
+<p><span class="target" id="index-31"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2195.html"><strong>RFC 2195</strong></a></p>
 <blockquote>
 <div>IMAP/POP AUTHorize Extension for Simple Challenge/Response</div></blockquote>
-<p><span class="target" id="index-31"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2246.html"><strong>RFC 2246</strong></a></p>
+<p><span class="target" id="index-32"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2246.html"><strong>RFC 2246</strong></a></p>
 <blockquote>
 <div>The TLS Protocol Version 1.0</div></blockquote>
-<p><span class="target" id="index-32"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2298.html"><strong>RFC 2298</strong></a></p>
+<p><span class="target" id="index-33"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2298.html"><strong>RFC 2298</strong></a></p>
 <blockquote>
 <div>Extensible Message Format for Message Disposition Notifications
 (MDNs)</div></blockquote>
-<p><span class="target" id="index-33"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2342.html"><strong>RFC 2342</strong></a></p>
+<p><span class="target" id="index-34"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2342.html"><strong>RFC 2342</strong></a></p>
 <blockquote>
 <div>IMAP4 Namespace</div></blockquote>
-<p><span class="target" id="index-34"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2359.html"><strong>RFC 2359</strong></a></p>
+<p><span class="target" id="index-35"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2359.html"><strong>RFC 2359</strong></a></p>
 <blockquote>
-<div>IMAP4 UIDPLUS extension, obsoleted by <span class="target" id="index-35"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4315.html"><strong>RFC 4315</strong></a></div></blockquote>
-<p><span class="target" id="index-36"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2444.html"><strong>RFC 2444</strong></a></p>
+<div>IMAP4 UIDPLUS extension, obsoleted by <span class="target" id="index-36"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4315.html"><strong>RFC 4315</strong></a></div></blockquote>
+<p><span class="target" id="index-37"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2444.html"><strong>RFC 2444</strong></a></p>
 <blockquote>
 <div>The One-Time-Password SASL Mechanism</div></blockquote>
-<p><span class="target" id="index-37"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2449.html"><strong>RFC 2449</strong></a></p>
+<p><span class="target" id="index-38"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2449.html"><strong>RFC 2449</strong></a></p>
 <blockquote>
 <div>POP3 Extension Mechanism</div></blockquote>
-<p><span class="target" id="index-38"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2518.html"><strong>RFC 2518</strong></a></p>
+<p><span class="target" id="index-39"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2518.html"><strong>RFC 2518</strong></a></p>
 <blockquote>
 <div>HTTP Extensions for Distributed Authoring &#8211; WEBDAV</div></blockquote>
-<p><span class="target" id="index-39"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2595.html"><strong>RFC 2595</strong></a></p>
+<p><span class="target" id="index-40"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2595.html"><strong>RFC 2595</strong></a></p>
 <blockquote>
 <div>Using TLS with IMAP, POP3 and ACAP</div></blockquote>
-<p><span class="target" id="index-40"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2617.html"><strong>RFC 2617</strong></a></p>
+<p><span class="target" id="index-41"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2617.html"><strong>RFC 2617</strong></a></p>
 <blockquote>
-<div>HTTP Authentication: Basic and Digest Access Authentication</div></blockquote>
-<p><span class="target" id="index-41"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2817.html"><strong>RFC 2817</strong></a></p>
+<div>HTTP Authentication: Basic and Digest Access Authentication,
+updated by <span class="target" id="index-42"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7615.html"><strong>RFC 7615</strong></a>, <span class="target" id="index-43"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7616.html"><strong>RFC 7616</strong></a>, <span class="target" id="index-44"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7617.html"><strong>RFC 7617</strong></a>.</div></blockquote>
+<p><span class="target" id="index-45"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2817.html"><strong>RFC 2817</strong></a></p>
 <blockquote>
 <div>HTTP Upgrading to TLS Within HTTP/1.1</div></blockquote>
-<p><span class="target" id="index-42"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2818.html"><strong>RFC 2818</strong></a></p>
+<p><span class="target" id="index-46"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2818.html"><strong>RFC 2818</strong></a></p>
 <blockquote>
 <div>HTTP Over TLS</div></blockquote>
-<p><span class="target" id="index-43"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2821.html"><strong>RFC 2821</strong></a></p>
+<p><span class="target" id="index-47"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2821.html"><strong>RFC 2821</strong></a></p>
 <blockquote>
 <div>Simple Mail Transfer Protocol</div></blockquote>
-<p><span class="target" id="index-44"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2822.html"><strong>RFC 2822</strong></a></p>
+<p><span class="target" id="index-48"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2822.html"><strong>RFC 2822</strong></a></p>
 <blockquote>
 <div>Internet Message Format</div></blockquote>
-<p><span class="target" id="index-45"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2831.html"><strong>RFC 2831</strong></a></p>
+<p><span class="target" id="index-49"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2831.html"><strong>RFC 2831</strong></a></p>
 <blockquote>
 <div>Using Digest Authentication as a SASL Mechanism</div></blockquote>
-<p><span class="target" id="index-46"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2920.html"><strong>RFC 2920</strong></a></p>
+<p><span class="target" id="index-50"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2920.html"><strong>RFC 2920</strong></a></p>
 <blockquote>
 <div>SMTP Service Extension for Command Pipelining</div></blockquote>
-<p><span class="target" id="index-47"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2971.html"><strong>RFC 2971</strong></a></p>
+<p><span class="target" id="index-51"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2971.html"><strong>RFC 2971</strong></a></p>
 <blockquote>
 <div>IMAP4 ID extension</div></blockquote>
-<p><span class="target" id="index-48"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2980.html"><strong>RFC 2980</strong></a></p>
+<p><span class="target" id="index-52"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2980.html"><strong>RFC 2980</strong></a></p>
 <blockquote>
 <div>Common NNTP Extensions</div></blockquote>
-<p><span class="target" id="index-49"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3028.html"><strong>RFC 3028</strong></a></p>
+<p><span class="target" id="index-53"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3028.html"><strong>RFC 3028</strong></a></p>
 <blockquote>
 <div>Sieve: A Mail Filtering Language</div></blockquote>
-<p><span class="target" id="index-50"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3206.html"><strong>RFC 3206</strong></a></p>
+<p><span class="target" id="index-54"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3206.html"><strong>RFC 3206</strong></a></p>
 <blockquote>
 <div>The SYS and AUTH POP Response Codes</div></blockquote>
-<p><span class="target" id="index-51"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3207.html"><strong>RFC 3207</strong></a></p>
+<p><span class="target" id="index-55"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3207.html"><strong>RFC 3207</strong></a></p>
 <blockquote>
 <div>SMTP Service Extension for Secure SMTP over TLS</div></blockquote>
-<p><span class="target" id="index-52"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3253.html"><strong>RFC 3253</strong></a></p>
+<p><span class="target" id="index-56"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3253.html"><strong>RFC 3253</strong></a></p>
 <blockquote>
 <div>Versioning Extensions to WebDAV (Web Distributed Authoring and
 Versioning)</div></blockquote>
-<p><span class="target" id="index-53"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3339.html"><strong>RFC 3339</strong></a></p>
+<p><span class="target" id="index-57"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3339.html"><strong>RFC 3339</strong></a></p>
 <blockquote>
 <div>Date and Time on the Internet: Timestamps</div></blockquote>
-<p><span class="target" id="index-54"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3348.html"><strong>RFC 3348</strong></a></p>
+<p><span class="target" id="index-58"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3348.html"><strong>RFC 3348</strong></a></p>
 <blockquote>
 <div>IMAP4 Child Mailbox Extension</div></blockquote>
-<p><span class="target" id="index-55"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3431.html"><strong>RFC 3431</strong></a></p>
+<p><span class="target" id="index-59"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3431.html"><strong>RFC 3431</strong></a></p>
 <blockquote>
 <div>Sieve Extension: Relational Tests</div></blockquote>
-<p><span class="target" id="index-56"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3463.html"><strong>RFC 3463</strong></a></p>
+<p><span class="target" id="index-60"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3463.html"><strong>RFC 3463</strong></a></p>
 <blockquote>
 <div>Enhanced Mail System Status Codes</div></blockquote>
-<p><span class="target" id="index-57"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a></p>
+<p><span class="target" id="index-61"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3501.html"><strong>RFC 3501</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol - version 4rev1</div></blockquote>
-<p><span class="target" id="index-58"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3502.html"><strong>RFC 3502</strong></a></p>
+<p><span class="target" id="index-62"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3502.html"><strong>RFC 3502</strong></a></p>
 <blockquote>
 <div>IMAP MULTIAPPEND extension</div></blockquote>
-<p><span class="target" id="index-59"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3516.html"><strong>RFC 3516</strong></a></p>
+<p><span class="target" id="index-63"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3516.html"><strong>RFC 3516</strong></a></p>
 <blockquote>
 <div>IMAP4 Binary Content Extension</div></blockquote>
-<p><span class="target" id="index-60"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3598.html"><strong>RFC 3598</strong></a></p>
+<p><span class="target" id="index-64"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3598.html"><strong>RFC 3598</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering &#8211; Subaddress Extension, obsoleted by
-<span class="target" id="index-61"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5233.html"><strong>RFC 5233</strong></a>.</div></blockquote>
-<p><span class="target" id="index-62"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3656.html"><strong>RFC 3656</strong></a></p>
+<span class="target" id="index-65"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5233.html"><strong>RFC 5233</strong></a>.</div></blockquote>
+<p><span class="target" id="index-66"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3656.html"><strong>RFC 3656</strong></a></p>
 <blockquote>
 <div>MUPDATE Protocol (For Cyrus Murder)</div></blockquote>
-<p><span class="target" id="index-63"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3691.html"><strong>RFC 3691</strong></a></p>
+<p><span class="target" id="index-67"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3691.html"><strong>RFC 3691</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol (IMAP) UNSELECT command</div></blockquote>
-<p><span class="target" id="index-64"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3744.html"><strong>RFC 3744</strong></a></p>
+<p><span class="target" id="index-68"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3744.html"><strong>RFC 3744</strong></a></p>
 <blockquote>
 <div>Web Distributed Authoring and Versioning (WebDAV) Access Control
 Protocol</div></blockquote>
-<p><span class="target" id="index-65"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3834.html"><strong>RFC 3834</strong></a></p>
+<p><span class="target" id="index-69"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3834.html"><strong>RFC 3834</strong></a></p>
 <blockquote>
 <div>Recommendations for Automatic Responses to Electronic Mail</div></blockquote>
-<p><span class="target" id="index-66"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3848.html"><strong>RFC 3848</strong></a></p>
+<p><span class="target" id="index-70"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3848.html"><strong>RFC 3848</strong></a></p>
 <blockquote>
 <div>ESMTP and LMTP Transmission Types Registration</div></blockquote>
-<p><span class="target" id="index-67"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3894.html"><strong>RFC 3894</strong></a></p>
+<p><span class="target" id="index-71"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3894.html"><strong>RFC 3894</strong></a></p>
 <blockquote>
 <div>Sieve Extension: Copying Without Side Effects</div></blockquote>
-<p><span class="target" id="index-68"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3977.html"><strong>RFC 3977</strong></a></p>
+<p><span class="target" id="index-72"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3977.html"><strong>RFC 3977</strong></a></p>
 <blockquote>
 <div>Network News Transfer Protocol (NNTP)</div></blockquote>
-<p><span class="target" id="index-69"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4287.html"><strong>RFC 4287</strong></a></p>
+<p><span class="target" id="index-73"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4287.html"><strong>RFC 4287</strong></a></p>
 <blockquote>
 <div>The Atom Syndication Format</div></blockquote>
-<p><span class="target" id="index-70"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4314.html"><strong>RFC 4314</strong></a></p>
+<p><span class="target" id="index-74"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4314.html"><strong>RFC 4314</strong></a></p>
 <blockquote>
 <div>IMAP4 Access Control List (ACL) Extension</div></blockquote>
-<p><span class="target" id="index-71"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4315.html"><strong>RFC 4315</strong></a></p>
+<p><span class="target" id="index-75"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4315.html"><strong>RFC 4315</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol (IMAP) - UIDPLUS extension</div></blockquote>
-<p><span class="target" id="index-72"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4331.html"><strong>RFC 4331</strong></a></p>
+<p><span class="target" id="index-76"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4331.html"><strong>RFC 4331</strong></a></p>
 <blockquote>
 <div>Quota and Size Properties for Distributed Authoring and Versioning
 (DAV) Collections</div></blockquote>
-<p><span class="target" id="index-73"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4346.html"><strong>RFC 4346</strong></a></p>
+<p><span class="target" id="index-77"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4346.html"><strong>RFC 4346</strong></a></p>
 <blockquote>
 <div>The Transport Layer Security (TLS) Protocol Version 1.1</div></blockquote>
-<p><span class="target" id="index-74"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4422.html"><strong>RFC 4422</strong></a></p>
+<p><span class="target" id="index-78"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4422.html"><strong>RFC 4422</strong></a></p>
 <blockquote>
 <div>Simple Authentication and Security Layer (SASL)</div></blockquote>
-<p><span class="target" id="index-75"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4466.html"><strong>RFC 4466</strong></a></p>
+<p><span class="target" id="index-79"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4466.html"><strong>RFC 4466</strong></a></p>
 <blockquote>
 <div>Collected Extensions to IMAP4 ABNF</div></blockquote>
-<p><span class="target" id="index-76"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4467.html"><strong>RFC 4467</strong></a></p>
+<p><span class="target" id="index-80"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4467.html"><strong>RFC 4467</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol (IMAP) - URLAUTH Extension, updated
-by <span class="target" id="index-77"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a>.</div></blockquote>
-<p><span class="target" id="index-78"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4469.html"><strong>RFC 4469</strong></a></p>
+by <span class="target" id="index-81"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a>.</div></blockquote>
+<p><span class="target" id="index-82"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4469.html"><strong>RFC 4469</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol (IMAP) CATENATE Extension</div></blockquote>
-<p><span class="target" id="index-79"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4505.html"><strong>RFC 4505</strong></a></p>
+<p><span class="target" id="index-83"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4505.html"><strong>RFC 4505</strong></a></p>
 <blockquote>
 <div>Anonymous Simple Authentication and Security Layer (SASL) Mechanism</div></blockquote>
-<p><span class="target" id="index-80"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4550.html"><strong>RFC 4550</strong></a></p>
+<p><span class="target" id="index-84"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4550.html"><strong>RFC 4550</strong></a></p>
 <blockquote>
 <div>Internet Email to Support Diverse Service Environments (Lemonade)
 Profile</div></blockquote>
-<p><span class="target" id="index-81"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4551.html"><strong>RFC 4551</strong></a></p>
+<p><span class="target" id="index-85"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4551.html"><strong>RFC 4551</strong></a></p>
 <blockquote>
 <div>IMAP Extension for Conditional STORE Operation or Quick Flag Changes
 Resynchronization</div></blockquote>
-<p><span class="target" id="index-82"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4559.html"><strong>RFC 4559</strong></a></p>
+<p><span class="target" id="index-86"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4559.html"><strong>RFC 4559</strong></a></p>
 <blockquote>
 <div>SPNEGO-based Kerberos and NTLM HTTP Authentication in Microsoft
 Windows</div></blockquote>
-<p><span class="target" id="index-83"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4616.html"><strong>RFC 4616</strong></a></p>
+<p><span class="target" id="index-87"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4616.html"><strong>RFC 4616</strong></a></p>
 <blockquote>
 <div>The PLAIN Simple Authentication and Security Layer (SASL) Mechanism</div></blockquote>
-<p><span class="target" id="index-84"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4642.html"><strong>RFC 4642</strong></a></p>
+<p><span class="target" id="index-88"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4642.html"><strong>RFC 4642</strong></a></p>
 <blockquote>
 <div>Using Transport Layer Security (TLS) with Network News Transfer
 Protocol (NNTP)</div></blockquote>
-<p><span class="target" id="index-85"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4643.html"><strong>RFC 4643</strong></a></p>
+<p><span class="target" id="index-89"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4643.html"><strong>RFC 4643</strong></a></p>
 <blockquote>
 <div>Network News Transfer Protocol (NNTP) Extension for Authentication</div></blockquote>
-<p><span class="target" id="index-86"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4644.html"><strong>RFC 4644</strong></a></p>
+<p><span class="target" id="index-90"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4644.html"><strong>RFC 4644</strong></a></p>
 <blockquote>
 <div>Network News Transfer Protocol (NNTP) Extension for Streaming Feeds</div></blockquote>
-<p><span class="target" id="index-87"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4731.html"><strong>RFC 4731</strong></a></p>
+<p><span class="target" id="index-91"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4731.html"><strong>RFC 4731</strong></a></p>
 <blockquote>
 <div>IMAP4 Extension to SEARCH Command for Controlling What Kind of
 Information Is Returned</div></blockquote>
-<p><span class="target" id="index-88"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4791.html"><strong>RFC 4791</strong></a></p>
+<p><span class="target" id="index-92"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4791.html"><strong>RFC 4791</strong></a></p>
 <blockquote>
 <div>Calendaring Extensions to WebDAV (CalDAV)</div></blockquote>
-<p><span class="target" id="index-89"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4918.html"><strong>RFC 4918</strong></a></p>
+<p><span class="target" id="index-93"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4918.html"><strong>RFC 4918</strong></a></p>
 <blockquote>
 <div>HTTP Extensions for Web Distributed Authoring and Versioning
 (WebDAV)</div></blockquote>
-<p><span class="target" id="index-90"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4954.html"><strong>RFC 4954</strong></a></p>
+<p><span class="target" id="index-94"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4954.html"><strong>RFC 4954</strong></a></p>
 <blockquote>
 <div>SMTP Service Extension for Authentication</div></blockquote>
-<p><span class="target" id="index-91"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4959.html"><strong>RFC 4959</strong></a></p>
+<p><span class="target" id="index-95"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4959.html"><strong>RFC 4959</strong></a></p>
 <blockquote>
 <div>IMAP Extension for Simple Authentication and Security Layer (SASL)
 Initial Client Response</div></blockquote>
-<p><span class="target" id="index-92"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4978.html"><strong>RFC 4978</strong></a></p>
+<p><span class="target" id="index-96"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4978.html"><strong>RFC 4978</strong></a></p>
 <blockquote>
 <div>The IMAP COMPRESS Extension</div></blockquote>
-<p><span class="target" id="index-93"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5032.html"><strong>RFC 5032</strong></a></p>
+<p><span class="target" id="index-97"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5032.html"><strong>RFC 5032</strong></a></p>
 <blockquote>
 <div>WITHIN Search Extension to the IMAP Protocol</div></blockquote>
-<p><span class="target" id="index-94"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5034.html"><strong>RFC 5034</strong></a></p>
+<p><span class="target" id="index-98"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5034.html"><strong>RFC 5034</strong></a></p>
 <blockquote>
 <div>The Post Office Protocol (POP3) Simple Authentication and Security
 Layer (SASL) Authentication Mechanism</div></blockquote>
-<p><span class="target" id="index-95"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a></p>
+<p><span class="target" id="index-99"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5092.html"><strong>RFC 5092</strong></a></p>
 <blockquote>
-<div>IMAP URL Scheme, updated by <span class="target" id="index-96"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5593.html"><strong>RFC 5593</strong></a>.</div></blockquote>
-<p><span class="target" id="index-97"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5161.html"><strong>RFC 5161</strong></a></p>
+<div>IMAP URL Scheme, updated by <span class="target" id="index-100"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5593.html"><strong>RFC 5593</strong></a>.</div></blockquote>
+<p><span class="target" id="index-101"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5161.html"><strong>RFC 5161</strong></a></p>
 <blockquote>
 <div>The IMAP ENABLE Extension</div></blockquote>
-<p><span class="target" id="index-98"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5162.html"><strong>RFC 5162</strong></a></p>
+<p><span class="target" id="index-102"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5162.html"><strong>RFC 5162</strong></a></p>
 <blockquote>
 <div>IMAP4 Extensions for Quick Mailbox Resynchronization</div></blockquote>
-<p><span class="target" id="index-99"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5173.html"><strong>RFC 5173</strong></a></p>
+<p><span class="target" id="index-103"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5173.html"><strong>RFC 5173</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Body Extension</div></blockquote>
-<p><span class="target" id="index-100"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5228.html"><strong>RFC 5228</strong></a></p>
+<p><span class="target" id="index-104"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5183.html"><strong>RFC 5183</strong></a></p>
+<blockquote>
+<div>Sieve Email Filtering: Environment Extension</div></blockquote>
+<p><span class="target" id="index-105"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5228.html"><strong>RFC 5228</strong></a></p>
 <blockquote>
 <div>Sieve: A Mail Filtering Language</div></blockquote>
-<p><span class="target" id="index-101"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5229.html"><strong>RFC 5229</strong></a></p>
+<p><span class="target" id="index-106"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5229.html"><strong>RFC 5229</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Variables Extension</div></blockquote>
-<p><span class="target" id="index-102"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5230.html"><strong>RFC 5230</strong></a></p>
+<p><span class="target" id="index-107"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5230.html"><strong>RFC 5230</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Vacation Extension</div></blockquote>
-<p><span class="target" id="index-103"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5231.html"><strong>RFC 5231</strong></a></p>
+<p><span class="target" id="index-108"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5231.html"><strong>RFC 5231</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Relational Extension</div></blockquote>
-<p><span class="target" id="index-104"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5232.html"><strong>RFC 5232</strong></a></p>
+<p><span class="target" id="index-109"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5232.html"><strong>RFC 5232</strong></a></p>
 <blockquote>
 <div><p>Sieve Email Filtering: Imap4flags Extension</p>
 <div class="versionadded">
 <p><span class="versionmodified">New in version 2.5.0.</span></p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-105"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5233.html"><strong>RFC 5233</strong></a></p>
+<p><span class="target" id="index-110"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5233.html"><strong>RFC 5233</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Subaddress Extension</div></blockquote>
-<p><span class="target" id="index-106"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5256.html"><strong>RFC 5256</strong></a></p>
+<p><span class="target" id="index-111"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5256.html"><strong>RFC 5256</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol - SORT and THREAD Extensions</div></blockquote>
-<p><span class="target" id="index-107"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5257.html"><strong>RFC 5257</strong></a></p>
+<p><span class="target" id="index-112"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5257.html"><strong>RFC 5257</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol - ANNOTATE Extension</div></blockquote>
-<p><span class="target" id="index-108"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5258.html"><strong>RFC 5258</strong></a></p>
+<p><span class="target" id="index-113"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5258.html"><strong>RFC 5258</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol version 4 - LIST Command Extensions</div></blockquote>
-<p><span class="target" id="index-109"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5260.html"><strong>RFC 5260</strong></a></p>
+<p><span class="target" id="index-114"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5260.html"><strong>RFC 5260</strong></a></p>
 <blockquote>
 <div><p>Sieve Email Filtering: Date and Index Extensions</p>
 <div class="versionadded">
 <p><span class="versionmodified">New in version 2.5.0.</span></p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-110"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5321.html"><strong>RFC 5321</strong></a></p>
+<p><span class="target" id="index-115"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5293.html"><strong>RFC 5293</strong></a></p>
+<blockquote>
+<div>Sieve Email Filtering: Editheader Extension</div></blockquote>
+<p><span class="target" id="index-116"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5321.html"><strong>RFC 5321</strong></a></p>
 <blockquote>
 <div>Simple Mail Transfer Protocol</div></blockquote>
-<p><span class="target" id="index-111"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5322.html"><strong>RFC 5322</strong></a></p>
+<p><span class="target" id="index-117"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5322.html"><strong>RFC 5322</strong></a></p>
 <blockquote>
 <div>Internet Message Format</div></blockquote>
-<p><span class="target" id="index-112"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5397.html"><strong>RFC 5397</strong></a></p>
+<p><span class="target" id="index-118"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5397.html"><strong>RFC 5397</strong></a></p>
 <blockquote>
 <div>WebDAV Current Principal Extension</div></blockquote>
-<p><span class="target" id="index-113"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5423.html"><strong>RFC 5423</strong></a></p>
+<p><span class="target" id="index-119"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5423.html"><strong>RFC 5423</strong></a></p>
 <blockquote>
 <div>Internet Message Store Events</div></blockquote>
-<p><span class="target" id="index-114"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5429.html"><strong>RFC 5429</strong></a></p>
+<p><span class="target" id="index-120"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5429.html"><strong>RFC 5429</strong></a></p>
 <blockquote>
-<div><p>Sieve Email Filtering: Reject and Extended Reject Extensions</p>
-<div class="admonition note">
-<p class="first admonition-title">Note</p>
-<p class="last">Only the <code class="docutils literal"><span class="pre">reject</span></code> action is currently implemented.</p>
-</div>
-</div></blockquote>
-<p><span class="target" id="index-115"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5435.html"><strong>RFC 5435</strong></a></p>
+<div>Sieve Email Filtering: Reject and Extended Reject Extensions</div></blockquote>
+<p><span class="target" id="index-121"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5435.html"><strong>RFC 5435</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Extension for Notifications</div></blockquote>
-<p><span class="target" id="index-116"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5436.html"><strong>RFC 5436</strong></a></p>
+<p><span class="target" id="index-122"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5436.html"><strong>RFC 5436</strong></a></p>
 <blockquote>
 <div>Sieve Notification Mechanism: mailto</div></blockquote>
-<p><span class="target" id="index-117"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5464.html"><strong>RFC 5464</strong></a></p>
+<p><span class="target" id="index-123"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5463.html"><strong>RFC 5463</strong></a></p>
+<blockquote>
+<div>Sieve Email Filtering: Ihave Extension</div></blockquote>
+<p><span class="target" id="index-124"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5464.html"><strong>RFC 5464</strong></a></p>
 <blockquote>
 <div>The IMAP METADATA Extension</div></blockquote>
-<p><span class="target" id="index-118"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5465.html"><strong>RFC 5465</strong></a></p>
+<p><span class="target" id="index-125"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5490.html"><strong>RFC 5490</strong></a></p>
 <blockquote>
-<div>The IMAP NOTIFY Extension</div></blockquote>
-<p><span class="target" id="index-119"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5524.html"><strong>RFC 5524</strong></a></p>
+<div>The Sieve Mail-Filtering Language &#8211; Extensions for Checking Mailbox
+Status and Accessing Mailbox Metadata</div></blockquote>
+<p><span class="target" id="index-126"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5524.html"><strong>RFC 5524</strong></a></p>
 <blockquote>
 <div>Extended URLFETCH for Binary and Converted Parts</div></blockquote>
-<p><span class="target" id="index-120"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5536.html"><strong>RFC 5536</strong></a></p>
+<p><span class="target" id="index-127"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5536.html"><strong>RFC 5536</strong></a></p>
 <blockquote>
 <div>Netnews Article Format</div></blockquote>
-<p><span class="target" id="index-121"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5537.html"><strong>RFC 5537</strong></a></p>
+<p><span class="target" id="index-128"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5537.html"><strong>RFC 5537</strong></a></p>
 <blockquote>
 <div>Netnews Architecture and Protocols</div></blockquote>
-<p><span class="target" id="index-122"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5545.html"><strong>RFC 5545</strong></a></p>
+<p><span class="target" id="index-129"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5545.html"><strong>RFC 5545</strong></a></p>
 <blockquote>
 <div>Internet Calendaring and Scheduling Core Object Specification
 (iCalendar)</div></blockquote>
-<p><span class="target" id="index-123"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5546.html"><strong>RFC 5546</strong></a></p>
+<p><span class="target" id="index-130"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5546.html"><strong>RFC 5546</strong></a></p>
 <blockquote>
 <div>iCalendar Transport-Independent Interoperability Protocol (iTIP)</div></blockquote>
-<p><span class="target" id="index-124"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5593.html"><strong>RFC 5593</strong></a></p>
+<p><span class="target" id="index-131"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5593.html"><strong>RFC 5593</strong></a></p>
 <blockquote>
 <div>Internet Message Access Protocol (IMAP) - URL Access Identifier
 Extension</div></blockquote>
-<p><span class="target" id="index-125"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5689.html"><strong>RFC 5689</strong></a></p>
+<p><span class="target" id="index-132"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5689.html"><strong>RFC 5689</strong></a></p>
 <blockquote>
 <div>Extended MKCOL for Web Distributed Authoring and Versioning (WebDAV)</div></blockquote>
-<p><span class="target" id="index-126"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5804.html"><strong>RFC 5804</strong></a></p>
+<p><span class="target" id="index-133"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5804.html"><strong>RFC 5804</strong></a></p>
 <blockquote>
 <div>A protocol for Remotely Managing Sieve Scripts</div></blockquote>
-<p><span class="target" id="index-127"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5819.html"><strong>RFC 5819</strong></a></p>
+<p><span class="target" id="index-134"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5819.html"><strong>RFC 5819</strong></a></p>
 <blockquote>
 <div>IMAP4 Extension for Returning STATUS Information in Extended LIST</div></blockquote>
-<p><span class="target" id="index-128"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5957.html"><strong>RFC 5957</strong></a></p>
+<p><span class="target" id="index-135"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5957.html"><strong>RFC 5957</strong></a></p>
 <blockquote>
 <div>Display-Based Address Sorting for the IMAP4 SORT Extension</div></blockquote>
-<p><span class="target" id="index-129"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5995.html"><strong>RFC 5995</strong></a></p>
+<p><span class="target" id="index-136"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5995.html"><strong>RFC 5995</strong></a></p>
 <blockquote>
 <div>Using POST to Add Members to Web Distributed Authoring and
 Versioning (WebDAV) Collections</div></blockquote>
-<p><span class="target" id="index-130"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6047.html"><strong>RFC 6047</strong></a></p>
+<p><span class="target" id="index-137"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6047.html"><strong>RFC 6047</strong></a></p>
 <blockquote>
 <div>iCalendar Message-Based Interoperability Protocol (iMIP)</div></blockquote>
-<p><span class="target" id="index-131"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6101.html"><strong>RFC 6101</strong></a></p>
+<p><span class="target" id="index-138"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6101.html"><strong>RFC 6101</strong></a></p>
 <blockquote>
 <div><p>The Secure Sockets Layer (SSL) Protocol Version 3.0</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
-<p>SSLv3 is considered insecure as it is vulnerable to POODLE.</p>
+<p>SSLv3 is considered inscure as it is vulnerable to POODLE.</p>
 <p class="last">Support for SSLv3 is being deprecated and removed.</p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-132"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6131.html"><strong>RFC 6131</strong></a></p>
+<p><span class="target" id="index-139"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6131.html"><strong>RFC 6131</strong></a></p>
 <blockquote>
 <div>Sieve Vacation Extension: &#8220;Seconds&#8221; Parameter</div></blockquote>
-<p><span class="target" id="index-133"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5463.html"><strong>RFC 5463</strong></a></p>
-<blockquote>
-<div>Sieve Email Filtering: Ihave Extension</div></blockquote>
-<p><span class="target" id="index-134"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6154.html"><strong>RFC 6154</strong></a></p>
+<p><span class="target" id="index-140"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6154.html"><strong>RFC 6154</strong></a></p>
 <blockquote>
 <div><p>IMAP LIST Extension for Special-Use Mailboxes</p>
 <div class="admonition note">
 <p class="first admonition-title">Note</p>
-<p class="last">The LIST and LSUB commands don&#8217;t return by default the special-use flags,
-unless <code class="docutils literal"><span class="pre">specialusealways</span></code> is turned explicitly on.</p>
+<p class="last">The LIST and LSUB commands return the special-use flags, unless the
+<code class="docutils literal"><span class="pre">specialusealways</span></code> configuration variable is explicitly turned off.</p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-135"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6321.html"><strong>RFC 6321</strong></a></p>
+<p><span class="target" id="index-141"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6321.html"><strong>RFC 6321</strong></a></p>
 <blockquote>
 <div>xCal: The XML Format for iCalendar</div></blockquote>
-<p><span class="target" id="index-136"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6350.html"><strong>RFC 6350</strong></a></p>
+<p><span class="target" id="index-142"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6350.html"><strong>RFC 6350</strong></a></p>
 <blockquote>
 <div>vCard Format Specification</div></blockquote>
-<p><span class="target" id="index-137"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6352.html"><strong>RFC 6352</strong></a></p>
+<p><span class="target" id="index-143"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6352.html"><strong>RFC 6352</strong></a></p>
 <blockquote>
 <div>CardDAV: vCard Extensions to Web Distributed Authoring and
 Versioning (WebDAV)</div></blockquote>
-<p><span class="target" id="index-138"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6376.html"><strong>RFC 6376</strong></a></p>
+<p><span class="target" id="index-144"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6376.html"><strong>RFC 6376</strong></a></p>
 <blockquote>
 <div>DomainKeys Identified Mail (DKIM) Signatures</div></blockquote>
-<p><span class="target" id="index-139"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6578.html"><strong>RFC 6578</strong></a></p>
+<p><span class="target" id="index-145"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6578.html"><strong>RFC 6578</strong></a></p>
 <blockquote>
 <div>Collection Synchronization for Web Distributed Authoring and
 Versioning (WebDAV)</div></blockquote>
-<p><span class="target" id="index-140"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6585.html"><strong>RFC 6585</strong></a></p>
+<p><span class="target" id="index-146"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6585.html"><strong>RFC 6585</strong></a></p>
 <blockquote>
 <div>Additional HTTP Status Codes</div></blockquote>
-<p><span class="target" id="index-141"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6609.html"><strong>RFC 6609</strong></a></p>
+<p><span class="target" id="index-147"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6609.html"><strong>RFC 6609</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Include Extension</div></blockquote>
-<p><span class="target" id="index-142"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6638.html"><strong>RFC 6638</strong></a></p>
+<p><span class="target" id="index-148"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6638.html"><strong>RFC 6638</strong></a></p>
 <blockquote>
 <div>Scheduling Extensions to CalDAV</div></blockquote>
-<p><span class="target" id="index-143"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6764.html"><strong>RFC 6764</strong></a></p>
+<p><span class="target" id="index-149"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6764.html"><strong>RFC 6764</strong></a></p>
 <blockquote>
 <div>Locating Services for Calendaring Extensions to WebDAV (CalDAV) and
 vCard Extensions to WebDAV (CardDAV)</div></blockquote>
-<p><span class="target" id="index-144"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6797.html"><strong>RFC 6797</strong></a></p>
+<p><span class="target" id="index-150"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6797.html"><strong>RFC 6797</strong></a></p>
 <blockquote>
 <div>HTTP Strict Transport Security (HSTS)</div></blockquote>
-<p><span class="target" id="index-145"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6851.html"><strong>RFC 6851</strong></a></p>
+<p><span class="target" id="index-151"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6851.html"><strong>RFC 6851</strong></a></p>
 <blockquote>
 <div><p>Internet Message Access Protocol (IMAP) - MOVE Extension</p>
 <div class="versionadded">
 <p><span class="versionmodified">New in version 2.5.0.</span></p>
 </div>
 </div></blockquote>
-<p><span class="target" id="index-146"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7230.html"><strong>RFC 7230</strong></a></p>
+<p><span class="target" id="index-152"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7230.html"><strong>RFC 7230</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing</div></blockquote>
-<p><span class="target" id="index-147"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7231.html"><strong>RFC 7231</strong></a></p>
+<p><span class="target" id="index-153"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7231.html"><strong>RFC 7231</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</div></blockquote>
-<p><span class="target" id="index-148"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7232.html"><strong>RFC 7232</strong></a></p>
+<p><span class="target" id="index-154"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7232.html"><strong>RFC 7232</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Conditional Requests</div></blockquote>
-<p><span class="target" id="index-149"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7233.html"><strong>RFC 7233</strong></a></p>
+<p><span class="target" id="index-155"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7233.html"><strong>RFC 7233</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Range Requests</div></blockquote>
-<p><span class="target" id="index-150"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7234.html"><strong>RFC 7234</strong></a></p>
+<p><span class="target" id="index-156"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7234.html"><strong>RFC 7234</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Caching</div></blockquote>
-<p><span class="target" id="index-151"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7235.html"><strong>RFC 7235</strong></a></p>
+<p><span class="target" id="index-157"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7235.html"><strong>RFC 7235</strong></a></p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP/1.1): Authentication</div></blockquote>
-<p><span class="target" id="index-152"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7238.html"><strong>RFC 7238</strong></a></p>
+<p><span class="target" id="index-158"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7238.html"><strong>RFC 7238</strong></a></p>
 <blockquote>
 <div>The Hypertext Transfer Protocol Status Code 308 (Permanent Redirect)</div></blockquote>
-<p><span class="target" id="index-153"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7239.html"><strong>RFC 7239</strong></a></p>
+<p><span class="target" id="index-159"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7239.html"><strong>RFC 7239</strong></a></p>
 <blockquote>
 <div>Forwarded HTTP Extension</div></blockquote>
-<p><span class="target" id="index-154"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7240.html"><strong>RFC 7240</strong></a></p>
+<p><span class="target" id="index-160"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7240.html"><strong>RFC 7240</strong></a></p>
 <blockquote>
 <div>Prefer Header for HTTP</div></blockquote>
-<p><span class="target" id="index-155"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7265.html"><strong>RFC 7265</strong></a></p>
+<p><span class="target" id="index-161"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7265.html"><strong>RFC 7265</strong></a></p>
 <blockquote>
 <div>jCal: The JSON Format for iCalendar</div></blockquote>
-<p><span class="target" id="index-156"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7529.html"><strong>RFC 7529</strong></a></p>
+<p><span class="target" id="index-162"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7529.html"><strong>RFC 7529</strong></a></p>
+<blockquote>
+<div>Non-Gregorian Recurrence Rules in the Internet Calendaring and
+Scheduling Core Object Specification (iCalendar)</div></blockquote>
+<p><span class="target" id="index-163"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7540.html"><strong>RFC 7540</strong></a></p>
+<blockquote>
+<div>Hypertext Transfer Protocol Version 2 (HTTP/2)</div></blockquote>
+<p><span class="target" id="index-164"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7615.html"><strong>RFC 7615</strong></a></p>
+<blockquote>
+<div>HTTP Authentication-Info and Proxy-Authentication-Info Response
+Header Fields</div></blockquote>
+<p><span class="target" id="index-165"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7616.html"><strong>RFC 7616</strong></a></p>
 <blockquote>
-<div>Non-Gregorian Recurrence Rules in the Internet Calendaring and Scheduling Core Object Specification (iCalendar) (obsoletes draft-ietf-calext-rscale)</div></blockquote>
-<p><span class="target" id="index-157"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7808.html"><strong>RFC 7808</strong></a></p>
+<div>HTTP Digest Access Authentication</div></blockquote>
+<p><span class="target" id="index-166"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7617.html"><strong>RFC 7617</strong></a></p>
+<blockquote>
+<div>The &#8216;Basic&#8217; HTTP Authentication Scheme</div></blockquote>
+<p><span class="target" id="index-167"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7694.html"><strong>RFC 7694</strong></a></p>
+<blockquote>
+<div>Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding</div></blockquote>
+<p><span class="target" id="index-168"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7804.html"><strong>RFC 7804</strong></a></p>
+<blockquote>
+<div>Salted Challenge Response HTTP Authentication Mechanism</div></blockquote>
+<p><span class="target" id="index-169"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7808.html"><strong>RFC 7808</strong></a></p>
 <blockquote>
 <div>Time Zone Data Distribution Service</div></blockquote>
-<p><span class="target" id="index-158"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7809.html"><strong>RFC 7809</strong></a></p>
+<p><span class="target" id="index-170"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7809.html"><strong>RFC 7809</strong></a></p>
 <blockquote>
 <div>CalDAV: Time Zones by Reference</div></blockquote>
-<p><span class="target" id="index-159"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7953.html"><strong>RFC 7953</strong></a></p>
+<p><span class="target" id="index-171"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7932.html"><strong>RFC 7932</strong></a></p>
+<blockquote>
+<div>Brotli Compressed Data Format</div></blockquote>
+<p><span class="target" id="index-172"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7953.html"><strong>RFC 7953</strong></a></p>
 <blockquote>
 <div>Calendar Availability</div></blockquote>
+<p><span class="target" id="index-173"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc8144.html"><strong>RFC 8144</strong></a></p>
+<blockquote>
+<div>Use of the Prefer Header Field in Web Distributed Authoring and
+Versioning (WebDAV)</div></blockquote>
 <div class="section" id="ietf-rfc-drafts">
 <h2>IETF RFC Drafts<a class="headerlink" href="#ietf-rfc-drafts" title="Permalink to this headline">¶</a></h2>
 <p>draft-murchison-lmtp-ignorequota</p>
@@ -1290,60 +1342,30 @@ vCard Extensions to WebDAV (CardDAV)</di
 <p>draft-thomson-hybi-http-timeout</p>
 <blockquote>
 <div>Hypertext Transfer Protocol (HTTP) Keep-Alive Header</div></blockquote>
-<p>draft-murchison-webdav-prefer</p>
-<blockquote>
-<div>Use of the Prefer Header Field in Web Distributed Authoring and
-Versioning (WebDAV)</div></blockquote>
-<p>draft-ietf-httpauth-basicauth-update</p>
-<blockquote>
-<div>The &#8216;Basic&#8217; HTTP Authentication Scheme</div></blockquote>
-<p>draft-ietf-httpauth-digest</p>
-<blockquote>
-<div>HTTP Digest Access Authentication</div></blockquote>
-<p>draft-ietf-httpbis-auth-info</p>
-<blockquote>
-<div>The Hypertext Transfer Protocol (HTTP) Authentication-Info and
-Proxy- Authentication-Info Response Header Fields</div></blockquote>
-<p>draft-ietf-httpbis-cice</p>
-<blockquote>
-<div>Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding</div></blockquote>
 <blockquote>
 <div>caldav-ctag     Calendar Collection Entity Tag (CTag) in CalDAV
 Brief Header    Microsoft &#8216;Brief&#8217; header extension</div></blockquote>
 </div>
 <div class="section" id="rfc-wishlist">
 <h2>RFC Wishlist<a class="headerlink" href="#rfc-wishlist" title="Permalink to this headline">¶</a></h2>
-<p><span class="target" id="index-160"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5183.html"><strong>RFC 5183</strong></a></p>
-<blockquote>
-<div>Sieve Email Filtering: Environment Extension</div></blockquote>
-<p><span class="target" id="index-161"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5235.html"><strong>RFC 5235</strong></a></p>
+<p><span class="target" id="index-174"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5235.html"><strong>RFC 5235</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: Spamtest and Virustest Extensions</div></blockquote>
-<p><span class="target" id="index-162"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5293.html"><strong>RFC 5293</strong></a></p>
-<blockquote>
-<div>Sieve Email Filtering: Editheader Extension</div></blockquote>
-<p><span class="target" id="index-163"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5429.html"><strong>RFC 5429</strong></a></p>
-<blockquote>
-<div>Sieve Email Filtering: Reject and Extended Reject Extensions</div></blockquote>
-<p><span class="target" id="index-164"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5437.html"><strong>RFC 5437</strong></a></p>
+<p><span class="target" id="index-175"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5437.html"><strong>RFC 5437</strong></a></p>
 <blockquote>
 <div>Sieve Notification Mechanism: Extensible Messaging and Presence
 Protocol (XMPP)</div></blockquote>
-<p><span class="target" id="index-165"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5490.html"><strong>RFC 5490</strong></a></p>
-<blockquote>
-<div>The Sieve Mail-Filtering Language &#8211; Extensions for Checking Mailbox
-Status and Accessing Mailbox Metadata</div></blockquote>
-<p><span class="target" id="index-166"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5703.html"><strong>RFC 5703</strong></a></p>
+<p><span class="target" id="index-176"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc5703.html"><strong>RFC 5703</strong></a></p>
 <blockquote>
 <div>Sieve Email Filtering: MIME Part Tests, Iteration, Extraction,
 Replacement, and Enclosure</div></blockquote>
-<p><span class="target" id="index-167"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6468.html"><strong>RFC 6468</strong></a></p>
+<p><span class="target" id="index-177"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6468.html"><strong>RFC 6468</strong></a></p>
 <blockquote>
 <div>Sieve Notification Mechanism: SIP MESSAGE</div></blockquote>
-<p><span class="target" id="index-168"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6558.html"><strong>RFC 6558</strong></a></p>
+<p><span class="target" id="index-178"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6558.html"><strong>RFC 6558</strong></a></p>
 <blockquote>
 <div>Sieve Extension for Converting Messages before Delivery</div></blockquote>
-<p><span class="target" id="index-169"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6785.html"><strong>RFC 6785</strong></a></p>
+<p><span class="target" id="index-179"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6785.html"><strong>RFC 6785</strong></a></p>
 <blockquote>
 <div>Support for Internet Message Access Protocol (IMAP) Events in Sieve</div></blockquote>
 </div>
@@ -1358,7 +1380,7 @@ Replacement, and Enclosure</div></blockq
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 08 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1378,7 +1400,7 @@ Replacement, and Enclosure</div></blockq
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/support/feedback-bugs.html 3.2.0-3/doc/html/imap/support/feedback-bugs.html
--- 3.0.13-5/doc/html/imap/support/feedback-bugs.html	2019-12-16 04:18:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/support/feedback-bugs.html	2020-05-04 04:13:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Reporting Bugs &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Reporting Bugs &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Support/Community" href="../../support.html"/>
         <link rel="next" title="Mailing Lists" href="feedback-mailing-lists.html"/>
         <link rel="prev" title="Support/Community" href="../../support.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../support.html">Support/Community</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/support/feedback-bugs.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/support/feedback-bugs.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -816,7 +835,7 @@ If package management, for whatever reas
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 26 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 26 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -836,7 +855,7 @@ If package management, for whatever reas
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/support/feedback-irc.html 3.2.0-3/doc/html/imap/support/feedback-irc.html
--- 3.0.13-5/doc/html/imap/support/feedback-irc.html	2019-12-16 04:18:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/support/feedback-irc.html	2020-05-04 04:13:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>IRC Chat &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>IRC Chat &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Support/Community" href="../../support.html"/>
         <link rel="next" title="Online Meetings" href="feedback-meetings.html"/>
         <link rel="prev" title="Mailing Lists" href="feedback-mailing-lists.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../support.html">Support/Community</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/support/feedback-irc.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/support/feedback-irc.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -795,7 +814,7 @@ around to talk to in a friendly, helpful
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 26 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 26 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -815,7 +834,7 @@ around to talk to in a friendly, helpful
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/support/feedback-mailing-lists.html 3.2.0-3/doc/html/imap/support/feedback-mailing-lists.html
--- 3.0.13-5/doc/html/imap/support/feedback-mailing-lists.html	2019-12-16 04:18:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/support/feedback-mailing-lists.html	2020-05-04 04:13:41.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Mailing Lists &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Mailing Lists &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Support/Community" href="../../support.html"/>
         <link rel="next" title="IRC Chat" href="feedback-irc.html"/>
         <link rel="prev" title="Reporting Bugs" href="feedback-bugs.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../support.html">Support/Community</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/support/feedback-mailing-lists.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/support/feedback-mailing-lists.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -797,22 +816,22 @@ maintainers, for all the Cyrus software.
 <ul class="simple">
 <li><dl class="first docutils">
 <dt><strong>cyrus-announce</strong></dt>
-<dd><a class="reference external" href="imap://cyrus.andrew.cmu.edu/archive.cyrus-announce">Anonymous IMAP</a> : <a class="reference external" href="http://asg.web.cmu.edu/bb/archive.cyrus-announce">Web/HTTP</a> or <a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-announce/">Pipermail</a></dd>
+<dd><a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-announce/">Web/HTTP via Pipermail</a></dd>
 </dl>
 </li>
 <li><dl class="first docutils">
 <dt><strong>info-cyrus</strong></dt>
-<dd><a class="reference external" href="imap://cyrus.andrew.cmu.edu/archive.info-cyrus">Anonymous IMAP</a> : <a class="reference external" href="http://asg.web.cmu.edu/bb/archive.info-cyrus">Web/HTTP</a> or <a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/info-cyrus/">Pipermail</a></dd>
+<dd><a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/info-cyrus/">Web/HTTP via Pipermail</a></dd>
 </dl>
 </li>
 <li><dl class="first docutils">
 <dt><strong>cyrus-sasl</strong></dt>
-<dd><a class="reference external" href="imap://cyrus.andrew.cmu.edu/archive.cyrus-sasl">Anonymous IMAP</a>: <a class="reference external" href="http://asg.web.cmu.edu/bb/archive.cyrus-sasl">Web/HTTP</a> or <a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/">Pipermail</a></dd>
+<dd><a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/">Web/HTTP via Pipermail</a></dd>
 </dl>
 </li>
 <li><dl class="first docutils">
 <dt><strong>cyrus-devel</strong></dt>
-<dd><a class="reference external" href="imap://cyrus.andrew.cmu.edu/archive.cyrus-devel">Anonymous IMAP</a> : <a class="reference external" href="http://asg.web.cmu.edu/bb/archive.cyrus-devel">Web/HTTP</a> or <a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-devel/">Pipermail</a></dd>
+<dd><a class="reference external" href="http://lists.andrew.cmu.edu/pipermail/cyrus-devel/">Web/HTTP via Pipermail</a></dd>
 </dl>
 </li>
 </ul>
@@ -868,7 +887,7 @@ maintainers, for all the Cyrus software.
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jan 15 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -888,7 +907,7 @@ maintainers, for all the Cyrus software.
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/imap/support/feedback-meetings.html 3.2.0-3/doc/html/imap/support/feedback-meetings.html
--- 3.0.13-5/doc/html/imap/support/feedback-meetings.html	2019-12-16 04:18:14.000000000 +0000
+++ 3.2.0-3/doc/html/imap/support/feedback-meetings.html	2020-05-04 04:13:42.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Online Meetings &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Online Meetings &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../../genindex.html"/>
         <link rel="search" title="Search" href="../../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../../index.html"/>
         <link rel="up" title="Support/Community" href="../../support.html"/>
         <link rel="next" title="About Cyrus" href="../../overview/about_cyrus.html"/>
         <link rel="prev" title="IRC Chat" href="feedback-irc.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../../support.html">Support/Community</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/imap/support/feedback-meetings.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/imap/support/feedback-meetings.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -793,7 +812,7 @@ to confirm the time and URL if nobody el
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 16 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 16 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -813,7 +832,7 @@ to confirm the time and URL if nobody el
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/index.html 3.2.0-3/doc/html/index.html
--- 3.0.13-5/doc/html/index.html	2019-12-16 04:18:15.000000000 +0000
+++ 3.2.0-3/doc/html/index.html	2020-05-04 04:13:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>What is Cyrus IMAP? &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>What is Cyrus IMAP? &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="#"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="#"/>
         <link rel="next" title="Download" href="download.html"/> 
 
   
@@ -128,19 +128,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -157,22 +162,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -329,19 +331,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -390,6 +392,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -417,7 +420,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -506,34 +509,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -550,6 +525,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -566,10 +542,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -582,10 +556,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -646,6 +618,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -665,9 +638,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -725,7 +744,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -745,13 +764,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="#">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="#">Docs v3.2.0</a> &raquo;</li>
       
     <li>What is Cyrus IMAP?</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/index.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/index.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -764,8 +783,8 @@
 <span id="imap-index"></span><h1>What is Cyrus IMAP?<a class="headerlink" href="#what-is-cyrus-imap" title="Permalink to this headline">¶</a></h1>
 <p>Cyrus IMAP is an email, contacts and calendar server. Cyrus is free and open source.</p>
 <ul class="simple">
-<li>This is the documentation for version 3.0.13 (stable) of Cyrus IMAP: <strong>stable</strong> branch.</li>
-<li>The latest development version 3.1.8 is at <a class="reference external" href="https://www.cyrusimap.org/dev/">https://www.cyrusimap.org/dev/</a>.</li>
+<li>This is the documentation for version 3.2.0 of Cyrus IMAP: <strong>stable</strong> branch.</li>
+<li>The latest development version 3.3.0-dev0 is at <a class="reference external" href="https://www.cyrusimap.org/dev/">https://www.cyrusimap.org/dev/</a>.</li>
 </ul>
 <div class="section" id="features">
 <h2>Features<a class="headerlink" href="#features" title="Permalink to this headline">¶</a></h2>
@@ -782,6 +801,7 @@
 <li>Supports antivirus and antispam toolkits</li>
 <li>Handles deliverability: SPF, DKIM, DMARC</li>
 <li>Extensive authentication options, through Cyrus SASL</li>
+<li>JMAP support</li>
 <li>Long list of supported standards</li>
 </ul>
 <p>Read more in our full <a class="reference internal" href="imap/concepts/features.html#imap-features"><span class="std std-ref">list of features</span></a>.</p>
@@ -804,10 +824,12 @@ systems around the world, at universitie
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a></li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#services-in-etc-services">Services in <code class="docutils literal"><span class="pre">/etc/services</span></code></a></li>
@@ -820,17 +842,14 @@ systems around the world, at universitie
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -880,14 +899,14 @@ systems around the world, at universitie
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -917,34 +936,6 @@ systems around the world, at universitie
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#user-commands">(1) User Commands</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#management">Management</a></li>
@@ -980,9 +971,17 @@ systems around the world, at universitie
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a></li>
 </ul>
 </li>
 </ul>
@@ -1040,7 +1039,7 @@ systems around the world, at universitie
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Nov 15 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Feb 10 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1060,7 +1059,7 @@ systems around the world, at universitie
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
Binary files 3.0.13-5/doc/html/objects.inv and 3.2.0-3/doc/html/objects.inv differ
diff -pruN 3.0.13-5/doc/html/operations.html 3.2.0-3/doc/html/operations.html
--- 3.0.13-5/doc/html/operations.html	2019-12-16 04:18:15.000000000 +0000
+++ 3.2.0-3/doc/html/operations.html	2020-05-04 04:13:43.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Operations &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Operations &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Man pages" href="imap/reference/manpages/commands.html"/>
         <link rel="prev" title="Supported Platforms and System Requirements" href="imap/concepts/deployment/supported-platforms.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Operations</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/operations.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/operations.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -771,34 +790,6 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html#user-commands">(1) User Commands</a></li>
 </ul>
 </li>
-<li class="toctree-l1"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l1"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html#management">Management</a></li>
@@ -814,11 +805,6 @@
 </li>
 </ul>
 </div>
-<blockquote>
-<div>manpages
-adminref
-sop
-othertasks</div></blockquote>
 </div>
 
 
@@ -839,7 +825,7 @@ othertasks</div></blockquote>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jun 15 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -859,7 +845,7 @@ othertasks</div></blockquote>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/about_cyrus.html 3.2.0-3/doc/html/overview/about_cyrus.html
--- 3.0.13-5/doc/html/overview/about_cyrus.html	2019-12-16 04:18:16.000000000 +0000
+++ 3.2.0-3/doc/html/overview/about_cyrus.html	2020-05-04 04:13:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>About Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>About Cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="Support/Community" href="../support.html"/>
         <link rel="next" title="About Cyrus" href="what_is_cyrus.html"/>
         <link rel="prev" title="Online Meetings" href="../imap/support/feedback-meetings.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -755,7 +774,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/about_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/about_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -817,7 +836,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 24 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 24 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -837,7 +856,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/cyrus_bylaws.html 3.2.0-3/doc/html/overview/cyrus_bylaws.html
--- 3.0.13-5/doc/html/overview/cyrus_bylaws.html	2019-12-16 04:18:16.000000000 +0000
+++ 3.2.0-3/doc/html/overview/cyrus_bylaws.html	2020-05-04 04:13:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Bylaws &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Bylaws &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="About Cyrus" href="about_cyrus.html"/>
         <link rel="prev" title="Cyrus History" href="cyrus_history.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,7 +765,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -756,7 +775,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/cyrus_bylaws.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/cyrus_bylaws.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -833,7 +852,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 24 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 24 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -853,7 +872,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/cyrus_history.html 3.2.0-3/doc/html/overview/cyrus_history.html
--- 3.0.13-5/doc/html/overview/cyrus_history.html	2019-12-16 04:18:17.000000000 +0000
+++ 3.2.0-3/doc/html/overview/cyrus_history.html	2020-05-04 04:13:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus History &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus History &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="About Cyrus" href="about_cyrus.html"/>
         <link rel="next" title="Cyrus Bylaws" href="cyrus_bylaws.html"/>
         <link rel="prev" title="Cyrus Roadmap" href="cyrus_roadmap.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/cyrus_history.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/cyrus_history.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -802,7 +821,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 29 2019
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -822,7 +841,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/cyrus_roadmap.html 3.2.0-3/doc/html/overview/cyrus_roadmap.html
--- 3.0.13-5/doc/html/overview/cyrus_roadmap.html	2019-12-16 04:18:17.000000000 +0000
+++ 3.2.0-3/doc/html/overview/cyrus_roadmap.html	2020-05-04 04:13:45.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Cyrus Roadmap &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Cyrus Roadmap &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="About Cyrus" href="about_cyrus.html"/>
         <link rel="next" title="Cyrus History" href="cyrus_history.html"/>
         <link rel="prev" title="Who Is Cyrus" href="who_is_cyrus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/cyrus_roadmap.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/cyrus_roadmap.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -775,7 +794,8 @@
 <div class="section" id="future">
 <h3>Future<a class="headerlink" href="#future" title="Permalink to this headline">¶</a></h3>
 <ul class="simple">
-<li>JMAP support</li>
+<li>JMAP support (Contacts, calendars and emails)</li>
+<li>Improved CalDAV and CardDAV support</li>
 <li>Improved backup support</li>
 <li>Multi-master replication</li>
 </ul>
@@ -783,10 +803,9 @@
 <div class="section" id="x">
 <h3>3.0.x<a class="headerlink" href="#x" title="Permalink to this headline">¶</a></h3>
 <ul class="simple">
-<li>Better calendaring support through jmap</li>
 <li>Cross-folder conversations</li>
 <li>Support for fuzzy Xapian search.</li>
-<li>CardDAV support</li>
+<li>CalDAV and CardDAV support</li>
 <li>Better backup support - initial release</li>
 <li>Basic object storage</li>
 <li>Archive partition support</li>
@@ -841,7 +860,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Jul 12 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -861,7 +880,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/what_is_cyrus.html 3.2.0-3/doc/html/overview/what_is_cyrus.html
--- 3.0.13-5/doc/html/overview/what_is_cyrus.html	2019-12-16 04:18:17.000000000 +0000
+++ 3.2.0-3/doc/html/overview/what_is_cyrus.html	2020-05-04 04:13:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>About Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>About Cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="About Cyrus" href="about_cyrus.html"/>
         <link rel="next" title="Who Is Cyrus" href="who_is_cyrus.html"/>
         <link rel="prev" title="About Cyrus" href="about_cyrus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/what_is_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/what_is_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -814,7 +833,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -834,7 +853,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview/who_is_cyrus.html 3.2.0-3/doc/html/overview/who_is_cyrus.html
--- 3.0.13-5/doc/html/overview/who_is_cyrus.html	2019-12-16 04:18:17.000000000 +0000
+++ 3.2.0-3/doc/html/overview/who_is_cyrus.html	2020-05-04 04:13:46.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Who Is Cyrus &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Who Is Cyrus &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="../genindex.html"/>
         <link rel="search" title="Search" href="../search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="../index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="../index.html"/>
         <link rel="up" title="About Cyrus" href="about_cyrus.html"/>
         <link rel="next" title="Cyrus Roadmap" href="cyrus_roadmap.html"/>
         <link rel="prev" title="About Cyrus" href="what_is_cyrus.html"/> 
@@ -130,19 +130,24 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -159,22 +164,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="../quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -331,19 +333,19 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="../imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -392,6 +394,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -419,7 +422,7 @@
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -508,34 +511,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="../imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/architecture.html">System Architecture</a></li>
@@ -552,6 +527,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -568,10 +544,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -584,10 +558,8 @@
 <li class="toctree-l3"><a class="reference internal" href="../imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -648,6 +620,7 @@
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="../imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -667,9 +640,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="../imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="../imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="../developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="../imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="../imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -727,7 +746,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -747,7 +766,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="../index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="../index.html">Docs v3.2.0</a> &raquo;</li>
       
           <li><a href="../support.html">Support/Community</a> &raquo;</li>
       
@@ -757,7 +776,7 @@
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview/who_is_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview/who_is_cyrus.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -859,7 +878,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 24 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 24 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -879,7 +898,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'../',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/overview.html 3.2.0-3/doc/html/overview.html
--- 3.0.13-5/doc/html/overview.html	2019-12-16 04:18:16.000000000 +0000
+++ 3.2.0-3/doc/html/overview.html	2020-05-04 04:13:44.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Overview &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Overview &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Features" href="imap/concepts/features.html"/>
         <link rel="prev" title="Introduction to Cyrus IMAP" href="imap/quickstart/introduction.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Overview</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/overview.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/overview.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -812,7 +831,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Mar 07 2018
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -832,7 +851,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/preface.html 3.2.0-3/doc/html/preface.html
--- 3.0.13-5/doc/html/preface.html	2019-12-16 04:18:18.000000000 +0000
+++ 3.2.0-3/doc/html/preface.html	2020-05-04 04:13:47.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Preface &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Preface &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Preface</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/preface.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/preface.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -778,7 +797,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Oct 25 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Oct 25 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -798,7 +817,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/quickstart.html 3.2.0-3/doc/html/quickstart.html
--- 3.0.13-5/doc/html/quickstart.html	2019-12-16 04:18:18.000000000 +0000
+++ 3.2.0-3/doc/html/quickstart.html	2020-05-04 04:13:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Quickstart Guide &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Quickstart Guide &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Introduction to Cyrus IMAP" href="imap/quickstart/introduction.html"/>
         <link rel="prev" title="Notes for Packagers" href="imap/download/packagers.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Quickstart Guide</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/quickstart.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/quickstart.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -771,57 +790,23 @@
 </li>
 </ul>
 </div>
-<div class="section" id="coming-soon">
-<h2>Coming Soon<a class="headerlink" href="#coming-soon" title="Permalink to this headline">¶</a></h2>
-<div class="admonition note">
-<p class="first admonition-title">Note</p>
-<p class="last">The deb packages referenced below are not yet available.  Sorry!</p>
-</div>
-</div>
 <div class="section" id="quick-install">
 <h2>Quick install<a class="headerlink" href="#quick-install" title="Permalink to this headline">¶</a></h2>
 <p>A quick guide to getting a basic installation of Cyrus up and running in 5 minutes.</p>
 <p>The first place to start with a new installation of Cyrus IMAP is with
-your OS distribution of choice and their packaging, where available.  If
-there is no Cyrus IMAP 3.0 package available yet from your distro,
-download the <a class="reference external" href="ftp://ftp.cyrusimap.org/cyrus-imapd/debs/">latest stable package</a> : version 3.0.13.</p>
-<p>We only provide limited options for reference packages, so use a
-supported distribution whenever possible.  At this time the only
-official Cyrus packages are for Debian Jessie (with backports enabled).</p>
-<p>Please download both the packages (*.deb) and the signature files.
-Installation is a two step process:</p>
-<div class="section" id="install-cyrus-reference-packages">
-<h3>1. Install Cyrus reference packages<a class="headerlink" href="#install-cyrus-reference-packages" title="Permalink to this headline">¶</a></h3>
-<p>First, invoke the <code class="docutils literal"><span class="pre">dpkg</span> <span class="pre">-i</span></code> command with the list of all packages:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span>$ sudo dpkg -i \
-    cyrus-common_3.0.1-jessie_amd64.deb  \
-    cyrus-doc_3.0.1-jessie_all.deb  \
-    cyrus-imapd_3.0.1-jessie_amd64.deb  \
-    cyrus-pop3d_3.0.1-jessie_amd64.deb  \
-    cyrus-admin_3.0.1-jessie_all.deb  \
-    cyrus-murder_3.0.1-jessie_amd64.deb  \
-    cyrus-replication_3.0.1-jessie_amd64.deb  \
-    cyrus-nntpd_3.0.1-jessie_amd64.deb  \
-    cyrus-caldav_3.0.1-jessie_amd64.deb  \
-    cyrus-clients_3.0.1-jessie_amd64.deb  \
-    cyrus-dev_3.0.1-jessie_amd64.deb  \
-    libcyrus-imap-perl_3.0.1-jessie_amd64.deb
-</pre></div>
-</div>
-<p>That step will produce an error, as there will doubtless be unmet
-dependencies.  Not to worry, there&#8217;s a fix for that...</p>
-</div>
-<div class="section" id="use-apt-get-install-f-to-complete-installation">
-<h3>2. Use &#8220;apt-get install -f&#8221; to complete installation<a class="headerlink" href="#use-apt-get-install-f-to-complete-installation" title="Permalink to this headline">¶</a></h3>
-<p>Now invoke <code class="docutils literal"><span class="pre">apt-get</span> <span class="pre">install</span> <span class="pre">-f</span></code> to pull in the dependencies and
-complete the installation:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span>$ sudo apt-get install -f
-</pre></div>
-</div>
-<p>The packaging should pull along all necessary support libraries, etc..</p>
+your OS distribution of choice and their packaging, where available.</p>
+<p>If there is no Cyrus IMAP 3.2.0 package available yet
+from your distro, download the official source tarball from <a class="reference external" href="https://github.com/cyrusimap/cyrus-imapd/releases">GitHub</a>.  The
+<a class="reference internal" href="imap/developer/compiling.html#compiling"><span class="std std-ref">Compiling</span></a> guide will help you get it built and installed.</p>
+<div class="section" id="install-cyrus-package-s">
+<h3>1. Install Cyrus package(s)<a class="headerlink" href="#install-cyrus-package-s" title="Permalink to this headline">¶</a></h3>
+<p>Install the Cyrus IMAP package(s), either from your distribution&#8217;s package
+manager, or from a release tarball.</p>
+<p>Your distribution might have split Cyrus IMAP into several packages.  Check
+their documentation if you&#8217;re not sure what you need.</p>
 </div>
 <div class="section" id="setup-the-cyrus-mail-user-and-group">
-<h3>3. Setup the cyrus:mail user and group<a class="headerlink" href="#setup-the-cyrus-mail-user-and-group" title="Permalink to this headline">¶</a></h3>
+<h3>2. Setup the cyrus:mail user and group<a class="headerlink" href="#setup-the-cyrus-mail-user-and-group" title="Permalink to this headline">¶</a></h3>
 <p>Now let&#8217;s create a <strong>special user account just for the Cyrus server</strong>
 to sandbox Cyrus: called <code class="docutils literal"><span class="pre">cyrus</span></code>. We&#8217;ll also create a <code class="docutils literal"><span class="pre">mail</span></code> group
 as well. This allows Cyrus to give other programs some permissions if
@@ -864,7 +849,7 @@ the PKI files.  On Debian/Ubuntu systems
 </div>
 </div>
 <div class="section" id="setting-up-authentication-with-sasl">
-<h3>4. Setting up authentication with SASL<a class="headerlink" href="#setting-up-authentication-with-sasl" title="Permalink to this headline">¶</a></h3>
+<h3>3. Setting up authentication with SASL<a class="headerlink" href="#setting-up-authentication-with-sasl" title="Permalink to this headline">¶</a></h3>
 <p>Now, let&#8217;s set up <strong>SASL</strong>. This will allow you to connect to your
 local IMAP server and login, just like any IMAP user would before
 checking for new emails.</p>
@@ -903,7 +888,7 @@ the user exists and is set up correctly:
 <p>You should get an <code class="docutils literal"><span class="pre">0:</span> <span class="pre">OK</span> <span class="pre">&quot;Success.&quot;</span></code> message.</p>
 </div>
 <div class="section" id="setup-mail-delivery-from-your-mta">
-<h3>5. Setup mail delivery from your MTA<a class="headerlink" href="#setup-mail-delivery-from-your-mta" title="Permalink to this headline">¶</a></h3>
+<h3>4. Setup mail delivery from your MTA<a class="headerlink" href="#setup-mail-delivery-from-your-mta" title="Permalink to this headline">¶</a></h3>
 <p>Your Cyrus IMAP server will want to receive the emails accepted by your
 SMTP server (ie Sendmail, Postfix, etc). In Cyrus, this happens via a
 protocol called LMTP, which is usually supported by your SMTP server.</p>
@@ -959,7 +944,13 @@ documentation at <a class="reference ext
 <ol class="arabic">
 <li><p class="first">Setup your recipient maps, thus defining for which recipients the
 <code class="docutils literal"><span class="pre">virtual</span></code> destination will be used:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">postconf</span> <span class="o">-</span><span class="n">e</span> <span class="s2">&quot;virtual_recipient_maps=hash:/etc/postfix/virtual_recipient_domains,hash:/etc/postfix/virtual_recipients&quot;</span>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">postconf</span> <span class="o">-</span><span class="n">e</span> <span class="s2">&quot;virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains&quot;</span>
+<span class="n">postconf</span> <span class="o">-</span><span class="n">e</span> <span class="s2">&quot;virtual_mailbox_maps=hash:/etc/postfix/virtual_recipients&quot;</span>
+</pre></div>
+</div>
+<p>or, if you have enabled smmapd you can automatically track mailboxes with:</p>
+<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">postconf</span> <span class="o">-</span><span class="n">e</span> <span class="s2">&quot;virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains&quot;</span>
+<span class="n">postconf</span> <span class="o">-</span><span class="n">e</span> <span class="s2">&quot;virtual_mailbox_maps=socketmap:unix:/run/cyrus/socket/smmap&quot;</span>
 </pre></div>
 </div>
 </li>
@@ -991,7 +982,7 @@ version of this, where the socket patch
 </div>
 </div>
 <div class="section" id="protocol-ports">
-<h3>6. Protocol ports<a class="headerlink" href="#protocol-ports" title="Permalink to this headline">¶</a></h3>
+<h3>5. Protocol ports<a class="headerlink" href="#protocol-ports" title="Permalink to this headline">¶</a></h3>
 <p>The Cyrus IMAP server provides service interfaces via either TCP/IP
 ports or Unix domain sockets.  For the former, Cyrus requires that there
 are proper entries in the host&#8217;s <code class="docutils literal"><span class="pre">/etc/services</span></code> file.  The following
@@ -1014,7 +1005,7 @@ are required for any host using the list
 <p>Make sure that these lines are present or add them if they are missing.</p>
 </div>
 <div class="section" id="configuring-cyrus">
-<h3>7. Configuring Cyrus<a class="headerlink" href="#configuring-cyrus" title="Permalink to this headline">¶</a></h3>
+<h3>6. Configuring Cyrus<a class="headerlink" href="#configuring-cyrus" title="Permalink to this headline">¶</a></h3>
 <p>(Nearly there)</p>
 <p>Set up a simple directory structure for Cyrus to store emails, owned by
 the <code class="docutils literal"><span class="pre">cyrus</span></code> user and group <code class="docutils literal"><span class="pre">mail</span></code>:</p>
@@ -1124,83 +1115,14 @@ in a Murder or Replication environment.<
 </div>
 </div>
 <div class="section" id="launch-cyrus">
-<h3>8. Launch Cyrus<a class="headerlink" href="#launch-cyrus" title="Permalink to this headline">¶</a></h3>
-<p>If using our packages on Debian Jessie, you will have a SystemV
-compatible init script installed, with systemd support.  Start Cyrus
-with the following command:</p>
-<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">systemctl</span> <span class="n">start</span> <span class="n">cyrus</span><span class="o">-</span><span class="n">imapd</span>
-</pre></div>
-</div>
-<p>Tada!  You should now have a working Cyrus IMAP server.</p>
-</div>
-<div class="section" id="feature-overview">
-<h3>Feature overview<a class="headerlink" href="#feature-overview" title="Permalink to this headline">¶</a></h3>
-<p>The features (compile-time configuration options) supported in our
-reference packages are:</p>
-<dl class="docutils">
-<dt>Cyrus Server configured components</dt>
-<dd><ul class="first last simple">
-<li>event notification : yes</li>
-<li>gssapi             : /usr</li>
-<li>autocreate         : yes</li>
-<li>idled              : yes</li>
-<li>httpd              : yes</li>
-<li>kerberos V4        : no</li>
-<li>murder             : yes</li>
-<li>nntpd              : yes</li>
-<li>replication        : yes</li>
-<li>sieve              : yes</li>
-<li>calalarmd          : no</li>
-<li>objectstore        : no</li>
-<li>backup             : no</li>
-</ul>
-</dd>
-<dt>External dependencies</dt>
-<dd><ul class="first last simple">
-<li>ldap              : yes</li>
-<li>openssl           : yes</li>
-<li>zlib              : yes</li>
-<li>pcre              : yes</li>
-<li>clamav            : yes</li>
-<li>snmp              : yes</li>
-<li>caringo           : no</li>
-<li>openio            : no</li>
-<li>nghttp2           : no</li>
-<li>brotli            : no</li>
-<li>xml2              : yes</li>
-<li>ical              : yes</li>
-<li>icu4c             : no</li>
-<li>shapelib          : no</li>
-</ul>
-</dd>
-<dt>Database support</dt>
-<dd><ul class="first last simple">
-<li>mysql             : no</li>
-<li>postgresql        : no</li>
-<li>sqlite            : yes</li>
-<li>lmdb              : no</li>
-</ul>
-</dd>
-<dt>Search engine</dt>
-<dd><ul class="first last simple">
-<li>squat             : yes</li>
-<li>sphinx            : no</li>
-<li>xapian            : yes</li>
-<li>xapian_flavor     : vanilla</li>
-</ul>
-</dd>
-<dt>Hardware support</dt>
-<dd><ul class="first last simple">
-<li>SSE4.2            : yes</li>
-</ul>
-</dd>
-<dt>Installation directories</dt>
-<dd><ul class="first last simple">
-<li>prefix            : /usr</li>
-<li>sysconfdir        : /etc</li>
-</ul>
-</dd>
-</dl>
+<h3>7. Launch Cyrus<a class="headerlink" href="#launch-cyrus" title="Permalink to this headline">¶</a></h3>
+<p>If using a distribution package, you probably now have an init script
+installed, that you can invoke with your system&#8217;s usual service control
+mechanism.</p>
+<p>If you built from source, you will need to write your own init script.
+The simplest one will simply start/stop the <a class="reference internal" href="imap/reference/manpages/systemcommands/master.html#std:cyrusman-master(8)">master(8)</a> binary,
+with suitable options, as root (master will drop root privileges itself
+as soon as it possibly can).</p>
 </div>
 </div>
 </div>
@@ -1223,7 +1145,7 @@ reference packages are:</p>
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Jan 24 2018
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Apr 29 2020
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -1243,7 +1165,7 @@ reference packages are:</p>
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/search.html 3.2.0-3/doc/html/search.html
--- 3.0.13-5/doc/html/search.html	2019-12-16 04:18:20.000000000 +0000
+++ 3.2.0-3/doc/html/search.html	2020-05-04 04:13:51.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Search &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Search &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="#"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,7 +763,7 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li></li>
       <li class="wy-breadcrumbs-aside">
@@ -777,7 +796,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team.
+        &copy; Copyright 1993-2018, The Cyrus Team.
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -797,7 +816,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/searchindex.js 3.2.0-3/doc/html/searchindex.js
--- 3.0.13-5/doc/html/searchindex.js	2019-12-16 04:18:20.000000000 +0000
+++ 3.2.0-3/doc/html/searchindex.js	2020-05-04 04:13:51.000000000 +0000
@@ -1 +1 @@
-Search.setIndex({envversion:49,filenames:["contribute","developers","download","glossary","imap/concepts/deployment","imap/concepts/deployment/authentication_and_authorization","imap/concepts/deployment/databases","imap/concepts/deployment/deployment_scenarios","imap/concepts/deployment/known_protocol_limitations","imap/concepts/deployment/mailbox_creation_distribution","imap/concepts/deployment/performance_recommendations","imap/concepts/deployment/storage","imap/concepts/deployment/supported-platforms","imap/concepts/features","imap/concepts/features/access-control","imap/concepts/features/archiving","imap/concepts/features/authentication-kerberos","imap/concepts/features/authentication-ldap","imap/concepts/features/authentication-sql","imap/concepts/features/automatic-creation-of-mailboxes","imap/concepts/features/caldav-collections","imap/concepts/features/carddav","imap/concepts/features/dav-collection-mgmt","imap/concepts/features/dav-components","imap/concepts/features/delayed-delete","imap/concepts/features/delayed-expunge","imap/concepts/features/duplicate-message-delivery-suppression","imap/concepts/features/event-notifications","imap/concepts/features/mail-spool-partitions","imap/concepts/features/mailbox-annotations","imap/concepts/features/mailbox-distribution","imap/concepts/features/mailbox-metadata-partitions","imap/concepts/features/message-annotations","imap/concepts/features/namespaces","imap/concepts/features/quota","imap/concepts/features/sealed-system","imap/concepts/features/server-aggregation","imap/concepts/features/server-side-filtering","imap/concepts/features/shared-seen-state","imap/concepts/features/single-instance-store","imap/concepts/features/virtual-domains","imap/concepts/overview_and_concepts","imap/developer","imap/developer/ancient-releasing","imap/developer/compiling","imap/developer/cyrusworks","imap/developer/developer-testing","imap/developer/developer-tips","imap/developer/documentation","imap/developer/github-guide","imap/developer/install-xapian","imap/developer/libraries","imap/developer/libraries/imclient","imap/developer/namespaces","imap/developer/overview","imap/developer/process","imap/developer/releasing","imap/download/getcyrus","imap/download/installation/distributions/centos","imap/download/installation/distributions/debian","imap/download/installation/distributions/fedora","imap/download/installation/distributions/opensuse","imap/download/installation/distributions/rhel","imap/download/installation/distributions/ubuntu","imap/download/installation/http/caldav","imap/download/installation/http/carddav","imap/download/installation/http/rss","imap/download/installation/http/webdav","imap/download/installation/manage-dav","imap/download/installation/mta/configuration","imap/download/installation/virus","imap/download/packagers","imap/download/release-notes/1/1.x.x","imap/download/release-notes/2.0/2.0.x","imap/download/release-notes/2.1/2.1.x","imap/download/release-notes/2.2/2.2.x","imap/download/release-notes/2.3/index","imap/download/release-notes/2.3/x/2.3.0","imap/download/release-notes/2.3/x/2.3.1","imap/download/release-notes/2.3/x/2.3.10","imap/download/release-notes/2.3/x/2.3.11","imap/download/release-notes/2.3/x/2.3.12","imap/download/release-notes/2.3/x/2.3.13","imap/download/release-notes/2.3/x/2.3.14","imap/download/release-notes/2.3/x/2.3.15","imap/download/release-notes/2.3/x/2.3.16","imap/download/release-notes/2.3/x/2.3.17","imap/download/release-notes/2.3/x/2.3.18","imap/download/release-notes/2.3/x/2.3.19","imap/download/release-notes/2.3/x/2.3.2","imap/download/release-notes/2.3/x/2.3.20","imap/download/release-notes/2.3/x/2.3.3","imap/download/release-notes/2.3/x/2.3.4","imap/download/release-notes/2.3/x/2.3.5","imap/download/release-notes/2.3/x/2.3.6","imap/download/release-notes/2.3/x/2.3.7","imap/download/release-notes/2.3/x/2.3.8","imap/download/release-notes/2.3/x/2.3.9","imap/download/release-notes/2.4-dav/index","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9","imap/download/release-notes/2.4/index","imap/download/release-notes/2.4/x/2.4.0","imap/download/release-notes/2.4/x/2.4.1","imap/download/release-notes/2.4/x/2.4.10","imap/download/release-notes/2.4/x/2.4.11","imap/download/release-notes/2.4/x/2.4.12","imap/download/release-notes/2.4/x/2.4.13","imap/download/release-notes/2.4/x/2.4.14","imap/download/release-notes/2.4/x/2.4.15","imap/download/release-notes/2.4/x/2.4.16","imap/download/release-notes/2.4/x/2.4.17","imap/download/release-notes/2.4/x/2.4.18","imap/download/release-notes/2.4/x/2.4.19","imap/download/release-notes/2.4/x/2.4.2","imap/download/release-notes/2.4/x/2.4.20","imap/download/release-notes/2.4/x/2.4.3","imap/download/release-notes/2.4/x/2.4.4","imap/download/release-notes/2.4/x/2.4.5","imap/download/release-notes/2.4/x/2.4.6","imap/download/release-notes/2.4/x/2.4.7","imap/download/release-notes/2.4/x/2.4.8","imap/download/release-notes/2.4/x/2.4.9","imap/download/release-notes/2.5/index","imap/download/release-notes/2.5/x/2.5.0","imap/download/release-notes/2.5/x/2.5.1","imap/download/release-notes/2.5/x/2.5.10","imap/download/release-notes/2.5/x/2.5.11","imap/download/release-notes/2.5/x/2.5.12","imap/download/release-notes/2.5/x/2.5.13","imap/download/release-notes/2.5/x/2.5.14","imap/download/release-notes/2.5/x/2.5.2","imap/download/release-notes/2.5/x/2.5.3","imap/download/release-notes/2.5/x/2.5.4","imap/download/release-notes/2.5/x/2.5.5","imap/download/release-notes/2.5/x/2.5.6","imap/download/release-notes/2.5/x/2.5.7","imap/download/release-notes/2.5/x/2.5.8","imap/download/release-notes/2.5/x/2.5.9","imap/download/release-notes/3.0/index","imap/download/release-notes/3.0/x/3.0.0","imap/download/release-notes/3.0/x/3.0.0-beta1","imap/download/release-notes/3.0/x/3.0.0-beta2","imap/download/release-notes/3.0/x/3.0.0-beta3","imap/download/release-notes/3.0/x/3.0.0-beta4","imap/download/release-notes/3.0/x/3.0.0-beta5","imap/download/release-notes/3.0/x/3.0.0-beta6","imap/download/release-notes/3.0/x/3.0.0-rc1","imap/download/release-notes/3.0/x/3.0.0-rc2","imap/download/release-notes/3.0/x/3.0.0-rc3","imap/download/release-notes/3.0/x/3.0.0-rc4","imap/download/release-notes/3.0/x/3.0.1","imap/download/release-notes/3.0/x/3.0.10","imap/download/release-notes/3.0/x/3.0.11","imap/download/release-notes/3.0/x/3.0.12","imap/download/release-notes/3.0/x/3.0.13","imap/download/release-notes/3.0/x/3.0.2","imap/download/release-notes/3.0/x/3.0.3","imap/download/release-notes/3.0/x/3.0.4","imap/download/release-notes/3.0/x/3.0.5","imap/download/release-notes/3.0/x/3.0.6","imap/download/release-notes/3.0/x/3.0.7","imap/download/release-notes/3.0/x/3.0.8","imap/download/release-notes/3.0/x/3.0.9","imap/download/release-notes/index","imap/download/upgrade","imap/installing","imap/quickstart/introduction","imap/reference/admin","imap/reference/admin/access-control","imap/reference/admin/access-control/combining-rights","imap/reference/admin/access-control/defaults","imap/reference/admin/access-control/identifiers","imap/reference/admin/access-control/rights-reference","imap/reference/admin/backups","imap/reference/admin/config-mailboxdistribution","imap/reference/admin/eventsource","imap/reference/admin/locations","imap/reference/admin/locations/archive-partitions","imap/reference/admin/locations/configuration-state","imap/reference/admin/locations/hashing","imap/reference/admin/locations/mailspool","imap/reference/admin/locations/searchtiers","imap/reference/admin/murder/murder","imap/reference/admin/murder/murder-concepts","imap/reference/admin/murder/murder-failure-modes","imap/reference/admin/murder/murder-installation","imap/reference/admin/murder/murder-mail-delivery","imap/reference/admin/murder/murder-mupdate-details","imap/reference/admin/nginx-proxy","imap/reference/admin/nntp","imap/reference/admin/ports-sockets","imap/reference/admin/ports/services","imap/reference/admin/ports/sockets","imap/reference/admin/protlayer","imap/reference/admin/quotas","imap/reference/admin/quotas/quotaroots","imap/reference/admin/quotas/quotatypes","imap/reference/admin/sieve","imap/reference/admin/sop","imap/reference/admin/sop/administration-running","imap/reference/admin/sop/altnamespace","imap/reference/admin/sop/deleting","imap/reference/admin/sop/mailbox-operations","imap/reference/admin/sop/mailbox-quota","imap/reference/admin/sop/reconstructing","imap/reference/admin/sop/reloading","imap/reference/admin/sop/replication","imap/reference/admin/sop/splitting-metadata","imap/reference/admin/sop/squatter","imap/reference/admin/sop/userdeny","imap/reference/admin/tweaking","imap/reference/administration-tools","imap/reference/architecture","imap/reference/faq","imap/reference/faqs/feature-database-backend","imap/reference/faqs/feature-duplicate-delivery","imap/reference/faqs/install-compilationerrors","imap/reference/faqs/install-detecting-berkeley","imap/reference/faqs/install-install-help","imap/reference/faqs/install-linkerwarnings","imap/reference/faqs/interop-8bit","imap/reference/faqs/interop-barenewlines","imap/reference/faqs/interop-sieve-exim","imap/reference/faqs/interop-slow-delivery","imap/reference/faqs/o-acls","imap/reference/faqs/o-annotations","imap/reference/faqs/o-berkeleydb","imap/reference/faqs/o-configdir-tempfs","imap/reference/faqs/o-coredump","imap/reference/faqs/o-db3-lockers","imap/reference/faqs/o-delete-mailbox","imap/reference/faqs/o-deleted-expired-expunged-purged","imap/reference/faqs/o-deliverdb-size","imap/reference/faqs/o-freezes","imap/reference/faqs/o-gdb","imap/reference/faqs/o-mailbox-doesnotexist","imap/reference/faqs/o-mixedcase","imap/reference/faqs/o-otherdatabases","imap/reference/faqs/o-pop3slow","imap/reference/faqs/o-reconstruct","imap/reference/faqs/o-sharedfilesystem-gpfs","imap/reference/faqs/o-telemetry","imap/reference/faqs/o-toomanyprocesses","imap/reference/faqs/o-unable-join-environment","imap/reference/faqs/o-vacation-mailfrom","imap/reference/faqs/r-murder-ha","imap/reference/faqs/r-pop3-logging","imap/reference/faqs/r-publicssharedfolders","imap/reference/faqs/r-subfolders","imap/reference/manpages/commands","imap/reference/manpages/configs/cyrus.conf","imap/reference/manpages/configs/imapd.conf","imap/reference/manpages/configs/krb.equiv","imap/reference/manpages/systemcommands/arbitron","imap/reference/manpages/systemcommands/backupd","imap/reference/manpages/systemcommands/chk_cyrus","imap/reference/manpages/systemcommands/ctl_backups","imap/reference/manpages/systemcommands/ctl_conversationsdb","imap/reference/manpages/systemcommands/ctl_cyrusdb","imap/reference/manpages/systemcommands/ctl_deliver","imap/reference/manpages/systemcommands/ctl_mboxlist","imap/reference/manpages/systemcommands/ctl_zoneinfo","imap/reference/manpages/systemcommands/cvt_cyrusdb","imap/reference/manpages/systemcommands/cvt_xlist_specialuse","imap/reference/manpages/systemcommands/cyr_backup","imap/reference/manpages/systemcommands/cyr_buildinfo","imap/reference/manpages/systemcommands/cyr_dbtool","imap/reference/manpages/systemcommands/cyr_deny","imap/reference/manpages/systemcommands/cyr_df","imap/reference/manpages/systemcommands/cyr_expire","imap/reference/manpages/systemcommands/cyr_info","imap/reference/manpages/systemcommands/cyr_sequence","imap/reference/manpages/systemcommands/cyr_synclog","imap/reference/manpages/systemcommands/cyr_userseen","imap/reference/manpages/systemcommands/cyr_virusscan","imap/reference/manpages/systemcommands/cyradm","imap/reference/manpages/systemcommands/cyrdump","imap/reference/manpages/systemcommands/deliver","imap/reference/manpages/systemcommands/fetchnews","imap/reference/manpages/systemcommands/fud","imap/reference/manpages/systemcommands/httpd","imap/reference/manpages/systemcommands/idled","imap/reference/manpages/systemcommands/imapd","imap/reference/manpages/systemcommands/ipurge","imap/reference/manpages/systemcommands/lmtpd","imap/reference/manpages/systemcommands/lmtpproxyd","imap/reference/manpages/systemcommands/masssievec","imap/reference/manpages/systemcommands/master","imap/reference/manpages/systemcommands/mbexamine","imap/reference/manpages/systemcommands/mbpath","imap/reference/manpages/systemcommands/mbtool","imap/reference/manpages/systemcommands/mkimap","imap/reference/manpages/systemcommands/mknewsgroups","imap/reference/manpages/systemcommands/mupdate","imap/reference/manpages/systemcommands/nntpd","imap/reference/manpages/systemcommands/notifyd","imap/reference/manpages/systemcommands/pop3d","imap/reference/manpages/systemcommands/pop3proxyd","imap/reference/manpages/systemcommands/proxyd","imap/reference/manpages/systemcommands/ptdump","imap/reference/manpages/systemcommands/ptexpire","imap/reference/manpages/systemcommands/ptloader","imap/reference/manpages/systemcommands/quota","imap/reference/manpages/systemcommands/reconstruct","imap/reference/manpages/systemcommands/rehash","imap/reference/manpages/systemcommands/restore","imap/reference/manpages/systemcommands/sievec","imap/reference/manpages/systemcommands/sieved","imap/reference/manpages/systemcommands/smmapd","imap/reference/manpages/systemcommands/squatter","imap/reference/manpages/systemcommands/sync_client","imap/reference/manpages/systemcommands/sync_reset","imap/reference/manpages/systemcommands/sync_server","imap/reference/manpages/systemcommands/timsieved","imap/reference/manpages/systemcommands/tls_prune","imap/reference/manpages/systemcommands/translatesieve","imap/reference/manpages/systemcommands/unexpunge","imap/reference/manpages/usercommands/arbitronsort.pl","imap/reference/manpages/usercommands/dav_reconstruct","imap/reference/manpages/usercommands/httptest","imap/reference/manpages/usercommands/imtest","imap/reference/manpages/usercommands/installsieve","imap/reference/manpages/usercommands/lmtptest","imap/reference/manpages/usercommands/mupdatetest","imap/reference/manpages/usercommands/nntptest","imap/reference/manpages/usercommands/pop3test","imap/reference/manpages/usercommands/sieveshell","imap/reference/manpages/usercommands/sivtest","imap/reference/manpages/usercommands/smtptest","imap/reference/manpages/usercommands/synctest","imap/rfc-support","imap/support/feedback-bugs","imap/support/feedback-irc","imap/support/feedback-mailing-lists","imap/support/feedback-meetings","index","operations","overview","overview/about_cyrus","overview/cyrus_bylaws","overview/cyrus_history","overview/cyrus_roadmap","overview/what_is_cyrus","overview/who_is_cyrus","preface","quickstart","setup","sitemap","styles","support"],objects:{"":{"-A":[328,0,1,"cmdoption-dav_reconstruct-A"],"-C":[328,0,1,"cmdoption-dav_reconstruct-C"],"-D":[318,0,1,"cmdoption-smmapd-D"],"-E":[310,0,1,"cmdoption-ptexpire-E"],"-F":[320,0,1,"cmdoption-sync_client-F"],"-G":[313,0,1,"cmdoption-reconstruct-G"],"-I":[330,0,1,"cmdoption-imtest-I"],"-J":[312,0,1,"cmdoption-quota-J"],"-L":[320,0,1,"cmdoption-sync_client-L"],"-M":[315,0,1,"cmdoption-restore-M"],"-N":[319,0,1,"cmdoption-squatter-N"],"-O":[320,0,1,"cmdoption-sync_client-O"],"-P":[315,0,1,"cmdoption-restore-P"],"-R":[319,0,1,"cmdoption-squatter-R"],"-S":[320,0,1,"cmdoption-sync_client-S"],"-T":[319,0,1,"cmdoption-squatter-T"],"-U":[318,0,1,"cmdoption-smmapd-U"],"-V":[313,0,1,"cmdoption-reconstruct-V"],"-X":[330,0,1,"cmdoption-imtest-X"],"-a":[338,0,1,"cmdoption-smtptest-a"],"-b":[293,0,1,"cmdoption-ipurge-b"],"-c":[338,0,1,"cmdoption-smtptest-c"],"-d":[331,0,1,"cmdoption-installsieve-d"],"-f":[338,0,1,"cmdoption-smtptest-f"],"-g":[331,0,1,"cmdoption-installsieve-g"],"-h":[319,0,1,"cmdoption-squatter-h"],"-i":[338,0,1,"cmdoption-smtptest-i"],"-j":[297,0,1,"cmdoption-master-j"],"-k":[338,0,1,"cmdoption-smtptest-k"],"-l":[338,0,1,"cmdoption-smtptest-l"],"-m":[338,0,1,"cmdoption-smtptest-m"],"-n":[338,0,1,"cmdoption-smtptest-n"],"-o":[338,0,1,"cmdoption-smtptest-o"],"-p":[338,0,1,"cmdoption-smtptest-p"],"-q":[334,0,1,"cmdoption-nntptest-q"],"-r":[338,0,1,"cmdoption-smtptest-r"],"-s":[338,0,1,"cmdoption-smtptest-s"],"-t":[338,0,1,"cmdoption-smtptest-t"],"-u":[338,0,1,"cmdoption-smtptest-u"],"-v":[338,0,1,"cmdoption-smtptest-v"],"-w":[338,0,1,"cmdoption-smtptest-w"],"-x":[330,0,1,"cmdoption-imtest-x"],"-y":[288,0,1,"cmdoption-fetchnews-y"],"-z":[330,0,1,"cmdoption-imtest-z"],"arbitron(8)":[263,1,1,"std:cyrusman-arbitron(8)"],"backupd(8)":[264,1,1,"std:cyrusman-backupd(8)"],"chk_cyrus(8)":[265,1,1,"std:cyrusman-chk_cyrus(8)"],"conf-all":[280,0,1,"cmdoption-arg-conf-all"],"conf-default":[280,0,1,"cmdoption-arg-conf-default"],"conf-lint":[280,0,1,"cmdoption-arg-conf-lint"],"config-file":[301,0,1,"cmdoption-mkimap-arg-config-file"],"ctl_backups(8)":[266,1,1,"std:cyrusman-ctl_backups(8)"],"ctl_conversationsdb(8)":[267,1,1,"std:cyrusman-ctl_conversationsdb(8)"],"ctl_cyrusdb(8)":[268,1,1,"std:cyrusman-ctl_cyrusdb(8)"],"ctl_deliver(8)":[269,1,1,"std:cyrusman-ctl_deliver(8)"],"ctl_mboxlist(8)":[270,1,1,"std:cyrusman-ctl_mboxlist(8)"],"ctl_zoneinfo(8)":[271,1,1,"std:cyrusman-ctl_zoneinfo(8)"],"cvt_cyrusdb(8)":[272,1,1,"std:cyrusman-cvt_cyrusdb(8)"],"cvt_xlist_specialuse(8)":[273,1,1,"std:cyrusman-cvt_xlist_specialuse(8)"],"cyr_backup(8)":[274,1,1,"std:cyrusman-cyr_backup(8)"],"cyr_buildinfo(8)":[275,1,1,"std:cyrusman-cyr_buildinfo(8)"],"cyr_dbtool(8)":[276,1,1,"std:cyrusman-cyr_dbtool(8)"],"cyr_deny(8)":[277,1,1,"std:cyrusman-cyr_deny(8)"],"cyr_df(8)":[278,1,1,"std:cyrusman-cyr_df(8)"],"cyr_expire(8)":[279,1,1,"std:cyrusman-cyr_expire(8)"],"cyr_info(8)":[280,1,1,"std:cyrusman-cyr_info(8)"],"cyr_sequence(8)":[281,1,1,"std:cyrusman-cyr_sequence(8)"],"cyr_synclog(8)":[282,1,1,"std:cyrusman-cyr_synclog(8)"],"cyr_userseen(8)":[283,1,1,"std:cyrusman-cyr_userseen(8)"],"cyr_virusscan(8)":[284,1,1,"std:cyrusman-cyr_virusscan(8)"],"cyradm(8)":[285,1,1,"std:cyrusman-cyradm(8)"],"cyrdump(8)":[286,1,1,"std:cyrusman-cyrdump(8)"],"dav_reconstruct(1)":[328,1,1,"std:cyrusman-dav_reconstruct(1)"],"deliver(8)":[287,1,1,"std:cyrusman-deliver(8)"],"fetchnews(8)":[288,1,1,"std:cyrusman-fetchnews(8)"],"fud(8)":[289,1,1,"std:cyrusman-fud(8)"],"httpd(8)":[290,1,1,"std:cyrusman-httpd(8)"],"httptest(1)":[329,1,1,"std:cyrusman-httptest(1)"],"idled(8)":[291,1,1,"std:cyrusman-idled(8)"],"imapd(8)":[292,1,1,"std:cyrusman-imapd(8)"],"imclient(3)":[52,1,1,"std:cyrusman-imclient(3)"],"imtest(1)":[330,1,1,"std:cyrusman-imtest(1)"],"installsieve(1)":[331,1,1,"std:cyrusman-installsieve(1)"],"ipurge(8)":[293,1,1,"std:cyrusman-ipurge(8)"],"lmtpd(8)":[294,1,1,"std:cyrusman-lmtpd(8)"],"lmtpproxyd(8)":[295,1,1,"std:cyrusman-lmtpproxyd(8)"],"lmtptest(1)":[332,1,1,"std:cyrusman-lmtptest(1)"],"mailbox-prefix":[312,0,1,"cmdoption-quota-arg-mailbox-prefix"],"masssievec(8)":[296,1,1,"std:cyrusman-masssievec(8)"],"master(8)":[297,1,1,"std:cyrusman-master(8)"],"mbexamine(8)":[298,1,1,"std:cyrusman-mbexamine(8)"],"mbpath(8)":[299,1,1,"std:cyrusman-mbpath(8)"],"mbtool(8)":[300,1,1,"std:cyrusman-mbtool(8)"],"mkimap(8)":[301,1,1,"std:cyrusman-mkimap(8)"],"mknewsgroups(8)":[302,1,1,"std:cyrusman-mknewsgroups(8)"],"mupdate(8)":[303,1,1,"std:cyrusman-mupdate(8)"],"mupdatetest(1)":[333,1,1,"std:cyrusman-mupdatetest(1)"],"nntpd(8)":[304,1,1,"std:cyrusman-nntpd(8)"],"nntptest(1)":[334,1,1,"std:cyrusman-nntptest(1)"],"notifyd(8)":[305,1,1,"std:cyrusman-notifyd(8)"],"pop3d(8)":[306,1,1,"std:cyrusman-pop3d(8)"],"pop3proxyd(8)":[307,1,1,"std:cyrusman-pop3proxyd(8)"],"pop3test(1)":[335,1,1,"std:cyrusman-pop3test(1)"],"proxyd(8)":[308,1,1,"std:cyrusman-proxyd(8)"],"ptdump(8)":[309,1,1,"std:cyrusman-ptdump(8)"],"ptexpire(8)":[310,1,1,"std:cyrusman-ptexpire(8)"],"ptloader(8)":[311,1,1,"std:cyrusman-ptloader(8)"],"quota(8)":[312,1,1,"std:cyrusman-quota(8)"],"reconstruct(8)":[313,1,1,"std:cyrusman-reconstruct(8)"],"rehash(8)":[314,1,1,"std:cyrusman-rehash(8)"],"restore(8)":[315,1,1,"std:cyrusman-restore(8)"],"sievec(8)":[316,1,1,"std:cyrusman-sievec(8)"],"sieved(8)":[317,1,1,"std:cyrusman-sieved(8)"],"sieveshell(1)":[336,1,1,"std:cyrusman-sieveshell(1)"],"sivtest(1)":[337,1,1,"std:cyrusman-sivtest(1)"],"smmapd(8)":[318,1,1,"std:cyrusman-smmapd(8)"],"smtptest(1)":[338,1,1,"std:cyrusman-smtptest(1)"],"squatter(8)":[319,1,1,"std:cyrusman-squatter(8)"],"sync_client(8)":[320,1,1,"std:cyrusman-sync_client(8)"],"sync_reset(8)":[321,1,1,"std:cyrusman-sync_reset(8)"],"sync_server(8)":[322,1,1,"std:cyrusman-sync_server(8)"],"synctest(1)":[339,1,1,"std:cyrusman-synctest(1)"],"timsieved(8)":[323,1,1,"std:cyrusman-timsieved(8)"],"tls_prune(8)":[324,1,1,"std:cyrusman-tls_prune(8)"],"translatesieve(8)":[325,1,1,"std:cyrusman-translatesieve(8)"],"unexpunge(8)":[326,1,1,"std:cyrusman-unexpunge(8)"],compact:[266,0,1,"cmdoption-ctl_backups-arg-compact"],compress:[281,0,1,"cmdoption-cyr_sequence-arg-compress"],conf:[280,0,1,"cmdoption-arg-conf"],create:[281,0,1,"cmdoption-cyr_sequence-arg-create"],dump:[274,0,1,"cmdoption-arg-dump"],format:[275,0,1,"cmdoption-cyr_buildinfo-arg-format"],imapd:[314,0,1,"cmdoption-rehash-arg-imapd"],ismember:[281,0,1,"cmdoption-cyr_sequence-arg-ismember"],join:[281,0,1,"cmdoption-cyr_sequence-arg-join"],json:[274,0,1,"cmdoption-arg-json"],list:[274,0,1,"cmdoption-arg-list"],lock:[266,0,1,"cmdoption-ctl_backups-arg-lock"],members:[281,0,1,"cmdoption-cyr_sequence-arg-members"],parsed:[281,0,1,"cmdoption-cyr_sequence-arg-parsed"],proc:[280,0,1,"cmdoption-arg-proc"],reindex:[266,0,1,"cmdoption-ctl_backups-arg-reindex"],show:[274,0,1,"cmdoption-arg-show"],stat:[266,0,1,"cmdoption-ctl_backups-arg-stat"],userid_list:[328,0,1,"cmdoption-dav_reconstruct-arg-userid_list"],verify:[266,0,1,"cmdoption-ctl_backups-arg-verify"]},arbitronsort:{"pl(1)":[327,1,1,"std:cyrusman-arbitronsort.pl(1)"]},cyrus:{"conf(5)":[260,1,1,"std:cyrusman-cyrus.conf(5)"]},imapd:{"conf(5)":[261,1,1,"std:cyrusman-imapd.conf(5)"]},krb:{"equiv(5)":[262,1,1,"std:cyrusman-krb.equiv(5)"]}},objnames:{"0":["std","option","option"],"1":["std","cyrusman","cyrusman"]},objtypes:{"0":"std:option","1":"std:cyrusman"},terms:{"1000gb":184,"1000gib":[9,184],"100gb":184,"100gib":9,"10t16":27,"110gib":9,"1234abcd":18,"128k":261,"12a62f123451395dc7d52518ae8e8c75571c9876":298,"152f59c":166,"19011213t204552z":261,"1mb":[15,261],"1tb":250,"2000gib":[9,184],"200g":236,"200gib":[9,184],"2013h":[64,271],"20151119t063000z":27,"20151119t073000z":27,"20151119t083000z":27,"20380119t031407z":261,"20t11":27,"20t13":27,"23t14":27,"23t18":27,"24h":326,"255f37ffc2e7":27,"2c_thoma":27,"2gb":[160,164],"2ghz":250,"30gb":184,"30gib":9,"3829c6087dac":326,"3ab4f8d5512e33b1":298,"3rd":261,"400gb":184,"400gib":9,"41d7":269,"41z":27,"49ba20f5":27,"4aa62f540d81395dc7d52518ae8e8c75571c8f11":298,"4d5c6b7a":211,"4d88af31":211,"4d88af34":211,"4d88af35":211,"4d9618acd0aea6b33683766358351459":27,"4gb":250,"4ghz":250,"4rev1":340,"500gib":9,"512mb":44,"53c4137":166,"5571a7bc1bc865":269,"5a6":72,"5edadcf":166,"5meg":352,"600gb":184,"600gib":9,"64bit":[117,165],"69bdb40dac9de4d17057a5245c34544f2d6849db":298,"6aa93fd583f143dde555184d508ab0916e06b026":298,"700gib":[9,184],"70gb":184,"70gib":9,"739232245980a3efe3df490841221a4b7bac4f27":298,"7bit":[27,326],"80gib":9,"80k":250,"8bit":[27,113,261,340],"8bitmime":73,"8gb":250,"8th":72,"900gib":[9,184],"95349cd5d1cf21b55e6e0930b2ee5754f977ba8c":326,"\u00f8yvind":353,"\u0434\u0438\u043b\u044f\u043d":[136,161,162,163,164,165,172],"\u043f\u0430\u043b\u0430\u0443\u0437\u043e\u0432":[136,161,162,163,164,165,172],"boolean":[52,235,261],"break":[40,72,115,116,118,119,131,137,145,146,161,173,183,207,232,261,270],"byte":[6,44,48,72,75,88,117,127,129,261,293,298,313],"case":[0,4,5,7],"catch":[36,72,344],"char":[47,52,211],"class":[41,186,193,206,261,350,358],"const":52,"default":[0,1,2,3,4,5,6,7,8,9,10,11],"delete":[64,73,74,79,84,109,133,182,193],"export":[41,50,73,106,175],"final":[3,6,11,15,25,41,46,79,97,120,127,131,174,175,182,207,228,238,261,350,352,358],"float":279,"function":[7,11,12,18,19,36,40,44,45],"go\u0142\u0119biowski":172,"h\u00e5vard":261,"import":[3,11,66,73,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,183,193,216,239,260,313,341,352,358],"int":[52,72,102,105,261],"jes\u00fa":131,"kundr\u00e1t":127,"long":[6,9,30,33,36,41,47,52,72,81,113,124,127,129,133,137,166,169,174,183,184,216,223,230],"new":4,"null":[3,6,11,18,33,41,47,52,72,73,88,117,135,149,151,152,153,154,155,156,157,158,159,175,181,188,203,254,261,305],"ond\u0159ej":[145,353],"public":[41,43,56,64,65,67,223],"return":[5,27,41,47,48,52,64,65,67,72,73,74,84,107,108,114,115,118,134,136,137,172,175,182,193,195,197,203,204,261,281,285,287,328,340,358],"short":[7,11,48,72,75,84,101,111,120,136,179,182,184,197,250,252,256,261,263,282],"static":[3,36,52,68,72,73,261],"super":[35,125,174,352],"sur\u00fd":[145,353],"switch":[11,41,52,72,73,74,75,120],"true":[7,18,40,63,72,171,175,179],"try":[40,47,55,72,133,173,175,183,193,195,207,216,219,223,226,231],"var":[11,28,40,43,46,50,56,63,72,174,175,186,187,188,190,191,195,199,202,204,216,217,219,220,236,243,249,251,260,261,272,276,278,280,290,292,294,297,298,299,301,303,306,322,323,355],"void":[35,52,203],"while":[5,6,9,11,19,27,28,33,36,40,41,43,44,48,52,54,60,68,74,84,133,162,174,182,183,185,186,188,193,195,197,203,209,217,218,220,222,229,236,241,243,245,250,252,260,261,266,273,285,319],_admin:41,_d9aa3c2dd73a9166113254d4ebe07bc8:27,_highlightword:239,_mech:261,_sync_authnam:183,_sync_host:183,_sync_password:183,_sync_port:183,_sync_repeat_interv:183,_tls_:75,a001:193,a002:193,a01:[58,59,60,62,63],a0e716087dac:326,a4bf5bbb9feaa271:27,a777:182,a8486f5db6ec207de9b9f069850546e:27,abandon:75,abbrevi:285,abc:48,abil:[7,11,19,35,38,40,41,68,72,73,74,164,192,193,195,199,222,249,261],abiliti:117,abl:[3,11,18,19,33,36,40,45,48,58,59,60,62,63,64,85,107,174,175,182,193,195,211,216,241,261,297,342],abnf:340,abnorm:238,abort:[72,73,83,193,238,261,315,320],about:[0,1,3,5,6,7,11,15,36,40,41,44],abov:[15,18,40,41,46,57,60,63,67,129,133,134,175,184,186,187,188,190,195,199,207,211,214,239,250,260,270,285,326,355,358],above:193,absenc:349,absolut:[9,28,30,56,64,75,133,184,188,204,221,236,261],abus:[41,270],acap:[52,73,193,197,340],acapmbox:73,acapsiev:73,accept:[11,72,73,74,75,97,108,109,117,134,136,149,151,152,153,154,155,156,157,158,159,169,174,175,193,197,199,207,216,230,261,264,275,281,285,287,290,292,294,303,304,305,306,311,318,319,323,349,352,355],access:[3,4,5],accid:321,accident:[24,25,241,250,315,326],accommod:193,accompani:[15,187],accomplish:[41,125,176,186,193,199,250,254,350],accord:[9,30,66,183,184,186,191,195,247,261,266,274,315,349],accordingli:[75,199,261],account:[10,11,18,19,27,35,40,41,43,46],accountid:27,accur:[11,133],achaemenid:46,acheiv:216,achiev:[11,28,174,200,216,250,261],aci:14,ack:252,acknowledg:57,acl:[6,27,36],aclright:27,acls:115,aclsubject:27,acm:261,acquir:[47,72,97],across:[8,11,12,13,36,41,46,73,75,81,125,137,165,171,180,183,192,193,195,197,222,239,250,261,352],act:[41,68,133,181,193,216,261,283,303,352],actdiag:48,action:[19,27,33,41,57,71,72,74,133,174,182,185,193,207,216,222,261,276,285,300,305,315,319,320,340],activ:[6,11,18,33,41,57,62,74,146,150,151,152,153,154,155,156,157,158,159,165,183,193,197,203,207,216,228,261,297,302,319,331,336,345,353],activate:195,actual:[3,5,7,9,11,15,19,26,28,30,33,41,45,72,81,116,129,131,133,149,153,154,155,156,157,158,159,175,182,183],actualli:283,adam:172,adapt:[3,71],adapter:[3,11],add:[18,40,43,44,45,46],added:[72,74,75,77,79,80,81,82,84,85,89,90,92,95,96,97,99,100,101,104,105,106,107,108,109,111,125,129,149,151,152,153,154,155,156,157,158,159,163,261],adding:1,addit:[3,5,6,7,9,11,12,31,41,44,47,48,49,50,57,71,73,84,133,149,150,151,152,153,154,155,156,157,158,159,174,175,180,183,185,186,187,188,189,190,191,193],addition:[11,19,36,41],address:[3,4,5,6,11,18,19,22,33,36],addressbook:22,addsub:83,addus:46,adher:[246,254],adjac:261,adjust:[11,41,64,175,188,211,216,252,313,355],adkin:[73,253],adkinss:[73,253],admin:[33,40,41,43,56,63,64,68,73,74,75,79,85,108,133,134,161,164,166,175,179,180,183,195,207,216,222,223,235],admin_3:355,administ:[33,35,40,41,179,180,182,285],administr:[3,7,11,13,15,24,25],adminref:346,admissibl:261,admit:[182,285],adopt:[19,354],adv:211,advanc:[9,30,184,350],advantag:[6,7,13,71,73,74,193,319,352],advent:45,advertis:[64,68,72,129,174,193,261],advis:[41,48,313],aea7:27,aege:116,aes256:[58,59,60,62,63],af11:261,af12:261,af13:261,af21:261,af22:261,af23:261,af31:261,af32:261,af33:261,af41:261,af42:261,af43:261,afek:353,affect:[19,33,44,49,72,73,125,162,166,174,183,216,225,233,248,250,252,258,261,267,284,313,319],aforement:[8,11,36,133],afs:[41,72,74,125,181,193,261,311],afskrb:261,afspt:75,afspts:261,afspts_localrealm:261,afspts_mycel:261,after:[3,8,9,11,15,19,24,26,30,33,41,44,52,56,71,72,80,82,83,84,92,114,125,127,133,135,147,182,183,184,193,194,195,197,199,203,207,211,214,215,235,236,240,241,250,261,266,267,268,285,313,319,320,329,330,332,333,334,335,337,338,350,354],again:[11,36,41,43,56,63,72,73,74,75,79,116,120,131,149,150,151,152,153,154,155,156,157,158,159,165,174,175,183,187,190,191,192],against:[5,11,41,47,48,54,56,58,59,60,62,63,72,90,114,133,139,145,175,185,193,197,206,207,227,229,241,253,261],age:293,agent:[3,41,103,175,193,222,246,297,352],agentx:[73,297],aggreg:4,aggregat:[13,19],aggress:134,agnost:11,ago:[127,211,241],agreement:230,ahead:[11,197,261],ahv:174,aid:[4,71,73,83,195,265,273,301],aim:133,aix:250,aka:[133,183],akio:[114,115],alain:73,alarm:[27,149,150,151,152,153,154,155,156,157,158,159,160,185,239],alarmrecipi:27,alarmtim:27,albert:75,alec:115,alert:[41,72,75,235,261,285,292],alexei:[349,353],algorithm:[72,79,189,261],alia:[5,6,262,285],alias:[5,6,40,121,261,285],align:[72,79,97],alik:11,aliv:[104,252,344],alive:340,all:[0,3,5,6,7,8,9,11,12,13,18,19,24,25,27,30,31,33,35,36,38,40,41,44,45,46,47,48,52,55,57,58,59,60,62,63,64,66,68,71,72,74,75,77,83,84,106,111,112,113,117,125,127,133,144,145,162,166,171,172,174,175,178],allberi:[73,285],alldai:27,alloc:[11,47,73,175,355],allof:75,allow:[3,5,7,8,9,11,13,15,18,19,24,25,27,30,33,34,35,36,40,41,44,52,53,64,65,66,67,68,72,73,74,75,77,79,80,81,83,84,85,89,97,106,108,114,116,121,125,129,130,131],allowallsubscrib:[7,182,195,261],allowanonymouslogin:[41,261],allowapop:[248,261],allownewnew:[199,261,304],allowplaintext:41,allowusermov:[75,261],allprop:106,almost:[74,175,214,250,261,313],alon:[7,11,95,184,187,250,355],along:[41,55,108,174,176,182,193,350,355],alongsid:[6,183],alphabet:[12,47,186,193,260],alphanumer:[18,186,190,197,261],alpine:81,alreadi:[5,11,12,18,19,26,38,41,44,49,55,64,68,71,72,74,133,164,174,175,183,193,195,204,261,266,267,276,285,315,319,325,331,352,355],also:[3,5,6,7,9,11,15,18,19,25,27,28,30,31,33,36,40,41,43,44,46,47,48,49,50],alt:[199,261,302,358],alt_config:328,altconfig:[272,281,316],alter:[18,64,216,222,246,260,279,283,315],altern:[9,11],although:[5,11,193,261,287],altogeth:19,altprefix:261,alumni:353,alwai:[11,33,41,46,47,72,74,75,83,84,105,116,126,127,134,174,175,180,189,195,204,216,222,229,260,261,314,320],always:53,alwaystru:175,amavisd:27,ambigu:182,amend:18,american:263,amo:[73,74],among:[3,9,30,72,133,193,264,301],amongst:354,amount:[9,11,18,24,25,27,28,30,34,72,73,75,77,81,97,133,174,184,193,196,204,223,236,247,252],ams:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],amssync:72,analysi:192,ancient:42,andjelkov:73,andrea:239,andrew:[52,57,72,116,176,193,195,211,343,352,354],andrewmailsystem:350,andrewproject:350,andy:262,anew:313,ani:[3,5,7,11,12,15,25,27,33,35,40,41,43,47,48,49,52,56,57,58,59,60,62,63,68,70,71,72,73,74,75,77,84,89,149,151,152,153,154,155,156,157,158,159,164],ann:183,annoi:[11,72,73,292],annot:4,annotat:4,annotate:[340,351],annotatemor:235,annotatemore:[58,59,60,62,63,74,75,133,146],annotatemsg:41,annotation:[41,206,285,312],annotation_allow_undefin:[133,261],annotation_callout:[133,261],annotation_db:[133,261],annotation_db_path:[188,261],annotation_definit:[85,261],annotations_definit:261,announc:[33,43,56,146,343],anonymous:[73,207,261],anoth:[0,11,33,36,38,40,63,74,133,174,185,193,207,216,223],another:[5,193,230,253],ansi:72,answer:[7,175,256,261,353],answere:298,anthoni:[164,172],anticipatori:11,antispam:345,antiviru:[149,150,151,152,153,154,155,156,157,158,159,345],any:[41,57,64,68,71,181,193,207,216,222,261,264,290,292,297,304,306,313,319,322,328],anybodi:[56,72],anymor:[195,261],anyof:75,anyon:[5,19,35],anyoneuseracl:261,anysievefold:[164,261],anyth:[11,43,46,54,56,72,174,179,214,279,280,285,292],anywai:[72,183,261],apach:68,apart:84,api:[6,47,73,100,111,115,162,165],api_refer:239,apop:[248,261,335],app:47,appar:[162,193,292],appear:[9,11,22,30,33,43,66,72,74,109,175,182,183,184,193,195,199,216,223,228,233,246,254],append:[3,24,33,41,46,64,65,67,72,73,74,75,83,92,93,113,120,122,129,130,170],append_addseen:72,append_check:246,appendic:192,appl:[64,185,261],apple:[27,64,149,151,152,153,154,155,156,157,158,159,177],appli:[11,19,27,28,33,35,41,45,48,49,84,145,181,182,184,193,205,207,214,215,216,217,222,230,241,245,261,266,267,279,358],applianc:11,applic:[3,5,8,11,36,47,72,75,133,176,195,200,203,210,216,241,248,253,254,268,341,345,352,358],application:27,apply:[46,315],appoint:11,apprais:193,appraiser:74,appreci:[11,116,183,341,353],approach:[11,193,216,250,358],appropri:[9,11,18,36,41,43,47,48,56,72,81,106,175,183,185,193,216,229,240,254,261,289,291,320,325,349,355],approv:[55,193,349],approxim:[41,266,319],april:263,aps_top:261,aps_topic_caldav:261,aps_topic_carddav:261,apsaccountid:27,apsdevicetoken:27,apssubtop:27,apsvers:27,apt:[44,46,59,63,174,175,345],aptli:217,arbit:36,arbitrari:[41,143,166,193,216],arbitrarili:72,arbitron:[48,72,74,75,89],architect:250,architectur:[7,36,84],archiv:[11,15,24,28,48,71,74,149,150,151,152,153,154,155,156,157,158,159,172,183,186,187,199,220,250,261,263,268,279,280,343],archive:[11,13],archive_:[71,149,150,151,152,153,154,155,156,157,158,159],archive_dai:[15,261],archive_en:[15,187,261],archive_keepflag:[15,261],archive_maxs:[15,261],archivecach:[186,190,261],archivepartit:[15,186,187,261,279,280],area:[11,41,49,72,261],aren:[45,73,127,174,175,193,207,244],arg:[72,244],arguabl:179,argument:[11,41,43,44,48,52,56,72,81,122,130,133,144,146,164,165,169,183,193,196,204,216,243,244,252,254,260,261,283,285,312,313,315,319,320],aris:[11,24],arising:57,around:[11,46,47,55,72,182,183,207,244,250,252,260,285,289,313,342,345],arpa:340,arrai:[11,27,28,52],arrang:[175,183],arrayu64:166,arriv:[19,25,149,150,151,152,153,154,155,156,157,158,159,196,261,267,289],arround:72,arrow:331,articl:[6,11,72,75],articul:11,artifact:46,artifici:72,ascii:[27,33,41,72,261,267,287,326,340],asid:[11,33,35,241],aside:[133,358],ask:[72,222,249,261,270,329,330,332,333,334,335,337,338],asn1:6,aspect:[5,7,12,41,186,193,343],ass:250,assert:[75,135,147,172],asset:11,assign:[5,11,19,71,163,182,183,204,261,267,285],assist:[44,241],associ:[5,6,9,11,19,30,40,41,108,133,181,184,191,193,195,199,203,235,261,267,268,285,358],associateddomain:261,assort:[74,75],assum:[18,33,40,43,44,46,49,54,56,68,75,136,174,175,183,193,199,207,211,241,260,270,284,287,313,325,329,330,332,333,334,335,337,338],assume:[18,46,207],assumpt:[72,193],assur:[0,26],astr:52,atim:226,atom:[52,72,75,106,128,165,186],atomic:11,attach:[11,64,117,165,197,207,261,264,290,292,294,303,304,306,315,318,320,323],attachment:[20,27,64,261],attack:[41,74],attempt:[5,12,26,36,41,44,47,71,72,73,75,128,162,169,182,183,193,195,203,207,222,230,238,261,272,276,287,313,320,329,330,332,333,334,335,336,337,338,350],attend:11,attende:64,attendeeemail:27,attendeenam:27,attendeestatu:27,attent:[71,174,358],attract:353,attrib:261,attribut:[5,22,35,64,134,185,261,285],auction:129,audio:352,audit:[74,328],auditlog:[117,122,165,261],aug:[284,300],augment:[41,181,352],australia:27,auth:[6,18,41,58,59,60,62,63,72,73,74,82,83,105,171,175,181,195,197,216,285,287,294,335,340,355],auth_:[41,181],auth_krb_pt:[72,261],auth_mech:[261,311],auth_newst:72,auth_pt:[47,124,137,166],auth_setid:72,auth_unix:[72,261],auth_xxx:72,authent:[3,4],authenticata:163,authenticate:[58,59,60,62,63,72],authid:285,authinfo:334,authnam:[195,288,331,336],author:[3,4],authorit:[11,40,193,195,197],authoriz:340,authors:48,authz:285,authzid:285,auto:[64,73,82,83,107,254],autoconf:[12,44,72,74,75],autocreate_:133,autocreate_inbox_fold:[19,133,261],autocreate_post:[19,133,204,261],autocreate_quota:[19,133,142,204,261],autocreate_quota_messag:[19,133,142,204,261],autocreate_siev:145,autocreate_sieve_compiled_script:[133,261],autocreate_sieve_compiledscript:[19,261],autocreate_sieve_fold:[19,133,261],autocreate_sieve_script:[19,133,261],autocreate_sieve_script_compil:[19,133,261],autocreate_subscribe_fold:[19,133,261],autocreate_subscribe_sharedfold:[19,133,261],autocreate_subscribe_sharedfolders_al:[19,133,261],autocreate_us:[19,133,261],autocreateinboxfold:[19,133,261],autocreatequota:[72,133,261],autocreatequotamsg:261,autof:250,autolearn:27,autologout:261,autom:11,automak:[12,44,75,115,174],automat:[6,9,11,12,13],automount:250,autonom:241,autoreconf:[43,44,46,56,137,165],autorepeat:321,autorepli:207,autorespond:254,autoselect:303,autosiev:351,autosievefold:[133,261],autosubscribe_all_sharedfold:[133,261],autosubscribeinboxfold:[133,261],autosubscribesharedfold:[133,261],autotool:174,autovivif:183,auxprop:[63,175,261],avail:[3,5,7,9,11,12,15,19,24,25,30,35,36,41,44,45,48,56,57,63,64,65,66,67,68,71,72,74,84,122,133,149,151,152,153,154,155,156,157,158,159,160,175,180,181,182,183,184,192,193],availabl:4,available_selection_modes_on_backend:9,available_selection_modes_on_frontend:9,availmech:52,avenu:[11,57],averag:260,avoid:[26,33,47,72,74,75,82,83,84,113,116,120,126,134,144,222,236,248,261,280,315,355],awai:[72,73,253,285],await:[23,26],awar:[3,33,36,40,41,175,185,355],away:250,awesom:[73,175],awri:72,ayland:115,babysit:260,bacchella:[137,169],back:[7,11,14,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,34,35,36,37,38,39,41,47,49,71,122,125,130,163,174,178,183,186,188,193],backend1:[9,36,195],backend2:[9,36],backend3:9,backend:[3,4,6,7],backendserv:193,background:[71,260,285,297,319],backlog:297,backport:[44,115,116,122,146,169,351,355],backscatt:[113,261],backslash:[81,211,261],backtrac:[238,341],backup1:249,backup2:249,backup:4,backup_compact_maxs:[183,261,266],backup_compact_mins:[183,261,266],backup_compact_work_threshold:[183,261,266],backup_db:[183,261,266,274,315],backup_db_path:[183,188,261,266,274,315],backup_keep_previ:[261,266],backup_retention_dai:[183,261,266],backup_staging_path:[183,261],backupd:[183,259],backuppartit:[183,261,264],backward:[116,125,174,182,261,295,307,340,352],bad:[52,61,72,92,116,129,134,136,137,164],badlogin:276,badurl:118,badus:276,bail:[97,134,321],balanc:[7,9,11,30,36,184],balden:72,band:[193,250],bandaid:131,bandwidth:[11,216,222,342],bank:[127,284,353],banner:[81,92,125,137,261],bar:[40,56,193,195,298,319,358],bare:223,base64:[46,197],base:[5,11,13,15,18,36,40,43,44,46,52,56,62,63,66,68,71,72,75,77,79,81,85,92,100,106,107,111,125,135,163,174,175,176,183,184,185,186,188,193,202,204,207,211,225,235,244,256,261,266,271,289,293,296,297,301,314,326,340,350,352,354],basedir:46,bash:[174,175,217,219,355],bashrc:175,basi:[5,15,36,41,79,92,133,216,225,236,261,273,319,355],basicauth:340,bastion01:326,batch:[216,261,326],batten:[122,146],batteri:[11,220],bba47b13e4839f49ab1c8047ee7b4fdb:27,bboard:350,bcc:[211,261,326],bce8:269,bcederli:27,bcopi:72,bcyru:195,bdb:[12,74,97,129,239],bdystr:326,be1:30,be2:30,be3:30,beamnet:85,bear:[11,179,210],bearer:171,beast:255,becam:[239,350],becaus:[3,6,7,11,18,19,28,33,40,41,43,44,54,56,72,133,175,182,193,194,195,211,229,243,250,253,254,261,284,287,289,352,353],becom:[3,5,11,19,24,25,40,133,183,184,193,195,196,197,209,211,229,241,261,266,297,352],beef:72,been:[0,5,6,9,11,19,25,27,30,33,45,55,56,66,70,71,72,73,74,75,77,117,127,129,131,133,135,145,147,149,152,153,154,155,156,157,158,159,169,172,174,176,182,183,193,194,195,196,197,199,203,210,211,214,215,216,222,241,244,250,261,266,273,279,285,297,300,313,315,319,326,345,349,350,352],beer:11,befor:[7,41,43,44,47,49],before:[72,75],begin:52,behalf:[305,352],behav:[73,133,182,195,222,279],behavior:25,behaviour:[25,31,41,44,47,125,134,162,167,175,183,190,195,261,266,313],behind:[9,30,77,125,146,184,195,216,250,261],belief:[3,11],believ:[11,133,216,253],belong:[40,167,175,261,266,279,313],below:[18,27,41,47,52,60,63,64,68,71,129,174,175,181,194,196,199,206,211,214,216,217,219,245,260,261,266,267,274,293,315,319,355],benchmark:193,benefit:[15,186,187],benn:[349,353],berdmann:232,berk:12,berkelei:[12,73,74,75,88,91,120,149,150,151,152,153,154,155,156,157,158,159,174,175,194,223,224,227,233],berkeley_caches:75,berkeley_hash:[75,89],berkeley_hash_nosync:[75,89],berkeley_locks_max:75,berkeley_txns_max:75,berklei:[74,75,223],bernard:[137,169],bernhard:232,bernstein:[160,353],best:[6,25,40,48,55,60,174,175,176,193,222,228,239,243,261,320,341,350],beta10:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99],beta11:98,beta1:98,beta2:98,beta3:98,beta4:98,beta5:98,beta6:98,beta7:98,beta8:98,beta9:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108],beta:[72,133,290],bethani:183,better:[9,11,18,26,30,71,72,73,74,75,77,89,92,96,104,105,108,111,114,120,133,136,142,146,174,183,193,195,236,260,261,320,349,351,352,354],betti:284,bettysu:280,between:[3,5,9,11,12,15,25,26,30,36,38,41,43,53,56,68,71,72,74,75,82,83,107,108,129,145,146,160,173,175,176,178,181,183,184,187,190,193],beyond:[7,9,11,30,40,69,184,193,199,250,261,350],big:[113,114,131,162,165,183,195],bigbuff:203,bigdisk:222,bigger:[0,193],biggest:[9,30,184],bill:35,bin:[43,44,46,50,63,72,127,162,174,175,195,216,217,229,232,261,266,268,270,272,285,287,289,291,319,320,355],binari:[44,46,57,72,74,75,120,133,149,150,151,152,153,154,155,156,157,158,159,162,193,199,211,215,224,295,307,340],binary:[58,59,60,62,63,75,92,111],bind:[5,64,250,260,261,297],bindir:[149,150,151,152,153,154,155,156,157,158,159],binsymlink:[46,175],bird:222,birger:73,bison:[44,72,116,174],bit:[11,58,59,60,62,63,72,74,77,79,82,84,95,97,118,119,131,133,162,175,193,197,223,226],bitmask:[6,52],blah:261,blank:[260,261,262],blast:239,bleed:173,blob:[45,175,197],block:[11,47,80,133,183,211,260,266,278,320,349],blockdiag:48,blocker:349,blog:45,blow:192,blurdybloop:261,board:[13,19,261,348],bob:[66,204],bodi:[64,75,77,105,149,154,155,156,157,158,159,185,207,261,319,326,340],body:[72,285],bodystructur:[27,185,261],bodystructure:97,bogu:[74,126,195],bold:48,bonu:84,book:[22,36,68,358],books_test:358,boost:71,boot:[11,58,59,60,62,63],born:[176,350],both:[3,5,6,7,11,18,19,25,36,40,41,43,52,56,57,64,68,71,74,75,77,83,97,146,174,176,181,182,183,184,193,194,195,199,200,216,222,235,237,260,261,266,270,285,312,313,315,319,320,325,344,349,355],bother:105,bottleneck:193,bottom:47,bounc:[246,261],bound:[75,187,261],boundari:[72,74,127,133,261],boundary:27,boundary_limit:261,bovik:[41,72,133,181,193,205,283,284],box:[112,263,270,358],boyer:72,brace:197,bracket:[55,260],brain:[72,111],branch:[43,49,55,56,126,169,173,290,341,345],brand:46,brandon:[73,285],brashear:353,breyha:[115,121,122,135,136,137,146,168,169],brick:11,bridg:11,brief:[71,175,224,340],briefli:[7,196],brilliant:55,bring:[7,57,195,197],broad:44,broke:[72,116],broken:[91,96,113,120,125,145,167,281],bron:[127,349,353],brong:[133,282],brotli:[44,355],brought:183,brown:261,brownfox:261,brows:56,browser:[64,65],bruce:72,bsearch_mem:72,btree:91,buczek:131,budget:11,buf:[47,127],bug:[0,11,45,49],bugfix:[73,74,75,125],buggi:[46,72,73,128,131,145],bugs:48,bugzilla:[11,133,135,147,149,152,153,154,155,156,157,158,159],bui:[11,193],build:[1,2,4,11],built:[19,22,48,54,57,72,74,145,160,172,195,199,226],builtin:285,bulk:[84,267,326,343],bulletin:[13,19,261,352],bunch:[56,72,120,121,122,183],burden:64,burn:175,bushi:[175,189,261],busi:[11,26,64,85,100,101,220,236,237,239],button:[49,241,358],byacc:72,bye:[18,58,59,60,62,63,72,261],bylaw:[345,348],bynari:74,bypass:[6,72,164,193,292],bytecod:[19,75,149,156,157,158,159,207,261,316,317],c01:[58,59,60,62,63],c38962096a47:269,c_include_path:226,cabinet:216,cabl:11,cacertdir:285,cacertdirectori:144,cacertfil:[144,285],cach:4,cachdr:326,cacheabl:163,cacheid:72,cachever:[298,326],cadir:[144,145],cafil:[144,285],cafile:52,cage:40,cal:328,calalarmd:[44,46,149,150,151,152,153,154,155,156,157,158,159,185,355],calconnect:64,calcul:[9,11],caldav:[0,1,2,3,4,5],caldav_3:355,caldav_allowattach:261,caldav_create_attach:[64,261],caldav_create_default:[64,261],caldav_create_sch:[64,261],caldav_maxdatetim:[101,261],caldav_mindatetim:[101,261],caldav_realm:261,caldavtalk:46,caldavtest:[54,106,107],caldavzap:108,calendar:[6,11],calendar_user_address_set:261,calendarnam:27,calendarprefix:22,calendarserv:[54,64,261],calext:340,call:[3,11,38,43,45,47,52,56,58,59,60,62,63,66,72,73,74,116,128,129,133,145,161,165,174,175,182,183,186,193,199,203,220,222,241,251,261,276,349,355],callahan:73,callback:[52,72,203,329,330,332,333,334,335,337,338],callback_cap:52,callback_noliteral:52,cam:[75,116],cambridg:75,campu:352,can:[0,3,5,6,7,9,10,11,12,18,24,26,28,33,35,36,39,40,41,43,44,45,46,47,48,49,50,52,53,54,55,56,63,64,65,66,67,68,70,71,72,73,74,75,77,79,83,84,95,100,104,114,120,122,125],cancel:[72,197,199,261],canist:11,cannot:[7,27,40,41,44,48,60,64,72,74,169,175,180,189,193,194,254,261,296,297,341],canon:[11,261,355],canonic:[6,41,72,74,75,181,261],canonif:[3,5,19,44],canonifi:[5,171,261],capa:261,capabilities:261,capability:[18,52,58,59,60,62,63,72,80,82,92],capability_str:52,capabl:[11,41,44,48,52,72,81,82,83,116,128,133,169,183,193,216,261,315,329,330,332,333,334,335,337,338],capac:[4,7,9],capath:[52,145,285],capo:147,captur:[36,175],card:328,carddav:4,carddav_realm:261,carddav_repair_vcard:261,carddavtalk:46,care:[40,72,75,183,184,193,195,261,270],career:250,carefulli:[7,11,183,250],caringo:[149,151,152,153,154,155,156,157,158,159,261,355],caringo_:[149,151,152,153,154,155,156,157,158,159],caringo_hostnam:261,caringo_port:261,carlo:[135,144],carnegi:[57,133,176,345,350,352,353,354],carnegie:57,carsten:[73,133],carter:[75,77,79,80,81,84,97,114,116,127],cascad:[66,72],cass:46,cassandan:[43,45],castorsdk:261,cat:[175,355,358],categori:[160,193],catenate:[58,59,60,62,63,77,92,118,340],caught:120,caus:[6,11,30,33,41,72,73,75,77,84,97,113,126,129,133,137,174,175,181,182,183,188,193,195,197,199,204,215,216,230,231,233,236,243,246,253,260,261,270,313,319,320,328,329,330,332,333,334,335,337,338,355,358],caution:[46,214,261],cave:115,cb44:27,cdt:300,cell:[11,261],center:11,centos:[2,12,57],centr:222,central:[3,36,352],centric:[22,222],centuri:[176,350],ceph:11,cephfs:11,cert:[44,73,84,175,355],cert_fil:52,certain:[5,11,45,72,137,169,179,183,203,229,243,250,255,260,261,329,330,332,333,334,335,337,338,358],certainli:133,certif:[5,28,44,52,58,59,60,62,63,80,133,144],cetera:250,cflags:[44,46],cgi:239,chain:[63,133,134,183],challeng:[11,24,72,261,329,330,332,333,334,335,337,338,340],chan1:216,chan2:216,chan3:216,chanc:[9,24,30,73,184,195,215,241,261],chang:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40],changeabl:18,channel1:216,channel:[3,11,50,56,62,125,133,175,183,193,208],chapter:[7,8,10,211,218],charact:[3,18,33,41,53,72,74,81,84,95,96,113,117,129,133,136,161,175,187,190,197,207,216,219,223],characterist:7,charg:[41,178,206],charset:[27,72,111,121,130,230,326],chaskiel:353,chassi:[11,216],chat:175,chatter:71,chatti:261,chattr:220,chattrsync:220,chdir:[46,174],cheap:[11,28,71,193,220],cheaper:[11,15,186,220,261],check:[9,11,18,24,25,30,43],checkapop:248,checkdeliv:72,checklist:7,checkout:46,checkpass:276,checkperiod:235,checkpoint:[114,175,183,236,260,261,266,268,344],checksum:[111,183,266],cherri:43,child:[64,65,67,71,112,199],children:[58,59,60,62,63,73,131,279,297,319],chin:75,china:75,chk_cyru:[74,75],chkconfig:[58,59,60,62],chmod:[18,175,355],choeger:73,choic:[9,11,30,63,64,73,184,188,193,250,355],choke:146,chomp:289,choos:[5,7,11,33,64,146,186,188,190,193,204,229,241,261,314,358],chop:331,chose:226,chosen:[11,254,261,319,329,330,331,332,333,334,335,337,338],chown:[175,219,251,355],chri:[72,143,230,353],christian:75,christoph:[139,162],chroot:63,chunk:[11,106,108,183,261,266,274],churn:112,cice:340,cid:[172,185,261,326],cipher:[58,59,60,62,63,74,121,133,261],circuit:[75,101],circumst:[11,31,33,190,241,358],citizen:254,cjk:[50,160],claim:[5,72,223],clamav:44,clarifi:[72,211,241],clash:[169,313],classifi:349,clean:[11,25,28,41,43,46,47,48,56,71,73,74,75,115,133,144,166,174],cleanli:[72,73,137,163,168,197],cleans:279,cleanup:[71,72,74,115,116,120,121,133,149,151,152,153,154,155,156,157,158,159,260,268,297],clear:[5,41,52,55,193,195,261,283,285,313,326,350],clearli:11,clearos:57,cleartext:[68,261],cli:174,cli_fat:47,click:358,client:[3,4],client_bind:261,client_bind_nam:261,client_id:166,client_timeout:[75,261],clientaddress:[185,261],clientid:[185,261],clientip:27,clientport:27,clients_3:355,clone:[46,49,50,55,57,149,152,153,154,155,156,157,158,159],close:[7,8,9,25,30,41,52,58,59,60,62,63,64,72,74,75,77,121,184,187,193,197,219,241,250,251,261,285,297,330,358],closed:127,closedir:85,closer:[195,261],closest:[41,180,250,261],cluster:[11,36,63,129,195,250,255,261,270,303],clusterlvm:11,clutter:72,cmd:[15,50,63,114],cmd_renam:117,cmu:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],cmuloc:[43,72],cname:[72,193],code:[0,1,44,45,47,49,52],codebas:49,coexist:183,coher:[11,173],coi:33,cold:186,collabor:[54,133],collat:145,colleagu:133,collect:[6,11],collectnew:72,collis:270,colon:[263,281],coloo:[88,114,121,131,133],colour:48,columbia:77,column:[18,266],com:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],com_err:[72,75,172],combat:255,combin:[5,11,14,41,55,177,178],combinatori:261,come:[11,41,48,50,58,59,60,62,63,67,174,176,181,182],comerr:174,comfort:[11,174],comma:[6,9,30,219,261,263,277,281,302,319],command:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196],commandcrew:33,commandlin:47,commandmintim:261,comment:[47,55,63,235,249,270,285],commerci:228,commit:[41,43,48,55,56,72,73,112,166,193,263,268,270,349],committ:349,commod:11,common:[5,8,11,12,15,33,36,63,72,175,186,194,203,222],common_3:355,commonli:[3,8,11,36,41,63,181,225,253,264,268,270,290,291,292,294,303,306,322,323],commun:[11,12,36,40,41,54],comp:[199,261],comp_flag:6,comp_typ:6,compact:[50,55,71,183,241,261,266,319],compar:[5,11,36,74,81,136,193,195,241,255,261,298,328],comparis:84,comparison:[41,74,134],compat:[41,72,74,75,82,94,96,116,125,133,134,149,151,152,153,154,155,156,157,158,159,168,174,181,182,207,229,261,275,285,287,295,307,313,340,352,355],compel:6,compil:[6,19,41,42,43],complain:[72,149,151,152,153,154,155,156,157,158,159,226],complaint:73,complet:[3,11,12,18,41,44,45,52,56,58,59,60,61,62,63,66,72,75,106,118,122,145,162],complex:[11,50,72,133,261],compli:[24,182],complianc:[25,54,182,351],compliant:[14,27,72,74,75,100,178,185,246,261,288,292,350,354],complic:[183,196],compon:[3,4,7,11],compos:[3,5,9,184],comprehens:355,compress:[44,58,59,60,62,63,84,85,121,133,145,175,183],compression:[330,333,334],compris:[3,349],compromis:[193,195,261],comput:[3,4],con:196,concaten:41,conced:74,concept:35,concern:[9,11,30,184,216,245,350],conclud:210,concurr:[13,41,73,193,239,352,355],condit:[9,19,47,57,72,73,75,122,127,128,134,164,184,261,340],condition:72,condstor:[83,84,92,235],condstore:[58,59,60,62,63,80,92,127,235],conectiva:239,conf:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70],confer:41,confid:11,confidenti:251,config:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63],config_dir:72,config_fil:18,config_init:47,configdirectori:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174],configdirectory:249,configfil:48,configur:[0,1,2,3],configuration:48,configurationdir:267,configured:175,confirm:[26,45,56,195,344,349],conflict:[82,125,193,194,195,197,229,270,285],conflocal_mailer:[175,355],conform:[72,107,185],conforming:48,confus:[33,47,72,75,133,175,261,355],conjunct:[64,182],connect:[3,6,7,11,13,18,36,41,52,58,59,60,62,63,68,72,73,74,75,80,97,104,105,113,122,125,133,134,136,137,139,145,163,170,171,175,193,194,195,197,207,215,216,219,223],connection:57,conrad:353,consecut:261,consensu:[229,340,349],consequ:[7,11,315,358],consequential:57,conserv:[41,183,206],consid:[3,7,9,11,12,30,33,40,41,44,63,68,71,72,133,173,174,182,184,192,193,195,216,218,222,230,261,279,289,297,319,320,340,355],consider:[4,5],consist:[3,7,11,19,36,40,41,71,74,75,83,97,111,136,140,144,183,193,195,197,199,204,217,220,236,260,261,262,263,265,266,270,276],consolid:64,consort:46,constant:[72,114],constantli:[72,250],constitut:[26,60,315,355],constrain:[11,283],constraint:255,construct:[75,199,304],consult:[11,41,63,66,69,71,72,145,174,186,187,190,193,199,201,276,311,355],consum:[11,84,216,220],consumpt:7,contact:12,contain:[3,6,11,14,18,19,24,28,33,40,41,43,45,56,57,66,68,72,75,97,117,118,137,146,149,150,151,152,153,154,155,156,157,158,159,160,162,164,165,172,174,175,181,183,185,186,191,193,197,220,222,238,244,251,260,261,262,264,266,270,274,276,284,285,287,292,298,313,315,319,329,330,331,332,334,335,337,338,355],contemporari:43,content:[6,11,26,27,36,41],context:36,contigu:281,continu:[3,7,11,19,26,33,36,40,58,59,60,62,63,72,74,81,133,174,193,195,216,241,252,255,261,266,319,354],contract:[11,57],contrari:[3,11,176,261],contrast:72,contraven:261,contrib:[72,145],contribut:[0,1,48,49,54,73,92,133,134,145,169,261,345,349,353,357],contributor:[0,344,348,351],control:[3,5,7,9,11,13],conundrum:11,conveni:[133,182,225,315,320],convent:[1,33,41],conver:6,converg:4,convers:4,conversations_counted_flag:261,conversations_db:261,conversations_expire_dai:[261,279],conversationsdb:172,convert:[6,46,64,72,74,75,111,113,165,174,177,182],convexist:[185,261],convunseen:[185,261],cool:[46,66,193],cooper:284,coordin:11,cope:33,copi:[3,5,11,24,38,39,41,43,44,46,49,50,56,72,77,83,97,114],copy:[64,72,94,108,182],copyback:320,copying:96,copyright:57,core:[73,111,223],core_uses_pid:238,corneliu:[87,115],correct:[3,7,18,40,41,56,68,72,73,74,75,83,113,114,121,133,137,168,171,172,174,175,193,194,199,220,230,261,298,313,314,328,329,330,332,333,334,335,337,338],correctli:[43,47,56,72,73,74,75,84,113,125,134,135,136,137,139,145,160,161,162,163,165,168,169,171,172,174,175,193,195,209,261,355],correspond:[6,10,15,25,56,72,133,182,183,186,187,190,199,235,261,262,267,279,285,286,304,315],corrupt:[6,11,41,64,72,84,112,114,120,125,127,128,142,171,183,195,214,220,233,249,250,261,266,313,328],cors:261,cost:4,costli:28,could:[3,5,7,10,11,15,18,19,28,33,36,38,41,46,47,60,72,74,75,83,103,115,128,129,133,145,164,166,174,179,181,182,183,193,195,197,216,220,236,241,320,326,341],couldn:[52,164,250],count:[6,9,11,30,35,41,84,122,133,137,165,182,184,197,206,213,223,241,250],counter:4,countri:19,coupl:[11,27,73,185],courier:[149,151,152,153,154,155,156,157,158,159,176,261,350],cours:[3,9,11,30,183,184,254],courtesi:[79,80,81,82,85,96,97,111],cover:[55,57,69,114,203],coverag:44,cpan:[44,46],cpu:[36,216,250,261],craft:[166,250],craig:[79,92,349,353],cram:[5,41],crap:72,crash:[46,71,73,74,75,82,84,90,114,116,120,121,122,124,125,127,128,129,130,131,134,135,136,137,139,140,141,145,146,147,160,162,163,164,165,166,168,169,170,172,193,195,216,224,341],crashi:171,crawl:39,crc32:[46,149,151,152,153,154,155,156,157,158,159],crc32c:165,crc:[111,134,320],creat:[3,5,7,9,10,11],create:[6,18,72,73,74,84,97,133,134,182,193,195,261,285],createabl:193,createdir:175,createmailbox:[134,175,213],createonpost:[133,261],creation:[4,7],creationd:6,credenti:[5,105,183,195,216,222,261,315,329,330,332,333,334,335,336,337,338],crept:130,cridland:84,crispin:72,crit:[41,250],criteria:[11,15,186,235,284],critic:[28,41,56,73,216,250],crlf:[41,55,117,197,232],cron:[15,41,70,183,216,222,260,284],crontab:[70,284,319],cross:42,crossdomain:[149,151,152,153,154,155,156,157,158,159,174,261],crossdomains_onlyoth:[149,151,152,153,154,155,156,157,158,159,261],crow:193,cruft:111,crypt:18,cs0:261,cs1:261,cs2:261,cs3:261,cs4:261,cs5:261,cs6:261,cs7:261,csync:[71,175,183,201,216,261,264,315,322,355],ctag:340,ctl_backup:[164,165],ctl_backups_lock_data_fnam:266,ctl_backups_lock_index_fnam:266,ctl_conversationsdb:[174,259,261],ctl_cyrusdb:[74,111,122,146,175,183,195],ctl_deliv:[73,75],ctl_mboxlist:[36,73,74,75,82,92,97,117,128,140,145,188,194,195,211,216],ctl_zoneinfo:[64,108,259],ctrl:[219,276,358],culprit:11,cumbersom:11,cunit:[44,56,165],curl:[174,175],current:[5,6,11,15,19,27,33,36,40,41,43,47,48,49,52,55,56,58,59,62,63,64,68,70,72,74,82,83,100,160,174,175,182,183,184,192,193,194,195,196,197,199,203,206,207,216,222,224,228,229,247,249,250,261,263,266,276,280,284,285,300,302,309,311,328,329,330,331,332,333,334,335,336,337,338,340,344,349,358],currently:[41,249,313],curv:[121,133,261],custom:[11,28,66,68,149,150,151,152,153,154,155,156,157,158,159,164,167,183,228,266,341],customer1:3,cut:[11,350],cutoff:285,cve:[86,114,138,139,145,161,163,164],cvs:112,cvt_cyrusdb:[74,75,174,204,219],cvt_xlist_specialus:[174,259],cycl:[24,25,36,60,72,133,173,215,216,241,260,320],cyr_buildinfo:259,cyr_dbtool:[96,146,183,219],cyr_deni:259,cyr_df:84,cyr_expir:[15,24,25,75,77,79,82,85,97,117,125,130,131,133,171,175,199,211],cyr_info:[174,259],cyr_synclog:[79,83,144,216],cyr_virusscan:[44,70,137],cyradm:[18,22,28,40,41,44,52,64,72,73,74,75,89,115,129],cyradmin:72,cyradmn:212,cyrdeliv:245,cyrdump:[112,166,171],cyril:85,cyrsudb_db3:73,cyru:[0,1,2,3,4,5],cyrudb:75,cyrupload:[43,56],cyrus24:46,cyrus25:46,cyrus:[64,137,169],cyrus_conf:[175,355],cyrus_don:47,cyrus_group:[172,261],cyrus_imap_murd:7,cyrus_path:261,cyrus_prefix:[73,131],cyrus_us:[172,261],cyrus_user:261,cyrus_verbose:297,cyrus_version:112,cyrusarch:187,cyrusdb:[6,47,64,73,74,75,82,89,165,204,236,261,272,276],cyrusdb_db3_nosync:73,cyrusdb_lmdb_maxsize:44,cyrusdb_quotalegaci:82,cyrusdb_skiplist:74,cyrushost:276,cyrusimap:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],cyrusisgreat:40,cyruslib:[50,160,170],cyruslibs:50,cyruslibs_dir:50,cyrusmeta:[190,191],cyrusmurd:[197,255],cyrussiev:223,cyrusv2:[40,175,355],cyruswork:45,cyrusworksrul:45,d5ec35c1414a:[58,59,60,62],daboo:235,daemon:[11,19,41,50,63,71,72,73,74,145,149,150,151,152,153,154,155,156,157,158,159,167,169,174,175,183,188,195,202,207,222],dai:[7,11,15,28,41,48,84,131,133,174,175,176,183,185,199,211,220,235,236,241,260,261,263,279,285,293,300,326,350],daili:[11,84,319],dam:285,damag:[41,216],damages:57,dan:353,danger:321,dark:[176,350],darrow:73,darth:[222,251],data:[3,4,6,7],databas:[1,4,5],database:18,datagram:[289,291],dataless:193,dataset:[193,216],datastor:[222,265],datastructur:203,datatyp:[84,131],datauuid:46,date:[27,41,57,64,72,112,127,149,156,157,158,159,175,183,184,193,195,197,207,222,255,261,263,284,285,293,298,300,320,340,350],datestamp:48,dav:4,dav_realm:261,dav_reconstruct:[133,137,174,259,261],dave:[84,127,349,353],davfilenam:[185,261],davi:353,david:[73,75,77,79,80,81,84,97,114,116,127],davnotificationsprefix:261,davtalk:46,davuid:[185,261],daylight:84,db3:[73,74,75,223],db4:[74,75,84,253],db_config:239,db_mail:18,db_mail_password:18,db_mail_us:18,db_passwd:18,db_recov:[75,194,249],db_stat:239,db_user:18,dba:6,dbdir:74,dberror:[74,84],dbm:72,dc814658a4d676789578bff3de35b45914abd774:298,ddmmyyyi:263,deactiv:[9,30,184,193,336],dead:[73,260,261],deadlock:[47,72,73,243],deal:[63,72,73,74,195,197,236,248,250],deanna:262,deb:355,debconf:174,debhelp:174,debian:[2,12,44,54,57],debug:[6,18],debug_command:[74,261,264,289,290,292,294,304,305,306,318],debugg:[74,244,264,289,290,292,294,304,305,306,315,318,320],decemb:350,decent:236,decid:[11,36,63,72,185,193,199],decim:[52,315],declar:[72,186,261,340],declarar:72,decod:[72,175],decompil:[207,317],decoupl:171,decreas:[72,252],decriptor:47,dedic:[7,71,183,216,264,353],deem:11,deep:[183,261,266],deeper:261,defaultacl:[41,180,261],defaultdomain:[40,149,151,152,153,154,155,156,157,158,159,175,261],defaultpart:[186,190,261],defaultpartit:[9,28,30,41,50,175,184,186,187,190,191,261],defaultsearchti:[50,186,191,261],defaultserv:[9,30,84,184,261],defeat:74,defect:72,defer:194,definit:[11,18,57,177,186,191],deflat:320,deflate:[58,59,60,62,63,340],degener:72,degrad:[72,233],degre:41,dekker:127,delai:[11,13],delaycompress:175,delayed_expung:125,deleg:179,delet:[8,11,13],delete_mod:[24,41,79,116],delete_unsubscrib:261,deleteacl:[182,285],deleteaclmailbox:41,deleted:[24,72,115,116,125,211,261,285],deletedmessag:211,deletedprefix:[24,79,211,261,315],deleteing:96,deletembox:41,deletemsg:41,deleteprun:[133,175],deleteright:[182,261],deletes:195,delight:341,delimit:[24,48,64,65,67,72,246,261,263,276],deliv:4,deliver:[75,345],deliverdb:[72,269],deliveri:4,delprun:[175,211,260],delsub:83,delta:[9,30,184,195,261],delteacl:285,demand:[100,216,237],demi:183,demot:220,deni:[6,73,85,175,182,195,197,219,276,277,292],denial:[6,74,175,197,276],denot:[232,358],dens:275,depart:352,depend:[7,9,11,30,36,41],depict:11,deploi:[4,15,60,182,250,319,350],deploy:[4,5],deployment:40,deployment_guid:9,deprec:[6,41,71,75,111,133,149,152,153,154,155,156,157,158,159,174,175,182,201,216,261,273,313,331,340,352,355],depth:[113,175],dereferenc:261,deriv:[41,57,195,216,243,313,319,336],derrick:353,des:72,describ:[3,8,12,18,27,41,47,52,56,64,72,135,182,187,193,207,216,218,222,260,261,262,271,319,345,350],description:48,descriptor:[47,52,72,75,106,149,151,152,153,154,155,156,157,158,159,260,261,264,290,292,294,303,304,306,318,323,330],deserv:5,design:[0,5,6,11,13],desir:[5,11,72,82,195,197,203,216,261,297,350,355],desktop1:358,desktop:[207,358],desno:353,despatch:[176,350],desper:207,despit:[47,55,175,188,197,226,355],desruisseaux:340,destdir:46,destin:[3,64,75,77,125,136,175,183,193,254,261,274,285,315,319,352,355],destroi:[43,56,71,321],desttier:319,desyncronis:166,detail:[6,11,12,18,41,44,47,52,56,57,63,69,71,72,75,77,82,83,85,96,97,129,133,174,177,183,184,185,186,187,190,191,192,193],detect:[12,26,70,73,75,84,85,107,125,126,129,133,134,137,146,149,156,157,158,159,162,165,169,171,214,215,223],determin:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211],determinist:275,dev:[10,11,44,50,173,174,175,183,248,261,345,349],dev_3:355,devel:[11,33,44,195,226,343],development:173,devic:[3,4],devrandom:248,dfuch:73,dhe:[58,59,60,62,63],diacrit:261,diagnos:[44,72,239],diagnost:274,diagram:[11,199],dialog:358,dictat:[11,15,41,63,181],did:[19,38,43,56,72,130,175,204,207,261,270,341],didn:[72,129,137],die:[233,289],diesel:11,differ:[7,9,11,13,18,19,30,33,36,41,44,53,54,55,64,71,72,74,75,105,112,114,116,129,130,134,140,174,175,182],differenti:261,difficult:[12,193,228],digest:[5,41,44,68,74,105,261,284,285,329,330,332,333,334,335,337,338,340],digit:[41,72,129,243,261,263,288],dilail:352,dilyan:[114,116],dilyanpalauzov:171,diminish:[9,30,184],dir:[12,64,72,137,150,151,152,153,154,155,175,319,358],direct:[7,11,15,41,48,56,68,72,164,174,186,187,190,193,199,201,222,258,261,319,349],directli:[11,22,41,44,48,57,64,75,112,115,133,175,193,195,227,228,241,261,266,268,352,355],director:193,directori:[10,11,15,24,30,35],dirhash:[118,119],dirsrv:11,disabl:[11,12,18,19,24,25,33,41,44,63,64,68,72,73,74,75,77,79,85,88,97,114,116,121,131,133,144,145,163,164,174,175,185,193,199,204,207,238,248,261,264,279,289,290,292,294,304,305,306,318],disable_shared_namespac:[33,261],disable_user_namespac:[33,178,261],disadvantag:7,disallow:[41,72,235,285],disappear:[25,261],disast:[11,175,267,355],disavow:72,disc:285,discard:236,disclaim:57,disclaims:57,disclos:[144,261],disconnect:[72,136,160,195,235,261],disconnect_on_vanished_mailbox:[85,121,261],discov:[127,214,236],discoveri:11,discreet:261,discret:4,discretionari:[33,177],discuss:[15,40,41,47,50,64,162,181,183,185,186,195,203,211,247,250,254,343,349,358],disinfect:221,disk:[3,6,9,10],diskquota:27,diskus:[27,185,261],dispatch:71,displai:[6,8,33,45],display:[63,113,351],disposit:[72,340],disrupt:71,dissapear:233,dissappear:[133,241],dist:[43,73],distanc:[55,176,350],distcheck:[56,163],distclean:72,distinct:[15,36,71,184,194,243,260,261,263,284],distinguish:[5,33,41,181,220,358],distribut:[2,4,6],distributor:19,distro:[44,174,175,195,216,355],ditto:193,divers:[340,353],divid:[3,11,28,68,72,122,186,220,260],dkim:[64,261,340,345],dlist:[6,165],dmarc:345,dmz:193,dnf:60,dnl:[175,355],dns:40,doabl:233,doc:[1,43,44,48,63,71,149,151,152,153,154,155,156,157,158,159,160,167,175,219,235,276,345,355,357],doc_3:355,docbook:358,docker:45,docsrc:[43,48,56],document:[0,1,11,13,15,18,19,27,40,41,43,44,46],doe:[3,5,7,8,11,13,19,27,33,35,36,40,41,46,53,58,59,60,62,63,65,67,68,70,72,73,74,75],does:[216,247],doesn:[0,18,19,33,41,43,46,56,64,72,73,74,79,85,115,117,122,135,137,175,182,185,193,211,219,230,250,260,261,276,320],doesnt:249,dohash:72,domain:[3,7,13,18,33],domainkei:[68,175,261,340],domainrelatedobject:261,don:[0,3,18,44,45,47,48,49,55,64,72,73,74,75,105,117,118,121,129,130,136,141,143,145,146,160,165,174,175,183,185,192,193,194,195,207,226,228,239,248,250,251,261,266,270,288,297,302,312,313,315,319,320,323,329,330,332,333,334,335,337,338,340,342],donald:131,done:[15,25,40,41,46,47,49,64,68,72,75,83,100,174,175,183,189,193,195,199,207,214,216,219,225,236,261,270,283,285,301,336,355],dopenssl_no_krb5:226,dormant:263,dos:[74,112],dot:[3,33,41,53,74,118,136,160,261],doubl:[75,113,197,260],doubt:113,doubtless:355,dovecot:[46,127,149,151,152,153,154,155,156,157,158,159,261],down:[36,71,72,74,129,133],downcas:246,downconvert:230,downgrad:[122,174,221,313],downloadurl:165,downtim:[195,352],dozen:36,dpc22:116,dperl_pollute:73,dpkg:[175,341,355],draft:[33,41,72,74,75,77,100,133,207,211,214,235,254,261,280,283,298,313,336],dragonfli:114,drastic:[97,255],draw:358,drawback:[193,350],drbd:[11,261],dread:[72,73],drive:[11,67,68,175,186,261],driver:11,drop:[72,133,149,150,151,152,153,154,155,156,157,158,159,170,197],drop_cr:232,dropcr:232,dropoff:72,dry:[147,195,293,325],dsn:72,dtend:6,dtstart:6,duck:[43,56],due:[41,68,73,82,101,125,133,134,166,174,175,183,223,239],dummi:261,dump:[72,74,75,92,118,183,188,194,197,223],dump_deliverdb:72,dupelim:72,duplic:4,duplicate_check:116,duplicate_db:[10,133,261],duplicate_db_path:[10,71,175,188,261],duplicate_mailbox_mod:280,duplicatedb:73,duplicatedeliv:[79,235],duplicatesuppress:[41,73,75,261],durabl:224,durat:[11,74,279],dure:[11,12,19,24,36,41,45,60,72,73,74,75,97,113,122,128,146,149,151,152,153,154,155,156,157,158,159,162,164,170,174,175,181,183,184,185,193,195,196,220,250,261,275,285,315,341],duse_setproctitle:145,dynam:[66,261],e503646e389f507777fb75eeacc2da0d2156016a:326,each:[3,6,7,9,11,13,15,19,27,28,30,31,33,36,38,40,41,43,52,56,71,75,84,114,115,125,133,149,150,151,152,153,154,155,156,157,158,159,174,175,176,178,181,183,184,186,190,191,193,194,195,196,197,199,203,205,206,211,216,217,222,224,229,233,239,243,251,260,261,262,263,266,267,274,276,281,287,288,292,300,303,314,319,320,350,355,358],eachoth:3,eager:73,earli:[172,261,350,352],earlier:[18,43,56,72,122,126,127,137,162,165,166,174,175,193,207,261,270],earliest:[241,261],earmark:12,easi:[41,193],easier:[0,18,35,72,74,133,134,179,223],easiest:[40,56,261],easili:[6,49,179,199,352,358],eat:72,eaton:[349,353],ebai:129,ecdhe:[121,133,261],ece:262,echo:[72,175,219,238,330,355],ecparam:[133,261],edda:[168,171],edg:[125,173],edit:[44,46,48,63,175,196,199,207,222],edithead:340,editor:[6,48,175],edu:[52,57,72,73,74,77,92,116,193,195,211,239,250,253,262,285,343],eest:284,effect:[5,9,30,36,47,68,72,82,133,164,175,182,186,195,207,216,220,236,261,280,315,319,340],effectiv:5,efficaci:28,effici:[11,13,35,71,72,73,126,195,216,255,261,320,328,352],efficienc:345,effort:[11,12,41,57,133,247],egd:73,ehlo:175,either:[6,9,11,18,19,22,30,36,41,44,63,68,71,84,162,174,175,176,179,181,193,194,197,199,201,202,204,207,211,216,222,226,227,241,248,260,261,263,282,285,287,311,315,319,349,350,352,355,358],el6:27,el6_6:[58,59,60,62],el7:326,elect:349,electron:[340,352],elfejoyeux:85,elimin:[11,35,72,73,80],elli:[56,183],ellie:[43,56,353],ellipt:[121,133,261],els:[0,43,56,63,250,344],elsewher:[15,47,199],email:[3,5,6,11,15,18,19,27,28,33,40,41,44,45,53,64,113,120,133],embarrass:39,embed:[6,285],emerg:11,emiss:27,emit:[27,72,117,230,261,313,319],emori:77,empire:[46,176,350],emploi:[19,26,178,216,250],employe:19,empti:[6,11,30,33,68,72,74,75,83,85,117,136,168,184,186,190,191,195,197,241,261,315,319],empty:[241,315],emul:[64,261],enabl:[4,5,6,11],enable:[63,111,340],enable_event_notif:185,enable_experiment:72,enabled:[115,122],enclos:[72,260],enclosur:340,encod:[121,172,197,211,230,261,287],encode:[27,106,340],encompass:222,encount:[72,226,358],encourag:[57,193,325],encrypt:[5,18,36,68,72,195,261,290,292,304,306,329,330,332,333,334,335,337,338],enctyp:226,end:[3,11,27,28,40,47,52,55,56,64,65,67],end_command:52,endian:[73,162,165],endless:[26,233],endors:57,endpoint:252,endscript:175,energi:11,enforc:[5,36,60,235,261],engin:[72,169,186,191,261,319,320,322,349,352,355],engineer:348,english:261,enhanc:[11,55,57,73,74,75,100,121,131,133,160,162,208],enorm:11,enospc:11,enough:[41,47,172,175,183,184,199,240,248,250,261],enrich:133,ensur:[5,8,11,18,19,24,25,36,39,44,58,59,60,62,63,71,72,75,83,84,136,174,175,183,193,195,197,199,216,220,236,241,260,261,319,349],ensure:[43,46,56,83],enter:[43,56,58,59,60,62,63,175,207,276,289,358],enterpris:[2,12,13,44,57],entertain:33,entir:[11,25,33,41,47,48,63,74,77,83,106,120,174,176,183,185,189,193,195,197,199,211,220,221,241,261,279,282,283,297,303,319,350],entireti:285,entiti:[3,5,193,197,340],entri:[5,6,25,36,40,41,71,72,77,103,114,127,137,144,169,170,175,180,181,183,186,187,188,190,191,193,195,197,199,201,207,211,216,222,235,236,260,261,266,267,268,276,277,279,282,285,297,305,309,310,313,319,355],entropi:[248,261],enumer:[224,261],env:131,envel:326,envelop:[27,40,41,72,73,75,185,207,230,261],envelope:[72,117],envfromsmtp:40,enviro:75,environ:[3,4],environment:[48,194],envset_lk_max_lock:239,envset_lk_max_object:239,envtosmtp:40,eof:[72,74,266],equal:4,equat:11,equi:261,equiv:[41,181,259],equival:[11,193,230,261,262,313],era:350,erat:[122,145,146,149,151,152,153,154,155,156,157,158,159],erdmann:232,erfrakon:111,eric:72,err:[41,75,219],errno:[52,74],error:[8,18,28,41,44,45,46,52,58,59,60,62,63,72,73,74,75,79,114,115,117,124,125,126,127,129,131,133,134,135,137,142,145,149,153,154,155,156,157,158,159,164,168,169,174,175,193,194,223],errors:48,escap:[74,211,219,245,261,276],escape:[175,207,219],esearch:[63,111,131,261,351],esh:92,esmtp:[175,340],esort:351,especi:[4,11,24,25,47,73,77,175,183,203,239,250,261,276],essenti:[44,174,195,222],essential:226,establish:[11,13,18,58,59,60,62,63,186,195,222,223],etc:[2,5,6,9,11,18,31,33,36,40,41,44,46,47,63,66,70],eudora:[74,261],evalu:[11,193],even:[0,3,11,15,18,19,36,40,41,43,53,60,72,73,74,75,84,116,125,127,164,172,173,175,182,193,195,206,216,219,222,226,240,241,261,266,279,285,287,319,329,330,332,333,334,335,337,338,352],event:[13,19,24,25],event_content_inclusion_mod:[185,261],event_content_s:[185,261],event_exclude_flag:[185,261],event_exclude_specialus:[185,261],event_extra_param:[185,261],event_group:[185,261],event_notifi:[185,261],events:[15,70,71,133,174,175,183,188,211,216,222],eventsourc:[149,151,152,153,154,155,156,157,158,159],eventu:267,eventual:[73,289],ever:[3,40,47,113,188,199,237,238,247,261,297,313],everi:[0,3,6,15,40,47,49,57,72,176,185,186,187,190,195,197,199,207,211,216,222,236,242,252,255,261,267,319,320,350,352],everydai:[11,40],everyon:[40,47,72],everyth:11,ex_tempfail:72,exact:[8,9,11,48,114,175,241,261,293,341,355],exactli:[11,26,48,84,175,182,261,293],exam:9,examin:[46,174,183,203,278,279,293,298,313,326,352],examine:[72,182,193,285],exampl:[3,5,9,11,18,19],example:48,example_of_freespace_most_selection_on_backend:9,example_of_freespace_most_selection_on_frontend:9,exampleisp:40,examples:48,exce:[41,204,261],exceed:[27,350,354],excel:[220,250],excempt:213,except:[11,47,63,65,67,72,184,194,241,261,285,352],exception:[13,241],exchang:[5,36,193],exclud:[3,7,9,30,184,193,195,197,261],exclus:[9,11,19,40,48,72,182],exclusion:4,exclusiv:266,exec:[131,336],exec_prefix:165,execut:[8,11,68,72,74,75,149,150,151,152,153,154,155,156,157,158,159,174,182,188,199,218,220,241,244,261,266,285,297,301,302,358],exercis:[11,216],exhaust:313,exim:[41,74,223],exim_dropcr:232,exist:[4,5,6,7,8,10,11,19,27,28,33,36,40,41,45,52,64,65,67,71,72,75,105,116,118,119,129,133,162,168],exists:[122,137,165],exit:[47,48,52,72,74,121,135,136,168,175,216,260,266],exitcod:72,expand:[11,64,261,281],expans:11,expect:[0,9,11,18,30,44,60,71,73,117,133,164,175,182,183,193,195,260,261,265,267,341,351],expens:[11,28,77,183,193,241,261,304,313,315],experi:[0,26,72,133,169,175,193,223,236],experienc:[233,342],experiment:[72,82,149,151,152,153,154,155,156,157,158,159,163],expert:[0,11],expertis:6,expg:[211,326],expir:[72,75,175,199,211,235,241,279,285,310,324],expirat:[199,279],expire:[24,25,175],expirenew:75,expiri:125,explain:[11,41,175,181,197,218,239,245,277],explan:[15,175],explicit:[0,83,260],explicitli:[9,30,44,64,82,175,176,182,184,207,261,315,319,340],exploit:[75,86,114],explor:195,explos:261,expos:[66,320],express:[41,44,48,73,261,266,354],expression:[207,340],expung:[13,24],expunge:[25,77,97,112,127,179,182,193,211,241,261,285],expunge_mod:[25,41,77],expunged:72,expungeprun:[133,175],ext2:236,ext3:236,ext4:11,ext:351,extend:74,extended:[63,111,115,134,149,150,151,152,153,154,155,156,157,158,159,261],extens:[27,44,52,72,73,75,77,81,89,111,115,149,151,152,153,154,155,156,157,158,159,164,175,195],extensibl:340,extension:[72,133,182,207,241,261,340],extensiv:[149,151,152,153,154,155,156,157,158,159,160,345],extent:285,extern:[36,41,52,53,64,70,74,80,85,181,193,203,221,222,261,264,284,289,290,292,294,304,305,306,318,322],external:2,extra:[9,11,30,64,73,74,117,127,185,209,211,261,319],extract:[43,56,57,261],extraction:340,extraid:74,extrem:[11,52,195],extutil:44,fa6558da:269,fabric:[137,169],face:[6,183],facil:11,facilit:[11,25,38,92,133,195,199,241,261,326,349],fact:[0,3,5,19,36,47,73,175,190,193,195,241,355],facto:176,factor:[11,49,58,59,60,62,63,261,264,290,292,304,306,322],faculti:353,fail:[11,18,19,26,41,44,45,46,52,56,72,73,74,116,117,126,133,134,135,137,146,162,174,182,193,194,207,215,226,246,250,261,266,276,287,289,313,315],failedloginpaus:[129,261],failov:[11,174],failur:[3,6,11,41,52,74,102,116,120,122,126,131,133,135,137,144,147,162,168,169,175,177,183,192],fair:228,fairli:[72,237,355],fake:47,fall:[11,19,64,125,163,193,216,261],fallback:199,fals:[40,63,72,175,188,216,235,261,285,319],famili:[11,352],familiar:[11,49,174,183,228],family2:3,famou:[11,176,350],fanci:230,faq:[223,239],far:[11,36,47,72,195,245,285,292],fare:241,fart:72,fashion:[11,40],fast:[6,28,46,71,74,176,186,220,224,247,279,313,319,329,330,332,333,334,335,337,338,350],faster:[10,11,47,74,75,101,133,149,150,151,152,153,154,155,156,157,158,159,165,174,177,188,193,196,208],fastmail:[27,45,74,77,79,80,81,82,96,97,127,133,149,150,151,152,153,154,155,156,157,158,159,185,261,353],fastmailshar:261,fatal:[47,52,72,74],fault:328,faulti:11,favero:172,favor:261,favorit:[11,133,175],favour:[6,146,149,150,151,152,153,154,155,156,157,158,159,216],fax:57,fc20:326,fc21:326,fcntl:74,fdatasync:74,fear:174,feasibl:11,featur:[0,1,2,3,4,5,6,7,8,9,10,11,12],feb:[27,211,246],fed:[75,199,261,267,288,304],fedex:284,fedora:[2,12,54,57,58,59],fedoraproject:[11,326],feed:[11,13],feedback:[0,183,349],feeder:[75,304],feel:[11,66,174],felix:172,fenc:11,ferreira:353,fetch:[44,45,46,48,49,50,72,75,80,97,120,122,140,174,175,182,193,220,222,223],fetching:193,fetchnew:4,few:[3,5,11,36,41,48,56,71,72,108,131,183,186,193,195,220,222,228,236,249,250,261],fewer:11,fiber:[3,11],field:[6,18,41,127,140,163,166,174,175,181,186,188,190,197,203,260],fields:72,fifth:319,fig2dev:44,figur:[72,175,250,266],file:[0,1,2,3,4,5],filedescriptor:74,fileformat:272,fileinto:[19,33,74,81,133,164,207,258,261],filenam:[19,41,75,183,188,243,261,264,266,269,270,274,290,292,303,304,306,309,310,315,316,336,358],filename:27,files:48,filesystem:[3,4],filesytem:241,fill:[47,49,52,72,129,174,261],filter:[13,19],find:[5,6,11,41,43,44,45,56,68,127,129,133,145,163,174,175,186],fine:[46,75,183,232],finer:183,finger:[72,289],finish:[11,56,61,73,174,211],finishproc:52,finishrock:52,fire:238,firewal:193,first:[0,9,19,30,41,44,47,52,55,64,65,67,72,73,101,115,127,128,131,133,145,174,175,176,181,183,184,187,189,190,193,195,197,204,207,211,216,226,231,235,241,243,246,249,251,254,261,262,267,277,279,284,290,292,312,313,315,319,320,350,354,355,358],fit:4,fitness:57,five:74,fix:[41,43,44,46,55,56,72,73,74,75,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,100,102,103,106,107,108,109,112,113,114,115,116,119,120,121,122,123,124,125,126,127,128,129,130,131],fixdir:175,flag:[6,15,19,27,38,40,41,46,50,52,72,73,74,75,79,85,92,102,111,112,113,125,133,134,135,162,174,179,182,183,185,188,194,207,211,216,220,235],flagnam:[27,185,261,326],flags:[73,118],flaki:253,flap:130,flash:11,flat:4,flatten:275,fleme:[193,239],flex:[44,72,174],flexibl:[11,133,193,204,216,285,345],flight:175,flip:236,flock:74,flow:[26,27],flush:[72,77],flushseenst:[77,97,261],flux:11,fly:[19,97,129,261],fmt:52,focus:193,fold:[72,75,114],folder:[5,6,7,9],folders:[41,165,206,285,312],follow:[0,6,7,8,9,10,11,12,13,18,19,23,24,25,27,28,30,33,36,40,41,43,44,46,48,50,52,54,55,56,57,58,59,60,62,63,64,68,71,133,149,156,157,158,159,174,175,180,181,182,183,184,186,188,193,195,197,201,202,207,211,216,217,218,219,220,229,232,241,254,260,261,263,266,274,275,280,284,285,304,315,319,320,336,340,341,343,349,350,355,358],followup:[75,261],foo:[40,72,131,133,193,194,195,207,261,298,319],fool:241,foolproof:195,foolstupidcli:261,foot:11,footer:162,footnot:[11,27,36,133,241],footprint:[11,73],forb:57,forbidden:243,forc:[73,74,261,266,293,313,314,321,329,330,331,332,333,334,335,337,338],force_sasl_client_mech:261,forcibl:74,foreach:[84,147],foreground:83,foreign:219,foremost:11,forerunn:[176,350],forese:7,forev:[133,182,261],forget:[49,207],forgiv:74,fork:48,form:[5,40,41,57,63,64,72,174,181,197,220,241,260,261,264,285,290,292,304,306,315,322,352],format:[6,27,41,43],former:[11,15,71,133,175,201,241,260,355],formul:11,forth:11,forthcom:73,fortun:207,forward:[36,108,193,197,207,216,285,340,352],found:[9,30,44,45,52,55,104,105,107,108,120,127,137,176,193,214,219,223,225,239],foundat:133,founder:[46,350],four:[33,41,174,181,260],fourth:[216,267,319],fox:261,fpic:[44,46],fprintf:52,fqdn:3,fraction:[131,319],framework:45,francoi:353,freakin:250,fred:41,free:[9,30,47,49,52,64,72,75,100,101,133,136,184,186,190,195,203,204,261,313,345,354],free_cr:72,freebsd:[12,114,130,174,188],freed:[52,75,197],freeli:75,freenod:[175,342],freespac:[9,30,184,195,235,261],freez:223,french:3,frequenc:[72,216,217,242],frequent:[11,72,193,217,220],fresh:183,freshmen:350,fri:300,friend:[195,222],friendli:[165,342],friendlier:97,from:[2,3,6,7,9,11,13,15,18,19,24,25,26,27,28,30,33,35,36,38,40,41,43,44,45,46,47,48,49,50,54,55,56],front:[7,174,193],frontend:[3,4,7],frustrat:358,fs_get:74,fs_give:74,fsck:11,ftp:[43,56,57,133,134,135,136,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,165,166,167,168,169,170,302],fuch:73,fud:[72,73,74,131,259],fud_queri:289,fud_respons:289,full:[11,12,13,18,19,40,48,57,69,71,75,83,133,174,179,182,183,185,195,202,241,261,281,297,320,341,345,352],fulldirhash:[75,82,120,189,261,314],fulli:[3,11,12,19,33,36,40,41,133,182,184,193,207,250,261,285,304,314],fullnam:6,fulltext:319,functionproc:52,fundament:40,further:[3,11,15,40,41,49,66,74,174,177,182,188,193],furthermor:[71,199],futur:[7,11,40,72,133,134,146,192],fuzzi:[77,261,351],fuzzy:[171,261],g0241b22:56,gahd:[163,172],gain:[175,220,352,355],garbag:[73,109],gardin:353,gari:[73,97],gatewai:[75,199,352],gather:74,gave:243,gcc:[44,50,73,85,116,135,149,153,154,155,156,157,158,159,163,167,226,229],gcm:[58,59,60,62],gdb:[46,223,238],geani:48,gener:[3,4,6],generate_compiled_sieve_script:[133,261],gentoo:[12,57],geograph:11,gesang:136,get:[0,1,2,7,9,11,18,19,27,30,41],getacl:[182,285],getent:[175,355],getgrent:[41,181,261],gethostnam:261,getinfo:134,getmetadata:[134,146,163,182],getnameinfo:74,getopt:285,getpassphras:129,getprotobynam:289,getquota:[84,193],getquotaroot:[131,172,193],getservbynam:72,getuid:72,getxstr:74,gfs:11,ghudson:72,giant:261,gif:261,gigabyt:[11,28,44],gilda:353,gile:127,git2:27,git:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56],github:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47],gitpython:48,give:[0,11,13,26,28,40,41,46,56,63,72,73,112,175,179,193,195,197,199,204,211,230,240,261,312,313,320,352,355],given:[9,11,30,40,41,60,64,72,73,74,133,137,149,151,152,153,154,155,156,157,158,159,175,179,182,185,193,195,197,199,201,203,204,206,216,244,245,247,255,261,263,274,276,277,279,281,284,285,293,297,298,299,300,312,313,316,317,319,326,331,355],glib:261,glibc:[82,88],glob:[72,82],global:[3,5,40,77,133,149,150,151,152,153,154,155,156,157,158,159,175,179,207,208],gloom:354,glusterfs:11,gmail:[85,269],gmt:300,gmtmoff_gmtim:72,gmx:115,gnarli:55,gnu99:[44,46],gnu:[44,50,175,285,343,355],goal:[350,352],god:250,goe:[15,33,43,56,72,199,222,241,242],gondwana:[127,349,353],gone:[72,174,241],good:[11,47,48,55,57,61,64,72,128,175,184,193,207,237,250,254,255,261],goof:73,googl:55,got:[55,72,131,219],gotcha:192,gouaux:[73,74],gov:74,govern:[53,186,348],gperf:[44,174],gpfs:223,gpg:[43,56],grab:72,gracefulli:72,grade:[11,220],grain:75,gramar:165,grammat:261,grand:199,grant:[18,41,179,180,193,261,285,287],granular:[133,183],granularli:133,great:[7,41,46,55,133,175,176,250,350,354,355],greater:[19,25,75,77],greenfield:353,greet:[81,261],greg:[72,127,353],gregorian:[229,340],grep:[18,211,276],greylist:326,groff:174,gross:72,group:[5,7,11,19,35,36,41,43,44,46,56,72,75,113,121,172,174],groupadd:[175,355],grow:[7,9,11,28,30,184,199,223,241],growth:[193,252],grundman:353,gss:[68,329],gssapi:[44,193,207,355],guarante:[5,7,47,57,60,83,174,193,195,224,352],guard:47,guest:11,gui:[22,57,64,65,68,250],guid:0,guidanc:[174,349],guide:40,guidelin:0,guilherm:353,guimard:162,gzip:183,hacmp:250,had:[5,6,72,127,130,162,166,169,176,193,195,241,250,273,315,350],haferkamp:[133,353],hagberg:72,hajimu:75,half:[72,236],ham:27,hammer:127,hand:[11,72,83,116,176,179,183,193,203,261,350,358],handl:[6,15,41,52,56,72,73,74,75,85,88,89,97,104,105,106,108,111,112,113,114,121,122,125,126,131,134,140,142,147,149,150,151,152,153,154,155,156,157,158,159,164,165,167,168,172,174,175,182,183,193,196,216,232,239,250,260,261,305,329,330,332,333,334,335,337,338,345,352],handler:168,handshak:6,hang:[72,196,223],hangout:55,hangup:297,happen:[3,4],happi:[106,250,313],happili:11,hard:[36,41,72,73,129,135,175],hardcod:162,harder:193,hardlink:130,hardwar:[11,56,193,236,355],harm:[11,223],harmless:261,hash:[72,73,74,75,79,175,177,183,186],hashimapspool:[175,189,261,314],hashtabl:[9,30],hasn:[6,33,193],hasnochildren:[135,211,285],hat:[2,12,57],hav:261,have:[0,3,5,6,7,8,9,11,15,18,19,22,24,25,27,28,30,33,36,40,41,43,44,45,46,47,48,49,50,53,55,56,57,63,64,65,66,67,68,71,72,73,74,75,77,82,114,129,133,137,138,139,145,149,152,153,154,155,156,157,158,159,161,162,163,164,165,171,172,174,175,176,180,181,182,183,184,185,186,187,190,191,192,193],have_acte_krb:72,have_libdb:72,haven:[18,46,73,75,244],hba:[3,11],hdd:[11,220],hdrfromsmtp:40,hdrsize:[298,326],head:[7,43,56,64,100,250,351],header:[12,41,44,47,72,73,74,75,88,92,95,97,106,107,108,109,113,114,115,117,121,122,134,140,149,151,152,153,154,155,156,157,158,159,163,172,185,186,190,191,199,214,217,220,223,226],headerbodi:[185,261],health:11,hear:[11,54],heart:260,heartbeat:261,heat:[176,350,354],heavi:[75,89,199,239,352],heimdal:[82,174],heino:[73,114,121,131,134,144,145,353],held:[6,18,35,48,55,75,114,266,344],hello:[73,175,298],helpdesk:26,helpfil:48,hen:73,henriqu:[74,75,112,353],her:[19,33,43,56],herdomain:40,here:[11,12,15,27,33,40,41,43,46,49,56,63,71,72,73,75,133,174,175,183,186,188,191,193,195,199,204,224,233,241,249,260,261,321,351],herodotu:[176,350],heurist:284,hex:[211,261],hhmm:260,hidden:11,hide:[77,79,179],hierarch:[33,72,73,261],hierarchi:[11,13,19,22,24,27,30,33,34,41,53,64,65,66,67,72,73,74,79,80,133,134,136,180,184,188,193,199,204,205,207,211,212,241,261,285,298,313,352],hierarchical:72,high:[6,7,11,15,36,71,72,77,174,177,193,199,217,220],higher:[11,15,19,27,30,44,68,71,204,216,233,261,264,290,292,297,304,306,322],highest:[6,30,298],highestmodseq:97,highli:[176,250,255,352],highlight:[48,358],him:[28,207],hinder:[176,350],hint:73,hisdomain:40,histor:[25,261,350],hit:[73,175,183,261],hmh:[74,75,112],hoeger:[73,133],hold:[5,7,11,35,41,47,53,74,133,174,183,193,197,220,222,241,266,355],hole:83,holidai:39,holschuh:[74,75,112,353],home:[40,64,107,175,188,195,207,220,239,261,296,358],honest:175,honor:[72,73,350],honour:[44,138],hook:222,hope:0,hopefulli:[72,73,74,193],horizont:[12,36,41,192,195],horribl:[250,314],hors:[176,350],host:[3,4],hostmast:33,hostnam:[40,41,68,72,175,197,216,222,230,260,261,288,289,304,315,329,330,332,333,334,335,337,338],hostname_mech:261,hostname_password:261,hosts_access:260,hot:[183,186,222,255,261,268],hour:[43,56,72,84,174,175,199,216,236,252,260,261,266,279,310,319,326],hourli:[56,70,284],hous:199,housekeep:73,how:[0,1,9,11,24,30,31,33,41,43,44],howard:74,howev:[3,5,7,9,11,12,36,54,57,74,133,174,182,187,193,194,195,197,215,224,230,232,238,239,241,246,255,261,350],howto:[36,177],hpux:72,href:103,hsk:[88,131],hsts:340,html:[43,48,50,56,66,75,85,149,151,152,153,154,155,156,157,158,159,235,239,261,276,284,355],hton:72,http2:164,http:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67],http_timezon:100,httpallowcompress:261,httpallowcor:[105,261],httpallowedurl:[104,261],httpallowtrac:261,httpauth:340,httpbi:340,httpcontentmd5:[107,261],httpd:[44,63],httpdocroot:[66,68,103,261],httpkeepal:261,httpprettytelemetri:[105,261],https:[57,68,137,138,139,161,162,163,164,170,171,172],httptest:259,httptimeout:261,hudson:72,human:[6,11,211,261],humili:11,hundr:[36,111,250],hung:[80,261],hurt:[74,211],husband:19,hybi:340,hypertext:340,hypervisor:11,hyphen:358,hypothet:30,ian:[122,146],iana:[64,71],ibm:250,ical:[46,168,355],ical_obj:6,ical_uid:6,icalendar:[6,64,68,101,106,108,340],icu4c:355,icu:[44,162],idea:[0,44,55,61,183,193,237,250],ideal:[11,38,47,183,193],idealli:174,ident:[5,41,72,181,207,225,261,263,329,330,332,333,334,335,337,338],identifi:[3,5,14,27,33],identified:18,idl:[12,26,44,46,71,73,75,78,84,85,133,135,136,145,167,172,174,175,188,202,215,259,260,261],idle:[12,58,59,60,62,63,73,75,78,122,136,175,261,291,340],idled:4,idlesocket:[71,175,188,202,261],idx_ical_uid:6,ietf:[23,77,106,235,261,336],ignor:[41,65,67,72,73,83,97,137,162,182,260,261,262,275,279,280,289,315,358],ignore:[287,290,305,313,340,358],ignorequota:340,ignorerefer:261,ihave:[199,261,340],iii:[11,348],ill:11,illustr:[3,11,36,41,48,182,216],ilovecyru:40,imag:[3,11,36,45,193,250,358],imagin:[11,28,187,190,220,250],imailbox:293,imap2:352,imap2bi:352,imap4:[58,59,60,62,72,176,182,218,340,348],imap4flag:[261,340],imap4rev1:[52,58,59,60,62,63,72,292],imap:[3,4,5,6],imap_quotaroot_nonexistent:72,imap_remot:243,imap_uid:6,imapclon:165,imapd:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70],imapd_3:355,imapd_conf:[175,355],imapext:235,imapflag:[207,261],imapidlepol:261,imapidletimeout:[122,136,261],imapidrespons:261,imapmagicplu:[75,261],imapnew:209,imaprev1:111,imaps:[13,175],imaptalk:46,imapus:[175,355],imaputf7:[46,174],imapv:72,imapwiki:54,imb:[88,131],imclient:51,imclient_addcallback:52,imclient_autent:72,imclient_authent:52,imclient_clearflag:52,imclient_clos:52,imclient_conn_nonsyncliteral:52,imclient_connect:52,imclient_eof:52,imclient_getselectinfo:52,imclient_havetl:52,imclient_proc_t:52,imclient_processoneev:52,imclient_repli:52,imclient_send:[52,72],imclient_servernam:52,imclient_setflag:52,imclient_starttl:52,imip:[149,151,152,153,154,155,156,157,158,159,261,340],imipnotifi:[149,151,152,153,154,155,156,157,158,159,261],immedi:[11,15,24,25,30,41,77,79,84,116,129,133,182,197,241,242,248,261,266,315,349],impact:[5,7,8,11,71],impad:296,imper:11,implement:[4,6],implementation:207,implementor:179,impli:[11,182,241,264,290,292,304,306,322,325],implic:[5,11,75,218],implicat:174,implicit:[3,5],implicit_owner_right:[41,180,261],implicitli:[41,64,180],implicitownerright:80,implied:57,important:[72,75,174,175,358],importantli:[11,352],impos:[41,72],imposs:193,impost:5,impract:11,impress:11,improperli:[72,230,261],improv:[71,72,73,74,75,114,117,133,135,147,165,189,193,196,261,276,351,352],improve:[72,74,75,79,120,140,149,150,151,152,153,154,155,156,157,158,159,165,166,351],improved_mboxlist_sort:[96,118,139,146,163,261],improvement:74,imsp:[52,71,72,73,175,193,201,285,330,355],imspd:72,imtest:[58,59,60,62,63,72,73,74,94,129,169,175,259,329],inabl:11,inact:[41,261,268],inadvert:[64,182],inbound:[183,222],inbox:[3,19,20,27,33,36,40,41,64,65,66,67,72,73,74,77,79,84,117,121,129,133,134,160,180,193,195,204,207,213,214,220,223,235],inboxe:[41,80,180],inc:[62,336],incdir:[12,44,74],inclin:11,includ:[0,6,8,10,11,12,13,18,19,24,25,27,33,41,43,44,46,47,48,52,55,56,57,58,59,62,63,66,68,72,74,75,77,92,108,112,116,118,119,129],include:[36,72,74,149,150,151,152,153,154,155,156,157,158,159,207,261,340],including:57,inclus:[24,25,49,111,149,152,153,154,155,156,157,158,159,193],incom:[19,64,75,175,193,196,199,204,207,223,233],income:194,incompat:[83,207],incomplet:[72,87,115,127,183,203,216],inconsist:[41,133,146,193,195,312],incorpor:[11,19,48,49,55],incorrect:[72,83,84,117,127,129,175],incorrectli:[72,74,134,298],increas:[10,11,35,74,79,83,129,135,195,196,216,236,239,242,255,261,266,274,297,315,319],increat:129,increment:[72,81,149,154,155,156,157,158,159,319],incur:11,inde:255,indefinit:[80,241,261],indent:[261,275],independ:[41,47,72,183,193,199,206,216,320,340,352],index:4,index_check:73,index_search_evalu:72,index_searchcachehead:73,index_upgrad:126,indexfrom:319,indic:[11,12,18,46,52,83,133,182,193,195,197,235,239,249,261,276,285,313,319,331,358],indicat:[235,285],indirect:57,individu:[3,7,11,24,28,34,38,41,64,77,120,133],ineffici:[120,319],inet6:174,inet:355,inet_aton:289,inetd:72,inetdomainbasedn:261,infect:[70,284],infin:263,infinit:[11,116,129,170,226,261],influenc:266,info:[11,33,38,41,43,46,56,72,73,74,162,199,205,207,211,212,226,228,261,279],inform:[3,5,6,7,11,12,14,22,24,28,30,34,35,36,38,41,46,49,52,54,64],informat:[20,21],infrastructur:[3,4,5,11,19,36,43,56,133,136,216,352,353],inher:[122,222],inherit:[33,41,139,163,164,199,279,285,319],ini:[46,244],inifil:[46,174],init:[47,48,174,175,355],initgroup:73,initi:[9,11,19,30,41,52,72,73,74,75,97,175,180,183,184,197,202,216,260,261,294,297,319,329,330,332,333,334,335,337,338,351,355],initiat:340,inject:[129,235,285],inlin:11,inmsg:52,inn:[72,199],inner:74,innosoft:230,inod:6,inode:6,input:[49,52,72,203,264,266,267,270,272,287,290,292,294,303,304,306,315,318,320,323,326,358],inquir:349,insecur:340,insensit:[72,74,261],insert:[11,18,41,64,81,117,179,181,182,197,199,211,216,246,260,261,285,287],insid:[27,33,40,73,74,175,203,207,211,355],inspect:[43,274,275,280],inspir:[73,97,183],inspire:84,instabl:229,instal:[3,11,12,19,40,41,44,46,48,50,54,56,58,59,60,61,62,63,64,68,69,70,71,72,73,74,75,85,133,137,149,150,151,152,153,154,155,156,157,158,159,161,164,166,168,169,174,175,183,195,199,211,216,220,222,226,228,229,244,250,261,284,285,301,329,332,335,339,342,345],install:[2,42,44],installat:[7,54],installbinsymlink:[149,150,151,152,153,154,155,156,157,158,159],installsiev:[72,259],instanc:[3,9,11,13,30],instant:[11,340,353],instanti:195,instead:[11,18,19,25,36,41,47,48,49,55,71,72,73,74,75,84,133,135,136,149,153,154,155,156,157,158,159,168,182,189,193,195,196,216,235,241,245,254,258,261,269,270,285,288,293,294,297,302,306,313,315,329,330,331,332,333,334,335,336,337,338],instruct:[18,40,41,43,44,48,50,54,56,61,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172,174,205,216,244,322],instruction:45,instrument:73,insuffici:193,insur:193,int64:46,int_date:[298,326],integ:[9,30,44,72,90,145,184,260,261],integer:[6,260],integr:[5,46,49,50,63,64,72,75,77,136,137,149,150,151,152,153,154,155,156,157,158,159,261,264,290,292,304,306,322,329,330,332,333,334,335,337,338,345,351],intel:72,intellig:[133,184],intend:[3,11,12,41,183,192,195,300,352,355],intens:[11,218,270],intent:[15,25,275,280],inter:40,interact:[11,48,72,75,80,116,175,193,199,250,261,270,285,311,329,330,332,333,334,335,336,337,338,339,340,355],interchang:[193,340,352],interest:[6,11,12,54,55,57,61,174,183,185,193,254,342],interfac:[7,11,36,40,41,44,49,52,71,72,73,75,175,179,181,201,202,209,230,260,261,289,355],interfer:[133,216],interim:45,interleav:193,interm:72,intermedi:[11,72],intermeta:73,intern:[11,33,36,41,48,53,66,72,73,75,149,151,152,153,154,155,156,157,158,159,164,195,214,219,230,235,236,258,261,265,276,285,328,352],internal:33,internald:[120,130,261,285,300,313],internaldate:[97,261],internaldate_heurist:[120,261],internation:72,internet:[3,13,45,71,175,176,201,260,294,340,352,353,355],interoper:71,interpret:[11,44,184,230,241,266,274,287,315],interrupt:[11,36,146],interv:[81,183,235,236,260,261,297,320,326],interven:[133,193],intervent:183,intial:72,intra2net:115,intra:40,intro:[287,300],introduc:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],introduct:42,intuit:5,invalid:[72,73,113,114,136,160,183,230,261],invari:73,invent:[176,350],inventor:176,inventori:340,invert:293,invest:11,invis:[162,182],invit:[64,342],invoc:[48,183,216,266,274,326],invocat:208,invok:[15,41,52,74,122,175,183,207,214,216,222,261,264,266,284,285,290,292,294,303,304,306,313,318,319,323,355],invoke:177,involv:[0,13,47,73,75,118,174,196,247,351],ioerror:[160,164,313],iolog:261,ionic:319,ios:[146,168],ipaddr:289,iphon:[117,131],ipop3d:117,ipurg:[48,73,74,84,113,125,147,160,163,172,259],ipv4:[260,261,315],ipv6:[74,75,260,261,315],irc:[55,56,175,216],irrelev:19,irretriev:241,irrit:358,isc:302,ischedule_dkim_domain:261,ischedule_dkim_key_fil:261,ischedule_dkim_selector:261,iscsi:3,ismemb:281,isn:[0,11,18,47,55,72,75,101,122,149,151,152,153,154,155,156,157,158,159,175,195,211,248,254,256,353],iso8601:46,iso:[27,72,261],isode:353,isol:193,issu:[11,27,36,41,43,49,55,56,58,59,60,62,63,72,73,74,75,78,79,80,81,82,83,84,89,92,95,96,97,115,127,129,133,149,152,153,154,155,156,157,158,159,166,174,175,182,184,193,195,197,212,218,241,246,261,298,313,329,330,332,333,334,335,337,338,341,349,358],ital:[48,358],item1:184,item2:184,item3:184,item4:184,item:[6,11,33,40,41,46,80,128,149,150,151,152,153,154,155,156,157,158,159],iter:[56,74,216,319],iterat:340,itip:[64,340],itself:[6,11,35,41,48,53,54,58,59,62,63,72,74,163,185,186,188,195,216,222,229,241,260,261,285,297,319],iversen:72,j16:46,jack:175,jakob:[163,172],jame:33,jan:[127,285,298],jane:[3,18,19,27,33,36,312],janepas3:18,janepass:18,janitor:297,jansson:[44,108,135],jarosch:[88,115,143,145],jarosh:122,jason:[165,171],javascript:66,jbro:261,jcal:[108,340],jdoe:[3,5,19,214],jean:353,jeff:72,jeffrei:[349,353],jen:[122,145,146,149,151,152,153,154,155,156,157,158,159,353],jena:[88,131],jenkin:45,jenkins:45,jeremi:[74,77],jeroen:[136,349,353],jessi:[44,45,355],jessie_al:355,jessie_amd64:355,jfs:250,jhoward:74,jim:72,jimson:73,jj12:262,jmap:[149,150,151,152,153,154,155,156,157,158,159,160,165,166,169,230,351],job:[41,45,72,133,183,216,241,260],john:[3,5,19,27,28,33,36,53,72,73,77,147,211,213,216,217,245,263,265,285,312,326,353,358],johnsmit:326,johnsmith:[270,280,326],join:[7,55,175,223],jonathan:168,josh:165,journal:236,journei:[176,350],jpeg:261,jsmith:[298,299,300,313],json:[274,275,312,340],jtampli:77,judgement:[11,250],jul:[298,300],juli:195,julien:[88,114,121,131,133],junk:[19,144,185,207,261,283],just:[0,3,11,18,36,39,41,43,47,48,55,56,72,73,74,83,129,144,162,171,174,175,183,189,191,192,193,194,195,197,208],justgotspammedlot:279,justifi:[55,217],jwz:73,jy9o:262,jyager:262,kamen:168,katu:114,kbyte:[6,48,293],kde:11,keep:[12,15,26,41,47,49,63,64,72,73,79,104,133,174,175,183,184,186,193],keepal:[113,261],kei:[4,5],ken:[72,73,74,116,226,349,353],kept:[7,74,149,151,152,153,154,155,156,157,158,159,174,183,193,195,199,242,247,261,323,331],kerber:[71,175,201,306,355],kerbero:[5,13],kerberos_v4:[41,193,195,207,329,330,332,333,334,335,337,338],kernel:[11,220,238],key:6,key_fil:52,keyboard:52,keycap:358,keyfil:[144,285,329,330,332,334,335,337,338],keyout:175,keytab:5,keyword:41,kib:[9,30,184,195,261],kick:[11,33,36],kick_mupd:116,kiev:284,kill:[85,236,250,297],kilobyt:[15,19,34,41,204,206,261,285],kind:[6,33,175,185,241,261,340],kinda:46,king:46,kingdom:354,kirk:33,kleinespel:353,knight:40,know:[3,5,7,9,30,31,40,41,44,46,47,55,56,68,84,174,175,182,183,184,190,193,207,209,222,226,261,292,341],knowledg:72,known:[4,5,7],kolab:[27,220,353],kolab_3:27,kolbu:353,konold:111,korreio:57,kpop:[13,35,41,71,72,175,195,201,306,352,355],kravchenko:73,krb5:[44,223],krb5_enctyp:226,krb:[41,181,259,261],krb_pt:72,krb_sasl_client:52,krbck:72,krbimpl:44,kristof:[114,353],kssl:223,kssl_build_principal_2:226,kssl_cget_tkt:226,kssl_check_auth:226,kssl_ctx:226,kssl_ctx_setkei:226,kssl_ctx_setprinc:226,kssl_ctx_setstr:226,kssl_sget_tkt:226,kssl_validate_tim:226,kueck:161,kxte:[58,59,60,62,63],label1:261,label2:261,label3:261,label:[209,230,358],lack:[11,47,75],lag:[9,30,184,195,261],lai:11,laid:48,lam:285,lappend:72,laps:[9,30,184],larg:[7,9,11,13,18,24,25,27,28,30,33,36,47,72,73,74,75,77,111,173,174,175,183,184,185,186,193,196,211,218,220,223,233,236,241],larger:[4,11,15,19,33,36,75,183,193,217,261,293,320],largest:[11,15,41,47,108,133,184,261,354],larri:[74,353],last:[6,39,72,75,135,174,175,187,190,207,216,235,236,261,285,288,289,298,319,326,355],last_uid:166,lastfailedbuild:45,lastpop:[75,235],lastupd:[235,298,326],latch:261,late:72,latenc:[11,71],later:[11,24,25,50,56,72,77,79,122,133,149,153,154,155,156,157,158,159,162,174,175,176,183,184,202,204,217,220,230,232,241,261,326,350,352,354,355],latest:[12,44,45,46,57,64,72,75,173,174,193,222,228,261,266,313,345,355],latter:[15,43,56,193,211,248,260,261,319],lauri:353,layer:[5,11,36,41,47,63,68,72,73,74,82,83,177],layout:[72,204,216,217,261],lazi:[72,175],lcyru:52,ldap:[5,11,13],ldap_authz:261,ldap_bas:261,ldap_bind_dn:261,ldap_ca_dir:[133,261],ldap_ca_fil:[133,261],ldap_ciph:[133,261],ldap_client_cert:[133,261],ldap_client_kei:[133,261],ldap_deref:261,ldap_domain_base_dn:261,ldap_domain_filt:261,ldap_domain_name_attribut:261,ldap_domain_result_attribut:261,ldap_domain_scop:261,ldap_filt:261,ldap_group_bas:261,ldap_group_filt:261,ldap_group_scop:261,ldap_id:261,ldap_mech:261,ldap_member_attribut:261,ldap_member_bas:261,ldap_member_filt:261,ldap_member_method:261,ldap_member_scop:261,ldap_password:261,ldap_realm:261,ldap_referr:261,ldap_restart:261,ldap_sasl:261,ldap_sasl_authc:261,ldap_sasl_authz:261,ldap_sasl_mech:261,ldap_sasl_password:261,ldap_sasl_realm:261,ldap_scop:261,ldap_serv:261,ldap_size_limit:261,ldap_start_tl:261,ldap_time_limit:261,ldap_timeout:[135,261],ldap_tls_cacert_dir:[133,261],ldap_tls_cacert_fil:[133,261],ldap_tls_cert:[133,261],ldap_tls_check_p:[133,261],ldap_tls_ciph:[133,261],ldap_tls_kei:[133,261],ldap_uri:261,ldap_use_sasl:261,ldap_user_attribut:261,ldap_verify_p:[133,261],ldap_vers:261,ldflags:[50,227],lead:[19,27,53,174,193,195,216,248,261,352,353],leak:[46,47,64,72,73,74,75,97,104,105,107,108,118,122,133,136,137,140,165,172,174],learn:[0,11,175,199,228],least:[3,11,47,50,63,75,174,175,182,183,186,190,193,195,216,220,230,236,241,249,260,261,262,263,264,279,293,300,313,319,355],leav:[24,46,64,65,67,83,85,146,195,226,261,297,326],lee:[144,146,149,151,152,153,154,155,156,157,158,159],leena:[73,114,121,131,134,144,145,353],leewai:261,left:[72,77,95,120,195,216,230,261,287,315,329,330,331,332,333,334,335,337,338,353,358],legaci:[6,41,43,111,145,152,182,273],legal:[57,74],lemonad:340,length:[41,72,75,89,175,211,261,289],lengthen:216,less:[6,9,11,30,43,73,107,108,128,134,162,174,183,184,188,193,216,220,239,241,261,266,313,352],lessen:73,let:[11,36,72,174,175,183,187,190,195,239,355],letter:[41,189,193,243,261],level:3,levenshteinx:46,leverag:216,lex:[44,46,72,75],lexer:[72,73],lhlo:81,liable:57,lib64:229,lib:[11,12,44,47,50,72,73,133,174,175,188,204,207,211,214,215,216,217,219,220,226,229,236,249,261,270,272,276,291,301,319,320,355],libacap:73,libanyev:46,libari:72,libbrotli:44,libbsd:[44,46,174],libcal:46,libclamav:229,libclon:[46,174],libcom_err:72,libcomerr2:63,libconfig:[46,174],libcrypto:229,libcunit1:[44,174],libcurl:261,libcyru:[47,52,72,74,75,164,355],libcyrus_imap:[44,161,165],libcyrus_init:47,libcyrus_min:75,libdata:46,libdatetim:[46,174],libdb5:[44,63],libdb:[44,174],libdigest:174,libdir:[12,44,74],libencod:[46,174],liber:261,libexecdir:[149,150,151,152,153,154,155,156,157,158,159],libfil:[46,174],libglib2:174,libic:[44,68,100,147,174,175,223],libicu:44,libimap:47,libio:[46,174],libjansson:[44,174],libjson:46,libldap2:[44,174],libmag:46,libmariadb:44,libmim:46,libmysqlcli:[44,174],libnet:[46,174],libnew:[46,174],libnghttp2:[44,164],libpam0g:174,libpcre3:[44,174],librari:[0,12,41,42,44,46],libressl:[137,169],librt:[137,165],libsasl2:[44,63,174],libsasl:[72,73],libsnmp:[44,174],libsqlite3:[44,174],libssl:[44,174,229],libstr:46,libtest:[46,174],libtext:46,libtool:[44,72],libunix:[46,174],liburi:174,libuuid:44,libwrap0:174,libwrap:73,libwrap_init:73,libxapian:[44,174],libxml2:[44,108,174],libxml:[44,46,162,174],libzephyr:174,licens:[2,27],life:[60,166,260,358],lifetim:324,light:[11,71],lightn:[6,44],lightweight:[71,175,197,201,202,355],liinu:73,like:[0,3,5,7,11,15,16,17,18,19,26,29,30,33,34,36,37,41,43,46,47,48,52,56,63,71,72,96,162,169,174,175,182,183,185,187,193,194,195,197,199,203,207,211,216,219,222,226,228,229,233,239,244,246,250,260,261,264,268,270,276,284,289,290,291,292,294,297,303,306,313,315,319,322,323,330,342,351,355,358],likelihood:11,likewis:[72,73],limit:[4,5,6,7],limitless:252,lin:115,line:[11,18,41,43,44,46,47,50,55,56,63,71,72,73,81,113,127,133,166,175,176,181,183,195,197,199,201,207,209,211,216,222,232,241,243,244,253,260,261,262,263,266,270,272,276,282,284],liner:211,lines:[298,326],link:[11,41,42,43,44,47,48,52],linkag:[56,222],linkend:9,linker:229,lint:[174,280,351],linux:[2,11,12,18,19,44,50,57,60],list:[0,3,4,5],list_curv:[133,261],list_fe:104,listacl:285,listaclmailbox:41,listaclmamilbox:41,listen:[18,63,71,73,137,169,175,183,185,188,193,195,197,199,201,202,207,209,216,222,252,260,261,264,289,290,292,294,297,303,305,306,319,322,323],listext:[58,59,60,62,73,111],listmailbox:[40,134,211],listquota:41,listquotaroot:[41,212,213],listrights:[182,285],liter:[3,33,36,52,72,74,114,197,340,358],literal:[52,58,59,60,62,63,129,261],literalminu:261,littl:[72,73,97,220,247,342],live:[6,11,36,45,67,72,74,133,174,175,189,193,195,207,252,261,270,289,291],liveli:183,lkxa:261,lmdb:4,lmr:74,lmtp2nntp:[199,261],lmtp:[8,40],lmtp_admin:[41,75,195],lmtp_allowplaintext:75,lmtp_downcase_rcpt:[74,246,261],lmtp_fuzzy_mailbox_match:77,lmtp_over_quota_perm_failur:[41,204,261],lmtp_strict_quota:[41,204,261],lmtp_strict_rfc2821:261,lmtpa:27,lmtpd:[19,40,41,63,73,75,77,121,122,124,129,134,145,164,166,168,169,172,175,188,195,202,204,207,216,222,233,238,239,242,244,259,260,261,269,287,290,292],lmtpengin:[73,75],lmtpproxyd:[63,74,75,77,194,195,196,233,259],lmtpsocket:[71,175,188,202,261,355],lmtptest:[74,259],lmtptxn_timeout:261,lmtpunix:[27,63,175,246,260,290,292,294,303,306,322,323],load:[5,6,7],loader:[44,188,202,311],loc:144,local0:261,local4:72,local6:[41,72,175],local7:261,local:[3,5,6,7,11,36,40],local_rule_0:199,localdefs:226,localdomain:207,localhost:[18,28,41,58,59,60,62,63,175,196,199,207,260,261,285,288],localpart:[40,136],localtim:211,locat:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185],lock:[4,5,6],lock_expir:6,lock_own:6,lock_ownerid:6,lock_token:6,locker:[74,223],lockfil:243,lodg:0,log:[3,5,11,13,18,19,40],log_debug:261,logfil:297,logic:[3,5,7,11,72,125,131,268,293],login:[3,5,18,19],login_sasl_cli:52,login_unix_getspnam:72,login_unix_pwcheck:72,login_unix_shadow:72,logindisabled:[58,59,60,62,63],loginrealm:[41,261],loginuseacl:[41,74,261],logout:18,logrot:175,logtimestamp:[72,261],longer:[11,25,72,73,74,75,77,82,117,120,121,122,133,134,135,136,137,139,140,143,144,145,146,147,160,161,162,163,164,165,166,168,169,170,171,172,174,182,193,196,197,216],longest:83,longev:252,longstand:73,look:[11,18,33,36,40,41,43,46,47,48,56,66,72,73,131,133,169,175,188,193,194,195,222,223,229,239,250,261,285,298,351],lookup:[40,41,64,74,75,179,180,182,193,199,225,261,279,285],loop:[72,73,74,112,116,170,254],loopback:209,loos:[28,193],lose:[7,11,128,135,169,174,193,195,236,250],loss:[11,57,134],lost:[41,45,120,130,183,195,216,224,246,300],lot:[6,24,46,73,80,115,116,128,129,149,150,151,152,153,154,155,156,157,158,159,175,183,184,189,199,207,233,242,328,355],love:[27,48,54,55,174,250,351],low:[47,193,220,261,288,343],lower:[15,27,193,252,261],lowercas:[74,261],lowest:[9,30,184],lpthread:227,lqm:285,lqr:285,lrp:41,lrsp:41,lrswip:41,lrswipkxt:285,lrswipkxtea:[41,270],lrswipkxtecda:41,lrwipkxtan789:64,lrwipkxtan9:64,lrwipkxtan:64,lsb:174,lseek:47,lsub:[72,96,112,116,128,131,193,195,261,285,340],ltd:353,ltmp:133,lucent:92,luck:72,luke:40,lukecag:40,lun:3,lvm:11,lwi:41,lwn:11,lyndon:72,lynx:172,machin:[11,40,74,75,95,175,183,193,195,196,207,216,233,250,279,289,350,352,358],maciel:353,macos:109,macro:41,mad:222,made:[4,7,46,52,66,72,73,75,82,83,114,126,127,129,144,174,194,195,197,213,236,260,261,266,315,349],mageia:57,magic:[41,75,190,313],mahoroba:75,mai:[3,5,7,8,9,10,11,12,18,19,25,27,30,31,33,36,38,40,41,44,46,47,48,52,53,57,63,71,72,73,74,75,77,105,133,145,162,164,174,175,179,181,182,183,184,185,186,187,188,189,190,193,195,196,197,199,201,202,203,204,205,209,211,214,216,217,218,220,226,229,233,236,241,242,246,247,249,250,251,252,253,254,260,261,265,270,274,276,279,285,297,300,313,314,315,319,325,326,329,330,331,332,333,334,335,336,337,338,341,342,349,350,351,352,355,358],maiden:19,mail1:195,mail1_password:195,mail2:195,mail2_password:195,mail:[0,3,5,6,11,13,15,18,19,22,27],mail_us:18,mailalternativeaddress:5,mailbox:[3,4],mailbox_badformat:72,mailbox_creation_distribut:9,mailbox_default_opt:[83,261],mailbox_initial_flag:261,mailbox_notsupported:72,mailboxacl:[185,261],mailboxdb:303,mailboxexist:169,mailboxid:27,mailboxlist:286,maildrop:85,mailer:[40,175,199,355],mailer_definitions:[175,355],mailert:40,mailfoldernam:211,maillog:[18,246],mailman:343,mailnotifi:[41,74,261],mailoffsit:216,mailproxi:195,mailrepl1:216,mailrepl2:216,mailserv:175,mailspool:[14,77,222,261],mailstor:[53,176,216,222,247,294],mailto:[27,136,305,340],main:[28,47,52,186,187,188,190,191,193,216,228,247,267,355,358],mainli:[83,261,274,315],mainlin:290,mainstream:133,maintain:[6,10,11,22,33,35,36,38,41,43,47,48,55,56,60,72,176,179,182,183,186,193,195,197,218,224,236,255,343],mainten:[44,260,279,297],major:[43,56,57,71,72,74,75,81,133],make:[0,7,10,11,12,18,25,35,36,40,41,43,44,46,47,48,49],make_md5:111,make_sha1:111,makedepend:72,makefil:[43,48,72,74,149,152,153,154,155,156,157,158,159],makemak:44,male:19,malet:127,malform:261,malici:64,malloc:47,man:[1,18,19,44],manag:[6,11],managesiev:[73,82,83,171,195,207,261,336],managesieve:[74,75,207,336,337],mandatori:[3,133,197,315],mani:[5,11,19,24,36,41,47,54,68,72,73,74,75,125,128,129,162,172,174,183,186,188,193,195,199,216,217,220,229,233,241,250,254,260,261,289,292,320,352,353,355],manifest:168,manipul:[41,96,186,193,207,276,298,336],mann:353,manner:[3,11,24,72,261],manpag:[48,72,169,183,224,288,346],manual:[43,48,56,64,68,70,169,183,194],map:[6,11,40,41,44,47,64,72,75,181,183,222,230,250,262,318,355],map_priv:72,map_stupidshar:72,mar:[211,298,326],marclaport:171,marco:172,margin:241,mari:[27,263],mariadb:[44,136],mark:[33,38,72,111,115,182,193,199,203,207,211,282,288,315,353],markdeliv:72,market:250,markup:261,marri:19,marti:[144,146,149,151,152,153,154,155,156,157,158,159],martin:[74,111,160,207,261,336,340,353],marysmith:265,mass:[183,199,221,296],massag:183,massiv:[149,154,155,156,157,158,159],masssievec:207,master:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70],match:[6,18,41,44,46,48,63,66,70,72,74,77,114,125,129,131,172,174,181,183,188,197,202,207,218,225,261,266,268,274,276,284,285,293,300,326,355],materi:57,math:46,matt:[349,353],matter:[0,11,80,85,122,127,146,249,261,353],matuska:160,matveev:353,max:[133,174,261,313,353],maxchild:[63,73,239,252,260,290,292,294,303,306,322,323],maxfd:[74,260],maxforkr:260,maxheaderlin:261,maximum:[7,15,28,44,73,133,149,151,152,153,154,155,156,157,158,159,175,183,204,241],maxlogins_per_host:[133,164,261],maxlogins_per_us:[133,164,261],maxmessag:[27,134],maxmessages:261,maxquot:261,maxquoted:82,maxssf:285,maxval:281,maxword:[82,261],may:[33,254],mayb:[0,44,162,216,320],mbexamin:[74,81,171,172,174],mbox:[263,276],mboxcfg:[207,285],mboxconfig:[134,279],mboxev:[149,150,151,152,153,154,155,156,157,158,159,165],mboxkei:4,mboxkey_db:[133,261],mboxlist:[72,75,121],mboxlist_db:[133,261],mboxlist_db_path:[188,261],mboxmetadata:261,mboxnam:[164,166,183,274,315],mboxname_lock:10,mboxname_lockpath:[10,71,175,188,261],mboxpattern1:284,mboxpattern:284,mboxutil:143,mbpath:[72,73,75,89,115,129],mbtool:259,mbtype:[185,261],mbtype_deleted:143,mbyte:[48,293],mcmurtri:[127,349,353],mcyru:285,md5:[5,18,41,44,68,74,107,128,261,285,329,330,332,333,334,335,337,338],mda:[26,355],mdn:[72,261,340],mean:[3,6,11,19,28,35,36,40,41,48,49,53,55,72,75,100,116,125,133,137,162,178,179,181,182,183,186,193,195,199,205,207,216,220,222,236,241,260,261,264,279,290,292,293,304,306,320,322],meant:[11,241,289],meantim:56,meanwhil:[179,183],measli:28,measur:261,mech_list:68,mechan:[5,8,14,40,41,44,52,64,68,72,73,74,111,175,181,189,193,195,197,216,220,261,285,329,330,331,332,333,334,335,337,338,340,345],mechanisms:[175,355],mechlist:129,media:[15,186,191,250,261,340],meet:[55,64,230],meeuwen:[136,349,353],megabyt:[44,242],melbourn:27,mellon:[57,133,176,345,350,352,353,354],melnikov:[349,353],member:[38,41,72,106,261,281,340,349],membership:[44,311],memmem:104,memmov:72,memori:[6,9,10,11,30,44,46],men:[176,350],meng:[122,137,145,168,172],mental:72,mention:[41,83,111,118,182,205,207,358],menu:[72,358],merced:40,mercedesknight:40,merchantability:57,mere:[11,41,241],merg:[0,55,64,73,74,75,77,111,145,195,261,320],merit:71,mesh:[216,261],mess:[56,314],messag:[6,8,11],message:[41,206,285,312,340,351],messagecont:[27,185,261],messagehead:27,messages:[27,185,261],messeng:[176,350],met:[57,350,354],meta:[33,63,117,172,186,218,250,261,299,301],metadata:[6,13],metapartit:[77,186,190,191,217,261],metapartition_fil:[77,186,190,191,217,261],method:[5,41,63,64,70,72,74,85,104,108,136,174,175,176,183,185,193,196,207,261,284,285,287,305,350,358],meyer:353,mib:[137,169],mic:261,michael:[122,137,145,168,172],micro:173,microsoft:[261,340],middl:[117,174,216],midset:[27,185,261],might:[0,7,11,40,43,48,56,75,133,174,193,195,199,209,210,216,222,229,230,238,239,244,251,260,261,289,358],migrat:[7,15,40,71,73,97,174,186,187,190,209,279],mileston:349,mill:[73,97],million:[11,250,354],milter:326,mime:[27,46,72,74,77,113,122,172,230,261,274,340,348],mimetransport:340,mimick:352,min:[56,75,144,261],mind:[11,183,184,210],minim:[11,12,40,48,175,193,203],minimum:[18,44,175,183,199,261,320,329,330,332,333,334,335,337,338],minor:[72,73,74,75,133,149,154,155,156,157,158,159,173,174,298,313],minpol:261,minssf:285,minut:[56,72,136,175,199,235,236,260,261,279,326,355],mirapoint:[193,336],mirror:[11,350],misc:[74,131,199],miscellan:[75,78,79,80,81,82,89,92,95,96,97],misconfigur:195,mislead:72,mismatch:[102,134,223],misnam:72,miss:[68,71,74,85,112,115,120,122,125,126,127,135,136,137,149,156,157,158,159,162,164,165,170,175,194,201,260,261,267,313,355,358],missingok:175,missingstatoverrid:175,mistakenli:80,mistmatch:313,mit:[41,43,44,56,72,306],mitig:11,mix:[96,165],mixe:223,mixed:27,mkcalendar:64,mkchartabl:72,mkcol:[64,340],mkdir:[46,72,175,251,355],mkf:11,mkgmtime:72,mkimap:[46,175,217],mknewsgroup:199,mktime:72,mmap:[47,72,117,128,140,250,255],mmap_priv:73,mmddyyyi:263,mobil:[71,352],mod:[6,298],mod_ssl:44,mode:4,model:[11,36,48],moder:224,modern:[18,125,176,186,227,350,354],modif:[6,57,72,80,179,193,215,235],modifi:[41,64,72,73,80,81,111,125,133,134,174,175,193,203,215,261,279,297,326,354,355],modseq:[27,58,59,60,62,63,84,94,118,162,185,261,298,326],modsequ:83,modul:[5,18,41,44],modulo:73,moench:[139,162],moment:[11,46,58,59,60,62,63],mon:[27,211,298,300],mondai:344,monitor:[11,28],month:[6,11,72,241,250,263],monthli:[133,241],moor:[72,254],mora:[74,75,112,353],more:[3,5,6,7,9,11,12,13,22,26,27,28,30,33,34,36,40,41,45,46,47,49,50,52,55,64,70,71,72,73,74,75,81,82,83,85,89,108,111,114,115,116,118,125,126,133,144,147,149,150,151,152,153,154,155,156,157,158,159,165,168,174,175,179,181,182,183,184,186,187,188,190,193,195,196,197,199,202,204,207,211,216,217,222,228,236,239,241,243,244,249,250,254,258,261,262,267,284,285,287,289,292,297,300,312,313,314,319,320,328,329,330,332,333,334,335,337,338,342,345,349,352,353,355],morgan:116,morn:266,mortal:[176,350],most:[4,5],mostli:[46,72,73,185,220,261,266,270,292,315],motd:[72,235,285,292],motto:354,mount:[11,28,220,237,250,358],mous:358,move:[10,15,27,36,43,50,56,64,72,73,74,75,108,116,129,135,149,152,153,154,155,156,157,158,159,169,174,182],movi:250,mozilla:261,msa:3,msg:[72,284,292],msgno:52,mss:358,mta:[3,26,40,41,58,59,60,62,63],mtbf:[3,11],mtime:[6,72,97,261],mua:3,much:[6,11,18,47,56,64,72,73,75,111,112,116,118,126,179,185,193,200,216,217,233,261,266],mult:72,multi:[4,5,6],multiappend:[58,59,60,62,63,73,75,340],multipl:[7,8,11,12,13,28,36,39],multiplexor:193,multipurpos:340,multithread:222,mung:[55,113,261],munge8bit:[95,261,287],mupdat:[7,36,63,71,74,84,96,97,116,122,130,137,140,145,146,166,168,174,175,177,192,193],mupdate:[36,84],mupdate_authnam:[195,261],mupdate_config:[77,261],mupdate_connections_max:261,mupdate_password:[195,261],mupdate_port:261,mupdate_realm:[195,261],mupdate_retry_delai:[194,261],mupdate_serv:[195,196,261,303],mupdate_synchron:84,mupdate_usernam:[195,261],mupdate_workers_max:261,mupdate_workers_maxspar:261,mupdate_workers_minspar:261,mupdate_workers_start:261,mupdatepush:[195,270],mupdateslave1:195,mupdatetest:[74,195,196,259],murch:[64,65,67],murchison:[72,73,74,226,340,349,353],murder:4,murder_3:355,murdermast:194,must:[3,7,11,18,19,31,40,41,44,47,52,57,63,64,65,66,67,68,70,71,72,75,79,82,84,92,129,133,174,175,182,183,186,188,189,190,191,193,195,197,199,203,207,216,222,223],mutf:72,mutual:[11,40],mvgroup:199,my_next_bestselling_novel:358,my_script:207,myconsist:276,mydestin:3,mydomain:246,myer:72,myhost:246,mynewsgroup:199,mypassword:175,myrights:182,mysasl_canon_us:75,myscript:[207,285],myscriptnam:285,mysql:[11,12],myuser:246,nag:41,nagl:79,name:[3,5,6,7,9,11,15,18,19,25,27,30,31,33,40,41,43,44,46,48,49,52,53,55,56,57,63,64,65,67,68,71,72,73,74,75,81,83,92,96,103,113,115,116,120,129],namespac:[3,13,19,27,28],namespace:[33,58,59,60,62,63,72],nas:11,nasti:[112,131],nativ:[72,193],natur:[11,33,184,192,195,197,261],ncontent:27,ndate:27,nearli:355,necessari:[11,40,41,46,55,63,72,75,81,102,174,175,183,193,197,199,216,237,261,301,313,315,355],necessarili:[5,11,38,222],necessit:352,need_sys_errlist:72,negligence:57,negoti:[11,52,58,59,60,62,63,68,73,144,197,261,320,329,330,332,334,335,337,338],neighbour:183,neither:[11,36,81,199,226,315,354],nerenberg:72,nest:[66,118,261],net:[18,40,44,46,57,75,84,115,174,222,251,280,297,342],netnew:[41,72,75,149,153,154,155,156,157,158,159,199,261,325,340],netscap:[72,193,261],netscape:[58,59,60,62],netscapehack:72,netscapeurl:261,network:[7,11,41],never:[25,40,72,116,127,183,193,195,199,226,239,252,261,315],new_cr:72,newer:[6,72,83,88,95,133,162,174,246,261,293,315,319],newgroup:199,newhost:63,newimap:174,newlin:[41,72,223],newman:[72,230,353],newmboxlist:270,newnam:285,newnew:261,newnews:[75,199,261,288,304],news2mail:[199,235,285],news:261,newsaddhead:261,newsfe:72,newsgroup:[41,72,75,177],newsgroups:75,newsmast:[199,261],newspeer:[199,261,304],newspostus:[199,261,304],newsprefix:[199,261,304],newsrc:[188,261],newsrc_db_path:[188,261],newsspool:72,newsstamp:288,next:[6,9,11,18,24,25,28,30,43,44,56,58,59,60,61,62,63,149,150,151,152,153,154,155,156,157,158,159,175,183,184,188,193,199,203,207,216,261,266,349,355],nfrom:27,nghttp2:[44,355],nginx:[7,36,177,192,195],nic:[3,40,160,353],nice:[116,193,223],nicknam:[6,160],nicola:353,night:[176,241,350,354],nightli:[46,183],nil:[27,137,235,261,284,326],nis:40,nist:261,nix:[63,174],nmessag:27,nmime:27,nntp:[13,35,41,44,46,63,71,75,89,115,175,177,193,195],nntpclient:[46,174],nntpd:[63,75,86,87,89,114,115,118,121,130,175,195,199,216,259,261],nntpd_3:355,nntptest:259,nntptimeout:[89,261],no_atomic_rename:[58,59,60,62,63],no_received:27,no_relays:27,noauthent:285,nobodi:[0,55,61,344],node:[3,7,11,13,36,175,220,261,270],noinferior:182,noisi:[46,261],nomin:349,non:[7,12,33,41,52,63,64,68,72,73,85,101,106,114,133,134,137,161,165,166,172,175,177,179,180,181,183,193,208],nonconform:230,none:[6,11,15,19,28,64,66,133,175],nonexist:[72,135,162,167,169,261],nono:231,nonsens:122,nonzero:52,noop:114,nopasswd:46,nor:[36,81,183,184,199,203,241,255,258,261,279,315,341],norbert:134,norc:285,normal:[6,11,13,38,41,48,56,63,66,72,73,74,174,175,180,186,195,196,199,207,209,226,232,233,241,247,263,266,276,285,300,314,343,352,355],normalis:[161,261],noselect:[72,116,193],nosync:[75,233,272],notabl:[74,261],notat:[261,263,276],note:[2,4,7,9],notebook:352,notes:48,notesmailbox:261,noth:[3,11,25,72,122,168,176,190,193,237,261,315,350],notic:[0,41,57,72,73,74,75,127,175,252,261,313],notice:41,notif:13,notifempti:175,notifi:[11,41,63,71,74,75,77,133,175,188,202,207,222,261,284,290,292,294,303,305,306,322,323,340],notify:[27,340],notify_extern:[261,305],notify_unix:73,notifyd:[41,63,74,136,149,151,152,153,154,155,156,157,158,159,175,185,259,260,261,290,292,294,303],notifysocket:[71,175,188,202,261,305],notl:[144,285],notspam:261,notwithstand:[3,11,13],nov:298,now:[5,9,11,28,30,33,41,43,49,56,57,58,59,60,62,63,71,72,73,74,75,77,79,80,81,92,97,100,106,107,108,109,111,120,121,122,124,125,128,129,131,133,134,135,136,137,138,139,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,168,169,170,171,172,174,175,182],nreceiv:27,nss:[41,181],nss_ldap:[41,181],nsubject:27,nthi:27,ntht:340,ntlm:[68,329,340],nto:27,ntoz:186,nuanc:211,num:[28,41,58,59,60,62,63,165,206,281,285,312,329,330,332,333,334,335,337,338],number:[4,6,7,9,11,15,25,27,30,34,41,43,47,48,71,72,73,74,75,77,85,127,129,130,133,145,149,151,152,153,154,155,156,157,158,159,173,176,183,184,193,195,197,199,204,206,209,215,216,222,228,233,235,236,239,248,250,252,260,261,263,264,276,279,281,285,289,290,292,294,297,298,304,305,306,315,318,327,329,330,332,333,334,335,337,338,349,350,355],nurtur:11,nwdiag:48,nye:353,nyota:33,o_dsync:74,o_rdwr:47,obata:[114,115],obei:[72,85,120,133,261],obfusc:5,object:[3,11,41,44,64,149,151,152,153,154,155,156,157,158,159,206,239,261,315,320,340,349,351],object_storage_:[149,151,152,153,154,155,156,157,158,159],object_storage_dummy_spool:261,object_storage_en:261,objectclass:261,objectstor:[149,151,152,153,154,155,156,157,158,159,355],obligari:321,obscur:[55,72],observ:[9,30,184],obsolet:[129,182,221,261,340],obtain:[3,5,40,41,66,72,182,183,197,212,241,266,331],obviou:[193,222],obvious:[183,241,261],obviousli:12,occasion:[72,223],occur:[8,11,19,27,72,75,100,125,126,133,165,173,183,185,193,194,197,204,207,216,239,243,252,261,266,279,299,315],oceana:[72,73,74],oct:[27,298],octal:175,octet:[172,197,285],october:50,odd:[173,313],off:11,offer:[11,18,129,133,192,195,241,261,319],offic:352,office:[57,71,175,176,201,340,352,355],offici:355,offlin:11,offsit:216,offsite_shutdown:216,offsite_shutdown_fil:216,offsite_sync_host:216,offsite_sync_port:216,offsite_sync_repeat_interv:216,offsitesync:216,often:[5,7,11,26,36,41,47,175,179,199,202,219,236,239,241,252,329,330,332,333,334,335,337,338,342,352],ohio:[73,253],okai:183,old:[11,25,43,46,48,56,57,71,72,84,109,114,117,127,133,134,135,137,140,141,142,143,162,172,174,175,182,204,207,261,263,270,272,285,314,325],older:[2,6,15,43,46,56,57,58,59,62,63,72,83,85,116,122,125,133,171],oldest:122,oldimap:174,oldmailboxid:27,oldnam:285,oldschool:261,olduidset:27,olivier:114,olson:[64,271],omit:[41,133,181,197,261,276,315],on_backend:9,onboard:236,onc:[9,11,27,30,47,70,72,73,75,77,79,111,112,183,184,191,193,199,222,223,236],once:[3,40,43,45,49,55,56,63,70,174,175,183,193,195,196,214,216,329,330,332,333,334,335,337,338,349,355],ondrej:[88,131],one:[6,11,175],ongo:15,onli:[3,5,6,7,9,11,12,18,19,27,30,33,36,39,40,41,43],onlin:[11,28,43,55,183,193,207,285,344],only:[6,9,11,30,47,64,66,72,75,89,175,179,183,184,197,241,261,265,279,293,300,302,304,305,312,315,319,320,340],onto:[7,15,72,203,323,331],onward:15,opaqu:203,open:[6,11,13,36,41,44,45,47,55,72,73,74,84,111,114,125,128,133,149,151,152,153,154,155,156,157,158,159,174,175,185,193,197,220,241,250,261,266,330,345,353],openbsd:[117,128],openio:[149,151,152,153,154,155,156,157,158,159,261,355],openio_:[149,151,152,153,154,155,156,157,158,159],openio_account:261,openio_autocr:261,openio_namespac:261,openio_proxy_timeout:261,openio_rawx_timeout:261,openio_verbos:261,openldap:[44,75,239],openssl:[18,44,72,74,90,122,133,147,149,152,153,154,155,156,157,158,159,175,195,223,226],opensuse:[2,12,57],oper:[3,6,8,11,15,18,19,33,41,44,47,48,54,58,59,60,62,63,64,74,75,79,133,165,182,183,186,193,194,195,197,199,203,214,216,218,221,222,236,241,250,252,255,260,261,266,267,268,269,270,271,281,284,301,313,315,319,320,321,326,329,330,332,333,334,335,337,338,352],opera:133,operat:[177,183],opinion:11,opportun:[11,28,220,241,261],oppos:[3,72,133,182,210,241,285,342],opposit:313,opt:[175,226,232],optim:[7,11,41,72,85,193,220,236,247,352],optimis:[149,151,152,153,154,155,156,157,158,159,261],optimize:72,option:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63],optional:4,options:[48,104,266,267,273,274,280,315,324],oracl:239,order:[3,9,12,19,30,40,41,47,48,64,65,67,68,72,75,82,84,121,129,133,137,164,168,175,176,179,182,193,195,199,219,222,236,242,244,260,261,275,281,313,315,327,333,350],orderedsubject:[58,59,60,62,63],org:[3,5,11,18,19,27,28,33,36,38,40,43,46,50,53,54,56,74,75,112,116,133,134,135,136,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,165,166,167,168,169,170,173,207,211,213,216,217,219,235,239,261,262,265,269,276,280,302,312,326,345,353,355],organ:[6,7,11,19,24,27,64,186,191,261,352,353],organis:207,organizer:136,orient:11,origin:[3,5,11,49,57,74,105,131,182,209,211,216,230,241,261,266,281,315,350,352,353],original_repository:49,origlist:281,ornl:74,orst:116,oshrin:[349,353],osi:11,other:[3,5,7,9,11,12,13,18,19,22,25,30,31],othertask:346,otherwis:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],otp:[329,330,332,333,334,335,337,338],ouch:116,our:[3,44,45,47,48,54,55,57,60,69,74,129,133,173,174,175,187,190,191,193,197,220,228,236,239,250,270,341,345,355],ournew:199,ourselv:[52,55],out:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],outag:[196,220,236],outbound:222,outbox:[20,64,261,313],outbox_sendlat:261,outcom:41,outdat:44,outer:74,outgo:199,outlin:[0,5,11,27,174,196],outlook:[77,134,195,261],output:[18,41,48,52,56,64,72,74,75,89,102,105,106,117,144,174,175,203,211,214,235,261,263,264,265,267,269,270,271,272,273,274,276,279,281,284,285,286,290,292,293,294,298,299,303,304,306,309,312,317,318,323,326,327,331,358],outputfil:316,outsid:[3,27,40,41,88,103,121,142,185,199,226,228],outstand:74,over:[5,7,11,36],overal:[11,195,216,261,349],overcom:193,overflow:[74,75,84,86,90,113,114,122,145,160,166,261],overhead:[6,11,41,64,206,207,252],overload:[196,233,279],overlook:358,overrid:[44,72,75,108,122,174,199,216,235,261,290,315,320],overridden:[50,188,261,285,314],overrun:[75,138,161],overshadow:352,overview:[1,4],overwrit:[52,74,83,166],overwritten:331,own:[3,7,11,27,31,33,38,40,41,46,48,49,72,145,163,175,180,181,185,186,190,195,196,199,206,222,261,263,285,295,307,341,352,354,355,358],owner:[27,33],ownership:[18,55,175,238],p615:250,p630:250,pace:184,packag:[2,19,44,45,46,48,50],packet:[176,252,350],pad:261,page:[1,18,19,43,44],pai:71,pair:[6,11,43,56,189,222,225,267,302],pairwis:46,palauzov:[114,116],pam:5,pam_deni:18,pam_ldap:[41,181],pam_nologin:18,pangolin:63,paragraph:[183,260,358],parallel:[11,233],paramet:[9,11,18,27,30,44,46,64,68,72,75,134,140,161,174,185,195,197,236,238,239,241,261,340],paranoia:129,paranoid:73,parcel:284,pardon:3,paremet:239,parent:[9,10,30,41,117,164,180,182,184,193,195,199,202,261,285],parenthes:285,pariti:11,pars:[52,72,73,74,77,79,80,106,109,113,120,126,129,131,133,160,169,183,197,199,207,261,267,281,313],parsed_consol:45,parser:[45,72,261],part1:[9,30,184,186,190,191,261],part2:[9,30,184],part3:[9,30],part4:[9,30],part:[3,5,11,13,19,27,33,40,41,48,55,61,62,68,72,73,74,75,80,120,149,154,155,156,157,158,159,164,181,184,193,194,195,199,216,241,251,261,268,274,285,302,315,340,350,352,358],parta:[9,30],partb:[9,30],parti:[5,19,27,54,85,185,261],partial:[72,73,75,149,154,155,156,157,158,159,172,216,255,261,265,279],particip:[7,11],particular:[5,7,9,11,12,28,30,41,49,61,72,73,74,75,84,149,151,152,153,154,155,156,157,158,159],particularli:[11,12],partit:[3,4,6],partition_mod:9,partition_mode_exclud:[9,30],partition_mode_soft_usage_limit:[9,30],partition_mode_usage_reinit:9,partition_select_exclud:[30,195,261],partition_select_mod:[9,30,184,195,261],partition_select_soft_usage_limit:[30,184,195,261],partition_select_usage_reinit:[30,184,195,261],partli:11,partner:11,pass:[40,41,43,44,56,68,70,72,73,115,127,176,183,193,216,261,265,285,296,329,330,332,333,334,335,337,338,349,350],passiv:11,passphras:5,passwd:[41,58,59,60,62,63,72,175,181,329,330,332,333,334,335,337,338,355],password:[5,18,28,41,49,58,59,60,62,63,68,72,73,115,129,175,195,199,207,251,261,288,292,329,330,332,333,334,335,337,338,340,355],password_column:18,password_crypt:18,past:[6,43,48,56,122,131,175,197,261,263,267,348],patch:0,path:[3,9,11,19,27,30,44,46,50,64,72,102,122,124,129,131],pathnam:[15,74,175,186,187,188,190,191,261,355],patholog:[134,183],pattern:[6,11,48,66,72,134,146,183,219,220,247,261,276,277,285,288,293,302],paul:[127,193,239],paus:[261,319],pavel:[160,169,172],payload:[3,11,36,220,261],pcre:[44,79,127,131,163,166,355],pdf:133,peek:33,peer:[75,199,261,288],peernam:288,pem:[175,352],penalti:11,pend:[61,112,197,349],peopl:[33,55,72,73,196,228,255,327],per:[6,11,40,41,64,68,72,73,77,79,92,97,112,125,133,174,177,182,183,186],perceiv:261,percent:[9,30,184,195,204,261],percentag:[9,28,30,72,184,266],percentil:30,perdit:[192,193,195],perfectli:[0,11],perform:[4,6,7,9],performance:57,perhap:[11,24,33,41,181,203,220],perido:216,perimet:[7,36],period:[11,41,47,64,70,71,73,149,150,151,152,153,154,155,156,157,158,159,175,183,184,197,199],perl5lib:175,perl:[44,46,48,72,73,74,88,114,127,129,131,149,152,153,154,155,156,157,158,159,165,168,174,175,211,285,289,301],perl_3:355,perman:[9,30,41,72,204,211,214,241,261,340,352],permiss:[5,7,19,41,43,52,56,57,66,74,166,175,182,193,199,207,240,244,261,285,355,358],permit:[7,13,18,33,41,57,72,168,182,195,261,304,352],persia:46,persian:[46,176,350,354],persist:[72,175,193,261],person:[5,13,19,27,28],perspect:[33,241],pertain:71,pertin:204,peski:73,petabyt:11,pf_inet:289,pfleme:239,pghmcfc:326,pgp:199,pgsql:[12,261],phase:350,philip:[111,116],philipp:[111,116,136,161],phish:284,photo:[39,67,358],php:[174,219,235],phpdomain:48,phrase:[43,56,329,330,332,333,334,335,337,338,358],phx2:326,physic:[3,11,186,191,261],pick:[38,43,72,175,261,320,355],pictur:[11,175,355],pid:[27,216,222,238,251,261,297,330],pidfil:[74,297],piec:[19,55,72,84,197,358],pile:[112,113],pinch:236,pine:[72,81,195],ping:[193,297],pip:44,pipe:[108,232,285,329,330,332,333,334,335,337,338],pipelin:[96,340],pipelining:175,pipermail:[50,343],pittsburgh:57,pkg:[44,137,174],pkg_config_path:50,pkgconfig:[44,50,165],pki:[175,355],place:[7,19,25,31,45,47,48,56,63,71,74,77],placehold:358,placement:193,plai:[47,223],plain:[5,27,41,44,58,59,60,62,63,72,95,129,144,175,196,207,249,261,285,326,330,332,333,334,335,337,338,340],plaintextloginalert:[75,89,261],plaintextloginpaus:[72,145,261],plan:[4,7,11,18,48,49,55,63],planner:55,platform:4,pleas:[3,7,11,12,24,25,41,43,44,56,57,58,59,60,61,62,63,69,71,133,137,138,139,161,162,163,164,169,171,172,174,176,179,184,186,187,188,190,193,197,201,207,216,217,224,230,238,249,263,276,319,325,331,341,355],plenti:239,plu:[11,72,75,133,179,183,197,241,261],plug:[104,105,107,108,345],plugin:[45,68,72],pmr:250,pod:[44,48,149,152,153,154,155,156,157,158,159],point:[3,4],pointer:[52,72,75,130,203,261],poitra:353,poke:183,pokorra:171,polici:[3,60,193,261],poll:261,pollin:42,pom:[44,48,149,152,153,154,155,156,157,158,159],poni:354,poodle:340,pool:[47,74,186,187,190,195],poor:319,poorli:195,pop3:4,pop3_new_uidl:[83,298],pop3d:[63,72,73,75,85,145,175,195,216,222,223],pop3d_3:355,pop3newuidl:235,pop3proxyd:[63,74,75,259],pop3s:13,pop3showaft:285,pop3test:[74,259],pop:[8,18,35,40,41,85,175,176],popd:118,popexpiretim:261,popminpol:[72,164,175,261],poppollpad:261,popsubfold:[77,261],poptimeout:[235,261],popul:[64,194,270],popular:[3,11,120,352],popuseacl:[75,261],popuseimapflag:[85,261],port:[11,18,52,71,72,73,77],portabl:[72,73,74,75,114,115,269,270],portaddr:289,portion:[183,261,330,352],pose:33,posh:71,posit:[11,260],posix:[10,35,41,163,181],possibl:[3,6,11,18,25,41,47,48,52,64,70,72,73,74,75,83,174,175,181,183,185,186,193,194,195,199,211,229,230,236,239,241,250,253,260,261,285,313,329,330,332,333,334,335,337,338,349,355],post:[26,28,41,45,64,71,75,106,108,133,175,176],postabl:318,postal:[176,350,354],postconf:355,postfix:[3,41,63,175,193,199,207,233,239,261],postfold:246,postgresql:[12,18,44,82,355],postman:195,postmast:[33,261],postpon:73,postrot:175,postus:[182,261],potenti:[5,11,72,74,82,84,127,174,179,183,193,215,261],power4:250,power:[11,13,14,41,50,220],ppc:162,practic:[11,36,41,183],prade:[164,172],prancer_sync_host:280,pre5:152,preauth:80,preauthent:41,preauthor:294,preced:[40,235,261],precis:[11,38,63,179],preclud:261,predecessor:261,predefin:2,predict:[11,183,250],prefer:[3,6,28,41,44,46,55,63,70,71,72,106,121,133,175,199,207,228,241,248,249,261,284,313,340,358],prefix:[24,33,41,44,46,52,56,64,65,67,114,117,120,122,133,140,149,150,151,152,153,154,155,156,157,158,159,175,181,183,197,211,216,241,261,266,276,279,281,304,312,313,315,319,355],prefork:[63,116,175,183,195,199,207,209,260,264,289,290,292,294,303,305,306,322,323,355],pregener:[149,152,153,154,155,156,157,158,159],preliminari:[73,74,147,149,151,152,153,154,155,156,157,158,159],prematur:[52,261],prepar:[46,64,65,115,116],prepend:[191,261,304],prerequisit:42,prese:5,presenc:[70,214,340],present:[33,53,66,71,108,126,127,174,175,179,188,193,201,216,258,261,270,279,285,287,320,329,330,332,333,334,335,337,338,355,358],preserv:[11,24,41,48,73,79,96,137,165,182,183,214,246,261,266,313,315],press:[219,358],presum:[194,220],pretend:182,pretti:[46,179,185,193,250,275],prevent:[3,11,36,40,60,64,65,67,72,74,80,97,169,193,220,226,236,238,254,261,268,321],preview:48,previou:[11,56,72,122,139,163,175,187,193,211,352],previous:[9,30,71,72,74,133,145,149,153,154,155,156,157,158,159,162,184,203,261,279,315],prevost:72,price:11,primari:[11,19,40,49,172,176,193,222,223],primarili:[6,11,184,297,352],primary:6,prime256:261,prime256v1:[121,133,261],princip:[41,175,181,207,261,262,285,320,321,340],principl:[9,11,184],prindevil:[111,116],print:[11,52,72,115,120,122,127,135,211,270,275,276,280,282,284,289,293,302,312,314,327,329,330,331,332,333,334,335,337,338],printabl:72,printable:27,printer:270,printf:[52,72],prior:[4,7,9,10,30,57,64,68,72,133,162,166,174,175,182,202,221,241,260,261,315,349,350,354],priorit:11,prioriti:[11,261],priv:261,privaci:[5,72,264,290,292,304,306,322,352],privat:[13,35,134,163,175,199,230,261,285,329,330,332,334,335,337,338,345,352,355],privileg:[11,18,35,36,41,64,180,193,297],pro:196,probabl:[9,15,18,30,41,44,47,73,77,133,183,184,192,195,211,214,221,236,237,253,266,285,313,320],probe:261,problem:[8,28,33,41,44,46,55,56,72,73,74,75,83,84,95,96,97,108,134,169,174,175,188,193,195,207],problemat:11,proc:10,proc_path:[10,71,130,175,188,261],proce:349,procedur:[72,177],proceed:[43,56,193],process:[0,3,5,10,11,12,19,25,35],procfnam:72,produc:[41,48,57,106,144,161,175,183,207,216,261,263,273,284,285,286,315,355],product:[2,11,12,18,46,57,74],profession:[0,250],profil:[3,49,340],profits:57,program:[2,41],programoutput:48,progress:[61,64,73,133,183,308,319,336,350],prohibit:[11,255],project:[12,45,49,55,57,58,59,60,62,63,133,145,176,228,263,345,349,350,351,352,353,354],promin:[11,241],promot:[57,81,220,261],prompt:[41,43,56,72,73,175,238,285,329,330,332,333,334,335,337,338,358],prone:224,prop:103,propag:[193,199,297],proper:[63,71,175,199,201,204,238,261,355],properli:[18,72,74,79,89,101,128,130,134,136,137,140,163,170,195,230,261,292,305],properti:[6,64,120,168,170,175,183,261,275,340,355],propfind:[64,106,162,175],propnam:106,proport:199,propos:[193,349],proppatch:64,proprietari:224,prot:[47,72,177],prot_addwaitev:203,prot_fil:72,prot_flush:74,prot_printf:72,prot_removewaitev:203,prot_select:203,prot_waitev:203,prot_waiteventcallback_t:203,protallow:52,protect:[11,18,41,52,58,59,60,62,63,68,72,73,90,122,145,193,261,264,290,292,304,306,309,322,329,330,332,333,334,335,337,338],proto:[63,175,260,289,290,292,294,303,305,306,322,323],protocol:4,prototyp:72,protstream:203,prove:[41,181,224],provid:[3,5,6,7,8,11,12,13,14,15,19,22,27,33,40,41,43,47,49,50,54,55,56,57,60,64,68,71,72,74,75,111,133,174,175,179,181,184,185,189,192,193,195,199,201,202,204,216,221,222,228,253,260,261,266,274,275,277,280,285,287,289,291,296,311,314,315,319,320,322,340,341,350,352,353,355],provis:[11,20],provision:261,prox:[75,89],proxi:4,proxy:261,proxy_and_backend:261,proxy_authnam:[195,261],proxy_compress:261,proxy_password:261,proxy_realm:261,proxyd:[63,73,75,77,193,195,259,261],proxyd_allow_status_referr:261,proxyd_disable_mailbox_referr:[116,193,261],proxyserv:[72,120,195,261],prune:[211,236,242,263,279,324],pselect:[145,146],pseudo:[9,30,184,195,199,261],ptclient:[5,72,171,172,188,202,261],ptdump:[72,138,259],ptexpir:[138,259],pthread:[227,253],ptloader:[5,41,44,72,74,75,125,138,140,181,188,202,259,261],ptloader_sock:[188,202,261],pts:4,pts_modul:[261,311],ptscach:4,ptscache_db:[133,261,310],ptscache_db_path:[71,138,172,175,188,261],ptscache_timeout:261,ptskrb5_convert524:261,ptskrb5_strip_default_realm:261,ptsloader:311,ptsmodule_standard_root_dn:140,ptsock:[188,202,261],pub:39,publican:358,publicli:251,publish:[43,358],publishcyrusdoc:43,pull:45,punctuat:260,purchas:28,pure:[64,193],purg:[11,24,25,27,77,113,133,199,223,237],purifi:72,purpos:11,purposefulli:25,purview:41,push:[27,36,43,45,49,56,133,149,151,152,153,154,155,156,157,158,159,177],put:[11,15,19,36,41,64,72,175,197,199,207,223],pwcheck:[63,72,175,261],pwcommand:72,pwd:285,pwer4:250,python:[44,48],q01:[58,59,60,62],qop:105,qos:[111,261],qosmark:261,qresync:[25,63,111,115,118,241,261],qualif:3,qualifi:[3,33,40,261,285,304],qualiti:[71,193,248],quantiti:[28,236],queri:[64,68,100,106,107,182,184,192],question:[7,33,113,133,174,175],queu:[239,255],queue:[38,41,204,255,261,297,352],quickest:46,quickli:[25,174,175,179,241,319,352],quickstart:345,quiesc:[189,261],quiet:261,quietli:312,quit:[3,18,41,72,73,84,175,190,193,206,207,239,285,313],quot:[52,72,74,130,197,260,261],quota:4,quota_db:[41,133,188,189,204,261],quota_db_path:[188,204,261],quota_legaci:6,quotadb:[75,166],quotalegaci:4,quotaroot:[6,74,75,77,118,131,188,193],quotawarn:[41,204,261],quotawarnkb:[204,261],quotawarnmsg:[204,261],quoted:27,r7dfjm9k083763:284,race:[73,75,120,122,127,128,160,261],radio:358,raid:[11,236],rain:[176,350,354],rais:[11,27,285],ralf:[133,353],ram:[7,71,188],ran:[11,196,352],rancid:270,random:[9,18,30,72,73,85,184,195,211,224,248,261],randomli:96,rang:[72,79,88,90,101,106,120,121,122,142,145,263,281,340],rank:327,rare:[22,127,193,195,236],raspberri:11,rate:[11,216,239,261,297],rather:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],ratio:[183,266],rational:[193,230],raw:[64,175,183,266,282],rawx:261,raymond:353,rc1:148,rc2:[56,148],rc3:148,rc4:148,rcpt:[40,73,175],rdn:5,reach:[9,30,164,184],reachabl:252,read:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178],readabl:[6,19,41,55,64,174,211,261],reader:[41,75,263,304],readership:263,readi:[0,50,56,58,59,60,62,63,72,174,175,195,197,219],readir:82,readlin:[44,285],readme:[64,71,72,149,151,152,153,154,155,156,157,158,159],real:[11,12,40,41,222,250,291,352],realli:[0,9,15,30,38,47,183,184,216,226,230,241,250,261,289,297],realm:[3,5,18,33,41,181,261,329,330,332,333,334,335,336,337,338],reappear:116,reason:[11,12,25,41,45,47,71,72,187,190,207,236,237,238,242,247,250,254,261,292,341,352],reauth:[74,329,330,332,333,334,335,337,338],reauthent:72,reboot:[41,175,237],rebuild:[41,44],rebuilt:[6,72,271],recalcul:[41,174,214,267],receiv:[7,18,19,26,27,36,39,40,41,44,52,58,59,60,62,63,72,73,175,183,193,195,196,197,199,204,225,261,266,287,291,297,341,351,355],receivedhead:261,recent:[6,11,12,43,56,64,71,72,149,151,152,153,154,155,156,157,158,159,171,179,182,186,202,224,261,266,289,313],reciev:255,recipi:[3,6,19,40,41,73,74,77,168,182,246,261,305,340,355],recogn:[72,336],recognis:[174,280],recognit:146,recommend:[4,6,7],recommended:261,recompil:[70,149,156,157,158,159,183,227,248],reconfigur:[40,53,193,196],reconnect:[36,74,107,193,194,195,297],reconstruct:6,record:[6,11,18,25,41,113,126,127,129,130,136,162,171,183,197,216,241,242,261,266,267,274,276,298,300,313,315,319,320],recov:[11,24,25,28,41,79,169,175,183,192],recover:[11,183],recoveri:[11,25],recreat:[116,133,174,175,188,211,267],recur:101,recurr:[229,261,340],recurs:[47,73,211,261,267,285,313,315,319],recursivematch:167,recus:313,recv:[211,289,326],recycl:297,red:[2,12,57],redbot:106,redefin:202,redesign:72,redfish:[111,116],redhat:[44,54,227,229],redirect:[6,73,74,172,207,225,261,285,297,340],rediscov:[162,313],redistribut:57,redo:72,reduc:[25,41,47,71,72,77,81,97,114,174],reduct:[193,222],redud:74,redund:[3,4],refactor:[73,162],refer:[3,5,6,7,12,14,19,33,40,41,71,72,84,97,114,115,121,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,181],referenc:[48,72,207,355],references:[58,59,60,62,63,73,121],referr:[41,74,75,95],referrals:[58,59,60,62,63,193],reflect:[72,133,193,197],refresh:[9,11,30,184],refus:[72,285],regard:[11,57,229,261,343],regardless:[6,7,11,41,66,84,180,182,189,261,280,287,315,349],regener:[41,183],regex:[163,171,207,261,340],region:250,regist:[3,27],registr:[261,340,341],registrar:3,regress:[45,75,120,127,131],regul:24,regular:[33,44,48,55,64,73,75,174,183,207,216,235,236,241,261,279,319,340,344],regularli:[11,48,55,238,266],regulatori:[11,25],rehash:[74,117,118,119,189],reindex:[183,261,266,319],reinstal:45,reintroduc:80,reject8bit:[72,261,287],reject:[41,72,73,74,88,129,134,137,169,172,207,223],rel:[11,30,174,183,199,261,266,285],relai:254,relat:[5,6,11,19,30,31,35,41,72,73,74,75,83,133,183,184,185,186,190,207,216,261,315,340,343,355,358],relationship:[5,183,261,264],relax:115,releas:[1,2,12],relev:[6,11,18,41,48,68,149,150,151,152,153,154,155,156,157,158,159,183,206,261,319,341],reli:[52,71,74,184,193],reliabl:[118,128,147,149,150,151,152,153,154,155,156,157,158,159,255,350],reload:[177,208],reloc:[63,174,188,285],remain:[11,24,25,53,68,166,182,183,185,211,216,220,241,252,266,279,315,320,349,352,353],remaind:40,remap:262,rememb:[18,43,56,73,174,184,276,341],remind:27,remot:[18,40,43,49,56,63,64,68,72,75,86,92,114,115,129,136,140,176,184,193,194,195,207,216,261,270,290,292,294,303,304,306,318,323,336,340,352,358],remote:[41,134,181],remotepurg:74,remount:358,remov:[7,11,24,25,27,36,40],renam:[19,24,36],rename:[36,72,73,74,97,117,182,193,261,285],renameing:79,renamemailbox:[211,217],render:[19,48,133],renew:72,renm:285,renounc:72,renown:353,repack:[50,127,276],repair:11,repeat:[48,146,183,261,320],repl1:216,repl1_shutdown:216,repl1_shutdown_fil:216,repl1_sync_host:216,repl1_sync_repeat_interv:216,repl1sync:216,repl2:216,repl2_shutdown:216,repl2_shutdown_fil:216,repl2_sync_host:216,repl2_sync_repeat_interv:216,repl2sync:216,replac:[11,47,48,66,72,75,108,111,133,162,175,176,182,184,191,195,203,207,211,230,261,267,340,352,355,358],replai:[131,216],repli:[11,52,64,72,75,193,199,261],replic:[3,4,6],replica:[11,18,83,96,125,127,183,188,193,197],replication_3:355,replman:216,replyto:261,report:[0,24,41,44,64,70,72,73,74,84,87,106,115,122,127,129,131,136,137,138,139,160,161,162,163,164,165,168,171,172,174,175,254,255,261,263,266,270,278,284,291,298,312,313,315,320],repositori:[43,45,46,48],repository:49,repres:[52,184,197,203,287],represent:[6,33,41,53,72],reproduc:[11,57,244],reputedli:133,req:175,request:[9,11,19,30,36,41],requeu:41,requir:[3,4,5,6,7,8,10,11],require:47,reread:[73,297],reschedul:203,rescu:[25,261],research:[87,115,353],resent:[236,261],reserv:[33,57,74,163,166,193,194,195,197,268,285],reserved:193,reset:4,resid:[6,7,15,27,36,41,64,65,66,67,133,186,187,190,193,197,199,241,261,326],resign:349,resolut:[72,352],resolv:[11,40,73,172,193,195,196,261,281],resourc:[1,6,27,34,41],respect:[9,27,28,30,40,44,52,68,75,77,182,186,193,250,261,266,285,315,355],respond:[11,33,36,179,197,254,261,264,289,290,292,294,303,304,306,318,323],respons:[6,18,25,33,64,65,67,72,73,75,77,80,81,82,83,84,89,92,97,105,106,107,108,114,115,121,127,128,129,131,135,149,151,152,153,154,155,156,157,158,159,163,166,174,175,179,182,192,193],rest:[3,11,36,46,47,56,169,174,183,199,216,261,336],restart:[56,75,174,175,183,186,195,196,199,215,216,233,246,251,260,261,297,320,358],restful:261,restict:260,restor:[24,41,72,81,135,179],restore_authnam:[261,315],restore_password:[261,315],restore_realm:[261,315],restrict:[5,11,14],restructur:[43,44,48,149,152,153,154,155,156,157,158,159],restructuredtext:133,result:[3,6,11,18,19,25,33,36,40,45,47,48,52,64,72,77,106,117,133,162,164,175,179,193,195,197,210,216,220,226,229,232,233,241,243,246,255,261,267,276,297,319,358],resulting:57,resum:183,resurrect:171,resync:[33,195],resynch:195,resynchron:[72,193,340],retain:[25,57,241,261,295,307],retext:48,retri:[195,204,233,261],retriev:[3,6,9,30,72,179,184,199,241,256,261,288,331],retrofit:247,retyp:[58,59,60,62,63],reus:[73,74,75,83,105,175],rev1:218,rev4:[71,175,201,355],reveal:[173,350],revers:[36,40,75,149,151,152,153,154,155,156,157,158,159,254,261],reverseacl:[149,151,152,153,154,155,156,157,158,159,163,174,261],revert:[75,174,285],review:[7,23,49,55,74,195,199,349,355],revis:[49,350,352],revok:178,rework:85,rewrit:[118,126,130,162,171,313],rewritten:[74,111],rewrot:[73,77,82,104,106],rfc2046_strict:[74,261],rfc2047_utf8:[230,261],rfc3028_strict:[75,261],rfc3501:285,rfc3977:75,rfc4315:75,rfc6203:171,rfc822:[72,183],rfc:[8,12,13,14,27,33,34,36,41],rich:[14,178,352],richard:353,rid:72,rider:[176,350],right:[5,6,7,11,14,33],rights:[58,59,60,62,63],ripe:71,risk:[11,72,145],rlist:[134,193],rlsub:193,rmgroup:199,rmnew:72,road:[176,350],roadmap:[345,348],rob:[73,353],robert:127,robust:[6,80,114,168,345],roc:73,rock:[52,203],roland:114,role:[20,36,184],roll:[50,83,122,125,169],rollback:168,roncero:131,room:183,root:[5,6,11,18,27,33],rosenbaum:74,rotat:[7,175,216,222],rough:349,rouillard:127,round:11,rout:[3,11,40,340],routin:[7,36,47,72,73,74,133,184,241],row:[33,261],rowid:6,royal:[176,350],rpath:[50,253],rpm:[58,59,60,62,215,226,249,341,358],rpost:199,rsa:[58,59,60,62,63],rscale:[100,229,340],rss_feedlist:[66,261],rss_maxag:261,rss_maxitem:261,rss_maxsynopsi:261,rss_realm:261,rst:[43,48,56],rsync:[50,162,174],rsyslog:[174,175],rudolf_sync_host:280,ruin:325,rule:[1,3,11,20,36],rummag:183,rumpf:77,run:[6,7,10,11,13,18,19,25,28,33,35,36,41,43,44],runawai:129,rundir:202,runtim:[53,75,133,184,188,248,275,280],rust:71,s01:[58,59,60,62,63],s_client:18,sa46093:[87,115],sacrif:193,sacrific:193,safe:[43,47,56,117,137,175,183,193,222,223],safeguard:321,safer:[116,133,193,261],safeti:[8,72,75,81,266],sai:[11,72,175,182,183,222,225,241,250,266],said:[5,7,11,43,56,72,199],sake:133,salt:18,sam:[199,240,263,285,353],same:[3,4,5,6,7],sampl:[2,15,40],san:[11,250],sandbox:[174,175,355],sane:[73,149,151,152,153,154,155,156,157,158,159,261],saniti:[96,175],sas:11,sasl2:[44,63,174],sasl_:[183,261],sasl_auto_transit:[41,175,261],sasl_checkapop:74,sasl_client:52,sasl_maximum_lay:261,sasl_minimum_lay:[63,261],sasl_opt:261,sasl_prot_any:52,sasl_pwcheck_method:[41,63,175,261],saslauth:[175,355],sasldb2:175,sasldb:[41,175,261,355],sasldblistusers2:[63,175],sasldir:72,saslficat:72,saslpasswd2:[63,175,355],saslserv:75,saslv2:73,sat:[131,326],sata:11,satisfi:174,satur:11,saturdai:241,save:[19,41,73,84,114,205,216,238,249,261,331],savvi:[61,199],saw:301,sbin:207,sbindir:[149,150,151,152,153,154,155,156,157,158,159],scalabl:[4,7],scalar:211,scale:[7,11,36,192,193,195,250,352],scan:[27,41,58,59,60,62,63],scarf:84,scaveng:[41,249,313],scenario:4,sched:64,sched_tag:6,schedul:[6,11,44,64,65,67,68,174],scheme:[68,71,103,171,189,195,199,204,216,261,340],schiller:72,schmiedehausen:73,schult:75,schumach:172,scientif:57,scope:[5,11,40,69,261,352],score:[27,149,151,152,153,154,155,156,157,158,159,326],scott:[73,253],scp:[43,56,174],scratch:[43,56,184],screen:[12,72,284],screw:72,scriptfil:317,scriptnam:285,scsp:261,sda2:11,sdb2:11,sdk:261,seal:13,seamless:[13,352],seamlessli:183,search:[4,5],search_batchs:[50,191,261],search_engin:[50,71,149,150,151,152,153,154,155,156,157,158,159,191,261,319],search_fuzzy_alwai:[171,261],search_index_head:[50,191,261],search_indexed_db:261,search_maxtim:261,search_normalisation_max:261,search_skipdiacrit:261,search_skiphtml:261,search_snippet_length:261,search_stopword_path:261,search_whitespac:261,searchabl:261,searchd:[188,202,261],searched:319,searchpartit:[186,191,261],searchtier:[186,191,261],searchtierpartit:[186,191,261],sec:[58,59,60,62,63,233,239,261],second:[11,41,53,72,130,176,181,183,193,194,195,197,207,216,222,236,239,260,261,262,264,267,277,279,289,290,292,294,297,304,305,306,313,315,318,319,320,326,340,350,358],secondari:[3,11,19],secret:5,sect:9,section:[3,11,12,26,34,36,41,46,48,50,54,63,64,68,70],sector:11,secunia:[87,115],secur:[3,5],securityapprais:74,see:[3,7,9,11,19,25,33,36,38,40,41,43,44,46,48,49],seek:133,seem:[74,75,89,105,175,182,344],seemingli:26,seen:4,seen_db:73,seenstate_db:[133,261],segfault:[75,89,121,143,144,145,172],segment:[3,193],segmul:74,select:[4,6,7],selector:261,self:[28,58,59,60,62,63],selinux:209,selski:[349,353],semanag:209,semant:[55,73,74,193,340],semi:179,send:[5,11,26,41,43,44,48,52,55,56,64,72,75,80,137,145,149,150,151,152,153,154,155,156,157,158,159,174],sender:[3,27,41,199,223,225],sendmailconfig:[175,355],sens:[56,75,255],sensibl:[55,193],sensit:[33,72,73,193,261],sent:[26,27,33,39,41,45,48,72,75,127,175,193,195,197,207,211,214,235,254,261,277,283,285,298,313,319,326,341,358],sentdate:[298,326],sep:276,separ:[5,6,7,9,11,19,24,25,30,31,33,36,40,41,52,53,54,66,68,72,73,77,78,125,131,133,150,151,152,153,154,155,174,175,182,185,186,190,195,197,211,216,219,220,241,250,260,261,262,263,266,277,281,284,285,292,299,302,319,325,326,355],seper:[73,285],seq:79,seqdiag:48,seqnum:298,seqset:281,sequenc:[6,11,52,72,73,79,80,197,232,235,260,261,276,281,298,320],sequence1:281,sequence2:281,serer:261,sergei:164,seri:[2,43,45,56,60,71,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147],serial:250,serious:[72,127,233],serv:[11,36,66,68,72,77,183,193,197,199,216,235,254,261,287,290,292,304,306,313],servant:85,server:[4,5,6],server_side_tls:261,serverdomain:27,serverfqdn:27,serverinfo:[81,144,261],serverlist:[9,30,84,184,195,261],serverlist_mod:9,serverlist_mode_soft_usage_limit:9,serverlist_mode_usage_reinit:9,serverlist_select_mod:[9,30,184,195,261],serverlist_select_soft_usage_limit:30,serverlist_select_usage_reinit:[30,184,195,261],servermetadata:261,servernam:[64,65,67,68,195,207,261,285,288,320],serverport:27,servic:[2,3,6,7,9,11,18,27,30,35,40,41,47,52,57,58,59,60,62,63],service_abort:74,servicenam:[75,280],services:[63,71,133,175,183,195,199,207,216,222,223],session:[3,6,8,18,41,72,73,74,83,133,136,144,160,166,175,188,193,195,197,216,241,261,264,290,292,297,303,304,306,324,329,330,332,333,334,335,337,338,358],sessionid:[27,117,185,261],set:[3,5,7,8,9,10,11,13,15,18],set_lk_max_lock:239,set_lk_max_object:239,setacl:[27,40,84,136,182,193,255,285],setaclmailbox:[40,41],setannotation:134,setgid:73,setinfo:279,setquota:[40,41,73,84,193,195,205,213],setrlimit:[73,145],setseen:41,setseen_al:83,settl:11,setuid:[72,238],setuidvalidity:79,setup:[7,12,18,48,69,172,174,177],seventh:319,sever:[11,19,36,41,48,71,72,73,74,75,80,82,106,107,174,175,186,188,195,196,197,202,204,239,250,350,355,358],sha1:79,sha384:[58,59,60,62],sha:[63,174],shadow:[41,72],shake:183,shall:[9,30,57,63,184,349],shape:11,shapelib:355,share:[4,5,6],sharedprefix:[33,261],sharedscript:175,sharedseen:[79,179,182,235,285],she:[33,43,56],sheet:66,shell:[33,43,56,72,74,164,175,276,285,302,358],shini:46,shinier:[149,150,151,152,153,154,155,156,157,158,159],ship:[11,44,57,58,59,60,62,63,71,185,220,227,229,284],shm:10,shoot:7,shortcut:358,shorter:[6,236],shortest:47,shorthand:[33,285],shortnam:261,should:[3,6,7,9,11,12,18,22,25,26,27,30,33,36,40,41,43,44,47,48,52,56,58,59,60,62,63,64,65,66,67,71,72,73,74,77,80,133,137,140,173,174,175,179,180,182,183,184,188,192,193,194,195,197,199,202,203,207,209,211,216,219,221,222,223],shouldn:72,show:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],showalt:353,shown:[15,48,63,183,199,260,274,325],shut:[71,72,74,133],shut_down:47,shutdown:[7,72,74,85,135,145,147,166,216,235,252,260,285,292,320],shutdown_fil:320,sibl:73,side:[5,11,13,19,36],siemborski:[73,353],siev:[4,6],sieve:[41,73,74,193,207,261],sieve_allowreferr:[75,95,261],sieve_extens:[77,151,152,153,154,155,164,261],sieve_maxscript:261,sieve_maxscripts:261,sieve_sasl_expect_unsolicited_cap:82,sieve_sasl_send_unsolicited_cap:[82,261],sieve_utf8fileinto:[82,261],sieve_vacation_max_respons:261,sieve_vacation_min_respons:261,sievec:[207,259,296],sievedir:[72,145,174,175,188,207,261,296],sievenotifi:[41,74,261],sieveshel:[74,207,259,331],sieveusehomedir:[72,175,188,207,261],sig:[43,56,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172],sighup:[73,215,297],sign:[28,43,49,56,58,59,60,62,63,72,102,115,136,197,246,261,350],signal:[73,166,215,235,261,291,297],signatur:[43,56,64,261,284,340,355],signific:[5,11,74],significantli:[75,81,133,174,193,218,236,319],sigsegv:195,sigserv:195,sigterm:297,sigusr2:168,silent:[118,134,238,261,289],silli:73,similar:[8,9,11,18,44,68,83,174,175,183,190,192,193,195,197,199,207,211,216,222,260,352],similarli:[5,47,183,195,199,241,260],simon:[80,85,122,127,146,249,353],simpl:[43,66,72,73,75,174,175,192,195,197,199,211,236,261,285,340,345,349,352,355],simpler:118,simplest:36,simpli:[11,41,47,72,133,169,195,199,203,206,253,329,330,332,333,334,335,337,338],simplist:11,simultan:[8,183,355,358],sinc:[7,9,11,12,18,25,30,33,35,47,53,66,71,72,73,74,75,77,78,79,80,81,82,83,84,85,86,89,91,92,93,94,95,96,97,99,102,103,104,105,106,107,108,109,111,112,113,114,115,116,117,118,119,123,125,126,127,128,129,130,131],since:73,singl:[3,4,6],singleinstancestor:[41,261],singular:11,sip:340,siriusit:115,sit:[7,250],site:[41,66,71,72,127,131,174,181,189,193,202,204,216,236,253,261],situat:[11,33,112,133,174,184,241,250],sium:239,sivtest:[74,207,259],six:55,sixth:319,size:[6,9,11,15,27,28,30,41,44,47,72,73,75,81,82,83,84,117,122,183,184,185,186,208,211],size_t:102,sizeof:47,skeleton:[52,175,195],skip:[6,50,72,74,75,97,261,266,279,293],skiplist:4,skiplist_always_checkpoint:261,skiplist_unsaf:261,skynet:216,slash:[33,73,175,285],slave:[11,63,97,193,195],sleep:[216,260,319],sleepycat:253,slide:6,slight:216,slightli:[108,133,195,216,254,261,354],slot1:265,slot:[216,261],sloti30t15:27,slow:[6,11,28,71,84,113,184,186,223,224],slower:[11,15,46,47,112,186,216,220,261],small:[0,11,13,28,47,72,73,74,114,116,174,183,217,220,236,239,250,301,321,352,355],smaller:[11,15,171,183,204,261,293,320],smart:11,smarter:72,smigielski:353,smilint:137,smith:353,smmap:[71,175,201,355],smmapd:[71,75,175,201,259],smooth:319,smoother:[9,30,184],smoothli:60,smtp:[41,72,175,195,199,222,254,269,338,340,348],smtpd:63,smtptest:[74,259],snakeoil:175,snapshot:[3,8,11,46,173,174,183],snip:326,snippet:[15,175,217,261,341],snmp:[44,73,75,297,355],snmpd:297,snmpgen:74,snow:[176,350,354],snuck:125,sock_dgram:289,sockaddr_in:289,socket:[5,27,36,40,41,63,71,72,73,74,75,97,124,129,137,172,174,175,177,188,195],socklen_t:73,soft:184,soft_noauth:261,softer:261,softwar:[4,11],software:57,solari:[12,72,74,102,123,129,134,144,149,151,152,153,154,155,156,157,158,159],sole:[11,352],solut:[11,19,111,116,174,175,183,188,192,193,195,220,226,239,246,249,250,255,261,349,352],solv:[83,108,352],solvabl:236,some:[7,10,11,24,25,28,31,33,40,41,44,46,47,48,50,55,56,60,63,64,66,68,71,72,73,74,77,84,90,116,120,122,125,129,133,136,160,162,169,174,175,180,182,183,185,186,188,190,193,195,197,199,203,207,211,215,216,220,226,229,233,238,244,247,248,250,253,255,260,261,264,273,285,287,290,292,304,306,313,314,319,322,350,351,352,355],somehow:195,someon:[0,183,246],someth:[18,26,43,44,47,56,74,174,175,185,187,199,207,211,219,222,230,236,244,250,253],sometim:[11,26,75,223],somewhat:[15,72,193,224],somewher:[11,43,56],soon:[25,75,184,215,249,261,319,345],sop:346,soref:165,sorri:[72,355],sort:[41,58,59,60,62,63,71,73,79,113,116,149,150,151,152,153,154,155,156,157,158,159,197,207,214,235,261,276,313,327,340,351],sortcache_db:261,soth:73,sound:193,sourc:[2,5,27,41,44,45,46,48,49,50],sourceforg:18,space:[3,6,7,9,10,11,15,19,28,30,41,44,48,49,52,55,68,72,84,114,115,117,133,137,161,172,174,175,183,184,185,186,190,193,195,197,204,206,211,242,261,263,278,299,319,326],spam:[27,33,41,133,149,151,152,153,154,155,156,157,158,159,207,261,298,313,326],spamtest:340,span:[101,193],sparc:79,spare:[11,250,255],spars:281,spawn:[71,73,215,216,222,252,260],speak:[3,11,36,41],spec:216,special:[1,4],specialus:[134,285,351],specialuse_extra:261,specialusealwai:[261,340],specif:[6,7,8,11,12,24,40,41,43,44,52,56,66],specifi:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40],speed:[15,55,57,74,77,84,176,193,218,261,319,345,350],spell:[48,165,261],spellman:127,spend:[36,72],spew:72,spf:345,sph:77,sphinx:[44,48],sphinx_pidfil:261,sphinx_socket:[188,202,261],sphinx_text_excludes_odd_head:261,sphinxcontrib:48,spice:46,spil:[137,169],spin:[15,71,72,96],split:[31,63,72,75,81,84,96,111,172,177,182,183,187,190,208],splitmeta:217,spnego:[68,329,340],spock:33,sponsor:77,spoof:41,spoofeddomain:284,spool:[7,11,13,15],spous:19,spread:[41,193,250],springfield:175,sql:[4,5],sql_:82,sql_databas:261,sql_engin:261,sql_hostnam:261,sql_passwd:261,sql_user:261,sql_usessl:261,sqlite3:266,sqlite:[6,44,82,165,183,261,328,355],squat:4,squat_decode_64:115,squatter1:319,squatter:[50,74,75,81,84,137,160,169,177,186,191,208,216],squattera:319,squeez:44,squirrl:72,src:[47,175],srcdir:74,srctier:319,srv:[43,56],srvtab:[41,72,261],ssd:[11,15,71,114,186,220,319],sse4:355,ssf:[95,261,264,290,292,304,306,322],ssh:43,ssl2:133,ssl3:133,ssl:[5,6,44,52,63,68,73,74,80],ssl_accept:80,ssl_ctx_load_verify_loc:52,sslv23:[73,145],sslv2:[73,88,121,145],sslv3:[88,121,145,340],sssd:[41,181],stabl:[2,11,12,43,48,57,60,63,131,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172],stack:[75,113,261],stackoverflow:175,staff:[11,41,181,353],stage:[43,56,74,75,166,183,185,241,261],stai:[9,30,49,184,195,293],stale:[71,183,216,266,276],stall:[149,154,155,156,157,158,159],stamp:300,stand:[7,182,184,187,193,355],standalon:[175,183,193,216,222,255],standard:[7,12,13,27,33,50,64,71,75,106,116,120,166,174,175,176,177,185,192,193],stanza:[174,188],start:[1,10,11,27,33,36],starttl:[18,136,169],starttls:[52,58,59,60,62,63,72,73,80,82,129,137,144,175,195,261],stat:[72,160,165,183,266,313],state:4,statedir:72,stateless:222,statement:[47,115,118],station:[176,350],statist:[3,73,74,183,263],statoverrid:175,statu:[6,27,64,72,81,149,151,152,153,154,155,156,157,158,159,183,195,207,254,261,265,284,285,319,340,344,349],status:4,statuscach:4,statuscache_db:[10,133,261],statuscache_db_path:[10,71,175,188,261],std:[44,46,75],stderr:[52,75,265,297,320],stdin:[129,261,276,297],stdio:[52,203],stdout:[52,115,265,269,286,297,317,336],stefan:[87,115],steinar:72,step:[18,41,44,56,64,70,174,175,185,195,196,209,266,355],stephen:250,stick:[43,193],still:[3,9,11,19,30,41,45,46,50,55,57,64,72,73,74,79,83,113,126,131,133,149,153,154,155,156,157,158,159,160,162,166,182,183,184,193,194,199,209,229,230,235,241,250,252,253,255,260,261,266,285,314,315,319,326],stipul:186,stock:[58,59,62,63,175],stomach:11,stonith:11,stop:[72,127,175,183,194,216,226,261,266,297,299,320,354],stopword:261,storag:[3,4],storage:[41,206,285,312],store:[6,9,11,13,15,22,27,30,31,33,36],storeing:73,storm:[24,74,133],straight:50,straightforward:[184,193],strang:[195,261],strarrai:166,strategi:[11,174],strconcat:115,strdup:47,stream:[26,72,101,197,203,250,266,274,340],strength:[58,59,60,62,63,261,264,290,292,304,306,322],strerror:72,stress:[11,54],stretch:[36,353],strict:[261,340],stricter:131,strictli:[11,15,125,133,144,186,187,243,261],strike:73,string:[6,33,41,45,47,64,68,70,72,73,74,75,112,135,181,186,190,191,195],stringi:[46,174],stringlist:74,strip:[19,64,261],strndup:47,stromso:143,strong:[248,254,261],strongest:[329,330,331,332,333,334,335,337,338],strongli:[40,133,174,195,216,325],strstr:52,struct:[52,203],structur:[6,11],struggl:48,stub:74,stuck:170,student:[352,353],studio:146,stuf:11,stuff:[48,72,203,250,284,328,358],stupend:175,stupid:72,style:[18,41,48],stylesheet:[66,261],styx:171,sub:4,subaddress:[207,261,340],subag:297,subcommand:41,subdirectori:[41,64,72,183,238],subdivid:261,subfold:[9,19,30,33,41,77,114,116,117,162,180,184,211,223],subj:[175,211,298,326],subjct:326,subject:[3,7,8,11,27,44,73,75,100,136,150,151,152,153,154,155,156,157,158,159,161,166,179,182,211,261,263,284],submailbox:[195,315],submiss:[3,41,182,261],submit:[1,36],submitserv:261,submitt:349,subscrib:[6,7,19,41,48,64,75,107,112,133,182,195,214,222,261,263],subscribe:[193,285],subscribed:[58,59,60,62],subscript:4,subscription_db:[133,261],subsequ:[6,72,133,137,199,235,241,276,285],subset:[64,65,67,193,207,222,267],subshel:285,substanti:[75,169],substitut:[35,43,56,186,190,261],substr:[74,116,261],subsystem:[74,75,97,111,312],subtl:[73,211],subtract:261,succe:[52,84,133,149,150,151,152,153,154,155,156,157,158,159,182],success:[4,11,18,19,26,41,52,58,59,60,62,63,74,137,175,182,193,197,204,255,261,355],successfulli:[11,19,58,59,60,62,63,81,182,195,197,261,266,331],successor:[182,250],sudo:[44,46,63,174,175,244,355],suffer:133,suffici:[11,18,25,80,175,229,261,319,355],suffix:[261,279],suggest:[73,175,183,196,226,230,232,250,253,255,349],suid_dump:238,suit:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],suitabl:[11,40,43,74,174,175,183,197,220,222,355,358],sum:[9,30,41,55,184,205],summari:[27,44,175],summer:350,sun:[72,145,146,326],sundai:241,superb:[176,350],supersed:289,supervis:83,suppli:[5,11,41,52,68,72,74,75,105,230,253,272,276,279,329,330,332,333,334,335,337,338,341],support:[2,4,7],suppos:[3,5,7,9,11,30,72,75,182,183,184,239],suppress:[6,13],suppress_cap:[116,261],sure:[7,12,43,44,47,49,55,56,63,71,75,133,174,175,183,195,196,199,201,207,215,220,222,226,233,238,249,253,260,261,268,313,344,355],suri:[88,131],surnam:19,surpris:[60,195],surround:358,survei:174,suse:[12,73],suspect:[183,195,222],sustain:[133,354],svg:358,svn:358,swap:[33,49,72,174],sweep:[297,310],swiftli:11,symbol:[164,261],symlink:[73,149,150,151,152,153,154,155,156,157,158,159],sync:[49,50,63,83,116,144,169,175,183,188,193,194],sync_:[114,183,216],sync_authnam:[216,261],sync_batchs:[149,154,155,156,157,158,159,216,261],sync_client:[79,83,97,113,120,125,147,149,151,152,153,154,155,156,157,158,159,183,216,222,259,261,264,270,282],sync_compress:[85,216],sync_crc:[127,134],sync_host:[216,261,320],sync_log:[50,183,216,222,261,319],sync_log_chain:[216,261],sync_log_channel:[50,183,216,261,319,320],sync_log_fil:320,sync_log_unsuppressable_channel:[216,261,319],sync_mailbox_ful:116,sync_password:[216,261],sync_port:[216,261],sync_realm:[216,261],sync_repeat_interv:[216,261],sync_reset:[114,126,259],sync_response_pars:222,sync_send_lookup:222,sync_serv:[79,84,97,118,127,145,183,216,222,259,261,315,320],sync_shutdown_fil:[216,261,320],sync_timeout:261,sync_try_imap:[216,261],syncapply:166,syncclient:[216,270,320],syncget:166,synchron:[11,52,72,96,97,177,192,193,194,195],synchronis:[183,222],synclog:319,synclogfil:319,syncnew:72,syncproto:165,syncrestore:166,syncserv:[216,322],syncstop:216,synctest:[183,259],syndic:340,synopsis:48,syntact:72,syntax:[15,18,40,48,72,207,226,230,261,340,358],synthet:[216,261],sys:[219,340],syscal:250,sysconfdir:[188,355],sysconfig:220,sysctl:[41,181],sysflags:[298,326],syslog_facil:261,syslog_prefix:[175,261],syslogd:75,system:[0,1,3,4,6,11],systemctl:[60,174,355],systemd:355,systemrc:285,systemv:355,t1searchpartit:50,t227:122,t229:122,tab:[6,41,55,72,115,219,266,276,358],tabl:[6,18,64,72,74,75,260,261,263,284,297],table:[6,18],tada:355,tag:[1,11,42,43],tagged_abov:27,tahr:63,tail:46,tailor:[41,174,202,204],takatukaland:73,take:[7,11,19,25,33,36,40,48,52,55,56,57,71,72,73,74,77,97,174,175,176,183,184,193,195,197,207,209,223,235],taken:[7,11,75,183,261],talk:[3,6,15,55,133,175,193,195,216,233,239,253,261,342,355],tamplin:77,tar:[43,46,56,57,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172],tarbal:[2,43,44,56],target:[3,7,9,11,27,30,36,48,73,125],tartaru:50,task:[11,33,36,44,84,101,121,134,135,140,141,142,143,145,146,174,183,188,260,279,285,358],tcl:[72,73,174,285],tcl_rcfilenam:72,tclconfig:72,tclsh:72,tcp4:260,tcp6:260,tcp:[41,71,113,114,175,193,195,200,201,202,209,216,252,260,261,355],tcp_keepal:[252,261],tcp_keepalive_:252,tcp_keepalive_cnt:261,tcp_keepalive_idl:261,tcp_keepalive_intvl:261,tcp_wrapper:44,team:[12,38,45,49,57,61,63,72,146,175,336,341],tech:[41,48,57,263,269,270,313],technet:270,technic:[3,40,349],techniqu:[11,250],technolog:[5,11,12,13,26,57,187,190,220,239,350,352],teged:[139,162],telemetri:[41,46,72,74,106,109,188,203,223],telemetry_bysessionid:261,tell:[11,31,55,72,137,175,186,190,195,196,197,199,226,261,264,290,292,304,306,313,320,322,341,355],telnet:[174,175,207,219,341],temp:[191,219],temp_path:[183,261],tempfail:255,templat:[48,66,68,261,283],temporari:4,temporarili:193,tempsearchpartit:191,ten:242,tenant:33,tend:[9,11,30,60,183,184,188,241,260,292],term:[11,33,36,44,84,230,241,261,285,319,326,358],termin:[36,48,52,74,75,175,207],terminated:47,terminolog:192,terribl:195,test:[0,1],testb:127,tester:[0,54],testfold:27,testfolder_renam:27,testrunn:46,testsaslauthd:[18,58,59,60,62,63,175,355],text:[5,6,27,43,46,48,52,57,63,71,72,73,75,77,122,149,152,153,154,155,156,157,158,159,175,194,202,239,249,261,267,269,270,276,319,326,340,358],tfz:43,than:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],thank:[72,73,75,84,85,87,88,112,114,115,116,121,122,127,131,133,134,135,136,137,138,139,143,144,145,146,147,149,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,168,169,171,172,358],thei:[3,7,9,11,15,19,22,25,30,33,36,38,40,41,43,45,46,47,50,56,57,64,68,71,72,74,116,133,135,145,149,152,153,154,155,156,157,158,159,164,174,175,176,182,183,184,186,187,188,193,194,195,197,199,201,205,207,214,215,216,222,230,236,237,241,243,244,250,253,254,260,261,279,280,285,292,297,300,315,350,352,355],them:[3,6,7,11,18,25,31,41,43,44,46,47,55,56,57,64,65,67,71,72,75,77,79,133,145,162,174,175,179,182,183,190,193,195,197,199,201,205,207,211,222,230,244,251,255,261,266,280,281,284,285,288,292,297,302,313,315,319,320,326,328,352,355],themovieposterpag:284,themselv:[6,28,41,71,121,133,178,179,186,193,195,260,261,313,323],theoret:193,theori:[11,214],thereaft:5,therebi:[11,193],therefor:[3,9,11,12,26,36,38,41,60,71,162,183,218,240,241,254],therein:[11,188,220,298,319],thereof:[11,24,47],thewrittenword:75,thi:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132],thing:[3,11,15,41,47,56,57,71,74,111,116,120,125,174,175,181,183,185,188,193,194,199,203,230,233,249,250,261,312,314,355,358],think:[0,11,40,57,71,194,236,250,261,313],third:[19,27,41,54,72,85,176,185,261,267,277,319,350],thise:270,thoma:[27,85,88,115,122,143,145,284],thomas_cooper94:284,thomson:340,thorough:195,those:[3,5,6,9,11,30,33,40,45,55,56,63,64,65,66,67,71,74,108,133,174,175,182,183,184,188,189,190,192,193,194,195,197,207,216,222,229,249,250,260,261,264,270,276,280,287,290,292,293,294,303,304,306,318,319,320,323,329,330,332,334,335,337,338,355],though:[3,5,33,36,47,60,72,74,75,182,185,193,195,197,241,250,253,261,289],thousand:[3,36,250],thread:[58,59,60,62,63,71,73,75,114,116,121,130,149,150,151,152,153,154,155,156,157,158,159,195,199,235,253,261,340,355],three:[3,5,6,7,24,33,36,40,182,191,193,197,241,319,340,358],threshold:[15,27,41],through:[4,7],throughout:[3,18,47,73,74,211],throughput:[79,193,233],thu:[7,9,30,33,41,79,181,183,184,186,193,195,211,236,260,261,298,355,358],thumb:11,tibbit:171,tibbitt:165,tick:262,ticket:[5,11,41],tickl:72,tidi:[116,127,165],tie:46,tier1:[186,191,261],tier1searchpartit:[186,191,261],tier:6,tilt:216,tim:[207,336,353],time:[0,3,6,7,9,11,12,15,25,27,30,36,41,43,47,49,55,56],time_t:[203,235],timefram:11,timeout:[41,75,89,113,122,136,233,261,264,289,290,292,294,304,305,306,318,320,340],timer:261,timestamp:[6,27,72,120,185,211,215,261,266,288,340],timezon:[6,27,46,55,64,72,162,271],timonei:353,timotheu:171,timsiev:[33,63,71,72,73,74,75,80,95,114,144,169,175,195,201,207,222,259,260,261,290,292,294,297,303,306,322],timzon:108,tini:[111,183],tinyint:18,titl:[207,358],tld:[207,245,246,261],tls1_0:[121,133,261],tls1_1:[121,133,261],tls1_2:[121,133,261],tls1_3:[163,261],tls:[4,5],tls_:75,tls_ca_:133,tls_ca_fil:[133,261],tls_ca_path:[133,261],tls_cert_fil:[133,261],tls_cipher:261,tls_cipher_list:261,tls_client_ca_dir:[133,175,261],tls_client_ca_fil:[133,175,261],tls_client_cert:[133,261],tls_client_kei:[133,261],tls_compress:[121,133,145],tls_eccurv:[121,133,261],tls_key_fil:[133,261],tls_prefer_server_ciph:[121,133,261],tls_prune:[137,168,174,175,188,259,260],tls_requir:[68,144,261],tls_server_ca_dir:[133,261],tls_server_ca_fil:[133,261],tls_server_cert:[133,175,261],tls_server_kei:[133,175,261],tls_session:4,tls_session_timeout:[175,261,324],tls_sessions_db:[133,174,188,261],tls_sessions_db_path:[71,133,175,188,261],tls_version:[121,133,145,261],tlscache_db:[133,261],tlscache_db_path:[133,261],tlskei:[144,285],tlsprune:[174,175,188,260],tlsv1:[58,59,60,62,63,73],tm_gmtoff:72,tmartin:336,tmp:[43,46,174,195,207,219,238,261,269,272],tmpf:[71,114,174,188,223],tmpfile:74,tocdepth:165,todai:[8,11,176,350,353],todd:263,todo:[6,27,41,205],toedtmann:73,togeth:7,token:[58,59,60,62,63,72,226,261],told:183,tom:[92,193],tomorrow:11,toni:73,tons:[44,46],too:[5,11,43,56,64,72,111,112,113,124,128,133,135,136,137,166,169,174,175,188,189,228,241],took:216,tool:[1,2,22,44,46],toolkit:345,top:[3,27,33,43,56,73,149,152,153,154,155,156,157,158,159,193,195,214,261,285],topic:[49,56,261],toplevel:[48,64,65,66,67,84,133,199,261],topolog:11,tortious:57,tos:261,total:[6,9,11,28,30,184,195,261,298],touch:[7,215,220,287],toward:[9,11,30,35,40,71,149,152,153,154,155,156,157,158,159,184,213,241],trace:[182,261],track:[6,54,72,74,81,85,92,129,188,199,250,261,288,313,315,349],tracker:341,trade:216,tradeoff:[6,252],tradit:[6,15,47,48,77,186],tradition:[3,184,193],traffic:[11,33,64,75,85,89,95,111,183,261,279,320,343],trail:[19,55,72,73,261,326],transact:[6,68,73,81,82,193,197,236,261,268,276,320],transfer:[3,7,27],transfig:[44,174],transit:[73,174,217],translat:[3,6,33,53,81,174,207,221,261,299,325],translatesiev:[33,165,174,207],transmiss:340,transmit:[5,175,197,254],transpar:[7,36,55,64,74,193,220,329,330,332,333,334,335,337,338],transport:[5,36,41,71,175,193,201,202,207,208],trap:47,trash:[19,33,41,207,211,214,222],travel:[176,350],travers:73,treat:[11,19,41,66,70,72,142,161,181,199,204,222,254,261,284],tree:[5,10,46,133,137,175,189,193,195,199,217,244,247,261,279,319],trend:73,tri:[72,113,117,137,163,175,239,244,254,315],trial:[137,138,139,161,162,163,164,171,172],trickier:[193,194],trigger:[24,27,63,75,185,203,216,222,241,261,319],trim:315,trip:[11,72],tripl:11,trivial:[175,255],trojan:284,trojita:127,troubl:[137,138,139,161,162,163,164,171,172,195,233],troubleshoot:35,truncat:[47,72,83,106,108,114,185,243,261],trust:[5,11,72,133,294],trusti:63,trycreate:72,tselina:284,tstampfil:288,ttest:27,tue:[284,298,300],tugowar:74,tune:[74,193],tupl:319,turbid:73,turn:[11,40,41,63,72,73,83,174,183,185,238,253,261,314,340],tweak:[11,72,73,177],twice:[75,120,175,222,260,320],two:[3,4,5],twoskip:4,txt:[72,74,254,261,269,336],ty347:262,type:[3,4],typedef:[52,203],typic:[5,11,27,33,36,41,48,179,182,186,188,204,216,220,241,247,260,261,264,274,276,319,320,341,355],typo:[72,73],tyq4:262,tyranni:55,tyrrel:353,tzid:6,u00fcederli:27,ubuntu:[2,54,57],ucd:73,udp4:260,udp6:260,udp:[63,74,175,209,260,289,290,292,294,303,305,306,322,323],udv:211,ufl:250,ugli:114,uhura:[33,53],uid:[5,6,27,36,41,72,97,170,171,183,193,211,235,241,261,269,274,284,298,313,319,326],uidl:[149,151,152,153,154,155,156,157,158,159,235,261],uidl_format:[149,151,152,153,154,155,156,157,158,159,261],uidnext:[27,72,185,261],uidonli:261,uidplus:[58,59,60,62,63,72,75,241,340],uidset:27,uidvalid:[235,298,315,319],uidvalidity:[27,72,112,261],uint:261,ulimit:238,ulmer:250,ultim:[5,11,133],umanitoba:73,umask:261,umbrella:57,umemoto:75,umich:92,unabl:[3,11,52,72,117,175,223,227,249],unaffect:[73,261],unanim:349,unauthent:[41,64,97,139,163,181,197],unauthenticate:114,unavail:[25,133,192,193],unavailable:[41,249,313],unbind:64,unchang:[6,133],uncom:[63,175],uncommit:[43,56],uncommon:[11,24,36,39,242],uncomplet:101,uncompress:[183,266,274],uncondition:319,unconfirmed:133,uncov:250,undelet:[116,177,179,182,208],under:[5,6,10,11,19,24,25,28,33,35,41,43,46,48,54,56,57,64,65,66,67,72,75,83,89,97,133,134,149,150,151,152,153,154,155,156,157,158,159,164,175,199,212,216,223,236,237,241],underestim:266,undergo:49,underli:[11,131,261,313],underlin:48,underneath:[41,195,205,241,313],understand:[0,11,41,73,174,175,195,236,285],understood:[11,285],undertaken:176,undesir:133,undetermin:241,undocu:81,undocument:235,undump:[75,92,128,139,163,261,267,270],unencod:95,unexpect:[11,72,117,195],unexpung:[25,81,84,117,120,211,241,259,261],unfortun:[73,185,211,292],unicod:[111,113,129],unicorn:63,unifi:4,uniform:[192,195],uniniti:72,uninitialis:166,uninterrupt:193,union:[41,75],uniqu:[3,5,6,11,27,33,47,112,193,195,216,222,260,261,298,300,313],unique:6,uniqueid:[73,79,120,169,183,274,280,313,315],uniserv:73,unit:[9,30,43,44,46,56,131,162,165,174,184,250,279,285,326],unite:354,unitialis:162,univers:[3,57,75,77,133,176,345,350,352,353,354],university:57,unix:[27,33],unix_group_en:261,unix_pwcheck:72,unixheirsep:128,unixheriarchysep:114,unixhierarchi:[33,171],unixhierarchysep:[18,33,46,63,66,73,74,75,106,120,149,153,154,155,156,157,158,159,174,175,199,207,221,245,261,273,285,325,326,341],unixhiersep:74,unknown:[162,230,285],unlabel:230,unless:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],unlik:[36,193,247],unlike:[193,222,279],unlimit:[19,28,115,130,131,142,204,238,260,261],unlink:[24,25,72],unlock:[64,147,266],unmailbox:282,unmet:355,unmodifi:74,unnecessari:266,unnecessarili:166,unord:[66,261],unpars:113,unpleas:60,unqualifi:[40,261,285],unreach:193,unread:[38,183],unrealm:33,unrecogn:280,unreport:129,unrespons:261,unseen:6,unseenmessag:[27,185,261],unselect:[58,59,60,62,63,126,261,340],unset:[261,326],unsign:[52,72],unsolicit:97,unspecifi:[72,175,266,315],unstabl:[169,224],unsubscrib:[75,261],unsubscribe:[72,193],unsuccess:[41,216],unsuit:[64,65,67,228],unsupport:[136,145,351],untag:[52,72,179],until:[8,11,25,26,47,71,77,117,130,133,174,176,183,195,204,209,230,241,260,261,266,297,320],untouch:293,unus:[41,44,183,242,252,282],unusu:73,updat:[1,6,7,12,18,36,41,42],update:[43,56,64,72,75,77,78,84,100],upgrad:[33,40,60,63,72,73,75,85,125,126,128,129,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172],upgrade:[71,72,129],upload:[43,56,74,113,164,170,195,216,261,319,336],upon:[6,9,19,30],upper:[136,349],uppercas:116,ups:11,upstream:[11,43,45,46,49,50,56,75,145,160,185,199,304,341],urandom:[248,261],urg:73,uri:[27,36,97,163,261],url:[6,56],urlauth:[6,46,58,59,60,62,63,77,111,261,340],urlfetch:[88,90,121,122,135,142,145,340],usabl:[272,276],usag:[6,9,30,35,41,73,74,77,81,84,113,116,118,127,128,133,135,165,174,183,184,195,204,205,214,216,239,241,261,278,282,285,298,312,313,319,358],usage:[4,6],use:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35],usenet:[6,41,75,175,199,261,302,340],user:[3,4],user_column:18,user_deleteacl:74,user_deni:4,user_deny_db:133,user_folder_limit:[85,280],useradd:[175,355],userdeni:[121,188,261],userdeny_db:261,userdeny_db_path:[188,261],userflags:[298,326],userid:4,userid_list:328,usermod:[175,355],usernam:[3,5,18,19,33,40,44,46,64,65,68,74,175,189,195,199,219,240,245,251,261,279,285,289,313,319,355,358],username:49,username_idx:18,username_tolow:261,userpassword:63,userprefix:[33,261],userrc:285,userspac:47,using:[18,33,36,41],usr:[43,44,46,50,71,72,127,133,162,174,175,188,195,207,211,214,215,216,217,219,226,229,238,261,265,268,270,272,289,291,319,320,355],usual:[6,11,40,41,48,62,73,164,175,179,181,183,193,207,217,222,239,241,261,291,329,330,332,333,334,335,337,338,341,355],usualli:239,uta:73,utc:[326,344],utdalla:[73,74],utf7:261,utf8:[230,261],utf8smtp:261,utf:[27,72,73,75,81,111,136,172,230,261],util:[47,57,63,64,73,74,75,79,96,97,127,133,162,166,188,189,195,199,204,207,212,214,216,239,241,261,285,301,321,326,329,330,331,332,333,334,335,337,338,351],utilis:266,utopic:63,uuid:[44,46,97,174,300],uutari:169,vacat:[6,72,73,74,75,77,114,136,207,223,225,236],vader:[222,251],vain:73,valentin:147,valgrind:[44,46,104,105,107,108],valid:[6,19,33,41,52,73,75,106,144,163,164,174,181,197,219,230,260,261,270,279,289],valu:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359],value:48,van:[136,349,353],vanilla:355,vansant:353,varchar:18,vari:[48,211],variabl:[41,44,55,66,72,73,77,130,149,156,157,158,159,163,169,207,210,227,261,266,297,340,358],variant:[41,137],varieti:[5,7,9,10,11,69],variou:[2,11,31,40,41,44,47,56,64],vast:[193,220,236],vastli:35,vavailability:[23,100,229],vcard:[6,68,160,261,340],vcard_obj:6,vcard_uid:6,vcardfast:46,velasco:[135,144],vendor:[11,64,74,77,79,92,103,175,179,182,199,228,235,261,279,319,355],ver:285,verbos:[18,48,73,107,261,266,267,271,273,274,279,284,286,293,313,314,315,319,320,321,325,326,329,330,332,333,334,335,337,338],verbose:175,veri:[5,7,11,18,28,36,43,46,47,63,72,116,120,174,175,182,183,189,193,195,199,216,224,236,239,254,261,266,270,319,350,351,353],verif:[5,41,44,63,133,183,199,215,266,270,329,330,332,333,334,335,337,338],verifi:[5,28,41,58,59,60,62,63,64,75,97,105,133],versa:[36,197,222,325],version:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42],versions:[48,133,134,140,141,142,143],vertic:36,vervet:63,verysecret:5,vevent:[23,107],vfreebusy:23,via:[6,11,15,19,28,36,40,41,44,46,47,55,64,65,66,68,70,71,73,74,75,77,82,107,112,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,181,186,188,191,193,194,195,199,201,202,204,207,211,214,216,219,222,235,255,261,268,276,284,285,304,305,313,315,319,325,328,336,341,344,355],viabil:11,viabl:253,vice:[36,197,222,325],video:39,videocharg:250,vidic:147,viehmann:85,view:[11,33,42,44,45,48,49],vim:174,violat:[47,195],virtdomain:[18,40,75,113,136,149,153,154,155,156,157,158,159,166,175,251,261,285,341],virtual:[3,6,8,11,13,18,33],virtual_destination_concurrency_limit:355,virtual_destination_recipient_limit:355,virtual_recipi:355,virtual_recipient_domain:355,virtual_recipient_map:355,virtual_transport:355,viru:27,virus:[207,284],virustest:340,visibl:[41,64,133,182,193,261,285],visit:[313,343],visual:[43,358],visudo:46,vivid:63,vjournal:23,vladimir:73,vnd:[27,185,261],volatil:10,volum:3,volunt:61,vote:349,vpath:165,vpoll:[23,100,146,229,340],vsd:250,vtimezone:[64,68],vtodo:23,vulner:[129,340],vzic:[64,108],wai:[11,12,31,40,41,47,48,56,63,72,116,125,133,169,181,182,183,184,190,192,193,195],wait:[11,15,26,55,56,64,215,260,261,264,266,289,290,292,294,297,304,305,306,315,318,320],wait_interv:320,waitev:203,walk:241,walkthrough:49,wall:[44,46],wallet:11,walter:[73,353],wamerican:174,wan:216,want:[0,5,11,18,26,33,41,43,45,46,47,48,49,50,56,57,59,60,63,64,72,133,137],wanttowrit:52,warm:250,warmuth:134,warning:[41,313],warranties:57,wasn:[72,73,75,131,183,353],wast:74,water:[72,199,288],wbreyha:115,wcw:73,web1:280,web2:280,web:[11,22,36,43,64,65,68,207,250,340,342,343],webdav:[6,64],webmast:33,webserv:36,websit:[11,43,48,56,136],wed:298,week:[39,45,241,326,349],weekend:[24,39],weekli:[45,175,344,345,357,359],weight:4,weiler:353,weird:[72,75,77,175],welcom:[0,256],well:[5,7,10,11,13,19,25,31,33,40,43,46,52,72,73,74,75,97,108,125,133,174,175,179,182,184,190,193,194,195,197,211,216,223,241],went:[72,84,174],were:[9,11,30,38,41,71,72,73,74,83,102,114,116,122,133,145,162,181,182,183,184,194,209,211,214,239,255,260,261,279,283,288,298,313,315,319,350],werewolf:63,werror:[44,46],wextra:[44,46],wget:174,what:[3,4,5],whatev:[41,72,174,175,181,183,195,249,250,261,313,341],whatsoev:57,whatsoever:57,wheaton:73,when:[3,4,5,6,8],whenev:[45,72,197,199,211,355],where:[3,5,7,11,13,26,33,36,41,44,46,57,63,64,72,73,74,75,83,84,101,102,103,106,108,112,115,126,130,162,172,174,175,182,184,186,188,190,191],where_claus:18,wherea:[183,216],wherein:191,wherev:108,whether:[3,7,38,49,52,57,63,64,68,72,73,75,77,79,95,133,173,175,179,182,184,211,216,235,261,280,285,315,319,355],which:[3,5,6,7,9,10,11,15,19,24,25,27,30,31,33,34,36,38,40,41,44,46,47,48,49,50,52,55,56,58,59,60,62,63,64,65,66,67,68,71,72,74,75,77,79,81,84,85,96,97,100,112,113,114,120,125,127,128,129,131,133,149,150,151,152,153,154,155,156,157,158,159,162,165,174,175,176,180,181,182,183,184,185,186,189,190,191,193,195,196,199,203,204,205,207,216,217,222,223],whichev:[64,84,229],whilst:279,white:353,whitespac:[19,72,73,161,195,260,261,262,302],who:[0,5,18,19,33,41,55,72,131,145],whole:[11,133,176,241,350,352],whom:[27,178],whose:[9,30,41,64,195,243,261,266,274,285,315,320,328,329,330,332,333,334,335,337,338,354],why:[11,33,46,47,55,175,223],wide:[13,44,193,209,235,255,273,352,354],widespread:352,wierd:129,wiggl:183,wiki:[45,54,261],wikidb:269,wikipedia:[46,176],wildcard:[115,277,285,313],wildmat:[6,66,199,219,261,276,288,302],wili:63,window:[11,48,74,174,340,358],wire:[5,11,68,197,261,345],wisdom:[174,226],wise:352,wish:[8,41,63,72,149,152,153,154,155,156,157,158,159,169,174,181,183,189,193,207,209,211,216,261],with_ldap:129,within:[3,5,6,11,14,15],without:[3,6,7,11,12,15,18,24,28,33,40,41,44,49,53,54,56,57,64,70,72,73,75,95,104,115,116,117,125,128,131,137,145,161,162,167,169,174,175,181,182,183,184,186,187,193,196,197,207,209,214,216,227,253,261,266,272,276,279,282,283,284,315,321,327,340,352,355],wno:[44,136],woefulli:203,wolfgang:[115,121,122,135,136,137,146,168,169],won:[15,73,116,149,154,155,156,157,158,159,182,193,194,195,204,238,251,261,315],wong:[73,353],word:[3,7,41,72,133,172,241,250,261,319,358],work:[0,1,5,11,18,33,40],workabl:183,workaround:[11,72,109,253,261],worker:261,workshop:11,world:[41,47,175,193,199,345,354],worri:355,wors:236,worst:250,worth:[7,11,49,73,133,183,344],worthwhil:57,would:[3,5,7,8,9,11,16,17,18,26,29,30,33,34,36,37,38,40,41,43,48,53,56,57,64,65,67,71,72,73,74,84,113,129,133,162,164,174,175,182,183,184,186,187,193,194,195,204,209,216,220,241,250,253,260,261,266,270,276,283,284,285,293,301,319,320,325,341,342,350,355],wrap:[80,172],wrapper:[47,72,73,169,199,232,260],writabl:[18,174,261],write:[0,3,6,7,11,13,41,43,46,47,52,56,61,64,72,73,74,115,133,176,177],write_bodi:106,writeabl:[10,207],writefil:115,written:[6,7,11,16,17,29,36,37,47,52,57,61,72,73,119,133,199,239,247,268,285,319,325,350],wrong:[43,46,56,72,116,174,261,312,328],wrote:[43,55],www:[36,40,43,45,54,56,57,133,134,135,136,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,165,166,167,168,169,170,173,175,239,261,345,355],x509:175,x86_64:[44,50,229],xapian:[6,44,46],xapian_flavor:355,xapianact:4,xapplepush:[149,151,152,153,154,155,156,157,158,159,185],xavier:[162,164],xbackup:[183,261],xbackup_en:[183,261],xcal:[108,340],xconversations:261,xconvmultisort:261,xfd:[43,56],xfer:[75,96,97,100,115,116,120,122,125,126,127,128,129,131,134,146,164,168,174,193,261,285],xfz:[43,56],xlist:[19,63,120,134,174,261,273],xmalloc:[47,52],xml2:355,xml:[27,46,117,140,261,340],xmpp:340,xpath:174,xrealloc:[47,75],xref:[9,75],xsha1:165,xsnippets:[170,261],xstrdup:52,xutil:174,xxd:44,xxx:[40,193,238],xzmalloc:47,xzvf:57,y2k:288,yacc:[72,75],yahoo:[27,185],yann:127,yapc12:133,year:[11,127,131,172,250,263,288,345,350],yet:[11,19,38,46,56,61,73,125,147,183,193,204,220,241,260,261,355],yield:183,yjh:171,yoni:353,york:340,you:[0,3,6,7,9,11,12,15,16,17,18,26,27,28,29,30,33,34,36,37,40,41,43,44,45,46,47,48,49,50,54],young:199,your_fork:49,your_username:49,yourself:[2,3],yum:[58,60,62],yyi:40,zan:172,zephyr:[72,73,305],zephyrgram:305,zero:[19,41,47,52,72,73,82,122,129,174,181,183,197,199,204,260,261,262,264,289,290,292,294,304,305,306,313,318],zhukov:[160,169,172],zlib1g:[44,174],zlib:[12,44,355],zoneinfo:4,zoneinfo_db:[64,261],zoneinfo_db_path:[64,188,261,271],zoom:344,zzz:40},titles:["We need your help","Developers","Download","Glossary","Configuration Guide","Authentication and Authorization","Databases","Deployment Scenarios","Known Protocol Limitations","Mailbox Creation Distribution","Performance Recommendations","Storage Considerations","Supported Platforms and System Requirements","Features","Access Control","Archiving","Kerberos Authentication","LDAP Authentication","SQL Authentication","Automatic Creation of Mailboxes","CalDAV Collections","CardDAV Support","DAV Collection Management","DAV Components","Delayed Delete","Delayed Expunge","Duplicate Message Delivery Suppression","Event Notifications","Mail Spool Partitions","Mailbox Annotations (METADATA)","Mailbox Distribution","Mailbox Metadata Partitions","Message Annotations (METADATA)","Mailbox Namespaces","Quota","Sealed System Design","Cyrus IMAP Murder (Server Aggregation)","Server Side Filtering (Sieve)","Shared Seen State","Single-Instance Store","Virtual Domains","Concepts","IMAP Developer Guide","Releasing new builds of ancient Cyrus IMAP versions","Compiling","Cyrus Works","Developer Test Environment","Tips for Hacking on Cyrus","Documentation","GitHub guide","Xapian for searching","Developer Libraries","<strong>imclient</strong> library","Namespaces: a developer view","Overview of Cyrus development environment","Development Process","Releasing Cyrus IMAP","Get Cyrus","CentOS","Debian","Fedora","openSUSE","Red Hat Enterprise Linux","Ubuntu","CalDAV","CardDAV","RSS Feeds","WebDAV","HTTP modules","Configuring the MTA","Virus Scanner","Notes for Packagers","Cyrus IMAP 1.x Release Notes","Cyrus IMAP 2.0.x Release Notes","Cyrus IMAP 2.1.x Release Notes","Cyrus IMAP 2.2.x Release Notes","Cyrus IMAP 2.3 Releases","Cyrus IMAP 2.3.0 Release Notes","Cyrus IMAP 2.3.1 Release Notes","Cyrus IMAP 2.3.10 Release Notes","Cyrus IMAP 2.3.11 Release Notes","Cyrus IMAP 2.3.12 Release Notes","Cyrus IMAP 2.3.13 Release Notes","Cyrus IMAP 2.3.14 Release Notes","Cyrus IMAP 2.3.15 Release Notes","Cyrus IMAP 2.3.16 Release Notes","Cyrus IMAP 2.3.17 Release Notes","Cyrus IMAP 2.3.18 Release Notes","Cyrus IMAP 2.3.19 Release Notes","Cyrus IMAP 2.3.2 Release Notes","Cyrus IMAP 2.3.20 Release Notes","Cyrus IMAP 2.3.3 Release Notes","Cyrus IMAP 2.3.4 Release Notes","Cyrus IMAP 2.3.5 Release Notes","Cyrus IMAP 2.3.6 Release Notes","Cyrus IMAP 2.3.7 Release Notes","Cyrus IMAP 2.3.8 Release Notes","Cyrus IMAP 2.3.9 Release Notes","Cyrus IMAP 2.4-caldav Releases","Cyrus IMAP 2.4.17-caldav-beta1 Release Notes","Cyrus IMAP 2.4.17-caldav-beta10 Release Notes","Cyrus IMAP 2.4.17-caldav-beta11 Release Notes","Cyrus IMAP 2.4.17-caldav-beta2 Release Notes","Cyrus IMAP 2.4.17-caldav-beta3 Release Notes","Cyrus IMAP 2.4.17-caldav-beta4 Release Notes","Cyrus IMAP 2.4.17-caldav-beta5 Release Notes","Cyrus IMAP 2.4.17-caldav-beta6 Release Notes","Cyrus IMAP 2.4.17-caldav-beta7 Release Notes","Cyrus IMAP 2.4.17-caldav-beta8 Release Notes","Cyrus IMAP 2.4.17-caldav-beta9 Release Notes","Cyrus IMAP 2.4 Releases","Cyrus IMAP 2.4.0 Release Notes","Cyrus IMAP 2.4.1 Release Notes","Cyrus IMAP 2.4.10 Release Notes","Cyrus IMAP 2.4.11 Release Notes","Cyrus IMAP 2.4.12 Release Notes","Cyrus IMAP 2.4.13 Release Notes","Cyrus IMAP 2.4.14 Release Notes","Cyrus IMAP 2.4.15 Release Notes","Cyrus IMAP 2.4.16 Release Notes","Cyrus IMAP 2.4.17 Release Notes","Cyrus IMAP 2.4.18 Release Notes","Cyrus IMAP 2.4.19 Release Notes","Cyrus IMAP 2.4.2 Release Notes","Cyrus IMAP 2.4.20 Release Notes","Cyrus IMAP 2.4.3 Release Notes","Cyrus IMAP 2.4.4 Release Notes","Cyrus IMAP 2.4.5 Release Notes","Cyrus IMAP 2.4.6 Release Notes","Cyrus IMAP 2.4.7 Release Notes","Cyrus IMAP 2.4.8 Release Notes","Cyrus IMAP 2.4.9 Release Notes","Cyrus IMAP 2.5 Releases","Cyrus IMAP 2.5.0 Release Notes","Cyrus IMAP 2.5.1 Release Notes","Cyrus IMAP 2.5.10 Release Notes","Cyrus IMAP 2.5.11 Release Notes","Cyrus IMAP 2.5.12 Release Notes","Cyrus IMAP 2.5.13 Release Notes","Cyrus IMAP 2.5.14 Release Notes","Cyrus IMAP 2.5.2 Release Notes","Cyrus IMAP 2.5.3 Release Notes","Cyrus IMAP 2.5.4 Release Notes","Cyrus IMAP 2.5.5 Release Notes","Cyrus IMAP 2.5.6 Release Notes","Cyrus IMAP 2.5.7 Release Notes","Cyrus IMAP 2.5.8 Release Notes","Cyrus IMAP 2.5.9 Release Notes","Cyrus IMAP 3.0 Releases","Cyrus IMAP 3.0.0 Release Notes","Cyrus IMAP 3.0.0 beta1 Release Notes","Cyrus IMAP 3.0.0 beta2 Release Notes","Cyrus IMAP 3.0.0 beta3 Release Notes","Cyrus IMAP 3.0.0 beta4 Release Notes","Cyrus IMAP 3.0.0 beta5 Release Notes","Cyrus IMAP 3.0.0 beta6 Release Notes","Cyrus IMAP 3.0.0 rc1 Release Notes","Cyrus IMAP 3.0.0 rc2 Release Notes","Cyrus IMAP 3.0.0 rc3 Release Notes","Cyrus IMAP 3.0.0 rc4 Release Notes","Cyrus IMAP 3.0.1 Release Notes","Cyrus IMAP 3.0.10 Release Notes","Cyrus IMAP 3.0.11 Release Notes","Cyrus IMAP 3.0.12 Release Notes","Cyrus IMAP 3.0.13 Release Notes","Cyrus IMAP 3.0.2 Release Notes","Cyrus IMAP 3.0.3 Release Notes","Cyrus IMAP 3.0.4 Release Notes","Cyrus IMAP 3.0.5 Release Notes","Cyrus IMAP 3.0.6 Release Notes","Cyrus IMAP 3.0.7 Release Notes","Cyrus IMAP 3.0.8 Release Notes","Cyrus IMAP 3.0.9 Release Notes","Release Notes","Upgrading to 3.0","Installing Cyrus","Introduction to Cyrus IMAP","Administrator Guide","Access Control","Combining Access Rights","Access Control Defaults","Access Control Identifier (ACI)","Access Control Lists Rights Reference","Cyrus Backups","Mailbox Distribution","Cyrus Event Source","File &amp; Directory Locations","Archive Partitions","Configuration file locations","Directory Hashing","Spool Directories","Search Tiers","Cyrus Murder","Cyrus Murder: Concepts","Cyrus Murder Failure Modes","Cyrus Murder: Installation and Administration","Cyrus Murder Mail Delivery","Cyrus Murder Mupdate Details","HOWTO: Using an NGINX IMAP Proxy","Cyrus NNTP","Ports and Sockets","Cyrus Service Definitions","Cyrus Socket Locations","Cyrus Prot Layer","Quotas","Quota Roots","Supported Quota Types","Cyrus Sieve","Standard Operating Procedures","Running Cyrus IMAP Services on Non-Standard Ports","Alternative Namespace","Deleting and Undeleting Messages and Folders","Mailbox Operations","Mailbox Folders exempt from quota","Reconstructing Mailboxes","Reloading Cyrus IMAP Services","Replication: Installation and Administration","Splitting Metadata from Partitions","Using Squatter for Faster IMAP SEARCH","Managing user_deny.db","Tweaking Cyrus IMAP","Tools &amp; Utilities","System Architecture","Frequently Asked Questions","Which database backend should I use for which databases?","Duplicate Delivery Suppression","Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora","Problems detecting Berkley DB on Red Hat Linux","Help! There must be an easier way to get all this going...","OpenSSL Version Mismatches","Why does Cyrus reject 8-bit characters in the headers of my messages?","Why does Cyrus reject messages with &#8220;bare newlines&#8221;?","How do I get Cyrus Sieve to play nice with Exim?","Why does mail delivery go slow or hang sometimes?","How do I view ACLs on a mailbox?","What annotations are available?","Why does ctl_cyrusdb -r take so long with Berkeley DB?","Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?","How to enable core dumps","Is the &#8220;db3: x Lockers&#8221; log message harmful?","Why can I not delete a mailbox as an admin user?","When is What ... Deleted, Expired, Expunged or Purged?","Why is deliver.db so large?","I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!","How to run gdb on Cyrus components","Cyrus delivers claims that the mailbox does not exist","Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?","Can I use MySQL (or another SQL database) as the primary mail store?","Why do POP3 connections take so long, but once the connection is established all is well?","Why does reconstruct -m not work?","Shared File Systems GPFS for high availability","How to enable telemetry","The process count keeps growing!","&#8220;unable to join environment&#8221; error","Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?","Does the Cyrus Murder support High Availability configurations?","Can I configure pop3d to log amount and size of messages fetched by user?","How can I make CyrusSieve work with public shared folders?","Can I have subfolders not appear under INBOX?","Man pages","<strong>cyrus.conf</strong>","imapd.conf","<strong>krb.equiv</strong>","<strong>arbitron</strong>","<strong>backupd</strong>","<strong>chk_cyrus</strong>","<strong>ctl_backups</strong>","<strong>ctl_conversationsdb</strong>","<strong>ctl_cyrusdb</strong>","<strong>ctl_deliver</strong>","<strong>ctl_mboxlist</strong>","<strong>ctl_zoneinfo</strong>","<strong>cvt_cyrusdb</strong>","<strong>cvt_xlist_specialuse</strong>","<strong>cyr_backup</strong>","<strong>cyr_buildinfo</strong>","<strong>cyr_dbtool</strong>","<strong>cyr_deny</strong>","<strong>cyr_df</strong>","<strong>cyr_expire</strong>","<strong>cyr_info</strong>","<strong>cyr_sequence</strong>","<strong>cyr_synclog</strong>","<strong>cyr_userseen</strong>","<strong>cyr_virusscan</strong>","<strong>cyradm</strong>","<strong>cyrdump</strong>","<strong>deliver</strong>","<strong>fetchnews</strong>","<strong>fud</strong>","<strong>httpd</strong>","<strong>idled</strong>","<strong>imapd</strong>","<strong>ipurge</strong>","<strong>lmtpd</strong>","<strong>lmtpproxyd</strong>","<strong>masssievec</strong>","<strong>master</strong>","<strong>mbexamine</strong>","<strong>mbpath</strong>","<strong>mbtool</strong>","<strong>mkimap</strong>","<strong>mknewsgroups</strong>","<strong>mupdate</strong>","<strong>nntpd</strong>","<strong>notifyd</strong>","<strong>pop3d</strong>","<strong>pop3proxyd</strong>","<strong>proxyd</strong>","<strong>ptdump</strong>","<strong>ptexpire</strong>","<strong>ptloader</strong>","<strong>quota</strong>","<strong>reconstruct</strong>","<strong>rehash</strong>","<strong>restore</strong>","<strong>sievec</strong>","<strong>sieved</strong>","<strong>smmapd</strong>","<strong>squatter</strong>","<strong>sync_client</strong>","<strong>sync_reset</strong>","<strong>sync_server</strong>","<strong>timsieved</strong>","<strong>tls_prune</strong>","<strong>translatesieve</strong>","<strong>unexpunge</strong>","<strong>arbitronsort.pl</strong>","<strong>dav_reconstruct</strong>","<strong>httptest</strong>","<strong>imtest</strong>","<strong>installsieve</strong>","<strong>lmtptest</strong>","<strong>mupdatetest</strong>","<strong>nntptest</strong>","<strong>pop3test</strong>","<strong>sieveshell</strong>","<strong>sivtest</strong>","<strong>smtptest</strong>","<strong>synctest</strong>","RFCs Supported by Cyrus IMAP","Reporting Bugs","IRC Chat","Mailing Lists","Online Meetings","What is Cyrus IMAP?","Operations","Overview","About Cyrus","Cyrus Bylaws","Cyrus History","Cyrus Roadmap","About Cyrus","Who Is Cyrus","Preface","Quickstart Guide","Setup","Sitemap","Document Conventions","Support/Community"],titleterms:{"case":[9,30,36,184,246],"default":[12,41,44,71,133,149,153,154,155,156,157,158,159,180,190,191],"delete":197,"export":195,"function":47,"long":[236,248],"new":[6,41,43,71,121,133,144,171,172,174,199],"public":257,"switch":[133,210],"true":193,"try":243,about:[45,64,66,68,70,183,226,348,352,354],access:[6,14,33,41,64,65,67,178,179,180,181,182,185,260],account:49,aci:[41,181],acl:[41,179,180,234],aclchang:27,activate:197,actual:184,add:49,adding:[45,195],addit:195,addition:[50,190,195],address:[40,254],addressbook:65,addressbookprefix:65,admin:240,administr:[33,40,41,64,65,67,177,180,183,195,216],again:194,aggreg:7,aggregat:[36,41],all:[179,228,248],allocat:47,allow:133,allowplaintext:68,also:[52,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,276,277,278,279,280,282,283,284,285,287,288,289,290,291,292,293,294,296,297,298,299,300,301,303,304,305,306,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,329,330,331,332,333,334,335,337,338],altern:[41,181,210],alternat:44,altnamespac:33,amount:256,analysi:193,ancient:43,ani:174,annot:[6,235],annotat:[6,29,32,133],anonym:[41,181],anoth:247,anyon:[41,181],api:203,appear:258,append:179,appendic:193,appendix:193,apple:185,applepushservic:27,applicat:[11,184],apt:355,arbitron:[221,263],arbitronsort:[221,327],architectur:[177,183,193,195,216,222],archive:[15,186,187,343],arguments:285,articl:199,asked:223,assumption:193,atom:197,authent:[5,13,16,17,18,41,44,68,175,193,285,355],authenticate:197,author:[5,41,47,181,285,336],autoconf:133,autocr:[19,64,133],autom:19,automat:19,avail:[194,235,250],availabl:[9,11,27,30,184,255],back:195,backend:[9,30,36,133,184,193,195,197,224],background:358,backup:[6,174,183,195],backupd:264,bad:197,balanc:193,bare:231,basic:33,befor:55,begin:55,behavior:[41,204],benefit:193,berkelei:236,berklei:227,beta10:100,beta11:101,beta1:[99,150],beta2:[102,151],beta3:[103,152],beta4:[104,153],beta5:[105,154],beta6:[106,155],beta7:107,beta8:108,beta9:109,between:195,bit:230,blow:194,board:349,bold:358,buffer:11,bug:[52,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172,289,341],bugfix:[149,150,151,152,153,154,155,156,157,158,159],build:[12,43,44,48,57,139,163,164],bylaw:349,cach:[6,174],calcul:41,caldav:[6,20,44,64,98,99,100,101,102,103,104,105,106,107,108,109,133],caldav_allowschedul:64,calendar:[13,64],calendaralarm:27,calendarprefix:64,callout:133,can:[133,240,247,256,257,258],capac:11,carddav:[6,21,44,65,133,175],cassandan:46,catchal:133,centos:58,certif:175,chain:216,chang:[41,55,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,195,209,349],channel:[216,222],charact:230,chat:342,chdir:285,check:[44,175],child:252,chk_cyru:[221,265],claim:245,clamav:70,clean:252,client:[5,40,193,199,241,289],cmd:133,code:55,collect:[13,20,22],combin:179,come:[193,355],command:[197,259,285],commands:285,common:223,commun:[55,175,355,359],compil:[44,50,185,226],complet:[174,214,355],compon:[12,23,54,175,244],compress:216,comput:9,concept:[40,41,193],conf:[71,133,144,222,260,261],config:[64,174,175],configdirectori:[175,237,355],configur:[4,18,24,25,40,41,46,50,64,65,66,67,68,69,70,71,121,133,149,153,154,155,156,157,158,159,171,172,174,185,188,195,199,207,216,243,255,256,259,297,355],connect:[248,252],consider:[11,216],contact:[13,196],content:[43,56,183,207],context:211,contributor:353,control:[14,15,41,64,65,67,178,180,181,182,199,201,202,204,260],convent:[48,358],converg:9,convers:6,convert:204,copi:174,copy:193,core:[238,349,353],cost:11,count:252,counter:6,creat:[18,41,49,175,180],createmailbox:285,creation:[9,19],cross:43,ctl_backup:[183,266],ctl_conversationsdb:267,ctl_cyrusdb:[221,236,268],ctl_deliv:[221,269],ctl_mboxlist:[221,270],ctl_zoneinfo:271,cvt_cyrusdb:[221,272],cvt_cyrusdb_al:221,cvt_xlist_specialus:273,cyr_backup:[183,274],cyr_buildinfo:275,cyr_dbtool:[221,276],cyr_deni:277,cyr_df:[221,278],cyr_expir:[221,279],cyr_info:280,cyr_sequ:[221,281],cyr_synclog:[221,282],cyr_userseen:[221,283],cyr_virusscan:[221,284],cyradm:[134,144,199,285],cyrdump:[221,286],cyru:[6,7,8,12,18,24,25,30,36,41,43,44,45,46,47,50,54,56,57,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,183,185,192,193,194,195,196,197,199,201,202,203,207,209,215,220,222,230,231,232,244,245,254,255,260,340,345,348,349,350,351,352,353,354,355],cyrusman:48,cyrussiev:257,daemon:[244,260],data:[9,11,162,174,184,197],databas:[6,10,18,42,44,133,174,188,193,195,197,204,224,247],dav:[6,13,22,23],dav_reconstruct:328,davdriveprefix:67,db3:239,debian:[59,145],debug:46,defin:[15,199],definit:[193,201,211],delai:[24,25],delet:[24,179,211,240,241],delete_mod:133,deleteaclmailbox:285,deletemailbox:285,deliv:[6,40,195,242,245,287],deliveri:[6,26,41,175,193,196,225,233,355],depend:[44,50,135,136,137,147,160,165,172],deploy:7,descript:[15,52,260,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,286,287,288,289,290,291,292,293,294,296,297,298,299,300,301,302,303,304,305,306,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,337,338],description:[261,285,336],descriptions:261,design:35,detail:197,detect:227,determin:212,develop:[1,42,44,46,51,53,54,55,133,173,349],devic:[9,30],differ:183,digest:343,directori:[41,175,186,188,189,190,214],disconnect:285,discret:[7,36],discretionari:178,disk:11,displai:66,distribut:[9,30,57,64,133,184,195,220],dns:193,document:[48,133,358],doe:[133,230,231,233,236,245,249,254,255],domain:40,down:174,download:2,draft:340,due:246,dump:238,duplic:[6,26,41,225],earlier:351,easi:194,easier:228,email:[175,199],enabl:[12,15,238,251],end:[68,195],engineer:349,enhanc:209,enhancement:133,enterpris:62,environ:[7,46,54,175,253],ephemer:[71,175,188],equal:[9,30,184],equiv:262,erratum:166,error:[226,253],establish:248,etc:[71,183],event:[27,133,185,203],events:260,everyon:183,everyth:18,exampl:[27,30,33,48,52,184,260,262,263,264,265,266,267,268,269,270,271,272,273,274,276,277,278,279,280,281,282,283,284,287,290,291,292,293,294,298,299,300,301,303,306,312,313,315,318,319,320,322,323,326,327,329,330,332,333,334,335,337,338],exclude:30,exclus:184,exclusion:[9,184],exempt:213,exim:232,exist:[174,245],exit:285,experi:243,experiment:169,expire:[199,211,241],expung:[25,241],expunge_mod:133,extend:133,extens:207,external:57,facil:41,failov:216,failur:[193,194],faster:218,featur:[13,71,133,169,174,179,223,345,355],fedora:[60,226],feed:[66,199],fetch:256,fetchnew:[6,221,288],field:261,file:[6,41,42,47,48,71,174,175,183,186,188,193,220,222,250,259,262,263,264,266,267,268,269,270,271,272,273,274,276,277,278,279,280,282,283,284,287,288,289,290,291,292,293,294,297,298,299,300,303,304,305,306,309,310,311,312,313,314,315,318,319,320,321,322,323,324,326],filesystem:[10,71,237],filter:[37,41],find:[193,197],fit:[9,30,184],fix:[133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,160,161,162,163,164,165,166,167,168,169,170,171,172],flag:241,flagsclear:27,flagsset:27,flat:6,folder:[11,19,133,207,211,213,214,241,257],footprint:133,fork:49,format:[44,133,197],found:246,freebusi:64,freez:243,frequent:223,from:[57,174,175,183,195,213,217,254,355],front:195,frontend:[9,30,184,193],fud:289,further:199,futur:[193,351],gdb:244,gener:[11,68,70,218],get:[42,57,228,232,355],git:57,github:[48,49,55],global:209,glossari:3,gotcha:195,govern:349,gpfs:250,greater:133,group:[175,183,349,355],groupwar:11,grow:252,guid:[4,42,49,177,355],guidelin:184,hack:47,hang:233,happen:[9,30,184,193,194],hard:194,harm:239,hash:189,hat:[62,226,227],have:[194,243,258],header:230,help:[0,228,285],high:[222,250,255,351],histori:[264,266,267,271,273,274,277,279,280,282,284,290,313,315,319,320,331,350],host:[7,133],how:[45,174,232,234,238,244,251,257],howto:198,http:68,httpd:[68,290],httpmodul:68,httptest:329,hub:54,idempot:216,identifi:[41,181],idl:291,idled:12,ietf:340,iii:349,imap4:352,imap:[7,8,12,24,25,30,36,41,42,43,56,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,176,183,193,198,209,215,218,220,241,340,345,352],imap_current_stable_vers:48,imapd:[71,144,222,243,261,292],imapfe:199,imaptest:46,imclient:52,impact:133,implement:[8,193],implicit:[41,180],imtest:330,inbox:258,includ:133,incom:246,index:[6,133,218],individu:[182,214,353],info:285,inform:[68,199],informat:[30,55],initial:[41,180,183,197],instal:355,install:[46,57,174,175,207,355],installat:[174,183,195,216,223],installsiev:331,instanc:[39,41],integrat:11,interoper:223,introduct:[43,176,183,207],invocat:218,invoke:222,ipurg:293,irc:342,ischedul:64,iscsi:11,issue:[49,162],italic:358,item:[174,184],join:253,just:209,keep:[195,252],kei:[6,49],kerbero:[16,41,181],keyword:52,known:8,krb5:226,krb:262,kssl:226,languag:41,larg:242,launch:[175,355],layer:203,ldap:17,ldap_tls_:133,level:[11,222,351],libic:229,librari:[51,52],libtool:133,licens:57,limit:[8,19,183],line:285,link:56,linux:[62,209,226,227],lirstw:179,list:[6,41,48,51,55,66,182,193,197,266,343],listaclmailbox:285,listmailbox:285,listquota:285,listquotaroot:285,lmdb:6,lmtp:[41,133],lmtp_catchall_mailbox:133,lmtp_fuzzy_mailbox_match:133,lmtpd:294,lmtpproxyd:295,lmtptest:332,load:[13,183,193],local:[41,196],locat:[186,188,190,191,202],lock:[8,47,183,237,266],locker:239,log:[41,222,239,243,256],login:[27,41,133],logout:[27,197],longer:252,loss:162,lrsip:179,lrsp:179,lrswipkxtecd:179,lrswipkxtecda:179,lrxte:179,lun:11,macro:179,mail:[28,40,41,44,48,55,175,186,193,195,196,207,220,233,246,247,254,343,355],mailbox:[5,6,8,9,13,18,19,29,30,31,33,41,66,133,180,184,193,195,196,197,211,212,213,214,234,240,245,246],mailboxcr:27,mailboxdelet:27,mailboxrenam:27,mailboxsubscrib:27,mailboxunsubscrib:27,major:[149,150,151,152,153,154,155,156,157,158,159],make:[55,257],man:[48,259],manag:[13,22,177,207,219],manual:216,map_fre:47,map_refresh:47,masssievec:[221,296],master:[71,194,195,197,216,297],maximum:252,mbexamin:[221,298],mboxconfig:285,mboxkei:6,mbpath:[221,299],mbtool:300,meet:344,memcpi:47,memori:[47,133],messag:[13,26,32,41,199,211,230,231,239,241,256],messageappend:27,messagecopi:27,messageexpir:27,messageexpung:27,messagemov:27,messagenew:27,messageread:27,messagetrash:27,metadata:[29,31,32,133,179,186,190,217,220],methods:305,mime:352,miscellan:133,mismatch:229,mixe:246,mkimap:[221,301],mknewsgroup:[221,302],mode:[9,30,33,184,193,194,216,266,274,315],modul:[47,68],monitor:[41,204],mono:358,most:[9,30,184],move:[183,195,241],mta:[69,175,355],multi:7,multipath:11,multipl:[40,183,243],multiplex:193,mupdat:[194,196,197,303],mupdate:[193,195],mupdatetest:333,murder:[7,9,12,30,36,41,44,133,146,174,192,193,194,195,196,197,222,255],must:228,mysql:[18,247],name:[133,191,193,285,336],namelock:133,namespac:[33,53,210],need:0,neg:41,network:47,newli:[41,180],newlin:231,newsgroup:199,nfs:11,nginx:198,nice:232,nntp:199,nntpd:304,nntptest:334,non:[209,358],none:179,noop:197,note:[11,43,56,71,72,73,74,75,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,104,105,106,107,108,109,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,297,358],notes:[285,287],notif:[27,41,133],notification:305,notifyd:305,now:183,numer:[41,206],occasion:243,off:33,older:173,onc:248,one:183,onli:44,online:344,openssl:229,opensuse:61,operat:[193,208,212,216,220,223,346],option:[64,121,133,144,171,172,185,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,286,287,288,289,290,291,292,293,294,296,297,298,299,300,301,302,303,304,305,306,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,328,329,330,331,332,333,334,335,337,338],optional:[12,44,175],options:336,other:[33,41,44,47,135,136,137,146,147,160,163,165,166,167,168,169,180,183,216],outgo:207,over:41,overview:[6,48,54,174,185,193,199,347,355],owner:[41,180],packag:[57,71,355],page:[48,259],pam:18,pam_mysql:18,particip:[55,197],particular:183,partit:[9,28,30,31,41,133,183,186,187,190,191,217,220],past:353,patch:[48,55,145],path:133,per:188,perform:[10,11,15],period:216,person:33,phabric:133,place:174,plai:232,plaintext:41,plan:174,platform:12,point:[9,30],pollin:43,pop3:[8,41,248],pop3d:[256,306],pop3proxyd:307,pop3test:335,pop:193,port:[175,200,201,209,355],post:[179,199],postfix:355,pre:[18,43,54,56],predefin:71,prefac:354,prepar:[174,175],prerequisit:[43,56],primari:247,problem:[223,227],proc:[41,237],procedur:208,process:[36,55,252,349],product:173,program:71,proport:358,prot:203,protocol:[8,11,41,175,355],provis:67,provok:183,proxi:[7,198],proxyd:308,ptdump:309,ptexpir:310,ptloader:311,pts:6,ptscach:6,pull:[48,49,183,199,358],purg:241,purpos:[15,71],push:[183,185,195,199],put:237,queri:196,question:223,quick:[40,355],quickstart:355,quot:358,quota:[6,19,34,41,133,204,205,206,213,312],quotachang:27,quotaexce:27,quotalegaci:6,quotawithin:27,rc1:156,rc2:157,rc3:158,rc4:159,read:[179,199],readahead:11,rebuild:46,recommend:[10,12],reconstruct:[41,174,214,249,285,313],recov:[194,214],recoveri:[41,194],red:[62,226,227],reduc:183,redund:11,refer:[182,355],references:336,referr:193,rehash:[221,314],reject:[230,231,246],releas:[42,43,56,57,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,349],reload:215,remov:41,renam:41,renamemailbox:285,repair:[41,204],replic:[7,11,12,36,44,174,183,216,222],replica:216,report:341,repositori:49,represent:184,request:[48,49,223],requir:[12,44,50,183,195,216],requisit:[18,54],reserve:197,reset:[9,30,184],resourc:42,respons:[197,254],restor:[183,315],restrict:[28,133],retent:11,reus:252,rfc:[48,133,340],right:[41,179,180,182,183],roadmap:[349,351],roll:[183,216],root:[41,205],rss:66,rss_feed:66,rss_feedlist_templ:66,rule:45,run:[46,175,209,244],safe:237,same:[9,30,184],sampl:[41,71],sasl:[18,44,175,345,355],saslauthd:18,scalabl:11,scan:70,scanner:70,scenario:[7,30],schedul:183,script:[19,207],seal:35,search:[6,50,186,191,218],secret:41,section:[71,260],secur:[13,138,139,145,161,163,164,166,209],see:[52,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,276,277,278,279,280,282,283,284,285,287,288,289,290,291,292,293,294,296,297,298,299,300,301,303,304,305,306,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,329,330,331,332,333,334,335,337,338],seen:[6,38],select:[9,30,41,133,184],send:175,sender:254,sendmail:[40,175,355],seri:[149,151,152,153,154,155,156,157,158,159,173],server:[7,18,36,37,41,183,193,195,196,197,207,216,285],serverlist_select_soft_usage_limit:184,servic:[64,71,185,201,209,215,244],services:[243,260],set:[19,44,71,175,195,254,355],setaclmailbox:285,setinfo:285,setmetadata:133,setquota:285,setup:[183,199,355,356],share:[7,11,33,38,41,133,207,250,257],should:224,shut:174,side:37,siev:[12,19,37,41,207,232,317],sievec:316,sieveshel:336,signific:[149,150,151,152,153,154,155,156,157,158,159],sinc:[134,135,136,137,138,139,140,141,142,143,144,145,146,147,149,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172],singl:[7,39,41],sitemap:357,sivtest:337,size:[212,256],skiplist:6,slave:197,slow:233,smmapd:318,smtp:352,smtptest:338,socket:[200,201,202],softwar:12,sometim:233,soon:355,sourc:[54,57,185],space:358,special:[9,30,48,174,184,207],specif:[68,174],specifi:41,sphinx:133,split:217,spool:[28,186,190,214,220],sql:[6,18,247],squat:6,squatter:[218,319],ssh:49,ssl:[121,145,175],stabl:173,stacktrac:46,standard:[196,208,209],start:[40,42,174,260],startup:36,state:[6,38,188],status:6,statuscach:6,storag:[6,11,13,28,41,67,175,183,206,220],store:[39,41,247],string:197,strlcpy:47,strncpy:47,structur:18,style:55,sub:[6,133],subfold:258,submit:48,subscrib:[285,343],subscript:[6,19,41,193],suck:199,summari:193,support:[12,21,41,50,68,70,133,173,206,207,255,340,359],suppress:[26,41,225],sync:[195,216],sync_client:320,sync_reset:321,sync_serv:322,synchron:[197,220],synctest:339,synopsi:[48,52,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,286,287,288,289,290,291,292,293,294,296,297,298,299,300,301,302,303,304,305,306,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,337,338],synopsis:[285,336],syslog:[41,175],system:[12,35,42,222,250,259],tag:[48,56],take:[236,248],tape:183,tarbal:[57,174],target:133,telemetri:251,temporari:[10,71],termin:216,terminolog:[195,211,216],test:[18,43,45,46,54,56,175,207],thi:[133,228],through:[9,48,55],tier:[11,28,191,220],time:[64,175],timsiev:323,tip:[46,47],tls:6,tls_:133,tls_prune:324,tls_session:6,tmpf:237,togeth:18,tool:[48,54,57,183,207,221],topolog:[36,133],tradit:199,transfer:41,translatesiev:[221,325],transport:216,trash:241,trick:46,troubleshoot:[175,195],tweak:[216,220],two:[9,30,184],twoskip:[6,133],type:[6,41,133,185,186,206],typograph:358,tzdist:64,ubuntu:63,unabl:253,unavail:194,undefin:133,undelet:211,under:258,underscor:133,undohash:221,unexpung:326,unifi:[7,36],unix:[41,181],unsubscrib:[285,343],updat:[43,48,174],update:[149,153,154,155,156,157,158,159,197],upgrad:174,upgrade:[133,174],upon:41,url:64,usage:[9,30,184],use:[36,57,355],used:28,useful:55,user:[5,6,11,19,33,41,68,133,175,183,188,240,241,256,259,355],user_deni:[6,219],userid:6,using:[48,55,183,198,199,218,220],utiliti:221,vacat:254,variou:71,verifi:174,version:[43,56,173,229,285,352],view:[53,234],virtual:40,viru:70,volum:11,wai:[196,228],want:174,warn:[41,358],webdav:67,weight:9,well:248,what:[9,30,40,64,174,176,183,184,193,194,235,241,244,345,352],when:[9,30,41,184,193,194,241,243],where:[193,241],which:224,white:358,who:[174,353],why:[230,231,233,236,240,242,246,248,249,254],wishlist:340,within:[18,193],work:[41,45,186,249,257],write:[179,207],xapian:50,xapianact:6,xfermailbox:285,you:[55,174],your:[0,49,175,355],yourself:57,zone:64,zoneinfo:[6,64]}})
\ No newline at end of file
+Search.setIndex({envversion:49,filenames:["contribute","developers","download","glossary","imap/concepts/deployment","imap/concepts/deployment/authentication_and_authorization","imap/concepts/deployment/databases","imap/concepts/deployment/deployment_scenarios","imap/concepts/deployment/known_protocol_limitations","imap/concepts/deployment/mailbox_creation_distribution","imap/concepts/deployment/performance_recommendations","imap/concepts/deployment/storage","imap/concepts/deployment/supported-platforms","imap/concepts/features","imap/concepts/features/access-control","imap/concepts/features/archiving","imap/concepts/features/authentication-kerberos","imap/concepts/features/authentication-ldap","imap/concepts/features/authentication-sql","imap/concepts/features/automatic-creation-of-mailboxes","imap/concepts/features/caldav-collections","imap/concepts/features/carddav","imap/concepts/features/dav-collection-mgmt","imap/concepts/features/dav-components","imap/concepts/features/delayed-delete","imap/concepts/features/delayed-expunge","imap/concepts/features/duplicate-message-delivery-suppression","imap/concepts/features/event-notifications","imap/concepts/features/mail-spool-partitions","imap/concepts/features/mailbox-annotations","imap/concepts/features/mailbox-distribution","imap/concepts/features/mailbox-metadata-partitions","imap/concepts/features/message-annotations","imap/concepts/features/namespaces","imap/concepts/features/quota","imap/concepts/features/sealed-system","imap/concepts/features/server-aggregation","imap/concepts/features/server-side-filtering","imap/concepts/features/shared-seen-state","imap/concepts/features/single-instance-store","imap/concepts/features/virtual-domains","imap/concepts/overview_and_concepts","imap/developer","imap/developer/API","imap/developer/API/cyrusdb","imap/developer/API/cyrusdb2","imap/developer/API/index-api","imap/developer/API/mailbox-api","imap/developer/ancient-releasing","imap/developer/compiling","imap/developer/cyrusworks","imap/developer/developer-testing","imap/developer/documentation","imap/developer/github-guide","imap/developer/guidance","imap/developer/guidance/hacking","imap/developer/guidance/internationalization","imap/developer/guidance/locking","imap/developer/guidance/mailbox-format","imap/developer/guidance/namelocks","imap/developer/guidance/prot","imap/developer/guidance/replication_examples","imap/developer/guidance/replication_protocol","imap/developer/guidance/special_chars","imap/developer/guidance/var_directory_structure","imap/developer/install-xapian","imap/developer/jmap","imap/developer/libraries","imap/developer/libraries/imclient","imap/developer/namespaces","imap/developer/overview","imap/developer/process","imap/developer/releasing","imap/developer/thoughts","imap/developer/thoughts/backup","imap/developer/thoughts/bytecode","imap/developer/thoughts/caldav_scheduling_flowchart","imap/developer/thoughts/improved_mboxlist_sort","imap/developer/thoughts/notes","imap/developer/thoughts/prot-events","imap/developer/unit-tests","imap/download/getcyrus","imap/download/installation/distributions/centos","imap/download/installation/distributions/debian","imap/download/installation/distributions/fedora","imap/download/installation/distributions/opensuse","imap/download/installation/distributions/rhel","imap/download/installation/distributions/ubuntu","imap/download/installation/http/caldav","imap/download/installation/http/carddav","imap/download/installation/http/jmap","imap/download/installation/http/rss","imap/download/installation/http/webdav","imap/download/installation/manage-dav","imap/download/installation/mta/configuration","imap/download/installation/virus","imap/download/packagers","imap/download/release-notes/1/1.x.x","imap/download/release-notes/2.0/2.0.x","imap/download/release-notes/2.1/2.1.x","imap/download/release-notes/2.2/2.2.x","imap/download/release-notes/2.3/index","imap/download/release-notes/2.3/x/2.3.0","imap/download/release-notes/2.3/x/2.3.1","imap/download/release-notes/2.3/x/2.3.10","imap/download/release-notes/2.3/x/2.3.11","imap/download/release-notes/2.3/x/2.3.12","imap/download/release-notes/2.3/x/2.3.13","imap/download/release-notes/2.3/x/2.3.14","imap/download/release-notes/2.3/x/2.3.15","imap/download/release-notes/2.3/x/2.3.16","imap/download/release-notes/2.3/x/2.3.17","imap/download/release-notes/2.3/x/2.3.18","imap/download/release-notes/2.3/x/2.3.19","imap/download/release-notes/2.3/x/2.3.2","imap/download/release-notes/2.3/x/2.3.20","imap/download/release-notes/2.3/x/2.3.3","imap/download/release-notes/2.3/x/2.3.4","imap/download/release-notes/2.3/x/2.3.5","imap/download/release-notes/2.3/x/2.3.6","imap/download/release-notes/2.3/x/2.3.7","imap/download/release-notes/2.3/x/2.3.8","imap/download/release-notes/2.3/x/2.3.9","imap/download/release-notes/2.4-dav/index","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8","imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9","imap/download/release-notes/2.4/index","imap/download/release-notes/2.4/x/2.4.0","imap/download/release-notes/2.4/x/2.4.1","imap/download/release-notes/2.4/x/2.4.10","imap/download/release-notes/2.4/x/2.4.11","imap/download/release-notes/2.4/x/2.4.12","imap/download/release-notes/2.4/x/2.4.13","imap/download/release-notes/2.4/x/2.4.14","imap/download/release-notes/2.4/x/2.4.15","imap/download/release-notes/2.4/x/2.4.16","imap/download/release-notes/2.4/x/2.4.17","imap/download/release-notes/2.4/x/2.4.18","imap/download/release-notes/2.4/x/2.4.19","imap/download/release-notes/2.4/x/2.4.2","imap/download/release-notes/2.4/x/2.4.20","imap/download/release-notes/2.4/x/2.4.3","imap/download/release-notes/2.4/x/2.4.4","imap/download/release-notes/2.4/x/2.4.5","imap/download/release-notes/2.4/x/2.4.6","imap/download/release-notes/2.4/x/2.4.7","imap/download/release-notes/2.4/x/2.4.8","imap/download/release-notes/2.4/x/2.4.9","imap/download/release-notes/2.5/index","imap/download/release-notes/2.5/x/2.5.0","imap/download/release-notes/2.5/x/2.5.1","imap/download/release-notes/2.5/x/2.5.10","imap/download/release-notes/2.5/x/2.5.11","imap/download/release-notes/2.5/x/2.5.12","imap/download/release-notes/2.5/x/2.5.13","imap/download/release-notes/2.5/x/2.5.15","imap/download/release-notes/2.5/x/2.5.2","imap/download/release-notes/2.5/x/2.5.3","imap/download/release-notes/2.5/x/2.5.4","imap/download/release-notes/2.5/x/2.5.5","imap/download/release-notes/2.5/x/2.5.6","imap/download/release-notes/2.5/x/2.5.7","imap/download/release-notes/2.5/x/2.5.8","imap/download/release-notes/2.5/x/2.5.9","imap/download/release-notes/3.0/index","imap/download/release-notes/3.0/x/3.0.0","imap/download/release-notes/3.0/x/3.0.0-beta1","imap/download/release-notes/3.0/x/3.0.0-beta2","imap/download/release-notes/3.0/x/3.0.0-beta3","imap/download/release-notes/3.0/x/3.0.0-beta4","imap/download/release-notes/3.0/x/3.0.0-beta5","imap/download/release-notes/3.0/x/3.0.0-beta6","imap/download/release-notes/3.0/x/3.0.0-rc1","imap/download/release-notes/3.0/x/3.0.0-rc2","imap/download/release-notes/3.0/x/3.0.0-rc3","imap/download/release-notes/3.0/x/3.0.0-rc4","imap/download/release-notes/3.0/x/3.0.1","imap/download/release-notes/3.0/x/3.0.10","imap/download/release-notes/3.0/x/3.0.11","imap/download/release-notes/3.0/x/3.0.12","imap/download/release-notes/3.0/x/3.0.13","imap/download/release-notes/3.0/x/3.0.2","imap/download/release-notes/3.0/x/3.0.3","imap/download/release-notes/3.0/x/3.0.4","imap/download/release-notes/3.0/x/3.0.5","imap/download/release-notes/3.0/x/3.0.6","imap/download/release-notes/3.0/x/3.0.7","imap/download/release-notes/3.0/x/3.0.8","imap/download/release-notes/3.0/x/3.0.9","imap/download/release-notes/3.1/index","imap/download/release-notes/3.1/x/3.1.0-dev","imap/download/release-notes/3.1/x/3.1.1","imap/download/release-notes/3.1/x/3.1.2","imap/download/release-notes/3.1/x/3.1.3","imap/download/release-notes/3.1/x/3.1.4","imap/download/release-notes/3.1/x/3.1.5","imap/download/release-notes/3.1/x/3.1.6","imap/download/release-notes/3.1/x/3.1.7","imap/download/release-notes/3.1/x/3.1.8","imap/download/release-notes/3.1/x/3.1.9","imap/download/release-notes/3.2/index","imap/download/release-notes/3.2/x/3.2.0","imap/download/release-notes/3.2/x/3.2.0-beta1","imap/download/release-notes/3.2/x/3.2.0-beta2","imap/download/release-notes/3.2/x/3.2.0-beta3","imap/download/release-notes/3.2/x/3.2.0-beta4","imap/download/release-notes/3.2/x/3.2.0-rc1","imap/download/release-notes/index","imap/download/upgrade","imap/installing","imap/quickstart/introduction","imap/reference/admin","imap/reference/admin/access-control","imap/reference/admin/access-control/combining-rights","imap/reference/admin/access-control/defaults","imap/reference/admin/access-control/identifiers","imap/reference/admin/access-control/rights-reference","imap/reference/admin/backups","imap/reference/admin/config-mailboxdistribution","imap/reference/admin/eventsource","imap/reference/admin/locations","imap/reference/admin/locations/archive-partitions","imap/reference/admin/locations/configuration-state","imap/reference/admin/locations/hashing","imap/reference/admin/locations/mailspool","imap/reference/admin/locations/searchtiers","imap/reference/admin/monitoring","imap/reference/admin/murder/murder","imap/reference/admin/murder/murder-concepts","imap/reference/admin/murder/murder-failure-modes","imap/reference/admin/murder/murder-installation","imap/reference/admin/murder/murder-mail-delivery","imap/reference/admin/murder/murder-mupdate-details","imap/reference/admin/nginx-proxy","imap/reference/admin/nntp","imap/reference/admin/ports-sockets","imap/reference/admin/ports/services","imap/reference/admin/ports/sockets","imap/reference/admin/protlayer","imap/reference/admin/quotas","imap/reference/admin/quotas/quotaroots","imap/reference/admin/quotas/quotatypes","imap/reference/admin/sieve","imap/reference/admin/sop","imap/reference/admin/sop/administration-running","imap/reference/admin/sop/altnamespace","imap/reference/admin/sop/deleting","imap/reference/admin/sop/mailbox-operations","imap/reference/admin/sop/mailbox-quota","imap/reference/admin/sop/reconstructing","imap/reference/admin/sop/reloading","imap/reference/admin/sop/replication","imap/reference/admin/sop/splitting-metadata","imap/reference/admin/sop/squatter","imap/reference/admin/sop/userdeny","imap/reference/admin/tweaking","imap/reference/architecture","imap/reference/faq","imap/reference/faqs/feature-database-backend","imap/reference/faqs/feature-duplicate-delivery","imap/reference/faqs/install-compilationerrors","imap/reference/faqs/install-install-help","imap/reference/faqs/install-linkerwarnings","imap/reference/faqs/interop-8bit","imap/reference/faqs/interop-barenewlines","imap/reference/faqs/interop-sieve-exim","imap/reference/faqs/interop-slow-delivery","imap/reference/faqs/o-acls","imap/reference/faqs/o-annotations","imap/reference/faqs/o-configdir-tempfs","imap/reference/faqs/o-coredump","imap/reference/faqs/o-delete-mailbox","imap/reference/faqs/o-deleted-expired-expunged-purged","imap/reference/faqs/o-deliverdb-size","imap/reference/faqs/o-freezes","imap/reference/faqs/o-gdb","imap/reference/faqs/o-mailbox-doesnotexist","imap/reference/faqs/o-mixedcase","imap/reference/faqs/o-otherdatabases","imap/reference/faqs/o-pop3slow","imap/reference/faqs/o-reconstruct","imap/reference/faqs/o-sharedfilesystem-gpfs","imap/reference/faqs/o-telemetry","imap/reference/faqs/o-toomanyprocesses","imap/reference/faqs/o-unable-join-environment","imap/reference/faqs/o-vacation-mailfrom","imap/reference/faqs/r-murder-ha","imap/reference/faqs/r-pop3-logging","imap/reference/faqs/r-publicssharedfolders","imap/reference/faqs/r-subfolders","imap/reference/manpages/commands","imap/reference/manpages/configs/cyrus.conf","imap/reference/manpages/configs/imapd.conf","imap/reference/manpages/configs/krb.equiv","imap/reference/manpages/systemcommands/arbitron","imap/reference/manpages/systemcommands/backupd","imap/reference/manpages/systemcommands/chk_cyrus","imap/reference/manpages/systemcommands/ctl_backups","imap/reference/manpages/systemcommands/ctl_conversationsdb","imap/reference/manpages/systemcommands/ctl_cyrusdb","imap/reference/manpages/systemcommands/ctl_deliver","imap/reference/manpages/systemcommands/ctl_mboxlist","imap/reference/manpages/systemcommands/ctl_zoneinfo","imap/reference/manpages/systemcommands/cvt_cyrusdb","imap/reference/manpages/systemcommands/cvt_xlist_specialuse","imap/reference/manpages/systemcommands/cyr_backup","imap/reference/manpages/systemcommands/cyr_buildinfo","imap/reference/manpages/systemcommands/cyr_dbtool","imap/reference/manpages/systemcommands/cyr_deny","imap/reference/manpages/systemcommands/cyr_df","imap/reference/manpages/systemcommands/cyr_expire","imap/reference/manpages/systemcommands/cyr_info","imap/reference/manpages/systemcommands/cyr_sequence","imap/reference/manpages/systemcommands/cyr_synclog","imap/reference/manpages/systemcommands/cyr_userseen","imap/reference/manpages/systemcommands/cyr_virusscan","imap/reference/manpages/systemcommands/cyradm","imap/reference/manpages/systemcommands/cyrdump","imap/reference/manpages/systemcommands/deliver","imap/reference/manpages/systemcommands/fetchnews","imap/reference/manpages/systemcommands/fud","imap/reference/manpages/systemcommands/httpd","imap/reference/manpages/systemcommands/idled","imap/reference/manpages/systemcommands/imapd","imap/reference/manpages/systemcommands/ipurge","imap/reference/manpages/systemcommands/lmtpd","imap/reference/manpages/systemcommands/lmtpproxyd","imap/reference/manpages/systemcommands/masssievec","imap/reference/manpages/systemcommands/master","imap/reference/manpages/systemcommands/mbexamine","imap/reference/manpages/systemcommands/mbpath","imap/reference/manpages/systemcommands/mbtool","imap/reference/manpages/systemcommands/mkimap","imap/reference/manpages/systemcommands/mknewsgroups","imap/reference/manpages/systemcommands/mupdate","imap/reference/manpages/systemcommands/nntpd","imap/reference/manpages/systemcommands/notifyd","imap/reference/manpages/systemcommands/pop3d","imap/reference/manpages/systemcommands/pop3proxyd","imap/reference/manpages/systemcommands/proxyd","imap/reference/manpages/systemcommands/ptdump","imap/reference/manpages/systemcommands/ptexpire","imap/reference/manpages/systemcommands/ptloader","imap/reference/manpages/systemcommands/quota","imap/reference/manpages/systemcommands/reconstruct","imap/reference/manpages/systemcommands/rehash","imap/reference/manpages/systemcommands/restore","imap/reference/manpages/systemcommands/sievec","imap/reference/manpages/systemcommands/sieved","imap/reference/manpages/systemcommands/smmapd","imap/reference/manpages/systemcommands/squatter","imap/reference/manpages/systemcommands/sync_client","imap/reference/manpages/systemcommands/sync_reset","imap/reference/manpages/systemcommands/sync_server","imap/reference/manpages/systemcommands/timsieved","imap/reference/manpages/systemcommands/tls_prune","imap/reference/manpages/systemcommands/translatesieve","imap/reference/manpages/systemcommands/unexpunge","imap/reference/manpages/usercommands/arbitronsort.pl","imap/reference/manpages/usercommands/dav_reconstruct","imap/reference/manpages/usercommands/httptest","imap/reference/manpages/usercommands/imtest","imap/reference/manpages/usercommands/installsieve","imap/reference/manpages/usercommands/lmtptest","imap/reference/manpages/usercommands/mupdatetest","imap/reference/manpages/usercommands/nntptest","imap/reference/manpages/usercommands/pop3test","imap/reference/manpages/usercommands/sieveshell","imap/reference/manpages/usercommands/sivtest","imap/reference/manpages/usercommands/smtptest","imap/reference/manpages/usercommands/synctest","imap/rfc-support","imap/support/feedback-bugs","imap/support/feedback-irc","imap/support/feedback-mailing-lists","imap/support/feedback-meetings","index","operations","overview","overview/about_cyrus","overview/cyrus_bylaws","overview/cyrus_history","overview/cyrus_roadmap","overview/what_is_cyrus","overview/who_is_cyrus","preface","quickstart","setup","sitemap","styles","support"],objects:{"":{"-A":[368,0,1,"cmdoption-dav_reconstruct-A"],"-C":[368,0,1,"cmdoption-dav_reconstruct-C"],"-D":[358,0,1,"cmdoption-smmapd-D"],"-E":[350,0,1,"cmdoption-ptexpire-E"],"-F":[360,0,1,"cmdoption-sync_client-F"],"-G":[353,0,1,"cmdoption-reconstruct-G"],"-I":[379,0,1,"cmdoption-imtest-I"],"-J":[352,0,1,"cmdoption-quota-J"],"-L":[360,0,1,"cmdoption-sync_client-L"],"-M":[355,0,1,"cmdoption-restore-M"],"-N":[359,0,1,"cmdoption-squatter-N"],"-O":[360,0,1,"cmdoption-sync_client-O"],"-P":[359,0,1,"cmdoption-squatter-P"],"-R":[359,0,1,"cmdoption-squatter-R"],"-S":[360,0,1,"cmdoption-sync_client-S"],"-T":[359,0,1,"cmdoption-squatter-T"],"-U":[359,0,1,"cmdoption-squatter-U"],"-V":[353,0,1,"cmdoption-reconstruct-V"],"-X":[379,0,1,"cmdoption-imtest-X"],"-Z":[359,0,1,"cmdoption-squatter-Z"],"-a":[379,0,1,"cmdoption-imtest-a"],"-b":[333,0,1,"cmdoption-ipurge-b"],"-c":[379,0,1,"cmdoption-imtest-c"],"-d":[371,0,1,"cmdoption-installsieve-d"],"-f":[379,0,1,"cmdoption-imtest-f"],"-g":[371,0,1,"cmdoption-installsieve-g"],"-h":[359,0,1,"cmdoption-squatter-h"],"-i":[379,0,1,"cmdoption-imtest-i"],"-j":[337,0,1,"cmdoption-master-j"],"-k":[379,0,1,"cmdoption-imtest-k"],"-l":[379,0,1,"cmdoption-imtest-l"],"-m":[379,0,1,"cmdoption-imtest-m"],"-n":[379,0,1,"cmdoption-imtest-n"],"-o":[379,0,1,"cmdoption-imtest-o"],"-p":[379,0,1,"cmdoption-imtest-p"],"-q":[379,0,1,"cmdoption-imtest-q"],"-r":[379,0,1,"cmdoption-imtest-r"],"-s":[379,0,1,"cmdoption-imtest-s"],"-t":[379,0,1,"cmdoption-imtest-t"],"-u":[379,0,1,"cmdoption-imtest-u"],"-v":[379,0,1,"cmdoption-imtest-v"],"-w":[379,0,1,"cmdoption-imtest-w"],"-x":[379,0,1,"cmdoption-imtest-x"],"-y":[328,0,1,"cmdoption-fetchnews-y"],"-z":[379,0,1,"cmdoption-imtest-z"],"arbitron(8)":[303,1,1,"std:cyrusman-arbitron(8)"],"backupd(8)":[304,1,1,"std:cyrusman-backupd(8)"],"chk_cyrus(8)":[305,1,1,"std:cyrusman-chk_cyrus(8)"],"conf-all":[320,0,1,"cmdoption-arg-conf-all"],"conf-default":[320,0,1,"cmdoption-arg-conf-default"],"conf-lint":[320,0,1,"cmdoption-arg-conf-lint"],"config-file":[341,0,1,"cmdoption-mkimap-arg-config-file"],"ctl_backups(8)":[306,1,1,"std:cyrusman-ctl_backups(8)"],"ctl_conversationsdb(8)":[307,1,1,"std:cyrusman-ctl_conversationsdb(8)"],"ctl_cyrusdb(8)":[308,1,1,"std:cyrusman-ctl_cyrusdb(8)"],"ctl_deliver(8)":[309,1,1,"std:cyrusman-ctl_deliver(8)"],"ctl_mboxlist(8)":[310,1,1,"std:cyrusman-ctl_mboxlist(8)"],"ctl_zoneinfo(8)":[311,1,1,"std:cyrusman-ctl_zoneinfo(8)"],"cvt_cyrusdb(8)":[312,1,1,"std:cyrusman-cvt_cyrusdb(8)"],"cvt_xlist_specialuse(8)":[313,1,1,"std:cyrusman-cvt_xlist_specialuse(8)"],"cyr_backup(8)":[314,1,1,"std:cyrusman-cyr_backup(8)"],"cyr_buildinfo(8)":[315,1,1,"std:cyrusman-cyr_buildinfo(8)"],"cyr_dbtool(8)":[316,1,1,"std:cyrusman-cyr_dbtool(8)"],"cyr_deny(8)":[317,1,1,"std:cyrusman-cyr_deny(8)"],"cyr_df(8)":[318,1,1,"std:cyrusman-cyr_df(8)"],"cyr_expire(8)":[319,1,1,"std:cyrusman-cyr_expire(8)"],"cyr_info(8)":[320,1,1,"std:cyrusman-cyr_info(8)"],"cyr_sequence(8)":[321,1,1,"std:cyrusman-cyr_sequence(8)"],"cyr_synclog(8)":[322,1,1,"std:cyrusman-cyr_synclog(8)"],"cyr_userseen(8)":[323,1,1,"std:cyrusman-cyr_userseen(8)"],"cyr_virusscan(8)":[324,1,1,"std:cyrusman-cyr_virusscan(8)"],"cyradm(8)":[325,1,1,"std:cyrusman-cyradm(8)"],"cyrdump(8)":[326,1,1,"std:cyrusman-cyrdump(8)"],"dav_reconstruct(1)":[368,1,1,"std:cyrusman-dav_reconstruct(1)"],"deliver(8)":[327,1,1,"std:cyrusman-deliver(8)"],"fetchnews(8)":[328,1,1,"std:cyrusman-fetchnews(8)"],"fud(8)":[329,1,1,"std:cyrusman-fud(8)"],"httpd(8)":[330,1,1,"std:cyrusman-httpd(8)"],"httptest(1)":[369,1,1,"std:cyrusman-httptest(1)"],"idled(8)":[331,1,1,"std:cyrusman-idled(8)"],"imapd(8)":[332,1,1,"std:cyrusman-imapd(8)"],"imclient(3)":[68,1,1,"std:cyrusman-imclient(3)"],"imtest(1)":[370,1,1,"std:cyrusman-imtest(1)"],"installsieve(1)":[371,1,1,"std:cyrusman-installsieve(1)"],"ipurge(8)":[333,1,1,"std:cyrusman-ipurge(8)"],"lmtpd(8)":[334,1,1,"std:cyrusman-lmtpd(8)"],"lmtpproxyd(8)":[335,1,1,"std:cyrusman-lmtpproxyd(8)"],"lmtptest(1)":[372,1,1,"std:cyrusman-lmtptest(1)"],"mailbox-spec":[352,0,1,"cmdoption-quota-arg-mailbox-spec"],"masssievec(8)":[336,1,1,"std:cyrusman-masssievec(8)"],"master(8)":[337,1,1,"std:cyrusman-master(8)"],"mbexamine(8)":[338,1,1,"std:cyrusman-mbexamine(8)"],"mbpath(8)":[339,1,1,"std:cyrusman-mbpath(8)"],"mbtool(8)":[340,1,1,"std:cyrusman-mbtool(8)"],"mkimap(8)":[341,1,1,"std:cyrusman-mkimap(8)"],"mknewsgroups(8)":[342,1,1,"std:cyrusman-mknewsgroups(8)"],"mupdate(8)":[343,1,1,"std:cyrusman-mupdate(8)"],"mupdatetest(1)":[373,1,1,"std:cyrusman-mupdatetest(1)"],"nntpd(8)":[344,1,1,"std:cyrusman-nntpd(8)"],"nntptest(1)":[374,1,1,"std:cyrusman-nntptest(1)"],"notifyd(8)":[345,1,1,"std:cyrusman-notifyd(8)"],"pop3d(8)":[346,1,1,"std:cyrusman-pop3d(8)"],"pop3proxyd(8)":[347,1,1,"std:cyrusman-pop3proxyd(8)"],"pop3test(1)":[375,1,1,"std:cyrusman-pop3test(1)"],"proxyd(8)":[348,1,1,"std:cyrusman-proxyd(8)"],"ptdump(8)":[349,1,1,"std:cyrusman-ptdump(8)"],"ptexpire(8)":[350,1,1,"std:cyrusman-ptexpire(8)"],"ptloader(8)":[351,1,1,"std:cyrusman-ptloader(8)"],"quota(8)":[352,1,1,"std:cyrusman-quota(8)"],"reconstruct(8)":[353,1,1,"std:cyrusman-reconstruct(8)"],"rehash(8)":[354,1,1,"std:cyrusman-rehash(8)"],"restore(8)":[355,1,1,"std:cyrusman-restore(8)"],"sievec(8)":[356,1,1,"std:cyrusman-sievec(8)"],"sieved(8)":[357,1,1,"std:cyrusman-sieved(8)"],"sieveshell(1)":[376,1,1,"std:cyrusman-sieveshell(1)"],"sivtest(1)":[377,1,1,"std:cyrusman-sivtest(1)"],"smmapd(8)":[358,1,1,"std:cyrusman-smmapd(8)"],"smtptest(1)":[378,1,1,"std:cyrusman-smtptest(1)"],"squatter(8)":[359,1,1,"std:cyrusman-squatter(8)"],"sync_client(8)":[360,1,1,"std:cyrusman-sync_client(8)"],"sync_reset(8)":[361,1,1,"std:cyrusman-sync_reset(8)"],"sync_server(8)":[362,1,1,"std:cyrusman-sync_server(8)"],"synctest(1)":[379,1,1,"std:cyrusman-synctest(1)"],"timsieved(8)":[363,1,1,"std:cyrusman-timsieved(8)"],"tls_prune(8)":[364,1,1,"std:cyrusman-tls_prune(8)"],"translatesieve(8)":[365,1,1,"std:cyrusman-translatesieve(8)"],"unexpunge(8)":[366,1,1,"std:cyrusman-unexpunge(8)"],compact:[306,0,1,"cmdoption-ctl_backups-arg-compact"],compress:[321,0,1,"cmdoption-cyr_sequence-arg-compress"],conf:[320,0,1,"cmdoption-arg-conf"],create:[321,0,1,"cmdoption-cyr_sequence-arg-create"],dump:[314,0,1,"cmdoption-arg-dump"],format:[315,0,1,"cmdoption-cyr_buildinfo-arg-format"],imapd:[354,0,1,"cmdoption-rehash-arg-imapd"],ismember:[321,0,1,"cmdoption-cyr_sequence-arg-ismember"],join:[321,0,1,"cmdoption-cyr_sequence-arg-join"],json:[314,0,1,"cmdoption-arg-json"],list:[314,0,1,"cmdoption-arg-list"],lock:[306,0,1,"cmdoption-ctl_backups-arg-lock"],members:[321,0,1,"cmdoption-cyr_sequence-arg-members"],parsed:[321,0,1,"cmdoption-cyr_sequence-arg-parsed"],proc:[320,0,1,"cmdoption-arg-proc"],reindex:[306,0,1,"cmdoption-ctl_backups-arg-reindex"],show:[314,0,1,"cmdoption-arg-show"],stat:[306,0,1,"cmdoption-ctl_backups-arg-stat"],userid_list:[368,0,1,"cmdoption-dav_reconstruct-arg-userid_list"],verify:[306,0,1,"cmdoption-ctl_backups-arg-verify"]},arbitronsort:{"pl(1)":[367,1,1,"std:cyrusman-arbitronsort.pl(1)"]},cyrus:{"conf(5)":[300,1,1,"std:cyrusman-cyrus.conf(5)"]},imapd:{"conf(5)":[301,1,1,"std:cyrusman-imapd.conf(5)"]},krb:{"equiv(5)":[302,1,1,"std:cyrusman-krb.equiv(5)"]}},objnames:{"0":["std","option","option"],"1":["std","cyrusman","cyrusman"]},objtypes:{"0":"std:option","1":"std:cyrusman"},terms:{"0101003f4c56b00545000000":61,"0101003f4c56b04b2900000d":61,"0101003f4c56b0514900001f":61,"0101003f4c56b07422000002":61,"0101003f4c56b07e56000023":61,"0101003f4c56b08328000016":61,"0101003f4c56b084d7000002":61,"0101003f4c56b087f3000001":61,"0101003f4c56b08c9d000026":61,"03ff":56,"0cee599b1573110fee428f8323690cbcb9589661":74,"0x0":80,"0x4066cc":80,"0x406806":80,"0x40c059":80,"0x4399d8":80,"0x44a0ca":80,"0x44a2f8":80,"0x4c2815c":80,"0x61b32a9":80,"0x61b36ed":80,"0x61b3827":80,"0x72d7748e":80,"1000gb":227,"1000gib":[9,227],"100gb":227,"100gib":9,"100mb":46,"10m":301,"10mb":301,"10t16":27,"110gib":9,"1234abcd":18,"128k":301,"12a62f123451395dc7d52518ae8e8c75571c9876":338,"152f59c":191,"19011213t204552z":301,"1c7cca361502dfed2d918da97e506f1c1e97dfb":74,"1gb":301,"1h30m":301,"1mb":[15,301],"1st":56,"1tb":290,"2000gib":[9,227],"200gib":[9,227],"2013h":[88,311],"20151119t063000z":27,"20151119t073000z":27,"20151119t083000z":27,"20380119t031407z":301,"20t11":27,"20t13":27,"23t14":27,"23t18":27,"24h":[301,366],"255f37ffc2e7":27,"2c_thoma":27,"2gb":[185,189],"2ghz":290,"2nd":56,"30gb":227,"30gib":9,"30m":301,"32625b552aa1":66,"32bit":58,"32m":301,"3829c6087dac":366,"39gmt":44,"3ab4f8d5512e33b1":338,"3d9f02135bf964ff0b6a917921b862c3420e48f0":74,"3rd":[56,301],"400gb":227,"400gib":9,"41d7":309,"41z":27,"45m":301,"49ba20f5":27,"4aa62f540d81395dc7d52518ae8e8c75571c8f11":338,"4d5c6b7a":255,"4d88af31":255,"4d88af34":255,"4d88af35":255,"4d9618acd0aea6b33683766358351459":27,"4gb":290,"4ghz":290,"4rev1":380,"4xx":301,"500gib":9,"512d":301,"53c4137":191,"5571a7bc1bc865":309,"5a6":97,"5d9e4f44":66,"5edadcf":191,"5meg":392,"600gb":227,"600gib":9,"60m":301,"640e232e3877":66,"64bit":[142,190],"6836d0110252d08a0656c14c2d2d314124755491":74,"69bdb40dac9de4d17057a5245c34544f2d6849db":338,"6aa93fd583f143dde555184d508ab0916e06b026":338,"6b98205c796c6c61":61,"700gib":[9,227],"70gb":227,"70gib":9,"739232245980a3efe3df490841221a4b7bac4f27":338,"7b64ec321457715ee61fe238f178f5d72adaef64":74,"7bit":[27,366],"7c76ec2b":66,"7df9":66,"7f6f384c3f5ba99a":61,"80gib":9,"80k":290,"8bit":[27,138,301,380],"8bitmime":98,"8gb":290,"8th":97,"900gib":[9,227],"90d":301,"90d104346ef3cba9e419461dd26045035f4cba02":74,"90m":301,"95349cd5d1cf21b55e6e0930b2ee5754f977ba8c":366,"9bd8":66,"\u00f8yvind":393,"\u0434\u0438\u043b\u044f\u043d":[161,186,187,188,189,190,197,207,208,210,211,212,213,214,215],"\u043f\u0430\u043b\u0430\u0443\u0437\u043e\u0432":[161,186,187,188,189,190,197,207,208,210,211,212,213,214,215],"abstract":[44,55],"boolean":[68,277,301],"break":[40,44,45,59,74,80,97,140,141,143,144,156,162,170,171,186,198,200,201,202,203,204,205,206,207,208,216,226,251,274,301,310],"byte":[6,46,52,56,58,59,62,74,75,80,97,100,113,142,152,154,301,333,338,353],"case":[0,4,5,7],"catch":[36,74,97,384],"class":[41,56,80,229,237,250,301,390,398],"default":[0,1,2,3,4,5,6,7,8,9,10,11],"enum":[75,80],"export":[41,65,98,131,218],"final":[3,6,11,15,25,41,47,51,56,58,62,75,80,104,122,145,152,156,217,218,225,251,270,279,301,390,392,398],"float":[301,319],"function":[7,11,12,18,19,36,40,44,45,47,49,50,52],"go\u0142\u0119biowski":197,"goto":[55,56,76],"h\u00e5vard":301,"import":[3,11,74,77,78,91,98,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,226,237,260,300,301,353,381,392,398],"jes\u00fa":156,"kundr\u00e1t":152,"long":[9,30,33,36,41,47,55,68,74,80,97,106,138,149,152,154,158,162,191,194,217,226,227,260,266,272,281],"new":[1,4],"null":[3,6,11,18,33,41,44,45,46,47,55,59,60,62,66,68,74,75,79,97,98,113,142,160,174,176,177,178,179,180,181,182,183,184,218,224,231,247,294,301,345],"ond\u0159ej":[170,393],"public":[41,48,56,72,88,89,92,266],"return":[5,27,41,44,45,46,47,52,55,56,59,60,61,63,68,74,75,76,79,80,88,89,92,97,98,99,109,132,133,139,140,143,159,161,162,197,206,207,208,210,211,212,213,214,215,218,225,237,239,241,247,248,301,321,325,327,368,380,398],"short":[7,11,44,52,57],"static":[3,36,44,68,80,93,97,98,301],"super":[35,55,58,150,217,392],"sur\u00fd":[170,393],"switch":[11,41,56,68,97,98,99,100,145],"true":[7,18,40,44,45,47,66,75,87,97,196,218,222],"try":[40,44,47,55,56,59,64,71,72,74,97,158,198,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,216,218,226,237,239,251,260,263,266,269,273],"var":[1,11,28,40,51,54],"void":35,"while":[5,9,10,11,19,27,28,33,36,40,41,44,45,47,49,52,55,56,57,58,59,60,66,68,70,72,74,84,93,99,109,158,187,217,225,226,228,229,231,237,239,241,247,253,261,262,264,265,271,281,283,285,290,292,300,301,306,313,325,359],_abort:74,_admin:41,_config:80,_d9aa3c2dd73a9166113254d4ebe07bc8:27,_end:74,_hash:80,_initi:80,_mech:301,_min:80,_name_:55,_part:80,_registri:80,_start:74,_sync_authnam:226,_sync_host:226,_sync_password:226,_sync_port:226,_sync_repeat_interv:226,_tls_:100,_userid:80,_usermbox:80,_xxxxxx:74,a001:237,a002:237,a01:[82,83,84,86,87],a0e716087dac:366,a4bf5bbb9feaa271:27,a5677cfa1f5f7b627763652f4bb9b99f5970748c:74,a665:66,a777:225,a8486f5db6ec207de9b9f069850546e:27,aaa:80,abandon:100,abbrevi:325,abc:52,abil:[7,11,19,35,38,40,41,93,97,98,99,164,189,236,237,239,243,265,289,301],abiliti:142,abl:[3,11,18,19,33,36,40,44,47,52,74,80,82,83,84,86,87,88,110,132,217,218,225,237,239,255,260,281,301,337,382],abnf:380,abnorm:279,abomin:44,abort:[44,45,74,97,98,108,237,279,301,355,360],about:[0,1,3,5,6,7,11,15,36,40,41],abov:[15,18,40,41,47,51,56,58,74,75,77,81,84,87,92,154,158,159,206,207,208,210,211,212,213,214,215,218,227,229,230,231,233,239,243,251,255,258,290,300,310,324,325,366,395,398],above:237,absenc:389,absolut:[9,28,30,55,72,74,88,100,158,227,231,235,248,301],abus:[41,310],acapmbox:98,acapsiev:98,accent:56,accept:[11,44,45,66,74,97,98,99,100,122,133,134,142,159,161,174,176,177,178,179,180,181,182,183,184,194,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,237,241,243,251,260,272,301,304,315,321,325,327,330,332,334,335,343,344,345,346,347,348,351,358,359,363,389,392,395],access:[3,4,5],accid:361,accident:[24,25,281,290,355,366],accommod:237,accompani:[15,230],accomplish:[41,150,219,229,237,243,290,294,390],accord:[9,30,74,91,210,213,214,215,226,227,229,234,239,287,301,306,314,324,355,389],accordingli:[74,100,243,301],account:[10,11,18,19,27,35,40,41,51],accountid:[27,66],accur:[11,47,158],achaemenid:51,achiev:[11,28,217,244,260,290,301],aci:14,ack:292,acknowledg:[58,81],acl:[6,27,36],aclright:27,acls:140,aclsubject:27,acm:301,acquir:[88,97,122],across:[8,11,12,13,36,41,44,51,55,57,59,74,98,100,106,150,162,190,196,223,226,236,237,239,241,265,290,301,392],act:[41,44,93,158,224,237,260,301,323,343,392],actdiag:52,action:[19,27,33,41,44,45],activ:[6,11,18,33,41,44,56,60,61,74,79,81,86,99,171,175,176,177,178,179,180,181,182,183,184,190,226,237,241,247,251,260,270,301,337,342,359,371,376,385,393],activate:239,actual:[3,5,7,9,11,15,19,26,28,30,33,41,44,47,56,58,62,72,74,75,80,97,106,141,154,156,158,174,178,179,180,181,182,183,184,206,207,208,210,211,212,213,214,215,218,225,226],actualli:[56,74,323],adam:197,adapt:[3,96],adapter:[3,11],add:[18,40,44,45,48,49,51],added:[97,99,100,102,104,105,106,107,109,110,114,115,117,120,121,122,124,125,126,129,130,131,132,133,134,136,150,154,174,176,177,178,179,180,181,182,183,184,188,301],addflag:75,adding:1,addit:[3,5,6,7,9,11,12,31,41,49,52,53,55,56,57,59,65,74,75,81,90,96,98,109,158,174,175,176,177,178,179,180,181,182,183,184,217,218,223,226,228,229,230,231,232,233,234,237],addition:[11,19,36,41],addr:75,address:[3,4,5,6,11,18,19,22,33,36],addressbook:22,addsub:108,addus:51,adher:[286,294],adjac:[56,74,301],adjust:[11,41],adkin:[98,293],adkinss:[98,293],admin:[33,40,41,87,88,93,98,99,100,104,110,133,158,159,186,189,191,207,208,210,211,212,213,214,215,218,222,223,226,235,239,251,260,265,266,277],administ:[33,35,40,41,222,223,225,325],administr:[3,7,11,13,15,24,25],admissibl:301,admit:[225,325],adopt:[19,394],adv:255,advanc:[9,30,227,390],advantag:[6,7,10,13,96,98,99,235,237,301,359,392],advers:74,advertis:[88,93,97,154,217,237,301],advis:[41,52,353],aea7:27,aege:141,aes256:[82,83,84,86,87],af11:301,af12:301,af13:301,af21:301,af22:301,af23:301,af31:301,af32:301,af33:301,af41:301,af42:301,af43:301,afek:393,affect:[19,33,46,49,53,72,74,97,98,150,187,191,210,211,212,213,214,215,217,226,260,268,275,288,290,292,298,301,307,324,353,359],aforement:[8,11,36,158],afs:[41,97,99,150,224,237,301,351],afskrb:301,afspt:100,afspts:301,afspts_localrealm:301,afspts_mycel:301,after:[3,8,9,11,19,24,26,30,33,41,44,45,47,49,55,56,57,60,66,68,72,74,77,80,96,97,105,107,108,109,117,139,150,152,158,160,172,217,225,226,227,237,238,239,241,243,247,251,255,258,259,264,277,280,281,290,301,306,307,308,320,325,353,359,360,369,370,372,373,375,377,378,379,390,394],afterward:[44,45],again:[11,36,41,44,45,47,48,58,61,72,74,79,87,97,98,99,100,104,141,145,156,174,175,176,177,178,179,180,181,182,183,184,190,210,211,212,213,214,215,217,218,226,230,233,234,236],against:[5,11,41,52,56,64,70,72,74,76,82,83,84,86,87,97,115,139,158,170,218,228,237,241,250,251,271,281,293,301],age:333,agent:[3,41,76,128,218,237,265,286,337,392],agentx:[98,337],aggreg:4,aggregat:[13,19],aggress:159,agnost:[11,44,45,66,90],ago:[152,255,281],agre:55,agreement:272,ahead:[11,47,72,79,241,301],ahh:74,ahv:217,aid:[4,56,96,98,108,239,305,313,341],aim:[55,66,90,158],aix:290,aka:[158,226],akio:[139,140],ala:74,alain:98,alarm:[27,174,175,176,177,178,179,180,181,182,183,184,185,228],alarmrecipi:27,alarmtim:27,albert:100,alec:140,alert:[41,97,100,277,301,325,332,348],alexei:[389,393],algorithm:[56,74,97,104,232,301],alia:[5,6,210,214,215,302,325],alias:[5,6,40,146,301,325],align:[55,58,75,97,104,122],alik:11,aliv:[74,129,292,301,384],alive:380,all:[0,3,5,6,7,8,9,11,12,13,18,19,24,25,27,30,31,33,35,36,38,40,41,44,45,46,47,49,51,52,55,56,57,58,61,62,68,71,72,74,75],allberi:[98,325],alldai:27,alloc:[11,44,55,56,80,98,218,395],allof:100,allow:[3,5,7,8,9,11,13,15,18,19,24,25,27,30,33,34,35,36,40,41,44,45,46,47,49,55,56,58,60,62,68,69,74,75,88,89,90,91,92,93,97,98,99,100,102,104,105,106,108,109,110,114,122,131,133,139,141,146,150,154,155,156],allowallsubscrib:[7,225,239,301],allowanonymouslogin:[41,301],allowapop:[288,301],allowdelet:[207,208,210,211,212,213,214,215,301],allownewnew:[243,301,344],allowplaintext:41,allowsetacl:301,allowusermov:[74,100,301],allprop:131,almost:[48,99,218,258,290,301,353],alon:[7,11,120,227,230,290,395],along:[41,66,71,74,133,217,219,225,237,390],alongsid:[6,226],alpha:72,alphabet:[12,55,229,237,300],alphanumer:[18,229,233,241,301],alpine:106,alreadi:[5,11,12,18,19,26,38,41,44,45,46,47,49,53,57,59,71,74,80,88,90,93,96,97,99,158,189,217,218,226,237,239,248,301,306,307,316,325,355,359,365,371,392,395],also:[3,5,6,7,9,11,15,18,19,25,27,28,30,31,33,36,40,41,44,45,46,48,49,50,51,52,53,55,56,58,59,65],alt:[243,301,342,398],alt_config:[44,45,74,368],altconfig:[312,321,356],alter:[18,74,88,260,265,286,300,319,323,355],altern:[9,11],although:[5,11,237,301,327],altogeth:19,altprefix:301,alumni:393,alwai:[11,33,41,44,45,47,51,55,56,57,58,59,74,80,97,99,100,108,109,130,141,151,152,159,217,218,223,232,239,248,260,265,271,300,301,354,360],always:69,alwaystru:218,amalgam:72,amavisd:27,ambigu:225,amend:18,american:303,amo:[98,99],among:[3,9,30,97,158,237,304,341],amongst:394,amount:[9,11,18,24,25,27,28,30,34,58,75,97,98,100,102,106,122,158,217,227,237,240,248,266,287,292],ams:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],amssync:97,analysi:236,ancient:42,andjelkov:98,andrew:[68,81,97,141,219,237,239,255,383,392,394],andrewmailsystem:390,andrewproject:390,andy:302,anew:353,angular:301,ani:[3,5,7,11,12,15,25,27,33,35,40,41,44,45,46,47,48,52,53,55,56,57,58,59,60,61,62,66,68,72,74,76,80,81,82,83,84,86,87,93,95,96,97,98,99,100,102,109,114,164,174,176,177,178,179,180,181,182,183,184,189,210,211,212,213,214,215],ann:226,annatotor:301,annoi:[11,97,98,332,348],annot:4,annotat:4,annotate:[380,391],annotatemor:277,annotatemore:[82,83,84,86,87,99,100,158,171],annotatemsg:41,annotation:[41,250,325,352],annotation_allow_undefin:[158,301],annotation_callout:[158,301],annotation_callout_disable_append:301,annotation_db:[44,45,158,301],annotation_db_path:[231,301],annotation_definit:[110,301],annotation_enable_legacy_command:[205,206,207,208,210,211,212,213,214,215,301],annotations_definit:301,announc:[33,48,72,171,383],annoy:56,anonymis:74,anonymous:[98,251,301],anoth:[0,11,33,36,38,40,47,55,56,58,74,80,87,99,158,217,228,237,251,260,266],another:[5,56,237,272,293],ansi:97,answer:[7,61,218,296,301,393],answere:[58,338],anthoni:[189,197],anticipatori:11,antiqu:55,antispam:385,antiviru:[174,175,176,177,178,179,180,181,182,183,184,324,385],any:[41,44,45,56,58,81,88,93,96,224,237,251,260,265,301,304,330,332,337,344,346,348,353,359,362,368],anybodi:[58,72,97],anymor:[239,301],anyof:100,anyon:[5,19,35],anyoneuseracl:301,anysievefold:[164,189,301],anyth:[11,47,48,51,70,72,74,97,217,222,258,319,320,325,332,348],anywai:[44,74,97,226,301],anywher:[44,45,58],apach:93,apart:109,api:[1,6],apop:[288,301],app:55,appar:[56,187,237,332,348],appear:[9,11,22,30,33,48,56,58,66,75,76,91,97,99,134,218,225,226,227,237,239,243,260,266,270,275,286,294],append:[3,24,33,41],append_addseen:97,append_check:286,appenddat:58,appendic:236,appl:[88,228,301],apple:[27,88,174,176,177,178,179,180,181,182,183,184,220],appli:[11,19,27,28,33,35,41,50,52,53,55,59,66,72,74,109,170,224,225,227,237,249,251,258,259,260,261,265,272,281,285,301,306,307,319,398],applianc:11,applic:[3,5,8,11,36,55,60,66,80,97,100,158,219,239,244,247,254,260,281,288,293,294,308,381,385,392,398],application:27,apply:[51,74,355],appoint:11,apprais:237,appraiser:99,appreci:[11,141,211,212,213,214,215,226,381,393],approach:[11,55,59,237,260,290,398],appropri:[9,11,18,36,41,47,48,52,55,58,72,74,80,97,106,131,218,226,228,237,260,271,280,294,301,329,331,360,365,389,395],approv:[71,237,389],approxim:[41,74,306,359],april:303,aps_top:301,aps_topic_caldav:301,aps_topic_carddav:301,apsaccountid:27,apsdevicetoken:27,apssubtop:27,apsvers:27,apt:[49,51,80,83,87,217,218,395],aptli:261,arbit:36,arbitrari:[41,44,56,168,191,207,208,210,211,212,213,214,215,237,260],arbitrarili:97,arbitron:[52,58,97,99,100,114,299],arbitronsort:299,architect:290,architectur:[7,36,109],archiv:[11,15,24,28,52,99,174,175,176,177,178,179,180,181,182,183,184,197,226,229,230,243,264,277,290,301,303,308,319,320,339,383],archive:[11,13],archive_:[174,175,176,177,178,179,180,181,182,183,184],archive_aft:[15,301],archive_dai:[15,301],archive_en:[15,230,301],archive_keepflag:[15,301],archive_maxs:[15,301],archivecach:[229,233,301],archivepartit:[15,229,230,301,319,320],area:[11,41,53,74,75,97,301],aren:[47,56,58,74,98,152,217,218,237,251,284],arg1:55,arg2:55,arg3:55,arg4:55,arg:[79,80,97,284],arguabl:[44,222],argument:[11,41,44,48,49,52,55,68,72,74,75,80,97,106,147,155,158,164,169,171,189,190,194,210,211,212,213,214,215,226,237,240,248,260,283,284,292,294,300,301,323,325,352,353,355,359,360],argv:74,aris:[11,24],arising:81,around:[11,44,51,55,58,71,72,74,80,97,225,226,251,284,290,292,300,325,329,353,382,385],arpa:380,arrai:[11,27,28,56,68,75,301],arrang:[80,218,226],arrayu64:191,arriv:[19,25,74,174,175,176,177,178,179,180,181,182,183,184,240,301,307,329],arround:97,arrow:371,articl:[6,11,97,100],articul:11,artifact:51,artifici:97,ascii:[27,33,41,56,97,301,307,327,366,380],asid:[11,33,35,281],aside:[158,398],ask:[58,61,97,265,289,301,310,369,370,372,373,375,377,378,379],asn1:6,aspect:[5,7,12,41,229,237,383],ass:290,assert:[44,45,59,80,100,160,172,197],asset:11,assign:[5,11,19,96,188,225,226,248,301,307,325],assist:[49,58,281],associ:[5,6,9,11,19,30,40,41,58,60,133,158,224,227,234,237,239,243,247,277,301,307,308,325,398],associateddomain:301,assort:[99,100],assum:[18,33,40,44,48,49,51,53,56,70,72,74,90,93,100,161,217,218,226,235,237,243,251,255,281,300,301,310,324,327,353,365,369,370,372,373,375,377,378,379],assume:[18,44,51,251],assumpt:[97,237],assur:[0,26,80],astr:68,asynchron:64,atim:269,atom:44,atomic:11,attach:[11,58,72,74,88,142,190,241,251,301,304,330,332,334,335,343,344,346,347,348,355,358,360,363],attachment:[20,27,88,301],attack:[41,99],attempt:[5,26,36,41,44,45,47,49,55,58,59,60,96,97,98,100,153,187,194,225,226,237,239,247,251,265,272,279,301,312,316,327,353,360,369,370,372,373,375,376,377,378,379,390],attend:11,attendee:76,attendeeemail:27,attendeenam:27,attendees:76,attendeestatu:27,attent:[96,217,398],attract:393,attrib:301,attribut:[5,22,35,44,88,159,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,228,301,325],auction:154,audio:392,audit:[99,359,368],auditlog:[142,147,190,301],aug:[324,340],augment:[41,224,392],australia:27,auth:[6,18,41,66,82,83,84,86,87,97,98,99,107,108,130,196,218,224,239,241,260,301,325,327,334,335,347,380,395],auth_:[41,224],auth_krb_pt:[97,301],auth_mech:[301,351],auth_newst:97,auth_pt:[149,162,191],auth_setid:97,auth_stat:61,auth_unix:[97,301],auth_xxx:97,authent:[3,4],authenticata:188,authenticate:[82,83,84,86,87,97],authid:325,authnam:[239,328,371,376],author:[3,4],authorit:[11,40,237,239,241,310],authoriz:380,authors:52,authstat:46,authz:325,authzid:325,auto:[88,98,107,108,132,294],autoconf:[12,49,97,99,100],autocreate_:158,autocreate_acl:[210,211,212,213,214,215,301],autocreate_inbox_fold:[19,158,210,211,212,213,214,215,301],autocreate_inbox_foldersr:301,autocreate_post:[19,158,248,301],autocreate_quota:[19,158,167,248,301],autocreate_quota_messag:[19,158,167,248,301],autocreate_siev:170,autocreate_sieve_compiled_script:[158,301],autocreate_sieve_compiledscript:[19,301],autocreate_sieve_fold:[19,158,301],autocreate_sieve_script:[19,158,301],autocreate_sieve_script_compil:[19,158,301],autocreate_subscribe_fold:[19,158,301],autocreate_subscribe_sharedfold:[19,158,301],autocreate_subscribe_sharedfolders_al:[19,158,301],autocreate_us:[19,158,301],autocreateinboxfold:[19,158,301],autocreatequota:[97,158,301],autocreatequotamsg:301,autoexpung:301,autof:290,autolearn:27,autologout:301,autom:11,automak:[12,49,80,100,140,217],automat:[6,9,11,13],automount:290,autonom:281,autoreconf:[48,49,51,72,162,190],autorepeat:361,autorepli:251,autorespond:294,autoselect:343,autosiev:391,autosievefold:[158,301],autosubscribe_all_sharedfold:[158,301],autosubscribeinboxfold:[158,301],autosubscribesharedfold:[158,301],autotool:217,autovivif:226,auxprop:[87,218,301],avail:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237],availabl:4,available_selection_modes_on_backend:9,available_selection_modes_on_frontend:9,availmech:68,avenu:[11,81],averag:[300,359],avoid:[26,33,44,46,47,55,58,59,74,75,97,99,100,107,108,109,138,141,145,151,159,169,265,288,301,320,355,395],awai:[80,97,98,293,325],await:[23,26],awar:[3,33,36,40,41,218,228,395],away:290,awesom:[98,218],awri:97,ayland:140,b8b3:66,babysit:300,bacchella:[162,194],back:[7,11,14,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,34,35,36,37,38,39,41,44,45,47,53,55,58,59,61,64,72,74,96,147,150,155,188,217,221,226,229,231,235,237],backend1:[9,36,239],backend2:[9,36],backend3:9,backend:[3,4,6,7],backend_timeout:79,backendserv:237,background:[58,66,96,300,325,337,359],backlog:[74,337],backport:[49,140,141,147,171,194,391],backscatt:[138,301],backslash:[106,255,301,325],backtrac:[279,381],backup1:[64,289],backup2:[64,289],backup:[1,4],backup_compact_maxs:[226,301,306],backup_compact_mins:[226,301,306],backup_compact_work_threshold:[226,301,306],backup_data_path:74,backup_db:[74,226,301,306,314,355],backup_db_path:[74,226,231,301,306,314,355],backup_filenam:74,backup_index_abort:74,backup_index_end:74,backup_index_start:74,backup_keep_previ:[301,306],backup_max_chunk_dur:74,backup_max_chunk_s:74,backup_min_chunk_dur:74,backup_min_chunk_s:74,backup_retent:301,backup_retention_dai:[74,226,301,306],backup_staging_path:[74,226,301],backup_sync:74,backup_sync_authnam:74,backup_sync_host:74,backup_sync_password:74,backup_sync_port:74,backup_sync_repeat_interv:74,backup_sync_shutdown_fil:74,backuppartit:[74,226,301,304],backward:[72,74,141,150,217,225,235,301,335,347,380,392],bad:[44,45,46,57,58,68,85,97,117,141,154,159,161,162,189],badlogin:316,badurl:143,badus:316,bail:[74,122,159,361],balanc:[7,9,11,30,36,227],balden:97,band:[237,290],bandaid:156,bandwidth:[11,58,260,265,382],bank:[152,324,393],banner:[80,106,117,150,162,301],bar:[40,44,55,72,74,237,239,338,359,398],bare:266,base64:[51,56,241],base:[5,11,13,15,18,36,40,47,48,49,51,56,58,61,62,65,66,68,72,74,75,76,80,86,87,90,91,93,97,100,102,104,106,110,117,125,131,132,136,150,160,188,217,218,219,226,227,228,229,231,237,246,248,251,255,264,268,277,284,296,301,306,311,329,333,336,337,341,354,366,380,390,392,394],basedir:51,bash:[80,217,218,261,263,395],bashrc:218,basi:[5,15,36,41,44,45,62,104,117,158,260,268,301,313,359,395],bastion01:366,batch:[44,66,260,301,366],batten:[147,171],batteri:[11,264],bba47b13e4839f49ab1c8047ee7b4fdb:27,bboard:390,bc_action_emit:75,bc_action_gener:75,bc_emit:75,bc_eval:75,bc_gener:75,bc_stringlist_gener:75,bc_test_gener:75,bcc:[58,255,301,366],bce8:309,bcederli:27,bcopi:97,bcyru:239,bdb:[99,122,154],bdystr:366,be1:30,be2:30,be3:30,beamnet:110,bear:[11,222,254],bearer:196,beast:295,becam:390,becaus:[3,6,7,11,18,19,28,33,40,41,44,45,46,47,48,49,57,58,70,72,74,80,97,158,218,225,237,238,239,255,271,283,290,293,294,301,324,327,329,392,393],becom:[3,5,11,19,24,25,40,44,45,66,74,158,226,227,237,239,240,241,253,255,271,281,301,306,337,392],beef:97,been:[0,5,6,9,11,19,25,27,30,33,44,45,47,50,55,56,58,60,61,71,72,74,75,79,80,91,95,96,97,98,99,100,102,142,152,154,156,158,160,170,172,174,177,178,179,180,181,182,183,184,194,197,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,219,225,226,235,237,239,240,241,243,247,254,255,258,259,260,265,281,284,290,301,306,313,319,320,324,325,337,340,353,355,359,366,385,389,390,392],beer:11,befor:[7,41,44,45,47,48,49,53,55,56,58,59],before:[44,97,100],begin:[44,58,68],behalf:[345,392],behav:[44,98,158,225,239,265,319],behavior:25,behaviour:[31,41,49,80,150,159,187,192,210,211,212,213,214,215,218,226,233,239,301,306,320,353],behind:[9,30,61,75,102,150,171,227,239,260,290,301],beholden:74,belief:[3,11],believ:[11,56,80,158,260,293],belong:[40,55,74,192,218,301,306,319,353],below:[18,27,41,45,47,55,57,58,68,74,84,87,88,93,96,154,217,218,224,238,240,243,250,255,258,260,261,263,285,300,301,306,307,314,324,333,355,359,395],benchmark:237,benefit:[15,80,205,206,207,208,210,211,212,213,214,215,229,230],benn:[389,393],berdmann:274,berkelei:[44,45,98,99,100,113,116,145,174,175,176,177,178,179,180,181,182,183,184,217,218,293,312],berkeley_caches:100,berkeley_hash:[100,114],berkeley_hash_nosync:[100,114],berkeley_locks_max:100,berkeley_txns_max:100,berklei:[99,100,293],bernard:[162,194],bernhard:274,bernstein:[185,393],best:[25,40,52,71,74,84,206,207,208,210,211,212,213,214,215,217,218,219,237,265,270,283,301,360,381,390],beta10:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124],beta11:123,beta1:123,beta2:123,beta3:123,beta4:123,beta5:123,beta6:123,beta7:123,beta8:123,beta9:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133],beta:[72,97,158,211,212,213,214,215,330],bethani:226,better:[9,11,18,26,30,44,59,74,96,97,98,99,100,102,114,117,121,129,130,133,136,139,145,158,161,167,171,217,226,237,239,300,301,360,389,391,392,394],betti:324,bettysu:320,between:[3,5,9,11,15,25,26,30,36,38,41,44,45,48,58],bewar:[44,45],beyond:[7,9,11,30,40,94,227,237,243,290,301,390],bidirect:[56,74],big:[74,138,139,156,187,190,208,210,211,212,213,214,215,226,239],bigbuff:247,bigdisk:265,bigger:[0,237],biggest:[9,30,227],bill:35,bin:[49,51,61,65,80,87,97,152,187,201,202,203,204,205,217,218,239,260,261,271,274,301,306,308,310,312,325,327,329,331,359,360,395],binari:[2,44,49,51,58,72,81],binary:[82,83,84,86,87,100,117,136],bind:[5,88,210,211,212,213,214,215,290,300,301,337],bindir:[174,175,176,177,178,179,180,181,182,183,184],binhex:80,binsymlink:[51,218],bird:265,birger:98,bison:[49,97,141,217],bit32:58,bit:[11,44,47,56,58,62,64,74,80,82,83,84,86,87,97,99,102,104,107,109,120,122,143,144,156,158,187,218,237,241,266,269],bitmask:[6,58,68],bitvector:80,bitwis:55,blah:301,blank:[44,72,300,301,302],bleed:[198,200,201,202,203,204,205,206,207,208,216],blob:[90,218,241,301],block:[11,47,55,59,74,75,80,105,158,210,211,212,213,214,215,226,255,300,306,318,360,389],blockdiag:52,blocker:389,blow:236,blurdybloop:301,bmp:56,board:[13,19,301,388],bob:[91,248],bodi:[46,55,56,58,88,100,102,130,174,179,180,181,182,183,184,228,251,301,359,366,380],body:[58,97,325],bodystructur:[27,58,228,301],bodystructure:122,bogu:[44,45,99,151,239],bold:52,bonu:109,book:[22,36,93,398],books_test:398,boost:96,boot:[11,82,83,84,86,87],born:[219,390],both:[3,5,6,7,11,18,19,25,36,40,41,44,56,58,61,62,68,74,80,81,88,93,96,99,100,102,108,122,171,217,219,224,225,226,227,237,239,243,244,260,264,265,277,278,300,301,306,310,325,352,353,355,359,360,365,384,389],bother:[48,72,130],bottleneck:237,bottom:55,bounc:[286,301],bound:[100,230,301],boundari:[58,66,75,97,99,152,158,210,211,212,213,214,215,301],boundary:27,boundary_limit:301,bovik:[41,97,158,224,237,249,323,324],box:[137,303,310,398],brace:[55,80,241],bracket:[71,300,301],brain:[58,97,136],braindead:44,branch:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],brand:[44,51,74],brandon:[98,325],brashear:393,breakpoint:80,breyha:[140,146,147,160,161,162,171,193,194],brick:11,bridg:11,brief:[56,96,218,267,380],briefli:[7,240],brilliant:71,bring:[7,81,239,241],britnei:55,broad:49,broadest:74,broke:[97,141],broken:[59,74,116,121,138,145,150,170,192,321,359],bron:[44,74,152,389,393],brong:[46,47,59,74,158,322],brong_:74,brontool:44,brotli:[49,380],brought:226,brown:301,brownfox:301,brows:72,browser:[88,89],bruce:97,brutish:59,bsearch_mem:97,btree:116,buczek:156,budget:11,buf:[47,55,56,58,80,152],bufsz:56,bug:[0,11,44,50,53],bugfix:[80,98,99,100,150],buggi:[51,57,97,98,153,156,170],bugs:52,bugzilla:[11,158,160,172,174,177,178,179,180,181,182,183,184],bui:[11,237],build:[1,2,4,11],built:[13,19,22,44,45,47,52,56,70,72,74,80,81,97,99,170,185,197,235,239,243,269,301,395],builtin:[301,325],bulk:[44,109,307,366,383],bulletin:[13,19,301,392],bump:[44,74],bunch:[72,74,97,145,146,147,226],bundl:96,burden:88,burdensom:74,burn:218,bushi:[218,232,301],busi:[11,26,74,88,110,125,126,264,278],button:[53,281,398],bwlimit:359,byacc:97,bye:[18,82,83,84,86,87,97,301],bylaw:[385,388],bynari:99,bypass:[6,97,164,189,237,332,348],bytecod:[1,19,73,74],bytecode_input_t:75,bytecode_t:75,byteorder64:80,c01:[82,83,84,86,87],c38962096a47:309,c_include_path:269,cabinet:260,cabl:11,cacertdir:325,cacertdirectori:169,cacertfil:[169,325],cach:4,cachdr:366,cache_crc:58,cache_envelope:47,cache_offset:58,cache_vers:58,cache_version:58,cacheabl:188,cacheid:97,cacheitem_bas:47,cacheitem_buf:47,cacheitem_s:47,cachever:[338,366],cadir:[169,170],cafil:[169,325],cafile:68,cage:40,cal:368,calalarmd:[49,51,174,175,176,177,178,179,180,181,182,183,184,228],calconnect:88,calcul:[9,11],caldav:[0,1,2,3,4,5],caldav_allowattach:301,caldav_create_attach:[88,301],caldav_create_default:[88,301],caldav_create_sch:[88,301],caldav_historical_ag:301,caldav_maxdatetim:[126,301],caldav_mindatetim:[126,301],caldav_realm:301,caldavtalk:51,caldavtest:[70,131,132],caldavzap:133,calendar:[6,11],calendar_component_set:301,calendar_user_address_set:301,calendarnam:27,calendarprefix:22,calendarserv:[70,88,301],call:[3,11,38,44,45,46,47,48,55,56,59,60,68,72,74,79,80,82,83,84,86,87,91,97,98,99,141,153,154,158,170,186,190,218,225,226,229,237,243,247,264,265,281,291,301,316,359,389,395],callahan:98,callback:[44,45,60,68,79,97,247,369,370,372,373,375,377,378,379],callback_cap:68,callback_noliteral:68,calle:44,caller:[44,58],calscale:76,cam:[100,141],cambridg:[61,100],came:[56,74],campu:392,can:[0,3,5,6,7,9,10,11,12,18,24,26,28,33,35,36,39,40,41,44,45,47,48,49,51,52,53,55,56,57,58,59,61,62,65,66,68,69,70,71,72,74,75,77,79,80,87,88,89,91,92,93,95,96,97,98,99,100,102,104,108,109,120,125,129,139,145,147,150],cancelled:76,canist:11,cannot:[7,27,40,41,44,49,52,80,84,88,97,99,194,218,223,232,237,238,294,301,336,337,381],canon:[11,47],canonic:[6,41,56,97,99,100,224,301],canonif:[3,5,19,49],canonifi:[5,196,301],capa:301,capabilities:301,capability:[18,68,82,83,84,86,87,97,105,107,117],capability_str:68,capabl:[11,41,49,52,68,97,106,107,108,141,153,158,194,226,237,260,301,355,369,370,372,373,375,377,378,379],capac:[4,7,9],capath:[68,170,325],capo:172,captur:[36,80,218],card:368,carddav:4,carddav_allowaddmemb:301,carddav_realm:301,carddav_repair_vcard:301,carddavtalk:51,care:[40,44,55,74,97,100,226,227,237,239,301,310],career:290,carefulli:[7,11,56,226,290],caringo:[174,176,177,178,179,180,181,182,183,184,301],caringo_:[174,176,177,178,179,180,181,182,183,184],caringo_hostnam:301,caringo_port:301,carlo:[160,169],carnegi:[81,158,219,385,390,392,393,394],carnegie:81,carsten:[98,158],carter:[100,102,104,105,106,109,122,139,141,152],cascad:[91,97],cass:51,cassandan:[48,50],castorsdk:301,cat:[218,395,398],categori:[56,185,237],catenate:[82,83,84,86,87,102,117,143,380],caught:145,caus:[6,11,30,33,41,44,58,59,80,97,98,100,102,109,122,138,151,154,158,162,217,218,224,225,226,231,237,239,241,243,248,259,260,272,273,275,283,286,293,300,301,310,353,359,360,368,369,370,372,373,375,377,378,379,395,398],caution:[51,258,301],cave:140,cb44:27,cdt:340,cell:[11,301],center:11,centos:[2,12,81],centr:265,central:[3,36,56,392],centric:[22,265],centuri:[219,390],ceph:11,cephfs:11,cert:[49,98,109,218,395],cert_fil:68,certain:[5,11,56,58,59,60,80,97,162,194,222,226,247,283,290,295,300,301,369,370,372,373,375,377,378,379,398],certainli:[44,48,158],certif:[4,5],cetera:290,cflags:[49,51],cgi:[93,201,202,203,204,205,301],chain:[87,158,159,226],challeng:[11,24,80,97,301,369,370,372,373,375,377,378,379,380],chan1:260,chan2:260,chan3:260,chanc:[9,24,30,58,98,227,239,259,281,301],chang:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40],changeabl:18,channel1:260,channel:[3,11,65,72,74,86,150,158,210,211,212,213,214,215,218,226,237,252],chapter:[7,8,10,255,262],charact:[1,3,18,33,41,44,54,55],characterist:7,charg:[41,221,250],charset:27,charset_compilepat:56,charset_convert:56,charset_decode_mimebodi:56,charset_decode_mimehead:56,charset_extractfil:56,charset_freepat:56,charset_index:56,charset_lookupnam:56,charset_max_transl:56,charset_searchfil:56,charset_searchstr:56,charset_unknown_charset:56,chartables_long_transl:56,chaskiel:393,chassi:[11,260],chatti:301,chattr:264,chattrsync:264,chdir:[51,217],cheap:[11,28,46,74,237,264],cheaper:[11,15,229,264,301],cheapli:74,check:[9,11,18,24,25,30,44,45,47,48],checkapop:288,checkbox:72,checkdeliv:97,checklist:7,checkout:[51,72],checkpass:316,checkperiod:277,checkpoint:[44,45,139,218,226,300,301,306,308,384],checksum:[58,74,136,226,306],cherri:[48,72],child:[88,89,92,96,137,243],children:[44,82,83,84,86,87,98,156,319,337,359],chin:100,china:100,chines:66,chk_cyru:[99,100,299],chkconfig:[82,83,84,86],chmod:[18,218,395],choeger:98,choic:[9,11,30,44,45,87,88,98,227,231,237,290,395],choke:171,chomp:[58,329],choos:[5,7,11,33,74,88,171,229,231,233,237,248,271,281,301,354,398],chose:269,chosen:[11,294,301,359,369,370,371,372,373,375,377,378,379],chown:[218,263,291,395],chri:[97,168,272,393],christian:100,christoph:187,chroot:[63,87],chunk:[11,74,131,133,226,301,306,314],chunk_id:74,churn:137,cid:[197,228,301,366],cipher:[82,83,84,86,87,99,146,158,301],circuit:[44,100,126],circumst:[11,31,33,80,233,281,398],citizen:294,cjk:[65,66,185],claim:[5,97,266],clamav:49,clarifi:[97,255,281],clash:[74,96,194,353],classifi:389,cld2:301,clean:[11,25,28,41,44,45,48,51,52,55,57,59,72,74,76,80,96,98,99,100,140,158,169,191,217,235],cleanli:[44,97,98,162,188,193,241],cleans:319,cleanup:[44,47,55,58,74,80,96,97,99,140,141,145,146,158,174,176,177,178,179,180,181,182,183,184,300,308,337],clear:[5,41,55,68,71,80,237,239,301,323,325,353,366,390],clearli:[11,55],clearos:81,cleartext:[93,301],cli:217,cli_fat:55,click:[72,398],client:[3,4],client_bind:301,client_bind_nam:301,client_id:191,client_timeout:[100,301],clientaddress:[228,301],clientid:[228,301],clientip:27,clientport:27,clock:79,clone:[51,53,65,71,76,81,174,177,178,179,180,181,182,183,184],close:[7,8,9,25,30,41,44,45],closed:152,closedir:110,closer:[80,239,301],closest:[41,223,290,301],cluster:[11,36,64,87,154,239,290,295,301,310,343],clusterlvm:11,clutter:97,cmd:[15,65,74,87,139],cmd_renam:142,cmdloop:74,cmu:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],cmuloc:[48,97],cname:[97,237],code:[0,1,44],codebas:[44,53],codepath:44,coexist:226,coher:[11,198,200,201,202,203,204,205,206,207,208,216],coi:33,cold:229,collabor:[70,158],collaps:56,collat:[44,170,235,301],colleagu:158,collect:[6,11],collectnew:97,collis:310,colon:[301,303,321],coloo:[113,139,146,156,158],colour:52,columbia:102,column:[18,80,306],com:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],com_err:[97,100,197],combat:295,combin:[5,11,14,41,56,58,71,74,80,217,220,221],combinatori:301,come:[11,41,52,55,65,74,80,82,83,84,86,87,92,217,219,224,225],comerr:217,comfort:[11,217],comma:[6,9,30,301,303,317,321,342,359],command:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73],commandcrew:33,commandlist_t:75,commandmintim:301,comment:[55,56,71,87,277,289,310,325],commerci:270,commit:[41,44,45,46],committ:389,commod:11,common:[5,8,11,12,15,33,36,44,45,60,74,87,97,218,229,238,247,265],commonli:[3,8,11,36,41,87,224,268,293,304,308,310,330,331,332,334,335,343,346,347,348,358,362,363],commun:[11,12,36,40,41,70],comp:[243,301],comp_flag:6,comp_pat:56,comp_typ:6,compact:[44,56,65,71],compar:[5,10,11,36],comparis:109,comparison:[41,76,80,99,159],compat:[41,44,66,90,97,99,100,107,119,121,141,150,158,159,174,176,177,178,179,180,181,182,183,184,193,205,206,207,208,210,211,212,213,214,215,217,224,225,235,251,271,301,315,325,327,335,347,353,380,392],compel:6,compens:74,compil:[6,19,41,42,48],complain:[74,80,97,174,176,177,178,179,180,181,182,183,184,210,211,212,213,214,215,269],complaint:98,complet:[3,11,12,18,41,47,49,58,61,64,68,72,74,75,82,83,84,85,86,87,91,97,100,131,143,147,170,187],complete:76,completed:76,complex:[11,59,65,74,80,97,158,301],compli:[24,225],complianc:[25,70,225,391],compliant:[14,27,97,99,100,125,221,228,286,301,328,332,348,390,394],complic:[55,56,74,75,80,226,240],compon:[3,4,7,11],compos:[3,5,9,66,227],comprehens:395,compress:[49,74,82,83,84,86,87,109,110,146,158,170,218,226],compression:[369,370,372,373,375,377,378,379],compris:[3,389],compromis:[237,239,301],comput:[3,4],computation:75,con:240,concaten:41,conced:99,concept:35,concern:[9,11,30,227,260,264,285,390],conclud:[254,301],concurr:[13,41,47,98,237,392,395],cond:55,condit:[9,19,55,58,59,75,80,81,97,98,100,147,152,153,159,164,189,227,264,301,380],condition:97,condstor:[47,108,109,117,277],condstore:[58,82,83,84,86,87,105,117,152,277],conf:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95],confer:41,confid:11,confidenti:291,config:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87],config_annotation_db:[44,45],config_dir:97,config_fil:18,config_getstr:[44,45],config_virtdomain:80,configdirectori:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217],configdirectory:289,configfil:52,configur:[0,1,2,3],configuration:52,configurationdir:307,configured:218,confirm:[26,50,72,239,384,389],conflat:74,conflict:[107,150,237,238,239,241,271,310,325],conflocal_mailer:[218,395],conform:[97,132,228],conforming:52,confus:[33,55,64,80,97,100,158,218,301,395],conjunct:[88,225],connect:[3,6,7,11,13,18,36,41,47,55,68,74,82,83,84,86,87,93,97,98,99,100,105,122,129,130,138,147,150,158,159,161,162,170,188,195,196,218,237,238,239,241,251,259,260,263,266],connection:81,conrad:393,consecut:301,consensu:[380,389],consequ:[7,11,355,398],consequential:81,conserv:[41,226,250],consid:[3,7,9,11,12,30,33,40,41,44,45,49,56,59],consider:[4,5],consist:[3,7,11,19,36,40,41,42,44,45,46,47,56,57,58],consolid:88,consort:51,constant:[44,47,97,139],constantli:[97,290],constitut:[26,84,355,395],constrain:[11,323],constraint:295,construct:[56,100,243,344],consult:[11,41,87,91,94,96,97,170,217,229,230,233,237,243,245,316,351,359,395],consum:[11,109,260,264],consumpt:7,contact:12,contain:[3,6,11,14,18,19,24,28,33,40,41,44,47,48,50,55,56,58,62,72,74,75,76,80,81,88,91,93,97,100,122,142,143,162,164,171,174,175,176,177,178,179,180,181,182,183,184,185,187,189,190,197,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,224,226,228,229,234,237,241,264,265,279,284,291,300,301,302,304,306,310,314,316,324,325,327,332,338,348,353,355,369,370,372,373,375,377,378,379,395],contemporari:48,content:[1,6,11,26,27,36,41,44],content_lines:58,context:[36,44],contigu:321,continu:[3,7,11,19,26,33,36,40,44,45,47,56,66,80,82,83,84,86,87,97,99,106,158,217,237,239,260,281,292,295,301,306,359,394],contract:[11,81],contrari:[3,11,219],contrast:97,contraven:301,contrib:[79,97,170],contribut:[0,1,52,53,70,98,117,158,159,170,194,301,385,389,393,397],contributor:[0,384,388,391],control:[3,5,7,9,11,13],conundrum:11,conveni:[44,80,158,225,268,316,355,360],convent:[1,33,41],converg:4,convers:4,conversations_counted_flag:301,conversations_db:[66,90,301],conversations_expire_aft:301,conversations_expire_dai:[301,319],conversations_max_thread:301,conversationsdb:[57,197],convert:[6,44,51,56,58,59,62,74,88,97,99,100,136,138,190,217,220,225],convexist:[228,301],convunseen:[228,301],cool:[51,91,237],cooper:324,coordin:11,cope:33,copi:[3,5,11,24,38,39,41,44,46,47,48,49,51,53,56,58,61,65,72,74,76,97,102,108,122,139],copy:[88,97,119,133,225],copyback:360,copying:121,copymessag:90,copyright:[80,81],core:[66,96,98,136,208,210,211,212,213,214,215,266],core_uses_pid:279,corneliu:[112,140],correct:[3,7,18,40,41,44,45,55,61,72,74,80,93,97,98,99,100,108,138,139,146,158,162,193,196,197,217,218,237,238,243,264,272,301,338,353,354,368,369,370,372,373,375,377,378,379],correctli:[47,48,55,56,72,74,97,98,99,100,109,138,150,159,160,161,162,170,185,186,187,188,190,193,194,196,197,217,218,237,239,253,301,395],correspond:[6,10,15,25,55,56,58,72,74,76,97,158,225,226,229,230,233,243,277,301,302,307,319,325,326,344,355],corrupt:[6,11,41,44,45,47,58],cors:301,cost:4,costli:[28,75],could:[3,5,7,10,11,15,18,19,28,33,36,38,41,51,55,58,59,74,75,77,84,97,99,100,108,128,140,153,154,158,164,170,189,191,222,224,225,226,237,239,241,260,264,281,360,366,381],couldn:[68,164,189,290],count:[6,9,11,30,35,41,47,58,109,147,158,162,190,203,204,205,206,207,208,210,211,212,213,214,215,225,227,241,250,257,266,281,290],counter:4,countri:19,coupl:[11,27,44,98,228],courier:[174,176,177,178,179,180,181,182,183,184,219,301,390],cours:[3,9,11,30,226,227,294],courtesi:[104,105,106,107,110,121,122,136],cover:[44,71,81,94,139,247],coverag:[49,80],cpan:[49,51],cpu:[36,260,290,301],crack:74,craft:[74,191,290],craig:[104,117,389,393],cram:[5,41],crap:97,crash:[51,58,59,96,98,99,100,107,109,115,139,141,145,146,147,149,150,152,153,154,155,156,159,160,161,162,165,166,170,171,172,185,187,188,189,190,191,193,194,195,197,237,239,260,381],crashi:196,crawl:[39,74],crc32:[51,58,80,174,176,177,178,179,180,181,182,183,184],crc32_iovec:80,crc32_map:[58,80],crc32c:190,crc:[58,136,159,360],crc_iovec:80,creat:[3,5,7,9,10,11],create:[6,18,59,61,97,98,99,109,122,158,159,225,237,239,301,325],createabl:237,createdir:218,createdmodseq:[204,205,206,207,208,210,211,212,213,214,215],createmailbox:[159,218,257],createonpost:[158,301],creation:[4,7],creationd:6,crec:47,credenti:[5,130,226,239,260,265,301,355,369,370,372,373,375,377,378,379],crept:155,cridland:109,crispin:97,crit:[41,290],criteria:[11,15,229,277,324],critic:[28,41,44,72,98,260,290],crlf:[41,58,71,142,241,274],cron:[15,41,74,95,226,260,265,300,324],crontab:[95,324,359],cross:42,crossdomain:[174,176,177,178,179,180,181,182,183,184,301],crossdomains_onlyoth:[174,176,177,178,179,180,181,182,183,184,301],crow:237,cruft:136,crypt:18,cs0:301,cs1:301,cs2:301,cs3:301,cs4:301,cs5:301,cs6:301,cs7:301,csync:[74,96,218,226,245,260,301,304,355,362,395],ctag:380,ctl_:96,ctl_backups_lock_data_fnam:306,ctl_backups_lock_index_fnam:306,ctl_conversationsdb:[44,66,90,205,206,207,208,210,211,212,213,214,215,217,299,301],ctl_deliv:[98,100,299,300],ctl_mboxlist:[36,44,77,98,99,100,107,117,122,142,153,165,170,231,238,239,255,260,289,299,301],ctl_zoneinfo:[88,133,299,301],ctrl:[263,316,398],cu_:80,cu_assert_equal:80,cu_run_all_test:80,culprit:11,cumbersom:11,cunit:[49,72,80,190],cunit_tests:80,curl:[66,217,218],curli:80,current:[5,6,11,15,19,27,33,36,40,41,44,45,47,48,52,53,55,56,58,60],currently:[41,289,353],curv:[146,158,301],custom:[11,28,44,66,91,93,164,174,175,176,177,178,179,180,181,182,183,184,189,192,207,208,210,211,212,213,214,215,226,270,306,324,381],customer1:3,customis:324,cut:[11,390],cutoff:325,cve:[111,139,163,164,170,186,188,189,201,202,203,204,205,206,207,208,210,211,212,213,214,215],cvenam:[201,202,203,204,205],cvs:137,cvt_xlist_specialus:[217,299],cycl:[24,25,36,44,46,59,84,97,158,216,259,260,281,300,360],cyr_:96,cyr_buildinfo:299,cyr_deni:[263,299,316],cyr_df:[109,299],cyr_expir:[15,24,25,44,58,100,102,104,107,110,122,142,150,155,156,158,196,218,243,255,265,281,299,300,301],cyr_info:[210,211,212,213,214,215,217,299],cyr_sequ:299,cyr_synclog:[104,108,169,260,299],cyr_userseen:299,cyr_virusscan:[49,95,162,207,208,210,211,212,213,214,215,284,299,301],cyradm:[18,22,28,40,41,49,68,88,97,98,99,100,114,140,154],cyradmin:97,cyradmn:256,cyrdeliv:285,cyrdump:[137,191,196,299],cyril:110,cyrsudb_db3:98,cyru:0,cyrudb:100,cyrunit:80,cyrus24:51,cyrus25:51,cyrus:[88,162,194],cyrus_conf:[218,395],cyrus_confdir:264,cyrus_db:74,cyrus_don:[44,45,55],cyrus_group:[197,301],cyrus_imap_murd:7,cyrus_init:[44,45,55],cyrus_path:301,cyrus_prefix:[98,156],cyrus_sendmail_auth_id:301,cyrus_syslog_prefix:301,cyrus_us:[197,301],cyrus_user:301,cyrus_verbose:337,cyrus_version:137,cyrusarch:230,cyrusdb:[1,6,43],cyrusdb_again:[44,45],cyrusdb_backend:44,cyrusdb_convert:44,cyrusdb_create:[44,45],cyrusdb_db3_nosync:98,cyrusdb_done:44,cyrusdb_exists:[44,45],cyrusdb_fetchnext:44,cyrusdb_flat:[44,45],cyrusdb_ioerror:[44,45],cyrusdb_locked:[44,45],cyrusdb_lockopen:44,cyrusdb_mboxsort:[44,45],cyrusdb_name:45,cyrusdb_nocompact:44,cyrusdb_notfound:[44,45],cyrusdb_ok:44,cyrusdb_quotalegaci:[44,107],cyrusdb_skiplist:[44,99],cyrusdb_sql:44,cyrusdb_twoskip:44,cyrushost:316,cyrusid:359,cyrusimap:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],cyrusisgreat:40,cyruslib:[65,185,195],cyruslibs:65,cyruslibs_dir:65,cyrusmeta:[233,234],cyrusmurd:[241,295],cyrussiev:266,cyrusv2:[40,218,395],d5ec35c1414a:[82,83,84,86],da39a3ee5e6b4b0d3255bfef95601890afd80709:74,daboo:277,dacl_invite:76,dacl_reply:76,dacl_schedfb:76,daemon:[11,19,41,64,65,87,96,97,98,99,170,174,175,176,177,178,179,180,181,182,183,184,192,194,217,218,226,231,235,239,246,251,265],dai:[7,11,15,28,41,44,52,58,109,156,158,217,218,219,226,228,243,255,264,277,281,300,301,303,319,325,333,340,366,390],daili:[11,109,359],dam:325,damag:[41,61,260],damages:81,damn:74,dan:393,danger:361,dark:[219,390],darrow:98,darth:[265,291],dashboard:50,data:[3,4,6,7],data_sha1:74,databas:[1,4,5],database:[18,44],datagram:[329,331],dataless:237,dataset:[237,260],datasourc:44,datastor:[44,265,305],datastructur:[60,247],datatyp:[109,156],datauuid:51,date:[27,41,58,60,79,80,81,88,97,137,152,174,181,182,183,184,218,226,227,237,239,241,251,265,295,301,303,324,325,333,338,340,360,380,390],datestamp:52,dav:4,dav_lock_timeout:301,dav_realm:301,dav_reconstruct:[44,158,162,217,299,301],dave:[109,152,389,393],davfilenam:[228,301],davi:393,david:[98,100,102,104,105,106,109,122,139,141,152],davnotificationsprefix:301,davtalk:51,davuid:[228,301],daylight:[109,301],db3:[98,99,100,293],db4:[99,100,109,293],db_mail:18,db_mail_password:18,db_mail_us:18,db_passwd:18,db_recov:[100,289],db_user:18,dba:6,dbdir:99,dberror:[99,109],dbm:97,dc814658a4d676789578bff3de35b45914abd774:338,ddmmyyyi:303,deactiv:[9,30,227,237,376],dead:[98,300,301],deadlock:[44,45,97,98,283],deal:[55,56,74,87,97,98,99,239,241,288,290],deanna:302,debconf:217,debhelp:217,debian:[2,12,49,70,80,81],debug:[1,6,18,44,45],debug_command:[99,301,304,329,330,332,334,335,344,345,346,347,348,358],debugg:[74,99,284,304,329,330,332,334,335,344,345,346,347,348,355,358,360],decemb:390,decent:75,decid:[11,36,44,45,74,87,97,228,237,243],decim:[56,62,68,355],declar:[80,97,229,301,380],declarar:97,declined:76,decod:[56,97,218,301],decode_st:56,decompil:[251,357],decompos:56,decomposit:56,decoupl:196,decreas:[97,292],decrement:59,dedic:[7,226,260,304,393],deem:11,deep:[226,301,306],deeper:301,deepli:66,defaultacl:[41,223,301],defaultdomain:[40,174,176,177,178,179,180,181,182,183,184,218,301],defaultpart:[229,233,301],defaultpartit:[9,28,30,41,65,218,227,229,230,233,234,301],defaultsearchti:[65,229,234,301],defaultserv:[9,30,109,227,301],defeat:99,defect:97,defer:238,defici:44,definit:[11,18,44,47,55,80,81,88,210,213,214,215,220,229,234],deflat:360,deflate:[82,83,84,86,87,380],degener:97,degrad:[97,275],degre:41,dekker:152,delai:[11,13],delaycompress:218,delayed_expung:150,deleg:222,delet:[8,11,13],delete_mod:[24,41,104,141],delete_unsubscrib:301,deleteacl:[225,325],deleteaclmailbox:41,deleted:[24,97,140,141,150,255,301,325],deletedmessag:255,deletedprefix:[24,74,104,255,301,355],deleteing:121,deletembox:41,deletemsg:41,deleteprun:[158,218],deleteright:[225,301],deletes:239,delight:381,delimit:[24,52,74,88,89,92,97,286,301,303,316,324],deliv:4,deliver:[100,385],deliverbi:301,deliverdb:[97,309],deliveri:4,delprun:[218,255,300],delsub:108,delta:[9,30,227,239,301],delteacl:325,demand:[62,125,260,278],demi:226,demonstr:61,demot:264,deni:[6,98,110,218,225,239,241,263,316,317,332,348],denial:[6,99,218,241,316],denot:[56,274,301,398],dens:315,depart:392,depend:[7,9,11,30,36,41,44,45],depfil:80,depict:11,deploi:[4,15,84,225,290,359,390],deploy:[4,5],deployment:40,deployment_guid:9,deprec:[6,15,41,56,96,100,136,158,174,177,178,179,180,181,182,183,184,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,225,245,260,301,313,353,371,380,392,395],deprecated:47,depth:[138,218],dereferenc:301,deriv:[41,81,239,260,283,353,359],derrick:393,des:97,describ:[3,8,12,18,27,41,44,45,56,58,68,72,88,97,160,225,230,237,251,260,262,265,300,301,302,311,324,385,390],description:52,descriptor:[44,45,55,68,97,100,131,174,176,177,178,179,180,181,182,183,184,300,301,304,330,332,334,335,343,344,346,347,348,358,363,369,370,372,373,375,377,378,379],deserv:5,design:[0,5,6,11,13],desir:[5,11,56,60,74,97,107,239,241,247,260,301,324,337,390,395],desktop1:398,desktop:[251,398],desno:393,despatch:[219,390],desper:251,despit:[55,71,218,231,241,269,395],desruisseaux:380,destdir:51,destin:[3,74,88,100,102,150,161,218,226,237,294,301,314,325,355,359,392,395],destroi:[48,72,96,301,361],desttier:359,desyncronis:191,detail:[1,6,11,12,18,41],detect:[26,44,45,58,74,80,95,98,100,109,110,132,150,151,154,158,159,162,171,174,181,182,183,184,187,190,194,196,258,259,301,338],detector:80,determin:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255],determinist:315,detritu:44,dev0:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],dev:[10,11,49,65,72,80,198],devel:[11,33,44,49,55,239,269,383],development:216,devic:[3,4],devrandom:288,dfuch:98,dhave:80,dhe:[82,83,84,86,87],diacrit:[56,301],diagnos:[44,49,97],diagnost:314,diagram:[1,11,243],dialog:398,dictat:[11,15,41,87,224],did:[19,38,48,72,76,80,97,155,218,248,251,301,310,381],didn:[44,74,80,97,154,162],die:[275,329],diesel:11,differ:[7,9,11,13,18,19,30,33,36,41,44,45,46,49,56,58,59,69,70,71,72,74,80,88,96,97,99,100,130,137,139,141,154,155,159,165,217,218,225],different:55,differenti:301,difficult:[80,237,270],digest:[5,41,49,93,99,130,301,324,325,369,370,372,373,375,377,378,379,380],digit:[41,56,74,97,154,283,301,303,328],dilail:392,dilyan:[139,141],dilyanpalauzov:196,dimens:301,diminish:[9,30,227],dir:[12,80,88,97,162,175,176,177,178,179,180,218,359,398],direct:[7,11,15,41,46,52,58,72,74,93,97,164,189,217,229,230,233,237,243,245,265,298,301,359,389],directli:[11,22,41,44,46,49,52,63,75,81,88,100,137,140,158,218,237,239,270,281,301,306,308,392,395],director:237,directori:[1,10,11,15,24,30,35],dirhash:[143,144],dirsrv:11,disabl:[11,12,18,19,24,25,33,41,49,74,77,80,87,88,89,93,97,98,99,100,102,104,110,113,122,139,141,146,156,158,169,170,188,189,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,228,237,243,248,251,279,288,301,304,308,319,329,330,332,334,335,344,345,346,347,348,358],disable_shared_namespac:[33,301],disable_user_namespac:[33,221,301],disadvantag:7,disallow:[41,97,277,301,325],disappear:[25,47,58,59,74,275,281,301],disast:[11,218,307,395],disastr:64,disavow:97,disc:325,discard:[74,75],disclaim:81,disclaims:81,disclos:[169,301],disconnect:[97,161,185,239,277,301],disconnect_on_vanished_mailbox:[110,146,301],discov:[74,80,152,258],discoveri:11,discreet:301,discret:4,discretionari:[33,220],discuss:[15,40,41,56,65,88,187,224,226,228,229,239,247,255,287,290,294,383,389,398],disk:[3,6,9,10],diskquota:27,diskus:[27,228,301],dispatch:96,displai:[6,8,33,56],display:[87,138,391],disposit:[97,380],disrupt:96,dissappear:158,dist:[48,72,98],distanc:[71,219,390],distcheck:[48,72,188],distclean:97,distinct:[15,36,66,74,96,227,238,283,300,301,303,324],distinguish:[5,33,41,224,264,398],distribut:[2,4,6],distributor:19,distro:[49,217,218,239,260,395],ditto:237,divers:[380,393],divid:[3,11,28,93,97,147,229,264,300],divis:58,dkim:[88,301,380,385],dlist:6,dmarc:385,dmz:237,dnf:84,dnl:[218,395],dns:40,do_stuff:[46,47,59],doc:[1,48,49,52,87,96,174,176,177,178,179,180,181,182,183,184,185,192,218,316,385,395,397],docbook:398,docker:50,docsrc:[48,52,72],document:[0,1,11,13,15,18,19,27,40,41,44,45,46,47,48,49,51],doe:[3,5,7,8,11,13,19,27,33,35,36,40,41,44,46,47,51,56,58,60,66,69,72,74,75,82,83,84,86,87,89,92,93,95,97,98,99,100],does:[260,287],doesn:[0,18,19,33,41,44,45,47,48,51,55,56,58,59,61,72,74,76,80,88,97,98,99,104,110,140,142,147,160,162,218,225,228,237,255,263,272,290,300,301,316,360],doesnt:289,dohash:97,domain:[3,7,13,18,33],domainkei:[93,218,301,380],domainrelatedobject:301,don:[0,3,18,44,45,47,48,49,52,53,55,56,58,71,72,74,88,97,98,99,100,130,142,143,146,154,155,161,166,168,170,171,185,190,217,218,226,228,236,237,238,239,251,269,270,288,290,291,301,306,310,328,337,342,352,353,355,359,360,363,369,370,372,373,375,377,378,379,382],donald:156,done:[15,25,40,41,47,51,53,55,56,57,58,61,75,76,80,88,90,93,97,100,108,125,217,218,226,232,237,239,243,251,258,260,263,268,301,310,323,325,341,376,395],dopenssl_no_krb5:269,dormant:303,dos:[99,137],dot:[3,33,41,69,99,143,161,185,217,301],doubl:[55,56,100,138,241,300],doubt:[72,138],dovecot:[51,152,174,176,177,178,179,180,181,182,183,184,301],down:[36,44,56,74,80,96,97,99,154,158],downcas:[56,286],downconvert:272,downgrad:[147,217,353],downloadurl:190,downtim:[239,264,392],dozen:36,dpc22:[61,141],dperl_pollute:98,dpkg:[218,381],drac:[200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],drac_auth:79,drac_p:79,draft:[33,41,97,99,100,102,125,158,251,255,258,277,294,301,320,323,338,353],dragonfli:139,drastic:[122,295],draw:398,drawback:[237,390],drbd:[11,301],dread:[97,98],drive:[11,92,93,218,229,301],driver:11,drop:[45,64,72,97,158,174,175,176,177,178,179,180,181,182,183,184,195,241,395],drop_cr:274,dropcr:274,dropoff:97,drwxr:64,dry:[172,239,333,365],dsn:[97,301],dtend:[6,76],dtstamp:76,dtstart:[6,76],duck:[48,72],due:[41,58,59,66,74,75,93,98,107,126,150,158,159,191,217,218,226,266],dumb:44,dummi:301,dump:[44,45,74,77,97,99,100,117,143,226,231,238,241,266],dump_deliverdb:97,dump_opt:74,dupelim:97,duplic:4,duplicate_check:141,duplicate_db:[10,158,301],duplicate_db_path:[10,96,218,231,301],duplicate_mailbox_mod:320,duplicatedb:98,duplicatedeliv:[104,277],duplicatesuppress:[41,98,100,301],durat:[11,44,45,58,74,99,207,208,210,211,212,213,214,215,301,319],duration:76,dure:[11,12,19,24,36,41,44,45,47,55,56,57,58,59,80,84,97,98,99,100,122,138,147,153,171,174,176,177,178,179,180,181,182,183,184,187,189,195,208,210,211,212,213,214,215,218,224,226,227,228,237,239,240,264,290,301,307,315,325,355,381],duse_setproctitle:170,dynam:[56,91,301],e503646e389f507777fb75eeacc2da0d2156016a:366,each:[3,6,7,9,11,13,15,19,27,28,30,31,33,36,38,40,41,44,45,46,55,56,58,59,60,61,64,66,68,72,74,75],eachoth:3,eager:98,earli:[197,301,390,392],earlier:[18,48,72,97,147,151,152,162,187,190,191,217,218,237,251,301,310],earliest:[281,301],earmark:12,easi:[41,47,74,80,237],easier:[0,18,35,44,56,62,74,80,88,97,99,158,159,222,266],easiest:[40,59,72,301],easili:[6,53,56,58,59,74,222,243,392,398],eat:97,eaton:[389,393],ebai:154,ecdhe:[146,158,301],ece:302,echo:[97,218,263,279,369,370,372,373,375,377,378,379,395],ecparam:[158,301],edda:[193,196],edg:[150,198,200,201,202,203,204,205,206,207,208,216],edit:[49,51,52,72,87,218,240,243,251,265],edithead:[251,301,380],editor:[6,52,218],edu:[68,81,97,98,99,102,117,141,237,239,255,290,293,302,325,383],eest:324,effect:[5,9,30,36,55,56,63,74,93,97,107,158,189,218,225,229,239,251,260,264,301,320,355,359,380],effectiv:5,efficaci:28,effici:[11,13,35,44,58,66,74,90,96,97,98,151,239,260,295,301,359,360,368,392],efficienc:385,effort:[1,11,12,41,81,158,287],egd:98,ehlo:[218,301],either:[6,9,11,18,19,22,30,36,41,44,45,47,49,56,57,58,74,79,87,93,96,109,187,217,218,219,222,224,237,238,241,243,245,246,248,251,255,260,265,269,281,288,300,301,303,322,325,327,351,355,359,389,390,392,395,398],el6:27,el6_6:[82,83,84,86],el7:366,elaps:74,elect:389,electron:[380,392],eleg:56,element:[6,75],elfejoyeux:110,elimin:[11,35,56,97,98,105],elli:[72,226],ellie:[48,72,393],elliefm:74,ellipt:[146,158,301],els:[0,47,48,55,57,58,59,72,74,75,80,87,290,384],elsewher:[15,55,75,243],email:[3,5,6,11,15,18,19,27,28,33,40,41,44,46,47,49,66,69,79,88,138,145,158,210,214,215],emailid:[228,301],emailsubmiss:301,embarrass:39,embed:[6,325],emerg:[11,13],emiss:27,emit:[27,75,80,97,142,272,301,353,359],emori:102,emphasis:44,empire:[51,219,390],emploi:[19,26,221,260,290],employe:19,empti:[6,11,30,33,74,76,80,93,97,99,100,108,110,142,161,193,227,229,233,234,239,241,281,301,355,359],empty:[56,281,355],emul:[88,301],enabl:[1,4,5,6,11],enable:[87,136,380],enable_event_notif:228,enable_experiment:97,enabled:[140,147],enclos:[97,300,301],enclosur:380,encod:[56,62,74,146,197,241,255,272,301,324,327],encode:[27,58,62,131,210,214,215,380],encompass:265,encount:[56,97,269,398],encourag:[81,237,365],encrypt:[5,18,36,55,93,97,239,301,330,332,344,346,348,369,370,372,373,375,377,378,379],enctyp:269,end:[3,11,27,28,40,44,45,55,56,58,63,64,68,71,72,74,75,80,88,89,92],end_command:68,endian:[98,187,190],endless:[26,275],endors:81,endpoint:[292,301],endscript:218,enduser:61,energi:11,enforc:[5,36,58,84,277,301],engin:[6,44,56,58,61,64,97,194,229,234,301,324,359,360,362,389,392,395],engineer:388,english:301,enhanc:[11,71,81,98,99,100,125,146,156,158,185,187,252],enorm:11,enospc:11,enough:[41,44,55,74,79,80,197,218,226,227,243,280,288,290,301],enrich:158,ensur:[5,8,11,18,19,24,25,36,39,45,46,47,49,58,59,80,82,83,84,86,87,96,97,100,108,109,161,210,211,212,213,214,215,217,218,226,237,239,241,243,260,264,281,300,301,359,389],ensure:[48,51,72,108],enter:[48,72,82,83,84,86,87,218,251,316,329,398],entere:80,enterpris:[2,12,13,81],entertain:33,entir:[11,25,33,41,44,52,55,58,59,74,75,87,99,102,108,131,145,217,219,226,228,232,237,239,241,243,255,264,281,301,319,322,323,337,343,359,390],entireti:[66,325],entiti:[3,5,237,241,380],entri:[5,6,25,36,40,41,56,57,58,64,74,75,76,90,96,97,102,128,139,152,162,169,194,195,217,218,223,224,226,229,230,231,233,234,237,239,241,243,245,251,255,260,265,277,300,301,306,307,308,316,317,319,322,325,337,345,349,350,353,359,395],entropi:[288,301],enum_valu:80,enumer:[267,301],env:156,envel:366,envelop:[27,40,41,58,97,98,100,228,251,272,301],envelope:[58,97,142],envelope_length:47,envfromsmtp:40,enviro:100,environ:[3,4],environment:52,envtosmtp:40,eof:[74,97,99,306],equal:4,equat:11,equi:301,equiv:[41,224,299],equival:[11,56,237,272,301,302,353],era:390,eras:47,erat:[147,170,171,174,176,177,178,179,180,181,182,183,184],erdmann:274,erfrakon:136,eric:97,err:[41,56,100,263],errno:[68,99],error:[8,18,28,41,44,45,47,49,51,55,68,74,80,82,83,84,86,87,97,98,99,100,104,139,140,142,149,150,151,152,154,156,158,159,160,162,164,167,170,174,178,179,180,181,182,183,184,189,193,194,206,207,208,210,211,212,213,214,215,217,218,237,238,266],errors:52,escap:[56,99,255,263,285,301,316,325],escape:[218,251,263],esearch:[87,136,156,301,391],esh:117,esmtp:[218,380],esort:391,especi:[4,11,24,25,44,55,60,72,98,102,208,210,211,212,213,214,215,218,226,247,290,301,316,359],essenti:[49,58,217,239,265],essential:269,establish:[11,13,18,82,83,84,86,87,229,239,265,266],etc:[2,5,6,9,11,18,31,33,36,40,41,47,49,51,55,58,63,74,75,87,91,95],eudora:[99,301],evalu:[11,75,210,211,212,213,214,215,237],even:[0,3,11,15,18,19,36,40,41,44,45,46,47,48,55,57,58,59,64,69,72,74,75,80,84,97,98,99,100,109,141,150,152,189,197,216,218,225,237,239,250,260,263,264,265,269,280,281,301,306,319,325,327,359,369,370,372,373,375,377,378,379,392],evenli:58,event:[1,13,19,24,25],event_content_inclusion_mod:[228,301],event_content_s:[228,301],event_exclude_flag:[228,301],event_exclude_specialus:[228,301],event_extra_param:[228,301],event_group:[228,301],event_notifi:[228,301],events:[15,44,74,95,96,158,217,218,226,231,255,260,265],eventsourc:[174,176,177,178,179,180,181,182,183,184],eventu:[74,80,307,359],eventual:[98,329],ever:[3,40,44,55,59,138,231,243,278,279,287,301,337,353],everi:[0,3,6,15,40,44,45,53,58,59,72,74,79,80,81,97,219,228,229,230,233,239,241,243,251,255,260,265,282,292,295,301,307,359,360,390,392],everydai:[11,40],everyon:[40,47,61,80,97],everyth:11,everywher:44,ex_software:47,ex_tempfail:[97,206,207,208,210,211,212,213,214,215],exact:[8,9,11,44,45,52,58,139,218,281,301,333,381,395],exactli:[11,26,44,52,74,79,109,218,225,301,333],exam:9,examin:[51,56,60,210,211,212,213,214,215,217,226,247,318,319,333,338,353,366,392],examine:[97,225,237,325],exampl:[1,3,5,9,11,18,19],example:52,example_of_freespace_most_selection_on_backend:9,example_of_freespace_most_selection_on_frontend:9,exampleisp:40,examples:52,exce:[41,248,301],exceed:[27,390,394],excel:[264,290],except:[11,44,45,55,56,72,74,80,87,89,92,97,227,238,281,301,325,392],exception:[13,45,281],exchang:[5,36,79,237],exclud:[3,7,9,30,74],exclus:[9,11,19,40,44,45,47,52,57,58,59,74,97,225],exclusion:4,exclusiv:[47,306],exclusive:[57,59],exdate:76,exec:[156,376],exec_prefix:190,execut:[8,11,74,75,80,93,97,99,100,174,175,176,177,178,179,180,181,182,183,184,217,225,231,243,262,264,281,284,301,306,325,337,341,342,398],exercis:[11,260],exhaust:353,exim:[41,99,266],exim_dropcr:274,exist:[4,5,6,7,8,10,11,19,27,28,33,36,40,41,44,45,46,47,50,58,59,62,66,68,74,75,76,80,88,89,92,96,97,100,130,141,143,144,154,158,187,193],exists:[58,147,162,190],exists_cb:44,exit:[52,55,68,74,80,97,99,146,160,161,193,206,207,208,210,211,212,213,214,215,218,260,300,301,306,324],exitcod:97,expand:[11,56,88,301,321],expans:[11,58],expect:[0,9,11,18,30,47,49,72,74,80,84,96,98,142,158,189,218,225,226,237,239,300,301,305,307,381,391],expens:[11,28,47,58,75,102,226,237,281,301,344,353,355],experi:[0,26,97,158,194,218,237,266],experienc:[275,382],experiment:[97,107,174,176,177,178,179,180,181,182,183,184,188],experimental:61,expert:[0,11],expertis:6,expg:[255,366],expir:[97,100,218,243,255,277,281,301,319,325,350,364],expirat:[243,319],expire:[24,25,218],expirenew:100,expiri:150,explain:[11,41,56,80,218,224,241,262,285,317],explan:[15,80,218],explicit:[0,62,108,300,325],explicitli:[9,30,47,49,56,61,88,107,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,218,219,225,227,251,301,355,359,380],exploit:[100,111,139],explor:239,explos:301,expos:[91,360],express:[41,49,52,55,56,98,301,306,394],expression:[251,380],expung:[13,24],expunge:[25,61,102,122,137,152,222,225,237,255,281,301,325],expunge_mod:[25,41,102],expunged:97,expungeprun:[158,218],ext4:11,ext:391,extend:[62,75,99],extended:[87,136,140,159,174,175,176,177,178,179,180,181,182,183,184,301],extens:[27,47,49,56,68,75,90,97,98,100,102,106,114,136,140,164,174,176,177,178,179,180,181,182,183,184,189,218,239],extensibl:380,extension:[97,158,225,251,281,301,380],extensiv:[174,176,177,178,179,180,181,182,183,184,185,385],extent:325,extern:[36,41],external:2,extlist:301,extra:[9,11,30,44,66,74,80,88,98,99,142,152,228,253,255,301,359],extract:[48,72,81,90,301],extraction:380,extractor:301,extraid:99,extrem:[11,68,239],extutil:49,fa6558da:309,fabric:[162,194],face:[6,74,226],facil:11,facilit:[11,25,38,117,158,239,243,281,301,366,389],fact:[0,3,5,19,36,55,98,218,233,237,239,281,395],facto:219,factor:[11,53,82,83,84,86,87,301,304,330,332,344,346,348,362],faculti:393,fail:[1,11,18,19,26,41,44,45,47,49,51,58,59,68,72,74,76],failed:80,failedloginpaus:[154,301],failov:[11,61,217],failur:[3,6,11,41,44,45,58,68,72,74,80,99,127,141,145,147,151,156,158,160,162,169,172,187,193,194,218,220,226,236],fair:270,fairli:[44,97,278,395],fake:[55,79],fall:[11,19,88,150,188,237,260,301],fallback:243,fals:[40,56,66,75,87,97,218,231,260,277,301,325,359],famili:[11,80,392],familiar:[11,53,64,66,217,226,270],family2:3,famou:[11,219,390],fanci:272,faq:266,far:[11,36,55,74,75,97,239,285,325,332,348],fare:281,fart:97,fashion:[11,40,55],fast:[28,44,51,56,58,74,99,219,229,264,267,287,319,353,359,369,370,372,373,375,377,378,379,390],faster:[10,11,44,45,55,99,100,126,158,174,175,176,177,178,179,180,181,182,183,184,190,217,220,231,237,240,252],fastmail:[27,44,99,102,104,105,106,107,121,122,152,158,174,175,176,177,178,179,180,181,182,183,184,228,301,393],fastmailshar:301,fatal:[47,55,68,97,99,301],fault:368,faulti:11,favero:197,favor:301,favorit:[11,158,218],favour:[6,15,171,174,175,176,177,178,179,180,181,182,183,184,260,301],fax:81,fc20:366,fc21:366,fcc:301,fcntl:[44,59,74,99,264],fdatasync:99,feasibl:[11,74],featur:[0,1,2,3,4,5,6,7,8,9,10,11,12],feb:[27,79,255,286],februari:44,fed:[100,243,301,307,328,344],fedex:324,fedora:[2,12,70,81,82,83],fedoraproject:[11,366],fee183c329c011ead7757f59182116500776eaaf:74,feed:[11,13,64],feedback:[0,211,212,213,214,215,226,389],feeder:[100,344],feel:[11,72,79,91,217],feet:64,felix:197,fenc:11,ferreira:393,fetch:[44,45,46,47,49,51,52,53,58,65,97,100,105,122,145,147,165,206,207,208,210,211,212,213,214,215,217,218,225,235,237,264,265,266],fetching:237,fetchlock:[44,45],fetchnew:4,fetchnext:44,few:[3,5,11,36,41,46,52,55,72,80,96,97,133,156,226,229,237,239,264,265,270,289,290,301],fewer:11,ffff:56,fiber:[3,11],fiddli:74,field:[6,18,41,44,45,47,58,60,62,72,74,152,165,188,191,205,206,207,208,210,211,212,213,214,215,217,218,224,229,231,233,241,247,300],fields:97,fifth:359,fig2dev:49,figur:[97,218,290,306],file:[0,1,2,3,4,5],file_sha1:74,filedescriptor:99,fileformat:312,fileinto:[19,33,75,99,106,158,164,189,251,298,301],filenam:[19,41,44,45,74,80,100,226,231,283,301,304,306,309,310,314,330,332,343,344,346,348,349,350,355,356,376,398],filename:27,files:52,filesystem:[3,4],fill:[47,53,55,68,97,154,217,301],filter:[13,19],find:[5,6,11,41,44,48,49,55,58,72,74,76,80,88,93,152,154,158,170,188,210,213,214,215,217,218,229],fine:[46,47,51,74,100,226,274],finer:226,finger:[97,329],finish:[11,42,44,45,47],finishproc:68,finishrock:68,fire:279,firewal:237,first:[0,6,9,19,30,41,44,45],fit:4,fitness:81,five:99,fix:[41,44,48,49,51,56,58,71,72,74,80,96,97,98,99,100,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,125,127,128,131,132,133,134,137,138,139,140,141,144,145,146,147,148,149,150,151,152,153,154,155,156],fixdir:218,fixme:74,flag:[6,15,19,27,38,40,41],flag_internal_expunged:47,flagnam:[27,228,301,366],flags:[58,98,143],flaki:293,flap:155,flash:11,flat:4,flatten:315,flaw:79,fleme:237,flex:[49,97,217],flexibl:[11,158,237,248,260,325,385],flight:218,flock:[59,74,99],flow:[26,27,74],flowchart:[1,73],flush:[74,78,97,102],flushseenst:[102,122,301],flux:11,fly:[19,58,122,154,301],fmt:68,focus:237,fold:[97,100,139],folder:[5,6,7,9],folders:[41,190,250,325,352],follow:[0,6,7,8,9,10,11,12,13,18,19,23,24,25,27,28,30,33,36,40,41,44,45,47,48,49,51,52,55,56,57,58,60,61,65,66,68,70,71,72,75,77,80,81,82,83,84,86,87,88,90,93,96,158,174,181,182,183,184,217,218,223,224,225,226,227,229,231,237,239,241,245,246,251,255,260,261,262,263,264,271,274,281,294,300,301,303,306,314,315,320,324,325,344,355,359,360,376,380,381,383,389,390,395,398],followup:[100,301],foo:[40,44,55,63,74,97,156,158,237,238,239,251,264,301,338,359],fool:281,foolproof:239,foolstupidcli:301,foot:11,footer:187,footnot:[11,27,36,158,281],footprint:[11,98],forb:81,forbidden:283,force_sasl_client_mech:301,forcibl:99,foreach:[44,45,74,76,109,172],foreach_cb:44,foreground:108,foreign:[80,263],foremost:11,forerunn:[219,390],forese:7,forethought:55,forev:[59,158,225,301],forget:[53,251],forgiv:99,forgotten:[58,72],fork:52,form:[5,40,41],format:[1,6,27,41,44,47,48],former:[11,15,96,158,218,245,281,300,395],formul:11,forth:11,forthcom:98,fortun:251,forward:[36,133,237,241,251,260,301,325,380,392],found:[9,30,44,49,68,71,74,76,129,130,132,133,145,152,162,219,237,258,263,266,268],foundat:158,founder:[51,390],four:[33,41,56,74,217,224,300],fourth:[260,307,359],fox:301,fpic:[49,51,80],fprintf:68,fqdn:3,fraction:[56,156,359],fragment:77,framework:[50,75,80],francoi:393,freakin:290,fred:41,free:[9,30,53,55,56,60,68,79,80,88,97,100,125,126,158,161,227,229,233,239,247,248,301,353,385,394],free_cr:97,freebsd:[12,139,155,217,231],freed:[59,68,100,241],freeli:100,freenod:[218,382],freespac:[9,30,227,239,277,301],freez:266,french:3,frequenc:[97,235,260,261,282,301],frequent:[11,58,75,97,237,261,264],fresh:226,freshmen:390,fri:340,friend:[74,239,265],friendli:[190,382],friendlier:122,fright:74,from:[2,3,6,7,9,11,13,15,18,19,24,25,26,27,28,30,33,35,36,38,40,41,44,45,46,47,48,49,51,52,53,55,56,57,58,60,61,64,65,66,70,71,72,74,75],front:[7,66,96,217,237],frontend:[3,4,7],frustrat:[55,398],fs_get:99,fs_give:99,fsck:11,fsync:47,ftp:342,fuch:98,fud:[97,98,99,156,299],fud_queri:329,fud_respons:329,full:[11,12,13,18,19,40],full_mboxnam:74,fulldirhash:[100,107,145,217,232,301,354],fulli:[3,11,19,33,36,40,41,56,80,158,225,227,237,251,290,301,325,344,354],fullnam:6,fulltext:359,fun:[74,211,212,213,214,215],functionproc:68,fundament:40,further:[3,11,15,40,41,44,45,53,56,60],furthermor:[74,96,243],futur:[7,11,40,44],fuzzi:[102,301,391],fuzzy:[196,301],g0241b22:72,gahd:[188,197],gain:[66,218,264,392,395],game:61,garbag:[98,134],gardin:393,gari:[98,122],gatewai:[100,243,392],gather:[99,235,301],gave:283,gcc:[49,65,80,98,110,141,160,174,178,179,180,181,182,183,184,188,192,269,271],gcm:[82,83,84,86],gdb:[51,80,266,279],geani:52,gen:58,gener:[3,4,6],generate_compiled_sieve_script:[158,301],gentoo:[12,81],geograph:11,gesang:161,get:[0,1,2,7,9,11,18,19,27,30,41],getacl:[225,325],getannotation:301,getannotations:[205,206,207,208,210,211,212,213,214,215],getent:[218,395],getgrent:[41,224,301],gethostnam:301,getidentityupd:90,getinfo:159,getmd:325,getmetadata:[159,171,188,225],getnameinfo:99,getopt:325,getpassphras:154,getprotobynam:329,getquota:[109,237],getquotaroot:[156,197,237],getservbynam:97,getuid:97,getvacationrespons:90,getxstr:99,gfs:11,ghudson:97,giant:301,gif:301,gigabyt:[11,28],gilda:393,gile:152,git2:27,git:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80],github:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51],gitpython:[49,52],give:[0,11,13,26,28,40,41,44,45,47,51,58,72,74,79,80,87,97,98,137,218,222,237,239,241,243,248,255,272,280,301,352,353,360,392,395],given:[9,11,30,40,41,44,45,56,58,60,61,74,80,84,88,97,98,99,158,162,174,176,177,178,179,180,181,182,183,184,218,222,225,228,237,239,241,243,245,247,248,250,260,284,285,287,295,301,303,307,314,316,317,319,321,324,325,333,337,338,339,340,352,353,356,357,359,366,371,395],glib:301,glibc:[107,113],glob:[80,97,107],global:[3,5,40,44,45,58,80,102,158,174,175,176,177,178,179,180,181,182,183,184,218,222,251,252],gloom:394,glusterfs:11,gmail:[110,309],gmt:[58,340],gmtime:58,gmtmoff_gmtim:97,gmx:140,gnarli:71,gnu99:[49,51],gnu:[49,65,80,218,325,383,395],goal:[390,392],god:290,goe:[15,33,48,55,72,97,243,265,281,282],gondwana:[152,389,393],gone:[74,97,217,281],good:[11,44,52,55,71,72,74,80,81,85,88,97,153,218,227,237,251,278,290,294,295,301],goof:98,googl:71,got:[57,59,71,72,74,97,156,263,301],gouaux:[98,99],gov:99,govern:[69,229,388],gperf:[49,217],gpfs:266,gpg:[48,72],gpl:80,grab:[74,97],gracefulli:97,grade:[11,264],grain:100,gramar:190,grammat:301,grand:243,grant:[18,41,222,223,237,301,325,327],granular:[74,158,226,301],granularli:158,graphic:72,great:[7,41,51,71,158,218,219,290,390,394,395],greater:[19,25,47,100,102],greatli:[58,211,212,213,214,215],greenfield:[79,393],greet:[106,301],greg:[97,152,393],gregorian:380,grep:[18,255,316],greylist:366,groff:217,gross:97,group:[5,7,11,19,35,36,41,49,51,55,97,100,138,146,197,217],groupadd:[218,395],grow:[7,9,11,28,30,227,243,266,281],grown:80,growth:[237,292],grundman:393,gss:93,gssapi:[49,237,251],guarante:[5,7,44,47,55,56,81,84,108,217,237,239,392],guess:74,guest:11,gui:[22,81,88,89,93,290],guid:0,guidanc:1,guide:40,guidelin:0,guilherm:393,guimard:187,gut:72,gzip:[74,226,380],gzname:74,hack:[1,44,54],hacmp:290,had:[5,6,47,74,97,152,155,187,191,194,219,237,239,281,290,313,355,390],haferkamp:[158,393],hagberg:97,hajimu:100,half:[61,97],ham:27,hammer:152,hand:[11,60,97,108,141,219,222,226,237,247,301,390,398],handi:[44,80],handl:[6,15,41,44,47,55],handler:193,handshak:6,hang:[97,240,266],hangout:71,hangup:337,happen:[3,4],happi:[131,290,353],happili:[11,47,74],hard:[36,41,44,55,97,98,154,160,218],hardcod:[187,210,213,214,215],harder:237,hardlink:155,hardwar:[11,58,72,237],harm:11,harmless:301,has_chang:47,hasattach:301,hash:[59,74,76,97,98,99,100,104,217,218,220,226,229],hashimapspool:[217,218,232,301,354],hashtabl:[9,30],hasn:[6,33,237,301],hasnochildren:[160,255,325],hat:[2,12,81],hav:301,have:[0,3,5,6,7,8,9,10,11,15,18,19,22,24,25,27,28,30,33,36,40,41,44,46,47,48,49,50,51,52,53,55,56,57,58,59,60,61,65,66,69,71,72,74,75,76,77,80,81,87,88,89,90,91,92,93,96,97,98,99,100,102,107,139,154,158,162,163,164,170,174,177,178,179,180,181,182,183,184,186,187,188,189,190,196,197,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,219,223,224,225,226,227,228,229,230,233,234,235,236,237],have_acte_krb:97,have_libdb:97,haven:[18,51,98,100,284],hba:[3,11],hdd:[11,264],hdrfromsmtp:40,hdrsize:[338,366],head:[7,48,72,74,88,125,290,391],header:[12,41,47,49],headerbodi:[228,301],headerdata:58,headernam:58,health:11,heap:80,hear:[11,70],heart:[58,300],heartbeat:301,heat:[219,390,394],heavi:[74,100,114,243,392],hei:44,height:301,heimdal:[107,217],heino:[98,139,146,156,159,169,170,393],held:[18,35,44,45,52,57,58,71,74,75,100,139,306,384],hello:[61,98,218,338],helpdesk:26,helpfil:52,hen:98,henc:44,henriqu:[99,100,137,393],her:[19,33,48,72,76],herdomain:40,here:[11,12,15,27,33,40,41,44,45,47,48,51,53,56,58,61,63,72,74,80,87,96,97,98,100,158,218,226,229,231,234,237,239,243,248,263,267,275,281,289,300,301,361,391],herodotu:[219,390],heurist:[74,324],hex:56,hexadecim:62,hhmm:300,hidden:[11,80,310],hide:[102,104,222],hierarch:[33,97,98,301],hierarchi:[11,13,19,22,24,27,30,33,34,41,63,69,72,74,88,89,91,92,97,98,99,104,105,158,159,161,223,227,231,237,243,248,249,251,255,256,281,301,325,338,353,392],hierarchical:97,hiersep:74,high:[7,11,15,36,97,102,217,220,237,243,261,264],higher:[11,15,19,27,30,49,93,248,260,275,301,304,330,332,337,344,346,348,362],highest:[6,30,58,338],highestmodseq:[74,122],highli:[56,219,290,295,392],highlight:[52,210,211,212,213,214,215,320,398],him:[28,251],hinder:[219,390],hint:[44,45],hisdomain:40,histor:[301,390],hit:[56,74,75,98,218,226,301],hmh:[99,100,137],hoeger:[98,158],hold:[5,7,11,35,41,47,57,58,59,69,74,76,99,158,217,226,237,241,264,265,281,306,395],hole:108,holidai:39,holschuh:[99,100,137,393],home:[40,80,88,132,218,231,239,251,264,301,336,398],honest:218,honor:[97,98,390],honour:[49,163],hook:265,hope:0,hopefulli:[55,97,98,99,237],horizont:[12,36,41,236,239],horribl:[44,62,290,354],hors:[219,390],host:[3,4],hostmast:33,hostnam:[40,41,93,97,218,241,260,265,272,300,301,328,329,344,355,369,370,372,373,375,377,378,379],hostname_mech:301,hostname_password:301,hosts_access:300,hot:[226,229,265,295,301,308],hour:[48,57,72,74,80,97,109,217,218,243,260,292,300,301,306,319,350,359,366],hourli:[72,95,324],hous:243,housekeep:98,how:[0,1,9,11,24,30,31,33,41],howard:99,howev:[3,5,7,9,11,36,44,45,57,70,81,90,99,158,217,225,230,237,238,239,241,259,264,272,274,279,281,286,295,301,390],howto:[36,220],hpux:97,href:128,hsk:[113,156],hsts:380,html:[46,48,52,58,65,91,100,110,174,176,177,178,179,180,181,182,183,184,277,301,316,324,395],hton:97,http2:189,http:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75],http_modul:[88,301],http_timezon:125,httpallowcompress:301,httpallowcor:[130,301],httpallowedurl:[129,301],httpallowtrac:301,httpcontentmd5:[132,301],httpd:[49,87],httpdocroot:[91,93,128,301],httpkeepal:301,httpmodul:66,httpprettytelemetri:[130,301],https:[81,93,162,163,164,186,187,188,189,196,197,301],httptest:299,httptimeout:301,hudson:97,huge:[46,74],human:[6,11,255,301],humili:11,hunch:74,hundr:[36,136,290],hung:[105,301],hurt:[99,255],husband:19,hybi:380,hypertext:380,hypervisor:11,hyphen:[74,398],hypothet:30,ian:[147,171],iana:[88,96],ibm:290,ical:[51,193],ical_obj:6,ical_uid:6,icalendar:[6,88,93,126,131,133,301,380],icu:[49,187],idea:[0,49,58,71,74,75,80,85,226,237,278,290],ideal:[11,38,57,74,226,237],idealli:[75,217],ident:[5,41,44,45,74,97,224,251,268,301,303,369,370,372,373,375,377,378,379],identifi:[3,5,14,27,33],identified:18,idl:[12,26,47,49,51,79,96,98,100,103,109,110,158,160,161,170,192,197,217,218,231,246,259,299,300,301],idle:[12,82,83,84,86,87,98,100,103,147,161,218,301,331,380],idled:4,idlesocket:[96,218,231,246,301],idx_ical_uid:6,ietf:[23,66,102,131,277,301],ignor:[41,72,76,89,92,97,98,108,122,162,187,225,300,301,302,315,319,329,355,398],ignore:[327,330,345,353,380,398],ignorequota:[47,380],ignorerefer:301,ihav:301,ihave:[243,251,301,380],iii:[11,388],ill:[11,59],illustr:[3,11,36,41,52,225,260],ilovecyru:40,imag:[3,11,36,237,290,301,398],imagin:[11,28,230,233,264,290],imailbox:333,imap2:392,imap2bi:392,imap4:[56,82,83,84,86,97,219,225,262,380,388],imap4flag:[301,380],imap4rev1:[68,82,83,84,86,87,97,332,348],imap:[1,2,3,4,5,6],imap_:44,imap_dupdeliver:58,imap_enum_virtdomains_on:80,imap_mailbox_locked:[47,59],imap_quotaroot_nonexistent:97,imap_remot:283,imap_sharedseen:58,imap_uid:6,imapclon:190,imapd:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95],imapd_authst:46,imapd_conf:[218,395],imapd_out:46,imapd_userid:46,imapext:277,imapflag:[251,301],imapidlepol:301,imapidletimeout:[147,161,301],imapidrespons:301,imapmagicplu:[63,100,301],imapnew:253,imapopt_annotation_db:[44,45],imapopt_annotation_db_path:[44,45],imaprev1:136,imaps:[13,218],imaptalk:51,imapus:[218,395],imaputf7:[51,217],imapv:97,imapwiki:70,imb:[113,156],imclient:67,imclient_addcallback:68,imclient_autent:97,imclient_authent:68,imclient_clearflag:68,imclient_clos:68,imclient_conn_nonsyncliteral:68,imclient_connect:68,imclient_eof:68,imclient_getselectinfo:68,imclient_havetl:68,imclient_proc_t:68,imclient_processoneev:68,imclient_repli:68,imclient_send:[68,97],imclient_servernam:68,imclient_setflag:68,imclient_starttl:68,imipnotifi:[174,176,177,178,179,180,181,182,183,184,301],immedi:[11,15,24,25,30,41,58,59,66,74,102,104,109,141,154,158,225,241,281,282,288,301,306,324,355,389],immediat:75,immens:80,impact:[5,7,8,11,96],impad:336,imper:11,implement:[1,4,6],implementation:251,implementor:222,impli:[11,225,281,304,330,332,344,346,348,362,365],implic:[5,11,100,262],implicat:217,implicit:[3,5],implicit_owner_right:[41,223,301],implicitli:[41,88,223],implicitownerright:105,implied:81,important:[97,100,217,218,301,398],importantli:[11,392],impos:[41,97],imposs:237,impost:5,impract:11,impress:11,improperli:[97,272,301],improv:[55,58,80],improve:[97,99,100,104,145,165,174,175,176,177,178,179,180,181,182,183,184,190,191,391],improved_mboxlist_sort:[1,44,73],improvement:[99,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],imsp:[68,96,97,98,218,237,245,325,369,370,372,373,375,377,378,379,395],imspd:97,imtest:[82,83,84,86,87,97,98,99,119,154,194,218,299,369],inabl:11,inaccur:44,inact:[41,301,308],inadvert:[88,225],inbound:[226,265],inbox:[3,19,20,27,33,36,40,41,58,61,66,74,76,88,89,91,92,97,98,99,102,104,109,142,146,154,158,159,185,223,237,239,248,251,257,258,264,266,277],inboxe:[41,105,223],inc:86,incdir:[12,49,99],inclin:11,includ:[0,6,8,10,11,12,13,18,19,24,25,27,33,41,44,47,48,49,51,52,55,56,58,68,71,72,74,75,76,80,81,82,83,86,87,91,93,96,97,99,100,102,117,133,137,141,143,144,154],include:[36,64,97,99,174,175,176,177,178,179,180,181,182,183,184,251,301,380],including:81,inclus:[24,25,53,136,174,177,178,179,180,181,182,183,184,237],incom:[19,88,90,100,218,237,240,243,248,251,266,275],income:238,incompat:[108,251],incomplet:[97,112,140,152,226,247,260],inconsist:[41,158,171,237,239,352],incorpor:[11,19,52,53,71],incorrect:[44,45,80,97,108,109,142,152,154,218,352],incorrectli:[97,99,159,338],increas:[10,11,35,44,56,58,99,104,108,154,160,239,240,260,282,295,301,306,314,337,355,359],increasingli:44,increat:154,increment:[59,74,75,97,106,174,179,180,181,182,183,184,359],incur:11,inde:[44,295],indefinit:[105,281,301],indent:[55,301,315],independ:[41,55,97,226,237,243,250,260,360,380,392],index:[1,4],index_check:98,index_clos:46,index_init:46,index_lock:46,index_open:46,index_record:[46,47],index_refresh:46,index_search_evalu:97,index_searchcachehead:98,index_st:46,index_statu:47,index_tellchang:46,index_tellexpung:46,index_unlock:46,index_upgrad:151,indic:[11,12,18,51,56,58,62,63,68,78,108,158,225,237,239,241,277,289,301,316,325,353,359,371,398],indicat:[56,58,277,325],indirect:81,individu:[3,7,11,24,28,34,38,41,44,47,58,74,75,78,80,88,102,145,158],ineffici:[145,359],inet6:217,inet:395,inet_aton:329,inetd:97,inetdomainbasedn:301,infect:[95,207,208,210,211,212,213,214,215,301,324],infin:303,infinit:[11,141,154,195,269,301],inflict:61,influenc:[80,306],info:[11,33,38,41,51,58,72,74,97,98,99,187,243,249,251,255,256,269,270,301,319],inform:[3,5,6,7,11,12,14,22,24,28,30,34,35,36,38,41,47,51,53,58,61,64,68,70,72,74,88,90],informat:[20,21],infrastructur:[3,4,5,11,19,36,48,72,80,158,161,260,392,393],inher:[147,265],inherit:[33,41,164,188,189,243,319,325,359],ini:[51,284],inifil:[51,217],init:[46,52,55,74,80,217,218,395],initgroup:98,initi:[9,11,19,30,41,44,45,56,68,74,75,97,98,99,100,122,218,223,226,227,241,246,260,300,301,334,335,347,359,369,370,372,373,375,377,378,379,391,395],initialis:[44,59,80,324],initiat:380,inject:[154,277,325],inlin:[11,55,301],inmsg:68,inn:[97,243],inner:99,innosoft:272,inod:6,inode:6,input:[44,47,53],inquir:389,inscur:380,insensit:[97,99,301],insert:[11,18,41,44,76,88,106,142,222,224,225,241,243,255,260,286,300,301,325,327],insid:[27,33,40,47,55,60,62,74,98,99,218,247,251,255,395],inspect:[48,74,314,315,320],inspir:[98,122,226],inspire:109,instabl:271,instal:[3,11,12,19,40,41,44,49,51,52,61,65,66,70,72],install:[2,42,49],installat:[7,70],installbinsymlink:[174,175,176,177,178,179,180,181,182,183,184],installsiev:[97,299],instanc:[3,9,11,13,30],instant:[11,380,393],instanti:239,instead:[11,18,19,25,36,41,44,47,52,53,55,56,58,66,71,72,74,75,80,96,97,98,99,100,109,158,160,161,174,178,179,180,181,182,183,184,193,206,207,208,210,211,212,213,214,215,225,232,237,239,240,260,277,281,285,294,298,301,309,310,325,328,333,334,335,337,342,346,347,352,353,355,369,370,371,372,373,375,376,377,378,379],instruct:[18,40,41,48,49,52,56,65,70,72],instrument:98,insuffici:237,insur:237,int64:51,int_date:[338,366],integ:[9,30,55,56,58,62,75,80,97,115,170,227,300,301],integer:[6,300],integr:[5,50,51,53,65,87,88,97,100,102,161,162,174,175,176,177,178,179,180,181,182,183,184,301,304,330,332,344,346,348,362,369,370,372,373,375,377,378,379,385,391],intel:97,intellig:[158,227],intend:[1,3,11,12,41,44,66,90,226,236,239,340,392,395],intens:[11,262,310],intent:[15,25,80,315,320],inter:[40,42],interact:[11,44,45,52,97,100,105,141,218,237,243,290,301,310,325,351,369,370,372,373,374,375,376,377,378,379,380,395],interchang:[56,237,380,392],interest:[1,6,11,12,44,45,47,70,71,81,85,226,228,237,294,382],interfac:[7,11,36,40,41],interfer:[80,158,260],interleav:237,interm:97,intermedi:[11,75,97,205,206,207,208,210,211,212,213,214,215],intermediari:310,intermeta:98,intern:[11,33,36,41,44,45,47,52,59,62,63,69,91,97,98,100,174,176,177,178,179,180,181,182,183,184,189,239,258,272,298,301,305,316,325,359,368,392],internal_flag:47,internald:[74,145,155,205,206,207,208,210,211,212,213,214,215,325,340,353],internaldate:[58,122],internaldate_heurist:145,internation:[1,54],internet:[3,13,96,218,219,245,300,334,335,347,380,392,393,395],interoper:[96,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],interpret:[11,49,56,63,74,227,272,281,306,314,327,352,355],interrupt:[11,36,171],interv:[79,106,226,277,300,301,337,360,366],interven:[56,158,237],intervent:226,intial:97,intimid:56,intra2net:140,intra:40,introduc:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],introduct:[1,42],intuit:5,invalid:[47,62,74,97,98,138,139,161,185,226,272,301],invari:[57,98],invent:[219,390],inventor:219,inventori:380,invert:333,invest:11,investig:80,invis:[187,225],invit:[88,301,382],invoc:[52,226,260,306,314,366],invocat:252,invok:[15,41,68,99,147,218,226,251,258,260,265,301,304,306,324,325,330,332,334,335,343,344,346,347,348,353,358,359,363,395],invoke:220,involv:[0,13,55,98,100,143,217,240,287,391],ioerror:[185,189,353],iolog:301,ionic:359,ios:[171,193],iov:80,iov_bas:80,iov_len:80,iovec:80,ipaddr:329,iphon:[142,156],ipop3d:142,ipsum:80,ipurg:[52,98,99,109,138,150,172,185,188,197,299],ipv4:[300,301,355],ipv6:[99,100,300,301,355],irc:[71,72,218,260],irk:74,irrelev:19,irretriev:281,irrit:398,is_tacki:55,isc:342,ischedule_dkim_domain:301,ischedule_dkim_key_fil:301,ischedule_dkim_requir:301,ischedule_dkim_selector:301,iscsi:3,ish:72,ismemb:321,isn:[0,11,18,44,45,47,55,56,58,59,71,74,97,100,126,147,174,176,177,178,179,180,181,182,183,184,218,239,255,288,294,296,393],iso8601:51,iso:[27,56,97,210,214,215,301],isode:393,isol:[80,237],issu:[11,27,36,41,44,48,53,61,66,71,72,74,82,83,84,86,87,97,98,99,100,103,104,105,106,107,108,109,114,117,120,121,122,140,152,154,158,174,177,178,179,180,181,182,183,184,191,217,218,225,227,237,239,241,256,262,264,281,286,301,338,353,369,370,372,373,375,377,378,379,381,389,398],issubscrib:66,ital:[52,398],itchi:55,item1:227,item2:227,item3:227,item4:227,item:[6,11,33,40,41,47,51,57,58,60,62,74,76,105,153,174,175,176,177,178,179,180,181,182,183,184,206,207,208,210,211,212,213,214,215],iter:[44,45,47,58,72,99,260,359],iter_skip_expunged:47,iterat:380,itself:[6,11,35,41,46,52,55,69,70,74,80,82,83,86,87,97,99,188,210,213,214,215,228,229,231,239,260,265,271,281,300,301,325,337,359,395],iversen:97,j16:51,jack:218,jakob:[188,197],jame:33,jan:[152,325,338],jane:[3,18,19,27,33,36,352],janepas3:18,janepass:18,janitor:337,jansson:[49,133,160],januari:61,japanes:66,jarosch:[113,140,168,170],jarosh:147,jason:[190,196],javascript:91,jbro:301,jcal:[133,380],jdoe:[3,5,19,258],jean:393,jeff:97,jeffrei:[389,393],jen:[147,170,171,174,176,177,178,179,180,181,182,183,184,393],jena:[113,156],jeremi:[99,102],jeroen:[161,389,393],jessi:49,jfs:290,jhoward:99,jim:97,jimson:98,jj12:302,jmap:[13,42],jmap_emailsearch_db_path:301,jmap_imagesize_annot:301,jmap_inlinedcids_annot:301,jmap_mail_max_size_attachments_per_email:301,jmap_max_calls_in_request:301,jmap_max_concurrent_request:301,jmap_max_concurrent_upload:301,jmap_max_delayed_send:301,jmap_max_objects_in_get:301,jmap_max_objects_in_set:301,jmap_max_size_request:301,jmap_max_size_upload:301,jmap_nonstandard_extens:[208,210,211,212,213,214,215,301],jmap_preview_annot:301,jmap_preview_length:301,jmap_set_has_attach:301,jmap_vac:301,jmappushsubscript:301,jmappushsubscriptionfold:301,jmapqueri:301,jmapsubmiss:301,jmapsubmission_deleteonsend:301,jmapsubmissionfold:301,jmaptalk:51,jmapuploadfold:301,jmp:56,job:[41,64,74,97,158,226,235,260,281,300],john:[3,5,19,27,28,33,36,69,97,98,102,172,255,257,260,261,285,303,305,325,352,366,393,398],johnsmit:366,johnsmith:[310,320,366],join:[7,71,74,218,266],jonathan:193,josh:190,journei:[219,390],jpeg:301,jsmith:[74,338,339,340,353],json:[66,74,90,93,301,306,314,315,352,380],jsr:56,jtampli:102,judgement:[11,55,290],jul:[338,340],juli:239,julian:80,julien:[113,139,146,156,158],jump:[56,75],jun:64,june:55,junk:[19,169,228,251,301,323,325],just:[0,3,11,18,36,39,41,44,46,47,48,52,55,58,59,61,62,71,72,74,75,76,80,97,98,99,108,154,169,187,196,206,207,208,210,211,212,213,214,215,217,218,226,232,234,236,237,238,239,241,252],justgotspammedlot:319,justifi:[71,261],jwz:98,jy9o:302,jyager:302,kamen:193,katu:139,kbyte:[6,52,333],kde:11,keep:[12,15,26,41,44,45,46,47,53,55,56,57,58,74,75,87,88,97,98,104,129,158,217,218,226,227,229,237],keepal:[138,301],kei:[4,5],ken:[79,97,98,99,141,269,389,393],kept:[7,74,99,174,176,177,178,179,180,181,182,183,184,217,226,237,239,243,282,287,301,363,371],kerber:[96,218,245,346,395],kerbero:[5,13],kerberos_v4:[41,237,239,251,369,370,372,373,375,377,378,379],kernel:[11,264,279],key1:62,key2:62,key3:62,key:6,key_fil:68,keyboard:68,keycap:398,keyfil:[169,325,369,370,372,373,375,377,378,379],keyout:218,keytab:5,keyword:[41,55],kib:[9,30,227,239,301],kick:[11,33,36],kick_mupd:141,kiev:324,kill:[110,290,337],kilobyt:[15,19,34,41,248,250,301,325],kind:[6,10,33,44,57,74,80,218,228,281,301,380],kinda:[51,56],king:51,kingdom:394,kirk:33,kleinespel:393,kmurchison:74,knight:40,know:[3,5,7,9,30,31,40,41,44,47,49,51,55,56,71,72,74,79,93,109,217,218,225,226,227,233,237,251,253,265,269,301,332,348,359,381],knowledg:97,known:[4,5,7],kolab:[27,264,393],kolab_3:27,kolbu:393,konold:136,korean:66,korreio:81,kpop:[13,35,41,96,97,218,239,245,346,392,395],kravchenko:98,krb5:[49,266],krb5_enctyp:269,krb:[41,224,299,301],krb_pt:97,krb_sasl_client:68,krbck:97,krbimpl:49,kristof:[139,393],kssl:266,kssl_build_principal_2:269,kssl_cget_tkt:269,kssl_check_auth:269,kssl_ctx:269,kssl_ctx_setkei:269,kssl_ctx_setprinc:269,kssl_ctx_setstr:269,kssl_sget_tkt:269,kssl_validate_tim:269,kthxbye:55,kueck:186,kxte:[82,83,84,86,87],label1:301,label2:301,label3:301,label:[55,56,253,272,398],lack:[11,55,100],lag:[9,30,227,239,301],lai:11,laid:52,lam:325,land:[44,66],lappend:97,laps:[9,30,227],larg:[7,9,11,13,18,24,25,27,28,30,33,36,55,56,74,97,98,99,100,102,136,198,200,201,202,203,204,205,206,207,208,216,217,218,226,227,228,229,237,240,255,262,264,266,275,281],larger:[4,11,15,19,33,36,56,100,226,237,261,301,333,360],largest:[11,15,41,133,158,227,301,394],larri:[99,393],last:[6,39,44,47,58,60,61,72,74,97,100,160,217,218,230,233,251,260,277,301,325,328,329,338,359,366,395],last_appendd:74,last_chunk_id:74,last_uid:[74,191],last_upd:[47,74],lastchang:74,lastpop:[100,277],lastread:74,lastuid:74,lastupd:[277,338,366],latch:301,late:[74,97],latenc:11,later:[11,24,25,56,65,72,74,80,97,102,104,147,158,174,178,179,180,181,182,183,184,187,217,218,219,226,227,246,248,261,264,272,274,281,301,366,390,392,394,395],latest:[12,49,51,72,81,88,97,100,216,217,237,265,270,301,306,353,385],latter:[15,74,237,255,288,300,301,359],lauri:393,lawrenc:79,layer:[1,5,11,36,41,44,54],lazi:[74,97,218],lcunit:80,lcyru:68,ldap:[5,11,13],ldap_authz:301,ldap_bas:301,ldap_bind_dn:301,ldap_ca_dir:[158,301],ldap_ca_fil:[158,301],ldap_ciph:[158,301],ldap_client_cert:[158,301],ldap_client_kei:[158,301],ldap_deref:301,ldap_domain_base_dn:301,ldap_domain_filt:301,ldap_domain_name_attribut:301,ldap_domain_result_attribut:301,ldap_domain_scop:301,ldap_filt:301,ldap_group_bas:301,ldap_group_filt:301,ldap_group_scop:301,ldap_id:301,ldap_mech:301,ldap_member_attribut:301,ldap_member_bas:301,ldap_member_filt:301,ldap_member_method:301,ldap_member_scop:301,ldap_password:301,ldap_realm:301,ldap_referr:301,ldap_restart:301,ldap_sasl:301,ldap_sasl_authc:301,ldap_sasl_authz:301,ldap_sasl_mech:301,ldap_sasl_password:301,ldap_sasl_realm:301,ldap_scop:301,ldap_serv:301,ldap_size_limit:301,ldap_start_tl:301,ldap_time_limit:301,ldap_timeout:[160,301],ldap_tls_cacert_dir:[158,301],ldap_tls_cacert_fil:[158,301],ldap_tls_cert:[158,301],ldap_tls_check_p:[158,301],ldap_tls_ciph:[158,301],ldap_tls_kei:[158,301],ldap_uri:301,ldap_use_sasl:301,ldap_user_attribut:301,ldap_verify_p:[158,301],ldap_vers:301,ldflags:65,lead:[19,27,62,69,237,239,260,288,301,325,392,393],leader:61,leak:[51,55,58,80,88,97,98,99,100,122,129,130,132,133,143,147,158,161,162,165,190,197,217],leap:301,learn:[0,11,218,243,270],least:[3,11,44,56,65,66,74,80,87,100,217,218,225,226,229,233,237,239,260,264,272,281,289,300,301,302,303,304,319,333,340,353,359,395],leav:[24,47,51,59,72,75,80,88,89,92,108,110,171,239,269,301,337,366],led:44,lee:[169,171,174,176,177,178,179,180,181,182,183,184],leena:[98,139,146,156,159,169,170,393],leewai:301,left:[61,74,97,102,120,145,239,260,264,272,301,327,355,369,370,371,372,373,375,377,378,379,393,398],legaci:[6,41,136,170,177,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,225,301,313,339],legal:[44,45,81,99],lemonad:380,len:56,length:[41,44,45,55,56,58,74,75,97,100,114,218,255,301,329],lengthen:260,less:[6,9,10,11,30,48,55,74,96,98,132,133,153,159,187,217,226,227,231,237,260,264,281,301,306,353,392],lessen:98,let:[11,36,44,45,61,74,80,97,210,213,214,215,217,218,226,230,233,239,395],letter:[41,232,237,283,301],level:[1,3],levenshteinx:51,leverag:260,lex:[49,51,75,97,100],lexer:[97,98],lhlo:106,liable:81,lib64:271,lib:[11,12,44,45,49,55,56,65,74,80,97,98,158,217,218,231,248,251,255,258,259,260,261,263,264,269,271,289,301,310,312,316,331,341,359,360,395],libacap:98,libanyev:51,libari:97,libbrotli:49,libbsd:[49,51,217],libc:80,libcal:51,libchardet:49,libclamav:271,libclon:[51,217],libcom_err:97,libcomerr2:87,libconfig:[51,217],libcrypto:271,libcunit1:[49,80,217],libcunit:80,libcurl:301,libcyru:[44,55,68,80,97,99,100,189],libcyrus_imap:[49,186,190],libcyrus_init:55,libcyrus_min:[44,100],libdata:51,libdatetim:[51,217],libdb5:[49,87],libdb:[49,217],libdigest:217,libdir:[12,49,99],libencod:[51,217],liber:301,libexecdir:[174,175,176,177,178,179,180,181,182,183,184],libfil:[51,217],libglib2:217,libic:[49,88,93,125,172,210,213,214,215,217,218,301],libicu:49,libimap:55,libio:[51,217],libjansson:[49,217],libjson:51,libldap2:[49,217],libmag:51,libmariadb:49,libmim:51,libmysqlcli:[49,217],libnet:[51,217],libnew:[51,217],libnghttp2:[49,189],libpam0g:217,libpcre3:[49,217],librari:[0,12,41,42,49,51,66],libressl:[162,194],librt:[162,190],libsasl2:[49,87,217],libsasl:[97,98],libsnmp:[49,217],libsqlite3:[49,217],libsrs2:49,libssl:[49,217,271],libstr:51,libtest:[51,217],libtext:51,libthread_db:80,libtool:[49,80,97],libunix:[51,217],liburi:217,libuuid:[49,74],libvex:80,libwrap0:217,libwrap:98,libwrap_init:98,libxapian:[49,217],libxml2:[49,133,217],libxml:[49,51,187,217],libzephyr:217,licens:[2,27,66],life:[84,191,300,398],light:[11,80,96],lighter:75,lightweight:[96,218,241,245,246,395],liinu:98,like:[0,3,5,7,11,15,16,17,18,19,26,29,30,33,34,36,37,41,44,45,46,47,48,51,52,55,58,60,62,68,72,74,78,79,80,87,96,97,121,187,194,217,218,225,226,228,230,237,238,239,241,243,247,251,255,260,263,265,269,270,271,275,284,286,290,300,301,304,308,310,316,324,329,330,331,332,334,335,337,343,346,347,348,353,355,358,359,362,363,369,370,372,373,375,377,378,379,382,391,395,398],likelihood:11,likewis:[55,57,97,98],limit:[4,5,6,7],limitless:292,lin:140,line:[11,18,41,48,49,51,55,58,65,66,71,72],liner:255,lines:[338,366],link:[11,41,42,44,48,49,52,55,61,68],linkag:[72,74,265],linkend:9,linker:271,lint:[210,211,212,213,214,215,217,320,391],linux:[2,11,12,18,19,49,65,81,84],list:[0,3,4,5],list_curv:[158,301],list_fe:129,list_opt:74,listacl:325,listaclmailbox:41,listaclmamilbox:41,listen:[18,74,87,96,98,162,194,218,226,228,231,237,239,241,243,245,246,251,253,260,265,292,300,301,304,329,330,332,334,335,337,343,345,346,347,348,358,359,362,363],listext:[82,83,84,86,98,136],listmailbox:[40,159,255],listquota:41,listquotaroot:[41,256,257],listrights:[225,325],liter:[3,33,36,44,62,68,97,99,139,241,380,398],literal8:44,literal:[68,82,83,84,86,87,154,301],literalminu:301,littl:[44,72,74,79,97,98,122,264,287,382],live:[6,11,36,44,47,56,61,74,77,80,92,97,99,158,217,218,232,237,239,251,292,301,310,329,331],liveli:[74,226],lkxan:301,lmr:99,lmtp2nntp:[243,301],lmtp:[8,40],lmtp_admin:[41,100,239],lmtp_allowplaintext:100,lmtp_downcase_rcpt:[99,286,301],lmtp_exclude_specialus:301,lmtp_fuzzy_mailbox_match:102,lmtp_over_quota_perm_failur:[41,248,301],lmtp_strict_quota:[41,248,301],lmtp_strict_rfc2821:301,lmtpa:27,lmtpd:[19,40,41,87,98,100,102,146,147,149,154,159,164,170,189,191,193,194,197,218,231,239,246,248,251,260,265,275,279,282,284,299,300,301,309,327,330,332],lmtpengin:[98,100],lmtpproxyd:[87,99,100,102,238,239,240,275,299],lmtpsocket:[96,218,231,246,301,395],lmtptest:[99,299],lmtptxn_timeout:301,lmtpunix:[27,87,218,286,300,330,332,334,335,343,346,347,348,358,362,363],load:[5,7],loader:[49,231,246,351],loc:169,local0:301,local4:97,local6:[41,97,218],local7:301,local:[3,5,6,7,11,36,40],local_onli:74,local_rule_0:243,localdefs:269,localdomain:251,localhost:[18,28,41,66,82,83,84,86,87,218,240,243,251,300,301,325,328],localpart:[40,161,217],localtim:255,locat:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228],lock:[1,4,5,6],lock_debugtim:301,lock_exclusive:[47,59],lock_expir:6,lock_nonblocking:59,lock_opt:74,lock_own:6,lock_ownerid:6,lock_shared:[47,59],lock_token:6,locker:99,lockfil:283,locktyp:59,lodg:0,log:[3,5,11,13,18,19,40],log_debug:301,logfil:337,logic:[3,5,7,11,46,55,56,97,150,156,308,333],login:[3,5,18,19],login_sasl_cli:68,login_unix_getspnam:97,login_unix_pwcheck:97,login_unix_shadow:97,logindisabled:[82,83,84,86,87],loginrealm:[41,301],loginuseacl:[41,99,301],logout:18,logrot:218,logtimestamp:[97,301],longer:[11,46,74,80,97,98,99,100,102,107,142,145,146,147,158,159,160,161,162,164,165,168,169,170,171,172,185,186,187,188,189,190,191,193,194,195,196,197,205,206,207,208,210,211,212,213,214,215,217,225,237,240,241,260],longest:108,longev:292,longstand:98,longwind:47,look:[11,18,33,36,40,41,44,45,47,48,51,52,55,56,58,62,66,72,74,79,80,91,96,97,98,156,158,194,210,213,214,215,218,231,237,238,239,265,266,271,290,301,325,338,391],lookup:[40,41,76,88,99,100,222,223,225,237,243,268,301,319,325],loop:[44,45,55,74,97,98,99,137,141,195,294],loopback:253,loos:[28,237],lorem:80,lose:[7,11,58,74,153,160,194,217,237,239,290],loss:[11,58,80,81,159],lost:[41,74,80,145,155,226,239,260,286,340,359],lot:[6,24,44,46,51,74,98,105,140,141,153,154,174,175,176,177,178,179,180,181,182,183,184,218,226,227,232,243,251,275,282,368,395],love:[27,52,70,71,80,217,290,391],low:[55,58,237,264,301,328,383],lower:[1,15,27,56,237,292,301],lowercas:[56,99,301],lowest:[9,30,58,227],lqm:325,lqr:325,lrp:41,lrsp:41,lrswip:41,lrswipcda:61,lrswipkxt:325,lrswipkxtea:[41,310],lrswipkxtecda:41,lrwipkxtan789:88,lrwipkxtan9:88,lrwipkxtan:88,lsb:217,lseek:55,lsub:[63,97,121,137,141,153,156,237,239,301,325,380],ltd:393,ltmp:158,lucent:117,luck:[80,97],luke:40,lukecag:40,lun:3,lvm:11,lwi:41,lwn:11,lyndon:97,lynx:197,machin:[1,11,40,56,64],maciel:393,macos:134,macro:41,mad:265,made:[4,7,44,45,46,51,55,57,58,68,74,80,91,97,98,100,107,108,139,151,152,154,169,217,238,239,241,257,300,301,306,355,389],mageia:81,magic:[41,44,47,58,75,100,233,353],mahoroba:100,mai:[3,5,7,8,9,10,11,18,19,25,27,30,31,33,36,38,40,41,44,45,49,51,52,55,56,57,58,60,68,69,74,75,80,81,87,90,96,97,98,99,100,102,130,158,164,170,187,189,211,212,213,214,215,217,218,222,224,225,226,227,228,229,230,231,232,233,235,237,239,240,241,243,245,246,247,248,249,253,255,258,260,261,262,264,269,271,275,281,282,286,287,289,290,291,292,293,294,300,301,305,310,314,316,319,325,337,340,353,354,355,359,365,366,369,370,372,373,375,376,377,378,379,381,382,389,390,391,392,395,398],maiden:19,mail1:239,mail1_password:239,mail2:239,mail2_password:239,mail:[0,3,5,6,11,13,15,18,19,22,27],mail_us:18,mailalternativeaddress:5,mailbox:[1,3,4],mailbox_append_index_record:47,mailbox_badformat:97,mailbox_cacherecord:47,mailbox_clos:[47,58],mailbox_commit:47,mailbox_cr:47,mailbox_creation_distribut:9,mailbox_default_opt:[108,301],mailbox_delet:47,mailbox_delete_cleanup:47,mailbox_deleted:[47,58],mailbox_id:74,mailbox_index_repack:47,mailbox_index_unlock:47,mailbox_initial_flag:301,mailbox_it:47,mailbox_iter_don:47,mailbox_iter_init:47,mailbox_iter_step:47,mailbox_lock:59,mailbox_lock_index:47,mailbox_messag:74,mailbox_needs_repack:[47,58],mailbox_notsupported:97,mailbox_open_exclus:47,mailbox_open_irl:47,mailbox_open_iwl:47,mailbox_read_index_record:47,mailbox_rename_copi:47,mailbox_rewrite_index_record:47,mailbox_unlock_index:47,mailboxacl:[228,301],mailboxdb:343,mailboxe:74,mailboxes:[61,206,207,208,210,211,212,213,214,215],mailboxexist:194,mailboxid:[27,301],mailboxids:[206,207,208,210,211,212,213,214,215],mailboxlist:326,mailboxptr:47,maildrop:110,mailer:[40,218,243,395],mailer_definitions:[218,395],mailert:40,mailfoldernam:255,maillog:[18,286],mailman:383,mailnotifi:[41,99,301],mailoffsit:260,mailproxi:239,mailrepl1:260,mailrepl2:260,mailserv:218,mailspool:[14,102,265,301],mailstor:[61,69,219,260,265,287,334,335,347],mailto:[27,161,345,380],main:[28,44,45,55,66,68,80,229,230,231,233,234,237,260,270,287,307,395,398],mainli:[108,301,314,355],mainlin:330,mainstream:158,maintain:[6,10,11,22,33,35,36,38,41,46,47,48,52,71,72,75,84,90,97,219,222,225,226,229,237,239,241,262,267,295,383],mainten:[44,49,300,319,337],major:[56,81,97,99,100,106,158],make:[0,1,7,10,11,12,18,25,35,36,40,41,44,45,47,48,49,51,52,53,55],make_chang:47,make_md5:136,make_sha1:136,makedepend:97,makefil:[48,52,80,97,99,174,177,178,179,180,181,182,183,184],makemak:49,male:19,malet:152,malform:301,malici:88,malloc:[47,55,80],man:[1,18,19,49],manag:[6,11],managesiev:[98,107,108,196,239,251,301],managesieve:[99,100,251,376,377],mandatori:[3,158,210,213,214,215,241,355],mani:[5,11,19,24,36,41,44,47,55,58,62,70,74,75,80,93,97,98,99,100,150,153,154,187,197,217,226,229,231,237,239,243,260,261,264,271,275,281,290,294,300,301,329,332,348,360,392,393,395],manifest:193,manipul:[41,75,121,229,237,251,316,338,376],mann:393,manner:[3,11,24,97,301],manpag:[52,97,194,226,267,328],manual:[48,52,66,72,80,88,90,93,95,194,226,238],map:[6,11,40,41,44,46,47,55,56],map_priv:97,map_stupidshar:97,mapnl:56,mar:[255,338,366],marclaport:196,marco:197,margin:281,mari:[27,303],mariadb:[49,161],mark:[33,38,56,60,75,79,97,136,140,225,237,243,247,251,255,322,328,355,393],markdeliv:97,market:290,markup:301,marri:19,marti:[169,171,174,176,177,178,179,180,181,182,183,184],martin:[99,136,185,251,301,376,380,393],marysmith:305,mask:76,mass:[74,226,243,336],massag:226,massiv:[44,174,179,180,181,182,183,184],masssievec:[251,299],master:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95],master_bind_errors_fat:[210,211,212,213,214,215,301],master_machin:64,master_start_tim:64,master_uuid:64,match:[6,18,41,44,45,47,49,51,52,55,56,58,63,74,76,87,91,95,97,99,102,139,150,154,156,197,217,224,226,231,241,246,251,262,268,301,306,308,314,316,317,324,325,333,340,352,366,395],materi:81,math:51,matt:[389,393],matter:[0,11,47,58,59,80,105,110,147,152,171,289,301,393],matur:90,matuska:185,matveev:393,max:[158,217,301,353,393],max_user_flags:58,maxcallsinrequest:301,maxchild:[87,98,292,300,330,332,334,335,343,346,347,348,358,362,363],maxconcurrentrequest:301,maxconcurrentupload:301,maxdelayedsend:301,maxfd:[99,300],maxforkr:300,maxheaderlin:301,maximum:[7,15,28,74,98,158,174,176,177,178,179,180,181,182,183,184,218,226,248,281],maxlogins_per_host:[158,164,189,301],maxlogins_per_us:[158,164,189,301],maxmessag:[27,159],maxmessages:301,maxobjectsinget:301,maxobjectsinset:301,maxquot:301,maxquoted:107,maxsizeattachmentsperemail:301,maxsizerequest:301,maxsizeupload:301,maxssf:325,maxval:321,maxword:[107,301],may:[33,294],mayadditem:66,mayadmin:66,mayb:[0,49,55,58,72,74,187,210,211,212,213,214,215,260,320,360],maycreatechild:66,maydelet:66,mayreaditem:66,mayremoveitem:66,mayrenam:66,maysetkeyword:66,maysetseen:66,maysubmit:66,mbexamin:[99,106,196,197,217,299],mbname:74,mbox:[74,303,316],mboxcfg:[251,325],mboxconfig:[159,319],mboxev:[174,175,176,177,178,179,180,181,182,183,184,190],mboxkei:4,mboxkey_db:[158,301],mboxlist:[44,45,97,100,146],mboxlist_:47,mboxlist_create_partit:74,mboxlist_db:[158,301],mboxlist_db_path:[231,301],mboxlist_renamemailbox:74,mboxlock:59,mboxmetadata:301,mboxnam:[46,47,59,74,80,189,191,226,314,355],mboxname_lock:[10,59],mboxname_lockpath:[10,96,218,231,301],mboxname_releas:59,mboxpattern1:324,mboxpattern:324,mboxtyp:74,mboxutil:168,mbpath:[97,98,100,114,140,154,206,207,208,210,211,212,213,214,215,299],mbtool:299,mbtype:[228,301],mbtype_deleted:168,mbyte:[52,333],mcmurtri:[152,389,393],mcyru:325,md5:[5,18,41,49,93,99,132,153,301,325,369,370,372,373,375,377,378,379],mda:[26,395],mdn:[97,301,380],mean:[3,6,11,19,28,35,36,40,41,44,45,52,53,55,58,59,69,71,72,74,80,96,97,100,125,141,150,158,162,187,221,222,224,225,226,229,237,239,243,249,251,260,264,265,281,300,301,304,319,330,332,333,344,346,348,360,362],meant:[11,281,329],meantim:[72,74,301],meanwhil:[222,226],measli:28,measur:301,mech_list:93,mechan:[5,8,14,40,41,49,66,68,88,90,93,97,98,99,136,218,224,232,237,239,241,260,264,301,325,369,370,371,372,373,375,377,378,379,380,385,395],mechanisms:[218,395],mechlist:154,media:[15,229,234,290,301,380],meet:[71,88,272],meeuwen:[161,389,393],mega:74,megabyt:282,melbourn:27,mellon:[81,158,219,385,390,392,393,394],melnikov:[389,393],member:[38,41],membership:[49,351],memcheck:80,memmem:129,memmov:97,memori:[9,10,11,30,46,47,49,51],memset:[46,80],men:[219,390],meng:[147,162,170,193,197],mental:97,mention:[41,56,57,108,136,143,225,249,251,398],menu:[97,398],merced:40,mercedesknight:40,merchantability:81,mere:[11,41,55,281],merg:[0,71,88,98,99,100,102,136,170,239,301,360],merit:96,mesh:[260,301],mess:[57,72,74,354],messag:[6,8,11],message:[41,74,250,325,352,380,391],message_guid_size:58,message_id:74,messagecont:[27,228,301],messagehead:27,messages:[27,74,228,301],messeng:[219,390],messi:74,met:[81,390,394],meta:[33,56,58,59,87,142,197,229,262,290,301,339,341],metadata:[6,13],metapartit:[102,229,233,234,261,301],metapartition_fil:[58,102,229,233,234,261,301],method:[5,41,58,59,76,80,87,88,90,95,97,99,110,129,133,161,217,218,219,226,228,237,240,251,301,324,325,327,345,390,398],methodcal:66,methodrespons:66,metric:[235,301],meyer:393,mib:[162,194],mic:301,michael:[147,162,170,193,197],micro:216,microsoft:[301,380],middl:[58,142,216,217,260],midset:[27,228,301],might:[0,7,11,40,44,48,52,56,58,72,74,80,100,158,217,237,239,243,253,254,260,264,265,271,272,279,284,291,300,301,329,395,398],migrat:[7,15,40,98,122,217,229,230,233,253,319],mileston:389,mill:[98,122],million:[11,46,290,394],milter:366,mime:[27,51,56,58,97,99,102,138,147,197,272,301,314,324,380,388],mimetransport:380,mimick:392,min:[72,100,169,301],mind:[11,58,226,227,254],mini:56,minim:[11,12,40,52],minimum:[18,49,74,218,226,235,243,301,360,369,370,372,373,375,377,378,379],minor:[58,97,98,99,100,158,174,179,180,181,182,183,184,216,217,338,353],minpol:301,minssf:325,minut:[72,97,161,218,243,277,300,301,319,366,395],mirapoint:[237,376],mirror:[11,56,390],misc:[99,156,243],miscellan:[100,103,104,105,106,107,114,117,120,121,122],misconfigur:239,mislead:[44,45,97],mismatch:[74,127,159,266],misnam:97,miss:[58,61,72,74,80,93,96,99,110,137,140,145,147,150,151,152,160,161,162,164,174,181,182,183,184,187,189,190,195,218,238,245,300,301,307,353,359,395,398],missing:74,missingok:218,missingstatoverrid:218,mistakenli:105,mit:[41,48,49,66,72,97,346],mithj:74,mitig:[11,264],mitr:[201,202,203,204,205],mix:[44,45,55,58,121,190],mixe:266,mixed:27,mkcalendar:88,mkcol:[88,380],mkdir:[51,97,218,291,395],mkf:11,mkgmtime:97,mkimap:[51,218,261,299],mknewsgroup:[243,299],mkstemp:74,mktime:97,mmap:[55,75,97,142,153,165,290,295],mmap_priv:98,mmape:46,mmddyyyi:303,mnenom:56,mobil:392,mod:[6,338],mod_ssl:49,modal:56,mode:4,model:[11,36],moder:267,modern:[18,46,80,150,219,229,390,394],modif:[6,58,81,97,105,222,237,259,277],modifi:[41,44,45,56,58,60],modseq:[27,47,57,58,74,82,83,84,86,87,109,119,143,187,228,301,338,366],modsequ:108,modul:[5,18,41,44,45,47,49],modulo:98,moench:187,moment:[11,51,82,83,84,86,87],mon:[27,255,338,340],mondai:384,monitor:[11,28],month:[6,11,97,281,290,303],monthli:[158,281],mora:[99,100,137,393],more:[3,5,6,7,9,11,12,13,22,26,27,28,30,33,34,36,40,41,44,47,51,53,55],morgan:141,morn:306,mortal:[219,390],most:[4,5],mostli:[51,97,98,228,264,301,306,310,332,348,355],motd:[97,277,325,332,348],motto:394,mount:[11,28,59,264,278,290,398],mous:398,move:[10,27,36,44,45,47,58,61,65,74,75,88,97,98,99,100,133,141,154,160,174,177,178,179,180,181,182,183,184,194,217,225],movi:290,mozilla:301,msa:3,msg:[58,61,64,97,324,332,348],msg_base:56,msg_date:324,msg_from:324,msg_id:324,msg_subject:324,msg_uid:324,msgno:68,mss:398,mta:[3,26,40,41,82,83,84,86,87],mtbf:[3,11],mtime:[6,97,122],mua:3,much:[6,11,18,44,48,55,56,58,72,74,75,88,97,98,100,136,137,141,143,151,206,207,208,210,211,212,213,214,215,222,228,237,244,260,261,275,301,306],mult:97,multi:[4,5,6],multiappend:[82,83,84,86,87,98,100,380],multilingu:56,multipart:58,multipl:[7,8,11,13,28,36,39],multiplexor:237,multipli:55,multipurpos:380,multithread:265,mung:[71,138,301],munge8bit:[120,301,327],mupdat:[7,36,59,74,87,96,99,109,121,122,141,147,155,162,165,170,171,191,193,217,218,220,236,237],mupdate:[36,109],mupdate_authnam:[239,301],mupdate_config:[102,301],mupdate_connections_max:301,mupdate_password:[239,301],mupdate_port:301,mupdate_realm:[239,301],mupdate_retry_delai:[238,301],mupdate_serv:[239,240,301,343],mupdate_synchron:109,mupdate_usernam:[239,301],mupdate_workers_max:301,mupdate_workers_maxspar:301,mupdate_workers_minspar:301,mupdate_workers_start:301,mupdatepush:[239,310],mupdateslave1:239,mupdatetest:[99,239,240,299],murch:[88,89,92],murchison:[79,97,98,99,269,380,389,393],murder:4,murdermast:238,must:[3,7,11,18,19,31,40,41,44,45,47,49,55,56,58,60,66,68,80,81,87,88,89,91,92,93,95,96,97,100,104,107,109,117,154,158,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,225,226,229,231,232,233,234,235,237,239,241,243,247,251,260,265,266],mutf:97,mutual:[11,40],mvgroup:243,my_next_bestselling_novel:398,my_script:251,mybox:80,myconsist:316,mydb:44,mydestin:3,mydomain:286,myer:97,myhost:286,mynewsgroup:243,mypassword:218,myright:66,myrights:225,mysasl_canon_us:100,myscript:[251,325],myscriptnam:325,mysql:[11,12],myuser:286,nag:41,nagl:104,nah:74,naiv:72,name:[2,3,5,6,7,9,11,15,18,19,27,30,31,33,40,41,44,45,47,48,49,51,52,53,55,56,58,59,61,62,63,66,68,69,71,72,74,80,81,87,88,89,92,93],namelock:[1,46,47,54,57,58],namespac:[3,13,19,27,28],namespace:[33,82,83,84,86,87,97],nas:11,nasti:[59,137,156],nativ:[55,97,237],natur:[11,33,58,227,236,239,241,301],navig:72,ncontent:27,ndate:27,nearli:[206,207,208,210,211,212,213,214,215,395],necessari:[11,40,41,47,51,55,58,59,71,74,75,77,78,87,97,100,106,127,217,218,226,237,241,243,260,278,301,341,353,355,395],necessarili:[5,11,38,74,80,265,325],necessit:392,need_sys_errlist:97,needs:76,negligence:81,negoti:[11,68,82,83,84,86,87,93,98,169,241,301,360,369,370,372,373,375,377,378,379],neighbour:226,neither:[11,36,74,106,243,269,355,394],nerenberg:97,nest:[44,45,55,62,91,143,301],net:[18,40,49,51,80,81,100,109,140,217,265,291,320,337,382],netnew:[41,58,97,100,174,178,179,180,181,182,183,184,243,301,365,380],netscap:[97,237,301],netscape:[82,83,84,86],netscapehack:97,netscapeurl:301,network:[7,11,41,46],never:[25,40,47,56,57,58,59,80,97,141,152,226,237,239,243,269,292,301,355],new_cr:97,new_fnam:74,newer:[6,44,80,97,108,113,120,158,187,217,286,301,333,355,359],newest:72,newgroup:243,newhost:87,newimap:217,newlin:[41,97,266],newmailboxptr:47,newman:[97,272,393],newmboxlist:310,newmboxname:74,newmod:56,newnam:[47,325],newnew:301,newnews:[100,243,301,328,344],newpart:47,news2mail:[243,277,325],news:301,newsaddhead:301,newsfe:97,newsgroup:[41,97,100,220],newsgroups:100,newsmast:[243,301],newspeer:[243,301,344],newspostus:[243,301,344],newsprefix:[243,301,344],newsrc:[231,301],newsrc_db_path:[231,301],newsspool:97,newsstamp:328,next:[6,9,11,18,24,25,28,30,44,45,47,48,49,56,58,60,72,74,76,80,82,83,84,85,86,87,174,175,176,177,178,179,180,181,182,183,184,218,226,227,231,237,243,247,251,260,301,306,389,395],nfrom:27,nghttp2:49,nginx:[7,36,220,236,239],nic:[3,40,185,393],nice:[74,141,237,266],nicknam:[6,185],nicola:393,night:[219,281,390,394],nightli:[51,226],nil:[27,58,162,277,301,366],nis:40,nist:301,nix:[87,217],nmessag:27,nmime:27,nntp:[13,35,41,49,51,58,87,96,100,114,140,218,220,237,239],nntpclient:[51,217],nntpd:[87,100,111,112,114,139,140,143,146,155,218,239,243,260,299,301],nntptest:299,nntptimeout:[114,301],no_atomic_rename:[82,83,84,86,87],no_received:27,no_relays:27,noarg:55,noauth:301,noauthent:325,nobodi:[0,71,85,384],node:[3,7,11,13,36,218,264,301,310],noinferior:225,noisi:[51,301],nomin:389,non:[7,12,33,41,44,45,46,47,56,58,59,68,74,80,87,88,93,97,98,110,126,131,139,158,159,162,186,190,191,197,218,220,222,223,224,226,237,252],nonconform:272,none:[6,11,15,19,28,88,91,158,218],nonexist:[74,97,160,187,192,194,301,339],nono:273,nonsens:147,nonzero:[58,68],noop:139,nopasswd:51,nor:[36,60,74,106,226,227,243,247,281,295,298,301,319,355,381],norbert:159,norc:325,normal:[6,11,13,38,41,44,45,52],normalis:[186,301],noselect:[97,141,237],nosync:[100,312],notabl:[99,301],notat:[301,303,316],note:[1,2,4,7,9],notebook:392,notes:52,notesmailbox:301,notfound:66,noth:[3,11,25,56,57,64,97,147,193,219,233,237,278,301,355,390],notic:[0,41,44,58,72,74,80,81,97,98,99,100,152,218,292,301,353],notice:41,notif:13,notifempti:218,notifi:[11,41,75,87,96,99,100,102,158,218,231,246,251,265,301,324,330,332,334,335,343,345,346,347,348,358,362,363,380],notify:27,notify_extern:[301,345],notify_unix:98,notifyd:[41,87,99,161,174,176,177,178,179,180,181,182,183,184,218,228,299,300,301,330,332,334,335,343],notifysocket:[96,218,231,246,301,345],notl:[169,325],notspam:301,notwithstand:[3,11,13],nov:338,now:[5,9,11,28,30,33,41,44,46,47,48,53,55,56,58,61,72,74,75,80,81,82,83,84,86,87,96,97,98,99,100,102,104,105,106,117,122,125,131,132,133,134,136,145,146,147,149,150,153,154,156,158,159,160,161,162,163,164,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,193,194,195,196,197,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,218,225],nreceiv:27,nss:[41,224],nss_ldap:[41,224],nsubject:27,nthi:27,ntht:380,ntlm:[93,380],nto:27,ntoz:229,nuanc:255,nul:[56,75],num:[28,41,58],num_record:47,number:[4,6,7,9,11,15,25,27,30,34,41,47,48,52,55,56,58,62,64,75,76,80,96,97,98,99,100,102,110,152,154,155,158,170,174,176,177,178,179,180,181,182,183,184,216,219,226,227,237,239,241,243,248,250,253,259,260,265,270,275,277,288,290,292,300,301,303,304,316,319,321,325,329,330,332,334,335,337,338,344,345,346,347,348,355,358,359,367,369,370,372,373,375,377,378,379,389,390,395],numrecord:58,nurtur:11,nvfsbc:74,nwdiag:52,nye:393,nyota:33,o_dsync:99,o_rdwr:55,obata:[139,140],obei:[46,97,110,145,158,301],obfusc:5,object:[3,11,41,44,47,49,58,61],object_storage_:[174,176,177,178,179,180,181,182,183,184],object_storage_dummy_spool:301,object_storage_en:301,objectclass:301,objectstor:[174,176,177,178,179,180,181,182,183,184],obligatori:361,obscur:[71,97],observ:[9,30,227],obsolet:[58,154,225,301,380],obtain:[3,5,40,41,47,66,74,91,97,225,226,241,256,281,301,306,371],obviou:[237,265],obvious:[74,226,281,301],obviousli:12,occas:59,occasion:[55,58,61,97,266],occur:[8,11,19,27,44,45,56,74,75,80,97,100,125,150,151,158,190,198,200,201,202,203,204,205,206,207,208,216,226,228,237,238,241,248,251,260,283,292,301,306,319,339,355],occurr:301,oceana:[97,98,99],oct:[27,338],octal:218,october:65,odd:[216,353],off:11,offer:[10,11,18,154,158,236,239,281,301,359],offic:392,office:[81,96,218,219,245,380,392,395],offici:[90,395],offlin:11,offset:[55,56,58,74,75],offset_header_crc:58,offsit:260,offsite_shutdown:260,offsite_shutdown_fil:260,offsite_sync_host:260,offsite_sync_port:260,offsite_sync_repeat_interv:260,offsitesync:260,often:[5,7,11,26,36,41,44,55,58,72,218,222,243,246,263,281,292,369,370,372,373,375,377,378,379,382,392],ohio:[98,293],okai:[61,226],old:[11,25,44,46,47,48,51,52,55,57,58,72,74,80,81,96,97,109,134,139,142,152,158,160,162,187,197,217,218,225,248,251,301,303,310,312,325,354,365],old_config_virtdomain:80,older:[2,6,15,48,51,66,72,74,75,80,81,82,83,86,87,97,108,110,141,147,150,158,196],oldest:[72,147],oldimap:217,oldmailbox:47,oldmailboxid:27,oldmboxname:74,oldnam:325,oldschool:301,olduidset:27,olivier:139,olson:[88,311],omit:[41,55,158,224,241,301,316,355],on_backend:9,onc:[9,11,27,30,44,45,55,56,58,59,72,74,95,97,98,100,102,104,136,137,226,227,234,237,243,265,266],once:[3,40,48,53,66,71,72,87,90,95,217,218,226,237,239,240,258,260,369,370,372,373,375,377,378,379,389,395],ondrej:[113,156],one:[6,11,56,218],ongo:15,onli:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48],onlin:[11,28,48,71,80,226,237,251,325,384],only:[6,9,11,30,44,45,55,88,91,97,100,114,218,222,226,227,241,281,301,305,307,319,333,340,342,344,345,352,355,359,360],onto:[7,15,60,79,97,247,363,371],onward:15,opaqu:[44,45,60,247],opcod:75,opcode:75,open:[11,13,36,41,44,45,47,49,55,57,58,59,71,74,80,97,98,99,109,136,139,150,153,158,174,176,177,178,179,180,181,182,183,184,217,218,228,237,241,264,281,290,301,306,369,370,372,373,375,377,378,379,385,393],openbsd:[142,153],opene:44,openio:[174,176,177,178,179,180,181,182,183,184,301],openio_:[174,176,177,178,179,180,181,182,183,184],openio_account:301,openio_autocr:301,openio_namespac:301,openio_proxy_timeout:301,openio_rawx_timeout:301,openio_verbos:301,openldap:[49,100],openssl:[18,49,97,99,115,147,158,172,174,177,178,179,180,181,182,183,184,218,239,266,269],opensuse:[2,12,81],oper:[3,6,8,11,15,18,19,33,41,42,44,47,49,52,55,58,59,60,70],opera:158,operat:[220,226],opinion:11,opportun:[11,28,264,281,301],oppos:[3,58,97,158,225,254,281,325,382],opposit:[44,45,353],opt:[218,269,274],opt_mailbox_deleted:47,optim:[7,11,41,56,97,110,237,264,287,392],optimis:[74,174,176,177,178,179,180,181,182,183,184,301],optimize:97,option:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87],optional:4,options:[52,129,306,307,313,314,320,355,364],order:[3,9,12,19,30,40,41,42,44,45,52,55],orderedsubject:[82,83,84,86,87],ordinari:74,org:[3,5,11,18,19,27,28,33,36,38,40,48,51,55,65,69,70,72,99,100,137,141,201,202,203,204,205,216,251,255,257,260,261,263,277,301,302,305,309,316,320,342,352,366,385,393,395],organ:[6,7,11,19,24,27,55],organis:251,organizer:[76,161],orient:[11,47],origin:[3,5,11,44,53,74,75,77,81,99,130,156,225,253,255,260,272,281,301,306,321,355,390,392,393],original_repository:53,origlist:321,ornl:99,orst:141,oshrin:[389,393],osi:11,ostens:74,other:[3,5,7,9,11,12,13,18,19,22,25,30,31],other_funct:55,othercond:55,otherwis:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],otp:[369,370,372,373,375,377,378,379],ouch:[44,141],our:[3,49,52,66,70,71,74,76,80,81,84,94,99,154,158,216,217,218,230,233,234,237,241,264,270,290,310,381,385,395],ournew:243,ourselv:[68,71,74],out:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],outag:[74,240,264],outbound:265,outbox:20,outbox_sendlat:[208,210,211,212,213,214,215],outbuf:56,outcom:41,outer:99,outgo:243,outindex:56,outlen:56,outlin:[0,5,11,27,217,240],outlook:[102,159,239,301],output:[18,41,44,52,56,58,60,68,72,74,75,80,88,97,99,100,114,127,130,131,142,169,217,218,247,255,258,277,301,303,304,305,306,307,309,310,311,312,313,314,316,319,321,324,325,326,330,332,333,334,335,338,339,343,344,346,347,348,349,352,357,358,363,366,367,371,398],outputfil:356,outsid:[3,27,40,41,56,113,128,146,167,228,243,269,270],outstand:99,over:[5,7,11,36],overal:[11,58],overcom:237,overflow:[99,100,109,111,115,138,139,147,170,185,191,301],overhead:[6,11,41,88,250,251,292],overlai:75,overload:[240,275,319],overlook:398,overrid:[56,58,74,97,100,133,147,217,243,260,277,301,330,355,360],overridden:[44,65,76,231,301,324,325,354],overrun:[80,100,163,186],overshadow:392,overtur:66,overview:[1,4],overwrit:[44,68,77,99,108,191],overwritten:[58,371],own:[1,3,7,11,27,31,33,38,40,41,44,45,51,52,53,74,77],owner:[27,33],ownership:[18,71,218,279],p615:290,p630:290,pace:227,packag:[2,19,49,51,52,65],packet:[219,292,390],pad:[75,301],page:[1,18,19,48,49],pai:96,pair:[6,11,61,207,208,210,211,212,213,214,215,232,265,268,301,307,342],pairwis:51,palauzov:[139,141],pam:5,pam_deni:18,pam_ldap:[41,224],pam_nologin:18,pangolin:87,paragraph:[74,226,300,398],parallel:[11,275],param:[66,301],paramet:[9,11,18,27,30,44,45,46,47,49,51,55,56,62,75,76,88,93,97,100,159,165,186,217,228,239,241,279,281,301,359,380],paranoia:154,paranoid:98,parcel:324,pardon:3,parent:[9,10,30,41,74,142,164,189,223,225,227,237,239,243,246,301,325],parent_id:74,parenthes:[55,62,325],parentid:66,pariti:11,parlanc:80,pars:[47,62,68,74,75,97,98,99,102,104,105,131,134,138,145,151,154,156,158,185,194,226,241,243,251,301,307,321,353],parser:[75,97,301],part1:[9,30,227,229,233,234,301],part2:[9,30,227],part3:[9,30],part4:[9,30],part:[3,5,11,13,19,27,33,40,41,44,45,47,52,56,58,63,71,74,75,80,85,86,93,97,98,99,100,105,145,164,174,179,180,181,182,183,184,189,224,227,237,238,239,243,260,281,291,301,308,314,325,342,355,359,380,390,392,398],parta:[9,30],partb:[9,30],parti:[5,19,27,70,110,228,301],partial:[74,97,98,100,174,179,180,181,182,183,184,197,260,295,301,305,319],particip:[7,11],particular:[5,7,9,11,12,28,30,41,53,58,74,85,97,98,99,100,109,174,176,177,178,179,180,181,182,183,184],particularli:[11,44],partit:[3,4,6],partition:74,partition_mod:9,partition_mode_exclud:[9,30],partition_mode_soft_usage_limit:[9,30],partition_mode_usage_reinit:9,partition_select_exclud:[30,239,301],partition_select_mod:[9,30,227,239,301],partition_select_soft_usage_limit:[30,227,239,301],partition_select_usage_reinit:[30,227,239,301],partli:11,partlist:74,partlist_local_init:74,partlist_local_select:74,partner:[11,61],partstat:76,pass:[40,41,44,45,46,47,48,49,55,56,59,72,74,75,79,80,93,95,97,98,140,152,219,226,237,260,301,305,325,336,359,369,370,372,373,375,377,378,379,389,390],passiv:11,passphras:5,passwd:[41,82,83,84,86,87,97,218,224,369,370,372,373,375,377,378,379,395],password:[5,18,28,41,53,66,82,83,84,86,87,93,97,98,140,154,218,239,243,251,291,301,328,332,348,369,370,372,373,375,377,378,379,380,395],password_column:18,password_crypt:18,past:[6,44,46,48,52,58,72,147,156,218,241,301,303,307,388],pat:56,patch:0,path:[3,9,11,19,27,30,49,51,57,63,65,72,74,80,88,97,127,147,149,154,156],pathnam:[15,99,218,229,230,231,233,234,301,395],patholog:[159,226],pattern:[6,11,45,52],paul:[152,237],paus:[301,359],pavel:[185,194,197],payload:[3,11,36,264,301],pcre:[49,104,152,156,188,191,395],pdf:158,peek:[33,46],peer:[100,243,301,328],peernam:328,pem:[218,392],penalti:11,pend:[85,137,241,389],peopl:[33,55,71,72,80,97,98,240,270,295,367],per:[6,11,40,41,44,45,56,57,58,59,74,88,89,90,93,97,98,102,104,117,122,137,150,158,199,210,214,215,217,220,225,226,229],perceiv:301,percent:[9,30,76,227,239,248,301],percentag:[9,28,30,97,227,306],percentil:30,perdit:[236,237,239],perfectli:[0,11,44],perform:[4,6,7,9],performance:81,perhap:[11,24,33,41,224,247,264],perimet:[7,36],period:[11,41,44,74,88,95,96,98,174,175,176,177,178,179,180,181,182,183,184,218,226,227,241,243],perl5lib:218,perl:[49,51,52,66,74,97,98,99,113,139,152,154,156,174,177,178,179,180,181,182,183,184,190,193,217,218,255,325,329,341],perman:[9,30,41,97,248,255,258,281,301,380,392],permiss:[5,7,19,41,48,55,68,72,81,91,99,191,218,225,237,243,251,280,284,301,325,395,398],permit:[7,13,18,33,41,44,57,81,97,193,225,239,301,344,392],persia:51,persian:[51,219,390,394],persist:[59,97,218,237,301],person:[1,5,13,19,27,28],perspect:[33,281],pertain:96,pertin:248,peski:98,petabyt:11,pf_inet:329,pghmcfc:366,pgp:243,pgsql:[12,301],phase:[58,75,390],philip:[136,141],philipp:[136,141,161,186],phish:324,photo:[39,92,398],php:217,phpdomain:52,phrase:[48,72,369,370,372,373,375,377,378,379,398],phx2:366,physic:[3,11,229,234,301],pick:[38,48,72,74,97,218,301,360,395],pictur:[11,218,395],pid:[27,64,260,265,279,291,301,337,369,370,372,373,375,377,378,379],pidfil:[99,337],piec:[19,44,71,80,97,109,241,398],pile:[137,138],pine:[97,106,239],ping:[237,337],pip:49,pipe:[74,133,274,325,369,370,372,373,375,377,378,379],pipelin:[121,380],pipelining:218,pipermail:[65,383],pittsburgh:81,pkg:[49,162,217],pkg_config_path:65,pkgconfig:[49,65,190],pki:[218,395],place:[7,19,25,31,44,46,47,52,55,58,72,75,80,87,96,99,102],placehold:398,placement:237,plai:[55,61,266],plain:[5,27,41,49,58,82,83,84,86,87,97,120,154,169,218,240,251,289,301,306,325,366,369,370,372,373,375,377,378,379,380],plaintextloginalert:[100,114,301],plaintextloginpaus:[97,170,301],plan:[4,7,11,18,44,47,52,53,71,87,90],plane:56,planner:71,platform:4,pleas:[3,7,11,12,24,25,41,48,49,72,81,82,83,84,85,86,87,94,96,158,162,163,164,186,187,188,189,194,196,197,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,219,222,227,229,230,231,233,237,241,245,251,260,261,267,272,279,289,303,316,359,365,371,381,395],pleasur:79,plu:[11,74,97,100,158,222,226,241,281,301],plug:[129,130,132,133,385],plugin:[93,97],pmr:290,pod:[49,52,174,177,178,179,180,181,182,183,184],point:[3,4],pointer:[44,45,46,55,56,60,68,75,79,97,100,155,247,301],poitra:393,poke:[74,226],pokorra:196,polici:[3,56,84,237,301],poll:[76,301],pollin:42,pollstatus:76,pom:[49,52,174,177,178,179,180,181,182,183,184],poni:394,poodle:380,pool:[55,99,229,230,233,239],poor:[74,359],poorli:239,pop3:4,pop3_last_login:74,pop3_new_uidl:[58,108,338],pop3_show_aft:74,pop3d:[87,97,98,100,110,170,218,239,260,265,266],pop3newuidl:277,pop3proxyd:[87,99,100,299],pop3s:13,pop3showaft:325,pop3test:[99,299],pop:[8,18,35,40,41,58,61,63,64,110,218,219],popd:143,popexpiretim:301,popminpol:[97,164,189,218,301],poppollpad:301,popsubfold:[102,301],poptimeout:[58,277,301],popul:[88,238,310],popular:[3,11,145,392],popuseacl:[100,301],popuseimapflag:[110,301],port:[11,18,68,74,96,97,98,102,210,211,212,213,214,215],portabl:[44,75,97,98,99,100,139,140,309,310],portaddr:329,portion:[226,301,369,370,372,373,375,377,378,379,392],pose:33,posit:[11,56,58,74,300],posix:[10,35,41,188,224],possibl:[3,6,11,18,25,41,44,45,52,55,56,57,58,59,63,68,74,80,88,95,97,98,99,100,108,217,218,224,226,228,229,237,238,239,243,255,271,272,281,290,293,300,301,325,353,359,369,370,372,373,375,377,378,379,389,395],post:[26,28,41,66],postabl:358,postal:[219,390,394],postconf:395,postfix:[3,41,87,218,237,243,251,275,301],postfold:286,postgresql:[12,18,49,107],postman:239,postmast:[33,301],postpon:98,postrot:218,postus:[63,225,301],potenti:[5,11,74,97,99,107,109,152,217,222,226,237,259,301],power4:290,power:[11,13,14,41,58,65,264],ppc:187,practic:[11,36,41,44,45,55,74,226,264],prade:[189,197],prancer_sync_host:320,pre5:177,preauth:105,preauthent:41,preauthor:[334,335,347],preced:[40,56,58,74,277,301],precis:[11,38,44,87,222],preclud:301,precomput:75,predecessor:301,predefin:2,predict:[11,80,226,290],preemptiv:74,prefer:[3,6,28,41,49,51,71,87,95,96,97,131,146,158,218,243,251,270,281,288,289,301,324,353,380,398],prefix:[24,33,41],prefork:[74,87,141,218,226,239,243,251,253,300,304,329,330,332,334,335,343,345,346,347,348,358,362,363,395],pregener:[174,177,178,179,180,181,182,183,184],preliminari:[98,99,172,174,176,177,178,179,180,181,182,183,184],prematur:[68,301],prepar:[44,51,88,89,140,141],prepend:[234,301,344],prerequisit:42,prese:5,presenc:[80,95,258,380],present:[33,56,58,69,74,91,96,133,151,152,217,218,222,231,237,245,260,298,301,310,319,325,327,360,369,370,372,373,375,377,378,379,395,398],preserv:[11,24,41,52,74,98,104,121,162,190,225,226,258,286,301,306,353,355],press:[263,398],presum:[56,74,238,264],pretend:225,pretti:[44,45,51,74,79,222,228,237,290,315],prevent:[3,11,36,40,64,74,84,88,89,92,96,97,99,105,122,194,208,210,211,212,213,214,215,237,264,269,279,294,301,308,361],preview:[52,301],previou:[11,56,58,72,74,97,147,188,218,230,235,237,255,320,392],previous:[9,30,56,60,74,96,97,99,158,170,174,178,179,180,181,182,183,184,187,227,247,301,319,355],prevost:97,price:11,primari:[11,19,40,53,197,219,237,265,266],primarili:[6,11,227,337,392],primary:6,prime256:301,prime256v1:[146,158,301],primit:59,princip:[41,218,224,251,301,302,325,360,361,380],principl:[9,11,80,227],prindevil:[136,141],print:[11,68,80,97,140,145,147,152,160,255,310,315,316,320,322,324,329,333,342,352,354,367,369,370,371,372,373,375,377,378,379],printabl:97,printable:27,printer:310,printf:[68,97],prior:[4,7,9,10,30,74,81,88,93,97,158,187,191,217,218,225,246,281,300,301,324,355,389,390,394],priorit:11,prioriti:[11,74,301],priv:301,privaci:[5,97,304,330,332,344,346,348,362,392],privat:[13,35,159,188,218,243,272,301,325,369,370,372,373,375,377,378,379,385,392,395],privileg:[11,18,35,36,41,88,223,237,337,395],pro:240,probabl:[9,15,18,30,41,47,49,55,58,62,64,72,74,98,102,158,226,227,236,239,255,258,278,293,306,325,353,360,395],probe:301,problem:[8,28,33,41,49,51,56,71,72,74,80,97,98,99,100,108,109,120,121,122,133,159,194,217,218,231,237,239,251],problemat:[11,75],proc:10,proc_path:[10,96,155,218,231,301],proce:[75,80,389],procedur:[74,97,220],proceed:[48,72,237],process:[0,3,5,10,11,12,19,25,35],processor:56,procfnam:97,procp_result:[44,45],produc:[41,52,56,81,131,169,186,218,226,251,260,301,303,306,313,324,325,326,355],product:[2,11,18,51,81,99,211,212,213,214,215],profession:[0,290],profil:[3,53,380],profits:81,program:[2,41,56,74,80],programoutput:52,progress:[66,85,88,98,158,226,359,376,390],prohibit:[11,295,301],project:[12,50,53,71,80,81,82,83,84,86,87,158,170,219,270,303,385,389,390,391,392,393,394],prometheu:[93,201,202,203,204,205,206,207,208,210,211,212,213,214,215,235,301],prometheus_en:[235,301],prometheus_need_auth:[235,301],prometheus_stats_dir:[235,301],prometheus_update_freq:[235,301],promin:[11,281],promot:[74,81,106,264,301],prompt:[41,48,72,97,98,218,279,325,369,370,372,373,375,377,378,379,398],promstatsd:[235,301],prop:128,propag:[237,243,337],proper:[75,76,87,96,218,243,245,248,279,301,395],properli:[18,44,45,56,97,99,104,114,126,153,155,159,161,162,165,188,195,239,272,301,324,332,345,348],properti:[6,56,76,88,145,193,195,218,226,301,315,380,395],propfind:[88,131,187,218],propnam:131,proport:243,propos:[56,237,389],proppatch:88,proprietari:267,propstat:76,prot:[1,54,55],prot_addwaitev:[60,79,247],prot_fil:[74,97],prot_fill_cb:74,prot_flush:99,prot_printf:97,prot_removewaitev:[60,79,247],prot_select:247,prot_waitev:[60,247],prot_waiteventcallback_t:[60,247],protallow:68,protect:[11,18,41,57,68,74,82,83,84,86,87,93,97,98,115,147,170,237,301,304,330,332,344,346,348,349,362,369,370,372,373,375,377,378,379],proto:[74,87,218,300,329,330,332,334,335,343,345,346,347,348,358,362,363],protocol:[1,4],prototyp:97,protstream:[60,247],prove:[41,224],provid:[3,5,6,7,8,10,11,12,13,14,15,19,22,27,33,40,41,44,45,46,48,53,55,58,65,70,71,72,74,80,81,84,88,90,93,96,97,99,100,136,158,211,212,213,214,215,217,218,222,224,227,228,232,236,237,239,243,245,246,248,260,265,270,293,300,301,306,314,315,316,317,320,324,325,327,329,331,336,351,352,354,355,359,360,362,380,381,390,392,393,395],provis:[11,20,66],provision:[13,301],prox:[100,114],proxi:4,proxy:301,proxy_and_backend:301,proxy_authnam:[239,301],proxy_compress:301,proxy_password:301,proxy_realm:301,proxyd:[79,87,98,100,102,237,239,299,301],proxyd_allow_status_referr:301,proxyd_disable_mailbox_referr:[141,237,301],proxyserv:[97,145,239,301],prune:[255,282,303,319,364],pselect:[170,171],pseudo:[9,30,227,239,243,301],psuedo:47,ptclient:[5,97,196,197,231,246,301],ptdump:[97,163,299],ptexpir:[163,299],pthread:293,ptloader:[5,41,49,97,99,100,150,163,165,224,231,246,299,301],ptloader_sock:[231,246,301],ptr:75,pts:4,pts_modul:[301,351],ptscach:4,ptscache_db:[158,301,350],ptscache_db_path:[96,163,197,218,231,301],ptscache_timeout:301,ptskrb5_convert524:301,ptskrb5_strip_default_realm:301,ptsmodule_standard_root_dn:165,ptsock:[231,246,301],pub:39,publican:398,publicli:291,publish:[72,398],pull:50,punctuat:[56,300],purchas:28,pure:[58,74,88,237],purg:[11,24,25,27,58,102,138,158,243,264,266,278],purifi:97,purpos:11,purposefulli:25,purposes:55,purview:41,push:[27,36,48,50,53,58,72,74,158,174,176,177,178,179,180,181,182,183,184,220],put:[1,11,15,19,36,41,56,72,74,75],pwcheck:[87,97,218,301],pwcommand:97,pwd:325,pwer4:290,python:[49,52],q01:[82,83,84,86],qop:130,qos:[136,301],qosmark:301,qresync:[25,58,87,136,140,143,281,301],qualif:3,qualifi:[3,33,40,301,325,344],qualiti:[237,288],quantiti:28,queri:[47,66],querychang:301,question:[7,33],queu:295,queue:[38,41,248,295,301,337,392],quickest:51,quickli:[25,58,74,217,218,222,281,359,392],quickstart:385,quiesc:[232,301],quiet:301,quietli:352,quit:[3,18,41,44,47,74,80,97,98,109,218,233,237,250,251,325,353],quot:[68,97,99,155,241,300,301],quota:4,quota_db:[41,158,231,232,248,301],quota_db_path:[231,248,301],quota_legaci:6,quotadb:[100,191],quotalegaci:4,quotaroot:[6,74,99,100,102,143,156,231,237],quotawarn:[41,248,301],quotawarnkb:[248,301],quotawarnmsg:[248,301],quoted:27,quux:55,r7dfjm9k083763:324,race:[57,58,59,74,98,100,145,147,152,153,185,208,210,211,212,213,214,215,264,301],racl:[217,308],radio:398,raid:[11,58],raii:55,rain:[219,390,394],rais:[11,27,80,325],ralf:[158,393],ram:[7,96,231],ran:[11,80,240,392],rancid:310,random:[9,18,30,74,97,98,110,227,239,255,267,288,301],randomli:121,rang:[47,56,59,97,104,113,115,126,131,145,146,147,167,170,301,303,321,359,380],rank:367,rare:[22,44,152,237,239],raspberri:11,rate:[11,260,301,337],rather:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],ratio:[226,306],rational:[237,272],raw:[44,58,88,218,226,306,322],rawx:301,raymond:393,rc1:173,rc2:[72,173],rc3:173,rc4:173,rcpt:[40,98,218],rdate:76,rdn:5,reach:[9,30,164,189,227],reachabl:292,reactiv:74,read:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43],read_index_record:47,readabl:[6,19,41,57,71,88,217,255,301],reader:[41,47,58,100,303,344],readership:303,readi:[0,56,65,72,82,83,84,86,87,97,217,218,239,241,263],reading:44,readir:107,readlin:[49,325],readme:[97,174,176,177,178,179,180,181,182,183,184],real:[11,12,40,41,74,80,206,207,208,210,211,212,213,214,215,265,290,331,392],realist:72,realiz:56,realli:[0,9,15,30,38,55,56,74,226,227,260,269,272,281,290,301,329,337],realloc:56,realm:[3,5,18,33,41,63,224,301,369,370,372,373,375,376,377,378,379],reappear:141,reason:[11,12,41,44,48,55,74,80,96,97,230,233,251,278,279,282,287,290,294,301,324,332,348,381,392],reauth:[99,369,370,372,373,375,377,378,379],reauthent:97,reboot:[41,218,278],rebuild:[41,49],rebuilt:[6,80,97,217,311],recal:56,recalcul:[41,217,258,307],receiv:[7,18,19,26,27,36,39,40,41,49,68,74,82,83,84,86,87,97,98,210,211,212,213,214,215,218,226,237,239,240,241,243,248,268,295,301,306,327,331,337,381,391,395],recent:[6,11,12,44,47,56,58,66,74,80,88,96,97,174,176,177,178,179,180,181,182,183,184,196,222,225,229,246,301,306,329,353],recenttim:74,recentuid:[47,74],recipi:[3,6,19,40,41],reckon:74,recno:47,recogn:[56,97,376],recognis:[74,217,320],recognit:171,recommend:[4,6,7],recommended:301,recompact:44,recompil:[95,174,181,182,183,184,226,288],recompress:74,reconfig:[74,301],reconfigur:[40,69,237,240],reconnect:[36,99,132,237,238,239,337],reconstruct:6,record:[6,11,18,25,41,44,45,46],record_crc:58,recov:[11,24,25,28,41,74,104,194,218,226,236],recover:[11,226],recoveri:[11,25],recreat:[141,158,217,218,231,255,307],recur:[76,126],recurrence:76,recurs:[55,58,74,80,98,255,301,307,325,333,353,355,359],recursivematch:192,recv:[255,329,366],recycl:337,red:[2,12,81],redact:79,redbot:131,redefin:246,redesign:97,redfish:[136,141],redhat:[49,70,271],redirect:[6,49,50,66,75,77,98,99,197,251,268,301,325,337,380],rediscov:[187,353],redistribut:81,redo:97,reduc:[25,41,47,55,66,74,90,97,102,106,122,139,217],reduct:[237,265],redud:99,redund:[3,4],refactor:[75,98,187],refcount:[44,47,74],refer:[3,5,6,7,12,14,19,33,40,41],referenc:[52,97,251,301,359],references:[82,83,84,86,87,98,146],referr:[41,99,100,120],referrals:[82,83,84,86,87,237],reflect:[97,158,237,241],reformat:58,refresh:[9,11,30,46,227],refus:[74,97,210,211,212,213,214,215,325],regard:[11,81,301,383],regardless:[6,7,11,41,44,45,56,91,109,223,225,232,301,327,355,389],regener:[41,75,217,226],regex:[188,196,251,301,380],regim:46,region:290,regist:[3,27,44,45],registr:[301,380,381],registrar:3,regress:[50,80,100,145,152,156],regul:24,regular:[33,44,45,49,52],regularli:[11,44,52,71,72,279,306],regulatori:[11,25],rehash:[99,142,143,144,232,299,301],reinsert:61,reintroduc:105,reject8bit:[97,301,327],reject:[41,74,75,97,98,99,113,154,159,162,194,197,251,266],rel:[11,30,58,217,226,243,301,306,325],relai:294,relat:[5,6,11,19,30,31,35,41,75,80,97,98,99,100,108,158,226,227,228,229,233,251,260,301,355,380,383,395,398],relationship:[5,226,301,304],relax:140,releas:[1,2,12],relev:[6,11,18,41,52,72,74,93,174,175,176,177,178,179,180,181,182,183,184,226,250,301,359,381],reli:[68,80,96,99,227,237,359],reliabl:[44,143,153,172,174,175,176,177,178,179,180,181,182,183,184,295,390],reload:[220,252],reloc:[87,217,231,325],remain:[11,24,25,44,48,58,59,61,69,76,93,191,225,226,228,255,260,264,281,292,306,319,355,360,389,392,393],remaind:[40,80],remap:302,rememb:[18,48,56,72,74,98,217,227,316,381],remind:27,remot:[18,40,48,53,72],remote:[41,159,224],remotepurg:99,remount:398,remov:[7,11,24,25,27,36,40],removeflag:75,renam:[19,24,36],rename:[36,74,97,98,99,122,142,225,237,301,325],renameing:104,renamemailbox:[255,261],render:[19,52,158],renew:97,renm:325,renounc:97,renown:393,repack:[47,57,58,59,65,152,316],repair:11,repeat:[52,58,171,226,301,360],repl1:260,repl1_shutdown:260,repl1_shutdown_fil:260,repl1_sync_host:260,repl1_sync_repeat_interv:260,repl1sync:260,repl2:260,repl2_shutdown:260,repl2_shutdown_fil:260,repl2_sync_host:260,repl2_sync_repeat_interv:260,repl2sync:260,replac:[11,44,45,47,52,55,60,66,74,76,90,91,97,100,133,136,158,187,218,219,225,227,234,239,247,251,255,272,301,307,380,392,395,398],replai:[156,260],repli:[11,58,68],replic:[1,3,4,6],replica:[11,18,61,108,121,150,152,226,231,237,241],replman:260,reply:76,replyto:301,repopul:74,report:[0,24,41,49,80,88,95,97,98,99,109,112,131,140,147,152,154,156,161,162,163,164,185,186,187,188,189,190,193,196,197,217,218,235,294,295,301,303,306,310,318,324,331,338,352,353,355,360],reportmessag:90,repositori:[44,48,50,51,52],repository:53,repres:[56,60,62,63,68,74,75,207,208,210,211,212,213,214,215,227,241,247,327],represent:[6,33,41,69,75,97],reproduc:[11,81,284],reputedli:158,req:218,request:[9,11,19,30,36,41,44,50],requeu:41,requi:218,requir:[3,4,5,6,7,8,10,11],require:55,reread:[98,337],rerun:80,reschedul:[60,79,247],rescu:[25,301],research:[112,140,393],resent:301,reserv:[33,61,74,81,99,188,191,237,238,239,241,308,325],reserve:[61,74],reserved:[59,237],reset:4,resid:[6,7,15,27,36,41,88,89,91,92,158,229,230,233,237,241,243,281,301,366],resign:389,resili:74,resolut:[58,97,392],resolv:[11,40,75,98,197,237,239,240,301,321],resourc:[1,6,10,27,34,41],resource_acquisition_is_initi:55,respect:[9,27,28,30,40,68,80,93,100,102,199,206,207,208,210,211,212,213,214,215,225,229,237,290,301,306,319,325,355,395],respond:[11,33,36,74,222,241,294,301,304,329,330,332,334,335,343,344,346,347,348,358,363],respons:[6,18,25,33,44,46,58,60,61,66,74],rest:[3,11,36,44,51,55,58,59,72,74,75,194,217,226,243,260,301,376],restart:[44,59,72,74,100,217,218,226,229,239,240,243,259,260,275,286,291,300,301,337,360,398],restful:301,restor:[24,41],restore:74,restore_authnam:[301,355],restore_password:[301,355],restore_realm:[301,355],restrict:[5,11,14],restructur:[48,49,52,174,177,178,179,180,181,182,183,184],restructuredtext:158,result:[3,6,11,18,19,25,33,36,40,52,55,56,63,68,72,74,75,80,88,97,102,131,142,158,187,189,218,222,237,239,241,254,260,264,269,271,274,275,281,283,286,295,301,307,316,324,337,359,398],resulting:81,resum:226,resurrect:196,resync:[33,239],resynch:239,resynchron:[97,237,380],ret:56,retain:[25,59,81,281,301,335,347],retest:80,retext:52,retri:[44,45,74,239,248,275,301],retriev:[3,6,9,30,76,97,222,227,243,281,296,301,328,371],retrofit:287,retyp:[82,83,84,86,87],reus:[74,98,99,100,108,130,218],reuse:55,rev1:262,rev4:[96,218,245,395],reveal:[216,390],revers:[36,40,57,74,100,174,176,177,178,179,180,181,182,183,184,294,301],reverseacl:[174,176,177,178,179,180,181,182,183,184,188,217,301,308],revert:[100,217,325],review:[7,23,53,71,99,239,243,320,389,395],revis:[53,58,390,392],revoc:301,revok:221,rewit:47,rework:110,rewrit:[47,49,58,59,75,143,151,155,187,196,301,307,353],rewritten:[58,59,99,136,301],rewrot:[98,102,107,129,131],rfc2046_strict:[99,301],rfc2047_utf8:[272,301],rfc3028_strict:[100,301],rfc3501:325,rfc3977:100,rfc4315:100,rfc6203:196,rfc822:58,rfc:[8,12,13,14,27,33,34,36,41],rhost:74,rich:[14,221,301,392],richard:393,rid:97,rider:[219,390],right:[5,6,7,11,14,33],rightmost:80,rights:[82,83,84,86,87],ripe:96,risk:[11,44,97,170,324],rjs3:63,rlist:[159,237],rlsub:237,rmgroup:243,rmnew:97,road:[219,390],roadmap:[385,388],rob:[98,393],robert:152,robust:[6,105,139,193,385],roc:98,roland:139,role:[20,36,66,227],roll:[44,45,47,65,74,108,147,150,194],rollback:193,roncero:156,room:226,root:[5,6,11,18,27,33],rosenbaum:99,rotat:[7,64,218,260,265],rough:389,roughli:58,rougli:46,rouillard:152,round:[11,58],roundtrip:44,rout:[3,11,40,380],routin:[7,36,55,56,75,80,97,98,99,158,227,281],row:[33,74,301],rowid:6,royal:[219,390],rpath:[65,293],rpm:[82,83,84,86,259,269,289,381,398],rpost:243,rrule:76,rsa:[10,82,83,84,86,87,207,208,210,211,212,213,214,215,301],rscale:125,rss_feedlist:[91,301],rss_maxag:301,rss_maxitem:301,rss_maxsynopsi:301,rss_realm:301,rst:[48,52,72],rsvp:76,rsync:[65,187,217,359],rsyslog:[217,218],rudolf_sync_host:320,ruin:365,rule:[3,11,20,36,56,69,80,97,226,229,239,243,300,301,380],rummag:[74,226],rumpf:102,run:[1,6,7,10,11,13,18,19,25,28,33,35,36,41,44,47,48,49],run_test:80,runawai:154,rundir:246,runner:64,runtim:[69,80,100,158,227,231,288,315,320],s01:[82,83,84,86,87],s_client:18,sa46093:[112,140],sacrif:237,sacrific:[237,359],safe:[48,55,61,72,74,142,162,218,226,237,265,266],safeguard:361,safer:[45,141,158,237,301],safeti:[8,97,100,106,210,213,214,215,306],sai:[11,44,45,72,80,97,218,225,226,265,268,281,290,306],said:[5,7,11,48,72,97,243],sake:158,salt:[18,380],sam:[243,280,303,325,393],samantha:74,same:[3,4,5,6,7],sampl:[2,15,40],san:[11,290],sandbox:[217,218,395],sane:[55,98,174,176,177,178,179,180,181,182,183,184,301],saniti:[61,64,121,218,324],sas:11,sasl2:[49,87,217],sasl_:[226,301],sasl_auto_transit:[41,218,301],sasl_checkapop:99,sasl_client:68,sasl_maximum_lay:301,sasl_minimum_lay:[87,301],sasl_opt:301,sasl_prot_any:68,sasl_pwcheck_method:[41,87,218,301],saslauth:[218,395],sasldb2:218,sasldb:[41,218,301,395],sasldblistusers2:[87,218],sasldir:97,saslficat:97,saslpasswd2:[87,218,395],saslserv:100,saslv2:98,sat:[156,366],sata:11,satisfi:217,satur:11,saturdai:281,save:[19,41,47,56,61,72,74,98,109,139,249,260,279,289,301,371],saved:[204,205,206,207,208,210,211,212,213,214,215],savvi:[85,243],saw:341,sbin:[74,251],sbindir:[174,175,176,177,178,179,180,181,182,183,184],scalabl:[4,7],scalar:255,scale:[7,11,36,236,237,239,290,392],scan:[27,41,74,82,83,84,86,87],scarf:109,scaveng:[41,289,353],scenario:4,sched:88,sched_tag:6,schedul:[1,6,11,47,73,74],schedule:76,schema:64,scheme:[49,58,74,93,128,196,232,239,243,248,260,301,380],schiller:97,schmiedehausen:98,schult:100,schumach:197,scientif:81,scope:[5,11,40,94,301,392],score:[27,174,176,177,178,179,180,181,182,183,184,366],scott:[98,293],scp:217,scrape:235,scratch:[48,72,227],scratchi:55,screen:[97,324],screw:97,script:1,scriptfil:357,scriptnam:325,scsp:301,sda2:11,sdata:47,sdb2:11,sdk:301,seal:13,seamless:[13,392],seamlessli:226,search:[4,5],search_attachment_extractor_url:301,search_batchs:[65,234,301],search_engin:[65,174,175,176,177,178,179,180,181,182,183,184,234,301,359],search_fuzzy_alwai:[196,301],search_index_head:[65,234,301],search_index_languag:301,search_index_part:301,search_indexed_db:[6,301],search_maxtim:301,search_normalisation_max:301,search_query_languag:301,search_queryscan:301,search_skipdiacrit:301,search_skiphtml:301,search_snippet_length:301,search_stopword_path:301,search_whitespac:301,search_xapian:359,searchabl:301,searched:359,searchpartit:[229,234,301],searchtier:[229,234,301],searchtierpartit:[229,234,301],sec:[44,82,83,84,86,87,301],second:[11,41,47,55,56,58,64,69,74,79,97,155,219,224,226,235,237,238,239,241,251,260,265,300,301,302,304,307,317,319,329,330,332,334,335,337,344,345,346,347,348,353,355,358,359,360,366,380,390,398],secondari:[3,11,19],secret:5,sect:9,section:[3,11,12,26,34,36,41,51,52,56,65,70,72,80,87,88,93,95],sector:[11,58],secunia:[112,140],secur:[3,5,10],securityapprais:99,see:[3,7,9,11,19,25,33,36,38,40,41,46,47,48,49,51,52,53,55,56,58,59,64,66],seek:[80,158],seem:[74,99,100,114,130,218,225,384],seemingli:26,seen:4,seen_db:[58,98],seenstate_db:[158,301],seenuid:74,segfault:[100,114,146,168,169,170,197],segment:[3,237,301],segmul:99,select:[4,6,7],selector:301,self:[28,82,83,84,86,87],selinux:253,selski:[389,393],semanag:253,semant:[46,47,56,59,71,98,99,237,380],semi:222,semicolon:56,semidelai:[25,301],send:[5,11,26,41,48,49,52,68,71,72,74,76,88,97,100,105,162,170,174,175,176,177,178,179,180,181,182,183,184,217],sender:[3,27,41,49,76,243,266,268],sendmail_auth_id:301,sendmailconfig:[218,395],sens:[72,100,295],sensibl:[71,80,237],sensit:[33,97,98,237,301],sent:[10,26,27,33,39,41,44,52,62,74,97,100,152,207,208,210,211,212,213,214,215,218,237,239,241,251,255,258,277,294,301,317,323,324,325,338,353,359,366,381,398],sentdate:[58,338,366],sep:[64,316],separ:[5,6,7,9,11,19,24,25,30,31,33,36,40,41,56,58,63,68,69,70,74,75,91,93,97,98,102,103,150,156,158,175,176,177,178,179,180,218,225,228,229,233,239,241,255,260,264,281,290,300,301,302,303,306,317,321,324,325,332,339,342,348,359,365,366,395],seper:98,seq:104,seqdiag:52,seqnum:338,seqset:321,sequenc:[6,11,56,58,62,68,74,75,97,98,104,105,206,207,208,210,211,212,213,214,215,241,274,277,300,301,316,321,338,360],sequence1:321,sequence2:321,sequence:76,serer:301,sergei:[164,189],seri:[2,56,72,84,96,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172],serial:[75,290],serialis:59,serious:[97,152,275],serv:[11,36,91,93,97,102,226,237,241,243,260,277,294,301,327,330,332,344,346,348,353],servant:110,server:[1,4,5,6],server_side_tls:301,serverdomain:27,serverfqdn:27,serverinfo:[106,169,301],serverlist:[9,30,109,227,239,301],serverlist_mod:9,serverlist_mode_soft_usage_limit:9,serverlist_mode_usage_reinit:9,serverlist_select_mod:[9,30,227,239,301],serverlist_select_soft_usage_limit:30,serverlist_select_usage_reinit:[30,227,239,301],servermetadata:301,servernam:[74,88,89,92,93,239,251,301,325,328,360],serverport:27,servic:[2,3,6,7,9,11,18,27,30,35,40,41,55,68,74,81,82,83,84,86,87],service_abort:99,servicenam:[100,320],services:[74,87,96,158,218,226,239,243,251,260,265,266],session:[3,6,8,18,41,97,98,99,108,158,161,169,185,191,218,231,237,239,241,260,281,301,304,330,332,337,343,344,346,348,364,369,370,372,373,375,377,378,379,398],sessionid:[27,142,228,301],sessionst:66,set:[1,3,5,7,8,9,10,11,13,15,18],set_up:80,setacl:[27,40,109,161,225,237,295,301,325],setaclmailbox:[40,41],setannotation:[159,301],setannotations:[205,206,207,208,210,211,212,213,214,215],setflag:[61,75],setflags:61,setgid:98,setident:90,setinfo:319,setmd:325,setquota:[40,41,98,109,237,239,249,257],setrlimit:[98,170],setseen:[41,61],setseen_al:108,settl:11,setuid:[97,279],setuidvalidity:104,setup:[1,7,12,18,44,52],setvacationrespons:90,sever:[11,19,36,41,52,56,72,75,96,97,98,99,100,105,107,131,132,217,218,229,231,239,240,241,246,248,290,390,395,398],severalfold:75,seward:80,sha1:[58,62,74,104],sha1sum:74,sha384:[82,83,84,86],sha:[87,217],shadow:[41,97],shake:[74,226],shall:[9,30,81,87,227,389],shape:11,shapelib:49,share:[4,5,6],shared:57,sharedprefix:[33,301],sharedscript:218,sharedseen:[58,104,222,225,277,325],she:[33,48,72],shed:80,sheet:91,shell:[33,74,80,97,99,189,218,316,325,342,398],shini:51,shinier:[174,175,176,177,178,179,180,181,182,183,184],ship:[11,49,81,82,83,84,86,87,96,228,264,271,324],shm:10,shoot:7,shortcut:398,shorter:6,shorthand:[33,325],shortnam:301,should:[3,6,7,9,11,12,18,22,25,26,27,30,33,36,40,41,44,45,47,48,52,55,56,58,59,60,63,64,66,68,72,74,75,79,80,82,83,84,86,87,88,89,91,92,96,97,98,99,102,105,158,162,165,198,200,201,202,203,204,205,206,207,208,210,213,214,215,216,217,218,222,223,225,226,227,231,235,236,237,239,241,243,246,247,251,253,255,260,263,265,266],shouldn:[74,80,97],show:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],showalt:393,shown:[15,52,87,226,243,264,300,314,339,365],shut:[74,96,97,99,158],shut_down:55,shutdown:[7,97,99,110,160,170,172,191,260,277,292,300,325,332,348,360],shutdown_fil:360,sibl:98,side:[5,11,13,19,36],siemborski:[98,393],siev:[1,4,6],sieve:[41,74,98,99,237,251,301],sieve_allowreferr:[100,120,301],sieve_duplicate_max_expir:301,sieve_emit_bytecod:75,sieve_extens:[102,164,176,177,178,179,180,189,301],sieve_generate_bytecod:75,sieve_maxscript:301,sieve_maxscripts:301,sieve_sasl_expect_unsolicited_cap:107,sieve_sasl_send_unsolicited_cap:[107,301],sieve_use_lmtp_reject:301,sieve_utf8fileinto:[107,301],sieve_vacation_max_respons:301,sieve_vacation_min_respons:301,sievec:[251,299,336],sievedir:[97,170,218,231,251,301,336],sievenotifi:[41,99,301],sieveshel:[99,251,299,371],sieveusehomedir:[97,218,231,251,301],sig:[158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,210,211,212,213,214,215],sighup:[98,210,211,212,213,214,215,259,301,337],sign:[28,48,53,72,82,83,84,86,87,97,127,140,161,241,286,301,390],signal:[58,98,191,259,277,301,331,337],signatur:[44,48,72,80,88,301,324,380],signific:[5,11,75,99],significantli:[74,100,106,158,217,237,262,359],sigsegv:239,sigserv:239,sigterm:337,sigusr2:193,silent:[44,45,47,143,159,279,301,329],silli:98,similar:[8,9,11,18,47,49,56,66,74,75,77,80,93,108,217,218,226,233,236,237,239,241,243,251,255,260,265,300,392],similarli:[5,55,80,226,239,243,281,300],simon:[105,110,147,152,171,289,393],simpl:[48,55,56,58,59,66,74,75,79,80,91,97,98,100,217,218,236,239,241,243,255,301,325,380,385,389,392,395],simpler:143,simplest:[36,395],simpli:[11,41,55,60,74,75,79,97,158,194,239,243,247,250,293,369,370,372,373,375,377,378,379,395],simplifi:[58,75],simplist:11,simultan:[8,74,226,395,398],sinc:[7,9,11,18,25,30,33,35,44,46,55,56,58,59,61,69,74,91,97,98,99,100,102,103,104,105,106,107,108,109,110,111,114,116,117,118,119,120,121,122,124,127,128,129,130,131,132,133,134,136,137,138,139,140,141,142,143,144,148,150,151,152,153,154,155,156],since:98,singl:[3,4,6],singleinstancestor:[41,301],singular:11,sip:380,siriusit:140,sit:[7,61,66,290],site:[41,44,50,91,96,97,152,156,217,224,232,237,246,248,260,293,301],situat:[11,33,58,137,158,227,281,290],sivtest:[99,251,299],six:71,sixth:359,size:[6,9,11,15,27,28,30,41,55,56,58,59,62,74,75,97,98,100,106,107,108,109,142,147,226,227,228,229,252,255],sizeof:[46,55,80],skeleton:[68,218,239],skip:[6,44,45,47,65,74,75,76,97,99,100,122,301,306,319,333],skiplist:4,skiplist_always_checkpoint:301,skiplist_unsaf:301,skynet:260,slash:[33,98,218,325],slave:[11,87,122,237,239],sleep:[47,260,300,359],sleepycat:293,sleev:74,slide:6,slight:260,slightli:[44,74,79,133,158,239,260,294,301,394],slot1:305,slot:[260,301],sloti30t15:27,slow:[6,11,28,109,138,227,229,266,267],slower:[11,15,51,55,137,229,260,264,301],small:[0,11,13,28,55,74,80,97,98,99,139,141,217,226,261,264,290,341,361,392,395],smaller:[11,15,74,196,226,248,301,333,360],smallest:80,smart:11,smarter:97,smigielski:393,smilint:162,smith:393,smithj:74,smmap:[96,218,245,358,395],smmapd:[96,100,218,245,299,300],smooth:359,smoother:[9,30,227],smoothli:84,smtp:[41,61],smtp_auth_authnam:301,smtp_auth_password:301,smtp_auth_realm:301,smtp_backend:301,smtp_host:301,smtpclient:301,smtpd:87,smtptest:[99,299],snakeoil:218,snappi:66,snapshot:[2,3,8,11,46,51,198,200,201,202,203,204,205,206,207,208],snip:366,snippet:[15,58,218,261,301,381],snmp:[49,98,100,210,211,212,213,214,215,337],snmpd:337,snmpgen:99,snooz:301,snow:[219,390,394],snuck:150,sock_dgram:329,sockaddr_in:329,socket:[5,27,36,40,41,55,64,87,96,97,98,99,100,122,149,154,162,197,217,218,220,231,239],socketmap:[218,395],socklen_t:98,soft:[55,227],soft_noauth:301,softer:301,softwar:[4,11],software:81,solari:[12,97,99,127,148,154,159,169,174,176,177,178,179,180,181,182,183,184],sole:[11,392],solut:[11,19,74,80,136,141,217,218,226,231,236,237,239,264,269,286,289,290,295,301,389,392],solv:[108,133,392],some:[7,10,11,24,25,28,31,33,40,41,44,47,49,51,52,55,56,58,60,61,65,71,72,74,79,80,84,87,88,91,93,96,97,98,99,102,109,115,141,145,147,150,154,158,161,185,187,194,217,218,223,225,226,228,229,231,233,237,239,241,243,247,251,255,259,260,264,269,271,275,279,284,287,288,290,293,295,300,301,304,313,324,325,327,330,332,344,346,348,353,354,359,362,390,391,392,395],somebodi:80,somehow:[74,239],someon:[0,59,72,74,226,286],someth:[18,26,44,48,49,55,58,61,72,74,76,77,78,80,99,217,218,228,230,243,251,255,263,265,272,284,290,293],sometim:[11,26,72,80,100,266],somewhat:[15,47,56,58,80,97,237],somewher:[11,48,58,72,74],soon:[25,44,45,74,100,227,259,289,301,359,395],soref:190,sorri:[74,97],sort:[41,44,45,46,56,58,74,80,82,83,84,86,87,96,98,104,138,141,174,175,176,177,178,179,180,181,182,183,184,241,251,258,277,301,316,353,367,380,391],sortcache_db:301,sortorder:66,soth:98,sound:237,sourc:[2,5,27,41,44,49,51,52,53,55,61,65],sourceforg:[18,80],space:[3,6,7,9,10,11,15,19,28,30,41,52,53,55,56,58,64,68,71,74,93,97,109,139,140,142,158,162,186,197,218,226,227,228,229,233,237,239,241,248,250,255,282,301,303,318,339,359,366],spam:[27,33,41,158,174,176,177,178,179,180,181,182,183,184,251,301,325,338,353,366],spamtest:380,span:[74,126,210,211,212,213,214,215,237],sparc:104,spare:[11,58,290,295],sparingli:55,spars:321,spawn:[96,98,259,260,265,292,300],speak:[3,11,36,41],spec:[56,260,352],special:[1,4],specialus:[159,325,391],specialuse_extra:301,specialuse_protect:301,specialusealwai:[199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,301,380],specif:[6,7,8,11,24,40,41,44,48,49,55,56,58,66,68,72,75,76,91],specifi:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40],speed:[15,58,71,81,99,102,109,219,237,262,301,359,385,390],spell:[52,56,190,263,301],spellman:152,spend:[36,97],spew:97,spf:385,sph:102,sphinx:[49,52],sphinxcontrib:52,spice:51,spil:[162,194],spin:[15,97,121],split:[31,55,58,74,87,97,100,106,109,121,136,197,220,225,226,230,233,252],splitmeta:261,spnego:[93,380],spock:33,spoke:74,sponsor:102,spoof:41,spoofeddomain:324,spool:[7,11,13,15],spous:19,spread:[41,44,74,237,290],springfield:218,sql:[4,5],sql_:107,sql_databas:301,sql_engin:301,sql_hostnam:301,sql_passwd:301,sql_user:301,sql_usessl:301,sqldb:44,sqlite3:306,sqlite:[6,44,49,74,107,190,226,301,368],squat:4,squat_decode_64:140,squatter1:359,squatter:[6,56,65,99,100,106,109,162,185,194,203,204,205,206,207,208,210,211,212,213,214,215,220,229,234,252,260],squattera:359,squirrl:97,src:[55,218],srcdir:99,srctier:359,srs:301,srs_alwaysrewrit:301,srs_domain:301,srs_hashlength:301,srs_secret:301,srs_separ:301,srvtab:[41,97,301],ssd:[11,15,139,229,264,359],ssf:[120,301,304,330,332,344,346,348,362],ssl2:158,ssl3:158,ssl:[5,6,49,55,68,87,93,98,99,105],ssl_accept:105,ssl_ctx_load_verify_loc:68,sslv23:[98,170],sslv2:[98,113,146,170],sslv3:[113,146,170,380],sssd:[41,224],stabl:[2,11,12,48,52,56,72,81,84,87,96,156,159,160,161,162,163,164,165,166,167,168,169,170,171,172,185,186,187,188,189,190,191,192,193,194,195,196,197],stack:[56,75,80,100,138,301],stackoverflow:218,staff:[11,41,224,393],stage:[47,48,64,72,74,90,99,100,191,226,228,281,301],stai:[9,30,53,227,239,333],stale:[74,96,226,260,264,306,316],stall:[174,179,180,181,182,183,184],stamp:340,stand:[7,225,227,230,237,395],standalon:[218,226,237,260,265,295],standard:[7,12,13,27,33],stanza:[217,231],start:[1,10,11,27,33,36],starttl:[18,161,194],starttls:[68,82,83,84,86,87,97,98,105,107,154,162,169,218,239,301],stat:[97,185,190,201,202,203,204,205,206,207,208,210,211,212,213,214,215,226,235,301,306,353],state:[1,4],statedir:97,stateless:[44,66,90,265],statement:[55,75,140,143],station:[219,390],statist:[3,98,99,226,235,301,303],statoverrid:218,statu:[6,27,47,58,61,66],status:4,statuscach:4,statuscache_db:[10,158,301],statuscache_db_path:[10,96,218,231,301],statusdata:47,std:[49,51,100],stderr:[68,100,305,337,360],stdin:[74,154,301,316,337],stdio:[60,68,247],stdout:[44,45,68,74,140,305,309,326,337,357,376],stefan:[112,140],steinar:97,stemmer:301,step:[18,41,44,48,49,56,72,74,76,80,88,95,217,218,228,239,240,253,306],stephen:290,stick:[48,237],still:[3,9,11,19,30,41,44,45,47,50,51,56,58,59,65,71,74,75,79,81,88,97,98,99,104,108,138,151,156,158,174,178,179,180,181,182,183,184,185,187,191,225,226,227,237,238,243,253,271,272,277,281,290,292,293,295,300,301,306,325,354,355,359,366],stipul:229,stock:[82,83,86,87,218],stomach:11,stonith:11,stop:[56,74,75,77,97,152,218,226,238,260,269,301,306,337,339,360,394,395],stopword:301,storag:[3,4],storage:[41,250,325,352],store:[6,9,11,13,15,22,27,30,31,33,36],storeing:98,storm:[24,99,158],straight:[44,45,65,75],straightforward:[227,237],strang:[44,80,239,301],strarrai:191,strategi:[11,217],strcmp:55,strconcat:[80,140],strdup:55,stream:[26,55,56,60,74,79,97,126,241,247,290,306,314,380],strength:[82,83,84,86,87,301,304,330,332,344,346,348,362],strerror:97,stress:[11,70,72],stretch:[36,393],strict:[301,380],stricter:156,strictli:[11,15,150,158,169,229,230,283,301],strike:98,string:[6,33,41,44,45,55,56,58,62,74,75,88,93,95,97,98,99,100,137,160,224,229,233,234,239],stringi:[51,217],stringlist:[75,99],strip:[19,58,88,301],strndup:55,stromso:168,strong:[288,294,301],strongest:[369,370,371,372,373,375,377,378,379],strongli:[40,158,217,239,260,365],strstr:68,structur:[1,6,11],struggl:52,stub:99,stuck:195,student:[392,393],studio:171,stuf:11,stuff:[52,74,97,247,290,324,368,398],stupend:218,stupid:97,style:[18,41,52,55,58],stylesheet:[91,301],styx:196,sub:4,subaddress:[251,301,380],subag:337,subcommand:[41,210,211,212,213,214,215],subdirectori:[41,58,88,97,226,279],subdivid:301,subfold:[9,19,30,33,41,63,102,139,141,142,187,223,227,255,266],subj:[218,255,338,366],subjct:366,subject:[3,7,8,11,27,49,58,66,79,98,100,125,161,175,176,177,178,179,180,181,182,183,184,186,191,222,225,255,301,303,324],submailbox:[63,74,239,355],submiss:[3,41,225,301],submit:[1,36,50],submitserv:301,submitt:389,subpart:58,subscrib:[6,7,19,41,52,88,100,132,137,158,225,239,258,265,301,303],subscribe:[237,325],subscribed:[82,83,84,86],subscript:4,subscription_db:[158,301],subsequ:[6,55,97,158,162,243,277,281,316,325],subset:[88,89,92,237,251,265,307],subshel:325,substanti:[100,194],substitut:[35,48,72,229,233,301,324],substr:[56,99,141,301],subsystem:[44,56,58,59,99,100,122,136,352],subtl:[80,98,255],subtract:301,succe:[44,45,47,59,68,77,80,109,158,174,175,176,177,178,179,180,181,182,183,184,225],succeed:74,success:[4,11,18,19,26,41,44,45,47,55,68,74,80,82,83,84,86,87,99,162,218,225,237,241,248,295,301,395],successfulli:[11,19,82,83,84,86,87,106,210,211,212,213,214,215,225,239,241,301,306,371],successor:[225,290],suck:[44,46,59,72],suddenli:74,sudo:[49,51,80,87,217,218,284,395],suffer:158,suffici:[11,18,25,105,218,301,359,395],suffix:[74,207,208,210,211,212,213,214,215,301,319],suggest:[96,98,218,226,240,269,272,274,290,293,295,389],suid_dump:279,suit:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79],suitabl:[11,40,48],sum:[9,30,41,71,74,227,249,301],summari:[27,49,80,218],summary:80,summer:390,sun:[97,170,171,366],sundai:281,superb:[219,390],supersed:329,supervis:108,suppli:[5,11,41,68,74,93,97,99,100,130,272,293,312,316,319,369,370,372,373,375,377,378,379,381],support:[2,4,7,10],suppos:[3,5,7,9,11,30,59,63,97,100,225,226,227],suppress:[6,13],suppress_cap:[141,301],sure:[7,12,44,47,48,49,53,55,66,71,72,74,87,96,100,158,217,218,226,239,240,243,245,251,259,264,265,269,275,279,289,293,300,301,308,353,384,395],suri:[113,156],surnam:19,surpris:[84,239],surround:398,survei:217,suse:[12,98],suspect:[79,226,239,265],sustain:[158,394],svg:398,svn:[80,398],swap:[33,53,97,217],sweep:[59,337,350],swiftli:11,symbol:[80,189,301],symlink:[59,98,174,175,176,177,178,179,180,181,182,183,184,348],sync:[53,58,61,64,65,74,78,87,108,141,169,194,210,211,212,213,214,215,218,226,231,237,238],sync_:[139,226,260],sync_apply_renam:74,sync_authnam:[260,301],sync_batchs:[174,179,180,181,182,183,184,260,301],sync_client:[64,74,104,108,122,138,145,150,172,174,176,177,178,179,180,181,182,183,184,226,260,265,299,301,304,310,322],sync_compress:[110,260],sync_crc:[74,152,159],sync_crc_annot:74,sync_host:[260,301,360],sync_log:[65,74,226,260,265,301,359],sync_log_chain:[260,301],sync_log_channel:[65,74,226,260,301,359,360],sync_log_fil:360,sync_log_mailbox:47,sync_log_unsuppressable_channel:[260,301,359],sync_mailbox_ful:141,sync_password:[260,301],sync_port:[260,301],sync_realm:[260,301],sync_repeat_interv:[260,301],sync_reset:[139,151,299],sync_response_pars:265,sync_send_lookup:265,sync_serv:[61,74,104,109,122,143,152,170,226,260,265,299,301,355,360],sync_shutdown_fil:[260,301,360],sync_sieve_list_gener:74,sync_timeout:301,sync_try_imap:[260,301],syncapply:191,syncclient:[260,310,360],syncget:191,synchron:[11,68,93,97,121,122,220,236,237,238,239],synchronis:[66,74,90,226,265],synclog:359,synclogfil:359,syncnew:97,syncproto:190,syncrestore:191,syncserv:[260,362],syncstop:260,synctest:[226,299],syndic:380,synopsis:52,syntact:97,syntax:[15,18,40,52,97,251,269,272,301,325,380,398],synthet:[260,301],sys:[263,380],syscal:290,sysconfdir:231,sysconfig:264,sysctl:[41,224],sysexit:[206,207,208,210,211,212,213,214,215],sysflags:[338,366],syslog_facil:301,syslog_prefix:[218,301],syslogd:100,system:[0,1,3,4,6,11],systemctl:[84,217],systemrc:325,t1searchpartit:65,t227:147,t229:147,tab:[6,41,55,71,97,140,263,306,316,398],tabl:[1,6,18],table:[6,18],tag:[1,2,11,42,48],tagged_abov:27,tahr:87,tail:51,tailor:[41,217,246,248],takatukaland:98,take:[7,11,19,25,33,36,40,44,45,46,52,55,56,57,58,59,68,71,72,74,75,79,80,81,96,97,98,99,102,122,217,218,219,226,227,237,239,241,251,253,266,277,281],taken:[7,11,80,100,226,301],talk:[3,6,15,66,71,74,158,218,237,239,260,275,293,301,382,395],tamplin:102,tar:[48,51,72,74,81,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,210,211,212,213,214,215],tarbal:[2,48,49,72],target:[3,7,9,11,27,30,36,52,61,63,64,76,80,98,150],tartaru:65,task:[11,33,36,47,49,58,59,66],tast:235,tasti:74,tcl:[97,98,217,325],tcl_rcfilenam:97,tclconfig:97,tclsh:97,tcp4:300,tcp6:300,tcp:[41,96,138,139,218,237,239,244,245,246,253,260,292,300,301,395],tcp_keepal:[292,301],tcp_keepalive_:292,tcp_keepalive_cnt:301,tcp_keepalive_idl:301,tcp_keepalive_intvl:301,tcp_wrapper:49,team:[12,38,50,53,81,85,87,96,97,171,218,376,381],tear:44,tear_down:80,teardown:1,tech:[41,52,81,303,309,310,353],technet:310,technic:[3,40,56,389],techniqu:[11,290],technolog:[5,11,13,26,81,230,233,264,390,392],teged:187,telemetri:[41,51,97,99,131,134,231,247,266],telemetry_bysessionid:301,tell:[11,31,42,46,71],telnet:[217,218,251,263,381],temp:[74,234,263],temp_path:[226,301],tempfail:295,templat:[52,76,91,93,207,208,210,211,212,213,214,215,301,323,324],temporari:4,temporarili:237,tempsearchpartit:234,ten:282,tenant:33,tend:[9,11,30,44,84,226,227,231,281,300,332,348],term:[11,33,36,49,74,75,109,272,281,301,325,359,366,398],termin:[36,52,56,58,68,75,99,100,218,251],terminated:55,terminolog:236,terribl:239,test:0,test_iovec:80,test_map:80,test_uncast_nul:80,test_whatev:80,testabl:80,testb:152,testc:80,tester:[0,70],testfold:27,testfolder_renam:27,testrunn:51,tests:80,testsaslauthd:[18,82,83,84,86,87,218,395],testslist:75,text1:80,text2:80,text:[5,6,27,48,51,52,56,58,68,74,80,81,87,97,98,100,102,147,174,177,178,179,180,181,182,183,184,218,238,289,301,306,307,309,310,316,324,359,366,380,398],tfz:48,than:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75],thank:[97,98,100,109,110,112,113,137,139,140,141,146,147,152,156,158,159,160,161,162,163,164,168,169,170,171,172,174,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,193,194,196,197,207,208,210,211,212,213,214,215,398],thei:[3,7,9,11,15,19,22,25,30,33,36,38,40,41,44,45,47,48,51,55,57,58,65,72,74,78,79,80,81,88,93,96,97,99,141,158,160,164,170,174,177,178,179,180,181,182,183,184,189,199,217,218,219,225,226,227,229,230,231,237,238,239,241,243,245,249,251,258,259,260,265,272,278,281,283,284,290,293,294,301,308,319,320,325,332,337,340,348,355,390,392,395],them:[3,6,7,10,11,18,25,31,41,44,45,47,48,49,51,55,56,57,58,59,66,71,72,74,75,80,81,88,89,90,92,96,97,100,102,104,158,170,187,210,211,212,213,214,215,217,218,222,225,226,233,237,239,241,243,245,249,251,255,265,272,284,291,295,301,306,321,324,325,328,332,337,342,348,352,353,355,359,360,366,368,392,395],themovieposterpag:324,themselv:[6,28,41,55,56,76,96,146,158,221,222,229,237,239,300,301,353,363],theoret:[44,237],theori:[11,258],thereaft:5,therebi:[11,237],therefor:[3,9,11,26,36,38,41,58,84,96,187,226,262,280,281,294],therein:[11,231,264,338,359],thereof:[11,24,55],thewrittenword:100,thi:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157],thin:80,thing:[3,11,15,41,44,45,47,55,60,72,74],think:[0,11,40,44,46,55,61,72,74,80,81,238,290,301,353],third:[19,27,41,47,70,74,75,97,110,219,228,301,307,317,359,390],thoma:[27,110,113,140,147,168,170,324],thomas_cooper94:324,thomson:380,thorough:239,those:[1,3,5,6,9,11,30,33,40,44,47,71,72,74,76,80,87,88,89,91,92,96,99,133,158,217,218,225,226,227,231,232,233,236,237,238,239,241,251,260,265,271,289,290,300,301,304,307,310,316,317,320,327,330,332,333,334,335,343,344,346,347,348,358,359,360,363,369,370,372,373,375,377,378,379,395],though:[3,5,33,36,44,55,56,72,74,84,97,99,100,225,228,237,239,241,281,290,293,301,329],thought:1,thousand:[3,36,290],thrash:55,thread:[56,80,82,83,84,86,87,98,100,139,141,146,155,174,175,176,177,178,179,180,181,182,183,184,239,243,277,293,301,380,395],threadid:[228,301],three:[3,5,6,7,24,33,36,40,44,45,56,75,225,234,237,241,281,359,380,398],threshold:[15,27,41,74],throttl:359,through:[4,7],throughout:[3,18,44,45,56,58,98,99,255],throughput:[104,237,275],thu:[7,9,30,33,41,56,104,224,226,227,229,237,239,255,300,301,338,395,398],thumb:11,tibbit:196,tibbitt:190,tick:302,ticket:[5,11,41],tickl:97,tidi:[74,141,152,190],tie:51,tier1:[229,234,301],tier1searchpartit:[229,234,301],tier:6,tilt:260,tim:[251,376,393],time:[0,3,6,7,9,11,12,15,25,27,30,36,41,44,47,48,53,55,56,58,60,64,71,72,74,79,80],time_t:[58,60,247,277],timefram:11,timeout:[41,80,100,114,138,147,161,275,301,304,329,330,332,334,335,344,345,346,347,348,358,360,380],timer:301,timestamp:[6,27,58,61,72,74,97,145,228,255,259,301,306,328,380],timestamp_gener:64,timezon:[6,27,51,58,71,88,97,187,210,213,214,215,301,311],timonei:393,timotheu:196,timsiev:[33,87,96,97,98,99,100,105,120,139,169,194,218,239,245,251,265,299,300,301,330,332,334,335,337,343,346,347,348,358,362],timzon:133,tini:[136,226],tinyint:18,titl:[251,398],tld:[251,285,286,301],tls1_0:[146,158,301],tls1_1:[146,158,301],tls1_2:[146,158,301],tls1_3:[188,301],tls:[4,5],tls_:100,tls_ca_:158,tls_ca_fil:[158,301],tls_ca_path:[158,301],tls_cert_fil:[158,301],tls_cipher:301,tls_cipher_list:301,tls_client_ca_dir:[158,218,301],tls_client_ca_fil:[158,218,301],tls_client_cert:[158,301],tls_client_kei:[158,301],tls_compress:[146,158,170],tls_crl_file:301,tls_eccurv:[146,158,301],tls_key_fil:[158,301],tls_prefer_server_ciph:[146,158,301],tls_prune:[162,193,217,218,231,299,300],tls_requir:[93,169,301],tls_server_ca_dir:[158,301],tls_server_ca_fil:[158,301],tls_server_cert:[158,207,208,210,211,212,213,214,215,218,301],tls_server_dhparam:301,tls_server_kei:[158,207,208,210,211,212,213,214,215,218,301],tls_session:4,tls_session_timeout:[218,301,364],tls_sessions_db:[158,217,231,301],tls_sessions_db_path:[96,158,218,231,301],tls_version:[146,158,170,301],tlscache_db:[158,301],tlscache_db_path:[158,301],tlskei:[169,325],tlsprune:[217,218,231,300],tlsv1:[82,83,84,86,87,98],tm_gmtoff:97,tmartin:376,tmp:[44,51,74,77,217,239,251,263,279,301,309,312],tmpf:[59,96,139,217,231,264,266],tmpfile:99,tocdepth:190,todai:[8,11,219,390,393],todd:303,todo:[6,27,41],toe:44,toedtmann:98,togeth:7,token:[44,82,83,84,86,87,97,269,301],told:[80,226],tom:[117,237],tomorrow:11,toni:98,tons:[49,51],too:[5,11,46,58,74,80,88,97,136,137,138,149,153,158,160,161,162,191,194,217,218,231,232,270,281,325],took:[46,260],tool:[1,2,22],toolkit:385,toolnam:[44,45],toomanyarg:55,top:[3,27,33,44,48,55,58,72,80,98,174,177,178,179,180,181,182,183,184,237,239,258,301,325],topic:[53,72,301],toplevel:[52,88,89,91,92,109,158,243,301],topolog:11,tortious:81,tos:301,total:[6,9,11,28,30,58,75,80,227,239,301,338],totalemail:66,totalthread:66,touch:[7,44,259,264,327],toward:[9,11,30,35,40,96,174,177,178,179,180,181,182,183,184,227,257,281],trace:[80,225,301],track:[6,47,58],tracker:381,trade:260,tradeoff:[6,292],tradit:[6,15,52,55,80,102,229],tradition:[3,75,227,237],traffic:[11,33,46,88,100,110,114,120,136,226,301,319,360,383],trail:[19,71,97,98,301,366],transact:6,transfer:[3,7,27],transfig:[49,217],transform:56,transit:[56,98,217,261],translat:[3,6,33,56,69,106,251,301,339,365],translatesiev:[33,190,251,299],transmiss:380,transmit:[5,218,241,294],transp:76,transpar:[7,36,71,74,88,99,237,264,369,370,372,373,375,377,378,379],transport:[5,36,41,66,90,96,218,237,245,246,251,252],trap:55,trash:[19,33,41,66,251,255,258,265],travel:[219,390],travers:[75,98],travi:50,treat:[11,19,41,44,58,91,95,97,167,186,210,214,215,224,243,248,265,294,301,324],treatment:80,tree:[5,10,51,59,75,80,158,162,218,232,237,239,243,261,284,287,301,319,359],trend:98,tri:[97,138,142,162,188,218,284,294,355],trial:[162,163,164,186,187,188,189,196,197],tricki:44,trickier:[56,237],trigger:[24,27,60,87,90,100,228,247,260,265,281,301,359],trim:[74,76,355],trip:[11,97],tripl:11,trivial:[56,218,295],trojan:324,trojita:152,troubl:[74,162,163,164,186,187,188,189,196,197,239,275],troubleshoot:35,truncat:[55,97,108,131,133,139,228,283,301],trust:[5,11,97,158,334,335,347],trusti:87,trycreate:97,tselina:324,tstampfil:328,ttest:27,tue:[324,338,340],tugowar:99,tune:[99,237],turbid:98,turn:[11,40,41,44,80,87,97,98,108,217,226,228,279,293,301,354,380],tweak:[11,97,98,220],twelv:80,twice:[100,145,218,265,300,360],two:[3,4,5],twoskip:4,txt:[56,77,97,99,294,301,309],ty347:302,type:[3,4],typedef:[44,60,68,247],typic:[5,11,27,33,36,41,52,61,64,80,222,225,229,231,248,260,264,281,287,300,301,304,314,316,359,360,381,395],typo:[97,98],tyq4:302,tyranni:71,tyrrel:393,tzid:[6,76],u00fcederli:27,u7f:56,u7n:56,u83:56,u83_2:56,u83_3:56,ubuntu:[2,70,80,81],ucd:98,udp4:300,udp6:300,udp:[87,99,218,253,300,329,330,332,334,335,343,345,346,347,348,358,362,363],udv:255,ufl:290,uggh:74,ugli:[55,62,139],uhura:[33,69],uid:[5,6,27,36,41,47,58,61,74,76,97,122,195,196,226,237,255,277,281,301,309,314,324,338,353,366],uidl:[58,174,176,177,178,179,180,181,182,183,184,277,301],uidl_format:[174,176,177,178,179,180,181,182,183,184,301],uidlast:61,uidnext:[27,58,97,228,301],uidonli:301,uidplus:[82,83,84,86,87,97,100,281,380],uidset:27,uidvalid:[47,58,74,277,338,355,359],uidvalidity:[27,74,97,137,301],uint32:80,uint32_t:[47,80],uint:301,ulimit:279,ulmer:290,ultim:[5,11,158],umanitoba:98,umask:301,umbrella:81,umemoto:100,umich:117,unabl:[3,11,68,74,97,142,210,211,212,213,214,215,218,266,289],unaffect:[98,301],unambigu:62,unanim:389,unauthent:[41,88,122,188,224,241],unauthenticate:139,unavail:[25,74,158,199,200,201,202,203,204,205,206,207,208,236,237],unavailable:[41,289,353],unbind:88,unbound:301,unchang:[6,158],unclear:79,uncom:[87,218],uncommit:[48,72],uncommon:[11,24,36,39,282],uncomplet:126,uncompress:[74,226,306,314],uncondit:75,uncondition:359,unconfirmed:158,uncov:[80,290],undelet:[74,141,220,222,225,252],undeliver:324,under:[5,6,10,11,19,24,25,28,33,35,41,46,47,48,51,52,55,56,57,58,59],underestim:306,undergo:53,underli:[11,44,46,47,59,156,301,353],underlin:52,underneath:[41,239,249,281,353],understand:[0,11,41,44,56,98,217,218,239,325],understood:[11,325],undertaken:219,undesir:158,undetermin:281,undifferenti:74,undocu:106,undocument:277,undump:[74,100,117,153,188,301,307,310],unencod:[56,120],unescap:301,unexpect:[11,97,142,239],unexpung:[25,47,74,106,109,142,145,255,281,299,301],unfortun:[59,98,228,255,332,348],unhappi:80,unicode:56,unicorn:87,unidata2:56,unifi:4,unifix:56,uniform:[236,239],uniniti:97,uninitialis:191,uninterrupt:237,union:[41,74,75,100],uniqu:[3,5,6,11,27,33,55,58,74,137,206,207,208,210,211,212,213,214,215,237,239,260,265,300,301,338,340,353],unique:6,uniqueid:[47,58,61,74,98,104,145,194,226,314,320,353,355],uniserv:98,unite:394,unitialis:187,univers:[3,81,100,102,158,219,385,390,392,393,394],university:81,unix:[27,33],unix_group_en:301,unix_pwcheck:97,unixheirsep:153,unixheriarchysep:139,unixhierarchi:[33,196],unixhierarchysep:[18,33,51,63,87,91,98,99,100,131,145,174,178,179,180,181,182,183,184,217,218,243,251,285,301,313,325,365,366,381],unixhiersep:99,unknown:[187,272,301,325],unlabel:272,unless:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],unlik:[36,80,237,287],unlike:[237,265,319],unlimit:[19,28,140,155,156,167,248,279,300,301],unlink:[24,25,47,58,97],unlock:[44,45,46],unmailbox:[74,322],unmark:75,unmodifi:99,unnecessari:306,unnecessarili:191,unord:[91,301],unpack:74,unpars:[74,138],unpleas:84,unpredict:74,unqualifi:[40,301,325],unreach:237,unread:[38,74,226],unreademail:66,unreadthread:66,unrealm:33,unrecogn:320,unreport:154,unrespons:301,unseen:[6,74,203,204,205,206,207,208,210,211,212,213,214,215],unseenmessag:[27,228,301],unselect:[82,83,84,86,87,151,301,380],unset:[58,301,366],unsign:[47,56,68,97],unsolicit:[61,122],unspecifi:[97,218,306,355],unstabl:194,unsubscrib:[74,100,301],unsubscribe:[97,237],unsuccess:[41,260],unsuit:[88,89,92,270],unsupport:[161,170,391],untag:[68,97,222],until:[8,11,25,26,44,45,47,55,58,59,74,96,102,142,155,158,210,211,212,213,214,215,217,219,226,239,248,253,272,281,300,301,306,337,360],untouch:333,unus:[41,44,49,56,59,74,226,282,292,322],unusu:[56,98],unwrap_str:75,upcom:96,updat:[1,6,7,12,18,36,41,42,45,46,47],update:[48,61,72,76,88,97,100,102,103,109,125],updated:58,updatenotifi:47,upgrad:[33,40,44,58,84,87,97,98,100,110,150,151,153,154,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,185,186,187,188,189,190,191,192,193,194,195,196,197],upgrade:[96,97,154],upload:[42,48,61],upon:[6,9,19,30],upper:[56,161,389],uppercas:[56,141],ups:11,upstream:[11,48,51,53,65,72,100,170,185,228,243,344,381],urandom:[288,301],urg:98,urgent:72,uri:[27,36,122,188,301],url:[6,47,72],urlauth:[6,51,82,83,84,86,87,102,136,301,380],urlfetch:[113,115,146,147,160,167,170,380],urn:[66,301],usabl:[80,312,316],usag:[6,9,30,35,41,44,45,66,74,75,80,90,98,99,102,106,109,138,141,143,152,153,158,160,190,217,226,227,239,248,249,258,260,281,301,318,322,325,338,352,353,359,398],usage:[4,6],use:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35],usefulli:80,useless:56,usenet:[6,41,100,218,243,301,342,380],user:[3,4],user_column:18,user_deleteacl:99,user_deni:4,user_deny_db:158,user_folder_limit:[110,320],user_som:61,user_some:61,useradd:[218,395],userdeni:[146,231,301],userdeny_db:301,userdeny_db_path:[231,301],userflag:59,userflags:[338,366],userid:4,userid_list:368,usermod:[218,395],usernam:[3,5,18,19,33,40,49,51,63,66,88,89,93,99,218,232,239,243,263,280,285,291,301,319,325,329,353,359,395,398],username:53,username_idx:18,username_tolow:301,userpassword:87,userprefix:[33,301],userrc:325,userspac:55,using:[1,18,33,36,41],usr:[49,51,61,65,80,96,97,152,158,187,217,218,231,239,251,255,258,259,260,261,263,269,271,279,301,305,308,310,312,329,331,359,360,395],usual:[6,11,40,41,52,72,74,80,86,98,164,189,218,222,224,226,237,251,261,265,281,301,331,369,370,372,373,375,377,378,379,381,395],uta:98,utc:[366,384],utdalla:[98,99],utf7:301,utf8:[62,272,301],utf8smtp:301,utf:27,util:55,utilis:306,utopic:87,uuid:[49,51,64,122,217,340],uutari:194,v14:203,v16:[204,205,206,207,208,210,211,212,213,214,215],vacat:[6,75,97,98,99,100,102,139,161,251,266,268],vader:[265,291],vain:98,val:55,valarm:76,valentin:172,valgrind:[1,49,51,74],valid:[6,19,33,41,44,45,68,74,98,100,131,164,169,188,189,217,224,241,263,272,300,301,310,319,329],validitii:58,valu:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399],value1:62,value3:62,value:52,van:[161,389,393],vansant:393,varchar:18,vari:[52,255],variabl:[41,44,45,47,49,55,58,71,80,91,97,98,102,155,174,181,182,183,184,188,194,251,254,301,306,337,380,398],variable:55,variant:[41,162],varieti:[5,7,9,10,11,94],variou:[2,11,31,40,41,49,55,58,72,80,88,90],vast:[237,264],vastli:35,vavailability:[23,125,301],vcard:[6,93,185,301,380],vcard_obj:6,vcard_uid:6,vcardfast:51,velasco:[160,169],vendonr:319,vendor:[11,88,99,102,104,117,128,218,222,225,243,270,277,301,319,359,395],ver:325,verbatim:56,verbos:[18,52,74,98,132,301,306,307,311,313,314,319,324,326,333,353,354,355,359,360,361,365,366,369,370,372,373,375,377,378,379],verbose:218,verdor:319,veri:[5,7,11,18,28,36,44,47,48,51,55,56,58,72,75,80,87,97,141,145,218,225,226,232,237,239,243,260,267,294,301,306,310,359,390,391,393],verif:[5,41,49,74,87,158,226,243,259,306,310,369,370,372,373,375,377,378,379],verifi:[5,28,41],versa:[36,241,265,365],version:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47],versions:52,vertic:36,vervet:87,verysecret:5,vevent:[23,132,301],vfreebusy:[23,301],vg_replace_malloc:80,via:[6,11,15,19,28,36,40,41,49,50,51,55,71,74],viabil:11,viabl:293,vice:[36,241,265,365],video:39,videocharg:290,vidic:172,viehmann:110,view:[11,33,42,46,49,52,53,66],vim:217,violat:[44,47,239],virtdomain:[18,40,100,138,161,174,178,179,180,181,182,183,184,191,218,291,301,325,381],virtual:[3,6,8,11,13,18,33],virtual_destination_concurrency_limit:395,virtual_destination_recipient_limit:395,virtual_mailbox_domain:395,virtual_mailbox_map:395,virtual_recipi:395,virtual_recipient_domain:395,virtual_transport:395,viru:27,virus:[251,324],virusscan_notification_subject:[301,324],virusscan_notification_templ:[301,324],virustest:380,visibl:[41,88,158,225,237,301,325],visit:[44,353,383],visual:[48,398],visudo:51,vivid:87,vjournal:[23,301],vladimir:98,vnd:[27,228,301],volatil:10,volum:3,volunt:85,vote:389,vpath:190,vpoll:23,vsd:290,vtimezone:[76,88,93],vtodo:[23,301],vulner:[154,380],vzic:[88,133,301],wai:[11,12,31,40,41,44,47,52,55,58,59,60,72,74,80,87,97,141,150,158,194,224,225,226,227,233,236,237,239],wait:[11,15,26,44,47,58,71,72,74,88,259,300,301,304,306,329,330,332,334,335,337,344,345,346,347,348,355,358,360],wait_interv:360,waitev:247,walk:281,walkthrough:53,wall:[49,51,79],wallet:11,walter:[98,393],wamerican:217,wan:260,want:[0,5,11,18,26,33,41,44,47,51,52,53,57,65,66,72,74,79,80,81,83,84,87,88,97,158,162],wanttowrit:68,warm:290,warmuth:159,warning:[41,47,353],warranties:81,wart:62,wasn:[97,98,100,156,226,393],wast:99,water:[97,243,328],wbreyha:140,wcw:98,web1:320,web2:320,web:[11,22,36,66,88,89,93,199,251,290,301,380,382,383],webdav:[6,88],webmast:33,webserv:36,websit:[11,42,48,52,56],websocket:[49,205,206,207,208,210,211,212,213,214,215],wed:338,week:[39,281,366,389],weekend:[24,39],weekli:[218,384,385,397,399],weight:4,weiler:393,weird:[44,97,100,102,218],welcom:[0,296],well:[5,7,10,11,13,19,25,31,33,40,44,45,46,47,48,51,55,58,61,68,74,79,97,98,99,100,122,133,150,158,217,218,222,225,227,233,237,238,239,241,255,260,266,281],went:[74,97,109,217],were:[9,11,30,38,41,44,58,74,80,96,97,98,99,108,127,139,141,147,158,170,187,224,225,226,227,238,253,255,258,295,300,301,319,323,328,338,339,353,355,359,390],werewolf:87,werror:[49,51],wextra:[49,51],wget:217,what:[1,3,4,5],whatev:[41,44,45,55,80,88,97,217,218,224,226,239,289,290,301,353,381],whatsoev:81,whatsoever:81,whatwg:[210,214,215],wheaton:98,when:[3,4,5,6,8],whenev:[50,55,58,59,97,241,243,255,301],where:[1,3,5,7,11,13,26,33,36,41,44,47,49,51,55,56,58,59,60,61,74,75],where_claus:18,wherea:[75,226,260],wherein:234,wherev:133,whether:[3,7,38,44,45,53,56,68,74,80,81,87,88,93,97,98,100,102,104,120,158,216,218,222,225,227,235,255,260,277,301,325,355,359,395],which:[3,5,6,7,9,10,11,15,19,24,25,27,30,31,33,34,36,38,40,41,44,45,46,47,49,51,52,53,55,56,58,60,61,62,64,65,66,68,71,72,74,75,79,80,82,83,84,86,87,88,89,91,92,93,96,97,99,100,102,104,106,109,110,121,122,125,137,138,139,145,150,152,153,154,156,158,174,175,176,177,178,179,180,181,182,183,184,187,190,206,207,208,210,211,212,213,214,215,217,218,219,223,224,225,226,227,228,229,232,233,234,235,237,239,240,243,247,248,249,251,260,261,264,265,266],whichev:[88,109,271],whilst:319,white:393,whitespac:[19,56,97,98,186,239,300,301,302,342],who:[0,5,18,19,33,41,71,72,80,97,156,170],whole:[11,58,80,158,219,281,301,390,392],whom:[27,221],whose:[9,30,41,88,210,211,212,213,214,215,217,239,283,301,306,314,320,325,355,360,368,369,370,372,373,375,376,377,378,379,394],why:[11,33,51,56,58,71,74,218,266],wide:[13,49,58,237,253,277,295,313,392,394],widespread:392,widget:72,width:[58,301],wierd:154,wiggl:226,wiki:[55,70,301],wikidb:309,wikipedia:[51,55,80,219],wildcard:[140,317,325,353],wildmat:[6,91,243,301,316,328,342],wili:87,wind:74,window:[11,52,99,210,214,215,217,380,398],wire:[5,11,58,62,74,93,241,301,385],wisdom:[217,269],wise:392,wish:[8,41,47,87,97,174,177,178,179,180,181,182,183,184,194,217,224,226,232,237,251,253,255,260,301],with_ldap:154,within:[3,5,6,11,14,15],without:[3,6,7,11,12,15,18,24,28,33,40,41,44,45,47,49,53,55,56,57,58,59,64,69,70,72,74,75,80,81,88,95,97,98,100,120,129,140,141,142,150,153,156,162,170,186,187,192,194,217,218,224,225,226,227,229,230,237,240,241,251,253,258,260,293,301,306,312,316,319,322,323,324,355,361,367,380,392,395],wno:[49,161],woefulli:247,wolfgang:[140,146,147,160,161,162,171,193,194],won:[15,47,48,74,98,141,174,179,180,181,182,183,184,225,237,238,239,248,279,291,301,355],wong:[98,393],word:[3,7,41,46,55,62,66,80,97,158,197,281,290,301,359,398],work:[0,1,5,11,18,33,40],workabl:226,workaround:[11,74,97,134,293,301],worker:301,workflow:74,workshop:11,world:[41,42,61],worst:290,worth:[7,11,53,98,158,226,384],worthwhil:81,would:[3,5,7,8,9,11,16,17,18,26,29,30,33,34,36,37,38,40,41,44,47,48,52,56,58,59,69,72,74,75,80,81,88,89,92,96,97,98,99,109,138,154,158,164,187,189,211,212,213,214,215,217,218,225,226,227,229,230,237,238,239,248,253,260,264,281,290,293,300,301,306,310,316,323,324,325,333,341,359,360,365,381,382,390,395],wouldn:74,wrap:[47,105,197],wrapper:[44,45,55,74,80,97,98,194,243,274,300],writabl:[18,44,217,301],write:[0,3,6,7,11,13,41],write_bodi:131,writeabl:[10,251],writefil:140,writer:58,writeutf8:56,written:[6,7,11,16,17,29,36,37,46,47,55,56,58,68,80,81,85,97,98,144,158,243,287,308,325,359,365,390],wrong:[48,51,55,72,74,97,141,217,301,352,368],wrote:[44,47,48,71,79],wrt:74,wslai:49,www:[36,40,70,81,216,218,301,385,395],x509:218,x86_64:[49,65,271],xapian:[6,44,49,51],xapianact:4,xapplepush:[174,176,177,178,179,180,181,182,183,184,228],xavier:[187,189],xbackup:[226,301],xbackup_en:[226,301],xcal:[133,380],xconversations:[90,301],xconvmodseq:74,xconvmultisort:301,xfd:[48,72],xfer:[74,100,121,122,125,140,141,145,147,150,151,152,153,154,156,159,171,189,193,217,237,301,325],xfz:[48,72],xlist:[19,87,145,159,217,301,313],xlt:56,xmalloc:[55,68,80],xml:[27,51,142,165,301,380],xmpp:380,xor:58,xpath:217,xrealloc:[55,100],xref:[9,100],xrunannot:301,xsha1:190,xsnippets:[195,301],xstrdup:68,xutil:217,xxd:49,xxx:[40,44,47,56,237,279],xzmalloc:55,xzvf:81,y2k:328,yacc:[75,97,100],yahoo:[27,228],yann:152,yapc12:158,yeah:74,year:[11,44,152,156,197,290,303,328,385,390],yep:74,yet:[11,19,38,44,45,46,47,51,66,72,74,85],yield:226,yjh:196,yoni:393,york:380,you:[0,3,6,7,9,11,12,15,16,17,18,26,27,28,29,30,33,34,36,37,40,41,44,45,46,47,48,49,51,52,53,55,57,58,59,65,66,70],young:243,your_fork:53,your_username:53,yourself:[2,3,44,45,55],yourserv:235,yum:[82,84,86],yyi:40,zan:197,zephyr:[97,98,345],zephyrgram:345,zero:[19,41,44,45,47,55,56,58,59,68,80,97,98,107,147,154,217,224,226,241,243,248,300,301,302,304,329,330,332,334,335,344,345,346,347,348,353,358],zeroskip:[6,88,90,205,206,207,208,210,211,212,213,214,215,248,301],zhukov:[185,194,197],zlib1g:[49,217],zlib:[12,49,74],zoneinfo:4,zoneinfo_db:[88,301],zoneinfo_db_path:[88,231,301,311],zoneinfo_dir:[88,210,213,214,215,301],zoom:384,zzz:[40,61]},titles:["We need your help","Developers","Download","Glossary","Configuration Guide","Authentication and Authorization","Databases","Deployment Scenarios","Known Protocol Limitations","Mailbox Creation Distribution","Performance Recommendations","Storage Considerations","Supported Platforms and System Requirements","Features","Access Control","Archiving","Kerberos Authentication","LDAP Authentication","SQL Authentication","Automatic Creation of Mailboxes","CalDAV Collections","CardDAV Support","DAV Collection Management","DAV Components","Delayed Delete","Delayed Expunge","Duplicate Message Delivery Suppression","Event Notifications","Mail Spool Partitions","Mailbox Annotations (METADATA)","Mailbox Distribution","Mailbox Metadata Partitions","Message Annotations (METADATA)","Mailbox Namespaces","Quota","Sealed System Design","Cyrus IMAP Murder (Server Aggregation)","Server Side Filtering (Sieve)","Shared Seen State","Single-Instance Store","Virtual Domains","Concepts","IMAP Developer Guide","Developer APIs","CyrusDB API","cyrusdb API","Index API","Mailbox API","Releasing new builds of ancient Cyrus IMAP versions","Compiling","Cyrus Works","Developer Test Environment","Documentation","GitHub guide","Developer Guidance","Cyrus IMAP Server: Hacking","Cyrus IMAP Server: Internationalization","Cyrus IMAP Server: Locking","Cyrus IMAP Server: Mailbox File Formats","Cyrus IMAP Server: Namelocks","Cyrus IMAP Server: prot layer","Cyrus IMAP Server: Replication Examples","Cyrus IMAP Server: Replication Protocol v2.4+","Cyrus IMAP Server: Special Characters","Cyrus IMAP Server: var directory structure","Xapian for searching","JMAP support","Developer Libraries","<strong>imclient</strong> library","Namespaces: a developer view","Overview of Cyrus development environment","Development Process","Releasing Cyrus IMAP","Developer Thoughts &amp; Notes","Notes for backup implementation","Cyrus IMAP Server: Sieve Bytecode","Cyrus CalDAV Scheduling Flowchart","Enabling improved_mboxlist_sort","Cyrus IMAP Server: Notes","Cyrus IMAP Server: Prot Events","Unit Tests","Get Cyrus","CentOS","Debian","Fedora","openSUSE","Red Hat Enterprise Linux","Ubuntu","CalDAV","CardDAV","JMAP","RSS Feeds","WebDAV","HTTP modules","Configuring the MTA","Virus Scanner","Notes for Packagers","Cyrus IMAP 1.x Release Notes","Cyrus IMAP 2.0.x Release Notes","Cyrus IMAP 2.1.x Release Notes","Cyrus IMAP 2.2.x Release Notes","Cyrus IMAP 2.3 Releases","Cyrus IMAP 2.3.0 Release Notes","Cyrus IMAP 2.3.1 Release Notes","Cyrus IMAP 2.3.10 Release Notes","Cyrus IMAP 2.3.11 Release Notes","Cyrus IMAP 2.3.12 Release Notes","Cyrus IMAP 2.3.13 Release Notes","Cyrus IMAP 2.3.14 Release Notes","Cyrus IMAP 2.3.15 Release Notes","Cyrus IMAP 2.3.16 Release Notes","Cyrus IMAP 2.3.17 Release Notes","Cyrus IMAP 2.3.18 Release Notes","Cyrus IMAP 2.3.19 Release Notes","Cyrus IMAP 2.3.2 Release Notes","Cyrus IMAP 2.3.20 Release Notes","Cyrus IMAP 2.3.3 Release Notes","Cyrus IMAP 2.3.4 Release Notes","Cyrus IMAP 2.3.5 Release Notes","Cyrus IMAP 2.3.6 Release Notes","Cyrus IMAP 2.3.7 Release Notes","Cyrus IMAP 2.3.8 Release Notes","Cyrus IMAP 2.3.9 Release Notes","Cyrus IMAP 2.4-caldav Releases","Cyrus IMAP 2.4.17-caldav-beta1 Release Notes","Cyrus IMAP 2.4.17-caldav-beta10 Release Notes","Cyrus IMAP 2.4.17-caldav-beta11 Release Notes","Cyrus IMAP 2.4.17-caldav-beta2 Release Notes","Cyrus IMAP 2.4.17-caldav-beta3 Release Notes","Cyrus IMAP 2.4.17-caldav-beta4 Release Notes","Cyrus IMAP 2.4.17-caldav-beta5 Release Notes","Cyrus IMAP 2.4.17-caldav-beta6 Release Notes","Cyrus IMAP 2.4.17-caldav-beta7 Release Notes","Cyrus IMAP 2.4.17-caldav-beta8 Release Notes","Cyrus IMAP 2.4.17-caldav-beta9 Release Notes","Cyrus IMAP 2.4 Releases","Cyrus IMAP 2.4.0 Release Notes","Cyrus IMAP 2.4.1 Release Notes","Cyrus IMAP 2.4.10 Release Notes","Cyrus IMAP 2.4.11 Release Notes","Cyrus IMAP 2.4.12 Release Notes","Cyrus IMAP 2.4.13 Release Notes","Cyrus IMAP 2.4.14 Release Notes","Cyrus IMAP 2.4.15 Release Notes","Cyrus IMAP 2.4.16 Release Notes","Cyrus IMAP 2.4.17 Release Notes","Cyrus IMAP 2.4.18 Release Notes","Cyrus IMAP 2.4.19 Release Notes","Cyrus IMAP 2.4.2 Release Notes","Cyrus IMAP 2.4.20 Release Notes","Cyrus IMAP 2.4.3 Release Notes","Cyrus IMAP 2.4.4 Release Notes","Cyrus IMAP 2.4.5 Release Notes","Cyrus IMAP 2.4.6 Release Notes","Cyrus IMAP 2.4.7 Release Notes","Cyrus IMAP 2.4.8 Release Notes","Cyrus IMAP 2.4.9 Release Notes","Cyrus IMAP 2.5 Releases","Cyrus IMAP 2.5.0 Release Notes","Cyrus IMAP 2.5.1 Release Notes","Cyrus IMAP 2.5.10 Release Notes","Cyrus IMAP 2.5.11 Release Notes","Cyrus IMAP 2.5.12 Release Notes","Cyrus IMAP 2.5.13 Release Notes","Cyrus IMAP 2.5.15 Release Notes","Cyrus IMAP 2.5.2 Release Notes","Cyrus IMAP 2.5.3 Release Notes","Cyrus IMAP 2.5.4 Release Notes","Cyrus IMAP 2.5.5 Release Notes","Cyrus IMAP 2.5.6 Release Notes","Cyrus IMAP 2.5.7 Release Notes","Cyrus IMAP 2.5.8 Release Notes","Cyrus IMAP 2.5.9 Release Notes","Cyrus IMAP 3.0 Releases","Cyrus IMAP 3.0.0 Release Notes","Cyrus IMAP 3.0.0 beta1 Release Notes","Cyrus IMAP 3.0.0 beta2 Release Notes","Cyrus IMAP 3.0.0 beta3 Release Notes","Cyrus IMAP 3.0.0 beta4 Release Notes","Cyrus IMAP 3.0.0 beta5 Release Notes","Cyrus IMAP 3.0.0 beta6 Release Notes","Cyrus IMAP 3.0.0 rc1 Release Notes","Cyrus IMAP 3.0.0 rc2 Release Notes","Cyrus IMAP 3.0.0 rc3 Release Notes","Cyrus IMAP 3.0.0 rc4 Release Notes","Cyrus IMAP 3.0.1 Release Notes","Cyrus IMAP 3.0.10 Release Notes","Cyrus IMAP 3.0.11 Release Notes","Cyrus IMAP 3.0.12 Release Notes","Cyrus IMAP 3.0.13 Release Notes","Cyrus IMAP 3.0.2 Release Notes","Cyrus IMAP 3.0.3 Release Notes","Cyrus IMAP 3.0.4 Release Notes","Cyrus IMAP 3.0.5 Release Notes","Cyrus IMAP 3.0.6 Release Notes","Cyrus IMAP 3.0.7 Release Notes","Cyrus IMAP 3.0.8 Release Notes","Cyrus IMAP 3.0.9 Release Notes","Cyrus IMAP 3.1 Tags","Cyrus IMAP 3.1.0-dev Release Notes","Cyrus IMAP 3.1.1 Tag Notes","Cyrus IMAP 3.1.2 Tag Notes","Cyrus IMAP 3.1.3 Tag Notes","Cyrus IMAP 3.1.4 Tag Notes","Cyrus IMAP 3.1.5 Tag Notes","Cyrus IMAP 3.1.6 Tag Notes","Cyrus IMAP 3.1.7 Tag Notes","Cyrus IMAP 3.1.8 Tag Notes","Cyrus IMAP 3.1.9 Tag Notes","Cyrus IMAP 3.2 Releases","Cyrus IMAP 3.2.0 Release Notes","Cyrus IMAP 3.2.0-beta1 Release Notes","Cyrus IMAP 3.2.0-beta2 Release Notes","Cyrus IMAP 3.2.0-beta3 Release Notes","Cyrus IMAP 3.2.0-beta4 Release Notes","Cyrus IMAP 3.2.0-rc1 Release Notes","Release Notes","Upgrading to 3.2","Installing Cyrus","Introduction to Cyrus IMAP","Administrator Guide","Access Control","Combining Access Rights","Access Control Defaults","Access Control Identifier (ACI)","Access Control Lists Rights Reference","Cyrus Backups","Mailbox Distribution","Cyrus Event Source","File &amp; Directory Locations","Archive Partitions","Configuration file locations","Directory Hashing","Spool Directories","Search Tiers","Monitoring","Cyrus Murder","Cyrus Murder: Concepts","Cyrus Murder Failure Modes","Cyrus Murder: Installation and Administration","Cyrus Murder Mail Delivery","Cyrus Murder Mupdate Details","HOWTO: Using an NGINX IMAP Proxy","Cyrus NNTP","Ports and Sockets","Cyrus Service Definitions","Cyrus Socket Locations","Cyrus Prot Layer","Quotas","Quota Roots","Supported Quota Types","Cyrus Sieve","Standard Operating Procedures","Running Cyrus IMAP Services on Non-Standard Ports","Alternative Namespace","Deleting and Undeleting Messages and Folders","Mailbox Operations","Mailbox Folders exempt from quota","Reconstructing Mailboxes","Reloading Cyrus IMAP Services","Replication: Installation and Administration","Splitting Metadata from Partitions","Using Squatter for Faster IMAP SEARCH","Managing user_deny.db","Tweaking Cyrus IMAP","System Architecture","Frequently Asked Questions","Which database backend should I use for which databases?","Duplicate Delivery Suppression","Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora","Help! There must be an easier way to get all this going...","OpenSSL Version Mismatches","Why does Cyrus reject 8-bit characters in the headers of my messages?","Why does Cyrus reject messages with &#8220;bare newlines&#8221;?","How do I get Cyrus Sieve to play nice with Exim?","Why does mail delivery go slow or hang sometimes?","How do I view ACLs on a mailbox?","What annotations are available?","Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?","How to enable core dumps","Why can I not delete a mailbox as an admin user?","When is What ... Deleted, Expired, Expunged or Purged?","Why is deliver.db so large?","I have multiple imapd-SERVICES configured and experience occasional freezes when I try to log in!","How to run gdb on Cyrus components","Cyrus delivers claims that the mailbox does not exist","Why is mail being rejected with No Mailbox found due to MiXed CaSe incoming e-mail?","Can I use MySQL (or another SQL database) as the primary mail store?","Why do POP3 connections take so long, but once the connection is established all is well?","Why does reconstruct -m not work?","Shared File Systems GPFS for high availability","How to enable telemetry","The process count keeps growing!","&#8220;unable to join environment&#8221; error","Why does Cyrus set the MAIL FROM address of the sender of vacation responses to &#8216;&lt;&gt;&#8217;?","Does the Cyrus Murder support High Availability configurations?","Can I configure pop3d to log amount and size of messages fetched by user?","How can I make CyrusSieve work with public shared folders?","Can I have subfolders not appear under INBOX?","Man pages","<strong>cyrus.conf</strong>","<strong>imapd.conf</strong>","<strong>krb.equiv</strong>","<strong>arbitron</strong>","<strong>backupd</strong>","<strong>chk_cyrus</strong>","<strong>ctl_backups</strong>","<strong>ctl_conversationsdb</strong>","<strong>ctl_cyrusdb</strong>","<strong>ctl_deliver</strong>","<strong>ctl_mboxlist</strong>","<strong>ctl_zoneinfo</strong>","<strong>cvt_cyrusdb</strong>","<strong>cvt_xlist_specialuse</strong>","<strong>cyr_backup</strong>","<strong>cyr_buildinfo</strong>","<strong>cyr_dbtool</strong>","<strong>cyr_deny</strong>","<strong>cyr_df</strong>","<strong>cyr_expire</strong>","<strong>cyr_info</strong>","<strong>cyr_sequence</strong>","<strong>cyr_synclog</strong>","<strong>cyr_userseen</strong>","<strong>cyr_virusscan</strong>","<strong>cyradm</strong>","<strong>cyrdump</strong>","<strong>deliver</strong>","<strong>fetchnews</strong>","<strong>fud</strong>","<strong>httpd</strong>","<strong>idled</strong>","<strong>imapd</strong>","<strong>ipurge</strong>","<strong>lmtpd</strong>","<strong>lmtpproxyd</strong>","<strong>masssievec</strong>","<strong>master</strong>","<strong>mbexamine</strong>","<strong>mbpath</strong>","<strong>mbtool</strong>","<strong>mkimap</strong>","<strong>mknewsgroups</strong>","<strong>mupdate</strong>","<strong>nntpd</strong>","<strong>notifyd</strong>","<strong>pop3d</strong>","<strong>pop3proxyd</strong>","<strong>proxyd</strong>","<strong>ptdump</strong>","<strong>ptexpire</strong>","<strong>ptloader</strong>","<strong>quota</strong>","<strong>reconstruct</strong>","<strong>rehash</strong>","<strong>restore</strong>","<strong>sievec</strong>","<strong>sieved</strong>","<strong>smmapd</strong>","<strong>squatter</strong>","<strong>sync_client</strong>","<strong>sync_reset</strong>","<strong>sync_server</strong>","<strong>timsieved</strong>","<strong>tls_prune</strong>","<strong>translatesieve</strong>","<strong>unexpunge</strong>","<strong>arbitronsort.pl</strong>","<strong>dav_reconstruct</strong>","<strong>httptest</strong>","<strong>imtest</strong>","<strong>installsieve</strong>","<strong>lmtptest</strong>","<strong>mupdatetest</strong>","<strong>nntptest</strong>","<strong>pop3test</strong>","<strong>sieveshell</strong>","<strong>sivtest</strong>","<strong>smtptest</strong>","<strong>synctest</strong>","RFCs Supported by Cyrus IMAP","Reporting Bugs","IRC Chat","Mailing Lists","Online Meetings","What is Cyrus IMAP?","Operations","Overview","About Cyrus","Cyrus Bylaws","Cyrus History","Cyrus Roadmap","About Cyrus","Who Is Cyrus","Preface","Quickstart Guide","Setup","Sitemap","Document Conventions","Support/Community"],titleterms:{"case":[9,30,36,227,286],"char":[44,45],"const":[44,45],"default":[12,41,49,96,158,174,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,223,233,234],"delete":[76,241],"export":239,"function":55,"int":[44,45],"long":288,"new":[6,41,48,80,96,146,158,169,196,197,217,243],"public":297,"short":61,"switch":[158,254],"true":237,"try":283,"var":64,"void":[44,45],about:[44,45,50,74,88,90,91,93,95,226,269,388,392,394],acap:56,access:[6,14,33,41,88,89,92,221,222,223,224,225,228,300],account:53,aci:[41,224],acl:[41,222,223,276],aclchang:27,action:[47,61],activate:241,actual:227,add:[53,76],adding:[80,239],addit:239,addition:[65,233,239],address:[40,294],addressbook:89,addressbookprefix:89,adjust:56,admin:280,administr:[33,40,41,66,88,89,92,220,223,226,239,260],again:238,aggreg:7,aggregat:[36,41],all:[76,222,270,288],allocat:55,allow:158,allowplaintext:93,also:[68,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,316,317,318,319,320,322,323,324,325,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,369,370,371,372,373,375,377,378,379],altern:[41,224,254],alternat:49,altnamespac:33,amount:296,analysi:237,ancient:48,ani:217,annot:[6,277],annotat:[6,29,32,158],anonym:[41,224],anoth:287,anyon:[41,224],api:[43,44,45,46,47,59,247],appear:298,append:[47,222],appendic:237,appendix:237,apple:228,applepushservic:27,applicat:[11,227],arbitron:303,arbitronsort:367,architectur:[220,226,237,239,260,265],archive:[15,229,230,383],arguments:325,articl:243,asked:266,assumption:237,atom:[62,241],attende:76,authent:[5,13,16,17,18,41,49,93,218,237,325,395],authenticate:241,author:[5,41,55,224,325,376],autoconf:158,autocr:[19,88,158],autom:19,automat:19,avail:[238,277,290],availabl:[9,11,27,30,227,295],back:239,backend:[9,30,36,44,45,158,227,237,239,241,267],background:398,backup:[6,74,217,226,239],backupd:[74,304],bad:241,balanc:237,bare:273,basic:33,befor:71,begin:71,behavior:[41,248],benefit:237,beta10:125,beta11:126,beta1:[124,175,211],beta2:[127,176,212],beta3:[128,177,213],beta4:[129,178,214],beta5:[130,179],beta6:[131,180],beta7:132,beta8:133,beta9:134,between:[61,239],binari:96,bit:272,blow:238,board:389,bold:398,boyer:56,buffer:11,bug:[68,159,160,161,162,163,164,165,166,167,168,169,170,171,172,185,186,187,188,189,190,191,192,193,194,195,196,197,329,381],bugfix:[174,175,176,177,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],build:[12,48,49,52,81,188,189],busytim:76,busytime_query_loc:76,busytime_query_remot:76,bylaw:389,bytecod:75,cach:[6,47,58,217],calcul:41,caldav:[6,20,49,76,88,123,124,125,126,127,128,129,130,131,132,133,134,158],caldav_allowcalendaradmin:88,caldav_allowschedul:88,caldav_delete_sch:76,caldav_post:76,caldav_put:76,calendar:[13,76,88],calendaralarm:27,calendarprefix:88,callout:158,can:[158,280,287,296,297,298],cancel:76,canon:56,capac:11,carddav:[6,21,49,89,158,218],carddav_allowaddressbookadmin:89,cassandan:51,catchal:158,centos:82,certif:[10,218],chain:260,chang:[41,71,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,239,253,389],channel:[260,265],charact:[56,63,272],charset:56,chartabl:56,chat:[74,382],chdir:325,check:[49,218],child:292,chk_cyru:305,claim:285,clamav:95,clean:292,clean_compon:76,client:[5,40,66,90,237,243,281,329],close:[46,47],cmd:158,code:[45,55,56,71],collect:[13,20,22],combin:222,come:237,command:[74,241,299,325],commands:325,commit:47,common:266,commun:[71,218,395,399],compact:74,compar:56,compil:[49,56,65,66,228,269],complet:[217,258],compon:[12,23,70,76,218,284],compress:260,comput:9,concept:[40,41,237],conf:[96,158,169,265,300,301],config:[88,217,218],configdirectori:[218,278,395],configur:[4,18,24,25,40,41,44,45,51,65,80,88,89,90,91,92,93,94,95,96,146,158,174,178,179,180,181,182,183,184,196,197,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,217,228,231,235,239,243,251,260,283,295,296,299,337,395],connect:[288,292],consid:75,consider:[11,58,59,260],consist:72,contact:[13,240],content:[48,72,80,226,251],context:255,contributor:393,control:[14,15,41,56,88,89,92,221,223,224,225,243,245,246,248,300],convent:[52,398],converg:9,convers:6,convert:248,copi:217,copy:237,core:[279,389,393],corrupt:74,cost:11,count:292,counter:6,creat:[18,41,47,53,76,218,223],createmailbox:325,creation:[9,19],cross:48,ctl_backup:[74,226,306],ctl_conversationsdb:307,ctl_cyrusdb:[44,308],ctl_deliv:309,ctl_mboxlist:310,ctl_zoneinfo:311,current:63,cvt_cyrusdb:[44,312],cvt_xlist_specialus:313,cyr_backup:[74,226,314],cyr_buildinfo:315,cyr_dbtool:[44,316],cyr_deni:317,cyr_df:318,cyr_expir:319,cyr_info:320,cyr_sequ:321,cyr_synclog:322,cyr_userseen:323,cyr_virusscan:324,cyradm:[159,169,243,325],cyrdump:326,cyru:[1,6,7,8,12,18,24,25,30,36,41,48,49,50,51,55,56,57,58,59,60,61,62,63,64,65,66,70,72,75,76,78,79,81,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,217,218,219,226,228,236,237,238,239,240,241,243,245,246,247,251,253,259,264,265,272,273,274,284,285,294,295,300,380,385,388,389,390,391,392,393,394,395],cyrusdb:[44,45],cyrusdb_:44,cyrusdb_abort:[44,45],cyrusdb_clos:[44,45],cyrusdb_commit:[44,45],cyrusdb_consist:[44,45],cyrusdb_cr:[44,45],cyrusdb_delet:[44,45],cyrusdb_don:[44,45],cyrusdb_dump:[44,45],cyrusdb_fetch:[44,45],cyrusdb_fetchlock:[44,45],cyrusdb_foreach:[44,45],cyrusdb_foron:[44,45],cyrusdb_init:[44,45],cyrusdb_open:[44,45],cyrusdb_stor:[44,45],cyrusdb_sync:[44,45],cyrusman:52,cyrussiev:297,daemon:[284,300],data:[9,11,44,45,56,74,187,217,227,241],databas:[6,10,18,42,49,74,158,217,231,237,239,241,248,267,287],datalen:[44,45],dav:[6,13,22,23],dav_reconstruct:368,davdriveprefix:92,debian:[83,170],debug:[51,80],declin:76,defin:[15,243],definit:[237,245,255],delai:[24,25,47],delet:[24,47,222,255,280,281],delete_mod:158,deleteaclmailbox:325,deletemailbox:325,deliv:[6,40,76,239,282,285,327],deliver_merge_pollstatu:76,deliver_merge_repli:76,deliver_merge_request:76,deliver_merge_vpoll_repli:76,deliveri:[6,26,41,218,237,240,268,275,395],depend:[49,65,160,161,162,172,185,190,197],deploy:7,descript:[15,68,300,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,375,377,378,379],description:[301,325,376],descriptions:301,design:35,detail:[44,45,58,241],determin:256,dev:199,develop:[1,42,43,49,51,54,66,67,69,70,71,73,158,216,389],devic:[9,30],differ:226,digest:383,directori:[41,64,218,229,231,232,233,258],disconnect:325,discret:[7,36],discretionari:221,disk:11,displai:91,distribut:[9,30,81,88,158,227,239,264],dlist:62,dns:237,document:[52,158,398],doe:[158,272,273,275,285,289,294,295],domain:40,down:217,download:2,draft:380,due:286,dump:279,duplic:[6,26,41,268],each:76,earlier:391,easi:238,easier:270,email:[218,243],enabl:[12,15,77,279,291],end:[93,239],engineer:389,enhanc:253,enhancement:158,enterpris:86,environ:[7,51,70,218,293],ephemer:[96,218,231],equal:[9,30,227],equiv:302,erratum:191,error:[269,293],establish:288,etc:[96,226],evaluat:75,event:[27,60,76,79,158,228,247],events:300,everyon:226,everyth:18,exampl:[27,30,33,44,45,52,59,61,68,227,300,302,303,304,305,306,307,308,309,310,311,312,313,314,316,317,318,319,320,321,322,323,324,327,330,331,332,333,334,335,338,339,340,341,343,346,347,348,352,353,355,358,359,360,362,363,366,367,369,370,372,373,375,377,378,379],exclud:76,exclude:30,exclus:227,exclusion:[9,227],exempt:257,exim:274,exist:[217,285],exit:325,experi:283,experiment:194,expire:[243,255,281],expung:[25,281],expunge_mod:158,extend:158,extens:251,extern:56,external:81,facil:41,fail:80,failov:260,failur:[237,238],faster:262,featur:[13,96,158,194,217,222,266,385],fedora:[84,269],feed:[91,243],fetch:296,fetchnew:[6,328],field:301,file:[6,41,42,52,58,62,96,217,218,226,229,231,237,264,265,290,299,302,303,304,306,307,308,309,310,311,312,313,314,316,317,318,319,320,322,323,324,327,328,329,330,331,332,333,334,335,337,338,339,340,343,344,345,346,347,348,349,350,351,352,353,354,355,358,359,360,361,362,363,364,366],filesystem:[10,96,278],filter:[37,41],find:[237,241],finish:48,first:47,fit:[9,30,227],fix:[158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,185,186,187,188,189,190,191,192,193,194,195,196,197,201,202,203,204,205,206,207,208,210,211,212,213,214,215],fixup:56,flag:[44,45,62,281],flagsclear:27,flagsset:27,flat:6,flowchart:76,fname:[44,45],folder:[11,19,61,158,251,255,257,258,281,297],footprint:158,forc:[44,45],foreach_p:[44,45],fork:53,form:56,format:[49,58,75,158,241],found:286,freebusi:88,freez:283,frequent:266,from:[76,81,217,218,226,239,257,261,294,395],front:239,frontend:[9,30,227,237],fud:329,full:[44,45],further:[66,243],futur:[56,58,63,237,391],gdb:284,gener:[11,55,56,75,93,95,262],get:[42,81,270,274],getmetadata:325,git:81,github:[52,53,71],global:253,glossari:3,goodp:[44,45],gotcha:[44,239],govern:389,gpfs:290,greater:158,group:[218,226,389,395],groupwar:11,grow:292,guid:[4,42,53,220,395],guidanc:54,guidelin:227,hack:55,handl:56,hang:275,happen:[9,30,227,237,238],hard:238,hash:232,hat:[86,269],have:[238,283,298],header:[58,272],help:[0,270,325],hex32:62,hex:62,high:[265,290,295,391],hint:55,histori:[304,306,307,311,313,314,317,319,320,322,324,330,353,355,359,360,371,390],host:[7,158],how:[44,50,217,274,276,279,284,291,297],howto:242,http:[76,93],httpd:[93,330],httpmodul:93,httptest:369,hub:70,idempot:260,identifi:[41,224],idl:331,idled:12,ietf:380,iii:389,imap4:392,imap:[7,8,12,24,25,30,36,41,42,44,48,55,56,57,58,59,60,61,62,63,64,72,75,78,79,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,219,226,237,242,253,259,262,264,281,380,385,392],imap_current_stable_vers:52,imapd:[96,169,265,283,301,332],imapfe:243,imaptest:51,imclient:68,imip:76,imip_send:76,impact:158,implement:[8,56,59,74,90,237],implicit:[41,223],improv:96,improved_mboxlist_sort:77,imtest:370,inbox:298,includ:158,incom:286,index:[6,46,58,74,158,262],individu:[225,258,393],info:325,inform:[93,243],informat:[30,71],initial:[41,223,226,241],input:56,instal:[74,395],install:[51,66,81,217,218,251,395],installat:[217,226,239,260,266],installsiev:371,instanc:[39,41,76],instruct:74,integrat:11,inter:72,interfac:[44,56],internal:1,internation:56,interoper:266,intro:[45,46,47,58,59],introduct:[48,56,61,80,219,226,251],invocat:262,invoke:265,ipurg:333,irc:382,isched_send:76,ischedul:[76,88],iscsi:11,issue:[53,187],italic:398,item:[217,227],itip:76,jmap:[49,66,90],join:293,just:253,keep:[239,292],kei:[6,44,45,53],kerbero:[16,41,224],keylen:[44,45],keyword:68,known:8,krb5:269,krb:302,kssl:269,kvlist:62,languag:41,larg:282,launch:[218,395],layer:[60,247],layout:45,ldap:17,ldap_tls_:158,level:[11,265,391],librari:[67,68],libtool:158,licens:81,lifetim:57,limit:[8,19,226],line:[74,325],link:72,linux:[86,253,269],lirstw:222,list:[6,41,52,62,67,71,74,91,225,237,241,306,383],listaclmailbox:325,listmailbox:325,listquota:325,listquotaroot:325,lmtp:[41,158],lmtp_catchall_mailbox:158,lmtp_fuzzy_mailbox_match:158,lmtpd:334,lmtpproxyd:335,lmtptest:372,load:[13,226,237],local:[41,76,240],locat:[229,231,233,234,246],lock:[8,47,57,58,59,74,226,264,278,306],log:[41,265,283,296],login:[27,41,158],logout:[27,241],longer:292,loss:187,lrsip:222,lrsp:222,lrswipkxtecd:222,lrswipkxtecda:222,lrxte:222,lun:11,machin:80,macro:[56,222],mail:[28,40,41,49,52,71,218,229,237,239,240,251,264,275,286,287,294,383,395],mailbox:[5,6,8,9,13,18,19,29,30,31,33,41,47,57,58,74,91,158,223,227,237,239,240,241,255,256,257,258,264,276,280,285,286],mailboxcr:27,mailboxdelet:27,mailboxrenam:27,mailboxsubscrib:27,mailboxunsubscrib:27,major:[174,175,176,177,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],make:[56,71,80,297],man:[52,299],manag:[13,22,220,251,263],manual:260,map:62,map_fre:55,map_refresh:55,masssievec:336,master:[96,238,239,241,260,337],maximum:292,mbexamin:338,mboxconfig:325,mboxkei:6,mbpath:339,mbtool:340,meet:384,member:76,memcpi:55,memori:[55,158],messag:[13,26,32,41,58,61,74,76,243,255,272,273,281,296],messageappend:27,messagecopi:27,messageexpir:27,messageexpung:27,messagemov:27,messagenew:27,messageread:27,messagetrash:27,metadata:[29,31,32,158,222,229,233,261,264],methods:345,mime:392,minim:56,miscellan:158,mismatch:271,mixe:286,mkchartabl:56,mkimap:341,mknewsgroup:342,mode:[9,30,33,227,237,238,260,306,314,355],model:46,modifi:76,modul:[55,93],monitor:[41,235,248],mono:398,moor:56,more:56,most:[9,30,227],motiv:75,move:[226,239,281],mta:[94,218,395],multi:7,multipath:11,multipl:[40,226,283],multiplex:237,mupdat:[238,240,241,343],mupdate:[237,239],mupdatetest:373,murder:[7,9,12,30,36,41,49,158,171,217,236,237,238,239,240,241,265,295],must:270,mysql:[18,287],name:[96,158,234,237,325,376],namelock:[59,158],namespac:[33,69,254],need:0,neg:41,network:55,newli:[41,223],newlin:273,newsgroup:243,nfs:11,nginx:242,nice:274,nntp:243,nntpd:344,nntptest:374,non:[253,398],none:222,noop:241,normal:56,note:[11,48,58,72,73,74,78,96,97,98,99,100,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,124,125,126,127,128,129,130,131,132,133,134,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,216,217,337,398],notes:[325,327],notif:[27,41,158,324],notification:345,notifyd:345,now:226,num32:62,num:62,numer:[41,250],object:62,occasion:283,octet:56,off:33,older:216,onc:288,one:226,onli:49,online:384,opene:[46,47],openssl:271,opensuse:85,oper:72,operat:[237,252,256,260,264,266,386],option:[88,146,158,169,196,197,228,235,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,368,369,370,371,372,373,375,377,378,379],optional:[12,49,66,218],options:376,order:[57,72],organ:76,other:[33,41,49,75,76,160,161,162,171,172,185,188,190,191,192,193,194,223,226,260],outbox:76,outgo:251,over:41,overal:75,overview:[6,52,70,217,228,237,243,387],own:80,owner:[41,223],packag:[81,96,395],page:[52,299],pam:18,pam_mysql:18,particip:[71,241],particular:226,partit:[9,28,30,31,41,74,158,226,229,230,233,234,261,264],past:393,patch:[52,71,170],path:158,pattern:56,per:231,perform:[10,11,15,76],period:260,person:33,phabric:158,place:217,plai:274,plaintext:41,plan:217,platform:12,point:[9,30],pollin:48,pop3:[8,41,288],pop3d:[296,346],pop3proxyd:347,pop3test:375,pop:237,port:[218,244,245,253,395],post:[76,222,243],postfix:395,pre:[18,48,70,72],predefin:96,prefac:394,prefix:[44,45],prefixlen:[44,45],prepar:[217,218],prerequisit:[48,72],primari:287,problem:266,proc:[41,278],procedur:252,process:[36,71,292,389],process_attende:76,procp:[44,45],product:216,program:96,proport:398,prot:[60,79,247],protocol:[8,11,41,62,218,395],provis:92,provok:226,proxi:[7,242],proxyd:348,ptdump:349,ptexpir:350,ptloader:351,pts:6,ptscach:6,pull:[52,53,226,243,398],purg:281,purpos:[15,96],push:[226,228,239,243],put:[76,80,278],queri:[76,240],question:[74,266],quick:[40,395],quickstart:395,quot:398,quota:[6,19,34,41,158,248,249,250,257,352],quotachang:27,quotaexce:27,quotalegaci:6,quotawithin:27,rc1:[181,215],rc2:182,rc3:183,rc4:184,read:[44,47,222,243],readahead:11,rebuild:51,recipi:76,recommend:[10,12],reconstruct:[41,74,217,258,289,325,353],record:[47,58],recov:[238,258],recoveri:[41,238],recurr:76,red:[86,269],reduc:226,redund:11,refer:[44,45,56,225],references:376,referr:237,regular:56,rehash:354,reindex:74,reject:[272,273,286],releas:[42,48,72,81,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,199,209,210,211,212,213,214,215,216,389],reload:259,remot:76,remov:[41,76],renam:[41,47,74],renamemailbox:325,repair:[41,248],repli:76,replic:[7,11,12,36,49,61,62,217,226,260,265],replica:260,report:381,repositori:53,represent:227,request:[52,53,76,266],requir:[12,49,56,65,226,239,260],requisit:[18,70],reserve:241,reset:[9,30,227],resourc:[42,76],respons:[76,241,294],restor:[74,226,355],restrict:[28,158],retdb:[44,45],retent:11,reus:292,rfc822:62,rfc:[52,158,380],right:[41,222,223,225,226],roadmap:[389,391],rock:[44,45],roll:[226,260],root:[41,249],rss:91,rss_feed:91,rss_feedlist_templ:91,run:[51,80,218,253,284],safe:278,same:[9,30,227],sampl:[41,66,96],sanit:76,sasl:[18,49,218,385,395],saslauthd:18,scalabl:11,scan:95,scanner:95,scenario:[7,30],sched_busytime_queri:76,sched_cancel:76,sched_declin:76,sched_deliv:76,sched_deliver_loc:76,sched_deliver_remot:76,sched_exclud:76,sched_pollstatu:76,sched_repli:76,sched_request:76,sched_vpoll_repli:76,schedul:[76,226],script:[19,80,251],seal:35,search:[6,56,65,229,234,262],secret:41,section:[96,300],secur:[13,163,164,170,186,188,189,191,201,202,203,204,205,206,207,208,210,211,212,213,214,215,253],see:[68,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,316,317,318,319,320,322,323,324,325,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,369,370,371,372,373,375,377,378,379],seen:[6,38],select:[9,30,41,158,227],selector:339,send:218,sender:294,sendmail:[40,218,395],seri:[174,176,177,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,216],server:[7,18,36,37,41,55,56,57,58,59,60,61,62,63,64,75,78,79,226,237,239,240,241,251,260,325],serverlist_select_soft_usage_limit:227,servic:[88,96,228,245,253,259,284],services:[283,300],set:[19,49,80,96,218,239,294,395],setaclmailbox:325,setinfo:325,setmetadata:[158,325],setquota:325,setup:[80,226,235,243,395,396],share:[7,11,33,38,41,158,251,290,297],should:267,shut:217,side:37,siev:[12,19,37,41,56,75,251,274,357],sievec:356,sieveshel:376,signific:[174,175,176,177,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],sinc:[159,160,161,162,163,164,165,166,167,168,169,170,171,172,174,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215],singl:[7,39,41],sitemap:397,sivtest:377,size:[256,296],size_t:[44,45],skiplist:6,slave:241,slow:275,smmapd:358,smtp:[76,392],smtptest:378,snapshot:216,socket:[244,245,246],softwar:12,sometim:275,sourc:[70,81,228],space:398,special:[9,30,52,63,217,227,251],specif:[93,217],specifi:41,sphinx:158,split:261,spool:[28,64,229,233,258,264],sql:[6,18,287],squat:6,squatter:[262,359],ssh:53,ssl:[146,170,218],stabl:216,stacktrac:51,standard:[55,240,252,253],start:[40,42,217,300],startup:36,state:[6,38,231],statu:[76,90],status:6,statuscach:6,storag:[6,11,13,28,41,92,218,226,250,264],store:[39,41,287],string:241,strlcpy:55,strncpy:55,struct:[44,45],structur:[18,64],style:71,sub:[6,158],subfold:298,submit:52,subscrib:[325,383],subscript:[6,19,41,237],suck:243,suit:80,suitabl:76,summari:237,support:[12,21,41,65,66,93,95,158,216,250,251,295,380,399],suppress:[26,41,268],sync:[239,260],sync_client:360,sync_reset:361,sync_serv:362,synchron:[241,264],synctest:379,synopsi:[52,68,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,375,377,378,379],synopsis:[325,376],syslog:[41,218],system:[12,35,42,265,290,299],tabl:[56,80],tag:[52,72,198,200,201,202,203,204,205,206,207,208],take:288,tape:226,tarbal:[81,217],target:158,task:76,teardown:80,telemetri:291,tell:72,temporari:[10,96],termin:260,terminolog:[239,255,260],test:[1,18,48,51,66,70,72,80,218,251],than:76,thi:[158,270],thing:75,thought:73,through:[9,52,71],tid:[44,45],tidptr:[44,45],tier:[11,28,234,264],time:[88,218],timsiev:363,tip:51,tls:6,tls_:158,tls_prune:364,tls_session:6,tmpf:278,todo:[55,74],togeth:18,tool:[44,52,70,81,226,251],topolog:[36,158],track:61,tradit:243,transact:[44,45],transcod:56,transfer:41,translate:56,translatesiev:365,transport:260,trash:281,trick:51,trim_attende:76,troubleshoot:[218,239],tweak:[260,264],two:[9,30,227],twoskip:[6,158],txn:[44,45],type:[6,41,62,158,228,229,250],typograph:398,tzdist:88,ubuntu:87,unabl:293,unavail:238,undefin:158,undelet:255,under:[64,298],underscor:158,unexpung:366,unicod:56,unifi:[7,36],unit:[1,80],unix:[41,224],unlock:47,unsubscrib:[325,383],updat:[48,52,76,217],update:[174,178,179,180,181,182,183,184,199,200,201,202,203,204,205,206,207,208,210,211,212,213,214,215,241],upgrad:217,upgrade:[158,217],upload:72,upon:41,url:88,usage:[9,30,227],use:[36,63,81],used:28,useful:71,user:[5,6,11,19,33,41,76,93,158,218,226,231,280,281,296,299,395],user_deni:[6,263],userid:6,using:[52,71,80,226,242,243,262,264],utf:56,util:74,vacat:294,valgrind:80,variou:96,verifi:[74,217],version:[48,72,216,271,325,392],via:76,view:[69,276],virtual:40,viru:95,volum:11,voter:76,vpoll:76,wai:[240,270],want:217,warn:[41,398],webdav:92,websit:72,weight:9,well:288,what:[9,30,40,80,88,217,219,226,227,237,238,277,281,284,385,392],when:[9,30,41,227,237,238,281,283],where:[80,237,281],which:267,white:398,who:[217,393],why:[272,273,275,280,282,286,288,289,294],wishlist:380,within:[18,237],work:[41,50,90,229,289,297],world:72,write:[44,47,222,251],xapian:[57,65],xapianact:6,xfermailbox:325,yet:90,you:[71,217],your:[0,53,80,218,395],yourself:81,zone:88,zoneinfo:[6,88]}})
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/setup.html 3.2.0-3/doc/html/setup.html
--- 3.0.13-5/doc/html/setup.html	2019-12-16 04:18:18.000000000 +0000
+++ 3.2.0-3/doc/html/setup.html	2020-05-04 04:13:48.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Setup &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Setup &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Compiling" href="imap/developer/compiling.html"/>
         <link rel="prev" title="Concepts" href="imap/concepts/overview_and_concepts.html"/> 
 
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Setup</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/setup.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/setup.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -781,14 +800,14 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l1"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l1"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -831,7 +850,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -851,7 +870,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/sitemap.html 3.2.0-3/doc/html/sitemap.html
--- 3.0.13-5/doc/html/sitemap.html	2019-12-16 04:18:19.000000000 +0000
+++ 3.2.0-3/doc/html/sitemap.html	2020-05-04 04:13:49.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Sitemap &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Sitemap &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Sitemap</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/sitemap.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/sitemap.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -789,6 +808,10 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.2/index.html">Cyrus IMAP 3.2 Releases</a></li>
+</ul>
+</li>
 <li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.0/index.html">Cyrus IMAP 3.0 Releases</a></li>
 </ul>
@@ -797,9 +820,20 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.5/index.html">Cyrus IMAP 2.5 Releases</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a><ul>
-<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.4/index.html">Cyrus IMAP 2.4 Releases</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.4-dav/index.html">Cyrus IMAP 2.4-caldav Releases</a></li>
+</ul>
+</li>
+<li class="toctree-l5"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.0-dev.html">Cyrus IMAP 3.1.0-dev Release Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.1.html">Cyrus IMAP 3.1.1 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.2.html">Cyrus IMAP 3.1.2 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.3.html">Cyrus IMAP 3.1.3 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.4.html">Cyrus IMAP 3.1.4 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.5.html">Cyrus IMAP 3.1.5 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.6.html">Cyrus IMAP 3.1.6 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.7.html">Cyrus IMAP 3.1.7 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.8.html">Cyrus IMAP 3.1.8 Tag Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/3.1/x/3.1.9.html">Cyrus IMAP 3.1.9 Tag Notes</a></li>
 </ul>
 </li>
 </ul>
@@ -809,11 +843,13 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/1/1.x.x.html">Cyrus IMAP 1.x Release Notes</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.0/2.0.x.html">Cyrus IMAP 2.0.x Release Notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.1/2.1.x.html">Cyrus IMAP 2.1.x Release Notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.2/2.2.x.html">Cyrus IMAP 2.2.x Release Notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.3/index.html">Cyrus IMAP 2.3 Releases</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.4/index.html">Cyrus IMAP 2.4 Releases</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/release-notes/2.4-dav/index.html">Cyrus IMAP 2.4-caldav Releases</a></li>
 </ul>
 </li>
 </ul>
@@ -821,6 +857,7 @@
 </ul>
 </li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l5"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a><ul>
@@ -830,7 +867,7 @@
 <li class="toctree-l6"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-the-various-programs-imapd-conf">The configuration file for the various programs: imapd.conf</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/packagers.html#ephemeral-files-and-temporary-filesystems">Ephemeral files and temporary filesystems</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/download/packagers.html#new-default-settings">New default settings</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/download/packagers.html#new-features">New features</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/download/packagers.html#new-or-improved-features">New or improved features</a></li>
 </ul>
 </li>
 </ul>
@@ -845,22 +882,19 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l4"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l6"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l6"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l5"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l5"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -1061,7 +1095,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#developers-only">Developers only</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#sasl-authentication">SASL Authentication</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#alternate-database-formats">Alternate database formats</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#caldav-and-or-carddav">CalDAV and/or CardDAV</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#caldav-carddav-or-jmap">CalDAV, CardDAV, or JMAP</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#other">Other</a></li>
 </ul>
 </li>
@@ -1070,7 +1104,7 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/developer/compiling.html#compile-cyrus">Compile Cyrus</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/developer/compiling.html#default-build-mail-only">Default build: mail only</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/developer/compiling.html#optional-dependencies">Optional dependencies</a><ul>
-<li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#caldav-and-carddav">CalDAV and CardDAV</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#caldav-carddav-jmap">CalDAV, CardDAV, JMAP</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#murder">Murder</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/compiling.html#replication">Replication</a></li>
 </ul>
@@ -1119,7 +1153,7 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a><ul>
@@ -1130,12 +1164,12 @@
 <li class="toctree-l6"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -1175,7 +1209,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#conversations-userid-conversations">Conversations (&lt;userid&gt;.conversations)</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#counters-userid-counters">Counters (&lt;userid&gt;.counters)</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#news-database-fetchnews-db">News database (fetchnews.db)</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#search-indexes-cyrus-squat-userid-xapianactive">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive)</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#search-indexes-cyrus-squat-userid-xapianactive-cyrus-indexed-db">Search Indexes (cyrus.squat, &lt;userid&gt;.xapianactive, cyrus.indexed.db)</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#zoneinfo-db-zoneinfo-db">Zoneinfo db (zoneinfo.db)</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#seen-state-userid-seen">Seen State (&lt;userid&gt;.seen)</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#subscriptions-userid-sub">Subscriptions (&lt;userid&gt;.sub)</a></li>
@@ -1188,7 +1222,6 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#flat">Flat</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#twoskip">Twoskip</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#skiplist">Skiplist</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#lmdb">lmdb</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#sql">sql</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/concepts/deployment/databases.html#quotalegacy">quotalegacy</a></li>
 </ul>
@@ -1230,6 +1263,7 @@
 </li>
 <li class="toctree-l5"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l5"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -1273,7 +1307,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html#see-also">See Also</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html#description">DESCRIPTION</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html#field-descriptions">FIELD DESCRIPTIONS</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html#see-also">SEE ALSO</a></li>
@@ -1490,6 +1524,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#synopsis">Synopsis</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#description">Description</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#notifications">Notifications</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#examples">Examples</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#history">History</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/cyr_virusscan.html#files">Files</a></li>
@@ -1586,7 +1621,15 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpd.html#see-also">See Also</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html"><strong>lmtpproxyd</strong></a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#synopsis">Synopsis</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#description">Description</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#examples">Examples</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#files">Files</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/lmtpproxyd.html#see-also">See Also</a></li>
+</ul>
+</li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/masssievec.html"><strong>masssievec</strong></a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/masssievec.html#synopsis">Synopsis</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/masssievec.html#description">Description</a></li>
@@ -1617,6 +1660,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#synopsis">Synopsis</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#description">Description</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#selectors">Selectors</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#examples">Examples</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#files">Files</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/mbpath.html#see-also">See Also</a></li>
@@ -1680,11 +1724,21 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3d.html#see-also">See Also</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html"><strong>pop3proxyd</strong></a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#synopsis">Synopsis</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#description">Description</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#examples">Examples</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#files">Files</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/pop3proxyd.html#see-also">See Also</a></li>
+</ul>
+</li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html"><strong>proxyd</strong></a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#synopsis">Synopsis</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#description">Description</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#examples">Examples</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#files">Files</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/systemcommands/proxyd.html#see-also">See Also</a></li>
 </ul>
 </li>
@@ -1900,14 +1954,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/mupdatetest.html#see-also">See Also</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a><ul>
-<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html#synopsis">Synopsis</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html#description">Description</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html#options">Options</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html#examples">Examples</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html#see-also">See Also</a></li>
-</ul>
-</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/usercommands/nntptest.html"><strong>nntptest</strong></a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/usercommands/pop3test.html"><strong>pop3test</strong></a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/pop3test.html#synopsis">Synopsis</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/pop3test.html#description">Description</a></li>
@@ -1941,37 +1988,16 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/smtptest.html#see-also">See Also</a></li>
 </ul>
 </li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html"><strong>synctest</strong></a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html#synopsis">Synopsis</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html#description">Description</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html#options">Options</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html#examples">Examples</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/manpages/usercommands/synctest.html#see-also">See Also</a></li>
 </ul>
 </li>
 </ul>
 </li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
 </ul>
 </li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
@@ -2073,6 +2099,11 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/admin/eventsource.html#apple-push-service">Apple Push Service</a></li>
 </ul>
 </li>
+<li class="toctree-l6"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/admin/monitoring.html#setup">Setup</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/reference/admin/monitoring.html#configuration-options">Configuration options</a></li>
+</ul>
+</li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html#selection-modes">Selection Modes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html#special-cases">Special cases</a></li>
@@ -2105,10 +2136,8 @@
 </li>
 <li class="toctree-l5"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l5"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -2121,10 +2150,8 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l6"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html#users-and-imap-clients-deleting-messages">Users and IMAP Clients Deleting Messages</a></li>
@@ -2232,6 +2259,11 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/developer-testing.html#tips-and-tricks">Tips and Tricks</a></li>
 </ul>
 </li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/jmap.html#cyrus-administration">Cyrus administration</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/jmap.html#jmap-client">JMAP client</a></li>
+</ul>
+</li>
 </ul>
 </li>
 <li class="toctree-l5"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -2248,11 +2280,14 @@
 <li class="toctree-l5"><a class="reference internal" href="imap/developer.html#releasing">Releasing</a><ul>
 <li class="toctree-l6"><a class="reference internal" href="imap/developer/releasing.html">Releasing Cyrus IMAP</a><ul>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#prerequisites">Prerequisites</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#order-of-operations">Order of operations</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#release-notes">Release notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#pre-release-testing">Pre-release testing</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#linking-up-release-notes">Linking up release notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#version-tagging">Version tagging</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#releasing">Releasing</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#inter-version-website-consistency">Inter-version website consistency</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#uploading">Uploading</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/releasing.html#tell-the-world">Tell the world</a></li>
 </ul>
 </li>
 <li class="toctree-l6"><a class="reference internal" href="imap/developer/ancient-releasing.html">Releasing new builds of ancient Cyrus IMAP versions</a><ul>
@@ -2262,7 +2297,7 @@
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/ancient-releasing.html#pre-release-testing">Pre-release testing</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/ancient-releasing.html#cross-pollination-of-release-notes">Cross-pollination of release notes</a></li>
 <li class="toctree-l7"><a class="reference internal" href="imap/developer/ancient-releasing.html#building-the-release">Building the release</a></li>
-<li class="toctree-l7"><a class="reference internal" href="imap/developer/ancient-releasing.html#releasing">Releasing</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/ancient-releasing.html#finishing-up">Finishing up</a></li>
 </ul>
 </li>
 </ul>
@@ -2271,9 +2306,205 @@
 </li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l5"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l5"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l5"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l4"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l5"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#the-interface">The interface</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#configuration">Configuration</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#a-full-example">A full example</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#tools">Tools</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#how-to-use-cyrusdb">How to use CyrusDB</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#reading-writing-transactions">Reading, Writing, &amp; Transactions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#gotchas">Gotchas!</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb.html#api-reference">API Reference</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#intro">Intro</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#code-layout">Code Layout</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#configuration">Configuration</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#a-full-example">A full example</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#about-transactions">About Transactions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/cyrusdb2.html#api-reference">API Reference</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/index-api.html#intro">Intro</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/index-api.html#opening-and-closing">Opening and closing</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/index-api.html#the-index-model">The Index Model</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#intro">Intro</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#opening-and-closing">Opening and closing</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#locking-and-unlocking">Locking and unlocking</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#creating-renaming-and-deleting">Creating, renaming and deleting</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#reading-and-writing-records">Reading and writing records</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/API/mailbox-api.html#delayed-actions">Delayed Actions</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l5"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#messages">messages</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#renames">renames</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#locking">locking</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#verifying-index">verifying index</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#mailboxes-database">mailboxes database</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#reindex">reindex</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#backupd">backupd</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#questions">questions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#restore">restore</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#compact">compact</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#command-line-locking-utility">command line locking utility</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#reconstruct">reconstruct</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#ctl-backups">ctl_backups</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#cyr-backup">cyr_backup</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#partitions">partitions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#data-corruption">data corruption</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#installation-instructions">installation instructions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#chatting-about-implementation-20-10">chatting about implementation 20/10</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/backup.html#todo-list">todo list</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/bytecode.html#motivation">Motivation</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/bytecode.html#overall-bytecode-format">Overall Bytecode Format</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/bytecode.html#generation">Generation</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/bytecode.html#evaluation">Evaluation</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/bytecode.html#other-things-to-consider">Other things to consider</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#caldav-put-create-modify-via-http-put-on-a-resource-or-post-add-member-on-a-calendar">caldav_put() - create/modify via HTTP PUT on a resource or POST (add-member) on a calendar</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#caldav-delete-sched-remove-via-http-delete-on-a-resource">caldav_delete_sched() - remove via HTTP DELETE on a resource</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#caldav-post-busytime-query-via-http-post-on-scheduling-outbox">caldav_post() - busytime query via HTTP POST on Scheduling Outbox</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-pollstatus-perform-a-voter-response-update">sched_pollstatus - perform a voter response update</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-request-perform-an-organizer-request-attendee-status-update">sched_request() - perform an organizer request / attendee status update</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#process-attendees-create-a-suitable-itip-request-message-for-each-attendee">process_attendees() - create a suitable iTIP request message for each attendee</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-exclude-exclude-an-attendee-from-a-recurrence-instance">sched_exclude() - exclude an attendee from a recurrence instance</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-cancel-cancel-an-organizer-event-task">sched_cancel() - cancel an organizer event/task</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-reply-perform-an-attendee-reply">sched_reply() - perform an attendee reply</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#trim-attendees-remove-all-attendees-other-than-the-one-replying">trim_attendees() - remove all attendees other than the one replying</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-vpoll-reply-add-voter-responses-to-vpoll-reply">sched_vpoll_reply() - add voter responses to VPOLL reply</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-decline-decline-a-recurrence-instance-for-an-attendee">sched_decline() - decline a recurrence instance for an attendee</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#clean-component-sanitize-a-component-for-use-in-an-itip-message">clean_component() - sanitize a component for use in an iTIP message</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-deliver-deliver-an-itip-message-to-a-recipient">sched_deliver() - deliver an iTIP message to a recipient</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-deliver-local-deliver-an-itip-message-to-a-local-user">sched_deliver_local() - deliver an iTIP message to a local user</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#deliver-merge-reply-update-an-organizer-resource-with-an-attendee-reply">deliver_merge_reply() - update an organizer resource with an attendee reply</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#deliver-merge-vpoll-reply-update-an-organizer-resource-with-voter-responses">deliver_merge_vpoll_reply() - update an organizer resource with voter responses</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#deliver-merge-request-create-update-an-attendee-resource-with-an-organizer-request">deliver_merge_request() - create/update an attendee resource with an organizer request</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#deliver-merge-pollstatus-update-voter-responses-on-a-voter-resource">deliver_merge_pollstatus() - update voter responses on a voter resource</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-deliver-remote-deliver-an-itip-message-to-a-remote-user">sched_deliver_remote() - deliver an iTIP message to a remote user</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#isched-send-deliver-an-itip-message-to-a-remote-user-via-ischedule-http">isched_send() - deliver an iTIP message to a remote user via iSchedule (HTTP)</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#imip-send-deliver-an-itip-message-to-a-remote-user-via-imip-smtp">imip_send() - deliver an iTIP message to a remote user via iMIP (SMTP)</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#sched-busytime-query-perform-a-busytime-query">sched_busytime_query() - perform a busytime query</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#busytime-query-local-perform-a-busytime-query-on-a-local-user">busytime_query_local() - perform a busytime query on a local user</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html#busytime-query-remote-perform-a-busytime-query-on-a-remote-user">busytime_query_remote() - perform a busytime query on a remote user</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l5"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#memory-allocation">Memory Allocation</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#strlcpy-vs-strncpy-vs-memcpy">strlcpy vs strncpy vs memcpy</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#map-refresh-and-map-free">map_refresh and map_free</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#network-functions">Network Functions</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#todo-authorization-modules">(todo) Authorization Modules</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#general-hints">General Hints</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/hacking.html#coding-standards">Coding Standards</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#introduction">introduction</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#cyrus-canonical-form">cyrus canonical form</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#external-interface">external interface</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#the-translate-macro-using-the-transcoding-tables">the TRANSLATE macro: using the transcoding tables</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#searching-and-compiled-patterns">searching and compiled patterns</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#generating-the-tables-mkchartable">generating the tables: <code class="docutils literal"><span class="pre">mkchartable</span></code></a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#for-the-future">for the future</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/internationalization.html#references">references</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/locking.html#mailboxes">Mailboxes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/locking.html#xapian">Xapian</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/locking.html#lock-lifetime">Lock lifetime</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#intro">Intro</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#message-files">Message Files</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#cyrus-header"><code class="docutils literal"><span class="pre">cyrus.header</span></code></a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#cyrus-cache"><code class="docutils literal"><span class="pre">cyrus.cache</span></code></a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#cyrus-index"><code class="docutils literal"><span class="pre">cyrus.index</span></code></a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#notes">Notes</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html#future-considerations">Future considerations</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/namelocks.html#intro">Intro</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/namelocks.html#implementation">Implementation</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/namelocks.html#api">API</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/prot.html#events">Events</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/replication_examples.html#introduction">Introduction</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/replication_examples.html#a-short-example-of-replication-in-action">A short example of replication in action</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/replication_examples.html#tracking-messages-between-folders">Tracking messages between folders</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html#dlist-1-0">DList 1.0</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/special_chars.html#current-uses">Current Uses</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/special_chars.html#future-uses">Future Uses</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html#directory-structure-under-var-spool-imap">Directory structure under /var/spool/imap</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html#directory-structure-under-var-imap">Directory structure under /var/imap</a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l4"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l5"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a><ul>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/unit-tests.html#setting-up-the-machine">3.1. Setting Up The Machine</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/unit-tests.html#configure-script">3.2 Configure Script</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/unit-tests.html#make">3.3 Make</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/unit-tests.html#using-valgrind">3.4 Using Valgrind</a></li>
+<li class="toctree-l7"><a class="reference internal" href="imap/developer/unit-tests.html#the-tests-are-failing">3.5 The Tests Are Failing</a></li>
+</ul>
+</li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l6"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -2348,7 +2579,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on Aug 19 2016
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on Aug 19 2016
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -2368,7 +2599,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/sitemap.xml 3.2.0-3/doc/html/sitemap.xml
--- 3.0.13-5/doc/html/sitemap.xml	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/doc/html/sitemap.xml	2020-05-04 04:13:51.000000000 +0000
@@ -1,2 +1,2 @@
 <?xml version='1.0' encoding='UTF-8'?>
-<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-ldap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/archive-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/preface.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-sharedfilesystem-gpfs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/feature-database-backend.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cvt_cyrusdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_df.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/databases.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-coredump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_dbtool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/master.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.2/2.2.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/install-xapian.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/namespaces.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/reloading.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/httptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/commands.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.18.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.19.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.14.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.15.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.16.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.17.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-kerberos.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyrdump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/feature-duplicate-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-irc.html</loc></url><url><loc>https://www.cyrusimap.org/dev/download.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_sequence.html</loc></url><url><loc>https://www.cyrusimap.org/dev/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/dav-collection-mgmt.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/delayed-delete.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mupdate.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-detecting-berkeley.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_info.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas/quotaroots.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/fetchnews.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/proxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/documentation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-mailing-lists.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-distribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-toomanyprocesses.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/eventsource.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/namespaces.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/dav-components.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_virusscan.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/nntpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/nntptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-bugs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/deleting.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/configuration-state.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-concepts.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptdump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/pop3test.html</loc></url><url><loc>https://www.cyrusimap.org/dev/setup.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-mupdate-details.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mknewsgroups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/pop3proxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/quickstart.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/about_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_server.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-mixedcase.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-pop3slow.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mail-spool-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-mailbox-doesnotexist.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/searchtiers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-berkeleydb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/operations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/compiling.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/rss.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/translatesieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/performance_recommendations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/combining-rights.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/architecture.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/squatter.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/libraries.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sievec.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sieved.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/mailbox-quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/tls_prune.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/github-guide.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/mupdatetest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/squatter.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/idled.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/centos.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/defaults.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/message-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/mailbox_creation_distribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/backupd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-install-help.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-freezes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/ubuntu.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-deliverdb-size.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/mailbox-operations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-vacation-mailfrom.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbpath.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/single-instance-store.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-deleted-expired-expunged-purged.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_userseen.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_expire.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/pop3d.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/protlayer.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.0/2.0.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_mboxlist.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_backup.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/event-notifications.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-compilationerrors.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/installsieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/manage-dav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-sieve-exim.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/sealed-system.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.1/2.1.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/debian.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/overview_and_concepts.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/rehash.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/rfc-support.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/process.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_deny.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/upgrade.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ipurge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/shared-seen-state.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-sql.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas/quotatypes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/splitting-metadata.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/who_is_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/httpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/replication.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/imtest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-otherdatabases.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/userdeny.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/chk_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/nginx-proxy.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/supported-platforms.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/releasing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-gdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mkimap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_client.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-telemetry.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/nntp.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.20.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/config-mailboxdistribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-barenewlines.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-publicssharedfolders.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/restore.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/krb.equiv.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/identifiers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/lmtpproxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptexpire.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/1/1.x.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-unable-join-environment.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/lmtptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/smtptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_history.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports/services.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbexamine.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/archiving.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/storage.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/getcyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_reset.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/webdav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/fud.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/libraries/imclient.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/altnamespace.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/masssievec.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/glossary.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/reconstructing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/overview.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/developer-tips.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/sieveshell.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/delayed-expunge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-murder-ha.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/server-aggregation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.18.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.19.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.14.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.15.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.16.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.17.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-mail-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/unexpunge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_buildinfo.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/synctest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/hashing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-meetings.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/automatic-creation-of-mailboxes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/imapd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-linkerwarnings.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/backups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-subfolders.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-db3-lockers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/mailspool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-delete-mailbox.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports/sockets.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/sivtest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/styles.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/arbitron.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-slow-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-configdir-tempfs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/timsieved.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/deployment_scenarios.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/smmapd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/virus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptloader.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/caldav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/caldav-collections.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/quickstart/introduction.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/cyrusworks.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/imapd.conf.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_roadmap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/arbitronsort.pl.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder.html</loc></url><url><loc>https://www.cyrusimap.org/dev/sitemap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/dav_reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-metadata-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_deliver.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_synclog.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_cyrusdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/fedora.html</loc></url><url><loc>https://www.cyrusimap.org/dev/support.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.20.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/access-control.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/carddav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/developer-testing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/carddav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/administration-running.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-8bit.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/rhel.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbtool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/deliver.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports-sockets.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/rights-reference.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.14.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_backups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_zoneinfo.html</loc></url><url><loc>https://www.cyrusimap.org/dev/contribute.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-pop3-logging.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/opensuse.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyradm.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/notifyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/cyrus.conf.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_conversationsdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/known_protocol_limitations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/tweaking.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faq.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-installation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/duplicate-message-delivery-suppression.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_bylaws.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/authentication_and_authorization.html</loc></url><url><loc>https://www.cyrusimap.org/dev/developers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/what_is_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-failure-modes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/lmtpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/installing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-acls.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/ancient-releasing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/virtual-domains.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/packagers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/administration-tools.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/server-side-filtering.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/mta/configuration.html</loc></url></urlset>
\ No newline at end of file
+<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-ldap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/archive-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/altnamespace.html</loc></url><url><loc>https://www.cyrusimap.org/dev/preface.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/API/cyrusdb2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/centos.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/locking.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-sharedfilesystem-gpfs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/feature-database-backend.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cvt_cyrusdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_df.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/databases.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-coredump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_dbtool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/master.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.2/2.2.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/improved_mboxlist_sort.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/install-xapian.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/namespaces.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/backup.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/reloading.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/replication_protocol.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/httptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/commands.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.18.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.19.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.14.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.15.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.16.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.17.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-kerberos.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyrdump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/feature-duplicate-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/download.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_sequence.html</loc></url><url><loc>https://www.cyrusimap.org/dev/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/dav-collection-mgmt.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/delayed-delete.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mupdate.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_info.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas/quotaroots.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/fetchnews.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/proxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/documentation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-mailing-lists.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/jmap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/API/cyrusdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-distribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-toomanyprocesses.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0-beta3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/eventsource.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/namespaces.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/dav-components.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_virusscan.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/nntpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/nntptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-bugs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/deleting.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/configuration-state.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-concepts.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/jmap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyradm.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/pop3test.html</loc></url><url><loc>https://www.cyrusimap.org/dev/setup.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-mupdate-details.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mknewsgroups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/pop3proxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/quickstart.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/about_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_server.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-mixedcase.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-pop3slow.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mail-spool-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-mailbox-doesnotexist.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/searchtiers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/API/index-api.html</loc></url><url><loc>https://www.cyrusimap.org/dev/operations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/compiling.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/rss.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/var_directory_structure.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/translatesieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/performance_recommendations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/combining-rights.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/architecture.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/squatter.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/libraries.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sievec.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sieved.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/mailbox-quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/tls_prune.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/github-guide.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/mupdatetest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/squatter.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/idled.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/prot.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/defaults.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/message-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/mailbox_creation_distribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/backupd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-install-help.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-freezes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0-beta1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0-beta2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0-beta4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/ubuntu.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/API.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-deliverdb-size.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/mailbox-operations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-vacation-mailfrom.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbpath.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/single-instance-store.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-deleted-expired-expunged-purged.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_userseen.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_expire.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/pop3d.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/namelocks.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/protlayer.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.0/2.0.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/replication_examples.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/mailbox-format.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_mboxlist.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_backup.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-irc.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/event-notifications.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-compilationerrors.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/installsieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/manage-dav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-sieve-exim.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/sealed-system.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.1/2.1.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/debian.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/overview_and_concepts.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/rehash.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/rfc-support.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/process.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_deny.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cvt_xlist_specialuse.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/upgrade.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ipurge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/shared-seen-state.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/authentication-sql.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas/quotatypes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/splitting-metadata.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/who_is_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/httpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/replication.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/imtest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-otherdatabases.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/userdeny.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/chk_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/nginx-proxy.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/supported-platforms.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/hacking.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/releasing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/monitoring.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-gdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mkimap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_client.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-telemetry.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/nntp.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sieve.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.20.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/config-mailboxdistribution.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-barenewlines.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-publicssharedfolders.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/restore.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/unit-tests.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/krb.equiv.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/identifiers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/notes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/quotas.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/lmtpproxyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptexpire.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/1/1.x.x.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-unable-join-environment.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/lmtptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/smtptest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/caldav_scheduling_flowchart.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_history.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports/services.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbexamine.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/archiving.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/storage.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/getcyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/sync_reset.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/webdav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/fud.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/quota.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/libraries/imclient.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-beta6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/masssievec.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0-rc1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/glossary.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/reconstructing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/overview.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/sieveshell.html</loc></url><url><loc>https://www.cyrusimap.org/dev/styles.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/delayed-expunge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-murder-ha.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/server-aggregation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4-dav/x/2.4.17-caldav-beta8.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.18.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.19.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.14.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.15.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.16.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.17.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/x/2.3.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-mail-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/unexpunge.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_buildinfo.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/synctest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.3/index.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/hashing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/support/feedback-meetings.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/automatic-creation-of-mailboxes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/imapd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.3.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.6.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.7.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.4.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.5.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/install-linkerwarnings.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.0/x/3.0.9.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/backups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-subfolders.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations/mailspool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.0-dev.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-delete-mailbox.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports/sockets.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/sivtest.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/special_chars.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/arbitron.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-slow-delivery.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/prot-events.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-configdir-tempfs.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/timsieved.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/deployment_scenarios.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/smmapd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/virus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptloader.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/caldav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/caldav-collections.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/quickstart/introduction.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-annotations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/cyrusworks.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/guidance/internationalization.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/imapd.conf.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0-rc1.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_roadmap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/arbitronsort.pl.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder.html</loc></url><url><loc>https://www.cyrusimap.org/dev/sitemap.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/API/mailbox-api.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/usercommands/dav_reconstruct.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/mailbox-metadata-partitions.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_deliver.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/cyr_synclog.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_cyrusdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/fedora.html</loc></url><url><loc>https://www.cyrusimap.org/dev/support.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.4/x/2.4.20.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/access-control.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/http/carddav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/developer-testing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/carddav.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/sop/administration-running.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/interop-8bit.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/rhel.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/mbtool.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/deliver.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/ports-sockets.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/access-control/rights-reference.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.15.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.10.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.11.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.12.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/2.5/x/2.5.13.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_backups.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.2/x/3.2.0.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_zoneinfo.html</loc></url><url><loc>https://www.cyrusimap.org/dev/contribute.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/r-pop3-logging.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/distributions/opensuse.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/notifyd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/locations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/configs/cyrus.conf.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ctl_conversationsdb.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/known_protocol_limitations.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/tweaking.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faq.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-installation.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/duplicate-message-delivery-suppression.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/cyrus_bylaws.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/deployment/authentication_and_authorization.html</loc></url><url><loc>https://www.cyrusimap.org/dev/developers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/overview/what_is_cyrus.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/admin/murder/murder-failure-modes.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/lmtpd.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/installing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/faqs/o-acls.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/reference/manpages/systemcommands/ptdump.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/ancient-releasing.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/release-notes/3.1/x/3.1.2.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/virtual-domains.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/developer/thoughts/bytecode.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/packagers.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/concepts/features/server-side-filtering.html</loc></url><url><loc>https://www.cyrusimap.org/dev/imap/download/installation/mta/configuration.html</loc></url></urlset>
\ No newline at end of file
diff -pruN 3.0.13-5/doc/html/_sources/developers.txt 3.2.0-3/doc/html/_sources/developers.txt
--- 3.0.13-5/doc/html/_sources/developers.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/developers.txt	2020-04-24 02:03:00.000000000 +0000
@@ -5,9 +5,33 @@ Developers
 
 .. toctree::
     :maxdepth: 2
-    :glob:
 
     contribute
     Contribute docs <imap/developer/documentation>
     Contribute code and tests <imap/developer>
     Cyrus.Works <imap/developer/cyrusworks>
+
+Cyrus Internals
+===============
+
+These documents are intended for persons interested in contributing to
+the Cyrus IMAP development effort, or for those interested in lower-
+level details about how Cyrus is implemented.
+
+.. toctree::
+    :maxdepth: 2
+    :glob:
+
+    Cyrus APIs <imap/developer/API>
+    Thoughts & Notes <imap/developer/thoughts>
+    Guidance for Developers <imap/developer/guidance>
+
+This :download:`diagram <imap/developer/images/master-state-machine.svg>` shows
+the Master State Machine.
+
+Unit Tests
+==========
+
+.. toctree::
+
+    imap/developer/unit-tests
diff -pruN 3.0.13-5/doc/html/_sources/download.txt 3.2.0-3/doc/html/_sources/download.txt
--- 3.0.13-5/doc/html/_sources/download.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/download.txt	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-========
+--------
 Download
-========
+--------
 
 
 .. toctree::
diff -pruN 3.0.13-5/doc/html/_sources/imap/concepts/deployment/databases.txt 3.2.0-3/doc/html/_sources/imap/concepts/deployment/databases.txt
--- 3.0.13-5/doc/html/_sources/imap/concepts/deployment/databases.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/concepts/deployment/databases.txt	2020-04-24 02:03:00.000000000 +0000
@@ -46,7 +46,7 @@ One per user:
 * `Mailbox Keys (<userid>.mboxkey)`_
 * `Seen State (<userid>.seen)`_
 * `Subscriptions (<userid>.sub)`_
-* `Search Indexes (cyrus.squat, <userid>.xapianactive)`_
+* `Search Indexes (cyrus.squat, <userid>.xapianactive, cyrus.indexed.db)`_
 
 .. _imap-concepts-deployment-db-mailboxes:
 
@@ -59,7 +59,7 @@ This database contains the master list o
 
     Data: <Type Number>SP<Partition>SP<ACL (space-separated userid/rights pairs)>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `sql`_.
 
 .. _imap-concepts-deployment-db-annotations:
 
@@ -72,7 +72,7 @@ This database contains mailbox and serve
 
     Data: <Value Size (4 bytes)><Value>\0<Content-Type>\0<Timestamp (4 bytes)>
 
-File type can be: `twoskip`_  (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_  (default) or `skiplist`_.
 
 .. _imap-concepts-deployment-db-quotas:
 
@@ -85,7 +85,7 @@ This database contains the master list o
 
     Data: <Usage (in bytes)>SP<Limit (in Kbytes)>
 
-File type can be: `quotalegacy`_ (default), `flat`_, `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `quotalegacy`_ (default), `flat`_, `skiplist`_, `sql`_, or `twoskip`_.
 
 
 **Legacy Quotas**
@@ -110,7 +110,7 @@ This database is used for duplicate deli
 
     Data: <Timestamp (4 bytes)><Message UID (4 bytes)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-tls:
@@ -124,7 +124,7 @@ This database caches SSL/TLS sessions so
 
     Data: <Timestamp (4 bytes)><Session Data (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-pts:
@@ -138,7 +138,7 @@ This database caches authentication stat
 
     Data: <Auth State (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default) or `skiplist`_.
 
 
 .. _imap-concepts-deployment-db-status:
@@ -152,7 +152,7 @@ This database caches IMAP STATUS informa
 
     Data: <Version>SP<Bitmask of Items>SP<Mtime of Index>SP<Inode of Index>SP<Size of Index>SP<- of Messages>SP<- of Recent Messages>SP<Next UID>SP<UID Validity>SP<- of Unseen Messages>SP<Highest Mod Sequence>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-userdeny:
@@ -160,13 +160,13 @@ File type can be: `twoskip`_ (default),
 User Access (user_deny.db)
 --------------------------
 
-This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of wildmat patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in cyrus.conf(5). The format of each record is as follows::
+This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of `wildmat <https://tools.ietf.org/html/rfc3977#section-4>`_ patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in :cyrusman:`cyrus.conf(5)`. The format of each record is as follows::
 
     Key: <Userid>
 
     Data: <Version>TAB<Deny List (comma-separated wildmat patterns)>TAB<Deny Message>
 
-File type can be: `flat`_ (default), `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `flat`_ (default), `skiplist`_, `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-backups:
 
@@ -176,7 +176,7 @@ Backups (backups.db)
 This database maps userids to the location of their backup files.  It only exists
 on Cyrus Backup servers (compiled with the `--enable-backup` configure option).
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-conversations:
 
@@ -188,12 +188,12 @@ in the past three months, mapping to the
 ID has been seen, and the timestamp when it was last seen.
 
 It also has a records for each conversation ID with details about which folders
-have that converations ID in them, and counts of messages and flags.
+have that conversations ID in them, and counts of messages and flags.
 
 Finally there are records for each folder with the counts of conversations in
 that folder.
 
-File type can be: `skiplist`_ (default), `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `skiplist`_ (default), `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-counters:
 
@@ -213,13 +213,19 @@ File format not selectable.
 
 .. _imap-concepts-deployment-db-search:
 
-Search Indexes (cyrus.squat, <userid>.xapianactive)
----------------------------------------------------
+Search Indexes (cyrus.squat, <userid>.xapianactive, cyrus.indexed.db)
+---------------------------------------------------------------------
 
-This is either cyrus.squat in each folder, or if you're using xapian a single
-<userid>.xapianactive file listing active databases by tier name and number.
+This is either cyrus.squat in each folder, or if you're using Xapian a single
+<userid>.xapianactive file listing active databases with tier name and number.
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+cyrus.indexed.db is used by the Xapian search engine.  Its file type
+can be: `twoskip`_ (default), `flat`_, `skiplist`_, or ``zeroskip`` and is
+determined by `search_indexed_db` in :cyrusman:`imapd.conf(5)`.
+
+The xapianactive file contains a space separated list of tiers and databases within
+the tier.  The first element is the active tier/database, to which new entries are
+added by `squatter -R`.
 
 .. _imap-concepts-deployment-db-zoneinfo:
 
@@ -237,7 +243,7 @@ alias).  The format of each record is as
 
     Data: <Version>SP<Record Type>SP<Timestamp>SP<Data Strings (TAB-separated)>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, or `skiplist`_.
 
 .. _imap-concepts-deployment-db-seen:
 
@@ -250,7 +256,7 @@ This database is a per-user database and
 
     Data: <Version>SP<Last Read Time>SP<Last Read UID>SP<Last Change Time>SP<List of Read UIDs>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, or `skiplist`_.
 
 .. _imap-concepts-deployment-db-sub:
 
@@ -263,7 +269,7 @@ This database is a per-user database and
 
     Data: None
 
-File type can be: `flat`_ (default), `skiplist`_, `twoskip`_, or `lmdb`_.
+File type can be: `flat`_ (default), `skiplist`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-xapianactive:
 
@@ -284,7 +290,7 @@ This database is a per-user database and
 
     Data: <Version (2 bytes)><Access Key (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default) or `skiplist`_.
 
 .. _imap-concepts-deployment-db-userdav:
 
@@ -380,15 +386,6 @@ An implementation of the `Skip List <htt
 data structure. Deprecated in favour of `Twoskip`_ as it is not robust in
 the face of disk failure.
 
-lmdb
-----
-
-`Lightning Memory-Mapped Database (lmdb) <http://symas.com/mdb>`_ is a
-high-performance transactional key-value store.
-
-Fast while in memory, but slow when the database is loaded. Best for databases
-that are held open for a long time: `Mailbox List (mailboxes.db)`_
-
 sql
 ---
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/concepts/deployment/performance_recommendations.txt 3.2.0-3/doc/html/_sources/imap/concepts/deployment/performance_recommendations.txt
--- 3.0.13-5/doc/html/_sources/imap/concepts/deployment/performance_recommendations.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/concepts/deployment/performance_recommendations.txt	2020-04-24 02:03:00.000000000 +0000
@@ -19,3 +19,6 @@ In-memory filesystems are faster then di
     Cyrus IMAP requires the parent directories to exist, and be writeable by the POSIX user account Cyrus IMAP runs under, prior to starting the ``master`` process.
 
 
+Certificates
+------------
+Cyrus IMAP can be configured to provide as server two kind of certificates: EC and RSA.  The EC certificates are only sent to the client, if the client supports them.  EC certificates have the advantage of requiring less computational resources compared to RSA, while offering comparatively the same security.
diff -pruN 3.0.13-5/doc/html/_sources/imap/concepts/deployment/supported-platforms.txt 3.2.0-3/doc/html/_sources/imap/concepts/deployment/supported-platforms.txt
--- 3.0.13-5/doc/html/_sources/imap/concepts/deployment/supported-platforms.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/concepts/deployment/supported-platforms.txt	2020-04-24 02:03:00.000000000 +0000
@@ -72,22 +72,6 @@ Optional Software Components
 
 When including the following software components during the build process, and providing the options listed here, additional optional functionality can be implemented;
 
-**Berkeley DB** (Development headers)
-
-To enable using Berkely DB as a database backend, include the Berkeley DB development headers and make sure to configure Cyrus IMAP with ``--with-bdb``.
-
-Berkeley DB Versions and Conversion
-
-The Cyrus IMAP ``configure`` process attempts to automatically detect and use the latest Berkeley DB technology available on the system. This may, however, not be the same version on your production systems. Since database conversions between versions of the Berkeley DB technology are particularly difficult and therefor NOT considered fully supported, we recommend you do NOT use Berkeley DB.
-
-Should the Berkeley DB development headers be installed in a non-standard location, or should you need a specific version when multiple versions are available on the system, please consider using any of the following options;
-
-::
-
-    --with-bdb=DIR            use Berkeley DB (in DIR) [yes]
-    --with-bdb-libdir=DIR     Berkeley DB lib files are in DIR
-    --with-bdb-incdir=DIR     Berkeley DB include files are in DIR</screen>
-
 **MySQL** (Development headers)
 
 To enable using MySQL as a database server backend, include the MySQL development headers and make sure to configure Cyrus IMAP with ``--with-mysql``.
diff -pruN 3.0.13-5/doc/html/_sources/imap/concepts/features/access-control.txt 3.2.0-3/doc/html/_sources/imap/concepts/features/access-control.txt
--- 3.0.13-5/doc/html/_sources/imap/concepts/features/access-control.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/concepts/features/access-control.txt	2020-04-24 02:03:00.000000000 +0000
@@ -17,8 +17,4 @@ to information contained within the Cyru
     *   :ref:`imap-admin-access-control-defaults`
     *   :ref:`imap-admin-access-control-identifiers`
 
-.. toctree::
-    :hidden:
-    :glob:
-
 Back to :ref:`imap-features`
diff -pruN 3.0.13-5/doc/html/_sources/imap/concepts/features.txt 3.2.0-3/doc/html/_sources/imap/concepts/features.txt
--- 3.0.13-5/doc/html/_sources/imap/concepts/features.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/concepts/features.txt	2020-04-24 02:03:00.000000000 +0000
@@ -25,6 +25,9 @@ concurrent read/write connections to the
 The server supports access control lists on mailboxes and storage
 quotas on mailbox hierarchies.
 
+Cyrus IMAP provisionally supports the emerging JMAP protocol standards,
+when built for such.
+
 The following documents show the full power of each feature that is
 included with Cyrus IMAP.
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/ancient-releasing.txt 3.2.0-3/doc/html/_sources/imap/developer/ancient-releasing.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/ancient-releasing.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/ancient-releasing.txt	2020-04-08 00:07:13.000000000 +0000
@@ -55,6 +55,11 @@ Pre-release testing
    vi.   Compile it: ``make`` -- it should build correctly.
    vii.  Run the unit tests if there are any: ``make check`` -- they should pass.
 
+.. Note::
+    We don't bother to run ``make distcheck`` on the old branches, because it
+    almost certainly won't work.  We also don't bother to run Cassandane, for
+    much the same reason.  If it builds, that's about as much as we can do.
+
 Cross-pollination of release notes
 ==================================
 
@@ -63,7 +68,7 @@ release notes for these versions appear
 be added to current branches as well.
 
 1. Change to the current stable branch (at time of writing, this is ``cyrus-imapd-3.0``).
-2. Create a new release notes at the appropriate location under
+2. Create a new release notes document at the appropriate location under
    ``docsrc/imap/download/release-notes/``.
 3. Add the release notes you wrote earlier, this time using RST format rather
    than simple HTML.
@@ -96,19 +101,7 @@ Building the release
 11. Push the tag upstream: ``git push ci cyrus-imapd-<version>`` (assuming your
     remote is named "ci").
 
-Releasing
-=========
+Finishing up
+============
 
-1. Upload the tarball and signature to www: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/``
-2. Upload them to ftp too: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/``
-3. SSH into both www and ftp, and move older releases to the old versions
-   directory.  You want only the two most recent tarball+sig pairs for each
-   major series.
-4. While SSH'd into www, build the legacy documentation for this release:
-
-   i.  Copy the release tarball to /var/tmp
-   ii. Run the script to publish the tarball documentation to the web:
-       ``/usr/local/bin/PublishCyrusDocs.pl -f /var/tmp/cyrus-imapd-<version>.tar.gz``
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+Now follow the remaining steps from :ref:`imap-developer-releasing`
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/API/cyrusdb2.txt 3.2.0-3/doc/html/_sources/imap/developer/API/cyrusdb2.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/API/cyrusdb2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/API/cyrusdb2.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,317 @@
+.. _imap-developer-api-cyrusdb2:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+cyrusdb API
+===========
+
+Intro
+-----
+
+The ``cyrusdb`` API is a common interface to a key-value store, used
+throughout the Cyrus code. It allows a choice of different backends for
+different access patterns, while ensuring a consistent interface.
+
+This document will describe the interface, and how to use the cyrusdb
+interface from within parts of Cyrus code, as well as how to implement
+your own backend
+
+If you pass incorrect values to these APIs, you will get an assertion
+failure in most cases. That's generally considered safer than silently
+breaking things. Exceptions are noted below.
+
+Code Layout
+-----------
+
+The implementation of each interface is in ``lib/cyrusdb_NAME.c``, for
+example lib/cyrusdb\_flat.c. General functions are in ``lib/cyrusdb.c``
+and the interface in ``lib/cyrusdb.h``.
+
+Configuration
+-------------
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: ``annotation_db: skiplist``. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable ``config_annotation_db`` gets set to the configured
+backend name:
+
+::
+
+        config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: ``config_annotation_db`` is a string
+describing the *backend* used by the database, not, say, its location on
+disk.)
+
+Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+``lib/cyrusdb.c``
+
+``lib/cyrus.c`` provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+A full example
+--------------
+
+::
+
+      struct db *db = NULL;
+      struct txn *tid = NULL;
+      const char *filename = NULL;
+      int flags = CYRUSDB_CREATE;
+
+      cyrus_init(alt_config, "toolname", 0);
+
+      filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+      r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+      r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+      r = cyrusdb_commit(db, tid);
+
+      r = cyrusdb_close(db);
+
+      cyrus_done();
+
+Note that you always open a database first, and close it at the end. You
+must always call cyrus\_init() and cyrus\_done() to properly initialize
+and clean up the ``cyrusdb`` environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+About Transactions
+------------------
+
+The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the 'tid' parameter decides which mode
+is used. There are three possible values:
+
+-  NULL - non-transactional. Will create a temporary lock for the
+   duration of the current action - either a write lock for "store" or a
+   read lock for "fetch". If you call "foreach", the lock will be
+   dropped between each record fetched
+-  Pointer to NULL - transactional, transaction not yet started. Will
+   always take a write lock on the database, and update the pointer to
+   point to the new transaction.
+-  Pointer to a valid transaction. Will keep using this transaction
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions. There is one exception in the skiplist backend: *If you
+pass NULL to a fetch or foreach while the database is in a transaction,
+it will silently do the read in the current transaction rather than
+returning an error*
+
+API Reference
+-------------
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+cyrusdb\_init(void)
+~~~~~~~~~~~~~~~~~~~
+
+Is called once per process. Don't call this yourself, use
+``cyrus_init()``. No other calls will be made until this is called.
+
+cyrusdb\_done(void)
+~~~~~~~~~~~~~~~~~~~
+
+The opposite of ``cyrusdb_init()`` - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use ``cyrus_done()``.
+
+cyrusdb\_sync(const char \*backend)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by ``ctl_cyrusdb -c`` on a regular basis
+
+cyrusdb\_open(const char \*backend, const char \*fname, int flags, struct db \*\*retdb)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Opens the database with the specified 'file name' (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure
+
+Flags:
+
+-  CYRUSDB\_CREATE - create the database if it doesn't exist
+-  CYRUSDB\_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there is any error reading the file, or any
+   corruption detected while loading the file
+
+cyrusdb\_close(struct db \*db)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Close the named database. Will release any locks if they are still held,
+but it's bad practice to close without committing or aborting, so the
+backend should log an error
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there are any errors during close
+
+cyrusdb\_fetch(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_fetchlock(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case \*datalen will be set to zero, and \*data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if any error occurs reading from the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if there is no record that matches the key
+
+cyrusdb\_foreach(struct db \*db, const char \*prefix, size\_t prefixlen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_forone(struct db \*db, const char \*key, size\_t keylen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+``cyrusdb_foreach()`` iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.
+
+``cyrusdb_forone()`` "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.
+
+``goodp`` - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can't make any database changes, it doesn't
+break the lock, so it's faster to use goodp to filter records if you
+don't need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.
+
+``procp`` - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+-  procp\_result - whatever your callback returns
+-  CYRUSDB\_IOERROR - if any error occurs while reading
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_create(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_store(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Create a new record or replace an existing one. The only difference
+between these two is that ``cyrusdb_create`` will return an error if the
+record already exists, while ``cyrusdb_store`` will replace it
+
+If tidptr is NULL, create/store will take a write lock for the duration
+of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_EXISTS - if ``cyrusdb_create`` is called on an existing key
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_delete(struct db \*db, const char \*key, size\_t keylen, struct txn \*\*tidptr, int force)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if force is not set and the key doesn't exist
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_commit(struct db \*db, struct txn \*tid)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_abort(struct db \*db, struct txn \*tid)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_dump(struct db \*db, int detail)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+cyrusdb\_consistent(struct db \*db)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check if the DB is internally consistent. Looks pretty bogus, and isn't
+used anywhere. Don't use.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/API/cyrusdb.txt 3.2.0-3/doc/html/_sources/imap/developer/API/cyrusdb.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/API/cyrusdb.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/API/cyrusdb.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,661 @@
+.. _imap-developer-api-cyrusdb:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from Markdown.
+
+CyrusDB API
+===========
+
+The interface
+-------------
+
+    The bulk, especially the beginning, of this document is from an
+    `email <https://lists.andrew.cmu.edu/pipermail/cyrus-devel/2018-February/004217.html>`__
+    Bron sent to the
+    `cyrus-devel <https://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
+    mailing list on 27 February 2018 05:50:39GMT.
+
+The cyrusdb interface is a common API for accessing key-value
+datastores from within cyrus code. It's part of the libcyrus shared
+object (but not libcyrus_min), used by all cyrus binaries. The use of
+the cyrusdb API abstracts the details of the underlying data store,
+allowing sites to use different database types depending on their
+needs, and allowing Cyrus developers to use a common API for data
+storage needs.
+
+The entire cyrusdb source lives in the lib/ directory of the cyrus-imapd repository, in the following files:
+
+::
+
+    lib/cyrusdb.h
+    lib/cyrusdb.c
+    lib/cyrusdb_flat.c
+    lib/cyrusdb_quotalegacy.c
+    lib/cyrusdb_skiplist.c
+    lib/cyrusdb_sql.c
+    lib/cyrusdb_twoskip.c
+
+cyrusdb.h
++++++++++
+
+*   interface definitions (all access to cyrusdb databases happens
+    through the functions defined here)
+*   the ``struct cyrusdb_backend`` data structure which defines the
+    interface implemented by each backend.
+*   constants for flags to the cyrusdb_open call, and return codes.
+    Cyrusdb functions all return their own CYRUSDB_* error codes, which
+    are not compatible with the r = IMAP_* return codes used throughout
+    much of the rest of the codebase.
+
+cyrusdb.c
++++++++++
+
+*   implementations of the wrapper functions around the backends,
+    including default implementations of some functions which are
+    common to many backends but overridden by some.
+*   a wrapper to initialise and cleanup the state of each backend
+    (if needed) during Cyrus set up / tear down.
+
+cyrusdb_*.c
++++++++++++
+
+*   the actual implementations of each backend! We'll look at some
+    in a sec.
+
+Configuration
+-------------
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: ``annotation_db: skiplist``. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable ``config_annotation_db`` gets set to the configured
+backend name:
+
+::
+
+        config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: ``config_annotation_db`` is a string
+describing the *backend* used by the database, not, say, its location on
+disk.)
+
+Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+``lib/cyrusdb.c``
+
+``lib/cyrus.c`` provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+A full example
+--------------
+
+::
+
+      struct db *db = NULL;
+      struct txn *tid = NULL;
+      const char *filename = NULL;
+      int flags = CYRUSDB_CREATE;
+
+      cyrus_init(alt_config, "toolname", 0);
+
+      filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+      r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+      r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+      r = cyrusdb_commit(db, tid);
+
+      r = cyrusdb_close(db);
+
+      cyrus_done();
+
+Note that you always open a database first, and close it at the end. You
+must always call cyrus\_init() and cyrus\_done() to properly initialize
+and clean up the ``cyrusdb`` environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+Tools
+-----
+
+There are also some tools to work with and support cyrus databases:
+
+imap/ctl_cyrusdb
+++++++++++++++++
+
+:cyrusman:`ctl_cyrusdb(8)`
+
+*   performs maintenance on the cyrusdb subsystem. This is called in two places:
+
+    *   START: "ctl_cyrusdb -r" (recovery).
+        This is the ONLY PLACE that code is guaranteed to be run at
+        startup on every cyrus installation, so you'll find quite a lot
+        of detritus has built up in this codepath over the years.
+    *   EVENTS: "ctl_cyrusdb -c" (checkpoint).
+        This is run regularly (period=180 at FastMail, examples in the
+        codebase have period=5 or period=30). Both this codepath and
+        cyr_expire tend to run periodically on cyrus systems, and
+        cleanup code is spread between those two locations.
+
+imap/cvt_cyrusdb
+++++++++++++++++
+
+:cyrusman:`cvt_cyrusdb(8)`
+
+*   used for converting a database between versions.
+    This is often used to prepare for upgrade, particularly in the past
+    when Cyrus supported berkeley DB which didn't upgrade cleanly
+    across OS versions, it was common to use cvt_cyrusdb to turn
+    databases into a very portable format (flat or skiplist) before
+    upgrading, upgrade the OS, convert back to the fast format
+    (berkeley) and then restart.
+
+imap/cyr_dbtool
++++++++++++++++
+
+:cyrusman:`cyr_dbtool(8)`
+
+*   once known as brontool, this is the first piece of Cyrus code
+    I ever wrote! It's a fairly dumb wrapper around the CyrusDB
+    interface, and able to be used to read, write, or iterate any parts
+    of a database. Its interactive mode is not special-character clean,
+    but it can also be used in batch mode, which uses IMAP atom-string
+    literal8 for input/output, and hence can roundtrip data reliably.
+
+There are also tools like: :cyrusman:`ctl_conversationsdb(8)`,
+:cyrusman:`dav_reconstruct(1)` and :cyrusman:`ctl_mboxlist(8)` which
+can be used to manage individual databases through a more specific
+interface which understands the context as well as just the raw
+key/value.
+
+How to use CyrusDB
+------------------
+
+Assuming that ``cyrus_init()`` has been called, which calls
+``cyrusdb_init()``, you can assume that databases will work in any
+Cyrus code.
+
+The first step is to open a database. Databases have a filename - this
+might be a literal filename on the backend, a directly containing data,
+or an opaque token used by the backend to locate a datasource.
+
+::
+
+    int flags = 0;
+    struct db *mydb = NULL;
+    int r = cyrusdb_open("skiplist", "/tmp/database.db", flags, &mydb);
+    if (!r) return mydb;  // if (r == CYRUSDB_OK) { ... }
+    /* XXX: error handling */
+
+Accepted flags:
+
+CYRUSDB_CREATE - if the named database doesn't exist, create a blank
+database.
+
+CYRUSDB_MBOXSORT - use the abomination called improved_mboxlist_sort
+which re-orders a couple of characters to allow "foo.bar" to sort
+before "foo bar", for perfectly good reasons, but we're going to fix it
+a better way. Not every engine supports arbitrary collation, and if
+many engines corrupt horribly if the same database is opened with
+different choices for this flag. Ouch.
+
+CYRUSDB_CONVERT - if set and the database fails to open, attempt a
+magic detection on the file content and try to convert the database to
+the requested backend type before opening it. In-place upgrades! If
+this is NOT set, then instead the magic detection will still be
+performed, but the open database will be returned using the correct
+engine for that database rather than converted. Magic detection only
+currently works for single-file database formats.
+
+CYRUSDB_NOCOMPACT - if the database format supports automatic
+compacting, don't use it. Handy for when you want to read without
+causing any possible issues (e.g. read-only filesystem during recovery)
+or when performance is critical and you don't want to risk waiting
+while a recompact happens.
+
+All the remaining functions take that "struct db" pointer.
+
+There's also a ``cyrusdb_lockopen()`` interface which takes a
+transaction pointer and returns with the transaction already active.
+This isn't actually being used yet, but is intended to allow slightly
+more efficient single-operation database use. Right now, open returns
+an unlocked database, but may need to lock as part of the setup, so
+keeping that lock would avoid one extra unlock/lock cycle.
+
+Reading, Writing, & Transactions
+--------------------------------
+
+CyrusDB supports both transactional and non-transactional access.
+Transactions are always exclusive. This is arguably a deficiency in the
+interface, particularly since many engines implement a non-exclusive
+(read) lock internally anyway.
+
+Reading
++++++++
+
+There are now 4 interfaces to read data. Two of which are original
+cyrusdb and two of which are more recently added.
+
+original:
+
+    ``cyrusdb_fetch()``
+        fetch a single value by exact key.
+    ``cyrusdb_foreach()``
+        given a prefix, iterate over all the keys with that prefix
+        (including exactly that key) in order.
+
+newer:
+
+    ``cyrusdb_fetchnext()``
+        given an exact key, fetch the following key and value
+        (regardless of whether the key exists), e.g given keys "f" and
+        "g", fetchnext "foo" would return "g", as would fetchnext "f".
+        This can be used to implement foreach (indeed, the skips do
+        exactly that).
+
+    ``cyrusdb_forone()``
+        given an exact key, act like ``cyrusdb_foreach`` but only for
+        that one key.
+
+        This is a convenience wrapper around fetch to
+        allow doing things like::
+
+            r = cyrusdb_forone(mydb, "folder", 6, p, cb, rock, &tid);
+            if (!r) r = cyrusdb_foreach(mydb, "folder.", 7, p, cb, rock, &tid);
+
+        Which does precisely "folder" and its children without visiting
+        any other keys that have "folder" as a prefix.
+
+Since the cyrusdb interface always takes both a pointer and a length,
+it's also possible to use::
+
+    char *key = "folder.";
+    r = cyrusdb_forone(mydb, key, 6, p, cb, rock, &tid);
+    if (!r) r = cyrusdb_foreach(mydb, key, 7, p, cb, rock, &tid);
+
+OK, foreach. Foreach is very tricky, because it takes TWO callbacks.
+The callbacks have an identical signature, but different return codes!
+
+::
+
+    typedef int foreach_p(void *rock,
+    const char *key, size_t keylen,
+    const char *data, size_t datalen);
+
+    typedef int foreach_cb(void *rock,
+    const char *key, size_t keylen,
+    const char *data, size_t datalen);
+
+The difference is this: ``foreach_p`` is called with the database
+locked, always - even if called without a transaction. ``foreach_p``
+returns 1 or 0. 0 means "skip this record", 1 means "process this
+record". This is useful to pre-filter records when called without a
+transaction, because otherwise you lock and unlock all the time.
+
+NULL for ``foreach_p`` is treated like a test which always returns '1',
+so you can pass NULL if you don't need filtering.
+
+If ``foreach_p`` returns 1, then with an unlocked transaction, the
+database is now unlocked BEFORE calling ``foreach_cb``, the callback.
+``foreach_cb`` returns a CYRUSDB\_ response. If zero, the foreach will
+continue. If non-zero, the foreach will abort and return the non-zero
+response. This is both useful for error cases, and useful for
+short-circuiting, if you only care that a key exists, you can do
+something like::
+
+    static int exists_cb(void rock attribute((unused)), [...])
+    {
+        return CYRUSDB_DONE; / one is enough */
+    }
+
+and then use ``exists_cb`` as your ``foreach_cb`` and check if the
+return code is CYRUSDB_DONE to know if the foreach found a key.
+
+If foreach is called with a transaction pointer, then it is your
+responsibility as the caller to also pass that pointer (and a pointer
+to the database) in that rock, so that callees can make further
+operations within the same transaction. A foreach with a transaction
+does NOT unlock before calling its callback.
+
+About Transactions
+++++++++++++++++++
+
+You may have noticed that 'tid' at the end. Every function for acting
+on the database takes as its last argument a ``struct txn **``.
+
+The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the 'tid' parameter decides which mode
+is used. There are three possible values:
+
+*   NULL - non-transactional request.
+    Do whatever you need for internal locking, but starts with an
+    unlocked database and ends with an unlocked database.
+
+    .. Note::
+
+        At least skiplist and twoskip implement a hack where if the
+        database IS locked for a non-transactional read request, they
+        will act as if you'd passed the current transaction in for the
+        NULL case. This is a hack around layering violations and kind
+        of sucks.
+
+*   &NULL - e.g::
+
+        struct txn *tid = NULL;
+        const char *data = NULL;
+        size_t datalen = 0;
+        int r = cyrusdb_fetch(mydb, key, keylen, &data, &datalen, &tid);
+
+    After calling this, tid will have an opaque value allocated by the
+    database backend, which must be passed to all further cyrusdb
+    operations on that database until either ``cyrusdb_commit()`` or
+    ``cyrusdb_abort()`` are called.
+
+*   &tid - e.g::
+
+        if (r == CYRUSDB_NOTFOUND) {
+            r = cyrusdb_store(mydb, key, keylen, "DEFAULT", 7, &tid); // set a default value
+        }
+
+    Given an existing transaction, perform this call in the context of the transaction.
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions.
+
+There is one exception in the skiplist backend:
+
+    If you pass NULL to a fetch or foreach while the database is in a
+    transaction, it will silently do the read in the current
+    transaction rather than returning an error.
+
+Writing
++++++++
+
+There are three write operations:
+
+::
+
+    cyrusdb_create
+    cyrusdb_store
+    cyrusdb_delete
+
+``cyrusdb_store`` will either create or overwrite an existing key.
+``cyrusdb_create`` will abort if the key already exists.
+``cyrusdb_delete`` takes a flag 'force' which just makes it return
+CYRUSDB_OK (0) rather than CYRUSDB_NOTFOUND if the key doesn't exist.
+Strangely, 'force' is after &tid, making it the only cyrusdb API that
+does that, but hey - keeps you on your toes.
+
+&tid behaves exactly the same for the write APIs. If not passed, then
+the database engine will behave as it if creates a writable
+transaction, does the operation, then commits all within the
+``cyrusdb_*`` call.
+
+Gotchas!
+--------
+
+*   NULL is permitted in both keys and values, though 'flat' and
+    'quotalegacy' have 8-bit cleanliness issues.
+
+*   zero-length keys are not supported
+
+*   zero-length values are theoretically supported, but a little
+    interesting. Certainly, pass "" rather than NULL as the value when
+    writing or things will get weird. I'm pretty sure at least the
+    \*skip databases assert on these kinds of weirdness.
+
+*   unlocked foreach: this is the land of the gotcha! They key and data
+    pointers (const char \*) passed to your ``foreach_cb`` are only
+    valid UNTIL YOU TOUCH THE DATABASE. A common cause of rare and hard
+    to diagnose bugs is writing something to the same database in the
+    same process (OR EVEN READING FROM IT AGAIN). I cannot emphasise
+    this enough. If you want to zero-copy access that data, you need to
+    access it first, before touching that DB again. Otherwise the map
+    in which the data was a pointer may have been replaced as the next
+    read found a new file and mapped it in!
+
+    also: if you're implementing a backend. Unlocked foreach must find
+    future records created by the current callback. Consider a database
+    containing 4 keys::
+
+        A B C D
+
+    If you are at key B and insert a key BB, then it must be iterated over.
+    If you insert AA while at B, it must NOT be iterated over.
+
+*   Opening the same database multiple times.
+    In the bad old days, opening the same database multiple times in
+    the same process led to locking bugs (fcntl is braindead). Each
+    database engine is responsible for making sure this doesn't happen.
+    Most engines keep a linked lists of open databases. If you try to
+    open the same database again, they will just return the existing
+    opened copy and bump a refcount. Beware. If a database is locked
+    and you try to lock again - thinking you were opening it brand new,
+    it will assertion fail and/or error.
+
+I think that covers about everything! Cyrusdb is used just about
+everywhere that sorted key-value databases give what's needed,
+including mailboxes.db, annotations.db (global and per mailbox
+databases), seen state (non-owner), subscriptions, cyrus.indexed.db for
+Xapian, and the rather massive (and increasingly inaccurately named)
+user.conversations.
+
+Future plans are to increase the usage of cyrusdb databases, possibly
+by building an indexing layer on top and using that instead of the
+sqldb interface used for sqlite databases by DAV code, and possibly
+also moving other custom file formats into a cyrusdb to allow easier
+stateless server builds on a distributed backend.
+
+
+API Reference
+-------------
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+cyrusdb\_init(void)
++++++++++++++++++++
+
+Is called once per process. Don't call this yourself, use
+``cyrus_init()``. No other calls will be made until this is called.
+
+cyrusdb\_done(void)
++++++++++++++++++++
+
+The opposite of ``cyrusdb_init()`` - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use ``cyrus_done()``.
+
+cyrusdb\_sync(const char \*backend)
++++++++++++++++++++++++++++++++++++
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by ``ctl_cyrusdb -c`` on a regular basis
+
+cyrusdb\_open(const char \*backend, const char \*fname, int flags, struct db \*\*retdb)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Opens the database with the specified 'file name' (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure
+
+Flags:
+
+-  CYRUSDB\_CREATE - create the database if it doesn't exist
+-  CYRUSDB\_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there is any error reading the file, or any
+   corruption detected while loading the file
+
+cyrusdb\_close(struct db \*db)
+++++++++++++++++++++++++++++++
+
+Close the named database. Will release any locks if they are still held,
+but it's bad practice to close without committing or aborting, so the
+backend should log an error
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there are any errors during close
+
+cyrusdb\_fetch(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_fetchlock(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case \*datalen will be set to zero, and \*data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if any error occurs reading from the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if there is no record that matches the key
+
+cyrusdb\_foreach(struct db \*db, const char \*prefix, size\_t prefixlen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_forone(struct db \*db, const char \*key, size\_t keylen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+``cyrusdb_foreach()`` iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.
+
+``cyrusdb_forone()`` "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.
+
+``goodp`` - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can't make any database changes, it doesn't
+break the lock, so it's faster to use goodp to filter records if you
+don't need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.
+
+``procp`` - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+-  procp\_result - whatever your callback returns
+-  CYRUSDB\_IOERROR - if any error occurs while reading
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_create(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_store(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Create a new record or replace an existing one. The only difference
+between these two is that ``cyrusdb_create`` will return an error if the
+record already exists, while ``cyrusdb_store`` will replace it
+
+If tidptr is NULL, create/store will take a write lock for the duration
+of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_EXISTS - if ``cyrusdb_create`` is called on an existing key
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_delete(struct db \*db, const char \*key, size\_t keylen, struct txn \*\*tidptr, int force)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if force is not set and the key doesn't exist
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_commit(struct db \*db, struct txn \*tid)
++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_abort(struct db \*db, struct txn \*tid)
+++++++++++++++++++++++++++++++++++++++++++++++++
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_dump(struct db \*db, int detail)
++++++++++++++++++++++++++++++++++++++++++
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+cyrusdb\_consistent(struct db \*db)
++++++++++++++++++++++++++++++++++++
+
+Check if the DB is internally consistent. Looks pretty bogus, and isn't
+used anywhere. Don't use.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/API/index-api.txt 3.2.0-3/doc/html/_sources/imap/developer/API/index-api.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/API/index-api.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/API/index-api.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,76 @@
+.. _imap-developer-api-index:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Index API
+=========
+
+Intro
+-----
+
+The Index API is implemented in ``imap/index.h`` and ``imap/index.c``.
+It provides a snapshot view into the underlying mailbox (see `the
+Mailbox API documentation <mailbox-api.html>`) which obeys IMAP
+semantics, as well as all the searching and sorting logic.
+
+Opening and closing
+-------------------
+
+::
+
+    struct index_state *state = NULL;
+    struct index_init init;
+    int r;
+    const char *mboxname = "user.brong";
+
+    memset(&init, 0, sizeof(struct index_init));
+    init.userid = imapd_userid;
+    init.authstate = imapd_authstate;
+    init.out = imapd_out;
+
+    r = index_open(mboxname, &init, &state);
+    if (r) return r;
+
+    do_stuff(state);
+
+    index_close(&state);
+
+The ``index_init`` interface sucks. So does passing lots of parameters.
+For now, this will do! Just pass NULL if you're only reading, or use the
+code already in imapd and you'll be fine.
+
+The Index Model
+---------------
+
+Ok - I think a few words about the index model and how it differs from
+direct mailbox access are needed! In the past, index.c used pointers
+directly into the mmaped ``cyrus.index`` file and maintained the old
+mmaped copy if an expunge took place. Under the namelock regime, this is
+no longer required because namelocks will avoid the file being
+re-written.
+
+Also, memory is now cheap. Rather than using locks to ensure
+consistency, we just keep a copy of the ``struct index_record`` for even
+message in the index, stored in memory. Since these are about 100 bytes
+each, a 1 million email mailbox will take rougly 100Mb of memory. That's
+not too bad on a modern server, and that's a **huge** mailbox.
+
+So - the model works like this:
+
+-  Create the index state or re-lock (``index_lock``) the mailbox on an
+   existing index.
+-  call ``index_refresh``
+-  if any changes are to be made (i.e. flag updates for a store,
+   non-peek body fetch, expunge) then cycle through the refreshed state
+   map and update the records which are affected.
+-  call ``index_unlock`` (unlock the underlying mailbox and commit the
+   statuscache changes)
+
+   At this point the index lock is **released** and we have not yet
+   generated any network traffic. Now start generating the response.
+
+-  if expunges are allowed, call ``index_tellexpunge``
+-  call ``index_tellchanges`` to tell about all other changes
+-  return any response that the command itself required
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/API/mailbox-api.txt 3.2.0-3/doc/html/_sources/imap/developer/API/mailbox-api.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/API/mailbox-api.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/API/mailbox-api.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,335 @@
+.. _imap-developer-api-mailbox:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Mailbox API
+===========
+
+Intro
+-----
+
+The Mailbox API is implemented in ``imap/mailbox.h`` and
+``imap/mailbox.c``. It wraps the data structures of the
+``cyrus.header``, ``cyrus.index`` and ``cyrus.cache`` files in a
+psuedo-object-oriented way, allowing easy changes to the mailbox while
+keeping the internal cached data structures consistent.
+
+Opening and closing
+-------------------
+
+::
+
+    struct mailbox *mailbox = NULL;
+    int r;
+    const char *mboxname = "user.brong";
+
+    r = mailbox_open_iwl(mboxname, &mailbox);
+    // or
+    r = mailbox_open_irl(mboxname, &mailbox);
+    // or
+    r = mailbox_open_exclusive(mboxname, &mailbox);
+    if (r) return r;
+
+    do_stuff(mailbox);
+
+    mailbox_close(&mailbox);
+
+It is always necessary to obtain an index lock when opening a mailbox,
+because the index header read must be consistent. The locks are as
+follows:
+
++----------------------------+-------------+--------------+
+| Function                   | Namelock    | Index Lock   |
++============================+=============+==============+
+| mailbox\_open\_iwl         | Shared      | Exclusive    |
++----------------------------+-------------+--------------+
+| mailbox\_open\_irl         | Shared      | Shared       |
++----------------------------+-------------+--------------+
+| mailbox\_open\_exclusive   | Exclusive   | Exclusive    |
++----------------------------+-------------+--------------+
+
+It should never be necessary to call ``mailbox_open_exclusive``, but
+it's included for completeness. Use ``mailbox_open_iwl`` if you expect
+to need to write to the index (or even if you're not sure) and
+``mailbox_open_irl`` when you know you're only reading from the file and
+wish to allow other readers to work concurrently.
+
+Many actions are delayed until the mailbox is closed, or even until the
+*last* mailbox is closed for things that require an exclusive namelock
+to perform like deletion or repack. See below under "delayed actions"
+for more detail.
+
+To avoid opening the same file multiple times, the mailbox API refcounts
+open mailboxes. If you open the same mailbox again (i.e. a URL fetch or
+status command on the currently select mailbox) then the same mailbox
+will be returned. It must be unlocked (see below or the open command
+will return IMAP\_MAILBOX\_LOCKED). The matching close will reduce the
+refcount, and only the final close will do the cleanup actions.
+
+Locking and unlocking
+---------------------
+
+You can keep a mailbox "open", maintaining the namelock, while releasing
+the index lock to allow other processes to make changes to the mailbox.
+By holding the namelock, you know that record numbers won't change, and
+the underlying message files won't be deleted.
+
+``mailbox_close`` will call ``mailbox_unlock_index`` if the index is
+still locked, so it is not necessary to explicitly unlock the index
+before closing.
+
+::
+
+    r = mailbox_unlock_index(mailbox, NULL);
+
+    // sleep on user input...
+
+    r = mailbox_lock_index(mailbox, LOCK_SHARED);
+    // or
+    r = mailbox_lock_index(mailbox, LOCK_EXCLUSIVE);
+
+For example, ``mailbox_unlock_index`` and ``mailbox_lock_index`` are
+used extensively by the index module, allowing an imap client to
+maintain a long lived connection selected to a mailbox and know that
+messages won't magically disappear from under it - yet at the same time
+allow new mail delivery to happen or other imap connections to query the
+mailbox.
+
+If you have built an accurate statuscache item for the locked mailbox,
+you can pass this as the second parameter to mailbox\_index\_unlock. If
+there have been any changes, mailbox\_index\_unlock will invalidated the
+statuscache. If you give it the new value, then it will store that value
+instead. For example:
+
+::
+
+    struct statusdata sdata;
+    index_status(state, &sdata);
+    /* RECENT is zero for everyone else because we wrote a new
+     * recentuid! */
+    sdata.recent = 0;
+    mailbox_unlock_index(state->mailbox, &sdata);
+
+See "delayed actions" below for delayed actions performed during an
+unlock.
+
+Creating, renaming and deleting
+-------------------------------
+
+**WARNING:** These functions only change the mailbox files on disk. They
+don't update the mailboxes.db records or contact murder servers. In most
+cases you are probably looking for the ``mboxlist_`` functions instead.
+
+Creating a mailbox is somewhat longwinded - as there are many optional
+parameters.
+
+::
+
+    int mailbox_create(const char *name, const char *part, const char *acl,
+                       const char *uniqueid, int options, unsigned uidvalidity,
+                       struct mailbox **mailboxptr);
+
+Most interesting to note is that on success, ``mailboxptr`` will contain
+the same mailbox that ``mailbox_open_exclusive`` above would have
+returned, with an exclusive namelock and an exclusive index lock. This
+allows you to perform other consistency operations after creating the
+mailbox with a full guarantee that no other process will even be able to
+know of the mailbox's existence! You can still roll-back by deleting the
+mailbox and the next process will get the namelock and see no mailbox
+with that name.
+
+::
+
+    int mailbox_rename_copy(struct mailbox *oldmailbox,
+                            const char *newname, const char *newpart,
+                            const char *userid, int ignorequota,
+                            int silent,
+                            struct mailbox **newmailboxptr);
+
+Very similar to mailbox\_create - the new mailbox is created with an
+exclusive name lock and returned. The old mailbox must be passed in with
+an **exclusive index lock** but is fine with a shared namelock, as it
+will be passed to ``mailbox_delete``.
+
+::
+
+    int mailbox_delete(struct mailbox **mailboxptr);
+
+Just like ``mailbox_close`` above, this closes the mailbox. Before it
+does so, it sets the OPT\_MAILBOX\_DELETED option flag in the index
+header. The interesting work is actually done in ``mailbox_close``. See
+below under "delayed actions".
+
+``mailbox_delete`` requires an exclusive index lock, but can complete
+quite happily with only a shared namelock.
+
+Reading and writing records
+---------------------------
+
+Ok - so you have a mailbox, it's opened, and the index is locked. Time
+to start reading and writing some records!
+
+At the mailbox level there is no concept of "message numbers" from imap,
+only "record numbers". The canonical variable name to refer to record
+numbers is ``recno``. All records are read and written using
+``struct index_record`` values.
+
+Here at the API definitions used for reading and writing:
+
+::
+
+    int mailbox_read_index_record(struct mailbox *mailbox,
+                                  uint32_t recno,
+                                  struct index_record *record);
+    int mailbox_rewrite_index_record(struct mailbox *mailbox,
+                                     struct index_record *record);
+    int mailbox_append_index_record(struct mailbox *mailbox,
+                                    struct index_record *record);
+    int mailbox_commit(mailbox);
+
+An example of iterating through a mailbox
+
+::
+
+    uint32_t recno;
+    struct index_record record;
+    int make_changes;
+
+    /* DEPRECATED */
+    for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+        if (mailbox_read_index_record(mailbox, recno, &record))
+            fatal("invalid record", EX_SOFTWARE); // or return an error
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+            continue; // skip expunged records
+        make_changes = do_stuff(mailbox, &record);
+        if (make_changes)
+            mailbox_rewrite_index_record(mailbox, &record);
+    }
+
+    /* the new way */
+    int make_change;
+    const struct index_record *record;
+    struct mailbox_iter *iter;
+
+    iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+    while ((record = mailbox_iter_step(iter))) {
+        make_changes = do_stuff(mailbox, record);
+        if (make_changes)
+            mailbox_rewrite_index_record(mailbox, record);
+    }
+    mailbox_iter_done(&iter);
+
+NOTE: ``mailbox_rewrite_index_record`` doesn't need a recno, as that's
+cached inside the index\_record struct.
+
+NOTE: You need an exclusively locked index to use rewrite or append, but
+only a shared index lock to use read.
+
+There are a range of consistency checks done to ensure that a rewrite
+doesn't violate IMAP semantics (an expunged message can never be
+unexpunged, UIDs can't change, etc) and the internal tracking counts and
+quota data are updated as well. They will be committed at unlock time,
+see "delayed actions"
+
+If you don't set the ``record.silent`` field to a true value before
+rewriting or appending, the ``record.modseq`` and
+``record.last_updated`` values will be changed. This allows condstore to
+work correctly.
+
+Appending
+~~~~~~~~~
+
+To append a record, the file must have already been copied into place
+(XXX - plan to move to a stage based system where the mailbox API
+handles the staging, but that's not finished yet) and been parsed into
+the record struct. The UID must be set already, and must be greater than
+the UID of any existing record in the mailbox. There are a range of
+consistency checks done.
+
+The internal consistency counts are updated by append as well.
+
+Committing
+~~~~~~~~~~
+
+When you have finished making any changes, you need to "commit". This
+will write the updated values for any index header fields, rewite the
+``cyrus.header`` file if needed and fsync all changes to disk.
+
+It is a fatal error to unlock (or close) a mailbox that has had changes
+without committing, as it can leave the mailbox in a corrupted state.
+
+Cache records
+~~~~~~~~~~~~~
+
+Cache records are accessed through ``record.crec`` which is not filled
+by read\_index\_record. The cache file is only read and mapped into
+memory as needed, so you if you want to access cache records, the basic
+API is as follows:
+
+::
+
+    int mailbox_cacherecord(struct mailbox *mailbox,
+                            struct index_record *record);
+    const char *cacheitem_base(struct index_record *record, int field);
+    unsigned cacheitem_size(struct index_record *record, int field);
+    struct buf *cacheitem_buf(struct index_record *record, int field);
+
+You must always call ``mailbox_cacherecord`` on a record before trying
+to access any of the cache items. "``field``" above is the individual
+field (there are 10) in the cache record. There's more information on
+those fields in the mailbox internal format documentation.
+
+::
+
+    for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+        if (mailbox_read_index_record(mailbox, recno, &record))
+            fatal("invalid record", EX_SOFTWARE); // or return an error
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+            continue; // skip expunged records
+        if (mailbox_cacherecord(mailbox, &record))
+            fatal("failed to read cache", EX_SOFTWARE);
+        ...
+        envelope_length = cacheitem_size(&record, CACHE_ENVELOPE);
+    }
+
+See ``imap/mailbox.h`` for the full list of constants.
+
+Delayed Actions
+---------------
+
+Here's the bit you've been waiting for! What happens during unlock and
+close
+
+first, unlock
+~~~~~~~~~~~~~
+
+Anything that makes any changes sets the mailbox->has\_changed flag. If
+this is set, then before the index gets unlocked:
+
+-  the updatenotifier (idle) is called
+-  ``sync_log_mailbox`` (replication) gets called
+-  the statuscache value gets erased (or replaced if you passed in an
+   updated value).
+
+then: close
+~~~~~~~~~~~
+
+next the index is unlocked (see above)
+
+third, any "unlink" commands scheduled for email files are run. These
+can't be done until after the mailbox\_commit to ensure consistency -
+the file isn't deleted until the record is written as unlinked! But we
+save the unlink until now so that other tasks aren't waiting for the
+index lock while the unlinks run. Unlink is expensive in IO and time.
+
+finally we check for MAILBOX\_NEEDS\_REPACK or MAILBOX\_DELETED option
+flags. If either is sets, then we make a non-blocking attempt to get an
+exclusive namelock. If the non-blocking attempt fails, then another
+process has the mailbox open, so save the cleanup for them! If it
+succeeds, then go ahead with either ``mailbox_delete_cleanup`` or
+``mailbox_index_repack`` as appropriate.
+
+After this it's just a matter of releasing malloc'd memory and finally
+releasing the name lock.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/API.txt 3.2.0-3/doc/html/_sources/imap/developer/API.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/API.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/API.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,12 @@
+.. _imap-developer-API:
+
+==============
+Developer APIs
+==============
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    API/*
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/compiling.txt 3.2.0-3/doc/html/_sources/imap/developer/compiling.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/compiling.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/compiling.txt	2020-04-24 02:03:00.000000000 +0000
@@ -77,6 +77,7 @@ Developers only
 
     Configure option: ``--with-perl``"
     `perl(Pod::POM::View::Restructured)`_,,,, "Perl library to generate man pages.  This has to be available to the system-wide perl interpreter, found by ``which``:  ``./configure --with-perl`` is not honoured."
+    `python(GitPython)`_,,,, "Python library needed for building the documentation"
     `python(Sphinx)`_,,,, "Python library needed for building the documentation"
     `valgrind`_, valgrind, valgrind, "no", "Performance and memory testing."
     `xxd`_,,,, "For rebuilding the _js.h files, for CalDAV and CardDAV support."
@@ -105,32 +106,23 @@ Alternate database formats
     :header: "Package", "Debian", "RedHat",  "Required for ``make check``?", "Notes"
     :widths: 20,15,15,5,45
 
-    `lmdb`_, lmdb-dev, lmdb, "no", "Lightning Memory-Mapped Database Manager (LMDB) backend for Cyrus IMAP
-    databases.     LMDB requires database environments to be set to a (user-configurable)
-    maximum size. The Cyrus backend uses 512MB as default size. Cyrus
-    installations may override this by setting the environment variable
-    CYRUSDB_LMDB_MAXSIZE. The value of this variable must be an integer,
-    optionally followed (without space) by 'mb' or 'gb' to define the
-    maximum size in bytes, megabytes or gigabytes. The size should be a
-    multiple of the OS page size. "
     `mysql`_ or `mariadb`_, libmysqlclient-dev or libmariadb-dev, mysql-devel or mariadb-devel, "no", "MariaDB or MySQL development headers, to allow Cyrus IMAP to use
     it as the backend for its databases.
 
     Configure option: ``--with-mysql``, ``--with-mysql-incdir``, ``--with-mysql-libdir``"
     `postgresql`_, postgresql-dev, postgresql-devel, "no"
 
-CalDAV and/or CardDAV
-#####################
+CalDAV, CardDAV, or JMAP
+########################
 
 .. csv-table::
     :header: "Package", "Debian", "RedHat",  "Required for ``make check``?", "Notes"
     :widths: 20,15,15,5,45
 
-    `libical`_, libical-dev, libical-devel, "no", "libical >= 0.48 required for scheduling support.
-    **Note:** Linux distributions Enterprise Linux 6 and Debian Squeeze are
-    known to ship outdated **libical** packages versions 0.43 and
-    0.44 respectively. The platforms will not support scheduling."
-    `libxml`_, libxml2-dev, libxml2-devel, "", "no"
+    `libchardet`_, libchardet-dev, libchardet-devel, "no", ""
+    `libical`_, libical-dev, libical-devel, "no", "version 3.0.0 or higher"
+    `libxml`_, libxml2-dev, libxml2-devel, "no", ""
+    `shapelib`_, shapelib, "", "no", "version 1.3.0 or higher"
 
 Other
 #####
@@ -152,8 +144,10 @@ Other
     `transfig`_, transfig, xx, "no", "also known as fig2dev"
     `pcre`_,,,, "PCRE 1 (or 8) - for regular expression matching"
     `perl(Term::ReadLine)`_,,,, "Perl library needed by cyradm"
+    `libsrs2`_,,,, "Sender Rewriting Scheme for lmtp, used on Sieve redirect "
     `zlib`_, zlib1g-dev, zlib-devel, "no", "Compression support for httpd"
     `libbrotli`_,,,, "Brotli compression support for httpd"
+    `wslay`_,,,, "WebSockets support in httpd"
     `nghttp2`_, libnghttp2-dev, libnghttp2-devel, "no", "HTTP/2 support for httpd"
 
 .. _ClamAV: https://www.clamav.net/
@@ -161,9 +155,9 @@ Other
 .. _Cyrus SASL Plain: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
 .. _Cyrus SASL MD5: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
 .. _sasl binaries: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
-.. _lmdb: http://lmdb.tech/
 .. _Kerberos: http://web.mit.edu/kerberos/www/
 .. _libbrotli: https://github.com/google/brotli
+.. _libchardet: https://github.com/Joungkyun/libchardet
 .. _libical: https://github.com/libical/libical/
 .. _libxml: http://xmlsoft.org/
 .. _mysql: http://www.mysql.com
@@ -177,10 +171,14 @@ Other
 .. _perl(Pod::POM::View::Restructured): https://metacpan.org/pod/Pod::POM::View::Restructured
 .. _perl-devel: http://www.perl.org/
 .. _postgresql: http://www.postgresql.org/
+.. _python(GitPython): https://github.com/gitpython-developers/GitPython
 .. _python(Sphinx): https://www.sphinx-doc.org/
+.. _shapelib: http://shapelib.maptools.org
+.. _libsrs2: https://www.libsrs2.org/
 .. _tcp_wrappers: ftp://ftp.porcupine.org/pub/security/index.html
 .. _transfig: http://www.xfig.org/
 .. _valgrind: http://www.valgrind.org/
+.. _wslay: https://tatsuhiro-t.github.io/wslay/
 .. _zlib: http://zlib.net/
 .. _xxd: https://github.com/ConorOG/xxd/
 
@@ -197,7 +195,8 @@ Optionally install dependencies for :ref
 Compile Cyrus
 =============
 
-There are additional :ref:`compile and installation steps<imapinstall-xapian>` if you are using Xapian for searching.
+There are additional :ref:`compile and installation steps<imapinstall-xapian>` if you are using Xapian for searching,
+or if you are :ref:`using jmap <developer-jmap>`.
 
 Default build: mail only
 ------------------------
@@ -231,10 +230,10 @@ via configure.
 
 Sieve is enabled by default.
 
-CalDAV and CardDAV
-##################
+CalDAV, CardDAV, JMAP
+#####################
 
-    ``./configure --enable-http --enable-calalarmd``
+    ``./configure --enable-http --enable-calalarmd --enable-jmap``
 
 Murder
 ######
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/cyrusworks.txt 3.2.0-3/doc/html/_sources/imap/developer/cyrusworks.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/cyrusworks.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/cyrusworks.txt	2020-04-08 00:07:13.000000000 +0000
@@ -5,24 +5,13 @@ Cyrus Works
 About Cyrus Works
 =================
 
-Whenever the Cyrus team push changes to
-`the project repository <https://github.com/cyrusimap/>`_, a notification is
-sent to `Jenkins <https://jenkins.io/>`_ (open source automation server).
-Our Jenkins server is called Cyrus Works and can be found at
-https://www.cyrus.works.
-
-Testing
-=======
-
-Once a week Cyrus.Works builds a complete image, fetching all upstream packages.
-
-Interim builds during the week use the cached weekly image and apply the latest
-Cyrus IMAP code changes from Git.
+`Cyrus Works <https://cyrus.works>`_ is a domain redirection to the Cyrus
+IMAP project's Travis CI dashboard.
 
-Email notifications of build results are sent to the development team.
-
-Cyrus.works will fail is certain strings are found in the log files.  To view results and filter errors/warnings view:
-https://cyrus.works/job/master-jessie/lastFailedBuild/parsed_console/
+Whenever the Cyrus team push changes to
+`the project repository <https://github.com/cyrusimap/>`_, Travis CI
+(via github integration) automatically builds the new commits.  This also
+applies to pull requests submitted through the GitHub site.
 
 How it works
 ============
@@ -31,22 +20,3 @@ How it works
 framework gets pulled in to the
 `Docker Container <https://github.com/cyrusimap/cyrus-docker>`_, confirms
 existing functionality still works and no regression bugs have been introduced.
-
-You can find out more about Cyrus.Works in the `FastMail 2016 advent series blog post <https://blog.fastmail.com/2016/12/14/cyrus-works/>`_.
-
-The code used to build Cyrus.works is available https://github.com/cyrusimap/cyrusworks.
-
-Adding Rules
-============
-
-Instructions on how to add rules:
-https://wiki.jenkins.io/display/JENKINS/Log+Parser+Plugin
-
-The rules for Cyrus Works are stored within git: https://github.com/cyrusimap/cyrusworks/blob/master/Scripts/cyrusworksrules
-
-You need to add rules to two places:
-
-1. **Git**: so when cyrus.works is reinstalled those rules are not lost
-
-2. **The server**: so they’re actually used. Changed pushed to git aren’t pushed to the server. This is for security reasons (we don’t want anyone on the internet to be able to push changes to a live server).
-``root@cyrus.works:/cyrusworks/source/Scripts/cyrusworksrules``
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/developer-testing.txt 3.2.0-3/doc/html/_sources/imap/developer/developer-testing.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/developer-testing.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/developer-testing.txt	2020-04-24 02:03:00.000000000 +0000
@@ -55,6 +55,7 @@ Install and configure Cassandane
         sudo cpan -i Net::DAVTalk
         sudo cpan -i Net::CardDAVTalk
         sudo cpan -i Net::CalDAVTalk
+        sudo cpan -i Mail::JMAPTalk
         sudo cpan -i Math::Int64
 
 3. Install Cassandane
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/developer-tips.txt 3.2.0-3/doc/html/_sources/imap/developer/developer-tips.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/developer-tips.txt	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/developer-tips.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,101 +0,0 @@
-.. _cyrus-hacking:
-
-=========================
-Tips for Hacking on Cyrus
-=========================
-
-Memory Allocation
-=================
-
-All Cyrus memory allocation should be done through the ``libcyrus`` functions. These are all written to correctly call fatal() in the event of an out-of-memory condition.
-
-In addition to xmalloc and xrealloc, we provide replacements for strdup, strndup, and a malloc that will guarantee zeroed block of memory (xzmalloc).
-
-If you are going to need to do a large number of small allocations, and then free them all at once, you should look at the memory pool routines, which are much faster, but will leak memory until you free the entire pool at once.
-
-strlcpy vs strncpy vs memcpy
-============================
-
-Use strlcpy when the size of the buffer is known, e.g.::
-
-    char buf[50];
-    strlcpy(buf, src, sizeof(buf));
-
-Use memcpy to truncate a string into a buffer you know is large enough. Note that the resulting buffer will NOT BE NULL TERMINATED.
-
-::
-
-    memcpy(buf, src, 4);  
-    buf[5] = '\0'
-
-Try to avoid strncpy, since it is much slower than memcpy (it zero-fills the rest of the buffer) and isn't as safe as strlcpy.
-
-Use of the functions in this way will reduce the confusion involved in their various behaviours. This avoids things that look like::
- 
-    strncpy(buf, src, sizeof(buf)-1);
-    buf[sizeof(buf)-1] = '\0';
-
-map_refresh and map_free
-========================
-
-In many cases, it is far more effective to read a file via the operating system's mmap facility than it is to via the traditional read() and lseek system calls. To this end, Cyrus provides an operating system independent wrapper around the mmap() services (or lack thereof) of the operating system.
-
-Cyrus currently only supports read-only memory maps, all writes back to a file need to be done via the more traditional facilities. This is to enable very low-performance support for operating systems which do not provide an mmap() facility via a fake userspace mmap.
-
-To create a map, simply call map_refresh on the map (details are in lib/map.h). To free it, call map_free on the same map.
-
-Despite the fact that the maps are read-only, it is often useful to open the file descriptors O_RDWR, especially if the file decriptors could possibly be used for writing elsewhere in the code. Some operating systems REQUIRE file descriptors that are mmap()ed to be opened O_RDWR, so just do it.
-
-Network Functionality
-=====================
-
-Read about :ref:`Cyrus IMAP Prot Layer <admin-protlayer>`.
-
-Authorization modules
-=====================
-
-**TO DO:**
-
-    Describe what the authorization modules do, what API needs to be implemented, etc. Also possibly discuss the auth_pts module.
-
-.. :todo:
-
-    Describe what the authorization modules do, what API needs to be implemented, etc. Also possibly discuss the auth_pts module.
-
-Other
-=====
-
-* Command line apps should link cli_fatal.o so they all fatal() in the same way, unless there is a really good reason they need to do something unique.
-
-* If you call config_init() you must call cyrus_done() before you exit.
-    No one should ever call DB->init() or DB->done() cyrusdb functions except for in libcyrus_init()
-
-* Try to keep #include statements for libcyrus and libimap alphabetical, and below any system includes.
-
-* Don't exit at the bottom of main with exit(x) use return instead.
-    For all the command line utilities that need to be sure that they are running as cyrus, it should be the first thing they do, and they should exit with an appropriate fatal() call
-
-* All services should have a shut_down call. It should be the ONLY way of exiting the application (every "clean" exit from the system should be via shut_down()). fatal() should always make an attempt to call shut_down() if it can (though it should have a recursive fatal() trap just in case). Similarly, commandline utilities probably don't need a shut_down().
-    
-File Locking
-============
-
-In order to guard against deadlocks, we want to maintain 
-the same order of acquiring locks throughout the system 
-(this may be violated in one or two places, but when it is it is 
-commented as to why it is safe). As long as everyone plays 
-by these rules, we can avoid deadlock.
-
-In an ideal world, our locking order is::
-
-    cyrus.header
-    cyrus.index
-    quota
-    seen
-    mailboxes file
-    
-These try to go from least general to most general, so we hold the largest locks for the shortest period of time.
-
-.. todo::
-    http://www.cyrusimap.org/mediawiki/index.php/Cyrus_IMAP_Hacking
-    http://www.cyrusimap.org/mediawiki/index.php/Cyrus_IMAP_File_Locking
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/hacking.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/hacking.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/hacking.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/hacking.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,401 @@
+.. _imap-developer-guidance-hacking:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Hacking
+==========================
+
+This file aims to be a guide to Cyrus coding style/conventions/useful
+utilities for people trying to approach the code in a sane way.  It's
+not well organized right now but hopefully that will improve with time
+;)
+
+Memory Allocation
+-----------------
+
+*   All cyrus memory allocation should be done through the libcyrus
+    functions.  These are all written to correctly call ``fatal()`` in
+    the event of an out-of-memory condition.
+*   In addition to ``xmalloc`` and ``xrealloc``, we provide replacements
+    for ``strdup``, ``strndup``, and a ``malloc`` that will guarantee
+    zeroed block of memory (``xzmalloc``).
+*   If you are going to need to do a large number of small allocations,
+    and then free them all at once, you should look at the memory pool
+    routines, which are much faster, but will leak memory until you
+    free the entire pool at once.
+
+strlcpy vs strncpy vs memcpy
+----------------------------
+
+*   use ``strlcpy`` when you know the size of the buffer, e.g.:
+
+::
+
+    char buf[50];
+    strlcpy(buf, src, sizeof(buf));
+
+*   use ``memcpy`` to truncate a string into a buffer you know is large
+    enough. Note that when you do this the resulting buffer will NOT BE
+    NULL TERMINATED:
+
+::
+
+    memcpy(buf, src, 4);
+    buf[5] = '\0'
+
+*   you should try to avoid ``strncpy``, since it is much slower than
+    ``memcpy`` (it zero-fills the rest of the buffer) and isn't as safe
+    as ``strlcpy``.
+
+*   Use of the functions in this way will reduce the confusion involved
+    in their various behaviors. In other words, this avoids things that
+    look like:
+
+::
+
+    strncpy(buf, src, sizeof(buf)-1);
+
+map_refresh and map_free
+------------------------
+
+*   In many cases, it is far more effective to read a file via the
+    operating system's mmap facility than it is to via the traditional
+    ``read()`` and ``lseek`` system calls.  To this end, Cyrus provides
+    an operating system independent wrapper around the ``mmap()``
+    services (or lack thereof) of the operating system.
+
+*   Cyrus currently only supports read-only memory maps, all writes back
+    to a file need to be done via the more traditional facilities. This
+    is to enable very low-performance support for operating systems
+    which do not provide an ``mmap()`` facility via a fake userspace
+    ``mmap``.
+
+*   To create a map, simply call ``map_refresh`` on the map (details
+    are in lib/map.h).  To free it, call ``map_free`` on the same map.
+
+*   Despite the fact that the maps are read-only, it is often useful
+    to open the file descriptors O_RDWR, especially if the file
+    descriptors could possibly be used for writing elsewhere in the
+    code. Some operating systems REQUIRE file descriptors that are
+    ``mmap()``-ed to be opened O_RDWR, so just do it.
+
+Network Functions
+-----------------
+
+*   Cyrus abstracts socket stream access to a concept we refer to as
+    "prot streams"  Prot Streams take care of all of the necessary
+    SASL and TLS/SSL encryption that may need to happen before data
+    goes out/comes in from the network.  The API is documented in
+    lib/prot.h
+
+(todo) Authorization Modules
+----------------------------
+
+General Hints
+-------------
+
+Some general hints that all made it into my 11/15 16:47 commit that I
+think may be generally useful to people hacking on the cyrus source:
+
+*   Command line apps should link cli_fatal.o so they all fatal()
+    in the same way, unless there is a really good reason they need to
+    do something unique.
+
+*   If you call ``cyrus_init()`` you must call ``cyrus_done()`` before
+    you exit.
+
+*   No one should ever call ``DB->init()`` or ``DB->done()`` cyrusdb
+    functions except for in ``libcyrus_init()``.
+
+*   I've been trying to keep ``#include`` statements for libcyrus and
+    libimap alphabetical, and below any system includes, but this is
+    merely my personal style
+
+*   Don't exit at the bottom of ``main`` with ``exit(x)`` use
+    ``return`` instead.
+
+*   For all the command line utilities that need to be sure that they
+    are running as the cyrus user, it should be the first thing they
+    do, and they should exit with an appropriate ``fatal()`` call.
+
+*   All services should have a ``shut_down`` call.  It should be the
+    ONLY way of exiting the application.  ``fatal()`` should always
+    make an attempt to call ``shut_down()`` if it can (though it should
+    have a recursive ``fatal()`` trap just in case).  Similarly,
+    command line utilities probably don't need a ``shut_down()``.
+
+
+Coding Standards
+----------------
+
+These are the generally agreed upon coding standards as thrashed
+out on the cyrus-devel list in June 2010.
+
+*   Spacing is 4 characters with soft tabs at 8 - mixed tabs and spaces
+    This corresponds to the vi settings `sw=4 sts=4 ts=8` etc.
+
+*   Group the '\*' character with the variable not the type, i.e.
+
+::
+
+    char *foo;  /* correct */
+    char* foo;  /* WRONG */
+
+*   The keywords 'if', 'for', and 'while' take a space after the keyword.
+    The parentheses around the following expression are not closely
+    connected to the expression without any spaces.  The ';' inside
+    the 'for' expression have a space after them and not before.
+    For example:
+
+::
+
+    if (condition)              /* correct */
+    if(condition)               /* WRONG */
+    if( condition )             /* WRONG */
+
+    for (i = 0; i < x; i++)     /* correct */
+    for(i = 0; i < x; i++)      /* WRONG */
+    for (i = 0 ;i < x ;i++)     /* WRONG */
+    for(i = 0 ;i < x ;i++)      /* WRONG */
+
+    while (foo)                 /* correct */
+    while(foo)                  /* WRONG */
+    while( foo )                /* WRONG */
+
+*   Use spaces around the double-character logical operator
+    '||' but don't use spaces around single-character bitwise
+    operator '|'.
+
+::
+
+    int flags = FOO|BAR;        /* correct */
+    int flags = FOO | BAR;      /* WRONG */
+    if (itchy || scratchy)      /* correct */
+    if (itchy||scratchy)        /* WRONG */
+
+*   Function definitions are followed by a brace on a line by itself,
+    all other braces are inline.  Return types are inline with function
+    definition.  Old K&R style function definitions are not allowed.
+
+::
+
+    void thing(int val)         /* correct */
+    {                           /* correct */
+        ...body...
+    }                           /* correct */
+
+    void                        /* WRONG */
+    thing(int val)              /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void                        /* WRONG */
+    thing(                      /* WRONG */
+        int val)                /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void                        /* WRONG */
+    antique(val)                /* WRONG */
+        int val;                /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void thing(int val) {       /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void noargs(void)           /* correct */
+    {                           /* correct */
+        ...body...
+    }                           /* correct */
+
+    void noargs()               /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+
+*   Long argument lists should be split across multiple lines,
+    with the second and subsequent lines indented so that they
+    line up with the start of the first line of arguments.
+
+::
+
+    void toomanyargs(int arg1, const char *arg2,        /* correct */
+                     struct whatever *arg3, int arg4)   /* correct */
+    {                                                   /* correct */
+        ...body...
+    }                                                   /* correct */
+
+    void toomanyargs(int arg1, const char *arg2,        /* WRONG */
+    struct whatever *arg3, int arg4)                    /* WRONG */
+    {                                                   /* WRONG */
+        ...body...
+    }                                                   /* WRONG */
+
+    void toomanyargs(                                   /* WRONG */
+        int arg1,                                       /* WRONG */
+        const char *arg2,                               /* WRONG */
+        struct whatever *arg3,                          /* WRONG */
+        int arg4)                                       /* WRONG */
+    {                                                   /* WRONG */
+        ...body...
+    }                                                   /* WRONG */
+
+*   Within a function, braces are used in old-fashioned K&R style.
+    Specifically:
+
+    *   open braces are placed at the end of the line containing the
+        statement (such as an 'if') to which they belong, after a
+        single space.
+
+    *   closing braces are placed on a line by themselves, aligned
+        with the start of the statement to which their matching
+        open brace belongs.
+
+    *   this applies even when the closing brace is followed by
+        an 'else' keyword.
+
+..
+
+    Yes, it's ugly and hard to read, but you get used to it and
+    most of the code is currently like that.  Deal with it.
+
+::
+
+    while (cond) {              /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+
+    while (cond){               /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    while (cond) { ...body... } /* WRONG */
+
+    while (cond) {              /* WRONG */
+        ...body... }            /* WRONG */
+
+    while (cond)                /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    while (cond)                /* WRONG */
+      {                         /* WRONG */
+        ...body...              /* WRONG */
+      }                         /* WRONG */
+
+    if (cond) {                 /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+    else if (othercond) {       /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+    else {                      /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+
+    if (cond) {                 /* WRONG */
+        ...body...              /* WRONG */
+    } else if (othercond) {     /* WRONG */
+        ...body...              /* WRONG */
+    } else {                    /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    if (cond)                   /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+    else if (othercond)         /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+    else                        /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+*   The braces around a block used in an 'if'...'else if'...'else'
+    may be omitted if the statement is very simple and clear, such
+    as a single function call.  This is a judgement call though,
+    so play it safe and use braces.
+
+::
+
+    if (cond)                   /* correct, maybe */
+        function();             /* correct, maybe */
+    else                        /* correct, maybe */
+        other_function();       /* correct, maybe */
+
+*   The 'goto' keyword needs to be used very very sparingly and only
+    with forethought.  The only clearly good example is to goto
+    a label at the end of a function to do cleanup under error
+    conditions.
+
+::
+
+    void foo(struct bar *b)     /* correct */
+    {                           /* correct */
+        char *x = xmalloc(...); /* correct */
+
+        if (b == NULL)          /* correct */
+            goto error;         /* correct */
+
+        if (b->quux != 42)      /* correct */
+            goto error;         /* correct */
+
+        ...do useful things...  /* correct */
+    error:                      /* correct */
+        free(x);                /* correct */
+    }                           /* correct */
+
+..
+
+    Very occasionally, it may be permissable to use 'goto' from within
+    a complicated or multiply-nested loop, to the top of a loop, but
+    only if using another control structure is *less* clear.
+
+*   Generally, zero return is SUCCESS and integer return is an error code.
+
+*   Use "``const char *``" where possible.
+
+::
+
+    int is_tacky(const char *name)              /* correct */
+    {                                           /* correct */
+        return !strcmp(name, "britney");        /* correct */
+    }                                           /* correct */
+
+    int is_tacky(char *name)                    /* WRONG */
+    {                                           /* WRONG */
+        return !strcmp(name, "britney");        /* WRONG */
+    }                                           /* WRONG */
+
+*   Use "``struct buf``" for variable length strings where possible.
+
+*   RAII http://en.wikipedia.org/wiki/Resource_Acquisition_Is_Initialization
+    In practice, this means each structure should have a single cleanup
+    function which handles all possible states of the structure and
+    is called whenever the structure needs cleaning up.  Likewise,
+    any resources allocated during a function should be cleaned up
+    in the same function, in a single code block at the end of the
+    function (see the comments on 'goto').
+
+*   If you find yourself passing the same multiple parameters through many
+    functions, create a struct and pass around a pointer to that instead.
+
+*   DON'T EVER REUSE THE SAME VARIABLE FOR TWO DIFFERENT PURPOSES IN THE SAME
+    FUNCTION.  IN FACT, DON'T REUSE THE SAME VARIABLE _NAME_ FOR DIFFERENT
+    PURPOSES.  KTHXBYE.  (note: this doesn't apply to 'i', 'n', etc which are
+    used in multiple loops.  It applies to using the same name for an absolute
+    offset and a "within this mmap" offset though, and it also applies to
+    using the same variable name for native order and network order numbers,
+    which is where I've seen it a few times and been super frustrated!)
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/internationalization.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/internationalization.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/internationalization.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/internationalization.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,386 @@
+.. _imap-developer-guidance-internationalization:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Internationalization
+=======================================
+
+introduction
+------------
+
+Cyrus currently transcodes characters to a canonical UTF-8 form for
+searching. The base spec of IMAP4 only requires understanding multiple
+character sets to properly implement SEARCH. Since the base spec came
+out, several extensions have been proposed that require further charset
+support: SORT, THREAD, and the Sieve subsystem. As of this writing,
+Cyrus doesn't correctly support these other commands.
+
+Cyrus currently only believes in 16-bit characters. Technically, Unicode
+has up to 21-bit characters (expressible in UTF-16 and 3-byte UTF-8) and
+ISO 10646 allows up to 31-bit characters (though ISO's current policy is
+to not allocate any characters outside of the 21-bit Unicode range). The
+lower 16-bit characters make up the basic multilingual plane (BMP) where
+the majority of languages live. This restriction is apparent in
+``charset.c:writeutf8()``, the UTF-8 decoders, and the Unicode
+canonicalization table used by Cyrus. Since Cyrus's known character sets
+(except for UTF-8) don't contain any characters off of the BMP this
+isn't seen to be a major problem.
+
+Throughout this text, Unicode and ISO 10646 will be used interchangeable
+to refer to the 16-bit character set of the BMP, regardless of encoding.
+"Character", unless otherwise specified, refers to a single Unicode
+character ``ffff`` or under.
+
+cyrus canonical form
+--------------------
+
+Since when users search e-mail messages it's much easier for them to
+eliminate false positives than realize there are hits that aren't
+displayed, the Cyrus searching algorithm errs on the side of more
+matches. Before comparing any two strings, Cyrus puts them in a
+canonical form. Logically, the process works as follows:
+
+-  the input string is translated into a sequence of Unicode characters.
+-  each character is transformed into lowercase. (For some characters, a
+   single uppercase character may transform into multiple lowercase
+   characters.)
+-  each character is fully decomposed.
+-  all whitespace (Unicode general categories starting with ``Z``) is
+   removed.
+-  combining diacritical marks, such as the accent on é, are removed.
+   (These are Unicode characters ``0300``-``03ff``.)
+-  certain characters are expanded to alternative spellings using ASCII
+   characters, such as "æ" to "ae".
+-  the output characters are then encoded in UTF-8.
+
+The actual transcoding does all of these steps at once with the aid of
+tables, carefully built at compile-time.
+
+The central part of Cyrus's internationalization support is it's
+transcoding routines in ``lib/charset.[ch]``, and
+``lib/chartable.[ch]``. Cyrus's transcoding routines are very elegant
+and very compact, thus somewhat intimidating. During compilation, Cyrus
+builds up a large number of tables (see `mkchartable <#mkchartable>`__)
+and uses them so that it never has to consider more than a single octet
+at a time while outputting the Cyrus canonical form for an input string.
+
+external interface
+------------------
+
+``lib/charset.h`` is the public interface for Cyrus lib clients to get
+character canonicalization and searching support. In contains the
+following functions:
+
+``char *charset_convert(const char *s, int charset, char *buf, int bufsz)``
+    Given a string *s* in charset *charset*, decode it into canonical
+    form in *buf*. *buf* must be reallocable and currently at least size
+    *bufsz*.
+``char *charset_decode_mimeheader(const char *s, char *buf, int bufsz)``
+    Given a string *s* containing possible MIME encoded substrings (per
+    RFC 2047), decode into canonical form in *buf*. *buf* must be
+    reallocable and currently at least size *bufsz*.
+``charset_index charset_lookupname(const char *name)``
+    Given *name* return the Cyrus charset index. 0 always represents
+    US-ASCII. The returned charset\_index may be saved in a file; it is
+    stable and is an integer. If this version of Cyrus does not support
+    the charset, ``CHARSET_UNKNOWN_CHARSET`` is returned.
+``comp_pat *charset_compilepat(const char *s)``
+    Compiles a NUL-terminated canonicalized string *s* into a
+    Boyer-Moore table for fast searching. I'll describe these `compiled
+    patterns <#comp_pat>`__ later.
+``void charset_freepat(comp_pat *pat)``
+    Frees a pattern previously return by ``charset_compilepat()``.
+``int charset_searchstring(const char *substr, comp_pat *pat,     const char *s, int len)``
+    Searches for a canonicalized string *substr* in the canonicalized
+    string *s*. *s* is of length *len*. *substr* must have been
+    previously compiled into *pat*. Returns non-zero for a hit, zero for
+    no match.
+``int charset_searchfile(const char *substr, comp_pat *pat,                               const char *msg_base, int mapnl, int len,                               charset_index charset, int encoding)``
+    Searches for the canonicalized string *substr* with compiled pattern
+    *pat* in a large buffer starting at *msg\_base* of length *len*. The
+    large buffer is of charset *charset* with the encoding *encoding*.
+    ``charset_searchfile()`` will dynamically unencode and canonicalize
+    the search text looking for *substr*. (If *mapnl* is set, the buffer
+    has only ``\n`` instead of ``\r\n``, but the length assumes that
+    each ``\n`` is dynamically converted to ``\r\n``. This feature is
+    deprecated.)
+``char *charset_decode_mimebody(const char *msg_base, int len,                                      int encoding, char **buf, int *bufsz,                                      int *outlen)``
+    Decode the MIME body part (per RFC 2045) located in the large buffer
+    starting at *msg\_base* of length *len*. The large buffer is of
+    encoding *encoding*. ``charset_decode_mimebody()`` will decode into
+    *buf*. *buf* must be reallocable and currently at least size
+    *bufsz*. The number of decoded bytes is returned in *outlen*.
+``charset_extractfile()``
+    Used by ``squatter`` and possibly other text indexing engines, but
+    not described here.
+
+the TRANSLATE macro: using the transcoding tables
+-------------------------------------------------
+
+The external interface is implemented with the help of the ``START`` and
+``TRANSLATE`` macros:
+
+``void START(struct decode_state *state, const unsigned char (*table)[256][4])``
+    ``START`` initializes *state* to be ready for transcoding of the
+    charset translation table given with *table*. The starting active
+    table is always the first one in the list passed in.
+``void TRANSLATE(struct decode_state *state, unsigned char input, unsigned char *outbuf, unsigned outindex)``
+    ``TRANSLATE`` takes four parameters: *state* is the current state of
+    the translation; it must have been initialized with ``START`` and is
+    modified by ``TRANSLATE``; *input* is one octet of input from the
+    stream to be transcoded; *outbuf* is a pointer to the start of the
+    buffer to write output characters; *outindex* is the index where
+    this translation should be written. The size of *outbuf* must be at
+    least *outindex + charset\_max\_translation*.
+
+Each charset consists of a set of one or more tables; the *table*
+parameter passed into ``START`` is the first of these tables and the
+others are adjacent in memory. Characters are transcoded by indexing
+into the active table with *input* and examining the 4 octet
+translation. The 4 octet translation may consist of 0–3 character
+translations followed by a control code or a series of control codes. In
+effect, the translation for a given octet is a mini-program that
+consists either of UTF-8 octets or control codes. One of the control
+codes RET, END, JSR, or JMP must occur in the 4 octet translation.
+
+control codes
+~~~~~~~~~~~~~
+
+Control codes are represented by uppercase US-ASCII characters since no
+uppercase characters can appear in the output translation (recall that
+Cyrus canonical form downcases). Any uppercase US-ASCII character
+(``[A .. Z]``) is thus interpreted specially by the ``TRANSLATE``
+virtual machine. Any other octet encountered as an output translation is
+presumed to be part of the UTF-8 output sequence and copied to the
+output.
+
+The names of control codes are actually C pre-processor defines to
+uppercase US-ASCII characters. As the mnenomics are easier to
+understand, I use them in discussing their semantics.
+
+control code reference
+~~~~~~~~~~~~~~~~~~~~~~
+
+``TRANSLATE`` recognizes the following "normal" control codes:
+
+XLT
+    This is the first octet of the four octet sequence, indicating that
+    the desired translation is larger than 3 UTF-8 octets. The next two
+    octets represent an offset to look up in the special
+    chartables\_long\_translations[] table. After that translation is
+    copied to the outbuf, the final octet is interpreted (it must be
+    either a RET or an END).
+JSR
+    The ``TRANSLATE`` virtual machine has a stack, fixed at size 1. A
+    JSR copies address of the current active table to the stack and
+    transitions to the active table given by the next two octets. (For
+    instance, table 1 would be the next table after the table given as a
+    parameter to ``START``.) Translation of the current octet stops
+    after encountering a JSR.
+
+    JSRs are useful for converting a two octet input character: the
+    first octet in the character will make a JSR to some table; the
+    second octet will produce a translation and RET to the current
+    table.
+
+    Since the virtual machine has a fixed size stack, it would be highly
+    unusual for the virtual machine to encounter two different JSRs
+    without an intervening RET.
+
+JMP
+    Similar to JSR, but does not change the stack. It is the equivalent
+    of a goto. JMPs are useful to deal with modal input character sets
+    (such as an escape in ISO-2022-JP, see `how the tables are
+    generated <#mkchartable>`__).
+RET
+    Indicates that we are done translating this input octet and we
+    should return to the previous active table. It might appear as the
+    first of the 4 translation octets, in which case this input
+    character translates into nothing (it might be whitespace, for
+    instance).
+END
+    Indicates we are done translating this input octet. When
+    ``TRANSLATE`` is next called, that input octet will be interpreted
+    against the current active table; the stack does not change.
+
+In addition, it recognizes the following "special" control codes for
+charsets that aren't easily represented by a set of tables, UTF-8 and
+UTF-7:
+
+U7F
+    UTF-7 consists of US-ASCII characters and a special escape character
+    that indicates a transition to base-64 encoded UTF-16 characters.
+    The virtual machine has built in code to handle the base64 decoding.
+    In UTF-7's base64, 8 input octets result in 3 characters, so the
+    tables would be rather large.
+U7N
+    This indicates that the current octet is the continuation of the
+    base-64 section.
+U83
+    One and two character UTF-8 sequences are handled normally in the
+    charset code. To keep the table size down, 3 octet sequences are
+    handled specially. U83 indicates that the current input octet is the
+    start of a three character sequence. It is also an implicit jump to
+    the 2nd table in the UTF-8 sequence, ending this translation.
+U83\_2
+    This input octet 2nd of 3-octet UTF-8 input, with an implicit jump
+    to the 3rd table.
+U83\_3
+    3rd octet of a 3-octet UTF-8 input. This produces the output
+    characters and has an implicit jump to the 1st table of UTF-8.
+
+Finally, it's useful to mention the special character ``EMPTY`` which is
+guaranteed not to match any character. It is also represented by an
+uppercase US-ASCII character.
+
+searching and compiled patterns
+-------------------------------
+
+boyer-moore
+~~~~~~~~~~~
+
+brief description of boyer-moore xxx
+
+cyrus implementation
+~~~~~~~~~~~~~~~~~~~~
+
+why two arrays? us-ascii optimization, really kinda useless now xxx
+
+meta-data stored at the end xxx
+
+generating the tables: ``mkchartable``
+--------------------------------------
+
+The program ``mkchartable`` is used to generate the charset transcoding
+tables used by TRANSLATE. These tables are carefully constructed so no
+more than a single octet need be examined at a time; this octet results
+in either an output stream of UTF-8 characters being generated or some
+sort of state change.
+
+``mkchartable`` uses three different sorts of input files to generate
+these tables. These files are located in the ``lib/charset`` directory.
+
+charset tables
+~~~~~~~~~~~~~~
+
+Each charset file maps a single charset to the corresponding Unicode
+characters. For the US-ASCII and ISO-8859-x character sets this is
+trivial: each input byte corresponds to a single Unicode character.
+(Actually, some ISO-8859-x octets do not map to any Unicode character.
+In that case, the file either does not contain that octet or map it to
+"``????``".)
+
+Other character sets are trickier. For instance, GB-2312 has both single
+and double byte characters, but is still a simple map from input
+character to output character. More complicated are modal character
+encodings. For instance, ISO-2022-JP starts in US-ASCII mode and uses
+``1B`` as an escape character followed by another two characters to
+select a new mode.
+
+The input charset labels modes with "``:``" followed by the mode name.
+The starting mode "``US-ASCII``" in ISO-2022-JP is preceded by
+"``:US-ASCII``". Mode transitions are denoted by a Unicode conversion of
+"``>newmode``" or "``:newmode``". To denote that the octet ``42``
+transitions into the "``US-ASCII``" mode, the charset file has
+"``42 >US-ASCII``". The mode names themselves are arbitrary labels and
+have no effect on the output.
+
+The input charset labels modes with ":" followed by the mode name. The
+mode name is optionally followed by a space and the "``<``" character.
+If the "``<``" character is present, then all translations will be
+followed by a RET instruction instead of an END instruction.
+
+The transition "``>newmode``" results in a JSR instruction being
+generated. A JMP instruction is generated by a transition of
+"``:newmode``".
+
+The input byte can be specified as "``*``". This is used to define the
+"default action" which is used for input bytes that are not otherwise
+defined for the mode. If the default action is not explicitly stated, it
+is a translation to EMPTY.
+
+unicode data table
+~~~~~~~~~~~~~~~~~~
+
+The ``unidata2.txt`` file is verbatim from the Unicode standard. More
+recent versions should be available `from their
+website <http://www.unicode.org/xxx>`__. Each entry in the file
+describers a Unicode character by the following properties, separated by
+semicolons:
+
+-  code point (16-bit character value) in hex
+-  character name (unused by Cyrus)
+-  general category, such as whitespace or punctuation
+-  the canonical combining class (unused)
+-  bidirection category (unused)
+-  character decomposition
+-  decimal digit value (unused)
+-  digit value (unused, and, no, I don't know the difference)
+-  numeric value including fractions (unused)
+-  mirrored character (unused)
+-  Unicode 1.0 name (unused)
+-  comment (unused)
+-  upper case equivalent (unused)
+-  lower case equivalent
+
+In general, Cyrus uses the lower case equivalent if there is one, and
+the decomposed value otherwise.
+
+unicode fixup table
+~~~~~~~~~~~~~~~~~~~
+
+The ``unifix.txt`` file contains Cyrus-specific mappings for characters.
+It overrides the ``unidata2.txt`` table. Each rule in the file is
+explained with a comment. It's helpful to remember that the Unicode
+general categories starting with ``Z`` represent whitespace, and
+whitespace is always removed.
+
+generating ``chartable.c``
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+how ``mkchartable`` works: collapses the encoding modes, the unicode
+translations, and other normalizations into the output tables described
+above xxx
+
+for the future
+--------------
+
+Sieve/ACAP comparators
+~~~~~~~~~~~~~~~~~~~~~~
+
+adjustable normalization?
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The use of uppercase US-ASCII characters is one of the annoyances in
+trying to generalize the charset transcoding. If we continue to restrict
+the characters under consideration to the BMP, switching to UTF-8
+control codes that start 4 or 5 byte sequences is possible.
+
+Another possibility is to use a NUL character as an escape sequence,
+though this increases the size of each control code by 1 octet.
+
+handle >2 octet input characters
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+make UTF-8 more regular
+~~~~~~~~~~~~~~~~~~~~~~~
+
+consider whether we really need U83, U83\_2, U83\_3. also consider
+changing ``{ U83, 0, 0, 0 }`` translations to ``{ U83, JMP, 0, 1 }``
+sequences to at least eliminate the implicit jump.
+
+require minimal UTF-8 characters
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+references
+----------
+
+xxx
+
+-  [UNICODE] Unicode / ISO 10646
+-  [UTF-8] utf-8 RFC
+-  [UTF-7] utf-7 RFC
+-  [BM] boyer-moore
+-  [ACAP] the comparators reference. see section XXX of RFC 2244.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/locking.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/locking.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/locking.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/locking.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,92 @@
+.. _imap-developer-guidance-locking:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Locking
+==========================
+
+Mailboxes
+---------
+
+For mailboxes, we lock in this order:
+
+*   Mailbox Namelock (shared) <== possibly reversible with
+    conversationsdb
+*   user conversations db
+*   cyrus.index
+
+If you want to do any mailboxes.db transactions, they need to open
+and close without changing any mailbox locking during the transaction.
+
+Likewise seen and statuscache are always done without changing mailbox
+locking during their transaction.
+
+Annotations databases are a mess.
+
+Xapian
+------
+
+*   Xapian per-user NAMELOCK (shared or exclusive)
+*   xapianactive file lock (shared or exclusive)
+
+Shared namelock holds the following invariants:
+
+*   xapianactive file contents are not changed
+*   directories mentioned in xapianactive are not cleaned up
+
+Xapianactive exclusive lock holds the following invariants:
+
+*   owner may write to first database mentioned in xapianactive
+
+Xapianactive shared lock holds:
+
+*   all databases in xapianactive are readable and a consistent
+    read can be made across all of them, even with multiple requests
+    while the lock is held.
+
+
+Locking orders
+++++++++++++++
+
+SHARED case:
+
+*   user conversations db <=== possibly reversible with SHARED xapian
+    namelock
+*   SHARED xapian namelock
+*   xapianactive lock (shared to search, exclusive to write)
+*   cyrus.index may be locked either side of the xapianactive lock,
+    because the conversationsdb lock protects it from races.
+
+EXCLUSIVE case:
+
+*   EXCLUSIVE xapian namelock
+    That's it.  While you've got this, you can add or delete items from
+    the xapianactive file, and delete paths on disk for directories
+    that you have removed (either during or after locking).  No other
+    locks are permitted.
+
+
+If you hold a SHARED xapian namelock, you may write to a .NEW folder
+for a xapianactive entry that you created without taking any additional
+locks, because nothing can clean it under you, and nothing else can
+read it.  This is how the repack case works.
+
+Lock lifetime
+-------------
+
+*   Shared mailbox namelock:
+    *   possibly hours
+*   conversations db and below
+    *   short as possible
+
+Mailbox namelock holds the following invariants:
+
+*   cyrus.index may not be repacked, however flags and modseqs may be
+    updated
+*   cyrus.annotations records may change (kind of buggy and bad,
+    ideally we'd always write new ones if we changed them and keep the
+    old ones)
+*   cyrus.cache may be appended, but never changed
+*   spool files may not be deleted (already can't be changed)
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/mailbox-format.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/mailbox-format.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/mailbox-format.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/mailbox-format.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,497 @@
+.. _imap-developer-guidance-mailbox-format:
+
+Cyrus IMAP Server: Mailbox File Formats
+=======================================
+
+Intro
+-----
+
+This documentation refers to the "version 12" cyrus index format and
+associated mailbox files.
+
+No external tools should make use of this information. The only
+supported method of access to the mail store is through the standard
+interfaces: IMAP, POP, NNTP, LMTP, etc.
+
+A cyrus mailbox is a directory in the filesystem. It contains the
+following files:
+
+-  zero or more message files
+-  the ``cyrus.header`` metadata file
+-  the ``cyrus.index`` metadata file
+-  the ``cyrus.cache`` metadata file
+-  zero or one ``cyrus.squat`` search indexes
+-  zero or more subdirectories
+
+With "split metadata" configuration, the mailbox may actually be split
+between multiple disks, with the files being in the same relative
+directory on the meta disk. See the ``imapd.conf`` option
+``metapartition_files`` for more information
+
+Message Files
+-------------
+
+The message files are named by their UID, followed by a ".", so UID 423
+would be named "``423.``". They are stored in wire-format: lines are
+terminated by CRLF and binary data is not allowed.
+
+``cyrus.header``
+----------------
+
+This file contains mailbox-wide information that does not change often.
+Its format:
+
+::
+
+    <Mailbox Header Magic String>
+    <Quota Root>\t<Mailbox Unique ID String>\n
+    <Space-separated list of user flags>\n
+    <Mailbox ACL>\n
+
+The Mailbox Unique ID String is used for non-owner per-user \\Seen flags
+so they remain with the mailbox during renames, and also by the
+replication subsystem to detect mailbox renames.
+
+The ACL is a copy of the value stored in mailboxes.db, and isn't
+actually used.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+The ``cyrus.index`` file must be locked in exclusive mode while making
+changes to the ``cyrus.header`` file to ensure consistency. All changes
+are made by rewriting the entire file and renaming the new version into
+place.
+
+``cyrus.cache``
+---------------
+
+The ``cyrus.cache`` file is a pure cache of information that's also
+present in the message files. It exists to make ENVELOPE and specific
+header fetches more efficient, as well as to assist with searches and
+sorts.
+
+If a ``cyrus.cache`` file is missing or corrupted, it can be
+re-generated by running a ``reconstruct`` on the mailbox.
+
+The format is 10 individual records each prefixed with a 32 bit length
+value in network byte order. The offset of each message's cache record
+is stored in the ``cyrus.index`` file (documented below). The records in
+a cyrus.cache file are of variable length, depending on the contents of
+the associated message.
+
+The first 4 bytes of the cyrus.cache file are a "generation number"
+which must match the first 4 bytes of the associated cyrus.index file.
+In the past this was used to track consistency between the files, but
+the name locking scheme and per-record CRC check in cyrus 2.4 and above
+means this is just a backup consistency check rather than an essential
+format feature.
+
+::
+
+    +------------------------------------------------------------------------+
+    |Gen # (32bits)|Size 1 (32bits)|Data 1                                   |
+    +------------------------------------------------------------------------+
+    |           |Size 2 (32bits)|Data 2            |Size 3 (32bits)| Data 3  |
+    +------------------------------------------------------------------------+
+    | .....                                                                  |
+    +------------------------------------------------------------------------+
+
+While there are occasional changes to the cache format, this information
+is NOT stored in the cyrus.cache file. Instead, there is a
+"cache\_version" field in the cyrus.index record, so multiple different
+versions of cache data may exist in the same cache file.
+
+The order of fields per record in the cache file is as follows: (keep in
+mind that they are all preceded by a 4 byte network byte order size).
+
+Envelope Response
+    Raw IMAP response for a request for the envelope.
+Bodystructure Response
+    Raw IMAP response for a request for the bodystructure.
+Body Response
+    Raw IMAP response for an (old style) request for the body.
+Binary Bodystructure
+    Offsets into the message file to pull out various body parts.
+    Because of the nature of MIME parts, this is somewhat recursive.
+
+    This looks like the following (starting the octet following the
+    cache field size). All of the fields are bit32s.
+
+    ::
+
+          [
+           [Number of message parts+1 for the rfc822 header if present]
+           [
+            [Offset in the message file of the header of this part]
+            [Size (octets) of the header of this part]
+            [Offset in the message file of the content of this part]
+            [Size (octets) of the content of this part]
+            [Encoding Type of this part]
+           ]
+              (repeat for each part as well as once for the headers)
+           [zero *or* number of sub-parts in the case of a multipart.
+            if nonzero, this is a recursion into the top structure]
+              (repeat for each part)
+          ]
+
+    Note if this is not a message/rfc822, than the values for the sizes
+    of the part 0 are -1 (to indicate that it doesn't exist). Sub-parts
+    are not possible for a part 0, so they aren't included when finding
+    recursive entries.
+
+    The offset and size info for both the mime header and content part
+    are useful in order to do fast indexing on the appropriate parts of
+    the message file when a client does a FETCH request for
+    BODY[HEADER], or BODY[2.MIME].
+
+    Note that the top level RFC822 headers are a treated as a separate
+    part from their body text ("0" or "HEADER").
+
+    In the case of a multipart/alternative, the content size & offset
+    refers to the size of the entire mime part.
+
+    A very simple message (with a single text/plain part) would
+    therefore look like:
+
+    ::
+
+          [[2][rfc822 header][text/plain body part info][0]]
+
+    A simple multipart/alternative message might look like:
+
+    ::
+
+          [[3][rfc822 header][text/plain message part info]
+              [second message part info][0][0]]
+
+    A message with an attachment that has two subparts:
+
+    ::
+
+          [[3][rfc822 header info][rfc822 first body part info][attachment info][0][
+                [3][NIL header info][sub part 1 info][sub part 2 info][0][0]]]
+
+    A message with an attached message/rfc822 message with the following
+    total structure:
+
+    ::
+
+            message/rfc822
+              0 headers; content-type: multipart/mixed
+              1 text/plain
+              2 message/rfc822
+                0 headers; content-type: multipart/alternative
+                1 text/plain
+                2 text/html
+
+    ::
+
+          [[3][rfc822 header part 0][text/plain part 1][overall attachment info][0][
+               [3][rfc822 header part 2.0][text/plain part 2.1][text/html part 2.2]
+                  [0][0]]]
+
+Cache Header
+    Any cached header fields. The exact set of fields here depends on
+    the cache record version - there is a function in ``imap/mailbox.c``
+    to determine if a named header would be cached based on the version.
+    These are in the same format they would appear in the message file:
+
+    ::
+
+          HeaderName: headerdata\r\n
+
+    Examples include: References, In-Reply-To, etc.
+
+From
+    The from header.
+To
+    The to header.
+Cc
+    The CC header.
+Bcc
+    The BCC header.
+Subject
+    The Subject header.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+The ``cyrus.index`` file must be locked in exclusive mode while making
+changes to the ``cyrus.cache`` file to ensure consistency. All new cache
+records are created by reading the current end-of-file offset, appending
+the new cache record, and storing that start offset into the associated
+cyrus.index record.
+
+``cyrus.index``
+---------------
+
+The cyrus.index file is NOT just a cache - it stores information not
+present in the message file!
+
+The cyrus.index file consists of a fixed width header, followed by fixed
+width records. In the past, it would be rewritten on every expunge, but
+since Cyrus 2.4 the expunged records remain in the cyrus.index file for
+a configurable time to support QRESYNC and more efficient delayed
+expunge.
+
+The cyrus.index file is the "heart" of the mailbox format - containing
+checksums (CRC32) of everything else, and the most frequently updated
+fields. All fields are stored in network byte order and aligned on 4
+byte boundaries. Due to some 64 bit values being stored, the header and
+individual records are aligned on 8 byte boundaries.
+
+The overall format looks sort of like this:
+
+::
+
+    cyrus.index:
+    +----------------+
+    | Mailbox Header |
+    +----------------+
+    | Msg: Num 1     |
+    +----------------+
+    | Msg: Num 2     |
+    +----------------+
+    |     ...        |
+    +----------------+
+
+The basic idea being that there is one header, and then all the message
+records are evenly spaced throughout the file. All of the message
+records are at well-known offsets, making any part of the file
+accessable at roughly equal speed.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+``cyrus.index`` files can not be repacked (i.e. records can not change
+UID for a particular offset, and the file can't be rewritten or deleted)
+unless there's an exclusive namelock held for the mailbox name. This is
+to avoid race conditions and simplify the use of mailboxes. Whenever a
+mailbox is opened, the caller holds a shared namelock on the mailbox
+name for the duration of the "mailbox object"'s existence.
+
+All reads of a ``cyrus.index`` file must be done with a lock held, and
+all writes must be done with an exclusive lock held. This ensures CRC32
+checksums of individual headers and records are always consistent. There
+are no direct "offset" reads done any more, instead the mailbox API
+provides a way to read an entire cyrus.index header or cyrus.index
+record into a struct, performing consistency checks. Writes are also
+done with a complete record struct.
+
+Detail of ``cyrus.index`` header
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The index header contains the following information, in order:
+
+Generation Number (4 bytes)
+    A number that is basically the "revision number" of the mailbox. It
+    must match between the cache and index files. This is to ensure that
+    if we fail to sync both the cache and index files and a crash
+    happens (so that only one is synced), we do not provide bad data to
+    the user. This is also backed by having individual cache checksums
+    on each record.
+Format (4 bytes)
+    Basically obsolete (indicates netnews or regular).
+Minor Version (4 bytes)
+    Indicates the version number of the index file. This can be used for
+    on-the-fly upgrades of the index and cache files.
+Start Offset (4 bytes)
+    Size of index header.
+Record Size (4 bytes)
+    Size of an index record.
+Num Records (4 bytes)
+    How many records are in this index (including records for expunged
+    records. See below for "Exists" which has moved from pre-version 12
+    files.
+Last Appenddate (4 bytes)
+    (time\_t) of the last time a message was appended
+Last UID (4 bytes)
+    Highest UID of all messages in the mailbox (UIDNEXT - 1).
+Quota Mailbox Used (8 bytes)
+    Total amount of storage used by all of the messages in the mailbox.
+    Platforms that don't support 64-bit integers only use the last 4
+    bytes.
+POP3 Last Login (4 bytes)
+    (time\_t) of the last pop3 login to this INBOX, used to enforce the
+    "poptimeout" ``imapd.conf`` option.
+UIDvalidity (4 bytes)
+    The UID validitiy of this mailbox. Cyrus currently uses the
+    ``time()`` when this mailbox was created.
+Deleted, Answered, and Flagged (4 bytes each)
+    Counts of how many messages have each flag.
+Mailbox Options (4 bytes)
+    Bitmask of mailbox options, consisting of any combination of the
+    following:
+
+    POP3\_NEW\_UIDL
+        Flag signalling that we're using "*uidvalidity*.\ *uid*" instead
+        of just "*uid*" for the output of the POP3 UIDL command.
+    IMAP\_SHAREDSEEN
+        Flag signalling that we're supporting a shared \\Seen flag on
+        the mailbox.
+    IMAP\_DUPDELIVER
+        Flag signalling that we're allowing duplicate delivery of
+        messages to the mailbox, overriding system-wide duplicate
+        suppression.
+    MAILBOX\_NEEDS\_REPACK
+        Flag signalling that the mailbox is due to be repacked. During
+        mailbox\_close() every process will attempt to take an exclusive
+        namelock on the mailbox and repack.
+    MAILBOX\_DELETED
+        Flag signalling that the mailbox is deleted. This can be set
+        with a shared namelock, and indicates to all other users of the
+        mailbox that they need to close it and attempt cleanup. The last
+        process to close the mailbox will perform the final cleanup
+        under an exclusive namelock, giving the other processes a chance
+        to finish their current operation first without files
+        disappearing from under them!
+
+Leaked Cache (4 bytes)
+    Number of leaked records in the cache file.
+Highest ModSeq (8 bytes)
+    Highest Modification Sequence of all the messages in the mailbox
+    (CONDSTORE).
+Deleted ModSeq (8 bytes)
+    Lowest Modification Sequence before which expunged message data may
+    have been purged from the mailbox and forgotten (CONDSTORE/QRESYNC
+    support).
+Exists (4 bytes)
+    See NumRecords above. This is the count of non-expunged records in
+    the mailbox and corresponds to the IMAP status item "EXISTS".
+First Expunged (4 bytes)
+    lowest modified time of an expunged message in this mailbox (or zero
+    if there are no expunged messages) - used to determine if the
+    mailbox needs repacking.
+Last Repack Time (4 bytes)
+    a timestamp for the last repack, to ensure repacks aren't done too
+    close together if expunges were closely spaced
+Header File CRC (4 bytes)
+    CRC32 value of the bytes in the ``cyrus.header`` file for this
+    mailbox. Must be rewritten whenever the cyrus.header file is changed
+    (see locking considerations above - this is why the cyrus.index must
+    be exclusively locked!)
+Sync CRC (4 bytes)
+    An XOR of the CRC32 of a specially generated value for each of the
+    non-expunged records in this mailbox. This is a cached value which
+    allows the replication subsystem to quickly determine that all
+    non-expunged records in a mailbox are in sync and detect possible
+    "split brain" scenarios with low bandwidth use.
+Recent UID (4 bytes)
+    The highest UID last time an IMAP client logged in as the mailbox
+    owner (or anybody if SHAREDSEEN is enabled) selected this mailbox.
+    Used to generate the \\Recent flags in IMAP
+Recent Time (4 bytes)
+    Used for consistency with the seen\_db code, but probably not
+    actually necessary. Oh well
+Header CRC (4 bytes)
+    Must always be the LAST record of the header. This is the CRC32 of
+    the actual bytes on disk (network order format) for the rest of the
+    cyrus.index. By keeping it last, it can be easily calculated with
+    the following snippet of code:
+    ``crc = crc32_map(buf, OFFSET_HEADER_CRC);`` - i.e. crc32 from the
+    start of the buffer to just before this field.
+
+There are also spare fields in the index header, to allow for future
+expansion without forcing an upgrade of the file, and to round up to be
+divisible by 8 bytes.
+
+Detail of ``cyrus.index`` records
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+These records start immediately following the ``cyrus.index`` header,
+and are all fixed size. They are in-order by uid of the message.
+
+UID (4 bytes)
+    UID of the message
+INTERNALDATE (4 bytes)
+    INTERNALDATE of the message (where possible, this matches the
+    creation and modification times of the file on disk to help
+    reconstruct in the event of data loss)
+SENTDATE (4 bytes)
+    Contents of the Date: header chomped to day resolution with timezone
+    stripped.
+SIZE (4 bytes)
+    Size of the whole message (in octets)
+HEADER SIZE (4 bytes)
+    Size of the message header (in octets)
+GMTIME (4 bytes)
+    Contents of the Date: header at 1 second resolution and converted to
+    GMT (for sort)
+CACHE\_OFFSET (4 bytes)
+    Offset into the ``cyrus.cache`` file for the beginning of this
+    message's cache entry.
+LAST UPDATED (4 bytes)
+    (time\_t) of the last time this record was changed
+SYSTEM FLAGS (4 bytes)
+    Bitmask showing which system flags are set/unset
+USER FLAGS (MAX\_USER\_FLAGS / 32 bytes)
+    Bitmask showing which user flags are set/unset (bits correspond to
+    positions in the cyrus.header flag list, i.e. (1<<0) == the flag
+    name
+CONTENT\_LINES (4 bytes)
+    Number of text lines contained in the message content (body).
+CACHE\_VERSION (4 bytes)
+    Indicates the version number of the cache record for the message
+    (determines which headers are cached, see list in mailbox.c).
+GUID (MESSAGE\_GUID\_SIZE bytes)
+    Globally Unique IDentifier of the message (used by replication
+    engine). This is the sha1 value of the bytes as stored on disk.
+MODSEQ (8 bytes)
+    Modification Sequence of the message (CONDSTORE).
+CACHE\_CRC (4 bytes)
+    This is the CRC32 of all the bytes of the cache record (all 10
+    fields) as stored on disk. Again, calculated over the exact bytes
+    stored in the ``cyrus.cache`` file.
+RECORD\_CRC (4 bytes)
+    Like the header CRC - this is the CRC32 of all the bytes in on-disk
+    order that exist in this record. Records are always rewritten as the
+    entire record, including the updated CRC, so it's always consistent
+    if you have a lock on the ``cyrus.index`` file, because writers will
+    wait until they get an exclusive lock to make modifications.
+
+Notes
+-----
+
+-  Expunge is super quick now - it's just a flag update!
+-  Append is relatively fast (it only adds to the end of both the cache
+   and index files and modifies the index header)
+-  Message unlinks always happen during the "close" phase - which may be
+   noticed when you select another mailbox, but otherwise are delayed
+   from the actual action. With delayed expunge, the unlinks are pushed
+   off to cyr\_expire which is a background task, and will never be
+   noticed by the user.
+-  Message delivery is something like this:
+
+   #. write/sync message file
+   #. write/sync new ``cyrus.cache`` record
+   #. write/sync new ``cyrus.index`` record
+   #. calculate, write, sync new ``cyrus.index`` header
+   #. acknowledge message delivery
+
+   The message isn't delivered until the new index header is written. In
+   case of a crash before the new index header is written, any previous
+   writes will be overwritten on the next delivery (and will not be
+   noticed by the readers).
+
+   Note that certain power failure situations (power failure in the
+   middle of a disk sector write) could cause a mailbox to need
+   reconstruction (possibly even losing some flag state). These failure
+   modes are not possible in the "Hardware RAID disk model" (which we
+   will describe somewhere else when we get around to it).
+
+Future considerations
+---------------------
+
+-  Cache all header fields? (or all up to Xk?) This could greatly
+   improve speeds of clients that just ask for everything, but also
+   increases the expense of rewriting the cache file (as well as the
+   size it takes on disk).
+-  Reformat cache file to use a
+   (size)(size)(size)(size)(data)(data)(data) format. This makes
+   accesses anywhere in the cache file equally fast, as opposed to
+   having to iterate through all the entires for a given message to get
+   to the last one. Note that either way is still O(1) so maybe it
+   doesn't matter much.
+-  It would be useful to store a uniqueid -> mailbox name index, so that
+   we could fix arbitron again.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/namelocks.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/namelocks.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/namelocks.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/namelocks.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,102 @@
+.. _imap-developer-guidance-namelocks:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Namelocks
+============================
+
+Intro
+-----
+
+Name locks are an addition to the cyrus internals to address a range of
+race conditions and complexities. These ills are most easily avoided by
+ensuring that only one process can do certain operations at once. Name
+locks also mean crashes can't leave the mailbox "broken" forever.
+
+Unfortunately, locks can't be retained over a rewrite-rename cycle, and
+every meta file in a regular mailbox gets rewritten upon occasion. Even
+cyrus.header gets a rewrite when a new userflag is added.
+
+The "RESERVED FLAG" method of handling mailbox creation is a nasty
+brutish method that breaks on process crashes, causing a full
+mailboxes.db sweep to be necessary on restart, and making that name
+unusable until the entire server is restarted. It's also unusable for
+serialisation of operations without making the mailbox "disappear" to
+other clients.
+
+Mailbox names are supposed to be exclusive per server, not just per
+partition, so any lock has to apply to the entire server.
+
+**MURDER Considerations:** Due to the way the mupdate protocol works,
+RESERVED records are still created over mupdate. This sucks, and a
+better way would be to support an "EXCLUSIVE CREATE" command, where the
+create only succeeds if the record doesn't already exist. Then a task
+could create the mailbox on the local server and retain an exclusive
+namelock while trying to assert the name on the mupdate server. If this
+failed (someone else got in first) then the mailbox could be cleaned up
+locally before releasing the exclusive namelock, meaning other users on
+the local server would never see it existing.
+
+Implementation
+--------------
+
+It's a simple matter of having a file under $configdirectory/lock - in a
+directory tree using the same hashing structure as the mailbox tree.
+This directory can be symlinked or mounted to a tmpfs since the locks
+need not persist across restarts. Due to race conditions while cleaning
+up, the easiest approach is to only ever delete lock files during
+restart, so the unlock code doesn't try to remove them. Lock files are
+zero byte in size, and are locked using the flock or fcntl primitives
+used by the rest of cyrus.
+
+API
+---
+
+Lock types:
+
+-  LOCK\_SHARED - shared lock on the name. Required whenever you have an
+   open mailbox with that name
+-  LOCK\_EXCLUSIVE - exclusive lock on the name. Required to create or
+   finish deleting a mailbox, and required when repacking the
+   cyrus.index and cyrus.cache files.
+-  LOCK\_NONBLOCKING - attempt to take an exclusive lock on the name,
+   but if it's not available, return immediately with r ==
+   IMAP\_MAILBOX\_LOCKED rather than blocking until the lock is
+   available.
+
+The ``mboxname`` is always an **internal name**, so convert it first.
+
+Example:
+~~~~~~~~
+
+::
+
+    struct mboxlock *lock = NULL;
+    int locktype = LOCK_SHARED; /* or LOCK_EXCLUSIVE or LOCK_NONBLOCKING */
+
+    r = mboxname_lock("user.brong", &lock, locktype);
+    if (!r) {
+        do_stuff();
+        mboxname_release(&lock);
+    }
+
+If mboxname\_lock fails, lock will remain NULL. It should always be
+initialised to NULL before being passed to mailbox\_lock. It will be set
+back to NULL by mboxname\_release.
+
+Re-locking considerations
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+It is not possible to hold multiple locks to the same name within the
+same process. If you call mboxname\_lock with the same name within a
+process, and the **same locktype** then a reference counter is
+incremented and the same lock is returned. If you use a **different
+locktype** (i.e. one shared, the other exclusive. Non-blocking is
+considered exclusive for this test) then IMAP\_MAILBOX\_LOCKED will be
+returned to avoid breaking the locking semantics. This is a restriction
+of the underlying fcntl/flock subsystem.
+
+On the way out, the reference counter is decremented with each release
+and the lock isn't freed until the counter gets back to zero.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/prot.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/prot.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/prot.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/prot.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,82 @@
+.. _imap-developer-guidance-prot-layer:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: prot layer
+=============================
+
+The prot layer, defined in ``prot.h``, is a stdio replacement for
+network i/o. It does the standard buffering of input and output and
+allows certain operations especially suited for request/response
+protocols like IMAP.
+
+Events
+------
+
+The prot layer allows "events" to be associated with each prot stream.
+These events are trigger at the given time or after when the protstream
+is attempted to be read from.
+
+An event is currently represented by the following datastructure:
+
+::
+
+    struct prot_waitevent;
+
+    typedef struct prot_waitevent *prot_waiteventcallback_t(struct protstream *s,
+                                struct prot_waitevent *ev,
+                                void *rock);
+
+    struct prot_waitevent {
+        time_t mark;
+        prot_waiteventcallback_t *proc;
+        void *rock;
+        struct prot_waitevent *next;
+    };
+
+The application is currently allowed to modify *mark*, *proc*, and
+*rock* as desired when there are no active calls to a prot function on
+the stream which this event is associated.
+
+The API is as follows:
+
+-  Use ``prot_addwaitevent()`` to add an event callback onto the stream:
+
+   ::
+
+       extern struct prot_waitevent *prot_addwaitevent(struct protstream *s,
+                               time_t mark,
+                               prot_waiteventcallback_t *proc,
+                               void *rock);
+
+   where *s* is the stream to add the event to, *mark* is the time to
+   trigger the event, *proc* is the callback to make, and *rock* is an
+   opaque data item handed to the callback. It returns a pointer to the
+   event structure; this is the pointer that must be used to remove the
+   event or modify it in some way.
+
+-  Use ``prot_removewaitevent()`` to remove an event:
+
+   ::
+
+       extern void prot_removewaitevent(struct protstream *s,
+                        struct prot_waitevent *event);
+
+   It requires *event* to have been returned from
+   ``prot_addwaitevent()`` previously. No further references are allowed
+   to *event* or its fields. *event->rock* is not free'd nor examined in
+   any way. This function may be called while inside the callback
+   *event->proc()*. If an event is removed inside of its callback, that
+   callback must return ``NULL``.
+
+Some common things to do with events:
+
+-  To reschedule an event *ev*, simply set *ev->mark* to the next time
+   it should trigger. If currently in *ev->proc()*, it should return
+   *ev*.
+
+--------------
+
+last modified: $Date: 2003/08/06 21:28:05 $
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/replication_examples.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/replication_examples.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/replication_examples.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/replication_examples.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,164 @@
+.. _imap-developer-guidance-replication-examples:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Replication Examples
+=======================================
+
+Introduction
+------------
+
+The replication system creates a link between two Cyrus mailstores: a
+master and a replica system. Both systems can be live mailstores with
+active users: here in Cambridge we install systems in pairs.
+
+Typically half of the users will be using each system, and each system
+replicates to its partner. In the event of a failover everyone uses the
+remaining system in a pair. This is typically safe as the IMAP/POP/SMTP
+servers define which of the two systems is the live server for any given
+account, and the replica just plays a game of follow my leader.
+
+Occasionally I think about introducing some form of sanity check so that
+we have to explicitly issue a command to the remaining backend system as
+well as the proxies in the event of a failover.
+
+A short example of replication in action
+----------------------------------------
+
+::
+
+    Index:
+
+      #: Annotation
+      C: Command issued by client
+      S: Command issued by server
+
+    # Authentication between systems is done using SSH key based authentication:
+
+    C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+    S: * Sync Server v0.0 [EXPERIMENTAL]
+
+    # Create new auth_state and ask for all information about given list of
+    # folders (namely user.dpc22). Returns:
+    #
+    #   "**" unsolicited response for each mailbox. Returns:
+    #      Folder UniqueID, Name, ACL, UIDlast, timestamp for last seen update.
+    #
+    #   "*" response for each mail message in folder:
+    #      UID, GUID, flags (other than \Seen state)
+
+    C: user_some dpc22 user.dpc22
+    S: ** 6b98205c796c6c61 user.dpc22 \
+    S:     "dpc22   lrswipcda       anonymous       0      " 4151 1062945305
+    S: * 1 000000000000000000000000 ()
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 ()
+    S: OK User_Some finished
+
+    # Select a folder to work with
+
+    C: select user.dpc22
+    S: OK 6b98205c796c6c61 4151 1062945305
+
+    # Remove message with UID "1" from folder list (message which has been
+    # sitting in my inbox since January, has no GUID defined)
+
+    C: expunge 1
+    S: OK Expunge Complete
+
+    # Set some user flags on message UID "4140"
+
+    C: setflags 4140 (hello world)
+    S: OK Updated flags on 1 messages okay
+
+    # Demonstrate that something has changed:
+
+    C: status
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 (hello world)
+    S: OK 4151
+
+    # Now lets correct the damage that we just inflicted:
+
+    C: $ replicate -s cyrus-2 -v -v -m user.dpc22
+    S: MAILBOXES user.dpc22
+    S: USER_SOME dpc22 user.dpc22
+    S: SELECT user.dpc22
+    S: SETFLAGS [1 msgs]
+    S: UPLOAD [1 msgs]
+    S: SETSEEN dpc22 ...
+    S: ENDUSER
+
+    C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+    S: * Sync Server v0.0 [EXPERIMENTAL]
+    S: user_some dpc22 user.dpc22
+    S: ** 6b98205c796c6c61 user.dpc22 \
+    S:    "dpc22   lrswipcda       anonymous       0      " 4156 1062968731
+    S: * 1 000000000000000000000000 ()
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 ()
+    S: OK User_Some finished
+
+    # Back where we started: the replication engine reinserted message UID 0
+    # which was missing, and removed "hello world" from message UID 4140
+
+Tracking messages between folders
+---------------------------------
+
+::
+
+    # I've just saved a message from my inbox into a folder named "zzz",
+    # creating the folder the process.
+
+    C: $ replicate -s cyrus-2 -v -v -m user.dpc22 user.dpc22.zzz
+
+    Replication action on two MAILBOX objects:
+
+    S: MAILBOXES user.dpc22 user.dpc22.zzz
+
+    Ask server for contents of the two folders:
+
+    S:   USER_SOME dpc22 ...
+
+    Reserve message with given GUID in user.dpc22 so that it can be moved
+
+    S:   RESERVE user.dpc22 ...
+
+    Remove message from source folder (reserved copy left behind)
+
+    S:   SELECT user.dpc22
+    S:   EXPUNGE [1 msgs]
+    S:   SETSEEN dpc22 ...
+
+    Create target folder and copy in message that we reserved (doesn't have to
+    be uploaded again)
+
+    S:   CREATE user.dpc22.zzz 7f6f384c3f5ba99a
+    S:      "dpc22        lrswipcda       anonymous       0       " 0 1062971802
+    S: SELECT user.dpc22.zzz
+    S: UPLOAD [1 msgs]
+    S: SETSEEN dpc22 ...
+    S: ENDUSER
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/replication_protocol.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/replication_protocol.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/replication_protocol.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/replication_protocol.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,83 @@
+.. _imap-developer-guidance-replication-protocol:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Replication Protocol v2.4+
+=============================================
+
+DList 1.0
+---------
+
+The DList protocol is based closely on the IMAP wire protocol, using
+atoms and literals as the basis, but with two extended types of data:
+
+-  kvlist
+-  rfc822-object
+
+A wart of the protocol is the rfc822-object, which contains an explicit
+cyrus backend partition. This will be removed in future versions of
+Cyrus.
+
+types
+~~~~~
+
+atom
+^^^^
+
+An atom is actually a sequence of any character other than '\\0', the
+NULL byte. Character encoding is not specified, but it can contain 8 bit
+characters, and is probably utf8
+
+flag
+^^^^
+
+Flag is a horrible special case of atom to allow \\word to be
+represented as an IMAP atom on the wire. This is one of many special
+cases in the IMAP protocol, and is duplicated into dlist just to make it
+easier to read
+
+num32/num
+^^^^^^^^^
+
+Both stored as 64 bit integers internally, and sent as decimal numbers
+over the wire, this type exists only in the API, it just looks like a
+string on the wire.
+
+hex32/hex
+^^^^^^^^^
+
+Stored like num internally, but sent as an 8 or 16 character hexadecimal
+string on the wire
+
+map
+^^^
+
+Like atom, but can contain NULL. All values are parsed off the wire as
+'map' type and then converted on demand into the requested type
+
+list
+^^^^
+
+Encoded in parentheses like so (item item item) a list type can be
+nested inside other lists: (item (sub sub) item)
+
+kvlist
+^^^^^^
+
+A kvlist allows named parameters, and is indicated with a leading %
+character. % is invalid in atoms, so parsing is unambiguous, e.g:
+
+%(key1 value1 key2 (list of values) key3 value3)
+
+rfc822-object/file
+^^^^^^^^^^^^^^^^^^
+
+Finally the ugly one. These look like a literal, but with a leading %
+and two more fields:
+
+::
+
+    %{partition sha1 size}\r\n
+    data
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/special_chars.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/special_chars.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/special_chars.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/special_chars.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,53 @@
+.. _imap-developer-guidance-special-chars:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Special Characters
+=====================================
+
+This document is supposed to be a repository of "special characters"
+used in Cyrus naming of users, folders, directory paths, etc.
+
+Current Uses
+------------
+
+|
+| Character: +
+
+-  (LMTP) Separation of postuser and target mailbox for delivery
+-  (LMTP) Separation of username and submailbox for delivery
+-  (IMAP) Flag at end of login name that indicates that LIST should
+   return LSUB results (when imapmagicplus is set)
+-  (POP3) POP a subfolder directly (e.g. rjs3+foo POPs user.rjs3.foo)
+
+|
+| Character: . /
+
+-  [mailbox names] Hierarchy separators
+
+|
+| Character: ^
+
+-  [mailbox names] In unixhierarchysep, ^ is the part of the internal
+   name that represents a '.'
+
+|
+| Characters: @ %
+
+-  [usernames] These are realm separators for the purposes of
+   authentication
+
+|
+
+Future Uses
+-----------
+
+| Character: +
+
+-  IMAP LIST filters (e.g. rjs3+foo will only list folders that match
+   foo\*)
+-  possibly other interpretations here:
+   - rjs3+foo will do an effective chroot(foo.)
+   - rjs3+foo will only list folders in user.rjs3.foo\*
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance/var_directory_structure.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance/var_directory_structure.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance/var_directory_structure.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance/var_directory_structure.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,73 @@
+.. _imap-developer-guidance-var_directory_structure:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: var directory structure
+==========================================
+
+Directory structure under /var/spool/imap
+-----------------------------------------
+
+::
+
+    stage./
+      Normal staging directory
+
+    sync./
+      Staging directory for replication system
+      Includes
+        sync./locks/*
+
+      which are lock files for each user on the system to prevent two
+      replication runs from trying to update the same account at the same time
+      (nothing disastrous should happen even without this lock, but the second
+      job in will get a bit confused if the target end changes under its feet,
+      and will probably drop back to a recovery mode.
+
+    user/
+      Familiar user.userid space.
+
+Directory structure under /var/imap
+-----------------------------------
+
+Complete list::
+
+      drwxr-xr-x    2 cyrus    cyrus         232 Sep  7 08:21 db
+      drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:51 db.backup1
+      drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:21 db.backup2
+      -rw-r-----    1 cyrus    cyrus    20799488 Sep  7 19:51 deliver.db
+      drwxr-xr-x    2 cyrus    cyrus          48 Sep  7 10:16 log
+      -rw-r-----    1 cyrus    cyrus     1995000 Sep  7 19:38 mailboxes.db
+      -rw-r--r--    1 cyrus    cyrus          10 Jun  2 10:08 master_machine
+      -rw-r--r--    1 cyrus    cyrus          71 Sep  7 08:21 master_uuid
+      drwxr-xr-x    2 cyrus    cyrus          48 Jun  2 10:08 msg
+      drwxr-xr-x    2 cyrus    cyrus        1872 Sep  7 19:55 proc
+      drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 quota
+      drwxr-xr-x    2 cyrus    cyrus         224 Sep  7 08:21 socket
+      drwxr-xr-x    2 cyrus    cyrus          72 Sep  7 10:19 sync
+      drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 user
+
+Most of that will be familiar. New entries are::
+
+    master_machine
+      Defines machine number in replication cluster. Used as sanity check
+      against master_uuid file. Sample content:
+
+        machine=1
+
+    master_uuid
+      Full information about UUID schema in use. See ./uuid for details.
+      Sample content:
+
+         schema=1
+         machine=1
+         timestamp_generation=0
+         master_start_time=1062919294
+
+    sync/current
+      Transaction log from IMAP, POP and LMTP daemons, typically feed into
+      sync_client running as asynchronous replication engine.
+
+      Rotated to be sync/current-<pid> by asynchronous runner.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/guidance.txt 3.2.0-3/doc/html/_sources/imap/developer/guidance.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/guidance.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/guidance.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-developer-guidance:
+
+.. author: Nic Bernstein (Onlight)
+
+==================
+Developer Guidance
+==================
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    guidance/*
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/install-xapian.txt 3.2.0-3/doc/html/_sources/imap/developer/install-xapian.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/install-xapian.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/install-xapian.txt	2020-04-24 02:03:00.000000000 +0000
@@ -69,10 +69,10 @@ You also need (at least one) search tier
     search_engine: xapian
     search_index_headers: no
     search_batchsize: 8192
-    defaultpartition: default
+    defaultpartition: base
     defaultsearchtier: t1
-    partition-default: /var/cyrus/spool
-    t1searchpartition-default: /var/cyrus/search
+    partition-base: /var/cyrus/spool
+    t1searchpartition-base: /var/cyrus/search
 
 If you want to do more complex search tiers and repacking, you'll want to read:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/jmap.txt 3.2.0-3/doc/html/_sources/imap/developer/jmap.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/jmap.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/jmap.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,144 @@
+.. _developer-jmap:
+
+============
+JMAP support
+============
+
+`JMAP <http://jmap.io/>`_ is an alternate mechanism for synchronising a mail client with a mail server, intended as a replacement for IMAP. It is a transport-agnostic, stateless JSON-based API, aiming to be compatible with the IMAP data model, but with reduced data usage and more efficient synchronisation.
+
+Cyrus administration
+====================
+
+Compile JMAP support into Cyrus
+-------------------------------
+
+1. Enable JMAP (and DAV) in Cyrus:
+
+    * ``./configure --enable-http --enable-jmap --enable-xapian`` along with your other configuration options.
+
+2. Enable :ref:`conversation support <imap-concepts-deployment-db-conversations>`
+
+    * In :cyrusman:`imapd.conf(5)`, set ``conversations: 1``, ``conversations_db: twoskip``
+    * Create a conversations.db for each user: ``ctl_conversationsdb -b -r``
+
+3. JMAP depends on Xapian. For full support (to gain full word boundary
+distinctions in CJK languages - Chinese, Japanese and Korean), this needs to be
+manually compiled due to extra patches needing to be applied.
+Our :ref:`Xapian install guide <imapinstall-xapian>` shows how.
+
+4. Once installed, the ``jmap`` module must be enabled in
+:cyrusman:`imapd.conf(5)`: ``httpmodules: jmap``
+
+JMAP client
+===========
+
+Test JMAP support
+-----------------
+
+Once Cyrus is running, you can test JMAP on the command line for any existing Cyrus user. The user must at least have an INBOX provisioned but is not required to have any calendars, contacts or messages.
+
+To obtain the JMAP mailbox folders for user ``test``, issue the following request:
+
+.. code-block:: bash
+
+    curl -X POST \
+         -H "Content-Type: application/json" \
+         -H "Accept: application/json" \
+         --user test:test \
+         -d '{
+           "using": [ "urn:ietf:params:jmap:core", "urn:ietf:params:jmap:mail" ],
+           "methodCalls": [[ "Mailbox/get", {}, "c1" ]]
+         }' \
+         http://localhost/jmap/
+
+you should get a response which looks similar to
+
+.. code-block:: none
+
+    {
+      "methodResponses": [
+        ["Mailbox/get", {
+          "state": "0",
+          "list": [{
+            "id": "7c76ec2b-9bd8-4091-a665-640e232e3877",
+            "name": "Inbox",
+            "parentId": null,
+            "myRights": {
+              "mayReadItems": true,
+              "mayAddItems": true,
+              "mayRemoveItems": true,
+              "mayCreateChild": true,
+              "mayDelete": false,
+              "maySubmit": true,
+              "maySetSeen": true,
+              "maySetKeywords": true,
+              "mayAdmin": true,
+              "mayRename": false
+            },
+            "role": "inbox",
+            "totalEmails": 0,
+            "unreadEmails": 0,
+            "totalThreads": 0,
+            "unreadThreads": 0,
+            "sortOrder": 1,
+            "isSubscribed": false
+          }, {
+            "id": "5d9e4f44-7df9-4489-b8b3-32625b552aa1",
+            "name": "Trash",
+            "parentId": null,
+            "myRights": {
+              "mayReadItems": true,
+              "mayAddItems": true,
+              "mayRemoveItems": true,
+              "mayCreateChild": true,
+              "mayDelete": true,
+              "maySubmit": true,
+              "maySetSeen": true,
+              "maySetKeywords": true,
+              "mayAdmin": true,
+              "mayRename": true
+            },
+            "role": null,
+            "totalEmails": 0,
+            "unreadEmails": 0,
+            "totalThreads": 0,
+            "unreadThreads": 0,
+            "sortOrder": 10,
+            "isSubscribed": true
+          }],
+          "notFound": [],
+          "accountId": "test"
+        }, "c1"]
+      ],
+      "sessionState": "0"
+    }
+
+Similar requests exist to obtain contacts and calendars. For details, see the
+JMAP specification.
+
+Optional: Install sample JMAP client
+------------------------------------
+
+.. note::
+
+    Cyrus does not yet implement JMAP authentication. Instead, it requires for
+    each request the HTTP Basic Auth header set with the account's username and
+    password. If you intend to use the JMAP perl or web clients, make sure to add
+    the required authentication headers for each request.
+
+You can set up the `JMAP Proxy (perl) <https://github.com/jmapio/jmap-perl>`_ to sit in front of a standard IMAP server and query that over a custom JMAP client.
+
+Or you can install a sample `JMAP web client <https://github.com/jmapio/jmap-demo-webmail>`_ which requires the `Overture.js library <https://github.com/fastmail/overture>`_ and `JMAP JS library <https://github.com/jmapio/jmap-js>`_ to talk to a JMAP-enabled Cyrus server and build from there (subject to the `MIT license <https://tldrlegal.com/license/mit-license>`_).
+
+The web client is a simple example (no compose, contacts or calendars). When you create your account, the most recent 50 emails will be downloaded in their entirety, so the first page should be snappy immediately. After that, you are redirected to the landing page. A background task will continue to pull in batches of messages and add them to your account, so you will see older messages appear while you are using the interface.
+
+Developing the client further
+-----------------------------
+
+You'll want to become deeply familiar with the `JMAP developer documentation <http://jmap.io/#i-want-to-get-involved-with-jmap.-what-do-i-need-to-know?>`_
+
+
+.. note::
+
+    JMAP implementation in Cyrus is a work in progress. Current status can be
+    viewed on the main :ref:`JMAP configuration page <jmap-implementation>`.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/process.txt 3.2.0-3/doc/html/_sources/imap/developer/process.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/process.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/process.txt	2020-04-24 02:03:00.000000000 +0000
@@ -55,7 +55,7 @@ If you're not planning on regularly subm
 Useful Developer Information
 ============================
 
-Some combined :ref:`tips on developing with Cyrus <cyrus-hacking>` have been collected.
+Some combined :ref:`tips on developing with Cyrus <imap-developer-guidance>` have been collected.
 
 Community Participation
 =======================
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/releasing.txt 3.2.0-3/doc/html/_sources/imap/developer/releasing.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/releasing.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/releasing.txt	2020-04-08 00:07:13.000000000 +0000
@@ -25,14 +25,27 @@ manual like she did. :)
 Once you have a GPG key, it's helpful to upload your public key to
 `the MIT key-server <http://pgp.mit.edu>`_
 
-You also need a shell account on www.cyrusimap.org and ftp.cyrusimap.org,
-with SSH key authentication.  You need to be in the "admin" group on each,
-and also the "cyrupload" group on the latter.
-
 And you need permission to send to the cyrus-announce mailing list.
 
 .. endblob releaseprereqs
 
+Order of operations
+===================
+
+Sometimes you're releasing several new versions all at once(ish), for example
+maybe there's been a security fix that affected 2.4, 2.5 and 3.0.
+
+Github's release page will put a "Latest Release" graphic on the release with
+the newest tag (by timestamp, I think).  This means that, if you're doing new
+releases for several different versions, you want to do the oldest one first,
+and only do the release for the current-stable branch last.
+
+If you start at the current stable branch and then work your way backwards
+through the older ones, you'll get Github saying "2.5.15 is the Latest
+Release" even though 3.0.13 was also just released... so, even though
+releasing the current-stable fix feels more urgent, suck it up and get the
+older-branch ones out first.
+
 
 Release notes
 =============
@@ -59,7 +72,7 @@ Pre-release testing
    need any other options at this stage).
 4. Run ``make distcheck``.  This will generate a distribution tarball, and
    test it in various ways.  It takes about 10-15 mins to run, depending on
-   your hardware.  If this command fails, you are not ready to release --
+   your hardware.  If this command fails*, you are not ready to release --
    fix the problems, get them tested and committed, then restart the
    pre-release testing.
 5. ``make distcheck`` can only test so much (it doesn't know about cunit or
@@ -78,6 +91,21 @@ Pre-release testing
    ix.   If any of this fails, fix it, commit it, then restart the pre-release
          testing.
 
+.. Note::
+    ``make distcheck`` doesn't work on the 2.5 branch.  For 2.5, just use
+    ``make dist`` instead.
+
+.. Note::
+    Realistically, there's usually some set of expected Cassandane failures
+    from each Cyrus branch, especially for 2.5.  If you're doing releases
+    regularly, you've probably got a good gut feel for which failures are a
+    problem and which ones are just "that old thing".  If you don't do
+    releases regularly, try to pull in someone who does for guidance about
+    which failures are ignorable, and which should be a source of stress.
+
+    If in doubt, try building and testing the previous release from the same
+    series, and compare the test results.
+
 
 Linking up release notes
 ========================
@@ -98,9 +126,9 @@ website updating before the downloads ar
 Version tagging
 ===============
 
-Note: it is absolutely critical that your local commits have been pushed
-upstream at this point.  If they are not, and if anybody else pushes in the
-meantime, you will end up with a mess.
+Note: it is absolutely critical that your repository is clean and your local
+commits have been pushed upstream at this point.  If they are not, and if
+anybody else pushes in the meantime, you will end up with a mess.
 
 1. Ensure your repository is clean again: ``git clean -xfd``
 2. Create a signed, annotated tag for the new version: ``git tag -s cyrus-imapd-<version>``
@@ -126,15 +154,60 @@ meantime, you will end up with a mess.
 11. Push the tag upstream: ``git push ci cyrus-imapd-<version>`` (assuming your
     remote is named "ci").
 
-Releasing
+
+Inter-version website consistency
+=================================
+
+The website is built from an amalgamation of documentation from:
+
+* The current stable cyrus-imapd branch (top level)
+* The current master cyrus-imapd branch (``/dev`` hierarchy)
+* Each of the following cyrus-imapd branches (``/x.y`` hierarchies)
+
+    - cyrus-imapd-2.5
+    - cyrus-imapd-3.0
+    - cyrus-imapd-3.2
+
+* The current master cyrus-sasl branch (``/sasl`` hierarchy)
+
+When making a cyrus-imapd release, you need to add the new release notes
+file to each relevant cyrus-imapd branch.  You also need to check and
+update the contents of ``docsrc/conf.py`` on each branch AND the cyrus-sasl
+repository.
+
+Sometimes you can just cherry-pick the commits around, but note that the
+2.5 website stores release notes files in a different path, so if you
+bother to copy release notes back to this branch, a naive cherry-pick will
+not put them in the right place!
+
+This step often gets forgotten, so if you actually follow it, and notice
+some missing versions, just go ahead and add them while you're there.
+
+Uploading
 =========
 
-1. Upload the tarball and signature to www: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/``
-2. Upload them to ftp too: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/``
-3. SSH into both www and ftp, and move older releases to the old versions
-   directory.  You want only the two most recent tarball+sig pairs for each
-   major series.
-4. Update the topic in the #cyrus IRC channel.
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+.. Note::
+    This section does NOT apply to releases from the master branch.  We
+    do not publish release tarballs for those.  People running master code
+    are expected to use a git checkout.
+
+Time to upload the release tarball and signature file!
+
+1. Navigate to https://github.com/cyrusimap/cyrus-imapd/releases
+2. The tag you pushed earlier will now be available as a release, but it will
+   have very little information about it
+3. Click on the tag name
+4. Click "Edit tag" on the right
+5. *Leave every field on the page as it is (probably blank!), except*:
+6. Use the "Attach binaries by dropping them here or selecting them" widget
+   to upload the tarball and signature files
+7. If this is an alpha/beta/rc release, click the "This is a pre-release"
+   checkbox
+8. Click "Save".  The commit message from the tag annotation will be used
+   as the release description.
+
+Tell the world
+==============
+
+1. Update the topic in the #cyrus IRC channel.
+2. Send an announcement to the info-cyrus and cyrus-announce lists.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/backup.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/backup.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/backup.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/backup.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,925 @@
+.. _imap-developer-thoughts-backup:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Notes for backup implementation
+===============================
+
+Backup index database (one per user):
+
+chunk::
+
+    int id
+    timestamp ts
+    int offset
+    int length
+    text file_sha1              -> sha1 of (compressed) data prior to this chunk
+    text data_sha1              -> sha1 of (uncompressed) data contained in this chunk
+
+mailbox::
+
+    int id
+    int last_chunk_id           -> chunk that knows the current state
+    char uniqueid               -> unique
+    char mboxname               -> altered by a rename
+    char mboxtype
+    int last_uid
+    int highestmodseq
+    int recentuid
+    timestamp recenttime
+    timestamp last_appenddate
+    timestamp pop3_last_login
+    timestamp pop3_show_after
+    timestamp uidvalidity
+    char partition
+    char acl
+    char options
+    int sync_crc
+    int sync_crc_annot
+    char quotaroot
+    int xconvmodseq
+    char annotations
+    timestamp deleted           -> time that it was unmailbox'd, or NULL if still alive
+
+message::
+
+    int id
+    char guid
+    char partition              -> this is used to set the spool directory for the temp file - we might not need it
+    int chunk_id
+    int offset                  -> offset within chunk of dlist containing this message
+    int size                    -> size of this message (n.b. not length of dlist)
+
+mailbox_message::
+
+    int mailbox_id
+    int message_id
+    int last_chunk_id           -> chunk that has a RECORD in a MAILBOX for this
+    int uid
+    int modseq
+    timestamp last_updated
+    char flags
+    timestamp internaldate
+    int size
+    char annotations
+    timestamp expunged          -> time that it was expunged, or NULL if still alive
+
+subscription::
+
+    int last_chunk_id           -> chunk that knows the current state
+    char mboxname               -> no linkage to mailbox table, users can be sub'd to nonexistent
+    timestamp unsubscribed      -> time that it was unsubscribed, or NULL if still alive
+
+seen::
+
+    int last_chunk_id           -> chunk that knows the current state
+    char uniqueid               -> mailbox (not necessarily ours) this applies to
+    timestamp lastread
+    int lastuid
+    timestamp lastchange
+    char seenuids               -> a uid sequence encoded as a string
+
+sieve::
+
+    int chunk_id
+    timestamp last_update
+    char filename
+    char guid
+    int offset                  -> offset within chunk of the dlist containing this script
+    timestamp deleted           -> time that it was deleted, or NULL if still alive
+
+
+sieve scripts and messages are both identified by a GUID
+but APPLY SIEVE doesn't take a GUID, it seems to be generated locally?
+the GUID in the response to APPLY SIEVE is generated in the process of
+reading the script from disk (sync_sieve_list_generate)
+
+can't activate scripts because only bytecode files are activated, but
+we neither receive bytecode files over sync protocol nor do we compile
+them ourselves.
+
+possibly reduce index size by breaking deleted/expunged values into their
+own tables, such that we only store a deleted value for things that are
+actually deleted.  use left join + is null to find undeleted content
+
+messages
+--------
+
+APPLY MESSAGE is a list of messages, not necessarily only one message.
+Actually, it's a list of messages for potentially multiple users, but we avoid
+this by rejecting GET MESSAGES requests that span multiple users (so that
+sync_client retries at USER level, and so we only see APPLY MESSAGE requests
+for a single user).
+
+Cheap first implementation is to index the start/end of the entire APPLY
+MESSAGE command identically for each message within it, and at restore time
+we grab that chunk and loop over it looking for the correct guid.
+
+Ideal implementation would be to index the offset and length of each message
+exactly (even excluding the dlist wrapper), but this is rather complicated
+by the dlist API.
+
+For now, we just index the offset of the dlist entry for the message,
+and we can parse the pure message data back out later from that, when
+we need to.  Slightly less efficient on reads, but works->good->fast.  We
+need to loop over the entries in the MESSAGE dlist to find the one with the
+desired GUID.
+
+The indexed length needs to be the length of the message, not the length of the
+dlist wrapper, because we need to know this cheaply to supply RECORDs in
+MAILBOX responses.
+
+renames
+-------
+
+APPLY RENAME %(OLDMBOXNAME old NEWMBOXNAME new PARTITION p UIDVALIDITY 123)
+
+We identify mboxes by uniqueid, so when we start seeing sync data for the same
+uniqueid with a new mboxname we just transparently update it anyway, without
+needing to handle the APPLY RENAME.  Not sure if this is a problem...  Do we
+need to record an mbox's previous names somehow?
+
+I think it's possible to use this to rename a USER though, something like:
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.smithj NEWMBOXNAME example.com!user.jsmith ...)
+
+-- in which case, without special handling of the RENAME command itself, there
+will be a backup for the old user that ends with the RENAME, and a backup of
+the new user that (probably) duplicates everything again (except for stuff
+that's been expunged).
+
+And if someone else gets given the original name, like
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.samantha-mithj NEWMBOXNAME example.com!user.smithj ...)
+
+Then anything that was expunged from the original user but still available in
+backup disappears?  Or the two backups get conflated, and samantha can
+"restore" the original smithj's old mail?
+
+Uggh.
+
+if there's a mailboxes database pointing to the backup files, then the backup
+file names don't need to be based on the userid, they could e.g. be based on
+the user's inbox's uniqueid.  this would make it easier to deal with user
+renames because the backup filename wouldn't need to change.  but this depends
+on the uniqueid(s) in question being present on most areas of the sync
+protocol, otherwise when starting a backup of a brand new user we won't be
+able to tell where to store it.  workaround in the meantime could be to make
+some kind of backup id from the mailboxes database, and base the filename on
+this.
+
+actually, using "some kind of backup id from the mailboxes database" is probably
+the best solution.  otherwise the lock complexity of renaming a user while making
+sure their new backup filename doesn't already exist is frightful.
+
+maybe do something with mkstemp()?
+
+furthermore: what if a mailbox is moved from one user to another?  like:
+
+APPLY RENAME %(OLD... example.com!user.foo.something NEW... example.com!user.bar.something ...)
+
+when a different-uid rename IS a rename of a user (and not just a folder
+being moved to a different user), what does it look like?
+* does it do a single APPLY RENAME for the user, and expect their folders to shake out of that?
+* does it do an APPLY RENAME for each of their folders?
+
+in the latter case, we need to append each of those RENAMEs to the old backup
+so they can take effect correctly, and THEN rename the backup file itself. but
+how to tell when the appends are finished?
+
+how can we tell the difference between folder(s) moved to a different user vs
+user has been renamed?
+
+there is a setting: 'allowusermoves: 0' which, when enabled, allows users to
+be renamed via IMAP rename/xfer commands.  but the default is that this is
+disabled.  we could initially require this to be disabled while using backups...
+
+not sure what the workflow looks like for renaming a user if this is not enabled.
+
+not sure what the sync flow looks like in either case.
+
+looking at sync_apply_rename and mboxlist_renamemailbox, it seems like we'll
+see an APPLY RENAME for each affected mbox when a recursive rename is occurring.
+
+there doesn't seem to be anything preventing user/a/foo -> user/b/foo in the
+general (non-INBOX) case.
+
+renames might be a little easier to handle if the index replicated the mailbox
+hierarchy rather than just being a flat structure.  though this adds complexity
+wrt hiersep handling.  something like:
+
+mailbox:
+
+    mboxname
+        # just the name of this mbox
+
+    parent_id
+        # fk to parent mailbox
+
+    full_mboxname
+        # cached value, parent.full_mboxname + mboxname
+
+locking
+-------
+
+just use a normal flock/fcntl lock on the data file and only open the index
+if that lock succeeded
+
+*   backup:   needs to append foo and update foo.index
+*   reindex:  only needs to read foo, but needs a write lock to prevent
+              writes while it does so. needs to write to (replace) foo.index
+*   compact:  needs to re-write foo and foo.index
+*   restore:  needs to read
+
+
+verifying index
+---------------
+
+how to tell whether the .index file is the correct one for the backup data it
+ostensibly represents?
+
+one way to do this would be to have backup_index_end() store a checksum of
+the corresponding data contents in the index.
+
+when opening a backup, verify this checksum against the data, and refuse to
+load the index if it doesn't match.
+
+- sha1sum of (compressed) contents of file prior to each chunk
+
+how to tell whether the chunk data is any good?  store a checksum of the chunk
+contents along with the rest of the chunk index
+
+- sha1sum of (uncompressed) contents of each chunk
+
+
+mailboxes database
+------------------
+
+bron reckons use twoskip for this
+userid -> backup_filename
+
+lib/cyrusdb module implements this, look into that
+
+look at conversations db code to see how to use it
+
+need a tool:
+* given a user, show their backup filename
+* dump/undump
+* rebuild based on files discovered in backup directory
+
+where does this fit into the locking scheme?
+
+
+reindex
+-------
+
+* convert user mailbox name to backup name
+* complain if there's no backup data file?
+* lock, rename .index to .index.old, init new .index
+* foreach file chunk:
+*   timestamp is from first line in chunk
+*   complain if timestamp has gone backwards?
+*   index records from chunk
+* unlock
+* clean up .index.old
+
+on error:
+* discard partial new index
+* restore .index.old
+* bail out
+
+
+backupd
+-------
+
+cmdloop:
+* (periodic cleanup)
+* read command, determine backup name
+* already holding lock ? bump timestamp : obtain lock
+* write data to gzname, flush immediately
+* index data
+
+periodic cleanup:
+* check timestamp of each held lock
+* if stale (define: stale?), release
+* FIXME if we've appended more than the chunk size we would compact to, release
+
+sync restart:
+* release each held lock
+
+exit:
+* release each held lock
+
+need a "backup_index_abort" to complete the backup_index_start/end set.
+_start should create a transaction, _end should commit it, and _abort should
+roll it back.  then, if backupd fails to write to the gzip file for some
+reason, the (now invalid) index info we added can be discarded too.
+
+flushing immediately on write results in poor gzip compression, but for
+incremental backups that's not a problem.  when the compact process hits the
+file it will recompress the data more efficiently.
+
+
+questions
+---------
+* what does it look like when uidvalidity changes?
+
+
+restore
+-------
+
+restoration is effectively a reverse-direction replication (replicating TO master),
+which means we can't necessarily supply things like uid, modseq, etc without racing
+against normal message arrivals.  so instead we add an extra command to the protocol
+to restore a message to a folder but let the destination determine the tasty bits.
+
+protocol flow looks something like:
+
+c: APPLY RESERVE ... # as usual
+s: * MISSING (foo bar)
+s: OK
+c: APPLY MESSAGE ... # as usual
+s: OK
+c: RESTORE MAILBOX ... # new sync proto command
+s: OK
+
+we introduce a new command, RESTORE MAILBOX, which is similar to the existing
+APPLY MAILBOX.  it specifies, for a mailbox, the mailbox state plus the message
+records relevant to the restore.
+
+the imapd/sync_server receiving the RESTORE command creates the mailbox if necessary,
+and then adds the message records to it as new records (i.e. generating new uid etc).
+this will end up generating new events in the backup channel's sync log, and then the
+messages will be backed up again with their new uids, etc.  additional wire transfer
+of message data should be avoided by keeping the same guid.
+
+if the mailbox already exists but its uniqueid does not match the one from the backup,
+then what?  this probably means user has deleted folder and contents, then made new
+folder with same name.  so it's probably v common for mailbox uniqueid to not match
+like this.  so we don't care about special handling for this case.  just add any
+messages that aren't already there.
+
+if the mailbox doesn't already exist on the destination (e.g. if rebuilding a server
+from backups) then it's safe and good to reuse uidvalidity, uniqueid, uid, modseq etc,
+such that connecting clients can preserve their state.  so the imapd/sync_server
+receiving the restore request accepts these fields as optional, but only preserves
+them if it's safe to do so.
+
+* restore: sbin program for selecting and restoring messages
+
+restore command needs options:
++ whether or not to trim deletedprefix off mailbox names to be restored
++ whether or not to restore uniqueid, highestmodseq, uid and so on
++ whether or not to limit to/exclude expunged messages
++ whether or not to restore sub-mailboxes
++ sync_client-like options (servername, local_only, partition, ...)
++ user/mailbox/backup file(s) to restore from
++ mailbox to restore to (override location in backup)
++ override acl?
+
+can we heuristically determine whether an argument is an mboxname, uniqueid or guid?
+    => libuuid uniqueid is 36 bytes of hyphen (at fixed positions) and hex digits
+    => non-libuuid uniqueid is 24 bytes of hex digits
+    => mboxname usually contains at least one . somewhere
+    => guid is 40 bytes of hex digits
+
+usage:
+    restore [options] server [mode] backup [mboxname | uniqueid | guid]...
+
+options:
+    -A acl              # apply specified acl to restored mailboxes
+    -C alt_config       # alternate config file
+    -D                  # don't trim deletedprefix before restoring
+    -F input-file       # read mailboxes/messages from file rather than argv
+    -L                  # local mailbox operations only (no mupdate)
+    -M mboxname         # restore messages to specified mailbox
+    -P partition        # restore mailboxes to specified partition
+    -U                  # try to preserve uniqueid, uid, modseq, etc
+    -X                  # don't restore expunged messages
+    -a                  # try to restore all mailboxes in backup
+    -n                  # calculate work required but don't perform restoration
+    -r                  # recurse into submailboxes
+    -v                  # verbose
+    -w seconds          # wait before starting (useful for attaching a debugger)
+    -x                  # only restore expunged messages (not sure if useful?)
+    -z                  # require compression (abort if compression unavailable)
+
+mode:
+    -f                  # specified backup interpreted as filename
+    -m                  # specified backup interpreted as mboxname
+    -u                  # specified backup interpreted as userid (default)
+
+
+compact
+--------
+
+# finding messages that are to be kept (either exist as unexpunged somewhere,
+# or exist as expunged but more recently than threshold)
+# (to get unique rows, add "distinct" and remove mm.expunged from fields)
+sqlite> select m.*, mm.expunged from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged > 1437709300);
+id|guid|partition|chunk_id|offset|length|expunged
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+
+# finding chunks that are still needed (due to containing last state
+# of mailbox or mailbox_message, or containing a message)
+sqlite> select * from chunk where id in (select last_chunk_id from mailbox where deleted is null or deleted > 1437709300 union select last_chunk_id from mailbox_message where expunged is null or expunged > 1437709300 union select chunk_id from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged > 1437709300));
+id|timestamp|offset|length|file_sha1|data_sha1
+1|1437709276|0|3397|da39a3ee5e6b4b0d3255bfef95601890afd80709|6836d0110252d08a0656c14c2d2d314124755491
+3|1437709355|1977|2129|fee183c329c011ead7757f59182116500776eaaf|a5677cfa1f5f7b627763652f4bb9b99f5970748c
+4|1437709425|2746|1719|3d9f02135bf964ff0b6a917921b862c3420e48f0|7b64ec321457715ee61fe238f178f5d72adaef64
+5|1437709508|3589|2890|0cee599b1573110fee428f8323690cbcb9589661|90d104346ef3cba9e419461dd26045035f4cba02
+
+remember: a single APPLY MESSAGE line can contain many messages!
+
+thoughts:
+
+* need a heuristic for quickly determining whether a backup needs to be compacted
+
+    * sum(chunks to discard, chunks to combine, chunks to split) > threshold
+    * can we detect chunks that are going to significantly reduce in size as result of discarding individual lines?
+
+* "quick" vs "full" compaction
+
+settings:
+
+* backup retention period
+* chunk combination size (byte length or elapsed time)
+
+combining chunks:
+* size threshold below which adjacent chunks can be joined
+* size threshold above which chunks should be split
+* duration threshold below which adjacent chunks can be joined
+* duration threshold above which chunks should be split
+backup_min_chunk_size: 0 for no minimum
+backup_max_chunk_size: 0 for no maximum
+backup_min_chunk_duration: 0 for no minimum
+backup_max_chunk_duration: 0 for no maximum
+priority: size or duration??
+
+data we absolutely need to keep:
+
+* the most recent APPLY MAILBOX for each mailbox we're keeping (mailbox state)
+* the APPLY MAILBOX containing the most recent RECORD for each message we're keeping (record state)
+* the APPLY MESSAGE for each message we're keeping (message data)
+
+data that we should practically keep:
+
+* all APPLY MAILBOXes for a given mailbox from the chunk identified as its last
+* all APPLY MAILBOXes containing a RECORD for a given message from the chunk identified as its last
+* the APPLY MESSAGE for each message we're keeping
+
+four kinds of compaction (probably at least two simultaneously):
+
+* removing unused chunks
+* combining adjacent chunks into a single chunk (for better gz compression)
+* removing unused message lines from within a chunk (important after combining)
+* removing unused messages from within a message line
+
+"unused messages"
+    messages for which all records have been expunged for longer
+    than the retention period
+
+"unused chunks"
+    chunks which contain only unused messages
+
+algorithm:
+
+*   open (and lock) backup and backup.new (or bail out)
+*   use backup index to identify chunks we still need
+*   create a chunk in backup.new
+*   foreach chunk we still need:
+*       foreach line in the chunk:
+*           next line if we don't need to keep it
+*           create new line
+*           foreach message in line:
+*               if we still need the message, or if we're not doing message granularity
+*                   add the message to the new line
+*           write and index tmp line to backup.new
+*       if the new chunk is big enough, or if we're not combining
+*           end chunk and start a new one
+*   end the new chunk
+*   rename backup->backup.old, backup.new->backup
+*   close (and unlock) backup.old and backup
+
+
+command line locking utility
+----------------------------
+
+command line utility to lock a backup (for e.g. safely poking around in the
+.index on a live system).
+
+example failure:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+NO some error
+<EOF>
+
+example success:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+[potentially a delay here if we need to wait for another process to release the lock]
+OK locked
+[waits for its stdin to close, then unlocks and exits]
+
+if you need to rummage around in backup.index, run this program in another
+shell, do your work, then ^D it when you're finished.
+
+you could also call this from e.g. perl over a bidirectional pipe - wait to
+read "OK locked", then you've got your lock.  close the pipe to unlock when
+you're finished working.  if you don't read "OK locked" before the pipe closes
+then something went wrong and you didn't get the lock.
+
+specify backups by -f filename, -m mailbox, -u userid
+default run mode as above
+-s to fork an sqlite of the index (and unlock when it exits)
+-x to fork a command of your choosing (and unlock when it exits)
+
+
+reconstruct
+-----------
+
+rebuilding backups.db from on disk files
+
+scan each backup partition for backup files:
+  * skip timestamped files (i.e. backups from compact/reindex)
+  * skip .old files (old backups from reindex)
+  * .index files => skip???
+  * skip unreadable files
+  * skip empty files
+  * skip directories etc
+
+what's the correct procedure for repopulating a cyrus database?
+keep copy of the previous (presumably broken) one?
+
+trim off mkstemp suffix (if any) to find userid
+can we use a recognisable character to delimit the mkstemp suffix?
+
+what if there's multiple backup files for a given userid? precedence?
+
+verify found backups before recording.  reindex?
+
+locking? what if something has a filename and does stuff with it while
+reconstruct runs?
+
+backupd always uses db for opens, so as long as reconstruct keeps the db
+locked while it works, the db won't clash.  but backupd might have backups
+still open from before reconstruct started, which it will write to quite
+happily, even though reconstruct might decide that some other file is the
+correct one for that user...
+
+a backup server would generally be used only for backups, and sync_client
+is quite resilient when the destination isn't there, so it's actually
+no problem to just shut down cyrus while reconstruct runs.  no outage to
+user-facing services, just maybe some sync backlog to catch up on once
+cyrus is restarted.
+
+
+ctl_backups
+-------------
+
+sbin tool for mass backup/index/database operations
+
+needs:
+    * rebuild backups.db from disk contents
+    * list backups/info
+    * rename a backup
+    * delete a backup
+    * verify a backup (check all sha1's, not just most recent)
+
+not sure if these should be included, or separate tools:
+    * reindex a backup (or more)
+    * compact a backup (or more)
+    * lock a backup
+    * some sort of rolling compaction?
+
+usage:
+    ctl_backups [options] reconstruct                       # reconstruct backups.db from disk files
+    ctl_backups [options] list [list_opts] [[mode] backup...] # list backup info for given/all users
+    ctl_backups [options] move new_fname [mode] backup      # rename a backup (think about this more)
+    ctl_backups [options] delete [mode] backup              # delete a backup
+    ctl_backups [options] verify [mode] backup...           # verify specified backups
+    ctl_backups [options] reindex [mode] backup...          # reindex specified backups
+    ctl_backups [options] compact [mode] backup...          # compact specified backups
+    ctl_backups [options] lock [lock_opts] [mode] backup    # lock specified backup
+
+options:
+    -C alt_config       # alternate config file
+    -F                  # force (run command even if not needed)
+    -S                  # stop on error
+    -v                  # verbose
+    -w                  # wait for locks (i.e. don't skip locked backups)
+
+mode:
+    -A                  # all known backups (not valid for single backup commands)
+    -D                  # specified backups interpreted as domains (nvfsbc)
+    -P                  # specified backups interpreted as userid prefixes (nvfsbc)
+    -f                  # specified backups interpreted as filenames
+    -m                  # specified backups interpreted as mboxnames
+    -u                  # specified backups interpreted as userids (default)
+
+lock_opts:
+    -c                  # exclusively create backup
+    -s                  # lock backup and open index in sqlite
+    -x cmd              # lock backup and execute cmd
+    -p                  # lock backup and wait for eof on stdin (default)
+
+list_opts:
+    -t [hours]          # "stale" (no update in hours) backups only (default: 24)
+
+
+cyr_backup
+----------
+
+sbin tool for inspecting backups
+
+needs:
+    * better name?
+    * list stuff
+    * show stuff
+    * dump stuff
+    * restore?
+
+* should lock/move/delete (single backup commands) from ctl_backups be moved here?
+
+usage:
+    cyr_backup [options] [mode] backup list [all | chunks | mailboxes | messages]...
+    cyr_backup [options] [mode] backup show chunks [id...]
+    cyr_backup [options] [mode] backup show messages [guid...]
+    cyr_backup [options] [mode] backup show mailboxes [mboxname | uniqueid]...
+    cyr_backup [options] [mode] backup dump [dump_opts] chunk id
+    cyr_backup [options] [mode] backup dump [dump_opts] message guid
+    cyr_backup [options] [mode] backup json [chunks | mailboxes | messages]...
+
+options:
+    -C alt_config       # alternate config file
+    -v                  # verbose
+
+mode:
+    -f                  # backup interpreted as filename
+    -m                  # backup interpreted as mboxname
+    -u                  # backup interpreted as userid (default)
+
+commands:
+    list: table of contents, one per line
+    show: indexed details of listed items, one per paragraph, detail per line
+    dump: relevant contents from backup stream
+    json: indexed details of listed items in json format
+
+dump options:
+    -o filename         # dump to named file instead of stdout
+
+
+partitions
+----------
+
+not enough information in sync protocol to handle partitions easily?
+
+we know what the partition is when we do an APPLY operation (mailbox, message,
+etc), but the initial GET operations don't include it.  so we need to already
+know where the appropriate backup is partitioned in order to find the backup
+file in order to look inside it to respond to the GET request
+
+if we have a mailboxes database (indexed by mboxname, uniqueid and userid) then
+maybe that would make it feasible?  if it's not in the mailboxes database then
+we don't have a backup for it yet, so we respond accordingly, and get sent
+enough information to create it.
+
+does that mean the backup api needs to take an mbname on open, and it handles
+the job of looking it up in the mailboxes database to find the appropriate
+thing to open?
+
+can we use sqlite for such a database, or is the load on it going to be too
+heavy?  locking?  we have lots of database formats up our sleeves here, so
+even though we use sqlite for the backup index there isn't any particular
+reason we're beholden to it for the mailboxes db too
+
+if we have a mailboxes db then we need a reconstruct tool for that, too
+
+what if we support multiple backup partitions, but don't expect these
+to necessarily correspond with mailbox partitions.  they're just for spreading
+disk usage around.
+
+* when creating a backup for a previously-unseen user we'd pick a random
+  partition to put them on
+* ctl_backups would need a command to move an existing backup to a
+  given partition
+* ctl_backups would need a command to pre-create a user backup on a
+  given partition for initial distribution
+* instead of "backup_data_path" setting, have one-or-more
+  "backuppartition-<name>" settings, ala partition- and friends
+
+see imap/partlist.[ch] for partition list management stuff.  it's complicated
+and doesn't have a test suite, so maybe save this implementation until needed.
+
+but... maybe rename backup_data_path to backuppartition-default in the meantime,
+so that when we do add this it's not a complicated reconfig to update?
+
+partlist_local_select (and lazy-loaded partlist_local_init) are where the
+mailbox partitions come from (see also mboxlist_create_partition), do something
+similar for backup partitions
+
+
+data corruption
+---------------
+
+backups.db:
+    * can be reconstructed from on disk files at any time
+    * how to detect corruption? does cyrus_db detect/repair on its own?
+
+backup indexes:
+    * can be reindexed at any time from backup data
+    * how to detect corruption? assume sqlite will notice, complain?
+
+backup data:
+    * what's zlib's failure mode? do we lose the entire chunk or just the corrupt bit?
+    * verify will notice sha1sum mismatches
+    * dlist format will reject some kinds of corruption (but not all)
+    * reindex: should skip unparseable dlist lines
+    * message data has its own checksums (guid)
+    * reindex: should skip messages that don't match their own checksums
+    * compact: "full" compact will only keep useful data according to index
+    * backupd: will sync anything that's in user mailbox but not in backup index
+
+i think this means that if a message or mailbox state becomes corrupted in
+the backup data file, and it still exists in the user's real mailbox, you
+recover from the corruption by reindexing and then letting the sync process
+copy the missing data back in again.  and you can tidy up the data file by
+running a compact over it.
+
+you detect data corruption in most recent chunk reactively as soon as the
+backup system needs to open it again (quick verify on open)
+
+you detect data corruption in older chunks reactively by trying to restore from
+it.  may be too late: if a message needs restoring it's because user mailbox no
+longer has it
+
+you detect data corruption preemptively by running the verify tool over it.
+recommend scheduling this in EVENTS/cron?
+
+if data corruption occurs in message that's no longer in user's mailbox, that
+message is lost.  it was going to be deleted from the backup after $retention
+period anyway (by compact), but if it needs restoring in the meantime, sorry
+
+
+installation instructions
+-------------------------
+
+(obviously, most of this won't work at this point, because the code doesn't
+exist.  but this is, approximately, where things are heading.)
+
+on your backup server:
+    * compile with --enable-backup configure option and install
+    * imapd.conf:
+        backuppartition-default: /var/spool/backup  # FIXME better example
+        backup_db: twoskip
+        backup_db_path: /var/imap/backups.db
+        backup_staging_path: /var/spool/backup
+        backup_retention_days: 7
+    * cyrus.conf SERVICES:
+        backupd cmd="backupd" listen="csync" prefork=0
+        (remove other services, most likely)
+        (should i create a master/conf/backup.conf example file?)
+    * cyrus.conf EVENTS:
+        compact cmd="ctl_backups compact -A" at=0400
+    * start server as usual
+    * do i want a special port for backupd?
+
+on your imap server:
+    * imapd.conf:
+        sync_log_channels: backup
+        sync_log: 1
+        backup_sync_host: backup-server.example.com
+        backup_sync_port: csync
+        backup_sync_authname: ...
+        backup_sync_password: ...
+        backup_sync_repeat_interval: ... # seconds, smaller value = livelier backups but more i/o
+        backup_sync_shutdown_file: ....
+    * cyrus.conf STARTUP:
+        backup_sync cmd="sync_client -r -n backup"
+    * cyrus.conf SERVICES:
+        restored cmd="restored" [...]
+    * start/restart master
+
+files and such:
+    {configdirectory}/backups.db                        - database mapping userids to backup locations
+    {backuppartition-name}/<hash>/<userid>_XXXXXX       - backup data stream for userid
+    {backuppartition-name}/<hash>/<userid>_XXXXXX.index - index into userid's backup data stream
+
+do i want rhost in the path?
+    * protects from issue if multiple servers are trying to back up their own version of same user
+      (though this is its own problem that the backup system shouldn't have to compensate for)
+    * but makes location of undifferentiated user unpredictable
+    * so probably not, actually
+
+
+chatting about implementation 20/10
+-----------------------------------
+
+::
+
+    09:54 @elliefm
+    here's a fun sync question
+    APPLY MESSAGE provides a list of messages
+    can a single APPLY MESSAGE contain messages for multiple mailboxes and/or users?
+    my first hunch is that it doesn't cross users, since the broadest granularity for a single sync run is USER
+    10:06 kmurchison
+    We'd have to check with Bron, but I *think* messages can cross mailboxes for a single user
+    10:06 @brong
+    yes
+    APPLY MESSAGE just adds it to the reserve list
+    10:07 @elliefm
+    nah apply message uploads the message, APPLY RESERVE adds it to the reserve list :P
+    10:07 @brong
+    same same
+    APPLY RESERVE copies it from a local mailbox
+    APPLY MESSAGE uploads it
+    10:07 @elliefm
+    yep
+    10:07 @brong
+    they both wind up in the reserve list
+    10:07 @elliefm
+    ahh i see what you mean, gotcha
+    10:07 @brong
+    until you send a RESTART
+    ideally you want it reserve in the same partition, but it will copy the message over if it's not on the same partition
+    there's no restriction on which mailbox it came from/went to
+    good for user renames, and good for an append to a bunch of mailboxes in different users / shared space all at once
+    (which LMTP can do)
+    10:10 @elliefm
+    i can handle the case where a single APPLY MESSAGE contains messages for multiple mailboxes belonging to the same user
+    but i'm in trouble if a single APPLY MESSAGE can contain messages belonging to different users
+    10:14 @brong
+    @elliefm: why?
+    10:14 @brong
+    you don't have to keep them if they aren't used
+    10:15 @elliefm
+    for backups - when i see the apply, i need to know which user's backup to add it to.  that's easy enough if it doesn't cross users but gets mega fiddly if it does
+    i'm poking around in sync client to see if it's likely to be an issue or not
+    11:00 @brong_
+    @elliefm: I would stage it, and add it to users as it gets refcounted in by an index file
+    11:07 @elliefm
+    that's pretty much what we do for ordinary sync and delivery stuff yeah?
+    11:08 @brong_
+    yep
+    and it's what the backup thing does
+    11:09 @elliefm
+    i'm pretty sure that APPLY RESERVE and APPLY MESSAGE don't give a damn about users, they're just "here's every message you might not have already had since last time we spoke" and it lets the APPLY MAILBOX work out where to attach them later
+    11:09 @brong_
+    yep
+    11:09 @elliefm
+    so yeah, i'll need to do something here
+    i've been working so far on the idea that a single user's backup consists of 1) an append-only gzip stream of the sync protocol chat that built it, and 2) an index that tracks current state of mailboxes, and offsets within (1) of message data
+    that gets us good compression (file per user, not file per message), and if the index gets corrupted or lost, it's rebuildable purely from (1), it doesn't need a live copy of the original mailbox
+    11:12 @brong
+    yep, that all works
+    11:12 @elliefm
+    (so if you lose your imap server, you're not unable to rebuild a broken index on the backup)
+    11:13 @brong
+    it's easy enough to require the sync protocol stream to only contain messages per user
+    though "apply reserve" is messy
+    because you need to return "yes, I have that message"
+    11:13 @elliefm
+    with that implementation i can't (easily) keep user.a's messages from not existing in user.b's data stream (though they won't be indexed)
+    11:14 @brong
+    I'm not too adverse to the idea of just unpacking each message as it comes off the wire into a temporary directory
+    11:14 @elliefm
+    (because at the time i'm receiving the sync data i don't know which it needs to go in, so if they come in in the same reserve i'd need to append them to both data streams)
+    which isn't a huge problem, just… irks me a bit
+    11:14 @brong
+    and then reading the indexes as they come in, checking against the state DB to see if we already have them, and streaming them into the gzip if they aren't there yet
+    what we can do is something like the current format, where files go into a tar
+    11:16 @elliefm
+    i guess the fiddly bit there is that there's one more moving part to keep synchronised across failure states
+    a backup for a single user becomes 1) data stream + 2) any messages that were uploaded but not yet added to a mailbox + 3) index (which doesn't know what to do with (2))
+    which in the general case is fine, the next sync will update the mailboxes, which will push (2) into (1) and index it nicely, and on we go
+    but it's just a little bit more mess if there's a failure that you need to recover from between those states — it's no longer a simple case of "it's in the backup and we know everything about it" or "it doesn't exist", there's a third case of "well we might have the data but don't really know what to do with it"
+    the other fiddly bit is that the process of appending to the data stream is suddenly in the business of crafting output rather than simply dumping what it gets, which isn't really burdensome, but it is one more little crack for bugs to crawl into
+    i guess in terms of sync protocol, one thing i could do on my end is identify apply operations that seem to contain multiple users' data, and just return an error on those.  the sync client on the other end will promote them until they're eventually user syncs, which i think are always user granularity
+    11:50 @elliefm
+    i think for now, first stage implementation will be to stream the reserve/message commands in full to every user backup they might apply to.  and optimising that down so that each stream only contains messages belonging to that user can be a future optimisation
+
+
+todo list
+---------
+
+* clean up error handling
+* perl tool to anonymise sync proto talk
+* verification step to check entire data stream for errors (even chunks that aren't indexed)
+* prot_fill_cb: extra argument to pass back an error string to prot_fill
+* ctl_backups verify: set level
+* backupd: don't block on locked backups, return mailbox locked -- but sync_client doesn't handle this
+* test multiple backup partitions
+* configure: error if backups requested and we don't have zlib
+* valgrind
+* finish reconstruct
+* compact: split before append?
+
+compact implementation steps:
+    1 remove unused chunks, keep everything else as is
+    2 join adjacent chunks if small enough, split large chunks
+    3 parse/rebuild message lines
+    4 discard unused mailbox lines
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/bytecode.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/bytecode.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/bytecode.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/bytecode.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,155 @@
+.. _imap-developer-thoughts-bytecode:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Sieve Bytecode
+=================================
+
+Motivation
+----------
+
+The motivation behind moving to Sieve Bytecode is severalfold:
+
+-  Parsing a script at each execution is expensive computationally
+-  Lex/Yacc are costly in terms of memory usage and executable size,
+   whereas a bytecode parser is much lighter weight.
+-  Using bytecode can simplify the code for the execution phase, which
+   is far more frequently occurring than the upload/compile phase.
+-  Rewriting a significant part of the sieve execution framework forces
+   a decent amount of refactoring on what has traditionally been a
+   problematic part of the Cyrus code base. There is still work to do in
+   this area.
+
+Overall Bytecode Format
+-----------------------
+
+In the final bytecode, each opcode/parameter is aligned on a 4-byte
+boundary. Strings are NUL-terminated (and padded to a 4-byte boundary as
+needed).
+
+Ideally, we'd have all integers in network byte order, so as to make the
+scripts portable, but version 1 does not have this feature.
+
+At the beginning of the file, there is a magic header to identify it as
+a bytecode file, and a 4 byte version number. Immediately following the
+version number are the opcodes that relate to the script.
+
+Generation
+----------
+
+A Sieve Bytecode file is generated in three "passes":
+
+-  Generate a parse tree using lex/yacc from the sieve script. (addr.y,
+   addr-lex.l, sieve.y, sieve-lex.l).
+-  Serialize the parse tree into an intermediate form, where strings are
+   held separate from the rest of the representation. (bc\_generate.c)
+-  Serialize the intermediate form into the final bytecode. (bc\_emit.c)
+
+The intermediate form is an array of bytecode\_t unions, with strings
+located elsewhere in memory. The entry point is bc\_generate:
+sieve\_generate\_bytecode() / bc\_action\_generate().
+
+bc\_action\_generate traverses the commandlist\_t tree and emits opcodes
+in sequence.
+
+Simple actions (STOP, DISCARD, KEEP, MARK, UNMARK) have no arguments,
+and processing proceeds directly.
+
+More complicated options have a sequence of arguments that are emitted
+following the initial opcode.
+
+For example, single argument commands such as REJECT, FILEINTO, REDIRECT
+are followed by a bytecode\_t for a string's length, and then a
+bytecode\_t which contains a pointer to a string.
+
+Commands such as ADDFLAG, SETFLAG, REMOVEFLAG, which take a stringlist,
+format the stringlist as (using bc\_stringlist\_generate):
+
+::
+
+    {Number of Strings}{String 1 Length}{String 1 Ptr}{String 2 Length}....
+
+So their resulting final output would appear as:
+
+::
+
+    {Opcode}{...stringlist from above...}
+
+Even more complicated action opcodes (vacation, notify) etc, may take a
+sequence of integer values (flags), stringlists, or individual strings.
+These are more specifically documented in the code.
+
+This leaves us with the IF keyword (and tests). In the pass 1 form, IF
+appears as the following bytecode\_t structures:
+
+::
+
+    {IF opcode}
+    {Beginning of the then block}
+    {End of the then block / beginning of the else block}
+    {End of the else block / -1 for no else block}
+    {....test opcodes....}
+    {....'then' action opcodes....}
+    {....'else' action opcodes.... [optional]}
+
+Test opcodes are generated by the bc\_test\_generate function, which is
+very similar to bc\_action\_generate (tests without arguments are just
+opcodes, tests with arguments have them serialized into place directly
+following the original opcode). Test lists are represented as {number of
+tests}{address of the end of the list}{test 1}{test 2}.
+
+In the third pass, strings are serialized into place, and if statement
+jumps are resolved to actual addresses within the file This is done in
+bc\_emit: sieve\_emit\_bytecode / bc\_action\_emit.
+
+This results in a totally serialized representation, using byte offsets
+within the file instead of indexes into the array of bytecode\_t's. In
+addition to the manipulations that are necessary to do this, there are
+several other changes in format.
+
+Two new opcodes exist: NULL and JUMP (which performs an unconditional
+jump).
+
+Stringlists and testslists now include a precomputed byte length of the
+entire list, so it can be skipped over as needed.
+
+So as to be executable without a stack, the IF statements are designed
+as follows:
+
+::
+
+    {IF opcode}
+    {....test block....}
+    {JUMP (location of false condition) }
+    {....then block....}
+    {(if there is an else) JUMP (end of else block)}
+    {(if there is an else) .... else block ....}
+
+The idea being that if the test is true, the instruction pointer should
+move to the then block, otherwise the else block will be hit
+automatically (due to the unconditional jump).
+
+Evaluation
+----------
+
+The evaluation routines are in bc\_eval.c, the basic idea is that we can
+simply mmap the bytecode, run straight through it, and complete the
+processing without maintaining a stack.
+
+The processing is done by overlaying a bytecode\_input\_t array over the
+mmap. This allows addressing elements within the file to be simple.
+There is an instruction pointer which is incremented as each action is
+performed, or as actions/tests are skipped.
+
+Of special note in bc\_eval.c is the unwrap\_string function which will
+pull a string out of the bytecode, and return the instruction pointer at
+the end of the string.
+
+Other things to consider
+------------------------
+
+The Bytecode can be extended to contain other extensions. This could
+require regeneration of older scripts. In many cases this can be avoided
+by putting the new commands at the end of the proper enum in bytecode.h
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/caldav_scheduling_flowchart.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/caldav_scheduling_flowchart.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/caldav_scheduling_flowchart.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/caldav_scheduling_flowchart.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,378 @@
+.. _imap-developer-thoughts-caldavflow:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus CalDAV Scheduling Flowchart
+=================================
+
+caldav\_put() - create/modify via HTTP PUT on a resource or POST (add-member) on a calendar
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check if the new resource is a scheduling resource (contains
+   ORGANIZER property). If not, skip to step 4.
+#. Check for (and load) any existing resource.
+#. Check if the authenticated user matches ORGANIZER:
+
+   -  If yes:
+
+      -  If only voter (VPOLL) responses changed, goto
+         `sched\_pollstatus() <#sched_pollstatus>`__.
+      -  Otherwise, goto `sched\_request() <#sched_request>`__.
+
+   -  Otherwise, goto `sched\_reply() <#sched_reply>`__.
+
+#. Store the new/modified resource.
+
+caldav\_delete\_sched() - remove via HTTP DELETE on a resource
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check if the existing resource is a scheduling resource (has
+   Schedule-Tag). If not, we are done.
+#. Load the existing resource.
+#. Check if the authenticated user matches ORGANIZER. If yes, goto
+   `sched\_request() <#sched_request>`__, otherwise goto
+   `sched\_reply() <#sched_reply>`__.
+
+caldav\_post() - busytime query via HTTP POST on Scheduling Outbox
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check the ACL on the owner's Scheduling Outbox. If the authenticated
+   user doesn't have the DACL\_SCHEDFB right, fail.
+#. `sched\_busytime\_query() <#sched_busytime_query>`__.
+
+--------------
+
+sched\_pollstatus - perform a voter response update
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#.
+
+--------------
+
+sched\_request() - perform an organizer request / attendee status update
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL\_INVITE right, fail.
+
+If the request includes a resource, then set METHOD:REQUEST, otherwise
+set METHOD:CANCEL.
+
+Create an iTIP message template, copying over any CALSCALE property and
+VTIMEZONE components.
+
+If not an attendee status update and the existing resource is a
+scheduling resource: Foreach component in the existing resource, add it
+and its SEQUENCE to our hash table keyed by RECURRENCE-ID (for
+comparison against new/modified resource).
+
+Create a hash table of attendees. This will hold attendee-specific iTIP
+messages.
+
+Foreach component in the new/modified resource:
+
+a. Lookup (by RECURRENCE-ID) and remove the component from the hash
+   table of existing components.
+b. If the component exists compare all of DTSTART, DTEND, DURATION,
+   RRULE, RDATE, EXDATE to those of the new component.
+c. If the component is new or changed, then
+   `process\_attendees() <#process_attendees>`__.
+
+Foreach remaining component in the hash table of existing components do
+`sched\_cancel() <#sched_cancel>`__.
+
+Foreach iTIP message in our hash table of ATTENDEES,
+`sched\_deliver() <#sched_deliver>`__ the iTIP message.
+
+Foreach component in the new/modified resource update the
+SCHEDULE-STATUS of each ATTENDEE.
+
+process\_attendees() - create a suitable iTIP request message for each attendee
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach ATTENDEE in the component, remove the SCHEDULE-STATUS parameter,
+and set PROPSTAT=NEEDS-ACTION if required.
+
+Make a copy of the component and
+`clean\_component() <#clean_component>`__.
+
+Foreach ATTENDEE in the cleaned component:
+
+a. Check the CalDAV Scheduling parameters. If SCHEDULE-AGENT != SERVER,
+   skip to the next attendee.
+b. Lookup attendee in our hash table.
+c. If it doesn't exist, create a clone of our iTIP template and insert
+   it into our hash table of attendees.
+d. Add the component to the attendee's iTIP message.
+e. Add the component “number” to our mask of new components appearing in
+   the attendee's iTIP message.
+
+If the component is not the "master", foreach attendee do
+`sched\_exclude() <#sched_exclude>`__.
+
+sched\_exclude() - exclude an attendee from a recurrence instance
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. If the component did not appear in the attendee's iTIP message, add
+   an EXDATE property (based on the RECURRENCE-ID of the component) to
+   the master component of the attendee's iTIP message.
+
+sched\_cancel() - cancel an organizer event/task
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Set STATUS:CANCELLED on the component.
+#. `process\_attendees() <#process_attendees>`__.
+
+--------------
+
+sched\_reply() - perform an attendee reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the CalDAV Scheduling parameters on ORGANIZER. If SCHEDULE-AGENT
+!= SERVER, we are done.
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL\_REPLY right, fail.
+
+Create a new iTIP (METHOD:REPLY) message, copying over any CALSCALE
+property and VTIMEZONE components.
+
+Foreach component in the existing resource:
+
+a. `trim\_attendees() <#trim_attendees>`__.
+b. Add the trimmed component and the attendee's PARTSTAT to our hash
+   table keyed by RECURRENCE-ID (for comparison against new/modified
+   resource).
+
+Foreach component in the new/modified resource:
+
+`trim\_attendees() <#trim_attendees>`__.
+
+Lookup (by RECURRENCE-ID) and remove the component from the hash table
+of existing components.
+
+If the component exists:
+
+i.  If component is VPOLL, add voter responses to REPLY via
+    `sched\_vpoll\_reply(). <#sched_vpoll_reply>`__
+ii. Otherwise, compare the PARTSTAT of the ATTENDEE to that of the new
+    component.
+
+If the component is new or the PARTSTAT has changed:
+
+i.   `clean\_component() <#clean_component>`__.
+ii.  Add the component to our iTIP message.
+iii. Add the component “number” to our mask of new components appearing
+     in our iTIP message.
+
+Foreach remaining component in the hash table of existing components do
+`sched\_decline() <#sched_decline>`__.
+
+`sched\_deliver() <#sched_deliver>`__ our iTIP message.
+
+Foreach component in the new/modified resource that appeared in our iTIP
+message, update the SCHEDULE-STATUS of the ORGANIZER.
+
+trim\_attendees() - remove all attendees other than the one replying
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Clone the component and remove all ATTENDEE properties other than the
+   one corresponding to the owner of the calendar.
+#. Return the ATTENDEE property of owner, his/her PARTSTAT parameter,
+   and the RECURRENCE-ID of the component.
+
+sched\_vpoll\_reply() - add voter responses to VPOLL reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#.
+
+sched\_decline() - decline a recurrence instance for an attendee
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Set PARTSTAT of ATTENDEE to DECLINED.
+#. `clean\_component() <#clean_component>`__.
+#. Add the component to our iTIP message.
+
+--------------
+
+clean\_component() - sanitize a component for use in an iTIP message
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Update DTSTAMP.
+#. Remove any VALARM components.
+#. For a reply/decline only, remove scheduling parameters from
+   ORGANIZER.
+
+sched\_deliver() - deliver an iTIP message to a recipient
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Lookup the recipient.
+#. If local to our server goto
+   `sched\_deliver\_local() <#sched_deliver_local>`__, otherwise goto
+   `sched\_deliver\_remote() <#sched_deliver_remote>`__.
+
+--------------
+
+sched\_deliver\_local() - deliver an iTIP message to a local user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the ACL on the owner's Scheduling Inbox. If the sender doesn't
+have the proper right (DACL\_INVITE for request/cancel, DACL\_REPLY for
+reply), fail.
+
+Search the recipient's calendars for a resource having the specified
+UID.
+
+If the resource doesn't exist:
+
+a. If the iTIP method is REPLY, fail (we are done).
+b. If the iTIP method is CANCEL, ignore it (we are done).
+c. Otherwise, create a new (empty) attendee object and target the
+   recipient's Default calendar.
+
+Otherwise, load the existing resource.
+
+Update the new/existing resource:
+
+a. If the iTIP method is CANCEL, set STATUS:CANCELLED on all existing
+   components.
+b. If the iTIP method is REPLY, do
+   `deliver\_merge\_reply() <#deliver_merge_reply>`__.
+c. If the iTIP method is REQUEST, do
+   `deliver\_merge\_request() <#deliver_merge_request>`__.
+d. If the iTIP method is POLLSTATUS, do
+   `deliver\_merge\_pollstatus() <#deliver_merge_pollstatus>`__.
+
+Store the new/updated resource in the recipient's target calendar.
+
+Record the delivery status (SCHEDULE-STATUS).
+
+If the iTIP message is something other than just a PARTSTAT update from
+an attendee, store the iTIP message as a new resource in the recipient's
+Inbox.
+
+If the iTIP method is REPLY, send an update other attendees via
+`sched\_pollstatus() <#sched_pollstatus>`__ (VPOLL only) or
+`sched\_request() <#sched_request>`__.
+
+deliver\_merge\_reply() - update an organizer resource with an attendee reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.
+
+If the component doesn't exist (new recurrence overridden by ATTENDEE)
+create a new recurring component:
+
+i.   Clone the existing master component.
+ii.  Remove the RRULE property.
+iii. Add the RECURRENCE-ID from the iTIP message.
+iv.  Replace the DTSTART, DTEND, SEQUENCE properties with those from the
+     iTIP message.
+v.   Add the new component to our existing resource.
+
+Get the sending ATTENDEE from the iTIP message.
+
+Find the matching ATTENDEE in the existing component.
+
+If not found (ATTENDEE added themselves to this recurrence), add new
+ATTENDEE to the component.
+
+Set the ATTENDEE PARTSTAT, RSVP, and SCHEDULE-STATUS parameters in the
+existing component.
+
+If the component is VPOLL, update the voter responses in the existing
+component via
+`deliver\_merge\_vpoll\_reply() <#deliver_merge_vpoll_reply>`__.
+
+Return the sending ATTENDEE.
+
+deliver\_merge\_vpoll\_reply() - update an organizer resource with voter responses
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Foreach sub-component in the existing resource, replace any voter
+   response(s) with those from the reply.
+
+deliver\_merge\_request() - create/update an attendee resource with an organizer request
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach VTIMEZONE component in the existing resource, add it to our hash
+table keyed by TZID (for comparison against iTIP message).
+
+Foreach VTIMEZONE component in the iTIP message:
+
+a. Lookup (by TZID) the VTIMEZONE component from the hash table of
+   existing components.
+b. If the component exists, remove it from the existing object.
+c. Add the VTIMEZONE from the iTIP message to our existing object.
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Clone a new component from the iTIP component.
+
+Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.
+
+If the component exists:
+
+i.   Compare the SEQUENCE of the new component to the existing component
+     to see if it has changed.
+ii.  Copy any COMPLETED, PERCENT-COMPLETE, or TRANSP properties from the
+     existing component to the new component.
+iii. Copy any ORGANIZER SCHEDULE-STATUS parameter from the existing
+     component to the new component.
+iv.  Remove the existing component from the existing object.
+
+Add the new component to the existing object.
+
+deliver\_merge\_pollstatus() - update voter responses on a voter resource
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach sub-component in the existing resource, add it to our hash table
+keyed by POLL-ITEM-ID (for comparison against iTIP message). The
+sub-component entry includes a hash table of VOTERs.
+
+Foreach sub-component in the iTIP message:
+
+a. Lookup (by POLL-ITEM-ID) the sub-component from the hash table of
+   existing sub-components.
+b. If the component exists, foreach VOTER in the sub-component in the
+   iTIP message:
+
+   i.  Lookup VOTER in the hash table of existing sub-component.
+   ii. Add/update VOTER response.
+
+--------------
+
+sched\_deliver\_remote() - deliver an iTIP message to a remote user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. If the recipient is local to our Murder, goto
+   `isched\_send() <#isched_send>`__, otherwise goto
+   `imip\_send() <#imip_send>`__.
+#. Retrieve status of iTIP message delivery.
+
+isched\_send() - deliver an iTIP message to a remote user via iSchedule (HTTP)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+imip\_send() - deliver an iTIP message to a remote user via iMIP (SMTP)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+sched\_busytime\_query() - perform a busytime query
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+busytime\_query\_local() - perform a busytime query on a local user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+busytime\_query\_remote() - perform a busytime query on a remote user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/improved_mboxlist_sort.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/improved_mboxlist_sort.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/improved_mboxlist_sort.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/improved_mboxlist_sort.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,32 @@
+.. _imap-developer-thoughts-improved_mboxlist_sort:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Enabling improved_mboxlist_sort
+=================================
+
+You can't enable and disable ``improved_mboxlist_sort`` on a live
+system. You need to dump and load the necessary database after stopping
+and before starting the master process.
+
+Dumping the mailboxes.db file
+
+::
+
+    ctl_mboxlist -d > /var/tmp/mailboxes.txt
+    ctl_mboxlist -u < /var/tmp/mailboxes.txt
+
+If your subscription databases are not in flat files you need to do
+something similar. Each user will have his own subscription file. Do the
+following for each subscription file.
+
+::
+
+    cyr_dbtool -C $file skiplist show > $file.TXT
+    cyr_dbtool -n $file skiplist set < $file.TXT
+
+The above fragments will overwrite the original file. So you could
+redirect to a temporary file and overwrite the database if the import
+succeeds.
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/notes.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/notes.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/notes.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/notes.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,19 @@
+.. _imap-developer-thoughts-notes:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Notes
+========================
+
+-  appending: it's important that the index records for individual
+   messages make it to disk before the index header indicating that
+   they're there. so something like:
+
+   #. sync messages to disk (or depend on ``link()`` being atomic)
+   #. create new index records, flush to disk
+   #. create new header if necessary (adding new user flag), flush to
+      disk
+   #. flush cache file
+   #. update index header, flush to disk
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts/prot-events.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts/prot-events.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts/prot-events.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts/prot-events.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,59 @@
+.. _imap-developer-thoughts-prot-events:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Prot Events
+==============================
+
+From an email exchange between Ken Murchison and Lawrence Greenfield,
+dated 03 Feb 2002 (slightly redacted and formatted for your viewing
+pleasure):
+
+|    From: Ken Murchison
+|    To: Lawrence Greenfield
+|    Subject: Re: prot events
+|
+
+    Lawrence Greenfield wrote:
+
+        Can you give me some details on how the event API in the prot
+        layer works?  I'm a little unclear about the memory management,
+        what should be returned from the event callback,
+
+    Either the event pointer (if the event is still active), or NULL
+    (if the event has been removed by the callback).
+
+        and how to reschedule an event.
+
+    Simply set the 'mark' time in the event to the wall time you want
+    it to run again.
+
+        (I'd like to make an event called every X seconds of idle time;
+        I know the API can't do exactly that but I suspect I can fake
+        it well enough.)
+
+    Look at backend_timeout() in proxyd.c and/or drac_ping() in
+    contrib/drac_auth.patch, they do exactly this.
+
+    The API is pretty simple:
+
+    *   use prot_addwaitevent() to add an event (linked list) callback
+        onto a stream.  takes the stream, the 'mark' time at which to
+        run the event (NOT an interval, but the future clock value),
+        the function pointer, and a rock to pass to the callback as
+        args, and returns a pointer to the event (to use for future
+        removal).
+
+    *   use prot_removewaitevent() to remove an event.  takes the
+        stream and a pointer to the event as args.
+
+    *   the event callback gets the stream, a pointer to the event
+        and the rock as args.  To reschedule an event, simply set the
+        'mark' time and return the event pointer.  If the callback
+        removes the event, then return NULL.
+
+    If you see and flaws in this API, feel free to go ahead and change it.
+
+    Ken
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/thoughts.txt 3.2.0-3/doc/html/_sources/imap/developer/thoughts.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/thoughts.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/thoughts.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-developer-thoughts:
+
+.. author: Nic Bernstein (Onlight)
+
+==========================
+Developer Thoughts & Notes
+==========================
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    thoughts/*
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer/unit-tests.txt 3.2.0-3/doc/html/_sources/imap/developer/unit-tests.txt
--- 3.0.13-5/doc/html/_sources/imap/developer/unit-tests.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer/unit-tests.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,628 @@
+.. _imap-developer-unit-tests:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Unit Tests
+==========
+
+Table of Contents
+-----------------
+
+-  `1. Introduction <#introduction>`__
+-  `2. What Is A Unit Test? <#what-is-a-unit-test>`__
+-  `3. Running The Tests <#running-the-tests>`__
+
+   -  `3.1. Setting Up The Machine <#setting-up-the-machine>`__
+   -  `3.2 Configure Script <#configure-scripts>`__
+   -  `3.3 Make <#running-the-tests>`__
+   -  `3.4 Using Valgrind <#using-valgrind>`__
+   -  `3.5 The Tests Are Failing <#the-tests-are-failing>`__
+   -  `3.6 Debugging A Test <#debugging-a-test>`__
+
+-  `4. Adding Your Own Tests <#adding-your-own-tests>`__
+
+   -  `4.1 Where To Put Your Tests <#where-to-put-your-tests>`__
+   -  `4.1 Adding A New Suite <#adding-a-new-suite>`__
+   -  `4.2 Adding A Test To A Suite <#adding-a-test-to-a-suite>`__
+   -  `4.3 Suite Init And Cleanup <#suite-init-and-cleanup>`__
+
+1. Introduction
+---------------
+
+Recently, a set of regression unit tests has been added to Cyrus. This
+document explains the purpose implementation of those unit tests, and
+gives an example of how to add more unit tests (because there are never
+enough unit tests!).
+
+2. What Is A Unit Test?
+-----------------------
+
+The `definition on Wikipedia <http://en.wikipedia.org/wiki/Unit_test>`__
+sheds some light:
+
+    ...\ **unit testing** is a method by which individual units of
+    source code are tested to determine if they are fit for use. A unit
+    is the smallest testable part of an application.
+
+In other words, unit testing is about verifying that small pieces of
+code, like individual functions, modules, or classes, work in isolation.
+It is **not** about testing the system as a whole.
+
+The tests implemented here are also **regression tests**, which in
+`Wikipedia's words <http://en.wikipedia.org/wiki/Regression_testing>`__
+means:
+
+    **Regression testing** is any type of software testing that seeks to
+    uncover software errors after changes to the program (e.g. bugfixes
+    or new functionality) have been made, by retesting the program. The
+    intent of regression testing is to assure that a change, such as a
+    bugfix, did not introduce new bugs.
+
+In other words, the tests are designed to be easy to run and to work out
+fully automatically whether they have passed or failed, so that they can
+be run usefully by people who didn't write them.
+
+3. Running The Tests
+--------------------
+
+This section takes you through the process of running Cyrus' unit tests.
+
+3.1. Setting Up The Machine
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Cyrus' unit tests are all located in a new directory,
+``cyrus-imapd/cunit/``. They're written in C, like the remainder of
+Cyrus, and use the `CUnit library from
+SourceForge <http://cunit.sourceforge.net/>`__, with some home grown
+wrappers and other improvements to make our lives easier.
+
+Your first step is step is to ensure that the CUnit library (including
+the headers) is installed. Some modern operating systems already have
+CUnit, for example on Ubuntu you can just do:
+
+::
+
+    me@ubuntu> sudo apt-get install libcunit1-dev
+
+Alternately, you can download the CUnit source, build it and install it.
+It's not a complicated or difficult library, this shouldn't take long.
+When you've done, install it in ``/usr/include`` and ``/usr/lib``.
+
+3.2 Configure Script
+~~~~~~~~~~~~~~~~~~~~
+
+Because of the dependency on the CUnit library, the tests are disabled
+by default; this means you need enable them with an option to the
+``configure`` script:
+
+::
+
+    me@mybox> ./configure --enable-unit-tests
+    ...
+    checking for CU\_initialize\_registry in -lcunit... yes
+    checking CUnit/CUnit.h usability... yes
+    checking CUnit/CUnit.h presence... yes
+    checking for CUnit/CUnit.h... yes
+    ...
+
+3.3 Make
+~~~~~~~~
+
+First you need to build Cyrus itself, using the traditional ``all:``
+target.
+
+::
+
+    me@mybox> make all
+    ...
+
+Then, use the new ``check:`` target to build and run the unit tests.
+
+::
+
+    me@mybox> make check
+     cd . && /bin/bash /home/me/cyrus-imapd/missing --run automake-1.11 --foreign Makefile
+     cd . && /bin/bash ./config.status Makefile depfiles (a)
+    config.status: creating Makefile
+    config.status: executing depfiles commands
+    ...
+    make[3]: Entering directory \`/home/me/cyrus-imapd'
+    make[3]: \`sieve/test' is up to date.
+    cunit/cunit.pl --project cunit/default.cunit --generate-wrapper cunit/mboxname.testc (b)
+    gcc -DHAVE\_CONFIG\_H ... -c -o cunit/mboxname.o cunit/mboxname.testc-cunit.c
+    rm -f cunit/mboxname.testc-cunit.c
+    /bin/bash ./libtool --tag=CC --mode=link gcc -fPIC -g -O2 -o
+    cunit/unit cunit/unit.o ... lib/libcyrus\_min.la ... (c)
+    ...
+    Running unit tests (d)
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: mboxname (e)
+      Test: dir\_hash\_c ... passed
+      Test: to\_parts ... passed
+      Test: to\_userid ... passed
+      Test: to\_usermbox ... passed
+    ...
+    --Run Summary: Type      Total     Ran  Passed  Failed (f)
+                   suites       34      34     n/a       0
+                   tests       323     323     323       0
+                   asserts 1079745 1079745 1079745       0
+    make[1]: Leaving directory `/home/me/cyrus-imapd/cunit'
+
+Let's take a closer look at what's happening here.
+
+(a)
+    The ``check:`` target causes automake to re-run itself. This is
+    normal automake behaviour. Note that the older build system used to
+    run make recursively in sub-directories, the newer automake-based
+    system builds everything from the top directory.
+(b)
+    The ``cunit/`` directory contains a number of C source files
+    (called, for reasons too complicated to explain here,
+    *whatever*.testc) with test code in them. For each of those, a small
+    wrapper C source file is generated and then compiled into an object
+    file.
+(c)
+    Finally, all the compiled object files are linked into an
+    executable, with a ``main()`` routine from ``unit.c``, and a number
+    of libraries and object files from other parts of the Cyrus tree.
+(d)
+    The resulting executable is then run.
+(e)
+    The test executable runs all the built tests one by one, telling us
+    which ones passed and which ones failed as it runs them. You can
+    also run it manually with the name of a test as an argument, and it
+    will run only the named test.
+(f)
+    At the end, the text executable prints a summary of how many tests
+    it ran and how many passed and failed. The key thing to look at here
+    is the rightmost column, it should be all zero.
+
+3.4 Using Valgrind
+~~~~~~~~~~~~~~~~~~
+
+Some failure modes are subtle, and cannot be detected in the C code
+itself; this is where `the Valgrind program <http://valgrind.org/>`__
+comes in very handy. It detects buffer overruns and memory leaks and
+various other kinds of subtle errors.
+
+To run the unit tests with Valgrind, use the new ``valgrind:`` target.
+
+::
+
+    me@mybox> make valgrind
+    ...
+    valgrind --tool=memcheck --leak-check=full ./unit -v (a)
+    ==2999== Memcheck, a memory error detector
+    ==2999== Copyright (C) 2002-2010, and GNU GPL'd, by Julian Seward et al.
+    ==2999== Using Valgrind-3.6.0.SVN-Debian and LibVEX; [...]
+    ==2999== Command: ./unit -v
+    ==2999==
+    ...
+    --Run Summary: Type      Total     Ran  Passed  Failed   (b)
+                   suites        9       9     n/a       0
+                   tests        51      51      50       1
+                   asserts     474     474     473       1
+    ...
+    ==2999== HEAP SUMMARY:   (c)
+    ==2999==     in use at exit: 4,489 bytes in 134 blocks
+    ==2999==   total heap usage: 715 allocs, 581 frees, 352,763 bytes allocated
+    ==2999==
+    ==2999== 4 bytes in 1 blocks are definitely lost in loss record 3 of 50
+    ==2999==    at 0x4C2815C: malloc (vg_replace_malloc.c:236)
+    ==2999==    by 0x44A0CA: xmalloc (xmalloc.c:57)
+    ==2999==    by 0x4399D8: strconcat (util.c:631)
+    ==2999==    by 0x40C059: test_uncast_null (strconcat.c:51)
+    ==2999==    by 0x61B32A9: ??? (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x61B36ED: ??? (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x61B3827: CU_run_all_tests (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x4066CC: run_tests (unit.c:144)
+    ==2999==    by 0x406806: main (unit.c:283)
+    ==2999==
+    ...
+
+Here's an explanation of what's happening in the example.
+
+(a)
+    The test executable is run as before, but using the ``valgrind``
+    program. The first thing we see is Valgrind's banner message.
+(b)
+    The test executable proceeds as normal and eventually emits it's run
+    summary, then exits.
+(c)
+    After the test executable exits, Valgrind checks for memory leaks
+    and prints both a summary of all leaks and a stack trace showing
+    where each block of leaked memory was allocated.
+
+I'd just like to say that I love Valgrind and I think it's immensely
+useful. I would have made running the tests under Valgrind the only
+option for the ``check:`` target, except that Valgrind is not available
+on all of Cyrus' supported platforms.
+
+3.5 The Tests Are Failing
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+So you've noticed that some of the tests are failing. Let me make the
+guiding principle of unit testing as clear as possible: **THE UNIT TESTS
+SHOULD NOT FAIL**. All of the tests are designed to pass all the time,
+in everyone's environment. The unit tests are run automatically every
+twelve hours on the Cyrus `Continuous Integration
+server <http://ci.cyrusimap.org/>`__, and a failing test fails the whole
+build and makes people unhappy.
+
+There are a few rules which you should follow to help us all get the
+most benefit out of unit testing
+
+-  If you see a test failing, investigate it.
+-  If you can't investigate, complain on the mailing list or raise a bug
+   so that somebody else can investigate.
+-  When writing tests, write them to work in all environments and all
+   combinations of ``configure`` script options. It's ok to have a test
+   which is empty in some circumstances; it's not ok to have a test that
+   fails.
+-  When adding code, write new tests for the new code.
+-  When modifying code, write new tests for the new behaviour.
+-  When looking at old code, also take a look at the `coverage
+   report <http://ci.cyrusimap.org/job/cyrus-imapd-master/887/cobertura/>`__
+   and consider writing tests for the existing code.
+
+3.6 Debugging A Test
+--------------------
+
+With the new Cyrus build system, the file ``cunit/unit`` is no longer an
+executable, it's a shell script which sets up some environment variables
+before running the real executable which is hidden away. This makes
+debugging a failing test somewhat challenging. The solution is:
+
+::
+
+    me@mybox> ( cd cunit ; libtool --mode=execute gdb --args unit -t crc32 )
+    ...
+    Reading symbols from /home/me/cyrus-imapd/cunit/.libs/lt-unit...done.
+    (gdb) list crc32.testc:1
+    1       /* Unit test for lib/crc32.c */
+    2       #include "cunit/cyrunit.h"
+    3       #include "crc32.h"
+    ...
+    (gdb) break test_map
+    Breakpoint 1 at 0x44a2f8: file ./cunit/crc32.testc, line 11.
+    (gdb) run
+    Starting program: /home/me/cyrus-imapd/cunit/.libs/lt-unit -t -v crc32
+    [Thread debugging using libthread_db enabled]
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    Suite: crc32
+      Test: map ...
+    Breakpoint 1, test_map () at ./cunit/crc32.testc:11
+    11          c = crc32_map(TEXT, sizeof(TEXT)-1);
+    (gdb)
+
+
+Note the **-t** option. This turns off test timeouts, which is very
+useful for manual debugging.
+
+4. Adding Your Own Tests
+------------------------
+
+Adding your own tests is quite simple. Here's how.
+
+4.1 Where To Put Your Tests
+---------------------------
+
+The unit test code in Cyrus is contained in a set of C source files in
+the ``cunit`` directory. For reasons too complex to go into here, these
+are named *whatever*.testc instead of the more usual *whatever*.c. If
+you look closely, you will see that each of those C source files maps to
+a "Suite" in CUnit parlance. For example, ``cunit/glob.testc`` is listed
+as the Suite "glob" in CUnit's runtime output.
+
+Typically, each Suite tests a single module or a related set of
+functions; for example, ``cunit/glob.testc`` contains tests for the glob
+module in ``lib/glob.c``.
+
+So, if you want to add a new test for a module which already has some
+existing tests, the sensible thing to do is to `add a new test to the
+existing suite <#adding-a-test-to-a-suite>`__. Otherwise, you'll need to
+`add a new Suite <#adding-a-new-suite>`__.
+
+4.1 Adding A New Suite
+----------------------
+
+Each Suite is a single C source file in the ``cunit/`` directory. Your
+first step is to create a new C source file. For this example, you'll
+create a new Suite to test the CRC32 routines which live in
+``lib/crc32.c``.
+
+::
+
+    me@mybox> vi cunit/crc32.testc
+    ...
+
+The file should contain something like this.
+
+::
+
+    /* Unit test for lib/crc32.c */
+    #include "cunit/cyrunit.h"  (a)
+    #include "crc32.h"  (b)
+
+    static void test_map(void)  (c)
+    {
+        static const char TEXT[] = "lorem ipsum";  (d)
+        static uint32_t CRC32 = 0x0;
+        uint32_t c;  (e)
+
+        c = crc32_map(TEXT, sizeof(TEXT)-1);  (f)
+        CU_ASSERT_EQUAL(c, CRC32);  (g)
+    }
+
+Here's an explanation of what all these bits are for.
+
+(a)
+    You need to include the header ``"cunit/cyrunit.h"``, which is a thin
+    Cyrus wrapper around the CUnit's library's header,
+    ``<CUnit/CUnit.h>`` with some extra conveniences.
+(b)
+    You should also include any headers you need for declarations of the
+    functions which you'll be testing. Note that the Cyrus ``lib/`` and
+    ``imap/`` directories are already in the include path, so any header
+    in there can be included without the directory prefix, e.g.
+    ``"crc32.h"`` for ``lib/crc32.h``.
+(c)
+    You need to have at least one function which looks like this: it
+    takes no arguments, returns void, and is named ``test_whatever``. It
+    may be ``static`` or ``extern``, but I recommend ``static``.
+    Functions with this signature are automatically discovered in the
+    source code by the Cyrus unit test infrastructure, so all you have
+    to do is write the function. Later, a CUnit test named "whatever"
+    will be created automatically for your ``test_whatever`` function.
+(d)
+    Here's a good place to define the test inputs and expected outputs.
+    Note that for this example you have no idea of the actual correct
+    output. The right thing to do there is to manually calculate the
+    expected result from first principles, or to use a different piece
+    of software which you believe to be working. For this example, let's
+    just use a known incorrect value and see what happens.
+(e)
+    Here's a good place for local variables you need during the test.
+(f)
+    Call the function under test (``crc32_map()`` in this example) with
+    known inputs, and capture the results in a local variable ``c``.
+(g)
+    Compare the actual result in ``c`` with the expected result in
+    ``CRC32``. The ``CU_ASSERT_EQUAL()`` macro checks that it's two
+    arguments are equal (using an integer comparison), and if they're
+    different it prints a message and records a failure. Note that
+    unlike the libc ``assert()`` macro, control will continue even if
+    the assert fails. The CUnit library provides a whole family of
+    similar macros, see `the online CUnit
+    documentation <http://cunit.sourceforge.net/doc/writing_tests.html#assertions>`__
+    for more details.
+
+Now you need to tell the Cyrus build system about your new Suite.
+
+::
+
+    me@mybox> vi Makefile.am
+    ...
+
+You need to add the filename of your new test to the definition of the
+``cunit_TESTS`` variable.
+
+::
+
+    cunit_TESTS = \
+        cunit/aaa-db.testc \
+        cunit/annotate.testc \
+        cunit/backend.testc \
+        cunit/binhex.testc \
+        cunit/bitvector.testc \
+        cunit/buf.testc \
+        cunit/byteorder64.testc \
+        cunit/charset.testc \
+        cunit/crc32.testc \
+        cunit/dlist.testc \
+        cunit/duplicate.testc \
+
+At this point you should be able to just rebuild and rerun using **make
+check**. You can also just rebuild without rerunning by using the
+command **make cunit/unit**.
+
+Note that sometimes this doesn't quite work right, and you may be able
+to work around this problem using the command **rm
+cunit/default.cunit**.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --add-sources [...] crc32.testc
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o ...
+    Running unit tests
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... FAILED
+        1. crc32.testc:12  - CU_ASSERT_EQUAL(c=1926722702,CRC32=0)
+
+Note how the test failure told us which in source file and at what line
+number the failure occurred, and what the actual and expected values
+were. Let's go and fix that up now.
+
+::
+
+    static const char TEXT[] = "lorem ipsum";
+    static uint32\_t CRC32 = 0x72d7748e;
+
+Re-run ``make check`` and you'll see your test being rebuilt and rerun,
+and this time passing.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o
+    ...
+    Running unit tests
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... passed
+
+4.2 Adding A Test To A Suite
+----------------------------
+
+Adding a new test to an existing test is easy: all you have to do is add
+a new function to an existing C source file in the ``cunit/`` directory.
+As an example, let's add a test for the ``crc_iovec()`` function.
+
+::
+
+    me@mybox> vi cunit/crc32.testc
+    ...
+
+    static void test_iovec(void)  (a)
+    {
+        static const char TEXT1[] = "lorem";  (b)
+        static const char TEXT2[] = " ipsum";
+        static uint32_t CRC32 = 0x72d7748e;
+        uint32_t c;  (c)
+        struct iovec iov[2];
+
+        memset(iov, 0, sizeof(iov));  (d)
+        iov[0].iov_base = TEXT1;
+        iov[0].iov_len = sizeof(TEXT1)-1;
+        iov[1].iov_base = TEXT2;
+        iov[1].iov_len = sizeof(TEXT2)-1;
+
+        c = crc32_iovec(iov, 2);  (e)
+        CU_ASSERT_EQUAL(c, CRC32);  (f)
+    }
+
+Here's an explanation of what all these bits are for.
+
+(a)
+    Your new test function should look like this: it takes no arguments,
+    returns void, and is named ``test_whatever``. It may be ``static``
+    or ``extern``, but I recommend ``static``. Functions with this
+    signature are automatically discovered in the source code by the
+    Cyrus unit test infrastructure, so all you have to do is write the
+    function. Later, a CUnit test named "whatever" will be created
+    automatically for your ``test_whatever`` function. Note that the
+    opening curly brace must be on the next line or the unit test
+    infrastructure will not find the function.
+(b)
+    Here's a good place to define the test inputs and expected outputs.
+(c)
+    Here's a good place for local variables you need during the test.
+(d)
+    Here you set up the input conditions for the function under test.
+(e)
+    Call the function under test with your known inputs, and capture the
+    results in a local variable, here ``c``.
+(f)
+    Compare the actual result in ``c`` with the expected result in
+    ``CRC32``. The ``CU_ASSERT_EQUAL()`` macro checks that it's two
+    arguments are equal (using an integer comparison), and if they're
+    different it prints a message and records a failure. Note that
+    unlike the libc ``assert()`` macro, control will continue even if
+    the assert fails. The CUnit library provides a whole family of
+    similar macros, see `the online CUnit
+    documentation <http://cunit.sourceforge.net/doc/writing_tests.html#assertions>`__
+    for more details.
+
+Now run ``make check`` and you'll see your test being built and run.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o
+    ...
+    Running unit tests
+
+
+         CUnit - A Unit testing framework for C - Version 2.1-0
+         http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... passed
+      Test: iovec ... passed
+
+4.3 Suite Setup And Teardown
+----------------------------
+
+Sometimes the behaviour of the functions under test depend on external
+influences such as environment variables, global variables, or the
+presence of certain files.
+
+These kinds of functions need special treatment to ensure that their
+behaviour is locked down during the running of your tests. Otherwise,
+all sorts of strange behaviour may confuse the results of the tests. For
+example, a test might succeed the first time it's run in a given
+directory and fail the next time. Or a test might succeed when run by
+the author of the test but fail when run by another user.
+
+CUnit provides a special arrangement which helps you in such cases: the
+suite initialisation and cleanup functions. These are two functions that
+you write and which live in the suite source. They are called from CUnit
+respectively before any of the tests in the suite is run, and after all
+tests from that suite are run.
+
+Here's how to use them. The suite setup function should set up any
+global state that the functions under test rely on, in such a way that
+their state is predictable and always the same no matter who runs the
+test or when or how many times. Similarly the suite teardown function
+should clean up any state which might possibly interfere with other test
+suites. Note that some suites will need an setup function but not
+necessarily a teardown function.
+
+Adding these functions is very easy: you just write functions of the
+appropriate signature (names, arguments and return type) and the Cyrus
+unit test infrastructure will automatically discover them and arrange
+for them to be called. The functions should look like (actual example
+taken from ``cunit/mboxname.testc``) this:
+
+::
+
+    static enum enum_value old_config_virtdomains;
+
+    static int set_up(void)
+    {
+        old_config_virtdomains = config_virtdomains;
+        config_virtdomains = IMAP_ENUM_VIRTDOMAINS_ON;
+        return 0;
+    }
+
+    static int tear_down(void)
+    {
+        config_virtdomains = old_config_virtdomains;
+        return 0;
+    }
+
+
+The functions should return 0 on success, and non-zero on error. They
+must not call and ``CU_*`` functions or macros.
+
+Good luck and good testing!
diff -pruN 3.0.13-5/doc/html/_sources/imap/developer.txt 3.2.0-3/doc/html/_sources/imap/developer.txt
--- 3.0.13-5/doc/html/_sources/imap/developer.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/developer.txt	2020-04-24 02:03:00.000000000 +0000
@@ -15,11 +15,11 @@ Getting Started
     developer/compiling
     installing
     developer/developer-testing
+    developer/jmap
 
 .. toctree::
     :hidden:
 
-    developer/developer-tips
     developer/install-xapian
 
 System files and Databases
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/getcyrus.txt 3.2.0-3/doc/html/_sources/imap/download/getcyrus.txt
--- 3.0.13-5/doc/html/_sources/imap/download/getcyrus.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/getcyrus.txt	2020-04-08 00:07:13.000000000 +0000
@@ -29,7 +29,7 @@ Use a release packaged tarball
 The Cyrus team produce packaged tarballs containing full source and
 pre-built documentation.
 
-Download a versioned tarball using `FTP`_ or `HTTPS`_. Latest stable
+Download a versioned tarball using `HTTPS`_. Latest stable
 version is |imap_current_stable_version|.
 
 Extract the tarball:
@@ -38,9 +38,7 @@ Extract the tarball:
 
     $ :command:`tar xzvf cyrus-imapd-x.y.z.tar.gz`
 
-.. _FTP: ftp://ftp.cyrusimap.org/cyrus-imapd/
-
-.. _HTTPS: https://www.cyrusimap.org/releases/
+.. _HTTPS: https://github.com/cyrusimap/cyrus-imapd/releases
 
 Use the source from Git
 -----------------------
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/installation/http/caldav.txt 3.2.0-3/doc/html/_sources/imap/download/installation/http/caldav.txt
--- 3.0.13-5/doc/html/_sources/imap/download/installation/http/caldav.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/installation/http/caldav.txt	2020-04-24 02:03:00.000000000 +0000
@@ -82,6 +82,17 @@ It allows you to:
     * Set visibility attributes such as Public or Transparent
     * Delete existing collections
 
+The Cyrus web GUI for CalDAV Collection Management is disabled by
+default, but can be enabled with the "caldav_allowcalendaradmin" option.
+
+.. sidebar:: caldav_allowcalendaradmin
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob caldav_allowcalendaradmin
+      :end-before: endblob caldav_allowcalendaradmin
+
 To access the Cyrus web GUI for CalDAV Collection Management, point
 a web browser at ``https://<servername>/dav/calendars/user/<username>``
 
@@ -167,7 +178,8 @@ The tables below show how the access con
         <td>CYRUS:admin</td>
         <td>DAV:read-acl
           <br>DAV:write-acl
-            <br>DAV:unlock</td>
+	  <br>DAV:share
+          <br>DAV:unlock</td>
         <td>ACL
           <br>PROPFIND <small>(DAV:acl property ONLY)</small>
           <br>UNLOCK <small>(ANY lock)</small></td>
@@ -296,6 +308,7 @@ accessed via URLs of the following form:
 collections, when they have explicitly "freebusy" ACL (9) set, is done via
 ``https://<servername>/freebusy/user/<userid>/<collection>``.
 
+
 Query parameters can be added to the URL per Section 4 of
 `Freebusy Read URL <http://www.calconnect.org/pubdocs/CD0903%20Freebusy%20Read%20URL.pdf>`_,
 allowing the user to choose to set the start, end, period and format of
@@ -307,7 +320,7 @@ Time Zone Distribution Service (TZDist)
 What is TZDist
 --------------
 
-The Time Zone module allows Cyrus to function as a Time Zone Distribution
+The TZDist module allows Cyrus to function as a Time Zone Distribution
 Service (:rfc:`7808` and :rfc:`7809`), providing time zone data for CalDAV
 and calendaring clients, without having to wait for their client vendor and/or
 OS vendor to update the timezone information. The responsibility for keeping
@@ -337,25 +350,33 @@ Configuration
        :start-after: startblob zoneinfo_db
        :end-before: endblob zoneinfo_db
 
-This module stores time zone data in the ``zoneinfo/`` subdirectory of the Cyrus
-configuration directory (as specified by the ``configdirectory`` option). The data is
-indexed by a database whose location is specified by the ``zoneinfo_db_path``
-option, using the format specified by the ``zoneinfo_db`` option.
+   |
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+       :start-after: startblob zoneinfo_dir
+       :end-before: endblob zoneinfo_dir
+
+The TZDist module requires the ``zoneinfo_dir`` setting in :cyrusman:`imapd.conf(5)`
+to be set to the directory where your time zone data is stored.
+
+The data is indexed by a database whose location is specified by the
+``zoneinfo_db_path`` option, using the format specified by the ``zoneinfo_db``
+option.
 
 Administration
 --------------
 
-This module is designed to use the IANA Time Zone Database data (a.k.a. Olson
-Database) converted to the iCalendar format.
+The TZDist module is designed to use the IANA Time Zone Database data (a.k.a.
+Olson Database) converted to the iCalendar format.
 
-Cyrus uses a modified `vzic <https://github.com/libical/vzic>`_ to convert IANA
-formatted data into iCalendar format. There is more information on Cyrus vzic in
-``tools/vzic/README``.
+We provide a modified `vzic <https://github.com/libical/vzic>`_ to convert IANA
+formatted data into iCalendar format, in the `cyrus-timezones package
+<https://github.com/cyrusimap/cyrus-timezones>`_ to make the following steps
+easier.
 
-The steps to populate the Cyrus ``zoneinfo/`` directory are:
+The steps to populate the ``zoneinfo_dir`` directory are:
 
-1. Build the local "vzic" utility located in the ``tools/vzic/`` subdirectory
-   of the Cyrus source code. Run make in the tools/vzic/ subdirectory to build.
+1. Acquire and build your choice of ``vzic`` tool.
 
 2. Download the latest version of the
    `Time Zone Database data from IANA <http://www.iana.org/time-zones>`_. Note
@@ -363,14 +384,15 @@ The steps to populate the Cyrus ``zonein
 
 3. Expand the downloaded time zone data into a temporary directory of your choice.
 
-4. Populate ``<configdirectory>/zoneinfo/`` with iCalendar data:
+4. Populate ``zoneinfo_dir`` with iCalendar data:
 
    *Initial Install Only*
 
    a. Convert the raw data into iCalendar format by running vzic as follows:
-      ``vzic --pure --olson-dir <location-of-raw-data> --output-dir <configdirectory>/zoneinfo``
+      ``vzic --pure --olson-dir <location-of-raw-data> --output-dir <zoneinfo_dir>``
 
-      This will create and install iCalendar data directly into the ``<configdirectory>/zoneinfo/`` directory.
+      This will create and install iCalendar data directly into the
+      ``<zoneinfo_dir>`` directory.
 
    *Updating Data Only*
 
@@ -378,9 +400,8 @@ The steps to populate the Cyrus ``zonein
       ``vzic --pure --olson-dir <location-of-raw-data>``
 
       This will create a zoneinfo/ subdirectory in your current location
-      (which should be `tools/vzic/`).
 
-   c. Merge new/updated iCalendar data into the ``<configdirectory>/zoneinfo/`` directory
+   c. Merge new/updated iCalendar data into the ``<zoneinfo_dir>`` directory
       by running vzic-merge.pl in your current location:
       ``vzic-merge.pl``
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/installation/http/carddav.txt 3.2.0-3/doc/html/_sources/imap/download/installation/http/carddav.txt
--- 3.0.13-5/doc/html/_sources/imap/download/installation/http/carddav.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/installation/http/carddav.txt	2020-04-24 02:03:00.000000000 +0000
@@ -43,6 +43,14 @@ the first time that the user authenticat
 user MUST have an existing IMAP Inbox in order for the addressbook to be
 created.
 
+.. sidebar:: carddav_allowaddressbookadmin
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob carddav_allowaddressbookadmin
+      :end-before: endblob carddav_allowaddressbookadmin
+
 There is also a Cyrus web GUI for managing addressbook resources.
 It allows you to:
 
@@ -50,6 +58,9 @@ It allows you to:
     * Delete existing collections
     * Download existing collections via prepared URLs
 
+The Cyrus web GUI for addressbook management is disabled by default,
+but can be enabled with the "carddav_allowaddressbookadmin" option.
+
 To access the Cyrus web GUI for addressbook management, point
 a web browser at ``https://<servername>/dav/addressbooks/user/<username>``
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/installation/http/jmap.txt 3.2.0-3/doc/html/_sources/imap/download/installation/http/jmap.txt
--- 3.0.13-5/doc/html/_sources/imap/download/installation/http/jmap.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/installation/http/jmap.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,90 @@
+====
+JMAP
+====
+
+About JMAP
+==========
+
+`JMAP <http://jmap.io/>`_ is an alternate mechanism for synchronising a mail
+client with a mail server, intended as a replacement for IMAP. It is a
+transport-agnostic, stateless JSON-based API, aiming to be compatible with the
+IMAP data model, but with reduced data usage and more efficient synchronisation.
+
+Configuration
+=============
+
+.. todo::
+
+    Stop duplication in this and developer-jmap by moving a chunk of this
+    information into /assets and include instead.
+
+JMAP support needs to be compiled in to the server using additional
+compile flags. Depending on your distribution, your package provider may
+have already done so. If not, check the
+:ref:`JMAP developer guide <developer-jmap>` for instructions on how to do
+so manually, assuming you have the source.
+
+.. sidebar:: JMAP configuration
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+       :start-after: startblob conversations
+       :end-before: endblob conversations
+
+   |
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob conversations_db
+      :end-before: endblob conversations_db
+
+Once it's compiled, JMAP needs to be enabled in :cyrusman:`imapd.conf(5)`.
+
+Enable :ref:`conversation support <imap-concepts-deployment-db-conversations>`
+
+    * In :cyrusman:`imapd.conf(5)`, set ``conversations: 1``, ``conversations_db: twoskip``
+    * Create a conversations.db for each user using
+      :cyrusman:`ctl_conversationsdb(8)`: ``ctl_conversationsdb -b -r``
+
+JMAP clients
+============
+
+The official JMAP website maintains a list of `known clients with JMAP support
+<http://jmap.io/software.html>`_.
+
+The Cyrus :ref:`JMAP developer guide <developer-jmap>` has information on using
+the sample test clients.
+
+.. _jmap-implementation:
+
+JMAP implementation status
+==========================
+
+The JMAP implementation in Cyrus is at various stages of maturity.
+
+Working
+-------
+
+* **Contacts**
+    * All JMAP methods are implemented. JMAP blobs are not supported.
+
+* **Calendars**
+    * All JMAP methods are implemented. JMAP blobs are not supported.
+
+* **Messages**
+    * Most JMAP methods are implemented. The following methods are not planned for implementation:
+
+      * copyMessages
+      * reportMessages
+      * getVacationResponse
+      * setVacationResponse
+      * getIdentityUpdates
+      * setIdentities
+
+Not yet implemented
+-------------------
+
+* **Remote mailboxes**
+
+* **Events**
+    * Changes on mailbox entries trigger notifications. However, the JMAP event service is not implemented.
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/installation/manage-dav.txt 3.2.0-3/doc/html/_sources/imap/download/installation/manage-dav.txt
--- 3.0.13-5/doc/html/_sources/imap/download/installation/manage-dav.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/installation/manage-dav.txt	2020-04-24 02:03:00.000000000 +0000
@@ -31,6 +31,8 @@ Its feature set is limited to:
 * File Storage (WebDAV)
     * Acts as a remote storage server server by using IMAP mailboxes as
       collections and :rfc:`5322` message to store files.
+* JMAP support
+    * Allows synchronization of mail clients via the JSON Mail Access Protocol (JMAP).
 * Other (RSS, static content)
     * Serves static content (such as the RSS feed list template and the
       CalDAV/CardDAV web GUIs ).
@@ -94,12 +96,12 @@ Module-specific information
 ===========================
 
 .. toctree::
-    :glob:
     :maxdepth: 2
 
     http/caldav
     http/carddav
     http/webdav
+    http/jmap
     http/rss
 
 For end users
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/packagers.txt 3.2.0-3/doc/html/_sources/imap/download/packagers.txt
--- 3.0.13-5/doc/html/_sources/imap/download/packagers.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/packagers.txt	2020-05-04 04:02:14.000000000 +0000
@@ -1,9 +1,17 @@
-===================
 Notes for Packagers
 ===================
 
+Binary naming
+-------------
+
+Prevent namespace clashes. We suggest renaming all binaries with ``cyr_`` at
+the front, including renaming the ``ctl_*`` to ``cyr_``.
+
+The Cyrus team are looking to fix this in the core bundle in upcoming releases
+so packagers have less to do.
+
 Sample configuration files
-==========================
+--------------------------
 
 There are several samples of :cyrusman:`cyrus.conf(5)` and
 :cyrusman:`imapd.conf(5)` located in the ``doc/examples`` directory of
@@ -12,10 +20,10 @@ documentation directory (i.e. ``/usr/sha
 reference for your users.
 
 Predefined configurations
-=========================
+-------------------------
 
 The configuration file for master: cyrus.conf
----------------------------------------------
+`````````````````````````````````````````````
 
 When installing a predefined :cyrusman:`cyrus.conf(5)` for your users,
 please pay attention to new features and how these may impact users.
@@ -64,7 +72,7 @@ sections are:
       it should shut down and clean up after.
 
 The configuration file for the various programs: imapd.conf
------------------------------------------------------------
+```````````````````````````````````````````````````````````
 
 The sample :cyrusman:`imapd.conf(5)` files must be adapted for use from
 site to site.  Here, therefore, we'll attempt to point you towards some
@@ -100,53 +108,30 @@ files.  In this example, the filesystem
 New default settings
 ####################
 
-With the introduction of version 3.0, the defaults for some settings
-have changed.  Please consult :ref:`upgrade` for details.
-
-New features
-############
-
-There are several features either new to version 3.0, or newly improved.
-Some of these may be features which previously were not considered ripe
-for packaging, but merit new consideration.
-
-Please see the release notes :ref:`relnotes-3.0.0-changes` for more
-details and other recent changes.
+A new stable series means the defaults for some settings may have changed.
+Please consult :ref:`upgrade` for details.
 
-*   Conversations
+New or improved features
+########################
 
-    *   Server-side threading with reduced protocol chatter for mobile
-        or other high-latency clients.
-    *   See the ``conversations`` options in :cyrusman:`imapd.conf(5)`
+A new stable series means new features, and improvements to existing features.
+Some of these may be features which previously were not considered ripe for
+packaging, but merit new consideration.
 
-*   Xapian
-
-    *   Higher quality full-text search support.
-    *   See the ``search_engine`` option in :cyrusman:`imapd.conf(5)`
-        and ``doc/README.xapian`` in the source distribution.
-
-*   Archive partitions
-
-    *   Automatically migrate messages from posh, fast storage (think
-        SSD) to cheap, slow storage (spinning rust).
-    *   Requires addition of an archive partition for each data
-        partition.
-    *   See ``archive_*`` options in :cyrusman:`imapd.conf(5)`
-
-*   Backup
-
-    *   Replication-based backup to dedicated instance with efficient,
-        compact scheme.
-    *   See :ref:`Cyrus Backups <cyrus-backups>`
-
-Please consider enabling these features in the :cyrusman:`imapd.conf(5)`
-you ship  in your packages.
+Please see :ref:`imap-release-notes-3.2` for details, and consider enabling
+these features in the :cyrusman:`imapd.conf(5)` you ship in your packages.
 
 Services in ``/etc/services``
-=============================
-
-Listing named services through ``/etc/services`` aids in cross-system consistency and cross-platform interoperability. Furthermore, it enables administrators and users to refer to the service by name (for example in ``/etc/cyrus.conf``, 'listen=mupdate' can be specified instead of 'listen=3905').
+-----------------------------
 
-Some of the services Cyrus IMAP would like to see available through ``/etc/services`` have not been assigned an IANA port number, and few have configuration options.
+Listing named services through ``/etc/services`` aids in cross-system
+consistency and cross-platform interoperability. Furthermore, it enables
+administrators and users to refer to the service by name (for example in
+``/etc/cyrus.conf``, 'listen=mupdate' can be specified instead of
+'listen=3905').
+
+Some of the services Cyrus IMAP would like to see available through
+``/etc/services`` have not been assigned an IANA port number, and few have
+configuration options.
 
 ..  include:: /assets/services.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.2/2.2.x.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.2/2.2.x.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.2/2.2.x.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.2/2.2.x.txt	2020-04-24 02:03:00.000000000 +0000
@@ -70,12 +70,12 @@ Changes to the Cyrus IMAP Server since 2
 Changes to the Cyrus IMAP Server since 2.2.5
 
 *   Fix a bug in the proxy code where a backend connection might get closed twice
-*   Improved consistency checking in chk_cyrus
+*   Improved consistancy checking in chk_cyrus
 *   Fix segfault in APPEND code
 *   Fix a bug with an interaction between sieve and unixhierarchysep
 *   Fix a file descriptor leak in the quotadb code
 *   Fix a triggered assertation in service-thread services
-*   Add a number of internal consistency checks to the skiplist code
+*   Add a number of internal consistancy checks to the skiplist code
 *   Allow mbpath to handle virtual domains
 *   Fix various MANAGESIEVE client authentication issues
 *   Other minor fixes
@@ -143,7 +143,7 @@ Changes to the Cyrus IMAP Server since 2
 
 Changes to the Cyrus IMAP Server since 2.1.x
 
-*   There have been extensive performance and consistency changes to the configuration subsystem. This will both ensure greater consistency between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:
+*   There have been extensive performance and consistancy changes to the configuration subsystem. This will both ensure greater consistancy between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:
 *       The tls_[service]_* configuration options have been removed. Now use [servicename]_tls_*, where servicename is the service identifier from cyrus.conf for that particular process.
 *       Administrative groups (e.g. admins and lmtp_admins) no longer union, service groups completely override the generic group.
 *       lmtp_allowplaintext is no longer a defined parameter and must be specified using the service name of your lmtp process if you require a specific value
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.4/x/2.4.19.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.4/x/2.4.19.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.4/x/2.4.19.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.4/x/2.4.19.txt	2020-04-24 02:03:00.000000000 +0000
@@ -29,5 +29,4 @@ Cyrus IMAP 2.4.19 Release Notes
 * Fixed :issue:`1967`: EXISTS count reported earlier if fetching past size
   of previous message set
 
-
 :ref:`imap-release-notes-2.4`
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.0.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.0.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.0.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.0.txt	2020-04-08 00:07:13.000000000 +0000
@@ -15,15 +15,10 @@ Cyrus IMAP 2.5.0 Release Notes
 *   :ref:`relnotes-2.5.0-development-phabricator`
 *   :ref:`relnotes-2.5.0-development-documentation`
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz.sig
 
 .. _imap-relnotes-2.5.0-upgrading:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.10.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.10.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.10.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.10.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.10 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz.sig
 
 .. _relnotes-2.5.10-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.11.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.11.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.11.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.11.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.11 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz.sig
 
 .. _relnotes-2.5.11-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.14.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.14.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.14.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.14.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-:tocdepth: 3
-
-===============================
-Cyrus IMAP 2.5.14 Release Notes
-===============================
-
-.. IMPORTANT::
-
-    This is a bug-fix release in the `stable 2.5 series <http://www.cyrusimap.org/stable>`_.
-
-    Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
-    about the 2.5 series, including upgrading instructions.
-
-Download via HTTPS:
-
-    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz
-    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz.sig
-
-.. _relnotes-2.5.14-changes:
-
-Changes Since 2.5.13
-====================
-
-Release changes
----------------
-
-We’re trialing using the Github Releases feature. If you have trouble
-downloading this release, please report this to the mailing lists. Thanks!
-
-Security fixes
---------------
-
-* Fixed CVE-2019-18928: unauthenticated HTTP requests no longer inherit
-  authentication from the previous request on the same connection
-
-Build changes
--------------
-
-* Can now build against ClamAV >= 0.101 (thanks Christoph Moench-Tegeder)
-
-Bug fixes
----------
-
-* Fixed :issue:`2877`: `quota -f` now works correctly with `improved_mboxlist_sort: no`
-* Fixed :issue:`2808`: UNDUMP no longer crashes when quota needs updating
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.15.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.15.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.15.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.15.txt	2020-04-08 00:07:13.000000000 +0000
@@ -0,0 +1,59 @@
+:tocdepth: 3
+
+===============================
+Cyrus IMAP 2.5.15 Release Notes
+===============================
+
+.. IMPORTANT::
+
+    This is a bug-fix release in the `stable 2.5 series <http://www.cyrusimap.org/stable>`_.
+
+    Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
+    about the 2.5 series, including upgrading instructions.
+
+Download via HTTPS:
+
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz.sig
+
+.. _relnotes-2.5.15-changes:
+
+Changes Since 2.5.14
+====================
+
+Release changes
+---------------
+
+We’re trialing using the Github Releases feature. If you have trouble
+downloading this release, please report this to the mailing lists. Thanks!
+
+Security fixes
+--------------
+
+* Fixed CVE-2019-19783_: When creating a missing mailbox as part of a sieve
+  'fileinto' directive, lmtpd would create it as administrator, bypassing ACL
+  checks.
+
+  lmtpd creates missing mailboxes as part of a sieve 'fileinto'
+  directive if:
+
+  * (2.5+) the `anysievefolder` option is enabled (default: not), or
+  * (3.0+) the `sieve_extensions` option has the 'mailbox' extension enabled
+    (default: enabled) and the 'fileinto' directive contains the ":create"
+    argument
+
+  Under these conditions, a user with the ability to upload a custom sieve
+  script to their account could use it to create any valid mailbox on the
+  server (with ACL inherited from the parent mailbox as usual).
+
+  lmtpd no longer creates these mailboxes as administrator, so users may no
+  longer use a 'fileinto' directive to create a mailbox they couldn't create
+  otherwise.
+
+.. _CVE-2019-19783: https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783
+
+Bug fixes
+---------
+
+* Fixed :issue:`2913`: errors are now logged when `maxlogins_per_host`,
+  `maxlogins_per_user`, and `popminpoll` limits are reached (thanks Sergey)
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.1.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.1.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.1 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz.sig
 
 .. _relnotes-2.5.1-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.2.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.2.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.2 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz.sig
 
 .. _relnotes-2.5.2-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.3.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.3.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.3 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz.sig
 
 .. _relnotes-2.5.3-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.4.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.4.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.4 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz.sig
 
 .. _relnotes-2.5.4-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.5.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.5.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.5.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.5.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.5 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz.sig
 
 .. _relnotes-2.5.5-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.6.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.6.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.6.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.6.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.6 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz.sig
 
 .. _relnotes-2.5.6-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.7.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.7.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.7.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.7.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.7 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz.sig
 
 .. _relnotes-2.5.7-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.8.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.8.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.8.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.8.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.8 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz.sig
 
 .. _relnotes-2.5.8-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.9.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.9.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.9.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/2.5/x/2.5.9.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.9 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz.sig
 
 .. _relnotes-2.5.9-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/index.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/index.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/index.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/index.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,4 +8,7 @@ Cyrus IMAP 3.0 Releases
     :maxdepth: 1
     :glob:
 
-    x/?.?.*
+    x/?.?.*-beta*
+    x/?.?.*-rc*
+    x/?.?.?
+    x/?.?.??
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta1.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta1.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta1 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz.sig
 
 .. _relnotes-3.0.0-beta1-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta2.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta2.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta2 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz.sig
 
 .. _relnotes-3.0.0-beta2-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta3.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta3.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta3 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz.sig
 
 .. _relnotes-3.0.0-beta3-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta4.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta4.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta4 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz.sig
 
 .. _relnotes-3.0.0-beta4-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta5.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta5.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta5.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta5.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta5 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz.sig
 
 .. _relnotes-3.0.0-beta5-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta6.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta6.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta6.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-beta6.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta6 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz.sig
 
 .. _relnotes-3.0.0-beta6-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc1.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc1.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc1 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz.sig
 
 .. _relnotes-3.0.0-rc1-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc2.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc2.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc2 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz.sig
 
 .. _relnotes-3.0.0-rc2-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc3.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc3.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc3 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz.sig
 
 .. _relnotes-3.0.0-rc3-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc4.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0-rc4.txt	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc4 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz.sig
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz.sig
 
 .. _relnotes-3.0.0-rc4-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.0.txt	2020-04-08 00:07:13.000000000 +0000
@@ -4,15 +4,10 @@
 Cyrus IMAP 3.0.0 Release Notes
 ====================================
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz.sig
 
 .. _relnotes-3.0.0-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.1.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.1.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 3.0.1 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz.sig
 
 .. _relnotes-3.0.1-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.2.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.2.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.2 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz.sig
 
 .. _relnotes-3.0.2-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.3.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.3.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.3 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz.sig
 
 .. _relnotes-3.0.3-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.4.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.4.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.4 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz.sig
 
 .. _relnotes-3.0.4-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.5.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.5.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.5.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.5.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.5 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz.sig
 
 .. _relnotes-3.0.5-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.6.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.6.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.6.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.6.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.6 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz.sig
 
 .. _relnotes-3.0.6-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.7.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.7.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.7.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.0/x/3.0.7.txt	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.7 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTPS:
-
-    *   https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz
-    *   https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz.sig
 
 .. _relnotes-3.0.7-changes:
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/index.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/index.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/index.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/index.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,18 @@
+.. _imap-release-notes-3.1:
+
+===================
+Cyrus IMAP 3.1 Tags
+===================
+
+.. warning::
+
+    The 3.1 series are tagged snapshots of the master branch, and should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. toctree::
+    :maxdepth: 1
+    :glob:
+
+    x/?.?.*
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.0-dev.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.0-dev.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.0-dev.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.0-dev.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,38 @@
+:tocdepth: 3
+
+==================================
+Cyrus IMAP 3.1.0-dev Release Notes
+==================================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. _relnotes-3.1.0-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+*
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The per-user calendar and addressbook administrative web user
+  interfaces (e.g. /dav/calendars/user/<userid>) are now disabled by
+  default.  They can be enabled with the `caldav_allowcalendaradmin`
+  and `carddav_allowaddressbookadmin` options respectively.
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.1.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,48 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.1 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.2.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,54 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.2 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.2-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.3.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.3.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,54 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.3 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.3-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.4.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.4.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.4 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.4-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v14 included in 3.1.4 - adds unseen count to index header
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.5.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.5.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.5.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.5.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.5 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.5-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count and createdmodseq to index header, savedate and createdmodseq to index records
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.6.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.6.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.6.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.6.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,67 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.6 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.6-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.7.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.7.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.7.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.7.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,75 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.7 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.7-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+Security fixes
+==============
+* Contains fix for `CVE-2017-14230 <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.8.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.8.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.8.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.8.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,92 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.8 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.8-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+.. XXX explicate JMAP support properly, not just "Support for JMAP"
+  * Support for RFCxyz JMAP Core and Email standards
+  * Experimental support for JMAP Calendar, Contacts, ... extensions
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.9.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.9.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.9.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.1/x/3.1.9.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,97 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.9 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.9-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP core protocol (:rfc:`8620`).
+* Support for JMAP Mail (:rfc:`8621`).
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`).
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`).
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames).
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/index.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/index.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/index.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/index.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-release-notes-3.2:
+
+=============================
+Cyrus IMAP 3.2 Releases
+=============================
+
+.. toctree::
+    :maxdepth: 1
+    :glob:
+
+    x/?.?.*-beta*
+    x/?.?.*-rc*
+    x/?.?.?
+    x/?.?.??
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta1.txt	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,113 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta1 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz.sig
+
+.. _relnotes-3.2.0-beta1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta2.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta2.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta2.txt	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,113 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta2 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz.sig
+
+.. _relnotes-3.2.0-beta2-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta3.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta3.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta3.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta3.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,123 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta3 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz.sig
+
+.. _relnotes-3.2.0-beta3-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta4.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta4.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta4.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-beta4.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,126 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta4 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz.sig
+
+.. _relnotes-3.2.0-beta4-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-rc1.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-rc1.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-rc1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0-rc1.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,126 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-rc1 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz.sig
+
+.. _relnotes-3.2.0-rc1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/3.2/x/3.2.0.txt	2020-05-04 04:02:14.000000000 +0000
@@ -0,0 +1,121 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0 Release Notes
+====================================
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz.sig
+
+.. _relnotes-3.2.0-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/release-notes/index.txt 3.2.0-3/doc/html/_sources/imap/download/release-notes/index.txt
--- 3.0.13-5/doc/html/_sources/imap/download/release-notes/index.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/release-notes/index.txt	2020-05-04 04:02:14.000000000 +0000
@@ -2,12 +2,12 @@
 Release Notes
 =============
 
-Cyrus has switched to an `odd-even release cycle <http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy>`_.
+Cyrus uses an `odd-even release cycle <http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy>`_.
 
-With our versioning system using ``major.minor.micro`` numbering, the minor number
-reveals whether a version is stable (even), or development-only (odd).
+With our versioning system using ``major.minor.micro`` numbering, the minor (middle)
+number reveals whether a version is stable (even), or development-only (odd).
 
-A 3.0.1 release is stable, but a 3.1.4 release is developmental only.
+A 3.\ **0**\ .1 release is stable, but a 3.\ **1**\ .4 release is developmental only.
 
 Stable Version
 ==============
@@ -22,14 +22,25 @@ Latest development snapshot is |imap_dev
 
 .. warning::
 
-    These are tagged snapshots of the master branch, and should be considered for
-    **testing purposes** and **bleeding-edge features** only. We will try to tag these
-    snapshots at coherent development points, but there will generally be **large
-    breaking changes** occurring between releases in this series.
+    Development versions are tagged snapshots of the master branch, and should
+    be considered for **testing purposes** and **bleeding-edge features** only.
+    We will try to tag these snapshots at coherent development points, but
+    there will generally be **large breaking changes** occurring between
+    releases in this series.
 
 Supported Product Series
 ========================
 
+Series 3.2
+----------
+
+Documentation at :cyrus-3.2:`/`.
+
+.. toctree::
+    :maxdepth: 1
+
+    3.2/index
+
 Series 3.0
 ----------
 
@@ -37,7 +48,6 @@ Documentation at :cyrus-3.0:`/`.
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     3.0/index
 
@@ -48,20 +58,17 @@ Documentation at :cyrus-2.5:`/`.
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     2.5/index
 
-Series 2.4
-----------
+Development snapshots
+=====================
 
 .. toctree::
     :maxdepth: 1
-    :glob:
-
-    2.4/index
-    2.4-dav/index
 
+    3.3/index
+    3.1/index
 
 Older Versions
 ==============
@@ -71,27 +78,18 @@ Series 1
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     1/1.x.x
 
-Series 2: 2.0 - 2.3
+Series 2: 2.0 - 2.4
 -------------------
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     2.0/2.0.x
     2.1/2.1.x
     2.2/2.2.x
     2.3/index
-
-
-.. toctree::
-    :hidden:
-
     2.4/index
     2.4-dav/index
-    2.5/index
-    3.0/index
diff -pruN 3.0.13-5/doc/html/_sources/imap/download/upgrade.txt 3.2.0-3/doc/html/_sources/imap/download/upgrade.txt
--- 3.0.13-5/doc/html/_sources/imap/download/upgrade.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/download/upgrade.txt	2020-05-04 04:02:14.000000000 +0000
@@ -1,7 +1,9 @@
+.. highlight:: none
+
 .. _upgrade:
 
 ================
-Upgrading to 3.0
+Upgrading to 3.2
 ================
 
 .. note::
@@ -27,24 +29,24 @@ Things to consider **before** you begin:
 Installation from tarball
 #########################
 
-You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren't able to test all platforms: you may find you need to install additional or different libraries to support v3.0.
+You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren't able to test all platforms: you may find you need to install additional or different libraries to support v3.2.
 
 How are you planning on upgrading?
 ##################################
 
-Ideally, you will do a sandboxed test installation of 3.0 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.0 installation.
+Ideally, you will do a sandboxed test installation of 3.2 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.2 installation.
 
 Upgrade by replicating
 ~~~~~~~~~~~~~~~~~~~~~~
 
 If you're familiar with replication, and your current installation is 2.4 or
 newer, you can set up your existing installation to replicate data to a new
-3.0 installation and failover to the new installation when you're ready. The
+3.2 installation and failover to the new installation when you're ready. The
 replication protocol has been kept backwards compatible.
 
 If your old installation contains mailboxes or messages that are older than
 2.4, they may not have GUID fields in their indexes (index version too old),
-or they may have their GUID field set to zero.  3.0 will not accept message
+or they may have their GUID field set to zero.  3.2 will not accept message
 replications without valid matching GUIDs, so you need to fix this on your
 old installation first.
 
@@ -69,9 +71,28 @@ Upgrade in place
 If you are upgrading in place, you will need to shut down Cyrus
 entirely while you install the new package.  If your old installation
 was using Berkeley DB format databases, you will need to convert or
-upgrade the databases **before** you upgrade.  Cyrus v3.0 does not
+upgrade the databases **before** you upgrade.  Cyrus v3.2 does not
 support Berkeley DB at all.
 
+.. note::
+
+    If you are upgrading from Cyrus version 2.5 or earlier,
+    and your system is configured with the following combination
+    in :cyrusman:`imapd.conf(5)`::
+
+        fulldirhash: yes
+        hashimapspool: either yes or no
+        unixhierarchysep: yes
+
+    then you will not be able to upgrade-in-place.  This is due to
+    a change in how directory hashes are calculated for users whose
+    localpart contains a dot, which was introduced in 3.0.0.  After
+    an in-place upgrade, Cyrus will not be able to find these users'
+    metadata and/or mailboxes.
+
+    If you have this configuration, you will need to upgrade by
+    replicating, not in place.
+
 Do What As Who?
 ###############
 
@@ -95,10 +116,10 @@ commands, such as ``rsync`` or ``scp``.
 
 We strongly recommend that you read this entire document before upgrading.
 
-2. Install new 3.0 Cyrus
+2. Install new 3.2 Cyrus
 ------------------------
 
-Download the release :ref:`3.0 package tarball <getcyrus>`.
+Download the release :ref:`3.2 package tarball <getcyrus>`.
 
 Fetch the libraries for your platform. The full list (including all optional packages) for Debian is::
 
@@ -143,7 +164,7 @@ We recommend backing up all your data be
 * Mail spool
 * :ref:`Cyrus Databases <databases>`
 
-(You do already have a backup strategy in place, right? Once you're on 3.0, you can
+(You do already have a backup strategy in place, right? Once you're on 3.2, you can
 consider using the experimental :ref:`backup tools <cyrus-backups>`.)
 
 Copy all of this to the new instance, using ``rsync`` or similar tools.
@@ -163,7 +184,7 @@ server)::
     rsync -aHv oldimap:/var/lib/cyrus/. /var/lib/cyrus/.
     rsync -aHv oldimap:/var/spool/cyrus/. /var/spool/cyrus/.
 
-You don't need to copy the following databases as Cyrus 3.0 will
+You don't need to copy the following databases as Cyrus 3.2 will
 recreate these for you automatically:
 
 * duplicate delivery (deliver.db),
@@ -212,8 +233,9 @@ you have provided overrides for in your
     cyr_info conf-all -C <path to imapd.conf> -M <path to cyrus.conf>
 
 **Important config** options: ``unixhierarchysep:`` and ``altnamespace:``
-defaults have changed in :cyrusman:`imapd.conf(5)`. Implications are
-outlined in the Note in :ref:`imap-admin-namespaces-mode` and
+defaults in :cyrusman:`imapd.conf(5)` changed in 3.0, which will affect you
+if you are upgrading to 3.2 from something earlier than 3.0. Implications
+are outlined in the Note in :ref:`imap-admin-namespaces-mode` and
 :ref:`imap-switching-alt-namespace-mode`.  Please also see "Sieve Scripts,"
 below.
 
@@ -236,34 +258,14 @@ DAEMON section.
    directive(s), you can convert these to per-user special-use annotations
    in your new install with the :cyrusman:`cvt_xlist_specialuse(8)` tool
 
-* Sieve Scripts
-
-    Since defaults for options: ``unixhierarchysep:`` and
-    ``altnamespace:`` have changed in :cyrusman:`imapd.conf(5)`, you
-    may very likely need to modify any sieve scripts already on your
-    system.  Fear not, there's a tool for this task, called
-    :cyrusman:`translatesieve(8)`.  This tool can handle situations
-    where either or both of these settings need change. Please consult
-    the man page for details.
-
-    Consider the following example, where the prior configuration was
-    already using ``altnamespace: on``, but was *not* using
-    ``unixhierarchysep: on``::
-
-        # su cyrus -c "/usr/lib/cyrus/upgrade/translatesieve -a"
-        you are using /var/lib/imap/sieve as your sieve directory.
-        translating sievedir /var/lib/imap/sieve... converting separator from '.' to '/'
-        not changing name space.
-        done
-
 .. warning::
 
-    **Berkeley db format no longer supported**
+    **Berkeley db format no longer supported since 3.0**
 
     If you have any databases using Berkeley db, they'll need to be
     converted to skiplist or flat *in your existing installation*. And
     then optionally converted to whatever final format you'd like in
-    your 3.0 installation.
+    your 3.2 installation.
 
     Databases potentially affected: mailboxes, annotations, conversations, quotas.
 
@@ -271,15 +273,15 @@ DAEMON section.
 
        cvt_cyrusdb /<configdirectory>mailboxes.db berkeley /tmp/new-mailboxes.db skiplist
 
-    If you don't want to use flat or skiplist for 3.0, you can use the
-    new 3.0 :cyrusman:`cvt_cyrusdb(8)` to swap to new format::
+    If you don't want to use flat or skiplist for 3.2, you can use the
+    new 3.2 :cyrusman:`cvt_cyrusdb(8)` to swap to new format::
 
        cvt_cyrusdb /tmp/new-mailboxes.db skiplist /<configdirectory>/mailboxes.db <new file format>
 
 .. note::
     The :cyrusman:`cvt_cyrusdb(8)` command does not accept relative paths.
 
-7. Start new 3.0 Cyrus and verify
+7. Start new 3.2 Cyrus and verify
 ---------------------------------
 
 ::
@@ -288,12 +290,12 @@ DAEMON section.
 
 Check ``/var/log/syslog`` for errors so you can quickly understand potential problems.
 
-When you're satisfied version 3.0 is running and can see all its data correctly,
+When you're satisfied version 3.2 is running and can see all its data correctly,
 start the new Cyrus up with your regular init script.
 
 If something has gone wrong, contact us on the :ref:`mailing list <feedback-mailing-lists>`.
 You can revert to backups and keep processing mail using your old version
-until you're able to finish your 3.0 installation.
+until you're able to finish your 3.2 installation.
 
 .. note::
 
@@ -304,15 +306,6 @@ until you're able to finish your 3.0 ins
 8. Reconstruct databases and cache
 ----------------------------------
 
-.. warning::
-
-    Versions of 3.0 prior to 3.0.11 contained a bug (:issue:`2389`) that
-    could lead to loss of seen state/flags during `reconstruct` for some
-    messages that already existed prior to Cyrus 2.3.  The :ref:`3.0.11
-    release notes <relnotes-3.0.11-changes>` contain the specifics.
-
-    Consider upgrading to 3.0.11 rather than an earlier release.
-
 The following steps can each take a long time, so we recommend
 running them one at a time (to reduce locking contention and high I/O load).
 
@@ -322,7 +315,8 @@ To upgrade all the mailboxes to the late
 
     reconstruct -V max
 
-New configuration: if turning on conversations, you need to create conversations.db for each user.::
+New configuration: if turning on conversations, you need to create conversations.db for each user.
+(This is required for jmap).::
 
      ctl_conversationsdb -b -r
 
@@ -335,16 +329,28 @@ databases need to be reconstructed due t
 
     dav_reconstruct -a
 
+If you are upgrading from 3.0, and have the `reverseacls` feature enabled
+in :cyrusman:`imapd.conf(5)`, you may need to regenerate the data it uses
+(which is stored in `mailboxes.db`).  This is automatically regenerated at
+startup by `ctl_cyrusdb -r` if the `reverseacls` setting has changed. So,
+to force a regeneration:
+
+    1. Shut down Cyrus
+    2. Change `reverseacls` to `0` in :cyrusman:`imapd.conf(5)`
+    3. Run :cyrusman:`ctl_cyrusdb(8)` with the `-r` switch (or just start
+       Cyrus, assuming your :cyrusman:`cyrus.conf(5)` contains a
+       `ctl_cyrusdb -r` entry in the START section).  The old RACL entries
+       will be removed
+    4. (If you started Cyrus, shut it down again)
+    5. Change `reverseacls` back to `1`
+    6. Start up Cyrus (or run `ctl_cyrusdb -r`).  The RACL entries will
+       be rebuilt
+
 9. Do you want any new features?
 --------------------------------
 
-3.0 comes with many lovely new features. Consider which ones you want to enable.
-Here are some which may interest you. Check the :ref:`3.0 release notes <imap-release-notes-3.0>`
-for the full list.
-
-* :ref:`Backups <cyrus-backups>`
-* :ref:`Xapian for searching <imapinstall-xapian>`
-* Cross-domain support. See ``crossdomains`` in :cyrusman:`imapd.conf(5)`
+3.2 comes with many lovely new features. Consider which ones you want to enable.
+Check the :ref:`3.2 release notes <imap-release-notes-3.2>` for the full list.
 
 10. Upgrade complete
 --------------------
@@ -353,9 +359,9 @@ Your upgrade is complete! We have a supe
 anonymous responses) we would love for you to fill out, so we can get a feel for
 how many Cyrus installations are out there, and how the upgrade process went.
 
-|3.0 survey link|
+|3.2 survey link|
 
-.. |3.0 survey link| raw:: html
+.. |3.2 survey link| raw:: html
 
     <a href="https://cyrusimap.typeform.com/to/YI9P0f" target="_blank">
     I'll fill in the survey right now</a> (opens in a new window)
@@ -374,9 +380,9 @@ upgrade all your back end servers first.
 Upgrade your mupdate master and front ends last.
 
 If you are upgrading from 2.4, and wish to use XFER to transfer your
-mailboxes to your new 3.0 server, please consider first upgrading your
+mailboxes to your new 3.2 server, please consider first upgrading your
 2.4 setup to version 2.4.19 or later.  Earlier versions of 2.4 do not
-correctly recognise the 2.5 and 3.0 mailbox versions, and will
+correctly recognise the 2.5 and later mailbox versions, and will
 downgrade mailboxes (losing metadata) in transit.  2.4.19 and later
-versions correctly recognise 2.5 and 3.0 servers, and will not
+versions correctly recognise 2.5 and later servers, and will not
 downgrade mailbox versions in transit.
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/access-control/identifiers.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/access-control/identifiers.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/access-control/identifiers.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/access-control/identifiers.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ distinguished be the prefix "group:".  F
 
 .. todo:: FIXME: Clarify what an ACL entry looks like first. Refer to
           how user login names are translated into their identifiers, and (in
-          that section) refer to altnamespace, unixhiersep, default domain,
+          that section) refer to altnamespace, unixhierarchysep, default domain,
           virtdomains, sasl_auth_mech tips and tricks etc.
 
 There are two special identifiers, "anonymous", and "anyone", which are
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/locations/configuration-state.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/locations/configuration-state.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/locations/configuration-state.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/locations/configuration-state.txt	2020-04-24 02:03:00.000000000 +0000
@@ -174,10 +174,6 @@ settings in :cyrusman:`imapd.conf(5)`:
 	:start-after: startblob notifysocket
 	:end-before: endblob notifysocket
 
-.. include:: /imap/reference/manpages/configs/imapd.conf.rst
-	:start-after: startblob sphinx_socket
-	:end-before: endblob sphinx_socket
-
 Per-user State Directories
 ==========================
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/locations/searchtiers.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/locations/searchtiers.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/locations/searchtiers.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/locations/searchtiers.txt	2020-04-24 02:03:00.000000000 +0000
@@ -18,7 +18,7 @@ setting:
         :start-after: startblob defaultsearchtier
         :end-before: endblob defaultsearchtier
 
-Search Tier Partition location
+Search Tier Partition Location
 ------------------------------
 
 Each search tier to be used requires a partition location be specified
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/monitoring.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/monitoring.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/monitoring.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/monitoring.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,50 @@
+.. _imap-admin-monitoring:
+
+==========
+Monitoring
+==========
+
+Cyrus IMAP supports monitoring using Prometheus_.
+
+To use this functionality, Cyrus IMAP must have been built with the
+``--enable-http`` configure option enabled.
+
+.. _imap-admin-monitoring-setup:
+
+Setup
+=====
+
+    * Set the `prometheus_enabled` setting in :cyrusman:`imapd.conf(5)` to "yes"
+    * Add the `prometheus` module to your `httpmodules` in :cyrusman:`imapd.conf(5)`
+    * Set the `prometheus_need_auth`, `prometheus_update_freq` and `prometheus_stats_dir`
+      settings in :cyrusman:`imapd.conf(5)` to taste
+    * Add a job to run ``promstatsd -c`` to the START section of :cyrusman:`cyrus.conf(5)`
+      (this cleans up the stats files from the previous run)
+    * Add a job to run ``promstatsd`` to the DAEMON section of :cyrusman:`cyrus.conf(5)`
+      (the actual daemon process)
+    * Configure your Prometheus server to scrape http://yourserver.example.com/metrics
+
+Configuration options
+=====================
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_enabled
+        :end-before: endblob prometheus_enabled
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_need_auth
+        :end-before: endblob prometheus_need_auth
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_update_freq
+        :end-before: endblob prometheus_update_freq
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_stats_dir
+        :end-before: endblob prometheus_stats_dir
+
+.. _imap-admin-monitoring-end:
+
+Back to :ref:`imap-admin`
+
+.. _Prometheus: https://prometheus.io
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/murder/murder-failure-modes.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/murder/murder-failure-modes.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/murder/murder-failure-modes.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/murder/murder-failure-modes.txt	2020-04-24 02:03:00.000000000 +0000
@@ -38,7 +38,7 @@ Don't have a backup? Well it is still ea
 4. Start everything backup
 5. Use ctl_mboxlist -m on each backend to update the murder master with any missing changes.
 
-If you are using skiplist for your mailboxes.db then you can just copy the file. If you are using a berkeley format then things are trickier since there is environmental state. It should be possible to run db_recover on both databases, then delete the db folder the mailboxes.db from the murder master and copy those from the frontend (this has not been tested)
+If you are using skiplist for your mailboxes.db then you can just copy the file.
 
 Hard recovery
 -------------
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/ports/sockets.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/ports/sockets.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/ports/sockets.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/ports/sockets.txt	2020-04-24 02:03:00.000000000 +0000
@@ -22,7 +22,6 @@ directory for Cyrus sockets. This defaul
     idle      <rundir>/idle   # idled daemon socket
     notify    <rundir>/notify # Notification daemon socket
     ptloader  <rundir>/ptsock # PT Loader socket (alternative authorization)
-    sphinx    <rundir>/sphinx # Sphinx full-text search daemon socket
 
 .. _imap-admin-sock-end:
 
@@ -47,7 +46,3 @@ sites, via the use of several settings i
 .. include:: /imap/reference/manpages/configs/imapd.conf.rst
 	:start-after: startblob ptloader_sock
 	:end-before: endblob ptloader_sock
-
-.. include:: /imap/reference/manpages/configs/imapd.conf.rst
-	:start-after: startblob sphinx_socket
-	:end-before: endblob sphinx_socket
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/sieve.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/sieve.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/sieve.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/sieve.txt	2020-04-24 02:03:00.000000000 +0000
@@ -180,6 +180,12 @@ Sieve has a lot of `extensions <http://w
 * Date :rfc:`5260`
 * Index :rfc:`5260`
 * Variables :rfc:`5229`
+* Editheader Extension :rfc:`5293`
+* Reject and Extended Reject :rfc:`5429`
+* Externally Stored Lists :rfc:`6134`
+* Duplicate Extension :rfc:`7352`
+* Ihave Extension :rfc:`5463`
+* Delivering to Special-Use Mailboxes `Draft special-use RFC <http://tools.ietf.org/html/draft-bosch-sieve-special-use-01>`_
 * IMAP flag Extension `Draft imap flags RFC <http://tools.ietf.org/html/draft-ietf-sieve-imapflags-05>`_
 * Body Extension :rfc:`5173`
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/mailbox-quota.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/mailbox-quota.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/mailbox-quota.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/mailbox-quota.txt	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 Mailbox Folders exempt from quota
 ---------------------------------
 
-By creating an additional quota root, a folder's contents can be made excempt from counting towards the mailbox's quota.
+By creating an additional quota root, a folder's contents can be made exempt from counting towards the mailbox's quota.
 
 .. note::
     Making an INBOX/Archive/ Folder exempt from quota: ::
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/replication.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/replication.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/replication.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/replication.txt	2020-04-24 02:03:00.000000000 +0000
@@ -314,7 +314,7 @@ EVENTS section of :cyrusman:`cyrus.conf(
 
     EVENTS {
         <...>
-        # Peridoically sync ALL user mailboxes every 4 hours
+        # Periodically sync ALL user mailboxes every 4 hours
         syncclient       cmd="/usr/cyrus/bin/sync_client -A" period=240
 
         # Periodically sync changes at specific times
@@ -400,7 +400,7 @@ exercise::
     offsitesync     cmd="/usr/cyrus/bin/sync_client -r -n offsite"
 
 Again, this is just an example for illustration.  The system provides so
-much flexibility, and one can combine channels with chaining to acheive
+much flexibility, and one can combine channels with chaining to achieve
 even more.
 
 .. _replication-other-uses:
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/userdeny.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/userdeny.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/sop/userdeny.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/sop/userdeny.txt	2020-04-08 00:07:13.000000000 +0000
@@ -3,6 +3,8 @@ Managing user_deny.db
 
 The user_deny database allows you to deny access via POP/IMAP even if the user can authenticate to the Cyrus server. For example, if the authentication data is also used for other network services.
 
+Use :cyrusman:`cyr_deny(8)` to manage the database.
+
 If the user_deny.db file doesn't exist in %configdirectory% (often /var/lib/imap) then you'll need to create it. In the example below, /var/lib/imap/ is used.
 
 ::
@@ -11,18 +13,14 @@ If the user_deny.db file doesn't exist i
     # /usr/lib/cyrus-imapd/cvt_cyrusdb /tmp/user_deny.flat flat /var/lib/imap/user_deny.db skiplist
     # chown cyrus:cyrus /var/lib/imap/user_deny.db
 
-The database specification can be found at http://cyrusimap.org/docs/cyrus-imapd/2.4.17/internal/database-formats.php
-
-**Key:** <Userid>
-
-**Data:** <Version>TAB<Deny List (comma-separated wildmat patterns)>TAB<Deny Message>
+The database specification can be found at :ref:`imap-concepts-deployment-db-userdeny`.
 
 ::
 
     # su - cyrus
-    $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2     pop3    Can't use pop."
+    $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2<tab>pop3<tab>Can't use pop."
 
-In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.
+Here `pop3` is the service name as spelled in :cyrusman:`cyrus.conf(5)`.  In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.
 
 If you got it right, when you authenticate via pop3 you should see something like the following::
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin/tweaking.txt 3.2.0-3/doc/html/_sources/imap/reference/admin/tweaking.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin/tweaking.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin/tweaking.txt	2020-04-24 02:03:00.000000000 +0000
@@ -137,4 +137,28 @@ To gain performance, execute the followi
 
         CHATTRSYNC=0
 
-.. _dm-cache: http://en.wikipedia.org/wiki/Dm-cache
\ No newline at end of file
+.. _dm-cache: http://en.wikipedia.org/wiki/Dm-cache
+
+
+Mailbox locking
+---------------
+Cyrus IMAP uses fcntl(2) based file locking for mailboxes, for example during
+SELECT commands. To mitigate race conditions it locks mailbox names even
+for non-existing mailboxes. For example, if user foo issued the following
+command
+
+    .. parsed-literal::
+
+       SELECT INBOX.x
+
+for non-existing mailbox x, it creates a lock file
+
+    .. parsed-literal::
+
+       $CYRUS_CONFDIR/lock/user/foo/x.lock
+
+which might be left on the filesystem after completion of the command.
+
+This has in practice not shown to be an issue. If this is a concern however,
+keeping the lock file directory in a tmpfs allows for both fast locking and
+to purge stale locks during controlled Cyrus downtimes.
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/administration-tools.txt 3.2.0-3/doc/html/_sources/imap/reference/administration-tools.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/administration-tools.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/administration-tools.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,86 +0,0 @@
-Tools & Utilities
------------------
-
-arbitron
-++++++++
-
-arbitronsort.pl
-+++++++++++++++
-
-chk_cyrus
-+++++++++
-
-ctl_cyrusdb
-+++++++++++
-
-ctl_deliver
-+++++++++++
-
-ctl_mboxlist
-++++++++++++
-
-cvt_cyrusdb
-+++++++++++
-
-cvt_cyrusdb_all
-+++++++++++++++
-
-cyr_dbtool
-++++++++++
-
-cyr_df
-++++++
-
-cyrdump
-+++++++
-
-cyr_expire
-++++++++++
-
-cyr_virusscan
-+++++++++++++
-
-Tool to disinfect mailboxes by operation of external virus scanning
-library or provided IMAP SEARCH string.
-
-fetchnews
-+++++++++
-
-cyr_sequence
-++++++++++++
-
-cyr_synclog
-+++++++++++
-
-cyr_userseen
-++++++++++++
-
-masssievec
-++++++++++
-
-Script to mass compile Sieve scripts
-
-mbexamine
-+++++++++
-
-mbpath
-++++++
-
-mkimap
-++++++
-
-mknewsgroups
-++++++++++++
-
-rehash
-++++++
-
-translatesieve
-++++++++++++++
-
-script to translate sieve scripts to use unixhierarchysep and/or altnamespace
-
-undohash
-++++++++
-
-absolutely ancient (downgrade to prior 1.6.2+), probably should be obsoleted entirely
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/admin.txt 3.2.0-3/doc/html/_sources/imap/reference/admin.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/admin.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/admin.txt	2020-04-24 02:03:00.000000000 +0000
@@ -28,6 +28,7 @@ Management
     admin/protlayer
     admin/sop
     admin/eventsource    
+    admin/monitoring
     admin/config-mailboxdistribution
     admin/murder/murder
     admin/nginx-proxy
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/feature-database-backend.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/feature-database-backend.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/feature-database-backend.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/feature-database-backend.txt	2020-04-24 02:03:00.000000000 +0000
@@ -3,10 +3,6 @@ Which database backend should I use for
 
 Here's a brief summary of the major database types:
 
-* **Berkeley DB**: Slow enumeration, fast random access, fast write, binary support. However, it has proved to be somewhat unstable and prone to locking problems.
-
-* **Berkeley DB (no sync)**: Slow enumeration, fast random access, very fast write, binary support, but no guarantee of database durability; recent writes can be lost on crashes.
-
 * **Skiplist**: Proprietary Cyrus Format, fast enumeration, moderately fast write, moderately fast random access, binary support
 
 * **Flat**: Easy to maintain format, fast enumeration, very slow write, moderate random access, no binary support
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/install-detecting-berkeley.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/install-detecting-berkeley.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/install-detecting-berkeley.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/install-detecting-berkeley.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,10 +0,0 @@
-Problems detecting Berkley DB on Red Hat Linux
-----------------------------------------------
-
-Modern Redhat Linux ships with a Berkeley DB compiled 
-``--with-pthreads``, which Cyrus is unable to directly link against. 
-
-You can either recompile Berkeley DB without pthread support, or you can 
-add ``-lpthread`` to your LDFLAGS environment variable before you 
-configure/build. 
-
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/install-linkerwarnings.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/install-linkerwarnings.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/install-linkerwarnings.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/install-linkerwarnings.txt	2020-04-24 02:03:00.000000000 +0000
@@ -27,15 +27,3 @@ from the linker like the following:
 
 In this case, ClamAV is still linked against OpenSSL 1.0, while Cyrus is
 building with OpenSSL 1.1.
-
-.. _libical-warnings:
-
-Libical v1.0.1 or v2.0
-----------------------
-
-You may see warnings regarding libical v2.0 being recommended to support certain
-functionality. Currently libical v1.0.1 is sufficient, unless you need/want
-RSCALE (non-gregorian recurrences), VPOLL (consensus scheduling), or
-VAVAILABILITY (specifying availability over time) functionality. If v2 is
-required, it will need to be installed from `github
-<https://github.com/libical/libical>`_.
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/interop-slow-delivery.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/interop-slow-delivery.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/interop-slow-delivery.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/interop-slow-delivery.txt	2020-04-24 02:03:00.000000000 +0000
@@ -9,7 +9,7 @@ There are a number of things that can af
     
     3. Slow dns. Some MTAs (like sendmail) talk to dns a lot. If dns is slow, mail delivery appears slow. We run named on each Cyrus machine 
     
-    4. Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and dissapear. Sometimes it just hangs. Not sure why, but restarting may help.
+    4. Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and disappear. Sometimes it just hangs. Not sure why, but restarting may help.
 
 If you have a large volume of mail then :ref:`Cyrus Murder Mail Delivery 
 <murder-mail-delivery>` has some tips. 
@@ -18,6 +18,5 @@ We experienced some filesystem locking p
 lmtpd-processes to be started. Performance was seriously degraded, 
 resulting in timeouts and endless retries. We use a postfix instance 
 between to limit parallel deliveries to lmtpd resulting in much higher 
-throughput. With berkeley-nosync as duplicate suppression db, 50-100 
-Messages/sec are doable. 
+throughput.
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-annotations.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-annotations.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-annotations.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-annotations.txt	2020-04-24 02:03:00.000000000 +0000
@@ -3,46 +3,89 @@
 What annotations are available?
 -------------------------------
 
-Cyrus annotations are based on a draft (http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08) version of :rfc:`5464`.
+Cyrus annotations are based on a draft
+(http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08) version of
+:rfc:`5464`.
 
-* **/admin** - Sets the administrator email address for the server. (See :cyrusman:`cyradm(8)`)
+* **/admin** - Sets the administrator email address for the server. (See
+  :cyrusman:`cyradm(8)`)
 
-* **/check** - Boolean value "true" or "false" that indicates whether this mailbox should be checked at regular intervals by the client. The interval in minutes is specified by the ``/checkperiod`` entry. (Draft RFC)
+* **/check** - Boolean value "true" or "false" that indicates whether this
+  mailbox should be checked at regular intervals by the client. The interval
+  in minutes is specified by the ``/checkperiod`` entry. (Draft RFC)
 
-* **/checkperiod** - Numeric value indicating a period of minutes that the client uses to determine the interval of regular 'new mail' checks for the corresponding mailbox. (Draft RFC)
+* **/checkperiod** - Numeric value indicating a period of minutes that the
+  client uses to determine the interval of regular 'new mail' checks for the
+  corresponding mailbox. (Draft RFC)
 
-* **/comment** - Sets a comment or description associated with the mailbox. (cyradm(8)) /motd - Sets a "message of the day". The message gets displayed as an ALERT after authentication.
+* **/comment** - Sets a comment or description associated with the mailbox.
+  (cyradm(8))
 
-* **/sort** - Defines the default sort criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if sorting is not required. (Draft RFC)
+* **/motd** - Sets a "message of the day". The message gets displayed
+  as an ALERT after authentication.
 
-* **/thread** - Defines the default thread criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if threading is not required. If both sort and thread are not NIL, then threading should take precedence over sorting. (Draft RFC)
+* **/sort** - Defines the default sort criteria [I-D.ietf-imapext-sort] to use
+  when first displaying the mailbox contents to the user, or NIL if sorting is
+  not required. (Draft RFC)
 
-* **/vendor/cmu/cyrus-imapd/condstore** - Enables the IMAP CONDSTORE extension (modification sequences) on the mailbox. (See :cyrusman:`cyradm(8)`)
+* **/thread** - Defines the default thread criteria [I-D.ietf-imapext-sort] to
+  use when first displaying the mailbox contents to the user, or NIL if
+  threading is not required. If both sort and thread are not NIL, then
+  threading should take precedence over sorting. (Draft RFC)
 
-* **vendor/cmu/cyrus-imapd/duplicatedeliver** - Flag signalling that we're allowing duplicate delivery of messages to the mailbox, overriding system-wide duplicate suppression. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/condstore** - Enables the IMAP CONDSTORE extension
+  (modification sequences) on the mailbox. (See :cyrusman:`cyradm(8)`)
 
-* **/vendor/cmu/cyrus-imapd/expire** - Sets the number of days after which messages will be expired from the mailbox. (cyradm(8))
+* **vendor/cmu/cyrus-imapd/duplicatedeliver** - Flag signalling that we're
+  allowing duplicate delivery of messages to the mailbox, overriding
+  system-wide duplicate suppression.
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/freespace** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/expire** - Sets the number of days after which
+  messages will be expired from the mailbox. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/lastpop** - (time_t) of the last pop3 login to this INBOX, used to enforce the "poptimeout" imapd.conf option. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/archive** - Sets the number of days after which
+  messages will be archived from the mailbox. (cyradm(8))
 
-* **vendor/cmu/cyrus-imapd/lastupdate** - (time_t) of the last time a message was appended (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/delete** - Sets the number of days after which
+  messages will be deleted from the mailbox. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/news2mail** - Sets an email address to which messages injected into the server via NNTP will be sent. (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/freespace** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/partition** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/lastpop** - (time_t) of the last pop3 login to
+  this INBOX, used to enforce the "poptimeout" imapd.conf option.
+  (:ref:`imap-developer-guidance-mailbox-format`)
+
+* **vendor/cmu/cyrus-imapd/lastupdate** - (time_t) of the last time a message
+  was appended
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/pop3newuidl** - Flag signalling that we're using "uidvalidity.uid" instead of just "uid" for the output of the POP3 UIDL command. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/news2mail** - Sets an email address to which
+  messages injected into the server via NNTP will be sent. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/serve** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/partition** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/sharedseen** - Enables the use of a shared \Seen flag on messages rather than a per-user \Seen flag. The ’s’ right in the mailbox ACL still controls whether a user can set the shared \Seen flag. (See :cyrusman:`cyradm(8)`)
+* **/vendor/cmu/cyrus-imapd/pop3newuidl** - Flag signalling that we're using
+  "uidvalidity.uid" instead of just "uid" for the output of the POP3 UIDL
+  command.
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/shutdown** - Sets a shutdown message. The message gets displayed as an ALERT and all users are disconnected from the server (subsequent logins are disallowed). (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/serve** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/sieve** - Indicates the name of the global sieve script that should be run when a message is delivered to the shared mailbox (not used for personal mailboxes). (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/sharedseen** - Enables the use of a shared \Seen
+  flag on messages rather than a per-user \Seen flag. The ’s’ right in the
+  mailbox ACL still controls whether a user can set the shared \Seen flag.
+  (See :cyrusman:`cyradm(8)`)
+
+* **/vendor/cmu/cyrus-imapd/shutdown** - Sets a shutdown message. The message
+  gets displayed as an ALERT and all users are disconnected from the server
+  (subsequent logins are disallowed). (cyradm(8))
+
+* **/vendor/cmu/cyrus-imapd/sieve** - Indicates the name of the global sieve
+  script that should be run when a message is delivered to the shared mailbox
+  (not used for personal mailboxes). (cyradm(8))
 
 * **/vendor/cmu/cyrus-imapd/size** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/squat** - Indicates that the mailbox should have a squat index created for it. (See :cyrusman:`squatter(8)`)
\ No newline at end of file
+* **/vendor/cmu/cyrus-imapd/squat** - Indicates that the mailbox should be
+  indexed. (See :cyrusman:`squatter(8)`)
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-berkeleydb.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-berkeleydb.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-berkeleydb.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-berkeleydb.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-Why does ctl_cyrusdb -r take so long with Berkeley DB?
-------------------------------------------------------
-
-Berkeley DB maintains a log of all the transactions since the last 
-checkpoint of the database. In order to ensure the database is in a 
-consistent state, you must recover the log after any outage (thus the 
-recommendation to run these processes when Cyrus starts). They can take 
-a long time for a few reasons. 
-
-The most common one is that you need to checkpoint the cyrusdb more 
-often. This can be done with a simple ``ctl_cyrusdb -c``. If you do this 
-very often, the amount of log that needs to be recovered will be 
-significantly shorter. We recommend doing this at least once every half 
-hour, and more often on busy sites. 
-
-The other reason is that your :ref:`deliver.db may be very large <faq-o-deliberdb-size>`. This is 
-solvable by increasing the pruning interval (the -E parameter to 
-ctl_deliver, which you should run on a regular basis), or (in a pinch) 
-by just removing the database (since the effects of losing it do not 
-prevent operation, they just cause vacation messages to be resent, and 
-duplicate delivery suppression to possibly deliver duplicates). 
-
-* "by increasing the pruning interval": My understanding is that the 
-   number after "-E" is the number of days after which entries are 
-   discarded. Is there a way to reduce it to a number of hours? Since most 
-   of our mail is internal mail should rarely be delayed by more then an 
-   hour or two. 
-
-* In case it's useful to anyone we discovered that moving /var/lib/imap 
-   from an ext2 to an ext3 journaled filesystem made a vast difference for 
-   the worse. While recovering the database Berkeley DB does a vast 
-   quantity of small writes and that combined with the updates to the 
-   journal absolutely kills disk performance (with journalling it was 
-   taking about 40 minutes to start Cyrus on a mail server with about 500 
-   users and 200G of mail). On the flip side moving /var/lib/imap to a 
-   hardware RAID system with a decent amount of onboard cache reduced this 
-   time to under 30 seconds. I think Berkeley DB could probably be 
-   optimized to deal with this better, but in the mean time avoid 
-   journaling filesystems, or at least be prepared to experiment to find 
-   something that works for you. 
-
-
-
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-db3-lockers.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-db3-lockers.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-db3-lockers.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-db3-lockers.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-Is the "db3: x Lockers" log message harmful?
---------------------------------------------
-
-This message is generally not harmful unless it is increasing at an 
-alarming rate or you are seeing other performance problems. It indicates 
-contention within a Berkeley DB database page, and especially on small 
-databases will occur quite frequently. 
-
-If there are performance problems, often times the best solution is to 
-convert your mailbox list to a skiplist format. 
-
-Paul M Fleming (pfleming@siumed.edu) also notes::
-
-    We found limiting the number of lmtp processes to 10 helped with locker problems. Let sendmail/postfix handle the queuing and lmtp the delivery.. When we tried to blast 10-20 messages/sec at our test server locking became a problem with the duplicate delivery db. Across 3 servers and 600 concurrent logins (lmtpd maxchild=10 on each server) we never see any locking problems and usually have less than 1 second delivery times.
-    
-Andreas (andreas@conectiva.com.br) writes::
-
-    Take a look at this text: http://www.openldap.org/faq/index.cgi?_highlightWords=locks&file=893
-    
-    It's written for openldap, but explains several important Berkeley DB configuration parameters. In particular:
-    
-        On a very busy system you might see error messages talking about running out of locks, lockers, or lock objects. Usually the default values are plenty, and in older versions of the BDB library the errors were more likely due to library bugs than actual system load. However, it is possible that you have actually run out of lock resources due to heavy system usage. If this happens, you should read about the set_lk_max_lockers[1], set_lk_max_locks[2], and set_lk_max_objects[3] keywords.
-
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_lockers.html
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_locks.html
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_objects.html
-
-    The links above talk about the C api, but don't get alarmed, these paremeters can be set with a DB_CONFIG configuration file located in the DB environment home.
-
-I also suppose the :manpage:`db_stat(8)` utility can be used to diagnose this.
-
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-deleted-expired-expunged-purged.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-deleted-expired-expunged-purged.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-deleted-expired-expunged-purged.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-deleted-expired-expunged-purged.txt	2020-04-24 02:03:00.000000000 +0000
@@ -100,13 +100,13 @@ values:
 
 Exceptional circumstances aside, when ``immediate`` or ``default`` is
 the configured ``expunge_mode``, message files are often purged from the
-filesytem too quickly for anyone to recover.
+filesystem too quickly for anyone to recover.
 
 .. NOTE::
 
     One such exceptional circumstance is a mailbox with multiple
     sessions keeping the mailbox open. Cyrus IMAP ensures no mailbox
-    records dissappear from underneath an existing open mailbox session.
+    records disappear from underneath an existing open mailbox session.
 
 Moved to Trash Folder
 ---------------------
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-deliverdb-size.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-deliverdb-size.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-deliverdb-size.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-deliverdb-size.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ of data there.
 
 Note also that it is common for databases to have unused 
 space that may not be immediately recovered for performance reasons 
-(this is the case with Berkeley DB and Cyrus Skiplist) You can control 
+(this is the case with Cyrus Skiplist) You can control
 the size by increasing the frequency at which it gets pruned. 
 
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-otherdatabases.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-otherdatabases.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-otherdatabases.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-otherdatabases.txt	2020-04-24 02:03:00.000000000 +0000
@@ -16,5 +16,5 @@ mailboxes.
 Cyrus DOES have the option of using databases of various types for 
 storing some other information, such as authentication data, mailbox 
 lists, etc. There may be reasons to add a SQL backend to these databases 
-in the future (in addition to flat, skiplist, and berkeley). 
+in the future (in addition to flat, and skiplist).
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-sharedfilesystem-gpfs.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-sharedfilesystem-gpfs.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/o-sharedfilesystem-gpfs.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/o-sharedfilesystem-gpfs.txt	2020-04-24 02:03:00.000000000 +0000
@@ -27,7 +27,7 @@ Our Cyrus installation has about 80K use
 many millions of files. Just the number of files alone would be enough 
 to kill the idea of using GPFS. 
 
-Cyrus makes pretty extensive use of mmap(), and so does Berkeley DB. 
+Cyrus makes pretty extensive use of mmap().
 While GPFS implements mmap(), the GPFS architect had some words about 
 the way certain operations are accomplished in Cyrus. I think there are 
 (or used to be) places where an mmap'd file is opened for write with 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/faqs/r-murder-ha.txt 3.2.0-3/doc/html/_sources/imap/reference/faqs/r-murder-ha.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/faqs/r-murder-ha.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/faqs/r-murder-ha.txt	2020-04-24 02:03:00.000000000 +0000
@@ -15,7 +15,7 @@ The mupdate server is indeed a single po
 failure at this point only prohibits message delivery (via the LMTP 
 proxies that are querying it for up-to-date mailbox data) and certain 
 mailbox operations (create, delete, setacl, and so on). Mail can still 
-be accessed by all users of the system, and incoming mail will recieve 
+be accessed by all users of the system, and incoming mail will receive 
 temporary failures, so the sending MTA should continue to queue the 
 mail. 
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/configs/cyrus.conf.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/configs/cyrus.conf.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/configs/cyrus.conf.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/configs/cyrus.conf.txt	2020-04-24 02:03:00.000000000 +0000
@@ -138,7 +138,7 @@ on certain Internet/UNIX sockets.
     (as listed in ``/etc/services``).
 
     If *host* is missing, 0.0.0.0 (all interfaces) is assumed.  Use
-    localhost or 127.0.0.1 to restict access, i.e. when a proxy
+    localhost or 127.0.0.1 to restrict access, i.e. when a proxy
     on the same host is front-ending Cyrus.
 
     Note that on most systems UNIX socket paths are limited to around
@@ -243,8 +243,10 @@ DAEMON
 ------
 
 This section lists long running daemons to start before any
-**SERVICES** are spawned.  They will be shutdown when
-:cyrusman:`master(8)` is exiting.
+**SERVICES** are spawned.  :cyrusman:`master(8)`  will ensure that
+these processes are running, restarting any process which dies or
+forks. All listed processes will be shutdown when :cyrusman:`master(8)`
+is exiting.
 
 .. parsed-literal::
 
@@ -302,6 +304,7 @@ See Also
 :cyrusman:`imapd(8)`,
 :cyrusman:`pop3d(8)`,
 :cyrusman:`lmtpd(8)`,
+:cyrusman:`smmapd(8)`,
 :cyrusman:`timsieved(8)`,
 :cyrusman:`idled(8)`,
 :cyrusman:`notifyd(8)`,
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/configs/imapd.conf.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/configs/imapd.conf.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/configs/imapd.conf.txt	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/configs/imapd.conf.txt	2020-05-04 04:10:42.000000000 +0000
@@ -5,9 +5,9 @@
 
 .. _imap-reference-manpages-configs-imapd.conf:
 
-==========
-imapd.conf
-==========
+==============
+**imapd.conf**
+==============
 
 
 
@@ -55,6 +55,15 @@ DESCRIPTION
     \`\`true'' and \`\`\ 1'' turn the option on, the values \`\`no'', \`\`off'',
     \`\`f'', \`\`false'' and \`\`\ 0'' turn the option off.
 
+    Duration options take the form of a number followed by a unit, for example
+    **\ 32m** (32 minutes).  Units are **d** (days), **h** (hours), **m**
+    (minutes) and **s** (seconds).  Multiple units can be combined and will
+    be summed together, for example **\ 1h30m** is equivalent to **\ 90m**.  If
+    no unit is specified, an option-specific backward-compatible default unit
+    is assumed (documented on an option-by-option basis).  These are simple time
+    units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+    etc are not considered).
+
 FIELD DESCRIPTIONS
 ==================
 
@@ -149,6 +158,15 @@ FIELD DESCRIPTIONS
 
     .. endblob allowapop
 
+    .. startblob allowdeleted
+
+    ``allowdeleted:`` 0
+
+        Allow access to deleted and expunged data via vendor.cmu-\* access 
+
+
+    .. endblob allowdeleted
+
     .. startblob allownewnews
 
     ``allownewnews:`` 0
@@ -174,6 +192,15 @@ FIELD DESCRIPTIONS
 
     .. endblob allowplaintext
 
+    .. startblob allowsetacl
+
+    ``allowsetacl:`` 1
+
+        Defaults to enabled.  If disabled, disallows the use of the SETACL
+        command at all via IMAP. 
+
+    .. endblob allowsetacl
+
     .. startblob allowusermoves
 
     ``allowusermoves:`` 0
@@ -219,7 +246,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for mailbox annotations. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob annotation_db
@@ -336,6 +363,26 @@ FIELD DESCRIPTIONS
 
     .. endblob annotation_callout
 
+    .. startblob annotation_callout_disable_append
+
+    ``annotation_callout_disable_append:`` 0
+
+        Disables annotations on append with xrunannotator 
+
+
+    .. endblob annotation_callout_disable_append
+
+    .. startblob annotation_enable_legacy_commands
+
+    ``annotation_enable_legacy_commands:`` 0
+
+        Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+        These commands are deprecated and will be removed in the future,
+        but might be useful in the meantime for supporting old clients that
+        do not implement the :rfc:`5464` IMAP METADATA extension. 
+
+    .. endblob annotation_enable_legacy_commands
+
     .. startblob aps_topic
 
     ``aps_topic:`` <none>
@@ -376,13 +423,25 @@ FIELD DESCRIPTIONS
 
     .. startblob archive_days
 
-    ``archive_days:`` 7
+    ``archive_days:`` <none>
+
+        Deprecated in favour of *archive_after*. 
 
-        The number of days after which to move messages to the archive partition
-        if archiving is enabled 
 
     .. endblob archive_days
 
+    .. startblob archive_after
+
+    ``archive_after:`` 7d
+
+        The duration after which to move messages to the archive partition
+        if archiving is enabled.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob archive_after
+
     .. startblob archive_maxsize
 
     ``archive_maxsize:`` 1024
@@ -517,6 +576,25 @@ FIELD DESCRIPTIONS
 
     .. endblob autosubscribe_all_sharedfolders
 
+    .. startblob autocreate_acl
+
+    ``autocreate_acl:`` <none>
+
+        If folders are to be created by *autocreate_inbox_folders\R, this
+        setting can be used to apply additional ACLs to the autocreated
+        folders.  The syntax is "autocreate_acl folder identifier rights",
+        where *\ *folder* must match one of the *autocreate_inbox_folders*
+        folders, *identifier* must be a valid cyrus identifier, and
+        *rights* must be a valid cyrus rights string.  Multiple
+        identifier|rights pairs can be assigned to a single folder by providing
+        this setting multiple times.
+
+        For example, "autocreate_acl Plus anyone p" would allow lmtp delivery
+        to a folder named "Plus".
+
+
+    .. endblob autocreate_acl
+
     .. startblob autocreate_inbox_folders
 
     ``autocreate_inbox_folders:`` <none>
@@ -676,6 +754,15 @@ FIELD DESCRIPTIONS
 
     .. endblob autocreate_users
 
+    .. startblob autoexpunge
+
+    ``autoexpunge:`` 0
+
+        If set to yes, then all \Deleted messages will be automatically expunged whenever
+        an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect 
+
+    .. endblob autoexpunge
+
     .. startblob backuppartition-name
 
     ``backuppartition-name:`` <none>
@@ -729,21 +816,33 @@ FIELD DESCRIPTIONS
 
     .. startblob backup_retention_days
 
-    ``backup_retention_days:`` 7
+    ``backup_retention_days:`` <none>
+
+        Deprecated in favor of *backup_retention*. 
 
-        The number of days to keep content in backup after it has been deleted
-        from the source.  If set to a negative value or zero, deleted content
-        will be kept indefinitely. 
 
     .. endblob backup_retention_days
 
+    .. startblob backup_retention
+
+    ``backup_retention:`` 7d
+
+        How long to keep content in backup after it has been deleted
+        from the source.  If set to a negative value or zero, deleted content
+        will be kept indefinitely.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob backup_retention
+
     .. startblob backup_db
 
     ``backup_db:`` twoskip
 
         The cyrusdb backend to use for the backup locations database. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob backup_db
@@ -787,11 +886,20 @@ FIELD DESCRIPTIONS
 
     ``caldav_allowattach:`` 1
 
-        Enable managed attachments support on the caldav server. 
+        Enable managed attachments support on the CalDAV server. 
 
 
     .. endblob caldav_allowattach
 
+    .. startblob caldav_allowcalendaradmin
+
+    ``caldav_allowcalendaradmin:`` 0
+
+        Enable per-user calendar administration web UI on the CalDAV server. 
+
+
+    .. endblob caldav_allowcalendaradmin
+
     .. startblob caldav_allowscheduling
 
     ``caldav_allowscheduling:`` on
@@ -808,7 +916,7 @@ FIELD DESCRIPTIONS
 
     ``caldav_create_attach:`` 1
 
-        Create the 'Attachments' calendar if it doesn't already exist 
+        Create the 'Attachments' collection if it doesn't already exist 
 
 
     .. endblob caldav_create_attach
@@ -831,6 +939,21 @@ FIELD DESCRIPTIONS
 
     .. endblob caldav_create_sched
 
+    .. startblob caldav_historical_age
+
+    ``caldav_historical_age:`` 7d
+
+        How long after an occurrence of event or task has concluded
+        that it is considered 'historical'.  Changes to historical
+        occurrences of events or tasks WILL NOT have invite or reply
+        messages sent for them.  A negative value means that events
+        and tasks are NEVER considered historical.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob caldav_historical_age
+
     .. startblob caldav_maxdatetime
 
     ``caldav_maxdatetime:`` 20380119T031407Z
@@ -885,6 +1008,38 @@ FIELD DESCRIPTIONS
 
     .. endblob calendar_user_address_set
 
+    .. startblob calendar_component_set
+
+    ``calendar_component_set:`` VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL
+
+        Space-separated list of iCalendar component types that calendar
+        object resources may contain in a calendar collection.
+        This restriction is only set at calendar creation time and only
+        if the CalDAV client hasn't specified a restriction in the creation
+        request. 
+        Allowed values: *VEVENT*, *VTODO*, *VJOURNAL*, *VFREEBUSY*, *VAVAILABILITY*, *VPOLL*
+
+
+    .. endblob calendar_component_set
+
+    .. startblob carddav_allowaddmember
+
+    ``carddav_allowaddmember:`` 0
+
+        Enable support for POST add-member on the CardDAV server. 
+
+
+    .. endblob carddav_allowaddmember
+
+    .. startblob carddav_allowaddressbookadmin
+
+    ``carddav_allowaddressbookadmin:`` 0
+
+        Enable per-user addressbook administration web UI on the CardDAV server. 
+
+
+    .. endblob carddav_allowaddressbookadmin
+
     .. startblob carddav_realm
 
     ``carddav_realm:`` <none>
@@ -939,10 +1094,13 @@ FIELD DESCRIPTIONS
 
     .. startblob client_timeout
 
-    ``client_timeout:`` 10
+    ``client_timeout:`` 10s
+
+        Time to wait before returning a timeout failure when performing a
+        client connection (e.g. in a murder environment).
 
-        Number of seconds to wait before returning a timeout failure when
-        performing a client connection (e.g., in a murder environment) 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed.  
 
     .. endblob client_timeout
 
@@ -1000,20 +1158,41 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the per-user conversations database. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob conversations_db
 
     .. startblob conversations_expire_days
 
-    ``conversations_expire_days:`` 90
+    ``conversations_expire_days:`` <none>
+
+        Deprecated in favor of *conversations_expire_after*. 
+
+
+    .. endblob conversations_expire_days
+
+    .. startblob conversations_expire_after
+
+    ``conversations_expire_after:`` 90d
 
         How long the conversations database keeps the message tracking
         information needed for receiving new messages in existing
-        conversations, in days. 
+        conversations.
 
-    .. endblob conversations_expire_days
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
+
+    .. endblob conversations_expire_after
+
+    .. startblob conversations_max_thread
+
+    ``conversations_max_thread:`` 100
+
+        maximum size for a single thread.  Threads will split if they have this many
+        \* messages in them and another message arrives 
+
+    .. endblob conversations_max_thread
 
     .. startblob crossdomains
 
@@ -1085,14 +1264,28 @@ FIELD DESCRIPTIONS
 
     .. endblob dav_realm
 
+    .. startblob dav_lock_timeout
+
+    ``dav_lock_timeout:`` 20s
+
+        The maximum time to wait for a write lock on the per-user DAV database
+        before timeout. For HTTP requests, the HTTP status code 503 is returned
+        if the lock can not be obtained within this time.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob dav_lock_timeout
+
     .. startblob debug_command
 
     ``debug_command:`` <none>
 
         Debug command to be used by processes started with -D option.  The string
         is a C format string that gets 3 options: the first is the name of the
-        executable (without path).  The second is the pid (integer) and the third
-        is the service ID.  Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d 
+        executable (as specified in the cmd parameter in cyrus.conf). The second
+        is the pid (integer) and the third is the service ID.
+        Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d 
 
     .. endblob debug_command
 
@@ -1253,6 +1446,15 @@ FIELD DESCRIPTIONS
 
     .. endblob ischedule_dkim_key_file
 
+    .. startblob ischedule_dkim_required
+
+    ``ischedule_dkim_required:`` 1
+
+        A DKIM signature is required on received iSchedule requests. 
+
+
+    .. endblob ischedule_dkim_required
+
     .. startblob ischedule_dkim_selector
 
     ``ischedule_dkim_selector:`` <none>
@@ -1269,7 +1471,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the duplicate delivery suppression
         and sieve. 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob duplicate_db
@@ -1343,7 +1545,7 @@ FIELD DESCRIPTIONS
 
         Space-separated list of extra parameters to add to any appropriated event. 
 
-        Allowed values: *bodyStructure*, *clientAddress*, *diskUsed*, *flagNames*, *messageContent*, *messageSize*, *messages*, *modseq*, *service*, *timestamp*, *uidnext*, *vnd.cmu.midset*, *vnd.cmu.unseenMessages*, *vnd.cmu.envelope*, *vnd.cmu.sessionId*, *vnd.cmu.mailboxACL*, *vnd.cmu.mbtype*, *vnd.cmu.davFilename*, *vnd.cmu.davUid*, *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*, *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*, *vnd.fastmail.cid*, *vnd.fastmail.counters*
+        Allowed values: *bodyStructure*, *clientAddress*, *diskUsed*, *flagNames*, *messageContent*, *messageSize*, *messages*, *modseq*, *service*, *timestamp*, *uidnext*, *vnd.cmu.midset*, *vnd.cmu.unseenMessages*, *vnd.cmu.envelope*, *vnd.cmu.sessionId*, *vnd.cmu.mailboxACL*, *vnd.cmu.mbtype*, *vnd.cmu.davFilename*, *vnd.cmu.davUid*, *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*, *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*, *vnd.fastmail.cid*, *vnd.fastmail.counters*, *vnd.cmu.emailid*, *vnd.cmu.threadid*
 
 
     .. endblob event_extra_params
@@ -1373,32 +1575,33 @@ FIELD DESCRIPTIONS
     ``expunge_mode:`` delayed
 
         The mode in which messages (and their corresponding cache entries)
-        are expunged.  "default" mode is the old behavior in which the
+        are expunged.  "semidelayed" mode is the old behavior in which the
         message files are purged at the time of the EXPUNGE, but index
-        and cache records are retained to facilitate QRESYNC.  (Note that
-        this behaviour is no longer the default, but is so named for historical
-        reasons.)  In "delayed" mode, which is the default since Cyrus 2.5.0,
+        and cache records are retained to facilitate QRESYNC.
+        In "delayed" mode, which is the default since Cyrus 2.5.0,
         the message files are also retained, allowing unexpunge to
         rescue them.  In "immediate" mode, both the message files and the
         index records are removed as soon as possible.  In all cases,
         nothing will be finally purged until all other processes have
         closed the mailbox to ensure they never see data disappear under
-        them.  In "default" or "delayed" mode, a later run of "cyr_expire"
+        them.  In "semidelayed" or "delayed" mode, a later run of "cyr_expire"
         will clean out the retained records (and possibly message files).
         This reduces the amount of I/O that takes place at the time of
         EXPUNGE and should result in greater responsiveness for the client,
         especially when expunging a large number of messages. 
-        Allowed values: *default*, *immediate*, *delayed*
+        Allowed values: *immediate*, *semidelayed*, *delayed*
 
 
     .. endblob expunge_mode
 
     .. startblob failedloginpause
 
-    ``failedloginpause:`` 3
+    ``failedloginpause:`` 3s
 
-        Number of seconds to pause after a failed login. 
+        Time to pause after a failed login.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob failedloginpause
 
@@ -1562,14 +1765,17 @@ FIELD DESCRIPTIONS
 
     .. startblob httpkeepalive
 
-    ``httpkeepalive:`` 20
+    ``httpkeepalive:`` 20s
+
+        Set the length of the HTTP server's keepalive heartbeat.  The
+        default is 20 seconds.  The minimum value is 0, which will disable
+        the keepalive heartbeat.  When enabled, if a request takes longer
+        than *httpkeepalive* to process, the server will send the client
+        provisional responses every *httpkeepalive* until the final
+        response can be sent.
 
-        Set the length of the HTTP server's keepalive heartbeat in seconds.
-        The default is 20.  The minimum value is 0, which will disable the
-        keepalive heartbeat.  When enabled, if a request takes longer than
-        *httpkeepalive* seconds to process, the server will send the client
-        provisional responses every *httpkeepalive* seconds until the
-        final response can be sent 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob httpkeepalive
 
@@ -1584,7 +1790,7 @@ FIELD DESCRIPTIONS
         Note that "domainkey" depends on "ischedule" being enabled, and
         that both "freebusy" and "ischedule" depend on "caldav" being
         enabled. 
-        Allowed values: *admin*, *caldav*, *carddav*, *domainkey*, *freebusy*, *ischedule*, *rss*, *tzdist*, *webdav*
+        Allowed values: *admin*, *caldav*, *carddav*, *cgi*, *domainkey*, *freebusy*, *ischedule*, *jmap*, *prometheus*, *rss*, *tzdist*, *webdav*
 
 
     .. endblob httpmodules
@@ -1603,11 +1809,14 @@ FIELD DESCRIPTIONS
 
     .. startblob httptimeout
 
-    ``httptimeout:`` 5
+    ``httptimeout:`` 5m
+
+        Set the length of the HTTP server's inactivity autologout timer.
+        The default is 5 minutes.  The minimum value is 0, which will
+        disable persistent connections.
 
-        Set the length of the HTTP server's inactivity autologout timer,
-        in minutes.  The default is 5.  The minimum value is 0, which will
-        disable persistent connections. 
+        For backwards compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob httptimeout
 
@@ -1631,12 +1840,15 @@ FIELD DESCRIPTIONS
 
     .. startblob imapidlepoll
 
-    ``imapidlepoll:`` 60
+    ``imapidlepoll:`` 60s
 
-        The interval (in seconds) for polling for mailbox changes and
-        ALERTs while running the IDLE command.  This option is used when
-        idled is not enabled or cannot be contacted.  The minimum value is
-        1.  A value of 0 will disable IDLE. 
+        The interval for polling for mailbox changes and ALERTs while running
+        the IDLE command.  This option is used when idled is not enabled or
+        cannot be contacted.  The minimum value is 1 second.  A value of 0
+        will disable IDLE.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob imapidlepoll
 
@@ -1672,7 +1884,7 @@ FIELD DESCRIPTIONS
 
     .. startblob implicit_owner_rights
 
-    ``implicit_owner_rights:`` lkxa
+    ``implicit_owner_rights:`` lkxan
 
         The implicit Access Control List (ACL) for the owner of a mailbox. 
 
@@ -1705,18 +1917,235 @@ FIELD DESCRIPTIONS
 
     .. endblob improved_mboxlist_sort
 
-    .. startblob internaldate_heuristic
+    .. startblob jmap_emailsearch_db_path
+
+    ``jmap_emailsearch_db_path:`` <none>
+
+        The absolute path to the JMAP email search cache file.  If not
+        specified, JMAP Email/query and Email/queryChanges will not
+        cache email search results. 
 
-    ``internaldate_heuristic:`` standard
+    .. endblob jmap_emailsearch_db_path
 
-        Mechanism to determine email internaldates on delivery/reconstruct.
-        "standard" uses time() when delivering a message, mtime on reconstruct.
-        "receivedheader" looks at the top most Received header
-        or time/mtime otherwise 
-        Allowed values: *standard*, *receivedheader*
+    .. startblob jmap_preview_annot
 
+    ``jmap_preview_annot:`` <none>
 
-    .. endblob internaldate_heuristic
+        The name of the per-message annotation, if any, to store message
+        previews. 
+
+    .. endblob jmap_preview_annot
+
+    .. startblob jmap_imagesize_annot
+
+    ``jmap_imagesize_annot:`` <none>
+
+        The name of the per-message annotation, if any, that stores a
+        JSON object, mapping message part numbers of MIME image types
+        to an array of their image dimensions. The array must have at
+        least two entries, where the first entry denotes the width
+        and the second entry the height of the image. Any additional
+        values are ignored.
+
+        For example, if message part 1.2 contains an image of width 300
+        and height 200, then the value of this annotation would be:
+
+        { "1.2" : [ 300, 200 ] }
+
+
+    .. endblob jmap_imagesize_annot
+
+    .. startblob jmap_inlinedcids_annot
+
+    ``jmap_inlinedcids_annot:`` <none>
+
+        The name of the per-message annotation, if any, that stores a
+        JSON object, mapping :rfc:`2392` Content-IDs referenced in HTML bodies
+        to the respective HTML body part number.
+
+        For example, if message part 1.2 contains HTML and references an
+        inlined image at "cid:foo", then the value of this annotation
+        would be:
+
+        { "<foo>" : "1.2" }
+
+        Note that the Content-ID key must be URL-unescaped and enclosed in
+        angular brackets, as defined in :rfc:`2392`. 
+
+    .. endblob jmap_inlinedcids_annot
+
+    .. startblob jmap_preview_length
+
+    ``jmap_preview_length:`` 64
+
+        The maximum byte length of dynamically generated message previews. Previews
+        stored in jmap_preview_annot take precedence. 
+
+    .. endblob jmap_preview_length
+
+    .. startblob jmap_max_size_upload
+
+    ``jmap_max_size_upload:`` 1048576
+
+        The maximum size (in kilobytes) that the JMAP API accepts
+        for blob uploads. Returned as the maxSizeUpload property
+        value of the JMAP \"urn:ietf:params:jmap:core\" capabilities object.
+        Default is 1Gb. 
+
+    .. endblob jmap_max_size_upload
+
+    .. startblob jmap_max_concurrent_upload
+
+    ``jmap_max_concurrent_upload:`` 5
+
+        The value to return for the maxConcurrentUpload property of
+        the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+        implementation does not enforce this rate-limit. 
+
+    .. endblob jmap_max_concurrent_upload
+
+    .. startblob jmap_max_size_request
+
+    ``jmap_max_size_request:`` 10240
+
+        The maximum size (in kilobytes) that the JMAP API accepts
+        for requests at the API endpoint. Returned as the
+        maxSizeRequest property value of the JMAP \"urn:ietf:params:jmap:core\"
+        capabilities object. Default is 10Mb. 
+
+    .. endblob jmap_max_size_request
+
+    .. startblob jmap_max_concurrent_requests
+
+    ``jmap_max_concurrent_requests:`` 5
+
+        The value to return for the maxConcurrentRequests property of
+        the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+        implementation does not enforce this rate-limit. 
+
+    .. endblob jmap_max_concurrent_requests
+
+    .. startblob jmap_max_calls_in_request
+
+    ``jmap_max_calls_in_request:`` 50
+
+        The maximum number of calls per JMAP request object.
+        Returned as the maxCallsInRequest property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_calls_in_request
+
+    .. startblob jmap_max_delayed_send
+
+    ``jmap_max_delayed_send:`` 512d
+
+        The value to return for the maxDelayedSend property of
+        the JMAP \"urn:ietf:params:jmap:emailsubmission\" capabilities object.
+        The Cyrus JMAP implementation does not enforce this limit.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob jmap_max_delayed_send
+
+    .. startblob jmap_max_objects_in_get
+
+    ``jmap_max_objects_in_get:`` 4096
+
+        The maximum number of ids that a JMAP client may request in
+        a single \"/get\" type method call. The actual number
+        of returned objects in the response may exceed this number
+        if the JMAP object type supports unbounded \"/get\" calls.
+        Returned as the maxObjectsInGet property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_objects_in_get
+
+    .. startblob jmap_max_objects_in_set
+
+    ``jmap_max_objects_in_set:`` 4096
+
+        The maximum number of objects a JMAP client may send to create,
+        update or destroy in a single /set type method call.
+        Returned as the maxObjectsInSet property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_objects_in_set
+
+    .. startblob jmap_mail_max_size_attachments_per_email
+
+    ``jmap_mail_max_size_attachments_per_email:`` 10240
+
+        The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+        property of the JMAP \"urn:ietf:params:jmap:mail\" capabilities object. The Cyrus
+        JMAP implementation does not enforce this size limit. Default is 10 Mb.
+
+    .. endblob jmap_mail_max_size_attachments_per_email
+
+    .. startblob jmap_nonstandard_extensions
+
+    ``jmap_nonstandard_extensions:`` 0
+
+        If enabled, support non-standard JMAP extensions.  If not enabled,
+        only IETF standard JMAP functionality is supported. 
+
+    .. endblob jmap_nonstandard_extensions
+
+    .. startblob jmap_set_has_attachment
+
+    ``jmap_set_has_attachment:`` 1
+
+        If enabled, the $hasAttachment flag is determined and set for new messages
+        created with the JMAP Email/set or Email/import methods. This option should
+        typically be enabled, but installations using Cyrus-external message
+        annatotors to determine the $hasAttachment flag might want to disable it. 
+
+    .. endblob jmap_set_has_attachment
+
+    .. startblob jmap_vacation
+
+    ``jmap_vacation:`` 1
+
+        If enabled, support the JMAP vacation extension 
+
+
+    .. endblob jmap_vacation
+
+    .. startblob jmapuploadfolder
+
+    ``jmapuploadfolder:`` #jmap
+
+        the name of the folder for JMAP uploads (#jmap) 
+
+
+    .. endblob jmapuploadfolder
+
+    .. startblob jmapsubmission_deleteonsend
+
+    ``jmapsubmission_deleteonsend:`` 1
+
+        If enabled (the default) then delete the EmailSubmission as soon as the email
+        \* has been sent 
+
+    .. endblob jmapsubmission_deleteonsend
+
+    .. startblob jmapsubmissionfolder
+
+    ``jmapsubmissionfolder:`` #jmapsubmission
+
+        the name of the folder for JMAP Submissions (#jmapsubmission) 
+
+
+    .. endblob jmapsubmissionfolder
+
+    .. startblob jmappushsubscriptionfolder
+
+    ``jmappushsubscriptionfolder:`` #jmappushsubscription
+
+        the name of the folder for JMAP Push Subscriptions (#jmappushsubscription) 
+
+
+    .. endblob jmappushsubscriptionfolder
 
     .. startblob iolog
 
@@ -1823,7 +2252,9 @@ FIELD DESCRIPTIONS
         %u   = user
         %U   = user portion of %u (%U = test when %u = test@domain.tld)
         %d   = domain portion of %u if available (%d = domain.tld when %u =
-        %test@domain.tld), otherwise same as %r
+        test@domain.tld), otherwise same as %R
+        %R   = domain portion of %u starting with @ (%R = @domain.tld
+        when %u = test@domain.tld)
         %D   = user dn.  (use when ldap_member_method: filter)
         %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
 
@@ -2069,19 +2500,23 @@ FIELD DESCRIPTIONS
 
     .. startblob ldap_time_limit
 
-    ``ldap_time_limit:`` 5
+    ``ldap_time_limit:`` 5s
 
-        Specify a number of seconds for a search request to complete. 
+        How long to wait for a search request to complete.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ldap_time_limit
 
     .. startblob ldap_timeout
 
-    ``ldap_timeout:`` 5
+    ``ldap_timeout:`` 5s
 
-        Specify a number of seconds a search can take before timing out. 
+        How long a search can take before timing out.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ldap_timeout
 
@@ -2230,6 +2665,19 @@ FIELD DESCRIPTIONS
 
     .. endblob lmtp_downcase_rcpt
 
+    .. startblob lmtp_exclude_specialuse
+
+    ``lmtp_exclude_specialuse:`` \\Snoozed
+
+        Don't allow delivery to folders with given special-use attributes.
+
+        Note that "snoozing" of emails can currently only be done via the
+        JMAP protocol, so delivery directly to the \Snoozed mailbox is
+        prohibited by default as it will not be moved back into INBOX
+        automatically. 
+
+    .. endblob lmtp_exclude_specialuse
+
     .. startblob lmtp_fuzzy_mailbox_match
 
     ``lmtp_fuzzy_mailbox_match:`` 0
@@ -2284,15 +2732,28 @@ FIELD DESCRIPTIONS
 
     .. startblob lmtptxn_timeout
 
-    ``lmtptxn_timeout:`` 300
+    ``lmtptxn_timeout:`` 5m
 
-        Timeout (in seconds) used during a lmtp transaction to a remote backend
-        (e.g. in a murder environment).  Can be used to prevent hung lmtpds
-        on proxy hosts when a backend server becomes unresponsive during a
-        lmtp transaction.  The default is 300 - change to zero for infinite. 
+        Timeout used during a lmtp transaction to a remote backend (e.g. in a
+        murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+        when a backend server becomes unresponsive during a lmtp transaction.
+        The default is 5 minutes - change to zero for infinite.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob lmtptxn_timeout
 
+    .. startblob lock_debugtime
+
+    ``lock_debugtime:`` <none>
+
+        A floating point number of seconds.  If set, time how long we wait for
+        any lock, and syslog the filename and time if it's longer than this
+        value.  The default of NULL means not to time locks. 
+
+    .. endblob lock_debugtime
+
     .. startblob loginrealms
 
     ``loginrealms:`` <empty string>
@@ -2353,6 +2814,21 @@ FIELD DESCRIPTIONS
 
     .. endblob mailnotifier
 
+    .. startblob master_bind_errors_fatal
+
+    ``master_bind_errors_fatal:`` 0
+
+        If enabled, failure to bind a port during startup is treated as a fatal
+        error, causing master to shut down immediately.  The default is to keep
+        running, with the affected service disabled until the next SIGHUP causes
+        it to retry.
+
+        Note that this only applies during startup.  New services that fail to
+        come up in response to a reconfig+SIGHUP will just be logged and disabled
+        like the default behaviour, without causing master to exit. 
+
+    .. endblob master_bind_errors_fatal
+
     .. startblob maxheaderlines
 
     ``maxheaderlines:`` 1000
@@ -2417,7 +2893,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for mailbox keys. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob mboxkey_db
@@ -2428,7 +2904,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the mailbox list. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob mboxlist_db
@@ -2738,10 +3214,13 @@ FIELD DESCRIPTIONS
 
     .. startblob nntptimeout
 
-    ``nntptimeout:`` 3
+    ``nntptimeout:`` 3m
+
+        Set the length of the NNTP server's inactivity autologout timer.
+        The minimum value is 3 minutes, also the default.
 
-        Set the length of the NNTP server's inactivity autologout timer,
-        in minutes.  The minimum value is 3, the default. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob nntptimeout
 
@@ -2798,15 +3277,6 @@ FIELD DESCRIPTIONS
 
     .. endblob partition-name
 
-    .. startblob outbox_sendlater
-
-    ``outbox_sendlater:`` 0
-
-        If enabled, any message with a \Draft flag will be sent at the time of its INTERNALDATE 
-
-
-    .. endblob outbox_sendlater
-
     .. startblob partition_select_mode
 
     ``partition_select_mode:`` freespace-most
@@ -2871,12 +3341,15 @@ FIELD DESCRIPTIONS
 
     .. startblob plaintextloginpause
 
-    ``plaintextloginpause:`` 0
+    ``plaintextloginpause:`` <none>
+
+        Time to pause after a successful plaintext login.  For systems that
+        support strong authentication, this permits users to perceive a cost
+        of using plaintext passwords.  (This does not affect the use of PLAIN
+        in SASL authentications.)
 
-        Number of seconds to pause after a successful plaintext login.  For
-        systems that support strong authentication, this permits users to
-        perceive a cost of using plaintext passwords.  (This does not
-        affect the use of PLAIN in SASL authentications.) 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob plaintextloginpause
 
@@ -2893,23 +3366,31 @@ FIELD DESCRIPTIONS
 
     ``popexpiretime:`` -1
 
-        The number of days advertised as being the minimum a message may be
+        The duration advertised as being the minimum a message may be
         left on the POP server before it is deleted (via the CAPA command,
         defined in the POP3 Extension Mechanism, which some clients may
-        support).  "NEVER", the default, may be specified with a negative
-        number.  The Cyrus POP3 server never deletes mail, no matter what
-        the value of this parameter is.  However, if a site implements a
-        less liberal policy, it needs to change this parameter
-        accordingly. 
+        support).  This duration has a granularity of whole days, with partial
+        days truncated (so e.g. "45m" is effectively "0d").  "NEVER", the
+        default, may be specified with a negative number.
+
+        The Cyrus POP3 server never deletes mail, no matter what the value of
+        this parameter is.  However, if a site implements a less liberal policy,
+        it needs to change this parameter accordingly.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
 
     .. endblob popexpiretime
 
     .. startblob popminpoll
 
-    ``popminpoll:`` 0
+    ``popminpoll:`` <none>
 
         Set the minimum amount of time the server forces users to wait
-        between successive POP logins, in minutes. 
+        between successive POP logins.
+
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob popminpoll
 
@@ -2945,10 +3426,13 @@ FIELD DESCRIPTIONS
 
     .. startblob poptimeout
 
-    ``poptimeout:`` 10
+    ``poptimeout:`` 10m
+
+        Set the length of the POP server's inactivity autologout timer.
+        The minimum value is 10 minutes, the default.
 
-        Set the length of the POP server's inactivity autologout timer,
-        in minutes.  The minimum value is 10, the default. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob poptimeout
 
@@ -3007,6 +3491,49 @@ FIELD DESCRIPTIONS
 
     .. endblob proc_path
 
+    .. startblob prometheus_enabled
+
+    ``prometheus_enabled:`` 0
+
+        Whether tracking of service metrics for Prometheus is enabled. 
+
+
+    .. endblob prometheus_enabled
+
+    .. startblob prometheus_need_auth
+
+    ``prometheus_need_auth:`` admin
+
+        Authentication level required to fetch Prometheus metrics. 
+
+        Allowed values: *none*, *user*, *admin*
+
+
+    .. endblob prometheus_need_auth
+
+    .. startblob prometheus_update_freq
+
+    ``prometheus_update_freq:`` 10s
+
+        Frequency in at which promstatsd should re-collate its statistics
+        report.  The minimum value is 1 second, the default is 10 seconds.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob prometheus_update_freq
+
+    .. startblob prometheus_stats_dir
+
+    ``prometheus_stats_dir:`` <none>
+
+        Directory to use for gathering prometheus statistics.  If specified,
+        must be an absolute path.  If not specified, the default path
+        $configdirectory/stats/ will be used.  It may be advantageous to locate this
+        directory on ephemeral storage. 
+
+    .. endblob prometheus_stats_dir
+
     .. startblob proxy_authname
 
     ``proxy_authname:`` proxy
@@ -3107,7 +3634,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the pts cache. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob ptscache_db
@@ -3123,10 +3650,13 @@ FIELD DESCRIPTIONS
 
     .. startblob ptscache_timeout
 
-    ``ptscache_timeout:`` 10800
+    ``ptscache_timeout:`` 3h
+
+        The timeout for the PTS cache database when using the auth_krb_pts
+        authorization method (default: 3 hours).
 
-        The timeout (in seconds) for the PTS cache database when using the
-        auth_krb_pts authorization method (default: 3 hours). 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ptscache_timeout
 
@@ -3167,7 +3697,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for quotas. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*, *twoskip*, *zeroskip*
 
 
     .. endblob quota_db
@@ -3323,12 +3853,14 @@ FIELD DESCRIPTIONS
 
     .. startblob rss_maxage
 
-    ``rss_maxage:`` 0
+    ``rss_maxage:`` <none>
 
-        Maximum age (in days) of items to display in an RSS channel.  If
-        non-zero, httpd will only display items received within the last
-        *rss_maxage* days.  If set to 0, all available items will be
-        displayed (the default). 
+        Maximum age of items to display in an RSS channel.  If non-zero,
+        httpd will only display items received within this time period.
+        If set to 0, all available items will be displayed (the default).
+
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
 
     .. endblob rss_maxage
 
@@ -3419,6 +3951,78 @@ FIELD DESCRIPTIONS
 
     .. endblob search_batchsize
 
+    .. startblob search_attachment_extractor_url
+
+    ``search_attachment_extractor_url:`` <none>
+
+        A HTTP or HTTPS URL to extract search text from rich text attachments
+        and other media during search indexing. The server at this URL must
+        implement the following protocol:
+
+        1. For each attachment of an email, Cyrus sends a GET request to the
+        URL <extractor-url>/<cyrus-id>, where <extractor-url> is the
+        configured URL and <cyrus-id> is a Cyrus-chosen path segment that
+        uniquely identifies this attachment.
+
+        2. If the extractor already has a cached plain text extract of the
+        attachment identified by <cyrus-id> then it may return HTTP status
+        code 200 (OK) and the plain text extract with a Content-Type
+        "text/plain" header. Otherwise it must return HTTP status 404 (Not Found).
+
+        3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+        a PUT request to the same URL as previously. The PUT request body
+        contains the decoded, binary body of the attachment. The Content-Type
+        request header has the same value as declared in the MIME part
+        headers, including any type parameters.
+
+        4. The extractor must return the plain text extract with either HTTP status
+        200 (OK) or 201 (Created) and a Content-Type "text/plain" header.
+        If no text can be extracted, then the extractor may return any return code
+        in the range 4xx, or 200 and an empty response body.
+
+        Any other HTTP status code is treated as an error. For performance
+        reasons, the Cyrus indexer attempts to keep-alive the TCP connection
+        to the extractor. 
+
+    .. endblob search_attachment_extractor_url
+
+    .. startblob search_index_language
+
+    ``search_index_language:`` 0
+
+
+        If enabled, then message bodies and subjects are indexed by their
+        detected language, if the cld2 dependency is built into Cyrus.
+        Regardless of this flag, bodies and subjects are always indexed and
+        searched using the default stemmer.
+
+
+    .. endblob search_index_language
+
+    .. startblob search_index_parts
+
+    ``search_index_parts:`` 0
+
+
+        If enabled, then message parts are each indexed separately into Xapian
+        so that matches can be done by part.
+
+
+    .. endblob search_index_parts
+
+    .. startblob search_query_language
+
+    ``search_query_language:`` 0
+
+
+        If enabled, then message bodies and subjects searched by their language
+        that got detected during indexing, if any.
+        Regardless of this flag, bodies and subjects are always searched using
+        the default stemmer.
+
+
+    .. endblob search_query_language
+
     .. startblob search_normalisation_max
 
     ``search_normalisation_max:`` 1000
@@ -3436,7 +4040,7 @@ FIELD DESCRIPTIONS
 
         The indexing engine used to speed up searching.  
 
-        Allowed values: *none*, *squat*, *sphinx*, *xapian*
+        Allowed values: *none*, *squat*, *xapian*
 
 
     .. endblob search_engine
@@ -3469,9 +4073,9 @@ FIELD DESCRIPTIONS
 
     ``search_indexed_db:`` twoskip
 
-        The cyrusdb backend to use for the search latest indexed uid state. 
+        The cyrusdb backend to use for the search latest indexed uid state.  Xapian only. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob search_indexed_db
@@ -3485,6 +4089,16 @@ FIELD DESCRIPTIONS
 
     .. endblob search_maxtime
 
+    .. startblob search_queryscan
+
+    ``search_queryscan:`` 5000
+
+        The minimum number of records require to do a direct scan of all G keys
+        \* rather than indexed lookups.  A value of 0 means always do indexed lookups.
+
+
+    .. endblob search_queryscan
+
     .. startblob search_skipdiacrit
 
     ``search_skipdiacrit:`` 1
@@ -3538,7 +4152,7 @@ FIELD DESCRIPTIONS
 
         The absolute base path to the search stopword lists. If not specified,
         no stopwords will be taken into account during search indexing. Currently,
-        the only supported and default stop word file is english.list. 
+        the only supported and default stop word file is english.txt. 
 
     .. endblob search_stopword_path
 
@@ -3566,7 +4180,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the seen state. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob seenstate_db
@@ -3580,6 +4194,17 @@ FIELD DESCRIPTIONS
 
     .. endblob sendmail
 
+    .. startblob sendmail_auth_id
+
+    ``sendmail_auth_id:`` CYRUS_SENDMAIL_AUTH_ID
+
+        The name of an environment variable to set when invoking sendmail.
+        The value of this environment variable will contain the user id
+        of the currently authenticated user. If no user is authenticated
+        the environment variable is not set. 
+
+    .. endblob sendmail_auth_id
+
     .. startblob serverlist
 
     ``serverlist:`` <none>
@@ -3695,9 +4320,20 @@ FIELD DESCRIPTIONS
 
     .. endblob sieve_allowreferrals
 
+    .. startblob sieve_duplicate_max_expiration
+
+    ``sieve_duplicate_max_expiration:`` 90d
+
+        Maximum expiration time for duplicate message tracking records.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob sieve_duplicate_max_expiration
+
     .. startblob sieve_extensions
 
-    ``sieve_extensions:`` fileinto reject vacation vacation-seconds imapflags notify envelope relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables
+    ``sieve_extensions:`` fileinto reject vacation vacation-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x-cyrus-jmapquery x-cyrus-snooze
 
         Space-separated list of Sieve extensions allowed to be used in
         sieve scripts, enforced at submission by timsieved(8).  Any
@@ -3705,7 +4341,7 @@ FIELD DESCRIPTIONS
         will continue to execute regardless of the extensions used.  This
         option has no effect on options that are disabled at compile time
         (e.g., "regex"). 
-        Allowed values: *fileinto*, *reject*, *vacation*, *vacation-seconds*, *imapflags*, *notify*, *include*, *envelope*, *body*, *relational*, *regex*, *subaddress*, *copy*, *date*, *index*, *imap4flags*, *mailbox*, *mboxmetadata*, *servermetadata*, *variables*
+        Allowed values: *fileinto*, *reject*, *vacation*, *vacation-seconds*, *imapflags*, *notify*, *include*, *envelope*, *environment*, *body*, *relational*, *regex*, *subaddress*, *copy*, *date*, *index*, *imap4flags*, *mailbox*, *mboxmetadata*, *servermetadata*, *variables*, *editheader*, *extlists*, *duplicate*, *ihave*, *fcc*, *special-use*, *redirect-dsn*, *redirect-deliverby*, *mailboxid*, *x-cyrus-log*, *x-cyrus-jmapquery*, *x-cyrus-snooze*
 
 
     .. endblob sieve_extensions
@@ -3747,21 +4383,37 @@ FIELD DESCRIPTIONS
 
     .. endblob sieve_sasl_send_unsolicited_capability
 
+    .. startblob sieve_use_lmtp_reject
+
+    ``sieve_use_lmtp_reject:`` 1
+
+        Enabled by default.  If reject can be done via LMTP, then return a 550
+        rather than generating the bounce message in Cyrus. 
+
+    .. endblob sieve_use_lmtp_reject
+
     .. startblob sieve_vacation_min_response
 
-    ``sieve_vacation_min_response:`` 259200 /\* 3 days \*/
+    ``sieve_vacation_min_response:`` 3d
+
+        Minimum time interval between consecutive vacation responses, per
+        draft-ietf-vacation-seconds.txt.  The default is 3 days.
 
-        Minimum time interval (in seconds) between consecutive vacation responses,
-        per draft-ietf-vacation-seconds.txt . 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sieve_vacation_min_response
 
     .. startblob sieve_vacation_max_response
 
-    ``sieve_vacation_max_response:`` 7776000 /\* 90 days \*/
+    ``sieve_vacation_max_response:`` 90d
 
-        Maximum time interval (in seconds) between consecutive vacation responses,
-        per draft-ietf-vacation-seconds.txt . 
+        Maximum time interval between consecutive vacation responses, per
+        draft-ietf-vacation-seconds.txt.  The default is 90 days.  The
+        minimum is 7 days.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sieve_vacation_max_response
 
@@ -3833,6 +4485,81 @@ FIELD DESCRIPTIONS
 
     .. endblob skiplist_unsafe
 
+    .. startblob smtp_backend
+
+    ``smtp_backend:`` sendmail
+
+        The SMTP backend to use for sending email.
+
+        The \"host\" backend sends message submissions via
+        a TCP socket to the SMTP host defined in the config
+        option smtp_host.
+
+        The \"sendmail\" backend forks the Cyrus process into
+        the executable defined in the config option sendmail.
+        The executable must accept \"-bs\" as command line
+        argument, read from stdin and must implement the minimum
+        SMTP protocol as defined in section 4.5.1 of :rfc:`5321`.
+
+        If the SMTP EHLO command reports AUTH (:rfc:`4954`) as a
+        supported extension, then the MAIL FROM command includes
+        the AUTH parameter, with its value set to the name of any
+        authenticated user which triggered the email. The AUTH
+        parameter is omitted if the user is unknown to the calling
+        process.
+
+        If the directory
+        *configdirectory*/log/smtpclient.\ *smtp_backend*
+        exists, then telemetry logs for outgoing SMTP sessions will
+        be created in this directory.
+
+        Allowed values: *host*, *sendmail*
+
+
+    .. endblob smtp_backend
+
+    .. startblob smtp_host
+
+    ``smtp_host:`` localhost:587
+
+        The SMTP host to use for sending mail (also see the
+        smtp_backend option). The value of this option must
+        the name or IP address of a TCP host, followed optionally
+        by a colon and the port or service to use. The default
+        port is 587. TLS may be activated by appending \"/tls\"
+        to the value. Authentication is enabled if smtp_auth_authname
+        is set. Authentication can be explicitly disabled by appending
+        \"/noauth\" to the host address. 
+
+    .. endblob smtp_host
+
+    .. startblob smtp_auth_authname
+
+    ``smtp_auth_authname:`` <none>
+
+        The authentication name to use when authenticating to the SMTP
+        server defined in smtp_host. 
+
+    .. endblob smtp_auth_authname
+
+    .. startblob smtp_auth_password
+
+    ``smtp_auth_password:`` <none>
+
+        The password to use when authenticating to the SMTP server defined
+        in smtp_host. 
+
+    .. endblob smtp_auth_password
+
+    .. startblob smtp_auth_realm
+
+    ``smtp_auth_realm:`` <none>
+
+        The authentication SASL realm to use when authenticating to a SMTP
+        server. 
+
+    .. endblob smtp_auth_realm
+
     .. startblob soft_noauth
 
     ``soft_noauth:`` 1
@@ -3849,7 +4576,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for caching sort results (currently only
         used for xconvmultisort) 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob sortcache_db
@@ -3866,43 +4593,25 @@ FIELD DESCRIPTIONS
 
     .. endblob specialuse_extra
 
-    .. startblob specialusealways
-
-    ``specialusealways:`` 0
-
-        If enabled, this option causes LIST and LSUB output to always include
-        the XLIST "special-use" flags 
-
-    .. endblob specialusealways
-
-    .. startblob sphinx_text_excludes_odd_headers
-
-    ``sphinx_text_excludes_odd_headers:`` 0
-
-        If enabled, Sphinx will perform a TEXT search as if it matches
-        FROM, TO, CC, BCC or SUBJECT but not any other headers.  This
-        is contrary to the RFC but a more useful behaviour for most
-        users.  Default: disabled. 
-
-    .. endblob sphinx_text_excludes_odd_headers
+    .. startblob specialuse_protect
 
-    .. startblob sphinx_socket
+    ``specialuse_protect:`` \\Archive \\Drafts \\Important \\Junk \\Sent \\Trash
 
-    ``sphinx_socket:`` {configdirectory}/socket/sphinx
+        Whitespace separated list of special-use attributes
+        to protect the mailboxes for.  If set, don't allow
+        mailboxes with these special use attributes to be deleted
+        or renamed to have a different parent. Default is the built-in list
 
-        Unix domain socket that the Sphinx searchd
-        daemons listens on. 
+    .. endblob specialuse_protect
 
-    .. endblob sphinx_socket
-
-    .. startblob sphinx_pidfile
-
-    ``sphinx_pidfile:`` /var/run/sphinx.pid
+    .. startblob specialusealways
 
-        File where the Sphinx searchd daemon writes its pid. 
+    ``specialusealways:`` 1
 
+        If enabled, this option causes LIST and LSUB output to always include
+        the XLIST "special-use" flags 
 
-    .. endblob sphinx_pidfile
+    .. endblob specialusealways
 
     .. startblob sql_database
 
@@ -3960,6 +4669,52 @@ FIELD DESCRIPTIONS
 
     .. endblob sql_usessl
 
+    .. startblob srs_alwaysrewrite
+
+    ``srs_alwaysrewrite:`` 0
+
+        If true, perform SRS rewriting for ALL forwarding, even when not required. 
+
+
+    .. endblob srs_alwaysrewrite
+
+    .. startblob srs_domain
+
+    ``srs_domain:`` <none>
+
+        The domain to use in rewritten addresses. This must point only to machines
+        which know the encoding secret used by this system. When present, SRS is
+        enabled. 
+
+    .. endblob srs_domain
+
+    .. startblob srs_hashlength
+
+    ``srs_hashlength:`` 0
+
+        The hash length to generate in a rewritten address. 
+
+
+    .. endblob srs_hashlength
+
+    .. startblob srs_secrets
+
+    ``srs_secrets:`` <none>
+
+        A list of secrets with which to generate addresses. 
+
+
+    .. endblob srs_secrets
+
+    .. startblob srs_separator
+
+    ``srs_separator:`` <none>
+
+        The separator to appear immediately after SRS[01] in rewritten addresses. 
+
+
+    .. endblob srs_separator
+
     .. startblob srvtab
 
     ``srvtab:`` <empty string>
@@ -3987,7 +4742,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the subscriptions list. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob subscription_db
@@ -4019,7 +4774,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the imap status cache. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob statuscache_db
@@ -4139,12 +4894,15 @@ FIELD DESCRIPTIONS
 
     .. startblob sync_repeat_interval
 
-    ``sync_repeat_interval:`` 1
+    ``sync_repeat_interval:`` 1s
 
-        Minimum interval (in seconds) between replication runs in rolling
-        replication mode. If a replication run takes longer than this
-        time, we repeat immediately.
-        Prefix with a channel name to only apply for that channel 
+        Minimum interval between replication runs in rolling replication
+        mode. If a replication run takes longer than this time, we repeat
+        immediately.  Prefix with a channel name to only apply for that
+        channel.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sync_repeat_interval
 
@@ -4160,10 +4918,14 @@ FIELD DESCRIPTIONS
 
     .. startblob sync_timeout
 
-    ``sync_timeout:`` 1800
+    ``sync_timeout:`` 30m
 
-        Number of seconds to wait for a response before returning a timeout
-        failure when talking to a replication peer (client or server). 
+        How long to wait for a response before returning a timeout failure
+        when talking to a replication peer (client or server).  The minimum
+        duration is 3 seconds, the default is 30 minutes.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sync_timeout
 
@@ -4182,8 +4944,14 @@ FIELD DESCRIPTIONS
 
     ``syslog_prefix:`` <none>
 
-        String to be prepended to the process name in syslog entries. 
-
+        String to be prepended to the process name in syslog entries. Can
+        be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+        variable.
+
+        Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+        advantage that it can be set before the **imapd.conf** is read, so
+        errors while reading the config file can be syslogged with the correct
+        prefix. 
 
     .. endblob syslog_prefix
 
@@ -4219,8 +4987,11 @@ FIELD DESCRIPTIONS
 
     ``tcp_keepalive_idle:`` 0
 
-        Number of seconds a connection must be idle before keepalive
-        probes are sent (0 == system default) 
+        How long a connection must be idle before keepalive probes are sent
+        (0 == system default).
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob tcp_keepalive_idle
 
@@ -4228,8 +4999,10 @@ FIELD DESCRIPTIONS
 
     ``tcp_keepalive_intvl:`` 0
 
-        Number of seconds between keepalive probes (0 == system default) 
+        Time between keepalive probes (0 == system default).
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob tcp_keepalive_intvl
 
@@ -4253,22 +5026,27 @@ FIELD DESCRIPTIONS
 
     .. startblob timeout
 
-    ``timeout:`` 32
+    ``timeout:`` 32m
 
-        The length of the IMAP server's inactivity autologout timer,
-        in minutes.  The minimum value is 30.  The default is 32 to
-        allow a bit of leeway for clients that try to NOOP every 30
-        minutes. 
+        The length of the IMAP server's inactivity autologout timer.
+        The minimum value is 30 minutes.  The default is 32 minutes,
+        to allow a bit of leeway for clients that try to NOOP every
+        30 minutes.
+
+        For backward compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob timeout
 
     .. startblob imapidletimeout
 
-    ``imapidletimeout:`` 0
+    ``imapidletimeout:`` <none>
+
+        Timeout for idling clients (:rfc:`2177`).  If not set (the default),
+        the value of "timeout" will be used instead.
 
-        Timeout for idling clients (:rfc:`2177`) in minutes. If set to
-        zero (the default) or less, the value of "timeout" will be
-        used instead. 
+        For backward compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob imapidletimeout
 
@@ -4339,6 +5117,15 @@ FIELD DESCRIPTIONS
 
     .. endblob tls_ciphers
 
+    .. startblob tls_crl_file
+
+    ``tls_crl_file:`` <none>
+
+        Path to a file containing the Certificate Revocation List 
+
+
+    .. endblob tls_crl_file
+
     .. startblob tls_client_ca_dir
 
     ``tls_client_ca_dir:`` <none>
@@ -4448,17 +5235,29 @@ FIELD DESCRIPTIONS
 
     ``tls_server_cert:`` <none>
 
-        File containing the certificate, including the full chain, presented to clients. 
-
+        File containing the certificate, including the full chain, presented to clients.
+        Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+        comma without spaces. 
 
     .. endblob tls_server_cert
 
+    .. startblob tls_server_dhparam
+
+    ``tls_server_dhparam:`` <none>
+
+        File containing the DH parameters belonging to the certificate in
+        tls_server_cert. 
+
+    .. endblob tls_server_dhparam
+
     .. startblob tls_server_key
 
     ``tls_server_key:`` <none>
 
         File containing the private key belonging to the certificate in
-        tls_server_cert. 
+        tls_server_cert.  If not set, tls_server_cert must contain both private and
+        public key.  Two files with keys can be set, if two certifates are used, in
+        which case the files must be separated with comma without spaces 
 
     .. endblob tls_server_key
 
@@ -4468,7 +5267,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the TLS cache. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob tls_sessions_db
@@ -4484,11 +5283,14 @@ FIELD DESCRIPTIONS
 
     .. startblob tls_session_timeout
 
-    ``tls_session_timeout:`` 1440
+    ``tls_session_timeout:`` 24h
+
+        The length of time that a TLS session will be cached for later
+        reuse.  The maximum value is 24 hours, also the default.  A
+        value of 0 will disable session caching.
 
-        The length of time (in minutes) that a TLS session will be cached
-        for later reuse.  The maximum value is 1440 (24 hours), the
-        default.  A value of 0 will disable session caching. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob tls_session_timeout
 
@@ -4531,7 +5333,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the user access list. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob userdeny_db
@@ -4616,6 +5418,26 @@ FIELD DESCRIPTIONS
 
     .. endblob virtdomains
 
+    .. startblob virusscan_notification_subject
+
+    ``virusscan_notification_subject:`` Automatically deleted mail
+
+        The text used in the subject of email notifications created by
+        **cyr_virusscan(8)** when deleting infected mail. 
+
+    .. endblob virusscan_notification_subject
+
+    .. startblob virusscan_notification_template
+
+    ``virusscan_notification_template:`` <none>
+
+        The absolute path to a file containing a template to use to describe
+        infected messages that have been deleted by **cyr_virusscan(8)**.
+        See **cyr_virusscan(8)** for specification of the format of this file.
+        If not specified, the builtin default template will be used. 
+
+    .. endblob virusscan_notification_template
+
     .. startblob xbackup_enabled
 
     ``xbackup_enabled:`` 0
@@ -4655,9 +5477,9 @@ FIELD DESCRIPTIONS
 
     ``zoneinfo_db:`` twoskip
 
-        The cyrusdb backend to use for zoneinfo. 
-
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        The cyrusdb backend to use for zoneinfo.  This database is used by the
+        "tzdist" *http_modules*, and is managed by **ctl_zoneinfo(8)**.
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob zoneinfo_db
@@ -4671,6 +5493,20 @@ FIELD DESCRIPTIONS
 
     .. endblob zoneinfo_db_path
 
+    .. startblob zoneinfo_dir
+
+    ``zoneinfo_dir:`` <none>
+
+        The absolute path to the zoneinfo directory, containing timezone
+        definitions as generated by the vzic tool.  If not specified, whatever
+        definitions libical finds will be used.
+
+        If you are providing a Time Zone Data Distribution Service (i.e. you have
+        "tzdist" listed in *http_modules*), then this configuration option MUST
+        be specified. 
+
+    .. endblob zoneinfo_dir
+
     .. startblob object_storage_enabled
 
     ``object_storage_enabled:`` 0
@@ -4714,7 +5550,7 @@ FIELD DESCRIPTIONS
 
     .. startblob openio_rawx_timeout
 
-    ``openio_rawx_timeout:`` 30
+    ``openio_rawx_timeout:`` 30s
 
         The OpenIO timeout to query to the RAWX services (default 30 sec). 
 
@@ -4723,7 +5559,7 @@ FIELD DESCRIPTIONS
 
     .. startblob openio_proxy_timeout
 
-    ``openio_proxy_timeout:`` 5
+    ``openio_proxy_timeout:`` 5s
 
         The OpenIO timeout to query to the PROXY services (default 5 sec). 
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_backups.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_backups.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_backups.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_backups.txt	2020-04-24 02:03:00.000000000 +0000
@@ -135,6 +135,10 @@ Options
 
     With this option, the verification step will be skipped.
 
+.. option:: -j
+
+    Produce output in JSON format.  The default is plain text.
+
 .. option:: -v
 
     Increase the verbosity.  Can be specified multiple times.
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt	2020-04-24 02:03:00.000000000 +0000
@@ -104,6 +104,12 @@ Options
     subset of **-b**; in particular it does not create conversations or
     assign messages to conversations.
 
+.. option:: -S
+
+    If given with **-b**, allows splitting of conversations during the
+    rewrite.   Only do this is changing the maximum conversation size
+    and you need to split those existing conversations.
+
 Examples
 ========
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt	2020-05-04 03:28:02.000000000 +0000
@@ -47,6 +47,12 @@ Options
     matches the configured database type in imapd.conf.  If not, the
     file is automatically converted using the same logic as cvt_cyrusdb.
 
+    If the ``reverseacls`` option in :cyrusman:`imapd.conf(5)` is enabled,
+    and the RACL entries do not exist in the database, they will be
+    generated.  Conversely, if RACL entries do exist in the database,
+    but the ``reverseacls`` option is disabled, then the entries will be
+    cleaned up.
+
 .. option:: -x
 
     Used with ``-r`` to only recover the database, and prevent any
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_mboxlist.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_mboxlist.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_mboxlist.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ctl_mboxlist.txt	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [ **-p** *partition* ] [ **-f** *filename* ]
+    **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [**-y**] [ **-p** *partition* ] [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-u** [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-m** [ **-a** ] [ **-w** ] [ **-i** ] [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-v** [ **-f** *filename* ]
@@ -53,9 +53,14 @@ Options
     When performing a dump, remove the mailboxes dumped from the mailbox
     list (mostly useful when specified with **-p**).
 
+.. option:: -y
+
+    When performing a dump, also list intermediary mailboxes which would
+    be hidden from IMAP.
+
 .. option:: -p partition
 
-    When performing a dump, dump only thise mailboxes that live on
+    When performing a dump, dump only those mailboxes that live on
     *partition*.
 
 .. option:: -f filename
@@ -79,7 +84,7 @@ Options
 
 .. option:: -a
 
-    When used with **-m**, assume the local mailboxes file is authoritiative,
+    When used with **-m**, assume the local mailboxes file is authoritative,
     that is, only change the mupdate server, do not delete any local
     mailboxes.
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cvt_cyrusdb.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cvt_cyrusdb.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cvt_cyrusdb.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cvt_cyrusdb.txt	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,7 @@ Examples
     ::
 
         Usage: /usr/lib/cyrus/bin/cvt_cyrusdb [-C altconfig] <old db> <old db backend> <new db> <new db backend>
-        Usable Backends:  berkeley, berkeley-nosync, berkeley-hash, berkeley-hash-nosync, flat, skiplist, quotalegacy
+        Usable Backends:  flat, skiplist, quotalegacy
 
 .. parsed-literal::
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyradm.txt	2020-05-04 04:10:42.000000000 +0000
@@ -211,8 +211,8 @@ Example Usage
  
  Note that in the above example, the \ ``unixhierarchysep``\  setting in
  imapd.conf is set to \ ``0``\ . When using the UNIX
- hierarchy seperator, the \ ``/``\  (forward slash) character would be
- used as the hierarchy seperator, and the example would look as
+ hierarchy separator, the \ ``/``\  (forward slash) character would be
+ used as the hierarchy separator, and the example would look as
  follows:
  
 
@@ -318,6 +318,19 @@ Show help for \ ``command``\  or all com
 
 aliases: \ ``?``\ 
 
+.. _imap-reference-manpages-systemcommands-cyradm-getmetadata:
+
+
+getmetadata
+===========
+
+
+\ **getmetadata**\  [\ *mailbox*\ ]
+
+Display mailbox/server metadata
+
+aliases: \ ``getmd``\ 
+
 .. _imap-reference-manpages-systemcommands-cyradm-info:
 
 
@@ -327,7 +340,7 @@ info
 
 \ **info**\  [\ *mailbox*\ ]
 
-Display the mailbox/server metadata.
+Display the mailbox/server annotations.
 
 .. _imap-reference-manpages-systemcommands-cyradm-listaclmailbox:
 
@@ -648,6 +661,46 @@ The currently supported attributes are:
  
 
 
+.. _imap-reference-manpages-systemcommands-cyradm-setmetadata:
+
+
+setmetadata
+===========
+
+
+\ **setmetadata**\  [--private] mailbox [\ *annotation*\ ] \ *value*\ 
+
+Set metadata on mailbox, where \ *annotation*\  is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/<explicit annotation>].
+
+Note that \ *value*\  with a leading backslash must be escaped with an
+additional backslash.  For example:
+
+
+
+.. code-block:: perl
+
+   setmetadata --private Spam specialuse "\\Junk"
+
+
+Note, too, that "private" annotations are private to the user currently
+authenticated as, not necessarily the owner of the mailbox.  To set
+annotations for another user you must authorize as that user.
+
+In addition to the use of optional flag \ **--private**\ , one may use a more
+explicit syntax, prefixing the annotation with '/shared/' or '/private/'
+as in this example:
+
+
+
+.. code-block:: perl
+
+   setmetadata Spam /private/specialuse "\\Junk"
+
+
+aliases: \ ``setmd``\ 
+
 .. _imap-reference-manpages-systemcommands-cyradm-setquota:
 
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_dbtool.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_dbtool.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_dbtool.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_dbtool.txt	2020-04-08 00:07:13.000000000 +0000
@@ -97,7 +97,8 @@ is typically a Cyrus "flat" format datab
 database version number (currently 2), a list of "wildmat" patterns
 specifying Cyrus services to be denied, and a text message to be
 displayed to the user upon denial. The service names to be matched are
-those as used in :cyrusman:`cyrus.conf(5)`.
+those as used in :cyrusman:`cyrus.conf(5)`.  :cyrusman:`cyr_deny(8)`
+provides more convenient way to manage *user_deny.db*.
 
 .. Note::
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_deny.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_deny.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_deny.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_deny.txt	2020-04-08 00:07:13.000000000 +0000
@@ -26,7 +26,8 @@ Description
 The first synopsis denies user *user* access to Cyrus services, the
 second synopsis allows access again.  **cyr_deny** works by adding an
 entry to the Cyrus ``user_deny.db`` database; the third synopsis lists
-the entries in the database.
+the entries in the database.  The service names to be matched are those
+as used in :cyrusman:`cyrus.conf(5)`.
 
 **cyr_deny** |default-conf-text|
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_expire.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_expire.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_expire.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_expire.txt	2020-04-24 02:03:00.000000000 +0000
@@ -31,13 +31,20 @@ on Cyrus databases, specifically:
 - expire entries from the duplicate delivery database, and
 - cleanse mailboxes of partially expunged messages (when using the "delayed" expunge mode), and
 - remove deleted mailboxes (when using the "delayed" delete mode), and
-- expire entries from conversations databases.
+- expire entries from conversations databases, and
+- archive messages from mailbox.
 
-The expiration of messages is controlled by the
-``/vendor/cmu/cyrus-imapd/expire`` mailbox annotation which specifies
-the age (in days) of messages in the given mailbox that should be
-deleted.  A value of 0 means that no expiration is to be performed on
-that mailbox.
+There are various annotations that **cyr_expire** respects:
+
+- ``/vendor/cmu/cyrus-imapd/expire`` which controls the expirations of
+  messages
+- ``/vendor/cmu/cyrus-imapd/archive`` which controls the archival of
+  messages
+- ``/vendor/cmu/cyrus-imapd/delete`` which controls the deletion of
+  messages
+
+These mailbox annotations specify the age(in days) of messages in the
+given mailbox that should be expired/archived/deleted.
 
 The value of the ``/vendor/cmu/cyrus-imapd/expire`` annotation is
 inherited by all children of the mailbox on which it is set, so an
@@ -52,7 +59,8 @@ The annotation can be examined using the
 
 Expiration of duplicate delivery database entries for a given mailbox
 is also controlled by the ``/vendor/cmu/cyrus-imapd/expire`` annotation
-which applies to that mailbox.  Unlike message expiration, if no
+which applies to that mailbox.  A value of 0 on the annotation means
+that no expiration is to be performed on that mailbox. Unlike message expiration, if no
 annotation applies to the mailbox then duplicate database entries are
 expired using the value given to the **-E** option.
 
@@ -82,6 +90,8 @@ Options
     archive partition, allowing mailbox messages to be split between fast
     storage and slow large storage.  Only does anything if
     ``archivepartition-*`` has been set in your config.
+    This value is only used for entries which do not have a
+    corresponding ``/vendonr/cmu/cyrus-imapd/archive`` mailbox annotation.
 
     |v3-new-feature|
 
@@ -93,6 +103,8 @@ Options
     specify the unit of time.  If no suffix, the value is number of days.
     Valid suffixes are **d** (days), **h** (hours), **m** (minutes) and
     **s** (seconds).
+    This value is only used for entries which do not have a
+    corresponding ``/verdor/cmu/cyrus-imapd/delete`` mailbox annotation.
 
 .. option:: -E expire-duration
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_info.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_info.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_info.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_info.txt	2020-04-24 02:03:00.000000000 +0000
@@ -35,17 +35,27 @@ configuring Cyrus easier.
 
 .. option:: conf
 
-    Print only the configuration options which are not the same as
-    default (regardless of whether you have specified them or not).
+    Print the configuration options which have been set to a value
+    other than their default, and their value.
 
-.. option:: conf-default
-
-    Print all default configuration options, ignoring those set locally.
+    With **-s version**, configuration options whose behaviour has
+    changed since *version* will be highlighted.
 
 .. option:: conf-all
 
-    Print ALL configuration options - including default options.  This
-    command shows which options will be in effect at runtime.
+    Print ALL configuration options and their configured values (including
+    those using their default value).  This command shows which options
+    will be in effect at runtime.
+
+    With **-s version**, configuration options which have been added or
+    whose behaviour has changed since *version* will be highlighted.
+
+.. option:: conf-default
+
+    Print the default values for all available configuration options.
+
+    With **-s version**, configuration options which have been added or
+    whose behaviour has changed since *version* will be highlighted.
 
 .. option:: conf-lint
 
@@ -75,6 +85,15 @@ Options
 
     Read the configuration as if for the service named *name*.
 
+.. option:: -s version
+
+    Highlight configuration options that have been added or whose behaviour
+    has been modified since *version*.  Use this option after a server upgrade,
+    specifying your previous version, to find which options you need to review
+    and maybe change before starting up the upgraded server.
+
+    For use with the **conf**, **conf-all**, and **conf-default** sub-commands.
+
 Examples
 ========
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_virusscan.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_virusscan.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_virusscan.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/cyr_virusscan.txt	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,7 @@
 .. cyrusman:: cyr_virusscan(8)
 
+.. highlight:: none
+
 .. author: Nic Bernstein (Onlight)
 
 .. _imap-reference-manpages-systemcommands-cyr_virusscan:
@@ -35,9 +37,10 @@ A table of infected messages will be out
 To remove infected messages, use the **-r** flag. Infected messages will be expunged
 from the user's mailbox.
 
-With the notify flag, **-n**, notifications will be appended to the inbox of the mailbox owner,
-containing message digest information for the affected mail.  This
-flag is only works in combination with **-r**.
+With the notify flag, **-n**, notifications will be appended to the inbox of
+the mailbox owner, containing message digest information for the affected mail.
+This flag only works in combination with **-r**.  The notification message
+can by customised by template, for details see `Notifications`_ below.
 
 **cyr_virusscan** can be configured to run periodically by cron(8)
 via crontab(5) or your preferred method (i.e. /etc/cron.hourly), or by
@@ -77,6 +80,44 @@ Options
 
     Produce more verbose output
 
+Notifications
+=============
+
+When the **-n** flag is provided, notifications are sent to mailbox owners
+when infected messages are removed.  One notification is sent per owner,
+containing a digest of each message that was deleted from any of their
+mailboxes.
+
+The default notification subject is "Automatically deleted mail", which
+can be overridden by setting ``virusscan_notification_subject`` in
+:cyrusman:`imapd.conf(5)` to a UTF-8 value.
+
+Each infected message will be described according to the following template::
+
+	The following message was deleted from mailbox '%MAILBOX%'
+	because it was infected with virus '%VIRUS%'
+
+	    Message-ID: %MSG_ID%
+	    Date: %MSG_DATE%
+	    From: %MSG_FROM%
+	    Subject: %MSG_SUBJECT%
+	    IMAP UID: %MSG_UID%
+
+To use a custom template, create a UTF-8 file containing your desired text
+and using the same %-delimited substitutions as above, and set the
+``virusscan_notification_template`` option in :cyrusman:`imapd.conf(5)` to
+its path.
+
+The notification message will be properly MIME-encoded at delivery. Do not
+pre-encode the template file or the subject!
+
+When **cyr_virusscan** starts up, if notifications have been requested (with
+the **-n** flag), a basic sanity check of the template will be performed
+prior to initialising the antivirus engine.  If it appears that the
+resultant notifications would be undeliverable for some reason,
+**cyr_virusscan** will exit immediately with an error, rather than risk
+deleting messages without notifying.
+
 Examples
 ========
 
@@ -114,7 +155,7 @@ Examples
 ..
 
         Scan mailbox *user/bovik*, removing infected messages and append
-        notifications to bovik's inbox.
+        notifications to Bovik's inbox.
 
 .. only:: html
 
@@ -130,12 +171,12 @@ Examples
 
     ::
 
-        The following message was deleted from mailbox 'Inbox.bovik'
+        The following message was deleted from mailbox 'INBOX'
         because it was infected with virus 'Email.Trojan.Trojan-1051'
 
             Message-ID: <201308131519.r7DFJM9K083763@tselina.kiev.ua>
             Date: Tue, 13 Aug 2013 18:19:22 +0300 (EEST)
-            From: ("FEDEX Thomas Cooper" NIL "thomas_cooper94" "themovieposterpage.com")
+            From: "FEDEX Thomas Cooper" <thomas_cooper94@themovieposterpage.com>
             Subject: Problem with the delivery of parcel
             IMAP UID: 17426
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/imapd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/imapd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/imapd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/imapd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,109 +10,4 @@
 
 IMAP server process
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **imapd** [ **-C** *config-file* ] [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ]
-        [ **-s** ] [ **-N** ] [ **-p** *ssf* ]
-
-Description
-===========
-
-**imapd** is an IMAP4rev1 server.  It accepts commands on its standard
-input and responds on its standard output.  It MUST be invoked by
-:cyrusman:`master(8)` with those descriptors attached to a remote client
-connection.
-
-**imapd** |default-conf-text|
-
-If the file ``msg/shutdown`` is created under the directory specified in
-the ``configdirectory`` configuration option, then **imapd** will shut
-down the connection, sending the first line contained in the file to the
-client as the reason.  New connections are denied.
-
-If the file ``msg/motd`` is created under the directory specified in the
-``configdirectory`` configuration option, then **imapd** will send the
-first line contained in the file to clients upon connect as an ALERT
-message which IMAP-compliant clients are required to display.
-
-This option serves to annoy users mostly.  Unfortunately clients tend to
-connect far more frequently than is apparent, generating a separate
-server ALERT for each connection.  Many clients do not display these
-properly, if they do anything with them at all.
-
-If the directory ``log``\/*user* exists under the directory specified in
-the ``configdirectory`` configuration option, then **imapd** will create
-protocol telemetry logs for sessions authenticating as *user*.
-
-The telemetry logs will be stored in the ``log``/\ *user* directory with
-a filename of the **imapd** process-id.
-
-Options
-=======
-
-.. program:: imapd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-.. option:: -U  uses
-
-    The maximum number of times that the process should be used for new
-    connections before shutting down.  The default is 250.
-
-.. option:: -T  timeout
-
-    The number of seconds that the process will wait for a new
-    connection before shutting down.  Note that a value of 0 (zero)
-    will disable the timeout.  The default is 60.
-
-.. option:: -D
-
-    Run external debugger specified in debug_command.
-
-.. option:: -s
-
-    Serve IMAP over SSL (imaps).  All data to and from **imapd** is
-    encrypted using the Secure Sockets Layer.
-
-.. option:: -N
-
-    Bypass password checking.  (Not recommended unless you know what
-    you're doing.)
-
-.. option:: -p  ssf
-
-    Tell **imapd** that an external layer exists.  An *SSF* (security
-    strength factor) of 1 means an integrity protection layer exists.
-    Any higher SSF implies some form of privacy protection.
-
-Examples
-========
-
-**imapd** is commonly included in the SERVICES section of
-:cyrusman:`cyrus.conf(5)` like so:
-
-.. parsed-literal::
-    SERVICES {
-        **imap        cmd="imapd -U 30" listen="imap" prefork=0**
-        **imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100**
-        lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
-        sieve       cmd="timsieved" listen="sieve" prefork=0
-        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
-    }
-
-Files
-=====
-
-/etc/imapd.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`master(8)`
+.. include:: /assets/man-imapdproxyd.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ipurge.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ipurge.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ipurge.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ipurge.txt	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
+    **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-M** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
             [ **-d** *days* | **-b** *bytes* | **-k** *Kbytes* | **-m** *Mbytes* ]
             [ *mailbox-pattern*... ]
 
@@ -34,7 +34,7 @@ of **-d**, **-b**, **-k** or **-m** MUST
 *Ipurge* by default only deletes mail below shared folders, which means
 that mails in mailbox(es) below INBOX.* and user.* stay untouched. Use
 the option **-f** to also delete mail in mailbox(es) below these
-folders.
+folders. Use the **-M** option to not recurse into the mailboxes.
 
 *ipurge* |default-conf-text|
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,76 +10,4 @@
 
 LMTP server process
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **lmtpd** [ **-C** *config-file* ]  [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ] [ **-a** ]
-
-Description
-===========
-
-**lmtpd** is an LMTP server used to deliver mail to the IMAP mailstore.
-It accepts commands on its standard input and responds on its standard
-output. It MUST be invoked by :cyrusman:`master(8)` with those
-descriptors attached to a remote client connection.
-
-**lmtpd** |default-conf-text|
-
-Options
-=======
-
-.. program:: lmtpd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-.. option:: -U  uses
-
-    The maximum number of times that the process should be used for new
-    connections before shutting down.  The default is 250.
-
-.. option:: -T  timeout
-
-    The number of seconds that the process will wait for a new
-    connection before shutting down.  Note that a value of 0 (zero)
-    will disable the timeout.  The default is 60.
-
-.. option:: -D
-
-    Run external debugger specified in debug_command.
-
-.. option:: -a
-
-    Preauthorize connections initiated on an internet socket, instead
-    of requiring LMTP AUTH.  This should only be used for connections
-    coming from trusted hosts.
-
-Examples
-========
-
-**lmtpd** is commonly included in the SERVICES section of
-:cyrusman:`cyrus.conf(5)` like so:
-
-.. parsed-literal::
-    SERVICES {
-        imap        cmd="imapd -U 30" listen="imap" prefork=0
-        imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
-        **lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20**
-        sieve       cmd="timsieved" listen="sieve" prefork=0
-        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
-    }
-
-Files
-=====
-
-/etc/imapd.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`master(8)`
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpproxyd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpproxyd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpproxyd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/lmtpproxyd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -7,3 +7,5 @@
 ==============
 
 This is a hard linked copy of :cyrusman:`lmtpd(8)`, retained for backwards compatibility from when a murder frontend used its own lmtpd binaries.
+
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/master.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/master.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/master.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/master.txt	2020-04-24 02:03:00.000000000 +0000
@@ -25,8 +25,8 @@ Description
 
 **master** is the process that controls all of the Cyrus
 processes. This process is responsible for creating all imapd, pop3d,
-lmtpd and timsieved child processes. This process also initializes the
-Berkeley DB code and performs scheduled cleanup/maintenance.
+lmtpd and sieved child processes. This process also performs scheduled
+cleanup/maintenance.
 
 If this process dies, then no new sessions will be started.
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/mbpath.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/mbpath.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/mbpath.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/mbpath.txt	2020-04-24 02:03:00.000000000 +0000
@@ -15,17 +15,18 @@ Synopsis
 
 .. parsed-literal::
 
-    **mbpath** [ **-C** *config-file* ] [ **-q** ] [ **-s** ] [ **-m** ] [ *mailbox-names*... ]
+    **mbpath** [ **-C** *config-file* ] [ **-l** ] [ **-m** ] [ **-q** ] [ **-s** ] [ **-u** ] [ **-a** | **-A** | **-M** | **-S** | **-U** ] [ *mailbox-names*... ]
 
 Description
 ===========
 
 Given a mailbox name or a space separated list of mailbox names,
-**mbpath** outputs the filesystem path to the mailbox.
-
+**mbpath** outputs the filesystem path(s) of the mailbox.  By default,
+the mailboxes' data partition paths are shown (same as **-D**).
+See `Selectors`_ for selecting which filesystem path(s) to output.
 
 **mbpath** |default-conf-text| It uses <configdirectory>/mailboxes.db
-to locate the mailbox on disk.
+to locate the mailboxes on disk.
 
 Options
 =======
@@ -36,6 +37,15 @@ Options
 
     |cli-dash-c-text|
 
+.. option:: -l
+
+    Local mailboxes only (exits with error for remote or nonexistent mailboxes)
+
+.. option:: -m
+
+    Output the path to the metadata files (if different from the
+    message files).  Legacy, use **-M**.
+
 .. option:: -q
 
     Suppress any error output.
@@ -44,10 +54,36 @@ Options
 
     If any error occurs, stop processing the list of mailboxes and exit.
 
-.. option:: -m
+.. option:: -u
 
-    Output the path to the metadata files (if different from the
-    message files).
+    The specified *mailbox-names* are users, not mailboxes.
+
+Selectors
+=========
+
+.. option:: -A
+
+    Show the mailbox archive path
+
+.. option:: -D
+
+    Show the mailbox data path (*default*)
+
+.. option:: -M
+
+    Show the mailbox metadata path (same as **-m**)
+
+.. option:: -S
+
+    Show the user sieve scripts path
+
+.. option:: -U
+
+    Show the user files path (seen, sub, etc)
+
+.. option:: -a
+
+    Show all paths, as if all selectors were specified
 
 Examples
 ========
@@ -58,7 +94,7 @@ Examples
 
 ..
 
-        Display the path for mailbox *user.jsmith*.
+        Display the data path for mailbox *user.jsmith*.
 
 .. only:: html
 
@@ -68,7 +104,7 @@ Examples
 
 .. parsed-literal::
 
-    **mbpath -m** *user.jsmith*
+    **mbpath -M** *user.jsmith*
 
 ..
 
@@ -80,6 +116,20 @@ Examples
 
         /var/spool/meta/imap/user/jsmith
 
+.. parsed-literal::
+
+    **mbpath -u -S** *jsmith*
+
+..
+
+        Display the sieve scripts path for user *jsmith*.
+
+.. only:: html
+
+    ::
+
+        /var/spool/sieve/j/jsmith
+
 Files
 =====
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/pop3proxyd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/pop3proxyd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/pop3proxyd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/pop3proxyd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,3 +8,5 @@
 
 
 This is a hard linked copy of :cyrusman:`pop3d(8)`, retained for backwards compatibility from when a murder frontend used its own pop3d binaries.
+
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/proxyd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/proxyd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/proxyd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/proxyd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -6,36 +6,6 @@
 **proxyd**
 ==========
 
-In Progress
+Proxyd is a symlink to :cyrusman:`imapd(8)` if you build with murder enabled.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **proxyd** [ **-C** *config-file* ]  
-
-Description
-===========
-
-
-Options
-=======
-
-.. program:: proxyd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-
-
-
-/etc/imapd.conf,
-/etc/cyrus.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`cyrus.conf(5)`
+.. include:: /assets/man-imapdproxyd.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ptloader.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ptloader.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/ptloader.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/ptloader.txt	2020-04-24 02:03:00.000000000 +0000
@@ -22,7 +22,7 @@ Description
 
 **ptloader** interacts with the authorization service, either AFS or
 LDAP, providing group membership information to Cyrus.  When
-``auth_mech: pts`` is set in :cyrusman:`imapd.conf(5)`, **ptsloader**
+``auth_mech: pts`` is set in :cyrusman:`imapd.conf(5)`, **ptloader**
 will then consult the backend specified in the ``pts_module`` setting
 (currently either ``afs`` or ``ldap``).
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/quota.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/quota.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/quota.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/quota.txt	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ *mailbox-prefix*... ]
+    **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ **-u** ] [ *mailbox-spec*... ]
 
 Description
 ===========
@@ -32,13 +32,16 @@ If an optional *domain* is specified wit
 listing (and any inconsistency fixing) is performed only in that domain
 rather than all mailboxes.
 
-If one or more *mailbox-prefix* arguments are specified, the quota
-listing (and inconsistency fixing) is limited to quota roots with names
-that start with one of the given prefixes.
+If one or more *mailbox-spec* arguments are specified, these are interpreted
+as mailbox prefixes, and the quota listing (and inconsistency fixing) is
+limited to quota roots with names that start with one of the given prefixes.
+If the **-u** is provided, *mailbox-spec* arguments are instead interpreted
+as userids, and the quota listing (and inconsistency fixing) is limited to
+quota roots for only the specified users.
 
 .. WARNING::
 
-    Running **quota** with both the **-f** option and *mailbox-prefix*
+    Running **quota** with both the **-f** option and *mailbox-spec*
     arguments is not recommended.
 
 **quota** |default-conf-text|
@@ -61,6 +64,11 @@ Options
     Fix any inconsistencies in the quota subsystem before generating a
     report.
 
+.. option:: -n
+
+    Check for any inconsistencies in the quota subsystem but don't actually
+    fix them.  Use with **-f** and **-q** to only see what's incorrect.
+
 .. option:: -q
 
     Operate quietly. If **-f** is specified, then don't print the quota
@@ -70,10 +78,15 @@ Options
 
     Output the quota values as JSON for automated tooling support
 
-.. option:: mailbox-prefix
+.. option:: -u
+
+    Interpret *mailbox-spec* arguments as userids.  The default is to
+    interpret them as mailbox prefixes
+
+.. option:: mailbox-spec
 
-    Only report and/or fix quota in mailboxes starting with the
-    specified *mailbox-prefix*.
+    Only report and/or fix quota in mailboxes matching the specified
+    *mailbox-spec* arguments.  See also **-u**.
 
 Examples
 ========
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/reconstruct.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/reconstruct.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/reconstruct.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/reconstruct.txt	2020-04-24 02:03:00.000000000 +0000
@@ -17,7 +17,7 @@ Synopsis
 
     **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
         [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
-        [ **-O** ] [ **-M** ] *mailbox*...
+        [ **-O** ] [ **-M** ] [ **-V** *version* ] *mailbox*...
 
     **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
         [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
@@ -94,7 +94,7 @@ Options
 
     Don't stat underlying files.  This makes reconstruct run faster, at
     the expense of not noticing some issues (like zero byte files or
-    size mistmatches).  "**reconstruct -s**" should be quite fast.
+    size mismatches).  "**reconstruct -s**" should be quite fast.
 
 .. option:: -q
 
@@ -229,7 +229,7 @@ Examples
 
 ..
 
-        Recusively reconstruct all mailboxes belonging to *jsmith*,
+        Recursively reconstruct all mailboxes belonging to *jsmith*,
         restoring any directories containing ``cyrus.header`` files.
 
 .. only:: html
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/rehash.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/rehash.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/rehash.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/rehash.txt	2020-04-24 02:03:00.000000000 +0000
@@ -50,12 +50,12 @@ Options
     In -n "no change" mode, it will just print the changes.  Note,
     verbose is always turned on in no-change mode.
 
-.. option:: -f | -F
+.. option:: -f \| -F
 
     | -f forces fulldirhash: no
     | -F forces fulldirhash: yes
 
-.. option:: -i
+.. option:: -i \| -I
 
     |  -i forces hashimapspool: no
     |  -I forces hashimapspool: yes
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/smmapd.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/smmapd.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/smmapd.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/smmapd.txt	2020-04-24 02:03:00.000000000 +0000
@@ -55,6 +55,21 @@ Options
 Examples
 ========
 
+**smmapd** is commonly included in the SERVICES section of
+:cyrusman:`cyrus.conf(5)` like so:
+
+.. parsed-literal::
+    SERVICES {
+        imap        cmd="imapd -U 30" listen="imap" prefork=0
+        imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+        lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+        **smmap       cmd="smmapd" listen="/var/run/cyrus/socket/smmap" prefork=0**
+        sieve       cmd="timsieved" listen="sieve" prefork=0
+        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+    }
+
+
 Files
 =====
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/squatter.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/squatter.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/squatter.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/squatter.txt	2020-04-24 02:03:00.000000000 +0000
@@ -19,13 +19,12 @@ Synopsis
     **squatter** [ **-C** *config-file* ] [**mode**] [**options**] [**source**]
 
     i.e.:
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  *mailbox*...
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  **-u** *user*...
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] **-I** *file*
-    **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ]  [ **-S** *seconds* ] [ **-u** *user*... ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] *mailbox*...
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] **-u** *user*...
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-U** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ] [ **-S** *seconds* ] [ **-u** *user*... ]
 
 
 
@@ -47,7 +46,7 @@ The index is a unified index of all of t
 of each message in a given mailbox.  This index is used to significantly
 reduce IMAP SEARCH times on a mailbox.
 
-**mode** is one of indexer, indexfrom (-I), search, rolling, synclog or compact.
+**mode** is one of indexer, search, rolling, synclog, compact or audit.
 
 By default, **squatter** creates an index of ALL messages in the
 mailbox, not just those since the last time that it was run.  The
@@ -82,20 +81,27 @@ In the fifth synopsis, **squatter** read
 performs incremental indexing on the mailbox(es) listed therein.  This
 is sometimes useful for cleaning up after problems with rolling mode.
 
-In the sixth synopsis, **squatter** reads *file* containing *mailbox*
-*uid* tuples and performs indexing on the specified messages.
-
-In the seventh synopsis, **squatter** will compact indices from
+In the sixth synopsis, **squatter** will compact indices from
 *srctier(s)* to *desttier*, optionally reindexing (**-X**) or filtering
-expunged records (**-F**) in the process.  The optional **-T** flag may
-be used to specify a directory to use for temporary files.  The **-o**
-flag may be used to direct that a single index be copied, rather than
-compacted, from *srctier* to *desttier*.  The **-u** flag may be used
-to restrict operation to the specified user(s).
+expunged records (**-F**) in the process.  The optional **-T** flag may be
+used to specify a directory to use for temporary files.  These files are
+eventually copied with `rsync -a` and then removed by `rm`.
+`rsync` can increase the load average of the system, especially when the
+temporary directory is on `tmpfs`.  To throttle `rsync` it is possible to
+modify the call in `imap/search_xapian.c` and pass `-\\-bwlimit=<number>` as further
+parameter.  The **-o** flag may be used to direct that a single index be
+copied, rather than compacted, from *srctier* to *desttier*.  The **-u** flag
+may be used to restrict operation to the specified user(s).
 
-For all modes, the **-S** option may be specified, causing squatter to
+For all modes, the **-S** option may be specified, causing **squatter** to
 pause *seconds* seconds after each mailbox, to smooth loads.
 
+When using the Xapian engine the **-Z** option may be specified, for
+the indexing modes.  This tells **squatter** to consult the Xapian
+internally indexed GUIDs, rather than relying on what's stored in
+`cyrus.indexed.db`, allowing for recovery from broken
+`cyrus.indexed.db` at the sacrifice of efficiency.
+
 .. Note::
     Incremental updates are very inefficient with the SQUAT search
     engine.  If using SQUAT for large and active mailboxes, you should
@@ -130,6 +136,11 @@ Options
     inherit one), then the mailbox is not indexed. In other words, the
     implicit value of */vendor/cmu/cyrus-imapd/squat* is "false".
 
+.. option:: -A
+
+    Missing documentation, starts audit mode.
+    |master-new-feature|
+
 .. option:: -d
 
     In rolling mode, don't background and do emit log messages on
@@ -153,11 +164,6 @@ Options
 
     Display this usage information.
 
-.. option:: -I file
-
-    Read from *file* and index individual messages described by
-    mailbox/uid tuples contained therein.
-
 .. option:: -i
 
     Incremental updates where indexes already exist.
@@ -181,6 +187,11 @@ Options
     it to the destination rather than compacting.
     |v3-new-feature|
 
+.. option:: -P
+
+    Missing documentation, reindex parts mode.
+    |master-new-feature|
+
 .. option:: -R
 
     Run in rolling mode; **squatter** runs as a daemon listening to a
@@ -211,7 +222,7 @@ Options
 
 .. option:: -t srctier...
 
-    In compact mode, the comma separated source tier(s) for the compacted
+    In compact mode, the comma-separated source tier(s) for the compacted
     indices.  At least one source tier must be specified in compact mode.
     Xapian only.
     |v3-new-feature|
@@ -222,6 +233,12 @@ Options
     mailbox names.  Usernames are space-separated.
     |v3-new-feature|
 
+.. option:: -U
+
+    In compact mode, only compact if re-indexing.
+    Xapian only.
+    |master-new-feature|
+
 .. option:: -v
 
     Increase the verbosity of progress/status messages.  Sometimes additional messages
@@ -244,6 +261,15 @@ Options
     Xapian only.
     |v3-new-feature|
 
+.. option:: -Z
+
+    When indexing messages, use the Xapian internal cyrusid rather than
+    referencing the ranges of already indexed messages to know if a
+    particular message is indexed.  Useful if the ranges get out of
+    sync with the actual messages (e.g. if files on a tier are lost)
+    Xapian only.
+    |master-new-feature|
+
 Examples
 ========
 
@@ -339,3 +365,7 @@ See Also
 ========
 
 :cyrusman:`imapd.conf(5)`, :cyrusman:`cyrus.conf(5)`
+
+.. only:: html
+
+    :ref:`configuring-xapian`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/sync_reset.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/sync_reset.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/systemcommands/sync_reset.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/systemcommands/sync_reset.txt	2020-04-24 02:03:00.000000000 +0000
@@ -23,7 +23,7 @@ Description
 ===========
 
 **sync_reset** is a small utility program to destroy user accounts on a
-system.  The only safeguard which is in place is the obligary force
+system.  The only safeguard which is in place is the obligatory force
 option.
 
 **sync_reset** |default-conf-text|
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/httptest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/httptest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/httptest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/httptest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,121 +8,10 @@
 
 Interactive HTTP test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **httptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-**httptest** is a utility that allows you to authenticate to a
-HTTP server and interactively issue requests to it. Once
-authenticated you may issue any HTTP request by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an http server. Also those developing HTTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: httptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **http** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **httptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify one of *Basic*, *Digest*, *NTLM*, or
-    *Negotiate* (GSS-SPNEGO).
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable HTTP over SSL (https).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send HTTP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`httpd(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/imtest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/imtest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/imtest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/imtest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,148 +8,6 @@
 **imtest**
 ==========
 
-Interactive IMAP test program
+Interactive IMAP test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
-        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
-        [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
-        [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
-        [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**imtest** is a utility that allows you to authenticate to a IMAP or
-IMSP server and interactively issue commands to it. Once authenticated
-you may issue any IMAP or IMSP command by simply typing it in. It is
-capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of a imsp or imap server. Also those developing IMAP
-clients find it useful.
-
-Options
-=======
-
-.. program:: imtest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **imap** as defined
-    in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **imtest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented to
-    the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable IMAP over SSL (imaps).
-
-.. option:: -q
-
-    Enable IMAP COMPRESSion (after authentication).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP mechanism
-    to ask for the the one-time password instead of the secret pass-phrase
-    (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -I  file
-
-    Echo the PID of the running process into *file* (This can be useful
-    with -X).
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -z
-
-    Timing test.
-
-.. option:: -x  file
-
-    Open the named socket for the interactive portion.
-
-.. option:: -X  file
-
-    Like -x, only close all file descriptors & daemonize the process.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
-
-:cyrusman:`imapd(8)`
+.. include:: /assets/man-imtest.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/installsieve.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/installsieve.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/installsieve.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/installsieve.txt	2020-04-24 02:03:00.000000000 +0000
@@ -52,9 +52,7 @@ Options
 
     Install a file onto the server. If a script with the same name
     already exists on the server it is overwritten. Upon successfully
-    putting the script on the server the script is set active. If
-    *file* has the extension .script it is chopped when put on the
-    server since sieve names may not contain a '.'.
+    putting the script on the server the script is set active.
 
 .. option:: -a  name
 
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/lmtptest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/lmtptest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/lmtptest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/lmtptest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,122 +10,10 @@
 
 Interactive LMTP test program
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **lmtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
-        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
-        [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-c** ] [ **-i** ]
-        [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard link to :cyrusman:`imtest(1)`.
 
-**lmtptest** is a utility that allows you to authenticate to a LMTP server
-and interactively issue commands to it. Once authenticated you may
-issue any LMTP command by simply typing it in. It is capable
-of multiple SASL authentication mechanisms and handles encryption
-layers transparently. This utility is often used for testing the
-operation of a lmtp server. Also those developing LMTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: lmtptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **lmtp** as defined
-    in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **lmtptest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented to
-    the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP mechanism
-    to ask for the the one-time password instead of the secret pass-phrase
-    (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send LMTP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`lmtpd(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/mupdatetest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/mupdatetest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/mupdatetest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/mupdatetest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,117 +10,10 @@
 
 Interactive MUPDATE test program
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send MUPDATE commands to the server.
 
-    **mupdatetest** [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ] [ **-u** *userid* ]
-        [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ]
-        [ **-q** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**mupdatetest** is a utility that allows you to authenticate to a
-MUPDATE server and interactively issue commands to it. Once
-authenticated you may issue any MUPDATE command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of a mupdate server. Note that you must be an admin in
-order to authenticate to an mupdate server.
-
-Options
-=======
-
-.. program:: mupdatetest
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **mupdate** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **mupdatetest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -q
-
-    Enable MUPDATE COMPRESSion (after authentication).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`mupdate(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/nntptest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/nntptest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/nntptest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/nntptest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,130 +8,10 @@
 **nntptest**
 ============
 
-Interactive NNTP test program
+Interactive NNTP test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
-
-    **nntptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-q** ]
-        [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**nntptest** is a utility that allows you to authenticate to a
-NNTP server and interactively issue commands to it. Once
-authenticated you may issue any NNTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an nntp server. Also those developing NNTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: nntptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **nntp** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **nntptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *user* to use the AUTHINFO USER/PASS
-    commands instead of AUTHINFO SASL.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable NNTP over SSL (nntps).
-
-.. option:: -q
-
-    Enable NNTP COMPRESSion (after authentication)
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+It allows you to authenticate and send NNTP commands to the server.
 
 :cyrusman:`nntpd(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/pop3test.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/pop3test.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/pop3test.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/pop3test.txt	2020-04-24 02:03:00.000000000 +0000
@@ -10,125 +10,10 @@
 
 Interactive POP3 test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **pop3test** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-**pop3test** is a utility that allows you to authenticate to a
-POP3 server and interactively issue commands to it. Once
-authenticated you may issue any POP3 command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an pop3 server. Also those developing POP3 clients
-find it useful.
-
-Options
-=======
-
-.. program:: pop3test
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **pop3** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **pop3test** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *user* to use the USER/PASS commands
-    or *apop* to use the APOP command instead of AUTH.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable POP3 over SSL (pop3s).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send POP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`pop3d(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/sieveshell.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/sieveshell.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/sieveshell.txt	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/sieveshell.txt	2020-05-04 04:10:42.000000000 +0000
@@ -63,14 +63,15 @@ OPTIONS
 
 \ **-u**\  \ *user*\ , \ **--user**\ =\ *user*\ 
  
- The authorization name to request; by default, derived from the
- authentication credentials.
+ The user whose mailboxes you want to work on. If not specified, it uses the same
+ as -a.
  
 
 
 \ **-a**\  \ *authname*\ , \ **--authname**\ =\ *authname*\ 
  
- The user to use for authentication (defaults to current user).
+ The user to use for authentication. If not specified, it defaults to the
+ current login user.
  
 
 
@@ -94,8 +95,7 @@ REFERENCES
 
 
 [MANAGESIEVE] Martin, T.; "A Protocol for Remotely Managing Sieve
-Scripts", draft-ietf-managesieve-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.
+Scripts", RFC 5804; May 2001
 
 
 ******
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/sivtest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/sivtest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/sivtest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/sivtest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -9,121 +9,12 @@
 **sivtest**
 ===========
 
-Interactive MANAGESIEVE test program
+Interactive MANAGESIEVE test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send MANAGESIEVE commands to the server.
 
-    **sivtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**sivtest** is a utility that allows you to authenticate to a
-MANAGESIEVE server and interactively issue commands to it. Once
-authenticated you may issue any MANAGESIEVE command by simply typing it
-in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used for
-testing the operation of a :cyrusman:`timsieved(8)` server. Also those
-developing MANAGESIEVE clients find it useful.
-
-Options
-=======
-
-.. program:: sivtest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **sieve** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **sivtest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`timsieved(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/smtptest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/smtptest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/smtptest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/smtptest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -8,125 +8,12 @@
 **smtptest**
 ============
 
-Interactive SMTP test program
+Interactive SMTP test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send SMTP commands to the server.
 
-    **smtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**smtptest** is a utility that allows you to authenticate to an
-SMTP server and interactively issue commands to it. Once
-authenticated you may issue any SMTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an SMTP server. Also those developing SMTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: smtptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **smtp** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **smtptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable SMTP over SSL (smtps).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :manpage:`sendmail(8)`
diff -pruN 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/synctest.txt 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/synctest.txt
--- 3.0.13-5/doc/html/_sources/imap/reference/manpages/usercommands/synctest.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/reference/manpages/usercommands/synctest.txt	2020-04-24 02:03:00.000000000 +0000
@@ -7,3 +7,5 @@
 ============
 
 Interactive IMAP test program: tests the replication protocol. This is installed as a hard link to :cyrusman:`imtest(1)`.
+
+.. include:: /assets/man-imtest.rst
diff -pruN 3.0.13-5/doc/html/_sources/imap/rfc-support.txt 3.2.0-3/doc/html/_sources/imap/rfc-support.txt
--- 3.0.13-5/doc/html/_sources/imap/rfc-support.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/rfc-support.txt	2020-05-04 03:28:02.000000000 +0000
@@ -54,6 +54,10 @@ The following is an inventory of RFCs su
 
     DEFLATE Compressed Data Format Specification version 1.3
 
+:rfc:`1952`
+
+    GZIP file format specification version 4.3
+
 :rfc:`2033`
 
     Local Mail Transfer Protocol
@@ -149,7 +153,8 @@ The following is an inventory of RFCs su
 
 :rfc:`2617`
 
-    HTTP Authentication: Basic and Digest Access Authentication
+    HTTP Authentication: Basic and Digest Access Authentication,
+    updated by :rfc:`7615`, :rfc:`7616`, :rfc:`7617`.
 
 :rfc:`2817`
 
@@ -388,6 +393,10 @@ The following is an inventory of RFCs su
 
     Sieve Email Filtering: Body Extension
 
+:rfc:`5183`
+
+    Sieve Email Filtering: Environment Extension
+
 :rfc:`5228`
 
     Sieve: A Mail Filtering Language
@@ -432,6 +441,10 @@ The following is an inventory of RFCs su
 
     .. versionadded:: 2.5.0
 
+:rfc:`5293`
+
+    Sieve Email Filtering: Editheader Extension
+
 :rfc:`5321`
 
     Simple Mail Transfer Protocol
@@ -452,10 +465,6 @@ The following is an inventory of RFCs su
 
     Sieve Email Filtering: Reject and Extended Reject Extensions
 
-    .. NOTE::
-
-        Only the ``reject`` action is currently implemented.
-
 :rfc:`5435`
 
     Sieve Email Filtering: Extension for Notifications
@@ -464,13 +473,18 @@ The following is an inventory of RFCs su
 
     Sieve Notification Mechanism: mailto
 
+:rfc:`5463`
+
+    Sieve Email Filtering: Ihave Extension
+
 :rfc:`5464`
 
     The IMAP METADATA Extension
 
-:rfc:`5465`
+:rfc:`5490`
 
-    The IMAP NOTIFY Extension
+    The Sieve Mail-Filtering Language -- Extensions for Checking Mailbox
+    Status and Accessing Mailbox Metadata
 
 :rfc:`5524`
 
@@ -529,7 +543,7 @@ The following is an inventory of RFCs su
 
     .. NOTE::
 
-        SSLv3 is considered insecure as it is vulnerable to POODLE.
+        SSLv3 is considered inscure as it is vulnerable to POODLE.
 
         Support for SSLv3 is being deprecated and removed.
 
@@ -537,18 +551,14 @@ The following is an inventory of RFCs su
 
     Sieve Vacation Extension: "Seconds" Parameter
 
-:rfc:`5463`
-
-    Sieve Email Filtering: Ihave Extension
-
 :rfc:`6154`
 
     IMAP LIST Extension for Special-Use Mailboxes
 
     .. NOTE::
 
-        The LIST and LSUB commands don't return by default the special-use flags,
-        unless ``specialusealways`` is turned explicitly on.
+        The LIST and LSUB commands return the special-use flags, unless the
+	``specialusealways`` configuration variable is explicitly turned off.
 
 :rfc:`6321`
 
@@ -641,7 +651,33 @@ The following is an inventory of RFCs su
 
 :rfc:`7529`
 
-    Non-Gregorian Recurrence Rules in the Internet Calendaring and Scheduling Core Object Specification (iCalendar) (obsoletes draft-ietf-calext-rscale)
+    Non-Gregorian Recurrence Rules in the Internet Calendaring and
+    Scheduling Core Object Specification (iCalendar)
+
+:rfc:`7540`
+
+      Hypertext Transfer Protocol Version 2 (HTTP/2)
+
+:rfc:`7615`
+
+    HTTP Authentication-Info and Proxy-Authentication-Info Response
+    Header Fields
+
+:rfc:`7616`
+
+    HTTP Digest Access Authentication
+
+:rfc:`7617`
+
+    The 'Basic' HTTP Authentication Scheme
+
+:rfc:`7694`
+
+    Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding
+
+:rfc:`7804`
+
+    Salted Challenge Response HTTP Authentication Mechanism
 
 :rfc:`7808`
 
@@ -651,10 +687,20 @@ The following is an inventory of RFCs su
 
     CalDAV: Time Zones by Reference
 
+:rfc:`7932`
+
+    Brotli Compressed Data Format
+
 :rfc:`7953`
 
     Calendar Availability
 
+:rfc:`8144`
+
+    Use of the Prefer Header Field in Web Distributed Authoring and
+    Versioning (WebDAV)
+
+
 IETF RFC Drafts
 ===============
 
@@ -684,29 +730,6 @@ draft-thomson-hybi-http-timeout
 
     Hypertext Transfer Protocol (HTTP) Keep-Alive Header
 
-draft-murchison-webdav-prefer
-
-    Use of the Prefer Header Field in Web Distributed Authoring and
-    Versioning (WebDAV)
-
-
-draft-ietf-httpauth-basicauth-update
-
-    The 'Basic' HTTP Authentication Scheme
-
-draft-ietf-httpauth-digest
-
-    HTTP Digest Access Authentication
-
-draft-ietf-httpbis-auth-info
-
-    The Hypertext Transfer Protocol (HTTP) Authentication-Info and
-    Proxy- Authentication-Info Response Header Fields
-
-draft-ietf-httpbis-cice
-
-    Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding
-
 ..
 
     caldav-ctag     Calendar Collection Entity Tag (CTag) in CalDAV
@@ -715,32 +738,15 @@ draft-ietf-httpbis-cice
 RFC Wishlist
 ============
 
-:rfc:`5183`
-
-    Sieve Email Filtering: Environment Extension
-
 :rfc:`5235`
 
     Sieve Email Filtering: Spamtest and Virustest Extensions
 
-:rfc:`5293`
-
-    Sieve Email Filtering: Editheader Extension
-
-:rfc:`5429`
-
-    Sieve Email Filtering: Reject and Extended Reject Extensions
-
 :rfc:`5437`
 
     Sieve Notification Mechanism: Extensible Messaging and Presence
     Protocol (XMPP)
 
-:rfc:`5490`
-
-    The Sieve Mail-Filtering Language -- Extensions for Checking Mailbox
-    Status and Accessing Mailbox Metadata
-
 :rfc:`5703`
 
     Sieve Email Filtering: MIME Part Tests, Iteration, Extraction,
diff -pruN 3.0.13-5/doc/html/_sources/imap/support/feedback-mailing-lists.txt 3.2.0-3/doc/html/_sources/imap/support/feedback-mailing-lists.txt
--- 3.0.13-5/doc/html/_sources/imap/support/feedback-mailing-lists.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/imap/support/feedback-mailing-lists.txt	2020-04-08 00:07:13.000000000 +0000
@@ -35,13 +35,13 @@ Archives
 The list archives can be accessed as follows:
 
 * **cyrus-announce**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-announce>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-announce>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-announce/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-announce/>`__
 * **info-cyrus**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.info-cyrus>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.info-cyrus>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/info-cyrus/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/info-cyrus/>`__
 * **cyrus-sasl**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-sasl>`__: `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-sasl>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/>`__
 * **cyrus-devel**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-devel>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-devel>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
 
 Subscribe/Unsubscribe
 ---------------------
diff -pruN 3.0.13-5/doc/html/_sources/index.txt 3.2.0-3/doc/html/_sources/index.txt
--- 3.0.13-5/doc/html/_sources/index.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/index.txt	2020-05-04 03:28:02.000000000 +0000
@@ -1,5 +1,6 @@
 .. _imap-index:
 
+===================
 What is Cyrus IMAP?
 ===================
 
@@ -25,6 +26,7 @@ Features
 * Supports antivirus and antispam toolkits
 * Handles deliverability: SPF, DKIM, DMARC
 * Extensive authentication options, through Cyrus SASL
+* JMAP support
 * Long list of supported standards
 
 Read more in our full :ref:`list of features <imap-features>`.
@@ -50,6 +52,7 @@ Need help? We have :ref:`active mailing
 
 --------
 
+===================
 What is Cyrus SASL?
 ===================
 Simple Authentication and Security Layer (SASL_) is a specification that describes how authentication mechanisms can be plugged into an application protocol on the wire. Cyrus SASL is an implementation of SASL that makes it easy for application developers to integrate authentication mechanisms into their application in a generic way.
diff -pruN 3.0.13-5/doc/html/_sources/operations.txt 3.2.0-3/doc/html/_sources/operations.txt
--- 3.0.13-5/doc/html/_sources/operations.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/operations.txt	2020-04-24 02:03:00.000000000 +0000
@@ -7,13 +7,5 @@ Operations
     :maxdepth: 2
 
     imap/reference/manpages/commands
-    imap/reference/administration-tools
     imap/reference/admin
     imap/reference/faq
-
-..
-
-    manpages
-    adminref
-    sop
-    othertasks
diff -pruN 3.0.13-5/doc/html/_sources/overview/cyrus_roadmap.txt 3.2.0-3/doc/html/_sources/overview/cyrus_roadmap.txt
--- 3.0.13-5/doc/html/_sources/overview/cyrus_roadmap.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/overview/cyrus_roadmap.txt	2020-04-24 02:03:00.000000000 +0000
@@ -14,17 +14,17 @@ High Level Roadmap
 Future
 ------
 
-* JMAP support
+* JMAP support (Contacts, calendars and emails)
+* Improved CalDAV and CardDAV support
 * Improved backup support
 * Multi-master replication
 
 3.0.x
 -----
 
-* Better calendaring support through jmap
 * Cross-folder conversations
 * Support for fuzzy Xapian search.
-* CardDAV support
+* CalDAV and CardDAV support
 * Better backup support - initial release
 * Basic object storage
 * Archive partition support
diff -pruN 3.0.13-5/doc/html/_sources/overview.txt 3.2.0-3/doc/html/_sources/overview.txt
--- 3.0.13-5/doc/html/_sources/overview.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/overview.txt	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,6 @@ Overview
 
 .. toctree::
     :maxdepth: 2
-    :glob:
 
     imap/concepts/features
     imap/concepts/overview_and_concepts
diff -pruN 3.0.13-5/doc/html/_sources/quickstart.txt 3.2.0-3/doc/html/_sources/quickstart.txt
--- 3.0.13-5/doc/html/_sources/quickstart.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/html/_sources/quickstart.txt	2020-05-04 04:02:14.000000000 +0000
@@ -1,5 +1,3 @@
-:orphan:
-
 ================
 Quickstart Guide
 ================
@@ -9,12 +7,8 @@ Quickstart Guide
 
     imap/quickstart/introduction
 
-Coming Soon
-===========
-
-.. note::
-
-    The deb packages referenced below are not yet available.  Sorry!
+.. Coming Soon
+.. -----------
 
 Quick install
 =============
@@ -22,62 +16,35 @@ Quick install
 A quick guide to getting a basic installation of Cyrus up and running in 5 minutes.
 
 The first place to start with a new installation of Cyrus IMAP is with
-your OS distribution of choice and their packaging, where available.  If
-there is no Cyrus IMAP 3.0 package available yet from your distro,
-download the `latest stable package`_ : version |imap_current_stable_version|.
+your OS distribution of choice and their packaging, where available.
 
-.. _latest stable package: ftp://ftp.cyrusimap.org/cyrus-imapd/debs/
+If there is no Cyrus IMAP |imap_current_stable_version| package available yet
+from your distro, download the official source tarball from GitHub_.  The
+:ref:`compiling` guide will help you get it built and installed.
 
-We only provide limited options for reference packages, so use a
-supported distribution whenever possible.  At this time the only
-official Cyrus packages are for Debian Jessie (with backports enabled).
+.. _GitHub: https://github.com/cyrusimap/cyrus-imapd/releases
 
-Please download both the packages (\*.deb) and the signature files.
-Installation is a two step process:
 
-1. Install Cyrus reference packages
+1. Install Cyrus package(s)
 -----------------------------------
 
-First, invoke the ``dpkg -i`` command with the list of all packages::
-
-    $ sudo dpkg -i \
-        cyrus-common_3.0.1-jessie_amd64.deb  \
-        cyrus-doc_3.0.1-jessie_all.deb  \
-        cyrus-imapd_3.0.1-jessie_amd64.deb  \
-        cyrus-pop3d_3.0.1-jessie_amd64.deb  \
-        cyrus-admin_3.0.1-jessie_all.deb  \
-        cyrus-murder_3.0.1-jessie_amd64.deb  \
-        cyrus-replication_3.0.1-jessie_amd64.deb  \
-        cyrus-nntpd_3.0.1-jessie_amd64.deb  \
-        cyrus-caldav_3.0.1-jessie_amd64.deb  \
-        cyrus-clients_3.0.1-jessie_amd64.deb  \
-        cyrus-dev_3.0.1-jessie_amd64.deb  \
-        libcyrus-imap-perl_3.0.1-jessie_amd64.deb
-
-That step will produce an error, as there will doubtless be unmet
-dependencies.  Not to worry, there's a fix for that...
-
-2. Use "apt-get install -f" to complete installation
-----------------------------------------------------
-
-Now invoke ``apt-get install -f`` to pull in the dependencies and
-complete the installation::
-
-    $ sudo apt-get install -f
+Install the Cyrus IMAP package(s), either from your distribution's package
+manager, or from a release tarball.
 
-The packaging should pull along all necessary support libraries, etc..
+Your distribution might have split Cyrus IMAP into several packages.  Check
+their documentation if you're not sure what you need.
 
-3. Setup the cyrus:mail user and group
+2. Setup the cyrus:mail user and group
 --------------------------------------
 
 .. include:: /assets/cyrus-user-group.rst
 
-4. Setting up authentication with SASL
+3. Setting up authentication with SASL
 --------------------------------------
 
 .. include:: /assets/setup-sasl-sasldb.rst
 
-5. Setup mail delivery from your MTA
+4. Setup mail delivery from your MTA
 ------------------------------------
 
 Your Cyrus IMAP server will want to receive the emails accepted by your
@@ -88,12 +55,12 @@ protocol called LMTP, which is usually s
 
 .. include:: /assets/setup-postfix.rst
 
-6. Protocol ports
+5. Protocol ports
 -----------------
 
 .. include:: /assets/services.rst
 
-7. Configuring Cyrus
+6. Configuring Cyrus
 --------------------
 
 (Nearly there)
@@ -166,69 +133,14 @@ For example::
     vi /etc/cyrus.conf
     ...
 
-8. Launch Cyrus
+7. Launch Cyrus
 ---------------
 
-If using our packages on Debian Jessie, you will have a SystemV
-compatible init script installed, with systemd support.  Start Cyrus
-with the following command::
-
-    systemctl start cyrus-imapd
-
-Tada!  You should now have a working Cyrus IMAP server.
-
-Feature overview
-----------------
-
-The features (compile-time configuration options) supported in our
-reference packages are:
-
-Cyrus Server configured components
-    * event notification : yes
-    * gssapi             : /usr
-    * autocreate         : yes
-    * idled              : yes
-    * httpd              : yes
-    * kerberos V4        : no
-    * murder             : yes
-    * nntpd              : yes
-    * replication        : yes
-    * sieve              : yes
-    * calalarmd          : no
-    * objectstore        : no
-    * backup             : no
-
-External dependencies
-    * ldap              : yes
-    * openssl           : yes
-    * zlib              : yes
-    * pcre              : yes
-    * clamav            : yes
-    * snmp              : yes
-    * caringo           : no
-    * openio            : no
-    * nghttp2           : no
-    * brotli            : no
-    * xml2              : yes
-    * ical              : yes
-    * icu4c             : no
-    * shapelib          : no
-
-Database support
-    * mysql             : no
-    * postgresql        : no
-    * sqlite            : yes
-    * lmdb              : no
-
-Search engine
-    * squat             : yes
-    * sphinx            : no
-    * xapian            : yes
-    * xapian_flavor     : vanilla
-
-Hardware support
-    * SSE4.2            : yes
-
-Installation directories
-    * prefix            : /usr
-    * sysconfdir        : /etc
+If using a distribution package, you probably now have an init script
+installed, that you can invoke with your system's usual service control
+mechanism.
+
+If you built from source, you will need to write your own init script.
+The simplest one will simply start/stop the :cyrusman:`master(8)` binary,
+with suitable options, as root (master will drop root privileges itself
+as soon as it possibly can).
diff -pruN 3.0.13-5/doc/html/styles.html 3.2.0-3/doc/html/styles.html
--- 3.0.13-5/doc/html/styles.html	2019-12-16 04:18:19.000000000 +0000
+++ 3.2.0-3/doc/html/styles.html	2020-05-04 04:13:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Document Conventions &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Document Conventions &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,7 +37,7 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/> 
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/> 
 
   
   
@@ -127,19 +127,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -156,22 +161,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -328,19 +330,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -389,6 +391,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -416,7 +419,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -505,34 +508,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -549,6 +524,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -565,10 +541,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -581,10 +555,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -645,6 +617,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -664,9 +637,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -724,7 +743,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -744,13 +763,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Document Conventions</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/styles.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/styles.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -837,7 +856,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 29 2019
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 08 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -857,7 +876,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/html/support.html 3.2.0-3/doc/html/support.html
--- 3.0.13-5/doc/html/support.html	2019-12-16 04:18:20.000000000 +0000
+++ 3.2.0-3/doc/html/support.html	2020-05-04 04:13:50.000000000 +0000
@@ -8,7 +8,7 @@
   
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
-  <title>Support/Community &mdash; Cyrus IMAP 3.0.13 (stable) documentation</title>
+  <title>Support/Community &mdash; Cyrus IMAP 3.2.0 documentation</title>
   
 
   
@@ -37,9 +37,9 @@
         <link rel="index" title="Index"
               href="genindex.html"/>
         <link rel="search" title="Search" href="search.html"/>
-    <link rel="top" title="Cyrus IMAP 3.0.13 (stable) documentation" href="index.html"/>
+    <link rel="top" title="Cyrus IMAP 3.2.0 documentation" href="index.html"/>
         <link rel="next" title="Reporting Bugs" href="imap/support/feedback-bugs.html"/>
-        <link rel="prev" title="Cyrus Works" href="imap/developer/cyrusworks.html"/> 
+        <link rel="prev" title="Unit Tests" href="imap/developer/unit-tests.html"/> 
 
   
   
@@ -129,19 +129,24 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#stable-version">Stable Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-version">Development Version</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#supported-product-series">Supported Product Series</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-2">Series 3.2</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-3-0">Series 3.0</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-5">Series 2.5</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-4">Series 2.4</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#development-snapshots">Development snapshots</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/3.1/index.html">Cyrus IMAP 3.1 Tags</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/release-notes/index.html#older-versions">Older Versions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-1">Series 1</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-3">Series 2: 2.0 - 2.3</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/download/release-notes/index.html#series-2-2-0-2-4">Series 2: 2.0 - 2.4</a></li>
 </ul>
 </li>
 </ul>
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/download/packagers.html">Notes for Packagers</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#binary-naming">Binary naming</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#sample-configuration-files">Sample configuration files</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/packagers.html#predefined-configurations">Predefined configurations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/packagers.html#the-configuration-file-for-master-cyrus-conf">The configuration file for master: cyrus.conf</a></li>
@@ -158,22 +163,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/quickstart/introduction.html#what-is-imap">What is IMAP?</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="quickstart.html#coming-soon">Coming Soon</a></li>
 <li class="toctree-l2"><a class="reference internal" href="quickstart.html#quick-install">Quick install</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-reference-packages">1. Install Cyrus reference packages</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#use-apt-get-install-f-to-complete-installation">2. Use &#8220;apt-get install -f&#8221; to complete installation</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">3. Setup the cyrus:mail user and group</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">4. Setting up authentication with SASL</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">5. Setup mail delivery from your MTA</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#install-cyrus-package-s">1. Install Cyrus package(s)</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-the-cyrus-mail-user-and-group">2. Setup the cyrus:mail user and group</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setting-up-authentication-with-sasl">3. Setting up authentication with SASL</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#setup-mail-delivery-from-your-mta">4. Setup mail delivery from your MTA</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-sendmail">Install Sendmail</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#sendmail-communication">Sendmail communication</a></li>
 <li class="toctree-l4"><a class="reference internal" href="quickstart.html#install-postfix">Install Postfix</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">6. Protocol ports</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">7. Configuring Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">8. Launch Cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="quickstart.html#feature-overview">Feature overview</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#protocol-ports">5. Protocol ports</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#configuring-cyrus">6. Configuring Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="quickstart.html#launch-cyrus">7. Launch Cyrus</a></li>
 </ul>
 </li>
 </ul>
@@ -330,19 +332,19 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/installing.html#troubleshooting">Troubleshooting</a></li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.0</a><ul>
+<li class="toctree-l2"><a class="reference internal" href="imap/download/upgrade.html">Upgrading to 3.2</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#preparation">1. Preparation</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#installation-from-tarball">Installation from tarball</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#how-are-you-planning-on-upgrading">How are you planning on upgrading?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/download/upgrade.html#do-what-as-who">Do What As Who?</a></li>
 </ul>
 </li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-0-cyrus">2. Install new 3.0 Cyrus</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#install-new-3-2-cyrus">2. Install new 3.2 Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#shut-down-existing-cyrus">3. Shut down existing Cyrus</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#backup-and-copy-existing-data">4. Backup and Copy existing data</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#copy-config-files-and-update">5. Copy config files and update</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-specific-items">6. Upgrade specific items</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-0-cyrus-and-verify">7. Start new 3.0 Cyrus and verify</a></li>
+<li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#start-new-3-2-cyrus-and-verify">7. Start new 3.2 Cyrus and verify</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#reconstruct-databases-and-cache">8. Reconstruct databases and cache</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#do-you-want-any-new-features">9. Do you want any new features?</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/download/upgrade.html#upgrade-complete">10. Upgrade complete</a></li>
@@ -391,6 +393,7 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html">Performance Recommendations</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#databases-on-temporary-filesystems">Databases on Temporary Filesystems</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/concepts/deployment/performance_recommendations.html#certificates">Certificates</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/concepts/deployment/storage.html">Storage Considerations</a><ul>
@@ -418,7 +421,7 @@
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/manpages/commands.html">Man pages</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/manpages/commands.html#configuration-files">(5) Configuration Files</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/cyrus.conf.html"><strong>cyrus.conf</strong></a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html">imapd.conf</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/imapd.conf.html"><strong>imapd.conf</strong></a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/manpages/configs/krb.equiv.html"><strong>krb.equiv</strong></a></li>
 </ul>
 </li>
@@ -507,34 +510,6 @@
 </li>
 </ul>
 </li>
-<li class="toctree-l2"><a class="reference internal" href="imap/reference/administration-tools.html">Tools &amp; Utilities</a><ul>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitron">arbitron</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#arbitronsort-pl">arbitronsort.pl</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#chk-cyrus">chk_cyrus</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-cyrusdb">ctl_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-deliver">ctl_deliver</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#ctl-mboxlist">ctl_mboxlist</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb">cvt_cyrusdb</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cvt-cyrusdb-all">cvt_cyrusdb_all</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-dbtool">cyr_dbtool</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-df">cyr_df</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyrdump">cyrdump</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-expire">cyr_expire</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-virusscan">cyr_virusscan</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#fetchnews">fetchnews</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-sequence">cyr_sequence</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-synclog">cyr_synclog</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#cyr-userseen">cyr_userseen</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#masssievec">masssievec</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbexamine">mbexamine</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mbpath">mbpath</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mkimap">mkimap</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#mknewsgroups">mknewsgroups</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#rehash">rehash</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#translatesieve">translatesieve</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/reference/administration-tools.html#undohash">undohash</a></li>
-</ul>
-</li>
 <li class="toctree-l2"><a class="reference internal" href="imap/reference/admin.html">Administrator Guide</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/admin.html#architecture">Architecture</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/architecture.html">System Architecture</a></li>
@@ -551,6 +526,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/protlayer.html">Cyrus Prot Layer</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/sop.html">Standard Operating Procedures</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/eventsource.html">Cyrus Event Source</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/monitoring.html">Monitoring</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/config-mailboxdistribution.html">Mailbox Distribution</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/murder/murder.html">Cyrus Murder</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/admin/nginx-proxy.html">HOWTO: Using an NGINX IMAP Proxy</a></li>
@@ -567,10 +543,8 @@
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#installation-problems">Installation Problems</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-compilationerrors.html">Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-detecting-berkeley.html">Problems detecting Berkley DB on Red Hat Linux</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-install-help.html">Help! There must be an easier way to get all this going...</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html">OpenSSL Version Mismatches</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/install-linkerwarnings.html#libical-v1-0-1-or-v2-0">Libical v1.0.1 or v2.0</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-feature-requests">Common Feature Requests</a><ul>
@@ -583,10 +557,8 @@
 <li class="toctree-l3"><a class="reference internal" href="imap/reference/faq.html#common-operational-questions">Common Operational Questions</a><ul>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-acls.html">How do I view ACLs on a mailbox?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-annotations.html">What annotations are available?</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-berkeleydb.html">Why does ctl_cyrusdb -r take so long with Berkeley DB?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-configdir-tempfs.html">Is it safe to put &lt;configdirectory&gt;/proc and &lt;configdirectory&gt;/lock on a tmpfs filesystem?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-coredump.html">How to enable core dumps</a></li>
-<li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-db3-lockers.html">Is the &#8220;db3: x Lockers&#8221; log message harmful?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-delete-mailbox.html">Why can I not delete a mailbox as an admin user?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deleted-expired-expunged-purged.html">When is What ... Deleted, Expired, Expunged or Purged?</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/reference/faqs/o-deliverdb-size.html">Why is deliver.db so large?</a></li>
@@ -647,6 +619,7 @@
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/compiling.html">Compiling</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/installing.html">Installing Cyrus</a></li>
 <li class="toctree-l4"><a class="reference internal" href="imap/developer/developer-testing.html">Developer Test Environment</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/jmap.html">JMAP support</a></li>
 </ul>
 </li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer.html#system-files-and-databases">System files and Databases</a><ul>
@@ -666,9 +639,55 @@
 </li>
 <li class="toctree-l2"><a class="reference internal" href="imap/developer/cyrusworks.html">Cyrus.Works</a><ul>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#about-cyrus-works">About Cyrus Works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#testing">Testing</a></li>
 <li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#how-it-works">How it works</a></li>
-<li class="toctree-l3"><a class="reference internal" href="imap/developer/cyrusworks.html#adding-rules">Adding Rules</a></li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#cyrus-internals">Cyrus Internals</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/API.html">Cyrus APIs</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb.html">CyrusDB API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/cyrusdb2.html">cyrusdb API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/index-api.html">Index API</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/API/mailbox-api.html">Mailbox API</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/thoughts.html">Thoughts &amp; Notes</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/backup.html">Notes for backup implementation</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/bytecode.html">Cyrus IMAP Server: Sieve Bytecode</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/caldav_scheduling_flowchart.html">Cyrus CalDAV Scheduling Flowchart</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/improved_mboxlist_sort.html">Enabling improved_mboxlist_sort</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/notes.html">Cyrus IMAP Server: Notes</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/thoughts/prot-events.html">Cyrus IMAP Server: Prot Events</a></li>
+</ul>
+</li>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/guidance.html">Guidance for Developers</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/hacking.html">Cyrus IMAP Server: Hacking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/internationalization.html">Cyrus IMAP Server: Internationalization</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/locking.html">Cyrus IMAP Server: Locking</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/mailbox-format.html">Cyrus IMAP Server: Mailbox File Formats</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/namelocks.html">Cyrus IMAP Server: Namelocks</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/prot.html">Cyrus IMAP Server: prot layer</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_examples.html">Cyrus IMAP Server: Replication Examples</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/replication_protocol.html">Cyrus IMAP Server: Replication Protocol v2.4+</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/special_chars.html">Cyrus IMAP Server: Special Characters</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/guidance/var_directory_structure.html">Cyrus IMAP Server: var directory structure</a></li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="toctree-l2"><a class="reference internal" href="developers.html#unit-tests">Unit Tests</a><ul>
+<li class="toctree-l3"><a class="reference internal" href="imap/developer/unit-tests.html">Unit Tests</a><ul>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#table-of-contents">Table of Contents</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#introduction">1. Introduction</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#what-is-a-unit-test">2. What Is A Unit Test?</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#running-the-tests">3. Running The Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#debugging-a-test">3.6 Debugging A Test</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-your-own-tests">4. Adding Your Own Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#where-to-put-your-tests">4.1 Where To Put Your Tests</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-new-suite">4.1 Adding A New Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#adding-a-test-to-a-suite">4.2 Adding A Test To A Suite</a></li>
+<li class="toctree-l4"><a class="reference internal" href="imap/developer/unit-tests.html#suite-setup-and-teardown">4.3 Suite Setup And Teardown</a></li>
+</ul>
+</li>
 </ul>
 </li>
 </ul>
@@ -726,7 +745,7 @@
       </div>
         
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">cyrus-imapd-3.0: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">cyrus-imapd-3.2: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.2"></a>
 </div>
       &nbsp;
     </nav>
@@ -746,13 +765,13 @@
 
           <div role="navigation" aria-label="breadcrumbs navigation">
   <ul class="wy-breadcrumbs">
-      <li><a href="index.html">Docs v3.0.13 (stable)</a> &raquo;</li>
+      <li><a href="index.html">Docs v3.2.0</a> &raquo;</li>
       
     <li>Support/Community</li>
       <li class="wy-breadcrumbs-aside">
         
           
-            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.0/docsrc/support.rst" class="fa fa-github"> Edit on GitHub</a>
+            <a href="https://github.com/cyrusimap/cyrus-imapd/blob/cyrus-imapd-3.2/docsrc/support.rst" class="fa fa-github"> Edit on GitHub</a>
           
         
       </li>
@@ -783,7 +802,7 @@
         <a href="imap/support/feedback-bugs.html" class="btn btn-neutral float-right" title="Reporting Bugs" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
       
       
-        <a href="imap/developer/cyrusworks.html" class="btn btn-neutral" title="Cyrus Works" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
+        <a href="imap/developer/unit-tests.html" class="btn btn-neutral" title="Unit Tests" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
       
     </div>
   
@@ -792,7 +811,7 @@
 
   <div role="contentinfo">
     <p>
-        &copy; Copyright 1993-2017, The Cyrus Team. Last updated on May 11 2017
+        &copy; Copyright 1993-2018, The Cyrus Team. Last updated on May 11 2017
     </p>
   </div>
   Built with <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.9 using a modified <a href="https://readthedocs.org">Read the Docs</a> <a href="https://github.com/snide/sphinx_rtd_theme">theme</a>.
@@ -812,7 +831,7 @@
     <script type="text/javascript">
         var DOCUMENTATION_OPTIONS = {
             URL_ROOT:'./',
-            VERSION:'3.0.13 (stable)',
+            VERSION:'3.2.0',
             COLLAPSE_INDEX:false,
             FILE_SUFFIX:'.html',
             HAS_SOURCE:  true
diff -pruN 3.0.13-5/doc/internal/backup 3.2.0-3/doc/internal/backup
--- 3.0.13-5/doc/internal/backup	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/backup	2020-04-24 02:03:00.000000000 +0000
@@ -196,7 +196,7 @@ there doesn't seem to be anything preven
 general (non-INBOX) case.
 
 renames might be a little easier to handle if the index replicated the mailbox
-heirarchy rather than just being a flat structure.  though this adds complexity
+hierarchy rather than just being a flat structure.  though this adds complexity
 wrt hiersep handling.  something like:
 
  mailbox:
@@ -333,7 +333,7 @@ we introduce a new command, RESTORE MAIL
 APPLY MAILBOX.  it specifies, for a mailbox, the mailbox state plus the message
 records relevant to the restore.
 
-the imapd/sync_server recieving the RESTORE command creates the mailbox if necessary,
+the imapd/sync_server receiving the RESTORE command creates the mailbox if necessary,
 and then adds the message records to it as new records (i.e. generating new uid etc).
 this will end up generating new events in the backup channel's sync log, and then the
 messages will be backed up again with their new uids, etc.  additional wire transfer
@@ -553,7 +553,7 @@ happily, even though reconstruct might d
 correct one for that user...
 
 a backup server would generally be used only for backups, and sync_client
-is quite resilient when the destinatition isn't there, so it's actually
+is quite resilient when the destination isn't there, so it's actually
 no problem to just shut down cyrus while reconstruct runs.  no outage to
 user-facing services, just maybe some sync backlog to catch up on once
 cyrus is restarted.
@@ -600,7 +600,7 @@ mode:
     -P                  # specified backups interpreted as userid prefixes (nvfsbc)
     -f                  # specified backups interpreted as filenames
     -m                  # specified backups interpreted as mboxnames
-    -u                  # specified backups interpteted as userids (default)
+    -u                  # specified backups interpreted as userids (default)
 
 lock_opts:
     -c                  # exclusively create backup
@@ -642,7 +642,7 @@ options:
 mode:
     -f                  # backup interpreted as filename
     -m                  # backup interpreted as mboxname
-    -u                  # backup interpteted as userid (default)
+    -u                  # backup interpreted as userid (default)
 
 commands:
     list: table of contents, one per line
@@ -738,7 +738,7 @@ you detect data corruption in older chun
 it.  may be too late: if a message needs restoring it's because user mailbox no
 longer has it
 
-you detect data corruption pre-emptively by running the verify tool over it.
+you detect data corruption preemptively by running the verify tool over it.
 recommend scheduling this in EVENTS/cron?
 
 if data corruption occurs in message that's no longer in user's mailbox, that
diff -pruN 3.0.13-5/doc/internal/bytecode.html 3.2.0-3/doc/internal/bytecode.html
--- 3.0.13-5/doc/internal/bytecode.html	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/doc/internal/bytecode.html	2020-04-24 02:03:00.000000000 +0000
@@ -18,7 +18,7 @@
 a bytecode parser is much lighter weight.</li>
 
 <li>Using bytecode can simplify the code for the execution phase,
-which is far more frequently occuring than the upload/compile phase.</li>
+which is far more frequently occurring than the upload/compile phase.</li>
 
 <li>Rewriting a significant part of the sieve execution framework forces
 a decent amount of refactoring on what has traditionally been a problematic
diff -pruN 3.0.13-5/doc/internal/cyrusdb-api.html 3.2.0-3/doc/internal/cyrusdb-api.html
--- 3.0.13-5/doc/internal/cyrusdb-api.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/cyrusdb-api.html	2020-04-24 02:03:00.000000000 +0000
@@ -23,7 +23,7 @@ interface from within parts of Cyrus cod
 your own backend</p>
 
 <p>If you pass incorrect values to these APIs, you will get an assertion
-failure in most cases.  That's generally considered safer than silenty
+failure in most cases.  That's generally considered safer than silently
 breaking things.  Exceptions are noted below.</p>
 
 <h2>Code Layout</h2>
@@ -79,7 +79,7 @@ interacting with cyrusdb databases.</p>
 </pre>
 
 <p>Note that you always open a database first, and close it at the end.
-You must always call cyrus_init() and cyrus_done() to properly intialise
+You must always call cyrus_init() and cyrus_done() to properly initialize
 and clean up the <tt>cyrusdb</tt> environments.</p>
 
 <p>This example also uses a transaction, meaning that the database is locked
@@ -127,8 +127,9 @@ yourself, use <tt>cyrus_done()</tt>.</p>
 
 <h3>cyrusdb_sync(const char *backend)</h3>
 
-<p>Perform a checkpoint of the database environment.  Used by berkeley
-backend.  Is called by <tt>ctl_cyrusdb -c</tt> on a regular basis</p>
+<p>Perform a checkpoint of the database environment. Our current database
+backends do not require this, and implement it as a no-op. Is called by
+<tt>ctl_cyrusdb -c</tt> on a regular basis</p>
 
 <!-- XXX update this bit to document the cyrusdb_archiver api
 <h3>archive(const char **fnames, const char *dirname)</h3>
diff -pruN 3.0.13-5/doc/internal/hacking 3.2.0-3/doc/internal/hacking
--- 3.0.13-5/doc/internal/hacking	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/hacking	2020-04-24 02:03:00.000000000 +0000
@@ -49,7 +49,7 @@ right now but hopefully that will improv
     lib/map.h).  To free it, call map_free on the same map.
 
   - Despite the fact that the maps are read-only, it is often useful to open
-    the file descriptors O_RDWR, especially if the file decriptors could
+    the file descriptors O_RDWR, especially if the file descriptors could
     possibly be used for writing elsewhere in the code. Some operating
     systems REQUIRE file descriptors that are mmap()ed to be opened
     O_RDWR, so just do it.
@@ -57,7 +57,7 @@ right now but hopefully that will improv
 - Network Functions
   - Cyrus abstracts socket stream access to a concept we refer to as
     "prot streams"  Prot Streams take care of all of the necessary
-    SASL and TLS/SSL encrpytion that may need to happen before data
+    SASL and TLS/SSL encryption that may need to happen before data
     goes out/comes in from the network.  The API is documented in
     lib/prot.h
 
diff -pruN 3.0.13-5/doc/internal/internationalization.html 3.2.0-3/doc/internal/internationalization.html
--- 3.0.13-5/doc/internal/internationalization.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/internationalization.html	2020-04-24 02:03:00.000000000 +0000
@@ -35,7 +35,7 @@ Cyrus's known character sets (except for
 characters off of the BMP this isn't seen to be a major problem.</p>
 
 <p>Throughout this text, Unicode and ISO 10646 will be used
-interchangible to refer to the 16-bit character set of the BMP,
+interchangeable to refer to the 16-bit character set of the BMP,
 regardless of encoding. "Character", unless otherwise specified,
 refers to a single Unicode character <tt>ffff</tt> or under. </p>
 
@@ -80,7 +80,7 @@ transcoding routines in <tt>lib/charset.
 elegant and very compact, thus somewhat intimidating. During
 compilation, Cyrus builds up a large number of tables (see <a
 href="#mkchartable">mkchartable</a>) and uses them so that it never
-has to consider more than a single octet at a time while outputing the
+has to consider more than a single octet at a time while outputting the
 Cyrus canonical form for an input string.</p>
 
 <h2>external interface</h2>
@@ -248,7 +248,7 @@ without an intervening RET.</p></dd>
 
 <dt>JMP</dt>
 
-<dd> Similiar to JSR, but does not change the stack. It is the
+<dd> Similar to JSR, but does not change the stack. It is the
 equivalent of a goto. JMPs are useful to deal with modal input
 character sets (such as an escape in ISO-2022-JP, see <a
 href="#mkchartable">how the tables are generated</a>).</dd>
@@ -354,7 +354,7 @@ characters to select a new mode.</p>
 
 <p>The input charset labels modes with "<tt>:</tt>" followed by the
 mode name. The starting mode "<tt>US-ASCII</tt>" in ISO-2022-JP is
-preceeded by "<tt>:US-ASCII</tt>". Mode transitions are denoted by a
+preceded by "<tt>:US-ASCII</tt>". Mode transitions are denoted by a
 Unicode conversion of "<tt>&gt;newmode</tt>" or
 "<tt>:newmode</tt>". To denote that the octet <tt>42</tt> transitions
 into the "<tt>US-ASCII</tt>" mode, the charset file has "<tt>42
@@ -382,14 +382,14 @@ explicitly stated, it is a translation t
 standard. More recent versions should be available <a
 href="http://www.unicode.org/xxx">from their website</a>. Each entry
 in the file describers a Unicode character by the following
-properties, seperated by semicolons:</p>
+properties, separated by semicolons:</p>
 
 <ul>
 <li>code point (16-bit character value) in hex</li>
 <li>character name (unused by Cyrus)</li>
-<li>general category, such as whitespace or puncuation</li>
+<li>general category, such as whitespace or punctuation</li>
 <li>the canonical combining class (unused)</li>
-<li>bidirection chategory (unused)</li>
+<li>bidirection category (unused)</li>
 <li>character decomposition</li>
 <li>decimal digit value (unused)</li>
 <li>digit value (unused, and, no, I don't know the difference)</li>
diff -pruN 3.0.13-5/doc/internal/locking 3.2.0-3/doc/internal/locking
--- 3.0.13-5/doc/internal/locking	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/doc/internal/locking	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-In an ideal world, our locking order is:
-
-cyrus.header
-cyrus.index
-quota
-seen
-mailboxes file
-
-
diff -pruN 3.0.13-5/doc/internal/locking.txt 3.2.0-3/doc/internal/locking.txt
--- 3.0.13-5/doc/internal/locking.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/internal/locking.txt	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,77 @@
+
+For mailboxes, we lock in this order:
+
+* Mailbox Namelock (shared) <== possibly reversible with conversationsdb
+* user conversations db
+* cyrus.index
+
+If you want to do any mailboxes.db transactions, they need to open
+and close without changing any mailbox locking during the transaction.
+
+Likewise seen and statuscache are always done without changing mailbox
+locking during their transaction.
+
+Annotations databases are a mess.
+
+Xapian Locking:
+---
+
+* Xapian per-user NAMELOCK (shared or exclusive)
+* xapianactive file lock (shared or exclusive)
+
+Shared namelock holds the following invariants:
+* xapianactive file contents are not changed
+* directories mentioned in xapianactive are not cleaned up
+
+Xapianactive exclusive lock holds the following invariants:
+* owner may write to first database mentioned in xapianactive
+
+Xapianactive shared lock holds:
+* all databases in xapianactive are readable and a consistent
+  read can be made across all of them, even with multiple requests
+  while the lock is held.
+
+
+Locking orders:
+
+SHARED case:
+* user conversations db <=== possibly reversible with SHARED xapian namelock
+* SHARED xapian namelock
+* xapianactive lock (shared to search, exclusive to write)
+* cyrus.index may be locked either side of the xapianactive lock, because the
+  conversationsdb lock protects it from races.
+
+EXCLUSIVE case:
+* EXCLUSIVE xapian namelock
+  -> that's it.  While you've got this, you can add or delete items from
+     the xapianactive file, and delete paths on disk for directories that
+     you have removed (either during or after locking).  No other locks are
+     permitted.
+
+
+If you hold a SHARED xapian namelock, you may write to a .NEW folder for a
+xapianactive entry that you created without taking any additional locks,
+because nothing can clean it under you, and nothing else can read it.  This
+is how the repack case works.
+
+
+
+
+
+
+
+
+
+Lock lifetime:
+* Shared mailbox namelock:
+  -> possibly hours
+* conversations db and below - short as possible
+
+Mailbox namelock holds the following invariants:
+* cyrus.index may not be repacked, however flags and modseqs may be updated
+* cyrus.annotations records may change (kind of buggy and bad, ideally we'd
+  always write new ones if we changed them and keep the old ones)
+* cyrus.cache may be appended, but never changed
+* spool files may not be deleted (already can't be changed)
+
+
diff -pruN 3.0.13-5/doc/internal/mailbox-api.html 3.2.0-3/doc/internal/mailbox-api.html
--- 3.0.13-5/doc/internal/mailbox-api.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/mailbox-api.html	2020-04-24 02:03:00.000000000 +0000
@@ -32,7 +32,7 @@ r = mailbox_open_iwl(mboxname, &amp;mail
 // or
 r = mailbox_open_irl(mboxname, &amp;mailbox);
 // or
-r = mailbox_open_exlusive(mboxname, &amp;mailbox);
+r = mailbox_open_exclusive(mboxname, &amp;mailbox);
 if (r) return r;
 
 do_stuff(mailbox);
@@ -87,7 +87,7 @@ numbers won't change, and the underlying
 deleted.</p>
 
 <p><tt>mailbox_close</tt> will call <tt>mailbox_unlock_index</tt>
-if the index is still locked, so it is not neccessary to explicitly
+if the index is still locked, so it is not necessary to explicitly
 unlock the index before closing.</p>
 
 <pre>
@@ -157,6 +157,7 @@ no mailbox with that name.</p>
 int mailbox_rename_copy(struct mailbox *oldmailbox,
                         const char *newname, const char *newpart,
                         const char *userid, int ignorequota,
+                        int silent,
                         struct mailbox **newmailboxptr);
 </pre>
 
@@ -171,7 +172,7 @@ int mailbox_delete(struct mailbox **mail
 
 <p>Just like <tt>mailbox_close</tt> above, this closes the mailbox.
 Before it does so, it sets the OPT_MAILBOX_DELETED option flag in
-the index header.  The interesting work is actualy done in
+the index header.  The interesting work is actually done in
 <tt>mailbox_close</tt>.  See below under "delayed actions".</p>
 
 <p><tt>mailbox_delete</tt> requires an exclusive index lock, but
@@ -210,8 +211,8 @@ int make_changes;
 /* DEPRECATED */
 for (recno = 1; recno &lt;= mailbox-&gt;i.num_records; recno++) {
     if (mailbox_read_index_record(mailbox, recno, &amp;record))
-        fatal("invalid record", EC_SOFTWARE); // or return an error
-    if (record.system_flags &amp; FLAG_EXPUNGED)
+        fatal("invalid record", EX_SOFTWARE); // or return an error
+    if (record.internal_flags &amp; FLAG_INTERNAL_EXPUNGED)
         continue; // skip expunged records
     make_changes = do_stuff(mailbox, &amp;record);
     if (make_changes)
@@ -295,11 +296,11 @@ format documentation.</p>
 <pre>
 for (recno = 1; recno &lt;= mailbox-&gt;i.num_records; recno++) {
     if (mailbox_read_index_record(mailbox, recno, &amp;record))
-        fatal("invalid record", EC_SOFTWARE); // or return an error
-    if (record.system_flags &amp; FLAG_EXPUNGED)
+        fatal("invalid record", EX_SOFTWARE); // or return an error
+    if (record.internal_flags &amp; FLAG_INTERNAL_EXPUNGED)
         continue; // skip expunged records
     if (mailbox_cacherecord(mailbox, &amp;record))
-        fatal("failed to read cache", EC_SOFTWARE);
+        fatal("failed to read cache", EX_SOFTWARE);
     ...
     envelope_length = cacheitem_size(&amp;record, CACHE_ENVELOPE);
 }
diff -pruN 3.0.13-5/doc/internal/mailbox-format.html 3.2.0-3/doc/internal/mailbox-format.html
--- 3.0.13-5/doc/internal/mailbox-format.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/mailbox-format.html	2020-04-24 02:03:00.000000000 +0000
@@ -110,7 +110,7 @@ different versions of cache data may exi
 
 <p>
 The order of fields per record in the cache file is as follows:
-(keep in mind that they are all preceeded by a 4 byte network byte order
+(keep in mind that they are all preceded by a 4 byte network byte order
 size).</p>
 
 <dl>
@@ -332,7 +332,7 @@ Generation Number (4 bytes)</dt>
   match between the cache and index files.  This is to ensure that if we
   fail to sync both the cache and index files and a crash happens (so that
   only one is synced), we do not provide bad data to the user.  This is
-  also backed by having indiviual cache checksums on each record.</dd>
+  also backed by having individual cache checksums on each record.</dd>
 
 <dt>Format (4 bytes)</dt>
 <dd>Basically obsolete (indicates netnews or regular).</dd>
diff -pruN 3.0.13-5/doc/internal/namelocks.html 3.2.0-3/doc/internal/namelocks.html
--- 3.0.13-5/doc/internal/namelocks.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/namelocks.html	2020-04-24 02:03:00.000000000 +0000
@@ -50,17 +50,17 @@ It's a simple matter of having a file un
 directory tree using the same hashing structure as the mailbox tree.
 This directory can be symlinked or mounted to a tmpfs since the locks
 need not persist across restarts.  Due to race conditions while
-cleaning up, the easist approach is to only ever delete lock files
+cleaning up, the easiest approach is to only ever delete lock files
 during restart, so the unlock code doesn't try to remove them.
 Lock files are zero byte in size, and are locked using the flock
-or fcntl primatives used by the rest of cyrus.
+or fcntl primitives used by the rest of cyrus.
 
 <h2>API</h2>
 
 <p>Lock types:</p>
 
 <ul>
-<li>LOCK_SHARED - shared lock on the name.  Requried whenever you have
+<li>LOCK_SHARED - shared lock on the name.  Required whenever you have
     an open mailbox with that name</li>
 <li>LOCK_EXCLUSIVE - exclusive lock on the name.  Required to create or
     finish deleting a mailbox, and required when repacking the cyrus.index
diff -pruN 3.0.13-5/doc/internal/unit-tests.html 3.2.0-3/doc/internal/unit-tests.html
--- 3.0.13-5/doc/internal/unit-tests.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/internal/unit-tests.html	2020-04-24 02:03:00.000000000 +0000
@@ -61,7 +61,7 @@ In other words, unit testing is about ve
 like individual functions, modules, or classes, work in isolation.  It is
 <b>not</b> about testing the system as a whole.
 
-<p>The tests implemenented here are also <b>regression tests</b>, which in
+<p>The tests implemented here are also <b>regression tests</b>, which in
 <a href="http://en.wikipedia.org/wiki/Regression_testing">Wikipedia&apos;s words</a>
 means:</p>
 
@@ -309,7 +309,7 @@ a failing test somewhat challenging.  Th
 Reading symbols from /home/me/cyrus-imapd/cunit/.libs/lt-unit...done.
 (gdb) <b>list crc32.testc:1</b>
 1       /* Unit test for lib/crc32.c */
-2       #include "cunit/cunit.h"
+2       #include "cunit/cyrunit.h"
 3       #include "crc32.h"
 ...
 (gdb) <b>break test_map</b>
@@ -371,7 +371,7 @@ in <tt>lib/crc32.c</tt>.</p>
 <p>The file should contain something like this.</p>
 
 <blockquote class="src">/* Unit test for lib/crc32.c */
-#include "cunit/cunit.h"  <span class="note">(a)</span>
+#include "cunit/cyrunit.h"  <span class="note">(a)</span>
 #include "crc32.h"  <span class="note">(b)</span>
 
 static void test_map(void)  <span class="note">(c)</span>
@@ -390,7 +390,7 @@ static void test_map(void)  <span class=
 <dl>
 
 <dt><span class="note">(a)</span></dt>
-<dd>You need to include the header <tt>"cunit/cunit.h"</tt>,
+<dd>You need to include the header <tt>"cunit/cyrunit.h"</tt>,
 which is a thin Cyrus wrapper around the CUnit's library's
 header, <tt>&lt;CUnit/CUnit.h&gt;</tt> with some extra
 conveniences.</dd>
diff -pruN 3.0.13-5/doc/internal/var_directory_structure.html 3.2.0-3/doc/internal/var_directory_structure.html
--- 3.0.13-5/doc/internal/var_directory_structure.html	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/doc/internal/var_directory_structure.html	2020-04-24 02:03:00.000000000 +0000
@@ -21,7 +21,7 @@ sync./
 
   which are lock files for each user on the system to prevent two
   replication runs from trying to update the same account at the same time
-  (nothing disasterous should happen even without this lock, but the second
+  (nothing disastrous should happen even without this lock, but the second
   job in will get a bit confused if the target end changes under its feet,
   and will probably drop back to a recovery mode.
 
@@ -53,7 +53,7 @@ Most of that will be familiar. New entri
 
 master_machine
   Defines machine number in replication cluster. Used as sanity check
-  aginst master_uuid file. Sample content:
+  against master_uuid file. Sample content:
 
     machine=1
 
@@ -70,7 +70,7 @@ sync/current
   Transaction log from IMAP, POP and LMTP daemons, typically feed into
   sync_client running as asynchronous replication engine.
 
-  Rotated to be sync/current-&lt;pid&gt; by asychronous runner.
+  Rotated to be sync/current-&lt;pid&gt; by asynchronous runner.
 </pre>
 </body>
 </html>
diff -pruN 3.0.13-5/doc/legacy/ag.html 3.2.0-3/doc/legacy/ag.html
--- 3.0.13-5/doc/legacy/ag.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/ag.html	2020-04-24 02:03:00.000000000 +0000
@@ -294,7 +294,7 @@ the messages to the destination server.<
 <tt>[CREATE, DELETE, RENAME, SETACL]</tt><br>
 
 These commands are all done by the back end server using the MUPDATE
-server as a lock manager.  Changes are then propogated to the frontend
+server as a lock manager.  Changes are then propagated to the frontend
 via the MUPDATE protocol.
 
 <p><tt>[LIST]</tt></p>
@@ -355,7 +355,7 @@ recovery can activate the mailbox in mup
 next CREATE attempt failing.  The earlier MUPDATE inconsistency results
 in any attempts to CREATE the mailbox on another back end failing.  The
 latter one makes the mailbox unreachable and un-createable.  Though, this
-is safer than potentially having the mailbox appaear in two places when
+is safer than potentially having the mailbox appear in two places when
 the failed backend comes back up.</p>
 
 <p><tt>[RENAME]</tt><br>
@@ -480,7 +480,7 @@ the MUPDATE server to fail with no avail
 
 <li>Load scalability - We have not done any specific benchmarks to show
 that this system actually performs better.  However, it is clear that it
-scales to a larger number of users than a single server architechure
+scales to a larger number of users than a single server architecture
 would.  Though, based on the fact that we have not had any performance
 problems similar to when we were running a single machine, and we are
 handling about 20% more concurrent users, things have been a rousing
diff -pruN 3.0.13-5/doc/legacy/anoncvs.html 3.2.0-3/doc/legacy/anoncvs.html
--- 3.0.13-5/doc/legacy/anoncvs.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/anoncvs.html	2020-04-24 02:03:00.000000000 +0000
@@ -54,15 +54,15 @@
 
 
     <p>
-      Read access to the repository is availible to anyone via
-      cvs.andrew.cmu.edu.  Write access is availible to only a few people at
+      Read access to the repository is available to anyone via
+      cvs.andrew.cmu.edu.  Write access is available to only a few people at
       CMU.
 
     <p>
       Please note that the version in the repository is not the version we are
       running.  We have a separate system that resembles version control for
       releases of software on the Andrew system, and sometimes changes don't
-      get propigated back to CVS.
+      get propagated back to CVS.
 
     <p>
       What is here is supposed to be stable.  It's supposed to work, and
diff -pruN 3.0.13-5/doc/legacy/changes.html 3.2.0-3/doc/legacy/changes.html
--- 3.0.13-5/doc/legacy/changes.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/changes.html	2020-04-24 02:03:00.000000000 +0000
@@ -13,7 +13,7 @@
 <ul><li>This document is no longer being maintained, and will be removed soon.
 Please refer to the release notes for the respective version, in the
 <code>doc/html/</code> directory of the source distribution, or on the
-<a href="http://cyrusimap.org/imap/release-notes/index.html">Cyrus IMAP
+<a href="http://www.cyrusimap.org/imap/release-notes/index.html">Cyrus IMAP
 website</a>.</li></ul>
 
 <h1>Changes in 3.0.0-beta2 since the 2.5.x series</h1>
@@ -32,6 +32,8 @@ and <em>doc/README.xapian</em> in the so
 <li><p>Archive support has arrived! Requires addition of an archive partition. (See <em>archive_*</em>
 options in <a href="https://www.cyrusimap.org/imap/admin/configs/imapd.conf.html#imap-admin-configs-imapd-conf"><em>imapd.conf</em></a>)</p>
 </li>
+<li><p>Basic <a href="http://jmap.io">JMAP</a> support. (See <em>httpmodules</em> in <a href="https://www.cyrusimap.org/imap/admin/configs/imapd.conf.html#imap-admin-configs-imapd-conf"><em>imapd.conf</em></a>)</p>
+</li>
 <li><p>Optional <a href="http://www.clamav.net">ClamAV</a> integration for AntiVirus support is now working again.
 Requires separate installation of <a href="http://www.clamav.net">ClamAV</a>. (See configure.ac <em>--with-clamav=DIR</em>)</p>
 </li>
@@ -155,7 +157,7 @@ complains if this isn&#8217;t allowed.</
 
 <h1>Changes to the Cyrus IMAP Server since 2.4.17-caldav-beta7</h1>
 <ul>
-<li>Added Timzone Service module along with associated admin tools
+<li>Added Timezone Service module along with associated admin tools
   (ctl_zoneinfo, vzic).</li>
 <li>Added support for accepting/returning jCal (requires Jansson) and
   xCal data wherever iCalendar data is allowed.</li>
@@ -546,7 +548,7 @@ complains if this isn&#8217;t allowed.</
 <li>Fixed numberous bugs with mailbox upgrades</li>
 <li>Fixed replication errors, which have been reported many
   times on the mailing list, but don't have bug numbers.</li>
-<li>Increated "paranoia" about record ordering in mailbox,
+<li>Increased "paranoia" about record ordering in mailbox,
   which would have detected some bad bugs in replication
   that caused the infinite runaway mailbox filling reported
   in 2.4.6 and below</li>
@@ -806,7 +808,7 @@ support for deprecated (compile-time) LI
 disk space usage.</li>
 <li>Fixed a crash when selecting a folder after using the SCAN command</li>
 <li>Split mupdate_synchronize() into network scarfing and mailbox
-  comparision pieces.  This allows us to not lock out the
+  comparison pieces.  This allows us to not lock out the
   mailboxes.db and mupdate clients while scarfing the UPDATE
   response, which can be quite time consuming over slow links.</li>
 <li>Added support for MUPDATE COMPRESS and IMAP COMPRESS commands
@@ -1116,7 +1118,7 @@ making it useful for remote mailboxes.</
 <h1>Changes to the Cyrus IMAP Server since 2.3.1</h1>
 <ul>
 <li>Added more extensive output to arbitron.</li>
-<li>Allow responses of any length from backend when proxing
+<li>Allow responses of any length from backend when proxying
 IMAP/POP3/NNTP traffic.</li>
 <li>Properly handle timeouts when proxying.</li>
 <li>Added plaintextloginalert option.</li>
@@ -1220,7 +1222,7 @@ specification (RFC4315).</li>
 <li>Fixed possible race condition in IMAP IDLE.</li>
 <li>Made <tt>ptloader</tt> runtime configurable.</li>
 <li>Added more extensive output to <tt>arbitron</tt>.</li>
-<li>Allow responses of any length from backend when proxing
+<li>Allow responses of any length from backend when proxying
 IMAP/POP3/NNTP traffic.</li>
 <li>Added <tt>plaintextloginalert</tt> option.</li>
 <li>Only allow <tt>mbpath</tt> to be run as Cyrus user.</li>
@@ -1293,7 +1295,7 @@ twice</li>
 <li>Fix segfault in APPEND code</li>
 <li>Fix a bug with an interaction between sieve and unixhierarchysep</li>
 <li>Fix a file descriptor leak in the quotadb code</li>
-<li>Fix a triggered assertation in service-thread services</li>
+<li>Fix a triggered assertion in service-thread services</li>
 <li>Add a number of internal consistency checks to the skiplist code</li>
 <li>Allow <tt>mbpath</tt> to handle virtual domains</li>
 <li>Fix various MANAGESIEVE client authentication issues</li>
@@ -1335,7 +1337,7 @@ to the Reply-To: header instead of the T
 <li>Berkeley DB 4.2 Support - note that the Cyrus Berkeley
 enviroment needs to be reset (db_recover) before
 a Berkeley DB version upgrade or you need to remove all berkeley dbs.
-Special care needs to be taken when berkley db is used for mboxlist.</li>
+Special care needs to be taken when Berkeley db is used for mboxlist.</li>
 <li>Runtime configuration of the Cyrus databases.  The cyrudb backend
 used for each database can be specified with an <tt>imapd.conf</tt>
 option.  <b>NOTE:</b> You MUST convert the database using
@@ -1412,7 +1414,7 @@ fixed, including issues with the Murder,
 <li>There have been extensive performance and consistency changes to
 the configuration subsystem.  This will both ensure greater consistency
 between the documentation and the code, as well as a more standard format
-for specifing service-specific configuration options in imapd.conf.  Important
+for specifying service-specific configuration options in imapd.conf.  Important
 changes are detailed here:
 <ul>
   <li> The tls_[service]_* configuration options have been removed.  Now
@@ -1426,7 +1428,7 @@ require a specific value</li>
 </ul></li>
 
 <li> libcyrus has been split into libcyrus_min and libcyrus, so as to allow
-sensative applications (such as master) include the least amount of code
+sensitive applications (such as master) include the least amount of code
 necessary for operation </li>
 
 <li> Virtual domain support.  See the <a
@@ -1498,7 +1500,7 @@ options</li>
 <li>Continued audit by Security Appraisers and Bynari</li>
 <li>Correctly terminate the processes by calling service_abort even on
     successful exit (helps to fix a db3 lockers problem)</li>
-<li>Fix some murder+altnamespace/unixhiersep issues</li>
+<li>Fix some murder+altnamespace/unixhierarchysep issues</li>
 <li>Fix imclient's handling of literals.</li>
 <li>Add support for the windows-1256 character set</li>
 <li>Don't log 'could not shut down filedescriptor' messages when the
@@ -1642,7 +1644,7 @@ cleans up "reserved" mailboxes that may
 of options.  Additionally, the hash table implementation has been updated
 to possibly take advantage of memory pools.</li>
 
-<li>Many bugfixes related to the Cyrus Murder.  Includes improvments to
+<li>Many bugfixes related to the Cyrus Murder.  Includes improvements to
 subscription handling as well as correct merging of seen state on
 mailbox moves.</li>
 
@@ -1680,7 +1682,7 @@ one server to another. </li>
 message was being delivered to five or more different
 partitions. </li>
 
-<li> Deliveries now don't create a redudant temporary file using
+<li> Deliveries now don't create a redundant temporary file using
 <tt>tmpfile()</tt>; the staging directory is used instead. (Ken
 Murchison) </li>
 
@@ -1797,7 +1799,7 @@ protocol extended with referrals </li>
 siblings to the INBOX at the top-level (Ken Murchison)</li>
 
 <li>unixhierarchysep: it is now possible possible to use slash as
-the hierarchy seperator, instead of a period. (Ken Murchison,
+the hierarchy separator, instead of a period. (Ken Murchison,
 inspired by David Fuchs, <tt>dfuchs@uniserve.com</tt>)</li>
 
 <li>SSL/TLS session caching (Ken Murchison)</li>
@@ -2531,7 +2533,7 @@ deliver.</li>
 
 <li>Possibly misnamed experimental --enable-static-libraries switch
 that tries to do a good job of building binaries with whatever
-static libraries are availible. If you use this, you do so at your
+static libraries are available. If you use this, you do so at your
 own risk, and if it fails, we will disavow all knowledge of you and
 your team. Good luck, Jim.</li>
 
@@ -2608,7 +2610,7 @@ grabs a write lock.</li>
 
 <li>Added logic to cause cyradm to abort more cleanly if not given
 command line arguments in an interactive session. This gets rid of
-the dreaded <tt>application-specific intialization failed</tt>
+the dreaded <tt>application-specific initialization failed</tt>
 messages.</li>
 </ul>
 
@@ -2619,7 +2621,7 @@ messages.</li>
 instead of ignoring the CREATE command.</li>
 
 <li>UIDPLUS is now always advertised in CAPABILITY and is always
-availible. The UIDPLUS extension is a set of optimizations using
+available. The UIDPLUS extension is a set of optimizations using
 UID values instead of sequence numbers and is described in RFC
 2359.</li>
 
@@ -2704,7 +2706,7 @@ bsearch_mem.</li>
 mailbox names.</li>
 
 <li>Makedepend still runs, and still generates warnings, but these
-are squirrled away in makedepend.log.</li>
+are squirreled away in makedepend.log.</li>
 
 <li>On mailbox delete, the server will no longer try and unlink
 ".." and "." as we got a report that it seriously breaks one file
@@ -2767,7 +2769,7 @@ month.)</li>
 it is not handling RENAME in an IMAP4rev1 compliant manner. This
 will be fixed in a subsequent release.</li>
 
-<li>Bug fix: imclient_autenticate now does resolution on the
+<li>Bug fix: imclient_authenticate now does resolution on the
 hostname before authenticating to it. This caused problems when
 authenticating to an address that was a CNAME.</li>
 
@@ -2778,7 +2780,7 @@ well.</li>
 <li>Bug fix: a fetch of exclusively BODY[HEADER.FIELDS...] should
 now work properly.</li>
 
-<li>Bug fix: reconstruct now considers a nonexistant INN news
+<li>Bug fix: reconstruct now considers a nonexistent INN news
 directory to be empty; this makes reconstruct fix the cyrus.* files
 in the imap news partition.</li>
 
@@ -2909,7 +2911,7 @@ attempts to stream its tagged responses.
 
 <li>Modify zephyr support to compile without Kerberos support.</li>
 
-<li>Add a bunch of prototype declararations to the code.</li>
+<li>Add a bunch of prototype declarations to the code.</li>
 
 <li>In deliver, change the MULT support to instead use the LMTP
 syntax.</li>
diff -pruN 3.0.13-5/doc/legacy/faq.html 3.2.0-3/doc/legacy/faq.html
--- 3.0.13-5/doc/legacy/faq.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/faq.html	2020-04-24 02:03:00.000000000 +0000
@@ -12,10 +12,7 @@
 <li><b>POP-Before-SMTP</b> It is not included in the default distribution
 because there is already a standard way of doing this with SMTP AUTH.
 Any good MTA and/or MUA should support SMTP AUTH, so we shouldn't have
-to create a hack in an unrelated service.  However, if you would like
-to install it anyway, we recommend using
-<a href="http://mail.cc.umanitoba.ca/drac/">DRAC</a>,
-along with the patch available in <tt>contrib/drac_auth.patch</tt>.</li>
+to create a hack in an unrelated service.</li>
 
 <li><b>Using NFS</b> We don't recommend it. If you want to do it,
 it may possibly work but you may also lose your email or have
@@ -40,7 +37,7 @@ href="install-virtdomains.html">virtual
 
 <li><b>dots in userids</b> - you can have a '.' in your username
 IF, AND ONLY IF, you use the <a
-href="altnamespace.html#unixhiersep">UNIX hierarchy
+href="altnamespace.html#unixhierarchysep">UNIX hierarchy
 convention</a>.</li>
 
 <li><b>renaming users</b> - Supported, but try to make sure that the
@@ -135,17 +132,6 @@ This behavior can be changed with the us
 <tt>allowplaintext</tt> option in <tt>imapd.conf.5</tt>.</p>
 </dd>
 
-<dt><b>Q:</b> I'm getting syslog'd messages from the master process
-saying processes are "signaled to death by 10". What's up?</dt>
-
-<dd>
-<p><b>A:</b> If you're using Berkeley DB 3.0.55, try installing
-some <a
-href="http://www.sleepycat.com/update/3.0.55/patch.3.0.55.html">patches
-to Berkeley DB</a> available from <a
-href="http://www.sleepycat.com/update/3.0.55/patch.3.0.55.html">http://www.sleepycat.com/update/3.0.55/patch.3.0.55.html</a>.</p>
-</dd>
-
 <dt><b>Q:</b> I've used <tt>saslpasswd2</tt> to create CRAM-MD5
 secrets, but imapd doesn't say <tt>AUTH=CRAM-MD5</tt>. Why?</dt>
 
@@ -247,21 +233,6 @@ tls.c:</p>
 </pre>
 </dd>
 
-<dt><b>Q:</b> I'm getting messages in <tt>imapd.log</tt> like
-"DBERROR db3: 16 lockers".  What's wrong?
-</dt>
-
-<dd>
-<p><b>A:</b> Nothing is wrong. These messages are logged whenever
-Berkeley DB encounters lock contention, but aren't necessarily
-problems. This is especially likely when you have an
-empty or small duplicate delivery database and are receiving a large
-volume of e-mail.</p>
-
-<p>Berkeley DB 4.0 has a bug where the number of lockers isn't
-decremented properly, causing this number to be unreliable.</p>
-</dd>
-
 <dt><b>Q:</b> All of the 8bit characters in the headers of messages
 that I receive are being changed to 'X's.  What's going on?</dt>
 
@@ -299,7 +270,7 @@ are a few options here:</p>
 <ul>
 <li>Contact your client vendor to have
 the broken client fixed (one possibility is to have the client ask the user
-if they wish to permanantly delete the message if the COPY operation fails).</li>
+if they wish to permanently delete the message if the COPY operation fails).</li>
 <li>Stop using the 'trash mailbox' feature of your client (if possible).</li>
 <li>Set a separate quota root on the 'trash folders'
 of users.  This last option is significantly harder to do correctly, since
diff -pruN 3.0.13-5/doc/legacy/index.html 3.2.0-3/doc/legacy/index.html
--- 3.0.13-5/doc/legacy/index.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/index.html	2020-04-24 02:03:00.000000000 +0000
@@ -22,7 +22,7 @@ private to the Cyrus IMAP system. All us
 through the IMAP, POP3, KPOP or NNTP protocols.</p>
 
 <p>The private mailbox database design gives the server large
-advantages in efficiency, scalability, and administratability.
+advantages in efficiency, scalability, and administrability.
 Multiple concurrent read/write connections to the same mailbox are
 permitted. The server supports access control lists on mailboxes
 and storage quotas on mailbox hierarchies.</p>
diff -pruN 3.0.13-5/doc/legacy/install-admin-mb.html 3.2.0-3/doc/legacy/install-admin-mb.html
--- 3.0.13-5/doc/legacy/install-admin-mb.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-admin-mb.html	2020-04-24 02:03:00.000000000 +0000
@@ -85,7 +85,7 @@ explicitly before she can delete a mailb
 Once you have created mailboxes, your IMAP server installation is
 done.  You must then configure a mail interface, such as <a
 href="http://www.washington.edu/pine/">Pine</a> or <a
-href="http://www.cyrusoft.com/mulberry/">Mulberry</a>, to work with the
+href="http://mulberrymail.com/">Mulberry</a>, to work with the
 IMAP server.
 
 <P><HR>
diff -pruN 3.0.13-5/doc/legacy/install-auth.html 3.2.0-3/doc/legacy/install-auth.html
--- 3.0.13-5/doc/legacy/install-auth.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-auth.html	2020-04-24 02:03:00.000000000 +0000
@@ -39,7 +39,7 @@ PLAIN) will send your password in clear-
 the password is still verified through the Cyrus SASL library, though no
 SASL mechanism actually performs a negotiation.
 
-<p>The POP server is capable of APOP authentication, but this requries that
+<p>The POP server is capable of APOP authentication, but this requires that
 Cyrus SASL be compiled <tt>--with-checkapop</tt>, and also that you are using
 an auxprop backend for your password store (e.g. the sasldb auxprop plugin).
 
diff -pruN 3.0.13-5/doc/legacy/install-backups.html 3.2.0-3/doc/legacy/install-backups.html
--- 3.0.13-5/doc/legacy/install-backups.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-backups.html	2020-04-24 02:03:00.000000000 +0000
@@ -265,7 +265,7 @@ will resume once your backupd is running
 backupd.  Just use <code>ctl_backups lock</code> to hold a lock on each backup while you
 work with its files, and the rest of the backup system will work around that.</p>
 
-<p>Restorating is more complicated, depending on what you actually need to do: when you
+<p>Restoring is more complicated, depending on what you actually need to do: when you
 restart the backupd after restoring a filesystem snapshot, the next time your Cyrus IMAP
 server replicates to it, the restored backups will be brought up to date.  Probably not
 what you wanted -- so don't restart backupd until you've done whatever you were doing.</p>
diff -pruN 3.0.13-5/doc/legacy/install-configure.html 3.2.0-3/doc/legacy/install-configure.html
--- 3.0.13-5/doc/legacy/install-configure.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-configure.html	2020-04-24 02:03:00.000000000 +0000
@@ -548,7 +548,7 @@ expiration period shortened.
 <p>Client certificates are somewhat harder to configure than server
 certificates.  You'll need a CA (certificate authority) and need to
 generate client certificates signed by that CA.  STARTTLS in Sendmail
-and other MTAs have similiar problems, so <a
+and other MTAs have similar problems, so <a
 href="http://www.sendmail.org/~ca/email/starttls.html">Claus Assman's
 page</a> is a good reference.</p>
 
diff -pruN 3.0.13-5/doc/legacy/install-murder.html 3.2.0-3/doc/legacy/install-murder.html
--- 3.0.13-5/doc/legacy/install-murder.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-murder.html	2020-04-24 02:03:00.000000000 +0000
@@ -20,12 +20,12 @@ future, you should probably just conside
 <h3>Introduction &amp; Assumptions</h3>
 This document is intended to be a guide to the configuration of a Cyrus
 IMAP Aggregator, aka Cyrus Murder.  It is recommended that you review
-<A HREF="ag.html">this document</A> to become familliar
+<A HREF="ag.html">this document</A> to become familiar
 with the concepts at work.  This document is a work in progress and is at this
 point incomplete.<p>
 This document assumes that you have successfully been able to setup atleast
 one Cyrus IMAP server.  This server will become your first backend server.
-It also assumes that you are familliar with the administration and day
+It also assumes that you are familiar with the administration and day
 to day operations of the Cyrus IMAP server and the SASL authentication library.
 If you feel uncomfortable with this, please refer to the rest of the
 documentation first.<p>
@@ -77,7 +77,7 @@ admins: mupdateslave1 backend1
 </pre>
 
 You will also need to configure SASL to properly allow authentication in
-your enviornment.<p>
+your environment.<p>
 
 <h3>Setting up the backends to push changes to the MUPDATE Master</h3>
 On the backends, configuration to be a part of a murder is easy.  You just
@@ -166,7 +166,7 @@ same machine, in the <tt>SERVICES</tt> s
 
 Note that as this is a threaded service, you must prefork atleast 1 of them
 so that the database can be synchronized at startup.  Otherwise, the service
-will not start running until after you recieve an mupdate client connection
+will not start running until after you receive an mupdate client connection
 to the slave (which is not a recommended configuration at this point).<p>
 
 You will also want to change all of your <tt>imapd</tt> entries to be
@@ -219,7 +219,7 @@ If your authentication system requires u
 authenticate (e.g. it isn't Kerberos), then you will also need to
 specify proxy_authname (and friends) in the backend imapd.confs as well.
 This is so that the backends can authenticate to eachother to facilitate
-maibox moves.  (Backend machines will need to be full admins).
+mailbox moves.  (Backend machines will need to be full admins).
 
 <h3>Delivering mail</h3>
 
@@ -232,18 +232,18 @@ install <tt>master</tt> and <tt>lmtpprox
 <h2>Administration</h2>
 
 <h3>Keeping the database synced</h3>
-<p>Consistancy in the database is maintained by pushing the current status
+<p>Consistency in the database is maintained by pushing the current status
 of the backends to the master, and having the frontends stay up to date with
 the master's database.  Since the frontends resync themselves entirely
 when they startup, downtime should not at all be a problem.  (While they
-are up they should be continously recieving database updates, as well as
+are up they should be continuously receiving database updates, as well as
 when they lose connection to the master, they will try to reconnect and
 resync their database upon reconnection)</p>
 <p>Provided that the namespace of the backend servers is kept discrete
 (with no mailboxes existing on the same server), it is not a big deal
 to resync the mupdate master using <tt>ctl_mboxlist -m</tt>.  If two servers
 do have the same mailbox, this will need to be resolved before database
-consistency can be guranteed.</p>
+consistency can be guaranteed.</p>
 <h3>Moving Mailboxes between backends</h3>
 <p>There is currently no 100% foolproof way to do this, however, if you issue
 a rename command to a frontend (as you would to move a mailbox between partitions),
@@ -291,9 +291,9 @@ authentications than you are used to.
 you will want to ensure that all your machines are keyed properly, as we
 have seen problems with different clients trying to authenticate to
 different services (e.g. imap.imap-pool instead of imap.pool-frontend-1), so
-test the clients in use in your enviornment and be sure that they work with
+test the clients in use in your environment and be sure that they work with
 whatever keying scheme you use.</li></ul>
-<li><b>Clients dealing with referrals</b> - Some clients (we've had particuar
+<li><b>Clients dealing with referrals</b> - Some clients (we've had particular
 trouble with pine, though most of these issues have now been resolved and
 new versions should be OK (that is, pine > 4.44), but as referrals have not
 been extensively used by any IMAP server until now, referrals are very likely
@@ -309,7 +309,7 @@ might be slightly unexpected.  For examp
 to a frontend server if the entire mailbox tree underneath where you are
 setting the quota exists on the same backend server, otherwise you will need
 to connect directly to the backend servers to perform the needed changes.
-Similarally, mailboxes will be created on the same backend server
+Similarly, mailboxes will be created on the same backend server
 that their parent is in.  In order to create them on a different server
 (or to create a new top level mailbox) you will need to connect directly to
 the desired backend server.
@@ -319,7 +319,7 @@ their backend home server, they won't be
 lets any string be subscribed to successfully.
 <li><b>Restarting the mupdate master</b> - Because <tt>ctl_cyrusdb -r</tt>
 clears reservations on mailbox, if you restart the mupdate master (and
-run recovery), then this could (we suspect, very rarely) lead to inconsistancies
+run recovery), then this could (we suspect, very rarely) lead to inconsistencies
 in the mupdate database.
 </ul>
 
diff -pruN 3.0.13-5/doc/legacy/install-netnews.html 3.2.0-3/doc/legacy/install-netnews.html
--- 3.0.13-5/doc/legacy/install-netnews.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-netnews.html	2020-04-24 02:03:00.000000000 +0000
@@ -137,7 +137,7 @@ are not savvy enough to reply to and pos
 have to configure your server so your users can reply to and post
 articles via SMTP.
 
-<p>To help faciliate this, you can set the <tt>newspostuser</tt>
+<p>To help facilitate this, you can set the <tt>newspostuser</tt>
 option to a "pseudo" user which will be used to construct email delivery
 addresses for each incoming article.  These addresses are inserted
 into a <tt>Reply-To:</tt> in the article.  For example, if set to "post", an
diff -pruN 3.0.13-5/doc/legacy/install-perf.html 3.2.0-3/doc/legacy/install-perf.html
--- 3.0.13-5/doc/legacy/install-perf.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-perf.html	2020-04-24 02:03:00.000000000 +0000
@@ -39,23 +39,7 @@ do this.</p>
 the ultimate source of contention between <tt>imapd</tt> processes, especially if
 clients are inefficient about their use of the LIST command.  For this reason
 it is often better to use the skiplist backend which is optimized for
-enumeration of the database, as opposed to the default, Berkeley DB
-(use <tt>--with-mboxlist-db=skiplist</tt>).
-
-<p>Mika Iisakkila (<i>mika.iisakkila@pingrid.fi</i>) writes: Nevertheless,
-you can also tweak the Berkeley backend if you want to or have to stick
-with it. Cyrus doesn't do anything to increase the BDB cache size, and the
-default (256 kB) is way too small for any reasonably large site. With some
-50000 mailboxes and random operations, I found the hit rate for the default
-BDB cache to be 70-80%. After growing the cache size to 2M, the hit rate
-approached 99% and disk traffic was greatly reduced since most of the
-operations are reads anyway. Therefore processes could complete their work
-and release their locks much more quickly, and the dreaded "DBERROR: xxx
-lockers" messages stayed at a comfortable level. You can modify the source
-(<tt>/lib/cyrusdb_db3.c</tt>, the setting is commented out) or you can put
-a <tt>DB_CONFIG</tt> file under <tt>/var/imap/db</tt> with the appropriate
-setting. Read more about this in the Berkeley docs before trying it - typos
-and incorrect settings can wreak havoc.</p></li>
+enumeration of the database, which is currently the default.</li>
 
 <li><tt><b>/var/imap/deliverdb</b></tt> - Unless you disable
 duplicate delivery suppression, each time a mail message is
diff -pruN 3.0.13-5/doc/legacy/install-prereq.html 3.2.0-3/doc/legacy/install-prereq.html
--- 3.0.13-5/doc/legacy/install-prereq.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-prereq.html	2020-04-24 02:03:00.000000000 +0000
@@ -21,12 +21,6 @@ Configure SASL so that it supports whate
 site uses.  Please pay careful attention to the SASL
 configuration. This is the biggest problem that most people have.
 
-<li> <b>Berkeley DB</b>, version 3.0.55 or higher. Berkeley DB can be
-obtained from <a href="http://www.sleepycat.com">Sleepycat</a>.  It is
-strongly recommended that <tt>libsasl</tt> be compiled with Berkeley DB
-support, using the same version of Berkeley DB.  (If you have a
-Berkeley DB version mismatch, somewhat perplexing crashes result.)
-
 <li> <b>GNU Make</b> is required.  Get it from <a
 href="http://www.gnu.org/">the Free Software Foundation</a>. It is
 probably easier to find it via <a
diff -pruN 3.0.13-5/doc/legacy/install-replication.html 3.2.0-3/doc/legacy/install-replication.html
--- 3.0.13-5/doc/legacy/install-replication.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-replication.html	2020-04-24 02:03:00.000000000 +0000
@@ -37,7 +37,7 @@ future.</i></p>
 
 <p>This document assumes that you have successfully been able to setup
 atleast one Cyrus IMAP server.  This server will become your first
-"master" server. It also assumes that you are familliar with the
+"master" server. It also assumes that you are familiar with the
 administration and day to day operations of the Cyrus IMAP server and
 the SASL authentication library. If you feel uncomfortable with this,
 please refer to the rest of the documentation first.</p>
@@ -57,7 +57,7 @@ replication client/server applications a
 
 The "replica" server is a <i>standalone</i> server which listens for
 and processes synchronization messages from a "master" server.  The
-"replica" server needs to be configured to accept these synchonization
+"replica" server needs to be configured to accept these synchronization
 messages.  The "replica" server <b>MUST NOT</b> be configured to be
 part of a Murder (it should only be configured into the Murder at the
 point at which it replaces a failed backend "master").<p>
@@ -134,13 +134,13 @@ to save bandwidth at a slight increase i
 <h4>"Rolling" replication</h4>
 
 "Rolling" replication means that the "master" server continuously
-synchonizes itself with the replica.  To configure "rolling"
+synchronizes itself with the replica.  To configure "rolling"
 replication, perform the following:
 
 <ol>
 <li>Enable the <tt>sync_log</tt> option in imapd.conf.  This allows
 the <tt>imapd</tt>, <tt>pop3d</tt>, <tt>nntpd</tt>, and <tt>lmtpd</tt>
-services to log synchonization actions which will be periodically
+services to log synchronization actions which will be periodically
 serviced by <tt>sync_client</tt>.
 
 <li>Optionally, adjust the <tt>sync_repeat_interval</tt> in imapd.conf.
@@ -160,9 +160,9 @@ Add a line similar to the following in t
 
 <h3>Manual replication</h3>
 
-To manually synchonize any part of the mailstore, simply run
+To manually synchronize any part of the mailstore, simply run
 <tt>sync_client(8)</tt> with the appropriate command line options.
-Note that you CAN manually synchonize even if "rolling" replication
+Note that you CAN manually synchronize even if "rolling" replication
 has been configured.
 
 <p>You can also run <tt>cyr_synclog(8)</tt> instead, which will insert
diff -pruN 3.0.13-5/doc/legacy/install-upgrade.html 3.2.0-3/doc/legacy/install-upgrade.html
--- 3.0.13-5/doc/legacy/install-upgrade.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/install-upgrade.html	2020-04-24 02:03:00.000000000 +0000
@@ -80,7 +80,7 @@
 <li>some LOG_DEBUG level messages are no longer created by
     default in the duplicate delivery system, so you won't
     see them in syslog any more</li>
-<li>mailboxes in the DELETED. heirarchy are now always
+<li>mailboxes in the DELETED. hierarchy are now always
     suppressed for non-admin users, even if delayed delete
     is not enabled (see Bug #3604).  If you happen to be
     using this namespace at your site for something else,
@@ -123,7 +123,7 @@
 
 <h2>Upgrading from 2.4.8</h2>
 <ul>
-<li>CYRUS_PREFIX environemnt varabile.  If you have an environment
+<li>CYRUS_PREFIX environment varabile.  If you have an environment
     variable "CYRUS_PREFIX" then config files will be searched for
     in there first, so for example the file /var/cyrus/etc/imapd.conf
     will override /etc/imapd.conf if your CYRUS_PREFIX is /var/cyrus.
@@ -227,7 +227,7 @@
     version backend because the index was upgraded.</li>
 <li>There is a new replication protocol, so you can't replicate between
     2.4.0 and previous versions in either direction.  You need to
-    upgrade both before you can restart repliation.</li>
+    upgrade both before you can restart replication.</li>
 <li>The default value for <tt>delayed_expunge</tt> has changed to
     provide better QRESYNC and replication support.  The default
     is still pretty efficient, but you may want to change it
@@ -414,7 +414,7 @@ those in the sample configurations in th
 directory.</li>
 
 <li>The sieve bytecode format has changed.  The new format is encoded in
-network byte order, and will be transferable between architechures.  To
+network byte order, and will be transferable between architectures.  To
 upgrade existing scripts (outside of home directories), you can run the
 <tt>tools/masssievec</tt> perl script included with the distribution. It
 requires a path to your <tt>sievec</tt> binary.  This should also upgrade
@@ -480,7 +480,7 @@ masssievec /usr/src/cyrus/sieve/sievec
 </pre>
 
 Note that this will fail for scripts that use the &quot;envelope&quot;
-extention but do not require it.  Cyrus 2.1's <tt>timsieved</tt> did
+extension but do not require it.  Cyrus 2.1's <tt>timsieved</tt> did
 not do appropriate checking that the optional envelope test was
 required before it was used.
 </li>
@@ -532,7 +532,7 @@ also an experimental ldap module.  Note
 fails the lookup, authorization (and therefore authentication) will
 now fail, as canonicalization is done inside of ptloader.</li>
 
-<li>The format of sieve referrals has changed to be more consistant
+<li>The format of sieve referrals has changed to be more consistent
 with the current managesieve draft, this may cause interoperability
 problems when using managesieve clients and servers from different
 cyrus versions.</li>
@@ -549,7 +549,7 @@ as well.</li>
 
 <h2>Upgrading from 2.1.13 or earlier</h2>
 <ul>
-<li>We are now more forgiving of MIME boundry headers generated by earlier
+<li>We are now more forgiving of MIME boundary headers generated by earlier
 versions of eudora.  However, if you have messages already in the mailstore
 that you want to fix you will need to reconstruct the affected mailboxes
 to regenerate the cached bodystructure data to take this into account.
@@ -569,7 +569,7 @@ is only needed if you are running with a
 <h2>Upgrading from 2.1.3 or earlier</h2>
 <ul>
 <li>If you use notifications (previously <tt>notify_zephyr</tt> or
-<tt>notify_unix</tt>) this functionality has been seperated out to
+<tt>notify_unix</tt>) this functionality has been separated out to
 <tt>notifyd</tt>.  See the <tt>notifyd</tt> manpage and example
 entries in <tt>master/conf</tt>.</li>
 
diff -pruN 3.0.13-5/doc/legacy/mailing-list.html 3.2.0-3/doc/legacy/mailing-list.html
--- 3.0.13-5/doc/legacy/mailing-list.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/mailing-list.html	2020-04-24 02:03:00.000000000 +0000
@@ -23,7 +23,7 @@ href=
 to subscribe (or just click
 the link above and that should just work).
 
-<p>An archive is availible via anonymous IMAP at <a
+<p>An archive is available via anonymous IMAP at <a
 href="imap://cyrus.andrew.cmu.edu/archive.info-cyrus">
 imap://cyrus.andrew.cmu.edu/archive.info-cyrus</a>.
 
diff -pruN 3.0.13-5/doc/legacy/murder.fig 3.2.0-3/doc/legacy/murder.fig
--- 3.0.13-5/doc/legacy/murder.fig	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/murder.fig	2020-04-24 02:03:00.000000000 +0000
@@ -24,7 +24,7 @@ Single
 6 5250 1800 9225 2475
 4 0 0 50 0 0 12 0.0000 4 135 2940 5250 1950 Frontend server mailbox databases are\001
 4 0 0 50 0 0 12 0.0000 4 180 3300 5250 2400 mupdate connection to the mupdate master.\001
-4 0 0 50 0 0 12 0.0000 4 180 3960 5250 2175 updated based upon a stream on a frotnend-initiated\001
+4 0 0 50 0 0 12 0.0000 4 180 3960 5250 2175 updated based upon a stream on a frontend-initiated\001
 -6
 6 9600 1500 11250 2400
 4 0 0 50 0 0 12 0.0000 4 135 1575 9600 1650 Connection to LMTP\001
Binary files 3.0.13-5/doc/legacy/murder.png and 3.2.0-3/doc/legacy/murder.png differ
diff -pruN 3.0.13-5/doc/legacy/os.html 3.2.0-3/doc/legacy/os.html
--- 3.0.13-5/doc/legacy/os.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/os.html	2020-04-24 02:03:00.000000000 +0000
@@ -54,8 +54,9 @@ just meta-data) become synchronous. This
 for performance.
 
 <p> The big problem used to be with the <tt>mailboxes</tt> file. The
-2.0 release and later addressed this problem by changing the flat file
-to a Berkerley DB database.
+2.0 release and later addressed this problem by changing the flat file first
+to a Berkeley DB database, and then to Cyrus' proprietary skiplist format
+since the 3.0 release.
 
 <p>Note this is for ext2fs. If you are using a newer filesystem (such
 as xfs, jfs, or reiserfs) the synchronous metadata issue shouldn't
diff -pruN 3.0.13-5/doc/legacy/overview.html 3.2.0-3/doc/legacy/overview.html
--- 3.0.13-5/doc/legacy/overview.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/overview.html	2020-04-24 02:03:00.000000000 +0000
@@ -24,7 +24,7 @@ Cyrus IMAP system.  All user access to m
 using the IMAP, IMAPS, POP3, POP3S, or KPOP protocols.
 
 <p>The private mailbox database design gives the server large advantages
-in efficiency, scalability, and administratability.  Multiple
+in efficiency, scalability, and administrability.  Multiple
 concurrent read/write connections to the same mailbox are permitted.
 The server supports access control lists on mailboxes and storage
 quotas on mailbox hierarchies.
@@ -105,7 +105,7 @@ character, nor may it contain two "." ch
 metacharacters are not permitted in mailbox names.
 
 <p>Optionally, the server can present mailboxes using the <a
-href="altnamespace.html#unixhiersep"> UNIX hierarchy convention</a>.
+href="altnamespace.html#unixhierarchysep"> UNIX hierarchy convention</a>.
 
 <H3><A NAME="mboxnamestd">Standard (Internal) Namespace</A></H3>
 
@@ -130,7 +130,7 @@ users' <TT>INBOX</TT>.  If a user has an
 allowed to subscribe to mailboxes.  Only users without dots in their
 userid are permitted to have an <TT>INBOX</TT>.  (A user with a dot in
 their userid would be able to login but would not be able to receive mail.
-Note that when using the unix hierarchy seperator, this is not the case, and
+Note that when using the unix hierarchy separator, this is not the case, and
 any user may have a dot in their userid.)
 
 <p>When an administrator deletes a user's <TT>INBOX</TT>, all of the
@@ -665,7 +665,7 @@ mailbox directory contains the following
    mailbox itself and each message in the mailbox.  <P>
 
 <DT><TT>cyrus.cache</TT>
-<DD>This file contans variable-length information about
+<DD>This file contains variable-length information about
    each message in the mailbox. <P>
 
 <DT><TT>cyrus.seen</TT>
@@ -790,7 +790,7 @@ MTA.</p>
 
 <p>The Cyrus server implements LMTP via the <tt>lmtpd</tt> daemon.  LMTP
 can either be used over a network via TCP or local via a UNIX domain
-socket. There are security differnces between these two alternatives; read
+socket. There are security differences between these two alternatives; read
 more below</p>
 
 <p>For final delivery via LMTP over a TCP socket, it is necessary to use
@@ -822,7 +822,7 @@ recipients of the message.</p>
 <h3>Duplicate Delivery Suppression</h3><a name="duplicate"></a>
 
 A message is considered a duplicate if two copies of a message with
-the same message-id and the same envelope receipient are received.
+the same message-id and the same envelope recipient are received.
 Cyrus uses the duplicate delivery database to hold this information,
 and it looks approximately 3 days back in the default install.
 
diff -pruN 3.0.13-5/doc/legacy/readme.html 3.2.0-3/doc/legacy/readme.html
--- 3.0.13-5/doc/legacy/readme.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/legacy/readme.html	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ parts of the filesystem that are private
 All user access to mail is through the IMAP, NNTP, POP3, or KPOP protocols.
 
 <P> The private mailbox database design gives the server large
-advantages in efficiency, scalability, and administratability.
+advantages in efficiency, scalability, and administrability.
 Multiple concurrent read/write connections to the same mailbox are
 permitted.  The server supports access control lists on mailboxes and
 storage quotas on mailbox hierarchies.
diff -pruN 3.0.13-5/doc/README.autocreate 3.2.0-3/doc/README.autocreate
--- 3.0.13-5/doc/README.autocreate	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/doc/README.autocreate	2020-04-24 02:03:00.000000000 +0000
@@ -18,7 +18,7 @@ Hence, to create a new email account the
      (e.g. sasldb, shadow, mysql, ldap).
   b) Create the corresponding INBOX folder.
 
-Alternatively, the user, if succesfully authenticated, may create his own INBOX folder,
+Alternatively, the user, if successfully authenticated, may create his own INBOX folder,
 as long as the configuration of the site allows it (see "autocreatequota" in imapd.conf).
 Unlike what not careful readers may think, enabling the "autocreatequota" option, doesn't
 lead to the automatic INBOX folder creation by Cyrus IMAP server.
@@ -33,10 +33,10 @@ and "create on post".
 
 Create on login
 ===============
-This feauture provides automatic creation of a user's INBOX folder when all of the
+This feature provides automatic creation of a user's INBOX folder when all of the
 following requirements are met:
 
-i)  The user has succesfully passed the authentication procedure.
+i)  The user has successfully passed the authentication procedure.
 
 ii) The user's authorisation ID (typically the same as the user's
 authentication ID)  doesn't belong to the imap_admins or admins
@@ -57,7 +57,7 @@ will be created.
 
 Create on post
 ==============
-This feauture provides automatic creation of a user's INBOX folder when all of the
+This feature provides automatic creation of a user's INBOX folder when all of the
 following requirements are met.
 
 i) An email message addressed to the user has been received.
@@ -103,7 +103,7 @@ shared folder.
 * A new config option has been added. 'autosubscribe_all_sharedfolders' is a yes/no
 option. When set to yes, the user is automatically subscribed to all shared folders one
 has permission to subscribe to. Please, note that when this option is set to yes, then
-'autosubscribesharedfolders' option is overriden.
+'autosubscribesharedfolders' option is overridden.
 
   (D) Automatic creation of a predefined default sieve script.
 
@@ -176,7 +176,7 @@ lmtp_autocreate_users: group:groupname
 Issues to be considered
 =======================
 
-I) In order to use the create on post feauture one should be absolutely sure that:
+I) In order to use the create on post feature one should be absolutely sure that:
 a) The MTA checks the validity of the email recipient before sending the email to
 LMTP. This is an RFC821 requirement. This usually expands to "the mta should be
 able to use the account database as user mailbox database".
diff -pruN 3.0.13-5/doc/README.cyrusdb.md 3.2.0-3/doc/README.cyrusdb.md
--- 3.0.13-5/doc/README.cyrusdb.md	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/README.cyrusdb.md	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,290 @@
+# The CyrusDB Interface
+
+> This document is from an [email](https://lists.andrew.cmu.edu/pipermail/cyrus-devel/2018-February/004217.html) Bron sent to the [cyrus-devel](https://lists.andrew.cmu.edu/pipermail/cyrus-devel/) mailing list.
+
+
+The cyrusdb interface is a common API for accessing key-value
+datastores from within Cyrus code.  It's part of the libcyrus shared
+object (but not libcyrus_min), used by all Cyrus binaries.  The use of
+the cyrusdb API abstracts the details of the underlying data store,
+allowing sites to use different database types depending on their
+needs, and allowing Cyrus developers to use a common API for data
+storage needs.
+
+The entire cyrusdb source lives in the `lib/` directory of the
+`cyrus-imapd` repository, in the following files:
+
+- [`lib/cyrusdb.h`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.h)
+- [`lib/cyrusdb.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c)
+- [`lib/cyrusdb_flat.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb_flat.c)
+- [`lib/cyrusdb_quotalegacy.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb_quotalegacy.c)
+- [`lib/cyrusdb_skiplist.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb_skiplist.c)
+- [`lib/cyrusdb_sql.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb_sql.c)
+- [`lib/cyrusdb_twoskip.c`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb_twoskip.c)
+
+### `cyrusdb.h`
+
+* interface definitions (all access to cyrusdb databases happens through the functions defined here)
+* the [`struct cyrusdb_backend`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.h#L94) data structure which defines the interface implemented by each backend.
+* constants for flags to the [`cyrusdb_open`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.h#L251) call, and return codes.  Cyrusdb functions all return their own `CYRUSDB_*` error codes, which are not compatible with the `r = IMAP_*` return codes used throughout much of the rest of the codebase.
+
+### `cyrusdb.c`
+
+* implementations of the wrapper functions around the backends, including default implementations of some functions which are common to many backends but overridden by some.
+* a wrapper to initialise and cleanup the state of each backend (if needed) during Cyrus set up / tear down.
+
+### `cyrusdb_*.c`
+
+* the actual implementations of each backend!  We'll look at some in a sec.
+
+## Tools
+There are also some tools to work with and support Cyrus databases:
+
+### `imap/ctl_cyrusdb`
+
+Performs maintenance on the cyrusdb subsystem.  This is called in two places:
+  - START: `ctl_cyrusdb -r` (recovery).  This is the *ONLY PLACE* that code is guaranteed to be run at startup on every Cyrus installation, so you'll find quite a lot of detritus has built up in this codepath over the years.
+  - EVENTS: `ctl_cyrusdb -c` (checkpoint).  This is run regularly (`period=180` at FastMail, examples in the codebase have `period=5` or `period=30`). Both this codepath and `cyr_expire` tend to run periodically on Cyrus systems, and cleanup code is spread between those two locations.
+
+### `imap/cvt_cyrusdb`
+
+Used for converting a database between versions.  This is often used
+to prepare for upgrade, particularly in the past when Cyrus supported
+Berkeley DB which didn't upgrade cleanly across OS versions, it was
+common to use `cvt_cyrusdb` to turn databases into a very portable
+format (`flat` or `skiplist`) before upgrading, upgrade the OS,
+convert back to the fast format (Berkeley DB) and then restart.
+
+### `imap/cyr_dbtool`
+
+Once known as `brontool`, this is the first piece of Cyrus code I ever wrote!  It's a fairly dumb wrapper around the CyrusDB interface, and able to be used to read, write, or iterate any parts of a database.  Its interactive mode is not special-character clean, but it can also be used in batch mode, which uses IMAP atom-string literal8 for input/output, and hence can roundtrip data reliably.
+
+There are also tools like: `ctl_conversationsdb`, `dav_reconstruct`
+and `ctl_mboxlist` which can be used to manage individual databases
+through a more specific interface which understands the context as
+well as just the raw key/value.
+
+## How to use CyrusDB
+
+Assuming that [`cyrus_init()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.h#L247) has been called, which calls [`cyrusdb_init()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L328), you can assume that databases will work in any Cyrus code.
+
+The first step is to open a database.  Databases have a filename -
+this might be a literal filename on the backend, a directly containing
+data, or an opaque token used by the backend to locate a datasource.
+
+```c
+int flags = 0;
+struct db *mydb = NULL;
+int r = cyrusdb_open("skiplist", "/tmp/database.db", flags, &mydb);
+if (!r) return mydb;  // if (r == CYRUSDB_OK) { ... }
+/* XXX: error handling */
+```
+
+#### Accepted flags
+
+* `CYRUSDB_CREATE` - if the named database doesn't exist, create a
+  blank database.
+  
+* `CYRUSDB_MBOXSORT` - use the abomination called
+  `improved_mboxlist_sort` which re-orders a couple of characters to
+  allow "foo.bar" to sort before "foo bar", for perfectly good
+  reasons, but we're going to fix it a better way.  Not every engine
+  supports arbitrary collation, and if many engines corrupt horribly
+  if the same database is opened with different choices for this flag.
+  Ouch.
+  
+* `CYRUSDB_CONVERT` - if set and the database fails to open, attempt a
+  magic detection on the file content and try to convert the database
+  to the requested backend type before opening it.  In-place upgrades!
+  If this is NOT set, then instead the magic detection will still be
+  performed, but the open database will be returned using the correct
+  engine for that database rather than converted.  Magic detection
+  only currently works for single-file database formats.
+
+* `CYRUSDB_NOCOMPACT` - if the database format supports automatic
+  compacting, don't use it.  Handy for when you want to read without
+  causing any possible issues (e.g. read-only filesystem during
+  recovery) or when performance is critical and you don't want to risk
+  waiting while a recompact happens.
+  
+
+All the remaining functions take that [`struct db`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L83) pointer.
+
+There's also
+a
+[`cyrusdb_lockopen()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L179) interface 
+which takes a transaction pointer and returns with the transaction
+already active.  This isn't actually being used yet, but is intended
+to allow slightly more efficient single-operation database use.  Right
+now, open returns an unlocked database, but may need to lock as part
+of the setup, so keeping that lock would avoid one extra unlock/lock
+cycle.
+
+
+## Reading, writing, transactions
+
+CyrusDB supports both transactional and non-transactional access.
+Transactions are always exclusive.  This is arguably a deficiency in
+the interface, particularly since many engines implement a
+non-exclusive (read) lock internally anyway.
+
+There are now 4 interfaces to read data.  Two of which are original
+cyrusdb and two of which are more recently added.
+
+* original
+  - [`cyrusdb_fetch()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L194)   - fetch a single value by exact key.
+  - [`cyrusdb_foreach()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L229) - given a prefix, iterate over all the keys with that prefix (including exactly that key) in order.
+
+* newer:
+  - [`cyrusdb_fetchnext()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L216) - given an exact key, fetch the following key and value (regardless of whether the key exists), e.g given keys "f" and "g", fetchnext "foo" would return "g", as would fetchnext "f".  This can be used to implement foreach (indeed, the skips do exactly that).
+  - [`cyrusdb_forone()`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L241) - given an exact key, act like `cyrusdb_foreach` but only for that one key.  This is a convenience wrapper around fetch to allow doing things like:
+```c
+r = cyrusdb_forone(mydb, "folder", 6, p, cb, rock, &tid);
+if (!r) r = cyrusdb_foreach(mydb, "folder.", 7, p, cb, rock, &tid);
+```
+
+Which does precisely *"folder"* and its children without visiting any other keys that have *"folder"* as a prefix.
+
+Since the cyrusdb interface always takes both a pointer and a length, it's also possible to use:
+```c
+char *key = "folder.";
+r = cyrusdb_forone(mydb, key, 6, p, cb, rock, &tid);
+if (!r) r = cyrusdb_foreach(mydb, key, 7, p, cb, rock, &tid);
+```
+
+You may have noticed that `tid` at the end.  Every function for acting on the database takes as its last argument a [`struct txn **`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.h#L49).  You can pass one of three things to this:
+
+* `NULL` - non-transactional request.  Do whatever you need for
+  internal locking, but starts with an unlocked database and ends with
+  an unlocked database.  NOTE: at least skiplist and twoskip implement
+  a hack where if the database IS locked for a non-transactional read
+  request, they will act as if you'd passed the current transaction in
+  for the NULL case.  This is a hack around layering violations and
+  kind of sucks.
+  `&NULL` - e.g:
+```c
+   struct txn *tid = NULL;
+   const char *data = NULL;
+   size_t datalen = 0;
+   int r = cyrusdb_fetch(mydb, key, keylen, &data, &datalen, &tid);
+```
+
+After calling this, tid will have an opaque value allocated by the
+database backend, which must be passed to all further cyrusdb
+operations on that database until either `cyrusdb_commit()` or
+`cyrusdb_abort()` are called.
+`&tid` - e.g.
+
+```c
+    if (r == CYRUSDB_NOTFOUND) {
+        r = cyrusdb_store(mydb, key, keylen, "DEFAULT", 7, &tid); // set a default value
+    }
+```
+
+Given an existing transaction, perform this call in the context of the transaction.
+
+OK, foreach.  Foreach is very tricky, because it takes TWO callbacks.  The callbacks have an identical signature, but different return codes!
+
+```c
+typedef int foreach_p(void *rock,
+                      const char *key, size_t keylen,
+                      const char *data, size_t datalen);
+
+typedef int foreach_cb(void *rock,
+                       const char *key, size_t keylen,
+                       const char *data, size_t datalen);
+```
+
+The difference is this:  `foreach_p` is called with the database
+locked, **always** - even if called without a transaction.
+`foreach_p` returns `1` or `0`.  `0` means *"skip this record"*, `1`
+means *"process this record"*.  This is useful to pre-filter records
+when called without a transaction, because otherwise you lock and
+unlock all the time.
+
+`NULL` for `foreach_p` is treated like a test which always returns `1`, so you can pass `NULL` if you don't need filtering.
+
+If `foreach_p` returns `1`, then with an unlocked transaction, the
+database is now unlocked BEFORE calling `foreach_cb`, the callback.
+`foreach_cb` returns a `CYRUSDB_` response.  If zero, the foreach will
+continue.  If non-zero, the `foreach` will abort and return the
+non-zero response.  This is both useful for error cases, and useful
+for short-circuiting, if you only care that a key exists, you can do
+something like:
+
+```c
+static int exists_cb(void *rock __attribute__((unused)), [...])
+{
+    return CYRUSDB_DONE; /* one is enough */
+}
+```
+
+and then use `exists_cb` as your `foreach_cb` and check if the return code is `CYRUSDB_DONE` to know if the foreach found a key.
+
+If `foreach` is called with a transaction pointer, then it is your responsibility as the caller to also pass that pointer (and a pointer to the database) in that rock, so that callees can make further operations within the same transaction.  A foreach with a transaction does NOT unlock before calling its callback.
+
+### Writing
+There are three write operations:
+
+- [`cyrusdb_create`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L258)
+- [`cyrusdb_store`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L268)
+- [`cyrusdb_delete`](https://github.com/cyrusimap/cyrus-imapd/blob/master/lib/cyrusdb.c#L278)
+
+`cyrusdb_store` will either create or overwrite an existing key.
+`cyrusdb_create` will abort if the key already exists.
+`cyrusdb_delete` takes a flag `force'`which just makes it return
+`CYRUSDB_OK (0)` rather than `CYRUSDB_NOTFOUND` if they key doesn't
+exist.  Strangely, `force` is after `&tid`, making it the only cyrusdb
+API that does that, but hey - keeps you on your toes.
+
+`&tid` behaves exactly the same for the write APIs.  If not passed, then the database engine will behave as it if creates a writable transaction, does the operation, then commits all within the `cyrusdb_*` call.
+
+### Gotchas!
+
+* `NULL` is permitted in both keys and values, though `flat` and `quotalegacy` have 8-bit cleanliness issues.
+* zero-length keys are not supported.
+* zero-length values are theoretically supported, but a little
+interesting.  Certainly, pass "" rather than `NULL` as the value when
+writing or things will get weird.  I'm pretty sure at least the *skip
+databases assert on these kinds of weirdness.
+* unlocked `foreach`: this is the land of the gotcha!  They key and
+data pointers (`const char *`) passed to your `foreach_cb` are only
+valid **UNTIL YOU TOUCH THE DATABASE**. A common cause of rare and
+hard to diagnose bugs is writing something to the same database in the
+same process (**OR EVEN READING FROM IT AGAIN**).  I cannot emphasise
+this enough.  If you want to zero-copy access that data, you need to
+access it first, before touching that DB again.  Otherwise the map in
+which the data was a pointer may have been replaced as the next read
+found a new file and mapped it in!
+Also: if you're implementing a backend.  Unlocked `foreach` must find future records created by the current callback.  Consider a database containing 4 keys:
+
+```
+A B C D
+```
+
+if you are at key `B` and insert a key `BB`, then it must be iterated over.  If you insert `AA` while at `B`, it must **NOT** be iterated over.
+
+* Opening the same database multiple times.  In the bad old days,
+  opening the same database multiple times in the same process led to
+  locking bugs (`fcntl` is braindead).  Each database engine is
+  responsible for making sure this doesn't happen.  Most engines keep
+  a linked lists of open databases.  If you try to open the same
+  database again, they will just return the existing opened copy and
+  bump a refcount.  Beware.  If a database is locked and you try to
+  lock again - thinking you were opening it brand new, it will
+  assertion fail and/or error.
+
+
+I think that covers about everything!
+
+Cyrusdb is used just about everywhere that sorted key-value databases
+give what's needed, including `mailboxes.db`, `annotations.db` (global and
+per mailbox databases), seen state (non-owner), subscriptions,
+`cyrus.indexed.db` for `Xapian`, and the rather massive (and increasingly
+inaccurately named) `user.conversations`.
+
+Future plans are to increase the usage of cyrusdb databases, possibly
+by building an indexing layer on top and using that instead of the
+sqldb interface used for sqlite databases by DAV code, and possibly
+also moving other custom file formats into a cyrusdb to allow easier
+stateless server builds on a distributed backend.
diff -pruN 3.0.13-5/doc/text/developers.txt 3.2.0-3/doc/text/developers.txt
--- 3.0.13-5/doc/text/developers.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/developers.txt	2020-05-04 04:13:52.000000000 +0000
@@ -32,8 +32,96 @@ Developers
 
   * About Cyrus Works
 
-  * Testing
-
   * How it works
 
-  * Adding Rules
+
+Cyrus Internals
+===============
+
+These documents are intended for persons interested in contributing to
+the Cyrus IMAP development effort, or for those interested in lower-
+level details about how Cyrus is implemented.
+
+* Cyrus APIs
+
+  * CyrusDB API
+
+  * cyrusdb API
+
+  * Index API
+
+  * Mailbox API
+
+* Thoughts & Notes
+
+  * Notes for backup implementation
+
+  * Cyrus IMAP Server: Sieve Bytecode
+
+  * Cyrus CalDAV Scheduling Flowchart
+
+  * Enabling improved_mboxlist_sort
+
+  * Cyrus IMAP Server: Notes
+
+  * Cyrus IMAP Server: Prot Events
+
+* Guidance for Developers
+
+  * Cyrus IMAP Server: Hacking
+
+  * Cyrus IMAP Server: Internationalization
+
+  * Cyrus IMAP Server: Locking
+
+  * Cyrus IMAP Server: Mailbox File Formats
+
+  * Cyrus IMAP Server: Namelocks
+
+  * Cyrus IMAP Server: prot layer
+
+  * Cyrus IMAP Server: Replication Examples
+
+  * Cyrus IMAP Server: Replication Protocol v2.4+
+
+  * Cyrus IMAP Server: Special Characters
+
+  * Cyrus IMAP Server: var directory structure
+
+This "diagram" shows the Master State Machine.
+
+
+Unit Tests
+==========
+
+* Unit Tests
+
+  * Table of Contents
+
+  * 1. Introduction
+
+  * 2. What Is A Unit Test?
+
+  * 3. Running The Tests
+
+    * 3.1. Setting Up The Machine
+
+    * 3.2 Configure Script
+
+    * 3.3 Make
+
+    * 3.4 Using Valgrind
+
+    * 3.5 The Tests Are Failing
+
+  * 3.6 Debugging A Test
+
+  * 4. Adding Your Own Tests
+
+  * 4.1 Where To Put Your Tests
+
+  * 4.1 Adding A New Suite
+
+  * 4.2 Adding A Test To A Suite
+
+  * 4.3 Suite Setup And Teardown
diff -pruN 3.0.13-5/doc/text/download.txt 3.2.0-3/doc/text/download.txt
--- 3.0.13-5/doc/text/download.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/download.txt	2020-05-04 04:13:52.000000000 +0000
@@ -36,20 +36,26 @@ Download
 
   * Supported Product Series
 
+    * Series 3.2
+
     * Series 3.0
 
     * Series 2.5
 
-    * Series 2.4
+  * Development snapshots
+
+    * Cyrus IMAP 3.1 Tags
 
   * Older Versions
 
     * Series 1
 
-    * Series 2: 2.0 - 2.3
+    * Series 2: 2.0 - 2.4
 
 * Notes for Packagers
 
+  * Binary naming
+
   * Sample configuration files
 
   * Predefined configurations
diff -pruN 3.0.13-5/doc/text/imap/concepts/deployment/databases.txt 3.2.0-3/doc/text/imap/concepts/deployment/databases.txt
--- 3.0.13-5/doc/text/imap/concepts/deployment/databases.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/deployment/databases.txt	2020-05-04 04:13:52.000000000 +0000
@@ -65,7 +65,8 @@ One per user:
 
 * Subscriptions (<userid>.sub)
 
-* Search Indexes (cyrus.squat, <userid>.xapianactive)
+* Search Indexes (cyrus.squat, <userid>.xapianactive,
+  cyrus.indexed.db)
 
 
 Mailbox List (mailboxes.db)
@@ -80,7 +81,7 @@ ACL on the mailbox. The format of each r
 
    Data: <Type Number>SP<Partition>SP<ACL (space-separated userid/rights pairs)>
 
-File type can be: twoskip (default), flat, skiplist, sql, or lmdb.
+File type can be: twoskip (default), flat, skiplist, or sql.
 
 
 Annotations (annotations.db)
@@ -97,7 +98,7 @@ each record is as follows:
 
    Data: <Value Size (4 bytes)><Value>\0<Content-Type>\0<Timestamp (4 bytes)>
 
-File type can be: twoskip  (default), skiplist, or lmdb.
+File type can be: twoskip  (default) or skiplist.
 
 
 Quotas (quotas.db)
@@ -112,8 +113,8 @@ of the quota root. The format of each re
 
    Data: <Usage (in bytes)>SP<Limit (in Kbytes)>
 
-File type can be: quotalegacy (default), flat, skiplist, sql, twoskip,
-or lmdb.
+File type can be: quotalegacy (default), flat, skiplist, sql, or
+twoskip.
 
 **Legacy Quotas**
 
@@ -146,7 +147,7 @@ timestamp of the record and the UID of t
 
    Data: <Timestamp (4 bytes)><Message UID (4 bytes)>
 
-File type can be: twoskip (default), skiplist, sql, or lmdb.
+File type can be: twoskip (default), skiplist, or sql.
 
 
 TLS cache (tls_sessions.db)
@@ -163,7 +164,7 @@ record is as follows:
 
    Data: <Timestamp (4 bytes)><Session Data (multi-byte)>
 
-File type can be: twoskip (default), skiplist, sql, or lmdb.
+File type can be: twoskip (default), skiplist, or sql.
 
 
 PTS cache (ptscache.db)
@@ -178,7 +179,7 @@ the userid. The format of each record is
 
    Data: <Auth State (multi-byte)>
 
-File type can be: twoskip (default), skiplist, or lmdb.
+File type can be: twoskip (default) or skiplist.
 
 
 STATUS cache (statuscache.db)
@@ -199,7 +200,7 @@ record is as follows:
 
    Data: <Version>SP<Bitmask of Items>SP<Mtime of Index>SP<Inode of Index>SP<Size of Index>SP<- of Messages>SP<- of Recent Messages>SP<Next UID>SP<UID Validity>SP<- of Unseen Messages>SP<Highest Mod Sequence>
 
-File type can be: twoskip (default), skiplist, sql, or lmdb.
+File type can be: twoskip (default), skiplist, or sql.
 
 
 User Access (user_deny.db)
@@ -217,7 +218,7 @@ follows:
 
    Data: <Version>TAB<Deny List (comma-separated wildmat patterns)>TAB<Deny Message>
 
-File type can be: flat (default), skiplist, sql, twoskip, or lmdb.
+File type can be: flat (default), skiplist, sql, or twoskip.
 
 
 Backups (backups.db)
@@ -227,7 +228,7 @@ This database maps userids to the locati
 only exists on Cyrus Backup servers (compiled with the *--enable-
 backup* configure option).
 
-File type can be: twoskip (default), skiplist, sql, twoskip, or lmdb.
+File type can be: twoskip (default), skiplist, sql, or twoskip.
 
 
 Conversations (<userid>.conversations)
@@ -239,13 +240,13 @@ which this message ID has been seen, and
 last seen.
 
 It also has a records for each conversation ID with details about
-which folders have that converations ID in them, and counts of
+which folders have that conversations ID in them, and counts of
 messages and flags.
 
 Finally there are records for each folder with the counts of
 conversations in that folder.
 
-File type can be: skiplist (default), sql, twoskip, or lmdb.
+File type can be: skiplist (default), sql, or twoskip.
 
 
 Counters (<userid>.counters)
@@ -262,14 +263,20 @@ News database (fetchnews.db)
 File format not selectable.
 
 
-Search Indexes (cyrus.squat, <userid>.xapianactive)
----------------------------------------------------
+Search Indexes (cyrus.squat, <userid>.xapianactive, cyrus.indexed.db)
+---------------------------------------------------------------------
 
-This is either cyrus.squat in each folder, or if you're using xapian a
-single <userid>.xapianactive file listing active databases by tier
+This is either cyrus.squat in each folder, or if you're using Xapian a
+single <userid>.xapianactive file listing active databases with tier
 name and number.
 
-File type can be: twoskip (default), flat, skiplist, or lmdb.
+cyrus.indexed.db is used by the Xapian search engine.  Its file type
+can be: twoskip (default), flat, skiplist, or "zeroskip" and is
+determined by *search_indexed_db* in imapd.conf(5).
+
+The xapianactive file contains a space separated list of tiers and
+databases within the tier.  The first element is the active
+tier/database, to which new entries are added by *squatter -R*.
 
 
 Zoneinfo db (zoneinfo.db)
@@ -286,7 +293,7 @@ format of each record is as follows:
 
    Data: <Version>SP<Record Type>SP<Timestamp>SP<Data Strings (TAB-separated)>
 
-File type can be: twoskip (default), flat, skiplist, or lmdb.
+File type can be: twoskip (default), flat, or skiplist.
 
 
 Seen State (<userid>.seen)
@@ -304,7 +311,7 @@ been read. The format of each record is
 
    Data: <Version>SP<Last Read Time>SP<Last Read UID>SP<Last Change Time>SP<List of Read UIDs>
 
-File type can be: twoskip (default), flat, skiplist, or lmdb.
+File type can be: twoskip (default), flat, or skiplist.
 
 
 Subscriptions (<userid>.sub)
@@ -319,7 +326,7 @@ record is follows:
 
    Data: None
 
-File type can be: flat (default), skiplist, twoskip, or lmdb.
+File type can be: flat (default), skiplist, or twoskip.
 
 
 Search Index DB List (<userid>.xapianactive)
@@ -341,7 +348,7 @@ each record is follows:
 
    Data: <Version (2 bytes)><Access Key (multi-byte)>
 
-File type can be: twoskip (default), skiplist, or lmdb.
+File type can be: twoskip (default) or skiplist.
 
 
 DAV Index (<userid>.dav)
@@ -438,17 +445,6 @@ An implementation of the Skip List data
 favour of Twoskip as it is not robust in the face of disk failure.
 
 
-lmdb
-----
-
-Lightning Memory-Mapped Database (lmdb) is a high-performance
-transactional key-value store.
-
-Fast while in memory, but slow when the database is loaded. Best for
-databases that are held open for a long time: Mailbox List
-(mailboxes.db)
-
-
 sql
 ---
 
diff -pruN 3.0.13-5/doc/text/imap/concepts/deployment/performance_recommendations.txt 3.2.0-3/doc/text/imap/concepts/deployment/performance_recommendations.txt
--- 3.0.13-5/doc/text/imap/concepts/deployment/performance_recommendations.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/deployment/performance_recommendations.txt	2020-05-04 04:13:52.000000000 +0000
@@ -29,3 +29,13 @@ filesystem.
 Important: Cyrus IMAP requires the parent directories to exist, and
   be writeable by the POSIX user account Cyrus IMAP runs under, prior
   to starting the "master" process.
+
+
+Certificates
+============
+
+Cyrus IMAP can be configured to provide as server two kind of
+certificates: EC and RSA.  The EC certificates are only sent to the
+client, if the client supports them.  EC certificates have the
+advantage of requiring less computational resources compared to RSA,
+while offering comparatively the same security.
diff -pruN 3.0.13-5/doc/text/imap/concepts/deployment/supported-platforms.txt 3.2.0-3/doc/text/imap/concepts/deployment/supported-platforms.txt
--- 3.0.13-5/doc/text/imap/concepts/deployment/supported-platforms.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/deployment/supported-platforms.txt	2020-05-04 04:13:52.000000000 +0000
@@ -110,30 +110,6 @@ When including the following software co
 process, and providing the options listed here, additional optional
 functionality can be implemented;
 
-**Berkeley DB** (Development headers)
-
-To enable using Berkely DB as a database backend, include the Berkeley
-DB development headers and make sure to configure Cyrus IMAP with "--
-with-bdb".
-
-Berkeley DB Versions and Conversion
-
-The Cyrus IMAP "configure" process attempts to automatically detect
-and use the latest Berkeley DB technology available on the system.
-This may, however, not be the same version on your production systems.
-Since database conversions between versions of the Berkeley DB
-technology are particularly difficult and therefor NOT considered
-fully supported, we recommend you do NOT use Berkeley DB.
-
-Should the Berkeley DB development headers be installed in a non-
-standard location, or should you need a specific version when multiple
-versions are available on the system, please consider using any of the
-following options;
-
-   --with-bdb=DIR            use Berkeley DB (in DIR) [yes]
-   --with-bdb-libdir=DIR     Berkeley DB lib files are in DIR
-   --with-bdb-incdir=DIR     Berkeley DB include files are in DIR</screen>
-
 **MySQL** (Development headers)
 
 To enable using MySQL as a database server backend, include the MySQL
diff -pruN 3.0.13-5/doc/text/imap/concepts/deployment.txt 3.2.0-3/doc/text/imap/concepts/deployment.txt
--- 3.0.13-5/doc/text/imap/concepts/deployment.txt	2019-12-16 04:18:21.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/deployment.txt	2020-05-04 04:13:52.000000000 +0000
@@ -59,7 +59,8 @@ deployment of Cyrus IMAP.
 
     * News database (fetchnews.db)
 
-    * Search Indexes (cyrus.squat, <userid>.xapianactive)
+    * Search Indexes (cyrus.squat, <userid>.xapianactive,
+      cyrus.indexed.db)
 
     * Zoneinfo db (zoneinfo.db)
 
@@ -85,8 +86,6 @@ deployment of Cyrus IMAP.
 
     * Skiplist
 
-    * lmdb
-
     * sql
 
     * quotalegacy
@@ -137,6 +136,8 @@ deployment of Cyrus IMAP.
 
   * Databases on Temporary Filesystems
 
+  * Certificates
+
 * Storage Considerations
 
   * General Notes on Storage
diff -pruN 3.0.13-5/doc/text/imap/concepts/features/archiving.txt 3.2.0-3/doc/text/imap/concepts/features/archiving.txt
--- 3.0.13-5/doc/text/imap/concepts/features/archiving.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/features/archiving.txt	2020-05-04 04:13:52.000000000 +0000
@@ -64,10 +64,9 @@ Controlling
 And to control the criteria used to manage migration of data between
 partitions:
 
-   "archive_days:" 7
+   "archive_days:" <none>
 
-      The number of days after which to move messages to the archive
-      partition if archiving is enabled
+      Deprecated in favour of *archive_after*.
 
    "archive_maxsize:" 1024
 
diff -pruN 3.0.13-5/doc/text/imap/concepts/features/delayed-expunge.txt 3.2.0-3/doc/text/imap/concepts/features/delayed-expunge.txt
--- 3.0.13-5/doc/text/imap/concepts/features/delayed-expunge.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/features/delayed-expunge.txt	2020-05-04 04:13:53.000000000 +0000
@@ -33,24 +33,22 @@ settings in imapd.conf(5).
       "expunge_mode:" delayed
 
          The mode in which messages (and their corresponding cache
-         entries) are expunged.  "default" mode is the old behavior in
-         which the message files are purged at the time of the
-         EXPUNGE, but index and cache records are retained to
-         facilitate QRESYNC.  (Note that this behaviour is no longer
-         the default, but is so named for historical reasons.)  In
-         "delayed" mode, which is the default since Cyrus 2.5.0, the
-         message files are also retained, allowing unexpunge to rescue
-         them.  In "immediate" mode, both the message files and the
-         index records are removed as soon as possible.  In all cases,
-         nothing will be finally purged until all other processes have
-         closed the mailbox to ensure they never see data disappear
-         under them.  In "default" or "delayed" mode, a later run of
-         "cyr_expire" will clean out the retained records (and
-         possibly message files). This reduces the amount of I/O that
-         takes place at the time of EXPUNGE and should result in
-         greater responsiveness for the client, especially when
-         expunging a large number of messages. Allowed values:
-         *default*, *immediate*, *delayed*
+         entries) are expunged.  "semidelayed" mode is the old
+         behavior in which the message files are purged at the time of
+         the EXPUNGE, but index and cache records are retained to
+         facilitate QRESYNC. In "delayed" mode, which is the default
+         since Cyrus 2.5.0, the message files are also retained,
+         allowing unexpunge to rescue them.  In "immediate" mode, both
+         the message files and the index records are removed as soon
+         as possible.  In all cases, nothing will be finally purged
+         until all other processes have closed the mailbox to ensure
+         they never see data disappear under them.  In "semidelayed"
+         or "delayed" mode, a later run of "cyr_expire" will clean out
+         the retained records (and possibly message files). This
+         reduces the amount of I/O that takes place at the time of
+         EXPUNGE and should result in greater responsiveness for the
+         client, especially when expunging a large number of messages.
+         Allowed values: *immediate*, *semidelayed*, *delayed*
 
 See also:
 
diff -pruN 3.0.13-5/doc/text/imap/concepts/features.txt 3.2.0-3/doc/text/imap/concepts/features.txt
--- 3.0.13-5/doc/text/imap/concepts/features.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/concepts/features.txt	2020-05-04 04:13:52.000000000 +0000
@@ -23,6 +23,9 @@ concurrent read/write connections to the
 The server supports access control lists on mailboxes and storage
 quotas on mailbox hierarchies.
 
+Cyrus IMAP provisionally supports the emerging JMAP protocol
+standards, when built for such.
+
 The following documents show the full power of each feature that is
 included with Cyrus IMAP.
 
diff -pruN 3.0.13-5/doc/text/imap/developer/ancient-releasing.txt 3.2.0-3/doc/text/imap/developer/ancient-releasing.txt
--- 3.0.13-5/doc/text/imap/developer/ancient-releasing.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/ancient-releasing.txt	2020-05-04 04:13:53.000000000 +0000
@@ -20,7 +20,7 @@ Contents
 
   * Building the release
 
-  * Releasing
+  * Finishing up
 
 
 Introduction
@@ -43,10 +43,6 @@ now just read the manual like she did. :
 Once you have a GPG key, it's helpful to upload your public key to the
 MIT key-server
 
-You also need a shell account on www.cyrusimap.org and
-ftp.cyrusimap.org, with SSH key authentication.  You need to be in the
-"admin" group on each, and also the "cyrupload" group on the latter.
-
 And you need permission to send to the cyrus-announce mailing list.
 
 
@@ -100,6 +96,11 @@ Pre-release testing
    7. Run the unit tests if there are any: "make check" -- they
       should pass.
 
+Note: We don't bother to run "make distcheck" on the old branches,
+  because it almost certainly won't work.  We also don't bother to run
+  Cassandane, for much the same reason.  If it builds, that's about as
+  much as we can do.
+
 
 Cross-pollination of release notes
 ==================================
@@ -112,8 +113,8 @@ well.
 1. Change to the current stable branch (at time of writing, this is
    "cyrus-imapd-3.0").
 
-2. Create a new release notes at the appropriate location under
-   "docsrc/imap/download/release-notes/".
+2. Create a new release notes document at the appropriate location
+   under "docsrc/imap/download/release-notes/".
 
 3. Add the release notes you wrote earlier, this time using RST
    format rather than simple HTML.
@@ -164,27 +165,7 @@ Building the release
     (assuming your remote is named "ci").
 
 
-Releasing
-=========
-
-1. Upload the tarball and signature to www: "scp cyrus-
-   imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/"
-
-2. Upload them to ftp too: "scp cyrus-imapd-*.tar.gz cyrus-
-   imapd-*.tar.gz.sig ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/"
-
-3. SSH into both www and ftp, and move older releases to the old
-   versions directory.  You want only the two most recent tarball+sig
-   pairs for each major series.
-
-4. While SSH'd into www, build the legacy documentation for this
-   release:
-
-   1. Copy the release tarball to /var/tmp
-
-   2. Run the script to publish the tarball documentation to the
-      web: "/usr/local/bin/PublishCyrusDocs.pl -f /var/tmp/cyrus-
-      imapd-<version>.tar.gz"
+Finishing up
+============
 
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+Now follow the remaining steps from Releasing Cyrus IMAP
diff -pruN 3.0.13-5/doc/text/imap/developer/API/cyrusdb2.txt 3.2.0-3/doc/text/imap/developer/API/cyrusdb2.txt
--- 3.0.13-5/doc/text/imap/developer/API/cyrusdb2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/API/cyrusdb2.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,346 @@
+
+cyrusdb API
+***********
+
+
+Intro
+=====
+
+The "cyrusdb" API is a common interface to a key-value store, used
+throughout the Cyrus code. It allows a choice of different backends
+for different access patterns, while ensuring a consistent interface.
+
+This document will describe the interface, and how to use the cyrusdb
+interface from within parts of Cyrus code, as well as how to implement
+your own backend
+
+If you pass incorrect values to these APIs, you will get an assertion
+failure in most cases. That's generally considered safer than silently
+breaking things. Exceptions are noted below.
+
+
+Code Layout
+===========
+
+The implementation of each interface is in "lib/cyrusdb_NAME.c", for
+example lib/cyrusdb_flat.c. General functions are in "lib/cyrusdb.c"
+and the interface in "lib/cyrusdb.h".
+
+
+Configuration
+=============
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: "annotation_db: skiplist". This
+is then read in imap/global.h and imap/global.c during startup, so
+that the global variable "config_annotation_db" gets set to the
+configured backend name:
+
+   config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: "config_annotation_db" is a string
+describing the *backend* used by the database, not, say, its location
+on disk.)
+
+Internally, the main module for each database sets up struct of
+pointers to the cyrusdb functions it implements, which is registered
+in "lib/cyrusdb.c"
+
+"lib/cyrus.c" provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+
+A full example
+==============
+
+   struct db *db = NULL;
+   struct txn *tid = NULL;
+   const char *filename = NULL;
+   int flags = CYRUSDB_CREATE;
+
+   cyrus_init(alt_config, "toolname", 0);
+
+   filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+   r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+   r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+   r = cyrusdb_commit(db, tid);
+
+   r = cyrusdb_close(db);
+
+   cyrus_done();
+
+Note that you always open a database first, and close it at the end.
+You must always call cyrus_init() and cyrus_done() to properly
+initialize and clean up the "cyrusdb" environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+
+About Transactions
+==================
+
+The cyrusdb interface works in two modes - transactional and non-
+transactional. The value of the 'tid' parameter decides which mode is
+used. There are three possible values:
+
+* NULL - non-transactional. Will create a temporary lock for the
+  duration of the current action - either a write lock for "store" or
+  a read lock for "fetch". If you call "foreach", the lock will be
+  dropped between each record fetched
+
+* Pointer to NULL - transactional, transaction not yet started. Will
+  always take a write lock on the database, and update the pointer to
+  point to the new transaction.
+
+* Pointer to a valid transaction. Will keep using this transaction
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions. There is one exception in the skiplist backend: *If you
+pass NULL to a fetch or foreach while the database is in a
+transaction, it will silently do the read in the current transaction
+rather than returning an error*
+
+
+API Reference
+=============
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+
+cyrusdb_init(void)
+------------------
+
+Is called once per process. Don't call this yourself, use
+"cyrus_init()". No other calls will be made until this is called.
+
+
+cyrusdb_done(void)
+------------------
+
+The opposite of "cyrusdb_init()" - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use "cyrus_done()".
+
+
+cyrusdb_sync(const char *backend)
+---------------------------------
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by "ctl_cyrusdb -c" on a regular basis
+
+
+cyrusdb_open(const char *backend, const char *fname, int flags, struct db **retdb)
+----------------------------------------------------------------------------------
+
+Opens the database with the specified 'file name' (or other
+descriptor, for example the sql backend is not a filename), and if
+successful returns an opaque database structure
+
+Flags:
+
+* CYRUSDB_CREATE - create the database if it doesn't exist
+
+* CYRUSDB_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+* CYRUSDB_IOERROR - if there is any error reading the file, or any
+  corruption detected while loading the file
+
+
+cyrusdb_close(struct db *db)
+----------------------------
+
+Close the named database. Will release any locks if they are still
+held, but it's bad practice to close without committing or aborting,
+so the backend should log an error
+
+Errors:
+
+* CYRUSDB_IOERROR - if there are any errors during close
+
+
+cyrusdb_fetch(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)
+---------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_fetchlock(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)
+-------------------------------------------------------------------------------------------------------------------------
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case *datalen will be set to zero, and *data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL
+datalen if you are only interested in the length
+
+Errors:
+
+* CYRUSDB_IOERROR - if any error occurs reading from the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_NOTFOUND - if there is no record that matches the key
+
+
+cyrusdb_foreach(struct db *db, const char *prefix, size_t prefixlen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)
+-----------------------------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_forone(struct db *db, const char *key, size_t keylen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)
+----------------------------------------------------------------------------------------------------------------------------------
+
+"cyrusdb_foreach()" iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on
+the parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error
+to give a non-zero prefixlen with a NULL prefix.
+
+"cyrusdb_forone()" "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each
+record from a foreach, this lets you use the same interface to process
+a single record.
+
+"goodp" - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and
+returns true (non-zero) to process, or zero to skip and move straight
+to the next record. Because goodp can't make any database changes, it
+doesn't break the lock, so it's faster to use goodp to filter records
+if you don't need to process all of them. NULL is a legal value for
+goodp, and means that all records will be processed.
+
+"procp" - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns non-
+zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+* procp_result - whatever your callback returns
+
+* CYRUSDB_IOERROR - if any error occurs while reading
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+
+cyrusdb_create(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)
+--------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_store(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)
+-------------------------------------------------------------------------------------------------------------------
+
+Create a new record or replace an existing one. The only difference
+between these two is that "cyrusdb_create" will return an error if the
+record already exists, while "cyrusdb_store" will replace it
+
+If tidptr is NULL, create/store will take a write lock for the
+duration of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero.
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_EXISTS - if "cyrusdb_create" is called on an existing key
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_delete(struct db *db, const char *key, size_t keylen, struct txn **tidptr, int force)
+---------------------------------------------------------------------------------------------
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_NOTFOUND - if force is not set and the key doesn't exist
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_commit(struct db *db, struct txn *tid)
+----------------------------------------------
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_abort(struct db *db, struct txn *tid)
+---------------------------------------------
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+
+cyrusdb_dump(struct db *db, int detail)
+---------------------------------------
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+
+cyrusdb_consistent(struct db *db)
+---------------------------------
+
+Check if the DB is internally consistent. Looks pretty bogus, and
+isn't used anywhere. Don't use.
diff -pruN 3.0.13-5/doc/text/imap/developer/API/cyrusdb.txt 3.2.0-3/doc/text/imap/developer/API/cyrusdb.txt
--- 3.0.13-5/doc/text/imap/developer/API/cyrusdb.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/API/cyrusdb.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,691 @@
+
+CyrusDB API
+***********
+
+
+The interface
+=============
+
+   The bulk, especially the beginning, of this document is from an
+   email Bron sent to the cyrus-devel mailing list on 27 February 2018
+   05:50:39GMT.
+
+The cyrusdb interface is a common API for accessing key-value
+datastores from within cyrus code. It's part of the libcyrus shared
+object (but not libcyrus_min), used by all cyrus binaries. The use of
+the cyrusdb API abstracts the details of the underlying data store,
+allowing sites to use different database types depending on their
+needs, and allowing Cyrus developers to use a common API for data
+storage needs.
+
+The entire cyrusdb source lives in the lib/ directory of the cyrus-
+imapd repository, in the following files:
+
+   lib/cyrusdb.h
+   lib/cyrusdb.c
+   lib/cyrusdb_flat.c
+   lib/cyrusdb_quotalegacy.c
+   lib/cyrusdb_skiplist.c
+   lib/cyrusdb_sql.c
+   lib/cyrusdb_twoskip.c
+
+
+cyrusdb.h
+---------
+
+* interface definitions (all access to cyrusdb databases happens
+  through the functions defined here)
+
+* the "struct cyrusdb_backend" data structure which defines the
+  interface implemented by each backend.
+
+* constants for flags to the cyrusdb_open call, and return codes.
+  Cyrusdb functions all return their own CYRUSDB_* error codes, which
+  are not compatible with the r = IMAP_* return codes used throughout
+  much of the rest of the codebase.
+
+
+cyrusdb.c
+---------
+
+* implementations of the wrapper functions around the backends,
+  including default implementations of some functions which are common
+  to many backends but overridden by some.
+
+* a wrapper to initialise and cleanup the state of each backend (if
+  needed) during Cyrus set up / tear down.
+
+
+cyrusdb_*.c
+-----------
+
+* the actual implementations of each backend! We'll look at some in
+  a sec.
+
+
+Configuration
+=============
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: "annotation_db: skiplist". This
+is then read in imap/global.h and imap/global.c during startup, so
+that the global variable "config_annotation_db" gets set to the
+configured backend name:
+
+   config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: "config_annotation_db" is a string
+describing the *backend* used by the database, not, say, its location
+on disk.)
+
+Internally, the main module for each database sets up struct of
+pointers to the cyrusdb functions it implements, which is registered
+in "lib/cyrusdb.c"
+
+"lib/cyrus.c" provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+
+A full example
+==============
+
+   struct db *db = NULL;
+   struct txn *tid = NULL;
+   const char *filename = NULL;
+   int flags = CYRUSDB_CREATE;
+
+   cyrus_init(alt_config, "toolname", 0);
+
+   filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+   r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+   r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+   r = cyrusdb_commit(db, tid);
+
+   r = cyrusdb_close(db);
+
+   cyrus_done();
+
+Note that you always open a database first, and close it at the end.
+You must always call cyrus_init() and cyrus_done() to properly
+initialize and clean up the "cyrusdb" environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+
+Tools
+=====
+
+There are also some tools to work with and support cyrus databases:
+
+
+imap/ctl_cyrusdb
+----------------
+
+ctl_cyrusdb(8)
+
+* performs maintenance on the cyrusdb subsystem. This is called in
+  two places:
+
+  * START: "ctl_cyrusdb -r" (recovery). This is the ONLY PLACE that
+    code is guaranteed to be run at startup on every cyrus
+    installation, so you'll find quite a lot of detritus has built up
+    in this codepath over the years.
+
+  * EVENTS: "ctl_cyrusdb -c" (checkpoint). This is run regularly
+    (period=180 at FastMail, examples in the codebase have period=5 or
+    period=30). Both this codepath and cyr_expire tend to run
+    periodically on cyrus systems, and cleanup code is spread between
+    those two locations.
+
+
+imap/cvt_cyrusdb
+----------------
+
+cvt_cyrusdb(8)
+
+* used for converting a database between versions. This is often
+  used to prepare for upgrade, particularly in the past when Cyrus
+  supported berkeley DB which didn't upgrade cleanly across OS
+  versions, it was common to use cvt_cyrusdb to turn databases into a
+  very portable format (flat or skiplist) before upgrading, upgrade
+  the OS, convert back to the fast format (berkeley) and then restart.
+
+
+imap/cyr_dbtool
+---------------
+
+cyr_dbtool(8)
+
+* once known as brontool, this is the first piece of Cyrus code I
+  ever wrote! It's a fairly dumb wrapper around the CyrusDB interface,
+  and able to be used to read, write, or iterate any parts of a
+  database. Its interactive mode is not special-character clean, but
+  it can also be used in batch mode, which uses IMAP atom-string
+  literal8 for input/output, and hence can roundtrip data reliably.
+
+There are also tools like: ctl_conversationsdb(8), dav_reconstruct(1)
+and ctl_mboxlist(8) which can be used to manage individual databases
+through a more specific interface which understands the context as
+well as just the raw key/value.
+
+
+How to use CyrusDB
+==================
+
+Assuming that "cyrus_init()" has been called, which calls
+"cyrusdb_init()", you can assume that databases will work in any Cyrus
+code.
+
+The first step is to open a database. Databases have a filename - this
+might be a literal filename on the backend, a directly containing
+data, or an opaque token used by the backend to locate a datasource.
+
+   int flags = 0;
+   struct db *mydb = NULL;
+   int r = cyrusdb_open("skiplist", "/tmp/database.db", flags, &mydb);
+   if (!r) return mydb;  // if (r == CYRUSDB_OK) { ... }
+   /* XXX: error handling */
+
+Accepted flags:
+
+CYRUSDB_CREATE - if the named database doesn't exist, create a blank
+database.
+
+CYRUSDB_MBOXSORT - use the abomination called improved_mboxlist_sort
+which re-orders a couple of characters to allow "foo.bar" to sort
+before "foo bar", for perfectly good reasons, but we're going to fix
+it a better way. Not every engine supports arbitrary collation, and if
+many engines corrupt horribly if the same database is opened with
+different choices for this flag. Ouch.
+
+CYRUSDB_CONVERT - if set and the database fails to open, attempt a
+magic detection on the file content and try to convert the database to
+the requested backend type before opening it. In-place upgrades! If
+this is NOT set, then instead the magic detection will still be
+performed, but the open database will be returned using the correct
+engine for that database rather than converted. Magic detection only
+currently works for single-file database formats.
+
+CYRUSDB_NOCOMPACT - if the database format supports automatic
+compacting, don't use it. Handy for when you want to read without
+causing any possible issues (e.g. read-only filesystem during
+recovery) or when performance is critical and you don't want to risk
+waiting while a recompact happens.
+
+All the remaining functions take that "struct db" pointer.
+
+There's also a "cyrusdb_lockopen()" interface which takes a
+transaction pointer and returns with the transaction already active.
+This isn't actually being used yet, but is intended to allow slightly
+more efficient single-operation database use. Right now, open returns
+an unlocked database, but may need to lock as part of the setup, so
+keeping that lock would avoid one extra unlock/lock cycle.
+
+
+Reading, Writing, & Transactions
+================================
+
+CyrusDB supports both transactional and non-transactional access.
+Transactions are always exclusive. This is arguably a deficiency in
+the interface, particularly since many engines implement a non-
+exclusive (read) lock internally anyway.
+
+
+Reading
+-------
+
+There are now 4 interfaces to read data. Two of which are original
+cyrusdb and two of which are more recently added.
+
+original:
+
+   "cyrusdb_fetch()"
+      fetch a single value by exact key.
+
+   "cyrusdb_foreach()"
+      given a prefix, iterate over all the keys with that prefix
+      (including exactly that key) in order.
+
+newer:
+
+   "cyrusdb_fetchnext()"
+      given an exact key, fetch the following key and value
+      (regardless of whether the key exists), e.g given keys "f" and
+      "g", fetchnext "foo" would return "g", as would fetchnext "f".
+      This can be used to implement foreach (indeed, the skips do
+      exactly that).
+
+   "cyrusdb_forone()"
+      given an exact key, act like "cyrusdb_foreach" but only for that
+      one key.
+
+      This is a convenience wrapper around fetch to allow doing things
+      like:
+
+         r = cyrusdb_forone(mydb, "folder", 6, p, cb, rock, &tid);
+         if (!r) r = cyrusdb_foreach(mydb, "folder.", 7, p, cb, rock, &tid);
+
+      Which does precisely "folder" and its children without visiting
+      any other keys that have "folder" as a prefix.
+
+Since the cyrusdb interface always takes both a pointer and a length,
+it's also possible to use:
+
+   char *key = "folder.";
+   r = cyrusdb_forone(mydb, key, 6, p, cb, rock, &tid);
+   if (!r) r = cyrusdb_foreach(mydb, key, 7, p, cb, rock, &tid);
+
+OK, foreach. Foreach is very tricky, because it takes TWO callbacks.
+The callbacks have an identical signature, but different return codes!
+
+   typedef int foreach_p(void *rock,
+   const char *key, size_t keylen,
+   const char *data, size_t datalen);
+
+   typedef int foreach_cb(void *rock,
+   const char *key, size_t keylen,
+   const char *data, size_t datalen);
+
+The difference is this: "foreach_p" is called with the database
+locked, always - even if called without a transaction. "foreach_p"
+returns 1 or 0. 0 means "skip this record", 1 means "process this
+record". This is useful to pre-filter records when called without a
+transaction, because otherwise you lock and unlock all the time.
+
+NULL for "foreach_p" is treated like a test which always returns '1',
+so you can pass NULL if you don't need filtering.
+
+If "foreach_p" returns 1, then with an unlocked transaction, the
+database is now unlocked BEFORE calling "foreach_cb", the callback.
+"foreach_cb" returns a CYRUSDB_ response. If zero, the foreach will
+continue. If non-zero, the foreach will abort and return the non-zero
+response. This is both useful for error cases, and useful for short-
+circuiting, if you only care that a key exists, you can do something
+like:
+
+   static int exists_cb(void rock attribute((unused)), [...])
+   {
+       return CYRUSDB_DONE; / one is enough */
+   }
+
+and then use "exists_cb" as your "foreach_cb" and check if the return
+code is CYRUSDB_DONE to know if the foreach found a key.
+
+If foreach is called with a transaction pointer, then it is your
+responsibility as the caller to also pass that pointer (and a pointer
+to the database) in that rock, so that callees can make further
+operations within the same transaction. A foreach with a transaction
+does NOT unlock before calling its callback.
+
+
+About Transactions
+------------------
+
+You may have noticed that 'tid' at the end. Every function for acting
+on the database takes as its last argument a "struct txn **".
+
+The cyrusdb interface works in two modes - transactional and non-
+transactional. The value of the 'tid' parameter decides which mode is
+used. There are three possible values:
+
+* NULL - non-transactional request. Do whatever you need for
+  internal locking, but starts with an unlocked database and ends with
+  an unlocked database.
+
+  Note: At least skiplist and twoskip implement a hack where if the
+    database IS locked for a non-transactional read request, they will
+    act as if you'd passed the current transaction in for the NULL
+    case. This is a hack around layering violations and kind of sucks.
+
+* &NULL - e.g:
+
+     struct txn *tid = NULL;
+     const char *data = NULL;
+     size_t datalen = 0;
+     int r = cyrusdb_fetch(mydb, key, keylen, &data, &datalen, &tid);
+
+  After calling this, tid will have an opaque value allocated by the
+  database backend, which must be passed to all further cyrusdb
+  operations on that database until either "cyrusdb_commit()" or
+  "cyrusdb_abort()" are called.
+
+* &tid - e.g:
+
+     if (r == CYRUSDB_NOTFOUND) {
+         r = cyrusdb_store(mydb, key, keylen, "DEFAULT", 7, &tid); // set a default value
+     }
+
+  Given an existing transaction, perform this call in the context of
+  the transaction.
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions.
+
+There is one exception in the skiplist backend:
+
+   If you pass NULL to a fetch or foreach while the database is in a
+   transaction, it will silently do the read in the current
+   transaction rather than returning an error.
+
+
+Writing
+-------
+
+There are three write operations:
+
+   cyrusdb_create
+   cyrusdb_store
+   cyrusdb_delete
+
+"cyrusdb_store" will either create or overwrite an existing key.
+"cyrusdb_create" will abort if the key already exists.
+"cyrusdb_delete" takes a flag 'force' which just makes it return
+CYRUSDB_OK (0) rather than CYRUSDB_NOTFOUND if the key doesn't exist.
+Strangely, 'force' is after &tid, making it the only cyrusdb API that
+does that, but hey - keeps you on your toes.
+
+&tid behaves exactly the same for the write APIs. If not passed, then
+the database engine will behave as it if creates a writable
+transaction, does the operation, then commits all within the
+"cyrusdb_*" call.
+
+
+Gotchas!
+========
+
+* NULL is permitted in both keys and values, though 'flat' and
+  'quotalegacy' have 8-bit cleanliness issues.
+
+* zero-length keys are not supported
+
+* zero-length values are theoretically supported, but a little
+  interesting. Certainly, pass "" rather than NULL as the value when
+  writing or things will get weird. I'm pretty sure at least the *skip
+  databases assert on these kinds of weirdness.
+
+* unlocked foreach: this is the land of the gotcha! They key and
+  data pointers (const char *) passed to your "foreach_cb" are only
+  valid UNTIL YOU TOUCH THE DATABASE. A common cause of rare and hard
+  to diagnose bugs is writing something to the same database in the
+  same process (OR EVEN READING FROM IT AGAIN). I cannot emphasise
+  this enough. If you want to zero-copy access that data, you need to
+  access it first, before touching that DB again. Otherwise the map in
+  which the data was a pointer may have been replaced as the next read
+  found a new file and mapped it in!
+
+  also: if you're implementing a backend. Unlocked foreach must find
+  future records created by the current callback. Consider a database
+  containing 4 keys:
+
+     A B C D
+
+  If you are at key B and insert a key BB, then it must be iterated
+  over. If you insert AA while at B, it must NOT be iterated over.
+
+* Opening the same database multiple times. In the bad old days,
+  opening the same database multiple times in the same process led to
+  locking bugs (fcntl is braindead). Each database engine is
+  responsible for making sure this doesn't happen. Most engines keep a
+  linked lists of open databases. If you try to open the same database
+  again, they will just return the existing opened copy and bump a
+  refcount. Beware. If a database is locked and you try to lock again
+  - thinking you were opening it brand new, it will assertion fail
+  and/or error.
+
+I think that covers about everything! Cyrusdb is used just about
+everywhere that sorted key-value databases give what's needed,
+including mailboxes.db, annotations.db (global and per mailbox
+databases), seen state (non-owner), subscriptions, cyrus.indexed.db
+for Xapian, and the rather massive (and increasingly inaccurately
+named) user.conversations.
+
+Future plans are to increase the usage of cyrusdb databases, possibly
+by building an indexing layer on top and using that instead of the
+sqldb interface used for sqlite databases by DAV code, and possibly
+also moving other custom file formats into a cyrusdb to allow easier
+stateless server builds on a distributed backend.
+
+
+API Reference
+=============
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+
+cyrusdb_init(void)
+------------------
+
+Is called once per process. Don't call this yourself, use
+"cyrus_init()". No other calls will be made until this is called.
+
+
+cyrusdb_done(void)
+------------------
+
+The opposite of "cyrusdb_init()" - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use "cyrus_done()".
+
+
+cyrusdb_sync(const char *backend)
+---------------------------------
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by "ctl_cyrusdb -c" on a regular basis
+
+
+cyrusdb_open(const char *backend, const char *fname, int flags, struct db **retdb)
+----------------------------------------------------------------------------------
+
+Opens the database with the specified 'file name' (or other
+descriptor, for example the sql backend is not a filename), and if
+successful returns an opaque database structure
+
+Flags:
+
+* CYRUSDB_CREATE - create the database if it doesn't exist
+
+* CYRUSDB_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+* CYRUSDB_IOERROR - if there is any error reading the file, or any
+  corruption detected while loading the file
+
+
+cyrusdb_close(struct db *db)
+----------------------------
+
+Close the named database. Will release any locks if they are still
+held, but it's bad practice to close without committing or aborting,
+so the backend should log an error
+
+Errors:
+
+* CYRUSDB_IOERROR - if there are any errors during close
+
+
+cyrusdb_fetch(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)
+---------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_fetchlock(struct db *db, const char *key, size_t keylen, const char **data, size_t *datalen, struct txn **tidptr)
+-------------------------------------------------------------------------------------------------------------------------
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case *datalen will be set to zero, and *data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL
+datalen if you are only interested in the length
+
+Errors:
+
+* CYRUSDB_IOERROR - if any error occurs reading from the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_NOTFOUND - if there is no record that matches the key
+
+
+cyrusdb_foreach(struct db *db, const char *prefix, size_t prefixlen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)
+-----------------------------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_forone(struct db *db, const char *key, size_t keylen, foreach_p *goodp, foreach_p *procp, void *rock, struct txn **tidptr)
+----------------------------------------------------------------------------------------------------------------------------------
+
+"cyrusdb_foreach()" iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on
+the parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error
+to give a non-zero prefixlen with a NULL prefix.
+
+"cyrusdb_forone()" "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each
+record from a foreach, this lets you use the same interface to process
+a single record.
+
+"goodp" - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and
+returns true (non-zero) to process, or zero to skip and move straight
+to the next record. Because goodp can't make any database changes, it
+doesn't break the lock, so it's faster to use goodp to filter records
+if you don't need to process all of them. NULL is a legal value for
+goodp, and means that all records will be processed.
+
+"procp" - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns non-
+zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+* procp_result - whatever your callback returns
+
+* CYRUSDB_IOERROR - if any error occurs while reading
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+
+cyrusdb_create(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)
+--------------------------------------------------------------------------------------------------------------------
+
+
+cyrusdb_store(struct db *db, const char *key, size_t keylen, const char *data, size_t datalen, struct txn **tidptr)
+-------------------------------------------------------------------------------------------------------------------
+
+Create a new record or replace an existing one. The only difference
+between these two is that "cyrusdb_create" will return an error if the
+record already exists, while "cyrusdb_store" will replace it
+
+If tidptr is NULL, create/store will take a write lock for the
+duration of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero.
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_EXISTS - if "cyrusdb_create" is called on an existing key
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_delete(struct db *db, const char *key, size_t keylen, struct txn **tidptr, int force)
+---------------------------------------------------------------------------------------------
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_NOTFOUND - if force is not set and the key doesn't exist
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_commit(struct db *db, struct txn *tid)
+----------------------------------------------
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+* CYRUSDB_AGAIN - if a deadlock is created. The current transaction
+  has been aborted, but a retry may succeed
+
+
+cyrusdb_abort(struct db *db, struct txn *tid)
+---------------------------------------------
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+* CYRUSDB_IOERROR - any error to write to the database
+
+* CYRUSDB_LOCKED - if tidptr is incorrect
+
+
+cyrusdb_dump(struct db *db, int detail)
+---------------------------------------
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+
+cyrusdb_consistent(struct db *db)
+---------------------------------
+
+Check if the DB is internally consistent. Looks pretty bogus, and
+isn't used anywhere. Don't use.
diff -pruN 3.0.13-5/doc/text/imap/developer/API/index-api.txt 3.2.0-3/doc/text/imap/developer/API/index-api.txt
--- 3.0.13-5/doc/text/imap/developer/API/index-api.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/API/index-api.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,78 @@
+
+Index API
+*********
+
+
+Intro
+=====
+
+The Index API is implemented in "imap/index.h" and "imap/index.c". It
+provides a snapshot view into the underlying mailbox (see *the Mailbox
+API documentation <mailbox-api.html>*) which obeys IMAP semantics, as
+well as all the searching and sorting logic.
+
+
+Opening and closing
+===================
+
+   struct index_state *state = NULL;
+   struct index_init init;
+   int r;
+   const char *mboxname = "user.brong";
+
+   memset(&init, 0, sizeof(struct index_init));
+   init.userid = imapd_userid;
+   init.authstate = imapd_authstate;
+   init.out = imapd_out;
+
+   r = index_open(mboxname, &init, &state);
+   if (r) return r;
+
+   do_stuff(state);
+
+   index_close(&state);
+
+The "index_init" interface sucks. So does passing lots of parameters.
+For now, this will do! Just pass NULL if you're only reading, or use
+the code already in imapd and you'll be fine.
+
+
+The Index Model
+===============
+
+Ok - I think a few words about the index model and how it differs from
+direct mailbox access are needed! In the past, index.c used pointers
+directly into the mmaped "cyrus.index" file and maintained the old
+mmaped copy if an expunge took place. Under the namelock regime, this
+is no longer required because namelocks will avoid the file being re-
+written.
+
+Also, memory is now cheap. Rather than using locks to ensure
+consistency, we just keep a copy of the "struct index_record" for even
+message in the index, stored in memory. Since these are about 100
+bytes each, a 1 million email mailbox will take rougly 100Mb of
+memory. That's not too bad on a modern server, and that's a **huge**
+mailbox.
+
+So - the model works like this:
+
+* Create the index state or re-lock ("index_lock") the mailbox on an
+  existing index.
+
+* call "index_refresh"
+
+* if any changes are to be made (i.e. flag updates for a store, non-
+  peek body fetch, expunge) then cycle through the refreshed state map
+  and update the records which are affected.
+
+* call "index_unlock" (unlock the underlying mailbox and commit the
+  statuscache changes)
+
+  At this point the index lock is **released** and we have not yet
+  generated any network traffic. Now start generating the response.
+
+* if expunges are allowed, call "index_tellexpunge"
+
+* call "index_tellchanges" to tell about all other changes
+
+* return any response that the command itself required
diff -pruN 3.0.13-5/doc/text/imap/developer/API/mailbox-api.txt 3.2.0-3/doc/text/imap/developer/API/mailbox-api.txt
--- 3.0.13-5/doc/text/imap/developer/API/mailbox-api.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/API/mailbox-api.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,325 @@
+
+Mailbox API
+***********
+
+
+Intro
+=====
+
+The Mailbox API is implemented in "imap/mailbox.h" and
+"imap/mailbox.c". It wraps the data structures of the "cyrus.header",
+"cyrus.index" and "cyrus.cache" files in a psuedo-object-oriented way,
+allowing easy changes to the mailbox while keeping the internal cached
+data structures consistent.
+
+
+Opening and closing
+===================
+
+   struct mailbox *mailbox = NULL;
+   int r;
+   const char *mboxname = "user.brong";
+
+   r = mailbox_open_iwl(mboxname, &mailbox);
+   // or
+   r = mailbox_open_irl(mboxname, &mailbox);
+   // or
+   r = mailbox_open_exclusive(mboxname, &mailbox);
+   if (r) return r;
+
+   do_stuff(mailbox);
+
+   mailbox_close(&mailbox);
+
+It is always necessary to obtain an index lock when opening a mailbox,
+because the index header read must be consistent. The locks are as
+follows:
+
++------------------------------+---------------+----------------+
+| Function                     | Namelock      | Index Lock     |
++==============================+===============+================+
+| mailbox_open_iwl             | Shared        | Exclusive      |
++------------------------------+---------------+----------------+
+| mailbox_open_irl             | Shared        | Shared         |
++------------------------------+---------------+----------------+
+| mailbox_open_exclusive       | Exclusive     | Exclusive      |
++------------------------------+---------------+----------------+
+
+It should never be necessary to call "mailbox_open_exclusive", but
+it's included for completeness. Use "mailbox_open_iwl" if you expect
+to need to write to the index (or even if you're not sure) and
+"mailbox_open_irl" when you know you're only reading from the file and
+wish to allow other readers to work concurrently.
+
+Many actions are delayed until the mailbox is closed, or even until
+the *last* mailbox is closed for things that require an exclusive
+namelock to perform like deletion or repack. See below under "delayed
+actions" for more detail.
+
+To avoid opening the same file multiple times, the mailbox API
+refcounts open mailboxes. If you open the same mailbox again (i.e. a
+URL fetch or status command on the currently select mailbox) then the
+same mailbox will be returned. It must be unlocked (see below or the
+open command will return IMAP_MAILBOX_LOCKED). The matching close will
+reduce the refcount, and only the final close will do the cleanup
+actions.
+
+
+Locking and unlocking
+=====================
+
+You can keep a mailbox "open", maintaining the namelock, while
+releasing the index lock to allow other processes to make changes to
+the mailbox. By holding the namelock, you know that record numbers
+won't change, and the underlying message files won't be deleted.
+
+"mailbox_close" will call "mailbox_unlock_index" if the index is still
+locked, so it is not necessary to explicitly unlock the index before
+closing.
+
+   r = mailbox_unlock_index(mailbox, NULL);
+
+   // sleep on user input...
+
+   r = mailbox_lock_index(mailbox, LOCK_SHARED);
+   // or
+   r = mailbox_lock_index(mailbox, LOCK_EXCLUSIVE);
+
+For example, "mailbox_unlock_index" and "mailbox_lock_index" are used
+extensively by the index module, allowing an imap client to maintain a
+long lived connection selected to a mailbox and know that messages
+won't magically disappear from under it - yet at the same time allow
+new mail delivery to happen or other imap connections to query the
+mailbox.
+
+If you have built an accurate statuscache item for the locked mailbox,
+you can pass this as the second parameter to mailbox_index_unlock. If
+there have been any changes, mailbox_index_unlock will invalidated the
+statuscache. If you give it the new value, then it will store that
+value instead. For example:
+
+   struct statusdata sdata;
+   index_status(state, &sdata);
+   /* RECENT is zero for everyone else because we wrote a new
+    * recentuid! */
+   sdata.recent = 0;
+   mailbox_unlock_index(state->mailbox, &sdata);
+
+See "delayed actions" below for delayed actions performed during an
+unlock.
+
+
+Creating, renaming and deleting
+===============================
+
+**WARNING:** These functions only change the mailbox files on disk.
+They don't update the mailboxes.db records or contact murder servers.
+In most cases you are probably looking for the "mboxlist_" functions
+instead.
+
+Creating a mailbox is somewhat longwinded - as there are many optional
+parameters.
+
+   int mailbox_create(const char *name, const char *part, const char *acl,
+                      const char *uniqueid, int options, unsigned uidvalidity,
+                      struct mailbox **mailboxptr);
+
+Most interesting to note is that on success, "mailboxptr" will contain
+the same mailbox that "mailbox_open_exclusive" above would have
+returned, with an exclusive namelock and an exclusive index lock. This
+allows you to perform other consistency operations after creating the
+mailbox with a full guarantee that no other process will even be able
+to know of the mailbox's existence! You can still roll-back by
+deleting the mailbox and the next process will get the namelock and
+see no mailbox with that name.
+
+   int mailbox_rename_copy(struct mailbox *oldmailbox,
+                           const char *newname, const char *newpart,
+                           const char *userid, int ignorequota,
+                           int silent,
+                           struct mailbox **newmailboxptr);
+
+Very similar to mailbox_create - the new mailbox is created with an
+exclusive name lock and returned. The old mailbox must be passed in
+with an **exclusive index lock** but is fine with a shared namelock,
+as it will be passed to "mailbox_delete".
+
+   int mailbox_delete(struct mailbox **mailboxptr);
+
+Just like "mailbox_close" above, this closes the mailbox. Before it
+does so, it sets the OPT_MAILBOX_DELETED option flag in the index
+header. The interesting work is actually done in "mailbox_close". See
+below under "delayed actions".
+
+"mailbox_delete" requires an exclusive index lock, but can complete
+quite happily with only a shared namelock.
+
+
+Reading and writing records
+===========================
+
+Ok - so you have a mailbox, it's opened, and the index is locked. Time
+to start reading and writing some records!
+
+At the mailbox level there is no concept of "message numbers" from
+imap, only "record numbers". The canonical variable name to refer to
+record numbers is "recno". All records are read and written using
+"struct index_record" values.
+
+Here at the API definitions used for reading and writing:
+
+   int mailbox_read_index_record(struct mailbox *mailbox,
+                                 uint32_t recno,
+                                 struct index_record *record);
+   int mailbox_rewrite_index_record(struct mailbox *mailbox,
+                                    struct index_record *record);
+   int mailbox_append_index_record(struct mailbox *mailbox,
+                                   struct index_record *record);
+   int mailbox_commit(mailbox);
+
+An example of iterating through a mailbox
+
+   uint32_t recno;
+   struct index_record record;
+   int make_changes;
+
+   /* DEPRECATED */
+   for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+       if (mailbox_read_index_record(mailbox, recno, &record))
+           fatal("invalid record", EX_SOFTWARE); // or return an error
+       if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+           continue; // skip expunged records
+       make_changes = do_stuff(mailbox, &record);
+       if (make_changes)
+           mailbox_rewrite_index_record(mailbox, &record);
+   }
+
+   /* the new way */
+   int make_change;
+   const struct index_record *record;
+   struct mailbox_iter *iter;
+
+   iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+   while ((record = mailbox_iter_step(iter))) {
+       make_changes = do_stuff(mailbox, record);
+       if (make_changes)
+           mailbox_rewrite_index_record(mailbox, record);
+   }
+   mailbox_iter_done(&iter);
+
+NOTE: "mailbox_rewrite_index_record" doesn't need a recno, as that's
+cached inside the index_record struct.
+
+NOTE: You need an exclusively locked index to use rewrite or append,
+but only a shared index lock to use read.
+
+There are a range of consistency checks done to ensure that a rewrite
+doesn't violate IMAP semantics (an expunged message can never be
+unexpunged, UIDs can't change, etc) and the internal tracking counts
+and quota data are updated as well. They will be committed at unlock
+time, see "delayed actions"
+
+If you don't set the "record.silent" field to a true value before
+rewriting or appending, the "record.modseq" and "record.last_updated"
+values will be changed. This allows condstore to work correctly.
+
+
+Appending
+---------
+
+To append a record, the file must have already been copied into place
+(XXX - plan to move to a stage based system where the mailbox API
+handles the staging, but that's not finished yet) and been parsed into
+the record struct. The UID must be set already, and must be greater
+than the UID of any existing record in the mailbox. There are a range
+of consistency checks done.
+
+The internal consistency counts are updated by append as well.
+
+
+Committing
+----------
+
+When you have finished making any changes, you need to "commit". This
+will write the updated values for any index header fields, rewite the
+"cyrus.header" file if needed and fsync all changes to disk.
+
+It is a fatal error to unlock (or close) a mailbox that has had
+changes without committing, as it can leave the mailbox in a corrupted
+state.
+
+
+Cache records
+-------------
+
+Cache records are accessed through "record.crec" which is not filled
+by read_index_record. The cache file is only read and mapped into
+memory as needed, so you if you want to access cache records, the
+basic API is as follows:
+
+   int mailbox_cacherecord(struct mailbox *mailbox,
+                           struct index_record *record);
+   const char *cacheitem_base(struct index_record *record, int field);
+   unsigned cacheitem_size(struct index_record *record, int field);
+   struct buf *cacheitem_buf(struct index_record *record, int field);
+
+You must always call "mailbox_cacherecord" on a record before trying
+to access any of the cache items. ""field"" above is the individual
+field (there are 10) in the cache record. There's more information on
+those fields in the mailbox internal format documentation.
+
+   for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+       if (mailbox_read_index_record(mailbox, recno, &record))
+           fatal("invalid record", EX_SOFTWARE); // or return an error
+       if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+           continue; // skip expunged records
+       if (mailbox_cacherecord(mailbox, &record))
+           fatal("failed to read cache", EX_SOFTWARE);
+       ...
+       envelope_length = cacheitem_size(&record, CACHE_ENVELOPE);
+   }
+
+See "imap/mailbox.h" for the full list of constants.
+
+
+Delayed Actions
+===============
+
+Here's the bit you've been waiting for! What happens during unlock and
+close
+
+
+first, unlock
+-------------
+
+Anything that makes any changes sets the mailbox->has_changed flag. If
+this is set, then before the index gets unlocked:
+
+* the updatenotifier (idle) is called
+
+* "sync_log_mailbox" (replication) gets called
+
+* the statuscache value gets erased (or replaced if you passed in an
+  updated value).
+
+
+then: close
+-----------
+
+next the index is unlocked (see above)
+
+third, any "unlink" commands scheduled for email files are run. These
+can't be done until after the mailbox_commit to ensure consistency -
+the file isn't deleted until the record is written as unlinked! But we
+save the unlink until now so that other tasks aren't waiting for the
+index lock while the unlinks run. Unlink is expensive in IO and time.
+
+finally we check for MAILBOX_NEEDS_REPACK or MAILBOX_DELETED option
+flags. If either is sets, then we make a non-blocking attempt to get
+an exclusive namelock. If the non-blocking attempt fails, then another
+process has the mailbox open, so save the cleanup for them! If it
+succeeds, then go ahead with either "mailbox_delete_cleanup" or
+"mailbox_index_repack" as appropriate.
+
+After this it's just a matter of releasing malloc'd memory and finally
+releasing the name lock.
diff -pruN 3.0.13-5/doc/text/imap/developer/API.txt 3.2.0-3/doc/text/imap/developer/API.txt
--- 3.0.13-5/doc/text/imap/developer/API.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/API.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,11 @@
+
+Developer APIs
+**************
+
+* CyrusDB API
+
+* cyrusdb API
+
+* Index API
+
+* Mailbox API
diff -pruN 3.0.13-5/doc/text/imap/developer/compiling.txt 3.2.0-3/doc/text/imap/developer/compiling.txt
--- 3.0.13-5/doc/text/imap/developer/compiling.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/compiling.txt	2020-05-04 04:13:53.000000000 +0000
@@ -109,6 +109,9 @@ Developers only
 |                      |                 |                 |       | interpreter, found by "which":  "./configure  |
 |                      |                 |                 |       | --with- perl" is not honoured.                |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
+| python(GitPython)    |                 |                 |       | Python library needed for building the        |
+|                      |                 |                 |       | documentation                                 |
++----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | python(Sphinx)       |                 |                 |       | Python library needed for building the        |
 |                      |                 |                 |       | documentation                                 |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
@@ -158,20 +161,6 @@ Alternate database formats
 |                      |                 |                 | chec  |                                               |
 |                      |                 |                 | k"?   |                                               |
 +======================+=================+=================+=======+===============================================+
-| lmdb                 | lmdb-dev        | lmdb            | no    | Lightning Memory-Mapped Database Manager      |
-|                      |                 |                 |       | (LMDB) backend for Cyrus IMAP databases.      |
-|                      |                 |                 |       | LMDB requires database environments to be set |
-|                      |                 |                 |       | to a (user-configurable) maximum size. The    |
-|                      |                 |                 |       | Cyrus backend uses 512MB as default size.     |
-|                      |                 |                 |       | Cyrus installations may override this by      |
-|                      |                 |                 |       | setting the environment variable              |
-|                      |                 |                 |       | CYRUSDB_LMDB_MAXSIZE. The value of this       |
-|                      |                 |                 |       | variable must be an integer, optionally       |
-|                      |                 |                 |       | followed (without space) by 'mb' or 'gb' to   |
-|                      |                 |                 |       | define the maximum size in bytes, megabytes   |
-|                      |                 |                 |       | or gigabytes. The size should be a multiple   |
-|                      |                 |                 |       | of the OS page size.                          |
-+----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | mysql or mariadb     | libmysqlclient- | mysql-devel or  | no    | MariaDB or MySQL development headers, to      |
 |                      | dev or          | mariadb-devel   |       | allow Cyrus IMAP to use it as the backend for |
 |                      | libmariadb-dev  |                 |       | its databases.  Configure option: "--with-    |
@@ -183,8 +172,8 @@ Alternate database formats
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 
 
-CalDAV and/or CardDAV
-~~~~~~~~~~~~~~~~~~~~~
+CalDAV, CardDAV, or JMAP
+~~~~~~~~~~~~~~~~~~~~~~~~
 
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | Package              | Debian          | RedHat          | Requ  | Notes                                         |
@@ -194,14 +183,14 @@ CalDAV and/or CardDAV
 |                      |                 |                 | chec  |                                               |
 |                      |                 |                 | k"?   |                                               |
 +======================+=================+=================+=======+===============================================+
-| libical              | libical-dev     | libical-devel   | no    | libical >= 0.48 required for scheduling       |
-|                      |                 |                 |       | support. **Note:** Linux distributions        |
-|                      |                 |                 |       | Enterprise Linux 6 and Debian Squeeze are     |
-|                      |                 |                 |       | known to ship outdated **libical** packages   |
-|                      |                 |                 |       | versions 0.43 and 0.44 respectively. The      |
-|                      |                 |                 |       | platforms will not support scheduling.        |
+| libchardet           | libchardet-dev  | libchardet-     | no    |                                               |
+|                      |                 | devel           |       |                                               |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
-| libxml               | libxml2-dev     | libxml2-devel   |       | no                                            |
+| libical              | libical-dev     | libical-devel   | no    | version 3.0.0 or higher                       |
++----------------------+-----------------+-----------------+-------+-----------------------------------------------+
+| libxml               | libxml2-dev     | libxml2-devel   | no    |                                               |
++----------------------+-----------------+-----------------+-------+-----------------------------------------------+
+| shapelib             | shapelib        |                 | no    | version 1.3.0 or higher                       |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 
 
@@ -238,10 +227,15 @@ Other
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | perl(Term::ReadLine) |                 |                 |       | Perl library needed by cyradm                 |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
+| libsrs2              |                 |                 |       | Sender Rewriting Scheme for lmtp, used on     |
+|                      |                 |                 |       | Sieve redirect                                |
++----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | zlib                 | zlib1g-dev      | zlib-devel      | no    | Compression support for httpd                 |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | libbrotli            |                 |                 |       | Brotli compression support for httpd          |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
+| wslay                |                 |                 |       | WebSockets support in httpd                   |
++----------------------+-----------------+-----------------+-------+-----------------------------------------------+
 | nghttp2              | libnghttp2-dev  | libnghttp2-dev  | no    | HTTP/2 support for httpd                      |
 |                      |                 | el              |       |                                               |
 +----------------------+-----------------+-----------------+-------+-----------------------------------------------+
@@ -259,7 +253,7 @@ Compile Cyrus
 =============
 
 There are additional compile and installation steps if you are using
-Xapian for searching.
+Xapian for searching, or if you are using jmap.
 
 
 Default build: mail only
@@ -291,10 +285,10 @@ via configure.
 Sieve is enabled by default.
 
 
-CalDAV and CardDAV
-~~~~~~~~~~~~~~~~~~
+CalDAV, CardDAV, JMAP
+~~~~~~~~~~~~~~~~~~~~~
 
-   "./configure --enable-http --enable-calalarmd"
+   "./configure --enable-http --enable-calalarmd --enable-jmap"
 
 
 Murder
diff -pruN 3.0.13-5/doc/text/imap/developer/cyrusworks.txt 3.2.0-3/doc/text/imap/developer/cyrusworks.txt
--- 3.0.13-5/doc/text/imap/developer/cyrusworks.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/cyrusworks.txt	2020-05-04 04:13:53.000000000 +0000
@@ -6,26 +6,12 @@ Cyrus Works
 About Cyrus Works
 =================
 
-Whenever the Cyrus team push changes to the project repository, a
-notification is sent to Jenkins (open source automation server). Our
-Jenkins server is called Cyrus Works and can be found at
-https://www.cyrus.works.
+Cyrus Works is a domain redirection to the Cyrus IMAP project's Travis
+CI dashboard.
 
-
-Testing
-=======
-
-Once a week Cyrus.Works builds a complete image, fetching all upstream
-packages.
-
-Interim builds during the week use the cached weekly image and apply
-the latest Cyrus IMAP code changes from Git.
-
-Email notifications of build results are sent to the development team.
-
-Cyrus.works will fail is certain strings are found in the log files.
-To view results and filter errors/warnings view:
-https://cyrus.works/job/master-jessie/lastFailedBuild/parsed_console/
+Whenever the Cyrus team push changes to the project repository, Travis
+CI (via github integration) automatically builds the new commits.
+This also applies to pull requests submitted through the GitHub site.
 
 
 How it works
@@ -34,29 +20,3 @@ How it works
 Cassandane, the Cyrus IMAP test framework gets pulled in to the Docker
 Container, confirms existing functionality still works and no
 regression bugs have been introduced.
-
-You can find out more about Cyrus.Works in the FastMail 2016 advent
-series blog post.
-
-The code used to build Cyrus.works is available
-https://github.com/cyrusimap/cyrusworks.
-
-
-Adding Rules
-============
-
-Instructions on how to add rules:
-https://wiki.jenkins.io/display/JENKINS/Log+Parser+Plugin
-
-The rules for Cyrus Works are stored within git: https://github.com/c
-yrusimap/cyrusworks/blob/master/Scripts/cyrusworksrules
-
-You need to add rules to two places:
-
-1. **Git**: so when cyrus.works is reinstalled those rules are not
-   lost
-
-2. **The server**: so they’re actually used. Changed pushed to git
-aren’t pushed to the server. This is for security reasons (we don’t
-want anyone on the internet to be able to push changes to a live
-server). "root@cyrus.works:/cyrusworks/source/Scripts/cyrusworksrules"
diff -pruN 3.0.13-5/doc/text/imap/developer/developer-testing.txt 3.2.0-3/doc/text/imap/developer/developer-testing.txt
--- 3.0.13-5/doc/text/imap/developer/developer-testing.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/developer-testing.txt	2020-05-04 04:13:53.000000000 +0000
@@ -51,6 +51,7 @@ Install and configure Cassandane
       sudo cpan -i Net::DAVTalk
       sudo cpan -i Net::CardDAVTalk
       sudo cpan -i Net::CalDAVTalk
+      sudo cpan -i Mail::JMAPTalk
       sudo cpan -i Math::Int64
 
 3. Install Cassandane
diff -pruN 3.0.13-5/doc/text/imap/developer/developer-tips.txt 3.2.0-3/doc/text/imap/developer/developer-tips.txt
--- 3.0.13-5/doc/text/imap/developer/developer-tips.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/developer-tips.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,134 +0,0 @@
-
-Tips for Hacking on Cyrus
-*************************
-
-
-Memory Allocation
-=================
-
-All Cyrus memory allocation should be done through the "libcyrus"
-functions. These are all written to correctly call fatal() in the
-event of an out-of-memory condition.
-
-In addition to xmalloc and xrealloc, we provide replacements for
-strdup, strndup, and a malloc that will guarantee zeroed block of
-memory (xzmalloc).
-
-If you are going to need to do a large number of small allocations,
-and then free them all at once, you should look at the memory pool
-routines, which are much faster, but will leak memory until you free
-the entire pool at once.
-
-
-strlcpy vs strncpy vs memcpy
-============================
-
-Use strlcpy when the size of the buffer is known, e.g.:
-
-   char buf[50];
-   strlcpy(buf, src, sizeof(buf));
-
-Use memcpy to truncate a string into a buffer you know is large
-enough. Note that the resulting buffer will NOT BE NULL TERMINATED.
-
-   memcpy(buf, src, 4);
-   buf[5] = '\0'
-
-Try to avoid strncpy, since it is much slower than memcpy (it zero-
-fills the rest of the buffer) and isn't as safe as strlcpy.
-
-Use of the functions in this way will reduce the confusion involved in
-their various behaviours. This avoids things that look like:
-
-   strncpy(buf, src, sizeof(buf)-1);
-   buf[sizeof(buf)-1] = '\0';
-
-
-map_refresh and map_free
-========================
-
-In many cases, it is far more effective to read a file via the
-operating system's mmap facility than it is to via the traditional
-read() and lseek system calls. To this end, Cyrus provides an
-operating system independent wrapper around the mmap() services (or
-lack thereof) of the operating system.
-
-Cyrus currently only supports read-only memory maps, all writes back
-to a file need to be done via the more traditional facilities. This is
-to enable very low-performance support for operating systems which do
-not provide an mmap() facility via a fake userspace mmap.
-
-To create a map, simply call map_refresh on the map (details are in
-lib/map.h). To free it, call map_free on the same map.
-
-Despite the fact that the maps are read-only, it is often useful to
-open the file descriptors O_RDWR, especially if the file decriptors
-could possibly be used for writing elsewhere in the code. Some
-operating systems REQUIRE file descriptors that are mmap()ed to be
-opened O_RDWR, so just do it.
-
-
-Network Functionality
-=====================
-
-Read about Cyrus IMAP Prot Layer.
-
-
-Authorization modules
-=====================
-
-**TO DO:**
-
-   Describe what the authorization modules do, what API needs to be
-   implemented, etc. Also possibly discuss the auth_pts module.
-
-
-Other
-=====
-
-* Command line apps should link cli_fatal.o so they all fatal() in
-  the same way, unless there is a really good reason they need to do
-  something unique.
-
-* If you call config_init() you must call cyrus_done() before you
-  exit.
-
-     No one should ever call DB->init() or DB->done() cyrusdb
-     functions except for in libcyrus_init()
-
-* Try to keep #include statements for libcyrus and libimap
-  alphabetical, and below any system includes.
-
-* Don't exit at the bottom of main with exit(x) use return instead.
-
-     For all the command line utilities that need to be sure that they
-     are running as cyrus, it should be the first thing they do, and
-     they should exit with an appropriate fatal() call
-
-* All services should have a shut_down call. It should be the ONLY
-  way of exiting the application (every "clean" exit from the system
-  should be via shut_down()). fatal() should always make an attempt to
-  call shut_down() if it can (though it should have a recursive
-  fatal() trap just in case). Similarly, commandline utilities
-  probably don't need a shut_down().
-
-
-File Locking
-============
-
-In order to guard against deadlocks, we want to maintain the same
-order of acquiring locks throughout the system (this may be violated
-in one or two places, but when it is it is commented as to why it is
-safe). As long as everyone plays by these rules, we can avoid
-deadlock.
-
-In an ideal world, our locking order is:
-
-   cyrus.header
-   cyrus.index
-   quota
-   seen
-   mailboxes file
-
-These try to go from least general to most general, so we hold the
-largest locks for the shortest period of time.
diff -pruN 3.0.13-5/doc/text/imap/developer/documentation.txt 3.2.0-3/doc/text/imap/developer/documentation.txt
--- 3.0.13-5/doc/text/imap/developer/documentation.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/documentation.txt	2020-05-04 04:13:53.000000000 +0000
@@ -162,7 +162,7 @@ number defined in conf.py.
 
 Usage: "|imap_current_stable_version|"
 
-Produces 3.0.13.
+Produces 3.2.0.
 
 
 Conventions: Man Pages
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/hacking.txt 3.2.0-3/doc/text/imap/developer/guidance/hacking.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/hacking.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/hacking.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,376 @@
+
+Cyrus IMAP Server: Hacking
+**************************
+
+This file aims to be a guide to Cyrus coding style/conventions/useful
+utilities for people trying to approach the code in a sane way.  It's
+not well organized right now but hopefully that will improve with time
+;)
+
+
+Memory Allocation
+=================
+
+* All cyrus memory allocation should be done through the libcyrus
+  functions.  These are all written to correctly call "fatal()" in the
+  event of an out-of-memory condition.
+
+* In addition to "xmalloc" and "xrealloc", we provide replacements
+  for "strdup", "strndup", and a "malloc" that will guarantee zeroed
+  block of memory ("xzmalloc").
+
+* If you are going to need to do a large number of small
+  allocations, and then free them all at once, you should look at the
+  memory pool routines, which are much faster, but will leak memory
+  until you free the entire pool at once.
+
+
+strlcpy vs strncpy vs memcpy
+============================
+
+* use "strlcpy" when you know the size of the buffer, e.g.:
+
+   char buf[50];
+   strlcpy(buf, src, sizeof(buf));
+
+* use "memcpy" to truncate a string into a buffer you know is large
+  enough. Note that when you do this the resulting buffer will NOT BE
+  NULL TERMINATED:
+
+   memcpy(buf, src, 4);
+   buf[5] = '\0'
+
+* you should try to avoid "strncpy", since it is much slower than
+  "memcpy" (it zero-fills the rest of the buffer) and isn't as safe as
+  "strlcpy".
+
+* Use of the functions in this way will reduce the confusion
+  involved in their various behaviors. In other words, this avoids
+  things that look like:
+
+   strncpy(buf, src, sizeof(buf)-1);
+
+
+map_refresh and map_free
+========================
+
+* In many cases, it is far more effective to read a file via the
+  operating system's mmap facility than it is to via the traditional
+  "read()" and "lseek" system calls.  To this end, Cyrus provides an
+  operating system independent wrapper around the "mmap()" services
+  (or lack thereof) of the operating system.
+
+* Cyrus currently only supports read-only memory maps, all writes
+  back to a file need to be done via the more traditional facilities.
+  This is to enable very low-performance support for operating systems
+  which do not provide an "mmap()" facility via a fake userspace
+  "mmap".
+
+* To create a map, simply call "map_refresh" on the map (details are
+  in lib/map.h).  To free it, call "map_free" on the same map.
+
+* Despite the fact that the maps are read-only, it is often useful
+  to open the file descriptors O_RDWR, especially if the file
+  descriptors could possibly be used for writing elsewhere in the
+  code. Some operating systems REQUIRE file descriptors that are
+  "mmap()"-ed to be opened O_RDWR, so just do it.
+
+
+Network Functions
+=================
+
+* Cyrus abstracts socket stream access to a concept we refer to as
+  "prot streams"  Prot Streams take care of all of the necessary SASL
+  and TLS/SSL encryption that may need to happen before data goes
+  out/comes in from the network.  The API is documented in lib/prot.h
+
+
+(todo) Authorization Modules
+============================
+
+
+General Hints
+=============
+
+Some general hints that all made it into my 11/15 16:47 commit that I
+think may be generally useful to people hacking on the cyrus source:
+
+* Command line apps should link cli_fatal.o so they all fatal() in
+  the same way, unless there is a really good reason they need to do
+  something unique.
+
+* If you call "cyrus_init()" you must call "cyrus_done()" before you
+  exit.
+
+* No one should ever call "DB->init()" or "DB->done()" cyrusdb
+  functions except for in "libcyrus_init()".
+
+* I've been trying to keep "#include" statements for libcyrus and
+  libimap alphabetical, and below any system includes, but this is
+  merely my personal style
+
+* Don't exit at the bottom of "main" with "exit(x)" use "return"
+  instead.
+
+* For all the command line utilities that need to be sure that they
+  are running as the cyrus user, it should be the first thing they do,
+  and they should exit with an appropriate "fatal()" call.
+
+* All services should have a "shut_down" call.  It should be the
+  ONLY way of exiting the application.  "fatal()" should always make
+  an attempt to call "shut_down()" if it can (though it should have a
+  recursive "fatal()" trap just in case).  Similarly, command line
+  utilities probably don't need a "shut_down()".
+
+
+Coding Standards
+================
+
+These are the generally agreed upon coding standards as thrashed out
+on the cyrus-devel list in June 2010.
+
+* Spacing is 4 characters with soft tabs at 8 - mixed tabs and
+  spaces This corresponds to the vi settings *sw=4 sts=4 ts=8* etc.
+
+* Group the '*' character with the variable not the type, i.e.
+
+   char *foo;  /* correct */
+   char* foo;  /* WRONG */
+
+* The keywords 'if', 'for', and 'while' take a space after the
+  keyword. The parentheses around the following expression are not
+  closely connected to the expression without any spaces.  The ';'
+  inside the 'for' expression have a space after them and not before.
+  For example:
+
+   if (condition)              /* correct */
+   if(condition)               /* WRONG */
+   if( condition )             /* WRONG */
+
+   for (i = 0; i < x; i++)     /* correct */
+   for(i = 0; i < x; i++)      /* WRONG */
+   for (i = 0 ;i < x ;i++)     /* WRONG */
+   for(i = 0 ;i < x ;i++)      /* WRONG */
+
+   while (foo)                 /* correct */
+   while(foo)                  /* WRONG */
+   while( foo )                /* WRONG */
+
+* Use spaces around the double-character logical operator '||' but
+  don't use spaces around single-character bitwise operator '|'.
+
+   int flags = FOO|BAR;        /* correct */
+   int flags = FOO | BAR;      /* WRONG */
+   if (itchy || scratchy)      /* correct */
+   if (itchy||scratchy)        /* WRONG */
+
+* Function definitions are followed by a brace on a line by itself,
+  all other braces are inline.  Return types are inline with function
+  definition.  Old K&R style function definitions are not allowed.
+
+   void thing(int val)         /* correct */
+   {                           /* correct */
+       ...body...
+   }                           /* correct */
+
+   void                        /* WRONG */
+   thing(int val)              /* WRONG */
+   {                           /* WRONG */
+       ...body...
+   }                           /* WRONG */
+
+   void                        /* WRONG */
+   thing(                      /* WRONG */
+       int val)                /* WRONG */
+   {                           /* WRONG */
+       ...body...
+   }                           /* WRONG */
+
+   void                        /* WRONG */
+   antique(val)                /* WRONG */
+       int val;                /* WRONG */
+   {                           /* WRONG */
+       ...body...
+   }                           /* WRONG */
+
+   void thing(int val) {       /* WRONG */
+       ...body...
+   }                           /* WRONG */
+
+   void noargs(void)           /* correct */
+   {                           /* correct */
+       ...body...
+   }                           /* correct */
+
+   void noargs()               /* WRONG */
+   {                           /* WRONG */
+       ...body...
+   }                           /* WRONG */
+
+* Long argument lists should be split across multiple lines, with
+  the second and subsequent lines indented so that they line up with
+  the start of the first line of arguments.
+
+   void toomanyargs(int arg1, const char *arg2,        /* correct */
+                    struct whatever *arg3, int arg4)   /* correct */
+   {                                                   /* correct */
+       ...body...
+   }                                                   /* correct */
+
+   void toomanyargs(int arg1, const char *arg2,        /* WRONG */
+   struct whatever *arg3, int arg4)                    /* WRONG */
+   {                                                   /* WRONG */
+       ...body...
+   }                                                   /* WRONG */
+
+   void toomanyargs(                                   /* WRONG */
+       int arg1,                                       /* WRONG */
+       const char *arg2,                               /* WRONG */
+       struct whatever *arg3,                          /* WRONG */
+       int arg4)                                       /* WRONG */
+   {                                                   /* WRONG */
+       ...body...
+   }                                                   /* WRONG */
+
+* Within a function, braces are used in old-fashioned K&R style.
+  Specifically:
+
+  * open braces are placed at the end of the line containing the
+    statement (such as an 'if') to which they belong, after a single
+    space.
+
+  * closing braces are placed on a line by themselves, aligned with
+    the start of the statement to which their matching open brace
+    belongs.
+
+  * this applies even when the closing brace is followed by an
+    'else' keyword.
+
+   Yes, it's ugly and hard to read, but you get used to it and most of
+   the code is currently like that.  Deal with it.
+
+   while (cond) {              /* correct */
+       ...body...              /* correct */
+   }                           /* correct */
+
+   while (cond){               /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+
+   while (cond) { ...body... } /* WRONG */
+
+   while (cond) {              /* WRONG */
+       ...body... }            /* WRONG */
+
+   while (cond)                /* WRONG */
+   {                           /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+
+   while (cond)                /* WRONG */
+     {                         /* WRONG */
+       ...body...              /* WRONG */
+     }                         /* WRONG */
+
+   if (cond) {                 /* correct */
+       ...body...              /* correct */
+   }                           /* correct */
+   else if (othercond) {       /* correct */
+       ...body...              /* correct */
+   }                           /* correct */
+   else {                      /* correct */
+       ...body...              /* correct */
+   }                           /* correct */
+
+   if (cond) {                 /* WRONG */
+       ...body...              /* WRONG */
+   } else if (othercond) {     /* WRONG */
+       ...body...              /* WRONG */
+   } else {                    /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+
+   if (cond)                   /* WRONG */
+   {                           /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+   else if (othercond)         /* WRONG */
+   {                           /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+   else                        /* WRONG */
+   {                           /* WRONG */
+       ...body...              /* WRONG */
+   }                           /* WRONG */
+
+* The braces around a block used in an 'if'...'else if'...'else' may
+  be omitted if the statement is very simple and clear, such as a
+  single function call.  This is a judgement call though, so play it
+  safe and use braces.
+
+   if (cond)                   /* correct, maybe */
+       function();             /* correct, maybe */
+   else                        /* correct, maybe */
+       other_function();       /* correct, maybe */
+
+* The 'goto' keyword needs to be used very very sparingly and only
+  with forethought.  The only clearly good example is to goto a label
+  at the end of a function to do cleanup under error conditions.
+
+   void foo(struct bar *b)     /* correct */
+   {                           /* correct */
+       char *x = xmalloc(...); /* correct */
+
+       if (b == NULL)          /* correct */
+           goto error;         /* correct */
+
+       if (b->quux != 42)      /* correct */
+           goto error;         /* correct */
+
+       ...do useful things...  /* correct */
+   error:                      /* correct */
+       free(x);                /* correct */
+   }                           /* correct */
+
+   Very occasionally, it may be permissable to use 'goto' from within
+   a complicated or multiply-nested loop, to the top of a loop, but
+   only if using another control structure is *less* clear.
+
+* Generally, zero return is SUCCESS and integer return is an error
+  code.
+
+* Use ""const char *"" where possible.
+
+   int is_tacky(const char *name)              /* correct */
+   {                                           /* correct */
+       return !strcmp(name, "britney");        /* correct */
+   }                                           /* correct */
+
+   int is_tacky(char *name)                    /* WRONG */
+   {                                           /* WRONG */
+       return !strcmp(name, "britney");        /* WRONG */
+   }                                           /* WRONG */
+
+* Use ""struct buf"" for variable length strings where possible.
+
+* RAII
+  http://en.wikipedia.org/wiki/Resource_Acquisition_Is_Initialization
+  In practice, this means each structure should have a single cleanup
+  function which handles all possible states of the structure and is
+  called whenever the structure needs cleaning up.  Likewise, any
+  resources allocated during a function should be cleaned up in the
+  same function, in a single code block at the end of the function
+  (see the comments on 'goto').
+
+* If you find yourself passing the same multiple parameters through
+  many functions, create a struct and pass around a pointer to that
+  instead.
+
+* DON'T EVER REUSE THE SAME VARIABLE FOR TWO DIFFERENT PURPOSES IN
+  THE SAME FUNCTION.  IN FACT, DON'T REUSE THE SAME VARIABLE _NAME_
+  FOR DIFFERENT PURPOSES.  KTHXBYE.  (note: this doesn't apply to 'i',
+  'n', etc which are used in multiple loops.  It applies to using the
+  same name for an absolute offset and a "within this mmap" offset
+  though, and it also applies to using the same variable name for
+  native order and network order numbers, which is where I've seen it
+  a few times and been super frustrated!)
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/internationalization.txt 3.2.0-3/doc/text/imap/developer/guidance/internationalization.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/internationalization.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/internationalization.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,450 @@
+
+Cyrus IMAP Server: Internationalization
+***************************************
+
+
+introduction
+============
+
+Cyrus currently transcodes characters to a canonical UTF-8 form for
+searching. The base spec of IMAP4 only requires understanding multiple
+character sets to properly implement SEARCH. Since the base spec came
+out, several extensions have been proposed that require further
+charset support: SORT, THREAD, and the Sieve subsystem. As of this
+writing, Cyrus doesn't correctly support these other commands.
+
+Cyrus currently only believes in 16-bit characters. Technically,
+Unicode has up to 21-bit characters (expressible in UTF-16 and 3-byte
+UTF-8) and ISO 10646 allows up to 31-bit characters (though ISO's
+current policy is to not allocate any characters outside of the 21-bit
+Unicode range). The lower 16-bit characters make up the basic
+multilingual plane (BMP) where the majority of languages live. This
+restriction is apparent in "charset.c:writeutf8()", the UTF-8
+decoders, and the Unicode canonicalization table used by Cyrus. Since
+Cyrus's known character sets (except for UTF-8) don't contain any
+characters off of the BMP this isn't seen to be a major problem.
+
+Throughout this text, Unicode and ISO 10646 will be used
+interchangeable to refer to the 16-bit character set of the BMP,
+regardless of encoding. "Character", unless otherwise specified,
+refers to a single Unicode character "ffff" or under.
+
+
+cyrus canonical form
+====================
+
+Since when users search e-mail messages it's much easier for them to
+eliminate false positives than realize there are hits that aren't
+displayed, the Cyrus searching algorithm errs on the side of more
+matches. Before comparing any two strings, Cyrus puts them in a
+canonical form. Logically, the process works as follows:
+
+* the input string is translated into a sequence of Unicode
+  characters.
+
+* each character is transformed into lowercase. (For some
+  characters, a single uppercase character may transform into multiple
+  lowercase characters.)
+
+* each character is fully decomposed.
+
+* all whitespace (Unicode general categories starting with "Z") is
+  removed.
+
+* combining diacritical marks, such as the accent on é, are removed.
+  (These are Unicode characters "0300"-"03ff".)
+
+* certain characters are expanded to alternative spellings using
+  ASCII characters, such as "æ" to "ae".
+
+* the output characters are then encoded in UTF-8.
+
+The actual transcoding does all of these steps at once with the aid of
+tables, carefully built at compile-time.
+
+The central part of Cyrus's internationalization support is it's
+transcoding routines in "lib/charset.[ch]", and "lib/chartable.[ch]".
+Cyrus's transcoding routines are very elegant and very compact, thus
+somewhat intimidating. During compilation, Cyrus builds up a large
+number of tables (see mkchartable) and uses them so that it never has
+to consider more than a single octet at a time while outputting the
+Cyrus canonical form for an input string.
+
+
+external interface
+==================
+
+"lib/charset.h" is the public interface for Cyrus lib clients to get
+character canonicalization and searching support. In contains the
+following functions:
+
+"char *charset_convert(const char *s, int charset, char *buf, int
+bufsz)"
+   Given a string *s* in charset *charset*, decode it into canonical
+   form in *buf*. *buf* must be reallocable and currently at least
+   size *bufsz*.
+
+"char *charset_decode_mimeheader(const char *s, char *buf, int bufsz)"
+   Given a string *s* containing possible MIME encoded substrings (per
+   RFC 2047), decode into canonical form in *buf*. *buf* must be
+   reallocable and currently at least size *bufsz*.
+
+"charset_index charset_lookupname(const char *name)"
+   Given *name* return the Cyrus charset index. 0 always represents
+   US-ASCII. The returned charset_index may be saved in a file; it is
+   stable and is an integer. If this version of Cyrus does not support
+   the charset, "CHARSET_UNKNOWN_CHARSET" is returned.
+
+"comp_pat *charset_compilepat(const char *s)"
+   Compiles a NUL-terminated canonicalized string *s* into a Boyer-
+   Moore table for fast searching. I'll describe these compiled
+   patterns later.
+
+"void charset_freepat(comp_pat *pat)"
+   Frees a pattern previously return by "charset_compilepat()".
+
+"int charset_searchstring(const char *substr, comp_pat *pat,     const
+char *s, int len)"
+   Searches for a canonicalized string *substr* in the canonicalized
+   string *s*. *s* is of length *len*. *substr* must have been
+   previously compiled into *pat*. Returns non-zero for a hit, zero
+   for no match.
+
+"int charset_searchfile(const char *substr, comp_pat *pat,
+const char *msg_base, int mapnl, int len,
+charset_index charset, int encoding)"
+   Searches for the canonicalized string *substr* with compiled
+   pattern *pat* in a large buffer starting at *msg_base* of length
+   *len*. The large buffer is of charset *charset* with the encoding
+   *encoding*. "charset_searchfile()" will dynamically unencode and
+   canonicalize the search text looking for *substr*. (If *mapnl* is
+   set, the buffer has only "\n" instead of "\r\n", but the length
+   assumes that each "\n" is dynamically converted to "\r\n". This
+   feature is deprecated.)
+
+"char *charset_decode_mimebody(const char *msg_base, int len,
+int encoding, char **buf, int *bufsz,
+int *outlen)"
+   Decode the MIME body part (per RFC 2045) located in the large
+   buffer starting at *msg_base* of length *len*. The large buffer is
+   of encoding *encoding*. "charset_decode_mimebody()" will decode
+   into *buf*. *buf* must be reallocable and currently at least size
+   *bufsz*. The number of decoded bytes is returned in *outlen*.
+
+"charset_extractfile()"
+   Used by "squatter" and possibly other text indexing engines, but
+   not described here.
+
+
+the TRANSLATE macro: using the transcoding tables
+=================================================
+
+The external interface is implemented with the help of the "START" and
+"TRANSLATE" macros:
+
+"void START(struct decode_state *state, const unsigned char
+(*table)[256][4])"
+   "START" initializes *state* to be ready for transcoding of the
+   charset translation table given with *table*. The starting active
+   table is always the first one in the list passed in.
+
+"void TRANSLATE(struct decode_state *state, unsigned char input,
+unsigned char *outbuf, unsigned outindex)"
+   "TRANSLATE" takes four parameters: *state* is the current state of
+   the translation; it must have been initialized with "START" and is
+   modified by "TRANSLATE"; *input* is one octet of input from the
+   stream to be transcoded; *outbuf* is a pointer to the start of the
+   buffer to write output characters; *outindex* is the index where
+   this translation should be written. The size of *outbuf* must be at
+   least *outindex + charset_max_translation*.
+
+Each charset consists of a set of one or more tables; the *table*
+parameter passed into "START" is the first of these tables and the
+others are adjacent in memory. Characters are transcoded by indexing
+into the active table with *input* and examining the 4 octet
+translation. The 4 octet translation may consist of 0–3 character
+translations followed by a control code or a series of control codes.
+In effect, the translation for a given octet is a mini-program that
+consists either of UTF-8 octets or control codes. One of the control
+codes RET, END, JSR, or JMP must occur in the 4 octet translation.
+
+
+control codes
+-------------
+
+Control codes are represented by uppercase US-ASCII characters since
+no uppercase characters can appear in the output translation (recall
+that Cyrus canonical form downcases). Any uppercase US-ASCII character
+("[A .. Z]") is thus interpreted specially by the "TRANSLATE" virtual
+machine. Any other octet encountered as an output translation is
+presumed to be part of the UTF-8 output sequence and copied to the
+output.
+
+The names of control codes are actually C pre-processor defines to
+uppercase US-ASCII characters. As the mnenomics are easier to
+understand, I use them in discussing their semantics.
+
+
+control code reference
+----------------------
+
+"TRANSLATE" recognizes the following "normal" control codes:
+
+XLT
+   This is the first octet of the four octet sequence, indicating that
+   the desired translation is larger than 3 UTF-8 octets. The next two
+   octets represent an offset to look up in the special
+   chartables_long_translations[] table. After that translation is
+   copied to the outbuf, the final octet is interpreted (it must be
+   either a RET or an END).
+
+JSR
+   The "TRANSLATE" virtual machine has a stack, fixed at size 1. A JSR
+   copies address of the current active table to the stack and
+   transitions to the active table given by the next two octets. (For
+   instance, table 1 would be the next table after the table given as
+   a parameter to "START".) Translation of the current octet stops
+   after encountering a JSR.
+
+   JSRs are useful for converting a two octet input character: the
+   first octet in the character will make a JSR to some table; the
+   second octet will produce a translation and RET to the current
+   table.
+
+   Since the virtual machine has a fixed size stack, it would be
+   highly unusual for the virtual machine to encounter two different
+   JSRs without an intervening RET.
+
+JMP
+   Similar to JSR, but does not change the stack. It is the equivalent
+   of a goto. JMPs are useful to deal with modal input character sets
+   (such as an escape in ISO-2022-JP, see how the tables are
+   generated).
+
+RET
+   Indicates that we are done translating this input octet and we
+   should return to the previous active table. It might appear as the
+   first of the 4 translation octets, in which case this input
+   character translates into nothing (it might be whitespace, for
+   instance).
+
+END
+   Indicates we are done translating this input octet. When
+   "TRANSLATE" is next called, that input octet will be interpreted
+   against the current active table; the stack does not change.
+
+In addition, it recognizes the following "special" control codes for
+charsets that aren't easily represented by a set of tables, UTF-8 and
+UTF-7:
+
+U7F
+   UTF-7 consists of US-ASCII characters and a special escape
+   character that indicates a transition to base-64 encoded UTF-16
+   characters. The virtual machine has built in code to handle the
+   base64 decoding. In UTF-7's base64, 8 input octets result in 3
+   characters, so the tables would be rather large.
+
+U7N
+   This indicates that the current octet is the continuation of the
+   base-64 section.
+
+U83
+   One and two character UTF-8 sequences are handled normally in the
+   charset code. To keep the table size down, 3 octet sequences are
+   handled specially. U83 indicates that the current input octet is
+   the start of a three character sequence. It is also an implicit
+   jump to the 2nd table in the UTF-8 sequence, ending this
+   translation.
+
+U83_2
+   This input octet 2nd of 3-octet UTF-8 input, with an implicit jump
+   to the 3rd table.
+
+U83_3
+   3rd octet of a 3-octet UTF-8 input. This produces the output
+   characters and has an implicit jump to the 1st table of UTF-8.
+
+Finally, it's useful to mention the special character "EMPTY" which is
+guaranteed not to match any character. It is also represented by an
+uppercase US-ASCII character.
+
+
+searching and compiled patterns
+===============================
+
+
+boyer-moore
+-----------
+
+brief description of boyer-moore xxx
+
+
+cyrus implementation
+--------------------
+
+why two arrays? us-ascii optimization, really kinda useless now xxx
+
+meta-data stored at the end xxx
+
+
+generating the tables: "mkchartable"
+====================================
+
+The program "mkchartable" is used to generate the charset transcoding
+tables used by TRANSLATE. These tables are carefully constructed so no
+more than a single octet need be examined at a time; this octet
+results in either an output stream of UTF-8 characters being generated
+or some sort of state change.
+
+"mkchartable" uses three different sorts of input files to generate
+these tables. These files are located in the "lib/charset" directory.
+
+
+charset tables
+--------------
+
+Each charset file maps a single charset to the corresponding Unicode
+characters. For the US-ASCII and ISO-8859-x character sets this is
+trivial: each input byte corresponds to a single Unicode character.
+(Actually, some ISO-8859-x octets do not map to any Unicode character.
+In that case, the file either does not contain that octet or map it to
+""????"".)
+
+Other character sets are trickier. For instance, GB-2312 has both
+single and double byte characters, but is still a simple map from
+input character to output character. More complicated are modal
+character encodings. For instance, ISO-2022-JP starts in US-ASCII mode
+and uses "1B" as an escape character followed by another two
+characters to select a new mode.
+
+The input charset labels modes with "":"" followed by the mode name.
+The starting mode ""US-ASCII"" in ISO-2022-JP is preceded by "":US-
+ASCII"". Mode transitions are denoted by a Unicode conversion of
+"">newmode"" or "":newmode"". To denote that the octet "42"
+transitions into the ""US-ASCII"" mode, the charset file has ""42 >US-
+ASCII"". The mode names themselves are arbitrary labels and have no
+effect on the output.
+
+The input charset labels modes with ":" followed by the mode name. The
+mode name is optionally followed by a space and the ""<"" character.
+If the ""<"" character is present, then all translations will be
+followed by a RET instruction instead of an END instruction.
+
+The transition "">newmode"" results in a JSR instruction being
+generated. A JMP instruction is generated by a transition of
+"":newmode"".
+
+The input byte can be specified as ""*"". This is used to define the
+"default action" which is used for input bytes that are not otherwise
+defined for the mode. If the default action is not explicitly stated,
+it is a translation to EMPTY.
+
+
+unicode data table
+------------------
+
+The "unidata2.txt" file is verbatim from the Unicode standard. More
+recent versions should be available from their website. Each entry in
+the file describers a Unicode character by the following properties,
+separated by semicolons:
+
+* code point (16-bit character value) in hex
+
+* character name (unused by Cyrus)
+
+* general category, such as whitespace or punctuation
+
+* the canonical combining class (unused)
+
+* bidirection category (unused)
+
+* character decomposition
+
+* decimal digit value (unused)
+
+* digit value (unused, and, no, I don't know the difference)
+
+* numeric value including fractions (unused)
+
+* mirrored character (unused)
+
+* Unicode 1.0 name (unused)
+
+* comment (unused)
+
+* upper case equivalent (unused)
+
+* lower case equivalent
+
+In general, Cyrus uses the lower case equivalent if there is one, and
+the decomposed value otherwise.
+
+
+unicode fixup table
+-------------------
+
+The "unifix.txt" file contains Cyrus-specific mappings for characters.
+It overrides the "unidata2.txt" table. Each rule in the file is
+explained with a comment. It's helpful to remember that the Unicode
+general categories starting with "Z" represent whitespace, and
+whitespace is always removed.
+
+
+generating "chartable.c"
+------------------------
+
+how "mkchartable" works: collapses the encoding modes, the unicode
+translations, and other normalizations into the output tables
+described above xxx
+
+
+for the future
+==============
+
+
+Sieve/ACAP comparators
+----------------------
+
+
+adjustable normalization?
+-------------------------
+
+The use of uppercase US-ASCII characters is one of the annoyances in
+trying to generalize the charset transcoding. If we continue to
+restrict the characters under consideration to the BMP, switching to
+UTF-8 control codes that start 4 or 5 byte sequences is possible.
+
+Another possibility is to use a NUL character as an escape sequence,
+though this increases the size of each control code by 1 octet.
+
+
+handle >2 octet input characters
+--------------------------------
+
+
+make UTF-8 more regular
+-----------------------
+
+consider whether we really need U83, U83_2, U83_3. also consider
+changing "{ U83, 0, 0, 0 }" translations to "{ U83, JMP, 0, 1 }"
+sequences to at least eliminate the implicit jump.
+
+
+require minimal UTF-8 characters
+--------------------------------
+
+
+references
+==========
+
+xxx
+
+* [UNICODE] Unicode / ISO 10646
+
+* [UTF-8] utf-8 RFC
+
+* [UTF-7] utf-7 RFC
+
+* [BM] boyer-moore
+
+* [ACAP] the comparators reference. see section XXX of RFC 2244.
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/locking.txt 3.2.0-3/doc/text/imap/developer/guidance/locking.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/locking.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/locking.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,97 @@
+
+Cyrus IMAP Server: Locking
+**************************
+
+
+Mailboxes
+=========
+
+For mailboxes, we lock in this order:
+
+* Mailbox Namelock (shared) <== possibly reversible with
+  conversationsdb
+
+* user conversations db
+
+* cyrus.index
+
+If you want to do any mailboxes.db transactions, they need to open and
+close without changing any mailbox locking during the transaction.
+
+Likewise seen and statuscache are always done without changing mailbox
+locking during their transaction.
+
+Annotations databases are a mess.
+
+
+Xapian
+======
+
+* Xapian per-user NAMELOCK (shared or exclusive)
+
+* xapianactive file lock (shared or exclusive)
+
+Shared namelock holds the following invariants:
+
+* xapianactive file contents are not changed
+
+* directories mentioned in xapianactive are not cleaned up
+
+Xapianactive exclusive lock holds the following invariants:
+
+* owner may write to first database mentioned in xapianactive
+
+Xapianactive shared lock holds:
+
+* all databases in xapianactive are readable and a consistent read
+  can be made across all of them, even with multiple requests while
+  the lock is held.
+
+
+Locking orders
+--------------
+
+SHARED case:
+
+* user conversations db <=== possibly reversible with SHARED xapian
+  namelock
+
+* SHARED xapian namelock
+
+* xapianactive lock (shared to search, exclusive to write)
+
+* cyrus.index may be locked either side of the xapianactive lock,
+  because the conversationsdb lock protects it from races.
+
+EXCLUSIVE case:
+
+* EXCLUSIVE xapian namelock That's it.  While you've got this, you
+  can add or delete items from the xapianactive file, and delete paths
+  on disk for directories that you have removed (either during or
+  after locking).  No other locks are permitted.
+
+If you hold a SHARED xapian namelock, you may write to a .NEW folder
+for a xapianactive entry that you created without taking any
+additional locks, because nothing can clean it under you, and nothing
+else can read it.  This is how the repack case works.
+
+
+Lock lifetime
+=============
+
+* Shared mailbox namelock: *   possibly hours
+
+* conversations db and below *   short as possible
+
+Mailbox namelock holds the following invariants:
+
+* cyrus.index may not be repacked, however flags and modseqs may be
+  updated
+
+* cyrus.annotations records may change (kind of buggy and bad,
+  ideally we'd always write new ones if we changed them and keep the
+  old ones)
+
+* cyrus.cache may be appended, but never changed
+
+* spool files may not be deleted (already can't be changed)
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/mailbox-format.txt 3.2.0-3/doc/text/imap/developer/guidance/mailbox-format.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/mailbox-format.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/mailbox-format.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,554 @@
+
+Cyrus IMAP Server: Mailbox File Formats
+***************************************
+
+
+Intro
+=====
+
+This documentation refers to the "version 12" cyrus index format and
+associated mailbox files.
+
+No external tools should make use of this information. The only
+supported method of access to the mail store is through the standard
+interfaces: IMAP, POP, NNTP, LMTP, etc.
+
+A cyrus mailbox is a directory in the filesystem. It contains the
+following files:
+
+* zero or more message files
+
+* the "cyrus.header" metadata file
+
+* the "cyrus.index" metadata file
+
+* the "cyrus.cache" metadata file
+
+* zero or one "cyrus.squat" search indexes
+
+* zero or more subdirectories
+
+With "split metadata" configuration, the mailbox may actually be split
+between multiple disks, with the files being in the same relative
+directory on the meta disk. See the "imapd.conf" option
+"metapartition_files" for more information
+
+
+Message Files
+=============
+
+The message files are named by their UID, followed by a ".", so UID
+423 would be named ""423."". They are stored in wire-format: lines are
+terminated by CRLF and binary data is not allowed.
+
+
+"cyrus.header"
+==============
+
+This file contains mailbox-wide information that does not change
+often. Its format:
+
+   <Mailbox Header Magic String>
+   <Quota Root>\t<Mailbox Unique ID String>\n
+   <Space-separated list of user flags>\n
+   <Mailbox ACL>\n
+
+The Mailbox Unique ID String is used for non-owner per-user \Seen
+flags so they remain with the mailbox during renames, and also by the
+replication subsystem to detect mailbox renames.
+
+The ACL is a copy of the value stored in mailboxes.db, and isn't
+actually used.
+
+
+Locking Considerations
+----------------------
+
+The "cyrus.index" file must be locked in exclusive mode while making
+changes to the "cyrus.header" file to ensure consistency. All changes
+are made by rewriting the entire file and renaming the new version
+into place.
+
+
+"cyrus.cache"
+=============
+
+The "cyrus.cache" file is a pure cache of information that's also
+present in the message files. It exists to make ENVELOPE and specific
+header fetches more efficient, as well as to assist with searches and
+sorts.
+
+If a "cyrus.cache" file is missing or corrupted, it can be re-
+generated by running a "reconstruct" on the mailbox.
+
+The format is 10 individual records each prefixed with a 32 bit length
+value in network byte order. The offset of each message's cache record
+is stored in the "cyrus.index" file (documented below). The records in
+a cyrus.cache file are of variable length, depending on the contents
+of the associated message.
+
+The first 4 bytes of the cyrus.cache file are a "generation number"
+which must match the first 4 bytes of the associated cyrus.index file.
+In the past this was used to track consistency between the files, but
+the name locking scheme and per-record CRC check in cyrus 2.4 and
+above means this is just a backup consistency check rather than an
+essential format feature.
+
+   +------------------------------------------------------------------------+
+   |Gen # (32bits)|Size 1 (32bits)|Data 1                                   |
+   +------------------------------------------------------------------------+
+   |           |Size 2 (32bits)|Data 2            |Size 3 (32bits)| Data 3  |
+   +------------------------------------------------------------------------+
+   | .....                                                                  |
+   +------------------------------------------------------------------------+
+
+While there are occasional changes to the cache format, this
+information is NOT stored in the cyrus.cache file. Instead, there is a
+"cache_version" field in the cyrus.index record, so multiple different
+versions of cache data may exist in the same cache file.
+
+The order of fields per record in the cache file is as follows: (keep
+in mind that they are all preceded by a 4 byte network byte order
+size).
+
+Envelope Response
+   Raw IMAP response for a request for the envelope.
+
+Bodystructure Response
+   Raw IMAP response for a request for the bodystructure.
+
+Body Response
+   Raw IMAP response for an (old style) request for the body.
+
+Binary Bodystructure
+   Offsets into the message file to pull out various body parts.
+   Because of the nature of MIME parts, this is somewhat recursive.
+
+   This looks like the following (starting the octet following the
+   cache field size). All of the fields are bit32s.
+
+      [
+       [Number of message parts+1 for the rfc822 header if present]
+       [
+        [Offset in the message file of the header of this part]
+        [Size (octets) of the header of this part]
+        [Offset in the message file of the content of this part]
+        [Size (octets) of the content of this part]
+        [Encoding Type of this part]
+       ]
+          (repeat for each part as well as once for the headers)
+       [zero *or* number of sub-parts in the case of a multipart.
+        if nonzero, this is a recursion into the top structure]
+          (repeat for each part)
+      ]
+
+   Note if this is not a message/rfc822, than the values for the sizes
+   of the part 0 are -1 (to indicate that it doesn't exist). Sub-parts
+   are not possible for a part 0, so they aren't included when finding
+   recursive entries.
+
+   The offset and size info for both the mime header and content part
+   are useful in order to do fast indexing on the appropriate parts of
+   the message file when a client does a FETCH request for
+   BODY[HEADER], or BODY[2.MIME].
+
+   Note that the top level RFC822 headers are a treated as a separate
+   part from their body text ("0" or "HEADER").
+
+   In the case of a multipart/alternative, the content size & offset
+   refers to the size of the entire mime part.
+
+   A very simple message (with a single text/plain part) would
+   therefore look like:
+
+      [[2][rfc822 header][text/plain body part info][0]]
+
+   A simple multipart/alternative message might look like:
+
+      [[3][rfc822 header][text/plain message part info]
+          [second message part info][0][0]]
+
+   A message with an attachment that has two subparts:
+
+      [[3][rfc822 header info][rfc822 first body part info][attachment info][0][
+            [3][NIL header info][sub part 1 info][sub part 2 info][0][0]]]
+
+   A message with an attached message/rfc822 message with the
+   following total structure:
+
+      message/rfc822
+        0 headers; content-type: multipart/mixed
+        1 text/plain
+        2 message/rfc822
+          0 headers; content-type: multipart/alternative
+          1 text/plain
+          2 text/html
+
+      [[3][rfc822 header part 0][text/plain part 1][overall attachment info][0][
+           [3][rfc822 header part 2.0][text/plain part 2.1][text/html part 2.2]
+              [0][0]]]
+
+Cache Header
+   Any cached header fields. The exact set of fields here depends on
+   the cache record version - there is a function in "imap/mailbox.c"
+   to determine if a named header would be cached based on the
+   version. These are in the same format they would appear in the
+   message file:
+
+      HeaderName: headerdata\r\n
+
+   Examples include: References, In-Reply-To, etc.
+
+From
+   The from header.
+
+To
+   The to header.
+
+Cc
+   The CC header.
+
+Bcc
+   The BCC header.
+
+Subject
+   The Subject header.
+
+
+Locking Considerations
+----------------------
+
+The "cyrus.index" file must be locked in exclusive mode while making
+changes to the "cyrus.cache" file to ensure consistency. All new cache
+records are created by reading the current end-of-file offset,
+appending the new cache record, and storing that start offset into the
+associated cyrus.index record.
+
+
+"cyrus.index"
+=============
+
+The cyrus.index file is NOT just a cache - it stores information not
+present in the message file!
+
+The cyrus.index file consists of a fixed width header, followed by
+fixed width records. In the past, it would be rewritten on every
+expunge, but since Cyrus 2.4 the expunged records remain in the
+cyrus.index file for a configurable time to support QRESYNC and more
+efficient delayed expunge.
+
+The cyrus.index file is the "heart" of the mailbox format - containing
+checksums (CRC32) of everything else, and the most frequently updated
+fields. All fields are stored in network byte order and aligned on 4
+byte boundaries. Due to some 64 bit values being stored, the header
+and individual records are aligned on 8 byte boundaries.
+
+The overall format looks sort of like this:
+
+   cyrus.index:
+   +----------------+
+   | Mailbox Header |
+   +----------------+
+   | Msg: Num 1     |
+   +----------------+
+   | Msg: Num 2     |
+   +----------------+
+   |     ...        |
+   +----------------+
+
+The basic idea being that there is one header, and then all the
+message records are evenly spaced throughout the file. All of the
+message records are at well-known offsets, making any part of the file
+accessable at roughly equal speed.
+
+
+Locking Considerations
+----------------------
+
+"cyrus.index" files can not be repacked (i.e. records can not change
+UID for a particular offset, and the file can't be rewritten or
+deleted) unless there's an exclusive namelock held for the mailbox
+name. This is to avoid race conditions and simplify the use of
+mailboxes. Whenever a mailbox is opened, the caller holds a shared
+namelock on the mailbox name for the duration of the "mailbox
+object"'s existence.
+
+All reads of a "cyrus.index" file must be done with a lock held, and
+all writes must be done with an exclusive lock held. This ensures
+CRC32 checksums of individual headers and records are always
+consistent. There are no direct "offset" reads done any more, instead
+the mailbox API provides a way to read an entire cyrus.index header or
+cyrus.index record into a struct, performing consistency checks.
+Writes are also done with a complete record struct.
+
+
+Detail of "cyrus.index" header
+------------------------------
+
+The index header contains the following information, in order:
+
+Generation Number (4 bytes)
+   A number that is basically the "revision number" of the mailbox. It
+   must match between the cache and index files. This is to ensure
+   that if we fail to sync both the cache and index files and a crash
+   happens (so that only one is synced), we do not provide bad data to
+   the user. This is also backed by having individual cache checksums
+   on each record.
+
+Format (4 bytes)
+   Basically obsolete (indicates netnews or regular).
+
+Minor Version (4 bytes)
+   Indicates the version number of the index file. This can be used
+   for on-the-fly upgrades of the index and cache files.
+
+Start Offset (4 bytes)
+   Size of index header.
+
+Record Size (4 bytes)
+   Size of an index record.
+
+Num Records (4 bytes)
+   How many records are in this index (including records for expunged
+   records. See below for "Exists" which has moved from pre-version 12
+   files.
+
+Last Appenddate (4 bytes)
+   (time_t) of the last time a message was appended
+
+Last UID (4 bytes)
+   Highest UID of all messages in the mailbox (UIDNEXT - 1).
+
+Quota Mailbox Used (8 bytes)
+   Total amount of storage used by all of the messages in the mailbox.
+   Platforms that don't support 64-bit integers only use the last 4
+   bytes.
+
+POP3 Last Login (4 bytes)
+   (time_t) of the last pop3 login to this INBOX, used to enforce the
+   "poptimeout" "imapd.conf" option.
+
+UIDvalidity (4 bytes)
+   The UID validitiy of this mailbox. Cyrus currently uses the
+   "time()" when this mailbox was created.
+
+Deleted, Answered, and Flagged (4 bytes each)
+   Counts of how many messages have each flag.
+
+Mailbox Options (4 bytes)
+   Bitmask of mailbox options, consisting of any combination of the
+   following:
+
+   POP3_NEW_UIDL
+      Flag signalling that we're using "*uidvalidity*.*uid*" instead
+      of just "*uid*" for the output of the POP3 UIDL command.
+
+   IMAP_SHAREDSEEN
+      Flag signalling that we're supporting a shared \Seen flag on the
+      mailbox.
+
+   IMAP_DUPDELIVER
+      Flag signalling that we're allowing duplicate delivery of
+      messages to the mailbox, overriding system-wide duplicate
+      suppression.
+
+   MAILBOX_NEEDS_REPACK
+      Flag signalling that the mailbox is due to be repacked. During
+      mailbox_close() every process will attempt to take an exclusive
+      namelock on the mailbox and repack.
+
+   MAILBOX_DELETED
+      Flag signalling that the mailbox is deleted. This can be set
+      with a shared namelock, and indicates to all other users of the
+      mailbox that they need to close it and attempt cleanup. The last
+      process to close the mailbox will perform the final cleanup
+      under an exclusive namelock, giving the other processes a chance
+      to finish their current operation first without files
+      disappearing from under them!
+
+Leaked Cache (4 bytes)
+   Number of leaked records in the cache file.
+
+Highest ModSeq (8 bytes)
+   Highest Modification Sequence of all the messages in the mailbox
+   (CONDSTORE).
+
+Deleted ModSeq (8 bytes)
+   Lowest Modification Sequence before which expunged message data may
+   have been purged from the mailbox and forgotten (CONDSTORE/QRESYNC
+   support).
+
+Exists (4 bytes)
+   See NumRecords above. This is the count of non-expunged records in
+   the mailbox and corresponds to the IMAP status item "EXISTS".
+
+First Expunged (4 bytes)
+   lowest modified time of an expunged message in this mailbox (or
+   zero if there are no expunged messages) - used to determine if the
+   mailbox needs repacking.
+
+Last Repack Time (4 bytes)
+   a timestamp for the last repack, to ensure repacks aren't done too
+   close together if expunges were closely spaced
+
+Header File CRC (4 bytes)
+   CRC32 value of the bytes in the "cyrus.header" file for this
+   mailbox. Must be rewritten whenever the cyrus.header file is
+   changed (see locking considerations above - this is why the
+   cyrus.index must be exclusively locked!)
+
+Sync CRC (4 bytes)
+   An XOR of the CRC32 of a specially generated value for each of the
+   non-expunged records in this mailbox. This is a cached value which
+   allows the replication subsystem to quickly determine that all non-
+   expunged records in a mailbox are in sync and detect possible
+   "split brain" scenarios with low bandwidth use.
+
+Recent UID (4 bytes)
+   The highest UID last time an IMAP client logged in as the mailbox
+   owner (or anybody if SHAREDSEEN is enabled) selected this mailbox.
+   Used to generate the \Recent flags in IMAP
+
+Recent Time (4 bytes)
+   Used for consistency with the seen_db code, but probably not
+   actually necessary. Oh well
+
+Header CRC (4 bytes)
+   Must always be the LAST record of the header. This is the CRC32 of
+   the actual bytes on disk (network order format) for the rest of the
+   cyrus.index. By keeping it last, it can be easily calculated with
+   the following snippet of code: "crc = crc32_map(buf,
+   OFFSET_HEADER_CRC);" - i.e. crc32 from the start of the buffer to
+   just before this field.
+
+There are also spare fields in the index header, to allow for future
+expansion without forcing an upgrade of the file, and to round up to
+be divisible by 8 bytes.
+
+
+Detail of "cyrus.index" records
+-------------------------------
+
+These records start immediately following the "cyrus.index" header,
+and are all fixed size. They are in-order by uid of the message.
+
+UID (4 bytes)
+   UID of the message
+
+INTERNALDATE (4 bytes)
+   INTERNALDATE of the message (where possible, this matches the
+   creation and modification times of the file on disk to help
+   reconstruct in the event of data loss)
+
+SENTDATE (4 bytes)
+   Contents of the Date: header chomped to day resolution with
+   timezone stripped.
+
+SIZE (4 bytes)
+   Size of the whole message (in octets)
+
+HEADER SIZE (4 bytes)
+   Size of the message header (in octets)
+
+GMTIME (4 bytes)
+   Contents of the Date: header at 1 second resolution and converted
+   to GMT (for sort)
+
+CACHE_OFFSET (4 bytes)
+   Offset into the "cyrus.cache" file for the beginning of this
+   message's cache entry.
+
+LAST UPDATED (4 bytes)
+   (time_t) of the last time this record was changed
+
+SYSTEM FLAGS (4 bytes)
+   Bitmask showing which system flags are set/unset
+
+USER FLAGS (MAX_USER_FLAGS / 32 bytes)
+   Bitmask showing which user flags are set/unset (bits correspond to
+   positions in the cyrus.header flag list, i.e. (1<<0) == the flag
+   name
+
+CONTENT_LINES (4 bytes)
+   Number of text lines contained in the message content (body).
+
+CACHE_VERSION (4 bytes)
+   Indicates the version number of the cache record for the message
+   (determines which headers are cached, see list in mailbox.c).
+
+GUID (MESSAGE_GUID_SIZE bytes)
+   Globally Unique IDentifier of the message (used by replication
+   engine). This is the sha1 value of the bytes as stored on disk.
+
+MODSEQ (8 bytes)
+   Modification Sequence of the message (CONDSTORE).
+
+CACHE_CRC (4 bytes)
+   This is the CRC32 of all the bytes of the cache record (all 10
+   fields) as stored on disk. Again, calculated over the exact bytes
+   stored in the "cyrus.cache" file.
+
+RECORD_CRC (4 bytes)
+   Like the header CRC - this is the CRC32 of all the bytes in on-disk
+   order that exist in this record. Records are always rewritten as
+   the entire record, including the updated CRC, so it's always
+   consistent if you have a lock on the "cyrus.index" file, because
+   writers will wait until they get an exclusive lock to make
+   modifications.
+
+
+Notes
+=====
+
+* Expunge is super quick now - it's just a flag update!
+
+* Append is relatively fast (it only adds to the end of both the
+  cache and index files and modifies the index header)
+
+* Message unlinks always happen during the "close" phase - which may
+  be noticed when you select another mailbox, but otherwise are
+  delayed from the actual action. With delayed expunge, the unlinks
+  are pushed off to cyr_expire which is a background task, and will
+  never be noticed by the user.
+
+* Message delivery is something like this:
+
+  1. write/sync message file
+
+  2. write/sync new "cyrus.cache" record
+
+  3. write/sync new "cyrus.index" record
+
+  4. calculate, write, sync new "cyrus.index" header
+
+  5. acknowledge message delivery
+
+  The message isn't delivered until the new index header is written.
+  In case of a crash before the new index header is written, any
+  previous writes will be overwritten on the next delivery (and will
+  not be noticed by the readers).
+
+  Note that certain power failure situations (power failure in the
+  middle of a disk sector write) could cause a mailbox to need
+  reconstruction (possibly even losing some flag state). These failure
+  modes are not possible in the "Hardware RAID disk model" (which we
+  will describe somewhere else when we get around to it).
+
+
+Future considerations
+=====================
+
+* Cache all header fields? (or all up to Xk?) This could greatly
+  improve speeds of clients that just ask for everything, but also
+  increases the expense of rewriting the cache file (as well as the
+  size it takes on disk).
+
+* Reformat cache file to use a
+  (size)(size)(size)(size)(data)(data)(data) format. This makes
+  accesses anywhere in the cache file equally fast, as opposed to
+  having to iterate through all the entires for a given message to get
+  to the last one. Note that either way is still O(1) so maybe it
+  doesn't matter much.
+
+* It would be useful to store a uniqueid -> mailbox name index, so
+  that we could fix arbitron again.
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/namelocks.txt 3.2.0-3/doc/text/imap/developer/guidance/namelocks.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/namelocks.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/namelocks.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,103 @@
+
+Cyrus IMAP Server: Namelocks
+****************************
+
+
+Intro
+=====
+
+Name locks are an addition to the cyrus internals to address a range
+of race conditions and complexities. These ills are most easily
+avoided by ensuring that only one process can do certain operations at
+once. Name locks also mean crashes can't leave the mailbox "broken"
+forever.
+
+Unfortunately, locks can't be retained over a rewrite-rename cycle,
+and every meta file in a regular mailbox gets rewritten upon occasion.
+Even cyrus.header gets a rewrite when a new userflag is added.
+
+The "RESERVED FLAG" method of handling mailbox creation is a nasty
+brutish method that breaks on process crashes, causing a full
+mailboxes.db sweep to be necessary on restart, and making that name
+unusable until the entire server is restarted. It's also unusable for
+serialisation of operations without making the mailbox "disappear" to
+other clients.
+
+Mailbox names are supposed to be exclusive per server, not just per
+partition, so any lock has to apply to the entire server.
+
+**MURDER Considerations:** Due to the way the mupdate protocol works,
+RESERVED records are still created over mupdate. This sucks, and a
+better way would be to support an "EXCLUSIVE CREATE" command, where
+the create only succeeds if the record doesn't already exist. Then a
+task could create the mailbox on the local server and retain an
+exclusive namelock while trying to assert the name on the mupdate
+server. If this failed (someone else got in first) then the mailbox
+could be cleaned up locally before releasing the exclusive namelock,
+meaning other users on the local server would never see it existing.
+
+
+Implementation
+==============
+
+It's a simple matter of having a file under $configdirectory/lock - in
+a directory tree using the same hashing structure as the mailbox tree.
+This directory can be symlinked or mounted to a tmpfs since the locks
+need not persist across restarts. Due to race conditions while
+cleaning up, the easiest approach is to only ever delete lock files
+during restart, so the unlock code doesn't try to remove them. Lock
+files are zero byte in size, and are locked using the flock or fcntl
+primitives used by the rest of cyrus.
+
+
+API
+===
+
+Lock types:
+
+* LOCK_SHARED - shared lock on the name. Required whenever you have
+  an open mailbox with that name
+
+* LOCK_EXCLUSIVE - exclusive lock on the name. Required to create or
+  finish deleting a mailbox, and required when repacking the
+  cyrus.index and cyrus.cache files.
+
+* LOCK_NONBLOCKING - attempt to take an exclusive lock on the name,
+  but if it's not available, return immediately with r ==
+  IMAP_MAILBOX_LOCKED rather than blocking until the lock is
+  available.
+
+The "mboxname" is always an **internal name**, so convert it first.
+
+
+Example:
+--------
+
+   struct mboxlock *lock = NULL;
+   int locktype = LOCK_SHARED; /* or LOCK_EXCLUSIVE or LOCK_NONBLOCKING */
+
+   r = mboxname_lock("user.brong", &lock, locktype);
+   if (!r) {
+       do_stuff();
+       mboxname_release(&lock);
+   }
+
+If mboxname_lock fails, lock will remain NULL. It should always be
+initialised to NULL before being passed to mailbox_lock. It will be
+set back to NULL by mboxname_release.
+
+
+Re-locking considerations
+-------------------------
+
+It is not possible to hold multiple locks to the same name within the
+same process. If you call mboxname_lock with the same name within a
+process, and the **same locktype** then a reference counter is
+incremented and the same lock is returned. If you use a **different
+locktype** (i.e. one shared, the other exclusive. Non-blocking is
+considered exclusive for this test) then IMAP_MAILBOX_LOCKED will be
+returned to avoid breaking the locking semantics. This is a
+restriction of the underlying fcntl/flock subsystem.
+
+On the way out, the reference counter is decremented with each release
+and the lock isn't freed until the counter gets back to zero.
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/prot.txt 3.2.0-3/doc/text/imap/developer/guidance/prot.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/prot.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/prot.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,73 @@
+
+Cyrus IMAP Server: prot layer
+*****************************
+
+The prot layer, defined in "prot.h", is a stdio replacement for
+network i/o. It does the standard buffering of input and output and
+allows certain operations especially suited for request/response
+protocols like IMAP.
+
+
+Events
+======
+
+The prot layer allows "events" to be associated with each prot stream.
+These events are trigger at the given time or after when the
+protstream is attempted to be read from.
+
+An event is currently represented by the following datastructure:
+
+   struct prot_waitevent;
+
+   typedef struct prot_waitevent *prot_waiteventcallback_t(struct protstream *s,
+                               struct prot_waitevent *ev,
+                               void *rock);
+
+   struct prot_waitevent {
+       time_t mark;
+       prot_waiteventcallback_t *proc;
+       void *rock;
+       struct prot_waitevent *next;
+   };
+
+The application is currently allowed to modify *mark*, *proc*, and
+*rock* as desired when there are no active calls to a prot function on
+the stream which this event is associated.
+
+The API is as follows:
+
+* Use "prot_addwaitevent()" to add an event callback onto the
+  stream:
+
+     extern struct prot_waitevent *prot_addwaitevent(struct protstream *s,
+                             time_t mark,
+                             prot_waiteventcallback_t *proc,
+                             void *rock);
+
+  where *s* is the stream to add the event to, *mark* is the time to
+  trigger the event, *proc* is the callback to make, and *rock* is an
+  opaque data item handed to the callback. It returns a pointer to the
+  event structure; this is the pointer that must be used to remove the
+  event or modify it in some way.
+
+* Use "prot_removewaitevent()" to remove an event:
+
+     extern void prot_removewaitevent(struct protstream *s,
+                      struct prot_waitevent *event);
+
+  It requires *event* to have been returned from "prot_addwaitevent()"
+  previously. No further references are allowed to *event* or its
+  fields. *event->rock* is not free'd nor examined in any way. This
+  function may be called while inside the callback *event->proc()*. If
+  an event is removed inside of its callback, that callback must
+  return "NULL".
+
+Some common things to do with events:
+
+* To reschedule an event *ev*, simply set *ev->mark* to the next
+  time it should trigger. If currently in *ev->proc()*, it should
+  return *ev*.
+
+======================================================================
+
+last modified: $Date: 2003/08/06 21:28:05 $
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/replication_examples.txt 3.2.0-3/doc/text/imap/developer/guidance/replication_examples.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/replication_examples.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/replication_examples.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,159 @@
+
+Cyrus IMAP Server: Replication Examples
+***************************************
+
+
+Introduction
+============
+
+The replication system creates a link between two Cyrus mailstores: a
+master and a replica system. Both systems can be live mailstores with
+active users: here in Cambridge we install systems in pairs.
+
+Typically half of the users will be using each system, and each system
+replicates to its partner. In the event of a failover everyone uses
+the remaining system in a pair. This is typically safe as the
+IMAP/POP/SMTP servers define which of the two systems is the live
+server for any given account, and the replica just plays a game of
+follow my leader.
+
+Occasionally I think about introducing some form of sanity check so
+that we have to explicitly issue a command to the remaining backend
+system as well as the proxies in the event of a failover.
+
+
+A short example of replication in action
+========================================
+
+   Index:
+
+     #: Annotation
+     C: Command issued by client
+     S: Command issued by server
+
+   # Authentication between systems is done using SSH key based authentication:
+
+   C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+   S: * Sync Server v0.0 [EXPERIMENTAL]
+
+   # Create new auth_state and ask for all information about given list of
+   # folders (namely user.dpc22). Returns:
+   #
+   #   "**" unsolicited response for each mailbox. Returns:
+   #      Folder UniqueID, Name, ACL, UIDlast, timestamp for last seen update.
+   #
+   #   "*" response for each mail message in folder:
+   #      UID, GUID, flags (other than \Seen state)
+
+   C: user_some dpc22 user.dpc22
+   S: ** 6b98205c796c6c61 user.dpc22 \
+   S:     "dpc22   lrswipcda       anonymous       0      " 4151 1062945305
+   S: * 1 000000000000000000000000 ()
+   S: * 3697 0101003f4c56b00545000000 ()
+   S: * 3919 0101003f4c56b04b2900000d ()
+   S: * 3937 0101003f4c56b0514900001f ()
+   S: * 4066 0101003f4c56b07422000002 ()
+   S: * 4089 0101003f4c56b07e56000023 (\answered)
+   S: * 4118 0101003f4c56b08328000016 ()
+   S: * 4131 0101003f4c56b084d7000002 ()
+   S: * 4136 0101003f4c56b087f3000001 ()
+   S: * 4140 0101003f4c56b08c9d000026 ()
+   S: OK User_Some finished
+
+   # Select a folder to work with
+
+   C: select user.dpc22
+   S: OK 6b98205c796c6c61 4151 1062945305
+
+   # Remove message with UID "1" from folder list (message which has been
+   # sitting in my inbox since January, has no GUID defined)
+
+   C: expunge 1
+   S: OK Expunge Complete
+
+   # Set some user flags on message UID "4140"
+
+   C: setflags 4140 (hello world)
+   S: OK Updated flags on 1 messages okay
+
+   # Demonstrate that something has changed:
+
+   C: status
+   S: * 3697 0101003f4c56b00545000000 ()
+   S: * 3919 0101003f4c56b04b2900000d ()
+   S: * 3937 0101003f4c56b0514900001f ()
+   S: * 4066 0101003f4c56b07422000002 ()
+   S: * 4089 0101003f4c56b07e56000023 (\answered)
+   S: * 4118 0101003f4c56b08328000016 ()
+   S: * 4131 0101003f4c56b084d7000002 ()
+   S: * 4136 0101003f4c56b087f3000001 ()
+   S: * 4140 0101003f4c56b08c9d000026 (hello world)
+   S: OK 4151
+
+   # Now lets correct the damage that we just inflicted:
+
+   C: $ replicate -s cyrus-2 -v -v -m user.dpc22
+   S: MAILBOXES user.dpc22
+   S: USER_SOME dpc22 user.dpc22
+   S: SELECT user.dpc22
+   S: SETFLAGS [1 msgs]
+   S: UPLOAD [1 msgs]
+   S: SETSEEN dpc22 ...
+   S: ENDUSER
+
+   C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+   S: * Sync Server v0.0 [EXPERIMENTAL]
+   S: user_some dpc22 user.dpc22
+   S: ** 6b98205c796c6c61 user.dpc22 \
+   S:    "dpc22   lrswipcda       anonymous       0      " 4156 1062968731
+   S: * 1 000000000000000000000000 ()
+   S: * 3697 0101003f4c56b00545000000 ()
+   S: * 3919 0101003f4c56b04b2900000d ()
+   S: * 3937 0101003f4c56b0514900001f ()
+   S: * 4066 0101003f4c56b07422000002 ()
+   S: * 4089 0101003f4c56b07e56000023 (\answered)
+   S: * 4118 0101003f4c56b08328000016 ()
+   S: * 4131 0101003f4c56b084d7000002 ()
+   S: * 4136 0101003f4c56b087f3000001 ()
+   S: * 4140 0101003f4c56b08c9d000026 ()
+   S: OK User_Some finished
+
+   # Back where we started: the replication engine reinserted message UID 0
+   # which was missing, and removed "hello world" from message UID 4140
+
+
+Tracking messages between folders
+=================================
+
+   # I've just saved a message from my inbox into a folder named "zzz",
+   # creating the folder the process.
+
+   C: $ replicate -s cyrus-2 -v -v -m user.dpc22 user.dpc22.zzz
+
+   Replication action on two MAILBOX objects:
+
+   S: MAILBOXES user.dpc22 user.dpc22.zzz
+
+   Ask server for contents of the two folders:
+
+   S:   USER_SOME dpc22 ...
+
+   Reserve message with given GUID in user.dpc22 so that it can be moved
+
+   S:   RESERVE user.dpc22 ...
+
+   Remove message from source folder (reserved copy left behind)
+
+   S:   SELECT user.dpc22
+   S:   EXPUNGE [1 msgs]
+   S:   SETSEEN dpc22 ...
+
+   Create target folder and copy in message that we reserved (doesn't have to
+   be uploaded again)
+
+   S:   CREATE user.dpc22.zzz 7f6f384c3f5ba99a
+   S:      "dpc22        lrswipcda       anonymous       0       " 0 1062971802
+   S: SELECT user.dpc22.zzz
+   S: UPLOAD [1 msgs]
+   S: SETSEEN dpc22 ...
+   S: ENDUSER
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/replication_protocol.txt 3.2.0-3/doc/text/imap/developer/guidance/replication_protocol.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/replication_protocol.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/replication_protocol.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,87 @@
+
+Cyrus IMAP Server: Replication Protocol v2.4+
+*********************************************
+
+
+DList 1.0
+=========
+
+The DList protocol is based closely on the IMAP wire protocol, using
+atoms and literals as the basis, but with two extended types of data:
+
+* kvlist
+
+* rfc822-object
+
+A wart of the protocol is the rfc822-object, which contains an
+explicit cyrus backend partition. This will be removed in future
+versions of Cyrus.
+
+
+types
+-----
+
+
+atom
+~~~~
+
+An atom is actually a sequence of any character other than '\0', the
+NULL byte. Character encoding is not specified, but it can contain 8
+bit characters, and is probably utf8
+
+
+flag
+~~~~
+
+Flag is a horrible special case of atom to allow \word to be
+represented as an IMAP atom on the wire. This is one of many special
+cases in the IMAP protocol, and is duplicated into dlist just to make
+it easier to read
+
+
+num32/num
+~~~~~~~~~
+
+Both stored as 64 bit integers internally, and sent as decimal numbers
+over the wire, this type exists only in the API, it just looks like a
+string on the wire.
+
+
+hex32/hex
+~~~~~~~~~
+
+Stored like num internally, but sent as an 8 or 16 character
+hexadecimal string on the wire
+
+
+map
+~~~
+
+Like atom, but can contain NULL. All values are parsed off the wire as
+'map' type and then converted on demand into the requested type
+
+
+list
+~~~~
+
+Encoded in parentheses like so (item item item) a list type can be
+nested inside other lists: (item (sub sub) item)
+
+
+kvlist
+~~~~~~
+
+A kvlist allows named parameters, and is indicated with a leading %
+character. % is invalid in atoms, so parsing is unambiguous, e.g:
+
+%(key1 value1 key2 (list of values) key3 value3)
+
+
+rfc822-object/file
+~~~~~~~~~~~~~~~~~~
+
+Finally the ugly one. These look like a literal, but with a leading %
+and two more fields:
+
+   %{partition sha1 size}\r\n
+   data
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/special_chars.txt 3.2.0-3/doc/text/imap/developer/guidance/special_chars.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/special_chars.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/special_chars.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,54 @@
+
+Cyrus IMAP Server: Special Characters
+*************************************
+
+This document is supposed to be a repository of "special characters"
+used in Cyrus naming of users, folders, directory paths, etc.
+
+
+Current Uses
+============
+
+
+   Character: +
+
+* (LMTP) Separation of postuser and target mailbox for delivery
+
+* (LMTP) Separation of username and submailbox for delivery
+
+* (IMAP) Flag at end of login name that indicates that LIST should
+  return LSUB results (when imapmagicplus is set)
+
+* (POP3) POP a subfolder directly (e.g. rjs3+foo POPs user.rjs3.foo)
+
+
+   Character: . /
+
+* [mailbox names] Hierarchy separators
+
+
+   Character: ^
+
+* [mailbox names] In unixhierarchysep, ^ is the part of the internal
+  name that represents a '.'
+
+
+   Characters: @ %
+
+* [usernames] These are realm separators for the purposes of
+  authentication
+
+
+
+
+Future Uses
+===========
+
+   Character: +
+
+* IMAP LIST filters (e.g. rjs3+foo will only list folders that match
+  foo*)
+
+* possibly other interpretations here: - rjs3+foo will do an
+  effective chroot(foo.) - rjs3+foo will only list folders in
+  user.rjs3.foo*
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance/var_directory_structure.txt 3.2.0-3/doc/text/imap/developer/guidance/var_directory_structure.txt
--- 3.0.13-5/doc/text/imap/developer/guidance/var_directory_structure.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance/var_directory_structure.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,68 @@
+
+Cyrus IMAP Server: var directory structure
+******************************************
+
+
+Directory structure under /var/spool/imap
+=========================================
+
+   stage./
+     Normal staging directory
+
+   sync./
+     Staging directory for replication system
+     Includes
+       sync./locks/*
+
+     which are lock files for each user on the system to prevent two
+     replication runs from trying to update the same account at the same time
+     (nothing disastrous should happen even without this lock, but the second
+     job in will get a bit confused if the target end changes under its feet,
+     and will probably drop back to a recovery mode.
+
+   user/
+     Familiar user.userid space.
+
+
+Directory structure under /var/imap
+===================================
+
+Complete list:
+
+   drwxr-xr-x    2 cyrus    cyrus         232 Sep  7 08:21 db
+   drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:51 db.backup1
+   drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:21 db.backup2
+   -rw-r-----    1 cyrus    cyrus    20799488 Sep  7 19:51 deliver.db
+   drwxr-xr-x    2 cyrus    cyrus          48 Sep  7 10:16 log
+   -rw-r-----    1 cyrus    cyrus     1995000 Sep  7 19:38 mailboxes.db
+   -rw-r--r--    1 cyrus    cyrus          10 Jun  2 10:08 master_machine
+   -rw-r--r--    1 cyrus    cyrus          71 Sep  7 08:21 master_uuid
+   drwxr-xr-x    2 cyrus    cyrus          48 Jun  2 10:08 msg
+   drwxr-xr-x    2 cyrus    cyrus        1872 Sep  7 19:55 proc
+   drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 quota
+   drwxr-xr-x    2 cyrus    cyrus         224 Sep  7 08:21 socket
+   drwxr-xr-x    2 cyrus    cyrus          72 Sep  7 10:19 sync
+   drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 user
+
+Most of that will be familiar. New entries are:
+
+   master_machine
+     Defines machine number in replication cluster. Used as sanity check
+     against master_uuid file. Sample content:
+
+       machine=1
+
+   master_uuid
+     Full information about UUID schema in use. See ./uuid for details.
+     Sample content:
+
+        schema=1
+        machine=1
+        timestamp_generation=0
+        master_start_time=1062919294
+
+   sync/current
+     Transaction log from IMAP, POP and LMTP daemons, typically feed into
+     sync_client running as asynchronous replication engine.
+
+     Rotated to be sync/current-<pid> by asynchronous runner.
diff -pruN 3.0.13-5/doc/text/imap/developer/guidance.txt 3.2.0-3/doc/text/imap/developer/guidance.txt
--- 3.0.13-5/doc/text/imap/developer/guidance.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/guidance.txt	2020-05-04 04:13:53.000000000 +0000
@@ -0,0 +1,23 @@
+
+Developer Guidance
+******************
+
+* Cyrus IMAP Server: Hacking
+
+* Cyrus IMAP Server: Internationalization
+
+* Cyrus IMAP Server: Locking
+
+* Cyrus IMAP Server: Mailbox File Formats
+
+* Cyrus IMAP Server: Namelocks
+
+* Cyrus IMAP Server: prot layer
+
+* Cyrus IMAP Server: Replication Examples
+
+* Cyrus IMAP Server: Replication Protocol v2.4+
+
+* Cyrus IMAP Server: Special Characters
+
+* Cyrus IMAP Server: var directory structure
diff -pruN 3.0.13-5/doc/text/imap/developer/install-xapian.txt 3.2.0-3/doc/text/imap/developer/install-xapian.txt
--- 3.0.13-5/doc/text/imap/developer/install-xapian.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/install-xapian.txt	2020-05-04 04:13:54.000000000 +0000
@@ -69,10 +69,10 @@ You also need (at least one) search tier
    search_engine: xapian
    search_index_headers: no
    search_batchsize: 8192
-   defaultpartition: default
+   defaultpartition: base
    defaultsearchtier: t1
-   partition-default: /var/cyrus/spool
-   t1searchpartition-default: /var/cyrus/search
+   partition-base: /var/cyrus/spool
+   t1searchpartition-base: /var/cyrus/search
 
 If you want to do more complex search tiers and repacking, you'll want
 to read:
diff -pruN 3.0.13-5/doc/text/imap/developer/jmap.txt 3.2.0-3/doc/text/imap/developer/jmap.txt
--- 3.0.13-5/doc/text/imap/developer/jmap.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/jmap.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,161 @@
+
+JMAP support
+************
+
+JMAP is an alternate mechanism for synchronising a mail client with a
+mail server, intended as a replacement for IMAP. It is a transport-
+agnostic, stateless JSON-based API, aiming to be compatible with the
+IMAP data model, but with reduced data usage and more efficient
+synchronisation.
+
+
+Cyrus administration
+====================
+
+
+Compile JMAP support into Cyrus
+-------------------------------
+
+1. Enable JMAP (and DAV) in Cyrus:
+
+      * "./configure --enable-http --enable-jmap --enable-xapian"
+        along with your other configuration options.
+
+2. Enable conversation support
+
+      * In imapd.conf(5), set "conversations: 1", "conversations_db:
+        twoskip"
+
+      * Create a conversations.db for each user:
+        "ctl_conversationsdb -b -r"
+
+3. JMAP depends on Xapian. For full support (to gain full word
+boundary distinctions in CJK languages - Chinese, Japanese and
+Korean), this needs to be manually compiled due to extra patches
+needing to be applied. Our Xapian install guide shows how.
+
+4. Once installed, the "jmap" module must be enabled in imapd.conf(5):
+"httpmodules: jmap"
+
+
+JMAP client
+===========
+
+
+Test JMAP support
+-----------------
+
+Once Cyrus is running, you can test JMAP on the command line for any
+existing Cyrus user. The user must at least have an INBOX provisioned
+but is not required to have any calendars, contacts or messages.
+
+To obtain the JMAP mailbox folders for user "test", issue the
+following request:
+
+   curl -X POST \
+        -H "Content-Type: application/json" \
+        -H "Accept: application/json" \
+        --user test:test \
+        -d '{
+          "using": [ "urn:ietf:params:jmap:core", "urn:ietf:params:jmap:mail" ],
+          "methodCalls": [[ "Mailbox/get", {}, "c1" ]]
+        }' \
+        http://localhost/jmap/
+
+you should get a response which looks similar to
+
+   {
+     "methodResponses": [
+       ["Mailbox/get", {
+         "state": "0",
+         "list": [{
+           "id": "7c76ec2b-9bd8-4091-a665-640e232e3877",
+           "name": "Inbox",
+           "parentId": null,
+           "myRights": {
+             "mayReadItems": true,
+             "mayAddItems": true,
+             "mayRemoveItems": true,
+             "mayCreateChild": true,
+             "mayDelete": false,
+             "maySubmit": true,
+             "maySetSeen": true,
+             "maySetKeywords": true,
+             "mayAdmin": true,
+             "mayRename": false
+           },
+           "role": "inbox",
+           "totalEmails": 0,
+           "unreadEmails": 0,
+           "totalThreads": 0,
+           "unreadThreads": 0,
+           "sortOrder": 1,
+           "isSubscribed": false
+         }, {
+           "id": "5d9e4f44-7df9-4489-b8b3-32625b552aa1",
+           "name": "Trash",
+           "parentId": null,
+           "myRights": {
+             "mayReadItems": true,
+             "mayAddItems": true,
+             "mayRemoveItems": true,
+             "mayCreateChild": true,
+             "mayDelete": true,
+             "maySubmit": true,
+             "maySetSeen": true,
+             "maySetKeywords": true,
+             "mayAdmin": true,
+             "mayRename": true
+           },
+           "role": null,
+           "totalEmails": 0,
+           "unreadEmails": 0,
+           "totalThreads": 0,
+           "unreadThreads": 0,
+           "sortOrder": 10,
+           "isSubscribed": true
+         }],
+         "notFound": [],
+         "accountId": "test"
+       }, "c1"]
+     ],
+     "sessionState": "0"
+   }
+
+Similar requests exist to obtain contacts and calendars. For details,
+see the JMAP specification.
+
+
+Optional: Install sample JMAP client
+------------------------------------
+
+Note: Cyrus does not yet implement JMAP authentication. Instead, it
+  requires for each request the HTTP Basic Auth header set with the
+  account's username and password. If you intend to use the JMAP perl
+  or web clients, make sure to add the required authentication headers
+  for each request.
+
+You can set up the JMAP Proxy (perl) to sit in front of a standard
+IMAP server and query that over a custom JMAP client.
+
+Or you can install a sample JMAP web client which requires the
+Overture.js library and JMAP JS library to talk to a JMAP-enabled
+Cyrus server and build from there (subject to the MIT license).
+
+The web client is a simple example (no compose, contacts or
+calendars). When you create your account, the most recent 50 emails
+will be downloaded in their entirety, so the first page should be
+snappy immediately. After that, you are redirected to the landing
+page. A background task will continue to pull in batches of messages
+and add them to your account, so you will see older messages appear
+while you are using the interface.
+
+
+Developing the client further
+-----------------------------
+
+You'll want to become deeply familiar with the JMAP developer
+documentation
+
+Note: JMAP implementation in Cyrus is a work in progress. Current
+  status can be viewed on the main JMAP configuration page.
diff -pruN 3.0.13-5/doc/text/imap/developer/releasing.txt 3.2.0-3/doc/text/imap/developer/releasing.txt
--- 3.0.13-5/doc/text/imap/developer/releasing.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/releasing.txt	2020-05-04 04:13:54.000000000 +0000
@@ -10,6 +10,8 @@ Contents
 
   * Prerequisites
 
+  * Order of operations
+
   * Release notes
 
   * Pre-release testing
@@ -18,7 +20,11 @@ Contents
 
   * Version tagging
 
-  * Releasing
+  * Inter-version website consistency
+
+  * Uploading
+
+  * Tell the world
 
 These instructions are specifically for doing releases from branches
 that contain RST-based documentation and infrastructure.  This
@@ -38,13 +44,29 @@ now just read the manual like she did. :
 Once you have a GPG key, it's helpful to upload your public key to the
 MIT key-server
 
-You also need a shell account on www.cyrusimap.org and
-ftp.cyrusimap.org, with SSH key authentication.  You need to be in the
-"admin" group on each, and also the "cyrupload" group on the latter.
-
 And you need permission to send to the cyrus-announce mailing list.
 
 
+Order of operations
+===================
+
+Sometimes you're releasing several new versions all at once(ish), for
+example maybe there's been a security fix that affected 2.4, 2.5 and
+3.0.
+
+Github's release page will put a "Latest Release" graphic on the
+release with the newest tag (by timestamp, I think).  This means that,
+if you're doing new releases for several different versions, you want
+to do the oldest one first, and only do the release for the current-
+stable branch last.
+
+If you start at the current stable branch and then work your way
+backwards through the older ones, you'll get Github saying "2.5.15 is
+the Latest Release" even though 3.0.13 was also just released... so,
+even though releasing the current-stable fix feels more urgent, suck
+it up and get the older-branch ones out first.
+
+
 Release notes
 =============
 
@@ -75,7 +97,7 @@ Pre-release testing
 
 4. Run "make distcheck".  This will generate a distribution
    tarball, and test it in various ways.  It takes about 10-15 mins to
-   run, depending on your hardware.  If this command fails, you are
+   run, depending on your hardware.  If this command fails*, you are
    not ready to release -- fix the problems, get them tested and
    committed, then restart the pre-release testing.
 
@@ -106,6 +128,19 @@ Pre-release testing
    9. If any of this fails, fix it, commit it, then restart the
       pre- release testing.
 
+Note: "make distcheck" doesn't work on the 2.5 branch.  For 2.5,
+  just use "make dist" instead.
+
+Note: Realistically, there's usually some set of expected Cassandane
+  failures from each Cyrus branch, especially for 2.5.  If you're
+  doing releases regularly, you've probably got a good gut feel for
+  which failures are a problem and which ones are just "that old
+  thing".  If you don't do releases regularly, try to pull in someone
+  who does for guidance about which failures are ignorable, and which
+  should be a source of stress.If in doubt, try building and testing
+  the previous release from the same series, and compare the test
+  results.
+
 
 Linking up release notes
 ========================
@@ -127,9 +162,10 @@ are available.
 Version tagging
 ===============
 
-Note: it is absolutely critical that your local commits have been
-pushed upstream at this point.  If they are not, and if anybody else
-pushes in the meantime, you will end up with a mess.
+Note: it is absolutely critical that your repository is clean and your
+local commits have been pushed upstream at this point.  If they are
+not, and if anybody else pushes in the meantime, you will end up with
+a mess.
 
 1. Ensure your repository is clean again: "git clean -xfd"
 
@@ -171,20 +207,74 @@ pushes in the meantime, you will end up
     (assuming your remote is named "ci").
 
 
-Releasing
+Inter-version website consistency
+=================================
+
+The website is built from an amalgamation of documentation from:
+
+* The current stable cyrus-imapd branch (top level)
+
+* The current master cyrus-imapd branch ("/dev" hierarchy)
+
+* Each of the following cyrus-imapd branches ("/x.y" hierarchies)
+
+     * cyrus-imapd-2.5
+
+     * cyrus-imapd-3.0
+
+     * cyrus-imapd-3.2
+
+* The current master cyrus-sasl branch ("/sasl" hierarchy)
+
+When making a cyrus-imapd release, you need to add the new release
+notes file to each relevant cyrus-imapd branch.  You also need to
+check and update the contents of "docsrc/conf.py" on each branch AND
+the cyrus-sasl repository.
+
+Sometimes you can just cherry-pick the commits around, but note that
+the 2.5 website stores release notes files in a different path, so if
+you bother to copy release notes back to this branch, a naive cherry-
+pick will not put them in the right place!
+
+This step often gets forgotten, so if you actually follow it, and
+notice some missing versions, just go ahead and add them while you're
+there.
+
+
+Uploading
 =========
 
-1. Upload the tarball and signature to www: "scp cyrus-
-   imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/"
+Note: This section does NOT apply to releases from the master
+  branch.  We do not publish release tarballs for those.  People
+  running master code are expected to use a git checkout.
+
+Time to upload the release tarball and signature file!
+
+1. Navigate to https://github.com/cyrusimap/cyrus-imapd/releases
+
+2. The tag you pushed earlier will now be available as a release,
+   but it will have very little information about it
+
+3. Click on the tag name
+
+4. Click "Edit tag" on the right
+
+5. *Leave every field on the page as it is (probably blank!),
+   except*:
+
+6. Use the "Attach binaries by dropping them here or selecting
+   them" widget to upload the tarball and signature files
+
+7. If this is an alpha/beta/rc release, click the "This is a pre-
+   release" checkbox
+
+8. Click "Save".  The commit message from the tag annotation will
+   be used as the release description.
 
-2. Upload them to ftp too: "scp cyrus-imapd-*.tar.gz cyrus-
-   imapd-*.tar.gz.sig ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/"
 
-3. SSH into both www and ftp, and move older releases to the old
-   versions directory.  You want only the two most recent tarball+sig
-   pairs for each major series.
+Tell the world
+==============
 
-4. Update the topic in the #cyrus IRC channel.
+1. Update the topic in the #cyrus IRC channel.
 
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+2. Send an announcement to the info-cyrus and cyrus-announce lists.
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/backup.txt 3.2.0-3/doc/text/imap/developer/thoughts/backup.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/backup.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/backup.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,1156 @@
+
+Notes for backup implementation
+*******************************
+
+Backup index database (one per user):
+
+chunk:
+
+   int id
+   timestamp ts
+   int offset
+   int length
+   text file_sha1              -> sha1 of (compressed) data prior to this chunk
+   text data_sha1              -> sha1 of (uncompressed) data contained in this chunk
+
+mailbox:
+
+   int id
+   int last_chunk_id           -> chunk that knows the current state
+   char uniqueid               -> unique
+   char mboxname               -> altered by a rename
+   char mboxtype
+   int last_uid
+   int highestmodseq
+   int recentuid
+   timestamp recenttime
+   timestamp last_appenddate
+   timestamp pop3_last_login
+   timestamp pop3_show_after
+   timestamp uidvalidity
+   char partition
+   char acl
+   char options
+   int sync_crc
+   int sync_crc_annot
+   char quotaroot
+   int xconvmodseq
+   char annotations
+   timestamp deleted           -> time that it was unmailbox'd, or NULL if still alive
+
+message:
+
+   int id
+   char guid
+   char partition              -> this is used to set the spool directory for the temp file - we might not need it
+   int chunk_id
+   int offset                  -> offset within chunk of dlist containing this message
+   int size                    -> size of this message (n.b. not length of dlist)
+
+mailbox_message:
+
+   int mailbox_id
+   int message_id
+   int last_chunk_id           -> chunk that has a RECORD in a MAILBOX for this
+   int uid
+   int modseq
+   timestamp last_updated
+   char flags
+   timestamp internaldate
+   int size
+   char annotations
+   timestamp expunged          -> time that it was expunged, or NULL if still alive
+
+subscription:
+
+   int last_chunk_id           -> chunk that knows the current state
+   char mboxname               -> no linkage to mailbox table, users can be sub'd to nonexistent
+   timestamp unsubscribed      -> time that it was unsubscribed, or NULL if still alive
+
+seen:
+
+   int last_chunk_id           -> chunk that knows the current state
+   char uniqueid               -> mailbox (not necessarily ours) this applies to
+   timestamp lastread
+   int lastuid
+   timestamp lastchange
+   char seenuids               -> a uid sequence encoded as a string
+
+sieve:
+
+   int chunk_id
+   timestamp last_update
+   char filename
+   char guid
+   int offset                  -> offset within chunk of the dlist containing this script
+   timestamp deleted           -> time that it was deleted, or NULL if still alive
+
+sieve scripts and messages are both identified by a GUID but APPLY
+SIEVE doesn't take a GUID, it seems to be generated locally? the GUID
+in the response to APPLY SIEVE is generated in the process of reading
+the script from disk (sync_sieve_list_generate)
+
+can't activate scripts because only bytecode files are activated, but
+we neither receive bytecode files over sync protocol nor do we compile
+them ourselves.
+
+possibly reduce index size by breaking deleted/expunged values into
+their own tables, such that we only store a deleted value for things
+that are actually deleted.  use left join + is null to find undeleted
+content
+
+
+messages
+========
+
+APPLY MESSAGE is a list of messages, not necessarily only one message.
+Actually, it's a list of messages for potentially multiple users, but
+we avoid this by rejecting GET MESSAGES requests that span multiple
+users (so that sync_client retries at USER level, and so we only see
+APPLY MESSAGE requests for a single user).
+
+Cheap first implementation is to index the start/end of the entire
+APPLY MESSAGE command identically for each message within it, and at
+restore time we grab that chunk and loop over it looking for the
+correct guid.
+
+Ideal implementation would be to index the offset and length of each
+message exactly (even excluding the dlist wrapper), but this is rather
+complicated by the dlist API.
+
+For now, we just index the offset of the dlist entry for the message,
+and we can parse the pure message data back out later from that, when
+we need to.  Slightly less efficient on reads, but works->good->fast.
+We need to loop over the entries in the MESSAGE dlist to find the one
+with the desired GUID.
+
+The indexed length needs to be the length of the message, not the
+length of the dlist wrapper, because we need to know this cheaply to
+supply RECORDs in MAILBOX responses.
+
+
+renames
+=======
+
+APPLY RENAME %(OLDMBOXNAME old NEWMBOXNAME new PARTITION p UIDVALIDITY
+123)
+
+We identify mboxes by uniqueid, so when we start seeing sync data for
+the same uniqueid with a new mboxname we just transparently update it
+anyway, without needing to handle the APPLY RENAME.  Not sure if this
+is a problem...  Do we need to record an mbox's previous names
+somehow?
+
+I think it's possible to use this to rename a USER though, something
+like:
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.smithj NEWMBOXNAME
+example.com!user.jsmith ...)
+
+-- in which case, without special handling of the RENAME command
+itself, there will be a backup for the old user that ends with the
+RENAME, and a backup of the new user that (probably) duplicates
+everything again (except for stuff that's been expunged).
+
+And if someone else gets given the original name, like
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.samantha-mithj NEWMBOXNAME
+example.com!user.smithj ...)
+
+Then anything that was expunged from the original user but still
+available in backup disappears?  Or the two backups get conflated, and
+samantha can "restore" the original smithj's old mail?
+
+Uggh.
+
+if there's a mailboxes database pointing to the backup files, then the
+backup file names don't need to be based on the userid, they could
+e.g. be based on the user's inbox's uniqueid.  this would make it
+easier to deal with user renames because the backup filename wouldn't
+need to change.  but this depends on the uniqueid(s) in question being
+present on most areas of the sync protocol, otherwise when starting a
+backup of a brand new user we won't be able to tell where to store it.
+workaround in the meantime could be to make some kind of backup id
+from the mailboxes database, and base the filename on this.
+
+actually, using "some kind of backup id from the mailboxes database"
+is probably the best solution.  otherwise the lock complexity of
+renaming a user while making sure their new backup filename doesn't
+already exist is frightful.
+
+maybe do something with mkstemp()?
+
+furthermore: what if a mailbox is moved from one user to another?
+like:
+
+APPLY RENAME %(OLD... example.com!user.foo.something NEW...
+example.com!user.bar.something ...)
+
+when a different-uid rename IS a rename of a user (and not just a
+folder being moved to a different user), what does it look like? *
+does it do a single APPLY RENAME for the user, and expect their
+folders to shake out of that? * does it do an APPLY RENAME for each of
+their folders?
+
+in the latter case, we need to append each of those RENAMEs to the old
+backup so they can take effect correctly, and THEN rename the backup
+file itself. but how to tell when the appends are finished?
+
+how can we tell the difference between folder(s) moved to a different
+user vs user has been renamed?
+
+there is a setting: 'allowusermoves: 0' which, when enabled, allows
+users to be renamed via IMAP rename/xfer commands.  but the default is
+that this is disabled.  we could initially require this to be disabled
+while using backups...
+
+not sure what the workflow looks like for renaming a user if this is
+not enabled.
+
+not sure what the sync flow looks like in either case.
+
+looking at sync_apply_rename and mboxlist_renamemailbox, it seems like
+we'll see an APPLY RENAME for each affected mbox when a recursive
+rename is occurring.
+
+there doesn't seem to be anything preventing user/a/foo -> user/b/foo
+in the general (non-INBOX) case.
+
+renames might be a little easier to handle if the index replicated the
+mailbox hierarchy rather than just being a flat structure.  though
+this adds complexity wrt hiersep handling.  something like:
+
+mailbox:
+
+   mboxname
+      # just the name of this mbox
+
+   parent_id
+      # fk to parent mailbox
+
+   full_mboxname
+      # cached value, parent.full_mboxname + mboxname
+
+
+locking
+=======
+
+just use a normal flock/fcntl lock on the data file and only open the
+index if that lock succeeded
+
+* backup:   needs to append foo and update foo.index
+
+* reindex:  only needs to read foo, but needs a write lock to
+  prevent
+
+     writes while it does so. needs to write to (replace) foo.index
+
+* compact:  needs to re-write foo and foo.index
+
+* restore:  needs to read
+
+
+verifying index
+===============
+
+how to tell whether the .index file is the correct one for the backup
+data it ostensibly represents?
+
+one way to do this would be to have backup_index_end() store a
+checksum of the corresponding data contents in the index.
+
+when opening a backup, verify this checksum against the data, and
+refuse to load the index if it doesn't match.
+
+* sha1sum of (compressed) contents of file prior to each chunk
+
+how to tell whether the chunk data is any good?  store a checksum of
+the chunk contents along with the rest of the chunk index
+
+* sha1sum of (uncompressed) contents of each chunk
+
+
+mailboxes database
+==================
+
+bron reckons use twoskip for this userid -> backup_filename
+
+lib/cyrusdb module implements this, look into that
+
+look at conversations db code to see how to use it
+
+need a tool: * given a user, show their backup filename * dump/undump
+* rebuild based on files discovered in backup directory
+
+where does this fit into the locking scheme?
+
+
+reindex
+=======
+
+* convert user mailbox name to backup name
+
+* complain if there's no backup data file?
+
+* lock, rename .index to .index.old, init new .index
+
+* foreach file chunk:
+
+* timestamp is from first line in chunk
+
+* complain if timestamp has gone backwards?
+
+* index records from chunk
+
+* unlock
+
+* clean up .index.old
+
+on error: * discard partial new index * restore .index.old * bail out
+
+
+backupd
+=======
+
+cmdloop: * (periodic cleanup) * read command, determine backup name *
+already holding lock ? bump timestamp : obtain lock * write data to
+gzname, flush immediately * index data
+
+periodic cleanup: * check timestamp of each held lock * if stale
+(define: stale?), release * FIXME if we've appended more than the
+chunk size we would compact to, release
+
+sync restart: * release each held lock
+
+exit: * release each held lock
+
+need a "backup_index_abort" to complete the backup_index_start/end
+set. _start should create a transaction, _end should commit it, and
+_abort should roll it back.  then, if backupd fails to write to the
+gzip file for some reason, the (now invalid) index info we added can
+be discarded too.
+
+flushing immediately on write results in poor gzip compression, but
+for incremental backups that's not a problem.  when the compact
+process hits the file it will recompress the data more efficiently.
+
+
+questions
+=========
+
+* what does it look like when uidvalidity changes?
+
+
+restore
+=======
+
+restoration is effectively a reverse-direction replication
+(replicating TO master), which means we can't necessarily supply
+things like uid, modseq, etc without racing against normal message
+arrivals.  so instead we add an extra command to the protocol to
+restore a message to a folder but let the destination determine the
+tasty bits.
+
+protocol flow looks something like:
+
+c: APPLY RESERVE ... # as usual s: * MISSING (foo bar) s: OK c: APPLY
+MESSAGE ... # as usual s: OK c: RESTORE MAILBOX ... # new sync proto
+command s: OK
+
+we introduce a new command, RESTORE MAILBOX, which is similar to the
+existing APPLY MAILBOX.  it specifies, for a mailbox, the mailbox
+state plus the message records relevant to the restore.
+
+the imapd/sync_server receiving the RESTORE command creates the
+mailbox if necessary, and then adds the message records to it as new
+records (i.e. generating new uid etc). this will end up generating new
+events in the backup channel's sync log, and then the messages will be
+backed up again with their new uids, etc.  additional wire transfer of
+message data should be avoided by keeping the same guid.
+
+if the mailbox already exists but its uniqueid does not match the one
+from the backup, then what?  this probably means user has deleted
+folder and contents, then made new folder with same name.  so it's
+probably v common for mailbox uniqueid to not match like this.  so we
+don't care about special handling for this case.  just add any
+messages that aren't already there.
+
+if the mailbox doesn't already exist on the destination (e.g. if
+rebuilding a server from backups) then it's safe and good to reuse
+uidvalidity, uniqueid, uid, modseq etc, such that connecting clients
+can preserve their state.  so the imapd/sync_server receiving the
+restore request accepts these fields as optional, but only preserves
+them if it's safe to do so.
+
+* restore: sbin program for selecting and restoring messages
+
+restore command needs options: + whether or not to trim deletedprefix
+off mailbox names to be restored + whether or not to restore uniqueid,
+highestmodseq, uid and so on + whether or not to limit to/exclude
+expunged messages + whether or not to restore sub-mailboxes +
+sync_client-like options (servername, local_only, partition, ...) +
+user/mailbox/backup file(s) to restore from + mailbox to restore to
+(override location in backup) + override acl?
+
+can we heuristically determine whether an argument is an mboxname,
+uniqueid or guid?
+   => libuuid uniqueid is 36 bytes of hyphen (at fixed positions) and
+   hex digits => non-libuuid uniqueid is 24 bytes of hex digits =>
+   mboxname usually contains at least one . somewhere => guid is 40
+   bytes of hex digits
+
+usage:
+   restore [options] server [mode] backup [mboxname | uniqueid |
+   guid]...
+
+options:
+   -A acl
+
+   # apply specified acl to restored mailboxes
+
+   -C alt_config
+
+   # alternate config file
+
+   -D
+
+   # don't trim deletedprefix before restoring
+
+   -F input-file
+
+   # read mailboxes/messages from file rather than argv
+
+   -L
+
+   # local mailbox operations only (no mupdate)
+
+   -M mboxname
+
+   # restore messages to specified mailbox
+
+   -P partition
+
+   # restore mailboxes to specified partition
+
+   -U
+
+   # try to preserve uniqueid, uid, modseq, etc
+
+   -X
+
+   # don't restore expunged messages
+
+   -a
+
+   # try to restore all mailboxes in backup
+
+   -n
+
+   # calculate work required but don't perform restoration
+
+   -r
+
+   # recurse into submailboxes
+
+   -v
+
+   # verbose
+
+   -w seconds
+
+   # wait before starting (useful for attaching a debugger)
+
+   -x
+
+   # only restore expunged messages (not sure if useful?)
+
+   -z
+
+   # require compression (abort if compression unavailable)
+
+mode:
+   -f
+
+   # specified backup interpreted as filename
+
+   -m
+
+   # specified backup interpreted as mboxname
+
+   -u
+
+   # specified backup interpreted as userid (default)
+
+
+compact
+=======
+
+# finding messages that are to be kept (either exist as unexpunged
+somewhere, # or exist as expunged but more recently than threshold) #
+(to get unique rows, add "distinct" and remove mm.expunged from
+fields) sqlite> select m.*, mm.expunged from message as m join
+mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null
+or mm.expunged > 1437709300);
+id|guid|partition|chunk_id|offset|length|expunged
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159| 1|1c7c
+ca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047 1|
+1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+
+# finding chunks that are still needed (due to containing last state #
+of mailbox or mailbox_message, or containing a message) sqlite> select
+* from chunk where id in (select last_chunk_id from mailbox where
+deleted is null or deleted > 1437709300 union select last_chunk_id
+from mailbox_message where expunged is null or expunged > 1437709300
+union select chunk_id from message as m join mailbox_message as mm on
+m.id = mm.message_id and (mm.expunged is null or mm.expunged >
+1437709300)); id|timestamp|offset|length|file_sha1|data_sha1 1|143770
+9276|0|3397|da39a3ee5e6b4b0d3255bfef95601890afd80709|6836d0110252d08a
+0656c14c2d2d314124755491 3|1437709355|1977|2129|fee183c329c011ead7757
+f59182116500776eaaf|a5677cfa1f5f7b627763652f4bb9b99f5970748c 4|143770
+9425|2746|1719|3d9f02135bf964ff0b6a917921b862c3420e48f0|7b64ec3214577
+15ee61fe238f178f5d72adaef64 5|1437709508|3589|2890|0cee599b1573110fee
+428f8323690cbcb9589661|90d104346ef3cba9e419461dd26045035f4cba02
+
+remember: a single APPLY MESSAGE line can contain many messages!
+
+thoughts:
+
+* need a heuristic for quickly determining whether a backup needs to
+  be compacted
+
+     * sum(chunks to discard, chunks to combine, chunks to split) >
+       threshold
+
+     * can we detect chunks that are going to significantly reduce
+       in size as result of discarding individual lines?
+
+* "quick" vs "full" compaction
+
+settings:
+
+* backup retention period
+
+* chunk combination size (byte length or elapsed time)
+
+combining chunks: * size threshold below which adjacent chunks can be
+joined * size threshold above which chunks should be split * duration
+threshold below which adjacent chunks can be joined * duration
+threshold above which chunks should be split backup_min_chunk_size: 0
+for no minimum backup_max_chunk_size: 0 for no maximum
+backup_min_chunk_duration: 0 for no minimum backup_max_chunk_duration:
+0 for no maximum priority: size or duration??
+
+data we absolutely need to keep:
+
+* the most recent APPLY MAILBOX for each mailbox we're keeping
+  (mailbox state)
+
+* the APPLY MAILBOX containing the most recent RECORD for each
+  message we're keeping (record state)
+
+* the APPLY MESSAGE for each message we're keeping (message data)
+
+data that we should practically keep:
+
+* all APPLY MAILBOXes for a given mailbox from the chunk identified
+  as its last
+
+* all APPLY MAILBOXes containing a RECORD for a given message from
+  the chunk identified as its last
+
+* the APPLY MESSAGE for each message we're keeping
+
+four kinds of compaction (probably at least two simultaneously):
+
+* removing unused chunks
+
+* combining adjacent chunks into a single chunk (for better gz
+  compression)
+
+* removing unused message lines from within a chunk (important after
+  combining)
+
+* removing unused messages from within a message line
+
+"unused messages"
+   messages for which all records have been expunged for longer than
+   the retention period
+
+"unused chunks"
+   chunks which contain only unused messages
+
+algorithm:
+
+* open (and lock) backup and backup.new (or bail out)
+
+* use backup index to identify chunks we still need
+
+* create a chunk in backup.new
+
+* foreach chunk we still need:
+
+* foreach line in the chunk:
+
+* next line if we don't need to keep it
+
+* create new line
+
+* foreach message in line:
+
+* if we still need the message, or if we're not doing message
+  granularity
+
+* add the message to the new line
+
+* write and index tmp line to backup.new
+
+* if the new chunk is big enough, or if we're not combining
+
+* end chunk and start a new one
+
+* end the new chunk
+
+* rename backup->backup.old, backup.new->backup
+
+* close (and unlock) backup.old and backup
+
+
+command line locking utility
+============================
+
+command line utility to lock a backup (for e.g. safely poking around
+in the .index on a live system).
+
+example failure: $ctl_backups lock -f /path/to/backup * Trying to
+obtain lock on /path/to/backup... NO some error <EOF>
+
+example success: $ctl_backups lock -f /path/to/backup * Trying to
+obtain lock on /path/to/backup... [potentially a delay here if we need
+to wait for another process to release the lock] OK locked [waits for
+its stdin to close, then unlocks and exits]
+
+if you need to rummage around in backup.index, run this program in
+another shell, do your work, then ^D it when you're finished.
+
+you could also call this from e.g. perl over a bidirectional pipe -
+wait to read "OK locked", then you've got your lock.  close the pipe
+to unlock when you're finished working.  if you don't read "OK locked"
+before the pipe closes then something went wrong and you didn't get
+the lock.
+
+specify backups by -f filename, -m mailbox, -u userid default run mode
+as above -s to fork an sqlite of the index (and unlock when it exits)
+-x to fork a command of your choosing (and unlock when it exits)
+
+
+reconstruct
+===========
+
+rebuilding backups.db from on disk files
+
+scan each backup partition for backup files:
+   * skip timestamped files (i.e. backups from compact/reindex)
+
+   * skip .old files (old backups from reindex)
+
+   * .index files => skip???
+
+   * skip unreadable files
+
+   * skip empty files
+
+   * skip directories etc
+
+what's the correct procedure for repopulating a cyrus database? keep
+copy of the previous (presumably broken) one?
+
+trim off mkstemp suffix (if any) to find userid can we use a
+recognisable character to delimit the mkstemp suffix?
+
+what if there's multiple backup files for a given userid? precedence?
+
+verify found backups before recording.  reindex?
+
+locking? what if something has a filename and does stuff with it while
+reconstruct runs?
+
+backupd always uses db for opens, so as long as reconstruct keeps the
+db locked while it works, the db won't clash.  but backupd might have
+backups still open from before reconstruct started, which it will
+write to quite happily, even though reconstruct might decide that some
+other file is the correct one for that user...
+
+a backup server would generally be used only for backups, and
+sync_client is quite resilient when the destination isn't there, so
+it's actually no problem to just shut down cyrus while reconstruct
+runs.  no outage to user-facing services, just maybe some sync backlog
+to catch up on once cyrus is restarted.
+
+
+ctl_backups
+===========
+
+sbin tool for mass backup/index/database operations
+
+needs:
+   * rebuild backups.db from disk contents
+
+   * list backups/info
+
+   * rename a backup
+
+   * delete a backup
+
+   * verify a backup (check all sha1's, not just most recent)
+
+not sure if these should be included, or separate tools:
+   * reindex a backup (or more)
+
+   * compact a backup (or more)
+
+   * lock a backup
+
+   * some sort of rolling compaction?
+
+usage:
+   ctl_backups [options] reconstruct                       #
+   reconstruct backups.db from disk files ctl_backups [options] list
+   [list_opts] [[mode] backup...] # list backup info for given/all
+   users ctl_backups [options] move new_fname [mode] backup      #
+   rename a backup (think about this more) ctl_backups [options]
+   delete [mode] backup              # delete a backup ctl_backups
+   [options] verify [mode] backup...           # verify specified
+   backups ctl_backups [options] reindex [mode] backup...          #
+   reindex specified backups ctl_backups [options] compact [mode]
+   backup...          # compact specified backups ctl_backups
+   [options] lock [lock_opts] [mode] backup    # lock specified backup
+
+options:
+   -C alt_config
+
+   # alternate config file
+
+   -F
+
+   # force (run command even if not needed)
+
+   -S
+
+   # stop on error
+
+   -v
+
+   # verbose
+
+   -w
+
+   # wait for locks (i.e. don't skip locked backups)
+
+mode:
+   -A
+
+   # all known backups (not valid for single backup commands)
+
+   -D
+
+   # specified backups interpreted as domains (nvfsbc)
+
+   -P
+
+   # specified backups interpreted as userid prefixes (nvfsbc)
+
+   -f
+
+   # specified backups interpreted as filenames
+
+   -m
+
+   # specified backups interpreted as mboxnames
+
+   -u
+
+   # specified backups interpreted as userids (default)
+
+lock_opts:
+   -c
+
+   # exclusively create backup
+
+   -s
+
+   # lock backup and open index in sqlite
+
+   -x cmd
+
+   # lock backup and execute cmd
+
+   -p
+
+   # lock backup and wait for eof on stdin (default)
+
+list_opts:
+   -t [hours]          # "stale" (no update in hours) backups only
+   (default: 24)
+
+
+cyr_backup
+==========
+
+sbin tool for inspecting backups
+
+needs:
+   * better name?
+
+   * list stuff
+
+   * show stuff
+
+   * dump stuff
+
+   * restore?
+
+* should lock/move/delete (single backup commands) from ctl_backups
+  be moved here?
+
+usage:
+   cyr_backup [options] [mode] backup list [all | chunks | mailboxes |
+   messages]... cyr_backup [options] [mode] backup show chunks [id...]
+   cyr_backup [options] [mode] backup show messages [guid...]
+   cyr_backup [options] [mode] backup show mailboxes [mboxname |
+   uniqueid]... cyr_backup [options] [mode] backup dump [dump_opts]
+   chunk id cyr_backup [options] [mode] backup dump [dump_opts]
+   message guid cyr_backup [options] [mode] backup json [chunks |
+   mailboxes | messages]...
+
+options:
+   -C alt_config
+
+   # alternate config file
+
+   -v
+
+   # verbose
+
+mode:
+   -f
+
+   # backup interpreted as filename
+
+   -m
+
+   # backup interpreted as mboxname
+
+   -u
+
+   # backup interpreted as userid (default)
+
+commands:
+   list: table of contents, one per line show: indexed details of
+   listed items, one per paragraph, detail per line dump: relevant
+   contents from backup stream json: indexed details of listed items
+   in json format
+
+dump options:
+   -o filename
+
+   # dump to named file instead of stdout
+
+
+partitions
+==========
+
+not enough information in sync protocol to handle partitions easily?
+
+we know what the partition is when we do an APPLY operation (mailbox,
+message, etc), but the initial GET operations don't include it.  so we
+need to already know where the appropriate backup is partitioned in
+order to find the backup file in order to look inside it to respond to
+the GET request
+
+if we have a mailboxes database (indexed by mboxname, uniqueid and
+userid) then maybe that would make it feasible?  if it's not in the
+mailboxes database then we don't have a backup for it yet, so we
+respond accordingly, and get sent enough information to create it.
+
+does that mean the backup api needs to take an mbname on open, and it
+handles the job of looking it up in the mailboxes database to find the
+appropriate thing to open?
+
+can we use sqlite for such a database, or is the load on it going to
+be too heavy?  locking?  we have lots of database formats up our
+sleeves here, so even though we use sqlite for the backup index there
+isn't any particular reason we're beholden to it for the mailboxes db
+too
+
+if we have a mailboxes db then we need a reconstruct tool for that,
+too
+
+what if we support multiple backup partitions, but don't expect these
+to necessarily correspond with mailbox partitions.  they're just for
+spreading disk usage around.
+
+* when creating a backup for a previously-unseen user we'd pick a
+  random partition to put them on
+
+* ctl_backups would need a command to move an existing backup to a
+  given partition
+
+* ctl_backups would need a command to pre-create a user backup on a
+  given partition for initial distribution
+
+* instead of "backup_data_path" setting, have one-or-more
+  "backuppartition-<name>" settings, ala partition- and friends
+
+see imap/partlist.[ch] for partition list management stuff.  it's
+complicated and doesn't have a test suite, so maybe save this
+implementation until needed.
+
+but... maybe rename backup_data_path to backuppartition-default in the
+meantime, so that when we do add this it's not a complicated reconfig
+to update?
+
+partlist_local_select (and lazy-loaded partlist_local_init) are where
+the mailbox partitions come from (see also mboxlist_create_partition),
+do something similar for backup partitions
+
+
+data corruption
+===============
+
+backups.db:
+   * can be reconstructed from on disk files at any time
+
+   * how to detect corruption? does cyrus_db detect/repair on its
+     own?
+
+backup indexes:
+   * can be reindexed at any time from backup data
+
+   * how to detect corruption? assume sqlite will notice, complain?
+
+backup data:
+   * what's zlib's failure mode? do we lose the entire chunk or just
+     the corrupt bit?
+
+   * verify will notice sha1sum mismatches
+
+   * dlist format will reject some kinds of corruption (but not all)
+
+   * reindex: should skip unparseable dlist lines
+
+   * message data has its own checksums (guid)
+
+   * reindex: should skip messages that don't match their own
+     checksums
+
+   * compact: "full" compact will only keep useful data according to
+     index
+
+   * backupd: will sync anything that's in user mailbox but not in
+     backup index
+
+i think this means that if a message or mailbox state becomes
+corrupted in the backup data file, and it still exists in the user's
+real mailbox, you recover from the corruption by reindexing and then
+letting the sync process copy the missing data back in again.  and you
+can tidy up the data file by running a compact over it.
+
+you detect data corruption in most recent chunk reactively as soon as
+the backup system needs to open it again (quick verify on open)
+
+you detect data corruption in older chunks reactively by trying to
+restore from it.  may be too late: if a message needs restoring it's
+because user mailbox no longer has it
+
+you detect data corruption preemptively by running the verify tool
+over it. recommend scheduling this in EVENTS/cron?
+
+if data corruption occurs in message that's no longer in user's
+mailbox, that message is lost.  it was going to be deleted from the
+backup after $retention period anyway (by compact), but if it needs
+restoring in the meantime, sorry
+
+
+installation instructions
+=========================
+
+(obviously, most of this won't work at this point, because the code
+doesn't exist.  but this is, approximately, where things are heading.)
+
+on your backup server:
+   * compile with --enable-backup configure option and install
+
+   * imapd.conf:
+
+        backuppartition-default: /var/spool/backup  # FIXME better
+        example backup_db: twoskip backup_db_path:
+        /var/imap/backups.db backup_staging_path: /var/spool/backup
+        backup_retention_days: 7
+
+   * cyrus.conf SERVICES:
+
+        backupd cmd="backupd" listen="csync" prefork=0 (remove other
+        services, most likely) (should i create a
+        master/conf/backup.conf example file?)
+
+   * cyrus.conf EVENTS:
+
+        compact cmd="ctl_backups compact -A" at=0400
+
+   * start server as usual
+
+   * do i want a special port for backupd?
+
+on your imap server:
+   * imapd.conf:
+
+        sync_log_channels: backup sync_log: 1 backup_sync_host:
+        backup-server.example.com backup_sync_port: csync
+        backup_sync_authname: ... backup_sync_password: ...
+        backup_sync_repeat_interval: ... # seconds, smaller value =
+        livelier backups but more i/o backup_sync_shutdown_file: ....
+
+   * cyrus.conf STARTUP:
+
+        backup_sync cmd="sync_client -r -n backup"
+
+   * cyrus.conf SERVICES:
+
+        restored cmd="restored" [...]
+
+   * start/restart master
+
+files and such:
+   {configdirectory}/backups.db                        - database
+   mapping userids to backup locations {backuppartition-
+   name}/<hash>/<userid>_XXXXXX       - backup data stream for userid
+   {backuppartition-name}/<hash>/<userid>_XXXXXX.index - index into
+   userid's backup data stream
+
+do i want rhost in the path?
+   * protects from issue if multiple servers are trying to back up
+     their own version of same user (though this is its own problem
+     that the backup system shouldn't have to compensate for)
+
+   * but makes location of undifferentiated user unpredictable
+
+   * so probably not, actually
+
+
+chatting about implementation 20/10
+===================================
+
+   09:54 @elliefm
+   here's a fun sync question
+   APPLY MESSAGE provides a list of messages
+   can a single APPLY MESSAGE contain messages for multiple mailboxes and/or users?
+   my first hunch is that it doesn't cross users, since the broadest granularity for a single sync run is USER
+   10:06 kmurchison
+   We'd have to check with Bron, but I *think* messages can cross mailboxes for a single user
+   10:06 @brong
+   yes
+   APPLY MESSAGE just adds it to the reserve list
+   10:07 @elliefm
+   nah apply message uploads the message, APPLY RESERVE adds it to the reserve list :P
+   10:07 @brong
+   same same
+   APPLY RESERVE copies it from a local mailbox
+   APPLY MESSAGE uploads it
+   10:07 @elliefm
+   yep
+   10:07 @brong
+   they both wind up in the reserve list
+   10:07 @elliefm
+   ahh i see what you mean, gotcha
+   10:07 @brong
+   until you send a RESTART
+   ideally you want it reserve in the same partition, but it will copy the message over if it's not on the same partition
+   there's no restriction on which mailbox it came from/went to
+   good for user renames, and good for an append to a bunch of mailboxes in different users / shared space all at once
+   (which LMTP can do)
+   10:10 @elliefm
+   i can handle the case where a single APPLY MESSAGE contains messages for multiple mailboxes belonging to the same user
+   but i'm in trouble if a single APPLY MESSAGE can contain messages belonging to different users
+   10:14 @brong
+   @elliefm: why?
+   10:14 @brong
+   you don't have to keep them if they aren't used
+   10:15 @elliefm
+   for backups - when i see the apply, i need to know which user's backup to add it to.  that's easy enough if it doesn't cross users but gets mega fiddly if it does
+   i'm poking around in sync client to see if it's likely to be an issue or not
+   11:00 @brong_
+   @elliefm: I would stage it, and add it to users as it gets refcounted in by an index file
+   11:07 @elliefm
+   that's pretty much what we do for ordinary sync and delivery stuff yeah?
+   11:08 @brong_
+   yep
+   and it's what the backup thing does
+   11:09 @elliefm
+   i'm pretty sure that APPLY RESERVE and APPLY MESSAGE don't give a damn about users, they're just "here's every message you might not have already had since last time we spoke" and it lets the APPLY MAILBOX work out where to attach them later
+   11:09 @brong_
+   yep
+   11:09 @elliefm
+   so yeah, i'll need to do something here
+   i've been working so far on the idea that a single user's backup consists of 1) an append-only gzip stream of the sync protocol chat that built it, and 2) an index that tracks current state of mailboxes, and offsets within (1) of message data
+   that gets us good compression (file per user, not file per message), and if the index gets corrupted or lost, it's rebuildable purely from (1), it doesn't need a live copy of the original mailbox
+   11:12 @brong
+   yep, that all works
+   11:12 @elliefm
+   (so if you lose your imap server, you're not unable to rebuild a broken index on the backup)
+   11:13 @brong
+   it's easy enough to require the sync protocol stream to only contain messages per user
+   though "apply reserve" is messy
+   because you need to return "yes, I have that message"
+   11:13 @elliefm
+   with that implementation i can't (easily) keep user.a's messages from not existing in user.b's data stream (though they won't be indexed)
+   11:14 @brong
+   I'm not too adverse to the idea of just unpacking each message as it comes off the wire into a temporary directory
+   11:14 @elliefm
+   (because at the time i'm receiving the sync data i don't know which it needs to go in, so if they come in in the same reserve i'd need to append them to both data streams)
+   which isn't a huge problem, just… irks me a bit
+   11:14 @brong
+   and then reading the indexes as they come in, checking against the state DB to see if we already have them, and streaming them into the gzip if they aren't there yet
+   what we can do is something like the current format, where files go into a tar
+   11:16 @elliefm
+   i guess the fiddly bit there is that there's one more moving part to keep synchronised across failure states
+   a backup for a single user becomes 1) data stream + 2) any messages that were uploaded but not yet added to a mailbox + 3) index (which doesn't know what to do with (2))
+   which in the general case is fine, the next sync will update the mailboxes, which will push (2) into (1) and index it nicely, and on we go
+   but it's just a little bit more mess if there's a failure that you need to recover from between those states — it's no longer a simple case of "it's in the backup and we know everything about it" or "it doesn't exist", there's a third case of "well we might have the data but don't really know what to do with it"
+   the other fiddly bit is that the process of appending to the data stream is suddenly in the business of crafting output rather than simply dumping what it gets, which isn't really burdensome, but it is one more little crack for bugs to crawl into
+   i guess in terms of sync protocol, one thing i could do on my end is identify apply operations that seem to contain multiple users' data, and just return an error on those.  the sync client on the other end will promote them until they're eventually user syncs, which i think are always user granularity
+   11:50 @elliefm
+   i think for now, first stage implementation will be to stream the reserve/message commands in full to every user backup they might apply to.  and optimising that down so that each stream only contains messages belonging to that user can be a future optimisation
+
+
+todo list
+=========
+
+* clean up error handling
+
+* perl tool to anonymise sync proto talk
+
+* verification step to check entire data stream for errors (even
+  chunks that aren't indexed)
+
+* prot_fill_cb: extra argument to pass back an error string to
+  prot_fill
+
+* ctl_backups verify: set level
+
+* backupd: don't block on locked backups, return mailbox locked --
+  but sync_client doesn't handle this
+
+* test multiple backup partitions
+
+* configure: error if backups requested and we don't have zlib
+
+* valgrind
+
+* finish reconstruct
+
+* compact: split before append?
+
+compact implementation steps:
+   1 remove unused chunks, keep everything else as is 2 join adjacent
+   chunks if small enough, split large chunks 3 parse/rebuild message
+   lines 4 discard unused mailbox lines
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/bytecode.txt 3.2.0-3/doc/text/imap/developer/thoughts/bytecode.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/bytecode.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/bytecode.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,156 @@
+
+Cyrus IMAP Server: Sieve Bytecode
+*********************************
+
+
+Motivation
+==========
+
+The motivation behind moving to Sieve Bytecode is severalfold:
+
+* Parsing a script at each execution is expensive computationally
+
+* Lex/Yacc are costly in terms of memory usage and executable size,
+  whereas a bytecode parser is much lighter weight.
+
+* Using bytecode can simplify the code for the execution phase,
+  which is far more frequently occurring than the upload/compile
+  phase.
+
+* Rewriting a significant part of the sieve execution framework
+  forces a decent amount of refactoring on what has traditionally been
+  a problematic part of the Cyrus code base. There is still work to do
+  in this area.
+
+
+Overall Bytecode Format
+=======================
+
+In the final bytecode, each opcode/parameter is aligned on a 4-byte
+boundary. Strings are NUL-terminated (and padded to a 4-byte boundary
+as needed).
+
+Ideally, we'd have all integers in network byte order, so as to make
+the scripts portable, but version 1 does not have this feature.
+
+At the beginning of the file, there is a magic header to identify it
+as a bytecode file, and a 4 byte version number. Immediately following
+the version number are the opcodes that relate to the script.
+
+
+Generation
+==========
+
+A Sieve Bytecode file is generated in three "passes":
+
+* Generate a parse tree using lex/yacc from the sieve script.
+  (addr.y, addr-lex.l, sieve.y, sieve-lex.l).
+
+* Serialize the parse tree into an intermediate form, where strings
+  are held separate from the rest of the representation.
+  (bc_generate.c)
+
+* Serialize the intermediate form into the final bytecode.
+  (bc_emit.c)
+
+The intermediate form is an array of bytecode_t unions, with strings
+located elsewhere in memory. The entry point is bc_generate:
+sieve_generate_bytecode() / bc_action_generate().
+
+bc_action_generate traverses the commandlist_t tree and emits opcodes
+in sequence.
+
+Simple actions (STOP, DISCARD, KEEP, MARK, UNMARK) have no arguments,
+and processing proceeds directly.
+
+More complicated options have a sequence of arguments that are emitted
+following the initial opcode.
+
+For example, single argument commands such as REJECT, FILEINTO,
+REDIRECT are followed by a bytecode_t for a string's length, and then
+a bytecode_t which contains a pointer to a string.
+
+Commands such as ADDFLAG, SETFLAG, REMOVEFLAG, which take a
+stringlist, format the stringlist as (using bc_stringlist_generate):
+
+   {Number of Strings}{String 1 Length}{String 1 Ptr}{String 2 Length}....
+
+So their resulting final output would appear as:
+
+   {Opcode}{...stringlist from above...}
+
+Even more complicated action opcodes (vacation, notify) etc, may take
+a sequence of integer values (flags), stringlists, or individual
+strings. These are more specifically documented in the code.
+
+This leaves us with the IF keyword (and tests). In the pass 1 form, IF
+appears as the following bytecode_t structures:
+
+   {IF opcode}
+   {Beginning of the then block}
+   {End of the then block / beginning of the else block}
+   {End of the else block / -1 for no else block}
+   {....test opcodes....}
+   {....'then' action opcodes....}
+   {....'else' action opcodes.... [optional]}
+
+Test opcodes are generated by the bc_test_generate function, which is
+very similar to bc_action_generate (tests without arguments are just
+opcodes, tests with arguments have them serialized into place directly
+following the original opcode). Test lists are represented as {number
+of tests}{address of the end of the list}{test 1}{test 2}.
+
+In the third pass, strings are serialized into place, and if statement
+jumps are resolved to actual addresses within the file This is done in
+bc_emit: sieve_emit_bytecode / bc_action_emit.
+
+This results in a totally serialized representation, using byte
+offsets within the file instead of indexes into the array of
+bytecode_t's. In addition to the manipulations that are necessary to
+do this, there are several other changes in format.
+
+Two new opcodes exist: NULL and JUMP (which performs an unconditional
+jump).
+
+Stringlists and testslists now include a precomputed byte length of
+the entire list, so it can be skipped over as needed.
+
+So as to be executable without a stack, the IF statements are designed
+as follows:
+
+   {IF opcode}
+   {....test block....}
+   {JUMP (location of false condition) }
+   {....then block....}
+   {(if there is an else) JUMP (end of else block)}
+   {(if there is an else) .... else block ....}
+
+The idea being that if the test is true, the instruction pointer
+should move to the then block, otherwise the else block will be hit
+automatically (due to the unconditional jump).
+
+
+Evaluation
+==========
+
+The evaluation routines are in bc_eval.c, the basic idea is that we
+can simply mmap the bytecode, run straight through it, and complete
+the processing without maintaining a stack.
+
+The processing is done by overlaying a bytecode_input_t array over the
+mmap. This allows addressing elements within the file to be simple.
+There is an instruction pointer which is incremented as each action is
+performed, or as actions/tests are skipped.
+
+Of special note in bc_eval.c is the unwrap_string function which will
+pull a string out of the bytecode, and return the instruction pointer
+at the end of the string.
+
+
+Other things to consider
+========================
+
+The Bytecode can be extended to contain other extensions. This could
+require regeneration of older scripts. In many cases this can be
+avoided by putting the new commands at the end of the proper enum in
+bytecode.h
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/caldav_scheduling_flowchart.txt 3.2.0-3/doc/text/imap/developer/thoughts/caldav_scheduling_flowchart.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/caldav_scheduling_flowchart.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/caldav_scheduling_flowchart.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,424 @@
+
+Cyrus CalDAV Scheduling Flowchart
+*********************************
+
+
+caldav_put() - create/modify via HTTP PUT on a resource or POST (add-member) on a calendar
+==========================================================================================
+
+1. Check if the new resource is a scheduling resource (contains
+   ORGANIZER property). If not, skip to step 4.
+
+2. Check for (and load) any existing resource.
+
+3. Check if the authenticated user matches ORGANIZER:
+
+   * If yes:
+
+     * If only voter (VPOLL) responses changed, goto
+       sched_pollstatus().
+
+     * Otherwise, goto sched_request().
+
+   * Otherwise, goto sched_reply().
+
+4. Store the new/modified resource.
+
+
+caldav_delete_sched() - remove via HTTP DELETE on a resource
+============================================================
+
+1. Check if the existing resource is a scheduling resource (has
+   Schedule-Tag). If not, we are done.
+
+2. Load the existing resource.
+
+3. Check if the authenticated user matches ORGANIZER. If yes, goto
+   sched_request(), otherwise goto sched_reply().
+
+
+caldav_post() - busytime query via HTTP POST on Scheduling Outbox
+=================================================================
+
+1. Check the ACL on the owner's Scheduling Outbox. If the
+   authenticated user doesn't have the DACL_SCHEDFB right, fail.
+
+2. sched_busytime_query().
+
+======================================================================
+
+
+sched_pollstatus - perform a voter response update
+==================================================
+
+======================================================================
+
+
+sched_request() - perform an organizer request / attendee status update
+=======================================================================
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL_INVITE right, fail.
+
+If the request includes a resource, then set METHOD:REQUEST, otherwise
+set METHOD:CANCEL.
+
+Create an iTIP message template, copying over any CALSCALE property
+and VTIMEZONE components.
+
+If not an attendee status update and the existing resource is a
+scheduling resource: Foreach component in the existing resource, add
+it and its SEQUENCE to our hash table keyed by RECURRENCE-ID (for
+comparison against new/modified resource).
+
+Create a hash table of attendees. This will hold attendee-specific
+iTIP messages.
+
+Foreach component in the new/modified resource:
+
+1. Lookup (by RECURRENCE-ID) and remove the component from the hash
+   table of existing components.
+
+2. If the component exists compare all of DTSTART, DTEND, DURATION,
+   RRULE, RDATE, EXDATE to those of the new component.
+
+3. If the component is new or changed, then process_attendees().
+
+Foreach remaining component in the hash table of existing components
+do sched_cancel().
+
+Foreach iTIP message in our hash table of ATTENDEES, sched_deliver()
+the iTIP message.
+
+Foreach component in the new/modified resource update the SCHEDULE-
+STATUS of each ATTENDEE.
+
+
+process_attendees() - create a suitable iTIP request message for each attendee
+==============================================================================
+
+Foreach ATTENDEE in the component, remove the SCHEDULE-STATUS
+parameter, and set PROPSTAT=NEEDS-ACTION if required.
+
+Make a copy of the component and clean_component().
+
+Foreach ATTENDEE in the cleaned component:
+
+1. Check the CalDAV Scheduling parameters. If SCHEDULE-AGENT !=
+   SERVER, skip to the next attendee.
+
+2. Lookup attendee in our hash table.
+
+3. If it doesn't exist, create a clone of our iTIP template and
+   insert it into our hash table of attendees.
+
+4. Add the component to the attendee's iTIP message.
+
+5. Add the component “number” to our mask of new components
+   appearing in the attendee's iTIP message.
+
+If the component is not the "master", foreach attendee do
+sched_exclude().
+
+
+sched_exclude() - exclude an attendee from a recurrence instance
+================================================================
+
+1. If the component did not appear in the attendee's iTIP message,
+   add an EXDATE property (based on the RECURRENCE-ID of the
+   component) to the master component of the attendee's iTIP message.
+
+
+sched_cancel() - cancel an organizer event/task
+===============================================
+
+1. Set STATUS:CANCELLED on the component.
+
+2. process_attendees().
+
+======================================================================
+
+
+sched_reply() - perform an attendee reply
+=========================================
+
+Check the CalDAV Scheduling parameters on ORGANIZER. If SCHEDULE-AGENT
+!= SERVER, we are done.
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL_REPLY right, fail.
+
+Create a new iTIP (METHOD:REPLY) message, copying over any CALSCALE
+property and VTIMEZONE components.
+
+Foreach component in the existing resource:
+
+1. trim_attendees().
+
+2. Add the trimmed component and the attendee's PARTSTAT to our
+   hash table keyed by RECURRENCE-ID (for comparison against
+   new/modified resource).
+
+Foreach component in the new/modified resource:
+
+trim_attendees().
+
+Lookup (by RECURRENCE-ID) and remove the component from the hash table
+of existing components.
+
+If the component exists:
+
+1. If component is VPOLL, add voter responses to REPLY via
+   sched_vpoll_reply().
+
+2. Otherwise, compare the PARTSTAT of the ATTENDEE to that of the
+   new component.
+
+If the component is new or the PARTSTAT has changed:
+
+1. clean_component().
+
+2. Add the component to our iTIP message.
+
+3. Add the component “number” to our mask of new components
+   appearing in our iTIP message.
+
+Foreach remaining component in the hash table of existing components
+do sched_decline().
+
+sched_deliver() our iTIP message.
+
+Foreach component in the new/modified resource that appeared in our
+iTIP message, update the SCHEDULE-STATUS of the ORGANIZER.
+
+
+trim_attendees() - remove all attendees other than the one replying
+===================================================================
+
+1. Clone the component and remove all ATTENDEE properties other
+   than the one corresponding to the owner of the calendar.
+
+2. Return the ATTENDEE property of owner, his/her PARTSTAT
+   parameter, and the RECURRENCE-ID of the component.
+
+
+sched_vpoll_reply() - add voter responses to VPOLL reply
+========================================================
+
+
+sched_decline() - decline a recurrence instance for an attendee
+===============================================================
+
+1. Set PARTSTAT of ATTENDEE to DECLINED.
+
+2. clean_component().
+
+3. Add the component to our iTIP message.
+
+======================================================================
+
+
+clean_component() - sanitize a component for use in an iTIP message
+===================================================================
+
+1. Update DTSTAMP.
+
+2. Remove any VALARM components.
+
+3. For a reply/decline only, remove scheduling parameters from
+   ORGANIZER.
+
+
+sched_deliver() - deliver an iTIP message to a recipient
+========================================================
+
+1. Lookup the recipient.
+
+2. If local to our server goto sched_deliver_local(), otherwise
+   goto sched_deliver_remote().
+
+======================================================================
+
+
+sched_deliver_local() - deliver an iTIP message to a local user
+===============================================================
+
+Check the ACL on the owner's Scheduling Inbox. If the sender doesn't
+have the proper right (DACL_INVITE for request/cancel, DACL_REPLY for
+reply), fail.
+
+Search the recipient's calendars for a resource having the specified
+UID.
+
+If the resource doesn't exist:
+
+1. If the iTIP method is REPLY, fail (we are done).
+
+2. If the iTIP method is CANCEL, ignore it (we are done).
+
+3. Otherwise, create a new (empty) attendee object and target the
+   recipient's Default calendar.
+
+Otherwise, load the existing resource.
+
+Update the new/existing resource:
+
+1. If the iTIP method is CANCEL, set STATUS:CANCELLED on all
+   existing components.
+
+2. If the iTIP method is REPLY, do deliver_merge_reply().
+
+3. If the iTIP method is REQUEST, do deliver_merge_request().
+
+4. If the iTIP method is POLLSTATUS, do deliver_merge_pollstatus().
+
+Store the new/updated resource in the recipient's target calendar.
+
+Record the delivery status (SCHEDULE-STATUS).
+
+If the iTIP message is something other than just a PARTSTAT update
+from an attendee, store the iTIP message as a new resource in the
+recipient's Inbox.
+
+If the iTIP method is REPLY, send an update other attendees via
+sched_pollstatus() (VPOLL only) or sched_request().
+
+
+deliver_merge_reply() - update an organizer resource with an attendee reply
+===========================================================================
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Lookup (by RECURRENCE-ID) the component from the hash table of
+existing components.
+
+If the component doesn't exist (new recurrence overridden by ATTENDEE)
+create a new recurring component:
+
+1. Clone the existing master component.
+
+2. Remove the RRULE property.
+
+3. Add the RECURRENCE-ID from the iTIP message.
+
+4. Replace the DTSTART, DTEND, SEQUENCE properties with those from
+   the iTIP message.
+
+5. Add the new component to our existing resource.
+
+Get the sending ATTENDEE from the iTIP message.
+
+Find the matching ATTENDEE in the existing component.
+
+If not found (ATTENDEE added themselves to this recurrence), add new
+ATTENDEE to the component.
+
+Set the ATTENDEE PARTSTAT, RSVP, and SCHEDULE-STATUS parameters in the
+existing component.
+
+If the component is VPOLL, update the voter responses in the existing
+component via deliver_merge_vpoll_reply().
+
+Return the sending ATTENDEE.
+
+
+deliver_merge_vpoll_reply() - update an organizer resource with voter responses
+===============================================================================
+
+1. Foreach sub-component in the existing resource, replace any
+   voter response(s) with those from the reply.
+
+
+deliver_merge_request() - create/update an attendee resource with an organizer request
+======================================================================================
+
+Foreach VTIMEZONE component in the existing resource, add it to our
+hash table keyed by TZID (for comparison against iTIP message).
+
+Foreach VTIMEZONE component in the iTIP message:
+
+1. Lookup (by TZID) the VTIMEZONE component from the hash table of
+   existing components.
+
+2. If the component exists, remove it from the existing object.
+
+3. Add the VTIMEZONE from the iTIP message to our existing object.
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Clone a new component from the iTIP component.
+
+Lookup (by RECURRENCE-ID) the component from the hash table of
+existing components.
+
+If the component exists:
+
+1. Compare the SEQUENCE of the new component to the existing
+   component to see if it has changed.
+
+2. Copy any COMPLETED, PERCENT-COMPLETE, or TRANSP properties from
+   the existing component to the new component.
+
+3. Copy any ORGANIZER SCHEDULE-STATUS parameter from the existing
+   component to the new component.
+
+4. Remove the existing component from the existing object.
+
+Add the new component to the existing object.
+
+
+deliver_merge_pollstatus() - update voter responses on a voter resource
+=======================================================================
+
+Foreach sub-component in the existing resource, add it to our hash
+table keyed by POLL-ITEM-ID (for comparison against iTIP message). The
+sub-component entry includes a hash table of VOTERs.
+
+Foreach sub-component in the iTIP message:
+
+1. Lookup (by POLL-ITEM-ID) the sub-component from the hash table
+   of existing sub-components.
+
+2. If the component exists, foreach VOTER in the sub-component in
+   the iTIP message:
+
+   1. Lookup VOTER in the hash table of existing sub-component.
+
+   2. Add/update VOTER response.
+
+======================================================================
+
+
+sched_deliver_remote() - deliver an iTIP message to a remote user
+=================================================================
+
+1. If the recipient is local to our Murder, goto isched_send(),
+   otherwise goto imip_send().
+
+2. Retrieve status of iTIP message delivery.
+
+
+isched_send() - deliver an iTIP message to a remote user via iSchedule (HTTP)
+=============================================================================
+
+
+imip_send() - deliver an iTIP message to a remote user via iMIP (SMTP)
+======================================================================
+
+
+sched_busytime_query() - perform a busytime query
+=================================================
+
+
+busytime_query_local() - perform a busytime query on a local user
+=================================================================
+
+
+busytime_query_remote() - perform a busytime query on a remote user
+===================================================================
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/improved_mboxlist_sort.txt 3.2.0-3/doc/text/imap/developer/thoughts/improved_mboxlist_sort.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/improved_mboxlist_sort.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/improved_mboxlist_sort.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,23 @@
+
+Enabling improved_mboxlist_sort
+*******************************
+
+You can't enable and disable "improved_mboxlist_sort" on a live
+system. You need to dump and load the necessary database after
+stopping and before starting the master process.
+
+Dumping the mailboxes.db file
+
+   ctl_mboxlist -d > /var/tmp/mailboxes.txt
+   ctl_mboxlist -u < /var/tmp/mailboxes.txt
+
+If your subscription databases are not in flat files you need to do
+something similar. Each user will have his own subscription file. Do
+the following for each subscription file.
+
+   cyr_dbtool -C $file skiplist show > $file.TXT
+   cyr_dbtool -n $file skiplist set < $file.TXT
+
+The above fragments will overwrite the original file. So you could
+redirect to a temporary file and overwrite the database if the import
+succeeds.
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/notes.txt 3.2.0-3/doc/text/imap/developer/thoughts/notes.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/notes.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/notes.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,18 @@
+
+Cyrus IMAP Server: Notes
+************************
+
+* appending: it's important that the index records for individual
+  messages make it to disk before the index header indicating that
+  they're there. so something like:
+
+  1. sync messages to disk (or depend on "link()" being atomic)
+
+  2. create new index records, flush to disk
+
+  3. create new header if necessary (adding new user flag), flush
+     to disk
+
+  4. flush cache file
+
+  5. update index header, flush to disk
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts/prot-events.txt 3.2.0-3/doc/text/imap/developer/thoughts/prot-events.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts/prot-events.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts/prot-events.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,54 @@
+
+Cyrus IMAP Server: Prot Events
+******************************
+
+From an email exchange between Ken Murchison and Lawrence Greenfield,
+dated 03 Feb 2002 (slightly redacted and formatted for your viewing
+pleasure):
+
+   From: Ken Murchison
+   To: Lawrence Greenfield
+   Subject: Re: prot events
+
+
+   Lawrence Greenfield wrote:
+
+      Can you give me some details on how the event API in the prot
+      layer works?  I'm a little unclear about the memory management,
+      what should be returned from the event callback,
+
+   Either the event pointer (if the event is still active), or NULL
+   (if the event has been removed by the callback).
+
+      and how to reschedule an event.
+
+   Simply set the 'mark' time in the event to the wall time you want
+   it to run again.
+
+      (I'd like to make an event called every X seconds of idle time;
+      I know the API can't do exactly that but I suspect I can fake it
+      well enough.)
+
+   Look at backend_timeout() in proxyd.c and/or drac_ping() in
+   contrib/drac_auth.patch, they do exactly this.
+
+   The API is pretty simple:
+
+   * use prot_addwaitevent() to add an event (linked list) callback
+     onto a stream.  takes the stream, the 'mark' time at which to run
+     the event (NOT an interval, but the future clock value), the
+     function pointer, and a rock to pass to the callback as args, and
+     returns a pointer to the event (to use for future removal).
+
+   * use prot_removewaitevent() to remove an event.  takes the
+     stream and a pointer to the event as args.
+
+   * the event callback gets the stream, a pointer to the event and
+     the rock as args.  To reschedule an event, simply set the 'mark'
+     time and return the event pointer.  If the callback removes the
+     event, then return NULL.
+
+   If you see and flaws in this API, feel free to go ahead and change
+   it.
+
+   Ken
diff -pruN 3.0.13-5/doc/text/imap/developer/thoughts.txt 3.2.0-3/doc/text/imap/developer/thoughts.txt
--- 3.0.13-5/doc/text/imap/developer/thoughts.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/thoughts.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,15 @@
+
+Developer Thoughts & Notes
+**************************
+
+* Notes for backup implementation
+
+* Cyrus IMAP Server: Sieve Bytecode
+
+* Cyrus CalDAV Scheduling Flowchart
+
+* Enabling improved_mboxlist_sort
+
+* Cyrus IMAP Server: Notes
+
+* Cyrus IMAP Server: Prot Events
diff -pruN 3.0.13-5/doc/text/imap/developer/unit-tests.txt 3.2.0-3/doc/text/imap/developer/unit-tests.txt
--- 3.0.13-5/doc/text/imap/developer/unit-tests.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer/unit-tests.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,613 @@
+
+Unit Tests
+**********
+
+
+Table of Contents
+=================
+
+* 1. Introduction
+
+* 2. What Is A Unit Test?
+
+* 3. Running The Tests
+
+  * 3.1. Setting Up The Machine
+
+  * 3.2 Configure Script
+
+  * 3.3 Make
+
+  * 3.4 Using Valgrind
+
+  * 3.5 The Tests Are Failing
+
+  * 3.6 Debugging A Test
+
+* 4. Adding Your Own Tests
+
+  * 4.1 Where To Put Your Tests
+
+  * 4.1 Adding A New Suite
+
+  * 4.2 Adding A Test To A Suite
+
+  * 4.3 Suite Init And Cleanup
+
+
+1. Introduction
+===============
+
+Recently, a set of regression unit tests has been added to Cyrus. This
+document explains the purpose implementation of those unit tests, and
+gives an example of how to add more unit tests (because there are
+never enough unit tests!).
+
+
+2. What Is A Unit Test?
+=======================
+
+The definition on Wikipedia sheds some light:
+
+   ...**unit testing** is a method by which individual units of source
+   code are tested to determine if they are fit for use. A unit is the
+   smallest testable part of an application.
+
+In other words, unit testing is about verifying that small pieces of
+code, like individual functions, modules, or classes, work in
+isolation. It is **not** about testing the system as a whole.
+
+The tests implemented here are also **regression tests**, which in
+Wikipedia's words means:
+
+   **Regression testing** is any type of software testing that seeks
+   to uncover software errors after changes to the program (e.g.
+   bugfixes or new functionality) have been made, by retesting the
+   program. The intent of regression testing is to assure that a
+   change, such as a bugfix, did not introduce new bugs.
+
+In other words, the tests are designed to be easy to run and to work
+out fully automatically whether they have passed or failed, so that
+they can be run usefully by people who didn't write them.
+
+
+3. Running The Tests
+====================
+
+This section takes you through the process of running Cyrus' unit
+tests.
+
+
+3.1. Setting Up The Machine
+---------------------------
+
+Cyrus' unit tests are all located in a new directory, "cyrus-
+imapd/cunit/". They're written in C, like the remainder of Cyrus, and
+use the CUnit library from SourceForge, with some home grown wrappers
+and other improvements to make our lives easier.
+
+Your first step is step is to ensure that the CUnit library (including
+the headers) is installed. Some modern operating systems already have
+CUnit, for example on Ubuntu you can just do:
+
+   me@ubuntu> sudo apt-get install libcunit1-dev
+
+Alternately, you can download the CUnit source, build it and install
+it. It's not a complicated or difficult library, this shouldn't take
+long. When you've done, install it in "/usr/include" and "/usr/lib".
+
+
+3.2 Configure Script
+--------------------
+
+Because of the dependency on the CUnit library, the tests are disabled
+by default; this means you need enable them with an option to the
+"configure" script:
+
+   me@mybox> ./configure --enable-unit-tests
+   ...
+   checking for CU\_initialize\_registry in -lcunit... yes
+   checking CUnit/CUnit.h usability... yes
+   checking CUnit/CUnit.h presence... yes
+   checking for CUnit/CUnit.h... yes
+   ...
+
+
+3.3 Make
+--------
+
+First you need to build Cyrus itself, using the traditional "all:"
+target.
+
+   me@mybox> make all
+   ...
+
+Then, use the new "check:" target to build and run the unit tests.
+
+   me@mybox> make check
+    cd . && /bin/bash /home/me/cyrus-imapd/missing --run automake-1.11 --foreign Makefile
+    cd . && /bin/bash ./config.status Makefile depfiles (a)
+   config.status: creating Makefile
+   config.status: executing depfiles commands
+   ...
+   make[3]: Entering directory \`/home/me/cyrus-imapd'
+   make[3]: \`sieve/test' is up to date.
+   cunit/cunit.pl --project cunit/default.cunit --generate-wrapper cunit/mboxname.testc (b)
+   gcc -DHAVE\_CONFIG\_H ... -c -o cunit/mboxname.o cunit/mboxname.testc-cunit.c
+   rm -f cunit/mboxname.testc-cunit.c
+   /bin/bash ./libtool --tag=CC --mode=link gcc -fPIC -g -O2 -o
+   cunit/unit cunit/unit.o ... lib/libcyrus\_min.la ... (c)
+   ...
+   Running unit tests (d)
+
+       CUnit - A Unit testing framework for C - Version 2.1-0
+       http://cunit.sourceforge.net/
+
+   ...
+   Suite: mboxname (e)
+     Test: dir\_hash\_c ... passed
+     Test: to\_parts ... passed
+     Test: to\_userid ... passed
+     Test: to\_usermbox ... passed
+   ...
+   --Run Summary: Type      Total     Ran  Passed  Failed (f)
+                  suites       34      34     n/a       0
+                  tests       323     323     323       0
+                  asserts 1079745 1079745 1079745       0
+   make[1]: Leaving directory `/home/me/cyrus-imapd/cunit'
+
+Let's take a closer look at what's happening here.
+
+1. The "check:" target causes automake to re-run itself. This is
+   normal automake behaviour. Note that the older build system used to
+   run make recursively in sub-directories, the newer automake-based
+   system builds everything from the top directory.
+
+2. The "cunit/" directory contains a number of C source files
+   (called, for reasons too complicated to explain here,
+   *whatever*.testc) with test code in them. For each of those, a
+   small wrapper C source file is generated and then compiled into an
+   object file.
+
+3. Finally, all the compiled object files are linked into an
+   executable, with a "main()" routine from "unit.c", and a number of
+   libraries and object files from other parts of the Cyrus tree.
+
+4. The resulting executable is then run.
+
+5. The test executable runs all the built tests one by one, telling
+   us which ones passed and which ones failed as it runs them. You can
+   also run it manually with the name of a test as an argument, and it
+   will run only the named test.
+
+6. At the end, the text executable prints a summary of how many
+   tests it ran and how many passed and failed. The key thing to look
+   at here is the rightmost column, it should be all zero.
+
+
+3.4 Using Valgrind
+------------------
+
+Some failure modes are subtle, and cannot be detected in the C code
+itself; this is where the Valgrind program comes in very handy. It
+detects buffer overruns and memory leaks and various other kinds of
+subtle errors.
+
+To run the unit tests with Valgrind, use the new "valgrind:" target.
+
+   me@mybox> make valgrind
+   ...
+   valgrind --tool=memcheck --leak-check=full ./unit -v (a)
+   ==2999== Memcheck, a memory error detector
+   ==2999== Copyright (C) 2002-2010, and GNU GPL'd, by Julian Seward et al.
+   ==2999== Using Valgrind-3.6.0.SVN-Debian and LibVEX; [...]
+   ==2999== Command: ./unit -v
+   ==2999==
+   ...
+   --Run Summary: Type      Total     Ran  Passed  Failed   (b)
+                  suites        9       9     n/a       0
+                  tests        51      51      50       1
+                  asserts     474     474     473       1
+   ...
+   ==2999== HEAP SUMMARY:   (c)
+   ==2999==     in use at exit: 4,489 bytes in 134 blocks
+   ==2999==   total heap usage: 715 allocs, 581 frees, 352,763 bytes allocated
+   ==2999==
+   ==2999== 4 bytes in 1 blocks are definitely lost in loss record 3 of 50
+   ==2999==    at 0x4C2815C: malloc (vg_replace_malloc.c:236)
+   ==2999==    by 0x44A0CA: xmalloc (xmalloc.c:57)
+   ==2999==    by 0x4399D8: strconcat (util.c:631)
+   ==2999==    by 0x40C059: test_uncast_null (strconcat.c:51)
+   ==2999==    by 0x61B32A9: ??? (in /usr/lib/libcunit.so.1.0.1)
+   ==2999==    by 0x61B36ED: ??? (in /usr/lib/libcunit.so.1.0.1)
+   ==2999==    by 0x61B3827: CU_run_all_tests (in /usr/lib/libcunit.so.1.0.1)
+   ==2999==    by 0x4066CC: run_tests (unit.c:144)
+   ==2999==    by 0x406806: main (unit.c:283)
+   ==2999==
+   ...
+
+Here's an explanation of what's happening in the example.
+
+1. The test executable is run as before, but using the "valgrind"
+   program. The first thing we see is Valgrind's banner message.
+
+2. The test executable proceeds as normal and eventually emits it's
+   run summary, then exits.
+
+3. After the test executable exits, Valgrind checks for memory
+   leaks and prints both a summary of all leaks and a stack trace
+   showing where each block of leaked memory was allocated.
+
+I'd just like to say that I love Valgrind and I think it's immensely
+useful. I would have made running the tests under Valgrind the only
+option for the "check:" target, except that Valgrind is not available
+on all of Cyrus' supported platforms.
+
+
+3.5 The Tests Are Failing
+-------------------------
+
+So you've noticed that some of the tests are failing. Let me make the
+guiding principle of unit testing as clear as possible: **THE UNIT
+TESTS SHOULD NOT FAIL**. All of the tests are designed to pass all the
+time, in everyone's environment. The unit tests are run automatically
+every twelve hours on the Cyrus Continuous Integration server, and a
+failing test fails the whole build and makes people unhappy.
+
+There are a few rules which you should follow to help us all get the
+most benefit out of unit testing
+
+* If you see a test failing, investigate it.
+
+* If you can't investigate, complain on the mailing list or raise a
+  bug so that somebody else can investigate.
+
+* When writing tests, write them to work in all environments and all
+  combinations of "configure" script options. It's ok to have a test
+  which is empty in some circumstances; it's not ok to have a test
+  that fails.
+
+* When adding code, write new tests for the new code.
+
+* When modifying code, write new tests for the new behaviour.
+
+* When looking at old code, also take a look at the coverage report
+  and consider writing tests for the existing code.
+
+
+3.6 Debugging A Test
+====================
+
+With the new Cyrus build system, the file "cunit/unit" is no longer an
+executable, it's a shell script which sets up some environment
+variables before running the real executable which is hidden away.
+This makes debugging a failing test somewhat challenging. The solution
+is:
+
+   me@mybox> ( cd cunit ; libtool --mode=execute gdb --args unit -t crc32 )
+   ...
+   Reading symbols from /home/me/cyrus-imapd/cunit/.libs/lt-unit...done.
+   (gdb) list crc32.testc:1
+   1       /* Unit test for lib/crc32.c */
+   2       #include "cunit/cyrunit.h"
+   3       #include "crc32.h"
+   ...
+   (gdb) break test_map
+   Breakpoint 1 at 0x44a2f8: file ./cunit/crc32.testc, line 11.
+   (gdb) run
+   Starting program: /home/me/cyrus-imapd/cunit/.libs/lt-unit -t -v crc32
+   [Thread debugging using libthread_db enabled]
+
+       CUnit - A Unit testing framework for C - Version 2.1-0
+       http://cunit.sourceforge.net/
+
+   Suite: crc32
+     Test: map ...
+   Breakpoint 1, test_map () at ./cunit/crc32.testc:11
+   11          c = crc32_map(TEXT, sizeof(TEXT)-1);
+   (gdb)
+
+Note the **-t** option. This turns off test timeouts, which is very
+useful for manual debugging.
+
+
+4. Adding Your Own Tests
+========================
+
+Adding your own tests is quite simple. Here's how.
+
+
+4.1 Where To Put Your Tests
+===========================
+
+The unit test code in Cyrus is contained in a set of C source files in
+the "cunit" directory. For reasons too complex to go into here, these
+are named *whatever*.testc instead of the more usual *whatever*.c. If
+you look closely, you will see that each of those C source files maps
+to a "Suite" in CUnit parlance. For example, "cunit/glob.testc" is
+listed as the Suite "glob" in CUnit's runtime output.
+
+Typically, each Suite tests a single module or a related set of
+functions; for example, "cunit/glob.testc" contains tests for the glob
+module in "lib/glob.c".
+
+So, if you want to add a new test for a module which already has some
+existing tests, the sensible thing to do is to add a new test to the
+existing suite. Otherwise, you'll need to add a new Suite.
+
+
+4.1 Adding A New Suite
+======================
+
+Each Suite is a single C source file in the "cunit/" directory. Your
+first step is to create a new C source file. For this example, you'll
+create a new Suite to test the CRC32 routines which live in
+"lib/crc32.c".
+
+   me@mybox> vi cunit/crc32.testc
+   ...
+
+The file should contain something like this.
+
+   /* Unit test for lib/crc32.c */
+   #include "cunit/cyrunit.h"  (a)
+   #include "crc32.h"  (b)
+
+   static void test_map(void)  (c)
+   {
+       static const char TEXT[] = "lorem ipsum";  (d)
+       static uint32_t CRC32 = 0x0;
+       uint32_t c;  (e)
+
+       c = crc32_map(TEXT, sizeof(TEXT)-1);  (f)
+       CU_ASSERT_EQUAL(c, CRC32);  (g)
+   }
+
+Here's an explanation of what all these bits are for.
+
+1. You need to include the header ""cunit/cyrunit.h"", which is a
+   thin Cyrus wrapper around the CUnit's library's header,
+   "<CUnit/CUnit.h>" with some extra conveniences.
+
+2. You should also include any headers you need for declarations of
+   the functions which you'll be testing. Note that the Cyrus "lib/"
+   and "imap/" directories are already in the include path, so any
+   header in there can be included without the directory prefix, e.g.
+   ""crc32.h"" for "lib/crc32.h".
+
+3. You need to have at least one function which looks like this: it
+   takes no arguments, returns void, and is named "test_whatever". It
+   may be "static" or "extern", but I recommend "static". Functions
+   with this signature are automatically discovered in the source code
+   by the Cyrus unit test infrastructure, so all you have to do is
+   write the function. Later, a CUnit test named "whatever" will be
+   created automatically for your "test_whatever" function.
+
+4. Here's a good place to define the test inputs and expected
+   outputs. Note that for this example you have no idea of the actual
+   correct output. The right thing to do there is to manually
+   calculate the expected result from first principles, or to use a
+   different piece of software which you believe to be working. For
+   this example, let's just use a known incorrect value and see what
+   happens.
+
+5. Here's a good place for local variables you need during the
+   test.
+
+6. Call the function under test ("crc32_map()" in this example)
+   with known inputs, and capture the results in a local variable "c".
+
+7. Compare the actual result in "c" with the expected result in
+   "CRC32". The "CU_ASSERT_EQUAL()" macro checks that it's two
+   arguments are equal (using an integer comparison), and if they're
+   different it prints a message and records a failure. Note that
+   unlike the libc "assert()" macro, control will continue even if the
+   assert fails. The CUnit library provides a whole family of similar
+   macros, see the online CUnit documentation for more details.
+
+Now you need to tell the Cyrus build system about your new Suite.
+
+   me@mybox> vi Makefile.am
+   ...
+
+You need to add the filename of your new test to the definition of the
+"cunit_TESTS" variable.
+
+   cunit_TESTS = \
+       cunit/aaa-db.testc \
+       cunit/annotate.testc \
+       cunit/backend.testc \
+       cunit/binhex.testc \
+       cunit/bitvector.testc \
+       cunit/buf.testc \
+       cunit/byteorder64.testc \
+       cunit/charset.testc \
+       cunit/crc32.testc \
+       cunit/dlist.testc \
+       cunit/duplicate.testc \
+
+At this point you should be able to just rebuild and rerun using
+**make check**. You can also just rebuild without rerunning by using
+the command **make cunit/unit**.
+
+Note that sometimes this doesn't quite work right, and you may be able
+to work around this problem using the command **rm
+cunit/default.cunit**.
+
+   me@mybox> make check
+   ...
+   ../cunit/cunit.pl [...] --add-sources [...] crc32.testc
+   ...
+   ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+   gcc -c [...] -g -O2 .cunit-crc32.c
+   gcc [...] -o unit [...] .cunit-crc32.o ...
+   Running unit tests
+
+       CUnit - A Unit testing framework for C - Version 2.1-0
+       http://cunit.sourceforge.net/
+
+   ...
+   Suite: crc32
+     Test: map ... FAILED
+       1. crc32.testc:12  - CU_ASSERT_EQUAL(c=1926722702,CRC32=0)
+
+Note how the test failure told us which in source file and at what
+line number the failure occurred, and what the actual and expected
+values were. Let's go and fix that up now.
+
+   static const char TEXT[] = "lorem ipsum";
+   static uint32\_t CRC32 = 0x72d7748e;
+
+Re-run "make check" and you'll see your test being rebuilt and rerun,
+and this time passing.
+
+   me@mybox> make check
+   ...
+   ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+   gcc -c [...] -g -O2 .cunit-crc32.c
+   gcc [...] -o unit [...] .cunit-crc32.o
+   ...
+   Running unit tests
+
+       CUnit - A Unit testing framework for C - Version 2.1-0
+       http://cunit.sourceforge.net/
+
+   ...
+   Suite: crc32
+     Test: map ... passed
+
+
+4.2 Adding A Test To A Suite
+============================
+
+Adding a new test to an existing test is easy: all you have to do is
+add a new function to an existing C source file in the "cunit/"
+directory. As an example, let's add a test for the "crc_iovec()"
+function.
+
+   me@mybox> vi cunit/crc32.testc
+   ...
+
+   static void test_iovec(void)  (a)
+   {
+       static const char TEXT1[] = "lorem";  (b)
+       static const char TEXT2[] = " ipsum";
+       static uint32_t CRC32 = 0x72d7748e;
+       uint32_t c;  (c)
+       struct iovec iov[2];
+
+       memset(iov, 0, sizeof(iov));  (d)
+       iov[0].iov_base = TEXT1;
+       iov[0].iov_len = sizeof(TEXT1)-1;
+       iov[1].iov_base = TEXT2;
+       iov[1].iov_len = sizeof(TEXT2)-1;
+
+       c = crc32_iovec(iov, 2);  (e)
+       CU_ASSERT_EQUAL(c, CRC32);  (f)
+   }
+
+Here's an explanation of what all these bits are for.
+
+1. Your new test function should look like this: it takes no
+   arguments, returns void, and is named "test_whatever". It may be
+   "static" or "extern", but I recommend "static". Functions with this
+   signature are automatically discovered in the source code by the
+   Cyrus unit test infrastructure, so all you have to do is write the
+   function. Later, a CUnit test named "whatever" will be created
+   automatically for your "test_whatever" function. Note that the
+   opening curly brace must be on the next line or the unit test
+   infrastructure will not find the function.
+
+2. Here's a good place to define the test inputs and expected
+   outputs.
+
+3. Here's a good place for local variables you need during the
+   test.
+
+4. Here you set up the input conditions for the function under
+   test.
+
+5. Call the function under test with your known inputs, and capture
+   the results in a local variable, here "c".
+
+6. Compare the actual result in "c" with the expected result in
+   "CRC32". The "CU_ASSERT_EQUAL()" macro checks that it's two
+   arguments are equal (using an integer comparison), and if they're
+   different it prints a message and records a failure. Note that
+   unlike the libc "assert()" macro, control will continue even if the
+   assert fails. The CUnit library provides a whole family of similar
+   macros, see the online CUnit documentation for more details.
+
+Now run "make check" and you'll see your test being built and run.
+
+   me@mybox> make check
+   ...
+   ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+   gcc -c [...] -g -O2 .cunit-crc32.c
+   gcc [...] -o unit [...] .cunit-crc32.o
+   ...
+   Running unit tests
+
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+   ...
+   Suite: crc32
+     Test: map ... passed
+     Test: iovec ... passed
+
+
+4.3 Suite Setup And Teardown
+============================
+
+Sometimes the behaviour of the functions under test depend on external
+influences such as environment variables, global variables, or the
+presence of certain files.
+
+These kinds of functions need special treatment to ensure that their
+behaviour is locked down during the running of your tests. Otherwise,
+all sorts of strange behaviour may confuse the results of the tests.
+For example, a test might succeed the first time it's run in a given
+directory and fail the next time. Or a test might succeed when run by
+the author of the test but fail when run by another user.
+
+CUnit provides a special arrangement which helps you in such cases:
+the suite initialisation and cleanup functions. These are two
+functions that you write and which live in the suite source. They are
+called from CUnit respectively before any of the tests in the suite is
+run, and after all tests from that suite are run.
+
+Here's how to use them. The suite setup function should set up any
+global state that the functions under test rely on, in such a way that
+their state is predictable and always the same no matter who runs the
+test or when or how many times. Similarly the suite teardown function
+should clean up any state which might possibly interfere with other
+test suites. Note that some suites will need an setup function but not
+necessarily a teardown function.
+
+Adding these functions is very easy: you just write functions of the
+appropriate signature (names, arguments and return type) and the Cyrus
+unit test infrastructure will automatically discover them and arrange
+for them to be called. The functions should look like (actual example
+taken from "cunit/mboxname.testc") this:
+
+   static enum enum_value old_config_virtdomains;
+
+   static int set_up(void)
+   {
+       old_config_virtdomains = config_virtdomains;
+       config_virtdomains = IMAP_ENUM_VIRTDOMAINS_ON;
+       return 0;
+   }
+
+   static int tear_down(void)
+   {
+       config_virtdomains = old_config_virtdomains;
+       return 0;
+   }
+
+The functions should return 0 on success, and non-zero on error. They
+must not call and "CU_*" functions or macros.
+
+Good luck and good testing!
diff -pruN 3.0.13-5/doc/text/imap/developer.txt 3.2.0-3/doc/text/imap/developer.txt
--- 3.0.13-5/doc/text/imap/developer.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/developer.txt	2020-05-04 04:13:53.000000000 +0000
@@ -18,6 +18,8 @@ Getting Started
 
 * Developer Test Environment
 
+* JMAP support
+
 
 System files and Databases
 ==========================
@@ -38,6 +40,8 @@ Releasing
 
   * Prerequisites
 
+  * Order of operations
+
   * Release notes
 
   * Pre-release testing
@@ -46,7 +50,11 @@ Releasing
 
   * Version tagging
 
-  * Releasing
+  * Inter-version website consistency
+
+  * Uploading
+
+  * Tell the world
 
 * Releasing new builds of ancient Cyrus IMAP versions
 
@@ -62,4 +70,4 @@ Releasing
 
   * Building the release
 
-  * Releasing
+  * Finishing up
diff -pruN 3.0.13-5/doc/text/imap/download/getcyrus.txt 3.2.0-3/doc/text/imap/download/getcyrus.txt
--- 3.0.13-5/doc/text/imap/download/getcyrus.txt	2019-12-16 04:18:22.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/getcyrus.txt	2020-05-04 04:13:54.000000000 +0000
@@ -36,8 +36,8 @@ Use a release packaged tarball
 The Cyrus team produce packaged tarballs containing full source and
 pre-built documentation.
 
-Download a versioned tarball using FTP or HTTPS. Latest stable version
-is 3.0.13.
+Download a versioned tarball using HTTPS. Latest stable version is
+3.2.0.
 
 Extract the tarball:
 
diff -pruN 3.0.13-5/doc/text/imap/download/installation/http/caldav.txt 3.2.0-3/doc/text/imap/download/installation/http/caldav.txt
--- 3.0.13-5/doc/text/imap/download/installation/http/caldav.txt	2019-12-16 04:18:23.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/installation/http/caldav.txt	2020-05-04 04:13:54.000000000 +0000
@@ -80,7 +80,7 @@ autocreate options
 
    "caldav_create_attach:" 1
 
-      Create the 'Attachments' calendar if it doesn't already exist
+      Create the 'Attachments' collection if it doesn't already exist
 
    "caldav_create_sched:" 1
 
@@ -104,6 +104,22 @@ allows you to:
 
    * Delete existing collections
 
+The Cyrus web GUI for CalDAV Collection Management is disabled by
+default, but can be enabled with the "caldav_allowcalendaradmin"
+option.
+
+
+caldav_allowcalendaradmin
+^^^^^^^^^^^^^^^^^^^^^^^^^
+
+   *This shows the default value: change it in imapd.conf to suit your
+   needs.*
+
+   "caldav_allowcalendaradmin:" 0
+
+      Enable per-user calendar administration web UI on the CalDAV
+      server.
+
 To access the Cyrus web GUI for CalDAV Collection Management, point a
 web browser at "https://<servername>/dav/calendars/user/<username>"
 
@@ -151,12 +167,12 @@ Time Zone Distribution Service (TZDist)
 What is TZDist
 --------------
 
-The Time Zone module allows Cyrus to function as a Time Zone
-Distribution Service (**RFC 7808** and **RFC 7809**), providing time
-zone data for CalDAV and calendaring clients, without having to wait
-for their client vendor and/or OS vendor to update the timezone
-information. The responsibility for keeping the time zone information
-up to date then falls upon the Cyrus administrator.
+The TZDist module allows Cyrus to function as a Time Zone Distribution
+Service (**RFC 7808** and **RFC 7809**), providing time zone data for
+CalDAV and calendaring clients, without having to wait for their
+client vendor and/or OS vendor to update the timezone information. The
+responsibility for keeping the time zone information up to date then
+falls upon the Cyrus administrator.
 
 TZDist is optional: without Cyrus having TZDist enabled, calendar
 clients should still be able to get their timezone information from
@@ -186,32 +202,44 @@ zoneinfo config
 
    "zoneinfo_db:" twoskip
 
-      The cyrusdb backend to use for zoneinfo.
+      The cyrusdb backend to use for zoneinfo.  This database is used
+      by the "tzdist" *http_modules*, and is managed by
+      **ctl_zoneinfo(8)**. Allowed values: *flat*, *skiplist*,
+      *twoskip*, *zeroskip*
 
-      Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
 
-This module stores time zone data in the "zoneinfo/" subdirectory of
-the Cyrus configuration directory (as specified by the
-"configdirectory" option). The data is indexed by a database whose
-location is specified by the "zoneinfo_db_path" option, using the
-format specified by the "zoneinfo_db" option.
+
+   "zoneinfo_dir:" <none>
+
+      The absolute path to the zoneinfo directory, containing timezone
+      definitions as generated by the vzic tool.  If not specified,
+      whatever definitions libical finds will be used.
+
+      If you are providing a Time Zone Data Distribution Service (i.e.
+      you have "tzdist" listed in *http_modules*), then this
+      configuration option MUST be specified.
+
+The TZDist module requires the "zoneinfo_dir" setting in imapd.conf(5)
+to be set to the directory where your time zone data is stored.
+
+The data is indexed by a database whose location is specified by the
+"zoneinfo_db_path" option, using the format specified by the
+"zoneinfo_db" option.
 
 
 Administration
 --------------
 
-This module is designed to use the IANA Time Zone Database data
+The TZDist module is designed to use the IANA Time Zone Database data
 (a.k.a. Olson Database) converted to the iCalendar format.
 
-Cyrus uses a modified vzic to convert IANA formatted data into
-iCalendar format. There is more information on Cyrus vzic in
-"tools/vzic/README".
-
-The steps to populate the Cyrus "zoneinfo/" directory are:
-
-1. Build the local "vzic" utility located in the "tools/vzic/"
-   subdirectory of the Cyrus source code. Run make in the tools/vzic/
-   subdirectory to build.
+We provide a modified vzic to convert IANA formatted data into
+iCalendar format, in the cyrus-timezones package to make the following
+steps easier.
+
+The steps to populate the "zoneinfo_dir" directory are:
+
+1. Acquire and build your choice of "vzic" tool.
 
 2. Download the latest version of the Time Zone Database data from
    IANA. Note you only need the **data**, not the code.
@@ -219,16 +247,16 @@ The steps to populate the Cyrus "zoneinf
 3. Expand the downloaded time zone data into a temporary directory
    of your choice.
 
-4. Populate "<configdirectory>/zoneinfo/" with iCalendar data:
+4. Populate "zoneinfo_dir" with iCalendar data:
 
    *Initial Install Only*
 
    1. Convert the raw data into iCalendar format by running vzic as
       follows: "vzic --pure --olson-dir <location-of-raw-data>
-      --output-dir <configdirectory>/zoneinfo"
+      --output-dir <zoneinfo_dir>"
 
       This will create and install iCalendar data directly into the
-      "<configdirectory>/zoneinfo/" directory.
+      "<zoneinfo_dir>" directory.
 
    *Updating Data Only*
 
@@ -236,11 +264,11 @@ The steps to populate the Cyrus "zoneinf
       follows: "vzic --pure --olson-dir <location-of-raw-data>"
 
       This will create a zoneinfo/ subdirectory in your current
-      location (which should be *tools/vzic/*).
+      location
 
-   3. Merge new/updated iCalendar data into the
-      "<configdirectory>/zoneinfo/" directory by running vzic-merge.pl
-      in your current location: "vzic-merge.pl"
+   3. Merge new/updated iCalendar data into the "<zoneinfo_dir>"
+      directory by running vzic-merge.pl in your current location:
+      "vzic-merge.pl"
 
 5. Rebuild the Cyrus zoneinfo index by running ctl_zoneinfo(8) as
    follows: "ctl_zoneinfo -r <version-string>"
diff -pruN 3.0.13-5/doc/text/imap/download/installation/http/carddav.txt 3.2.0-3/doc/text/imap/download/installation/http/carddav.txt
--- 3.0.13-5/doc/text/imap/download/installation/http/carddav.txt	2019-12-16 04:18:23.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/installation/http/carddav.txt	2020-05-04 04:13:54.000000000 +0000
@@ -49,6 +49,18 @@ for a user the first time that the user
 server. Note that the user MUST have an existing IMAP Inbox in order
 for the addressbook to be created.
 
+
+carddav_allowaddressbookadmin
+^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+   *This shows the default value: change it in imapd.conf to suit your
+   needs.*
+
+   "carddav_allowaddressbookadmin:" 0
+
+      Enable per-user addressbook administration web UI on the CardDAV
+      server.
+
 There is also a Cyrus web GUI for managing addressbook resources. It
 allows you to:
 
@@ -58,6 +70,9 @@ allows you to:
 
    * Download existing collections via prepared URLs
 
+The Cyrus web GUI for addressbook management is disabled by default,
+but can be enabled with the "carddav_allowaddressbookadmin" option.
+
 To access the Cyrus web GUI for addressbook management, point a web
 browser at "https://<servername>/dav/addressbooks/user/<username>"
 
diff -pruN 3.0.13-5/doc/text/imap/download/installation/http/jmap.txt 3.2.0-3/doc/text/imap/download/installation/http/jmap.txt
--- 3.0.13-5/doc/text/imap/download/installation/http/jmap.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/installation/http/jmap.txt	2020-05-04 04:13:54.000000000 +0000
@@ -0,0 +1,112 @@
+
+JMAP
+****
+
+
+About JMAP
+==========
+
+JMAP is an alternate mechanism for synchronising a mail client with a
+mail server, intended as a replacement for IMAP. It is a transport-
+agnostic, stateless JSON-based API, aiming to be compatible with the
+IMAP data model, but with reduced data usage and more efficient
+synchronisation.
+
+
+Configuration
+=============
+
+JMAP support needs to be compiled in to the server using additional
+compile flags. Depending on your distribution, your package provider
+may have already done so. If not, check the JMAP developer guide for
+instructions on how to do so manually, assuming you have the source.
+
+
+JMAP configuration
+^^^^^^^^^^^^^^^^^^
+
+   *This shows the default value: change it in imapd.conf to suit your
+   needs.*
+
+   "conversations:" 0
+
+      Enable the XCONVERSATIONS extensions.  Extract conversation
+      tracking information from incoming messages and track them in
+      per-user databases.
+
+
+
+   "conversations_db:" skiplist
+
+      The cyrusdb backend to use for the per-user conversations
+      database.
+
+      Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
+
+Once it's compiled, JMAP needs to be enabled in imapd.conf(5).
+
+Enable conversation support
+
+   * In imapd.conf(5), set "conversations: 1", "conversations_db:
+     twoskip"
+
+   * Create a conversations.db for each user using
+     ctl_conversationsdb(8): "ctl_conversationsdb -b -r"
+
+
+JMAP clients
+============
+
+The official JMAP website maintains a list of known clients with JMAP
+support.
+
+The Cyrus JMAP developer guide has information on using the sample
+test clients.
+
+
+JMAP implementation status
+==========================
+
+The JMAP implementation in Cyrus is at various stages of maturity.
+
+
+Working
+-------
+
+* **Contacts**
+
+     * All JMAP methods are implemented. JMAP blobs are not
+       supported.
+
+* **Calendars**
+
+     * All JMAP methods are implemented. JMAP blobs are not
+       supported.
+
+* **Messages**
+
+     * Most JMAP methods are implemented. The following methods are
+       not planned for implementation:
+
+       * copyMessages
+
+       * reportMessages
+
+       * getVacationResponse
+
+       * setVacationResponse
+
+       * getIdentityUpdates
+
+       * setIdentities
+
+
+Not yet implemented
+-------------------
+
+* **Remote mailboxes**
+
+* **Events**
+
+     * Changes on mailbox entries trigger notifications. However,
+       the JMAP event service is not implemented.
diff -pruN 3.0.13-5/doc/text/imap/download/installation/manage-dav.txt 3.2.0-3/doc/text/imap/download/installation/manage-dav.txt
--- 3.0.13-5/doc/text/imap/download/installation/manage-dav.txt	2019-12-16 04:18:23.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/installation/manage-dav.txt	2020-05-04 04:13:54.000000000 +0000
@@ -42,6 +42,11 @@ Apache httpd). Its feature set is limite
        mailboxes as collections and **RFC 5322** message to store
        files.
 
+* JMAP support
+
+     * Allows synchronization of mail clients via the JSON Mail
+       Access Protocol (JMAP).
+
 * Other (RSS, static content)
 
      * Serves static content (such as the RSS feed list template and
@@ -72,8 +77,9 @@ httpmodules
 
       Note that "domainkey" depends on "ischedule" being enabled, and
       that both "freebusy" and "ischedule" depend on "caldav" being
-      enabled. Allowed values: *admin*, *caldav*, *carddav*,
-      *domainkey*, *freebusy*, *ischedule*, *rss*, *tzdist*, *webdav*
+      enabled. Allowed values: *admin*, *caldav*, *carddav*, *cgi*,
+      *domainkey*, *freebusy*, *ischedule*, *jmap*, *prometheus*,
+      *rss*, *tzdist*, *webdav*
 
 The support for RSS, CalDAV, and CardDAV is divided into separate
 modules which run as part of the Cyrus httpd service. Selection of
@@ -154,6 +160,16 @@ Module-specific information
 
   * Administration
 
+* JMAP
+
+  * About JMAP
+
+  * Configuration
+
+  * JMAP clients
+
+  * JMAP implementation status
+
 * RSS Feeds
 
   * About RSS Feeds
diff -pruN 3.0.13-5/doc/text/imap/download/packagers.txt 3.2.0-3/doc/text/imap/download/packagers.txt
--- 3.0.13-5/doc/text/imap/download/packagers.txt	2019-12-16 04:18:23.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/packagers.txt	2020-05-04 04:13:54.000000000 +0000
@@ -3,6 +3,16 @@ Notes for Packagers
 *******************
 
 
+Binary naming
+=============
+
+Prevent namespace clashes. We suggest renaming all binaries with
+"cyr_" at the front, including renaming the "ctl_*" to "cyr_".
+
+The Cyrus team are looking to fix this in the core bundle in upcoming
+releases so packagers have less to do.
+
+
 Sample configuration files
 ==========================
 
@@ -106,53 +116,19 @@ Note: Any process which depends on these
 New default settings
 ~~~~~~~~~~~~~~~~~~~~
 
-With the introduction of version 3.0, the defaults for some settings
-have changed.  Please consult Upgrading to 3.0 for details.
+A new stable series means the defaults for some settings may have
+changed. Please consult Upgrading to 3.2 for details.
 
 
-New features
-~~~~~~~~~~~~
+New or improved features
+~~~~~~~~~~~~~~~~~~~~~~~~
 
-There are several features either new to version 3.0, or newly
-improved. Some of these may be features which previously were not
+A new stable series means new features, and improvements to existing
+features. Some of these may be features which previously were not
 considered ripe for packaging, but merit new consideration.
 
-Please see the release notes Major changes since the 2.5.x series for
-more details and other recent changes.
-
-* Conversations
-
-  * Server-side threading with reduced protocol chatter for mobile
-    or other high-latency clients.
-
-  * See the "conversations" options in imapd.conf(5)
-
-* Xapian
-
-  * Higher quality full-text search support.
-
-  * See the "search_engine" option in imapd.conf(5) and
-    "doc/README.xapian" in the source distribution.
-
-* Archive partitions
-
-  * Automatically migrate messages from posh, fast storage (think
-    SSD) to cheap, slow storage (spinning rust).
-
-  * Requires addition of an archive partition for each data
-    partition.
-
-  * See "archive_*" options in imapd.conf(5)
-
-* Backup
-
-  * Replication-based backup to dedicated instance with efficient,
-    compact scheme.
-
-  * See Cyrus Backups
-
-Please consider enabling these features in the imapd.conf(5) you ship
-in your packages.
+Please see Cyrus IMAP 3.2 Releases for details, and consider enabling
+these features in the imapd.conf(5) you ship in your packages.
 
 
 Services in "/etc/services"
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.2/2.2.x.txt 3.2.0-3/doc/text/imap/download/release-notes/2.2/2.2.x.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.2/2.2.x.txt	2019-12-16 04:18:23.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.2/2.2.x.txt	2020-05-04 04:13:55.000000000 +0000
@@ -123,7 +123,7 @@ Changes to the Cyrus IMAP Server since 2
 * Fix a bug in the proxy code where a backend connection might get
   closed twice
 
-* Improved consistency checking in chk_cyrus
+* Improved consistancy checking in chk_cyrus
 
 * Fix segfault in APPEND code
 
@@ -133,7 +133,7 @@ Changes to the Cyrus IMAP Server since 2
 
 * Fix a triggered assertation in service-thread services
 
-* Add a number of internal consistency checks to the skiplist code
+* Add a number of internal consistancy checks to the skiplist code
 
 * Allow mbpath to handle virtual domains
 
@@ -284,9 +284,9 @@ Changes to the Cyrus IMAP Server since 2
 
 Changes to the Cyrus IMAP Server since 2.1.x
 
-* There have been extensive performance and consistency changes to
+* There have been extensive performance and consistancy changes to
   the configuration subsystem. This will both ensure greater
-  consistency between the documentation and the code, as well as a
+  consistancy between the documentation and the code, as well as a
   more standard format for specifing service-specific configuration
   options in imapd.conf. Important changes are detailed here:
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/index.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/index.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/index.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/index.txt	2020-05-04 04:13:55.000000000 +0000
@@ -30,4 +30,4 @@ Cyrus IMAP 2.5 Releases
 
 * Cyrus IMAP 2.5.13 Release Notes
 
-* Cyrus IMAP 2.5.14 Release Notes
+* Cyrus IMAP 2.5.15 Release Notes
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.0.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.0.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.0.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.0.txt	2020-05-04 04:13:56.000000000 +0000
@@ -15,19 +15,14 @@ Important: Make sure to read the Upgradi
 
 * Development: Sphinx for Documentation
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.0.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.0/cyrus-
      imapd-2.5.0.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.0/cyrus-
      imapd-2.5.0.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.10.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.10.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.10.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.10.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.10/cyrus-
+     imapd-2.5.10.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.10/cyrus-
      imapd-2.5.10.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.11.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.11.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.11.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.11.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.11/cyrus-
+     imapd-2.5.11.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.11/cyrus-
      imapd-2.5.11.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.14.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.14.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.14.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.14.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,54 +0,0 @@
-
-Cyrus IMAP 2.5.14 Release Notes
-*******************************
-
-Important: This is a bug-fix release in the stable 2.5 series.Refer
-  to the Cyrus IMAP 2.5.0 Release Notes for important information
-  about the 2.5 series, including upgrading instructions.
-
-Download via HTTPS:
-
-   * https://github.com/cyrusimap/cyrus-
-     imapd/releases/download/cyrus- imapd-2.5.14/cyrus-
-     imapd-2.5.14.tar.gz
-
-   * https://github.com/cyrusimap/cyrus-
-     imapd/releases/download/cyrus- imapd-2.5.14/cyrus-
-     imapd-2.5.14.tar.gz.sig
-
-
-Changes Since 2.5.13
-====================
-
-
-Release changes
----------------
-
-We’re trialing using the Github Releases feature. If you have trouble
-downloading this release, please report this to the mailing lists.
-Thanks!
-
-
-Security fixes
---------------
-
-* Fixed CVE-2019-18928: unauthenticated HTTP requests no longer
-  inherit authentication from the previous request on the same
-  connection
-
-
-Build changes
--------------
-
-* Can now build against ClamAV >= 0.101 (thanks Christoph Moench-
-  Tegeder)
-
-
-Bug fixes
----------
-
-* Fixed Issue #2877: *quota -f* now works correctly with
-  *improved_mboxlist_sort: no*
-
-* Fixed Issue #2808: UNDUMP no longer crashes when quota needs
-  updating
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.15.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.15.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.15.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.15.txt	2020-05-04 04:13:56.000000000 +0000
@@ -0,0 +1,63 @@
+
+Cyrus IMAP 2.5.15 Release Notes
+*******************************
+
+Important: This is a bug-fix release in the stable 2.5 series.Refer
+  to the Cyrus IMAP 2.5.0 Release Notes for important information
+  about the 2.5 series, including upgrading instructions.
+
+Download via HTTPS:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.15/cyrus-
+     imapd-2.5.15.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.15/cyrus-
+     imapd-2.5.15.tar.gz.sig
+
+
+Changes Since 2.5.14
+====================
+
+
+Release changes
+---------------
+
+We’re trialing using the Github Releases feature. If you have trouble
+downloading this release, please report this to the mailing lists.
+Thanks!
+
+
+Security fixes
+--------------
+
+* Fixed CVE-2019-19783: When creating a missing mailbox as part of a
+  sieve 'fileinto' directive, lmtpd would create it as administrator,
+  bypassing ACL checks.
+
+  lmtpd creates missing mailboxes as part of a sieve 'fileinto'
+  directive if:
+
+  * (2.5+) the *anysievefolder* option is enabled (default: not), or
+
+  * (3.0+) the *sieve_extensions* option has the 'mailbox' extension
+    enabled (default: enabled) and the 'fileinto' directive contains
+    the ":create" argument
+
+  Under these conditions, a user with the ability to upload a custom
+  sieve script to their account could use it to create any valid
+  mailbox on the server (with ACL inherited from the parent mailbox as
+  usual).
+
+  lmtpd no longer creates these mailboxes as administrator, so users
+  may no longer use a 'fileinto' directive to create a mailbox they
+  couldn't create otherwise.
+
+
+Bug fixes
+---------
+
+* Fixed Issue #2913: errors are now logged when
+  *maxlogins_per_host*, *maxlogins_per_user*, and *popminpoll* limits
+  are reached (thanks Sergey)
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.1.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.1.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.1.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.1.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.1/cyrus-
      imapd-2.5.1.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.1/cyrus-
      imapd-2.5.1.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.2.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.2.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.2.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.2.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.2/cyrus-
      imapd-2.5.2.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.2/cyrus-
      imapd-2.5.2.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.3.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.3.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.3.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.3.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.3/cyrus-
      imapd-2.5.3.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.3/cyrus-
      imapd-2.5.3.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.4.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.4.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.4.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.4.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.4/cyrus-
      imapd-2.5.4.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.4/cyrus-
      imapd-2.5.4.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.5.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.5.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.5.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.5.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz
-
-   * http://www.cyrusimap.org/releases/old/cyrus-
-     imapd-2.5.5.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.5/cyrus-
      imapd-2.5.5.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.5/cyrus-
      imapd-2.5.5.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.6.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.6.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.6.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.6.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.6/cyrus-
+     imapd-2.5.6.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.6/cyrus-
      imapd-2.5.6.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.7.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.7.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.7.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.7.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.7/cyrus-
+     imapd-2.5.7.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.7/cyrus-
      imapd-2.5.7.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.8.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.8.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.8.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.8.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.8/cyrus-
+     imapd-2.5.8.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.8/cyrus-
      imapd-2.5.8.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.9.txt 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.9.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/2.5/x/2.5.9.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/2.5/x/2.5.9.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 2.5.0 Release Notes for important information
   about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.9/cyrus-
+     imapd-2.5.9.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-2.5.9/cyrus-
      imapd-2.5.9.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/index.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/index.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/index.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/index.txt	2020-05-04 04:13:56.000000000 +0000
@@ -2,8 +2,6 @@
 Cyrus IMAP 3.0 Releases
 ***********************
 
-* Cyrus IMAP 3.0.0 Release Notes
-
 * Cyrus IMAP 3.0.0 beta1 Release Notes
 
 * Cyrus IMAP 3.0.0 beta2 Release Notes
@@ -24,15 +22,9 @@ Cyrus IMAP 3.0 Releases
 
 * Cyrus IMAP 3.0.0 rc4 Release Notes
 
-* Cyrus IMAP 3.0.1 Release Notes
-
-* Cyrus IMAP 3.0.10 Release Notes
-
-* Cyrus IMAP 3.0.11 Release Notes
-
-* Cyrus IMAP 3.0.12 Release Notes
+* Cyrus IMAP 3.0.0 Release Notes
 
-* Cyrus IMAP 3.0.13 Release Notes
+* Cyrus IMAP 3.0.1 Release Notes
 
 * Cyrus IMAP 3.0.2 Release Notes
 
@@ -49,3 +41,11 @@ Cyrus IMAP 3.0 Releases
 * Cyrus IMAP 3.0.8 Release Notes
 
 * Cyrus IMAP 3.0.9 Release Notes
+
+* Cyrus IMAP 3.0.10 Release Notes
+
+* Cyrus IMAP 3.0.11 Release Notes
+
+* Cyrus IMAP 3.0.12 Release Notes
+
+* Cyrus IMAP 3.0.13 Release Notes
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta1.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta1.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta1/cyrus-
      imapd-3.0.0-beta1.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta1.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta1.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta1/cyrus-
      imapd-3.0.0-beta1.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta2.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta2.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta2.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta2/cyrus-
      imapd-3.0.0-beta2.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta2.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta2.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta2/cyrus-
      imapd-3.0.0-beta2.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta3.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta3.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta3.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta3/cyrus-
      imapd-3.0.0-beta3.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta3.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta3.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta3/cyrus-
      imapd-3.0.0-beta3.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta4.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta4.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta4.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta4/cyrus-
      imapd-3.0.0-beta4.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta4.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta4.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta4/cyrus-
      imapd-3.0.0-beta4.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta5.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta5.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta5.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta5.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta5/cyrus-
      imapd-3.0.0-beta5.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta5.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta5.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta5/cyrus-
      imapd-3.0.0-beta5.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta6.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta6.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta6.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-beta6.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,20 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta6/cyrus-
      imapd-3.0.0-beta6.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-beta6.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
-     imapd-3.0.0-beta6.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-beta6/cyrus-
      imapd-3.0.0-beta6.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc1.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc1.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz
-
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-rc1.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc1/cyrus-
      imapd-3.0.0-rc1.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc1/cyrus-
      imapd-3.0.0-rc1.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc2.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc2.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc2.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz
-
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-rc2.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc2/cyrus-
      imapd-3.0.0-rc2.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc2/cyrus-
      imapd-3.0.0-rc2.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc3.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc3.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc3.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz
-
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-rc3.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc3/cyrus-
      imapd-3.0.0-rc3.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc3/cyrus-
      imapd-3.0.0-rc3.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc4.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc4.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0-rc4.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,19 +6,14 @@ Warning: Cyrus IMAP 3.0 is under active
   change.Do **NOT** use this version unless you're a developer of
   sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz
-
-   * http://www.cyrusimap.org/releases/cyrus-
-     imapd-3.0.0-rc4.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc4/cyrus-
      imapd-3.0.0-rc4.tar.gz
 
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0-rc4/cyrus-
      imapd-3.0.0-rc4.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.0.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.0.txt	2020-05-04 04:13:56.000000000 +0000
@@ -2,17 +2,14 @@
 Cyrus IMAP 3.0.0 Release Notes
 ******************************
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0/cyrus-
+     imapd-3.0.0.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.0/cyrus-
      imapd-3.0.0.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.1.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.1.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.1/cyrus-
+     imapd-3.0.1.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.1/cyrus-
      imapd-3.0.1.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.2.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.2.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.2.txt	2020-05-04 04:13:56.000000000 +0000
@@ -8,17 +8,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.2/cyrus-
+     imapd-3.0.2.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.2/cyrus-
      imapd-3.0.2.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.3.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.3.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.3.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.3/cyrus-
+     imapd-3.0.3.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.3/cyrus-
      imapd-3.0.3.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.4.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.4.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.4.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.4/cyrus-
+     imapd-3.0.4.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.4/cyrus-
      imapd-3.0.4.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.5.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.5.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.5.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.5.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.5/cyrus-
+     imapd-3.0.5.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.5/cyrus-
      imapd-3.0.5.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.6.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.6.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.6.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.6.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.6/cyrus-
+     imapd-3.0.6.tar.gz
 
-   * http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.6/cyrus-
      imapd-3.0.6.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.7.txt 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.7.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.0/x/3.0.7.txt	2019-12-16 04:18:24.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.0/x/3.0.7.txt	2020-05-04 04:13:56.000000000 +0000
@@ -6,17 +6,14 @@ Important: This is a bug-fix release in
   to the Cyrus IMAP 3.0.0 Release Notes for important information
   about the 3.0 series, including upgrading instructions.
 
-Download via HTTPS:
+Download from GitHub:
 
-   * https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.7/cyrus-
+     imapd-3.0.7.tar.gz
 
-   * https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz.sig
-
-Download via FTP:
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz
-
-   * ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.0.7/cyrus-
      imapd-3.0.7.tar.gz.sig
 
 
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/index.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/index.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/index.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/index.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,29 @@
+
+Cyrus IMAP 3.1 Tags
+*******************
+
+Warning: The 3.1 series are tagged snapshots of the master branch,
+  and should be considered for **testing purposes** and **bleeding-
+  edge features** only. We will try to tag these snapshots at coherent
+  development points, but there will generally be **large breaking
+  changes** occurring between releases in this series.
+
+* Cyrus IMAP 3.1.0-dev Release Notes
+
+* Cyrus IMAP 3.1.1 Tag Notes
+
+* Cyrus IMAP 3.1.2 Tag Notes
+
+* Cyrus IMAP 3.1.3 Tag Notes
+
+* Cyrus IMAP 3.1.4 Tag Notes
+
+* Cyrus IMAP 3.1.5 Tag Notes
+
+* Cyrus IMAP 3.1.6 Tag Notes
+
+* Cyrus IMAP 3.1.7 Tag Notes
+
+* Cyrus IMAP 3.1.8 Tag Notes
+
+* Cyrus IMAP 3.1.9 Tag Notes
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.0-dev.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.0-dev.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.0-dev.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.0-dev.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,28 @@
+
+Cyrus IMAP 3.1.0-dev Release Notes
+**********************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+
+Major changes since the 3.0.x series
+====================================
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The per-user calendar and addressbook administrative web user
+  interfaces (e.g. /dav/calendars/user/<userid>) are now disabled by
+  default.  They can be enabled with the *caldav_allowcalendaradmin*
+  and *carddav_allowaddressbookadmin* options respectively.
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.1.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,43 @@
+
+Cyrus IMAP 3.1.1 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.2.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.2.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,52 @@
+
+Cyrus IMAP 3.1.2 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230. [ http://cve.mitre.org/cgi-
+  bin/cvename.cgi?name=CVE-2017-14230 ]
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.3.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.3.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.3.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,52 @@
+
+Cyrus IMAP 3.1.3 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230. [ http://cve.mitre.org/cgi-
+  bin/cvename.cgi?name=CVE-2017-14230 ]
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.4.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.4.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.4.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,58 @@
+
+Cyrus IMAP 3.1.4 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Support for the Sphinx backend to squatter searches has been
+  removed.
+
+* new cyrus.index format v14 included in 3.1.4 - adds unseen count
+  to index header
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230. [ http://cve.mitre.org/cgi-
+  bin/cvename.cgi?name=CVE-2017-14230 ]
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.5.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.5.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.5.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.5.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,59 @@
+
+Cyrus IMAP 3.1.5 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Support for the Sphinx backend to squatter searches has been
+  removed.
+
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count
+  and createdmodseq to index header, savedate and createdmodseq to
+  index records
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230. [ http://cve.mitre.org/cgi-
+  bin/cvename.cgi?name=CVE-2017-14230 ]
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.6.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.6.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.6.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.6.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,75 @@
+
+Cyrus IMAP 3.1.6 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* JMAP improvements.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Support for the Sphinx backend to squatter searches has been
+  removed.
+
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count
+  and createdmodseq to index header, savedate and createdmodseq to
+  index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this.
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230. [ http://cve.mitre.org/cgi-
+  bin/cvename.cgi?name=CVE-2017-14230 ]
+
+
+Significant bugfixes
+====================
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.7.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.7.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.7.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.7.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,90 @@
+
+Cyrus IMAP 3.1.7 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* Support for JMAP.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Removed support for the Sphinx backend to squatter searches.
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this.
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.8.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.8.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.8.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.8.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,106 @@
+
+Cyrus IMAP 3.1.8 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* Support for JMAP.
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Removed support for the Sphinx backend to squatter searches.
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this.
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.9.txt 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.9.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.1/x/3.1.9.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.1/x/3.1.9.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,122 @@
+
+Cyrus IMAP 3.1.9 Tag Notes
+**************************
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+Warning: This should be considered for **testing purposes** and
+  **bleeding- edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+
+* Caldav and Carddav improvements.
+
+* Support for JMAP core protocol (**RFC 8620**).
+
+* Support for JMAP Mail (**RFC 8621**).
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5)).
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5)).
+
+* Xapian bug fixes.
+
+* Improvements to Annotations handling.
+
+* DRAC support has been deprecated.
+
+* Support for Prometheus stats.
+
+* Removed support for the Sphinx backend to squatter searches.
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this.
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames).
+
+
+Updates to default configuration
+================================
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/index.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/index.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/index.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/index.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,15 @@
+
+Cyrus IMAP 3.2 Releases
+***********************
+
+* Cyrus IMAP 3.2.0-beta1 Release Notes
+
+* Cyrus IMAP 3.2.0-beta2 Release Notes
+
+* Cyrus IMAP 3.2.0-beta3 Release Notes
+
+* Cyrus IMAP 3.2.0-beta4 Release Notes
+
+* Cyrus IMAP 3.2.0-rc1 Release Notes
+
+* Cyrus IMAP 3.2.0 Release Notes
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta1.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,150 @@
+
+Cyrus IMAP 3.2.0-beta1 Release Notes
+************************************
+
+Warning: This is a beta release and may contain fun bugs.  Testing
+  it out and providing feedback would be greatly appreciated, but do
+  not run this on your production mail stores!
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta1/cyrus-
+     imapd-3.2.0-beta1.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta1/cyrus-
+     imapd-3.2.0-beta1.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta2.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta2.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta2.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta2.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,150 @@
+
+Cyrus IMAP 3.2.0-beta2 Release Notes
+************************************
+
+Warning: This is a beta release and may contain fun bugs.  Testing
+  it out and providing feedback would be greatly appreciated, but do
+  not run this on your production mail stores!
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta2/cyrus-
+     imapd-3.2.0-beta2.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta2/cyrus-
+     imapd-3.2.0-beta2.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta3.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta3.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta3.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta3.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,163 @@
+
+Cyrus IMAP 3.2.0-beta3 Release Notes
+************************************
+
+Warning: This is a beta release and may contain fun bugs.  Testing
+  it out and providing feedback would be greatly appreciated, but do
+  not run this on your production mail stores!
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta3/cyrus-
+     imapd-3.2.0-beta3.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta3/cyrus-
+     imapd-3.2.0-beta3.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Replication safety improvements
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+* New *zoneinfo_dir* imapd.conf(5) option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The
+  default is to let libical find them itself.  If the *tzdist* http
+  module is enabled, this option is mandatory.
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+* The *tzdist* http module now finds its timezone data directory
+  according to the new *zoneinfo_dir* imapd.conf(5) option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using
+  this module, you MUST now set this option explicitly.  Calendaring
+  services will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta4.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta4.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta4.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-beta4.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,166 @@
+
+Cyrus IMAP 3.2.0-beta4 Release Notes
+************************************
+
+Warning: This is a beta release and may contain fun bugs.  Testing
+  it out and providing feedback would be greatly appreciated, but do
+  not run this on your production mail stores!
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta4/cyrus-
+     imapd-3.2.0-beta4.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-beta4/cyrus-
+     imapd-3.2.0-beta4.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Replication safety improvements
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+* New *zoneinfo_dir* imapd.conf(5) option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The
+  default is to let libical find them itself.  If the *tzdist* http
+  module is enabled, this option is mandatory.
+
+* The iso-8859-1 charset is now treated as an alias for
+  windows-1252, as per WHATWG Encoding for emails and websites
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+* The *tzdist* http module now finds its timezone data directory
+  according to the new *zoneinfo_dir* imapd.conf(5) option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using
+  this module, you MUST now set this option explicitly.  Calendaring
+  services will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-rc1.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-rc1.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0-rc1.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0-rc1.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,166 @@
+
+Cyrus IMAP 3.2.0-rc1 Release Notes
+**********************************
+
+Warning: This is a beta release and may contain fun bugs.  Testing
+  it out and providing feedback would be greatly appreciated, but do
+  not run this on your production mail stores!
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-rc1/cyrus-
+     imapd-3.2.0-rc1.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0-rc1/cyrus-
+     imapd-3.2.0-rc1.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Replication safety improvements
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+* New *zoneinfo_dir* imapd.conf(5) option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The
+  default is to let libical find them itself.  If the *tzdist* http
+  module is enabled, this option is mandatory.
+
+* The iso-8859-1 charset is now treated as an alias for
+  windows-1252, as per WHATWG Encoding for emails and websites
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+* The *tzdist* http module now finds its timezone data directory
+  according to the new *zoneinfo_dir* imapd.conf(5) option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using
+  this module, you MUST now set this option explicitly.  Calendaring
+  services will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0.txt 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/3.2/x/3.2.0.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/3.2/x/3.2.0.txt	2020-05-04 04:13:57.000000000 +0000
@@ -0,0 +1,162 @@
+
+Cyrus IMAP 3.2.0 Release Notes
+******************************
+
+Download from GitHub:
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0/cyrus-
+     imapd-3.2.0.tar.gz
+
+   * https://github.com/cyrusimap/cyrus-
+     imapd/releases/download/cyrus- imapd-3.2.0/cyrus-
+     imapd-3.2.0.tar.gz.sig
+
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+
+* Replication safety improvements
+
+* Caldav and Carddav improvements
+
+* Support for JMAP core protocol (**RFC 8620**)
+
+* Support for JMAP Mail (**RFC 8621**)
+
+* Experimental support for JMAP Contacts (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Experimental support for JMAP Calendars (requires
+  *jmap_nonstandard_extensions: yes* in imapd.conf(5))
+
+* Xapian bug fixes
+
+* Improvements to Annotations handling
+
+* DRAC support has been deprecated
+
+* Support for Prometheus stats
+
+* SNMP stats support has been deprecated
+
+* Removed support for the Sphinx backend to squatter searches
+
+* New cyrus.index format v16 included since 3.1.5 - adds unseen
+  count and createdmodseq to index header, savedate and createdmodseq
+  to index records
+
+* Support for WebSockets
+
+* Support for HTTP/2.0
+
+* Experimental support for Zeroskip database format
+
+* Intermediate mailboxes are now recorded in mailboxes database
+
+* Conversations database format update - adds flags and internaldate
+  fields, and is now versioned for future-compatibility.  You will
+  need to rebuild your conversations databases with
+  ctl_conversationsdb(8) and the *-b* switch to benefit from this
+
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES,
+  which respectively return the unique ids or names of the containing
+  mailboxes of each message in the sequence (for best performance,
+  rebuild your conversations databases as above)
+
+* mbpath(8) is now much more useful
+
+* Twoskip database format now supports shared locks, and ensures
+  record headers do not span disk block boundaries
+
+* All Cyrus binaries now use real sysexits exit codes instead of
+  mapping nearly everything to EX_TEMPFAIL
+
+* CyrusDB errors now syslog the actual error instead of just
+  "cyrusdb error"
+
+* New *allowdeleted* imapd.conf(5) option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages
+  over IMAP
+
+* cyr_virusscan(8) now supports custom templates for notifications
+  sent about infected messages that have been deleted
+
+* imapd.conf(5) options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+
+* The *tls_server_cert* and *tls_server_key* imapd.conf(5) options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.
+  Thanks Дилян Палаузов
+
+* Mailbox create/delete/rename are now performed under a lock on the
+  user's namespace, to prevent races (especially during big renames)
+
+* The cyr_info(8) *conf-lint* subcommand no longer complains about
+  channel-prefixed sync options
+
+* New *master_bind_errors_fatal* imapd.conf(5) option (default off),
+  with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default
+  and legacy behaviour is for master to start with the affected
+  services disabled, and not try to start them again until a SIGHUP is
+  received
+
+* New *autocreate_acl* imapd.conf(5) option, for specifying ACLs to
+  use when mailboxes are created by *autocreate_inbox_folders*
+
+* New *zoneinfo_dir* imapd.conf(5) option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The
+  default is to let libical find them itself.  If the *tzdist* http
+  module is enabled, this option is mandatory.
+
+* The iso-8859-1 charset is now treated as an alias for
+  windows-1252, as per WHATWG Encoding for emails and websites
+
+
+Updates to default configuration
+================================
+
+The cyr_info(8) *conf*, *conf-all* and *conf-default* subcommands now
+accept an *-s <version>* argument to highlight imapd.conf(5) options
+that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version
+to check which configuration options you will need to re-examine and
+maybe change during the process.
+
+* The *specialusealways* option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The values accepted by *expunge_mode* have changed, please see the
+  documentation for more information about the changes.
+
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no
+  longer work unless *annotation_enable_legacy_commands* is enabled.
+
+* The *outbox_sendlater* option and its functionality have been
+  removed.
+
+* The *tzdist* http module now finds its timezone data directory
+  according to the new *zoneinfo_dir* imapd.conf(5) option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using
+  this module, you MUST now set this option explicitly.  Calendaring
+  services will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for CVE-2017-14230
+
+* Contains fix for CVE-2019-18928
+
+* Contains fix for CVE-2019-19783
+
+
+Significant bugfixes
+====================
+
+* Contains fix for Issue #2839
diff -pruN 3.0.13-5/doc/text/imap/download/release-notes/index.txt 3.2.0-3/doc/text/imap/download/release-notes/index.txt
--- 3.0.13-5/doc/text/imap/download/release-notes/index.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/release-notes/index.txt	2020-05-04 04:13:57.000000000 +0000
@@ -2,20 +2,21 @@
 Release Notes
 *************
 
-Cyrus has switched to an odd-even release cycle.
+Cyrus uses an odd-even release cycle.
 
 With our versioning system using "major.minor.micro" numbering, the
-minor number reveals whether a version is stable (even), or
+minor (middle) number reveals whether a version is stable (even), or
 development-only (odd).
 
-A 3.0.1 release is stable, but a 3.1.4 release is developmental only.
+A 3.**0**.1 release is stable, but a 3.**1**.4 release is
+developmental only.
 
 
 Stable Version
 ==============
 
 Latest stable version is . Documentation at
-https://www.cyrusimap.org/3.0/.
+https://www.cyrusimap.org/.
 
 
 Development Version
@@ -24,17 +25,25 @@ Development Version
 Latest development snapshot is . Documentation at
 https://www.cyrusimap.org/dev/.
 
-Warning: These are tagged snapshots of the master branch, and should
-  be considered for **testing purposes** and **bleeding-edge
-  features** only. We will try to tag these snapshots at coherent
-  development points, but there will generally be **large breaking
-  changes** occurring between releases in this series.
+Warning: Development versions are tagged snapshots of the master
+  branch, and should be considered for **testing purposes** and
+  **bleeding-edge features** only. We will try to tag these snapshots
+  at coherent development points, but there will generally be **large
+  breaking changes** occurring between releases in this series.
 
 
 Supported Product Series
 ========================
 
 
+Series 3.2
+----------
+
+Documentation at https://www.cyrusimap.org/3.2/.
+
+* Cyrus IMAP 3.2 Releases
+
+
 Series 3.0
 ----------
 
@@ -51,12 +60,10 @@ Documentation at https://www.cyrusimap.o
 * Cyrus IMAP 2.5 Releases
 
 
-Series 2.4
-----------
+Development snapshots
+=====================
 
-* Cyrus IMAP 2.4 Releases
-
-* Cyrus IMAP 2.4-caldav Releases
+* Cyrus IMAP 3.1 Tags
 
 
 Older Versions
@@ -69,7 +76,7 @@ Series 1
 * Cyrus IMAP 1.x Release Notes
 
 
-Series 2: 2.0 - 2.3
+Series 2: 2.0 - 2.4
 -------------------
 
 * Cyrus IMAP 2.0.x Release Notes
@@ -79,3 +86,7 @@ Series 2: 2.0 - 2.3
 * Cyrus IMAP 2.2.x Release Notes
 
 * Cyrus IMAP 2.3 Releases
+
+* Cyrus IMAP 2.4 Releases
+
+* Cyrus IMAP 2.4-caldav Releases
diff -pruN 3.0.13-5/doc/text/imap/download/upgrade.txt 3.2.0-3/doc/text/imap/download/upgrade.txt
--- 3.0.13-5/doc/text/imap/download/upgrade.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/download/upgrade.txt	2020-05-04 04:13:57.000000000 +0000
@@ -1,5 +1,5 @@
 
-Upgrading to 3.0
+Upgrading to 3.2
 ****************
 
 Note: This guide assumes that you are familiar and comfortable with
@@ -24,7 +24,7 @@ Upgrading: an overview
 
   * Do What As Who?
 
-* 2. Install new 3.0 Cyrus
+* 2. Install new 3.2 Cyrus
 
 * 3. Shut down existing Cyrus
 
@@ -34,7 +34,7 @@ Upgrading: an overview
 
 * 6. Upgrade specific items
 
-* 7. Start new 3.0 Cyrus and verify
+* 7. Start new 3.2 Cyrus and verify
 
 * 8. Reconstruct databases and cache
 
@@ -63,16 +63,16 @@ Installation from tarball
 You will need to install from our packaged tarball. We provide a full
 list of libraries that Debian requires, but we aren't able to test all
 platforms: you may find you need to install additional or different
-libraries to support v3.0.
+libraries to support v3.2.
 
 
 How are you planning on upgrading?
 ----------------------------------
 
-Ideally, you will do a sandboxed test installation of 3.0 using a
+Ideally, you will do a sandboxed test installation of 3.2 using a
 snapshot of your existing data before you switch off your existing
 installation. The rest of the instructions are assuming a sandboxed
-3.0 installation.
+3.2 installation.
 
 
 Upgrade by replicating
@@ -80,13 +80,13 @@ Upgrade by replicating
 
 If you're familiar with replication, and your current installation is
 2.4 or newer, you can set up your existing installation to replicate
-data to a new 3.0 installation and failover to the new installation
+data to a new 3.2 installation and failover to the new installation
 when you're ready. The replication protocol has been kept backwards
 compatible.
 
 If your old installation contains mailboxes or messages that are older
 than 2.4, they may not have GUID fields in their indexes (index
-version too old), or they may have their GUID field set to zero.  3.0
+version too old), or they may have their GUID field set to zero.  3.2
 will not accept message replications without valid matching GUIDs, so
 you need to fix this on your old installation first.
 
@@ -113,9 +113,24 @@ Upgrade in place
 If you are upgrading in place, you will need to shut down Cyrus
 entirely while you install the new package.  If your old installation
 was using Berkeley DB format databases, you will need to convert or
-upgrade the databases **before** you upgrade.  Cyrus v3.0 does not
+upgrade the databases **before** you upgrade.  Cyrus v3.2 does not
 support Berkeley DB at all.
 
+Note: If you are upgrading from Cyrus version 2.5 or earlier, and
+  your system is configured with the following combination in
+  imapd.conf(5):
+
+     fulldirhash: yes
+     hashimapspool: either yes or no
+     unixhierarchysep: yes
+
+  then you will not be able to upgrade-in-place.  This is due to a
+  change in how directory hashes are calculated for users whose
+  localpart contains a dot, which was introduced in 3.0.0.  After an
+  in-place upgrade, Cyrus will not be able to find these users'
+  metadata and/or mailboxes.If you have this configuration, you will
+  need to upgrade by replicating, not in place.
+
 
 Do What As Who?
 ---------------
@@ -141,10 +156,10 @@ We strongly recommend that you read this
 upgrading.
 
 
-2. Install new 3.0 Cyrus
+2. Install new 3.2 Cyrus
 ========================
 
-Download the release 3.0 package tarball.
+Download the release 3.2 package tarball.
 
 Fetch the libraries for your platform. The full list (including all
 optional packages) for Debian is:
@@ -195,7 +210,7 @@ We recommend backing up all your data be
 * Cyrus Databases
 
 (You do already have a backup strategy in place, right? Once you're on
-3.0, you can consider using the experimental backup tools.)
+3.2, you can consider using the experimental backup tools.)
 
 Copy all of this to the new instance, using "rsync" or similar tools.
 
@@ -212,7 +227,7 @@ server):
    rsync -aHv oldimap:/var/lib/cyrus/. /var/lib/cyrus/.
    rsync -aHv oldimap:/var/spool/cyrus/. /var/spool/cyrus/.
 
-You don't need to copy the following databases as Cyrus 3.0 will
+You don't need to copy the following databases as Cyrus 3.2 will
 recreate these for you automatically:
 
 * duplicate delivery (deliver.db),
@@ -261,9 +276,10 @@ anything you have provided overrides for
    cyr_info conf-all -C <path to imapd.conf> -M <path to cyrus.conf>
 
 **Important config** options: "unixhierarchysep:" and "altnamespace:"
-defaults have changed in imapd.conf(5). Implications are outlined in
-the Note in User Namespace Mode and Switching the Alternative
-Namespace.  Please also see "Sieve Scripts," below.
+defaults in imapd.conf(5) changed in 3.0, which will affect you if you
+are upgrading to 3.2 from something earlier than 3.0. Implications are
+outlined in the Note in User Namespace Mode and Switching the
+Alternative Namespace.  Please also see "Sieve Scripts," below.
 
 * unixhierarchysep: on
 
@@ -287,43 +303,24 @@ section.
      annotations in your new install with the cvt_xlist_specialuse(8)
      tool
 
-* Sieve Scripts
-
-     Since defaults for options: "unixhierarchysep:" and
-     "altnamespace:" have changed in imapd.conf(5), you may very
-     likely need to modify any sieve scripts already on your system.
-     Fear not, there's a tool for this task, called translatesieve(8).
-     This tool can handle situations where either or both of these
-     settings need change. Please consult the man page for details.
-
-     Consider the following example, where the prior configuration was
-     already using "altnamespace: on", but was *not* using
-     "unixhierarchysep: on":
-
-        # su cyrus -c "/usr/lib/cyrus/upgrade/translatesieve -a"
-        you are using /var/lib/imap/sieve as your sieve directory.
-        translating sievedir /var/lib/imap/sieve... converting separator from '.' to '/'
-        not changing name space.
-        done
-
-Warning: **Berkeley db format no longer supported**If you have any
-  databases using Berkeley db, they'll need to be converted to
-  skiplist or flat *in your existing installation*. And then
-  optionally converted to whatever final format you'd like in your 3.0
+Warning: **Berkeley db format no longer supported since 3.0**If you
+  have any databases using Berkeley db, they'll need to be converted
+  to skiplist or flat *in your existing installation*. And then
+  optionally converted to whatever final format you'd like in your 3.2
   installation.Databases potentially affected: mailboxes, annotations,
   conversations, quotas.On old install, prior to migration:
 
      cvt_cyrusdb /<configdirectory>mailboxes.db berkeley /tmp/new-mailboxes.db skiplist
 
-  If you don't want to use flat or skiplist for 3.0, you can use the
-  new 3.0 cvt_cyrusdb(8) to swap to new format:
+  If you don't want to use flat or skiplist for 3.2, you can use the
+  new 3.2 cvt_cyrusdb(8) to swap to new format:
 
      cvt_cyrusdb /tmp/new-mailboxes.db skiplist /<configdirectory>/mailboxes.db <new file format>
 
 Note: The cvt_cyrusdb(8) command does not accept relative paths.
 
 
-7. Start new 3.0 Cyrus and verify
+7. Start new 3.2 Cyrus and verify
 =================================
 
    sudo ./master/master -d
@@ -331,12 +328,12 @@ Note: The cvt_cyrusdb(8) command does no
 Check "/var/log/syslog" for errors so you can quickly understand
 potential problems.
 
-When you're satisfied version 3.0 is running and can see all its data
+When you're satisfied version 3.2 is running and can see all its data
 correctly, start the new Cyrus up with your regular init script.
 
 If something has gone wrong, contact us on the mailing list. You can
 revert to backups and keep processing mail using your old version
-until you're able to finish your 3.0 installation.
+until you're able to finish your 3.2 installation.
 
 Note: If you've disable your system startup scripts, as recommended
   in step 2, remember to re-enable them.  Use something like
@@ -346,12 +343,6 @@ Note: If you've disable your system star
 8. Reconstruct databases and cache
 ==================================
 
-Warning: Versions of 3.0 prior to 3.0.11 contained a bug (Issue
-  #2389) that could lead to loss of seen state/flags during
-  *reconstruct* for some messages that already existed prior to Cyrus
-  2.3.  The 3.0.11 release notes contain the specifics.Consider
-  upgrading to 3.0.11 rather than an earlier release.
-
 The following steps can each take a long time, so we recommend running
 them one at a time (to reduce locking contention and high I/O load).
 
@@ -361,7 +352,7 @@ hours, possibly days.
    reconstruct -V max
 
 New configuration: if turning on conversations, you need to create
-conversations.db for each user.:
+conversations.db for each user. (This is required for jmap).:
 
    ctl_conversationsdb -b -r
 
@@ -375,19 +366,33 @@ format changes.:
 
    dav_reconstruct -a
 
+If you are upgrading from 3.0, and have the *reverseacls* feature
+enabled in imapd.conf(5), you may need to regenerate the data it uses
+(which is stored in *mailboxes.db*).  This is automatically
+regenerated at startup by *ctl_cyrusdb -r* if the *reverseacls*
+setting has changed. So, to force a regeneration:
 
-9. Do you want any new features?
-================================
+   1. Shut down Cyrus
+
+   2. Change *reverseacls* to *0* in imapd.conf(5)
 
-3.0 comes with many lovely new features. Consider which ones you want
-to enable. Here are some which may interest you. Check the 3.0 release
-notes for the full list.
+   3. Run ctl_cyrusdb(8) with the *-r* switch (or just start Cyrus,
+      assuming your cyrus.conf(5) contains a *ctl_cyrusdb -r* entry in
+      the START section).  The old RACL entries will be removed
 
-* Backups
+   4. (If you started Cyrus, shut it down again)
 
-* Xapian for searching
+   5. Change *reverseacls* back to *1*
+
+   6. Start up Cyrus (or run *ctl_cyrusdb -r*).  The RACL entries
+      will be rebuilt
+
+
+9. Do you want any new features?
+================================
 
-* Cross-domain support. See "crossdomains" in imapd.conf(5)
+3.2 comes with many lovely new features. Consider which ones you want
+to enable. Check the 3.2 release notes for the full list.
 
 
 10. Upgrade complete
@@ -414,9 +419,9 @@ time.
 Upgrade your mupdate master and front ends last.
 
 If you are upgrading from 2.4, and wish to use XFER to transfer your
-mailboxes to your new 3.0 server, please consider first upgrading your
+mailboxes to your new 3.2 server, please consider first upgrading your
 2.4 setup to version 2.4.19 or later.  Earlier versions of 2.4 do not
-correctly recognise the 2.5 and 3.0 mailbox versions, and will
+correctly recognise the 2.5 and later mailbox versions, and will
 downgrade mailboxes (losing metadata) in transit.  2.4.19 and later
-versions correctly recognise 2.5 and 3.0 servers, and will not
+versions correctly recognise 2.5 and later servers, and will not
 downgrade mailbox versions in transit.
diff -pruN 3.0.13-5/doc/text/imap/installing.txt 3.2.0-3/doc/text/imap/installing.txt
--- 3.0.13-5/doc/text/imap/installing.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/installing.txt	2020-05-04 04:13:57.000000000 +0000
@@ -402,7 +402,7 @@ For cyrus.conf(5), again we'll start wit
      recover       cmd="ctl_cyrusdb -r"
    }
 
-   # UNIX sockets start with a slash and are put into /var/imap/socket
+   # UNIX sockets start with a slash and are put into /run/cyrus/socket
    SERVICES {
      # add or remove based on preferences
      imap          cmd="imapd" listen="imap" prefork=0
@@ -421,10 +421,13 @@ For cyrus.conf(5), again we'll start wit
 
      # at least one LMTP is required for delivery
    #  lmtp          cmd="lmtpd" listen="lmtp" prefork=0
-     lmtpunix      cmd="lmtpd" listen="/var/imap/socket/lmtp" prefork=0
+     lmtpunix      cmd="lmtpd" listen="/run/cyrus/socket/lmtp" prefork=0
+
+     # this is requied if using socketmap
+   #  smmap         cmd="smmapd" listen="/run/cyrus/socket/smmap" prefork=0
 
      # this is required if using notifications
-   #  notify        cmd="notifyd" listen="/var/imap/socket/notify" proto="udp" prefork=1
+   #  notify        cmd="notifyd" listen="/run/cyrus/socket/notify" proto="udp" prefork=1
    }
 
    EVENTS {
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/eventsource.txt 3.2.0-3/doc/text/imap/reference/admin/eventsource.txt
--- 3.0.13-5/doc/text/imap/reference/admin/eventsource.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/eventsource.txt	2020-05-04 04:13:57.000000000 +0000
@@ -80,7 +80,8 @@ These need to be set in imapd.conf(5).
       *vnd.cmu.davFilename*, *vnd.cmu.davUid*,
       *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*,
       *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*,
-      *vnd.fastmail.cid*, *vnd.fastmail.counters*
+      *vnd.fastmail.cid*, *vnd.fastmail.counters*, *vnd.cmu.emailid*,
+      *vnd.cmu.threadid*
 
    "event_groups:" message mailbox
 
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/locations/configuration-state.txt 3.2.0-3/doc/text/imap/reference/admin/locations/configuration-state.txt
--- 3.0.13-5/doc/text/imap/reference/admin/locations/configuration-state.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/locations/configuration-state.txt	2020-05-04 04:13:58.000000000 +0000
@@ -214,10 +214,6 @@ Note: If your configuration uses "quota_
 
       Unix domain socket that the mail notification daemon listens on.
 
-   "sphinx_socket:" {configdirectory}/socket/sphinx
-
-      Unix domain socket that the Sphinx searchd daemons listens on.
-
 
 Per-user State Directories
 **************************
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/locations/searchtiers.txt 3.2.0-3/doc/text/imap/reference/admin/locations/searchtiers.txt
--- 3.0.13-5/doc/text/imap/reference/admin/locations/searchtiers.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/locations/searchtiers.txt	2020-05-04 04:13:58.000000000 +0000
@@ -25,7 +25,7 @@ Specify the name of the default search t
       This option MUST be specified for xapian search.
 
 
-Search Tier Partition location
+Search Tier Partition Location
 ==============================
 
 Each search tier to be used requires a partition location be specified
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/monitoring.txt 3.2.0-3/doc/text/imap/reference/admin/monitoring.txt
--- 3.0.13-5/doc/text/imap/reference/admin/monitoring.txt	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/monitoring.txt	2020-05-04 04:13:58.000000000 +0000
@@ -0,0 +1,63 @@
+
+Monitoring
+**********
+
+Cyrus IMAP supports monitoring using Prometheus.
+
+To use this functionality, Cyrus IMAP must have been built with the "
+--enable-http" configure option enabled.
+
+
+Setup
+=====
+
+   * Set the *prometheus_enabled* setting in imapd.conf(5) to "yes"
+
+   * Add the *prometheus* module to your *httpmodules* in
+     imapd.conf(5)
+
+   * Set the *prometheus_need_auth*, *prometheus_update_freq* and
+     *prometheus_stats_dir* settings in imapd.conf(5) to taste
+
+   * Add a job to run "promstatsd -c" to the START section of
+     cyrus.conf(5) (this cleans up the stats files from the previous
+     run)
+
+   * Add a job to run "promstatsd" to the DAEMON section of
+     cyrus.conf(5) (the actual daemon process)
+
+   * Configure your Prometheus server to scrape
+     http://yourserver.example.com/metrics
+
+
+Configuration options
+=====================
+
+      "prometheus_enabled:" 0
+
+         Whether tracking of service metrics for Prometheus is
+         enabled.
+
+      "prometheus_need_auth:" admin
+
+         Authentication level required to fetch Prometheus metrics.
+
+         Allowed values: *none*, *user*, *admin*
+
+      "prometheus_update_freq:" 10s
+
+         Frequency in at which promstatsd should re-collate its
+         statistics report.  The minimum value is 1 second, the
+         default is 10 seconds.
+
+         For backward compatibility, if no unit is specified, seconds
+         is assumed.
+
+      "prometheus_stats_dir:" <none>
+
+         Directory to use for gathering prometheus statistics.  If
+         specified, must be an absolute path.  If not specified, the
+         default path $configdirectory/stats/ will be used.  It may be
+         advantageous to locate this directory on ephemeral storage.
+
+Back to Administrator Guide
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/murder/murder-failure-modes.txt 3.2.0-3/doc/text/imap/reference/admin/murder/murder-failure-modes.txt
--- 3.0.13-5/doc/text/imap/reference/admin/murder/murder-failure-modes.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/murder/murder-failure-modes.txt	2020-05-04 04:13:58.000000000 +0000
@@ -71,11 +71,7 @@ format.
    with any missing changes.
 
 If you are using skiplist for your mailboxes.db then you can just copy
-the file. If you are using a berkeley format then things are trickier
-since there is environmental state. It should be possible to run
-db_recover on both databases, then delete the db folder the
-mailboxes.db from the murder master and copy those from the frontend
-(this has not been tested)
+the file.
 
 
 Hard recovery
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/ports/sockets.txt 3.2.0-3/doc/text/imap/reference/admin/ports/sockets.txt
--- 3.0.13-5/doc/text/imap/reference/admin/ports/sockets.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/ports/sockets.txt	2020-05-04 04:13:58.000000000 +0000
@@ -17,7 +17,6 @@ more recently "/run/cyrus/socket/":
    idle      <rundir>/idle   # idled daemon socket
    notify    <rundir>/notify # Notification daemon socket
    ptloader  <rundir>/ptsock # PT Loader socket (alternative authorization)
-   sphinx    <rundir>/sphinx # Sphinx full-text search daemon socket
 
 
 Controlling Socket Locations
@@ -43,7 +42,3 @@ via the use of several settings in imapd
 
       Unix domain socket that ptloader listens on. (defaults to
       configdirectory/ptclient/ptsock)
-
-   "sphinx_socket:" {configdirectory}/socket/sphinx
-
-      Unix domain socket that the Sphinx searchd daemons listens on.
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/quotas.txt 3.2.0-3/doc/text/imap/reference/admin/quotas.txt
--- 3.0.13-5/doc/text/imap/reference/admin/quotas.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/quotas.txt	2020-05-04 04:13:58.000000000 +0000
@@ -95,7 +95,7 @@ more about the pertinent settings:
          The cyrusdb backend to use for quotas.
 
          Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*,
-         *twoskip*, *lmdb*
+         *twoskip*, *zeroskip*
 
       "quota_db_path:" <none>
 
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/sieve.txt 3.2.0-3/doc/text/imap/reference/admin/sieve.txt
--- 3.0.13-5/doc/text/imap/reference/admin/sieve.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/sieve.txt	2020-05-04 04:13:58.000000000 +0000
@@ -282,6 +282,18 @@ Sieve has a lot of extensions. Cyrus sup
 
 * Variables **RFC 5229**
 
+* Editheader Extension **RFC 5293**
+
+* Reject and Extended Reject **RFC 5429**
+
+* Externally Stored Lists **RFC 6134**
+
+* Duplicate Extension **RFC 7352**
+
+* Ihave Extension **RFC 5463**
+
+* Delivering to Special-Use Mailboxes Draft special-use RFC
+
 * IMAP flag Extension Draft imap flags RFC
 
 * Body Extension **RFC 5173**
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/sop/mailbox-quota.txt 3.2.0-3/doc/text/imap/reference/admin/sop/mailbox-quota.txt
--- 3.0.13-5/doc/text/imap/reference/admin/sop/mailbox-quota.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/sop/mailbox-quota.txt	2020-05-04 04:13:58.000000000 +0000
@@ -3,7 +3,7 @@ Mailbox Folders exempt from quota
 *********************************
 
 By creating an additional quota root, a folder's contents can be made
-excempt from counting towards the mailbox's quota.
+exempt from counting towards the mailbox's quota.
 
 Note: Making an INBOX/Archive/ Folder exempt from quota:
 
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/sop/replication.txt 3.2.0-3/doc/text/imap/reference/admin/sop/replication.txt
--- 3.0.13-5/doc/text/imap/reference/admin/sop/replication.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/sop/replication.txt	2020-05-04 04:13:58.000000000 +0000
@@ -315,7 +315,7 @@ section of cyrus.conf(5) like any of the
 
    EVENTS {
        <...>
-       # Peridoically sync ALL user mailboxes every 4 hours
+       # Periodically sync ALL user mailboxes every 4 hours
        syncclient       cmd="/usr/cyrus/bin/sync_client -A" period=240
 
        # Periodically sync changes at specific times
@@ -403,7 +403,7 @@ Then these entries in cyrus.conf(5) woul
 
 Again, this is just an example for illustration.  The system provides
 so much flexibility, and one can combine channels with chaining to
-acheive even more.
+achieve even more.
 
 
 Other Considerations
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/sop/userdeny.txt 3.2.0-3/doc/text/imap/reference/admin/sop/userdeny.txt
--- 3.0.13-5/doc/text/imap/reference/admin/sop/userdeny.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/sop/userdeny.txt	2020-05-04 04:13:58.000000000 +0000
@@ -6,6 +6,8 @@ The user_deny database allows you to den
 the user can authenticate to the Cyrus server. For example, if the
 authentication data is also used for other network services.
 
+Use cyr_deny(8) to manage the database.
+
 If the user_deny.db file doesn't exist in %configdirectory% (often
 /var/lib/imap) then you'll need to create it. In the example below,
 /var/lib/imap/ is used.
@@ -14,19 +16,14 @@ If the user_deny.db file doesn't exist i
    # /usr/lib/cyrus-imapd/cvt_cyrusdb /tmp/user_deny.flat flat /var/lib/imap/user_deny.db skiplist
    # chown cyrus:cyrus /var/lib/imap/user_deny.db
 
-The database specification can be found at http://cyrusimap.org/docs
-/cyrus-imapd/2.4.17/internal/database-formats.php
-
-**Key:** <Userid>
-
-**Data:** <Version>TAB<Deny List (comma-separated wildmat
-patterns)>TAB<Deny Message>
+The database specification can be found at User Access (user_deny.db).
 
    # su - cyrus
-   $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2     pop3    Can't use pop."
+   $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2<tab>pop3<tab>Can't use pop."
 
-In order to type a tab character, you will need to escape your tabs.
-In bash, this is done by typing CTRL-v and then pressing Tab.
+Here *pop3* is the service name as spelled in cyrus.conf(5).  In order
+to type a tab character, you will need to escape your tabs. In bash,
+this is done by typing CTRL-v and then pressing Tab.
 
 If you got it right, when you authenticate via pop3 you should see
 something like the following:
diff -pruN 3.0.13-5/doc/text/imap/reference/admin/tweaking.txt 3.2.0-3/doc/text/imap/reference/admin/tweaking.txt
--- 3.0.13-5/doc/text/imap/reference/admin/tweaking.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin/tweaking.txt	2020-05-04 04:13:58.000000000 +0000
@@ -128,3 +128,25 @@ To gain performance, execute the followi
    to:
 
       CHATTRSYNC=0
+
+
+Mailbox locking
+---------------
+
+Cyrus IMAP uses fcntl(2) based file locking for mailboxes, for example
+during SELECT commands. To mitigate race conditions it locks mailbox
+names even for non-existing mailboxes. For example, if user foo issued
+the following command
+
+      SELECT INBOX.x
+
+for non-existing mailbox x, it creates a lock file
+
+      $CYRUS_CONFDIR/lock/user/foo/x.lock
+
+which might be left on the filesystem after completion of the command.
+
+This has in practice not shown to be an issue. If this is a concern
+however, keeping the lock file directory in a tmpfs allows for both
+fast locking and to purge stale locks during controlled Cyrus
+downtimes.
diff -pruN 3.0.13-5/doc/text/imap/reference/administration-tools.txt 3.2.0-3/doc/text/imap/reference/administration-tools.txt
--- 3.0.13-5/doc/text/imap/reference/administration-tools.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/administration-tools.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,114 +0,0 @@
-
-Tools & Utilities
-*****************
-
-
-arbitron
-========
-
-
-arbitronsort.pl
-===============
-
-
-chk_cyrus
-=========
-
-
-ctl_cyrusdb
-===========
-
-
-ctl_deliver
-===========
-
-
-ctl_mboxlist
-============
-
-
-cvt_cyrusdb
-===========
-
-
-cvt_cyrusdb_all
-===============
-
-
-cyr_dbtool
-==========
-
-
-cyr_df
-======
-
-
-cyrdump
-=======
-
-
-cyr_expire
-==========
-
-
-cyr_virusscan
-=============
-
-Tool to disinfect mailboxes by operation of external virus scanning
-library or provided IMAP SEARCH string.
-
-
-fetchnews
-=========
-
-
-cyr_sequence
-============
-
-
-cyr_synclog
-===========
-
-
-cyr_userseen
-============
-
-
-masssievec
-==========
-
-Script to mass compile Sieve scripts
-
-
-mbexamine
-=========
-
-
-mbpath
-======
-
-
-mkimap
-======
-
-
-mknewsgroups
-============
-
-
-rehash
-======
-
-
-translatesieve
-==============
-
-script to translate sieve scripts to use unixhierarchysep and/or
-altnamespace
-
-
-undohash
-========
-
-absolutely ancient (downgrade to prior 1.6.2+), probably should be
-obsoleted entirely
diff -pruN 3.0.13-5/doc/text/imap/reference/admin.txt 3.2.0-3/doc/text/imap/reference/admin.txt
--- 3.0.13-5/doc/text/imap/reference/admin.txt	2019-12-16 04:18:25.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/admin.txt	2020-05-04 04:13:57.000000000 +0000
@@ -154,6 +154,12 @@ Management
 
   * Apple Push Service
 
+* Monitoring
+
+  * Setup
+
+  * Configuration options
+
 * Mailbox Distribution
 
   * Selection Modes
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/feature-database-backend.txt 3.2.0-3/doc/text/imap/reference/faqs/feature-database-backend.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/feature-database-backend.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/feature-database-backend.txt	2020-05-04 04:13:58.000000000 +0000
@@ -4,14 +4,6 @@ Which database backend should I use for
 
 Here's a brief summary of the major database types:
 
-* **Berkeley DB**: Slow enumeration, fast random access, fast write,
-  binary support. However, it has proved to be somewhat unstable and
-  prone to locking problems.
-
-* **Berkeley DB (no sync)**: Slow enumeration, fast random access,
-  very fast write, binary support, but no guarantee of database
-  durability; recent writes can be lost on crashes.
-
 * **Skiplist**: Proprietary Cyrus Format, fast enumeration,
   moderately fast write, moderately fast random access, binary support
 
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/install-detecting-berkeley.txt 3.2.0-3/doc/text/imap/reference/faqs/install-detecting-berkeley.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/install-detecting-berkeley.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/install-detecting-berkeley.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,10 +0,0 @@
-
-Problems detecting Berkley DB on Red Hat Linux
-**********************************************
-
-Modern Redhat Linux ships with a Berkeley DB compiled "--with-
-pthreads", which Cyrus is unable to directly link against.
-
-You can either recompile Berkeley DB without pthread support, or you
-can add "-lpthread" to your LDFLAGS environment variable before you
-configure/build.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/install-linkerwarnings.txt 3.2.0-3/doc/text/imap/reference/faqs/install-linkerwarnings.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/install-linkerwarnings.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/install-linkerwarnings.txt	2020-05-04 04:13:58.000000000 +0000
@@ -23,14 +23,3 @@ happening, look for warnings from the li
 
 In this case, ClamAV is still linked against OpenSSL 1.0, while Cyrus
 is building with OpenSSL 1.1.
-
-
-Libical v1.0.1 or v2.0
-**********************
-
-You may see warnings regarding libical v2.0 being recommended to
-support certain functionality. Currently libical v1.0.1 is sufficient,
-unless you need/want RSCALE (non-gregorian recurrences), VPOLL
-(consensus scheduling), or VAVAILABILITY (specifying availability over
-time) functionality. If v2 is required, it will need to be installed
-from github.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/interop-slow-delivery.txt 3.2.0-3/doc/text/imap/reference/faqs/interop-slow-delivery.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/interop-slow-delivery.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/interop-slow-delivery.txt	2020-05-04 04:13:58.000000000 +0000
@@ -16,7 +16,7 @@ some common causes.
       machine
 
    4. Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die
-      and dissapear. Sometimes it just hangs. Not sure why, but
+      and disappear. Sometimes it just hangs. Not sure why, but
       restarting may help.
 
 If you have a large volume of mail then Cyrus Murder Mail Delivery has
@@ -26,5 +26,4 @@ We experienced some filesystem locking p
 lmtpd-processes to be started. Performance was seriously degraded,
 resulting in timeouts and endless retries. We use a postfix instance
 between to limit parallel deliveries to lmtpd resulting in much higher
-throughput. With berkeley-nosync as duplicate suppression db, 50-100
-Messages/sec are doable.
+throughput.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-annotations.txt 3.2.0-3/doc/text/imap/reference/faqs/o-annotations.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-annotations.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-annotations.txt	2020-05-04 04:13:58.000000000 +0000
@@ -18,8 +18,10 @@ Cyrus annotations are based on a draft (
   checks for the corresponding mailbox. (Draft RFC)
 
 * **/comment** - Sets a comment or description associated with the
-  mailbox. (cyradm(8)) /motd - Sets a "message of the day". The
-  message gets displayed as an ALERT after authentication.
+  mailbox. (cyradm(8))
+
+* **/motd** - Sets a "message of the day". The message gets
+  displayed as an ALERT after authentication.
 
 * **/sort** - Defines the default sort criteria [I-D.ietf-imapext-
   sort] to use when first displaying the mailbox contents to the user,
@@ -36,23 +38,26 @@ Cyrus annotations are based on a draft (
 
 * **vendor/cmu/cyrus-imapd/duplicatedeliver** - Flag signalling that
   we're allowing duplicate delivery of messages to the mailbox,
-  overriding system-wide duplicate suppression.
-  (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-
-  format.php)
+  overriding system-wide duplicate suppression. (Cyrus IMAP Server:
+  Mailbox File Formats)
 
 * **/vendor/cmu/cyrus-imapd/expire** - Sets the number of days after
   which messages will be expired from the mailbox. (cyradm(8))
 
+* **/vendor/cmu/cyrus-imapd/archive** - Sets the number of days
+  after which messages will be archived from the mailbox. (cyradm(8))
+
+* **/vendor/cmu/cyrus-imapd/delete** - Sets the number of days after
+  which messages will be deleted from the mailbox. (cyradm(8))
+
 * **/vendor/cmu/cyrus-imapd/freespace** - Undocumented.
 
 * **/vendor/cmu/cyrus-imapd/lastpop** - (time_t) of the last pop3
   login to this INBOX, used to enforce the "poptimeout" imapd.conf
-  option. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal
-  /mailbox-format.php)
+  option. (Cyrus IMAP Server: Mailbox File Formats)
 
 * **vendor/cmu/cyrus-imapd/lastupdate** - (time_t) of the last time
-  a message was appended (https://cyrusimap.org/docs/cyrus-
-  imapd/2.5.7/internal/mailbox-format.php)
+  a message was appended (Cyrus IMAP Server: Mailbox File Formats)
 
 * **/vendor/cmu/cyrus-imapd/news2mail** - Sets an email address to
   which messages injected into the server via NNTP will be sent.
@@ -62,8 +67,7 @@ Cyrus annotations are based on a draft (
 
 * **/vendor/cmu/cyrus-imapd/pop3newuidl** - Flag signalling that
   we're using "uidvalidity.uid" instead of just "uid" for the output
-  of the POP3 UIDL command. (https://cyrusimap.org/docs/cyrus-
-  imapd/2.5.7/internal/mailbox-format.php)
+  of the POP3 UIDL command. (Cyrus IMAP Server: Mailbox File Formats)
 
 * **/vendor/cmu/cyrus-imapd/serve** - Undocumented.
 
@@ -84,4 +88,4 @@ Cyrus annotations are based on a draft (
 * **/vendor/cmu/cyrus-imapd/size** - Undocumented.
 
 * **/vendor/cmu/cyrus-imapd/squat** - Indicates that the mailbox
-  should have a squat index created for it. (See squatter(8))
+  should be indexed. (See squatter(8))
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-berkeleydb.txt 3.2.0-3/doc/text/imap/reference/faqs/o-berkeleydb.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-berkeleydb.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-berkeleydb.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-
-Why does ctl_cyrusdb -r take so long with Berkeley DB?
-******************************************************
-
-Berkeley DB maintains a log of all the transactions since the last
-checkpoint of the database. In order to ensure the database is in a
-consistent state, you must recover the log after any outage (thus the
-recommendation to run these processes when Cyrus starts). They can
-take a long time for a few reasons.
-
-The most common one is that you need to checkpoint the cyrusdb more
-often. This can be done with a simple "ctl_cyrusdb -c". If you do this
-very often, the amount of log that needs to be recovered will be
-significantly shorter. We recommend doing this at least once every
-half hour, and more often on busy sites.
-
-The other reason is that your deliver.db may be very large. This is
-solvable by increasing the pruning interval (the -E parameter to
-ctl_deliver, which you should run on a regular basis), or (in a pinch)
-by just removing the database (since the effects of losing it do not
-prevent operation, they just cause vacation messages to be resent, and
-duplicate delivery suppression to possibly deliver duplicates).
-
-* "by increasing the pruning interval": My understanding is that the
-
-     number after "-E" is the number of days after which entries are
-     discarded. Is there a way to reduce it to a number of hours?
-     Since most of our mail is internal mail should rarely be delayed
-     by more then an hour or two.
-
-* In case it's useful to anyone we discovered that moving
-  /var/lib/imap
-
-     from an ext2 to an ext3 journaled filesystem made a vast
-     difference for the worse. While recovering the database Berkeley
-     DB does a vast quantity of small writes and that combined with
-     the updates to the journal absolutely kills disk performance
-     (with journalling it was taking about 40 minutes to start Cyrus
-     on a mail server with about 500 users and 200G of mail). On the
-     flip side moving /var/lib/imap to a hardware RAID system with a
-     decent amount of onboard cache reduced this time to under 30
-     seconds. I think Berkeley DB could probably be optimized to deal
-     with this better, but in the mean time avoid journaling
-     filesystems, or at least be prepared to experiment to find
-     something that works for you.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-db3-lockers.txt 3.2.0-3/doc/text/imap/reference/faqs/o-db3-lockers.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-db3-lockers.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-db3-lockers.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-
-Is the "db3: x Lockers" log message harmful?
-********************************************
-
-This message is generally not harmful unless it is increasing at an
-alarming rate or you are seeing other performance problems. It
-indicates contention within a Berkeley DB database page, and
-especially on small databases will occur quite frequently.
-
-If there are performance problems, often times the best solution is to
-convert your mailbox list to a skiplist format.
-
-Paul M Fleming (pfleming@siumed.edu) also notes:
-
-   We found limiting the number of lmtp processes to 10 helped with locker problems. Let sendmail/postfix handle the queuing and lmtp the delivery.. When we tried to blast 10-20 messages/sec at our test server locking became a problem with the duplicate delivery db. Across 3 servers and 600 concurrent logins (lmtpd maxchild=10 on each server) we never see any locking problems and usually have less than 1 second delivery times.
-
-Andreas (andreas@conectiva.com.br) writes:
-
-   Take a look at this text: http://www.openldap.org/faq/index.cgi?_highlightWords=locks&file=893
-
-   It's written for openldap, but explains several important Berkeley DB configuration parameters. In particular:
-
-       On a very busy system you might see error messages talking about running out of locks, lockers, or lock objects. Usually the default values are plenty, and in older versions of the BDB library the errors were more likely due to library bugs than actual system load. However, it is possible that you have actually run out of lock resources due to heavy system usage. If this happens, you should read about the set_lk_max_lockers[1], set_lk_max_locks[2], and set_lk_max_objects[3] keywords.
-
-   http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_lockers.html
-   http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_locks.html
-   http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_objects.html
-
-   The links above talk about the C api, but don't get alarmed, these paremeters can be set with a DB_CONFIG configuration file located in the DB environment home.
-
-I also suppose the *db_stat(8)* utility can be used to diagnose this.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-deleted-expired-expunged-purged.txt 3.2.0-3/doc/text/imap/reference/faqs/o-deleted-expired-expunged-purged.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-deleted-expired-expunged-purged.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-deleted-expired-expunged-purged.txt	2020-05-04 04:13:58.000000000 +0000
@@ -102,11 +102,11 @@ values:
 
 Exceptional circumstances aside, when "immediate" or "default" is the
 configured "expunge_mode", message files are often purged from the
-filesytem too quickly for anyone to recover.
+filesystem too quickly for anyone to recover.
 
 Note: One such exceptional circumstance is a mailbox with multiple
   sessions keeping the mailbox open. Cyrus IMAP ensures no mailbox
-  records dissappear from underneath an existing open mailbox session.
+  records disappear from underneath an existing open mailbox session.
 
 
 Moved to Trash Folder
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-deliverdb-size.txt 3.2.0-3/doc/text/imap/reference/faqs/o-deliverdb-size.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-deliverdb-size.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-deliverdb-size.txt	2020-05-04 04:13:58.000000000 +0000
@@ -9,5 +9,5 @@ lot of data there.
 
 Note also that it is common for databases to have unused space that
 may not be immediately recovered for performance reasons (this is the
-case with Berkeley DB and Cyrus Skiplist) You can control the size by
-increasing the frequency at which it gets pruned.
+case with Cyrus Skiplist) You can control the size by increasing the
+frequency at which it gets pruned.
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-otherdatabases.txt 3.2.0-3/doc/text/imap/reference/faqs/o-otherdatabases.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-otherdatabases.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-otherdatabases.txt	2020-05-04 04:13:58.000000000 +0000
@@ -17,4 +17,4 @@ in the mailboxes.
 Cyrus DOES have the option of using databases of various types for
 storing some other information, such as authentication data, mailbox
 lists, etc. There may be reasons to add a SQL backend to these
-databases in the future (in addition to flat, skiplist, and berkeley).
+databases in the future (in addition to flat, and skiplist).
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/o-sharedfilesystem-gpfs.txt 3.2.0-3/doc/text/imap/reference/faqs/o-sharedfilesystem-gpfs.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/o-sharedfilesystem-gpfs.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/o-sharedfilesystem-gpfs.txt	2020-05-04 04:13:58.000000000 +0000
@@ -28,16 +28,15 @@ Our Cyrus installation has about 80K use
 many millions of files. Just the number of files alone would be enough
 to kill the idea of using GPFS.
 
-Cyrus makes pretty extensive use of mmap(), and so does Berkeley DB.
-While GPFS implements mmap(), the GPFS architect had some words about
-the way certain operations are accomplished in Cyrus. I think there
-are (or used to be) places where an mmap'd file is opened for write
-with another file handle (or from another process). GPFS doesn't
-handle this well. This technique works accidentally on non-clustered
-filesystems because AIX (also) mmap's things for you behind your back
-(in addition to whatever you do) and then serializes all of the access
-to regions of those files. That's really the only reason why Cyrus
-works on JFS.
+Cyrus makes pretty extensive use of mmap(). While GPFS implements
+mmap(), the GPFS architect had some words about the way certain
+operations are accomplished in Cyrus. I think there are (or used to
+be) places where an mmap'd file is opened for write with another file
+handle (or from another process). GPFS doesn't handle this well. This
+technique works accidentally on non-clustered filesystems because AIX
+(also) mmap's things for you behind your back (in addition to whatever
+you do) and then serializes all of the access to regions of those
+files. That's really the only reason why Cyrus works on JFS.
 
 Also note that the other groups/developers within IBM (especially the
 group that does the automounter) have their collective heads up their
diff -pruN 3.0.13-5/doc/text/imap/reference/faqs/r-murder-ha.txt 3.2.0-3/doc/text/imap/reference/faqs/r-murder-ha.txt
--- 3.0.13-5/doc/text/imap/reference/faqs/r-murder-ha.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faqs/r-murder-ha.txt	2020-05-04 04:13:58.000000000 +0000
@@ -16,7 +16,7 @@ The mupdate server is indeed a single po
 failure at this point only prohibits message delivery (via the LMTP
 proxies that are querying it for up-to-date mailbox data) and certain
 mailbox operations (create, delete, setacl, and so on). Mail can still
-be accessed by all users of the system, and incoming mail will recieve
+be accessed by all users of the system, and incoming mail will receive
 temporary failures, so the sending MTA should continue to queue the
 mail.
 
diff -pruN 3.0.13-5/doc/text/imap/reference/faq.txt 3.2.0-3/doc/text/imap/reference/faq.txt
--- 3.0.13-5/doc/text/imap/reference/faq.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/faq.txt	2020-05-04 04:13:58.000000000 +0000
@@ -16,14 +16,10 @@ Installation Problems
 
 * Compilation errors about kssl.h and krb5.h on Red Hat Linux/Fedora
 
-* Problems detecting Berkley DB on Red Hat Linux
-
 * Help! There must be an easier way to get all this going...
 
 * OpenSSL Version Mismatches
 
-* Libical v1.0.1 or v2.0
-
 
 Common Feature Requests
 =======================
@@ -45,15 +41,11 @@ Common Operational Questions
 
 * What annotations are available?
 
-* Why does ctl_cyrusdb -r take so long with Berkeley DB?
-
 * Is it safe to put <configdirectory>/proc and
   <configdirectory>/lock on a tmpfs filesystem?
 
 * How to enable core dumps
 
-* Is the "db3: x Lockers" log message harmful?
-
 * Why can I not delete a mailbox as an admin user?
 
 * When is What ... Deleted, Expired, Expunged or Purged?
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/commands.txt 3.2.0-3/doc/text/imap/reference/manpages/commands.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/commands.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/commands.txt	2020-05-04 04:13:59.000000000 +0000
@@ -8,7 +8,7 @@ Man pages
 
 * **cyrus.conf**
 
-* imapd.conf
+* **imapd.conf**
 
 * **krb.equiv**
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/configs/cyrus.conf.txt 3.2.0-3/doc/text/imap/reference/manpages/configs/cyrus.conf.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/configs/cyrus.conf.txt	2019-12-16 04:18:26.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/configs/cyrus.conf.txt	2020-05-04 04:13:59.000000000 +0000
@@ -107,7 +107,7 @@ on certain Internet/UNIX sockets.
    listed in "/etc/services").
 
    If *host* is missing, 0.0.0.0 (all interfaces) is assumed.  Use
-   localhost or 127.0.0.1 to restict access, i.e. when a proxy on the
+   localhost or 127.0.0.1 to restrict access, i.e. when a proxy on the
    same host is front-ending Cyrus.
 
    Note that on most systems UNIX socket paths are limited to around
@@ -181,8 +181,9 @@ DAEMON
 ------
 
 This section lists long running daemons to start before any
-**SERVICES** are spawned.  They will be shutdown when master(8) is
-exiting.
+**SERVICES** are spawned.  master(8)  will ensure that these processes
+are running, restarting any process which dies or forks. All listed
+processes will be shutdown when master(8) is exiting.
 
    **cmd=**<no default>
 
@@ -232,6 +233,6 @@ separate access control rules.
 See Also
 ========
 
-master(8), imapd(8), pop3d(8), lmtpd(8), timsieved(8), idled(8),
-notifyd(8), ctl_cyrusdb(8), ctl_deliver(8), tls_prune(8),
+master(8), imapd(8), pop3d(8), lmtpd(8), smmapd(8), timsieved(8),
+idled(8), notifyd(8), ctl_cyrusdb(8), ctl_deliver(8), tls_prune(8),
 *hosts_access(5)*
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/configs/imapd.conf.txt 3.2.0-3/doc/text/imap/reference/manpages/configs/imapd.conf.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/configs/imapd.conf.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/configs/imapd.conf.txt	2020-05-04 04:13:59.000000000 +0000
@@ -1,6 +1,6 @@
 
-imapd.conf
-**********
+**imapd.conf**
+**************
 
 IMAP configuration file
 
@@ -40,6 +40,16 @@ DESCRIPTION
    ``t'', ``true'' and ``1'' turn the option on, the values ``no'',
    ``off'', ``f'', ``false'' and ``0'' turn the option off.
 
+   Duration options take the form of a number followed by a unit, for
+   example **32m** (32 minutes).  Units are **d** (days), **h**
+   (hours), **m** (minutes) and **s** (seconds).  Multiple units can
+   be combined and will be summed together, for example **1h30m** is
+   equivalent to **90m**.  If no unit is specified, an option-specific
+   backward-compatible default unit is assumed (documented on an
+   option-by-option basis).  These are simple time units: 1d=24h,
+   1h=60m, 1m=60s (daylight savings, timezones, leap adjustments, etc
+   are not considered).
+
 
 FIELD DESCRIPTIONS
 ==================
@@ -107,6 +117,11 @@ FIELD DESCRIPTIONS
       enough entropy (e.g., from /dev/urandom) to create a challenge
       in the banner.
 
+   "allowdeleted:" 0
+
+      Allow access to deleted and expunged data via vendor.cmu-*
+      access
+
    "allownewnews:" 0
 
       Allow use of the NNTP NEWNEWS command.
@@ -124,6 +139,11 @@ FIELD DESCRIPTIONS
       require a TLS/SSL encryption layer to be negotiated prior to ANY
       authentication, see the *tls_required* option.
 
+   "allowsetacl:" 1
+
+      Defaults to enabled.  If disabled, disallows the use of the
+      SETACL command at all via IMAP.
+
    "allowusermoves:" 0
 
       Allow moving user accounts (with associated meta-data) via
@@ -156,7 +176,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for mailbox annotations.
 
-      Allowed values: *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
    "annotation_db_path:" <none>
 
@@ -249,6 +269,18 @@ FIELD DESCRIPTIONS
       mailbox.  The path can be either an executable (including a
       script), or a UNIX domain socket.
 
+   "annotation_callout_disable_append:" 0
+
+      Disables annotations on append with xrunannotator
+
+   "annotation_enable_legacy_commands:" 0
+
+      Whether to enable the legacy GETANNOTATION/SETANNOTATION
+      commands. These commands are deprecated and will be removed in
+      the future, but might be useful in the meantime for supporting
+      old clients that do not implement the **RFC 5464** IMAP METADATA
+      extension.
+
    "aps_topic:" <none>
 
       Topic for Apple Push Service registration.
@@ -268,10 +300,17 @@ FIELD DESCRIPTIONS
       to be stored on slower, cheaper disks - even within the same
       mailbox, as distinct from partitions.
 
-   "archive_days:" 7
+   "archive_days:" <none>
+
+      Deprecated in favour of *archive_after*.
+
+   "archive_after:" 7d
+
+      The duration after which to move messages to the archive
+      partition if archiving is enabled.
 
-      The number of days after which to move messages to the archive
-      partition if archiving is enabled
+      For backward compatibility, if no unit is specified, days is
+      assumed.
 
    "archive_maxsize:" 1024
 
@@ -343,6 +382,20 @@ FIELD DESCRIPTIONS
 
       Deprecated in favor of *autocreate_subscribe_sharedfolders_all*.
 
+   "autocreate_acl:" <none>
+
+      If folders are to be created by *autocreate_inbox_foldersR, this
+      setting can be used to apply additional ACLs to the autocreated
+      folders.  The syntax is "autocreate_acl folder identifier
+      rights", where **folder* must match one of the
+      *autocreate_inbox_folders* folders, *identifier* must be a valid
+      cyrus identifier, and *rights* must be a valid cyrus rights
+      string.  Multiple identifier|rights pairs can be assigned to a
+      single folder by providing this setting multiple times.
+
+      For example, "autocreate_acl Plus anyone p" would allow lmtp
+      delivery to a folder named "Plus".
+
    "autocreate_inbox_folders:" <none>
 
       If a user does not have an INBOX already, and the INBOX is to be
@@ -458,6 +511,12 @@ FIELD DESCRIPTIONS
       A space separated list of users and/or groups that are allowed
       their INBOX to be automatically created.
 
+   "autoexpunge:" 0
+
+      If set to yes, then all Deleted messages will be automatically
+      expunged whenever an index is closed, whether CLOSE, UNSELECT,
+      SELECT or on disconnect
+
    "backuppartition-name:" <none>
 
       The pathname of the backup partition *name*.  At least one
@@ -494,17 +553,24 @@ FIELD DESCRIPTIONS
       The absolute path of the backup staging area.  If not specified,
       will be temp_path/backup
 
-   "backup_retention_days:" 7
+   "backup_retention_days:" <none>
+
+      Deprecated in favor of *backup_retention*.
 
-      The number of days to keep content in backup after it has been
-      deleted from the source.  If set to a negative value or zero,
-      deleted content will be kept indefinitely.
+   "backup_retention:" 7d
+
+      How long to keep content in backup after it has been deleted
+      from the source.  If set to a negative value or zero, deleted
+      content will be kept indefinitely.
+
+      For backward compatibility, if no unit is specified, days is
+      assumed.
 
    "backup_db:" twoskip
 
       The cyrusdb backend to use for the backup locations database.
 
-      Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
    "backup_db_path:" <none>
 
@@ -531,7 +597,12 @@ FIELD DESCRIPTIONS
 
    "caldav_allowattach:" 1
 
-      Enable managed attachments support on the caldav server.
+      Enable managed attachments support on the CalDAV server.
+
+   "caldav_allowcalendaradmin:" 0
+
+      Enable per-user calendar administration web UI on the CalDAV
+      server.
 
    "caldav_allowscheduling:" on
 
@@ -541,7 +612,7 @@ FIELD DESCRIPTIONS
 
    "caldav_create_attach:" 1
 
-      Create the 'Attachments' calendar if it doesn't already exist
+      Create the 'Attachments' collection if it doesn't already exist
 
    "caldav_create_default:" 1
 
@@ -552,6 +623,17 @@ FIELD DESCRIPTIONS
       Create the 'Inbox' and 'Outbox' calendars if they don't already
       exist
 
+   "caldav_historical_age:" 7d
+
+      How long after an occurrence of event or task has concluded that
+      it is considered 'historical'.  Changes to historical
+      occurrences of events or tasks WILL NOT have invite or reply
+      messages sent for them.  A negative value means that events and
+      tasks are NEVER considered historical.
+
+      For backward compatibility, if no unit is specified, days is
+      assumed.
+
    "caldav_maxdatetime:" 20380119T031407Z
 
       The latest date and time accepted by the server (ISO format).
@@ -587,6 +669,25 @@ FIELD DESCRIPTIONS
       addresses for which the server is responsible.  If not set (the
       default), the value of the "servername" option will be used.
 
+   "calendar_component_set:" VEVENT VTODO VJOURNAL VFREEBUSY
+   VAVAILABILITY VPOLL
+
+      Space-separated list of iCalendar component types that calendar
+      object resources may contain in a calendar collection. This
+      restriction is only set at calendar creation time and only if
+      the CalDAV client hasn't specified a restriction in the creation
+      request. Allowed values: *VEVENT*, *VTODO*, *VJOURNAL*,
+      *VFREEBUSY*, *VAVAILABILITY*, *VPOLL*
+
+   "carddav_allowaddmember:" 0
+
+      Enable support for POST add-member on the CardDAV server.
+
+   "carddav_allowaddressbookadmin:" 0
+
+      Enable per-user addressbook administration web UI on the CardDAV
+      server.
+
    "carddav_realm:" <none>
 
       The realm to present for HTTP authentication of CardDAV
@@ -619,11 +720,13 @@ FIELD DESCRIPTIONS
       when **client_bind** is enabled.  If not set (the default),
       servername will be used.
 
-   "client_timeout:" 10
+   "client_timeout:" 10s
 
-      Number of seconds to wait before returning a timeout failure
-      when performing a client connection (e.g., in a murder
-      environment)
+      Time to wait before returning a timeout failure when performing
+      a client connection (e.g. in a murder environment).
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "commandmintimer:" <none>
 
@@ -657,13 +760,25 @@ FIELD DESCRIPTIONS
       The cyrusdb backend to use for the per-user conversations
       database.
 
-      Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
+
+   "conversations_expire_days:" <none>
+
+      Deprecated in favor of *conversations_expire_after*.
 
-   "conversations_expire_days:" 90
+   "conversations_expire_after:" 90d
 
       How long the conversations database keeps the message tracking
       information needed for receiving new messages in existing
-      conversations, in days.
+      conversations.
+
+      For backward compatibility, if no unit is specified, days is
+      assumed.
+
+   "conversations_max_thread:" 100
+
+      maximum size for a single thread.  Threads will split if they
+      have this many * messages in them and another message arrives
 
    "crossdomains:" 0
 
@@ -711,13 +826,23 @@ FIELD DESCRIPTIONS
       resources (principals).  If not set (the default), the value of
       the "servername" option will be used.
 
+   "dav_lock_timeout:" 20s
+
+      The maximum time to wait for a write lock on the per-user DAV
+      database before timeout. For HTTP requests, the HTTP status code
+      503 is returned if the lock can not be obtained within this
+      time.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
+
    "debug_command:" <none>
 
       Debug command to be used by processes started with -D option.
       The string is a C format string that gets 3 options: the first
-      is the name of the executable (without path).  The second is the
-      pid (integer) and the third is the service ID.  Example:
-      /usr/local/bin/gdb /usr/cyrus/bin/%s %d
+      is the name of the executable (as specified in the cmd parameter
+      in cyrus.conf). The second is the pid (integer) and the third is
+      the service ID. Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d
 
    "defaultacl:" anyone lrs
 
@@ -816,6 +941,10 @@ FIELD DESCRIPTIONS
 
       File containing the private key for iSchedule DKIM signing.
 
+   "ischedule_dkim_required:" 1
+
+      A DKIM signature is required on received iSchedule requests.
+
    "ischedule_dkim_selector:" <none>
 
       Name of the selector subdividing the domain namespace.  This
@@ -826,7 +955,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the duplicate delivery
       suppression and sieve. Allowed values: *skiplist*, *sql*,
-      *twoskip*, *lmdb*
+      *twoskip*, *zeroskip*
 
    "duplicate_db_path:" <none>
 
@@ -881,7 +1010,8 @@ FIELD DESCRIPTIONS
       *vnd.cmu.davFilename*, *vnd.cmu.davUid*,
       *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*,
       *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*,
-      *vnd.fastmail.cid*, *vnd.fastmail.counters*
+      *vnd.fastmail.cid*, *vnd.fastmail.counters*, *vnd.cmu.emailid*,
+      *vnd.cmu.threadid*
 
    "event_groups:" message mailbox
 
@@ -900,27 +1030,29 @@ FIELD DESCRIPTIONS
    "expunge_mode:" delayed
 
       The mode in which messages (and their corresponding cache
-      entries) are expunged.  "default" mode is the old behavior in
-      which the message files are purged at the time of the EXPUNGE,
-      but index and cache records are retained to facilitate QRESYNC.
-      (Note that this behaviour is no longer the default, but is so
-      named for historical reasons.)  In "delayed" mode, which is the
-      default since Cyrus 2.5.0, the message files are also retained,
-      allowing unexpunge to rescue them.  In "immediate" mode, both
-      the message files and the index records are removed as soon as
-      possible.  In all cases, nothing will be finally purged until
-      all other processes have closed the mailbox to ensure they never
-      see data disappear under them.  In "default" or "delayed" mode,
-      a later run of "cyr_expire" will clean out the retained records
-      (and possibly message files). This reduces the amount of I/O
-      that takes place at the time of EXPUNGE and should result in
-      greater responsiveness for the client, especially when expunging
-      a large number of messages. Allowed values: *default*,
-      *immediate*, *delayed*
+      entries) are expunged.  "semidelayed" mode is the old behavior
+      in which the message files are purged at the time of the
+      EXPUNGE, but index and cache records are retained to facilitate
+      QRESYNC. In "delayed" mode, which is the default since Cyrus
+      2.5.0, the message files are also retained, allowing unexpunge
+      to rescue them.  In "immediate" mode, both the message files and
+      the index records are removed as soon as possible.  In all
+      cases, nothing will be finally purged until all other processes
+      have closed the mailbox to ensure they never see data disappear
+      under them.  In "semidelayed" or "delayed" mode, a later run of
+      "cyr_expire" will clean out the retained records (and possibly
+      message files). This reduces the amount of I/O that takes place
+      at the time of EXPUNGE and should result in greater
+      responsiveness for the client, especially when expunging a large
+      number of messages. Allowed values: *immediate*, *semidelayed*,
+      *delayed*
+
+   "failedloginpause:" 3s
 
-   "failedloginpause:" 3
+      Time to pause after a failed login.
 
-      Number of seconds to pause after a failed login.
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "flushseenstate:" 1
 
@@ -1026,14 +1158,17 @@ FIELD DESCRIPTIONS
       files, etc) rooted at this directory.  Otherwise, httpd will not
       serve any static content.
 
-   "httpkeepalive:" 20
+   "httpkeepalive:" 20s
 
-      Set the length of the HTTP server's keepalive heartbeat in
-      seconds. The default is 20.  The minimum value is 0, which will
+      Set the length of the HTTP server's keepalive heartbeat.  The
+      default is 20 seconds.  The minimum value is 0, which will
       disable the keepalive heartbeat.  When enabled, if a request
-      takes longer than *httpkeepalive* seconds to process, the server
-      will send the client provisional responses every *httpkeepalive*
-      seconds until the final response can be sent
+      takes longer than *httpkeepalive* to process, the server will
+      send the client provisional responses every *httpkeepalive*
+      until the final response can be sent.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "httpmodules:" <empty string>
 
@@ -1044,8 +1179,9 @@ FIELD DESCRIPTIONS
 
       Note that "domainkey" depends on "ischedule" being enabled, and
       that both "freebusy" and "ischedule" depend on "caldav" being
-      enabled. Allowed values: *admin*, *caldav*, *carddav*,
-      *domainkey*, *freebusy*, *ischedule*, *rss*, *tzdist*, *webdav*
+      enabled. Allowed values: *admin*, *caldav*, *carddav*, *cgi*,
+      *domainkey*, *freebusy*, *ischedule*, *jmap*, *prometheus*,
+      *rss*, *tzdist*, *webdav*
 
    "httpprettytelemetry:" 0
 
@@ -1055,11 +1191,14 @@ FIELD DESCRIPTIONS
       logs. Note that enabling this option will increase the amount of
       data sent across the wire.
 
-   "httptimeout:" 5
+   "httptimeout:" 5m
+
+      Set the length of the HTTP server's inactivity autologout timer.
+      The default is 5 minutes.  The minimum value is 0, which will
+      disable persistent connections.
 
-      Set the length of the HTTP server's inactivity autologout timer,
-      in minutes.  The default is 5.  The minimum value is 0, which
-      will disable persistent connections.
+      For backwards compatibility, if no unit is specified, minutes is
+      assumed.
 
    "idlesocket:" {configdirectory}/socket/idle
 
@@ -1070,12 +1209,15 @@ FIELD DESCRIPTIONS
       For backwards compatibility with Cyrus 1.5.10 and earlier --
       ignore the reference argument in LIST or LSUB commands.
 
-   "imapidlepoll:" 60
+   "imapidlepoll:" 60s
 
-      The interval (in seconds) for polling for mailbox changes and
-      ALERTs while running the IDLE command.  This option is used when
-      idled is not enabled or cannot be contacted.  The minimum value
-      is 1.  A value of 0 will disable IDLE.
+      The interval for polling for mailbox changes and ALERTs while
+      running the IDLE command.  This option is used when idled is not
+      enabled or cannot be contacted.  The minimum value is 1 second.
+      A value of 0 will disable IDLE.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "imapidresponse:" 1
 
@@ -1097,7 +1239,7 @@ FIELD DESCRIPTIONS
       based on the **RFC 6047**.  If not set, "IMIP" notifications are
       disabled.
 
-   "implicit_owner_rights:" lkxa
+   "implicit_owner_rights:" lkxan
 
       The implicit Access Control List (ACL) for the owner of a
       mailbox.
@@ -1121,13 +1263,150 @@ FIELD DESCRIPTIONS
       databases the same has to be done (cyr_dbtool) for each
       subscription database See improved_mboxlist_sort.html.
 
-   "internaldate_heuristic:" standard
+   "jmap_emailsearch_db_path:" <none>
+
+      The absolute path to the JMAP email search cache file.  If not
+      specified, JMAP Email/query and Email/queryChanges will not
+      cache email search results.
+
+   "jmap_preview_annot:" <none>
+
+      The name of the per-message annotation, if any, to store message
+      previews.
+
+   "jmap_imagesize_annot:" <none>
+
+      The name of the per-message annotation, if any, that stores a
+      JSON object, mapping message part numbers of MIME image types to
+      an array of their image dimensions. The array must have at least
+      two entries, where the first entry denotes the width and the
+      second entry the height of the image. Any additional values are
+      ignored.
+
+      For example, if message part 1.2 contains an image of width 300
+      and height 200, then the value of this annotation would be:
+
+      { "1.2" : [ 300, 200 ] }
+
+   "jmap_inlinedcids_annot:" <none>
+
+      The name of the per-message annotation, if any, that stores a
+      JSON object, mapping **RFC 2392** Content-IDs referenced in HTML
+      bodies to the respective HTML body part number.
+
+      For example, if message part 1.2 contains HTML and references an
+      inlined image at "cid:foo", then the value of this annotation
+      would be:
+
+      { "<foo>" : "1.2" }
+
+      Note that the Content-ID key must be URL-unescaped and enclosed
+      in angular brackets, as defined in **RFC 2392**.
+
+   "jmap_preview_length:" 64
+
+      The maximum byte length of dynamically generated message
+      previews. Previews stored in jmap_preview_annot take precedence.
+
+   "jmap_max_size_upload:" 1048576
+
+      The maximum size (in kilobytes) that the JMAP API accepts for
+      blob uploads. Returned as the maxSizeUpload property value of
+      the JMAP "urn:ietf:params:jmap:core" capabilities object.
+      Default is 1Gb.
+
+   "jmap_max_concurrent_upload:" 5
+
+      The value to return for the maxConcurrentUpload property of the
+      JMAP "urn:ietf:params:jmap:core" capabilities object. The Cyrus
+      JMAP implementation does not enforce this rate-limit.
+
+   "jmap_max_size_request:" 10240
+
+      The maximum size (in kilobytes) that the JMAP API accepts for
+      requests at the API endpoint. Returned as the maxSizeRequest
+      property value of the JMAP "urn:ietf:params:jmap:core"
+      capabilities object. Default is 10Mb.
+
+   "jmap_max_concurrent_requests:" 5
+
+      The value to return for the maxConcurrentRequests property of
+      the JMAP "urn:ietf:params:jmap:core" capabilities object. The
+      Cyrus JMAP implementation does not enforce this rate-limit.
+
+   "jmap_max_calls_in_request:" 50
+
+      The maximum number of calls per JMAP request object. Returned as
+      the maxCallsInRequest property value of the JMAP
+      "urn:ietf:params:jmap:core" capabilities object.
+
+   "jmap_max_delayed_send:" 512d
+
+      The value to return for the maxDelayedSend property of the JMAP
+      "urn:ietf:params:jmap:emailsubmission" capabilities object. The
+      Cyrus JMAP implementation does not enforce this limit.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
+
+   "jmap_max_objects_in_get:" 4096
+
+      The maximum number of ids that a JMAP client may request in a
+      single "/get" type method call. The actual number of returned
+      objects in the response may exceed this number if the JMAP
+      object type supports unbounded "/get" calls. Returned as the
+      maxObjectsInGet property value of the JMAP
+      "urn:ietf:params:jmap:core" capabilities object.
+
+   "jmap_max_objects_in_set:" 4096
+
+      The maximum number of objects a JMAP client may send to create,
+      update or destroy in a single /set type method call. Returned as
+      the maxObjectsInSet property value of the JMAP
+      "urn:ietf:params:jmap:core" capabilities object.
+
+   "jmap_mail_max_size_attachments_per_email:" 10240
+
+      The value (in kilobytes) to return for the
+      maxSizeAttachmentsPerEmail property of the JMAP
+      "urn:ietf:params:jmap:mail" capabilities object. The Cyrus JMAP
+      implementation does not enforce this size limit. Default is 10
+      Mb.
+
+   "jmap_nonstandard_extensions:" 0
+
+      If enabled, support non-standard JMAP extensions.  If not
+      enabled, only IETF standard JMAP functionality is supported.
+
+   "jmap_set_has_attachment:" 1
+
+      If enabled, the $hasAttachment flag is determined and set for
+      new messages created with the JMAP Email/set or Email/import
+      methods. This option should typically be enabled, but
+      installations using Cyrus-external message annatotors to
+      determine the $hasAttachment flag might want to disable it.
+
+   "jmap_vacation:" 1
+
+      If enabled, support the JMAP vacation extension
+
+   "jmapuploadfolder:" #jmap
+
+      the name of the folder for JMAP uploads (#jmap)
+
+   "jmapsubmission_deleteonsend:" 1
+
+      If enabled (the default) then delete the EmailSubmission as soon
+      as the email * has been sent
+
+   "jmapsubmissionfolder:" #jmapsubmission
+
+      the name of the folder for JMAP Submissions (#jmapsubmission)
+
+   "jmappushsubscriptionfolder:" #jmappushsubscription
 
-      Mechanism to determine email internaldates on
-      delivery/reconstruct. "standard" uses time() when delivering a
-      message, mtime on reconstruct. "receivedheader" looks at the top
-      most Received header or time/mtime otherwise Allowed values:
-      *standard*, *receivedheader*
+      the name of the folder for JMAP Push Subscriptions
+      (#jmappushsubscription)
 
    "iolog:" 0
 
@@ -1182,9 +1461,11 @@ FIELD DESCRIPTIONS
 
       %%   = % %u   = user %U   = user portion of %u (%U = test when
       %u = test@domain.tld) %d   = domain portion of %u if available
-      (%d = domain.tld when %u = %test@domain.tld), otherwise same as
-      %r %D   = user dn.  (use when ldap_member_method: filter) %1-9 =
-      domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
+      (%d = domain.tld when %u = test@domain.tld), otherwise same as
+      %R %R   = domain portion of %u starting with @ (%R = @domain.tld
+      when %u = test@domain.tld) %D   = user dn.  (use when
+      ldap_member_method: filter) %1-9 = domain tokens (%1 = tld, %2 =
+      domain when %d = domain.tld)
 
       ldap_filter is not used when ldap_sasl is enabled.
 
@@ -1306,13 +1587,19 @@ FIELD DESCRIPTIONS
       Use transport layer security for ldap:// using STARTTLS. Do not
       use ldaps:// in 'ldap_uri' with this option enabled.
 
-   "ldap_time_limit:" 5
+   "ldap_time_limit:" 5s
 
-      Specify a number of seconds for a search request to complete.
+      How long to wait for a search request to complete.
 
-   "ldap_timeout:" 5
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
-      Specify a number of seconds a search can take before timing out.
+   "ldap_timeout:" 5s
+
+      How long a search can take before timing out.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "ldap_ca_dir:" <none>
 
@@ -1388,6 +1675,16 @@ FIELD DESCRIPTIONS
       If enabled, lmtpd will convert the recipient addresses to
       lowercase (up to a '+' character, if present).
 
+   "lmtp_exclude_specialuse:" \Snoozed
+
+      Don't allow delivery to folders with given special-use
+      attributes.
+
+      Note that "snoozing" of emails can currently only be done via
+      the JMAP protocol, so delivery directly to the Snoozed mailbox
+      is prohibited by default as it will not be moved back into INBOX
+      automatically.
+
    "lmtp_fuzzy_mailbox_match:" 0
 
       If enabled, and the mailbox specified in the detail part of the
@@ -1423,13 +1720,23 @@ FIELD DESCRIPTIONS
       Unix domain socket that lmtpd listens on, used by deliver(8).
       This should match the path specified in cyrus.conf(5).
 
-   "lmtptxn_timeout:" 300
+   "lmtptxn_timeout:" 5m
 
-      Timeout (in seconds) used during a lmtp transaction to a remote
-      backend (e.g. in a murder environment).  Can be used to prevent
-      hung lmtpds on proxy hosts when a backend server becomes
-      unresponsive during a lmtp transaction.  The default is 300 -
-      change to zero for infinite.
+      Timeout used during a lmtp transaction to a remote backend (e.g.
+      in a murder environment).  Can be used to prevent hung lmtpds on
+      proxy hosts when a backend server becomes unresponsive during a
+      lmtp transaction. The default is 5 minutes - change to zero for
+      infinite.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
+
+   "lock_debugtime:" <none>
+
+      A floating point number of seconds.  If set, time how long we
+      wait for any lock, and syslog the filename and time if it's
+      longer than this value.  The default of NULL means not to time
+      locks.
 
    "loginrealms:" <empty string>
 
@@ -1468,6 +1775,18 @@ FIELD DESCRIPTIONS
       Notifyd(8) method to use for "MAIL" notifications.  If not set,
       "MAIL" notifications are disabled.
 
+   "master_bind_errors_fatal:" 0
+
+      If enabled, failure to bind a port during startup is treated as
+      a fatal error, causing master to shut down immediately.  The
+      default is to keep running, with the affected service disabled
+      until the next SIGHUP causes it to retry.
+
+      Note that this only applies during startup.  New services that
+      fail to come up in response to a reconfig+SIGHUP will just be
+      logged and disabled like the default behaviour, without causing
+      master to exit.
+
    "maxheaderlines:" 1000
 
       Maximum number of lines of header that will be processed into
@@ -1505,13 +1824,13 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for mailbox keys.
 
-      Allowed values: *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
    "mboxlist_db:" twoskip
 
       The cyrusdb backend to use for the mailbox list.
 
-      Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
    "mboxlist_db_path:" <none>
 
@@ -1701,10 +2020,13 @@ FIELD DESCRIPTIONS
       The absolute path to the newsrc db file.  If not specified, will
       be configdirectory/fetchnews.db
 
-   "nntptimeout:" 3
+   "nntptimeout:" 3m
+
+      Set the length of the NNTP server's inactivity autologout timer.
+      The minimum value is 3 minutes, also the default.
 
-      Set the length of the NNTP server's inactivity autologout timer,
-      in minutes.  The minimum value is 3, the default.
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
    "notesmailbox:" <none>
 
@@ -1741,11 +2063,6 @@ FIELD DESCRIPTIONS
       the value of the **defaultpartion** option is **part1**, then
       the **partition-part1** field is required.
 
-   "outbox_sendlater:" 0
-
-      If enabled, any message with a Draft flag will be sent at the
-      time of its INTERNALDATE
-
    "partition_select_mode:" freespace-most
 
       Partition selection mode.
@@ -1795,12 +2112,15 @@ FIELD DESCRIPTIONS
       If all partitions are over that limit, this feature is not used
       anymore.
 
-   "plaintextloginpause:" 0
+   "plaintextloginpause:" <none>
+
+      Time to pause after a successful plaintext login.  For systems
+      that support strong authentication, this permits users to
+      perceive a cost of using plaintext passwords.  (This does not
+      affect the use of PLAIN in SASL authentications.)
 
-      Number of seconds to pause after a successful plaintext login.
-      For systems that support strong authentication, this permits
-      users to perceive a cost of using plaintext passwords.  (This
-      does not affect the use of PLAIN in SASL authentications.)
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "plaintextloginalert:" <none>
 
@@ -1808,19 +2128,29 @@ FIELD DESCRIPTIONS
 
    "popexpiretime:" -1
 
-      The number of days advertised as being the minimum a message may
-      be left on the POP server before it is deleted (via the CAPA
+      The duration advertised as being the minimum a message may be
+      left on the POP server before it is deleted (via the CAPA
       command, defined in the POP3 Extension Mechanism, which some
-      clients may support).  "NEVER", the default, may be specified
-      with a negative number.  The Cyrus POP3 server never deletes
-      mail, no matter what the value of this parameter is.  However,
-      if a site implements a less liberal policy, it needs to change
-      this parameter accordingly.
+      clients may support).  This duration has a granularity of whole
+      days, with partial days truncated (so e.g. "45m" is effectively
+      "0d").  "NEVER", the default, may be specified with a negative
+      number.
+
+      The Cyrus POP3 server never deletes mail, no matter what the
+      value of this parameter is.  However, if a site implements a
+      less liberal policy, it needs to change this parameter
+      accordingly.
 
-   "popminpoll:" 0
+      For backward compatibility, if no unit is specified, days is
+      assumed.
+
+   "popminpoll:" <none>
 
       Set the minimum amount of time the server forces users to wait
-      between successive POP logins, in minutes.
+      between successive POP logins.
+
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
    "popsubfolders:" 0
 
@@ -1844,10 +2174,13 @@ FIELD DESCRIPTIONS
       is cleared.  If the user waits a sufficient amount of time, they
       will get back many or all of the slots.
 
-   "poptimeout:" 10
+   "poptimeout:" 10m
+
+      Set the length of the POP server's inactivity autologout timer.
+      The minimum value is 10 minutes, the default.
 
-      Set the length of the POP server's inactivity autologout timer,
-      in minutes.  The minimum value is 10, the default.
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
    "popuseacl:" 0
 
@@ -1884,6 +2217,32 @@ FIELD DESCRIPTIONS
       path if specified.  If not specified, the path
       $configdirectory/proc/ will be used.
 
+   "prometheus_enabled:" 0
+
+      Whether tracking of service metrics for Prometheus is enabled.
+
+   "prometheus_need_auth:" admin
+
+      Authentication level required to fetch Prometheus metrics.
+
+      Allowed values: *none*, *user*, *admin*
+
+   "prometheus_update_freq:" 10s
+
+      Frequency in at which promstatsd should re-collate its
+      statistics report.  The minimum value is 1 second, the default
+      is 10 seconds.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
+
+   "prometheus_stats_dir:" <none>
+
+      Directory to use for gathering prometheus statistics.  If
+      specified, must be an absolute path.  If not specified, the
+      default path $configdirectory/stats/ will be used.  It may be
+      advantageous to locate this directory on ephemeral storage.
+
    "proxy_authname:" proxy
 
       The authentication name to use when authenticating to a backend
@@ -1946,17 +2305,20 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the pts cache.
 
-      Allowed values: *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
    "ptscache_db_path:" <none>
 
       The absolute path to the ptscache db file.  If not specified,
       will be configdirectory/ptscache.db
 
-   "ptscache_timeout:" 10800
+   "ptscache_timeout:" 3h
+
+      The timeout for the PTS cache database when using the
+      auth_krb_pts authorization method (default: 3 hours).
 
-      The timeout (in seconds) for the PTS cache database when using
-      the auth_krb_pts authorization method (default: 3 hours).
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "ptskrb5_convert524:" 1
 
@@ -1984,7 +2346,7 @@ FIELD DESCRIPTIONS
       The cyrusdb backend to use for quotas.
 
       Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*,
-      *twoskip*, *lmdb*
+      *twoskip*, *zeroskip*
 
    "quota_db_path:" <none>
 
@@ -2080,12 +2442,15 @@ FIELD DESCRIPTIONS
       have their messages available via RSS.  If not set, a default
       wildmat of "*" (ALL mailboxes) will be used.
 
-   "rss_maxage:" 0
+   "rss_maxage:" <none>
 
-      Maximum age (in days) of items to display in an RSS channel.  If
-      non-zero, httpd will only display items received within the last
-      *rss_maxage* days.  If set to 0, all available items will be
-      displayed (the default).
+      Maximum age of items to display in an RSS channel.  If non-zero,
+      httpd will only display items received within this time period.
+      If set to 0, all available items will be displayed (the
+      default).
+
+      For backward compatibility, if no unit is specified, days is
+      assumed.
 
    "rss_maxitems:" 0
 
@@ -2139,6 +2504,59 @@ FIELD DESCRIPTIONS
       The number of messages to be indexed in one batch (default 20).
       Note that long batches may delay user commands or mail delivery.
 
+   "search_attachment_extractor_url:" <none>
+
+      A HTTP or HTTPS URL to extract search text from rich text
+      attachments and other media during search indexing. The server
+      at this URL must implement the following protocol:
+
+      1. For each attachment of an email, Cyrus sends a GET request to
+      the URL <extractor-url>/<cyrus-id>, where <extractor-url> is the
+      configured URL and <cyrus-id> is a Cyrus-chosen path segment
+      that uniquely identifies this attachment.
+
+      2. If the extractor already has a cached plain text extract of
+      the attachment identified by <cyrus-id> then it may return HTTP
+      status code 200 (OK) and the plain text extract with a Content-
+      Type "text/plain" header. Otherwise it must return HTTP status
+      404 (Not Found).
+
+      3. If Cyrus receives the HTTP status code 404 (Not Found), then
+      it sends a PUT request to the same URL as previously. The PUT
+      request body contains the decoded, binary body of the
+      attachment. The Content-Type request header has the same value
+      as declared in the MIME part headers, including any type
+      parameters.
+
+      4. The extractor must return the plain text extract with either
+      HTTP status 200 (OK) or 201 (Created) and a Content-Type
+      "text/plain" header. If no text can be extracted, then the
+      extractor may return any return code in the range 4xx, or 200
+      and an empty response body.
+
+      Any other HTTP status code is treated as an error. For
+      performance reasons, the Cyrus indexer attempts to keep-alive
+      the TCP connection to the extractor.
+
+   "search_index_language:" 0
+
+      If enabled, then message bodies and subjects are indexed by
+      their detected language, if the cld2 dependency is built into
+      Cyrus. Regardless of this flag, bodies and subjects are always
+      indexed and searched using the default stemmer.
+
+   "search_index_parts:" 0
+
+      If enabled, then message parts are each indexed separately into
+      Xapian so that matches can be done by part.
+
+   "search_query_language:" 0
+
+      If enabled, then message bodies and subjects searched by their
+      language that got detected during indexing, if any. Regardless
+      of this flag, bodies and subjects are always searched using the
+      default stemmer.
+
    "search_normalisation_max:" 1000
 
       A resource bound for the combinatorial explosion of search
@@ -2150,7 +2568,7 @@ FIELD DESCRIPTIONS
 
       The indexing engine used to speed up searching.
 
-      Allowed values: *none*, *squat*, *sphinx*, *xapian*
+      Allowed values: *none*, *squat*, *xapian*
 
    "search_fuzzy_always:" 0
 
@@ -2172,9 +2590,9 @@ FIELD DESCRIPTIONS
    "search_indexed_db:" twoskip
 
       The cyrusdb backend to use for the search latest indexed uid
-      state.
+      state.  Xapian only.
 
-      Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
    "search_maxtime:" <none>
 
@@ -2182,6 +2600,12 @@ FIELD DESCRIPTIONS
       aborting.  Default of no value means search "forever" until
       other timeouts.
 
+   "search_queryscan:" 5000
+
+      The minimum number of records require to do a direct scan of all
+      G keys * rather than indexed lookups.  A value of 0 means always
+      do indexed lookups.
+
    "search_skipdiacrit:" 1
 
       When searching, should diacriticals be stripped from the search
@@ -2217,7 +2641,7 @@ FIELD DESCRIPTIONS
       The absolute base path to the search stopword lists. If not
       specified, no stopwords will be taken into account during search
       indexing. Currently, the only supported and default stop word
-      file is english.list.
+      file is english.txt.
 
    "searchpartition-name:" <none>
 
@@ -2238,13 +2662,20 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the seen state.
 
-      Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
    "sendmail:" /usr/lib/sendmail
 
       The pathname of the sendmail executable.  Sieve invokes sendmail
       for sending rejections, redirects and vacation responses.
 
+   "sendmail_auth_id:" CYRUS_SENDMAIL_AUTH_ID
+
+      The name of an environment variable to set when invoking
+      sendmail. The value of this environment variable will contain
+      the user id of the currently authenticated user. If no user is
+      authenticated the environment variable is not set.
+
    "serverlist:" <none>
 
       Whitespace separated list of backend server names.  Used for
@@ -2327,9 +2758,19 @@ FIELD DESCRIPTIONS
       user's scripts reside on a remote server (in a Murder).
       Otherwise, timsieved will proxy traffic to the remote server.
 
+   "sieve_duplicate_max_expiration:" 90d
+
+      Maximum expiration time for duplicate message tracking records.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
+
    "sieve_extensions:" fileinto reject vacation vacation-seconds
-   imapflags notify envelope relational regex subaddress copy date
-   index imap4flags mailbox mboxmetadata servermetadata variables
+   imapflags notify include envelope environment body relational regex
+   subaddress copy date index imap4flags mailbox mboxmetadata
+   servermetadata variables editheader extlists duplicate ihave fcc
+   special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x
+   -cyrus-jmapquery x-cyrus-snooze
 
       Space-separated list of Sieve extensions allowed to be used in
       sieve scripts, enforced at submission by timsieved(8).  Any
@@ -2338,9 +2779,12 @@ FIELD DESCRIPTIONS
       This option has no effect on options that are disabled at
       compile time (e.g., "regex"). Allowed values: *fileinto*,
       *reject*, *vacation*, *vacation-seconds*, *imapflags*, *notify*,
-      *include*, *envelope*, *body*, *relational*, *regex*,
-      *subaddress*, *copy*, *date*, *index*, *imap4flags*, *mailbox*,
-      *mboxmetadata*, *servermetadata*, *variables*
+      *include*, *envelope*, *environment*, *body*, *relational*,
+      *regex*, *subaddress*, *copy*, *date*, *index*, *imap4flags*,
+      *mailbox*, *mboxmetadata*, *servermetadata*, *variables*,
+      *editheader*, *extlists*, *duplicate*, *ihave*, *fcc*, *special-
+      use*, *redirect-dsn*, *redirect-deliverby*, *mailboxid*, *x
+      -cyrus-log*, *x-cyrus-jmapquery*, *x-cyrus-snooze*
 
    "sieve_maxscriptsize:" 32
 
@@ -2364,15 +2808,27 @@ FIELD DESCRIPTIONS
       successful SASL authentication, per draft-martin-
       managesieve-12.txt .
 
-   "sieve_vacation_min_response:" 259200 /* 3 days */
+   "sieve_use_lmtp_reject:" 1
+
+      Enabled by default.  If reject can be done via LMTP, then return
+      a 550 rather than generating the bounce message in Cyrus.
+
+   "sieve_vacation_min_response:" 3d
 
-      Minimum time interval (in seconds) between consecutive vacation
-      responses, per draft-ietf-vacation-seconds.txt .
+      Minimum time interval between consecutive vacation responses,
+      per draft-ietf-vacation-seconds.txt.  The default is 3 days.
 
-   "sieve_vacation_max_response:" 7776000 /* 90 days */
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
-      Maximum time interval (in seconds) between consecutive vacation
-      responses, per draft-ietf-vacation-seconds.txt .
+   "sieve_vacation_max_response:" 90d
+
+      Maximum time interval between consecutive vacation responses,
+      per draft-ietf-vacation-seconds.txt.  The default is 90 days.
+      The minimum is 7 days.
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "sievedir:" /usr/sieve
 
@@ -2417,6 +2873,56 @@ FIELD DESCRIPTIONS
       not sync writes to the disk.  Enabling this option is NOT
       RECOMMENDED.
 
+   "smtp_backend:" sendmail
+
+      The SMTP backend to use for sending email.
+
+      The "host" backend sends message submissions via a TCP socket to
+      the SMTP host defined in the config option smtp_host.
+
+      The "sendmail" backend forks the Cyrus process into the
+      executable defined in the config option sendmail. The executable
+      must accept "-bs" as command line argument, read from stdin and
+      must implement the minimum SMTP protocol as defined in section
+      4.5.1 of **RFC 5321**.
+
+      If the SMTP EHLO command reports AUTH (**RFC 4954**) as a
+      supported extension, then the MAIL FROM command includes the
+      AUTH parameter, with its value set to the name of any
+      authenticated user which triggered the email. The AUTH parameter
+      is omitted if the user is unknown to the calling process.
+
+      If the directory *configdirectory*/log/smtpclient.*smtp_backend*
+      exists, then telemetry logs for outgoing SMTP sessions will be
+      created in this directory.
+
+      Allowed values: *host*, *sendmail*
+
+   "smtp_host:" localhost:587
+
+      The SMTP host to use for sending mail (also see the smtp_backend
+      option). The value of this option must the name or IP address of
+      a TCP host, followed optionally by a colon and the port or
+      service to use. The default port is 587. TLS may be activated by
+      appending "/tls" to the value. Authentication is enabled if
+      smtp_auth_authname is set. Authentication can be explicitly
+      disabled by appending "/noauth" to the host address.
+
+   "smtp_auth_authname:" <none>
+
+      The authentication name to use when authenticating to the SMTP
+      server defined in smtp_host.
+
+   "smtp_auth_password:" <none>
+
+      The password to use when authenticating to the SMTP server
+      defined in smtp_host.
+
+   "smtp_auth_realm:" <none>
+
+      The authentication SASL realm to use when authenticating to a
+      SMTP server.
+
    "soft_noauth:" 1
 
       If enabled, lmtpd returns temporary failures if the client does
@@ -2427,7 +2933,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for caching sort results (currently
       only used for xconvmultisort) Allowed values: *skiplist*,
-      *twoskip*, *lmdb*
+      *twoskip*, *zeroskip*
 
    "specialuse_extra:" <none>
 
@@ -2436,25 +2942,18 @@ FIELD DESCRIPTIONS
       special-use attributes can be set. This allows extending that
       list in the future or adding your own if needed.
 
-   "specialusealways:" 0
-
-      If enabled, this option causes LIST and LSUB output to always
-      include the XLIST "special-use" flags
-
-   "sphinx_text_excludes_odd_headers:" 0
-
-      If enabled, Sphinx will perform a TEXT search as if it matches
-      FROM, TO, CC, BCC or SUBJECT but not any other headers.  This is
-      contrary to the RFC but a more useful behaviour for most users.
-      Default: disabled.
-
-   "sphinx_socket:" {configdirectory}/socket/sphinx
+   "specialuse_protect:" \Archive \Drafts \Important \Junk \Sent
+   \Trash
 
-      Unix domain socket that the Sphinx searchd daemons listens on.
+      Whitespace separated list of special-use attributes to protect
+      the mailboxes for.  If set, don't allow mailboxes with these
+      special use attributes to be deleted or renamed to have a
+      different parent. Default is the built-in list
 
-   "sphinx_pidfile:" /var/run/sphinx.pid
+   "specialusealways:" 1
 
-      File where the Sphinx searchd daemon writes its pid.
+      If enabled, this option causes LIST and LSUB output to always
+      include the XLIST "special-use" flags
 
    "sql_database:" <none>
 
@@ -2482,6 +2981,30 @@ FIELD DESCRIPTIONS
 
       If enabled, a secure connection will be made to the SQL server.
 
+   "srs_alwaysrewrite:" 0
+
+      If true, perform SRS rewriting for ALL forwarding, even when not
+      required.
+
+   "srs_domain:" <none>
+
+      The domain to use in rewritten addresses. This must point only
+      to machines which know the encoding secret used by this system.
+      When present, SRS is enabled.
+
+   "srs_hashlength:" 0
+
+      The hash length to generate in a rewritten address.
+
+   "srs_secrets:" <none>
+
+      A list of secrets with which to generate addresses.
+
+   "srs_separator:" <none>
+
+      The separator to appear immediately after SRS[01] in rewritten
+      addresses.
+
    "srvtab:" <empty string>
 
       The pathname of *srvtab* file containing the server's private
@@ -2499,7 +3022,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the subscriptions list.
 
-      Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+      Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
    "suppress_capabilities:" <none>
 
@@ -2518,7 +3041,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the imap status cache.
 
-      Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
    "statuscache_db_path:" <none>
 
@@ -2595,12 +3118,15 @@ FIELD DESCRIPTIONS
       server. Prefix with a channel name to only apply for that
       channel
 
-   "sync_repeat_interval:" 1
+   "sync_repeat_interval:" 1s
+
+      Minimum interval between replication runs in rolling replication
+      mode. If a replication run takes longer than this time, we
+      repeat immediately.  Prefix with a channel name to only apply
+      for that channel.
 
-      Minimum interval (in seconds) between replication runs in
-      rolling replication mode. If a replication run takes longer than
-      this time, we repeat immediately. Prefix with a channel name to
-      only apply for that channel
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "sync_shutdown_file:" <none>
 
@@ -2609,11 +3135,14 @@ FIELD DESCRIPTIONS
       running processes. Prefix with a channel name to only apply for
       that channel
 
-   "sync_timeout:" 1800
+   "sync_timeout:" 30m
+
+      How long to wait for a response before returning a timeout
+      failure when talking to a replication peer (client or server).
+      The minimum duration is 3 seconds, the default is 30 minutes.
 
-      Number of seconds to wait for a response before returning a
-      timeout failure when talking to a replication peer (client or
-      server).
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "sync_try_imap:" 1
 
@@ -2625,6 +3154,13 @@ FIELD DESCRIPTIONS
    "syslog_prefix:" <none>
 
       String to be prepended to the process name in syslog entries.
+      Can be further overridden by setting the $CYRUS_SYSLOG_PREFIX
+      environment variable.
+
+      Using the $CYRUS_SYSLOG_PREFIX environment variable has the
+      additional advantage that it can be set before the
+      **imapd.conf** is read, so errors while reading the config file
+      can be syslogged with the correct prefix.
 
    "syslog_facility:" <none>
 
@@ -2643,12 +3179,18 @@ FIELD DESCRIPTIONS
 
    "tcp_keepalive_idle:" 0
 
-      Number of seconds a connection must be idle before keepalive
-      probes are sent (0 == system default)
+      How long a connection must be idle before keepalive probes are
+      sent (0 == system default).
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "tcp_keepalive_intvl:" 0
 
-      Number of seconds between keepalive probes (0 == system default)
+      Time between keepalive probes (0 == system default).
+
+      For backward compatibility, if no unit is specified, seconds is
+      assumed.
 
    "temp_path:" /tmp
 
@@ -2658,17 +3200,23 @@ FIELD DESCRIPTIONS
 
       If true, log by sessionid instead of PID for telemetry
 
-   "timeout:" 32
+   "timeout:" 32m
 
-      The length of the IMAP server's inactivity autologout timer, in
-      minutes.  The minimum value is 30.  The default is 32 to allow a
-      bit of leeway for clients that try to NOOP every 30 minutes.
+      The length of the IMAP server's inactivity autologout timer. The
+      minimum value is 30 minutes.  The default is 32 minutes, to
+      allow a bit of leeway for clients that try to NOOP every 30
+      minutes.
 
-   "imapidletimeout:" 0
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
-      Timeout for idling clients (**RFC 2177**) in minutes. If set to
-      zero (the default) or less, the value of "timeout" will be used
-      instead.
+   "imapidletimeout:" <none>
+
+      Timeout for idling clients (**RFC 2177**).  If not set (the
+      default), the value of "timeout" will be used instead.
+
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
    "tls_ca_file:" <none>
 
@@ -2703,6 +3251,10 @@ FIELD DESCRIPTIONS
 
       https://wiki.mozilla.org/Security/Server_Side_TLS
 
+   "tls_crl_file:" <none>
+
+      Path to a file containing the Certificate Revocation List
+
    "tls_client_ca_dir:" <none>
 
       Path to a directory containing the CA certificates used to
@@ -2767,29 +3319,41 @@ FIELD DESCRIPTIONS
    "tls_server_cert:" <none>
 
       File containing the certificate, including the full chain,
-      presented to clients.
+      presented to clients. Two certificates can be set, e.g RSA and
+      EC, if the filenames are separated with comma without spaces.
+
+   "tls_server_dhparam:" <none>
+
+      File containing the DH parameters belonging to the certificate
+      in tls_server_cert.
 
    "tls_server_key:" <none>
 
       File containing the private key belonging to the certificate in
-      tls_server_cert.
+      tls_server_cert.  If not set, tls_server_cert must contain both
+      private and public key.  Two files with keys can be set, if two
+      certifates are used, in which case the files must be separated
+      with comma without spaces
 
    "tls_sessions_db:" twoskip
 
       The cyrusdb backend to use for the TLS cache.
 
-      Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
    "tls_sessions_db_path:" <none>
 
       The absolute path to the TLS sessions db file. If not specified,
       will be configdirectory/tls_sessions.db
 
-   "tls_session_timeout:" 1440
+   "tls_session_timeout:" 24h
 
-      The length of time (in minutes) that a TLS session will be
-      cached for later reuse.  The maximum value is 1440 (24 hours),
-      the default.  A value of 0 will disable session caching.
+      The length of time that a TLS session will be cached for later
+      reuse.  The maximum value is 24 hours, also the default.  A
+      value of 0 will disable session caching.
+
+      For backward compatibility, if no unit is specified, minutes is
+      assumed.
 
    "tls_versions:" tls1_0 tls1_1 tls1_2 tls1_3
 
@@ -2815,7 +3379,7 @@ FIELD DESCRIPTIONS
 
       The cyrusdb backend to use for the user access list.
 
-      Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+      Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
    "userdeny_db_path:" <none>
 
@@ -2875,6 +3439,19 @@ FIELD DESCRIPTIONS
 
          Allowed values: *off*, *userid*, *on*
 
+   "virusscan_notification_subject:" Automatically deleted mail
+
+      The text used in the subject of email notifications created by
+      **cyr_virusscan(8)** when deleting infected mail.
+
+   "virusscan_notification_template:" <none>
+
+      The absolute path to a file containing a template to use to
+      describe infected messages that have been deleted by
+      **cyr_virusscan(8)**. See **cyr_virusscan(8)** for specification
+      of the format of this file. If not specified, the builtin
+      default template will be used.
+
    "xbackup_enabled:" 0
 
       Enable support for the XBACKUP command in imapd.  If enabled,
@@ -2900,15 +3477,26 @@ FIELD DESCRIPTIONS
 
    "zoneinfo_db:" twoskip
 
-      The cyrusdb backend to use for zoneinfo.
-
-      Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+      The cyrusdb backend to use for zoneinfo.  This database is used
+      by the "tzdist" *http_modules*, and is managed by
+      **ctl_zoneinfo(8)**. Allowed values: *flat*, *skiplist*,
+      *twoskip*, *zeroskip*
 
    "zoneinfo_db_path:" <none>
 
       The absolute path to the zoneinfo db file.  If not specified,
       will be configdirectory/zoneinfo.db
 
+   "zoneinfo_dir:" <none>
+
+      The absolute path to the zoneinfo directory, containing timezone
+      definitions as generated by the vzic tool.  If not specified,
+      whatever definitions libical finds will be used.
+
+      If you are providing a Time Zone Data Distribution Service (i.e.
+      you have "tzdist" listed in *http_modules*), then this
+      configuration option MUST be specified.
+
    "object_storage_enabled:" 0
 
       Is Object storage enabled for this server.  You also need to
@@ -2935,12 +3523,12 @@ FIELD DESCRIPTIONS
       are unique in their namespace. They provides virtual partitions,
       with quotas and QoS features.
 
-   "openio_rawx_timeout:" 30
+   "openio_rawx_timeout:" 30s
 
       The OpenIO timeout to query to the RAWX services (default 30
       sec).
 
-   "openio_proxy_timeout:" 5
+   "openio_proxy_timeout:" 5s
 
       The OpenIO timeout to query to the PROXY services (default 5
       sec).
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_backups.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_backups.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_backups.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_backups.txt	2020-05-04 04:13:59.000000000 +0000
@@ -145,6 +145,10 @@ Options
 
    With this option, the verification step will be skipped.
 
+-j
+
+   Produce output in JSON format.  The default is plain text.
+
 -v
 
    Increase the verbosity.  Can be specified multiple times.
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_conversationsdb.txt	2020-05-04 04:13:59.000000000 +0000
@@ -100,6 +100,12 @@ Options
    subset of **-b**; in particular it does not create conversations or
    assign messages to conversations.
 
+-S
+
+   If given with **-b**, allows splitting of conversations during the
+   rewrite.   Only do this is changing the maximum conversation size
+   and you need to split those existing conversations.
+
 
 Examples
 ========
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_cyrusdb.txt	2020-05-04 04:13:59.000000000 +0000
@@ -43,6 +43,12 @@ Options
    file is automatically converted using the same logic as
    cvt_cyrusdb.
 
+   If the "reverseacls" option in imapd.conf(5) is enabled, and the
+   RACL entries do not exist in the database, they will be generated.
+   Conversely, if RACL entries do exist in the database, but the
+   "reverseacls" option is disabled, then the entries will be cleaned
+   up.
+
 -x
 
    Used with "-r" to only recover the database, and prevent any
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_mboxlist.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_mboxlist.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ctl_mboxlist.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ctl_mboxlist.txt	2020-05-04 04:13:59.000000000 +0000
@@ -8,7 +8,7 @@ Perform operations on the mailbox list d
 Synopsis
 ========
 
-   **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [ **-p** *partition* ] [ **-f** *filename* ]
+   **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [**-y**] [ **-p** *partition* ] [ **-f** *filename* ]
    **ctl_mboxlist** [ **-C** *config-file* ] **-u** [ **-f** *filename* ]
    **ctl_mboxlist** [ **-C** *config-file* ] **-m** [ **-a** ] [ **-w** ] [ **-i** ] [ **-f** *filename* ]
    **ctl_mboxlist** [ **-C** *config-file* ] **-v** [ **-f** *filename* ]
@@ -47,9 +47,14 @@ Options
    When performing a dump, remove the mailboxes dumped from the
    mailbox list (mostly useful when specified with **-p**).
 
+-y
+
+   When performing a dump, also list intermediary mailboxes which
+   would be hidden from IMAP.
+
 -p partition
 
-   When performing a dump, dump only thise mailboxes that live on
+   When performing a dump, dump only those mailboxes that live on
    *partition*.
 
 -f filename
@@ -73,7 +78,7 @@ Note: Both the old and new formats can b
 -a
 
    When used with **-m**, assume the local mailboxes file is
-   authoritiative, that is, only change the mupdate server, do not
+   authoritative, that is, only change the mupdate server, do not
    delete any local mailboxes.
 
 Important: USE THIS OPTION WITH CARE, as it allows namespace
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyradm.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyradm.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyradm.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyradm.txt	2020-05-04 04:14:00.000000000 +0000
@@ -149,9 +149,9 @@ Example Usage
       john lrswipkxtecda
 
    Note that in the above example, the "unixhierarchysep" setting in
-   imapd.conf is set to "0". When using the UNIX hierarchy seperator,
+   imapd.conf is set to "0". When using the UNIX hierarchy separator,
    the "/" (forward slash) character would be used as the hierarchy
-   seperator, and the example would look as follows:
+   separator, and the example would look as follows:
 
 Example Usage with "unixhierarchysep: 1"
 
@@ -232,12 +232,22 @@ Show help for "command" or all commands.
 aliases: "?"
 
 
+getmetadata
+-----------
+
+**getmetadata** [*mailbox*]
+
+Display mailbox/server metadata
+
+aliases: "getmd"
+
+
 info
 ----
 
 **info** [*mailbox*]
 
-Display the mailbox/server metadata.
+Display the mailbox/server annotations.
 
 
 listaclmailbox
@@ -489,6 +499,33 @@ currently supported attributes are:
    for them (unless overridden by a mailbox annotation).
 
 
+setmetadata
+-----------
+
+**setmetadata** [--private] mailbox [*annotation*] *value*
+
+Set metadata on mailbox, where *annotation* is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/<explicit annotation>].
+
+Note that *value* with a leading backslash must be escaped with an
+additional backslash.  For example:
+
+   setmetadata --private Spam specialuse "\\Junk"
+
+Note, too, that "private" annotations are private to the user
+currently authenticated as, not necessarily the owner of the mailbox.
+To set annotations for another user you must authorize as that user.
+
+In addition to the use of optional flag **--private**, one may use a
+more explicit syntax, prefixing the annotation with '/shared/' or
+'/private/' as in this example:
+
+   setmetadata Spam /private/specialuse "\\Junk"
+
+aliases: "setmd"
+
+
 setquota
 --------
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_dbtool.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_dbtool.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_dbtool.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_dbtool.txt	2020-05-04 04:13:59.000000000 +0000
@@ -92,7 +92,8 @@ This is typically a Cyrus "flat" format
 database version number (currently 2), a list of "wildmat" patterns
 specifying Cyrus services to be denied, and a text message to be
 displayed to the user upon denial. The service names to be matched are
-those as used in cyrus.conf(5).
+those as used in cyrus.conf(5).  cyr_deny(8) provides more convenient
+way to manage *user_deny.db*.
 
 Note: Given that *keys* are tab-delimited, these examples use the
   notation <tab> to indicate the tab character.  When entering this
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_deny.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_deny.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_deny.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_deny.txt	2020-05-04 04:13:59.000000000 +0000
@@ -20,7 +20,8 @@ Description
 services. The first synopsis denies user *user* access to Cyrus
 services, the second synopsis allows access again.  **cyr_deny** works
 by adding an entry to the Cyrus "user_deny.db" database; the third
-synopsis lists the entries in the database.
+synopsis lists the entries in the database.  The service names to be
+matched are those as used in cyrus.conf(5).
 
 **cyr_deny** reads its configuration options out of the imapd.conf(5)
 file unless specified otherwise by **-C**.
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_expire.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_expire.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_expire.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_expire.txt	2020-05-04 04:13:59.000000000 +0000
@@ -30,12 +30,23 @@ Cyrus databases, specifically:
 * remove deleted mailboxes (when using the "delayed" delete mode),
   and
 
-* expire entries from conversations databases.
+* expire entries from conversations databases, and
 
-The expiration of messages is controlled by the "/vendor/cmu/cyrus-
-imapd/expire" mailbox annotation which specifies the age (in days) of
-messages in the given mailbox that should be deleted.  A value of 0
-means that no expiration is to be performed on that mailbox.
+* archive messages from mailbox.
+
+There are various annotations that **cyr_expire** respects:
+
+* "/vendor/cmu/cyrus-imapd/expire" which controls the expirations of
+  messages
+
+* "/vendor/cmu/cyrus-imapd/archive" which controls the archival of
+  messages
+
+* "/vendor/cmu/cyrus-imapd/delete" which controls the deletion of
+  messages
+
+These mailbox annotations specify the age(in days) of messages in the
+given mailbox that should be expired/archived/deleted.
 
 The value of the "/vendor/cmu/cyrus-imapd/expire" annotation is
 inherited by all children of the mailbox on which it is set, so an
@@ -50,9 +61,11 @@ commands of cyradm(8).
 
 Expiration of duplicate delivery database entries for a given mailbox
 is also controlled by the "/vendor/cmu/cyrus-imapd/expire" annotation
-which applies to that mailbox.  Unlike message expiration, if no
-annotation applies to the mailbox then duplicate database entries are
-expired using the value given to the **-E** option.
+which applies to that mailbox.  A value of 0 on the annotation means
+that no expiration is to be performed on that mailbox. Unlike message
+expiration, if no annotation applies to the mailbox then duplicate
+database entries are expired using the value given to the **-E**
+option.
 
 Expiration of conversations database entries occurs if the
 **conversations** option is present in imapd.conf(5). Expiration can
@@ -80,7 +93,9 @@ Options
    Archive non-flagged messages older than *archive-duration* to the
    archive partition, allowing mailbox messages to be split between
    fast storage and slow large storage.  Only does anything if
-   "archivepartition-*" has been set in your config.
+   "archivepartition-*" has been set in your config. This value is
+   only used for entries which do not have a corresponding
+   "/vendonr/cmu/cyrus-imapd/archive" mailbox annotation.
 
    This feature was introduced in version 3.0.
 
@@ -90,7 +105,9 @@ Options
    (when using the "delayed" delete mode). The value can be a floating
    point number, and may have a suffix to specify the unit of time.
    If no suffix, the value is number of days. Valid suffixes are **d**
-   (days), **h** (hours), **m** (minutes) and **s** (seconds).
+   (days), **h** (hours), **m** (minutes) and **s** (seconds). This
+   value is only used for entries which do not have a corresponding
+   "/verdor/cmu/cyrus-imapd/delete" mailbox annotation.
 
 -E expire-duration
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_info.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_info.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_info.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_info.txt	2020-05-04 04:13:59.000000000 +0000
@@ -29,18 +29,27 @@ file unless specified otherwise by **-C*
 
 conf
 
-   Print only the configuration options which are not the same as
-   default (regardless of whether you have specified them or not).
+   Print the configuration options which have been set to a value
+   other than their default, and their value.
 
-conf-default
-
-   Print all default configuration options, ignoring those set
-   locally.
+   With **-s version**, configuration options whose behaviour has
+   changed since *version* will be highlighted.
 
 conf-all
 
-   Print ALL configuration options - including default options.  This
-   command shows which options will be in effect at runtime.
+   Print ALL configuration options and their configured values
+   (including those using their default value).  This command shows
+   which options will be in effect at runtime.
+
+   With **-s version**, configuration options which have been added or
+   whose behaviour has changed since *version* will be highlighted.
+
+conf-default
+
+   Print the default values for all available configuration options.
+
+   With **-s version**, configuration options which have been added or
+   whose behaviour has changed since *version* will be highlighted.
 
 conf-lint
 
@@ -70,6 +79,17 @@ Options
 
    Read the configuration as if for the service named *name*.
 
+-s version
+
+   Highlight configuration options that have been added or whose
+   behaviour has been modified since *version*.  Use this option after
+   a server upgrade, specifying your previous version, to find which
+   options you need to review and maybe change before starting up the
+   upgraded server.
+
+   For use with the **conf**, **conf-all**, and **conf-default** sub-
+   commands.
+
 
 Examples
 ========
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_virusscan.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_virusscan.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/cyr_virusscan.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/cyr_virusscan.txt	2020-05-04 04:13:59.000000000 +0000
@@ -32,8 +32,9 @@ will be expunged from the user's mailbox
 
 With the notify flag, **-n**, notifications will be appended to the
 inbox of the mailbox owner, containing message digest information for
-the affected mail.  This flag is only works in combination with
-**-r**.
+the affected mail. This flag only works in combination with **-r**.
+The notification message can by customised by template, for details
+see Notifications below.
 
 **cyr_virusscan** can be configured to run periodically by cron(8) via
 crontab(5) or your preferred method (i.e. /etc/cron.hourly), or by
@@ -73,6 +74,46 @@ Options
    Produce more verbose output
 
 
+Notifications
+=============
+
+When the **-n** flag is provided, notifications are sent to mailbox
+owners when infected messages are removed.  One notification is sent
+per owner, containing a digest of each message that was deleted from
+any of their mailboxes.
+
+The default notification subject is "Automatically deleted mail",
+which can be overridden by setting "virusscan_notification_subject" in
+imapd.conf(5) to a UTF-8 value.
+
+Each infected message will be described according to the following
+template:
+
+   The following message was deleted from mailbox '%MAILBOX%'
+   because it was infected with virus '%VIRUS%'
+
+       Message-ID: %MSG_ID%
+       Date: %MSG_DATE%
+       From: %MSG_FROM%
+       Subject: %MSG_SUBJECT%
+       IMAP UID: %MSG_UID%
+
+To use a custom template, create a UTF-8 file containing your desired
+text and using the same %-delimited substitutions as above, and set
+the "virusscan_notification_template" option in imapd.conf(5) to its
+path.
+
+The notification message will be properly MIME-encoded at delivery. Do
+not pre-encode the template file or the subject!
+
+When **cyr_virusscan** starts up, if notifications have been requested
+(with the **-n** flag), a basic sanity check of the template will be
+performed prior to initialising the antivirus engine.  If it appears
+that the resultant notifications would be undeliverable for some
+reason, **cyr_virusscan** will exit immediately with an error, rather
+than risk deleting messages without notifying.
+
+
 Examples
 ========
 
@@ -84,7 +125,7 @@ Examples
    **cyr_virusscan** -r -n user/bovik
 
    Scan mailbox *user/bovik*, removing infected messages and append
-   notifications to bovik's inbox.
+   notifications to Bovik's inbox.
 
    **cyr_virusscan** -r -n -s 'SUBJECT "Fedex"' user/bovik
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ipurge.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ipurge.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ipurge.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ipurge.txt	2020-05-04 04:14:00.000000000 +0000
@@ -8,7 +8,7 @@ Delete mail from IMAP mailbox or partiti
 Synopsis
 ========
 
-   **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
+   **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-M** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
            [ **-d** *days* | **-b** *bytes* | **-k** *Kbytes* | **-m** *Mbytes* ]
            [ *mailbox-pattern*... ]
 
@@ -27,7 +27,8 @@ of **-d**, **-b**, **-k** or **-m** MUST
 *Ipurge* by default only deletes mail below shared folders, which
 means that mails in mailbox(es) below INBOX.* and user.* stay
 untouched. Use the option **-f** to also delete mail in mailbox(es)
-below these folders.
+below these folders. Use the **-M** option to not recurse into the
+mailboxes.
 
 *ipurge* reads its configuration options out of the imapd.conf(5) file
 unless specified otherwise by **-C**.
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/lmtpproxyd.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/lmtpproxyd.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/lmtpproxyd.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/lmtpproxyd.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,3 +4,79 @@
 
 This is a hard linked copy of lmtpd(8), retained for backwards
 compatibility from when a murder frontend used its own lmtpd binaries.
+
+
+Synopsis
+========
+
+   **lmtpd** [ **-C** *config-file* ]  [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ] [ **-a** ]
+
+
+Description
+===========
+
+**lmtpd** is an LMTP server used to deliver mail to the IMAP
+mailstore. It accepts commands on its standard input and responds on
+its standard output. It MUST be invoked by master(8) with those
+descriptors attached to a remote client connection.
+
+**lmtpd** reads its configuration options out of the imapd.conf(5)
+file unless specified otherwise by **-C**.
+
+
+Options
+=======
+
+-C config-file
+
+   Use the specified configuration file *config-file* rather than the
+   default imapd.conf(5).
+
+-U  uses
+
+   The maximum number of times that the process should be used for new
+   connections before shutting down.  The default is 250.
+
+-T  timeout
+
+   The number of seconds that the process will wait for a new
+   connection before shutting down.  Note that a value of 0 (zero)
+   will disable the timeout.  The default is 60.
+
+-D
+
+   Run external debugger specified in debug_command.
+
+-a
+
+   Preauthorize connections initiated on an internet socket, instead
+   of requiring LMTP AUTH.  This should only be used for connections
+   coming from trusted hosts.
+
+
+Examples
+========
+
+**lmtpd** is commonly included in the SERVICES section of
+cyrus.conf(5) like so:
+
+   SERVICES {
+       imap        cmd="imapd -U 30" listen="imap" prefork=0
+       imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+       **lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20**
+       sieve       cmd="timsieved" listen="sieve" prefork=0
+       notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+       httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+   }
+
+
+Files
+=====
+
+/etc/imapd.conf
+
+
+See Also
+========
+
+imapd.conf(5), master(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/master.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/master.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/master.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/master.txt	2020-05-04 04:14:00.000000000 +0000
@@ -19,8 +19,8 @@ Description
 
 **master** is the process that controls all of the Cyrus processes.
 This process is responsible for creating all imapd, pop3d, lmtpd and
-timsieved child processes. This process also initializes the Berkeley
-DB code and performs scheduled cleanup/maintenance.
+sieved child processes. This process also performs scheduled
+cleanup/maintenance.
 
 If this process dies, then no new sessions will be started.
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/mbpath.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/mbpath.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/mbpath.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/mbpath.txt	2020-05-04 04:14:00.000000000 +0000
@@ -8,18 +8,20 @@ Translate mailbox names to filesystem pa
 Synopsis
 ========
 
-   **mbpath** [ **-C** *config-file* ] [ **-q** ] [ **-s** ] [ **-m** ] [ *mailbox-names*... ]
+   **mbpath** [ **-C** *config-file* ] [ **-l** ] [ **-m** ] [ **-q** ] [ **-s** ] [ **-u** ] [ **-a** | **-A** | **-M** | **-S** | **-U** ] [ *mailbox-names*... ]
 
 
 Description
 ===========
 
 Given a mailbox name or a space separated list of mailbox names,
-**mbpath** outputs the filesystem path to the mailbox.
+**mbpath** outputs the filesystem path(s) of the mailbox.  By default,
+the mailboxes' data partition paths are shown (same as **-D**). See
+Selectors for selecting which filesystem path(s) to output.
 
 **mbpath** reads its configuration options out of the imapd.conf(5)
 file unless specified otherwise by **-C**. It uses
-<configdirectory>/mailboxes.db to locate the mailbox on disk.
+<configdirectory>/mailboxes.db to locate the mailboxes on disk.
 
 
 Options
@@ -30,6 +32,16 @@ Options
    Use the specified configuration file *config-file* rather than the
    default imapd.conf(5).
 
+-l
+
+   Local mailboxes only (exits with error for remote or nonexistent
+   mailboxes)
+
+-m
+
+   Output the path to the metadata files (if different from the
+   message files).  Legacy, use **-M**.
+
 -q
 
    Suppress any error output.
@@ -39,10 +51,37 @@ Options
    If any error occurs, stop processing the list of mailboxes and
    exit.
 
--m
+-u
 
-   Output the path to the metadata files (if different from the
-   message files).
+   The specified *mailbox-names* are users, not mailboxes.
+
+
+Selectors
+=========
+
+-A
+
+   Show the mailbox archive path
+
+-D
+
+   Show the mailbox data path (*default*)
+
+-M
+
+   Show the mailbox metadata path (same as **-m**)
+
+-S
+
+   Show the user sieve scripts path
+
+-U
+
+   Show the user files path (seen, sub, etc)
+
+-a
+
+   Show all paths, as if all selectors were specified
 
 
 Examples
@@ -50,12 +89,16 @@ Examples
 
    **mbpath** *user.jsmith*
 
-   Display the path for mailbox *user.jsmith*.
+   Display the data path for mailbox *user.jsmith*.
 
-   **mbpath -m** *user.jsmith*
+   **mbpath -M** *user.jsmith*
 
    Display the metadata path for mailbox *user.jsmith*.
 
+   **mbpath -u -S** *jsmith*
+
+   Display the sieve scripts path for user *jsmith*.
+
 
 Files
 =====
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/pop3proxyd.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/pop3proxyd.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/pop3proxyd.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/pop3proxyd.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,3 +4,79 @@
 
 This is a hard linked copy of pop3d(8), retained for backwards
 compatibility from when a murder frontend used its own pop3d binaries.
+
+
+Synopsis
+========
+
+   **lmtpd** [ **-C** *config-file* ]  [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ] [ **-a** ]
+
+
+Description
+===========
+
+**lmtpd** is an LMTP server used to deliver mail to the IMAP
+mailstore. It accepts commands on its standard input and responds on
+its standard output. It MUST be invoked by master(8) with those
+descriptors attached to a remote client connection.
+
+**lmtpd** reads its configuration options out of the imapd.conf(5)
+file unless specified otherwise by **-C**.
+
+
+Options
+=======
+
+-C config-file
+
+   Use the specified configuration file *config-file* rather than the
+   default imapd.conf(5).
+
+-U  uses
+
+   The maximum number of times that the process should be used for new
+   connections before shutting down.  The default is 250.
+
+-T  timeout
+
+   The number of seconds that the process will wait for a new
+   connection before shutting down.  Note that a value of 0 (zero)
+   will disable the timeout.  The default is 60.
+
+-D
+
+   Run external debugger specified in debug_command.
+
+-a
+
+   Preauthorize connections initiated on an internet socket, instead
+   of requiring LMTP AUTH.  This should only be used for connections
+   coming from trusted hosts.
+
+
+Examples
+========
+
+**lmtpd** is commonly included in the SERVICES section of
+cyrus.conf(5) like so:
+
+   SERVICES {
+       imap        cmd="imapd -U 30" listen="imap" prefork=0
+       imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+       **lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20**
+       sieve       cmd="timsieved" listen="sieve" prefork=0
+       notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+       httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+   }
+
+
+Files
+=====
+
+/etc/imapd.conf
+
+
+See Also
+========
+
+imapd.conf(5), master(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/proxyd.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/proxyd.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/proxyd.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/proxyd.txt	2020-05-04 04:14:00.000000000 +0000
@@ -2,18 +2,49 @@
 **proxyd**
 **********
 
-In Progress
+Proxyd is a symlink to imapd(8) if you build with murder enabled.
 
 
 Synopsis
 ========
 
-   **proxyd** [ **-C** *config-file* ]
+   **imapd** [ **-C** *config-file* ] [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ]
+       [ **-s** ] [ **-N** ] [ **-p** *ssf* ]
 
 
 Description
 ===========
 
+**imapd** is an IMAP4rev1 server.  It accepts commands on its standard
+input and responds on its standard output.  It MUST be invoked by
+master(8) with those descriptors attached to a remote client
+connection.
+
+**imapd** reads its configuration options out of the imapd.conf(5)
+file unless specified otherwise by **-C**.
+
+If the file "msg/shutdown" is created under the directory specified in
+the "configdirectory" configuration option, then **imapd** will shut
+down the connection, sending the first line contained in the file to
+the client as the reason.  New connections are denied.
+
+If the file "msg/motd" is created under the directory specified in the
+"configdirectory" configuration option, then **imapd** will send the
+first line contained in the file to clients upon connect as an ALERT
+message which IMAP-compliant clients are required to display.
+
+This option serves to annoy users mostly.  Unfortunately clients tend
+to connect far more frequently than is apparent, generating a separate
+server ALERT for each connection.  Many clients do not display these
+properly, if they do anything with them at all.
+
+If the directory "log"/*user* exists under the directory specified in
+the "configdirectory" configuration option, then **imapd** will create
+protocol telemetry logs for sessions authenticating as *user*.
+
+The telemetry logs will be stored in the "log"/*user* directory with a
+filename of the **imapd** process-id.
+
 
 Options
 =======
@@ -23,10 +54,61 @@ Options
    Use the specified configuration file *config-file* rather than the
    default imapd.conf(5).
 
-/etc/imapd.conf, /etc/cyrus.conf
+-U  uses
+
+   The maximum number of times that the process should be used for new
+   connections before shutting down.  The default is 250.
+
+-T  timeout
+
+   The number of seconds that the process will wait for a new
+   connection before shutting down.  Note that a value of 0 (zero)
+   will disable the timeout.  The default is 60.
+
+-D
+
+   Run external debugger specified in debug_command.
+
+-s
+
+   Serve IMAP over SSL (imaps).  All data to and from **imapd** is
+   encrypted using the Secure Sockets Layer.
+
+-N
+
+   Bypass password checking.  (Not recommended unless you know what
+   you're doing.)
+
+-p  ssf
+
+   Tell **imapd** that an external layer exists.  An *SSF* (security
+   strength factor) of 1 means an integrity protection layer exists.
+   Any higher SSF implies some form of privacy protection.
+
+
+Examples
+========
+
+**imapd** is commonly included in the SERVICES section of
+cyrus.conf(5) like so:
+
+   SERVICES {
+       **imap        cmd="imapd -U 30" listen="imap" prefork=0**
+       **imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100**
+       lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+       sieve       cmd="timsieved" listen="sieve" prefork=0
+       notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+       httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+   }
+
+
+Files
+=====
+
+/etc/imapd.conf
 
 
 See Also
 ========
 
-imapd.conf(5), cyrus.conf(5)
+imapd.conf(5), master(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ptloader.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ptloader.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/ptloader.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/ptloader.txt	2020-05-04 04:14:00.000000000 +0000
@@ -16,7 +16,7 @@ Description
 
 **ptloader** interacts with the authorization service, either AFS or
 LDAP, providing group membership information to Cyrus.  When
-"auth_mech: pts" is set in imapd.conf(5), **ptsloader** will then
+"auth_mech: pts" is set in imapd.conf(5), **ptloader** will then
 consult the backend specified in the "pts_module" setting (currently
 either "afs" or "ldap").
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/quota.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/quota.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/quota.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/quota.txt	2020-05-04 04:14:00.000000000 +0000
@@ -8,7 +8,7 @@ Report and optionally fix storage and me
 Synopsis
 ========
 
-   **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ *mailbox-prefix*... ]
+   **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ **-u** ] [ *mailbox-spec*... ]
 
 
 Description
@@ -25,12 +25,16 @@ If an optional *domain* is specified wit
 listing (and any inconsistency fixing) is performed only in that
 domain rather than all mailboxes.
 
-If one or more *mailbox-prefix* arguments are specified, the quota
-listing (and inconsistency fixing) is limited to quota roots with
-names that start with one of the given prefixes.
+If one or more *mailbox-spec* arguments are specified, these are
+interpreted as mailbox prefixes, and the quota listing (and
+inconsistency fixing) is limited to quota roots with names that start
+with one of the given prefixes. If the **-u** is provided, *mailbox-
+spec* arguments are instead interpreted as userids, and the quota
+listing (and inconsistency fixing) is limited to quota roots for only
+the specified users.
 
 Warning: Running **quota** with both the **-f** option and *mailbox-
-  prefix* arguments is not recommended.
+  spec* arguments is not recommended.
 
 **quota** reads its configuration options out of the imapd.conf(5)
 file unless specified otherwise by **-C**.
@@ -53,6 +57,12 @@ Options
    Fix any inconsistencies in the quota subsystem before generating a
    report.
 
+-n
+
+   Check for any inconsistencies in the quota subsystem but don't
+   actually fix them.  Use with **-f** and **-q** to only see what's
+   incorrect.
+
 -q
 
    Operate quietly. If **-f** is specified, then don't print the quota
@@ -62,10 +72,15 @@ Options
 
    Output the quota values as JSON for automated tooling support
 
-mailbox-prefix
+-u
+
+   Interpret *mailbox-spec* arguments as userids.  The default is to
+   interpret them as mailbox prefixes
+
+mailbox-spec
 
-   Only report and/or fix quota in mailboxes starting with the
-   specified *mailbox-prefix*.
+   Only report and/or fix quota in mailboxes matching the specified
+   *mailbox-spec* arguments.  See also **-u**.
 
 
 Examples
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/reconstruct.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/reconstruct.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/reconstruct.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/reconstruct.txt	2020-05-04 04:14:00.000000000 +0000
@@ -10,7 +10,7 @@ Synopsis
 
    **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
        [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
-       [ **-O** ] [ **-M** ] *mailbox*...
+       [ **-O** ] [ **-M** ] [ **-V** *version* ] *mailbox*...
 
    **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
        [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
@@ -89,7 +89,7 @@ Options
 
    Don't stat underlying files.  This makes reconstruct run faster, at
    the expense of not noticing some issues (like zero byte files or
-   size mistmatches).  "**reconstruct -s**" should be quite fast.
+   size mismatches).  "**reconstruct -s**" should be quite fast.
 
 -q
 
@@ -181,7 +181,7 @@ Examples
 
    **reconstruct -r -f -u** *jsmith*
 
-   Recusively reconstruct all mailboxes belonging to *jsmith*,
+   Recursively reconstruct all mailboxes belonging to *jsmith*,
    restoring any directories containing "cyrus.header" files.
 
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/rehash.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/rehash.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/rehash.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/rehash.txt	2020-05-04 04:14:00.000000000 +0000
@@ -52,7 +52,7 @@ imapd.conf
       -f forces fulldirhash: no
       -F forces fulldirhash: yes
 
--i
+-i | -I
 
       -i forces hashimapspool: no
       -I forces hashimapspool: yes
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/smmapd.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/smmapd.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/smmapd.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/smmapd.txt	2020-05-04 04:14:00.000000000 +0000
@@ -51,6 +51,19 @@ Options
 Examples
 ========
 
+**smmapd** is commonly included in the SERVICES section of
+cyrus.conf(5) like so:
+
+   SERVICES {
+       imap        cmd="imapd -U 30" listen="imap" prefork=0
+       imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+       lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+       **smmap       cmd="smmapd" listen="/var/run/cyrus/socket/smmap" prefork=0**
+       sieve       cmd="timsieved" listen="sieve" prefork=0
+       notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+       httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+   }
+
 
 Files
 =====
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/squatter.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/squatter.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/squatter.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/squatter.txt	2020-05-04 04:14:00.000000000 +0000
@@ -12,13 +12,12 @@ Synopsis
    **squatter** [ **-C** *config-file* ] [**mode**] [**options**] [**source**]
 
    i.e.:
-   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ]
-   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  *mailbox*...
-   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  **-u** *user*...
-   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ]
-   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ]
-   **squatter** [ **-C** *config-file* ] [ **-v** ] **-I** *file*
-   **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ]  [ **-S** *seconds* ] [ **-u** *user*... ]
+   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ] [ **-Z** ]
+   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] *mailbox*...
+   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] **-u** *user*...
+   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ] [ **-Z** ]
+   **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ] [ **-Z** ]
+   **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-U** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ] [ **-S** *seconds* ] [ **-u** *user*... ]
 
 
 Description
@@ -38,8 +37,8 @@ The index is a unified index of all of t
 each message in a given mailbox.  This index is used to significantly
 reduce IMAP SEARCH times on a mailbox.
 
-**mode** is one of indexer, indexfrom (-I), search, rolling, synclog
-or compact.
+**mode** is one of indexer, search, rolling, synclog, compact or
+audit.
 
 By default, **squatter** creates an index of ALL messages in the
 mailbox, not just those since the last time that it was run.  The
@@ -75,20 +74,28 @@ In the fifth synopsis, **squatter** read
 performs incremental indexing on the mailbox(es) listed therein.  This
 is sometimes useful for cleaning up after problems with rolling mode.
 
-In the sixth synopsis, **squatter** reads *file* containing *mailbox*
-*uid* tuples and performs indexing on the specified messages.
-
-In the seventh synopsis, **squatter** will compact indices from
+In the sixth synopsis, **squatter** will compact indices from
 *srctier(s)* to *desttier*, optionally reindexing (**-X**) or
 filtering expunged records (**-F**) in the process.  The optional
 **-T** flag may be used to specify a directory to use for temporary
-files.  The **-o** flag may be used to direct that a single index be
-copied, rather than compacted, from *srctier* to *desttier*.  The
-**-u** flag may be used to restrict operation to the specified
-user(s).
-
-For all modes, the **-S** option may be specified, causing squatter to
-pause *seconds* seconds after each mailbox, to smooth loads.
+files.  These files are eventually copied with *rsync -a* and then
+removed by *rm*. *rsync* can increase the load average of the system,
+especially when the temporary directory is on *tmpfs*.  To throttle
+*rsync* it is possible to modify the call in *imap/search_xapian.c*
+and pass *-\-bwlimit=<number>* as further parameter.  The **-o** flag
+may be used to direct that a single index be copied, rather than
+compacted, from *srctier* to *desttier*.  The **-u** flag may be used
+to restrict operation to the specified user(s).
+
+For all modes, the **-S** option may be specified, causing
+**squatter** to pause *seconds* seconds after each mailbox, to smooth
+loads.
+
+When using the Xapian engine the **-Z** option may be specified, for
+the indexing modes.  This tells **squatter** to consult the Xapian
+internally indexed GUIDs, rather than relying on what's stored in
+*cyrus.indexed.db*, allowing for recovery from broken
+*cyrus.indexed.db* at the sacrifice of efficiency.
 
 Note: Incremental updates are very inefficient with the SQUAT search
   engine.  If using SQUAT for large and active mailboxes, you should
@@ -123,6 +130,11 @@ Options
    the mailbox is not indexed. In other words, the implicit value of
    */vendor/cmu/cyrus-imapd/squat* is "false".
 
+-A
+
+   Missing documentation, starts audit mode. This feature is only
+   available on the master branch.
+
 -d
 
    In rolling mode, don't background and do emit log messages on
@@ -145,11 +157,6 @@ Options
 
    Display this usage information.
 
--I file
-
-   Read from *file* and index individual messages described by
-   mailbox/uid tuples contained therein.
-
 -i
 
    Incremental updates where indexes already exist.
@@ -172,6 +179,11 @@ Options
    it to the destination rather than compacting. This feature was
    introduced in version 3.0.
 
+-P
+
+   Missing documentation, reindex parts mode. This feature is only
+   available on the master branch.
+
 -R
 
    Run in rolling mode; **squatter** runs as a daemon listening to a
@@ -201,7 +213,7 @@ Options
 
 -t srctier...
 
-   In compact mode, the comma separated source tier(s) for the
+   In compact mode, the comma-separated source tier(s) for the
    compacted indices.  At least one source tier must be specified in
    compact mode. Xapian only. This feature was introduced in version
    3.0.
@@ -212,6 +224,11 @@ Options
    mailbox names.  Usernames are space-separated. This feature was
    introduced in version 3.0.
 
+-U
+
+   In compact mode, only compact if re-indexing. Xapian only. This
+   feature is only available on the master branch.
+
 -v
 
    Increase the verbosity of progress/status messages.  Sometimes
@@ -233,6 +250,14 @@ Options
    This must be specified in compact mode. Xapian only. This feature
    was introduced in version 3.0.
 
+-Z
+
+   When indexing messages, use the Xapian internal cyrusid rather than
+   referencing the ranges of already indexed messages to know if a
+   particular message is indexed.  Useful if the ranges get out of
+   sync with the actual messages (e.g. if files on a tier are lost)
+   Xapian only. This feature is only available on the master branch.
+
 
 Examples
 ========
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/sync_reset.txt 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/sync_reset.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/systemcommands/sync_reset.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/systemcommands/sync_reset.txt	2020-05-04 04:14:00.000000000 +0000
@@ -15,8 +15,8 @@ Description
 ===========
 
 **sync_reset** is a small utility program to destroy user accounts on
-a system.  The only safeguard which is in place is the obligary force
-option.
+a system.  The only safeguard which is in place is the obligatory
+force option.
 
 **sync_reset** reads its configuration options out of the
 imapd.conf(5) file unless specified otherwise by **-C**.
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/httptest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/httptest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/httptest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/httptest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,26 +4,31 @@
 
 Interactive HTTP test program.
 
+This is actually installed as a hard linked copy of imtest(1).
+
+It allows you to authenticate and send HTTP commands to the server.
+
 
 Synopsis
 ========
 
-   **httptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-       [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-       [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-This is actually installed as a hard linked copy of imtest(1).
-
-**httptest** is a utility that allows you to authenticate to a HTTP
-server and interactively issue requests to it. Once authenticated you
-may issue any HTTP request by simply typing it in. It is capable of
-multiple SASL authentication mechanisms and handles encryption layers
-transparently. This utility is often used for testing the operation of
-an http server. Also those developing HTTP clients find it useful.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
@@ -37,15 +42,15 @@ Options
 
 -p  port
 
-   Port to connect to. If left off this defaults to **http** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **httptest** to use *mechanism* for authentication. If not
-   specified, the strongest authentication mechanism supported by the
-   server is chosen.  Specify one of *Basic*, *Digest*, *NTLM*, or
-   *Negotiate* (GSS-SPNEGO).
+   Force **imtest** to use *mechanism* for authentication. If not
+   specified the strongest authentication mechanism supported by the
+   server is chosen.  Specify *login* to use the LOGIN command instead
+   of AUTHENTICATE.
 
 -a  userid
 
@@ -58,6 +63,9 @@ Options
    Userid to use for authorization; defaults to the current user. This
    is the userid whose identity will be assumed after authentication.
 
+   Note: This is only used with SASL mechanisms that allow proxying
+     (e.g. PLAIN, DIGEST-MD5).
+
 -k  num
 
    Minimum protection layer required.
@@ -87,7 +95,11 @@ Options
 
 -s
 
-   Enable HTTP over SSL (https).
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
 
 -c
 
@@ -100,11 +112,28 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
--w
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
+-w passwd
 
    Password to use (if not supplied, we will prompt).
 
@@ -120,4 +149,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 httpd(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/imtest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/imtest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/imtest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/imtest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -2,7 +2,7 @@
 **imtest**
 **********
 
-Interactive IMAP test program
+Interactive IMAP test program.
 
 
 Synopsis
@@ -91,7 +91,7 @@ Options
 
 -s
 
-   Enable IMAP over SSL (imaps).
+   Enable SSL over chosen protocol.
 
 -q
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/installsieve.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/installsieve.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/installsieve.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/installsieve.txt	2020-05-04 04:14:00.000000000 +0000
@@ -45,9 +45,7 @@ Options
 
    Install a file onto the server. If a script with the same name
    already exists on the server it is overwritten. Upon successfully
-   putting the script on the server the script is set active. If
-   *file* has the extension .script it is chopped when put on the
-   server since sieve names may not contain a '.'.
+   putting the script on the server the script is set active.
 
 -a  name
 
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/lmtptest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/lmtptest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/lmtptest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/lmtptest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,27 +4,31 @@
 
 Interactive LMTP test program
 
+This is actually installed as a hard link to imtest(1).
+
+It allows you to authenticate and send LMTP commands to the server.
+
 
 Synopsis
 ========
 
-   **lmtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
-       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-c** ] [ **-i** ]
-       [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-This is actually installed as a hard link to imtest(1).
-
-**lmtptest** is a utility that allows you to authenticate to a LMTP
-server and interactively issue commands to it. Once authenticated you
-may issue any LMTP command by simply typing it in. It is capable of
-multiple SASL authentication mechanisms and handles encryption layers
-transparently. This utility is often used for testing the operation of
-a lmtp server. Also those developing LMTP clients find it useful.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
@@ -38,12 +42,12 @@ Options
 
 -p  port
 
-   Port to connect to. If left off this defaults to **lmtp** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **lmtptest** to use *mechanism* for authentication. If not
+   Force **imtest** to use *mechanism* for authentication. If not
    specified the strongest authentication mechanism supported by the
    server is chosen.  Specify *login* to use the LOGIN command instead
    of AUTHENTICATE.
@@ -89,6 +93,14 @@ Options
    attempt to do SSL/TLS session reuse and/or fast reauth (e.g.
    DIGEST-MD5), if possible.
 
+-s
+
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
+
 -c
 
    Enable challenge prompt callbacks.  This will cause the OTP
@@ -100,10 +112,27 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
 -w passwd
 
    Password to use (if not supplied, we will prompt).
@@ -120,4 +149,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 lmtpd(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/mupdatetest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/mupdatetest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/mupdatetest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/mupdatetest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,38 +4,50 @@
 
 Interactive MUPDATE test program
 
+This is actually installed as a hard linked copy of imtest(1).
+
+It allows you to authenticate and send MUPDATE commands to the server.
+
 
 Synopsis
 ========
 
-   **mupdatetest** [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ] [ **-u** *userid* ]
-       [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ]
-       [ **-q** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-**mupdatetest** is a utility that allows you to authenticate to a
-MUPDATE server and interactively issue commands to it. Once
-authenticated you may issue any MUPDATE command by simply typing it
-in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used
-for testing the operation of a mupdate server. Note that you must be
-an admin in order to authenticate to an mupdate server.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
 =======
 
+-t  keyfile
+
+   Enable TLS.  *keyfile* contains the TLS public and private keys.
+   Specify **""** to negotiate a TLS encryption layer but not use TLS
+   authentication.
+
 -p  port
 
-   Port to connect to. If left off this defaults to **mupdate** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **mupdatetest** to use *mechanism* for authentication. If not
+   Force **imtest** to use *mechanism* for authentication. If not
    specified the strongest authentication mechanism supported by the
    server is chosen.  Specify *login* to use the LOGIN command instead
    of AUTHENTICATE.
@@ -81,9 +93,13 @@ Options
    attempt to do SSL/TLS session reuse and/or fast reauth (e.g.
    DIGEST-MD5), if possible.
 
+-s
+
+   Enable SSL over chosen protocol.
+
 -q
 
-   Enable MUPDATE COMPRESSion (after authentication).
+   Enable IMAP COMPRESSion (after authentication).
 
 -c
 
@@ -96,10 +112,27 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
 -w passwd
 
    Password to use (if not supplied, we will prompt).
@@ -116,4 +149,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 mupdate(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/nntptest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/nntptest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/nntptest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/nntptest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -2,128 +2,10 @@
 **nntptest**
 ************
 
-Interactive NNTP test program
+Interactive NNTP test program.
 
+This is actually installed as a hard linked copy of imtest(1).
 
-Synopsis
-========
-
-   **nntptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-       [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-       [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-q** ]
-       [ **-o** *option*=*value* ] *hostname*
-
-
-Description
-===========
-
-**nntptest** is a utility that allows you to authenticate to a NNTP
-server and interactively issue commands to it. Once authenticated you
-may issue any NNTP command by simply typing it in. It is capable of
-multiple SASL authentication mechanisms and handles encryption layers
-transparently. This utility is often used for testing the operation of
-an nntp server. Also those developing NNTP clients find it useful.
-
-
-Options
-=======
-
--t  keyfile
-
-   Enable TLS.  *keyfile* contains the TLS public and private keys.
-   Specify **""** to negotiate a TLS encryption layer but not use TLS
-   authentication.
-
--p  port
-
-   Port to connect to. If left off this defaults to **nntp** as
-   defined in "/etc/services".
-
--m  mechanism
-
-   Force **nntptest** to use *mechanism* for authentication. If not
-   specified, the strongest authentication mechanism supported by the
-   server is chosen.  Specify *user* to use the AUTHINFO USER/PASS
-   commands instead of AUTHINFO SASL.
-
--a  userid
-
-   Userid to use for authentication; defaults to the current user.
-   This is the userid whose password or credentials will be presented
-   to the server for verification.
-
--u  userid
-
-   Userid to use for authorization; defaults to the current user. This
-   is the userid whose identity will be assumed after authentication.
-
-   Note: This is only used with SASL mechanisms that allow proxying
-     (e.g. PLAIN, DIGEST-MD5).
-
--k  num
-
-   Minimum protection layer required.
-
--l  num
-
-   Maximum protection layer to use (**0**=none; **1**=integrity; etc).
-   For example if you are using the KERBEROS_V4 authentication
-   mechanism specifying **0** will force imtest to not use any layer
-   and specifying **1** will force it to use the integrity layer.  By
-   default the maximum supported protection layer will be used.
-
--r  realm
-
-   Specify the *realm* to use. Certain authentication mechanisms (e.g.
-   DIGEST-MD5) may require one to specify the realm.
-
--f  file
-
-   Pipe *file* into connection after authentication.
-
--n  num
-
-   Number of authentication attempts; default = 1.  The client will
-   attempt to do SSL/TLS session reuse and/or fast reauth (e.g.
-   DIGEST-MD5), if possible.
-
--s
-
-   Enable NNTP over SSL (nntps).
-
--q
-
-   Enable NNTP COMPRESSion (after authentication)
-
--c
-
-   Enable challenge prompt callbacks.  This will cause the OTP
-   mechanism to ask for the the one-time password instead of the
-   secret pass-phrase (library generates the correct response).
-
--i
-
-   Don't send an initial client response for SASL mechanisms, even if
-   the protocol supports it.
-
--v
-
-   Verbose. Print out more information than usual.
-
--w passwd
-
-   Password to use (if not supplied, we will prompt).
-
--o  option=value
-
-   Set the SASL *option* to *value*.
-
-
-Examples
-========
-
-
-See Also
-========
+It allows you to authenticate and send NNTP commands to the server.
 
 nntpd(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/pop3test.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/pop3test.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/pop3test.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/pop3test.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,26 +4,31 @@
 
 Interactive POP3 test program.
 
+This is actually installed as a hard linked copy of imtest(1).
+
+It allows you to authenticate and send POP commands to the server.
+
 
 Synopsis
 ========
 
-   **pop3test** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-       [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-       [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-This is actually installed as a hard linked copy of imtest(1).
-
-**pop3test** is a utility that allows you to authenticate to a POP3
-server and interactively issue commands to it. Once authenticated you
-may issue any POP3 command by simply typing it in. It is capable of
-multiple SASL authentication mechanisms and handles encryption layers
-transparently. This utility is often used for testing the operation of
-an pop3 server. Also those developing POP3 clients find it useful.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
@@ -37,15 +42,15 @@ Options
 
 -p  port
 
-   Port to connect to. If left off this defaults to **pop3** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **pop3test** to use *mechanism* for authentication. If not
-   specified, the strongest authentication mechanism supported by the
-   server is chosen.  Specify *user* to use the USER/PASS commands or
-   *apop* to use the APOP command instead of AUTH.
+   Force **imtest** to use *mechanism* for authentication. If not
+   specified the strongest authentication mechanism supported by the
+   server is chosen.  Specify *login* to use the LOGIN command instead
+   of AUTHENTICATE.
 
 -a  userid
 
@@ -90,7 +95,11 @@ Options
 
 -s
 
-   Enable POP3 over SSL (pop3s).
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
 
 -c
 
@@ -103,10 +112,27 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
 -w passwd
 
    Password to use (if not supplied, we will prompt).
@@ -123,4 +149,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 pop3d(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/sieveshell.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/sieveshell.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/sieveshell.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/sieveshell.txt	2020-05-04 04:14:00.000000000 +0000
@@ -45,12 +45,13 @@ OPTIONS
 
 **-u** *user*, **--user**=*user*
 
-   The authorization name to request; by default, derived from the
-   authentication credentials.
+   The user whose mailboxes you want to work on. If not specified, it
+   uses the same as -a.
 
 **-a** *authname*, **--authname**=*authname*
 
-   The user to use for authentication (defaults to current user).
+   The user to use for authentication. If not specified, it defaults
+   to the current login user.
 
 **-r** *realm*, **--realm**=*realm*
 
@@ -66,8 +67,7 @@ REFERENCES
 ==========
 
 [MANAGESIEVE] Martin, T.; "A Protocol for Remotely Managing Sieve
-Scripts", draft-ietf-managesieve-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.
+Scripts", RFC 5804; May 2001
 
 
 AUTHOR
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/sivtest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/sivtest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/sivtest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/sivtest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -2,27 +2,34 @@
 **sivtest**
 ***********
 
-Interactive MANAGESIEVE test program
+Interactive MANAGESIEVE test program.
+
+This is actually installed as a hard linked copy of imtest(1).
+
+It allows you to authenticate and send MANAGESIEVE commands to the
+server.
 
 
 Synopsis
 ========
 
-   **sivtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-       [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-       [ **-n** *num* ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-**sivtest** is a utility that allows you to authenticate to a
-MANAGESIEVE server and interactively issue commands to it. Once
-authenticated you may issue any MANAGESIEVE command by simply typing
-it in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used
-for testing the operation of a timsieved(8) server. Also those
-developing MANAGESIEVE clients find it useful.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
@@ -36,13 +43,13 @@ Options
 
 -p  port
 
-   Port to connect to. If left off this defaults to **sieve** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **sivtest** to use *mechanism* for authentication. If not
-   specified, the strongest authentication mechanism supported by the
+   Force **imtest** to use *mechanism* for authentication. If not
+   specified the strongest authentication mechanism supported by the
    server is chosen.  Specify *login* to use the LOGIN command instead
    of AUTHENTICATE.
 
@@ -87,6 +94,14 @@ Options
    attempt to do SSL/TLS session reuse and/or fast reauth (e.g.
    DIGEST-MD5), if possible.
 
+-s
+
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
+
 -c
 
    Enable challenge prompt callbacks.  This will cause the OTP
@@ -98,10 +113,27 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
 -w passwd
 
    Password to use (if not supplied, we will prompt).
@@ -118,4 +150,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 timsieved(8)
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/smtptest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/smtptest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/smtptest.txt	2019-12-16 04:18:27.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/smtptest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -2,26 +2,33 @@
 **smtptest**
 ************
 
-Interactive SMTP test program
+Interactive SMTP test program.
+
+This is actually installed as a hard linked copy of imtest(1).
+
+It allows you to authenticate and send SMTP commands to the server.
 
 
 Synopsis
 ========
 
-   **smtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-       [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-       [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
 
 
 Description
 ===========
 
-**smtptest** is a utility that allows you to authenticate to an SMTP
-server and interactively issue commands to it. Once authenticated you
-may issue any SMTP command by simply typing it in. It is capable of
-multiple SASL authentication mechanisms and handles encryption layers
-transparently. This utility is often used for testing the operation of
-an SMTP server. Also those developing SMTP clients find it useful.
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
 
 
 Options
@@ -35,13 +42,13 @@ Options
 
 -p  port
 
-   Port to connect to. If left off this defaults to **smtp** as
+   Port to connect to. If left off this defaults to **imap** as
    defined in "/etc/services".
 
 -m  mechanism
 
-   Force **smtptest** to use *mechanism* for authentication. If not
-   specified, the strongest authentication mechanism supported by the
+   Force **imtest** to use *mechanism* for authentication. If not
+   specified the strongest authentication mechanism supported by the
    server is chosen.  Specify *login* to use the LOGIN command instead
    of AUTHENTICATE.
 
@@ -88,7 +95,11 @@ Options
 
 -s
 
-   Enable SMTP over SSL (smtps).
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
 
 -c
 
@@ -101,10 +112,27 @@ Options
    Don't send an initial client response for SASL mechanisms, even if
    the protocol supports it.
 
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
 -v
 
    Verbose. Print out more information than usual.
 
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
 -w passwd
 
    Password to use (if not supplied, we will prompt).
@@ -121,4 +149,6 @@ Examples
 See Also
 ========
 
+imapd(8)
+
 *sendmail(8)*
diff -pruN 3.0.13-5/doc/text/imap/reference/manpages/usercommands/synctest.txt 3.2.0-3/doc/text/imap/reference/manpages/usercommands/synctest.txt
--- 3.0.13-5/doc/text/imap/reference/manpages/usercommands/synctest.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/imap/reference/manpages/usercommands/synctest.txt	2020-05-04 04:14:00.000000000 +0000
@@ -4,3 +4,146 @@
 
 Interactive IMAP test program: tests the replication protocol. This is
 installed as a hard link to imtest(1).
+
+
+Synopsis
+========
+
+   **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+       [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+       [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+       [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+       [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*=*value* ] *hostname*
+
+
+Description
+===========
+
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for
+testing the operation of a imsp or imap server. Also those developing
+IMAP clients find it useful.
+
+
+Options
+=======
+
+-t  keyfile
+
+   Enable TLS.  *keyfile* contains the TLS public and private keys.
+   Specify **""** to negotiate a TLS encryption layer but not use TLS
+   authentication.
+
+-p  port
+
+   Port to connect to. If left off this defaults to **imap** as
+   defined in "/etc/services".
+
+-m  mechanism
+
+   Force **imtest** to use *mechanism* for authentication. If not
+   specified the strongest authentication mechanism supported by the
+   server is chosen.  Specify *login* to use the LOGIN command instead
+   of AUTHENTICATE.
+
+-a  userid
+
+   Userid to use for authentication; defaults to the current user.
+   This is the userid whose password or credentials will be presented
+   to the server for verification.
+
+-u  userid
+
+   Userid to use for authorization; defaults to the current user. This
+   is the userid whose identity will be assumed after authentication.
+
+   Note: This is only used with SASL mechanisms that allow proxying
+     (e.g. PLAIN, DIGEST-MD5).
+
+-k  num
+
+   Minimum protection layer required.
+
+-l  num
+
+   Maximum protection layer to use (**0**=none; **1**=integrity; etc).
+   For example if you are using the KERBEROS_V4 authentication
+   mechanism specifying **0** will force imtest to not use any layer
+   and specifying **1** will force it to use the integrity layer.  By
+   default the maximum supported protection layer will be used.
+
+-r  realm
+
+   Specify the *realm* to use. Certain authentication mechanisms (e.g.
+   DIGEST-MD5) may require one to specify the realm.
+
+-f  file
+
+   Pipe *file* into connection after authentication.
+
+-n  num
+
+   Number of authentication attempts; default = 1.  The client will
+   attempt to do SSL/TLS session reuse and/or fast reauth (e.g.
+   DIGEST-MD5), if possible.
+
+-s
+
+   Enable SSL over chosen protocol.
+
+-q
+
+   Enable IMAP COMPRESSion (after authentication).
+
+-c
+
+   Enable challenge prompt callbacks.  This will cause the OTP
+   mechanism to ask for the the one-time password instead of the
+   secret pass-phrase (library generates the correct response).
+
+-i
+
+   Don't send an initial client response for SASL mechanisms, even if
+   the protocol supports it.
+
+-I  file
+
+   Echo the PID of the running process into *file* (This can be useful
+   with -X).
+
+-v
+
+   Verbose. Print out more information than usual.
+
+-z
+
+   Timing test.
+
+-x  file
+
+   Open the named socket for the interactive portion.
+
+-X  file
+
+   Like -x, only close all file descriptors & daemonize the process.
+
+-w passwd
+
+   Password to use (if not supplied, we will prompt).
+
+-o  option=value
+
+   Set the SASL *option* to *value*.
+
+
+Examples
+========
+
+
+See Also
+========
+
+imapd(8)
diff -pruN 3.0.13-5/doc/text/imap/rfc-support.txt 3.2.0-3/doc/text/imap/rfc-support.txt
--- 3.0.13-5/doc/text/imap/rfc-support.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/imap/rfc-support.txt	2020-05-04 04:14:00.000000000 +0000
@@ -50,6 +50,10 @@ The following is an inventory of RFCs su
 
    DEFLATE Compressed Data Format Specification version 1.3
 
+**RFC 1952**
+
+   GZIP file format specification version 4.3
+
 **RFC 2033**
 
    Local Mail Transfer Protocol
@@ -142,7 +146,8 @@ The following is an inventory of RFCs su
 
 **RFC 2617**
 
-   HTTP Authentication: Basic and Digest Access Authentication
+   HTTP Authentication: Basic and Digest Access Authentication,
+   updated by **RFC 7615**, **RFC 7616**, **RFC 7617**.
 
 **RFC 2817**
 
@@ -381,6 +386,10 @@ The following is an inventory of RFCs su
 
    Sieve Email Filtering: Body Extension
 
+**RFC 5183**
+
+   Sieve Email Filtering: Environment Extension
+
 **RFC 5228**
 
    Sieve: A Mail Filtering Language
@@ -426,6 +435,10 @@ The following is an inventory of RFCs su
 
    New in version 2.5.0.
 
+**RFC 5293**
+
+   Sieve Email Filtering: Editheader Extension
+
 **RFC 5321**
 
    Simple Mail Transfer Protocol
@@ -446,8 +459,6 @@ The following is an inventory of RFCs su
 
    Sieve Email Filtering: Reject and Extended Reject Extensions
 
-   Note: Only the "reject" action is currently implemented.
-
 **RFC 5435**
 
    Sieve Email Filtering: Extension for Notifications
@@ -456,13 +467,18 @@ The following is an inventory of RFCs su
 
    Sieve Notification Mechanism: mailto
 
+**RFC 5463**
+
+   Sieve Email Filtering: Ihave Extension
+
 **RFC 5464**
 
    The IMAP METADATA Extension
 
-**RFC 5465**
+**RFC 5490**
 
-   The IMAP NOTIFY Extension
+   The Sieve Mail-Filtering Language -- Extensions for Checking
+   Mailbox Status and Accessing Mailbox Metadata
 
 **RFC 5524**
 
@@ -520,24 +536,20 @@ The following is an inventory of RFCs su
 
    The Secure Sockets Layer (SSL) Protocol Version 3.0
 
-   Note: SSLv3 is considered insecure as it is vulnerable to
+   Note: SSLv3 is considered inscure as it is vulnerable to
      POODLE.Support for SSLv3 is being deprecated and removed.
 
 **RFC 6131**
 
    Sieve Vacation Extension: "Seconds" Parameter
 
-**RFC 5463**
-
-   Sieve Email Filtering: Ihave Extension
-
 **RFC 6154**
 
    IMAP LIST Extension for Special-Use Mailboxes
 
-   Note: The LIST and LSUB commands don't return by default the
-     special- use flags, unless "specialusealways" is turned
-     explicitly on.
+   Note: The LIST and LSUB commands return the special-use flags,
+     unless the "specialusealways" configuration variable is
+     explicitly turned off.
 
 **RFC 6321**
 
@@ -632,8 +644,33 @@ The following is an inventory of RFCs su
 **RFC 7529**
 
    Non-Gregorian Recurrence Rules in the Internet Calendaring and
-   Scheduling Core Object Specification (iCalendar) (obsoletes draft-
-   ietf-calext-rscale)
+   Scheduling Core Object Specification (iCalendar)
+
+**RFC 7540**
+
+   Hypertext Transfer Protocol Version 2 (HTTP/2)
+
+**RFC 7615**
+
+   HTTP Authentication-Info and Proxy-Authentication-Info Response
+   Header Fields
+
+**RFC 7616**
+
+   HTTP Digest Access Authentication
+
+**RFC 7617**
+
+   The 'Basic' HTTP Authentication Scheme
+
+**RFC 7694**
+
+   Hypertext Transfer Protocol (HTTP) Client-Initiated Content-
+   Encoding
+
+**RFC 7804**
+
+   Salted Challenge Response HTTP Authentication Mechanism
 
 **RFC 7808**
 
@@ -643,10 +680,19 @@ The following is an inventory of RFCs su
 
    CalDAV: Time Zones by Reference
 
+**RFC 7932**
+
+   Brotli Compressed Data Format
+
 **RFC 7953**
 
    Calendar Availability
 
+**RFC 8144**
+
+   Use of the Prefer Header Field in Web Distributed Authoring and
+   Versioning (WebDAV)
+
 
 IETF RFC Drafts
 ===============
@@ -677,29 +723,6 @@ draft-thomson-hybi-http-timeout
 
    Hypertext Transfer Protocol (HTTP) Keep-Alive Header
 
-draft-murchison-webdav-prefer
-
-   Use of the Prefer Header Field in Web Distributed Authoring and
-   Versioning (WebDAV)
-
-draft-ietf-httpauth-basicauth-update
-
-   The 'Basic' HTTP Authentication Scheme
-
-draft-ietf-httpauth-digest
-
-   HTTP Digest Access Authentication
-
-draft-ietf-httpbis-auth-info
-
-   The Hypertext Transfer Protocol (HTTP) Authentication-Info and
-   Proxy- Authentication-Info Response Header Fields
-
-draft-ietf-httpbis-cice
-
-   Hypertext Transfer Protocol (HTTP) Client-Initiated Content-
-   Encoding
-
    caldav-ctag     Calendar Collection Entity Tag (CTag) in CalDAV
    Brief Header    Microsoft 'Brief' header extension
 
@@ -707,32 +730,15 @@ draft-ietf-httpbis-cice
 RFC Wishlist
 ============
 
-**RFC 5183**
-
-   Sieve Email Filtering: Environment Extension
-
 **RFC 5235**
 
    Sieve Email Filtering: Spamtest and Virustest Extensions
 
-**RFC 5293**
-
-   Sieve Email Filtering: Editheader Extension
-
-**RFC 5429**
-
-   Sieve Email Filtering: Reject and Extended Reject Extensions
-
 **RFC 5437**
 
    Sieve Notification Mechanism: Extensible Messaging and Presence
    Protocol (XMPP)
 
-**RFC 5490**
-
-   The Sieve Mail-Filtering Language -- Extensions for Checking
-   Mailbox Status and Accessing Mailbox Metadata
-
 **RFC 5703**
 
    Sieve Email Filtering: MIME Part Tests, Iteration, Extraction,
diff -pruN 3.0.13-5/doc/text/imap/support/feedback-mailing-lists.txt 3.2.0-3/doc/text/imap/support/feedback-mailing-lists.txt
--- 3.0.13-5/doc/text/imap/support/feedback-mailing-lists.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/imap/support/feedback-mailing-lists.txt	2020-05-04 04:14:00.000000000 +0000
@@ -30,19 +30,19 @@ The list archives can be accessed as fol
 
 * **cyrus-announce**
 
-     Anonymous IMAP : Web/HTTP or Pipermail
+     Web/HTTP via Pipermail
 
 * **info-cyrus**
 
-     Anonymous IMAP : Web/HTTP or Pipermail
+     Web/HTTP via Pipermail
 
 * **cyrus-sasl**
 
-     Anonymous IMAP: Web/HTTP or Pipermail
+     Web/HTTP via Pipermail
 
 * **cyrus-devel**
 
-     Anonymous IMAP : Web/HTTP or Pipermail
+     Web/HTTP via Pipermail
 
 
 Subscribe/Unsubscribe
diff -pruN 3.0.13-5/doc/text/index.txt 3.2.0-3/doc/text/index.txt
--- 3.0.13-5/doc/text/index.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/index.txt	2020-05-04 04:14:01.000000000 +0000
@@ -5,10 +5,10 @@ What is Cyrus IMAP?
 Cyrus IMAP is an email, contacts and calendar server. Cyrus is free
 and open source.
 
-* This is the documentation for version 3.0.13 (stable) of Cyrus
-  IMAP: **stable** branch.
+* This is the documentation for version 3.2.0 of Cyrus IMAP:
+  **stable** branch.
 
-* The latest development version 3.1.8 is at
+* The latest development version 3.3.0-dev0 is at
   https://www.cyrusimap.org/dev/.
 
 
@@ -39,6 +39,8 @@ Features
 
 * Extensive authentication options, through Cyrus SASL
 
+* JMAP support
+
 * Long list of supported standards
 
 Read more in our full list of features.
@@ -74,10 +76,14 @@ Cyrus IMAP
 
     * Supported Product Series
 
+    * Development snapshots
+
     * Older Versions
 
   * Notes for Packagers
 
+    * Binary naming
+
     * Sample configuration files
 
     * Predefined configurations
@@ -90,27 +96,21 @@ Cyrus IMAP
 
     * What is IMAP?
 
-  * Coming Soon
-
   * Quick install
 
-    * 1. Install Cyrus reference packages
-
-    * 2. Use "apt-get install -f" to complete installation
+    * 1. Install Cyrus package(s)
 
-    * 3. Setup the cyrus:mail user and group
+    * 2. Setup the cyrus:mail user and group
 
-    * 4. Setting up authentication with SASL
+    * 3. Setting up authentication with SASL
 
-    * 5. Setup mail delivery from your MTA
+    * 4. Setup mail delivery from your MTA
 
-    * 6. Protocol ports
+    * 5. Protocol ports
 
-    * 7. Configuring Cyrus
+    * 6. Configuring Cyrus
 
-    * 8. Launch Cyrus
-
-    * Feature overview
+    * 7. Launch Cyrus
 
 * Overview
 
@@ -182,11 +182,11 @@ Cyrus IMAP
 
     * Troubleshooting
 
-  * Upgrading to 3.0
+  * Upgrading to 3.2
 
     * 1. Preparation
 
-    * 2. Install new 3.0 Cyrus
+    * 2. Install new 3.2 Cyrus
 
     * 3. Shut down existing Cyrus
 
@@ -196,7 +196,7 @@ Cyrus IMAP
 
     * 6. Upgrade specific items
 
-    * 7. Start new 3.0 Cyrus and verify
+    * 7. Start new 3.2 Cyrus and verify
 
     * 8. Reconstruct databases and cache
 
@@ -240,58 +240,6 @@ Cyrus IMAP
 
     * (1) User Commands
 
-  * Tools & Utilities
-
-    * arbitron
-
-    * arbitronsort.pl
-
-    * chk_cyrus
-
-    * ctl_cyrusdb
-
-    * ctl_deliver
-
-    * ctl_mboxlist
-
-    * cvt_cyrusdb
-
-    * cvt_cyrusdb_all
-
-    * cyr_dbtool
-
-    * cyr_df
-
-    * cyrdump
-
-    * cyr_expire
-
-    * cyr_virusscan
-
-    * fetchnews
-
-    * cyr_sequence
-
-    * cyr_synclog
-
-    * cyr_userseen
-
-    * masssievec
-
-    * mbexamine
-
-    * mbpath
-
-    * mkimap
-
-    * mknewsgroups
-
-    * rehash
-
-    * translatesieve
-
-    * undohash
-
   * Administrator Guide
 
     * Architecture
@@ -342,11 +290,19 @@ Cyrus IMAP
 
     * About Cyrus Works
 
-    * Testing
-
     * How it works
 
-    * Adding Rules
+  * Cyrus Internals
+
+    * Cyrus APIs
+
+    * Thoughts & Notes
+
+    * Guidance for Developers
+
+  * Unit Tests
+
+    * Unit Tests
 
 * Support/Community
 
diff -pruN 3.0.13-5/doc/text/operations.txt 3.2.0-3/doc/text/operations.txt
--- 3.0.13-5/doc/text/operations.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/operations.txt	2020-05-04 04:14:01.000000000 +0000
@@ -10,58 +10,6 @@ Operations
 
   * (1) User Commands
 
-* Tools & Utilities
-
-  * arbitron
-
-  * arbitronsort.pl
-
-  * chk_cyrus
-
-  * ctl_cyrusdb
-
-  * ctl_deliver
-
-  * ctl_mboxlist
-
-  * cvt_cyrusdb
-
-  * cvt_cyrusdb_all
-
-  * cyr_dbtool
-
-  * cyr_df
-
-  * cyrdump
-
-  * cyr_expire
-
-  * cyr_virusscan
-
-  * fetchnews
-
-  * cyr_sequence
-
-  * cyr_synclog
-
-  * cyr_userseen
-
-  * masssievec
-
-  * mbexamine
-
-  * mbpath
-
-  * mkimap
-
-  * mknewsgroups
-
-  * rehash
-
-  * translatesieve
-
-  * undohash
-
 * Administrator Guide
 
   * Architecture
@@ -79,5 +27,3 @@ Operations
   * Common Operational Questions
 
   * Common Interoperability Problems
-
-   manpages adminref sop othertasks
diff -pruN 3.0.13-5/doc/text/overview/cyrus_roadmap.txt 3.2.0-3/doc/text/overview/cyrus_roadmap.txt
--- 3.0.13-5/doc/text/overview/cyrus_roadmap.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/overview/cyrus_roadmap.txt	2020-05-04 04:14:01.000000000 +0000
@@ -19,7 +19,9 @@ High Level Roadmap
 Future
 ------
 
-* JMAP support
+* JMAP support (Contacts, calendars and emails)
+
+* Improved CalDAV and CardDAV support
 
 * Improved backup support
 
@@ -29,13 +31,11 @@ Future
 3.0.x
 -----
 
-* Better calendaring support through jmap
-
 * Cross-folder conversations
 
 * Support for fuzzy Xapian search.
 
-* CardDAV support
+* CalDAV and CardDAV support
 
 * Better backup support - initial release
 
diff -pruN 3.0.13-5/doc/text/quickstart.txt 3.2.0-3/doc/text/quickstart.txt
--- 3.0.13-5/doc/text/quickstart.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/quickstart.txt	2020-05-04 04:14:01.000000000 +0000
@@ -7,13 +7,6 @@ Quickstart Guide
   * What is IMAP?
 
 
-Coming Soon
-===========
-
-Note: The deb packages referenced below are not yet available.
-  Sorry!
-
-
 Quick install
 =============
 
@@ -22,53 +15,23 @@ in 5 minutes.
 
 The first place to start with a new installation of Cyrus IMAP is with
 your OS distribution of choice and their packaging, where available.
-If there is no Cyrus IMAP 3.0 package available yet from your distro,
-download the latest stable package : version 3.0.13.
-
-We only provide limited options for reference packages, so use a
-supported distribution whenever possible.  At this time the only
-official Cyrus packages are for Debian Jessie (with backports
-enabled).
-
-Please download both the packages (*.deb) and the signature files.
-Installation is a two step process:
-
-
-1. Install Cyrus reference packages
------------------------------------
 
-First, invoke the "dpkg -i" command with the list of all packages:
+If there is no Cyrus IMAP 3.2.0 package available yet from your
+distro, download the official source tarball from GitHub.  The
+Compiling guide will help you get it built and installed.
 
-   $ sudo dpkg -i \
-       cyrus-common_3.0.1-jessie_amd64.deb  \
-       cyrus-doc_3.0.1-jessie_all.deb  \
-       cyrus-imapd_3.0.1-jessie_amd64.deb  \
-       cyrus-pop3d_3.0.1-jessie_amd64.deb  \
-       cyrus-admin_3.0.1-jessie_all.deb  \
-       cyrus-murder_3.0.1-jessie_amd64.deb  \
-       cyrus-replication_3.0.1-jessie_amd64.deb  \
-       cyrus-nntpd_3.0.1-jessie_amd64.deb  \
-       cyrus-caldav_3.0.1-jessie_amd64.deb  \
-       cyrus-clients_3.0.1-jessie_amd64.deb  \
-       cyrus-dev_3.0.1-jessie_amd64.deb  \
-       libcyrus-imap-perl_3.0.1-jessie_amd64.deb
 
-That step will produce an error, as there will doubtless be unmet
-dependencies.  Not to worry, there's a fix for that...
+1. Install Cyrus package(s)
+---------------------------
 
+Install the Cyrus IMAP package(s), either from your distribution's
+package manager, or from a release tarball.
 
-2. Use "apt-get install -f" to complete installation
-----------------------------------------------------
+Your distribution might have split Cyrus IMAP into several packages.
+Check their documentation if you're not sure what you need.
 
-Now invoke "apt-get install -f" to pull in the dependencies and
-complete the installation:
 
-   $ sudo apt-get install -f
-
-The packaging should pull along all necessary support libraries, etc..
-
-
-3. Setup the cyrus:mail user and group
+2. Setup the cyrus:mail user and group
 --------------------------------------
 
 Now let's create a **special user account just for the Cyrus server**
@@ -115,7 +78,7 @@ the PKI files.  On Debian/Ubuntu systems
    usermod -aG ssl-cert cyrus
 
 
-4. Setting up authentication with SASL
+3. Setting up authentication with SASL
 --------------------------------------
 
 Now, let's set up **SASL**. This will allow you to connect to your
@@ -154,7 +117,7 @@ the user exists and is set up correctly:
 You should get an "0: OK "Success."" message.
 
 
-5. Setup mail delivery from your MTA
+4. Setup mail delivery from your MTA
 ------------------------------------
 
 Your Cyrus IMAP server will want to receive the emails accepted by
@@ -225,7 +188,14 @@ Note: Postfix supports a great many conf
 1. Setup your recipient maps, thus defining for which recipients
    the "virtual" destination will be used:
 
-      postconf -e "virtual_recipient_maps=hash:/etc/postfix/virtual_recipient_domains,hash:/etc/postfix/virtual_recipients"
+      postconf -e "virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains"
+      postconf -e "virtual_mailbox_maps=hash:/etc/postfix/virtual_recipients"
+
+   or, if you have enabled smmapd you can automatically track
+   mailboxes with:
+
+      postconf -e "virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains"
+      postconf -e "virtual_mailbox_maps=socketmap:unix:/run/cyrus/socket/smmap"
 
 2. Optional: Set the concurrency and recipient limits for LMTP
    delivery to the "virtual" destination:
@@ -251,7 +221,7 @@ Note: Postfix supports a great many conf
       postconf -e "virtual_transport=lmtp:unix:/run/cyrus/socket/lmtp"
 
 
-6. Protocol ports
+5. Protocol ports
 -----------------
 
 The Cyrus IMAP server provides service interfaces via either TCP/IP
@@ -277,7 +247,7 @@ Make sure that these lines are present o
 missing.
 
 
-7. Configuring Cyrus
+6. Configuring Cyrus
 --------------------
 
 (Nearly there)
@@ -371,102 +341,14 @@ For example:
    ...
 
 
-8. Launch Cyrus
+7. Launch Cyrus
 ---------------
 
-If using our packages on Debian Jessie, you will have a SystemV
-compatible init script installed, with systemd support.  Start Cyrus
-with the following command:
-
-   systemctl start cyrus-imapd
-
-Tada!  You should now have a working Cyrus IMAP server.
-
-
-Feature overview
-----------------
-
-The features (compile-time configuration options) supported in our
-reference packages are:
-
-Cyrus Server configured components
-   * event notification : yes
-
-   * gssapi             : /usr
-
-   * autocreate         : yes
-
-   * idled              : yes
-
-   * httpd              : yes
-
-   * kerberos V4        : no
-
-   * murder             : yes
-
-   * nntpd              : yes
-
-   * replication        : yes
-
-   * sieve              : yes
-
-   * calalarmd          : no
-
-   * objectstore        : no
-
-   * backup             : no
-
-External dependencies
-   * ldap              : yes
-
-   * openssl           : yes
-
-   * zlib              : yes
-
-   * pcre              : yes
-
-   * clamav            : yes
-
-   * snmp              : yes
-
-   * caringo           : no
-
-   * openio            : no
-
-   * nghttp2           : no
-
-   * brotli            : no
-
-   * xml2              : yes
-
-   * ical              : yes
-
-   * icu4c             : no
-
-   * shapelib          : no
-
-Database support
-   * mysql             : no
-
-   * postgresql        : no
-
-   * sqlite            : yes
-
-   * lmdb              : no
-
-Search engine
-   * squat             : yes
-
-   * sphinx            : no
-
-   * xapian            : yes
-
-   * xapian_flavor     : vanilla
-
-Hardware support
-   * SSE4.2            : yes
-
-Installation directories
-   * prefix            : /usr
-
-   * sysconfdir        : /etc
+If using a distribution package, you probably now have an init script
+installed, that you can invoke with your system's usual service
+control mechanism.
+
+If you built from source, you will need to write your own init script.
+The simplest one will simply start/stop the master(8) binary, with
+suitable options, as root (master will drop root privileges itself as
+soon as it possibly can).
diff -pruN 3.0.13-5/doc/text/setup.txt 3.2.0-3/doc/text/setup.txt
--- 3.0.13-5/doc/text/setup.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/setup.txt	2020-05-04 04:14:01.000000000 +0000
@@ -26,11 +26,11 @@ Setup
 
   * Troubleshooting
 
-* Upgrading to 3.0
+* Upgrading to 3.2
 
   * 1. Preparation
 
-  * 2. Install new 3.0 Cyrus
+  * 2. Install new 3.2 Cyrus
 
   * 3. Shut down existing Cyrus
 
@@ -40,7 +40,7 @@ Setup
 
   * 6. Upgrade specific items
 
-  * 7. Start new 3.0 Cyrus and verify
+  * 7. Start new 3.2 Cyrus and verify
 
   * 8. Reconstruct databases and cache
 
diff -pruN 3.0.13-5/doc/text/sitemap.txt 3.2.0-3/doc/text/sitemap.txt
--- 3.0.13-5/doc/text/sitemap.txt	2019-12-16 04:18:28.000000000 +0000
+++ 3.2.0-3/doc/text/sitemap.txt	2020-05-04 04:14:01.000000000 +0000
@@ -42,6 +42,10 @@ Sitemap
 
         * Supported Product Series
 
+          * Series 3.2
+
+            * Cyrus IMAP 3.2 Releases
+
           * Series 3.0
 
             * Cyrus IMAP 3.0 Releases
@@ -50,11 +54,29 @@ Sitemap
 
             * Cyrus IMAP 2.5 Releases
 
-          * Series 2.4
+        * Development snapshots
 
-            * Cyrus IMAP 2.4 Releases
+          * Cyrus IMAP 3.1 Tags
 
-            * Cyrus IMAP 2.4-caldav Releases
+            * Cyrus IMAP 3.1.0-dev Release Notes
+
+            * Cyrus IMAP 3.1.1 Tag Notes
+
+            * Cyrus IMAP 3.1.2 Tag Notes
+
+            * Cyrus IMAP 3.1.3 Tag Notes
+
+            * Cyrus IMAP 3.1.4 Tag Notes
+
+            * Cyrus IMAP 3.1.5 Tag Notes
+
+            * Cyrus IMAP 3.1.6 Tag Notes
+
+            * Cyrus IMAP 3.1.7 Tag Notes
+
+            * Cyrus IMAP 3.1.8 Tag Notes
+
+            * Cyrus IMAP 3.1.9 Tag Notes
 
         * Older Versions
 
@@ -62,7 +84,7 @@ Sitemap
 
             * Cyrus IMAP 1.x Release Notes
 
-          * Series 2: 2.0 - 2.3
+          * Series 2: 2.0 - 2.4
 
             * Cyrus IMAP 2.0.x Release Notes
 
@@ -72,8 +94,14 @@ Sitemap
 
             * Cyrus IMAP 2.3 Releases
 
+            * Cyrus IMAP 2.4 Releases
+
+            * Cyrus IMAP 2.4-caldav Releases
+
       * Notes for Packagers
 
+        * Binary naming
+
         * Sample configuration files
 
         * Predefined configurations
@@ -89,7 +117,7 @@ Sitemap
 
             * New default settings
 
-            * New features
+            * New or improved features
 
         * Services in "/etc/services"
 
@@ -99,19 +127,15 @@ Sitemap
 
         * What is IMAP?
 
-      * Coming Soon
-
       * Quick install
 
-        * 1. Install Cyrus reference packages
+        * 1. Install Cyrus package(s)
 
-        * 2. Use "apt-get install -f" to complete installation
+        * 2. Setup the cyrus:mail user and group
 
-        * 3. Setup the cyrus:mail user and group
+        * 3. Setting up authentication with SASL
 
-        * 4. Setting up authentication with SASL
-
-        * 5. Setup mail delivery from your MTA
+        * 4. Setup mail delivery from your MTA
 
           * Install Sendmail
 
@@ -119,13 +143,11 @@ Sitemap
 
           * Install Postfix
 
-        * 6. Protocol ports
-
-        * 7. Configuring Cyrus
+        * 5. Protocol ports
 
-        * 8. Launch Cyrus
+        * 6. Configuring Cyrus
 
-        * Feature overview
+        * 7. Launch Cyrus
 
     * Overview
 
@@ -395,7 +417,7 @@ Sitemap
 
             * Alternate database formats
 
-            * CalDAV and/or CardDAV
+            * CalDAV, CardDAV, or JMAP
 
             * Other
 
@@ -405,7 +427,7 @@ Sitemap
 
           * Optional dependencies
 
-            * CalDAV and CardDAV
+            * CalDAV, CardDAV, JMAP
 
             * Murder
 
@@ -467,7 +489,7 @@ Sitemap
 
         * Troubleshooting
 
-      * Upgrading to 3.0
+      * Upgrading to 3.2
 
         * 1. Preparation
 
@@ -481,7 +503,7 @@ Sitemap
 
           * Do What As Who?
 
-        * 2. Install new 3.0 Cyrus
+        * 2. Install new 3.2 Cyrus
 
         * 3. Shut down existing Cyrus
 
@@ -491,7 +513,7 @@ Sitemap
 
         * 6. Upgrade specific items
 
-        * 7. Start new 3.0 Cyrus and verify
+        * 7. Start new 3.2 Cyrus and verify
 
         * 8. Reconstruct databases and cache
 
@@ -555,7 +577,8 @@ Sitemap
 
             * News database (fetchnews.db)
 
-            * Search Indexes (cyrus.squat, <userid>.xapianactive)
+            * Search Indexes (cyrus.squat, <userid>.xapianactive,
+              cyrus.indexed.db)
 
             * Zoneinfo db (zoneinfo.db)
 
@@ -577,8 +600,6 @@ Sitemap
 
             * Skiplist
 
-            * lmdb
-
             * sql
 
             * quotalegacy
@@ -631,6 +652,8 @@ Sitemap
 
           * Databases on Temporary Filesystems
 
+          * Certificates
+
         * Storage Considerations
 
           * General Notes on Storage
@@ -685,7 +708,7 @@ Sitemap
 
             * See Also
 
-          * imapd.conf
+          * **imapd.conf**
 
             * DESCRIPTION
 
@@ -1023,6 +1046,8 @@ Sitemap
 
             * Options
 
+            * Notifications
+
             * Examples
 
             * History
@@ -1173,6 +1198,18 @@ Sitemap
 
           * **lmtpproxyd**
 
+            * Synopsis
+
+            * Description
+
+            * Options
+
+            * Examples
+
+            * Files
+
+            * See Also
+
           * **masssievec**
 
             * Synopsis
@@ -1221,6 +1258,8 @@ Sitemap
 
             * Options
 
+            * Selectors
+
             * Examples
 
             * Files
@@ -1317,6 +1356,18 @@ Sitemap
 
           * **pop3proxyd**
 
+            * Synopsis
+
+            * Description
+
+            * Options
+
+            * Examples
+
+            * Files
+
+            * See Also
+
           * **proxyd**
 
             * Synopsis
@@ -1325,6 +1376,10 @@ Sitemap
 
             * Options
 
+            * Examples
+
+            * Files
+
             * See Also
 
           * **ptdump**
@@ -1649,16 +1704,6 @@ Sitemap
 
           * **nntptest**
 
-            * Synopsis
-
-            * Description
-
-            * Options
-
-            * Examples
-
-            * See Also
-
           * **pop3test**
 
             * Synopsis
@@ -1711,57 +1756,15 @@ Sitemap
 
           * **synctest**
 
-      * Tools & Utilities
-
-        * arbitron
-
-        * arbitronsort.pl
-
-        * chk_cyrus
-
-        * ctl_cyrusdb
-
-        * ctl_deliver
-
-        * ctl_mboxlist
-
-        * cvt_cyrusdb
-
-        * cvt_cyrusdb_all
-
-        * cyr_dbtool
-
-        * cyr_df
-
-        * cyrdump
-
-        * cyr_expire
-
-        * cyr_virusscan
-
-        * fetchnews
-
-        * cyr_sequence
-
-        * cyr_synclog
-
-        * cyr_userseen
-
-        * masssievec
-
-        * mbexamine
-
-        * mbpath
-
-        * mkimap
+            * Synopsis
 
-        * mknewsgroups
+            * Description
 
-        * rehash
+            * Options
 
-        * translatesieve
+            * Examples
 
-        * undohash
+            * See Also
 
       * Administrator Guide
 
@@ -1913,6 +1916,12 @@ Sitemap
 
             * Apple Push Service
 
+          * Monitoring
+
+            * Setup
+
+            * Configuration options
+
           * Mailbox Distribution
 
             * Selection Modes
@@ -1954,15 +1963,11 @@ Sitemap
           * Compilation errors about kssl.h and krb5.h on Red Hat
             Linux/Fedora
 
-          * Problems detecting Berkley DB on Red Hat Linux
-
           * Help! There must be an easier way to get all this
             going...
 
           * OpenSSL Version Mismatches
 
-          * Libical v1.0.1 or v2.0
-
         * Common Feature Requests
 
           * Does the Cyrus Murder support High Availability
@@ -1982,15 +1987,11 @@ Sitemap
 
           * What annotations are available?
 
-          * Why does ctl_cyrusdb -r take so long with Berkeley DB?
-
           * Is it safe to put <configdirectory>/proc and
             <configdirectory>/lock on a tmpfs filesystem?
 
           * How to enable core dumps
 
-          * Is the "db3: x Lockers" log message harmful?
-
           * Why can I not delete a mailbox as an admin user?
 
           * When is What ... Deleted, Expired, Expunged or Purged?
@@ -2147,6 +2148,12 @@ Sitemap
 
             * Tips and Tricks
 
+          * JMAP support
+
+            * Cyrus administration
+
+            * JMAP client
+
         * System files and Databases
 
           * Namespaces: a developer view
@@ -2163,6 +2170,8 @@ Sitemap
 
             * Prerequisites
 
+            * Order of operations
+
             * Release notes
 
             * Pre-release testing
@@ -2171,7 +2180,11 @@ Sitemap
 
             * Version tagging
 
-            * Releasing
+            * Inter-version website consistency
+
+            * Uploading
+
+            * Tell the world
 
           * Releasing new builds of ancient Cyrus IMAP versions
 
@@ -2187,17 +2200,334 @@ Sitemap
 
             * Building the release
 
-            * Releasing
+            * Finishing up
 
       * Cyrus.Works
 
         * About Cyrus Works
 
-        * Testing
-
         * How it works
 
-        * Adding Rules
+      * Cyrus Internals
+
+        * Cyrus APIs
+
+          * CyrusDB API
+
+            * The interface
+
+            * Configuration
+
+            * A full example
+
+            * Tools
+
+            * How to use CyrusDB
+
+            * Reading, Writing, & Transactions
+
+            * Gotchas!
+
+            * API Reference
+
+          * cyrusdb API
+
+            * Intro
+
+            * Code Layout
+
+            * Configuration
+
+            * A full example
+
+            * About Transactions
+
+            * API Reference
+
+          * Index API
+
+            * Intro
+
+            * Opening and closing
+
+            * The Index Model
+
+          * Mailbox API
+
+            * Intro
+
+            * Opening and closing
+
+            * Locking and unlocking
+
+            * Creating, renaming and deleting
+
+            * Reading and writing records
+
+            * Delayed Actions
+
+        * Thoughts & Notes
+
+          * Notes for backup implementation
+
+            * messages
+
+            * renames
+
+            * locking
+
+            * verifying index
+
+            * mailboxes database
+
+            * reindex
+
+            * backupd
+
+            * questions
+
+            * restore
+
+            * compact
+
+            * command line locking utility
+
+            * reconstruct
+
+            * ctl_backups
+
+            * cyr_backup
+
+            * partitions
+
+            * data corruption
+
+            * installation instructions
+
+            * chatting about implementation 20/10
+
+            * todo list
+
+          * Cyrus IMAP Server: Sieve Bytecode
+
+            * Motivation
+
+            * Overall Bytecode Format
+
+            * Generation
+
+            * Evaluation
+
+            * Other things to consider
+
+          * Cyrus CalDAV Scheduling Flowchart
+
+            * caldav_put() - create/modify via HTTP PUT on a
+              resource or POST (add-member) on a calendar
+
+            * caldav_delete_sched() - remove via HTTP DELETE on a
+              resource
+
+            * caldav_post() - busytime query via HTTP POST on
+              Scheduling Outbox
+
+            * sched_pollstatus - perform a voter response update
+
+            * sched_request() - perform an organizer request /
+              attendee status update
+
+            * process_attendees() - create a suitable iTIP request
+              message for each attendee
+
+            * sched_exclude() - exclude an attendee from a
+              recurrence instance
+
+            * sched_cancel() - cancel an organizer event/task
+
+            * sched_reply() - perform an attendee reply
+
+            * trim_attendees() - remove all attendees other than the
+              one replying
+
+            * sched_vpoll_reply() - add voter responses to VPOLL
+              reply
+
+            * sched_decline() - decline a recurrence instance for an
+              attendee
+
+            * clean_component() - sanitize a component for use in an
+              iTIP message
+
+            * sched_deliver() - deliver an iTIP message to a
+              recipient
+
+            * sched_deliver_local() - deliver an iTIP message to a
+              local user
+
+            * deliver_merge_reply() - update an organizer resource
+              with an attendee reply
+
+            * deliver_merge_vpoll_reply() - update an organizer
+              resource with voter responses
+
+            * deliver_merge_request() - create/update an attendee
+              resource with an organizer request
+
+            * deliver_merge_pollstatus() - update voter responses on
+              a voter resource
+
+            * sched_deliver_remote() - deliver an iTIP message to a
+              remote user
+
+            * isched_send() - deliver an iTIP message to a remote
+              user via iSchedule (HTTP)
+
+            * imip_send() - deliver an iTIP message to a remote user
+              via iMIP (SMTP)
+
+            * sched_busytime_query() - perform a busytime query
+
+            * busytime_query_local() - perform a busytime query on a
+              local user
+
+            * busytime_query_remote() - perform a busytime query on
+              a remote user
+
+          * Enabling improved_mboxlist_sort
+
+          * Cyrus IMAP Server: Notes
+
+          * Cyrus IMAP Server: Prot Events
+
+        * Guidance for Developers
+
+          * Cyrus IMAP Server: Hacking
+
+            * Memory Allocation
+
+            * strlcpy vs strncpy vs memcpy
+
+            * map_refresh and map_free
+
+            * Network Functions
+
+            * (todo) Authorization Modules
+
+            * General Hints
+
+            * Coding Standards
+
+          * Cyrus IMAP Server: Internationalization
+
+            * introduction
+
+            * cyrus canonical form
+
+            * external interface
+
+            * the TRANSLATE macro: using the transcoding tables
+
+            * searching and compiled patterns
+
+            * generating the tables: "mkchartable"
+
+            * for the future
+
+            * references
+
+          * Cyrus IMAP Server: Locking
+
+            * Mailboxes
+
+            * Xapian
+
+            * Lock lifetime
+
+          * Cyrus IMAP Server: Mailbox File Formats
+
+            * Intro
+
+            * Message Files
+
+            * "cyrus.header"
+
+            * "cyrus.cache"
+
+            * "cyrus.index"
+
+            * Notes
+
+            * Future considerations
+
+          * Cyrus IMAP Server: Namelocks
+
+            * Intro
+
+            * Implementation
+
+            * API
+
+          * Cyrus IMAP Server: prot layer
+
+            * Events
+
+          * Cyrus IMAP Server: Replication Examples
+
+            * Introduction
+
+            * A short example of replication in action
+
+            * Tracking messages between folders
+
+          * Cyrus IMAP Server: Replication Protocol v2.4+
+
+            * DList 1.0
+
+          * Cyrus IMAP Server: Special Characters
+
+            * Current Uses
+
+            * Future Uses
+
+          * Cyrus IMAP Server: var directory structure
+
+            * Directory structure under /var/spool/imap
+
+            * Directory structure under /var/imap
+
+      * Unit Tests
+
+        * Unit Tests
+
+          * Table of Contents
+
+          * 1. Introduction
+
+          * 2. What Is A Unit Test?
+
+          * 3. Running The Tests
+
+            * 3.1. Setting Up The Machine
+
+            * 3.2 Configure Script
+
+            * 3.3 Make
+
+            * 3.4 Using Valgrind
+
+            * 3.5 The Tests Are Failing
+
+          * 3.6 Debugging A Test
+
+          * 4. Adding Your Own Tests
+
+          * 4.1 Where To Put Your Tests
+
+          * 4.1 Adding A New Suite
+
+          * 4.2 Adding A Test To A Suite
+
+          * 4.3 Suite Setup And Teardown
 
     * Support/Community
 
diff -pruN 3.0.13-5/docsrc/assets/cyrus-build-devpkg.rst 3.2.0-3/docsrc/assets/cyrus-build-devpkg.rst
--- 3.0.13-5/docsrc/assets/cyrus-build-devpkg.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/assets/cyrus-build-devpkg.rst	2020-04-24 02:03:00.000000000 +0000
@@ -7,7 +7,7 @@ automated test facility.
     sudo apt-get install -y autoconf automake autotools-dev bash-completion bison build-essential comerr-dev \
         debhelper flex g++ git gperf groff heimdal-dev libbsd-resource-perl libclone-perl libconfig-inifiles-perl \
         libcunit1-dev libdatetime-perl libbsd-dev libdb-dev libdigest-sha-perl libencode-imaputf7-perl \ libfile-chdir-perl libglib2.0-dev libical-dev libio-socket-inet6-perl \
-        libio-stringy-perl libjansson-dev libldap2-dev libmysqlclient-dev \
+        libio-stringy-perl libldap2-dev libmysqlclient-dev \
         libnet-server-perl libnews-nntpclient-perl libpam0g-dev libpcre3-dev libsasl2-dev \
         libsnmp-dev libsqlite3-dev libssl-dev libtest-unit-perl libtool libunix-syslog-perl liburi-perl \
         libxapian-dev libxml-generator-perl libxml-xpath-perl libxml2-dev libwrap0-dev libzephyr-dev lsb-base \
diff -pruN 3.0.13-5/docsrc/assets/man-imapdproxyd.rst 3.2.0-3/docsrc/assets/man-imapdproxyd.rst
--- 3.0.13-5/docsrc/assets/man-imapdproxyd.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/assets/man-imapdproxyd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,110 @@
+
+
+.. author: Nic Bernstein (Onlight)
+
+Synopsis
+========
+
+.. parsed-literal::
+
+    **imapd** [ **-C** *config-file* ] [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ]
+        [ **-s** ] [ **-N** ] [ **-p** *ssf* ]
+
+Description
+===========
+
+**imapd** is an IMAP4rev1 server.  It accepts commands on its standard
+input and responds on its standard output.  It MUST be invoked by
+:cyrusman:`master(8)` with those descriptors attached to a remote client
+connection.
+
+**imapd** |default-conf-text|
+
+If the file ``msg/shutdown`` is created under the directory specified in
+the ``configdirectory`` configuration option, then **imapd** will shut
+down the connection, sending the first line contained in the file to the
+client as the reason.  New connections are denied.
+
+If the file ``msg/motd`` is created under the directory specified in the
+``configdirectory`` configuration option, then **imapd** will send the
+first line contained in the file to clients upon connect as an ALERT
+message which IMAP-compliant clients are required to display.
+
+This option serves to annoy users mostly.  Unfortunately clients tend to
+connect far more frequently than is apparent, generating a separate
+server ALERT for each connection.  Many clients do not display these
+properly, if they do anything with them at all.
+
+If the directory ``log``\/*user* exists under the directory specified in
+the ``configdirectory`` configuration option, then **imapd** will create
+protocol telemetry logs for sessions authenticating as *user*.
+
+The telemetry logs will be stored in the ``log``/\ *user* directory with
+a filename of the **imapd** process-id.
+
+Options
+=======
+
+.. program:: imapd
+
+.. option:: -C config-file
+
+    |cli-dash-c-text|
+
+.. option:: -U  uses
+
+    The maximum number of times that the process should be used for new
+    connections before shutting down.  The default is 250.
+
+.. option:: -T  timeout
+
+    The number of seconds that the process will wait for a new
+    connection before shutting down.  Note that a value of 0 (zero)
+    will disable the timeout.  The default is 60.
+
+.. option:: -D
+
+    Run external debugger specified in debug_command.
+
+.. option:: -s
+
+    Serve IMAP over SSL (imaps).  All data to and from **imapd** is
+    encrypted using the Secure Sockets Layer.
+
+.. option:: -N
+
+    Bypass password checking.  (Not recommended unless you know what
+    you're doing.)
+
+.. option:: -p  ssf
+
+    Tell **imapd** that an external layer exists.  An *SSF* (security
+    strength factor) of 1 means an integrity protection layer exists.
+    Any higher SSF implies some form of privacy protection.
+
+Examples
+========
+
+**imapd** is commonly included in the SERVICES section of
+:cyrusman:`cyrus.conf(5)` like so:
+
+.. parsed-literal::
+    SERVICES {
+        **imap        cmd="imapd -U 30" listen="imap" prefork=0**
+        **imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100**
+        lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+        sieve       cmd="timsieved" listen="sieve" prefork=0
+        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+    }
+
+Files
+=====
+
+/etc/imapd.conf
+
+See Also
+========
+
+:cyrusman:`imapd.conf(5)`,
+:cyrusman:`master(8)`
diff -pruN 3.0.13-5/docsrc/assets/man-imtest.rst 3.2.0-3/docsrc/assets/man-imtest.rst
--- 3.0.13-5/docsrc/assets/man-imtest.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/assets/man-imtest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,143 @@
+Synopsis
+========
+
+.. parsed-literal::
+
+    **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
+        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
+        [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
+        [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
+        [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
+
+Description
+===========
+
+**imtest** is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
+
+Options
+=======
+
+.. program:: imtest
+
+.. option:: -t  keyfile
+
+    Enable TLS.  *keyfile* contains the TLS public and private keys.
+    Specify **""** to negotiate a TLS encryption layer but not use TLS
+    authentication.
+
+.. option:: -p  port
+
+    Port to connect to. If left off this defaults to **imap** as defined
+    in ``/etc/services``.
+
+.. option:: -m  mechanism
+
+    Force **imtest** to use *mechanism* for authentication. If not
+    specified the strongest authentication mechanism supported by the
+    server is chosen.  Specify *login* to use the LOGIN command instead
+    of AUTHENTICATE.
+
+.. option:: -a  userid
+
+    Userid to use for authentication; defaults to the current user.
+    This is the userid whose password or credentials will be presented to
+    the server for verification.
+
+.. option:: -u  userid
+
+    Userid to use for authorization; defaults to the current user.
+    This is the userid whose identity will be assumed after
+    authentication.
+
+    .. Note::
+        This is only used with SASL mechanisms that allow proxying
+        (e.g. PLAIN, DIGEST-MD5).
+
+.. option:: -k  num
+
+    Minimum protection layer required.
+
+.. option:: -l  num
+
+    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
+    etc).  For example if you are using the KERBEROS_V4 authentication
+    mechanism specifying **0** will force imtest to not use any layer
+    and specifying **1** will force it to use the integrity layer.  By
+    default the maximum supported protection layer will be used.
+
+.. option:: -r  realm
+
+    Specify the *realm* to use. Certain authentication mechanisms
+    (e.g. DIGEST-MD5) may require one to specify the realm.
+
+.. option:: -f  file
+
+    Pipe *file* into connection after authentication.
+
+.. option:: -n  num
+
+    Number of authentication attempts; default = 1.  The client will
+    attempt to do SSL/TLS session reuse and/or fast reauth
+    (e.g. DIGEST-MD5), if possible.
+
+.. option:: -s
+
+    Enable SSL over chosen protocol.
+
+.. option:: -q
+
+    Enable IMAP COMPRESSion (after authentication).
+
+.. option:: -c
+
+    Enable challenge prompt callbacks.  This will cause the OTP mechanism
+    to ask for the the one-time password instead of the secret pass-phrase
+    (library generates the correct response).
+
+.. option:: -i
+
+    Don't send an initial client response for SASL mechanisms, even if
+    the protocol supports it.
+
+.. option:: -I  file
+
+    Echo the PID of the running process into *file* (This can be useful
+    with -X).
+
+.. option:: -v
+
+    Verbose. Print out more information than usual.
+
+.. option:: -z
+
+    Timing test.
+
+.. option:: -x  file
+
+    Open the named socket for the interactive portion.
+
+.. option:: -X  file
+
+    Like -x, only close all file descriptors & daemonize the process.
+
+.. option:: -w passwd
+
+    Password to use (if not supplied, we will prompt).
+
+.. option:: -o  option=value
+
+    Set the SASL *option* to *value*.
+
+Examples
+========
+
+See Also
+========
+
+:cyrusman:`imapd(8)`
diff -pruN 3.0.13-5/docsrc/assets/man-lmtpd.rst 3.2.0-3/docsrc/assets/man-lmtpd.rst
--- 3.0.13-5/docsrc/assets/man-lmtpd.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/assets/man-lmtpd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,73 @@
+Synopsis
+========
+
+.. parsed-literal::
+
+    **lmtpd** [ **-C** *config-file* ]  [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ] [ **-a** ]
+
+Description
+===========
+
+**lmtpd** is an LMTP server used to deliver mail to the IMAP mailstore.
+It accepts commands on its standard input and responds on its standard
+output. It MUST be invoked by :cyrusman:`master(8)` with those
+descriptors attached to a remote client connection.
+
+**lmtpd** |default-conf-text|
+
+Options
+=======
+
+.. program:: lmtpd
+
+.. option:: -C config-file
+
+    |cli-dash-c-text|
+
+.. option:: -U  uses
+
+    The maximum number of times that the process should be used for new
+    connections before shutting down.  The default is 250.
+
+.. option:: -T  timeout
+
+    The number of seconds that the process will wait for a new
+    connection before shutting down.  Note that a value of 0 (zero)
+    will disable the timeout.  The default is 60.
+
+.. option:: -D
+
+    Run external debugger specified in debug_command.
+
+.. option:: -a
+
+    Preauthorize connections initiated on an internet socket, instead
+    of requiring LMTP AUTH.  This should only be used for connections
+    coming from trusted hosts.
+
+Examples
+========
+
+**lmtpd** is commonly included in the SERVICES section of
+:cyrusman:`cyrus.conf(5)` like so:
+
+.. parsed-literal::
+    SERVICES {
+        imap        cmd="imapd -U 30" listen="imap" prefork=0
+        imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+        **lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20**
+        sieve       cmd="timsieved" listen="sieve" prefork=0
+        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+    }
+
+Files
+=====
+
+/etc/imapd.conf
+
+See Also
+========
+
+:cyrusman:`imapd.conf(5)`,
+:cyrusman:`master(8)`
diff -pruN 3.0.13-5/docsrc/assets/setup-postfix.rst 3.2.0-3/docsrc/assets/setup-postfix.rst
--- 3.0.13-5/docsrc/assets/setup-postfix.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/assets/setup-postfix.rst	2020-04-24 02:03:00.000000000 +0000
@@ -23,7 +23,13 @@ server and engineer delivery via LMTP.
 1.  Setup your recipient maps, thus defining for which recipients the
     ``virtual`` destination will be used::
 
-        postconf -e "virtual_recipient_maps=hash:/etc/postfix/virtual_recipient_domains,hash:/etc/postfix/virtual_recipients"
+        postconf -e "virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains"
+        postconf -e "virtual_mailbox_maps=hash:/etc/postfix/virtual_recipients"
+
+    or, if you have enabled smmapd you can automatically track mailboxes with::
+
+        postconf -e "virtual_mailbox_domains=hash:/etc/postfix/virtual_recipient_domains"
+        postconf -e "virtual_mailbox_maps=socketmap:unix:/run/cyrus/socket/smmap"
 
 2.  Optional: Set the concurrency and recipient limits for LMTP delivery to the
     ``virtual`` destination::
diff -pruN 3.0.13-5/docsrc/conf.py 3.2.0-3/docsrc/conf.py
--- 3.0.13-5/docsrc/conf.py	2019-12-16 04:12:45.000000000 +0000
+++ 3.2.0-3/docsrc/conf.py	2020-05-04 04:02:14.000000000 +0000
@@ -81,7 +81,7 @@ master_doc = 'index'
 
 # General information about the project.
 project = u'Cyrus IMAP'
-copyright = u'1993-2017, The Cyrus Team'
+copyright = u'1993-2018, The Cyrus Team'
 
 
 # The version info for the project you're documenting, acts as replacement for
@@ -97,9 +97,9 @@ copyright = u'1993-2017, The Cyrus Team'
 # May need to also update toplevel index.rst to point to other versions.
 #
 # The short X.Y version.
-version = '3.0.13'
+version = '3.2.0'
 # The full version, including alpha/beta/rc tags.
-release = '3.0.13 (stable)'
+release = '3.2.0'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
@@ -151,7 +151,7 @@ html_context = {
   "display_github": True, # Add 'Edit on Github' link instead of 'View page source'
   "github_user": "cyrusimap",
   "github_repo": "cyrus-imapd",
-  "github_version": "cyrus-imapd-3.0",
+  "github_version": "cyrus-imapd-3.2",
   "conf_py_path": "/docsrc/",
   "source_suffix": source_suffix,
   "githubexclude": ["imap/reference/manpages/usercommands/sieveshell",
@@ -162,7 +162,7 @@ html_context = {
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-html_theme_options = { 'travis_version': 'cyrus-imapd-3.0'}
+html_theme_options = { 'travis_version': 'cyrus-imapd-3.2'}
 
 
 # Add any paths that contain custom themes here, relative to this directory.
@@ -196,7 +196,7 @@ html_static_path = ['_static']
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
+# html_last_updated_fmt = '%b %d, %Y'
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
@@ -429,11 +429,11 @@ epub_exclude_files = ['search.html']
 # When this is updated, you may also need to update the version and release
 # definitions listed above to stay up to date.
 rst_prolog = """
-.. |imap_last_stable_version| replace:: 2.5.15
-.. |imap_last_stable_branch| replace:: `cyrus-imapd-2.5`
-.. |imap_current_stable_version| replace:: 3.0.13
-.. |imap_current_stable_branch| replace:: `cyrus-imapd-3.0`
-.. |imap_latest_development_version| replace:: 3.1.8
+.. |imap_last_stable_version| replace:: 3.0.13
+.. |imap_last_stable_branch| replace:: `cyrus-imapd-3.0`
+.. |imap_current_stable_version| replace:: 3.2.0
+.. |imap_current_stable_branch| replace:: `cyrus-imapd-3.2`
+.. |imap_latest_development_version| replace:: 3.3.0-dev0
 .. |imap_latest_development_branch| replace:: master
 .. |imap_tikanga_stock_version| replace:: 2.3.7
 .. |imap_santiago_stock_version| replace:: 2.3.16
@@ -446,11 +446,11 @@ rst_prolog = """
 .. |sasl_current_stable_version| replace:: 2.1.27
 .. |imap_stable_release_notes| raw:: html
 
-    <a href="3.0/x/3.0.13.html">3.0.13</a>
+    <a href="3.2/x/3.2.0.html">3.2.0</a>
 
 .. |imap_development_release_notes| raw:: html
 
-    <a href="3.1/x/3.1.8.html">3.1.8</a>
+    <a href="3.1/x/3.1.9.html">3.1.9</a>
 
 """
 
@@ -495,6 +495,12 @@ rst_prolog += """
 .. |v3-new-command| replace:: This command was introduced in version 3.0.
 """
 
+# New feature version disclaimer for master branch
+rst_prolog += """
+.. |master-new-feature| replace:: This feature is only available on the master branch.
+.. |master-new-command| replace:: This command is only available on the master branch.
+"""
+
 rst_prolog += """
 .. |AMS| replace:: :abbr:`AMS (Andrew Mail System)`
 .. |CMU| replace:: :abbr:`CMU (Carnegie Mellon University)`
@@ -515,10 +521,21 @@ rst_prolog += """
 #"""
 
 # Use this as :task:`18`
+# XXX would be really nice to be able to have 'github-tarball' and 'github-sig'
+# XXX handlers here, except that these urls require expanding the version string
+# XXX twice, and the sphinx extlinks thingy currently only supports a single %s
 extlinks = {
         'issue':('https://github.com/cyrusimap/cyrus-imapd/issues/%s', 'Issue #'),
         'cyrus-2.5':('https://www.cyrusimap.org/2.5%s',None),
         'cyrus-3.0':('https://www.cyrusimap.org/3.0%s',None),
+        'cyrus-3.2':('https://www.cyrusimap.org/3.2%s',None),
         'cyrus-dev':('https://www.cyrusimap.org/dev%s',None),
-        'cyrus-stable': ('https://www.cyrusimap.org/3.0%s',None),
+        'cyrus-stable': ('https://www.cyrusimap.org%s',None),
+        'github-release':
+            ('https://github.com/cyrusimap/cyrus-imapd/releases/tag/cyrus-imapd-%s',
+             'cyrus-imapd-'),
     }
+
+# Change this to whatever your output root is
+# If you're in a local build environment, this might be file://cyrus-imapd/doc/build/imap/admin/$num/$topic/$topic.html
+#cyrus_man_url_regex = "http://www.cyrusimap.org/imap/admin/$num/$topic.html";
diff -pruN 3.0.13-5/docsrc/developers.rst 3.2.0-3/docsrc/developers.rst
--- 3.0.13-5/docsrc/developers.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/developers.rst	2020-04-24 02:03:00.000000000 +0000
@@ -5,9 +5,33 @@ Developers
 
 .. toctree::
     :maxdepth: 2
-    :glob:
 
     contribute
     Contribute docs <imap/developer/documentation>
     Contribute code and tests <imap/developer>
     Cyrus.Works <imap/developer/cyrusworks>
+
+Cyrus Internals
+===============
+
+These documents are intended for persons interested in contributing to
+the Cyrus IMAP development effort, or for those interested in lower-
+level details about how Cyrus is implemented.
+
+.. toctree::
+    :maxdepth: 2
+    :glob:
+
+    Cyrus APIs <imap/developer/API>
+    Thoughts & Notes <imap/developer/thoughts>
+    Guidance for Developers <imap/developer/guidance>
+
+This :download:`diagram <imap/developer/images/master-state-machine.svg>` shows
+the Master State Machine.
+
+Unit Tests
+==========
+
+.. toctree::
+
+    imap/developer/unit-tests
diff -pruN 3.0.13-5/docsrc/download.rst 3.2.0-3/docsrc/download.rst
--- 3.0.13-5/docsrc/download.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/download.rst	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-========
+--------
 Download
-========
+--------
 
 
 .. toctree::
Binary files 3.0.13-5/docsrc/exts/sphinxlocal/builders/gitstamp.pyc and 3.2.0-3/docsrc/exts/sphinxlocal/builders/gitstamp.pyc differ
Binary files 3.0.13-5/docsrc/exts/sphinxlocal/builders/manpage.pyc and 3.2.0-3/docsrc/exts/sphinxlocal/builders/manpage.pyc differ
Binary files 3.0.13-5/docsrc/exts/sphinxlocal/roles/cyrusman.pyc and 3.2.0-3/docsrc/exts/sphinxlocal/roles/cyrusman.pyc differ
Binary files 3.0.13-5/docsrc/exts/sphinxlocal/sitemap.pyc and 3.2.0-3/docsrc/exts/sphinxlocal/sitemap.pyc differ
Binary files 3.0.13-5/docsrc/exts/sphinxlocal/writers/manpage.pyc and 3.2.0-3/docsrc/exts/sphinxlocal/writers/manpage.pyc differ
diff -pruN 3.0.13-5/docsrc/exts/themes/cyrus/buildstatus.html 3.2.0-3/docsrc/exts/themes/cyrus/buildstatus.html
--- 3.0.13-5/docsrc/exts/themes/cyrus/buildstatus.html	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/exts/themes/cyrus/buildstatus.html	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 {%- if builder != 'singlehtml' %}
 <div class="buildstatus">
-    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd/branches" target="_blank">{{ theme_travis_version }}: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch={{ theme_travis_version }}"></a>
+    <a href="https://travis-ci.org/cyrusimap/cyrus-imapd" target="_blank">{{ theme_travis_version }}: <img src="https://travis-ci.org/cyrusimap/cyrus-imapd.svg?branch={{ theme_travis_version }}"></a>
 </div>
 {%- endif %}
diff -pruN 3.0.13-5/docsrc/imap/concepts/deployment/databases.rst 3.2.0-3/docsrc/imap/concepts/deployment/databases.rst
--- 3.0.13-5/docsrc/imap/concepts/deployment/databases.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/concepts/deployment/databases.rst	2020-04-24 02:03:00.000000000 +0000
@@ -46,7 +46,7 @@ One per user:
 * `Mailbox Keys (<userid>.mboxkey)`_
 * `Seen State (<userid>.seen)`_
 * `Subscriptions (<userid>.sub)`_
-* `Search Indexes (cyrus.squat, <userid>.xapianactive)`_
+* `Search Indexes (cyrus.squat, <userid>.xapianactive, cyrus.indexed.db)`_
 
 .. _imap-concepts-deployment-db-mailboxes:
 
@@ -59,7 +59,7 @@ This database contains the master list o
 
     Data: <Type Number>SP<Partition>SP<ACL (space-separated userid/rights pairs)>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `sql`_.
 
 .. _imap-concepts-deployment-db-annotations:
 
@@ -72,7 +72,7 @@ This database contains mailbox and serve
 
     Data: <Value Size (4 bytes)><Value>\0<Content-Type>\0<Timestamp (4 bytes)>
 
-File type can be: `twoskip`_  (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_  (default) or `skiplist`_.
 
 .. _imap-concepts-deployment-db-quotas:
 
@@ -85,7 +85,7 @@ This database contains the master list o
 
     Data: <Usage (in bytes)>SP<Limit (in Kbytes)>
 
-File type can be: `quotalegacy`_ (default), `flat`_, `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `quotalegacy`_ (default), `flat`_, `skiplist`_, `sql`_, or `twoskip`_.
 
 
 **Legacy Quotas**
@@ -110,7 +110,7 @@ This database is used for duplicate deli
 
     Data: <Timestamp (4 bytes)><Message UID (4 bytes)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-tls:
@@ -124,7 +124,7 @@ This database caches SSL/TLS sessions so
 
     Data: <Timestamp (4 bytes)><Session Data (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-pts:
@@ -138,7 +138,7 @@ This database caches authentication stat
 
     Data: <Auth State (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default) or `skiplist`_.
 
 
 .. _imap-concepts-deployment-db-status:
@@ -152,7 +152,7 @@ This database caches IMAP STATUS informa
 
     Data: <Version>SP<Bitmask of Items>SP<Mtime of Index>SP<Inode of Index>SP<Size of Index>SP<- of Messages>SP<- of Recent Messages>SP<Next UID>SP<UID Validity>SP<- of Unseen Messages>SP<Highest Mod Sequence>
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, or `sql`_.
 
 
 .. _imap-concepts-deployment-db-userdeny:
@@ -160,13 +160,13 @@ File type can be: `twoskip`_ (default),
 User Access (user_deny.db)
 --------------------------
 
-This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of wildmat patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in cyrus.conf(5). The format of each record is as follows::
+This database contains a list of users that are denied access to Cyrus services. The database is indexed by userid and each data record contains the database version number (currently 2), a list of `wildmat <https://tools.ietf.org/html/rfc3977#section-4>`_ patterns specifying Cyrus services to be denied, and a text message to be displayed to the user upon denial. The service names to be matched are those as used in :cyrusman:`cyrus.conf(5)`. The format of each record is as follows::
 
     Key: <Userid>
 
     Data: <Version>TAB<Deny List (comma-separated wildmat patterns)>TAB<Deny Message>
 
-File type can be: `flat`_ (default), `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `flat`_ (default), `skiplist`_, `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-backups:
 
@@ -176,7 +176,7 @@ Backups (backups.db)
 This database maps userids to the location of their backup files.  It only exists
 on Cyrus Backup servers (compiled with the `--enable-backup` configure option).
 
-File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `skiplist`_, `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-conversations:
 
@@ -188,12 +188,12 @@ in the past three months, mapping to the
 ID has been seen, and the timestamp when it was last seen.
 
 It also has a records for each conversation ID with details about which folders
-have that converations ID in them, and counts of messages and flags.
+have that conversations ID in them, and counts of messages and flags.
 
 Finally there are records for each folder with the counts of conversations in
 that folder.
 
-File type can be: `skiplist`_ (default), `sql`_, `twoskip`_, or `lmdb`_.
+File type can be: `skiplist`_ (default), `sql`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-counters:
 
@@ -213,13 +213,19 @@ File format not selectable.
 
 .. _imap-concepts-deployment-db-search:
 
-Search Indexes (cyrus.squat, <userid>.xapianactive)
----------------------------------------------------
+Search Indexes (cyrus.squat, <userid>.xapianactive, cyrus.indexed.db)
+---------------------------------------------------------------------
 
-This is either cyrus.squat in each folder, or if you're using xapian a single
-<userid>.xapianactive file listing active databases by tier name and number.
+This is either cyrus.squat in each folder, or if you're using Xapian a single
+<userid>.xapianactive file listing active databases with tier name and number.
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+cyrus.indexed.db is used by the Xapian search engine.  Its file type
+can be: `twoskip`_ (default), `flat`_, `skiplist`_, or ``zeroskip`` and is
+determined by `search_indexed_db` in :cyrusman:`imapd.conf(5)`.
+
+The xapianactive file contains a space separated list of tiers and databases within
+the tier.  The first element is the active tier/database, to which new entries are
+added by `squatter -R`.
 
 .. _imap-concepts-deployment-db-zoneinfo:
 
@@ -237,7 +243,7 @@ alias).  The format of each record is as
 
     Data: <Version>SP<Record Type>SP<Timestamp>SP<Data Strings (TAB-separated)>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, or `skiplist`_.
 
 .. _imap-concepts-deployment-db-seen:
 
@@ -250,7 +256,7 @@ This database is a per-user database and
 
     Data: <Version>SP<Last Read Time>SP<Last Read UID>SP<Last Change Time>SP<List of Read UIDs>
 
-File type can be: `twoskip`_ (default), `flat`_, `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default), `flat`_, or `skiplist`_.
 
 .. _imap-concepts-deployment-db-sub:
 
@@ -263,7 +269,7 @@ This database is a per-user database and
 
     Data: None
 
-File type can be: `flat`_ (default), `skiplist`_, `twoskip`_, or `lmdb`_.
+File type can be: `flat`_ (default), `skiplist`_, or `twoskip`_.
 
 .. _imap-concepts-deployment-db-xapianactive:
 
@@ -284,7 +290,7 @@ This database is a per-user database and
 
     Data: <Version (2 bytes)><Access Key (multi-byte)>
 
-File type can be: `twoskip`_ (default), `skiplist`_, or `lmdb`_.
+File type can be: `twoskip`_ (default) or `skiplist`_.
 
 .. _imap-concepts-deployment-db-userdav:
 
@@ -380,15 +386,6 @@ An implementation of the `Skip List <htt
 data structure. Deprecated in favour of `Twoskip`_ as it is not robust in
 the face of disk failure.
 
-lmdb
-----
-
-`Lightning Memory-Mapped Database (lmdb) <http://symas.com/mdb>`_ is a
-high-performance transactional key-value store.
-
-Fast while in memory, but slow when the database is loaded. Best for databases
-that are held open for a long time: `Mailbox List (mailboxes.db)`_
-
 sql
 ---
 
diff -pruN 3.0.13-5/docsrc/imap/concepts/deployment/performance_recommendations.rst 3.2.0-3/docsrc/imap/concepts/deployment/performance_recommendations.rst
--- 3.0.13-5/docsrc/imap/concepts/deployment/performance_recommendations.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/concepts/deployment/performance_recommendations.rst	2020-04-24 02:03:00.000000000 +0000
@@ -19,3 +19,6 @@ In-memory filesystems are faster then di
     Cyrus IMAP requires the parent directories to exist, and be writeable by the POSIX user account Cyrus IMAP runs under, prior to starting the ``master`` process.
 
 
+Certificates
+------------
+Cyrus IMAP can be configured to provide as server two kind of certificates: EC and RSA.  The EC certificates are only sent to the client, if the client supports them.  EC certificates have the advantage of requiring less computational resources compared to RSA, while offering comparatively the same security.
diff -pruN 3.0.13-5/docsrc/imap/concepts/deployment/supported-platforms.rst 3.2.0-3/docsrc/imap/concepts/deployment/supported-platforms.rst
--- 3.0.13-5/docsrc/imap/concepts/deployment/supported-platforms.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/concepts/deployment/supported-platforms.rst	2020-04-24 02:03:00.000000000 +0000
@@ -72,22 +72,6 @@ Optional Software Components
 
 When including the following software components during the build process, and providing the options listed here, additional optional functionality can be implemented;
 
-**Berkeley DB** (Development headers)
-
-To enable using Berkely DB as a database backend, include the Berkeley DB development headers and make sure to configure Cyrus IMAP with ``--with-bdb``.
-
-Berkeley DB Versions and Conversion
-
-The Cyrus IMAP ``configure`` process attempts to automatically detect and use the latest Berkeley DB technology available on the system. This may, however, not be the same version on your production systems. Since database conversions between versions of the Berkeley DB technology are particularly difficult and therefor NOT considered fully supported, we recommend you do NOT use Berkeley DB.
-
-Should the Berkeley DB development headers be installed in a non-standard location, or should you need a specific version when multiple versions are available on the system, please consider using any of the following options;
-
-::
-
-    --with-bdb=DIR            use Berkeley DB (in DIR) [yes]
-    --with-bdb-libdir=DIR     Berkeley DB lib files are in DIR
-    --with-bdb-incdir=DIR     Berkeley DB include files are in DIR</screen>
-
 **MySQL** (Development headers)
 
 To enable using MySQL as a database server backend, include the MySQL development headers and make sure to configure Cyrus IMAP with ``--with-mysql``.
diff -pruN 3.0.13-5/docsrc/imap/concepts/features/access-control.rst 3.2.0-3/docsrc/imap/concepts/features/access-control.rst
--- 3.0.13-5/docsrc/imap/concepts/features/access-control.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/concepts/features/access-control.rst	2020-04-24 02:03:00.000000000 +0000
@@ -17,8 +17,4 @@ to information contained within the Cyru
     *   :ref:`imap-admin-access-control-defaults`
     *   :ref:`imap-admin-access-control-identifiers`
 
-.. toctree::
-    :hidden:
-    :glob:
-
 Back to :ref:`imap-features`
diff -pruN 3.0.13-5/docsrc/imap/concepts/features.rst 3.2.0-3/docsrc/imap/concepts/features.rst
--- 3.0.13-5/docsrc/imap/concepts/features.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/concepts/features.rst	2020-04-24 02:03:00.000000000 +0000
@@ -25,6 +25,9 @@ concurrent read/write connections to the
 The server supports access control lists on mailboxes and storage
 quotas on mailbox hierarchies.
 
+Cyrus IMAP provisionally supports the emerging JMAP protocol standards,
+when built for such.
+
 The following documents show the full power of each feature that is
 included with Cyrus IMAP.
 
diff -pruN 3.0.13-5/docsrc/imap/developer/ancient-releasing.rst 3.2.0-3/docsrc/imap/developer/ancient-releasing.rst
--- 3.0.13-5/docsrc/imap/developer/ancient-releasing.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/ancient-releasing.rst	2020-04-08 00:07:13.000000000 +0000
@@ -55,6 +55,11 @@ Pre-release testing
    vi.   Compile it: ``make`` -- it should build correctly.
    vii.  Run the unit tests if there are any: ``make check`` -- they should pass.
 
+.. Note::
+    We don't bother to run ``make distcheck`` on the old branches, because it
+    almost certainly won't work.  We also don't bother to run Cassandane, for
+    much the same reason.  If it builds, that's about as much as we can do.
+
 Cross-pollination of release notes
 ==================================
 
@@ -63,7 +68,7 @@ release notes for these versions appear
 be added to current branches as well.
 
 1. Change to the current stable branch (at time of writing, this is ``cyrus-imapd-3.0``).
-2. Create a new release notes at the appropriate location under
+2. Create a new release notes document at the appropriate location under
    ``docsrc/imap/download/release-notes/``.
 3. Add the release notes you wrote earlier, this time using RST format rather
    than simple HTML.
@@ -96,19 +101,7 @@ Building the release
 11. Push the tag upstream: ``git push ci cyrus-imapd-<version>`` (assuming your
     remote is named "ci").
 
-Releasing
-=========
+Finishing up
+============
 
-1. Upload the tarball and signature to www: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/``
-2. Upload them to ftp too: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/``
-3. SSH into both www and ftp, and move older releases to the old versions
-   directory.  You want only the two most recent tarball+sig pairs for each
-   major series.
-4. While SSH'd into www, build the legacy documentation for this release:
-
-   i.  Copy the release tarball to /var/tmp
-   ii. Run the script to publish the tarball documentation to the web:
-       ``/usr/local/bin/PublishCyrusDocs.pl -f /var/tmp/cyrus-imapd-<version>.tar.gz``
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+Now follow the remaining steps from :ref:`imap-developer-releasing`
diff -pruN 3.0.13-5/docsrc/imap/developer/API/cyrusdb2.rst 3.2.0-3/docsrc/imap/developer/API/cyrusdb2.rst
--- 3.0.13-5/docsrc/imap/developer/API/cyrusdb2.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/API/cyrusdb2.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,317 @@
+.. _imap-developer-api-cyrusdb2:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+cyrusdb API
+===========
+
+Intro
+-----
+
+The ``cyrusdb`` API is a common interface to a key-value store, used
+throughout the Cyrus code. It allows a choice of different backends for
+different access patterns, while ensuring a consistent interface.
+
+This document will describe the interface, and how to use the cyrusdb
+interface from within parts of Cyrus code, as well as how to implement
+your own backend
+
+If you pass incorrect values to these APIs, you will get an assertion
+failure in most cases. That's generally considered safer than silently
+breaking things. Exceptions are noted below.
+
+Code Layout
+-----------
+
+The implementation of each interface is in ``lib/cyrusdb_NAME.c``, for
+example lib/cyrusdb\_flat.c. General functions are in ``lib/cyrusdb.c``
+and the interface in ``lib/cyrusdb.h``.
+
+Configuration
+-------------
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: ``annotation_db: skiplist``. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable ``config_annotation_db`` gets set to the configured
+backend name:
+
+::
+
+        config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: ``config_annotation_db`` is a string
+describing the *backend* used by the database, not, say, its location on
+disk.)
+
+Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+``lib/cyrusdb.c``
+
+``lib/cyrus.c`` provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+A full example
+--------------
+
+::
+
+      struct db *db = NULL;
+      struct txn *tid = NULL;
+      const char *filename = NULL;
+      int flags = CYRUSDB_CREATE;
+
+      cyrus_init(alt_config, "toolname", 0);
+
+      filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+      r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+      r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+      r = cyrusdb_commit(db, tid);
+
+      r = cyrusdb_close(db);
+
+      cyrus_done();
+
+Note that you always open a database first, and close it at the end. You
+must always call cyrus\_init() and cyrus\_done() to properly initialize
+and clean up the ``cyrusdb`` environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+About Transactions
+------------------
+
+The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the 'tid' parameter decides which mode
+is used. There are three possible values:
+
+-  NULL - non-transactional. Will create a temporary lock for the
+   duration of the current action - either a write lock for "store" or a
+   read lock for "fetch". If you call "foreach", the lock will be
+   dropped between each record fetched
+-  Pointer to NULL - transactional, transaction not yet started. Will
+   always take a write lock on the database, and update the pointer to
+   point to the new transaction.
+-  Pointer to a valid transaction. Will keep using this transaction
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions. There is one exception in the skiplist backend: *If you
+pass NULL to a fetch or foreach while the database is in a transaction,
+it will silently do the read in the current transaction rather than
+returning an error*
+
+API Reference
+-------------
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+cyrusdb\_init(void)
+~~~~~~~~~~~~~~~~~~~
+
+Is called once per process. Don't call this yourself, use
+``cyrus_init()``. No other calls will be made until this is called.
+
+cyrusdb\_done(void)
+~~~~~~~~~~~~~~~~~~~
+
+The opposite of ``cyrusdb_init()`` - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use ``cyrus_done()``.
+
+cyrusdb\_sync(const char \*backend)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by ``ctl_cyrusdb -c`` on a regular basis
+
+cyrusdb\_open(const char \*backend, const char \*fname, int flags, struct db \*\*retdb)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Opens the database with the specified 'file name' (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure
+
+Flags:
+
+-  CYRUSDB\_CREATE - create the database if it doesn't exist
+-  CYRUSDB\_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there is any error reading the file, or any
+   corruption detected while loading the file
+
+cyrusdb\_close(struct db \*db)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Close the named database. Will release any locks if they are still held,
+but it's bad practice to close without committing or aborting, so the
+backend should log an error
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there are any errors during close
+
+cyrusdb\_fetch(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_fetchlock(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case \*datalen will be set to zero, and \*data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if any error occurs reading from the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if there is no record that matches the key
+
+cyrusdb\_foreach(struct db \*db, const char \*prefix, size\_t prefixlen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_forone(struct db \*db, const char \*key, size\_t keylen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+``cyrusdb_foreach()`` iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.
+
+``cyrusdb_forone()`` "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.
+
+``goodp`` - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can't make any database changes, it doesn't
+break the lock, so it's faster to use goodp to filter records if you
+don't need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.
+
+``procp`` - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+-  procp\_result - whatever your callback returns
+-  CYRUSDB\_IOERROR - if any error occurs while reading
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_create(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+cyrusdb\_store(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Create a new record or replace an existing one. The only difference
+between these two is that ``cyrusdb_create`` will return an error if the
+record already exists, while ``cyrusdb_store`` will replace it
+
+If tidptr is NULL, create/store will take a write lock for the duration
+of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_EXISTS - if ``cyrusdb_create`` is called on an existing key
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_delete(struct db \*db, const char \*key, size\_t keylen, struct txn \*\*tidptr, int force)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if force is not set and the key doesn't exist
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_commit(struct db \*db, struct txn \*tid)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_abort(struct db \*db, struct txn \*tid)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_dump(struct db \*db, int detail)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+cyrusdb\_consistent(struct db \*db)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check if the DB is internally consistent. Looks pretty bogus, and isn't
+used anywhere. Don't use.
diff -pruN 3.0.13-5/docsrc/imap/developer/API/cyrusdb.rst 3.2.0-3/docsrc/imap/developer/API/cyrusdb.rst
--- 3.0.13-5/docsrc/imap/developer/API/cyrusdb.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/API/cyrusdb.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,661 @@
+.. _imap-developer-api-cyrusdb:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from Markdown.
+
+CyrusDB API
+===========
+
+The interface
+-------------
+
+    The bulk, especially the beginning, of this document is from an
+    `email <https://lists.andrew.cmu.edu/pipermail/cyrus-devel/2018-February/004217.html>`__
+    Bron sent to the
+    `cyrus-devel <https://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
+    mailing list on 27 February 2018 05:50:39GMT.
+
+The cyrusdb interface is a common API for accessing key-value
+datastores from within cyrus code. It's part of the libcyrus shared
+object (but not libcyrus_min), used by all cyrus binaries. The use of
+the cyrusdb API abstracts the details of the underlying data store,
+allowing sites to use different database types depending on their
+needs, and allowing Cyrus developers to use a common API for data
+storage needs.
+
+The entire cyrusdb source lives in the lib/ directory of the cyrus-imapd repository, in the following files:
+
+::
+
+    lib/cyrusdb.h
+    lib/cyrusdb.c
+    lib/cyrusdb_flat.c
+    lib/cyrusdb_quotalegacy.c
+    lib/cyrusdb_skiplist.c
+    lib/cyrusdb_sql.c
+    lib/cyrusdb_twoskip.c
+
+cyrusdb.h
++++++++++
+
+*   interface definitions (all access to cyrusdb databases happens
+    through the functions defined here)
+*   the ``struct cyrusdb_backend`` data structure which defines the
+    interface implemented by each backend.
+*   constants for flags to the cyrusdb_open call, and return codes.
+    Cyrusdb functions all return their own CYRUSDB_* error codes, which
+    are not compatible with the r = IMAP_* return codes used throughout
+    much of the rest of the codebase.
+
+cyrusdb.c
++++++++++
+
+*   implementations of the wrapper functions around the backends,
+    including default implementations of some functions which are
+    common to many backends but overridden by some.
+*   a wrapper to initialise and cleanup the state of each backend
+    (if needed) during Cyrus set up / tear down.
+
+cyrusdb_*.c
++++++++++++
+
+*   the actual implementations of each backend! We'll look at some
+    in a sec.
+
+Configuration
+-------------
+
+The name of the backend for each of the main internal databases can be
+configured in imapd.conf, for example: ``annotation_db: skiplist``. This
+is then read in imap/global.h and imap/global.c during startup, so that
+the global variable ``config_annotation_db`` gets set to the configured
+backend name:
+
+::
+
+        config_annotation_db = config_getstring(IMAPOPT_ANNOTATION_DB);
+
+(Beware the misleading naming here: ``config_annotation_db`` is a string
+describing the *backend* used by the database, not, say, its location on
+disk.)
+
+Internally, the main module for each database sets up struct of pointers
+to the cyrusdb functions it implements, which is registered in
+``lib/cyrusdb.c``
+
+``lib/cyrus.c`` provides backend-agnostic wrapper functions for
+interacting with cyrusdb databases.
+
+A full example
+--------------
+
+::
+
+      struct db *db = NULL;
+      struct txn *tid = NULL;
+      const char *filename = NULL;
+      int flags = CYRUSDB_CREATE;
+
+      cyrus_init(alt_config, "toolname", 0);
+
+      filename = config_getstring(IMAPOPT_ANNOTATION_DB_PATH);
+
+      r = cyrusdb_open(config_annotation_db, filename, flags, &db);
+
+      r = cyrusdb_fetch(db, key, keylen, &data, &datalen, &tid);
+
+      r = cyrusdb_commit(db, tid);
+
+      r = cyrusdb_close(db);
+
+      cyrus_done();
+
+Note that you always open a database first, and close it at the end. You
+must always call cyrus\_init() and cyrus\_done() to properly initialize
+and clean up the ``cyrusdb`` environments.
+
+This example also uses a transaction, meaning that the database is
+locked in exclusive mode between the 'fetch' (the first use of the
+transaction) and the commit.
+
+Tools
+-----
+
+There are also some tools to work with and support cyrus databases:
+
+imap/ctl_cyrusdb
+++++++++++++++++
+
+:cyrusman:`ctl_cyrusdb(8)`
+
+*   performs maintenance on the cyrusdb subsystem. This is called in two places:
+
+    *   START: "ctl_cyrusdb -r" (recovery).
+        This is the ONLY PLACE that code is guaranteed to be run at
+        startup on every cyrus installation, so you'll find quite a lot
+        of detritus has built up in this codepath over the years.
+    *   EVENTS: "ctl_cyrusdb -c" (checkpoint).
+        This is run regularly (period=180 at FastMail, examples in the
+        codebase have period=5 or period=30). Both this codepath and
+        cyr_expire tend to run periodically on cyrus systems, and
+        cleanup code is spread between those two locations.
+
+imap/cvt_cyrusdb
+++++++++++++++++
+
+:cyrusman:`cvt_cyrusdb(8)`
+
+*   used for converting a database between versions.
+    This is often used to prepare for upgrade, particularly in the past
+    when Cyrus supported berkeley DB which didn't upgrade cleanly
+    across OS versions, it was common to use cvt_cyrusdb to turn
+    databases into a very portable format (flat or skiplist) before
+    upgrading, upgrade the OS, convert back to the fast format
+    (berkeley) and then restart.
+
+imap/cyr_dbtool
++++++++++++++++
+
+:cyrusman:`cyr_dbtool(8)`
+
+*   once known as brontool, this is the first piece of Cyrus code
+    I ever wrote! It's a fairly dumb wrapper around the CyrusDB
+    interface, and able to be used to read, write, or iterate any parts
+    of a database. Its interactive mode is not special-character clean,
+    but it can also be used in batch mode, which uses IMAP atom-string
+    literal8 for input/output, and hence can roundtrip data reliably.
+
+There are also tools like: :cyrusman:`ctl_conversationsdb(8)`,
+:cyrusman:`dav_reconstruct(1)` and :cyrusman:`ctl_mboxlist(8)` which
+can be used to manage individual databases through a more specific
+interface which understands the context as well as just the raw
+key/value.
+
+How to use CyrusDB
+------------------
+
+Assuming that ``cyrus_init()`` has been called, which calls
+``cyrusdb_init()``, you can assume that databases will work in any
+Cyrus code.
+
+The first step is to open a database. Databases have a filename - this
+might be a literal filename on the backend, a directly containing data,
+or an opaque token used by the backend to locate a datasource.
+
+::
+
+    int flags = 0;
+    struct db *mydb = NULL;
+    int r = cyrusdb_open("skiplist", "/tmp/database.db", flags, &mydb);
+    if (!r) return mydb;  // if (r == CYRUSDB_OK) { ... }
+    /* XXX: error handling */
+
+Accepted flags:
+
+CYRUSDB_CREATE - if the named database doesn't exist, create a blank
+database.
+
+CYRUSDB_MBOXSORT - use the abomination called improved_mboxlist_sort
+which re-orders a couple of characters to allow "foo.bar" to sort
+before "foo bar", for perfectly good reasons, but we're going to fix it
+a better way. Not every engine supports arbitrary collation, and if
+many engines corrupt horribly if the same database is opened with
+different choices for this flag. Ouch.
+
+CYRUSDB_CONVERT - if set and the database fails to open, attempt a
+magic detection on the file content and try to convert the database to
+the requested backend type before opening it. In-place upgrades! If
+this is NOT set, then instead the magic detection will still be
+performed, but the open database will be returned using the correct
+engine for that database rather than converted. Magic detection only
+currently works for single-file database formats.
+
+CYRUSDB_NOCOMPACT - if the database format supports automatic
+compacting, don't use it. Handy for when you want to read without
+causing any possible issues (e.g. read-only filesystem during recovery)
+or when performance is critical and you don't want to risk waiting
+while a recompact happens.
+
+All the remaining functions take that "struct db" pointer.
+
+There's also a ``cyrusdb_lockopen()`` interface which takes a
+transaction pointer and returns with the transaction already active.
+This isn't actually being used yet, but is intended to allow slightly
+more efficient single-operation database use. Right now, open returns
+an unlocked database, but may need to lock as part of the setup, so
+keeping that lock would avoid one extra unlock/lock cycle.
+
+Reading, Writing, & Transactions
+--------------------------------
+
+CyrusDB supports both transactional and non-transactional access.
+Transactions are always exclusive. This is arguably a deficiency in the
+interface, particularly since many engines implement a non-exclusive
+(read) lock internally anyway.
+
+Reading
++++++++
+
+There are now 4 interfaces to read data. Two of which are original
+cyrusdb and two of which are more recently added.
+
+original:
+
+    ``cyrusdb_fetch()``
+        fetch a single value by exact key.
+    ``cyrusdb_foreach()``
+        given a prefix, iterate over all the keys with that prefix
+        (including exactly that key) in order.
+
+newer:
+
+    ``cyrusdb_fetchnext()``
+        given an exact key, fetch the following key and value
+        (regardless of whether the key exists), e.g given keys "f" and
+        "g", fetchnext "foo" would return "g", as would fetchnext "f".
+        This can be used to implement foreach (indeed, the skips do
+        exactly that).
+
+    ``cyrusdb_forone()``
+        given an exact key, act like ``cyrusdb_foreach`` but only for
+        that one key.
+
+        This is a convenience wrapper around fetch to
+        allow doing things like::
+
+            r = cyrusdb_forone(mydb, "folder", 6, p, cb, rock, &tid);
+            if (!r) r = cyrusdb_foreach(mydb, "folder.", 7, p, cb, rock, &tid);
+
+        Which does precisely "folder" and its children without visiting
+        any other keys that have "folder" as a prefix.
+
+Since the cyrusdb interface always takes both a pointer and a length,
+it's also possible to use::
+
+    char *key = "folder.";
+    r = cyrusdb_forone(mydb, key, 6, p, cb, rock, &tid);
+    if (!r) r = cyrusdb_foreach(mydb, key, 7, p, cb, rock, &tid);
+
+OK, foreach. Foreach is very tricky, because it takes TWO callbacks.
+The callbacks have an identical signature, but different return codes!
+
+::
+
+    typedef int foreach_p(void *rock,
+    const char *key, size_t keylen,
+    const char *data, size_t datalen);
+
+    typedef int foreach_cb(void *rock,
+    const char *key, size_t keylen,
+    const char *data, size_t datalen);
+
+The difference is this: ``foreach_p`` is called with the database
+locked, always - even if called without a transaction. ``foreach_p``
+returns 1 or 0. 0 means "skip this record", 1 means "process this
+record". This is useful to pre-filter records when called without a
+transaction, because otherwise you lock and unlock all the time.
+
+NULL for ``foreach_p`` is treated like a test which always returns '1',
+so you can pass NULL if you don't need filtering.
+
+If ``foreach_p`` returns 1, then with an unlocked transaction, the
+database is now unlocked BEFORE calling ``foreach_cb``, the callback.
+``foreach_cb`` returns a CYRUSDB\_ response. If zero, the foreach will
+continue. If non-zero, the foreach will abort and return the non-zero
+response. This is both useful for error cases, and useful for
+short-circuiting, if you only care that a key exists, you can do
+something like::
+
+    static int exists_cb(void rock attribute((unused)), [...])
+    {
+        return CYRUSDB_DONE; / one is enough */
+    }
+
+and then use ``exists_cb`` as your ``foreach_cb`` and check if the
+return code is CYRUSDB_DONE to know if the foreach found a key.
+
+If foreach is called with a transaction pointer, then it is your
+responsibility as the caller to also pass that pointer (and a pointer
+to the database) in that rock, so that callees can make further
+operations within the same transaction. A foreach with a transaction
+does NOT unlock before calling its callback.
+
+About Transactions
+++++++++++++++++++
+
+You may have noticed that 'tid' at the end. Every function for acting
+on the database takes as its last argument a ``struct txn **``.
+
+The cyrusdb interface works in two modes - transactional and
+non-transactional. The value of the 'tid' parameter decides which mode
+is used. There are three possible values:
+
+*   NULL - non-transactional request.
+    Do whatever you need for internal locking, but starts with an
+    unlocked database and ends with an unlocked database.
+
+    .. Note::
+
+        At least skiplist and twoskip implement a hack where if the
+        database IS locked for a non-transactional read request, they
+        will act as if you'd passed the current transaction in for the
+        NULL case. This is a hack around layering violations and kind
+        of sucks.
+
+*   &NULL - e.g::
+
+        struct txn *tid = NULL;
+        const char *data = NULL;
+        size_t datalen = 0;
+        int r = cyrusdb_fetch(mydb, key, keylen, &data, &datalen, &tid);
+
+    After calling this, tid will have an opaque value allocated by the
+    database backend, which must be passed to all further cyrusdb
+    operations on that database until either ``cyrusdb_commit()`` or
+    ``cyrusdb_abort()`` are called.
+
+*   &tid - e.g::
+
+        if (r == CYRUSDB_NOTFOUND) {
+            r = cyrusdb_store(mydb, key, keylen, "DEFAULT", 7, &tid); // set a default value
+        }
+
+    Given an existing transaction, perform this call in the context of the transaction.
+
+If you are currently in a transaction, you MUST pass the same
+transaction to every database call. It is not possible to mix or nest
+transactions.
+
+There is one exception in the skiplist backend:
+
+    If you pass NULL to a fetch or foreach while the database is in a
+    transaction, it will silently do the read in the current
+    transaction rather than returning an error.
+
+Writing
++++++++
+
+There are three write operations:
+
+::
+
+    cyrusdb_create
+    cyrusdb_store
+    cyrusdb_delete
+
+``cyrusdb_store`` will either create or overwrite an existing key.
+``cyrusdb_create`` will abort if the key already exists.
+``cyrusdb_delete`` takes a flag 'force' which just makes it return
+CYRUSDB_OK (0) rather than CYRUSDB_NOTFOUND if the key doesn't exist.
+Strangely, 'force' is after &tid, making it the only cyrusdb API that
+does that, but hey - keeps you on your toes.
+
+&tid behaves exactly the same for the write APIs. If not passed, then
+the database engine will behave as it if creates a writable
+transaction, does the operation, then commits all within the
+``cyrusdb_*`` call.
+
+Gotchas!
+--------
+
+*   NULL is permitted in both keys and values, though 'flat' and
+    'quotalegacy' have 8-bit cleanliness issues.
+
+*   zero-length keys are not supported
+
+*   zero-length values are theoretically supported, but a little
+    interesting. Certainly, pass "" rather than NULL as the value when
+    writing or things will get weird. I'm pretty sure at least the
+    \*skip databases assert on these kinds of weirdness.
+
+*   unlocked foreach: this is the land of the gotcha! They key and data
+    pointers (const char \*) passed to your ``foreach_cb`` are only
+    valid UNTIL YOU TOUCH THE DATABASE. A common cause of rare and hard
+    to diagnose bugs is writing something to the same database in the
+    same process (OR EVEN READING FROM IT AGAIN). I cannot emphasise
+    this enough. If you want to zero-copy access that data, you need to
+    access it first, before touching that DB again. Otherwise the map
+    in which the data was a pointer may have been replaced as the next
+    read found a new file and mapped it in!
+
+    also: if you're implementing a backend. Unlocked foreach must find
+    future records created by the current callback. Consider a database
+    containing 4 keys::
+
+        A B C D
+
+    If you are at key B and insert a key BB, then it must be iterated over.
+    If you insert AA while at B, it must NOT be iterated over.
+
+*   Opening the same database multiple times.
+    In the bad old days, opening the same database multiple times in
+    the same process led to locking bugs (fcntl is braindead). Each
+    database engine is responsible for making sure this doesn't happen.
+    Most engines keep a linked lists of open databases. If you try to
+    open the same database again, they will just return the existing
+    opened copy and bump a refcount. Beware. If a database is locked
+    and you try to lock again - thinking you were opening it brand new,
+    it will assertion fail and/or error.
+
+I think that covers about everything! Cyrusdb is used just about
+everywhere that sorted key-value databases give what's needed,
+including mailboxes.db, annotations.db (global and per mailbox
+databases), seen state (non-owner), subscriptions, cyrus.indexed.db for
+Xapian, and the rather massive (and increasingly inaccurately named)
+user.conversations.
+
+Future plans are to increase the usage of cyrusdb databases, possibly
+by building an indexing layer on top and using that instead of the
+sqldb interface used for sqlite databases by DAV code, and possibly
+also moving other custom file formats into a cyrusdb to allow easier
+stateless server builds on a distributed backend.
+
+
+API Reference
+-------------
+
+All functions follow the normal C API of returning '0' on success, and
+an error code on failure
+
+cyrusdb\_init(void)
++++++++++++++++++++
+
+Is called once per process. Don't call this yourself, use
+``cyrus_init()``. No other calls will be made until this is called.
+
+cyrusdb\_done(void)
++++++++++++++++++++
+
+The opposite of ``cyrusdb_init()`` - called once per process to do any
+cleaning up after all database usage is finished. Don't call this
+yourself, use ``cyrus_done()``.
+
+cyrusdb\_sync(const char \*backend)
++++++++++++++++++++++++++++++++++++
+
+Perform a checkpoint of the database environment. Used by berkeley
+backend. Is called by ``ctl_cyrusdb -c`` on a regular basis
+
+cyrusdb\_open(const char \*backend, const char \*fname, int flags, struct db \*\*retdb)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Opens the database with the specified 'file name' (or other descriptor,
+for example the sql backend is not a filename), and if successful
+returns an opaque database structure
+
+Flags:
+
+-  CYRUSDB\_CREATE - create the database if it doesn't exist
+-  CYRUSDB\_MBOXSORT - sort '.' first, so folder listing is correct
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there is any error reading the file, or any
+   corruption detected while loading the file
+
+cyrusdb\_close(struct db \*db)
+++++++++++++++++++++++++++++++
+
+Close the named database. Will release any locks if they are still held,
+but it's bad practice to close without committing or aborting, so the
+backend should log an error
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if there are any errors during close
+
+cyrusdb\_fetch(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_fetchlock(struct db \*db, const char \*key, size\_t keylen, const char \*\*data, size\_t \*datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Fetch the value for the exact key given by key and keylen. If data is
+not NULL, set datalen and return a valid pointer to the start of the
+value.
+
+Fetchlock is identical to fetch, but gives a hint to the database that
+the record is likely to be modified soon.
+
+NOTE: it is possible to store a key with a zero length data record, in
+which case \*datalen will be set to zero, and \*data will be set to a
+non-NULL value
+
+It is an error to call fetch with a NULL key or a zero keylen
+
+It is an error to call fetch with a NULL datalen and a non-NULL data,
+however it is acceptable to call with a NULL data and a non-NULL datalen
+if you are only interested in the length
+
+Errors:
+
+-  CYRUSDB\_IOERROR - if any error occurs reading from the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if there is no record that matches the key
+
+cyrusdb\_foreach(struct db \*db, const char \*prefix, size\_t prefixlen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_forone(struct db \*db, const char \*key, size\_t keylen, foreach\_p \*goodp, foreach\_p \*procp, void \*rock, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+``cyrusdb_foreach()`` iterates over all records matching the given
+prefix, in database order (which may be MBOXLIST sort, depending on the
+parameters given to open
+
+It is legal to give a NULL pointer as prefix if prefixlen is zero, in
+which case it will return all records in the database. It is an error to
+give a non-zero prefixlen with a NULL prefix.
+
+``cyrusdb_forone()`` "iterates" over the single record matched by the
+given key. If you've already built callbacks for processing each record
+from a foreach, this lets you use the same interface to process a single
+record.
+
+``goodp`` - this function is only used for deciding if the record needs
+to be further processed. It can be used for basic filtering, and returns
+true (non-zero) to process, or zero to skip and move straight to the
+next record. Because goodp can't make any database changes, it doesn't
+break the lock, so it's faster to use goodp to filter records if you
+don't need to process all of them. NULL is a legal value for goodp, and
+means that all records will be processed.
+
+``procp`` - procp is the main callback function. If you use foreach in
+non-transactional mode, the database is unlocked before calling procp,
+and locked again afterwards. You are allowed to add, delete or modify
+values in the same database from within procp. If procp returns
+non-zero, the foreach loop breaks at this point, and the return value of
+the foreach becomes the return value of procp. If procp returns zero,
+the foreach loop will continue at the NEXT record by sort order,
+regardless of whether the current record has changed or been removed.
+procp MUST NOT be NULL.
+
+Errors:
+
+-  procp\_result - whatever your callback returns
+-  CYRUSDB\_IOERROR - if any error occurs while reading
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_create(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+cyrusdb\_store(struct db \*db, const char \*key, size\_t keylen, const char \*data, size\_t datalen, struct txn \*\*tidptr)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Create a new record or replace an existing one. The only difference
+between these two is that ``cyrusdb_create`` will return an error if the
+record already exists, while ``cyrusdb_store`` will replace it
+
+If tidptr is NULL, create/store will take a write lock for the duration
+of the action.
+
+Any failure during create/store will abort the current transaction as
+well as returning an error
+
+It is legal to pass NULL for the data field ONLY if datalen is zero. It
+is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_EXISTS - if ``cyrusdb_create`` is called on an existing key
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_delete(struct db \*db, const char \*key, size\_t keylen, struct txn \*\*tidptr, int force)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Delete the given record from the database. If force is true, then
+succeed even if the record doesn't currently exist.
+
+It is not legal to pass NULL for key or zero for keylen
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_NOTFOUND - if force is not set and the key doesn't exist
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_commit(struct db \*db, struct txn \*tid)
++++++++++++++++++++++++++++++++++++++++++++++++++
+
+Commit the current transaction. tid will not be valid after this call,
+regardless of success
+
+If the commit fails, it will attempt to abort the transaction
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+-  CYRUSDB\_AGAIN - if a deadlock is created. The current transaction
+   has been aborted, but a retry may succeed
+
+cyrusdb\_abort(struct db \*db, struct txn \*tid)
+++++++++++++++++++++++++++++++++++++++++++++++++
+
+Abort the current transaction. tid will not be valid after this call,
+regardless of success
+
+Attempt to roll back all changes made in the current transaction.
+
+Errors:
+
+-  CYRUSDB\_IOERROR - any error to write to the database
+-  CYRUSDB\_LOCKED - if tidptr is incorrect
+
+cyrusdb\_dump(struct db \*db, int detail)
++++++++++++++++++++++++++++++++++++++++++
+
+Optional function to dump the internal structure of the database to
+stdout for debugging purposes. Don't use.
+
+cyrusdb\_consistent(struct db \*db)
++++++++++++++++++++++++++++++++++++
+
+Check if the DB is internally consistent. Looks pretty bogus, and isn't
+used anywhere. Don't use.
diff -pruN 3.0.13-5/docsrc/imap/developer/API/index-api.rst 3.2.0-3/docsrc/imap/developer/API/index-api.rst
--- 3.0.13-5/docsrc/imap/developer/API/index-api.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/API/index-api.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,76 @@
+.. _imap-developer-api-index:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Index API
+=========
+
+Intro
+-----
+
+The Index API is implemented in ``imap/index.h`` and ``imap/index.c``.
+It provides a snapshot view into the underlying mailbox (see `the
+Mailbox API documentation <mailbox-api.html>`) which obeys IMAP
+semantics, as well as all the searching and sorting logic.
+
+Opening and closing
+-------------------
+
+::
+
+    struct index_state *state = NULL;
+    struct index_init init;
+    int r;
+    const char *mboxname = "user.brong";
+
+    memset(&init, 0, sizeof(struct index_init));
+    init.userid = imapd_userid;
+    init.authstate = imapd_authstate;
+    init.out = imapd_out;
+
+    r = index_open(mboxname, &init, &state);
+    if (r) return r;
+
+    do_stuff(state);
+
+    index_close(&state);
+
+The ``index_init`` interface sucks. So does passing lots of parameters.
+For now, this will do! Just pass NULL if you're only reading, or use the
+code already in imapd and you'll be fine.
+
+The Index Model
+---------------
+
+Ok - I think a few words about the index model and how it differs from
+direct mailbox access are needed! In the past, index.c used pointers
+directly into the mmaped ``cyrus.index`` file and maintained the old
+mmaped copy if an expunge took place. Under the namelock regime, this is
+no longer required because namelocks will avoid the file being
+re-written.
+
+Also, memory is now cheap. Rather than using locks to ensure
+consistency, we just keep a copy of the ``struct index_record`` for even
+message in the index, stored in memory. Since these are about 100 bytes
+each, a 1 million email mailbox will take rougly 100Mb of memory. That's
+not too bad on a modern server, and that's a **huge** mailbox.
+
+So - the model works like this:
+
+-  Create the index state or re-lock (``index_lock``) the mailbox on an
+   existing index.
+-  call ``index_refresh``
+-  if any changes are to be made (i.e. flag updates for a store,
+   non-peek body fetch, expunge) then cycle through the refreshed state
+   map and update the records which are affected.
+-  call ``index_unlock`` (unlock the underlying mailbox and commit the
+   statuscache changes)
+
+   At this point the index lock is **released** and we have not yet
+   generated any network traffic. Now start generating the response.
+
+-  if expunges are allowed, call ``index_tellexpunge``
+-  call ``index_tellchanges`` to tell about all other changes
+-  return any response that the command itself required
diff -pruN 3.0.13-5/docsrc/imap/developer/API/mailbox-api.rst 3.2.0-3/docsrc/imap/developer/API/mailbox-api.rst
--- 3.0.13-5/docsrc/imap/developer/API/mailbox-api.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/API/mailbox-api.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,335 @@
+.. _imap-developer-api-mailbox:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Mailbox API
+===========
+
+Intro
+-----
+
+The Mailbox API is implemented in ``imap/mailbox.h`` and
+``imap/mailbox.c``. It wraps the data structures of the
+``cyrus.header``, ``cyrus.index`` and ``cyrus.cache`` files in a
+psuedo-object-oriented way, allowing easy changes to the mailbox while
+keeping the internal cached data structures consistent.
+
+Opening and closing
+-------------------
+
+::
+
+    struct mailbox *mailbox = NULL;
+    int r;
+    const char *mboxname = "user.brong";
+
+    r = mailbox_open_iwl(mboxname, &mailbox);
+    // or
+    r = mailbox_open_irl(mboxname, &mailbox);
+    // or
+    r = mailbox_open_exclusive(mboxname, &mailbox);
+    if (r) return r;
+
+    do_stuff(mailbox);
+
+    mailbox_close(&mailbox);
+
+It is always necessary to obtain an index lock when opening a mailbox,
+because the index header read must be consistent. The locks are as
+follows:
+
++----------------------------+-------------+--------------+
+| Function                   | Namelock    | Index Lock   |
++============================+=============+==============+
+| mailbox\_open\_iwl         | Shared      | Exclusive    |
++----------------------------+-------------+--------------+
+| mailbox\_open\_irl         | Shared      | Shared       |
++----------------------------+-------------+--------------+
+| mailbox\_open\_exclusive   | Exclusive   | Exclusive    |
++----------------------------+-------------+--------------+
+
+It should never be necessary to call ``mailbox_open_exclusive``, but
+it's included for completeness. Use ``mailbox_open_iwl`` if you expect
+to need to write to the index (or even if you're not sure) and
+``mailbox_open_irl`` when you know you're only reading from the file and
+wish to allow other readers to work concurrently.
+
+Many actions are delayed until the mailbox is closed, or even until the
+*last* mailbox is closed for things that require an exclusive namelock
+to perform like deletion or repack. See below under "delayed actions"
+for more detail.
+
+To avoid opening the same file multiple times, the mailbox API refcounts
+open mailboxes. If you open the same mailbox again (i.e. a URL fetch or
+status command on the currently select mailbox) then the same mailbox
+will be returned. It must be unlocked (see below or the open command
+will return IMAP\_MAILBOX\_LOCKED). The matching close will reduce the
+refcount, and only the final close will do the cleanup actions.
+
+Locking and unlocking
+---------------------
+
+You can keep a mailbox "open", maintaining the namelock, while releasing
+the index lock to allow other processes to make changes to the mailbox.
+By holding the namelock, you know that record numbers won't change, and
+the underlying message files won't be deleted.
+
+``mailbox_close`` will call ``mailbox_unlock_index`` if the index is
+still locked, so it is not necessary to explicitly unlock the index
+before closing.
+
+::
+
+    r = mailbox_unlock_index(mailbox, NULL);
+
+    // sleep on user input...
+
+    r = mailbox_lock_index(mailbox, LOCK_SHARED);
+    // or
+    r = mailbox_lock_index(mailbox, LOCK_EXCLUSIVE);
+
+For example, ``mailbox_unlock_index`` and ``mailbox_lock_index`` are
+used extensively by the index module, allowing an imap client to
+maintain a long lived connection selected to a mailbox and know that
+messages won't magically disappear from under it - yet at the same time
+allow new mail delivery to happen or other imap connections to query the
+mailbox.
+
+If you have built an accurate statuscache item for the locked mailbox,
+you can pass this as the second parameter to mailbox\_index\_unlock. If
+there have been any changes, mailbox\_index\_unlock will invalidated the
+statuscache. If you give it the new value, then it will store that value
+instead. For example:
+
+::
+
+    struct statusdata sdata;
+    index_status(state, &sdata);
+    /* RECENT is zero for everyone else because we wrote a new
+     * recentuid! */
+    sdata.recent = 0;
+    mailbox_unlock_index(state->mailbox, &sdata);
+
+See "delayed actions" below for delayed actions performed during an
+unlock.
+
+Creating, renaming and deleting
+-------------------------------
+
+**WARNING:** These functions only change the mailbox files on disk. They
+don't update the mailboxes.db records or contact murder servers. In most
+cases you are probably looking for the ``mboxlist_`` functions instead.
+
+Creating a mailbox is somewhat longwinded - as there are many optional
+parameters.
+
+::
+
+    int mailbox_create(const char *name, const char *part, const char *acl,
+                       const char *uniqueid, int options, unsigned uidvalidity,
+                       struct mailbox **mailboxptr);
+
+Most interesting to note is that on success, ``mailboxptr`` will contain
+the same mailbox that ``mailbox_open_exclusive`` above would have
+returned, with an exclusive namelock and an exclusive index lock. This
+allows you to perform other consistency operations after creating the
+mailbox with a full guarantee that no other process will even be able to
+know of the mailbox's existence! You can still roll-back by deleting the
+mailbox and the next process will get the namelock and see no mailbox
+with that name.
+
+::
+
+    int mailbox_rename_copy(struct mailbox *oldmailbox,
+                            const char *newname, const char *newpart,
+                            const char *userid, int ignorequota,
+                            int silent,
+                            struct mailbox **newmailboxptr);
+
+Very similar to mailbox\_create - the new mailbox is created with an
+exclusive name lock and returned. The old mailbox must be passed in with
+an **exclusive index lock** but is fine with a shared namelock, as it
+will be passed to ``mailbox_delete``.
+
+::
+
+    int mailbox_delete(struct mailbox **mailboxptr);
+
+Just like ``mailbox_close`` above, this closes the mailbox. Before it
+does so, it sets the OPT\_MAILBOX\_DELETED option flag in the index
+header. The interesting work is actually done in ``mailbox_close``. See
+below under "delayed actions".
+
+``mailbox_delete`` requires an exclusive index lock, but can complete
+quite happily with only a shared namelock.
+
+Reading and writing records
+---------------------------
+
+Ok - so you have a mailbox, it's opened, and the index is locked. Time
+to start reading and writing some records!
+
+At the mailbox level there is no concept of "message numbers" from imap,
+only "record numbers". The canonical variable name to refer to record
+numbers is ``recno``. All records are read and written using
+``struct index_record`` values.
+
+Here at the API definitions used for reading and writing:
+
+::
+
+    int mailbox_read_index_record(struct mailbox *mailbox,
+                                  uint32_t recno,
+                                  struct index_record *record);
+    int mailbox_rewrite_index_record(struct mailbox *mailbox,
+                                     struct index_record *record);
+    int mailbox_append_index_record(struct mailbox *mailbox,
+                                    struct index_record *record);
+    int mailbox_commit(mailbox);
+
+An example of iterating through a mailbox
+
+::
+
+    uint32_t recno;
+    struct index_record record;
+    int make_changes;
+
+    /* DEPRECATED */
+    for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+        if (mailbox_read_index_record(mailbox, recno, &record))
+            fatal("invalid record", EX_SOFTWARE); // or return an error
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+            continue; // skip expunged records
+        make_changes = do_stuff(mailbox, &record);
+        if (make_changes)
+            mailbox_rewrite_index_record(mailbox, &record);
+    }
+
+    /* the new way */
+    int make_change;
+    const struct index_record *record;
+    struct mailbox_iter *iter;
+
+    iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+    while ((record = mailbox_iter_step(iter))) {
+        make_changes = do_stuff(mailbox, record);
+        if (make_changes)
+            mailbox_rewrite_index_record(mailbox, record);
+    }
+    mailbox_iter_done(&iter);
+
+NOTE: ``mailbox_rewrite_index_record`` doesn't need a recno, as that's
+cached inside the index\_record struct.
+
+NOTE: You need an exclusively locked index to use rewrite or append, but
+only a shared index lock to use read.
+
+There are a range of consistency checks done to ensure that a rewrite
+doesn't violate IMAP semantics (an expunged message can never be
+unexpunged, UIDs can't change, etc) and the internal tracking counts and
+quota data are updated as well. They will be committed at unlock time,
+see "delayed actions"
+
+If you don't set the ``record.silent`` field to a true value before
+rewriting or appending, the ``record.modseq`` and
+``record.last_updated`` values will be changed. This allows condstore to
+work correctly.
+
+Appending
+~~~~~~~~~
+
+To append a record, the file must have already been copied into place
+(XXX - plan to move to a stage based system where the mailbox API
+handles the staging, but that's not finished yet) and been parsed into
+the record struct. The UID must be set already, and must be greater than
+the UID of any existing record in the mailbox. There are a range of
+consistency checks done.
+
+The internal consistency counts are updated by append as well.
+
+Committing
+~~~~~~~~~~
+
+When you have finished making any changes, you need to "commit". This
+will write the updated values for any index header fields, rewite the
+``cyrus.header`` file if needed and fsync all changes to disk.
+
+It is a fatal error to unlock (or close) a mailbox that has had changes
+without committing, as it can leave the mailbox in a corrupted state.
+
+Cache records
+~~~~~~~~~~~~~
+
+Cache records are accessed through ``record.crec`` which is not filled
+by read\_index\_record. The cache file is only read and mapped into
+memory as needed, so you if you want to access cache records, the basic
+API is as follows:
+
+::
+
+    int mailbox_cacherecord(struct mailbox *mailbox,
+                            struct index_record *record);
+    const char *cacheitem_base(struct index_record *record, int field);
+    unsigned cacheitem_size(struct index_record *record, int field);
+    struct buf *cacheitem_buf(struct index_record *record, int field);
+
+You must always call ``mailbox_cacherecord`` on a record before trying
+to access any of the cache items. "``field``" above is the individual
+field (there are 10) in the cache record. There's more information on
+those fields in the mailbox internal format documentation.
+
+::
+
+    for (recno = 1; recno <= mailbox->i.num_records; recno++) {
+        if (mailbox_read_index_record(mailbox, recno, &record))
+            fatal("invalid record", EX_SOFTWARE); // or return an error
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
+            continue; // skip expunged records
+        if (mailbox_cacherecord(mailbox, &record))
+            fatal("failed to read cache", EX_SOFTWARE);
+        ...
+        envelope_length = cacheitem_size(&record, CACHE_ENVELOPE);
+    }
+
+See ``imap/mailbox.h`` for the full list of constants.
+
+Delayed Actions
+---------------
+
+Here's the bit you've been waiting for! What happens during unlock and
+close
+
+first, unlock
+~~~~~~~~~~~~~
+
+Anything that makes any changes sets the mailbox->has\_changed flag. If
+this is set, then before the index gets unlocked:
+
+-  the updatenotifier (idle) is called
+-  ``sync_log_mailbox`` (replication) gets called
+-  the statuscache value gets erased (or replaced if you passed in an
+   updated value).
+
+then: close
+~~~~~~~~~~~
+
+next the index is unlocked (see above)
+
+third, any "unlink" commands scheduled for email files are run. These
+can't be done until after the mailbox\_commit to ensure consistency -
+the file isn't deleted until the record is written as unlinked! But we
+save the unlink until now so that other tasks aren't waiting for the
+index lock while the unlinks run. Unlink is expensive in IO and time.
+
+finally we check for MAILBOX\_NEEDS\_REPACK or MAILBOX\_DELETED option
+flags. If either is sets, then we make a non-blocking attempt to get an
+exclusive namelock. If the non-blocking attempt fails, then another
+process has the mailbox open, so save the cleanup for them! If it
+succeeds, then go ahead with either ``mailbox_delete_cleanup`` or
+``mailbox_index_repack`` as appropriate.
+
+After this it's just a matter of releasing malloc'd memory and finally
+releasing the name lock.
diff -pruN 3.0.13-5/docsrc/imap/developer/API.rst 3.2.0-3/docsrc/imap/developer/API.rst
--- 3.0.13-5/docsrc/imap/developer/API.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/API.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,12 @@
+.. _imap-developer-API:
+
+==============
+Developer APIs
+==============
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    API/*
diff -pruN 3.0.13-5/docsrc/imap/developer/compiling.rst 3.2.0-3/docsrc/imap/developer/compiling.rst
--- 3.0.13-5/docsrc/imap/developer/compiling.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/compiling.rst	2020-04-24 02:03:00.000000000 +0000
@@ -77,6 +77,7 @@ Developers only
 
     Configure option: ``--with-perl``"
     `perl(Pod::POM::View::Restructured)`_,,,, "Perl library to generate man pages.  This has to be available to the system-wide perl interpreter, found by ``which``:  ``./configure --with-perl`` is not honoured."
+    `python(GitPython)`_,,,, "Python library needed for building the documentation"
     `python(Sphinx)`_,,,, "Python library needed for building the documentation"
     `valgrind`_, valgrind, valgrind, "no", "Performance and memory testing."
     `xxd`_,,,, "For rebuilding the _js.h files, for CalDAV and CardDAV support."
@@ -105,32 +106,23 @@ Alternate database formats
     :header: "Package", "Debian", "RedHat",  "Required for ``make check``?", "Notes"
     :widths: 20,15,15,5,45
 
-    `lmdb`_, lmdb-dev, lmdb, "no", "Lightning Memory-Mapped Database Manager (LMDB) backend for Cyrus IMAP
-    databases.     LMDB requires database environments to be set to a (user-configurable)
-    maximum size. The Cyrus backend uses 512MB as default size. Cyrus
-    installations may override this by setting the environment variable
-    CYRUSDB_LMDB_MAXSIZE. The value of this variable must be an integer,
-    optionally followed (without space) by 'mb' or 'gb' to define the
-    maximum size in bytes, megabytes or gigabytes. The size should be a
-    multiple of the OS page size. "
     `mysql`_ or `mariadb`_, libmysqlclient-dev or libmariadb-dev, mysql-devel or mariadb-devel, "no", "MariaDB or MySQL development headers, to allow Cyrus IMAP to use
     it as the backend for its databases.
 
     Configure option: ``--with-mysql``, ``--with-mysql-incdir``, ``--with-mysql-libdir``"
     `postgresql`_, postgresql-dev, postgresql-devel, "no"
 
-CalDAV and/or CardDAV
-#####################
+CalDAV, CardDAV, or JMAP
+########################
 
 .. csv-table::
     :header: "Package", "Debian", "RedHat",  "Required for ``make check``?", "Notes"
     :widths: 20,15,15,5,45
 
-    `libical`_, libical-dev, libical-devel, "no", "libical >= 0.48 required for scheduling support.
-    **Note:** Linux distributions Enterprise Linux 6 and Debian Squeeze are
-    known to ship outdated **libical** packages versions 0.43 and
-    0.44 respectively. The platforms will not support scheduling."
-    `libxml`_, libxml2-dev, libxml2-devel, "", "no"
+    `libchardet`_, libchardet-dev, libchardet-devel, "no", ""
+    `libical`_, libical-dev, libical-devel, "no", "version 3.0.0 or higher"
+    `libxml`_, libxml2-dev, libxml2-devel, "no", ""
+    `shapelib`_, shapelib, "", "no", "version 1.3.0 or higher"
 
 Other
 #####
@@ -152,8 +144,10 @@ Other
     `transfig`_, transfig, xx, "no", "also known as fig2dev"
     `pcre`_,,,, "PCRE 1 (or 8) - for regular expression matching"
     `perl(Term::ReadLine)`_,,,, "Perl library needed by cyradm"
+    `libsrs2`_,,,, "Sender Rewriting Scheme for lmtp, used on Sieve redirect "
     `zlib`_, zlib1g-dev, zlib-devel, "no", "Compression support for httpd"
     `libbrotli`_,,,, "Brotli compression support for httpd"
+    `wslay`_,,,, "WebSockets support in httpd"
     `nghttp2`_, libnghttp2-dev, libnghttp2-devel, "no", "HTTP/2 support for httpd"
 
 .. _ClamAV: https://www.clamav.net/
@@ -161,9 +155,9 @@ Other
 .. _Cyrus SASL Plain: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
 .. _Cyrus SASL MD5: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
 .. _sasl binaries: :ref:`Cyrus SASL <cyrussasl:sasl-index>`
-.. _lmdb: http://lmdb.tech/
 .. _Kerberos: http://web.mit.edu/kerberos/www/
 .. _libbrotli: https://github.com/google/brotli
+.. _libchardet: https://github.com/Joungkyun/libchardet
 .. _libical: https://github.com/libical/libical/
 .. _libxml: http://xmlsoft.org/
 .. _mysql: http://www.mysql.com
@@ -177,10 +171,14 @@ Other
 .. _perl(Pod::POM::View::Restructured): https://metacpan.org/pod/Pod::POM::View::Restructured
 .. _perl-devel: http://www.perl.org/
 .. _postgresql: http://www.postgresql.org/
+.. _python(GitPython): https://github.com/gitpython-developers/GitPython
 .. _python(Sphinx): https://www.sphinx-doc.org/
+.. _shapelib: http://shapelib.maptools.org
+.. _libsrs2: https://www.libsrs2.org/
 .. _tcp_wrappers: ftp://ftp.porcupine.org/pub/security/index.html
 .. _transfig: http://www.xfig.org/
 .. _valgrind: http://www.valgrind.org/
+.. _wslay: https://tatsuhiro-t.github.io/wslay/
 .. _zlib: http://zlib.net/
 .. _xxd: https://github.com/ConorOG/xxd/
 
@@ -197,7 +195,8 @@ Optionally install dependencies for :ref
 Compile Cyrus
 =============
 
-There are additional :ref:`compile and installation steps<imapinstall-xapian>` if you are using Xapian for searching.
+There are additional :ref:`compile and installation steps<imapinstall-xapian>` if you are using Xapian for searching,
+or if you are :ref:`using jmap <developer-jmap>`.
 
 Default build: mail only
 ------------------------
@@ -231,10 +230,10 @@ via configure.
 
 Sieve is enabled by default.
 
-CalDAV and CardDAV
-##################
+CalDAV, CardDAV, JMAP
+#####################
 
-    ``./configure --enable-http --enable-calalarmd``
+    ``./configure --enable-http --enable-calalarmd --enable-jmap``
 
 Murder
 ######
diff -pruN 3.0.13-5/docsrc/imap/developer/cyrusworks.rst 3.2.0-3/docsrc/imap/developer/cyrusworks.rst
--- 3.0.13-5/docsrc/imap/developer/cyrusworks.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/cyrusworks.rst	2020-04-08 00:07:13.000000000 +0000
@@ -5,24 +5,13 @@ Cyrus Works
 About Cyrus Works
 =================
 
-Whenever the Cyrus team push changes to
-`the project repository <https://github.com/cyrusimap/>`_, a notification is
-sent to `Jenkins <https://jenkins.io/>`_ (open source automation server).
-Our Jenkins server is called Cyrus Works and can be found at
-https://www.cyrus.works.
-
-Testing
-=======
-
-Once a week Cyrus.Works builds a complete image, fetching all upstream packages.
-
-Interim builds during the week use the cached weekly image and apply the latest
-Cyrus IMAP code changes from Git.
+`Cyrus Works <https://cyrus.works>`_ is a domain redirection to the Cyrus
+IMAP project's Travis CI dashboard.
 
-Email notifications of build results are sent to the development team.
-
-Cyrus.works will fail is certain strings are found in the log files.  To view results and filter errors/warnings view:
-https://cyrus.works/job/master-jessie/lastFailedBuild/parsed_console/
+Whenever the Cyrus team push changes to
+`the project repository <https://github.com/cyrusimap/>`_, Travis CI
+(via github integration) automatically builds the new commits.  This also
+applies to pull requests submitted through the GitHub site.
 
 How it works
 ============
@@ -31,22 +20,3 @@ How it works
 framework gets pulled in to the
 `Docker Container <https://github.com/cyrusimap/cyrus-docker>`_, confirms
 existing functionality still works and no regression bugs have been introduced.
-
-You can find out more about Cyrus.Works in the `FastMail 2016 advent series blog post <https://blog.fastmail.com/2016/12/14/cyrus-works/>`_.
-
-The code used to build Cyrus.works is available https://github.com/cyrusimap/cyrusworks.
-
-Adding Rules
-============
-
-Instructions on how to add rules:
-https://wiki.jenkins.io/display/JENKINS/Log+Parser+Plugin
-
-The rules for Cyrus Works are stored within git: https://github.com/cyrusimap/cyrusworks/blob/master/Scripts/cyrusworksrules
-
-You need to add rules to two places:
-
-1. **Git**: so when cyrus.works is reinstalled those rules are not lost
-
-2. **The server**: so they’re actually used. Changed pushed to git aren’t pushed to the server. This is for security reasons (we don’t want anyone on the internet to be able to push changes to a live server).
-``root@cyrus.works:/cyrusworks/source/Scripts/cyrusworksrules``
diff -pruN 3.0.13-5/docsrc/imap/developer/developer-testing.rst 3.2.0-3/docsrc/imap/developer/developer-testing.rst
--- 3.0.13-5/docsrc/imap/developer/developer-testing.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/developer-testing.rst	2020-04-24 02:03:00.000000000 +0000
@@ -55,6 +55,7 @@ Install and configure Cassandane
         sudo cpan -i Net::DAVTalk
         sudo cpan -i Net::CardDAVTalk
         sudo cpan -i Net::CalDAVTalk
+        sudo cpan -i Mail::JMAPTalk
         sudo cpan -i Math::Int64
 
 3. Install Cassandane
diff -pruN 3.0.13-5/docsrc/imap/developer/developer-tips.rst 3.2.0-3/docsrc/imap/developer/developer-tips.rst
--- 3.0.13-5/docsrc/imap/developer/developer-tips.rst	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/developer-tips.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,101 +0,0 @@
-.. _cyrus-hacking:
-
-=========================
-Tips for Hacking on Cyrus
-=========================
-
-Memory Allocation
-=================
-
-All Cyrus memory allocation should be done through the ``libcyrus`` functions. These are all written to correctly call fatal() in the event of an out-of-memory condition.
-
-In addition to xmalloc and xrealloc, we provide replacements for strdup, strndup, and a malloc that will guarantee zeroed block of memory (xzmalloc).
-
-If you are going to need to do a large number of small allocations, and then free them all at once, you should look at the memory pool routines, which are much faster, but will leak memory until you free the entire pool at once.
-
-strlcpy vs strncpy vs memcpy
-============================
-
-Use strlcpy when the size of the buffer is known, e.g.::
-
-    char buf[50];
-    strlcpy(buf, src, sizeof(buf));
-
-Use memcpy to truncate a string into a buffer you know is large enough. Note that the resulting buffer will NOT BE NULL TERMINATED.
-
-::
-
-    memcpy(buf, src, 4);  
-    buf[5] = '\0'
-
-Try to avoid strncpy, since it is much slower than memcpy (it zero-fills the rest of the buffer) and isn't as safe as strlcpy.
-
-Use of the functions in this way will reduce the confusion involved in their various behaviours. This avoids things that look like::
- 
-    strncpy(buf, src, sizeof(buf)-1);
-    buf[sizeof(buf)-1] = '\0';
-
-map_refresh and map_free
-========================
-
-In many cases, it is far more effective to read a file via the operating system's mmap facility than it is to via the traditional read() and lseek system calls. To this end, Cyrus provides an operating system independent wrapper around the mmap() services (or lack thereof) of the operating system.
-
-Cyrus currently only supports read-only memory maps, all writes back to a file need to be done via the more traditional facilities. This is to enable very low-performance support for operating systems which do not provide an mmap() facility via a fake userspace mmap.
-
-To create a map, simply call map_refresh on the map (details are in lib/map.h). To free it, call map_free on the same map.
-
-Despite the fact that the maps are read-only, it is often useful to open the file descriptors O_RDWR, especially if the file decriptors could possibly be used for writing elsewhere in the code. Some operating systems REQUIRE file descriptors that are mmap()ed to be opened O_RDWR, so just do it.
-
-Network Functionality
-=====================
-
-Read about :ref:`Cyrus IMAP Prot Layer <admin-protlayer>`.
-
-Authorization modules
-=====================
-
-**TO DO:**
-
-    Describe what the authorization modules do, what API needs to be implemented, etc. Also possibly discuss the auth_pts module.
-
-.. :todo:
-
-    Describe what the authorization modules do, what API needs to be implemented, etc. Also possibly discuss the auth_pts module.
-
-Other
-=====
-
-* Command line apps should link cli_fatal.o so they all fatal() in the same way, unless there is a really good reason they need to do something unique.
-
-* If you call config_init() you must call cyrus_done() before you exit.
-    No one should ever call DB->init() or DB->done() cyrusdb functions except for in libcyrus_init()
-
-* Try to keep #include statements for libcyrus and libimap alphabetical, and below any system includes.
-
-* Don't exit at the bottom of main with exit(x) use return instead.
-    For all the command line utilities that need to be sure that they are running as cyrus, it should be the first thing they do, and they should exit with an appropriate fatal() call
-
-* All services should have a shut_down call. It should be the ONLY way of exiting the application (every "clean" exit from the system should be via shut_down()). fatal() should always make an attempt to call shut_down() if it can (though it should have a recursive fatal() trap just in case). Similarly, commandline utilities probably don't need a shut_down().
-    
-File Locking
-============
-
-In order to guard against deadlocks, we want to maintain 
-the same order of acquiring locks throughout the system 
-(this may be violated in one or two places, but when it is it is 
-commented as to why it is safe). As long as everyone plays 
-by these rules, we can avoid deadlock.
-
-In an ideal world, our locking order is::
-
-    cyrus.header
-    cyrus.index
-    quota
-    seen
-    mailboxes file
-    
-These try to go from least general to most general, so we hold the largest locks for the shortest period of time.
-
-.. todo::
-    http://www.cyrusimap.org/mediawiki/index.php/Cyrus_IMAP_Hacking
-    http://www.cyrusimap.org/mediawiki/index.php/Cyrus_IMAP_File_Locking
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/hacking.rst 3.2.0-3/docsrc/imap/developer/guidance/hacking.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/hacking.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/hacking.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,401 @@
+.. _imap-developer-guidance-hacking:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Hacking
+==========================
+
+This file aims to be a guide to Cyrus coding style/conventions/useful
+utilities for people trying to approach the code in a sane way.  It's
+not well organized right now but hopefully that will improve with time
+;)
+
+Memory Allocation
+-----------------
+
+*   All cyrus memory allocation should be done through the libcyrus
+    functions.  These are all written to correctly call ``fatal()`` in
+    the event of an out-of-memory condition.
+*   In addition to ``xmalloc`` and ``xrealloc``, we provide replacements
+    for ``strdup``, ``strndup``, and a ``malloc`` that will guarantee
+    zeroed block of memory (``xzmalloc``).
+*   If you are going to need to do a large number of small allocations,
+    and then free them all at once, you should look at the memory pool
+    routines, which are much faster, but will leak memory until you
+    free the entire pool at once.
+
+strlcpy vs strncpy vs memcpy
+----------------------------
+
+*   use ``strlcpy`` when you know the size of the buffer, e.g.:
+
+::
+
+    char buf[50];
+    strlcpy(buf, src, sizeof(buf));
+
+*   use ``memcpy`` to truncate a string into a buffer you know is large
+    enough. Note that when you do this the resulting buffer will NOT BE
+    NULL TERMINATED:
+
+::
+
+    memcpy(buf, src, 4);
+    buf[5] = '\0'
+
+*   you should try to avoid ``strncpy``, since it is much slower than
+    ``memcpy`` (it zero-fills the rest of the buffer) and isn't as safe
+    as ``strlcpy``.
+
+*   Use of the functions in this way will reduce the confusion involved
+    in their various behaviors. In other words, this avoids things that
+    look like:
+
+::
+
+    strncpy(buf, src, sizeof(buf)-1);
+
+map_refresh and map_free
+------------------------
+
+*   In many cases, it is far more effective to read a file via the
+    operating system's mmap facility than it is to via the traditional
+    ``read()`` and ``lseek`` system calls.  To this end, Cyrus provides
+    an operating system independent wrapper around the ``mmap()``
+    services (or lack thereof) of the operating system.
+
+*   Cyrus currently only supports read-only memory maps, all writes back
+    to a file need to be done via the more traditional facilities. This
+    is to enable very low-performance support for operating systems
+    which do not provide an ``mmap()`` facility via a fake userspace
+    ``mmap``.
+
+*   To create a map, simply call ``map_refresh`` on the map (details
+    are in lib/map.h).  To free it, call ``map_free`` on the same map.
+
+*   Despite the fact that the maps are read-only, it is often useful
+    to open the file descriptors O_RDWR, especially if the file
+    descriptors could possibly be used for writing elsewhere in the
+    code. Some operating systems REQUIRE file descriptors that are
+    ``mmap()``-ed to be opened O_RDWR, so just do it.
+
+Network Functions
+-----------------
+
+*   Cyrus abstracts socket stream access to a concept we refer to as
+    "prot streams"  Prot Streams take care of all of the necessary
+    SASL and TLS/SSL encryption that may need to happen before data
+    goes out/comes in from the network.  The API is documented in
+    lib/prot.h
+
+(todo) Authorization Modules
+----------------------------
+
+General Hints
+-------------
+
+Some general hints that all made it into my 11/15 16:47 commit that I
+think may be generally useful to people hacking on the cyrus source:
+
+*   Command line apps should link cli_fatal.o so they all fatal()
+    in the same way, unless there is a really good reason they need to
+    do something unique.
+
+*   If you call ``cyrus_init()`` you must call ``cyrus_done()`` before
+    you exit.
+
+*   No one should ever call ``DB->init()`` or ``DB->done()`` cyrusdb
+    functions except for in ``libcyrus_init()``.
+
+*   I've been trying to keep ``#include`` statements for libcyrus and
+    libimap alphabetical, and below any system includes, but this is
+    merely my personal style
+
+*   Don't exit at the bottom of ``main`` with ``exit(x)`` use
+    ``return`` instead.
+
+*   For all the command line utilities that need to be sure that they
+    are running as the cyrus user, it should be the first thing they
+    do, and they should exit with an appropriate ``fatal()`` call.
+
+*   All services should have a ``shut_down`` call.  It should be the
+    ONLY way of exiting the application.  ``fatal()`` should always
+    make an attempt to call ``shut_down()`` if it can (though it should
+    have a recursive ``fatal()`` trap just in case).  Similarly,
+    command line utilities probably don't need a ``shut_down()``.
+
+
+Coding Standards
+----------------
+
+These are the generally agreed upon coding standards as thrashed
+out on the cyrus-devel list in June 2010.
+
+*   Spacing is 4 characters with soft tabs at 8 - mixed tabs and spaces
+    This corresponds to the vi settings `sw=4 sts=4 ts=8` etc.
+
+*   Group the '\*' character with the variable not the type, i.e.
+
+::
+
+    char *foo;  /* correct */
+    char* foo;  /* WRONG */
+
+*   The keywords 'if', 'for', and 'while' take a space after the keyword.
+    The parentheses around the following expression are not closely
+    connected to the expression without any spaces.  The ';' inside
+    the 'for' expression have a space after them and not before.
+    For example:
+
+::
+
+    if (condition)              /* correct */
+    if(condition)               /* WRONG */
+    if( condition )             /* WRONG */
+
+    for (i = 0; i < x; i++)     /* correct */
+    for(i = 0; i < x; i++)      /* WRONG */
+    for (i = 0 ;i < x ;i++)     /* WRONG */
+    for(i = 0 ;i < x ;i++)      /* WRONG */
+
+    while (foo)                 /* correct */
+    while(foo)                  /* WRONG */
+    while( foo )                /* WRONG */
+
+*   Use spaces around the double-character logical operator
+    '||' but don't use spaces around single-character bitwise
+    operator '|'.
+
+::
+
+    int flags = FOO|BAR;        /* correct */
+    int flags = FOO | BAR;      /* WRONG */
+    if (itchy || scratchy)      /* correct */
+    if (itchy||scratchy)        /* WRONG */
+
+*   Function definitions are followed by a brace on a line by itself,
+    all other braces are inline.  Return types are inline with function
+    definition.  Old K&R style function definitions are not allowed.
+
+::
+
+    void thing(int val)         /* correct */
+    {                           /* correct */
+        ...body...
+    }                           /* correct */
+
+    void                        /* WRONG */
+    thing(int val)              /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void                        /* WRONG */
+    thing(                      /* WRONG */
+        int val)                /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void                        /* WRONG */
+    antique(val)                /* WRONG */
+        int val;                /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void thing(int val) {       /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+    void noargs(void)           /* correct */
+    {                           /* correct */
+        ...body...
+    }                           /* correct */
+
+    void noargs()               /* WRONG */
+    {                           /* WRONG */
+        ...body...
+    }                           /* WRONG */
+
+
+*   Long argument lists should be split across multiple lines,
+    with the second and subsequent lines indented so that they
+    line up with the start of the first line of arguments.
+
+::
+
+    void toomanyargs(int arg1, const char *arg2,        /* correct */
+                     struct whatever *arg3, int arg4)   /* correct */
+    {                                                   /* correct */
+        ...body...
+    }                                                   /* correct */
+
+    void toomanyargs(int arg1, const char *arg2,        /* WRONG */
+    struct whatever *arg3, int arg4)                    /* WRONG */
+    {                                                   /* WRONG */
+        ...body...
+    }                                                   /* WRONG */
+
+    void toomanyargs(                                   /* WRONG */
+        int arg1,                                       /* WRONG */
+        const char *arg2,                               /* WRONG */
+        struct whatever *arg3,                          /* WRONG */
+        int arg4)                                       /* WRONG */
+    {                                                   /* WRONG */
+        ...body...
+    }                                                   /* WRONG */
+
+*   Within a function, braces are used in old-fashioned K&R style.
+    Specifically:
+
+    *   open braces are placed at the end of the line containing the
+        statement (such as an 'if') to which they belong, after a
+        single space.
+
+    *   closing braces are placed on a line by themselves, aligned
+        with the start of the statement to which their matching
+        open brace belongs.
+
+    *   this applies even when the closing brace is followed by
+        an 'else' keyword.
+
+..
+
+    Yes, it's ugly and hard to read, but you get used to it and
+    most of the code is currently like that.  Deal with it.
+
+::
+
+    while (cond) {              /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+
+    while (cond){               /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    while (cond) { ...body... } /* WRONG */
+
+    while (cond) {              /* WRONG */
+        ...body... }            /* WRONG */
+
+    while (cond)                /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    while (cond)                /* WRONG */
+      {                         /* WRONG */
+        ...body...              /* WRONG */
+      }                         /* WRONG */
+
+    if (cond) {                 /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+    else if (othercond) {       /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+    else {                      /* correct */
+        ...body...              /* correct */
+    }                           /* correct */
+
+    if (cond) {                 /* WRONG */
+        ...body...              /* WRONG */
+    } else if (othercond) {     /* WRONG */
+        ...body...              /* WRONG */
+    } else {                    /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+    if (cond)                   /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+    else if (othercond)         /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+    else                        /* WRONG */
+    {                           /* WRONG */
+        ...body...              /* WRONG */
+    }                           /* WRONG */
+
+*   The braces around a block used in an 'if'...'else if'...'else'
+    may be omitted if the statement is very simple and clear, such
+    as a single function call.  This is a judgement call though,
+    so play it safe and use braces.
+
+::
+
+    if (cond)                   /* correct, maybe */
+        function();             /* correct, maybe */
+    else                        /* correct, maybe */
+        other_function();       /* correct, maybe */
+
+*   The 'goto' keyword needs to be used very very sparingly and only
+    with forethought.  The only clearly good example is to goto
+    a label at the end of a function to do cleanup under error
+    conditions.
+
+::
+
+    void foo(struct bar *b)     /* correct */
+    {                           /* correct */
+        char *x = xmalloc(...); /* correct */
+
+        if (b == NULL)          /* correct */
+            goto error;         /* correct */
+
+        if (b->quux != 42)      /* correct */
+            goto error;         /* correct */
+
+        ...do useful things...  /* correct */
+    error:                      /* correct */
+        free(x);                /* correct */
+    }                           /* correct */
+
+..
+
+    Very occasionally, it may be permissable to use 'goto' from within
+    a complicated or multiply-nested loop, to the top of a loop, but
+    only if using another control structure is *less* clear.
+
+*   Generally, zero return is SUCCESS and integer return is an error code.
+
+*   Use "``const char *``" where possible.
+
+::
+
+    int is_tacky(const char *name)              /* correct */
+    {                                           /* correct */
+        return !strcmp(name, "britney");        /* correct */
+    }                                           /* correct */
+
+    int is_tacky(char *name)                    /* WRONG */
+    {                                           /* WRONG */
+        return !strcmp(name, "britney");        /* WRONG */
+    }                                           /* WRONG */
+
+*   Use "``struct buf``" for variable length strings where possible.
+
+*   RAII http://en.wikipedia.org/wiki/Resource_Acquisition_Is_Initialization
+    In practice, this means each structure should have a single cleanup
+    function which handles all possible states of the structure and
+    is called whenever the structure needs cleaning up.  Likewise,
+    any resources allocated during a function should be cleaned up
+    in the same function, in a single code block at the end of the
+    function (see the comments on 'goto').
+
+*   If you find yourself passing the same multiple parameters through many
+    functions, create a struct and pass around a pointer to that instead.
+
+*   DON'T EVER REUSE THE SAME VARIABLE FOR TWO DIFFERENT PURPOSES IN THE SAME
+    FUNCTION.  IN FACT, DON'T REUSE THE SAME VARIABLE _NAME_ FOR DIFFERENT
+    PURPOSES.  KTHXBYE.  (note: this doesn't apply to 'i', 'n', etc which are
+    used in multiple loops.  It applies to using the same name for an absolute
+    offset and a "within this mmap" offset though, and it also applies to
+    using the same variable name for native order and network order numbers,
+    which is where I've seen it a few times and been super frustrated!)
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/internationalization.rst 3.2.0-3/docsrc/imap/developer/guidance/internationalization.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/internationalization.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/internationalization.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,386 @@
+.. _imap-developer-guidance-internationalization:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Internationalization
+=======================================
+
+introduction
+------------
+
+Cyrus currently transcodes characters to a canonical UTF-8 form for
+searching. The base spec of IMAP4 only requires understanding multiple
+character sets to properly implement SEARCH. Since the base spec came
+out, several extensions have been proposed that require further charset
+support: SORT, THREAD, and the Sieve subsystem. As of this writing,
+Cyrus doesn't correctly support these other commands.
+
+Cyrus currently only believes in 16-bit characters. Technically, Unicode
+has up to 21-bit characters (expressible in UTF-16 and 3-byte UTF-8) and
+ISO 10646 allows up to 31-bit characters (though ISO's current policy is
+to not allocate any characters outside of the 21-bit Unicode range). The
+lower 16-bit characters make up the basic multilingual plane (BMP) where
+the majority of languages live. This restriction is apparent in
+``charset.c:writeutf8()``, the UTF-8 decoders, and the Unicode
+canonicalization table used by Cyrus. Since Cyrus's known character sets
+(except for UTF-8) don't contain any characters off of the BMP this
+isn't seen to be a major problem.
+
+Throughout this text, Unicode and ISO 10646 will be used interchangeable
+to refer to the 16-bit character set of the BMP, regardless of encoding.
+"Character", unless otherwise specified, refers to a single Unicode
+character ``ffff`` or under.
+
+cyrus canonical form
+--------------------
+
+Since when users search e-mail messages it's much easier for them to
+eliminate false positives than realize there are hits that aren't
+displayed, the Cyrus searching algorithm errs on the side of more
+matches. Before comparing any two strings, Cyrus puts them in a
+canonical form. Logically, the process works as follows:
+
+-  the input string is translated into a sequence of Unicode characters.
+-  each character is transformed into lowercase. (For some characters, a
+   single uppercase character may transform into multiple lowercase
+   characters.)
+-  each character is fully decomposed.
+-  all whitespace (Unicode general categories starting with ``Z``) is
+   removed.
+-  combining diacritical marks, such as the accent on é, are removed.
+   (These are Unicode characters ``0300``-``03ff``.)
+-  certain characters are expanded to alternative spellings using ASCII
+   characters, such as "æ" to "ae".
+-  the output characters are then encoded in UTF-8.
+
+The actual transcoding does all of these steps at once with the aid of
+tables, carefully built at compile-time.
+
+The central part of Cyrus's internationalization support is it's
+transcoding routines in ``lib/charset.[ch]``, and
+``lib/chartable.[ch]``. Cyrus's transcoding routines are very elegant
+and very compact, thus somewhat intimidating. During compilation, Cyrus
+builds up a large number of tables (see `mkchartable <#mkchartable>`__)
+and uses them so that it never has to consider more than a single octet
+at a time while outputting the Cyrus canonical form for an input string.
+
+external interface
+------------------
+
+``lib/charset.h`` is the public interface for Cyrus lib clients to get
+character canonicalization and searching support. In contains the
+following functions:
+
+``char *charset_convert(const char *s, int charset, char *buf, int bufsz)``
+    Given a string *s* in charset *charset*, decode it into canonical
+    form in *buf*. *buf* must be reallocable and currently at least size
+    *bufsz*.
+``char *charset_decode_mimeheader(const char *s, char *buf, int bufsz)``
+    Given a string *s* containing possible MIME encoded substrings (per
+    RFC 2047), decode into canonical form in *buf*. *buf* must be
+    reallocable and currently at least size *bufsz*.
+``charset_index charset_lookupname(const char *name)``
+    Given *name* return the Cyrus charset index. 0 always represents
+    US-ASCII. The returned charset\_index may be saved in a file; it is
+    stable and is an integer. If this version of Cyrus does not support
+    the charset, ``CHARSET_UNKNOWN_CHARSET`` is returned.
+``comp_pat *charset_compilepat(const char *s)``
+    Compiles a NUL-terminated canonicalized string *s* into a
+    Boyer-Moore table for fast searching. I'll describe these `compiled
+    patterns <#comp_pat>`__ later.
+``void charset_freepat(comp_pat *pat)``
+    Frees a pattern previously return by ``charset_compilepat()``.
+``int charset_searchstring(const char *substr, comp_pat *pat,     const char *s, int len)``
+    Searches for a canonicalized string *substr* in the canonicalized
+    string *s*. *s* is of length *len*. *substr* must have been
+    previously compiled into *pat*. Returns non-zero for a hit, zero for
+    no match.
+``int charset_searchfile(const char *substr, comp_pat *pat,                               const char *msg_base, int mapnl, int len,                               charset_index charset, int encoding)``
+    Searches for the canonicalized string *substr* with compiled pattern
+    *pat* in a large buffer starting at *msg\_base* of length *len*. The
+    large buffer is of charset *charset* with the encoding *encoding*.
+    ``charset_searchfile()`` will dynamically unencode and canonicalize
+    the search text looking for *substr*. (If *mapnl* is set, the buffer
+    has only ``\n`` instead of ``\r\n``, but the length assumes that
+    each ``\n`` is dynamically converted to ``\r\n``. This feature is
+    deprecated.)
+``char *charset_decode_mimebody(const char *msg_base, int len,                                      int encoding, char **buf, int *bufsz,                                      int *outlen)``
+    Decode the MIME body part (per RFC 2045) located in the large buffer
+    starting at *msg\_base* of length *len*. The large buffer is of
+    encoding *encoding*. ``charset_decode_mimebody()`` will decode into
+    *buf*. *buf* must be reallocable and currently at least size
+    *bufsz*. The number of decoded bytes is returned in *outlen*.
+``charset_extractfile()``
+    Used by ``squatter`` and possibly other text indexing engines, but
+    not described here.
+
+the TRANSLATE macro: using the transcoding tables
+-------------------------------------------------
+
+The external interface is implemented with the help of the ``START`` and
+``TRANSLATE`` macros:
+
+``void START(struct decode_state *state, const unsigned char (*table)[256][4])``
+    ``START`` initializes *state* to be ready for transcoding of the
+    charset translation table given with *table*. The starting active
+    table is always the first one in the list passed in.
+``void TRANSLATE(struct decode_state *state, unsigned char input, unsigned char *outbuf, unsigned outindex)``
+    ``TRANSLATE`` takes four parameters: *state* is the current state of
+    the translation; it must have been initialized with ``START`` and is
+    modified by ``TRANSLATE``; *input* is one octet of input from the
+    stream to be transcoded; *outbuf* is a pointer to the start of the
+    buffer to write output characters; *outindex* is the index where
+    this translation should be written. The size of *outbuf* must be at
+    least *outindex + charset\_max\_translation*.
+
+Each charset consists of a set of one or more tables; the *table*
+parameter passed into ``START`` is the first of these tables and the
+others are adjacent in memory. Characters are transcoded by indexing
+into the active table with *input* and examining the 4 octet
+translation. The 4 octet translation may consist of 0–3 character
+translations followed by a control code or a series of control codes. In
+effect, the translation for a given octet is a mini-program that
+consists either of UTF-8 octets or control codes. One of the control
+codes RET, END, JSR, or JMP must occur in the 4 octet translation.
+
+control codes
+~~~~~~~~~~~~~
+
+Control codes are represented by uppercase US-ASCII characters since no
+uppercase characters can appear in the output translation (recall that
+Cyrus canonical form downcases). Any uppercase US-ASCII character
+(``[A .. Z]``) is thus interpreted specially by the ``TRANSLATE``
+virtual machine. Any other octet encountered as an output translation is
+presumed to be part of the UTF-8 output sequence and copied to the
+output.
+
+The names of control codes are actually C pre-processor defines to
+uppercase US-ASCII characters. As the mnenomics are easier to
+understand, I use them in discussing their semantics.
+
+control code reference
+~~~~~~~~~~~~~~~~~~~~~~
+
+``TRANSLATE`` recognizes the following "normal" control codes:
+
+XLT
+    This is the first octet of the four octet sequence, indicating that
+    the desired translation is larger than 3 UTF-8 octets. The next two
+    octets represent an offset to look up in the special
+    chartables\_long\_translations[] table. After that translation is
+    copied to the outbuf, the final octet is interpreted (it must be
+    either a RET or an END).
+JSR
+    The ``TRANSLATE`` virtual machine has a stack, fixed at size 1. A
+    JSR copies address of the current active table to the stack and
+    transitions to the active table given by the next two octets. (For
+    instance, table 1 would be the next table after the table given as a
+    parameter to ``START``.) Translation of the current octet stops
+    after encountering a JSR.
+
+    JSRs are useful for converting a two octet input character: the
+    first octet in the character will make a JSR to some table; the
+    second octet will produce a translation and RET to the current
+    table.
+
+    Since the virtual machine has a fixed size stack, it would be highly
+    unusual for the virtual machine to encounter two different JSRs
+    without an intervening RET.
+
+JMP
+    Similar to JSR, but does not change the stack. It is the equivalent
+    of a goto. JMPs are useful to deal with modal input character sets
+    (such as an escape in ISO-2022-JP, see `how the tables are
+    generated <#mkchartable>`__).
+RET
+    Indicates that we are done translating this input octet and we
+    should return to the previous active table. It might appear as the
+    first of the 4 translation octets, in which case this input
+    character translates into nothing (it might be whitespace, for
+    instance).
+END
+    Indicates we are done translating this input octet. When
+    ``TRANSLATE`` is next called, that input octet will be interpreted
+    against the current active table; the stack does not change.
+
+In addition, it recognizes the following "special" control codes for
+charsets that aren't easily represented by a set of tables, UTF-8 and
+UTF-7:
+
+U7F
+    UTF-7 consists of US-ASCII characters and a special escape character
+    that indicates a transition to base-64 encoded UTF-16 characters.
+    The virtual machine has built in code to handle the base64 decoding.
+    In UTF-7's base64, 8 input octets result in 3 characters, so the
+    tables would be rather large.
+U7N
+    This indicates that the current octet is the continuation of the
+    base-64 section.
+U83
+    One and two character UTF-8 sequences are handled normally in the
+    charset code. To keep the table size down, 3 octet sequences are
+    handled specially. U83 indicates that the current input octet is the
+    start of a three character sequence. It is also an implicit jump to
+    the 2nd table in the UTF-8 sequence, ending this translation.
+U83\_2
+    This input octet 2nd of 3-octet UTF-8 input, with an implicit jump
+    to the 3rd table.
+U83\_3
+    3rd octet of a 3-octet UTF-8 input. This produces the output
+    characters and has an implicit jump to the 1st table of UTF-8.
+
+Finally, it's useful to mention the special character ``EMPTY`` which is
+guaranteed not to match any character. It is also represented by an
+uppercase US-ASCII character.
+
+searching and compiled patterns
+-------------------------------
+
+boyer-moore
+~~~~~~~~~~~
+
+brief description of boyer-moore xxx
+
+cyrus implementation
+~~~~~~~~~~~~~~~~~~~~
+
+why two arrays? us-ascii optimization, really kinda useless now xxx
+
+meta-data stored at the end xxx
+
+generating the tables: ``mkchartable``
+--------------------------------------
+
+The program ``mkchartable`` is used to generate the charset transcoding
+tables used by TRANSLATE. These tables are carefully constructed so no
+more than a single octet need be examined at a time; this octet results
+in either an output stream of UTF-8 characters being generated or some
+sort of state change.
+
+``mkchartable`` uses three different sorts of input files to generate
+these tables. These files are located in the ``lib/charset`` directory.
+
+charset tables
+~~~~~~~~~~~~~~
+
+Each charset file maps a single charset to the corresponding Unicode
+characters. For the US-ASCII and ISO-8859-x character sets this is
+trivial: each input byte corresponds to a single Unicode character.
+(Actually, some ISO-8859-x octets do not map to any Unicode character.
+In that case, the file either does not contain that octet or map it to
+"``????``".)
+
+Other character sets are trickier. For instance, GB-2312 has both single
+and double byte characters, but is still a simple map from input
+character to output character. More complicated are modal character
+encodings. For instance, ISO-2022-JP starts in US-ASCII mode and uses
+``1B`` as an escape character followed by another two characters to
+select a new mode.
+
+The input charset labels modes with "``:``" followed by the mode name.
+The starting mode "``US-ASCII``" in ISO-2022-JP is preceded by
+"``:US-ASCII``". Mode transitions are denoted by a Unicode conversion of
+"``>newmode``" or "``:newmode``". To denote that the octet ``42``
+transitions into the "``US-ASCII``" mode, the charset file has
+"``42 >US-ASCII``". The mode names themselves are arbitrary labels and
+have no effect on the output.
+
+The input charset labels modes with ":" followed by the mode name. The
+mode name is optionally followed by a space and the "``<``" character.
+If the "``<``" character is present, then all translations will be
+followed by a RET instruction instead of an END instruction.
+
+The transition "``>newmode``" results in a JSR instruction being
+generated. A JMP instruction is generated by a transition of
+"``:newmode``".
+
+The input byte can be specified as "``*``". This is used to define the
+"default action" which is used for input bytes that are not otherwise
+defined for the mode. If the default action is not explicitly stated, it
+is a translation to EMPTY.
+
+unicode data table
+~~~~~~~~~~~~~~~~~~
+
+The ``unidata2.txt`` file is verbatim from the Unicode standard. More
+recent versions should be available `from their
+website <http://www.unicode.org/xxx>`__. Each entry in the file
+describers a Unicode character by the following properties, separated by
+semicolons:
+
+-  code point (16-bit character value) in hex
+-  character name (unused by Cyrus)
+-  general category, such as whitespace or punctuation
+-  the canonical combining class (unused)
+-  bidirection category (unused)
+-  character decomposition
+-  decimal digit value (unused)
+-  digit value (unused, and, no, I don't know the difference)
+-  numeric value including fractions (unused)
+-  mirrored character (unused)
+-  Unicode 1.0 name (unused)
+-  comment (unused)
+-  upper case equivalent (unused)
+-  lower case equivalent
+
+In general, Cyrus uses the lower case equivalent if there is one, and
+the decomposed value otherwise.
+
+unicode fixup table
+~~~~~~~~~~~~~~~~~~~
+
+The ``unifix.txt`` file contains Cyrus-specific mappings for characters.
+It overrides the ``unidata2.txt`` table. Each rule in the file is
+explained with a comment. It's helpful to remember that the Unicode
+general categories starting with ``Z`` represent whitespace, and
+whitespace is always removed.
+
+generating ``chartable.c``
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+how ``mkchartable`` works: collapses the encoding modes, the unicode
+translations, and other normalizations into the output tables described
+above xxx
+
+for the future
+--------------
+
+Sieve/ACAP comparators
+~~~~~~~~~~~~~~~~~~~~~~
+
+adjustable normalization?
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The use of uppercase US-ASCII characters is one of the annoyances in
+trying to generalize the charset transcoding. If we continue to restrict
+the characters under consideration to the BMP, switching to UTF-8
+control codes that start 4 or 5 byte sequences is possible.
+
+Another possibility is to use a NUL character as an escape sequence,
+though this increases the size of each control code by 1 octet.
+
+handle >2 octet input characters
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+make UTF-8 more regular
+~~~~~~~~~~~~~~~~~~~~~~~
+
+consider whether we really need U83, U83\_2, U83\_3. also consider
+changing ``{ U83, 0, 0, 0 }`` translations to ``{ U83, JMP, 0, 1 }``
+sequences to at least eliminate the implicit jump.
+
+require minimal UTF-8 characters
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+references
+----------
+
+xxx
+
+-  [UNICODE] Unicode / ISO 10646
+-  [UTF-8] utf-8 RFC
+-  [UTF-7] utf-7 RFC
+-  [BM] boyer-moore
+-  [ACAP] the comparators reference. see section XXX of RFC 2244.
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/locking.rst 3.2.0-3/docsrc/imap/developer/guidance/locking.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/locking.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/locking.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,92 @@
+.. _imap-developer-guidance-locking:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Locking
+==========================
+
+Mailboxes
+---------
+
+For mailboxes, we lock in this order:
+
+*   Mailbox Namelock (shared) <== possibly reversible with
+    conversationsdb
+*   user conversations db
+*   cyrus.index
+
+If you want to do any mailboxes.db transactions, they need to open
+and close without changing any mailbox locking during the transaction.
+
+Likewise seen and statuscache are always done without changing mailbox
+locking during their transaction.
+
+Annotations databases are a mess.
+
+Xapian
+------
+
+*   Xapian per-user NAMELOCK (shared or exclusive)
+*   xapianactive file lock (shared or exclusive)
+
+Shared namelock holds the following invariants:
+
+*   xapianactive file contents are not changed
+*   directories mentioned in xapianactive are not cleaned up
+
+Xapianactive exclusive lock holds the following invariants:
+
+*   owner may write to first database mentioned in xapianactive
+
+Xapianactive shared lock holds:
+
+*   all databases in xapianactive are readable and a consistent
+    read can be made across all of them, even with multiple requests
+    while the lock is held.
+
+
+Locking orders
+++++++++++++++
+
+SHARED case:
+
+*   user conversations db <=== possibly reversible with SHARED xapian
+    namelock
+*   SHARED xapian namelock
+*   xapianactive lock (shared to search, exclusive to write)
+*   cyrus.index may be locked either side of the xapianactive lock,
+    because the conversationsdb lock protects it from races.
+
+EXCLUSIVE case:
+
+*   EXCLUSIVE xapian namelock
+    That's it.  While you've got this, you can add or delete items from
+    the xapianactive file, and delete paths on disk for directories
+    that you have removed (either during or after locking).  No other
+    locks are permitted.
+
+
+If you hold a SHARED xapian namelock, you may write to a .NEW folder
+for a xapianactive entry that you created without taking any additional
+locks, because nothing can clean it under you, and nothing else can
+read it.  This is how the repack case works.
+
+Lock lifetime
+-------------
+
+*   Shared mailbox namelock:
+    *   possibly hours
+*   conversations db and below
+    *   short as possible
+
+Mailbox namelock holds the following invariants:
+
+*   cyrus.index may not be repacked, however flags and modseqs may be
+    updated
+*   cyrus.annotations records may change (kind of buggy and bad,
+    ideally we'd always write new ones if we changed them and keep the
+    old ones)
+*   cyrus.cache may be appended, but never changed
+*   spool files may not be deleted (already can't be changed)
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/mailbox-format.rst 3.2.0-3/docsrc/imap/developer/guidance/mailbox-format.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/mailbox-format.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/mailbox-format.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,497 @@
+.. _imap-developer-guidance-mailbox-format:
+
+Cyrus IMAP Server: Mailbox File Formats
+=======================================
+
+Intro
+-----
+
+This documentation refers to the "version 12" cyrus index format and
+associated mailbox files.
+
+No external tools should make use of this information. The only
+supported method of access to the mail store is through the standard
+interfaces: IMAP, POP, NNTP, LMTP, etc.
+
+A cyrus mailbox is a directory in the filesystem. It contains the
+following files:
+
+-  zero or more message files
+-  the ``cyrus.header`` metadata file
+-  the ``cyrus.index`` metadata file
+-  the ``cyrus.cache`` metadata file
+-  zero or one ``cyrus.squat`` search indexes
+-  zero or more subdirectories
+
+With "split metadata" configuration, the mailbox may actually be split
+between multiple disks, with the files being in the same relative
+directory on the meta disk. See the ``imapd.conf`` option
+``metapartition_files`` for more information
+
+Message Files
+-------------
+
+The message files are named by their UID, followed by a ".", so UID 423
+would be named "``423.``". They are stored in wire-format: lines are
+terminated by CRLF and binary data is not allowed.
+
+``cyrus.header``
+----------------
+
+This file contains mailbox-wide information that does not change often.
+Its format:
+
+::
+
+    <Mailbox Header Magic String>
+    <Quota Root>\t<Mailbox Unique ID String>\n
+    <Space-separated list of user flags>\n
+    <Mailbox ACL>\n
+
+The Mailbox Unique ID String is used for non-owner per-user \\Seen flags
+so they remain with the mailbox during renames, and also by the
+replication subsystem to detect mailbox renames.
+
+The ACL is a copy of the value stored in mailboxes.db, and isn't
+actually used.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+The ``cyrus.index`` file must be locked in exclusive mode while making
+changes to the ``cyrus.header`` file to ensure consistency. All changes
+are made by rewriting the entire file and renaming the new version into
+place.
+
+``cyrus.cache``
+---------------
+
+The ``cyrus.cache`` file is a pure cache of information that's also
+present in the message files. It exists to make ENVELOPE and specific
+header fetches more efficient, as well as to assist with searches and
+sorts.
+
+If a ``cyrus.cache`` file is missing or corrupted, it can be
+re-generated by running a ``reconstruct`` on the mailbox.
+
+The format is 10 individual records each prefixed with a 32 bit length
+value in network byte order. The offset of each message's cache record
+is stored in the ``cyrus.index`` file (documented below). The records in
+a cyrus.cache file are of variable length, depending on the contents of
+the associated message.
+
+The first 4 bytes of the cyrus.cache file are a "generation number"
+which must match the first 4 bytes of the associated cyrus.index file.
+In the past this was used to track consistency between the files, but
+the name locking scheme and per-record CRC check in cyrus 2.4 and above
+means this is just a backup consistency check rather than an essential
+format feature.
+
+::
+
+    +------------------------------------------------------------------------+
+    |Gen # (32bits)|Size 1 (32bits)|Data 1                                   |
+    +------------------------------------------------------------------------+
+    |           |Size 2 (32bits)|Data 2            |Size 3 (32bits)| Data 3  |
+    +------------------------------------------------------------------------+
+    | .....                                                                  |
+    +------------------------------------------------------------------------+
+
+While there are occasional changes to the cache format, this information
+is NOT stored in the cyrus.cache file. Instead, there is a
+"cache\_version" field in the cyrus.index record, so multiple different
+versions of cache data may exist in the same cache file.
+
+The order of fields per record in the cache file is as follows: (keep in
+mind that they are all preceded by a 4 byte network byte order size).
+
+Envelope Response
+    Raw IMAP response for a request for the envelope.
+Bodystructure Response
+    Raw IMAP response for a request for the bodystructure.
+Body Response
+    Raw IMAP response for an (old style) request for the body.
+Binary Bodystructure
+    Offsets into the message file to pull out various body parts.
+    Because of the nature of MIME parts, this is somewhat recursive.
+
+    This looks like the following (starting the octet following the
+    cache field size). All of the fields are bit32s.
+
+    ::
+
+          [
+           [Number of message parts+1 for the rfc822 header if present]
+           [
+            [Offset in the message file of the header of this part]
+            [Size (octets) of the header of this part]
+            [Offset in the message file of the content of this part]
+            [Size (octets) of the content of this part]
+            [Encoding Type of this part]
+           ]
+              (repeat for each part as well as once for the headers)
+           [zero *or* number of sub-parts in the case of a multipart.
+            if nonzero, this is a recursion into the top structure]
+              (repeat for each part)
+          ]
+
+    Note if this is not a message/rfc822, than the values for the sizes
+    of the part 0 are -1 (to indicate that it doesn't exist). Sub-parts
+    are not possible for a part 0, so they aren't included when finding
+    recursive entries.
+
+    The offset and size info for both the mime header and content part
+    are useful in order to do fast indexing on the appropriate parts of
+    the message file when a client does a FETCH request for
+    BODY[HEADER], or BODY[2.MIME].
+
+    Note that the top level RFC822 headers are a treated as a separate
+    part from their body text ("0" or "HEADER").
+
+    In the case of a multipart/alternative, the content size & offset
+    refers to the size of the entire mime part.
+
+    A very simple message (with a single text/plain part) would
+    therefore look like:
+
+    ::
+
+          [[2][rfc822 header][text/plain body part info][0]]
+
+    A simple multipart/alternative message might look like:
+
+    ::
+
+          [[3][rfc822 header][text/plain message part info]
+              [second message part info][0][0]]
+
+    A message with an attachment that has two subparts:
+
+    ::
+
+          [[3][rfc822 header info][rfc822 first body part info][attachment info][0][
+                [3][NIL header info][sub part 1 info][sub part 2 info][0][0]]]
+
+    A message with an attached message/rfc822 message with the following
+    total structure:
+
+    ::
+
+            message/rfc822
+              0 headers; content-type: multipart/mixed
+              1 text/plain
+              2 message/rfc822
+                0 headers; content-type: multipart/alternative
+                1 text/plain
+                2 text/html
+
+    ::
+
+          [[3][rfc822 header part 0][text/plain part 1][overall attachment info][0][
+               [3][rfc822 header part 2.0][text/plain part 2.1][text/html part 2.2]
+                  [0][0]]]
+
+Cache Header
+    Any cached header fields. The exact set of fields here depends on
+    the cache record version - there is a function in ``imap/mailbox.c``
+    to determine if a named header would be cached based on the version.
+    These are in the same format they would appear in the message file:
+
+    ::
+
+          HeaderName: headerdata\r\n
+
+    Examples include: References, In-Reply-To, etc.
+
+From
+    The from header.
+To
+    The to header.
+Cc
+    The CC header.
+Bcc
+    The BCC header.
+Subject
+    The Subject header.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+The ``cyrus.index`` file must be locked in exclusive mode while making
+changes to the ``cyrus.cache`` file to ensure consistency. All new cache
+records are created by reading the current end-of-file offset, appending
+the new cache record, and storing that start offset into the associated
+cyrus.index record.
+
+``cyrus.index``
+---------------
+
+The cyrus.index file is NOT just a cache - it stores information not
+present in the message file!
+
+The cyrus.index file consists of a fixed width header, followed by fixed
+width records. In the past, it would be rewritten on every expunge, but
+since Cyrus 2.4 the expunged records remain in the cyrus.index file for
+a configurable time to support QRESYNC and more efficient delayed
+expunge.
+
+The cyrus.index file is the "heart" of the mailbox format - containing
+checksums (CRC32) of everything else, and the most frequently updated
+fields. All fields are stored in network byte order and aligned on 4
+byte boundaries. Due to some 64 bit values being stored, the header and
+individual records are aligned on 8 byte boundaries.
+
+The overall format looks sort of like this:
+
+::
+
+    cyrus.index:
+    +----------------+
+    | Mailbox Header |
+    +----------------+
+    | Msg: Num 1     |
+    +----------------+
+    | Msg: Num 2     |
+    +----------------+
+    |     ...        |
+    +----------------+
+
+The basic idea being that there is one header, and then all the message
+records are evenly spaced throughout the file. All of the message
+records are at well-known offsets, making any part of the file
+accessable at roughly equal speed.
+
+Locking Considerations
+~~~~~~~~~~~~~~~~~~~~~~
+
+``cyrus.index`` files can not be repacked (i.e. records can not change
+UID for a particular offset, and the file can't be rewritten or deleted)
+unless there's an exclusive namelock held for the mailbox name. This is
+to avoid race conditions and simplify the use of mailboxes. Whenever a
+mailbox is opened, the caller holds a shared namelock on the mailbox
+name for the duration of the "mailbox object"'s existence.
+
+All reads of a ``cyrus.index`` file must be done with a lock held, and
+all writes must be done with an exclusive lock held. This ensures CRC32
+checksums of individual headers and records are always consistent. There
+are no direct "offset" reads done any more, instead the mailbox API
+provides a way to read an entire cyrus.index header or cyrus.index
+record into a struct, performing consistency checks. Writes are also
+done with a complete record struct.
+
+Detail of ``cyrus.index`` header
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The index header contains the following information, in order:
+
+Generation Number (4 bytes)
+    A number that is basically the "revision number" of the mailbox. It
+    must match between the cache and index files. This is to ensure that
+    if we fail to sync both the cache and index files and a crash
+    happens (so that only one is synced), we do not provide bad data to
+    the user. This is also backed by having individual cache checksums
+    on each record.
+Format (4 bytes)
+    Basically obsolete (indicates netnews or regular).
+Minor Version (4 bytes)
+    Indicates the version number of the index file. This can be used for
+    on-the-fly upgrades of the index and cache files.
+Start Offset (4 bytes)
+    Size of index header.
+Record Size (4 bytes)
+    Size of an index record.
+Num Records (4 bytes)
+    How many records are in this index (including records for expunged
+    records. See below for "Exists" which has moved from pre-version 12
+    files.
+Last Appenddate (4 bytes)
+    (time\_t) of the last time a message was appended
+Last UID (4 bytes)
+    Highest UID of all messages in the mailbox (UIDNEXT - 1).
+Quota Mailbox Used (8 bytes)
+    Total amount of storage used by all of the messages in the mailbox.
+    Platforms that don't support 64-bit integers only use the last 4
+    bytes.
+POP3 Last Login (4 bytes)
+    (time\_t) of the last pop3 login to this INBOX, used to enforce the
+    "poptimeout" ``imapd.conf`` option.
+UIDvalidity (4 bytes)
+    The UID validitiy of this mailbox. Cyrus currently uses the
+    ``time()`` when this mailbox was created.
+Deleted, Answered, and Flagged (4 bytes each)
+    Counts of how many messages have each flag.
+Mailbox Options (4 bytes)
+    Bitmask of mailbox options, consisting of any combination of the
+    following:
+
+    POP3\_NEW\_UIDL
+        Flag signalling that we're using "*uidvalidity*.\ *uid*" instead
+        of just "*uid*" for the output of the POP3 UIDL command.
+    IMAP\_SHAREDSEEN
+        Flag signalling that we're supporting a shared \\Seen flag on
+        the mailbox.
+    IMAP\_DUPDELIVER
+        Flag signalling that we're allowing duplicate delivery of
+        messages to the mailbox, overriding system-wide duplicate
+        suppression.
+    MAILBOX\_NEEDS\_REPACK
+        Flag signalling that the mailbox is due to be repacked. During
+        mailbox\_close() every process will attempt to take an exclusive
+        namelock on the mailbox and repack.
+    MAILBOX\_DELETED
+        Flag signalling that the mailbox is deleted. This can be set
+        with a shared namelock, and indicates to all other users of the
+        mailbox that they need to close it and attempt cleanup. The last
+        process to close the mailbox will perform the final cleanup
+        under an exclusive namelock, giving the other processes a chance
+        to finish their current operation first without files
+        disappearing from under them!
+
+Leaked Cache (4 bytes)
+    Number of leaked records in the cache file.
+Highest ModSeq (8 bytes)
+    Highest Modification Sequence of all the messages in the mailbox
+    (CONDSTORE).
+Deleted ModSeq (8 bytes)
+    Lowest Modification Sequence before which expunged message data may
+    have been purged from the mailbox and forgotten (CONDSTORE/QRESYNC
+    support).
+Exists (4 bytes)
+    See NumRecords above. This is the count of non-expunged records in
+    the mailbox and corresponds to the IMAP status item "EXISTS".
+First Expunged (4 bytes)
+    lowest modified time of an expunged message in this mailbox (or zero
+    if there are no expunged messages) - used to determine if the
+    mailbox needs repacking.
+Last Repack Time (4 bytes)
+    a timestamp for the last repack, to ensure repacks aren't done too
+    close together if expunges were closely spaced
+Header File CRC (4 bytes)
+    CRC32 value of the bytes in the ``cyrus.header`` file for this
+    mailbox. Must be rewritten whenever the cyrus.header file is changed
+    (see locking considerations above - this is why the cyrus.index must
+    be exclusively locked!)
+Sync CRC (4 bytes)
+    An XOR of the CRC32 of a specially generated value for each of the
+    non-expunged records in this mailbox. This is a cached value which
+    allows the replication subsystem to quickly determine that all
+    non-expunged records in a mailbox are in sync and detect possible
+    "split brain" scenarios with low bandwidth use.
+Recent UID (4 bytes)
+    The highest UID last time an IMAP client logged in as the mailbox
+    owner (or anybody if SHAREDSEEN is enabled) selected this mailbox.
+    Used to generate the \\Recent flags in IMAP
+Recent Time (4 bytes)
+    Used for consistency with the seen\_db code, but probably not
+    actually necessary. Oh well
+Header CRC (4 bytes)
+    Must always be the LAST record of the header. This is the CRC32 of
+    the actual bytes on disk (network order format) for the rest of the
+    cyrus.index. By keeping it last, it can be easily calculated with
+    the following snippet of code:
+    ``crc = crc32_map(buf, OFFSET_HEADER_CRC);`` - i.e. crc32 from the
+    start of the buffer to just before this field.
+
+There are also spare fields in the index header, to allow for future
+expansion without forcing an upgrade of the file, and to round up to be
+divisible by 8 bytes.
+
+Detail of ``cyrus.index`` records
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+These records start immediately following the ``cyrus.index`` header,
+and are all fixed size. They are in-order by uid of the message.
+
+UID (4 bytes)
+    UID of the message
+INTERNALDATE (4 bytes)
+    INTERNALDATE of the message (where possible, this matches the
+    creation and modification times of the file on disk to help
+    reconstruct in the event of data loss)
+SENTDATE (4 bytes)
+    Contents of the Date: header chomped to day resolution with timezone
+    stripped.
+SIZE (4 bytes)
+    Size of the whole message (in octets)
+HEADER SIZE (4 bytes)
+    Size of the message header (in octets)
+GMTIME (4 bytes)
+    Contents of the Date: header at 1 second resolution and converted to
+    GMT (for sort)
+CACHE\_OFFSET (4 bytes)
+    Offset into the ``cyrus.cache`` file for the beginning of this
+    message's cache entry.
+LAST UPDATED (4 bytes)
+    (time\_t) of the last time this record was changed
+SYSTEM FLAGS (4 bytes)
+    Bitmask showing which system flags are set/unset
+USER FLAGS (MAX\_USER\_FLAGS / 32 bytes)
+    Bitmask showing which user flags are set/unset (bits correspond to
+    positions in the cyrus.header flag list, i.e. (1<<0) == the flag
+    name
+CONTENT\_LINES (4 bytes)
+    Number of text lines contained in the message content (body).
+CACHE\_VERSION (4 bytes)
+    Indicates the version number of the cache record for the message
+    (determines which headers are cached, see list in mailbox.c).
+GUID (MESSAGE\_GUID\_SIZE bytes)
+    Globally Unique IDentifier of the message (used by replication
+    engine). This is the sha1 value of the bytes as stored on disk.
+MODSEQ (8 bytes)
+    Modification Sequence of the message (CONDSTORE).
+CACHE\_CRC (4 bytes)
+    This is the CRC32 of all the bytes of the cache record (all 10
+    fields) as stored on disk. Again, calculated over the exact bytes
+    stored in the ``cyrus.cache`` file.
+RECORD\_CRC (4 bytes)
+    Like the header CRC - this is the CRC32 of all the bytes in on-disk
+    order that exist in this record. Records are always rewritten as the
+    entire record, including the updated CRC, so it's always consistent
+    if you have a lock on the ``cyrus.index`` file, because writers will
+    wait until they get an exclusive lock to make modifications.
+
+Notes
+-----
+
+-  Expunge is super quick now - it's just a flag update!
+-  Append is relatively fast (it only adds to the end of both the cache
+   and index files and modifies the index header)
+-  Message unlinks always happen during the "close" phase - which may be
+   noticed when you select another mailbox, but otherwise are delayed
+   from the actual action. With delayed expunge, the unlinks are pushed
+   off to cyr\_expire which is a background task, and will never be
+   noticed by the user.
+-  Message delivery is something like this:
+
+   #. write/sync message file
+   #. write/sync new ``cyrus.cache`` record
+   #. write/sync new ``cyrus.index`` record
+   #. calculate, write, sync new ``cyrus.index`` header
+   #. acknowledge message delivery
+
+   The message isn't delivered until the new index header is written. In
+   case of a crash before the new index header is written, any previous
+   writes will be overwritten on the next delivery (and will not be
+   noticed by the readers).
+
+   Note that certain power failure situations (power failure in the
+   middle of a disk sector write) could cause a mailbox to need
+   reconstruction (possibly even losing some flag state). These failure
+   modes are not possible in the "Hardware RAID disk model" (which we
+   will describe somewhere else when we get around to it).
+
+Future considerations
+---------------------
+
+-  Cache all header fields? (or all up to Xk?) This could greatly
+   improve speeds of clients that just ask for everything, but also
+   increases the expense of rewriting the cache file (as well as the
+   size it takes on disk).
+-  Reformat cache file to use a
+   (size)(size)(size)(size)(data)(data)(data) format. This makes
+   accesses anywhere in the cache file equally fast, as opposed to
+   having to iterate through all the entires for a given message to get
+   to the last one. Note that either way is still O(1) so maybe it
+   doesn't matter much.
+-  It would be useful to store a uniqueid -> mailbox name index, so that
+   we could fix arbitron again.
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/namelocks.rst 3.2.0-3/docsrc/imap/developer/guidance/namelocks.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/namelocks.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/namelocks.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,102 @@
+.. _imap-developer-guidance-namelocks:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Namelocks
+============================
+
+Intro
+-----
+
+Name locks are an addition to the cyrus internals to address a range of
+race conditions and complexities. These ills are most easily avoided by
+ensuring that only one process can do certain operations at once. Name
+locks also mean crashes can't leave the mailbox "broken" forever.
+
+Unfortunately, locks can't be retained over a rewrite-rename cycle, and
+every meta file in a regular mailbox gets rewritten upon occasion. Even
+cyrus.header gets a rewrite when a new userflag is added.
+
+The "RESERVED FLAG" method of handling mailbox creation is a nasty
+brutish method that breaks on process crashes, causing a full
+mailboxes.db sweep to be necessary on restart, and making that name
+unusable until the entire server is restarted. It's also unusable for
+serialisation of operations without making the mailbox "disappear" to
+other clients.
+
+Mailbox names are supposed to be exclusive per server, not just per
+partition, so any lock has to apply to the entire server.
+
+**MURDER Considerations:** Due to the way the mupdate protocol works,
+RESERVED records are still created over mupdate. This sucks, and a
+better way would be to support an "EXCLUSIVE CREATE" command, where the
+create only succeeds if the record doesn't already exist. Then a task
+could create the mailbox on the local server and retain an exclusive
+namelock while trying to assert the name on the mupdate server. If this
+failed (someone else got in first) then the mailbox could be cleaned up
+locally before releasing the exclusive namelock, meaning other users on
+the local server would never see it existing.
+
+Implementation
+--------------
+
+It's a simple matter of having a file under $configdirectory/lock - in a
+directory tree using the same hashing structure as the mailbox tree.
+This directory can be symlinked or mounted to a tmpfs since the locks
+need not persist across restarts. Due to race conditions while cleaning
+up, the easiest approach is to only ever delete lock files during
+restart, so the unlock code doesn't try to remove them. Lock files are
+zero byte in size, and are locked using the flock or fcntl primitives
+used by the rest of cyrus.
+
+API
+---
+
+Lock types:
+
+-  LOCK\_SHARED - shared lock on the name. Required whenever you have an
+   open mailbox with that name
+-  LOCK\_EXCLUSIVE - exclusive lock on the name. Required to create or
+   finish deleting a mailbox, and required when repacking the
+   cyrus.index and cyrus.cache files.
+-  LOCK\_NONBLOCKING - attempt to take an exclusive lock on the name,
+   but if it's not available, return immediately with r ==
+   IMAP\_MAILBOX\_LOCKED rather than blocking until the lock is
+   available.
+
+The ``mboxname`` is always an **internal name**, so convert it first.
+
+Example:
+~~~~~~~~
+
+::
+
+    struct mboxlock *lock = NULL;
+    int locktype = LOCK_SHARED; /* or LOCK_EXCLUSIVE or LOCK_NONBLOCKING */
+
+    r = mboxname_lock("user.brong", &lock, locktype);
+    if (!r) {
+        do_stuff();
+        mboxname_release(&lock);
+    }
+
+If mboxname\_lock fails, lock will remain NULL. It should always be
+initialised to NULL before being passed to mailbox\_lock. It will be set
+back to NULL by mboxname\_release.
+
+Re-locking considerations
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+It is not possible to hold multiple locks to the same name within the
+same process. If you call mboxname\_lock with the same name within a
+process, and the **same locktype** then a reference counter is
+incremented and the same lock is returned. If you use a **different
+locktype** (i.e. one shared, the other exclusive. Non-blocking is
+considered exclusive for this test) then IMAP\_MAILBOX\_LOCKED will be
+returned to avoid breaking the locking semantics. This is a restriction
+of the underlying fcntl/flock subsystem.
+
+On the way out, the reference counter is decremented with each release
+and the lock isn't freed until the counter gets back to zero.
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/prot.rst 3.2.0-3/docsrc/imap/developer/guidance/prot.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/prot.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/prot.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,82 @@
+.. _imap-developer-guidance-prot-layer:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: prot layer
+=============================
+
+The prot layer, defined in ``prot.h``, is a stdio replacement for
+network i/o. It does the standard buffering of input and output and
+allows certain operations especially suited for request/response
+protocols like IMAP.
+
+Events
+------
+
+The prot layer allows "events" to be associated with each prot stream.
+These events are trigger at the given time or after when the protstream
+is attempted to be read from.
+
+An event is currently represented by the following datastructure:
+
+::
+
+    struct prot_waitevent;
+
+    typedef struct prot_waitevent *prot_waiteventcallback_t(struct protstream *s,
+                                struct prot_waitevent *ev,
+                                void *rock);
+
+    struct prot_waitevent {
+        time_t mark;
+        prot_waiteventcallback_t *proc;
+        void *rock;
+        struct prot_waitevent *next;
+    };
+
+The application is currently allowed to modify *mark*, *proc*, and
+*rock* as desired when there are no active calls to a prot function on
+the stream which this event is associated.
+
+The API is as follows:
+
+-  Use ``prot_addwaitevent()`` to add an event callback onto the stream:
+
+   ::
+
+       extern struct prot_waitevent *prot_addwaitevent(struct protstream *s,
+                               time_t mark,
+                               prot_waiteventcallback_t *proc,
+                               void *rock);
+
+   where *s* is the stream to add the event to, *mark* is the time to
+   trigger the event, *proc* is the callback to make, and *rock* is an
+   opaque data item handed to the callback. It returns a pointer to the
+   event structure; this is the pointer that must be used to remove the
+   event or modify it in some way.
+
+-  Use ``prot_removewaitevent()`` to remove an event:
+
+   ::
+
+       extern void prot_removewaitevent(struct protstream *s,
+                        struct prot_waitevent *event);
+
+   It requires *event* to have been returned from
+   ``prot_addwaitevent()`` previously. No further references are allowed
+   to *event* or its fields. *event->rock* is not free'd nor examined in
+   any way. This function may be called while inside the callback
+   *event->proc()*. If an event is removed inside of its callback, that
+   callback must return ``NULL``.
+
+Some common things to do with events:
+
+-  To reschedule an event *ev*, simply set *ev->mark* to the next time
+   it should trigger. If currently in *ev->proc()*, it should return
+   *ev*.
+
+--------------
+
+last modified: $Date: 2003/08/06 21:28:05 $
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/replication_examples.rst 3.2.0-3/docsrc/imap/developer/guidance/replication_examples.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/replication_examples.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/replication_examples.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,164 @@
+.. _imap-developer-guidance-replication-examples:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Replication Examples
+=======================================
+
+Introduction
+------------
+
+The replication system creates a link between two Cyrus mailstores: a
+master and a replica system. Both systems can be live mailstores with
+active users: here in Cambridge we install systems in pairs.
+
+Typically half of the users will be using each system, and each system
+replicates to its partner. In the event of a failover everyone uses the
+remaining system in a pair. This is typically safe as the IMAP/POP/SMTP
+servers define which of the two systems is the live server for any given
+account, and the replica just plays a game of follow my leader.
+
+Occasionally I think about introducing some form of sanity check so that
+we have to explicitly issue a command to the remaining backend system as
+well as the proxies in the event of a failover.
+
+A short example of replication in action
+----------------------------------------
+
+::
+
+    Index:
+
+      #: Annotation
+      C: Command issued by client
+      S: Command issued by server
+
+    # Authentication between systems is done using SSH key based authentication:
+
+    C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+    S: * Sync Server v0.0 [EXPERIMENTAL]
+
+    # Create new auth_state and ask for all information about given list of
+    # folders (namely user.dpc22). Returns:
+    #
+    #   "**" unsolicited response for each mailbox. Returns:
+    #      Folder UniqueID, Name, ACL, UIDlast, timestamp for last seen update.
+    #
+    #   "*" response for each mail message in folder:
+    #      UID, GUID, flags (other than \Seen state)
+
+    C: user_some dpc22 user.dpc22
+    S: ** 6b98205c796c6c61 user.dpc22 \
+    S:     "dpc22   lrswipcda       anonymous       0      " 4151 1062945305
+    S: * 1 000000000000000000000000 ()
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 ()
+    S: OK User_Some finished
+
+    # Select a folder to work with
+
+    C: select user.dpc22
+    S: OK 6b98205c796c6c61 4151 1062945305
+
+    # Remove message with UID "1" from folder list (message which has been
+    # sitting in my inbox since January, has no GUID defined)
+
+    C: expunge 1
+    S: OK Expunge Complete
+
+    # Set some user flags on message UID "4140"
+
+    C: setflags 4140 (hello world)
+    S: OK Updated flags on 1 messages okay
+
+    # Demonstrate that something has changed:
+
+    C: status
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 (hello world)
+    S: OK 4151
+
+    # Now lets correct the damage that we just inflicted:
+
+    C: $ replicate -s cyrus-2 -v -v -m user.dpc22
+    S: MAILBOXES user.dpc22
+    S: USER_SOME dpc22 user.dpc22
+    S: SELECT user.dpc22
+    S: SETFLAGS [1 msgs]
+    S: UPLOAD [1 msgs]
+    S: SETSEEN dpc22 ...
+    S: ENDUSER
+
+    C: $ ssh -x cyrus-2 /usr/local/cyrus/bin/sync_server
+    S: * Sync Server v0.0 [EXPERIMENTAL]
+    S: user_some dpc22 user.dpc22
+    S: ** 6b98205c796c6c61 user.dpc22 \
+    S:    "dpc22   lrswipcda       anonymous       0      " 4156 1062968731
+    S: * 1 000000000000000000000000 ()
+    S: * 3697 0101003f4c56b00545000000 ()
+    S: * 3919 0101003f4c56b04b2900000d ()
+    S: * 3937 0101003f4c56b0514900001f ()
+    S: * 4066 0101003f4c56b07422000002 ()
+    S: * 4089 0101003f4c56b07e56000023 (\answered)
+    S: * 4118 0101003f4c56b08328000016 ()
+    S: * 4131 0101003f4c56b084d7000002 ()
+    S: * 4136 0101003f4c56b087f3000001 ()
+    S: * 4140 0101003f4c56b08c9d000026 ()
+    S: OK User_Some finished
+
+    # Back where we started: the replication engine reinserted message UID 0
+    # which was missing, and removed "hello world" from message UID 4140
+
+Tracking messages between folders
+---------------------------------
+
+::
+
+    # I've just saved a message from my inbox into a folder named "zzz",
+    # creating the folder the process.
+
+    C: $ replicate -s cyrus-2 -v -v -m user.dpc22 user.dpc22.zzz
+
+    Replication action on two MAILBOX objects:
+
+    S: MAILBOXES user.dpc22 user.dpc22.zzz
+
+    Ask server for contents of the two folders:
+
+    S:   USER_SOME dpc22 ...
+
+    Reserve message with given GUID in user.dpc22 so that it can be moved
+
+    S:   RESERVE user.dpc22 ...
+
+    Remove message from source folder (reserved copy left behind)
+
+    S:   SELECT user.dpc22
+    S:   EXPUNGE [1 msgs]
+    S:   SETSEEN dpc22 ...
+
+    Create target folder and copy in message that we reserved (doesn't have to
+    be uploaded again)
+
+    S:   CREATE user.dpc22.zzz 7f6f384c3f5ba99a
+    S:      "dpc22        lrswipcda       anonymous       0       " 0 1062971802
+    S: SELECT user.dpc22.zzz
+    S: UPLOAD [1 msgs]
+    S: SETSEEN dpc22 ...
+    S: ENDUSER
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/replication_protocol.rst 3.2.0-3/docsrc/imap/developer/guidance/replication_protocol.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/replication_protocol.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/replication_protocol.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,83 @@
+.. _imap-developer-guidance-replication-protocol:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Replication Protocol v2.4+
+=============================================
+
+DList 1.0
+---------
+
+The DList protocol is based closely on the IMAP wire protocol, using
+atoms and literals as the basis, but with two extended types of data:
+
+-  kvlist
+-  rfc822-object
+
+A wart of the protocol is the rfc822-object, which contains an explicit
+cyrus backend partition. This will be removed in future versions of
+Cyrus.
+
+types
+~~~~~
+
+atom
+^^^^
+
+An atom is actually a sequence of any character other than '\\0', the
+NULL byte. Character encoding is not specified, but it can contain 8 bit
+characters, and is probably utf8
+
+flag
+^^^^
+
+Flag is a horrible special case of atom to allow \\word to be
+represented as an IMAP atom on the wire. This is one of many special
+cases in the IMAP protocol, and is duplicated into dlist just to make it
+easier to read
+
+num32/num
+^^^^^^^^^
+
+Both stored as 64 bit integers internally, and sent as decimal numbers
+over the wire, this type exists only in the API, it just looks like a
+string on the wire.
+
+hex32/hex
+^^^^^^^^^
+
+Stored like num internally, but sent as an 8 or 16 character hexadecimal
+string on the wire
+
+map
+^^^
+
+Like atom, but can contain NULL. All values are parsed off the wire as
+'map' type and then converted on demand into the requested type
+
+list
+^^^^
+
+Encoded in parentheses like so (item item item) a list type can be
+nested inside other lists: (item (sub sub) item)
+
+kvlist
+^^^^^^
+
+A kvlist allows named parameters, and is indicated with a leading %
+character. % is invalid in atoms, so parsing is unambiguous, e.g:
+
+%(key1 value1 key2 (list of values) key3 value3)
+
+rfc822-object/file
+^^^^^^^^^^^^^^^^^^
+
+Finally the ugly one. These look like a literal, but with a leading %
+and two more fields:
+
+::
+
+    %{partition sha1 size}\r\n
+    data
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/special_chars.rst 3.2.0-3/docsrc/imap/developer/guidance/special_chars.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/special_chars.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/special_chars.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,53 @@
+.. _imap-developer-guidance-special-chars:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: Special Characters
+=====================================
+
+This document is supposed to be a repository of "special characters"
+used in Cyrus naming of users, folders, directory paths, etc.
+
+Current Uses
+------------
+
+|
+| Character: +
+
+-  (LMTP) Separation of postuser and target mailbox for delivery
+-  (LMTP) Separation of username and submailbox for delivery
+-  (IMAP) Flag at end of login name that indicates that LIST should
+   return LSUB results (when imapmagicplus is set)
+-  (POP3) POP a subfolder directly (e.g. rjs3+foo POPs user.rjs3.foo)
+
+|
+| Character: . /
+
+-  [mailbox names] Hierarchy separators
+
+|
+| Character: ^
+
+-  [mailbox names] In unixhierarchysep, ^ is the part of the internal
+   name that represents a '.'
+
+|
+| Characters: @ %
+
+-  [usernames] These are realm separators for the purposes of
+   authentication
+
+|
+
+Future Uses
+-----------
+
+| Character: +
+
+-  IMAP LIST filters (e.g. rjs3+foo will only list folders that match
+   foo\*)
+-  possibly other interpretations here:
+   - rjs3+foo will do an effective chroot(foo.)
+   - rjs3+foo will only list folders in user.rjs3.foo\*
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance/var_directory_structure.rst 3.2.0-3/docsrc/imap/developer/guidance/var_directory_structure.rst
--- 3.0.13-5/docsrc/imap/developer/guidance/var_directory_structure.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance/var_directory_structure.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,73 @@
+.. _imap-developer-guidance-var_directory_structure:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Cyrus IMAP Server: var directory structure
+==========================================
+
+Directory structure under /var/spool/imap
+-----------------------------------------
+
+::
+
+    stage./
+      Normal staging directory
+
+    sync./
+      Staging directory for replication system
+      Includes
+        sync./locks/*
+
+      which are lock files for each user on the system to prevent two
+      replication runs from trying to update the same account at the same time
+      (nothing disastrous should happen even without this lock, but the second
+      job in will get a bit confused if the target end changes under its feet,
+      and will probably drop back to a recovery mode.
+
+    user/
+      Familiar user.userid space.
+
+Directory structure under /var/imap
+-----------------------------------
+
+Complete list::
+
+      drwxr-xr-x    2 cyrus    cyrus         232 Sep  7 08:21 db
+      drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:51 db.backup1
+      drwxr-x---    2 cyrus    cyrus         112 Sep  7 19:21 db.backup2
+      -rw-r-----    1 cyrus    cyrus    20799488 Sep  7 19:51 deliver.db
+      drwxr-xr-x    2 cyrus    cyrus          48 Sep  7 10:16 log
+      -rw-r-----    1 cyrus    cyrus     1995000 Sep  7 19:38 mailboxes.db
+      -rw-r--r--    1 cyrus    cyrus          10 Jun  2 10:08 master_machine
+      -rw-r--r--    1 cyrus    cyrus          71 Sep  7 08:21 master_uuid
+      drwxr-xr-x    2 cyrus    cyrus          48 Jun  2 10:08 msg
+      drwxr-xr-x    2 cyrus    cyrus        1872 Sep  7 19:55 proc
+      drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 quota
+      drwxr-xr-x    2 cyrus    cyrus         224 Sep  7 08:21 socket
+      drwxr-xr-x    2 cyrus    cyrus          72 Sep  7 10:19 sync
+      drwxr-xr-x   28 cyrus    cyrus         672 Jun  2 10:08 user
+
+Most of that will be familiar. New entries are::
+
+    master_machine
+      Defines machine number in replication cluster. Used as sanity check
+      against master_uuid file. Sample content:
+
+        machine=1
+
+    master_uuid
+      Full information about UUID schema in use. See ./uuid for details.
+      Sample content:
+
+         schema=1
+         machine=1
+         timestamp_generation=0
+         master_start_time=1062919294
+
+    sync/current
+      Transaction log from IMAP, POP and LMTP daemons, typically feed into
+      sync_client running as asynchronous replication engine.
+
+      Rotated to be sync/current-<pid> by asynchronous runner.
diff -pruN 3.0.13-5/docsrc/imap/developer/guidance.rst 3.2.0-3/docsrc/imap/developer/guidance.rst
--- 3.0.13-5/docsrc/imap/developer/guidance.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/guidance.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-developer-guidance:
+
+.. author: Nic Bernstein (Onlight)
+
+==================
+Developer Guidance
+==================
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    guidance/*
diff -pruN 3.0.13-5/docsrc/imap/developer/images/master-state-machine.svg 3.2.0-3/docsrc/imap/developer/images/master-state-machine.svg
--- 3.0.13-5/docsrc/imap/developer/images/master-state-machine.svg	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/images/master-state-machine.svg	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,523 @@
+<?xml version="1.0" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<!-- Creator: fig2dev Version 3.2 Patchlevel 5e -->
+<!-- CreationDate: Tue Mar  6 14:12:27 2018 -->
+<!-- Magnification: 1.000 -->
+<svg	xmlns="http://www.w3.org/2000/svg"
+	xmlns:xlink="http://www.w3.org/1999/xlink"
+	width="10.9in" height="7.9in"
+	viewBox="288 453 13042 9534">
+<g style="stroke-width:.025in; fill:none">
+<!-- Line -->
+<polyline points="11175,9225
+11850,9225
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Line -->
+<polyline points="11175,9525
+11850,9525
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line -->
+<polyline points="11175,9825
+11850,9825
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Line: box -->
+<rect x="5175" y="1125" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="825" y="4500" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="10050" y="4575" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line: box -->
+<rect x="5175" y="8025" width="2025" height="1200" rx="105" 
+style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Line -->
+<polyline points="5175,1275
+1515,4422
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 1275 - 1413 4509-->
+<polygon points="1496 4397
+1425 4498
+1535 4442
+1496 4397
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,8325
+2412,5780
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 8325 - 2313 5689-->
+<polygon points="2433 5759
+2325 5700
+2392 5803
+2433 5759
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,8850
+1887,5781
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 8850 - 1789 5689-->
+<polygon points="1909 5759
+1801 5700
+1868 5803
+1909 5759
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10050,4800
+2969,4800
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 10050 4800 - 2835 4800-->
+<polygon points="2971 4770
+2851 4800
+2971 4830
+2971 4770
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="1350,5700
+1350,6300
+525,6300
+525,5325
+705,5325
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 525 5325 - 840 5325-->
+<polygon points="704 5355
+824 5325
+704 5295
+704 5355
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="975,2250
+975,4380
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 975 2250 - 975 4515-->
+<polygon points="945 4379
+975 4499
+1005 4379
+945 4379
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="1575,5700
+1575,6675
+300,6675
+300,5100
+705,5100
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 300 5100 - 840 5100-->
+<polygon points="704 5130
+824 5100
+704 5070
+704 5130
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,2025
+10257,4499
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7200 2025 - 10361 4584-->
+<polygon points="10235 4521
+10348 4574
+10273 4475
+10235 4521
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7275,1575
+10783,4498
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7275 1575 - 10886 4584-->
+<polygon points="10762 4520
+10874 4574
+10801 4474
+10762 4520
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5175,1875
+2338,4420
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 5175 1875 - 2238 4510-->
+<polygon points="2319 4396
+2250 4499
+2359 4441
+2319 4396
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10050,5400
+2969,5400
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:40 40;"/>
+<!-- Arrowhead on XXXpoint 10050 5400 - 2835 5400-->
+<polygon points="2971 5370
+2851 5400
+2971 5430
+2971 5370
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10200,5775
+7290,8247
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10200 5775 - 7188 8334-->
+<polygon points="7272 8223
+7200 8324
+7310 8269
+7272 8223
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,8400
+7200,8625
+10409,5852
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7200 8625 - 10511 5765-->
+<polygon points="10427 5877
+10499 5776
+10388 5831
+10427 5877
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="7200,8775
+10425,8775
+10929,5892
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10425 8775 - 10952 5760-->
+<polygon points="10957 5899
+10949 5776
+10898 5889
+10957 5899
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5700,9225
+5700,9975
+3975,9975
+3975,9000
+5055,9000
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 3975 9000 - 5190 9000-->
+<polygon points="5054 9030
+5174 9000
+5054 8970
+5054 9030
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5850,9225
+5850,9975
+7575,9975
+7575,9075
+7319,9075
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 7575 9075 - 7185 9075-->
+<polygon points="7321 9045
+7201 9075
+7321 9105
+7321 9045
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="3975,750
+5475,750
+5475,1005
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 5475 750 - 5475 1140-->
+<polygon points="5445 1004
+5475 1124
+5505 1004
+5445 1004
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="6300,750
+5775,750
+5775,1005
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 5775 750 - 5775 1140-->
+<polygon points="5745 1004
+5775 1124
+5805 1004
+5745 1004
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11400,4575
+11400,3900
+13050,3900
+13050,4875
+12194,4875
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 13050 4875 - 12060 4875-->
+<polygon points="12196 4845
+12076 4875
+12196 4905
+12196 4845
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11175,5775
+10725,8925
+7319,8925
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 10725 8925 - 7185 8925-->
+<polygon points="7321 8895
+7201 8925
+7321 8955
+7321 8895
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="11325,5775
+11325,6450
+13050,6450
+13050,5550
+12194,5550
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 13050 5550 - 12060 5550-->
+<polygon points="12196 5520
+12076 5550
+12196 5580
+12196 5520
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="10800,2700
+10800,4125
+11165,4490
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+stroke-dasharray:10 30;"/>
+<!-- Arrowhead on XXXpoint 10800 4125 - 11260 4585-->
+<polygon points="11142 4510
+11249 4574
+11185 4467
+11142 4510
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="5550,2325
+5550,7905
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 5550 2325 - 5550 8040-->
+<polygon points="5520 7904
+5550 8024
+5580 7904
+5520 7904
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Line -->
+<polyline points="6600,2325
+6600,7905
+" style="stroke:#000000;stroke-width:7;
+stroke-linejoin:miter; stroke-linecap:butt;
+"/>
+<!-- Arrowhead on XXXpoint 6600 2325 - 6600 8040-->
+<polygon points="6570 7904
+6600 8024
+6630 7904
+6570 7904
+
+" style="stroke:#000000;stroke-width:7;stroke-miterlimit:8;
+fill:#000000;"/>
+<!-- Text -->
+<g transform="translate(3516,3741) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+</g><!-- Text -->
+<g transform="translate(3675,3900) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive--</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="4050" y="9675" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection</text>
+<!-- Text -->
+<text xml:space="preserve" x="4050" y="9900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+<!-- Text -->
+<g transform="translate(2797,7041) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+</g><!-- Text -->
+<g transform="translate(2638,7200) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive--</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="2100" y="600" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Child in illegal state detected</text>
+<!-- Text -->
+<text xml:space="preserve" x="2100" y="825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">(via message handling)</text>
+<!-- Text -->
+<text xml:space="preserve" x="11100" y="3600" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="11100" y="3825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+<!-- Text -->
+<g transform="translate(8210,7116) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable(service)</text>
+</g><!-- Text -->
+<g transform="translate(8369,7275) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">readyworkers--</text>
+</g><!-- Text -->
+<g transform="translate(9055,7470) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+</g><!-- Text -->
+<g transform="translate(9214,7630) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">readyworkers++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="8100" y="8400" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="8625" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++ readyworkers++</text>
+<!-- Text -->
+<g transform="translate(8484,2016) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">ConnectionMulti(service)</text>
+</g><!-- Text -->
+<g transform="translate(8325,2175) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="11925" y="9825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Initial States</text>
+<!-- Text -->
+<text xml:space="preserve" x="11925" y="9525" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Messages</text>
+<!-- Text -->
+<text xml:space="preserve" x="11925" y="9225" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Signals</text>
+<!-- Text -->
+<text xml:space="preserve" x="9750" y="750" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="432" text-anchor="start">Cyrus Master</text>
+<!-- Text -->
+<text xml:space="preserve" x="9750" y="1350" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="432" text-anchor="start">State Machine</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="9225" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection(service)</text>
+<!-- Text -->
+<text xml:space="preserve" x="8100" y="9450" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++ readyworkers--</text>
+<!-- Text -->
+<text xml:space="preserve" x="10050" y="2550" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">New Service (nactive++)</text>
+<!-- Text -->
+<text xml:space="preserve" x="10050" y="2775" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">or Event</text>
+<!-- Text -->
+<text xml:space="preserve" x="3446" y="4628" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nactive-- readyworkers--</text>
+<!-- Text -->
+<text xml:space="preserve" x="3446" y="4403" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(service)</text>
+<!-- Text -->
+<g transform="translate(6900,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Connection(service)</text>
+</g><!-- Text -->
+<g transform="translate(7125,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">nconn++</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="1350" y="5250" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Dead</text>
+<!-- Text -->
+<text xml:space="preserve" x="5475" y="1875" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Unknown</text>
+<!-- Text -->
+<text xml:space="preserve" x="5775" y="8775" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Busy</text>
+<!-- Text -->
+<text xml:space="preserve" x="10500" y="5325" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="288" text-anchor="start">Ready</text>
+<!-- Text -->
+<text xml:space="preserve" x="675" y="6150" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">(Any)</text>
+<!-- Text -->
+<text xml:space="preserve" x="450" y="1875" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unregistered Child</text>
+<!-- Text -->
+<text xml:space="preserve" x="675" y="2100" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD</text>
+<!-- Text -->
+<text xml:space="preserve" x="375" y="6900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD</text>
+<!-- Text -->
+<g transform="translate(2850,3225) rotate(-45.00010523)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+</g><!-- Text -->
+<g transform="translate(3300,6450) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="6075" y="9900" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable</text>
+<!-- Text -->
+<text xml:space="preserve" x="6375" y="825" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Message from unknown child</text>
+<!-- Text -->
+<text xml:space="preserve" x="11550" y="6300" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+<!-- Text -->
+<g transform="translate(7950,3000) rotate(-315.00073661)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Available(service)</text>
+</g><!-- Text -->
+<text xml:space="preserve" x="9900" y="1650" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">based on a sketch by hmh@debian.org</text>
+<!-- Text -->
+<text xml:space="preserve" x="3450" y="5700" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">SIGCHLD(!service)</text>
+<!-- Text -->
+<g transform="translate(5775,4050) rotate(-90.00021046)" >
+<text xml:space="preserve" x="0" y="0" fill="#000000"  font-family="Times" font-style="normal" font-weight="normal" font-size="144" text-anchor="start">Unavailable(service)</text>
+</g></g>
+</svg>
diff -pruN 3.0.13-5/docsrc/imap/developer/install-xapian.rst 3.2.0-3/docsrc/imap/developer/install-xapian.rst
--- 3.0.13-5/docsrc/imap/developer/install-xapian.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/install-xapian.rst	2020-04-24 02:03:00.000000000 +0000
@@ -69,10 +69,10 @@ You also need (at least one) search tier
     search_engine: xapian
     search_index_headers: no
     search_batchsize: 8192
-    defaultpartition: default
+    defaultpartition: base
     defaultsearchtier: t1
-    partition-default: /var/cyrus/spool
-    t1searchpartition-default: /var/cyrus/search
+    partition-base: /var/cyrus/spool
+    t1searchpartition-base: /var/cyrus/search
 
 If you want to do more complex search tiers and repacking, you'll want to read:
 
diff -pruN 3.0.13-5/docsrc/imap/developer/jmap.rst 3.2.0-3/docsrc/imap/developer/jmap.rst
--- 3.0.13-5/docsrc/imap/developer/jmap.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/jmap.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,144 @@
+.. _developer-jmap:
+
+============
+JMAP support
+============
+
+`JMAP <http://jmap.io/>`_ is an alternate mechanism for synchronising a mail client with a mail server, intended as a replacement for IMAP. It is a transport-agnostic, stateless JSON-based API, aiming to be compatible with the IMAP data model, but with reduced data usage and more efficient synchronisation.
+
+Cyrus administration
+====================
+
+Compile JMAP support into Cyrus
+-------------------------------
+
+1. Enable JMAP (and DAV) in Cyrus:
+
+    * ``./configure --enable-http --enable-jmap --enable-xapian`` along with your other configuration options.
+
+2. Enable :ref:`conversation support <imap-concepts-deployment-db-conversations>`
+
+    * In :cyrusman:`imapd.conf(5)`, set ``conversations: 1``, ``conversations_db: twoskip``
+    * Create a conversations.db for each user: ``ctl_conversationsdb -b -r``
+
+3. JMAP depends on Xapian. For full support (to gain full word boundary
+distinctions in CJK languages - Chinese, Japanese and Korean), this needs to be
+manually compiled due to extra patches needing to be applied.
+Our :ref:`Xapian install guide <imapinstall-xapian>` shows how.
+
+4. Once installed, the ``jmap`` module must be enabled in
+:cyrusman:`imapd.conf(5)`: ``httpmodules: jmap``
+
+JMAP client
+===========
+
+Test JMAP support
+-----------------
+
+Once Cyrus is running, you can test JMAP on the command line for any existing Cyrus user. The user must at least have an INBOX provisioned but is not required to have any calendars, contacts or messages.
+
+To obtain the JMAP mailbox folders for user ``test``, issue the following request:
+
+.. code-block:: bash
+
+    curl -X POST \
+         -H "Content-Type: application/json" \
+         -H "Accept: application/json" \
+         --user test:test \
+         -d '{
+           "using": [ "urn:ietf:params:jmap:core", "urn:ietf:params:jmap:mail" ],
+           "methodCalls": [[ "Mailbox/get", {}, "c1" ]]
+         }' \
+         http://localhost/jmap/
+
+you should get a response which looks similar to
+
+.. code-block:: none
+
+    {
+      "methodResponses": [
+        ["Mailbox/get", {
+          "state": "0",
+          "list": [{
+            "id": "7c76ec2b-9bd8-4091-a665-640e232e3877",
+            "name": "Inbox",
+            "parentId": null,
+            "myRights": {
+              "mayReadItems": true,
+              "mayAddItems": true,
+              "mayRemoveItems": true,
+              "mayCreateChild": true,
+              "mayDelete": false,
+              "maySubmit": true,
+              "maySetSeen": true,
+              "maySetKeywords": true,
+              "mayAdmin": true,
+              "mayRename": false
+            },
+            "role": "inbox",
+            "totalEmails": 0,
+            "unreadEmails": 0,
+            "totalThreads": 0,
+            "unreadThreads": 0,
+            "sortOrder": 1,
+            "isSubscribed": false
+          }, {
+            "id": "5d9e4f44-7df9-4489-b8b3-32625b552aa1",
+            "name": "Trash",
+            "parentId": null,
+            "myRights": {
+              "mayReadItems": true,
+              "mayAddItems": true,
+              "mayRemoveItems": true,
+              "mayCreateChild": true,
+              "mayDelete": true,
+              "maySubmit": true,
+              "maySetSeen": true,
+              "maySetKeywords": true,
+              "mayAdmin": true,
+              "mayRename": true
+            },
+            "role": null,
+            "totalEmails": 0,
+            "unreadEmails": 0,
+            "totalThreads": 0,
+            "unreadThreads": 0,
+            "sortOrder": 10,
+            "isSubscribed": true
+          }],
+          "notFound": [],
+          "accountId": "test"
+        }, "c1"]
+      ],
+      "sessionState": "0"
+    }
+
+Similar requests exist to obtain contacts and calendars. For details, see the
+JMAP specification.
+
+Optional: Install sample JMAP client
+------------------------------------
+
+.. note::
+
+    Cyrus does not yet implement JMAP authentication. Instead, it requires for
+    each request the HTTP Basic Auth header set with the account's username and
+    password. If you intend to use the JMAP perl or web clients, make sure to add
+    the required authentication headers for each request.
+
+You can set up the `JMAP Proxy (perl) <https://github.com/jmapio/jmap-perl>`_ to sit in front of a standard IMAP server and query that over a custom JMAP client.
+
+Or you can install a sample `JMAP web client <https://github.com/jmapio/jmap-demo-webmail>`_ which requires the `Overture.js library <https://github.com/fastmail/overture>`_ and `JMAP JS library <https://github.com/jmapio/jmap-js>`_ to talk to a JMAP-enabled Cyrus server and build from there (subject to the `MIT license <https://tldrlegal.com/license/mit-license>`_).
+
+The web client is a simple example (no compose, contacts or calendars). When you create your account, the most recent 50 emails will be downloaded in their entirety, so the first page should be snappy immediately. After that, you are redirected to the landing page. A background task will continue to pull in batches of messages and add them to your account, so you will see older messages appear while you are using the interface.
+
+Developing the client further
+-----------------------------
+
+You'll want to become deeply familiar with the `JMAP developer documentation <http://jmap.io/#i-want-to-get-involved-with-jmap.-what-do-i-need-to-know?>`_
+
+
+.. note::
+
+    JMAP implementation in Cyrus is a work in progress. Current status can be
+    viewed on the main :ref:`JMAP configuration page <jmap-implementation>`.
diff -pruN 3.0.13-5/docsrc/imap/developer/process.rst 3.2.0-3/docsrc/imap/developer/process.rst
--- 3.0.13-5/docsrc/imap/developer/process.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/process.rst	2020-04-24 02:03:00.000000000 +0000
@@ -55,7 +55,7 @@ If you're not planning on regularly subm
 Useful Developer Information
 ============================
 
-Some combined :ref:`tips on developing with Cyrus <cyrus-hacking>` have been collected.
+Some combined :ref:`tips on developing with Cyrus <imap-developer-guidance>` have been collected.
 
 Community Participation
 =======================
diff -pruN 3.0.13-5/docsrc/imap/developer/releasing.rst 3.2.0-3/docsrc/imap/developer/releasing.rst
--- 3.0.13-5/docsrc/imap/developer/releasing.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/releasing.rst	2020-04-08 00:07:13.000000000 +0000
@@ -25,14 +25,27 @@ manual like she did. :)
 Once you have a GPG key, it's helpful to upload your public key to
 `the MIT key-server <http://pgp.mit.edu>`_
 
-You also need a shell account on www.cyrusimap.org and ftp.cyrusimap.org,
-with SSH key authentication.  You need to be in the "admin" group on each,
-and also the "cyrupload" group on the latter.
-
 And you need permission to send to the cyrus-announce mailing list.
 
 .. endblob releaseprereqs
 
+Order of operations
+===================
+
+Sometimes you're releasing several new versions all at once(ish), for example
+maybe there's been a security fix that affected 2.4, 2.5 and 3.0.
+
+Github's release page will put a "Latest Release" graphic on the release with
+the newest tag (by timestamp, I think).  This means that, if you're doing new
+releases for several different versions, you want to do the oldest one first,
+and only do the release for the current-stable branch last.
+
+If you start at the current stable branch and then work your way backwards
+through the older ones, you'll get Github saying "2.5.15 is the Latest
+Release" even though 3.0.13 was also just released... so, even though
+releasing the current-stable fix feels more urgent, suck it up and get the
+older-branch ones out first.
+
 
 Release notes
 =============
@@ -59,7 +72,7 @@ Pre-release testing
    need any other options at this stage).
 4. Run ``make distcheck``.  This will generate a distribution tarball, and
    test it in various ways.  It takes about 10-15 mins to run, depending on
-   your hardware.  If this command fails, you are not ready to release --
+   your hardware.  If this command fails*, you are not ready to release --
    fix the problems, get them tested and committed, then restart the
    pre-release testing.
 5. ``make distcheck`` can only test so much (it doesn't know about cunit or
@@ -78,6 +91,21 @@ Pre-release testing
    ix.   If any of this fails, fix it, commit it, then restart the pre-release
          testing.
 
+.. Note::
+    ``make distcheck`` doesn't work on the 2.5 branch.  For 2.5, just use
+    ``make dist`` instead.
+
+.. Note::
+    Realistically, there's usually some set of expected Cassandane failures
+    from each Cyrus branch, especially for 2.5.  If you're doing releases
+    regularly, you've probably got a good gut feel for which failures are a
+    problem and which ones are just "that old thing".  If you don't do
+    releases regularly, try to pull in someone who does for guidance about
+    which failures are ignorable, and which should be a source of stress.
+
+    If in doubt, try building and testing the previous release from the same
+    series, and compare the test results.
+
 
 Linking up release notes
 ========================
@@ -98,9 +126,9 @@ website updating before the downloads ar
 Version tagging
 ===============
 
-Note: it is absolutely critical that your local commits have been pushed
-upstream at this point.  If they are not, and if anybody else pushes in the
-meantime, you will end up with a mess.
+Note: it is absolutely critical that your repository is clean and your local
+commits have been pushed upstream at this point.  If they are not, and if
+anybody else pushes in the meantime, you will end up with a mess.
 
 1. Ensure your repository is clean again: ``git clean -xfd``
 2. Create a signed, annotated tag for the new version: ``git tag -s cyrus-imapd-<version>``
@@ -126,15 +154,60 @@ meantime, you will end up with a mess.
 11. Push the tag upstream: ``git push ci cyrus-imapd-<version>`` (assuming your
     remote is named "ci").
 
-Releasing
+
+Inter-version website consistency
+=================================
+
+The website is built from an amalgamation of documentation from:
+
+* The current stable cyrus-imapd branch (top level)
+* The current master cyrus-imapd branch (``/dev`` hierarchy)
+* Each of the following cyrus-imapd branches (``/x.y`` hierarchies)
+
+    - cyrus-imapd-2.5
+    - cyrus-imapd-3.0
+    - cyrus-imapd-3.2
+
+* The current master cyrus-sasl branch (``/sasl`` hierarchy)
+
+When making a cyrus-imapd release, you need to add the new release notes
+file to each relevant cyrus-imapd branch.  You also need to check and
+update the contents of ``docsrc/conf.py`` on each branch AND the cyrus-sasl
+repository.
+
+Sometimes you can just cherry-pick the commits around, but note that the
+2.5 website stores release notes files in a different path, so if you
+bother to copy release notes back to this branch, a naive cherry-pick will
+not put them in the right place!
+
+This step often gets forgotten, so if you actually follow it, and notice
+some missing versions, just go ahead and add them while you're there.
+
+Uploading
 =========
 
-1. Upload the tarball and signature to www: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   www.cyrusimap.org:/var/www/html/releases/``
-2. Upload them to ftp too: ``scp cyrus-imapd-*.tar.gz cyrus-imapd-*.tar.gz.sig
-   ftp.cyrusimap.org:/srv/ftp/cyrus-imapd/``
-3. SSH into both www and ftp, and move older releases to the old versions
-   directory.  You want only the two most recent tarball+sig pairs for each
-   major series.
-4. Update the topic in the #cyrus IRC channel.
-5. Send an announcement to the info-cyrus and cyrus-announce lists.
+.. Note::
+    This section does NOT apply to releases from the master branch.  We
+    do not publish release tarballs for those.  People running master code
+    are expected to use a git checkout.
+
+Time to upload the release tarball and signature file!
+
+1. Navigate to https://github.com/cyrusimap/cyrus-imapd/releases
+2. The tag you pushed earlier will now be available as a release, but it will
+   have very little information about it
+3. Click on the tag name
+4. Click "Edit tag" on the right
+5. *Leave every field on the page as it is (probably blank!), except*:
+6. Use the "Attach binaries by dropping them here or selecting them" widget
+   to upload the tarball and signature files
+7. If this is an alpha/beta/rc release, click the "This is a pre-release"
+   checkbox
+8. Click "Save".  The commit message from the tag annotation will be used
+   as the release description.
+
+Tell the world
+==============
+
+1. Update the topic in the #cyrus IRC channel.
+2. Send an announcement to the info-cyrus and cyrus-announce lists.
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/backup.rst 3.2.0-3/docsrc/imap/developer/thoughts/backup.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/backup.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/backup.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,925 @@
+.. _imap-developer-thoughts-backup:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Notes for backup implementation
+===============================
+
+Backup index database (one per user):
+
+chunk::
+
+    int id
+    timestamp ts
+    int offset
+    int length
+    text file_sha1              -> sha1 of (compressed) data prior to this chunk
+    text data_sha1              -> sha1 of (uncompressed) data contained in this chunk
+
+mailbox::
+
+    int id
+    int last_chunk_id           -> chunk that knows the current state
+    char uniqueid               -> unique
+    char mboxname               -> altered by a rename
+    char mboxtype
+    int last_uid
+    int highestmodseq
+    int recentuid
+    timestamp recenttime
+    timestamp last_appenddate
+    timestamp pop3_last_login
+    timestamp pop3_show_after
+    timestamp uidvalidity
+    char partition
+    char acl
+    char options
+    int sync_crc
+    int sync_crc_annot
+    char quotaroot
+    int xconvmodseq
+    char annotations
+    timestamp deleted           -> time that it was unmailbox'd, or NULL if still alive
+
+message::
+
+    int id
+    char guid
+    char partition              -> this is used to set the spool directory for the temp file - we might not need it
+    int chunk_id
+    int offset                  -> offset within chunk of dlist containing this message
+    int size                    -> size of this message (n.b. not length of dlist)
+
+mailbox_message::
+
+    int mailbox_id
+    int message_id
+    int last_chunk_id           -> chunk that has a RECORD in a MAILBOX for this
+    int uid
+    int modseq
+    timestamp last_updated
+    char flags
+    timestamp internaldate
+    int size
+    char annotations
+    timestamp expunged          -> time that it was expunged, or NULL if still alive
+
+subscription::
+
+    int last_chunk_id           -> chunk that knows the current state
+    char mboxname               -> no linkage to mailbox table, users can be sub'd to nonexistent
+    timestamp unsubscribed      -> time that it was unsubscribed, or NULL if still alive
+
+seen::
+
+    int last_chunk_id           -> chunk that knows the current state
+    char uniqueid               -> mailbox (not necessarily ours) this applies to
+    timestamp lastread
+    int lastuid
+    timestamp lastchange
+    char seenuids               -> a uid sequence encoded as a string
+
+sieve::
+
+    int chunk_id
+    timestamp last_update
+    char filename
+    char guid
+    int offset                  -> offset within chunk of the dlist containing this script
+    timestamp deleted           -> time that it was deleted, or NULL if still alive
+
+
+sieve scripts and messages are both identified by a GUID
+but APPLY SIEVE doesn't take a GUID, it seems to be generated locally?
+the GUID in the response to APPLY SIEVE is generated in the process of
+reading the script from disk (sync_sieve_list_generate)
+
+can't activate scripts because only bytecode files are activated, but
+we neither receive bytecode files over sync protocol nor do we compile
+them ourselves.
+
+possibly reduce index size by breaking deleted/expunged values into their
+own tables, such that we only store a deleted value for things that are
+actually deleted.  use left join + is null to find undeleted content
+
+messages
+--------
+
+APPLY MESSAGE is a list of messages, not necessarily only one message.
+Actually, it's a list of messages for potentially multiple users, but we avoid
+this by rejecting GET MESSAGES requests that span multiple users (so that
+sync_client retries at USER level, and so we only see APPLY MESSAGE requests
+for a single user).
+
+Cheap first implementation is to index the start/end of the entire APPLY
+MESSAGE command identically for each message within it, and at restore time
+we grab that chunk and loop over it looking for the correct guid.
+
+Ideal implementation would be to index the offset and length of each message
+exactly (even excluding the dlist wrapper), but this is rather complicated
+by the dlist API.
+
+For now, we just index the offset of the dlist entry for the message,
+and we can parse the pure message data back out later from that, when
+we need to.  Slightly less efficient on reads, but works->good->fast.  We
+need to loop over the entries in the MESSAGE dlist to find the one with the
+desired GUID.
+
+The indexed length needs to be the length of the message, not the length of the
+dlist wrapper, because we need to know this cheaply to supply RECORDs in
+MAILBOX responses.
+
+renames
+-------
+
+APPLY RENAME %(OLDMBOXNAME old NEWMBOXNAME new PARTITION p UIDVALIDITY 123)
+
+We identify mboxes by uniqueid, so when we start seeing sync data for the same
+uniqueid with a new mboxname we just transparently update it anyway, without
+needing to handle the APPLY RENAME.  Not sure if this is a problem...  Do we
+need to record an mbox's previous names somehow?
+
+I think it's possible to use this to rename a USER though, something like:
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.smithj NEWMBOXNAME example.com!user.jsmith ...)
+
+-- in which case, without special handling of the RENAME command itself, there
+will be a backup for the old user that ends with the RENAME, and a backup of
+the new user that (probably) duplicates everything again (except for stuff
+that's been expunged).
+
+And if someone else gets given the original name, like
+
+APPLY RENAME %(OLDMBOXNAME example.com!user.samantha-mithj NEWMBOXNAME example.com!user.smithj ...)
+
+Then anything that was expunged from the original user but still available in
+backup disappears?  Or the two backups get conflated, and samantha can
+"restore" the original smithj's old mail?
+
+Uggh.
+
+if there's a mailboxes database pointing to the backup files, then the backup
+file names don't need to be based on the userid, they could e.g. be based on
+the user's inbox's uniqueid.  this would make it easier to deal with user
+renames because the backup filename wouldn't need to change.  but this depends
+on the uniqueid(s) in question being present on most areas of the sync
+protocol, otherwise when starting a backup of a brand new user we won't be
+able to tell where to store it.  workaround in the meantime could be to make
+some kind of backup id from the mailboxes database, and base the filename on
+this.
+
+actually, using "some kind of backup id from the mailboxes database" is probably
+the best solution.  otherwise the lock complexity of renaming a user while making
+sure their new backup filename doesn't already exist is frightful.
+
+maybe do something with mkstemp()?
+
+furthermore: what if a mailbox is moved from one user to another?  like:
+
+APPLY RENAME %(OLD... example.com!user.foo.something NEW... example.com!user.bar.something ...)
+
+when a different-uid rename IS a rename of a user (and not just a folder
+being moved to a different user), what does it look like?
+* does it do a single APPLY RENAME for the user, and expect their folders to shake out of that?
+* does it do an APPLY RENAME for each of their folders?
+
+in the latter case, we need to append each of those RENAMEs to the old backup
+so they can take effect correctly, and THEN rename the backup file itself. but
+how to tell when the appends are finished?
+
+how can we tell the difference between folder(s) moved to a different user vs
+user has been renamed?
+
+there is a setting: 'allowusermoves: 0' which, when enabled, allows users to
+be renamed via IMAP rename/xfer commands.  but the default is that this is
+disabled.  we could initially require this to be disabled while using backups...
+
+not sure what the workflow looks like for renaming a user if this is not enabled.
+
+not sure what the sync flow looks like in either case.
+
+looking at sync_apply_rename and mboxlist_renamemailbox, it seems like we'll
+see an APPLY RENAME for each affected mbox when a recursive rename is occurring.
+
+there doesn't seem to be anything preventing user/a/foo -> user/b/foo in the
+general (non-INBOX) case.
+
+renames might be a little easier to handle if the index replicated the mailbox
+hierarchy rather than just being a flat structure.  though this adds complexity
+wrt hiersep handling.  something like:
+
+mailbox:
+
+    mboxname
+        # just the name of this mbox
+
+    parent_id
+        # fk to parent mailbox
+
+    full_mboxname
+        # cached value, parent.full_mboxname + mboxname
+
+locking
+-------
+
+just use a normal flock/fcntl lock on the data file and only open the index
+if that lock succeeded
+
+*   backup:   needs to append foo and update foo.index
+*   reindex:  only needs to read foo, but needs a write lock to prevent
+              writes while it does so. needs to write to (replace) foo.index
+*   compact:  needs to re-write foo and foo.index
+*   restore:  needs to read
+
+
+verifying index
+---------------
+
+how to tell whether the .index file is the correct one for the backup data it
+ostensibly represents?
+
+one way to do this would be to have backup_index_end() store a checksum of
+the corresponding data contents in the index.
+
+when opening a backup, verify this checksum against the data, and refuse to
+load the index if it doesn't match.
+
+- sha1sum of (compressed) contents of file prior to each chunk
+
+how to tell whether the chunk data is any good?  store a checksum of the chunk
+contents along with the rest of the chunk index
+
+- sha1sum of (uncompressed) contents of each chunk
+
+
+mailboxes database
+------------------
+
+bron reckons use twoskip for this
+userid -> backup_filename
+
+lib/cyrusdb module implements this, look into that
+
+look at conversations db code to see how to use it
+
+need a tool:
+* given a user, show their backup filename
+* dump/undump
+* rebuild based on files discovered in backup directory
+
+where does this fit into the locking scheme?
+
+
+reindex
+-------
+
+* convert user mailbox name to backup name
+* complain if there's no backup data file?
+* lock, rename .index to .index.old, init new .index
+* foreach file chunk:
+*   timestamp is from first line in chunk
+*   complain if timestamp has gone backwards?
+*   index records from chunk
+* unlock
+* clean up .index.old
+
+on error:
+* discard partial new index
+* restore .index.old
+* bail out
+
+
+backupd
+-------
+
+cmdloop:
+* (periodic cleanup)
+* read command, determine backup name
+* already holding lock ? bump timestamp : obtain lock
+* write data to gzname, flush immediately
+* index data
+
+periodic cleanup:
+* check timestamp of each held lock
+* if stale (define: stale?), release
+* FIXME if we've appended more than the chunk size we would compact to, release
+
+sync restart:
+* release each held lock
+
+exit:
+* release each held lock
+
+need a "backup_index_abort" to complete the backup_index_start/end set.
+_start should create a transaction, _end should commit it, and _abort should
+roll it back.  then, if backupd fails to write to the gzip file for some
+reason, the (now invalid) index info we added can be discarded too.
+
+flushing immediately on write results in poor gzip compression, but for
+incremental backups that's not a problem.  when the compact process hits the
+file it will recompress the data more efficiently.
+
+
+questions
+---------
+* what does it look like when uidvalidity changes?
+
+
+restore
+-------
+
+restoration is effectively a reverse-direction replication (replicating TO master),
+which means we can't necessarily supply things like uid, modseq, etc without racing
+against normal message arrivals.  so instead we add an extra command to the protocol
+to restore a message to a folder but let the destination determine the tasty bits.
+
+protocol flow looks something like:
+
+c: APPLY RESERVE ... # as usual
+s: * MISSING (foo bar)
+s: OK
+c: APPLY MESSAGE ... # as usual
+s: OK
+c: RESTORE MAILBOX ... # new sync proto command
+s: OK
+
+we introduce a new command, RESTORE MAILBOX, which is similar to the existing
+APPLY MAILBOX.  it specifies, for a mailbox, the mailbox state plus the message
+records relevant to the restore.
+
+the imapd/sync_server receiving the RESTORE command creates the mailbox if necessary,
+and then adds the message records to it as new records (i.e. generating new uid etc).
+this will end up generating new events in the backup channel's sync log, and then the
+messages will be backed up again with their new uids, etc.  additional wire transfer
+of message data should be avoided by keeping the same guid.
+
+if the mailbox already exists but its uniqueid does not match the one from the backup,
+then what?  this probably means user has deleted folder and contents, then made new
+folder with same name.  so it's probably v common for mailbox uniqueid to not match
+like this.  so we don't care about special handling for this case.  just add any
+messages that aren't already there.
+
+if the mailbox doesn't already exist on the destination (e.g. if rebuilding a server
+from backups) then it's safe and good to reuse uidvalidity, uniqueid, uid, modseq etc,
+such that connecting clients can preserve their state.  so the imapd/sync_server
+receiving the restore request accepts these fields as optional, but only preserves
+them if it's safe to do so.
+
+* restore: sbin program for selecting and restoring messages
+
+restore command needs options:
++ whether or not to trim deletedprefix off mailbox names to be restored
++ whether or not to restore uniqueid, highestmodseq, uid and so on
++ whether or not to limit to/exclude expunged messages
++ whether or not to restore sub-mailboxes
++ sync_client-like options (servername, local_only, partition, ...)
++ user/mailbox/backup file(s) to restore from
++ mailbox to restore to (override location in backup)
++ override acl?
+
+can we heuristically determine whether an argument is an mboxname, uniqueid or guid?
+    => libuuid uniqueid is 36 bytes of hyphen (at fixed positions) and hex digits
+    => non-libuuid uniqueid is 24 bytes of hex digits
+    => mboxname usually contains at least one . somewhere
+    => guid is 40 bytes of hex digits
+
+usage:
+    restore [options] server [mode] backup [mboxname | uniqueid | guid]...
+
+options:
+    -A acl              # apply specified acl to restored mailboxes
+    -C alt_config       # alternate config file
+    -D                  # don't trim deletedprefix before restoring
+    -F input-file       # read mailboxes/messages from file rather than argv
+    -L                  # local mailbox operations only (no mupdate)
+    -M mboxname         # restore messages to specified mailbox
+    -P partition        # restore mailboxes to specified partition
+    -U                  # try to preserve uniqueid, uid, modseq, etc
+    -X                  # don't restore expunged messages
+    -a                  # try to restore all mailboxes in backup
+    -n                  # calculate work required but don't perform restoration
+    -r                  # recurse into submailboxes
+    -v                  # verbose
+    -w seconds          # wait before starting (useful for attaching a debugger)
+    -x                  # only restore expunged messages (not sure if useful?)
+    -z                  # require compression (abort if compression unavailable)
+
+mode:
+    -f                  # specified backup interpreted as filename
+    -m                  # specified backup interpreted as mboxname
+    -u                  # specified backup interpreted as userid (default)
+
+
+compact
+--------
+
+# finding messages that are to be kept (either exist as unexpunged somewhere,
+# or exist as expunged but more recently than threshold)
+# (to get unique rows, add "distinct" and remove mm.expunged from fields)
+sqlite> select m.*, mm.expunged from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged > 1437709300);
+id|guid|partition|chunk_id|offset|length|expunged
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+1|1c7cca361502dfed2d918da97e506f1c1e97dfbe|default|1|458|2159|1446179047
+
+# finding chunks that are still needed (due to containing last state
+# of mailbox or mailbox_message, or containing a message)
+sqlite> select * from chunk where id in (select last_chunk_id from mailbox where deleted is null or deleted > 1437709300 union select last_chunk_id from mailbox_message where expunged is null or expunged > 1437709300 union select chunk_id from message as m join mailbox_message as mm on m.id = mm.message_id and (mm.expunged is null or mm.expunged > 1437709300));
+id|timestamp|offset|length|file_sha1|data_sha1
+1|1437709276|0|3397|da39a3ee5e6b4b0d3255bfef95601890afd80709|6836d0110252d08a0656c14c2d2d314124755491
+3|1437709355|1977|2129|fee183c329c011ead7757f59182116500776eaaf|a5677cfa1f5f7b627763652f4bb9b99f5970748c
+4|1437709425|2746|1719|3d9f02135bf964ff0b6a917921b862c3420e48f0|7b64ec321457715ee61fe238f178f5d72adaef64
+5|1437709508|3589|2890|0cee599b1573110fee428f8323690cbcb9589661|90d104346ef3cba9e419461dd26045035f4cba02
+
+remember: a single APPLY MESSAGE line can contain many messages!
+
+thoughts:
+
+* need a heuristic for quickly determining whether a backup needs to be compacted
+
+    * sum(chunks to discard, chunks to combine, chunks to split) > threshold
+    * can we detect chunks that are going to significantly reduce in size as result of discarding individual lines?
+
+* "quick" vs "full" compaction
+
+settings:
+
+* backup retention period
+* chunk combination size (byte length or elapsed time)
+
+combining chunks:
+* size threshold below which adjacent chunks can be joined
+* size threshold above which chunks should be split
+* duration threshold below which adjacent chunks can be joined
+* duration threshold above which chunks should be split
+backup_min_chunk_size: 0 for no minimum
+backup_max_chunk_size: 0 for no maximum
+backup_min_chunk_duration: 0 for no minimum
+backup_max_chunk_duration: 0 for no maximum
+priority: size or duration??
+
+data we absolutely need to keep:
+
+* the most recent APPLY MAILBOX for each mailbox we're keeping (mailbox state)
+* the APPLY MAILBOX containing the most recent RECORD for each message we're keeping (record state)
+* the APPLY MESSAGE for each message we're keeping (message data)
+
+data that we should practically keep:
+
+* all APPLY MAILBOXes for a given mailbox from the chunk identified as its last
+* all APPLY MAILBOXes containing a RECORD for a given message from the chunk identified as its last
+* the APPLY MESSAGE for each message we're keeping
+
+four kinds of compaction (probably at least two simultaneously):
+
+* removing unused chunks
+* combining adjacent chunks into a single chunk (for better gz compression)
+* removing unused message lines from within a chunk (important after combining)
+* removing unused messages from within a message line
+
+"unused messages"
+    messages for which all records have been expunged for longer
+    than the retention period
+
+"unused chunks"
+    chunks which contain only unused messages
+
+algorithm:
+
+*   open (and lock) backup and backup.new (or bail out)
+*   use backup index to identify chunks we still need
+*   create a chunk in backup.new
+*   foreach chunk we still need:
+*       foreach line in the chunk:
+*           next line if we don't need to keep it
+*           create new line
+*           foreach message in line:
+*               if we still need the message, or if we're not doing message granularity
+*                   add the message to the new line
+*           write and index tmp line to backup.new
+*       if the new chunk is big enough, or if we're not combining
+*           end chunk and start a new one
+*   end the new chunk
+*   rename backup->backup.old, backup.new->backup
+*   close (and unlock) backup.old and backup
+
+
+command line locking utility
+----------------------------
+
+command line utility to lock a backup (for e.g. safely poking around in the
+.index on a live system).
+
+example failure:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+NO some error
+<EOF>
+
+example success:
+$ctl_backups lock -f /path/to/backup
+* Trying to obtain lock on /path/to/backup...
+[potentially a delay here if we need to wait for another process to release the lock]
+OK locked
+[waits for its stdin to close, then unlocks and exits]
+
+if you need to rummage around in backup.index, run this program in another
+shell, do your work, then ^D it when you're finished.
+
+you could also call this from e.g. perl over a bidirectional pipe - wait to
+read "OK locked", then you've got your lock.  close the pipe to unlock when
+you're finished working.  if you don't read "OK locked" before the pipe closes
+then something went wrong and you didn't get the lock.
+
+specify backups by -f filename, -m mailbox, -u userid
+default run mode as above
+-s to fork an sqlite of the index (and unlock when it exits)
+-x to fork a command of your choosing (and unlock when it exits)
+
+
+reconstruct
+-----------
+
+rebuilding backups.db from on disk files
+
+scan each backup partition for backup files:
+  * skip timestamped files (i.e. backups from compact/reindex)
+  * skip .old files (old backups from reindex)
+  * .index files => skip???
+  * skip unreadable files
+  * skip empty files
+  * skip directories etc
+
+what's the correct procedure for repopulating a cyrus database?
+keep copy of the previous (presumably broken) one?
+
+trim off mkstemp suffix (if any) to find userid
+can we use a recognisable character to delimit the mkstemp suffix?
+
+what if there's multiple backup files for a given userid? precedence?
+
+verify found backups before recording.  reindex?
+
+locking? what if something has a filename and does stuff with it while
+reconstruct runs?
+
+backupd always uses db for opens, so as long as reconstruct keeps the db
+locked while it works, the db won't clash.  but backupd might have backups
+still open from before reconstruct started, which it will write to quite
+happily, even though reconstruct might decide that some other file is the
+correct one for that user...
+
+a backup server would generally be used only for backups, and sync_client
+is quite resilient when the destination isn't there, so it's actually
+no problem to just shut down cyrus while reconstruct runs.  no outage to
+user-facing services, just maybe some sync backlog to catch up on once
+cyrus is restarted.
+
+
+ctl_backups
+-------------
+
+sbin tool for mass backup/index/database operations
+
+needs:
+    * rebuild backups.db from disk contents
+    * list backups/info
+    * rename a backup
+    * delete a backup
+    * verify a backup (check all sha1's, not just most recent)
+
+not sure if these should be included, or separate tools:
+    * reindex a backup (or more)
+    * compact a backup (or more)
+    * lock a backup
+    * some sort of rolling compaction?
+
+usage:
+    ctl_backups [options] reconstruct                       # reconstruct backups.db from disk files
+    ctl_backups [options] list [list_opts] [[mode] backup...] # list backup info for given/all users
+    ctl_backups [options] move new_fname [mode] backup      # rename a backup (think about this more)
+    ctl_backups [options] delete [mode] backup              # delete a backup
+    ctl_backups [options] verify [mode] backup...           # verify specified backups
+    ctl_backups [options] reindex [mode] backup...          # reindex specified backups
+    ctl_backups [options] compact [mode] backup...          # compact specified backups
+    ctl_backups [options] lock [lock_opts] [mode] backup    # lock specified backup
+
+options:
+    -C alt_config       # alternate config file
+    -F                  # force (run command even if not needed)
+    -S                  # stop on error
+    -v                  # verbose
+    -w                  # wait for locks (i.e. don't skip locked backups)
+
+mode:
+    -A                  # all known backups (not valid for single backup commands)
+    -D                  # specified backups interpreted as domains (nvfsbc)
+    -P                  # specified backups interpreted as userid prefixes (nvfsbc)
+    -f                  # specified backups interpreted as filenames
+    -m                  # specified backups interpreted as mboxnames
+    -u                  # specified backups interpreted as userids (default)
+
+lock_opts:
+    -c                  # exclusively create backup
+    -s                  # lock backup and open index in sqlite
+    -x cmd              # lock backup and execute cmd
+    -p                  # lock backup and wait for eof on stdin (default)
+
+list_opts:
+    -t [hours]          # "stale" (no update in hours) backups only (default: 24)
+
+
+cyr_backup
+----------
+
+sbin tool for inspecting backups
+
+needs:
+    * better name?
+    * list stuff
+    * show stuff
+    * dump stuff
+    * restore?
+
+* should lock/move/delete (single backup commands) from ctl_backups be moved here?
+
+usage:
+    cyr_backup [options] [mode] backup list [all | chunks | mailboxes | messages]...
+    cyr_backup [options] [mode] backup show chunks [id...]
+    cyr_backup [options] [mode] backup show messages [guid...]
+    cyr_backup [options] [mode] backup show mailboxes [mboxname | uniqueid]...
+    cyr_backup [options] [mode] backup dump [dump_opts] chunk id
+    cyr_backup [options] [mode] backup dump [dump_opts] message guid
+    cyr_backup [options] [mode] backup json [chunks | mailboxes | messages]...
+
+options:
+    -C alt_config       # alternate config file
+    -v                  # verbose
+
+mode:
+    -f                  # backup interpreted as filename
+    -m                  # backup interpreted as mboxname
+    -u                  # backup interpreted as userid (default)
+
+commands:
+    list: table of contents, one per line
+    show: indexed details of listed items, one per paragraph, detail per line
+    dump: relevant contents from backup stream
+    json: indexed details of listed items in json format
+
+dump options:
+    -o filename         # dump to named file instead of stdout
+
+
+partitions
+----------
+
+not enough information in sync protocol to handle partitions easily?
+
+we know what the partition is when we do an APPLY operation (mailbox, message,
+etc), but the initial GET operations don't include it.  so we need to already
+know where the appropriate backup is partitioned in order to find the backup
+file in order to look inside it to respond to the GET request
+
+if we have a mailboxes database (indexed by mboxname, uniqueid and userid) then
+maybe that would make it feasible?  if it's not in the mailboxes database then
+we don't have a backup for it yet, so we respond accordingly, and get sent
+enough information to create it.
+
+does that mean the backup api needs to take an mbname on open, and it handles
+the job of looking it up in the mailboxes database to find the appropriate
+thing to open?
+
+can we use sqlite for such a database, or is the load on it going to be too
+heavy?  locking?  we have lots of database formats up our sleeves here, so
+even though we use sqlite for the backup index there isn't any particular
+reason we're beholden to it for the mailboxes db too
+
+if we have a mailboxes db then we need a reconstruct tool for that, too
+
+what if we support multiple backup partitions, but don't expect these
+to necessarily correspond with mailbox partitions.  they're just for spreading
+disk usage around.
+
+* when creating a backup for a previously-unseen user we'd pick a random
+  partition to put them on
+* ctl_backups would need a command to move an existing backup to a
+  given partition
+* ctl_backups would need a command to pre-create a user backup on a
+  given partition for initial distribution
+* instead of "backup_data_path" setting, have one-or-more
+  "backuppartition-<name>" settings, ala partition- and friends
+
+see imap/partlist.[ch] for partition list management stuff.  it's complicated
+and doesn't have a test suite, so maybe save this implementation until needed.
+
+but... maybe rename backup_data_path to backuppartition-default in the meantime,
+so that when we do add this it's not a complicated reconfig to update?
+
+partlist_local_select (and lazy-loaded partlist_local_init) are where the
+mailbox partitions come from (see also mboxlist_create_partition), do something
+similar for backup partitions
+
+
+data corruption
+---------------
+
+backups.db:
+    * can be reconstructed from on disk files at any time
+    * how to detect corruption? does cyrus_db detect/repair on its own?
+
+backup indexes:
+    * can be reindexed at any time from backup data
+    * how to detect corruption? assume sqlite will notice, complain?
+
+backup data:
+    * what's zlib's failure mode? do we lose the entire chunk or just the corrupt bit?
+    * verify will notice sha1sum mismatches
+    * dlist format will reject some kinds of corruption (but not all)
+    * reindex: should skip unparseable dlist lines
+    * message data has its own checksums (guid)
+    * reindex: should skip messages that don't match their own checksums
+    * compact: "full" compact will only keep useful data according to index
+    * backupd: will sync anything that's in user mailbox but not in backup index
+
+i think this means that if a message or mailbox state becomes corrupted in
+the backup data file, and it still exists in the user's real mailbox, you
+recover from the corruption by reindexing and then letting the sync process
+copy the missing data back in again.  and you can tidy up the data file by
+running a compact over it.
+
+you detect data corruption in most recent chunk reactively as soon as the
+backup system needs to open it again (quick verify on open)
+
+you detect data corruption in older chunks reactively by trying to restore from
+it.  may be too late: if a message needs restoring it's because user mailbox no
+longer has it
+
+you detect data corruption preemptively by running the verify tool over it.
+recommend scheduling this in EVENTS/cron?
+
+if data corruption occurs in message that's no longer in user's mailbox, that
+message is lost.  it was going to be deleted from the backup after $retention
+period anyway (by compact), but if it needs restoring in the meantime, sorry
+
+
+installation instructions
+-------------------------
+
+(obviously, most of this won't work at this point, because the code doesn't
+exist.  but this is, approximately, where things are heading.)
+
+on your backup server:
+    * compile with --enable-backup configure option and install
+    * imapd.conf:
+        backuppartition-default: /var/spool/backup  # FIXME better example
+        backup_db: twoskip
+        backup_db_path: /var/imap/backups.db
+        backup_staging_path: /var/spool/backup
+        backup_retention_days: 7
+    * cyrus.conf SERVICES:
+        backupd cmd="backupd" listen="csync" prefork=0
+        (remove other services, most likely)
+        (should i create a master/conf/backup.conf example file?)
+    * cyrus.conf EVENTS:
+        compact cmd="ctl_backups compact -A" at=0400
+    * start server as usual
+    * do i want a special port for backupd?
+
+on your imap server:
+    * imapd.conf:
+        sync_log_channels: backup
+        sync_log: 1
+        backup_sync_host: backup-server.example.com
+        backup_sync_port: csync
+        backup_sync_authname: ...
+        backup_sync_password: ...
+        backup_sync_repeat_interval: ... # seconds, smaller value = livelier backups but more i/o
+        backup_sync_shutdown_file: ....
+    * cyrus.conf STARTUP:
+        backup_sync cmd="sync_client -r -n backup"
+    * cyrus.conf SERVICES:
+        restored cmd="restored" [...]
+    * start/restart master
+
+files and such:
+    {configdirectory}/backups.db                        - database mapping userids to backup locations
+    {backuppartition-name}/<hash>/<userid>_XXXXXX       - backup data stream for userid
+    {backuppartition-name}/<hash>/<userid>_XXXXXX.index - index into userid's backup data stream
+
+do i want rhost in the path?
+    * protects from issue if multiple servers are trying to back up their own version of same user
+      (though this is its own problem that the backup system shouldn't have to compensate for)
+    * but makes location of undifferentiated user unpredictable
+    * so probably not, actually
+
+
+chatting about implementation 20/10
+-----------------------------------
+
+::
+
+    09:54 @elliefm
+    here's a fun sync question
+    APPLY MESSAGE provides a list of messages
+    can a single APPLY MESSAGE contain messages for multiple mailboxes and/or users?
+    my first hunch is that it doesn't cross users, since the broadest granularity for a single sync run is USER
+    10:06 kmurchison
+    We'd have to check with Bron, but I *think* messages can cross mailboxes for a single user
+    10:06 @brong
+    yes
+    APPLY MESSAGE just adds it to the reserve list
+    10:07 @elliefm
+    nah apply message uploads the message, APPLY RESERVE adds it to the reserve list :P
+    10:07 @brong
+    same same
+    APPLY RESERVE copies it from a local mailbox
+    APPLY MESSAGE uploads it
+    10:07 @elliefm
+    yep
+    10:07 @brong
+    they both wind up in the reserve list
+    10:07 @elliefm
+    ahh i see what you mean, gotcha
+    10:07 @brong
+    until you send a RESTART
+    ideally you want it reserve in the same partition, but it will copy the message over if it's not on the same partition
+    there's no restriction on which mailbox it came from/went to
+    good for user renames, and good for an append to a bunch of mailboxes in different users / shared space all at once
+    (which LMTP can do)
+    10:10 @elliefm
+    i can handle the case where a single APPLY MESSAGE contains messages for multiple mailboxes belonging to the same user
+    but i'm in trouble if a single APPLY MESSAGE can contain messages belonging to different users
+    10:14 @brong
+    @elliefm: why?
+    10:14 @brong
+    you don't have to keep them if they aren't used
+    10:15 @elliefm
+    for backups - when i see the apply, i need to know which user's backup to add it to.  that's easy enough if it doesn't cross users but gets mega fiddly if it does
+    i'm poking around in sync client to see if it's likely to be an issue or not
+    11:00 @brong_
+    @elliefm: I would stage it, and add it to users as it gets refcounted in by an index file
+    11:07 @elliefm
+    that's pretty much what we do for ordinary sync and delivery stuff yeah?
+    11:08 @brong_
+    yep
+    and it's what the backup thing does
+    11:09 @elliefm
+    i'm pretty sure that APPLY RESERVE and APPLY MESSAGE don't give a damn about users, they're just "here's every message you might not have already had since last time we spoke" and it lets the APPLY MAILBOX work out where to attach them later
+    11:09 @brong_
+    yep
+    11:09 @elliefm
+    so yeah, i'll need to do something here
+    i've been working so far on the idea that a single user's backup consists of 1) an append-only gzip stream of the sync protocol chat that built it, and 2) an index that tracks current state of mailboxes, and offsets within (1) of message data
+    that gets us good compression (file per user, not file per message), and if the index gets corrupted or lost, it's rebuildable purely from (1), it doesn't need a live copy of the original mailbox
+    11:12 @brong
+    yep, that all works
+    11:12 @elliefm
+    (so if you lose your imap server, you're not unable to rebuild a broken index on the backup)
+    11:13 @brong
+    it's easy enough to require the sync protocol stream to only contain messages per user
+    though "apply reserve" is messy
+    because you need to return "yes, I have that message"
+    11:13 @elliefm
+    with that implementation i can't (easily) keep user.a's messages from not existing in user.b's data stream (though they won't be indexed)
+    11:14 @brong
+    I'm not too adverse to the idea of just unpacking each message as it comes off the wire into a temporary directory
+    11:14 @elliefm
+    (because at the time i'm receiving the sync data i don't know which it needs to go in, so if they come in in the same reserve i'd need to append them to both data streams)
+    which isn't a huge problem, just… irks me a bit
+    11:14 @brong
+    and then reading the indexes as they come in, checking against the state DB to see if we already have them, and streaming them into the gzip if they aren't there yet
+    what we can do is something like the current format, where files go into a tar
+    11:16 @elliefm
+    i guess the fiddly bit there is that there's one more moving part to keep synchronised across failure states
+    a backup for a single user becomes 1) data stream + 2) any messages that were uploaded but not yet added to a mailbox + 3) index (which doesn't know what to do with (2))
+    which in the general case is fine, the next sync will update the mailboxes, which will push (2) into (1) and index it nicely, and on we go
+    but it's just a little bit more mess if there's a failure that you need to recover from between those states — it's no longer a simple case of "it's in the backup and we know everything about it" or "it doesn't exist", there's a third case of "well we might have the data but don't really know what to do with it"
+    the other fiddly bit is that the process of appending to the data stream is suddenly in the business of crafting output rather than simply dumping what it gets, which isn't really burdensome, but it is one more little crack for bugs to crawl into
+    i guess in terms of sync protocol, one thing i could do on my end is identify apply operations that seem to contain multiple users' data, and just return an error on those.  the sync client on the other end will promote them until they're eventually user syncs, which i think are always user granularity
+    11:50 @elliefm
+    i think for now, first stage implementation will be to stream the reserve/message commands in full to every user backup they might apply to.  and optimising that down so that each stream only contains messages belonging to that user can be a future optimisation
+
+
+todo list
+---------
+
+* clean up error handling
+* perl tool to anonymise sync proto talk
+* verification step to check entire data stream for errors (even chunks that aren't indexed)
+* prot_fill_cb: extra argument to pass back an error string to prot_fill
+* ctl_backups verify: set level
+* backupd: don't block on locked backups, return mailbox locked -- but sync_client doesn't handle this
+* test multiple backup partitions
+* configure: error if backups requested and we don't have zlib
+* valgrind
+* finish reconstruct
+* compact: split before append?
+
+compact implementation steps:
+    1 remove unused chunks, keep everything else as is
+    2 join adjacent chunks if small enough, split large chunks
+    3 parse/rebuild message lines
+    4 discard unused mailbox lines
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/bytecode.rst 3.2.0-3/docsrc/imap/developer/thoughts/bytecode.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/bytecode.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/bytecode.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,155 @@
+.. _imap-developer-thoughts-bytecode:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Sieve Bytecode
+=================================
+
+Motivation
+----------
+
+The motivation behind moving to Sieve Bytecode is severalfold:
+
+-  Parsing a script at each execution is expensive computationally
+-  Lex/Yacc are costly in terms of memory usage and executable size,
+   whereas a bytecode parser is much lighter weight.
+-  Using bytecode can simplify the code for the execution phase, which
+   is far more frequently occurring than the upload/compile phase.
+-  Rewriting a significant part of the sieve execution framework forces
+   a decent amount of refactoring on what has traditionally been a
+   problematic part of the Cyrus code base. There is still work to do in
+   this area.
+
+Overall Bytecode Format
+-----------------------
+
+In the final bytecode, each opcode/parameter is aligned on a 4-byte
+boundary. Strings are NUL-terminated (and padded to a 4-byte boundary as
+needed).
+
+Ideally, we'd have all integers in network byte order, so as to make the
+scripts portable, but version 1 does not have this feature.
+
+At the beginning of the file, there is a magic header to identify it as
+a bytecode file, and a 4 byte version number. Immediately following the
+version number are the opcodes that relate to the script.
+
+Generation
+----------
+
+A Sieve Bytecode file is generated in three "passes":
+
+-  Generate a parse tree using lex/yacc from the sieve script. (addr.y,
+   addr-lex.l, sieve.y, sieve-lex.l).
+-  Serialize the parse tree into an intermediate form, where strings are
+   held separate from the rest of the representation. (bc\_generate.c)
+-  Serialize the intermediate form into the final bytecode. (bc\_emit.c)
+
+The intermediate form is an array of bytecode\_t unions, with strings
+located elsewhere in memory. The entry point is bc\_generate:
+sieve\_generate\_bytecode() / bc\_action\_generate().
+
+bc\_action\_generate traverses the commandlist\_t tree and emits opcodes
+in sequence.
+
+Simple actions (STOP, DISCARD, KEEP, MARK, UNMARK) have no arguments,
+and processing proceeds directly.
+
+More complicated options have a sequence of arguments that are emitted
+following the initial opcode.
+
+For example, single argument commands such as REJECT, FILEINTO, REDIRECT
+are followed by a bytecode\_t for a string's length, and then a
+bytecode\_t which contains a pointer to a string.
+
+Commands such as ADDFLAG, SETFLAG, REMOVEFLAG, which take a stringlist,
+format the stringlist as (using bc\_stringlist\_generate):
+
+::
+
+    {Number of Strings}{String 1 Length}{String 1 Ptr}{String 2 Length}....
+
+So their resulting final output would appear as:
+
+::
+
+    {Opcode}{...stringlist from above...}
+
+Even more complicated action opcodes (vacation, notify) etc, may take a
+sequence of integer values (flags), stringlists, or individual strings.
+These are more specifically documented in the code.
+
+This leaves us with the IF keyword (and tests). In the pass 1 form, IF
+appears as the following bytecode\_t structures:
+
+::
+
+    {IF opcode}
+    {Beginning of the then block}
+    {End of the then block / beginning of the else block}
+    {End of the else block / -1 for no else block}
+    {....test opcodes....}
+    {....'then' action opcodes....}
+    {....'else' action opcodes.... [optional]}
+
+Test opcodes are generated by the bc\_test\_generate function, which is
+very similar to bc\_action\_generate (tests without arguments are just
+opcodes, tests with arguments have them serialized into place directly
+following the original opcode). Test lists are represented as {number of
+tests}{address of the end of the list}{test 1}{test 2}.
+
+In the third pass, strings are serialized into place, and if statement
+jumps are resolved to actual addresses within the file This is done in
+bc\_emit: sieve\_emit\_bytecode / bc\_action\_emit.
+
+This results in a totally serialized representation, using byte offsets
+within the file instead of indexes into the array of bytecode\_t's. In
+addition to the manipulations that are necessary to do this, there are
+several other changes in format.
+
+Two new opcodes exist: NULL and JUMP (which performs an unconditional
+jump).
+
+Stringlists and testslists now include a precomputed byte length of the
+entire list, so it can be skipped over as needed.
+
+So as to be executable without a stack, the IF statements are designed
+as follows:
+
+::
+
+    {IF opcode}
+    {....test block....}
+    {JUMP (location of false condition) }
+    {....then block....}
+    {(if there is an else) JUMP (end of else block)}
+    {(if there is an else) .... else block ....}
+
+The idea being that if the test is true, the instruction pointer should
+move to the then block, otherwise the else block will be hit
+automatically (due to the unconditional jump).
+
+Evaluation
+----------
+
+The evaluation routines are in bc\_eval.c, the basic idea is that we can
+simply mmap the bytecode, run straight through it, and complete the
+processing without maintaining a stack.
+
+The processing is done by overlaying a bytecode\_input\_t array over the
+mmap. This allows addressing elements within the file to be simple.
+There is an instruction pointer which is incremented as each action is
+performed, or as actions/tests are skipped.
+
+Of special note in bc\_eval.c is the unwrap\_string function which will
+pull a string out of the bytecode, and return the instruction pointer at
+the end of the string.
+
+Other things to consider
+------------------------
+
+The Bytecode can be extended to contain other extensions. This could
+require regeneration of older scripts. In many cases this can be avoided
+by putting the new commands at the end of the proper enum in bytecode.h
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/caldav_scheduling_flowchart.rst 3.2.0-3/docsrc/imap/developer/thoughts/caldav_scheduling_flowchart.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/caldav_scheduling_flowchart.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/caldav_scheduling_flowchart.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,378 @@
+.. _imap-developer-thoughts-caldavflow:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus CalDAV Scheduling Flowchart
+=================================
+
+caldav\_put() - create/modify via HTTP PUT on a resource or POST (add-member) on a calendar
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check if the new resource is a scheduling resource (contains
+   ORGANIZER property). If not, skip to step 4.
+#. Check for (and load) any existing resource.
+#. Check if the authenticated user matches ORGANIZER:
+
+   -  If yes:
+
+      -  If only voter (VPOLL) responses changed, goto
+         `sched\_pollstatus() <#sched_pollstatus>`__.
+      -  Otherwise, goto `sched\_request() <#sched_request>`__.
+
+   -  Otherwise, goto `sched\_reply() <#sched_reply>`__.
+
+#. Store the new/modified resource.
+
+caldav\_delete\_sched() - remove via HTTP DELETE on a resource
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check if the existing resource is a scheduling resource (has
+   Schedule-Tag). If not, we are done.
+#. Load the existing resource.
+#. Check if the authenticated user matches ORGANIZER. If yes, goto
+   `sched\_request() <#sched_request>`__, otherwise goto
+   `sched\_reply() <#sched_reply>`__.
+
+caldav\_post() - busytime query via HTTP POST on Scheduling Outbox
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Check the ACL on the owner's Scheduling Outbox. If the authenticated
+   user doesn't have the DACL\_SCHEDFB right, fail.
+#. `sched\_busytime\_query() <#sched_busytime_query>`__.
+
+--------------
+
+sched\_pollstatus - perform a voter response update
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#.
+
+--------------
+
+sched\_request() - perform an organizer request / attendee status update
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL\_INVITE right, fail.
+
+If the request includes a resource, then set METHOD:REQUEST, otherwise
+set METHOD:CANCEL.
+
+Create an iTIP message template, copying over any CALSCALE property and
+VTIMEZONE components.
+
+If not an attendee status update and the existing resource is a
+scheduling resource: Foreach component in the existing resource, add it
+and its SEQUENCE to our hash table keyed by RECURRENCE-ID (for
+comparison against new/modified resource).
+
+Create a hash table of attendees. This will hold attendee-specific iTIP
+messages.
+
+Foreach component in the new/modified resource:
+
+a. Lookup (by RECURRENCE-ID) and remove the component from the hash
+   table of existing components.
+b. If the component exists compare all of DTSTART, DTEND, DURATION,
+   RRULE, RDATE, EXDATE to those of the new component.
+c. If the component is new or changed, then
+   `process\_attendees() <#process_attendees>`__.
+
+Foreach remaining component in the hash table of existing components do
+`sched\_cancel() <#sched_cancel>`__.
+
+Foreach iTIP message in our hash table of ATTENDEES,
+`sched\_deliver() <#sched_deliver>`__ the iTIP message.
+
+Foreach component in the new/modified resource update the
+SCHEDULE-STATUS of each ATTENDEE.
+
+process\_attendees() - create a suitable iTIP request message for each attendee
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach ATTENDEE in the component, remove the SCHEDULE-STATUS parameter,
+and set PROPSTAT=NEEDS-ACTION if required.
+
+Make a copy of the component and
+`clean\_component() <#clean_component>`__.
+
+Foreach ATTENDEE in the cleaned component:
+
+a. Check the CalDAV Scheduling parameters. If SCHEDULE-AGENT != SERVER,
+   skip to the next attendee.
+b. Lookup attendee in our hash table.
+c. If it doesn't exist, create a clone of our iTIP template and insert
+   it into our hash table of attendees.
+d. Add the component to the attendee's iTIP message.
+e. Add the component “number” to our mask of new components appearing in
+   the attendee's iTIP message.
+
+If the component is not the "master", foreach attendee do
+`sched\_exclude() <#sched_exclude>`__.
+
+sched\_exclude() - exclude an attendee from a recurrence instance
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. If the component did not appear in the attendee's iTIP message, add
+   an EXDATE property (based on the RECURRENCE-ID of the component) to
+   the master component of the attendee's iTIP message.
+
+sched\_cancel() - cancel an organizer event/task
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Set STATUS:CANCELLED on the component.
+#. `process\_attendees() <#process_attendees>`__.
+
+--------------
+
+sched\_reply() - perform an attendee reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the CalDAV Scheduling parameters on ORGANIZER. If SCHEDULE-AGENT
+!= SERVER, we are done.
+
+Check the ACL on the owner's Scheduling Outbox. If the authenticated
+user doesn't have the DACL\_REPLY right, fail.
+
+Create a new iTIP (METHOD:REPLY) message, copying over any CALSCALE
+property and VTIMEZONE components.
+
+Foreach component in the existing resource:
+
+a. `trim\_attendees() <#trim_attendees>`__.
+b. Add the trimmed component and the attendee's PARTSTAT to our hash
+   table keyed by RECURRENCE-ID (for comparison against new/modified
+   resource).
+
+Foreach component in the new/modified resource:
+
+`trim\_attendees() <#trim_attendees>`__.
+
+Lookup (by RECURRENCE-ID) and remove the component from the hash table
+of existing components.
+
+If the component exists:
+
+i.  If component is VPOLL, add voter responses to REPLY via
+    `sched\_vpoll\_reply(). <#sched_vpoll_reply>`__
+ii. Otherwise, compare the PARTSTAT of the ATTENDEE to that of the new
+    component.
+
+If the component is new or the PARTSTAT has changed:
+
+i.   `clean\_component() <#clean_component>`__.
+ii.  Add the component to our iTIP message.
+iii. Add the component “number” to our mask of new components appearing
+     in our iTIP message.
+
+Foreach remaining component in the hash table of existing components do
+`sched\_decline() <#sched_decline>`__.
+
+`sched\_deliver() <#sched_deliver>`__ our iTIP message.
+
+Foreach component in the new/modified resource that appeared in our iTIP
+message, update the SCHEDULE-STATUS of the ORGANIZER.
+
+trim\_attendees() - remove all attendees other than the one replying
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Clone the component and remove all ATTENDEE properties other than the
+   one corresponding to the owner of the calendar.
+#. Return the ATTENDEE property of owner, his/her PARTSTAT parameter,
+   and the RECURRENCE-ID of the component.
+
+sched\_vpoll\_reply() - add voter responses to VPOLL reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#.
+
+sched\_decline() - decline a recurrence instance for an attendee
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Set PARTSTAT of ATTENDEE to DECLINED.
+#. `clean\_component() <#clean_component>`__.
+#. Add the component to our iTIP message.
+
+--------------
+
+clean\_component() - sanitize a component for use in an iTIP message
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Update DTSTAMP.
+#. Remove any VALARM components.
+#. For a reply/decline only, remove scheduling parameters from
+   ORGANIZER.
+
+sched\_deliver() - deliver an iTIP message to a recipient
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Lookup the recipient.
+#. If local to our server goto
+   `sched\_deliver\_local() <#sched_deliver_local>`__, otherwise goto
+   `sched\_deliver\_remote() <#sched_deliver_remote>`__.
+
+--------------
+
+sched\_deliver\_local() - deliver an iTIP message to a local user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Check the ACL on the owner's Scheduling Inbox. If the sender doesn't
+have the proper right (DACL\_INVITE for request/cancel, DACL\_REPLY for
+reply), fail.
+
+Search the recipient's calendars for a resource having the specified
+UID.
+
+If the resource doesn't exist:
+
+a. If the iTIP method is REPLY, fail (we are done).
+b. If the iTIP method is CANCEL, ignore it (we are done).
+c. Otherwise, create a new (empty) attendee object and target the
+   recipient's Default calendar.
+
+Otherwise, load the existing resource.
+
+Update the new/existing resource:
+
+a. If the iTIP method is CANCEL, set STATUS:CANCELLED on all existing
+   components.
+b. If the iTIP method is REPLY, do
+   `deliver\_merge\_reply() <#deliver_merge_reply>`__.
+c. If the iTIP method is REQUEST, do
+   `deliver\_merge\_request() <#deliver_merge_request>`__.
+d. If the iTIP method is POLLSTATUS, do
+   `deliver\_merge\_pollstatus() <#deliver_merge_pollstatus>`__.
+
+Store the new/updated resource in the recipient's target calendar.
+
+Record the delivery status (SCHEDULE-STATUS).
+
+If the iTIP message is something other than just a PARTSTAT update from
+an attendee, store the iTIP message as a new resource in the recipient's
+Inbox.
+
+If the iTIP method is REPLY, send an update other attendees via
+`sched\_pollstatus() <#sched_pollstatus>`__ (VPOLL only) or
+`sched\_request() <#sched_request>`__.
+
+deliver\_merge\_reply() - update an organizer resource with an attendee reply
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.
+
+If the component doesn't exist (new recurrence overridden by ATTENDEE)
+create a new recurring component:
+
+i.   Clone the existing master component.
+ii.  Remove the RRULE property.
+iii. Add the RECURRENCE-ID from the iTIP message.
+iv.  Replace the DTSTART, DTEND, SEQUENCE properties with those from the
+     iTIP message.
+v.   Add the new component to our existing resource.
+
+Get the sending ATTENDEE from the iTIP message.
+
+Find the matching ATTENDEE in the existing component.
+
+If not found (ATTENDEE added themselves to this recurrence), add new
+ATTENDEE to the component.
+
+Set the ATTENDEE PARTSTAT, RSVP, and SCHEDULE-STATUS parameters in the
+existing component.
+
+If the component is VPOLL, update the voter responses in the existing
+component via
+`deliver\_merge\_vpoll\_reply() <#deliver_merge_vpoll_reply>`__.
+
+Return the sending ATTENDEE.
+
+deliver\_merge\_vpoll\_reply() - update an organizer resource with voter responses
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. Foreach sub-component in the existing resource, replace any voter
+   response(s) with those from the reply.
+
+deliver\_merge\_request() - create/update an attendee resource with an organizer request
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach VTIMEZONE component in the existing resource, add it to our hash
+table keyed by TZID (for comparison against iTIP message).
+
+Foreach VTIMEZONE component in the iTIP message:
+
+a. Lookup (by TZID) the VTIMEZONE component from the hash table of
+   existing components.
+b. If the component exists, remove it from the existing object.
+c. Add the VTIMEZONE from the iTIP message to our existing object.
+
+Foreach component in the existing resource, add it to our hash table
+keyed by RECURRENCE-ID (for comparison against iTIP message).
+
+Foreach component in the iTIP message:
+
+Clone a new component from the iTIP component.
+
+Lookup (by RECURRENCE-ID) the component from the hash table of existing
+components.
+
+If the component exists:
+
+i.   Compare the SEQUENCE of the new component to the existing component
+     to see if it has changed.
+ii.  Copy any COMPLETED, PERCENT-COMPLETE, or TRANSP properties from the
+     existing component to the new component.
+iii. Copy any ORGANIZER SCHEDULE-STATUS parameter from the existing
+     component to the new component.
+iv.  Remove the existing component from the existing object.
+
+Add the new component to the existing object.
+
+deliver\_merge\_pollstatus() - update voter responses on a voter resource
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Foreach sub-component in the existing resource, add it to our hash table
+keyed by POLL-ITEM-ID (for comparison against iTIP message). The
+sub-component entry includes a hash table of VOTERs.
+
+Foreach sub-component in the iTIP message:
+
+a. Lookup (by POLL-ITEM-ID) the sub-component from the hash table of
+   existing sub-components.
+b. If the component exists, foreach VOTER in the sub-component in the
+   iTIP message:
+
+   i.  Lookup VOTER in the hash table of existing sub-component.
+   ii. Add/update VOTER response.
+
+--------------
+
+sched\_deliver\_remote() - deliver an iTIP message to a remote user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#. If the recipient is local to our Murder, goto
+   `isched\_send() <#isched_send>`__, otherwise goto
+   `imip\_send() <#imip_send>`__.
+#. Retrieve status of iTIP message delivery.
+
+isched\_send() - deliver an iTIP message to a remote user via iSchedule (HTTP)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+imip\_send() - deliver an iTIP message to a remote user via iMIP (SMTP)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+sched\_busytime\_query() - perform a busytime query
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+busytime\_query\_local() - perform a busytime query on a local user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+busytime\_query\_remote() - perform a busytime query on a remote user
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/improved_mboxlist_sort.rst 3.2.0-3/docsrc/imap/developer/thoughts/improved_mboxlist_sort.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/improved_mboxlist_sort.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/improved_mboxlist_sort.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,32 @@
+.. _imap-developer-thoughts-improved_mboxlist_sort:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Enabling improved_mboxlist_sort
+=================================
+
+You can't enable and disable ``improved_mboxlist_sort`` on a live
+system. You need to dump and load the necessary database after stopping
+and before starting the master process.
+
+Dumping the mailboxes.db file
+
+::
+
+    ctl_mboxlist -d > /var/tmp/mailboxes.txt
+    ctl_mboxlist -u < /var/tmp/mailboxes.txt
+
+If your subscription databases are not in flat files you need to do
+something similar. Each user will have his own subscription file. Do the
+following for each subscription file.
+
+::
+
+    cyr_dbtool -C $file skiplist show > $file.TXT
+    cyr_dbtool -n $file skiplist set < $file.TXT
+
+The above fragments will overwrite the original file. So you could
+redirect to a temporary file and overwrite the database if the import
+succeeds.
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/notes.rst 3.2.0-3/docsrc/imap/developer/thoughts/notes.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/notes.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/notes.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,19 @@
+.. _imap-developer-thoughts-notes:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Notes
+========================
+
+-  appending: it's important that the index records for individual
+   messages make it to disk before the index header indicating that
+   they're there. so something like:
+
+   #. sync messages to disk (or depend on ``link()`` being atomic)
+   #. create new index records, flush to disk
+   #. create new header if necessary (adding new user flag), flush to
+      disk
+   #. flush cache file
+   #. update index header, flush to disk
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts/prot-events.rst 3.2.0-3/docsrc/imap/developer/thoughts/prot-events.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts/prot-events.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts/prot-events.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,59 @@
+.. _imap-developer-thoughts-prot-events:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.  Converted via the pandoc tool from HTML.
+
+Cyrus IMAP Server: Prot Events
+==============================
+
+From an email exchange between Ken Murchison and Lawrence Greenfield,
+dated 03 Feb 2002 (slightly redacted and formatted for your viewing
+pleasure):
+
+|    From: Ken Murchison
+|    To: Lawrence Greenfield
+|    Subject: Re: prot events
+|
+
+    Lawrence Greenfield wrote:
+
+        Can you give me some details on how the event API in the prot
+        layer works?  I'm a little unclear about the memory management,
+        what should be returned from the event callback,
+
+    Either the event pointer (if the event is still active), or NULL
+    (if the event has been removed by the callback).
+
+        and how to reschedule an event.
+
+    Simply set the 'mark' time in the event to the wall time you want
+    it to run again.
+
+        (I'd like to make an event called every X seconds of idle time;
+        I know the API can't do exactly that but I suspect I can fake
+        it well enough.)
+
+    Look at backend_timeout() in proxyd.c and/or drac_ping() in
+    contrib/drac_auth.patch, they do exactly this.
+
+    The API is pretty simple:
+
+    *   use prot_addwaitevent() to add an event (linked list) callback
+        onto a stream.  takes the stream, the 'mark' time at which to
+        run the event (NOT an interval, but the future clock value),
+        the function pointer, and a rock to pass to the callback as
+        args, and returns a pointer to the event (to use for future
+        removal).
+
+    *   use prot_removewaitevent() to remove an event.  takes the
+        stream and a pointer to the event as args.
+
+    *   the event callback gets the stream, a pointer to the event
+        and the rock as args.  To reschedule an event, simply set the
+        'mark' time and return the event pointer.  If the callback
+        removes the event, then return NULL.
+
+    If you see and flaws in this API, feel free to go ahead and change it.
+
+    Ken
diff -pruN 3.0.13-5/docsrc/imap/developer/thoughts.rst 3.2.0-3/docsrc/imap/developer/thoughts.rst
--- 3.0.13-5/docsrc/imap/developer/thoughts.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/thoughts.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-developer-thoughts:
+
+.. author: Nic Bernstein (Onlight)
+
+==========================
+Developer Thoughts & Notes
+==========================
+
+.. toctree::
+    :maxdepth: 1
+    :titlesonly:
+    :glob:
+
+    thoughts/*
diff -pruN 3.0.13-5/docsrc/imap/developer/unit-tests.rst 3.2.0-3/docsrc/imap/developer/unit-tests.rst
--- 3.0.13-5/docsrc/imap/developer/unit-tests.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer/unit-tests.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,628 @@
+.. _imap-developer-unit-tests:
+
+..  Note: This document was converted from the original by Nic Bernstein
+    (Onlight).  Any formatting mistakes are my fault and not the
+    original author's.
+
+Unit Tests
+==========
+
+Table of Contents
+-----------------
+
+-  `1. Introduction <#introduction>`__
+-  `2. What Is A Unit Test? <#what-is-a-unit-test>`__
+-  `3. Running The Tests <#running-the-tests>`__
+
+   -  `3.1. Setting Up The Machine <#setting-up-the-machine>`__
+   -  `3.2 Configure Script <#configure-scripts>`__
+   -  `3.3 Make <#running-the-tests>`__
+   -  `3.4 Using Valgrind <#using-valgrind>`__
+   -  `3.5 The Tests Are Failing <#the-tests-are-failing>`__
+   -  `3.6 Debugging A Test <#debugging-a-test>`__
+
+-  `4. Adding Your Own Tests <#adding-your-own-tests>`__
+
+   -  `4.1 Where To Put Your Tests <#where-to-put-your-tests>`__
+   -  `4.1 Adding A New Suite <#adding-a-new-suite>`__
+   -  `4.2 Adding A Test To A Suite <#adding-a-test-to-a-suite>`__
+   -  `4.3 Suite Init And Cleanup <#suite-init-and-cleanup>`__
+
+1. Introduction
+---------------
+
+Recently, a set of regression unit tests has been added to Cyrus. This
+document explains the purpose implementation of those unit tests, and
+gives an example of how to add more unit tests (because there are never
+enough unit tests!).
+
+2. What Is A Unit Test?
+-----------------------
+
+The `definition on Wikipedia <http://en.wikipedia.org/wiki/Unit_test>`__
+sheds some light:
+
+    ...\ **unit testing** is a method by which individual units of
+    source code are tested to determine if they are fit for use. A unit
+    is the smallest testable part of an application.
+
+In other words, unit testing is about verifying that small pieces of
+code, like individual functions, modules, or classes, work in isolation.
+It is **not** about testing the system as a whole.
+
+The tests implemented here are also **regression tests**, which in
+`Wikipedia's words <http://en.wikipedia.org/wiki/Regression_testing>`__
+means:
+
+    **Regression testing** is any type of software testing that seeks to
+    uncover software errors after changes to the program (e.g. bugfixes
+    or new functionality) have been made, by retesting the program. The
+    intent of regression testing is to assure that a change, such as a
+    bugfix, did not introduce new bugs.
+
+In other words, the tests are designed to be easy to run and to work out
+fully automatically whether they have passed or failed, so that they can
+be run usefully by people who didn't write them.
+
+3. Running The Tests
+--------------------
+
+This section takes you through the process of running Cyrus' unit tests.
+
+3.1. Setting Up The Machine
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Cyrus' unit tests are all located in a new directory,
+``cyrus-imapd/cunit/``. They're written in C, like the remainder of
+Cyrus, and use the `CUnit library from
+SourceForge <http://cunit.sourceforge.net/>`__, with some home grown
+wrappers and other improvements to make our lives easier.
+
+Your first step is step is to ensure that the CUnit library (including
+the headers) is installed. Some modern operating systems already have
+CUnit, for example on Ubuntu you can just do:
+
+::
+
+    me@ubuntu> sudo apt-get install libcunit1-dev
+
+Alternately, you can download the CUnit source, build it and install it.
+It's not a complicated or difficult library, this shouldn't take long.
+When you've done, install it in ``/usr/include`` and ``/usr/lib``.
+
+3.2 Configure Script
+~~~~~~~~~~~~~~~~~~~~
+
+Because of the dependency on the CUnit library, the tests are disabled
+by default; this means you need enable them with an option to the
+``configure`` script:
+
+::
+
+    me@mybox> ./configure --enable-unit-tests
+    ...
+    checking for CU\_initialize\_registry in -lcunit... yes
+    checking CUnit/CUnit.h usability... yes
+    checking CUnit/CUnit.h presence... yes
+    checking for CUnit/CUnit.h... yes
+    ...
+
+3.3 Make
+~~~~~~~~
+
+First you need to build Cyrus itself, using the traditional ``all:``
+target.
+
+::
+
+    me@mybox> make all
+    ...
+
+Then, use the new ``check:`` target to build and run the unit tests.
+
+::
+
+    me@mybox> make check
+     cd . && /bin/bash /home/me/cyrus-imapd/missing --run automake-1.11 --foreign Makefile
+     cd . && /bin/bash ./config.status Makefile depfiles (a)
+    config.status: creating Makefile
+    config.status: executing depfiles commands
+    ...
+    make[3]: Entering directory \`/home/me/cyrus-imapd'
+    make[3]: \`sieve/test' is up to date.
+    cunit/cunit.pl --project cunit/default.cunit --generate-wrapper cunit/mboxname.testc (b)
+    gcc -DHAVE\_CONFIG\_H ... -c -o cunit/mboxname.o cunit/mboxname.testc-cunit.c
+    rm -f cunit/mboxname.testc-cunit.c
+    /bin/bash ./libtool --tag=CC --mode=link gcc -fPIC -g -O2 -o
+    cunit/unit cunit/unit.o ... lib/libcyrus\_min.la ... (c)
+    ...
+    Running unit tests (d)
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: mboxname (e)
+      Test: dir\_hash\_c ... passed
+      Test: to\_parts ... passed
+      Test: to\_userid ... passed
+      Test: to\_usermbox ... passed
+    ...
+    --Run Summary: Type      Total     Ran  Passed  Failed (f)
+                   suites       34      34     n/a       0
+                   tests       323     323     323       0
+                   asserts 1079745 1079745 1079745       0
+    make[1]: Leaving directory `/home/me/cyrus-imapd/cunit'
+
+Let's take a closer look at what's happening here.
+
+(a)
+    The ``check:`` target causes automake to re-run itself. This is
+    normal automake behaviour. Note that the older build system used to
+    run make recursively in sub-directories, the newer automake-based
+    system builds everything from the top directory.
+(b)
+    The ``cunit/`` directory contains a number of C source files
+    (called, for reasons too complicated to explain here,
+    *whatever*.testc) with test code in them. For each of those, a small
+    wrapper C source file is generated and then compiled into an object
+    file.
+(c)
+    Finally, all the compiled object files are linked into an
+    executable, with a ``main()`` routine from ``unit.c``, and a number
+    of libraries and object files from other parts of the Cyrus tree.
+(d)
+    The resulting executable is then run.
+(e)
+    The test executable runs all the built tests one by one, telling us
+    which ones passed and which ones failed as it runs them. You can
+    also run it manually with the name of a test as an argument, and it
+    will run only the named test.
+(f)
+    At the end, the text executable prints a summary of how many tests
+    it ran and how many passed and failed. The key thing to look at here
+    is the rightmost column, it should be all zero.
+
+3.4 Using Valgrind
+~~~~~~~~~~~~~~~~~~
+
+Some failure modes are subtle, and cannot be detected in the C code
+itself; this is where `the Valgrind program <http://valgrind.org/>`__
+comes in very handy. It detects buffer overruns and memory leaks and
+various other kinds of subtle errors.
+
+To run the unit tests with Valgrind, use the new ``valgrind:`` target.
+
+::
+
+    me@mybox> make valgrind
+    ...
+    valgrind --tool=memcheck --leak-check=full ./unit -v (a)
+    ==2999== Memcheck, a memory error detector
+    ==2999== Copyright (C) 2002-2010, and GNU GPL'd, by Julian Seward et al.
+    ==2999== Using Valgrind-3.6.0.SVN-Debian and LibVEX; [...]
+    ==2999== Command: ./unit -v
+    ==2999==
+    ...
+    --Run Summary: Type      Total     Ran  Passed  Failed   (b)
+                   suites        9       9     n/a       0
+                   tests        51      51      50       1
+                   asserts     474     474     473       1
+    ...
+    ==2999== HEAP SUMMARY:   (c)
+    ==2999==     in use at exit: 4,489 bytes in 134 blocks
+    ==2999==   total heap usage: 715 allocs, 581 frees, 352,763 bytes allocated
+    ==2999==
+    ==2999== 4 bytes in 1 blocks are definitely lost in loss record 3 of 50
+    ==2999==    at 0x4C2815C: malloc (vg_replace_malloc.c:236)
+    ==2999==    by 0x44A0CA: xmalloc (xmalloc.c:57)
+    ==2999==    by 0x4399D8: strconcat (util.c:631)
+    ==2999==    by 0x40C059: test_uncast_null (strconcat.c:51)
+    ==2999==    by 0x61B32A9: ??? (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x61B36ED: ??? (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x61B3827: CU_run_all_tests (in /usr/lib/libcunit.so.1.0.1)
+    ==2999==    by 0x4066CC: run_tests (unit.c:144)
+    ==2999==    by 0x406806: main (unit.c:283)
+    ==2999==
+    ...
+
+Here's an explanation of what's happening in the example.
+
+(a)
+    The test executable is run as before, but using the ``valgrind``
+    program. The first thing we see is Valgrind's banner message.
+(b)
+    The test executable proceeds as normal and eventually emits it's run
+    summary, then exits.
+(c)
+    After the test executable exits, Valgrind checks for memory leaks
+    and prints both a summary of all leaks and a stack trace showing
+    where each block of leaked memory was allocated.
+
+I'd just like to say that I love Valgrind and I think it's immensely
+useful. I would have made running the tests under Valgrind the only
+option for the ``check:`` target, except that Valgrind is not available
+on all of Cyrus' supported platforms.
+
+3.5 The Tests Are Failing
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+So you've noticed that some of the tests are failing. Let me make the
+guiding principle of unit testing as clear as possible: **THE UNIT TESTS
+SHOULD NOT FAIL**. All of the tests are designed to pass all the time,
+in everyone's environment. The unit tests are run automatically every
+twelve hours on the Cyrus `Continuous Integration
+server <http://ci.cyrusimap.org/>`__, and a failing test fails the whole
+build and makes people unhappy.
+
+There are a few rules which you should follow to help us all get the
+most benefit out of unit testing
+
+-  If you see a test failing, investigate it.
+-  If you can't investigate, complain on the mailing list or raise a bug
+   so that somebody else can investigate.
+-  When writing tests, write them to work in all environments and all
+   combinations of ``configure`` script options. It's ok to have a test
+   which is empty in some circumstances; it's not ok to have a test that
+   fails.
+-  When adding code, write new tests for the new code.
+-  When modifying code, write new tests for the new behaviour.
+-  When looking at old code, also take a look at the `coverage
+   report <http://ci.cyrusimap.org/job/cyrus-imapd-master/887/cobertura/>`__
+   and consider writing tests for the existing code.
+
+3.6 Debugging A Test
+--------------------
+
+With the new Cyrus build system, the file ``cunit/unit`` is no longer an
+executable, it's a shell script which sets up some environment variables
+before running the real executable which is hidden away. This makes
+debugging a failing test somewhat challenging. The solution is:
+
+::
+
+    me@mybox> ( cd cunit ; libtool --mode=execute gdb --args unit -t crc32 )
+    ...
+    Reading symbols from /home/me/cyrus-imapd/cunit/.libs/lt-unit...done.
+    (gdb) list crc32.testc:1
+    1       /* Unit test for lib/crc32.c */
+    2       #include "cunit/cyrunit.h"
+    3       #include "crc32.h"
+    ...
+    (gdb) break test_map
+    Breakpoint 1 at 0x44a2f8: file ./cunit/crc32.testc, line 11.
+    (gdb) run
+    Starting program: /home/me/cyrus-imapd/cunit/.libs/lt-unit -t -v crc32
+    [Thread debugging using libthread_db enabled]
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    Suite: crc32
+      Test: map ...
+    Breakpoint 1, test_map () at ./cunit/crc32.testc:11
+    11          c = crc32_map(TEXT, sizeof(TEXT)-1);
+    (gdb)
+
+
+Note the **-t** option. This turns off test timeouts, which is very
+useful for manual debugging.
+
+4. Adding Your Own Tests
+------------------------
+
+Adding your own tests is quite simple. Here's how.
+
+4.1 Where To Put Your Tests
+---------------------------
+
+The unit test code in Cyrus is contained in a set of C source files in
+the ``cunit`` directory. For reasons too complex to go into here, these
+are named *whatever*.testc instead of the more usual *whatever*.c. If
+you look closely, you will see that each of those C source files maps to
+a "Suite" in CUnit parlance. For example, ``cunit/glob.testc`` is listed
+as the Suite "glob" in CUnit's runtime output.
+
+Typically, each Suite tests a single module or a related set of
+functions; for example, ``cunit/glob.testc`` contains tests for the glob
+module in ``lib/glob.c``.
+
+So, if you want to add a new test for a module which already has some
+existing tests, the sensible thing to do is to `add a new test to the
+existing suite <#adding-a-test-to-a-suite>`__. Otherwise, you'll need to
+`add a new Suite <#adding-a-new-suite>`__.
+
+4.1 Adding A New Suite
+----------------------
+
+Each Suite is a single C source file in the ``cunit/`` directory. Your
+first step is to create a new C source file. For this example, you'll
+create a new Suite to test the CRC32 routines which live in
+``lib/crc32.c``.
+
+::
+
+    me@mybox> vi cunit/crc32.testc
+    ...
+
+The file should contain something like this.
+
+::
+
+    /* Unit test for lib/crc32.c */
+    #include "cunit/cyrunit.h"  (a)
+    #include "crc32.h"  (b)
+
+    static void test_map(void)  (c)
+    {
+        static const char TEXT[] = "lorem ipsum";  (d)
+        static uint32_t CRC32 = 0x0;
+        uint32_t c;  (e)
+
+        c = crc32_map(TEXT, sizeof(TEXT)-1);  (f)
+        CU_ASSERT_EQUAL(c, CRC32);  (g)
+    }
+
+Here's an explanation of what all these bits are for.
+
+(a)
+    You need to include the header ``"cunit/cyrunit.h"``, which is a thin
+    Cyrus wrapper around the CUnit's library's header,
+    ``<CUnit/CUnit.h>`` with some extra conveniences.
+(b)
+    You should also include any headers you need for declarations of the
+    functions which you'll be testing. Note that the Cyrus ``lib/`` and
+    ``imap/`` directories are already in the include path, so any header
+    in there can be included without the directory prefix, e.g.
+    ``"crc32.h"`` for ``lib/crc32.h``.
+(c)
+    You need to have at least one function which looks like this: it
+    takes no arguments, returns void, and is named ``test_whatever``. It
+    may be ``static`` or ``extern``, but I recommend ``static``.
+    Functions with this signature are automatically discovered in the
+    source code by the Cyrus unit test infrastructure, so all you have
+    to do is write the function. Later, a CUnit test named "whatever"
+    will be created automatically for your ``test_whatever`` function.
+(d)
+    Here's a good place to define the test inputs and expected outputs.
+    Note that for this example you have no idea of the actual correct
+    output. The right thing to do there is to manually calculate the
+    expected result from first principles, or to use a different piece
+    of software which you believe to be working. For this example, let's
+    just use a known incorrect value and see what happens.
+(e)
+    Here's a good place for local variables you need during the test.
+(f)
+    Call the function under test (``crc32_map()`` in this example) with
+    known inputs, and capture the results in a local variable ``c``.
+(g)
+    Compare the actual result in ``c`` with the expected result in
+    ``CRC32``. The ``CU_ASSERT_EQUAL()`` macro checks that it's two
+    arguments are equal (using an integer comparison), and if they're
+    different it prints a message and records a failure. Note that
+    unlike the libc ``assert()`` macro, control will continue even if
+    the assert fails. The CUnit library provides a whole family of
+    similar macros, see `the online CUnit
+    documentation <http://cunit.sourceforge.net/doc/writing_tests.html#assertions>`__
+    for more details.
+
+Now you need to tell the Cyrus build system about your new Suite.
+
+::
+
+    me@mybox> vi Makefile.am
+    ...
+
+You need to add the filename of your new test to the definition of the
+``cunit_TESTS`` variable.
+
+::
+
+    cunit_TESTS = \
+        cunit/aaa-db.testc \
+        cunit/annotate.testc \
+        cunit/backend.testc \
+        cunit/binhex.testc \
+        cunit/bitvector.testc \
+        cunit/buf.testc \
+        cunit/byteorder64.testc \
+        cunit/charset.testc \
+        cunit/crc32.testc \
+        cunit/dlist.testc \
+        cunit/duplicate.testc \
+
+At this point you should be able to just rebuild and rerun using **make
+check**. You can also just rebuild without rerunning by using the
+command **make cunit/unit**.
+
+Note that sometimes this doesn't quite work right, and you may be able
+to work around this problem using the command **rm
+cunit/default.cunit**.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --add-sources [...] crc32.testc
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o ...
+    Running unit tests
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... FAILED
+        1. crc32.testc:12  - CU_ASSERT_EQUAL(c=1926722702,CRC32=0)
+
+Note how the test failure told us which in source file and at what line
+number the failure occurred, and what the actual and expected values
+were. Let's go and fix that up now.
+
+::
+
+    static const char TEXT[] = "lorem ipsum";
+    static uint32\_t CRC32 = 0x72d7748e;
+
+Re-run ``make check`` and you'll see your test being rebuilt and rerun,
+and this time passing.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o
+    ...
+    Running unit tests
+
+        CUnit - A Unit testing framework for C - Version 2.1-0
+        http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... passed
+
+4.2 Adding A Test To A Suite
+----------------------------
+
+Adding a new test to an existing test is easy: all you have to do is add
+a new function to an existing C source file in the ``cunit/`` directory.
+As an example, let's add a test for the ``crc_iovec()`` function.
+
+::
+
+    me@mybox> vi cunit/crc32.testc
+    ...
+
+    static void test_iovec(void)  (a)
+    {
+        static const char TEXT1[] = "lorem";  (b)
+        static const char TEXT2[] = " ipsum";
+        static uint32_t CRC32 = 0x72d7748e;
+        uint32_t c;  (c)
+        struct iovec iov[2];
+
+        memset(iov, 0, sizeof(iov));  (d)
+        iov[0].iov_base = TEXT1;
+        iov[0].iov_len = sizeof(TEXT1)-1;
+        iov[1].iov_base = TEXT2;
+        iov[1].iov_len = sizeof(TEXT2)-1;
+
+        c = crc32_iovec(iov, 2);  (e)
+        CU_ASSERT_EQUAL(c, CRC32);  (f)
+    }
+
+Here's an explanation of what all these bits are for.
+
+(a)
+    Your new test function should look like this: it takes no arguments,
+    returns void, and is named ``test_whatever``. It may be ``static``
+    or ``extern``, but I recommend ``static``. Functions with this
+    signature are automatically discovered in the source code by the
+    Cyrus unit test infrastructure, so all you have to do is write the
+    function. Later, a CUnit test named "whatever" will be created
+    automatically for your ``test_whatever`` function. Note that the
+    opening curly brace must be on the next line or the unit test
+    infrastructure will not find the function.
+(b)
+    Here's a good place to define the test inputs and expected outputs.
+(c)
+    Here's a good place for local variables you need during the test.
+(d)
+    Here you set up the input conditions for the function under test.
+(e)
+    Call the function under test with your known inputs, and capture the
+    results in a local variable, here ``c``.
+(f)
+    Compare the actual result in ``c`` with the expected result in
+    ``CRC32``. The ``CU_ASSERT_EQUAL()`` macro checks that it's two
+    arguments are equal (using an integer comparison), and if they're
+    different it prints a message and records a failure. Note that
+    unlike the libc ``assert()`` macro, control will continue even if
+    the assert fails. The CUnit library provides a whole family of
+    similar macros, see `the online CUnit
+    documentation <http://cunit.sourceforge.net/doc/writing_tests.html#assertions>`__
+    for more details.
+
+Now run ``make check`` and you'll see your test being built and run.
+
+::
+
+    me@mybox> make check
+    ...
+    ../cunit/cunit.pl [...] --generate-wrapper crc32.testc
+    gcc -c [...] -g -O2 .cunit-crc32.c
+    gcc [...] -o unit [...] .cunit-crc32.o
+    ...
+    Running unit tests
+
+
+         CUnit - A Unit testing framework for C - Version 2.1-0
+         http://cunit.sourceforge.net/
+
+    ...
+    Suite: crc32
+      Test: map ... passed
+      Test: iovec ... passed
+
+4.3 Suite Setup And Teardown
+----------------------------
+
+Sometimes the behaviour of the functions under test depend on external
+influences such as environment variables, global variables, or the
+presence of certain files.
+
+These kinds of functions need special treatment to ensure that their
+behaviour is locked down during the running of your tests. Otherwise,
+all sorts of strange behaviour may confuse the results of the tests. For
+example, a test might succeed the first time it's run in a given
+directory and fail the next time. Or a test might succeed when run by
+the author of the test but fail when run by another user.
+
+CUnit provides a special arrangement which helps you in such cases: the
+suite initialisation and cleanup functions. These are two functions that
+you write and which live in the suite source. They are called from CUnit
+respectively before any of the tests in the suite is run, and after all
+tests from that suite are run.
+
+Here's how to use them. The suite setup function should set up any
+global state that the functions under test rely on, in such a way that
+their state is predictable and always the same no matter who runs the
+test or when or how many times. Similarly the suite teardown function
+should clean up any state which might possibly interfere with other test
+suites. Note that some suites will need an setup function but not
+necessarily a teardown function.
+
+Adding these functions is very easy: you just write functions of the
+appropriate signature (names, arguments and return type) and the Cyrus
+unit test infrastructure will automatically discover them and arrange
+for them to be called. The functions should look like (actual example
+taken from ``cunit/mboxname.testc``) this:
+
+::
+
+    static enum enum_value old_config_virtdomains;
+
+    static int set_up(void)
+    {
+        old_config_virtdomains = config_virtdomains;
+        config_virtdomains = IMAP_ENUM_VIRTDOMAINS_ON;
+        return 0;
+    }
+
+    static int tear_down(void)
+    {
+        config_virtdomains = old_config_virtdomains;
+        return 0;
+    }
+
+
+The functions should return 0 on success, and non-zero on error. They
+must not call and ``CU_*`` functions or macros.
+
+Good luck and good testing!
diff -pruN 3.0.13-5/docsrc/imap/developer.rst 3.2.0-3/docsrc/imap/developer.rst
--- 3.0.13-5/docsrc/imap/developer.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/developer.rst	2020-04-24 02:03:00.000000000 +0000
@@ -15,11 +15,11 @@ Getting Started
     developer/compiling
     installing
     developer/developer-testing
+    developer/jmap
 
 .. toctree::
     :hidden:
 
-    developer/developer-tips
     developer/install-xapian
 
 System files and Databases
diff -pruN 3.0.13-5/docsrc/imap/download/getcyrus.rst 3.2.0-3/docsrc/imap/download/getcyrus.rst
--- 3.0.13-5/docsrc/imap/download/getcyrus.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/getcyrus.rst	2020-04-08 00:07:13.000000000 +0000
@@ -29,7 +29,7 @@ Use a release packaged tarball
 The Cyrus team produce packaged tarballs containing full source and
 pre-built documentation.
 
-Download a versioned tarball using `FTP`_ or `HTTPS`_. Latest stable
+Download a versioned tarball using `HTTPS`_. Latest stable
 version is |imap_current_stable_version|.
 
 Extract the tarball:
@@ -38,9 +38,7 @@ Extract the tarball:
 
     $ :command:`tar xzvf cyrus-imapd-x.y.z.tar.gz`
 
-.. _FTP: ftp://ftp.cyrusimap.org/cyrus-imapd/
-
-.. _HTTPS: https://www.cyrusimap.org/releases/
+.. _HTTPS: https://github.com/cyrusimap/cyrus-imapd/releases
 
 Use the source from Git
 -----------------------
diff -pruN 3.0.13-5/docsrc/imap/download/installation/http/caldav.rst 3.2.0-3/docsrc/imap/download/installation/http/caldav.rst
--- 3.0.13-5/docsrc/imap/download/installation/http/caldav.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/installation/http/caldav.rst	2020-04-24 02:03:00.000000000 +0000
@@ -82,6 +82,17 @@ It allows you to:
     * Set visibility attributes such as Public or Transparent
     * Delete existing collections
 
+The Cyrus web GUI for CalDAV Collection Management is disabled by
+default, but can be enabled with the "caldav_allowcalendaradmin" option.
+
+.. sidebar:: caldav_allowcalendaradmin
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob caldav_allowcalendaradmin
+      :end-before: endblob caldav_allowcalendaradmin
+
 To access the Cyrus web GUI for CalDAV Collection Management, point
 a web browser at ``https://<servername>/dav/calendars/user/<username>``
 
@@ -167,7 +178,8 @@ The tables below show how the access con
         <td>CYRUS:admin</td>
         <td>DAV:read-acl
           <br>DAV:write-acl
-            <br>DAV:unlock</td>
+	  <br>DAV:share
+          <br>DAV:unlock</td>
         <td>ACL
           <br>PROPFIND <small>(DAV:acl property ONLY)</small>
           <br>UNLOCK <small>(ANY lock)</small></td>
@@ -296,6 +308,7 @@ accessed via URLs of the following form:
 collections, when they have explicitly "freebusy" ACL (9) set, is done via
 ``https://<servername>/freebusy/user/<userid>/<collection>``.
 
+
 Query parameters can be added to the URL per Section 4 of
 `Freebusy Read URL <http://www.calconnect.org/pubdocs/CD0903%20Freebusy%20Read%20URL.pdf>`_,
 allowing the user to choose to set the start, end, period and format of
@@ -307,7 +320,7 @@ Time Zone Distribution Service (TZDist)
 What is TZDist
 --------------
 
-The Time Zone module allows Cyrus to function as a Time Zone Distribution
+The TZDist module allows Cyrus to function as a Time Zone Distribution
 Service (:rfc:`7808` and :rfc:`7809`), providing time zone data for CalDAV
 and calendaring clients, without having to wait for their client vendor and/or
 OS vendor to update the timezone information. The responsibility for keeping
@@ -337,25 +350,33 @@ Configuration
        :start-after: startblob zoneinfo_db
        :end-before: endblob zoneinfo_db
 
-This module stores time zone data in the ``zoneinfo/`` subdirectory of the Cyrus
-configuration directory (as specified by the ``configdirectory`` option). The data is
-indexed by a database whose location is specified by the ``zoneinfo_db_path``
-option, using the format specified by the ``zoneinfo_db`` option.
+   |
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+       :start-after: startblob zoneinfo_dir
+       :end-before: endblob zoneinfo_dir
+
+The TZDist module requires the ``zoneinfo_dir`` setting in :cyrusman:`imapd.conf(5)`
+to be set to the directory where your time zone data is stored.
+
+The data is indexed by a database whose location is specified by the
+``zoneinfo_db_path`` option, using the format specified by the ``zoneinfo_db``
+option.
 
 Administration
 --------------
 
-This module is designed to use the IANA Time Zone Database data (a.k.a. Olson
-Database) converted to the iCalendar format.
+The TZDist module is designed to use the IANA Time Zone Database data (a.k.a.
+Olson Database) converted to the iCalendar format.
 
-Cyrus uses a modified `vzic <https://github.com/libical/vzic>`_ to convert IANA
-formatted data into iCalendar format. There is more information on Cyrus vzic in
-``tools/vzic/README``.
+We provide a modified `vzic <https://github.com/libical/vzic>`_ to convert IANA
+formatted data into iCalendar format, in the `cyrus-timezones package
+<https://github.com/cyrusimap/cyrus-timezones>`_ to make the following steps
+easier.
 
-The steps to populate the Cyrus ``zoneinfo/`` directory are:
+The steps to populate the ``zoneinfo_dir`` directory are:
 
-1. Build the local "vzic" utility located in the ``tools/vzic/`` subdirectory
-   of the Cyrus source code. Run make in the tools/vzic/ subdirectory to build.
+1. Acquire and build your choice of ``vzic`` tool.
 
 2. Download the latest version of the
    `Time Zone Database data from IANA <http://www.iana.org/time-zones>`_. Note
@@ -363,14 +384,15 @@ The steps to populate the Cyrus ``zonein
 
 3. Expand the downloaded time zone data into a temporary directory of your choice.
 
-4. Populate ``<configdirectory>/zoneinfo/`` with iCalendar data:
+4. Populate ``zoneinfo_dir`` with iCalendar data:
 
    *Initial Install Only*
 
    a. Convert the raw data into iCalendar format by running vzic as follows:
-      ``vzic --pure --olson-dir <location-of-raw-data> --output-dir <configdirectory>/zoneinfo``
+      ``vzic --pure --olson-dir <location-of-raw-data> --output-dir <zoneinfo_dir>``
 
-      This will create and install iCalendar data directly into the ``<configdirectory>/zoneinfo/`` directory.
+      This will create and install iCalendar data directly into the
+      ``<zoneinfo_dir>`` directory.
 
    *Updating Data Only*
 
@@ -378,9 +400,8 @@ The steps to populate the Cyrus ``zonein
       ``vzic --pure --olson-dir <location-of-raw-data>``
 
       This will create a zoneinfo/ subdirectory in your current location
-      (which should be `tools/vzic/`).
 
-   c. Merge new/updated iCalendar data into the ``<configdirectory>/zoneinfo/`` directory
+   c. Merge new/updated iCalendar data into the ``<zoneinfo_dir>`` directory
       by running vzic-merge.pl in your current location:
       ``vzic-merge.pl``
 
diff -pruN 3.0.13-5/docsrc/imap/download/installation/http/carddav.rst 3.2.0-3/docsrc/imap/download/installation/http/carddav.rst
--- 3.0.13-5/docsrc/imap/download/installation/http/carddav.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/installation/http/carddav.rst	2020-04-24 02:03:00.000000000 +0000
@@ -43,6 +43,14 @@ the first time that the user authenticat
 user MUST have an existing IMAP Inbox in order for the addressbook to be
 created.
 
+.. sidebar:: carddav_allowaddressbookadmin
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob carddav_allowaddressbookadmin
+      :end-before: endblob carddav_allowaddressbookadmin
+
 There is also a Cyrus web GUI for managing addressbook resources.
 It allows you to:
 
@@ -50,6 +58,9 @@ It allows you to:
     * Delete existing collections
     * Download existing collections via prepared URLs
 
+The Cyrus web GUI for addressbook management is disabled by default,
+but can be enabled with the "carddav_allowaddressbookadmin" option.
+
 To access the Cyrus web GUI for addressbook management, point
 a web browser at ``https://<servername>/dav/addressbooks/user/<username>``
 
diff -pruN 3.0.13-5/docsrc/imap/download/installation/http/jmap.rst 3.2.0-3/docsrc/imap/download/installation/http/jmap.rst
--- 3.0.13-5/docsrc/imap/download/installation/http/jmap.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/installation/http/jmap.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,90 @@
+====
+JMAP
+====
+
+About JMAP
+==========
+
+`JMAP <http://jmap.io/>`_ is an alternate mechanism for synchronising a mail
+client with a mail server, intended as a replacement for IMAP. It is a
+transport-agnostic, stateless JSON-based API, aiming to be compatible with the
+IMAP data model, but with reduced data usage and more efficient synchronisation.
+
+Configuration
+=============
+
+.. todo::
+
+    Stop duplication in this and developer-jmap by moving a chunk of this
+    information into /assets and include instead.
+
+JMAP support needs to be compiled in to the server using additional
+compile flags. Depending on your distribution, your package provider may
+have already done so. If not, check the
+:ref:`JMAP developer guide <developer-jmap>` for instructions on how to do
+so manually, assuming you have the source.
+
+.. sidebar:: JMAP configuration
+
+    |change-default-config|
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+       :start-after: startblob conversations
+       :end-before: endblob conversations
+
+   |
+
+   .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+      :start-after: startblob conversations_db
+      :end-before: endblob conversations_db
+
+Once it's compiled, JMAP needs to be enabled in :cyrusman:`imapd.conf(5)`.
+
+Enable :ref:`conversation support <imap-concepts-deployment-db-conversations>`
+
+    * In :cyrusman:`imapd.conf(5)`, set ``conversations: 1``, ``conversations_db: twoskip``
+    * Create a conversations.db for each user using
+      :cyrusman:`ctl_conversationsdb(8)`: ``ctl_conversationsdb -b -r``
+
+JMAP clients
+============
+
+The official JMAP website maintains a list of `known clients with JMAP support
+<http://jmap.io/software.html>`_.
+
+The Cyrus :ref:`JMAP developer guide <developer-jmap>` has information on using
+the sample test clients.
+
+.. _jmap-implementation:
+
+JMAP implementation status
+==========================
+
+The JMAP implementation in Cyrus is at various stages of maturity.
+
+Working
+-------
+
+* **Contacts**
+    * All JMAP methods are implemented. JMAP blobs are not supported.
+
+* **Calendars**
+    * All JMAP methods are implemented. JMAP blobs are not supported.
+
+* **Messages**
+    * Most JMAP methods are implemented. The following methods are not planned for implementation:
+
+      * copyMessages
+      * reportMessages
+      * getVacationResponse
+      * setVacationResponse
+      * getIdentityUpdates
+      * setIdentities
+
+Not yet implemented
+-------------------
+
+* **Remote mailboxes**
+
+* **Events**
+    * Changes on mailbox entries trigger notifications. However, the JMAP event service is not implemented.
diff -pruN 3.0.13-5/docsrc/imap/download/installation/manage-dav.rst 3.2.0-3/docsrc/imap/download/installation/manage-dav.rst
--- 3.0.13-5/docsrc/imap/download/installation/manage-dav.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/installation/manage-dav.rst	2020-04-24 02:03:00.000000000 +0000
@@ -31,6 +31,8 @@ Its feature set is limited to:
 * File Storage (WebDAV)
     * Acts as a remote storage server server by using IMAP mailboxes as
       collections and :rfc:`5322` message to store files.
+* JMAP support
+    * Allows synchronization of mail clients via the JSON Mail Access Protocol (JMAP).
 * Other (RSS, static content)
     * Serves static content (such as the RSS feed list template and the
       CalDAV/CardDAV web GUIs ).
@@ -94,12 +96,12 @@ Module-specific information
 ===========================
 
 .. toctree::
-    :glob:
     :maxdepth: 2
 
     http/caldav
     http/carddav
     http/webdav
+    http/jmap
     http/rss
 
 For end users
diff -pruN 3.0.13-5/docsrc/imap/download/packagers.rst 3.2.0-3/docsrc/imap/download/packagers.rst
--- 3.0.13-5/docsrc/imap/download/packagers.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/packagers.rst	2020-05-04 04:02:14.000000000 +0000
@@ -1,9 +1,17 @@
-===================
 Notes for Packagers
 ===================
 
+Binary naming
+-------------
+
+Prevent namespace clashes. We suggest renaming all binaries with ``cyr_`` at
+the front, including renaming the ``ctl_*`` to ``cyr_``.
+
+The Cyrus team are looking to fix this in the core bundle in upcoming releases
+so packagers have less to do.
+
 Sample configuration files
-==========================
+--------------------------
 
 There are several samples of :cyrusman:`cyrus.conf(5)` and
 :cyrusman:`imapd.conf(5)` located in the ``doc/examples`` directory of
@@ -12,10 +20,10 @@ documentation directory (i.e. ``/usr/sha
 reference for your users.
 
 Predefined configurations
-=========================
+-------------------------
 
 The configuration file for master: cyrus.conf
----------------------------------------------
+`````````````````````````````````````````````
 
 When installing a predefined :cyrusman:`cyrus.conf(5)` for your users,
 please pay attention to new features and how these may impact users.
@@ -64,7 +72,7 @@ sections are:
       it should shut down and clean up after.
 
 The configuration file for the various programs: imapd.conf
------------------------------------------------------------
+```````````````````````````````````````````````````````````
 
 The sample :cyrusman:`imapd.conf(5)` files must be adapted for use from
 site to site.  Here, therefore, we'll attempt to point you towards some
@@ -100,53 +108,30 @@ files.  In this example, the filesystem
 New default settings
 ####################
 
-With the introduction of version 3.0, the defaults for some settings
-have changed.  Please consult :ref:`upgrade` for details.
-
-New features
-############
-
-There are several features either new to version 3.0, or newly improved.
-Some of these may be features which previously were not considered ripe
-for packaging, but merit new consideration.
-
-Please see the release notes :ref:`relnotes-3.0.0-changes` for more
-details and other recent changes.
+A new stable series means the defaults for some settings may have changed.
+Please consult :ref:`upgrade` for details.
 
-*   Conversations
+New or improved features
+########################
 
-    *   Server-side threading with reduced protocol chatter for mobile
-        or other high-latency clients.
-    *   See the ``conversations`` options in :cyrusman:`imapd.conf(5)`
+A new stable series means new features, and improvements to existing features.
+Some of these may be features which previously were not considered ripe for
+packaging, but merit new consideration.
 
-*   Xapian
-
-    *   Higher quality full-text search support.
-    *   See the ``search_engine`` option in :cyrusman:`imapd.conf(5)`
-        and ``doc/README.xapian`` in the source distribution.
-
-*   Archive partitions
-
-    *   Automatically migrate messages from posh, fast storage (think
-        SSD) to cheap, slow storage (spinning rust).
-    *   Requires addition of an archive partition for each data
-        partition.
-    *   See ``archive_*`` options in :cyrusman:`imapd.conf(5)`
-
-*   Backup
-
-    *   Replication-based backup to dedicated instance with efficient,
-        compact scheme.
-    *   See :ref:`Cyrus Backups <cyrus-backups>`
-
-Please consider enabling these features in the :cyrusman:`imapd.conf(5)`
-you ship  in your packages.
+Please see :ref:`imap-release-notes-3.2` for details, and consider enabling
+these features in the :cyrusman:`imapd.conf(5)` you ship in your packages.
 
 Services in ``/etc/services``
-=============================
-
-Listing named services through ``/etc/services`` aids in cross-system consistency and cross-platform interoperability. Furthermore, it enables administrators and users to refer to the service by name (for example in ``/etc/cyrus.conf``, 'listen=mupdate' can be specified instead of 'listen=3905').
+-----------------------------
 
-Some of the services Cyrus IMAP would like to see available through ``/etc/services`` have not been assigned an IANA port number, and few have configuration options.
+Listing named services through ``/etc/services`` aids in cross-system
+consistency and cross-platform interoperability. Furthermore, it enables
+administrators and users to refer to the service by name (for example in
+``/etc/cyrus.conf``, 'listen=mupdate' can be specified instead of
+'listen=3905').
+
+Some of the services Cyrus IMAP would like to see available through
+``/etc/services`` have not been assigned an IANA port number, and few have
+configuration options.
 
 ..  include:: /assets/services.rst
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.2/2.2.x.rst 3.2.0-3/docsrc/imap/download/release-notes/2.2/2.2.x.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.2/2.2.x.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.2/2.2.x.rst	2020-04-24 02:03:00.000000000 +0000
@@ -70,12 +70,12 @@ Changes to the Cyrus IMAP Server since 2
 Changes to the Cyrus IMAP Server since 2.2.5
 
 *   Fix a bug in the proxy code where a backend connection might get closed twice
-*   Improved consistency checking in chk_cyrus
+*   Improved consistancy checking in chk_cyrus
 *   Fix segfault in APPEND code
 *   Fix a bug with an interaction between sieve and unixhierarchysep
 *   Fix a file descriptor leak in the quotadb code
 *   Fix a triggered assertation in service-thread services
-*   Add a number of internal consistency checks to the skiplist code
+*   Add a number of internal consistancy checks to the skiplist code
 *   Allow mbpath to handle virtual domains
 *   Fix various MANAGESIEVE client authentication issues
 *   Other minor fixes
@@ -143,7 +143,7 @@ Changes to the Cyrus IMAP Server since 2
 
 Changes to the Cyrus IMAP Server since 2.1.x
 
-*   There have been extensive performance and consistency changes to the configuration subsystem. This will both ensure greater consistency between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:
+*   There have been extensive performance and consistancy changes to the configuration subsystem. This will both ensure greater consistancy between the documentation and the code, as well as a more standard format for specifing service-specific configuration options in imapd.conf. Important changes are detailed here:
 *       The tls_[service]_* configuration options have been removed. Now use [servicename]_tls_*, where servicename is the service identifier from cyrus.conf for that particular process.
 *       Administrative groups (e.g. admins and lmtp_admins) no longer union, service groups completely override the generic group.
 *       lmtp_allowplaintext is no longer a defined parameter and must be specified using the service name of your lmtp process if you require a specific value
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst 3.2.0-3/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.4/x/2.4.19.rst	2020-04-24 02:03:00.000000000 +0000
@@ -29,5 +29,4 @@ Cyrus IMAP 2.4.19 Release Notes
 * Fixed :issue:`1967`: EXISTS count reported earlier if fetching past size
   of previous message set
 
-
 :ref:`imap-release-notes-2.4`
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.0.rst	2020-04-08 00:07:13.000000000 +0000
@@ -15,15 +15,10 @@ Cyrus IMAP 2.5.0 Release Notes
 *   :ref:`relnotes-2.5.0-development-phabricator`
 *   :ref:`relnotes-2.5.0-development-documentation`
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.0.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.0.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.0/cyrus-imapd-2.5.0.tar.gz.sig
 
 .. _imap-relnotes-2.5.0-upgrading:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.10.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.10 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.10.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.10.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.10/cyrus-imapd-2.5.10.tar.gz.sig
 
 .. _relnotes-2.5.10-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.11.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.11 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.11.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.11.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.11/cyrus-imapd-2.5.11.tar.gz.sig
 
 .. _relnotes-2.5.11-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.14.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.14.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.14.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.14.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-:tocdepth: 3
-
-===============================
-Cyrus IMAP 2.5.14 Release Notes
-===============================
-
-.. IMPORTANT::
-
-    This is a bug-fix release in the `stable 2.5 series <http://www.cyrusimap.org/stable>`_.
-
-    Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
-    about the 2.5 series, including upgrading instructions.
-
-Download via HTTPS:
-
-    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz
-    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.14/cyrus-imapd-2.5.14.tar.gz.sig
-
-.. _relnotes-2.5.14-changes:
-
-Changes Since 2.5.13
-====================
-
-Release changes
----------------
-
-We’re trialing using the Github Releases feature. If you have trouble
-downloading this release, please report this to the mailing lists. Thanks!
-
-Security fixes
---------------
-
-* Fixed CVE-2019-18928: unauthenticated HTTP requests no longer inherit
-  authentication from the previous request on the same connection
-
-Build changes
--------------
-
-* Can now build against ClamAV >= 0.101 (thanks Christoph Moench-Tegeder)
-
-Bug fixes
----------
-
-* Fixed :issue:`2877`: `quota -f` now works correctly with `improved_mboxlist_sort: no`
-* Fixed :issue:`2808`: UNDUMP no longer crashes when quota needs updating
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.15.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.15.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.15.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.15.rst	2020-04-08 00:07:13.000000000 +0000
@@ -0,0 +1,59 @@
+:tocdepth: 3
+
+===============================
+Cyrus IMAP 2.5.15 Release Notes
+===============================
+
+.. IMPORTANT::
+
+    This is a bug-fix release in the `stable 2.5 series <http://www.cyrusimap.org/stable>`_.
+
+    Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
+    about the 2.5 series, including upgrading instructions.
+
+Download via HTTPS:
+
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.15/cyrus-imapd-2.5.15.tar.gz.sig
+
+.. _relnotes-2.5.15-changes:
+
+Changes Since 2.5.14
+====================
+
+Release changes
+---------------
+
+We’re trialing using the Github Releases feature. If you have trouble
+downloading this release, please report this to the mailing lists. Thanks!
+
+Security fixes
+--------------
+
+* Fixed CVE-2019-19783_: When creating a missing mailbox as part of a sieve
+  'fileinto' directive, lmtpd would create it as administrator, bypassing ACL
+  checks.
+
+  lmtpd creates missing mailboxes as part of a sieve 'fileinto'
+  directive if:
+
+  * (2.5+) the `anysievefolder` option is enabled (default: not), or
+  * (3.0+) the `sieve_extensions` option has the 'mailbox' extension enabled
+    (default: enabled) and the 'fileinto' directive contains the ":create"
+    argument
+
+  Under these conditions, a user with the ability to upload a custom sieve
+  script to their account could use it to create any valid mailbox on the
+  server (with ACL inherited from the parent mailbox as usual).
+
+  lmtpd no longer creates these mailboxes as administrator, so users may no
+  longer use a 'fileinto' directive to create a mailbox they couldn't create
+  otherwise.
+
+.. _CVE-2019-19783: https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783
+
+Bug fixes
+---------
+
+* Fixed :issue:`2913`: errors are now logged when `maxlogins_per_host`,
+  `maxlogins_per_user`, and `popminpoll` limits are reached (thanks Sergey)
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.1.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.1 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.1/cyrus-imapd-2.5.1.tar.gz.sig
 
 .. _relnotes-2.5.1-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.2.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.2 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.2/cyrus-imapd-2.5.2.tar.gz.sig
 
 .. _relnotes-2.5.2-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.3.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.3 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.3/cyrus-imapd-2.5.3.tar.gz.sig
 
 .. _relnotes-2.5.3-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.4.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.4 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.4.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.4/cyrus-imapd-2.5.4.tar.gz.sig
 
 .. _relnotes-2.5.4-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.5.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.5 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz
-    *   http://www.cyrusimap.org/releases/old/cyrus-imapd-2.5.5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/OLD-VERSIONS/cyrus-imapd-2.5.5.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.5/cyrus-imapd-2.5.5.tar.gz.sig
 
 .. _relnotes-2.5.5-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.6.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.6 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.6.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.6/cyrus-imapd-2.5.6.tar.gz.sig
 
 .. _relnotes-2.5.6-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.7.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.7 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.7.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.7.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.7/cyrus-imapd-2.5.7.tar.gz.sig
 
 .. _relnotes-2.5.7-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.8.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.8 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.8.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.8.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.8/cyrus-imapd-2.5.8.tar.gz.sig
 
 .. _relnotes-2.5.8-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/2.5/x/2.5.9.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 2.5.9 Release Notes
     Refer to the Cyrus IMAP 2.5.0 Release Notes for important information
     about the 2.5 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-2.5.9.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-2.5.9.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-2.5.9/cyrus-imapd-2.5.9.tar.gz.sig
 
 .. _relnotes-2.5.9-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/index.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/index.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/index.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/index.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,4 +8,7 @@ Cyrus IMAP 3.0 Releases
     :maxdepth: 1
     :glob:
 
-    x/?.?.*
+    x/?.?.*-beta*
+    x/?.?.*-rc*
+    x/?.?.?
+    x/?.?.??
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta1.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta1 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta1/cyrus-imapd-3.0.0-beta1.tar.gz.sig
 
 .. _relnotes-3.0.0-beta1-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta2.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta2 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta2/cyrus-imapd-3.0.0-beta2.tar.gz.sig
 
 .. _relnotes-3.0.0-beta2-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta3.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta3 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta3/cyrus-imapd-3.0.0-beta3.tar.gz.sig
 
 .. _relnotes-3.0.0-beta3-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta4.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta4 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta4.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta4/cyrus-imapd-3.0.0-beta4.tar.gz.sig
 
 .. _relnotes-3.0.0-beta4-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta5.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta5 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta5.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta5/cyrus-imapd-3.0.0-beta5.tar.gz.sig
 
 .. _relnotes-3.0.0-beta5-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-beta6.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 beta6 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-beta6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-beta6.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-beta6/cyrus-imapd-3.0.0-beta6.tar.gz.sig
 
 .. _relnotes-3.0.0-beta6-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc1.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc1 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc1/cyrus-imapd-3.0.0-rc1.tar.gz.sig
 
 .. _relnotes-3.0.0-rc1-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc2.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc2 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc2.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc2/cyrus-imapd-3.0.0-rc2.tar.gz.sig
 
 .. _relnotes-3.0.0-rc2-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc3.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc3 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc3.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc3/cyrus-imapd-3.0.0-rc3.tar.gz.sig
 
 .. _relnotes-3.0.0-rc3-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0-rc4.rst	2020-04-08 00:07:13.000000000 +0000
@@ -10,15 +10,10 @@ Cyrus IMAP 3.0.0 rc4 Release Notes
 
     Do **NOT** use this version unless you're a developer of sorts.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0-rc4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0-rc4.tar.gz.sig
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz
+    * https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0-rc4/cyrus-imapd-3.0.0-rc4.tar.gz.sig
 
 .. _relnotes-3.0.0-rc4-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.0.rst	2020-04-08 00:07:13.000000000 +0000
@@ -4,15 +4,10 @@
 Cyrus IMAP 3.0.0 Release Notes
 ====================================
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.0.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.0.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.0/cyrus-imapd-3.0.0.tar.gz.sig
 
 .. _relnotes-3.0.0-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.1.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,15 +11,10 @@ Cyrus IMAP 3.0.1 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
+Download from GitHub:
 
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.1.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.1.tar.gz.sig
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.1/cyrus-imapd-3.0.1.tar.gz.sig
 
 .. _relnotes-3.0.1-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.2.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.2 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.2.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.2.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.2/cyrus-imapd-3.0.2.tar.gz.sig
 
 .. _relnotes-3.0.2-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.3.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.3 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.3.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.3.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.3/cyrus-imapd-3.0.3.tar.gz.sig
 
 .. _relnotes-3.0.3-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.4.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.4 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.4.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.4.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.4/cyrus-imapd-3.0.4.tar.gz.sig
 
 .. _relnotes-3.0.4-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.5.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.5 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.5.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.5.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.5/cyrus-imapd-3.0.5.tar.gz.sig
 
 .. _relnotes-3.0.5-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.6.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.6 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTP:
-
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz
-    *   http://www.cyrusimap.org/releases/cyrus-imapd-3.0.6.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.6.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.6/cyrus-imapd-3.0.6.tar.gz.sig
 
 .. _relnotes-3.0.6-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.0/x/3.0.7.rst	2020-04-08 00:07:13.000000000 +0000
@@ -11,16 +11,10 @@ Cyrus IMAP 3.0.7 Release Notes
     Refer to the Cyrus IMAP 3.0.0 Release Notes for important information
     about the 3.0 series, including upgrading instructions.
 
-Download via HTTPS:
-
-    *   https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz
-    *   https://www.cyrusimap.org/releases/cyrus-imapd-3.0.7.tar.gz.sig
-
-Download via FTP:
-
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz
-    *   ftp://ftp.cyrusimap.org/cyrus-imapd/cyrus-imapd-3.0.7.tar.gz.sig
+Download from GitHub:
 
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.0.7/cyrus-imapd-3.0.7.tar.gz.sig
 
 .. _relnotes-3.0.7-changes:
 
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/index.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/index.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/index.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/index.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,18 @@
+.. _imap-release-notes-3.1:
+
+===================
+Cyrus IMAP 3.1 Tags
+===================
+
+.. warning::
+
+    The 3.1 series are tagged snapshots of the master branch, and should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. toctree::
+    :maxdepth: 1
+    :glob:
+
+    x/?.?.*
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.0-dev.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.0-dev.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.0-dev.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.0-dev.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,38 @@
+:tocdepth: 3
+
+==================================
+Cyrus IMAP 3.1.0-dev Release Notes
+==================================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. _relnotes-3.1.0-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+*
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+
+* The per-user calendar and addressbook administrative web user
+  interfaces (e.g. /dav/calendars/user/<userid>) are now disabled by
+  default.  They can be enabled with the `caldav_allowcalendaradmin`
+  and `carddav_allowaddressbookadmin` options respectively.
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.1.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.1.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,48 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.1 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.2.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.2.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.2.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,54 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.2 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.2-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.3.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.3.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.3.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,54 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.3 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.3-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.4.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.4.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.4.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.4 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.4-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v14 included in 3.1.4 - adds unseen count to index header
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.5.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.5.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.5.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.5.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.5 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.5-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count and createdmodseq to index header, savedate and createdmodseq to index records
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+*
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.6.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.6.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.6.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.6.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,67 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.6 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.6-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* JMAP improvements.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Support for the Sphinx backend to squatter searches has been removed.
+* new cyrus.index format v16 included in 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+Security fixes
+==============
+* Contains fix for CVE-2017-14230.
+  [ http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230 ]
+
+Significant bugfixes
+====================
+
+*
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.7.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.7.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.7.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.7.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,75 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.7 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.7-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+Security fixes
+==============
+* Contains fix for `CVE-2017-14230 <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.8.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.8.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.8.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.8.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,92 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.8 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.8-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+.. XXX explicate JMAP support properly, not just "Support for JMAP"
+  * Support for RFCxyz JMAP Core and Email standards
+  * Experimental support for JMAP Calendar, Contacts, ... extensions
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP.
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.9.rst 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.9.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.1/x/3.1.9.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.1/x/3.1.9.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,97 @@
+:tocdepth: 3
+
+==========================
+Cyrus IMAP 3.1.9 Tag Notes
+==========================
+
+Unavailable for download as this is a development branch only.
+
+Access is via git.
+
+.. warning::
+
+    This should be considered for
+    **testing purposes** and **bleeding-edge features** only. We will try to tag these
+    snapshots at coherent development points, but there will generally be **large
+    breaking changes** occurring between releases in this series.
+
+.. _relnotes-3.1.9-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features.
+* Caldav and Carddav improvements.
+* Support for JMAP core protocol (:rfc:`8620`).
+* Support for JMAP Mail (:rfc:`8621`).
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`).
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`).
+* Xapian bug fixes.
+* Improvements to Annotations handling.
+* DRAC support has been deprecated.
+* Support for Prometheus stats.
+* Removed support for the Sphinx backend to squatter searches.
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this.
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units.
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames).
+
+
+Updates to default configuration
+================================
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/index.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/index.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/index.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/index.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,14 @@
+.. _imap-release-notes-3.2:
+
+=============================
+Cyrus IMAP 3.2 Releases
+=============================
+
+.. toctree::
+    :maxdepth: 1
+    :glob:
+
+    x/?.?.*-beta*
+    x/?.?.*-rc*
+    x/?.?.?
+    x/?.?.??
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta1.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta1.rst	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,113 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta1 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta1/cyrus-imapd-3.2.0-beta1.tar.gz.sig
+
+.. _relnotes-3.2.0-beta1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta2.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta2.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta2.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta2.rst	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,113 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta2 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta2/cyrus-imapd-3.2.0-beta2.tar.gz.sig
+
+.. _relnotes-3.2.0-beta2-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta3.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta3.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta3.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta3.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,123 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta3 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta3/cyrus-imapd-3.2.0-beta3.tar.gz.sig
+
+.. _relnotes-3.2.0-beta3-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta4.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta4.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta4.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-beta4.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,126 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-beta4 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-beta4/cyrus-imapd-3.2.0-beta4.tar.gz.sig
+
+.. _relnotes-3.2.0-beta4-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-rc1.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-rc1.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0-rc1.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0-rc1.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,126 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0-rc1 Release Notes
+====================================
+
+.. WARNING::
+    This is a beta release and may contain fun bugs.  Testing it
+    out and providing feedback would be greatly appreciated, but do
+    not run this on your production mail stores!
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0-rc1/cyrus-imapd-3.2.0-rc1.tar.gz.sig
+
+.. _relnotes-3.2.0-rc1-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0.rst 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/3.2/x/3.2.0.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/3.2/x/3.2.0.rst	2020-05-04 04:02:14.000000000 +0000
@@ -0,0 +1,121 @@
+:tocdepth: 3
+
+====================================
+Cyrus IMAP 3.2.0 Release Notes
+====================================
+
+Download from GitHub:
+
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz
+    *   https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-3.2.0/cyrus-imapd-3.2.0.tar.gz.sig
+
+.. _relnotes-3.2.0-changes:
+
+Major changes since the 3.0.x series
+====================================
+
+* Sieve bug fixes and features
+* Replication safety improvements
+* Caldav and Carddav improvements
+* Support for JMAP core protocol (:rfc:`8620`)
+* Support for JMAP Mail (:rfc:`8621`)
+* Experimental support for JMAP Contacts (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Experimental support for JMAP Calendars (requires
+  `jmap_nonstandard_extensions: yes` in :cyrusman:`imapd.conf(5)`)
+* Xapian bug fixes
+* Improvements to Annotations handling
+* DRAC support has been deprecated
+* Support for Prometheus stats
+* SNMP stats support has been deprecated
+* Removed support for the Sphinx backend to squatter searches
+* New cyrus.index format v16 included since 3.1.5 - adds unseen count and
+  createdmodseq to index header, savedate and createdmodseq to index records
+* Support for WebSockets
+* Support for HTTP/2.0
+* Experimental support for Zeroskip database format
+* Intermediate mailboxes are now recorded in mailboxes database
+* Conversations database format update - adds flags and internaldate fields,
+  and is now versioned for future-compatibility.  You will need to rebuild
+  your conversations databases with :cyrusman:`ctl_conversationsdb(8)` and
+  the `-b` switch to benefit from this
+* IMAP FETCH accepts two new data items, MAILBOXIDS and MAILBOXES, which
+  respectively return the unique ids or names of the containing mailboxes of
+  each message in the sequence (for best performance, rebuild your
+  conversations databases as above)
+* :cyrusman:`mbpath(8)` is now much more useful
+* Twoskip database format now supports shared locks, and ensures record
+  headers do not span disk block boundaries
+* All Cyrus binaries now use real sysexits exit codes instead of mapping
+  nearly everything to EX_TEMPFAIL
+* CyrusDB errors now syslog the actual error instead of just "cyrusdb error"
+* New `allowdeleted` :cyrusman:`imapd.conf(5)` option (default off), which
+  allows admin users to see deleted mailboxes and expunged messages over IMAP
+* :cyrusman:`cyr_virusscan(8)` now supports custom templates for notifications
+  sent about infected messages that have been deleted
+* :cyrusman:`imapd.conf(5)` options that represent a time duration now accept
+  'd', 'h', 'm', 's' suffixes rather than arbitrary units
+* The `tls_server_cert` and `tls_server_key` :cyrusman:`imapd.conf(5)` options
+  now allow two certificate/key pairs (e.g. RSA and EC) to be used.  Thanks
+  Дилян Палаузов
+* Mailbox create/delete/rename are now performed under a lock on the user's
+  namespace, to prevent races (especially during big renames)
+* The :cyrusman:`cyr_info(8)` `conf-lint` subcommand no longer complains
+  about channel-prefixed sync options
+* New `master_bind_errors_fatal` :cyrusman:`imapd.conf(5)` option (default
+  off), with which master will refuse to start if any of the configured
+  services are unable to successfully bind their port.  The default and legacy
+  behaviour is for master to start with the affected services disabled, and
+  not try to start them again until a SIGHUP is received
+* New `autocreate_acl` :cyrusman:`imapd.conf(5)` option, for specifying ACLs
+  to use when mailboxes are created by `autocreate_inbox_folders`
+* New `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, for specifying the
+  directory Cyrus should look for timezone definitions in.  The default is
+  to let libical find them itself.  If the `tzdist` http module is enabled,
+  this option is mandatory.
+* The iso-8859-1 charset is now treated as an alias for windows-1252, as per
+  `WHATWG Encoding for emails and websites
+  <https://encoding.spec.whatwg.org/#names-and-labels>`_
+
+Updates to default configuration
+================================
+
+The :cyrusman:`cyr_info(8)` `conf`, `conf-all` and `conf-default` subcommands
+now accept an `-s <version>` argument to highlight :cyrusman:`imapd.conf(5)`
+options that are new or whose behaviour has changed since the specified
+version.  We recommend using this when evaluating a new Cyrus version to
+check which configuration options you will need to re-examine and maybe change
+during the process.
+
+* The `specialusealways` option is now enabled by default. It must
+  explicitly be disabled for interoperability with legacy clients that
+  can't handle RFC 6154 attributes in extended LIST commands.
+* The values accepted by `expunge_mode` have changed, please see the
+  documentation for more information about the changes.
+* The legacy GETANNOTATIONS/SETANNOTATIONS IMAP commands will no longer
+  work unless `annotation_enable_legacy_commands` is enabled.
+* The `outbox_sendlater` option and its functionality have been removed.
+* The `tzdist` http module now finds its timezone data directory according
+  to the new `zoneinfo_dir` :cyrusman:`imapd.conf(5)` option, instead of
+  being hardcoded to "{configdirectory}/zoneinfo".  If you are using this
+  module, you MUST now set this option explicitly.  Calendaring services
+  will use the same timezone definitions.
+
+
+Security fixes
+==============
+
+* Contains fix for `CVE-2017-14230 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-14230>`_
+* Contains fix for `CVE-2019-18928 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-18928>`_
+* Contains fix for `CVE-2019-19783 <https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-19783>`_
+
+
+Significant bugfixes
+====================
+
+* Contains fix for :issue:`2839`
+
+
+.. _Xapian: https://xapian.org
+.. _ClamAV: https://www.clamav.net
+.. _JMAP: http://jmap.io
diff -pruN 3.0.13-5/docsrc/imap/download/release-notes/index.rst 3.2.0-3/docsrc/imap/download/release-notes/index.rst
--- 3.0.13-5/docsrc/imap/download/release-notes/index.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/release-notes/index.rst	2020-05-04 04:02:14.000000000 +0000
@@ -2,12 +2,12 @@
 Release Notes
 =============
 
-Cyrus has switched to an `odd-even release cycle <http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy>`_.
+Cyrus uses an `odd-even release cycle <http://producingoss.com/en/development-cycle.html#release-number-even-odd-strategy>`_.
 
-With our versioning system using ``major.minor.micro`` numbering, the minor number
-reveals whether a version is stable (even), or development-only (odd).
+With our versioning system using ``major.minor.micro`` numbering, the minor (middle)
+number reveals whether a version is stable (even), or development-only (odd).
 
-A 3.0.1 release is stable, but a 3.1.4 release is developmental only.
+A 3.\ **0**\ .1 release is stable, but a 3.\ **1**\ .4 release is developmental only.
 
 Stable Version
 ==============
@@ -22,14 +22,25 @@ Latest development snapshot is |imap_dev
 
 .. warning::
 
-    These are tagged snapshots of the master branch, and should be considered for
-    **testing purposes** and **bleeding-edge features** only. We will try to tag these
-    snapshots at coherent development points, but there will generally be **large
-    breaking changes** occurring between releases in this series.
+    Development versions are tagged snapshots of the master branch, and should
+    be considered for **testing purposes** and **bleeding-edge features** only.
+    We will try to tag these snapshots at coherent development points, but
+    there will generally be **large breaking changes** occurring between
+    releases in this series.
 
 Supported Product Series
 ========================
 
+Series 3.2
+----------
+
+Documentation at :cyrus-3.2:`/`.
+
+.. toctree::
+    :maxdepth: 1
+
+    3.2/index
+
 Series 3.0
 ----------
 
@@ -37,7 +48,6 @@ Documentation at :cyrus-3.0:`/`.
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     3.0/index
 
@@ -48,20 +58,17 @@ Documentation at :cyrus-2.5:`/`.
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     2.5/index
 
-Series 2.4
-----------
+Development snapshots
+=====================
 
 .. toctree::
     :maxdepth: 1
-    :glob:
-
-    2.4/index
-    2.4-dav/index
 
+    3.3/index
+    3.1/index
 
 Older Versions
 ==============
@@ -71,27 +78,18 @@ Series 1
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     1/1.x.x
 
-Series 2: 2.0 - 2.3
+Series 2: 2.0 - 2.4
 -------------------
 
 .. toctree::
     :maxdepth: 1
-    :glob:
 
     2.0/2.0.x
     2.1/2.1.x
     2.2/2.2.x
     2.3/index
-
-
-.. toctree::
-    :hidden:
-
     2.4/index
     2.4-dav/index
-    2.5/index
-    3.0/index
diff -pruN 3.0.13-5/docsrc/imap/download/upgrade.rst 3.2.0-3/docsrc/imap/download/upgrade.rst
--- 3.0.13-5/docsrc/imap/download/upgrade.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/download/upgrade.rst	2020-05-04 04:02:14.000000000 +0000
@@ -1,7 +1,9 @@
+.. highlight:: none
+
 .. _upgrade:
 
 ================
-Upgrading to 3.0
+Upgrading to 3.2
 ================
 
 .. note::
@@ -27,24 +29,24 @@ Things to consider **before** you begin:
 Installation from tarball
 #########################
 
-You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren't able to test all platforms: you may find you need to install additional or different libraries to support v3.0.
+You will need to install from our packaged tarball. We provide a full list of libraries that Debian requires, but we aren't able to test all platforms: you may find you need to install additional or different libraries to support v3.2.
 
 How are you planning on upgrading?
 ##################################
 
-Ideally, you will do a sandboxed test installation of 3.0 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.0 installation.
+Ideally, you will do a sandboxed test installation of 3.2 using a snapshot of your existing data before you switch off your existing installation. The rest of the instructions are assuming a sandboxed 3.2 installation.
 
 Upgrade by replicating
 ~~~~~~~~~~~~~~~~~~~~~~
 
 If you're familiar with replication, and your current installation is 2.4 or
 newer, you can set up your existing installation to replicate data to a new
-3.0 installation and failover to the new installation when you're ready. The
+3.2 installation and failover to the new installation when you're ready. The
 replication protocol has been kept backwards compatible.
 
 If your old installation contains mailboxes or messages that are older than
 2.4, they may not have GUID fields in their indexes (index version too old),
-or they may have their GUID field set to zero.  3.0 will not accept message
+or they may have their GUID field set to zero.  3.2 will not accept message
 replications without valid matching GUIDs, so you need to fix this on your
 old installation first.
 
@@ -69,9 +71,28 @@ Upgrade in place
 If you are upgrading in place, you will need to shut down Cyrus
 entirely while you install the new package.  If your old installation
 was using Berkeley DB format databases, you will need to convert or
-upgrade the databases **before** you upgrade.  Cyrus v3.0 does not
+upgrade the databases **before** you upgrade.  Cyrus v3.2 does not
 support Berkeley DB at all.
 
+.. note::
+
+    If you are upgrading from Cyrus version 2.5 or earlier,
+    and your system is configured with the following combination
+    in :cyrusman:`imapd.conf(5)`::
+
+        fulldirhash: yes
+        hashimapspool: either yes or no
+        unixhierarchysep: yes
+
+    then you will not be able to upgrade-in-place.  This is due to
+    a change in how directory hashes are calculated for users whose
+    localpart contains a dot, which was introduced in 3.0.0.  After
+    an in-place upgrade, Cyrus will not be able to find these users'
+    metadata and/or mailboxes.
+
+    If you have this configuration, you will need to upgrade by
+    replicating, not in place.
+
 Do What As Who?
 ###############
 
@@ -95,10 +116,10 @@ commands, such as ``rsync`` or ``scp``.
 
 We strongly recommend that you read this entire document before upgrading.
 
-2. Install new 3.0 Cyrus
+2. Install new 3.2 Cyrus
 ------------------------
 
-Download the release :ref:`3.0 package tarball <getcyrus>`.
+Download the release :ref:`3.2 package tarball <getcyrus>`.
 
 Fetch the libraries for your platform. The full list (including all optional packages) for Debian is::
 
@@ -143,7 +164,7 @@ We recommend backing up all your data be
 * Mail spool
 * :ref:`Cyrus Databases <databases>`
 
-(You do already have a backup strategy in place, right? Once you're on 3.0, you can
+(You do already have a backup strategy in place, right? Once you're on 3.2, you can
 consider using the experimental :ref:`backup tools <cyrus-backups>`.)
 
 Copy all of this to the new instance, using ``rsync`` or similar tools.
@@ -163,7 +184,7 @@ server)::
     rsync -aHv oldimap:/var/lib/cyrus/. /var/lib/cyrus/.
     rsync -aHv oldimap:/var/spool/cyrus/. /var/spool/cyrus/.
 
-You don't need to copy the following databases as Cyrus 3.0 will
+You don't need to copy the following databases as Cyrus 3.2 will
 recreate these for you automatically:
 
 * duplicate delivery (deliver.db),
@@ -212,8 +233,9 @@ you have provided overrides for in your
     cyr_info conf-all -C <path to imapd.conf> -M <path to cyrus.conf>
 
 **Important config** options: ``unixhierarchysep:`` and ``altnamespace:``
-defaults have changed in :cyrusman:`imapd.conf(5)`. Implications are
-outlined in the Note in :ref:`imap-admin-namespaces-mode` and
+defaults in :cyrusman:`imapd.conf(5)` changed in 3.0, which will affect you
+if you are upgrading to 3.2 from something earlier than 3.0. Implications
+are outlined in the Note in :ref:`imap-admin-namespaces-mode` and
 :ref:`imap-switching-alt-namespace-mode`.  Please also see "Sieve Scripts,"
 below.
 
@@ -236,34 +258,14 @@ DAEMON section.
    directive(s), you can convert these to per-user special-use annotations
    in your new install with the :cyrusman:`cvt_xlist_specialuse(8)` tool
 
-* Sieve Scripts
-
-    Since defaults for options: ``unixhierarchysep:`` and
-    ``altnamespace:`` have changed in :cyrusman:`imapd.conf(5)`, you
-    may very likely need to modify any sieve scripts already on your
-    system.  Fear not, there's a tool for this task, called
-    :cyrusman:`translatesieve(8)`.  This tool can handle situations
-    where either or both of these settings need change. Please consult
-    the man page for details.
-
-    Consider the following example, where the prior configuration was
-    already using ``altnamespace: on``, but was *not* using
-    ``unixhierarchysep: on``::
-
-        # su cyrus -c "/usr/lib/cyrus/upgrade/translatesieve -a"
-        you are using /var/lib/imap/sieve as your sieve directory.
-        translating sievedir /var/lib/imap/sieve... converting separator from '.' to '/'
-        not changing name space.
-        done
-
 .. warning::
 
-    **Berkeley db format no longer supported**
+    **Berkeley db format no longer supported since 3.0**
 
     If you have any databases using Berkeley db, they'll need to be
     converted to skiplist or flat *in your existing installation*. And
     then optionally converted to whatever final format you'd like in
-    your 3.0 installation.
+    your 3.2 installation.
 
     Databases potentially affected: mailboxes, annotations, conversations, quotas.
 
@@ -271,15 +273,15 @@ DAEMON section.
 
        cvt_cyrusdb /<configdirectory>mailboxes.db berkeley /tmp/new-mailboxes.db skiplist
 
-    If you don't want to use flat or skiplist for 3.0, you can use the
-    new 3.0 :cyrusman:`cvt_cyrusdb(8)` to swap to new format::
+    If you don't want to use flat or skiplist for 3.2, you can use the
+    new 3.2 :cyrusman:`cvt_cyrusdb(8)` to swap to new format::
 
        cvt_cyrusdb /tmp/new-mailboxes.db skiplist /<configdirectory>/mailboxes.db <new file format>
 
 .. note::
     The :cyrusman:`cvt_cyrusdb(8)` command does not accept relative paths.
 
-7. Start new 3.0 Cyrus and verify
+7. Start new 3.2 Cyrus and verify
 ---------------------------------
 
 ::
@@ -288,12 +290,12 @@ DAEMON section.
 
 Check ``/var/log/syslog`` for errors so you can quickly understand potential problems.
 
-When you're satisfied version 3.0 is running and can see all its data correctly,
+When you're satisfied version 3.2 is running and can see all its data correctly,
 start the new Cyrus up with your regular init script.
 
 If something has gone wrong, contact us on the :ref:`mailing list <feedback-mailing-lists>`.
 You can revert to backups and keep processing mail using your old version
-until you're able to finish your 3.0 installation.
+until you're able to finish your 3.2 installation.
 
 .. note::
 
@@ -304,15 +306,6 @@ until you're able to finish your 3.0 ins
 8. Reconstruct databases and cache
 ----------------------------------
 
-.. warning::
-
-    Versions of 3.0 prior to 3.0.11 contained a bug (:issue:`2389`) that
-    could lead to loss of seen state/flags during `reconstruct` for some
-    messages that already existed prior to Cyrus 2.3.  The :ref:`3.0.11
-    release notes <relnotes-3.0.11-changes>` contain the specifics.
-
-    Consider upgrading to 3.0.11 rather than an earlier release.
-
 The following steps can each take a long time, so we recommend
 running them one at a time (to reduce locking contention and high I/O load).
 
@@ -322,7 +315,8 @@ To upgrade all the mailboxes to the late
 
     reconstruct -V max
 
-New configuration: if turning on conversations, you need to create conversations.db for each user.::
+New configuration: if turning on conversations, you need to create conversations.db for each user.
+(This is required for jmap).::
 
      ctl_conversationsdb -b -r
 
@@ -335,16 +329,28 @@ databases need to be reconstructed due t
 
     dav_reconstruct -a
 
+If you are upgrading from 3.0, and have the `reverseacls` feature enabled
+in :cyrusman:`imapd.conf(5)`, you may need to regenerate the data it uses
+(which is stored in `mailboxes.db`).  This is automatically regenerated at
+startup by `ctl_cyrusdb -r` if the `reverseacls` setting has changed. So,
+to force a regeneration:
+
+    1. Shut down Cyrus
+    2. Change `reverseacls` to `0` in :cyrusman:`imapd.conf(5)`
+    3. Run :cyrusman:`ctl_cyrusdb(8)` with the `-r` switch (or just start
+       Cyrus, assuming your :cyrusman:`cyrus.conf(5)` contains a
+       `ctl_cyrusdb -r` entry in the START section).  The old RACL entries
+       will be removed
+    4. (If you started Cyrus, shut it down again)
+    5. Change `reverseacls` back to `1`
+    6. Start up Cyrus (or run `ctl_cyrusdb -r`).  The RACL entries will
+       be rebuilt
+
 9. Do you want any new features?
 --------------------------------
 
-3.0 comes with many lovely new features. Consider which ones you want to enable.
-Here are some which may interest you. Check the :ref:`3.0 release notes <imap-release-notes-3.0>`
-for the full list.
-
-* :ref:`Backups <cyrus-backups>`
-* :ref:`Xapian for searching <imapinstall-xapian>`
-* Cross-domain support. See ``crossdomains`` in :cyrusman:`imapd.conf(5)`
+3.2 comes with many lovely new features. Consider which ones you want to enable.
+Check the :ref:`3.2 release notes <imap-release-notes-3.2>` for the full list.
 
 10. Upgrade complete
 --------------------
@@ -353,9 +359,9 @@ Your upgrade is complete! We have a supe
 anonymous responses) we would love for you to fill out, so we can get a feel for
 how many Cyrus installations are out there, and how the upgrade process went.
 
-|3.0 survey link|
+|3.2 survey link|
 
-.. |3.0 survey link| raw:: html
+.. |3.2 survey link| raw:: html
 
     <a href="https://cyrusimap.typeform.com/to/YI9P0f" target="_blank">
     I'll fill in the survey right now</a> (opens in a new window)
@@ -374,9 +380,9 @@ upgrade all your back end servers first.
 Upgrade your mupdate master and front ends last.
 
 If you are upgrading from 2.4, and wish to use XFER to transfer your
-mailboxes to your new 3.0 server, please consider first upgrading your
+mailboxes to your new 3.2 server, please consider first upgrading your
 2.4 setup to version 2.4.19 or later.  Earlier versions of 2.4 do not
-correctly recognise the 2.5 and 3.0 mailbox versions, and will
+correctly recognise the 2.5 and later mailbox versions, and will
 downgrade mailboxes (losing metadata) in transit.  2.4.19 and later
-versions correctly recognise 2.5 and 3.0 servers, and will not
+versions correctly recognise 2.5 and later servers, and will not
 downgrade mailbox versions in transit.
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/access-control/identifiers.rst 3.2.0-3/docsrc/imap/reference/admin/access-control/identifiers.rst
--- 3.0.13-5/docsrc/imap/reference/admin/access-control/identifiers.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/access-control/identifiers.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ distinguished be the prefix "group:".  F
 
 .. todo:: FIXME: Clarify what an ACL entry looks like first. Refer to
           how user login names are translated into their identifiers, and (in
-          that section) refer to altnamespace, unixhiersep, default domain,
+          that section) refer to altnamespace, unixhierarchysep, default domain,
           virtdomains, sasl_auth_mech tips and tricks etc.
 
 There are two special identifiers, "anonymous", and "anyone", which are
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/locations/configuration-state.rst 3.2.0-3/docsrc/imap/reference/admin/locations/configuration-state.rst
--- 3.0.13-5/docsrc/imap/reference/admin/locations/configuration-state.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/locations/configuration-state.rst	2020-04-24 02:03:00.000000000 +0000
@@ -174,10 +174,6 @@ settings in :cyrusman:`imapd.conf(5)`:
 	:start-after: startblob notifysocket
 	:end-before: endblob notifysocket
 
-.. include:: /imap/reference/manpages/configs/imapd.conf.rst
-	:start-after: startblob sphinx_socket
-	:end-before: endblob sphinx_socket
-
 Per-user State Directories
 ==========================
 
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/locations/searchtiers.rst 3.2.0-3/docsrc/imap/reference/admin/locations/searchtiers.rst
--- 3.0.13-5/docsrc/imap/reference/admin/locations/searchtiers.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/locations/searchtiers.rst	2020-04-24 02:03:00.000000000 +0000
@@ -18,7 +18,7 @@ setting:
         :start-after: startblob defaultsearchtier
         :end-before: endblob defaultsearchtier
 
-Search Tier Partition location
+Search Tier Partition Location
 ------------------------------
 
 Each search tier to be used requires a partition location be specified
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/monitoring.rst 3.2.0-3/docsrc/imap/reference/admin/monitoring.rst
--- 3.0.13-5/docsrc/imap/reference/admin/monitoring.rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/monitoring.rst	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,50 @@
+.. _imap-admin-monitoring:
+
+==========
+Monitoring
+==========
+
+Cyrus IMAP supports monitoring using Prometheus_.
+
+To use this functionality, Cyrus IMAP must have been built with the
+``--enable-http`` configure option enabled.
+
+.. _imap-admin-monitoring-setup:
+
+Setup
+=====
+
+    * Set the `prometheus_enabled` setting in :cyrusman:`imapd.conf(5)` to "yes"
+    * Add the `prometheus` module to your `httpmodules` in :cyrusman:`imapd.conf(5)`
+    * Set the `prometheus_need_auth`, `prometheus_update_freq` and `prometheus_stats_dir`
+      settings in :cyrusman:`imapd.conf(5)` to taste
+    * Add a job to run ``promstatsd -c`` to the START section of :cyrusman:`cyrus.conf(5)`
+      (this cleans up the stats files from the previous run)
+    * Add a job to run ``promstatsd`` to the DAEMON section of :cyrusman:`cyrus.conf(5)`
+      (the actual daemon process)
+    * Configure your Prometheus server to scrape http://yourserver.example.com/metrics
+
+Configuration options
+=====================
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_enabled
+        :end-before: endblob prometheus_enabled
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_need_auth
+        :end-before: endblob prometheus_need_auth
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_update_freq
+        :end-before: endblob prometheus_update_freq
+
+    .. include:: /imap/reference/manpages/configs/imapd.conf.rst
+        :start-after: startblob prometheus_stats_dir
+        :end-before: endblob prometheus_stats_dir
+
+.. _imap-admin-monitoring-end:
+
+Back to :ref:`imap-admin`
+
+.. _Prometheus: https://prometheus.io
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/murder/murder-failure-modes.rst 3.2.0-3/docsrc/imap/reference/admin/murder/murder-failure-modes.rst
--- 3.0.13-5/docsrc/imap/reference/admin/murder/murder-failure-modes.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/murder/murder-failure-modes.rst	2020-04-24 02:03:00.000000000 +0000
@@ -38,7 +38,7 @@ Don't have a backup? Well it is still ea
 4. Start everything backup
 5. Use ctl_mboxlist -m on each backend to update the murder master with any missing changes.
 
-If you are using skiplist for your mailboxes.db then you can just copy the file. If you are using a berkeley format then things are trickier since there is environmental state. It should be possible to run db_recover on both databases, then delete the db folder the mailboxes.db from the murder master and copy those from the frontend (this has not been tested)
+If you are using skiplist for your mailboxes.db then you can just copy the file.
 
 Hard recovery
 -------------
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/ports/sockets.rst 3.2.0-3/docsrc/imap/reference/admin/ports/sockets.rst
--- 3.0.13-5/docsrc/imap/reference/admin/ports/sockets.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/ports/sockets.rst	2020-04-24 02:03:00.000000000 +0000
@@ -22,7 +22,6 @@ directory for Cyrus sockets. This defaul
     idle      <rundir>/idle   # idled daemon socket
     notify    <rundir>/notify # Notification daemon socket
     ptloader  <rundir>/ptsock # PT Loader socket (alternative authorization)
-    sphinx    <rundir>/sphinx # Sphinx full-text search daemon socket
 
 .. _imap-admin-sock-end:
 
@@ -47,7 +46,3 @@ sites, via the use of several settings i
 .. include:: /imap/reference/manpages/configs/imapd.conf.rst
 	:start-after: startblob ptloader_sock
 	:end-before: endblob ptloader_sock
-
-.. include:: /imap/reference/manpages/configs/imapd.conf.rst
-	:start-after: startblob sphinx_socket
-	:end-before: endblob sphinx_socket
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/sieve.rst 3.2.0-3/docsrc/imap/reference/admin/sieve.rst
--- 3.0.13-5/docsrc/imap/reference/admin/sieve.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/sieve.rst	2020-04-24 02:03:00.000000000 +0000
@@ -180,6 +180,12 @@ Sieve has a lot of `extensions <http://w
 * Date :rfc:`5260`
 * Index :rfc:`5260`
 * Variables :rfc:`5229`
+* Editheader Extension :rfc:`5293`
+* Reject and Extended Reject :rfc:`5429`
+* Externally Stored Lists :rfc:`6134`
+* Duplicate Extension :rfc:`7352`
+* Ihave Extension :rfc:`5463`
+* Delivering to Special-Use Mailboxes `Draft special-use RFC <http://tools.ietf.org/html/draft-bosch-sieve-special-use-01>`_
 * IMAP flag Extension `Draft imap flags RFC <http://tools.ietf.org/html/draft-ietf-sieve-imapflags-05>`_
 * Body Extension :rfc:`5173`
 
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/sop/mailbox-quota.rst 3.2.0-3/docsrc/imap/reference/admin/sop/mailbox-quota.rst
--- 3.0.13-5/docsrc/imap/reference/admin/sop/mailbox-quota.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/sop/mailbox-quota.rst	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 Mailbox Folders exempt from quota
 ---------------------------------
 
-By creating an additional quota root, a folder's contents can be made excempt from counting towards the mailbox's quota.
+By creating an additional quota root, a folder's contents can be made exempt from counting towards the mailbox's quota.
 
 .. note::
     Making an INBOX/Archive/ Folder exempt from quota: ::
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/sop/replication.rst 3.2.0-3/docsrc/imap/reference/admin/sop/replication.rst
--- 3.0.13-5/docsrc/imap/reference/admin/sop/replication.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/sop/replication.rst	2020-04-24 02:03:00.000000000 +0000
@@ -314,7 +314,7 @@ EVENTS section of :cyrusman:`cyrus.conf(
 
     EVENTS {
         <...>
-        # Peridoically sync ALL user mailboxes every 4 hours
+        # Periodically sync ALL user mailboxes every 4 hours
         syncclient       cmd="/usr/cyrus/bin/sync_client -A" period=240
 
         # Periodically sync changes at specific times
@@ -400,7 +400,7 @@ exercise::
     offsitesync     cmd="/usr/cyrus/bin/sync_client -r -n offsite"
 
 Again, this is just an example for illustration.  The system provides so
-much flexibility, and one can combine channels with chaining to acheive
+much flexibility, and one can combine channels with chaining to achieve
 even more.
 
 .. _replication-other-uses:
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/sop/userdeny.rst 3.2.0-3/docsrc/imap/reference/admin/sop/userdeny.rst
--- 3.0.13-5/docsrc/imap/reference/admin/sop/userdeny.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/sop/userdeny.rst	2020-04-08 00:07:13.000000000 +0000
@@ -3,6 +3,8 @@ Managing user_deny.db
 
 The user_deny database allows you to deny access via POP/IMAP even if the user can authenticate to the Cyrus server. For example, if the authentication data is also used for other network services.
 
+Use :cyrusman:`cyr_deny(8)` to manage the database.
+
 If the user_deny.db file doesn't exist in %configdirectory% (often /var/lib/imap) then you'll need to create it. In the example below, /var/lib/imap/ is used.
 
 ::
@@ -11,18 +13,14 @@ If the user_deny.db file doesn't exist i
     # /usr/lib/cyrus-imapd/cvt_cyrusdb /tmp/user_deny.flat flat /var/lib/imap/user_deny.db skiplist
     # chown cyrus:cyrus /var/lib/imap/user_deny.db
 
-The database specification can be found at http://cyrusimap.org/docs/cyrus-imapd/2.4.17/internal/database-formats.php
-
-**Key:** <Userid>
-
-**Data:** <Version>TAB<Deny List (comma-separated wildmat patterns)>TAB<Deny Message>
+The database specification can be found at :ref:`imap-concepts-deployment-db-userdeny`.
 
 ::
 
     # su - cyrus
-    $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2     pop3    Can't use pop."
+    $ cyr_dbtool /var/lib/imap/user_deny.db skiplist set **username** "2<tab>pop3<tab>Can't use pop."
 
-In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.
+Here `pop3` is the service name as spelled in :cyrusman:`cyrus.conf(5)`.  In order to type a tab character, you will need to escape your tabs. In bash, this is done by typing CTRL-v and then pressing Tab.
 
 If you got it right, when you authenticate via pop3 you should see something like the following::
 
diff -pruN 3.0.13-5/docsrc/imap/reference/admin/tweaking.rst 3.2.0-3/docsrc/imap/reference/admin/tweaking.rst
--- 3.0.13-5/docsrc/imap/reference/admin/tweaking.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin/tweaking.rst	2020-04-24 02:03:00.000000000 +0000
@@ -137,4 +137,28 @@ To gain performance, execute the followi
 
         CHATTRSYNC=0
 
-.. _dm-cache: http://en.wikipedia.org/wiki/Dm-cache
\ No newline at end of file
+.. _dm-cache: http://en.wikipedia.org/wiki/Dm-cache
+
+
+Mailbox locking
+---------------
+Cyrus IMAP uses fcntl(2) based file locking for mailboxes, for example during
+SELECT commands. To mitigate race conditions it locks mailbox names even
+for non-existing mailboxes. For example, if user foo issued the following
+command
+
+    .. parsed-literal::
+
+       SELECT INBOX.x
+
+for non-existing mailbox x, it creates a lock file
+
+    .. parsed-literal::
+
+       $CYRUS_CONFDIR/lock/user/foo/x.lock
+
+which might be left on the filesystem after completion of the command.
+
+This has in practice not shown to be an issue. If this is a concern however,
+keeping the lock file directory in a tmpfs allows for both fast locking and
+to purge stale locks during controlled Cyrus downtimes.
diff -pruN 3.0.13-5/docsrc/imap/reference/administration-tools.rst 3.2.0-3/docsrc/imap/reference/administration-tools.rst
--- 3.0.13-5/docsrc/imap/reference/administration-tools.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/administration-tools.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,86 +0,0 @@
-Tools & Utilities
------------------
-
-arbitron
-++++++++
-
-arbitronsort.pl
-+++++++++++++++
-
-chk_cyrus
-+++++++++
-
-ctl_cyrusdb
-+++++++++++
-
-ctl_deliver
-+++++++++++
-
-ctl_mboxlist
-++++++++++++
-
-cvt_cyrusdb
-+++++++++++
-
-cvt_cyrusdb_all
-+++++++++++++++
-
-cyr_dbtool
-++++++++++
-
-cyr_df
-++++++
-
-cyrdump
-+++++++
-
-cyr_expire
-++++++++++
-
-cyr_virusscan
-+++++++++++++
-
-Tool to disinfect mailboxes by operation of external virus scanning
-library or provided IMAP SEARCH string.
-
-fetchnews
-+++++++++
-
-cyr_sequence
-++++++++++++
-
-cyr_synclog
-+++++++++++
-
-cyr_userseen
-++++++++++++
-
-masssievec
-++++++++++
-
-Script to mass compile Sieve scripts
-
-mbexamine
-+++++++++
-
-mbpath
-++++++
-
-mkimap
-++++++
-
-mknewsgroups
-++++++++++++
-
-rehash
-++++++
-
-translatesieve
-++++++++++++++
-
-script to translate sieve scripts to use unixhierarchysep and/or altnamespace
-
-undohash
-++++++++
-
-absolutely ancient (downgrade to prior 1.6.2+), probably should be obsoleted entirely
diff -pruN 3.0.13-5/docsrc/imap/reference/admin.rst 3.2.0-3/docsrc/imap/reference/admin.rst
--- 3.0.13-5/docsrc/imap/reference/admin.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/admin.rst	2020-04-24 02:03:00.000000000 +0000
@@ -28,6 +28,7 @@ Management
     admin/protlayer
     admin/sop
     admin/eventsource    
+    admin/monitoring
     admin/config-mailboxdistribution
     admin/murder/murder
     admin/nginx-proxy
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/feature-database-backend.rst 3.2.0-3/docsrc/imap/reference/faqs/feature-database-backend.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/feature-database-backend.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/feature-database-backend.rst	2020-04-24 02:03:00.000000000 +0000
@@ -3,10 +3,6 @@ Which database backend should I use for
 
 Here's a brief summary of the major database types:
 
-* **Berkeley DB**: Slow enumeration, fast random access, fast write, binary support. However, it has proved to be somewhat unstable and prone to locking problems.
-
-* **Berkeley DB (no sync)**: Slow enumeration, fast random access, very fast write, binary support, but no guarantee of database durability; recent writes can be lost on crashes.
-
 * **Skiplist**: Proprietary Cyrus Format, fast enumeration, moderately fast write, moderately fast random access, binary support
 
 * **Flat**: Easy to maintain format, fast enumeration, very slow write, moderate random access, no binary support
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/install-detecting-berkeley.rst 3.2.0-3/docsrc/imap/reference/faqs/install-detecting-berkeley.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/install-detecting-berkeley.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/install-detecting-berkeley.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,10 +0,0 @@
-Problems detecting Berkley DB on Red Hat Linux
-----------------------------------------------
-
-Modern Redhat Linux ships with a Berkeley DB compiled 
-``--with-pthreads``, which Cyrus is unable to directly link against. 
-
-You can either recompile Berkeley DB without pthread support, or you can 
-add ``-lpthread`` to your LDFLAGS environment variable before you 
-configure/build. 
-
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/install-linkerwarnings.rst 3.2.0-3/docsrc/imap/reference/faqs/install-linkerwarnings.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/install-linkerwarnings.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/install-linkerwarnings.rst	2020-04-24 02:03:00.000000000 +0000
@@ -27,15 +27,3 @@ from the linker like the following:
 
 In this case, ClamAV is still linked against OpenSSL 1.0, while Cyrus is
 building with OpenSSL 1.1.
-
-.. _libical-warnings:
-
-Libical v1.0.1 or v2.0
-----------------------
-
-You may see warnings regarding libical v2.0 being recommended to support certain
-functionality. Currently libical v1.0.1 is sufficient, unless you need/want
-RSCALE (non-gregorian recurrences), VPOLL (consensus scheduling), or
-VAVAILABILITY (specifying availability over time) functionality. If v2 is
-required, it will need to be installed from `github
-<https://github.com/libical/libical>`_.
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/interop-slow-delivery.rst 3.2.0-3/docsrc/imap/reference/faqs/interop-slow-delivery.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/interop-slow-delivery.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/interop-slow-delivery.rst	2020-04-24 02:03:00.000000000 +0000
@@ -9,7 +9,7 @@ There are a number of things that can af
     
     3. Slow dns. Some MTAs (like sendmail) talk to dns a lot. If dns is slow, mail delivery appears slow. We run named on each Cyrus machine 
     
-    4. Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and dissapear. Sometimes it just hangs. Not sure why, but restarting may help.
+    4. Lmtpproxyd is having trouble. Sometimes lmtpproxyd will die and disappear. Sometimes it just hangs. Not sure why, but restarting may help.
 
 If you have a large volume of mail then :ref:`Cyrus Murder Mail Delivery 
 <murder-mail-delivery>` has some tips. 
@@ -18,6 +18,5 @@ We experienced some filesystem locking p
 lmtpd-processes to be started. Performance was seriously degraded, 
 resulting in timeouts and endless retries. We use a postfix instance 
 between to limit parallel deliveries to lmtpd resulting in much higher 
-throughput. With berkeley-nosync as duplicate suppression db, 50-100 
-Messages/sec are doable. 
+throughput.
 
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-annotations.rst 3.2.0-3/docsrc/imap/reference/faqs/o-annotations.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-annotations.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-annotations.rst	2020-04-24 02:03:00.000000000 +0000
@@ -3,46 +3,89 @@
 What annotations are available?
 -------------------------------
 
-Cyrus annotations are based on a draft (http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08) version of :rfc:`5464`.
+Cyrus annotations are based on a draft
+(http://tools.ietf.org/html/draft-daboo-imap-annotatemore-08) version of
+:rfc:`5464`.
 
-* **/admin** - Sets the administrator email address for the server. (See :cyrusman:`cyradm(8)`)
+* **/admin** - Sets the administrator email address for the server. (See
+  :cyrusman:`cyradm(8)`)
 
-* **/check** - Boolean value "true" or "false" that indicates whether this mailbox should be checked at regular intervals by the client. The interval in minutes is specified by the ``/checkperiod`` entry. (Draft RFC)
+* **/check** - Boolean value "true" or "false" that indicates whether this
+  mailbox should be checked at regular intervals by the client. The interval
+  in minutes is specified by the ``/checkperiod`` entry. (Draft RFC)
 
-* **/checkperiod** - Numeric value indicating a period of minutes that the client uses to determine the interval of regular 'new mail' checks for the corresponding mailbox. (Draft RFC)
+* **/checkperiod** - Numeric value indicating a period of minutes that the
+  client uses to determine the interval of regular 'new mail' checks for the
+  corresponding mailbox. (Draft RFC)
 
-* **/comment** - Sets a comment or description associated with the mailbox. (cyradm(8)) /motd - Sets a "message of the day". The message gets displayed as an ALERT after authentication.
+* **/comment** - Sets a comment or description associated with the mailbox.
+  (cyradm(8))
 
-* **/sort** - Defines the default sort criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if sorting is not required. (Draft RFC)
+* **/motd** - Sets a "message of the day". The message gets displayed
+  as an ALERT after authentication.
 
-* **/thread** - Defines the default thread criteria [I-D.ietf-imapext-sort] to use when first displaying the mailbox contents to the user, or NIL if threading is not required. If both sort and thread are not NIL, then threading should take precedence over sorting. (Draft RFC)
+* **/sort** - Defines the default sort criteria [I-D.ietf-imapext-sort] to use
+  when first displaying the mailbox contents to the user, or NIL if sorting is
+  not required. (Draft RFC)
 
-* **/vendor/cmu/cyrus-imapd/condstore** - Enables the IMAP CONDSTORE extension (modification sequences) on the mailbox. (See :cyrusman:`cyradm(8)`)
+* **/thread** - Defines the default thread criteria [I-D.ietf-imapext-sort] to
+  use when first displaying the mailbox contents to the user, or NIL if
+  threading is not required. If both sort and thread are not NIL, then
+  threading should take precedence over sorting. (Draft RFC)
 
-* **vendor/cmu/cyrus-imapd/duplicatedeliver** - Flag signalling that we're allowing duplicate delivery of messages to the mailbox, overriding system-wide duplicate suppression. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/condstore** - Enables the IMAP CONDSTORE extension
+  (modification sequences) on the mailbox. (See :cyrusman:`cyradm(8)`)
 
-* **/vendor/cmu/cyrus-imapd/expire** - Sets the number of days after which messages will be expired from the mailbox. (cyradm(8))
+* **vendor/cmu/cyrus-imapd/duplicatedeliver** - Flag signalling that we're
+  allowing duplicate delivery of messages to the mailbox, overriding
+  system-wide duplicate suppression.
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/freespace** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/expire** - Sets the number of days after which
+  messages will be expired from the mailbox. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/lastpop** - (time_t) of the last pop3 login to this INBOX, used to enforce the "poptimeout" imapd.conf option. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/archive** - Sets the number of days after which
+  messages will be archived from the mailbox. (cyradm(8))
 
-* **vendor/cmu/cyrus-imapd/lastupdate** - (time_t) of the last time a message was appended (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/delete** - Sets the number of days after which
+  messages will be deleted from the mailbox. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/news2mail** - Sets an email address to which messages injected into the server via NNTP will be sent. (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/freespace** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/partition** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/lastpop** - (time_t) of the last pop3 login to
+  this INBOX, used to enforce the "poptimeout" imapd.conf option.
+  (:ref:`imap-developer-guidance-mailbox-format`)
+
+* **vendor/cmu/cyrus-imapd/lastupdate** - (time_t) of the last time a message
+  was appended
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/pop3newuidl** - Flag signalling that we're using "uidvalidity.uid" instead of just "uid" for the output of the POP3 UIDL command. (https://cyrusimap.org/docs/cyrus-imapd/2.5.7/internal/mailbox-format.php)
+* **/vendor/cmu/cyrus-imapd/news2mail** - Sets an email address to which
+  messages injected into the server via NNTP will be sent. (cyradm(8))
 
-* **/vendor/cmu/cyrus-imapd/serve** - Undocumented.
+* **/vendor/cmu/cyrus-imapd/partition** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/sharedseen** - Enables the use of a shared \Seen flag on messages rather than a per-user \Seen flag. The ’s’ right in the mailbox ACL still controls whether a user can set the shared \Seen flag. (See :cyrusman:`cyradm(8)`)
+* **/vendor/cmu/cyrus-imapd/pop3newuidl** - Flag signalling that we're using
+  "uidvalidity.uid" instead of just "uid" for the output of the POP3 UIDL
+  command.
+  (:ref:`imap-developer-guidance-mailbox-format`)
 
-* **/vendor/cmu/cyrus-imapd/shutdown** - Sets a shutdown message. The message gets displayed as an ALERT and all users are disconnected from the server (subsequent logins are disallowed). (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/serve** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/sieve** - Indicates the name of the global sieve script that should be run when a message is delivered to the shared mailbox (not used for personal mailboxes). (cyradm(8))
+* **/vendor/cmu/cyrus-imapd/sharedseen** - Enables the use of a shared \Seen
+  flag on messages rather than a per-user \Seen flag. The ’s’ right in the
+  mailbox ACL still controls whether a user can set the shared \Seen flag.
+  (See :cyrusman:`cyradm(8)`)
+
+* **/vendor/cmu/cyrus-imapd/shutdown** - Sets a shutdown message. The message
+  gets displayed as an ALERT and all users are disconnected from the server
+  (subsequent logins are disallowed). (cyradm(8))
+
+* **/vendor/cmu/cyrus-imapd/sieve** - Indicates the name of the global sieve
+  script that should be run when a message is delivered to the shared mailbox
+  (not used for personal mailboxes). (cyradm(8))
 
 * **/vendor/cmu/cyrus-imapd/size** - Undocumented.
 
-* **/vendor/cmu/cyrus-imapd/squat** - Indicates that the mailbox should have a squat index created for it. (See :cyrusman:`squatter(8)`)
\ No newline at end of file
+* **/vendor/cmu/cyrus-imapd/squat** - Indicates that the mailbox should be
+  indexed. (See :cyrusman:`squatter(8)`)
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-berkeleydb.rst 3.2.0-3/docsrc/imap/reference/faqs/o-berkeleydb.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-berkeleydb.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-berkeleydb.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-Why does ctl_cyrusdb -r take so long with Berkeley DB?
-------------------------------------------------------
-
-Berkeley DB maintains a log of all the transactions since the last 
-checkpoint of the database. In order to ensure the database is in a 
-consistent state, you must recover the log after any outage (thus the 
-recommendation to run these processes when Cyrus starts). They can take 
-a long time for a few reasons. 
-
-The most common one is that you need to checkpoint the cyrusdb more 
-often. This can be done with a simple ``ctl_cyrusdb -c``. If you do this 
-very often, the amount of log that needs to be recovered will be 
-significantly shorter. We recommend doing this at least once every half 
-hour, and more often on busy sites. 
-
-The other reason is that your :ref:`deliver.db may be very large <faq-o-deliberdb-size>`. This is 
-solvable by increasing the pruning interval (the -E parameter to 
-ctl_deliver, which you should run on a regular basis), or (in a pinch) 
-by just removing the database (since the effects of losing it do not 
-prevent operation, they just cause vacation messages to be resent, and 
-duplicate delivery suppression to possibly deliver duplicates). 
-
-* "by increasing the pruning interval": My understanding is that the 
-   number after "-E" is the number of days after which entries are 
-   discarded. Is there a way to reduce it to a number of hours? Since most 
-   of our mail is internal mail should rarely be delayed by more then an 
-   hour or two. 
-
-* In case it's useful to anyone we discovered that moving /var/lib/imap 
-   from an ext2 to an ext3 journaled filesystem made a vast difference for 
-   the worse. While recovering the database Berkeley DB does a vast 
-   quantity of small writes and that combined with the updates to the 
-   journal absolutely kills disk performance (with journalling it was 
-   taking about 40 minutes to start Cyrus on a mail server with about 500 
-   users and 200G of mail). On the flip side moving /var/lib/imap to a 
-   hardware RAID system with a decent amount of onboard cache reduced this 
-   time to under 30 seconds. I think Berkeley DB could probably be 
-   optimized to deal with this better, but in the mean time avoid 
-   journaling filesystems, or at least be prepared to experiment to find 
-   something that works for you. 
-
-
-
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-db3-lockers.rst 3.2.0-3/docsrc/imap/reference/faqs/o-db3-lockers.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-db3-lockers.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-db3-lockers.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-Is the "db3: x Lockers" log message harmful?
---------------------------------------------
-
-This message is generally not harmful unless it is increasing at an 
-alarming rate or you are seeing other performance problems. It indicates 
-contention within a Berkeley DB database page, and especially on small 
-databases will occur quite frequently. 
-
-If there are performance problems, often times the best solution is to 
-convert your mailbox list to a skiplist format. 
-
-Paul M Fleming (pfleming@siumed.edu) also notes::
-
-    We found limiting the number of lmtp processes to 10 helped with locker problems. Let sendmail/postfix handle the queuing and lmtp the delivery.. When we tried to blast 10-20 messages/sec at our test server locking became a problem with the duplicate delivery db. Across 3 servers and 600 concurrent logins (lmtpd maxchild=10 on each server) we never see any locking problems and usually have less than 1 second delivery times.
-    
-Andreas (andreas@conectiva.com.br) writes::
-
-    Take a look at this text: http://www.openldap.org/faq/index.cgi?_highlightWords=locks&file=893
-    
-    It's written for openldap, but explains several important Berkeley DB configuration parameters. In particular:
-    
-        On a very busy system you might see error messages talking about running out of locks, lockers, or lock objects. Usually the default values are plenty, and in older versions of the BDB library the errors were more likely due to library bugs than actual system load. However, it is possible that you have actually run out of lock resources due to heavy system usage. If this happens, you should read about the set_lk_max_lockers[1], set_lk_max_locks[2], and set_lk_max_objects[3] keywords.
-
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_lockers.html
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_locks.html
-    http://www.oracle.com/technology/documentation/berkeley-db/db/api_reference/C/envset_lk_max_objects.html
-
-    The links above talk about the C api, but don't get alarmed, these paremeters can be set with a DB_CONFIG configuration file located in the DB environment home.
-
-I also suppose the :manpage:`db_stat(8)` utility can be used to diagnose this.
-
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst 3.2.0-3/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-deleted-expired-expunged-purged.rst	2020-04-24 02:03:00.000000000 +0000
@@ -100,13 +100,13 @@ values:
 
 Exceptional circumstances aside, when ``immediate`` or ``default`` is
 the configured ``expunge_mode``, message files are often purged from the
-filesytem too quickly for anyone to recover.
+filesystem too quickly for anyone to recover.
 
 .. NOTE::
 
     One such exceptional circumstance is a mailbox with multiple
     sessions keeping the mailbox open. Cyrus IMAP ensures no mailbox
-    records dissappear from underneath an existing open mailbox session.
+    records disappear from underneath an existing open mailbox session.
 
 Moved to Trash Folder
 ---------------------
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-deliverdb-size.rst 3.2.0-3/docsrc/imap/reference/faqs/o-deliverdb-size.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-deliverdb-size.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-deliverdb-size.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,7 +10,7 @@ of data there.
 
 Note also that it is common for databases to have unused 
 space that may not be immediately recovered for performance reasons 
-(this is the case with Berkeley DB and Cyrus Skiplist) You can control 
+(this is the case with Cyrus Skiplist) You can control
 the size by increasing the frequency at which it gets pruned. 
 
 
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-otherdatabases.rst 3.2.0-3/docsrc/imap/reference/faqs/o-otherdatabases.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-otherdatabases.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-otherdatabases.rst	2020-04-24 02:03:00.000000000 +0000
@@ -16,5 +16,5 @@ mailboxes.
 Cyrus DOES have the option of using databases of various types for 
 storing some other information, such as authentication data, mailbox 
 lists, etc. There may be reasons to add a SQL backend to these databases 
-in the future (in addition to flat, skiplist, and berkeley). 
+in the future (in addition to flat, and skiplist).
 
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst 3.2.0-3/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/o-sharedfilesystem-gpfs.rst	2020-04-24 02:03:00.000000000 +0000
@@ -27,7 +27,7 @@ Our Cyrus installation has about 80K use
 many millions of files. Just the number of files alone would be enough 
 to kill the idea of using GPFS. 
 
-Cyrus makes pretty extensive use of mmap(), and so does Berkeley DB. 
+Cyrus makes pretty extensive use of mmap().
 While GPFS implements mmap(), the GPFS architect had some words about 
 the way certain operations are accomplished in Cyrus. I think there are 
 (or used to be) places where an mmap'd file is opened for write with 
diff -pruN 3.0.13-5/docsrc/imap/reference/faqs/r-murder-ha.rst 3.2.0-3/docsrc/imap/reference/faqs/r-murder-ha.rst
--- 3.0.13-5/docsrc/imap/reference/faqs/r-murder-ha.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/faqs/r-murder-ha.rst	2020-04-24 02:03:00.000000000 +0000
@@ -15,7 +15,7 @@ The mupdate server is indeed a single po
 failure at this point only prohibits message delivery (via the LMTP 
 proxies that are querying it for up-to-date mailbox data) and certain 
 mailbox operations (create, delete, setacl, and so on). Mail can still 
-be accessed by all users of the system, and incoming mail will recieve 
+be accessed by all users of the system, and incoming mail will receive 
 temporary failures, so the sending MTA should continue to queue the 
 mail. 
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/configs/cyrus.conf.rst 3.2.0-3/docsrc/imap/reference/manpages/configs/cyrus.conf.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/configs/cyrus.conf.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/configs/cyrus.conf.rst	2020-04-24 02:03:00.000000000 +0000
@@ -138,7 +138,7 @@ on certain Internet/UNIX sockets.
     (as listed in ``/etc/services``).
 
     If *host* is missing, 0.0.0.0 (all interfaces) is assumed.  Use
-    localhost or 127.0.0.1 to restict access, i.e. when a proxy
+    localhost or 127.0.0.1 to restrict access, i.e. when a proxy
     on the same host is front-ending Cyrus.
 
     Note that on most systems UNIX socket paths are limited to around
@@ -243,8 +243,10 @@ DAEMON
 ------
 
 This section lists long running daemons to start before any
-**SERVICES** are spawned.  They will be shutdown when
-:cyrusman:`master(8)` is exiting.
+**SERVICES** are spawned.  :cyrusman:`master(8)`  will ensure that
+these processes are running, restarting any process which dies or
+forks. All listed processes will be shutdown when :cyrusman:`master(8)`
+is exiting.
 
 .. parsed-literal::
 
@@ -302,6 +304,7 @@ See Also
 :cyrusman:`imapd(8)`,
 :cyrusman:`pop3d(8)`,
 :cyrusman:`lmtpd(8)`,
+:cyrusman:`smmapd(8)`,
 :cyrusman:`timsieved(8)`,
 :cyrusman:`idled(8)`,
 :cyrusman:`notifyd(8)`,
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/configs/imapd.conf.rst 3.2.0-3/docsrc/imap/reference/manpages/configs/imapd.conf.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/configs/imapd.conf.rst	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/configs/imapd.conf.rst	2020-05-04 04:10:42.000000000 +0000
@@ -5,9 +5,9 @@
 
 .. _imap-reference-manpages-configs-imapd.conf:
 
-==========
-imapd.conf
-==========
+==============
+**imapd.conf**
+==============
 
 
 
@@ -55,6 +55,15 @@ DESCRIPTION
     \`\`true'' and \`\`\ 1'' turn the option on, the values \`\`no'', \`\`off'',
     \`\`f'', \`\`false'' and \`\`\ 0'' turn the option off.
 
+    Duration options take the form of a number followed by a unit, for example
+    **\ 32m** (32 minutes).  Units are **d** (days), **h** (hours), **m**
+    (minutes) and **s** (seconds).  Multiple units can be combined and will
+    be summed together, for example **\ 1h30m** is equivalent to **\ 90m**.  If
+    no unit is specified, an option-specific backward-compatible default unit
+    is assumed (documented on an option-by-option basis).  These are simple time
+    units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+    etc are not considered).
+
 FIELD DESCRIPTIONS
 ==================
 
@@ -149,6 +158,15 @@ FIELD DESCRIPTIONS
 
     .. endblob allowapop
 
+    .. startblob allowdeleted
+
+    ``allowdeleted:`` 0
+
+        Allow access to deleted and expunged data via vendor.cmu-\* access 
+
+
+    .. endblob allowdeleted
+
     .. startblob allownewnews
 
     ``allownewnews:`` 0
@@ -174,6 +192,15 @@ FIELD DESCRIPTIONS
 
     .. endblob allowplaintext
 
+    .. startblob allowsetacl
+
+    ``allowsetacl:`` 1
+
+        Defaults to enabled.  If disabled, disallows the use of the SETACL
+        command at all via IMAP. 
+
+    .. endblob allowsetacl
+
     .. startblob allowusermoves
 
     ``allowusermoves:`` 0
@@ -219,7 +246,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for mailbox annotations. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob annotation_db
@@ -336,6 +363,26 @@ FIELD DESCRIPTIONS
 
     .. endblob annotation_callout
 
+    .. startblob annotation_callout_disable_append
+
+    ``annotation_callout_disable_append:`` 0
+
+        Disables annotations on append with xrunannotator 
+
+
+    .. endblob annotation_callout_disable_append
+
+    .. startblob annotation_enable_legacy_commands
+
+    ``annotation_enable_legacy_commands:`` 0
+
+        Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+        These commands are deprecated and will be removed in the future,
+        but might be useful in the meantime for supporting old clients that
+        do not implement the :rfc:`5464` IMAP METADATA extension. 
+
+    .. endblob annotation_enable_legacy_commands
+
     .. startblob aps_topic
 
     ``aps_topic:`` <none>
@@ -376,13 +423,25 @@ FIELD DESCRIPTIONS
 
     .. startblob archive_days
 
-    ``archive_days:`` 7
+    ``archive_days:`` <none>
+
+        Deprecated in favour of *archive_after*. 
 
-        The number of days after which to move messages to the archive partition
-        if archiving is enabled 
 
     .. endblob archive_days
 
+    .. startblob archive_after
+
+    ``archive_after:`` 7d
+
+        The duration after which to move messages to the archive partition
+        if archiving is enabled.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob archive_after
+
     .. startblob archive_maxsize
 
     ``archive_maxsize:`` 1024
@@ -517,6 +576,25 @@ FIELD DESCRIPTIONS
 
     .. endblob autosubscribe_all_sharedfolders
 
+    .. startblob autocreate_acl
+
+    ``autocreate_acl:`` <none>
+
+        If folders are to be created by *autocreate_inbox_folders\R, this
+        setting can be used to apply additional ACLs to the autocreated
+        folders.  The syntax is "autocreate_acl folder identifier rights",
+        where *\ *folder* must match one of the *autocreate_inbox_folders*
+        folders, *identifier* must be a valid cyrus identifier, and
+        *rights* must be a valid cyrus rights string.  Multiple
+        identifier|rights pairs can be assigned to a single folder by providing
+        this setting multiple times.
+
+        For example, "autocreate_acl Plus anyone p" would allow lmtp delivery
+        to a folder named "Plus".
+
+
+    .. endblob autocreate_acl
+
     .. startblob autocreate_inbox_folders
 
     ``autocreate_inbox_folders:`` <none>
@@ -676,6 +754,15 @@ FIELD DESCRIPTIONS
 
     .. endblob autocreate_users
 
+    .. startblob autoexpunge
+
+    ``autoexpunge:`` 0
+
+        If set to yes, then all \Deleted messages will be automatically expunged whenever
+        an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect 
+
+    .. endblob autoexpunge
+
     .. startblob backuppartition-name
 
     ``backuppartition-name:`` <none>
@@ -729,21 +816,33 @@ FIELD DESCRIPTIONS
 
     .. startblob backup_retention_days
 
-    ``backup_retention_days:`` 7
+    ``backup_retention_days:`` <none>
+
+        Deprecated in favor of *backup_retention*. 
 
-        The number of days to keep content in backup after it has been deleted
-        from the source.  If set to a negative value or zero, deleted content
-        will be kept indefinitely. 
 
     .. endblob backup_retention_days
 
+    .. startblob backup_retention
+
+    ``backup_retention:`` 7d
+
+        How long to keep content in backup after it has been deleted
+        from the source.  If set to a negative value or zero, deleted content
+        will be kept indefinitely.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob backup_retention
+
     .. startblob backup_db
 
     ``backup_db:`` twoskip
 
         The cyrusdb backend to use for the backup locations database. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob backup_db
@@ -787,11 +886,20 @@ FIELD DESCRIPTIONS
 
     ``caldav_allowattach:`` 1
 
-        Enable managed attachments support on the caldav server. 
+        Enable managed attachments support on the CalDAV server. 
 
 
     .. endblob caldav_allowattach
 
+    .. startblob caldav_allowcalendaradmin
+
+    ``caldav_allowcalendaradmin:`` 0
+
+        Enable per-user calendar administration web UI on the CalDAV server. 
+
+
+    .. endblob caldav_allowcalendaradmin
+
     .. startblob caldav_allowscheduling
 
     ``caldav_allowscheduling:`` on
@@ -808,7 +916,7 @@ FIELD DESCRIPTIONS
 
     ``caldav_create_attach:`` 1
 
-        Create the 'Attachments' calendar if it doesn't already exist 
+        Create the 'Attachments' collection if it doesn't already exist 
 
 
     .. endblob caldav_create_attach
@@ -831,6 +939,21 @@ FIELD DESCRIPTIONS
 
     .. endblob caldav_create_sched
 
+    .. startblob caldav_historical_age
+
+    ``caldav_historical_age:`` 7d
+
+        How long after an occurrence of event or task has concluded
+        that it is considered 'historical'.  Changes to historical
+        occurrences of events or tasks WILL NOT have invite or reply
+        messages sent for them.  A negative value means that events
+        and tasks are NEVER considered historical.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed.  
+
+    .. endblob caldav_historical_age
+
     .. startblob caldav_maxdatetime
 
     ``caldav_maxdatetime:`` 20380119T031407Z
@@ -885,6 +1008,38 @@ FIELD DESCRIPTIONS
 
     .. endblob calendar_user_address_set
 
+    .. startblob calendar_component_set
+
+    ``calendar_component_set:`` VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL
+
+        Space-separated list of iCalendar component types that calendar
+        object resources may contain in a calendar collection.
+        This restriction is only set at calendar creation time and only
+        if the CalDAV client hasn't specified a restriction in the creation
+        request. 
+        Allowed values: *VEVENT*, *VTODO*, *VJOURNAL*, *VFREEBUSY*, *VAVAILABILITY*, *VPOLL*
+
+
+    .. endblob calendar_component_set
+
+    .. startblob carddav_allowaddmember
+
+    ``carddav_allowaddmember:`` 0
+
+        Enable support for POST add-member on the CardDAV server. 
+
+
+    .. endblob carddav_allowaddmember
+
+    .. startblob carddav_allowaddressbookadmin
+
+    ``carddav_allowaddressbookadmin:`` 0
+
+        Enable per-user addressbook administration web UI on the CardDAV server. 
+
+
+    .. endblob carddav_allowaddressbookadmin
+
     .. startblob carddav_realm
 
     ``carddav_realm:`` <none>
@@ -939,10 +1094,13 @@ FIELD DESCRIPTIONS
 
     .. startblob client_timeout
 
-    ``client_timeout:`` 10
+    ``client_timeout:`` 10s
+
+        Time to wait before returning a timeout failure when performing a
+        client connection (e.g. in a murder environment).
 
-        Number of seconds to wait before returning a timeout failure when
-        performing a client connection (e.g., in a murder environment) 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed.  
 
     .. endblob client_timeout
 
@@ -1000,20 +1158,41 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the per-user conversations database. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob conversations_db
 
     .. startblob conversations_expire_days
 
-    ``conversations_expire_days:`` 90
+    ``conversations_expire_days:`` <none>
+
+        Deprecated in favor of *conversations_expire_after*. 
+
+
+    .. endblob conversations_expire_days
+
+    .. startblob conversations_expire_after
+
+    ``conversations_expire_after:`` 90d
 
         How long the conversations database keeps the message tracking
         information needed for receiving new messages in existing
-        conversations, in days. 
+        conversations.
 
-    .. endblob conversations_expire_days
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
+
+    .. endblob conversations_expire_after
+
+    .. startblob conversations_max_thread
+
+    ``conversations_max_thread:`` 100
+
+        maximum size for a single thread.  Threads will split if they have this many
+        \* messages in them and another message arrives 
+
+    .. endblob conversations_max_thread
 
     .. startblob crossdomains
 
@@ -1085,14 +1264,28 @@ FIELD DESCRIPTIONS
 
     .. endblob dav_realm
 
+    .. startblob dav_lock_timeout
+
+    ``dav_lock_timeout:`` 20s
+
+        The maximum time to wait for a write lock on the per-user DAV database
+        before timeout. For HTTP requests, the HTTP status code 503 is returned
+        if the lock can not be obtained within this time.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob dav_lock_timeout
+
     .. startblob debug_command
 
     ``debug_command:`` <none>
 
         Debug command to be used by processes started with -D option.  The string
         is a C format string that gets 3 options: the first is the name of the
-        executable (without path).  The second is the pid (integer) and the third
-        is the service ID.  Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d 
+        executable (as specified in the cmd parameter in cyrus.conf). The second
+        is the pid (integer) and the third is the service ID.
+        Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d 
 
     .. endblob debug_command
 
@@ -1253,6 +1446,15 @@ FIELD DESCRIPTIONS
 
     .. endblob ischedule_dkim_key_file
 
+    .. startblob ischedule_dkim_required
+
+    ``ischedule_dkim_required:`` 1
+
+        A DKIM signature is required on received iSchedule requests. 
+
+
+    .. endblob ischedule_dkim_required
+
     .. startblob ischedule_dkim_selector
 
     ``ischedule_dkim_selector:`` <none>
@@ -1269,7 +1471,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the duplicate delivery suppression
         and sieve. 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob duplicate_db
@@ -1343,7 +1545,7 @@ FIELD DESCRIPTIONS
 
         Space-separated list of extra parameters to add to any appropriated event. 
 
-        Allowed values: *bodyStructure*, *clientAddress*, *diskUsed*, *flagNames*, *messageContent*, *messageSize*, *messages*, *modseq*, *service*, *timestamp*, *uidnext*, *vnd.cmu.midset*, *vnd.cmu.unseenMessages*, *vnd.cmu.envelope*, *vnd.cmu.sessionId*, *vnd.cmu.mailboxACL*, *vnd.cmu.mbtype*, *vnd.cmu.davFilename*, *vnd.cmu.davUid*, *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*, *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*, *vnd.fastmail.cid*, *vnd.fastmail.counters*
+        Allowed values: *bodyStructure*, *clientAddress*, *diskUsed*, *flagNames*, *messageContent*, *messageSize*, *messages*, *modseq*, *service*, *timestamp*, *uidnext*, *vnd.cmu.midset*, *vnd.cmu.unseenMessages*, *vnd.cmu.envelope*, *vnd.cmu.sessionId*, *vnd.cmu.mailboxACL*, *vnd.cmu.mbtype*, *vnd.cmu.davFilename*, *vnd.cmu.davUid*, *vnd.fastmail.clientId*, *vnd.fastmail.sessionId*, *vnd.fastmail.convExists*, *vnd.fastmail.convUnseen*, *vnd.fastmail.cid*, *vnd.fastmail.counters*, *vnd.cmu.emailid*, *vnd.cmu.threadid*
 
 
     .. endblob event_extra_params
@@ -1373,32 +1575,33 @@ FIELD DESCRIPTIONS
     ``expunge_mode:`` delayed
 
         The mode in which messages (and their corresponding cache entries)
-        are expunged.  "default" mode is the old behavior in which the
+        are expunged.  "semidelayed" mode is the old behavior in which the
         message files are purged at the time of the EXPUNGE, but index
-        and cache records are retained to facilitate QRESYNC.  (Note that
-        this behaviour is no longer the default, but is so named for historical
-        reasons.)  In "delayed" mode, which is the default since Cyrus 2.5.0,
+        and cache records are retained to facilitate QRESYNC.
+        In "delayed" mode, which is the default since Cyrus 2.5.0,
         the message files are also retained, allowing unexpunge to
         rescue them.  In "immediate" mode, both the message files and the
         index records are removed as soon as possible.  In all cases,
         nothing will be finally purged until all other processes have
         closed the mailbox to ensure they never see data disappear under
-        them.  In "default" or "delayed" mode, a later run of "cyr_expire"
+        them.  In "semidelayed" or "delayed" mode, a later run of "cyr_expire"
         will clean out the retained records (and possibly message files).
         This reduces the amount of I/O that takes place at the time of
         EXPUNGE and should result in greater responsiveness for the client,
         especially when expunging a large number of messages. 
-        Allowed values: *default*, *immediate*, *delayed*
+        Allowed values: *immediate*, *semidelayed*, *delayed*
 
 
     .. endblob expunge_mode
 
     .. startblob failedloginpause
 
-    ``failedloginpause:`` 3
+    ``failedloginpause:`` 3s
 
-        Number of seconds to pause after a failed login. 
+        Time to pause after a failed login.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob failedloginpause
 
@@ -1562,14 +1765,17 @@ FIELD DESCRIPTIONS
 
     .. startblob httpkeepalive
 
-    ``httpkeepalive:`` 20
+    ``httpkeepalive:`` 20s
+
+        Set the length of the HTTP server's keepalive heartbeat.  The
+        default is 20 seconds.  The minimum value is 0, which will disable
+        the keepalive heartbeat.  When enabled, if a request takes longer
+        than *httpkeepalive* to process, the server will send the client
+        provisional responses every *httpkeepalive* until the final
+        response can be sent.
 
-        Set the length of the HTTP server's keepalive heartbeat in seconds.
-        The default is 20.  The minimum value is 0, which will disable the
-        keepalive heartbeat.  When enabled, if a request takes longer than
-        *httpkeepalive* seconds to process, the server will send the client
-        provisional responses every *httpkeepalive* seconds until the
-        final response can be sent 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob httpkeepalive
 
@@ -1584,7 +1790,7 @@ FIELD DESCRIPTIONS
         Note that "domainkey" depends on "ischedule" being enabled, and
         that both "freebusy" and "ischedule" depend on "caldav" being
         enabled. 
-        Allowed values: *admin*, *caldav*, *carddav*, *domainkey*, *freebusy*, *ischedule*, *rss*, *tzdist*, *webdav*
+        Allowed values: *admin*, *caldav*, *carddav*, *cgi*, *domainkey*, *freebusy*, *ischedule*, *jmap*, *prometheus*, *rss*, *tzdist*, *webdav*
 
 
     .. endblob httpmodules
@@ -1603,11 +1809,14 @@ FIELD DESCRIPTIONS
 
     .. startblob httptimeout
 
-    ``httptimeout:`` 5
+    ``httptimeout:`` 5m
+
+        Set the length of the HTTP server's inactivity autologout timer.
+        The default is 5 minutes.  The minimum value is 0, which will
+        disable persistent connections.
 
-        Set the length of the HTTP server's inactivity autologout timer,
-        in minutes.  The default is 5.  The minimum value is 0, which will
-        disable persistent connections. 
+        For backwards compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob httptimeout
 
@@ -1631,12 +1840,15 @@ FIELD DESCRIPTIONS
 
     .. startblob imapidlepoll
 
-    ``imapidlepoll:`` 60
+    ``imapidlepoll:`` 60s
 
-        The interval (in seconds) for polling for mailbox changes and
-        ALERTs while running the IDLE command.  This option is used when
-        idled is not enabled or cannot be contacted.  The minimum value is
-        1.  A value of 0 will disable IDLE. 
+        The interval for polling for mailbox changes and ALERTs while running
+        the IDLE command.  This option is used when idled is not enabled or
+        cannot be contacted.  The minimum value is 1 second.  A value of 0
+        will disable IDLE.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob imapidlepoll
 
@@ -1672,7 +1884,7 @@ FIELD DESCRIPTIONS
 
     .. startblob implicit_owner_rights
 
-    ``implicit_owner_rights:`` lkxa
+    ``implicit_owner_rights:`` lkxan
 
         The implicit Access Control List (ACL) for the owner of a mailbox. 
 
@@ -1705,18 +1917,235 @@ FIELD DESCRIPTIONS
 
     .. endblob improved_mboxlist_sort
 
-    .. startblob internaldate_heuristic
+    .. startblob jmap_emailsearch_db_path
+
+    ``jmap_emailsearch_db_path:`` <none>
+
+        The absolute path to the JMAP email search cache file.  If not
+        specified, JMAP Email/query and Email/queryChanges will not
+        cache email search results. 
 
-    ``internaldate_heuristic:`` standard
+    .. endblob jmap_emailsearch_db_path
 
-        Mechanism to determine email internaldates on delivery/reconstruct.
-        "standard" uses time() when delivering a message, mtime on reconstruct.
-        "receivedheader" looks at the top most Received header
-        or time/mtime otherwise 
-        Allowed values: *standard*, *receivedheader*
+    .. startblob jmap_preview_annot
 
+    ``jmap_preview_annot:`` <none>
 
-    .. endblob internaldate_heuristic
+        The name of the per-message annotation, if any, to store message
+        previews. 
+
+    .. endblob jmap_preview_annot
+
+    .. startblob jmap_imagesize_annot
+
+    ``jmap_imagesize_annot:`` <none>
+
+        The name of the per-message annotation, if any, that stores a
+        JSON object, mapping message part numbers of MIME image types
+        to an array of their image dimensions. The array must have at
+        least two entries, where the first entry denotes the width
+        and the second entry the height of the image. Any additional
+        values are ignored.
+
+        For example, if message part 1.2 contains an image of width 300
+        and height 200, then the value of this annotation would be:
+
+        { "1.2" : [ 300, 200 ] }
+
+
+    .. endblob jmap_imagesize_annot
+
+    .. startblob jmap_inlinedcids_annot
+
+    ``jmap_inlinedcids_annot:`` <none>
+
+        The name of the per-message annotation, if any, that stores a
+        JSON object, mapping :rfc:`2392` Content-IDs referenced in HTML bodies
+        to the respective HTML body part number.
+
+        For example, if message part 1.2 contains HTML and references an
+        inlined image at "cid:foo", then the value of this annotation
+        would be:
+
+        { "<foo>" : "1.2" }
+
+        Note that the Content-ID key must be URL-unescaped and enclosed in
+        angular brackets, as defined in :rfc:`2392`. 
+
+    .. endblob jmap_inlinedcids_annot
+
+    .. startblob jmap_preview_length
+
+    ``jmap_preview_length:`` 64
+
+        The maximum byte length of dynamically generated message previews. Previews
+        stored in jmap_preview_annot take precedence. 
+
+    .. endblob jmap_preview_length
+
+    .. startblob jmap_max_size_upload
+
+    ``jmap_max_size_upload:`` 1048576
+
+        The maximum size (in kilobytes) that the JMAP API accepts
+        for blob uploads. Returned as the maxSizeUpload property
+        value of the JMAP \"urn:ietf:params:jmap:core\" capabilities object.
+        Default is 1Gb. 
+
+    .. endblob jmap_max_size_upload
+
+    .. startblob jmap_max_concurrent_upload
+
+    ``jmap_max_concurrent_upload:`` 5
+
+        The value to return for the maxConcurrentUpload property of
+        the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+        implementation does not enforce this rate-limit. 
+
+    .. endblob jmap_max_concurrent_upload
+
+    .. startblob jmap_max_size_request
+
+    ``jmap_max_size_request:`` 10240
+
+        The maximum size (in kilobytes) that the JMAP API accepts
+        for requests at the API endpoint. Returned as the
+        maxSizeRequest property value of the JMAP \"urn:ietf:params:jmap:core\"
+        capabilities object. Default is 10Mb. 
+
+    .. endblob jmap_max_size_request
+
+    .. startblob jmap_max_concurrent_requests
+
+    ``jmap_max_concurrent_requests:`` 5
+
+        The value to return for the maxConcurrentRequests property of
+        the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+        implementation does not enforce this rate-limit. 
+
+    .. endblob jmap_max_concurrent_requests
+
+    .. startblob jmap_max_calls_in_request
+
+    ``jmap_max_calls_in_request:`` 50
+
+        The maximum number of calls per JMAP request object.
+        Returned as the maxCallsInRequest property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_calls_in_request
+
+    .. startblob jmap_max_delayed_send
+
+    ``jmap_max_delayed_send:`` 512d
+
+        The value to return for the maxDelayedSend property of
+        the JMAP \"urn:ietf:params:jmap:emailsubmission\" capabilities object.
+        The Cyrus JMAP implementation does not enforce this limit.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob jmap_max_delayed_send
+
+    .. startblob jmap_max_objects_in_get
+
+    ``jmap_max_objects_in_get:`` 4096
+
+        The maximum number of ids that a JMAP client may request in
+        a single \"/get\" type method call. The actual number
+        of returned objects in the response may exceed this number
+        if the JMAP object type supports unbounded \"/get\" calls.
+        Returned as the maxObjectsInGet property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_objects_in_get
+
+    .. startblob jmap_max_objects_in_set
+
+    ``jmap_max_objects_in_set:`` 4096
+
+        The maximum number of objects a JMAP client may send to create,
+        update or destroy in a single /set type method call.
+        Returned as the maxObjectsInSet property value of the
+        JMAP \"urn:ietf:params:jmap:core\" capabilities object. 
+
+    .. endblob jmap_max_objects_in_set
+
+    .. startblob jmap_mail_max_size_attachments_per_email
+
+    ``jmap_mail_max_size_attachments_per_email:`` 10240
+
+        The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+        property of the JMAP \"urn:ietf:params:jmap:mail\" capabilities object. The Cyrus
+        JMAP implementation does not enforce this size limit. Default is 10 Mb.
+
+    .. endblob jmap_mail_max_size_attachments_per_email
+
+    .. startblob jmap_nonstandard_extensions
+
+    ``jmap_nonstandard_extensions:`` 0
+
+        If enabled, support non-standard JMAP extensions.  If not enabled,
+        only IETF standard JMAP functionality is supported. 
+
+    .. endblob jmap_nonstandard_extensions
+
+    .. startblob jmap_set_has_attachment
+
+    ``jmap_set_has_attachment:`` 1
+
+        If enabled, the $hasAttachment flag is determined and set for new messages
+        created with the JMAP Email/set or Email/import methods. This option should
+        typically be enabled, but installations using Cyrus-external message
+        annatotors to determine the $hasAttachment flag might want to disable it. 
+
+    .. endblob jmap_set_has_attachment
+
+    .. startblob jmap_vacation
+
+    ``jmap_vacation:`` 1
+
+        If enabled, support the JMAP vacation extension 
+
+
+    .. endblob jmap_vacation
+
+    .. startblob jmapuploadfolder
+
+    ``jmapuploadfolder:`` #jmap
+
+        the name of the folder for JMAP uploads (#jmap) 
+
+
+    .. endblob jmapuploadfolder
+
+    .. startblob jmapsubmission_deleteonsend
+
+    ``jmapsubmission_deleteonsend:`` 1
+
+        If enabled (the default) then delete the EmailSubmission as soon as the email
+        \* has been sent 
+
+    .. endblob jmapsubmission_deleteonsend
+
+    .. startblob jmapsubmissionfolder
+
+    ``jmapsubmissionfolder:`` #jmapsubmission
+
+        the name of the folder for JMAP Submissions (#jmapsubmission) 
+
+
+    .. endblob jmapsubmissionfolder
+
+    .. startblob jmappushsubscriptionfolder
+
+    ``jmappushsubscriptionfolder:`` #jmappushsubscription
+
+        the name of the folder for JMAP Push Subscriptions (#jmappushsubscription) 
+
+
+    .. endblob jmappushsubscriptionfolder
 
     .. startblob iolog
 
@@ -1823,7 +2252,9 @@ FIELD DESCRIPTIONS
         %u   = user
         %U   = user portion of %u (%U = test when %u = test@domain.tld)
         %d   = domain portion of %u if available (%d = domain.tld when %u =
-        %test@domain.tld), otherwise same as %r
+        test@domain.tld), otherwise same as %R
+        %R   = domain portion of %u starting with @ (%R = @domain.tld
+        when %u = test@domain.tld)
         %D   = user dn.  (use when ldap_member_method: filter)
         %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
 
@@ -2069,19 +2500,23 @@ FIELD DESCRIPTIONS
 
     .. startblob ldap_time_limit
 
-    ``ldap_time_limit:`` 5
+    ``ldap_time_limit:`` 5s
 
-        Specify a number of seconds for a search request to complete. 
+        How long to wait for a search request to complete.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ldap_time_limit
 
     .. startblob ldap_timeout
 
-    ``ldap_timeout:`` 5
+    ``ldap_timeout:`` 5s
 
-        Specify a number of seconds a search can take before timing out. 
+        How long a search can take before timing out.
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ldap_timeout
 
@@ -2230,6 +2665,19 @@ FIELD DESCRIPTIONS
 
     .. endblob lmtp_downcase_rcpt
 
+    .. startblob lmtp_exclude_specialuse
+
+    ``lmtp_exclude_specialuse:`` \\Snoozed
+
+        Don't allow delivery to folders with given special-use attributes.
+
+        Note that "snoozing" of emails can currently only be done via the
+        JMAP protocol, so delivery directly to the \Snoozed mailbox is
+        prohibited by default as it will not be moved back into INBOX
+        automatically. 
+
+    .. endblob lmtp_exclude_specialuse
+
     .. startblob lmtp_fuzzy_mailbox_match
 
     ``lmtp_fuzzy_mailbox_match:`` 0
@@ -2284,15 +2732,28 @@ FIELD DESCRIPTIONS
 
     .. startblob lmtptxn_timeout
 
-    ``lmtptxn_timeout:`` 300
+    ``lmtptxn_timeout:`` 5m
 
-        Timeout (in seconds) used during a lmtp transaction to a remote backend
-        (e.g. in a murder environment).  Can be used to prevent hung lmtpds
-        on proxy hosts when a backend server becomes unresponsive during a
-        lmtp transaction.  The default is 300 - change to zero for infinite. 
+        Timeout used during a lmtp transaction to a remote backend (e.g. in a
+        murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+        when a backend server becomes unresponsive during a lmtp transaction.
+        The default is 5 minutes - change to zero for infinite.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob lmtptxn_timeout
 
+    .. startblob lock_debugtime
+
+    ``lock_debugtime:`` <none>
+
+        A floating point number of seconds.  If set, time how long we wait for
+        any lock, and syslog the filename and time if it's longer than this
+        value.  The default of NULL means not to time locks. 
+
+    .. endblob lock_debugtime
+
     .. startblob loginrealms
 
     ``loginrealms:`` <empty string>
@@ -2353,6 +2814,21 @@ FIELD DESCRIPTIONS
 
     .. endblob mailnotifier
 
+    .. startblob master_bind_errors_fatal
+
+    ``master_bind_errors_fatal:`` 0
+
+        If enabled, failure to bind a port during startup is treated as a fatal
+        error, causing master to shut down immediately.  The default is to keep
+        running, with the affected service disabled until the next SIGHUP causes
+        it to retry.
+
+        Note that this only applies during startup.  New services that fail to
+        come up in response to a reconfig+SIGHUP will just be logged and disabled
+        like the default behaviour, without causing master to exit. 
+
+    .. endblob master_bind_errors_fatal
+
     .. startblob maxheaderlines
 
     ``maxheaderlines:`` 1000
@@ -2417,7 +2893,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for mailbox keys. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob mboxkey_db
@@ -2428,7 +2904,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the mailbox list. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob mboxlist_db
@@ -2738,10 +3214,13 @@ FIELD DESCRIPTIONS
 
     .. startblob nntptimeout
 
-    ``nntptimeout:`` 3
+    ``nntptimeout:`` 3m
+
+        Set the length of the NNTP server's inactivity autologout timer.
+        The minimum value is 3 minutes, also the default.
 
-        Set the length of the NNTP server's inactivity autologout timer,
-        in minutes.  The minimum value is 3, the default. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob nntptimeout
 
@@ -2798,15 +3277,6 @@ FIELD DESCRIPTIONS
 
     .. endblob partition-name
 
-    .. startblob outbox_sendlater
-
-    ``outbox_sendlater:`` 0
-
-        If enabled, any message with a \Draft flag will be sent at the time of its INTERNALDATE 
-
-
-    .. endblob outbox_sendlater
-
     .. startblob partition_select_mode
 
     ``partition_select_mode:`` freespace-most
@@ -2871,12 +3341,15 @@ FIELD DESCRIPTIONS
 
     .. startblob plaintextloginpause
 
-    ``plaintextloginpause:`` 0
+    ``plaintextloginpause:`` <none>
+
+        Time to pause after a successful plaintext login.  For systems that
+        support strong authentication, this permits users to perceive a cost
+        of using plaintext passwords.  (This does not affect the use of PLAIN
+        in SASL authentications.)
 
-        Number of seconds to pause after a successful plaintext login.  For
-        systems that support strong authentication, this permits users to
-        perceive a cost of using plaintext passwords.  (This does not
-        affect the use of PLAIN in SASL authentications.) 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob plaintextloginpause
 
@@ -2893,23 +3366,31 @@ FIELD DESCRIPTIONS
 
     ``popexpiretime:`` -1
 
-        The number of days advertised as being the minimum a message may be
+        The duration advertised as being the minimum a message may be
         left on the POP server before it is deleted (via the CAPA command,
         defined in the POP3 Extension Mechanism, which some clients may
-        support).  "NEVER", the default, may be specified with a negative
-        number.  The Cyrus POP3 server never deletes mail, no matter what
-        the value of this parameter is.  However, if a site implements a
-        less liberal policy, it needs to change this parameter
-        accordingly. 
+        support).  This duration has a granularity of whole days, with partial
+        days truncated (so e.g. "45m" is effectively "0d").  "NEVER", the
+        default, may be specified with a negative number.
+
+        The Cyrus POP3 server never deletes mail, no matter what the value of
+        this parameter is.  However, if a site implements a less liberal policy,
+        it needs to change this parameter accordingly.
+
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
 
     .. endblob popexpiretime
 
     .. startblob popminpoll
 
-    ``popminpoll:`` 0
+    ``popminpoll:`` <none>
 
         Set the minimum amount of time the server forces users to wait
-        between successive POP logins, in minutes. 
+        between successive POP logins.
+
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob popminpoll
 
@@ -2945,10 +3426,13 @@ FIELD DESCRIPTIONS
 
     .. startblob poptimeout
 
-    ``poptimeout:`` 10
+    ``poptimeout:`` 10m
+
+        Set the length of the POP server's inactivity autologout timer.
+        The minimum value is 10 minutes, the default.
 
-        Set the length of the POP server's inactivity autologout timer,
-        in minutes.  The minimum value is 10, the default. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob poptimeout
 
@@ -3007,6 +3491,49 @@ FIELD DESCRIPTIONS
 
     .. endblob proc_path
 
+    .. startblob prometheus_enabled
+
+    ``prometheus_enabled:`` 0
+
+        Whether tracking of service metrics for Prometheus is enabled. 
+
+
+    .. endblob prometheus_enabled
+
+    .. startblob prometheus_need_auth
+
+    ``prometheus_need_auth:`` admin
+
+        Authentication level required to fetch Prometheus metrics. 
+
+        Allowed values: *none*, *user*, *admin*
+
+
+    .. endblob prometheus_need_auth
+
+    .. startblob prometheus_update_freq
+
+    ``prometheus_update_freq:`` 10s
+
+        Frequency in at which promstatsd should re-collate its statistics
+        report.  The minimum value is 1 second, the default is 10 seconds.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob prometheus_update_freq
+
+    .. startblob prometheus_stats_dir
+
+    ``prometheus_stats_dir:`` <none>
+
+        Directory to use for gathering prometheus statistics.  If specified,
+        must be an absolute path.  If not specified, the default path
+        $configdirectory/stats/ will be used.  It may be advantageous to locate this
+        directory on ephemeral storage. 
+
+    .. endblob prometheus_stats_dir
+
     .. startblob proxy_authname
 
     ``proxy_authname:`` proxy
@@ -3107,7 +3634,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the pts cache. 
 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob ptscache_db
@@ -3123,10 +3650,13 @@ FIELD DESCRIPTIONS
 
     .. startblob ptscache_timeout
 
-    ``ptscache_timeout:`` 10800
+    ``ptscache_timeout:`` 3h
+
+        The timeout for the PTS cache database when using the auth_krb_pts
+        authorization method (default: 3 hours).
 
-        The timeout (in seconds) for the PTS cache database when using the
-        auth_krb_pts authorization method (default: 3 hours). 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob ptscache_timeout
 
@@ -3167,7 +3697,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for quotas. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *quotalegacy*, *twoskip*, *zeroskip*
 
 
     .. endblob quota_db
@@ -3323,12 +3853,14 @@ FIELD DESCRIPTIONS
 
     .. startblob rss_maxage
 
-    ``rss_maxage:`` 0
+    ``rss_maxage:`` <none>
 
-        Maximum age (in days) of items to display in an RSS channel.  If
-        non-zero, httpd will only display items received within the last
-        *rss_maxage* days.  If set to 0, all available items will be
-        displayed (the default). 
+        Maximum age of items to display in an RSS channel.  If non-zero,
+        httpd will only display items received within this time period.
+        If set to 0, all available items will be displayed (the default).
+
+        For backward compatibility, if no unit is specified, days is
+        assumed. 
 
     .. endblob rss_maxage
 
@@ -3419,6 +3951,78 @@ FIELD DESCRIPTIONS
 
     .. endblob search_batchsize
 
+    .. startblob search_attachment_extractor_url
+
+    ``search_attachment_extractor_url:`` <none>
+
+        A HTTP or HTTPS URL to extract search text from rich text attachments
+        and other media during search indexing. The server at this URL must
+        implement the following protocol:
+
+        1. For each attachment of an email, Cyrus sends a GET request to the
+        URL <extractor-url>/<cyrus-id>, where <extractor-url> is the
+        configured URL and <cyrus-id> is a Cyrus-chosen path segment that
+        uniquely identifies this attachment.
+
+        2. If the extractor already has a cached plain text extract of the
+        attachment identified by <cyrus-id> then it may return HTTP status
+        code 200 (OK) and the plain text extract with a Content-Type
+        "text/plain" header. Otherwise it must return HTTP status 404 (Not Found).
+
+        3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+        a PUT request to the same URL as previously. The PUT request body
+        contains the decoded, binary body of the attachment. The Content-Type
+        request header has the same value as declared in the MIME part
+        headers, including any type parameters.
+
+        4. The extractor must return the plain text extract with either HTTP status
+        200 (OK) or 201 (Created) and a Content-Type "text/plain" header.
+        If no text can be extracted, then the extractor may return any return code
+        in the range 4xx, or 200 and an empty response body.
+
+        Any other HTTP status code is treated as an error. For performance
+        reasons, the Cyrus indexer attempts to keep-alive the TCP connection
+        to the extractor. 
+
+    .. endblob search_attachment_extractor_url
+
+    .. startblob search_index_language
+
+    ``search_index_language:`` 0
+
+
+        If enabled, then message bodies and subjects are indexed by their
+        detected language, if the cld2 dependency is built into Cyrus.
+        Regardless of this flag, bodies and subjects are always indexed and
+        searched using the default stemmer.
+
+
+    .. endblob search_index_language
+
+    .. startblob search_index_parts
+
+    ``search_index_parts:`` 0
+
+
+        If enabled, then message parts are each indexed separately into Xapian
+        so that matches can be done by part.
+
+
+    .. endblob search_index_parts
+
+    .. startblob search_query_language
+
+    ``search_query_language:`` 0
+
+
+        If enabled, then message bodies and subjects searched by their language
+        that got detected during indexing, if any.
+        Regardless of this flag, bodies and subjects are always searched using
+        the default stemmer.
+
+
+    .. endblob search_query_language
+
     .. startblob search_normalisation_max
 
     ``search_normalisation_max:`` 1000
@@ -3436,7 +4040,7 @@ FIELD DESCRIPTIONS
 
         The indexing engine used to speed up searching.  
 
-        Allowed values: *none*, *squat*, *sphinx*, *xapian*
+        Allowed values: *none*, *squat*, *xapian*
 
 
     .. endblob search_engine
@@ -3469,9 +4073,9 @@ FIELD DESCRIPTIONS
 
     ``search_indexed_db:`` twoskip
 
-        The cyrusdb backend to use for the search latest indexed uid state. 
+        The cyrusdb backend to use for the search latest indexed uid state.  Xapian only. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob search_indexed_db
@@ -3485,6 +4089,16 @@ FIELD DESCRIPTIONS
 
     .. endblob search_maxtime
 
+    .. startblob search_queryscan
+
+    ``search_queryscan:`` 5000
+
+        The minimum number of records require to do a direct scan of all G keys
+        \* rather than indexed lookups.  A value of 0 means always do indexed lookups.
+
+
+    .. endblob search_queryscan
+
     .. startblob search_skipdiacrit
 
     ``search_skipdiacrit:`` 1
@@ -3538,7 +4152,7 @@ FIELD DESCRIPTIONS
 
         The absolute base path to the search stopword lists. If not specified,
         no stopwords will be taken into account during search indexing. Currently,
-        the only supported and default stop word file is english.list. 
+        the only supported and default stop word file is english.txt. 
 
     .. endblob search_stopword_path
 
@@ -3566,7 +4180,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the seen state. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob seenstate_db
@@ -3580,6 +4194,17 @@ FIELD DESCRIPTIONS
 
     .. endblob sendmail
 
+    .. startblob sendmail_auth_id
+
+    ``sendmail_auth_id:`` CYRUS_SENDMAIL_AUTH_ID
+
+        The name of an environment variable to set when invoking sendmail.
+        The value of this environment variable will contain the user id
+        of the currently authenticated user. If no user is authenticated
+        the environment variable is not set. 
+
+    .. endblob sendmail_auth_id
+
     .. startblob serverlist
 
     ``serverlist:`` <none>
@@ -3695,9 +4320,20 @@ FIELD DESCRIPTIONS
 
     .. endblob sieve_allowreferrals
 
+    .. startblob sieve_duplicate_max_expiration
+
+    ``sieve_duplicate_max_expiration:`` 90d
+
+        Maximum expiration time for duplicate message tracking records.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
+
+    .. endblob sieve_duplicate_max_expiration
+
     .. startblob sieve_extensions
 
-    ``sieve_extensions:`` fileinto reject vacation vacation-seconds imapflags notify envelope relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables
+    ``sieve_extensions:`` fileinto reject vacation vacation-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x-cyrus-jmapquery x-cyrus-snooze
 
         Space-separated list of Sieve extensions allowed to be used in
         sieve scripts, enforced at submission by timsieved(8).  Any
@@ -3705,7 +4341,7 @@ FIELD DESCRIPTIONS
         will continue to execute regardless of the extensions used.  This
         option has no effect on options that are disabled at compile time
         (e.g., "regex"). 
-        Allowed values: *fileinto*, *reject*, *vacation*, *vacation-seconds*, *imapflags*, *notify*, *include*, *envelope*, *body*, *relational*, *regex*, *subaddress*, *copy*, *date*, *index*, *imap4flags*, *mailbox*, *mboxmetadata*, *servermetadata*, *variables*
+        Allowed values: *fileinto*, *reject*, *vacation*, *vacation-seconds*, *imapflags*, *notify*, *include*, *envelope*, *environment*, *body*, *relational*, *regex*, *subaddress*, *copy*, *date*, *index*, *imap4flags*, *mailbox*, *mboxmetadata*, *servermetadata*, *variables*, *editheader*, *extlists*, *duplicate*, *ihave*, *fcc*, *special-use*, *redirect-dsn*, *redirect-deliverby*, *mailboxid*, *x-cyrus-log*, *x-cyrus-jmapquery*, *x-cyrus-snooze*
 
 
     .. endblob sieve_extensions
@@ -3747,21 +4383,37 @@ FIELD DESCRIPTIONS
 
     .. endblob sieve_sasl_send_unsolicited_capability
 
+    .. startblob sieve_use_lmtp_reject
+
+    ``sieve_use_lmtp_reject:`` 1
+
+        Enabled by default.  If reject can be done via LMTP, then return a 550
+        rather than generating the bounce message in Cyrus. 
+
+    .. endblob sieve_use_lmtp_reject
+
     .. startblob sieve_vacation_min_response
 
-    ``sieve_vacation_min_response:`` 259200 /\* 3 days \*/
+    ``sieve_vacation_min_response:`` 3d
+
+        Minimum time interval between consecutive vacation responses, per
+        draft-ietf-vacation-seconds.txt.  The default is 3 days.
 
-        Minimum time interval (in seconds) between consecutive vacation responses,
-        per draft-ietf-vacation-seconds.txt . 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sieve_vacation_min_response
 
     .. startblob sieve_vacation_max_response
 
-    ``sieve_vacation_max_response:`` 7776000 /\* 90 days \*/
+    ``sieve_vacation_max_response:`` 90d
 
-        Maximum time interval (in seconds) between consecutive vacation responses,
-        per draft-ietf-vacation-seconds.txt . 
+        Maximum time interval between consecutive vacation responses, per
+        draft-ietf-vacation-seconds.txt.  The default is 90 days.  The
+        minimum is 7 days.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sieve_vacation_max_response
 
@@ -3833,6 +4485,81 @@ FIELD DESCRIPTIONS
 
     .. endblob skiplist_unsafe
 
+    .. startblob smtp_backend
+
+    ``smtp_backend:`` sendmail
+
+        The SMTP backend to use for sending email.
+
+        The \"host\" backend sends message submissions via
+        a TCP socket to the SMTP host defined in the config
+        option smtp_host.
+
+        The \"sendmail\" backend forks the Cyrus process into
+        the executable defined in the config option sendmail.
+        The executable must accept \"-bs\" as command line
+        argument, read from stdin and must implement the minimum
+        SMTP protocol as defined in section 4.5.1 of :rfc:`5321`.
+
+        If the SMTP EHLO command reports AUTH (:rfc:`4954`) as a
+        supported extension, then the MAIL FROM command includes
+        the AUTH parameter, with its value set to the name of any
+        authenticated user which triggered the email. The AUTH
+        parameter is omitted if the user is unknown to the calling
+        process.
+
+        If the directory
+        *configdirectory*/log/smtpclient.\ *smtp_backend*
+        exists, then telemetry logs for outgoing SMTP sessions will
+        be created in this directory.
+
+        Allowed values: *host*, *sendmail*
+
+
+    .. endblob smtp_backend
+
+    .. startblob smtp_host
+
+    ``smtp_host:`` localhost:587
+
+        The SMTP host to use for sending mail (also see the
+        smtp_backend option). The value of this option must
+        the name or IP address of a TCP host, followed optionally
+        by a colon and the port or service to use. The default
+        port is 587. TLS may be activated by appending \"/tls\"
+        to the value. Authentication is enabled if smtp_auth_authname
+        is set. Authentication can be explicitly disabled by appending
+        \"/noauth\" to the host address. 
+
+    .. endblob smtp_host
+
+    .. startblob smtp_auth_authname
+
+    ``smtp_auth_authname:`` <none>
+
+        The authentication name to use when authenticating to the SMTP
+        server defined in smtp_host. 
+
+    .. endblob smtp_auth_authname
+
+    .. startblob smtp_auth_password
+
+    ``smtp_auth_password:`` <none>
+
+        The password to use when authenticating to the SMTP server defined
+        in smtp_host. 
+
+    .. endblob smtp_auth_password
+
+    .. startblob smtp_auth_realm
+
+    ``smtp_auth_realm:`` <none>
+
+        The authentication SASL realm to use when authenticating to a SMTP
+        server. 
+
+    .. endblob smtp_auth_realm
+
     .. startblob soft_noauth
 
     ``soft_noauth:`` 1
@@ -3849,7 +4576,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for caching sort results (currently only
         used for xconvmultisort) 
-        Allowed values: *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob sortcache_db
@@ -3866,43 +4593,25 @@ FIELD DESCRIPTIONS
 
     .. endblob specialuse_extra
 
-    .. startblob specialusealways
-
-    ``specialusealways:`` 0
-
-        If enabled, this option causes LIST and LSUB output to always include
-        the XLIST "special-use" flags 
-
-    .. endblob specialusealways
-
-    .. startblob sphinx_text_excludes_odd_headers
-
-    ``sphinx_text_excludes_odd_headers:`` 0
-
-        If enabled, Sphinx will perform a TEXT search as if it matches
-        FROM, TO, CC, BCC or SUBJECT but not any other headers.  This
-        is contrary to the RFC but a more useful behaviour for most
-        users.  Default: disabled. 
-
-    .. endblob sphinx_text_excludes_odd_headers
+    .. startblob specialuse_protect
 
-    .. startblob sphinx_socket
+    ``specialuse_protect:`` \\Archive \\Drafts \\Important \\Junk \\Sent \\Trash
 
-    ``sphinx_socket:`` {configdirectory}/socket/sphinx
+        Whitespace separated list of special-use attributes
+        to protect the mailboxes for.  If set, don't allow
+        mailboxes with these special use attributes to be deleted
+        or renamed to have a different parent. Default is the built-in list
 
-        Unix domain socket that the Sphinx searchd
-        daemons listens on. 
+    .. endblob specialuse_protect
 
-    .. endblob sphinx_socket
-
-    .. startblob sphinx_pidfile
-
-    ``sphinx_pidfile:`` /var/run/sphinx.pid
+    .. startblob specialusealways
 
-        File where the Sphinx searchd daemon writes its pid. 
+    ``specialusealways:`` 1
 
+        If enabled, this option causes LIST and LSUB output to always include
+        the XLIST "special-use" flags 
 
-    .. endblob sphinx_pidfile
+    .. endblob specialusealways
 
     .. startblob sql_database
 
@@ -3960,6 +4669,52 @@ FIELD DESCRIPTIONS
 
     .. endblob sql_usessl
 
+    .. startblob srs_alwaysrewrite
+
+    ``srs_alwaysrewrite:`` 0
+
+        If true, perform SRS rewriting for ALL forwarding, even when not required. 
+
+
+    .. endblob srs_alwaysrewrite
+
+    .. startblob srs_domain
+
+    ``srs_domain:`` <none>
+
+        The domain to use in rewritten addresses. This must point only to machines
+        which know the encoding secret used by this system. When present, SRS is
+        enabled. 
+
+    .. endblob srs_domain
+
+    .. startblob srs_hashlength
+
+    ``srs_hashlength:`` 0
+
+        The hash length to generate in a rewritten address. 
+
+
+    .. endblob srs_hashlength
+
+    .. startblob srs_secrets
+
+    ``srs_secrets:`` <none>
+
+        A list of secrets with which to generate addresses. 
+
+
+    .. endblob srs_secrets
+
+    .. startblob srs_separator
+
+    ``srs_separator:`` <none>
+
+        The separator to appear immediately after SRS[01] in rewritten addresses. 
+
+
+    .. endblob srs_separator
+
     .. startblob srvtab
 
     ``srvtab:`` <empty string>
@@ -3987,7 +4742,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the subscriptions list. 
 
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob subscription_db
@@ -4019,7 +4774,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the imap status cache. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob statuscache_db
@@ -4139,12 +4894,15 @@ FIELD DESCRIPTIONS
 
     .. startblob sync_repeat_interval
 
-    ``sync_repeat_interval:`` 1
+    ``sync_repeat_interval:`` 1s
 
-        Minimum interval (in seconds) between replication runs in rolling
-        replication mode. If a replication run takes longer than this
-        time, we repeat immediately.
-        Prefix with a channel name to only apply for that channel 
+        Minimum interval between replication runs in rolling replication
+        mode. If a replication run takes longer than this time, we repeat
+        immediately.  Prefix with a channel name to only apply for that
+        channel.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sync_repeat_interval
 
@@ -4160,10 +4918,14 @@ FIELD DESCRIPTIONS
 
     .. startblob sync_timeout
 
-    ``sync_timeout:`` 1800
+    ``sync_timeout:`` 30m
 
-        Number of seconds to wait for a response before returning a timeout
-        failure when talking to a replication peer (client or server). 
+        How long to wait for a response before returning a timeout failure
+        when talking to a replication peer (client or server).  The minimum
+        duration is 3 seconds, the default is 30 minutes.
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob sync_timeout
 
@@ -4182,8 +4944,14 @@ FIELD DESCRIPTIONS
 
     ``syslog_prefix:`` <none>
 
-        String to be prepended to the process name in syslog entries. 
-
+        String to be prepended to the process name in syslog entries. Can
+        be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+        variable.
+
+        Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+        advantage that it can be set before the **imapd.conf** is read, so
+        errors while reading the config file can be syslogged with the correct
+        prefix. 
 
     .. endblob syslog_prefix
 
@@ -4219,8 +4987,11 @@ FIELD DESCRIPTIONS
 
     ``tcp_keepalive_idle:`` 0
 
-        Number of seconds a connection must be idle before keepalive
-        probes are sent (0 == system default) 
+        How long a connection must be idle before keepalive probes are sent
+        (0 == system default).
+
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob tcp_keepalive_idle
 
@@ -4228,8 +4999,10 @@ FIELD DESCRIPTIONS
 
     ``tcp_keepalive_intvl:`` 0
 
-        Number of seconds between keepalive probes (0 == system default) 
+        Time between keepalive probes (0 == system default).
 
+        For backward compatibility, if no unit is specified, seconds is
+        assumed. 
 
     .. endblob tcp_keepalive_intvl
 
@@ -4253,22 +5026,27 @@ FIELD DESCRIPTIONS
 
     .. startblob timeout
 
-    ``timeout:`` 32
+    ``timeout:`` 32m
 
-        The length of the IMAP server's inactivity autologout timer,
-        in minutes.  The minimum value is 30.  The default is 32 to
-        allow a bit of leeway for clients that try to NOOP every 30
-        minutes. 
+        The length of the IMAP server's inactivity autologout timer.
+        The minimum value is 30 minutes.  The default is 32 minutes,
+        to allow a bit of leeway for clients that try to NOOP every
+        30 minutes.
+
+        For backward compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob timeout
 
     .. startblob imapidletimeout
 
-    ``imapidletimeout:`` 0
+    ``imapidletimeout:`` <none>
+
+        Timeout for idling clients (:rfc:`2177`).  If not set (the default),
+        the value of "timeout" will be used instead.
 
-        Timeout for idling clients (:rfc:`2177`) in minutes. If set to
-        zero (the default) or less, the value of "timeout" will be
-        used instead. 
+        For backward compatibility, if no unit is specified, minutes
+        is assumed. 
 
     .. endblob imapidletimeout
 
@@ -4339,6 +5117,15 @@ FIELD DESCRIPTIONS
 
     .. endblob tls_ciphers
 
+    .. startblob tls_crl_file
+
+    ``tls_crl_file:`` <none>
+
+        Path to a file containing the Certificate Revocation List 
+
+
+    .. endblob tls_crl_file
+
     .. startblob tls_client_ca_dir
 
     ``tls_client_ca_dir:`` <none>
@@ -4448,17 +5235,29 @@ FIELD DESCRIPTIONS
 
     ``tls_server_cert:`` <none>
 
-        File containing the certificate, including the full chain, presented to clients. 
-
+        File containing the certificate, including the full chain, presented to clients.
+        Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+        comma without spaces. 
 
     .. endblob tls_server_cert
 
+    .. startblob tls_server_dhparam
+
+    ``tls_server_dhparam:`` <none>
+
+        File containing the DH parameters belonging to the certificate in
+        tls_server_cert. 
+
+    .. endblob tls_server_dhparam
+
     .. startblob tls_server_key
 
     ``tls_server_key:`` <none>
 
         File containing the private key belonging to the certificate in
-        tls_server_cert. 
+        tls_server_cert.  If not set, tls_server_cert must contain both private and
+        public key.  Two files with keys can be set, if two certifates are used, in
+        which case the files must be separated with comma without spaces 
 
     .. endblob tls_server_key
 
@@ -4468,7 +5267,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the TLS cache. 
 
-        Allowed values: *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob tls_sessions_db
@@ -4484,11 +5283,14 @@ FIELD DESCRIPTIONS
 
     .. startblob tls_session_timeout
 
-    ``tls_session_timeout:`` 1440
+    ``tls_session_timeout:`` 24h
+
+        The length of time that a TLS session will be cached for later
+        reuse.  The maximum value is 24 hours, also the default.  A
+        value of 0 will disable session caching.
 
-        The length of time (in minutes) that a TLS session will be cached
-        for later reuse.  The maximum value is 1440 (24 hours), the
-        default.  A value of 0 will disable session caching. 
+        For backward compatibility, if no unit is specified, minutes is
+        assumed. 
 
     .. endblob tls_session_timeout
 
@@ -4531,7 +5333,7 @@ FIELD DESCRIPTIONS
 
         The cyrusdb backend to use for the user access list. 
 
-        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *lmdb*
+        Allowed values: *flat*, *skiplist*, *sql*, *twoskip*, *zeroskip*
 
 
     .. endblob userdeny_db
@@ -4616,6 +5418,26 @@ FIELD DESCRIPTIONS
 
     .. endblob virtdomains
 
+    .. startblob virusscan_notification_subject
+
+    ``virusscan_notification_subject:`` Automatically deleted mail
+
+        The text used in the subject of email notifications created by
+        **cyr_virusscan(8)** when deleting infected mail. 
+
+    .. endblob virusscan_notification_subject
+
+    .. startblob virusscan_notification_template
+
+    ``virusscan_notification_template:`` <none>
+
+        The absolute path to a file containing a template to use to describe
+        infected messages that have been deleted by **cyr_virusscan(8)**.
+        See **cyr_virusscan(8)** for specification of the format of this file.
+        If not specified, the builtin default template will be used. 
+
+    .. endblob virusscan_notification_template
+
     .. startblob xbackup_enabled
 
     ``xbackup_enabled:`` 0
@@ -4655,9 +5477,9 @@ FIELD DESCRIPTIONS
 
     ``zoneinfo_db:`` twoskip
 
-        The cyrusdb backend to use for zoneinfo. 
-
-        Allowed values: *flat*, *skiplist*, *twoskip*, *lmdb*
+        The cyrusdb backend to use for zoneinfo.  This database is used by the
+        "tzdist" *http_modules*, and is managed by **ctl_zoneinfo(8)**.
+        Allowed values: *flat*, *skiplist*, *twoskip*, *zeroskip*
 
 
     .. endblob zoneinfo_db
@@ -4671,6 +5493,20 @@ FIELD DESCRIPTIONS
 
     .. endblob zoneinfo_db_path
 
+    .. startblob zoneinfo_dir
+
+    ``zoneinfo_dir:`` <none>
+
+        The absolute path to the zoneinfo directory, containing timezone
+        definitions as generated by the vzic tool.  If not specified, whatever
+        definitions libical finds will be used.
+
+        If you are providing a Time Zone Data Distribution Service (i.e. you have
+        "tzdist" listed in *http_modules*), then this configuration option MUST
+        be specified. 
+
+    .. endblob zoneinfo_dir
+
     .. startblob object_storage_enabled
 
     ``object_storage_enabled:`` 0
@@ -4714,7 +5550,7 @@ FIELD DESCRIPTIONS
 
     .. startblob openio_rawx_timeout
 
-    ``openio_rawx_timeout:`` 30
+    ``openio_rawx_timeout:`` 30s
 
         The OpenIO timeout to query to the RAWX services (default 30 sec). 
 
@@ -4723,7 +5559,7 @@ FIELD DESCRIPTIONS
 
     .. startblob openio_proxy_timeout
 
-    ``openio_proxy_timeout:`` 5
+    ``openio_proxy_timeout:`` 5s
 
         The OpenIO timeout to query to the PROXY services (default 5 sec). 
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_backups.rst	2020-04-24 02:03:00.000000000 +0000
@@ -135,6 +135,10 @@ Options
 
     With this option, the verification step will be skipped.
 
+.. option:: -j
+
+    Produce output in JSON format.  The default is plain text.
+
 .. option:: -v
 
     Increase the verbosity.  Can be specified multiple times.
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_conversationsdb.rst	2020-04-24 02:03:00.000000000 +0000
@@ -104,6 +104,12 @@ Options
     subset of **-b**; in particular it does not create conversations or
     assign messages to conversations.
 
+.. option:: -S
+
+    If given with **-b**, allows splitting of conversations during the
+    rewrite.   Only do this is changing the maximum conversation size
+    and you need to split those existing conversations.
+
 Examples
 ========
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_cyrusdb.rst	2020-05-04 03:28:02.000000000 +0000
@@ -47,6 +47,12 @@ Options
     matches the configured database type in imapd.conf.  If not, the
     file is automatically converted using the same logic as cvt_cyrusdb.
 
+    If the ``reverseacls`` option in :cyrusman:`imapd.conf(5)` is enabled,
+    and the RACL entries do not exist in the database, they will be
+    generated.  Conversely, if RACL entries do exist in the database,
+    but the ``reverseacls`` option is disabled, then the entries will be
+    cleaned up.
+
 .. option:: -x
 
     Used with ``-r`` to only recover the database, and prevent any
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ctl_mboxlist.rst	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [ **-p** *partition* ] [ **-f** *filename* ]
+    **ctl_mboxlist** [ **-C** *config-file* ] **-d** [ **-x** ] [**-y**] [ **-p** *partition* ] [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-u** [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-m** [ **-a** ] [ **-w** ] [ **-i** ] [ **-f** *filename* ]
     **ctl_mboxlist** [ **-C** *config-file* ] **-v** [ **-f** *filename* ]
@@ -53,9 +53,14 @@ Options
     When performing a dump, remove the mailboxes dumped from the mailbox
     list (mostly useful when specified with **-p**).
 
+.. option:: -y
+
+    When performing a dump, also list intermediary mailboxes which would
+    be hidden from IMAP.
+
 .. option:: -p partition
 
-    When performing a dump, dump only thise mailboxes that live on
+    When performing a dump, dump only those mailboxes that live on
     *partition*.
 
 .. option:: -f filename
@@ -79,7 +84,7 @@ Options
 
 .. option:: -a
 
-    When used with **-m**, assume the local mailboxes file is authoritiative,
+    When used with **-m**, assume the local mailboxes file is authoritative,
     that is, only change the mupdate server, do not delete any local
     mailboxes.
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cvt_cyrusdb.rst	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,7 @@ Examples
     ::
 
         Usage: /usr/lib/cyrus/bin/cvt_cyrusdb [-C altconfig] <old db> <old db backend> <new db> <new db backend>
-        Usable Backends:  berkeley, berkeley-nosync, berkeley-hash, berkeley-hash-nosync, flat, skiplist, quotalegacy
+        Usable Backends:  flat, skiplist, quotalegacy
 
 .. parsed-literal::
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyradm.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyradm.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyradm.rst	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyradm.rst	2020-05-04 04:10:42.000000000 +0000
@@ -211,8 +211,8 @@ Example Usage
  
  Note that in the above example, the \ ``unixhierarchysep``\  setting in
  imapd.conf is set to \ ``0``\ . When using the UNIX
- hierarchy seperator, the \ ``/``\  (forward slash) character would be
- used as the hierarchy seperator, and the example would look as
+ hierarchy separator, the \ ``/``\  (forward slash) character would be
+ used as the hierarchy separator, and the example would look as
  follows:
  
 
@@ -318,6 +318,19 @@ Show help for \ ``command``\  or all com
 
 aliases: \ ``?``\ 
 
+.. _imap-reference-manpages-systemcommands-cyradm-getmetadata:
+
+
+getmetadata
+===========
+
+
+\ **getmetadata**\  [\ *mailbox*\ ]
+
+Display mailbox/server metadata
+
+aliases: \ ``getmd``\ 
+
 .. _imap-reference-manpages-systemcommands-cyradm-info:
 
 
@@ -327,7 +340,7 @@ info
 
 \ **info**\  [\ *mailbox*\ ]
 
-Display the mailbox/server metadata.
+Display the mailbox/server annotations.
 
 .. _imap-reference-manpages-systemcommands-cyradm-listaclmailbox:
 
@@ -648,6 +661,46 @@ The currently supported attributes are:
  
 
 
+.. _imap-reference-manpages-systemcommands-cyradm-setmetadata:
+
+
+setmetadata
+===========
+
+
+\ **setmetadata**\  [--private] mailbox [\ *annotation*\ ] \ *value*\ 
+
+Set metadata on mailbox, where \ *annotation*\  is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/<explicit annotation>].
+
+Note that \ *value*\  with a leading backslash must be escaped with an
+additional backslash.  For example:
+
+
+
+.. code-block:: perl
+
+   setmetadata --private Spam specialuse "\\Junk"
+
+
+Note, too, that "private" annotations are private to the user currently
+authenticated as, not necessarily the owner of the mailbox.  To set
+annotations for another user you must authorize as that user.
+
+In addition to the use of optional flag \ **--private**\ , one may use a more
+explicit syntax, prefixing the annotation with '/shared/' or '/private/'
+as in this example:
+
+
+
+.. code-block:: perl
+
+   setmetadata Spam /private/specialuse "\\Junk"
+
+
+aliases: \ ``setmd``\ 
+
 .. _imap-reference-manpages-systemcommands-cyradm-setquota:
 
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_dbtool.rst	2020-04-08 00:07:13.000000000 +0000
@@ -97,7 +97,8 @@ is typically a Cyrus "flat" format datab
 database version number (currently 2), a list of "wildmat" patterns
 specifying Cyrus services to be denied, and a text message to be
 displayed to the user upon denial. The service names to be matched are
-those as used in :cyrusman:`cyrus.conf(5)`.
+those as used in :cyrusman:`cyrus.conf(5)`.  :cyrusman:`cyr_deny(8)`
+provides more convenient way to manage *user_deny.db*.
 
 .. Note::
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_deny.rst	2020-04-08 00:07:13.000000000 +0000
@@ -26,7 +26,8 @@ Description
 The first synopsis denies user *user* access to Cyrus services, the
 second synopsis allows access again.  **cyr_deny** works by adding an
 entry to the Cyrus ``user_deny.db`` database; the third synopsis lists
-the entries in the database.
+the entries in the database.  The service names to be matched are those
+as used in :cyrusman:`cyrus.conf(5)`.
 
 **cyr_deny** |default-conf-text|
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_expire.rst	2020-04-24 02:03:00.000000000 +0000
@@ -31,13 +31,20 @@ on Cyrus databases, specifically:
 - expire entries from the duplicate delivery database, and
 - cleanse mailboxes of partially expunged messages (when using the "delayed" expunge mode), and
 - remove deleted mailboxes (when using the "delayed" delete mode), and
-- expire entries from conversations databases.
+- expire entries from conversations databases, and
+- archive messages from mailbox.
 
-The expiration of messages is controlled by the
-``/vendor/cmu/cyrus-imapd/expire`` mailbox annotation which specifies
-the age (in days) of messages in the given mailbox that should be
-deleted.  A value of 0 means that no expiration is to be performed on
-that mailbox.
+There are various annotations that **cyr_expire** respects:
+
+- ``/vendor/cmu/cyrus-imapd/expire`` which controls the expirations of
+  messages
+- ``/vendor/cmu/cyrus-imapd/archive`` which controls the archival of
+  messages
+- ``/vendor/cmu/cyrus-imapd/delete`` which controls the deletion of
+  messages
+
+These mailbox annotations specify the age(in days) of messages in the
+given mailbox that should be expired/archived/deleted.
 
 The value of the ``/vendor/cmu/cyrus-imapd/expire`` annotation is
 inherited by all children of the mailbox on which it is set, so an
@@ -52,7 +59,8 @@ The annotation can be examined using the
 
 Expiration of duplicate delivery database entries for a given mailbox
 is also controlled by the ``/vendor/cmu/cyrus-imapd/expire`` annotation
-which applies to that mailbox.  Unlike message expiration, if no
+which applies to that mailbox.  A value of 0 on the annotation means
+that no expiration is to be performed on that mailbox. Unlike message expiration, if no
 annotation applies to the mailbox then duplicate database entries are
 expired using the value given to the **-E** option.
 
@@ -82,6 +90,8 @@ Options
     archive partition, allowing mailbox messages to be split between fast
     storage and slow large storage.  Only does anything if
     ``archivepartition-*`` has been set in your config.
+    This value is only used for entries which do not have a
+    corresponding ``/vendonr/cmu/cyrus-imapd/archive`` mailbox annotation.
 
     |v3-new-feature|
 
@@ -93,6 +103,8 @@ Options
     specify the unit of time.  If no suffix, the value is number of days.
     Valid suffixes are **d** (days), **h** (hours), **m** (minutes) and
     **s** (seconds).
+    This value is only used for entries which do not have a
+    corresponding ``/verdor/cmu/cyrus-imapd/delete`` mailbox annotation.
 
 .. option:: -E expire-duration
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_info.rst	2020-04-24 02:03:00.000000000 +0000
@@ -35,17 +35,27 @@ configuring Cyrus easier.
 
 .. option:: conf
 
-    Print only the configuration options which are not the same as
-    default (regardless of whether you have specified them or not).
+    Print the configuration options which have been set to a value
+    other than their default, and their value.
 
-.. option:: conf-default
-
-    Print all default configuration options, ignoring those set locally.
+    With **-s version**, configuration options whose behaviour has
+    changed since *version* will be highlighted.
 
 .. option:: conf-all
 
-    Print ALL configuration options - including default options.  This
-    command shows which options will be in effect at runtime.
+    Print ALL configuration options and their configured values (including
+    those using their default value).  This command shows which options
+    will be in effect at runtime.
+
+    With **-s version**, configuration options which have been added or
+    whose behaviour has changed since *version* will be highlighted.
+
+.. option:: conf-default
+
+    Print the default values for all available configuration options.
+
+    With **-s version**, configuration options which have been added or
+    whose behaviour has changed since *version* will be highlighted.
 
 .. option:: conf-lint
 
@@ -75,6 +85,15 @@ Options
 
     Read the configuration as if for the service named *name*.
 
+.. option:: -s version
+
+    Highlight configuration options that have been added or whose behaviour
+    has been modified since *version*.  Use this option after a server upgrade,
+    specifying your previous version, to find which options you need to review
+    and maybe change before starting up the upgraded server.
+
+    For use with the **conf**, **conf-all**, and **conf-default** sub-commands.
+
 Examples
 ========
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/cyr_virusscan.rst	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,7 @@
 .. cyrusman:: cyr_virusscan(8)
 
+.. highlight:: none
+
 .. author: Nic Bernstein (Onlight)
 
 .. _imap-reference-manpages-systemcommands-cyr_virusscan:
@@ -35,9 +37,10 @@ A table of infected messages will be out
 To remove infected messages, use the **-r** flag. Infected messages will be expunged
 from the user's mailbox.
 
-With the notify flag, **-n**, notifications will be appended to the inbox of the mailbox owner,
-containing message digest information for the affected mail.  This
-flag is only works in combination with **-r**.
+With the notify flag, **-n**, notifications will be appended to the inbox of
+the mailbox owner, containing message digest information for the affected mail.
+This flag only works in combination with **-r**.  The notification message
+can by customised by template, for details see `Notifications`_ below.
 
 **cyr_virusscan** can be configured to run periodically by cron(8)
 via crontab(5) or your preferred method (i.e. /etc/cron.hourly), or by
@@ -77,6 +80,44 @@ Options
 
     Produce more verbose output
 
+Notifications
+=============
+
+When the **-n** flag is provided, notifications are sent to mailbox owners
+when infected messages are removed.  One notification is sent per owner,
+containing a digest of each message that was deleted from any of their
+mailboxes.
+
+The default notification subject is "Automatically deleted mail", which
+can be overridden by setting ``virusscan_notification_subject`` in
+:cyrusman:`imapd.conf(5)` to a UTF-8 value.
+
+Each infected message will be described according to the following template::
+
+	The following message was deleted from mailbox '%MAILBOX%'
+	because it was infected with virus '%VIRUS%'
+
+	    Message-ID: %MSG_ID%
+	    Date: %MSG_DATE%
+	    From: %MSG_FROM%
+	    Subject: %MSG_SUBJECT%
+	    IMAP UID: %MSG_UID%
+
+To use a custom template, create a UTF-8 file containing your desired text
+and using the same %-delimited substitutions as above, and set the
+``virusscan_notification_template`` option in :cyrusman:`imapd.conf(5)` to
+its path.
+
+The notification message will be properly MIME-encoded at delivery. Do not
+pre-encode the template file or the subject!
+
+When **cyr_virusscan** starts up, if notifications have been requested (with
+the **-n** flag), a basic sanity check of the template will be performed
+prior to initialising the antivirus engine.  If it appears that the
+resultant notifications would be undeliverable for some reason,
+**cyr_virusscan** will exit immediately with an error, rather than risk
+deleting messages without notifying.
+
 Examples
 ========
 
@@ -114,7 +155,7 @@ Examples
 ..
 
         Scan mailbox *user/bovik*, removing infected messages and append
-        notifications to bovik's inbox.
+        notifications to Bovik's inbox.
 
 .. only:: html
 
@@ -130,12 +171,12 @@ Examples
 
     ::
 
-        The following message was deleted from mailbox 'Inbox.bovik'
+        The following message was deleted from mailbox 'INBOX'
         because it was infected with virus 'Email.Trojan.Trojan-1051'
 
             Message-ID: <201308131519.r7DFJM9K083763@tselina.kiev.ua>
             Date: Tue, 13 Aug 2013 18:19:22 +0300 (EEST)
-            From: ("FEDEX Thomas Cooper" NIL "thomas_cooper94" "themovieposterpage.com")
+            From: "FEDEX Thomas Cooper" <thomas_cooper94@themovieposterpage.com>
             Subject: Problem with the delivery of parcel
             IMAP UID: 17426
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/imapd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/imapd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/imapd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/imapd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,109 +10,4 @@
 
 IMAP server process
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **imapd** [ **-C** *config-file* ] [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ]
-        [ **-s** ] [ **-N** ] [ **-p** *ssf* ]
-
-Description
-===========
-
-**imapd** is an IMAP4rev1 server.  It accepts commands on its standard
-input and responds on its standard output.  It MUST be invoked by
-:cyrusman:`master(8)` with those descriptors attached to a remote client
-connection.
-
-**imapd** |default-conf-text|
-
-If the file ``msg/shutdown`` is created under the directory specified in
-the ``configdirectory`` configuration option, then **imapd** will shut
-down the connection, sending the first line contained in the file to the
-client as the reason.  New connections are denied.
-
-If the file ``msg/motd`` is created under the directory specified in the
-``configdirectory`` configuration option, then **imapd** will send the
-first line contained in the file to clients upon connect as an ALERT
-message which IMAP-compliant clients are required to display.
-
-This option serves to annoy users mostly.  Unfortunately clients tend to
-connect far more frequently than is apparent, generating a separate
-server ALERT for each connection.  Many clients do not display these
-properly, if they do anything with them at all.
-
-If the directory ``log``\/*user* exists under the directory specified in
-the ``configdirectory`` configuration option, then **imapd** will create
-protocol telemetry logs for sessions authenticating as *user*.
-
-The telemetry logs will be stored in the ``log``/\ *user* directory with
-a filename of the **imapd** process-id.
-
-Options
-=======
-
-.. program:: imapd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-.. option:: -U  uses
-
-    The maximum number of times that the process should be used for new
-    connections before shutting down.  The default is 250.
-
-.. option:: -T  timeout
-
-    The number of seconds that the process will wait for a new
-    connection before shutting down.  Note that a value of 0 (zero)
-    will disable the timeout.  The default is 60.
-
-.. option:: -D
-
-    Run external debugger specified in debug_command.
-
-.. option:: -s
-
-    Serve IMAP over SSL (imaps).  All data to and from **imapd** is
-    encrypted using the Secure Sockets Layer.
-
-.. option:: -N
-
-    Bypass password checking.  (Not recommended unless you know what
-    you're doing.)
-
-.. option:: -p  ssf
-
-    Tell **imapd** that an external layer exists.  An *SSF* (security
-    strength factor) of 1 means an integrity protection layer exists.
-    Any higher SSF implies some form of privacy protection.
-
-Examples
-========
-
-**imapd** is commonly included in the SERVICES section of
-:cyrusman:`cyrus.conf(5)` like so:
-
-.. parsed-literal::
-    SERVICES {
-        **imap        cmd="imapd -U 30" listen="imap" prefork=0**
-        **imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100**
-        lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
-        sieve       cmd="timsieved" listen="sieve" prefork=0
-        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
-    }
-
-Files
-=====
-
-/etc/imapd.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`master(8)`
+.. include:: /assets/man-imapdproxyd.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ipurge.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ipurge.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ipurge.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ipurge.rst	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
+    **ipurge** [ **-f** ] [ **-C** *config-file* ] [ **-x** ] [ **-M** ] [ **-X** ] [ **-i** ] [ **-s** ] [ **-o** ] [ **-n** ] [ **-v** ]
             [ **-d** *days* | **-b** *bytes* | **-k** *Kbytes* | **-m** *Mbytes* ]
             [ *mailbox-pattern*... ]
 
@@ -34,7 +34,7 @@ of **-d**, **-b**, **-k** or **-m** MUST
 *Ipurge* by default only deletes mail below shared folders, which means
 that mails in mailbox(es) below INBOX.* and user.* stay untouched. Use
 the option **-f** to also delete mail in mailbox(es) below these
-folders.
+folders. Use the **-M** option to not recurse into the mailboxes.
 
 *ipurge* |default-conf-text|
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/lmtpd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,76 +10,4 @@
 
 LMTP server process
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **lmtpd** [ **-C** *config-file* ]  [ **-U** *uses* ] [ **-T** *timeout* ] [ **-D** ] [ **-a** ]
-
-Description
-===========
-
-**lmtpd** is an LMTP server used to deliver mail to the IMAP mailstore.
-It accepts commands on its standard input and responds on its standard
-output. It MUST be invoked by :cyrusman:`master(8)` with those
-descriptors attached to a remote client connection.
-
-**lmtpd** |default-conf-text|
-
-Options
-=======
-
-.. program:: lmtpd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-.. option:: -U  uses
-
-    The maximum number of times that the process should be used for new
-    connections before shutting down.  The default is 250.
-
-.. option:: -T  timeout
-
-    The number of seconds that the process will wait for a new
-    connection before shutting down.  Note that a value of 0 (zero)
-    will disable the timeout.  The default is 60.
-
-.. option:: -D
-
-    Run external debugger specified in debug_command.
-
-.. option:: -a
-
-    Preauthorize connections initiated on an internet socket, instead
-    of requiring LMTP AUTH.  This should only be used for connections
-    coming from trusted hosts.
-
-Examples
-========
-
-**lmtpd** is commonly included in the SERVICES section of
-:cyrusman:`cyrus.conf(5)` like so:
-
-.. parsed-literal::
-    SERVICES {
-        imap        cmd="imapd -U 30" listen="imap" prefork=0
-        imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
-        **lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20**
-        sieve       cmd="timsieved" listen="sieve" prefork=0
-        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
-    }
-
-Files
-=====
-
-/etc/imapd.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`master(8)`
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/lmtpproxyd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -7,3 +7,5 @@
 ==============
 
 This is a hard linked copy of :cyrusman:`lmtpd(8)`, retained for backwards compatibility from when a murder frontend used its own lmtpd binaries.
+
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/master.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/master.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/master.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/master.rst	2020-04-24 02:03:00.000000000 +0000
@@ -25,8 +25,8 @@ Description
 
 **master** is the process that controls all of the Cyrus
 processes. This process is responsible for creating all imapd, pop3d,
-lmtpd and timsieved child processes. This process also initializes the
-Berkeley DB code and performs scheduled cleanup/maintenance.
+lmtpd and sieved child processes. This process also performs scheduled
+cleanup/maintenance.
 
 If this process dies, then no new sessions will be started.
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/mbpath.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/mbpath.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/mbpath.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/mbpath.rst	2020-04-24 02:03:00.000000000 +0000
@@ -15,17 +15,18 @@ Synopsis
 
 .. parsed-literal::
 
-    **mbpath** [ **-C** *config-file* ] [ **-q** ] [ **-s** ] [ **-m** ] [ *mailbox-names*... ]
+    **mbpath** [ **-C** *config-file* ] [ **-l** ] [ **-m** ] [ **-q** ] [ **-s** ] [ **-u** ] [ **-a** | **-A** | **-M** | **-S** | **-U** ] [ *mailbox-names*... ]
 
 Description
 ===========
 
 Given a mailbox name or a space separated list of mailbox names,
-**mbpath** outputs the filesystem path to the mailbox.
-
+**mbpath** outputs the filesystem path(s) of the mailbox.  By default,
+the mailboxes' data partition paths are shown (same as **-D**).
+See `Selectors`_ for selecting which filesystem path(s) to output.
 
 **mbpath** |default-conf-text| It uses <configdirectory>/mailboxes.db
-to locate the mailbox on disk.
+to locate the mailboxes on disk.
 
 Options
 =======
@@ -36,6 +37,15 @@ Options
 
     |cli-dash-c-text|
 
+.. option:: -l
+
+    Local mailboxes only (exits with error for remote or nonexistent mailboxes)
+
+.. option:: -m
+
+    Output the path to the metadata files (if different from the
+    message files).  Legacy, use **-M**.
+
 .. option:: -q
 
     Suppress any error output.
@@ -44,10 +54,36 @@ Options
 
     If any error occurs, stop processing the list of mailboxes and exit.
 
-.. option:: -m
+.. option:: -u
 
-    Output the path to the metadata files (if different from the
-    message files).
+    The specified *mailbox-names* are users, not mailboxes.
+
+Selectors
+=========
+
+.. option:: -A
+
+    Show the mailbox archive path
+
+.. option:: -D
+
+    Show the mailbox data path (*default*)
+
+.. option:: -M
+
+    Show the mailbox metadata path (same as **-m**)
+
+.. option:: -S
+
+    Show the user sieve scripts path
+
+.. option:: -U
+
+    Show the user files path (seen, sub, etc)
+
+.. option:: -a
+
+    Show all paths, as if all selectors were specified
 
 Examples
 ========
@@ -58,7 +94,7 @@ Examples
 
 ..
 
-        Display the path for mailbox *user.jsmith*.
+        Display the data path for mailbox *user.jsmith*.
 
 .. only:: html
 
@@ -68,7 +104,7 @@ Examples
 
 .. parsed-literal::
 
-    **mbpath -m** *user.jsmith*
+    **mbpath -M** *user.jsmith*
 
 ..
 
@@ -80,6 +116,20 @@ Examples
 
         /var/spool/meta/imap/user/jsmith
 
+.. parsed-literal::
+
+    **mbpath -u -S** *jsmith*
+
+..
+
+        Display the sieve scripts path for user *jsmith*.
+
+.. only:: html
+
+    ::
+
+        /var/spool/sieve/j/jsmith
+
 Files
 =====
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/pop3proxyd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,3 +8,5 @@
 
 
 This is a hard linked copy of :cyrusman:`pop3d(8)`, retained for backwards compatibility from when a murder frontend used its own pop3d binaries.
+
+.. include:: /assets/man-lmtpd.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/proxyd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/proxyd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/proxyd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/proxyd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -6,36 +6,6 @@
 **proxyd**
 ==========
 
-In Progress
+Proxyd is a symlink to :cyrusman:`imapd(8)` if you build with murder enabled.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **proxyd** [ **-C** *config-file* ]  
-
-Description
-===========
-
-
-Options
-=======
-
-.. program:: proxyd
-
-.. option:: -C config-file
-
-    |cli-dash-c-text|
-
-
-
-
-/etc/imapd.conf,
-/etc/cyrus.conf
-
-See Also
-========
-
-:cyrusman:`imapd.conf(5)`,
-:cyrusman:`cyrus.conf(5)`
+.. include:: /assets/man-imapdproxyd.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ptloader.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ptloader.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/ptloader.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/ptloader.rst	2020-04-24 02:03:00.000000000 +0000
@@ -22,7 +22,7 @@ Description
 
 **ptloader** interacts with the authorization service, either AFS or
 LDAP, providing group membership information to Cyrus.  When
-``auth_mech: pts`` is set in :cyrusman:`imapd.conf(5)`, **ptsloader**
+``auth_mech: pts`` is set in :cyrusman:`imapd.conf(5)`, **ptloader**
 will then consult the backend specified in the ``pts_module`` setting
 (currently either ``afs`` or ``ldap``).
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/quota.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/quota.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/quota.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/quota.rst	2020-04-24 02:03:00.000000000 +0000
@@ -16,7 +16,7 @@ Synopsis
 
 .. parsed-literal::
 
-    **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ *mailbox-prefix*... ]
+    **quota** [ **-C** *config-file* ] [ **-d** *domain* ] [ **-f** ] [ **-u** ] [ *mailbox-spec*... ]
 
 Description
 ===========
@@ -32,13 +32,16 @@ If an optional *domain* is specified wit
 listing (and any inconsistency fixing) is performed only in that domain
 rather than all mailboxes.
 
-If one or more *mailbox-prefix* arguments are specified, the quota
-listing (and inconsistency fixing) is limited to quota roots with names
-that start with one of the given prefixes.
+If one or more *mailbox-spec* arguments are specified, these are interpreted
+as mailbox prefixes, and the quota listing (and inconsistency fixing) is
+limited to quota roots with names that start with one of the given prefixes.
+If the **-u** is provided, *mailbox-spec* arguments are instead interpreted
+as userids, and the quota listing (and inconsistency fixing) is limited to
+quota roots for only the specified users.
 
 .. WARNING::
 
-    Running **quota** with both the **-f** option and *mailbox-prefix*
+    Running **quota** with both the **-f** option and *mailbox-spec*
     arguments is not recommended.
 
 **quota** |default-conf-text|
@@ -61,6 +64,11 @@ Options
     Fix any inconsistencies in the quota subsystem before generating a
     report.
 
+.. option:: -n
+
+    Check for any inconsistencies in the quota subsystem but don't actually
+    fix them.  Use with **-f** and **-q** to only see what's incorrect.
+
 .. option:: -q
 
     Operate quietly. If **-f** is specified, then don't print the quota
@@ -70,10 +78,15 @@ Options
 
     Output the quota values as JSON for automated tooling support
 
-.. option:: mailbox-prefix
+.. option:: -u
+
+    Interpret *mailbox-spec* arguments as userids.  The default is to
+    interpret them as mailbox prefixes
+
+.. option:: mailbox-spec
 
-    Only report and/or fix quota in mailboxes starting with the
-    specified *mailbox-prefix*.
+    Only report and/or fix quota in mailboxes matching the specified
+    *mailbox-spec* arguments.  See also **-u**.
 
 Examples
 ========
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/reconstruct.rst	2020-04-24 02:03:00.000000000 +0000
@@ -17,7 +17,7 @@ Synopsis
 
     **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
         [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
-        [ **-O** ] [ **-M** ] *mailbox*...
+        [ **-O** ] [ **-M** ] [ **-V** *version* ] *mailbox*...
 
     **reconstruct** [ **-C** *config-file* ] [ **-p** *partition* ] [ **-x** ] [ **-r** ]
         [ **-f** ] [ **-U** ] [ **-s** ] [ **-q** ] [ **-G** ] [ **-R** ] [ **-o** ]
@@ -94,7 +94,7 @@ Options
 
     Don't stat underlying files.  This makes reconstruct run faster, at
     the expense of not noticing some issues (like zero byte files or
-    size mistmatches).  "**reconstruct -s**" should be quite fast.
+    size mismatches).  "**reconstruct -s**" should be quite fast.
 
 .. option:: -q
 
@@ -229,7 +229,7 @@ Examples
 
 ..
 
-        Recusively reconstruct all mailboxes belonging to *jsmith*,
+        Recursively reconstruct all mailboxes belonging to *jsmith*,
         restoring any directories containing ``cyrus.header`` files.
 
 .. only:: html
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/rehash.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/rehash.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/rehash.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/rehash.rst	2020-04-24 02:03:00.000000000 +0000
@@ -50,12 +50,12 @@ Options
     In -n "no change" mode, it will just print the changes.  Note,
     verbose is always turned on in no-change mode.
 
-.. option:: -f | -F
+.. option:: -f \| -F
 
     | -f forces fulldirhash: no
     | -F forces fulldirhash: yes
 
-.. option:: -i
+.. option:: -i \| -I
 
     |  -i forces hashimapspool: no
     |  -I forces hashimapspool: yes
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/smmapd.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/smmapd.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/smmapd.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/smmapd.rst	2020-04-24 02:03:00.000000000 +0000
@@ -55,6 +55,21 @@ Options
 Examples
 ========
 
+**smmapd** is commonly included in the SERVICES section of
+:cyrusman:`cyrus.conf(5)` like so:
+
+.. parsed-literal::
+    SERVICES {
+        imap        cmd="imapd -U 30" listen="imap" prefork=0
+        imaps       cmd="imapd -s -U 30" listen="imaps" prefork=0 maxchild=100
+        lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+        **smmap       cmd="smmapd" listen="/var/run/cyrus/socket/smmap" prefork=0**
+        sieve       cmd="timsieved" listen="sieve" prefork=0
+        notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+        httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+    }
+
+
 Files
 =====
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/squatter.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/squatter.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/squatter.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/squatter.rst	2020-04-24 02:03:00.000000000 +0000
@@ -19,13 +19,12 @@ Synopsis
     **squatter** [ **-C** *config-file* ] [**mode**] [**options**] [**source**]
 
     i.e.:
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  *mailbox*...
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ]  **-u** *user*...
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ]
-    **squatter** [ **-C** *config-file* ] [ **-v** ] **-I** *file*
-    **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ]  [ **-S** *seconds* ] [ **-u** *user*... ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] *mailbox*...
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] [ **-i** ] [ **-N** *name* ] [ **-S** *seconds* ] [ **-r** ] [ **-Z** ] **-u** *user*...
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-R** [ **-n** *channel* ] [ **-d** ] [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] [ **-a** ] **-f** *synclogfile* [ **-S** *seconds* ] [ **-Z** ]
+    **squatter** [ **-C** *config-file* ] [ **-v** ] **-t** *srctier(s)*... **-z** *desttier* [ **-F** ] [ **-U** ] [ **-T** *dir* ] [ **-X** ] [ **-o** ] [ **-S** *seconds* ] [ **-u** *user*... ]
 
 
 
@@ -47,7 +46,7 @@ The index is a unified index of all of t
 of each message in a given mailbox.  This index is used to significantly
 reduce IMAP SEARCH times on a mailbox.
 
-**mode** is one of indexer, indexfrom (-I), search, rolling, synclog or compact.
+**mode** is one of indexer, search, rolling, synclog, compact or audit.
 
 By default, **squatter** creates an index of ALL messages in the
 mailbox, not just those since the last time that it was run.  The
@@ -82,20 +81,27 @@ In the fifth synopsis, **squatter** read
 performs incremental indexing on the mailbox(es) listed therein.  This
 is sometimes useful for cleaning up after problems with rolling mode.
 
-In the sixth synopsis, **squatter** reads *file* containing *mailbox*
-*uid* tuples and performs indexing on the specified messages.
-
-In the seventh synopsis, **squatter** will compact indices from
+In the sixth synopsis, **squatter** will compact indices from
 *srctier(s)* to *desttier*, optionally reindexing (**-X**) or filtering
-expunged records (**-F**) in the process.  The optional **-T** flag may
-be used to specify a directory to use for temporary files.  The **-o**
-flag may be used to direct that a single index be copied, rather than
-compacted, from *srctier* to *desttier*.  The **-u** flag may be used
-to restrict operation to the specified user(s).
+expunged records (**-F**) in the process.  The optional **-T** flag may be
+used to specify a directory to use for temporary files.  These files are
+eventually copied with `rsync -a` and then removed by `rm`.
+`rsync` can increase the load average of the system, especially when the
+temporary directory is on `tmpfs`.  To throttle `rsync` it is possible to
+modify the call in `imap/search_xapian.c` and pass `-\\-bwlimit=<number>` as further
+parameter.  The **-o** flag may be used to direct that a single index be
+copied, rather than compacted, from *srctier* to *desttier*.  The **-u** flag
+may be used to restrict operation to the specified user(s).
 
-For all modes, the **-S** option may be specified, causing squatter to
+For all modes, the **-S** option may be specified, causing **squatter** to
 pause *seconds* seconds after each mailbox, to smooth loads.
 
+When using the Xapian engine the **-Z** option may be specified, for
+the indexing modes.  This tells **squatter** to consult the Xapian
+internally indexed GUIDs, rather than relying on what's stored in
+`cyrus.indexed.db`, allowing for recovery from broken
+`cyrus.indexed.db` at the sacrifice of efficiency.
+
 .. Note::
     Incremental updates are very inefficient with the SQUAT search
     engine.  If using SQUAT for large and active mailboxes, you should
@@ -130,6 +136,11 @@ Options
     inherit one), then the mailbox is not indexed. In other words, the
     implicit value of */vendor/cmu/cyrus-imapd/squat* is "false".
 
+.. option:: -A
+
+    Missing documentation, starts audit mode.
+    |master-new-feature|
+
 .. option:: -d
 
     In rolling mode, don't background and do emit log messages on
@@ -153,11 +164,6 @@ Options
 
     Display this usage information.
 
-.. option:: -I file
-
-    Read from *file* and index individual messages described by
-    mailbox/uid tuples contained therein.
-
 .. option:: -i
 
     Incremental updates where indexes already exist.
@@ -181,6 +187,11 @@ Options
     it to the destination rather than compacting.
     |v3-new-feature|
 
+.. option:: -P
+
+    Missing documentation, reindex parts mode.
+    |master-new-feature|
+
 .. option:: -R
 
     Run in rolling mode; **squatter** runs as a daemon listening to a
@@ -211,7 +222,7 @@ Options
 
 .. option:: -t srctier...
 
-    In compact mode, the comma separated source tier(s) for the compacted
+    In compact mode, the comma-separated source tier(s) for the compacted
     indices.  At least one source tier must be specified in compact mode.
     Xapian only.
     |v3-new-feature|
@@ -222,6 +233,12 @@ Options
     mailbox names.  Usernames are space-separated.
     |v3-new-feature|
 
+.. option:: -U
+
+    In compact mode, only compact if re-indexing.
+    Xapian only.
+    |master-new-feature|
+
 .. option:: -v
 
     Increase the verbosity of progress/status messages.  Sometimes additional messages
@@ -244,6 +261,15 @@ Options
     Xapian only.
     |v3-new-feature|
 
+.. option:: -Z
+
+    When indexing messages, use the Xapian internal cyrusid rather than
+    referencing the ranges of already indexed messages to know if a
+    particular message is indexed.  Useful if the ranges get out of
+    sync with the actual messages (e.g. if files on a tier are lost)
+    Xapian only.
+    |master-new-feature|
+
 Examples
 ========
 
@@ -339,3 +365,7 @@ See Also
 ========
 
 :cyrusman:`imapd.conf(5)`, :cyrusman:`cyrus.conf(5)`
+
+.. only:: html
+
+    :ref:`configuring-xapian`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/systemcommands/sync_reset.rst	2020-04-24 02:03:00.000000000 +0000
@@ -23,7 +23,7 @@ Description
 ===========
 
 **sync_reset** is a small utility program to destroy user accounts on a
-system.  The only safeguard which is in place is the obligary force
+system.  The only safeguard which is in place is the obligatory force
 option.
 
 **sync_reset** |default-conf-text|
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/httptest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/httptest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/httptest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/httptest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,121 +8,10 @@
 
 Interactive HTTP test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **httptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-**httptest** is a utility that allows you to authenticate to a
-HTTP server and interactively issue requests to it. Once
-authenticated you may issue any HTTP request by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an http server. Also those developing HTTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: httptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **http** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **httptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify one of *Basic*, *Digest*, *NTLM*, or
-    *Negotiate* (GSS-SPNEGO).
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable HTTP over SSL (https).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send HTTP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`httpd(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/imtest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/imtest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/imtest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/imtest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,148 +8,6 @@
 **imtest**
 ==========
 
-Interactive IMAP test program
+Interactive IMAP test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **imtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
-        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
-        [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-s** ] [ **-q** ]
-        [ **-c** ] [ **-i** ] [ **-z** ] [ **-v** ] [ **-I** *file* ] [ **-x** *file* ]
-        [ **-X** *file* ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**imtest** is a utility that allows you to authenticate to a IMAP or
-IMSP server and interactively issue commands to it. Once authenticated
-you may issue any IMAP or IMSP command by simply typing it in. It is
-capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of a imsp or imap server. Also those developing IMAP
-clients find it useful.
-
-Options
-=======
-
-.. program:: imtest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **imap** as defined
-    in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **imtest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented to
-    the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable IMAP over SSL (imaps).
-
-.. option:: -q
-
-    Enable IMAP COMPRESSion (after authentication).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP mechanism
-    to ask for the the one-time password instead of the secret pass-phrase
-    (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -I  file
-
-    Echo the PID of the running process into *file* (This can be useful
-    with -X).
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -z
-
-    Timing test.
-
-.. option:: -x  file
-
-    Open the named socket for the interactive portion.
-
-.. option:: -X  file
-
-    Like -x, only close all file descriptors & daemonize the process.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
-
-:cyrusman:`imapd(8)`
+.. include:: /assets/man-imtest.rst
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/installsieve.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/installsieve.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/installsieve.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/installsieve.rst	2020-04-24 02:03:00.000000000 +0000
@@ -52,9 +52,7 @@ Options
 
     Install a file onto the server. If a script with the same name
     already exists on the server it is overwritten. Upon successfully
-    putting the script on the server the script is set active. If
-    *file* has the extension .script it is chopped when put on the
-    server since sieve names may not contain a '.'.
+    putting the script on the server the script is set active.
 
 .. option:: -a  name
 
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/lmtptest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/lmtptest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/lmtptest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/lmtptest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,122 +10,10 @@
 
 Interactive LMTP test program
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **lmtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ]
-        [ **-a** *userid* ] [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ]
-        [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ] [ **-c** ] [ **-i** ]
-        [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard link to :cyrusman:`imtest(1)`.
 
-**lmtptest** is a utility that allows you to authenticate to a LMTP server
-and interactively issue commands to it. Once authenticated you may
-issue any LMTP command by simply typing it in. It is capable
-of multiple SASL authentication mechanisms and handles encryption
-layers transparently. This utility is often used for testing the
-operation of a lmtp server. Also those developing LMTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: lmtptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **lmtp** as defined
-    in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **lmtptest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented to
-    the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP mechanism
-    to ask for the the one-time password instead of the secret pass-phrase
-    (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send LMTP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`lmtpd(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/mupdatetest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,117 +10,10 @@
 
 Interactive MUPDATE test program
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send MUPDATE commands to the server.
 
-    **mupdatetest** [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ] [ **-u** *userid* ]
-        [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ] [ **-n** *num* ]
-        [ **-q** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**mupdatetest** is a utility that allows you to authenticate to a
-MUPDATE server and interactively issue commands to it. Once
-authenticated you may issue any MUPDATE command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of a mupdate server. Note that you must be an admin in
-order to authenticate to an mupdate server.
-
-Options
-=======
-
-.. program:: mupdatetest
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **mupdate** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **mupdatetest** to use *mechanism* for authentication. If not
-    specified the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -q
-
-    Enable MUPDATE COMPRESSion (after authentication).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`mupdate(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/nntptest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/nntptest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/nntptest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/nntptest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,130 +8,10 @@
 **nntptest**
 ============
 
-Interactive NNTP test program
+Interactive NNTP test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
-
-    **nntptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-q** ]
-        [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**nntptest** is a utility that allows you to authenticate to a
-NNTP server and interactively issue commands to it. Once
-authenticated you may issue any NNTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an nntp server. Also those developing NNTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: nntptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **nntp** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **nntptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *user* to use the AUTHINFO USER/PASS
-    commands instead of AUTHINFO SASL.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable NNTP over SSL (nntps).
-
-.. option:: -q
-
-    Enable NNTP COMPRESSion (after authentication)
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+It allows you to authenticate and send NNTP commands to the server.
 
 :cyrusman:`nntpd(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/pop3test.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/pop3test.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/pop3test.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/pop3test.rst	2020-04-24 02:03:00.000000000 +0000
@@ -10,125 +10,10 @@
 
 Interactive POP3 test program.
 
-Synopsis
-========
-
-.. parsed-literal::
-
-    **pop3test** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
 This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-**pop3test** is a utility that allows you to authenticate to a
-POP3 server and interactively issue commands to it. Once
-authenticated you may issue any POP3 command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an pop3 server. Also those developing POP3 clients
-find it useful.
-
-Options
-=======
-
-.. program:: pop3test
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **pop3** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **pop3test** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *user* to use the USER/PASS commands
-    or *apop* to use the APOP command instead of AUTH.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable POP3 over SSL (pop3s).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
+It allows you to authenticate and send POP commands to the server.
 
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`pop3d(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/sieveshell.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/sieveshell.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/sieveshell.rst	2019-12-16 04:16:12.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/sieveshell.rst	2020-05-04 04:10:42.000000000 +0000
@@ -63,14 +63,15 @@ OPTIONS
 
 \ **-u**\  \ *user*\ , \ **--user**\ =\ *user*\ 
  
- The authorization name to request; by default, derived from the
- authentication credentials.
+ The user whose mailboxes you want to work on. If not specified, it uses the same
+ as -a.
  
 
 
 \ **-a**\  \ *authname*\ , \ **--authname**\ =\ *authname*\ 
  
- The user to use for authentication (defaults to current user).
+ The user to use for authentication. If not specified, it defaults to the
+ current login user.
  
 
 
@@ -94,8 +95,7 @@ REFERENCES
 
 
 [MANAGESIEVE] Martin, T.; "A Protocol for Remotely Managing Sieve
-Scripts", draft-ietf-managesieve-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.
+Scripts", RFC 5804; May 2001
 
 
 ******
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/sivtest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/sivtest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/sivtest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/sivtest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -9,121 +9,12 @@
 **sivtest**
 ===========
 
-Interactive MANAGESIEVE test program
+Interactive MANAGESIEVE test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send MANAGESIEVE commands to the server.
 
-    **sivtest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**sivtest** is a utility that allows you to authenticate to a
-MANAGESIEVE server and interactively issue commands to it. Once
-authenticated you may issue any MANAGESIEVE command by simply typing it
-in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used for
-testing the operation of a :cyrusman:`timsieved(8)` server. Also those
-developing MANAGESIEVE clients find it useful.
-
-Options
-=======
-
-.. program:: sivtest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **sieve** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **sivtest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :cyrusman:`timsieved(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/smtptest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/smtptest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/smtptest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/smtptest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -8,125 +8,12 @@
 **smtptest**
 ============
 
-Interactive SMTP test program
+Interactive SMTP test program.
 
-Synopsis
-========
+This is actually installed as a hard linked copy of :cyrusman:`imtest(1)`.
 
-.. parsed-literal::
+It allows you to authenticate and send SMTP commands to the server.
 
-    **smtptest** [ **-t** *keyfile* ] [ **-p** *port* ] [ **-m** *mechanism* ] [ **-a** *userid* ]
-        [ **-u** *userid* ] [ **-k** *num* ] [ **-l** *num* ] [ **-r** *realm* ] [ **-f** *file* ]
-        [ **-n** *num* ] [ **-s** ] [ **-c** ] [ **-i** ] [ **-v** ] [ **-w** *passwd* ] [ **-o** *option*\ =\ *value* ] *hostname*
-
-Description
-===========
-
-**smtptest** is a utility that allows you to authenticate to an
-SMTP server and interactively issue commands to it. Once
-authenticated you may issue any SMTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an SMTP server. Also those developing SMTP clients
-find it useful.
-
-Options
-=======
-
-.. program:: smtptest
-
-.. option:: -t  keyfile
-
-    Enable TLS.  *keyfile* contains the TLS public and private keys.
-    Specify **""** to negotiate a TLS encryption layer but not use TLS
-    authentication.
-
-.. option:: -p  port
-
-    Port to connect to. If left off this defaults to **smtp** as
-    defined in ``/etc/services``.
-
-.. option:: -m  mechanism
-
-    Force **smtptest** to use *mechanism* for authentication. If not
-    specified, the strongest authentication mechanism supported by the
-    server is chosen.  Specify *login* to use the LOGIN command instead
-    of AUTHENTICATE.
-
-.. option:: -a  userid
-
-    Userid to use for authentication; defaults to the current user.
-    This is the userid whose password or credentials will be presented
-    to the server for verification.
-
-.. option:: -u  userid
-
-    Userid to use for authorization; defaults to the current user.
-    This is the userid whose identity will be assumed after
-    authentication.
-
-    .. Note::
-        This is only used with SASL mechanisms that allow proxying
-        (e.g. PLAIN, DIGEST-MD5).
-
-.. option:: -k  num
-
-    Minimum protection layer required.
-
-.. option:: -l  num
-
-    Maximum protection layer to use (**0**\ =none; **1**\ =integrity;
-    etc).  For example if you are using the KERBEROS_V4 authentication
-    mechanism specifying **0** will force imtest to not use any layer
-    and specifying **1** will force it to use the integrity layer.  By
-    default the maximum supported protection layer will be used.
-
-.. option:: -r  realm
-
-    Specify the *realm* to use. Certain authentication mechanisms
-    (e.g. DIGEST-MD5) may require one to specify the realm.
-
-.. option:: -f  file
-
-    Pipe *file* into connection after authentication.
-
-.. option:: -n  num
-
-    Number of authentication attempts; default = 1.  The client will
-    attempt to do SSL/TLS session reuse and/or fast reauth
-    (e.g. DIGEST-MD5), if possible.
-
-.. option:: -s
-
-    Enable SMTP over SSL (smtps).
-
-.. option:: -c
-
-    Enable challenge prompt callbacks.  This will cause the OTP
-    mechanism to ask for the the one-time password instead of the
-    secret pass-phrase (library generates the correct response).
-
-.. option:: -i
-
-    Don't send an initial client response for SASL mechanisms, even if
-    the protocol supports it.
-
-.. option:: -v
-
-    Verbose. Print out more information than usual.
-
-.. option:: -w passwd
-
-    Password to use (if not supplied, we will prompt).
-
-.. option:: -o  option=value
-
-    Set the SASL *option* to *value*.
-
-Examples
-========
-
-See Also
-========
+.. include:: /assets/man-imtest.rst
 
 :manpage:`sendmail(8)`
diff -pruN 3.0.13-5/docsrc/imap/reference/manpages/usercommands/synctest.rst 3.2.0-3/docsrc/imap/reference/manpages/usercommands/synctest.rst
--- 3.0.13-5/docsrc/imap/reference/manpages/usercommands/synctest.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/reference/manpages/usercommands/synctest.rst	2020-04-24 02:03:00.000000000 +0000
@@ -7,3 +7,5 @@
 ============
 
 Interactive IMAP test program: tests the replication protocol. This is installed as a hard link to :cyrusman:`imtest(1)`.
+
+.. include:: /assets/man-imtest.rst
diff -pruN 3.0.13-5/docsrc/imap/rfc-support.rst 3.2.0-3/docsrc/imap/rfc-support.rst
--- 3.0.13-5/docsrc/imap/rfc-support.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/rfc-support.rst	2020-05-04 03:28:02.000000000 +0000
@@ -54,6 +54,10 @@ The following is an inventory of RFCs su
 
     DEFLATE Compressed Data Format Specification version 1.3
 
+:rfc:`1952`
+
+    GZIP file format specification version 4.3
+
 :rfc:`2033`
 
     Local Mail Transfer Protocol
@@ -149,7 +153,8 @@ The following is an inventory of RFCs su
 
 :rfc:`2617`
 
-    HTTP Authentication: Basic and Digest Access Authentication
+    HTTP Authentication: Basic and Digest Access Authentication,
+    updated by :rfc:`7615`, :rfc:`7616`, :rfc:`7617`.
 
 :rfc:`2817`
 
@@ -388,6 +393,10 @@ The following is an inventory of RFCs su
 
     Sieve Email Filtering: Body Extension
 
+:rfc:`5183`
+
+    Sieve Email Filtering: Environment Extension
+
 :rfc:`5228`
 
     Sieve: A Mail Filtering Language
@@ -432,6 +441,10 @@ The following is an inventory of RFCs su
 
     .. versionadded:: 2.5.0
 
+:rfc:`5293`
+
+    Sieve Email Filtering: Editheader Extension
+
 :rfc:`5321`
 
     Simple Mail Transfer Protocol
@@ -452,10 +465,6 @@ The following is an inventory of RFCs su
 
     Sieve Email Filtering: Reject and Extended Reject Extensions
 
-    .. NOTE::
-
-        Only the ``reject`` action is currently implemented.
-
 :rfc:`5435`
 
     Sieve Email Filtering: Extension for Notifications
@@ -464,13 +473,18 @@ The following is an inventory of RFCs su
 
     Sieve Notification Mechanism: mailto
 
+:rfc:`5463`
+
+    Sieve Email Filtering: Ihave Extension
+
 :rfc:`5464`
 
     The IMAP METADATA Extension
 
-:rfc:`5465`
+:rfc:`5490`
 
-    The IMAP NOTIFY Extension
+    The Sieve Mail-Filtering Language -- Extensions for Checking Mailbox
+    Status and Accessing Mailbox Metadata
 
 :rfc:`5524`
 
@@ -529,7 +543,7 @@ The following is an inventory of RFCs su
 
     .. NOTE::
 
-        SSLv3 is considered insecure as it is vulnerable to POODLE.
+        SSLv3 is considered inscure as it is vulnerable to POODLE.
 
         Support for SSLv3 is being deprecated and removed.
 
@@ -537,18 +551,14 @@ The following is an inventory of RFCs su
 
     Sieve Vacation Extension: "Seconds" Parameter
 
-:rfc:`5463`
-
-    Sieve Email Filtering: Ihave Extension
-
 :rfc:`6154`
 
     IMAP LIST Extension for Special-Use Mailboxes
 
     .. NOTE::
 
-        The LIST and LSUB commands don't return by default the special-use flags,
-        unless ``specialusealways`` is turned explicitly on.
+        The LIST and LSUB commands return the special-use flags, unless the
+	``specialusealways`` configuration variable is explicitly turned off.
 
 :rfc:`6321`
 
@@ -641,7 +651,33 @@ The following is an inventory of RFCs su
 
 :rfc:`7529`
 
-    Non-Gregorian Recurrence Rules in the Internet Calendaring and Scheduling Core Object Specification (iCalendar) (obsoletes draft-ietf-calext-rscale)
+    Non-Gregorian Recurrence Rules in the Internet Calendaring and
+    Scheduling Core Object Specification (iCalendar)
+
+:rfc:`7540`
+
+      Hypertext Transfer Protocol Version 2 (HTTP/2)
+
+:rfc:`7615`
+
+    HTTP Authentication-Info and Proxy-Authentication-Info Response
+    Header Fields
+
+:rfc:`7616`
+
+    HTTP Digest Access Authentication
+
+:rfc:`7617`
+
+    The 'Basic' HTTP Authentication Scheme
+
+:rfc:`7694`
+
+    Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding
+
+:rfc:`7804`
+
+    Salted Challenge Response HTTP Authentication Mechanism
 
 :rfc:`7808`
 
@@ -651,10 +687,20 @@ The following is an inventory of RFCs su
 
     CalDAV: Time Zones by Reference
 
+:rfc:`7932`
+
+    Brotli Compressed Data Format
+
 :rfc:`7953`
 
     Calendar Availability
 
+:rfc:`8144`
+
+    Use of the Prefer Header Field in Web Distributed Authoring and
+    Versioning (WebDAV)
+
+
 IETF RFC Drafts
 ===============
 
@@ -684,29 +730,6 @@ draft-thomson-hybi-http-timeout
 
     Hypertext Transfer Protocol (HTTP) Keep-Alive Header
 
-draft-murchison-webdav-prefer
-
-    Use of the Prefer Header Field in Web Distributed Authoring and
-    Versioning (WebDAV)
-
-
-draft-ietf-httpauth-basicauth-update
-
-    The 'Basic' HTTP Authentication Scheme
-
-draft-ietf-httpauth-digest
-
-    HTTP Digest Access Authentication
-
-draft-ietf-httpbis-auth-info
-
-    The Hypertext Transfer Protocol (HTTP) Authentication-Info and
-    Proxy- Authentication-Info Response Header Fields
-
-draft-ietf-httpbis-cice
-
-    Hypertext Transfer Protocol (HTTP) Client-Initiated Content-Encoding
-
 ..
 
     caldav-ctag     Calendar Collection Entity Tag (CTag) in CalDAV
@@ -715,32 +738,15 @@ draft-ietf-httpbis-cice
 RFC Wishlist
 ============
 
-:rfc:`5183`
-
-    Sieve Email Filtering: Environment Extension
-
 :rfc:`5235`
 
     Sieve Email Filtering: Spamtest and Virustest Extensions
 
-:rfc:`5293`
-
-    Sieve Email Filtering: Editheader Extension
-
-:rfc:`5429`
-
-    Sieve Email Filtering: Reject and Extended Reject Extensions
-
 :rfc:`5437`
 
     Sieve Notification Mechanism: Extensible Messaging and Presence
     Protocol (XMPP)
 
-:rfc:`5490`
-
-    The Sieve Mail-Filtering Language -- Extensions for Checking Mailbox
-    Status and Accessing Mailbox Metadata
-
 :rfc:`5703`
 
     Sieve Email Filtering: MIME Part Tests, Iteration, Extraction,
diff -pruN 3.0.13-5/docsrc/imap/support/feedback-mailing-lists.rst 3.2.0-3/docsrc/imap/support/feedback-mailing-lists.rst
--- 3.0.13-5/docsrc/imap/support/feedback-mailing-lists.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/imap/support/feedback-mailing-lists.rst	2020-04-08 00:07:13.000000000 +0000
@@ -35,13 +35,13 @@ Archives
 The list archives can be accessed as follows:
 
 * **cyrus-announce**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-announce>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-announce>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-announce/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-announce/>`__
 * **info-cyrus**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.info-cyrus>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.info-cyrus>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/info-cyrus/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/info-cyrus/>`__
 * **cyrus-sasl**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-sasl>`__: `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-sasl>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-sasl/>`__
 * **cyrus-devel**
-    `Anonymous IMAP <imap://cyrus.andrew.cmu.edu/archive.cyrus-devel>`__ : `Web/HTTP <http://asg.web.cmu.edu/bb/archive.cyrus-devel>`__ or `Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
+    `Web/HTTP via Pipermail <http://lists.andrew.cmu.edu/pipermail/cyrus-devel/>`__
 
 Subscribe/Unsubscribe
 ---------------------
diff -pruN 3.0.13-5/docsrc/index.rst 3.2.0-3/docsrc/index.rst
--- 3.0.13-5/docsrc/index.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/index.rst	2020-05-04 03:28:02.000000000 +0000
@@ -1,5 +1,6 @@
 .. _imap-index:
 
+===================
 What is Cyrus IMAP?
 ===================
 
@@ -25,6 +26,7 @@ Features
 * Supports antivirus and antispam toolkits
 * Handles deliverability: SPF, DKIM, DMARC
 * Extensive authentication options, through Cyrus SASL
+* JMAP support
 * Long list of supported standards
 
 Read more in our full :ref:`list of features <imap-features>`.
@@ -50,6 +52,7 @@ Need help? We have :ref:`active mailing
 
 --------
 
+===================
 What is Cyrus SASL?
 ===================
 Simple Authentication and Security Layer (SASL_) is a specification that describes how authentication mechanisms can be plugged into an application protocol on the wire. Cyrus SASL is an implementation of SASL that makes it easy for application developers to integrate authentication mechanisms into their application in a generic way.
diff -pruN 3.0.13-5/docsrc/operations.rst 3.2.0-3/docsrc/operations.rst
--- 3.0.13-5/docsrc/operations.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/operations.rst	2020-04-24 02:03:00.000000000 +0000
@@ -7,13 +7,5 @@ Operations
     :maxdepth: 2
 
     imap/reference/manpages/commands
-    imap/reference/administration-tools
     imap/reference/admin
     imap/reference/faq
-
-..
-
-    manpages
-    adminref
-    sop
-    othertasks
diff -pruN 3.0.13-5/docsrc/overview/cyrus_roadmap.rst 3.2.0-3/docsrc/overview/cyrus_roadmap.rst
--- 3.0.13-5/docsrc/overview/cyrus_roadmap.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/overview/cyrus_roadmap.rst	2020-04-24 02:03:00.000000000 +0000
@@ -14,17 +14,17 @@ High Level Roadmap
 Future
 ------
 
-* JMAP support
+* JMAP support (Contacts, calendars and emails)
+* Improved CalDAV and CardDAV support
 * Improved backup support
 * Multi-master replication
 
 3.0.x
 -----
 
-* Better calendaring support through jmap
 * Cross-folder conversations
 * Support for fuzzy Xapian search.
-* CardDAV support
+* CalDAV and CardDAV support
 * Better backup support - initial release
 * Basic object storage
 * Archive partition support
diff -pruN 3.0.13-5/docsrc/overview.rst 3.2.0-3/docsrc/overview.rst
--- 3.0.13-5/docsrc/overview.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/overview.rst	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,6 @@ Overview
 
 .. toctree::
     :maxdepth: 2
-    :glob:
 
     imap/concepts/features
     imap/concepts/overview_and_concepts
diff -pruN 3.0.13-5/docsrc/quickstart.rst 3.2.0-3/docsrc/quickstart.rst
--- 3.0.13-5/docsrc/quickstart.rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/docsrc/quickstart.rst	2020-05-04 04:02:14.000000000 +0000
@@ -1,5 +1,3 @@
-:orphan:
-
 ================
 Quickstart Guide
 ================
@@ -9,12 +7,8 @@ Quickstart Guide
 
     imap/quickstart/introduction
 
-Coming Soon
-===========
-
-.. note::
-
-    The deb packages referenced below are not yet available.  Sorry!
+.. Coming Soon
+.. -----------
 
 Quick install
 =============
@@ -22,62 +16,35 @@ Quick install
 A quick guide to getting a basic installation of Cyrus up and running in 5 minutes.
 
 The first place to start with a new installation of Cyrus IMAP is with
-your OS distribution of choice and their packaging, where available.  If
-there is no Cyrus IMAP 3.0 package available yet from your distro,
-download the `latest stable package`_ : version |imap_current_stable_version|.
+your OS distribution of choice and their packaging, where available.
 
-.. _latest stable package: ftp://ftp.cyrusimap.org/cyrus-imapd/debs/
+If there is no Cyrus IMAP |imap_current_stable_version| package available yet
+from your distro, download the official source tarball from GitHub_.  The
+:ref:`compiling` guide will help you get it built and installed.
 
-We only provide limited options for reference packages, so use a
-supported distribution whenever possible.  At this time the only
-official Cyrus packages are for Debian Jessie (with backports enabled).
+.. _GitHub: https://github.com/cyrusimap/cyrus-imapd/releases
 
-Please download both the packages (\*.deb) and the signature files.
-Installation is a two step process:
 
-1. Install Cyrus reference packages
+1. Install Cyrus package(s)
 -----------------------------------
 
-First, invoke the ``dpkg -i`` command with the list of all packages::
-
-    $ sudo dpkg -i \
-        cyrus-common_3.0.1-jessie_amd64.deb  \
-        cyrus-doc_3.0.1-jessie_all.deb  \
-        cyrus-imapd_3.0.1-jessie_amd64.deb  \
-        cyrus-pop3d_3.0.1-jessie_amd64.deb  \
-        cyrus-admin_3.0.1-jessie_all.deb  \
-        cyrus-murder_3.0.1-jessie_amd64.deb  \
-        cyrus-replication_3.0.1-jessie_amd64.deb  \
-        cyrus-nntpd_3.0.1-jessie_amd64.deb  \
-        cyrus-caldav_3.0.1-jessie_amd64.deb  \
-        cyrus-clients_3.0.1-jessie_amd64.deb  \
-        cyrus-dev_3.0.1-jessie_amd64.deb  \
-        libcyrus-imap-perl_3.0.1-jessie_amd64.deb
-
-That step will produce an error, as there will doubtless be unmet
-dependencies.  Not to worry, there's a fix for that...
-
-2. Use "apt-get install -f" to complete installation
-----------------------------------------------------
-
-Now invoke ``apt-get install -f`` to pull in the dependencies and
-complete the installation::
-
-    $ sudo apt-get install -f
+Install the Cyrus IMAP package(s), either from your distribution's package
+manager, or from a release tarball.
 
-The packaging should pull along all necessary support libraries, etc..
+Your distribution might have split Cyrus IMAP into several packages.  Check
+their documentation if you're not sure what you need.
 
-3. Setup the cyrus:mail user and group
+2. Setup the cyrus:mail user and group
 --------------------------------------
 
 .. include:: /assets/cyrus-user-group.rst
 
-4. Setting up authentication with SASL
+3. Setting up authentication with SASL
 --------------------------------------
 
 .. include:: /assets/setup-sasl-sasldb.rst
 
-5. Setup mail delivery from your MTA
+4. Setup mail delivery from your MTA
 ------------------------------------
 
 Your Cyrus IMAP server will want to receive the emails accepted by your
@@ -88,12 +55,12 @@ protocol called LMTP, which is usually s
 
 .. include:: /assets/setup-postfix.rst
 
-6. Protocol ports
+5. Protocol ports
 -----------------
 
 .. include:: /assets/services.rst
 
-7. Configuring Cyrus
+6. Configuring Cyrus
 --------------------
 
 (Nearly there)
@@ -166,69 +133,14 @@ For example::
     vi /etc/cyrus.conf
     ...
 
-8. Launch Cyrus
+7. Launch Cyrus
 ---------------
 
-If using our packages on Debian Jessie, you will have a SystemV
-compatible init script installed, with systemd support.  Start Cyrus
-with the following command::
-
-    systemctl start cyrus-imapd
-
-Tada!  You should now have a working Cyrus IMAP server.
-
-Feature overview
-----------------
-
-The features (compile-time configuration options) supported in our
-reference packages are:
-
-Cyrus Server configured components
-    * event notification : yes
-    * gssapi             : /usr
-    * autocreate         : yes
-    * idled              : yes
-    * httpd              : yes
-    * kerberos V4        : no
-    * murder             : yes
-    * nntpd              : yes
-    * replication        : yes
-    * sieve              : yes
-    * calalarmd          : no
-    * objectstore        : no
-    * backup             : no
-
-External dependencies
-    * ldap              : yes
-    * openssl           : yes
-    * zlib              : yes
-    * pcre              : yes
-    * clamav            : yes
-    * snmp              : yes
-    * caringo           : no
-    * openio            : no
-    * nghttp2           : no
-    * brotli            : no
-    * xml2              : yes
-    * ical              : yes
-    * icu4c             : no
-    * shapelib          : no
-
-Database support
-    * mysql             : no
-    * postgresql        : no
-    * sqlite            : yes
-    * lmdb              : no
-
-Search engine
-    * squat             : yes
-    * sphinx            : no
-    * xapian            : yes
-    * xapian_flavor     : vanilla
-
-Hardware support
-    * SSE4.2            : yes
-
-Installation directories
-    * prefix            : /usr
-    * sysconfdir        : /etc
+If using a distribution package, you probably now have an init script
+installed, that you can invoke with your system's usual service control
+mechanism.
+
+If you built from source, you will need to write your own init script.
+The simplest one will simply start/stop the :cyrusman:`master(8)` binary,
+with suitable options, as root (master will drop root privileges itself
+as soon as it possibly can).
diff -pruN 3.0.13-5/imap/annotate.c 3.2.0-3/imap/annotate.c
--- 3.0.13-5/imap/annotate.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/annotate.c	2020-04-24 02:03:00.000000000 +0000
@@ -59,12 +59,12 @@
 #include <sys/uio.h>
 #include <fcntl.h>
 #include <ctype.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "acl.h"
 #include "assert.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "glob.h"
 #include "hash.h"
 #include "imapd.h"
@@ -151,8 +151,8 @@ struct annotate_state
 
     /* state for output_entryatt */
     struct attvaluelist *attvalues;
-    char lastname[MAX_MAILBOX_BUFFER];  /* internal */
-    char lastentry[MAX_MAILBOX_BUFFER];
+    char lastname[MAX_MAILBOX_PATH+1];  /* internal */
+    char lastentry[MAX_MAILBOX_PATH+1];
     uint32_t lastuid;
     annotate_fetch_cb_t callback;
     void *callback_rock;
@@ -162,6 +162,12 @@ struct annotate_state
      */
     /* number of mailboxes matching the pattern */
     unsigned count;
+
+    /*
+     * Silent. If set, mailboxes aren't dirtied for mailbox and
+     * message annotation writes.
+     */
+    unsigned silent;
 };
 
 enum {
@@ -200,7 +206,8 @@ struct annotate_entrydesc
                 struct annotate_entry_list *entry);
                /* function to set the entry */
     int (*set)(annotate_state_t *state,
-               struct annotate_entry_list *entry);
+               struct annotate_entry_list *entry,
+               int maywrite);
     void *rock;                 /* rock passed to get() function */
 };
 
@@ -236,15 +243,20 @@ static int annotate_state_set_scope(anno
                                     unsigned int uid);
 static void init_annotation_definitions(void);
 static int annotation_set_tofile(annotate_state_t *state,
-                                 struct annotate_entry_list *entry);
+                                 struct annotate_entry_list *entry,
+                                 int maywrite);
 static int annotation_set_todb(annotate_state_t *state,
-                               struct annotate_entry_list *entry);
+                               struct annotate_entry_list *entry,
+                               int maywrite);
 static int annotation_set_mailboxopt(annotate_state_t *state,
-                                     struct annotate_entry_list *entry);
+                                     struct annotate_entry_list *entry,
+                                     int maywrite);
 static int annotation_set_pop3showafter(annotate_state_t *state,
-                                        struct annotate_entry_list *entry);
+                                        struct annotate_entry_list *entry,
+                                        int maywrite);
 static int annotation_set_specialuse(annotate_state_t *state,
-                                     struct annotate_entry_list *entry);
+                                     struct annotate_entry_list *entry,
+                                     int maywrite);
 static int _annotate_rewrite(struct mailbox *oldmailbox,
                              uint32_t olduid,
                              const char *olduserid,
@@ -259,6 +271,11 @@ static void annotate_begin(annotate_db_t
 static void annotate_abort(annotate_db_t *d);
 static int annotate_commit(annotate_db_t *d);
 
+static void init_internal();
+
+static int annotate_initialized = 0;
+static int annotatemore_dbopen = 0;
+
 /* String List Management */
 /*
  * Append 's' to the strlist 'l'.
@@ -395,6 +412,32 @@ EXPORTED void setentryatt(struct entryat
     }
 }
 
+EXPORTED char *dumpentryatt(const struct entryattlist *l)
+{
+    struct buf buf = BUF_INITIALIZER;
+
+    const struct entryattlist *ee;
+    buf_printf(&buf, "(");
+    const char *sp = "";
+    const struct attvaluelist *av;
+    for (ee = l ; ee ; ee = ee->next) {
+        buf_printf(&buf, "%s%s (", sp, ee->entry);
+        const char *insp = "";
+        for (av = ee->attvalues ; av ; av = av->next) {
+            buf_printf(&buf, "%s%s %s", insp, av->attrib, buf_cstring(&av->value));
+            insp = " ";
+        }
+        buf_printf(&buf, ")");
+        sp = " ";
+    }
+    buf_printf(&buf, ")");
+
+    char *res = buf_release(&buf);
+    buf_free(&buf);
+
+    return res;
+}
+
 EXPORTED void clearentryatt(struct entryattlist **l, const char *entry,
                    const char *attrib)
 {
@@ -474,10 +517,29 @@ EXPORTED void freeentryatts(struct entry
     }
 }
 
+static void done_cb(void*rock __attribute__((unused)))
+{
+    if (annotatemore_dbopen) {
+        annotatemore_close();
+    }
+    annotate_done();
+}
+
+static void init_internal()
+{
+    if (!annotate_initialized) {
+        annotate_init(NULL, NULL);
+        cyrus_modules_add(done_cb, NULL);
+    }
+    if (!annotatemore_dbopen) {
+        annotatemore_open();
+    }
+}
+
 /* must be called after cyrus_init */
 EXPORTED void annotate_init(int (*fetch_func)(const char *, const char *,
                                      const strarray_t *, const strarray_t *),
-                   int (*store_func)(const char *, const char *,
+                            int (*store_func)(const char *, const char *,
                                      struct entryattlist *))
 {
     if (fetch_func) {
@@ -488,6 +550,7 @@ EXPORTED void annotate_init(int (*fetch_
     }
 
     init_annotation_definitions();
+    annotate_initialized = 1;
 }
 
 /* detach the db_t from the global list */
@@ -717,7 +780,9 @@ EXPORTED void annotatemore_open(void)
     /* force opening the global annotations db */
     r = _annotate_getdb(NULL, 0, CYRUSDB_CREATE, &d);
     if (r)
-        fatal("can't open global annotations database", EC_TEMPFAIL);
+        fatal("can't open global annotations database", EX_TEMPFAIL);
+
+    annotatemore_dbopen = 1;
 }
 
 EXPORTED void annotatemore_close(void)
@@ -725,6 +790,8 @@ EXPORTED void annotatemore_close(void)
     /* close all the open databases */
     while (all_dbs_head)
         annotate_closedb(all_dbs_head);
+
+    annotatemore_dbopen = 0;
 }
 
 /* Begin a txn if one is not already started.  Can be called multiple
@@ -774,6 +841,10 @@ static int annotate_commit(annotate_db_t
 EXPORTED void annotate_done(void)
 {
     /* DB->done() handled by cyrus_done() */
+    if (annotatemore_dbopen) {
+        annotatemore_close();
+    }
+    annotate_initialized = 0;
 }
 
 static int make_key(const char *mboxname,
@@ -782,20 +853,18 @@ static int make_key(const char *mboxname
                     const char *userid,
                     char *key, size_t keysize)
 {
-    int keylen = 0;
+    int keylen;
 
     if (!uid) {
-        strlcpy(key+keylen, mboxname, keysize-keylen);
-        keylen += strlen(mboxname) + 1;
+        strlcpy(key, mboxname, keysize);
     }
     else if (uid == ANNOTATE_ANY_UID) {
-        strlcpy(key+keylen, "*", keysize-keylen);
-        keylen += strlen(key+keylen) + 1;
+        strlcpy(key, "*", keysize);
     }
     else {
-        snprintf(key+keylen, keysize-keylen, "%u", uid);
-        keylen += strlen(key+keylen) + 1;
+        snprintf(key, keysize, "%u", uid);
     }
+    keylen = strlen(key) + 1;
     strlcpy(key+keylen, entry, keysize-keylen);
     keylen += strlen(entry);
     /* if we don't have a userid, we're doing a foreach() */
@@ -876,13 +945,19 @@ static const char *key_as_string(const a
 }
 #endif
 
-static int split_attribs(const char *data, int datalen __attribute__((unused)),
-                         struct buf *value)
+static int split_attribs(const char *data, int datalen,
+                         struct buf *value, struct annotate_metadata *mdata)
 {
     unsigned long tmp; /* for alignment */
+    const char *tmps;
+    const char *end = data + datalen;
+
+    /* initialize metadata */
+    memset(mdata, 0, sizeof(struct annotate_metadata));
 
-    /* xxx use datalen? */
     /* xxx sanity check the data? */
+    if (datalen <= 0)
+            return 1;
     /*
      * Sigh...this is dumb.  We take care to be machine independent by
      * storing the length in network byte order...but the size of the
@@ -897,8 +972,30 @@ static int split_attribs(const char *dat
     /*
      * In records written by older versions of Cyrus, there will be
      * binary encoded content-type and modifiedsince values after the
-     * data.  We don't care about those anymore, so we just ignore them.
+     * data. We don't care about those anymore, so we just ignore them
+     * and skip to the entry's metadata.
      */
+    tmps = data + ntohl(tmp) + 1;  /* Skip zero-terminated value */
+    if (tmps < end) {
+        tmps += strlen(tmps) + 1;      /* Skip zero-terminated content-type */
+        tmps += sizeof(unsigned long); /* Skip modifiedsince value */
+    }
+
+    if (tmps < end) {
+        mdata->modseq = ntohll(*((unsigned long long *)tmps));
+        tmps += sizeof(unsigned long long);
+    }
+
+    if (tmps < end) {
+        mdata->flags = *tmps;
+        tmps++;
+    }
+
+    /* normalise deleted entries */
+    if (mdata->flags & ANNOTATE_FLAG_DELETED) {
+        buf_reset(value);
+    }
+
     return 0;
 }
 
@@ -906,9 +1003,11 @@ struct find_rock {
     struct glob *mglob;
     struct glob *eglob;
     unsigned int uid;
+    modseq_t since_modseq;
     annotate_db_t *d;
     annotatemore_find_proc_t proc;
     void *rock;
+    int flags;
 };
 
 static int find_p(void *rock, const char *key, size_t keylen,
@@ -925,6 +1024,9 @@ static int find_p(void *rock, const char
     if (r < 0)
         return 0;
 
+    if (!userid)
+        return 0;
+
     if (frock->uid &&
         frock->uid != ANNOTATE_ANY_UID &&
         frock->uid != uid)
@@ -942,48 +1044,76 @@ static int find_cb(void *rock, const cha
     struct find_rock *frock = (struct find_rock *) rock;
     const char *mboxname, *entry, *userid;
     unsigned int uid;
-    char newkey[MAX_MAILBOX_NAME+1];
+    char newkey[MAX_MAILBOX_PATH+1];
     size_t newkeylen;
     struct buf value = BUF_INITIALIZER;
+    struct annotate_metadata mdata;
     int r;
 
     assert(keylen < MAX_MAILBOX_PATH);
 
-#if DEBUG
-    syslog(LOG_ERR, "find_cb: found key %s in %s",
-            key_as_string(frock->d, key, keylen), frock->d->filename);
-#endif
-
     r = split_key(frock->d, key, keylen, &mboxname,
                   &uid, &entry, &userid);
-    if (r)
+    if (r) {
+        syslog(LOG_ERR, "find_cb: can't split bogus key %*.s", (int)keylen, key);
         return r;
+    }
 
     newkeylen = make_key(mboxname, uid, entry, userid, newkey, sizeof(newkey));
     if (keylen != newkeylen || strncmp(newkey, key, keylen)) {
         syslog(LOG_ERR, "find_cb: bogus key %s %d %s %s (%d %d)", mboxname, uid, entry, userid, (int)keylen, (int)newkeylen);
     }
 
-    r = split_attribs(data, datalen, &value);
+    r = split_attribs(data, datalen, &value, &mdata);
+    if (r) {
+        buf_free(&value);
+        return r;
+    }
+#if DEBUG
+    syslog(LOG_ERR, "find_cb: found key %s in %s with modseq " MODSEQ_FMT,
+            key_as_string(frock->d, key, keylen), frock->d->filename, mdata.modseq);
+#endif
+
+    if (frock->since_modseq && frock->since_modseq >= mdata.modseq) {
+#if DEBUG
+        syslog(LOG_ERR,"find_cb: ignoring key %s: " " modseq " MODSEQ_FMT " is <= " MODSEQ_FMT,
+                key_as_string(frock->d, key, keylen), mdata.modseq, frock->since_modseq);
+#endif
+        buf_free(&value);
+        return 0;
+    }
 
-    if (!r) r = frock->proc(mboxname, uid, entry, userid, &value, frock->rock);
+    if (((mdata.flags & ANNOTATE_FLAG_DELETED) || !buf_len(&value)) &&
+        !(frock->flags & ANNOTATE_TOMBSTONES)) {
+#if DEBUG
+    syslog(LOG_ERR, "find_cb: ignoring key %s, tombstones are ignored",
+            key_as_string(frock->d, key, keylen));
+#endif
+        buf_free(&value);
+        return 0;
+    }
 
+    if (!r) r = frock->proc(mboxname, uid, entry, userid, &value, &mdata,
+                            frock->rock);
     buf_free(&value);
-
     return r;
 }
 
 EXPORTED int annotatemore_findall(const char *mboxname, /* internal */
                          unsigned int uid,
                          const char *entry,
+                         modseq_t since_modseq,
                          annotatemore_find_proc_t proc,
-                         void *rock)
+                         void *rock,
+                         int flags)
 {
     char key[MAX_MAILBOX_PATH+1], *p;
     size_t keylen;
     int r;
     struct find_rock frock;
 
+    init_internal();
+
     assert(mboxname);
     assert(entry);
     frock.mglob = glob_init(mboxname, '.');
@@ -991,6 +1121,8 @@ EXPORTED int annotatemore_findall(const
     frock.uid = uid;
     frock.proc = proc;
     frock.rock = rock;
+    frock.since_modseq = since_modseq;
+    frock.flags = flags;
     r = _annotate_getdb(mboxname, uid, 0, &frock.d);
     if (r) {
         if (r == CYRUSDB_NOTFOUND)
@@ -1017,7 +1149,6 @@ out:
 
     return r;
 }
-
 /***************************  Annotate State Management  ***************************/
 
 EXPORTED annotate_state_t *annotate_state_new(void)
@@ -1069,6 +1200,8 @@ static void annotate_state_free(annotate
 
 EXPORTED void annotate_state_begin(annotate_state_t *state)
 {
+    init_internal();
+
     annotate_begin(state->d);
 }
 
@@ -1146,6 +1279,8 @@ HIDDEN int annotate_state_set_message(an
 /* unset any state from a previous scope */
 static void annotate_state_unset_scope(annotate_state_t *state)
 {
+    init_internal();
+
     if (state->ourmailbox)
         mailbox_close(&state->ourmailbox);
     state->mailbox = NULL;
@@ -1168,6 +1303,8 @@ static int annotate_state_set_scope(anno
     annotate_db_t *oldd = NULL;
     int oldwhich = state->which;
 
+    init_internal();
+
     /* Carefully preserve the reference on the old DB just in case it
      * turns out to be the same as the new DB, so we avoid the overhead
      * of an unnecessary cyrusdb_open/close pair. */
@@ -1261,11 +1398,9 @@ static void output_entryatt(annotate_sta
                             const char *userid, const struct buf *value)
 {
     const char *mboxname;
-    char key[MAX_MAILBOX_BUFFER]; /* XXX MAX_MAILBOX_NAME + entry + userid */
+    char key[MAX_MAILBOX_PATH+1]; /* XXX MAX_MAILBOX_NAME + entry + userid */
     struct buf buf = BUF_INITIALIZER;
 
-    if (!userid) userid = "";
-
     /* We don't put any funny interpretations on NULL values for
      * some of these anymore, now that the dirty hacks are gone. */
     assert(state);
@@ -1624,6 +1759,21 @@ static void annotation_get_synccrcs(anno
     buf_free(&value);
 }
 
+static void annotation_get_foldermodseq(annotate_state_t *state,
+                                        struct annotate_entry_list *entry)
+{
+    struct buf value = BUF_INITIALIZER;
+
+    assert(state);
+    annotate_state_need_mbentry(state);
+    assert(state->mbentry);
+
+    buf_printf(&value, "%llu", state->mbentry->foldermodseq);
+    output_entryatt(state, entry->name, "", &value);
+
+    buf_free(&value);
+}
+
 static void annotation_get_usermodseq(annotate_state_t *state,
                                       struct annotate_entry_list *entry)
 {
@@ -1659,12 +1809,13 @@ static void annotation_get_usercounters(
     mboxname = mboxname_user_mbox(state->userid, NULL);
     int r = mboxname_read_counters(mboxname, &counters);
 
-    if (!r) buf_printf(&value, "%u %llu %llu %llu %llu %llu %llu %llu %llu %llu %u",
+    if (!r) buf_printf(&value, "%u %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %u",
                        counters.version, counters.highestmodseq,
                        counters.mailmodseq, counters.caldavmodseq,
                        counters.carddavmodseq, counters.notesmodseq,
                        counters.mailfoldersmodseq, counters.caldavfoldersmodseq,
                        counters.carddavfoldersmodseq, counters.notesfoldersmodseq,
+                       counters.quotamodseq, counters.raclmodseq,
                        counters.uidvalidity);
 
     output_entryatt(state, entry->name, state->userid, &value);
@@ -1689,12 +1840,12 @@ static void annotation_get_uniqueid(anno
 static int rw_cb(const char *mailbox __attribute__((unused)),
                  uint32_t uid __attribute__((unused)),
                  const char *entry, const char *userid,
-                 const struct buf *value, void *rock)
+                 const struct buf *value,
+                 const struct annotate_metadata *mdata __attribute__((unused)),
+                 void *rock)
 {
     annotate_state_t *state = (annotate_state_t *)rock;
 
-    if (!userid) userid = "";
-
     if (!userid[0] || !strcmp(userid, state->userid)) {
         output_entryatt(state, entry, userid, value);
     }
@@ -1708,7 +1859,7 @@ static void annotation_get_fromdb(annota
     const char *mboxname = (state->mailbox ? state->mailbox->name : "");
     state->found = 0;
 
-    annotatemore_findall(mboxname, state->uid, entry->name, &rw_cb, state);
+    annotatemore_findall(mboxname, state->uid, entry->name, 0, &rw_cb, state, 0);
 
     if (state->found != state->attribs &&
         (!strchr(entry->name, '%') && !strchr(entry->name, '*'))) {
@@ -1743,7 +1894,8 @@ static const annotate_entrydesc_t messag
         annotation_get_fromdb,
         annotation_set_todb,
         NULL
-    },{
+    },
+    {
         /* RFC5257 defines /comment with both .shared & .priv */
         "/comment",
         ATTRIB_TYPE_STRING,
@@ -1753,7 +1905,73 @@ static const annotate_entrydesc_t messag
         annotation_get_fromdb,
         annotation_set_todb,
         NULL
-    },{ NULL, 0, ANNOTATION_PROXY_T_INVALID, 0, 0, NULL, NULL, NULL }
+    },
+    {
+        /* we use 'basethrid' to support split threads */
+        IMAP_ANNOT_NS "basethrid",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED | ATTRIB_VALUE_PRIV,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },
+    {
+        /* prior to version 12, there was no storage for thrid, so it became an annotation */
+        IMAP_ANNOT_NS "thrid",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED | ATTRIB_VALUE_PRIV,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },
+    {
+        /* prior to version 15, there was no storage for savedate, so it became an annotation */
+        IMAP_ANNOT_NS "savedate",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED | ATTRIB_VALUE_PRIV,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },
+    {
+        /* prior to version 16, there was no storage for createdmodseq, so it became an annotation */
+        IMAP_ANNOT_NS "createdmodseq",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED | ATTRIB_VALUE_PRIV,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },
+    {
+        /* Deprecated in favor of "snoozed" */
+        IMAP_ANNOT_NS "snoozed-until",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_fromdb,
+        NULL,
+        NULL
+    },
+    {
+        IMAP_ANNOT_NS "snoozed",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },
+    { NULL, 0, ANNOTATION_PROXY_T_INVALID, 0, 0, NULL, NULL, NULL }
 };
 
 static const annotate_entrydesc_t message_db_entry =
@@ -1862,6 +2080,24 @@ static const annotate_entrydesc_t mailbo
         /*set*/NULL,
         NULL
     },{
+        IMAP_ANNOT_NS "archive",
+        ATTRIB_TYPE_UINT,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        ACL_ADMIN,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },{
+        IMAP_ANNOT_NS "delete",
+        ATTRIB_TYPE_UINT,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        ACL_ADMIN,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },{
         IMAP_ANNOT_NS "duplicatedeliver",
         ATTRIB_TYPE_BOOLEAN,
         BACKEND_ONLY,
@@ -1889,6 +2125,24 @@ static const annotate_entrydesc_t mailbo
         /*set*/NULL,
         NULL
     },{
+        IMAP_ANNOT_NS "hasalarms",
+        ATTRIB_TYPE_BOOLEAN,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_mailboxopt,
+        /*set*/NULL,
+        (void *)OPT_IMAP_HAS_ALARMS
+    },{
+        IMAP_ANNOT_NS "foldermodseq",
+        ATTRIB_TYPE_UINT,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_foldermodseq,
+        /*set*/NULL,
+        NULL
+    },{
         IMAP_ANNOT_NS "lastupdate",
         ATTRIB_TYPE_STRING,
         BACKEND_ONLY,
@@ -1972,6 +2226,15 @@ static const annotate_entrydesc_t mailbo
         /*set*/NULL,
         NULL
     },{
+        IMAP_ANNOT_NS "sortorder",
+        ATTRIB_TYPE_UINT,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_PRIV,
+        0,
+        annotation_get_fromdb,
+        annotation_set_todb,
+        NULL
+    },{
         IMAP_ANNOT_NS "squat",
         ATTRIB_TYPE_BOOLEAN,
         BACKEND_ONLY,
@@ -2065,7 +2328,7 @@ static const annotate_entrydesc_t server
         /* The "usemodseq" was added with conversations support, to allow
          * a single value to show any changes to anything about a user */
         IMAP_ANNOT_NS "usercounters",
-        ATTRIB_TYPE_UINT,
+        ATTRIB_TYPE_STRING,
         BACKEND_ONLY,
         ATTRIB_VALUE_PRIV,
         0,
@@ -2091,22 +2354,22 @@ static const annotate_entrydesc_t server
         /*set*/NULL,
         NULL
     },{
-    IMAP_ANNOT_NS "freespace/total",
-    ATTRIB_TYPE_STRING,
-    BACKEND_ONLY,
-    ATTRIB_VALUE_SHARED,
-    0,
-    annotation_get_freespace_total,
-    /*set*/NULL,
-    NULL
+        IMAP_ANNOT_NS "freespace/total",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_freespace_total,
+        /*set*/NULL,
+        NULL
     },{
-    IMAP_ANNOT_NS "freespace/percent/most",
-    ATTRIB_TYPE_STRING,
-    BACKEND_ONLY,
-    ATTRIB_VALUE_SHARED,
-    0,
-    annotation_get_freespace_percent_most,
-    /*set*/NULL,
+        IMAP_ANNOT_NS "freespace/percent/most",
+        ATTRIB_TYPE_STRING,
+        BACKEND_ONLY,
+        ATTRIB_VALUE_SHARED,
+        0,
+        annotation_get_freespace_percent_most,
+        /*set*/NULL,
     NULL
     },{
         IMAP_ANNOT_NS "shutdown",
@@ -2206,6 +2469,8 @@ EXPORTED int annotate_state_fetch(annota
     const annotate_entrydesc_t *db_entry;
     int r = 0;
 
+    init_internal();
+
     annotate_state_start(state);
     state->callback = callback;
     state->callback_rock = rock;
@@ -2375,6 +2640,9 @@ EXPORTED int annotatemore_msg_lookup(con
     int r;
     const char *data;
     annotate_db_t *d = NULL;
+    struct annotate_metadata mdata;
+
+    init_internal();
 
     r = _annotate_getdb(mboxname, uid, 0, &d);
     if (r)
@@ -2387,14 +2655,18 @@ EXPORTED int annotatemore_msg_lookup(con
     } while (r == CYRUSDB_AGAIN);
 
     if (!r && data) {
-        r = split_attribs(data, datalen, value);
+        r = split_attribs(data, datalen, value, &mdata);
         if (!r) {
             /* Force a copy, in case the putdb() call destroys
              * the per-db data area that @data points to.  */
             buf_cstring(value);
         }
+        if (mdata.flags & ANNOTATE_FLAG_DELETED) {
+            buf_free(value);
+            r = CYRUSDB_NOTFOUND;
+        }
     }
-    else if (r == CYRUSDB_NOTFOUND) r = 0;
+    if (r == CYRUSDB_NOTFOUND) r = 0;
 
     annotate_putdb(&d);
     return r;
@@ -2405,6 +2677,9 @@ EXPORTED int annotatemore_msg_lookupmask
 {
     int r = 0;
     value->len = 0; /* just in case! */
+
+    init_internal();
+
     /* only if the user isn't the owner, we look for a masking value */
     if (!mboxname_userownsmailbox(userid, mboxname))
         r = annotatemore_msg_lookup(mboxname, uid, entry, userid, value);
@@ -2419,7 +2694,8 @@ EXPORTED int annotatemore_msg_lookupmask
 
 static int read_old_value(annotate_db_t *d,
                           const char *key, int keylen,
-                          struct buf *valp)
+                          struct buf *valp,
+                          struct annotate_metadata *mdata)
 {
     int r;
     size_t datalen;
@@ -2436,24 +2712,69 @@ static int read_old_value(annotate_db_t
     if (r || !data)
         goto out;
 
-    r = split_attribs(data, datalen, valp);
+    r = split_attribs(data, datalen, valp, mdata);
 
 out:
     return r;
 }
 
+static int make_entry(struct buf *data,
+                      const struct buf *value,
+                      modseq_t modseq,
+                      unsigned char flags)
+{
+    unsigned long l;
+    static const char contenttype[] = "text/plain"; /* fake */
+    unsigned long long nmodseq;
+
+    /* Make sure that native types are wide enough */
+    assert(sizeof(modseq_t) <= sizeof(unsigned long long));
+    nmodseq = htonll((unsigned long long) modseq);
+
+    l = htonl(value->len);
+    buf_appendmap(data, (const char *)&l, sizeof(l));
+
+    buf_appendmap(data, value->s ? value->s : "", value->len);
+    buf_putc(data, '\0');
+
+    /*
+     * Older versions of Cyrus expected content-type and
+     * modifiedsince fields after the value.  We don't support those
+     * but we write out default values just in case the database
+     * needs to be read by older versions of Cyrus
+     */
+    buf_appendcstr(data, contenttype);
+    buf_putc(data, '\0');
+
+    l = 0;  /* fake modifiedsince */
+    buf_appendmap(data, (const char *)&l, sizeof(l));
+
+    /* Append modseq at the end */
+    buf_appendmap(data, (const char *)&nmodseq, sizeof(nmodseq));
+
+    /* Append flags */
+    buf_putc(data, flags);
+
+    return 0;
+}
+
 static int write_entry(struct mailbox *mailbox,
                        unsigned int uid,
                        const char *entry,
                        const char *userid,
                        const struct buf *value,
-                       int ignorequota)
+                       int ignorequota,
+                       int silent,
+                       const struct annotate_metadata *mdata,
+                       int maywrite)
+
 {
     char key[MAX_MAILBOX_PATH+1];
     int keylen, r;
     annotate_db_t *d = NULL;
     struct buf oldval = BUF_INITIALIZER;
     const char *mboxname = mailbox ? mailbox->name : "";
+    modseq_t modseq = mdata ? mdata->modseq : 0;
 
     r = _annotate_getdb(mboxname, uid, CYRUSDB_CREATE, &d);
     if (r)
@@ -2465,9 +2786,14 @@ static int write_entry(struct mailbox *m
     keylen = make_key(mboxname, uid, entry, userid, key, sizeof(key));
 
     if (mailbox) {
-        r = read_old_value(d, key, keylen, &oldval);
+        struct annotate_metadata oldmdata;
+        r = read_old_value(d, key, keylen, &oldval, &oldmdata);
         if (r) goto out;
 
+        /* if the value is identical, don't touch the mailbox */
+        if (oldval.len == value->len && (!value->len || !memcmp(oldval.s, value->s, value->len)))
+            goto out;
+
         if (!ignorequota) {
             quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_DONTCARE_INITIALIZER;
             qdiffs[QUOTA_ANNOTSTORAGE] = value->len - (quota_t)oldval.len;
@@ -2475,12 +2801,23 @@ static int write_entry(struct mailbox *m
             if (r) goto out;
         }
 
+        if (!maywrite) {
+            r = IMAP_PERMISSION_DENIED;
+            if (r) goto out;
+        }
+
         /* do the annot-changed here before altering the DB */
-        mailbox_annot_changed(mailbox, uid, entry, userid, &oldval, value);
+        mailbox_annot_changed(mailbox, uid, entry, userid, &oldval, value, silent);
+
+        /* grab the message annotation modseq, if not overridden */
+        if (uid && !mdata) {
+            modseq = mailbox->i.highestmodseq;
+        }
     }
 
-    /* zero length annotation is also deletion I think */
-    if (!value->len) {
+    /* zero length annotation is deletion.
+     * keep tombstones for message annotations */
+    if (!value->len && !uid) {
 
 #if DEBUG
         syslog(LOG_ERR, "write_entry: deleting key %s from %s",
@@ -2493,30 +2830,23 @@ static int write_entry(struct mailbox *m
     }
     else {
         struct buf data = BUF_INITIALIZER;
-        unsigned long l;
-        static const char contenttype[] = "text/plain"; /* fake */
-
-        l = htonl(value->len);
-        buf_appendmap(&data, (const char *)&l, sizeof(l));
-
-        buf_appendmap(&data, value->s, value->len);
-        buf_putc(&data, '\0');
-
-        /*
-         * Older versions of Cyrus expected content-type and
-         * modifiedsince fields after the value.  We don't support those
-         * but we write out default values just in case the database
-         * needs to be read by older versions of Cyrus
-         */
-        buf_appendcstr(&data, contenttype);
-        buf_putc(&data, '\0');
-
-        l = 0;  /* fake modifiedsince */
-        buf_appendmap(&data, (const char *)&l, sizeof(l));
+        unsigned char flags = 0;
+        if (!value->len || value->s == NULL) {
+            flags |= ANNOTATE_FLAG_DELETED;
+        }
+        else {
+            // this is only here to allow cleanup of invalid values in the past...
+            // the calling of this API with a NULL "userid" is bogus, because that's
+            // supposed to be reserved for the make_key of prefixes - but there has
+            // been API abuse in the past, so some of these are in the wild.  *sigh*.
+            // Don't allow new ones to be written
+            if (!userid) goto out;
+        }
+        make_entry(&data, value, modseq, flags);
 
 #if DEBUG
-        syslog(LOG_ERR, "write_entry: storing key %s to %s",
-                key_as_string(d, key, keylen), d->filename);
+        syslog(LOG_ERR, "write_entry: storing key %s (value: %s) to %s (modseq=" MODSEQ_FMT ")",
+                key_as_string(d, key, keylen), value->s, d->filename, modseq);
 #endif
 
         do {
@@ -2543,6 +2873,8 @@ EXPORTED int annotatemore_rawwrite(const
     annotate_db_t *d = NULL;
     uint32_t uid = 0;
 
+    init_internal();
+
     r = _annotate_getdb(mboxname, uid, CYRUSDB_CREATE, &d);
     if (r) goto done;
 
@@ -2558,31 +2890,12 @@ EXPORTED int annotatemore_rawwrite(const
     }
     else {
         struct buf data = BUF_INITIALIZER;
-        unsigned long l;
-        static const char contenttype[] = "text/plain"; /* fake */
-
-        l = htonl(value->len);
-        buf_appendmap(&data, (const char *)&l, sizeof(l));
-
-        buf_appendmap(&data, value->s, value->len);
-        buf_putc(&data, '\0');
-
-        /*
-         * Older versions of Cyrus expected content-type and
-         * modifiedsince fields after the value.  We don't support those
-         * but we write out default values just in case the database
-         * needs to be read by older versions of Cyrus
-         */
-        buf_appendcstr(&data, contenttype);
-        buf_putc(&data, '\0');
 
-        l = 0;  /* fake modifiedsince */
-        buf_appendmap(&data, (const char *)&l, sizeof(l));
+        make_entry(&data, value, uid, /*flags*/0);
 
         do {
             r = cyrusdb_store(d->db, key, keylen, data.s, data.len, tid(d));
         } while (r == CYRUSDB_AGAIN);
-
         buf_free(&data);
     }
 
@@ -2598,17 +2911,13 @@ done:
 EXPORTED int annotatemore_write(const char *mboxname, const char *entry,
                                 const char *userid, const struct buf *value)
 {
-    return annotatemore_msg_write(mboxname, /*uid*/0, entry, userid, value);
-}
-
-EXPORTED int annotatemore_msg_write(const char *mboxname, uint32_t uid, const char *entry,
-                                    const char *userid, const struct buf *value)
-{
     struct mailbox *mailbox = NULL;
     int r = 0;
     annotate_db_t *d = NULL;
 
-    r = _annotate_getdb(mboxname, uid, CYRUSDB_CREATE, &d);
+    init_internal();
+
+    r = _annotate_getdb(mboxname, /*uid*/0, CYRUSDB_CREATE, &d);
     if (r) goto done;
 
     if (mboxname) {
@@ -2616,7 +2925,8 @@ EXPORTED int annotatemore_msg_write(cons
         if (r) goto done;
     }
 
-    r = write_entry(mailbox, uid, entry, userid, value, /*ignorequota*/1);
+    r = write_entry(mailbox, /*uid*/0, entry, userid, value,
+                    /*ignorequota*/1, /*silent*/0, NULL, /*maywrite*/1);
     if (r) goto done;
 
     r = annotate_commit(d);
@@ -2628,13 +2938,43 @@ done:
     return r;
 }
 
+EXPORTED int annotatemore_writemask(const char *mboxname, const char *entry,
+                                    const char *userid, const struct buf *value)
+{
+    if (mboxname_userownsmailbox(userid, mboxname))
+        return annotatemore_write(mboxname, entry, "", value);
+    else
+        return annotatemore_write(mboxname, entry, userid, value);
+}
+
 EXPORTED int annotate_state_write(annotate_state_t *state,
-                         const char *entry,
-                         const char *userid,
-                         const struct buf *value)
+                                  const char *entry,
+                                  const char *userid,
+                                  const struct buf *value)
+{
+    return write_entry(state->mailbox, state->uid,
+                       entry, userid, value, /*ignorequota*/1,
+                       state->silent, NULL, /*maywrite*/1);
+}
+
+EXPORTED int annotate_state_writesilent(annotate_state_t *state,
+                                        const char *entry,
+                                        const char *userid,
+                                        const struct buf *value)
 {
     return write_entry(state->mailbox, state->uid,
-                       entry, userid, value, /*ignorequota*/1);
+                       entry, userid, value, /*ignorequota*/1,
+                       /*silent*/1, NULL, /*maywrite*/1);
+}
+
+EXPORTED int annotate_state_writemdata(annotate_state_t *state,
+                                       const char *entry,
+                                       const char *userid,
+                                       const struct buf *value,
+                                       const struct annotate_metadata *mdata)
+{
+    return write_entry(state->mailbox, state->uid, entry, userid, value,
+                       /*ignorequota*/1, 0, mdata, /*maywrite*/1);
 }
 
 EXPORTED int annotate_state_writemask(annotate_state_t *state,
@@ -2722,10 +3062,12 @@ static int annotate_canon_value(struct b
 static int _annotate_store_entries(annotate_state_t *state)
 {
     struct annotate_entry_list *ee;
-    int r;
+    int r = 0;
+    unsigned oldsilent = state->silent;
 
     /* Loop through the list of provided entries to set */
     for (ee = state->entry_list ; ee ; ee = ee->next) {
+        int maystore = 1;
 
         /* Skip annotations that can't be stored on frontend */
         if ((ee->desc->proxytype == BACKEND_ONLY) &&
@@ -2733,18 +3075,27 @@ static int _annotate_store_entries(annot
             continue;
 
         if (ee->have_shared &&
-            !_annotate_may_store(state, /*shared*/1, ee->desc))
-            return IMAP_PERMISSION_DENIED;
+            !_annotate_may_store(state, /*shared*/1, ee->desc)) {
+            maystore = 0;
+        }
 
         if (ee->have_priv &&
-            !_annotate_may_store(state, /*shared*/0, ee->desc))
-            return IMAP_PERMISSION_DENIED;
+            !_annotate_may_store(state, /*shared*/0, ee->desc)) {
+            maystore = 0;
+        }
 
-        r = ee->desc->set(state, ee);
+        r = ee->desc->set(state, ee, maystore);
         if (r)
-            return r;
+            goto done;
+
+        /* only the first write for message annotations isn't silent! */
+        if (state->which == ANNOTATION_SCOPE_MESSAGE)
+            state->silent = 1;
     }
-    return 0;
+
+done:
+    state->silent = oldsilent;
+    return r;
 }
 
 
@@ -2813,13 +3164,16 @@ static int _annotate_may_store(annotate_
 
 static int annotation_set_tofile(annotate_state_t *state
                                     __attribute__((unused)),
-                                 struct annotate_entry_list *entry)
+                                 struct annotate_entry_list *entry,
+                                 int maywrite)
 {
     const char *filename = (const char *)entry->desc->rock;
     char path[MAX_MAILBOX_PATH+1];
     int r;
     FILE *f;
 
+    if (!maywrite) return IMAP_PERMISSION_DENIED;
+
     snprintf(path, sizeof(path), "%s/msg/%s", config_dir, filename);
 
     /* XXX how do we do this atomically with other annotations? */
@@ -2843,24 +3197,26 @@ static int annotation_set_tofile(annotat
 }
 
 static int annotation_set_todb(annotate_state_t *state,
-                               struct annotate_entry_list *entry)
+                               struct annotate_entry_list *entry,
+                               int maywrite)
 {
     int r = 0;
 
     if (entry->have_shared)
         r = write_entry(state->mailbox, state->uid,
                         entry->name, "",
-                        &entry->shared, 0);
+                        &entry->shared, 0, state->silent, NULL, maywrite);
     if (!r && entry->have_priv)
         r = write_entry(state->mailbox, state->uid,
                         entry->name, state->userid,
-                        &entry->priv, 0);
+                        &entry->priv, 0, state->silent, NULL, maywrite);
 
     return r;
 }
 
 static int annotation_set_mailboxopt(annotate_state_t *state,
-                                     struct annotate_entry_list *entry)
+                                     struct annotate_entry_list *entry,
+                                     int maywrite)
 {
     struct mailbox *mailbox = state->mailbox;
     uint32_t flag = (unsigned long)entry->desc->rock;
@@ -2879,16 +3235,19 @@ static int annotation_set_mailboxopt(ann
 
     /* only mark dirty if there's been a change */
     if (mailbox->i.options != newopts) {
+        if (!maywrite) return IMAP_PERMISSION_DENIED;
         mailbox_index_dirty(mailbox);
+        mailbox_modseq_dirty(mailbox);
         mailbox->i.options = newopts;
-        mboxlist_foldermodseq_dirty(mailbox);
+        mboxlist_update_foldermodseq(mailbox->name, mailbox->i.highestmodseq);
     }
 
     return 0;
 }
 
 static int annotation_set_pop3showafter(annotate_state_t *state,
-                                        struct annotate_entry_list *entry)
+                                        struct annotate_entry_list *entry,
+                                        int maywrite)
 {
     struct mailbox *mailbox = state->mailbox;
     int r = 0;
@@ -2901,25 +3260,31 @@ static int annotation_set_pop3showafter(
         date = 0;
     }
     else {
-        r = time_from_rfc3501(buf_cstring(&entry->shared), &date);
+        r = time_from_rfc5322(buf_cstring(&entry->shared), &date, DATETIME_FULL);
         if (r < 0)
             return IMAP_PROTOCOL_BAD_PARAMETERS;
     }
 
     if (date != mailbox->i.pop3_show_after) {
-        mailbox->i.pop3_show_after = date;
+        if (!maywrite) return IMAP_PERMISSION_DENIED;
         mailbox_index_dirty(mailbox);
+        mailbox_modseq_dirty(mailbox);
+        mailbox->i.pop3_show_after = date;
+        mboxlist_update_foldermodseq(mailbox->name, mailbox->i.highestmodseq);
     }
 
     return 0;
 }
 
-EXPORTED int specialuse_validate(const char *userid, const char *src, struct buf *dest)
+EXPORTED int specialuse_validate(const char *mboxname, const char *userid,
+                                 const char *src, struct buf *dest)
 {
     const char *specialuse_extra_opt = config_getstring(IMAPOPT_SPECIALUSE_EXTRA);
     char *strval = NULL;
     strarray_t *valid = NULL;
-    strarray_t *values = NULL;
+    strarray_t *new_attribs = NULL;
+    strarray_t *cur_attribs = NULL;
+    struct buf mbattribs = BUF_INITIALIZER;
     int i, j;
     int r = 0;
 
@@ -2928,6 +3293,15 @@ EXPORTED int specialuse_validate(const c
         return 0;
     }
 
+    /* If there is a valid mboxname, we get the current specialuse annotations.
+     */
+    if (mboxname) {
+        annotatemore_lookup(mboxname, "/specialuse", userid, &mbattribs);
+        if (mbattribs.len) {
+            cur_attribs = strarray_split(buf_cstring(&mbattribs), NULL, 0);
+        }
+    }
+
     /* check specialuse_extra option if set */
     if (specialuse_extra_opt)
         valid = strarray_split(specialuse_extra_opt, NULL, 0);
@@ -2938,14 +3312,17 @@ EXPORTED int specialuse_validate(const c
     strarray_add(valid, "\\Archive");
     strarray_add(valid, "\\Drafts");
     /* strarray_add(valid, "\\Flagged"); -- we don't support virtual folders right now */
+    strarray_add(valid, "\\Important"); // draft-ietf-specialuse-important
     strarray_add(valid, "\\Junk");
     strarray_add(valid, "\\Sent");
     strarray_add(valid, "\\Trash");
+    strarray_add(valid, "\\Snoozed"); // JMAP
 
-    values = strarray_split(src, NULL, 0);
+    new_attribs = strarray_split(src, NULL, 0);
 
-    for (i = 0; i < values->count; i++) {
-        const char *item = strarray_nth(values, i);
+    for (i = 0; i < new_attribs->count; i++) {
+        int skip_mbcheck = 0;
+        const char *item = strarray_nth(new_attribs, i);
 
         for (j = 0; j < valid->count; j++) { /* can't use find here */
             if (!strcasecmp(strarray_nth(valid, j), item))
@@ -2954,35 +3331,48 @@ EXPORTED int specialuse_validate(const c
             if (!strcasecmp(strarray_nth(valid, j) + 1, item))
                 break;
         }
+
         if (j >= valid->count) {
             r = IMAP_ANNOTATION_BADENTRY;
             goto done;
         }
 
+        if (cur_attribs &&
+            (strarray_find_case(cur_attribs, strarray_nth(valid, j), 0) >= 0)) {
+            /* The mailbox has this specialuse attribute set already */
+            skip_mbcheck = 1;
+        }
+
         /* don't allow names that are already in use */
-        char *mboxname = mboxlist_find_specialuse(strarray_nth(valid, j), userid);
-        if (mboxname) {
-            free(mboxname);
-            r = IMAP_MAILBOX_SPECIALUSE;
-            goto done;
+        if (!skip_mbcheck) {
+            char *mbname = mboxlist_find_specialuse(strarray_nth(valid, j),
+                                                    userid);
+            if (mbname) {
+                free(mbname);
+                r = IMAP_MAILBOX_SPECIALUSE;
+                goto done;
+            }
         }
 
         /* normalise the value */
-        strarray_set(values, i, strarray_nth(valid, j));
+        strarray_set(new_attribs, i, strarray_nth(valid, j));
     }
 
-    strval = strarray_join(values, " ");
+    strval = strarray_join(new_attribs, " ");
     buf_setcstr(dest, strval);
 
 done:
     free(strval);
     strarray_free(valid);
-    strarray_free(values);
+    strarray_free(new_attribs);
+    strarray_free(cur_attribs);
+    buf_free(&mbattribs);
     return r;
 }
 
 static int annotation_set_specialuse(annotate_state_t *state,
-                                     struct annotate_entry_list *entry)
+                                     struct annotate_entry_list *entry,
+                                     int maywrite)
 {
     struct buf res = BUF_INITIALIZER;
     int r = IMAP_PERMISSION_DENIED;
@@ -2991,14 +3381,17 @@ static int annotation_set_specialuse(ann
 
     /* Effectively removes the annotation */
     if (entry->priv.s == NULL) {
-        r = write_entry(state->mailbox, state->uid, entry->name, state->userid, &entry->priv, 0);
+        r = write_entry(state->mailbox, state->uid, entry->name, state->userid,
+                        &entry->priv, /*ignorequota*/0, /*silent*/0, NULL, maywrite);
         goto done;
     }
 
-    r = specialuse_validate(state->userid, buf_cstring(&entry->priv), &res);
+    r = specialuse_validate(state->mailbox->name, state->userid,
+                            buf_cstring(&entry->priv), &res);
     if (r) goto done;
 
-    r = write_entry(state->mailbox, state->uid, entry->name, state->userid, &res, 0);
+    r = write_entry(state->mailbox, state->uid, entry->name, state->userid,
+                    &res, /*ignorequota*/0, state->silent, NULL, maywrite);
 
 done:
     buf_free(&res);
@@ -3204,12 +3597,15 @@ static int rename_cb(const char *mboxnam
                      uint32_t uid,
                      const char *entry,
                      const char *userid, const struct buf *value,
+                     const struct annotate_metadata *mdata __attribute__((unused)),
                      void *rock)
 {
     struct rename_rock *rrock = (struct rename_rock *) rock;
     int r = 0;
 
     if (rrock->newmailbox &&
+            /* snoozed MUST only appear on one copy of a message */
+            strcmp(entry, IMAP_ANNOT_NS "snoozed") &&
             /* displayname stores the UTF-8 encoded JMAP name of a mailbox */
             strcmp(entry, IMAP_ANNOT_NS "displayname")) {
         /* create newly renamed entry */
@@ -3220,13 +3616,15 @@ static int rename_cb(const char *mboxnam
             /* renaming a user, so change the userid for priv annots */
             newuserid = rrock->newuserid;
         }
-        r = write_entry(rrock->newmailbox, rrock->newuid, entry, newuserid, value, 0);
+        r = write_entry(rrock->newmailbox, rrock->newuid, entry, newuserid,
+                        value, /*ignorequota*/0, /*silent*/0, NULL, /*maywrite*/1);
     }
 
     if (!rrock->copy && !r) {
         /* delete existing entry */
         struct buf dattrib = BUF_INITIALIZER;
-        r = write_entry(rrock->oldmailbox, uid, entry, userid, &dattrib, 0);
+        r = write_entry(rrock->oldmailbox, uid, entry, userid, &dattrib,
+                        /*ignorequota*/0, /*silent*/0, NULL, /*maywrite*/1);
     }
 
     return r;
@@ -3241,6 +3639,8 @@ EXPORTED int annotate_rename_mailbox(str
     annotate_db_t *d = NULL;
     int r = 0;
 
+    init_internal();
+
     /* rewrite any per-folder annotations from the global db */
     r = _annotate_getdb(NULL, 0, /*don't create*/0, &d);
     if (r == CYRUSDB_NOTFOUND) {
@@ -3273,7 +3673,6 @@ EXPORTED int annotate_rename_mailbox(str
     return r;
 }
 
-
 /*
  * Perform a scan-and-rewrite through the database(s) for
  * a given set of criteria; common code for several higher
@@ -3297,7 +3696,8 @@ static int _annotate_rewrite(struct mail
     rrock.newuid = newuid;
     rrock.copy = copy;
 
-    return annotatemore_findall(oldmailbox->name, olduid, "*", &rename_cb, &rrock);
+    return annotatemore_findall(oldmailbox->name, olduid, "*", /*modseq*/0,
+                                &rename_cb, &rrock, /*flags*/0);
 }
 
 EXPORTED int annotate_delete_mailbox(struct mailbox *mailbox)
@@ -3306,6 +3706,8 @@ EXPORTED int annotate_delete_mailbox(str
     char *fname = NULL;
     annotate_db_t *d = NULL;
 
+    init_internal();
+
     assert(mailbox);
 
     /* remove any per-folder annotations from the global db */
@@ -3350,6 +3752,8 @@ EXPORTED int annotate_msg_copy(struct ma
     annotate_db_t *d = NULL;
     int r;
 
+    init_internal();
+
     r = _annotate_getdb(newmailbox->name, newuid, CYRUSDB_CREATE, &d);
     if (r) return r;
 
@@ -3628,7 +4032,7 @@ static void init_annotation_definitions(
         tok_initm(&state.tok, aline, ",", TOK_TRIMLEFT|TOK_TRIMRIGHT|TOK_EMPTY);
 
         /* note, we only do the most basic validity checking and may
-           be more restrictive than neccessary */
+           be more restrictive than necessary */
 
         ae = xzmalloc(sizeof(*ae));
 
diff -pruN 3.0.13-5/imap/annotate.h 3.2.0-3/imap/annotate.h
--- 3.0.13-5/imap/annotate.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/annotate.h	2020-04-24 02:03:00.000000000 +0000
@@ -79,6 +79,14 @@ struct entryattlist {
     struct entryattlist *next;
 };
 
+#define ANNOTATE_FLAG_DELETED (1<<0)
+
+struct annotate_metadata
+{
+    modseq_t modseq;
+    unsigned char flags; /* read-only */
+};
+
 typedef struct annotate_state annotate_state_t;
 typedef struct annotate_recalc_state annotate_recalc_state_t;
 
@@ -121,6 +129,7 @@ void clearentryatt(struct entryattlist *
 void dupentryatt(struct entryattlist **l,
                  const struct entryattlist *);
 size_t sizeentryatts(const struct entryattlist *);
+char *dumpentryatt(const struct entryattlist *l);
 void freeentryatts(struct entryattlist *l);
 
 /* initialize database structures */
@@ -136,13 +145,22 @@ void annotatemore_open(void);
 typedef int (*annotatemore_find_proc_t)(const char *mailbox,
                     uint32_t uid,
                     const char *entry, const char *userid,
-                    const struct buf *value, void *rock);
+                    const struct buf *value,
+                    const struct annotate_metadata *mdata,
+                    void *rock);
 
 /* For findall(), matches any non-zero uid */
 #define ANNOTATE_ANY_UID    ((unsigned int)~0)
+
+/* For findall() matches also tombstones */
+#define ANNOTATE_TOMBSTONES  (1<<0)
+
 /* 'proc'ess all annotations matching 'mailbox' and 'entry' */
-int annotatemore_findall(const char *mboxname, uint32_t uid, const char *entry,
-                         annotatemore_find_proc_t proc, void *rock);
+int annotatemore_findall(const char *mboxname, uint32_t uid,
+                         const char *entry,
+                         modseq_t since_modseq,
+                         annotatemore_find_proc_t proc, void *rock,
+                         int flags);
 
 /* fetch annotations and output results */
 typedef void (*annotate_fetch_cb_t)(const char *mboxname, /* internal */
@@ -157,7 +175,8 @@ int annotate_state_fetch(annotate_state_
 /* write a single annotation, avoiding all ACL checks and etc */
 int annotatemore_write(const char *mboxname, const char *entry,
                        const char *userid, const struct buf *value);
-int annotatemore_msg_write(const char *mboxname, uint32_t uid, const char *entry,
+/* same but write to shared if the user own the mailbox */
+int annotatemore_writemask(const char *mboxname, const char *entry,
                            const char *userid, const struct buf *value);
 /* flat out ignore modseq and quota and everything */
 int annotatemore_rawwrite(const char *mboxname, const char *entry,
@@ -187,6 +206,13 @@ int annotate_state_write(annotate_state_
 /* same but write to shared if the user owns the mailbox */
 int annotate_state_writemask(annotate_state_t *, const char *entry,
                              const char *userid, const struct buf *value);
+/* same but call mailbox_annot_changed with the silent flag set */
+int annotate_state_writesilent(annotate_state_t *, const char *entry,
+                               const char *userid, const struct buf *value);
+/* same but set annotation metadata (flags field is ignored) */
+int annotate_state_writemdata(annotate_state_t *state, const char *entry,
+                              const char *userid, const struct buf *value,
+                              const struct annotate_metadata *mdata);
 
 /* rename the annotations for 'oldmboxname' to 'newmboxname'
  * if 'olduserid' is non-NULL then the private annotations
@@ -252,6 +278,7 @@ int annotate_getdb(const char *mboxname,
 void annotate_putdb(annotate_db_t **dbp);
 
 /* Maybe this isn't the right place - move later */
-int specialuse_validate(const char *userid, const char *src, struct buf *dest);
+int specialuse_validate(const char *mboxname, const char *userid,
+                        const char *src, struct buf *dest);
 
 #endif /* ANNOTATE_H */
diff -pruN 3.0.13-5/imap/append.c 3.2.0-3/imap/append.c
--- 3.0.13-5/imap/append.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/append.c	2020-05-04 03:28:02.000000000 +0000
@@ -60,6 +60,7 @@
 #include "mailbox.h"
 #include "notify.h"
 #include "message.h"
+#include "msgrecord.h"
 #include "append.h"
 #include "global.h"
 #include "prot.h"
@@ -94,9 +95,7 @@ struct stagemsg {
 
 static int append_addseen(struct mailbox *mailbox, const char *userid,
                           struct seqset *newseen);
-static void append_setseen(struct appendstate *as, struct index_record *record);
-
-#define zero_index(i) { memset(&i, 0, sizeof(struct index_record)); }
+static int append_setseen(struct appendstate *as, msgrecord_t *mr);
 
 /*
  * Check to see if mailbox can be appended to
@@ -164,7 +163,10 @@ EXPORTED int append_setup(struct appends
     struct mailbox *mailbox = NULL;
 
     r = mailbox_open_iwl(name, &mailbox);
-    if (r) return r;
+    if (r) {
+        memset(as, 0, sizeof(*as));
+        return r;
+    }
 
     r = append_setup_mbox(as, mailbox, userid, auth_state,
                           aclcheck, quotacheck, namespace, isadmin, event_type);
@@ -226,10 +228,6 @@ EXPORTED int append_setup_mbox(struct ap
 
     as->mailbox = mailbox;
 
-    if (config_getswitch(IMAPOPT_OUTBOX_SENDLATER)) {
-        as->isoutbox = mboxname_isoutbox(mailbox->name);
-    }
-
     return 0;
 }
 
@@ -295,10 +293,18 @@ EXPORTED int append_commit(struct append
 /* may return non-zero, indicating an internal error of some sort. */
 EXPORTED int append_abort(struct appendstate *as)
 {
+    int i, r = 0;
     if (as->s == APPEND_DONE) return 0;
+
+    // nuke any files that we've created
+    for (i = 0; i < as->nummsg; i++) {
+        mailbox_cleanup_uid(as->mailbox, as->baseuid + i, "ZZ");
+    }
+
+    if (as->mailbox) r = mailbox_abort(as->mailbox);
     append_free(as);
 
-    return 0;
+    return r;
 }
 
 /*
@@ -306,8 +312,8 @@ EXPORTED int append_abort(struct appends
  * with the file for the given mailboxname and returns the open file
  * so it can double as the spool file
  */
-EXPORTED FILE *append_newstage(const char *mailboxname, time_t internaldate,
-                      int msgnum, struct stagemsg **stagep)
+EXPORTED FILE *append_newstage_full(const char *mailboxname, time_t internaldate,
+                      int msgnum, struct stagemsg **stagep, const char *sourcefile)
 {
     struct stagemsg *stage;
     char stagedir[MAX_MAILBOX_PATH+1], stagefile[MAX_MAILBOX_PATH+1];
@@ -337,7 +343,19 @@ EXPORTED FILE *append_newstage(const cha
 
     /* create this file and put it into stage->parts[0] */
     unlink(stagefile);
-    f = fopen(stagefile, "w+");
+    if (sourcefile) {
+        r = mailbox_copyfile(sourcefile, stagefile, 0);
+        if (r) {
+            syslog(LOG_ERR, "couldn't copy stagefile '%s' for mbox: '%s': %s",
+                   sourcefile, mailboxname, error_message(r));
+            free(stage);
+            return NULL;
+        }
+        f = fopen(stagefile, "r+");
+    }
+    else {
+        f = fopen(stagefile, "w+");
+    }
     if (!f) {
         if (mkdir(stagedir, 0755) != 0) {
             syslog(LOG_ERR, "couldn't create stage directory: %s: %m",
@@ -452,7 +470,7 @@ static int callout_run_socket(const char
 
     memset(&mysun, 0, sizeof(mysun));
     mysun.sun_family = AF_UNIX;
-    strncpy(mysun.sun_path, callout, sizeof(mysun.sun_path));
+    xstrncpy(mysun.sun_path, callout, sizeof(mysun.sun_path));
     r = connect(sock, (struct sockaddr *)&mysun, sizeof(mysun));
     if (r < 0) {
         syslog(LOG_ERR, "cannot connect socket for callout: %m");
@@ -509,11 +527,11 @@ static int callout_run_executable(const
         /* child process */
 
         close(inpipe[PIPE_WRITE]);
-        dup2(inpipe[PIPE_READ], /*FILENO_STDIN*/0);
+        dup2(inpipe[PIPE_READ], STDIN_FILENO);
         close(inpipe[PIPE_READ]);
 
         close(outpipe[PIPE_READ]);
-        dup2(outpipe[PIPE_WRITE], /*FILENO_STDOUT*/1);
+        dup2(outpipe[PIPE_WRITE], STDOUT_FILENO);
         close(outpipe[PIPE_WRITE]);
 
         execl(callout, callout, (char *)NULL);
@@ -776,10 +794,11 @@ out:
 
 static int append_apply_flags(struct appendstate *as,
                               struct mboxevent *mboxevent,
-                              struct index_record *record,
+                              msgrecord_t *msgrec,
                               const strarray_t *flags)
 {
     int userflag;
+    uint32_t system_flags = 0, internal_flags = 0;
     int i, r = 0;
 
     assert(flags);
@@ -787,47 +806,61 @@ static int append_apply_flags(struct app
     for (i = 0; i < flags->count; i++) {
         const char *flag = strarray_nth(flags, i);
         if (!strcasecmp(flag, "\\seen")) {
-            append_setseen(as, record);
+            r = append_setseen(as, msgrec);
+            if (r) goto out;
             mboxevent_add_flag(mboxevent, flag);
         }
         else if (!strcasecmp(flag, "\\expunged")) {
             /* NOTE - this is a fake internal name */
             if (as->myrights & ACL_DELETEMSG) {
-                record->system_flags |= FLAG_EXPUNGED;
+                internal_flags |= FLAG_INTERNAL_EXPUNGED;
+            }
+        }
+        else if (!strcasecmp(flag, "\\snoozed")) {
+            /* NOTE - this is a fake internal name */
+            if (as->myrights & ACL_WRITE) {
+                internal_flags |= FLAG_INTERNAL_SNOOZED;
             }
         }
         else if (!strcasecmp(flag, "\\deleted")) {
             if (as->myrights & ACL_DELETEMSG) {
-                record->system_flags |= FLAG_DELETED;
+                system_flags |= FLAG_DELETED;
                 mboxevent_add_flag(mboxevent, flag);
             }
         }
         else if (!strcasecmp(flag, "\\draft")) {
             if (as->myrights & ACL_WRITE) {
-                record->system_flags |= FLAG_DRAFT;
+                system_flags |= FLAG_DRAFT;
                 mboxevent_add_flag(mboxevent, flag);
             }
         }
         else if (!strcasecmp(flag, "\\flagged")) {
             if (as->myrights & ACL_WRITE) {
-                record->system_flags |= FLAG_FLAGGED;
+                system_flags |= FLAG_FLAGGED;
                 mboxevent_add_flag(mboxevent, flag);
             }
         }
         else if (!strcasecmp(flag, "\\answered")) {
             if (as->myrights & ACL_WRITE) {
-                record->system_flags |= FLAG_ANSWERED;
+                system_flags |= FLAG_ANSWERED;
                 mboxevent_add_flag(mboxevent, flag);
             }
         }
         else if (as->myrights & ACL_WRITE) {
             r = mailbox_user_flag(as->mailbox, flag, &userflag, 1);
             if (r) goto out;
-            record->user_flags[userflag/32] |= 1<<(userflag&31);
+            r = msgrecord_set_userflag(msgrec, userflag, 1);
+            if (r) goto out;
             mboxevent_add_flag(mboxevent, flag);
         }
     }
 
+    r = msgrecord_add_systemflags(msgrec, system_flags);
+    if (r) goto out;
+
+    r = msgrecord_add_internalflags(msgrec, internal_flags);
+    if (r) goto out;
+
 out:
     return r;
 }
@@ -839,13 +872,15 @@ out:
  * Note: @user_annots needs to be freed by the caller but
  * may be modified during processing of callout responses.
  */
-EXPORTED int append_fromstage(struct appendstate *as, struct body **body,
-                     struct stagemsg *stage, time_t internaldate,
-                     const strarray_t *flags, int nolink,
-                     struct entryattlist *user_annots)
+EXPORTED int append_fromstage_full(struct appendstate *as, struct body **body,
+                                   struct stagemsg *stage,
+                                   time_t internaldate, time_t savedate,
+                                   modseq_t createdmodseq,
+                                   const strarray_t *flags, int nolink,
+                                   struct entryattlist *user_annots)
 {
     struct mailbox *mailbox = as->mailbox;
-    struct index_record record;
+    msgrecord_t *msgrec = NULL;
     const char *fname;
     int i, r;
     strarray_t *newflags = NULL;
@@ -864,7 +899,7 @@ EXPORTED int append_fromstage(struct app
     if (!*body) {
         FILE *file = fopen(stage->parts.data[0], "r");
         if (file) {
-            r = message_parse_file(file, NULL, NULL, body);
+            r = message_parse_file(file, NULL, NULL, body, stage->parts.data[0]);
             fclose(file);
         }
         else
@@ -872,8 +907,6 @@ EXPORTED int append_fromstage(struct app
         if (r) goto out;
     }
 
-    zero_index(record);
-
     /* xxx check errors */
     mboxlist_findstage(mailbox->name, stagefile, sizeof(stagefile));
     strlcat(stagefile, stage->fname, sizeof(stagefile));
@@ -922,8 +955,6 @@ EXPORTED int append_fromstage(struct app
        as the mailbox we're looking at */
 
     /* Setup */
-    record.uid = as->baseuid + as->nummsg;
-    record.internaldate = internaldate;
 
     /* prepare a new notification for this appended message
      * the event type must be set with MessageNew or MessageAppend */
@@ -931,21 +962,46 @@ EXPORTED int append_fromstage(struct app
         mboxevent = mboxevent_enqueue(as->event_type, &as->mboxevents);
     }
 
+    uint32_t uid = as->baseuid + as->nummsg;
+
     /* we need to parse the record first */
-    r = message_create_record(&record, *body);
+    msgrec = msgrecord_new(mailbox);
+    r = msgrecord_set_uid(msgrec, uid);
+    if (r) goto out;
+    r = msgrecord_set_internaldate(msgrec, internaldate);
     if (r) goto out;
+    r = msgrecord_set_createdmodseq(msgrec, createdmodseq);
+    if (r) goto out;
+    r = msgrecord_set_bodystructure(msgrec, *body);
+    if (r) goto out;
+    if (savedate) {
+        r = msgrecord_set_savedate(msgrec, savedate);
+        if (r) goto out;
+    }
 
     /* And make sure it has a timestamp */
-    if (!record.internaldate)
-        record.internaldate = time(NULL);
+    r = msgrecord_get_internaldate(msgrec, &internaldate);
+    if (!r && !internaldate)
+        r = msgrecord_set_internaldate(msgrec, time(NULL));
+    if (r) goto out;
 
     /* should we archive it straight away? */
-    if (mailbox_should_archive(mailbox, &record, NULL))
-        record.system_flags |= FLAG_ARCHIVED;
+    if (msgrecord_should_archive(msgrec, NULL)) {
+        r = msgrecord_add_internalflags(msgrec, FLAG_INTERNAL_ARCHIVED);
+        if (r) goto out;
+    }
+
+    /* unlink BOTH potential destination files to clean up any past failure.
+     * This was added because we found that a small message was partially
+     * delivered and got uid X. - then later a large message was delivered
+     * with the same UID which went straight to archive, and the file with
+     * the same name was left lying around in the filesystem */
+    mailbox_cleanup_uid(mailbox, uid, "ZZ");
 
     /* Create message file */
     as->nummsg++;
-    fname = mailbox_record_fname(mailbox, &record);
+    r = msgrecord_get_fname(msgrec, &fname);
+    if (r) goto out;
 
     r = mailbox_copyfile(stagefile, fname, nolink);
     if (r) goto out;
@@ -978,39 +1034,45 @@ EXPORTED int append_fromstage(struct app
     /* straight to archive? */
     int in_object_storage = 0;
 #if defined ENABLE_OBJECTSTORE
-    if (object_storage_enabled && record.system_flags & FLAG_ARCHIVED)
+
+    if (object_storage_enabled)
     {
-        r = objectstore_put(mailbox, &record, fname);
-        if (!r) {
-            // file in object store now; must delete local copy
-            in_object_storage = 1;
-        }
-        else {
-            // didn't manage to store it, so remove the ARCHIVED flag
-            record.system_flags &= ~FLAG_ARCHIVED;
+        uint32_t internal_flags;
+        r = msgrecord_get_internalflags(msgrec, &internal_flags);
+        if (r) goto out;
+
+        if (internal_flags & FLAG_INTERNAL_ARCHIVED) {
+            struct index_record record;
+            r = msgrecord_get_index_record(msgrec, &record);
+            if (!r) {
+                r = objectstore_put(mailbox, &record, fname);
+                if (!r) {
+                    // file in object store now; must delete local copy
+                    in_object_storage = 1;
+                }
+                else {
+                    // didn't manage to store it, so remove the ARCHIVED flag
+                    internal_flags &= ~FLAG_INTERNAL_ARCHIVED;
+                    r = msgrecord_set_internalflags(msgrec, internal_flags);
+                    if (r) goto out;
+                }
+            }
         }
     }
 #endif
 
     /* Handle flags the user wants to set in the message */
     if (flags) {
-        r = append_apply_flags(as, mboxevent, &record, flags);
+        r = append_apply_flags(as, mboxevent, msgrec, flags);
         if (r) {
             syslog(LOG_ERR, "Annotation callout failed to apply flags %s", error_message(r));
             goto out;
         }
     }
 
-    if (as->isoutbox) {
-        char num[10];
-        snprintf(num, 10, "%u", record.uid);
-        r = notify_at(record.internaldate, "sendemail", "append", "", "", as->mailbox->name, 0, NULL, num);
-        if (r) goto out;
-    }
-
-    /* Write out index file entry */
-    r = mailbox_append_index_record(mailbox, &record);
-    if (r) goto out;
+    /* Write the new message record */
+    r = msgrecord_append(msgrec);
+    if (r) return r;
 
     if (in_object_storage) {  // must delete local file
         if (unlink(fname) != 0) // unlink should do it.
@@ -1018,49 +1080,48 @@ EXPORTED int append_fromstage(struct app
                 syslog(LOG_ERR, "Removing local file <%s> error \n", fname);
     }
 
-    /* Apply the annotations afterwards, so that the record already exists */
+    /* Apply the annotations */
     if (user_annots || system_annots) {
-        annotate_state_t *astate = NULL;
-        r = mailbox_get_annotate_state(as->mailbox, record.uid, &astate);
-        if (r) goto out;
+        /* pretend to be admin to avoid ACL checks when writing annotations here, since there calling user
+         * didn't control them */
         if (user_annots) {
-            annotate_state_set_auth(astate, as->isadmin,
-                                    as->userid, as->auth_state);
-            r = annotate_state_store(astate, user_annots);
+           r = msgrecord_annot_set_auth(msgrec, /*isadmin*/1, as->userid, as->auth_state);
+           if (!r) r = msgrecord_annot_writeall(msgrec, user_annots);
         }
         if (r) {
             syslog(LOG_ERR, "Annotation callout failed to apply user annots %s", error_message(r));
             goto out;
         }
         if (system_annots) {
-            /* pretend to be admin to avoid ACL checks */
-            annotate_state_set_auth(astate, /*isadmin*/1,
-                                    as->userid, as->auth_state);
-            r = annotate_state_store(astate, system_annots);
+           r = msgrecord_annot_set_auth(msgrec, /*isadmin*/1, as->userid, as->auth_state);
+           if (!r) r = msgrecord_annot_writeall(msgrec, system_annots);
         }
         if (r) {
             syslog(LOG_ERR, "Annotation callout failed to apply system annots %s", error_message(r));
             goto out;
         }
     }
+
 out:
     if (newflags)
         strarray_free(newflags);
     freeentryatts(system_annots);
     if (r) {
         append_abort(as);
+        if (msgrec) msgrecord_unref(&msgrec);
         return r;
     }
 
     /* finish filling the event notification */
     /* XXX avoid to parse ENVELOPE record since Message-Id is already
      * present in body structure ? */
-    mboxevent_extract_record(mboxevent, mailbox, &record);
+    mboxevent_extract_msgrecord(mboxevent, msgrec);
     mboxevent_extract_mailbox(mboxevent, mailbox);
     mboxevent_set_access(mboxevent, NULL, NULL, as->userid, as->mailbox->name, 1);
     mboxevent_set_numunseen(mboxevent, mailbox, -1);
 
-    return 0;
+    if (msgrec) msgrecord_unref(&msgrec);
+    return r;
 }
 
 EXPORTED int append_removestage(struct stagemsg *stage)
@@ -1103,21 +1164,24 @@ EXPORTED int append_fromstream(struct ap
                       const strarray_t *flags)
 {
     struct mailbox *mailbox = as->mailbox;
-    struct index_record record;
     const char *fname;
+    msgrecord_t *msgrec = NULL;
     FILE *destfile;
     int r;
     struct mboxevent *mboxevent = NULL;
 
     assert(size != 0);
 
-    zero_index(record);
     /* Setup */
-    record.uid = as->baseuid + as->nummsg;
-    record.internaldate = internaldate;
+    msgrec = msgrecord_new(mailbox);
+    r = msgrecord_set_uid(msgrec, as->baseuid + as->nummsg);
+    if (r) goto out;
+    r = msgrecord_set_internaldate(msgrec, internaldate);
+    if (r) goto out;
 
     /* Create message file */
-    fname = mailbox_record_fname(mailbox, &record);
+    r = msgrecord_get_fname(msgrec, &fname);
+    if (r) goto out;
     as->nummsg++;
 
     unlink(fname);
@@ -1140,25 +1204,25 @@ EXPORTED int append_fromstream(struct ap
     r = message_copy_strict(messagefile, destfile, size, 0);
     if (!r) {
         if (!*body || (as->nummsg - 1))
-            r = message_parse_file(destfile, NULL, NULL, body);
-        if (!r) r = message_create_record(&record, *body);
+            r = message_parse_file(destfile, NULL, NULL, body, fname);
+        if (!r) r = msgrecord_set_bodystructure(msgrec, *body);
 
         /* messageContent may be included with MessageAppend and MessageNew */
         if (!r)
-            mboxevent_extract_content(mboxevent, &record, destfile);
+            mboxevent_extract_content_msgrec(mboxevent, msgrec, destfile);
     }
     fclose(destfile);
     if (r) goto out;
 
     /* Handle flags the user wants to set in the message */
     if (flags) {
-        r = append_apply_flags(as, mboxevent, &record, flags);
+        r = append_apply_flags(as, mboxevent, msgrec, flags);
         if (r) goto out;
     }
 
     /* Write out index file entry; if we abort later, it's not
        important */
-    r = mailbox_append_index_record(mailbox, &record);
+    r = msgrecord_append(msgrec);
 
 out:
     if (r) {
@@ -1169,34 +1233,41 @@ out:
     /* finish filling the event notification */
     /* XXX avoid to parse ENVELOPE record since Message-Id is already
      * present in body structure */
-    mboxevent_extract_record(mboxevent, mailbox, &record);
+    mboxevent_extract_msgrecord(mboxevent, msgrec);
     mboxevent_extract_mailbox(mboxevent, mailbox);
     mboxevent_set_access(mboxevent, NULL, NULL, as->userid, as->mailbox->name, 1);
     mboxevent_set_numunseen(mboxevent, mailbox, -1);
+    msgrecord_unref(&msgrec);
 
     return 0;
 }
 
 HIDDEN int append_run_annotator(struct appendstate *as,
-                         struct index_record *record)
+                                msgrecord_t *msgrec)
 {
     FILE *f = NULL;
     const char *fname;
     struct entryattlist *user_annots = NULL;
     struct entryattlist *system_annots = NULL;
     strarray_t *flags = NULL;
-    annotate_state_t *astate = NULL;
     struct body *body = NULL;
     int r = 0;
 
     if (!config_getstring(IMAPOPT_ANNOTATION_CALLOUT))
         return 0;
 
-    flags = mailbox_extract_flags(as->mailbox, record, as->userid);
-    user_annots = mailbox_extract_annots(as->mailbox, record);
+    if (config_getswitch(IMAPOPT_ANNOTATION_CALLOUT_DISABLE_APPEND)) {
+        syslog(LOG_DEBUG, "append_run_annotator: Append disabled.");
+        return 0;
+    }
+
+    r = msgrecord_extract_flags(msgrec, as->userid, &flags);
+    if (r) goto out;
+    r = msgrecord_extract_annots(msgrec, &user_annots);
+    if (r) goto out;
 
-    fname = mailbox_record_fname(as->mailbox, record);
-    if (!fname) goto out;
+    r = msgrecord_get_fname(msgrec, &fname);
+    if (r) goto out;
 
     f = fopen(fname, "r");
     if (!f) {
@@ -1204,7 +1275,7 @@ HIDDEN int append_run_annotator(struct a
         goto out;
     }
 
-    r = message_parse_file(f, NULL, NULL, &body);
+    r = message_parse_file(f, NULL, NULL, &body, fname);
     if (r) goto out;
 
     fclose(f);
@@ -1213,9 +1284,23 @@ HIDDEN int append_run_annotator(struct a
     r = callout_run(fname, body, &user_annots, &system_annots, flags);
     if (r) goto out;
 
-    record->system_flags &= (FLAG_SEEN | FLAGS_INTERNAL);
-    memset(&record->user_flags, 0, sizeof(record->user_flags));
-    r = append_apply_flags(as, NULL, record, flags);
+    /* Reset system flags */
+    uint32_t system_flags;
+    r = msgrecord_get_systemflags(msgrec, &system_flags);
+    if (!r) {
+        system_flags &= (FLAG_SEEN);
+        r = msgrecord_set_systemflags(msgrec, system_flags);
+    }
+    if (r) goto out;
+
+    /* Reset user flags */
+    uint32_t user_flags[MAX_USER_FLAGS/32];
+    memset(user_flags, 0, sizeof(user_flags));
+    r = msgrecord_set_userflags(msgrec, user_flags);
+    if (r) goto out;
+
+    /* Apply annotator flags */
+    r = append_apply_flags(as, NULL, msgrec, flags);
     if (r) {
         syslog(LOG_ERR, "Setting flags from annotator "
                         "callout failed (%s)",
@@ -1223,32 +1308,23 @@ HIDDEN int append_run_annotator(struct a
         goto out;
     }
 
-    r = mailbox_get_annotate_state(as->mailbox, record->uid, &astate);
-    if (r) goto out;
-    if (user_annots) {
-        annotate_state_set_auth(astate, as->isadmin,
-                                as->userid, as->auth_state);
-        r = annotate_state_store(astate, user_annots);
-        if (r) {
-            syslog(LOG_ERR, "Setting user annnotations from annotator "
-                            "callout failed (%s)",
-                            error_message(r));
-            goto out;
-        }
-    }
     if (system_annots) {
         /* pretend to be admin to avoid ACL checks */
-        annotate_state_set_auth(astate, /*isadmin*/1,
-                                as->userid, as->auth_state);
-        r = annotate_state_store(astate, system_annots);
+        r = msgrecord_annot_set_auth(msgrec, /*isadmin*/1, as->userid, as->auth_state);
+        if (r) goto out;
+        r = msgrecord_annot_writeall(msgrec, system_annots);
         if (r) {
-            syslog(LOG_ERR, "Setting system annnotations from annotator "
-                            "callout failed (%s)",
-                            error_message(r));
+            char *res = dumpentryatt(system_annots);
+            syslog(LOG_ERR, "Setting system annotations from annotator "
+                            "callout failed (%s) for %s",
+                            error_message(r), res);
+            free(res);
             goto out;
         }
     }
 
+    r = msgrecord_rewrite(msgrec);
+
 out:
     if (f) fclose(f);
     freeentryatts(user_annots);
@@ -1269,11 +1345,9 @@ out:
  * contains the name of the user whose \Seen flag gets set.
  */
 EXPORTED int append_copy(struct mailbox *mailbox, struct appendstate *as,
-                         int nummsg, struct index_record *records,
-                         int nolink, int is_same_user)
+                         ptrarray_t *msgrecs, int nolink, int is_same_user)
 {
     int msg;
-    struct index_record record;
     char *srcfname = NULL;
     char *destfname = NULL;
     int object_storage_enabled = 0 ;
@@ -1283,10 +1357,10 @@ EXPORTED int append_copy(struct mailbox
     int r = 0;
     int userflag;
     int i;
-    annotate_state_t *astate = NULL;
     struct mboxevent *mboxevent = NULL;
+    msgrecord_t *dst_msgrec = NULL;
 
-    if (!nummsg) {
+    if (!msgrecs->count) {
         append_abort(as);
         return 0;
     }
@@ -1297,100 +1371,161 @@ EXPORTED int append_copy(struct mailbox
     }
 
     /* Copy/link all files and cache info */
-    for (msg = 0; msg < nummsg; msg++) {
+    for (msg = 0; msg < msgrecs->count; msg++) {
+        msgrecord_t *src_msgrec = ptrarray_nth(msgrecs, msg);
+        uint32_t src_uid;
+        uint32_t src_system_flags;
+        uint32_t src_internal_flags;
+
+        r = msgrecord_get_uid(src_msgrec, &src_uid);
+        if (r) goto out;
+        r = msgrecord_get_systemflags(src_msgrec, &src_system_flags);
+        if (r) goto out;
+        r = msgrecord_get_internalflags(src_msgrec, &src_internal_flags);
+        if (r) goto out;
         /* read in existing cache record BEFORE we copy data, so that the
          * mmap will be up to date even if it's the same mailbox for source
          * and destination */
-        r = mailbox_cacherecord(mailbox, &records[msg]);
+        r = msgrecord_load_cache(src_msgrec);
         if (r) goto out;
 
-        record = records[msg]; /* copy data */
-
         /* wipe out the bits that aren't magically copied */
-        record.system_flags &= ~FLAG_SEEN;
-        for (i = 0; i < MAX_USER_FLAGS/32; i++)
-            record.user_flags[i] = 0;
-        if (!is_same_user)
-            record.cid = NULLCONVERSATION;
-        record.cache_offset = 0;
+        uint32_t dst_system_flags, dst_internal_flags;
+        uint32_t dst_user_flags[MAX_USER_FLAGS/32];
+
+        dst_msgrec = msgrecord_copy_msgrecord(as->mailbox, src_msgrec);
+
+        /* clear savedate */
+        r = msgrecord_set_savedate(dst_msgrec, 0);
+        if (r) goto out;
+
+        r = msgrecord_get_systemflags(dst_msgrec, &dst_system_flags);
+        if (r) goto out;
+        dst_system_flags &= ~FLAG_SEEN;
+
+        r = msgrecord_get_internalflags(dst_msgrec, &dst_internal_flags);
+        if (r) goto out;
+        dst_internal_flags &= ~FLAG_INTERNAL_SNOOZED;
+
+        for (i = 0; i < MAX_USER_FLAGS/32; i++) {
+            dst_user_flags[i] = 0;
+        }
+        r = msgrecord_set_userflags(dst_msgrec, dst_user_flags);
+        if (r) goto out;
+
+        if (!is_same_user) {
+            r = msgrecord_set_cid(dst_msgrec, NULLCONVERSATION);
+            if (r) goto out;
+        }
+
+        r = msgrecord_set_cache_offset(dst_msgrec, 0);
+        if (r) goto out;
 
         /* renumber the message into the new mailbox */
-        record.uid = as->mailbox->i.last_uid + 1;
+        uint32_t dst_uid = as->mailbox->i.last_uid + 1;
+        r = msgrecord_set_uid(dst_msgrec, dst_uid);
+        if (r) goto out;
         as->nummsg++;
 
         /* user flags are special - different numbers, so look them up */
         if (as->myrights & ACL_WRITE) {
+            uint32_t src_user_flags[MAX_USER_FLAGS/32];
+
+            r = msgrecord_get_userflags(src_msgrec, src_user_flags);
+            if (r) goto out;
+
             for (userflag = 0; userflag < MAX_USER_FLAGS; userflag++) {
-                bit32 flagmask = records[msg].user_flags[userflag/32];
+                bit32 flagmask = src_user_flags[userflag/32];
                 if (mailbox->flagname[userflag] && (flagmask & (1<<(userflag&31)))) {
                     int num;
                     r = mailbox_user_flag(as->mailbox, mailbox->flagname[userflag], &num, 1);
                     if (r)
                         syslog(LOG_ERR, "IOERROR: unable to copy flag %s from %s to %s for UID %u: %s",
                                mailbox->flagname[userflag], mailbox->name, as->mailbox->name,
-                               records[msg].uid, error_message(r));
+                               src_uid, error_message(r));
                     else
-                        record.user_flags[num/32] |= 1<<(num&31);
+                        dst_user_flags[num/32] |= 1<<(num&31);
                 }
             }
+
+            r = msgrecord_set_userflags(dst_msgrec, dst_user_flags);
+            if (r) {
+                syslog(LOG_ERR, "IOERROR: unable to copy user flags from %s to %s for UID %u: %s",
+                        mailbox->name, as->mailbox->name, src_uid, error_message(r));
+            }
         }
         else {
             /* only flag allow to be kept without ACL_WRITE is DELETED */
-            record.system_flags &= FLAG_DELETED;
+            dst_system_flags &= FLAG_DELETED;
         }
 
         /* deleted flag has its own ACL */
         if (!(as->myrights & ACL_DELETEMSG)) {
-            record.system_flags &= ~FLAG_DELETED;
+            dst_system_flags &= ~FLAG_DELETED;
         }
 
+        /* we're not modifying the ARCHIVED flag here, just keeping it */
+
+        /* set system flags */
+        r = msgrecord_set_systemflags(dst_msgrec, dst_system_flags);
+        if (r) goto out;
+
+        /* set internal flags */
+        r = msgrecord_set_internalflags(dst_msgrec, dst_internal_flags);
+        if (r) goto out;
+
         /* should this message be marked \Seen? */
-        if (records[msg].system_flags & FLAG_SEEN) {
-            append_setseen(as, &record);
+        if (src_system_flags & FLAG_SEEN) {
+            append_setseen(as, dst_msgrec);
         }
 
-        /* we're not modifying the ARCHIVED flag here, just keeping it */
-
         /* Link/copy message file */
         free(srcfname);
         free(destfname);
-        srcfname = xstrdup(mailbox_record_fname(mailbox, &records[msg]));
-        destfname = xstrdup(mailbox_record_fname(as->mailbox, &record));
 
-        if (!(object_storage_enabled && records[msg].system_flags & FLAG_ARCHIVED))   // if object storage do not move file
+        const char *tmp;
+        r = msgrecord_get_fname(src_msgrec, &tmp);
+        if (r) goto out;
+        srcfname = xstrdup(tmp);
+
+        r = msgrecord_get_fname(dst_msgrec, &tmp);
+        if (r) goto out;
+        destfname = xstrdup(tmp);
+
+        if (!(object_storage_enabled &&
+              src_internal_flags & FLAG_INTERNAL_ARCHIVED))   // if object storage do not move file
            r = mailbox_copyfile(srcfname, destfname, nolink);
 
         if (r) goto out;
 
 #if defined ENABLE_OBJECTSTORE
-        if (object_storage_enabled && records[msg].system_flags & FLAG_ARCHIVED)
-            r = objectstore_put(as->mailbox, &record, destfname);   // put should just add the refcount.
-#endif
-
-        if (as->isoutbox) {
-            char num[10];
-            snprintf(num, 10, "%u", record.uid);
-            r = notify_at(record.internaldate, "sendemail", "append", "", "", as->mailbox->name, 0, NULL, num);
-            if (r) goto out;
+        if (object_storage_enabled &&
+            src_internal_flags & FLAG_INTERNAL_ARCHIVED) {
+            struct index_record record;
+            r = msgrecord_get_index_record(dst_msgrec, &record);
+            if (!r) r = objectstore_put(as->mailbox, &record, destfname);   // put should just add the refcount.
         }
+#endif
 
         /* Write out index file entry */
-        r = mailbox_append_index_record(as->mailbox, &record);
+        r = msgrecord_append(dst_msgrec);
         if (r) goto out;
 
         /* ensure we have an astate connected to the destination
          * mailbox, so that the annotation txn will be committed
          * when we close the mailbox */
-        r = mailbox_get_annotate_state(as->mailbox, record.uid, &astate);
+        annotate_state_t *astate = NULL;
+        r = mailbox_get_annotate_state(as->mailbox, dst_uid, &astate);
         if (r) goto out;
-
-        r = annotate_msg_copy(mailbox, records[msg].uid,
-                              as->mailbox, record.uid,
+        r = annotate_msg_copy(mailbox, src_uid,
+                              as->mailbox, dst_uid,
                               as->userid);
         if (r) goto out;
 
-        mboxevent_extract_record(mboxevent, as->mailbox, &record);
-        mboxevent_extract_copied_record(mboxevent, mailbox, &records[msg]);
+        mboxevent_extract_msgrecord(mboxevent, dst_msgrec);
+        mboxevent_extract_copied_msgrecord(mboxevent, src_msgrec);
+
+        msgrecord_unref(&dst_msgrec);
     }
 
 out:
@@ -1400,6 +1535,9 @@ out:
         append_abort(as);
         return r;
     }
+    if (dst_msgrec) {
+        msgrecord_unref(&dst_msgrec);
+    }
 
     mboxevent_extract_mailbox(mboxevent, as->mailbox);
     mboxevent_set_access(mboxevent, NULL, NULL, as->userid, as->mailbox->name, 1);
@@ -1408,12 +1546,18 @@ out:
     return 0;
 }
 
-static void append_setseen(struct appendstate *as, struct index_record *record)
+static int append_setseen(struct appendstate *as, msgrecord_t *msgrec)
 {
-    if (as->internalseen)
-        record->system_flags |= FLAG_SEEN;
-    else
-        seqset_add(as->seen_seq, record->uid, 1);
+    int r = 0;
+    if (as->internalseen) {
+        r = msgrecord_add_systemflags(msgrec, FLAG_SEEN);
+    }
+    else {
+        uint32_t uid;
+        r = msgrecord_get_uid(msgrec, &uid);
+        if (!r) seqset_add(as->seen_seq, uid, 1);
+    }
+    return r;
 }
 
 /*
@@ -1434,10 +1578,17 @@ static int append_addseen(struct mailbox
         return 0;
 
     r = seen_open(userid, SEEN_CREATE, &seendb);
-    if (r) goto done;
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: append_addseen failed to open DB for %s", userid);
+        goto done;
+    }
 
     r = seen_lockread(seendb, mailbox->uniqueid, &sd);
-    if (r) goto done;
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: append_addseen failed to read old value for %s/%s",
+               userid, mailbox->uniqueid);
+        goto done;
+    }
 
     /* parse the old sequence */
     oldseen = seqset_parse(sd.seenuids, NULL, mailbox->i.last_uid);
@@ -1451,6 +1602,10 @@ static int append_addseen(struct mailbox
     /* and write it out */
     sd.lastchange = time(NULL);
     r = seen_write(seendb, mailbox->uniqueid, &sd);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: append_addseen failed to write new value for %s/%s",
+               userid, mailbox->uniqueid);
+    }
     seen_freedata(&sd);
 
  done:
diff -pruN 3.0.13-5/imap/append.h 3.2.0-3/imap/append.h
--- 3.0.13-5/imap/append.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/append.h	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,6 @@ struct appendstate {
     struct mailbox *mailbox;
     /* do we own it? */
     int close_mailbox_when_done:1;
-    int isoutbox:1;
     int myrights;
     char userid[MAX_MAILBOX_BUFFER];
 
@@ -113,14 +112,20 @@ extern int append_commit(struct appendst
 extern int append_abort(struct appendstate *as);
 
 /* creates a new stage and returns stage file corresponding to mailboxname */
-extern FILE *append_newstage(const char *mailboxname, time_t internaldate,
-                             int msgnum, struct stagemsg **stagep);
+extern FILE *append_newstage_full(const char *mailboxname, time_t internaldate,
+                                  int msgnum, struct stagemsg **stagep,
+                                  const char *sourcefile);
+#define append_newstage(m, i, n, s) append_newstage_full((m), (i), (n), (s), NULL)
 
 /* adds a new mailbox to the stage initially created by append_newstage() */
-extern int append_fromstage(struct appendstate *mailbox, struct body **body,
-                            struct stagemsg *stage, time_t internaldate,
-                            const strarray_t *flags, int nolink,
-                            struct entryattlist *annotations);
+extern int append_fromstage_full(struct appendstate *mailbox, struct body **body,
+                                 struct stagemsg *stage,
+                                 time_t internaldate, time_t savedate,
+                                 modseq_t createdmodseq,
+                                 const strarray_t *flags, int nolink,
+                                 struct entryattlist *annotations);
+#define append_fromstage(m, b, s, i, c, f, n, a) \
+  append_fromstage_full((m), (b), (s), (i), 0, (c), (f), (n), (a))
 
 /* removes the stage (frees memory, deletes the staging files) */
 extern int append_removestage(struct stagemsg *stage);
@@ -132,7 +137,7 @@ extern int append_fromstream(struct appe
 
 extern int append_copy(struct mailbox *mailbox,
                        struct appendstate *append_mailbox,
-                       int nummsg, struct index_record *records,
+                       ptrarray_t *msgrecs,
                        int nolink, int is_same_user);
 
 extern int append_collectnews(struct appendstate *mailbox,
@@ -142,7 +147,7 @@ extern int append_collectnews(struct app
 #define append_getlastuid(as) ((as)->m.last_uid)
 
 extern int append_run_annotator(struct appendstate *as,
-                                struct index_record *record);
+                                msgrecord_t *msgrec);
 
 extern const char *append_stagefname(struct stagemsg *stage);
 
diff -pruN 3.0.13-5/imap/arbitron.c 3.2.0-3/imap/arbitron.c
--- 3.0.13-5/imap/arbitron.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/arbitron.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,13 +49,13 @@
 #include <stdio.h>
 #include <string.h>
 #include <dirent.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
 #include <sys/stat.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "hash.h"
 #include "mailbox.h"
 #include "mpool.h"
@@ -185,13 +185,10 @@ int main(int argc,char **argv)
     /* Init Cyrus Backend Foo */
     cyrus_init(alt_config, "arbitron", 0, 0);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&arb_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     if (optind != argc) strlcpy(pattern, argv[optind], sizeof(pattern));
@@ -227,8 +224,6 @@ int main(int argc,char **argv)
     free_hash_table(&mailbox_table, NULL);
     free_hash_table(&mboxname_table, NULL);
     free_mpool(arb_pool);
-    mboxlist_close();
-    mboxlist_done();
 
     cyrus_done();
 
@@ -241,12 +236,13 @@ static void usage(void)
             "usage: arbitron [-o] [-u] [-l] [-C alt_config] "
             "[-d days | -D mmddyyy[:mmddyyyy]]\n"
             "                [-p months] [mboxpattern]\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static int do_mailbox(struct findall_data *data, void *rock __attribute__((unused)))
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
     int r;
     struct mailbox *mailbox = NULL;
     const char *name = mbname_intname(data->mbname);
@@ -272,8 +268,8 @@ static int do_mailbox(struct findall_dat
 
 static void run_users(void)
 {
-    char prefix[MAX_MAILBOX_PATH+1],path[MAX_MAILBOX_PATH+1],
-        file[MAX_MAILBOX_PATH+1];
+    char prefix[MAX_MAILBOX_PATH+1],path[2*MAX_MAILBOX_PATH+1],
+        file[3*MAX_MAILBOX_PATH+1];
     DIR *dirp, *dirq;
     struct dirent *dirent1, *dirent2;
 
@@ -281,7 +277,7 @@ static void run_users(void)
 
     dirp = opendir(prefix);
     if(!dirp) {
-        fatal("can't open user directory", EC_SOFTWARE);
+        fatal("can't open user directory", EX_SOFTWARE);
     }
 
     while((dirent1 = readdir(dirp)) != NULL) {
diff -pruN 3.0.13-5/imap/autocreate.c 3.2.0-3/imap/autocreate.c
--- 3.0.13-5/imap/autocreate.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/autocreate.c	2020-04-24 02:03:00.000000000 +0000
@@ -59,6 +59,7 @@
 #include <syslog.h>
 
 #include "global.h"
+#include "acl.h"
 #include "annotate.h"
 #include "util.h"
 #include "user.h"
@@ -93,88 +94,167 @@ static const char *get_script_name(const
         return p + 1;
 }
 
+enum SieveFileType {
+    SIEVE_TMP_1 = 0,
+    SIEVE_TMP_2,
+    SIEVE_BC_TMP,
+    SIEVE_SCRIPT,
+    SIEVE_BC_SCRIPT,
+    SIEVE_DEFAULT,
+    SIEVE_BC_LINK,
+    SIEVE_NUM_FILE_TYPES
+};
+static struct sieve_scripts_info {
+    enum SieveFileType stype;
+    char *ext;
+} sieve_names[] = {
+    {SIEVE_TMP_1, ".script.NEW"},
+    {SIEVE_TMP_2, ".NEW"},
+    {SIEVE_BC_TMP, ".bc.NEW"},
+    {SIEVE_SCRIPT, ".script"},
+    {SIEVE_BC_SCRIPT, ".bc"},
+    {SIEVE_DEFAULT, ""},
+    {SIEVE_BC_LINK, ".bc"}
+};
+
+struct sieve_scripts {
+    char tmpname1[MAX_FILENAME];
+    char tmpname2[MAX_FILENAME];
+    char bctmpname[MAX_FILENAME];
+    char scriptname[MAX_FILENAME];
+    char bcscriptname[MAX_FILENAME];
+    char defaultname[MAX_FILENAME];
+    char bclinkname[MAX_FILENAME];
+};
+
+/*
+ * Given the path to the sieve script directory `script_dir` and the sievename,
+ * generate filenames and return it in the `fnames` structure.
+ *
+ * On Success, returns 0, else returns 1
+ */
+static int setup_sieve_filenames(const char *script_dir, const char *sievename,
+                                 struct sieve_scripts *fnames)
+{
+    int r = 0, i;
+
+    for (i = 0; i < SIEVE_NUM_FILE_TYPES; i++) {
+        struct sieve_scripts_info *info = &sieve_names[i];
+        int ret = 0;
+        switch(info->stype) {
+            case SIEVE_TMP_1:
+                ret = snprintf(fnames->tmpname1, MAX_FILENAME, "%s/%s%s",
+                               script_dir, sievename, info->ext);
+                break;
+            case SIEVE_TMP_2:
+                ret = snprintf(fnames->tmpname2, MAX_FILENAME, "%s/%s%s",
+                               script_dir, sievename, info->ext);
+                break;
+            case SIEVE_BC_TMP:
+                ret = snprintf(fnames->bctmpname, MAX_FILENAME, "%s/%s%s",
+                               script_dir, sievename, info->ext);
+                break;
+            case SIEVE_SCRIPT:
+                ret = snprintf(fnames->scriptname, MAX_FILENAME, "%s/%s%s",
+                               script_dir, sievename, info->ext);
+                break;
+            case SIEVE_BC_SCRIPT:
+                ret = snprintf(fnames->bcscriptname, MAX_FILENAME, "%s/%s%s",
+                               script_dir, sievename, info->ext);
+                break;
+            case SIEVE_DEFAULT:
+                ret = snprintf(fnames->defaultname, MAX_FILENAME, "%s/%s%s",
+                               script_dir, "defaultbc", info->ext);
+                break;
+            case SIEVE_BC_LINK:
+                /*
+                  Note from ellie timoney:
+                  This is because a relative symlink target is relative to the
+                  location of the symlink, and since the defaultname symlink is
+                  being created in the appropriate directory, its target can't
+                  also specify the directory [otherwise you'd get like
+                  "user/f/foo/default" pointing to
+                  "[user/f/foo/]user/f/foo/somescript.bc" and things would fall
+                  apart :)]
+                 */
+                ret = snprintf(fnames->bclinkname, MAX_FILENAME, "%s%s",
+                               sievename, info->ext);
+                break;
+            default:
+                break;
+        }
+
+        if (ret < 0) {
+            r = 1;
+            break;
+        }
+    }
+
+    return r;
+}
+
 static int autocreate_sieve(const char *userid, const char *source_script)
 {
-    /* XXX - this is really ugly, but too much work to tidy up right now -- Bron */
     sieve_script_t *s = NULL;
     bytecode_info_t *bc = NULL;
     char *err = NULL;
-    FILE *in_stream, *out_fp;
-    int out_fd, in_fd, r, k;
+    FILE *in_stream = NULL, *out_fp;
+    int out_fd, in_fd, r, w;
     int do_compile = 0;
     const char *compiled_source_script = NULL;
     const char *sievename = get_script_name(source_script);
     const char *sieve_script_dir = NULL;
-    char sieve_script_name[MAX_FILENAME];
-    char sieve_bcscript_name[MAX_FILENAME];
-    char sieve_default[MAX_FILENAME];
-    char sieve_tmpname[MAX_FILENAME];
-    char sieve_bctmpname[MAX_FILENAME];
-    char sieve_bclink_name[MAX_FILENAME];
+    struct sieve_scripts script_names;
     char buf[4096];
     mode_t oldmask;
     struct stat statbuf;
 
-    /* We don't support using the homedirectory, like timsieved */
+    memset(&script_names, 0, sizeof(struct sieve_scripts));
+    /* We don't support using the home directory, like timsieved */
     if (config_getswitch(IMAPOPT_SIEVEUSEHOMEDIR)) {
-        syslog(LOG_WARNING,"autocreate_sieve: autocreate_sieve does not work with sieveusehomedir option in imapd.conf");
-        return 1;
+        syslog(LOG_ERR, "autocreate_sieve: does not work with sievehomeuserdir"
+               "option in imapd.conf");
+        goto failed_start;
     }
 
-    /* Check if sievedir is defined in imapd.conf */
-    if(!config_getstring(IMAPOPT_SIEVEDIR)) {
-        syslog(LOG_WARNING, "autocreate_sieve: sievedir option is not defined. Check imapd.conf");
-        return 1;
+    /* check if sievedir is defined in impad.conf */
+    if (!config_getstring(IMAPOPT_SIEVEDIR)) {
+        syslog(LOG_ERR, "autocreate_sieve: sievedir option is not defined in"
+               "imapd.conf");
+        goto failed_start;
     }
 
     /* Check if autocreate_sieve_compiledscript is defined in imapd.conf */
-    if(!(compiled_source_script = config_getstring(IMAPOPT_AUTOCREATE_SIEVE_SCRIPT_COMPILED))) {
-        syslog(LOG_WARNING, "autocreate_sieve: autocreate_sieve_compiledscript option is not defined. Compiling it");
+    compiled_source_script = config_getstring(IMAPOPT_AUTOCREATE_SIEVE_SCRIPT_COMPILED);
+    if (!compiled_source_script) {
+        syslog(LOG_WARNING, "autocreate_sieve: autocreate_sieve_compiledscript"
+               "option is not defined. Compiling it");
         do_compile = 1;
     }
 
-    if (!(sieve_script_dir = user_sieve_path(userid))) {
-        syslog(LOG_WARNING, "autocreate_sieve: unable to determine sieve directory for user %s", userid);
-        return 1;
+    sieve_script_dir = user_sieve_path(userid);
+    if (!sieve_script_dir) {
+        syslog(LOG_ERR, "autocreate_sieve: unable to determine sieve directory"
+               "for user %s", userid);
+        goto failed_start;
     }
 
-    if(snprintf(sieve_tmpname, MAX_FILENAME, "%s/%s.script.NEW",sieve_script_dir, sievename) >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
-    }
-    if(snprintf(sieve_bctmpname, MAX_FILENAME, "%s/%s.bc.NEW",sieve_script_dir, sievename) >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
-    }
-    if(snprintf(sieve_script_name, MAX_FILENAME, "%s/%s.script",sieve_script_dir, sievename) >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
-    }
-    if(snprintf(sieve_bcscript_name, MAX_FILENAME, "%s/%s.bc",sieve_script_dir, sievename) >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
-    }
-    if(snprintf(sieve_default, MAX_FILENAME, "%s/%s",sieve_script_dir,"defaultbc") >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
-    }
-    /* XXX no directory? umm */
-    if(snprintf(sieve_bclink_name, MAX_FILENAME, "%s.bc", sievename) >= MAX_FILENAME) {
-        syslog(LOG_WARNING, "autocreate_sieve: Invalid sieve path %s, %s, %s", sieve_script_dir, sievename, userid);
-        return 1;
+    if (setup_sieve_filenames(sieve_script_dir, sievename, &script_names) != 0) {
+        syslog(LOG_ERR, "autocreate_sieve: Invalid sieve path %s, %s, %s",
+               sieve_script_dir, sievename, userid);
+        goto failed_start;
     }
 
-    /* Check if a default sieve filter alrady exists */
-    if(!stat(sieve_default,&statbuf)) {
-        syslog(LOG_WARNING,"autocreate_sieve: Default sieve script already exists");
-        return 1;
+    /* Check if a default sieve filter already exists */
+    if (!stat(script_names.defaultname, &statbuf)) {
+        syslog(LOG_ERR, "autocreate_sieve: Default sieve script already exists");
+        goto failed_start;
     }
 
-    /* Open the source script. if there is a problem with that exit */
-    in_stream = fopen(source_script, "r");
-    if(!in_stream) {
-        syslog(LOG_WARNING,"autocreate_sieve: Unable to open sieve script %s. Check permissions",source_script);
-        return 1;
+    if (access(source_script, R_OK)) {
+        syslog(LOG_ERR, "autocreate_sieve: No read access permission to %s."
+               "Check permissions", source_script);
+        goto failed_start;
     }
 
     /*
@@ -182,241 +262,240 @@ static int autocreate_sieve(const char *
      */
 
     /* Create the directory where the sieve scripts will reside */
-    r = cyrus_mkdir(sieve_bctmpname, 0755);
-    if(r == -1) {
-        /* If this fails we just leave */
-        fclose(in_stream);
-        return 1;
-    }
+    r = cyrus_mkdir(script_names.bctmpname, 0755);
+    if (r == -1)
+        goto failed_start;
+
+    /*
+     * We open the file that will be used as the bc file. If this file exists,
+     * overwrite it since something bad has happened. We open the file here so
+     * that this error checking is done before we try to open the rest of the
+     * files to start copying etc.
+     */
+    out_fd = open(script_names.bctmpname,
+                  O_CREAT|O_TRUNC|O_WRONLY,
+                  S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
+    if (out_fd < 0 && errno != EEXIST) {
+        syslog(LOG_ERR, "autocreate_sieve: Error opening file %s :%m\n",
+               script_names.bctmpname);
+        goto failed_start;
+    }
+
+    /* Read the compiled script file */
+    if (!do_compile && compiled_source_script) {
+        if ((in_fd = open(compiled_source_script, O_RDONLY)) != -1) {
+            do {
+                r = read(in_fd, buf, sizeof(buf));
+                w = write(out_fd, buf, r);
+                if ( w < 0 || w != r) {
+                    syslog(LOG_ERR, "autocreate_sieve: Error writing to file"
+                           "%s: %m", script_names.bctmpname);
+                    goto failed2;
+                }
+            } while (r > 0);
 
-    /*
-     * We open the file that will be used as the bc file. If this file exists, overwrite it
-     * since something bad has happened. We open the file here so that this error checking is
-     * done before we try to open the rest of the files to start copying etc.
-     */
-    out_fd = open(sieve_bctmpname, O_CREAT|O_TRUNC|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
-    if(out_fd < 0) {
-        if(errno == EEXIST) {
-            syslog(LOG_WARNING,"autocreate_sieve: File %s already exists. Probably left over. Ignoring",sieve_bctmpname);
-        } else if (errno == EACCES) {
-            syslog(LOG_WARNING,"autocreate_sieve: No access to create file %s. Check permissions",sieve_bctmpname);
-            fclose(in_stream);
-            return 1;
-        } else {
-            syslog(LOG_WARNING,"autocreate_sieve: Unable to create %s: %m",sieve_bctmpname);
-            fclose(in_stream);
-            return 1;
-        }
-    }
-
-    if(!do_compile && compiled_source_script && (in_fd = open(compiled_source_script, O_RDONLY)) != -1) {
-        while((r = read(in_fd, buf, sizeof(buf))) > 0) {
-            if((k=write(out_fd, buf,r)) < 0) {
-                syslog(LOG_WARNING, "autocreate_sieve: Error writing to file %s: %m", sieve_bctmpname);
-                close(out_fd);
-                close(in_fd);
-                fclose(in_stream);
-                unlink(sieve_bctmpname);
-                return 1;
-           }
-        }
-
-        if(r == 0) { /* EOF */
-            xclose(out_fd);
-            xclose(in_fd);
-        } else if (r < 0) {
-            syslog(LOG_WARNING, "autocreate_sieve: Error reading compiled script file %s: %m. Will try to compile it",
+            if (r == 0) {       /* EOF */
+                xclose(out_fd);
+                xclose(in_fd);
+            } else if (r < 0) {
+                syslog(LOG_ERR, "autocreate_sieve: Error reading"
+                       "compiled script %s: %m\n", compiled_source_script);
+                xclose(in_fd);
+                do_compile = 1;
+                if (lseek(out_fd, 0, SEEK_SET)) {
+                    syslog(LOG_ERR, "autocreate_sieve: lseek failed with %s:%m",
                            compiled_source_script);
+                    goto failed1;
+                } /* if (lseek()) */
+            } /* if (r < 0) */
+
             xclose(in_fd);
-            do_compile = 1;
-            if(lseek(out_fd, 0, SEEK_SET)) {
-                syslog(LOG_WARNING, "autocreate_sieve: Major IO problem (lseek: %m). Aborting");
-                xclose(out_fd);
-                return 1;
-            }
-        }
-        xclose(in_fd);
+        } else
+            syslog(LOG_WARNING, "autocreate_sieve: Problem opening"
+                   "compiled script %s:%m", compiled_source_script);
     } else {
-        if(compiled_source_script)
-              syslog(LOG_WARNING,"autocreate_sieve: Problem opening compiled script file: %s. Compiling it", compiled_source_script);
         do_compile = 1;
-    }
-
+    } /* if (!do_compile && compiled_source_script) */
 
-    /* Because we failed to open a precompiled bc sieve script, we compile one */
-    if(do_compile) {
-       if(sieve_script_parse_only(in_stream,&err, &s) != SIEVE_OK) {
-            if(err && *err) {
-               syslog(LOG_WARNING,"autocreate_sieve: Error while parsing script %s.",err);
-               free(err);
-            } else
-                syslog(LOG_WARNING,"autocreate_sieve: Error while parsing script");
+    /*
+      We either failed to open a precompiled bc sieve script or
+      we need to compile on
+    */
+    if (do_compile) {
+        in_stream = fopen(source_script, "r");
+        if (!in_stream) {
+            syslog(LOG_ERR, "autocreate_sieve: Unable to open sieve script %s",
+                   source_script);
+            goto failed1;
+        }
+
+        if (sieve_script_parse_only(in_stream, &err, &s) != SIEVE_OK) {
+            syslog(LOG_ERR, "autosieve_create: Error parsing script %s:%m.",
+                   source_script);
+            if (err && *err) {
+                syslog(LOG_ERR, "autosieve_create: %s.", err);
+                free(err);
+            }
+            goto failed2;
+        } /* if (sieve_script_parse_only()) */
 
-            unlink(sieve_bctmpname);
+        /* Generate Bytecode */
+        if (sieve_generate_bytecode(&bc, s) == TIMSIEVE_FAIL) {
+            syslog(LOG_ERR, "autocreate_sieve: problem compiling sieve script.");
             fclose(in_stream);
-            close(out_fd);
-            return 1;
-        }
+            goto failed2;
+        } /* if (sieve_generate_bytecode()) */
 
-        /* generate the bytecode */
-        if(sieve_generate_bytecode(&bc, s) == TIMSIEVE_FAIL) {
-            syslog(LOG_WARNING,"autocreate_sieve: problem compiling sieve script");
-            /* removing the copied script and cleaning up memory */
-            unlink(sieve_bctmpname);
-            sieve_script_free(&s);
+        if (sieve_emit_bytecode(out_fd, bc) == TIMSIEVE_FAIL) {
+            syslog(LOG_ERR, "autocreate_sieve: problem emitting sieve script.");
             fclose(in_stream);
-            close(out_fd);
-            return 1;
-        }
-
-        if(sieve_emit_bytecode(out_fd, bc) == TIMSIEVE_FAIL) {
-            syslog(LOG_WARNING,"autocreate_sieve: problem emitting sieve script");
-            /* removing the copied script and cleaning up memory */
-            unlink(sieve_bctmpname);
             sieve_free_bytecode(&bc);
             sieve_script_free(&s);
-            fclose(in_stream);
-            close(out_fd);
-            return 1;
-        }
+            goto failed2;
+        } /* if (sieve_emit_bytecode()) */
 
-        /* clean up the memory */
         sieve_free_bytecode(&bc);
         sieve_script_free(&s);
-    }
+    } /* if (do_compile) */
 
     xclose(out_fd);
     rewind(in_stream);
 
-    /* Copy the initial script */
+    /* Copy the source script */
     oldmask = umask(077);
-    if((out_fp = fopen(sieve_tmpname, "w")) == NULL) {
-        syslog(LOG_WARNING,"autocreate_sieve: Unable to open destination sieve script %s: %m", sieve_tmpname);
-        unlink(sieve_bctmpname);
-        umask(oldmask);
+
+    if ((out_fp = fopen(script_names.tmpname1, "w")) == NULL) {
+        syslog(LOG_ERR, "autocreate_sieve: Unable to open destination sieve"
+               "script %s: %m", script_names.tmpname1);
         fclose(in_stream);
-        return 1;
+        umask(oldmask);
+        goto failed2;
     }
     umask(oldmask);
 
-    while((r = fread(buf,sizeof(char), sizeof(buf), in_stream)) > 0) {
-        if( fwrite(buf,sizeof(char), r, out_fp) != (unsigned)r) {
-            syslog(LOG_WARNING,"autocreate_sieve: Problem writing to sieve script file %s: %m",sieve_tmpname);
+    while ((r = fread(buf, sizeof(char), sizeof(buf), in_stream)) > 0) {
+        if (fwrite(buf, sizeof(char), r, out_fp) != (unsigned)r) {
+            syslog(LOG_ERR, "autocreate_sieve: Problem writing to sieve script"
+                   "%s:%m", script_names.tmpname1);
             fclose(out_fp);
-            unlink(sieve_tmpname);
-            unlink(sieve_bctmpname);
             fclose(in_stream);
-            return 1;
+            goto failed3;
         }
     }
 
-    if(feof(in_stream)) {
-        fclose(out_fp);
-        fclose(in_stream);
-    } else { /* ferror */
-        fclose(out_fp);
-        unlink(sieve_tmpname);
-        unlink(sieve_bctmpname);
-        fclose(in_stream);
-        return 1;
-    }
+    r = feof(in_stream);
+    fclose(in_stream);
+    fclose(out_fp);
+
+    if (!r)                     /* error */
+        goto failed3;
+
 
     /* Renaming the necessary stuff */
-    if(rename(sieve_tmpname, sieve_script_name)) {
-        unlink(sieve_tmpname);
-        unlink(sieve_bctmpname);
-        return 1;
+    if (rename(script_names.tmpname1, script_names.scriptname)) {
+        syslog(LOG_ERR, "autocreate_sieve: rename %s -> %s failed: %m",
+               script_names.tmpname1, script_names.scriptname);
+        goto failed3;
     }
 
-    if(rename(sieve_bctmpname, sieve_bcscript_name)) {
-        unlink(sieve_bctmpname);
-        unlink(sieve_bcscript_name);
-        return 1;
+    if (rename(script_names.bctmpname, script_names.bcscriptname)) {
+        syslog(LOG_ERR, "autocreate_sieve: rename %s -> %s failed: %m",
+               script_names.bctmpname, script_names.bcscriptname);
+        unlink(script_names.bcscriptname);
+        goto failed2;
     }
 
     /* end now with the symlink */
-    if(symlink(sieve_bclink_name, sieve_default)) {
-        if(errno != EEXIST) {
-            syslog(LOG_WARNING, "autocreate_sieve: problem making the default link (symlink: %m).");
-            /* Lets delete the files */
-            unlink(sieve_script_name);
-            unlink(sieve_bcscript_name);
+    if (symlink(script_names.bclinkname, script_names.defaultname)) {
+        if (errno != EEXIST) {
+            syslog(LOG_WARNING, "autocreate_sieve: error the symlink-ing %m.");
+            unlink(script_names.scriptname);
+            unlink(script_names.bcscriptname);
         }
     }
 
     /*
-     * If everything has succeeded AND we have compiled the script AND we have requested
-     * to generate the global script so that it is not compiled each time then we create it.
+     * If everything has succeeded AND we have compiled the script AND we have
+     * requested to generate the global script so that it is not compiled each
+     * time then we create it.
      */
-    if(do_compile &&
-          config_getswitch(IMAPOPT_AUTOCREATE_SIEVE_SCRIPT_COMPILE)) {
+    if (do_compile &&
+        config_getswitch(IMAPOPT_AUTOCREATE_SIEVE_SCRIPT_COMPILE)) {
 
-        if(!compiled_source_script) {
-            syslog(LOG_WARNING, "autocreate_sieve: To save a compiled sieve script, autocreate_sieve_compiledscript must have been defined in imapd.conf");
-            return 0;
-        }
-
-        if(snprintf(sieve_tmpname, MAX_FILENAME, "%s.NEW", compiled_source_script) >= MAX_FILENAME)
-            return 0;
+        if (!compiled_source_script) {
+            syslog(LOG_WARNING, "autocreate_sieve: To save a compiled sieve"
+                   "script, autocreate_sieve_compiledscript must have been"
+                   "defined in imapd.conf");
+            goto success;
+        } /* if (!compiled_source_script) */
 
         /*
          * Copy everything from the newly created bc sieve sieve script.
          */
-        if((in_fd = open(sieve_bcscript_name, O_RDONLY))<0) {
-            return 0;
-        }
-
-        if((out_fd = open(sieve_tmpname, O_CREAT|O_EXCL|O_WRONLY, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)) < 0) {
-            if(errno == EEXIST) {
-               /* Someone is already doing this so just bail out. */
-               syslog(LOG_WARNING, "autocreate_sieve: %s already exists. Some other instance processing it, or it is left over", sieve_tmpname);
-                close(in_fd);
-                return 0;
-            } else if (errno == EACCES) {
-                syslog(LOG_WARNING,"autocreate_sieve: No access to create file %s. Check permissions",sieve_tmpname);
-                close(in_fd);
-                return 0;
-            } else {
-                syslog(LOG_WARNING,"autocreate_sieve: Unable to create %s: %m",sieve_tmpname);
-                close(in_fd);
-                return 0;
-            }
+        if ((in_fd = open(script_names.bcscriptname, O_RDONLY)) < 0) {
+            syslog(LOG_WARNING, "autocreate_sieve: Failed to open %s:%m.",
+                   script_names.bcscriptname);
+            goto success;
+        } /* if (open()) */
+
+        out_fd = open(script_names.tmpname2,
+                      O_CREAT|O_EXCL|O_WRONLY,
+                      S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
+        if (out_fd < 0 && errno != EEXIST) {
+            syslog(LOG_ERR, "autocreate_sieve: Error opening file %s :%m\n",
+                   script_names.tmpname2);
+            xclose(in_fd);
+            goto success;
         }
 
-        while((r = read(in_fd, buf, sizeof(buf))) > 0) {
-            if((k = write(out_fd,buf,r)) < 0) {
-                syslog(LOG_WARNING, "autocreate_sieve: Error writing to file: %s: %m", sieve_tmpname);
-                close(out_fd);
-                close(in_fd);
-                unlink(sieve_tmpname);
-                return 0;
+        while ((r = read(in_fd, buf, sizeof(buf))) > 0) {
+            if ((w = write(out_fd,buf,r)) < 0) {
+                syslog(LOG_WARNING, "autocreate_sieve: Error writing to file:"
+                       "%s: %m", script_names.tmpname2);
+                xclose(out_fd);
+                xclose(in_fd);
+                unlink(script_names.tmpname2);
+                goto success;
            }
-        }
+        } /* while */
 
-        if(r == 0 ) { /*EOF */
+        if (r == 0) { /*EOF */
             xclose(out_fd);
             xclose(in_fd);
         } else if (r < 0) {
-                syslog(LOG_WARNING, "autocreate_sieve: Error reading file: %s: %m", sieve_bcscript_name);
+                syslog(LOG_WARNING, "autocreate_sieve: Error reading file:"
+                       "%s: %m", script_names.bcscriptname);
                 xclose(out_fd);
                 xclose(in_fd);
-                unlink(sieve_tmpname);
-                return 0;
-        }
+                unlink(script_names.tmpname2);
+                goto success;
+        } /* if else if */
 
-        /* Rename the temporary created sieve script to its final name. */
-        if(rename(sieve_tmpname, compiled_source_script)) {
-            if(errno != EEXIST) {
-               unlink(sieve_tmpname);
-               unlink(compiled_source_script);
-        }
-            return 0;
+        /* rename the temporary created sieve script to its final name. */
+        if (rename(script_names.tmpname2, compiled_source_script)) {
+            if (errno != EEXIST) {
+                unlink(script_names.tmpname2);
+                unlink(compiled_source_script);
+            } /* if (errno) */
+            goto success;
         }
 
-        syslog(LOG_NOTICE, "autocreate_sieve: Compiled sieve script was successfully saved in %s", compiled_source_script);
+        syslog(LOG_NOTICE, "autocreate_sieve: Compiled sieve script was"
+               "successfully saved in %s", compiled_source_script);
     }
 
+ success:
     return 0;
+
+ failed3:
+    unlink(script_names.tmpname1);
+ failed2:
+    unlink(script_names.bctmpname);
+    xclose(in_fd);
+ failed1:
+    xclose(out_fd);
+ failed_start:
+    return 1;
 }
 #endif /* USE_SIEVE */
 
@@ -438,6 +517,7 @@ struct changesub_rock_st {
 static int autochangesub(struct findall_data *data, void *rock)
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
     struct changesub_rock_st *crock = (struct changesub_rock_st *)rock;
     const char *userid = crock->userid;
     struct auth_state *auth_state = crock->auth_state;
@@ -490,7 +570,7 @@ static void autosubscribe_sharedfolders(
 
     /*
      * If subscribeallsharedfolders is set to yes in imapd.conf, then
-     * subscribe user to every shared folder one has the apropriate
+     * subscribe user to every shared folder one has the appropriate
      * permissions.
      */
     if (config_getswitch(IMAPOPT_AUTOCREATE_SUBSCRIBE_SHAREDFOLDERS_ALL)) {
@@ -559,8 +639,64 @@ static void autocreate_specialuse_cb(con
     buf_free(&usebuf);
 }
 
-int autocreate_user(struct namespace *namespace,
-                    const char *userid)
+struct autocreate_acl_rock {
+    struct namespace *namespace;
+    const char *intname;
+    const char *shortname;
+    struct auth_state *auth_state;
+    const char *userid;
+};
+
+static void autocreate_acl_cb(const char *key, const char *val, void *rock)
+{
+    char *freeme = NULL, *folder, *identifier, *rights, *junk;
+    char *err = NULL;
+    struct autocreate_acl_rock *acl_rock = (struct autocreate_acl_rock *) rock;
+    int r;
+
+    if (strcmp(key, "autocreate_acl")) return;
+
+    freeme = xstrdup(val);
+    folder = strtok(freeme, " ");
+    identifier = strtok(NULL, " ");
+    rights = strtok(NULL, " ");
+    junk = strtok(NULL, " ");
+
+    if (strcmpnull(folder, acl_rock->shortname)) goto done;
+
+    if (!folder || !identifier || !rights || junk) {
+        syslog(LOG_WARNING, "autocreate: ignoring invalid autocreate_acl: %s",
+                            val);
+        goto done;
+    }
+
+    r = cyrus_acl_checkstr(rights, &err);
+    if (r) {
+        syslog(LOG_WARNING, "autocreate_acl %s: ignoring invalid rights string '%s': %s",
+                            acl_rock->shortname, rights, err);
+        goto done;
+    }
+
+    r = mboxlist_setacl(acl_rock->namespace,
+                        acl_rock->intname,
+                        identifier, rights,
+                        /* isadmin */ 1, acl_rock->userid,
+                        acl_rock->auth_state);
+
+    if (r) {
+        syslog(LOG_ERR, "autocreate_acl %s: unable to setacl for %s to %s: %s",
+                          acl_rock->shortname, identifier, rights,
+                          error_message(r));
+        goto done;
+    }
+
+done:
+    free(freeme);
+    free(err);
+    return;
+}
+
+int autocreate_user(struct namespace *namespace, const char *userid)
 {
     int r = IMAP_MAILBOX_NONEXISTENT; /* default error if we break early */
     int autocreatequota = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
@@ -571,6 +707,7 @@ int autocreate_user(struct namespace *na
     strarray_t *subscribe = NULL;
     int numcrt = 0;
     int numsub = 0;
+    struct mboxlock *namespacelock = user_namespacelock(userid);
 #ifdef USE_SIEVE
     const char *source_script;
 #endif
@@ -657,7 +794,7 @@ int autocreate_user(struct namespace *na
         if (autocreatequotamessage)
             newquotas[QUOTA_MESSAGE] = autocreatequotamessage;
 
-        r = mboxlist_setquotas(inboxname, newquotas, 0);
+        r = mboxlist_setquotas(inboxname, newquotas, 0, 0);
         if (r) {
             syslog(LOG_ERR, "autocreateinbox: User %s, QUOTA failed. %s",
                    userid, error_message(r));
@@ -675,6 +812,8 @@ int autocreate_user(struct namespace *na
         const char *name = strarray_nth(create, n);
         char *foldername = mboxname_user_mbox(userid, name);
         struct autocreate_specialuse_rock specialrock = { userid, foldername, name };
+        struct autocreate_acl_rock aclrock = { namespace, foldername, name,
+                                               auth_state, userid };
 
         r = mboxlist_createmailbox(foldername, /*mbtype*/0, /*partition*/NULL,
                                    /*isadmin*/1, userid, auth_state,
@@ -690,6 +829,7 @@ int autocreate_user(struct namespace *na
             syslog(LOG_WARNING, "autocreateinbox: User %s, subfolder %s creation failed. %s",
                    userid, name, error_message(r));
             r = 0;
+            free(foldername);
             continue;
         }
 
@@ -709,6 +849,11 @@ int autocreate_user(struct namespace *na
 
         /* set specialuse if requested */
         config_foreachoverflowstring(autocreate_specialuse_cb, &specialrock);
+
+        /* add additional acl's if requested */
+        config_foreachoverflowstring(autocreate_acl_cb, &aclrock);
+
+        free(foldername);
     }
 
     if (numcrt)
@@ -722,7 +867,7 @@ int autocreate_user(struct namespace *na
 
 #ifdef USE_SIEVE
     /*
-     * Here the autocreate sieve script feature is iniated from.
+     * Here the autocreate sieve script feature is initiated from.
      */
     source_script = config_getstring(IMAPOPT_AUTOCREATE_SIEVE_SCRIPT);
 
@@ -735,6 +880,7 @@ int autocreate_user(struct namespace *na
 #endif
 
  done:
+    mboxname_release(&namespacelock);
     free(inboxname);
     strarray_free(create);
     strarray_free(subscribe);
diff -pruN 3.0.13-5/imap/backend.c 3.2.0-3/imap/backend.c
--- 3.0.13-5/imap/backend.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/backend.c	2020-04-24 02:03:00.000000000 +0000
@@ -53,6 +53,7 @@
 #include <sys/param.h>
 #include <sys/stat.h>
 #include <sys/un.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -65,7 +66,6 @@
 #include <sasl/saslutil.h>
 
 #include "backend.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "iptostring.h"
 #include "nonblock.h"
@@ -329,8 +329,8 @@ static int parse_capability(struct backe
 
     } else {
         /*
-         * IMAP style: one humungous line with a list of atoms
-         * of the form NAME or NAME=PARAM, preceeded by the atom
+         * IMAP style: one humongous line with a list of atoms
+         * of the form NAME or NAME=PARAM, preceded by the atom
          * CAPABILITY, and either surrounded by [] or being an
          * untagged response like "* CAPABILITY ...atoms... CRLF"
          */
@@ -394,7 +394,7 @@ static int ask_capability(struct backend
     struct protstream *pout = s->out, *pin = s->in;
     const struct protocol_t *prot = s->prot;
     int matches = 0;
-    char str[4096];
+    char str[2047];
     const char *resp;
 
     if (prot->type != TYPE_STD) return 0;
@@ -763,7 +763,7 @@ static int backend_login(struct backend
 {
     int r = 0;
     int ask = 1; /* should we explicitly ask for capabilities? */
-    char buf[2048];
+    char buf[2047];
     struct protocol_t *prot = ret->prot;
 
     if (prot->type != TYPE_STD) return -1;
@@ -786,7 +786,7 @@ static int backend_login(struct backend
             }
         } while (strncasecmp(buf, prot->u.std.banner.resp,
                              strlen(prot->u.std.banner.resp)));
-        xstrncpy(ret->banner, buf, 2048);
+        xstrncpy(ret->banner, buf, sizeof(ret->banner));
     }
 
     if (ask) {
@@ -930,6 +930,55 @@ static int backend_client_bind(const int
     return r;
 }
 
+EXPORTED struct backend *backend_connect_pipe(int infd, int outfd,
+                                              struct protocol_t *prot,
+                                              int do_tls, int logfd)
+
+{
+    struct backend *ret = xzmalloc(sizeof(struct backend));
+    int r;
+
+    ret->in = prot_new(infd, 0);
+    ret->out = prot_new(outfd, 1);
+    ret->sock = -1;
+    prot_settimeout(ret->in, config_getduration(IMAPOPT_CLIENT_TIMEOUT, 's'));
+    prot_setflushonread(ret->in, ret->out);
+    ret->prot = prot;
+
+    /* use literal+ to send literals */
+    prot_setisclient(ret->in, 1);
+    prot_setisclient(ret->out, 1);
+
+    /* Start TLS if required */
+    if (do_tls) {
+        r = backend_starttls(ret, NULL, NULL, NULL);
+        if (r) goto error;
+    }
+
+    /* Login to the server. Not really, but let's handshake. */
+    if (prot->type == TYPE_SPEC)
+        r = prot->u.spec.login(ret, NULL, NULL, NULL, /*noauth*/1);
+    else
+        r = backend_login(ret, NULL, NULL, NULL, /*noauth*/1);
+
+    if (r) goto error;
+
+    /* Set up logging */
+    if (logfd >= 0) {
+        prot_setlog(ret->in, logfd);
+        prot_setlog(ret->out, logfd);
+    }
+    else prot_settimeout(ret->in, 0);
+
+    return ret;
+
+error:
+    backend_disconnect(ret);
+    ret->sock = -1;
+    free(ret);
+    return NULL;
+}
+
 EXPORTED struct backend *backend_connect(struct backend *ret_backend, const char *server,
                                 struct protocol_t *prot, const char *userid,
                                 sasl_callback_t *cb, const char **auth_status,
@@ -1037,7 +1086,7 @@ EXPORTED struct backend *backend_connect
             int n;
             fd_set wfds, rfds;
             time_t now = time(NULL);
-            time_t timeout = now + config_getint(IMAPOPT_CLIENT_TIMEOUT);
+            time_t timeout = now + config_getduration(IMAPOPT_CLIENT_TIMEOUT, 's');
             struct timeval waitfor;
 
             /* select() socket for writing until we succeed, fail, or timeout */
@@ -1090,7 +1139,7 @@ EXPORTED struct backend *backend_connect
     ret->in = prot_new(sock, 0);
     ret->out = prot_new(sock, 1);
     ret->sock = sock;
-    prot_settimeout(ret->in, config_getint(IMAPOPT_CLIENT_TIMEOUT));
+    prot_settimeout(ret->in, config_getduration(IMAPOPT_CLIENT_TIMEOUT, 's'));
     prot_setflushonread(ret->in, ret->out);
     ret->prot = prot;
 
@@ -1161,7 +1210,7 @@ EXPORTED int backend_ping(struct backend
 
 EXPORTED void backend_disconnect(struct backend *s)
 {
-    if (!s || s->sock == -1) return;
+    if (!s) return;
 
     if (!prot_error(s->in)) {
        if (s->prot->type == TYPE_SPEC) s->prot->u.spec.logout(s);
@@ -1205,7 +1254,7 @@ EXPORTED void backend_disconnect(struct
 #endif /* HAVE_SSL */
 
     /* close/free socket & prot layer */
-    cyrus_close_sock(s->sock);
+    if (s->sock != -1) cyrus_close_sock(s->sock);
     s->sock = -1;
 
     prot_free(s->in);
diff -pruN 3.0.13-5/imap/backend.h 3.2.0-3/imap/backend.h
--- 3.0.13-5/imap/backend.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/backend.h	2020-04-24 02:03:00.000000000 +0000
@@ -96,6 +96,13 @@ struct backend *backend_connect(struct b
                                 struct protocol_t *prot, const char *userid,
                                 sasl_callback_t *cb, const char **auth_status,
                                 int logfd);
+
+/* returns a new struct backend, where the infd and outfd file descriptors
+ * are used to open the backend's 'in' and 'out' protstreams. Note that piped
+ * backends do not support authentication */
+struct backend *backend_connect_pipe(int infd, int outfd, struct protocol_t *prot,
+                                     int do_tls, int logfd);
+
 int backend_starttls(   struct backend *s,
                         struct tls_cmd_t *tls_cmd,
                         const char *c_cert_file,
diff -pruN 3.0.13-5/imap/calalarmd.c 3.2.0-3/imap/calalarmd.c
--- 3.0.13-5/imap/calalarmd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/calalarmd.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 #endif
 
 #include <sys/types.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/stat.h>
 #include <stdlib.h>
@@ -57,7 +58,6 @@
 
 #include "global.h"
 #include "xmalloc.h"
-#include "exitcodes.h"
 #include "caldav_db.h"
 #include "caldav_alarm.h"
 
@@ -66,6 +66,8 @@ extern char *optarg;
 
 static int debugmode = 0;
 
+struct namespace calalarmd_namespace;
+
 EXPORTED void fatal(const char *msg, int err)
 {
     if (debugmode) fprintf(stderr, "dying with %s %d\n", msg, err);
@@ -80,12 +82,6 @@ EXPORTED void fatal(const char *msg, int
 static void shut_down(int ec) __attribute__((noreturn));
 static void shut_down(int ec)
 {
-    caldav_done();
-    annotatemore_close();
-    quotadb_close();
-    quotadb_done();
-    mboxlist_close();
-    mboxlist_done();
     cyrus_done();
     exit(ec);
 }
@@ -114,24 +110,15 @@ int main(int argc, char **argv)
             break;
         default:
             fprintf(stderr, "invalid argument\n");
-            exit(EC_USAGE);
+            exit(EX_USAGE);
             break;
         }
     }
 
     cyrus_init(alt_config, "calalarmd", 0, 0);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    annotatemore_open();
-
-    caldav_init();
-
-    mboxevent_init();
+    mboxname_init_namespace(&calalarmd_namespace, /*isadmin*/1);
+    mboxevent_setnamespace(&calalarmd_namespace);
 
     if (upgrade) {
         caldav_alarm_upgrade();
@@ -139,7 +126,7 @@ int main(int argc, char **argv)
     }
 
     if (runattime) {
-        caldav_alarm_process(runattime);
+        caldav_alarm_process(runattime, NULL);
         shut_down(0);
     }
 
@@ -166,17 +153,18 @@ int main(int argc, char **argv)
         struct timeval start, end;
         double totaltime;
         int tosleep;
+        time_t interval = 1;
 
         signals_poll();
 
         gettimeofday(&start, 0);
-        caldav_alarm_process(0);
+        caldav_alarm_process(0, &interval);
         gettimeofday(&end, 0);
 
         signals_poll();
 
         totaltime = timesub(&start, &end);
-        tosleep = 10 - (int) (totaltime + 0.5); /* round to nearest int */
+        tosleep = interval - (int) (totaltime + 0.5); /* round to nearest int */
         if (tosleep > 0)
             sleep(tosleep);
     }
diff -pruN 3.0.13-5/imap/caldav_alarm.c 3.2.0-3/imap/caldav_alarm.c
--- 3.0.13-5/imap/caldav_alarm.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/caldav_alarm.c	2020-04-24 02:03:00.000000000 +0000
@@ -43,20 +43,25 @@
 
 #include <config.h>
 
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 
 #include <libical/ical.h>
 
+#include "append.h"
 #include "caldav_alarm.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "httpd.h"
 #include "http_dav.h"
 #include "ical_support.h"
+#include "jmap_util.h"
 #include "libconfig.h"
 #include "mboxevent.h"
+#include "mboxlist.h"
 #include "mboxname.h"
+#include "msgrecord.h"
+#include "times.h"
 #include "util.h"
 #include "xstrlcat.h"
 #include "xmalloc.h"
@@ -78,6 +83,7 @@ void caldav_alarm_fini(struct caldav_ala
 }
 
 struct get_alarm_rock {
+    const char *userid;
     const char *mboxname;
     uint32_t imap_uid;  // for logging
     icaltimezone *floatingtz;
@@ -87,18 +93,15 @@ struct get_alarm_rock {
 };
 
 static struct namespace caldav_alarm_namespace;
-icaltimezone *utc_zone = NULL;
 
 EXPORTED int caldav_alarm_init(void)
 {
     int r;
 
-    utc_zone = icaltimezone_get_utc_timezone();
-
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&caldav_alarm_namespace, 1))) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     return sqldb_init();
@@ -155,7 +158,8 @@ static sqldb_t *caldav_alarm_open()
 
     // XXX - config option?
     char *dbfilename = strconcat(config_dir, "/caldav_alarm.sqlite3", NULL);
-    my_alarmdb = sqldb_open(dbfilename, CMD_CREATE, DBVERSION, upgrade);
+    my_alarmdb = sqldb_open(dbfilename, CMD_CREATE, DBVERSION, upgrade,
+                            config_getduration(IMAPOPT_DAV_LOCK_TIMEOUT, 's') * 1000);
 
     if (!my_alarmdb) {
         syslog(LOG_ERR, "DBERROR: failed to open %s", dbfilename);
@@ -185,15 +189,25 @@ static int caldav_alarm_close(sqldb_t *a
  */
 static int send_alarm(struct get_alarm_rock *rock,
                       icalcomponent *comp, icalcomponent *alarm,
-                      icaltimetype start, icaltimetype end, icaltimetype alarmtime)
+                      icaltimetype start, icaltimetype end,
+                      icaltimetype alarmtime)
 {
-    char *userid = mboxname_to_userid(rock->mboxname);
+    const char *userid = rock->userid;
     struct buf calname = BUF_INITIALIZER;
+    struct buf calcolor = BUF_INITIALIZER;
+
+    /* get the calendar id */
+    mbname_t *mbname = mbname_from_intname(rock->mboxname);
+    const char *calid = strarray_nth(mbname_boxes(mbname), -1);
 
     /* get the display name annotation */
     const char *displayname_annot = DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
     annotatemore_lookupmask(rock->mboxname, displayname_annot, userid, &calname);
-    if (!calname.len) buf_setcstr(&calname, strrchr(rock->mboxname, '.') + 1);
+    if (!calname.len) buf_setcstr(&calname, calid);
+
+    /* get the calendar color annotation */
+    const char *color_annot = DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-color";
+    annotatemore_lookupmask(rock->mboxname, color_annot, userid, &calcolor);
 
     struct mboxevent *event = mboxevent_new(EVENT_CALENDAR_ALARM);
     icalproperty *prop;
@@ -213,7 +227,9 @@ static int send_alarm(struct get_alarm_r
     }
 
     FILL_STRING_PARAM(event, EVENT_CALENDAR_USER_ID, xstrdup(userid));
+    FILL_STRING_PARAM(event, EVENT_CALENDAR_CALENDAR_ID, xstrdup(calid));
     FILL_STRING_PARAM(event, EVENT_CALENDAR_CALENDAR_NAME, buf_release(&calname));
+    FILL_STRING_PARAM(event, EVENT_CALENDAR_CALENDAR_COLOR, buf_release(&calcolor));
 
     prop = icalcomponent_get_first_property(comp, ICAL_UID_PROPERTY);
     FILL_STRING_PARAM(event, EVENT_CALENDAR_UID,
@@ -278,7 +294,8 @@ static int send_alarm(struct get_alarm_r
         const char *name = icalproperty_get_parameter_as_string(prop, "CN");
         strarray_append(attendee_names, name ? name : "");
 
-        const char *partstat = icalproperty_get_parameter_as_string(prop, "PARTSTAT");
+        const char *partstat =
+            icalproperty_get_parameter_as_string(prop, "PARTSTAT");
         strarray_append(attendee_status, partstat ? partstat : "");
     }
     FILL_ARRAY_PARAM(event, EVENT_CALENDAR_ATTENDEE_NAMES, attendee_names);
@@ -294,7 +311,8 @@ static int send_alarm(struct get_alarm_r
     strarray_free(attendee_status);
 
     buf_free(&calname);
-    free(userid);
+    buf_free(&calcolor);
+    mbname_free(&mbname);
 
     return 0;
 }
@@ -342,7 +360,8 @@ static int process_alarm_cb(icalcomponen
 
         icaltimetype alarmtime = icaltime_null_time();
         if (icalvalue_isa(val) == ICAL_DURATION_VALUE) {
-            icalparameter *param = icalproperty_get_first_parameter(prop, ICAL_RELATED_PARAMETER);
+            icalparameter *param =
+                icalproperty_get_first_parameter(prop, ICAL_RELATED_PARAMETER);
             icaltimetype base = icaltime_null_time();
             if (param && icalparameter_get_related(param) == ICAL_RELATED_END) {
                 base = end;
@@ -368,10 +387,12 @@ static int process_alarm_cb(icalcomponen
 
         if (check <= data->now) {
             prop = icalcomponent_get_first_property(comp, ICAL_SUMMARY_PROPERTY);
-            const char *summary = prop ? icalproperty_get_value_as_string(prop) : "[no summary]";
+            const char *summary =
+                prop ? icalproperty_get_value_as_string(prop) : "[no summary]";
             int age = data->now - check;
             if (age > 7200) { // more than 2 hours stale?  Just log it
-                syslog(LOG_ERR, "suppressing alarm aged %d seconds at %s for %s %u - %s(%d) %s",
+                syslog(LOG_ERR, "suppressing alarm aged %d seconds "
+                       "at %s for %s %u - %s(%d) %s",
                        age,
                        icaltime_as_ical_string(alarmtime),
                        data->mboxname, data->imap_uid,
@@ -392,9 +413,10 @@ static int process_alarm_cb(icalcomponen
             data->nextcheck = check;
         }
 
-        /* alarms can't be more than a week either side of the event start, so if we're
-         * past 2 months, then just check again in a month */
+        /* alarms can't be more than a week either side of the event start,
+         * so if we're past 2 months, then just check again in a month */
         if (check > data->now + 86400*60) {
+            syslog(LOG_DEBUG, "XXX  pushing off nextcheck");
             time_t next = data->now + 86400*30;
             if (!data->nextcheck || next < data->nextcheck)
                 data->nextcheck = next;
@@ -418,7 +440,8 @@ static int process_alarm_cb(icalcomponen
     "   AND imap_uid = :imap_uid"                \
     ";"
 
-static int update_alarmdb(const char *mboxname, uint32_t imap_uid, time_t nextcheck)
+static int update_alarmdb(const char *mboxname,
+                          uint32_t imap_uid, time_t nextcheck)
 {
     struct sqldb_bindval bval[] = {
         { ":mboxname",  SQLITE_TEXT,    { .s = mboxname  } },
@@ -431,6 +454,9 @@ static int update_alarmdb(const char *mb
     if (!alarmdb) return -1;
     int rc = SQLITE_OK;
 
+    syslog(LOG_DEBUG, "update_alarmdb(%s:%u, %ld)",
+           mboxname, imap_uid, nextcheck);
+
     if (nextcheck)
         rc = sqldb_exec(alarmdb, CMD_REPLACE, bval, NULL, NULL);
     else
@@ -444,16 +470,17 @@ static int update_alarmdb(const char *mb
     return -1;
 }
 
-static icaltimezone *get_floatingtz(struct mailbox *mailbox)
+static icaltimezone *get_floatingtz(const char *mailbox, const char *userid)
 {
     icaltimezone *floatingtz = NULL;
 
     struct buf buf = BUF_INITIALIZER;
     const char *annotname = DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-timezone";
-    if (!annotatemore_lookup(mailbox->name, annotname, /*userid*/"", &buf)) {
+    if (!annotatemore_lookupmask(mailbox, annotname, userid, &buf)) {
         icalcomponent *comp = NULL;
         comp = icalparser_parse_string(buf_cstring(&buf));
-        icalcomponent *subcomp = icalcomponent_get_first_component(comp, ICAL_VTIMEZONE_COMPONENT);
+        icalcomponent *subcomp =
+            icalcomponent_get_first_component(comp, ICAL_VTIMEZONE_COMPONENT);
         if (subcomp) {
             floatingtz = icaltimezone_new();
             icalcomponent_remove_component(comp, subcomp);
@@ -466,27 +493,99 @@ static icaltimezone *get_floatingtz(stru
     return floatingtz;
 }
 
-static int has_alarms(icalcomponent *ical)
+static icalcomponent *vpatch_from_peruserdata(const struct buf *userdata)
 {
-    icalcomponent *comp = icalcomponent_get_first_real_component(ical);
-    icalcomponent_kind kind = icalcomponent_isa(comp);
-    for (; comp; comp = icalcomponent_get_next_component(ical, kind)) {
-        if (icalcomponent_get_first_component(comp, ICAL_VALARM_COMPONENT))
-            return 1;
+    struct dlist *dl;
+    const char *icalstr;
+    icalcomponent *vpatch;
+
+    /* Parse the value and fetch the patch */
+    dlist_parsemap(&dl, 1, 0, buf_base(userdata), buf_len(userdata));
+    dlist_getatom(dl, "VPATCH", &icalstr);
+    vpatch = icalparser_parse_string(icalstr);
+    dlist_free(&dl);
+
+    return vpatch;
+}
+
+struct has_alarms_rock {
+    uint32_t mbox_options;
+    int *has_alarms;
+};
+
+static int has_peruser_alarms_cb(const char *mailbox,
+                                 uint32_t uid __attribute__((unused)),
+                                 const char *entry __attribute__((unused)),
+                                 const char *userid, const struct buf *value,
+                                 const struct annotate_metadata *mdata __attribute__((unused)),
+                                 void *rock)
+{
+    struct has_alarms_rock *hrock = (struct has_alarms_rock *) rock;
+    icalcomponent *vpatch, *comp;
+
+    if (!mboxname_userownsmailbox(userid, mailbox) &&
+        ((hrock->mbox_options & OPT_IMAP_SHAREDSEEN) ||
+         mboxlist_checksub(mailbox, userid) != 0)) {
+        /* No per-user-data, or sharee has unsubscribed from this calendar */
+        return 0;
+    }
+        
+    /* Extract VPATCH from per-user-cal-data annotation */
+    vpatch = vpatch_from_peruserdata(value);
+
+    /* Check PATCHes for any VALARMs */
+    for (comp = icalcomponent_get_first_component(vpatch, ICAL_XPATCH_COMPONENT);
+         comp;
+         comp = icalcomponent_get_next_component(vpatch, ICAL_XPATCH_COMPONENT)) {
+        if (icalcomponent_get_first_component(comp, ICAL_VALARM_COMPONENT)) {
+            *(hrock->has_alarms) = 1;
+            break;
+        }
     }
+
+    icalcomponent_free(vpatch);
+
     return 0;
 }
 
-static time_t process_alarms(const char *mboxname, uint32_t imap_uid, icaltimezone *floatingtz,
-                             icalcomponent *ical, time_t lastrun, time_t runtime)
+static int has_alarms(icalcomponent *ical, struct mailbox *mailbox, uint32_t uid)
 {
-    /* we don't send alarms for anything except VEVENTS */
-    icalcomponent *comp = icalcomponent_get_first_real_component(ical);
-    icalcomponent_kind kind = icalcomponent_isa(comp);
-    if (kind != ICAL_VEVENT_COMPONENT)
-        return 0;
+    int has_alarms = 0;
+
+    syslog(LOG_DEBUG, "checking for alarms in mailbox %s uid %u",
+           mailbox->name, uid);
+
+    if (mailbox->i.options & OPT_IMAP_HAS_ALARMS) return 1;
 
-    struct get_alarm_rock rock = { mboxname, imap_uid, floatingtz, lastrun, runtime, 0 };
+    if (ical) {
+        /* Check iCalendar resource for VALARMs */
+        icalcomponent *comp = icalcomponent_get_first_real_component(ical);
+        icalcomponent_kind kind = icalcomponent_isa(comp);
+
+        syslog(LOG_DEBUG, "checking resource");
+        for (; comp; comp = icalcomponent_get_next_component(ical, kind)) {
+            if (icalcomponent_get_first_component(comp, ICAL_VALARM_COMPONENT))
+                return 1;
+        }
+    }
+
+    /* Check all per-user-cal-data for VALARMs */
+    struct has_alarms_rock hrock = { mailbox->i.options, &has_alarms };
+
+    syslog(LOG_DEBUG, "checking per-user-data");
+    mailbox_get_annotate_state(mailbox, uid, NULL);
+    annotatemore_findall(mailbox->name, uid, PER_USER_CAL_DATA, /* modseq */ 0,
+                         &has_peruser_alarms_cb, &hrock, /* flags */ 0);
+
+    return has_alarms;
+}
+
+static time_t process_alarms(const char *mboxname, uint32_t imap_uid,
+                             const char *userid, icaltimezone *floatingtz,
+                             icalcomponent *ical, time_t lastrun, time_t runtime)
+{
+    struct get_alarm_rock rock =
+        { userid, mboxname, imap_uid, floatingtz, lastrun, runtime, 0 };
     struct icalperiodtype range = icalperiodtype_null_period();
     icalcomponent_myforeach(ical, range, floatingtz, process_alarm_cb, &rock);
     return rock.nextcheck;
@@ -497,21 +596,47 @@ struct lastalarm_data {
     time_t nextcheck;
 };
 
-static int read_lastalarm(struct mailbox *mailbox, const struct index_record *record,
+static int write_lastalarm(struct mailbox *mailbox,
+                           const struct index_record *record,
+                           struct lastalarm_data *data)
+{
+    struct buf annot_buf = BUF_INITIALIZER;
+
+    syslog(LOG_DEBUG, "writing last alarm for mailbox %s uid %u",
+           mailbox->name, record->uid);
+
+    if (data) {
+        buf_printf(&annot_buf, "%ld %ld", data->lastrun, data->nextcheck);
+    }
+    syslog(LOG_DEBUG, "data: %s", buf_cstring(&annot_buf));
+
+    const char *annotname = DAV_ANNOT_NS "lastalarm";
+    int r = mailbox_annotation_write(mailbox, record->uid,
+                                     annotname, "", &annot_buf);
+    buf_free(&annot_buf);
+
+    return r;
+}
+
+static int read_lastalarm(struct mailbox *mailbox,
+                          const struct index_record *record,
                           struct lastalarm_data *data)
 {
     int r = IMAP_NOTFOUND;
     memset(data, 0, sizeof(struct lastalarm_data));
 
+    syslog(LOG_DEBUG, "reading last alarm for mailbox %s uid %u",
+           mailbox->name, record->uid);
+
     const char *annotname = DAV_ANNOT_NS "lastalarm";
     struct buf annot_buf = BUF_INITIALIZER;
-    annotatemore_msg_lookup(mailbox->name, record->uid, annotname, "", &annot_buf);
-
-    if (annot_buf.len) {
-        char *base = (char *)buf_cstring(&annot_buf);
-        data->lastrun = strtoul(base, &base, 10);
-        if (*base == ' ') base++;
-        data->nextcheck = strtoul(base, &base, 10);
+    mailbox_get_annotate_state(mailbox, record->uid, NULL);
+    annotatemore_msg_lookup(mailbox->name, record->uid,
+                            annotname, "", &annot_buf);
+
+    if (annot_buf.len &&
+        sscanf(buf_cstring(&annot_buf), "%ld %ld",
+               &data->lastrun, &data->nextcheck) == 2) {
         r = 0;
     }
 
@@ -520,39 +645,38 @@ static int read_lastalarm(struct mailbox
 }
 
 /* add a calendar alarm */
-EXPORTED int caldav_alarm_add_record(struct mailbox *mailbox, const struct index_record *record,
+EXPORTED int caldav_alarm_add_record(struct mailbox *mailbox,
+                                     const struct index_record *record,
                                      icalcomponent *ical)
 {
-    if (!has_alarms(ical)) return 0;
-    // we need to skip silent records (replication) because the lastalarm annotation won't be
-    // set yet, so it will all break :(  Instead, we have an explicit touch on the record which
-    // is done after the annotations are written, and processes the alarms if needed then, and
-    // regardless will always update the alarmdb
-    if (record->silent) return 0;
-    int rc = 0;
-
-    /* XXX - we COULD cache this in the mailbox object so it doesn't get read multiple times,
-     * but this is really rare - only dav_reconstruct maybe */
-    icaltimezone *floatingtz = get_floatingtz(mailbox);
+    if (has_alarms(ical, mailbox, record->uid))
+        update_alarmdb(mailbox->name, record->uid, record->internaldate);
 
-    struct lastalarm_data data;
-    if (read_lastalarm(mailbox, record, &data))
-        data.lastrun = record->internaldate;
-    data.nextcheck = process_alarms(mailbox->name, record->uid, floatingtz,
-                                    ical, data.lastrun, data.lastrun);
-    rc = update_alarmdb(mailbox->name, record->uid, data.nextcheck);
+    return 0;
+}
 
-    if (floatingtz) icaltimezone_free(floatingtz, 1);
+EXPORTED int caldav_alarm_touch_record(struct mailbox *mailbox,
+                                       const struct index_record *record)
+{
+    /* if there are alarms in the annotations,
+     * the next alarm may have become earlier, so get calalarmd to check again */
+    if (has_alarms(NULL, mailbox, record->uid))
+        return update_alarmdb(mailbox->name, record->uid, record->last_updated);
 
-    return rc;
+    return 0;
 }
 
-EXPORTED int caldav_alarm_touch_record(struct mailbox *mailbox, const struct index_record *record)
+/* called by sync_support from sync_server -
+ * set nextcheck in the calalarmdb based on the full state,
+ * record + annotations, after the annotations have been updated too */
+EXPORTED int caldav_alarm_sync_nextcheck(struct mailbox *mailbox, const struct index_record *record)
 {
     struct lastalarm_data data;
     if (!read_lastalarm(mailbox, record, &data))
         return update_alarmdb(mailbox->name, record->uid, data.nextcheck);
-    return 0;
+
+    /* if there's no lastalarm on the record, nuke any existing alarmdb entry */
+    return caldav_alarm_delete_record(mailbox->name, record->uid);
 }
 
 /* delete all alarms matching the event */
@@ -608,6 +732,12 @@ EXPORTED int caldav_alarm_delete_user(co
     return rc;
 }
 
+struct alarm_read_rock {
+    ptrarray_t list;
+    time_t runtime;
+    time_t next;
+};
+
 #define CMD_SELECT_ALARMS                                                \
     "SELECT mboxname, imap_uid, nextcheck"                               \
     " FROM events WHERE"                                                 \
@@ -617,25 +747,379 @@ EXPORTED int caldav_alarm_delete_user(co
 
 static int alarm_read_cb(sqlite3_stmt *stmt, void *rock)
 {
-    ptrarray_t *target = (ptrarray_t *)rock;
+    struct alarm_read_rock *alarm = rock;
+
+    time_t nextcheck = sqlite3_column_int(stmt, 2);
+
+    if (nextcheck <= alarm->runtime) {
+        struct caldav_alarm_data *data = xzmalloc(sizeof(struct caldav_alarm_data));
+        data->mboxname    = xstrdup((const char *) sqlite3_column_text(stmt, 0));
+        data->imap_uid    = sqlite3_column_int(stmt, 1);
+        data->nextcheck   = nextcheck;
+        ptrarray_append(&alarm->list, data);
+    }
+    else if (nextcheck < alarm->next) {
+        alarm->next = nextcheck;
+    }
+
+    return 0;
+}
+
+struct process_alarms_rock {
+    uint32_t mbox_options;
+    icalcomponent *ical;
+    struct lastalarm_data *alarm;
+    time_t runtime;
+};
+
+static int process_peruser_alarms_cb(const char *mailbox, uint32_t uid,
+                                     const char *entry __attribute__((unused)),
+                                     const char *userid, const struct buf *value,
+                                     const struct annotate_metadata *mdata __attribute__((unused)),
+                                     void *rock)
+{
+    struct process_alarms_rock *prock = (struct process_alarms_rock *) rock;
+    icalcomponent *vpatch, *myical;
+    icaltimezone *floatingtz = NULL;
+    time_t check;
 
-    struct caldav_alarm_data *data = xzmalloc(sizeof(struct caldav_alarm_data));
+    if (!mboxname_userownsmailbox(userid, mailbox) &&
+        ((prock->mbox_options & OPT_IMAP_SHAREDSEEN) ||
+         mboxlist_checksub(mailbox, userid) != 0)) {
+        /* No per-user-data, or sharee has unsubscribed from this calendar */
+        return 0;
+    }
 
-    data->mboxname    = xstrdup((const char *) sqlite3_column_text(stmt, 0));
-    data->imap_uid    = sqlite3_column_int(stmt, 1);
-    data->nextcheck   = sqlite3_column_int(stmt, 2);
+    /* Extract VPATCH from per-user-cal-data annotation */
+    vpatch = vpatch_from_peruserdata(value);
 
-    ptrarray_append(target, data);
+    /* Apply VPATCH to a clone of the iCalendar resource */
+    myical = icalcomponent_clone(prock->ical);
+    icalcomponent_apply_vpatch(myical, vpatch, NULL, NULL);
+    icalcomponent_free(vpatch);
+
+    /* Fetch per-user timezone for floating events */
+    floatingtz = get_floatingtz(mailbox, userid);
+
+    /* Process any VALARMs in the patched iCalendar resource */
+    check = process_alarms(mailbox, uid, userid, floatingtz, myical,
+                           prock->alarm->lastrun, prock->runtime);
+    if (!prock->alarm->nextcheck || check < prock->alarm->nextcheck) {
+        prock->alarm->nextcheck = check;
+    }
+
+    if (floatingtz) icaltimezone_free(floatingtz, 1);
+    icalcomponent_free(myical);
 
     return 0;
 }
 
+static void process_valarms(struct mailbox *mailbox,
+                            struct index_record *record,
+                            icaltimezone *floatingtz, time_t runtime)
+{
+    icalcomponent *ical = ical = record_to_ical(mailbox, record, NULL);
+
+    if (!ical) {
+        syslog(LOG_ERR, "error parsing ical string mailbox %s uid %u",
+               mailbox->name, record->uid);
+        caldav_alarm_delete_record(mailbox->name, record->uid);
+        return;
+    }
+
+    /* check for bogus lastalarm data on record
+       which actually shouldn't have it */
+    if (!has_alarms(ical, mailbox, record->uid)) {
+        syslog(LOG_NOTICE, "removing bogus lastalarm check "
+               "for mailbox %s uid %u which has no alarms",
+               mailbox->name, record->uid);
+        caldav_alarm_delete_record(mailbox->name, record->uid);
+        goto done_item;
+    }
+
+    struct lastalarm_data data;
+    if (read_lastalarm(mailbox, record, &data))
+        data.lastrun = record->internaldate;
+
+    /* Process VALARMs in iCalendar resource */
+    char *userid = mboxname_to_userid(mailbox->name);
+
+    syslog(LOG_DEBUG, "processing alarms in resource");
+
+    data.nextcheck = process_alarms(mailbox->name, record->uid, userid,
+                                    floatingtz, ical, data.lastrun, runtime);
+    free(userid);
+
+    /* Process VALARMs in per-user-cal-data */
+    struct process_alarms_rock prock =
+        { mailbox->i.options, ical, &data, runtime };
+
+    syslog(LOG_DEBUG, "processing per-user alarms");
+
+    mailbox_get_annotate_state(mailbox, record->uid, NULL);
+    annotatemore_findall(mailbox->name, record->uid, PER_USER_CAL_DATA,
+                         /* modseq */ 0, &process_peruser_alarms_cb,
+                         &prock, /* flags */ 0);
+
+    data.lastrun = runtime;
+    write_lastalarm(mailbox, record, &data);
+
+    update_alarmdb(mailbox->name, record->uid, data.nextcheck);
+
+done_item:
+    if (ical) icalcomponent_free(ical);
+}
+
+#ifdef WITH_JMAP
+static void process_futurerelease(struct mailbox *mailbox,
+                                  struct index_record *record)
+{
+    message_t *m = message_new_from_record(mailbox, record);
+    struct buf buf = BUF_INITIALIZER;
+    json_t *submission = NULL, *identity, *envelope;
+    int r = 0;
+
+    syslog(LOG_DEBUG, "processing future release for mailbox %s uid %u",
+           mailbox->name, record->uid);
+
+    if (record->system_flags & FLAG_ANSWERED) {
+        syslog(LOG_NOTICE, "email already sent for mailbox %s uid %u",
+               mailbox->name, record->uid);
+        r = IMAP_NO_NOSUCHMSG;
+        goto done;
+    }
+
+    if (record->system_flags & FLAG_FLAGGED) {
+        syslog(LOG_NOTICE, "submission canceled for mailbox %s uid %u",
+               mailbox->name, record->uid);
+        r = IMAP_NO_NOSUCHMSG;
+        goto done;
+    }
+
+    /* Parse the submission object from the header field */
+    r = message_get_field(m, JMAP_SUBMISSION_HDR, MESSAGE_RAW, &buf);
+    if (!r) {
+        json_error_t jerr;
+        submission = json_loadb(buf_base(&buf), buf_len(&buf),
+                                JSON_DISABLE_EOF_CHECK, &jerr);
+    }
+    if (!submission) {
+        syslog(LOG_ERR,
+               "process_futurerelease: failed to parse submission obj");
+        goto done;
+    }
+    envelope = json_object_get(submission, "envelope");
+    identity = json_object_get(submission, "identityId");
+
+    /* Load message */
+    r = message_get_field(m, "rawbody", MESSAGE_RAW, &buf);
+    if (r) {
+        syslog(LOG_ERR, "process_futurerelease: can't get body for %s:%u",
+               mailbox->name, record->uid);
+        goto done;
+    }
+
+    /* Open the SMTP connection */
+    smtpclient_t *sm = NULL;
+    r = smtpclient_open(&sm);
+    if (r) {
+        syslog(LOG_ERR, "smtpclient_open failed: %s", error_message(r));
+        goto done;
+    }
+    smtpclient_set_auth(sm, json_string_value(identity));
+
+    /* Prepare envelope */
+    smtp_envelope_t smtpenv = SMTP_ENVELOPE_INITIALIZER;
+    jmap_emailsubmission_envelope_to_smtp(&smtpenv, envelope);
+
+    /* Send message */
+    r = smtpclient_send(sm, &smtpenv, &buf);
+    smtp_envelope_fini(&smtpenv);
+    smtpclient_close(&sm);
+
+    if (r) {
+        syslog(LOG_ERR, "smtpclient_send failed: %s", error_message(r));
+        goto done;
+    }
+
+    /* Mark the email as sent */
+    record->system_flags |= FLAG_ANSWERED;
+    if (config_getswitch(IMAPOPT_JMAPSUBMISSION_DELETEONSEND)) {
+        /* delete the EmailSubmission object immediately */
+        record->system_flags |= FLAG_DELETED;
+        record->internal_flags |= FLAG_INTERNAL_EXPUNGED;
+    }
+    r = mailbox_rewrite_index_record(mailbox, record);
+    if (r) {
+        syslog(LOG_ERR, "marking emailsubmission as sent (%s:%u) failed: %s",
+               mailbox->name, record->uid, error_message(r));
+    }
+
+  done:
+    if (submission) json_decref(submission);
+    if (m) message_unref(&m);
+    buf_free(&buf);
+
+    return;
+}
+
+static void process_snoozed(struct mailbox *mailbox,
+                            struct index_record *record, time_t runtime)
+{
+    struct buf buf = BUF_INITIALIZER;
+    msgrecord_t *mr = NULL;
+    mbname_t *mbname = NULL;
+    struct appendstate as;
+    struct mailbox *destmbox = NULL;
+    struct auth_state *authstate = NULL;
+    const char *userid;
+    char *destname = NULL;
+    time_t wakeup;
+    struct stagemsg *stage = NULL;
+    struct entryattlist *annots = NULL;
+    strarray_t *flags = NULL;
+    struct body *body = NULL;
+    FILE *f = NULL;
+    json_t *snoozed, *destmboxid, *keywords;
+    int r = 0;
+
+    syslog(LOG_DEBUG, "processing snoozed email for mailbox %s uid %u",
+           mailbox->name, record->uid);
+
+    /* Get the snoozed annotation */
+    snoozed = jmap_fetch_snoozed(mailbox->name, record->uid);
+    if (!snoozed) goto done;
+
+    time_from_iso8601(json_string_value(json_object_get(snoozed, "until")),
+                      &wakeup);
+
+    /* Check runtime against wakup and adjust as necessary */
+    if (wakeup > runtime) {
+        update_alarmdb(mailbox->name, record->uid, wakeup);
+        goto done;
+    }
+
+    mr = msgrecord_from_index_record(mailbox, record);
+    if (!mr) goto done;
+
+    /* Fetch message */
+    r = msgrecord_get_body(mr, &buf);
+    if (r) goto done;
+
+    /* Fetch annotations */
+    r = msgrecord_extract_annots(mr, &annots);
+    if (r) goto done;
+
+    mbname = mbname_from_intname(mailbox->name);
+    mbname_set_boxes(mbname, NULL);
+    userid = mbname_userid(mbname);
+    authstate = auth_newstate(userid);
+
+    /* Fetch flags */
+    r = msgrecord_extract_flags(mr, userid, &flags);
+    if (r) goto done;
+
+    /* Add \snoozed pseudo-flag */
+    strarray_add(flags, "\\snoozed");
+
+    /* (Un)set any client-supplied flags */
+    keywords = json_object_get(snoozed, "setKeywords");
+    if (keywords) {
+        const char *key;
+        json_t *val;
+
+        json_object_foreach(keywords, key, val) {
+            const char *flag = jmap_keyword_to_imap(key);
+            if (flag) {
+                if (json_is_true(val)) strarray_add_case(flags, flag);
+                else strarray_remove_all_case(flags, flag);
+            }
+        }
+    }
+
+    /* Determine destination mailbox of awakened email */
+    destmboxid = json_object_get(snoozed, "moveToMailboxId");
+    if (destmboxid) {
+        destname = mboxlist_find_uniqueid(json_string_value(destmboxid),
+                                          userid, authstate);
+    }
+    if (!destname) {
+        destname = xstrdup(mbname_intname(mbname));
+    }
+
+    /* Fetch message filename */
+    const char *fname;
+    r = msgrecord_get_fname(mr, &fname);
+    if (r) goto done;
+
+    /* Prepare to stage the message */
+    if (!(f = append_newstage_full(destname, runtime, 0, &stage, fname))) {
+        syslog(LOG_ERR, "append_newstage(%s) failed", destname);
+        r = IMAP_IOERROR;
+        goto done;
+    }
+    fclose(f);
+
+    r = mailbox_open_iwl(destname, &destmbox);
+    if (r) goto done;
+
+    r = append_setup_mbox(&as, destmbox, userid, authstate,
+                          ACL_INSERT, NULL, NULL, 0, EVENT_MESSAGE_NEW);
+    if (r) goto done;
+
+    /* Extract until and use it as savedate */
+    time_t savedate;
+    time_from_iso8601(json_string_value(json_object_get(snoozed, "until")),
+                      &savedate);
+
+    /* Append the message to the mailbox */
+    r = append_fromstage_full(&as, &body, stage, record->internaldate,
+                              savedate, 0, flags, 0, annots);
+    if (r) {
+        append_abort(&as);
+        goto done;
+    }
+
+    r = append_commit(&as);
+    if (r) goto done;
+
+    /* Expunge the resource from the \Snoozed mailbox (also unset \snoozed) */
+    record->internal_flags |= FLAG_INTERNAL_EXPUNGED;
+    record->internal_flags &= ~FLAG_INTERNAL_SNOOZED;
+    r = mailbox_rewrite_index_record(mailbox, record);
+    if (r) {
+        syslog(LOG_ERR, "expunging record (%s:%u) failed: %s",
+               mailbox->name, record->uid, error_message(r));
+    }
+
+  done:
+    if (r) {
+        /* XXX  Error handling */
+        caldav_alarm_delete_record(mailbox->name, record->uid);
+    }
+
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    strarray_free(flags);
+    freeentryatts(annots);
+    append_removestage(stage);
+
+    mailbox_close(&destmbox);
+    if (authstate) auth_freestate(authstate);
+    if (mbname) mbname_free(&mbname);
+    if (mr) msgrecord_unref(&mr);
+    if (snoozed) json_decref(snoozed);
+    buf_free(&buf);
+    free(destname);
+}
+#endif /* WITH_JMAP */
+
 static void process_one_record(struct mailbox *mailbox, uint32_t imap_uid,
                                icaltimezone *floatingtz, time_t runtime)
 {
     int rc;
-    icalcomponent *ical = NULL;
-    struct buf msg_buf = BUF_INITIALIZER;
 
     syslog(LOG_DEBUG, "processing alarms for mailbox %s uid %u",
            mailbox->name, imap_uid);
@@ -644,47 +1128,50 @@ static void process_one_record(struct ma
     memset(&record, 0, sizeof(struct index_record));
     rc = mailbox_find_index_record(mailbox, imap_uid, &record);
     if (rc == IMAP_NOTFOUND) {
+        syslog(LOG_ERR, "not found mailbox %s uid %u",
+               mailbox->name, imap_uid);
         /* no record, no worries */
-        goto done_item;
+        caldav_alarm_delete_record(mailbox->name, imap_uid);
+        return;
     }
     if (rc) {
+        syslog(LOG_ERR, "error reading mailbox %s uid %u (%s)",
+               mailbox->name, imap_uid, error_message(rc));
         /* XXX no index record? item deleted or transient error? */
-        goto done_item;
+        caldav_alarm_delete_record(mailbox->name, imap_uid);
+        return;
     }
-    if (record.system_flags & FLAG_EXPUNGED) {
+    if (record.internal_flags & FLAG_INTERNAL_EXPUNGED) {
+        syslog(LOG_ERR, "already expunged mailbox %s uid %u",
+               mailbox->name, imap_uid);
         /* no longer exists?  nothing to do */
-        goto done_item;
+        caldav_alarm_delete_record(mailbox->name, imap_uid);
+        return;
     }
 
-    rc = mailbox_map_record(mailbox, &record, &msg_buf);
-    if (rc) {
-        /* XXX no message? index is wrong? yikes */
-        goto done_item;
+    if (mailbox->mbtype == MBTYPE_CALENDAR) {
+        process_valarms(mailbox, &record, floatingtz, runtime);
     }
-
-    ical = icalparser_parse_string(buf_cstring(&msg_buf) + record.header_size);
-
-    if (!ical) {
-        /* XXX log error */
-        goto done_item;
+#ifdef WITH_JMAP
+    else if (mailbox->mbtype == MBTYPE_SUBMISSION) {
+        if (record.internaldate > runtime) {
+            update_alarmdb(mailbox->name, imap_uid, record.internaldate);
+            return;
+        }
+        process_futurerelease(mailbox, &record);
+    }
+    else if (mailbox->i.options & OPT_IMAP_HAS_ALARMS) {
+        /* XXX  Check special-use flag on mailbox */
+        process_snoozed(mailbox, &record, runtime);
+    }
+#endif
+    else {
+        /* XXX  Should never get here */
+        syslog(LOG_ERR, "Unknown/unsupported alarm triggered for"
+               " mailbox %s of type %d with options 0x%02x",
+               mailbox->name, mailbox->mbtype, mailbox->i.options);
+        caldav_alarm_delete_record(mailbox->name, imap_uid);
     }
-
-    struct lastalarm_data data;
-    if (read_lastalarm(mailbox, &record, &data))
-        data.lastrun = record.internaldate;
-
-    if (runtime > data.nextcheck)
-        data.nextcheck = process_alarms(mailbox->name, record.uid, floatingtz, ical, data.lastrun, runtime);
-
-    struct buf annot_buf = BUF_INITIALIZER;
-    buf_printf(&annot_buf, "%ld %ld", runtime, data.nextcheck);
-    const char *annotname = DAV_ANNOT_NS "lastalarm";
-    mailbox_annotation_write(mailbox, record.uid, annotname, "", &annot_buf);
-    buf_free(&annot_buf);
-
-done_item:
-    buf_free(&msg_buf);
-    if (ical) icalcomponent_free(ical);
 }
 
 static void process_records(ptrarray_t *list, time_t runtime)
@@ -694,6 +1181,8 @@ static void process_records(ptrarray_t *
     int i;
     icaltimezone *floatingtz = NULL;
 
+    syslog(LOG_DEBUG, "processing records");
+
     for (i = 0; i < list->count; i++) {
         struct caldav_alarm_data *data = ptrarray_nth(list, i);
 
@@ -714,7 +1203,8 @@ static void process_records(ptrarray_t *
                 /* transient open error, don't delete this alarm */
                 continue;
             }
-            floatingtz = get_floatingtz(mailbox);
+            if (mailbox->mbtype == MBTYPE_CALENDAR)
+                floatingtz = get_floatingtz(mailbox->name, "");
         }
         process_one_record(mailbox, data->imap_uid, floatingtz, runtime);
     }
@@ -724,40 +1214,44 @@ static void process_records(ptrarray_t *
 }
 
 /* process alarms with triggers before a given time */
-EXPORTED int caldav_alarm_process(time_t runtime)
+EXPORTED int caldav_alarm_process(time_t runtime, time_t *intervalp)
 {
     syslog(LOG_DEBUG, "processing alarms");
 
     if (!runtime) {
-        /* check 10s into the future - we run every 10, so that guarantees we will
-         * deliver on or before the target time */
-        runtime = time(NULL) + 10;
+        runtime = time(NULL);
     }
 
+    struct alarm_read_rock rock = { PTRARRAY_INITIALIZER, runtime, runtime + 10 };
+
+    // check 10 seconds into the future - if there's something in there,
+    // we'll run again - otherwise we'll wait the 10 seconds before checking again
     struct sqldb_bindval bval[] = {
-        { ":before",    SQLITE_INTEGER, { .i = runtime  } },
-        { NULL,         SQLITE_NULL,    { .s = NULL     } }
+        { ":before",    SQLITE_INTEGER, { .i = rock.next } },
+        { NULL,         SQLITE_NULL,    { .s = NULL      } }
     };
 
     sqldb_t *alarmdb = caldav_alarm_open();
     if (!alarmdb)
         return HTTP_SERVER_ERROR;
 
-    ptrarray_t list = PTRARRAY_INITIALIZER;
-
-    int rc = sqldb_exec(alarmdb, CMD_SELECT_ALARMS, bval, &alarm_read_cb, &list);
+    int rc = sqldb_exec(alarmdb, CMD_SELECT_ALARMS, bval, &alarm_read_cb, &rock);
 
     caldav_alarm_close(alarmdb);
 
-    process_records(&list, runtime);
+    process_records(&rock.list, runtime);
 
     int i;
-    for (i = 0; i < list.count; i++) {
-        struct caldav_alarm_data *data = ptrarray_nth(&list, i);
+    for (i = 0; i < rock.list.count; i++) {
+        struct caldav_alarm_data *data = ptrarray_nth(&rock.list, i);
         caldav_alarm_fini(data);
         free(data);
     }
-    ptrarray_fini(&list);
+    ptrarray_fini(&rock.list);
+
+    syslog(LOG_DEBUG, "done");
+
+    if (intervalp) *intervalp = rock.next - runtime;
 
     return rc;
 }
@@ -788,8 +1282,6 @@ EXPORTED int caldav_alarm_upgrade()
     caldav_alarm_close(alarmdb);
 
     time_t runtime = time(NULL);
-    const char *annotname = DAV_ANNOT_NS "lastalarm";
-    struct buf annot_buf = BUF_INITIALIZER;
 
     int i;
     for (i = 0; i < strarray_size(&mailboxes); i++) {
@@ -808,27 +1300,30 @@ EXPORTED int caldav_alarm_upgrade()
         caldav_alarm_close(alarmdb);
         if (rc) continue;
 
-        icaltimezone *floatingtz = get_floatingtz(mailbox);
+        icaltimezone *floatingtz = get_floatingtz(mailbox->name, "");
 
         /* add alarms for all records */
-        struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+        struct mailbox_iter *iter =
+            mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
         const message_t *msg;
         while ((msg = mailbox_iter_step(iter))) {
             const struct index_record *record = msg_record(msg);
-            struct buf msg_buf = BUF_INITIALIZER;
-            rc = mailbox_map_record(mailbox, record, &msg_buf);
-            if (rc) continue;
-            icalcomponent *ical = icalparser_parse_string(buf_cstring(&msg_buf) + record->header_size);
+            icalcomponent *ical = record_to_ical(mailbox, record, NULL);
+
             if (ical) {
-                if (has_alarms(ical)) {
-                    time_t nextcheck = process_alarms(mailbox->name, record->uid, floatingtz, ical, runtime, runtime);
-                    buf_reset(&annot_buf);
-                    buf_printf(&annot_buf, "%ld %ld", runtime, nextcheck);
-                    mailbox_annotation_write(mailbox, record->uid, annotname, "", &annot_buf);
+                if (has_alarms(ical, mailbox, record->uid)) {
+                    char *userid = mboxname_to_userid(mailbox->name);
+                    time_t nextcheck = process_alarms(mailbox->name, record->uid,
+                                                      userid, floatingtz, ical,
+                                                      runtime, runtime);
+                    free(userid);
+
+                    struct lastalarm_data data = { runtime, nextcheck };
+                    write_lastalarm(mailbox, record, &data);
+                    update_alarmdb(mailbox->name, record->uid, data.nextcheck);
                 }
                 icalcomponent_free(ical);
             }
-            buf_free(&msg_buf);
         }
         mailbox_iter_done(&iter);
         mailbox_close(&mailbox);
@@ -844,7 +1339,5 @@ EXPORTED int caldav_alarm_upgrade()
     sqldb_exec(alarmdb, "DROP TABLE alarms;", NULL, NULL, NULL);
     caldav_alarm_close(alarmdb);
 
-    buf_free(&annot_buf);
-
     return rc;
 }
diff -pruN 3.0.13-5/imap/caldav_alarm.h 3.2.0-3/imap/caldav_alarm.h
--- 3.0.13-5/imap/caldav_alarm.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/caldav_alarm.h	2020-04-24 02:03:00.000000000 +0000
@@ -57,11 +57,17 @@ int caldav_alarm_init(void);
 int caldav_alarm_done(void);
 
 /* add a calendar alarm */
-int caldav_alarm_add_record(struct mailbox *mailbox, const struct index_record *record,
+int caldav_alarm_add_record(struct mailbox *mailbox,
+                            const struct index_record *record,
                             icalcomponent *ical);
 
 /* make sure that the alarms match the annotation */
-int caldav_alarm_touch_record(struct mailbox *mailbox, const struct index_record *record);
+int caldav_alarm_touch_record(struct mailbox *mailbox,
+                              const struct index_record *record);
+
+/* set the caldav_alarm db nextcheck field for the record (from sync_support) */
+int caldav_alarm_sync_nextcheck(struct mailbox *mailbox,
+                                const struct index_record *record);
 
 /* delete all alarms matching the event */
 int caldav_alarm_delete_record(const char *mboxname, uint32_t uid);
@@ -73,7 +79,7 @@ int caldav_alarm_delete_mailbox(const ch
 int caldav_alarm_delete_user(const char *userid);
 
 /* distribute alarms with triggers in the next minute */
-int caldav_alarm_process(time_t runtime);
+int caldav_alarm_process(time_t runtime, time_t *next);
 
 /* upgrade old databases */
 int caldav_alarm_upgrade();
diff -pruN 3.0.13-5/imap/caldav_db.c 3.2.0-3/imap/caldav_db.c
--- 3.0.13-5/imap/caldav_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/caldav_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -43,6 +43,7 @@
 
 #include <config.h>
 
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 
@@ -51,7 +52,6 @@
 #include "caldav_alarm.h"
 #include "caldav_db.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "httpd.h"
 #include "http_dav.h"
 #include "ical_support.h"
@@ -61,6 +61,8 @@
 #include "xstrlcat.h"
 #include "xmalloc.h"
 
+/* generated headers are not necessarily in current directory */
+#include "imap/imap_err.h"
 
 struct caldav_db {
     sqldb_t *db;                        /* DB handle */
@@ -75,12 +77,26 @@ struct caldav_db {
     struct buf dtstart;
     struct buf dtend;
     struct buf sched_tag;
+    struct buf jmapdata;
 };
 
 
 static struct namespace caldav_namespace;
-time_t caldav_epoch = -1;
-time_t caldav_eternity = -1;
+EXPORTED time_t caldav_epoch = -1;
+EXPORTED time_t caldav_eternity = -1;
+
+static int caldav_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    caldav_done();
+}
+
+static void init_internal() {
+    if (!caldav_initialized) {
+        caldav_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
 
 EXPORTED int caldav_init(void)
 {
@@ -90,7 +106,7 @@ EXPORTED int caldav_init(void)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&caldav_namespace, 1))) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     /* Get min date-time */
@@ -109,20 +125,27 @@ EXPORTED int caldav_init(void)
 
     r = sqldb_init();
     caldav_alarm_init();
+
+    if (!r) caldav_initialized = 1;
     return r;
 }
 
 
 EXPORTED int caldav_done(void)
 {
+    int r;
     caldav_alarm_done();
-    return sqldb_done();
+    r = sqldb_done();
+    if (!r) caldav_initialized = 0;
+    return r;
 }
 
 EXPORTED struct caldav_db *caldav_open_userid(const char *userid)
 {
     struct caldav_db *caldavdb = NULL;
 
+    init_internal();
+
     sqldb_t *db = dav_open_userid(userid);
     if (!db) return NULL;
 
@@ -141,6 +164,8 @@ EXPORTED struct caldav_db *caldav_open_m
     struct caldav_db *caldavdb = NULL;
     char *userid = mboxname_to_userid(mailbox->name);
 
+    init_internal();
+
     if (userid) {
         caldavdb = caldav_open_userid(userid);
         free(userid);
@@ -174,6 +199,7 @@ EXPORTED int caldav_close(struct caldav_
     buf_free(&caldavdb->dtstart);
     buf_free(&caldavdb->dtend);
     buf_free(&caldavdb->sched_tag);
+    buf_free(&caldavdb->jmapdata);
 
     r = sqldb_close(&caldavdb->db);
 
@@ -218,29 +244,41 @@ static const char *column_text_to_buf(co
 
 static void _num_to_comp_flags(struct comp_flags *flags, unsigned num)
 {
-    flags->recurring = num & 1;
-    flags->transp = (num >> 1) & 1;
-    flags->status = (num >> 2) & 3;
-    flags->tzbyref = (num >> 4) & 1;
-    flags->mattach = (num >> 5) & 1;
+    flags->recurring =  num & 1;
+    flags->transp    = (num >> 1) & 1;
+    flags->status    = (num >> 2) & 3;
+    flags->tzbyref   = (num >> 4) & 1;
+    flags->mattach   = (num >> 5) & 1;
+    flags->shared    = (num >> 6) & 1;
 }
 
 static unsigned _comp_flags_to_num(struct comp_flags *flags)
 {
    return (flags->recurring & 1)
-       + ((flags->transp & 1) << 1)
-       + ((flags->status & 3) << 2)
-       + ((flags->tzbyref & 1) << 4)
-       + ((flags->mattach & 1) << 5);
+       + ((flags->transp    & 1) << 1)
+       + ((flags->status    & 3) << 2)
+       + ((flags->tzbyref   & 1) << 4)
+       + ((flags->mattach   & 1) << 5)
+       + ((flags->shared    & 1) << 6);
 }
 
 #define CMD_READFIELDS                                                  \
     "SELECT rowid, creationdate, mailbox, resource, imap_uid,"          \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
     "  comp_type, ical_uid, organizer, dtstart, dtend,"                 \
-    "  comp_flags, sched_tag, alive, modseq"                            \
+    "  comp_flags, sched_tag, alive, modseq, createdmodseq,"            \
+    "  NULL, NULL"                                                      \
     " FROM ical_objs"                                                   \
 
+#define CMD_READFIELDS_JMAP                                             \
+    "SELECT ical_objs.rowid, creationdate, mailbox, resource, imap_uid,"\
+    "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
+    "  comp_type, ical_uid, organizer, dtstart, dtend,"                 \
+    "  comp_flags, sched_tag, alive, modseq, createdmodseq,"            \
+    "  jmapversion, jmapdata"                                           \
+    " FROM ical_objs LEFT JOIN ical_jmapcache"                          \
+    " ON (ical_objs.rowid = ical_jmapcache.rowid AND ical_jmapcache.userid = :asuserid)"
+
 static int read_cb(sqlite3_stmt *stmt, void *rock)
 {
     struct read_rock *rrock = (struct read_rock *) rock;
@@ -251,8 +289,9 @@ static int read_cb(sqlite3_stmt *stmt, v
     memset(cdata, 0, sizeof(struct caldav_data));
 
     cdata->dav.alive = sqlite3_column_int(stmt, 16);
-    cdata->dav.modseq = sqlite3_column_int(stmt, 17);
-    if (!(rrock->flags && RROCK_FLAG_TOMBSTONES) && !cdata->dav.alive)
+    cdata->dav.modseq = sqlite3_column_int64(stmt, 17);
+    cdata->dav.createdmodseq = sqlite3_column_int64(stmt, 18);
+    if (!(rrock->flags & RROCK_FLAG_TOMBSTONES) && !cdata->dav.alive)
         return 0;
 
     cdata->dav.rowid = sqlite3_column_int(stmt, 0);
@@ -261,6 +300,7 @@ static int read_cb(sqlite3_stmt *stmt, v
     cdata->dav.lock_expire = sqlite3_column_int(stmt, 8);
     cdata->comp_type = sqlite3_column_int(stmt, 9);
     _num_to_comp_flags(&cdata->comp_flags, sqlite3_column_int(stmt, 14));
+    cdata->jmapversion = sqlite3_column_int(stmt, 19);
 
     if (rrock->cb) {
         /* We can use the column data directly for the callback */
@@ -274,6 +314,7 @@ static int read_cb(sqlite3_stmt *stmt, v
         cdata->dtstart = (const char *) sqlite3_column_text(stmt, 12);
         cdata->dtend = (const char *) sqlite3_column_text(stmt, 13);
         cdata->sched_tag = (const char *) sqlite3_column_text(stmt, 15);
+        cdata->jmapdata = (const char *) sqlite3_column_text(stmt, 20);
         r = rrock->cb(rrock->rock, cdata);
     }
     else {
@@ -310,6 +351,9 @@ static int read_cb(sqlite3_stmt *stmt, v
         cdata->sched_tag =
             column_text_to_buf((const char *) sqlite3_column_text(stmt, 15),
                                &db->sched_tag);
+        cdata->jmapdata =
+            column_text_to_buf((const char *) sqlite3_column_text(stmt, 20),
+                               &db->jmapdata);
     }
 
     return r;
@@ -424,15 +468,16 @@ EXPORTED int caldav_foreach(struct calda
 
 #define CMD_SELRANGE_MBOX CMD_READFIELDS \
     " WHERE dtend > :after AND dtstart < :before " \
-    " AND mailbox = :mailbox AND alive = 1;"
+    " AND mailbox = :mailbox AND alive = 1 "
 
 #define CMD_SELRANGE CMD_READFIELDS \
     " WHERE dtend > :after AND dtstart < :before " \
-    " AND alive = 1;"
+    " AND alive = 1 "
 
 EXPORTED int caldav_foreach_timerange(struct caldav_db *caldavdb,
                                       const char *mailbox,
                                       time_t after, time_t before,
+                                      enum caldav_sort* sort, size_t nsort,
                                       caldav_cb_t *cb, void *rock)
 {
     struct sqldb_bindval bval[] = {
@@ -457,22 +502,47 @@ EXPORTED int caldav_foreach_timerange(st
 
     /* XXX - tombstones */
 
-    if (mailbox) {
-        return sqldb_exec(caldavdb->db, CMD_SELRANGE_MBOX, bval, &read_cb, &rrock);
-    } else {
-        return sqldb_exec(caldavdb->db, CMD_SELRANGE, bval, &read_cb, &rrock);
+    struct buf stmt = BUF_INITIALIZER;
+    buf_setcstr(&stmt, mailbox ? CMD_SELRANGE_MBOX : CMD_SELRANGE);
+    if (nsort) {
+        buf_appendcstr(&stmt, " ORDER BY ");
+        size_t i;
+        for (i = 0; i < nsort; i++) {
+            if (i) buf_appendcstr(&stmt, ", ");
+            switch (sort[i] & ~CAL_SORT_DESC) {
+                case CAL_SORT_UID:
+                    buf_appendcstr(&stmt, "ical_uid");
+                    break;
+                case CAL_SORT_START:
+                    buf_appendcstr(&stmt, "dtstart");
+                    break;
+                case CAL_SORT_MAILBOX:
+                    buf_appendcstr(&stmt, "mailbox");
+                    break;
+                default:
+                    continue;
+            }
+            buf_appendcstr(&stmt, sort[i] & CAL_SORT_DESC ? " DESC" : " ASC");
+        }
     }
+    buf_putc(&stmt, ';');
+
+    int r = sqldb_exec(caldavdb->db, buf_cstring(&stmt), bval, &read_cb, &rrock);
+    buf_free(&stmt);
+    return r;
 }
 
 
 #define CMD_INSERT                                                      \
     "INSERT INTO ical_objs ("                                           \
     "  alive, mailbox, resource, creationdate, imap_uid, modseq,"       \
+    "  createdmodseq,"                                                  \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
     "  comp_type, ical_uid, organizer, dtstart, dtend,"                 \
     "  comp_flags, sched_tag )"                                         \
     " VALUES ("                                                         \
     "  :alive, :mailbox, :resource, :creationdate, :imap_uid, :modseq," \
+    "  :createdmodseq,"                                                 \
     "  :lock_token, :lock_owner, :lock_ownerid, :lock_expire,"          \
     "  :comp_type, :ical_uid, :organizer, :dtstart, :dtend,"            \
     "  :comp_flags, :sched_tag );"
@@ -483,6 +553,7 @@ EXPORTED int caldav_foreach_timerange(st
     "  creationdate = :creationdate,"   \
     "  imap_uid     = :imap_uid,"       \
     "  modseq       = :modseq,"         \
+    "  createdmodseq = :createdmodseq,"  \
     "  lock_token   = :lock_token,"     \
     "  lock_owner   = :lock_owner,"     \
     "  lock_ownerid = :lock_ownerid,"   \
@@ -496,9 +567,11 @@ EXPORTED int caldav_foreach_timerange(st
     "  sched_tag    = :sched_tag"       \
     " WHERE rowid = :rowid;"
 
+#define CMD_DELETE_JMAPCACHE "DELETE FROM ical_jmapcache WHERE rowid = :rowid"
+
 EXPORTED int caldav_write(struct caldav_db *caldavdb, struct caldav_data *cdata)
 {
-    int comp_flags = _comp_flags_to_num(&cdata->comp_flags);
+    unsigned comp_flags = _comp_flags_to_num(&cdata->comp_flags);
     struct sqldb_bindval bval[] = {
         { ":rowid",        SQLITE_INTEGER, { .i = cdata->dav.rowid        } },
         { ":alive",        SQLITE_INTEGER, { .i = cdata->dav.alive        } },
@@ -507,6 +580,7 @@ EXPORTED int caldav_write(struct caldav_
         { ":creationdate", SQLITE_INTEGER, { .i = cdata->dav.creationdate } },
         { ":imap_uid",     SQLITE_INTEGER, { .i = cdata->dav.imap_uid     } },
         { ":modseq",       SQLITE_INTEGER, { .i = cdata->dav.modseq       } },
+        { ":createdmodseq", SQLITE_INTEGER, { .i = cdata->dav.createdmodseq } },
         { ":lock_token",   SQLITE_TEXT,    { .s = cdata->dav.lock_token   } },
         { ":lock_owner",   SQLITE_TEXT,    { .s = cdata->dav.lock_owner   } },
         { ":lock_ownerid", SQLITE_TEXT,    { .s = cdata->dav.lock_ownerid } },
@@ -521,7 +595,9 @@ EXPORTED int caldav_write(struct caldav_
         { NULL,            SQLITE_NULL,    { .s = NULL                    } } };
 
     if (cdata->dav.rowid) {
-        int r = sqldb_exec(caldavdb->db, CMD_UPDATE, bval, NULL, NULL);
+        int r = sqldb_exec(caldavdb->db, CMD_DELETE_JMAPCACHE, bval, NULL, NULL);
+        if (r) return r;
+        r = sqldb_exec(caldavdb->db, CMD_UPDATE, bval, NULL, NULL);
         if (r) return r;
     }
     else {
@@ -563,17 +639,9 @@ EXPORTED int caldav_delmbox(struct calda
     return r;
 }
 
-
-#define CMD_GETUPDATES CMD_READFIELDS \
-      " WHERE comp_type = :comp_type AND modseq > :modseq" \
-      " ORDER BY modseq LIMIT :limit;"
-
-#define CMD_GETUPDATES_MBOX CMD_READFIELDS \
-      " WHERE mailbox = :mailbox AND comp_type = :comp_type AND modseq > :modseq" \
-      " ORDER BY modseq LIMIT :limit;"
-
 EXPORTED int caldav_get_updates(struct caldav_db *caldavdb,
-                                modseq_t oldmodseq, const char *mboxname, int kind, int limit,
+                                modseq_t oldmodseq, const char *mboxname,
+                                int kind, int limit,
                                 int (*cb)(void *rock, struct caldav_data *cdata),
                                 void *rock)
 {
@@ -581,19 +649,28 @@ EXPORTED int caldav_get_updates(struct c
         { ":mailbox",      SQLITE_TEXT,    { .s = mboxname  } },
         { ":modseq",       SQLITE_INTEGER, { .i = oldmodseq } },
         { ":comp_type",    SQLITE_INTEGER, { .i = kind      } },
+        /* SQLite interprets a negative limit as unbounded. */
         { ":limit",        SQLITE_INTEGER, { .i = limit > 0 ? limit : -1 } },
         { NULL,            SQLITE_NULL,    { .s = NULL      } }
     };
     static struct caldav_data cdata;
-    struct read_rock rrock = { caldavdb, &cdata, RROCK_FLAG_TOMBSTONES, cb, rock };
+    struct read_rock rrock =
+        { caldavdb, &cdata, RROCK_FLAG_TOMBSTONES, cb, rock };
+    struct buf sqlbuf = BUF_INITIALIZER;
     int r;
 
-    /* SQLite interprets a negative limit as unbounded. */
-    if (mboxname) {
-        r = sqldb_exec(caldavdb->db, CMD_GETUPDATES_MBOX, bval, &read_cb, &rrock);
-    } else {
-        r = sqldb_exec(caldavdb->db, CMD_GETUPDATES, bval, &read_cb, &rrock);
+    buf_setcstr(&sqlbuf, CMD_READFIELDS " WHERE");
+    if (mboxname) buf_appendcstr(&sqlbuf, " mailbox = :mailbox AND");
+    if (kind >= 0) {
+        /* Use a negative value to signal that we accept ALL components types */
+        buf_appendcstr(&sqlbuf, " comp_type = :comp_type AND");
     }
+    if (!oldmodseq) buf_appendcstr(&sqlbuf, " alive = 1 AND");
+    buf_appendcstr(&sqlbuf, " modseq > :modseq ORDER BY modseq LIMIT :limit;");
+
+    r = sqldb_exec(caldavdb->db, buf_cstring(&sqlbuf), bval, &read_cb, &rrock);
+    buf_free(&sqlbuf);
+
     if (r) {
         syslog(LOG_ERR, "caldav error %s", error_message(r));
     }
@@ -645,9 +722,7 @@ EXPORTED int caldav_writeentry(struct ca
     case ICAL_VJOURNAL_COMPONENT: mykind = CAL_COMP_VJOURNAL; break;
     case ICAL_VFREEBUSY_COMPONENT: mykind = CAL_COMP_VFREEBUSY; break;
     case ICAL_VAVAILABILITY_COMPONENT: mykind = CAL_COMP_VAVAILABILITY; break;
-#ifdef HAVE_VPOLL
     case ICAL_VPOLL_COMPONENT: mykind = CAL_COMP_VPOLL; break;
-#endif
     default: break;
     }
     cdata->comp_type = mykind;
@@ -693,7 +768,7 @@ EXPORTED int caldav_writeentry(struct ca
     cdata->comp_flags.transp = transp;
 
     /* Get span of component set and check for managed attachments */
-    span = icalrecurrenceset_get_utc_timespan(ical, kind, &recurring,
+    span = icalrecurrenceset_get_utc_timespan(ical, kind, NULL, &recurring,
                                               &check_mattach_cb, &mattach);
 
     cdata->dtstart = icaltime_as_ical_string(span.start);
@@ -725,22 +800,20 @@ EXPORTED char *caldav_mboxname(const cha
     return res;
 }
 
-#define CMD_SELMBOX CMD_READFIELDS \
-    " WHERE mailbox = :mailbox AND alive = 1;"
-
-EXPORTED int caldav_get_events(struct caldav_db *caldavdb,
+EXPORTED int caldav_get_events(struct caldav_db *caldavdb, const char *asuserid,
                                const char *mailbox, const char *ical_uid,
                                caldav_cb_t *cb, void *rock)
 {
     struct sqldb_bindval bval[] = {
         { ":mailbox",  SQLITE_TEXT, { .s = mailbox } },
         { ":ical_uid", SQLITE_TEXT, { .s = ical_uid } },
+        { ":asuserid", SQLITE_TEXT, { .s = asuserid } },
         { NULL,        SQLITE_NULL, { .s = NULL    } } };
     struct caldav_data cdata;
     struct read_rock rrock = { caldavdb, &cdata, 0, cb, rock };
     struct buf sqlbuf = BUF_INITIALIZER;
 
-    buf_setcstr(&sqlbuf, CMD_READFIELDS);
+    buf_setcstr(&sqlbuf, CMD_READFIELDS_JMAP);
     buf_appendcstr(&sqlbuf, " WHERE alive = 1");
     if (mailbox)
         buf_appendcstr(&sqlbuf, " AND mailbox = :mailbox");
@@ -754,10 +827,221 @@ EXPORTED int caldav_get_events(struct ca
     buf_free(&sqlbuf);
 
     if (r) {
-        syslog(LOG_ERR, "carddav error %s", error_message(r));
+        syslog(LOG_ERR, "caldav error %s", error_message(r));
         /* XXX - free memory */
     }
 
+    return r;
+}
+
+#define CMD_DELETE_JMAPCACHE_USER "DELETE FROM ical_jmapcache WHERE rowid = :rowid AND userid = :userid"
+#define CMD_INSERT_JMAPCACHE_USER                                           \
+    "INSERT INTO ical_jmapcache ( rowid, userid, jmapversion, jmapdata )"   \
+    " VALUES ( :rowid, :userid, :jmapversion, :jmapdata );"
+
+EXPORTED int caldav_write_jmapcache(struct caldav_db *caldavdb, int rowid, const char *userid, int version, const char *data)
+{
+    struct sqldb_bindval bval[] = {
+        { ":rowid",        SQLITE_INTEGER, { .i = rowid  } },
+        { ":userid",       SQLITE_TEXT,    { .s = userid } },
+        { ":jmapversion",  SQLITE_INTEGER, { .i = version } },
+        { ":jmapdata",     SQLITE_TEXT,    { .s = data   } },
+        { NULL,            SQLITE_NULL,    { .s = NULL   } } };
+    int r;
+
+    /* clean up existing records if any */
+    r = sqldb_exec(caldavdb->db, CMD_DELETE_JMAPCACHE_USER, bval, NULL, NULL);
+    if (r) return r;
+
+    /* insert the cache record */
+    return sqldb_exec(caldavdb->db, CMD_INSERT_JMAPCACHE_USER, bval, NULL, NULL);
+}
+
+struct shareacls_rock {
+    const char *userid;
+    char *principalname;
+    char *principalacl;
+    char *newprincipalacl;
+    char *outboxname;
+    char *outboxacl;
+    char *newoutboxacl;
+    hash_table user_access;
+};
+
+#define CALSHARE_WANTSCHED 1
+#define CALSHARE_HAVESCHED 2
+#define CALSHARE_WANTPRIN 4
+#define CALSHARE_HAVEPRIN 8
+
+static int _add_shareacls(const mbentry_t *mbentry, void *rock)
+{
+    struct shareacls_rock *share = rock;
+
+    char *acl = xstrdup(mbentry->acl);
+
+    int isprincipal = !strcmp(mbentry->name, share->principalname);
+    int isoutbox = !strcmp(mbentry->name, share->outboxname);
+
+    if (isprincipal) {
+        share->principalacl = xstrdup(acl);
+        share->newprincipalacl = xstrdup(acl);
+    }
+
+    if (isoutbox) {
+        share->outboxacl = xstrdup(acl);
+        share->newoutboxacl = xstrdup(acl);
+    }
+
+    char *userid;
+    char *nextid = NULL;
+    for (userid = acl; userid; userid = nextid) {
+        char *rightstr;
+        int access;
+
+        rightstr = strchr(userid, '\t');
+        if (!rightstr) break;
+        *rightstr++ = '\0';
+
+        nextid = strchr(rightstr, '\t');
+        if (!nextid) break;
+        *nextid++ = '\0';
+
+        /* skip system users and owner */
+        if (is_system_user(userid)) continue;
+        if (!strcmp(userid, share->userid)) continue;
+
+        cyrus_acl_strtomask(rightstr, &access);
+
+        unsigned long long have = (unsigned long long)hash_lookup(userid, &share->user_access);
+        unsigned long long set = have;
+
+        // if it's the principal, we have each user with principal read access
+        if (isprincipal) {
+            if ((access & DACL_READ) == DACL_READ)
+                set |= CALSHARE_HAVEPRIN;
+        }
+        // if it's the Outbox, we have each user with reply ability
+        else if (isoutbox) {
+            if ((access & (DACL_INVITE|DACL_REPLY)) == (DACL_INVITE|DACL_REPLY))
+                set |= CALSHARE_HAVESCHED;
+        }
+        // and if they can see anything else, then we NEED the above!
+        else {
+            if (access & ACL_READ)
+                set |= CALSHARE_WANTPRIN;
+            if (access & ACL_INSERT)
+                set |= CALSHARE_WANTSCHED;
+        }
+
+        if (set != have) hash_insert(userid, (void *)set, &share->user_access);
+    }
+
+    free(acl);
+    return 0;
+}
+
+static void _update_acls(const char *userid, void *data, void *rock)
+{
+    struct shareacls_rock *share = rock;
+    unsigned long long aclstatus = (unsigned long long)data;
+
+    if ((aclstatus & CALSHARE_WANTSCHED) && !(aclstatus & CALSHARE_HAVESCHED)) {
+        cyrus_acl_set(&share->newoutboxacl, userid, ACL_MODE_ADD, (DACL_INVITE|DACL_REPLY), NULL, NULL);
+    }
+
+    if (!(aclstatus & CALSHARE_WANTSCHED) && (aclstatus & CALSHARE_HAVESCHED)) {
+        cyrus_acl_set(&share->newoutboxacl, userid, ACL_MODE_REMOVE, (DACL_INVITE|DACL_REPLY), NULL, NULL);
+    }
+
+    if ((aclstatus & CALSHARE_WANTPRIN) && !(aclstatus & CALSHARE_HAVEPRIN)) {
+        cyrus_acl_set(&share->newprincipalacl, userid, ACL_MODE_ADD, DACL_READ, NULL, NULL);
+    }
+
+    if (!(aclstatus & CALSHARE_WANTPRIN) && (aclstatus & CALSHARE_HAVEPRIN)) {
+        cyrus_acl_set(&share->newprincipalacl, userid, ACL_MODE_REMOVE, DACL_READ, NULL, NULL);
+    }
+}
+
+/* update the share acls.  We do this by:
+ * 1) iterating all the calendars for this user, looking at all the ACLs and
+ *    tracking for each user mentioned, whether they have or need principal
+ *    access or scheduling access.
+ * 2) when we see the inbox and outbox, clone the ACLs.
+ * 3) iterate all seen users, and decide whether we need to change the ACLs
+ *    for either of those mailboxes.
+ */
+EXPORTED int caldav_update_shareacls(const char *userid)
+{
+    struct shareacls_rock rock = {
+        userid,
+        NULL, NULL, NULL,
+        NULL, NULL, NULL,
+        HASH_TABLE_INITIALIZER
+    };
+    construct_hash_table(&rock.user_access, 10, 0);
+    rock.principalname = caldav_mboxname(userid, NULL);
+    rock.outboxname = caldav_mboxname(userid, SCHED_OUTBOX);
+
+    // find out what the values should be
+    int r = mboxlist_mboxtree(rock.principalname, _add_shareacls, &rock, 0);
+
+    // did we find the ACLs?  If not, bail now!
+    if (!rock.principalacl || !rock.outboxacl) {
+        r = IMAP_MAILBOX_NONEXISTENT;
+        goto done;
+    }
+
+    // change the ACLs as required
+    hash_enumerate(&rock.user_access, _update_acls, &rock);
+
+    if (strcmp(rock.principalacl, rock.newprincipalacl)) {
+        r = mboxlist_updateacl_raw(rock.principalname, rock.newprincipalacl);
+        if (r) goto done;
+    }
+
+    if (strcmp(rock.outboxacl, rock.newoutboxacl)) {
+        r = mboxlist_updateacl_raw(rock.outboxname, rock.newoutboxacl);
+        if (r) goto done;
+    }
+
+done:
+    free(rock.principalname);
+    free(rock.principalacl);
+    free(rock.newprincipalacl);
+    free(rock.outboxname);
+    free(rock.outboxacl);
+    free(rock.newoutboxacl);
+    free_hash_table(&rock.user_access, NULL);
 
     return r;
 }
+
+
+EXPORTED const char *caldav_comp_type_as_string(unsigned comp_type)
+{
+    switch (comp_type) {
+        /* "Real" components */
+        case CAL_COMP_VEVENT:
+            return "VEVENT";
+        case CAL_COMP_VTODO:
+            return "VTODO";
+        case CAL_COMP_VJOURNAL:
+            return "VJOURNAL";
+        case CAL_COMP_VFREEBUSY:
+            return "VFREEBUSY";
+        case CAL_COMP_VAVAILABILITY:
+            return "VAVAILABILITY";
+        case CAL_COMP_VPOLL:
+            return "VPOLL";
+        /* Other components */
+        case CAL_COMP_VALARM:
+            return "VALARM";
+        case CAL_COMP_VTIMEZONE:
+            return "VTIMEZONE";
+        case CAL_COMP_VCALENDAR:
+            return "VCALENDAR";
+        default:
+            return NULL;
+    }
+}
+
diff -pruN 3.0.13-5/imap/caldav_db.h 3.2.0-3/imap/caldav_db.h
--- 3.0.13-5/imap/caldav_db.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/caldav_db.h	2020-04-24 02:03:00.000000000 +0000
@@ -52,21 +52,7 @@ extern time_t caldav_eternity;
 #include <libical/ical.h>
 
 #include "dav_db.h"
-
-#ifndef HAVE_VAVAILABILITY
-/* Allow us to compile without #ifdef HAVE_VAVAILABILITY everywhere */
-#define ICAL_VAVAILABILITY_COMPONENT  ICAL_X_COMPONENT
-#define ICAL_XAVAILABLE_COMPONENT     ICAL_X_COMPONENT
-#endif
-
-#ifndef HAVE_VPOLL
-/* Allow us to compile without #ifdef HAVE_VPOLL everywhere */
-#define ICAL_VPOLL_COMPONENT          ICAL_NO_COMPONENT
-#define ICAL_VVOTER_COMPONENT         ICAL_X_COMPONENT
-#define ICAL_METHOD_POLLSTATUS        ICAL_METHOD_NONE
-#define ICAL_VOTER_PROPERTY           ICAL_NO_PROPERTY
-#define icalproperty_get_voter        icalproperty_get_attendee
-#endif
+#include "ical_support.h"
 
 /* Bitmask of calendar components */
 enum {
@@ -85,6 +71,9 @@ enum {
     CAL_COMP_VCALENDAR =        (1<<15)
 };
 
+/* Returns NULL for unknown type */
+extern const char *caldav_comp_type_as_string(unsigned comp_type);
+
 #define CAL_COMP_REAL            0xff   /* All "real" components */
 
 struct caldav_db;
@@ -95,6 +84,7 @@ struct comp_flags {
     unsigned status       : 2;          /* STATUS property value (see below) */
     unsigned tzbyref      : 1;          /* VTIMEZONEs by reference */
     unsigned mattach      : 1;          /* Has managed ATTACHment(s) */
+    unsigned shared       : 1;          /* Is shared (per-user-data stripped) */
 };
 
 /* Status values */
@@ -114,6 +104,8 @@ struct caldav_data {
     const char *dtend;
     struct comp_flags comp_flags;
     const char *sched_tag;
+    int jmapversion;
+    const char *jmapdata;
 };
 
 typedef int caldav_cb_t(void *rock, struct caldav_data *cdata);
@@ -154,12 +146,23 @@ int caldav_lookup_uid(struct caldav_db *
 int caldav_foreach(struct caldav_db *caldavdb, const char *mailbox,
                    caldav_cb_t *cb, void *rock);
 
+enum caldav_sort {
+    CAL_SORT_NONE = 0,
+    CAL_SORT_UID,
+    CAL_SORT_START,
+    CAL_SORT_MAILBOX,
+    CAL_SORT_DESC  = 0x80 /* bit-flag for descending sort */
+};
+
 /* process each entry for 'mailbox' in 'caldavdb' with cb()
  * which last recurrence ends after 'after' and first
  * recurrence starts before 'before'. The largest possible
- * timerange spans from caldav_epoch to caldav_eternity. */
+ * timerange spans from caldav_epoch to caldav_eternity.
+ * The callback is called in order of sort, or by an
+ * arbitrary order if no sort is specified. */
 int caldav_foreach_timerange(struct caldav_db *caldavdb, const char *mailbox,
                              time_t after, time_t before,
+                             enum caldav_sort* sort, size_t nsort,
                              caldav_cb_t *cb, void *rock);
 
 /* write an entry to 'caldavdb' */
@@ -184,16 +187,24 @@ int caldav_abort(struct caldav_db *calda
 
 char *caldav_mboxname(const char *userid, const char *name);
 
-int caldav_get_events(struct caldav_db *caldavdb,
+int caldav_get_events(struct caldav_db *caldavdb, const char *asuserid,
                       const char *mailbox, const char *ical_uid,
                       caldav_cb_t *cb, void *rock);
 
+int caldav_write_jmapcache(struct caldav_db *caldavdb, int rowid,
+                           const char *userid, int version, const char *data);
+
+
 /* Process each entry for 'caldavdb' with a modseq higher than oldmodseq,
  * in ascending order of modseq.
  * If mailbox is not NULL, only process entries of this mailbox.
+ * If kind is non-negative, only process entries of this kind.
  * If max_records is positive, only call cb for at most this entries. */
 int caldav_get_updates(struct caldav_db *caldavdb,
                        modseq_t oldmodseq, const char *mailbox, int kind,
                        int max_records, caldav_cb_t *cb, void *rock);
 
+/* Update all the share ACLs */
+int caldav_update_shareacls(const char *userid);
+
 #endif /* CALDAV_DB_H */
diff -pruN 3.0.13-5/imap/carddav_db.c 3.2.0-3/imap/carddav_db.c
--- 3.0.13-5/imap/carddav_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/carddav_db.c	2020-05-04 03:28:02.000000000 +0000
@@ -67,22 +67,40 @@ struct carddav_db {
     char *userid;
 };
 
+static int carddav_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    carddav_done();
+}
+
+static void init_internal() {
+    if (!carddav_initialized) {
+        carddav_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
 
 EXPORTED int carddav_init(void)
 {
-    return sqldb_init();
+    int r = sqldb_init();
+    if (!r) carddav_initialized = 1;
+    return r;
 }
 
 
 EXPORTED int carddav_done(void)
 {
-    return sqldb_done();
+    int r = sqldb_done();
+    if (!r) carddav_initialized = 0;
+    return r;
 }
 
 EXPORTED struct carddav_db *carddav_open_userid(const char *userid)
 {
     struct carddav_db *carddavdb = NULL;
 
+    init_internal();
+
     sqldb_t *db = dav_open_userid(userid);
     if (!db) return NULL;
 
@@ -98,6 +116,8 @@ EXPORTED struct carddav_db *carddav_open
     struct carddav_db *carddavdb = NULL;
     char *userid = mboxname_to_userid(mailbox->name);
 
+    init_internal();
+
     if (userid) {
         carddavdb = carddav_open_userid(userid);
         free(userid);
@@ -113,6 +133,12 @@ EXPORTED struct carddav_db *carddav_open
     return carddavdb;
 }
 
+EXPORTED int carddav_set_otheruser(struct carddav_db *carddavdb, const char *userid)
+{
+    sqldb_detach(carddavdb->db); // remove any current
+    return dav_attach_userid(carddavdb->db, userid);
+}
+
 
 /* Close DAV DB */
 EXPORTED int carddav_close(struct carddav_db *carddavdb)
@@ -170,9 +196,16 @@ static const char *column_text_to_buf(co
     "SELECT rowid, creationdate, mailbox, resource, imap_uid,"          \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
     "  version, vcard_uid, kind, fullname, name, nickname, alive,"      \
-    "  modseq" \
+    "  modseq, createdmodseq, NULL, NULL" \
     " FROM vcard_objs"
 
+#define CMD_GETFIELDS_JMAP                                              \
+    "SELECT vcard_objs.rowid, creationdate, mailbox, resource, imap_uid," \
+    "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
+    "  version, vcard_uid, kind, fullname, name, nickname, alive,"      \
+    "  modseq, createdmodseq, jmapversion, jmapdata" \
+    " FROM vcard_objs LEFT JOIN vcard_jmapcache USING (rowid)"
+
 static int read_cb(sqlite3_stmt *stmt, void *rock)
 {
     struct read_rock *rrock = (struct read_rock *) rock;
@@ -183,7 +216,8 @@ static int read_cb(sqlite3_stmt *stmt, v
     memset(cdata, 0, sizeof(struct carddav_data));
 
     cdata->dav.alive = sqlite3_column_int(stmt, 15);
-    cdata->dav.modseq = sqlite3_column_int(stmt, 16);
+    cdata->dav.modseq = sqlite3_column_int64(stmt, 16);
+    cdata->dav.createdmodseq = sqlite3_column_int64(stmt, 17);
     if (!rrock->tombstones && !cdata->dav.alive)
         return 0;
 
@@ -193,6 +227,7 @@ static int read_cb(sqlite3_stmt *stmt, v
     cdata->dav.lock_expire = sqlite3_column_int(stmt, 8);
     cdata->version = sqlite3_column_int(stmt, 9);
     cdata->kind = sqlite3_column_int(stmt, 11);
+    cdata->jmapversion = sqlite3_column_int(stmt, 18);
 
     if (rrock->cb) {
         /* We can use the column data directly for the callback */
@@ -205,6 +240,7 @@ static int read_cb(sqlite3_stmt *stmt, v
         cdata->fullname = (const char *) sqlite3_column_text(stmt, 12);
         cdata->name = (const char *) sqlite3_column_text(stmt, 13);
         cdata->nickname = (const char *) sqlite3_column_text(stmt, 14);
+        cdata->jmapdata = (const char *) sqlite3_column_text(stmt, 19);
         r = rrock->cb(rrock->rock, cdata);
     }
     else {
@@ -238,6 +274,9 @@ static int read_cb(sqlite3_stmt *stmt, v
         cdata->nickname =
             column_text_to_buf((const char *) sqlite3_column_text(stmt, 14),
                                &db->bufs[8]);
+        cdata->jmapdata =
+            column_text_to_buf((const char *) sqlite3_column_text(stmt, 15),
+                                &db->bufs[9]);
     }
 
     return r;
@@ -272,6 +311,34 @@ EXPORTED int carddav_lookup_resource(str
 }
 
 
+#define CMD_SELIMAPUID CMD_GETFIELDS \
+    " WHERE mailbox = :mailbox AND imap_uid = :imap_uid;"
+
+EXPORTED int carddav_lookup_imapuid(struct carddav_db *carddavdb,
+                                    const char *mailbox, int imap_uid,
+                                    struct carddav_data **result,
+                                    int tombstones)
+{
+    struct sqldb_bindval bval[] = {
+        { ":mailbox",  SQLITE_TEXT,    { .s = mailbox       } },
+        { ":imap_uid", SQLITE_INTEGER, { .i = imap_uid      } },
+        { NULL,        SQLITE_NULL,    { .s = NULL          } } };
+    static struct carddav_data cdata;
+    struct read_rock rrock = { carddavdb, &cdata, tombstones, NULL, NULL };
+    int r;
+
+    *result = memset(&cdata, 0, sizeof(struct carddav_data));
+
+    r = sqldb_exec(carddavdb->db, CMD_SELIMAPUID, bval, &read_cb, &rrock);
+    if (!r && !cdata.dav.rowid) r = CYRUSDB_NOTFOUND;
+
+    cdata.dav.mailbox = mailbox;
+    cdata.dav.imap_uid = imap_uid;
+
+    return r;
+}
+
+
 #define CMD_SELUID CMD_GETFIELDS \
     " WHERE vcard_uid = :vcard_uid AND alive = 1;"
 
@@ -295,26 +362,70 @@ EXPORTED int carddav_lookup_uid(struct c
 
 
 #define CMD_SELMBOX CMD_GETFIELDS \
-    " WHERE mailbox = :mailbox AND alive = 1 ORDER BY modseq DESC;"
+    " WHERE mailbox = :mailbox AND alive = 1"
 
 #define CMD_SELALIVE CMD_GETFIELDS \
-    " WHERE alive = 1 ORDER BY modseq DESC;"
+    " WHERE alive = 1"
+
+#define CMD_DEFAULT_ORDER " ORDER BY modseq DESC;"
 
 EXPORTED int carddav_foreach(struct carddav_db *carddavdb, const char *mailbox,
                    int (*cb)(void *rock, struct carddav_data *data),
                    void *rock)
 {
+    return carddav_foreach_sort(carddavdb, mailbox, NULL, 0, cb, rock);
+}
+
+EXPORTED int carddav_foreach_sort(struct carddav_db *carddavdb, const char *mailbox,
+                                  enum carddav_sort* sort, size_t nsort,
+                                  int (*cb)(void *rock, struct carddav_data *data),
+                                  void *rock)
+{
     struct sqldb_bindval bval[] = {
         { ":mailbox", SQLITE_TEXT, { .s = mailbox } },
         { NULL,       SQLITE_NULL, { .s = NULL    } } };
     struct carddav_data cdata;
     struct read_rock rrock = { carddavdb, &cdata, 0, cb, rock };
 
-    if (mailbox) {
-        return sqldb_exec(carddavdb->db, CMD_SELMBOX, bval, &read_cb, &rrock);
-    } else {
-        return sqldb_exec(carddavdb->db, CMD_SELALIVE, bval, &read_cb, &rrock);
+    if (!nsort) {
+        if (mailbox) {
+            return sqldb_exec(carddavdb->db, CMD_SELMBOX CMD_DEFAULT_ORDER,
+                              bval, &read_cb, &rrock);
+        } else {
+            return sqldb_exec(carddavdb->db, CMD_SELALIVE CMD_DEFAULT_ORDER,
+                              bval, &read_cb, &rrock);
+        }
+    }
+
+    struct buf stmt = BUF_INITIALIZER;
+    buf_setcstr(&stmt, mailbox ? CMD_SELMBOX : CMD_SELALIVE);
+    buf_appendcstr(&stmt, " ORDER BY");
+    size_t i;
+    for (i = 0; i < nsort; i++) {
+        const char *column = NULL;
+        switch (sort[i] & ~CARD_SORT_DESC) {
+            case CARD_SORT_MODSEQ:
+                column = "modseq";
+                break;
+            case CARD_SORT_UID:
+                column = "vcard_uid";
+                break;
+            case CARD_SORT_FULLNAME:
+                column = "fullname";
+                break;
+            default:
+                continue;
+        }
+        if (i) buf_putc(&stmt, ',');
+        buf_putc(&stmt, ' ');
+        buf_appendcstr(&stmt, column);
+        buf_appendcstr(&stmt, sort[i] & CARD_SORT_DESC ? " DESC" : " ASC");
     }
+    buf_putc(&stmt, ';');
+
+    int r = sqldb_exec(carddavdb->db, buf_cstring(&stmt), bval, &read_cb, &rrock);
+    buf_free(&stmt);
+    return r;
 }
 
 #define CMD_GETUID_GROUPS \
@@ -374,8 +485,8 @@ EXPORTED strarray_t *carddav_getuid_grou
     " AND G.objid = GO.rowid AND E.email = :email" \
     " AND GO.alive = 1 AND CO.alive = 1;"
 
-#define CMD_GETEMAIL2UIDS \
-    "SELECT DISTINCT vcard_uid " \
+#define CMD_GETEMAIL2DETAILS \
+    "SELECT DISTINCT vcard_uid, ispinned " \
     " FROM vcard_objs CO JOIN vcard_emails E" \
     " WHERE E.objid = CO.rowid AND CO.alive = 1" \
     " AND E.email = :email AND CO.mailbox = :mailbox;"
@@ -425,19 +536,38 @@ EXPORTED strarray_t *carddav_getemail(st
     return groups;
 }
 
-EXPORTED strarray_t *carddav_getemail2uids(struct carddav_db *carddavdb, const char *email,
-                                           const char *mboxname)
+struct detailsdata {
+    strarray_t *uids;
+    int ispinned;
+};
+
+static int details_cb(sqlite3_stmt *stmt, void *rock)
+{
+    struct detailsdata *data = (struct detailsdata *)rock;
+    const char *value = (const char *)sqlite3_column_text(stmt, 0);
+    if (value) strarray_add(data->uids, value);
+    if (sqlite3_column_int(stmt, 1))
+        data->ispinned = 1;
+    return 0;
+}
+
+EXPORTED strarray_t *carddav_getemail2details(struct carddav_db *carddavdb, const char *email,
+                                              const char *mboxname, int *ispinned)
 {
     struct sqldb_bindval bval[] = {
         { ":email", SQLITE_TEXT,   { .s = email } },
         { ":mailbox", SQLITE_TEXT, { .s = mboxname } },
         { NULL,     SQLITE_NULL,   { .s = NULL  } }
     };
-    strarray_t *uids = strarray_new();
+    struct detailsdata data = { strarray_new(), 0 };
 
-    sqldb_exec(carddavdb->db, CMD_GETEMAIL2UIDS, bval, &addarray_cb, uids);
+    sqldb_exec(carddavdb->db, CMD_GETEMAIL2DETAILS, bval, &details_cb, &data);
 
-    return uids;
+    if (ispinned) {
+        *ispinned = data.ispinned;
+    }
+
+    return data.uids;
 }
 
 EXPORTED strarray_t *carddav_getuid2groups(struct carddav_db *carddavdb, const char *member_uid,
@@ -456,18 +586,67 @@ EXPORTED strarray_t *carddav_getuid2grou
     return groups;
 }
 
+/* FUNCTIONS FOR LOOKING UP headerAllContacts */
+
+#define GETALL_LOCAL \
+    "SELECT DISTINCT E.email FROM vcard_emails E" \
+    " JOIN vcard_objs CO" \
+    " WHERE E.objid = CO.rowid AND CO.alive = 1" \
+    " AND (:mailbox IS NULL OR CO.mailbox = :mailbox)"
+
+#define GETALL_MEMBERS GETALL_LOCAL ";"
+
+#define GETALL_OTHERMEMBERS \
+    GETALL_LOCAL " UNION " \
+    "SELECT DISTINCT E.email FROM other.vcard_emails E" \
+    " JOIN other.vcard_objs CO" \
+    " WHERE E.objid = CO.rowid AND CO.alive = 1" \
+    " AND CO.mailbox = :othermailbox;"
+
+/* FUNCTIONS FOR LOOKING UP headerContactGroupId on own groups */
 
-#define CMD_GETGROUP_EXISTS \
+#define GETGROUP_EXISTS \
     "SELECT rowid " \
     " FROM vcard_objs" \
-    " WHERE mailbox = :mailbox AND kind = :kind AND vcard_uid = :group AND alive = 1;"
+    " WHERE kind = :kind AND vcard_uid = :group AND alive = 1" \
+    " AND (:mailbox IS NULL OR mailbox = :mailbox);"
 
-#define CMD_GETGROUP_MEMBERS \
-    "SELECT E.email FROM vcard_emails E" \
+#define GETGROUP_LOCAL \
+    "SELECT DISTINCT E.email FROM vcard_emails E" \
     " JOIN vcard_objs CO JOIN vcard_groups G JOIN vcard_objs GO" \
     " WHERE E.objid = CO.rowid AND CO.vcard_uid = G.member_uid AND G.objid = GO.rowid" \
-    " AND E.pos = 0 AND GO.mailbox = :mailbox AND GO.vcard_uid = :group" \
-    " AND GO.alive = 1 AND CO.alive = 1;"
+    " AND G.otheruser = '' AND GO.vcard_uid = :group AND GO.alive = 1 AND CO.alive = 1" \
+    " AND (:mailbox IS NULL OR GO.mailbox = :mailbox)"
+
+#define GETGROUP_MEMBERS GETGROUP_LOCAL ";"
+
+#define GETGROUP_OTHERMEMBERS \
+    GETGROUP_LOCAL " UNION " \
+    "SELECT DISTINCT E.email FROM other.vcard_emails E" \
+    " JOIN other.vcard_objs CO JOIN vcard_groups G JOIN vcard_objs GO" \
+    " WHERE E.objid = CO.rowid AND CO.vcard_uid = G.member_uid AND G.objid = GO.rowid" \
+    " AND G.otheruser = :otheruser AND GO.vcard_uid = :group AND GO.alive = 1 AND CO.alive = 1" \
+    " AND (:mailbox IS NULL OR GO.mailbox = :mailbox) AND CO.mailbox = :othermailbox;"
+
+/* FUNCTIONS FOR LOOKING UPO headerContactGroupId on shared groups:
+ * this is different than GROUP_OTHERMEMBERS in the following way,
+ * GROUP_OTHERMEMBERS: the group is in the user, but contains a member in the masteruser
+ * OTHERGROUP_MEMBERS: the group is in the masteruser, containing members in the masteruser
+ */
+
+#define GETOTHERGROUP_EXISTS \
+    "SELECT rowid " \
+    " FROM other.vcard_objs" \
+    " WHERE kind = :kind AND vcard_uid = :group AND alive = 1" \
+    " AND mailbox = :othermailbox;"
+
+// need to make sure all the contacts are only in 'Shared' as well!
+#define GETOTHERGROUP_MEMBERS \
+    "SELECT DISTINCT E.email FROM other.vcard_emails E" \
+    " JOIN other.vcard_objs CO JOIN other.vcard_groups G JOIN other.vcard_objs GO" \
+    " WHERE E.objid = CO.rowid AND CO.vcard_uid = G.member_uid AND G.objid = GO.rowid" \
+    " AND G.otheruser = '' AND GO.vcard_uid = :group AND GO.alive = 1 AND CO.alive = 1" \
+    " AND GO.mailbox = :othermailbox AND CO.mailbox = :othermailbox;"
 
 static int groupexists_cb(sqlite3_stmt *stmt, void *rock)
 {
@@ -480,35 +659,59 @@ static int groupexists_cb(sqlite3_stmt *
 static int groupmembers_cb(sqlite3_stmt *stmt, void *rock)
 {
     strarray_t *array = (strarray_t *)rock;
-    strarray_add(array, (const char *)sqlite3_column_text(stmt, 0));
+    strarray_append(array, (const char *)sqlite3_column_text(stmt, 0));
     return 0;
 }
 
-EXPORTED strarray_t *carddav_getgroup(struct carddav_db *carddavdb, const char *mailbox, const char *group)
+EXPORTED strarray_t *carddav_getgroup(struct carddav_db *carddavdb, const char *mailbox, const char *group,
+                                      mbname_t *othermb)
 {
+    int r = 0;
+    int isshared = 0;
+    if (!strncmpsafe(group, "shared/", 7)) {
+        assert(!mailbox); // no mailbox filter on shared groups
+        if (!carddavdb->db->attached) return NULL;
+        if (!*group) return NULL; // can't just be "shared/"
+        isshared = 1;
+        group += 7;
+    }
+
     struct sqldb_bindval bval[] = {
-        { ":mailbox", SQLITE_TEXT,    { .s = mailbox } },
-        { ":group",   SQLITE_TEXT,    { .s = group   } },
-        { ":kind",    SQLITE_INTEGER, { .i = CARDDAV_KIND_GROUP } },
-        { NULL,       SQLITE_NULL,    { .s = NULL    } }
+        { ":mailbox",      SQLITE_TEXT,    { .s = mailbox } },
+        { ":group",        SQLITE_TEXT,    { .s = group   } },
+        { ":kind",         SQLITE_INTEGER, { .i = CARDDAV_KIND_GROUP } },
+        { ":otheruser",    SQLITE_TEXT,    { .s = othermb ? mbname_userid(othermb) : NULL } },
+        { ":othermailbox", SQLITE_TEXT,    { .s = othermb ? mbname_intname(othermb) : NULL } },
+        { NULL,            SQLITE_NULL,    { .s = NULL    } }
     };
 
-    int exists = 0;
-    strarray_t *members;
-    int r;
+    if (*group) {
+        // first check that the group exists
 
-    r = sqldb_exec(carddavdb->db, CMD_GETGROUP_EXISTS, bval, &groupexists_cb, &exists);
-    if (r) {
-        /* XXX syslog */
-        return NULL;
+        const char *existsql = isshared ? GETOTHERGROUP_EXISTS : GETGROUP_EXISTS;
+        int exists = 0;
+        r = sqldb_exec(carddavdb->db, existsql, bval, &groupexists_cb, &exists);
+        if (r) {
+            /* XXX syslog */
+            return NULL;
+        }
+
+        if (!exists)
+            return NULL;
     }
 
-    if (!exists)
-        return NULL;
+    strarray_t *members = strarray_new();
 
-    members = strarray_new();
+    // pick which filter to use!
+    const char *membersql = GETGROUP_MEMBERS;
+    if (carddavdb->db->attached) {
+        if (isshared) membersql = GETOTHERGROUP_MEMBERS;
+        else if (!*group) membersql = GETALL_OTHERMEMBERS;
+        else membersql = GETGROUP_OTHERMEMBERS;
+    }
+    else if (!*group) membersql = GETALL_MEMBERS;
 
-    r = sqldb_exec(carddavdb->db, CMD_GETGROUP_MEMBERS, bval, &groupmembers_cb, members);
+    r = sqldb_exec(carddavdb->db, membersql, bval, &groupmembers_cb, members);
     if (r) {
         /* XXX syslog */
     }
@@ -519,16 +722,17 @@ EXPORTED strarray_t *carddav_getgroup(st
 
 #define CMD_DELETE_EMAIL "DELETE FROM vcard_emails WHERE objid = :objid"
 #define CMD_INSERT_EMAIL                                                \
-    "INSERT INTO vcard_emails ( objid, pos, email, ispref )"            \
-    " VALUES ( :objid, :pos, :email, :ispref );"
+    "INSERT INTO vcard_emails ( objid, pos, email, ispref, ispinned )"            \
+    " VALUES ( :objid, :pos, :email, :ispref, :ispinned );"
 
-static int carddav_write_emails(struct carddav_db *carddavdb, int rowid, const strarray_t *emails)
+static int carddav_write_emails(struct carddav_db *carddavdb, int rowid, const strarray_t *emails, int ispinned)
 {
     struct sqldb_bindval bval[] = {
         { ":objid",        SQLITE_INTEGER, { .i = rowid  } },
         { ":pos",          SQLITE_INTEGER, { .i = 0      } },
         { ":email",        SQLITE_TEXT,    { .s = NULL   } },
         { ":ispref",       SQLITE_INTEGER, { .i = 0      } },
+        { ":ispinned",     SQLITE_INTEGER, { .i = 0      } },
         { NULL,            SQLITE_NULL,    { .s = NULL   } } };
     int r;
     int i;
@@ -541,6 +745,7 @@ static int carddav_write_emails(struct c
         bval[1].val.i = i;
         bval[2].val.s = strarray_safenth(emails, i*2);
         bval[3].val.i = *pref ? 1 : 0;
+        bval[4].val.i = ispinned ? 1 : 0;
         r = sqldb_exec(carddavdb->db, CMD_INSERT_EMAIL, bval, NULL, NULL);
         if (r) return r;
     }
@@ -548,11 +753,40 @@ static int carddav_write_emails(struct c
     return 0;
 }
 
+static int carddav_delete_emails(struct carddav_db *carddavdb, int rowid)
+{
+    struct sqldb_bindval bval[] = {
+        { ":rowid", SQLITE_INTEGER, { .i = rowid } },
+        { NULL,     SQLITE_NULL,    { .s = NULL  } } };
+    int r;
+
+    r = sqldb_exec(carddavdb->db, CMD_DELETE_EMAIL, bval, NULL, NULL);
+    if (r) return r;
+
+    return 0;
+}
+
 #define CMD_DELETE_GROUP "DELETE FROM vcard_groups WHERE objid = :objid"
 #define CMD_INSERT_GROUP                                                \
     "INSERT INTO vcard_groups ( objid, pos, member_uid, otheruser )"    \
     " VALUES ( :objid, :pos, :member_uid, :otheruser );"
 
+static int carddav_delete_groups(struct carddav_db *carddavdb, int rowid)
+{
+    struct sqldb_bindval bval[] = {
+        { ":objid",        SQLITE_INTEGER, { .i = rowid        } },
+        { ":pos",          SQLITE_INTEGER, { .i = 0            } },
+        { ":member_uid",   SQLITE_TEXT,    { .s = NULL         } },
+        { ":otheruser",    SQLITE_TEXT,    { .s = NULL         } },
+        { NULL,            SQLITE_NULL,    { .s = NULL         } } };
+    int r;
+
+    r = sqldb_exec(carddavdb->db, CMD_DELETE_GROUP, bval, NULL, NULL);
+    if (r) return r;
+
+    return 0;
+}
+
 static int carddav_write_groups(struct carddav_db *carddavdb, int rowid, const strarray_t *member_uids)
 {
     struct sqldb_bindval bval[] = {
@@ -581,10 +815,12 @@ static int carddav_write_groups(struct c
 #define CMD_INSERT                                                      \
     "INSERT INTO vcard_objs ("                                          \
     "  alive, creationdate, mailbox, resource, imap_uid, modseq,"       \
+    "  createdmodseq,"                                                  \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
     "  version, vcard_uid, kind, fullname, name, nickname)"             \
     " VALUES ("                                                         \
     "  :alive, :creationdate, :mailbox, :resource, :imap_uid, :modseq," \
+    "  :createdmodseq,"                                                 \
     "  :lock_token, :lock_owner, :lock_ownerid, :lock_expire,"          \
     "  :version, :vcard_uid, :kind, :fullname, :name, :nickname );"
 
@@ -594,6 +830,7 @@ static int carddav_write_groups(struct c
     "  creationdate = :creationdate,"   \
     "  imap_uid     = :imap_uid,"       \
     "  modseq       = :modseq,"         \
+    "  createdmodseq = :createdmodseq," \
     "  lock_token   = :lock_token,"     \
     "  lock_owner   = :lock_owner,"     \
     "  lock_ownerid = :lock_ownerid,"   \
@@ -606,6 +843,7 @@ static int carddav_write_groups(struct c
     "  nickname     = :nickname"        \
     " WHERE rowid = :rowid;"
 
+#define CMD_DELETE_JMAPCACHE "DELETE FROM vcard_jmapcache WHERE rowid = :rowid"
 
 EXPORTED int carddav_write(struct carddav_db *carddavdb, struct carddav_data *cdata)
 {
@@ -617,6 +855,7 @@ EXPORTED int carddav_write(struct cardda
         { ":resource",     SQLITE_TEXT,    { .s = cdata->dav.resource     } },
         { ":imap_uid",     SQLITE_INTEGER, { .i = cdata->dav.imap_uid     } },
         { ":modseq",       SQLITE_INTEGER, { .i = cdata->dav.modseq       } },
+        { ":createdmodseq", SQLITE_INTEGER, { .i = cdata->dav.createdmodseq } },
         { ":lock_token",   SQLITE_TEXT,    { .s = cdata->dav.lock_token   } },
         { ":lock_owner",   SQLITE_TEXT,    { .s = cdata->dav.lock_owner   } },
         { ":lock_ownerid", SQLITE_TEXT,    { .s = cdata->dav.lock_ownerid } },
@@ -630,7 +869,9 @@ EXPORTED int carddav_write(struct cardda
         { NULL,            SQLITE_NULL,    { .s = NULL                    } } };
 
     if (cdata->dav.rowid) {
-        int r = sqldb_exec(carddavdb->db, CMD_UPDATE, bval, NULL, NULL);
+        int r = sqldb_exec(carddavdb->db, CMD_DELETE_JMAPCACHE, bval, NULL, NULL);
+        if (r) return r;
+        r = sqldb_exec(carddavdb->db, CMD_UPDATE, bval, NULL, NULL);
         if (r) return r;
     }
     else {
@@ -653,6 +894,8 @@ EXPORTED int carddav_delete(struct cardd
     int r;
 
     r = sqldb_exec(carddavdb->db, CMD_DELETE, bval, NULL, NULL);
+    if (!r) r = carddav_delete_emails(carddavdb, rowid);
+    if (!r) r = carddav_delete_groups(carddavdb, rowid);
     if (r) return r;
 
     return 0;
@@ -674,6 +917,27 @@ EXPORTED int carddav_delmbox(struct card
     return 0;
 }
 
+#define CMD_INSERT_JMAPCACHE                                                \
+    "INSERT INTO vcard_jmapcache ( rowid, jmapversion, jmapdata )"          \
+    " VALUES ( :rowid, :jmapversion, :jmapdata );"
+
+EXPORTED int carddav_write_jmapcache(struct carddav_db *carddavdb, int rowid, int version, const char *data)
+{
+    struct sqldb_bindval bval[] = {
+        { ":rowid",        SQLITE_INTEGER, { .i = rowid  } },
+        { ":jmapversion",  SQLITE_INTEGER, { .i = version } },
+        { ":jmapdata",     SQLITE_TEXT,    { .s = data   } },
+        { NULL,            SQLITE_NULL,    { .s = NULL   } } };
+    int r;
+
+    /* clean up existing records if any */
+    r = sqldb_exec(carddavdb->db, CMD_DELETE_JMAPCACHE, bval, NULL, NULL);
+    if (r) return r;
+
+    /* insert the cache record */
+    return sqldb_exec(carddavdb->db, CMD_INSERT_JMAPCACHE, bval, NULL, NULL);
+}
+
 EXPORTED int carddav_get_cards(struct carddav_db *carddavdb,
                                const char *abookname,
                                const char *vcard_uid, int kind,
@@ -691,7 +955,7 @@ EXPORTED int carddav_get_cards(struct ca
     struct read_rock rrock = { carddavdb, &cdata, 0, cb, rock };
     struct buf sqlbuf = BUF_INITIALIZER;
 
-    buf_setcstr(&sqlbuf, CMD_GETFIELDS);
+    buf_setcstr(&sqlbuf, CMD_GETFIELDS_JMAP);
     buf_appendcstr(&sqlbuf, " WHERE alive = 1 AND kind = :kind");
     if (abookname)
         buf_appendcstr(&sqlbuf, " AND mailbox = :mailbox");
@@ -702,21 +966,23 @@ EXPORTED int carddav_get_cards(struct ca
     int r = sqldb_exec(carddavdb->db, buf_cstring(&sqlbuf), bval, &read_cb, &rrock);
     buf_free(&sqlbuf);
     if (r) {
-        syslog(LOG_ERR, "caldav error %s", error_message(r));
+        syslog(LOG_ERR, "carddav error %s", error_message(r));
         /* XXX - free memory */
     }
 
     return r;
 }
 
-#define CMD_GETUPDATES CMD_GETFIELDS \
-  " WHERE kind = :kind AND modseq > :modseq;"
 
-#define CMD_GETUPDATES_MBOX CMD_GETFIELDS \
-  " WHERE mailbox = :mailbox AND kind = :kind AND modseq > :modseq;"
+#define BYMAILBOX " mailbox = :mailbox AND"
+
+#define BYKIND    " kind = :kind AND"
+
+#define BYMODSEQ  " modseq > :modseq;"
 
 EXPORTED int carddav_get_updates(struct carddav_db *carddavdb,
-                                 modseq_t oldmodseq, const char *mboxname, int kind,
+                                 modseq_t oldmodseq, const char *mboxname,
+                                 int kind, int limit,
                                  int (*cb)(void *rock,
                                            struct carddav_data *cdata),
                                  void *rock)
@@ -725,26 +991,39 @@ EXPORTED int carddav_get_updates(struct
         { ":mailbox", SQLITE_TEXT,    { .s = mboxname  } },
         { ":modseq",  SQLITE_INTEGER, { .i = oldmodseq } },
         { ":kind",    SQLITE_INTEGER, { .i = kind      } },
+        /* SQLite interprets a negative limit as unbounded. */
+        { ":limit",   SQLITE_INTEGER, { .i = limit > 0 ? limit : -1 } },
         { NULL,       SQLITE_NULL,    { .s = NULL      } }
     };
     static struct carddav_data cdata;
     struct read_rock rrock = { carddavdb, &cdata, 1 /* tombstones */, cb, rock };
+    struct buf sqlbuf = BUF_INITIALIZER;
     int r;
 
-    if (mboxname)
-        r = sqldb_exec(carddavdb->db, CMD_GETUPDATES_MBOX, bval, &read_cb, &rrock);
-    else
-        r = sqldb_exec(carddavdb->db, CMD_GETUPDATES, bval, &read_cb, &rrock);
+    buf_setcstr(&sqlbuf, CMD_GETFIELDS " WHERE");
+    if (mboxname) buf_appendcstr(&sqlbuf, " mailbox = :mailbox AND");
+    if (kind >= 0) {
+        /* Use a negative value to signal that we accept ALL card types */
+        buf_appendcstr(&sqlbuf, " kind = :kind AND");
+    }
+    if (!oldmodseq) buf_appendcstr(&sqlbuf, " alive = 1 AND");
+    buf_appendcstr(&sqlbuf, " modseq > :modseq ORDER BY modseq LIMIT :limit;");
+
+    r = sqldb_exec(carddavdb->db, buf_cstring(&sqlbuf), bval, &read_cb, &rrock);
+    buf_free(&sqlbuf);
+
     if (r) {
-        syslog(LOG_ERR, "caldav error %s", error_message(r));
+        syslog(LOG_ERR, "carddav error %s", error_message(r));
         /* XXX - free memory */
     }
 
     return r;
 }
 
-EXPORTED int carddav_writecard(struct carddav_db *carddavdb, struct carddav_data *cdata,
-                               struct vparse_card *vcard)
+EXPORTED int carddav_writecard(struct carddav_db *carddavdb,
+                               struct carddav_data *cdata,
+                               struct vparse_card *vcard,
+                               int ispinned)
 {
     struct vparse_entry *ventry;
 
@@ -804,7 +1083,7 @@ EXPORTED int carddav_writecard(struct ca
     }
 
     int r = carddav_write(carddavdb, cdata);
-    if (!r) r = carddav_write_emails(carddavdb, cdata->dav.rowid, &emails);
+    if (!r) r = carddav_write_emails(carddavdb, cdata->dav.rowid, &emails, ispinned);
     if (!r) r = carddav_write_groups(carddavdb, cdata->dav.rowid, &member_uids);
 
     strarray_fini(&emails);
@@ -814,7 +1093,7 @@ EXPORTED int carddav_writecard(struct ca
 }
 
 EXPORTED int carddav_store(struct mailbox *mailbox, struct vparse_card *vcard,
-                           const char *resource,
+                           const char *resource, modseq_t createdmodseq,
                            strarray_t *flags, struct entryattlist *annots,
                            const char *userid, struct auth_state *authstate,
                            int ignorequota)
@@ -829,6 +1108,8 @@ EXPORTED int carddav_store(struct mailbo
     char *freeme = NULL;
     char datestr[80];
 
+    init_internal();
+
     /* Prepare to stage the message */
     if (!(f = append_newstage(mailbox->name, now, 0, &stage))) {
         syslog(LOG_ERR, "append_newstage(%s) failed", mailbox->name);
@@ -847,14 +1128,14 @@ EXPORTED int carddav_store(struct mailbo
     vparse_tobuf(vcard, &buf);
     char *mbuserid = mboxname_to_userid(mailbox->name);
 
-    time_to_rfc822(now, datestr, sizeof(datestr));
+    time_to_rfc5322(now, datestr, sizeof(datestr));
 
     /* XXX  This needs to be done via an LDAP/DB lookup */
-    header = charset_encode_mimeheader(mbuserid, 0);
+    header = charset_encode_mimeheader(mbuserid, 0, 0);
     fprintf(f, "From: %s <>\r\n", header);
     free(header);
 
-    header = charset_encode_mimeheader(fullname, 0);
+    header = charset_encode_mimeheader(fullname, 0, 0);
     fprintf(f, "Subject: %s\r\n", header);
     free(header);
 
@@ -894,7 +1175,7 @@ EXPORTED int carddav_store(struct mailbo
 
     struct body *body = NULL;
 
-    r = append_fromstage(&as, &body, stage, now, flags, 0, annots);
+    r = append_fromstage(&as, &body, stage, now, createdmodseq, flags, 0, annots);
     if (body) {
         message_free_body(body);
         free(body);
@@ -927,10 +1208,13 @@ EXPORTED int carddav_remove(struct mailb
     int userflag;
     int r = mailbox_user_flag(mailbox, DFLAG_UNBIND, &userflag, 1);
     struct index_record oldrecord;
+
+    init_internal();
+
     if (!r) r = mailbox_find_index_record(mailbox, olduid, &oldrecord);
-    if (!r && !(oldrecord.system_flags & FLAG_EXPUNGED)) {
+    if (!r && !(oldrecord.internal_flags & FLAG_INTERNAL_EXPUNGED)) {
         if (isreplace) oldrecord.user_flags[userflag/32] |= 1<<(userflag&31);
-        oldrecord.system_flags |= FLAG_EXPUNGED;
+        oldrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
 
         r = mailbox_rewrite_index_record(mailbox, &oldrecord);
 
@@ -955,6 +1239,8 @@ EXPORTED char *carddav_mboxname(const ch
     struct buf boxbuf = BUF_INITIALIZER;
     char *res = NULL;
 
+    init_internal();
+
     buf_setcstr(&boxbuf, config_getstring(IMAPOPT_ADDRESSBOOKPREFIX));
 
     if (name) {
diff -pruN 3.0.13-5/imap/carddav_db.h 3.2.0-3/imap/carddav_db.h
--- 3.0.13-5/imap/carddav_db.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/carddav_db.h	2020-04-24 02:03:00.000000000 +0000
@@ -48,6 +48,7 @@
 
 #include "auth.h"
 #include "dav_db.h"
+#include "mboxname.h"
 #include "strarray.h"
 #include "util.h"
 #include "vparse.h"
@@ -64,10 +65,20 @@ struct carddav_data {
     const char *fullname;
     const char *name;
     const char *nickname;
+    int jmapversion;
+    const char *jmapdata;
     strarray_t *emails;
     strarray_t *member_uids;
 };
 
+enum carddav_sort {
+    CARD_SORT_NONE = 0,
+    CARD_SORT_MODSEQ,
+    CARD_SORT_UID,
+    CARD_SORT_FULLNAME,
+    CARD_SORT_DESC = 0x80 /* bit-flag for descending sort */
+};
+
 typedef int carddav_cb_t(void *rock, struct carddav_data *cdata);
 
 
@@ -81,6 +92,9 @@ int carddav_done(void);
 struct carddav_db *carddav_open_mailbox(struct mailbox *mailbox);
 struct carddav_db *carddav_open_userid(const char *userid);
 
+/* add another DB */
+int carddav_set_otheruser(struct carddav_db *db, const char *userid);
+
 /* close this handle */
 int carddav_close(struct carddav_db *carddavdb);
 
@@ -91,6 +105,13 @@ int carddav_lookup_resource(struct cardd
                            struct carddav_data **result,
                            int tombstones);
 
+/* lookup an entry from 'carddavdb' by mailbox and IMAP uid
+   (optionally inside a transaction for updates) */
+int carddav_lookup_imapuid(struct carddav_db *carddavdb,
+                           const char *mailbox, int uid,
+                           struct carddav_data **result,
+                           int tombstones);
+
 /* lookup an entry from 'carddavdb' by iCal UID
    (optionally inside a transaction for updates) */
 int carddav_lookup_uid(struct carddav_db *carddavdb, const char *ical_uid,
@@ -99,14 +120,16 @@ int carddav_lookup_uid(struct carddav_db
 /* check if an email address exists on any card.
    returns the groups its in (if any) */
 strarray_t *carddav_getemail(struct carddav_db *carddavdb, const char *key);
-strarray_t *carddav_getemail2uids(struct carddav_db *carddavdb, const char *key,
-                                  const char *mboxname);
+strarray_t *carddav_getemail2details(struct carddav_db *carddavdb, const char *key,
+                                     const char *mboxname, int *ispinned);
 strarray_t *carddav_getuid2groups(struct carddav_db *carddavdb, const char *key,
                                   const char *mboxname, const char *otheruser);
 
-/* checks if a group exists (by id).
+/* checks if a group exists (by id), optionally filtered by addressbook mailbox.
+ * Looks up groups across addressbooks if mailbox is NULL.
    returns emails of its members (if any) */
-strarray_t *carddav_getgroup(struct carddav_db *carddavdb, const char *mailbox, const char *group);
+strarray_t *carddav_getgroup(struct carddav_db *carddavdb, const char *mailbox, const char *group,
+                             mbname_t *othermb);
 
 /* get a list of groups the given uid is a member of */
 strarray_t *carddav_getuid_groups(struct carddav_db *carddavdb, const char *uid);
@@ -116,22 +139,35 @@ int carddav_get_cards(struct carddav_db
                       const char *mailbox, const char *vcard_uid, int kind,
                       carddav_cb_t *cb, void *rock);
 
-/* process each entry of type 'kind' and updated since 'oldmodseq'
-   in 'carddavdb' with cb() */
+/* Process each entry for 'carddavdb' with a modseq higher than oldmodseq,
+ * in ascending order of modseq.
+ * If mailbox is not NULL, only process entries of this mailbox.
+ * If kind is non-negative, only process entries of this kind.
+ * If max_records is positive, only call cb for at most this entries. */
 int carddav_get_updates(struct carddav_db *carddavdb,
                         modseq_t oldmodseq, const char *mboxname, int kind,
-                        carddav_cb_t *cb, void *rock);
+                        int max_records, carddav_cb_t *cb, void *rock);
 
 /* process each entry for 'mailbox' in 'carddavdb' with cb() */
 int carddav_foreach(struct carddav_db *carddavdb, const char *mailbox,
                     carddav_cb_t *cb, void *rock);
 
+/* process each entry for 'mailbox' in 'carddavdb' with cb()
+ * The callback is called in order of sort, or by descending
+ * modseq if no sort is specified. */
+int carddav_foreach_sort(struct carddav_db *carddavdb, const char *mailbox,
+                         enum carddav_sort* sort, size_t nsort,
+                         carddav_cb_t *cb, void *rock);
+
+int carddav_write_jmapcache(struct carddav_db *carddavdb, int rowid,
+                            int version, const char *data);
+
 /* write an entry to 'carddavdb' */
 int carddav_write(struct carddav_db *carddavdb, struct carddav_data *cdata);
 
 /* write an entry form a vcard */
 int carddav_writecard(struct carddav_db *carddavdb, struct carddav_data *cdata,
-                      struct vparse_card *vcard);
+                      struct vparse_card *vcard, int ispinned);
 
 /* delete an entry from 'carddavdb' */
 int carddav_delete(struct carddav_db *carddavdb, unsigned rowid);
@@ -150,7 +186,7 @@ int carddav_abort(struct carddav_db *car
 
 /* store a vcard to mailbox/resource */
 int carddav_store(struct mailbox *mailbox, struct vparse_card *vcard,
-                  const char *resource,
+                  const char *resource, modseq_t createdmodseq,
                   strarray_t *flags, struct entryattlist *annots,
                   const char *userid, struct auth_state *authstate,
                   int ignorequota);
diff -pruN 3.0.13-5/imap/chk_cyrus.c 3.2.0-3/imap/chk_cyrus.c
--- 3.0.13-5/imap/chk_cyrus.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/chk_cyrus.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/mman.h>
@@ -55,7 +56,6 @@
 #include <unistd.h>
 #endif
 
-#include "exitcodes.h"
 #include "index.h"
 #include "global.h"
 #include "mboxlist.h"
@@ -74,6 +74,7 @@ static const char *check_part = NULL; /*
 static int chkmbox(struct findall_data *data, void *rock __attribute__((unused)))
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
     int r;
     mbentry_t *mbentry = NULL;
     const char *name = mbname_intname(data->mbname);
@@ -84,7 +85,7 @@ static int chkmbox(struct findall_data *
 
     if (r) {
         fprintf(stderr, "bad mailbox %s in chkmbox\n", name);
-        fatal("fatal error",EC_TEMPFAIL);
+        fatal("fatal error",EX_TEMPFAIL);
     }
 
     /* are we on the partition we are checking? */
@@ -120,7 +121,7 @@ int main(int argc, char **argv)
         case 'P':
             if(mailbox) {
                 usage();
-                exit(EC_USAGE);
+                exit(EX_USAGE);
             }
             check_part = optarg;
             break;
@@ -128,7 +129,7 @@ int main(int argc, char **argv)
         case 'M':
             if(check_part) {
                 usage();
-                exit(EC_USAGE);
+                exit(EX_USAGE);
             }
             mailbox = optarg;
             break;
@@ -141,9 +142,6 @@ int main(int argc, char **argv)
 
     cyrus_init(alt_config, "chk_cyrus", 0, CONFIG_NEED_PARTITION_DATA);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     if(mailbox) {
         fprintf(stderr, "Examining mailbox: %s\n", mailbox);
         mboxlist_findone(NULL, mailbox, 1, NULL,
@@ -157,9 +155,6 @@ int main(int argc, char **argv)
                          NULL, chkmbox, NULL);
     }
 
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return 0;
diff -pruN 3.0.13-5/imap/conversations.c 3.2.0-3/imap/conversations.c
--- 3.0.13-5/imap/conversations.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/conversations.c	2020-05-04 03:28:02.000000000 +0000
@@ -51,6 +51,7 @@
 #include <errno.h>
 #include <ctype.h>
 #include <stdlib.h>
+#include <sysexits.h>
 
 #include "acl.h"
 #include "annotate.h"
@@ -60,7 +61,6 @@
 #include "charset.h"
 #include "crc32.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "hash.h"
 #include "global.h"
 #include "imapd.h"
@@ -82,6 +82,8 @@
 #include "xstrlcat.h"
 #include "xstats.h"
 #include "times.h"
+#include "vparse.h"
+#include "vcard_support.h"
 
 #include "conversations.h"
 
@@ -94,12 +96,15 @@
 #define FNAME_CONVERSATIONS_SUFFIX "conversations"
 #define FNKEY "$FOLDER_NAMES"
 #define CFKEY "$COUNTED_FLAGS"
+#define CONVSPLITFOLDER "#splitconversations"
 
 #define DB config_conversations_db
 
 #define CONVERSATIONS_VERSION 0
 
-static conv_status_t NULLSTATUS = { 0, 0, 0};
+static struct conversations_open *open_conversations;
+
+static conv_status_t NULLSTATUS = CONV_STATUS_INIT;
 
 static char *convdir = NULL;
 static char *suffix = NULL;
@@ -111,7 +116,8 @@ static int _conversations_set_key(struct
                                   const char *key, size_t keylen,
                                   const arrayu64_t *cids, time_t stamp);
 
-static struct conversations_open *open_conversations;
+static void _conv_remove(struct conversations_state *state);
+
 EXPORTED void conversations_set_directory(const char *dir)
 {
     free(convdir);
@@ -166,11 +172,13 @@ static int _init_counted(struct conversa
         val = config_getstring(IMAPOPT_CONVERSATIONS_COUNTED_FLAGS);
         if (!val) val = "";
         vallen = strlen(val);
-        r = cyrusdb_store(state->db, CFKEY, strlen(CFKEY),
-                          val, vallen, &state->txn);
-        if (r) {
-            syslog(LOG_ERR, "Failed to write counted_flags");
-            return r;
+        if (vallen) {
+            r = cyrusdb_store(state->db, CFKEY, strlen(CFKEY),
+                    val, vallen, &state->txn);
+            if (r) {
+                syslog(LOG_ERR, "Failed to write counted_flags");
+                return r;
+            }
         }
     }
 
@@ -183,12 +191,103 @@ static int _init_counted(struct conversa
     /* add the value only if there's some flags set */
     if (vallen) {
         state->counted_flags = strarray_nsplit(val, vallen, " ", /*flags*/0);
+        if (state->counted_flags->count > 32) {
+            syslog(LOG_ERR, "conversations: truncating counted_flags: %d (%.*s)",
+                            state->counted_flags->count, vallen, val);
+            strarray_truncate(state->counted_flags, 32);
+        }
     }
 
     return 0;
 }
 
-EXPORTED int conversations_open_path(const char *fname, struct conversations_state **statep)
+int _saxfolder(int type, struct dlistsax_data *d)
+{
+    struct conversations_open *open = (struct conversations_open *)d->rock;
+    if (type == DLISTSAX_STRING)
+        strarray_append(open->s.folder_names, d->data);
+    return 0;
+}
+
+static int write_folders(struct conversations_state *state)
+{
+    struct dlist *dl = dlist_newlist(NULL, NULL);
+    struct buf buf = BUF_INITIALIZER;
+    int r;
+    int i;
+
+    for (i = 0; i < strarray_size(state->folder_names); i++) {
+        const char *fname = strarray_nth(state->folder_names, i);
+        dlist_setatom(dl, NULL, fname);
+    }
+
+    dlist_printbuf(dl, 0, &buf);
+    dlist_free(&dl);
+
+    r = cyrusdb_store(state->db, FNKEY, strlen(FNKEY),
+                      buf.s, buf.len, &state->txn);
+
+    buf_free(&buf);
+
+    return r;
+}
+
+static int folder_number(struct conversations_state *state,
+                         const char *name,
+                         int create_flag)
+{
+    int pos = strarray_find(state->folder_names, name, 0);
+    int r;
+
+    /* if we have to add it, then save the keys back */
+    if (pos < 0 && create_flag) {
+        /* replace the first unused if there is one */
+        pos = strarray_find(state->folder_names, "-", 0);
+        if (pos >= 0)
+            strarray_set(state->folder_names, pos, name);
+        /* otherwise append */
+        else
+            pos = strarray_append(state->folder_names, name);
+
+        /* track the Trash folder number as it's added */
+        if (!strcmpsafe(name, state->trashmboxname))
+            state->trashfolder = pos;
+
+        /* store must succeed */
+        r = write_folders(state);
+        if (r) abort();
+    }
+
+    return pos;
+}
+
+EXPORTED uint32_t conversations_num_folders(struct conversations_state *state)
+{
+    return strarray_size(state->folder_names);
+}
+
+EXPORTED const char* conversations_folder_name(struct conversations_state *state,
+                                               uint32_t foldernum)
+{
+    return strarray_safenth(state->folder_names, foldernum);
+}
+
+EXPORTED size_t conversations_estimate_emailcount(struct conversations_state *state)
+{
+    int i;
+    size_t count = 0;
+    conv_status_t status;
+    for (i = 0; i < strarray_size(state->folder_names); i++) {
+        const char *mboxname = strarray_nth(state->folder_names, i);
+        int r = conversation_getstatus(state, mboxname, &status);
+        if (r) continue;
+        count += status.emailexists;
+    }
+    return count;
+}
+
+EXPORTED int conversations_open_path(const char *fname, const char *userid, int shared,
+                                     struct conversations_state **statep)
 {
     struct conversations_open *open = NULL;
     const char *val = NULL;
@@ -201,24 +300,40 @@ EXPORTED int conversations_open_path(con
     for (open = open_conversations; open; open = open->next) {
         if (!strcmp(open->s.path, fname))
             return IMAP_CONVERSATIONS_ALREADY_OPEN;
+        syslog(LOG_NOTICE, "conversations_open_path: opening %s over %s", fname, open->s.path);
     }
 
     open = xzmalloc(sizeof(struct conversations_open));
 
-    r = cyrusdb_open(DB, fname, CYRUSDB_CREATE | CYRUSDB_CONVERT, &open->s.db);
+    /* open db */
+    open->s.is_shared = shared;
+    int flags = CYRUSDB_CREATE | (shared ? CYRUSDB_SHARED : CYRUSDB_CONVERT);
+    r = cyrusdb_lockopen(DB, fname, flags, &open->s.db, &open->s.txn);
     if (r || open->s.db == NULL) {
         free(open);
         return IMAP_IOERROR;
     }
-
     open->s.path = xstrdup(fname);
     open->next = open_conversations;
     open_conversations = open;
 
-    /* ensure a write lock immediately, and also load the counted flags */
-    cyrusdb_fetchlock(open->s.db, CFKEY, strlen(CFKEY),
-                      &val, &vallen, &open->s.txn);
-    _init_counted(&open->s, val, vallen);
+    /* load or initialize counted flags */
+    cyrusdb_fetch(open->s.db, CFKEY, strlen(CFKEY), &val, &vallen, &open->s.txn);
+    r = _init_counted(&open->s, val, vallen);
+    if (r == CYRUSDB_READONLY) {
+        /* racy: drop shared lock, grab write lock */
+        cyrusdb_commit(open->s.db, open->s.txn);
+        open->s.txn = NULL;
+        flags &= ~CYRUSDB_SHARED;
+        r = cyrusdb_lockopen(DB, fname, flags, &open->s.db, &open->s.txn);
+        if (!r) r = _init_counted(&open->s, val, vallen);
+    }
+    if (r) {
+        cyrusdb_abort(open->s.db, open->s.txn);
+        _conv_remove(&open->s);
+        free(open);
+        return r;
+    }
 
     /* we should just read the folder names up front too */
     open->s.folder_names = strarray_new();
@@ -226,41 +341,48 @@ EXPORTED int conversations_open_path(con
     /* if there's a value, parse as a dlist */
     if (!cyrusdb_fetch(open->s.db, FNKEY, strlen(FNKEY),
                    &val, &vallen, &open->s.txn)) {
-        struct dlist *dl = NULL;
-        struct dlist *dp;
-        dlist_parsemap(&dl, 0, 0, val, vallen);
-        for (dp = dl->head; dp; dp = dp->next) {
-            strarray_append(open->s.folder_names, dlist_cstring(dp));
-        }
-        dlist_free(&dl);
+        dlist_parsesax(val, vallen, 0, _saxfolder, open);
     }
 
+    if (userid)
+        open->s.annotmboxname = mboxname_user_mbox(userid, CONVSPLITFOLDER);
+    else
+        open->s.annotmboxname = xstrdup(CONVSPLITFOLDER);
+
+    char *trashmboxname = mboxname_user_mbox(userid, "Trash");
+    open->s.trashfolder = folder_number(&open->s, trashmboxname, /*create*/0);
+    open->s.trashmboxname = trashmboxname;
+
     /* create the status cache */
-    construct_hash_table(&open->s.folderstatus, open->s.folder_names->count/4+4, 0);
+    construct_hash_table(&open->s.folderstatus, strarray_size(open->s.folder_names)/4+4, 0);
 
     *statep = &open->s;
 
     return 0;
 }
 
-EXPORTED int conversations_open_user(const char *username, struct conversations_state **statep)
+EXPORTED int conversations_open_user(const char *userid, int shared,
+                                     struct conversations_state **statep)
 {
-    char *path = conversations_getuserpath(username);
+    char *path = conversations_getuserpath(userid);
     int r;
     if (!path) return IMAP_MAILBOX_BADNAME;
-    r = conversations_open_path(path, statep);
+    r = conversations_open_path(path, userid, shared, statep);
     free(path);
     return r;
 }
 
-EXPORTED int conversations_open_mbox(const char *mboxname, struct conversations_state **statep)
+EXPORTED int conversations_open_mbox(const char *mboxname, int shared, struct conversations_state **statep)
 {
     char *path = conversations_getmboxpath(mboxname);
     int r;
     if (!path) return IMAP_MAILBOX_BADNAME;
-    r = conversations_open_path(path, statep);
+    char *userid = mboxname_to_userid(mboxname);
+    r = conversations_open_path(path, userid, shared, statep);
+    free(userid);
     free(path);
     return r;
+    return 0;
 }
 
 EXPORTED struct conversations_state *conversations_get_path(const char *fname)
@@ -305,7 +427,9 @@ static void _conv_remove(struct conversa
         if (state == &cur->s) {
             /* found it! */
             *prevp = cur->next;
+            free(cur->s.annotmboxname);
             free(cur->s.path);
+            free(cur->s.trashmboxname);
             if (cur->s.counted_flags)
                 strarray_free(cur->s.counted_flags);
             if (cur->s.folder_names)
@@ -316,7 +440,7 @@ static void _conv_remove(struct conversa
         prevp = &cur->next;
     }
 
-    fatal("unknown conversation db closed", EC_SOFTWARE);
+    fatal("unknown conversation db closed", EX_SOFTWARE);
 }
 
 static void conversations_abortcache(struct conversations_state *state)
@@ -333,7 +457,7 @@ static void commitstatus_cb(const char *
     conversation_storestatus(state, key, strlen(key), status);
     /* just in case convdb has a higher modseq for any reason (aka deleted and
      * recreated while a replica was still valid with the old user) */
-    mboxname_setmodseq(key+1, status->modseq, /*mbtype */0, /*dofolder*/0);
+    mboxname_setmodseq(key+1, status->threadmodseq, /*mbtype */0, /*dofolder*/0);
     sync_log_mailbox(key+1); /* skip the leading F */
 }
 
@@ -397,29 +521,43 @@ static int check_msgid(const char *msgid
     if (!len)
         len = strlen(msgid);
 
-    if (msgid[0] != '<' || msgid[len-1] != '>' || strchr(msgid, '@') == NULL)
+    if (msgid[0] != '<' || msgid[len-1] != '>' || len < 3)
+        return IMAP_INVALID_IDENTIFIER;
+
+    /* Leniently accept msg-id without @, but refuse multiple @ */
+    if (memchr(msgid, '@', len) != memrchr(msgid, '@', len))
         return IMAP_INVALID_IDENTIFIER;
 
+    /* Leniently accept specials, but refuse the outright broken */
+    size_t i;
+    for (i = 1; i < len - 1; i++) {
+        if (!isprint(msgid[i]) || isspace(msgid[i]))
+            return IMAP_INVALID_IDENTIFIER;
+    }
+
     if (lenp)
         *lenp = len;
 
     return 0;
 }
 
+EXPORTED int conversations_check_msgid(const char *msgid, size_t len)
+{
+    return check_msgid(msgid, len, NULL);
+}
+
 static int _conversations_set_key(struct conversations_state *state,
                                   const char *key, size_t keylen,
                                   const arrayu64_t *cids, time_t stamp)
 {
     int r;
-    struct buf buf;
+    struct buf buf = BUF_INITIALIZER;
     int version = CONVERSATIONS_VERSION;
     int i;
 
     /* XXX: should this be a delete operation? */
     assert(cids->count);
 
-    buf_init(&buf);
-
     if (state->db == NULL)
         return IMAP_IOERROR;
 
@@ -642,54 +780,6 @@ EXPORTED void conversation_normalise_sub
     buf_replace_all_re(s, &whitespace_re, NULL);
 }
 
-static int write_folders(struct conversations_state *state)
-{
-    struct dlist *dl = dlist_newlist(NULL, NULL);
-    struct buf buf = BUF_INITIALIZER;
-    int r;
-    int i;
-
-    for (i = 0; i < state->folder_names->count; i++) {
-        const char *fname = strarray_nth(state->folder_names, i);
-        dlist_setatom(dl, NULL, fname);
-    }
-
-    dlist_printbuf(dl, 0, &buf);
-    dlist_free(&dl);
-
-    r = cyrusdb_store(state->db, FNKEY, strlen(FNKEY),
-                      buf.s, buf.len, &state->txn);
-
-    buf_free(&buf);
-
-    return r;
-}
-
-static int folder_number(struct conversations_state *state,
-                         const char *name,
-                         int create_flag)
-{
-    int pos = strarray_find(state->folder_names, name, 0);
-    int r;
-
-    /* if we have to add it, then save the keys back */
-    if (pos < 0 && create_flag) {
-        /* replace the first unused if there is one */
-        pos = strarray_find(state->folder_names, "-", 0);
-        if (pos >= 0)
-            strarray_set(state->folder_names, pos, name);
-        /* otherwise append */
-        else
-            pos = strarray_append(state->folder_names, name);
-
-        /* store must succeed */
-        r = write_folders(state);
-        if (r) abort();
-    }
-
-    return pos;
-}
-
 static int folder_number_rename(struct conversations_state *state,
                                 const char *from_name,
                                 const char *to_name)
@@ -708,16 +798,18 @@ EXPORTED int conversation_storestatus(st
                                       const char *key, size_t keylen,
                                       const conv_status_t *status)
 {
-    if (!status || !status->modseq) {
+    if (!status || !status->threadmodseq) {
         return cyrusdb_delete(state->db,
                               key, keylen,
                               &state->txn, /*force*/1);
     }
 
     struct dlist *dl = dlist_newlist(NULL, NULL);
-    dlist_setnum64(dl, "MODSEQ", status->modseq);
-    dlist_setnum32(dl, "EXISTS", status->exists);
-    dlist_setnum32(dl, "UNSEEN", status->unseen);
+    dlist_setnum64(dl, "THREADMODSEQ", status->threadmodseq);
+    dlist_setnum32(dl, "THREADEXISTS", status->threadexists);
+    dlist_setnum32(dl, "THREADUNSEEN", status->threadunseen);
+    dlist_setnum32(dl, "EMAILEXISTS", status->emailexists);
+    dlist_setnum32(dl, "EMAILUNSEEN", status->emailunseen);
 
     struct buf buf = BUF_INITIALIZER;
     buf_printf(&buf, "%d ", CONVERSATIONS_VERSION);
@@ -755,18 +847,14 @@ EXPORTED int conversation_setstatus(stru
     return 0;
 }
 
-EXPORTED int conversation_store(struct conversations_state *state,
-                       const char *key, int keylen,
-                       conversation_t *conv)
+static void conv_to_buf(conversation_t *conv, struct buf *buf, int flagcount)
 {
     struct dlist *dl, *n, *nn;
-    struct buf buf = BUF_INITIALIZER;
     const conv_folder_t *folder;
     const conv_sender_t *sender;
     const conv_thread_t *thread;
     int version = CONVERSATIONS_VERSION;
     int i;
-    int r;
 
     dl = dlist_newlist(NULL, NULL);
     dlist_setnum64(dl, "MODSEQ", conv->modseq);
@@ -774,11 +862,8 @@ EXPORTED int conversation_store(struct c
     dlist_setnum32(dl, "EXISTS", conv->exists);
     dlist_setnum32(dl, "UNSEEN", conv->unseen);
     n = dlist_newlist(dl, "COUNTS");
-    if (state->counted_flags) {
-        for (i = 0; i < state->counted_flags->count; i++) {
-            const char *flag = strarray_nth(state->counted_flags, i);
-            dlist_setnum32(n, flag, conv->counts[i]);
-        }
+    for (i = 0; i < flagcount; i++) {
+        dlist_setnum32(n, "flag", conv->counts[i]);
     }
 
     n = dlist_newlist(dl, "FOLDER");
@@ -822,29 +907,54 @@ EXPORTED int conversation_store(struct c
         dlist_setguid(nn, "GUID", &thread->guid);
         dlist_setnum32(nn, "EXISTS", thread->exists);
         dlist_setnum32(nn, "INTERNALDATE", thread->internaldate);
-        dlist_setnum32(nn, "MSGID", thread->msgid);
-        if (thread->inreplyto) dlist_setnum32(nn, "INREPLYTO", thread->inreplyto);
     }
 
-    buf_printf(&buf, "%d ", version);
-    dlist_printbuf(dl, 0, &buf);
+    dlist_setnum64(dl, "CREATEDMODSEQ", conv->createdmodseq);
+
+    buf_printf(buf, "%d ", version);
+    dlist_printbuf(dl, 0, buf);
     dlist_free(&dl);
+}
+
+EXPORTED int conversation_store(struct conversations_state *state,
+                       const char *key, int keylen,
+                       conversation_t *conv)
+{
+    struct buf buf = BUF_INITIALIZER;
+
+    conv_to_buf(conv, &buf, state->counted_flags ? state->counted_flags->count : 0);
 
     if (_sanity_check_counts(conv)) {
         syslog(LOG_ERR, "IOERROR: conversations_audit on store: %s %.*s %.*s",
                state->path, keylen, key, (int)buf.len, buf.s);
     }
 
-    r = cyrusdb_store(state->db, key, keylen, buf.s, buf.len, &state->txn);
+    int r = cyrusdb_store(state->db, key, keylen, buf.s, buf.len, &state->txn);
 
     buf_free(&buf);
 
     return r;
 }
 
+static void _apply_delta(uint32_t *valp, int delta)
+{
+    if (delta >= 0) {
+        *valp += delta;
+    }
+    else {
+        uint32_t decrease = -delta;
+        /* let us die where it broke */
+        if (decrease <= *valp)
+            *valp -= decrease;
+        else
+            *valp = 0;
+    }
+}
+
 static int _conversation_save(struct conversations_state *state,
                               const char *key, int keylen,
-                              conversation_t *conv)
+                              conversation_t *conv,
+                              struct emailcounts *ecounts)
 {
     const conv_folder_t *folder;
     int r;
@@ -854,42 +964,61 @@ static int _conversation_save(struct con
         const char *mboxname = strarray_nth(state->folder_names, folder->number);
         int exists_diff = 0;
         int unseen_diff = 0;
+        int emailexists_diff = 0;
+        int emailunseen_diff = 0;
         conv_status_t status = CONV_STATUS_INIT;
+        int unseen = conv->unseen;
+        int prev_unseen = conv->prev_unseen;
+
+        if (folder->number == state->trashfolder) {
+            unseen = conv->trash_unseen;
+            prev_unseen = conv->prev_trash_unseen;
+        }
 
         /* case: full removal of conversation - make sure to remove
          * unseen as well */
         if (folder->exists) {
             if (folder->prev_exists) {
                 /* both exist, just check for unseen changes */
-                unseen_diff = !!conv->unseen - !!conv->prev_unseen;
+                unseen_diff = !!unseen - !!prev_unseen;
             }
             else {
                 /* adding, check if it's unseen */
                 exists_diff = 1;
-                if (conv->unseen) unseen_diff = 1;
+                if (unseen) unseen_diff = 1;
             }
         }
         else if (folder->prev_exists) {
             /* removing, check if it WAS unseen */
             exists_diff = -1;
-            if (conv->prev_unseen) unseen_diff = -1;
+            if (prev_unseen) unseen_diff = -1;
         }
         else {
             /* we don't care about unseen if the cid is not registered
              * in this folder, and wasn't previously either */
         }
 
+        if (ecounts && !strcmp(ecounts->mboxname, mboxname)) {
+            // do we have email diffs?
+            emailexists_diff = !!ecounts->post_emailexists - !!ecounts->pre_emailexists;
+            emailunseen_diff = !!ecounts->post_emailunseen - !!ecounts->pre_emailunseen;
+        }
+
         /* XXX - it's super inefficient to be doing this for
          * every cid in every folder in the transaction.  Big
          * wins available by caching these in memory and writing
          * once at the end of the transaction */
         r = conversation_getstatus(state, mboxname, &status);
         if (r) goto done;
-        if (exists_diff || unseen_diff || status.modseq < conv->modseq) {
-            if (status.modseq < conv->modseq)
-                status.modseq = conv->modseq;
-            status.exists += exists_diff;
-            status.unseen += unseen_diff;
+        if (exists_diff || unseen_diff
+         || emailexists_diff || emailunseen_diff
+         || status.threadmodseq < conv->modseq) {
+            if (status.threadmodseq < conv->modseq)
+                status.threadmodseq = conv->modseq;
+            _apply_delta(&status.threadexists, exists_diff);
+            _apply_delta(&status.threadunseen, unseen_diff);
+            _apply_delta(&status.emailexists, emailexists_diff);
+            _apply_delta(&status.emailunseen, emailunseen_diff);
             r = conversation_setstatus(state, mboxname, &status);
             if (r) goto done;
         }
@@ -906,20 +1035,21 @@ static int _conversation_save(struct con
 
 done:
     if (!r)
-        conv->dirty = 0;
+        conv->flags &= ~CONV_ISDIRTY;
 
     return r;
 }
 
 EXPORTED int conversation_save(struct conversations_state *state,
                       conversation_id_t cid,
-                      conversation_t *conv)
+                      conversation_t *conv,
+                      struct emailcounts *ecounts)
 {
     char bkey[CONVERSATION_ID_STRMAX+2];
 
     if (!conv)
         return IMAP_INTERNAL;
-    if (!conv->dirty)
+    if (!(conv->flags & CONV_ISDIRTY))
         return 0;
 
     /* old pre-conversations message, nothing to do */
@@ -929,22 +1059,57 @@ EXPORTED int conversation_save(struct co
 
     snprintf(bkey, sizeof(bkey), "B" CONV_FMT, cid);
 
-    return _conversation_save(state, bkey, strlen(bkey), conv);
+    return _conversation_save(state, bkey, strlen(bkey), conv, ecounts);
+}
+
+struct convstatusrock {
+    conv_status_t *status;
+    int state;
+};
+
+int _saxconvstatus(int type, struct dlistsax_data *d)
+{
+    struct convstatusrock *rock = (struct convstatusrock *)d->rock;
+    if (type != DLISTSAX_STRING) return 0;
+    switch (rock->state) {
+    case 0:
+        rock->status->threadmodseq = atomodseq_t(d->data);
+        rock->state++;
+        return 0;
+    case 1:
+        rock->status->threadexists = atol(d->data);
+        rock->state++;
+        return 0;
+    case 2:
+        rock->status->threadunseen = atol(d->data);
+        rock->state++;
+        return 0;
+    case 3:
+        rock->status->emailexists = atol(d->data);
+        rock->state++;
+        return 0;
+    case 4:
+        rock->status->emailunseen = atol(d->data);
+        rock->state++;
+        return 0;
+    }
+    return IMAP_MAILBOX_BADFORMAT;
 }
 
 EXPORTED int conversation_parsestatus(const char *data, size_t datalen,
                                       conv_status_t *status)
 {
+    struct convstatusrock rock = { status, 0 };
     bit64 version;
     const char *rest;
     size_t restlen;
-    struct dlist *dl = NULL;
-    struct dlist *n;
     int r;
 
-    status->modseq = 0;
-    status->exists = 0;
-    status->unseen = 0;
+    status->threadmodseq = 0;
+    status->threadexists = 0;
+    status->threadunseen = 0;
+    status->emailexists = 0;
+    status->emailunseen = 0;
 
     r = parsenum(data, &rest, datalen, &version);
     if (r) return IMAP_MAILBOX_BADFORMAT;
@@ -959,24 +1124,7 @@ EXPORTED int conversation_parsestatus(co
         return IMAP_MAILBOX_BADFORMAT;
     }
 
-    r = dlist_parsemap(&dl, 0, 0, rest, restlen);
-    if (r) return r;
-
-    n = dl->head;
-    if (n) {
-        status->modseq = dlist_num(n);
-        n = n->next;
-    }
-    if (n) {
-        status->exists = dlist_num(n);
-        n = n->next;
-    }
-    if (n) {
-        status->unseen = dlist_num(n);
-    }
-
-    dlist_free(&dl);
-    return 0;
+    return dlist_parsesax(rest, restlen, 0, _saxconvstatus, &rock);
 }
 
 EXPORTED int conversation_getstatus(struct conversations_state *state,
@@ -1051,56 +1199,269 @@ EXPORTED conv_folder_t *conversation_get
     folder->number = number;
     folder->next = *nextp;
     *nextp = folder;
-    conv->dirty = 1;
+    conv->flags |= CONV_ISDIRTY;
 
     return folder;
 }
 
-static conv_thread_t *parse_thread(struct dlist *dl)
+struct convparserock {
+    conversation_t *conv;
+    strarray_t strs;
+    conv_folder_t *folder;
+    conv_thread_t *thread;
+    conv_thread_t **nextthread;
+    int state;
+    int substate;
+    int flags;
+};
+
+int _saxconvparse(int type, struct dlistsax_data *d)
 {
-    conv_thread_t *res = NULL;
-    conv_thread_t **p = &res;
-    struct dlist *item = dl->head;
-    struct dlist *n;
-    while (item) {
-        conv_thread_t *thread = *p = xzmalloc(sizeof(conv_thread_t));
-        p = &thread->next;
-        n = dlist_getchildn(item, 0);
-        if (n) {
-            struct message_guid *guid = NULL;
-            dlist_toguid(n, &guid);
-            if (guid) message_guid_copy(&thread->guid, guid);
-        }
-        n = dlist_getchildn(item, 1);
-        if (n) thread->exists = dlist_num(n);
-        n = dlist_getchildn(item, 2);
-        if (n) thread->internaldate = dlist_num(n);
-        n = dlist_getchildn(item, 3);
-        if (n) thread->msgid = dlist_num(n);
-        n = dlist_getchildn(item, 4);
-        if (n) thread->inreplyto = dlist_num(n);
-        item = item->next;
-    }
-
-    return res;
-}
-
-EXPORTED int conversation_parse(struct conversations_state *state,
-                       const char *data, size_t datalen,
-                       conversation_t **convp)
+    struct convparserock *rock = (struct convparserock *)d->rock;
+    switch (rock->state) {
+    case 0:
+        // initial dlist start
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 1;
+        return 0;
+
+    case 1:
+        // modseq
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->modseq = atomodseq_t(d->data);
+        rock->state = 2;
+        return 0;
+
+    case 2:
+        // num_records
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->num_records = atol(d->data);
+        rock->state = 3;
+        return 0;
+
+    case 3:
+        // exists
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->exists = atol(d->data);
+        rock->state = 4;
+        return 0;
+
+    case 4:
+        // unseen
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->unseen = atol(d->data);
+        rock->conv->prev_unseen = rock->conv->unseen;
+        rock->state = 5;
+        return 0;
+
+    case 5:
+        // enter flagcounts
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 6;
+        return 0;
+
+    case 6:
+        if (type == DLISTSAX_LISTEND) {
+            // end of flagcounts
+            rock->substate = 0;
+            rock->state = 7;
+            return 0;
+        }
+        // inside flagcounts
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->counts[rock->substate++] = atol(d->data);
+        return 0;
+
+    case 7:
+        // start of folders list
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 8;
+        return 0;
+
+    case 8:
+        if (type == DLISTSAX_LISTEND) {
+            rock->state = 10; // finished folders list
+            return 0;
+        }
+        // start of individual folder info
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 9;
+        return 0;
+
+    case 9:
+        if (type == DLISTSAX_LISTEND) {
+            rock->substate = 0;
+            rock->state = 8; // back to folders list state
+            return 0;
+        }
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        if (!(rock->flags & CONV_WITHFOLDERS)) return 0;
+        switch (rock->substate) {
+        case 0:
+            rock->folder = conversation_get_folder(rock->conv, atol(d->data), 1);
+            rock->substate = 1;
+            return 0;
+        case 1:
+            rock->folder->modseq = atomodseq_t(d->data);
+            rock->substate = 2;
+            return 0;
+        case 2:
+            rock->folder->num_records = atol(d->data);
+            rock->substate = 3;
+            return 0;
+        case 3:
+            rock->folder->exists = atol(d->data);
+            rock->folder->prev_exists = rock->folder->exists;
+            rock->substate = 4;
+            return 0;
+        case 4:
+            rock->folder->unseen = atol(d->data);
+            rock->substate = 5;
+            return 0;
+        }
+        return IMAP_MAILBOX_BADFORMAT;
+
+    case 10:
+        // start senders list
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 11;
+        return 0;
+
+    case 11:
+        if (type == DLISTSAX_LISTEND) {
+            // end of senders list
+            rock->state = 13;
+            return 0;
+        }
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 12;
+        return 0;
+
+    case 12:
+        // individual sender items
+        if (type == DLISTSAX_LISTEND) {
+            if (rock->flags & CONV_WITHSENDERS) {
+                conversation_update_sender(rock->conv,
+                                           strarray_nth(&rock->strs, 0),
+                                           strarray_nth(&rock->strs, 1),
+                                           strarray_nth(&rock->strs, 2),
+                                           strarray_nth(&rock->strs, 3),
+                                           atol(strarray_nth(&rock->strs, 4)),
+                                           atol(strarray_nth(&rock->strs, 5)));
+                strarray_fini(&rock->strs);
+            }
+            rock->substate = 0;
+            rock->state = 11; // drop back to senders list
+            return 0;
+        }
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        if (rock->flags & CONV_WITHSENDERS)
+            strarray_set(&rock->strs, rock->substate++, d->data);
+        return 0;
+
+    case 13:
+        // encoded subject
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        if (rock->flags & CONV_WITHSUBJECT)
+            rock->conv->subject = xstrdupnull(d->data);
+        rock->state = 14;
+        return 0;
+
+    case 14:
+        if (type == DLISTSAX_LISTEND) {
+            rock->state = 20; // finish early
+            return 0;
+        }
+        // conversation size
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->size = atol(d->data);
+        rock->state = 15;
+        return 0;
+
+    case 15:
+        if (type == DLISTSAX_LISTEND) {
+            rock->state = 20; // finish early
+            return 0;
+        }
+        // start thread list
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 16;
+        rock->nextthread = &rock->conv->thread;
+        return 0;
+
+    case 16:
+        if (type == DLISTSAX_LISTEND) {
+            // end of thread list
+            rock->state = 18;
+            return 0;
+        }
+        if (type != DLISTSAX_LISTSTART) return IMAP_MAILBOX_BADFORMAT;
+        if (rock->flags & CONV_WITHTHREAD)
+            rock->thread = xzmalloc(sizeof(conv_thread_t));
+        rock->state = 17;
+        return 0;
+
+    case 17:
+        if (type == DLISTSAX_LISTEND) {
+            // end of individual thread
+            if (rock->flags & CONV_WITHTHREAD) {
+                *rock->nextthread = rock->thread;
+                rock->nextthread = &rock->thread->next;
+                rock->thread = NULL;
+            }
+            rock->substate = 0;
+            rock->state = 16;
+            return 0;
+        }
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        if (!(rock->flags & CONV_WITHTHREAD)) return 0;
+        switch (rock->substate) {
+        case 0:
+            message_guid_decode(&rock->thread->guid, d->data);
+            rock->substate = 1;
+            return 0;
+
+        case 1:
+            rock->thread->exists = atol(d->data);
+            rock->substate = 2;
+            return 0;
+
+        case 2:
+            rock->thread->internaldate = atol(d->data);
+            rock->substate = 3;
+            return 0;
+        }
+        return 0; // there might be following fields that we ignore here
+
+    case 18:
+        if (type == DLISTSAX_LISTEND) {
+            rock->state = 20; // finish early
+            return 0;
+        }
+        if (type != DLISTSAX_STRING) return IMAP_MAILBOX_BADFORMAT;
+        rock->conv->createdmodseq = atomodseq_t(d->data);
+        rock->state = 19;
+        return 0;
+
+    case 19:
+        if (type != DLISTSAX_LISTEND) return IMAP_MAILBOX_BADFORMAT;
+        rock->state = 20;
+        return 0;
+
+    }
+
+    // we should finish at createdmodseq
+    return IMAP_MAILBOX_BADFORMAT;
+}
+
+EXPORTED int conversation_parse(const char *data, size_t datalen,
+                                conversation_t *conv, int flags)
 {
     const char *rest;
-    int i;
     int restlen;
     bit64 version;
-    struct dlist *dl = NULL;
-    struct dlist *n, *nn;
-    conversation_t *conv;
-    conv_folder_t *folder;
     int r;
 
-    *convp = NULL;
-
     r = parsenum(data, &rest, datalen, &version);
     if (r) return IMAP_MAILBOX_BADFORMAT;
 
@@ -1110,101 +1471,22 @@ EXPORTED int conversation_parse(struct c
 
     if (version != CONVERSATIONS_VERSION) return IMAP_MAILBOX_BADFORMAT;
 
-    r = dlist_parsemap(&dl, 0, 0, rest, restlen);
-    if (r) return r;
-
-    conv = conversation_new(state);
-
-    n = dlist_getchildn(dl, 0);
-    if (n)
-        conv->modseq = dlist_num(n);
-    n = dlist_getchildn(dl, 1);
-    if (n)
-        conv->num_records = dlist_num(n);
-    n = dlist_getchildn(dl, 2);
-    if (n)
-        conv->exists = dlist_num(n);
-    n = dlist_getchildn(dl, 3);
-    if (n)
-        conv->unseen = dlist_num(n);
-    n = dlist_getchildn(dl, 4);
-    if (state->counted_flags) {
-        nn = n ? n->head : NULL;
-        for (i = 0; i < state->counted_flags->count; i++) {
-            if (nn) {
-                conv->counts[i] = dlist_num(nn);
-                nn = nn->next;
-            }
-            else
-                conv->counts[i] = 0;
-        }
-    }
-
-    n = dlist_getchildn(dl, 5);
-    for (n = (n ? n->head : NULL) ; n ; n = n->next) {
-        int number;
-        nn = dlist_getchildn(n, 0);
-        if (!nn)
-            continue;
-        number = dlist_num(nn);
-        folder = conversation_get_folder(conv, number, 1);
-
-        nn = dlist_getchildn(n, 1);
-        if (nn)
-            folder->modseq = dlist_num(nn);
-        nn = dlist_getchildn(n, 2);
-        if (nn)
-            folder->num_records = dlist_num(nn);
-        nn = dlist_getchildn(n, 3);
-        if (nn)
-            folder->exists = dlist_num(nn);
-        nn = dlist_getchildn(n, 4);
-        if (nn)
-            folder->unseen = dlist_num(nn);
-
-        folder->prev_exists = folder->exists;
-    }
-
-    n = dlist_getchildn(dl, 6);
-    for (n = (n ? n->head : NULL) ; n ; n = n->next) {
-        struct dlist *nn2, *nn3, *nn4, *nn5, *nn6;
-        nn = dlist_getchildn(n, 0);
-        nn2 = dlist_getchildn(n, 1);
-        nn3 = dlist_getchildn(n, 2);
-        nn4 = dlist_getchildn(n, 3);
-        nn5 = dlist_getchildn(n, 4);
-        nn6 = dlist_getchildn(n, 5);
-        if (nn6)
-            conversation_update_sender(conv, nn->sval, nn2->sval,
-                                       nn3->sval, nn4->sval,
-                                       dlist_num(nn5), dlist_num(nn6));
-        else if (nn4) /* XXX: remove when cleaned up - handle old-style too */
-            conversation_update_sender(conv, nn->sval, nn2->sval,
-                                       nn3->sval, nn4->sval,
-                                       0/*time_t*/, (1<<30)/*exists*/);
-        /* INSANE EXISTS NUMBER MEANS IT NEVER GETS CLEANED UP */
-    }
-
-    n = dlist_getchildn(dl, 7);
-    if (n) conv->subject = xstrdupnull(dlist_cstring(n));
+    struct convparserock rock = { conv, STRARRAY_INITIALIZER,
+                                  NULL, NULL, NULL, 0, 0, flags };
 
-    n = dlist_getchildn(dl, 8);
-    if (n) conv->size = dlist_num(n);
-
-    n = dlist_getchildn(dl, 9);
-    if (n) conv->thread = parse_thread(n);
+    r = dlist_parsesax(rest, restlen, 0, _saxconvparse, &rock);
+    if (r) return r;
 
-    conv->prev_unseen = conv->unseen;
+    conv->flags = flags;
 
-    dlist_free(&dl);
-    conv->dirty = 0;
-    *convp = conv;
     return 0;
 }
 
-EXPORTED int conversation_load(struct conversations_state *state,
+
+EXPORTED int conversation_load_advanced(struct conversations_state *state,
                       conversation_id_t cid,
-                      conversation_t **convp)
+                      conversation_t *conv,
+                      int flags)
 {
     const char *data;
     size_t datalen;
@@ -1218,25 +1500,45 @@ EXPORTED int conversation_load(struct co
                   &state->txn);
 
     if (r == CYRUSDB_NOTFOUND) {
-        *convp = NULL;
-        return 0;
+        return IMAP_MAILBOX_NONEXISTENT;
     } else if (r != CYRUSDB_OK) {
-        return r;
+        return IMAP_INTERNAL;
     }
     xstats_inc(CONV_LOAD);
 
-    r = conversation_parse(state, data, datalen, convp);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: conversations invalid conversation "
-               CONV_FMT, cid);
-        *convp = NULL;
-    }
+    r = conversation_parse(data, datalen, conv, flags);
 
-    if (_sanity_check_counts(*convp)) {
+    if (r || ((conv->flags & CONV_WITHFOLDERS) && _sanity_check_counts(conv))) {
         syslog(LOG_ERR, "IOERROR: conversations_audit on load: %s %s %.*s",
                state->path, bkey, (int)datalen, data);
     }
 
+    const conv_folder_t *folder = conversation_get_folder(conv, state->trashfolder, /*create*/0);
+    if (folder) {
+        conv->trash_unseen = conv->prev_trash_unseen = folder->unseen;
+    }
+    else {
+        conv->trash_unseen = conv->prev_trash_unseen = 0;
+    }
+
+    return r;
+}
+
+EXPORTED int conversation_load(struct conversations_state *state,
+                      conversation_id_t cid,
+                      conversation_t **convp)
+{
+    // we'll malloc one
+    conversation_t *conv = conversation_new();
+    int r = conversation_load_advanced(state, cid, conv, CONV_WITHALL);
+    if (r) {
+        // we still return success, just don't have any data
+        conversation_free(conv);
+        *convp = NULL;
+    }
+    else {
+        *convp = conv;
+    }
     return 0;
 }
 
@@ -1331,7 +1633,7 @@ static int sender_cmp(const conv_sender_
 static int sender_preferred_mailbox(const char *a, const char *b)
 {
     /* choosing the lexically earlier string tends to keep
-     * capital letters, which is an arbitrary asthetic */
+     * capital letters, which is an arbitrary aesthetic */
     return strcmpsafe(a, b);
 }
 
@@ -1340,7 +1642,7 @@ static int sender_preferred_mailbox(cons
 static int sender_preferred_domain(const char *a, const char *b)
 {
     /* choosing the lexically earlier string tends to keep
-     * capital letters, which is an arbitrary asthetic */
+     * capital letters, which is an arbitrary aesthetic */
     return strcmpsafe(a, b);
 }
 
@@ -1349,7 +1651,7 @@ static int sender_preferred_domain(const
 static int sender_preferred_route(const char *a, const char *b)
 {
     /* choosing the lexically earlier string tends to keep
-     * capital letters, which is an arbitrary asthetic */
+     * capital letters, which is an arbitrary aesthetic */
     return strcmpsafe(a, b);
 }
 
@@ -1395,14 +1697,51 @@ static int sender_preferred_name(const c
     return d;
 }
 
+static int _thread_datesort(const void **a, const void **b)
+{
+    const conv_thread_t *ta = (const conv_thread_t *)*a;
+    const conv_thread_t *tb = (const conv_thread_t *)*b;
+
+    int r = (ta->internaldate - tb->internaldate);
+    if (r < 0) return -1;
+    if (r > 0) return 1;
+
+    return message_guid_cmp(&ta->guid, &tb->guid);
+}
+
+static void conversations_thread_sort(conversation_t *conv)
+{
+    conv_thread_t *thread;
+    ptrarray_t items = PTRARRAY_INITIALIZER;
+
+    for (thread = conv->thread; thread; thread = thread->next) {
+        ptrarray_append(&items, thread);
+    }
+
+    ptrarray_sort(&items, _thread_datesort);
+
+    conv_thread_t **nextp = &conv->thread;
+
+    // relink the list
+    int i;
+    for (i = 0; i < ptrarray_size(&items); i++) {
+        thread = ptrarray_nth(&items, i);
+        *nextp = thread;
+        nextp = &thread->next;
+    }
+
+    // finish the list
+    *nextp = NULL;
+
+    ptrarray_fini(&items);
+}
+
 static void conversation_update_thread(conversation_t *conv,
                                        const struct message_guid *guid,
                                        time_t internaldate,
-                                       const char *msgid,
-                                       const char *inreplyto,
                                        int delta_exists)
 {
-    conv_thread_t *thread, *parent, **nextp = &conv->thread;
+    conv_thread_t *thread, **nextp = &conv->thread;
 
     for (thread = conv->thread; thread; thread = thread->next) {
         /* does it already exist? */
@@ -1411,58 +1750,26 @@ static void conversation_update_thread(c
         nextp = &thread->next;
     }
 
-    if (thread) {
-        /* unstitch */
-        *nextp = thread->next;
-    }
-    else {
-        /* we start with zero */
+    if (!thread) {
+        if (delta_exists <= 0) return; // no thread and no count, skip
         thread = xzmalloc(sizeof(*thread));
+        *nextp = thread;
     }
-
-    /* counts first, may be just removing it */
-    if (thread->exists + delta_exists <= 0) {
-        conv->dirty = 1;
+    else if (thread->exists + delta_exists <= 0) {
+        /* we're just removing the thread, this is always sort-safe */
+        *nextp = thread->next;
         free(thread);
+        conv->flags |= CONV_ISDIRTY;
         return;
     }
 
     message_guid_copy(&thread->guid, guid);
     thread->internaldate = internaldate;
-    thread->exists += delta_exists;
-    /* just copy, it's not that expensive for a write */
-    thread->msgid = msgid ? crc32_cstring(msgid) : 0;
-    thread->inreplyto = inreplyto ? crc32_cstring(inreplyto) : 0;
-
-    if (thread->inreplyto) {
-        /* see if we can stitch it into the list behind the message it replies to */
-        conv_thread_t *candidate = NULL;
-        for (parent = conv->thread; parent; parent = parent->next) {
-            if (thread->inreplyto == parent->msgid) {
-                candidate = parent;
-            }
-            if (thread->inreplyto == parent->inreplyto) {
-                if (parent->internaldate < internaldate)
-                    candidate = parent;
-            }
-        }
-        if (candidate) {
-            thread->next = candidate->next;
-            candidate->next = thread;
-            return;
-        }
-    }
-
-    /* OK, we didn't find a parent to attach to, so just go through by date and put it
-     * after the last one with an earlier date */
-    nextp = &conv->thread;
-    for (parent = conv->thread; parent; parent = parent->next) {
-        if (parent->internaldate > thread->internaldate) break;
-        nextp = &parent->next;
-    }
+    _apply_delta(&thread->exists, delta_exists);
 
-    thread->next = *nextp;
-    *nextp = thread;
+    conversations_thread_sort(conv);
+    // if we've sorted, it's probably dirty
+    conv->flags |= CONV_ISDIRTY;
 }
 
 EXPORTED void conversation_update_sender(conversation_t *conv,
@@ -1495,7 +1802,7 @@ EXPORTED void conversation_update_sender
 
     /* counts first, may be just removing it */
     if (delta_exists <= 0 && (uint32_t)(- delta_exists) >= sender->exists) {
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
         free(sender->name);
         free(sender->route);
         free(sender->mailbox);
@@ -1505,7 +1812,7 @@ EXPORTED void conversation_update_sender
     }
 
     /* otherwise update the counter */
-    sender->exists += delta_exists;
+    _apply_delta(&sender->exists, delta_exists);
 
     /* ensure the database is consistent regardless
      * of message arrival order, update the record if the newly
@@ -1522,12 +1829,12 @@ EXPORTED void conversation_update_sender
 
     if (!sender->mailbox || sender_preferred_mailbox(sender->mailbox, mailbox) > 0) {
         free(sender->mailbox);
-        sender->mailbox = xstrdup(mailbox);
+        sender->mailbox = xstrdupnull(mailbox);
     }
 
     if (!sender->domain || sender_preferred_domain(sender->domain, domain) > 0) {
         free(sender->domain);
-        sender->domain = xstrdup(domain);
+        sender->domain = xstrdupnull(domain);
     }
 
     /* last seen for display sorting */
@@ -1549,27 +1856,7 @@ EXPORTED void conversation_update_sender
     sender->next = *nextp;
     *nextp = sender;
 
-    conv->dirty = 1;
-}
-
-static void _apply_delta(uint32_t *valp, int delta)
-{
-    if (delta >= 0) {
-        *valp += delta;
-    }
-    else {
-        uint32_t decrease = -delta;
-        /* let us die where it broke */
-        if (decrease <= *valp)
-            *valp -= decrease;
-        else
-            *valp = 0;
-    }
-}
-
-EXPORTED const strarray_t *conversations_get_folders(struct conversations_state *state)
-{
-    return state->folder_names;
+    conv->flags |= CONV_ISDIRTY;
 }
 
 static int _match1(void *rock,
@@ -1599,23 +1886,44 @@ struct guid_foreach_rock {
     struct conversations_state *state;
     int(*cb)(const conv_guidrec_t *, void *);
     void *cbrock;
+    const void *filterdata;
+    int filternum;
+    int filterpos;
+    struct buf partbuf;
 };
 
-static int _guid_one(const char *s, struct guid_foreach_rock *frock, conversation_id_t cid)
+static int _guid_one(struct guid_foreach_rock *frock,
+                     const char *key,
+                     conversation_id_t cid,
+                     uint32_t system_flags,
+                     uint32_t internal_flags,
+                     time_t internaldate,
+                     char version)
 {
     const char *p, *err;
     conv_guidrec_t rec;
     uint32_t res;
 
-    p = strchr(s, ':');
-    if (!p) return IMAP_INTERNAL;
-
-    /* cid */
+    /* Set G record values */
+    rec.guidrep = key+1;
     rec.cid = cid;
+    rec.system_flags = system_flags;
+    rec.internal_flags = internal_flags;
+    rec.internaldate = internaldate;
+    rec.version = version;
+
+    /* ensure a NULL terminated key string */
+    buf_cstring(&frock->partbuf);
+    char *item = frock->partbuf.s;
+
+    /* Parse G record key */
+    p = strchr(item, ':');
+    if (!p) return IMAP_INTERNAL;
 
     /* mboxname */
-    int r = parseuint32(s, &err, &res);
+    int r = parseuint32(item, &err, &res);
     if (r || err != p) return IMAP_INTERNAL;
+    rec.foldernum = res;
     rec.mboxname = strarray_safenth(frock->state->folder_names, res);
     if (!rec.mboxname) return IMAP_INTERNAL;
 
@@ -1627,20 +1935,41 @@ static int _guid_one(const char *s, stru
 
     /* part */
     rec.part = NULL;
-    char *freeme = NULL;
     if (*p) {
-        const char *end = strchr(p+1, ']');
+        char *end = strchr(p+1, ']');
         if (*p != '[' || !end || p+1 == end) {
             return IMAP_INTERNAL;
         }
-        rec.part = freeme = xstrndup(p+1, end-p-1);
+        // overwrite the end of the part in the buffer buffer to avoid double-dupe
+        *end = '\0';
+        rec.part = p+1;
     }
 
     r = frock->cb(&rec, frock->cbrock);
-    free(freeme);
     return r;
 }
 
+static int _guid_filter_p(void *rock,
+                          const char *key,
+                          size_t keylen,
+                          const char *data __attribute__((unused)),
+                          size_t datalen __attribute__((unused)))
+{
+    if (keylen < 41) return 0; // bogus record??
+
+    struct guid_foreach_rock *frock = (struct guid_foreach_rock *)rock;
+
+    for (; frock->filterpos < frock->filternum; frock->filterpos++) {
+        int cmp = memcmp(frock->filterdata + (41 * frock->filterpos), key+1, 40);
+        if (cmp > 0) break; // definitely not a match
+        if (cmp == 0) return 1; // match.
+        /* We don't also increment for a match because multiple rows
+         * could have the same GUID */
+    }
+
+    return 0;  // no match
+}
+
 static int _guid_cb(void *rock,
                     const char *key,
                     size_t keylen,
@@ -1648,7 +1977,7 @@ static int _guid_cb(void *rock,
                     size_t datalen)
 {
     struct guid_foreach_rock *frock = (struct guid_foreach_rock *)rock;
-    int r;
+    int r = 0;
 
     if (keylen < 41)
         return IMAP_INTERNAL;
@@ -1658,7 +1987,10 @@ static int _guid_cb(void *rock,
         strarray_t *recs = strarray_nsplit(data, datalen, ",", /*flags*/0);
         int i;
         for (i = 0; i < recs->count; i++) {
-            r = _guid_one(strarray_nth(recs, i), frock, /*cid*/0);
+            buf_setcstr(&frock->partbuf, strarray_nth(recs, i));
+            r = _guid_one(frock, key, /*cid*/0,
+                          /*system_flags*/0, /*internal_flags*/0,
+                          /*internaldate*/0, /*version*/0);
             if (r) break;
         }
         strarray_free(recs);
@@ -1670,15 +2002,63 @@ static int _guid_cb(void *rock,
         return IMAP_INTERNAL;
 
     conversation_id_t cid = 0;
+    uint32_t system_flags = 0;
+    uint32_t internal_flags = 0;
+    time_t internaldate = 0;
+    char version = 0;
     if (datalen >= 16) {
         const char *p = data;
-        r = parsehex(p, &p, 16, &cid);
-        if (r) return r;
+
+        /* version */
+        if (*p & 0x80) version = *p & 0x7f;
+        if (version > 0) p++;
+
+        if (version == 0) {
+            /* cid */
+            r = parsehex(p, &p, 16, &cid);
+            if (r) return r;
+        }
+        else {
+            /* cid */
+            cid = ntohll(*((bit64*)p));
+            p += 8;
+            /* system_flags */
+            system_flags = ntohl(*((bit32*)p));
+            p += 4;
+            /* internal flags */
+            internal_flags = ntohl(*((bit32*)p));
+            p += 4;
+            /* internaldate*/
+            internaldate = (time_t) ntohll(*((bit64*)p));
+            p += 8;
+        }
     }
 
-    char *freeme = xstrndup(key+42, keylen-42);
-    r = _guid_one(freeme, frock, cid);
-    free(freeme);
+    buf_setmap(&frock->partbuf, key+42, keylen-42);
+    r = _guid_one(frock, key, cid, system_flags, internal_flags,
+                  internaldate, version);
+
+    return r;
+}
+
+static int _guid_foreach_helper(struct conversations_state *state,
+                                const char *prefix,
+                                int(*cb)(const conv_guidrec_t *, void *),
+                                void *cbrock,
+                                const void *data,
+                                size_t num)
+{
+    struct guid_foreach_rock rock = {
+        state, cb, cbrock, data, num, 0, BUF_INITIALIZER
+    };
+
+    foreach_p *filter = data ? _guid_filter_p : NULL;
+
+    char *key = strconcat("G", prefix, (char *)NULL);
+    int r = cyrusdb_foreach(state->db, key, strlen(key), filter, _guid_cb, &rock, &state->txn);
+    free(key);
+
+    buf_free(&rock.partbuf);
 
     return r;
 }
@@ -1688,16 +2068,39 @@ EXPORTED int conversations_guid_foreach(
                                         int(*cb)(const conv_guidrec_t *, void *),
                                         void *cbrock)
 {
-    struct guid_foreach_rock rock;
-    rock.state = state;
-    rock.cb = cb;
-    rock.cbrock = cbrock;
-
-    char *key = strconcat("G", guidrep, (char *)NULL);
-    int r = cyrusdb_foreach(state->db, key, strlen(key), NULL, _guid_cb, &rock, NULL);
-    free(key);
+    return _guid_foreach_helper(state, guidrep, cb, cbrock, NULL, 0);
+}
 
-    return r;
+EXPORTED int conversations_iterate_searchset(struct conversations_state *state,
+                                             const void *data, size_t n,
+                                             int(*cb)(const conv_guidrec_t*,void*),
+                                             void *cbrock)
+{
+    // magic number to switch from index mode to scan mode
+    size_t limit = config_getint(IMAPOPT_SEARCH_QUERYSCAN);
+    if (limit && n > limit) {
+        size_t estimate = conversations_estimate_emailcount(state);
+        if (estimate > n*20) { // 5% matches is enough to to iterate!
+            syslog(LOG_DEBUG, "conversation_iterate_searchset: %s falling back to index for %d/%d records",
+                   state->path, (int)n, (int)estimate);
+        }
+        else {
+            syslog(LOG_DEBUG, "conversation_iterate_searchset: %s using scan mode for %d/%d records",
+                   state->path, (int)n, (int)estimate);
+            return _guid_foreach_helper(state, "", cb, cbrock, data, n);
+        }
+    }
+    else {
+        syslog(LOG_DEBUG, "conversation_iterate_searchset: %s using indexed mode for %d records",
+               state->path, (int)n);
+    }
+    size_t i;
+    for (i = 0; i < n; i++) {
+        const char *guidrep = data + (i*41);
+        int r = conversations_guid_foreach(state, guidrep, cb, cbrock);
+        if (r) return r;
+    }
+    return 0;
 }
 
 static int _getcid(const conv_guidrec_t *rec, void *rock)
@@ -1719,8 +2122,14 @@ EXPORTED conversation_id_t conversations
 }
 
 
-static int conversations_guid_setitem(struct conversations_state *state, const char *guidrep,
-                                      const char *item, conversation_id_t cid, int add)
+static int conversations_guid_setitem(struct conversations_state *state,
+                                      const char *guidrep,
+                                      const char *item,
+                                      conversation_id_t cid,
+                                      uint32_t system_flags,
+                                      uint32_t internal_flags,
+                                      time_t internaldate,
+                                      int add)
 {
     struct buf key = BUF_INITIALIZER;
     buf_setcstr(&key, "G");
@@ -1756,13 +2165,17 @@ static int conversations_guid_setitem(st
     buf_appendcstr(&key, item);
 
     if (add) {
-        char val[17];
-        size_t len = 0;
-        if (cid) {
-            snprintf(val, 17, "%016llx", cid);
-            len = 16;
-        }
-        r = cyrusdb_store(state->db, buf_base(&key), buf_len(&key), val, len, &state->txn);
+        /* When bumping the G value version, make sure to update _guid_cb */
+        struct buf val = BUF_INITIALIZER;
+        buf_putc(&val, (char)(0x80 | CONV_GUIDREC_VERSION));
+        buf_appendbit64(&val, cid);
+        buf_appendbit32(&val, system_flags);
+        buf_appendbit32(&val, internal_flags);
+        buf_appendbit64(&val, (bit64)internaldate);
+        r = cyrusdb_store(state->db, buf_base(&key), buf_len(&key),
+                                     buf_base(&val), buf_len(&val),
+                                     &state->txn);
+        buf_free(&val);
     }
     else {
         r = cyrusdb_delete(state->db, buf_base(&key), buf_len(&key), &state->txn, /*force*/1);
@@ -1774,7 +2187,11 @@ done:
     return r;
 }
 
-static int _guid_addbody(struct conversations_state *state, struct body *body,
+static int _guid_addbody(struct conversations_state *state,
+                         conversation_id_t cid,
+                         uint32_t system_flags, uint32_t internal_flags,
+                         time_t internaldate,
+                         struct body *body,
                          const char *base, int add)
 {
     int i;
@@ -1788,17 +2205,19 @@ static int _guid_addbody(struct conversa
         buf_setcstr(&buf, base);
         buf_printf(&buf, "[%s]", body->part_id);
         const char *guidrep = message_guid_encode(&body->content_guid);
-        r = conversations_guid_setitem(state, guidrep, buf_cstring(&buf), /*cid*/0, add);
+        r = conversations_guid_setitem(state, guidrep, buf_cstring(&buf), cid,
+                                       system_flags, internal_flags, internaldate,
+                                       add);
         buf_free(&buf);
 
         if (r) return r;
     }
 
-    r = _guid_addbody(state, body->subpart, base, add);
+    r = _guid_addbody(state, cid, system_flags, internal_flags, internaldate, body->subpart, base, add);
     if (r) return r;
 
     for (i = 1; i < body->numparts; i++) {
-        r = _guid_addbody(state, body->subpart + i, base, add);
+        r = _guid_addbody(state, cid, system_flags, internal_flags, internaldate, body->subpart + i, base, add);
         if (r) return r;
     }
 
@@ -1825,8 +2244,40 @@ static int conversations_set_guid(struct
     const char *base = buf_cstring(&item);
 
     r = conversations_guid_setitem(state, message_guid_encode(&record->guid),
-                                   base, record->cid, add);
-    if (!r) r = _guid_addbody(state, body, base, add);
+                                   base, record->cid,
+                                   record->system_flags,
+                                   record->internal_flags,
+                                   record->internaldate,
+                                   add);
+    if (!r) r = _guid_addbody(state, record->cid,
+                              record->system_flags, record->internal_flags,
+                              record->internaldate, body, base, add);
+
+#ifdef WITH_DAV
+    if (!r && (mailbox->mbtype == MBTYPE_ADDRESSBOOK) &&
+        !strcmp(body->type, "TEXT") && !strcmp(body->subtype, "VCARD")) {
+
+        struct vparse_card *vcard = record_to_vcard(mailbox, record);
+
+        if (vcard) {
+            struct message_guid guid;
+            struct vparse_entry *photo =
+                vparse_get_entry(vcard->objects, NULL, "photo");
+
+            if (photo && vcard_prop_decode_value(photo, NULL, NULL, &guid)) {
+                buf_printf(&item, "[%s/VCARD#PHOTO]", body->part_id);
+                r = conversations_guid_setitem(state, message_guid_encode(&guid),
+                                               buf_cstring(&item), 0 /*cid*/,
+                                               record->system_flags,
+                                               record->internal_flags,
+                                               record->internaldate,
+                                               add);
+            }
+
+            vparse_free_card(vcard);
+        }
+    }
+#endif /* WITH_DAV */
 
     message_free_body(body);
     free(body);
@@ -1834,10 +2285,38 @@ static int conversations_set_guid(struct
     return r;
 }
 
+static int _read_emailcounts_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct emailcounts *ecounts = (struct emailcounts *)rock;
+    if (rec->part) return 0;
+    if (strcmp(ecounts->mboxname, rec->mboxname)) return 0;
+    // ok, we're in the same folder - are we expunged?
+    if (rec->version > 0 &&
+         (rec->system_flags & FLAG_DELETED ||
+          rec->internal_flags & FLAG_INTERNAL_EXPUNGED))
+        return 0;
+    if (ecounts->ispost) {
+        // not expunged or unsure, count it as exists
+        ecounts->post_emailexists++;
+        // not seen or unsure, count it as unseen
+        if (rec->version == 0 || !(rec->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
+            ecounts->post_emailunseen++;
+    }
+    else {
+        // not expunged or unsure, count it as exists
+        ecounts->pre_emailexists++;
+        // not seen or unsure, count it as unseen
+        if (rec->version == 0 || !(rec->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
+            ecounts->pre_emailunseen++;
+    }
+    return 0;
+}
+
 EXPORTED int conversations_update_record(struct conversations_state *cstate,
                                          struct mailbox *mailbox,
                                          const struct index_record *old,
-                                         struct index_record *new)
+                                         struct index_record *new,
+                                         int allowrenumber)
 {
     conversation_t *conv = NULL;
     int delta_num_records = 0;
@@ -1856,25 +2335,27 @@ EXPORTED int conversations_update_record
         assert(old->modseq <= new->modseq);
 
         /* this flag cannot go away */
-        if ((old->system_flags & FLAG_EXPUNGED))
-            assert((new->system_flags & FLAG_EXPUNGED));
+        if (old->internal_flags & FLAG_INTERNAL_EXPUNGED)
+                assert(new->internal_flags & FLAG_INTERNAL_EXPUNGED);
 
         /* we're changing the CID for any reason at all, treat as
          * a removal and re-add, so cache gets parsed and msgids
          * updated */
         if (old->cid != new->cid) {
-            r = conversations_update_record(cstate, mailbox, old, NULL);
+            r = conversations_update_record(cstate, mailbox, old, NULL, 0);
             if (r) return r;
-            return conversations_update_record(cstate, mailbox, NULL, new);
+            return conversations_update_record(cstate, mailbox, NULL, new, 0);
         }
     }
 
     const struct index_record *record = new ? new : old;
-    if (new && !old) {
+    if (!record) return 0;
+
+    if (new && !old && allowrenumber) {
         /* add the conversation */
         r = mailbox_cacherecord(mailbox, new); /* make sure it's loaded */
         if (r) return r;
-        r = message_update_conversations(cstate, new, &conv);
+        r = message_update_conversations(cstate, mailbox, new, &conv);
         if (r) return r;
     }
     else if (record->cid) {
@@ -1888,14 +2369,23 @@ EXPORTED int conversations_update_record
                                    "deleted, ignoring", record->cid);
                 return 0;
             }
-            conv = conversation_new(cstate);
+            conv = conversation_new();
         }
     }
 
+    struct emailcounts ecounts = EMAILCOUNTS_INIT;
+    /* count the email state before making GUID changes */
+    ecounts.mboxname = mailbox->name;
+    r = conversations_guid_foreach(cstate, message_guid_encode(&record->guid),
+                                   _read_emailcounts_cb, &ecounts);
+    if (r) return r;
+
     // always update the GUID information first, as it's used for search
     // even if conversations have not been set on this email
     if (new) {
-        if (!old) {
+        if (!old || old->system_flags != new->system_flags ||
+                    old->internal_flags != new->internal_flags ||
+                    old->internaldate != new->internaldate) {
             r = conversations_set_guid(cstate, mailbox, new, /*add*/1);
             if (r) return r;
         }
@@ -1907,33 +2397,26 @@ EXPORTED int conversations_update_record
         }
     }
 
-    // the rest is bookkeeping for CIDs only
+    // the rest is bookkeeping purely for CIDed messages
     if (!record->cid) return 0;
 
-    if (cstate->counted_flags)
-        delta_counts = xzmalloc(sizeof(int) * cstate->counted_flags->count);
-
     /* IRIS-2534: check if it's the trash folder - XXX - should be separate
      * conversation root or similar more useful method in future */
-    mbname_t *mbname = mbname_from_intname(mailbox->name);
-    if (!mbname)
-        return IMAP_MAILBOX_BADNAME;
-
-    const strarray_t *boxes = mbname_boxes(mbname);
-    if (strarray_size(boxes) == 1 && !strcmpsafe(strarray_nth(boxes, 0), "Trash"))
-        is_trash = 1;
+    is_trash = mboxname_isusertrash(mailbox->name);
 
-    mbname_free(&mbname);
+    if (cstate->counted_flags)
+        delta_counts = xzmalloc(sizeof(int) * cstate->counted_flags->count);
 
     /* calculate the changes */
     if (old) {
         /* decrease any relevant counts */
-        if (!(old->system_flags & FLAG_EXPUNGED)) {
+        if (!(old->internal_flags & FLAG_INTERNAL_EXPUNGED) &&
+            !(old->system_flags & FLAG_DELETED)) {
             delta_exists--;
             delta_size -= old->size;
             /* drafts don't update the 'unseen' counter so that
              * they never turn a conversation "unread" */
-            if (!is_trash && !(old->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
+            if (!(old->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
                 delta_unseen--;
             if (cstate->counted_flags) {
                 for (i = 0; i < cstate->counted_flags->count; i++) {
@@ -1949,12 +2432,13 @@ EXPORTED int conversations_update_record
 
     if (new) {
         /* add any counts */
-        if (!(new->system_flags & FLAG_EXPUNGED)) {
+        if (!(new->internal_flags & FLAG_INTERNAL_EXPUNGED) &&
+            !(new->system_flags & FLAG_DELETED)) {
             delta_exists++;
             delta_size += new->size;
             /* drafts don't update the 'unseen' counter so that
              * they never turn a conversation "unread" */
-            if (!is_trash && !(new->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
+            if (!(new->system_flags & (FLAG_SEEN|FLAG_DRAFT)))
                 delta_unseen++;
             if (cstate->counted_flags) {
                 for (i = 0; i < cstate->counted_flags->count; i++) {
@@ -1968,6 +2452,12 @@ EXPORTED int conversations_update_record
         modseq = MAX(modseq, new->modseq);
     }
 
+    /* we've made any set_guid, so count the state again! */
+    ecounts.ispost = 1;
+    r = conversations_guid_foreach(cstate, message_guid_encode(&record->guid),
+                                   _read_emailcounts_cb, &ecounts);
+    if (r) return r;
+
     /* XXX - combine this with the earlier cache parsing */
     if (!mailbox_cacherecord(mailbox, record)) {
         char *env = NULL;
@@ -1985,33 +2475,27 @@ EXPORTED int conversations_update_record
         if (envtokens[ENV_FROM])
             message_parse_env_address(envtokens[ENV_FROM], &addr);
 
-        const char *msgid = envtokens[ENV_MSGID];
-        const char *inreplyto = NULL;
-        if (record->system_flags & FLAG_DRAFT) {
-            /* non-drafts don't get an inreplyto, using it as both a value AND a flag */
-            inreplyto = envtokens[ENV_INREPLYTO];
-        }
-
         /* XXX - internaldate vs gmtime? */
         conversation_update_sender(conv,
                                    addr.name, addr.route,
                                    addr.mailbox, addr.domain,
                                    record->gmtime, delta_exists);
-
-        conversation_update_thread(conv,
-                                   &record->guid,
-                                   record->internaldate,
-                                   msgid, inreplyto,
-                                   delta_exists);
         free(env);
     }
 
+
+    conversation_update_thread(conv,
+                               &record->guid,
+                               record->internaldate,
+                               delta_exists);
+
     conversation_update(cstate, conv, mailbox->name,
-                        delta_num_records,
+                        is_trash, delta_num_records,
                         delta_exists, delta_unseen,
-                        delta_size, delta_counts, modseq);
+                        delta_size, delta_counts, modseq,
+                        record->createdmodseq);
 
-    r = conversation_save(cstate, record->cid, conv);
+    r = conversation_save(cstate, record->cid, conv, &ecounts);
 
     conversation_free(conv);
     free(delta_counts);
@@ -2021,10 +2505,10 @@ EXPORTED int conversations_update_record
 
 EXPORTED void conversation_update(struct conversations_state *state,
                          conversation_t *conv, const char *mboxname,
-                         int delta_num_records,
+                         int is_trash, int delta_num_records,
                          int delta_exists, int delta_unseen,
                          int delta_size, int *delta_counts,
-                         modseq_t modseq)
+                         modseq_t modseq, modseq_t createdmodseq)
 {
     conv_folder_t *folder;
     int number = folder_number(state, mboxname, /*create*/1);
@@ -2035,87 +2519,91 @@ EXPORTED void conversation_update(struct
     if (delta_num_records) {
         _apply_delta(&conv->num_records, delta_num_records);
         _apply_delta(&folder->num_records, delta_num_records);
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
     }
     if (delta_exists) {
         _apply_delta(&conv->exists, delta_exists);
         _apply_delta(&folder->exists, delta_exists);
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
     }
     if (delta_unseen) {
-        _apply_delta(&conv->unseen, delta_unseen);
+        if (is_trash) _apply_delta(&conv->trash_unseen, delta_unseen);
+        else _apply_delta(&conv->unseen, delta_unseen);
         _apply_delta(&folder->unseen, delta_unseen);
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
     }
     if (delta_size) {
         _apply_delta(&conv->size, delta_size);
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
     }
     if (state->counted_flags) {
         for (i = 0; i < state->counted_flags->count; i++) {
             if (delta_counts[i]) {
                 _apply_delta(&conv->counts[i], delta_counts[i]);
-                conv->dirty = 1;
+                conv->flags |= CONV_ISDIRTY;
             }
         }
     }
     if (modseq > conv->modseq) {
         conv->modseq = modseq;
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
     }
     if (modseq > folder->modseq) {
         folder->modseq = modseq;
-        conv->dirty = 1;
+        conv->flags |= CONV_ISDIRTY;
+    }
+    if (createdmodseq && (!conv->createdmodseq || createdmodseq < conv->createdmodseq)) {
+        conv->createdmodseq = createdmodseq;
+        conv->flags |= CONV_ISDIRTY;
     }
 }
 
-EXPORTED conversation_t *conversation_new(struct conversations_state *state)
+EXPORTED conversation_t *conversation_new()
 {
     conversation_t *conv;
 
     conv = xzmalloc(sizeof(conversation_t));
-    if (state->counted_flags)
-        conv->counts = xzmalloc(sizeof(uint32_t) * state->counted_flags->count);
-    conv->dirty = 1;
+    conv->flags |= CONV_ISDIRTY;
     xstats_inc(CONV_NEW);
 
     return conv;
 }
 
-EXPORTED void conversation_free(conversation_t *conv)
+EXPORTED void conversation_fini(conversation_t *conv)
 {
-    conv_folder_t *folder;
-    conv_sender_t *sender;
-    conv_thread_t *thread;
-
     if (!conv) return;
 
+    conv_folder_t *folder;
     while ((folder = conv->folders)) {
         conv->folders = folder->next;
         free(folder);
     }
 
+    conv_sender_t *sender;
     while ((sender = conv->senders)) {
         conv->senders = sender->next;
-        free(sender->name);
-        free(sender->route);
-        free(sender->mailbox);
-        free(sender->domain);
+        xfree(sender->name);
+        xfree(sender->route);
+        xfree(sender->mailbox);
+        xfree(sender->domain);
         free(sender);
     }
 
-    free(conv->subject);
-    free(conv->counts);
+    xzfree(conv->subject);
 
+    conv_thread_t *thread;
     while ((thread = conv->thread)) {
         conv->thread = thread->next;
         free(thread);
     }
+}
 
+EXPORTED void conversation_free(conversation_t *conv)
+{
+    conversation_fini(conv);
     free(conv);
 }
 
-
 struct prune_rock {
     struct conversations_state *state;
     time_t thresh;
@@ -2210,8 +2698,13 @@ static int folder_key_rename(struct conv
         return conversation_setstatus(state, from_name, NULL);
     }
 
-    /* you can't delete a folder until the messages are cleared */
-    assert(!status.exists);
+    /* in theory there shouldn't be any EXISTS left because you've deleted the messages,
+     * but DB corruption could mean this wasn't cleared - better to allow the rename to
+     * succeed and clean up later */
+    if (status.threadexists || status.emailexists) {
+        syslog(LOG_ERR, "IOERROR: conversationsdb corruption %s still had %d/%d messages in folder key on delete",
+               from_name, status.threadexists, status.emailexists);
+    }
 
     return 0;
 }
@@ -2250,16 +2743,15 @@ static int zero_b_cb(void *rock,
                      size_t vallen)
 {
     struct conversations_state *state = (struct conversations_state *)rock;
-    conversation_t *conv = NULL;
+    conversation_t *conv = conversation_new();
     conv_folder_t *folder;
-    conv_sender_t *sender;
     int r;
     int i;
 
-    r = conversation_parse(state, val, vallen, &conv);
+    r = conversation_parse(val, vallen, conv, CONV_WITHFOLDERS|CONV_WITHSUBJECT);
     if (r) {
         r = cyrusdb_delete(state->db, key, keylen, &state->txn, /*force*/1);
-        return r;
+        goto done;
     }
 
     /* leave modseq untouched */
@@ -2280,23 +2772,15 @@ static int zero_b_cb(void *rock,
         folder->unseen = 0;
     }
 
-    /* just zero out senders */
-    while ((sender = conv->senders)) {
-        conv->senders = sender->next;
-        free(sender->name);
-        free(sender->route);
-        free(sender->mailbox);
-        free(sender->domain);
-        free(sender);
-    }
-
     /* keep the subject of course */
 
+    /* zero out the size */
     conv->size = 0;
 
     r = conversation_store(state, key, keylen, conv);
-    conversation_free(conv);
 
+done:
+    conversation_free(conv);
     return r;
 }
 
@@ -2317,8 +2801,10 @@ static int zero_f_cb(void *rock,
     }
 
     /* leave modseq unchanged */
-    status.exists = 0;
-    status.unseen = 0;
+    status.threadexists = 0;
+    status.threadunseen = 0;
+    status.emailexists = 0;
+    status.emailunseen = 0;
 
     return conversation_storestatus(state, key, keylen, &status);
 }
@@ -2367,18 +2853,19 @@ static int cleanup_b_cb(void *rock,
                         size_t vallen)
 {
     struct conversations_state *state = (struct conversations_state *)rock;
-    conversation_t *conv = NULL;
+    conversation_t *conv = conversation_new();
     int r;
 
-    r = conversation_parse(state, val, vallen, &conv);
-    if (r) return r;
+    r = conversation_parse(val, vallen, conv, /*flags*/0);
+    if (r) goto done;
 
     /* should be gone, wipe it */
     if (!conv->num_records)
         r = cyrusdb_delete(state->db, key, keylen, &state->txn, 1);
 
-    conversation_free(conv);
 
+done:
+    conversation_free(conv);
     return r;
 }
 
diff -pruN 3.0.13-5/imap/conversations.h 3.2.0-3/imap/conversations.h
--- 3.0.13-5/imap/conversations.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/conversations.h	2020-05-04 03:28:02.000000000 +0000
@@ -63,12 +63,25 @@ typedef bit64   conversation_id_t;
 struct index_record;
 struct mailbox;
 
+#define CONV_ISDIRTY     (1<<0)
+#define CONV_WITHFOLDERS (1<<1)
+#define CONV_WITHSENDERS (1<<2)
+#define CONV_WITHSUBJECT (1<<3)
+#define CONV_WITHTHREAD  (1<<4)
+
+#define CONV_WITHALL CONV_WITHFOLDERS|CONV_WITHSENDERS|\
+                     CONV_WITHSUBJECT|CONV_WITHTHREAD
+
 struct conversations_state {
     struct db *db;
     struct txn *txn;
+    char *annotmboxname;
     strarray_t *counted_flags;
     strarray_t *folder_names;
     hash_table folderstatus;
+    int trashfolder;
+    char *trashmboxname;
+    int is_shared;
     char *path;
 };
 
@@ -77,7 +90,6 @@ struct conversations_open {
     struct conversations_open *next;
 };
 
-
 typedef struct conversation conversation_t;
 typedef struct conv_folder  conv_folder_t;
 typedef struct conv_sender  conv_sender_t;
@@ -90,10 +102,8 @@ typedef struct conv_thread  conv_thread_
 struct conv_thread {
     conv_thread_t *next;
     struct message_guid guid;
-    int exists;
+    uint32_t exists;
     time_t internaldate;
-    int32_t msgid;
-    int32_t inreplyto;
 };
 
 struct conv_folder {
@@ -106,11 +116,19 @@ struct conv_folder {
     uint32_t        prev_exists;
 };
 
+#define CONV_GUIDREC_VERSION 0x1 // (must be <= 127)
+
 struct conv_guidrec {
+    const char      *guidrep; // [MESSAGE_GUID_SIZE*2], hex-encoded
     const char      *mboxname;
+    uint32_t        foldernum;
     uint32_t        uid;
     const char      *part;
     conversation_id_t cid;
+    char            version;
+    uint32_t        system_flags;   // if version >= 1
+    uint32_t        internal_flags; // if version >= 1
+    time_t          internaldate;   // if version >= 1
 };
 
 struct conv_sender {
@@ -124,11 +142,13 @@ struct conv_sender {
 };
 
 struct conv_status {
-    modseq_t modseq;
-    uint32_t exists;
-    uint32_t unseen;
+    modseq_t threadmodseq;
+    uint32_t threadexists;
+    uint32_t threadunseen;
+    uint32_t emailexists;
+    uint32_t emailunseen;
 };
-#define CONV_STATUS_INIT {0, 0, 0}
+#define CONV_STATUS_INIT { 0, 0, 0, 0, 0 }
 
 struct conversation {
     modseq_t        modseq;
@@ -136,15 +156,31 @@ struct conversation {
     uint32_t        exists;
     uint32_t        unseen;
     uint32_t        prev_unseen;
+    uint32_t        trash_unseen;
+    uint32_t        prev_trash_unseen;
     uint32_t        size;
-    uint32_t        *counts;
+    uint32_t        counts[32];
     conv_folder_t   *folders;
     conv_sender_t   *senders;
     conv_thread_t   *thread;
     char            *subject;
-    int             dirty;
+    modseq_t        createdmodseq;
+    int             flags;
 };
 
+#define CONVERSATION_INIT { 0, 0, 0, 0, 0, 0, 0, 0, {0}, NULL, NULL, NULL, NULL, 0, CONV_ISDIRTY }
+
+struct emailcounts {
+    const char *mboxname;
+    int ispost;
+    int pre_emailexists;
+    int pre_emailunseen;
+    int post_emailexists;
+    int post_emailunseen;
+};
+
+#define EMAILCOUNTS_INIT { NULL, 0, 0, 0, 0, 0 }
+
 #include "mailbox.h"
 
 /* Sets the suffix used for conversations db filenames.  Only needed
@@ -154,16 +190,20 @@ extern void conversations_set_suffix(con
 extern char *conversations_getmboxpath(const char *mboxname);
 extern char *conversations_getuserpath(const char *username);
 
-extern int conversations_open_path(const char *path,
+extern int conversations_open_path(const char *path, const char *userid, int shared,
                                    struct conversations_state **statep);
-extern int conversations_open_user(const char *username,
+extern int conversations_open_user(const char *username, int shared,
                                    struct conversations_state **statep);
-extern int conversations_open_mbox(const char *mboxname,
+extern int conversations_open_mbox(const char *mboxname, int shared,
                                    struct conversations_state **statep);
 extern struct conversations_state *conversations_get_path(const char *path);
 extern struct conversations_state *conversations_get_user(const char *username);
 extern struct conversations_state *conversations_get_mbox(const char *mboxname);
 
+extern uint32_t conversations_num_folders(struct conversations_state *state);
+extern const char* conversations_folder_name(struct conversations_state *state,
+                                             uint32_t foldernum);
+
 /* either of these close */
 extern int conversations_abort(struct conversations_state **state);
 extern int conversations_commit(struct conversations_state **state);
@@ -181,13 +221,16 @@ extern conv_folder_t *conversation_get_f
 extern void conversation_normalise_subject(struct buf *);
 
 /* G record */
-extern const strarray_t *conversations_get_folders(struct conversations_state *state);
 extern int conversations_guid_exists(struct conversations_state *state,
                                      const char *guidrep);
 extern int conversations_guid_foreach(struct conversations_state *state,
                                       const char *guidrep,
                                       int(*cb)(const conv_guidrec_t*,void*),
                                       void *rock);
+extern int conversations_iterate_searchset(struct conversations_state *state,
+                                           const void *data, size_t n,
+                                           int(*cb)(const conv_guidrec_t*,void*),
+                                           void *rock);
 extern conversation_id_t conversations_guid_cid_lookup(struct conversations_state *state,
                                                        const char *guidrep);
 
@@ -210,38 +253,46 @@ extern int conversation_get_modseq(struc
                                    modseq_t *modseqp);
 extern int conversation_save(struct conversations_state *state,
                              conversation_id_t cid,
-                             conversation_t *conv);
+                             conversation_t *conv,
+                             struct emailcounts *ecounts);
+extern int conversation_load_advanced(struct conversations_state *state,
+                                      conversation_id_t cid,
+                                      conversation_t *convp,
+                                      int flags);
 extern int conversation_load(struct conversations_state *state,
                              conversation_id_t cid,
                              conversation_t **convp);
-extern int conversation_parse(struct conversations_state *state,
-                              const char *data, size_t datalen,
-                              conversation_t **convp);
+extern int conversation_parse(const char *data, size_t datalen,
+                              conversation_t *conv, int flags);
 extern int conversation_store(struct conversations_state *state,
                                const char *key, int keylen,
                                conversation_t *conv);
 /* Update the internal data about a conversation, enforcing
  * consistency rules (e.g. the conversation's modseq is the
- * maximum of all the per-folder modseqs).  Sets conv->dirty
+ * maximum of all the per-folder modseqs).  Sets CONV_DIRTY
  * if any data actually changed.  */
 extern int conversations_update_record(struct conversations_state *cstate,
                                        struct mailbox *mailbox,
                                        const struct index_record *old,
-                                       struct index_record *new_);
+                                       struct index_record *new_,
+                                       int allowrenumber);
 
 extern void conversation_update(struct conversations_state *state,
                                 conversation_t *conv,
                                 const char *mboxname,
+                                int is_trash,
                                 int delta_num_records,
                                 int delta_exists,
                                 int delta_unseen,
                                 int delta_size,
                                 int *delta_counts,
-                                modseq_t modseq);
+                                modseq_t modseq,
+                                modseq_t createdmodseq);
 extern conv_folder_t *conversation_find_folder(struct conversations_state *state,
                                                conversation_t *,
                                                const char *mboxname);
-extern conversation_t *conversation_new(struct conversations_state *state);
+extern conversation_t *conversation_new();
+extern void conversation_fini(conversation_t *);
 extern void conversation_free(conversation_t *);
 
 extern void conversation_update_sender(conversation_t *conv,
@@ -271,4 +322,6 @@ extern int conversations_rename_folder(s
                                        const char *from_name,
                                        const char *to_name);
 
+extern int conversations_check_msgid(const char *msgid, size_t len);
+
 #endif /* __CYRUS_CONVERSATIONS_H_ */
diff -pruN 3.0.13-5/imap/convert_code.c 3.2.0-3/imap/convert_code.c
--- 3.0.13-5/imap/convert_code.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/convert_code.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* convert_code.c: Convert IMAP_* error to exitcodes.h exit status
+/* convert_code.c: Convert IMAP_* error to sysexits.h exit status
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
@@ -47,7 +47,7 @@
 
 #include <config.h>
 
-#include "exitcodes.h"
+#include <sysexits.h>
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -59,21 +59,21 @@ EXPORTED int convert_code(int r)
         return 0;
 
     case IMAP_IOERROR:
-        return EC_IOERR;
+        return EX_IOERR;
 
     case IMAP_PERMISSION_DENIED:
-        return EC_NOPERM;
+        return EX_NOPERM;
 
     case IMAP_QUOTA_EXCEEDED:
-        return EC_TEMPFAIL;
+        return EX_TEMPFAIL;
 
     case IMAP_MAILBOX_NOTSUPPORTED:
-        return EC_DATAERR;
+        return EX_DATAERR;
 
     case IMAP_MAILBOX_NONEXISTENT:
-        return EC_UNAVAILABLE;
+        return EX_UNAVAILABLE;
     }
 
     /* Some error we're not expecting. */
-    return EC_SOFTWARE;
+    return EX_SOFTWARE;
 }
diff -pruN 3.0.13-5/imap/css3_color.c 3.2.0-3/imap/css3_color.c
--- 3.0.13-5/imap/css3_color.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/css3_color.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,257 @@
+/* css3_color.c -- Routines for handling css3 colors
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <limits.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+
+struct css3_color_t {
+    const char *name;
+    unsigned char r;
+    unsigned char g;
+    unsigned char b;
+};
+
+static const struct css3_color_t css3_colors[] = {
+    { "aliceblue",            240, 248, 255 },
+    { "antiquewhite",         250, 235, 215 },
+    { "aqua",                   0, 255, 255 },
+    { "aquamarine",           127, 255, 212 },
+    { "azure",                240, 255, 255 },
+    { "beige",                245, 245, 220 },
+    { "bisque",               255, 228, 196 },
+    { "black",                  0,   0,   0 },
+    { "blanchedalmond",       255, 235, 205 },
+    { "blue",                   0,   0, 255 },
+    { "blueviolet",           138,  43, 226 },
+    { "brown",                165,  42,  42 },
+    { "burlywood",            222, 184, 135 },
+    { "cadetblue",             95, 158, 160 },
+    { "chartreuse",           127, 255,   0 },
+    { "chocolate",            210, 105,  30 },
+    { "coral",                255, 127,  80 },
+    { "cornflowerblue",       100, 149, 237 },
+    { "cornsilk",             255, 248, 220 },
+    { "crimson",              220,  20,  60 },
+    { "cyan",                   0, 255, 255 },
+    { "darkblue",               0,   0, 139 },
+    { "darkcyan",               0, 139, 139 },
+    { "darkgoldenrod",        184, 134,  11 },
+    { "darkgray",             169, 169, 169 },
+    { "darkgreen",              0, 100,   0 },
+    { "darkgrey",             169, 169, 169 },
+    { "darkkhaki",            189, 183, 107 },
+    { "darkmagenta",          139,   0, 139 },
+    { "darkolivegreen",        85, 107,  47 },
+    { "darkorange",           255, 140,   0 },
+    { "darkorchid",           153,  50, 204 },
+    { "darkred",              139,   0,   0 },
+    { "darksalmon",           233, 150, 122 },
+    { "darkseagreen",         143, 188, 143 },
+    { "darkslateblue",         72 , 61, 139 },
+    { "darkslategray",         47,  79,  79 },
+    { "darkslategrey",         47,  79,  79 },
+    { "darkturquoise",          0, 206, 209 },
+    { "darkviolet",           148,   0, 211 },
+    { "deeppink",             255,  20, 147 },
+    { "deepskyblue",            0, 191, 255 },
+    { "dimgray",              105, 105, 105 },
+    { "dimgrey",              105, 105, 105 },
+    { "dodgerblue",            30, 144, 255 },
+    { "firebrick",            178,  34,  34 },
+    { "floralwhite",          255, 250, 240 },
+    { "forestgreen",           34, 139,  34 },
+    { "fuchsia",              255,   0, 255 },
+    { "gainsboro",            220, 220, 220 },
+    { "ghostwhite",           248, 248, 255 },
+    { "gold",                 255, 215,   0 },
+    { "goldenrod",            218, 165,  32 },
+    { "gray",                 128, 128, 128 },
+    { "green",                  0, 128,   0 },
+    { "greenyellow",          173, 255,  47 },
+    { "grey",                 128, 128, 128 },
+    { "honeydew",             240, 255, 240 },
+    { "hotpink",              255, 105, 180 },
+    { "indianred",            205,  92,  92 },
+    { "indigo",                75,   0, 130 },
+    { "ivory",                255, 255, 240 },
+    { "khaki",                240, 230, 140 },
+    { "lavender",             230, 230, 250 },
+    { "lavenderblush",        255, 240, 245 },
+    { "lawngreen",            124, 252,   0 },
+    { "lemonchiffon",         255, 250, 205 },
+    { "lightblue",            173, 216, 230 },
+    { "lightcoral",           240, 128, 128 },
+    { "lightcyan",            224, 255, 255 },
+    { "lightgoldenrodyellow", 250, 250, 210 },
+    { "lightgray",            211, 211, 211 },
+    { "lightgreen",           144, 238, 144 },
+    { "lightgrey",            211, 211, 211 },
+    { "lightpink",            255, 182, 193 },
+    { "lightsalmon",          255, 160, 122 },
+    { "lightseagreen",         32, 178, 170 },
+    { "lightskyblue",         135, 206, 250 },
+    { "lightslategray",       119, 136, 153 },
+    { "lightslategrey",       119, 136, 153 },
+    { "lightsteelblue",       176, 196, 222 },
+    { "lightyellow",          255, 255, 224 },
+    { "lime",                   0, 255,   0 },
+    { "limegreen",             50, 205,  50 },
+    { "linen",                250, 240, 230 },
+    { "magenta",              255,   0, 255 },
+    { "maroon",               128,   0,   0 },
+    { "mediumaquamarine",     102, 205, 170 },
+    { "mediumblue",             0,   0, 205 },
+    { "mediumorchid",         186,  85, 211 },
+    { "mediumpurple",         147, 112, 219 },
+    { "mediumseagreen",        60, 179, 113 },
+    { "mediumslateblue",      123, 104, 238 },
+    { "mediumspringgreen",      0, 250, 154 },
+    { "mediumturquoise",       72, 209, 204 },
+    { "mediumvioletred",      199,  21, 133 },
+    { "midnightblue",          25,  25, 112 },
+    { "mintcream",            245, 255, 250 },
+    { "mistyrose",            255, 228, 225 },
+    { "moccasin",             255, 228, 181 },
+    { "navajowhite",          255, 222, 173 },
+    { "navy",                   0,   0, 128 },
+    { "oldlace",              253, 245, 230 },
+    { "olive",                128, 128,   0 },
+    { "olivedrab",            107, 142,  35 },
+    { "orange",               255, 165,   0 },
+    { "orangered",            255,  69,   0 },
+    { "orchid",               218, 112, 214 },
+    { "palegoldenrod",        238, 232, 170 },
+    { "palegreen",            152, 251, 152 },
+    { "paleturquoise",        175, 238, 238 },
+    { "palevioletred",        219, 112, 147 },
+    { "papayawhip",           255, 239, 213 },
+    { "peachpuff",            255, 218, 185 },
+    { "peru",                 205, 133, 63 },
+    { "pink",                 255, 192, 203 },
+    { "plum",                 221, 160, 221 },
+    { "powderblue",           176, 224, 230 },
+    { "purple",               128,   0, 128 },
+    { "red",                  255,   0,   0 },
+    { "rosybrown",            188, 143, 143 },
+    { "royalblue",             65, 105, 225 },
+    { "saddlebrown",          139,  69,  19 },
+    { "salmon",               250, 128, 114 },
+    { "sandybrown",           244, 164,  96 },
+    { "seagreen",              46, 139,  87 },
+    { "seashell",             255, 245, 238 },
+    { "sienna",               160,  82,  45 },
+    { "silver",               192, 192, 192 },
+    { "skyblue",              135, 206, 235 },
+    { "slateblue",            106,  90, 205 },
+    { "slategray",            112, 128, 144 },
+    { "slategrey",            112, 128, 144 },
+    { "snow",                 255, 250, 250 },
+    { "springgreen",            0, 255, 127 },
+    { "steelblue",             70, 130, 180 },
+    { "tan",                  210, 180, 140 }, 
+    { "teal",                   0, 128, 128 },
+    { "thistle",              216, 191, 216 },
+    { "tomato",               255,  99,  71 },
+    { "turquoise",             64, 224, 208 },
+    { "violet",               238, 130, 238 },
+    { "wheat",                245, 222, 179 },
+    { "white",                255, 255, 255 },
+    { "whitesmoke",           245, 245, 245 },
+    { "yellow",               255, 255,   0 },
+    { "yellowgreen",          154, 205,  50 },
+    { NULL,                     0,   0,   0 }
+};
+
+/* Take a hex value for a color and find best matching css3 color name using:
+   https://en.wikipedia.org/wiki/Color_difference */
+const char *css3_color_hex_to_name(const char *hexstr)
+{
+    if (!hexstr || hexstr[0] != '#') return NULL;
+
+    size_t hexlen = strlen(hexstr);
+
+    if (hexlen != 7 && hexlen != 9) return NULL;
+
+    /* Convert hex encoded color into separate RGB */
+    long hex = strtol(hexstr+1, NULL, 16);
+    if (hexlen == 9) hex >>= 8;  /* drop last 2 digits */
+
+    struct {
+        unsigned char r, g, b;
+    } C;
+
+    C.b = (hex & 0x0000ff);
+    hex >>= 8;
+    C.g = (hex & 0x00ff);
+    hex >>= 8;
+    C.r = (hex & 0xff);
+
+    const struct css3_color_t *css;
+    unsigned long best = ULONG_MAX;
+    const char *name = NULL;
+
+    for (css = css3_colors; css->name; css++) {
+        int dR = css->r - C.r;
+        int dG = css->g - C.g;
+        int dB = css->b - C.b;
+
+        if (dR == 0 && dG == 0 && dB == 0) return css->name;
+
+        unsigned dR2 = dR * dR;
+        unsigned dG2 = dG * dG;
+        unsigned dB2 = dB * dB;
+        unsigned long dC = 2*dR2 + 4*dG2 + 3*dB2;
+
+        unsigned r = (css->r + C.r) / 2;
+        dC += (r * (dR2 - dB2)) / 256;
+
+        if (dC < best) {
+            best = dC;
+            name = css->name;
+        }
+    }
+
+    return name;
+}
diff -pruN 3.0.13-5/imap/css3_color.h 3.2.0-3/imap/css3_color.h
--- 3.0.13-5/imap/css3_color.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/css3_color.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,49 @@
+/* css3_color.h -- Routines for handling css3 colors
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef CSS3_COLOR_H
+#define CSS3_COLOR_H
+
+extern const char *css3_color_hex_to_name(const char *hexstr);
+
+#endif /* CSS3_COLOR_H */
diff -pruN 3.0.13-5/imap/ctl_conversationsdb.c 3.2.0-3/imap/ctl_conversationsdb.c
--- 3.0.13-5/imap/ctl_conversationsdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ctl_conversationsdb.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/stat.h>
@@ -53,15 +54,12 @@
 /* cyrus includes */
 #include "assert.h"
 #include "bsearch.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "index.h"
 #include "conversations.h"
 #include "mailbox.h"
 #include "mboxlist.h"
 #include "message.h"
-#include "sync_log.h"
-#include "sysexits.h"
 #include "util.h"
 #include "xmalloc.h"
 
@@ -78,14 +76,16 @@ int verbose = 0;
 int mode = UNKNOWN;
 static const char *audit_temp_directory;
 
-static int do_dump(const char *fname)
+int recalc_silent = 1;
+
+static int do_dump(const char *fname, const char *userid)
 {
     struct conversations_state *state = NULL;
     struct stat sb;
     int r;
 
     /* What we really want here is read-only database access without
-     * the create-if-nonexistant semantics.  However, the cyrusdb
+     * the create-if-nonexistent semantics.  However, the cyrusdb
      * interface makes it difficult to do that properly.  In the
      * meantime, we can just check if the file exists here. */
     r = stat(fname, &sb);
@@ -94,7 +94,7 @@ static int do_dump(const char *fname)
         return -1;
     }
 
-    r = conversations_open_path(fname, &state);
+    r = conversations_open_path(fname, userid, 0/*shared*/, &state);
     if (r) {
         fprintf(stderr, "Failed to open conversations database %s: %s\n",
                 fname, error_message(r));
@@ -107,12 +107,12 @@ static int do_dump(const char *fname)
     return 0;
 }
 
-static int do_undump(const char *fname)
+static int do_undump(const char *fname, const char *userid)
 {
     struct conversations_state *state;
     int r;
 
-    r = conversations_open_path(fname, &state);
+    r = conversations_open_path(fname, userid, 0/*shared*/, &state);
     if (r) {
         fprintf(stderr, "Failed to open conversations database %s: %s\n",
                 fname, error_message(r));
@@ -162,6 +162,8 @@ static int zero_cid_cb(const mbentry_t *
 
         struct index_record oldrecord = *record;
         oldrecord.cid = NULLCONVERSATION;
+        oldrecord.basecid = NULLCONVERSATION;
+        oldrecord.internal_flags &= ~FLAG_INTERNAL_SPLITCONVERSATION;
         r = mailbox_rewrite_index_record(mailbox, &oldrecord);
         if (r) break;
     }
@@ -176,13 +178,19 @@ static int do_zero(const char *userid)
     struct conversations_state *state = NULL;
     int r;
 
-    r = conversations_open_user(userid, &state);
+    r = conversations_open_user(userid, 0/*shared*/, &state);
     if (r) return r;
 
-    r = mboxlist_usermboxtree(userid, zero_cid_cb, NULL, 0);
+    r = mboxlist_usermboxtree(userid, NULL, zero_cid_cb, NULL, 0);
+    if (r) goto done;
 
-    conversations_commit(&state);
+    /* XXX:
+     * annotatemore_findall(state->annotmboxname, IMAP_ANNOT_NS "basecid/%", &deleteannot);
+     * remove all the basecid mappings so they don't create bad splits on rebuild
+     */
 
+done:
+    conversations_commit(&state);
     return r;
 }
 
@@ -214,7 +222,7 @@ static int build_cid_cb(const mbentry_t
             r = mailbox_cacherecord(mailbox, &oldrecord);
             if (r) goto done;
 
-            r = message_update_conversations(cstate, &oldrecord, NULL);
+            r = message_update_conversations(cstate, mailbox, &oldrecord, NULL);
             if (r) goto done;
 
             r = mailbox_rewrite_index_record(mailbox, &oldrecord);
@@ -239,10 +247,10 @@ static int do_build(const char *userid)
     struct conversations_state *state = NULL;
     int r;
 
-    r = conversations_open_user(userid, &state);
+    r = conversations_open_user(userid, 0/*shared*/, &state);
     if (r) return r;
 
-    r = mboxlist_usermboxtree(userid, build_cid_cb, NULL, 0);
+    r = mboxlist_usermboxtree(userid, NULL, build_cid_cb, NULL, 0);
 
     conversations_commit(&state);
     return r;
@@ -254,13 +262,13 @@ static int recalc_counts_cb(const mbentr
     struct mailbox *mailbox = NULL;
     int r;
 
-    r = mailbox_open_irl(mbentry->name, &mailbox);
+    r = mailbox_open_iwl(mbentry->name, &mailbox);
     if (r) return r;
 
     if (verbose)
         printf("%s\n", mbentry->name);
 
-    r = mailbox_add_conversations(mailbox);
+    r = mailbox_add_conversations(mailbox, recalc_silent);
 
     mailbox_close(&mailbox);
     return r;
@@ -278,7 +286,7 @@ static int audit_counts_cb(const mbentry
     if (verbose)
         printf("%s\n", mbentry->name);
 
-    r = mailbox_add_conversations(mailbox);
+    r = mailbox_add_conversations(mailbox, /*silent*/1);
 
     mailbox_close(&mailbox);
     return r;
@@ -289,13 +297,13 @@ static int do_recalc(const char *userid)
     struct conversations_state *state = NULL;
     int r;
 
-    r = conversations_open_user(userid, &state);
+    r = conversations_open_user(userid, 0/*shared*/, &state);
     if (r) return r;
 
     r = conversations_zero_counts(state);
     if (r) goto err;
 
-    r = mboxlist_usermboxtree(userid, recalc_counts_cb, NULL, 0);
+    r = mboxlist_usermboxtree(userid, NULL, recalc_counts_cb, NULL, 0);
     if (r) goto err;
 
     r = conversations_cleanup_zero(state);
@@ -443,7 +451,7 @@ static int fix_modseqs(struct conversati
                 /* need to add record if it's zero */
                 r = conversation_parsestatus(ca.data, ca.datalen, &status);
                 if (r) return r;
-                if (status.exists == 0) {
+                if (status.threadexists == 0) {
                     r = conversation_storestatus(b, ca.key, ca.keylen, &status);
                     if (r) {
                         fprintf(stderr, "Failed to store conversations "
@@ -489,8 +497,8 @@ static int fix_modseqs(struct conversati
                                 b->path, error_message(r));
                 goto next;
             }
-            if (statusa.modseq > statusb.modseq) {
-                statusb.modseq = statusa.modseq;
+            if (statusa.threadmodseq > statusb.threadmodseq) {
+                statusb.threadmodseq = statusa.threadmodseq;
                 r = conversation_storestatus(b, cb.key, cb.keylen, &statusb);
                 if (r) {
                     fprintf(stderr, "Failed to store conversations "
@@ -505,13 +513,13 @@ static int fix_modseqs(struct conversati
         }
         if (ca.key[0] == 'B') {
             /* B keys - check all the modseqs, both top level and per folder */
-            conversation_t *conva = NULL;
-            conversation_t *convb = NULL;
+            conversation_t conva = CONVERSATION_INIT;
+            conversation_t convb = CONVERSATION_INIT;
             conv_folder_t *foldera;
             conv_folder_t *folderb;
             conv_sender_t *sendera;
 
-            r = conversation_parse(a, ca.data, ca.datalen, &conva);
+            r = conversation_parse(ca.data, ca.datalen, &conva, CONV_WITHALL);
             if (r) {
                 fprintf(stderr, "Failed to parse conversations "
                                 "record \"%.*s\" in %s: %s\n",
@@ -519,45 +527,45 @@ static int fix_modseqs(struct conversati
                                 a->path, error_message(r));
                 goto next;
             }
-            r = conversation_parse(b, cb.data, cb.datalen, &convb);
+            r = conversation_parse(cb.data, cb.datalen, &convb, CONV_WITHALL);
             if (r) {
                 fprintf(stderr, "Failed to parse conversations "
                                 "record \"%.*s\" in %s: %s\n",
                                 (int)cb.keylen, cb.key,
                                 b->path, error_message(r));
-                conversation_free(conva);
+                conversation_fini(&conva);
                 goto next;
             }
 
             /* because expunged messages could have had higher modseqs,
              * we need to re-copy any higher modseqs in */
-            if (conva->modseq > convb->modseq)
-                convb->modseq = conva->modseq;
+            if (conva.modseq > convb.modseq)
+                convb.modseq = conva.modseq;
 
-            for (foldera = conva->folders; foldera; foldera = foldera->next) {
-                folderb = conversation_get_folder(convb, foldera->number, 1);
+            for (foldera = conva.folders; foldera; foldera = foldera->next) {
+                folderb = conversation_get_folder(&convb, foldera->number, 1);
                 if (folderb->modseq < foldera->modseq)
                     folderb->modseq = foldera->modseq;
             }
 
             /* senders are timestamped, and the timestamp might be for a
              * deleted message! */
-            for (sendera = conva->senders; sendera; sendera = sendera->next) {
+            for (sendera = conva.senders; sendera; sendera = sendera->next) {
                 /* always update!  The delta logic will ensure we don't add
                  * the record if it's not already at least present in the
                  * other conversation */
-                conversation_update_sender(convb, sendera->name, sendera->route,
+                conversation_update_sender(&convb, sendera->name, sendera->route,
                                            sendera->mailbox, sendera->domain,
                                            sendera->lastseen, /*delta_count*/0);
             }
 
             /* be nice to know if this is needed, but at least twoskip
              * will dedup for us */
-            r = conversation_store(b, cb.key, cb.keylen, convb);
+            r = conversation_store(b, cb.key, cb.keylen, &convb);
 
             /* free first before checking for errors */
-            conversation_free(conva);
-            conversation_free(convb);
+            conversation_fini(&conva);
+            conversation_fini(&convb);
 
             if (r) {
                 fprintf(stderr, "Failed to store conversations "
@@ -583,7 +591,7 @@ int do_checkfolders(const char *userid)
     strarray_t *copy1, *copy2;
 
     /* open the DB */
-    r = conversations_open_user(userid, &state);
+    r = conversations_open_user(userid, 0/*shared*/, &state);
     if (r) {
         fprintf(stderr, "Cannot open conversations db %s: %s\n",
                 userid, error_message(r));
@@ -650,7 +658,7 @@ static int do_audit(const char *userid)
     }
 
     /* Begin recalculating in the temp db */
-    r = conversations_open_path(filename_temp, &state_temp);
+    r = conversations_open_path(filename_temp, userid, 0/*shared*/, &state_temp);
     if (r) {
         fprintf(stderr, "Cannot open conversations db %s: %s\n",
                 filename_temp, error_message(r));
@@ -672,7 +680,7 @@ static int do_audit(const char *userid)
     conversations_set_suffix(temp_suffix);
     conversations_set_directory(audit_temp_directory);
 
-    r = mboxlist_usermboxtree(userid, audit_counts_cb, NULL, 0);
+    r = mboxlist_usermboxtree(userid, NULL, audit_counts_cb, NULL, 0);
     if (r) {
         fprintf(stderr, "Failed to recalculate counts in %s: %s\n",
                 filename_temp, error_message(r));
@@ -699,14 +707,14 @@ static int do_audit(const char *userid)
     if (verbose)
         printf("Pass 2: find differences from recalculated to live dbs\n");
 
-    r = conversations_open_path(filename_temp, &state_temp);
+    r = conversations_open_path(filename_temp, userid, 0/*shared*/, &state_temp);
     if (r) {
         fprintf(stderr, "Cannot open conversations db %s: %s\n",
                 filename_temp, error_message(r));
         goto out;
     }
 
-    r = conversations_open_path(filename_real, &state_real);
+    r = conversations_open_path(filename_real, userid, 0/*shared*/, &state_real);
     if (r) {
         fprintf(stderr, "Cannot open conversations db %s: %s\n",
                 filename_real, error_message(r));
@@ -751,48 +759,48 @@ static int do_user(const char *userid, v
         fprintf(stderr, "Unable to get conversations database "
                         "filename for userid \"%s\"\n",
                         userid);
-        return EC_USAGE;
+        return EX_USAGE;
     }
 
     switch (mode)
     {
     case DUMP:
-        if (do_dump(fname))
-            r = EC_NOINPUT;
+        if (do_dump(fname, userid))
+            r = EX_NOINPUT;
         break;
 
     case UNDUMP:
-        if (do_undump(fname))
-            r = EC_NOINPUT;
+        if (do_undump(fname, userid))
+            r = EX_NOINPUT;
         break;
 
     case ZERO:
         if (do_zero(userid))
-            r = EC_NOINPUT;
+            r = EX_NOINPUT;
         break;
 
     case BUILD:
         if (do_build(userid))
-            r = EC_NOINPUT;
+            r = EX_NOINPUT;
         break;
 
     case RECALC:
         if (do_recalc(userid))
-            r = EC_NOINPUT;
+            r = EX_NOINPUT;
         break;
 
     case AUDIT:
         if (do_audit(userid))
-            r = EC_NOINPUT;
+            r = EX_NOINPUT;
         break;
 
     case CHECKFOLDERS:
         if (do_checkfolders(userid))
-            r = EC_NOINPUT;
+            r = EX_NOINPUT;
         break;
 
     case UNKNOWN:
-        fatal("UNKNOWN MODE", EC_SOFTWARE);
+        fatal("UNKNOWN MODE", EX_SOFTWARE);
     }
 
     free(fname);
@@ -808,7 +816,7 @@ int main(int argc, char **argv)
     int r = 0;
     int recursive = 0;
 
-    while ((c = getopt(argc, argv, "durzAbvRFC:T:")) != EOF) {
+    while ((c = getopt(argc, argv, "durzSAbvRFC:T:")) != EOF) {
         switch (c) {
         case 'd':
             if (mode != UNKNOWN)
@@ -868,6 +876,10 @@ int main(int argc, char **argv)
             audit_temp_directory = optarg;
             break;
 
+        case 'S':
+            recalc_silent = 0;
+            break;
+
         default:
             usage(argv[0]);
             break;
@@ -886,22 +898,12 @@ int main(int argc, char **argv)
 
     cyrus_init(alt_config, "ctl_conversationsdb", 0, 0);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    sync_log_init();
-
     if (recursive) {
         mboxlist_alluser(do_user, NULL);
     }
     else
         do_user(userid, NULL);
 
-    sync_log_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return r;
@@ -925,7 +927,7 @@ static int usage(const char *name)
     fprintf(stderr, "\n");
     fprintf(stderr, "    -r             recursive mode: username is a prefix\n");
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 void fatal(const char* s, int code)
diff -pruN 3.0.13-5/imap/ctl_cyrusdb.c 3.2.0-3/imap/ctl_cyrusdb.c
--- 3.0.13-5/imap/ctl_cyrusdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ctl_cyrusdb.c	2020-05-04 03:28:02.000000000 +0000
@@ -50,6 +50,7 @@
 #include <string.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <errno.h>
 
@@ -74,7 +75,6 @@
 #include "cyrusdb.h"
 #include "duplicate.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "mboxlist.h"
 #include "seen.h"
@@ -131,6 +131,23 @@ static int fixmbox(const mbentry_t *mben
 {
     int r;
 
+    /* if MBTYPE_RESERVED, unset it & call mboxlist_delete */
+    if (mbentry->mbtype & MBTYPE_RESERVE) {
+        r = mboxlist_deletemailboxlock(mbentry->name, 1, NULL, NULL, NULL, 0, 0, 1, 0);
+        if (r) {
+            /* log the error */
+            syslog(LOG_ERR,
+                   "could not remove reserved mailbox '%s': %s",
+                   mbentry->name, error_message(r));
+        } else {
+            syslog(LOG_NOTICE,
+                   "removed reserved mailbox '%s'",
+                   mbentry->name);
+        }
+        return 0;
+    }
+
+    /* clean out any legacy specialuse */
     if (mbentry->legacy_specialuse) {
         char *userid = mboxname_to_userid(mbentry->name);
         if (userid) {
@@ -148,19 +165,11 @@ static int fixmbox(const mbentry_t *mben
         mboxlist_entry_free(&copy);
     }
 
-    /* if MBTYPE_RESERVED, unset it & call mboxlist_delete */
-    if (mbentry->mbtype & MBTYPE_RESERVE) {
-        r = mboxlist_deletemailbox(mbentry->name, 1, NULL, NULL, NULL, 0, 0, 1);
-        if (r) {
-            /* log the error */
-            syslog(LOG_ERR,
-                   "could not remove reserved mailbox '%s': %s",
-                   mbentry->name, error_message(r));
-        } else {
-            syslog(LOG_NOTICE,
-                   "removed reserved mailbox '%s'",
-                   mbentry->name);
-        }
+    r = mboxlist_update_intermediaries(mbentry->name, mbentry->mbtype, /*modseq*/0);
+    if (r) {
+        syslog(LOG_ERR,
+               "failed to update intermediaries to mailboxes list for %s: %s",
+               mbentry->name, cyrusdb_strerror(r));
     }
 
     return 0;
@@ -168,32 +177,11 @@ static int fixmbox(const mbentry_t *mben
 
 static void process_mboxlist(void)
 {
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* Need annotations.db for mboxlist_deletemailbox() and also
-     * for fixing legacy specialuse support */
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
-    /* Need quotadb for deleting mailboxes with quotas */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
     /* build a list of mailboxes - we're using internal names here */
-    mboxlist_allmbox(NULL, fixmbox, NULL, 0);
+    mboxlist_allmbox(NULL, fixmbox, NULL, MBOXTREE_INTERMEDIATES);
 
     /* enable or disable RACLs per config */
     mboxlist_set_racls(config_getswitch(IMAPOPT_REVERSEACLS));
-
-    quotadb_close();
-    quotadb_done();
-
-    annotatemore_close();
-    annotate_done();
-
-    mboxlist_close();
-    mboxlist_done();
 }
 
 static const char *dbfname(struct cyrusdb *db)
@@ -215,7 +203,7 @@ static const char *dbfname(struct cyrusd
     else if (!strcmp(db->name, FNAME_DELIVERDB))
         fname = config_getstring(IMAPOPT_DUPLICATE_DB_PATH);
     else if (!strcmp(db->name, FNAME_TLSSESSIONS))
-        fname = config_getstring(IMAPOPT_TLSCACHE_DB_PATH);
+        fname = config_getstring(IMAPOPT_TLS_SESSIONS_DB_PATH);
     else if (!strcmp(db->name, FNAME_PTSDB))
         fname = config_getstring(IMAPOPT_PTSCACHE_DB_PATH);
     else if (!strcmp(db->name, FNAME_STATUSCACHEDB))
diff -pruN 3.0.13-5/imap/ctl_deliver.c 3.2.0-3/imap/ctl_deliver.c
--- 3.0.13-5/imap/ctl_deliver.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ctl_deliver.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,12 +48,12 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 #include <signal.h>
 
 #include "duplicate.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "libcyr_cfg.h"
 #include "util.h"
@@ -113,7 +113,7 @@ int main(int argc, char *argv[])
 
         r = snprintf(buf, sizeof(buf), "%s/cyr_expire", SBIN_DIR);
         if(r < 0 || r >= (int) sizeof(buf)) {
-            fatal("cyr_expire command buffer not sufficiently big", EC_CONFIG);
+            fatal("cyr_expire command buffer not sufficiently big", EX_CONFIG);
         }
 
         if (alt_config)
diff -pruN 3.0.13-5/imap/ctl_mboxlist.c 3.2.0-3/imap/ctl_mboxlist.c
--- 3.0.13-5/imap/ctl_mboxlist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ctl_mboxlist.c	2020-04-24 02:03:00.000000000 +0000
@@ -65,6 +65,7 @@
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
+#include <sysexits.h>
 #include <syslog.h>
 #include <stdlib.h>
 #include <string.h>
@@ -73,11 +74,11 @@
 #include "assert.h"
 #include "annotate.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "libcyr_cfg.h"
 #include "mboxlist.h"
 #include "mupdate.h"
+#include "user.h"
 #include "util.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -276,7 +277,7 @@ static int dump_cb(const mbentry_t *mben
                             mbentry->name, realpart, mbentry->acl );
                     fprintf( stderr, "mupdate says: %s %s %s\n",
                             mdata->mailbox, mdata->location, mdata->acl );
-                    fatal("mupdate said not us before it said us", EC_SOFTWARE);
+                    fatal("mupdate said not us before it said us", EX_SOFTWARE);
                 }
 
                 /*
@@ -374,7 +375,7 @@ static int dump_cb(const mbentry_t *mben
 }
 
 /*
- * True if user types Y\n or y\n.  Anthing else is false.
+ * True if user types Y\n or y\n.  Anything else is false.
  */
 static int yes(void)
 {
@@ -406,7 +407,7 @@ static int yes(void)
  *    mupdate.
  */
 
-static void do_dump(enum mboxop op, const char *part, int purge)
+static void do_dump(enum mboxop op, const char *part, int purge, int intermediary)
 {
     struct dumprock d;
     int ret;
@@ -460,7 +461,9 @@ static void do_dump(enum mboxop op, cons
     }
 
     /* Dump Database */
-    mboxlist_allmbox("", &dump_cb, &d, /*incdel*/1);
+    int flags = MBOXTREE_TOMBSTONES;
+    if (intermediary) flags |= MBOXTREE_INTERMEDIATES;
+    mboxlist_allmbox("", &dump_cb, &d, flags);
 
     if (op == M_POPULATE) {
         /* Remove MBTYPE_MOVING flags (unflag_head) */
@@ -522,16 +525,20 @@ static void do_dump(enum mboxop op, cons
 
         while (wipe_head) {
             struct mb_node *me = wipe_head;
-
             wipe_head = wipe_head->next;
+
+            struct mboxlock *namespacelock = mboxname_usernamespacelock(me->mailbox);
+
             if (!mboxlist_delayed_delete_isenabled()) {
-                ret = mboxlist_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1);
+                ret = mboxlist_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1, 0);
             } else if (mboxname_isdeletedmailbox(me->mailbox, NULL)) {
-                ret = mboxlist_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1);
+                ret = mboxlist_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1, 0);
             } else {
-                ret = mboxlist_delayed_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1);
+                ret = mboxlist_delayed_deletemailbox(me->mailbox, 1, "", NULL, NULL, 0, 1, 1, 0);
             }
 
+            mboxname_release(&namespacelock);
+
             if (ret) {
                 fprintf(stderr, "couldn't delete defunct mailbox %s\n",
                         me->mailbox);
@@ -825,8 +832,9 @@ static void do_verify(void)
 
         if (!(dirp = opendir(found.data[i].path))) continue;
         while ((dirent = readdir(dirp))) {
+            const char *fname = FNAME_HEADER;
             if (dirent->d_name[0] == '.') continue;
-            else if (!strcmp(dirent->d_name, FNAME_HEADER+1)) {
+            else if (!strcmp(dirent->d_name, fname+1)) {
                 /* XXX - check that it can be opened */
                 found.data[i].type |= MBOX;
             }
@@ -867,13 +875,13 @@ static void do_verify(void)
 
     qsort(found.data, found.size, sizeof(struct found_data), compar_mbox);
 
-    mboxlist_allmbox("", &verify_cb, &found, /*incdel*/1);
+    mboxlist_allmbox("", &verify_cb, &found, MBOXTREE_TOMBSTONES);
 }
 
 static void usage(void)
 {
     fprintf(stderr, "DUMP:\n");
-    fprintf(stderr, "  ctl_mboxlist [-C <alt_config>] -d [-x] [-p partition] [-f filename]\n");
+    fprintf(stderr, "  ctl_mboxlist [-C <alt_config>] -d [-x] [-y] [-p partition] [-f filename]\n");
     fprintf(stderr, "UNDUMP:\n");
     fprintf(stderr,
             "  ctl_mboxlist [-C <alt_config>] -u [-f filename]"
@@ -893,8 +901,9 @@ int main(int argc, char *argv[])
     int opt;
     enum mboxop op = NONE;
     char *alt_config = NULL;
+    int dointermediary = 0;
 
-    while ((opt = getopt(argc, argv, "C:awmdurcxf:p:vi")) != EOF) {
+    while ((opt = getopt(argc, argv, "C:awmdurcxf:p:viy")) != EOF) {
         switch (opt) {
         case 'C': /* alt config file */
             alt_config = optarg;
@@ -968,6 +977,10 @@ int main(int argc, char *argv[])
             interactive = 1;
             break;
 
+        case 'y':
+            dointermediary = 1;
+            break;
+
         default:
             usage();
             break;
@@ -977,6 +990,7 @@ int main(int argc, char *argv[])
     if (op != M_POPULATE && (local_authoritative || warn_only)) usage();
     if (op != DUMP && partition) usage();
     if (op != DUMP && dopurge) usage();
+    if (op != DUMP && dointermediary) usage();
 
     if (op == RECOVER) {
         syslog(LOG_NOTICE, "running mboxlist recovery");
@@ -995,6 +1009,8 @@ int main(int argc, char *argv[])
     case CHECKPOINT:
         syslog(LOG_NOTICE, "checkpointing mboxlist");
         mboxlist_init(MBOXLIST_SYNC);
+        mboxlist_open(NULL);
+        mboxlist_close();
         mboxlist_done();
         syslog(LOG_NOTICE, "done checkpointing mboxlist");
         break;
@@ -1007,19 +1023,7 @@ int main(int argc, char *argv[])
         mboxlist_init(0);
         mboxlist_open(mboxdb_fname);
 
-        quotadb_init(0);
-        quotadb_open(NULL);
-
-        annotate_init(NULL, NULL);
-        annotatemore_open();
-
-        do_dump(op, partition, dopurge);
-
-        annotatemore_close();
-        annotate_done();
-
-        quotadb_close();
-        quotadb_done();
+        do_dump(op, partition, dopurge, dointermediary);
 
         mboxlist_close();
         mboxlist_done();
@@ -1034,20 +1038,8 @@ int main(int argc, char *argv[])
         mboxlist_init(0);
         mboxlist_open(mboxdb_fname);
 
-        quotadb_init(0);
-        quotadb_open(NULL);
-
-        annotate_init(NULL, NULL);
-        annotatemore_open();
-
         do_undump();
 
-        annotatemore_close();
-        annotate_done();
-
-        quotadb_close();
-        quotadb_done();
-
         mboxlist_close();
         mboxlist_done();
         break;
diff -pruN 3.0.13-5/imap/ctl_zoneinfo.c 3.2.0-3/imap/ctl_zoneinfo.c
--- 3.0.13-5/imap/ctl_zoneinfo.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ctl_zoneinfo.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,6 +50,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <dirent.h>
 #include <sys/stat.h>
 #include <sys/types.h>
@@ -58,7 +59,6 @@
 #include <libxml/tree.h>
 
 #include "annotate.h" /* for strlist functionality */
-#include "exitcodes.h"
 #include "global.h"
 #include "hash.h"
 #include "map.h"
@@ -88,7 +88,7 @@ int main(int argc, char **argv)
 {
     int opt, r = 0;
     char *alt_config = NULL, *pub = NULL, *ver = NULL, *winfile = NULL;
-    char prefix[2048];
+    const char *zoneinfo_dir = NULL;
     enum { REBUILD, WINZONES, NONE } op = NONE;
 
     while ((opt = getopt(argc, argv, "C:r:vw:")) != EOF) {
@@ -130,14 +130,19 @@ int main(int argc, char **argv)
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
 
-    snprintf(prefix, sizeof(prefix), "%s%s", config_dir, FNAME_ZONEINFODIR);
+    zoneinfo_dir = config_getstring(IMAPOPT_ZONEINFO_DIR);
+    if (!zoneinfo_dir) {
+        fprintf(stderr, "zoneinfo_dir must be set for tzdist service\n");
+        cyrus_done();
+        return EX_CONFIG;
+    }
 
     switch (op) {
     case REBUILD: {
         struct hash_table tzentries;
         struct zoneinfo *info;
         struct txn *tid = NULL;
-        char buf[1024];
+        char buf[3000];
         FILE *fp;
 
         construct_hash_table(&tzentries, 500, 1);
@@ -150,7 +155,7 @@ int main(int argc, char **argv)
         hash_insert(INFO_TZID, info, &tzentries);
 
         /* Add LEAP record (last updated and hash) */
-        snprintf(buf, sizeof(buf), "%s%s", prefix, FNAME_LEAPSECFILE);
+        snprintf(buf, sizeof(buf), "%s%s", zoneinfo_dir, FNAME_LEAPSECFILE);
         if (verbose) printf("Processing leap seconds file %s\n", buf);
         if (!(fp = fopen(buf, "r"))) {
             fprintf(stderr, "Could not open leap seconds file %s\n", buf);
@@ -187,7 +192,7 @@ int main(int argc, char **argv)
         }
 
         /* Add ZONE/LINK records */
-        do_zonedir(prefix, &tzentries, info);
+        do_zonedir(zoneinfo_dir, &tzentries, info);
 
         zoneinfo_open(NULL);
 
@@ -243,8 +248,8 @@ int main(int argc, char **argv)
             goto done;
         }
 
-        if (chdir(prefix)) {
-            fprintf(stderr, "chdir(%s) failed\n", prefix);
+        if (chdir(zoneinfo_dir)) {
+            fprintf(stderr, "chdir(%s) failed\n", zoneinfo_dir);
             goto done;
         }
 
@@ -324,7 +329,7 @@ void usage(void)
     fprintf(stderr,
             "usage: zoneinfo_reconstruct [-C <alt_config>] [-v]"
             " -r <publisher>:<version>\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 
@@ -371,7 +376,7 @@ void do_zonedir(const char *dir, struct
 
             /* Isolate alias in path */
             path[plen-4] = '\0';  /* Trim ".ics" */
-            alias = path + strlen(config_dir) + strlen("zoneinfo") + 2;
+            alias = path + strlen(dir) + 1;
 
             if (verbose) printf("\tLINK: %s -> %s\n", alias, tzid);
 
@@ -398,6 +403,7 @@ void do_zonedir(const char *dir, struct
             size_t len = 0;
             icalcomponent *ical, *comp;
             icalproperty *prop;
+            char *alias = NULL;
 
             /* Parse the iCalendar file for important properties */
             if ((fd = open(path, O_RDONLY)) == -1) continue;
@@ -414,7 +420,15 @@ void do_zonedir(const char *dir, struct
             prop = icalcomponent_get_first_property(comp, ICAL_TZID_PROPERTY);
             tzid = (char *) icalproperty_get_value_as_string(prop);
 
-            if (verbose) printf("\tZONE: %s\n", tzid);
+            prop = icalcomponent_get_first_property(comp,
+                                                    ICAL_TZIDALIASOF_PROPERTY);
+            if (prop) {
+                alias = tzid;
+                tzid = (char *) icalproperty_get_value_as_string(prop);
+
+                if (verbose) printf("\tLINK: %s -> %s\n", alias, tzid);
+            }
+            else if (verbose) printf("\tZONE: %s\n", tzid);
 
             /* Create/update hash entry for tzid */
             if (!(zi = hash_lookup(tzid, tzentries))) {
@@ -430,6 +444,19 @@ void do_zonedir(const char *dir, struct
 
             /* Check overall lastmod */
             if (zi->dtstamp > info->dtstamp) info->dtstamp = zi->dtstamp;
+
+            if (alias) {
+                /* Add alias to the list for this tzid */
+                appendstrlist(&zi->data, alias);
+
+                /* Create hash entry for alias */
+                if (!(zi = hash_lookup(alias, tzentries))) {
+                    zi = xzmalloc(sizeof(struct zoneinfo));
+                    hash_insert(alias, zi, tzentries);
+                }
+                zi->type = ZI_LINK;
+                appendstrlist(&zi->data, tzid);
+            }
         }
         else {
             fprintf(stderr, "unknown path type %s\n", path);
diff -pruN 3.0.13-5/imap/cvt_cyrusdb.c 3.2.0-3/imap/cvt_cyrusdb.c
--- 3.0.13-5/imap/cvt_cyrusdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cvt_cyrusdb.c	2020-05-04 03:28:02.000000000 +0000
@@ -45,6 +45,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
@@ -57,7 +58,6 @@
 #include <sys/msg.h>
 
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mailbox.h"
 #include "util.h"
@@ -107,14 +107,14 @@ int main(int argc, char *argv[])
                "This is because some database backends (mainly berkeley) do not\n"
                "always do what you would expect with them.\n"
                "\nPlease use absolute pathnames instead.\n\n");
-        exit(EC_OSERR);
+        exit(EX_OSERR);
     }
 
     OLDDB = argv[optind+1];
     NEWDB = argv[optind+3];
 
     if (NEWDB == OLDDB) {
-        fatal("no conversion required", EC_TEMPFAIL);
+        fatal("no conversion required", EX_TEMPFAIL);
     }
 
     cyrus_init(alt_config, "cvt_cyrusdb", 0, 0);
diff -pruN 3.0.13-5/imap/cvt_xlist_specialuse.c 3.2.0-3/imap/cvt_xlist_specialuse.c
--- 3.0.13-5/imap/cvt_xlist_specialuse.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cvt_xlist_specialuse.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,10 +45,10 @@
 
 #include <stdio.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <unistd.h>
 
-#include "lib/exitcodes.h"
 #include "lib/hash.h"
 #include "lib/libconfig.h"
 
@@ -70,7 +70,7 @@ static void usage(void)
             "    -v                  # verbose\n"
     );
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static void save_argv0(const char *s)
@@ -115,8 +115,7 @@ static int set_specialuse(struct findall
     int r;
 
     if (!data) return 0;
-
-    if (!data->mbname) return 0; /* XXX what does this mean? */
+    if (!data->is_exactmatch) return 0;
 
     if (!mbname_userid(data->mbname)) return 0;
 
@@ -195,30 +194,12 @@ int main (int argc, char **argv)
         strarray_append(&patterns, argv[i]);
     }
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
     r = mboxlist_findallmulti(NULL, &patterns, 1, NULL, NULL, set_specialuse, &xlist);
 
-    annotatemore_close();
-    annotate_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
 done:
     free_hash_table(&xlist, (void (*)(void*)) buf_free);
     strarray_fini(&patterns);
 
     cyrus_done();
-    return r ? EC_TEMPFAIL : EC_OK;
+    return r ? EX_TEMPFAIL : EX_OK;
 }
diff -pruN 3.0.13-5/imap/cyr_buildinfo.c 3.2.0-3/imap/cyr_buildinfo.c
--- 3.0.13-5/imap/cyr_buildinfo.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_buildinfo.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* cyr_buildinfo.c - tool to insepct Cyrus build configuration
+/* cyr_buildinfo.c - tool to inspect Cyrus build configuration
  *
  * Copyright (c) 1994-2016 Carnegie Mellon University.  All rights reserved.
  *
@@ -48,10 +48,10 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <jansson.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "proc.h"
 #include "util.h"
 #include "../master/masterconf.h"
@@ -93,11 +93,7 @@ static json_t *buildinfo()
     /* Yikes... */
 
     /* Enabled components */
-#ifdef ENABLE_MBOXEVENT
     json_object_set_new(component, "event_notification", json_true());
-#else
-    json_object_set_new(component, "event_notification", json_false());
-#endif
 #ifdef HAVE_GSSAPI_H
     json_object_set_new(component, "gssapi", json_true());
 #else
@@ -148,6 +144,11 @@ static json_t *buildinfo()
 #else
     json_object_set_new(component, "calalarmd", json_false());
 #endif
+#ifdef WITH_JMAP
+    json_object_set_new(component, "jmap", json_true());
+#else
+    json_object_set_new(component, "jmap", json_false());
+#endif
 #ifdef ENABLE_OBJECTSTORE
     json_object_set_new(component, "objectstore", json_true());
 #else
@@ -158,6 +159,11 @@ static json_t *buildinfo()
 #else
     json_object_set_new(component, "backup", json_false());
 #endif
+#if defined(HAVE_UCDSNMP) || defined(HAVE_NETSNMP)
+    json_object_set_new(component, "snmp", json_true());
+#else
+    json_object_set_new(component, "snmp", json_false());
+#endif
 
     /* Build dependencies */
 #ifdef HAVE_LDAP
@@ -170,6 +176,16 @@ static json_t *buildinfo()
 #else
     json_object_set_new(dependency, "openssl", json_false());
 #endif
+#ifdef HAVE_ZLIB
+    json_object_set_new(dependency, "zlib", json_true());
+#else
+    json_object_set_new(dependency, "zlib", json_false());
+#endif
+#ifdef HAVE_JANSSON
+    json_object_set_new(dependency, "jansson", json_true());
+#else
+    json_object_set_new(dependency, "jansson", json_false());
+#endif
 #if defined(ENABLE_REGEX) && defined(HAVE_PCREPOSIX_H)
     json_object_set_new(dependency, "pcre", json_true());
 #else
@@ -180,6 +196,66 @@ static json_t *buildinfo()
 #else
     json_object_set_new(dependency, "clamav", json_false());
 #endif
+#ifdef HAVE_UCDSNMP
+    json_object_set_new(dependency, "ucdsnmp", json_true());
+#else
+    json_object_set_new(dependency, "ucdsnmp", json_false());
+#endif
+#ifdef HAVE_NETSNMP
+    json_object_set_new(dependency, "netsnmp", json_true());
+#else
+    json_object_set_new(dependency, "netsnmp", json_false());
+#endif
+#ifdef WITH_OPENIO
+    json_object_set_new(dependency, "openio", json_true());
+#else
+    json_object_set_new(dependency, "openio", json_false());
+#endif
+#ifdef HAVE_NGHTTP2
+    json_object_set_new(dependency, "nghttp2", json_true());
+#else
+    json_object_set_new(dependency, "nghttp2", json_false());
+#endif
+#ifdef HAVE_WSLAY
+    json_object_set_new(dependency, "wslay", json_true());
+#else
+    json_object_set_new(dependency, "wslay", json_false());
+#endif
+#ifdef HAVE_BROTLI
+    json_object_set_new(dependency, "brotli", json_true());
+#else
+    json_object_set_new(dependency, "brotli", json_false());
+#endif
+#ifdef USE_HTTPD
+    json_object_set_new(dependency, "xml2", json_true());
+#else
+    json_object_set_new(dependency, "xml2", json_false());
+#endif
+#ifdef HAVE_ICAL
+    json_object_set_new(dependency, "ical", json_true());
+#else
+    json_object_set_new(dependency, "ical", json_false());
+#endif
+#ifdef HAVE_ICU
+    json_object_set_new(dependency, "icu4c", json_true());
+#else
+    json_object_set_new(dependency, "icu4c", json_false());
+#endif
+#ifdef HAVE_SHAPELIB
+    json_object_set_new(dependency, "shapelib", json_true());
+#else
+    json_object_set_new(dependency, "shapelib", json_false());
+#endif
+#ifdef HAVE_LIBCHARDET
+    json_object_set_new(dependency, "chardet", json_true());
+#else
+    json_object_set_new(dependency, "chardet", json_false());
+#endif
+#ifdef HAVE_CLD2
+    json_object_set_new(dependency, "cld2", json_true());
+#else
+    json_object_set_new(dependency, "cld2", json_false());
+#endif
 
     /* Enabled databases */
 #ifdef HAVE_MYSQL
@@ -197,11 +273,6 @@ static json_t *buildinfo()
 #else
     json_object_set_new(database, "sqlite", json_false());
 #endif
-#ifdef HAVE_LMDB
-    json_object_set_new(database, "lmdb", json_true());
-#else
-    json_object_set_new(database, "lmdb", json_false());
-#endif
 
     /* Enabled search engines */
 #ifdef USE_SQUAT
@@ -209,17 +280,12 @@ static json_t *buildinfo()
 #else
     json_object_set_new(search, "squat", json_false());
 #endif
-#ifdef USE_SPHINX
-    json_object_set_new(search, "sphinx", json_true());
-#else
-    json_object_set_new(search, "sphinx", json_false());
-#endif
 #ifdef USE_XAPIAN
     json_object_set_new(search, "xapian", json_true());
 #else
     json_object_set_new(search, "xapian", json_false());
 #endif
-    json_object_set_new(search, "xapian_flavor", json_string(XAPIAN_FLAVOR));
+    json_object_set_new(search, "xapian_cjk_tokens", json_string(XAPIAN_CJK_TOKENS));
 
     /* Supported hardware features */
 #ifdef HAVE_SSE42
diff -pruN 3.0.13-5/imap/cyr_dbtool.c 3.2.0-3/imap/cyr_dbtool.c
--- 3.0.13-5/imap/cyr_dbtool.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_dbtool.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
@@ -58,7 +59,6 @@
 
 #include "assert.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mailbox.h"
 #include "util.h"
@@ -97,7 +97,7 @@ static int read_key_value(char **keyptr,
     }
     if (*keylen + *vallen >= STACKSIZE - 1) {
       printf("Error, stack overflow\n");
-      fatal("stack overflow", EC_DATAERR);
+      fatal("stack overflow", EX_DATAERR);
     }
   }
   (*keyptr)[*keylen] = '\0';
@@ -154,17 +154,27 @@ static void batch_commands(struct db *db
     int c = '-';
     int r = 0;
 
-    while (c != EOF) {
+    prot_setisclient(in, 1);
+    prot_setisclient(out, 1);
+
+    while (1) {
         buf_reset(&cmd);
         buf_reset(&key);
         buf_reset(&val);
         line++;
         c = getword(in, &cmd);
+        if (c == EOF) break;
+
         if (c == ' ')
-            c = getastring(in, NULL, &key);
+            c = getbastring(in, NULL, &key);
         if (c == ' ')
-            c = getastring(in, NULL, &val);
+            c = getbastring(in, NULL, &val);
         if (c == '\r') c = prot_getc(in);
+        if (c != '\n') {
+            r = IMAP_PROTOCOL_BAD_PARAMETERS;
+            goto done;
+        }
+
         if (cmd.len) {
             /* got a command! */
             if (!strcmp(cmd.s, "BEGIN")) {
@@ -220,7 +230,6 @@ static void batch_commands(struct db *db
                 goto done;
             }
         }
-        if (c != '\n') break;
     }
 
 done:
@@ -235,10 +244,10 @@ int main(int argc, char *argv[])
 {
     const char *fname;
     const char *action;
-    char *key;
-    char *value;
+    char *key = NULL;
+    char *value = NULL;
     int i,r;
-    size_t keylen,vallen,reslen;
+    size_t keylen = 0, vallen = 0, reslen = 0;
     int opt,loop;
     char *alt_config = NULL;
     const char *res = NULL;
@@ -311,7 +320,7 @@ int main(int argc, char *argv[])
                "This is because some database backends (mainly berkeley) do not\n"
                "always do what you would expect with them.\n"
                "\nPlease use absolute pathnames instead.\n\n");
-        exit(EC_OSERR);
+        exit(EX_OSERR);
     }
 
     outfd = fileno(stdout);
@@ -320,7 +329,7 @@ int main(int argc, char *argv[])
 
     r = cyrusdb_open(argv[optind+1], fname, db_flags, &db);
     if(r != CYRUSDB_OK)
-        fatal("can't open database", EC_TEMPFAIL);
+        fatal("can't open database", EX_TEMPFAIL);
 
     if (( is_get = !strcmp(action, "get"))  ||
       (is_delete = !strcmp(action, "delete")) ||
diff -pruN 3.0.13-5/imap/cyr_deny.c 3.2.0-3/imap/cyr_deny.c
--- 3.0.13-5/imap/cyr_deny.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_deny.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,11 +50,11 @@
 #include <string.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "proc.h"
 #include "userdeny.h"
@@ -70,7 +70,7 @@ static void usage(void)
     fprintf(stderr, "Usage: cyr_deny [-C <altconfig>] [ -s services ] [ -m message ] user\n");
     fprintf(stderr, "       cyr_deny [-C <altconfig>] -a user\n");
     fprintf(stderr, "       cyr_deny [-C <altconfig>] -l\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static int list_one(const char *user, const char *services,
diff -pruN 3.0.13-5/imap/cyr_df.c 3.2.0-3/imap/cyr_df.c
--- 3.0.13-5/imap/cyr_df.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_df.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,11 +47,11 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include "string.h"
 #include <sys/statvfs.h>
 #include <sys/types.h>
 
-#include "exitcodes.h"
 #include "global.h"
 #include "util.h"
 #include "xmalloc.h"
@@ -101,7 +101,7 @@ static void usage(void)
 {
     fprintf(stderr,
             "usage: cyr_df [-C <alt_config>] [-m]\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 
diff -pruN 3.0.13-5/imap/cyrdump.c 3.2.0-3/imap/cyrdump.c
--- 3.0.13-5/imap/cyrdump.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyrdump.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -44,14 +44,15 @@
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
+#include <libgen.h>
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 
 /* cyrus includes */
 #include "assert.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "index.h"
 #include "imapurl.h"
@@ -65,11 +66,12 @@
 #include "imap/imap_err.h"
 
 static int verbose = 0;
+static const char *progname = NULL;
 
 static int dump_me(struct findall_data *data, void *rock);
 static void print_seq(const char *tag, const char *attrib,
                       unsigned *seq, int n);
-static int usage(const char *name);
+static int usage(void);
 
 struct incremental_record {
     unsigned incruid;
@@ -82,6 +84,8 @@ int main(int argc, char *argv[])
     char *alt_config = NULL;
     struct incremental_record irec;
 
+    progname = basename(argv[0]);
+
     while ((option = getopt(argc, argv, "vC:")) != EOF) {
         switch (option) {
         case 'v':
@@ -93,18 +97,16 @@ int main(int argc, char *argv[])
             break;
 
         default:
-            usage(argv[0]);
+            usage();
             break;
         }
     }
 
     if (optind == argc) {
-        usage(argv[0]);
+        usage();
     }
 
     cyrus_init(alt_config, "dump", 0, CONFIG_NEED_PARTITION_DATA);
-    mboxlist_init(0);
-    mboxlist_open(NULL);
 
     search_attr_init();
 
@@ -118,19 +120,23 @@ int main(int argc, char *argv[])
 
     strarray_free(array);
 
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return 0;
 }
 
-static int usage(const char *name)
+static int usage(void)
 {
-    fprintf(stderr, "usage: %s [-v] [mboxpattern ...]\n", name);
+    fprintf(stderr, "Usage: %s [OPTIONS] {mailboxes}\n", progname);
+    fprintf(stderr, "Dumps out a basic copy of mailbox data to stdout.\n");
+    fprintf(stderr, "\n");
+
+    fprintf(stderr, "-C <config-file>         use <config-file> instead of config from imapd.conf\n");
+    fprintf(stderr, "-v                       enable verbose output\n");
+
+    fprintf(stderr, "\n");
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static void generate_boundary(char *boundary, size_t size)
@@ -164,7 +170,8 @@ static int dump_me(struct findall_data *
     unsigned msgno;
 
     /* don't want partial matches */
-    if (!data || !data->mbname) return 0;
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
 
     const char *name = mbname_intname(data->mbname);
 
diff -pruN 3.0.13-5/imap/cyr_expire.c 3.2.0-3/imap/cyr_expire.c
--- 3.0.13-5/imap/cyr_expire.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_expire.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
 /* cyr_expire.c -- Program to expire deliver.db entries and messages
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -40,6 +40,14 @@
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+/*
+  NOTES:
+  * Precedence of configuration in `cyr_expire`:
+     Highest                       Lowest
+     |----------------------------------|
+     Annotation -> Command-line -> Config
+ */
+
 #include <config.h>
 
 #ifdef HAVE_UNISTD_H
@@ -50,14 +58,17 @@
 #include <string.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
+#include <errno.h>
+#include <stdbool.h>
+#include <libgen.h>
 
 #include <sasl/sasl.h>
 
 #include "annotate.h"
 #include "duplicate.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "hash.h"
 #include "libcyr_cfg.h"
@@ -71,33 +82,54 @@
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
 
+#define SECS_IN_A_MIN 60
+#define SECS_IN_AN_HR (60 * SECS_IN_A_MIN)
+#define SECS_IN_A_DAY (24 * SECS_IN_AN_HR)
+
 /* global state */
 static volatile sig_atomic_t sigquit = 0;
 static int verbose = 0;
-static int keep_flagged = 1;
+static const char *progname = NULL;
+static struct namespace expire_namespace; /* current namespace */
 
-/* current namespace */
-static struct namespace expire_namespace;
+/* command line arguments */
+struct arguments {
+    int archive_seconds;
+    int delete_seconds;
+    int expire_seconds;
+    int expunge_seconds;
+
+    int do_cid_expire;
+
+    /* bools */
+    bool do_expunge;
+    bool do_userflags;
+    bool skip_annotate;
+
+    const char *altconfig;
+    const char *mbox_prefix;
+    const char *userid;
+};
 
-static void usage(void)
-{
-    fprintf(stderr,
-            "cyr_expire [-C <altconfig>] [-E <expire-duration>] [-D <delete-duration] [-X <expunge-duration>] [-p prefix] [-a] [-v] [-x]\n");
-    exit(-1);
-}
+struct archive_rock {
+    time_t archive_mark;
+    unsigned long messages_archived;
+    bool skip_annotate;
+};
 
 struct expire_rock {
     struct hash_table table;
     time_t expire_mark;
     time_t expunge_mark;
+    time_t tombstone_mark;
     unsigned long mailboxes_seen;
     unsigned long messages_seen;
     unsigned long messages_expired;
     unsigned long messages_expunged;
-    int skip_annotate;
-    bit32 userflags[MAX_USER_FLAGS/32];
-    int do_userflags;
     unsigned long userflags_expunged;
+    bit32 userflags[MAX_USER_FLAGS/32];
+    bool do_userflags;
+    bool skip_annotate;
 };
 
 struct conversations_rock {
@@ -111,8 +143,107 @@ struct conversations_rock {
 struct delete_rock {
     time_t delete_mark;
     strarray_t to_delete;
+    bool skip_annotate;
 };
 
+/* The global context */
+struct cyr_expire_ctx {
+    struct arguments args;
+    struct archive_rock arock;
+    struct conversations_rock crock;
+    struct delete_rock drock;
+    struct expire_rock erock;
+};
+
+static const struct cyr_expire_ctx zero_ctx;
+
+static void sighandler(int sig);
+
+/* verbosep - a wrapper to print if the 'verbose' option is
+   turned on.
+ */
+__attribute__((format (printf, 1, 2)))
+static inline void verbosep(const char *fmt, ...)
+{
+    va_list params;
+
+    if (!verbose)
+        return;
+
+    va_start(params, fmt);
+    vfprintf(stderr, fmt, params);
+    va_end(params);
+    fputc('\n', stderr);
+}
+
+static void cyr_expire_init(const char *progname, struct cyr_expire_ctx *ctx)
+{
+    struct sigaction action;
+
+    /* Initialise signal handlers */
+    sigemptyset(&action.sa_mask);
+    action.sa_flags = 0;
+    action.sa_handler = sighandler;
+    if (sigaction(SIGQUIT, &action, NULL) < 0)
+        fatal("unable to install signal handler for SIGQUIT", EX_TEMPFAIL);
+    if (sigaction(SIGINT, &action, NULL) < 0)
+        fatal("unable to install signal handler for SIGINT", EX_TEMPFAIL);
+    if (sigaction(SIGTERM, &action, NULL) < 0)
+        fatal("unable to install signal handler for SIGTERM", EX_TEMPFAIL);
+
+    construct_hash_table(&ctx->erock.table, 10000, 1);
+    strarray_init(&ctx->drock.to_delete);
+    construct_hash_table(&ctx->crock.seen, 100, 1);
+
+    cyrus_init(ctx->args.altconfig, progname, 0, 0);
+    global_sasl_init(1, 0, NULL);
+
+    ctx->erock.do_userflags = ctx->args.do_userflags;
+    /* TODO: Ideally all the functions should just use the skip_annotate from
+     *       args. But that would require a change in the callback signatures.
+     *       So retaining it as is for now.
+     */
+    ctx->arock.skip_annotate = ctx->args.skip_annotate;
+    ctx->erock.skip_annotate = ctx->args.skip_annotate;
+    ctx->drock.skip_annotate = ctx->args.skip_annotate;
+}
+
+static void cyr_expire_cleanup(struct cyr_expire_ctx *ctx)
+{
+    free_hash_table(&ctx->erock.table, free);
+    free_hash_table(&ctx->crock.seen, NULL);
+    strarray_fini(&ctx->drock.to_delete);
+
+    duplicate_done();
+    sasl_done();
+    cyrus_done();
+}
+
+static void usage(void)
+{
+    fprintf(stderr, "Usage: %s [OPTIONS] {mailbox|users}\n", progname);
+    fprintf(stderr, "Expire messages and duplicate delivery database entries.\n");
+    fprintf(stderr, "\n");
+
+    fprintf(stderr, "-a                       skip annotation lookup\n");
+    fprintf(stderr, "-c                       do not expire conversations\n");
+    fprintf(stderr, "-h                       print this help and exit\n");
+    fprintf(stderr, "-p <mailbox-prefix>      specify prefix for mailboxes\n");
+    fprintf(stderr, "-t                       remove user flags which are not used\n");
+    fprintf(stderr, "-u <user-id>             specify user id for mailbox lookup\n");
+    fprintf(stderr, "-v                       enable verbose output\n");
+    fprintf(stderr, "-x                       do not expunge messages\n");
+    fprintf(stderr, "-C <config-file>         use <config-file> instead of config from imapd.conf\n");
+    fprintf(stderr, "-A <archive-duration>    \n");
+    fprintf(stderr, "-D <delete-duration>     \n");
+    fprintf(stderr, "-E <expire-duration>     \n");
+    fprintf(stderr, "-X <expunge-duration>    \n");
+
+    fprintf(stderr, "\n");
+
+    exit(EX_USAGE);
+}
+
 /*
  * Parse a non-negative duration string as seconds.
  *
@@ -126,7 +257,7 @@ static int parse_duration(const char *s,
 {
     char *end = NULL;
     double val;
-    int multiplier = 86400; /* default is days */
+    int multiplier = SECS_IN_A_DAY; /* default is days */
 
     /* no negative or empty numbers please */
     if (!*s || *s == '-')
@@ -142,10 +273,10 @@ static int parse_duration(const char *s,
             /* already the default */
             break;
         case 'h':
-            multiplier = 3600;
+            multiplier = SECS_IN_AN_HR;
             break;
         case 'm':
-            multiplier = 60;
+            multiplier = SECS_IN_A_MIN;
             break;
         case 's':
             multiplier = 1;
@@ -160,6 +291,48 @@ static int parse_duration(const char *s,
     return 1;
 }
 
+/*
+ * Given an annotation, reads it, and converts it into 'seconds',
+ * using `parse_duration`.
+ *
+ * On Success: Returns 1
+ * On Failure: Returns 0
+ */
+static int get_annotation_value(const char *mboxname,
+                                const char *annot_entry,
+                                int *secondsp, bool iterate)
+{
+    struct buf attrib = BUF_INITIALIZER;
+    int ret = 0;
+    /* mboxname needs to be copied since `mboxname_make_parent`
+     * runs a strrchr() on it.
+     */
+    char *buf = xstrdup(mboxname);
+
+    /*
+     * Mailboxes inherit /vendo/cmu/cyrus-imapd/{expire, archive, delete},
+     * so we need to iterate all the way up to "" (server entry).
+     */
+    do {
+        buf_free(&attrib);
+        ret = annotatemore_lookup(buf, annot_entry, "", &attrib);
+        if (ret ||              /* error */
+            attrib.s)           /* found an entry */
+            break;
+    } while (mboxname_make_parent(buf) && iterate);
+
+    if (attrib.s && parse_duration(attrib.s, secondsp))
+        ret = 1;
+    else
+        ret = 0;
+
+    buf_free(&attrib);
+    free(buf);
+
+    syslog(LOG_DEBUG, "get_annotation_value: ret(%d):secondsp(%d)\n", ret, *secondsp);
+    return ret;
+}
+
 static int expunge_userflags(struct mailbox *mailbox, struct expire_rock *erock)
 {
     unsigned int i;
@@ -170,9 +343,8 @@ static int expunge_userflags(struct mail
             continue;
         if (!mailbox->flagname[i])
             continue;
-        if (verbose)
-            fprintf(stderr, "Expunging userflag %u (%s) from %s\n",
-                    i, mailbox->flagname[i], mailbox->name);
+        verbosep("Expunging userflag %u (%s) from %s\n",
+                        i, mailbox->flagname[i], mailbox->name);
         r = mailbox_remove_user_flag(mailbox, i);
         if (r) return r;
         erock->userflags_expunged++;
@@ -182,29 +354,6 @@ static int expunge_userflags(struct mail
 }
 
 /*
- * mailbox_expunge() callback to expunge expired articles.
- */
-static unsigned expire_cb(struct mailbox *mailbox __attribute__((unused)),
-                          const struct index_record *record,
-                          void *rock)
-{
-    struct expire_rock *erock = (struct expire_rock *) rock;
-    unsigned int i;
-
-    /* otherwise, we're expiring messages by sent date */
-    if (record->gmtime < erock->expire_mark) {
-        erock->messages_expired++;
-        return 1;
-    }
-
-    /* record which user flags are set */
-    for (i = 0; i < (MAX_USER_FLAGS/32); i++)
-        erock->userflags[i] |= record->user_flags[i];
-
-    return 0;
-}
-
-/*
  * mailbox_expunge() callback to *only* count userflags.
  */
 static unsigned userflag_cb(struct mailbox *mailbox __attribute__((unused)),
@@ -223,7 +372,9 @@ static unsigned userflag_cb(struct mailb
 
 static int archive(const mbentry_t *mbentry, void *rock)
 {
+    struct archive_rock *arock = (struct archive_rock *) rock;
     struct mailbox *mailbox = NULL;
+    int archive_seconds = -1;
 
     if (sigquit)
         return 1;
@@ -237,10 +388,19 @@ static int archive(const mbentry_t *mben
     if (mailbox_open_iwl(mbentry->name, &mailbox))
         goto done;
 
-    if (verbose)
-        fprintf(stderr, "archiving mailbox %s\n", mbentry->name);
+    /* check /vendor/cmu/cyrus-imapd/archive */
+    if (!arock->skip_annotate &&
+        get_annotation_value(mbentry->name, IMAP_ANNOT_NS "archive",
+                             &archive_seconds, false)) {
+        arock->archive_mark = archive_seconds ?
+            time(0) - archive_seconds : 0;
+    }
 
-    mailbox_archive(mailbox, NULL, rock, ITER_SKIP_EXPUNGED);
+    /* The default callback for mailbox_archive() is mailbox_should_archive()
+     * in imap/mailbox.c. This one takes the arock->archive_mark as the
+     * callback data.
+     */
+    mailbox_archive(mailbox, NULL, &arock->archive_mark, ITER_SKIP_EXPUNGED);
 
 done:
     mailbox_close(&mailbox);
@@ -250,6 +410,29 @@ done:
 }
 
 /*
+ * mailbox_expunge() callback to expunge expired articles.
+ */
+static unsigned expire_cb(struct mailbox *mailbox __attribute__((unused)),
+                          const struct index_record *record,
+                          void *rock)
+{
+    struct expire_rock *erock = (struct expire_rock *) rock;
+    unsigned int i;
+
+    /* otherwise, we're expiring messages by sent date */
+    if (record->gmtime < erock->expire_mark) {
+        erock->messages_expired++;
+        return 1;
+    }
+
+    /* record which user flags are set */
+    for (i = 0; i < (MAX_USER_FLAGS/32); i++)
+        erock->userflags[i] |= record->user_flags[i];
+
+    return 0;
+}
+
+/*
  * callback function to:
  * - expire messages from mailboxes,
  * - build a hash table of mailboxes in which we expired messages,
@@ -258,8 +441,6 @@ done:
 static int expire(const mbentry_t *mbentry, void *rock)
 {
     struct expire_rock *erock = (struct expire_rock *) rock;
-    char *buf;
-    struct buf attrib = BUF_INITIALIZER;
     int r;
     struct mailbox *mailbox = NULL;
     unsigned numexpunged = 0;
@@ -277,35 +458,14 @@ static int expire(const mbentry_t *mbent
 
     /* clean up deleted entries after 7 days */
     if (mbentry->mbtype & MBTYPE_DELETED) {
-        if (time(0) - mbentry->mtime > 86400*7) {
-            if (verbose)
-                fprintf(stderr, "Removing stale tombstone for %s\n", mbentry->name);
+        if (mbentry->mtime < erock->tombstone_mark) {
+            verbosep("Removing stale tombstone for %s\n", mbentry->name);
             syslog(LOG_NOTICE, "Removing stale tombstone for %s", mbentry->name);
             mboxlist_delete(mbentry->name);
         }
         goto done;
     }
 
-    buf = xstrdup(mbentry->name);
-
-    /* see if we need to expire messages.
-     * since mailboxes inherit /vendor/cmu/cyrus-imapd/expire,
-     * we need to iterate all the way up to "" (server entry)
-     */
-    if (!erock->skip_annotate) {
-        do {
-            buf_free(&attrib);
-            r = annotatemore_lookup(buf, IMAP_ANNOT_NS "expire", "",
-                                    &attrib);
-
-            if (r ||                            /* error */
-                attrib.s)                       /* found an entry */
-                break;
-
-        } while (mboxname_make_parent(buf));
-    }
-    free(buf);
-
     memset(erock->userflags, 0, sizeof(erock->userflags));
 
     r = mailbox_open_iwl(mbentry->name, &mailbox);
@@ -316,20 +476,24 @@ static int expire(const mbentry_t *mbent
         goto done;
     }
 
-    if (attrib.s && parse_duration(attrib.s, &expire_seconds)) {
+    /* see if we need to expire messages.
+     * since mailboxes inherit /vendor/cmu/cyrus-imapd/expire,
+     * we need to iterate all the way up to "" (server entry)
+     */
+    if (!erock->skip_annotate &&
+        get_annotation_value(mbentry->name, IMAP_ANNOT_NS "expire",
+                             &expire_seconds, true)) {
         /* add mailbox to table */
         erock->expire_mark = expire_seconds ?
-                             time(0) - expire_seconds : 0 /* never */ ;
+            time(0) - expire_seconds : 0 /* never */ ;
         hash_insert(mbentry->name,
                     xmemdup(&erock->expire_mark, sizeof(erock->expire_mark)),
                     &erock->table);
 
         if (expire_seconds) {
-            if (verbose) {
-                fprintf(stderr,
-                        "expiring messages in %s older than %0.2f days\n",
-                        mbentry->name, ((double)expire_seconds/86400));
-            }
+            verbosep("expiring messages in %s older than %0.2f days\n",
+                     mbentry->name,
+                     ((double)expire_seconds/SECS_IN_A_DAY));
 
             r = mailbox_expunge(mailbox, expire_cb, erock, NULL,
                                 EVENT_MESSAGE_EXPIRE);
@@ -338,7 +502,6 @@ static int expire(const mbentry_t *mbent
             did_expunge = 1;
         }
     }
-    buf_free(&attrib);
 
     if (!did_expunge && erock->do_userflags) {
         r = mailbox_expunge(mailbox, userflag_cb, erock, NULL,
@@ -353,8 +516,7 @@ static int expire(const mbentry_t *mbent
     if (erock->do_userflags)
         expunge_userflags(mailbox, erock);
 
-    if (verbose)
-        fprintf(stderr, "cleaning up expunged messages in %s\n", mbentry->name);
+    verbosep("cleaning up expunged messages in %s\n", mbentry->name);
 
     r = mailbox_expunge_cleanup(mailbox, erock->expunge_mark, &numexpunged);
 
@@ -376,6 +538,7 @@ static int delete(const mbentry_t *mbent
 {
     struct delete_rock *drock = (struct delete_rock *) rock;
     time_t timestamp;
+    int delete_seconds = -1;
 
     if (sigquit)
         return 1;
@@ -390,11 +553,18 @@ static int delete(const mbentry_t *mbent
     if (!mboxname_isdeletedmailbox(mbentry->name, &timestamp))
         goto done;
 
+    /* check /vendor/cmu/cyrus-imapd/delete */
+    if (!drock->skip_annotate &&
+        get_annotation_value(mbentry->name, IMAP_ANNOT_NS "delete",
+                             &delete_seconds, false)) {
+        drock->delete_mark = delete_seconds ?
+            time(0) - delete_seconds: 0;
+    }
+
     if ((timestamp == 0) || (timestamp > drock->delete_mark))
         goto done;
 
-    if (verbose)
-        fprintf(stderr, "Cleaning up %s\n", mbentry->name);
+    verbosep("Cleaning up %s\n", mbentry->name);
 
     /* Add this mailbox to list of mailboxes to delete */
     strarray_append(&drock->to_delete, mbentry->name);
@@ -430,10 +600,9 @@ static int expire_conversations(const mb
     if (hash_lookup(filename, &crock->seen))
         goto done;
 
-    if (verbose)
-        fprintf(stderr, "Pruning conversations from db %s\n", filename);
+    verbosep("Pruning conversations from db %s\n", filename);
 
-    if (!conversations_open_path(filename, &state)) {
+    if (!conversations_open_mbox(mbentry->name, 0/*shared*/, &state)) {
         conversations_prune(state, crock->expire_mark, &nseen, &ndeleted);
         conversations_commit(&state);
     }
@@ -449,145 +618,275 @@ done:
     return 0;
 }
 
-static void sighandler (int sig __attribute((unused)))
+static void sighandler(int sig __attribute((unused)))
 {
     sigquit = 1;
     return;
 }
 
-int main(int argc, char *argv[])
+static int do_archive(struct cyr_expire_ctx *ctx)
+{
+    if (ctx->args.archive_seconds >= 0) {
+        syslog(LOG_DEBUG, ">> do_archive: archive_seconds(%d) >= 0\n",
+               ctx->args.archive_seconds);
+        ctx->arock.archive_mark = time(0) - ctx->args.archive_seconds;
+
+        if (ctx->args.userid)
+            mboxlist_usermboxtree(ctx->args.userid, NULL, archive,
+                                  &ctx->arock, MBOXTREE_DELETED);
+        else
+            mboxlist_allmbox(ctx->args.mbox_prefix, archive, &ctx->arock, 0);
+    }
+
+    return 0;
+}
+
+static int do_expunge(struct cyr_expire_ctx *ctx)
+{
+    if (ctx->args.do_expunge && (ctx->args.expunge_seconds >= 0 ||
+                                 ctx->args.expire_seconds ||
+                                 ctx->erock.do_userflags)) {
+        /* XXX: better way to determine a size for this table? */
+
+        /* expire messages from mailboxes,
+         * build a hash table of mailboxes in which we expired messages,
+         * and perform a cleanup of expunged messages
+         */
+        if (ctx->args.expunge_seconds < 0) {
+            ctx->erock.expunge_mark = 0;
+        } else {
+            ctx->erock.expunge_mark = time(0) - ctx->args.expunge_seconds;
+
+            verbosep("Expunging deleted messages in mailboxes older than %0.2f days\n",
+                           ((double)ctx->args.expunge_seconds/SECS_IN_A_DAY));
+        }
+
+        /* XXX _ a control for this too? */
+        ctx->erock.tombstone_mark = time(0) - SECS_IN_A_DAY*7;
+
+        if (ctx->args.userid)
+            mboxlist_usermboxtree(ctx->args.userid, NULL, expire,
+                                  &ctx->erock, MBOXTREE_DELETED|MBOXTREE_TOMBSTONES);
+        else
+            mboxlist_allmbox(ctx->args.mbox_prefix, expire, &ctx->erock,
+                             MBOXTREE_TOMBSTONES);
+
+        syslog(LOG_NOTICE, "Expired %lu and expunged %lu out of %lu "
+                            "messages from %lu mailboxes",
+                           ctx->erock.messages_expired,
+                           ctx->erock.messages_expunged,
+                           ctx->erock.messages_seen,
+                           ctx->erock.mailboxes_seen);
+        verbosep("\nExpired %lu and expunged %lu out of %lu "
+                       "messages from %lu mailboxes\n",
+                       ctx->erock.messages_expired,
+                       ctx->erock.messages_expunged,
+                       ctx->erock.messages_seen,
+                       ctx->erock.mailboxes_seen);
+
+        if (ctx->erock.do_userflags) {
+            syslog(LOG_NOTICE, "Expunged %lu user flags",
+                           ctx->erock.userflags_expunged);
+            verbosep("Expunged %lu user flags\n",
+                           ctx->erock.userflags_expunged);
+        }
+
+    }
+
+    return 0;
+}
+
+static int do_cid_expire(struct cyr_expire_ctx *ctx)
+{
+    if (ctx->args.do_cid_expire) {
+        int cid_expire_seconds;
+
+        cid_expire_seconds = config_getduration(IMAPOPT_CONVERSATIONS_EXPIRE_AFTER, 'd');
+        ctx->crock.expire_mark = time(0) - cid_expire_seconds;
+
+        verbosep("Removing conversation entries older than %0.2f days\n",
+                       (double)(cid_expire_seconds/SECS_IN_A_DAY));
+
+        if (ctx->args.userid)
+            mboxlist_usermboxtree(ctx->args.userid, NULL, expire_conversations,
+                                  &ctx->crock, MBOXTREE_DELETED);
+        else
+            mboxlist_allmbox(ctx->args.mbox_prefix, expire_conversations,
+                             &ctx->crock, 0);
+
+        syslog(LOG_NOTICE, "Expired %lu entries of %lu entries seen "
+                            "in %lu conversation databases",
+                            ctx->crock.msgids_expired,
+                            ctx->crock.msgids_seen,
+                            ctx->crock.databases_seen);
+        verbosep("Expired %lu entries of %lu entries seen "
+                       "in %lu conversation databases\n",
+                       ctx->crock.msgids_expired,
+                       ctx->crock.msgids_seen,
+                       ctx->crock.databases_seen);
+    }
+
+    return 0;
+}
+
+static int do_delete(struct cyr_expire_ctx *ctx)
+{
+    int ret = 0;
+
+    if ((ctx->args.delete_seconds >= 0) &&
+        mboxlist_delayed_delete_isenabled() &&
+        config_getstring(IMAPOPT_DELETEDPREFIX)) {
+        int count = 0;
+        int i;
+
+        verbosep("Removing deleted mailboxes older than %0.2f days\n",
+                 ((double)ctx->args.delete_seconds/SECS_IN_A_DAY));
+
+        ctx->drock.delete_mark = time(0) - ctx->args.delete_seconds;
+
+        if (ctx->args.userid)
+            mboxlist_usermboxtree(ctx->args.userid, NULL, delete,
+                                  &ctx->drock, MBOXTREE_DELETED);
+        else
+            mboxlist_allmbox(ctx->args.mbox_prefix, delete, &ctx->drock, 0);
+
+        for (i = 0 ; i < ctx->drock.to_delete.count ; i++) {
+            char *name = ctx->drock.to_delete.data[i];
+
+            if (sigquit)
+                return ret;         /* return from here, will quit in main. */
+
+            verbosep("Removing: %s\n", name);
+
+            ret = mboxlist_deletemailboxlock(name, 1, NULL, NULL, NULL, 0, 0, 0, 0);
+            /* XXX: Ignoring the return from mboxlist_deletemailbox() ??? */
+            count++;
+        }
+
+        verbosep("Removed %d deleted mailboxes\n", count);
+
+        syslog(LOG_NOTICE, "Removed %d deleted mailboxes", count);
+    }
+
+    return ret;
+}
+
+static int do_duplicate_prune(struct cyr_expire_ctx *ctx)
+{
+    int ret = 0;
+    if (ctx->args.expire_seconds > 0)
+        ret = duplicate_prune(ctx->args.expire_seconds, &ctx->erock.table);
+
+    return ret;
+}
+
+static int parse_args(int argc, char *argv[], struct arguments *args)
 {
     extern char *optarg;
-    int opt, r = 0;
-    int do_expunge = 1; /* gnb:TODO bool */
-    int expunge_seconds = -1;
-    int archive_seconds = -1;
-    int delete_seconds = -1;
-    int expire_seconds = 0;
-    int cid_expire_seconds;
-    int do_cid_expire = -1;
-    char *alt_config = NULL;
-    const char *find_prefix = NULL;
-    const char *do_user = NULL;
-    struct expire_rock erock;
-    struct delete_rock drock;
-    struct conversations_rock crock;
-    struct sigaction action;
+    int opt;
 
-    /* zero the expire_rock & delete_rock */
-    memset(&erock, 0, sizeof(erock));
-    construct_hash_table(&erock.table, 10000, 1);
-    memset(&drock, 0, sizeof(drock));
-    strarray_init(&drock.to_delete);
-    memset(&crock, 0, sizeof(crock));
-    construct_hash_table(&crock.seen, 100, 1);
+    args->archive_seconds = -1;
+    args->delete_seconds = -1;
+    args->expire_seconds = -1;
+    args->expunge_seconds = -1;
+    args->do_expunge = true;
+    args->do_cid_expire = -1;
 
-    while ((opt = getopt(argc, argv, "C:D:E:X:A:p:u:vaxtcFS:")) != EOF) {
+    while ((opt = getopt(argc, argv, "C:D:E:X:A:p:u:vaxtch")) != EOF) {
         switch (opt) {
-        case 'C': /* alt config file */
-            alt_config = optarg;
+        case 'A':
+            if (!parse_duration(optarg, &args->archive_seconds)) usage();
             break;
 
-        case 'A':
-            if (archive_seconds >= 0) usage();
-            if (!parse_duration(optarg, &archive_seconds)) usage();
+        case 'C':
+            args->altconfig = optarg;
             break;
 
         case 'D':
-            if (delete_seconds >= 0) usage();
-            if (!parse_duration(optarg, &delete_seconds)) usage();
+            if (!parse_duration(optarg, &args->delete_seconds))
+                usage();
             break;
 
         case 'E':
-            if (expire_seconds > 0) usage();
-            if (!parse_duration(optarg, &expire_seconds)) usage();
+            if (!parse_duration(optarg, &args->expire_seconds))
+                usage();
             break;
 
         case 'X':
-            if (expunge_seconds >= 0) usage();
-            if (!parse_duration(optarg, &expunge_seconds)) usage();
+            if (!parse_duration(optarg, &args->expunge_seconds))
+                usage();
             break;
 
-        case 'F':
-            keep_flagged = 0;
+        case 'a':
+            args->skip_annotate = true;
+            break;
+
+        case 'c':
+            args->do_cid_expire = 0;
             break;
 
         case 'p':
-            find_prefix = optarg;
+            args->mbox_prefix = optarg;
+            break;
+
+        case 't':
+            args->do_userflags = true;
             break;
 
         case 'u':
-            do_user = optarg;
+            args->userid = optarg;
             break;
 
         case 'v':
             verbose++;
             break;
 
-        case 'a':
-            erock.skip_annotate = 1;
-            break;
-
         case 'x':
-            if (!do_expunge) usage();
-            do_expunge = 0;
-            break;
-
-        case 't':
-            erock.do_userflags = 1;
-            break;
-
-        case 'c':
-            if (!do_cid_expire) usage();
-            do_cid_expire = 0;
+            args->do_expunge = false;
             break;
 
+        case 'h':
         default:
             usage();
             break;
         }
     }
 
-    if (!expire_seconds &&
-        delete_seconds == -1 &&
-        expunge_seconds == -1 &&
-        archive_seconds == -1 &&
-        !erock.do_userflags)
+    if (args->archive_seconds == -1 &&
+        args->delete_seconds  == -1 &&
+        args->expire_seconds  == -1 &&
+        args->expunge_seconds == -1 &&
+        !args->do_userflags) {
+        /* TODO: Print a more useful error message here. */
+        fprintf(stderr, "Missing arguments.\n");
         usage();
+        return -EINVAL;
+    }
 
-    sigemptyset(&action.sa_mask);
-    action.sa_flags = 0;
-    action.sa_handler = sighandler;
-    if (sigaction(SIGQUIT, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGQUIT", EC_TEMPFAIL);
-    if (sigaction(SIGINT, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGINT", EC_TEMPFAIL);
-    if (sigaction(SIGTERM, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGTERM", EC_TEMPFAIL);
 
-    cyrus_init(alt_config, "cyr_expire", 0, 0);
-    global_sasl_init(1, 0, NULL);
+    return 0;
+}
 
-    if (do_cid_expire < 0)
-        do_cid_expire = config_getswitch(IMAPOPT_CONVERSATIONS);
+int main(int argc, char *argv[])
+{
+    int r = 0;
+    struct cyr_expire_ctx ctx = zero_ctx;
 
-    annotate_init(NULL, NULL);
-    annotatemore_open();
+    progname = basename(argv[0]);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
+    if (parse_args(argc, argv, &ctx.args) != 0)
+        exit(EXIT_FAILURE);
 
-    /* open the quota db, we'll need it for expunge */
-    quotadb_init(0);
-    quotadb_open(NULL);
+    cyr_expire_init(progname, &ctx);
 
-    /* setup for mailbox event notifications */
-    mboxevent_init();
+    /* do_cid_expire defaults to whatever IMAP options are set */
+    if (ctx.args.do_cid_expire < 0)
+        ctx.args.do_cid_expire = config_getswitch(IMAPOPT_CONVERSATIONS);
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&expire_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     mboxevent_setnamespace(&expire_namespace);
@@ -598,157 +897,30 @@ int main(int argc, char *argv[])
         exit(1);
     }
 
-    if (archive_seconds >= 0) {
-        time_t archive_mark = time(0) - archive_seconds;
-        /* XXX - add syslog? */
-        if (do_user)
-            mboxlist_usermboxtree(do_user, archive, &archive_mark, MBOXTREE_DELETED);
-        else
-            mboxlist_allmbox(find_prefix, archive, &archive_mark, 0);
-    }
-
-    if (do_expunge && (expunge_seconds >= 0 || expire_seconds || erock.do_userflags)) {
-        /* xxx better way to determine a size for this table? */
-
-        /* expire messages from mailboxes,
-         * build a hash table of mailboxes in which we expired messages,
-         * and perform a cleanup of expunged messages
-         */
-        if (expunge_seconds < 0) {
-            erock.expunge_mark = 0;
-        } else {
-            erock.expunge_mark = time(0) - expunge_seconds;
-
-            if (verbose) {
-                fprintf(stderr,
-                        "Expunging deleted messages in mailboxes older than %0.2f days\n",
-                        ((double)expunge_seconds/86400));
-            }
-        }
+    r = do_archive(&ctx);
 
-        if (do_user)
-            mboxlist_usermboxtree(do_user, expire, &erock, MBOXTREE_DELETED);
-        else
-            mboxlist_allmbox(find_prefix, expire, &erock, 0);
-
-        syslog(LOG_NOTICE, "Expired %lu and expunged %lu out of %lu "
-                            "messages from %lu mailboxes",
-                           erock.messages_expired,
-                           erock.messages_expunged,
-                           erock.messages_seen,
-                           erock.mailboxes_seen);
-        if (erock.do_userflags)
-            syslog(LOG_NOTICE, "Expunged %lu user flags",
-                           erock.userflags_expunged);
-        if (verbose) {
-            fprintf(stderr, "\nExpired %lu and expunged %lu out of %lu "
-                            "messages from %lu mailboxes\n",
-                           erock.messages_expired,
-                           erock.messages_expunged,
-                           erock.messages_seen,
-                           erock.mailboxes_seen);
-            if (erock.do_userflags)
-                fprintf(stderr, "Expunged %lu user flags\n",
-                               erock.userflags_expunged);
-        }
-    }
-    if (sigquit) {
+    if (sigquit)
         goto finish;
-    }
 
-    if (do_cid_expire) {
-        cid_expire_seconds = config_getint(IMAPOPT_CONVERSATIONS_EXPIRE_DAYS) * 86400;
-        crock.expire_mark = time(0) - cid_expire_seconds;
-
-        if (verbose)
-            fprintf(stderr,
-                    "Removing conversation entries older than %0.2f days\n",
-                    (double)(cid_expire_seconds/86400));
-
-        if (do_user)
-            mboxlist_usermboxtree(do_user, expire_conversations, &crock, MBOXTREE_DELETED);
-        else
-            mboxlist_allmbox(find_prefix, expire_conversations, &crock, 0);
-
-        syslog(LOG_NOTICE, "Expired %lu entries of %lu entries seen "
-                            "in %lu conversation databases",
-                            crock.msgids_expired,
-                            crock.msgids_seen,
-                            crock.databases_seen);
-        if (verbose)
-            fprintf(stderr, "Expired %lu entries of %lu entries seen "
-                            "in %lu conversation databases\n",
-                            crock.msgids_expired,
-                            crock.msgids_seen,
-                            crock.databases_seen);
-    }
+    r = do_expunge(&ctx);
 
-    if (sigquit) {
+    if (sigquit)
         goto finish;
-    }
-
-    if ((delete_seconds >= 0) && mboxlist_delayed_delete_isenabled() &&
-        config_getstring(IMAPOPT_DELETEDPREFIX)) {
-        int count = 0;
-        int i;
 
-        if (verbose) {
-            fprintf(stderr,
-                    "Removing deleted mailboxes older than %0.2f days\n",
-                    ((double)delete_seconds/86400));
-        }
-
-        drock.delete_mark = time(0) - delete_seconds;
+    r = do_cid_expire(&ctx);
 
-        if (do_user)
-            mboxlist_usermboxtree(do_user, delete, &drock, MBOXTREE_DELETED);
-        else
-            mboxlist_allmbox(find_prefix, delete, &drock, 0);
-
-        for (i = 0 ; i < drock.to_delete.count ; i++) {
-            char *name = drock.to_delete.data[i];
+    if (sigquit)
+        goto finish;
 
-            if (sigquit) {
-                goto finish;
-            }
-            if (verbose) {
-                fprintf(stderr, "Removing: %s\n", name);
-            }
-            r = mboxlist_deletemailbox(name, 1, NULL, NULL, NULL, 0, 0, 0);
-            count++;
-        }
+    r = do_delete(&ctx);
 
-        if (verbose) {
-            if (count != 1) {
-                fprintf(stderr, "Removed %d deleted mailboxes\n", count);
-            } else {
-                fprintf(stderr, "Removed 1 deleted mailbox\n");
-            }
-        }
-        syslog(LOG_NOTICE, "Removed %d deleted mailboxes", count);
-    }
-    if (sigquit) {
+    if (sigquit)
         goto finish;
-    }
 
     /* purge deliver.db entries of expired messages */
-    if (expire_seconds > 0)
-        r = duplicate_prune(expire_seconds, &erock.table);
-
-finish:
-    free_hash_table(&erock.table, free);
-    free_hash_table(&crock.seen, NULL);
-    strarray_fini(&drock.to_delete);
-
-    quotadb_close();
-    quotadb_done();
-    mboxlist_close();
-    mboxlist_done();
-    annotatemore_close();
-    annotate_done();
-    duplicate_done();
-    sasl_done();
-    cyrus_done();
+    r = do_duplicate_prune(&ctx);
 
+ finish:
+    cyr_expire_cleanup(&ctx);
     exit(r);
 }
diff -pruN 3.0.13-5/imap/cyr_info.c 3.2.0-3/imap/cyr_info.c
--- 3.0.13-5/imap/cyr_info.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_info.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* ctl_info.c - tool to get information about cyrus
+/* cyr_info.c - tool to get information about cyrus
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
@@ -46,13 +46,14 @@
 #include <unistd.h>
 #endif
 #include <stdlib.h>
+#include <stdint.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "proc.h"
 #include "util.h"
 #include "../master/masterconf.h"
@@ -69,18 +70,24 @@ struct service_item {
 
 static void usage(void)
 {
-    fprintf(stderr, "cyr_info [-C <altconfig>] [-M <cyrus.conf>] [-n servicename] command\n");
+    fprintf(stderr, "cyr_info [-C <altconfig>] [-M <cyrus.conf>] [-n servicename] [-s oldversion] command\n");
     fprintf(stderr, "\n");
-    fprintf(stderr, "If you give a service name, it will show config as if you were\n");
-    fprintf(stderr, "running that service, i.e. imap\n");
+    fprintf(stderr, "If you give a service name (-n), it will show config as if you\n");
+    fprintf(stderr, "were running that service, i.e. imap\n");
+    fprintf(stderr, "\n");
+    fprintf(stderr, "If you give an old version (-s), it will highlight config\n");
+    fprintf(stderr, "options that are new or whose behaviour has changed since that\n");
+    fprintf(stderr, "version.\n");
     fprintf(stderr, "\n");
     fprintf(stderr, "Where command is one of:\n");
     fprintf(stderr, "\n");
-    fprintf(stderr, "  * conf-all      - listing of all config values\n");
     fprintf(stderr, "  * conf          - listing of non-default config values\n");
+    fprintf(stderr, "  * conf-all      - listing of all config values\n");
     fprintf(stderr, "  * conf-default  - listing of all default config values\n");
     fprintf(stderr, "  * conf-lint     - unknown config keys\n");
     fprintf(stderr, "  * proc          - listing of all open processes\n");
+    fprintf(stderr, "  * version       - Cyrus version\n");
+    fprintf(stderr, "\n");
     cyrus_done();
     exit(-1);
 }
@@ -110,7 +117,15 @@ static void print_overflow(const char *k
     printf("%s: %s\n", key, val);
 }
 
-static void do_conf(int only_changed)
+static void highlight(uint32_t version)
+{
+    printf("(%u.%u.%u) ",
+            (version >> 24) & 0xff,
+            (version >> 16) & 0xff,
+            (version >>  8) & 0xff);
+}
+
+static void do_conf(int only_changed, int want_since, uint32_t since)
 {
     int i;
     unsigned j;
@@ -123,6 +138,8 @@ static void do_conf(int only_changed)
                 if (only_changed) {
                     if (imapopts[i].def.x == imapopts[i].val.x) break;
                 }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
                 printf("%s:", imapopts[i].optname);
                 for (j = 0; imapopts[i].enum_options[j].name; j++) {
                     if (imapopts[i].val.x & (1<<j)) {
@@ -132,10 +149,22 @@ static void do_conf(int only_changed)
                 printf("\n");
                 break;
 
+            case OPT_DURATION:
+                if (only_changed) {
+                    if (0 == strcmpsafe(imapopts[i].def.s, imapopts[i].val.s))
+                        break;
+                }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
+                printf("%s: %s\n", imapopts[i].optname, imapopts[i].val.s);
+                break;
+
             case OPT_ENUM:
                 if (only_changed) {
                     if (imapopts[i].def.e == imapopts[i].val.e) break;
                 }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
                 printf("%s:", imapopts[i].optname);
                 for (j = 0; imapopts[i].enum_options[j].name; j++) {
                     if (imapopts[i].val.e == imapopts[i].enum_options[j].val) {
@@ -150,6 +179,8 @@ static void do_conf(int only_changed)
                 if (only_changed) {
                     if (imapopts[i].def.i == imapopts[i].val.i) break;
                 }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
                 printf("%s: %ld\n", imapopts[i].optname, imapopts[i].val.i);
                 break;
 
@@ -172,6 +203,8 @@ static void do_conf(int only_changed)
                     }
                     free(freeme);
                 }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
                 printf("%s: %s\n", imapopts[i].optname, imapopts[i].val.s ? imapopts[i].val.s : "");
                 break;
 
@@ -179,6 +212,8 @@ static void do_conf(int only_changed)
                 if (only_changed) {
                     if (imapopts[i].def.b == imapopts[i].val.b) break;
                 }
+                if (want_since && since < imapopts[i].last_modified)
+                    highlight(imapopts[i].last_modified);
                 printf("%s: %s\n", imapopts[i].optname, imapopts[i].val.b ? "yes" : "no");
                 break;
 
@@ -191,7 +226,7 @@ static void do_conf(int only_changed)
     config_foreachoverflowstring(print_overflow, NULL);
 }
 
-static void do_defconf(void)
+static void do_defconf(int want_since, uint32_t since)
 {
     int i;
     unsigned j;
@@ -199,6 +234,8 @@ static void do_defconf(void)
     /* XXX: this is semi-sorted, but the overflow strings aren't sorted at all */
 
     for (i = 1; i < IMAPOPT_LAST; i++) {
+        if (want_since && since < imapopts[i].last_modified)
+            highlight(imapopts[i].last_modified);
         switch (imapopts[i].t) {
             case OPT_BITFIELD:
                 printf("%s:", imapopts[i].optname);
@@ -221,10 +258,12 @@ static void do_defconf(void)
                 printf("\n");
                 break;
 
+
             case OPT_INT:
                 printf("%s: %ld\n", imapopts[i].optname, imapopts[i].def.i);
                 break;
 
+            case OPT_DURATION:
             case OPT_STRING:
             case OPT_STRINGLIST:
                 printf("%s: %s\n", imapopts[i].optname, imapopts[i].def.s ? imapopts[i].def.s : "");
@@ -291,10 +330,16 @@ static int known_saslkey(const char *key
     return 1;
 }
 
+struct lint_callback_rock {
+    struct service_item *known_services;
+    strarray_t *known_channels;
+};
+
 static void lint_callback(const char *key, const char *val, void *rock)
 {
-    struct service_item *known_services = (struct service_item *)rock;
+    struct lint_callback_rock *cbrock = (struct lint_callback_rock *) rock;
     struct service_item *svc;
+    int i;
 
     if (known_overflowkey(key)) return;
 
@@ -302,7 +347,7 @@ static void lint_callback(const char *ke
         if (known_saslkey(key+5)) return;
     }
 
-    for (svc = known_services; svc; svc = svc->next) {
+    for (svc = cbrock->known_services; svc; svc = svc->next) {
         if (!strncmp(key, svc->prefix, svc->prefixlen)) {
             /* check if it's a known key */
             if (known_regularkey(key+svc->prefixlen)) return;
@@ -310,6 +355,27 @@ static void lint_callback(const char *ke
         }
     }
 
+    for (i = 0; i < strarray_size(cbrock->known_channels); i++) {
+        const char *channel = strarray_nth(cbrock->known_channels, i);
+        size_t channel_len = strlen(channel);
+        if (!strcmp(channel, "\"\"")) {
+            /* ignore default channel, it cannot be a prefix */
+            continue;
+        }
+        else if (!strncmp(key, channel, channel_len)) {
+            /* channel prefix must be separated by an underscore */
+            if (strlen(key) <= channel_len + 1) break;
+            if (key[channel_len] != '_') break;
+
+            /* channel prefix only applies to sync_* options */
+            if (strncmp(key + channel_len + 1, "sync_", strlen("sync_"))) break;
+
+            /* check if it's a known key */
+            if (known_regularkey(key + channel_len + 1)) return;
+            if (known_overflowkey(key + channel_len + 1)) return;
+        }
+    }
+
     printf("%s: %s\n", key, val);
 }
 
@@ -327,33 +393,79 @@ static void add_service(const char *name
 
 static void do_lint(void)
 {
-    struct service_item *ks = NULL;
+    struct lint_callback_rock rock = {0};
 
     /* pull the config from cyrus.conf to get service names */
-    masterconf_getsection("SERVICES", &add_service, &ks);
+    masterconf_getsection("SERVICES", &add_service, &rock.known_services);
+
+    /* read channels from sync_log_channels config */
+    rock.known_channels = strarray_split(config_getstring(IMAPOPT_SYNC_LOG_CHANNELS),
+                                         " ", 0);
 
     /* check all overflow strings */
-    config_foreachoverflowstring(lint_callback, ks);
+    config_foreachoverflowstring(lint_callback, &rock);
 
     /* XXX - check directories and permissions? */
 
     /* clean up */
+    struct service_item *ks = rock.known_services;
     while (ks) {
         struct service_item *next = ks->next;
         free(ks->prefix);
         free(ks);
         ks = next;
     }
+    strarray_free(rock.known_channels);
+}
+
+static uint32_t parse_since_version(const char *str)
+{
+    unsigned parts[3] = {0}, i;
+    const char *p;
+    int saw_digit = 0;
+    size_t pnlen = strlen(PACKAGE_NAME);
+
+    /* politely strip 'cyrus-imapd[- ]' from start of version string */
+    if (!strncmp(str, PACKAGE_NAME, pnlen)
+            && (str[pnlen] == '-' || str[pnlen] == ' '))
+        str += pnlen + 1;
+
+    for (p = str, i = 0; *p; p++) {
+        if (cyrus_isdigit(*p)) {
+            saw_digit++;
+            parts[i] *= 10;
+            parts[i] += *p - '0';
+            if (parts[i] > 255) usage();
+        }
+        else if (*p == '.') {
+            if (!saw_digit) usage();
+            saw_digit = 0;
+            if (++i > 2) break;
+        }
+        else if (*p == '-') {
+            break;
+        }
+        else {
+            usage();
+        }
+    }
+
+    return (parts[0] & 0xff) * 0x01000000
+        +  (parts[1] & 0xff) * 0x00010000
+        +  (parts[2] & 0xff) * 0x00000100
+        +  0;
 }
 
 int main(int argc, char *argv[])
 {
     extern char *optarg;
     int opt;
-    char *alt_config = NULL;
-    char *srvname = "cyr_info";
+    const char *alt_config = NULL;
+    const char *srvname = "cyr_info";
+    uint32_t since = 0;
+    int want_since = 0;
 
-    while ((opt = getopt(argc, argv, "C:M:n:")) != EOF) {
+    while ((opt = getopt(argc, argv, "C:M:n:s:")) != EOF) {
         switch (opt) {
         case 'C': /* alt config file */
             alt_config = optarg;
@@ -367,25 +479,36 @@ int main(int argc, char *argv[])
             srvname = optarg;
             break;
 
+        case 's':
+            want_since = 1;
+            since = parse_since_version(optarg);
+            break;
+
         default:
             usage();
             break;
         }
     }
 
-    cyrus_init(alt_config, srvname, 0, 0);
-
     if (optind >= argc)
         usage();
 
+    /* we don't need to read config to handle this one */
+    if (!strcmp(argv[optind], "version")) {
+        printf("%s %s\n", PACKAGE_NAME, CYRUS_VERSION);
+        return 0;
+    }
+
+    cyrus_init(alt_config, srvname, 0, 0);
+
     if (!strcmp(argv[optind], "proc"))
         do_proc();
     else if (!strcmp(argv[optind], "conf-all"))
-        do_conf(0);
+        do_conf(0, want_since, since);
     else if (!strcmp(argv[optind], "conf"))
-        do_conf(1);
+        do_conf(1, want_since, since);
     else if (!strcmp(argv[optind], "conf-default"))
-        do_defconf();
+        do_defconf(want_since, since);
     else if (!strcmp(argv[optind], "conf-lint"))
         do_lint();
     else
diff -pruN 3.0.13-5/imap/cyr_sphinxmgr.c 3.2.0-3/imap/cyr_sphinxmgr.c
--- 3.0.13-5/imap/cyr_sphinxmgr.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_sphinxmgr.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1382 +0,0 @@
-/* cyr_sphinxmgr.c - daemon for managing Sphinx index daemons
- *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <sys/types.h>
-#include <syslog.h>
-#include <sys/stat.h>
-#include <sys/socket.h>
-#include <sys/un.h>
-#include <stdlib.h>
-#include <errno.h>
-#ifdef HAVE_UNISTD_H
-#include <unistd.h>
-#endif
-#include <signal.h>
-#include <fcntl.h>
-#include <sys/poll.h>
-
-#include "mboxname.h"
-#include "mboxlist.h"
-#include "global.h"
-#include "retry.h"
-#include "command.h"
-#include "xstrlcat.h"
-#include "xstrlcpy.h"
-#include "xmalloc.h"
-#include "hash.h"
-#include "exitcodes.h"
-
-/* generated headers are not necessarily in current directory */
-#include "imap/imap_err.h"
-
-/* Various locations, relative to the Sphinx base directory */
-#define SOCKET_PATH         "/searchd.sock"
-#define SPHINX_CONFIG       "/sphinx.conf"
-#define SPHINX_PIDFILE      "/searchd.pid"
-#define SEARCHD             "/usr/bin/searchd"
-
-#define STOPWAIT_DELAY_MS   50  /* 50 millisec */
-#define STOPWAIT_MAX_TRIES  (20*1000/STOPWAIT_DELAY_MS) /* 20 sec */
-
-extern int optind;
-extern char *optarg;
-
-static int verbose = 0;
-static int server_sock;
-static int sphinx_timeout;
-static int max_children;
-static int num_started; /* number of children in STARTED state */
-static const char *syslog_prefix;
-
-typedef struct indexd indexd_t;
-struct indexd {
-    /* There is no visible STARTING state because
-     * starting searchd is synchronous */
-    enum { STOPPED, STARTED, STOPPING } state;
-    char *basedir;      /* also used as the key */
-    char *socketpath;
-    time_t started;     /* for debugging */
-    time_t used;
-    time_t stopped;     /* when entered STOPPING state; for debugging */
-    struct indexd *prev;
-    struct indexd *next;
-};
-static struct hash_table itable;
-
-static struct indexd indexroot;
-
-static void shut_down(int code) __attribute__((noreturn));
-static int indexd_is_running(indexd_t *id);
-
-void fatal(const char *msg, int err)
-{
-    syslog(LOG_ERR, "Fatal error %s, exiting", msg);
-    shut_down(err);
-}
-
-static void indexd_free(indexd_t *id)
-{
-    free(id->basedir);
-    free(id->socketpath);
-    free(id);
-}
-
-static void indexd_set_state(indexd_t *id, unsigned state)
-{
-    if (id->state != state) {
-        if (id->state == STARTED)
-            num_started--;
-
-        id->state = state;
-
-        if (id->state == STARTED)
-            num_started++;
-    }
-}
-
-static int indexd_setup_tree(indexd_t *id)
-{
-    static const char * const tobuild[] = {
-        "",
-        "/binlog",
-        NULL
-    };
-    const char * const *dp;
-    char *path = NULL;
-    int r;
-
-    if (verbose > 1)
-        syslog(LOG_INFO, "setting up tree");
-    for (dp = tobuild ; *dp ; dp++) {
-        free(path);
-        path = strconcat(id->basedir, *dp, "/filename",  (char *)NULL);
-        r = cyrus_mkdir(path, 0700);
-        if (r < 0 && errno != EEXIST) {
-            syslog(LOG_ERR, "IOERROR: unable to mkdir %s: %m", path);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-    }
-    r = 0;
-
-out:
-    free(path);
-    return r;
-}
-
-static int indexd_setup_config(indexd_t *id)
-{
-    static const char config[] =
-        "index rt\n"
-        "{\n"
-        "    type = rt\n"
-        "    source = fmindex\n"
-        "    path = $sphinxdir/rt\n"
-        "    morphology = stem_en\n"
-        "    charset_type = utf-8\n"
-        "    charset_table = 0..9, A..Z->a..z, _, a..z, \\\n"
-        /* Support for Cyrillic from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cyrillic */
-        "       U+0400->U+0435, U+0401->U+0435, U+0402->U+0452, U+0452, \\\n"
-        "       U+0403->U+0433, U+0404->U+0454, U+0454, U+0405->U+0455, \\\n"
-        "       U+0455, U+0406->U+0456, U+0407->U+0456, U+0457->U+0456, \\\n"
-        "       U+0456, U+0408..U+040B->U+0458..U+045B, U+0458..U+045B, \\\n"
-        "       U+040C->U+043A, U+040D->U+0438, U+040E->U+0443, U+040F->U+045F, \\\n"
-        "       U+045F, U+0450->U+0435, U+0451->U+0435, U+0453->U+0433, \\\n"
-        "       U+045C->U+043A, U+045D->U+0438, U+045E->U+0443, U+0460->U+0461, \\\n"
-        "       U+0461, U+0462->U+0463, U+0463, U+0464->U+0465, U+0465, \\\n"
-        "       U+0466->U+0467, U+0467, U+0468->U+0469, U+0469, U+046A->U+046B, \\\n"
-        "       U+046B, U+046C->U+046D, U+046D, U+046E->U+046F, U+046F, \\\n"
-        "       U+0470->U+0471, U+0471, U+0472->U+0473, U+0473, U+0474->U+0475, \\\n"
-        "       U+0476->U+0475, U+0477->U+0475, U+0475, U+0478->U+0479, U+0479, \\\n"
-        "       U+047A->U+047B, U+047B, U+047C->U+047D, U+047D, U+047E->U+047F, \\\n"
-        "       U+047F, U+0480->U+0481, U+0481, U+048A->U+0438, U+048B->U+0438, \\\n"
-        "       U+048C->U+044C, U+048D->U+044C, U+048E->U+0440, U+048F->U+0440, \\\n"
-        "       U+0490->U+0433, U+0491->U+0433, U+0490->U+0433, U+0491->U+0433, \\\n"
-        "       U+0492->U+0433, U+0493->U+0433, U+0494->U+0433, U+0495->U+0433, \\\n"
-        "       U+0496->U+0436, U+0497->U+0436, U+0498->U+0437, U+0499->U+0437, \\\n"
-        "       U+049A->U+043A, U+049B->U+043A, U+049C->U+043A, U+049D->U+043A, \\\n"
-        "       U+049E->U+043A, U+049F->U+043A, U+04A0->U+043A, U+04A1->U+043A, \\\n"
-        "       U+04A2->U+043D, U+04A3->U+043D, U+04A4->U+043D, U+04A5->U+043D, \\\n"
-        "       U+04A6->U+043F, U+04A7->U+043F, U+04A8->U+04A9, U+04A9, \\\n"
-        "       U+04AA->U+0441, U+04AB->U+0441, U+04AC->U+0442, U+04AD->U+0442, \\\n"
-        "       U+04AE->U+0443, U+04AF->U+0443, U+04B0->U+0443, U+04B1->U+0443, \\\n"
-        "       U+04B2->U+0445, U+04B3->U+0445, U+04B4->U+04B5, U+04B5, \\\n"
-        "       U+04B6->U+0447, U+04B7->U+0447, U+04B8->U+0447, U+04B9->U+0447, \\\n"
-        "       U+04BA->U+04BB, U+04BB, U+04BC->U+04BD, U+04BE->U+04BD, \\\n"
-        "       U+04BF->U+04BD, U+04BD, U+04C0->U+04CF, U+04CF, U+04C1->U+0436, \\\n"
-        "       U+04C2->U+0436, U+04C3->U+043A, U+04C4->U+043A, U+04C5->U+043B, \\\n"
-        "       U+04C6->U+043B, U+04C7->U+043D, U+04C8->U+043D, U+04C9->U+043D, \\\n"
-        "       U+04CA->U+043D, U+04CB->U+0447, U+04CC->U+0447, U+04CD->U+043C, \\\n"
-        "       U+04CE->U+043C, U+04D0->U+0430, U+04D1->U+0430, U+04D2->U+0430, \\\n"
-        "       U+04D3->U+0430, U+04D4->U+00E6, U+04D5->U+00E6, U+04D6->U+0435, \\\n"
-        "       U+04D7->U+0435, U+04D8->U+04D9, U+04DA->U+04D9, U+04DB->U+04D9, \\\n"
-        "       U+04D9, U+04DC->U+0436, U+04DD->U+0436, U+04DE->U+0437, \\\n"
-        "       U+04DF->U+0437, U+04E0->U+04E1, U+04E1, U+04E2->U+0438, \\\n"
-        "       U+04E3->U+0438, U+04E4->U+0438, U+04E5->U+0438, U+04E6->U+043E, \\\n"
-        "       U+04E7->U+043E, U+04E8->U+043E, U+04E9->U+043E, U+04EA->U+043E, \\\n"
-        "       U+04EB->U+043E, U+04EC->U+044D, U+04ED->U+044D, U+04EE->U+0443, \\\n"
-        "       U+04EF->U+0443, U+04F0->U+0443, U+04F1->U+0443, U+04F2->U+0443, \\\n"
-        "       U+04F3->U+0443, U+04F4->U+0447, U+04F5->U+0447, U+04F6->U+0433, \\\n"
-        "       U+04F7->U+0433, U+04F8->U+044B, U+04F9->U+044B, U+04FA->U+0433, \\\n"
-        "       U+04FB->U+0433, U+04FC->U+0445, U+04FD->U+0445, U+04FE->U+0445, \\\n"
-        "       U+04FF->U+0445, U+0410..U+0418->U+0430..U+0438, U+0419->U+0438, \\\n"
-        "       U+0430..U+0438, U+041A..U+042F->U+043A..U+044F, U+043A..U+044F,\\\n"
-        /* and this one was missing dammit */
-        "       U+0418->U+0438, U+0439->U+0438, \\\n"
-        /* Sumerian cuneiform which is fun for testing but seems
-         * to be broken in Spinx. */
-        /*
-        "       U+12000..U+1237F, \\\n"
-        */
-        /* Support for Chinese/Japanese/Korean, from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cjk */
-        "       U+F900->U+8C48, U+F901->U+66F4, U+F902->U+8ECA, U+F903->U+8CC8, \\\n"
-        "       U+F904->U+6ED1, U+F905->U+4E32, U+F906->U+53E5, U+F907->U+9F9C, \\\n"
-        "       U+F908->U+9F9C, U+F909->U+5951, U+F90A->U+91D1, U+F90B->U+5587, \\\n"
-        "       U+F90C->U+5948, U+F90D->U+61F6, U+F90E->U+7669, U+F90F->U+7F85, \\\n"
-        "       U+F910->U+863F, U+F911->U+87BA, U+F912->U+88F8, U+F913->U+908F, \\\n"
-        "       U+F914->U+6A02, U+F915->U+6D1B, U+F916->U+70D9, U+F917->U+73DE, \\\n"
-        "       U+F918->U+843D, U+F919->U+916A, U+F91A->U+99F1, U+F91B->U+4E82, \\\n"
-        "       U+F91C->U+5375, U+F91D->U+6B04, U+F91E->U+721B, U+F91F->U+862D, \\\n"
-        "       U+F920->U+9E1E, U+F921->U+5D50, U+F922->U+6FEB, U+F923->U+85CD, \\\n"
-        "       U+F924->U+8964, U+F925->U+62C9, U+F926->U+81D8, U+F927->U+881F, \\\n"
-        "       U+F928->U+5ECA, U+F929->U+6717, U+F92A->U+6D6A, U+F92B->U+72FC, \\\n"
-        "       U+F92C->U+90CE, U+F92D->U+4F86, U+F92E->U+51B7, U+F92F->U+52DE, \\\n"
-        "       U+F930->U+64C4, U+F931->U+6AD3, U+F932->U+7210, U+F933->U+76E7, \\\n"
-        "       U+F934->U+8001, U+F935->U+8606, U+F936->U+865C, U+F937->U+8DEF, \\\n"
-        "       U+F938->U+9732, U+F939->U+9B6F, U+F93A->U+9DFA, U+F93B->U+788C, \\\n"
-        "       U+F93C->U+797F, U+F93D->U+7DA0, U+F93E->U+83C9, U+F93F->U+9304, \\\n"
-        "       U+F940->U+9E7F, U+F941->U+8AD6, U+F942->U+58DF, U+F943->U+5F04, \\\n"
-        "       U+F944->U+7C60, U+F945->U+807E, U+F946->U+7262, U+F947->U+78CA, \\\n"
-        "       U+F948->U+8CC2, U+F949->U+96F7, U+F94A->U+58D8, U+F94B->U+5C62, \\\n"
-        "       U+F94C->U+6A13, U+F94D->U+6DDA, U+F94E->U+6F0F, U+F94F->U+7D2F, \\\n"
-        "       U+F950->U+7E37, U+F951->U+964B, U+F952->U+52D2, U+F953->U+808B, \\\n"
-        "       U+F954->U+51DC, U+F955->U+51CC, U+F956->U+7A1C, U+F957->U+7DBE, \\\n"
-        "       U+F958->U+83F1, U+F959->U+9675, U+F95A->U+8B80, U+F95B->U+62CF, \\\n"
-        "       U+F95C->U+6A02, U+F95D->U+8AFE, U+F95E->U+4E39, U+F95F->U+5BE7, \\\n"
-        "       U+F960->U+6012, U+F961->U+7387, U+F962->U+7570, U+F963->U+5317, \\\n"
-        "       U+F964->U+78FB, U+F965->U+4FBF, U+F966->U+5FA9, U+F967->U+4E0D, \\\n"
-        "       U+F968->U+6CCC, U+F969->U+6578, U+F96A->U+7D22, U+F96B->U+53C3, \\\n"
-        "       U+F96C->U+585E, U+F96D->U+7701, U+F96E->U+8449, U+F96F->U+8AAA, \\\n"
-        "       U+F970->U+6BBA, U+F971->U+8FB0, U+F972->U+6C88, U+F973->U+62FE, \\\n"
-        "       U+F974->U+82E5, U+F975->U+63A0, U+F976->U+7565, U+F977->U+4EAE, \\\n"
-        "       U+F978->U+5169, U+F979->U+51C9, U+F97A->U+6881, U+F97B->U+7CE7, \\\n"
-        "       U+F97C->U+826F, U+F97D->U+8AD2, U+F97E->U+91CF, U+F97F->U+52F5, \\\n"
-        "       U+F980->U+5442, U+F981->U+5973, U+F982->U+5EEC, U+F983->U+65C5, \\\n"
-        "       U+F984->U+6FFE, U+F985->U+792A, U+F986->U+95AD, U+F987->U+9A6A, \\\n"
-        "       U+F988->U+9E97, U+F989->U+9ECE, U+F98A->U+529B, U+F98B->U+66C6, \\\n"
-        "       U+F98C->U+6B77, U+F98D->U+8F62, U+F98E->U+5E74, U+F98F->U+6190, \\\n"
-        "       U+F990->U+6200, U+F991->U+649A, U+F992->U+6F23, U+F993->U+7149, \\\n"
-        "       U+F994->U+7489, U+F995->U+79CA, U+F996->U+7DF4, U+F997->U+806F, \\\n"
-        "       U+F998->U+8F26, U+F999->U+84EE, U+F99A->U+9023, U+F99B->U+934A, \\\n"
-        "       U+F99C->U+5217, U+F99D->U+52A3, U+F99E->U+54BD, U+F99F->U+70C8, \\\n"
-        "       U+F9A0->U+88C2, U+F9A1->U+8AAA, U+F9A2->U+5EC9, U+F9A3->U+5FF5, \\\n"
-        "       U+F9A4->U+637B, U+F9A5->U+6BAE, U+F9A6->U+7C3E, U+F9A7->U+7375, \\\n"
-        "       U+F9A8->U+4EE4, U+F9A9->U+56F9, U+F9AA->U+5BE7, U+F9AB->U+5DBA, \\\n"
-        "       U+F9AC->U+601C, U+F9AD->U+73B2, U+F9AE->U+7469, U+F9AF->U+7F9A, \\\n"
-        "       U+F9B0->U+8046, U+F9B1->U+9234, U+F9B2->U+96F6, U+F9B3->U+9748, \\\n"
-        "       U+F9B4->U+9818, U+F9B5->U+4F8B, U+F9B6->U+79AE, U+F9B7->U+91B4, \\\n"
-        "       U+F9B8->U+96B8, U+F9B9->U+60E1, U+F9BA->U+4E86, U+F9BB->U+50DA, \\\n"
-        "       U+F9BC->U+5BEE, U+F9BD->U+5C3F, U+F9BE->U+6599, U+F9BF->U+6A02, \\\n"
-        "       U+F9C0->U+71CE, U+F9C1->U+7642, U+F9C2->U+84FC, U+F9C3->U+907C, \\\n"
-        "       U+F9C4->U+9F8D, U+F9C5->U+6688, U+F9C6->U+962E, U+F9C7->U+5289, \\\n"
-        "       U+F9C8->U+677B, U+F9C9->U+67F3, U+F9CA->U+6D41, U+F9CB->U+6E9C, \\\n"
-        "       U+F9CC->U+7409, U+F9CD->U+7559, U+F9CE->U+786B, U+F9CF->U+7D10, \\\n"
-        "       U+F9D0->U+985E, U+F9D1->U+516D, U+F9D2->U+622E, U+F9D3->U+9678, \\\n"
-        "       U+F9D4->U+502B, U+F9D5->U+5D19, U+F9D6->U+6DEA, U+F9D7->U+8F2A, \\\n"
-        "       U+F9D8->U+5F8B, U+F9D9->U+6144, U+F9DA->U+6817, U+F9DB->U+7387, \\\n"
-        "       U+F9DC->U+9686, U+F9DD->U+5229, U+F9DE->U+540F, U+F9DF->U+5C65, \\\n"
-        "       U+F9E0->U+6613, U+F9E1->U+674E, U+F9E2->U+68A8, U+F9E3->U+6CE5, \\\n"
-        "       U+F9E4->U+7406, U+F9E5->U+75E2, U+F9E6->U+7F79, U+F9E7->U+88CF, \\\n"
-        "       U+F9E8->U+88E1, U+F9E9->U+91CC, U+F9EA->U+96E2, U+F9EB->U+533F, \\\n"
-        "       U+F9EC->U+6EBA, U+F9ED->U+541D, U+F9EE->U+71D0, U+F9EF->U+7498, \\\n"
-        "       U+F9F0->U+85FA, U+F9F1->U+96A3, U+F9F2->U+9C57, U+F9F3->U+9E9F, \\\n"
-        "       U+F9F4->U+6797, U+F9F5->U+6DCB, U+F9F6->U+81E8, U+F9F7->U+7ACB, \\\n"
-        "       U+F9F8->U+7B20, U+F9F9->U+7C92, U+F9FA->U+72C0, U+F9FB->U+7099, \\\n"
-        "       U+F9FC->U+8B58, U+F9FD->U+4EC0, U+F9FE->U+8336, U+F9FF->U+523A, \\\n"
-        "       U+FA00->U+5207, U+FA01->U+5EA6, U+FA02->U+62D3, U+FA03->U+7CD6, \\\n"
-        "       U+FA04->U+5B85, U+FA05->U+6D1E, U+FA06->U+66B4, U+FA07->U+8F3B, \\\n"
-        "       U+FA08->U+884C, U+FA09->U+964D, U+FA0A->U+898B, U+FA0B->U+5ED3, \\\n"
-        "       U+FA0C->U+5140, U+FA0D->U+55C0, U+FA10->U+585A, U+FA12->U+6674, \\\n"
-        "       U+FA15->U+51DE, U+FA16->U+732A, U+FA17->U+76CA, U+FA18->U+793C, \\\n"
-        "       U+FA19->U+795E, U+FA1A->U+7965, U+FA1B->U+798F, U+FA1C->U+9756, \\\n"
-        "       U+FA1D->U+7CBE, U+FA1E->U+7FBD, U+FA20->U+8612, U+FA22->U+8AF8, \\\n"
-        "       U+FA25->U+9038, U+FA26->U+90FD, U+FA2A->U+98EF, U+FA2B->U+98FC, \\\n"
-        "       U+FA2C->U+9928, U+FA2D->U+9DB4, U+FA30->U+4FAE, U+FA31->U+50E7, \\\n"
-        "       U+FA32->U+514D, U+FA33->U+52C9, U+FA34->U+52E4, U+FA35->U+5351, \\\n"
-        "       U+FA36->U+559D, U+FA37->U+5606, U+FA38->U+5668, U+FA39->U+5840, \\\n"
-        "       U+FA3A->U+58A8, U+FA3B->U+5C64, U+FA3C->U+5C6E, U+FA3D->U+6094, \\\n"
-        "       U+FA3E->U+6168, U+FA3F->U+618E, U+FA40->U+61F2, U+FA41->U+654F, \\\n"
-        "       U+FA42->U+65E2, U+FA43->U+6691, U+FA44->U+6885, U+FA45->U+6D77, \\\n"
-        "       U+FA46->U+6E1A, U+FA47->U+6F22, U+FA48->U+716E, U+FA49->U+722B, \\\n"
-        "       U+FA4A->U+7422, U+FA4B->U+7891, U+FA4C->U+793E, U+FA4D->U+7949, \\\n"
-        "       U+FA4E->U+7948, U+FA4F->U+7950, U+FA50->U+7956, U+FA51->U+795D, \\\n"
-        "       U+FA52->U+798D, U+FA53->U+798E, U+FA54->U+7A40, U+FA55->U+7A81, \\\n"
-        "       U+FA56->U+7BC0, U+FA57->U+7DF4, U+FA58->U+7E09, U+FA59->U+7E41, \\\n"
-        "       U+FA5A->U+7F72, U+FA5B->U+8005, U+FA5C->U+81ED, U+FA5D->U+8279, \\\n"
-        "       U+FA5E->U+8279, U+FA5F->U+8457, U+FA60->U+8910, U+FA61->U+8996, \\\n"
-        "       U+FA62->U+8B01, U+FA63->U+8B39, U+FA64->U+8CD3, U+FA65->U+8D08, \\\n"
-        "       U+FA66->U+8FB6, U+FA67->U+9038, U+FA68->U+96E3, U+FA69->U+97FF, \\\n"
-        "       U+FA6A->U+983B, U+FA70->U+4E26, U+FA71->U+51B5, U+FA72->U+5168, \\\n"
-        "       U+FA73->U+4F80, U+FA74->U+5145, U+FA75->U+5180, U+FA76->U+52C7, \\\n"
-        "       U+FA77->U+52FA, U+FA78->U+559D, U+FA79->U+5555, U+FA7A->U+5599, \\\n"
-        "       U+FA7B->U+55E2, U+FA7C->U+585A, U+FA7D->U+58B3, U+FA7E->U+5944, \\\n"
-        "       U+FA7F->U+5954, U+FA80->U+5A62, U+FA81->U+5B28, U+FA82->U+5ED2, \\\n"
-        "       U+FA83->U+5ED9, U+FA84->U+5F69, U+FA85->U+5FAD, U+FA86->U+60D8, \\\n"
-        "       U+FA87->U+614E, U+FA88->U+6108, U+FA89->U+618E, U+FA8A->U+6160, \\\n"
-        "       U+FA8B->U+61F2, U+FA8C->U+6234, U+FA8D->U+63C4, U+FA8E->U+641C, \\\n"
-        "       U+FA8F->U+6452, U+FA90->U+6556, U+FA91->U+6674, U+FA92->U+6717, \\\n"
-        "       U+FA93->U+671B, U+FA94->U+6756, U+FA95->U+6B79, U+FA96->U+6BBA, \\\n"
-        "       U+FA97->U+6D41, U+FA98->U+6EDB, U+FA99->U+6ECB, U+FA9A->U+6F22, \\\n"
-        "       U+FA9B->U+701E, U+FA9C->U+716E, U+FA9D->U+77A7, U+FA9E->U+7235, \\\n"
-        "       U+FA9F->U+72AF, U+FAA0->U+732A, U+FAA1->U+7471, U+FAA2->U+7506, \\\n"
-        "       U+FAA3->U+753B, U+FAA4->U+761D, U+FAA5->U+761F, U+FAA6->U+76CA, \\\n"
-        "       U+FAA7->U+76DB, U+FAA8->U+76F4, U+FAA9->U+774A, U+FAAA->U+7740, \\\n"
-        "       U+FAAB->U+78CC, U+FAAC->U+7AB1, U+FAAD->U+7BC0, U+FAAE->U+7C7B, \\\n"
-        "       U+FAAF->U+7D5B, U+FAB0->U+7DF4, U+FAB1->U+7F3E, U+FAB2->U+8005, \\\n"
-        "       U+FAB3->U+8352, U+FAB4->U+83EF, U+FAB5->U+8779, U+FAB6->U+8941, \\\n"
-        "       U+FAB7->U+8986, U+FAB8->U+8996, U+FAB9->U+8ABF, U+FABA->U+8AF8, \\\n"
-        "       U+FABB->U+8ACB, U+FABC->U+8B01, U+FABD->U+8AFE, U+FABE->U+8AED, \\\n"
-        "       U+FABF->U+8B39, U+FAC0->U+8B8A, U+FAC1->U+8D08, U+FAC2->U+8F38, \\\n"
-        "       U+FAC3->U+9072, U+FAC4->U+9199, U+FAC5->U+9276, U+FAC6->U+967C, \\\n"
-        "       U+FAC7->U+96E3, U+FAC8->U+9756, U+FAC9->U+97DB, U+FACA->U+97FF, \\\n"
-        "       U+FACB->U+980B, U+FACC->U+983B, U+FACD->U+9B12, U+FACE->U+9F9C, \\\n"
-        "       U+FACF->U+2284A, U+FAD0->U+22844, U+FAD1->U+233D5, U+FAD2->U+3B9D, \\\n"
-        "       U+FAD3->U+4018, U+FAD4->U+4039, U+FAD5->U+25249, U+FAD6->U+25CD0, \\\n"
-        "       U+FAD7->U+27ED3, U+FAD8->U+9F43, U+FAD9->U+9F8E, U+2F800->U+4E3D, \\\n"
-        "       U+2F801->U+4E38, U+2F802->U+4E41, U+2F803->U+20122, U+2F804->U+4F60, \\\n"
-        "       U+2F805->U+4FAE, U+2F806->U+4FBB, U+2F807->U+5002, U+2F808->U+507A, \\\n"
-        "       U+2F809->U+5099, U+2F80A->U+50E7, U+2F80B->U+50CF, U+2F80C->U+349E, \\\n"
-        "       U+2F80D->U+2063A, U+2F80E->U+514D, U+2F80F->U+5154, U+2F810->U+5164, \\\n"
-        "       U+2F811->U+5177, U+2F812->U+2051C, U+2F813->U+34B9, U+2F814->U+5167, \\\n"
-        "       U+2F815->U+518D, U+2F816->U+2054B, U+2F817->U+5197, U+2F818->U+51A4, \\\n"
-        "       U+2F819->U+4ECC, U+2F81A->U+51AC, U+2F81B->U+51B5, U+2F81C->U+291DF, \\\n"
-        "       U+2F81D->U+51F5, U+2F81E->U+5203, U+2F81F->U+34DF, U+2F820->U+523B, \\\n"
-        "       U+2F821->U+5246, U+2F822->U+5272, U+2F823->U+5277, U+2F824->U+3515, \\\n"
-        "       U+2F825->U+52C7, U+2F826->U+52C9, U+2F827->U+52E4, U+2F828->U+52FA, \\\n"
-        "       U+2F829->U+5305, U+2F82A->U+5306, U+2F82B->U+5317, U+2F82C->U+5349, \\\n"
-        "       U+2F82D->U+5351, U+2F82E->U+535A, U+2F82F->U+5373, U+2F830->U+537D, \\\n"
-        "       U+2F831->U+537F, U+2F832->U+537F, U+2F833->U+537F, U+2F834->U+20A2C, \\\n"
-        "       U+2F835->U+7070, U+2F836->U+53CA, U+2F837->U+53DF, U+2F838->U+20B63, \\\n"
-        "       U+2F839->U+53EB, U+2F83A->U+53F1, U+2F83B->U+5406, U+2F83C->U+549E, \\\n"
-        "       U+2F83D->U+5438, U+2F83E->U+5448, U+2F83F->U+5468, U+2F840->U+54A2, \\\n"
-        "       U+2F841->U+54F6, U+2F842->U+5510, U+2F843->U+5553, U+2F844->U+5563, \\\n"
-        "       U+2F845->U+5584, U+2F846->U+5584, U+2F847->U+5599, U+2F848->U+55AB, \\\n"
-        "       U+2F849->U+55B3, U+2F84A->U+55C2, U+2F84B->U+5716, U+2F84C->U+5606, \\\n"
-        "       U+2F84D->U+5717, U+2F84E->U+5651, U+2F84F->U+5674, U+2F850->U+5207, \\\n"
-        "       U+2F851->U+58EE, U+2F852->U+57CE, U+2F853->U+57F4, U+2F854->U+580D, \\\n"
-        "       U+2F855->U+578B, U+2F856->U+5832, U+2F857->U+5831, U+2F858->U+58AC, \\\n"
-        "       U+2F859->U+214E4, U+2F85A->U+58F2, U+2F85B->U+58F7, U+2F85C->U+5906, \\\n"
-        "       U+2F85D->U+591A, U+2F85E->U+5922, U+2F85F->U+5962, U+2F860->U+216A8, \\\n"
-        "       U+2F861->U+216EA, U+2F862->U+59EC, U+2F863->U+5A1B, U+2F864->U+5A27, \\\n"
-        "       U+2F865->U+59D8, U+2F866->U+5A66, U+2F867->U+36EE, U+2F868->U+36FC, \\\n"
-        "       U+2F869->U+5B08, U+2F86A->U+5B3E, U+2F86B->U+5B3E, U+2F86C->U+219C8, \\\n"
-        "       U+2F86D->U+5BC3, U+2F86E->U+5BD8, U+2F86F->U+5BE7, U+2F870->U+5BF3, \\\n"
-        "       U+2F871->U+21B18, U+2F872->U+5BFF, U+2F873->U+5C06, U+2F874->U+5F53, \\\n"
-        "       U+2F875->U+5C22, U+2F876->U+3781, U+2F877->U+5C60, U+2F878->U+5C6E, \\\n"
-        "       U+2F879->U+5CC0, U+2F87A->U+5C8D, U+2F87B->U+21DE4, U+2F87C->U+5D43, \\\n"
-        "       U+2F87D->U+21DE6, U+2F87E->U+5D6E, U+2F87F->U+5D6B, U+2F880->U+5D7C, \\\n"
-        "       U+2F881->U+5DE1, U+2F882->U+5DE2, U+2F883->U+382F, U+2F884->U+5DFD, \\\n"
-        "       U+2F885->U+5E28, U+2F886->U+5E3D, U+2F887->U+5E69, U+2F888->U+3862, \\\n"
-        "       U+2F889->U+22183, U+2F88A->U+387C, U+2F88B->U+5EB0, U+2F88C->U+5EB3, \\\n"
-        "       U+2F88D->U+5EB6, U+2F88E->U+5ECA, U+2F88F->U+2A392, U+2F890->U+5EFE, \\\n"
-        "       U+2F891->U+22331, U+2F892->U+22331, U+2F893->U+8201, U+2F894->U+5F22, \\\n"
-        "       U+2F895->U+5F22, U+2F896->U+38C7, U+2F897->U+232B8, U+2F898->U+261DA, \\\n"
-        "       U+2F899->U+5F62, U+2F89A->U+5F6B, U+2F89B->U+38E3, U+2F89C->U+5F9A, \\\n"
-        "       U+2F89D->U+5FCD, U+2F89E->U+5FD7, U+2F89F->U+5FF9, U+2F8A0->U+6081, \\\n"
-        "       U+2F8A1->U+393A, U+2F8A2->U+391C, U+2F8A3->U+6094, U+2F8A4->U+226D4, \\\n"
-        "       U+2F8A5->U+60C7, U+2F8A6->U+6148, U+2F8A7->U+614C, U+2F8A8->U+614E, \\\n"
-        "       U+2F8A9->U+614C, U+2F8AA->U+617A, U+2F8AB->U+618E, U+2F8AC->U+61B2, \\\n"
-        "       U+2F8AD->U+61A4, U+2F8AE->U+61AF, U+2F8AF->U+61DE, U+2F8B0->U+61F2, \\\n"
-        "       U+2F8B1->U+61F6, U+2F8B2->U+6210, U+2F8B3->U+621B, U+2F8B4->U+625D, \\\n"
-        "       U+2F8B5->U+62B1, U+2F8B6->U+62D4, U+2F8B7->U+6350, U+2F8B8->U+22B0C, \\\n"
-        "       U+2F8B9->U+633D, U+2F8BA->U+62FC, U+2F8BB->U+6368, U+2F8BC->U+6383, \\\n"
-        "       U+2F8BD->U+63E4, U+2F8BE->U+22BF1, U+2F8BF->U+6422, U+2F8C0->U+63C5, \\\n"
-        "       U+2F8C1->U+63A9, U+2F8C2->U+3A2E, U+2F8C3->U+6469, U+2F8C4->U+647E, \\\n"
-        "       U+2F8C5->U+649D, U+2F8C6->U+6477, U+2F8C7->U+3A6C, U+2F8C8->U+654F, \\\n"
-        "       U+2F8C9->U+656C, U+2F8CA->U+2300A, U+2F8CB->U+65E3, U+2F8CC->U+66F8, \\\n"
-        "       U+2F8CD->U+6649, U+2F8CE->U+3B19, U+2F8CF->U+6691, U+2F8D0->U+3B08, \\\n"
-        "       U+2F8D1->U+3AE4, U+2F8D2->U+5192, U+2F8D3->U+5195, U+2F8D4->U+6700, \\\n"
-        "       U+2F8D5->U+669C, U+2F8D6->U+80AD, U+2F8D7->U+43D9, U+2F8D8->U+6717, \\\n"
-        "       U+2F8D9->U+671B, U+2F8DA->U+6721, U+2F8DB->U+675E, U+2F8DC->U+6753, \\\n"
-        "       U+2F8DD->U+233C3, U+2F8DE->U+3B49, U+2F8DF->U+67FA, U+2F8E0->U+6785, \\\n"
-        "       U+2F8E1->U+6852, U+2F8E2->U+6885, U+2F8E3->U+2346D, U+2F8E4->U+688E, \\\n"
-        "       U+2F8E5->U+681F, U+2F8E6->U+6914, U+2F8E7->U+3B9D, U+2F8E8->U+6942, \\\n"
-        "       U+2F8E9->U+69A3, U+2F8EA->U+69EA, U+2F8EB->U+6AA8, U+2F8EC->U+236A3, \\\n"
-        "       U+2F8ED->U+6ADB, U+2F8EE->U+3C18, U+2F8EF->U+6B21, U+2F8F0->U+238A7, \\\n"
-        "       U+2F8F1->U+6B54, U+2F8F2->U+3C4E, U+2F8F3->U+6B72, U+2F8F4->U+6B9F, \\\n"
-        "       U+2F8F5->U+6BBA, U+2F8F6->U+6BBB, U+2F8F7->U+23A8D, U+2F8F8->U+21D0B, \\\n"
-        "       U+2F8F9->U+23AFA, U+2F8FA->U+6C4E, U+2F8FB->U+23CBC, U+2F8FC->U+6CBF, \\\n"
-        "       U+2F8FD->U+6CCD, U+2F8FE->U+6C67, U+2F8FF->U+6D16, U+2F900->U+6D3E, \\\n"
-        "       U+2F901->U+6D77, U+2F902->U+6D41, U+2F903->U+6D69, U+2F904->U+6D78, \\\n"
-        "       U+2F905->U+6D85, U+2F906->U+23D1E, U+2F907->U+6D34, U+2F908->U+6E2F, \\\n"
-        "       U+2F909->U+6E6E, U+2F90A->U+3D33, U+2F90B->U+6ECB, U+2F90C->U+6EC7, \\\n"
-        "       U+2F90D->U+23ED1, U+2F90E->U+6DF9, U+2F90F->U+6F6E, U+2F910->U+23F5E, \\\n"
-        "       U+2F911->U+23F8E, U+2F912->U+6FC6, U+2F913->U+7039, U+2F914->U+701E, \\\n"
-        "       U+2F915->U+701B, U+2F916->U+3D96, U+2F917->U+704A, U+2F918->U+707D, \\\n"
-        "       U+2F919->U+7077, U+2F91A->U+70AD, U+2F91B->U+20525, U+2F91C->U+7145, \\\n"
-        "       U+2F91D->U+24263, U+2F91E->U+719C, U+2F91F->U+243AB, U+2F920->U+7228, \\\n"
-        "       U+2F921->U+7235, U+2F922->U+7250, U+2F923->U+24608, U+2F924->U+7280, \\\n"
-        "       U+2F925->U+7295, U+2F926->U+24735, U+2F927->U+24814, U+2F928->U+737A, \\\n"
-        "       U+2F929->U+738B, U+2F92A->U+3EAC, U+2F92B->U+73A5, U+2F92C->U+3EB8, \\\n"
-        "       U+2F92D->U+3EB8, U+2F92E->U+7447, U+2F92F->U+745C, U+2F930->U+7471, \\\n"
-        "       U+2F931->U+7485, U+2F932->U+74CA, U+2F933->U+3F1B, U+2F934->U+7524, \\\n"
-        "       U+2F935->U+24C36, U+2F936->U+753E, U+2F937->U+24C92, U+2F938->U+7570, \\\n"
-        "       U+2F939->U+2219F, U+2F93A->U+7610, U+2F93B->U+24FA1, U+2F93C->U+24FB8, \\\n"
-        "       U+2F93D->U+25044, U+2F93E->U+3FFC, U+2F93F->U+4008, U+2F940->U+76F4, \\\n"
-        "       U+2F941->U+250F3, U+2F942->U+250F2, U+2F943->U+25119, U+2F944->U+25133, \\\n"
-        "       U+2F945->U+771E, U+2F946->U+771F, U+2F947->U+771F, U+2F948->U+774A, \\\n"
-        "       U+2F949->U+4039, U+2F94A->U+778B, U+2F94B->U+4046, U+2F94C->U+4096, \\\n"
-        "       U+2F94D->U+2541D, U+2F94E->U+784E, U+2F94F->U+788C, U+2F950->U+78CC, \\\n"
-        "       U+2F951->U+40E3, U+2F952->U+25626, U+2F953->U+7956, U+2F954->U+2569A, \\\n"
-        "       U+2F955->U+256C5, U+2F956->U+798F, U+2F957->U+79EB, U+2F958->U+412F, \\\n"
-        "       U+2F959->U+7A40, U+2F95A->U+7A4A, U+2F95B->U+7A4F, U+2F95C->U+2597C, \\\n"
-        "       U+2F95D->U+25AA7, U+2F95E->U+25AA7, U+2F95F->U+7AEE, U+2F960->U+4202, \\\n"
-        "       U+2F961->U+25BAB, U+2F962->U+7BC6, U+2F963->U+7BC9, U+2F964->U+4227, \\\n"
-        "       U+2F965->U+25C80, U+2F966->U+7CD2, U+2F967->U+42A0, U+2F968->U+7CE8, \\\n"
-        "       U+2F969->U+7CE3, U+2F96A->U+7D00, U+2F96B->U+25F86, U+2F96C->U+7D63, \\\n"
-        "       U+2F96D->U+4301, U+2F96E->U+7DC7, U+2F96F->U+7E02, U+2F970->U+7E45, \\\n"
-        "       U+2F971->U+4334, U+2F972->U+26228, U+2F973->U+26247, U+2F974->U+4359, \\\n"
-        "       U+2F975->U+262D9, U+2F976->U+7F7A, U+2F977->U+2633E, U+2F978->U+7F95, \\\n"
-        "       U+2F979->U+7FFA, U+2F97A->U+8005, U+2F97B->U+264DA, U+2F97C->U+26523, \\\n"
-        "       U+2F97D->U+8060, U+2F97E->U+265A8, U+2F97F->U+8070, U+2F980->U+2335F, \\\n"
-        "       U+2F981->U+43D5, U+2F982->U+80B2, U+2F983->U+8103, U+2F984->U+440B, \\\n"
-        "       U+2F985->U+813E, U+2F986->U+5AB5, U+2F987->U+267A7, U+2F988->U+267B5, \\\n"
-        "       U+2F989->U+23393, U+2F98A->U+2339C, U+2F98B->U+8201, U+2F98C->U+8204, \\\n"
-        "       U+2F98D->U+8F9E, U+2F98E->U+446B, U+2F98F->U+8291, U+2F990->U+828B, \\\n"
-        "       U+2F991->U+829D, U+2F992->U+52B3, U+2F993->U+82B1, U+2F994->U+82B3, \\\n"
-        "       U+2F995->U+82BD, U+2F996->U+82E6, U+2F997->U+26B3C, U+2F998->U+82E5, \\\n"
-        "       U+2F999->U+831D, U+2F99A->U+8363, U+2F99B->U+83AD, U+2F99C->U+8323, \\\n"
-        "       U+2F99D->U+83BD, U+2F99E->U+83E7, U+2F99F->U+8457, U+2F9A0->U+8353, \\\n"
-        "       U+2F9A1->U+83CA, U+2F9A2->U+83CC, U+2F9A3->U+83DC, U+2F9A4->U+26C36, \\\n"
-        "       U+2F9A5->U+26D6B, U+2F9A6->U+26CD5, U+2F9A7->U+452B, U+2F9A8->U+84F1, \\\n"
-        "       U+2F9A9->U+84F3, U+2F9AA->U+8516, U+2F9AB->U+273CA, U+2F9AC->U+8564, \\\n"
-        "       U+2F9AD->U+26F2C, U+2F9AE->U+455D, U+2F9AF->U+4561, U+2F9B0->U+26FB1, \\\n"
-        "       U+2F9B1->U+270D2, U+2F9B2->U+456B, U+2F9B3->U+8650, U+2F9B4->U+865C, \\\n"
-        "       U+2F9B5->U+8667, U+2F9B6->U+8669, U+2F9B7->U+86A9, U+2F9B8->U+8688, \\\n"
-        "       U+2F9B9->U+870E, U+2F9BA->U+86E2, U+2F9BB->U+8779, U+2F9BC->U+8728, \\\n"
-        "       U+2F9BD->U+876B, U+2F9BE->U+8786, U+2F9BF->U+45D7, U+2F9C0->U+87E1, \\\n"
-        "       U+2F9C1->U+8801, U+2F9C2->U+45F9, U+2F9C3->U+8860, U+2F9C4->U+8863, \\\n"
-        "       U+2F9C5->U+27667, U+2F9C6->U+88D7, U+2F9C7->U+88DE, U+2F9C8->U+4635, \\\n"
-        "       U+2F9C9->U+88FA, U+2F9CA->U+34BB, U+2F9CB->U+278AE, U+2F9CC->U+27966, \\\n"
-        "       U+2F9CD->U+46BE, U+2F9CE->U+46C7, U+2F9CF->U+8AA0, U+2F9D0->U+8AED, \\\n"
-        "       U+2F9D1->U+8B8A, U+2F9D2->U+8C55, U+2F9D3->U+27CA8, U+2F9D4->U+8CAB, \\\n"
-        "       U+2F9D5->U+8CC1, U+2F9D6->U+8D1B, U+2F9D7->U+8D77, U+2F9D8->U+27F2F, \\\n"
-        "       U+2F9D9->U+20804, U+2F9DA->U+8DCB, U+2F9DB->U+8DBC, U+2F9DC->U+8DF0, \\\n"
-        "       U+2F9DD->U+208DE, U+2F9DE->U+8ED4, U+2F9DF->U+8F38, U+2F9E0->U+285D2, \\\n"
-        "       U+2F9E1->U+285ED, U+2F9E2->U+9094, U+2F9E3->U+90F1, U+2F9E4->U+9111, \\\n"
-        "       U+2F9E5->U+2872E, U+2F9E6->U+911B, U+2F9E7->U+9238, U+2F9E8->U+92D7, \\\n"
-        "       U+2F9E9->U+92D8, U+2F9EA->U+927C, U+2F9EB->U+93F9, U+2F9EC->U+9415, \\\n"
-        "       U+2F9ED->U+28BFA, U+2F9EE->U+958B, U+2F9EF->U+4995, U+2F9F0->U+95B7, \\\n"
-        "       U+2F9F1->U+28D77, U+2F9F2->U+49E6, U+2F9F3->U+96C3, U+2F9F4->U+5DB2, \\\n"
-        "       U+2F9F5->U+9723, U+2F9F6->U+29145, U+2F9F7->U+2921A, U+2F9F8->U+4A6E, \\\n"
-        "       U+2F9F9->U+4A76, U+2F9FA->U+97E0, U+2F9FB->U+2940A, U+2F9FC->U+4AB2, \\\n"
-        "       U+2F9FD->U+29496, U+2F9FE->U+980B, U+2F9FF->U+980B, U+2FA00->U+9829, \\\n"
-        "       U+2FA01->U+295B6, U+2FA02->U+98E2, U+2FA03->U+4B33, U+2FA04->U+9929, \\\n"
-        "       U+2FA05->U+99A7, U+2FA06->U+99C2, U+2FA07->U+99FE, U+2FA08->U+4BCE, \\\n"
-        "       U+2FA09->U+29B30, U+2FA0A->U+9B12, U+2FA0B->U+9C40, U+2FA0C->U+9CFD, \\\n"
-        "       U+2FA0D->U+4CCE, U+2FA0E->U+4CED, U+2FA0F->U+9D67, U+2FA10->U+2A0CE, \\\n"
-        "       U+2FA11->U+4CF8, U+2FA12->U+2A105, U+2FA13->U+2A20E, U+2FA14->U+2A291, \\\n"
-        "       U+2FA15->U+9EBB, U+2FA16->U+4D56, U+2FA17->U+9EF9, U+2FA18->U+9EFE, \\\n"
-        "       U+2FA19->U+9F05, U+2FA1A->U+9F0F, U+2FA1B->U+9F16, U+2FA1C->U+9F3B, \\\n"
-        "       U+2FA1D->U+2A600, U+2F00->U+4E00, U+2F01->U+4E28, U+2F02->U+4E36, \\\n"
-        "       U+2F03->U+4E3F, U+2F04->U+4E59, U+2F05->U+4E85, U+2F06->U+4E8C, \\\n"
-        "       U+2F07->U+4EA0, U+2F08->U+4EBA, U+2F09->U+513F, U+2F0A->U+5165, \\\n"
-        "       U+2F0B->U+516B, U+2F0C->U+5182, U+2F0D->U+5196, U+2F0E->U+51AB, \\\n"
-        "       U+2F0F->U+51E0, U+2F10->U+51F5, U+2F11->U+5200, U+2F12->U+529B, \\\n"
-        "       U+2F13->U+52F9, U+2F14->U+5315, U+2F15->U+531A, U+2F16->U+5338, \\\n"
-        "       U+2F17->U+5341, U+2F18->U+535C, U+2F19->U+5369, U+2F1A->U+5382, \\\n"
-        "       U+2F1B->U+53B6, U+2F1C->U+53C8, U+2F1D->U+53E3, U+2F1E->U+56D7, \\\n"
-        "       U+2F1F->U+571F, U+2F20->U+58EB, U+2F21->U+5902, U+2F22->U+590A, \\\n"
-        "       U+2F23->U+5915, U+2F24->U+5927, U+2F25->U+5973, U+2F26->U+5B50, \\\n"
-        "       U+2F27->U+5B80, U+2F28->U+5BF8, U+2F29->U+5C0F, U+2F2A->U+5C22, \\\n"
-        "       U+2F2B->U+5C38, U+2F2C->U+5C6E, U+2F2D->U+5C71, U+2F2E->U+5DDB, \\\n"
-        "       U+2F2F->U+5DE5, U+2F30->U+5DF1, U+2F31->U+5DFE, U+2F32->U+5E72, \\\n"
-        "       U+2F33->U+5E7A, U+2F34->U+5E7F, U+2F35->U+5EF4, U+2F36->U+5EFE, \\\n"
-        "       U+2F37->U+5F0B, U+2F38->U+5F13, U+2F39->U+5F50, U+2F3A->U+5F61, \\\n"
-        "       U+2F3B->U+5F73, U+2F3C->U+5FC3, U+2F3D->U+6208, U+2F3E->U+6236, \\\n"
-        "       U+2F3F->U+624B, U+2F40->U+652F, U+2F41->U+6534, U+2F42->U+6587, \\\n"
-        "       U+2F43->U+6597, U+2F44->U+65A4, U+2F45->U+65B9, U+2F46->U+65E0, \\\n"
-        "       U+2F47->U+65E5, U+2F48->U+66F0, U+2F49->U+6708, U+2F4A->U+6728, \\\n"
-        "       U+2F4B->U+6B20, U+2F4C->U+6B62, U+2F4D->U+6B79, U+2F4E->U+6BB3, \\\n"
-        "       U+2F4F->U+6BCB, U+2F50->U+6BD4, U+2F51->U+6BDB, U+2F52->U+6C0F, \\\n"
-        "       U+2F53->U+6C14, U+2F54->U+6C34, U+2F55->U+706B, U+2F56->U+722A, \\\n"
-        "       U+2F57->U+7236, U+2F58->U+723B, U+2F59->U+723F, U+2F5A->U+7247, \\\n"
-        "       U+2F5B->U+7259, U+2F5C->U+725B, U+2F5D->U+72AC, U+2F5E->U+7384, \\\n"
-        "       U+2F5F->U+7389, U+2F60->U+74DC, U+2F61->U+74E6, U+2F62->U+7518, \\\n"
-        "       U+2F63->U+751F, U+2F64->U+7528, U+2F65->U+7530, U+2F66->U+758B, \\\n"
-        "       U+2F67->U+7592, U+2F68->U+7676, U+2F69->U+767D, U+2F6A->U+76AE, \\\n"
-        "       U+2F6B->U+76BF, U+2F6C->U+76EE, U+2F6D->U+77DB, U+2F6E->U+77E2, \\\n"
-        "       U+2F6F->U+77F3, U+2F70->U+793A, U+2F71->U+79B8, U+2F72->U+79BE, \\\n"
-        "       U+2F73->U+7A74, U+2F74->U+7ACB, U+2F75->U+7AF9, U+2F76->U+7C73, \\\n"
-        "       U+2F77->U+7CF8, U+2F78->U+7F36, U+2F79->U+7F51, U+2F7A->U+7F8A, \\\n"
-        "       U+2F7B->U+7FBD, U+2F7C->U+8001, U+2F7D->U+800C, U+2F7E->U+8012, \\\n"
-        "       U+2F7F->U+8033, U+2F80->U+807F, U+2F81->U+8089, U+2F82->U+81E3, \\\n"
-        "       U+2F83->U+81EA, U+2F84->U+81F3, U+2F85->U+81FC, U+2F86->U+820C, \\\n"
-        "       U+2F87->U+821B, U+2F88->U+821F, U+2F89->U+826E, U+2F8A->U+8272, \\\n"
-        "       U+2F8B->U+8278, U+2F8C->U+864D, U+2F8D->U+866B, U+2F8E->U+8840, \\\n"
-        "       U+2F8F->U+884C, U+2F90->U+8863, U+2F91->U+897E, U+2F92->U+898B, \\\n"
-        "       U+2F93->U+89D2, U+2F94->U+8A00, U+2F95->U+8C37, U+2F96->U+8C46, \\\n"
-        "       U+2F97->U+8C55, U+2F98->U+8C78, U+2F99->U+8C9D, U+2F9A->U+8D64, \\\n"
-        "       U+2F9B->U+8D70, U+2F9C->U+8DB3, U+2F9D->U+8EAB, U+2F9E->U+8ECA, \\\n"
-        "       U+2F9F->U+8F9B, U+2FA0->U+8FB0, U+2FA1->U+8FB5, U+2FA2->U+9091, \\\n"
-        "       U+2FA3->U+9149, U+2FA4->U+91C6, U+2FA5->U+91CC, U+2FA6->U+91D1, \\\n"
-        "       U+2FA7->U+9577, U+2FA8->U+9580, U+2FA9->U+961C, U+2FAA->U+96B6, \\\n"
-        "       U+2FAB->U+96B9, U+2FAC->U+96E8, U+2FAD->U+9751, U+2FAE->U+975E, \\\n"
-        "       U+2FAF->U+9762, U+2FB0->U+9769, U+2FB1->U+97CB, U+2FB2->U+97ED, \\\n"
-        "       U+2FB3->U+97F3, U+2FB4->U+9801, U+2FB5->U+98A8, U+2FB6->U+98DB, \\\n"
-        "       U+2FB7->U+98DF, U+2FB8->U+9996, U+2FB9->U+9999, U+2FBA->U+99AC, \\\n"
-        "       U+2FBB->U+9AA8, U+2FBC->U+9AD8, U+2FBD->U+9ADF, U+2FBE->U+9B25, \\\n"
-        "       U+2FBF->U+9B2F, U+2FC0->U+9B32, U+2FC1->U+9B3C, U+2FC2->U+9B5A, \\\n"
-        "       U+2FC3->U+9CE5, U+2FC4->U+9E75, U+2FC5->U+9E7F, U+2FC6->U+9EA5, \\\n"
-        "       U+2FC7->U+9EBB, U+2FC8->U+9EC3, U+2FC9->U+9ECD, U+2FCA->U+9ED1, \\\n"
-        "       U+2FCB->U+9EF9, U+2FCC->U+9EFD, U+2FCD->U+9F0E, U+2FCE->U+9F13, \\\n"
-        "       U+2FCF->U+9F20, U+2FD0->U+9F3B, U+2FD1->U+9F4A, U+2FD2->U+9F52, \\\n"
-        "       U+2FD3->U+9F8D, U+2FD4->U+9F9C, U+2FD5->U+9FA0, U+3042->U+3041, \\\n"
-        "       U+3044->U+3043, U+3046->U+3045, U+3048->U+3047, U+304A->U+3049, \\\n"
-        "       U+304C->U+304B, U+304E->U+304D, U+3050->U+304F, U+3052->U+3051, \\\n"
-        "       U+3054->U+3053, U+3056->U+3055, U+3058->U+3057, U+305A->U+3059, \\\n"
-        "       U+305C->U+305B, U+305E->U+305D, U+3060->U+305F, U+3062->U+3061, \\\n"
-        "       U+3064->U+3063, U+3065->U+3063, U+3067->U+3066, U+3069->U+3068, \\\n"
-        "       U+3070->U+306F, U+3071->U+306F, U+3073->U+3072, U+3074->U+3072, \\\n"
-        "       U+3076->U+3075, U+3077->U+3075, U+3079->U+3078, U+307A->U+3078, \\\n"
-        "       U+307C->U+307B, U+307D->U+307B, U+3084->U+3083, U+3086->U+3085, \\\n"
-        "       U+3088->U+3087, U+308F->U+308E, U+3094->U+3046, U+3095->U+304B, \\\n"
-        "       U+3096->U+3051, U+30A2->U+30A1, U+30A4->U+30A3, U+30A6->U+30A5, \\\n"
-        "       U+30A8->U+30A7, U+30AA->U+30A9, U+30AC->U+30AB, U+30AE->U+30AD, \\\n"
-        "       U+30B0->U+30AF, U+30B2->U+30B1, U+30B4->U+30B3, U+30B6->U+30B5, \\\n"
-        "       U+30B8->U+30B7, U+30BA->U+30B9, U+30BC->U+30BB, U+30BE->U+30BD, \\\n"
-        "       U+30C0->U+30BF, U+30C2->U+30C1, U+30C5->U+30C4, U+30C7->U+30C6, \\\n"
-        "       U+30C9->U+30C8, U+30D0->U+30CF, U+30D1->U+30CF, U+30D3->U+30D2, \\\n"
-        "       U+30D4->U+30D2, U+30D6->U+30D5, U+30D7->U+30D5, U+30D9->U+30D8, \\\n"
-        "       U+30DA->U+30D8, U+30DC->U+30DB, U+30DD->U+30DB, U+30E4->U+30E3, \\\n"
-        "       U+30E6->U+30E5, U+30E8->U+30E7, U+30EF->U+30EE, U+30F4->U+30A6, \\\n"
-        "       U+30AB->U+30F5, U+30B1->U+30F6, U+30F7->U+30EF, U+30F8->U+30F0, \\\n"
-        "       U+30F9->U+30F1, U+30FA->U+30F2, U+30AF->U+31F0, U+30B7->U+31F1, \\\n"
-        "       U+30B9->U+31F2, U+30C8->U+31F3, U+30CC->U+31F4, U+30CF->U+31F5, \\\n"
-        "       U+30D2->U+31F6, U+30D5->U+31F7, U+30D8->U+31F8, U+30DB->U+31F9, \\\n"
-        "       U+30E0->U+31FA, U+30E9->U+31FB, U+30EA->U+31FC, U+30EB->U+31FD, \\\n"
-        "       U+30EC->U+31FE, U+30ED->U+31FF, U+FF66->U+30F2, U+FF67->U+30A1, \\\n"
-        "       U+FF68->U+30A3, U+FF69->U+30A5, U+FF6A->U+30A7, U+FF6B->U+30A9, \\\n"
-        "       U+FF6C->U+30E3, U+FF6D->U+30E5, U+FF6E->U+30E7, U+FF6F->U+30C3, \\\n"
-        "       U+FF71->U+30A1, U+FF72->U+30A3, U+FF73->U+30A5, U+FF74->U+30A7, \\\n"
-        "       U+FF75->U+30A9, U+FF76->U+30AB, U+FF77->U+30AD, U+FF78->U+30AF, \\\n"
-        "       U+FF79->U+30B1, U+FF7A->U+30B3, U+FF7B->U+30B5, U+FF7C->U+30B7, \\\n"
-        "       U+FF7D->U+30B9, U+FF7E->U+30BB, U+FF7F->U+30BD, U+FF80->U+30BF, \\\n"
-        "       U+FF81->U+30C1, U+FF82->U+30C3, U+FF83->U+30C6, U+FF84->U+30C8, \\\n"
-        "       U+FF85->U+30CA, U+FF86->U+30CB, U+FF87->U+30CC, U+FF88->U+30CD, \\\n"
-        "       U+FF89->U+30CE, U+FF8A->U+30CF, U+FF8B->U+30D2, U+FF8C->U+30D5, \\\n"
-        "       U+FF8D->U+30D8, U+FF8E->U+30DB, U+FF8F->U+30DE, U+FF90->U+30DF, \\\n"
-        "       U+FF91->U+30E0, U+FF92->U+30E1, U+FF93->U+30E2, U+FF94->U+30E3, \\\n"
-        "       U+FF95->U+30E5, U+FF96->U+30E7, U+FF97->U+30E9, U+FF98->U+30EA, \\\n"
-        "       U+FF99->U+30EB, U+FF9A->U+30EC, U+FF9B->U+30ED, U+FF9C->U+30EF, \\\n"
-        "       U+FF9D->U+30F3, U+FFA0->U+3164, U+FFA1->U+3131, U+FFA2->U+3132, \\\n"
-        "       U+FFA3->U+3133, U+FFA4->U+3134, U+FFA5->U+3135, U+FFA6->U+3136, \\\n"
-        "       U+FFA7->U+3137, U+FFA8->U+3138, U+FFA9->U+3139, U+FFAA->U+313A, \\\n"
-        "       U+FFAB->U+313B, U+FFAC->U+313C, U+FFAD->U+313D, U+FFAE->U+313E, \\\n"
-        "       U+FFAF->U+313F, U+FFB0->U+3140, U+FFB1->U+3141, U+FFB2->U+3142, \\\n"
-        "       U+FFB3->U+3143, U+FFB4->U+3144, U+FFB5->U+3145, U+FFB6->U+3146, \\\n"
-        "       U+FFB7->U+3147, U+FFB8->U+3148, U+FFB9->U+3149, U+FFBA->U+314A, \\\n"
-        "       U+FFBB->U+314B, U+FFBC->U+314C, U+FFBD->U+314D, U+FFBE->U+314E, \\\n"
-        "       U+FFC2->U+314F, U+FFC3->U+3150, U+FFC4->U+3151, U+FFC5->U+3152, \\\n"
-        "       U+FFC6->U+3153, U+FFC7->U+3154, U+FFCA->U+3155, U+FFCB->U+3156, \\\n"
-        "       U+FFCC->U+3157, U+FFCD->U+3158, U+FFCE->U+3159, U+FFCF->U+315A, \\\n"
-        "       U+FFD2->U+315B, U+FFD3->U+315C, U+FFD4->U+315D, U+FFD5->U+315E, \\\n"
-        "       U+FFD6->U+315F, U+FFD7->U+3160, U+FFDA->U+3161, U+FFDB->U+3162, \\\n"
-        "       U+FFDC->U+3163, U+3131->U+1100, U+3132->U+1101, U+3133->U+11AA, \\\n"
-        "       U+3134->U+1102, U+3135->U+11AC, U+3136->U+11AD, U+3137->U+1103, \\\n"
-        "       U+3138->U+1104, U+3139->U+1105, U+313A->U+11B0, U+313B->U+11B1, \\\n"
-        "       U+313C->U+11B2, U+313D->U+11B3, U+313E->U+11B4, U+313F->U+11B5, \\\n"
-        "       U+3140->U+111A, U+3141->U+1106, U+3142->U+1107, U+3143->U+1108, \\\n"
-        "       U+3144->U+1121, U+3145->U+1109, U+3146->U+110A, U+3147->U+110B, \\\n"
-        "       U+3148->U+110C, U+3149->U+110D, U+314A->U+110E, U+314B->U+110F, \\\n"
-        "       U+314C->U+1110, U+314D->U+1111, U+314E->U+1112, U+314F->U+1161, \\\n"
-        "       U+3150->U+1162, U+3151->U+1163, U+3152->U+1164, U+3153->U+1165, \\\n"
-        "       U+3154->U+1166, U+3155->U+1167, U+3156->U+1168, U+3157->U+1169, \\\n"
-        "       U+3158->U+116A, U+3159->U+116B, U+315A->U+116C, U+315B->U+116D, \\\n"
-        "       U+315C->U+116E, U+315D->U+116F, U+315E->U+1170, U+315F->U+1171, \\\n"
-        "       U+3160->U+1172, U+3161->U+1173, U+3162->U+1174, U+3163->U+1175, \\\n"
-        "       U+3165->U+1114, U+3166->U+1115, U+3167->U+11C7, U+3168->U+11C8, \\\n"
-        "       U+3169->U+11CC, U+316A->U+11CE, U+316B->U+11D3, U+316C->U+11D7, \\\n"
-        "       U+316D->U+11D9, U+316E->U+111C, U+316F->U+11DD, U+3170->U+11DF, \\\n"
-        "       U+3171->U+111D, U+3172->U+111E, U+3173->U+1120, U+3174->U+1122, \\\n"
-        "       U+3175->U+1123, U+3176->U+1127, U+3177->U+1129, U+3178->U+112B, \\\n"
-        "       U+3179->U+112C, U+317A->U+112D, U+317B->U+112E, U+317C->U+112F, \\\n"
-        "       U+317D->U+1132, U+317E->U+1136, U+317F->U+1140, U+3180->U+1147, \\\n"
-        "       U+3181->U+114C, U+3182->U+11F1, U+3183->U+11F2, U+3184->U+1157, \\\n"
-        "       U+3185->U+1158, U+3186->U+1159, U+3187->U+1184, U+3188->U+1185, \\\n"
-        "       U+3189->U+1188, U+318A->U+1191, U+318B->U+1192, U+318C->U+1194, \\\n"
-        "       U+318D->U+119E, U+318E->U+11A1, U+A490->U+A408, U+A491->U+A1B9, \\\n"
-        "       U+4E00..U+9FBB, U+3400..U+4DB5, U+20000..U+2A6D6, U+FA0E, U+FA0F, \\\n"
-        "       U+FA11, U+FA13, U+FA14, U+FA1F, U+FA21, U+FA23, U+FA24, U+FA27, U+FA28, \\\n"
-        "       U+FA29, U+3105..U+312C, U+31A0..U+31B7, U+3041, U+3043, U+3045, U+3047, \\\n"
-        "       U+3049, U+304B, U+304D, U+304F, U+3051, U+3053, U+3055, U+3057, U+3059, \\\n"
-        "       U+305B, U+305D, U+305F, U+3061, U+3063, U+3066, U+3068, U+306A..U+306F, \\\n"
-        "       U+3072, U+3075, U+3078, U+307B, U+307E..U+3083, U+3085, U+3087, \\\n"
-        "       U+3089..U+308E, U+3090..U+3093, U+30A1, U+30A3, U+30A5, U+30A7, U+30A9, \\\n"
-        "       U+30AD, U+30AF, U+30B3, U+30B5, U+30BB, U+30BD, U+30BF, U+30C1, U+30C3, \\\n"
-        "       U+30C4, U+30C6, U+30CA, U+30CB, U+30CD, U+30CE, U+30DE, U+30DF, U+30E1, \\\n"
-        "       U+30E2, U+30E3, U+30E5, U+30E7, U+30EE, U+30F0..U+30F3, U+30F5, U+30F6, \\\n"
-        "       U+31F0, U+31F1, U+31F2, U+31F3, U+31F4, U+31F5, U+31F6, U+31F7, U+31F8, \\\n"
-        "       U+31F9, U+31FA, U+31FB, U+31FC, U+31FD, U+31FE, U+31FF, U+AC00..U+D7A3, \\\n"
-        "       U+1100..U+1159, U+1161..U+11A2, U+11A8..U+11F9, U+A000..U+A48C, \\\n"
-        "       U+A492..U+A4C6\n"
-        "       ngram_chars = \\\n"
-        /* Support for Chinese/Japanese/Korean, from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cjk */
-        "       U+4E00..U+9FBB, U+3400..U+4DB5, U+20000..U+2A6D6, U+FA0E, U+FA0F, \\\n"
-        "       U+FA11, U+FA13, U+FA14, U+FA1F, U+FA21, U+FA23, U+FA24, U+FA27, U+FA28, \\\n"
-        "       U+FA29, U+3105..U+312C, U+31A0..U+31B7, U+3041, U+3043, U+3045, U+3047, \\\n"
-        "       U+3049, U+304B, U+304D, U+304F, U+3051, U+3053, U+3055, U+3057, U+3059, \\\n"
-        "       U+305B, U+305D, U+305F, U+3061, U+3063, U+3066, U+3068, U+306A..U+306F, \\\n"
-        "       U+3072, U+3075, U+3078, U+307B, U+307E..U+3083, U+3085, U+3087, \\\n"
-        "       U+3089..U+308E, U+3090..U+3093, U+30A1, U+30A3, U+30A5, U+30A7, U+30A9, \\\n"
-        "       U+30AD, U+30AF, U+30B3, U+30B5, U+30BB, U+30BD, U+30BF, U+30C1, U+30C3, \\\n"
-        "       U+30C4, U+30C6, U+30CA, U+30CB, U+30CD, U+30CE, U+30DE, U+30DF, U+30E1, \\\n"
-        "       U+30E2, U+30E3, U+30E5, U+30E7, U+30EE, U+30F0..U+30F3, U+30F5, U+30F6, \\\n"
-        "       U+31F0, U+31F1, U+31F2, U+31F3, U+31F4, U+31F5, U+31F6, U+31F7, U+31F8, \\\n"
-        "       U+31F9, U+31FA, U+31FB, U+31FC, U+31FD, U+31FE, U+31FF, U+AC00..U+D7A3, \\\n"
-        "       U+1100..U+1159, U+1161..U+11A2, U+11A8..U+11F9, U+A000..U+A48C, \\\n"
-        "       U+A492..U+A4C6\n"
-        "       ngram_len = 1\n"
-        "\n"
-        "    rt_attr_string = cyrusid\n"
-        "    rt_field = header_from\n"
-        "    rt_field = header_to\n"
-        "    rt_field = header_cc\n"
-        "    rt_field = header_bcc\n"
-        "    rt_field = header_subject\n"
-        "    rt_field = headers\n"
-        "    rt_field = body\n"
-        "    preopen = 0\n"
-        "}\n"
-        "\n"
-        "searchd\n"
-        "{\n"
-        "    listen = $sphinxsock:mysql41\n"
-        "    log = syslog\n"
-        "    pid_file = $sphinxdir" SPHINX_PIDFILE "\n"
-        "    binlog_path = $sphinxdir/binlog\n"
-        "    compat_sphinxql_magics = 0\n"
-        "    workers = threads\n"
-        "    max_matches = " SPHINX_MAX_MATCHES "\n"
-        "    preopen_indexes = 0\n"
-        "}\n"
-        "\n"
-        "source fmindex\n"
-        "{\n"
-        "    type = xmlpipe2\n"
-        "    xmlpipe_command = cat $sphinxdir/fmindex.xml\n"
-        "    xmlpipe_attr_string = cyrusid\n"
-        "    xmlpipe_field = header_from\n"
-        "    xmlpipe_field = header_to\n"
-        "    xmlpipe_field = header_cc\n"
-        "    xmlpipe_field = header_bcc\n"
-        "    xmlpipe_field = header_subject\n"
-        "    xmlpipe_field = headers\n"
-        "    xmlpipe_field = body\n"
-        "}\n";
-    char *sphinx_config = NULL;
-    int fd = -1;
-    struct buf buf = BUF_INITIALIZER;
-    int r;
-
-    sphinx_config = strconcat(id->basedir, SPHINX_CONFIG, (char *)NULL);
-    if (verbose > 1)
-        syslog(LOG_INFO, "setting up config \"%s\"", sphinx_config);
-
-/* the searchd.log entry changed, so force a rewrite of the config file */
-#if 0
-    struct stat sb;
-    if (stat(sphinx_config, &sb) == 0 &&
-        S_ISREG(sb.st_mode) &&
-        sb.st_size > 0) {
-        r = 0;
-        goto out;       /* a non-zero file already exists */
-    }
-#endif
-
-    if (verbose)
-        syslog(LOG_INFO, "Sphinx writing config file %s", sphinx_config);
-
-    fd = open(sphinx_config, O_WRONLY|O_CREAT|O_TRUNC, 0600);
-    if (fd < 0) {
-        syslog(LOG_ERR, "IOERROR: unable to open %s for writing: %m",
-               sphinx_config);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    buf_init_ro_cstr(&buf, config);
-    buf_replace_all(&buf, "$sphinxsock", id->socketpath);
-    buf_replace_all(&buf, "$sphinxdir", id->basedir);
-
-    r = retry_write(fd, buf.s, buf.len);
-    if (r < 0) {
-        syslog(LOG_ERR, "IOERROR: error writing %s: %m", sphinx_config);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-    r = 0;
-
-out:
-    if (fd >= 0) close(fd);
-    free(sphinx_config);
-    buf_free(&buf);
-    return r;
-}
-
-/* Wait until the searchd finishes shutting down.
- * Returns 0 if all went well, or a system error code.  */
-static int indexd_stopwait(indexd_t *id)
-{
-    int tries = 0;
-
-    while (tries++ < STOPWAIT_MAX_TRIES) {
-        if (indexd_is_running(id) != 0)
-            return 0;
-        poll(NULL, 0, STOPWAIT_DELAY_MS);
-    }
-    return ETIMEDOUT;
-}
-
-static int indexd_start(indexd_t *id)
-{
-    char *config_file = NULL;
-    int r;
-
-    assert(id->state == STOPPED);
-
-    if (verbose)
-        syslog(LOG_INFO, "Sphinx starting searchd %s", id->basedir);
-
-    config_file = strconcat(id->basedir, SPHINX_CONFIG, (char *)NULL);
-    r = run_command(SEARCHD, "--config", config_file,
-                    "--syslog-prefix", syslog_prefix, (char *)NULL);
-    if (r) goto out;
-
-    id->started = time(NULL);
-    indexd_set_state(id, STARTED);
-    r = 0;
-
-out:
-    free(config_file);
-    return r;
-}
-
-static int indexd_stop(indexd_t *id)
-{
-    char *config_file = NULL;
-    int r;
-
-    if (id->state != STARTED) return 0; /* nothing to do */
-
-    if (verbose)
-        syslog(LOG_INFO, "Sphinx stopping searchd %s",
-                           id->basedir);
-
-    config_file = strconcat(id->basedir, SPHINX_CONFIG, (char *)NULL);
-    r = run_command(SEARCHD, "--config", config_file,
-                    "--syslog-prefix", syslog_prefix,
-                    "--stop", (char *)NULL);
-    if (r) goto out;
-
-    unlink(id->socketpath);
-    indexd_set_state(id, STOPPING);
-    id->stopped = time(NULL);
-
-    r = 0;
-
-out:
-    free(config_file);
-    return r;
-}
-
-/* Returns in *basedir and *sockname, two new strings which must be free()d */
-static int sphinx_paths_from_mboxname(const char *mboxname,
-                                      char **basedirp,
-                                      char **socknamep)
-{
-    char *confkey = NULL;
-    const char *root;
-    struct mboxlist_entry *mbentry = NULL;
-    char *basedir = NULL;
-    struct mboxname_parts parts;
-    char *sockname = NULL;
-    char c[2], d[2];
-    int r;
-
-    mboxname_init_parts(&parts);
-
-    r = mboxlist_lookup(mboxname, &mbentry, /*tid*/NULL);
-    if (r) goto out;
-    if (mbentry->mbtype & MBTYPE_REMOTE) {
-        r = IMAP_PARTITION_UNKNOWN;
-        goto out;
-    }
-
-    confkey = strconcat("sphinxpartition-", mbentry->partition, NULL);
-    root = config_getoverflowstring(confkey, NULL);
-    if (!root) {
-        r = IMAP_PARTITION_UNKNOWN;
-        goto out;
-    }
-
-    r = mboxname_to_parts(mboxname, &parts);
-    if (r) goto out;
-    if (!parts.userid) {
-        r = IMAP_PARTITION_UNKNOWN;
-        goto out;
-    }
-
-    if (parts.domain)
-        basedir = strconcat(root,
-                            FNAME_DOMAINDIR,
-                            dir_hash_b(parts.domain, config_fulldirhash, d),
-                            "/", parts.domain,
-                            FNAME_USERDIR,
-                            dir_hash_b(parts.userid, config_fulldirhash, c),
-                            "/", parts.userid,
-                            (char *)NULL);
-    else
-        basedir = strconcat(root,
-                            FNAME_USERDIR,
-                            dir_hash_b(parts.userid, config_fulldirhash, c),
-                            "/", parts.userid,
-                            (char *)NULL);
-
-    if (parts.domain)
-        sockname = strconcat(config_dir,
-                             "/socket/sphinx.",
-                             parts.userid,
-                             "@",
-                             parts.domain,
-                             (char *)NULL);
-    else
-        sockname = strconcat(config_dir,
-                             "/socket/sphinx.",
-                             parts.userid,
-                             (char *)NULL);
-    r = 0;
-
-out:
-    if (r) {
-        free(basedir);
-        free(sockname);
-    }
-    else {
-        *basedirp = basedir;
-        *socknamep = sockname;
-    }
-    free(confkey);
-    mboxname_free_parts(&parts);
-    mboxlist_entry_free(&mbentry);
-    return r;
-}
-
-static void indexd_detach(indexd_t *id)
-{
-    if (id->state != STOPPED)
-        syslog(LOG_ERR, "IOERROR: internal error, state=%d in "
-                        "indexd_detach for basedir %s",
-                        id->state, id->basedir);
-
-    /* unstitch */
-    id->prev->next = id->next;
-    id->next->prev = id->prev;
-    hash_del(id->basedir, &itable);
-}
-
-/* Checks to see if the searchd is still running.
- * Returns 0 if still running or a system error code */
-static int indexd_is_running(indexd_t *id)
-{
-    char *pidfile = strconcat(id->basedir, SPHINX_PIDFILE, (char *)NULL);
-    int r;
-    struct stat sb;
-
-    do {
-        r = stat(pidfile, &sb);
-    } while (r < 0 && errno == EINTR);
-
-    if (r < 0) {
-        r = errno;
-        if (errno != ENOENT)
-            syslog(LOG_ERR, "cannot stat %s: %m", pidfile);
-    }
-
-    /* TODO: could also read the pidfile send the process named there a
-     * signal 0 to see if it's still alive.  But that would be a lot of
-     * work to detect and hide abnormal shutdowns, which don't seem to
-     * happen; sphinx seems pretty good about cleaning up after itself.
-     * So just check for the existance of the pidfile. */
-
-    free(pidfile);
-    return r;
-}
-
-#define ID_NONE         0
-#define ID_SETUP        1
-#define ID_START        2
-static int indexd_get(const char *mboxname, indexd_t **idp, int action)
-{
-    indexd_t *id;
-    char *basedir = NULL;
-    char *socketpath = NULL;
-    int r;
-
-    r = sphinx_paths_from_mboxname(mboxname, &basedir, &socketpath);
-    if (r) return r;
-
-    id = (indexd_t *)hash_lookup(basedir, &itable);
-
-    if (id && id->state == STOPPING) {
-        syslog(LOG_NOTICE, "searchd %s is still shutting down, "
-                           "waiting to start a new one",
-                           id->basedir);
-        r = indexd_stopwait(id);
-        if (r) {
-            syslog(LOG_ERR, "IOERROR: failed to wait for "
-                            "searchd %s to shut down: %s",
-                            id->basedir, error_message(r));
-            return r;
-        }
-        indexd_set_state(id, STOPPED);
-        indexd_detach(id);
-        indexd_free(id);
-        id = NULL;
-    }
-
-    if (id && indexd_is_running(id) != 0) {
-        syslog(LOG_NOTICE, "searchd %s is no longer running, forgetting",
-                           id->basedir);
-        indexd_set_state(id, STOPPED);
-        indexd_detach(id);
-        indexd_free(id);
-        id = NULL;
-    }
-
-    if (!id) {
-        if (action == ID_NONE) {
-            r = IMAP_NOTFOUND;
-            goto out;
-        }
-        if (action == ID_START && max_children && num_started >= max_children) {
-            /* stop the oldest STARTED child */
-            indexd_t *oldest;
-            for (oldest = indexroot.next ;
-                 oldest != &indexroot && oldest->state != STARTED ;
-                 oldest = oldest->next)
-                ;
-            if (oldest->state == STARTED) {
-                syslog(LOG_NOTICE, "hit limit %d, killing oldest %s",
-                       max_children, oldest->basedir);
-                if (indexd_is_running(oldest) != 0 || indexd_stop(oldest) != 0) {
-                    /* not running or failed to initiate shut down */
-                    indexd_set_state(oldest, STOPPED);
-                    indexd_detach(oldest);
-                    indexd_free(oldest);
-                }
-                /* will be detached and freed later */
-            }
-        }
-        id = xzmalloc(sizeof(*id));
-        id->basedir = basedir;
-        basedir = NULL;
-        id->socketpath = socketpath;
-        socketpath = NULL;
-
-        r = indexd_setup_tree(id);
-        if (r) {
-            indexd_free(id);
-            return r;
-        }
-
-        r = indexd_setup_config(id);
-        if (r) {
-            indexd_free(id);
-            return r;
-        }
-
-        if (action == ID_START) {
-            r = indexd_start(id);
-            if (r) {
-                indexd_free(id);
-                return r;
-            }
-        }
-
-        hash_insert(id->basedir, id, &itable);
-        id->prev = indexroot.prev;
-        id->next = &indexroot;
-        id->prev->next = id;
-        id->next->prev = id;
-    }
-    else {
-        /* remove from the list */
-        id->prev->next = id->next;
-        id->next->prev = id->prev;
-        /* move to the end */
-        id->prev = indexroot.prev;
-        id->next = &indexroot;
-        id->prev->next = id;
-        id->next->prev = id;
-    }
-
-    id->used = time(NULL);
-    *idp = id;
-    r = 0;
-out:
-    free(basedir);
-    free(socketpath);
-    return r;
-}
-
-static void expire_indexd(const char *key __attribute__((unused)),
-                          void *data, void *rock)
-{
-    indexd_t *id = (indexd_t *)data;
-    time_t now = *(time_t *)rock;
-
-    switch (id->state) {
-    case STARTED:
-        if (now > id->used + sphinx_timeout) {
-            if (verbose)
-                syslog(LOG_INFO, "searchd %s has been idle for %d sec",
-                                 id->basedir, (int)(now - id->used));
-            if (indexd_is_running(id) != 0 || indexd_stop(id) != 0) {
-                /* not running or failed to initiate shut down */
-                indexd_set_state(id, STOPPED);
-                indexd_detach(id);
-                indexd_free(id);
-            }
-            /* or, will be detached and freed later */
-        }
-        break;
-    case STOPPING:
-        if (indexd_is_running(id) != 0) {
-            if (verbose)
-                syslog(LOG_INFO, "searchd %s finished shutting down after %d sec",
-                                 id->basedir,
-                                 (int)(now - id->stopped));
-            indexd_set_state(id, STOPPED);
-            indexd_detach(id);
-            indexd_free(id);
-        }
-        break;
-    case STOPPED:
-        abort();
-    }
-}
-
-static int create_server_socket(void)
-{
-    const char *sockname = config_getstring(IMAPOPT_SPHINXMGR_SOCKET);
-    struct sockaddr_un asun;
-    int r;
-    int s;
-
-    s = socket(PF_UNIX, SOCK_STREAM, 0);
-    if (s < 0) {
-        perror("socket(PF_UNIX)");
-        shut_down(1);
-    }
-
-    r = unlink(sockname);
-    if (r < 0 && errno != ENOENT) {
-        perror(sockname);
-        shut_down(1);
-    }
-
-    memset(&asun, 0, sizeof(asun));
-    asun.sun_family = AF_UNIX;
-    strlcpy(asun.sun_path, sockname, sizeof(asun.sun_path));
-
-    r = bind(s, (struct sockaddr *)&asun, sizeof(asun));
-    if (r < 0) {
-        perror(sockname);
-        shut_down(1);
-    }
-
-    r = listen(s, 100);
-    if (r < 0) {
-        perror("listen");
-        shut_down(1);
-    }
-
-    return s;
-}
-
-/*
- * Command is: GETSOCK <internal-mboxname>
- */
-static int handle_getsock(char *mboxname, char *reply, size_t maxreply)
-{
-    indexd_t *id = NULL;
-    int r;
-
-    if (!mboxname || !*mboxname) return IMAP_PROTOCOL_BAD_PARAMETERS;
-
-    r = indexd_get(mboxname, &id, ID_START);
-    if (!r)
-        snprintf(reply, maxreply, "%s", id->socketpath);
-    return r;
-}
-
-/*
- * Command is: GETCONF <internal-mboxname>
- */
-static int handle_getconf(char *mboxname, char *reply, size_t maxreply)
-{
-    indexd_t *id = NULL;
-    int r;
-
-    if (!mboxname || !*mboxname) return IMAP_PROTOCOL_BAD_PARAMETERS;
-
-    r = indexd_get(mboxname, &id, ID_SETUP);
-    if (!r)
-        snprintf(reply, maxreply, "%s%s", id->basedir, SPHINX_CONFIG);
-    if (id->state == STOPPED) {
-        /* This index_t was just created to return the basedir to us */
-        indexd_detach(id);
-        indexd_free(id);
-    }
-    return r;
-}
-
-/*
- * Command is: STOP <internal-mboxname>
- */
-static int handle_stop(char *mboxname,
-                       char *reply __attribute__((unused)),
-                       size_t maxreply __attribute__((unused)))
-{
-    indexd_t *id = NULL;
-    int r;
-
-    if (!mboxname || !*mboxname) return IMAP_PROTOCOL_BAD_PARAMETERS;
-
-    r = indexd_get(mboxname, &id, ID_NONE);
-    if (!r)
-        indexd_stop(id);
-    return r;
-}
-
-static void process_command(int ss)
-{
-    int s;
-    int r;
-    int i;
-    char *cmd;
-    char *arg;
-    int (*handler)(char *arg, char *reply, size_t maxreply) = NULL;
-    char buf[1024];
-    static const char sep[] = " \t\r\n";
-
-    s = accept(ss, NULL, NULL);
-    if (s < 0) {
-        syslog(LOG_ERR, "accept(): %m");
-        return;
-    }
-
-    r = read(s, buf, sizeof(buf)-1);
-    if (r < 0) {
-        syslog(LOG_ERR, "read(): %m");
-        goto out;
-    }
-    if (r == 0) {
-        /* what, eof already?  whatever */
-        goto out;
-    }
-    buf[r] = '\0';
-
-    /* trim trailing CR or LF from the line */
-    while (r > 0 && (buf[r-1] == '\r' || buf[r-1] == '\n'))
-        buf[--r] = '\0';
-
-    /* split into command and argument, preserving whitespace
-     * inside the argument */
-    cmd = buf;
-    i = strcspn(buf, sep);
-    if (i <= 0 || i >= r) {
-        syslog(LOG_ERR, "Malformed command received, ignoring");
-        goto out;
-    }
-    while (i < r && isspace(buf[i]))
-        buf[i++] = '\0';
-
-    ucase(cmd);
-    arg = buf+i;
-
-    if (verbose > 1)
-        syslog(LOG_INFO, "parsed command, cmd=\"%s\" arg=\"%s\"", cmd, arg);
-
-    if (!strcmp(cmd, "GETSOCK"))
-        handler = handle_getsock;
-    if (!strcmp(cmd, "GETCONF"))
-        handler = handle_getconf;
-    else if (!strcmp(cmd, "STOP"))
-        handler = handle_stop;
-
-    if (handler) {
-        snprintf(buf, sizeof(buf), "OK ");
-        r = handler(arg, buf+strlen(buf), sizeof(buf)-strlen(buf)-2);
-        if (!r)
-            strlcat(buf, "\r\n", sizeof(buf));
-        else
-            snprintf(buf, sizeof(buf), "NO %s\r\n", error_message(r));
-    }
-    else
-        snprintf(buf, sizeof(buf), "BAD Unrecognized command\r\n");
-
-    if (verbose > 1)
-        syslog(LOG_INFO, "sending reply \"%s\"", buf);
-
-    retry_write(s, buf, strlen(buf));
-
-    /* we always shut down the connection after one command */
-out:
-    close(s);
-}
-
-static void kill_indexd(const char *key __attribute__((unused)),
-                        void *data,
-                        void *rock __attribute__((unused)))
-{
-    indexd_t *id = (indexd_t *)data;
-
-    indexd_stop(id);
-}
-
-static void shut_down(int code)
-{
-    if (server_sock >= 0) close(server_sock);
-    hash_enumerate(&itable, kill_indexd, NULL);
-
-    /* mboxlist might not have been opened yet, but that's harmless */
-    mboxlist_close();
-    mboxlist_done();
-
-    cyrus_done();
-
-    exit(code);
-}
-
-int main(int argc, char **argv)
-{
-    char *p = NULL;
-    int opt;
-    struct pollfd pfd;
-    char *alt_config = NULL;
-    int background = 1;
-    int init_flags = CYRUSINIT_PERROR;
-
-    p = getenv("CYRUS_VERBOSE");
-    if (p) verbose = atoi(p) + 1;
-
-    while ((opt = getopt(argc, argv, "C:fv")) != EOF) {
-        switch (opt) {
-        case 'C': /* alt config file */
-            alt_config = optarg;
-            break;
-        case 'f': /* run in foreground for debugging */
-            background = 0;
-            break;
-        case 'v':   /* be more verbose */
-            verbose++;
-            break;
-        default:
-            fprintf(stderr, "invalid argument\n");
-            exit(EC_USAGE);
-            break;
-        }
-    }
-
-    cyrus_init(alt_config, "cyr_sphinxmgr", 0, 0);
-
-    syslog_prefix = config_getstring(IMAPOPT_SYSLOG_PREFIX);
-    if (!syslog_prefix)
-        syslog_prefix = "cyrus";
-
-    /* Set inactivity timer (convert from minutes to seconds) */
-    sphinx_timeout = config_getint(IMAPOPT_SPHINXMGR_TIMEOUT);
-    max_children = config_getint(IMAPOPT_SPHINXMGR_MAX_CHILDREN);
-
-    signals_add_handlers(0);
-    signals_set_shutdown(shut_down);
-
-    /* create idle table */
-    construct_hash_table(&itable, 1024, 1);
-
-    /* initialise the linked list */
-    indexroot.prev = &indexroot;
-    indexroot.next = &indexroot;
-
-    server_sock = create_server_socket();
-
-    /* fork unless we were given the -f option */
-    if (background) {
-        pid_t pid;
-        int nullfd;
-
-        nullfd = open("/dev/null", O_RDWR, 0);
-        if (nullfd < 0) {
-            perror("/dev/null");
-            exit(1);
-        }
-        dup2(nullfd, 0);
-        dup2(nullfd, 1);
-        dup2(nullfd, 2);
-        close(nullfd);
-        init_flags &= ~CYRUSINIT_PERROR;
-
-        pid = fork();
-        if (pid == -1) {
-            perror("fork");
-            exit(1);
-        }
-
-        if (pid)
-            exit(0);/* parent */
-        /* child */
-    }
-
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    syslog(LOG_INFO, "cyr_sphinxmgr running");
-
-    for (;;) {
-        int n;
-        time_t now = time(NULL);
-
-        signals_poll();
-
-        /* check for shutdown file */
-        if (shutdown_file(NULL, 0))
-            shut_down(0);
-
-        hash_enumerate(&itable, expire_indexd, &now);
-
-        memset(&pfd, 0, sizeof(pfd));
-        pfd.fd = server_sock;
-        pfd.events = POLLIN;
-
-        n = poll(&pfd, 1, /*1 second timeout*/1000);
-        if (n < 0) {
-            if (errno == EAGAIN || errno == EINTR) continue;
-            syslog(LOG_ERR, "poll(): %m");
-            fatal("poll failed", EC_TEMPFAIL);
-        }
-
-        if (n > 0 && (pfd.revents & POLLIN))
-            process_command(server_sock);
-    }
-
-    shut_down(0);
-}
-
diff -pruN 3.0.13-5/imap/cyr_synclog.c 3.2.0-3/imap/cyr_synclog.c
--- 3.0.13-5/imap/cyr_synclog.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_synclog.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,11 +46,11 @@
 
 #include <stdio.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
 
-#include "exitcodes.h"
 #include "global.h"
 #include "sync_log.h"
 #include "util.h"
diff -pruN 3.0.13-5/imap/cyr_userseen.c 3.2.0-3/imap/cyr_userseen.c
--- 3.0.13-5/imap/cyr_userseen.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_userseen.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,11 +48,11 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "mailbox.h"
 #include "mboxlist.h"
@@ -115,14 +115,10 @@ int main(int argc, char *argv[])
 
     cyrus_init(alt_config, "cyr_userseen", 0, 0);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     /* build a list of mailboxes - we're using internal names here */
-    mboxlist_allmbox("", deluserseen, NULL, /*incdel*/0);
+    mboxlist_allmbox("", deluserseen, NULL, /*flags*/0);
 
-    mboxlist_close();
-    mboxlist_done();
+    cyrus_done();
 
     return 0;
 }
diff -pruN 3.0.13-5/imap/cyr_virusscan.c 3.2.0-3/imap/cyr_virusscan.c
--- 3.0.13-5/imap/cyr_virusscan.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/cyr_virusscan.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,22 +47,24 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <netinet/in.h>
 
 /* cyrus includes */
+#include "assert.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "append.h"
 #include "index.h"
 #include "mailbox.h"
+#include "map.h"
 #include "message.h"
 #include "xmalloc.h"
 #include "mboxlist.h"
+#include "parseaddr.h"
 #include "prot.h"
 #include "util.h"
-#include "sync_log.h"
 #include "times.h"
 #include "xstrlcpy.h"
 
@@ -90,6 +92,7 @@ struct scan_rock {
     struct infected_mbox *i_mbox;
     struct searchargs *searchargs;
     struct index_state *idx_state;
+    struct namespace *namespace;
     uint32_t msgno;
     char userid[MAX_MAILBOX_NAME];
     int user_infected;
@@ -133,39 +136,42 @@ struct clamav_state {
 void *clamav_init()
 {
     unsigned int sigs = 0;
+    int64_t starttime;
     int r;
 
     /* initialise ClamAV library */
     if ((r = cl_init(0)) != CL_SUCCESS) {
         syslog(LOG_ERR, "cl_init: %s", cl_strerror(r));
-        fatal("Failed to initialise ClamAV library", EC_SOFTWARE);
+        fatal("Failed to initialise ClamAV library", EX_SOFTWARE);
     }
 
     struct clamav_state *st = xzmalloc(sizeof(struct clamav_state));
     if (st == NULL) {
-        fatal("memory allocation failed", EC_SOFTWARE);
+        fatal("memory allocation failed", EX_SOFTWARE);
     }
 
     st->av_engine = cl_engine_new();
     if ( ! st->av_engine ) {
-        fatal("Failed to initialize AV engine", EC_SOFTWARE);
+        fatal("Failed to initialize AV engine", EX_SOFTWARE);
     }
 
     /* load all available databases from default directory */
     if (verbose) puts("Loading virus signatures...");
+    starttime = now_ms();
     if ((r = cl_load(cl_retdbdir(), st->av_engine, &sigs, CL_DB_STDOPT))) {
         syslog(LOG_ERR, "cl_load: %s", cl_strerror(r));
-        fatal(cl_strerror(r), EC_SOFTWARE);
+        fatal(cl_strerror(r), EX_SOFTWARE);
     }
 
-    printf("Loaded %d virus signatures.\n", sigs);
+    printf("Loaded %d virus signatures (%.3f seconds).\n",
+           sigs, (now_ms() - starttime)/1000.0);
 
     /* build av_engine */
     if ((r = cl_engine_compile(st->av_engine))) {
         syslog(LOG_ERR,
                "Database initialization error: %s", cl_strerror(r));
         cl_engine_free(st->av_engine);
-        fatal(cl_strerror(r), EC_SOFTWARE);
+        fatal(cl_strerror(r), EX_SOFTWARE);
     }
 
     /* set up archive av_limits */
@@ -251,14 +257,31 @@ int scan_me(struct findall_data *, void
 unsigned virus_check(struct mailbox *mailbox,
                      const struct index_record *record,
                      void *rock);
-void append_notifications();
+static int load_notification_template(struct buf *dst);
+static int check_notification_template(const struct buf *template);
+static void put_notification_headers(FILE *f, int counter, time_t t,
+                                     const mbname_t *mbname);
+static void append_notifications(const struct buf *template);
+
+static const char *default_notification_template =
+	"The following message was deleted from mailbox '%MAILBOX%'\n"
+	"because it was infected with virus '%VIRUS%'\n"
+	"\n"
+	"\tMessage-ID: %MSG_ID%\n"
+	"\tDate: %MSG_DATE%\n"
+	"\tFrom: %MSG_FROM%\n"
+	"\tSubject: %MSG_SUBJECT%\n"
+	"\tIMAP UID: %MSG_UID%\n";
 
-
-int main (int argc, char *argv[]) {
+int main (int argc, char *argv[])
+{
     int option;         /* getopt() returns an int */
     char *alt_config = NULL;
     char *search_str = NULL;
     struct scan_rock srock;
+    struct buf notification_template = BUF_INITIALIZER;
+    struct namespace scan_namespace;
+    int r;
 
     while ((option = getopt(argc, argv, "C:s:rnv")) != EOF) {
         switch (option) {
@@ -291,23 +314,30 @@ int main (int argc, char *argv[]) {
 
     memset(&srock, 0, sizeof(struct scan_rock));
 
+    if (email_notification) {
+        /* load notification template early, so if it fails we haven't wasted
+         * time initialising the av engine */
+        if (load_notification_template(&notification_template)) {
+            syslog(LOG_ERR, "Couldn't load notification template");
+            fatal("Couldn't load notification template", EX_CONFIG);
+        }
+    }
+
+    /* Set namespace -- force standard (internal) */
+    if ((r = mboxname_init_namespace(&scan_namespace, 1)) != 0) {
+        syslog(LOG_ERR, "%s", error_message(r));
+        fatal(error_message(r), EX_CONFIG);
+    }
+    srock.namespace = &scan_namespace;
+
     if (search_str) {
-        int r, c;
-        struct namespace scan_namespace;
+        int c;
         struct protstream *scan_in = NULL;
         struct protstream *scan_out = NULL;
 
         scan_in = prot_readmap(search_str, strlen(search_str)+1); /* inc NUL */
         scan_out = prot_new(2, 1);
 
-        /* Set namespace -- force standard (internal) */
-        if ((r = mboxname_init_namespace(&scan_namespace, 1)) != 0) {
-            syslog(LOG_ERR, "%s", error_message(r));
-            fatal(error_message(r), EC_CONFIG);
-        }
-
-        search_attr_init();
-
         srock.searchargs = new_searchargs("*", GETSEARCH_CHARSET_KEYWORD,
                                           &scan_namespace, NULL, NULL, 1);
         c = get_search_program(scan_in, scan_out, srock.searchargs);
@@ -317,7 +347,7 @@ int main (int argc, char *argv[]) {
 
         if (c == EOF) {
             syslog(LOG_ERR, "Invalid search string");
-            fatal("Invalid search string", EC_USAGE);
+            fatal("Invalid search string", EX_USAGE);
         }
     }
     else {
@@ -326,18 +356,6 @@ int main (int argc, char *argv[]) {
         if (engine.init) engine.state = engine.init();
     }
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for expunge */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    sync_log_init();
-
-    /* setup for mailbox event notifications */
-    mboxevent_init();
-
     if (optind == argc) { /* do the whole partition */
         mboxlist_findall(NULL, "*", 1, 0, 0, scan_me, &srock);
     } else {
@@ -349,15 +367,9 @@ int main (int argc, char *argv[]) {
         strarray_free(array);
     }
 
-    if (email_notification) append_notifications();
-
-    sync_log_done();
-
-    quotadb_close();
-    quotadb_done();
+    if (email_notification) append_notifications(&notification_template);
 
-    mboxlist_close();
-    mboxlist_done();
+    buf_free(&notification_template);
 
     printf("\n%d mailboxes scanned, %d infected messages %s\n",
            srock.mailboxes_scanned,
@@ -397,7 +409,9 @@ static void print_header(void)
 
 int scan_me(struct findall_data *data, void *rock)
 {
-    if (!data || !data->mbname) return 0;
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
+
     struct mailbox *mailbox = NULL;
     int r;
     struct infected_mbox *i_mbox = NULL;
@@ -477,6 +491,9 @@ void create_digest(struct infected_mbox
                    const struct index_record *record, const char *virname)
 {
     struct infected_msg *i_msg = xzmalloc(sizeof(struct infected_msg));
+    char *tmp;
+    struct address addr;
+    struct buf from = BUF_INITIALIZER;
 
     i_msg->mboxname = xstrdup(mailbox->name);
     i_msg->virname = xstrdup(virname);
@@ -484,9 +501,17 @@ void create_digest(struct infected_mbox
 
     i_msg->msgid = mailbox_cache_get_env(mailbox, record, ENV_MSGID);
     i_msg->date = mailbox_cache_get_env(mailbox, record, ENV_DATE);
-    i_msg->from = mailbox_cache_get_env(mailbox, record, ENV_FROM);
     i_msg->subj = mailbox_cache_get_env(mailbox, record, ENV_SUBJECT);
 
+    /* decode the FROM header */
+    tmp = mailbox_cache_get_env(mailbox, record, ENV_FROM);
+    message_parse_env_address(tmp, &addr);
+    if (addr.name)
+        buf_printf(&from, "\"%s\" ", addr.name);
+    buf_printf(&from, "<%s@%s>", addr.mailbox, addr.domain);
+    free(tmp);
+    i_msg->from = buf_release(&from);
+
     i_msg->next = i_mbox->msgs;
     i_mbox->msgs = i_msg;
 }
@@ -519,10 +544,16 @@ unsigned virus_check(struct mailbox *mai
         /* print header if this is the first infection seen for this user */
         if (verbose || !srock->user_infected) print_header();
 
-        printf("%-40s\t%10u\t%6s\t%s\n", mailbox->name, record->uid,
+        char *extname = mboxname_to_external(mailbox->name,
+                                             srock->namespace,
+                                             NULL);
+
+        printf("%-40s\t%10u\t%6s\t%s\n", extname, record->uid,
                (record->system_flags & FLAG_SEEN) ? "READ" : "UNREAD",
                virname);
 
+        free(extname);
+
         srock->user_infected ++;
         srock->total_infected ++;
 
@@ -537,51 +568,180 @@ unsigned virus_check(struct mailbox *mai
     return r;
 }
 
-void append_notifications()
+static int load_notification_template(struct buf *dst)
+{
+    const char *template_fname =
+        config_getstring(IMAPOPT_VIRUSSCAN_NOTIFICATION_TEMPLATE);
+    int r;
+
+    if (!template_fname) {
+        buf_setcstr(dst, default_notification_template);
+        return 0;
+    }
+
+    int fd = open(template_fname, O_RDONLY);
+    if (fd == -1) {
+        syslog(LOG_WARNING, "unable to read notification template file %s (%m), "
+                            "using default instead",
+                            template_fname);
+        buf_setcstr(dst, default_notification_template);
+        return 0;
+    }
+
+    buf_refresh_mmap(dst, 1, fd, template_fname, MAP_UNKNOWN_LEN, NULL);
+    close(fd);
+
+    /* using a custom template, validate it! */
+    r = check_notification_template(dst);
+    if (r) buf_reset(dst);
+
+    return r;
+}
+
+static int check_notification_template(const struct buf *template)
+{
+    struct buf chunk = BUF_INITIALIZER;
+    int fd;
+    FILE *f;
+    mbname_t *mbname;
+    struct protstream *pout;
+    size_t msgsize;
+    size_t i;
+    int r;
+
+    const char *subs[] = {
+        "%MAILBOX%",
+        "%VIRUS%",
+        "%MSG_ID%",
+        "%MSG_DATE%",
+        "%MSG_FROM%",
+        "%MSG_SUBJECT%",
+        "%MSG_UID%",
+    };
+
+    /* warn about missing fields, but they're not catastrophic */
+    for (i = 0; i < sizeof(subs) / sizeof(subs[0]); i++) {
+        if (!memmem(buf_base(template), buf_len(template),
+                    subs[i], strlen(subs[i])))
+            syslog(LOG_WARNING, "notification template is missing %s substitution",
+                                subs[i]);
+    }
+
+    /* stub a message, and do minimal checking for rfc822 compliance */
+    fd = create_tempfile(config_getstring(IMAPOPT_TEMP_PATH));
+    f = fdopen(fd, "w+");
+    mbname = mbname_from_intname("user.nobody");
+    put_notification_headers(f, 0, time(NULL), mbname);
+    mbname_free(&mbname);
+
+    buf_copy(&chunk, template);
+    buf_tocrlf(&chunk);
+    /* not bothering to perform substitutions */
+    char *encoded_chunk = charset_qpencode_mimebody(buf_base(&chunk),
+                                                    buf_len(&chunk),
+                                                    /* force_quote */ 0, NULL);
+    fputs(encoded_chunk, f);
+    fputs("\r\n", f);
+    free(encoded_chunk);
+    buf_free(&chunk);
+
+    fflush(f);
+    msgsize = ftell(f);
+
+    pout = prot_new(fd, 0);
+    prot_rewind(pout);
+    r = message_copy_strict(pout, NULL, msgsize, /* allow_null */ 0);
+    prot_free(pout);
+
+    fclose(f);
+    return r;
+}
+
+static void put_notification_headers(FILE *f, int counter, time_t t,
+                                     const mbname_t *mbname)
+{
+    pid_t p = getpid();
+    char datestr[RFC5322_DATETIME_MAX+1];
+    char *encoded_subject;
+
+    time_to_rfc5322(t, datestr, sizeof(datestr));
+    encoded_subject = charset_encode_mimeheader(
+        config_getstring(IMAPOPT_VIRUSSCAN_NOTIFICATION_SUBJECT), 0, 0);
+
+    fprintf(f, "Return-Path: <>\r\n");
+    fprintf(f, "Message-ID: <cmu-cyrus-%d-%d-%d@%s>\r\n",
+               (int) p, (int) t, counter, config_servername);
+    fprintf(f, "Date: %s\r\n", datestr);
+    fprintf(f, "From: Mail System Administrator <%s>\r\n",
+               config_getstring(IMAPOPT_POSTMASTER));
+    fprintf(f, "To: <%s>\r\n", mbname_userid(mbname));
+    fprintf(f, "Subject: %s\r\n", encoded_subject);
+    fprintf(f, "MIME-Version: 1.0\r\n");
+    fprintf(f, "Content-Type: text/plain; charset=UTF-8\r\n");
+    fprintf(f, "Content-Transfer-Encoding: quoted-printable\r\n");
+    fputs("\r\n", f);
+
+    free(encoded_subject);
+}
+
+static void append_notifications(const struct buf *template)
 {
     struct infected_mbox *i_mbox;
     int outgoing_count = 0;
-    pid_t p = getpid();;
     int fd = create_tempfile(config_getstring(IMAPOPT_TEMP_PATH));
+    struct namespace notification_namespace;
+
+    mboxname_init_namespace(&notification_namespace, 0);
 
     while ((i_mbox = user)) {
         if (i_mbox->msgs) {
             FILE *f = fdopen(fd, "w+");
             struct infected_msg *msg;
-            char buf[8192], datestr[RFC822_DATETIME_MAX+1];
             time_t t;
             struct protstream *pout;
             struct appendstate as;
             struct body *body = NULL;
             long msgsize;
-            mbname_t *mbname = mbname_from_userid(i_mbox->owner);
+            mbname_t *owner = mbname_from_userid(i_mbox->owner);
+            struct buf message = BUF_INITIALIZER;
+            int first;
+            int r;
 
-
-            fprintf(f, "Return-Path: <>\r\n");
             t = time(NULL);
-            snprintf(buf, sizeof(buf), "<cmu-cyrus-%d-%d-%d@%s>",
-                     (int) p, (int) t,
-                     outgoing_count++, config_servername);
-            fprintf(f, "Message-ID: %s\r\n", buf);
-            time_to_rfc822(t, datestr, sizeof(datestr));
-            fprintf(f, "Date: %s\r\n", datestr);
-            fprintf(f, "From: Mail System Administrator <%s>\r\n",
-                    config_getstring(IMAPOPT_POSTMASTER));
-            /* XXX  Need to handle virtdomains */
-            fprintf(f, "To: <%s>\r\n", mbname_userid(mbname));
-            fprintf(f, "MIME-Version: 1.0\r\n");
-            fprintf(f, "Subject: Automatically deleted mail\r\n");
+            put_notification_headers(f, outgoing_count++, t, owner);
 
+            first = 1;
             while ((msg = i_mbox->msgs)) {
-                fprintf(f, "\r\n\r\nThe following message was deleted from mailbox "
-                        "'Inbox%s'\r\n", msg->mboxname+4);  /* skip "user" */
-                fprintf(f, "because it was infected with virus '%s'\r\n\r\n",
-                        msg->virname);
-                fprintf(f, "\tMessage-ID: %s\r\n", msg->msgid);
-                fprintf(f, "\tDate: %s\r\n", msg->date);
-                fprintf(f, "\tFrom: %s\r\n", msg->from);
-                fprintf(f, "\tSubject: %s\r\n", msg->subj);
-                fprintf(f, "\tIMAP UID: %lu\r\n", msg->uid);
+                struct buf chunk = BUF_INITIALIZER;
+                char uidbuf[16]; /* UINT32_MAX is 4294967295 */
+                int n;
+
+                /* stringify the uid */
+                n = snprintf(uidbuf, sizeof(uidbuf), "%lu", msg->uid);
+                assert(n > 0 && (unsigned) n < sizeof(uidbuf));
+
+                buf_copy(&chunk, template);
+                buf_tocrlf(&chunk);
+
+                mbname_t *mailbox = mbname_from_intname(msg->mboxname);
+                const char *extname = mbname_extname(mailbox,
+                                                     &notification_namespace,
+                                                     mbname_userid(owner));
+                buf_replace_all(&chunk, "%MAILBOX%", extname);
+                buf_replace_all(&chunk, "%VIRUS%", msg->virname);
+                buf_replace_all(&chunk, "%MSG_ID%", msg->msgid);
+                buf_replace_all(&chunk, "%MSG_DATE%", msg->date);
+                buf_replace_all(&chunk, "%MSG_FROM%", msg->from);
+                buf_replace_all(&chunk, "%MSG_SUBJECT%", msg->subj);
+                buf_replace_all(&chunk, "%MSG_UID%", uidbuf);
+                mbname_free(&mailbox);
+
+                if (!first)
+                    buf_appendcstr(&message, "\r\n");
+                else
+                    first = 0;
+                buf_append(&message, &chunk);
+                buf_free(&chunk);
 
                 i_mbox->msgs = msg->next;
 
@@ -595,24 +755,45 @@ void append_notifications()
                 free(msg);
             }
 
+            char *encoded_message = charset_qpencode_mimebody(
+                                        buf_base(&message), buf_len(&message),
+                                        /* force_quote */ 0, NULL);
+            fputs(encoded_message, f);
             fflush(f);
             msgsize = ftell(f);
 
+            free(encoded_message);
+            buf_free(&message);
+
             /* send MessageAppend event notification */
-            append_setup(&as, mbname_intname(mbname), NULL, NULL, 0, NULL, NULL, 0,
-                         EVENT_MESSAGE_APPEND);
-            mbname_free(&mbname);
-
-            pout = prot_new(fd, 0);
-            prot_rewind(pout);
-            append_fromstream(&as, &body, pout, msgsize, t, NULL);
-            append_commit(&as);
-
-            if (body) {
-                message_free_body(body);
-                free(body);
+            r = append_setup(&as, mbname_intname(owner), NULL, NULL, 0, NULL, NULL, 0,
+                             EVENT_MESSAGE_APPEND);
+
+            if (!r) {
+                pout = prot_new(fd, 0);
+                prot_rewind(pout);
+                r = append_fromstream(&as, &body, pout, msgsize, t, NULL);
+                /* n.b. append_fromstream calls append_abort itself if it fails */
+                if (!r) r = append_commit(&as);
+
+                if (body) {
+                    message_free_body(body);
+                    free(body);
+                }
+                prot_free(pout);
             }
-            prot_free(pout);
+
+            if (r) {
+                syslog(LOG_ERR, "couldn't send notification to user %s: %s",
+                                mbname_userid(owner),
+                                error_message(r));
+            }
+
+            mbname_free(&owner);
+            /* XXX funny smell here, fdopen() promises to close the underlying
+             *     file descriptor at fclose(), but we're about to loop around
+             *     and re-fdopen() it?
+             */
             fclose(f);
         }
 
diff -pruN 3.0.13-5/imap/dav_db.c 3.2.0-3/imap/dav_db.c
--- 3.0.13-5/imap/dav_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dav_db.c	2020-05-04 03:28:02.000000000 +0000
@@ -70,6 +70,7 @@
     " resource TEXT NOT NULL,"                                          \
     " imap_uid INTEGER,"                                                \
     " modseq INTEGER,"                                                  \
+    " createdmodseq INTEGER,"                                           \
     " lock_token TEXT,"                                                 \
     " lock_owner TEXT,"                                                 \
     " lock_ownerid TEXT,"                                               \
@@ -93,6 +94,7 @@
     " resource TEXT NOT NULL,"                                          \
     " imap_uid INTEGER,"                                                \
     " modseq INTEGER,"                                                  \
+    " createdmodseq INTEGER,"                                           \
     " lock_token TEXT,"                                                 \
     " lock_owner TEXT,"                                                 \
     " lock_ownerid TEXT,"                                               \
@@ -115,6 +117,7 @@
     " pos INTEGER NOT NULL," /* for sorting */                          \
     " email TEXT NOT NULL COLLATE NOCASE,"                              \
     " ispref INTEGER NOT NULL DEFAULT 0,"                               \
+    " ispinned INTEGER NOT NULL DEFAULT 0,"                             \
     " FOREIGN KEY (objid) REFERENCES vcard_objs (rowid) ON DELETE CASCADE );" \
     "CREATE INDEX IF NOT EXISTS idx_vcard_email ON vcard_emails ( email COLLATE NOCASE );"
 
@@ -135,6 +138,7 @@
     " resource TEXT NOT NULL,"                                          \
     " imap_uid INTEGER,"                                                \
     " modseq INTEGER,"                                                  \
+    " createdmodseq INTEGER,"                                           \
     " lock_token TEXT,"                                                 \
     " lock_owner TEXT,"                                                 \
     " lock_ownerid TEXT,"                                               \
@@ -148,9 +152,25 @@
     " UNIQUE( mailbox, resource ) );"                                   \
     "CREATE INDEX IF NOT EXISTS idx_res_uid ON dav_objs ( res_uid );"
 
+#define CMD_CREATE_CALCACHE                                             \
+    "CREATE TABLE IF NOT EXISTS ical_jmapcache ("                       \
+    " rowid INTEGER NOT NULL,"                                          \
+    " userid TEXT NOT NULL,"                                            \
+    " jmapversion INTEGER NOT NULL,"                                    \
+    " jmapdata TEXT NOT NULL,"                                          \
+    " PRIMARY KEY (rowid, userid)"                                      \
+    " FOREIGN KEY (rowid) REFERENCES ical_objs (rowid) ON DELETE CASCADE );"
+
+#define CMD_CREATE_CARDCACHE                                            \
+    "CREATE TABLE IF NOT EXISTS vcard_jmapcache ("                      \
+    " rowid INTEGER NOT NULL PRIMARY KEY,"                              \
+    " jmapversion INTEGER NOT NULL,"                                    \
+    " jmapdata TEXT NOT NULL,"                                          \
+    " FOREIGN KEY (rowid) REFERENCES vcard_objs (rowid) ON DELETE CASCADE );"
+
 
 #define CMD_CREATE CMD_CREATE_CAL CMD_CREATE_CARD CMD_CREATE_EM CMD_CREATE_GR \
-                   CMD_CREATE_OBJS
+                   CMD_CREATE_OBJS CMD_CREATE_CALCACHE CMD_CREATE_CARDCACHE
 
 /* leaves these unused columns around, but that's life.  A dav_reconstruct
  * will fix them */
@@ -176,16 +196,33 @@
 
 #define CMD_DBUPGRADEv6 CMD_CREATE_OBJS
 
+#define CMD_DBUPGRADEv7                                         \
+    "ALTER TABLE ical_objs ADD COLUMN createdmodseq INTEGER;"   \
+    "UPDATE ical_objs SET createdmodseq = 0;"                   \
+    "ALTER TABLE vcard_objs ADD COLUMN createdmodseq INTEGER;"  \
+    "UPDATE vcard_objs SET createdmodseq = 0;"                  \
+    "ALTER TABLE dav_objs ADD COLUMN createdmodseq INTEGER;"    \
+    "UPDATE dav_objs SET createdmodseq = 0;"
+
+#define CMD_DBUPGRADEv8                                         \
+    "ALTER TABLE vcard_emails ADD COLUMN ispinned INTEGER NOT NULL DEFAULT 0;"
+
+#define CMD_DBUPGRADEv9 CMD_CREATE_CALCACHE CMD_CREATE_CARDCACHE
+
+
 struct sqldb_upgrade davdb_upgrade[] = {
   { 2, CMD_DBUPGRADEv2, NULL },
   { 3, CMD_DBUPGRADEv3, NULL },
   { 4, CMD_DBUPGRADEv4, NULL },
   { 5, CMD_DBUPGRADEv5, NULL },
   { 6, CMD_DBUPGRADEv6, NULL },
+  { 7, CMD_DBUPGRADEv7, NULL },
+  { 8, CMD_DBUPGRADEv8, NULL },
+  { 9, CMD_DBUPGRADEv9, NULL },
   { 0, NULL, NULL }
 };
 
-#define DB_VERSION 6
+#define DB_VERSION 9
 
 static int in_reconstruct = 0;
 
@@ -195,7 +232,8 @@ EXPORTED sqldb_t *dav_open_userid(const
     struct buf fname = BUF_INITIALIZER;
     dav_getpath_byuserid(&fname, userid);
     if (in_reconstruct) buf_printf(&fname, ".NEW");
-    db = sqldb_open(buf_cstring(&fname), CMD_CREATE, DB_VERSION, davdb_upgrade);
+    db = sqldb_open(buf_cstring(&fname), CMD_CREATE, DB_VERSION, davdb_upgrade,
+                    config_getduration(IMAPOPT_DAV_LOCK_TIMEOUT, 's') * 1000);
     buf_free(&fname);
     return db;
 }
@@ -206,29 +244,87 @@ EXPORTED sqldb_t *dav_open_mailbox(struc
     struct buf fname = BUF_INITIALIZER;
     dav_getpath(&fname, mailbox);
     if (in_reconstruct) buf_printf(&fname, ".NEW");
-    db = sqldb_open(buf_cstring(&fname), CMD_CREATE, DB_VERSION, davdb_upgrade);
+    db = sqldb_open(buf_cstring(&fname), CMD_CREATE, DB_VERSION, davdb_upgrade,
+                    config_getduration(IMAPOPT_DAV_LOCK_TIMEOUT, 's') * 1000);
     buf_free(&fname);
     return db;
 }
 
+EXPORTED int dav_attach_userid(sqldb_t *db, const char *userid)
+{
+    struct buf fname = BUF_INITIALIZER;
+    dav_getpath_byuserid(&fname, userid);
+    int r = sqldb_attach(db, buf_cstring(&fname));
+    buf_free(&fname);
+    return r;
+}
+
+EXPORTED int dav_attach_mailbox(sqldb_t *db, struct mailbox *mailbox)
+{
+    struct buf fname = BUF_INITIALIZER;
+    dav_getpath(&fname, mailbox);
+    int r = sqldb_attach(db, buf_cstring(&fname));
+    buf_free(&fname);
+    return r;
+}
+
+
 /*
  * mboxlist_usermboxtree() callback function to create DAV DB entries for a mailbox
  */
-static int _dav_reconstruct_mb(const mbentry_t *mbentry, void *rock __attribute__((unused)))
+static int _dav_reconstruct_mb(const mbentry_t *mbentry,
+                               void *rock
+#ifndef WITH_JMAP
+                                          __attribute__((unused))
+#endif
+                              )
 {
+#ifdef WITH_JMAP
+    const char *userid = (const char *) rock;
+    struct buf attrib = BUF_INITIALIZER;
+#endif
+    int (*addproc)(struct mailbox *) = NULL;
     int r = 0;
 
     signals_poll();
 
+    switch (mbentry->mbtype) {
 #ifdef WITH_DAV
-    if (mbentry->mbtype & MBTYPES_DAV) {
+    case MBTYPE_CALENDAR:
+    case MBTYPE_COLLECTION:
+    case MBTYPE_ADDRESSBOOK:
+        addproc = &mailbox_add_dav;
+        break;
+#endif
+#ifdef WITH_JMAP
+    case MBTYPE_SUBMISSION:
+        addproc = &mailbox_add_email_alarms;
+        break;
+
+    case MBTYPE_EMAIL:
+        r = annotatemore_lookup(mbentry->name, "/specialuse", userid, &attrib);
+        if (!r && buf_len(&attrib)) {
+            strarray_t *specialuse =
+                strarray_split(buf_cstring(&attrib), NULL, 0);
+
+            if (strarray_find(specialuse, "\\Snoozed", 0) >= 0) {
+                addproc = &mailbox_add_email_alarms;
+            }
+            strarray_free(specialuse);
+        }
+        buf_free(&attrib);
+        break;
+#endif
+    }
+
+    if (addproc) {
         struct mailbox *mailbox = NULL;
         /* Open/lock header */
-        r = mailbox_open_irl(mbentry->name, &mailbox);
-        if (!r) r = mailbox_add_dav(mailbox);
+        r = mailbox_open_iwl(mbentry->name, &mailbox);
+        // needs to be writable to remove bogus lastalarm data
+        if (!r) r = addproc(mailbox);
         mailbox_close(&mailbox);
     }
-#endif
 
     return r;
 }
@@ -270,7 +366,8 @@ EXPORTED int dav_reconstruct_user(const
 
     sqldb_t *userdb = dav_open_userid(userid);
     sqldb_begin(userdb, "reconstruct");
-    int r = mboxlist_usermboxtree(userid, _dav_reconstruct_mb, NULL, 0);
+    int r = mboxlist_usermboxtree(userid, NULL,
+                                  _dav_reconstruct_mb, (void *) userid, 0);
     if (r)
         sqldb_rollback(userdb, "reconstruct");
     else
diff -pruN 3.0.13-5/imap/dav_db.h 3.2.0-3/imap/dav_db.h
--- 3.0.13-5/imap/dav_db.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dav_db.h	2020-04-24 02:03:00.000000000 +0000
@@ -56,6 +56,7 @@ struct dav_data {
     const char *resource;
     uint32_t imap_uid;          /* zero (0) until URL is mapped */
     modseq_t modseq;
+    modseq_t createdmodseq;
     const char *lock_token;
     const char *lock_owner;
     const char *lock_ownerid;
@@ -72,4 +73,7 @@ int dav_delete(struct mailbox *mailbox);
 
 int dav_reconstruct_user(const char *userid, const char *audit_tool);
 
+int dav_attach_userid(sqldb_t *db, const char *userid);
+int dav_attach_mailbox(sqldb_t *db, struct mailbox *mailbox);
+
 #endif /* DAV_DB_H */
diff -pruN 3.0.13-5/imap/dav_reconstruct.c 3.2.0-3/imap/dav_reconstruct.c
--- 3.0.13-5/imap/dav_reconstruct.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dav_reconstruct.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,15 +49,13 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <time.h>
 
 #include <libical/ical.h>
 
 #include "annotate.h"
-#include "caldav_db.h"
-#include "carddav_db.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "http_dav.h"
 #include "mailbox.h"
@@ -126,28 +124,15 @@ int main(int argc, char **argv)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&recon_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
+    sqldb_init();
 
-#ifdef HAVE_TZ_BY_REF
-    /* Use TZdist VTIMEZONEs if we have them */
-    if (config_getbitfield(IMAPOPT_HTTPMODULES) & IMAP_ENUM_HTTPMODULES_TZDIST) {
-        char buf[MAX_MAILBOX_PATH];
-        snprintf(buf, MAX_MAILBOX_PATH, "%s%s", config_dir, FNAME_ZONEINFODIR);
-        set_zone_directory(buf);
-        icaltimezone_set_tzid_prefix("");
-        icaltimezone_set_builtin_tzdata(1);
-    }
-#endif
-
-    caldav_init();
-    carddav_init();
+    /* Initialize libical */
+    ical_support_init();
 
     if (allusers) {
         mboxlist_alluser(do_user, (void *)audit_tool);
@@ -161,12 +146,6 @@ int main(int argc, char **argv)
             do_user(argv[i], (void *)audit_tool);
     }
 
-    carddav_done();
-    caldav_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
     exit(code);
 }
 
@@ -175,7 +154,7 @@ void usage(void)
 {
     fprintf(stderr,
             "usage: dav_reconstruct [-C <alt_config>] userid\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /*
@@ -188,6 +167,6 @@ void shut_down(int code)
 
     mboxlist_close();
     mboxlist_done();
-    caldav_done();
+    sqldb_done();
     exit(code);
 }
diff -pruN 3.0.13-5/imap/dav_util.c 3.2.0-3/imap/dav_util.c
--- 3.0.13-5/imap/dav_util.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dav_util.c	2020-04-24 02:03:00.000000000 +0000
@@ -67,10 +67,6 @@ EXPORTED void dav_getpath(struct buf *fn
 EXPORTED void dav_getpath_byuserid(struct buf *fname, const char *userid)
 {
     char *path = user_hash_meta(userid, FNAME_DAVSUFFIX);
-
-    if (buf_cstringnull(fname)) {
-        buf_setcstr(fname, path);
-        free(path);
-    }
-    else buf_initm(fname, path, strlen(path));
+    buf_setcstr(fname, path);
+    free(path);
 }
diff -pruN 3.0.13-5/imap/deliver.c 3.2.0-3/imap/deliver.c
--- 3.0.13-5/imap/deliver.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/deliver.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,6 +50,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 #include <errno.h>
@@ -63,7 +64,6 @@
 #include <sys/un.h>
 
 #include "global.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "xstrlcat.h"
@@ -115,8 +115,8 @@ static void usage(void)
     fprintf(stderr,
             "421-4.3.0 usage: deliver [-C <alt_config> ] [-m mailbox]"
             " [-a auth] [-r return_path] [-l] [-D]\r\n");
-    fprintf(stderr, "421 4.3.0 %s\n", cyrus_version());
-    exit(EC_USAGE);
+    fprintf(stderr, "421 4.3.0 %s\n", CYRUS_VERSION);
+    exit(EX_USAGE);
 }
 
 EXPORTED void fatal(const char* s, int code)
@@ -277,7 +277,7 @@ static void just_exit(const char *msg)
 {
     com_err(msg, 0, "%s", error_message(errno));
 
-    fatal(msg, EC_CONFIG);
+    fatal(msg, EX_CONFIG);
 }
 
 /* initialize the network
@@ -386,7 +386,7 @@ static int deliver_msg(char *return_path
             break;
 
         case RCPT_TEMPFAIL:
-            r = EC_TEMPFAIL;
+            r = EX_TEMPFAIL;
             break;
 
         case RCPT_PERMFAIL:
@@ -394,12 +394,13 @@ static int deliver_msg(char *return_path
                probably return data from the client-side LMTP info */
             printf("%s: %s\n",
                    txn->rcpt[j].addr, error_message(txn->rcpt[j].r));
-            if (r != EC_TEMPFAIL) {
-                r = EC_DATAERR;
+            if (r != EX_TEMPFAIL) {
+                r = EX_DATAERR;
             }
             break;
         }
         free(txn->rcpt[j].addr);
+        strarray_free(txn->rcpt[j].resp);
     }
 
     free(txn);
diff -pruN 3.0.13-5/imap/dlist.c 3.2.0-3/imap/dlist.c
--- 3.0.13-5/imap/dlist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dlist.c	2020-05-04 03:28:02.000000000 +0000
@@ -201,6 +201,7 @@ static int reservefile(struct protstream
             break;
         }
         size -= n;
+        if (!file) continue;
         if (fwrite(buf, 1, n, file) != n) {
             syslog(LOG_ERR, "IOERROR: writing to file '%s': %m", *fname);
             r = IMAP_IOERROR;
@@ -824,6 +825,7 @@ struct dlistsax_state {
     dlistsax_cb_t *proc;
     int depth;
     struct dlistsax_data d;
+    struct buf buf;
     struct buf gbuf;
 };
 
@@ -862,15 +864,25 @@ static int _parseliteral(struct dlistsax
     while (s->p < s->end) {
         if (cyrus_isdigit(*s->p)) {
             len = (len * 10) + (*s->p++ - '0');
+            continue;
         }
-        else if (*s->p == '}') {
+
+        // skip literal+ if present
+        if (*s->p == '+' && (s->p + 1 < s->end))
+            s->p++;
+
+        // we'd better be at the end of the literal
+        if (*s->p == '}') {
             if (s->p + 3 + len >= s->end) break;
             if (s->p[1] != '\r') break;
             if (s->p[2] != '\n') break;
-            buf_setmap(buf, s->p+3, len);
-            s->p += len = 3;
+            buf_truncate(buf, 0);
+            buf_appendmap(buf, s->p + 3, len);
+            s->p += len + 3;
             return 0;
         }
+
+        break;
     }
 
     return IMAP_INVALID_IDENTIFIER;
@@ -879,19 +891,28 @@ static int _parseliteral(struct dlistsax
 static int _parseitem(struct dlistsax_state *s, struct buf *buf)
 {
     const char *sp;
-    if (*s->p == '"')
+
+    /* this is much faster than setmap because it doesn't
+     * do a reset and check the MMAP flag */
+    buf_truncate(buf, 0);
+
+    switch (*s->p) {
+    case '"':
         return _parseqstring(s, buf);
-    else if (*s->p == '{')
+
+    case '{':
         return _parseliteral(s, buf);
 
-    sp = memchr(s->p, ' ', s->end - s->p);
-    if (!sp) sp = s->end;
-    while (sp[-1] == ')' && sp > s->p) sp--;
-    /* this is much faster because it doesn't do a reset and check the MMAP flag */
-    buf->len = 0;
-    buf_appendmap(buf, s->p, sp - s->p);
-    s->p = sp;
-    return 0; /* this could be the last thing, so end is OK */
+    default:
+        sp = memchr(s->p, ' ', s->end - s->p);
+        if (!sp) sp = s->end;
+        while (sp[-1] == ')' && sp > s->p) sp--;
+        buf_appendmap(buf, s->p, sp - s->p);
+        s->p = sp;
+        if (buf->len == 3 && buf->s[0] == 'N' && buf->s[1] == 'I' && buf->s[2] == 'L')
+            return IMAP_ZERO_LENGTH_LITERAL; // this is kinda bogus, but...
+        return 0; /* this could be the last thing, so end is OK */
+    }
 }
 
 static int _parsesax(struct dlistsax_state *s, int parsekey)
@@ -901,15 +922,16 @@ static int _parsesax(struct dlistsax_sta
     s->depth++;
 
     /* handle the key if wanted */
+    struct buf *backdoor = (struct buf *)(&s->d.kbuf);
     if (parsekey) {
-        r = _parseitem(s, &s->d.kbuf);
+        r = _parseitem(s, backdoor);
         if (r) return r;
         if (s->p >= s->end) return IMAP_INVALID_IDENTIFIER;
         if (*s->p == ' ') s->p++;
         else return IMAP_INVALID_IDENTIFIER;
     }
     else {
-        s->d.kbuf.len = 0;
+        backdoor->len = 0;
     }
 
     if (s->p >= s->end) return IMAP_INVALID_IDENTIFIER;
@@ -967,10 +989,14 @@ static int _parsesax(struct dlistsax_sta
         }
     }
     else {
-        r = _parseitem(s, &s->d.buf);
-        if (r) return r;
-
+        r = _parseitem(s, &s->buf);
+        if (r == IMAP_ZERO_LENGTH_LITERAL)
+            s->d.data = NULL; // NIL
+        else if (r) return r;
+        else
+            s->d.data = buf_cstring(&s->buf);
         r = s->proc(DLISTSAX_STRING, &s->d);
+        s->d.data = NULL; // zero out for next call
         if (r) return r;
     }
 
@@ -1305,6 +1331,7 @@ HIDDEN int dlist_tomap(struct dlist *dl,
     case DL_ATOM:
     case DL_FLAG:
     case DL_BUF:
+    case DL_NIL:
         break;
 
     default:
diff -pruN 3.0.13-5/imap/dlist.h 3.2.0-3/imap/dlist.h
--- 3.0.13-5/imap/dlist.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/dlist.h	2020-04-24 02:03:00.000000000 +0000
@@ -65,8 +65,8 @@ enum dlistsax_t {
 };
 
 struct dlistsax_data {
-    struct buf kbuf;
-    struct buf buf;
+    const struct buf kbuf;
+    const char *data;
     void *rock;
 };
 
diff -pruN 3.0.13-5/imap/duplicate.c 3.2.0-3/imap/duplicate.c
--- 3.0.13-5/imap/duplicate.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/duplicate.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <ctype.h>
 #include <sys/stat.h>
@@ -70,7 +71,6 @@
 #include "assert.h"
 #include "xmalloc.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "util.h"
 #include "cyrusdb.h"
 
@@ -340,7 +340,7 @@ EXPORTED int duplicate_prune(int seconds
 {
     struct prunerock prock;
 
-    if (seconds < 0) fatal("must specify positive number of seconds", EC_USAGE);
+    if (seconds < 0) fatal("must specify positive number of seconds", EX_USAGE);
 
     prock.count = prock.deletions = 0;
     prock.expmark = time(NULL) - seconds;
diff -pruN 3.0.13-5/imap/fetchnews.c 3.2.0-3/imap/fetchnews.c
--- 3.0.13-5/imap/fetchnews.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/fetchnews.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,6 +47,7 @@
 #endif
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 
@@ -57,7 +58,6 @@
 #include <sys/un.h>
 
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "gmtoff.h"
 #include "cyr_lock.h"
@@ -264,7 +264,7 @@ int main(int argc, char *argv[])
     time_t stamp;
     strarray_t resp = STRARRAY_INITIALIZER;
     int newnews = 1;
-    char *datefmt = "%y%m%d %H%M%S";
+    int y2k_compliant_date_format = 0;
 
     while ((opt = getopt(argc, argv, "C:s:w:f:a:p:ny")) != EOF) {
         switch (opt) {
@@ -301,7 +301,7 @@ int main(int argc, char *argv[])
             break;
 
         case 'y': /* newsserver is y2k compliant */
-            datefmt = "%Y%m%d %H%M%S";
+            y2k_compliant_date_format = 1;
             break;
 
         default:
@@ -417,7 +417,18 @@ int main(int argc, char *argv[])
         if (stamp) stamp -= 180; /* adjust back 3 minutes */
         ptime = gmtime(&stamp);
         ptime->tm_isdst = -1;
-        strftime(buf, sizeof(buf), datefmt, ptime);
+
+        if (y2k_compliant_date_format) {
+            strftime(buf, sizeof(buf), "%Y%m%d %H%M%S", ptime);
+        }
+        else {
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-y2k"
+            /* We know this is not y2k compliant! */
+            strftime(buf, sizeof(buf), "%y%m%d %H%M%S", ptime);
+#pragma GCC diagnostic pop
+        }
+
         prot_printf(pout, "NEWNEWS %s %s GMT\r\n", wildmat, buf);
 
         if (!prot_fgets(buf, sizeof(buf), pin) || strncmp("230", buf, 3)) {
diff -pruN 3.0.13-5/imap/fud.c 3.2.0-3/imap/fud.c
--- 3.0.13-5/imap/fud.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/fud.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,6 +48,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 #include <sys/types.h>
@@ -63,7 +64,6 @@
 #include "acl.h"
 #include "mboxlist.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "map.h"
 #include "mboxname.h"
@@ -139,8 +139,6 @@ void shut_down(int code)
     in_shutdown = 1;
 
     seen_done();
-    mboxlist_close();
-    mboxlist_done();
     closelog();
     cyrus_done();
     exit(code);
@@ -153,15 +151,12 @@ void shut_down(int code)
  */
 int service_init(int argc, char **argv, char **envp)
 {
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
 
     setproctitle_init(argc, argv, envp);
 
     signals_set_shutdown(&shut_down);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     return 0;
 }
 
@@ -180,7 +175,7 @@ int service_main(int argc __attribute__(
     /* Set namespace */
     if ((r = mboxname_init_namespace(&fud_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     r = begin_handling();
@@ -223,7 +218,7 @@ static int do_proxy_request(const char *
                             const char *backend_host,
                             struct sockaddr *sfrom, socklen_t sfromsiz)
 {
-    char tmpbuf[1024];
+    char tmpbuf[2048];
     int replysize;
     int r = 0;
     int csoc = -1;
diff -pruN 3.0.13-5/imap/global.c 3.2.0-3/imap/global.c
--- 3.0.13-5/imap/global.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/global.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <ctype.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/statvfs.h>
 #include <sys/types.h>
@@ -63,7 +64,7 @@
 #include "acl.h"
 #include "assert.h"
 #include "charset.h"
-#include "exitcodes.h"
+#include "cyr_lock.h"
 #include "gmtoff.h"
 #include "iptostring.h"
 #include "global.h"
@@ -76,9 +77,11 @@
 #include "userdeny.h"
 #include "util.h"
 #include "xmalloc.h"
+#include "xstrlcat.h"
 #include "xstrlcpy.h"
 
 /* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
 #include "imap/imap_err.h"
 #include "imap/mupdate_err.h"
 
@@ -153,6 +156,30 @@ static int get_facility(const char *name
     return SYSLOG_FACILITY;
 }
 
+struct cyrus_module {
+    void (*done)(void *rock);
+    void *rock;
+};
+
+static ptrarray_t cyrus_modules = PTRARRAY_INITIALIZER;
+
+EXPORTED void cyrus_modules_add(void (*done)(void*), void *rock)
+{
+    struct cyrus_module *cm = xmalloc(sizeof(struct cyrus_module));
+    cm->done = done;
+    cm->rock = rock;
+    ptrarray_append(&cyrus_modules, cm);
+}
+
+static void cyrus_modules_done()
+{
+    struct cyrus_module *cm;
+    while ((cm = ptrarray_pop(&cyrus_modules))) {
+        cm->done(cm->rock);
+        free(cm);
+    }
+}
+
 /* Called before a cyrus application starts (but after command line parameters
  * are read) */
 EXPORTED int cyrus_init(const char *alt_config, const char *ident, unsigned flags, int config_need_data)
@@ -163,9 +190,10 @@ EXPORTED int cyrus_init(const char *alt_
     int umaskval = 0;
     int syslog_opts = LOG_PID;
     const char *facility;
+    char *ident_buf = NULL;
 
-    if(cyrus_init_run != NOT_RUNNING) {
-        fatal("cyrus_init called twice!", EC_CONFIG);
+    if (cyrus_init_run != NOT_RUNNING) {
+        fatal("cyrus_init called twice!", EX_CONFIG);
     } else {
         cyrus_init_run = RUNNING;
     }
@@ -176,45 +204,64 @@ EXPORTED int cyrus_init(const char *alt_
         syslog_opts |= LOG_PERROR;
 #endif
 
+    initialize_http_error_table();
     initialize_imap_error_table();
     initialize_mupd_error_table();
 
-    if(!ident)
-        fatal("service name was not specified to cyrus_init", EC_CONFIG);
+    /* various things can run our commands with only two file descriptors, e.g. old strace on FreeBSD,
+     * or IPC::Run from Perl.  Make sure we don't accidentally reuse low FD numbers */
+    while (1) {
+        int fd = open("/dev/null", 0);
+        if (fd == -1) fatal("can't open /dev/null", EX_SOFTWARE);
+        if (fd >= 3) {
+            close(fd);
+            break;
+        }
+    }
+
+    if (!ident)
+        fatal("service name was not specified to cyrus_init", EX_SOFTWARE);
 
     config_ident = ident;
 
-    /* xxx we lose here since we can't have the prefix until we load the
-     * config file */
-    openlog(config_ident, syslog_opts, SYSLOG_FACILITY);
+    /* If we have the syslog prefix in the environment, set it before reading
+     * config, so that config read failures get logged with the right prefix!
+     */
+    if ((prefix = getenv("CYRUS_SYSLOG_PREFIX"))) {
+        ident_buf = strconcat(prefix, "/", ident, NULL);
+        openlog(ident_buf, syslog_opts, SYSLOG_FACILITY);
+    }
+    else {
+        openlog(config_ident, syslog_opts, SYSLOG_FACILITY);
+    }
 
     /* Load configuration file.  This will set config_dir when it finds it */
     config_read(alt_config, config_need_data);
 
     /* changed user if needed */
     if ((geteuid()) == 0 && (become_cyrus(/*is_master*/0) != 0)) {
-        fatal("must run as the Cyrus user", EC_USAGE);
+        fatal("must run as the Cyrus user", EX_USAGE);
     }
 
-
+    /* Now that we have config loaded, we might need to openlog again with
+     * the configured facility and/or prefix. */
     prefix = config_getstring(IMAPOPT_SYSLOG_PREFIX);
     facility = config_getstring(IMAPOPT_SYSLOG_FACILITY);
-
-    /* Reopen the log with the new prefix, if needed  */
     if (prefix || facility) {
-        char *ident_buf;
         int facnum = facility ? get_facility(facility) : SYSLOG_FACILITY;
 
-        if (prefix)
-            ident_buf = strconcat(prefix, "/", ident, (char *)NULL);
-        else
-            ident_buf = xstrdup(ident);
+        /* The $CYRUS_SYSLOG_PREFIX environment variable takes precedence */
+        if (!ident_buf) {
+            if (prefix)
+                ident_buf = strconcat(prefix, "/", ident, NULL);
+            else
+                ident_buf = xstrdup(ident);
+        }
 
         closelog();
         openlog(ident_buf, syslog_opts, facnum);
-
-        /* don't free the openlog() string! */
     }
+    /* Do not free ident_buf, syslog needs it for the life of this process! */
 
     /* allow debug logging */
     if (!config_debug)
@@ -225,7 +272,7 @@ EXPORTED int cyrus_init(const char *alt_
     for (p = (char *)config_defpartition; p && *p; p++) {
         if (!Uisalnum(*p))
           fatal("defaultpartition option contains non-alphanumeric character",
-                EC_CONFIG);
+                EX_CONFIG);
         if (Uisupper(*p)) *p = tolower((unsigned char) *p);
     }
 
@@ -270,7 +317,7 @@ EXPORTED int cyrus_init(const char *alt_
         charset_flags |= CHARSET_MIME_UTF8;
 
     /* Set snippet conversion flags. */
-    charset_snippet_flags = CHARSET_SNIPPET;
+    charset_snippet_flags = CHARSET_KEEPCASE;
     if (config_getenum(IMAPOPT_SEARCH_ENGINE) != IMAP_ENUM_SEARCH_ENGINE_XAPIAN) {
         /* All search engines other than Xapian require escaped HTML */
         charset_snippet_flags |= CHARSET_ESCAPEHTML;
@@ -303,8 +350,8 @@ EXPORTED int cyrus_init(const char *alt_
                                   config_getswitch(IMAPOPT_SKIPLIST_UNSAFE));
         libcyrus_config_setstring(CYRUSOPT_TEMP_PATH,
                                   config_getstring(IMAPOPT_TEMP_PATH));
-        libcyrus_config_setint(CYRUSOPT_PTS_CACHE_TIMEOUT,
-                               config_getint(IMAPOPT_PTSCACHE_TIMEOUT));
+        libcyrus_config_setint(CYRUSOPT_PTS_CACHE_TIMEOUT, /* <-- n.b. still an int */
+                               config_getduration(IMAPOPT_PTSCACHE_TIMEOUT, 's'));
         libcyrus_config_setswitch(CYRUSOPT_FULLDIRHASH,
                                   config_getswitch(IMAPOPT_FULLDIRHASH));
         libcyrus_config_setstring(CYRUSOPT_PTSCACHE_DB,
@@ -338,6 +385,12 @@ EXPORTED int cyrus_init(const char *alt_
         libcyrus_init();
     }
 
+    /* debug lock timing */
+    const char *locktime = config_getstring(IMAPOPT_LOCK_DEBUGTIME);
+    if (locktime) {
+        debug_locks_longer_than = atof(locktime);
+    }
+
     return 0;
 }
 
@@ -363,11 +416,11 @@ EXPORTED void global_sasl_init(int clien
                    (sasl_mutex_free_t *) &cyrus_mutex_free);
 
     if(client && sasl_client_init(callbacks)) {
-        fatal("could not init sasl (client)", EC_SOFTWARE);
+        fatal("could not init sasl (client)", EX_SOFTWARE);
     }
 
     if(server && sasl_server_init(callbacks, "Cyrus")) {
-        fatal("could not init sasl (server)", EC_SOFTWARE);
+        fatal("could not init sasl (server)", EX_SOFTWARE);
     }
 }
 
@@ -717,6 +770,7 @@ EXPORTED int mysasl_proxy_policy(sasl_co
 /* call before a cyrus application exits */
 EXPORTED void cyrus_done(void)
 {
+    cyrus_modules_done();
     if (cyrus_init_run != RUNNING)
         return;
     cyrus_init_run = DONE;
@@ -732,16 +786,39 @@ EXPORTED void cyrus_done(void)
 EXPORTED int shutdown_file(char *buf, int size)
 {
     FILE *f;
-    static char shutdownfilename[1024] = "";
+    static char *shutdownfilename = NULL, *suffix;
     char *p;
     char tmpbuf[1024];
 
-    if (!shutdownfilename[0])
-        snprintf(shutdownfilename, sizeof(shutdownfilename),
-                 "%s/msg/shutdown", config_dir);
+    if (!shutdownfilename) {
+        /* Create system shutdownfile name */
+        struct buf buf = BUF_INITIALIZER;
+        size_t system_len;
+
+        buf_printf(&buf, "%s/msg/shutdown", config_dir);
+        system_len = buf_len(&buf);
+
+        /* Add per-service suffix */
+        buf_printf(&buf, ".%s", config_ident);
+        shutdownfilename = buf_release(&buf);
+        suffix = shutdownfilename + system_len;
+    }
 
+    /* Try per-service shutdown file */
     f = fopen(shutdownfilename, "r");
-    if (!f) return 0;
+    if (!f) {
+        /* Trim per-service suffix and try system shutdownfile */
+        *suffix = '\0';
+
+        f = fopen(shutdownfilename, "r");
+        if (!f) {
+            /* Restore per-service suffix */
+            *suffix = '.';
+            return 0;
+        }
+    }
+
+    free(shutdownfilename);
 
     if (!buf) {
         buf = tmpbuf;
@@ -782,10 +859,10 @@ EXPORTED void session_new_id(void)
     unsigned long long random;
     RAND_bytes((unsigned char *) &random, sizeof(random));
     snprintf(session_id_buf, MAX_SESSIONID_SIZE, "%.128s-%d-%d-%d-%llu",
-             base, getpid(), session_id_time, session_id_count, random);
+             base, session_id_time, getpid(), session_id_count, random);
 #else
     snprintf(session_id_buf, MAX_SESSIONID_SIZE, "%.128s-%d-%d-%d",
-             base, getpid(), session_id_time, session_id_count);
+             base, session_id_time, getpid(), session_id_count);
 #endif
 }
 
@@ -979,7 +1056,7 @@ EXPORTED const char *get_clienthost(int
                 *remoteip = ripbuf;
             }
         } else {
-            fatal("can't get local addr", EC_SOFTWARE);
+            fatal("can't get local addr", EX_SOFTWARE);
         }
     } else {
         /* we're not connected to a internet socket! */
@@ -989,11 +1066,56 @@ EXPORTED const char *get_clienthost(int
     return buf_cstring(&clientbuf);
 }
 
-EXPORTED int cmd_cancelled()
+EXPORTED int cmd_cancelled(int insearch)
 {
     if (signals_cancelled())
         return IMAP_CANCELLED;
-    if (cmdtime_checksearch())
+    if (insearch && cmdtime_checksearch())
         return IMAP_SEARCH_SLOW;
     return 0;
 }
+
+EXPORTED void saslprops_reset(struct saslprops_t *saslprops)
+{
+    buf_reset(&saslprops->iplocalport);
+    buf_reset(&saslprops->ipremoteport);
+    buf_reset(&saslprops->authid);
+    saslprops->ssf = 0;
+    saslprops->cbinding.name = NULL;
+}
+
+EXPORTED void saslprops_free(struct saslprops_t *saslprops)
+{
+    buf_free(&saslprops->iplocalport);
+    buf_free(&saslprops->ipremoteport);
+    buf_free(&saslprops->authid);
+}
+
+EXPORTED int saslprops_set_tls(struct saslprops_t *saslprops,
+                               sasl_conn_t *saslconn)
+{
+    int r;
+
+    r = sasl_setprop(saslconn, SASL_SSF_EXTERNAL, &saslprops->ssf);
+    if (r != SASL_OK) {
+        syslog(LOG_NOTICE, "sasl_setprop(SSF_EXTERNAL) failed");
+        return r;
+    }
+
+    r = sasl_setprop(saslconn, SASL_AUTH_EXTERNAL,
+                     buf_cstringnull(&saslprops->authid));
+    if (r != SASL_OK) {
+        syslog(LOG_NOTICE, "sasl_setprop(AUTH_EXTERNAL) failed");
+        return r;
+    }
+
+    if (saslprops->cbinding.name) {
+        r = sasl_setprop(saslconn, SASL_CHANNEL_BINDING, &saslprops->cbinding);
+        if (r != SASL_OK) {
+            syslog(LOG_NOTICE, "sasl_setprop(CHANNEL_BINDING) failed");
+            return r;
+        }
+    }
+
+    return SASL_OK;
+}
diff -pruN 3.0.13-5/imap/global.h 3.2.0-3/imap/global.h
--- 3.0.13-5/imap/global.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/global.h	2020-04-24 02:03:00.000000000 +0000
@@ -52,10 +52,16 @@
 #include "imapparse.h"
 #include "util.h"
 
-#define MAX_SESSIONID_SIZE 256
+#ifdef HAVE_SSL
+#include <openssl/evp.h>
+#define MAX_FINISHED_LEN EVP_MAX_MD_SIZE
+
+#else /* !HAVE_SSL */
+#define MAX_FINISHED_LEN 1
+#endif /* HAVE_SSL */
+
 
-/* This is a string because we only ever use it as a string */
-#define SPHINX_MAX_MATCHES          "1000000"
+#define MAX_SESSIONID_SIZE 256
 
 /* Flags for cyrus_init() */
 enum {
@@ -72,6 +78,10 @@ extern int cyrus_init(const char *alt_co
 extern void global_sasl_init(int client, int server,
                              const sasl_callback_t *callbacks);
 
+/* Register a module callback. This callback will be called
+ * during cyrus_done, passing callback data rock */
+extern void cyrus_modules_add(void (*done)(void*), void *rock);
+
 /* Shutdown a cyrus process */
 extern void cyrus_done(void);
 
@@ -83,7 +93,11 @@ extern int mysasl_config(void *context,
                          unsigned *len);
 extern sasl_security_properties_t *mysasl_secprops(int flags);
 
+#if GCC_VERSION >= 80000
+typedef void mysasl_cb_ft;  /* shut up GCC */
+#else
 typedef int (mysasl_cb_ft)(void);
+#endif
 
 /* user canonification */
 extern const char *canonify_userid(char *user, const char *loginid,
@@ -122,12 +136,28 @@ struct proxy_context {
     int *userisproxyadmin;
 };
 
+struct saslprops_t {
+    struct buf iplocalport;
+    struct buf ipremoteport;
+    sasl_ssf_t ssf;
+    struct buf authid;
+    sasl_channel_binding_t cbinding;
+    unsigned char tls_finished[MAX_FINISHED_LEN];
+};
+#define SASLPROPS_INITIALIZER \
+    { BUF_INITIALIZER, BUF_INITIALIZER, 0, BUF_INITIALIZER, \
+      { NULL, 0, 0, NULL }, { 0 } }
+
 /* Misc utils */
 extern int shutdown_file(char *buf, int size);
 extern char *find_msgid(char *, char **);
 #define UNIX_SOCKET "[unix socket]"
 extern const char *get_clienthost(int s,
                                   const char **localip, const char **remoteip);
+extern void saslprops_reset(struct saslprops_t *saslprops);
+extern void saslprops_free(struct saslprops_t *saslprops);
+extern int saslprops_set_tls(struct saslprops_t *saslprops,
+                             sasl_conn_t *saslconn);
 
 /* Misc globals */
 extern int in_shutdown;
@@ -159,6 +189,6 @@ extern void parse_sessionid(const char *
 /* Capability suppression */
 extern int capa_is_disabled(const char *str);
 
-extern int cmd_cancelled();
+extern int cmd_cancelled(int insearch);
 
 #endif /* INCLUDED_GLOBAL_H */
diff -pruN 3.0.13-5/imap/http_admin.c 3.2.0-3/imap/http_admin.c
--- 3.0.13-5/imap/http_admin.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_admin.c	2020-04-24 02:03:00.000000000 +0000
@@ -58,6 +58,8 @@
 #include <sys/statvfs.h>
 #include <sys/types.h>
 
+#include "lib/times.h"
+#include "cyr_qsort_r.h"
 #include "global.h"
 #include "httpd.h"
 #include "http_proxy.h"
@@ -91,7 +93,7 @@ static int action_conf(struct transactio
 
 /* Namespace for admin service */
 struct namespace_t namespace_admin = {
-    URL_NS_ADMIN, 1, "/admin", NULL,
+    URL_NS_ADMIN, 1, "admin", "/admin", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -99,6 +101,7 @@ struct namespace_t namespace_admin = {
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get,            NULL },                 /* GET          */
@@ -461,7 +464,7 @@ static int add_procinfo(pid_t pid,
         unsigned long long starttime = 0;
         char state = 0, *s = NULL;
 
-        fscanf(f, "%d %ms %c " /* 1-3 */
+        int c = fscanf(f, "%d %ms %c " /* 1-3 */
                "%d %d %d %d %d %u " /* 4-9 */
                "%lu %lu %lu %lu %lu %lu " /* 10-15 */
                "%ld %ld %ld %ld %ld %ld " /* 16-21 */
@@ -475,56 +478,16 @@ static int add_procinfo(pid_t pid,
         free(s);
         fclose(f);
 
-        pinfo->state = state;
-        pinfo->vmsize = vmsize;
-        pinfo->start = starttime/sysconf(_SC_CLK_TCK);
+        if (c != EOF) {
+            pinfo->state = state;
+            pinfo->vmsize = vmsize;
+            pinfo->start = starttime/sysconf(_SC_CLK_TCK);
+        }
     }
 
     return 0;
 }
 
-#if defined(_GNU_SOURCE) && defined (__GLIBC__) && \
-	((__GLIBC__ > 2) || ((__GLIBC__ == 2) && (__GLIBC_MINOR__ >=0)))
-#define HAVE_GLIBC_QSORT_R
-#endif
-
-#if defined(__NEWLIB__) && \
-	((__NEWLIB__ > 2) || ((__NEWLIB__ == 2) && (__NEWLIB_MINOR__ >= 2)))
-#if defined(_GNU_SOURCE)
-#define HAVE_GLIBC_QSORT_R
-#else
-#define HAVE_BSD_QSORT_R
-#endif
-#endif
-
-#if !defined(HAVE_GLIBC_QSORT_R) && \
-	(defined(__FreeBSD__) || defined(__DragonFly__) || defined(__APPLE__))
-#define HAVE_BSD_QSORT_R
-#endif
-
-#ifdef HAVE_BSD_QSORT_R
-#define QSORT_R_COMPAR_ARGS(a,b,c) (c,a,b)
-#define cyr_qsort_r(base, nmemb, size, compar, thunk) qsort_r(base, nmemb, size, thunk, compar)
-#else
-#define QSORT_R_COMPAR_ARGS(a,b,c) (a,b,c)
-#  if defined(HAVE_GLIBC_QSORT_R)
-#define cyr_qsort_r(base, nmemb, size, compar, thunk) qsort_r(base, nmemb, size, compar, thunk)
-#  elif defined(__GNUC__)
-static void cyr_qsort_r(void *base, size_t nmemb, size_t size,
-                        int (*compar)(const void *, const void *, void *),
-                        void *thunk)
-{
-    int compar_func(const void *a, const void *b)
-    {
-        return compar(a, b, thunk);
-    }
-    qsort(base, nmemb, size, compar_func);
-}
-#  else
-#    error No qsort_r support
-#  endif
-#endif
-
 static int sort_procinfo QSORT_R_COMPAR_ARGS(
                          const void *pa, const void *pb,
                          void *k)
@@ -703,10 +666,6 @@ static int action_proc(struct transactio
                 /* X */ "", /* Y */ "",
                 /* Z */ " (zombie)"
             };
-            const char *monthname[] = {
-                "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
-            };
 
             buf_printf_markup(body, level, "<td>%c%s</td>", pinfo->state,
                               isupper((int) pinfo->state) ?
@@ -1258,7 +1217,7 @@ static int action_conf(struct transactio
         /* Add the overflow options */
         for (k = OVER_PARTITION; k >= OVER_UNKNOWN; k--) {
             if (crock.overflow[k].count) {
-                const char *colname;
+                const char *colname = "UNKNOWN";
 
                 switch (k) {
                 case OVER_UNKNOWN:
diff -pruN 3.0.13-5/imap/http_applepush.c 3.2.0-3/imap/http_applepush.c
--- 3.0.13-5/imap/http_applepush.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_applepush.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 
 #include "acl.h"
 #include "httpd.h"
+#include "http_dav.h"
 #include "util.h"
 #include <syslog.h>
 
@@ -57,7 +58,7 @@ static int meth_get_applepush(struct tra
 static int meth_post_applepush(struct transaction_t *txn, void *params);
 
 struct namespace_t namespace_applepush = {
-    URL_NS_APPLEPUSH, /*enabled*/0, "/applepush/subscribe", NULL,
+    URL_NS_APPLEPUSH, /*enabled*/0, "applepush", "/applepush/subscribe", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ|ALLOW_POST,
@@ -65,6 +66,7 @@ struct namespace_t namespace_applepush =
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get_applepush,  NULL },                 /* GET          */
@@ -122,7 +124,8 @@ static int meth_get_applepush(struct tra
     mailbox_uniqueid = strarray_nth(keyparts, 1);
 
     /* lookup mailbox */
-    mboxname = mboxlist_find_uniqueid(mailbox_uniqueid, mailbox_userid);
+    mboxname = mboxlist_find_uniqueid(mailbox_uniqueid, mailbox_userid,
+                                      httpd_authstate);
     if (!mboxname) {
         syslog(LOG_ERR,
                "meth_get_applepush: mboxlist_find_uniqueid(%s, %s) not found",
@@ -188,8 +191,7 @@ static int meth_post_applepush(struct tr
         /* Read body */
         txn->req_body.flags |= BODY_DECODE;
 
-        int r = http_read_body(httpd_in, httpd_out,
-                               txn->req_hdrs, &txn->req_body, &txn->error.desc);
+        int r = http_read_req_body(txn);
         if (r) {
             txn->flags.conn = CONN_CLOSE;
             return r;
@@ -207,3 +209,87 @@ static int meth_post_applepush(struct tr
 
     return meth_get_applepush(txn, params);
 }
+
+
+/* Apple push notifications
+   https://github.com/apple/ccs-calendarserver/blob/master/doc/Extensions/caldav-pubsubdiscovery.txt
+*/
+int propfind_push_transports(const xmlChar *name, xmlNsPtr ns,
+                             struct propfind_ctx *fctx,
+                             xmlNodePtr prop __attribute__((unused)),
+                             xmlNodePtr resp,
+                             struct propstat propstat[],
+                             void *rock __attribute__((unused)))
+{
+    xmlNodePtr node, transport, subscription_url;
+
+    assert(fctx->req_tgt->namespace->id == URL_NS_CALENDAR ||
+           fctx->req_tgt->namespace->id == URL_NS_ADDRESSBOOK);
+
+    if (!namespace_applepush.enabled) return HTTP_NOT_FOUND;
+
+    /* Only on home sets */
+    if (fctx->req_tgt->collection) return HTTP_NOT_FOUND;
+
+    if (!propstat) {
+        /* Prescreen "property" request - add namespace for environment */
+        ensure_ns(fctx->ns, NS_MOBME, fctx->root, XML_NS_MOBME, "MM");
+        return 0;
+    }
+
+    const char *aps_topic =
+        config_getstring(fctx->req_tgt->namespace->id == URL_NS_CALENDAR ?
+                         IMAPOPT_APS_TOPIC_CALDAV : IMAPOPT_APS_TOPIC_CARDDAV);
+    if (!aps_topic) {
+        syslog(LOG_DEBUG, "aps_topic_%s not configured,"
+               " can't build CS:push-transports response",
+               fctx->req_tgt->namespace->id == URL_NS_CALENDAR ?
+               "caldav" : "carddav");
+        return HTTP_NOT_FOUND;
+    }
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_CS], &propstat[PROPSTAT_OK],
+                        name, ns, NULL, 0);
+
+    transport = xmlNewChild(node, NULL, BAD_CAST "transport", NULL);
+    xmlNewProp(transport, BAD_CAST "type", BAD_CAST "APSD");
+
+    subscription_url =
+        xmlNewChild(transport, NULL, BAD_CAST "subscription-url", NULL);
+    xml_add_href(subscription_url, fctx->ns[NS_DAV], namespace_applepush.prefix);
+
+    xmlNewChild(transport, NULL, BAD_CAST "apsbundleid", BAD_CAST aps_topic);
+
+    // XXX from config, I think?
+    ensure_ns(fctx->ns, NS_MOBME, resp->parent, XML_NS_MOBME, "MM");
+    xmlNewChild(transport, fctx->ns[NS_MOBME],
+                BAD_CAST "env", BAD_CAST "PRODUCTION");
+
+    // XXX from config
+    xmlNewChild(transport, NULL,
+                BAD_CAST "refresh-interval", BAD_CAST "86400");
+
+    return 0;
+}
+
+int propfind_pushkey(const xmlChar *name, xmlNsPtr ns,
+                     struct propfind_ctx *fctx,
+                     xmlNodePtr prop __attribute__((unused)),
+                     xmlNodePtr resp __attribute__((unused)),
+                     struct propstat propstat[],
+                     void *rock __attribute__((unused)))
+{
+    if (!namespace_applepush.enabled) return HTTP_NOT_FOUND;
+
+    /* Only on collections */
+    if (!fctx->req_tgt->collection) return HTTP_NOT_FOUND;
+
+    /* key is userid and mailbox uniqueid */
+    buf_reset(&fctx->buf);
+    buf_printf(&fctx->buf, "%s/%s",
+               fctx->req_tgt->userid, fctx->mailbox->uniqueid);
+    xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                 name, ns, BAD_CAST buf_cstring(&fctx->buf), 0);
+
+    return 0;
+}
diff -pruN 3.0.13-5/imap/http_caldav.c 3.2.0-3/imap/http_caldav.c
--- 3.0.13-5/imap/http_caldav.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_caldav.c	2020-05-04 03:28:02.000000000 +0000
@@ -48,13 +48,13 @@
  *     calendars.
  *   - Support COPY/MOVE on collections
  *   - Add more required properties?
- *   - calendar-query REPORT (handle timezone, timezone-id)
  *   - free-busy-query REPORT (check ACL and transp on all calendars)
  *   - sync-collection REPORT - need to handle Depth infinity?
  */
 
 #include <config.h>
 
+#include <sysexits.h>
 #include <syslog.h>
 
 #include <libical/ical.h>
@@ -66,16 +66,18 @@
 #include "append.h"
 #include "caldav_db.h"
 #include "charset.h"
-#include "exitcodes.h"
+#include "css3_color.h"
 #include "global.h"
 #include "hash.h"
 #include "httpd.h"
 #include "http_caldav.h"
 #include "http_caldav_sched.h"
 #include "http_dav.h"
+#include "http_dav_sharing.h"
 #include "http_proxy.h"
 #include "index.h"
 #include "ical_support.h"
+#include "jmap_ical.h"
 #include "jcal.h"
 #include "xcal.h"
 #include "map.h"
@@ -89,6 +91,7 @@
 #include "strhash.h"
 #include "stristr.h"
 #include "tok.h"
+#include "user.h"
 #include "util.h"
 #include "version.h"
 #include "webdav_db.h"
@@ -103,7 +106,10 @@
 #include "imap/http_err.h"
 #include "imap/imap_err.h"
 
-#define TZ_STRIP (1<<9)
+#define TZ_STRIP  (1<<9)
+
+#define SHARED_MODSEQ \
+    DAV_ANNOT_NS "<" XML_NS_CYRUS ">shared-modseq"
 
 
 #ifdef HAVE_RSCALE
@@ -134,23 +140,31 @@ struct partial_comp_t {
     struct partial_comp_t *child;
 };
 
-static struct partial_caldata_t {
+struct partial_caldata_t {
     unsigned expand : 1;
     struct icalperiodtype range;
     struct partial_comp_t *comp;
-} partial_caldata;
+};
 
 static int meth_options_cal(struct transaction_t *txn, void *params);
 static int meth_get_head_cal(struct transaction_t *txn, void *params);
 static int meth_get_head_fb(struct transaction_t *txn, void *params);
 
 static void my_caldav_init(struct buf *serverinfo);
-static void my_caldav_auth(const char *userid);
+static int my_caldav_auth(const char *userid);
 static void my_caldav_reset(void);
 static void my_caldav_shutdown(void);
 
-static int caldav_parse_path(const char *path,
-                             struct request_target_t *tgt, const char **errstr);
+static unsigned long caldav_allow_cb(struct request_target_t *tgt);
+static int caldav_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr);
+
+static int caldav_get_validators(struct mailbox *mailbox, void *data,
+                                 const char *userid, struct index_record *record,
+                                 const char **etag, time_t *lastmod);
+
+static modseq_t caldav_get_modseq(struct mailbox *mailbox,
+                                  void *data, const char *userid);
 
 static int caldav_check_precond(struct transaction_t *txn,
                                 struct meth_params *params,
@@ -166,6 +180,7 @@ static int caldav_delete_cal(struct tran
                              struct index_record *record, void *data);
 static int caldav_get(struct transaction_t *txn, struct mailbox *mailbox,
                       struct index_record *record, void *data, void **obj);
+static int caldav_mkcol(struct mailbox *mailbox);
 static int caldav_post(struct transaction_t *txn);
 static int caldav_patch(struct transaction_t *txn, void *obj);
 static int caldav_put(struct transaction_t *txn, void *obj,
@@ -218,10 +233,6 @@ static int propfind_schedtag(const xmlCh
                              struct propfind_ctx *fctx,
                              xmlNodePtr prop, xmlNodePtr resp,
                              struct propstat propstat[], void *rock);
-static int propfind_caltransp(const xmlChar *name, xmlNsPtr ns,
-                              struct propfind_ctx *fctx,
-                              xmlNodePtr prop, xmlNodePtr resp,
-                              struct propstat propstat[], void *rock);
 static int proppatch_caltransp(xmlNodePtr prop, unsigned set,
                                struct proppatch_ctx *pctx,
                                struct propstat propstat[], void *rock);
@@ -268,7 +279,9 @@ static int report_fb_query(struct transa
                            struct meth_params *rparams,
                            xmlNodePtr inroot, struct propfind_ctx *fctx);
 
-static const char *begin_icalendar(struct buf *buf);
+static const char *begin_icalendar(struct buf *buf, struct mailbox *mailbox,
+                                   const char *prodid, const char *name,
+                                   const char *desc, const char *color);
 static void end_icalendar(struct buf *buf);
 
 #define ICALENDAR_CONTENT_TYPE "text/calendar; charset=utf-8"
@@ -290,15 +303,20 @@ static struct mime_type_t caldav_mime_ty
       (void * (*)(const struct buf*)) &jcal_string_as_icalcomponent,
       NULL, &begin_jcal, &end_jcal
     },
+#ifdef WITH_JMAP
+    { "application/event+json; charset=utf-8", NULL, "jevent",
+      (struct buf* (*)(void *)) &icalcomponent_as_jevent_string,
+      (void * (*)(const struct buf*)) &jevent_string_as_icalcomponent,
+      NULL, NULL, NULL
+    },
+#endif
     { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
 };
 
 static struct patch_doc_t caldav_patch_docs[] = {
-#ifdef HAVE_VPATCH
     { ICALENDAR_CONTENT_TYPE "; component=VPATCH; optinfo=\"PATCH-VERSION:1\"",
       &caldav_patch },
-#endif
-    { NULL, &caldav_patch /* silence compiler when !HAVE_VPATCH */}
+    { NULL, &caldav_patch }
 };
 
 /* Array of supported REPORTs */
@@ -310,7 +328,7 @@ static const struct report_type_t caldav
 
     /* WebDAV ACL (RFC 3744) REPORTs */
     { "acl-principal-prop-set", NS_DAV, "multistatus", &report_acl_prin_prop,
-      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_DEPTH_ZERO },
+      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_NEED_PROPS | REPORT_DEPTH_ZERO },
 
     /* WebDAV Sync (RFC 6578) REPORTs */
     { "sync-collection", NS_DAV, "multistatus", &report_sync_col,
@@ -335,9 +353,10 @@ static const struct prop_entry caldav_pr
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_creationdate, NULL, NULL },
     { "displayname", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_fromdb, proppatch_todb, NULL },
-    { "getcontentlanguage", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PERUSER,
+      propfind_collectionname, proppatch_todb, NULL },
+    { "getcontentlanguage", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_fromhdr, NULL, "Content-Language" },
     { "getcontentlength", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
@@ -345,137 +364,195 @@ static const struct prop_entry caldav_pr
     { "getcontenttype", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getcontenttype, NULL, "Content-Type" },
-    { "getetag", NS_DAV, PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+    { "getetag", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getetag, NULL, NULL },
     { "getlastmodified", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getlastmod, NULL, NULL },
-    { "lockdiscovery", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "lockdiscovery", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_lockdisc, NULL, NULL },
     { "resourcetype", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_restype, proppatch_restype, "calendar" },
-    { "supportedlock", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "supportedlock", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_suplock, NULL, NULL },
 
     /* WebDAV Versioning (RFC 3253) properties */
-    { "supported-report-set", NS_DAV, PROP_COLLECTION,
+    { "supported-report-set", NS_DAV,
+      PROP_COLLECTION | PROP_PRESCREEN,
       propfind_reportset, NULL, (void *) caldav_reports },
+    { "supported-method-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_methodset, NULL, (void *) &caldav_allow_cb },
 
     /* WebDAV ACL (RFC 3744) properties */
-    { "owner", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "owner", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_owner, NULL, NULL },
-    { "group", NS_DAV, 0, NULL, NULL, NULL },
-    { "supported-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "group", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "supported-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_supprivset, NULL, NULL },
-    { "current-user-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "current-user-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_curprivset, NULL, NULL },
-    { "acl", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl", NS_DAV, PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_acl, NULL, NULL },
-    { "acl-restrictions", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl-restrictions", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_aclrestrict, NULL, NULL },
-    { "inherited-acl-set", NS_DAV, 0, NULL, NULL, NULL },
-    { "principal-collection-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "inherited-acl-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "principal-collection-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_princolset, NULL, NULL },
 
     /* WebDAV Quota (RFC 4331) properties */
-    { "quota-available-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-available-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
-    { "quota-used-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-used-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
 
     /* WebDAV Current Principal (RFC 5397) properties */
-    { "current-user-principal", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "current-user-principal", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_curprin, NULL, NULL },
 
     /* WebDAV POST (RFC 5995) properties */
-    { "add-member", NS_DAV, PROP_COLLECTION,
+    { "add-member", NS_DAV,
+      PROP_COLLECTION,
       propfind_addmember, NULL, NULL },
 
     /* WebDAV Sync (RFC 6578) properties */
-    { "sync-token", NS_DAV, PROP_COLLECTION,
+    { "sync-token", NS_DAV,
+      PROP_COLLECTION,
       propfind_sync_token, NULL, SYNC_TOKEN_URL_SCHEME },
 
     /* WebDAV Sharing (draft-pot-webdav-resource-sharing) properties */
-    { "share-access", NS_DAV, PROP_COLLECTION,
+    { "share-access", NS_DAV,
+      PROP_COLLECTION,
       propfind_shareaccess, NULL, NULL },
-    { "invite", NS_DAV, PROP_COLLECTION,
+    { "invite", NS_DAV,
+      PROP_COLLECTION,
       propfind_invite, NULL, NULL },
-    { "sharer-resource-uri", NS_DAV, PROP_COLLECTION,
+    { "sharer-resource-uri", NS_DAV,
+      PROP_COLLECTION,
       propfind_sharedurl, NULL, NULL },
 
     /* Backwards compatibility with Apple calendar sharing clients */
-    { "invite", NS_CS, PROP_COLLECTION,
+    { "invite", NS_CS,
+      PROP_COLLECTION,
       propfind_invite, NULL, "calendarserver-sharing" },
-    { "allowed-sharing-modes", NS_CS, PROP_COLLECTION,
+    { "allowed-sharing-modes", NS_CS,
+      PROP_COLLECTION,
       propfind_sharingmodes, NULL, NULL },
-    { "shared-url", NS_CS, PROP_COLLECTION,
+    { "shared-url", NS_CS,
+      PROP_COLLECTION,
       propfind_sharedurl, NULL, "calendarserver-sharing" },
 
     /* CalDAV (RFC 4791) properties */
-    { "calendar-data", NS_CALDAV, PROP_RESOURCE | PROP_PRESCREEN | PROP_CLEANUP,
-      propfind_caldata, NULL, &partial_caldata },
-    { "schedule-user-address", NS_CYRUS, PROP_RESOURCE,
+    { "calendar-data", NS_CALDAV,
+      PROP_RESOURCE | PROP_PRESCREEN | PROP_CLEANUP,
+      propfind_caldata, NULL, (void *) CALDAV_SUPP_DATA },
+    { "schedule-user-address", NS_CYRUS,
+      PROP_RESOURCE,
       propfind_scheduser, NULL, NULL },
-    { "calendar-description", NS_CALDAV, PROP_COLLECTION,
+    { "calendar-description", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER,
       propfind_fromdb, proppatch_todb, NULL },
-    { "calendar-timezone", NS_CALDAV, PROP_COLLECTION | PROP_PRESCREEN,
-      propfind_timezone, proppatch_timezone, NULL },
-    { "supported-calendar-component-set", NS_CALDAV, PROP_COLLECTION,
+    { "calendar-timezone", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER | PROP_PRESCREEN,
+      propfind_timezone, proppatch_timezone, (void *) CALDAV_SUPP_DATA },
+    { "supported-calendar-component-set", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calcompset, proppatch_calcompset, NULL },
-    { "supported-calendar-data", NS_CALDAV, PROP_COLLECTION,
+    { "supported-calendar-data", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_suppcaldata, NULL, NULL },
-    { "max-resource-size", NS_CALDAV, PROP_COLLECTION,
+    { "max-resource-size", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_maxsize, NULL, NULL },
-    { "min-date-time", NS_CALDAV, PROP_COLLECTION,
+    { "min-date-time", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_minmaxdate, NULL, &caldav_epoch },
-    { "max-date-time", NS_CALDAV, PROP_COLLECTION,
+    { "max-date-time", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_minmaxdate, NULL, &caldav_eternity },
-    { "max-instances", NS_CALDAV, 0, NULL, NULL, NULL },
-    { "max-attendees-per-instance", NS_CALDAV, 0, NULL, NULL, NULL },
+    { "max-instances", NS_CALDAV,
+      PROP_COLLECTION,
+      NULL, NULL, NULL },
+    { "max-attendees-per-instance", NS_CALDAV,
+      PROP_COLLECTION,
+      NULL, NULL, NULL },
 
     /* CalDAV Scheduling (RFC 6638) properties */
-    { "schedule-tag", NS_CALDAV, PROP_RESOURCE,
+    { "schedule-tag", NS_CALDAV,
+      PROP_RESOURCE,
       propfind_schedtag, NULL, NULL },
-    { "schedule-default-calendar-URL", NS_CALDAV, PROP_COLLECTION,
+    { "schedule-default-calendar-URL", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_scheddefault, NULL, NULL },
-    { "schedule-calendar-transp", NS_CALDAV, PROP_COLLECTION,
-      propfind_caltransp, proppatch_caltransp, NULL },
+    { "schedule-calendar-transp", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER,
+      propfind_fromdb, proppatch_caltransp, NULL },
+
+    /* CalDAV Sharing (draft-pot-caldav-sharing) properties */
+    { "calendar-user-address-set", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER,
+      propfind_caluseraddr, proppatch_caluseraddr, NULL },
 
     /* Calendar Availability (RFC 7953) properties */
-    { "calendar-availability", NS_CALDAV, PROP_COLLECTION | PROP_PRESCREEN,
-      propfind_availability, proppatch_availability, NULL },
+    { "calendar-availability", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER | PROP_PRESCREEN,
+      propfind_availability, proppatch_availability, (void *) CALDAV_SUPP_DATA },
 
     /* Backwards compatibility with Apple VAVAILABILITY clients */
-    { "calendar-availability", NS_CS, PROP_COLLECTION | PROP_PRESCREEN,
-      propfind_availability, proppatch_availability, NULL },
+    { "calendar-availability", NS_CS,
+      PROP_COLLECTION | PROP_PERUSER | PROP_PRESCREEN,
+      propfind_availability, proppatch_availability, (void *) CALDAV_SUPP_DATA },
 
     /* Time Zones by Reference (RFC 7809) properties */
-    { "timezone-service-set", NS_CALDAV, PROP_COLLECTION,
+    { "timezone-service-set", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_tzservset, NULL, NULL },
-    { "calendar-timezone-id", NS_CALDAV, PROP_COLLECTION,
+    { "calendar-timezone-id", NS_CALDAV,
+      PROP_COLLECTION | PROP_PERUSER,
       propfind_tzid, proppatch_tzid, NULL },
 
     /* RSCALE (RFC 7529) properties */
-    { "supported-rscale-set", NS_CALDAV, PROP_COLLECTION,
+    { "supported-rscale-set", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_rscaleset, NULL, NULL },
 
     /* CalDAV Extensions (draft-daboo-caldav-extensions) properties */
-    { "supported-calendar-component-sets", NS_CALDAV, PROP_COLLECTION,
+    { "supported-calendar-component-sets", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calcompset, NULL, NULL },
 
     /* Apple Calendar Server properties */
-    { "getctag", NS_CS, PROP_ALLPROP | PROP_COLLECTION,
+    { "getctag", NS_CS,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_sync_token, NULL, "" },
 
     /* Apple Mobile Me properties */
-    { "bulk-requests", NS_MECOM, PROP_COLLECTION,
+    { "bulk-requests", NS_MECOM,
+      PROP_COLLECTION,
       propfind_bulkrequests, NULL, NULL },
 
     /* Apple Push Notifications Service properties */
-    { "push-transports", NS_CS, PROP_COLLECTION,
+    { "push-transports", NS_CS,
+      PROP_COLLECTION | PROP_PRESCREEN,
       propfind_push_transports, NULL, (void *) MBTYPE_CALENDAR },
-    { "pushkey", NS_CS, PROP_COLLECTION,
+    { "pushkey", NS_CS,
+      PROP_COLLECTION,
       propfind_pushkey, NULL, NULL },
 
     { NULL, 0, 0, NULL, NULL, NULL }
@@ -485,6 +562,8 @@ static const struct prop_entry caldav_pr
 static struct meth_params caldav_params = {
     caldav_mime_types,
     &caldav_parse_path,
+    &caldav_get_validators,
+    &caldav_get_modseq,
     &caldav_check_precond,
     { (db_open_proc_t) &caldav_open_mailbox,
       (db_close_proc_t) &caldav_close,
@@ -492,16 +571,19 @@ static struct meth_params caldav_params
       (db_proc_t) &caldav_commit,
       (db_proc_t) &caldav_abort,
       (db_lookup_proc_t) &caldav_lookup_resource,
+      (db_imapuid_proc_t) &caldav_lookup_imapuid,
       (db_foreach_proc_t) &caldav_foreach,
+      (db_updates_proc_t) &caldav_get_updates,
       (db_write_proc_t) &caldav_write,
       (db_delete_proc_t) &caldav_delete },
     &caldav_acl,
     { CALDAV_UID_CONFLICT, &caldav_copy },
     &caldav_delete_cal,
     &caldav_get,
-    { CALDAV_LOCATION_OK, MBTYPE_CALENDAR },
+    { CALDAV_LOCATION_OK, MBTYPE_CALENDAR, &caldav_mkcol },
     caldav_patch_docs,
-    { POST_ADDMEMBER | POST_SHARE | POST_BULK, &caldav_post, &caldav_import },
+    { POST_ADDMEMBER | POST_SHARE, &caldav_post,
+      { NS_CALDAV, "calendar-data", &caldav_import } },
     { CALDAV_SUPP_DATA, &caldav_put },
     { 0, caldav_props },                        /* Allow infinite depth */
     caldav_reports
@@ -510,31 +592,28 @@ static struct meth_params caldav_params
 
 /* Namespace for CalDAV collections */
 struct namespace_t namespace_calendar = {
-    URL_NS_CALENDAR, 0, "/dav/calendars", "/.well-known/caldav",
+    URL_NS_CALENDAR, 0, "calendar", "/dav/calendars", "/.well-known/caldav",
     http_allow_noauth_get, /*authschemes*/0,
     MBTYPE_CALENDAR,
     (ALLOW_READ | ALLOW_POST | ALLOW_WRITE | ALLOW_DELETE |
-#ifdef HAVE_VPATCH
-     ALLOW_PATCH |
-#endif
-#ifdef HAVE_VAVAILABILITY
+     ALLOW_PATCH | ALLOW_USERDATA |
      ALLOW_CAL_AVAIL |
-#endif
      ALLOW_DAV | ALLOW_PROPPATCH | ALLOW_MKCOL | ALLOW_ACL | ALLOW_CAL ),
     &my_caldav_init, &my_caldav_auth, my_caldav_reset, &my_caldav_shutdown,
     &dav_premethod, /*bearer*/NULL,
     {
         { &meth_acl,            &caldav_params },       /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { &meth_copy_move,      &caldav_params },       /* COPY         */
         { &meth_delete,         &caldav_params },       /* DELETE       */
-        { &meth_get_head_cal,   NULL },                 /* GET          */
-        { &meth_get_head_cal,   NULL },                 /* HEAD         */
+        { &meth_get_head_cal,   &caldav_params },       /* GET          */
+        { &meth_get_head_cal,   &caldav_params },       /* HEAD         */
         { &meth_lock,           &caldav_params },       /* LOCK         */
         { &meth_mkcol,          &caldav_params },       /* MKCALENDAR   */
         { &meth_mkcol,          &caldav_params },       /* MKCOL        */
         { &meth_copy_move,      &caldav_params },       /* MOVE         */
-        { &meth_options_cal,    &caldav_parse_path },   /* OPTIONS      */
+        { &meth_options_cal,    &caldav_params },       /* OPTIONS      */
         { &meth_patch,          &caldav_params },       /* PATCH        */
         { &meth_post,           &caldav_params },       /* POST         */
         { &meth_propfind,       &caldav_params },       /* PROPFIND     */
@@ -550,7 +629,7 @@ struct namespace_t namespace_calendar =
 
 /* Namespace for Freebusy Read URL */
 struct namespace_t namespace_freebusy = {
-    URL_NS_FREEBUSY, 0, "/freebusy", NULL,
+    URL_NS_FREEBUSY, 0, "freebusy", "/freebusy", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     MBTYPE_CALENDAR,
     ALLOW_READ,
@@ -558,10 +637,11 @@ struct namespace_t namespace_freebusy =
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
-        { &meth_get_head_fb,    NULL },                 /* GET          */
-        { &meth_get_head_fb,    NULL },                 /* HEAD         */
+        { &meth_get_head_fb,    &caldav_params },       /* GET          */
+        { &meth_get_head_fb,    &caldav_params },       /* HEAD         */
         { NULL,                 NULL },                 /* LOCK         */
         { NULL,                 NULL },                 /* MKCALENDAR   */
         { NULL,                 NULL },                 /* MKCOL        */
@@ -588,12 +668,8 @@ static const struct cal_comp_t {
     { "VTODO",          CAL_COMP_VTODO },
     { "VJOURNAL",       CAL_COMP_VJOURNAL },
     { "VFREEBUSY",      CAL_COMP_VFREEBUSY },
-#ifdef HAVE_VAVAILABILITY
     { "VAVAILABILITY",  CAL_COMP_VAVAILABILITY },
-#endif
-#ifdef HAVE_VPOLL
     { "VPOLL",          CAL_COMP_VPOLL },
-#endif
 //    { "VTIMEZONE",    CAL_COMP_VTIMEZONE },
 //    { "VALARM",               CAL_COMP_VALARM },
     { NULL, 0 }
@@ -606,7 +682,6 @@ static void my_caldav_init(struct buf *s
     char *domain;
     tok_t tok;
 
-    buf_printf(serverinfo, " SQLite/%s", sqlite3_libversion());
     buf_printf(serverinfo, " LibiCal/%s", ICAL_VERSION);
 #ifdef HAVE_RSCALE
     if ((rscale_calendars = icalrecurrencetype_rscale_supported_calendars())) {
@@ -615,7 +690,6 @@ static void my_caldav_init(struct buf *s
         buf_printf(serverinfo, " ICU4C/%s", U_ICU_VERSION);
     }
 #endif
-    buf_printf(serverinfo, " Jansson/%s", JANSSON_VERSION);
 
     namespace_calendar.enabled =
         config_httpmodules & IMAP_ENUM_HTTPMODULES_CALDAV;
@@ -623,10 +697,9 @@ static void my_caldav_init(struct buf *s
     if (!namespace_calendar.enabled) return;
 
     if (!config_getstring(IMAPOPT_CALENDARPREFIX)) {
-        fatal("Required 'calendarprefix' option is not set", EC_CONFIG);
+        fatal("Required 'calendarprefix' option is not set", EX_CONFIG);
     }
 
-#ifdef HAVE_IANA_PARAMS
     config_allowsched = config_getenum(IMAPOPT_CALDAV_ALLOWSCHEDULING);
     if (config_allowsched) {
         namespace_calendar.allow |= ALLOW_CAL_SCHED;
@@ -638,23 +711,9 @@ static void my_caldav_init(struct buf *s
     if (config_getswitch(IMAPOPT_CALDAV_ALLOWATTACH))
         namespace_calendar.allow |= ALLOW_CAL_ATTACH;
 
-#endif /* HAVE_IANA_PARAMS */
-
-#ifdef HAVE_TZ_BY_REF
     if (namespace_tzdist.enabled) {
-        /* Tell libical to use our builtin TZ */
-        /* XXX  MUST be done before any use of libical, e.g caldav_init() */
-        char zonedir[MAX_MAILBOX_PATH+1];
-
-        snprintf(zonedir, MAX_MAILBOX_PATH, "%s%s",
-                 config_dir, FNAME_ZONEINFODIR);
-        set_zone_directory(zonedir);
-        icaltimezone_set_tzid_prefix("");
-        icaltimezone_set_builtin_tzdata(1);
-
         namespace_calendar.allow |= ALLOW_CAL_NOTZ;
     }
-#endif
 
     caldav_init();
     webdav_init();
@@ -670,10 +729,10 @@ static void my_caldav_init(struct buf *s
     compile_time = calc_compile_time(__TIME__, __DATE__);
 
     buf_printf(&ical_prodid_buf,
-               "-//CyrusIMAP.org/Cyrus %s//EN", cyrus_version());
+               "-//CyrusIMAP.org/Cyrus %s//EN", CYRUS_VERSION);
     ical_prodid = buf_cstring(&ical_prodid_buf);
 
-    /* Create an array of calendar-user-adddress-set domains */
+    /* Create an array of calendar-user-address-set domains */
     domains = config_getstring(IMAPOPT_CALENDAR_USER_ADDRESS_SET);
     if (!domains) domains = config_defdomain;
     if (!domains) domains = config_servername;
@@ -686,8 +745,9 @@ static void my_caldav_init(struct buf *s
 }
 
 static int _create_mailbox(const char *userid, const char *mailboxname,
-                           int type, int useracl, int anyoneacl,
-                           const char *displayname)
+                           int type, unsigned long comp_types,
+                           int useracl, int anyoneacl, const char *displayname,
+                           struct mboxlock **namespacelockp)
 {
     int r = 0;
     char rights[100];
@@ -697,6 +757,14 @@ static int _create_mailbox(const char *u
     if (!r) return 0;
     if (r != IMAP_MAILBOX_NONEXISTENT) return r;
 
+    if (!*namespacelockp) {
+        *namespacelockp = mboxname_usernamespacelock(mailboxname);
+        // maybe we lost the race on this one
+        r = mboxlist_lookup(mailboxname, NULL, NULL);
+        if (!r) return 0;
+        if (r != IMAP_MAILBOX_NONEXISTENT) return r;
+    }
+
     /* Create locally */
     r = mboxlist_createmailbox(mailboxname, type,
                                NULL, 0,
@@ -707,11 +775,19 @@ static int _create_mailbox(const char *u
 
         r = mailbox_get_annotate_state(mailbox, 0, &astate);
         if (!r) {
-            const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+            const char *disp_annot = DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+            const char *comp_annot =
+                DAV_ANNOT_NS "<" XML_NS_CALDAV ">supported-calendar-component-set";
             struct buf value = BUF_INITIALIZER;
 
             buf_init_ro_cstr(&value, displayname);
-            r = annotate_state_writemask(astate, annot, userid, &value);
+            r = annotate_state_writemask(astate, disp_annot, userid, &value);
+            if (!r && comp_types) {
+                buf_reset(&value);
+                buf_printf(&value, "%lu", comp_types);
+                r = annotate_state_writemask(astate, comp_annot, userid, &value);
+            }
+            buf_free(&value);
         }
 
         mailbox_close(&mailbox);
@@ -732,11 +808,35 @@ static int _create_mailbox(const char *u
     return r;
 }
 
+unsigned long config_types_to_caldav_types(void)
+{
+    unsigned long config_types =
+            config_getbitfield(IMAPOPT_CALENDAR_COMPONENT_SET);
+    unsigned long types = 0;
+
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VEVENT)
+        types |= CAL_COMP_VEVENT;
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VTODO)
+        types |= CAL_COMP_VTODO;
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VJOURNAL)
+        types |= CAL_COMP_VJOURNAL;
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VFREEBUSY)
+        types |= CAL_COMP_VFREEBUSY;
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VAVAILABILITY)
+        types |= CAL_COMP_VAVAILABILITY;
+#ifdef VPOLL
+    if (config_types & IMAP_ENUM_CALENDAR_COMPONENT_SET_VPOLL)
+        types |= CAL_COMP_VPOLL;
+#endif
+
+    return types;
+}
+
 int caldav_create_defaultcalendars(const char *userid)
 {
     int r;
     char *mailboxname;
-    struct buf acl = BUF_INITIALIZER;
+    struct mboxlock *namespacelock = NULL;
 
     /* calendar-home-set */
     mailboxname = caldav_mboxname(userid, NULL);
@@ -758,8 +858,9 @@ int caldav_create_defaultcalendars(const
         }
         mboxlist_entry_free(&mbentry);
 
-        if (!r) r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR,
-                                    ACL_ALL | DACL_READFB, DACL_READFB, NULL);
+        if (!r) r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR, 0,
+                                    ACL_ALL | DACL_READFB, DACL_READFB, NULL,
+                                    &namespacelock);
     }
 
     free(mailboxname);
@@ -767,9 +868,12 @@ int caldav_create_defaultcalendars(const
 
     if (config_getswitch(IMAPOPT_CALDAV_CREATE_DEFAULT)) {
         /* Default calendar */
+        unsigned long comp_types = config_types_to_caldav_types();
+
         mailboxname = caldav_mboxname(userid, SCHED_DEFAULT);
-        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR,
-                            ACL_ALL | DACL_READFB, DACL_READFB, "personal");
+        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR, comp_types,
+                            ACL_ALL | DACL_READFB, DACL_READFB, "personal",
+                            &namespacelock);
         free(mailboxname);
         if (r) goto done;
     }
@@ -778,15 +882,17 @@ int caldav_create_defaultcalendars(const
         namespace_calendar.allow & ALLOW_CAL_SCHED) {
         /* Scheduling Inbox */
         mailboxname = caldav_mboxname(userid, SCHED_INBOX);
-        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR,
-                            ACL_ALL | DACL_SCHED, DACL_SCHED, NULL);
+        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR, 0,
+                            ACL_ALL | DACL_SCHED, DACL_SCHED, NULL,
+                            &namespacelock);
         free(mailboxname);
         if (r) goto done;
 
         /* Scheduling Outbox */
         mailboxname = caldav_mboxname(userid, SCHED_OUTBOX);
-        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR,
-                            ACL_ALL | DACL_SCHED, 0, NULL);
+        r = _create_mailbox(userid, mailboxname, MBTYPE_CALENDAR, 0,
+                            ACL_ALL | DACL_SCHED, 0, NULL,
+                            &namespacelock);
         free(mailboxname);
         if (r) goto done;
     }
@@ -795,43 +901,48 @@ int caldav_create_defaultcalendars(const
         namespace_calendar.allow & ALLOW_CAL_ATTACH) {
         /* Managed Attachment Collection */
         mailboxname = caldav_mboxname(userid, MANAGED_ATTACH);
-        r = _create_mailbox(userid, mailboxname, MBTYPE_COLLECTION,
-                            ACL_ALL, ACL_READ, NULL);
+        r = _create_mailbox(userid, mailboxname, MBTYPE_COLLECTION, 0,
+                            ACL_ALL, ACL_READ, NULL,
+                            &namespacelock);
         free(mailboxname);
         if (r) goto done;
     }
 
   done:
-    buf_free(&acl);
+    if (namespacelock) mboxname_release(&namespacelock);
     return r;
 }
 
-static void my_caldav_auth(const char *userid)
+static int my_caldav_auth(const char *userid)
 {
-    int r;
-
     if (httpd_userisadmin ||
         global_authisa(httpd_authstate, IMAPOPT_PROXYSERVERS)) {
         /* admin or proxy from frontend - won't have DAV database */
-        return;
+        return 0;
     }
     if (config_mupdate_server && !config_getstring(IMAPOPT_PROXYSERVERS)) {
         /* proxy-only server - won't have DAV database */
-        return;
+        return 0;
     }
     else {
         /* Open CalDAV DB for 'userid' */
         my_caldav_reset();
         auth_caldavdb = caldav_open_userid(userid);
-        if (!auth_caldavdb) fatal("Unable to open CalDAV DB", EC_IOERR);
+        if (!auth_caldavdb) {
+            syslog(LOG_ERR, "Unable to open CalDAV DB for userid %s", userid);
+            return HTTP_UNAVAILABLE;
+        }
     }
 
     /* Auto-provision calendars for 'userid' */
-    r = caldav_create_defaultcalendars(userid);
+    int r = caldav_create_defaultcalendars(userid);
     if (r) {
         syslog(LOG_ERR, "could not autoprovision calendars for userid %s: %s",
                 userid, error_message(r));
+        return HTTP_SERVER_ERROR;
     }
+
+    return 0;
 }
 
 static void my_caldav_reset(void)
@@ -856,15 +967,51 @@ static void my_caldav_shutdown(void)
 }
 
 
+/* Determine allowed methods in CalDAV namespace */
+static unsigned long caldav_allow_cb(struct request_target_t *tgt)
+{
+    unsigned long allow = calcarddav_allow_cb(tgt);
+
+    if (!tgt->collection) {
+        if (tgt->userid) {
+            /* Allow POST to cal-home-set (share reply) */
+            allow |= ALLOW_POST;
+        }
+    }
+    else if (!strncmp(tgt->collection, MANAGED_ATTACH, strlen(MANAGED_ATTACH))) {
+        /* Read-only non-calendar collection */
+        allow = ALLOW_READ;
+    }
+    else if (!strncmp(tgt->collection, SCHED_INBOX, strlen(SCHED_INBOX))) {
+        /* Can only read and DELETE resources from this collection */
+        allow &= ALLOW_READ_MASK;
+
+        if (tgt->resource) allow |= ALLOW_DELETE;
+    }
+    else if (!strncmp(tgt->collection, SCHED_OUTBOX, strlen(SCHED_OUTBOX))){
+        /* Can only POST to this collection (free/busy request) */
+        allow &= ALLOW_READ_MASK;
+
+        if (!tgt->resource) allow |= ALLOW_POST;
+    }
+    else if (tgt->resource) {
+        /* Resource in regular calendar collection (POST for managed attach) */
+        allow |= ALLOW_POST;
+    }
+
+    return allow;
+}
+
+
 /* Parse request-target path in CalDAV namespace */
-static int caldav_parse_path(const char *path,
-                             struct request_target_t *tgt, const char **errstr)
+static int caldav_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr)
 {
     int r;
 
     r = calcarddav_parse_path(path, tgt,
                               config_getstring(IMAPOPT_CALENDARPREFIX),
-                              errstr);
+                              resultstr);
     if (r) return r;
 
     /* Set proper Allow bits based on collection */
@@ -873,8 +1020,10 @@ static int caldav_parse_path(const char
         tgt->allow = ALLOW_READ;
     }
     else if (!tgt->collection) {
-        /* Allow POST to cal-home-set (share reply) */
-        tgt->allow |= ALLOW_POST;
+        if (tgt->userid) {
+            /* Allow POST to cal-home-set (share reply) */
+            tgt->allow |= ALLOW_POST;
+        }
     }
     else if (!strncmp(tgt->collection, MANAGED_ATTACH, strlen(MANAGED_ATTACH))) {
         /* Read-only non-calendar collection */
@@ -907,6 +1056,141 @@ static int caldav_parse_path(const char
 }
 
 
+#define STRIP_OWNER_CAL_DATA              \
+    "CALDATA %(VPATCH {248+}\r\n"         \
+    "BEGIN:VPATCH\r\n"                    \
+    "VERSION:1\r\n"                       \
+    "DTSTAMP:19760401T005545Z\r\n"        \
+    "UID:strip-owner-cal-data\r\n"        \
+    "BEGIN:PATCH\r\n"                     \
+    "PATCH-TARGET:/VCALENDAR/ANY\r\n"     \
+    "PATCH-DELETE:/VALARM\r\n"            \
+    "PATCH-DELETE:#TRANSP\r\n"            \
+    "PATCH-DELETE:#X-MOZ-LASTACK\r\n"     \
+    "PATCH-DELETE:#X-MOZ-SNOOZE-TIME\r\n" \
+    "END:PATCH\r\n"                       \
+    "END:VPATCH\r\n)"
+
+
+HIDDEN int caldav_is_personalized(struct mailbox *mailbox,
+                                  const struct caldav_data *cdata,
+                                  const char *userid,
+                                  struct buf *userdata)
+{
+    if (cdata->comp_flags.shared) {
+        /* Lookup per-user calendar data */
+        int r = mailbox_get_annotate_state(mailbox, cdata->dav.imap_uid, NULL);
+
+        if (!r) {
+            mbname_t *mbname = NULL;
+
+            if (mailbox->i.options & OPT_IMAP_SHAREDSEEN) {
+                /* No longer using per-user-data - use owner data */
+                mbname = mbname_from_intname(mailbox->name);
+                userid = mbname_userid(mbname);
+            }
+
+            r = mailbox_annotation_lookup(mailbox, cdata->dav.imap_uid,
+                                          PER_USER_CAL_DATA, userid, userdata);
+            mbname_free(&mbname);
+        }
+
+        if (!r && buf_len(userdata)) return 1;
+        buf_free(userdata);
+    }
+    else if (!(mailbox->i.options & OPT_IMAP_SHAREDSEEN) &&
+             !mboxname_userownsmailbox(userid, mailbox->name)) {
+        buf_init_ro_cstr(userdata, STRIP_OWNER_CAL_DATA);
+        return 1;
+    }
+
+    return 0;
+}
+
+
+static int caldav_get_validators(struct mailbox *mailbox, void *data,
+                                 const char *userid, struct index_record *record,
+                                 const char **etag, time_t *lastmod)
+{
+
+    const struct caldav_data *cdata = (const struct caldav_data *) data;
+    struct buf userdata = BUF_INITIALIZER;
+
+    int r = dav_get_validators(mailbox, data, userid, record, etag, lastmod);
+    if (r) return r;
+
+    if ((namespace_calendar.allow & ALLOW_USERDATA) &&
+        cdata->dav.imap_uid && cdata->comp_flags.shared &&
+        caldav_is_personalized(mailbox, cdata, userid, &userdata)) {
+        struct dlist *dl;
+
+        /* Parse the userdata and fetch the validators */
+        dlist_parsemap(&dl, 1, 0, buf_base(&userdata), buf_len(&userdata));
+
+        if (etag) {
+            char buf[2*MESSAGE_GUID_SIZE];
+            struct message_guid *user_guid;
+
+            dlist_getguid(dl, "GUID", &user_guid);
+
+            /* Per-user ETag is GUID of concatenated GUIDs */
+            message_guid_export(&record->guid, buf);
+            message_guid_export(user_guid, buf+MESSAGE_GUID_SIZE);
+            message_guid_generate(user_guid, buf, sizeof(buf));
+            *etag = message_guid_encode(user_guid);
+        }
+        if (lastmod) {
+            time_t user_lastmod;
+
+            dlist_getdate(dl, "LASTMOD", &user_lastmod);
+
+            /* Per-user Last-Modified is latest mod time */
+            *lastmod = MAX(record->internaldate, user_lastmod);
+        }
+
+        dlist_free(&dl);
+        buf_free(&userdata);
+    }
+
+    return 0;
+}
+
+
+static modseq_t caldav_get_modseq(struct mailbox *mailbox,
+                                  void *data, const char *userid)
+{
+    struct caldav_data *cdata = (struct caldav_data *) data;
+    struct buf userdata = BUF_INITIALIZER;
+    modseq_t modseq = cdata->dav.modseq;
+
+    if ((namespace_calendar.allow & ALLOW_USERDATA) &&
+        cdata->comp_flags.shared &&
+        caldav_is_personalized(mailbox, cdata, userid, &userdata)) {
+        modseq_t shared_modseq = cdata->dav.modseq;
+        struct dlist *dl;
+        int r;
+
+        /* Parse the userdata and fetch the modseq */
+        dlist_parsemap(&dl, 1, 0, buf_base(&userdata), buf_len(&userdata));
+        dlist_getnum64(dl, "MODSEQ", &modseq);
+        dlist_free(&dl);
+        buf_free(&userdata);
+
+        /* Lookup shared modseq */
+        r = mailbox_annotation_lookup(mailbox, cdata->dav.imap_uid,
+                                      SHARED_MODSEQ, "", &userdata);
+        if (!r && buf_len(&userdata)) {
+            sscanf(buf_cstring(&userdata), MODSEQ_FMT, &shared_modseq);
+        }
+        buf_free(&userdata);
+
+        modseq = MAX(modseq, shared_modseq);
+    }
+
+    return modseq;
+}
+
+
 /* Check headers for any preconditions */
 static int caldav_check_precond(struct transaction_t *txn,
                                 struct meth_params *params,
@@ -1036,7 +1320,7 @@ static int _scheduling_enabled(struct tr
     struct buf buf = BUF_INITIALIZER;
     int is_enabled = 1;
 
-    annotatemore_lookupmask(mailbox->name, entry, httpd_userid, &buf);
+    annotatemore_lookup(mailbox->name, entry, "", &buf);
     /* legacy */
     if (!strcasecmp(buf_cstring(&buf), "no"))
         is_enabled = 0;
@@ -1091,7 +1375,9 @@ static int caldav_copy(struct transactio
 
     /* Store source resource at destination */
     /* XXX - set calendar-user-address based on original message? */
-    r = caldav_store_resource(txn, ical, dest_mbox, dest_rsrc, db, flags, NULL);
+    /* XXX - get createdmodseq from source */
+    r = caldav_store_resource(txn, ical, dest_mbox, dest_rsrc, 0,
+                              db, flags, httpd_userid, NULL);
 
     return r;
 }
@@ -1123,28 +1409,14 @@ static void update_refcount(const char *
     }
 }
 
-/* Check an iCal object to see if managed attachments are being manipulated */
-static int manage_attachments(struct transaction_t *txn,
-                              struct mailbox *mailbox,
-                              icalcomponent *ical, struct caldav_data *cdata,
-                              icalcomponent **oldical, char **schedule_address)
+static int open_attachments(const char *userid, struct mailbox **attachments,
+                            struct webdav_db **webdavdb)
 {
-    /* Compare any managed attachments in new and existing resources */
-    char *mailboxname = NULL;
-    struct mailbox *attachments = NULL;
-    struct webdav_db *webdavdb = NULL;
-    struct hash_table mattach_table = HASH_TABLE_INITIALIZER;
-    icalcomponent *comp = NULL;
-    icalcomponent_kind kind;
-    icalproperty *prop;
-    icalparameter *param;
-    const char *mid;
-    short *op;
+    char *mailboxname = mailboxname = caldav_mboxname(userid, MANAGED_ATTACH);
     int r, ret = 0;
 
     /* Open attachments collection for writing */
-    mailboxname = caldav_mboxname(httpd_userid, MANAGED_ATTACH);
-    r = mailbox_open_iwl(mailboxname, &attachments);
+    r = mailbox_open_iwl(mailboxname, attachments);
     if (r) {
         syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
                mailboxname, error_message(r));
@@ -1152,16 +1424,36 @@ static int manage_attachments(struct tra
     }
     else {
         /* Open the WebDAV DB corresponding to the attachments collection */
-        webdavdb = mailbox_open_webdav(attachments);
-        if (!webdavdb) {
-            syslog(LOG_ERR, "webdav_open_mailbox(%s) failed",
-                   attachments->name);
+        *webdavdb = webdav_open_mailbox(*attachments);
+        if (!*webdavdb) {
+            syslog(LOG_ERR,
+                   "webdav_open_mailbox(%s) failed", (*attachments)->name);
             ret = HTTP_SERVER_ERROR;
         }
     }
+
     free(mailboxname);
 
-    if (ret) return ret;
+    return ret;
+}
+
+/* Check an iCal object to see if managed attachments are being manipulated */
+static int manage_attachments(struct transaction_t *txn,
+                              struct mailbox *mailbox,
+                              icalcomponent *ical, struct caldav_data *cdata,
+                              icalcomponent **oldical, strarray_t *schedule_addresses)
+{
+    /* Compare any managed attachments in new and existing resources */
+    struct mailbox *attachments = NULL;
+    struct webdav_db *webdavdb = NULL;
+    struct hash_table mattach_table = HASH_TABLE_INITIALIZER;
+    icalcomponent *comp = NULL;
+    icalcomponent_kind kind;
+    icalproperty *prop;
+    icalparameter *param;
+    const char *mid;
+    short *op;
+    int ret = 0;
 
     /* Create hash table of managed attachments in new resource */
     construct_hash_table(&mattach_table, 10, 1);
@@ -1188,6 +1480,13 @@ static int manage_attachments(struct tra
                 param = icalproperty_get_managedid_parameter(prop);
                 if (!param) continue;
 
+                if (!attachments) {
+                    /* Open attachments collection and its DAV DB for writing */
+                    ret = open_attachments(httpd_userid,
+                                           &attachments, &webdavdb);
+                    if (ret) goto done;
+                }
+
                 /* Find DAV record for the attachment with this managed-id */
                 mid = icalparameter_get_managedid(param);
                 webdav_lookup_uid(webdavdb, mid, &wdata);
@@ -1213,19 +1512,19 @@ static int manage_attachments(struct tra
 
     /* Compare existing managed attachments to those in new resource */
     if (cdata->comp_flags.mattach) {
-        struct index_record record;
-
-        syslog(LOG_NOTICE, "LOADING ICAL %u", cdata->dav.imap_uid);
+        if (!*oldical) {
+            syslog(LOG_NOTICE, "LOADING ICAL %u", cdata->dav.imap_uid);
 
-        /* Load message containing the resource and parse iCal data */
-        r = mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record);
-        if (r) {
-            txn->error.desc = "Failed to read record";
-            ret = HTTP_SERVER_ERROR;
-            goto done;
+            /* Load message containing the resource and parse iCal data */
+            *oldical = caldav_record_to_ical(mailbox, cdata,
+                                             NULL, schedule_addresses);
+            if (!*oldical) {
+                txn->error.desc = "Failed to read record";
+                ret = HTTP_SERVER_ERROR;
+                goto done;
+            }
         }
 
-        *oldical = record_to_ical(mailbox, &record, schedule_address);
         comp = icalcomponent_get_first_real_component(*oldical);
         kind = icalcomponent_isa(comp);
 
@@ -1256,13 +1555,22 @@ static int manage_attachments(struct tra
         }
     }
 
-    /* Update reference counts of attachments in hash table */
-    hash_enumerate(&mattach_table,
-                   (void(*)(const char*,void*,void*)) &update_refcount,
-                   attachments);
+    if (hash_numrecords(&mattach_table)) {
+        if (!attachments) {
+            /* Open attachments collection and its DAV DB for writing */
+            ret = open_attachments(httpd_userid, &attachments, &webdavdb);
+            if (ret) goto done;
+        }
+
+        /* Update reference counts of attachments in hash table */
+        hash_enumerate(&mattach_table,
+                       (void(*)(const char*,void*,void*)) &update_refcount,
+                       attachments);
+    }
 
   done:
     free_hash_table(&mattach_table, free);
+    if (webdavdb) webdav_close(webdavdb);
     mailbox_close(&attachments);
 
     return ret;
@@ -1286,16 +1594,29 @@ static void get_schedule_addresses(struc
     else {
         /* find schedule address based on the destination calendar's user */
 
-        /* check calendar-user-address-set for target user */
+        /* check calendar-user-address-set for target user's mailbox */
         const char *annotname =
             DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
-        char *mailboxname = caldav_mboxname(txn->req_tgt.userid, NULL);
-        int r = annotatemore_lookupmask(mailboxname, annotname,
+        int r = annotatemore_lookupmask(txn->req_tgt.mbentry->name, annotname,
                                         txn->req_tgt.userid, &buf);
-        free(mailboxname);
-        if (!r && buf.len > 7 &&
-            !strncasecmp(buf_cstring(&buf), "mailto:", 7)) {
-            strarray_append(addresses, buf_cstring(&buf) + 7);
+        if (r || !buf.len) {
+            /* check calendar-user-address-set for target user's principal */
+            char *mailboxname = caldav_mboxname(txn->req_tgt.userid, NULL);
+            buf_reset(&buf);
+            r = annotatemore_lookupmask(mailboxname, annotname,
+                                        txn->req_tgt.userid, &buf);
+            free(mailboxname);
+        }
+
+        if (!r && buf.len) {
+            strarray_t *values = strarray_split(buf_cstring(&buf), ",", STRARRAY_TRIM);
+            int i;
+            for (i = 0; i < strarray_size(values); i++) {
+                const char *item = strarray_nth(values, i);
+                if (!strncasecmp(item, "mailto:", 7)) item += 7;
+                strarray_append(addresses, item);
+            }
+            strarray_free(values);
         }
         else if (strchr(txn->req_tgt.userid, '@')) {
             /* userid corresponding to target */
@@ -1326,7 +1647,7 @@ static int caldav_delete_cal(struct tran
     struct caldav_data *cdata = (struct caldav_data *) data;
     icalcomponent *ical = NULL;
     struct buf buf = BUF_INITIALIZER;
-    char *schedule_address = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
     int r = 0;
 
     /* Only process deletes on regular calendar collections */
@@ -1335,19 +1656,18 @@ static int caldav_delete_cal(struct tran
     if ((namespace_calendar.allow & ALLOW_CAL_ATTACH) &&
         cdata->comp_flags.mattach) {
         r = manage_attachments(txn, mailbox, NULL,
-                               cdata, &ical, &schedule_address);
+                               cdata, &ical, &schedule_addresses);
         if (r) goto done;
     }
 
     if (cdata->organizer) {
         /* Scheduling object resource */
-        strarray_t schedule_addresses = STRARRAY_INITIALIZER;
         const char **hdr;
 
         /* XXX - check date range? - don't send in the past */
 
         /* Load message containing the resource and parse iCal data */
-        if (!ical) ical = record_to_ical(mailbox, record, &schedule_address);
+        if (!ical) ical = record_to_ical(mailbox, record, &schedule_addresses);
 
         if (!ical) {
             syslog(LOG_ERR,
@@ -1356,10 +1676,6 @@ static int caldav_delete_cal(struct tran
             return HTTP_SERVER_ERROR;
         }
 
-        if (schedule_address) {
-            strarray_appendm(&schedule_addresses, schedule_address);
-            schedule_address = NULL;
-        }
         get_schedule_addresses(txn, &schedule_addresses);
 
         /* XXX - after legacy records are gone, we can strip this and just not send a
@@ -1368,36 +1684,47 @@ static int caldav_delete_cal(struct tran
         char *userid = mboxname_to_userid(txn->req_tgt.mbentry->name);
         if (strarray_find_case(&schedule_addresses, cdata->organizer, 0) >= 0) {
             /* Organizer scheduling object resource */
-            schedule_address = xstrdupnull(cdata->organizer);
             if (_scheduling_enabled(txn, mailbox))
-                sched_request(userid, schedule_address, ical, NULL);
+                sched_request(userid, &schedule_addresses, cdata->organizer, ical, NULL);
         }
         else if (!(hdr = spool_getheader(txn->req_hdrs, "Schedule-Reply")) ||
                  strcasecmp(hdr[0], "F")) {
             /* Attendee scheduling object resource */
-            schedule_address = xstrdupnull(strarray_nth(&schedule_addresses, 0));
-            if (_scheduling_enabled(txn, mailbox) && schedule_address)
-                sched_reply(userid, schedule_address, ical, NULL);
+            if (_scheduling_enabled(txn, mailbox) && strarray_size(&schedule_addresses))
+                sched_reply(userid, &schedule_addresses, ical, NULL);
         }
 
         free(userid);
-        strarray_fini(&schedule_addresses);
     }
 
   done:
     if (ical) icalcomponent_free(ical);
-    free(schedule_address);
+    strarray_fini(&schedule_addresses);
     buf_free(&buf);
 
     return r;
 }
 
-static const char *begin_icalendar(struct buf *buf)
+static const char *begin_icalendar(struct buf *buf, struct mailbox *mailbox,
+                                   const char *prodid, const char *name,
+                                   const char *desc, const char *color)
 {
+    icalcomponent *ical;
+    icalproperty *prop;
+
     /* Begin iCalendar stream */
     buf_setcstr(buf, "BEGIN:VCALENDAR\r\n");
-    buf_printf(buf, "PRODID:%s\r\n", ical_prodid);
-    buf_appendcstr(buf, "VERSION:2.0\r\n");
+
+    /* Add toplevel properties */
+    ical = icalcomponent_new_stream(mailbox, prodid, name, desc, color);
+
+    for (prop = icalcomponent_get_first_property(ical, ICAL_ANY_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(ical, ICAL_ANY_PROPERTY)) {
+
+        buf_appendcstr(buf, icalproperty_as_ical_string(prop));
+    }
+    icalcomponent_free(ical);
 
     return "";
 }
@@ -1408,9 +1735,41 @@ static void end_icalendar(struct buf *bu
     buf_setcstr(buf, "END:VCALENDAR\r\n");
 }
 
+
+struct timezone_rock {
+    icalcomponent *old;
+    icalcomponent *new;
+};
+
+static void add_timezone(icalparameter *param, void *data)
+{
+    struct timezone_rock *tzrock = (struct timezone_rock *) data;
+    const char *tzid = icalparameter_get_tzid(param);
+
+    /* Check if this tz is in our new object */
+    if (!icalcomponent_get_timezone(tzrock->new, tzid)) {
+        icalcomponent *vtz = NULL;
+
+        if (tzrock->old) {
+            /* Fetch tz from old object and add to new */
+            icaltimezone *tz = icalcomponent_get_timezone(tzrock->old, tzid);
+            if (tz) vtz = icalcomponent_clone(icaltimezone_get_component(tz));
+        }
+        else {
+            /* Fetch tz from builtin repository */
+            icaltimezone *tz = icaltimezone_get_builtin_timezone(tzid);
+
+            if (tz) vtz = icalcomponent_clone(icaltimezone_get_component(tz));
+        }
+
+        if (vtz) icalcomponent_add_component(tzrock->new, vtz);
+    }
+}
+
+
 static int export_calendar(struct transaction_t *txn)
 {
-    int ret = 0, r, precond;
+    int ret = 0, r, n, precond, need_tz = 1;
     struct resp_body_t *resp_body = &txn->resp_body;
     struct buf *buf = &resp_body->payload;
     struct mailbox *mailbox = NULL;
@@ -1418,9 +1777,17 @@ static int export_calendar(struct transa
     struct hash_table tzid_table;
     static const char *displayname_annot =
         DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
-    struct buf attrib = BUF_INITIALIZER;
+    static const char *description_annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-description";
+    static const char *color_annot =
+        DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-color";
+    struct buf name = BUF_INITIALIZER, link = BUF_INITIALIZER;
+    struct buf desc = BUF_INITIALIZER, color = BUF_INITIALIZER;
     const char **hdr, *sep;
     struct mime_type_t *mime = NULL;
+    modseq_t syncmodseq = 0;
+    int unbind_flag = -1, unchanged_flag = -1;
+    struct caldav_db *caldavdb = NULL;
 
     /* Check requested MIME type:
        1st entry in caldav_mime_types array MUST be default MIME type */
@@ -1440,8 +1807,9 @@ static int export_calendar(struct transa
     }
 
     /* Check any preconditions */
-    sprintf(etag, "%u-%u-%u",
-            mailbox->i.uidvalidity, mailbox->i.last_uid, mailbox->i.exists);
+    assert(!buf_len(&txn->buf));
+    dav_get_synctoken(mailbox, &txn->buf, "");
+    strlcpy(etag, buf_cstring(&txn->buf), sizeof(etag));
     precond = check_precond(txn, etag, mailbox->index_mtime);
 
     switch (precond) {
@@ -1465,23 +1833,76 @@ static int export_calendar(struct transa
 
     /* Setup for chunked response */
     txn->flags.te |= TE_CHUNKED;
-    txn->flags.vary |= VARY_ACCEPT;
+    txn->flags.vary |= VARY_ACCEPT | VARY_PREFER | VARY_IFNONE | VARY_CALTZ;
     txn->resp_body.type = mime->content_type;
 
     /* Set filename of resource */
     r = annotatemore_lookupmask(mailbox->name, displayname_annot,
-                                httpd_userid, &attrib);
+                                httpd_userid, &name);
     /* fall back to last part of mailbox name */
-    if (r || !attrib.len) buf_setcstr(&attrib, strrchr(mailbox->name, '.') + 1);
+    if (r || !name.len) buf_setcstr(&name, strrchr(mailbox->name, '.') + 1);
 
     buf_reset(&txn->buf);
-    buf_printf(&txn->buf, "%s.%s", buf_cstring(&attrib), mime->file_ext);
-    txn->resp_body.fname = buf_cstring(&txn->buf);
+    buf_printf(&txn->buf, "%s.%s", buf_cstring(&name), mime->file_ext);
+    txn->resp_body.dispo.fname = buf_cstring(&txn->buf);
+
+    /* Add subscription upgrade links */
+    buf_printf(&link, "<%s>; rel=\"subscribe-caldav_auth\"", txn->req_tgt.path);
+    strarray_appendm(&txn->resp_body.links, buf_release(&link));
+    buf_printf(&link, "<%s>; rel=\"subscribe-webdav_sync\"", txn->req_tgt.path);
+    strarray_appendm(&txn->resp_body.links, buf_release(&link));
+
+    if (get_preferences(txn) & PREFER_MIN) {
+        /* Enhanced GET request */
+        need_tz = 0;
+
+        if ((hdr = spool_getheader(txn->req_hdrs, "If-None-Match"))) {
+            /* Report only changed resources since ETag (sync-token) */
+            uint32_t uidvalidity;
+            char dquote[2];
+
+            /* Parse sync-token */
+            n = sscanf((char *) hdr[0], "\"%u-" MODSEQ_FMT "%1s",
+                       &uidvalidity, &syncmodseq, dquote /* trailing DQUOTE */);
+
+            syslog(LOG_DEBUG, "scanned token %s to %d %u %llu",
+                   hdr[0], n, uidvalidity, syncmodseq);
+
+            /* Sanity check the token components */
+            if (n != 3 || dquote[0] != '"' ||
+                uidvalidity != mailbox->i.uidvalidity ||
+                syncmodseq > mailbox->i.highestmodseq ||
+                syncmodseq < mailbox->i.deletedmodseq) {
+                syncmodseq = 0;
+                txn->resp_body.prefs &= ~PREFER_MIN;
+            }
+            else {
+                mailbox_user_flag(mailbox, DFLAG_UNBIND, &unbind_flag, 1);
+                mailbox_user_flag(mailbox, DFLAG_UNCHANGED, &unchanged_flag, 1);
+
+                if (namespace_calendar.allow & ALLOW_CAL_NOTZ) {
+                    /* Add link to tzdist */
+                    buf_printf(&link, "<%s>; rel=\"timezone-service\"",
+                               namespace_tzdist.prefix);
+                    strarray_appendm(&txn->resp_body.links, buf_release(&link));
+                }
+            }
+
+            /* Check for optional CalDAV-Timezones header */
+            hdr = spool_getheader(txn->req_hdrs, "CalDAV-Timezones");
+            if (hdr && !strcmp(hdr[0], "T")) need_tz = 1;
+        }
+    }
+    else {
+        buf_printf(&link,
+                   "<%s>; rel=\"subscribe-enhanced-get\"", txn->req_tgt.path);
+        strarray_appendm(&txn->resp_body.links, buf_release(&link));
+    }
 
     /* Short-circuit for HEAD request */
     if (txn->meth == METH_HEAD) {
-        response_header(HTTP_OK, txn);
-        return 0;
+        ret = HTTP_OK;
+        goto done;
     }
 
     /* iCalendar data in response should not be transformed */
@@ -1490,51 +1911,139 @@ static int export_calendar(struct transa
     /* Create hash table for TZIDs */
     construct_hash_table(&tzid_table, 10, 1);
 
+    /* Get description and color of calendar */
+    r = annotatemore_lookupmask(mailbox->name, description_annot,
+                                httpd_userid, &desc);
+    r = annotatemore_lookupmask(mailbox->name, color_annot,
+                                httpd_userid, &color);
+
     /* Begin (converted) iCalendar stream */
-    sep = mime->begin_stream(buf);
+    sep = mime->begin_stream(buf, mailbox, ical_prodid, buf_cstring(&name),
+                             buf_cstringnull(&desc),
+                             css3_color_hex_to_name(buf_cstringnull(&color)));
     write_body(HTTP_OK, txn, buf_cstring(buf), buf_len(buf));
 
     struct mailbox_iter *iter =
-        mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED|ITER_SKIP_DELETED);
+        mailbox_iter_init(mailbox, syncmodseq,
+                          syncmodseq ? 0 : ITER_SKIP_EXPUNGED|ITER_SKIP_DELETED);
 
+    if (!syncmodseq) caldavdb = caldav_open_mailbox(mailbox);
+
+    n = 0;
     const message_t *msg;
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
-        icalcomponent *ical;
+        struct caldav_data *cdata;
+        icalcomponent *ical = NULL;
+
+        r = caldav_lookup_imapuid(caldavdb, mailbox->name,
+                                  record->uid, &cdata, 0);
+
+        if (syncmodseq) { 
+            if ((unbind_flag >= 0) &&
+                record->user_flags[unbind_flag / 32] & (1 << (unbind_flag & 31))) {
+                /* Resource replaced by a PUT, COPY, or MOVE - ignore it */
+                continue;
+            }
+
+            if ((record->modseq - syncmodseq == 1) &&
+                (unchanged_flag >= 0) &&
+                (record->user_flags[unchanged_flag / 32] &
+                 (1 << (unchanged_flag & 31)))) {
+                /* Resource has just had VTIMEZONEs stripped - ignore it */
+                continue;
+            }
+        }
 
         /* Map and parse existing iCalendar resource */
-        ical = record_to_ical(mailbox, record, NULL);
+        if (!r) ical = caldav_record_to_ical(mailbox, cdata, httpd_userid, NULL);
 
         if (ical) {
             icalcomponent *comp;
 
+            if (!syncmodseq) {
+                struct caldav_data *cdata;
+
+                /* Fetch the CalDAV db record */
+                r = caldav_lookup_imapuid(caldavdb, mailbox->name,
+                                          record->uid, &cdata, 0);
+
+                if (!r && need_tz && cdata->comp_flags.tzbyref) {
+                    /* Add VTIMEZONE components for known TZIDs */
+                    struct timezone_rock tzrock = { NULL, ical };
+                    icalcomponent *next;
+                    icalcomponent_kind kind;
+
+                    comp = icalcomponent_get_first_real_component(ical);
+                    kind = icalcomponent_isa(comp);
+                    for (; comp; comp = next) {
+                        next = icalcomponent_get_next_component(ical, kind);
+                        icalcomponent_foreach_tzid(comp, &add_timezone, &tzrock);
+                    }
+                }
+            }
+
             for (comp = icalcomponent_get_first_component(ical,
                                                           ICAL_ANY_COMPONENT);
                  comp;
                  comp = icalcomponent_get_next_component(ical,
                                                          ICAL_ANY_COMPONENT)) {
-                struct buf *cal_str;
                 icalcomponent_kind kind = icalcomponent_isa(comp);
 
-                /* Don't duplicate any TZIDs in our iCalendar */
+                /* Don't duplicate any VTIMEZONEs in our iCalendar */
                 if (kind == ICAL_VTIMEZONE_COMPONENT) {
+                    if (syncmodseq) continue;
+                    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) continue;
+
                     icalproperty *prop =
                         icalcomponent_get_first_property(comp,
                                                          ICAL_TZID_PROPERTY);
                     const char *tzid = icalproperty_get_tzid(prop);
 
+                    if (!tzid) continue;
+
                     if (hash_lookup(tzid, &tzid_table)) continue;
                     else hash_insert(tzid, (void *)0xDEADBEEF, &tzid_table);
                 }
+                else if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
+                    /* Resource was deleted - remove non-mandatory properties */
+                    icalproperty *prop, *next;
+
+                    for (prop =
+                             icalcomponent_get_first_property(comp,
+                                                              ICAL_ANY_PROPERTY);
+                         prop; prop = next) {
+                        next =
+                            icalcomponent_get_next_property(comp,
+                                                            ICAL_ANY_PROPERTY);
+
+                        switch (icalproperty_isa(prop)) {
+                        case ICAL_UID_PROPERTY:
+                        case ICAL_DTSTAMP_PROPERTY:
+                        case ICAL_DTSTART_PROPERTY:
+                            /* Mandatory - keep */
+                            break;
+
+                        default:
+                            /* Optional - strip */
+                            icalcomponent_remove_property(comp, prop);
+                            icalproperty_free(prop);
+                            break;
+                        }
+                    }
+
+                    /* Set STATUS:DELETED */
+                    icalcomponent_set_status(comp, ICAL_STATUS_DELETED);
+                }
 
                 /* Include this component in our iCalendar */
-                if (r++ && *sep) {
+                if (n++ && *sep) {
                     /* Add separator, if necessary */
                     buf_reset(buf);
-                    buf_printf_markup(buf, 0, sep);
+                    buf_printf_markup(buf, 0, "%s", sep);
                     write_body(0, txn, buf_cstring(buf), buf_len(buf));
                 }
-                cal_str = mime->from_object(comp);
+                struct buf *cal_str = mime->from_object(comp);
                 write_body(0, txn, buf_base(cal_str), buf_len(cal_str));
                 buf_destroy(cal_str);
             }
@@ -1545,6 +2054,8 @@ static int export_calendar(struct transa
 
     mailbox_iter_done(&iter);
 
+    caldav_close(caldavdb);
+
     free_hash_table(&tzid_table, NULL);
 
     /* End (converted) iCalendar stream */
@@ -1555,7 +2066,9 @@ static int export_calendar(struct transa
     write_body(0, txn, NULL, 0);
 
   done:
-    buf_free(&attrib);
+    buf_free(&name);
+    buf_free(&desc);
+    buf_free(&color);
     mailbox_close(&mailbox);
 
     return ret;
@@ -1799,7 +2312,7 @@ static int list_calendars(struct transac
     buf_printf_markup(body, level++, "<script type=\"text/javascript\">");
     buf_appendcstr(body, "//<![CDATA[\n");
     buf_printf(body, (const char *) http_caldav_js,
-               cyrus_version(), http_caldav_js_len);
+               CYRUS_VERSION, http_caldav_js_len);
     buf_appendcstr(body, "//]]>\n");
     buf_printf_markup(body, --level, "</script>");
     buf_printf_markup(body, level++, "<noscript>");
@@ -2031,53 +2544,51 @@ static struct icaltimetype icaltime_from
 }
 
 
-struct timezone_rock {
-    icalcomponent *old;
-    icalcomponent *new;
-};
+static void add_personal_data(icalcomponent *ical, struct buf *userdata)
+{
+    struct dlist *dl;
+    const char *icalstr;
+    icalcomponent *vpatch;
 
-static void add_timezone(icalparameter *param, void *data)
+    /* Parse the value and fetch the patch */
+    dlist_parsemap(&dl, 1, 0, buf_base(userdata), buf_len(userdata));
+    dlist_getatom(dl, "VPATCH", &icalstr);
+    vpatch = icalparser_parse_string(icalstr);
+    dlist_free(&dl);
+
+    /* Apply the patch to the "base" resource */
+    icalcomponent_apply_vpatch(ical, vpatch, NULL, NULL);
+
+    icalcomponent_free(vpatch);
+}
+
+
+EXPORTED icalcomponent *caldav_record_to_ical(struct mailbox *mailbox,
+                                              const struct caldav_data *cdata,
+                                              const char *userid,
+                                              strarray_t *schedule_addresses)
 {
-    struct timezone_rock *tzrock = (struct timezone_rock *) data;
-    const char *tzid = icalparameter_get_tzid(param);
+    icalcomponent *ical = NULL;
+    struct index_record record;
+    int r;
 
-    /* Check if this tz is in our new object */
-    if (!icalcomponent_get_timezone(tzrock->new, tzid)) {
-        icalcomponent *vtz = NULL;
+    /* Fetch index record for the cal resource */
+    r = mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record);
+    if (r) return NULL;
 
-        if (tzrock->old) {
-            /* Fetch tz from old object and add to new */
-            icaltimezone *tz = icalcomponent_get_timezone(tzrock->old, tzid);
-            if (tz) vtz = icalcomponent_new_clone(icaltimezone_get_component(tz));
-        }
-        else {
-            /* Fetch tz from our tzdist repository */
-            struct buf buf = BUF_INITIALIZER;
-            const char *path;
-            int fd;
+    ical = record_to_ical(mailbox, &record, schedule_addresses);
 
-            /* Open and mmap the timezone file */
-            buf_printf(&buf, "%s%s/%s.ics", config_dir, FNAME_ZONEINFODIR, tzid);
-            path = buf_cstring(&buf);
-
-            if ((fd = open(path, O_RDONLY)) != -1) {
-                struct buf data = BUF_INITIALIZER;
-                icalcomponent *ical;
-
-                buf_init_mmap(&data, 1, fd, path, MAP_UNKNOWN_LEN, NULL);
-                ical = ical_string_as_icalcomponent(&data);
-                vtz = icalcomponent_get_first_component(ical,
-                                                        ICAL_VTIMEZONE_COMPONENT);
-                icalcomponent_remove_component(ical, vtz);
-                icalcomponent_free(ical);
-                buf_free(&data);
-                close(fd);
-            }
-            buf_free(&buf);
+    if (userid && (namespace_calendar.allow & ALLOW_USERDATA)) {
+        struct buf userdata = BUF_INITIALIZER;
+
+        if (caldav_is_personalized(mailbox, cdata, httpd_userid, &userdata)) {
+            add_personal_data(ical, &userdata);
         }
 
-        if (vtz) icalcomponent_add_component(tzrock->new, vtz);
+        buf_free(&userdata);
     }
+
+    return ical;
 }
 
 
@@ -2105,7 +2616,7 @@ static int caldav_get(struct transaction
         struct caldav_data *cdata = (struct caldav_data *) data;
         unsigned need_tz = 0;
         const char **hdr;
-        icalcomponent *ical;
+        icalcomponent *ical = NULL;
         int ret = HTTP_CONTINUE;
 
         /* Check for optional CalDAV-Timezones header */
@@ -2127,25 +2638,14 @@ static int caldav_get(struct transaction
             }
             if (need_tz) {
                 /* Add VTIMEZONE components for known TZIDs */
-                struct timezone_rock tzrock = { NULL, NULL };
-                icalcomponent *comp, *next;
-                icalcomponent_kind kind;
-
                 *obj = ical = record_to_ical(mailbox, record, NULL);
-                tzrock.new = ical;
 
-                comp = icalcomponent_get_first_real_component(ical);
-                kind = icalcomponent_isa(comp);
-                for (; comp; comp = next) {
-                    next = icalcomponent_get_next_component(ical, kind);
-                    icalcomponent_foreach_tzid(comp, &add_timezone, &tzrock);
-                }
+                icalcomponent_add_required_timezones(ical);
             }
         }
         else if (!need_tz && (namespace_calendar.allow & ALLOW_CAL_NOTZ)) {
             /* Strip known VTIMEZONEs */
             struct caldav_db *caldavdb = caldav_open_mailbox(mailbox);
-            char *userid = NULL;
 
             mailbox_unlock_index(mailbox, NULL);
             r = mailbox_lock_index(mailbox, LOCK_EXCLUSIVE);
@@ -2155,13 +2655,16 @@ static int caldav_get(struct transaction
                 goto done;
             }
 
-            *obj = ical = record_to_ical(mailbox, record, &userid);
+            strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+
+            *obj = ical = record_to_ical(mailbox, record, &schedule_addresses);
 
             caldav_store_resource(txn, ical, mailbox,
-                                  cdata->dav.resource, caldavdb,
+                                  cdata->dav.resource, cdata->dav.createdmodseq, caldavdb,
                                   TZ_STRIP | (!cdata->sched_tag ? NEW_STAG : 0),
-                                  userid);
-            free(userid);
+                                  NULL, &schedule_addresses);
+
+            strarray_fini(&schedule_addresses);
 
             /* Fetch the new DAV and index records */
             /* NOTE: previous contents of cdata was freed by store_resource */
@@ -2177,8 +2680,21 @@ static int caldav_get(struct transaction
             caldav_close(caldavdb);
         }
 
+        /* Personalize resource, if necessary */
+        if (namespace_calendar.allow & ALLOW_USERDATA) {
+            struct buf userdata = BUF_INITIALIZER;
+
+            if (caldav_is_personalized(mailbox, cdata, httpd_userid, &userdata)) {
+                if (!ical) *obj = ical = record_to_ical(mailbox, record, NULL);
+
+                add_personal_data(ical, &userdata);
+                buf_free(&userdata);
+            }
+        }
+
         /* iCalendar data in response should not be transformed */
         txn->flags.cc |= CC_NOTRANSFORM;
+        txn->flags.vary |= VARY_CALTZ;
 
       done:
         return ret;
@@ -2202,7 +2718,8 @@ static int caldav_get(struct transaction
         /* Download an entire calendar collection */
         return export_calendar(txn);
     }
-    else if (txn->req_tgt.userid) {
+    else if (txn->req_tgt.userid &&
+             config_getswitch(IMAPOPT_CALDAV_ALLOWCALENDARADMIN)) {
         /* GET a list of calendars under calendar-home-set */
         return list_calendars(txn);
     }
@@ -2212,18 +2729,56 @@ static int caldav_get(struct transaction
 }
 
 
+/* Perform post-create MKCOL/MKCALENDAR processing */
+static int caldav_mkcol(struct mailbox *mailbox)
+{
+    const char *comp_annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">supported-calendar-component-set";
+    struct buf attrib = BUF_INITIALIZER;
+    unsigned long types = 0;
+    int r;
+
+    /* Check if client specified CALDAV:supported-calendar-component-set */
+    r = annotatemore_lookupmask(mailbox->name, comp_annot,
+                                httpd_userid, &attrib);
+    if (r) return HTTP_SERVER_ERROR;
+
+    if (attrib.len) {
+        types = strtoul(buf_cstring(&attrib), NULL, 10);
+    }
+
+    if (!types) {
+        /* Client didn't specify, so use imap.conf option */
+        annotate_state_t *astate = NULL;
+
+        r = mailbox_get_annotate_state(mailbox, 0, &astate);
+        if (!r) {
+            types = config_types_to_caldav_types();
+            buf_reset(&attrib);
+            buf_printf(&attrib, "%lu", types);
+
+            r = annotate_state_writemask(astate, comp_annot,
+                                         httpd_userid, &attrib);
+        }
+    }
+
+    buf_free(&attrib);
+
+    return r;
+}
+
 /* Perform a GET/HEAD request on a CalDAV/M-Attach resource */
-static int meth_get_head_cal(struct transaction_t *txn,
-                             void *gparams __attribute__((unused)))
+static int meth_get_head_cal(struct transaction_t *txn, void *params)
 {
+    struct meth_params *gparams = (struct meth_params *) params;
     int r;
 
     /* Parse the path */
-    if ((r = caldav_parse_path(txn->req_uri->path,
-                               &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, gparams);
+    if (r) return r;
 
-    return meth_get_head(txn, (txn->req_tgt.flags == TGT_MANAGED_ATTACH) ?
-                         &webdav_params : &caldav_params);
+    if (txn->req_tgt.flags == TGT_MANAGED_ATTACH) gparams = &webdav_params;
+    return meth_get_head(txn, gparams);
 }
 
 /* Decrement reference count on a managed attachment resource */
@@ -2244,7 +2799,7 @@ static void decrement_refcount(const cha
         struct index_record record;
 
         mailbox_find_index_record(attachments, wdata->dav.imap_uid, &record);
-        record.system_flags |= FLAG_EXPUNGED;
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
 
         r = mailbox_rewrite_index_record(attachments, &record);
 
@@ -2301,9 +2856,8 @@ static int caldav_post_attach(struct tra
     struct webdav_db *webdavdb = NULL;
     struct webdav_data *wdata;
     struct index_record record;
-    char *schedule_address = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
     const char *etag = NULL, **hdr;
-    char *mailboxname = NULL;
     time_t lastmod = 0;
     icalcomponent *ical = NULL, *comp, *nextc, *master = NULL;
     icalcomponent_kind kind;
@@ -2390,7 +2944,7 @@ static int caldav_post_attach(struct tra
     lastmod = record.internaldate;
 
     /* Load and parse message containing the resource */
-    ical = record_to_ical(calendar, &record, &schedule_address);
+    ical = record_to_ical(calendar, &record, &schedule_addresses);
     comp = icalcomponent_get_first_real_component(ical);
     kind = icalcomponent_isa(comp);
 
@@ -2416,21 +2970,9 @@ static int caldav_post_attach(struct tra
         else goto done;
     }
 
-    /* Open attachments collection for writing */
-    mailboxname = caldav_mboxname(httpd_userid, MANAGED_ATTACH);
-    r = mailbox_open_iwl(mailboxname, &attachments);
-    if (r) {
-        syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
-               mailboxname, error_message(r));
-        txn->error.desc = error_message(r);
-        ret = HTTP_SERVER_ERROR;
-        free(mailboxname);
-        goto done;
-    }
-    free(mailboxname);
-
-    /* Open the WebDAV DB corresponding to the attachments collection */
-    webdavdb = webdav_open_mailbox(attachments);
+    /* Open attachments collection and its DAV DB for writing */
+    ret = open_attachments(httpd_userid, &attachments, &webdavdb);
+    if (ret) goto done;
 
     if (mid) {
         /* Locate first ATTACH property with this MANAGED-ID */
@@ -2473,8 +3015,7 @@ static int caldav_post_attach(struct tra
 
         /* Read body */
         txn->req_body.flags |= BODY_DECODE;
-        r = http_read_body(httpd_in, httpd_out,
-                           txn->req_hdrs, &txn->req_body, &txn->error.desc);
+        r = http_read_req_body(txn);
         if (r) {
             txn->flags.conn = CONN_CLOSE;
             return r;
@@ -2512,23 +3053,20 @@ static int caldav_post_attach(struct tra
         wdata = increment_refcount(uid, webdavdb);
 
         /* Create new ATTACH property */
-        if (aprop) aprop = icalproperty_new_clone(aprop);
-        else {
-            const char *proto = NULL, *host = NULL;
-            icalattach *attach;
+        const char *proto = NULL, *host = NULL;
+        icalattach *attach;
 
-            assert(!buf_len(&txn->buf));
-            http_proto_host(txn->req_hdrs, &proto, &host);
-            buf_printf(&txn->buf, "%s://%s%s/%s/%s/%s%s",
-                       proto, host, namespace_calendar.prefix,
-                       USER_COLLECTION_PREFIX,
-                       txn->req_tgt.userid, MANAGED_ATTACH, uid);
-            attach = icalattach_new_from_url(buf_cstring(&txn->buf));
-            buf_reset(&txn->buf);
+        assert(!buf_len(&txn->buf));
+        http_proto_host(txn->req_hdrs, &proto, &host);
+        buf_printf(&txn->buf, "%s://%s%s/%s/%s/%s%s",
+                   proto, host, namespace_calendar.prefix,
+                   USER_COLLECTION_PREFIX,
+                   txn->req_tgt.userid, MANAGED_ATTACH, uid);
+        attach = icalattach_new_from_url(buf_cstring(&txn->buf));
+        buf_reset(&txn->buf);
 
-            aprop = icalproperty_new_attach(attach);
-            icalattach_unref(attach);
-        }
+        aprop = icalproperty_new_attach(attach);
+        icalattach_unref(attach);
 
         /* Update ATTACH parameters - MANAGED-ID, FILENAME, SIZE, FMTTYPE */
         param = icalproperty_get_managedid_parameter(aprop);
@@ -2602,7 +3140,7 @@ static int caldav_post_attach(struct tra
                 struct icaldatetimeperiodtype dtp;
                 icalproperty *nextp;
 
-                master = icalcomponent_new_clone(master);
+                master = icalcomponent_clone(master);
 
                 /* Get DTSTART and Remove unwanted recurrence properties */
                 for (prop = icalcomponent_get_first_property(master,
@@ -2640,7 +3178,7 @@ static int caldav_post_attach(struct tra
 
                     icaltime_set_timezone(&dtstart, tz);
 
-                    comp = icalcomponent_new_clone(master);
+                    comp = icalcomponent_clone(master);
                     icalcomponent_add_component(ical, comp);
                     icalcomponent_set_dtstart(comp, dtstart);
 
@@ -2686,7 +3224,7 @@ static int caldav_post_attach(struct tra
 
         if (aprop) {
             /* Add new/updated ATTACH property */
-            icalcomponent_add_property(comp, icalproperty_new_clone(aprop));
+            icalcomponent_add_property(comp, icalproperty_clone(aprop));
         }
     }
 
@@ -2695,44 +3233,52 @@ static int caldav_post_attach(struct tra
 
     /* Store updated calendar resource */
     ret = caldav_store_resource(txn, ical, calendar, txn->req_tgt.resource,
-                                caldavdb, return_rep, schedule_address);
+                                record.createdmodseq,
+                                caldavdb, return_rep, NULL, &schedule_addresses);
+
+    if (ret == HTTP_NO_CONTENT) {
+        if (aprop) {
+            buf_setcstr(&txn->buf, icalproperty_get_value_as_string(aprop));
+            txn->location = buf_cstring(&txn->buf);
+        }
 
-    if (ret == HTTP_NO_CONTENT && return_rep) {
-        struct buf *data;
+        if (return_rep) {
+            struct buf *data;
 
-        ret = (op == ATTACH_ADD) ? HTTP_CREATED : HTTP_OK;
+            ret = (op == ATTACH_ADD) ? HTTP_CREATED : HTTP_OK;
 
-      return_rep:
-        /* Convert into requested MIME type */
-        data = mime->from_object(ical);
+          return_rep:
+            /* Convert into requested MIME type */
+            data = mime->from_object(ical);
 
-        /* Fill in Content-Type, Content-Length */
-        resp_body->type = mime->content_type;
-        resp_body->len = buf_len(data);
+            /* Fill in Content-Type, Content-Length */
+            resp_body->type = mime->content_type;
+            resp_body->len = buf_len(data);
 
-        /* Fill in Content-Location */
-        resp_body->loc = txn->req_tgt.path;
+            /* Fill in Content-Location */
+            resp_body->loc = txn->req_tgt.path;
 
-        /* Fill in Expires and Cache-Control */
-        resp_body->maxage = 3600;       /* 1 hr */
-        txn->flags.cc = CC_MAXAGE
-            | CC_REVALIDATE             /* don't use stale data */
-            | CC_NOTRANSFORM;           /* don't alter iCal data */
+            /* Fill in Expires and Cache-Control */
+            resp_body->maxage = 3600;       /* 1 hr */
+            txn->flags.cc = CC_MAXAGE
+                | CC_REVALIDATE             /* don't use stale data */
+                | CC_NOTRANSFORM;           /* don't alter iCal data */
 
-        /* Output current representation */
-        write_body(ret, txn, buf_base(data), buf_len(data));
+            /* Output current representation */
+            write_body(ret, txn, buf_base(data), buf_len(data));
 
-        buf_destroy(data);
-        ret = 0;
+            buf_destroy(data);
+            ret = 0;
+        }
     }
 
   done:
     strarray_free(rids);
-    free(schedule_address);
+    strarray_fini(&schedule_addresses);
     if (aprop) icalproperty_free(aprop);
     if (ical) icalcomponent_free(ical);
-    if (webdavdb) webdav_close(webdavdb);
     if (caldavdb) caldav_close(caldavdb);
+    if (webdavdb) webdav_close(webdavdb);
     mailbox_close(&attachments);
     mailbox_close(&calendar);
 
@@ -2766,8 +3312,7 @@ static int caldav_post_outbox(struct tra
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    r = http_read_body(httpd_in, httpd_out,
-                       txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    r = http_read_req_body(txn);
     if (r) {
         txn->flags.conn = CONN_CLOSE;
         return r;
@@ -2809,19 +3354,19 @@ static int caldav_post_outbox(struct tra
         ret = HTTP_FORBIDDEN;
         goto done;
     }
-    r = caladdress_lookup(organizer, &sparam, txn->req_tgt.userid);
+    r = caladdress_lookup(organizer, &sparam, NULL); // XXX: this needs to lookup the user's principal
     if (r) {
         txn->error.precond = CALDAV_VALID_ORGANIZER;
         ret = HTTP_FORBIDDEN;
         goto done;
     }
     if (!sparam.isyou) {
-        sched_param_free(&sparam);
+        sched_param_fini(&sparam);
         txn->error.precond = CALDAV_VALID_ORGANIZER;
         ret = HTTP_FORBIDDEN;
         goto done;
     }
-    sched_param_free(&sparam);
+    sched_param_fini(&sparam);
 
     switch (kind) {
     case ICAL_VFREEBUSY_COMPONENT:
@@ -2852,19 +3397,141 @@ static int caldav_post_outbox(struct tra
 }
 
 
+struct import_rock {
+    struct transaction_t *txn;
+    icalcomponent *ical;
+    struct mailbox *mailbox;
+    struct caldav_db *caldavdb;
+    xmlNodePtr root;
+    xmlNsPtr *ns;
+    unsigned flags;
+
+    ptrarray_t *props;
+    size_t baselen;
+    xmlBufferPtr xmlbuf;
+};
+
+
+static void import_resource(const char *uid, void *data, void *rock)
+{
+    ptrarray_t *comps = (ptrarray_t *) data;
+    struct import_rock *irock = (struct import_rock *) rock;
+    struct transaction_t *txn = irock->txn;
+    xmlNodePtr root = irock->root, resp, node;
+    xmlNsPtr *ns = irock->ns;
+    xmlBufferPtr *xmlbuf = &irock->xmlbuf;
+    icalcomponent *newical;
+    int i, r;
+
+    /* Create DAV:response element */
+    resp = xmlNewChild(root, ns[NS_DAV], BAD_CAST "response", NULL);
+    if (!resp) {
+        syslog(LOG_ERR,
+               "import_resource()): Unable to add response XML element");
+        fatal("import_resource()): Unable to add response XML element",
+              EX_SOFTWARE);
+    }
+
+    /* Create new object, making copies of PRODID, VERSION, CALSCALE */
+    newical = icalcomponent_new(ICAL_VCALENDAR_COMPONENT);
+
+    for (i = 0; i < ptrarray_size(irock->props); i++) {
+        icalproperty *newprop =
+            icalproperty_clone(ptrarray_nth(irock->props, i));
+
+        icalcomponent_add_property(newical, newprop);
+    }
+
+    /* Add component in recurrence set */
+    for (i = 0; i < ptrarray_size(comps); i++) {
+        struct timezone_rock tzrock = { irock->ical, newical };
+        icalcomponent *comp = ptrarray_nth(comps, i);
+
+        icalcomponent_add_component(newical, comp);
+
+        /* Add required timezone components */
+        icalcomponent_foreach_tzid(comp, &add_timezone, &tzrock);
+    }
+
+    /* Append a unique resource name to URL and perform a PUT */
+    txn->req_tgt.reslen =
+        snprintf(txn->req_tgt.resource, MAX_MAILBOX_PATH - irock->baselen,
+                 "%s.ics", makeuuid());
+
+    r = caldav_put(txn, newical, irock->mailbox,
+                   txn->req_tgt.resource, irock->caldavdb, irock->flags);
+
+    switch (r) {
+    case HTTP_OK:
+    case HTTP_CREATED:
+    case HTTP_NO_CONTENT:
+        /* Success: Add DAV:href and DAV:propstat elements */
+        xml_add_href(resp, NULL, txn->req_tgt.path);
+
+        node = xmlNewChild(resp, ns[NS_DAV], BAD_CAST "propstat", NULL);
+        xmlNewChild(node, ns[NS_DAV], BAD_CAST "status",
+                    BAD_CAST http_statusline(VER_1_1, HTTP_OK));
+
+        node = xmlNewChild(node, ns[NS_DAV], BAD_CAST "prop", NULL);
+
+        if (txn->resp_body.etag) {
+            /* Add DAV:getetag property */
+            xmlNewTextChild(node, ns[NS_DAV], BAD_CAST "getetag",
+                            BAD_CAST txn->resp_body.etag);
+        }
+        if ((irock->flags & PREFER_REP) &&
+            icalcomponent_get_first_property(ptrarray_nth(comps, 0),
+                                             ICAL_ORGANIZER_PROPERTY)) {
+            /* Add CALDAV:calendar-data property */
+            const char *icalstr = icalcomponent_as_ical_string(newical);
+            xmlNodePtr cdata = xmlNewChild(node, ns[NS_CALDAV],
+                                           BAD_CAST "calendar-data", NULL);
+
+            xmlAddChild(cdata, xmlNewCDataBlock(root->doc, BAD_CAST icalstr,
+                                                strlen(icalstr)));
+        }
+        break;
+
+    default:
+        /* Failure: Add DAV:href, DAV:status, and DAV:error elements */
+        xml_add_href(resp, NULL, NULL);
+
+        xmlNewChild(resp, ns[NS_DAV], BAD_CAST "status",
+                    BAD_CAST http_statusline(VER_1_1, r));
+
+        node = xml_add_error(resp, &txn->error, ns);
+        break;
+    }
+
+    /* Add CS:uid property */
+    xmlNewTextChild(node, ns[NS_CS], BAD_CAST "uid", BAD_CAST uid);
+
+    /* Add DAV:response element for this resource to output buffer.
+       Only output the xmlBuffer every PROT_BUFSIZE bytes */
+    xml_partial_response((xmlBufferLength(*xmlbuf) > PROT_BUFSIZE) ? txn : NULL,
+                         root->doc, resp, 1, xmlbuf);
+
+    /* Remove DAV:response element from root (no need to keep in memory) */
+    xmlReplaceNode(resp, NULL);
+    xmlFreeNode(resp);
+
+    icalcomponent_free(newical);
+    ptrarray_free(comps);
+}
+
+
 /* Perform a bulk import */
 static int caldav_import(struct transaction_t *txn, void *obj,
                          struct mailbox *mailbox, void *destdb,
                          xmlNodePtr root, xmlNsPtr *ns, unsigned flags)
 {
-    int ret = 0;
+    struct hash_table comp_table = HASH_TABLE_INITIALIZER;
     icalcomponent *ical = obj, *comp, *next;
-    icalcomponent_kind kind;
-    icalproperty *prodid, *version, *calscale;
+    icalproperty *prop;
     const char *uid;
-    struct caldav_db *caldavdb = destdb;
-    xmlNodePtr resp, propstat, prop, error;
-    unsigned post_count = 0;
+    ptrarray_t *comps;
+    struct import_rock irock = { txn, ical, mailbox, destdb, root, ns, flags,
+                                 NULL/*props*/, 0/*baselen*/, NULL/*xmlbuf*/ };
 
     if (!root) {
         /* Validate the iCal data */
@@ -2872,7 +3539,7 @@ static int caldav_import(struct transact
             txn->error.precond = CALDAV_VALID_DATA;
             return HTTP_FORBIDDEN;
         }
-        icalrestriction_check(ical);
+        cyrus_icalrestriction_check(ical);
         if ((txn->error.desc = get_icalcomponent_errstr(ical))) {
             buf_setcstr(&txn->buf, txn->error.desc);
             txn->error.desc = buf_cstring(&txn->buf);
@@ -2903,97 +3570,68 @@ static int caldav_import(struct transact
         return 0;
     }
 
-    ensure_ns(ns, NS_CALDAV, root, XML_NS_CALDAV, "C");
+    /* Fetch important properties from VCALENDAR */
+    irock.props = ptrarray_new();
+    for (prop = icalcomponent_get_first_property(ical, ICAL_ANY_PROPERTY);
+         prop; prop = icalcomponent_get_next_property(ical, ICAL_ANY_PROPERTY)) {
+
+        switch (icalproperty_isa(prop)) {
+        case ICAL_CALSCALE_PROPERTY:
+        case ICAL_PRODID_PROPERTY:
+        case ICAL_VERSION_PROPERTY:
+            ptrarray_append(irock.props, prop);
+            break;
+
+        default:
+            break;
+        }
+    }
 
-    size_t len = strlen(txn->req_tgt.path);
-    txn->req_tgt.resource = txn->req_tgt.path + len;
+    /* Setup for appending resource name to request path */
+    irock.baselen = strlen(txn->req_tgt.path);
+    txn->req_tgt.resource = txn->req_tgt.path + irock.baselen;
 
-    prodid = icalcomponent_get_first_property(ical, ICAL_PRODID_PROPERTY);
-    version = icalcomponent_get_first_property(ical, ICAL_VERSION_PROPERTY);
-    calscale = icalcomponent_get_first_property(ical, ICAL_CALSCALE_PROPERTY);
+    /* Create hash table of components */
+    construct_hash_table(&comp_table, 100, 1);
 
+    /* Group components by UID (recurrence sets) */
     for (comp = icalcomponent_get_first_component(ical, ICAL_ANY_COMPONENT);
          comp; comp = next) {
-        icalcomponent *newical;
-        struct timezone_rock tzrock;
 
         next = icalcomponent_get_next_component(ical, ICAL_ANY_COMPONENT);
-        kind = icalcomponent_isa(comp);
-        if (kind == ICAL_VTIMEZONE_COMPONENT) continue;
 
-        /* Create new object, making copies of PRODID, VERSION, CALSCALE */
-        newical = icalcomponent_new(ICAL_VCALENDAR_COMPONENT);
-        if (prodid)
-            icalcomponent_add_property(newical, icalproperty_new_clone(prodid));
-        if (version)
-            icalcomponent_add_property(newical, icalproperty_new_clone(version));
-        if (calscale)
-            icalcomponent_add_property(newical, icalproperty_new_clone(calscale));
+        if (icalcomponent_isa(comp) == ICAL_VTIMEZONE_COMPONENT) continue;
 
-        /* Add our component */
         icalcomponent_remove_component(ical, comp);
-        icalcomponent_add_component(newical, comp);
-
-        /* Look for matching UIDs (recurrence set) */
 
-        /* Add required timezone components */
-        tzrock.old = ical;
-        tzrock.new = newical;
-        icalcomponent_foreach_tzid(comp, &add_timezone, &tzrock);
-
-        /* Append a unique resource name to URL and perform a PUT */
         uid = icalcomponent_get_uid(comp);
-        txn->req_tgt.reslen =
-            snprintf(txn->req_tgt.resource, MAX_MAILBOX_PATH - len,
-                     "%x-%d-%ld-%u.ics",
-                     strhash(uid), getpid(), time(0), post_count++);
-
-        ret = caldav_put(txn, newical, mailbox,
-                         txn->req_tgt.resource, caldavdb, flags);
-
-        resp = xmlNewChild(root, ns[NS_DAV], BAD_CAST "response", NULL);
-        if (!resp) {
-            txn->error.desc = "Unable to add response XML element";
-            return HTTP_SERVER_ERROR;
-        }
+        comps = hash_lookup(uid, &comp_table);
 
-        switch (ret) {
-        case HTTP_OK:
-        case HTTP_CREATED:
-        case HTTP_NO_CONTENT:
-            xml_add_href(resp, NULL, txn->req_tgt.path);
-            propstat = xmlNewChild(resp, ns[NS_DAV], BAD_CAST "propstat", NULL);
-            prop = xmlNewChild(propstat, ns[NS_DAV], BAD_CAST "prop", NULL);
-
-            if (txn->resp_body.etag) {
-                xmlNewTextChild(prop, ns[NS_DAV], BAD_CAST "getetag",
-                                BAD_CAST txn->resp_body.etag);
-            }
-            if (flags & PREFER_REP) {
-                xmlNodePtr data = xmlNewChild(prop, ns[NS_CALDAV],
-                                              BAD_CAST "calendar-data", NULL);
-                const char *icalstr = icalcomponent_as_ical_string(newical);
-                xmlAddChild(data, xmlNewCDataBlock(root->doc, BAD_CAST icalstr,
-                                                   strlen(icalstr)));
-            }
-            else xmlNewTextChild(prop, ns[NS_CS], BAD_CAST "uid", BAD_CAST uid);
-
-            xmlNewChild(propstat, ns[NS_DAV], BAD_CAST "status",
-                        BAD_CAST http_statusline(HTTP_OK));
-            break;
-
-        default:
-            xml_add_href(resp, NULL, NULL);
-            xmlNewChild(resp, ns[NS_DAV], BAD_CAST "status",
-                        BAD_CAST http_statusline(ret));
-            error = xml_add_error(resp, &txn->error, ns);
-            xmlNewTextChild(error, ns[NS_CS], BAD_CAST "uid", BAD_CAST uid);
-            break;
+        if (!comps) {
+            /* Haven't seen this UID yet - create new recurrence set */
+            comps = ptrarray_new();
+            hash_insert(uid, comps, &comp_table);
         }
 
-        icalcomponent_free(newical);
+        /* Add component to recurrence set */
+        if (icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY)) {
+            ptrarray_append(comps, comp);
+        }
+        else {
+            /* Master component - always place first */
+            ptrarray_insert(comps, 0, comp);
+        }
     }
 
+    /* Process the recurrence sets */
+    hash_enumerate(&comp_table, &import_resource, &irock);
+    free_hash_table(&comp_table, NULL);
+    ptrarray_free(irock.props);
+
+    /* End XML response */
+    xml_partial_response(txn, root->doc, NULL /* end */, 0, &irock.xmlbuf);
+    xmlBufferFree(irock.xmlbuf);
+
     return 0;
 }
 
@@ -3046,872 +3684,502 @@ static int caldav_post(struct transactio
 }
 
 
-#ifdef HAVE_VPATCH
-enum {
-    ACTION_UPDATE = 1,
-    ACTION_DELETE,
-    ACTION_SETPARAM
-};
-
-enum {
-    SEGMENT_COMP = 1,
-    SEGMENT_PROP,
-    SEGMENT_PARAM
-};
-
-union match_criteria_t {
-    struct {
-        char *uid;                /* component UID (optional) */
-        icaltimetype rid;         /* component RECURRENCE-ID (optional) */
-    } comp;
-    struct {
-        char *param;              /* parameter name (optional) */
-        char *value;              /* prop/param value (optional) */
-        unsigned not:1;           /* not equal? */
-    } prop;
-};
-
-struct path_segment_t {
-    unsigned type;                    /* Is it comp, prop, or param segment? */
-    unsigned kind;                    /* libical kind of comp, prop, or param */
-    union match_criteria_t match;     /* match criteria (depends on 'type') */
-    unsigned action;                  /* patch action (create,update,setparam)*/
-    void *data;                       /* patch data (depends on 'action') */
-
-    struct path_segment_t *sibling;
-    struct path_segment_t *child;
-};
-
-struct patch_data_t {
-    icalcomponent *patch;             /* component containg patch data */
-    struct path_segment_t *delete;    /* list of PATCH-DELETE actions */
-    struct path_segment_t *setparam;  /* list of PATCH-PARAMETER items */
-};
-
-static int parse_target_path(char *path, struct path_segment_t **path_seg,
-                             unsigned action, void *data,
-                             struct error_t *err)
-{
-    char *p, sep;
-    struct path_segment_t *tail = NULL, *new;
-
-    for (sep = *path++; sep == '/';) {
-        p = path + strcspn(path, "[/#");
-        if ((sep = *p)) *p++ = '\0';
-
-        new = xzmalloc(sizeof(struct path_segment_t));
-        new->type = SEGMENT_COMP;
-        new->kind = icalcomponent_string_to_kind(path);
-        /* Initialize RID as invalid time rather than NULL time
-           since NULL time is used for empty RID (master component) */
-        new->match.comp.rid.year = -1;
-
-        if (!*path_seg) *path_seg = new;
-        else tail->child = new;
-        tail = new;
-
-        path = p;
-
-        if (sep == '[') {
-            /* Parse comp-match */
-            const char *prefix = "UID=";
-            size_t prefix_len = strlen(prefix);
-
-            if (!(p = strchr(path, ']'))) {
-                err->desc = "Badly formatted comp-match";
-                return HTTP_BAD_REQUEST;
-            }
-
-            /* Parse uid-match */
-            if (!strncmp(path, prefix, prefix_len)) {
-                path += prefix_len;
-                *p++ = '\0';
-                new->match.comp.uid = xstrdup(path);
-                sep = *p++;
-                path = p;
-            }
-
-            /* Parse rid-match */
-            if (sep == '[') {
-                prefix = "RID=";
-                prefix_len = strlen(prefix);
-
-                if (strncmp(path, prefix, prefix_len) ||
-                    !(p = strchr(path, ']'))) {
-                    err->desc = "Badly formatted rid-match";
-                    return HTTP_BAD_REQUEST;
-                }
-
-                path += prefix_len;
-                *p++ = '\0';
-                if (*path && strcmp(path, "M")) {
-                    new->match.comp.rid = icaltime_from_string(path);
-                    if (icaltime_is_null_time(new->match.comp.rid)) {
-                        err->desc = "Invalid recurrence-id";
-                        return HTTP_BAD_REQUEST;
-                    }
-                }
-                else new->match.comp.rid = icaltime_null_time();
+/* Perform a PATCH request
+ *
+ * preconditions:
+ */
+static int caldav_patch(struct transaction_t *txn, void *obj)
+{
+    icalcomponent *ical = (icalcomponent *) obj;
+    icalcomponent *pdoc, *vpatch;
+    icalproperty *prop;
+    int num_changes = 0;
+    int ret = 0;
 
-                sep = *p++;
-                path = p;
-            }
-        }
+    /* Validate the iCal patch */
+    pdoc = ical_string_as_icalcomponent(&txn->req_body.payload);
+    if (!pdoc || (icalcomponent_isa(pdoc) != ICAL_VCALENDAR_COMPONENT)) {
+        txn->error.desc = "Missing VCALENDAR";
+        txn->error.precond = CALDAV_VALID_DATA;
+        ret = HTTP_BAD_REQUEST;
     }
-
-    if (sep == '#' && !*path_seg) {
-        /* Parse prop-segment */
-        p = path + strcspn(path, "[;=");
-        if ((sep = *p)) *p++ = '\0';
-
-        new = xzmalloc(sizeof(struct path_segment_t));
-        new->type = SEGMENT_PROP;
-        new->kind = icalproperty_string_to_kind(path);
-
-        if (!*path_seg) *path_seg = new;
-        else tail->child = new;
-        tail = new;
-
-        path = p;
-
-        if (sep == '[') {
-            /* Parse prop-match (MUST start with '=' or '!' or '@') */
-            if (strspn(path, "=!@") != 1 || !(p = strchr(path, ']'))) {
-                err->desc = "Badly formatted prop-match";
-                return HTTP_BAD_REQUEST;
-            }
-
-            *p++ = '\0';
-            if (*path == '@') {
-                /* Parse param-match */
-                size_t namelen = strcspn(++path, "!=");
-                new->match.prop.param = xstrndup(path, namelen);
-                path += namelen;
-            }
-
-            if (*path) {
-                /* Parse prop/param [not]equal value */
-                if (*path++ == '!') new->match.prop.not = 1;
-                new->match.prop.value = xstrdup(path);
-            }
-
-            sep = *p++;
-            path = p;
-        }
-
-        if (sep == ';') {
-            /* Parse param-segment */
-            p = path + strcspn(path, "=");
-            if ((sep = *p)) *p++ = '\0';
-
-            new = xzmalloc(sizeof(struct path_segment_t));
-            new->type = SEGMENT_PARAM;
-            new->kind = icalparameter_string_to_kind(path);
-
-            tail->child = new;
-            tail = new;
-
-            path = p;
-        }
-
-        if (sep == '=' && action == ACTION_DELETE) {
-            /* Parse value-segment */
-            new->data = xstrdup(path);
-        }
-        else if (sep != '\0') {
-            err->desc = "Invalid separator following prop-segment";
-            return HTTP_BAD_REQUEST;
+    else if (!icalrestriction_check(pdoc) || icalcomponent_count_errors(pdoc)) {
+        if ((txn->error.desc = get_icalcomponent_errstr(pdoc)) ||
+            (txn->error.desc =
+             get_icalcomponent_errstr(icalcomponent_get_first_real_component(pdoc)))) {
+            buf_setcstr(&txn->buf, txn->error.desc);
+            txn->error.desc = buf_cstring(&txn->buf);
         }
+        else txn->error.desc = "Error in VPATCH";
+        txn->error.precond = CALDAV_VALID_DATA;
+        ret = HTTP_BAD_REQUEST;
     }
-    else if (sep != '\0') {
-        err->desc = "Invalid separator following comp-segment";
-        return HTTP_BAD_REQUEST;
+    else if (!(vpatch = icalcomponent_get_first_real_component(pdoc)) ||
+             icalcomponent_isa(vpatch) != ICAL_VPATCH_COMPONENT) {
+        txn->error.desc = "Missing VPATCH";
+        txn->error.precond = CALDAV_VALID_DATA;
+        ret = HTTP_BAD_REQUEST;
     }
-
-    tail->action = action;
-    if (!tail->data) tail->data = data;
-
-    return 0;
-}
-
-static void apply_patch(struct path_segment_t *path_seg,
-                        void *parent, int *num_changes);
-
-static char *remove_single_value(const char *oldstr, const char *single)
-{
-    char *newstr = NULL;
-    strarray_t *values = strarray_split(oldstr, ",", STRARRAY_TRIM);
-    int idx = strarray_find(values, single, 0);
-
-    if (idx >= 0) {
-        /* Found the single value, remove it, and create new string */
-        strarray_remove(values, idx);
-        newstr = strarray_join(values, ",");
+    else if ((prop =
+              icalcomponent_get_first_property(vpatch,
+                                               ICAL_PATCHVERSION_PROPERTY)) &&
+             strcmp(icalproperty_get_patchversion(prop), "1")) {
+        txn->error.desc = "Unsupported PATCH-VERSION";
+        txn->error.precond = CALDAV_SUPP_DATA;
+        ret = HTTP_BAD_REQUEST;
     }
-    strarray_free(values);
-
-    return newstr;
-}
 
-/* Apply a patch action to a parameter segment */
-static void apply_patch_parameter(struct path_segment_t *path_seg,
-                                  icalproperty *parent, int *num_changes)
-{
-    icalparameter *param =
-        icalproperty_get_first_parameter(parent, path_seg->kind);
-    if (!param) return;
-
-    if (path_seg->action == ACTION_DELETE) {
-        switch (path_seg->kind) {
-        case ICAL_MEMBER_PARAMETER:
-            /* Multi-valued parameter */
-            if (path_seg->data) {
-                /* Check if entire parameter value == single value */
-                const char *single = (const char *) path_seg->data;
-                const char *param_val = icalparameter_get_value_as_string(param);
-
-                if (strcmp(param_val, single)) {
-                    /* Not an exact match, try to remove single value */
-                    char *newval = remove_single_value(param_val, single);
-                    if (newval) {
-                        *num_changes += 1;
-                        icalparameter_set_member(param, newval);
-                        free(newval);
-                    }
-                    break;
-                }
-            }
+    if (!ret) ret = icalcomponent_apply_vpatch(ical, vpatch,
+                                               &num_changes, &txn->error.desc);
 
-            /* Fall through and delete entire parameter */
-            GCC_FALLTHROUGH
+    icalcomponent_free(pdoc);
 
-        default:
-            *num_changes += 1;
-            icalproperty_remove_parameter_by_ref(parent, param);
-            break;
-        }
+    if (ret) return ret;
+    else if (!num_changes) {
+        /* If no changes are made,
+           return HTTP_NO_CONTENT to suppress storing of resource */
+        return HTTP_NO_CONTENT;
     }
+    else return 0;
 }
 
-static int apply_param_match(icalproperty *prop, union match_criteria_t *match)
+
+/*
+ * Compare two components and extract per-user data (alarms, transparency).
+ *
+ * NOTE: This function assumes that both components has been normalized
+ */
+static int extract_personal_data(icalcomponent *ical, icalcomponent *oldical,
+                                 icalcomponent *vpatch, struct buf *path,
+                                 int read_only, unsigned *num_changes)
 {
-    icalparameter_kind kind;
-    icalparameter *param;
-    int ret = 1;
+    icalcomponent *comp, *nextcomp, *oldcomp = NULL, *patch = NULL;
+    icalproperty *prop, *nextprop, *oldprop = NULL;
+    int r;
 
-    /* XXX  Need to handle X- parameters */
+    /* Add this component to path */
+    size_t path_len = buf_len(path);
+    buf_printf(path, "/%s",
+               icalcomponent_kind_to_string(icalcomponent_isa(ical)));
 
-    kind = icalparameter_string_to_kind(match->prop.param);
-    param = icalproperty_get_first_parameter(prop, kind);
-    if (!param) {
-        /* property doesn't have this parameter */
-        ret = match->prop.not;
+    prop = icalcomponent_get_first_property(ical, ICAL_UID_PROPERTY);
+    if (prop) {
+        buf_printf(path, "[UID=%s]", icalproperty_get_uid(prop));
+        prop = icalcomponent_get_first_property(ical,
+                                                ICAL_RECURRENCEID_PROPERTY);
+        buf_printf(path, "[RID=%s]",
+                   prop ? icalproperty_get_value_as_string(prop) : "M");
     }
-    else if (match->prop.value) {
-        const char *param_val = icalparameter_get_value_as_string(param);
 
-        ret = !strcmp(match->prop.value, param_val);
-        if (match->prop.not) ret = !ret;  /* invert */
+    if (oldical) {
+        oldprop = icalcomponent_get_first_property(oldical, ICAL_ANY_PROPERTY);
+        oldcomp = icalcomponent_get_first_component(oldical, ICAL_ANY_COMPONENT);
     }
 
-    return ret;
-}
-
-/* Apply a patch action to a property segment */
-static void apply_patch_property(struct path_segment_t *path_seg,
-                                 icalcomponent *parent, int *num_changes)
-{
-    icalproperty *prop, *nextprop;
-    icalparameter *param;
-
-    /* Iterate through each property */
-    for (prop = icalcomponent_get_first_property(parent, path_seg->kind);
+    for (prop = icalcomponent_get_first_property(ical, ICAL_ANY_PROPERTY);
          prop; prop = nextprop) {
-        nextprop = icalcomponent_get_next_property(parent, path_seg->kind);
-
-        /* Check prop-match */
-        int match = 1;
-        if (path_seg->match.prop.param) {
-            /* Check param-match */
-            match = apply_param_match(prop, &path_seg->match);
-        }
-        else if (path_seg->match.prop.value) {
-            /* Check prop-[not-]equal */
-            const char *prop_val = icalproperty_get_value_as_string(prop);
-
-            match = !strcmp(path_seg->match.prop.value, prop_val);
-            if (path_seg->match.prop.not) match = !match;  /* invert */
-        }
-        if (!match) continue;
-
-        if (path_seg->child) {
-            /* Recurse into next segment */
-            apply_patch(path_seg->child, prop, num_changes);
-        }
-        else if (path_seg->action == ACTION_DELETE) {
-            /* Delete existing property */
-            switch (path_seg->kind) {
-            case ICAL_RDATE_PROPERTY:
-            case ICAL_EXDATE_PROPERTY:
-            case ICAL_FREEBUSY_PROPERTY:
-            case ICAL_CATEGORIES_PROPERTY:
-            case ICAL_RESOURCES_PROPERTY:
-            case ICAL_ACCEPTRESPONSE_PROPERTY:
-            case ICAL_POLLPROPERTIES_PROPERTY:
-                /* Multi-valued property */
-                if (path_seg->data) {
-                    /* Check if entire property value == single value */
-                    const char *single = (const char *) path_seg->data;
-                    const char *propval = icalproperty_get_value_as_string(prop);
-
-                    if (strcmp(propval, single)) {
-                        /* Not an exact match, try to remove single value */
-                        char *newval = remove_single_value(propval, single);
-                        if (newval) {
-                            *num_changes += 1;
-                            icalproperty_set_value(prop,
-                                                   icalvalue_new_string(newval));
-                            free(newval);
-                        }
-                        break;
-                    }
-                }
-
-                /* Fall through and delete entire property */
-                GCC_FALLTHROUGH
-
-            default:
-                *num_changes += 1;
-                icalcomponent_remove_property(parent, prop);
-                icalproperty_free(prop);
-                break;
+        const char *xname = NULL, *oldxname;
+        icalproperty_kind kind = icalproperty_isa(prop);
+        icalproperty_kind oldkind =
+            oldprop ? icalproperty_isa(oldprop) : ICAL_NO_PROPERTY;
+
+        nextprop = icalcomponent_get_next_property(ical, ICAL_ANY_PROPERTY);
+
+        if (oldkind == ICAL_NO_PROPERTY) {
+            /* No more components in old component */
+            r = -1;
+        }
+        else if (kind == oldkind) {
+            if (kind == ICAL_X_PROPERTY) {
+                /* Compare property names alphabetically */
+                xname = icalproperty_get_x_name(prop);
+                oldxname = icalproperty_get_x_name(oldprop);
+                r = strcmp(xname, oldxname);
             }
+            else r = 0;
         }
-        else if (path_seg->action == ACTION_SETPARAM) {
-            /* Set parameter(s) from those on PATCH-PARAMETER */
-            icalproperty *pp_prop = (icalproperty *) path_seg->data;
-
-            *num_changes += 1;
-            for (param = icalproperty_get_first_parameter(pp_prop,
-                                                          ICAL_ANY_PARAMETER);
-                 param;
-                 param = icalproperty_get_next_parameter(pp_prop,
-                                                         ICAL_ANY_PARAMETER)) {
-                icalproperty_set_parameter(prop, icalparameter_new_clone(param));
-            }
-        }
-    }
-}
-
-static void create_override(icalcomponent *master, struct icaltime_span *span,
-                            void *rock)
-{
-    icalcomponent *new;
-    icalproperty *prop, *next;
-    struct icaltimetype dtstart, dtend, now;
-    const icaltimezone *tz = NULL;
-    const char *tzid;
-    int is_date;
-
-    now = icaltime_current_time_with_zone(utc_zone);
-
-    new = icalcomponent_new_clone(master);
-
-    for (prop = icalcomponent_get_first_property(new, ICAL_ANY_PROPERTY);
-         prop; prop = next) {
-        next = icalcomponent_get_next_property(new, ICAL_ANY_PROPERTY);
-
-        switch (icalproperty_isa(prop)) {
-        case ICAL_DTSTART_PROPERTY:
-            /* Set DTSTART for this recurrence */
-            dtstart = icalproperty_get_dtstart(prop);
-            is_date = icaltime_is_date(dtstart);
-            tz = icaltime_get_timezone(dtstart);
-
-            dtstart = icaltime_from_timet_with_zone(span->start, is_date, tz);
-            icaltime_set_timezone(&dtstart, tz);
-            icalproperty_set_dtstart(prop, dtstart);
-
-            /* Add RECURRENCE-ID for this recurrence */
-            prop = icalproperty_new_recurrenceid(dtstart);
-            tzid = icaltimezone_get_tzid((icaltimezone *) tz);
-            if (tzid) {
-                icalproperty_add_parameter(prop, icalparameter_new_tzid(tzid));
-            }
-            icalcomponent_add_property(new, prop);
-            break;
-
-        case ICAL_DTEND_PROPERTY:
-            /* Set DTEND for this recurrence */
-            dtend = icalproperty_get_dtend(prop);
-            is_date = icaltime_is_date(dtend);
-            tz = icaltime_get_timezone(dtend);
-
-            dtend = icaltime_from_timet_with_zone(span->end, is_date, tz);
-            icaltime_set_timezone(&dtend, tz);
-            icalproperty_set_dtend(prop, dtend);
-            break;
-
-        case ICAL_RRULE_PROPERTY:
-        case ICAL_RDATE_PROPERTY:
-        case ICAL_EXDATE_PROPERTY:
-            /* Remove recurrence properties */
-            icalcomponent_remove_property(new, prop);
-            icalproperty_free(prop);
-            break;
-
-        case ICAL_DTSTAMP_PROPERTY:
-            /* Update DTSTAMP */
-            icalproperty_set_dtstamp(prop, now);
-            break;
-
-        case ICAL_CREATED_PROPERTY:
-            /* Update CREATED */
-            icalproperty_set_created(prop, now);
-            break;
-
-        case ICAL_LASTMODIFIED_PROPERTY:
-            /* Update LASTMODIFIED */
-            icalproperty_set_lastmodified(prop, now);
-            break;
-
-        default:
-            break;
+        else {
+            /* Compare property names alphabetically */
+            r = strcmp(icalproperty_kind_to_string(kind),
+                       icalproperty_kind_to_string(oldkind));
         }
-    }
 
-    *((icalcomponent **) rock) = new;
-}
+        if (r == 0) {
+            switch (kind) {
+            case ICAL_CALSCALE_PROPERTY:
+            case ICAL_PRODID_PROPERTY:
+            case ICAL_DTSTAMP_PROPERTY:
+            case ICAL_LASTMODIFIED_PROPERTY:
+                /* Ok to modify these - ignore */
+                break;
 
-/* Apply property updates */
-static void apply_property_updates(struct patch_data_t *patch,
-                                   icalcomponent *parent, int *num_changes)
-{
-    icalproperty *prop = NULL, *nextprop, *newprop;
-
-    for (newprop = icalcomponent_get_first_property(patch->patch,
-                                                    ICAL_ANY_PROPERTY);
-         newprop;
-         newprop = icalcomponent_get_next_property(patch->patch,
-                                                   ICAL_ANY_PROPERTY)) {
-        icalproperty_kind kind = icalproperty_isa(newprop);
-        icalparameter_patchaction action = ICAL_PATCHACTION_BYNAME;
-        icalparameter *actionp;
-        union match_criteria_t byparam;
-
-        memset(&byparam, 0, sizeof(union match_criteria_t));
-        newprop = icalproperty_new_clone(newprop);
-
-        actionp = icalproperty_get_first_parameter(newprop,
-                                                   ICAL_PATCHACTION_PARAMETER);
-        if (actionp) {
-            action = icalparameter_get_patchaction(actionp);
-            if (action == ICAL_PATCHACTION_X) {
-                /* libical treats DQUOTEd BYPARAM as X value */
-                const char *byparam_prefix = "BYPARAM@";
-                const char *x_val = icalparameter_get_xvalue(actionp);
-                if (!strncmp(x_val, byparam_prefix, strlen(byparam_prefix))) {
-                    /* Parse param-match */
-                    const char *p = x_val + strlen(byparam_prefix);
-                    size_t namelen = strcspn(p, "!=");
-                    byparam.prop.param = xstrndup(p, namelen);
-                    p += namelen;
-
-                    if (*p) {
-                        if (*p++ == '!') byparam.prop.not = 1;
-                        byparam.prop.value = xstrdup(p);
-                    }
-                    action = ICAL_PATCHACTION_BYPARAM;
+            case ICAL_X_PROPERTY:
+                if (!strcmpsafe(xname, "X-MOZ-GENERATION")) {
+                    /* Ok to modify these - ignore */
+                    break;
                 }
-            }
-
-            icalproperty_remove_parameter_by_ref(newprop, actionp);
-            icalparameter_free(actionp);
-        }
-
-        if (action != ICAL_PATCHACTION_CREATE) {
-            /* Delete properties matching those being updated */
-            const char *value = icalproperty_get_value_as_string(newprop);
 
-            for (prop = icalcomponent_get_first_property(parent, kind);
-                 prop; prop = nextprop) {
-                int match = 1;
-
-                nextprop = icalcomponent_get_next_property(parent, kind);
+                GCC_FALLTHROUGH
 
-                if (action == ICAL_PATCHACTION_BYVALUE) {
-                    match = !strcmp(value,
-                                    icalproperty_get_value_as_string(prop));
-                }
-                else if (action == ICAL_PATCHACTION_BYPARAM) {
-                    /* Check param-match */
-                    match = apply_param_match(prop, &byparam);
-                    free(byparam.prop.param);
-                    free(byparam.prop.value);
+            default:
+                /* Compare entire properties (names, values, parameters) */
+                if (strcmp(icalproperty_as_ical_string(prop),
+                           icalproperty_as_ical_string(oldprop))) {
+                    /* Property has been updated in ical */
+                    if (read_only) return HTTP_FORBIDDEN;
+                    if (num_changes) (*num_changes)++;
                 }
-                if (!match) continue;
-
-                icalcomponent_remove_property(parent, prop);
-                icalproperty_free(prop);
+                break;
             }
         }
+        else if (r < 0) {
+            /* Property has been added to ical */
+            switch (kind) {
+            case ICAL_CALSCALE_PROPERTY:
+            case ICAL_PRODID_PROPERTY:
+            case ICAL_DTSTAMP_PROPERTY:
+            case ICAL_LASTMODIFIED_PROPERTY:
+                /* Ok to add these - ignore */
+                break;
 
-        *num_changes += 1;
-        icalcomponent_add_property(parent, newprop);
-    }
-}
+            case ICAL_X_PROPERTY:
+                xname = icalproperty_get_x_name(prop);
+                if (strncmp(xname, "X-MOZ-", 6) ||
+                    (strcmp(xname+6, "LASTACK") &&
+                     strcmp(xname+6, "SNOOZE-TIME"))) {
+                    if (read_only) return HTTP_FORBIDDEN;
+                    if (num_changes) (*num_changes)++;
+                    break;
+                }
 
-/* Apply property updates */
-static void apply_component_updates(struct patch_data_t *patch,
-                                    icalcomponent *parent, int *num_changes)
-{
-    icalcomponent *comp, *nextcomp, *newcomp;
+                GCC_FALLTHROUGH
 
-    for (newcomp = icalcomponent_get_first_component(patch->patch,
-                                                     ICAL_ANY_COMPONENT);
-         newcomp;
-         newcomp = icalcomponent_get_next_component(patch->patch,
-                                                    ICAL_ANY_COMPONENT)){
-        icalcomponent_kind kind = icalcomponent_isa(newcomp);
-        const char *uid = icalcomponent_get_uid(newcomp);
-        icaltimetype rid = icalcomponent_get_recurrenceid(newcomp);
+            case ICAL_TRANSP_PROPERTY:
+                /* Add per-user property to VPATCH */
+                if (!patch) {
+                    patch = icalcomponent_vanew(ICAL_XPATCH_COMPONENT,
+                                                icalproperty_new_patchtarget(
+                                                    buf_cstring(path)),
+                                                0);
+                    icalcomponent_add_component(vpatch, patch);
+                }
 
-        newcomp = icalcomponent_new_clone(newcomp);
+                icalcomponent_remove_property(ical, prop);
+                icalcomponent_add_property(patch, prop);
+                break;
 
-        /* Delete components matching those being updated */
-        for (comp = icalcomponent_get_first_component(parent, kind);
-             comp; comp = nextcomp) {
+            default:
+                if (read_only) return HTTP_FORBIDDEN;
+                if (num_changes) (*num_changes)++;
+                break;
+            }
 
-            nextcomp = icalcomponent_get_next_component(parent, kind);
+            continue;  /* Do NOT increment to next old property */
+        }
+        else {
+            /* Property has been removed from ical */
+            switch (oldkind) {
+            case ICAL_CALSCALE_PROPERTY:
+            case ICAL_PRODID_PROPERTY:
+            case ICAL_DTSTAMP_PROPERTY:
+            case ICAL_LASTMODIFIED_PROPERTY:
+                /* Ok to remove these - ignore */
+                break;
 
-            if (strcmp(uid, icalcomponent_get_uid(comp)) ||
-                icaltime_compare(rid, icalcomponent_get_recurrenceid(comp))) {
-                /* skip */
-                continue;
+            default:
+                if (read_only) return HTTP_FORBIDDEN;
+                if (num_changes) (*num_changes)++;
+                break;
             }
-
-            icalcomponent_remove_component(parent, comp);
-            icalcomponent_free(comp);
         }
 
-        *num_changes += 1;
-        icalcomponent_add_component(parent, newcomp);
+        oldprop = icalcomponent_get_next_property(oldical, ICAL_ANY_PROPERTY);
     }
-}
-
-/* Apply a patch action to a component segment */
-static void apply_patch_component(struct path_segment_t *path_seg,
-                                 icalcomponent *parent, int *num_changes)
-{
-    icalcomponent *comp, *nextcomp, *master = NULL;
 
-    /* Iterate through each component */
-    if (path_seg->kind == ICAL_VCALENDAR_COMPONENT)
-        comp = parent;
-    else
-        comp = icalcomponent_get_first_component(parent, path_seg->kind);
+    for (comp = icalcomponent_get_first_component(ical, ICAL_ANY_COMPONENT);
+         comp; comp = nextcomp) {
+        icalcomponent_kind kind = icalcomponent_isa(comp);
+        icalcomponent_kind oldkind =
+            oldcomp ? icalcomponent_isa(oldcomp) : ICAL_NO_COMPONENT;
 
-    for (; comp; comp = nextcomp) {
-        nextcomp = icalcomponent_get_next_component(parent, path_seg->kind);
+        nextcomp = icalcomponent_get_next_component(ical, ICAL_ANY_COMPONENT);
 
-        /* Check comp-match */
-        if (path_seg->match.comp.uid &&
-            strcmp(path_seg->match.comp.uid, icalcomponent_get_uid(comp))) {
-            continue;  /* UID doesn't match */
+        if (oldkind == ICAL_NO_COMPONENT) {
+            /* No more components in old component */
+            r = -1;
         }
+        else if (kind == oldkind) {
+            if (kind == ICAL_X_COMPONENT) {
+                /* Compare component names alphabetically */
 
-        if (icaltime_is_valid_time(path_seg->match.comp.rid)) {
-            icaltimetype recurid =
-                icalcomponent_get_recurrenceid_with_zone(comp);
-
-            if (icaltime_is_null_time(recurid)) master = comp;
-            if (icaltime_compare(recurid, path_seg->match.comp.rid)) {
-                if (!nextcomp && master) {
-                    /* Possibly add an override recurrence.
-                       Set start and end to coincide with recurrence */
-                    icalcomponent *override = NULL;
-                    struct icaltimetype start = path_seg->match.comp.rid;
-                    struct icaltimetype end =
-                        icaltime_add(start, icalcomponent_get_duration(master));
-                    icalcomponent_foreach_recurrence(master, start, end,
-                                                     &create_override,
-                                                     &override);
-                    if (!override) break;  /* Can't override - done */
-
-                    /* Act on new overridden component */
-                    icalcomponent_add_component(parent, override);
-                    comp = override;
-                }
-                else continue;  /* RECURRENCE-ID doesn't match */
+                /* XXX  Need a new libical function */
+                r = 0;
             }
+            else r = 0;
         }
-
-        if (path_seg->child) {
-            /* Recurse into next segment */
-            apply_patch(path_seg->child, comp, num_changes);
-        }
-        else if (path_seg->action == ACTION_DELETE) {
-            /* Delete existing component */
-            *num_changes += 1;
-            icalcomponent_remove_component(parent, comp);
-            icalcomponent_free(comp);
+        else {
+            /* Compare component names alphabetically */
+            r = strcmp(icalcomponent_kind_to_string(kind),
+                       icalcomponent_kind_to_string(oldkind));
         }
-        else if (path_seg->action == ACTION_UPDATE) {
-            /* Patch existing component */
-            struct patch_data_t *patch = (struct patch_data_t *) path_seg->data;
-
-            /* Process all PATCH-DELETEs first */
-            for (path_seg = patch->delete;
-                 path_seg; path_seg = path_seg->child) {
-                apply_patch(path_seg, comp, num_changes);
-            }
 
-            /* Process all PATCH-SETPARAMETERs second */
-            for (path_seg = patch->setparam;
-                 path_seg; path_seg = path_seg->child) {
-                apply_patch(path_seg, comp, num_changes);
-            }
-
-            /* Process all components updates third */
-            apply_component_updates(patch, comp, num_changes);
-
-            /* Process all property updates last */
-            apply_property_updates(patch, comp, num_changes);
+        if (r == 0) {
+            r = extract_personal_data(comp, oldcomp, vpatch,
+                                      path, read_only, num_changes);
+            if (r) return r;
         }
-    }
-}
-
-/* Apply a patch action to a target segment */
-static void apply_patch(struct path_segment_t *path_seg,
-                        void *parent, int *num_changes)
-{
-    switch (path_seg->type) {
-    case SEGMENT_COMP:
-        apply_patch_component(path_seg, parent, num_changes);
-        break;
-
-    case SEGMENT_PROP:
-        apply_patch_property(path_seg, parent, num_changes);
-        break;
-
-    case SEGMENT_PARAM:
-        apply_patch_parameter(path_seg, parent, num_changes);
-        break;
-    }
-}
-
-static void path_segment_free(struct path_segment_t *path_seg)
-{
-    struct path_segment_t *next;
+        else if (r < 0) {
+            /* Component has been added to ical */
+            switch (kind) {
+            case ICAL_VALARM_COMPONENT:
+                /* Add per-user component to VPATCH */
+                if (!patch) {
+                    patch = icalcomponent_vanew(ICAL_XPATCH_COMPONENT,
+                                                icalproperty_new_patchtarget(
+                                                    buf_cstring(path)),
+                                                0);
+                    icalcomponent_add_component(vpatch, patch);
+                }
 
-    for (; path_seg; path_seg = next) {
-        next = path_seg->child;
+                icalcomponent_remove_component(ical, comp);
+                icalcomponent_add_component(patch, comp);
+                break;
 
-        switch (path_seg->type) {
-        case SEGMENT_COMP:
-            free(path_seg->match.comp.uid);
-            break;
+            default:
+                if (read_only) return HTTP_FORBIDDEN;
+                if (num_changes) (*num_changes)++;
 
-        case SEGMENT_PROP:
-            free(path_seg->match.prop.param);
-            free(path_seg->match.prop.value);
-            break;
+                r = extract_personal_data(comp, oldcomp, vpatch,
+                                          path, read_only, num_changes);
+                if (r) return r;
+                break;
+            }
 
-        case SEGMENT_PARAM:
-            break;
+            continue;  /* Do NOT increment to next old component */
         }
-
-        free(path_seg);
-    }
-}
-
-
-/* Perform a PATCH request
- *
- * preconditions:
- */
-static int caldav_patch(struct transaction_t *txn, void *obj)
-{
-    icalcomponent *ical = (icalcomponent *) obj;
-    icalcomponent *pdoc, *vpatch, *patch;
-    icalproperty *prop;
-    int num_changes = 0;
-    int ret = 0;
-
-    /* Validate the iCal patch */
-    pdoc = ical_string_as_icalcomponent(&txn->req_body.payload);
-    if (!pdoc || (icalcomponent_isa(pdoc) != ICAL_VCALENDAR_COMPONENT)) {
-        txn->error.desc = "Missing VCALENDAR";
-        txn->error.precond = CALDAV_VALID_DATA;
-        ret = HTTP_BAD_REQUEST;
-    }
-    else if (!icalrestriction_check(pdoc) || icalcomponent_count_errors(pdoc)) {
-        if ((txn->error.desc = get_icalcomponent_errstr(pdoc)) ||
-            (txn->error.desc =
-             get_icalcomponent_errstr(icalcomponent_get_first_real_component(pdoc)))) {
-            buf_setcstr(&txn->buf, txn->error.desc);
-            txn->error.desc = buf_cstring(&txn->buf);
+        else if (read_only) {
+            return HTTP_FORBIDDEN;
         }
-        txn->error.precond = CALDAV_VALID_DATA;
-        ret = HTTP_BAD_REQUEST;
+        else {
+            /* Component has been removed from ical */
+            if (num_changes) (*num_changes)++;
+        }
+
+        oldcomp = icalcomponent_get_next_component(oldical, ICAL_ANY_COMPONENT);
     }
-    else if (!(vpatch = icalcomponent_get_first_real_component(pdoc)) ||
-             icalcomponent_isa(vpatch) != ICAL_VPATCH_COMPONENT) {
-        txn->error.desc = "Missing VPATCH";
-        txn->error.precond = CALDAV_VALID_DATA;
-        ret = HTTP_BAD_REQUEST;
+
+    /* Trim this component from path */
+    buf_truncate(path, path_len);
+
+    return 0;
+}
+
+
+static int write_personal_data(const char *userid,
+                               struct mailbox *mailbox,
+                               uint32_t uid,
+                               modseq_t modseq,
+                               icalcomponent *vpatch)
+{
+    struct message_guid guid;
+    struct buf value = BUF_INITIALIZER;
+    const char *icalstr = icalcomponent_as_ical_string(vpatch);
+    struct dlist *dl = dlist_newkvlist(NULL, "CALDATA");
+    int ret;
+
+    ret = mailbox_get_annotate_state(mailbox, uid, NULL);
+    if (ret) return ret;
+
+    dlist_setdate(dl, "LASTMOD", time(0));
+    dlist_setnum64(dl, "MODSEQ", modseq);
+    message_guid_generate(&guid, icalstr, strlen(icalstr));
+    dlist_setguid(dl, "GUID", &guid);
+    dlist_setatom(dl, "VPATCH", icalstr);
+    dlist_printbuf(dl, 1, &value);
+    dlist_free(&dl);
+
+    ret = mailbox_annotation_write(mailbox, uid,
+                                   PER_USER_CAL_DATA, userid, &value);
+    buf_free(&value);
+
+    return ret;
+}
+
+
+/*
+ * Handle stripping per-user data from existing and/or new shared resource.
+ *
+ * Logic is as follows:
+ * 
+ *   Owner   R/W   Exists Shared   EO  SO  EU  SU  PD
+ *   ------------------------------------------------
+ *            0      0                             Y
+ *     0      0      1      0      Y   Y   Y
+ *     0      0      1      1              Y
+ *     0      1      0                     Y   Y
+ *     0      1      1      0      Y       Y   ?
+ *     0      1      1      1              Y   ?
+ *     1      0      1                     Y
+ *     1      1      0                         Y
+ *     1      1      1      0                  Y
+ *     1      1      1      1              Y   ?
+ *
+ *   EO = Extract Owner Data
+ *   SO = Store Owner Resource
+ *   EU = Extract User Data
+ *   SU = Store User Resource
+ *   PD = Permission Denied
+ */
+static int personalize_resource(struct transaction_t *txn,
+                                struct mailbox *mailbox,
+                                icalcomponent *ical,
+                                struct caldav_data *cdata,
+                                const char *userid,
+                                icalcomponent **store_me,
+                                icalcomponent **userdata)
+{
+    int is_owner, rights, read_only, ret = 0;
+    mbname_t *mbname;
+    const char *owner;
+    icalcomponent *oldical = NULL;
+    unsigned num_changes = 0;
+    struct auth_state *authstate = auth_newstate(userid);
+    char *resource = xstrdupnull(cdata->dav.resource);
+
+    *store_me = ical;
+
+    /* Check ownership and ACL for current user */
+    mbname = mbname_from_intname(mailbox->name);
+    owner = mbname_userid(mbname);
+    is_owner = !strcmpsafe(owner, userid);
+
+    rights = cyrus_acl_myrights(authstate, mailbox->acl);
+    auth_freestate(authstate);
+
+    if (rights & DACL_WRITECONT) {
+        /* User has read-write access */
+        read_only = 0;
+    }
+    else if (cdata->dav.imap_uid &&
+             !(mailbox->i.options & OPT_IMAP_SHAREDSEEN)) {
+        /* User has read-only access to existing resource */
+        read_only = 1;
     }
-    else if ((prop =
-              icalcomponent_get_first_property(vpatch,
-                                               ICAL_PATCHVERSION_PROPERTY)) &&
-             strcmp(icalproperty_get_patchversion(prop), "1")) {
-        txn->error.desc = "Unsupported PATCH-VERSION";
-        txn->error.precond = CALDAV_SUPP_DATA;
-        ret = HTTP_BAD_REQUEST;
+    else {
+        /* DAV:need-privileges */
+        txn->error.precond = DAV_NEED_PRIVS;
+        txn->error.resource = txn->req_tgt.path;
+        txn->error.rights = DACL_WRITECONT;
+        ret = HTTP_NO_PRIVS;
+        goto done;
     }
 
-    if (ret) goto done;
-
-    /* Process each patch sub-component */
-    for (patch = icalcomponent_get_first_component(vpatch, ICAL_ANY_COMPONENT);
-         patch;
-         patch = icalcomponent_get_next_component(vpatch, ICAL_ANY_COMPONENT)) {
+    if (cdata->dav.imap_uid &&
+        (!is_owner || read_only || cdata->comp_flags.shared)) {
+        syslog(LOG_NOTICE, "LOADING ICAL %u", cdata->dav.imap_uid);
 
-        if (icalcomponent_isa(patch) != ICAL_XPATCH_COMPONENT) {
-            /* Unknown patch action */
-            txn->error.precond = CALDAV_SUPP_COMP;
-            ret = HTTP_BAD_REQUEST;
+        /* Load message containing the existing resource and parse iCal data */
+        oldical = caldav_record_to_ical(mailbox, cdata, NULL, NULL);
+        if (!oldical) {
+            txn->error.desc = "Failed to read record";
+            ret = HTTP_SERVER_ERROR;
             goto done;
         }
+    }
 
-        prop = icalcomponent_get_first_property(patch,
-                                                ICAL_PATCHTARGET_PROPERTY);
-        if (!prop) {
-            txn->error.desc = "Missing TARGET";
-            txn->error.precond = CALDAV_VALID_DATA;
-            ret = HTTP_BAD_REQUEST;
-            goto done;
-        }
+    if (cdata->dav.imap_uid && !is_owner && !cdata->comp_flags.shared) {
+        /* Split owner's personal data from resource */
 
-        /* Parse PATCH-TARGET */
-        char *path = xstrdup(icalproperty_get_patchtarget(prop));
-        struct path_segment_t *target = NULL, *next;
-        struct patch_data_t patch_data = { patch, NULL, NULL };
-
-        icalcomponent_remove_property(patch, prop);
-        icalproperty_free(prop);
-
-        ret = parse_target_path(path, &target,
-                                ACTION_UPDATE, &patch_data, &txn->error);
-        free(path);
-        if (!ret) {
-            if (!target || target->type != SEGMENT_COMP ||
-                target->kind != ICAL_VCALENDAR_COMPONENT ||
-                target->match.comp.uid) {
-                txn->error.desc = "Initial segment of PATCH-TARGET"
-                    " MUST be an unmatched VCALENDAR";
-                ret = HTTP_BAD_REQUEST;
-            }
-        }
+        /* Create UID for owner VPATCH */
+        assert(!buf_len(&txn->buf));
+        buf_printf(&txn->buf, "%x-%x-%x", strhash(mailbox->name),
+                   strhash(resource), strhash(owner));
 
-        if (!ret) {
-            /* Parse and remove all PATCH-DELETEs and PATCH-PARAMETERs */
-            icalproperty *nextprop;
-            for (prop =
-                     icalcomponent_get_first_property(patch, ICAL_ANY_PROPERTY);
-                 !ret && prop; prop = nextprop) {
-
-                icalproperty_kind kind = icalproperty_isa(prop);
-                struct path_segment_t *ppath = NULL;
+        *userdata =
+            icalcomponent_vanew(ICAL_VPATCH_COMPONENT,
+                                icalproperty_new_version("1"),
+                                icalproperty_new_dtstamp(
+                                    icaltime_from_timet_with_zone(time(0),
+                                                                  0,
+                                                                  utc_zone)),
+                                icalproperty_new_uid(buf_cstring(&txn->buf)),
+                                0);
+        buf_reset(&txn->buf);
 
-                nextprop =
-                    icalcomponent_get_next_property(patch, ICAL_ANY_PROPERTY);
+        /* Extract personal info from owner's resource and create vpatch */
+        ret = extract_personal_data(oldical, NULL, *userdata,
+                                    &txn->buf /* path */, 0 /* read_only */,
+                                    &num_changes);
+        buf_reset(&txn->buf);
 
-                if (kind == ICAL_PATCHDELETE_PROPERTY) {
-                    path = xstrdup(icalproperty_get_patchdelete(prop));
+        if (!ret) ret = write_personal_data(owner, mailbox, cdata->dav.imap_uid,
+                                            cdata->dav.modseq, *userdata);
 
-                    icalcomponent_remove_property(patch, prop);
-                    icalproperty_free(prop);
+        if (ret) goto done;
 
-                    ret = parse_target_path(path, &ppath,
-                                            ACTION_DELETE, NULL, &txn->error);
-                    free(path);
-                    if (!ret) {
-                        if (!ppath ||
-                            (ppath->type == SEGMENT_COMP &&
-                             ppath->kind == ICAL_VCALENDAR_COMPONENT)) {
-                            txn->error.desc = "Initial segment of PATCH-DELETE"
-                                " MUST NOT be VCALENDAR";
-                            ret = HTTP_BAD_REQUEST;
-                        }
-                        else {
-                            /* Add this delete path to our list */
-                            ppath->sibling = patch_data.delete;
-                            patch_data.delete = ppath;
-                        }
-                    }
-                }
-                else if (kind == ICAL_PATCHPARAMETER_PROPERTY) {
-                    path = xstrdup(icalproperty_get_patchparameter(prop));
+        if (read_only) {
+            /* Resource to store is the existing resource just stripped */
+            *store_me = oldical;
+        }
 
-                    icalcomponent_remove_property(patch, prop);
+        icalcomponent_free(*userdata);
+        *userdata = NULL;
+    }
 
-                    ret = parse_target_path(path, &ppath,
-                                            ACTION_SETPARAM, prop, &txn->error);
-                    free(path);
-                    if (!ret) {
-                        if (!ppath || ppath->type != SEGMENT_PROP) {
-                            txn->error.desc =
-                                "Initial segment of PATCH-PARAMETER"
-                                " MUST be a property";
-                            ret = HTTP_BAD_REQUEST;
-                        }
-                        else {
-                            /* Add this setparam path to our list */
-                            ppath->sibling = patch_data.setparam;
-                            patch_data.setparam = ppath;
-                        }
-                    }
-                }
-            }
+    if (!is_owner || read_only ||
+        (cdata->dav.imap_uid && cdata->comp_flags.shared)) {
+        /* Extract personal info from user's resource and create vpatch */
+        if (oldical) {
+            /* Normalize existing resource for comparison */
+            icalcomponent_normalize(oldical);
+
+            /* Normalize new resource for comparison */
+            icalcomponent_normalize(ical);
         }
 
-        /* Apply this patch to the target component */
-        if (!ret) apply_patch(target, ical, &num_changes);
+        /* Create UID for sharee VPATCH */
+        assert(!buf_len(&txn->buf));
+        buf_printf(&txn->buf, "%x-%x-%x", strhash(mailbox->name),
+                   strhash(resource), strhash(userid));
 
-        /* Cleanup target paths */
-        path_segment_free(target);
-        for (target = patch_data.delete; target; target = next) {
-            next = target->sibling;
-            if (target->data) free(target->data);
-            path_segment_free(target);
-        }
-        for (target = patch_data.setparam; target; target = next) {
-            next = target->sibling;
-            if (target->data) icalproperty_free(target->data);
-            path_segment_free(target);
-        }
+        *userdata =
+            icalcomponent_vanew(ICAL_VPATCH_COMPONENT,
+                                icalproperty_new_version("1"),
+                                icalproperty_new_dtstamp(
+                                    icaltime_from_timet_with_zone(time(0),
+                                                                  0,
+                                                                  utc_zone)),
+                                icalproperty_new_uid(buf_cstring(&txn->buf)),
+                                0);
+        buf_reset(&txn->buf);
+
+        /* Extract personal info from new resource and add to vpatch */
+        /* XXX  DO NOT reinitialize num_changes.  We need the changes
+           from rewriting owner resource to force storage of that resource */
+        ret = extract_personal_data(ical, oldical, *userdata,
+                                    &txn->buf /* path */, read_only,
+                                    &num_changes);
+        buf_reset(&txn->buf);
 
         if (ret) goto done;
-    }
 
-  done:
-    icalcomponent_free(pdoc);
+        if (cdata->dav.imap_uid && !num_changes) {
+            /* No resource to store (per-user data change only) */
+            ret = HTTP_NO_CONTENT;
+            *store_me = NULL;
+            goto done;
+        }
 
-    if (ret) return ret;
+        cdata->comp_flags.shared = 1;
+    }
 
-    /* If no changes are made,
-       return HTTP_NO_CONTENT to suppress storing of resource */
-    return (!num_changes ? HTTP_NO_CONTENT : 0);
-}
-#else
-static int caldav_patch(struct transaction_t *txn __attribute__((unused)),
-                        void *obj __attribute__((unused)))
+  done:
+    if (oldical && (*store_me != oldical)) icalcomponent_free(oldical);
+    mbname_free(&mbname);
+    free(resource);
 
-{
-    fatal("caldav_patch() called, but no VPATCH", EC_SOFTWARE);
+    return ret;
 }
-#endif /* HAVE_VPATCH */
 
 
 /* Perform a PUT request
@@ -3937,20 +4205,22 @@ static int caldav_put(struct transaction
     icalcomponent *oldical = NULL;
     icalcomponent *comp, *nextcomp;
     icalcomponent_kind kind;
+    icaltimetype dtstart, dtend;
     icalproperty *prop, *rrule = NULL;
     const char *uid, *organizer = NULL;
-    char *schedule_address = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
     struct buf buf = BUF_INITIALIZER;
     struct caldav_data *cdata;
 
     /* Validate the iCal data */
     if (!ical || (icalcomponent_isa(ical) != ICAL_VCALENDAR_COMPONENT)) {
+        txn->error.desc = "Resource is not an iCalendar object";
         txn->error.precond = CALDAV_VALID_DATA;
         ret = HTTP_FORBIDDEN;
         goto done;
     }
 
-    icalrestriction_check(ical);
+    cyrus_icalrestriction_check(ical);
     if ((txn->error.desc = get_icalcomponent_errstr(ical))) {
         buf_setcstr(&txn->buf, txn->error.desc);
         txn->error.desc = buf_cstring(&txn->buf);
@@ -3969,17 +4239,35 @@ static int caldav_put(struct transaction
     kind = icalcomponent_isa(comp);
     uid = icalcomponent_get_uid(comp);
     if (!uid) {
+        txn->error.desc = "Missing UID property";
         txn->error.precond = CALDAV_VALID_OBJECT;
         ret = HTTP_FORBIDDEN;
         goto done;
     }
     prop = icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
     if (prop) organizer = icalproperty_get_organizer(prop);
+
+    /* Also make sure DTEND > DTSTART, and both values have value same type */
+    dtend = icalcomponent_get_dtend(comp);
+    if (!icaltime_is_null_time(dtend)) {
+        dtstart = icalcomponent_get_dtstart(comp);
+
+        if (icaltime_is_date(dtend) != icaltime_is_date(dtstart) ||
+//            !icaltime_get_timezone(dtend) != !icaltime_get_timezone(dtstart) ||
+            icaltime_compare(dtend, dtstart) < 0) {
+            txn->error.desc = "DTEND occurs before DTSTART";
+            txn->error.precond = CALDAV_VALID_DATA;
+            ret = HTTP_FORBIDDEN;
+            goto done;
+        }
+    }
+
     while ((nextcomp =
             icalcomponent_get_next_component(ical, kind))) {
         const char *nextuid = icalcomponent_get_uid(nextcomp);
 
         if (!nextuid || strcmp(uid, nextuid)) {
+            txn->error.desc = "Mismatched UIDs";
             txn->error.precond = CALDAV_VALID_OBJECT;
             ret = HTTP_FORBIDDEN;
             goto done;
@@ -3998,6 +4286,18 @@ static int caldav_put(struct transaction
             goto done;
         }
 
+        dtend = icalcomponent_get_dtend(nextcomp);
+        if (!icaltime_is_null_time(dtend)) {
+            dtstart = icalcomponent_get_dtstart(nextcomp);
+
+            if (icaltime_compare(dtend, dtstart) < 0) {
+                txn->error.desc = "DTEND occurs before DTSTART";
+                txn->error.precond = CALDAV_VALID_OBJECT;
+                ret = HTTP_FORBIDDEN;
+                goto done;
+            }
+        }
+
         if (rscale_calendars && !rrule) {
             /* Grab RRULE to check RSCALE */
             rrule = icalcomponent_get_first_property(nextcomp,
@@ -4038,6 +4338,8 @@ static int caldav_put(struct transaction
     /* Check for changed UID */
     caldav_lookup_resource(db, mailbox->name, resource, &cdata, 0);
     if (cdata->dav.imap_uid && strcmpsafe(cdata->ical_uid, uid)) {
+        /* CALDAV:no-uid-conflict */
+        txn->error.precond = CALDAV_UID_CONFLICT;
         ret = HTTP_FORBIDDEN;
     }
     else {
@@ -4045,14 +4347,14 @@ static int caldav_put(struct transaction
         caldav_lookup_uid(db, uid, &cdata);
         if (cdata->dav.imap_uid && (strcmp(cdata->dav.mailbox, mailbox->name) ||
                                     strcmp(cdata->dav.resource, resource))) {
+            /* CALDAV:unique-scheduling-object-resource */
+            txn->error.precond = CALDAV_UNIQUE_OBJECT;
             ret = HTTP_FORBIDDEN;
         }
     }
     if (ret) {
-        /* CALDAV:no-uid-conflict */
         char *owner = mboxname_to_userid(cdata->dav.mailbox);
 
-        txn->error.precond = CALDAV_UID_CONFLICT;
         buf_reset(&txn->buf);
         buf_printf(&txn->buf, "%s/%s/%s/%s/%s",
                    namespace_calendar.prefix, USER_COLLECTION_PREFIX, owner,
@@ -4065,7 +4367,7 @@ static int caldav_put(struct transaction
 
     if (namespace_calendar.allow & ALLOW_CAL_ATTACH) {
         ret = manage_attachments(txn, mailbox, ical,
-                                 cdata, &oldical, &schedule_address);
+                                 cdata, &oldical, &schedule_addresses);
         if (ret) goto done;
     }
 
@@ -4075,15 +4377,13 @@ static int caldav_put(struct transaction
     case ICAL_VPOLL_COMPONENT:
         if (organizer) {
             /* Scheduling object resource */
-            strarray_t schedule_addresses = STRARRAY_INITIALIZER;
-            int r;
 
-            syslog(LOG_DEBUG,
-                   "caldav_put: organizer: %s", organizer);
+            syslog(LOG_DEBUG, "caldav_put: organizer: %s", organizer);
 
             if (!strncasecmp(organizer, "mailto:", 7)) organizer += 7;
 
-            if (cdata->organizer && !spool_getheader(txn->req_hdrs, "Allow-Organizer-Change")) {
+            if (cdata->organizer &&
+                !spool_getheader(txn->req_hdrs, "Allow-Organizer-Change")) {
                 /* Don't allow ORGANIZER to be changed */
                 if (strcmp(cdata->organizer, organizer)) {
                     txn->error.desc = "Can not change organizer address";
@@ -4094,38 +4394,31 @@ static int caldav_put(struct transaction
             /* existing record? */
             if (cdata->dav.imap_uid && !oldical) {
                 /* Update existing object */
-                struct index_record record;
-
                 syslog(LOG_NOTICE, "LOADING ICAL %u", cdata->dav.imap_uid);
 
                 /* Load message containing the resource and parse iCal data */
-                r = mailbox_find_index_record(mailbox,
-                                              cdata->dav.imap_uid, &record);
-                if (r) {
-                    txn->error.desc = "Failed to read record \r\n";
+                oldical = caldav_record_to_ical(mailbox, cdata,
+                                                NULL, NULL);
+                if (!oldical) {
+                    txn->error.desc = "Failed to read record";
                     ret = HTTP_SERVER_ERROR;
                     goto done;
                 }
-
-                oldical = record_to_ical(mailbox, &record, &schedule_address);
             }
 
-            if (schedule_address) {
-                strarray_appendm(&schedule_addresses, schedule_address);
-                schedule_address = NULL;
-            }
             get_schedule_addresses(txn, &schedule_addresses);
 
-            char *userid = mboxname_to_userid(txn->req_tgt.mbentry->name);
+            char *userid = (txn->req_tgt.flags == TGT_DAV_SHARED) ?
+                xstrdup(txn->req_tgt.userid) :
+                mboxname_to_userid(txn->req_tgt.mbentry->name);
             if (strarray_find_case(&schedule_addresses, organizer, 0) >= 0) {
                 /* Organizer scheduling object resource */
                 if (ret) {
                     txn->error.precond = CALDAV_ALLOWED_ORG_CHANGE;
                 }
                 else {
-                    schedule_address = xstrdupnull(organizer);
                     if (_scheduling_enabled(txn, mailbox))
-                        sched_request(userid, schedule_address, oldical, ical);
+                        sched_request(userid, &schedule_addresses, organizer, oldical, ical);
                 }
             }
             else {
@@ -4142,13 +4435,11 @@ static int caldav_put(struct transaction
                 }
 #endif
                 else {
-                    schedule_address = xstrdupnull(strarray_nth(&schedule_addresses, 0));
-                    if (_scheduling_enabled(txn, mailbox) && schedule_address)
-                        sched_reply(userid, schedule_address, oldical, ical);
+                    if (_scheduling_enabled(txn, mailbox) && strarray_size(&schedule_addresses))
+                        sched_reply(userid, &schedule_addresses, oldical, ical);
                 }
             }
             free(userid);
-            strarray_fini(&schedule_addresses);
 
             if (ret) goto done;
 
@@ -4170,13 +4461,13 @@ static int caldav_put(struct transaction
 
     /* Store resource at target */
     if (!ret) {
-        ret = caldav_store_resource(txn, ical, mailbox,
-                                    resource, db, flags, schedule_address);
+        ret = caldav_store_resource(txn, ical, mailbox, resource, cdata->dav.createdmodseq,
+                                    db, flags, httpd_userid, &schedule_addresses);
     }
 
   done:
     if (oldical) icalcomponent_free(oldical);
-    free(schedule_address);
+    strarray_fini(&schedule_addresses);
     buf_free(&buf);
 
     return ret;
@@ -4199,13 +4490,14 @@ struct comp_filter {
 struct calquery_filter {
     unsigned flags;             /* mask of flags controlling filter */
     unsigned comp_types;        /* mask of "real" component types in filter */
-    icaltimezone *tz;
+    icaltimezone *tz;           /* time zone to use for floating time */
     struct comp_filter *comp;
 };
 
 /* Bitmask of calquery flags */
 enum {
-    PARSE_ICAL = (1<<0)
+    PARSE_ICAL = (1<<0),
+    NEED_TZ    = (1<<1),
 };
 
 static int is_valid_timerange(const struct icaltimetype start,
@@ -4335,7 +4627,7 @@ static void parse_compfilter(xmlNodePtr
             case 0:
                 /* VCALENDAR */
                 if (kind != ICAL_VCALENDAR_COMPONENT) {
-                    /* All other components MUST be a decendent of VCALENDAR */
+                    /* All other components MUST be a descendent of VCALENDAR */
                     error->precond = CALDAV_VALID_FILTER;
                     error->desc = "VCALENDAR must be toplevel component";
                 }
@@ -4440,6 +4732,7 @@ static void parse_compfilter(xmlNodePtr
                 case ICAL_VAVAILABILITY_COMPONENT:
                 case ICAL_VPOLL_COMPONENT:
                     parse_timerange(node, &(*comp)->range, error);
+                    *flags |= NEED_TZ;
                     break;
 
                 default:
@@ -4469,6 +4762,10 @@ static void parse_compfilter(xmlNodePtr
                         error->node = xmlCopyNode(node, 1);
                     }
                 }
+                else if (prop->other) {
+                    /* CALDAV:time-range */
+                    *flags |= NEED_TZ;
+                }
             }
         }
         else if (!xmlStrcmp(node->name, BAD_CAST "comp-filter")) {
@@ -4547,7 +4844,8 @@ static int apply_paramfilter(struct para
     return pass;
 }
 
-static int apply_prop_timerange(struct icalperiodtype *range, icalproperty *prop)
+static int apply_prop_timerange(struct icalperiodtype *range,
+                                icaltimezone *floating_tz, icalproperty *prop)
 {
     icalvalue *value = icalproperty_get_value(prop);
     struct icalperiodtype period = icalperiodtype_null_period();
@@ -4596,8 +4894,8 @@ static int apply_prop_timerange(struct i
     else if (icaltime_is_null_time(period.end)) period.end = period.start;
 
     /* Convert to UTC for comparison with range */
-    period.start = icaltime_convert_to_zone(period.start, utc_zone);
-    period.end = icaltime_convert_to_zone(period.end, utc_zone);
+    period.start = icaltime_convert_to_utc(period.start, floating_tz);
+    period.end = icaltime_convert_to_utc(period.end, floating_tz);
 
     if (icaltime_compare(period.start, range->end) >= 0 ||
         icaltime_compare(period.end, range->start) <= 0) {
@@ -4608,7 +4906,8 @@ static int apply_prop_timerange(struct i
     return 1;
 }
 
-static int apply_propfilter(struct prop_filter *propfilter, icalcomponent *comp)
+static int apply_propfilter(struct prop_filter *propfilter,
+                            icaltimezone *floating_tz, icalcomponent *comp)
 {
     int pass = 1;
     icalproperty *prop =
@@ -4639,7 +4938,7 @@ static int apply_propfilter(struct prop_
         pass = propfilter->allof;
 
         if (propfilter->other) {
-            pass = apply_prop_timerange(propfilter->other, prop);
+            pass = apply_prop_timerange(propfilter->other, floating_tz, prop);
         }
         else if (propfilter->match) {
             const char *text = icalproperty_get_value_as_string(prop);
@@ -4671,6 +4970,7 @@ static void in_range(icalcomponent *comp
 }
 
 static int apply_comp_timerange(struct comp_filter *compfilter,
+                                icaltimezone *floating_tz,
                                 icalcomponent *comp, struct caldav_data *cdata,
                                 struct propfind_ctx *fctx)
 {
@@ -4681,8 +4981,10 @@ static int apply_comp_timerange(struct c
 
     if (compfilter->depth == 1) {
         /* Use period from cdata */
-        dtstart = icaltime_from_string(cdata->dtstart);
-        dtend = icaltime_from_string(cdata->dtend);
+        dtstart = icaltime_convert_to_utc(icaltime_from_string(cdata->dtstart),
+                                          floating_tz);
+        dtend = icaltime_convert_to_utc(icaltime_from_string(cdata->dtend),
+                                        floating_tz);
 
         if (icaltime_compare(dtstart, range->end) >= 0 ||
             icaltime_compare(dtend, range->start) <= 0) {
@@ -4736,7 +5038,8 @@ static int apply_comp_timerange(struct c
 /* See if the current resource matches the specified filter.
  * Returns 1 if match, 0 otherwise.
  */
-static int apply_compfilter(struct comp_filter *compfilter, icalcomponent *ical,
+static int apply_compfilter(struct comp_filter *compfilter,
+                            icaltimezone *floating_tz, icalcomponent *ical,
                             struct caldav_data *cdata, struct propfind_ctx *fctx)
 {
     int pass = 0;
@@ -4765,7 +5068,7 @@ static int apply_compfilter(struct comp_
         pass = compfilter->allof;
 
         if (compfilter->range) {
-            pass = apply_comp_timerange(compfilter, comp, cdata, fctx);
+            pass = apply_comp_timerange(compfilter, floating_tz, comp, cdata, fctx);
         }
 
         /* Apply each prop-filter, breaking if allof fails or anyof succeeds */
@@ -4773,7 +5076,7 @@ static int apply_compfilter(struct comp_
              propfilter && (pass == compfilter->allof);
              propfilter = propfilter->next) {
 
-            pass = apply_propfilter(propfilter, comp);
+            pass = apply_propfilter(propfilter, floating_tz, comp);
         }
 
         /* Apply each comp-filter, breaking if allof fails or anyof succeeds */
@@ -4781,7 +5084,7 @@ static int apply_compfilter(struct comp_
              subfilter && (pass == compfilter->allof);
              subfilter = subfilter->next) {
 
-            pass = apply_compfilter(subfilter, comp, cdata, fctx);
+            pass = apply_compfilter(subfilter, floating_tz, comp, cdata, fctx);
         }
 
     } while (!pass &&
@@ -4825,7 +5128,7 @@ static int apply_calfilter(struct propfi
         if (!ical) return 0;
     }
 
-    return apply_compfilter(calfilter->comp, ical, cdata, fctx);
+    return apply_compfilter(calfilter->comp, calfilter->tz, ical, cdata, fctx);
 }
 
 
@@ -4895,16 +5198,16 @@ static int caldav_propfind_by_resource(v
         }
 
         if (fctx->record) {
-            char *schedule_address = NULL;
+            strarray_t schedule_addresses = STRARRAY_INITIALIZER;
             icalcomponent *ical =
-                record_to_ical(fctx->mailbox, fctx->record, &schedule_address);
+                record_to_ical(fctx->mailbox, fctx->record, &schedule_addresses);
             struct transaction_t txn;
 
             if (!ical) {
                 syslog(LOG_NOTICE,
                        "Unable to parse iCal %s:%u prior to stripping TZ",
                        fctx->mailbox->name, fctx->record->uid);
-                free(schedule_address);
+                strarray_fini(&schedule_addresses);
                 goto done;
             }
 
@@ -4912,12 +5215,13 @@ static int caldav_propfind_by_resource(v
             txn.req_hdrs = spool_new_hdrcache();
 
             caldav_store_resource(&txn, ical, fctx->mailbox,
-                                  cdata->dav.resource, fctx->davdb,
+                                  cdata->dav.resource, cdata->dav.createdmodseq,
+                                  fctx->davdb,
                                   TZ_STRIP | (!cdata->sched_tag ? NEW_STAG : 0),
-                                  schedule_address);
+                                  NULL, &schedule_addresses);
             spool_free_hdrcache(txn.req_hdrs);
             buf_free(&txn.buf);
-            free(schedule_address);
+            strarray_fini(&schedule_addresses);
 
             icalcomponent_free(ical);
 
@@ -4973,6 +5277,18 @@ static int propfind_restype(const xmlCha
                             struct propstat propstat[],
                             void *rock)
 {
+    if (!propstat) {
+        /* Prescreen "property" request */
+        if (fctx->req_tgt->collection ||
+            (fctx->req_tgt->userid && fctx->depth >= 1) || fctx->depth >= 2) {
+            /* Add namespaces for possible resource types */
+            ensure_ns(fctx->ns, NS_CALDAV, fctx->root, XML_NS_CALDAV, "C");
+            ensure_ns(fctx->ns, NS_CS, fctx->root, XML_NS_CS, "CS");
+        }
+
+        return 0;
+    }
+
     xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
                                    &propstat[PROPSTAT_OK], name, ns, NULL, 0);
 
@@ -5185,7 +5501,7 @@ static int expand_cb(icalcomponent *comp
 
     if (!recurid) {
         /* Clone the master component */
-        comp = icalcomponent_new_clone(comp);
+        comp = icalcomponent_clone(comp);
         if (icaltime_compare(start, dtstart)) {
             /* Not the first instance - set RECURRENCE-ID */
             icalcomponent_set_recurrenceid(comp, start);
@@ -5213,7 +5529,7 @@ static icalcomponent *expand_caldata(ica
     icalproperty *prop =
         icalcomponent_get_first_property(*ical, ICAL_CALSCALE_PROPERTY);
     if (prop)
-        icalcomponent_add_property(expanded_ical, icalproperty_new_clone(prop));
+        icalcomponent_add_property(expanded_ical, icalproperty_clone(prop));
 
     icalcomponent_myforeach(*ical, range, NULL, expand_cb, expanded_ical);
     icalcomponent_free(*ical);
@@ -5304,11 +5620,16 @@ static int propfind_scheduser(const xmlC
         rc = 0;
         xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
                                        name, ns, NULL, 0);
-        buf_reset(&fctx->buf);
-        const char *address = buf_cstring(&buf);
-        if (!strncasecmp(address, "mailto:", 7)) address += 7;
-        buf_printf(&fctx->buf, "mailto:%s", address);
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+        strarray_t *schedule_addresses = strarray_split(buf_cstring(&buf), ",", STRARRAY_TRIM);
+        int i;
+        for (i = strarray_size(schedule_addresses); i; i--) {
+            const char *address = strarray_nth(schedule_addresses, i-1);
+            if (!strncasecmp(address, "mailto:", 7)) address += 7;
+            buf_reset(&fctx->buf);
+            buf_printf(&fctx->buf, "mailto:%s", address);
+            xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+        }
+        strarray_free(schedule_addresses);
     }
 
     buf_free(&buf);
@@ -5322,80 +5643,35 @@ static int propfind_caldata(const xmlCha
                             xmlNodePtr prop,
                             xmlNodePtr resp __attribute__((unused)),
                             struct propstat propstat[],
-                            void *rock)
+                            void *rock __attribute__((unused)))
 {
-    struct partial_caldata_t *partial = (struct partial_caldata_t *) rock;
-    struct caldav_data *cdata = (struct caldav_data *) fctx->data;
+    static struct mime_type_t *out_type = caldav_mime_types;
+    static struct partial_caldata_t partial_caldata = { .comp = NULL };
+    struct partial_caldata_t *partial = &partial_caldata;
     static unsigned need_tz = 0;
     const char *data = NULL;
     size_t datalen = 0;
-    int r = 0;
-
-    if (propstat) {
-        icalcomponent *ical = NULL;
-
-        if (!fctx->record) return HTTP_NOT_FOUND;
-
-        if (!fctx->msg_buf.len)
-            mailbox_map_record(fctx->mailbox, fctx->record, &fctx->msg_buf);
-        if (!fctx->msg_buf.len) return HTTP_SERVER_ERROR;
-
-        data = fctx->msg_buf.s + fctx->record->header_size;
-        datalen = fctx->record->size - fctx->record->header_size;
-
-        if (need_tz) {
-            if (cdata->comp_flags.tzbyref) {
-                /* Add VTIMEZONE components for known TZIDs */
-                struct timezone_rock tzrock = { NULL, NULL };
-                icalcomponent *comp, *next;
-                icalcomponent_kind kind;
 
-                if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
-                ical = fctx->obj;
-                tzrock.new = ical;
-
-                comp = icalcomponent_get_first_real_component(ical);
-                kind = icalcomponent_isa(comp);
-                for (; comp; comp = next) {
-                    next = icalcomponent_get_next_component(ical, kind);
-                    icalcomponent_foreach_tzid(comp, &add_timezone, &tzrock);
-                }
-            }
-        }
-        else if (!cdata->comp_flags.tzbyref &&
-                 (namespace_calendar.allow & ALLOW_CAL_NOTZ)) {
-            /* Strip all VTIMEZONE components for known TZIDs */
-            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
-            ical = fctx->obj;
-
-            strip_vtimezones(ical);
-        }
+    if (!fctx) {
+        /* Cleanup "property" request - free partial component structure */
+        struct partial_comp_t *pcomp, *child, *sibling;
 
-        if (!icaltime_is_null_time(partial->range.start)) {
-            /* Expand/limit recurrence set */
-            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
-            ical = fctx->obj;
+        for (pcomp = partial->comp; pcomp; pcomp = child) {
+            child = pcomp->child;
 
-            if (partial->expand) {
-                fctx->obj = expand_caldata(&ical, partial->range);
-            }
-            else limit_caldata(ical, &partial->range);
+            do {
+                sibling = pcomp->sibling;
+                arrayu64_fini(&pcomp->props);
+                free(pcomp);
+            } while ((pcomp = sibling));
         }
 
-        if (partial->comp) {
-            /* Limit returned properties */
-            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
-            ical = fctx->obj;
-            prune_properties(ical, partial->comp);
-        }
+        partial->comp = NULL;
 
-        if (ical) {
-            /* Create iCalendar data from new ical component */
-            data = icalcomponent_as_ical_string(ical);
-            datalen = strlen(data);
-        }
+        return 0;
     }
-    else if (prop) {
+
+    if (!propstat) {
         /* Prescreen "property" request - read partial/expand children */
         xmlNodePtr node;
 
@@ -5448,26 +5724,80 @@ static int propfind_caldata(const xmlCha
         }
     }
     else {
-        /* Cleanup "property" request - free partial component structure */
-        struct partial_comp_t *pcomp, *child, *sibling;
+        struct caldav_data *cdata = (struct caldav_data *) fctx->data;
+        icalcomponent *ical = NULL;
 
-        for (pcomp = partial->comp; pcomp; pcomp = child) {
-            child = pcomp->child;
+        if (fctx->txn->meth != METH_REPORT) return HTTP_FORBIDDEN;
 
-            do {
-                sibling = pcomp->sibling;
-                arrayu64_fini(&pcomp->props);
-                free(pcomp);
-            } while ((pcomp = sibling));
+        if (!out_type->content_type) return HTTP_BAD_MEDIATYPE;
+
+        if (!fctx->record) return HTTP_NOT_FOUND;
+
+        if (!fctx->msg_buf.len)
+            mailbox_map_record(fctx->mailbox, fctx->record, &fctx->msg_buf);
+        if (!fctx->msg_buf.len) return HTTP_SERVER_ERROR;
+
+        data = fctx->msg_buf.s + fctx->record->header_size;
+        datalen = fctx->record->size - fctx->record->header_size;
+
+        if (cdata->comp_flags.tzbyref) {
+            if (need_tz) {
+                /* Add VTIMEZONE components for known TZIDs */
+                if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
+                ical = fctx->obj;
+
+                icalcomponent_add_required_timezones(ical);
+            }
         }
+        else if (!need_tz && (namespace_calendar.allow & ALLOW_CAL_NOTZ)) {
+            /* Strip all VTIMEZONE components for known TZIDs */
+            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
+            ical = fctx->obj;
 
-        return 0;
-    }
+            strip_vtimezones(ical);
+        }
 
-    r = propfind_getdata(name, ns, fctx, prop, propstat, caldav_mime_types,
-                         CALDAV_SUPP_DATA, data, datalen);
+        /* Personalize resource, if necessary */
+        if (namespace_calendar.allow & ALLOW_USERDATA) {
+            struct buf userdata = BUF_INITIALIZER;
 
-    return r;
+            if (caldav_is_personalized(fctx->mailbox, fctx->data,
+                                       httpd_userid, &userdata)) {
+                if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
+                ical = fctx->obj;
+
+                add_personal_data(ical, &userdata);
+                buf_free(&userdata);
+            }
+        }
+
+        if (!icaltime_is_null_time(partial->range.start)) {
+            /* Expand/limit recurrence set */
+            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
+            ical = fctx->obj;
+
+            if (partial->expand) {
+                fctx->obj = expand_caldata(&ical, partial->range);
+            }
+            else limit_caldata(ical, &partial->range);
+        }
+
+        if (partial->comp) {
+            /* Limit returned properties */
+            if (!fctx->obj) fctx->obj = icalparser_parse_string(data);
+            ical = fctx->obj;
+            prune_properties(ical, partial->comp);
+        }
+
+        if (ical) {
+            /* Create iCalendar data from new ical component */
+            data = icalcomponent_as_ical_string(ical);
+            datalen = strlen(data);
+        }
+    }
+
+    return propfind_getdata(name, ns, fctx, prop, propstat, caldav_mime_types,
+                            &out_type, data, datalen);
 }
 
 
@@ -5593,8 +5923,10 @@ static int propfind_calcompset(const xml
     else {
         types = -1;  /* ALL components types */
 
+#ifndef IOPTEST  /* CalConnect ioptest */
         /* Apple clients don't like VPOLL */
         types &= ~CAL_COMP_VPOLL;
+#endif
     }
 
     buf_free(&attrib);
@@ -5795,58 +6127,209 @@ static int propfind_schedtag(const xmlCh
     return 0;
 }
 
-
-/* Callback to fetch CALDAV:calendar-user-address-set */
-int propfind_caluseraddr(const xmlChar *name, xmlNsPtr ns,
+static int propfind_caluseraddr_all(const xmlChar *name, xmlNsPtr ns,
                          struct propfind_ctx *fctx,
                          xmlNodePtr prop __attribute__((unused)),
                          xmlNodePtr resp __attribute__((unused)),
                          struct propstat propstat[],
-                         void *rock __attribute__((unused)))
+                         void *rock __attribute__((unused)),
+                         int isemail)
 {
+    const char *annotname =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
     xmlNodePtr node;
-    struct strlist *domains;
+    int r, ret = HTTP_NOT_FOUND;
 
     if (!(namespace_calendar.enabled && fctx->req_tgt->userid))
         return HTTP_NOT_FOUND;
 
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                        name, ns, NULL, 0);
+    if (fctx->req_tgt->namespace->id == URL_NS_PRINCIPAL) {
+        char *mailboxname = caldav_mboxname(fctx->req_tgt->userid, NULL);
 
-    const char *annotname =
-        DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
-    char *mailboxname = caldav_mboxname(fctx->req_tgt->userid, NULL);
-    buf_reset(&fctx->buf);
-    int r = annotatemore_lookupmask(mailboxname, annotname,
+        node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                            name, ns, NULL, 0);
+
+        buf_reset(&fctx->buf);
+        r = annotatemore_lookupmask(mailboxname, annotname,
                                     fctx->req_tgt->userid, &fctx->buf);
-    free(mailboxname);
-    if (!r && fctx->buf.len) {
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
-        return 0;
-    }
+        free(mailboxname);
+        if (!r && fctx->buf.len) {
+            strarray_t *items = strarray_split(buf_cstring(&fctx->buf), ",", STRARRAY_TRIM);
+            if (isemail) {
+                xml_add_href(node, fctx->ns[NS_DAV], strarray_nth(items, 0));
+            }
+            else {
+                int i;
+                for (i = strarray_size(items); i; i--) {
+                    xmlNodePtr href = xml_add_href(node, fctx->ns[NS_DAV], strarray_nth(items, i-1));
+                    /* apple will use the alphabetically first href, and Thunderbird will use the
+                     * last one in order, so we set preferred for Apple, and put the preferred one
+                     * last for Thunderbird (and maybe others) */
+                    if (i == 1) xmlNewProp(href, BAD_CAST "preferred", BAD_CAST "1");
+                }
+                strarray_free(items);
+            }
+        }
+
+        /* XXX  This needs to be done via an LDAP/DB lookup */
+        else if (strchr(fctx->req_tgt->userid, '@')) {
+            buf_reset(&fctx->buf);
+            buf_printf(&fctx->buf, "mailto:%s", fctx->req_tgt->userid);
+            xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+        }
+
+        else if (httpd_extradomain) {
+            buf_reset(&fctx->buf);
+            buf_printf(&fctx->buf, "mailto:%s@%s",
+                       fctx->req_tgt->userid, httpd_extradomain);
+            xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+        }
+
+        else {
+            struct strlist *domains;
+            for (domains = cua_domains; domains; domains = domains->next) {
+                buf_reset(&fctx->buf);
+                buf_printf(&fctx->buf, "mailto:%s@%s",
+                           fctx->req_tgt->userid, domains->s);
+
+                xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+            }
+        }
 
-    /* XXX  This needs to be done via an LDAP/DB lookup */
-    if (strchr(fctx->req_tgt->userid, '@')) {
+        ret = 0;
+    }
+    else {
         buf_reset(&fctx->buf);
-        buf_printf(&fctx->buf, "mailto:%s", fctx->req_tgt->userid);
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
-        return 0;
+        r = annotatemore_lookupmask(fctx->mbentry->name, annotname,
+                                    fctx->req_tgt->userid, &fctx->buf);
+        if (!r && fctx->buf.len) {
+            strarray_t *addr =
+                strarray_split(buf_cstring(&fctx->buf), ",", STRARRAY_TRIM);
+
+            node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                                &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+            int i;
+            for (i = strarray_size(addr); i; i--) {
+                xml_add_href(node, fctx->ns[NS_DAV], strarray_nth(addr, i-1));
+            }
+            strarray_free(addr);
+            ret = 0;
+        }
     }
 
-    if (httpd_extradomain) {
-        buf_reset(&fctx->buf);
-        buf_printf(&fctx->buf, "mailto:%s@%s",
-                   fctx->req_tgt->userid, httpd_extradomain);
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
-        return 0;
+    return ret;
+}
+
+/* Callback to fetch CALDAV:calendar-user-address-set */
+EXPORTED int propfind_caluseraddr(const xmlChar *name, xmlNsPtr ns,
+                         struct propfind_ctx *fctx,
+                         xmlNodePtr prop,
+                         xmlNodePtr resp,
+                         struct propstat propstat[],
+                         void *rock)
+{
+    return propfind_caluseraddr_all(name, ns, fctx, prop, resp, propstat, rock, 0);
+}
+
+/* Callback to fetch APPLE:calendar-email-set */
+EXPORTED int propfind_caluseremail(const xmlChar *name, xmlNsPtr ns,
+                         struct propfind_ctx *fctx,
+                         xmlNodePtr prop,
+                         xmlNodePtr resp,
+                         struct propstat propstat[],
+                         void *rock)
+{
+    return propfind_caluseraddr_all(name, ns, fctx, prop, resp, propstat, rock, 1);
+}
+
+
+/* Callback to write CALDAV:calendar-user-address-set */
+int proppatch_caluseraddr(xmlNodePtr prop, unsigned set,
+                          struct proppatch_ctx *pctx,
+                          struct propstat propstat[],
+                          void *rock __attribute__((unused)))
+{
+    struct mailbox *mailbox = pctx->mailbox;
+    struct mailbox *calhomeset = NULL;
+
+    if (pctx->txn->req_tgt.namespace->id == URL_NS_PRINCIPAL) {
+        /* We have been storing CUAS on cal-home-set, NOT INBOX */
+        char *mboxname = caldav_mboxname(pctx->txn->req_tgt.userid, NULL);
+        int r = 0;
+
+        if (!mailbox || strcmp(mboxname, mailbox->name)) {
+            r = mailbox_open_iwl(mboxname, &calhomeset);
+            if (!r) pctx->mailbox = calhomeset;
+        }
+        free(mboxname);
+
+        if (r) {
+            xml_add_prop(HTTP_SERVER_ERROR, pctx->ns[NS_DAV],
+                         &propstat[PROPSTAT_ERROR],
+                         prop->name, prop->ns, NULL, 0);
+            *pctx->ret = HTTP_SERVER_ERROR;
+            return 0;
+        }
     }
 
-    for (domains = cua_domains; domains; domains = domains->next) {
-        buf_reset(&fctx->buf);
-        buf_printf(&fctx->buf, "mailto:%s@%s",
-                   fctx->req_tgt->userid, domains->s);
+    /* Make sure this is on a collection and the user has admin rights */
+    if (pctx->txn->req_tgt.resource ||
+        !(cyrus_acl_myrights(httpd_authstate, pctx->mailbox->acl) & DACL_ADMIN)) {
+        xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
+                     &propstat[PROPSTAT_FORBID],
+                     prop->name, prop->ns, NULL, 0);
 
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+        *pctx->ret = HTTP_FORBIDDEN;
+    }
+    else {
+        char *value = NULL;
+
+        if (set) {
+            xmlNodePtr node = xmlFirstElementChild(prop);
+
+            /* Find the value */
+            if (!node) {
+                /* single text value */
+                value = (char *) xmlNodeGetContent(prop);
+            }
+            else {
+                /* href(s) */
+                strarray_t addr = STRARRAY_INITIALIZER;
+
+                for (; node; node = xmlNextElementSibling(node)) {
+                    /* Make sure its a value we understand */
+                    if (!xmlStrcmp(node->name, BAD_CAST "href")) {
+                        /* because clients look for the last item, we put the default last,
+                         * but we want it first in the internal data structure because that
+                         * makes iterating to look for matches more sensible, so reverse it
+                         * right here! */
+                        strarray_unshiftm(&addr, (char *) xmlNodeGetContent(node));
+                    }
+                    else {
+                        /* Unknown value */
+                        xml_add_prop(HTTP_CONFLICT, pctx->ns[NS_DAV],
+                                     &propstat[PROPSTAT_CONFLICT],
+                                     prop->name, prop->ns, NULL, 0);
+
+                        strarray_fini(&addr);
+                        *pctx->ret = HTTP_FORBIDDEN;
+
+                        return 0;
+                    }
+                }
+
+                value = strarray_join(&addr, ",");
+                strarray_fini(&addr);
+            }
+        }
+
+        proppatch_todb(prop, set, pctx, propstat, (void *) value);
+        free(value);
+    }
+
+    if (calhomeset) {
+        mailbox_close(&calhomeset);
+        pctx->mailbox = mailbox;
     }
 
     return 0;
@@ -5871,38 +6354,6 @@ int propfind_calusertype(const xmlChar *
 }
 
 
-/* Callback to fetch CALDAV:schedule-calendar-transp */
-static int propfind_caltransp(const xmlChar *name, xmlNsPtr ns,
-                              struct propfind_ctx *fctx,
-                              xmlNodePtr prop __attribute__((unused)),
-                              xmlNodePtr resp __attribute__((unused)),
-                              struct propstat propstat[],
-                              void *rock __attribute__((unused)))
-{
-    struct buf attrib = BUF_INITIALIZER;
-    const char *prop_annot =
-        DAV_ANNOT_NS "<" XML_NS_CALDAV ">schedule-calendar-transp";
-    xmlNodePtr node;
-    int r = 0;
-
-    if (!fctx->req_tgt->collection) return HTTP_NOT_FOUND;
-
-    r = annotatemore_lookupmask(fctx->mailbox->name, prop_annot,
-                                httpd_userid, &attrib);
-
-    if (r) return HTTP_SERVER_ERROR;
-    if (!attrib.len) return HTTP_NOT_FOUND;
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                        name, ns, NULL, 0);
-    xmlNewChild(node, fctx->ns[NS_CALDAV], BAD_CAST buf_cstring(&attrib), NULL);
-
-    buf_free(&attrib);
-
-    return 0;
-}
-
-
 /* Callback to write schedule-calendar-transp property */
 static int proppatch_caltransp(xmlNodePtr prop, unsigned set,
                                struct proppatch_ctx *pctx,
@@ -5960,8 +6411,9 @@ static int propfind_timezone(const xmlCh
                              struct propstat propstat[],
                              void *rock __attribute__((unused)))
 {
+    static struct mime_type_t *out_type = caldav_mime_types;
     struct buf attrib = BUF_INITIALIZER;
-    const char *data = NULL, *msg_base = NULL;
+    const char *data = NULL;
     size_t datalen = 0;
     int r = 0;
 
@@ -5969,6 +6421,8 @@ static int propfind_timezone(const xmlCh
         const char *prop_annot =
             DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-timezone";
 
+        if (!out_type->content_type) return HTTP_BAD_MEDIATYPE;
+
         if (fctx->mailbox && !fctx->record) {
             r = annotatemore_lookupmask(fctx->mailbox->name, prop_annot,
                                         httpd_userid, &attrib);
@@ -5984,42 +6438,41 @@ static int propfind_timezone(const xmlCh
             prop_annot = DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-timezone-id";
 
             buf_free(&attrib);
-
-            if (fctx->mailbox)
-                r = annotatemore_lookupmask(fctx->mailbox->name, prop_annot,
-                                            httpd_userid, &attrib);
+            r = annotatemore_lookupmask(fctx->mailbox->name, prop_annot,
+                                        httpd_userid, &attrib);
 
             if (r) r = HTTP_SERVER_ERROR;
             else if (!attrib.len) r = HTTP_NOT_FOUND;
             else {
-                const char *path;
-                int fd;
-
-                /* Open and mmap the timezone file */
-                buf_reset(&fctx->buf);
-                buf_printf(&fctx->buf, "%s%s/%s.ics",
-                           config_dir, FNAME_ZONEINFODIR, buf_cstring(&attrib));
-
-                path = buf_cstring(&fctx->buf);
-                if ((fd = open(path, O_RDONLY)) == -1) return HTTP_SERVER_ERROR;
+                /* Fetch tz from builtin repository */
+                icaltimezone *tz =
+                    icaltimezone_get_builtin_timezone(buf_cstring(&attrib));
+
+                if (tz) {
+                    icalcomponent *vtz = icaltimezone_get_component(tz);
+                    icalcomponent *ical =
+                        icalcomponent_vanew(ICAL_VCALENDAR_COMPONENT,
+                                            icalproperty_new_version("2.0"),
+                                            icalproperty_new_prodid(ical_prodid),
+                                            vtz,
+                                            0);
 
-                map_refresh(fd, 1, &msg_base, &datalen,
-                            MAP_UNKNOWN_LEN, path, NULL);
-                close(fd);
+                    data = icalcomponent_as_ical_string(ical);
+                    datalen = strlen(data);
 
-                if (!msg_base) r = HTTP_SERVER_ERROR;
-
-                data = msg_base;
+                    icalcomponent_remove_component(ical, vtz);
+                    icalcomponent_free(ical);
+                }
+                else r = HTTP_SERVER_ERROR;
             }
         }
         else r = HTTP_NOT_FOUND;
     }
 
     if (!r) r = propfind_getdata(name, ns, fctx, prop, propstat,
-                                 caldav_mime_types, CALDAV_SUPP_DATA,
+                                 caldav_mime_types, &out_type,
                                  data, datalen);
 
-    if (msg_base) map_free(&msg_base, &datalen);
     buf_free(&attrib);
 
     return r;
@@ -6062,7 +6515,7 @@ static int proppatch_timezone(xmlNodePtr
         }
         else if (set) {
             icalcomponent *ical = NULL;
-            struct buf buf;
+            struct buf buf = BUF_INITIALIZER;
 
             freeme = xmlNodeGetContent(prop);
             tz = (const char *) freeme;
@@ -6142,12 +6595,15 @@ static int propfind_availability(const x
                                  struct propstat propstat[],
                                  void *rock __attribute__((unused)))
 {
+    static struct mime_type_t *out_type = caldav_mime_types;
     struct buf attrib = BUF_INITIALIZER;
     const char *data = NULL;
     unsigned long datalen = 0;
     int r = 0;
 
     if (propstat) {
+        if (!out_type->content_type) return HTTP_BAD_MEDIATYPE;
+
         buf_reset(&fctx->buf);
         buf_printf(&fctx->buf, DAV_ANNOT_NS "<%s>%s",
                    (const char *) ns->href, name);
@@ -6179,7 +6635,7 @@ static int propfind_availability(const x
     }
 
     if (!r) r = propfind_getdata(name, ns, fctx, prop, propstat,
-                                 caldav_mime_types, CALDAV_SUPP_DATA,
+                                 caldav_mime_types, &out_type,
                                  data, datalen);
     buf_free(&attrib);
 
@@ -6224,7 +6680,7 @@ static int proppatch_availability(xmlNod
         }
         else if (set) {
             icalcomponent *ical = NULL;
-            struct buf buf;
+            struct buf buf = BUF_INITIALIZER;
 
             freeme = xmlNodeGetContent(prop);
             avail = (const char *) freeme;
@@ -6285,7 +6741,6 @@ static int propfind_tzservset(const xmlC
 {
     assert(name && ns && fctx && propstat);
 
-#ifdef HAVE_TZ_BY_REF
     if (fctx->req_tgt->resource) return HTTP_NOT_FOUND;
 
     if (namespace_calendar.allow & ALLOW_CAL_NOTZ) {
@@ -6305,7 +6760,6 @@ static int propfind_tzservset(const xmlC
 
         return 0;
     }
-#endif /* HAVE_TZ_BY_REF */
 
     return HTTP_NOT_FOUND;
 }
@@ -6375,7 +6829,6 @@ static int proppatch_tzid(xmlNodePtr pro
                           struct propstat propstat[],
                           void *rock __attribute__((unused)))
 {
-#ifdef HAVE_TZ_BY_REF
     if ((namespace_calendar.allow & ALLOW_CAL_NOTZ) &&
         pctx->txn->req_tgt.collection && !pctx->txn->req_tgt.resource) {
         xmlChar *freeme = NULL;
@@ -6433,9 +6886,6 @@ static int proppatch_tzid(xmlNodePtr pro
 
         return 0;
     }
-#else
-    (void) set;  /* squash compiler warning */
-#endif /* HAVE_TZ_BY_REF */
 
     xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
                  &propstat[PROPSTAT_FORBID], prop->name, prop->ns, NULL, 0);
@@ -6487,21 +6937,50 @@ static int propfind_sharingmodes(const x
                                  struct propstat propstat[],
                                  void *rock __attribute__((unused)))
 {
-    xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
-                                   &propstat[PROPSTAT_OK], name, ns, NULL, 0);
-
     fctx->flags.cs_sharing = 1;
 
     if (fctx->req_tgt->collection && !fctx->req_tgt->flags &&
         !fctx->req_tgt->resource &&
         mboxname_userownsmailbox(fctx->req_tgt->userid, fctx->mbentry->name)) {
+        xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                                       &propstat[PROPSTAT_OK],
+                                       name, ns, NULL, 0);
+
         xmlNewChild(node, NULL, BAD_CAST "can-be-shared", NULL);
 #if 0  /* XXX  this is probably iCloud specific */
         xmlNewChild(node, NULL, BAD_CAST "can-be-published", NULL);
 #endif
+        return 0;
     }
 
-    return 0;
+    return HTTP_NOT_FOUND;
+}
+
+
+static icaltimezone *get_calendar_tz(const char *mboxname, const char *userid);
+
+/* mboxlist_findall() callback to run calendar-query on a collection */
+static int calquery_by_collection(const mbentry_t *mbentry, void *rock)
+{
+    const char *mboxname = mbentry->name;
+    struct propfind_ctx *fctx = (struct propfind_ctx *) rock;
+    struct calquery_filter *calfilter =
+        (struct calquery_filter *) fctx->filter_crit;
+    icaltimezone *cal_tz = NULL;
+
+    if (!calfilter->tz && (calfilter->flags & NEED_TZ)) {
+        /* Determine which time zone to use for floating time */
+        calfilter->tz = cal_tz = get_calendar_tz(mboxname, httpd_userid);
+    }
+
+    int r = propfind_by_collection(mbentry, rock);
+
+    if (cal_tz) {
+        icaltimezone_free(cal_tz, 1 /* free_struct */);
+        calfilter->tz = NULL;
+    }
+
+    return r;
 }
 
 
@@ -6535,8 +7014,6 @@ static int report_cal_query(struct trans
                 xmlChar *tzdata = NULL;
                 icalcomponent *ical = NULL, *tz = NULL;
 
-                /* XXX  Need to pass this to query for floating time */
-                syslog(LOG_WARNING, "REPORT calendar-query w/timezone");
                 tzdata = xmlNodeGetContent(node);
                 if (tzdata) {
                     ical = icalparser_parse_string((const char *) tzdata);
@@ -6568,8 +7045,9 @@ static int report_cal_query(struct trans
                 tzid = xmlNodeGetContent(node);
 
                 if (tzid) {
-                    calfilter.tz =
+                    icaltimezone *tz =
                         icaltimezone_get_builtin_timezone_from_tzid((const char *) tzid);
+                    if (tz) calfilter.tz = icaltimezone_copy(tz);
                     xmlFree(tzid);
 
                     if (!calfilter.tz) {
@@ -6581,27 +7059,38 @@ static int report_cal_query(struct trans
         }
     }
 
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
+
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, fctx->root->doc);
+
     if (fctx->depth++ > 0) {
         /* Calendar collection(s) */
         if (txn->req_tgt.collection) {
             /* Add response for target calendar collection */
-            propfind_by_collection(txn->req_tgt.mbentry, fctx);
+            calquery_by_collection(txn->req_tgt.mbentry, fctx);
         }
         else {
             /* Add responses for all contained calendar collections */
             mboxlist_mboxtree(txn->req_tgt.mbentry->name,
-                              propfind_by_collection, fctx,
+                              calquery_by_collection, fctx,
                               MBOXTREE_SKIP_ROOT);
 
             /* Add responses for all shared calendar collections */
             mboxlist_usersubs(txn->req_tgt.userid,
-                              propfind_by_collection, fctx,
+                              calquery_by_collection, fctx,
                               MBOXTREE_SKIP_PERSONAL);
         }
-
-        ret = *fctx->ret;
     }
 
+    /* End XML response */
+    xml_partial_response(txn, fctx->root->doc, NULL /* end */, 0, &fctx->xmlbuf);
+    xmlBufferFree(fctx->xmlbuf);
+
+    /* End of output */
+    write_body(0, txn, NULL, 0);
+
   done:
     /* Free filter structure */
     if (calfilter.tz) icaltimezone_free(calfilter.tz, 1);
@@ -6612,7 +7101,7 @@ static int report_cal_query(struct trans
         fctx->davdb = NULL;
     }
 
-    return (ret ? ret : HTTP_MULTI_STATUS);
+    return ret;
 }
 
 
@@ -6713,7 +7202,6 @@ static int add_freebusy_comp(icalcompone
         fbtype = ICAL_FBTYPE_BUSY;
         break;
 
-#ifdef HAVE_VAVAILABILITY
     case ICAL_VAVAILABILITY_COMPONENT: {
         enum icalproperty_busytype busytype = ICAL_BUSYTYPE_BUSYUNAVAILABLE;
         icalproperty *prop =
@@ -6738,7 +7226,6 @@ static int add_freebusy_comp(icalcompone
     case ICAL_XAVAILABLE_COMPONENT:
         fbtype = ICAL_FBTYPE_FREE;
         break;
-#endif /* HAVE_VAVAILABILITY */
 
     default:
         fbtype = ICAL_FBTYPE_NONE;
@@ -6831,6 +7318,9 @@ static int busytime_by_resource(void *ro
     struct icaltimetype dtstart = icaltime_from_string(cdata->dtstart);
     struct icaltimetype dtend = icaltime_from_string(cdata->dtend);
 
+    dtstart = icaltime_convert_to_utc(dtstart, fbfilter->tz);
+    dtend = icaltime_convert_to_utc(dtend, fbfilter->tz);
+
     if (icaltime_compare(dtend, fbfilter->start) <= 0) {
         /* Component ends earlier than range */
         return 0;
@@ -6843,15 +7333,10 @@ static int busytime_by_resource(void *ro
     if (cdata->comp_flags.recurring ||
         cdata->comp_type == CAL_COMP_VAVAILABILITY) {
         /* Need to mmap() and parse iCalendar object */
-        struct index_record record;
         icalcomponent *ical = NULL;
-        int r;
 
         /* Fetch index record for the resource */
-        r = mailbox_find_index_record(fctx->mailbox,
-                                      cdata->dav.imap_uid, &record);
-
-        if (!r) ical = record_to_ical(fctx->mailbox, &record, NULL);
+        ical = caldav_record_to_ical(fctx->mailbox, cdata, NULL, NULL);
         if (!ical) return 0;
 
         if (cdata->comp_flags.recurring) {
@@ -6896,6 +7381,44 @@ static int busytime_by_resource(void *ro
 }
 
 
+static icaltimezone *get_calendar_tz(const char *mboxname, const char *userid)
+{
+    struct buf attrib = BUF_INITIALIZER;
+    icaltimezone *tz = NULL;
+
+    /*  Check for CALDAV:calendar-timezone-id */
+    const char *prop_annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-timezone-id";
+
+    int r = annotatemore_lookupmask(mboxname, prop_annot, userid, &attrib);
+    if (!r && buf_len(&attrib)) {
+        tz = icaltimezone_get_builtin_timezone(buf_cstring(&attrib));
+        buf_free(&attrib);
+        if (tz) return icaltimezone_copy(tz);
+    }
+
+    /*  Check for CALDAV:calendar-timezone */
+    prop_annot = DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-timezone";
+
+    r = annotatemore_lookupmask(mboxname, prop_annot, httpd_userid, &attrib);
+    if (!r && buf_len(&attrib)) {
+        icalcomponent *ical, *vtz;
+
+        ical = icalparser_parse_string(buf_cstring(&attrib));
+        vtz = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
+        icalcomponent_remove_component(ical, vtz);
+        icalcomponent_free(ical);
+        buf_free(&attrib);
+
+        tz = icaltimezone_new();
+        icaltimezone_set_component(tz, vtz);
+        return tz;
+    }
+
+    /* Default to UTC */
+    return icaltimezone_copy(icaltimezone_get_utc_timezone());
+}
+
 /* mboxlist_findall() callback to find busytime of a collection */
 static int busytime_by_collection(const mbentry_t *mbentry, void *rock)
 {
@@ -6920,7 +7443,15 @@ static int busytime_by_collection(const
         }
     }
 
-    return propfind_by_collection(mbentry, rock);
+    /* Determine which time zone to use for floating time */
+    fbfilter->tz = get_calendar_tz(mboxname, httpd_userid);
+
+    int r = propfind_by_collection(mbentry, rock);
+
+    if (fbfilter->tz) icaltimezone_free(fbfilter->tz, 1 /* free_struct */);
+    fbfilter->tz = NULL;
+
+    return r;
 }
 
 
@@ -6982,7 +7513,7 @@ static void combine_vavailability(struct
 
     memset(&availfilter, 0, sizeof(struct freebusy_filter));
 
-    /* Sort VAVAILBILITY periods by priority and start time */
+    /* Sort VAVAILABILITY periods by priority and start time */
     qsort(vavail->vav, vavail->len,
           sizeof(struct vavailability), compare_vavail);
 
@@ -7124,6 +7655,9 @@ icalcomponent *busytime_query_local(stru
     icalproperty *prop;
     unsigned n;
 
+    syslog(LOG_DEBUG, "busytime_query_local(mbox: '%s', org: '%s', att: '%s')",
+           mailboxname, organizer, attendee);
+
     fctx->open_db = (db_open_proc_t) &caldav_open_mailbox;
     fctx->close_db = (db_close_proc_t) &caldav_close;
     fctx->lookup_resource = (db_lookup_proc_t) &caldav_lookup_resource;
@@ -7157,12 +7691,21 @@ icalcomponent *busytime_query_local(stru
         const char *prop_annot =
             DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-availability";
         char *userid = mboxname_to_userid(mailboxname);
-        const char *mboxname = caldav_mboxname(userid, SCHED_INBOX);
+        char *mboxname = caldav_mboxname(userid, SCHED_INBOX);
         if (!annotatemore_lookupmask(mboxname, prop_annot,
                                      httpd_userid, &attrib) && attrib.len) {
             add_vavailability(vavail,
                               icalparser_parse_string(buf_cstring(&attrib)));
         }
+        else {
+            prop_annot = DAV_ANNOT_NS "<" XML_NS_CS ">calendar-availability";
+            if (!annotatemore_lookupmask(mboxname, prop_annot,
+                                         httpd_userid, &attrib) && attrib.len) {
+                add_vavailability(vavail,
+                                  icalparser_parse_string(buf_cstring(&attrib)));
+            }
+        }
+        free(mboxname);
         free(userid);
     }
 
@@ -7265,7 +7808,8 @@ icalcomponent *busytime_query_local(stru
 
         /* Create new FREEBUSY property with FBTYPE and add to component */
         busy = icalproperty_new_freebusy(fb->per);
-        icalproperty_add_parameter(busy, icalparameter_new_fbtype(fb->type));
+        if (fb->type != ICAL_FBTYPE_BUSY)
+            icalproperty_add_parameter(busy, icalparameter_new_fbtype(fb->type));
         icalcomponent_add_property(fbcomp, busy);
     }
 
@@ -7394,7 +7938,7 @@ static void strip_vtimezones(icalcompone
         const char *tzid = icalproperty_get_tzid(prop);
         struct zoneinfo zi;
 
-        if (!zoneinfo_lookup(tzid, &zi)) {
+        if (tzid && !zoneinfo_lookup(tzid, &zi)) {
             if (zi.type == ZI_LINK) {
                 /* Add this alias to our table */
                 hash_insert(tzid, xstrdup(zi.data->s), &tzid_table);
@@ -7419,11 +7963,12 @@ static void strip_vtimezones(icalcompone
 /* Store the iCal data in the specified calendar/resource */
 int caldav_store_resource(struct transaction_t *txn, icalcomponent *ical,
                           struct mailbox *mailbox, const char *resource,
+                          modseq_t createdmodseq,
                           struct caldav_db *caldavdb, unsigned flags,
-                          const char *schedule_address)
+                          const char *userid, const strarray_t *schedule_addresses)
 {
     int ret;
-    icalcomponent *comp;
+    icalcomponent *comp, *userdata = NULL, *store_ical = ical;
     icalcomponent_kind kind;
     icalproperty_method meth;
     icalproperty *prop;
@@ -7437,6 +7982,7 @@ int caldav_store_resource(struct transac
     struct index_record *oldrecord = NULL, record;
     char datestr[80], *mimehdr;
     const char *sched_tag;
+    uint32_t newuid = 0;
     strarray_t imapflags = STRARRAY_INITIALIZER;
 
     /* Check for supported component type */
@@ -7449,9 +7995,7 @@ int caldav_store_resource(struct transac
     case ICAL_VJOURNAL_COMPONENT: mykind = CAL_COMP_VJOURNAL; break;
     case ICAL_VFREEBUSY_COMPONENT: mykind = CAL_COMP_VFREEBUSY; break;
     case ICAL_VAVAILABILITY_COMPONENT: mykind = CAL_COMP_VAVAILABILITY; break;
-#ifdef HAVE_VPOLL
     case ICAL_VPOLL_COMPONENT: mykind = CAL_COMP_VPOLL; break;
-#endif
     default:
         txn->error.precond = CALDAV_SUPP_COMP;
         return HTTP_FORBIDDEN;
@@ -7475,6 +8019,7 @@ int caldav_store_resource(struct transac
 
     /* does it already exist? */
     if (cdata->dav.imap_uid) {
+        newuid = cdata->dav.imap_uid;
         /* Check for change of iCalendar UID */
         if (strcmp(cdata->ical_uid, uid)) {
             /* CALDAV:no-uid-conflict */
@@ -7495,8 +8040,30 @@ int caldav_store_resource(struct transac
         tzbyref = 1;
     }
 
+    /* Set Schedule-Tag, if any */
+    if (flags & NEW_STAG) {
+        if (oldrecord) sched_tag = message_guid_encode(&oldrecord->guid);
+        else sched_tag = NULL_ETAG;
+    }
+    else if (organizer) sched_tag = cdata->sched_tag;
+    else sched_tag = cdata->sched_tag = NULL;
+
     /* If we are just stripping VTIMEZONEs from resource, flag it */
     if (flags & TZ_STRIP) strarray_append(&imapflags, DFLAG_UNCHANGED);
+    else if (mailbox->i.options & OPT_IMAP_SHAREDSEEN) {
+        cdata->comp_flags.shared = 0;
+    }
+    else if (userid && (namespace_calendar.allow & ALLOW_USERDATA)) {
+        ret = personalize_resource(txn, mailbox, ical,
+                                   cdata, userid, &store_ical, &userdata);
+        if (ret) goto done;
+
+        if (store_ical != ical) {
+            comp = icalcomponent_get_first_real_component(store_ical);
+            uid = icalcomponent_get_uid(comp);
+            kind = icalcomponent_isa(comp);
+        }
+    }
 
     /* Create and cache RFC 5322 header fields for resource */
     prop = icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
@@ -7507,36 +8074,30 @@ int caldav_store_resource(struct transac
             assert(!buf_len(&txn->buf));
             buf_printf(&txn->buf, "<%s>", organizer);
             mimehdr = charset_encode_mimeheader(buf_cstring(&txn->buf),
-                                                buf_len(&txn->buf));
+                                                buf_len(&txn->buf), 0);
             spool_replace_header(xstrdup("From"), mimehdr, txn->req_hdrs);
             buf_reset(&txn->buf);
         }
     }
 
-    /* Set Schedule-Tag, if any */
-    if (flags & NEW_STAG) {
-        if (oldrecord) sched_tag = message_guid_encode(&oldrecord->guid);
-        else sched_tag = NULL_ETAG;
-    }
-    else if (organizer) sched_tag = cdata->sched_tag;
-    else sched_tag = cdata->sched_tag = NULL;
-
     prop = icalcomponent_get_first_property(comp, ICAL_SUMMARY_PROPERTY);
     if (prop) {
-        mimehdr = charset_encode_mimeheader(icalproperty_get_summary(prop), 0);
+        mimehdr = charset_encode_mimeheader(icalproperty_get_summary(prop), 0, 0);
         spool_replace_header(xstrdup("Subject"), mimehdr, txn->req_hdrs);
     }
     else spool_replace_header(xstrdup("Subject"),
                             xstrdup(icalcomponent_kind_to_string(kind)),
                             txn->req_hdrs);
 
-    if (schedule_address) {
-        mimehdr = charset_encode_mimeheader(schedule_address, 0);
+    if (strarray_size(schedule_addresses)) {
+        char *value = strarray_join(schedule_addresses, ",");
+        mimehdr = charset_encode_mimeheader(value, 0, 0);
         spool_replace_header(xstrdup("X-Schedule-User-Address"),
                              mimehdr, txn->req_hdrs);
+        free(value);
     }
 
-    time_to_rfc822(icaltime_as_timet_with_zone(icalcomponent_get_dtstamp(comp),
+    time_to_rfc5322(icaltime_as_timet_with_zone(icalcomponent_get_dtstamp(comp),
                                                utc_zone),
                    datestr, sizeof(datestr));
     spool_replace_header(xstrdup("Date"), xstrdup(datestr), txn->req_hdrs);
@@ -7554,7 +8115,7 @@ int caldav_store_resource(struct transac
                          buf_release(&txn->buf), txn->req_hdrs);
 
     buf_setcstr(&txn->buf, ICALENDAR_CONTENT_TYPE);
-    if ((meth = icalcomponent_get_method(ical)) != ICAL_METHOD_NONE) {
+    if ((meth = icalcomponent_get_method(store_ical)) != ICAL_METHOD_NONE) {
         buf_printf(&txn->buf, "; method=%s",
                    icalproperty_method_to_string(meth));
     }
@@ -7565,19 +8126,87 @@ int caldav_store_resource(struct transac
     buf_printf(&txn->buf, "attachment;\r\n\tfilename=\"%s\"", resource);
     if (sched_tag) buf_printf(&txn->buf, ";\r\n\tschedule-tag=%s", sched_tag);
     if (tzbyref) buf_printf(&txn->buf, ";\r\n\ttz-by-ref=true");
+    if (cdata->comp_flags.shared) {
+        buf_printf(&txn->buf, ";\r\n\tper-user-data=true");
+    }
     spool_replace_header(xstrdup("Content-Disposition"),
                          buf_release(&txn->buf), txn->req_hdrs);
 
     spool_remove_header(xstrdup("Content-Description"), txn->req_hdrs);
 
     /* Store the resource */
-    ret = dav_store_resource(txn, icalcomponent_as_ical_string(ical), 0,
-                             mailbox, oldrecord, &imapflags);
+    ret = dav_store_resource(txn, icalcomponent_as_ical_string(store_ical), 0,
+                             mailbox, oldrecord, createdmodseq, &imapflags);
     strarray_fini(&imapflags);
 
+    newuid = mailbox->i.last_uid;
+
+  done:
     switch (ret) {
     case HTTP_CREATED:
     case HTTP_NO_CONTENT:
+        if ((namespace_calendar.allow & ALLOW_USERDATA) &&
+            cdata->comp_flags.shared) {
+
+            /* either the UID created by dav_store_resource, or if nothing but per-user data
+             * was changed, the UID of the existing record */
+            assert(newuid);
+
+            /* Ensure we have an astate connected to the mailbox,
+             * so that the annotation txn will be committed
+             * when we close the mailbox */
+            annotate_state_t *astate = NULL;
+
+            if (oldrecord && (newuid != oldrecord->uid) &&
+                !mailbox_get_annotate_state(mailbox, newuid, &astate)) {
+                /* Copy across all per-message annotations.
+
+                   XXX  Hack until we fix annotation copying in
+                   append_fromstage() to preserve userid of private annots. */
+                annotate_msg_copy(mailbox, oldrecord->uid,
+                                  mailbox, newuid, NULL);
+            }
+
+            int r = write_personal_data(userid, mailbox, newuid,
+                                        mailbox->i.highestmodseq+1, userdata);
+            if (r) {
+                /* XXX  We have already written the stripped resource
+                   so we're pretty screwed.  All message annotations
+                   need to be handled (properly) in append_fromstage()
+                   so storing resource and annotations is atomic.
+                */
+                txn->error.desc = error_message(r);
+                ret = HTTP_SERVER_ERROR;
+                goto done;
+            }
+
+            if (store_ical) {
+                /* Write shared modseq for resource */
+                buf_printf(&txn->buf, MODSEQ_FMT, mailbox->i.highestmodseq);
+                mailbox_get_annotate_state(mailbox, newuid, NULL);
+                mailbox_annotation_write(mailbox, newuid, SHARED_MODSEQ,
+                                         /* shared */ "", &txn->buf);
+                buf_reset(&txn->buf);
+            }
+
+            if (!cdata->organizer || (flags & PREFER_REP)) {
+                /* Read index record for new message (always the last one) */
+                struct index_record newrecord;
+
+                cdata->dav.alive = 1;
+                cdata->dav.imap_uid = newuid;
+
+                caldav_get_validators(mailbox, cdata, userid, &newrecord,
+                                      &txn->resp_body.etag,
+                                      &txn->resp_body.lastmod);
+
+                if (flags & PREFER_REP) {
+                    /* Re-insert per-user data */
+                    icalcomponent_apply_vpatch(ical, userdata, NULL, NULL);
+                }
+            }
+        }
+
         if (cdata->organizer) {
             if (flags & NEW_STAG) txn->resp_body.stag = sched_tag;
 
@@ -7590,6 +8219,9 @@ int caldav_store_resource(struct transac
         break;
     }
 
+    if (userdata) icalcomponent_free(userdata);
+    if (store_ical && (store_ical != ical)) icalcomponent_free(store_ical);
+
     return ret;
 }
 
@@ -7614,10 +8246,10 @@ static struct mime_type_t freebusy_mime_
 
 /* Execute a free/busy query per
    http://www.calconnect.org/pubdocs/CD0903%20Freebusy%20Read%20URL.pdf */
-static int meth_get_head_fb(struct transaction_t *txn,
-                            void *params __attribute__((unused)))
+static int meth_get_head_fb(struct transaction_t *txn, void *params)
 
 {
+    struct meth_params *gparams = (struct meth_params *) params;
     int ret = 0, r, rights;
     struct tm *tm;
     struct strlist *param;
@@ -7629,8 +8261,8 @@ static int meth_get_head_fb(struct trans
     icalcomponent *cal;
 
     /* Parse the path */
-    if ((r = caldav_parse_path(txn->req_uri->path,
-                               &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, gparams);
+    if (r) return r;
 
     if (txn->req_tgt.resource ||
         !(txn->req_tgt.userid)) {
@@ -7696,10 +8328,8 @@ static int meth_get_head_fb(struct trans
     }
     else {
         /* Default to start of current day */
-        start = time(0);
-        tm = localtime(&start);
-        tm->tm_hour = tm->tm_min = tm->tm_sec = 0;
-        fbfilter.start = icaltime_from_timet_with_zone(mktime(tm), 0, utc_zone);
+        start = (time(0) / 86400) * 86400;
+        fbfilter.start = icaltime_from_timet_with_zone(start, 0, utc_zone);
 
         /* Default to 42 day period */
         period.days = 42;
@@ -7750,7 +8380,6 @@ static int meth_get_head_fb(struct trans
         const char *proto, *host;
         icalcomponent *fb;
         icalproperty *url;
-        struct buf *cal_str;
 
         /* Construct URL */
         buf_reset(&txn->buf);
@@ -7769,7 +8398,7 @@ static int meth_get_head_fb(struct trans
         buf_printf(&txn->buf, "%s.%s",
                    txn->req_tgt.userid,
                    mime->file_ext);
-        txn->resp_body.fname = buf_cstring(&txn->buf);
+        txn->resp_body.dispo.fname = buf_cstring(&txn->buf);
 
         txn->resp_body.type = mime->content_type;
 
@@ -7777,7 +8406,7 @@ static int meth_get_head_fb(struct trans
         txn->flags.cc |= CC_NOTRANSFORM;
 
         /* Output the iCalendar object */
-        cal_str = mime->from_object(cal);
+        struct buf *cal_str = mime->from_object(cal);
         icalcomponent_free(cal);
 
         write_body(HTTP_OK, txn, buf_base(cal_str), buf_len(cal_str));
@@ -7791,16 +8420,31 @@ static int meth_get_head_fb(struct trans
 
 static int meth_options_cal(struct transaction_t *txn, void *params)
 {
+    struct meth_params *oparams = (struct meth_params *) params;
     int r;
 
     /* Parse the path */
-    if ((r = caldav_parse_path(txn->req_uri->path,
-                               &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, oparams);
+    if (r) return r;
 
     if (txn->req_tgt.allow & ALLOW_PATCH) {
         /* Add Accept-Patch formats to response */
         txn->resp_body.patch = caldav_patch_docs;
     }
+    if (txn->req_tgt.collection && !txn->req_tgt.resource) {
+        /* Add subscription upgrade links */
+        struct buf link = BUF_INITIALIZER;
+
+        buf_printf(&link, "<%s>; rel=\"subscribe-caldav_auth\"",
+                   txn->req_tgt.path);
+        strarray_appendm(&txn->resp_body.links, buf_release(&link));
+        buf_printf(&link, "<%s>; rel=\"subscribe-webdav_sync\"",
+                   txn->req_tgt.path);
+        strarray_appendm(&txn->resp_body.links, buf_release(&link));
+        buf_printf(&link, "<%s>; rel=\"subscribe-enhanced-get\"",
+                   txn->req_tgt.path);
+        strarray_appendm(&txn->resp_body.links, buf_release(&link));
+    }
 
-    return meth_options(txn, params);
+    return meth_options(txn, oparams->parse_path);
 }
diff -pruN 3.0.13-5/imap/http_caldav.h 3.2.0-3/imap/http_caldav.h
--- 3.0.13-5/imap/http_caldav.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_caldav.h	2020-04-24 02:03:00.000000000 +0000
@@ -46,14 +46,23 @@
 
 /* Create the calendar home, default calendars and scheduling
  * boxes for userid, if they don't already exist. */
+extern unsigned long config_types_to_caldav_types(void);
 extern int caldav_create_defaultcalendars(const char *userid);
 
 extern int caldav_store_resource(struct transaction_t *txn, icalcomponent *ical,
                                  struct mailbox *mailbox, const char *resource,
+                                 modseq_t createdmodseq,
                                  struct caldav_db *caldavdb, unsigned flags,
-                                 const char *schedule_userid);
+                                 const char *userid, const strarray_t *schedule_addresses);
 
-/* defined in http_tzdist.c */
-extern void icalcomponent_add_required_timezones(icalcomponent *ical);
+extern icalcomponent *caldav_record_to_ical(struct mailbox *mailbox,
+                                            const struct caldav_data *cdata,
+                                            const char *userid,
+                                            strarray_t *schedule_addresses);
+
+extern int caldav_is_personalized(struct mailbox *mailbox,
+                                  const struct caldav_data *cdata,
+                                  const char *userid,
+                                  struct buf *userdata);
 
 #endif /* HTTP_CALDAV_H */
diff -pruN 3.0.13-5/imap/http_caldav_sched.c 3.2.0-3/imap/http_caldav_sched.c
--- 3.0.13-5/imap/http_caldav_sched.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_caldav_sched.c	2020-05-04 03:28:02.000000000 +0000
@@ -58,6 +58,8 @@
 #include "http_caldav_sched.h"
 #include "http_dav.h"
 #include "http_proxy.h"
+#include "jmap_ical.h"
+#include "jmap_util.h"
 #include "notify.h"
 #include "crc32.h"
 #include "smtpclient.h"
@@ -75,99 +77,70 @@ static const char *get_organizer(icalcom
 static int partstat_changed(icalcomponent *oldcomp,
                             icalcomponent *newcomp, const char *attendee);
 
-int caladdress_lookup(const char *addr,
-                      struct caldav_sched_param *param, const char *myuserid)
+int caladdress_lookup(const char *addr, struct caldav_sched_param *param,
+                      const strarray_t *schedule_addresses)
 {
-    const char *userid = addr, *p;
-    int islocal = 1, found = 1;
-    size_t len;
-    char *testuser = NULL;
+    const char *userid = addr;
+    int i;
 
     if (!addr) return HTTP_NOT_FOUND;
 
-    if (myuserid) {
-        const char *annotname =
-            DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
-        char *mailboxname = caldav_mboxname(myuserid, NULL);
-        struct buf mybuf = BUF_INITIALIZER;
-        int r = annotatemore_lookupmask(mailboxname, annotname,
-                                        myuserid, &mybuf);
-
-        if (!r && mybuf.len) {
-            if (!strncasecmp(buf_cstring(&mybuf), "mailto:", 7))
-                testuser = xstrdup(buf_cstring(&mybuf) + 7);
-            else
-                testuser = buf_release(&mybuf);
-        }
-        else if (strchr(myuserid, '@') || !httpd_extradomain) {
-            testuser = xstrdup(myuserid);
-        }
-        else {
-            testuser = strconcat(myuserid, "@", httpd_extradomain, (char *)NULL);
-        }
-
-        free(mailboxname);
-        buf_free(&mybuf);
-    }
-
     if (!strncasecmp(userid, "mailto:", 7)) userid += 7;
 
+    char *addresses = schedule_addresses ? strarray_join(schedule_addresses, ",") : xstrdup("NULL");
+    syslog(LOG_DEBUG,
+           "caladdress_lookup(userid: '%s', schedule_addresses: '%s')",
+           userid, addresses);
+    free(addresses);
+
     memset(param, 0, sizeof(struct caldav_sched_param));
 
-    if (testuser && !strcasecmp(userid, testuser)) {
-        param->isyou = 1;
-        param->userid = testuser;
-        return 0; // myself is always local
+    param->userid = xstrdup(userid);
+
+    if (schedule_addresses) {
+        for (i = 0; i < strarray_size(schedule_addresses); i++) {
+            const char *item = strarray_nth(schedule_addresses, i);
+            if (!strncasecmp(item, "mailto:", 7)) item += 7;
+            if (strcasecmp(item, userid)) continue;
+            // found one!
+            param->isyou = 1;
+            return 0; // myself is always local
+        }
     }
-    free(testuser);
-    len = strlen(userid);
+
+    // does this user have an inbox on this machine?
 
     /* XXX  Do LDAP/DB/socket lookup to see if user is local */
     /* XXX  Hack until real lookup stuff is written */
-    if ((p = strchr(userid, '@')) && *++p) {
-        struct strlist *domains = cua_domains;
+    int islocal = 0;
 
-        for (; domains && strcmp(p, domains->s); domains = domains->next);
-
-        if (!domains) islocal = 0;
-        else if (!config_virtdomains) len = p - userid - 1;
+    const char *at = strchr(userid, '@');
+    if (at) {
+        struct strlist *domains = cua_domains;
+        for (; domains && strcmp(at+1, domains->s); domains = domains->next);
+        if (domains) islocal = 1;
     }
 
     if (islocal) {
-        /* User is in a local domain */
-        int r;
-        const char *mboxname = NULL;
         mbentry_t *mbentry = NULL;
-        mbname_t *mbname = NULL;
-
-        if (!found) return HTTP_NOT_FOUND;
-        else param->userid = xstrndup(userid, len); /* freed by sched_param_free */
-
         /* Lookup user's cal-home-set to see if its on this server */
-
-        mbname = mbname_from_userid(param->userid);
+        mbname_t *mbname = mbname_from_userid(userid);
         mbname_push_boxes(mbname, config_getstring(IMAPOPT_CALENDARPREFIX));
-        mboxname = mbname_intname(mbname);
-
-        r = http_mlookup(mboxname, &mbentry, NULL);
+        int r = http_mlookup(mbname_intname(mbname), &mbentry, NULL);
         mbname_free(&mbname);
 
         if (!r) {
-            param->server = xstrdupnull(mbentry->server); /* freed by sched_param_free */
+            param->server = xstrdupnull(mbentry->server); /* freed by sched_param_fini */
             mboxlist_entry_free(&mbentry);
             if (param->server) param->flags |= SCHEDTYPE_ISCHEDULE;
             return 0;
         }
-        /* Fall through and try remote */
     }
 
     /* User is outside of our domain(s) -
        Do remote scheduling (default = iMIP) */
-    if (param->userid) free(param->userid);
-    param->userid = xstrdupnull(userid); /* freed by sched_param_free */
     param->flags |= SCHEDTYPE_REMOTE;
 
-#ifdef WITH_DKIM
     /* Do iSchedule DNS SRV lookup */
 
     /* XXX  If success, set server, port,
@@ -185,14 +158,12 @@ int caladdress_lookup(const char *addr,
         param->flags |= SCHEDTYPE_ISCHEDULE;
     }
     else if (!strcmp(p, "bedework.org")) {
-        param->server = xstrdrup("www.bedework.org");
+        param->server = xstrdup("www.bedework.org");
         param->port = 80;
         param->flags |= SCHEDTYPE_ISCHEDULE;
     }
 #endif /* IOPTEST */
 
-#endif /* WITH_DKIM */
-
     return 0;
 }
 
@@ -220,7 +191,7 @@ static void add_address(struct address_t
     param = icalproperty_get_first_parameter(prop, ICAL_CN_PARAMETER);
     if (param) {
         new->name = icalparameter_get_cn(param);
-        new->qpname = charset_encode_mimeheader(new->name, 0);
+        new->qpname = charset_encode_mimeheader(new->name, 0, 0);
     }
     param = icalproperty_get_first_parameter(prop, ICAL_ROLE_PARAMETER);
     if (param)
@@ -250,7 +221,7 @@ static void HTMLencode(struct buf *outpu
 #define HTML_ROW        "<tr><td><b>%s</b></td><td>%s</td></tr>\r\n"
 
 /* Send an iMIP request for attendees in 'ical' */
-static int imip_send_sendmail(icalcomponent *ical,
+static int imip_send_sendmail(icalcomponent *ical, const char *sender,
                               const char *recipient, int is_update)
 {
     int r;
@@ -259,24 +230,16 @@ static int imip_send_sendmail(icalcompon
     icalproperty_method meth;
     icalcomponent_kind kind;
     const char *uid, *summary, *location, *descrip, *status;
-    const char *argv[7], *msg_type, *filename;
+    const char *msg_type, *filename;
     struct address_t *recipients = NULL, *originator = NULL, *recip;
     struct icaltimetype start, end;
-    char *cp, when[2*RFC822_DATETIME_MAX+4], datestr[RFC822_DATETIME_MAX+1];
+    char *cp, when[2*RFC5322_DATETIME_MAX+4], datestr[RFC5322_DATETIME_MAX+1];
     char boundary[100], *mimebody, *ical_str;
     size_t outlen;
-    struct buf plainbuf = BUF_INITIALIZER, tmpbuf = BUF_INITIALIZER;
-    FILE *sm;
-    pid_t sm_pid, p = getpid();
+    struct buf plainbuf = BUF_INITIALIZER, tmpbuf = BUF_INITIALIZER, msgbuf = BUF_INITIALIZER;
+    pid_t p = getpid();
     time_t t = time(NULL);
     static unsigned send_count = 0;
-    const char *day_of_week[] = {
-        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
-    };
-    const char *month_of_year[] = {
-        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
-    };
 
     meth = icalcomponent_get_method(ical);
     comp = icalcomponent_get_first_real_component(ical);
@@ -321,23 +284,6 @@ static int imip_send_sendmail(icalcompon
         }
     }
 
-    argv[0] = "sendmail";
-    argv[1] = "-f";
-    argv[2] = originator->addr;
-    argv[3] = "-t";             /* get recipients from body */
-    argv[4] = "-N";             /* notify on failure or delay */
-    argv[5] = "failure,delay";
-    argv[6] = NULL;
-
-    sm_pid = open_sendmail(argv, &sm);
-
-    if (sm == NULL) {
-        syslog(LOG_ERR,
-               "imip_send_sendmail(%s): failed to fork sendmail", recipient);
-        r = HTTP_UNAVAILABLE;
-        goto done;
-    }
-
     /* Get other useful properties/values */
     summary = icalcomponent_get_summary(comp);
     location = icalcomponent_get_location(comp);
@@ -352,8 +298,8 @@ static int imip_send_sendmail(icalcompon
 
     cp = when;
     cp += sprintf(cp, "%s, %02u %s %04u",
-                  day_of_week[icaltime_day_of_week(start)-1],
-                  start.day, month_of_year[start.month-1], start.year);
+                  wday[icaltime_day_of_week(start)-1],
+                  start.day, monthname[start.month-1], start.year);
     if (!icaltime_is_date(start)) {
         cp += sprintf(cp, " %02u:%02u", start.hour, start.minute);
         if (start.second) cp += sprintf(cp, ":%02u", start.second);
@@ -366,8 +312,8 @@ static int imip_send_sendmail(icalcompon
         cp += 2;
         if (icaltime_compare_date_only(end, start)) {
             cp += sprintf(cp, " %s, %02u %s %04u",
-                          day_of_week[icaltime_day_of_week(end)-1],
-                          end.day, month_of_year[end.month-1], end.year);
+                          wday[icaltime_day_of_week(end)-1],
+                          end.day, monthname[end.month-1], end.year);
         }
         if (!icaltime_is_date(end)) {
             cp += sprintf(cp, " %02u:%02u", end.hour, end.minute);
@@ -377,61 +323,61 @@ static int imip_send_sendmail(icalcompon
     }
 
     /* Create multipart/mixed + multipart/alternative iMIP message */
-    fprintf(sm, "From: %s <%s>\r\n",
-            originator->qpname ? originator->qpname : "", originator->addr);
+    buf_printf(&msgbuf, "From: %s <%s>\r\n",
+            originator->qpname ? originator->qpname : "", sender);
 
     for (recip = recipients; recip; recip = recip->next) {
-        if (strcmp(recip->addr, originator->addr) &&
+        if (strcmp(recip->addr, sender) &&
             (!recipient || !strcasecmp(recip->addr, recipient))) {
-            fprintf(sm, "To: %s <%s>\r\n",
+            buf_printf(&msgbuf, "To: %s <%s>\r\n",
                     recip->qpname ? recip->qpname : "", recip->addr);
         }
     }
 
-    fprintf(sm, "Subject: %s: ", filename);
+    buf_printf(&msgbuf, "Subject: %s: ", filename);
     if (summary) {
-        char *mimehdr = charset_encode_mimeheader(summary, 0);
-        fputs(mimehdr, sm);
+        char *mimehdr = charset_encode_mimeheader(summary, 0, 0);
+        buf_appendcstr(&msgbuf, mimehdr);
         free(mimehdr);
     }
     else {
-        fputs(icalcomponent_kind_to_string(kind), sm);
+        buf_appendcstr(&msgbuf, icalcomponent_kind_to_string(kind));
     }
-    fputs("\r\n", sm);
+    buf_appendcstr(&msgbuf, "\r\n");
 
-    time_to_rfc822(t, datestr, sizeof(datestr));
-    fprintf(sm, "Date: %s\r\n", datestr);
+    time_to_rfc5322(t, datestr, sizeof(datestr));
+    buf_printf(&msgbuf, "Date: %s\r\n", datestr);
 
-    fprintf(sm, "Message-ID: <cyrus-caldav-%u-%ld-%u@%s>\r\n",
+    buf_printf(&msgbuf, "Message-ID: <cyrus-caldav-%u-%ld-%u@%s>\r\n",
             p, t, send_count++, config_servername);
 
     /* Create multipart boundary */
     snprintf(boundary, sizeof(boundary), "%s=_%ld=_%ld=_%ld",
              config_servername, (long) p, (long) t, (long) rand());
 
-    fprintf(sm, "Content-Type: multipart/mixed;"
+    buf_printf(&msgbuf, "Content-Type: multipart/mixed;"
             "\r\n\tboundary=\"%s_M\"\r\n", boundary);
 
-    fprintf(sm, "iMIP-Content-ID: <%s@%s>\r\n", uid, config_servername);
+    buf_printf(&msgbuf, "iMIP-Content-ID: <%s@%s>\r\n", uid, config_servername);
 
-    fputs("Auto-Submitted: auto-generated\r\n", sm);
-    fputs("MIME-Version: 1.0\r\n", sm);
-    fputs("\r\n", sm);
+    buf_appendcstr(&msgbuf, "Auto-Submitted: auto-generated\r\n");
+    buf_appendcstr(&msgbuf, "MIME-Version: 1.0\r\n");
+    buf_appendcstr(&msgbuf, "\r\n");
 
     /* preamble */
-    fputs("This is a message with multiple parts in MIME format.\r\n", sm);
+    buf_appendcstr(&msgbuf, "This is a message with multiple parts in MIME format.\r\n");
 
     /* multipart/alternative */
-    fprintf(sm, "\r\n--%s_M\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_M\r\n", boundary);
 
-    fprintf(sm, "Content-Type: multipart/alternative;"
+    buf_printf(&msgbuf, "Content-Type: multipart/alternative;"
             "\r\n\tboundary=\"%s_A\"\r\n", boundary);
 
     /* plain text part */
-    fprintf(sm, "\r\n--%s_A\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_A\r\n", boundary);
 
-    fputs("Content-Type: text/plain; charset=utf-8\r\n", sm);
-    fputs("Content-Disposition: inline\r\n", sm);
+    buf_appendcstr(&msgbuf, "Content-Type: text/plain; charset=utf-8\r\n");
+    buf_appendcstr(&msgbuf, "Content-Disposition: inline\r\n");
 
     buf_printf(&plainbuf, "You have received %s from %s <%s>\r\n\r\n", msg_type,
                originator->name ? originator->name : "", originator->addr);
@@ -470,25 +416,25 @@ static int imip_send_sendmail(icalcompon
     }
 
     mimebody = charset_qpencode_mimebody(buf_base(&plainbuf),
-                                         buf_len(&plainbuf), &outlen);
+                                         buf_len(&plainbuf), 0, &outlen);
 
     if (outlen > buf_len(&plainbuf)) {
-        fputs("Content-Transfer-Encoding: quoted-printable\r\n", sm);
+        buf_appendcstr(&msgbuf, "Content-Transfer-Encoding: quoted-printable\r\n");
     }
-    fputs("\r\n", sm);
+    buf_appendcstr(&msgbuf, "\r\n");
 
-    fwrite(mimebody, outlen, 1, sm);
+    buf_appendmap(&msgbuf, mimebody, outlen);
     free(mimebody);
     buf_free(&plainbuf);
 
     /* HTML part */
-    fprintf(sm, "\r\n--%s_A\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_A\r\n", boundary);
 
-    fprintf(sm, "Content-Type: text/html; charset=utf-8\r\n");
-    fputs("Content-Disposition: inline\r\n", sm);
-    fputs("\r\n", sm);
+    buf_printf(&msgbuf, "Content-Type: text/html; charset=utf-8\r\n");
+    buf_appendcstr(&msgbuf, "Content-Disposition: inline\r\n");
+    buf_appendcstr(&msgbuf, "\r\n");
 
-    fputs(HTML_DOCTYPE "\r\n<html><head><title></title></head><body>\r\n", sm);
+    buf_appendcstr(&msgbuf, HTML_DOCTYPE "\r\n<html><head><title></title></head><body>\r\n");
 
     if (originator->name) {
         HTMLencode(&tmpbuf, originator->name);
@@ -496,28 +442,28 @@ static int imip_send_sendmail(icalcompon
     }
     else originator->name = originator->addr;
 
-    fprintf(sm, "<b>You have received %s from"
+    buf_printf(&msgbuf, "<b>You have received %s from"
             " <a href=\"mailto:%s\">%s</a></b><p>\r\n",
             msg_type, originator->addr, originator->name);
 
-    fputs("<table border cellpadding=5>\r\n", sm);
+    buf_appendcstr(&msgbuf, "<table border cellpadding=5>\r\n");
     if (summary) {
         HTMLencode(&tmpbuf, summary);
-        fprintf(sm, HTML_ROW, "Summary", buf_cstring(&tmpbuf));
+        buf_printf(&msgbuf, HTML_ROW, "Summary", buf_cstring(&tmpbuf));
     }
     if (location) {
         HTMLencode(&tmpbuf, location);
-        fprintf(sm, HTML_ROW, "Location", buf_cstring(&tmpbuf));
+        buf_printf(&msgbuf, HTML_ROW, "Location", buf_cstring(&tmpbuf));
     }
-    fprintf(sm, HTML_ROW, "When", when);
+    buf_printf(&msgbuf, HTML_ROW, "When", when);
     if (meth == ICAL_METHOD_REPLY) {
         if (originator->partstat)
-            fprintf(sm, HTML_ROW, "RSVP", originator->partstat);
+            buf_printf(&msgbuf, HTML_ROW, "RSVP", originator->partstat);
     }
     else {
-        if (status) fprintf(sm, HTML_ROW, "Status", status);
+        if (status) buf_printf(&msgbuf, HTML_ROW, "Status", status);
 
-        fputs("<tr><td><b>Attendees</b></td>", sm);
+        buf_appendcstr(&msgbuf, "<tr><td><b>Attendees</b></td>");
         for (cp = "<td>", recip = recipients; recip; recip = recip->next) {
             if (recip->name) {
                 HTMLencode(&tmpbuf, recip->name);
@@ -525,74 +471,100 @@ static int imip_send_sendmail(icalcompon
             }
             else recip->name = recip->addr;
 
-            fprintf(sm, "%s&#8226; <a href=\"mailto:%s\">%s</a>",
+            buf_printf(&msgbuf, "%s&#8226; <a href=\"mailto:%s\">%s</a>",
                     cp, recip->addr, recip->name);
-            if (recip->role) fprintf(sm, " <i>(%s)</i>", recip->role);
+            if (recip->role) buf_printf(&msgbuf, " <i>(%s)</i>", recip->role);
 
             cp = "\n  <br>";
         }
-        fputs("</td></tr>\r\n", sm);
+        buf_appendcstr(&msgbuf, "</td></tr>\r\n");
 
         if (descrip) {
             HTMLencode(&tmpbuf, descrip);
-            fprintf(sm, HTML_ROW, "Description", buf_cstring(&tmpbuf));
+            buf_printf(&msgbuf, HTML_ROW, "Description", buf_cstring(&tmpbuf));
         }
     }
-    fprintf(sm, "</table></body></html>\r\n");
+    buf_printf(&msgbuf, "</table></body></html>\r\n");
 
     /* iCalendar part */
-    fprintf(sm, "\r\n--%s_A\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_A\r\n", boundary);
 
-    fprintf(sm, "Content-Type: text/calendar; charset=utf-8");
-    fprintf(sm, "; method=%s; component=%s \r\n",
+    buf_printf(&msgbuf, "Content-Type: text/calendar; charset=utf-8");
+    buf_printf(&msgbuf, "; method=%s; component=%s \r\n",
             icalproperty_method_to_string(meth),
             icalcomponent_kind_to_string(kind));
 
-    fprintf(sm, "Content-ID: <%s@%s>\r\n", uid, config_servername);
+    buf_printf(&msgbuf, "Content-ID: <%s@%s>\r\n", uid, config_servername);
 
     ical_str = icalcomponent_as_ical_string(ical);
-    mimebody = charset_qpencode_mimebody(ical_str, strlen(ical_str), &outlen);
+    mimebody = charset_qpencode_mimebody(ical_str, strlen(ical_str), 0, &outlen);
 
     if (outlen > strlen(ical_str)) {
-        fputs("Content-Transfer-Encoding: quoted-printable\r\n", sm);
+        buf_appendcstr(&msgbuf, "Content-Transfer-Encoding: quoted-printable\r\n");
     }
-    fputs("\r\n", sm);
+    buf_appendcstr(&msgbuf, "\r\n");
 
-    fwrite(mimebody, outlen, 1, sm);
+    buf_appendmap(&msgbuf, mimebody, outlen);
     free(mimebody);
 
     /* end boundary (alternative) */
-    fprintf(sm, "\r\n--%s_A--\r\n", boundary);
-
+    buf_printf(&msgbuf, "\r\n--%s_A--\r\n", boundary);
 
     /* application/ics part */
-    fprintf(sm, "\r\n--%s_M\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_M\r\n", boundary);
 
-    fprintf(sm,
+    buf_printf(&msgbuf,
             "Content-Type: application/ics; charset=utf-8; name=\"%s.ics\"\r\n",
             filename);
-    fprintf(sm, "Content-Disposition: attachment; filename=\"%s.ics\"\r\n",
+    buf_printf(&msgbuf, "Content-Disposition: attachment; filename=\"%s.ics\"\r\n",
             filename);
-    fputs("Content-Transfer-Encoding: base64\r\n", sm);
-    fputs("\r\n", sm);
+    buf_appendcstr(&msgbuf, "Content-Transfer-Encoding: base64\r\n");
+    buf_appendcstr(&msgbuf, "\r\n");
 
-    charset_encode_mimebody(NULL, strlen(ical_str), NULL, &outlen, NULL);
+    charset_encode_mimebody(NULL, strlen(ical_str), NULL, &outlen,
+                            NULL, 1 /* wrap */);
     buf_ensure(&tmpbuf, outlen);
     charset_encode_mimebody(ical_str, strlen(ical_str),
-                            (char *) buf_base(&tmpbuf), &outlen, NULL);
-    fwrite(buf_base(&tmpbuf), outlen, 1, sm);
+                            (char *) buf_base(&tmpbuf), &outlen,
+                            NULL, 1 /* wrap */);
+    buf_appendmap(&msgbuf, buf_base(&tmpbuf), outlen);
 
     /* end boundary (mixed) and epilogue */
-    fprintf(sm, "\r\n--%s_M--\r\n\r\nEnd of MIME multipart body.\r\n", boundary);
+    buf_printf(&msgbuf, "\r\n--%s_M--\r\n\r\nEnd of MIME multipart body.\r\n", boundary);
 
-    fclose(sm);
+    /* Open SMTP connection */
+    smtpclient_t *sm = NULL;
+    r = smtpclient_open(&sm);
+    if (r) {
+        syslog(LOG_ERR,
+               "imip_send_sendmail(%s): failed to open SMTP client", recipient);
+        r = HTTP_UNAVAILABLE;
+        goto done;
+    }
+    smtpclient_set_auth(sm, httpd_userid);
+    smtpclient_set_notify(sm, "FAILURE,DELAY");
 
-    while (waitpid(sm_pid, &r, 0) < 0);
+    /* Set SMTP envelope */
+    smtp_envelope_t sm_env = SMTP_ENVELOPE_INITIALIZER;
+    smtp_envelope_set_from(&sm_env, originator->addr);
+    for (recip = recipients; recip; recip = recip->next) {
+        if (strcmp(recip->addr, originator->addr) &&
+            (!recipient || !strcasecmp(recip->addr, recipient))) {
+            smtp_envelope_add_rcpt(&sm_env, recip->addr);
+        }
+    }
 
+    /* Send message */
+    r = smtpclient_send(sm, &sm_env, &msgbuf);
     syslog(LOG_INFO,
-           "imip_send_sendmail(%s): %s", recipient, sendmail_errstr(r));
+           "imip_send_sendmail(%s): %s", recipient, error_message(r));
+    smtp_envelope_fini(&sm_env);
+
+    int r2 = smtpclient_close(&sm);
+    if (!r) r = r2;
 
   done:
+    buf_free(&msgbuf);
     buf_free(&tmpbuf);
     free(originator->qpname);
     free(originator);
@@ -608,21 +580,57 @@ static int imip_send_sendmail(icalcompon
 
 
 /* Send an iMIP request for attendees in 'ical' */
-static int imip_send(icalcomponent *ical, const char *recipient, unsigned is_update)
+static int imip_send(struct sched_data *sched_data,
+                     const char *sender, const char *recipient)
 {
     const char *notifier = config_getstring(IMAPOPT_IMIPNOTIFIER);
 
     syslog(LOG_DEBUG, "imip_send(%s)", recipient);
 
     /* if no notifier, fall back to sendmail */
-    if (!notifier) return imip_send_sendmail(ical, recipient, is_update);
+    if (!notifier) {
+        return imip_send_sendmail(sched_data->itip,
+                                  sender, recipient, sched_data->is_update);
+    }
+
+    const char *ical_str = icalcomponent_as_ical_string(sched_data->itip);
+    json_t *jsevent, *patch;
+
+#ifdef WITH_JMAP
+    if (sched_data->oldical) {
+        jsevent = jmapical_tojmap(sched_data->oldical, NULL);
 
-    const char *ical_str = icalcomponent_as_ical_string(ical);
-    json_t *val = json_pack("{s:s s:s s:b}",
+        if (sched_data->newical) {
+            /* Updated event */
+            json_t *new_jsevent = jmapical_tojmap(sched_data->newical, NULL);
+
+            patch = jmap_patchobject_create(jsevent, new_jsevent);
+            json_decref(new_jsevent);
+        }
+        else {
+            /* Canceled event */
+            patch = json_null();
+        }
+    }
+    else {
+        /* New event */
+        jsevent = json_null();
+        patch = jmapical_tojmap(sched_data->newical, NULL);
+    }
+#else
+    jsevent = json_null();
+    patch = json_null();
+#endif
+
+    json_t *val = json_pack("{s:s s:s s:s s:o s:o s:b}",
                             "recipient", recipient,
+                            "sender", sender,
                             "ical", ical_str,
-                            "is_update", is_update);
+                            "jsevent", jsevent,
+                            "patch", patch,
+                            "is_update", sched_data->is_update);
     char *serial = json_dumps(val, JSON_COMPACT);
+    // XXX: should we be replacing httpd_userid with sender?
     notify(notifier, "IMIP", NULL, httpd_userid, NULL, 0, NULL, serial, NULL);
     free(serial);
     json_decref(val);
@@ -669,6 +677,9 @@ static void busytime_query_remote(const
     const char *status = NULL;
     int r;
 
+    syslog(LOG_DEBUG, "busytime_query_remote(server: '%s', flags: 0x%x)",
+           server, remote->flags);
+
     comp = icalcomponent_get_first_real_component(rrock->ical);
 
     /* Add the attendees to the iTIP request */
@@ -739,7 +750,7 @@ static void busytime_query_remote(const
         }
     }
 
-    /* Report request-status (if necesary)
+    /* Report request-status (if necessary)
      * Remove the attendees from the iTIP request and hash bucket
      */
     for (list = remote->props; list; list = list->next) {
@@ -760,18 +771,13 @@ static void busytime_query_remote(const
 }
 
 
-static void free_sched_param_props(void *data)
+static void sched_param_cleanup(void *data)
 {
-    struct caldav_sched_param *sched_param = (struct caldav_sched_param *) data;
-
-    if (sched_param) {
-        struct proplist *prop, *next;
+    struct caldav_sched_param *sparam = (struct caldav_sched_param *) data;
 
-        for (prop = sched_param->props; prop; prop = next) {
-            next = prop->next;
-            free(prop);
-        }
-        free(sched_param);
+    if (sparam) {
+        sched_param_fini(sparam);
+        free(sparam);
     }
 }
 
@@ -784,7 +790,6 @@ int sched_busytime_query(struct transact
     int ret = 0;
     static const char *calendarprefix = NULL;
     icalcomponent *comp;
-    char mailboxname[MAX_MAILBOX_BUFFER];
     icalproperty *prop = NULL, *next;
     const char *uid = NULL, *organizer = NULL;
     struct caldav_sched_param sparam;
@@ -807,7 +812,7 @@ int sched_busytime_query(struct transact
     organizer = icalproperty_get_organizer(prop);
 
     /* XXX  Do we need to do more checks here? */
-    if (caladdress_lookup(organizer, &sparam, httpd_userid) ||
+    if (caladdress_lookup(organizer, &sparam, NULL) ||
         (sparam.flags & SCHEDTYPE_REMOTE))
         org_authstate = auth_newstate("anonymous");
     else
@@ -861,7 +866,7 @@ int sched_busytime_query(struct transact
 
         /* Is attendee remote or local? */
         attendee = icalproperty_get_attendee(prop);
-        r = caladdress_lookup(attendee, &sparam, httpd_userid);
+        r = caladdress_lookup(attendee, &sparam, NULL);
 
         /* Don't allow scheduling of remote users via an iSchedule request */
         if ((sparam.flags & SCHEDTYPE_REMOTE) &&
@@ -910,6 +915,8 @@ int sched_busytime_query(struct transact
             xmlNodePtr resp;
             const char *userid = sparam.userid;
             icalcomponent *busy = NULL;
+            mbentry_t *mbentry = NULL;
+            const char *status = REQSTAT_NOUSER;
 
             resp =
                 xml_add_schedresponse(root,
@@ -917,30 +924,32 @@ int sched_busytime_query(struct transact
                                       ns[NS_DAV] : NULL,
                                       BAD_CAST attendee, NULL);
 
-            /* XXX - BROKEN WITH DOMAIN SPLIT, POS */
             /* Check ACL of ORGANIZER on attendee's Scheduling Inbox */
-            snprintf(mailboxname, sizeof(mailboxname),
-                     "user.%s.%s.Inbox", userid, calendarprefix);
+            char *inboxname = caldav_mboxname(userid, SCHED_INBOX);
 
-            r = mboxlist_lookup(mailboxname, NULL, NULL);
+            r = mboxlist_lookup(inboxname, &mbentry, NULL);
             if (r) {
                 syslog(LOG_INFO, "mboxlist_lookup(%s) failed: %s",
-                       mailboxname, error_message(r));
-                xmlNewChild(resp, NULL, BAD_CAST "request-status",
-                            BAD_CAST REQSTAT_REJECTED);
+                       inboxname, error_message(r));
+                status = REQSTAT_REJECTED;
+            }
+            else if (!(httpd_myrights(org_authstate, mbentry) & DACL_SCHEDFB)) {
+                status = REQSTAT_NOPRIVS;
             }
             else {
                 /* Start query at attendee's calendar-home-set */
-                snprintf(mailboxname, sizeof(mailboxname),
-                         "user.%s.%s", userid, calendarprefix);
+                char *mboxname = caldav_mboxname(userid, NULL);
 
                 fctx.davdb = NULL;
                 fctx.req_tgt->collection = NULL;
                 calfilter.freebusy.len = 0;
-                busy = busytime_query_local(txn, &fctx, mailboxname,
+                busy = busytime_query_local(txn, &fctx, mboxname,
                                             ICAL_METHOD_REPLY, uid,
                                             organizer, attendee);
+                free(mboxname);
             }
+            mboxlist_entry_free(&mbentry);
+            free(inboxname);
 
             if (busy) {
                 xmlNodePtr cdata;
@@ -977,7 +986,7 @@ int sched_busytime_query(struct transact
             }
             else {
                 xmlNewChild(resp, NULL, BAD_CAST "request-status",
-                            BAD_CAST REQSTAT_NOUSER);
+                            BAD_CAST status);
             }
 
             icalproperty_free(prop);
@@ -990,7 +999,7 @@ int sched_busytime_query(struct transact
         struct remote_rock rrock = { txn, ical, root, ns };
         hash_enumerate(&remote_table, busytime_query_remote, &rrock);
     }
-    free_hash_table(&remote_table, free_sched_param_props);
+    free_hash_table(&remote_table, sched_param_cleanup);
 
     /* Output the XML response */
     if (!ret) xml_response(HTTP_OK, txn, root->doc);
@@ -1017,7 +1026,7 @@ int sched_busytime_query(struct transact
 #define SCHEDSTAT_REJECTED      "5.3"
 
 /* Deliver scheduling object to a remote recipient */
-static void sched_deliver_remote(const char *recipient,
+static void sched_deliver_remote(const char *sender, const char *recipient,
                                  struct caldav_sched_param *sparam,
                                  struct sched_data *sched_data)
 {
@@ -1080,7 +1089,7 @@ static void sched_deliver_remote(const c
         }
     }
     else {
-        r = imip_send(sched_data->itip, recipient, sched_data->is_update);
+        r = imip_send(sched_data, sender, recipient);
         if (!r) {
             sched_data->status =
                 sched_data->ischedule ? REQSTAT_SENT : SCHEDSTAT_SENT;
@@ -1093,7 +1102,6 @@ static void sched_deliver_remote(const c
 }
 
 
-#ifdef HAVE_VPOLL
 /*
  * deliver_merge_reply() helper function
  *
@@ -1129,7 +1137,7 @@ static void deliver_merge_vpoll_reply(ic
     }
 
     /* XXX  Actually need to compare POLL-ITEM-IDs */
-    icalcomponent_add_component(ical, icalcomponent_new_clone(new_ballot));
+    icalcomponent_add_component(ical, icalcomponent_clone(new_ballot));
 }
 
 
@@ -1191,7 +1199,7 @@ static int deliver_merge_pollstatus(ical
          vvoter =
              icalcomponent_get_next_component(newpoll, ICAL_VVOTER_COMPONENT)) {
 
-        icalcomponent_add_component(oldpoll, icalcomponent_new_clone(vvoter));
+        icalcomponent_add_component(oldpoll, icalcomponent_clone(vvoter));
     }
 
     return deliver_inbox;
@@ -1225,7 +1233,7 @@ static void sched_pollstatus(const char
 
     /* Copy over any CALSCALE property */
     prop = icalcomponent_get_first_property(ical, ICAL_CALSCALE_PROPERTY);
-    if (prop) icalcomponent_add_property(itip, icalproperty_new_clone(prop));
+    if (prop) icalcomponent_add_property(itip, icalproperty_clone(prop));
 
     /* Process each VPOLL in resource */
     for (comp = icalcomponent_get_first_component(ical, ICAL_VPOLL_COMPONENT);
@@ -1236,10 +1244,10 @@ static void sched_pollstatus(const char
         struct strlist *voters = NULL;
 
         /* Make a working copy of the iTIP */
-        stat = icalcomponent_new_clone(itip);
+        stat = icalcomponent_clone(itip);
 
         /* Make a working copy of the VPOLL and add to pollstatus */
-        poll = icalcomponent_new_clone(comp);
+        poll = icalcomponent_clone(comp);
         icalcomponent_add_component(stat, poll);
 
         /* Process each sub-component of VPOLL */
@@ -1278,7 +1286,7 @@ static void sched_pollstatus(const char
             struct strlist *next = voters->next;
 
             sched_data.itip = stat;
-            sched_deliver(voters->s, &sched_data, authstate);
+            sched_deliver(organizer, voters->s, &sched_data, authstate);
 
             free(voters->s);
             free(voters);
@@ -1291,34 +1299,6 @@ static void sched_pollstatus(const char
     icalcomponent_free(itip);
     auth_freestate(authstate);
 }
-#else  /* HAVE_VPOLL */
-static void
-deliver_merge_vpoll_reply(icalcomponent *ical __attribute__((unused)),
-                          icalcomponent *reply __attribute__((unused)))
-{
-    return;
-}
-
-static void sched_vpoll_reply(icalcomponent *poll __attribute__((unused)))
-{
-    return;
-}
-
-static int
-deliver_merge_pollstatus(icalcomponent *ical __attribute__((unused)),
-                         icalcomponent *request __attribute__((unused)))
-{
-    return 0;
-}
-
-static void sched_pollstatus(const char *organizer __attribute__((unused)),
-                             struct caldav_sched_param *sparam __attribute__((unused)),
-                             icalcomponent *ical __attribute__((unused)),
-                             const char *voter __attribute__((unused)))
-{
-    return;
-}
-#endif  /* HAVE_VPOLL */
 
 /* annoying copypaste from libical because it's not exposed */
 static struct icaltimetype _get_datetime(icalcomponent *comp, icalproperty *prop)
@@ -1357,7 +1337,7 @@ static icalcomponent *master_to_recurren
     icalproperty *endprop = NULL;
     icalproperty *startprop = NULL;
 
-    icalcomponent *comp = icalcomponent_new_clone(master);
+    icalcomponent *comp = icalcomponent_clone(master);
 
     for (prop = icalcomponent_get_first_property(comp, ICAL_ANY_PROPERTY);
          prop; prop = next) {
@@ -1387,7 +1367,7 @@ static icalcomponent *master_to_recurren
     }
 
     /* Add RECURRENCE-ID */
-    icalcomponent_add_property(comp, icalproperty_new_clone(recurid));
+    icalcomponent_add_property(comp, icalproperty_clone(recurid));
 
     /* calculate a new dtend based on recurid */
     struct icaltimetype start = _get_datetime(master, startprop);
@@ -1466,7 +1446,7 @@ static const char *deliver_merge_reply(i
             prop =
                 icalcomponent_get_first_property(itip, ICAL_DTSTART_PROPERTY);
             if (prop)
-                icalcomponent_add_property(comp, icalproperty_new_clone(prop));
+                icalcomponent_add_property(comp, icalproperty_clone(prop));
 
             prop =
                 icalcomponent_get_first_property(comp, ICAL_DTEND_PROPERTY);
@@ -1477,7 +1457,7 @@ static const char *deliver_merge_reply(i
             prop =
                 icalcomponent_get_first_property(itip, ICAL_DTEND_PROPERTY);
             if (prop)
-                icalcomponent_add_property(comp, icalproperty_new_clone(prop));
+                icalcomponent_add_property(comp, icalproperty_clone(prop));
 
             prop =
                 icalcomponent_get_first_property(comp, ICAL_SEQUENCE_PROPERTY);
@@ -1488,7 +1468,7 @@ static const char *deliver_merge_reply(i
             prop =
                 icalcomponent_get_first_property(itip, ICAL_SEQUENCE_PROPERTY);
             if (prop)
-                icalcomponent_add_property(comp, icalproperty_new_clone(prop));
+                icalcomponent_add_property(comp, icalproperty_clone(prop));
 
             icalcomponent_add_component(ical, comp);
         }
@@ -1515,7 +1495,7 @@ static const char *deliver_merge_reply(i
         if (!prop) {
             /* Attendee added themselves to this recurrence */
             assert(icalproperty_isa(prop) != ICAL_VOTER_PROPERTY);
-            prop = icalproperty_new_clone(att);
+            prop = icalproperty_clone(att);
             icalcomponent_add_property(comp, prop);
         }
 
@@ -1566,6 +1546,7 @@ static int deliver_merge_request(const c
              icalcomponent_get_next_component(ical, ICAL_VTIMEZONE_COMPONENT)) {
         prop = icalcomponent_get_first_property(comp, ICAL_TZID_PROPERTY);
         tzid = icalproperty_get_tzid(prop);
+        if (!tzid) continue;
 
         hash_insert(tzid, comp, &comp_table);
     }
@@ -1579,6 +1560,7 @@ static int deliver_merge_request(const c
         /* Lookup this TZID in the hash table */
         prop = icalcomponent_get_first_property(itip, ICAL_TZID_PROPERTY);
         tzid = icalproperty_get_tzid(prop);
+        if (!tzid) continue;
 
         comp = hash_lookup(tzid, &comp_table);
         if (comp) {
@@ -1588,7 +1570,7 @@ static int deliver_merge_request(const c
         }
 
         /* Add new/modified component from iTIP request */
-        icalcomponent_add_component(ical, icalcomponent_new_clone(itip));
+        icalcomponent_add_component(ical, icalcomponent_clone(itip));
     }
 
     free_hash_table(&comp_table, NULL);
@@ -1613,7 +1595,7 @@ static int deliver_merge_request(const c
     itip = icalcomponent_get_first_real_component(request);
     if (kind == ICAL_NO_COMPONENT) kind = icalcomponent_isa(itip);
     for (; itip; itip = icalcomponent_get_next_component(request, kind)) {
-        icalcomponent *new_comp = icalcomponent_new_clone(itip);
+        icalcomponent *new_comp = icalcomponent_clone(itip);
 
         /* Lookup this comp in the hash table */
         prop =
@@ -1639,20 +1621,20 @@ static int deliver_merge_request(const c
                 icalcomponent_get_first_property(comp, ICAL_COMPLETED_PROPERTY);
             if (prop) {
                 icalcomponent_add_property(new_comp,
-                                           icalproperty_new_clone(prop));
+                                           icalproperty_clone(prop));
             }
             prop =
                 icalcomponent_get_first_property(comp,
                                                  ICAL_PERCENTCOMPLETE_PROPERTY);
             if (prop) {
                 icalcomponent_add_property(new_comp,
-                                           icalproperty_new_clone(prop));
+                                           icalproperty_clone(prop));
             }
             prop =
                 icalcomponent_get_first_property(comp, ICAL_TRANSP_PROPERTY);
             if (prop) {
                 icalcomponent_add_property(new_comp,
-                                           icalproperty_new_clone(prop));
+                                           icalproperty_clone(prop));
             }
 
             /* Copy over any ORGANIZER;SCHEDULE-STATUS */
@@ -1661,7 +1643,7 @@ static int deliver_merge_request(const c
                 icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
             param = icalproperty_get_schedulestatus_parameter(prop);
             if (param) {
-                param = icalparameter_new_clone(param);
+                param = icalparameter_clone(param);
                 prop =
                     icalcomponent_get_first_property(new_comp,
                                                      ICAL_ORGANIZER_PROPERTY);
@@ -1716,7 +1698,7 @@ static int deliver_merge_request(const c
 
 
 /* Deliver scheduling object to local recipient */
-static void sched_deliver_local(const char *recipient,
+static void sched_deliver_local(const char *sender, const char *recipient,
                                 struct caldav_sched_param *sparam,
                                 struct sched_data *sched_data,
                                 struct auth_state *authstate)
@@ -1724,8 +1706,7 @@ static void sched_deliver_local(const ch
     int r = 0, rights, reqd_privs, deliver_inbox = 1;
     const char *userid = sparam->userid, *attendee = NULL;
     static struct buf resource = BUF_INITIALIZER;
-    static unsigned sched_count = 0;
-    const char *mailboxname = NULL;
+    char *mailboxname = NULL;
     mbentry_t *mbentry = NULL;
     struct mailbox *mailbox = NULL, *inbox = NULL;
     struct caldav_db *caldavdb = NULL;
@@ -1737,7 +1718,7 @@ static void sched_deliver_local(const ch
     icalproperty *prop;
     struct transaction_t txn;
 
-    syslog(LOG_DEBUG, "sched_deliver_local(%s, %X)", recipient, sparam->flags);
+    syslog(LOG_DEBUG, "sched_deliver_local(%s, %s, %X)", sender, recipient, sparam->flags);
 
     /* Start with an empty (clean) transaction */
     memset(&txn, 0, sizeof(struct transaction_t));
@@ -1773,6 +1754,7 @@ static void sched_deliver_local(const ch
             sched_data->ischedule ? REQSTAT_TEMPFAIL : SCHEDSTAT_TEMPFAIL;
         goto done;
     }
+    free(mailboxname);
 
     /* Get METHOD of the iTIP message */
     method = icalcomponent_get_method(sched_data->itip);
@@ -1789,7 +1771,7 @@ static void sched_deliver_local(const ch
                       icalcomponent_get_uid(sched_data->itip), &cdata);
 
     if (cdata->dav.mailbox) {
-        mailboxname = cdata->dav.mailbox;
+        mailboxname = xstrdup(cdata->dav.mailbox);
         buf_setcstr(&resource, cdata->dav.resource);
     }
     else if (sched_data->is_reply) {
@@ -1818,19 +1800,19 @@ static void sched_deliver_local(const ch
         /* Copy over VERSION property */
         prop = icalcomponent_get_first_property(sched_data->itip,
                                                 ICAL_VERSION_PROPERTY);
-        icalcomponent_add_property(ical, icalproperty_new_clone(prop));
+        icalcomponent_add_property(ical, icalproperty_clone(prop));
 
         /* Copy over PRODID property */
         prop = icalcomponent_get_first_property(sched_data->itip,
                                                 ICAL_PRODID_PROPERTY);
-        icalcomponent_add_property(ical, icalproperty_new_clone(prop));
+        icalcomponent_add_property(ical, icalproperty_clone(prop));
 
         /* Copy over any CALSCALE property */
         prop = icalcomponent_get_first_property(sched_data->itip,
                                                 ICAL_CALSCALE_PROPERTY);
         if (prop) {
             icalcomponent_add_property(ical,
-                                       icalproperty_new_clone(prop));
+                                       icalproperty_clone(prop));
         }
     }
 
@@ -1845,11 +1827,8 @@ static void sched_deliver_local(const ch
     }
 
     if (cdata->dav.imap_uid) {
-        struct index_record record;
-
         /* Load message containing the resource and parse iCal data */
-        r = mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record);
-        ical = record_to_ical(mailbox, &record, NULL);
+        ical = caldav_record_to_ical(mailbox, cdata, NULL, NULL);
 
         for (comp = icalcomponent_get_first_component(sched_data->itip,
                                                       ICAL_ANY_COMPONENT);
@@ -1875,11 +1854,9 @@ static void sched_deliver_local(const ch
             case ICAL_VAVAILABILITY_COMPONENT:
                 if (cdata->comp_type != CAL_COMP_VAVAILABILITY) reject = 1;
                 break;
-#ifdef HAVE_VPOLL
             case ICAL_VPOLL_COMPONENT:
                 if (cdata->comp_type != CAL_COMP_VPOLL) reject = 1;
                 break;
-#endif
             default:
                 break;
             }
@@ -1950,9 +1927,12 @@ static void sched_deliver_local(const ch
     if (!txn.req_hdrs) r = HTTP_SERVER_ERROR;
 
     /* Store the (updated) object in the recipients's calendar */
+    strarray_t recipient_addresses = STRARRAY_INITIALIZER;
+    strarray_append(&recipient_addresses, recipient);
     if (!r) r = caldav_store_resource(&txn, ical, mailbox,
-                                      buf_cstring(&resource), caldavdb, NEW_STAG,
-                                      recipient);
+                                      buf_cstring(&resource), cdata->dav.createdmodseq,
+                                      caldavdb, NEW_STAG, recipient, &recipient_addresses);
+    strarray_fini(&recipient_addresses);
 
     if (r == HTTP_CREATED || r == HTTP_NO_CONTENT) {
         sched_data->status =
@@ -1970,13 +1950,11 @@ static void sched_deliver_local(const ch
     if (deliver_inbox) {
         /* Create a name for the new iTIP message resource */
         buf_reset(&resource);
-        buf_printf(&resource, "%x-%d-%ld-%u.ics",
-                   strhash(icalcomponent_get_uid(sched_data->itip)), getpid(),
-                   time(0), sched_count++);
+        buf_printf(&resource, "%s.ics", makeuuid());
 
         /* Store the message in the recipient's Inbox */
         r = caldav_store_resource(&txn, sched_data->itip, inbox,
-                                  buf_cstring(&resource), caldavdb, 0, NULL);
+                                  buf_cstring(&resource), 0, caldavdb, 0, NULL, NULL);
         /* XXX  What do we do if storing to Inbox fails? */
     }
 
@@ -1987,7 +1965,7 @@ static void sched_deliver_local(const ch
         if (icalcomponent_isa(comp) == ICAL_VPOLL_COMPONENT)
             sched_pollstatus(recipient, sparam, ical, attendee);
         else
-            sched_request(userid, userid, NULL, ical); // oldical?
+            sched_request(userid, NULL, recipient, NULL, ical); // oldical?
     }
 
   done:
@@ -1997,11 +1975,12 @@ static void sched_deliver_local(const ch
     if (caldavdb) caldav_close(caldavdb);
     spool_free_hdrcache(txn.req_hdrs);
     buf_free(&txn.buf);
+    free(mailboxname);
 }
 
 
 /* Deliver scheduling object to recipient's Inbox */
-void sched_deliver(const char *recipient, void *data, void *rock)
+void sched_deliver(const char *sender, const char *recipient, void *data, void *rock)
 {
     struct sched_data *sched_data = (struct sched_data *) data;
     struct auth_state *authstate = (struct auth_state *) rock;
@@ -2010,6 +1989,8 @@ void sched_deliver(const char *recipient
 
     syslog(LOG_DEBUG, "sched_deliver(%s)", recipient);
 
+    memset(&sparam, 0, sizeof(struct caldav_sched_param));
+
     /* Check SCHEDULE-FORCE-SEND value */
     switch (sched_data->force_send) {
     case ICAL_SCHEDULEFORCESEND_NONE:
@@ -2034,26 +2015,33 @@ void sched_deliver(const char *recipient
         return;
     }
 
-    if (caladdress_lookup(recipient, &sparam, httpd_userid)) {
+    if (caladdress_lookup(recipient, &sparam, sched_data->schedule_addresses)) {
         sched_data->status =
             sched_data->ischedule ? REQSTAT_NOUSER : SCHEDSTAT_NOUSER;
         /* Unknown user */
-        return;
+        goto done;
     }
 
     /* don't schedule to yourself */
-    if (sparam.isyou) return;
+    if (sparam.isyou) goto done;
 
     if (sparam.flags) {
         /* Remote recipient */
-        sched_deliver_remote(recipient, &sparam, sched_data);
+        syslog(LOG_NOTICE, "%s scheduling delivery to %s",
+               (sparam.flags & SCHEDTYPE_ISCHEDULE) ? "iSchedule" : "iMIP",
+               recipient);
+
+        sched_deliver_remote(sender, recipient, &sparam, sched_data);
     }
     else {
         /* Local recipient */
-        sched_deliver_local(recipient, &sparam, sched_data, authstate);
+        syslog(LOG_NOTICE, "CalDAV scheduling delivery to %s", recipient);
+
+        sched_deliver_local(sender, recipient, &sparam, sched_data, authstate);
     }
 
-    sched_param_free(&sparam);
+done:
+    sched_param_fini(&sparam);
 }
 
 /*
@@ -2119,6 +2107,12 @@ static unsigned propcmp(icalcomponent *o
 
     if (!oldprop) return (newprop != NULL);
     else if (!newprop) return 1;
+    else if (kind == ICAL_DURATION_PROPERTY) {
+        struct icaldurationtype olddur = icalproperty_get_duration(oldprop);
+        struct icaldurationtype newdur = icalproperty_get_duration(newprop);
+
+        return (icaldurationtype_as_int(olddur) != icaldurationtype_as_int(newdur));
+    }
     else if ((kind == ICAL_RDATE_PROPERTY) || (kind == ICAL_EXDATE_PROPERTY)) {
         const char *str;
         uint32_t old_crc = 0, new_crc = 0;
@@ -2293,6 +2287,8 @@ static int check_changes_any(icalcompone
         is_changed = 1;
     else if (propcmp(old, comp, ICAL_DESCRIPTION_PROPERTY))
         is_changed = 1;
+    else if (propcmp(old, comp, ICAL_POLLWINNER_PROPERTY))
+        is_changed = 1;
     else if (partstat_changed(old, comp, get_organizer(comp)))
         is_changed = 1;
 
@@ -2335,7 +2331,7 @@ icalcomponent *make_itip(icalproperty_me
     icalproperty *prop =
         icalcomponent_get_first_property(ical, ICAL_CALSCALE_PROPERTY);
     if (prop) {
-        icalcomponent_add_property(req, icalproperty_new_clone(prop));
+        icalcomponent_add_property(req, icalproperty_clone(prop));
     }
 
     /* Copy over any VTIMEZONE components */
@@ -2343,7 +2339,7 @@ icalcomponent *make_itip(icalproperty_me
     for (comp = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
          comp;
          comp = icalcomponent_get_next_component(ical, ICAL_VTIMEZONE_COMPONENT)) {
-         icalcomponent_add_component(req, icalcomponent_new_clone(comp));
+         icalcomponent_add_component(req, icalcomponent_clone(comp));
     }
 
     return req;
@@ -2363,11 +2359,11 @@ static void schedule_set_exdate(icalcomp
     /* Copy any parameters from RECURRENCE-ID to EXDATE */
     param = icalproperty_get_first_parameter(recurid, ICAL_TZID_PARAMETER);
     if (param) {
-        icalproperty_add_parameter(exdate, icalparameter_new_clone(param));
+        icalproperty_add_parameter(exdate, icalparameter_clone(param));
     }
     param = icalproperty_get_first_parameter(recurid, ICAL_VALUE_PARAMETER);
     if (param) {
-        icalproperty_add_parameter(exdate, icalparameter_new_clone(param));
+        icalproperty_add_parameter(exdate, icalparameter_clone(param));
     }
 
     /* XXX  Need to handle RANGE parameter */
@@ -2410,17 +2406,58 @@ static void update_attendee_status(icalc
     }
 }
 
-static void schedule_full_cancel(const char *attendee, icalcomponent *mastercomp,
+static icaltimetype get_historical_cutoff()
+{
+    int age = config_getduration(IMAPOPT_CALDAV_HISTORICAL_AGE, 'd');
+    icaltimetype cutoff;
+
+    if (age < 0) return icaltime_null_time();
+
+    /* Set cutoff to current time -age days */
+    cutoff = icaltime_current_time_with_zone(icaltimezone_get_utc_timezone());
+    icaltime_adjust(&cutoff, 0, 0, 0, -age);
+
+    return cutoff;
+}
+
+static int icalcomponent_is_historical(icalcomponent *comp, icaltimetype cutoff)
+{
+    if (icaltime_is_null_time(cutoff)) return 0;
+
+    icalcomponent_kind kind = icalcomponent_isa(comp);
+    struct icalperiodtype span;
+
+    if (icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY)) {
+         /* span is just the span of the override */
+        span = icalcomponent_get_utc_timespan(comp, kind, NULL);
+    }
+    else {
+        /* span is entire span of the master */
+        icalcomponent *ical = icalcomponent_new_vcalendar();
+
+        icalcomponent_add_component(ical, icalcomponent_clone(comp));
+        span = icalrecurrenceset_get_utc_timespan(ical, kind, NULL, NULL, NULL, NULL);
+        icalcomponent_free(ical);
+    }
+
+    return (icaltime_compare(span.end, cutoff) < 0);
+}
+
+static void schedule_full_cancel(const strarray_t *schedule_addresses,
+                                 const char *organizer, const char *attendee,
+                                 icalcomponent *mastercomp, icaltimetype h_cutoff,
                                  icalcomponent *oldical, icalcomponent *newical)
 {
     /* we need to send a cancel for all recurrences with this attendee,
        and add exdates to the master for all without this attendee */
     icalcomponent *itip = make_itip(ICAL_METHOD_CANCEL, oldical);
 
-    icalcomponent *mastercopy = icalcomponent_new_clone(mastercomp);
+    icalcomponent *mastercopy = icalcomponent_clone(mastercomp);
     clean_component(mastercopy);
     icalcomponent_add_component(itip, mastercopy);
 
+    int do_send = !icalcomponent_is_historical(mastercopy, h_cutoff);
+
     icalcomponent *comp = icalcomponent_get_first_real_component(oldical);
     icalcomponent_kind kind = icalcomponent_isa(comp);
 
@@ -2440,20 +2477,27 @@ static void schedule_full_cancel(const c
             find_attended_component(newical, recurid, attendee);
         if (newcomp) continue; /* will be scheduled separately */
 
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
         clean_component(copy);
         icalcomponent_add_component(itip, copy);
+
+        if (!do_send && !icalcomponent_is_historical(copy, h_cutoff))
+            do_send = 1;
     }
 
-    struct sched_data sched =
-        { 0, 0, 0, itip, ICAL_SCHEDULEFORCESEND_NONE, NULL };
-    sched_deliver(attendee, &sched, httpd_authstate);
+    if (do_send) {
+        struct sched_data sched =
+            { 0, 0, 0, itip, oldical, newical, ICAL_SCHEDULEFORCESEND_NONE, schedule_addresses, NULL };
+        sched_deliver(organizer, attendee, &sched, httpd_authstate);
+    }
 
     icalcomponent_free(itip);
 }
 
 /* we've already tested that master does NOT contain this attendee */
-static void schedule_sub_cancels(const char *attendee,
+static void schedule_sub_cancels(const strarray_t *schedule_addresses,
+                                 const char *organizer, const char *attendee,
+                                 icaltimetype h_cutoff,
                                  icalcomponent *oldical, icalcomponent *newical)
 {
     if (!oldical) return;
@@ -2481,17 +2525,18 @@ static void schedule_sub_cancels(const c
         if (find_attended_component(newical, recurid, attendee))
             continue;
 
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
         clean_component(copy);
         icalcomponent_add_component(itip, copy);
 
-        do_send = 1;
+        if (!do_send && !icalcomponent_is_historical(copy, h_cutoff))
+            do_send = 1;
     }
 
     if (do_send) {
         struct sched_data sched =
-            { 0, 0, 0, itip, ICAL_SCHEDULEFORCESEND_NONE, NULL };
-        sched_deliver(attendee, &sched, httpd_authstate);
+            { 0, 0, 0, itip, oldical, newical, ICAL_SCHEDULEFORCESEND_NONE, schedule_addresses, NULL };
+        sched_deliver(organizer, attendee, &sched, httpd_authstate);
 
     }
 
@@ -2509,7 +2554,9 @@ icalparameter_scheduleforcesend get_forc
 
 /* we've already tested that master does NOT contain this attendee or that
  * master doesn't need to be scheduled */
-static void schedule_sub_updates(const char *attendee,
+static void schedule_sub_updates(const strarray_t *schedule_addresses,
+                                 const char *organizer, const char *attendee,
+                                 icaltimetype h_cutoff,
                                  icalcomponent *oldical, icalcomponent *newical)
 {
     if (!newical) return;
@@ -2554,7 +2601,7 @@ static void schedule_sub_updates(const c
             }
         }
 
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
         clean_component(copy);
 
         if (find_attendee(oldcomp, attendee))
@@ -2564,14 +2611,16 @@ static void schedule_sub_updates(const c
 
         strarray_add(&recurids, recurid);
 
-        do_send = 1;
+        if (!do_send && !icalcomponent_is_historical(copy, h_cutoff))
+            do_send = 1;
 
         if (freeme) icalcomponent_free(freeme);
     }
 
     if (do_send) {
-        struct sched_data sched = { 0, 0, is_update, itip, force_send, NULL };
-        sched_deliver(attendee, &sched, httpd_authstate);
+        struct sched_data sched =
+            { 0, 0, is_update, itip, oldical, newical, force_send, schedule_addresses, NULL };
+        sched_deliver(organizer, attendee, &sched, httpd_authstate);
         update_attendee_status(newical, &recurids, attendee, sched.status);
     }
 
@@ -2580,13 +2629,15 @@ static void schedule_sub_updates(const c
 }
 
 /* we've already tested that master does contain this attendee */
-static void schedule_full_update(const char *attendee, icalcomponent *mastercomp,
+static void schedule_full_update(const strarray_t *schedule_addresses,
+                                 const char *organizer, const char *attendee,
+                                 icalcomponent *mastercomp, icaltimetype h_cutoff,
                                  icalcomponent *oldical, icalcomponent *newical)
 {
     /* create an itip for the complete event */
     icalcomponent *itip = make_itip(ICAL_METHOD_REQUEST, newical);
 
-    icalcomponent *mastercopy = icalcomponent_new_clone(mastercomp);
+    icalcomponent *mastercopy = icalcomponent_clone(mastercomp);
     clean_component(mastercopy);
     icalcomponent_add_component(itip, mastercopy);
 
@@ -2596,8 +2647,13 @@ static void schedule_full_update(const c
     icalcomponent *oldmaster = find_attended_component(oldical, "", attendee);
     if (check_changes(oldmaster, mastercopy, attendee)) {
         /* we only force the send if the top level event has changed */
-        do_send = 1;
-        if (oldmaster) is_update = 1;
+        if (!icalcomponent_is_historical(mastercopy, h_cutoff)) do_send = 1;
+
+        if (oldmaster) {
+            is_update = 1;
+            if (!do_send && !icalcomponent_is_historical(oldmaster, h_cutoff))
+                do_send = 1;
+        }
     }
 
     icalproperty *masteratt = find_attendee(mastercomp, attendee);
@@ -2632,12 +2688,14 @@ static void schedule_full_update(const c
             schedule_set_exdate(mastercopy, comp);
 
             /* different from last time? */
-            if (!oldcomp || has_old) do_send = 1;
-
+            if ((!oldcomp || has_old) &&
+                !do_send && !icalcomponent_is_historical(comp, h_cutoff)) {
+                do_send = 1;
+            }
             continue;
         }
 
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
 
         /* we don't care if it's changed, just using this for the
          * side effect changes to RSVP */
@@ -2648,14 +2706,15 @@ static void schedule_full_update(const c
     }
 
     if (do_send) {
-        struct sched_data sched = { 0, 0, is_update, itip, force_send, NULL };
-        sched_deliver(attendee, &sched, httpd_authstate);
+        struct sched_data sched =
+            { 0, 0, is_update, itip, oldical, newical, force_send, schedule_addresses, NULL };
+        sched_deliver(organizer, attendee, &sched, httpd_authstate);
 
         update_attendee_status(newical, NULL, attendee, sched.status);
     }
     else {
         /* just look for sub updates */
-        schedule_sub_updates(attendee, oldical, newical);
+        schedule_sub_updates(schedule_addresses, organizer, attendee, h_cutoff, oldical, newical);
     }
 
     icalcomponent_free(itip);
@@ -2663,43 +2722,43 @@ static void schedule_full_update(const c
 
 /* sched_request() helper
  * handles scheduling for a single attendee */
-static void schedule_one_attendee(const char *attendee,
+static void schedule_one_attendee(const strarray_t *schedule_addresses,
+                                  const char *organizer, const char *attendee,
+                                  icaltimetype h_cutoff,
                                   icalcomponent *oldical, icalcomponent *newical)
 {
     /* case: this attendee is attending the master event */
     icalcomponent *mastercomp;
     if ((mastercomp = find_attended_component(newical, "", attendee))) {
-        schedule_full_update(attendee, mastercomp, oldical, newical);
+        schedule_full_update(schedule_addresses, organizer, attendee,
+                             mastercomp, h_cutoff, oldical, newical);
         return;
     }
 
     /* otherwise we need to cancel for each sub event and then we'll still
      * send the updates if any */
     if ((mastercomp = find_attended_component(oldical, "", attendee))) {
-        schedule_full_cancel(attendee, mastercomp, oldical, newical);
+        schedule_full_cancel(schedule_addresses, organizer, attendee, mastercomp, h_cutoff, oldical, newical);
     }
     else {
-        schedule_sub_cancels(attendee, oldical, newical);
+        schedule_sub_cancels(schedule_addresses, organizer, attendee, h_cutoff, oldical, newical);
     }
 
-    schedule_sub_updates(attendee, oldical, newical);
+    schedule_sub_updates(schedule_addresses, organizer, attendee, h_cutoff, oldical, newical);
 }
 
 
 /* Create and deliver an organizer scheduling request */
-void sched_request(const char *userid, const char *organizer,
+void sched_request(const char *asuserid, const strarray_t *schedule_addresses,
+                   const char *organizer,
                    icalcomponent *oldical, icalcomponent *newical)
 {
-    int r;
-
-    int rights = 0;
-    mbentry_t *mbentry = NULL;
     /* Check ACL of auth'd user on userid's Scheduling Outbox */
-    char *outboxname = caldav_mboxname(userid, SCHED_OUTBOX);
-
-    syslog(LOG_DEBUG, "sched_request(%s)", organizer);
+    int rights = 0;
 
-    r = mboxlist_lookup(outboxname, &mbentry, NULL);
+    mbentry_t *mbentry = NULL;
+    char *outboxname = caldav_mboxname(asuserid, SCHED_OUTBOX);
+    int r = mboxlist_lookup(outboxname, &mbentry, NULL);
     if (r) {
         syslog(LOG_INFO, "mboxlist_lookup(%s) failed: %s",
                outboxname, error_message(r));
@@ -2720,15 +2779,19 @@ void sched_request(const char *userid, c
         return;
     }
 
-    /* ok, permissions are checked, let's figure out who the attendees are */
+    /* ok, let's figure out who the attendees are */
     strarray_t attendees = STRARRAY_INITIALIZER;
     add_attendees(oldical, organizer, &attendees);
     add_attendees(newical, organizer, &attendees);
 
+    icaltimetype h_cutoff = get_historical_cutoff();
+
     int i;
     for (i = 0; i < strarray_size(&attendees); i++) {
         const char *attendee = strarray_nth(&attendees, i);
-        schedule_one_attendee(attendee, oldical, newical);
+        syslog(LOG_NOTICE, "iTIP scheduling request from %s to %s",
+               organizer, attendee);
+        schedule_one_attendee(schedule_addresses, organizer, attendee, h_cutoff, oldical, newical);
     }
 
     strarray_fini(&attendees);
@@ -2858,10 +2921,12 @@ static icalparameter_partstat get_partst
 static int partstat_changed(icalcomponent *oldcomp,
                             icalcomponent *newcomp, const char *attendee)
 {
+    if (!attendee) return 1; // something weird is going on, treat it as a change
     return (get_partstat(oldcomp, attendee) != get_partstat(newcomp, attendee));
 }
 
 static void schedule_sub_declines(const char *attendee,
+                                  icaltimetype h_cutoff,
                                   icalcomponent *oldical, icalcomponent *newical,
                                   struct reply_data *reply)
 {
@@ -2894,7 +2959,7 @@ static void schedule_sub_declines(const
         if (newcomp) continue;
 
         /* we need to send an update for this recurrence */
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
         trim_attendees(copy, attendee);
         if (kind == ICAL_VPOLL_COMPONENT) sched_vpoll_reply(copy);
         clean_component(copy);
@@ -2902,12 +2967,14 @@ static void schedule_sub_declines(const
 
         icalcomponent_add_component(reply->itip, copy);
 
-        reply->do_send = 1;
+        if (!reply->do_send && !icalcomponent_is_historical(comp, h_cutoff))
+            reply->do_send = 1;
     }
 }
 
 /* we've already tested that master does NOT contain this attendee */
 static void schedule_sub_replies(const char *attendee,
+                                 icaltimetype h_cutoff,
                                  icalcomponent *oldical, icalcomponent *newical,
                                  struct reply_data *reply)
 {
@@ -2951,7 +3018,7 @@ static void schedule_sub_replies(const c
         reply->organizer = organizer;
 
         /* we need to send an update for this recurrence */
-        icalcomponent *copy = icalcomponent_new_clone(comp);
+        icalcomponent *copy = icalcomponent_clone(comp);
         trim_attendees(copy, attendee);
         if (kind == ICAL_VPOLL_COMPONENT) sched_vpoll_reply(copy);
         clean_component(copy);
@@ -2963,11 +3030,13 @@ static void schedule_sub_replies(const c
             strarray_add(reply->didparts, recurid);
         }
 
-        reply->do_send = 1;
+        if (!reply->do_send && !icalcomponent_is_historical(comp, h_cutoff))
+            reply->do_send = 1;
     }
 }
 
 static void schedule_full_decline(const char *attendee,
+                                  icaltimetype h_cutoff,
                                   icalcomponent *oldical, icalcomponent *newical __attribute__((unused)),
                                   struct reply_data *reply)
 {
@@ -2986,7 +3055,7 @@ static void schedule_full_decline(const
         get_forcesend(icalcomponent_get_first_property(mastercomp,
                                                        ICAL_ORGANIZER_PROPERTY));
 
-    icalcomponent *mastercopy = icalcomponent_new_clone(mastercomp);
+    icalcomponent *mastercopy = icalcomponent_clone(mastercomp);
     trim_attendees(mastercopy, attendee);
     if (icalcomponent_isa(mastercomp) == ICAL_VPOLL_COMPONENT) sched_vpoll_reply(mastercopy);
     clean_component(mastercopy);
@@ -2994,25 +3063,33 @@ static void schedule_full_decline(const
 
     icalcomponent_add_component(reply->itip, mastercopy);
 
-    reply->do_send = 1;
+    if (!reply->do_send && !icalcomponent_is_historical(mastercomp, h_cutoff))
+        reply->do_send = 1;
+
     /* force ALL sub parts to be added */
     reply->master_send = 1;
 }
 
 /* we've already tested that master contains this attendee */
 static void schedule_full_reply(const char *attendee,
+                                icaltimetype h_cutoff,
                                 icalcomponent *oldical, icalcomponent *newical,
                                 struct reply_data *reply)
 {
     icalcomponent *mastercomp = find_attended_component(newical, "", attendee);
+    icalcomponent_kind kind;
+    int add_master = 0;
+
     if (!mastercomp) {
-        schedule_full_decline(attendee, oldical, newical, reply);
+        schedule_full_decline(attendee, h_cutoff, oldical, newical, reply);
         return;
     }
 
     reply->organizer = get_organizer(mastercomp);
     if (!reply->organizer) return;
 
+    kind = icalcomponent_isa(mastercomp);
+
     reply->force_send =
         get_forcesend(icalcomponent_get_first_property(mastercomp,
                                                        ICAL_ORGANIZER_PROPERTY));
@@ -3021,52 +3098,60 @@ static void schedule_full_reply(const ch
 
     /* it's forced */
     if (reply->force_send != ICAL_SCHEDULEFORCESEND_NONE)
-        reply->do_send = 1;
+        add_master = 1;
 
-    /* or it's different */
-    icalcomponent *oldmaster = find_attended_component(oldical, "", attendee);
-    if (partstat_changed(oldmaster, mastercomp, attendee))
-        reply->do_send = 1;
+    /* or it's a VPOLL */
+    else if (kind == ICAL_VPOLL_COMPONENT)
+        add_master = 1;
 
-    /* or it includes new EXDATEs */
-    icalproperty *prop =
-        icalcomponent_get_first_property(mastercomp, ICAL_EXDATE_PROPERTY);
-    for (; prop; prop = icalcomponent_get_next_property(mastercomp,
-                                                        ICAL_EXDATE_PROPERTY)) {
-        struct icaltimetype exdate = icalproperty_get_exdate(prop);
-        if (!has_exdate(oldmaster, exdate))
-            reply->do_send = 1;
+    else {
+        /* or it's different */
+        icalcomponent *oldmaster = find_attended_component(oldical, "", attendee);
+        if (partstat_changed(oldmaster, mastercomp, attendee))
+            add_master = 1;
+
+        /* or it includes new EXDATEs */
+        else {
+            icalproperty *prop =
+                icalcomponent_get_first_property(mastercomp, ICAL_EXDATE_PROPERTY);
+            for (; prop; prop = icalcomponent_get_next_property(mastercomp,
+                                                                ICAL_EXDATE_PROPERTY)) {
+                struct icaltimetype exdate = icalproperty_get_exdate(prop);
+                if (!has_exdate(oldmaster, exdate))
+                    add_master = 1;
+            }
+        }
     }
 
-    if (reply->do_send) {
+    if (add_master) {
         if (!reply->itip) reply->itip = make_itip(ICAL_METHOD_REPLY, newical);
 
         /* add the master */
-        icalcomponent *mastercopy = icalcomponent_new_clone(mastercomp);
+        icalcomponent *mastercopy = icalcomponent_clone(mastercomp);
         trim_attendees(mastercopy, attendee);
-        if (icalcomponent_isa(mastercomp) == ICAL_VPOLL_COMPONENT) sched_vpoll_reply(mastercopy);
+        if (kind == ICAL_VPOLL_COMPONENT) sched_vpoll_reply(mastercopy);
         clean_component(mastercopy);
         icalcomponent_add_component(reply->itip, mastercopy);
 
         /* force ALL sub parts to be added */
         reply->master_send = 1;
+
+        /* master includes "recent" occurrence(s) - send it */
+        if (!icalcomponent_is_historical(mastercopy, h_cutoff))
+            reply->do_send = 1;
     }
 }
 
 /* Create and deliver an attendee scheduling reply */
-void sched_reply(const char *userid, const char *attendee,
+void sched_reply(const char *onuserid, const strarray_t *schedule_addresses,
                  icalcomponent *oldical, icalcomponent *newical)
 {
-    int r;
-
-    syslog(LOG_DEBUG, "sched_reply(%s)", attendee);
-
     /* Check ACL of auth'd user on userid's Scheduling Outbox */
-    char *outboxname = caldav_mboxname(userid, SCHED_OUTBOX);
-
     int rights = 0;
+
     mbentry_t *mbentry = NULL;
-    r = mboxlist_lookup(outboxname, &mbentry, NULL);
+    char *outboxname = caldav_mboxname(onuserid, SCHED_OUTBOX);
+    int r = mboxlist_lookup(outboxname, &mbentry, NULL);
     if (r) {
         syslog(LOG_INFO, "mboxlist_lookup(%s) failed: %s",
                outboxname, error_message(r));
@@ -3080,34 +3165,49 @@ void sched_reply(const char *userid, con
     if (!(rights & DACL_REPLY)) {
         /* DAV:need-privileges */
         syslog(LOG_DEBUG, "No scheduling send ACL for user %s on Outbox %s",
-               httpd_userid, attendee);
+               httpd_userid, onuserid);
         update_organizer_status(newical, NULL, SCHEDSTAT_NOPRIVS);
         return;
     }
 
     /* otherwise we need to decline for each sub event and then we'll still
      * send the accepts if any */
-    struct reply_data reply = { NULL, NULL, NULL, 0, 0, ICAL_SCHEDULEFORCESEND_NONE };
+    icaltimetype h_cutoff = get_historical_cutoff();
 
-    schedule_full_reply(attendee, oldical, newical, &reply);
-    schedule_sub_replies(attendee, oldical, newical, &reply);
-    schedule_sub_declines(attendee, oldical, newical, &reply);
+    int i;
+    for (i = 0; i < strarray_size(schedule_addresses); i++) {
+        const char *attendee = strarray_nth(schedule_addresses, i);
+        struct reply_data reply = { NULL, NULL, NULL, 0, 0, ICAL_SCHEDULEFORCESEND_NONE };
+        if (!strncasecmp(attendee, "mailto:", 7)) attendee += 7;
 
-    if (reply.do_send) {
-        struct sched_data sched = { 0, 1, 0, reply.itip, reply.force_send, NULL };
-        sched_deliver(reply.organizer, &sched, httpd_authstate);
-        update_organizer_status(newical, reply.didparts, sched.status);
-    }
+        schedule_full_reply(attendee, h_cutoff, oldical, newical, &reply);
+        schedule_sub_replies(attendee, h_cutoff, oldical, newical, &reply);
+        schedule_sub_declines(attendee, h_cutoff, oldical, newical, &reply);
+
+        if (reply.do_send) {
+            struct sched_data sched =
+                { 0, 1, 0, reply.itip, oldical, newical, reply.force_send, schedule_addresses, NULL };
+            syslog(LOG_NOTICE, "iTIP scheduling reply from %s to %s",
+                   attendee, reply.organizer ? reply.organizer : "<unknown>");
+            sched_deliver(attendee, reply.organizer, &sched, httpd_authstate);
+            update_organizer_status(newical, reply.didparts, sched.status);
+        }
 
-    if (reply.didparts) strarray_free(reply.didparts);
-    if (reply.itip) icalcomponent_free(reply.itip);
+        if (reply.didparts) strarray_free(reply.didparts);
+        if (reply.itip) icalcomponent_free(reply.itip);
+    }
 }
 
-void sched_param_free(struct caldav_sched_param *sparam) {
-    if (sparam->userid) free(sparam->userid);
-    if (sparam->server) free(sparam->server);
-    if (sparam->props) {
-        free_sched_param_props(sparam->props);
+void sched_param_fini(struct caldav_sched_param *sparam)
+{
+    free(sparam->userid);
+    free(sparam->server);
+
+    struct proplist *prop, *next;
+    for (prop = sparam->props; prop; prop = next) {
+        next = prop->next;
+        free(prop);
     }
+
     memset(sparam, 0, sizeof(struct caldav_sched_param));
 }
diff -pruN 3.0.13-5/imap/http_caldav_sched.h 3.2.0-3/imap/http_caldav_sched.h
--- 3.0.13-5/imap/http_caldav_sched.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_caldav_sched.h	2020-05-04 03:28:02.000000000 +0000
@@ -81,7 +81,10 @@ struct sched_data {
     unsigned is_reply;
     unsigned is_update;
     icalcomponent *itip;
+    icalcomponent *oldical;
+    icalcomponent *newical;
     icalparameter_scheduleforcesend force_send;
+    const strarray_t *schedule_addresses;
     const char *status;
 };
 
@@ -96,7 +99,7 @@ struct proplist {
 };
 
 /* Each calendar user address has the following scheduling protocol params */
-/* All memory must be freed with sched_param_free. */
+/* All memory must be freed with sched_param_fini. */
 struct caldav_sched_param {
     char *userid;       /* Userid corresponding to calendar address */
     char *server;       /* Remote server user lives on */
@@ -106,7 +109,7 @@ struct caldav_sched_param {
     struct proplist *props; /* List of attendee iCal properties */
 };
 
-extern void sched_param_free(struct caldav_sched_param *sparam);
+extern void sched_param_fini(struct caldav_sched_param *sparam);
 
 struct freebusy {
     struct icalperiodtype per;
@@ -166,15 +169,15 @@ extern int isched_send(struct caldav_sch
 
 extern int sched_busytime_query(struct transaction_t *txn,
                                 struct mime_type_t *mime, icalcomponent *comp);
-extern void sched_request(const char *userid, const char *organizer,
+extern void sched_request(const char *onuserid, const strarray_t *schedule_addresses, const char *organizer,
                           icalcomponent *oldical, icalcomponent *newical);
-extern void sched_reply(const char *userid, const char *attendee,
+extern void sched_reply(const char *onuserid, const strarray_t *schedule_addresses,
                         icalcomponent *oldical, icalcomponent *newical);
-extern void sched_deliver(const char *recipient, void *data, void *rock);
+extern void sched_deliver(const char *sender, const char *recipient, void *data, void *rock);
 extern xmlNodePtr xml_add_schedresponse(xmlNodePtr root, xmlNsPtr dav_ns,
                                         xmlChar *recipient, xmlChar *status);
 extern int caladdress_lookup(const char *addr, struct caldav_sched_param *param,
-                             const char *myuserid);
+                             const strarray_t *schedule_addresses);
 
 
 #endif /* HTTP_CALDAV_SCHED_H */
diff -pruN 3.0.13-5/imap/http_carddav.c 3.2.0-3/imap/http_carddav.c
--- 3.0.13-5/imap/http_carddav.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_carddav.c	2020-05-04 03:28:02.000000000 +0000
@@ -48,6 +48,7 @@
 
 #include <config.h>
 
+#include <sysexits.h>
 #include <syslog.h>
 
 #include <libxml/tree.h>
@@ -58,11 +59,11 @@
 #include "acl.h"
 #include "append.h"
 #include "carddav_db.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "hash.h"
 #include "httpd.h"
 #include "http_dav.h"
+#include "http_dav_sharing.h"
 #include "http_proxy.h"
 #include "index.h"
 #include "mailbox.h"
@@ -72,8 +73,10 @@
 #include "proxy.h"
 #include "smtpclient.h"
 #include "spool.h"
+#include "strhash.h"
 #include "stristr.h"
 #include "times.h"
+#include "user.h"
 #include "util.h"
 #include "vcard_support.h"
 #include "version.h"
@@ -91,14 +94,12 @@ static struct carddav_db *auth_carddavdb
 static time_t compile_time;
 
 static void my_carddav_init(struct buf *serverinfo);
-static void my_carddav_auth(const char *userid);
+static int my_carddav_auth(const char *userid);
 static void my_carddav_reset(void);
 static void my_carddav_shutdown(void);
 
-static strarray_t partial_addrdata;
-
-static int carddav_parse_path(const char *path,
-                              struct request_target_t *tgt, const char **errstr);
+static int carddav_parse_path(const char *path, struct request_target_t *tgt,
+                              const char **resultstr);
 
 static int carddav_copy(struct transaction_t *txn, void *obj,
                         struct mailbox *mailbox, const char *resource,
@@ -111,6 +112,10 @@ static int carddav_put(struct transactio
                        struct mailbox *mailbox, const char *resource,
                        void *destdb, unsigned flags);
 
+static int carddav_import(struct transaction_t *txn, void *obj,
+                          struct mailbox *mailbox, void *destdb,
+                          xmlNodePtr root, xmlNsPtr *ns, unsigned flags);
+
 static int propfind_getcontenttype(const xmlChar *name, xmlNsPtr ns,
                                    struct propfind_ctx *fctx,
                                    xmlNodePtr prop, xmlNodePtr resp,
@@ -155,7 +160,7 @@ static const struct report_type_t cardda
 
     /* WebDAV ACL (RFC 3744) REPORTs */
     { "acl-principal-prop-set", NS_DAV, "multistatus", &report_acl_prin_prop,
-      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_DEPTH_ZERO },
+      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_NEED_PROPS | REPORT_DEPTH_ZERO },
 
     /* WebDAV Sync (RFC 6578) REPORTs */
     { "sync-collection", NS_DAV, "multistatus", &report_sync_col,
@@ -178,9 +183,10 @@ static const struct prop_entry carddav_p
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_creationdate, NULL, NULL },
     { "displayname", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_fromdb, proppatch_todb, NULL },
-    { "getcontentlanguage", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PERUSER,
+      propfind_collectionname, proppatch_todb, NULL },
+    { "getcontentlanguage", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_fromhdr, NULL, "Content-Language" },
     { "getcontentlength", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
@@ -188,43 +194,62 @@ static const struct prop_entry carddav_p
     { "getcontenttype", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getcontenttype, NULL, "Content-Type" },
-    { "getetag", NS_DAV, PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+    { "getetag", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getetag, NULL, NULL },
     { "getlastmodified", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getlastmod, NULL, NULL },
-    { "lockdiscovery", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "lockdiscovery", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_lockdisc, NULL, NULL },
     { "resourcetype", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_restype, proppatch_restype, "addressbook" },
-    { "supportedlock", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "supportedlock", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_suplock, NULL, NULL },
 
     /* WebDAV Versioning (RFC 3253) properties */
-    { "supported-report-set", NS_DAV, PROP_COLLECTION,
+    { "supported-report-set", NS_DAV,
+      PROP_COLLECTION | PROP_PRESCREEN,
       propfind_reportset, NULL, (void *) carddav_reports },
+    { "supported-method-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_methodset, NULL, (void *) &calcarddav_allow_cb },
 
     /* WebDAV ACL (RFC 3744) properties */
-    { "owner", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "owner", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_owner, NULL, NULL },
-    { "group", NS_DAV, 0, NULL, NULL, NULL },
-    { "supported-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "group", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "supported-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_supprivset, NULL, NULL },
-    { "current-user-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "current-user-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_curprivset, NULL, NULL },
-    { "acl", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_acl, NULL, NULL },
-    { "acl-restrictions", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl-restrictions", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_aclrestrict, NULL, NULL },
-    { "inherited-acl-set", NS_DAV, 0, NULL, NULL, NULL },
-    { "principal-collection-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "inherited-acl-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "principal-collection-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_princolset, NULL, NULL },
 
     /* WebDAV Quota (RFC 4331) properties */
-    { "quota-available-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-available-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
-    { "quota-used-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-used-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
 
     /* WebDAV Current Principal (RFC 5397) properties */
@@ -233,44 +258,59 @@ static const struct prop_entry carddav_p
       propfind_curprin, NULL, NULL },
 
     /* WebDAV POST (RFC 5995) properties */
-    { "add-member", NS_DAV, PROP_COLLECTION,
-      NULL /* add-member broken at FM */, NULL, NULL },
+    { "add-member", NS_DAV,
+      PROP_COLLECTION,
+      propfind_addmember, NULL, NULL },
 
     /* WebDAV Sync (RFC 6578) properties */
-    { "sync-token", NS_DAV, PROP_COLLECTION,
+    { "sync-token", NS_DAV,
+      PROP_COLLECTION,
       propfind_sync_token, NULL, SYNC_TOKEN_URL_SCHEME },
 
     /* WebDAV Sharing (draft-pot-webdav-resource-sharing) properties */
-    { "share-access", NS_DAV, PROP_COLLECTION,
+    { "share-access", NS_DAV,
+      PROP_COLLECTION,
       propfind_shareaccess, NULL, NULL },
-    { "invite", NS_DAV, PROP_COLLECTION,
+    { "invite", NS_DAV,
+      PROP_COLLECTION,
       propfind_invite, NULL, NULL },
-    { "sharer-resource-uri", NS_DAV, PROP_COLLECTION,
+    { "sharer-resource-uri", NS_DAV,
+      PROP_COLLECTION,
       propfind_sharedurl, NULL, NULL },
 
     /* CardDAV (RFC 6352) properties */
-    { "address-data", NS_CARDDAV, PROP_RESOURCE | PROP_PRESCREEN | PROP_CLEANUP,
-      propfind_addrdata, NULL, &partial_addrdata },
-    { "addressbook-description", NS_CARDDAV, PROP_COLLECTION,
+    { "address-data", NS_CARDDAV,
+      PROP_RESOURCE | PROP_PRESCREEN | PROP_CLEANUP,
+      propfind_addrdata, NULL, (void *) CARDDAV_SUPP_DATA },
+    { "addressbook-description", NS_CARDDAV,
+      PROP_COLLECTION | PROP_PERUSER,
       propfind_fromdb, proppatch_todb, NULL },
-    { "supported-address-data", NS_CARDDAV, PROP_COLLECTION,
+    { "supported-address-data", NS_CARDDAV,
+      PROP_COLLECTION,
       propfind_suppaddrdata, NULL, NULL },
-    { "supported-collation-set", NS_CARDDAV, PROP_COLLECTION,
+    { "supported-collation-set", NS_CARDDAV,
+      PROP_COLLECTION,
       propfind_collationset, NULL, NULL },
-    { "max-resource-size", NS_CARDDAV, 0, NULL, NULL, NULL },
+    { "max-resource-size", NS_CARDDAV,
+      PROP_COLLECTION,
+      NULL, NULL, NULL },
 
     /* Apple Calendar Server properties */
-    { "getctag", NS_CS, PROP_ALLPROP | PROP_COLLECTION,
+    { "getctag", NS_CS,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_sync_token, NULL, "" },
 
     /* Apple Push Notifications Service properties */
-    { "push-transports", NS_CS, PROP_COLLECTION,
+    { "push-transports", NS_CS,
+      PROP_COLLECTION | PROP_PRESCREEN,
       propfind_push_transports, NULL, (void *) MBTYPE_ADDRESSBOOK },
-    { "pushkey", NS_CS, PROP_COLLECTION,
+    { "pushkey", NS_CS,
+      PROP_COLLECTION,
       propfind_pushkey, NULL, NULL },
 
     /* Cyrus properties */
-    { "address-groups", NS_CYRUS, PROP_RESOURCE,
+    { "address-groups", NS_CYRUS,
+      PROP_RESOURCE,
       propfind_addrgroups, NULL, NULL },
 
     { NULL, 0, 0, NULL, NULL, NULL }
@@ -279,6 +319,8 @@ static const struct prop_entry carddav_p
 static struct meth_params carddav_params = {
     carddav_mime_types,
     &carddav_parse_path,
+    &dav_get_validators,
+    &dav_get_modseq,
     &dav_check_precond,
     { (db_open_proc_t) &carddav_open_mailbox,
       (db_close_proc_t) &carddav_close,
@@ -286,16 +328,19 @@ static struct meth_params carddav_params
       (db_proc_t) &carddav_commit,
       (db_proc_t) &carddav_abort,
       (db_lookup_proc_t) &carddav_lookup_resource,
+      (db_imapuid_proc_t) &carddav_lookup_imapuid,
       (db_foreach_proc_t) &carddav_foreach,
+      (db_updates_proc_t) &carddav_get_updates,
       (db_write_proc_t) &carddav_write,
       (db_delete_proc_t) &carddav_delete },
     NULL,                                       /* No ACL extensions */
     { CARDDAV_UID_CONFLICT, &carddav_copy },
     NULL,                                       /* No special DELETE handling */
     &carddav_get,
-    { CARDDAV_LOCATION_OK, MBTYPE_ADDRESSBOOK },
+    { CARDDAV_LOCATION_OK, MBTYPE_ADDRESSBOOK, NULL },
     NULL,                                       /* No PATCH handling */
-    { POST_SHARE, NULL, NULL },                 /* No special POST handling */
+    { POST_ADDMEMBER | POST_SHARE, NULL,        /* No special POST handling */
+      { NS_CARDDAV, "addressbook-data", &carddav_import } },
     { CARDDAV_SUPP_DATA, &carddav_put },
     { DAV_FINITE_DEPTH, carddav_props },        /* Disable infinite depth */
     carddav_reports
@@ -304,7 +349,7 @@ static struct meth_params carddav_params
 
 /* Namespace for Carddav collections */
 struct namespace_t namespace_addressbook = {
-    URL_NS_ADDRESSBOOK, 0, "/dav/addressbooks", "/.well-known/carddav",
+    URL_NS_ADDRESSBOOK, 0, "addressbook", "/dav/addressbooks", "/.well-known/carddav",
     http_allow_noauth_get, /*authschemes*/0,
     MBTYPE_ADDRESSBOOK,
     (ALLOW_READ | ALLOW_POST | ALLOW_WRITE | ALLOW_DELETE |
@@ -314,6 +359,7 @@ struct namespace_t namespace_addressbook
     {
         { &meth_acl,            &carddav_params },      /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { &meth_copy_move,      &carddav_params },      /* COPY         */
         { &meth_delete,         &carddav_params },      /* DELETE       */
         { &meth_get_head,       &carddav_params },      /* GET          */
@@ -343,7 +389,7 @@ static void my_carddav_init(struct buf *
     if (!namespace_addressbook.enabled) return;
 
     if (!config_getstring(IMAPOPT_ADDRESSBOOKPREFIX)) {
-        fatal("Required 'addressbookprefix' option is not set", EC_CONFIG);
+        fatal("Required 'addressbookprefix' option is not set", EX_CONFIG);
     }
 
     carddav_init();
@@ -358,7 +404,57 @@ static void my_carddav_init(struct buf *
 
 #define DEFAULT_ADDRBOOK "Default"
 
+static int _create_mailbox(const char *userid, const char *mailboxname, int type,
+                           const char *displayname, struct mboxlock **namespacelockp)
+{
+    int r = 0;
+    struct mailbox *mailbox = NULL;
+
+    r = mboxlist_lookup(mailboxname, NULL, NULL);
+    if (!r) return 0;
+    if (r != IMAP_MAILBOX_NONEXISTENT) return r;
+
+    if (!*namespacelockp) {
+        *namespacelockp = mboxname_usernamespacelock(mailboxname);
+        // maybe we lost the race on this one
+        r = mboxlist_lookup(mailboxname, NULL, NULL);
+        if (!r) return 0;
+        if (r != IMAP_MAILBOX_NONEXISTENT) return r;
+    }
+
+    /* Create locally */
+    r = mboxlist_createmailbox(mailboxname, type,
+                               NULL, 0,
+                               userid, httpd_authstate,
+                               0, 0, 0, 0, displayname ? &mailbox : NULL);
+
+    if (!r && displayname) {
+        annotate_state_t *astate = NULL;
+
+        r = mailbox_get_annotate_state(mailbox, 0, &astate);
+        if (!r) {
+            const char *disp_annot = DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+            struct buf value = BUF_INITIALIZER;
+
+            buf_init_ro_cstr(&value, displayname);
+            r = annotate_state_writemask(astate, disp_annot, userid, &value);
+            buf_free(&value);
+        }
+
+        mailbox_close(&mailbox);
+    }
+
+    if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                  mailboxname, error_message(r));
+
+    return r;
+}
+
+
+
 EXPORTED int carddav_create_defaultaddressbook(const char *userid) {
+    struct mboxlock *namespacelock = NULL;
+
     /* addressbook-home-set */
     mbname_t *mbname = mbname_from_userid(userid);
     mbname_push_boxes(mbname, config_getstring(IMAPOPT_ADDRESSBOOKPREFIX));
@@ -379,15 +475,9 @@ EXPORTED int carddav_create_defaultaddre
         }
         mboxlist_entry_free(&mbentry);
 
-        if (!r) {
-            r = mboxlist_createmailbox(mbname_intname(mbname),
-                                       MBTYPE_ADDRESSBOOK,
-                                       NULL, 0,
-                                       userid, httpd_authstate,
-                                       0, 0, 0, 0, NULL);
-            if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
-                          mbname_intname(mbname), error_message(r));
-        }
+        if (!r) r = _create_mailbox(userid, mbname_intname(mbname),
+                                    MBTYPE_ADDRESSBOOK, NULL,
+                                    &namespacelock);
     }
     if (r) goto done;
 
@@ -395,60 +485,46 @@ EXPORTED int carddav_create_defaultaddre
     mbname_push_boxes(mbname, DEFAULT_ADDRBOOK);
     r = mboxlist_lookup(mbname_intname(mbname), NULL, NULL);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
-        struct mailbox *mailbox = NULL;
-
-        r = mboxlist_createmailbox(mbname_intname(mbname), MBTYPE_ADDRESSBOOK,
-                                   NULL, 0,
-                                   userid, httpd_authstate,
-                                   0, 0, 0, 0, &mailbox);
-        if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
-                      mbname_intname(mbname), error_message(r));
-        else {
-            annotate_state_t *astate = NULL;
-
-            r = mailbox_get_annotate_state(mailbox, 0, &astate);
-            if (!r) {
-                const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
-                struct buf value = BUF_INITIALIZER;
-
-                buf_init_ro_cstr(&value, "personal");
-                r = annotate_state_writemask(astate, annot, userid, &value);
-            }
-
-            mailbox_close(&mailbox);
-        }
+        r = _create_mailbox(userid, mbname_intname(mbname),
+                            MBTYPE_ADDRESSBOOK, "personal",
+                            &namespacelock);
     }
 
  done:
+    mboxname_release(&namespacelock);
     mbname_free(&mbname);
     return r;
 }
 
-static void my_carddav_auth(const char *userid)
+static int my_carddav_auth(const char *userid)
 {
-    int r;
-
     if (httpd_userisadmin || httpd_userisanonymous ||
         global_authisa(httpd_authstate, IMAPOPT_PROXYSERVERS)) {
         /* admin, anonymous, or proxy from frontend - won't have DAV database */
-        return;
+        return 0;
     }
     else if (config_mupdate_server && !config_getstring(IMAPOPT_PROXYSERVERS)) {
         /* proxy-only server - won't have DAV databases */
+        return 0;
     }
     else {
         /* Open CardDAV DB for 'userid' */
         my_carddav_reset();
         auth_carddavdb = carddav_open_userid(userid);
-        if (!auth_carddavdb) fatal("Unable to open CardDAV DB", EC_IOERR);
+        if (!auth_carddavdb) {
+            syslog(LOG_ERR, "Unable to open CardDAV DB for userid: %s", userid);
+            return HTTP_UNAVAILABLE;
+        }
     }
 
     /* Auto-provision an addressbook for 'userid' */
-    r = carddav_create_defaultaddressbook(userid);
+    int r = carddav_create_defaultaddressbook(userid);
     if (r) {
         syslog(LOG_ERR, "could not autoprovision addressbook for userid %s: %s",
                 userid, error_message(r));
+        return HTTP_SERVER_ERROR;
     }
+    return 0;
 }
 
 
@@ -467,12 +543,12 @@ static void my_carddav_shutdown(void)
 
 
 /* Parse request-target path in CardDAV namespace */
-static int carddav_parse_path(const char *path,
-                              struct request_target_t *tgt, const char **errstr)
+static int carddav_parse_path(const char *path, struct request_target_t *tgt,
+                              const char **resultstr)
 {
     return calcarddav_parse_path(path, tgt,
                                  config_getstring(IMAPOPT_ADDRESSBOOKPREFIX),
-                                 errstr);
+                                 resultstr);
 }
 
 /* Perform a COPY/MOVE/PUT request
@@ -576,7 +652,7 @@ static int store_resource(struct transac
     }
 
     /* Create and cache RFC 5322 header fields for resource */
-    mimehdr = charset_encode_mimeheader(fullname, 0);
+    mimehdr = charset_encode_mimeheader(fullname, 0, 0);
     spool_replace_header(xstrdup("Subject"), mimehdr, txn->req_hdrs);
 
     /* XXX - validate uid for mime safety? */
@@ -605,7 +681,7 @@ static int store_resource(struct transac
     /* Store the resource */
     struct buf *buf = vcard_as_buf(vcard);
     int r = dav_store_resource(txn, buf_cstring(buf), 0,
-                              mailbox, oldrecord, NULL);
+                              mailbox, oldrecord, cdata->dav.createdmodseq, NULL);
     buf_destroy(buf);
     return r;
 }
@@ -634,7 +710,7 @@ static int export_addressbook(struct tra
     struct mime_type_t *mime = NULL;
 
     /* Check requested MIME type:
-       1st entry in caldav_mime_types array MUST be default MIME type */
+       1st entry in carddav_mime_types array MUST be default MIME type */
     if ((hdr = spool_getheader(txn->req_hdrs, "Accept")))
         mime = get_accept_type(hdr, carddav_mime_types);
     else mime = carddav_mime_types;
@@ -687,19 +763,21 @@ static int export_addressbook(struct tra
 
     buf_reset(&txn->buf);
     buf_printf(&txn->buf, "%s.%s", buf_cstring(&attrib), mime->file_ext);
-    txn->resp_body.fname = buf_cstring(&txn->buf);
+    txn->resp_body.dispo.fname = buf_cstring(&txn->buf);
 
     /* Short-circuit for HEAD request */
     if (txn->meth == METH_HEAD) {
         response_header(HTTP_OK, txn);
-        return 0;
+        ret = 0;
+        goto done;
     }
 
     /* vCard data in response should not be transformed */
     txn->flags.cc |= CC_NOTRANSFORM;
 
     /* Begin (converted) vCard stream */
-    if (mime->begin_stream) sep = mime->begin_stream(buf);
+    if (mime->begin_stream)
+        sep = mime->begin_stream(buf, mailbox, NULL, NULL, NULL, NULL);
     else buf_reset(buf);
     write_body(HTTP_OK, txn, buf_cstring(buf), buf_len(buf));
 
@@ -718,7 +796,7 @@ static int export_addressbook(struct tra
             if (r++ && *sep) {
                 /* Add separator, if necessary */
                 buf_reset(buf);
-                buf_printf_markup(buf, 0, sep);
+                buf_printf_markup(buf, 0, "%s", sep);
                 write_body(0, txn, buf_cstring(buf), buf_len(buf));
             }
 
@@ -927,7 +1005,7 @@ static int list_addressbooks(struct tran
     buf_printf_markup(body, level++, "<script type=\"text/javascript\">");
     buf_appendcstr(body, "//<![CDATA[\n");
     buf_printf(body, (const char *) http_carddav_js,
-               cyrus_version(), http_carddav_js_len);
+               CYRUS_VERSION, http_carddav_js_len);
     buf_appendcstr(body, "//]]>\n");
     buf_printf_markup(body, --level, "</script>");
     buf_printf_markup(body, level++, "<noscript>");
@@ -1096,7 +1174,8 @@ static int carddav_get(struct transactio
         /* Download an entire addressbook collection */
         return export_addressbook(txn);
     }
-    else if (txn->req_tgt.userid) {
+    else if (txn->req_tgt.userid &&
+             config_getswitch(IMAPOPT_CARDDAV_ALLOWADDRESSBOOKADMIN)) {
         /* GET a list of addressbook under addressbook-home-set */
         return list_addressbooks(txn);
     }
@@ -1112,10 +1191,156 @@ static int carddav_put(struct transactio
 {
     struct carddav_db *db = (struct carddav_db *)destdb;
     struct vparse_card *vcard = (struct vparse_card *)obj;
+
+    if (!(vcard && vcard->objects &&
+          vparse_restriction_check(vcard->objects))) {
+        txn->error.precond = CARDDAV_VALID_DATA;
+        return HTTP_FORBIDDEN;
+    }
+
     return store_resource(txn, vcard, mailbox, resource, db, /*dupcheck*/1);
 }
 
 
+/* Perform a bulk import */
+static int carddav_import(struct transaction_t *txn, void *obj,
+                          struct mailbox *mailbox, void *destdb,
+                          xmlNodePtr root, xmlNsPtr *ns, unsigned flags)
+{
+    struct vparse_card *vcard = obj;
+    xmlBufferPtr xmlbuf = NULL;
+    size_t baselen;
+
+    if (!root) {
+        /* Validate the vCard data */
+        if (!vcard ||
+            !vcard->objects ||
+            !vcard->objects->type ||
+            strcasecmp(vcard->objects->type, "vcard")) {
+            txn->error.precond = CARDDAV_VALID_DATA;
+            return HTTP_FORBIDDEN;
+        }
+
+        return 0;
+    }
+
+
+    /* Setup for appending resource name to request path */
+    baselen = strlen(txn->req_tgt.path);
+    txn->req_tgt.resource = txn->req_tgt.path + baselen;
+
+    /* Import vCards */
+    while (vcard->objects) {
+        struct vparse_card *this, *next;
+        xmlNodePtr resp, node;
+        struct vparse_entry *entry;
+        const char *resource = makeuuid(), *uid, *myuid = NULL;
+        int r;
+
+        /* Create DAV:response element */
+        resp = xmlNewChild(root, ns[NS_DAV], BAD_CAST "response", NULL);
+        if (!resp) {
+            syslog(LOG_ERR,
+                   "import_resource()): Unable to add response XML element");
+            fatal("import_resource()): Unable to add response XML element",
+                  EX_SOFTWARE);
+        }
+
+        /* Isolate this card */
+        this = vcard->objects;
+        next = this->next;
+        this->next = NULL;
+
+        /* Get/create UID property */
+        entry = vparse_get_entry(this, NULL, "UID");
+        if (entry) {
+            uid = entry->v.value;
+        }
+        else {
+            myuid = uid = resource;
+            vparse_add_entry(this, NULL, "UID", uid);
+        }
+
+        /* Append a unique resource name to URL and perform a PUT */
+        txn->req_tgt.reslen =
+            snprintf(txn->req_tgt.resource, MAX_MAILBOX_PATH - baselen,
+                     "%s.vcf", resource);
+
+        r = carddav_put(txn, vcard, mailbox,
+                       txn->req_tgt.resource, destdb, flags);
+
+        switch (r) {
+        case HTTP_OK:
+        case HTTP_CREATED:
+        case HTTP_NO_CONTENT:
+            /* Success: Add DAV:href and DAV:propstat elements */
+            xml_add_href(resp, NULL, txn->req_tgt.path);
+
+            node = xmlNewChild(resp, ns[NS_DAV], BAD_CAST "propstat", NULL);
+            xmlNewChild(node, ns[NS_DAV], BAD_CAST "status",
+                        BAD_CAST http_statusline(VER_1_1, HTTP_OK));
+
+            node = xmlNewChild(node, ns[NS_DAV], BAD_CAST "prop", NULL);
+
+            if (txn->resp_body.etag) {
+                /* Add DAV:getetag property */
+                xmlNewTextChild(node, ns[NS_DAV], BAD_CAST "getetag",
+                                BAD_CAST txn->resp_body.etag);
+            }
+
+            if ((flags & PREFER_REP) && myuid /* we added a UID */) {
+                /* Add CARDDAV:addressbook-data property */
+                struct buf *vcardbuf = vcard_as_buf(this);
+                xmlNodePtr cdata = xmlNewChild(node, ns[NS_CARDDAV],
+                                               BAD_CAST "addressbook-data", NULL);
+
+                xmlAddChild(cdata, xmlNewCDataBlock(root->doc,
+                                                    BAD_CAST buf_cstring(vcardbuf),
+                                                    buf_len(vcardbuf)));
+                buf_free(vcardbuf);
+            }
+
+            break;
+
+        default:
+            /* Failure: Add DAV:href, DAV:status, and DAV:error elements */
+            xml_add_href(resp, NULL, NULL);
+
+            xmlNewChild(resp, ns[NS_DAV], BAD_CAST "status",
+                        BAD_CAST http_statusline(VER_1_1, r));
+
+            node = xml_add_error(resp, &txn->error, ns);
+            break;
+        }
+
+        /* Add CS:uid property */
+        xmlNewTextChild(node, ns[NS_CS], BAD_CAST "uid", BAD_CAST uid);
+
+        /* Add DAV:response element for this resource to output buffer.
+           Only output the xmlBuffer every PROT_BUFSIZE bytes */
+        xml_partial_response((xmlBufferLength(xmlbuf) > PROT_BUFSIZE) ? txn : NULL,
+                             root->doc, resp, 1, &xmlbuf);
+
+        /* Remove DAV:response element from root (no need to keep in memory) */
+        xmlReplaceNode(resp, NULL);
+        xmlFreeNode(resp);
+
+        /* Remove this vcard from the head of the list */
+        vparse_free_card(this);
+        vcard->objects = next;
+
+        /* Clear the buffer used for constructing href */
+        buf_reset(&txn->buf);
+    }
+
+    /* End XML response */
+    xml_partial_response(txn, root->doc, NULL /* end */, 0, &xmlbuf);
+    xmlBufferFree(xmlbuf);
+
+    return 0;
+}
+
+
 /* Callback to fetch DAV:getcontenttype */
 static int propfind_getcontenttype(const xmlChar *name, xmlNsPtr ns,
                                    struct propfind_ctx *fctx,
@@ -1141,6 +1366,17 @@ static int propfind_restype(const xmlCha
                             struct propstat propstat[],
                             void *rock __attribute__((unused)))
 {
+    if (!propstat) {
+        /* Prescreen "property" request */
+        if (fctx->req_tgt->collection ||
+            (fctx->req_tgt->userid && fctx->depth >= 1) || fctx->depth >= 2) {
+            /* Add namespaces for possible resource types */
+            ensure_ns(fctx->ns, NS_CARDDAV, fctx->root, XML_NS_CARDDAV, "C");
+        }
+
+        return 0;
+    }
+
     xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
                                    &propstat[PROPSTAT_OK], name, ns, NULL, 0);
 
@@ -1183,37 +1419,22 @@ static int propfind_addrdata(const xmlCh
                              xmlNodePtr prop,
                              xmlNodePtr resp __attribute__((unused)),
                              struct propstat propstat[],
-                             void *rock)
+                             void *rock __attribute__((unused)))
 {
-    strarray_t *partial = (strarray_t *) rock;
+    static struct mime_type_t *out_type = carddav_mime_types;
+    static strarray_t partial_addrdata = STRARRAY_INITIALIZER;
+    strarray_t *partial = &partial_addrdata;
     const char *data = NULL;
     size_t datalen = 0;
 
-    if (propstat) {
-        if (!fctx->record) return HTTP_NOT_FOUND;
-
-        if (!fctx->msg_buf.len)
-            mailbox_map_record(fctx->mailbox, fctx->record, &fctx->msg_buf);
-        if (!fctx->msg_buf.len) return HTTP_SERVER_ERROR;
-
-        data = fctx->msg_buf.s + fctx->record->header_size;
-        datalen = fctx->record->size - fctx->record->header_size;
-
-        if (strarray_size(partial)) {
-            /* Limit returned properties */
-            struct vparse_card *vcard = fctx->obj;
-
-            if (!vcard) vcard = fctx->obj = vcard_parse_string(data, 1);
-            prune_properties(vcard->objects, partial);
+    if (!fctx) {
+        /* Cleanup "property" request - free partial property array */
+        strarray_fini(partial);
 
-            /* Create vCard data from new vcard component */
-            buf_reset(&fctx->msg_buf);
-            vparse_tobuf(vcard, &fctx->msg_buf);
-            data = buf_cstring(&fctx->msg_buf);
-            datalen = buf_len(&fctx->msg_buf);
-        }
+        return 0;
     }
-    else if (prop) {
+
+    if (!propstat) {
         /* Prescreen "property" request - read partial properties */
         xmlNodePtr node;
 
@@ -1234,14 +1455,36 @@ static int propfind_addrdata(const xmlCh
         }
     }
     else {
-        /* Cleanup "property" request - free partial property array */
-        strarray_fini(partial);
+        if (fctx->txn->meth != METH_REPORT) return HTTP_FORBIDDEN;
 
-        return 0;
+        if (!out_type->content_type) return HTTP_BAD_MEDIATYPE;
+
+        if (!fctx->record) return HTTP_NOT_FOUND;
+
+        if (!fctx->msg_buf.len)
+            mailbox_map_record(fctx->mailbox, fctx->record, &fctx->msg_buf);
+        if (!fctx->msg_buf.len) return HTTP_SERVER_ERROR;
+
+        data = fctx->msg_buf.s + fctx->record->header_size;
+        datalen = fctx->record->size - fctx->record->header_size;
+
+        if (strarray_size(partial)) {
+            /* Limit returned properties */
+            struct vparse_card *vcard = fctx->obj;
+
+            if (!vcard) vcard = fctx->obj = vcard_parse_string(data, 1);
+            prune_properties(vcard->objects, partial);
+
+            /* Create vCard data from new vcard component */
+            buf_reset(&fctx->msg_buf);
+            vparse_tobuf(vcard, &fctx->msg_buf);
+            data = buf_cstring(&fctx->msg_buf);
+            datalen = buf_len(&fctx->msg_buf);
+        }
     }
 
     return propfind_getdata(name, ns, fctx, prop, propstat, carddav_mime_types,
-                            CARDDAV_SUPP_DATA, data, datalen);
+                            &out_type, data, datalen);
 }
 
 
@@ -1632,6 +1875,12 @@ static int report_card_query(struct tran
         }
     }
 
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
+
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, fctx->root->doc);
+
     if (fctx->depth++ > 0) {
         /* Addressbook collection(s) */
         if (txn->req_tgt.collection) {
@@ -1649,10 +1898,15 @@ static int report_card_query(struct tran
                               propfind_by_collection, fctx,
                               MBOXTREE_SKIP_PERSONAL);
         }
-
-        ret = *fctx->ret;
     }
 
+    /* End XML response */
+    xml_partial_response(txn, fctx->root->doc, NULL /* end */, 0, &fctx->xmlbuf);
+    xmlBufferFree(fctx->xmlbuf);
+
+    /* End of output */
+    write_body(0, txn, NULL, 0);
+
   done:
     /* Free filter structure */
     free_cardfilter(&cardfilter);
@@ -1662,5 +1916,5 @@ static int report_card_query(struct tran
         fctx->davdb = NULL;
     }
 
-    return (ret ? ret : HTTP_MULTI_STATUS);
+    return ret;
 }
diff -pruN 3.0.13-5/imap/http_cgi.c 3.2.0-3/imap/http_cgi.c
--- 3.0.13-5/imap/http_cgi.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_cgi.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,369 @@
+/* http_cgi.c -- Routines for handling Common Gateway Interface scripts in httpd
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+
+#include "command.h"
+#include "global.h"
+#include "httpd.h"
+#include "http_proxy.h"
+#include "proxy.h"
+#include "tok.h"
+#include "util.h"
+#include "version.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+static void cgi_init(struct buf *serverinfo);
+static int meth_get(struct transaction_t *txn, void *params);
+static int meth_post(struct transaction_t *txn, void *params);
+
+
+/* Namespace for CGI */
+struct namespace_t namespace_cgi = {
+    URL_NS_CGI, 0, "cgi", "/cgi-bin", NULL,
+    http_allow_noauth, /*authschemes*/0,
+    /*mbtype*/0,
+    ALLOW_READ | ALLOW_POST,
+    cgi_init, NULL, NULL, NULL, NULL, NULL,
+    {
+        { NULL,                 NULL },                 /* ACL          */
+        { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
+        { NULL,                 NULL },                 /* COPY         */
+        { NULL,                 NULL },                 /* DELETE       */
+        { &meth_get,            NULL },                 /* GET          */
+        { &meth_get,            NULL },                 /* HEAD         */
+        { NULL,                 NULL },                 /* LOCK         */
+        { NULL,                 NULL },                 /* MKCALENDAR   */
+        { NULL,                 NULL },                 /* MKCOL        */
+        { NULL,                 NULL },                 /* MOVE         */
+        { &meth_options,        NULL },                 /* OPTIONS      */
+        { NULL,                 NULL },                 /* PATCH        */
+        { &meth_post,           NULL },                 /* POST         */
+        { NULL,                 NULL },                 /* PROPFIND     */
+        { NULL,                 NULL },                 /* PROPPATCH    */
+        { NULL,                 NULL },                 /* PUT          */
+        { NULL,                 NULL },                 /* REPORT       */
+        { &meth_trace,          NULL },                 /* TRACE        */
+        { NULL,                 NULL },                 /* UNBIND       */
+        { NULL,                 NULL }                  /* UNLOCK       */
+    }
+};
+
+
+static void cgi_init(struct buf *serverinfo __attribute__((unused)))
+{
+    namespace_cgi.enabled = config_httpmodules & IMAP_ENUM_HTTPMODULES_CGI;
+}
+
+/* Add request headers to environment for script */
+static void req_hdr_to_env(const char *name, const char *contents,
+                           const char *raw __attribute__((unused)), void *rock)
+{
+    struct buf *environ = (struct buf *) rock;
+    const char **hdr, *skip[] =
+        { "authorization", "cookie", "expect", "http2-settings",
+          "proxy-authorization", "transfer-encoding", "upgrade", NULL };
+
+    /* Ignore private headers in our cache */
+    if (name[0] == ':') return;
+
+    for (hdr = skip; *hdr && strcasecmp(name, *hdr); hdr++);
+
+    if (!*hdr) {
+        static struct buf env_name = BUF_INITIALIZER;
+        const char *env_str = buf_cstring(environ);
+        const char *exists;
+
+        buf_reset(&env_name);
+        buf_printf(&env_name, "\tHTTP_%s=", name);
+        buf_ucase(&env_name);
+        buf_replace_all(&env_name, "-", "_");
+
+        /* See if this name already exists */
+        exists = strstr(env_str, buf_cstring(&env_name));
+        if (exists) {
+            /* Append value to existing value(s) */
+            const char *next = strchr(exists + 1, '\t');
+            unsigned offset = next ? next - env_str : (unsigned) strlen(env_str);
+
+            buf_insertcstr(environ, offset, ", ");
+            buf_insertcstr(environ, offset + 2, contents);
+        }
+        else {
+            /* Add name and value */
+            buf_appendcstr(environ, buf_cstring(&env_name));
+            buf_appendcstr(environ, contents);
+        }
+    }
+}
+
+/* Perform a GET/HEAD request */
+static int meth_get(struct transaction_t *txn,
+                    void *params __attribute__((unused)))
+{
+    int ret = 0;
+    const char *prefix, *urls, *errstr = NULL;
+    const char **hdr, *extra, *port, *query;
+    char *script, *cwd;
+    struct stat sbuf;
+    strarray_t *env = NULL;
+    struct command *cmd = NULL;
+    hdrcache_t resp_hdrs = NULL;
+    struct body_t resp_body;
+    long code = 0;
+    
+    memset(&resp_body, 0, sizeof(struct body_t));
+
+    prefix = config_getstring(IMAPOPT_HTTPDOCROOT);
+    if (!prefix) return HTTP_NOT_FOUND;
+
+    if ((urls = config_getstring(IMAPOPT_HTTPALLOWEDURLS))) {
+        tok_t tok = TOK_INITIALIZER(urls, " \t", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+        char *token;
+
+        while ((token = tok_next(&tok)) && strcmp(token, txn->req_uri->path));
+        tok_fini(&tok);
+
+        if (!token) return HTTP_NOT_FOUND;
+    }
+
+    /* Construct path to script */
+    extra = strchr(txn->req_uri->path + strlen(namespace_cgi.prefix) + 1, '/');
+    buf_setcstr(&txn->buf, prefix);
+    if (extra)
+        buf_appendmap(&txn->buf, txn->req_uri->path, extra - txn->req_uri->path);
+    else buf_appendcstr(&txn->buf, txn->req_uri->path);
+    script = buf_release(&txn->buf);
+    cwd = strconcat(prefix, namespace_cgi.prefix, NULL);
+
+    /* See if script exists */
+    if (stat(script, &sbuf) || !S_ISREG(sbuf.st_mode)) {
+        ret = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* See if script is executable */
+    if (access(script, X_OK)) {
+        syslog(LOG_ERR, "CGI script %s is not executable",
+               txn->req_uri->path);
+        txn->error.desc = "CGI script is not executable";
+        ret = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Construct environment for script */
+    buf_setcstr(&txn->buf, "GATEWAY_INTERFACE=CGI/1.1");
+    if ((hdr = spool_getheader(txn->req_hdrs, "Content-Length"))) {
+        buf_printf(&txn->buf, "\tCONTENT_LENGTH=%s", hdr[0]);
+    }
+    if ((hdr = spool_getheader(txn->req_hdrs, "Content-Type"))) {
+        buf_printf(&txn->buf, "\tCONTENT_TYPE=%s", hdr[0]);
+    }
+    buf_printf(&txn->buf, "\tPATH_INFO=%s", extra ? extra : "");
+    if (extra) {
+        buf_printf(&txn->buf, "\tPATH_TRANSLATED=%s%s", prefix, extra);
+    }
+    buf_printf(&txn->buf, "\tQUERY_STRING=%s",
+               (query = URI_QUERY(txn->req_uri)) ? query : "");
+    buf_printf(&txn->buf, "\tREMOTE_ADDR=%.*s",
+               (int) (httpd_remoteip ? strcspn(httpd_remoteip, ";") : 0),
+               httpd_remoteip);
+    buf_printf(&txn->buf, "\tREMOTE_HOST=%.*s",
+               (int) (txn->conn->clienthost ?
+                      strcspn(txn->conn->clienthost, " ") : 0),
+               txn->conn->clienthost);
+    if (httpd_userid) {
+        buf_printf(&txn->buf, "\tREMOTE_USER=%s", httpd_userid);
+
+        if (txn->auth_chal.scheme) {
+            buf_printf(&txn->buf, "\tAUTH_TYPE=%s", txn->auth_chal.scheme->name);
+        }
+    }
+    buf_printf(&txn->buf, "\tREQUEST_METHOD=%s", http_methods[txn->meth].name);
+    buf_printf(&txn->buf, "\tSCRIPT_NAME=%s", script + strlen(prefix));
+    buf_printf(&txn->buf, "\tSERVER_NAME=%s", config_servername);
+    buf_printf(&txn->buf, "\tSERVER_PORT=%s",
+               (port = strchr(httpd_localip ? httpd_localip : "", ';')) ?
+               port + 1 : (https ? "443" : "80"));
+    buf_printf(&txn->buf, "\tSERVER_PROTOCOL=%s", HTTP_VERSION);
+    buf_printf(&txn->buf, "\tSERVER_SOFTWARE=%s", buf_cstring(&serverinfo));
+
+    /* Add some HTTP headers from request */
+    spool_enum_hdrcache(txn->req_hdrs, &req_hdr_to_env, &txn->buf);
+
+    env = strarray_splitm(buf_release(&txn->buf), "\t", 0);
+    strarray_append(env, NULL);
+    environ = env->data;
+
+    /* Run script */
+    if (command_popen(&cmd, "rw", cwd, script, NULL)) {
+        ret = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Send request body */
+    prot_putbuf(cmd->stdin_prot, &txn->req_body.payload);
+    prot_flush(cmd->stdin_prot);
+
+    /* Read response headers */
+    ret = http_read_headers(cmd->stdout_prot,
+                            0 /* read_sep */, &resp_hdrs, &errstr);
+    if (ret) {
+        syslog(LOG_ERR, "Failed to read headers from CGI script %s",
+               txn->req_uri->path);
+        txn->error.desc = "Failed to read headers from CGI script";
+        ret = HTTP_SERVER_ERROR;
+    }
+    else {
+        /* Read [CR]LF separating headers and body */
+        int c = prot_getc(cmd->stdout_prot);
+
+        if (c == '\r') c = prot_getc(cmd->stdout_prot);
+        if (c != '\n') {
+            syslog(LOG_ERR, "Failed to read newline from CGI script %s",
+                   txn->req_uri->path);
+            txn->error.desc = "Failed to read newline from CGI script";
+            ret = HTTP_SERVER_ERROR;
+        }
+
+        if (!ret) {
+            /* Check for and read response body */
+            hdr = spool_getheader(resp_hdrs, "Content-Type");
+            if (hdr) {
+                txn->resp_body.type = hdr[0];
+
+                resp_body.flags = BODY_RESPONSE | BODY_CLOSE;
+                ret = http_read_body(cmd->stdout_prot,
+                                     resp_hdrs, &resp_body, &errstr);
+                if (ret) {
+                    syslog(LOG_ERR, "Failed to body from CGI script %s",
+                           txn->req_uri->path);
+                    txn->error.desc = "Failed to read body from CGI script";
+                    ret = HTTP_SERVER_ERROR;
+                }
+            }
+        }
+    }
+
+    if (command_pclose(&cmd)) ret = HTTP_SERVER_ERROR;
+
+    if (ret) goto done;
+
+    /* Check for a status code */
+    hdr = spool_getheader(resp_hdrs, "Status");
+    if (hdr) code = http_status_to_code(atoi(hdr[0]));
+
+    /* Check the type of the CGI response */
+    hdr = spool_getheader(resp_hdrs, "Location");
+    if (hdr) {
+        /* Redirect */
+        if (hdr[0][0] == '/') {
+            /* Local Redirect */
+            txn->flags.redirect = 1;
+
+            /* Reset the URI part of our current transaction */
+            xmlFreeURI(txn->req_uri);
+            free_hash_table(&txn->req_qparams, (void (*)(void *)) &freestrlist);
+
+            /* Examine new request */
+            ret = examine_request(txn, hdr[0]);
+
+            /* Reprocess the requested method on new URI */
+            if (!ret) ret = process_request(txn);
+
+            goto done;
+        }
+        else {
+            /* Client Redirect */
+            if (!code) code = HTTP_FOUND;
+            txn->location = hdr[0];
+        }
+    }
+    else {
+        /* Document */
+        if (!code) code = HTTP_OK;
+    }
+
+    /* Output response */
+    txn->resp_body.extra_hdrs = resp_hdrs;
+    write_body(code, txn,
+               buf_base(&resp_body.payload), buf_len(&resp_body.payload));
+
+  done:
+    spool_free_hdrcache(resp_hdrs);
+    buf_free(&resp_body.payload);
+    strarray_free(env);
+    free(script);
+    free(cwd);
+
+    return ret;
+}
+
+/* Perform a POST request */
+static int meth_post(struct transaction_t *txn, void *params)
+{
+    int ret;
+
+    /* Read request body */
+    txn->req_body.flags |= BODY_DECODE;
+    ret = http_read_req_body(txn);
+
+    if (ret) {
+        txn->flags.conn = CONN_CLOSE;
+        return ret;
+    }
+
+    return meth_get(txn, params);
+}
diff -pruN 3.0.13-5/imap/http_client.c 3.2.0-3/imap/http_client.c
--- 3.0.13-5/imap/http_client.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_client.c	2020-04-24 02:03:00.000000000 +0000
@@ -238,23 +238,15 @@ EXPORTED int http_read_headers(struct pr
  * Handles close-delimited response bodies (no Content-Length specified)
  * Handles gzip and deflate CE only.
  */
-EXPORTED int http_read_body(struct protstream *pin, struct protstream *pout,
-                            hdrcache_t hdrs, struct body_t *body,
-                            const char **errstr)
+EXPORTED int http_read_body(struct protstream *pin, hdrcache_t hdrs,
+                            struct body_t *body, const char **errstr)
 {
     char buf[PROT_BUFSIZE];
     unsigned n;
     int r = 0;
 
-    syslog(LOG_DEBUG, "read_body(flags=%#x, framing=%d)", body->flags, body->framing);
-
-    if (body->flags & BODY_DONE) return 0;
-    body->flags |= BODY_DONE;
-
-    if ((body->flags & BODY_DISCARD) && (body->flags & BODY_CONTINUE)) {
-        /* Don't care about the body and client hasn't sent it, we're done */
-        return 0;
-    }
+    syslog(LOG_DEBUG, "http_read_body(flags=%#x, framing=%d)",
+           body->flags, body->framing);
 
     if (body->framing == FRAMING_UNKNOWN) {
         /* Get message framing */
@@ -262,13 +254,6 @@ EXPORTED int http_read_body(struct prots
         if (r) return r;
     }
 
-    if (body->flags & BODY_CONTINUE) {
-        /* Tell client to send the body */
-        prot_printf(pout, "%s %s\r\n\r\n",
-                    HTTP_VERSION, error_message(HTTP_CONTINUE));
-        prot_flush(pout);
-    }
-
     /* Read and buffer the body */
     switch (body->framing) {
     case FRAMING_HTTP2:
@@ -487,7 +472,7 @@ EXPORTED int http_read_response(struct b
             body->flags |= BODY_RESPONSE;
             body->framing = FRAMING_UNKNOWN;
 
-            if (http_read_body(be->in, be->out, *hdrs, body, errstr)) {
+            if (http_read_body(be->in, *hdrs, body, errstr)) {
                 return HTTP_BAD_GATEWAY;
             }
         }
@@ -495,3 +480,83 @@ EXPORTED int http_read_response(struct b
 
     return 0;
 }
+
+
+/* Convert a HTTP status to one of our error codes */
+EXPORTED long http_status_to_code(unsigned status)
+{
+    int i, len, n_msgs = et_http_error_table.n_msgs;
+    const char * const *msgs = et_http_error_table.msgs;
+    char buf[100];
+
+    len = snprintf(buf, sizeof(buf), "%u ", status);
+
+    for (i = 0; i < n_msgs; i++) {
+        if (!strncmp(msgs[i], buf, len)) return et_http_error_table.base + i;
+    }
+
+    return HTTP_SERVER_ERROR;
+}
+
+
+EXPORTED int http_parse_auth_params(const char *params,
+                                    const char **realm, unsigned int *realm_len,
+                                    const char **sid, unsigned int *sid_len,
+                                    const char **data, unsigned int *data_len)
+{
+    const char *param = params;
+
+    if (realm) {
+        *realm = NULL;
+        *realm_len = 0;
+    }
+    if (sid) {
+        *sid = NULL;
+        *sid_len = 0;
+    }
+    if (data) {
+        *data = NULL;
+        *data_len = 0;
+    }
+
+    while (param && *param) {
+        size_t tok_len, val_len;
+        const char *value;
+
+        /* Trim leading and trailing BWS */
+        while (strchr(", \t", *param)) param++;
+        tok_len = strcspn(param, "= \t");
+
+        /* Find value */
+        value = strchr(param + tok_len, '=');
+        if (!value) {
+            syslog(LOG_ERR,
+                   "Missing value for '%.*s' parameter in credentials",
+                   (int) tok_len, param);
+            return SASL_BADAUTH;
+        }
+
+        /* Trim leading and trailing BWS */
+        while (strchr(" \t", *++value));
+        val_len = strcspn(value, ", \t");
+
+        /* Check known parameters */
+        if (realm && !strncmp("realm", param, tok_len)) {
+            *realm = value;
+            *realm_len = val_len;
+        }
+        else if (sid && !strncmp("sid", param, tok_len)) {
+            *sid = value;
+            *sid_len = val_len;
+        }
+        else if (data && !strncmp("data", param, tok_len)) {
+            *data = value;
+            *data_len = val_len;
+        }
+
+        /* Find next param */
+        param = strchr(value + val_len, ',');
+    }
+
+    return SASL_OK;
+}
diff -pruN 3.0.13-5/imap/http_client.h 3.2.0-3/imap/http_client.h
--- 3.0.13-5/imap/http_client.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_client.h	2020-04-24 02:03:00.000000000 +0000
@@ -94,6 +94,7 @@ enum {
 enum {
     METH_ACL = 0,
     METH_BIND,
+    METH_CONNECT,
     METH_COPY,
     METH_DELETE,
     METH_GET,
@@ -122,11 +123,15 @@ extern int http_parse_framing(int http2,
                               const char **errstr);
 extern int http_read_headers(struct protstream *pin, int read_sep,
                              hdrcache_t *hdrs, const char **errstr);
-extern int http_read_body(struct protstream *pin, struct protstream *pout,
-                          hdrcache_t hdrs, struct body_t *body,
-                          const char **errstr);
+extern int http_read_body(struct protstream *pin, hdrcache_t hdrs,
+                          struct body_t *body, const char **errstr);
 extern int http_read_response(struct backend *be, unsigned meth, unsigned *code,
                               hdrcache_t *hdrs, struct body_t *body,
                               const char **errstr);
+extern long http_status_to_code(unsigned status);
+extern int http_parse_auth_params(const char *params,
+                                  const char **realm, unsigned int *realm_len,
+                                  const char **sid, unsigned int *sid_len,
+                                  const char **data, unsigned int *data_len);
 
 #endif /* _HTTP_CLIENT_H */
diff -pruN 3.0.13-5/imap/http_dav.c 3.2.0-3/imap/http_dav.c
--- 3.0.13-5/imap/http_dav.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_dav.c	2020-05-04 03:28:02.000000000 +0000
@@ -49,7 +49,7 @@
  *   - CALDAV:schedule-calendar-transp should be a flag in
  *     cyrus.index header (Mailbox Options)
  *
- *   - DAV:creationdate sould be added to cyrus.header since it only
+ *   - DAV:creationdate should be added to cyrus.header since it only
  *     gets set at creation time
  *
  *   - Should add a last_metadata_update field to cyrus.index header
@@ -62,14 +62,16 @@
  *
  */
 
-#include "http_dav.h"
+#include <sysexits.h>
+
 #include "annotate.h"
 #include "acl.h"
 #include "append.h"
 #include "caldav_db.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "global.h"
+#include "http_dav.h"
+#include "http_dav_sharing.h"
 #include "http_proxy.h"
 #include "index.h"
 #include "proxy.h"
@@ -77,9 +79,9 @@
 #include "syslog.h"
 #include "strhash.h"
 #include "tok.h"
+#include "user.h"
 #include "util.h"
 #include "version.h"
-#include "webdav_db.h"
 #include "xmalloc.h"
 #include "xml_support.h"
 #include "xstrlcat.h"
@@ -90,6 +92,7 @@
 #include "imap/http_err.h"
 #include "imap/imap_err.h"
 
+#include <errno.h>
 #include <libxml/uri.h>
 
 static const struct dav_namespace_t {
@@ -128,23 +131,23 @@ static int server_info_size = 0;
 static time_t server_info_lastmod = 0;
 static struct buf server_info_token = BUF_INITIALIZER;
 static struct buf server_info_link = BUF_INITIALIZER;
-static struct webdav_db *auth_webdavdb = NULL;
 
 static void my_dav_init(struct buf *serverinfo);
-static void my_dav_auth(const char *userid);
-static void my_dav_reset(void);
 static void my_dav_shutdown(void);
 
 static int get_server_info(struct transaction_t *txn);
-static void get_synctoken(struct mailbox *mailbox,
-                          struct buf *buf, const char *prefix);
 
+static unsigned long principal_allow_cb(struct request_target_t *tgt);
 static int principal_parse_path(const char *path, struct request_target_t *tgt,
-                                const char **errstr);
-static int propfind_displayname(const xmlChar *name, xmlNsPtr ns,
-                                struct propfind_ctx *fctx,
-                                xmlNodePtr prop, xmlNodePtr resp,
-                                struct propstat propstat[], void *rock);
+                                const char **resultstr);
+static int propfind_principalname(const xmlChar *name, xmlNsPtr ns,
+                                  struct propfind_ctx *fctx,
+                                  xmlNodePtr prop, xmlNodePtr resp,
+                                  struct propstat propstat[], void *rock);
+static int proppatch_principalname(xmlNodePtr prop, unsigned set,
+                                   struct proppatch_ctx *pctx,
+                                   struct propstat propstat[],
+                                   void *rock);
 static int propfind_restype(const xmlChar *name, xmlNsPtr ns,
                             struct propfind_ctx *fctx,
                             xmlNodePtr prop, xmlNodePtr resp,
@@ -153,14 +156,6 @@ static int propfind_alturiset(const xmlC
                               struct propfind_ctx *fctx,
                               xmlNodePtr prop, xmlNodePtr resp,
                               struct propstat propstat[], void *rock);
-static int propfind_notifyurl(const xmlChar *name, xmlNsPtr ns,
-                              struct propfind_ctx *fctx,
-                              xmlNodePtr prop, xmlNodePtr resp,
-                              struct propstat propstat[], void *rock);
-
-
-static int propfind_csnotify_collection(struct propfind_ctx *fctx,
-                                        xmlNodePtr props);
 
 static int principal_search(const char *userid, void *rock);
 static int report_prin_prop_search(struct transaction_t *txn,
@@ -176,6 +171,7 @@ static int allprop_cb(const char *mailbo
                       uint32_t uid __attribute__((unused)),
                       const char *entry,
                       const char *userid, const struct buf *attrib,
+                      const struct annotate_metadata *mdata __attribute__((unused)),
                       void *rock);
 
 /* Array of supported REPORTs */
@@ -198,71 +194,104 @@ static const struct report_type_t princi
 static const struct prop_entry principal_props[] = {
 
     /* WebDAV (RFC 4918) properties */
-    { "creationdate", NS_DAV, PROP_ALLPROP, NULL, NULL, NULL },
-    { "displayname", NS_DAV, PROP_ALLPROP | PROP_COLLECTION,
-      propfind_displayname, NULL, NULL },
-    { "getcontentlanguage", NS_DAV, PROP_ALLPROP, NULL, NULL, NULL },
-    { "getcontentlength", NS_DAV, PROP_ALLPROP | PROP_COLLECTION,
+    { "creationdate", NS_DAV,
+      PROP_ALLPROP, NULL, NULL, NULL },
+    { "displayname", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION,
+      propfind_principalname, proppatch_principalname, NULL },
+    { "getcontentlanguage", NS_DAV,
+      PROP_ALLPROP, NULL, NULL, NULL },
+    { "getcontentlength", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_getlength, NULL, NULL },
-    { "getcontenttype", NS_DAV, PROP_ALLPROP, NULL, NULL, NULL },
-    { "getetag", NS_DAV, PROP_ALLPROP, NULL, NULL, NULL },
-    { "getlastmodified", NS_DAV, PROP_ALLPROP, NULL, NULL, NULL },
-    { "lockdiscovery", NS_DAV, PROP_ALLPROP | PROP_COLLECTION,
+    { "getcontenttype", NS_DAV,
+      PROP_ALLPROP, NULL, NULL, NULL },
+    { "getetag", NS_DAV,
+      PROP_ALLPROP, NULL, NULL, NULL },
+    { "getlastmodified", NS_DAV,
+      PROP_ALLPROP, NULL, NULL, NULL },
+    { "lockdiscovery", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_lockdisc, NULL, NULL },
-    { "resourcetype", NS_DAV, PROP_ALLPROP | PROP_COLLECTION,
+    { "resourcetype", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_restype, NULL, NULL },
-    { "supportedlock", NS_DAV, PROP_ALLPROP | PROP_COLLECTION,
+    { "supportedlock", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_suplock, NULL, NULL },
 
     /* WebDAV Versioning (RFC 3253) properties */
-    { "supported-report-set", NS_DAV, PROP_COLLECTION,
+    { "supported-report-set", NS_DAV,
+      PROP_COLLECTION,
       propfind_reportset, NULL, (void *) principal_reports },
+    { "supported-method-set", NS_DAV,
+      PROP_COLLECTION,
+      propfind_methodset, NULL, (void *) &principal_allow_cb },
 
     /* WebDAV ACL (RFC 3744) properties */
-    { "alternate-URI-set", NS_DAV, PROP_COLLECTION,
+    { "alternate-URI-set", NS_DAV,
+      PROP_COLLECTION,
       propfind_alturiset, NULL, NULL },
-    { "principal-URL", NS_DAV, PROP_COLLECTION,
+    { "principal-URL", NS_DAV,
+      PROP_COLLECTION,
       propfind_principalurl, NULL, NULL },
-    { "group-member-set", NS_DAV, 0, NULL, NULL, NULL },
-    { "group-membership", NS_DAV, 0, NULL, NULL, NULL },
-    { "principal-collection-set", NS_DAV, PROP_COLLECTION,
+    { "group-member-set", NS_DAV,
+      PROP_COLLECTION,
+      NULL, NULL, NULL },
+    { "group-membership", NS_DAV,
+      PROP_COLLECTION,
+      NULL, NULL, NULL },
+    { "principal-collection-set", NS_DAV,
+      PROP_COLLECTION,
       propfind_princolset, NULL, NULL },
 
     /* WebDAV Current Principal (RFC 5397) properties */
-    { "current-user-principal", NS_DAV, PROP_COLLECTION,
+    { "current-user-principal", NS_DAV,
+      PROP_COLLECTION,
       propfind_curprin, NULL, NULL },
 
     /* CalDAV (RFC 4791) properties */
-    { "calendar-home-set", NS_CALDAV, PROP_COLLECTION,
+    { "calendar-home-set", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calurl, NULL, NULL },
 
     /* CalDAV Scheduling (RFC 6638) properties */
-    { "schedule-inbox-URL", NS_CALDAV, PROP_COLLECTION,
+    { "schedule-inbox-URL", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calurl, NULL, SCHED_INBOX },
-    { "schedule-outbox-URL", NS_CALDAV, PROP_COLLECTION,
+    { "schedule-outbox-URL", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calurl, NULL, SCHED_OUTBOX },
-    { "calendar-user-address-set", NS_CALDAV, PROP_COLLECTION,
-      propfind_caluseraddr, NULL, NULL },
-    { "calendar-user-type", NS_CALDAV, PROP_COLLECTION,
+    { "calendar-user-address-set", NS_CALDAV,
+      PROP_COLLECTION,
+      propfind_caluseraddr, proppatch_caluseraddr, NULL },
+    { "calendar-user-type", NS_CALDAV,
+      PROP_COLLECTION,
       propfind_calusertype, NULL, NULL },
 
     /* CardDAV (RFC 6352) properties */
-    { "addressbook-home-set", NS_CARDDAV, PROP_COLLECTION,
+    { "addressbook-home-set", NS_CARDDAV,
+      PROP_COLLECTION,
       propfind_abookhome, NULL, NULL },
 
     /* WebDAV Notifications (draft-pot-webdav-notifications) properties */
-    { "notification-URL", NS_DAV, PROP_COLLECTION,
+    { "notification-URL", NS_DAV,
+      PROP_COLLECTION,
       propfind_notifyurl, NULL, NULL },
 
     /* Backwards compatibility with Apple notifications clients */
-    { "notification-URL", NS_CS, PROP_COLLECTION,
+    { "notification-URL", NS_CS,
+      PROP_COLLECTION,
       propfind_notifyurl, NULL, NULL },
+    { "email-address-set", NS_CS,
+      PROP_COLLECTION,
+      propfind_caluseremail, NULL, NULL },
 
     { NULL, 0, 0, NULL, NULL, NULL }
 };
 
 
-static struct meth_params princ_params = {
+struct meth_params princ_params = {
     .parse_path = &principal_parse_path,
     .propfind = { 0, principal_props },
     .reports = principal_reports
@@ -270,15 +299,16 @@ static struct meth_params princ_params =
 
 /* Namespace for WebDAV principals */
 struct namespace_t namespace_principal = {
-    URL_NS_PRINCIPAL, 0, "/dav/principals", NULL,
+    URL_NS_PRINCIPAL, 0, "principal", "/dav/principals", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     /*mbtype */ 0,
-    ALLOW_READ | ALLOW_DAV,
-    &my_dav_init, &my_dav_auth, &my_dav_reset, &my_dav_shutdown, &dav_premethod,
+    ALLOW_READ | ALLOW_DAV | ALLOW_PROPPATCH,
+    &my_dav_init, NULL, NULL, &my_dav_shutdown, &dav_premethod,
     /*bearer*/NULL,
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get_head,       &princ_params },        /* GET          */
@@ -291,7 +321,7 @@ struct namespace_t namespace_principal =
         { NULL,                 NULL },                 /* PATCH        */
         { NULL,                 NULL },                 /* POST         */
         { &meth_propfind,       &princ_params },        /* PROPFIND     */
-        { NULL,                 NULL },                 /* PROPPATCH    */
+        { &meth_proppatch,      &princ_params },        /* PROPPATCH    */
         { NULL,                 NULL },                 /* PUT          */
         { &meth_report,         &princ_params },        /* REPORT       */
         { &meth_trace,          NULL },                 /* TRACE        */
@@ -332,7 +362,7 @@ static const struct precond_t {
     /* Placeholder for zero (no) precondition code */
     { NULL, 0 },
 
-    /* WebDAV (RFC 4918) preconditons */
+    /* WebDAV (RFC 4918) preconditions */
     { "cannot-modify-protected-property", NS_DAV },
     { "lock-token-matches-request-uri", NS_DAV },
     { "lock-token-submitted", NS_DAV },
@@ -417,36 +447,44 @@ static const struct precond_t {
 };
 
 
-/* Check ACL on userid's principal (Inbox): LOOKUP right gives access */
+/* Check ACL on userid's principal (Inbox): ACL_LOOKUP right gives access */
 static int principal_acl_check(const char *userid, struct auth_state *authstate)
 {
     int r = 0;
 
     if (!httpd_userisadmin) {
-        char *inboxname = mboxname_user_mbox(userid, NULL);
+        char *mboxname = caldav_mboxname(userid, NULL);
         mbentry_t *mbentry = NULL;
 
-        r = http_mlookup(inboxname, &mbentry, NULL);
+        r = http_mlookup(mboxname, &mbentry, NULL);
         if (r) {
             syslog(LOG_ERR, "mlookup(%s) failed: %s",
-                   inboxname, error_message(r));
+                   mboxname, error_message(r));
             r = HTTP_NOT_FOUND;
         }
         else if (!(httpd_myrights(authstate, mbentry) & ACL_LOOKUP)) {
+            // allow READ (for owner) or USER6 (to grant access generally without anything else)
             r = HTTP_NOT_FOUND;
         }
 
         mboxlist_entry_free(&mbentry);
-        free(inboxname);
+        free(mboxname);
     }
 
     return r;
 }
 
 
+/* Determine allowed methods in DAV principals namespace */
+static unsigned long principal_allow_cb(struct request_target_t *tgt)
+{
+    return tgt->namespace->allow;
+}
+
+
 /* Parse request-target path in DAV principals namespace */
 static int principal_parse_path(const char *path, struct request_target_t *tgt,
-                                const char **errstr)
+                                const char **resultstr)
 {
     char *p;
     size_t len;
@@ -462,12 +500,12 @@ static int principal_parse_path(const ch
     if (strlen(p) < len ||
         strncmp(namespace_principal.prefix, p, len) ||
         (path[len] && path[len] != '/')) {
-        *errstr = "Namespace mismatch request target path";
+        *resultstr = "Namespace mismatch request target path";
         return HTTP_FORBIDDEN;
     }
 
-    /* Skip namespace */
-    p += len;
+    /* Skip past namespace (and any extra '/') */
+    for (p += len; p[1] == '/'; p++);
     if (!*p || !*++p) {
         /* Make sure collection is terminated with '/' */
         if (p[-1] != '/') *p++ = '/';
@@ -477,7 +515,8 @@ static int principal_parse_path(const ch
     /* Check if we're in user space */
     len = strcspn(p, "/");
     if (!strncmp(p, USER_COLLECTION_PREFIX, len)) {
-        p += len;
+        /* Skip past user prefix (and any extra '/') */
+        for (p += len; p[1] == '/'; p++);
         if (!*p || !*++p) {
             /* Make sure collection is terminated with '/' */
             if (p[-1] != '/') *p++ = '/';
@@ -494,8 +533,9 @@ static int principal_parse_path(const ch
                 *at = 0;
         }
 
-        p += len;
-        if (!*p || !*++p) return 0;
+        /* Skip past userid (and any extra '/') */
+        for (p += len; p[1] == '/'; p++);
+        if (!*p || !*++p) goto mailbox;
     }
     else if (!strncmp(p, SERVER_INFO, len)) {
         p += len;
@@ -507,24 +547,94 @@ static int principal_parse_path(const ch
     else return HTTP_NOT_FOUND;  /* need to specify a userid */
 
     if (*p) {
-//      *errstr = "Too many segments in request target path";
+//      *resultstr = "Too many segments in request target path";
         return HTTP_NOT_FOUND;
     }
 
+  mailbox:
+    /* Create mailbox name from the parsed path */
+
+    if (tgt->userid) {
+        /* Locate the mailbox */
+        char *mboxname = caldav_mboxname(tgt->userid, NULL);
+        int r = http_mlookup(mboxname, &tgt->mbentry, NULL);
+
+        if (r) {
+            *resultstr = error_message(r);
+            syslog(LOG_ERR, "mlookup(%s) failed: %s", mboxname, *resultstr);
+        }
+        free(mboxname);
+
+        switch (r) {
+        case 0:
+            break;
+
+        case IMAP_PERMISSION_DENIED:
+            return HTTP_FORBIDDEN;
+
+        case IMAP_MAILBOX_NONEXISTENT:
+            return HTTP_NOT_FOUND;
+
+        default:
+            return HTTP_SERVER_ERROR;
+        }
+    }
+
     return 0;
 }
 
 
-/* Parse request-target path in Cal/CardDAV namespace */
+/* Determine allowed methods in Cal/CardDAV namespace */
+EXPORTED unsigned long calcarddav_allow_cb(struct request_target_t *tgt)
+{
+    unsigned long allow = tgt->namespace->allow;
+
+    if (!tgt->userid) {
+        allow &= ALLOW_READ_MASK;
+    }
+    else if (!tgt->collection) {
+        allow &= ~(ALLOW_DELETE | ALLOW_PATCH | ALLOW_POST | ALLOW_WRITE);
+    }
+    else if (!tgt->resource) {
+        allow &= ~(ALLOW_MKCOL | ALLOW_PATCH);
+    }
+    else {
+        allow &= ~(ALLOW_MKCOL | ALLOW_POST);
+    }
+
+    return allow;
+}
+
+
+/* Parse request-target path in *DAV namespace */
+EXPORTED int dav_parse_req_target(struct transaction_t *txn,
+                                  struct meth_params *params)
+{
+    const char *resultstr = NULL;
+    int r;
+
+    r = params->parse_path(txn->req_uri->path, &txn->req_tgt, &resultstr);
+    if (r) {
+        if (r == HTTP_MOVED) txn->location = resultstr;
+        else txn->error.desc = resultstr;
+    }
+
+    return r;
+}
+
+
+/* Parse a path in Cal/CardDAV namespace */
 EXPORTED int calcarddav_parse_path(const char *path,
                                    struct request_target_t *tgt,
                                    const char *mboxprefix,
-                                   const char **errstr)
+                                   const char **resultstr)
 {
     char *p, *owner = NULL, *collection = NULL, *freeme = NULL;
     size_t len;
     const char *mboxname;
     mbname_t *mbname = NULL;
+    int ret = 0;
+    static struct buf redirect_buf = BUF_INITIALIZER;
 
     if (*tgt->path) return 0;  /* Already parsed */
 
@@ -538,7 +648,7 @@ EXPORTED int calcarddav_parse_path(const
     len = strlen(tgt->namespace->prefix);
     if (strlen(p) < len ||
         strncmp(tgt->namespace->prefix, p, len) || (path[len] && path[len] != '/')) {
-        *errstr = "Namespace mismatch request target path";
+        *resultstr = "Namespace mismatch request target path";
         return HTTP_FORBIDDEN;
     }
 
@@ -547,8 +657,8 @@ EXPORTED int calcarddav_parse_path(const
     /* Default to bare-bones Allow bits */
     tgt->allow &= ALLOW_READ_MASK;
 
-    /* Skip namespace */
-    p += len;
+    /* Skip past namespace (and any extra '/') */
+    for (p += len; p[1] == '/'; p++);
     if (!*p || !*++p) return 0;
 
     /* Check if we're in user space */
@@ -556,18 +666,23 @@ EXPORTED int calcarddav_parse_path(const
     /* zzzz is part of the FastMail sorting hack to make shared collections
      * always appear later */
     if (!strncmp(p, USER_COLLECTION_PREFIX, len) || !strncmp(p, "zzzz", len)) {
-        p += len;
+        if (!strncmp(p, "zzzz", len))
+            tgt->flags |= TGT_USER_ZZZZ;
+
+        /* Skip past user prefix (and any extra '/') */
+        for (p += len; p[1] == '/'; p++);
         if (!*p || !*++p) return 0;
 
         /* Get user id */
         len = strcspn(p, "/");
         tgt->userid = xstrndup(p, len);
 
-        p += len;
+        /* Skip past userid (and any extra '/') */
+        for (p += len; p[1] == '/'; p++);
         if (!*p || !*++p) {
             /* Make sure home-set is terminated with '/' */
             if (p[-1] != '/') *p++ = '/';
-            goto done;
+            goto mailbox;
         }
 
         len = strcspn(p, "/");
@@ -577,11 +692,12 @@ EXPORTED int calcarddav_parse_path(const
     tgt->collection = p;
     tgt->collen = len;
 
-    p += len;
+    /* Skip past collection (and any extra '/') */
+    for (p += len; p[1] == '/'; p++);
     if (!*p || !*++p) {
         /* Make sure collection is terminated with '/' */
         if (p[-1] != '/') *p++ = '/';
-        goto done;
+        goto mailbox;
     }
 
     /* Get resource */
@@ -592,26 +708,33 @@ EXPORTED int calcarddav_parse_path(const
     p += len;
 
     if (*p) {
-//      *errstr = "Too many segments in request target path";
+//      *resultstr = "Too many segments in request target path";
         return HTTP_NOT_FOUND;
     }
 
-  done:
+  mailbox:
     /* Create mailbox name from the parsed path */
 
     owner = tgt->userid;
     if (tgt->collen) {
         collection = freeme = xstrndup(tgt->collection, tgt->collen);
 
-        /* Shared collection encoded as: <owner> "." <mboxname> */
-        if (!tgt->mbentry &&  /* Not MKCOL or COPY/MOVE destination */
-            (p = strrchr(collection, SHARED_COLLECTION_DELIM))) {
-            owner = collection;
-            *p++ = '\0';
-            collection = p;
+        p = strrchr(collection, SHARED_COLLECTION_DELIM);
+        if (p) {
+            if (tgt->mbentry) { /* MKCOL or COPY/MOVE destination */
+                *resultstr = "Invalid characters in collection name";
+                ret = HTTP_FORBIDDEN;
+                goto done;
+            }
+            else {
+                /* Shared collection encoded as: <owner> "." <mboxname> */
+                owner = collection;
+                *p++ = '\0';
+                collection = p;
 
-            tgt->flags = TGT_DAV_SHARED;
-            tgt->allow |= ALLOW_DELETE;
+                tgt->flags = TGT_DAV_SHARED;
+                tgt->allow |= ALLOW_DELETE;
+            }
         }
     }
 
@@ -620,44 +743,70 @@ EXPORTED int calcarddav_parse_path(const
     mbname_push_boxes(mbname, mboxprefix);
     if (collection) {
         mbname_push_boxes(mbname, collection);
-        free(freeme);
     }
 
     /* XXX - hack to allow @domain parts for non-domain-split users */
     if (httpd_extradomain) {
         /* not allowed to be cross domain */
         if (mbname_localpart(mbname) &&
-            strcmpsafe(mbname_domain(mbname), httpd_extradomain))
-            return HTTP_NOT_FOUND;
+            strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
+            ret = HTTP_NOT_FOUND;
+            goto done;
+        }
         mbname_set_domain(mbname, NULL);
     }
 
     mboxname = mbname_intname(mbname);
 
+    /* Check for FastMail legacy sharing URLs and redirect */
+    if (httpd_userid && !config_getswitch(IMAPOPT_FASTMAILSHARING) &&
+        tgt->flags != TGT_DAV_SHARED &&
+        !mboxname_userownsmailbox(httpd_userid, mboxname)) {
+        buf_reset(&redirect_buf);
+        buf_printf(&redirect_buf, "%s/%s/%s/%s%c%s",
+                 tgt->namespace->prefix, USER_COLLECTION_PREFIX,
+                 httpd_userid, tgt->userid, SHARED_COLLECTION_DELIM,
+                 tgt->collection);
+        *resultstr = buf_cstring(&redirect_buf);
+
+        ret = HTTP_MOVED;
+        goto done;
+    }
+
     if (tgt->mbentry) {
         /* Just return the mboxname (MKCOL or COPY/MOVE destination) */
         tgt->mbentry->name = xstrdup(mboxname);
 
-        if (!mboxlist_createmailboxcheck(mboxname, 0, NULL, httpd_userisadmin,
-                                         httpd_userid, httpd_authstate,
-                                         NULL, NULL, 0 /* force */)) {
-            tgt->allow |= ALLOW_MKCOL;
-        }
+        ret = mboxlist_createmailboxcheck(mboxname, 0, NULL, httpd_userisadmin,
+                                          httpd_userid, httpd_authstate,
+                                          NULL, NULL, 0 /* force */);
+        if (ret) goto done;
+
+        tgt->allow |= ALLOW_MKCOL;
     }
     else if (*mboxname) {
         /* Locate the mailbox */
         int r = http_mlookup(mboxname, &tgt->mbentry, NULL);
+
         if (r) {
-            syslog(LOG_ERR, "mlookup(%s) failed: %s",
-                   mboxname, error_message(r));
-            *errstr = error_message(r);
-            mbname_free(&mbname);
+            *resultstr = error_message(r);
+            syslog(LOG_ERR, "mlookup(%s) failed: %s", mboxname, *resultstr);
 
             switch (r) {
-            case IMAP_PERMISSION_DENIED: return HTTP_FORBIDDEN;
-            case IMAP_MAILBOX_NONEXISTENT: return HTTP_NOT_FOUND;
-            default: return HTTP_SERVER_ERROR;
+            case IMAP_PERMISSION_DENIED:
+                ret = HTTP_FORBIDDEN;
+                break;
+
+            case IMAP_MAILBOX_NONEXISTENT:
+                ret = HTTP_NOT_FOUND;
+                break;
+
+            default:
+                ret = HTTP_SERVER_ERROR;
+                break;
             }
+
+            goto done;
         }
     }
 
@@ -671,12 +820,61 @@ EXPORTED int calcarddav_parse_path(const
     }
     else if (tgt->userid) tgt->allow |= ALLOW_MKCOL;
 
+  done:
     mbname_free(&mbname);
+    free(freeme);
+
+    return ret;
+}
+
+
+EXPORTED int dav_get_validators(struct mailbox *mailbox, void *data,
+                                const char *userid __attribute__((unused)),
+                                struct index_record *record,
+                                const char **etag, time_t *lastmod)
+{
+    const struct dav_data *ddata = (const struct dav_data *) data;
+
+    memset(record, 0, sizeof(struct index_record));
+
+    if (!ddata->alive) {
+        /* New resource */
+        if (etag) *etag = NULL;
+        if (lastmod) *lastmod = 0;
+    }
+    else if (ddata->imap_uid) {
+        /* Mapped URL */
+        int r;
+
+        /* Fetch index record for the resource */
+        r = mailbox_find_index_record(mailbox, ddata->imap_uid, record);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_find_index_record(%s, %u) failed: %s",
+                   mailbox->name, ddata->imap_uid, error_message(r));
+            return r;
+        }
+
+        if (etag) *etag = message_guid_encode(&record->guid);
+        if (lastmod) *lastmod = record->internaldate;
+    }
+    else {
+        /* Unmapped URL (empty resource) */
+        if (etag) *etag = NULL;
+        if (lastmod) *lastmod = ddata->creationdate;
+    }
 
     return 0;
 }
 
 
+EXPORTED modseq_t dav_get_modseq(struct mailbox *mailbox __attribute__((unused)),
+                                 void *data,
+                                 const char *userid __attribute__((unused)))
+{
+    return ((struct dav_data *) data)->modseq;
+}
+
+
 /* Evaluate If header.  Note that we can't short-circuit any of the tests
    because we need to check for a lock-token anywhere in the header */
 static int eval_list(char *list, struct mailbox *mailbox, const char *etag,
@@ -710,10 +908,10 @@ static int eval_list(char *list, struct
             else if (mailbox) {
                 struct buf buf = BUF_INITIALIZER;
 
-                get_synctoken(mailbox, &buf, SYNC_TOKEN_URL_SCHEME);
+                dav_get_synctoken(mailbox, &buf, SYNC_TOKEN_URL_SCHEME);
                 r = !strcmp(cond, buf_cstring(&buf));
                 if (!r) {
-                    get_synctoken(mailbox, &buf, XML_NS_MECOM "ctag/");
+                    dav_get_synctoken(mailbox, &buf, XML_NS_MECOM "ctag/");
                     r = !strcmp(cond, buf_cstring(&buf));
                 }
                 buf_free(&buf);
@@ -729,6 +927,7 @@ static int eval_list(char *list, struct
 }
 
 static int eval_if(const char *hdr, struct meth_params *params,
+                   const struct namespace_t *namespace,
                    struct mailbox *tgt_mailbox, const char *tgt_resource,
                    const char *tgt_etag, const char *tgt_lock_token,
                    unsigned *locked)
@@ -765,6 +964,7 @@ static int eval_if(const char *hdr, stru
                 int r;
 
                 memset(&tag_tgt, 0, sizeof(struct request_target_t));
+                tag_tgt.namespace = namespace;
 
                 if (!params->parse_path(uri->path, &tag_tgt, &err)) {
                     if (tag_tgt.mbentry && !tag_tgt.mbentry->server) {
@@ -925,7 +1125,8 @@ EXPORTED int dav_check_precond(struct tr
        Per RFC 7232, LOCK errors supercede preconditions */
     if ((hdr = spool_getheader(hdrcache, "If"))) {
         /* State tokens (sync-token, lock-token) and Etags */
-        if (!eval_if(hdr[0], params, mailbox, txn->req_tgt.resource,
+        if (!eval_if(hdr[0], params, txn->req_tgt.namespace,
+                     mailbox, txn->req_tgt.resource,
                      etag, lock_token, &locked))
             return HTTP_PRECOND_FAILED;
     }
@@ -949,7 +1150,8 @@ EXPORTED int dav_premethod(struct transa
 
         if ((hdr && strcmp(hdr[0], buf_cstring(&server_info_token))) ||
             (!hdr && txn->meth == METH_OPTIONS)) {
-            txn->resp_body.link = buf_cstring(&server_info_link);
+            strarray_append(&txn->resp_body.links,
+                            buf_cstring(&server_info_link));
         }
     }
 
@@ -972,6 +1174,7 @@ EXPORTED unsigned get_preferences(struct
         mask = PREFER_REP;
         break;
 
+    case METH_GET:
     case METH_MKCALENDAR:
     case METH_MKCOL:
     case METH_PROPPATCH:
@@ -1149,7 +1352,10 @@ xmlNodePtr init_xml_response(const char
     xmlNodePtr root = NULL;
 
     if (!doc) return NULL;
-    if (!(root = xmlNewNode(NULL, BAD_CAST resp))) return NULL;
+    if (!(root = xmlNewNode(NULL, BAD_CAST resp))) {
+        xmlFreeDoc(doc);
+        return NULL;
+    }
 
     xmlDocSetRootElement(doc, root);
 
@@ -1255,10 +1461,9 @@ void xml_add_lockdisc(xmlNodePtr node, c
         xmlNewChild(active, NULL, BAD_CAST "depth", BAD_CAST "0");
 
         if (data->lock_owner) {
-            /* Last char of token signals href (1) or text (0) */
-            if (data->lock_token[strlen(data->lock_token)-1] == '1') {
+            if (!strncmp(data->lock_owner, "<DAV:href>", 10)) {
                 node1 = xmlNewChild(active, NULL, BAD_CAST "owner", NULL);
-                xml_add_href(node1, NULL, data->lock_owner);
+                xml_add_href(node1, NULL, data->lock_owner + 10);
             }
             else {
                 xmlNewTextChild(active, NULL, BAD_CAST "owner",
@@ -1311,7 +1516,8 @@ struct allprop_rock {
 
 /* Add a response tree to 'root' for the specified href and
    either error code or property list */
-int xml_add_response(struct propfind_ctx *fctx, long code, unsigned precond)
+int xml_add_response(struct propfind_ctx *fctx, long code, unsigned precond,
+                     const char *desc, const char *location)
 {
     xmlNodePtr resp;
 
@@ -1325,13 +1531,22 @@ int xml_add_response(struct propfind_ctx
 
     if (code) {
         xmlNewChild(resp, NULL, BAD_CAST "status",
-                    BAD_CAST http_statusline(code));
+                    BAD_CAST http_statusline(VER_1_1, code));
 
         if (precond) {
             xmlNodePtr error = xmlNewChild(resp, NULL, BAD_CAST "error", NULL);
 
             xmlNewChild(error, NULL, BAD_CAST preconds[precond].name, NULL);
         }
+        if (desc) {
+            xmlNewTextChild(resp, NULL,
+                            BAD_CAST "errordescription", BAD_CAST desc);
+        }
+        if (location) {
+            xmlNodePtr node = xmlNewChild(resp, NULL, BAD_CAST "location", NULL);
+
+            xml_add_href(node, NULL, location);
+        }
     }
     else {
         struct propstat propstat[NUM_PROPSTAT], *stat;
@@ -1392,6 +1607,16 @@ int xml_add_response(struct propfind_ctx
                 }
                 break;
 
+            case HTTP_BAD_MEDIATYPE:
+                /* CALDAV:calendar-data/timezone/availability and
+                   CARDDAV:address-data ONLY.
+                   'e->rock' contains supported data precondition code.
+                */
+                xml_add_prop(HTTP_FORBIDDEN, fctx->ns[NS_DAV],
+                             &propstat[PROPSTAT_FORBID],
+                             e->name, e->ns, NULL, (uintptr_t) e->rock);
+                break;
+
             default:
                 xml_add_prop(r, fctx->ns[NS_DAV], &propstat[PROPSTAT_ERROR],
                              e->name, e->ns, NULL, 0);
@@ -1405,7 +1630,8 @@ int xml_add_response(struct propfind_ctx
             (fctx->mode == PROPFIND_ALL || fctx->mode == PROPFIND_NAME)) {
             struct allprop_rock arock = { fctx, propstat };
 
-            annotatemore_findall(fctx->mailbox->name, 0, "*", allprop_cb, &arock);
+            annotatemore_findall(fctx->mailbox->name, 0, "*", /*modseq*/0,
+                                 allprop_cb, &arock, /*flags*/0);
         }
 
         /* Check if we have any propstat elements */
@@ -1423,7 +1649,7 @@ int xml_add_response(struct propfind_ctx
 
             if (stat->root) {
                 xmlNewChild(stat->root, NULL, BAD_CAST "status",
-                            BAD_CAST http_statusline(stat->status));
+                            BAD_CAST http_statusline(VER_1_1, stat->status));
                 if (stat->precond) {
                     struct error_t error = { NULL, stat->precond, NULL, NULL, 0 };
                     xml_add_error(stat->root, &error, fctx->ns);
@@ -1436,6 +1662,18 @@ int xml_add_response(struct propfind_ctx
 
     fctx->record = NULL;
 
+    if (fctx->txn->flags.te & TE_CHUNKED) {
+        /* Add <response> element for this resource to output buffer.
+           Only output the xmlBuffer every PROT_BUFSIZE bytes */
+        xml_partial_response((xmlBufferLength(fctx->xmlbuf) > PROT_BUFSIZE) ?
+                             fctx->txn : NULL,
+                             fctx->root->doc, resp, 1, &fctx->xmlbuf);
+
+        /* Remove <response> element from root (no need to keep in memory) */
+        xmlReplaceNode(resp, NULL);
+        xmlFreeNode(resp);
+    }
+
     return 0;
 }
 
@@ -1444,36 +1682,39 @@ int xml_add_response(struct propfind_ctx
 int propfind_getdata(const xmlChar *name, xmlNsPtr ns,
                      struct propfind_ctx *fctx,
                      xmlNodePtr prop, struct propstat propstat[],
-                     struct mime_type_t *mime_types, int precond,
+                     struct mime_type_t *mime_types,
+                     struct mime_type_t **out_type,
                      const char *data, unsigned long datalen)
 {
     int ret = 0;
-    xmlChar *type, *ver = NULL;
-    struct mime_type_t *mime;
 
-    type = xmlGetProp(prop, BAD_CAST "content-type");
-    if (type) ver = xmlGetProp(prop, BAD_CAST "version");
+    if (!propstat) {
+        /* Prescreen "property" request */
+        xmlChar *type, *ver = NULL;
+        struct mime_type_t *mime;
+
+        type = xmlGetProp(prop, BAD_CAST "content-type");
+        if (type) ver = xmlGetProp(prop, BAD_CAST "version");
 
-    /* Check/find requested MIME type */
-    for (mime = mime_types; type && mime->content_type; mime++) {
-        if (is_mediatype((const char *) type, mime->content_type)) {
-            if (ver &&
-                (!mime->version || xmlStrcmp(ver, BAD_CAST mime->version))) {
-                continue;
+        /* Check/find requested MIME type */
+        for (mime = mime_types; type && mime->content_type; mime++) {
+            if (is_mediatype((const char *) type, mime->content_type)) {
+                if (ver &&
+                    (!mime->version || xmlStrcmp(ver, BAD_CAST mime->version))) {
+                    continue;
+                }
+                break;
             }
-            break;
         }
-    }
 
-    if (!propstat) {
-        /* Prescreen "property" request */
-        if (!mime->content_type) {
-            fctx->txn->error.precond = precond;
-            ret = *fctx->ret = HTTP_FORBIDDEN;
-        }
+        if (type) xmlFree(type);
+        if (ver) xmlFree(ver);
+
+        *out_type = mime;
     }
     else {
         /* Add "property" */
+        struct mime_type_t *mime = *out_type;
         char *freeme = NULL;
 
         prop = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
@@ -1481,7 +1722,7 @@ int propfind_getdata(const xmlChar *name
 
         if (mime != mime_types) {
             /* Not the storage format - convert into requested MIME type */
-            struct buf inbuf, *outbuf;
+            struct buf inbuf = BUF_INITIALIZER;
 
             if (!fctx->obj) {
                 buf_init_ro(&inbuf, data, datalen);
@@ -1489,15 +1730,15 @@ int propfind_getdata(const xmlChar *name
                 buf_free(&inbuf);
             }
 
-            outbuf = mime->from_object(fctx->obj);
+            struct buf *outbuf = mime->from_object(fctx->obj);
             datalen = buf_len(outbuf);
             data = freeme = buf_release(outbuf);
             buf_destroy(outbuf);
-        }
 
-        if (type) {
-            xmlSetProp(prop, BAD_CAST "content-type", type);
-            if (ver) xmlSetProp(prop, BAD_CAST "version", ver);
+            xmlSetProp(prop,
+                       BAD_CAST "content-type", BAD_CAST mime->content_type);
+            if (mime->version)
+                xmlSetProp(prop, BAD_CAST "version", BAD_CAST mime->version);
         }
 
         xmlAddChild(prop,
@@ -1508,9 +1749,6 @@ int propfind_getdata(const xmlChar *name
         if (freeme) free(freeme);
     }
 
-    if (type) xmlFree(type);
-    if (ver) xmlFree(ver);
-
     return ret;
 }
 
@@ -1549,14 +1787,75 @@ int propfind_creationdate(const xmlChar
     return 0;
 }
 
+/* Callback to write CALDAV:displayname for the principal */
+int proppatch_principalname(xmlNodePtr prop, unsigned set,
+                          struct proppatch_ctx *pctx,
+                          struct propstat propstat[],
+                          void *rock __attribute__((unused)))
+{
+    struct mailbox *mailbox = pctx->mailbox;
+    struct mailbox *calhomeset = NULL;
+
+    if (pctx->txn->req_tgt.namespace->id == URL_NS_PRINCIPAL) {
+        /* We have been storing CUAS on cal-home-set, NOT INBOX */
+        char *mboxname = caldav_mboxname(pctx->txn->req_tgt.userid, NULL);
+        int r = 0;
+
+        if (!mailbox || strcmp(mboxname, mailbox->name)) {
+            r = mailbox_open_iwl(mboxname, &calhomeset);
+            if (!r) pctx->mailbox = calhomeset;
+        }
+        free(mboxname);
+
+        if (r) {
+            xml_add_prop(HTTP_SERVER_ERROR, pctx->ns[NS_DAV],
+                         &propstat[PROPSTAT_ERROR],
+                         prop->name, prop->ns, NULL, 0);
+            *pctx->ret = HTTP_SERVER_ERROR;
+            return 0;
+        }
+    }
+    else {
+        /* shouldn't happen!  Internal server error 'r' us */
+        *pctx->ret = HTTP_SERVER_ERROR;
+        return 0;
+    }
+
+    /* Make sure this is on a collection and the user has admin rights */
+    if (pctx->txn->req_tgt.resource ||
+        !(cyrus_acl_myrights(httpd_authstate, pctx->mailbox->acl) & DACL_ADMIN)) {
+        xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
+                     &propstat[PROPSTAT_FORBID],
+                     prop->name, prop->ns, NULL, 0);
+
+        *pctx->ret = HTTP_FORBIDDEN;
+    }
+    else {
+        char *value = NULL;
+
+        if (set) {
+            value = (char *) xmlNodeGetContent(prop);
+        }
+
+        proppatch_todb(prop, set, pctx, propstat, (void *) value);
+        free(value);
+    }
+
+    if (calhomeset) {
+        mailbox_close(&calhomeset);
+        pctx->mailbox = mailbox;
+    }
+
+    return 0;
+}
 
-/* Callback to fetch DAV:displayname */
-static int propfind_displayname(const xmlChar *name, xmlNsPtr ns,
-                                struct propfind_ctx *fctx,
-                                xmlNodePtr prop __attribute__((unused)),
-                                xmlNodePtr resp __attribute__((unused)),
-                                struct propstat propstat[],
-                                void *rock __attribute__((unused)))
+/* Callback to fetch DAV:displayname for principals */
+static int propfind_principalname(const xmlChar *name, xmlNsPtr ns,
+                                  struct propfind_ctx *fctx,
+                                  xmlNodePtr prop __attribute__((unused)),
+                                  xmlNodePtr resp __attribute__((unused)),
+                                  struct propstat propstat[],
+                                  void *rock __attribute__((unused)))
 {
     /* XXX  Do LDAP/SQL lookup here */
     buf_reset(&fctx->buf);
@@ -1582,6 +1881,29 @@ static int propfind_displayname(const xm
 }
 
 
+/* Callback to fetch DAV:displayname for collections */
+int propfind_collectionname(const xmlChar *name, xmlNsPtr ns,
+                            struct propfind_ctx *fctx,
+                            xmlNodePtr prop, xmlNodePtr resp,
+                            struct propstat propstat[], void *rock)
+{
+    int r = propfind_fromdb(name, ns, fctx, prop, resp, propstat, rock);
+
+    if (r && fctx->mbentry && !fctx->req_tgt->resource) {
+        /* Special case empty displayname -- use last segment of path */
+        xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                                       &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+        buf_setcstr(&fctx->buf, strrchr(fctx->mbentry->name, '.') + 1);
+        xmlAddChild(node, xmlNewCDataBlock(fctx->root->doc,
+                                           BAD_CAST buf_cstring(&fctx->buf),
+                                           buf_len(&fctx->buf)));
+        return 0;
+    }
+
+    return r;
+}
+
+
 /* Callback to fetch DAV:getcontentlength */
 int propfind_getlength(const xmlChar *name, xmlNsPtr ns,
                        struct propfind_ctx *fctx,
@@ -1618,9 +1940,12 @@ int propfind_getetag(const xmlChar *name
     buf_reset(&fctx->buf);
 
     if (fctx->record) {
+        const char *etag;
+
+        fctx->get_validators(fctx->mailbox, fctx->data, fctx->userid,
+                             fctx->record, &etag, NULL);
         /* add DQUOTEs */
-        buf_printf(&fctx->buf, "\"%s\"",
-                   message_guid_encode(&fctx->record->guid));
+        buf_printf(&fctx->buf, "\"%s\"", etag);
     }
     else {
         buf_printf(&fctx->buf, "\"%u-%u-%u\"", fctx->mailbox->i.uidvalidity,
@@ -1642,13 +1967,21 @@ int propfind_getlastmod(const xmlChar *n
                         struct propstat propstat[],
                         void *rock __attribute__((unused)))
 {
+    time_t lastmod;
+
     if (!fctx->mailbox ||
         (fctx->req_tgt->resource && !fctx->record)) return HTTP_NOT_FOUND;
 
+    if (fctx->record) {
+        fctx->get_validators(fctx->mailbox, fctx->data, fctx->userid,
+                             fctx->record, NULL, &lastmod);
+    }
+    else {
+        lastmod = fctx->mailbox->index_mtime;
+    }
+
     buf_ensure(&fctx->buf, 30);
-    httpdate_gen(fctx->buf.s, fctx->buf.alloc,
-                 fctx->record ? fctx->record->internaldate :
-                 fctx->mailbox->index_mtime);
+    httpdate_gen(fctx->buf.s, fctx->buf.alloc, lastmod);
 
     xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
                  name, ns, BAD_CAST fctx->buf.s, 0);
@@ -1790,6 +2123,19 @@ int propfind_reportset(const xmlChar *na
     xmlNodePtr top, node;
     const struct report_type_t *report;
 
+    if (!propstat) {
+        /* Prescreen "property" request */
+        for (report = (const struct report_type_t *) rock;
+             report && report->name; report++) {
+            /* Add namespaces for possible reports */
+            ensure_ns(fctx->ns, report->ns, fctx->root,
+                      known_namespaces[report->ns].href,
+                      known_namespaces[report->ns].prefix);
+        }
+
+        return 0;
+    }
+
     top = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
                        name, ns, NULL, 0);
 
@@ -1808,7 +2154,98 @@ int propfind_reportset(const xmlChar *na
 }
 
 
-/* Callback to fetch *DAV:supported-collection-set */
+/* Callback to fetch DAV:supported-method-set */
+int propfind_methodset(const xmlChar *name, xmlNsPtr ns,
+                       struct propfind_ctx *fctx,
+                       xmlNodePtr prop __attribute__((unused)),
+                       xmlNodePtr resp __attribute__((unused)),
+                       struct propstat propstat[],
+                       void *rock)
+{
+    unsigned long (*allow_cb)(struct request_target_t *) =
+        (unsigned long (*)(struct request_target_t *)) rock;
+    unsigned long allow = allow_cb(fctx->req_tgt);
+    xmlNodePtr top, node;
+
+    top = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                       name, ns, NULL, 0);
+
+    if (allow & ALLOW_ACL) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "ACL");
+    }
+    if (allow & ALLOW_READ) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "COPY");
+    }
+    if (allow & ALLOW_DELETE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "DELETE");
+    }
+    if (allow & ALLOW_READ) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "GET");
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "HEAD");
+    }
+    if (allow & ALLOW_WRITE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "LOCK");
+    }
+    if (allow & ALLOW_MKCOL) {
+        if (allow & ALLOW_CAL) {
+            node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+            xmlSetProp(node, BAD_CAST "name", BAD_CAST "MKCALENDAR");
+        }
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "MKCOL");
+    }
+    if (allow & ALLOW_DELETE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "MOVE");
+    }
+    if (allow & ALLOW_READ) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "OPTIONS");
+    }
+    if (allow & ALLOW_PATCH) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "PATCH");
+    }
+    if (allow & ALLOW_POST) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "POST");
+    }
+    if (allow & ALLOW_READ) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "PROPFIND");
+    }
+    if (allow & ALLOW_PROPPATCH) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "PROPPATCH");
+    }
+    if (allow & ALLOW_WRITE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "PUT");
+    }
+    if (allow & ALLOW_READ) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "REPORT");
+    }
+    if (allow & ALLOW_TRACE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "TRACE");
+    }
+    if (allow & ALLOW_WRITE) {
+        node = xmlNewChild(top, NULL, BAD_CAST "supported-method", NULL);
+        xmlSetProp(node, BAD_CAST "name", BAD_CAST "UNLOCK");
+    }
+
+    return 0;
+}
+
+
+/* Callback to fetch *DAV:supported-collation-set */
 int propfind_collationset(const xmlChar *name, xmlNsPtr ns,
                           struct propfind_ctx *fctx,
                           xmlNodePtr prop __attribute__((unused)),
@@ -1919,7 +2356,7 @@ int propfind_owner(const xmlChar *name,
 
 
 /* Add possibly 'abstract' supported-privilege 'priv_name', of namespace 'ns',
- * with description 'desc_str' to node 'root'.  For now, we alssume all
+ * with description 'desc_str' to node 'root'.  For now, we assume all
  * descriptions are English.
  */
 static xmlNodePtr add_suppriv(xmlNodePtr root, const char *priv_name,
@@ -1949,8 +2386,22 @@ int propfind_supprivset(const xmlChar *n
     xmlNodePtr set, all, agg, write;
     unsigned tgt_flags = 0;
 
-    set = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                       name, ns, NULL, 0);
+    if (!propstat) {
+        /* Prescreen "property" request */
+        if (fctx->req_tgt->collection ||
+            (fctx->req_tgt->userid && fctx->depth >= 1) || fctx->depth >= 2) {
+            /* Add namespaces for possible privileges */
+            ensure_ns(fctx->ns, NS_CYRUS, fctx->root, XML_NS_CYRUS, "CY");
+            if (fctx->req_tgt->namespace->id == URL_NS_CALENDAR) {
+                ensure_ns(fctx->ns, NS_CALDAV, fctx->root, XML_NS_CALDAV, "C");
+            }
+        }
+
+        return 0;
+    }
+
+    set = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                       name, ns, NULL, 0);
 
     all = add_suppriv(set, "all", NULL, 0, "Any operation");
 
@@ -2099,7 +2550,7 @@ static void add_privs(int rights, unsign
                     xmlNewChild(priv, ns[NS_CYRUS],
                                 BAD_CAST "write-properties-collection", NULL);
                 }
-                if (rights & DACL_PROPRES) {
+                if (rights & DACL_PROPRSRC) {
                     priv = xmlNewChild(parent, NULL,
                                        BAD_CAST "privilege", NULL);
                     xmlNewChild(priv, ns[NS_CYRUS],
@@ -2123,7 +2574,7 @@ static void add_privs(int rights, unsign
                     xmlNewChild(priv, ns[NS_CYRUS],
                                 BAD_CAST "make-collection", NULL);
                 }
-                if (rights & DACL_ADDRES) {
+                if (rights & DACL_ADDRSRC) {
                     priv = xmlNewChild(parent, NULL,
                                        BAD_CAST "privilege", NULL);
                     xmlNewChild(priv, ns[NS_CYRUS],
@@ -2147,7 +2598,7 @@ static void add_privs(int rights, unsign
                     xmlNewChild(priv, ns[NS_CYRUS],
                                 BAD_CAST "remove-collection", NULL);
                 }
-                if ((rights & DACL_RMRES) == DACL_RMRES) {
+                if ((rights & DACL_RMRSRC) == DACL_RMRSRC) {
                     priv = xmlNewChild(parent, NULL,
                                        BAD_CAST "privilege", NULL);
                     xmlNewChild(priv, ns[NS_CYRUS],
@@ -2207,6 +2658,7 @@ static void add_privs(int rights, unsign
                             BAD_CAST buf_cstring(&buf), NULL);
             }
         }
+        buf_free(&buf);
     }
 }
 
@@ -2223,6 +2675,20 @@ int propfind_curprivset(const xmlChar *n
     unsigned flags = 0;
     xmlNodePtr set;
 
+    if (!propstat) {
+        /* Prescreen "property" request */
+        if (fctx->req_tgt->collection ||
+            (fctx->req_tgt->userid && fctx->depth >= 1) || fctx->depth >= 2) {
+            /* Add namespaces for possible privileges */
+            ensure_ns(fctx->ns, NS_CYRUS, fctx->root, XML_NS_CYRUS, "CY");
+            if (fctx->req_tgt->namespace->id == URL_NS_CALENDAR) {
+                ensure_ns(fctx->ns, NS_CALDAV, fctx->root, XML_NS_CALDAV, "C");
+            }
+        }
+
+        return 0;
+    }
+
     if (!fctx->mailbox) return HTTP_NOT_FOUND;
     rights = httpd_myrights(fctx->authstate, fctx->mbentry);
     if ((rights & DACL_READ) != DACL_READ) {
@@ -2276,6 +2742,18 @@ int propfind_acl(const xmlChar *name, xm
     char *aclstr, *userid;
     unsigned flags = 0;
 
+    if (!propstat) {
+        /* Prescreen "property" request */
+        if (fctx->req_tgt->namespace->id == URL_NS_CALENDAR &&
+            (fctx->req_tgt->collection ||
+             (fctx->req_tgt->userid && fctx->depth >= 1) || fctx->depth >= 2)) {
+            /* Add namespaces for possible privileges */
+            ensure_ns(fctx->ns, NS_CALDAV, fctx->root, XML_NS_CALDAV, "C");
+        }
+
+        return 0;
+    }
+
     if (!fctx->mailbox) return HTTP_NOT_FOUND;
 
     /* owner has implicit admin rights */
@@ -2515,7 +2993,9 @@ int propfind_addmember(const xmlChar *na
 
     if (!fctx->req_tgt->collection ||
         !strcmp(fctx->req_tgt->collection, SCHED_INBOX) ||
-        !strcmp(fctx->req_tgt->collection, SCHED_OUTBOX)) {
+        !strcmp(fctx->req_tgt->collection, SCHED_OUTBOX) ||
+        (fctx->req_tgt->namespace->id == URL_NS_ADDRESSBOOK &&
+         !config_getswitch(IMAPOPT_CARDDAV_ALLOWADDMEMBER))) {
         /* Only allowed on non-scheduling collections */
         return HTTP_NOT_FOUND;
     }
@@ -2535,8 +3015,8 @@ int propfind_addmember(const xmlChar *na
 }
 
 
-static void get_synctoken(struct mailbox *mailbox,
-                          struct buf *buf, const char *prefix)
+void dav_get_synctoken(struct mailbox *mailbox,
+                       struct buf *buf, const char *prefix)
 {
     buf_reset(buf);
     buf_printf(buf, "%s%u-" MODSEQ_FMT,
@@ -2559,7 +3039,7 @@ int propfind_sync_token(const xmlChar *n
     /* not defined on the top-level collection either (aka #calendars) */
     if (!fctx->req_tgt->collection) return HTTP_NOT_FOUND;
 
-    get_synctoken(fctx->mailbox, &fctx->buf, prefix);
+    dav_get_synctoken(fctx->mailbox, &fctx->buf, prefix);
 
     xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
                  name, ns, BAD_CAST buf_cstring(&fctx->buf), 0);
@@ -2707,7 +3187,8 @@ static int proppatch_toresource(xmlNodeP
     }
 
     r = mailbox_get_annotate_state(pctx->mailbox, pctx->record->uid, &astate);
-    if (!r) r = annotate_state_writemask(astate, buf_cstring(&pctx->buf), httpd_userid, &value);
+    if (!r) r = annotate_state_writemask(astate, buf_cstring(&pctx->buf),
+                                         httpd_userid, &value);
     /* we need to rewrite the record to update the modseq because the layering
      * of annotations and mailboxes is broken */
     if (!r) r = mailbox_rewrite_index_record(pctx->mailbox, pctx->record);
@@ -2723,6 +3204,7 @@ static int proppatch_toresource(xmlNodeP
                      &propstat[PROPSTAT_ERROR], prop->name, prop->ns, NULL, 0);
     }
 
+    buf_free(&value);
     if (freeme) xmlFree(freeme);
 
     return 0;
@@ -2811,15 +3293,10 @@ int propfind_fromdb(const xmlChar *name,
     buf_printf(&fctx->buf, DAV_ANNOT_NS "<%s>%s",
                (const char *) ns->href, name);
 
-    if (fctx->mbentry && !fctx->record &&
-        !(r = annotatemore_lookupmask(fctx->mbentry->name,
-                                      buf_cstring(&fctx->buf),
-                                      httpd_userid, &attrib))) {
-        if (!buf_len(&attrib) &&
-            !xmlStrcmp(name, BAD_CAST "displayname")) {
-            /* Special case empty displayname -- use last segment of path */
-            buf_setcstr(&attrib, strrchr(fctx->mbentry->name, '.') + 1);
-        }
+    if (fctx->mbentry && !fctx->record) {
+        r = annotatemore_lookupmask(fctx->mbentry->name,
+                                    buf_cstring(&fctx->buf),
+                                    httpd_userid, &attrib);
     }
 
     if (r) return HTTP_SERVER_ERROR;
@@ -2877,17 +3354,18 @@ int proppatch_todb(xmlNodePtr prop, unsi
                      &propstat[PROPSTAT_ERROR], prop->name, prop->ns, NULL, 0);
     }
 
+    buf_free(&value);
     if (freeme) xmlFree(freeme);
 
     return 0;
 }
 
-
-/* annotemore_findall callback for adding dead properties (allprop/propname) */
+/* annotatemore_findall callback for adding dead properties (allprop/propname) */
 static int allprop_cb(const char *mailbox __attribute__((unused)),
                       uint32_t uid __attribute__((unused)),
                       const char *entry,
                       const char *userid, const struct buf *attrib,
+                      const struct annotate_metadata *mdata __attribute__((unused)),
                       void *rock)
 {
     struct allprop_rock *arock = (struct allprop_rock *) rock;
@@ -2919,12 +3397,6 @@ static int allprop_cb(const char *mailbo
 
     /* Look for an instance of this namespace in our response */
     ns = hash_lookup(href, arock->fctx->ns_table);
-    if (!ns) {
-        char prefix[5];
-        snprintf(prefix, sizeof(prefix), "X%u", arock->fctx->prefix_count++);
-        ns = xmlNewNs(arock->fctx->root, BAD_CAST href, BAD_CAST prefix);
-        hash_insert(href, ns, arock->fctx->ns_table);
-    }
 
     /* XXX - can return the same property multiple times with annotate masks! */
 
@@ -2932,6 +3404,13 @@ static int allprop_cb(const char *mailbo
     node = xml_add_prop(HTTP_OK, arock->fctx->ns[NS_DAV],
                         &arock->propstat[PROPSTAT_OK],
                         BAD_CAST name, ns, NULL, 0);
+    if (!ns) {
+        /* Add the namespace directly to the property -
+           its too late to add it to the root when chunking the responses */
+        char prefix[9];
+        snprintf(prefix, sizeof(prefix), "X%X", strhash(href));
+        xmlSetNs(node, xmlNewNs(node, BAD_CAST href, BAD_CAST prefix));
+    }
 
     if (arock->fctx->mode == PROPFIND_ALL) {
         xmlAddChild(node, xmlNewCDataBlock(arock->fctx->root->doc,
@@ -2950,7 +3429,7 @@ static int prescreen_prop(const struct p
 
     if (fctx->req_tgt->resource && !(entry->flags & PROP_RESOURCE)) allowed = 0;
     else if (entry->flags & PROP_PRESCREEN) {
-        allowed = !entry->get(prop->name, NULL, fctx,
+        allowed = !entry->get(BAD_CAST entry->name, NULL, fctx,
                               prop, NULL, NULL, entry->rock);
     }
 
@@ -2961,7 +3440,7 @@ static int prescreen_prop(const struct p
 /* Parse the requested properties and create a linked list of fetch callbacks.
  * The list gets reused for each href if Depth > 0
  */
-static int preload_proplist(xmlNodePtr proplist, struct propfind_ctx *fctx)
+HIDDEN int preload_proplist(xmlNodePtr proplist, struct propfind_ctx *fctx)
 {
     int ret = 0;
     xmlNodePtr prop;
@@ -3024,10 +3503,15 @@ static int preload_proplist(xmlNodePtr p
         if (prop->type == XML_ELEMENT_NODE) {
             struct propfind_entry_list *nentry;
             xmlChar *name, *namespace = NULL;
-            xmlNsPtr ns = prop->ns;
-            const char *ns_href = (const char *) ns->href;
+            xmlNsPtr ns;
+            const char *ns_href;
             unsigned i;
 
+            if (!prop->ns) return HTTP_BAD_REQUEST;
+
+            ns = prop->ns;
+            ns_href = (const char *) ns->href;
+
             if (fctx->mode == PROPFIND_EXPAND) {
                 /* Get name/namespace from <property> */
                 name = xmlGetProp(prop, BAD_CAST "name");
@@ -3098,8 +3582,8 @@ static int preload_proplist(xmlNodePtr p
                 ret = *fctx->ret;
             }
             else {
-                /* No match, treat as a dead property.  Need to look for both collections
-                 * resources */
+                /* No match, treat as a dead property.
+                   Need to look at both collections and resources */
                 nentry->flags = PROP_COLLECTION | PROP_RESOURCE;
                 nentry->get = propfind_fromdb;
                 nentry->prop = NULL;
@@ -3159,11 +3643,14 @@ static int do_proppatch(struct proppatch
                     for (entry = pctx->lprops;
                          entry->name &&
                              (strcmp((const char *) prop->name, entry->name) ||
+                              !prop->ns ||
                               strcmp((const char *) prop->ns->href,
                                      known_namespaces[entry->ns].href));
                          entry++);
 
                     if (entry->name) {
+                        int rights = httpd_myrights(httpd_authstate,
+                                                    pctx->txn->req_tgt.mbentry);
                         if (!entry->put) {
                             /* Protected property */
                             xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
@@ -3172,12 +3659,31 @@ static int do_proppatch(struct proppatch
                                          DAV_PROT_PROP);
                             *pctx->ret = HTTP_FORBIDDEN;
                         }
+                        else if ((pctx->txn->meth == METH_PROPPATCH) &&
+                                 !(rights & ((entry->flags & PROP_PERUSER) ?
+                                             DACL_READ : DACL_PROPCOL))) {
+                            /* DAV:need-privileges */
+                            xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
+                                         &propstat[PROPSTAT_FORBID],
+                                         prop->name, prop->ns, NULL,
+                                         DAV_NEED_PRIVS);
+                            *pctx->ret = HTTP_FORBIDDEN;
+                        }
                         else {
                             /* Write "live" property */
                             entry->put(prop, set, pctx, propstat, entry->rock);
                         }
                     }
-                    else {
+                    else if (!prop->ns) {
+                        /* Property with no namespace */
+                        xmlNodePtr newprop =
+                            xml_add_prop(HTTP_FORBIDDEN, pctx->ns[NS_DAV],
+                                         &propstat[PROPSTAT_FORBID],
+                                         prop->name, NULL, NULL, 0);
+                        xmlSetNs(newprop, NULL);
+                        *pctx->ret = HTTP_FORBIDDEN;
+                    }
+                    else if (pctx->txn->req_tgt.namespace->id != URL_NS_PRINCIPAL) {
                         /* Write "dead" property */
                         proppatch_todb(prop, set, pctx, propstat, NULL);
                     }
@@ -3201,7 +3707,7 @@ static int do_proppatch(struct proppatch
 
         if (stat->root) {
             xmlNewChild(stat->root, NULL, BAD_CAST "status",
-                        BAD_CAST http_statusline(stat->status));
+                        BAD_CAST http_statusline(VER_1_1, stat->status));
             if (stat->precond) {
                 struct error_t error = { NULL, stat->precond, NULL, NULL, 0 };
                 xml_add_error(stat->root, &error, pctx->ns);
@@ -3220,7 +3726,6 @@ int parse_xml_body(struct transaction_t
                    const char *spec_type)
 {
     const char **hdr;
-    xmlParserCtxtPtr ctxt;
     xmlDocPtr doc = NULL;
     int r = 0;
 
@@ -3228,8 +3733,7 @@ int parse_xml_body(struct transaction_t
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    r = http_read_body(httpd_in, httpd_out,
-                       txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    r = http_read_req_body(txn);
     if (r) {
         txn->flags.conn = CONN_CLOSE;
         return r;
@@ -3242,26 +3746,31 @@ int parse_xml_body(struct transaction_t
         (!is_mediatype("text/xml", hdr[0]) &&
          !is_mediatype("application/xml", hdr[0]) &&
          !(spec_type && is_mediatype(spec_type, hdr[0])))) {
-        txn->error.desc = "This method requires an XML body\r\n";
+        txn->error.desc = "This method requires an XML body";
         return HTTP_BAD_MEDIATYPE;
     }
 
     /* Parse the XML request */
-    ctxt = xmlNewParserCtxt();
-    if (ctxt) {
-        doc = xmlCtxtReadMemory(ctxt, buf_cstring(&txn->req_body.payload),
-                                buf_len(&txn->req_body.payload), NULL, NULL,
-                                XML_PARSE_NOERROR | XML_PARSE_NOWARNING);
-        xmlFreeParserCtxt(ctxt);
-    }
+    doc = xmlCtxtReadMemory(txn->conn->xml, buf_cstring(&txn->req_body.payload),
+                            buf_len(&txn->req_body.payload), NULL, NULL,
+                            XML_PARSE_NOERROR | XML_PARSE_NOWARNING);
     if (!doc) {
-        txn->error.desc = "Unable to parse XML body\r\n";
+        txn->error.desc = "Unable to parse XML body";
         return HTTP_BAD_REQUEST;
     }
+    else {
+        xmlErrorPtr err = xmlCtxtGetLastError(txn->conn->xml);
+        if (err) {
+            xmlFreeDoc(doc);
+            txn->error.desc = err->message;
+            return HTTP_BAD_REQUEST;
+        }
+    }
 
     /* Get the root element of the XML request */
     if (!(*root = xmlDocGetRootElement(doc))) {
-        txn->error.desc = "Missing root element in request\r\n";
+        xmlFreeDoc(doc);
+        txn->error.desc = "Missing root element in request";
         return HTTP_BAD_REQUEST;
     }
 
@@ -3306,8 +3815,8 @@ int meth_acl(struct transaction_t *txn,
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    if ((r = aparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, aparams);
+    if (r) return r;
 
     /* Make sure method is allowed (only allowed on collections) */
     if (!(txn->req_tgt.allow & ALLOW_ACL)) {
@@ -3353,8 +3862,9 @@ int meth_acl(struct transaction_t *txn,
     indoc = root->doc;
 
     /* Make sure its an DAV:acl element */
-    if (xmlStrcmp(root->name, BAD_CAST "acl")) {
-        txn->error.desc = "Missing acl element in ACL request\r\n";
+    if (!root->ns || xmlStrcmp(root->ns->href, BAD_CAST XML_NS_DAV) ||
+        xmlStrcmp(root->name, BAD_CAST "acl")) {
+        txn->error.desc = "Missing DAV:acl element in ACL request";
         ret = HTTP_BAD_REQUEST;
         goto done;
     }
@@ -3390,6 +3900,11 @@ int meth_acl(struct transaction_t *txn,
 
                         for (prin = child->children; prin &&
                              prin->type != XML_ELEMENT_NODE; prin = prin->next);
+                        if (!prin) {
+                            txn->error.desc = "Empty principal in ACE\r\n";
+                            ret = HTTP_BAD_REQUEST;
+                            goto done;
+                        }
                     }
                     else if (!xmlStrcmp(child->name, BAD_CAST "grant")) {
                         if (privs) {
@@ -3562,7 +4077,7 @@ int meth_acl(struct transaction_t *txn,
                             rights |= DACL_PROPCOL;
                         else if (!xmlStrcmp(priv->name,
                                        BAD_CAST "write-properties-resource"))
-                            rights |= DACL_PROPRES;
+                            rights |= DACL_PROPRSRC;
                         else if (!xmlStrcmp(priv->name,
                                        BAD_CAST "make-collection"))
                             rights |= DACL_MKCOL;
@@ -3571,10 +4086,10 @@ int meth_acl(struct transaction_t *txn,
                             rights |= DACL_RMCOL;
                         else if (!xmlStrcmp(priv->name,
                                        BAD_CAST "add-resource"))
-                            rights |= DACL_ADDRES;
+                            rights |= DACL_ADDRSRC;
                         else if (!xmlStrcmp(priv->name,
                                        BAD_CAST "remove-resource"))
-                            rights |= DACL_RMRES;
+                            rights |= DACL_RMRSRC;
                         else if (!xmlStrcmp(priv->name,
                                        BAD_CAST "admin"))
                             rights |= DACL_ADMIN;
@@ -3615,8 +4130,13 @@ int meth_acl(struct transaction_t *txn,
         }
     }
 
-    mailbox_set_acl(mailbox, buf_cstring(&acl), 1);
-    r = mboxlist_sync_setacls(txn->req_tgt.mbentry->name, buf_cstring(&acl));
+    r = mboxlist_sync_setacls(txn->req_tgt.mbentry->name, buf_cstring(&acl), mailbox_modseq_dirty(mailbox));
+    if (!r) r = mailbox_set_acl(mailbox, buf_cstring(&acl));
+    if (!r) {
+        char *userid = mboxname_to_userid(txn->req_tgt.mbentry->name);
+        r = caldav_update_shareacls(userid);
+        free(userid);
+    }
     if (r) {
         syslog(LOG_ERR, "mboxlist_sync_setacls(%s) failed: %s",
                txn->req_tgt.mbentry->name, error_message(r));
@@ -3659,10 +4179,10 @@ static int move_collection(const mbentry
     else {
         /* Rename mailbox -
            Pretend we're an admin since we already renamed the parent */
-        r = mboxlist_renamemailbox(mbentry->name, buf_cstring(&mrock->newname),
+        r = mboxlist_renamemailbox(mbentry, buf_cstring(&mrock->newname),
                                    NULL /* partition */, 0 /* uidvalidity */,
                                    1 /* admin */, httpd_userid, httpd_authstate,
-                                   NULL, 0, 0, 1 /* ignorequota */);
+                                   NULL, 0, 0, 1 /* ignorequota */, 0, 0, 0);
     }
 
     if (r) {
@@ -3736,7 +4256,7 @@ static int move_collection(const mbentry
 
         /* Add <status> element */
         xmlNewChild(resp, NULL, BAD_CAST "status",
-                    BAD_CAST http_statusline(code));
+                    BAD_CAST http_statusline(VER_1_1, code));
 
         /* Add <error> element */
         xml_add_error(resp, &err, mrock->ns);
@@ -3761,13 +4281,16 @@ static int remove_collection(const mbent
         r = mboxlist_delayed_deletemailbox(mbentry->name, 1, /* admin */
                                            httpd_userid, httpd_authstate,
                                            NULL, 1 /* checkacl */,
-                                           0 /* localonly */, 0 /* force */);
+                                           0 /* localonly */, 0 /* force */,
+                                           0 /* keep_intermediaries */);
+
     }
     else {
         r = mboxlist_deletemailbox(mbentry->name, 1, /* admin */
                                    httpd_userid, httpd_authstate,
                                    NULL, 1 /* checkacl */,
-                                   0 /* localonly */, 0 /* force */);
+                                   0 /* localonly */, 0 /* force */,
+                                   0 /* keep_intermediaries */);
     }
 
     return r;
@@ -3829,6 +4352,8 @@ static int dav_move_collection(struct tr
         }
     }
 
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(newmailboxname);
+
     r = mboxlist_createmailboxcheck(newmailboxname, 0, NULL, httpd_userisadmin,
                                     httpd_userid, httpd_authstate,
                                     NULL, NULL, 0 /* force */);
@@ -3844,14 +4369,17 @@ static int dav_move_collection(struct tr
                                                httpd_userisadmin,
                                                httpd_userid, httpd_authstate,
                                                mboxevent, 1 /* checkacl */,
-                                               0 /* localonly*/, 0 /* force */);
+                                               0 /* localonly*/, 0 /* force */,
+                                               0 /* keep_intermediaries */);
+
         }
         else {
             r = mboxlist_deletemailbox(newmailboxname,
                                        httpd_userisadmin,
                                        httpd_userid, httpd_authstate,
                                        mboxevent, 1 /* checkacl */,
-                                       0 /* localonly*/, 0 /* force */);
+                                       0 /* localonly*/, 0 /* force */,
+                                       0 /* keep_intermediaries */);
         }
 
         if (!r) mboxevent_notify(&mboxevent);
@@ -3872,10 +4400,10 @@ static int dav_move_collection(struct tr
     /* Attempt to rename the base mailbox */
     mboxevent = mboxevent_new(EVENT_MAILBOX_RENAME);
 
-    r = mboxlist_renamemailbox(oldmailboxname, newmailboxname,
+    r = mboxlist_renamemailbox(txn->req_tgt.mbentry, newmailboxname,
                                NULL /* partition */, 0 /* uidvalidity */,
                                httpd_userisadmin, httpd_userid, httpd_authstate,
-                               mboxevent, 0, 0, 1 /* ignorequota */);
+                               mboxevent, 0, 0, 1 /* ignorequota */, 0, 0, 0);
 
     if (!r) mboxevent_notify(&mboxevent);
     mboxevent_free(&mboxevent);
@@ -3883,8 +4411,8 @@ static int dav_move_collection(struct tr
     /* Attempt to rename all submailboxes */
     if (!r && recursive) {
         char ombn[MAX_MAILBOX_BUFFER];
-        struct move_rock mrock =
-            { ++omlen, ++nmlen, BUF_INITIALIZER, dest_tgt->namespace->prefix, NULL, {0} };
+        struct move_rock mrock = { ++omlen, ++nmlen, BUF_INITIALIZER,
+                                   dest_tgt->namespace->prefix, NULL, {0} };
 
         strcpy(ombn, oldmailboxname);
         strcat(ombn, ".");
@@ -3899,11 +4427,13 @@ static int dav_move_collection(struct tr
         if (mrock.root) {
             xml_response(HTTP_MULTI_STATUS, txn, mrock.root->doc);
             xmlFreeDoc(mrock.root->doc);
+            mboxname_release(&namespacelock);
             return 0;
         }
     }
 
   done:
+    mboxname_release(&namespacelock);
     switch (r) {
     case 0:
         return (overwrite < 0) ? HTTP_NO_CONTENT : HTTP_CREATED;
@@ -3947,7 +4477,8 @@ int meth_copy_move(struct transaction_t
     time_t lastmod = 0;
     unsigned meth_move = (txn->meth == METH_MOVE);
     void *src_davdb = NULL, *dest_davdb = NULL, *obj = NULL;
-    struct buf msg_buf = BUF_INITIALIZER, body_buf;
+    struct buf msg_buf = BUF_INITIALIZER;
+    struct buf body_buf = BUF_INITIALIZER;
 
     memset(&dest_tgt, 0, sizeof(struct request_target_t));
 
@@ -3955,8 +4486,8 @@ int meth_copy_move(struct transaction_t
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the source path */
-    if ((r = cparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, cparams);
+    if (r) return r;
 
     /* Make sure method is allowed (not allowed on collections yet) */
     if (!(txn->req_tgt.allow & ALLOW_WRITE)) return HTTP_NOT_ALLOWED;
@@ -3997,7 +4528,7 @@ int meth_copy_move(struct transaction_t
     dest_tgt.namespace = txn->req_tgt.namespace;
     r = cparams->parse_path(dest_uri->path, &dest_tgt, &txn->error.desc);
     if (r) {
-        ret = r;
+        ret = (r == HTTP_MOVED) ? HTTP_FORBIDDEN : r;
         goto done;
     }
 
@@ -4027,24 +4558,24 @@ int meth_copy_move(struct transaction_t
     /* Check ACL for current user on source mailbox */
     rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
     if (((rights & DACL_READ) != DACL_READ) ||
-        (meth_move && !(rights & DACL_RMRES))) {
+        (meth_move && !(rights & DACL_RMRSRC))) {
         /* DAV:need-privileges */
         txn->error.precond = DAV_NEED_PRIVS;
         txn->error.resource = txn->req_tgt.path;
         txn->error.rights =
-            (rights & DACL_READ) != DACL_READ ? DACL_READ : DACL_RMRES;
+            (rights & DACL_READ) != DACL_READ ? DACL_READ : DACL_RMRSRC;
         ret = HTTP_NO_PRIVS;
         goto done;
     }
 
     /* Check ACL for current user on destination */
     rights = httpd_myrights(httpd_authstate, dest_tgt.mbentry);
-    if (!(rights & DACL_ADDRES) || !(rights & DACL_WRITECONT)) {
+    if (!(rights & DACL_ADDRSRC) || !(rights & DACL_WRITECONT)) {
         /* DAV:need-privileges */
         txn->error.precond = DAV_NEED_PRIVS;
         txn->error.resource = dest_tgt.path;
         txn->error.rights =
-            !(rights & DACL_ADDRES) ? DACL_ADDRES : DACL_WRITECONT;
+            !(rights & DACL_ADDRSRC) ? DACL_ADDRSRC : DACL_WRITECONT;
         ret = HTTP_NO_PRIVS;
         goto done;
     }
@@ -4141,24 +4672,13 @@ int meth_copy_move(struct transaction_t
         goto done;
     }
 
-    if (ddata->imap_uid) {
-        /* Mapped URL - Fetch index record for the resource */
-        r = mailbox_find_index_record(src_mbox, ddata->imap_uid, &src_rec);
-        if (r) {
-            txn->error.desc = error_message(r);
-            ret = HTTP_SERVER_ERROR;
-            goto done;
-        }
-
-        etag = message_guid_encode(&src_rec.guid);
-        lastmod = src_rec.internaldate;
-    }
-    else {
-        /* Unmapped URL (empty resource) */
-        src_rec.uid = 0;
-        src_rec.recno = ddata->rowid;
-        etag = NULL;
-        lastmod = ddata->creationdate;
+    /* Fetch resource validators */
+    r = cparams->get_validators(src_mbox, (void *) ddata, httpd_userid,
+                                &src_rec, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
 
     /* Check any preconditions on source */
@@ -4192,6 +4712,7 @@ int meth_copy_move(struct transaction_t
         /* Unmapped URL (empty resource) */
         buf_init_ro_cstr(&body_buf, "");
         obj = &body_buf;
+        src_rec.recno = ddata->rowid; /* For deleting DAV record */
     }
 
     if (dest_mbox != src_mbox) {
@@ -4245,7 +4766,7 @@ int meth_copy_move(struct transaction_t
             /* Expunge the source message */
             if (src_rec.uid) {
                 /* Mapped URL */
-                src_rec.system_flags |= FLAG_EXPUNGED;
+                src_rec.internal_flags |= FLAG_INTERNAL_EXPUNGED;
                 if ((r = mailbox_rewrite_index_record(src_mbox, &src_rec))) {
                     syslog(LOG_ERR, "expunging src record (%s) failed: %s",
                            txn->req_tgt.mbentry->name, error_message(r));
@@ -4280,6 +4801,7 @@ int meth_copy_move(struct transaction_t
     if (src_mbox) mailbox_close(&src_mbox);
 
     buf_free(&msg_buf);
+    buf_free(&body_buf);
     xmlFreeURI(dest_uri);
     free(dest_tgt.userid);
     mboxlist_entry_free(&dest_tgt.mbentry);
@@ -4335,8 +4857,7 @@ int meth_delete(struct transaction_t *tx
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    r = dparams->parse_path(txn->req_uri->path,
-                            &txn->req_tgt, &txn->error.desc);
+    r = dav_parse_req_target(txn, dparams);
     if (r) return r;
 
     /* Make sure method is allowed */
@@ -4427,7 +4948,7 @@ int meth_delete(struct transaction_t *tx
 
     /* Check ACL for current user */
     rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    needrights = txn->req_tgt.resource ? DACL_RMRES : DACL_RMCOL;
+    needrights = txn->req_tgt.resource ? DACL_RMRSRC : DACL_RMCOL;
     if (!(rights & needrights)) {
         /* DAV:need-privileges */
         txn->error.precond = DAV_NEED_PRIVS;
@@ -4480,24 +5001,35 @@ int meth_delete(struct transaction_t *tx
             }
         }
 
+        mbname_t *mbname = mbname_from_intname(txn->req_tgt.mbentry->name);
+        struct mboxlock *namespacelock = user_namespacelock(mbname_userid(mbname));
+
         mboxevent = mboxevent_new(EVENT_MAILBOX_DELETE);
 
         if (mboxlist_delayed_delete_isenabled()) {
             r = mboxlist_delayed_deletemailbox(txn->req_tgt.mbentry->name,
                                        httpd_userisadmin || httpd_userisproxyadmin,
                                        httpd_userid, httpd_authstate, mboxevent,
-                                       /*checkack*/1, /*localonly*/0, /*force*/0);
+                                       /*checkack*/1, /*localonly*/0, /*force*/0,
+                                       /* keep_intermediaries */0);
         }
         else {
             r = mboxlist_deletemailbox(txn->req_tgt.mbentry->name,
                                        httpd_userisadmin || httpd_userisproxyadmin,
                                        httpd_userid, httpd_authstate, mboxevent,
-                                       /*checkack*/1, /*localonly*/0, /*force*/0);
+                                       /*checkack*/1, /*localonly*/0, /*force*/0,
+                                       /* keep_intermediaries */0);
+        }
+        if (!r) {
+            r = caldav_update_shareacls(mbname_userid(mbname));
         }
         if (r == IMAP_PERMISSION_DENIED) ret = HTTP_FORBIDDEN;
         else if (r == IMAP_MAILBOX_NONEXISTENT) ret = HTTP_NOT_FOUND;
         else if (r) ret = HTTP_SERVER_ERROR;
 
+        mboxname_release(&namespacelock);
+        mbname_free(&mbname);
+
         goto done;
     }
 
@@ -4524,23 +5056,13 @@ int meth_delete(struct transaction_t *tx
         goto done;
     }
 
-    memset(&record, 0, sizeof(struct index_record));
-    if (ddata->imap_uid) {
-        /* Mapped URL - Fetch index record for the resource */
-        r = mailbox_find_index_record(mailbox, ddata->imap_uid, &record);
-        if (r) {
-            txn->error.desc = error_message(r);
-            ret = HTTP_SERVER_ERROR;
-            goto done;
-        }
-
-        etag = message_guid_encode(&record.guid);
-        lastmod = record.internaldate;
-    }
-    else {
-        /* Unmapped URL (empty resource) */
-        etag = NULL;
-        lastmod = ddata->creationdate;
+    /* Fetch resource validators */
+    r = dparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &record, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
 
     /* Check any preconditions */
@@ -4568,7 +5090,7 @@ int meth_delete(struct transaction_t *tx
         if (dparams->delete) dparams->delete(txn, mailbox, &record, ddata);
 
         /* Expunge the resource */
-        record.system_flags |= FLAG_EXPUNGED;
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
 
         mboxevent = mboxevent_new(EVENT_MESSAGE_EXPUNGE);
 
@@ -4621,9 +5143,8 @@ int meth_get_head(struct transaction_t *
     char *freeme = NULL;
 
     /* Parse the path */
-    ret = gparams->parse_path(txn->req_uri->path,
-                              &txn->req_tgt, &txn->error.desc);
-    if (ret) return ret;
+    r = dav_parse_req_target(txn, gparams);
+    if (r) return r;
 
     if (txn->req_tgt.namespace->id == URL_NS_PRINCIPAL) {
         /* Special "principal" */
@@ -4693,23 +5214,17 @@ int meth_get_head(struct transaction_t *
         goto done;
     }
 
-    memset(&record, 0, sizeof(struct index_record));
-    if (ddata->imap_uid) {
-        /* Mapped URL - Fetch index record for the resource */
-        r = mailbox_find_index_record(mailbox, ddata->imap_uid, &record);
-        if (r) goto done;
-
-        txn->flags.ranges = 1;
-        etag = message_guid_encode(&record.guid);
-        lastmod = record.internaldate;
-    }
-    else {
-        /* Unmapped URL (empty resource) */
-        txn->flags.ranges = 0;
-        etag = NULL;
-        lastmod = ddata->creationdate;
+    /* Fetch resource validators */
+    r = gparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &record, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
 
+    txn->flags.ranges = (ddata->imap_uid != 0);
+
     /* Check any preconditions, including range request */
     precond = gparams->check_precond(txn, params, mailbox,
                                      (void *) ddata, etag, lastmod);
@@ -4762,8 +5277,7 @@ int meth_get_head(struct transaction_t *
 
             if (mime != gparams->mime_types) {
                 /* Not the storage format - create resource object */
-                struct buf inbuf;
-
+                struct buf inbuf = BUF_INITIALIZER;
                 buf_init_ro(&inbuf, data, datalen);
                 obj = gparams->mime_types[0].to_object(&inbuf);
                 buf_free(&inbuf);
@@ -4818,7 +5332,7 @@ int meth_lock(struct transaction_t *txn,
     xmlDocPtr indoc = NULL, outdoc = NULL;
     xmlNodePtr root = NULL;
     xmlNsPtr ns[NUM_NAMESPACE];
-    xmlChar *owner = NULL;
+    xmlBufferPtr owner = NULL;
     time_t now = time(NULL);
     void *davdb = NULL;
 
@@ -4828,20 +5342,20 @@ int meth_lock(struct transaction_t *txn,
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    if ((r = lparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, lparams);
+    if (r) return r;
 
     /* Make sure method is allowed (only allowed on resources) */
     if (!(txn->req_tgt.allow & ALLOW_WRITE)) return HTTP_NOT_ALLOWED;
 
     /* Check ACL for current user */
     rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_WRITECONT) || !(rights & DACL_ADDRES)) {
+    if (!(rights & DACL_WRITECONT) || !(rights & DACL_ADDRSRC)) {
         /* DAV:need-privileges */
         txn->error.precond = DAV_NEED_PRIVS;
         txn->error.resource = txn->req_tgt.path;
         txn->error.rights =
-            !(rights & DACL_WRITECONT) ? DACL_WRITECONT : DACL_ADDRES;
+            !(rights & DACL_WRITECONT) ? DACL_WRITECONT : DACL_ADDRSRC;
         return HTTP_NO_PRIVS;
     }
 
@@ -4877,32 +5391,17 @@ int meth_lock(struct transaction_t *txn,
     lparams->davdb.lookup_resource(davdb, txn->req_tgt.mbentry->name,
                                    txn->req_tgt.resource, (void *) &ddata, 1);
 
-    if (ddata->alive) {
-        if (ddata->imap_uid) {
-            /* Locking existing resource */
-
-            /* Fetch index record for the resource */
-            r = mailbox_find_index_record(mailbox, ddata->imap_uid, &oldrecord);
-            if (r) {
-                txn->error.desc = error_message(r);
-                ret = HTTP_SERVER_ERROR;
-                goto done;
-            }
-
-            etag = message_guid_encode(&oldrecord.guid);
-            lastmod = oldrecord.internaldate;
-        }
-        else {
-            /* Unmapped URL (empty resource) */
-            etag = NULL;
-            lastmod = ddata->creationdate;
-        }
+    /* Fetch resource validators */
+    r = lparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &oldrecord, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
-    else {
-        /* New resource */
-        etag = NULL;
-        lastmod = 0;
 
+    if (!ddata->alive) {
+        /* New resource */
         ddata->creationdate = now;
         ddata->mailbox = mailbox->name;
         ddata->resource = txn->req_tgt.resource;
@@ -4937,7 +5436,6 @@ int meth_lock(struct transaction_t *txn,
     if (ddata->lock_expire <= now) {
         /* Create new lock */
         xmlNodePtr node, sub;
-        unsigned owner_is_href = 0;
 
         /* Parse the required body */
         ret = parse_xml_body(txn, &root, NULL);
@@ -4947,10 +5445,11 @@ int meth_lock(struct transaction_t *txn,
         }
         if (ret) goto done;
 
-        /* Check for correct root element */
+        /* Make sure its a DAV:lockinfo element */
         indoc = root->doc;
-        if (xmlStrcmp(root->name, BAD_CAST "lockinfo")) {
-            txn->error.desc = "Incorrect root element in XML request\r\n";
+        if (!root->ns || xmlStrcmp(root->ns->href, BAD_CAST XML_NS_DAV) ||
+            xmlStrcmp(root->name, BAD_CAST "lockinfo")) {
+            txn->error.desc = "Missing DAV:lockinfo element in LOCK request";
             ret = HTTP_BAD_MEDIATYPE;
             goto done;
         }
@@ -4983,10 +5482,11 @@ int meth_lock(struct transaction_t *txn,
             }
             else if (!xmlStrcmp(node->name, BAD_CAST "owner")) {
                 /* Find child element of owner */
+                owner = xmlBufferCreate();
                 for (sub = node->children;
                      sub && sub->type != XML_ELEMENT_NODE; sub = sub->next);
                 if (!sub) {
-                    owner = xmlNodeGetContent(node);
+                    xmlNodeBufGetContent(owner, node);
                 }
                 /* Make sure its a href element */
                 else if (xmlStrcmp(sub->name, BAD_CAST "href")) {
@@ -4994,20 +5494,18 @@ int meth_lock(struct transaction_t *txn,
                     goto done;
                 }
                 else {
-                    owner_is_href = 1;
-                    owner = xmlNodeGetContent(sub);
+                    xmlNodeBufGetContent(owner, sub);
+                    xmlBufferAddHead(owner, BAD_CAST "<DAV:href>", 10);
                 }
             }
         }
 
         ddata->lock_ownerid = httpd_userid;
-        if (owner) ddata->lock_owner = (const char *) owner;
+        if (owner) ddata->lock_owner = (const char *) xmlBufferContent(owner);
 
         /* Construct lock-token */
         assert(!buf_len(&txn->buf));
-        buf_printf(&txn->buf, XML_NS_CYRUS "lock/%s-%x-%u",
-                   mailbox->uniqueid, strhash(txn->req_tgt.resource),
-                   owner_is_href);
+        buf_printf(&txn->buf, LOCK_TOKEN_URL_SCHEME "%s", makeuuid());
 
         ddata->lock_token = buf_cstring(&txn->buf);
     }
@@ -5057,7 +5555,7 @@ int meth_lock(struct transaction_t *txn,
     mailbox_close(&mailbox);
     if (outdoc) xmlFreeDoc(outdoc);
     if (indoc) xmlFreeDoc(indoc);
-    if (owner) xmlFree(owner);
+    if (owner) xmlBufferFree(owner);
 
     return ret;
 }
@@ -5090,15 +5588,34 @@ int meth_mkcol(struct transaction_t *txn
 
     /* Parse the path (use our own entry to suppress lookup) */
     txn->req_tgt.mbentry = mboxlist_entry_create();
-    if ((r = mparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) {
+    r = mparams->parse_path(txn->req_uri->path, &txn->req_tgt, &txn->error.desc);
+
+    /* Make sure method is allowed (only allowed on child of home-set) */
+    if (!txn->req_tgt.collection || txn->req_tgt.resource) {
         txn->error.precond = mparams->mkcol.location_precond;
         return HTTP_FORBIDDEN;
     }
+    else if (r) {
+        switch (r) {
+        case IMAP_MAILBOX_EXISTS:
+            txn->error.precond = DAV_RES_EXISTS;
+            break;
+
+        case IMAP_PERMISSION_DENIED:
+            txn->error.precond = DAV_NEED_PRIVS;
+            txn->error.rights = DACL_BIND;
+            buf_reset(&txn->buf);
+            buf_printf(&txn->buf, "%s/%s/%s",
+                       txn->req_tgt.namespace->prefix, USER_COLLECTION_PREFIX,
+                       txn->req_tgt.userid);
+            txn->error.resource = buf_cstring(&txn->buf);
+            break;
+
+        default:
+            txn->error.precond = mparams->mkcol.location_precond;
+            break;
+        }
 
-    /* Make sure method is allowed (only allowed on home-set) */
-    if (!(txn->req_tgt.allow & ALLOW_MKCOL)) {
-        txn->error.precond = mparams->mkcol.location_precond;
         return HTTP_FORBIDDEN;
     }
 
@@ -5131,19 +5648,25 @@ int meth_mkcol(struct transaction_t *txn
 
     if (root) {
         /* Check for correct root element (lowercase method name ) */
+        const char *ns_href;
+
         indoc = root->doc;
 
         buf_setcstr(&txn->buf, http_methods[txn->meth].name);
-        r = xmlStrcmp(root->name, BAD_CAST buf_lcase(&txn->buf));
-        if (r) {
-            txn->error.desc = "Incorrect root element in XML request\r\n";
-            ret = HTTP_BAD_MEDIATYPE;
+        ns_href = buf_len(&txn->buf) > 5 ? XML_NS_CALDAV : XML_NS_DAV;
+        if (!root->ns || xmlStrcmp(root->ns->href, BAD_CAST ns_href) ||
+            xmlStrcmp(root->name, BAD_CAST buf_lcase(&txn->buf))) {
+            txn->error.desc =
+                "Incorrect root element in MKCOL/MKCALENDAR request";
+            ret = HTTP_BAD_REQUEST;
             goto done;
         }
 
         instr = root->children;
     }
 
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(txn->req_tgt.mbentry->name);
+
     /* Create the mailbox */
     r = mboxlist_createmailbox(txn->req_tgt.mbentry->name,
                                mparams->mkcol.mbtype, partition,
@@ -5161,6 +5684,7 @@ int meth_mkcol(struct transaction_t *txn
         if (!root) {
             ret = HTTP_SERVER_ERROR;
             txn->error.desc = "Unable to create XML response\r\n";
+            mboxname_release(&namespacelock);
             goto done;
         }
 
@@ -5180,23 +5704,35 @@ int meth_mkcol(struct transaction_t *txn
 
         if (ret || r) {
             /* Setting properties failed - delete mailbox */
+            mailbox_abort(mailbox);
             mailbox_close(&mailbox);
             mboxlist_deletemailbox(txn->req_tgt.mbentry->name,
                                    /*isadmin*/1, NULL, NULL, NULL,
-                                   /*checkacl*/0, /*localonly*/0, /*force*/1);
+                                   /*checkacl*/0, /*localonly*/0, /*force*/1,
+                                   /*keep_intermediaries*/0);
 
             if (!ret) {
                 /* Output the XML response */
+                if (txn->meth == METH_MKCALENDAR) {
+                    /* MKCALENDAR failure response MUST be 207 (Multi-Status) */
+                    xmlNodeSetName(root, BAD_CAST "multistatus");
+                    xmlSetNs(root, ns[NS_DAV]);
+                    r = HTTP_MULTI_STATUS;
+                }
                 xml_response(r, txn, outdoc);
             }
 
+            mboxname_release(&namespacelock);
             goto done;
         }
     }
+    mboxname_release(&namespacelock);
 
     if (!r) {
+        if (mparams->mkcol.proc) r = mparams->mkcol.proc(mailbox);
+
         assert(!buf_len(&txn->buf));
-        get_synctoken(mailbox, &txn->buf, "");
+        dav_get_synctoken(mailbox, &txn->buf, "");
         txn->resp_body.ctag = buf_cstring(&txn->buf);
         ret = HTTP_CREATED;
     }
@@ -5262,11 +5798,11 @@ int propfind_by_resource(void *rock, voi
 
     if (r || (!ddata->imap_uid && ddata->lock_expire <= time(NULL))) {
         /* Add response for missing target */
-        ret = xml_add_response(fctx, HTTP_NOT_FOUND, 0);
+        ret = xml_add_response(fctx, HTTP_NOT_FOUND, 0, NULL, NULL);
     }
     else if (!fctx->filter || fctx->filter(fctx, data)) {
         /* Add response for target */
-        ret = xml_add_response(fctx, 0, 0);
+        ret = xml_add_response(fctx, 0, 0, NULL, NULL);
     }
 
     buf_free(&fctx->msg_buf);
@@ -5305,7 +5841,7 @@ static int propfind_by_resources(struct
                               fctx->req_tgt->resource, (void **) &ddata, 0);
         if (!ddata->rowid) {
             /* Add response for missing target */
-            xml_add_response(fctx, HTTP_NOT_FOUND, 0);
+            xml_add_response(fctx, HTTP_NOT_FOUND, 0, NULL, NULL);
             return HTTP_NOT_FOUND;
         }
         r = fctx->proc_by_resource(fctx, ddata);
@@ -5324,32 +5860,22 @@ static int propfind_by_resources(struct
 }
 
 
-static size_t make_collection_url(struct buf *buf, const char  *urlprefix,
-                                  const char *mboxname, const char *userid,
-                                  char **mbox_owner)
+HIDDEN size_t make_collection_url(struct buf *buf, const char *urlprefix, int haszzzz,
+                                  const mbname_t *mbname, const char *userid)
 {
-    mbname_t *mbname = NULL;
     const strarray_t *boxes;
     int n, size;
     size_t len;
 
-    mbname = mbname_from_intname(mboxname);
-
     buf_reset(buf);
     buf_printf(buf, "%s/", urlprefix);
 
     if (userid) {
-        if (!mbname_domain(mbname)) mbname_set_domain(mbname, httpd_extradomain);
         const char *owner = mbname_userid(mbname);
         if (!owner) owner = "";
 
-        if (mbox_owner) *mbox_owner = xstrdup(owner);
-
         if (config_getswitch(IMAPOPT_FASTMAILSHARING)) {
-            if (strcmp(owner, userid) && strstr(urlprefix, "addressbooks"))
-                buf_printf(buf, "%s/%s/", "zzzz", owner);
-            else
-                buf_printf(buf, "%s/%s/", USER_COLLECTION_PREFIX, owner);
+            buf_printf(buf, "%s/%s/", haszzzz ? "zzzz" : USER_COLLECTION_PREFIX, owner);
         }
         else {
             buf_printf(buf, "%s/", USER_COLLECTION_PREFIX);
@@ -5376,8 +5902,6 @@ static size_t make_collection_url(struct
         buf_putc(buf, '/');
     }
 
-    mbname_free(&mbname);
-
     return len;
 }
 
@@ -5394,8 +5918,10 @@ int propfind_by_collection(const mbentry
     int r = 0, rights = 0;
 
     /* skip deleted items */
-    if (mboxname_isdeletedmailbox(mbentry->name, 0) || mbentry->mbtype == MBTYPE_DELETED)
+    if (mboxname_isdeletedmailbox(mbentry->name, 0) ||
+        (mbentry->mbtype & MBTYPE_DELETED)) {
         goto done;
+    }
 
     /* Check ACL on mailbox for current user */
     rights = httpd_myrights(httpd_authstate, mbentry);
@@ -5421,14 +5947,6 @@ int propfind_by_collection(const mbentry
         }
         break;
 
-    case URL_NS_CALENDAR:
-        /*  Inbox and Outbox can't appear unless they are the target */
-        if (!fctx->req_tgt->flags) {
-            if (!strncmp(p, SCHED_INBOX, strlen(SCHED_INBOX) - 1)) goto done;
-            if (!strncmp(p, SCHED_OUTBOX, strlen(SCHED_OUTBOX) - 1)) goto done;
-        }
-        /* fall through */
-
     default:
         /* Magic folder filter */
         if (httpd_extrafolder && strcasecmp(p, httpd_extrafolder)) goto done;
@@ -5444,9 +5962,6 @@ int propfind_by_collection(const mbentry
     if ((r = mailbox_open_irl(mboxname, &mailbox))) {
         syslog(LOG_INFO, "mailbox_open_irl(%s) failed: %s",
                mboxname, error_message(r));
-        fctx->txn->error.desc = error_message(r);
-        *fctx->ret = HTTP_SERVER_ERROR;
-        goto done;
     }
 
     fctx->mbentry = mbentry;
@@ -5454,8 +5969,24 @@ int propfind_by_collection(const mbentry
     fctx->record = NULL;
 
     if (!fctx->req_tgt->resource) {
+        /* we always have zzzz if it's already in the URL */
+        int haszzzz = fctx->req_tgt->flags & TGT_USER_ZZZZ;
+
+        mbname_t *mbname = mbname_from_intname(mboxname);
+        if (!mbname_domain(mbname))
+            mbname_set_domain(mbname, httpd_extradomain);
+
+        /* we also need to deal with the discovery case,
+         * where mboxname doesn't match request path */
+        if (fctx->req_tgt->userid &&
+            strcmpsafe(mbname_userid(mbname), fctx->req_tgt->userid)) {
+            haszzzz = 1;
+        }
+
         len = make_collection_url(&writebuf, fctx->req_tgt->namespace->prefix,
-                                  mboxname, fctx->req_tgt->userid, NULL);
+                                  haszzzz, mbname, fctx->req_tgt->userid);
+
+        mbname_free(&mbname);
 
         /* copy it all back into place... in theory we should check against
          * 'last' and make sure it doesn't change from the original request.
@@ -5467,8 +5998,13 @@ int propfind_by_collection(const mbentry
 
         /* If not filtering by calendar resource, and not excluding root,
            add response for collection */
-        if (!fctx->filter_crit && !(fctx->prefer & PREFER_NOROOT) &&
-            (r = xml_add_response(fctx, 0, 0))) goto done;
+        if (!r && !fctx->filter_crit && !(fctx->prefer & PREFER_NOROOT) &&
+            (r = xml_add_response(fctx, 0, 0, NULL, NULL))) goto done;
+    }
+
+    if (r) {
+        xml_add_response(fctx, HTTP_SERVER_ERROR, 0, error_message(r), NULL);
+        goto done;
     }
 
     if (fctx->depth > 1 && fctx->open_db) { // can't do davdb searches if no dav db
@@ -5480,9 +6016,25 @@ int propfind_by_collection(const mbentry
     buf_free(&writebuf);
     if (mailbox) mailbox_close(&mailbox);
 
-    return r;
+    return 0;
 }
 
+/* Free an entry list */
+HIDDEN void free_entry_list(struct propfind_entry_list *elist)
+{
+    while (elist) {
+        struct propfind_entry_list *freeme = elist;
+
+        elist = elist->next;
+        if (freeme->flags & PROP_CLEANUP) {
+            freeme->get(freeme->name, NULL, NULL,
+                        NULL, NULL, NULL, freeme->rock);
+        }
+
+        xmlFree(freeme->name);
+        free(freeme);
+    }
+}
 
 /* Perform a PROPFIND request */
 EXPORTED int meth_propfind(struct transaction_t *txn, void *params)
@@ -5496,14 +6048,12 @@ EXPORTED int meth_propfind(struct transa
     xmlNsPtr ns[NUM_NAMESPACE];
     struct hash_table ns_table = { 0, NULL, NULL };
     struct propfind_ctx fctx;
-    struct propfind_entry_list *elist = NULL;
 
     memset(&fctx, 0, sizeof(struct propfind_ctx));
 
     /* Parse the path */
     if (fparams->parse_path) {
-        r = fparams->parse_path(txn->req_uri->path,
-                                &txn->req_tgt, &txn->error.desc);
+        r = dav_parse_req_target(txn, fparams);
         if (r) return r;
     }
 
@@ -5573,9 +6123,10 @@ EXPORTED int meth_propfind(struct transa
     else {
         indoc = root->doc;
 
-        /* Make sure its a propfind element */
-        if (xmlStrcmp(root->name, BAD_CAST "propfind")) {
-            txn->error.desc = "Missing propfind element in PROPFIND request";
+        /* Make sure its a DAV:propfind element */
+        if (!root->ns || xmlStrcmp(root->ns->href, BAD_CAST XML_NS_DAV) ||
+            xmlStrcmp(root->name, BAD_CAST "propfind")) {
+            txn->error.desc = "Missing DAV:propfind element in PROPFIND request";
             ret = HTTP_BAD_REQUEST;
             goto done;
         }
@@ -5640,6 +6191,7 @@ EXPORTED int meth_propfind(struct transa
     /* Populate our propfind context */
     fctx.txn = txn;
     fctx.req_tgt = &txn->req_tgt;
+    fctx.depth = depth;
     fctx.prefer |= get_preferences(txn);
     fctx.userid = httpd_userid;
     fctx.userisadmin = httpd_userisadmin;
@@ -5647,6 +6199,7 @@ EXPORTED int meth_propfind(struct transa
     fctx.mbentry = NULL;
     fctx.mailbox = NULL;
     fctx.record = NULL;
+    fctx.get_validators = fparams->get_validators;
     fctx.reqd_privs = DACL_READ;
     fctx.filter = NULL;
     fctx.filter_crit = NULL;
@@ -5664,13 +6217,23 @@ EXPORTED int meth_propfind(struct transa
     fctx.ret = &ret;
 
     /* Parse the list of properties and build a list of callbacks */
-    preload_proplist(props, &fctx);
+    ret = preload_proplist(props, &fctx);
+    if (ret) goto done;
+
+    /* iCalendar/vCard data in response should not be transformed */
+    if (fctx.flags.fetcheddata) txn->flags.cc |= CC_NOTRANSFORM;
+
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
+
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, fctx.root->doc);
 
     /* Generate responses */
     if (txn->req_tgt.namespace->id == URL_NS_PRINCIPAL) {
         if (!depth || !(fctx.prefer & PREFER_NOROOT)) {
             /* Add response for target URL */
-            xml_add_response(&fctx, 0, 0);
+            xml_add_response(&fctx, 0, 0, NULL, NULL);
         }
 
         if (depth > 0 && !txn->req_tgt.userid) {
@@ -5687,7 +6250,7 @@ EXPORTED int meth_propfind(struct transa
                 /* Add a response for 'user' collection */
                 snprintf(p, MAX_MAILBOX_PATH - len,
                          "/%s/", USER_COLLECTION_PREFIX);
-                xml_add_response(&fctx, 0, 0);
+                xml_add_response(&fctx, 0, 0, NULL, NULL);
             }
 
             if (depth >= 2) {
@@ -5723,7 +6286,8 @@ EXPORTED int meth_propfind(struct transa
                 fctx.mbentry = txn->req_tgt.mbentry;
             }
 
-            if (!fctx.req_tgt->resource) xml_add_response(&fctx, 0, 0);
+            if (!fctx.req_tgt->resource)
+                xml_add_response(&fctx, 0, 0, NULL, NULL);
 
             /* Resource(s) */
             r = propfind_by_resources(&fctx);
@@ -5741,7 +6305,9 @@ EXPORTED int meth_propfind(struct transa
             }
             else if (config_getswitch(IMAPOPT_FASTMAILSHARING)) {
                 /* Add responses for all visible collections */
-                mboxlist_usermboxtree(httpd_userid, propfind_by_collection, &fctx, MBOXTREE_PLUS_RACL);
+                mboxlist_usermboxtree(httpd_userid, httpd_authstate,
+                                      propfind_by_collection,
+                                      &fctx, MBOXTREE_PLUS_RACL);
             }
             else if (txn->req_tgt.mbentry) {
                 /* Add responses for all contained collections */
@@ -5760,7 +6326,7 @@ EXPORTED int meth_propfind(struct transa
                                 buf_cstring(&fctx.buf), MAX_MAILBOX_PATH);
                         fctx.mbentry = NULL;
                         fctx.mailbox = NULL;
-                        r = xml_add_response(&fctx, 0, 0);
+                        r = xml_add_response(&fctx, 0, 0, NULL, NULL);
                     }
                     break;
 
@@ -5786,23 +6352,17 @@ EXPORTED int meth_propfind(struct transa
 
     if (fctx.davdb) fctx.close_db(fctx.davdb);
 
-    /* Output the XML response */
-    if (!ret) {
-        /* iCalendar data in response should not be transformed */
-        if (fctx.flags.fetcheddata) txn->flags.cc |= CC_NOTRANSFORM;
+    /* End XML response */
+    xml_partial_response(txn, fctx.root->doc, NULL /* end */, 0, &fctx.xmlbuf);
+    xmlBufferFree(fctx.xmlbuf);
 
-        xml_response(HTTP_MULTI_STATUS, txn, outdoc);
-    }
+    /* End of output */
+    write_body(0, txn, NULL, 0);
+    ret = 0;
 
   done:
     /* Free the entry list */
-    elist = fctx.elist;
-    while (elist) {
-        struct propfind_entry_list *freeme = elist;
-        elist = elist->next;
-        xmlFree(freeme->name);
-        free(freeme);
-    }
+    free_entry_list(fctx.elist);
 
     buf_free(&fctx.buf);
 
@@ -5824,7 +6384,7 @@ EXPORTED int meth_propfind(struct transa
 int meth_proppatch(struct transaction_t *txn, void *params)
 {
     struct meth_params *pparams = (struct meth_params *) params;
-    int ret = 0, r = 0, rights;
+    int ret = 0, r = 0;
     xmlDocPtr indoc = NULL, outdoc = NULL;
     xmlNodePtr root, instr, resp;
     xmlNsPtr ns[NUM_NAMESPACE];
@@ -5839,24 +6399,14 @@ int meth_proppatch(struct transaction_t
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    if ((r = pparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, pparams);
+    if (r) return r;
 
     if (!txn->req_tgt.collection && !txn->req_tgt.userid) {
         txn->error.desc = "PROPPATCH requires a collection";
         return HTTP_NOT_ALLOWED;
     }
 
-    /* Check ACL for current user */
-    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_PROPCOL)) {
-        /* DAV:need-privileges */
-        txn->error.precond = DAV_NEED_PRIVS;
-        txn->error.resource = txn->req_tgt.path;
-        txn->error.rights = DACL_PROPCOL;
-        return HTTP_NO_PRIVS;
-    }
-
     if (txn->req_tgt.mbentry->server) {
         /* Remote mailbox */
         struct backend *be;
@@ -5888,10 +6438,11 @@ int meth_proppatch(struct transaction_t
 
     indoc = root->doc;
 
-    /* Make sure its a propertyupdate element */
-    if (xmlStrcmp(root->name, BAD_CAST "propertyupdate")) {
+    /* Make sure its a DAV:propertyupdate element */
+    if (!root->ns || xmlStrcmp(root->ns->href, BAD_CAST XML_NS_DAV) ||
+        xmlStrcmp(root->name, BAD_CAST "propertyupdate")) {
         txn->error.desc =
-            "Missing propertyupdate element in PROPPATCH request\r\n";
+            "Missing DAV:propertyupdate element in PROPPATCH request";
         ret = HTTP_BAD_REQUEST;
         goto done;
     }
@@ -5951,8 +6502,13 @@ int meth_proppatch(struct transaction_t
 
     /* Output the XML response */
     if (!ret) {
-        if (!r && (get_preferences(txn) & PREFER_MIN)) ret = HTTP_OK;
-        else xml_response(HTTP_MULTI_STATUS, txn, outdoc);
+        if (r) mailbox_abort(mailbox);
+        else if (get_preferences(txn) & PREFER_MIN) {
+            ret = HTTP_OK;
+            goto done;
+        }
+
+        xml_response(HTTP_MULTI_STATUS, txn, outdoc);
     }
 
   done:
@@ -5967,450 +6523,46 @@ int meth_proppatch(struct transaction_t
 }
 
 
-enum {
-    SHARE_NONE = 0,
-    SHARE_READONLY,
-    SHARE_READWRITE
-};
-
-static const char *access_types[] = { "no-access", "read", "read-write" };
-
-static int set_share_access(const char *mboxname,
-                            const char *userid, int access)
+static int dav_post_import(struct transaction_t *txn,
+                          struct meth_params *pparams)
 {
-    char r, rightstr[100];
+    int ret = 0, r, precond = HTTP_OK, rights;
+    const char **hdr;
+    struct mime_type_t *mime = NULL;
+    struct mailbox *mailbox = NULL;
+    quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_INITIALIZER;
+    void *davdb = NULL, *obj = NULL;
+    xmlDocPtr outdoc = NULL;
+    xmlNodePtr root;
+    xmlNsPtr ns[NUM_NAMESPACE];
+    unsigned data_ns = pparams->post.bulk.data_ns;
 
-    /* Set access rights */
-    rightstr[0] = (access == SHARE_READWRITE) ? '+' : '-';
-
-    cyrus_acl_masktostr(DACL_SHARERW, rightstr+1);
-    r = mboxlist_setacl(&httpd_namespace, mboxname, userid, rightstr,
-                        httpd_userisadmin || httpd_userisproxyadmin,
-                        httpd_userid, httpd_authstate);
-    if (!r && access == SHARE_READONLY) {
-        rightstr[0] = '+';
-        cyrus_acl_masktostr(DACL_SHARE, rightstr+1);
-        r = mboxlist_setacl(&httpd_namespace, mboxname, userid, rightstr,
-                            httpd_userisadmin || httpd_userisproxyadmin,
-                            httpd_userid, httpd_authstate);
+    /* Check Content-Type */
+    mime = pparams->mime_types;
+    if ((hdr = spool_getheader(txn->req_hdrs, "Content-Type"))) {
+        for (; mime->content_type; mime++) {
+            if (is_mediatype(mime->content_type, hdr[0])) break;
+        }
+        if (!mime->content_type) {
+            txn->error.precond = pparams->put.supp_data_precond;
+            return HTTP_FORBIDDEN;
+        }
     }
 
-    return r;
-}
+    /* Check ACL for current user */
+    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
+    if (!(rights & DACL_WRITECONT) || !(rights & DACL_ADDRSRC)) {
+        /* DAV:need-privileges */
+        txn->error.precond = DAV_NEED_PRIVS;
+        txn->error.resource = txn->req_tgt.path;
+        txn->error.rights =
+            !(rights & DACL_WRITECONT) ? DACL_WRITECONT : DACL_ADDRSRC;
+        return HTTP_NO_PRIVS;
+    }
 
-
-static xmlNodePtr get_props(struct request_target_t *req_tgt,
-                            const char *prop_names[],
-                            xmlNodePtr root, xmlNsPtr ns[],
-                            const struct prop_entry prop_list[])
-{
-    struct propstat propstat = { NULL, 0, 0 };
-    struct propfind_ctx fctx;
-    const struct prop_entry *prop;
-    const char **name;
-    xmlNodePtr node;
-
-    memset(&fctx, 0, sizeof(struct propfind_ctx));
-    fctx.req_tgt = req_tgt;
-    fctx.mbentry = req_tgt->mbentry;
-    fctx.root = root;
-    fctx.ns = ns;
-
-    for (prop = prop_list; prop->name; prop++) {
-        for (name = prop_names; *name; name++) {
-            if (!strcmp(*name, prop->name)) {
-                prop->get(BAD_CAST prop->name, ns[NS_DAV],
-                          &fctx, NULL, NULL, &propstat, NULL);
-            }
-        }
-    }
-
-    buf_free(&fctx.buf);
-
-    node = propstat.root->children;
-    xmlUnlinkNode(node);
-    xmlFreeNode(propstat.root);
-
-    return node;
-}
-
-
-static int create_notify_collection(const char *userid,
-                                    struct mailbox **mailbox);
-static int notify_put(struct transaction_t *txn, void *obj,
-                      struct mailbox *mailbox, const char *resource,
-                      void *davdb, unsigned flags);
-
-#define DAVSHARING_CONTENT_TYPE "application/davsharing+xml"
-
-#define DAVNOTIFICATION_CONTENT_TYPE \
-    "application/davnotification+xml; charset=utf-8"
-
-#define SYSTEM_STATUS_NOTIFICATION  "systemstatus"
-#define SHARE_INVITE_NOTIFICATION   "share-invite-notification"
-#define SHARE_REPLY_NOTIFICATION    "share-reply-notification"
-
-static int send_notification(struct transaction_t *top_txn, xmlDocPtr doc,
-                             const char *userid, const char *resource)
-{
-    struct mailbox *mailbox = NULL;
-    struct webdav_db *webdavdb = NULL;
-    struct transaction_t txn;
-    int r;
-
-    /* XXX  Need to find location of user.
-       If remote need to do a PUT or possibly email */
-
-    /* Open notifications collection for writing */
-    r = create_notify_collection(userid, &mailbox);
-    if (r == IMAP_INVALID_USER) {
-        syslog(LOG_NOTICE,
-               "send_notification(%s) failed: %s", userid, error_message(r));
-        return 0;
-    }
-    else if (r) {
-        syslog(LOG_ERR,
-               "send_notification: create_notify_collection(%s) failed: %s",
-               userid, error_message(r));
-        return r;
-    }
-
-    /* Open the WebDAV DB corresponding to collection */
-    webdavdb = webdav_open_mailbox(mailbox);
-    if (!webdavdb) {
-        syslog(LOG_ERR, "send_notification: unable to open WebDAV DB (%s)",
-               mailbox->name);
-        r = HTTP_SERVER_ERROR;
-        goto done;
-    }
-
-    /* Start with an empty (clean) transaction */
-    memset(&txn, 0, sizeof(struct transaction_t));
-    txn.req_tgt.namespace = top_txn->req_tgt.namespace;
-    txn.req_tgt.mboxprefix = top_txn->req_tgt.mboxprefix;
-
-    /* Create header cache */
-    if (!(txn.req_hdrs = spool_new_hdrcache())) {
-        syslog(LOG_ERR, "send_notification: unable to create header cache");
-        r = HTTP_SERVER_ERROR;
-        goto done;
-    }
-
-    spool_cache_header(xstrdup("Content-Type"),
-                       xstrdup(DAVNOTIFICATION_CONTENT_TYPE), txn.req_hdrs);
-
-    r = notify_put(&txn, doc, mailbox, resource, webdavdb, 0);
-    if (r != HTTP_CREATED && r != HTTP_NO_CONTENT) {
-        syslog(LOG_ERR,
-               "send_notification: notify_put(%s, %s) failed: %s",
-               mailbox->name, resource, error_message(r));
-    }
-
-  done:
-    spool_free_hdrcache(txn.req_hdrs);
-    buf_free(&txn.buf);
-    webdav_close(webdavdb);
-    mailbox_close(&mailbox);
-
-    return r;
-}
-
-
-static int dav_post_share(struct transaction_t *txn,
-                          struct meth_params *pparams)
-{
-    xmlNodePtr root = NULL, node, sharee, princ;
-    int rights, ret, legacy = 0;
-    struct buf resource = BUF_INITIALIZER;
-    char dtstamp[RFC3339_DATETIME_MAX];
-    xmlNodePtr notify = NULL, type, resp, share, comment;
-    xmlNsPtr ns[NUM_NAMESPACE];
-    const char *invite_principal_props[] = { "displayname", NULL };
-    const char *invite_collection_props[] = { "displayname", "resourcetype",
-                                              "supported-calendar-component-set",
-                                              NULL };
-
-    /* Check ACL for current user */
-    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_ADMIN)) {
-        /* DAV:need-privileges */
-        txn->error.precond = DAV_NEED_PRIVS;
-        txn->error.resource = txn->req_tgt.path;
-        txn->error.rights = DACL_ADMIN;
-        return HTTP_NO_PRIVS;
-    }
-
-    if (txn->req_tgt.mbentry->server) {
-        /* Remote mailbox */
-        struct backend *be;
-
-        be = proxy_findserver(txn->req_tgt.mbentry->server,
-                              &http_protocol, httpd_userid,
-                              &backend_cached, NULL, NULL, httpd_in);
-        if (!be) return HTTP_UNAVAILABLE;
-
-        return http_pipe_req_resp(be, txn);
-    }
-
-    /* Local mailbox */
-
-    /* Read body */
-    ret = parse_xml_body(txn, &root, DAVSHARING_CONTENT_TYPE);
-    if (!ret && !root) {
-        txn->error.desc = "Missing request body";
-        ret = HTTP_BAD_REQUEST;
-    }
-    if (ret) goto done;
-
-    /* Make sure its a share-resource element */
-    if (!xmlStrcmp(root->name, BAD_CAST "share")) legacy = 1;
-    else if (xmlStrcmp(root->name, BAD_CAST "share-resource")) {
-        txn->error.desc =
-            "Missing share-resource element in POST request";
-        ret = HTTP_BAD_REQUEST;
-        goto done;
-    }
-
-    /* Create share-invite-notification -
-       response and share-access will be replaced for each sharee */
-    notify = init_xml_response("notification", NS_DAV, NULL, ns);
-
-    time_to_rfc3339(time(0), dtstamp, RFC3339_DATETIME_MAX);
-    xmlNewChild(notify, NULL, BAD_CAST "dtstamp", BAD_CAST dtstamp);
-
-    type = xmlNewChild(notify, NULL, BAD_CAST SHARE_INVITE_NOTIFICATION, NULL);
-
-    princ = xmlNewChild(type, NULL, BAD_CAST "principal", NULL);
-    buf_printf(&resource, "%s/%s/%s/", namespace_principal.prefix,
-               USER_COLLECTION_PREFIX, txn->req_tgt.userid);
-    xml_add_href(princ, NULL, buf_cstring(&resource));
-    node = get_props(&txn->req_tgt, invite_principal_props,
-                     notify, ns, princ_params.propfind.lprops);
-    xmlAddChild(princ, node);
-
-    resp = xmlNewChild(type, NULL, BAD_CAST "invite-noresponse", NULL);
-
-    node = xmlNewChild(type, NULL, BAD_CAST "sharer-resource-uri", NULL);
-    xml_add_href(node, NULL, txn->req_tgt.path);
-
-    node = xmlNewChild(type, NULL, BAD_CAST "share-access", NULL);
-    share = xmlNewChild(node, NULL, BAD_CAST "no-access", NULL);
-
-    node = get_props(&txn->req_tgt, invite_collection_props,
-                     notify, ns, pparams->propfind.lprops);
-    xmlAddChild(type, node);
-
-    comment = xmlNewChild(type, NULL, BAD_CAST "comment", NULL);
-
-
-    /* Process each sharee */
-    for (sharee = xmlFirstElementChild(root); sharee;
-         sharee = xmlNextElementSibling(sharee)) {
-        xmlChar *href = NULL, *content;
-        int access = SHARE_READONLY;
-
-        xmlNodeSetContent(comment, BAD_CAST "");
-
-        if (legacy) {
-            if (!xmlStrcmp(sharee->name, BAD_CAST "remove")) {
-                access = SHARE_NONE;
-            }
-            else if (xmlStrcmp(sharee->name, BAD_CAST "set")) continue;
-        }
-        else if (xmlStrcmp(sharee->name, BAD_CAST "sharee")) continue;
-
-        for (node = xmlFirstElementChild(sharee); node;
-             node = xmlNextElementSibling(node)) {
-            if (!xmlStrcmp(node->name, BAD_CAST "href")) {
-                href = xmlNodeGetContent(node);
-                if (access == SHARE_NONE) break;
-            }
-
-            if (legacy) {
-                if (!xmlStrcmp(node->name, BAD_CAST "read-write")) {
-                    access = SHARE_READWRITE;
-                }
-                else if (!xmlStrcmp(node->name, BAD_CAST "summary")) {
-                    content = xmlNodeGetContent(node);
-                    xmlNodeSetContent(comment, content);
-                    xmlFree(content);
-                }
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "share-access")) {
-                xmlNodePtr share = xmlFirstElementChild(node);
-
-                if (!xmlStrcmp(share->name, BAD_CAST "no-access")) {
-                    access = SHARE_NONE;
-                }
-                else if (!xmlStrcmp(share->name, BAD_CAST "read-write")) {
-                    access = SHARE_READWRITE;
-                }
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
-                content = xmlNodeGetContent(node);
-                xmlNodeSetContent(comment, content);
-                xmlFree(content);
-            }
-        }
-
-        if (href) {
-            char *userid = NULL, *at;
-            int r;
-
-            if (!xmlStrncmp(href, BAD_CAST "mailto:", 7)) {
-                userid = xstrdup((char *) href + 7);
-                if ((at = strchr(userid, '@'))) {
-                    if (!config_virtdomains || !strcmp(at+1, config_defdomain)){
-                        *at = '\0';
-                    }
-                }
-            }
-            else if (!xmlStrncmp(href, BAD_CAST "DAV:", 4)) {
-                if (!xmlStrcmp(href + 4, BAD_CAST "all")) {
-                    userid = xstrdup("anyone");
-                }
-                else if (!xmlStrcmp(href + 4, BAD_CAST "unauthenticated")) {
-                    userid = xstrdup("anonymous");
-                }
-                else if (!xmlStrcmp(href + 4, BAD_CAST "authenticated")) {
-                    /* This needs to be done as anyone - anonymous */
-                    r = set_share_access(txn->req_tgt.mbentry->name,
-                                         "anyone", access);
-                    if (r) {
-                        syslog(LOG_NOTICE,
-                               "failed to set share access for"
-                               " 'anyone' on '%s': %s",
-                               txn->req_tgt.mbentry->name, error_message(r));
-                    }
-                    else userid = xstrdup("-anonymous");
-                }
-            }
-            else {
-                const char *errstr = NULL;
-                xmlURIPtr uri = parse_uri(METH_UNKNOWN,
-                                          (const char *) href, 1, &errstr);
-
-                if (uri) {
-                    struct request_target_t principal;
-
-                    memset(&principal, 0, sizeof(struct request_target_t));
-                    r = principal_parse_path((const char *) uri->path,
-                                             &principal, &errstr);
-                    if (!r && principal.userid) userid = principal.userid;
-                    else if (principal.userid) free(principal.userid);
-
-                    xmlFreeURI(uri);
-                }
-            }
-
-            if (!userid) {
-                /* XXX  set invite-invalid ? */
-            }
-            else {
-                /* Set access rights */
-                r = set_share_access(txn->req_tgt.mbentry->name,
-                                     userid, access);
-                if (r) {
-                    syslog(LOG_NOTICE,
-                           "failed to set share access for '%s' on '%s': %s",
-                           userid, txn->req_tgt.mbentry->name,
-                           error_message(r));
-                }
-                else {
-                    /* Notify sharee - patch in response and share-access */
-                    const char *annot =
-                        DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
-                    const char *response = "invite-noresponse";
-                    struct buf value = BUF_INITIALIZER;
-                    int r;
-
-                    /* Lookup invite status */
-                    r = annotatemore_lookupmask(txn->req_tgt.mbentry->name,
-                                                annot, userid, &value);
-                    if (!r && buf_len(&value)) response = buf_cstring(&value);
-                    node = xmlNewNode(ns[NS_DAV], BAD_CAST response);
-                    buf_free(&value);
-                    xmlReplaceNode(resp, node);
-                    xmlFreeNode(resp);
-                    resp = node;
-
-                    node = xmlNewNode(ns[NS_DAV], BAD_CAST access_types[access]);
-                    xmlReplaceNode(share, node);
-                    xmlFreeNode(share);
-                    share = node;
-
-                    /* Create a resource name for the notifications -
-                       We use a consistent naming scheme so that multiple
-                       notifications of the same type for the same resource
-                       are coalesced (overwritten) */
-                    buf_reset(&resource);
-                    buf_printf(&resource, "%x-%x-%x-%x.xml",
-                               strhash(XML_NS_DAV),
-                               strhash(SHARE_INVITE_NOTIFICATION),
-                               strhash(txn->req_tgt.mbentry->name),
-                               strhash(userid));
-
-                    r = send_notification(txn, notify->doc,
-                                          userid, buf_cstring(&resource));
-                }
-
-                free(userid);
-            }
-
-            xmlFree(href);
-        }
-
-        ret = HTTP_NO_CONTENT;
-    }
-
-  done:
-    if (root) xmlFreeDoc(root->doc);
-    if (notify) xmlFreeDoc(notify->doc);
-    buf_free(&resource);
-
-    return ret;
-}
-
-
-static int dav_post_import(struct transaction_t *txn,
-                          struct meth_params *pparams)
-{
-    int ret = 0, r, precond = HTTP_OK, rights;
-    const char **hdr;
-    struct mime_type_t *mime = NULL;
-    struct mailbox *mailbox = NULL;
-    quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_INITIALIZER;
-    void *davdb = NULL, *obj = NULL;
-    xmlDocPtr outdoc = NULL;
-    xmlNodePtr root;
-    xmlNsPtr ns[NUM_NAMESPACE];
-
-    /* Check Content-Type */
-    mime = pparams->mime_types;
-    if ((hdr = spool_getheader(txn->req_hdrs, "Content-Type"))) {
-        for (; mime->content_type; mime++) {
-            if (is_mediatype(mime->content_type, hdr[0])) break;
-        }
-        if (!mime->content_type) {
-            txn->error.precond = pparams->put.supp_data_precond;
-            return HTTP_FORBIDDEN;
-        }
-    }
-
-    /* Check ACL for current user */
-    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_WRITECONT) || !(rights & DACL_ADDRES)) {
-        /* DAV:need-privileges */
-        txn->error.precond = DAV_NEED_PRIVS;
-        txn->error.resource = txn->req_tgt.path;
-        txn->error.rights =
-            !(rights & DACL_WRITECONT) ? DACL_WRITECONT : DACL_ADDRES;
-        return HTTP_NO_PRIVS;
-    }
-
-    if (txn->req_tgt.mbentry->server) {
-        /* Remote mailbox */
-        struct backend *be;
+    if (txn->req_tgt.mbentry->server) {
+        /* Remote mailbox */
+        struct backend *be;
 
         be = proxy_findserver(txn->req_tgt.mbentry->server,
                               &http_protocol, httpd_userid,
@@ -6424,8 +6576,7 @@ static int dav_post_import(struct transa
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    r = http_read_body(httpd_in, httpd_out,
-                       txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    r = http_read_req_body(txn);
     if (r) {
         txn->flags.conn = CONN_CLOSE;
         return r;
@@ -6481,7 +6632,7 @@ static int dav_post_import(struct transa
 
     /* Parse and validate the resources */
     obj = mime->to_object(&txn->req_body.payload);
-    ret = pparams->post.import(txn, obj, NULL, NULL, NULL, NULL, 0);
+    ret = pparams->post.bulk.import(txn, obj, NULL, NULL, NULL, NULL, 0);
     if (ret) goto done;
 
     /* Start construction of our multistatus response */
@@ -6492,22 +6643,31 @@ static int dav_post_import(struct transa
         goto done;
     }
     ensure_ns(ns, NS_CS, root, XML_NS_CS, "CS");
+    ensure_ns(ns, data_ns, root, known_namespaces[data_ns].href,
+              known_namespaces[data_ns].prefix);
 
     outdoc = root->doc;
 
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
+
+    /* Include CTag in trailer */
+    txn->flags.trailer |= TRAILER_CTAG;
+
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, outdoc);
+
     /* Store the resources */
-    ret = pparams->post.import(txn, obj, mailbox, davdb,
-                               root, ns, get_preferences(txn));
+    ret = pparams->post.bulk.import(txn, obj, mailbox, davdb,
+                                    root, ns, get_preferences(txn));
 
     /* Validators */
-    assert(!buf_len(&txn->buf));
-    get_synctoken(mailbox, &txn->buf, "");
+    dav_get_synctoken(mailbox, &txn->buf, "");
     txn->resp_body.ctag = buf_cstring(&txn->buf);
-    txn->resp_body.etag = NULL;
-    txn->resp_body.lastmod = 0;
 
-    /* Output the XML response */
-    if (!ret) xml_response(HTTP_MULTI_STATUS, txn, outdoc);
+    /* End of output */
+    write_body(0, txn, NULL, 0);
+    ret = 0;
 
   done:
     if (outdoc) xmlFreeDoc(outdoc);
@@ -6525,7 +6685,6 @@ static int dav_post_import(struct transa
 int meth_post(struct transaction_t *txn, void *params)
 {
     struct meth_params *pparams = (struct meth_params *) params;
-    static unsigned post_count = 0;
     struct strlist *action;
     int r, ret;
     size_t len;
@@ -6535,8 +6694,8 @@ int meth_post(struct transaction_t *txn,
     if (httpd_userid) txn->flags.cc |= CC_PRIVATE;
 
     /* Parse the path */
-    if ((r = pparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, pparams);
+    if (r) return r;
 
     /* Make sure method is allowed (only allowed on certain collections) */
     if (!(txn->req_tgt.allow & ALLOW_POST)) return HTTP_NOT_ALLOWED;
@@ -6555,19 +6714,19 @@ int meth_post(struct transaction_t *txn,
         const char **hdr = spool_getheader(txn->req_hdrs, "Content-Type");
 
         if ((pparams->post.allowed & POST_SHARE) && hdr &&
-            is_mediatype(hdr[0], DAVSHARING_CONTENT_TYPE)) {
+            (is_mediatype(hdr[0], DAVSHARING_CONTENT_TYPE) ||
+             is_mediatype(hdr[0], "text/xml"))) {
             /* Sharing request */
             return dav_post_share(txn, pparams);
         }
-        else if ((pparams->post.allowed & POST_BULK) && hdr) {
-            if (is_mediatype(hdr[0], "application/xml")) {
-                /* Bulk CRUD */
-                return HTTP_FORBIDDEN;
-            }
-            else {
-                /* Bulk import */
-                return dav_post_import(txn, pparams);
-            }
+        else if (pparams->post.bulk.data_prop && hdr &&
+                 is_mediatype(hdr[0], "application/xml")) {
+            /* Bulk CRUD */
+            return HTTP_FORBIDDEN;
+        }
+        else if (pparams->post.bulk.import && hdr) {
+            /* Bulk import */
+            return dav_post_import(txn, pparams);
         }
         else return HTTP_BAD_REQUEST;
     }
@@ -6584,8 +6743,8 @@ int meth_post(struct transaction_t *txn,
     txn->req_tgt.resource = txn->req_tgt.path + len;
     txn->req_tgt.reslen =
         snprintf(txn->req_tgt.resource, MAX_MAILBOX_PATH - len,
-                 "%x-%d-%ld-%u.ics",
-                 strhash(txn->req_tgt.path), getpid(), time(0), post_count++);
+                 "%s.%s", makeuuid(), pparams->mime_types[0].file_ext ?
+                 pparams->mime_types[0].file_ext : "");
 
     /* Tell client where to find the new resource */
     txn->location = txn->req_tgt.path;
@@ -6620,10 +6779,8 @@ int meth_patch(struct transaction_t *txn
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    if ((r = pparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) {
-        return HTTP_FORBIDDEN;
-    }
+    r = dav_parse_req_target(txn, pparams);
+    if (r) return r;
 
     /* Make sure method is allowed (only allowed on resources) */
     if (!(txn->req_tgt.allow & ALLOW_PATCH)) return HTTP_NOT_ALLOWED;
@@ -6665,8 +6822,7 @@ int meth_patch(struct transaction_t *txn
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    ret = http_read_body(httpd_in, httpd_out,
-                         txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    ret = http_read_req_body(txn);
     if (ret) {
         txn->flags.conn = CONN_CLOSE;
         return ret;
@@ -6702,19 +6858,15 @@ int meth_patch(struct transaction_t *txn
         goto done;
     }
 
-    /* Fetch index record for the resource */
-    r = mailbox_find_index_record(mailbox, ddata->imap_uid, &oldrecord);
+    /* Fetch resource validators */
+    r = pparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &oldrecord, &etag, &lastmod);
     if (r) {
-        syslog(LOG_ERR, "mailbox_find_index_record(%s, %u) failed: %s",
-               txn->req_tgt.mbentry->name, ddata->imap_uid, error_message(r));
         txn->error.desc = error_message(r);
         ret = HTTP_SERVER_ERROR;
         goto done;
     }
 
-    etag = message_guid_encode(&oldrecord.guid);
-    lastmod = oldrecord.internaldate;
-
     /* Check any preferences */
     flags = get_preferences(txn);
 
@@ -6735,7 +6887,7 @@ int meth_patch(struct transaction_t *txn
 
     case HTTP_OK: {
         unsigned offset;
-        struct buf buf;
+        struct buf buf = BUF_INITIALIZER;
 
         /* Load message containing the resource */
         mailbox_map_record(mailbox, &oldrecord, &msg_buf);
@@ -6838,7 +6990,7 @@ int meth_patch(struct transaction_t *txn
 int meth_put(struct transaction_t *txn, void *params)
 {
     struct meth_params *pparams = (struct meth_params *) params;
-    int ret, r, precond, rights;
+    int ret, r, precond, rights, reqd_rights;
     const char **hdr, *etag;
     struct mime_type_t *mime = NULL;
     struct mailbox *mailbox = NULL;
@@ -6850,18 +7002,30 @@ int meth_put(struct transaction_t *txn,
     void *davdb = NULL, *obj = NULL;
     struct buf msg_buf = BUF_INITIALIZER;
 
-    if (txn->meth == METH_PUT) {
+    if (txn->meth == METH_POST) {
+        reqd_rights = DACL_ADDRSRC;
+    }
+    else {
         /* Response should not be cached */
         txn->flags.cc |= CC_NOCACHE;
 
         /* Parse the path */
-        if ((r = pparams->parse_path(txn->req_uri->path,
-                                     &txn->req_tgt, &txn->error.desc))) {
-            return HTTP_FORBIDDEN;
+        r = dav_parse_req_target(txn, pparams);
+        if (r) {
+            switch (r){
+            case HTTP_MOVED:
+            case HTTP_SERVER_ERROR: return r;
+            default: return HTTP_FORBIDDEN;
+            }
         }
 
         /* Make sure method is allowed (only allowed on resources) */
-        if (!(txn->req_tgt.allow & ALLOW_WRITE)) return HTTP_NOT_ALLOWED;
+        if (!((txn->req_tgt.allow & ALLOW_WRITE) && txn->req_tgt.resource))
+            return HTTP_NOT_ALLOWED;
+
+        reqd_rights = DACL_WRITECONT;
+
+        if (txn->req_tgt.allow & ALLOW_USERDATA) reqd_rights |= DACL_PROPRSRC;
     }
 
     /* Make sure mailbox type is correct */
@@ -6886,12 +7050,11 @@ int meth_put(struct transaction_t *txn,
 
     /* Check ACL for current user */
     rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_WRITECONT) || !(rights & DACL_ADDRES)) {
+    if (!(rights & reqd_rights)) {
         /* DAV:need-privileges */
         txn->error.precond = DAV_NEED_PRIVS;
         txn->error.resource = txn->req_tgt.path;
-        txn->error.rights =
-            !(rights & DACL_WRITECONT) ? DACL_WRITECONT : DACL_ADDRES;
+        txn->error.rights = reqd_rights;
         return HTTP_NO_PRIVS;
     }
 
@@ -6911,21 +7074,22 @@ int meth_put(struct transaction_t *txn,
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    ret = http_read_body(httpd_in, httpd_out,
-                         txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    ret = http_read_req_body(txn);
     if (ret) {
         txn->flags.conn = CONN_CLOSE;
         return ret;
     }
 
-    /* Check if we can append a new message to mailbox */
-    qdiffs[QUOTA_STORAGE] = buf_len(&txn->req_body.payload);
-    if ((r = append_check(txn->req_tgt.mbentry->name, httpd_authstate,
-                          ACL_INSERT, ignorequota ? NULL : qdiffs))) {
-        syslog(LOG_ERR, "append_check(%s) failed: %s",
-               txn->req_tgt.mbentry->name, error_message(r));
-        txn->error.desc = error_message(r);
-        return HTTP_SERVER_ERROR;
+    if (rights & DACL_WRITECONT) {
+        /* Check if we can append a new message to mailbox */
+        qdiffs[QUOTA_STORAGE] = buf_len(&txn->req_body.payload);
+        if ((r = append_check(txn->req_tgt.mbentry->name, httpd_authstate,
+                              ACL_INSERT, ignorequota ? NULL : qdiffs))) {
+            syslog(LOG_ERR, "append_check(%s) failed: %s",
+                   txn->req_tgt.mbentry->name, error_message(r));
+            txn->error.desc = error_message(r);
+            return HTTP_SERVER_ERROR;
+        }
     }
 
     /* Open mailbox for writing */
@@ -6945,31 +7109,13 @@ int meth_put(struct transaction_t *txn,
                                    txn->req_tgt.resource, (void *) &ddata, 0);
     /* XXX  Check errors */
 
-    if (ddata->imap_uid) {
-        /* Overwriting existing resource */
-
-        /* Fetch index record for the resource */
-        r = mailbox_find_index_record(mailbox, ddata->imap_uid, &oldrecord);
-        if (r) {
-            syslog(LOG_ERR, "mailbox_find_index_record(%s, %u) failed: %s",
-                   txn->req_tgt.mbentry->name, ddata->imap_uid, error_message(r));
-            txn->error.desc = error_message(r);
-            ret = HTTP_SERVER_ERROR;
-            goto done;
-        }
-
-        etag = message_guid_encode(&oldrecord.guid);
-        lastmod = oldrecord.internaldate;
-    }
-    else if (ddata->rowid) {
-        /* Unmapped URL (empty resource) */
-        etag = NULL;
-        lastmod = ddata->creationdate;
-    }
-    else {
-        /* New resource */
-        etag = NULL;
-        lastmod = 0;
+    /* Fetch resource validators */
+    r = pparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &oldrecord, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
 
     /* Check any preferences */
@@ -6999,27 +7145,33 @@ int meth_put(struct transaction_t *txn,
         break;
 
     case HTTP_PRECOND_FAILED:
-        if (flags & PREFER_REP) {
-            unsigned offset;
-            struct buf buf;
-
-            /* Load message containing the resource */
-            mailbox_map_record(mailbox, &oldrecord, &msg_buf);
-
-            /* Resource length doesn't include RFC 5322 header */
-            offset = oldrecord.header_size;
-
-            /* Parse existing resource */
-            buf_init_ro(&buf, buf_base(&msg_buf) + offset,
-                        buf_len(&msg_buf) - offset);
-            obj = pparams->mime_types[0].to_object(&buf);
-            buf_free(&buf);
-
+        if ((flags & PREFER_REP) && ((rights & DACL_READ) == DACL_READ)) {
             /* Fill in ETag and Last-Modified */
             txn->resp_body.etag = etag;
             txn->resp_body.lastmod = lastmod;
-        }
-        break;
+
+            if (pparams->get) {
+                r = pparams->get(txn, mailbox, &oldrecord, (void *) ddata, &obj);
+                if (r != HTTP_CONTINUE) flags &= ~PREFER_REP;
+            }
+            else {
+                unsigned offset;
+                struct buf buf = BUF_INITIALIZER;
+
+                /* Load message containing the resource */
+                mailbox_map_record(mailbox, &oldrecord, &msg_buf);
+
+                /* Resource length doesn't include RFC 5322 header */
+                offset = oldrecord.header_size;
+
+                /* Parse existing resource */
+                buf_init_ro(&buf, buf_base(&msg_buf) + offset,
+                            buf_len(&msg_buf) - offset);
+                obj = pparams->mime_types[0].to_object(&buf);
+                buf_free(&buf);
+            }
+        }
+        break;
 
     case HTTP_LOCKED:
         txn->error.precond = DAV_NEED_LOCK_TOKEN;
@@ -7084,10 +7236,9 @@ int meth_put(struct transaction_t *txn,
     }
 
   done:
-    if (obj) {
-        if (pparams->mime_types[0].free) pparams->mime_types[0].free(obj);
-        buf_free(&msg_buf);
-    }
+    if (obj && pparams->mime_types[0].free)
+        pparams->mime_types[0].free(obj);
+    buf_free(&msg_buf);
     if (davdb) pparams->davdb.close_db(davdb);
     mailbox_close(&mailbox);
 
@@ -7095,16 +7246,6 @@ int meth_put(struct transaction_t *txn,
 }
 
 
-/* Compare modseq in index maps -- used for sorting */
-static int map_modseq_cmp(const struct index_map *m1,
-                          const struct index_map *m2)
-{
-    if (m1->modseq < m2->modseq) return -1;
-    if (m1->modseq > m2->modseq) return 1;
-    return 0;
-}
-
-
 /* CALDAV:calendar-multiget/CARDDAV:addressbook-multiget REPORT */
 int report_multiget(struct transaction_t *txn, struct meth_params *rparams,
                     xmlNodePtr inroot, struct propfind_ctx *fctx)
@@ -7113,6 +7254,12 @@ int report_multiget(struct transaction_t
     struct mailbox *mailbox = NULL;
     xmlNodePtr node;
 
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
+
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, fctx->root->doc);
+
     /* Get props for each href */
     for (node = inroot->children; node; node = node->next) {
         if ((node->type == XML_ELEMENT_NODE) &&
@@ -7121,25 +7268,30 @@ int report_multiget(struct transaction_t
             xmlURIPtr uri;
             struct request_target_t tgt;
             struct dav_data *ddata;
+            const char *resultstr = NULL;
+
+            memset(&tgt, 0, sizeof(struct request_target_t));
 
             /* Parse the URI */
             uri = parse_uri(METH_REPORT, (const char *) href,
-                            1 /* path required */, &fctx->txn->error.desc);
+                            1 /* path required */, &resultstr);
             xmlFree(href);
             if (!uri) {
-                ret = HTTP_FORBIDDEN;
-                goto done;
+                r = HTTP_FORBIDDEN;
             }
+            else {
+                /* Parse the path */
+                tgt.namespace = txn->req_tgt.namespace;
 
-            /* Parse the path */
-            memset(&tgt, 0, sizeof(struct request_target_t));
-            tgt.namespace = txn->req_tgt.namespace;
-
-            r = rparams->parse_path(uri->path, &tgt, &fctx->txn->error.desc);
-            xmlFreeURI(uri);
+                r = rparams->parse_path(uri->path, &tgt, &resultstr);
+                xmlFreeURI(uri);
+            }
             if (r) {
-                ret = r;
-                goto done;
+                if (r == HTTP_MOVED)
+                    xml_add_response(fctx, HTTP_MOVED, 0, NULL, resultstr);
+                else
+                    xml_add_response(fctx, r, 0, resultstr, NULL);
+                goto next;
             }
 
             fctx->req_tgt = &tgt;
@@ -7154,9 +7306,9 @@ int report_multiget(struct transaction_t
                 if (r && r != IMAP_MAILBOX_NONEXISTENT) {
                     syslog(LOG_ERR, "http_mailbox_open(%s) failed: %s",
                            tgt.mbentry->name, error_message(r));
-                    txn->error.desc = error_message(r);
-                    ret = HTTP_SERVER_ERROR;
-                    goto done;
+                    xml_add_response(fctx, HTTP_SERVER_ERROR,
+                                     0, error_message(r), NULL);
+                    goto next;
                 }
 
                 fctx->mailbox = mailbox;
@@ -7164,8 +7316,8 @@ int report_multiget(struct transaction_t
 
             if (!fctx->mailbox || !tgt.resource) {
                 /* Add response for missing target */
-                xml_add_response(fctx, HTTP_NOT_FOUND, 0);
-                continue;
+                xml_add_response(fctx, HTTP_NOT_FOUND, 0, NULL, NULL);
+                goto next;
             }
 
             /* Open the DAV DB corresponding to the mailbox */
@@ -7179,45 +7331,100 @@ int report_multiget(struct transaction_t
 
             fctx->proc_by_resource(fctx, ddata);
 
+            rparams->davdb.close_db(fctx->davdb);
+
+        next:
             /* XXX - split this into a req_tgt cleanup */
             free(tgt.userid);
             mboxlist_entry_free(&tgt.mbentry);
-
-            rparams->davdb.close_db(fctx->davdb);
         }
     }
 
-  done:
+    /* End XML response */
+    xml_partial_response(txn, fctx->root->doc, NULL /* end */, 0, &fctx->xmlbuf);
+    xmlBufferFree(fctx->xmlbuf);
+
+    /* End of output */
+    write_body(0, txn, NULL, 0);
+
     mailbox_close(&mailbox);
 
-    return (ret ? ret : HTTP_MULTI_STATUS);
+    return ret;
+}
+
+
+struct updates_rock {
+    struct propfind_ctx *fctx;
+    get_modseq_t get_modseq;
+    uint32_t limit;
+    modseq_t syncmodseq;
+    modseq_t basemodseq;
+    modseq_t *respmodseq;
+    uint32_t *nresp;
+};
+
+static int updates_cb(void *rock, void *data)
+{
+    struct dav_data *ddata = (struct dav_data *) data;
+    struct updates_rock *urock = (struct updates_rock *) rock;
+    struct propfind_ctx *fctx = urock->fctx;
+    modseq_t modseq = urock->get_modseq(fctx->mailbox, data, fctx->userid);
+
+    if (!ddata->alive) {
+        if (modseq <= urock->basemodseq) {
+            /* Initial sync - ignore unmapped resources */
+            return 0;
+        }
+
+        /* Report resource as NOT FOUND
+           IMAP UID of 0 will cause index record to be ignored
+           propfind_by_resource() will append our resource name */
+        ddata->imap_uid = 0;
+    }
+    else if (modseq <= urock->syncmodseq) {
+        /* Per-user modseq hasn't changed */
+        return 0;
+    }
+
+
+    if (*urock->nresp >= urock->limit) {
+        /* Number of responses has reached client-specified limit */
+        return HTTP_NO_STORAGE;
+    }
+    else {
+        /* Bump response count */
+        *urock->nresp += 1;
+    }
+
+    /* respmodseq will be highest modseq of the resources we return */
+    *(urock->respmodseq) = MAX(modseq, *(urock->respmodseq));
+
+    /* Add <response> element for this resource to root */
+    fctx->proc_by_resource(fctx, ddata);
+    fctx->record = NULL;
+
+    return 0;
 }
 
 
 /* DAV:sync-collection REPORT */
-int report_sync_col(struct transaction_t *txn,
-                    struct meth_params *rparams __attribute__((unused)),
+int report_sync_col(struct transaction_t *txn, struct meth_params *rparams,
                     xmlNodePtr inroot, struct propfind_ctx *fctx)
 {
-    int ret = 0, r, i, unbind_flag = -1, unchanged_flag = -1;
+    int ret = 0, r;
     struct mailbox *mailbox = NULL;
     uint32_t uidvalidity = 0;
     modseq_t syncmodseq = 0;
     modseq_t basemodseq = 0;
     modseq_t highestmodseq = 0;
     modseq_t respmodseq = 0;
-    uint32_t limit = -1;
-    uint32_t msgno;
+    uint32_t limit = UINT32_MAX - 1;
     uint32_t nresp = 0;
     xmlNodePtr node;
-    struct index_state istate;
     char tokenuri[MAX_MAILBOX_PATH+1];
 
     /* XXX  Handle Depth (cal-home-set at toplevel) */
 
-    memset(&istate, 0, sizeof(struct index_state));
-    istate.map = NULL;
-
     /* Open mailbox for reading */
     r = mailbox_open_irl(txn->req_tgt.mbentry->name, &mailbox);
     if (r) {
@@ -7232,8 +7439,6 @@ int report_sync_col(struct transaction_t
     fctx->mailbox = mailbox;
 
     highestmodseq = mailbox->i.highestmodseq;
-    mailbox_user_flag(mailbox, DFLAG_UNBIND, &unbind_flag, 1);
-    mailbox_user_flag(mailbox, DFLAG_UNCHANGED, &unchanged_flag, 1);
 
     /* Parse children element of report */
     for (node = inroot->children; node; node = node->next) {
@@ -7242,6 +7447,10 @@ int report_sync_col(struct transaction_t
         if (node->type == XML_ELEMENT_NODE) {
             if (!xmlStrcmp(node->name, BAD_CAST "sync-token") &&
                 (str = xmlNodeListGetString(inroot->doc, node->children, 1))) {
+                /* Add sync-token to our header cache */
+                spool_cache_header(xstrdup(":token"),
+                                   xstrdup((const char *) str), txn->req_hdrs);
+
                 /* Parse sync-token */
                 r = sscanf((char *) str, SYNC_TOKEN_URL_SCHEME
                            "%u-" MODSEQ_FMT "-" MODSEQ_FMT "%1s",
@@ -7292,12 +7501,15 @@ int report_sync_col(struct transaction_t
                 }
             }
             else if (!xmlStrcmp(node->name, BAD_CAST "limit")) {
+                errno = 0;
+
                 for (node2 = node->children; node2; node2 = node2->next) {
                     if ((node2->type == XML_ELEMENT_NODE) &&
                         !xmlStrcmp(node2->name, BAD_CAST "nresults") &&
                         (!(str = xmlNodeListGetString(inroot->doc,
                                                       node2->children, 1)) ||
-                         (sscanf((char *) str, "%u", &limit) != 1))) {
+                         (sscanf((char *) str, "%u", &limit) != 1) ||
+                         (errno != 0) || (limit >= UINT32_MAX))) {
                         txn->error.precond = DAV_OVER_LIMIT;
                         ret = HTTP_FORBIDDEN;
                     }
@@ -7321,133 +7533,36 @@ int report_sync_col(struct transaction_t
         basemodseq = highestmodseq;
     }
 
-    /* Construct array of records for sorting and/or fetching cached header */
-    istate.mailbox = mailbox;
-    istate.map = xzmalloc(mailbox->i.num_records *
-                          sizeof(struct index_map));
-
-    /* Find which resources we need to report */
-    struct mailbox_iter *iter = mailbox_iter_init(mailbox, syncmodseq, 0);
-    const message_t *msg;
-    while ((msg = mailbox_iter_step(iter))) {
-        const struct index_record *record = msg_record(msg);
-        if ((unbind_flag >= 0) &&
-            record->user_flags[unbind_flag / 32] & (1 << (unbind_flag & 31))) {
-            /* Resource replaced by a PUT, COPY, or MOVE - ignore it */
-            continue;
-        }
-
-        if ((record->modseq - syncmodseq == 1) &&
-            (unchanged_flag >= 0) &&
-            (record->user_flags[unchanged_flag / 32] &
-             (1 << (unchanged_flag & 31)))) {
-            /* Resource has just had VTIMEZONEs stripped - ignore it */
-            continue;
-        }
+    /* Open the DAV DB corresponding to the mailbox */
+    fctx->davdb = rparams->davdb.open_db(fctx->mailbox);
 
-        if ((record->modseq <= basemodseq) &&
-            (record->system_flags & FLAG_EXPUNGED)) {
-            /* Initial sync - ignore unmapped resources */
-            continue;
-        }
+    /* Setup for chunked response */
+    txn->flags.te |= TE_CHUNKED;
 
-        /* copy data into map (just like index.c - XXX helper fn? */
-        istate.map[nresp].recno = record->recno;
-        istate.map[nresp].uid = record->uid;
-        istate.map[nresp].modseq = record->modseq;
-        istate.map[nresp].system_flags = record->system_flags;
-        for (i = 0; i < MAX_USER_FLAGS/32; i++)
-            istate.map[nresp].user_flags[i] = record->user_flags[i];
-        istate.map[nresp].cache_offset = record->cache_offset;
-
-        nresp++;
-    }
-    mailbox_iter_done(&iter);
-
-    if (limit < nresp) {
-        /* Need to truncate the responses */
-        struct index_map *map = istate.map;
-
-        /* Sort the response records by modseq */
-        qsort(map, nresp, sizeof(struct index_map),
-              (int (*)(const void *, const void *)) &map_modseq_cmp);
-
-        /* Our last response MUST be the last record with its modseq */
-        for (nresp = limit;
-             nresp && map[nresp-1].modseq == map[nresp].modseq;
-             nresp--);
-
-        if (!nresp) {
-            /* DAV:number-of-matches-within-limits */
-            fctx->txn->error.desc = "Unable to truncate results";
-            txn->error.precond = DAV_OVER_LIMIT;
-            ret = HTTP_NO_STORAGE;
-            goto done;
-        }
+    /* Begin XML response */
+    xml_response(HTTP_MULTI_STATUS, txn, fctx->root->doc);
 
-        /* respmodseq will be modseq of last record we return */
-        respmodseq = map[nresp-1].modseq;
+    /* Report the resources within the client requested limit (if any) */
+    struct updates_rock rock = { fctx, rparams->get_modseq, limit,
+                                 syncmodseq, basemodseq, &respmodseq, &nresp };
 
+    r = rparams->davdb.foreach_update(fctx->davdb, syncmodseq, mailbox->name,
+                                      -1 /* ALL kinds of resources */,
+                                      (syncmodseq && basemodseq) ? 0 : limit + 1,
+                                      &updates_cb, &rock);
+    if (r) {
         /* Tell client we truncated the responses */
-        xml_add_response(fctx, HTTP_NO_STORAGE, DAV_OVER_LIMIT);
+        if (fctx->req_tgt->resource) *(fctx->req_tgt->resource) = '\0';
+        xml_add_response(fctx, HTTP_NO_STORAGE, DAV_OVER_LIMIT, NULL, NULL);
     }
     else {
         /* Full response - respmodseq will be highestmodseq of mailbox */
         respmodseq = highestmodseq;
     }
 
-    /* XXX - this is crappy - re-reading the messages again */
-    /* Report the resources within the client requested limit (if any) */
-    for (msgno = 1; msgno <= nresp; msgno++) {
-        char *p, *resource = NULL;
-        struct index_record thisrecord;
-
-        if (index_reload_record(&istate, msgno, &thisrecord))
-            continue;
-
-        /* Get resource filename from Content-Disposition header */
-        if ((p = index_getheader(&istate, msgno, "Content-Disposition")) &&
-            (p = strstr(p, "filename="))) {
-            resource = p + 9;
-        }
-        if (!resource) continue;  /* No filename */
-
-        if (*resource == '\"') {
-            resource++;
-            if ((p = strchr(resource, '\"'))) *p = '\0';
-        }
-        else if ((p = strchr(resource, ';'))) *p = '\0';
-
-        if (thisrecord.system_flags & FLAG_EXPUNGED) {
-            /* report as NOT FOUND
-               IMAP UID of 0 will cause index record to be ignored
-               propfind_by_resource() will append our resource name */
-            struct dav_data ddata;
-
-            memset(&ddata, 0, sizeof(struct dav_data));
-            ddata.resource = resource;
-            fctx->proc_by_resource(fctx, &ddata);
-        }
-        else {
-            struct dav_data *ddata;
-
-            /* Open the DAV DB corresponding to the mailbox */
-            if (!fctx->davdb)
-                fctx->davdb = rparams->davdb.open_db(fctx->mailbox);
-
-            rparams->davdb.lookup_resource(fctx->davdb, fctx->mailbox->name,
-                                           resource, (void **) &ddata, 0);
-            ddata->resource = resource;
-            fctx->record = &thisrecord;
-            fctx->proc_by_resource(fctx, ddata);
-        }
-
-        fctx->record = NULL;
-    }
-
     if (fctx->davdb) rparams->davdb.close_db(fctx->davdb);
 
-    /* Add sync-token element */
+    /* Add sync-token element to root */
     if (respmodseq < basemodseq) {
         /* Client limited results of initial sync - include basemodseq */
         snprintf(tokenuri, MAX_MAILBOX_PATH,
@@ -7459,13 +7574,24 @@ int report_sync_col(struct transaction_t
                  SYNC_TOKEN_URL_SCHEME "%u-" MODSEQ_FMT,
                  mailbox->i.uidvalidity, respmodseq);
     }
-    xmlNewChild(fctx->root, NULL, BAD_CAST "sync-token", BAD_CAST tokenuri);
+    node =
+        xmlNewChild(fctx->root, NULL, BAD_CAST "sync-token", BAD_CAST tokenuri);
+
+    /* Add sync-token element to output buffer */
+    xml_partial_response(NULL /* !output */,
+                         fctx->root->doc, node, 1, &fctx->xmlbuf);
+
+    /* End XML response */
+    xml_partial_response(txn, fctx->root->doc, NULL /* end */, 0, &fctx->xmlbuf);
+    xmlBufferFree(fctx->xmlbuf);
+
+    /* End of output */
+    write_body(0, txn, NULL, 0);
 
   done:
-    if (istate.map) free(istate.map);
     mailbox_close(&mailbox);
 
-    return (ret ? ret : HTTP_MULTI_STATUS);
+    return ret;
 }
 
 
@@ -7517,7 +7643,7 @@ int expand_property(xmlNodePtr inroot, s
             fctx->mailbox = mailbox;
         }
 
-        xml_add_response(fctx, 0, 0);
+        xml_add_response(fctx, 0, 0, NULL, NULL);
 
         mailbox_close(&mailbox);
     }
@@ -7553,12 +7679,7 @@ int expand_property(xmlNodePtr inroot, s
 
   done:
     /* Free the entry list */
-    while (fctx->elist) {
-        struct propfind_entry_list *freeme = fctx->elist;
-        fctx->elist = freeme->next;
-        xmlFree(freeme->name);
-        free(freeme);
-    }
+    free_entry_list(fctx->elist);
 
     free(req_tgt.userid);
 
@@ -7604,13 +7725,13 @@ int report_expand_prop(struct transactio
 /* DAV:acl-principal-prop-set REPORT */
 int report_acl_prin_prop(struct transaction_t *txn __attribute__((unused)),
                          struct meth_params *rparams __attribute__((unused)),
-                         xmlNodePtr inroot, struct propfind_ctx *fctx)
+                         xmlNodePtr inroot __attribute__((unused)),
+                         struct propfind_ctx *fctx)
 {
     int ret = 0;
     struct request_target_t req_tgt;
     mbentry_t *mbentry = fctx->req_tgt->mbentry;
     char *userid, *nextid;
-    xmlNodePtr cur;
 
     /* Generate URL for user principal collection */
     buf_reset(&fctx->buf);
@@ -7625,16 +7746,6 @@ int report_acl_prin_prop(struct transact
     fctx->lprops = principal_props;
     fctx->proc_by_resource = &propfind_by_resource;
 
-    /* Parse children element of report */
-    for (cur = inroot->children; cur; cur = cur->next) {
-        if (cur->type == XML_ELEMENT_NODE &&
-            !xmlStrcmp(cur->name, BAD_CAST "prop")) {
-
-            if ((ret = preload_proplist(cur->children, fctx))) goto done;
-            break;
-        }
-    }
-
     /* Parse the ACL string (userid/rights pairs) */
     for (userid = mbentry->acl; userid; userid = nextid) {
         char *rightstr;
@@ -7653,13 +7764,12 @@ int report_acl_prin_prop(struct transact
             req_tgt.userid = xstrdup(userid);
 
             /* Add response for URL */
-            xml_add_response(fctx, 0, 0);
+            xml_add_response(fctx, 0, 0, NULL, NULL);
 
             free(req_tgt.userid);
         }
     }
 
-  done:
     return (ret ? ret : HTTP_MULTI_STATUS);
 }
 
@@ -7718,7 +7828,7 @@ static int principal_search(const char *
     free(fctx->req_tgt->userid);
     fctx->req_tgt->userid = xstrdup(userid);
 
-    return xml_add_response(fctx, 0, 0);
+    return xml_add_response(fctx, 0, 0, NULL, NULL);
 }
 
 
@@ -7902,13 +8012,12 @@ int meth_report(struct transaction_t *tx
     xmlNsPtr ns[NUM_NAMESPACE];
     struct hash_table ns_table = { 0, NULL, NULL };
     struct propfind_ctx fctx;
-    struct propfind_entry_list *elist = NULL;
 
     memset(&fctx, 0, sizeof(struct propfind_ctx));
 
     /* Parse the path */
-    if ((r = rparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, rparams);
+    if (r) return r;
 
     /* Make sure method is allowed */
     if (!(txn->req_tgt.allow & ALLOW_DAV)) return HTTP_NOT_ALLOWED;
@@ -7938,7 +8047,10 @@ int meth_report(struct transaction_t *tx
 
     /* Check the report type against our supported list */
     for (report = rparams->reports; report && report->name; report++) {
-        if (!xmlStrcmp(inroot->name, BAD_CAST report->name)) break;
+        if (inroot->ns &&
+            !xmlStrcmp(inroot->ns->href,
+                       BAD_CAST known_namespaces[report->ns].href) &&
+            !xmlStrcmp(inroot->name, BAD_CAST report->name)) break;
     }
     if (!report || !report->name) {
         syslog(LOG_WARNING, "REPORT %s", inroot->name);
@@ -7999,29 +8111,38 @@ int meth_report(struct transaction_t *tx
     if (report->flags & (REPORT_NEED_PROPS | REPORT_ALLOW_PROPS)) {
         /* Parse children element of report */
         for (cur = inroot->children; cur; cur = cur->next) {
+            unsigned mode = PROPFIND_NONE;
+
             if (cur->type == XML_ELEMENT_NODE) {
                 if (!xmlStrcmp(cur->name, BAD_CAST "allprop")) {
-                    fctx.mode = PROPFIND_ALL;
+                    mode = PROPFIND_ALL;
                     prop = cur;
-                    break;
                 }
                 else if (!xmlStrcmp(cur->name, BAD_CAST "propname")) {
-                    fctx.mode = PROPFIND_NAME;
+                    mode = PROPFIND_NAME;
                     fctx.prefer = PREFER_MIN;  /* Don't want 404 (Not Found) */
                     prop = cur;
-                    break;
                 }
                 else if (!xmlStrcmp(cur->name, BAD_CAST "prop")) {
-                    fctx.mode = PROPFIND_PROP;
+                    mode = PROPFIND_PROP;
                     prop = cur;
                     props = cur->children;
-                    break;
                 }
             }
+
+            if (mode != PROPFIND_NONE) {
+                if (fctx.mode != PROPFIND_NONE) {
+                    txn->error.desc = "Multiple <*prop*> elements in REPORT";
+                    ret = HTTP_BAD_REQUEST;
+                    goto done;
+                }
+
+                fctx.mode = mode;
+            }
         }
 
         if (!prop && (report->flags & REPORT_NEED_PROPS)) {
-            txn->error.desc = "Missing <prop> element in REPORT\r\n";
+            txn->error.desc = "Missing <prop> element in REPORT";
             ret = HTTP_BAD_REQUEST;
             goto done;
         }
@@ -8046,8 +8167,10 @@ int meth_report(struct transaction_t *tx
     fctx.mbentry = NULL;
     fctx.mailbox = NULL;
     fctx.record = NULL;
+    fctx.get_validators = rparams->get_validators;
     fctx.reqd_privs = report->reqd_privs;
     if (rparams->mime_types) fctx.free_obj = rparams->mime_types[0].free;
+    fctx.proc_by_resource = &propfind_by_resource;
     fctx.elist = NULL;
     fctx.lprops = rparams->propfind.lprops;
     fctx.root = outroot;
@@ -8057,8 +8180,10 @@ int meth_report(struct transaction_t *tx
 
     /* Parse the list of properties and build a list of callbacks */
     if (fctx.mode) {
-        fctx.proc_by_resource = &propfind_by_resource;
         ret = preload_proplist(props, &fctx);
+
+        /* iCalendar/vCard data in response should not be transformed */
+        if (fctx.flags.fetcheddata) txn->flags.cc |= CC_NOTRANSFORM;
     }
 
     /* Process the requested report */
@@ -8069,7 +8194,7 @@ int meth_report(struct transaction_t *tx
         switch (ret) {
         case HTTP_OK:
         case HTTP_MULTI_STATUS:
-            /* iCalendar data in response should not be transformed */
+            /* iCalendar/vCard data in response should not be transformed */
             if (fctx.flags.fetcheddata) txn->flags.cc |= CC_NOTRANSFORM;
 
             xml_response(ret, txn, outroot->doc);
@@ -8084,17 +8209,7 @@ int meth_report(struct transaction_t *tx
 
   done:
     /* Free the entry list */
-    elist = fctx.elist;
-    while (elist) {
-        struct propfind_entry_list *freeme = elist;
-        elist = elist->next;
-        if (freeme->flags & PROP_CLEANUP) {
-            freeme->get(freeme->name, NULL, &fctx,
-                        NULL, NULL, NULL, freeme->rock);
-        }
-        xmlFree(freeme->name);
-        free(freeme);
-    }
+    free_entry_list(fctx.elist);
 
     buf_free(&fctx.buf);
 
@@ -8130,8 +8245,8 @@ int meth_unlock(struct transaction_t *tx
     txn->flags.cc |= CC_NOCACHE;
 
     /* Parse the path */
-    if ((r = lparams->parse_path(txn->req_uri->path,
-                                 &txn->req_tgt, &txn->error.desc))) return r;
+    r = dav_parse_req_target(txn, lparams);
+    if (r) return r;
 
     /* Make sure method is allowed (only allowed on resources) */
     if (!(txn->req_tgt.allow & ALLOW_WRITE)) return HTTP_NOT_ALLOWED;
@@ -8212,22 +8327,13 @@ int meth_unlock(struct transaction_t *tx
         goto done;
     }
 
-    if (ddata->imap_uid) {
-        /* Mapped URL - Fetch index record for the resource */
-        r = mailbox_find_index_record(mailbox, ddata->imap_uid, &record);
-        if (r) {
-            txn->error.desc = error_message(r);
-            ret = HTTP_SERVER_ERROR;
-            goto done;
-        }
-
-        etag = message_guid_encode(&record.guid);
-        lastmod = record.internaldate;
-    }
-    else {
-        /* Unmapped URL (empty resource) */
-        etag = NULL;
-        lastmod = ddata->creationdate;
+    /* Fetch resource validators */
+    r = lparams->get_validators(mailbox, (void *) ddata, httpd_userid,
+                                &record, &etag, &lastmod);
+    if (r) {
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
     }
 
     /* Check any preconditions */
@@ -8269,7 +8375,7 @@ int meth_unlock(struct transaction_t *tx
 int dav_store_resource(struct transaction_t *txn,
                        const char *data, size_t datalen,
                        struct mailbox *mailbox, struct index_record *oldrecord,
-                       strarray_t *imapflags)
+                       modseq_t createdmodseq, strarray_t *imapflags)
 {
     int ret = HTTP_CREATED, r;
     hdrcache_t hdrcache = txn->req_hdrs;
@@ -8308,7 +8414,7 @@ int dav_store_resource(struct transactio
         }
 
         mimehdr = charset_encode_mimeheader(buf_cstring(&txn->buf),
-                                            buf_len(&txn->buf));
+                                            buf_len(&txn->buf), 0);
         fprintf(f, "From: %s\r\n", mimehdr);
         free(mimehdr);
         buf_reset(&txn->buf);
@@ -8322,8 +8428,8 @@ int dav_store_resource(struct transactio
         fprintf(f, "Date: %s\r\n", hdr[0]);
     }
     else {
-        char datestr[80];
-        time_to_rfc822(now, datestr, sizeof(datestr));
+        char datestr[80];       /* XXX: Why do we need 80 character buffer? */
+        time_to_rfc5322(now, datestr, sizeof(datestr));
         fprintf(f, "Date: %s\r\n", datestr);
     }
 
@@ -8374,7 +8480,13 @@ int dav_store_resource(struct transactio
                           0, qdiffs, 0, 0, EVENT_MESSAGE_NEW|EVENT_CALENDAR))) {
         syslog(LOG_ERR, "append_setup(%s) failed: %s",
                mailbox->name, error_message(r));
-        ret = HTTP_SERVER_ERROR;
+        if (r == IMAP_QUOTA_EXCEEDED) {
+            /* DAV:quota-not-exceeded */
+            txn->error.precond = DAV_OVER_QUOTA;
+            ret = HTTP_NO_STORAGE;
+        } else {
+            ret = HTTP_SERVER_ERROR;
+        }
         txn->error.desc = "append_setup() failed\r\n";
     }
     else {
@@ -8385,6 +8497,7 @@ int dav_store_resource(struct transactio
 
         if (oldrecord) {
             flaglist = mailbox_extract_flags(mailbox, oldrecord, httpd_userid);
+            mailbox_get_annotate_state(mailbox, oldrecord->uid, NULL);
             annots = mailbox_extract_annots(mailbox, oldrecord);
         }
 
@@ -8397,7 +8510,7 @@ int dav_store_resource(struct transactio
         }
 
         /* Append the message to the mailbox */
-        if ((r = append_fromstage(&as, &body, stage, now, flaglist, 0, annots))) {
+        if ((r = append_fromstage(&as, &body, stage, now, createdmodseq, flaglist, 0, annots))) {
             syslog(LOG_ERR, "append_fromstage(%s) failed: %s",
                    mailbox->name, error_message(r));
             ret = HTTP_SERVER_ERROR;
@@ -8420,14 +8533,6 @@ int dav_store_resource(struct transactio
                 txn->error.desc = "append_commit() failed\r\n";
             }
             else {
-                /* Read index record for new message (always the last one) */
-                struct index_record newrecord;
-                memset(&newrecord, 0, sizeof(struct index_record));
-                newrecord.recno = mailbox->i.num_records;
-                newrecord.uid = mailbox->i.last_uid;
-
-                mailbox_reload_index_record(mailbox, &newrecord);
-
                 if (oldrecord) {
                     /* Now that we have the replacement message in place
                        expunge the old one. */
@@ -8439,7 +8544,7 @@ int dav_store_resource(struct transactio
                     r = mailbox_user_flag(mailbox, DFLAG_UNBIND, &userflag, 1);
                     if (!r) {
                         oldrecord->user_flags[userflag/32] |= 1 << (userflag & 31);
-                        oldrecord->system_flags |= FLAG_EXPUNGED;
+                        oldrecord->internal_flags |= FLAG_INTERNAL_EXPUNGED;
                         r = mailbox_rewrite_index_record(mailbox, oldrecord);
                     }
                     if (r) {
@@ -8451,15 +8556,19 @@ int dav_store_resource(struct transactio
                 }
 
                 if (!r) {
-                    struct resp_body_t *resp_body = &txn->resp_body;
-                    static char *newetag;
-
-                    if (newetag) free(newetag);
-                    newetag = xstrdupnull(message_guid_encode(&newrecord.guid));
-
-                    /* Tell client about the new resource */
-                    resp_body->lastmod = newrecord.internaldate;
-                    resp_body->etag = newetag;
+                    /* Read index record for new message (always the last one) */
+                    struct index_record newrecord;
+                    struct dav_data ddata;
+                    static char etagbuf[256];
+                    const char *etag;
+
+                    ddata.alive = 1;
+                    ddata.imap_uid = mailbox->i.last_uid;
+                    dav_get_validators(mailbox, &ddata, httpd_userid, &newrecord,
+                                       &etag, &txn->resp_body.lastmod);
+                    strncpy(etagbuf, etag, 255);
+                    etagbuf[255] = 0;
+                    txn->resp_body.etag = etagbuf;
                 }
             }
         }
@@ -8471,244 +8580,117 @@ int dav_store_resource(struct transactio
 }
 
 
-static void my_dav_init(struct buf *serverinfo __attribute__((unused)))
-{
-    if (!namespace_principal.enabled) return;
-
-    if (!config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX)) {
-        fatal("Required 'davnotificationsprefix' option is not set", EC_CONFIG);
-    }
-
-    namespace_notify.enabled = 1;
-
-    webdav_init();
-}
-
-
-static int lookup_notify_collection(const char *userid, mbentry_t **mbentry)
+static void my_dav_init(struct buf *serverinfo)
 {
-    mbname_t *mbname;
-    const char *notifyname;
-    int r;
-
-    /* Create notification mailbox name from the parsed path */
-    mbname = mbname_from_userid(userid);
-    mbname_push_boxes(mbname, config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX));
-
-    /* XXX - hack to allow @domain parts for non-domain-split users */
-    if (httpd_extradomain) {
-        /* not allowed to be cross domain */
-        if (mbname_localpart(mbname) &&
-            strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
-            r = HTTP_NOT_FOUND;
-            goto done;
-        }
-        mbname_set_domain(mbname, NULL);
-    }
-
-    /* Locate the mailbox */
-    notifyname = mbname_intname(mbname);
-    r = http_mlookup(notifyname, mbentry, NULL);
-    if (r == IMAP_MAILBOX_NONEXISTENT) {
-        /* Find location of INBOX */
-        char *inboxname = mboxname_user_mbox(userid, NULL);
-
-        int r1 = http_mlookup(inboxname, mbentry, NULL);
-        free(inboxname);
-        if (r1 == IMAP_MAILBOX_NONEXISTENT) {
-            r = IMAP_INVALID_USER;
-            goto done;
-        }
-
-        if (*mbentry) free((*mbentry)->name);
-        else *mbentry = mboxlist_entry_create();
-        (*mbentry)->name = xstrdup(notifyname);
-    }
-
-  done:
-    mbname_free(&mbname);
-
-    return r;
-}
-
+    time_t compile_time = calc_compile_time(__TIME__, __DATE__);
+    struct stat sbuf;
+    struct message_guid guid;
+    xmlNodePtr root, node, apps, app;
+    xmlNsPtr ns[NUM_NAMESPACE];
 
-static int create_notify_collection(const char *userid, struct mailbox **mailbox)
-{
-    /* notifications collection */
-    mbentry_t *mbentry = NULL;
-    int r = lookup_notify_collection(userid, &mbentry);
+    buf_printf(serverinfo, " SQLite/%s", sqlite3_libversion());
 
-    if (r == IMAP_INVALID_USER) {
-        goto done;
+    /* Generate token based on compile date/time of this source file,
+       the number of available RSCALEs and the config file size/mtime */
+    stat(config_filename, &sbuf);
+    server_info_lastmod = MAX(compile_time, sbuf.st_mtime);
+
+    buf_printf(&server_info_token, "%ld-%ld-%ld", (long) compile_time,
+               sbuf.st_mtime, sbuf.st_size);
+    message_guid_generate(&guid, buf_cstring(&server_info_token),
+                          buf_len(&server_info_token));
+    buf_setcstr(&server_info_token, message_guid_encode(&guid));
+
+    /* Generate link header contents */
+    buf_printf(&server_info_link,
+               "<%s/%s>; rel=\"server-info\"; token=\"%s\"",
+               namespace_principal.prefix, SERVER_INFO,
+               buf_cstring(&server_info_token));
+
+    /* Start construction of our server-info */
+    if (!(root = init_xml_response("server-info", NS_DAV, NULL, ns))) {
+        syslog(LOG_ERR, "Unable to create server-info XML");
+        return;
     }
-    else if (r == IMAP_MAILBOX_NONEXISTENT) {
-        if (!mbentry) goto done;
-        else if (mbentry->server) {
-            proxy_findserver(mbentry->server, &http_protocol, httpd_userid,
-                             &backend_cached, NULL, NULL, httpd_in);
-            goto done;
-        }
 
-        r = mboxlist_createmailbox(mbentry->name, MBTYPE_COLLECTION,
-                                   NULL, 1 /* admin */, userid, NULL,
-                                   0, 0, 0, 0, mailbox);
-        /* we lost the race, that's OK */
-        if (r == IMAP_MAILBOX_LOCKED) r = 0;
-        if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
-                      mbentry->name, error_message(r));
-    }
-    else if (mailbox) {
-        /* Open mailbox for writing */
-        r = mailbox_open_iwl(mbentry->name, mailbox);
-        if (r) {
-            syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
-                   mbentry->name, error_message(r));
+    /* Add token */
+    xmlNewTextChild(root, ns[NS_DAV], BAD_CAST "token",
+                    BAD_CAST buf_cstring(&server_info_token));
+
+    /* Add server */
+    if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
+        node = xmlNewChild(root, NULL, BAD_CAST "server", NULL);
+        xmlNewChild(node, ns[NS_DAV],
+                    BAD_CAST "name", BAD_CAST "Cyrus-HTTP");
+        xmlNewTextChild(node, ns[NS_DAV],
+                        BAD_CAST "version", BAD_CAST CYRUS_VERSION);
+    }
+
+    /* Add global DAV features */
+    node = xmlNewChild(root, NULL, BAD_CAST "features", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-1", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-2", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-3", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "access-control", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "extended-mkcol", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "quota", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "sync-collection", NULL);
+    xmlNewChild(node, ns[NS_DAV], BAD_CAST "add-member", NULL);
+
+    apps = xmlNewChild(root, NULL, BAD_CAST "applications", NULL);
+
+    if (namespace_calendar.enabled) {
+        app = xmlNewChild(apps, NULL, BAD_CAST "application", NULL);
+        ensure_ns(ns, NS_CALDAV, app, XML_NS_CALDAV, "C");
+        xmlNewChild(app, NULL, BAD_CAST "name", BAD_CAST "caldav");
+
+        /* Add CalDAV features */
+        node = xmlNewChild(app, NULL, BAD_CAST "features", NULL);
+        xmlNewChild(node, ns[NS_CALDAV],
+                    BAD_CAST "calendar-access", NULL);
+        if (namespace_calendar.allow & ALLOW_CAL_SCHED)
+            xmlNewChild(node, ns[NS_CALDAV],
+                        BAD_CAST "calendar-auto-schedule", NULL);
+        if (namespace_calendar.allow & ALLOW_CAL_NOTZ)
+            xmlNewChild(node, ns[NS_CALDAV],
+                        BAD_CAST "calendar-no-timezone", NULL);
+        if (namespace_calendar.allow & ALLOW_CAL_AVAIL)
+            xmlNewChild(node, ns[NS_CALDAV],
+                        BAD_CAST "calendar-availability", NULL);
+        if (namespace_calendar.allow & ALLOW_CAL_ATTACH) {
+            xmlNewChild(node, ns[NS_CALDAV],
+                        BAD_CAST "calendar-managed-attachments", NULL);
+            xmlNewChild(node, ns[NS_CALDAV],
+                        BAD_CAST "calendar-managed-attachments-no-recurrence",
+                        NULL);
         }
     }
 
- done:
-    mboxlist_entry_free(&mbentry);
-    return r;
-}
+    if (namespace_addressbook.enabled) {
+        app = xmlNewChild(apps, NULL, BAD_CAST "application", NULL);
+        ensure_ns(ns, NS_CARDDAV, app, XML_NS_CARDDAV, "A");
+        xmlNewChild(app, NULL, BAD_CAST "name", BAD_CAST "carddav");
 
-static void my_dav_auth(const char *userid)
-{
-    if (httpd_userisadmin || httpd_userisanonymous ||
-        global_authisa(httpd_authstate, IMAPOPT_PROXYSERVERS)) {
-        /* admin, anonymous, or proxy from frontend - won't have DAV database */
-        return;
+        /* Add CardDAV features */
+        node = xmlNewChild(app, NULL, BAD_CAST "features", NULL);
+        xmlNewChild(node, ns[NS_CARDDAV], BAD_CAST "addressbook", NULL);
     }
-    else if (config_mupdate_server && !config_getstring(IMAPOPT_PROXYSERVERS)) {
-        /* proxy-only server - won't have DAV databases */
-    }
-    else {
-        /* Open WebDAV DB for 'userid' */
-        my_dav_reset();
-        auth_webdavdb = webdav_open_userid(userid);
-        if (!auth_webdavdb) fatal("Unable to open WebDAV DB", EC_IOERR);
-    }
-
-    /* Auto-provision a notifications collection for 'userid' */
-    create_notify_collection(userid, NULL);
-
-
-    if (!server_info) {
-        time_t compile_time = calc_compile_time(__TIME__, __DATE__);
-        struct stat sbuf;
-        struct message_guid guid;
-        xmlNodePtr root, node, apps, app;
-        xmlNsPtr ns[NUM_NAMESPACE];
-
-        /* Generate token based on compile date/time of this source file,
-           the number of available RSCALEs and the config file size/mtime */
-        stat(config_filename, &sbuf);
-        server_info_lastmod = MAX(compile_time, sbuf.st_mtime);
-
-        buf_printf(&server_info_token, "%ld-%ld-%ld", (long) compile_time,
-                   sbuf.st_mtime, sbuf.st_size);
-        message_guid_generate(&guid, buf_cstring(&server_info_token),
-                              buf_len(&server_info_token));
-        buf_setcstr(&server_info_token, message_guid_encode(&guid));
-
-        /* Generate link header contents */
-        buf_printf(&server_info_link,
-                   "<%s/%s>; rel=\"server-info\"; token=\"%s\"",
-                   namespace_principal.prefix, SERVER_INFO,
-                   buf_cstring(&server_info_token));
-
-        /* Start construction of our server-info */
-        if (!(root = init_xml_response("server-info", NS_DAV, NULL, ns))) {
-            syslog(LOG_ERR, "Unable to create server-info XML");
-            return;
-        }
-
-        /* Add token */
-        xmlNewTextChild(root, ns[NS_DAV], BAD_CAST "token",
-                        BAD_CAST buf_cstring(&server_info_token));
-
-        /* Add server */
-        if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-            node = xmlNewChild(root, NULL, BAD_CAST "server", NULL);
-            xmlNewChild(node, ns[NS_DAV],
-                        BAD_CAST "name", BAD_CAST "Cyrus-HTTP");
-            xmlNewTextChild(node, ns[NS_DAV],
-                            BAD_CAST "version", BAD_CAST cyrus_version());
-        }
-
-        /* Add global DAV features */
-        node = xmlNewChild(root, NULL, BAD_CAST "features", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-1", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-2", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "class-3", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "access-control", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "extended-mkcol", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "quota", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "sync-collection", NULL);
-        xmlNewChild(node, ns[NS_DAV], BAD_CAST "add-member", NULL);
-
-        apps = xmlNewChild(root, NULL, BAD_CAST "applications", NULL);
-
-        if (namespace_calendar.enabled) {
-            app = xmlNewChild(apps, NULL, BAD_CAST "application", NULL);
-            ensure_ns(ns, NS_CALDAV, app, XML_NS_CALDAV, "C");
-            xmlNewChild(app, NULL, BAD_CAST "name", BAD_CAST "caldav");
 
-            /* Add CalDAV features */
-            node = xmlNewChild(app, NULL, BAD_CAST "features", NULL);
-            xmlNewChild(node, ns[NS_CALDAV],
-                        BAD_CAST "calendar-access", NULL);
-            if (namespace_calendar.allow & ALLOW_CAL_SCHED)
-                xmlNewChild(node, ns[NS_CALDAV],
-                            BAD_CAST "calendar-auto-schedule", NULL);
-            if (namespace_calendar.allow & ALLOW_CAL_NOTZ)
-                xmlNewChild(node, ns[NS_CALDAV],
-                            BAD_CAST "calendar-no-timezone", NULL);
-            if (namespace_calendar.allow & ALLOW_CAL_AVAIL)
-                xmlNewChild(node, ns[NS_CALDAV],
-                            BAD_CAST "calendar-availability", NULL);
-            if (namespace_calendar.allow & ALLOW_CAL_ATTACH) {
-                xmlNewChild(node, ns[NS_CALDAV],
-                            BAD_CAST "calendar-managed-attachments", NULL);
-                xmlNewChild(node, ns[NS_CALDAV],
-                            BAD_CAST "calendar-managed-attachments-no-recurrence",
-                    NULL);
-            }
-        }
-
-        if (namespace_addressbook.enabled) {
-            app = xmlNewChild(apps, NULL, BAD_CAST "application", NULL);
-            ensure_ns(ns, NS_CARDDAV, app, XML_NS_CARDDAV, "A");
-            xmlNewChild(app, NULL, BAD_CAST "name", BAD_CAST "carddav");
-
-            /* Add CardDAV features */
-            node = xmlNewChild(app, NULL, BAD_CAST "features", NULL);
-            xmlNewChild(node, ns[NS_CARDDAV], BAD_CAST "addressbook", NULL);
-        }
-
-        /* Dump XML response tree into a text buffer */
-        xmlDocDumpFormatMemoryEnc(root->doc,
+    /* Dump XML response tree into a text buffer */
+    xmlDocDumpFormatMemoryEnc(root->doc,
                                   &server_info, &server_info_size, "utf-8", 1);
-        xmlFreeDoc(root->doc);
+    xmlFreeDoc(root->doc);
 
-        if (!server_info) {
-            syslog(LOG_ERR, "Unable to dump server-info XML tree");
-        }
+    if (!server_info) {
+        syslog(LOG_ERR, "Unable to dump server-info XML tree");
     }
-}
 
-
-static void my_dav_reset(void)
-{
-    if (auth_webdavdb) webdav_close(auth_webdavdb);
-    auth_webdavdb = NULL;
+    return;
 }
 
 
 static void my_dav_shutdown(void)
 {
-    my_dav_reset();
-    webdav_done();
-
     if (server_info) xmlFree(server_info);
     buf_free(&server_info_token);
     buf_free(&server_info_link);
@@ -8759,1433 +8741,6 @@ static int get_server_info(struct transa
     return 0;
 }
 
-static int notify_parse_path(const char *path,
-                             struct request_target_t *tgt, const char **errstr);
-
-static int notify_get(struct transaction_t *txn, struct mailbox *mailbox,
-                      struct index_record *record, void *data, void **obj);
-
-static int propfind_notifytype(const xmlChar *name, xmlNsPtr ns,
-                               struct propfind_ctx *fctx,
-                               xmlNodePtr prop, xmlNodePtr resp,
-                               struct propstat propstat[], void *rock);
-
-static struct buf *from_xml(xmlDocPtr doc)
-{
-    struct buf *buf = buf_new();
-    xmlChar *xml = NULL;
-    int len;
-
-    /* Dump XML response tree into a text buffer */
-    xmlDocDumpFormatMemoryEnc(doc, &xml, &len, "utf-8",
-                              config_httpprettytelemetry);
-    if (xml) buf_initm(buf, (char *) xml, len);
-    else buf_init(buf);
-
-    return buf;
-}
-
-static xmlDocPtr to_xml(const struct buf *buf)
-{
-    xmlParserCtxtPtr ctxt;
-    xmlDocPtr doc = NULL;
-
-    ctxt = xmlNewParserCtxt();
-    if (ctxt) {
-        doc = xmlCtxtReadMemory(ctxt, buf_base(buf), buf_len(buf), NULL, NULL,
-                                XML_PARSE_NOWARNING);
-        xmlFreeParserCtxt(ctxt);
-    }
-
-    return doc;
-}
-
-static struct mime_type_t notify_mime_types[] = {
-    /* First item MUST be the default type and storage format */
-    { DAVNOTIFICATION_CONTENT_TYPE, NULL, "xml",
-      (struct buf* (*)(void *)) &from_xml,
-      (void * (*)(const struct buf*)) &to_xml,
-      (void (*)(void *)) &xmlFreeDoc, NULL, NULL
-    },
-    { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
-};
-
-/* Array of supported REPORTs */
-static const struct report_type_t notify_reports[] = {
-
-    /* WebDAV Versioning (RFC 3253) REPORTs */
-    { "expand-property", NS_DAV, "multistatus", &report_expand_prop,
-      DACL_READ, 0 },
-
-    /* WebDAV ACL (RFC 3744) REPORTs */
-    { "acl-principal-prop-set", NS_DAV, "multistatus", &report_acl_prin_prop,
-      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_DEPTH_ZERO },
-
-    /* WebDAV Sync (RFC 6578) REPORTs */
-    { "sync-collection", NS_DAV, "multistatus", &report_sync_col,
-      DACL_READ, REPORT_NEED_MBOX | REPORT_NEED_PROPS },
-
-    { NULL, 0, NULL, NULL, 0, 0 }
-};
-
-/* Array of known "live" properties */
-static const struct prop_entry notify_props[] = {
-
-    /* WebDAV (RFC 4918) properties */
-    { "creationdate", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_creationdate, NULL, NULL },
-    { "displayname", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_fromdb, proppatch_todb, NULL },
-    { "getcontentlanguage", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
-      propfind_fromhdr, NULL, "Content-Language" },
-    { "getcontentlength", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_getlength, NULL, NULL },
-    { "getcontenttype", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
-      propfind_fromhdr, NULL, "Content-Type" },
-    { "getetag", NS_DAV, PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_getetag, NULL, NULL },
-    { "getlastmodified", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_getlastmod, NULL, NULL },
-    { "resourcetype", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_restype, NULL, NULL },
-
-    /* WebDAV Versioning (RFC 3253) properties */
-    { "supported-report-set", NS_DAV, PROP_COLLECTION,
-      propfind_reportset, NULL, (void *) notify_reports },
-
-    /* WebDAV ACL (RFC 3744) properties */
-    { "owner", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_owner, NULL, NULL },
-    { "group", NS_DAV, 0, NULL, NULL, NULL },
-    { "supported-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_supprivset, NULL, NULL },
-    { "current-user-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_curprivset, NULL, NULL },
-    { "acl", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_acl, NULL, NULL },
-    { "acl-restrictions", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_aclrestrict, NULL, NULL },
-    { "inherited-acl-set", NS_DAV, 0, NULL, NULL, NULL },
-    { "principal-collection-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
-      propfind_princolset, NULL, NULL },
-
-    /* WebDAV Current Principal (RFC 5397) properties */
-    { "current-user-principal", NS_DAV,
-      PROP_COLLECTION | PROP_RESOURCE,
-      propfind_curprin, NULL, NULL },
-
-    /* WebDAV Sync (RFC 6578) properties */
-    { "sync-token", NS_DAV, PROP_COLLECTION,
-      propfind_sync_token, NULL, SYNC_TOKEN_URL_SCHEME },
-
-    /* WebDAV Notifications (draft-pot-webdav-notifications) properties */
-    { "notificationtype", NS_DAV, PROP_RESOURCE,
-      propfind_notifytype, NULL, NULL },
-
-    /* Backwards compatibility with Apple notifications clients */
-    { "notificationtype", NS_CS, PROP_RESOURCE,
-      propfind_notifytype, NULL, "calendarserver-sharing" },
-
-    /* Apple Calendar Server properties */
-    { "getctag", NS_CS, PROP_ALLPROP | PROP_COLLECTION,
-      propfind_sync_token, NULL, "" },
-
-    { NULL, 0, 0, NULL, NULL, NULL }
-};
-
-struct meth_params notify_params = {
-    notify_mime_types,
-    &notify_parse_path,
-    &dav_check_precond,
-    { (db_open_proc_t) &webdav_open_mailbox,
-      (db_close_proc_t) &webdav_close,
-      (db_proc_t) &webdav_begin,
-      (db_proc_t) &webdav_commit,
-      (db_proc_t) &webdav_abort,
-      (db_lookup_proc_t) &webdav_lookup_resource,
-      (db_foreach_proc_t) &webdav_foreach,
-      (db_write_proc_t) &webdav_write,
-      (db_delete_proc_t) &webdav_delete },
-    NULL,                                       /* No ACL extensions */
-    { 0, &notify_put },
-    NULL,                                       /* No special DELETE handling */
-    &notify_get,
-    { 0, 0 },                                   /* No MKCOL handling */
-    NULL,                                       /* No PATCH handling */
-    { 0, &notify_post, NULL },                  /* No generic POST handling */
-    { 0, &notify_put },
-    { DAV_FINITE_DEPTH, notify_props},
-    notify_reports
-};
-
-
-/* Namespace for WebDAV notifcation collections */
-struct namespace_t namespace_notify = {
-    URL_NS_NOTIFY, 0, "/dav/notifications", NULL,
-    http_allow_noauth_get, /*authschemes*/0,
-    MBTYPE_COLLECTION,
-    (ALLOW_READ | ALLOW_POST | ALLOW_DELETE |
-     ALLOW_DAV | ALLOW_PROPPATCH | ALLOW_ACL),
-    NULL, NULL, NULL, NULL,
-    &dav_premethod, /*bearer*/NULL,
-    {
-        { &meth_acl,            &notify_params },      /* ACL          */
-        { NULL,                 NULL },                /* BIND         */
-        { NULL,                 NULL },                /* COPY         */
-        { &meth_delete,         &notify_params },      /* DELETE       */
-        { &meth_get_head,       &notify_params },      /* GET          */
-        { &meth_get_head,       &notify_params },      /* HEAD         */
-        { NULL,                 NULL },                /* LOCK         */
-        { NULL,                 NULL },                /* MKCALENDAR   */
-        { NULL,                 NULL },                /* MKCOL        */
-        { NULL,                 NULL },                /* MOVE         */
-        { &meth_options,        &notify_parse_path },  /* OPTIONS      */
-        { NULL,                 NULL },                /* PATCH        */
-        { &meth_post,           &notify_params },      /* POST         */
-        { &meth_propfind,       &notify_params },      /* PROPFIND     */
-        { NULL,                 NULL },                /* PROPPATCH    */
-        { NULL,                 NULL },                /* PUT          */
-        { &meth_report,         &notify_params },      /* REPORT       */
-        { &meth_trace,          &notify_parse_path },  /* TRACE        */
-        { NULL,                 NULL },                /* UNBIND       */
-        { NULL,                 NULL },                /* UNLOCK       */
-    }
-};
-
-
-/* Perform a GET/HEAD request on a WebDAV notification resource */
-static int notify_get(struct transaction_t *txn, struct mailbox *mailbox,
-                      struct index_record *record, void *data,
-                      void **obj __attribute__((unused)))
-{
-    const char **hdr;
-    struct webdav_data *wdata = (struct webdav_data *) data;
-    struct dlist *dl = NULL, *al;
-    const char *type_str;
-    struct buf msg_buf = BUF_INITIALIZER;
-    struct buf inbuf, *outbuf = NULL;
-    xmlDocPtr indoc = NULL, outdoc;
-    xmlNodePtr notify = NULL, root, node, type;
-    xmlNodePtr resp = NULL, sharedurl = NULL, node2;
-    xmlNsPtr ns[NUM_NAMESPACE];
-    xmlChar *dtstamp = NULL, *comment = NULL;
-    char datestr[RFC3339_DATETIME_MAX];
-    time_t t;
-    enum {
-        SYSTEM_STATUS,
-        SHARE_INVITE,
-        SHARE_REPLY
-    } notify_type;
-    int r, ret = 0;
-
-    if (!record || !record->uid) return HTTP_NO_CONTENT;
-
-    if ((hdr = spool_getheader(txn->req_hdrs, "Accept")) &&
-        is_mediatype(DAVSHARING_CONTENT_TYPE, hdr[0])) {
-        return HTTP_CONTINUE;
-    }
-
-    /* If no Accept header is given or its not application/davsharing+xml,
-       assume its a legacy notification client and do a mime type translation
-       from application/davnotification+xml to application/xml */
-
-    /* Parse dlist representing notification type, and data */
-    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
-    dlist_getatom(dl, "T", &type_str);
-    dlist_getlist(dl, "D", &al);
-
-    if (!strcmp(type_str, SYSTEM_STATUS_NOTIFICATION)) {
-        notify_type = SYSTEM_STATUS;
-    }
-    else if (!strcmp(type_str, SHARE_INVITE_NOTIFICATION)) {
-        notify_type = SHARE_INVITE;
-    }
-    else if (!strcmp(type_str, SHARE_REPLY_NOTIFICATION)) {
-        notify_type = SHARE_REPLY;
-    }
-    else {
-        ret = HTTP_NOT_ACCEPTABLE;
-        goto done;
-    }
-
-    txn->resp_body.type = "application/xml";
-
-    if (txn->meth == METH_HEAD) {
-        ret = HTTP_CONTINUE;
-        goto done;
-    }
-
-
-    /* Load message containing the resource */
-    r = mailbox_map_record(mailbox, record, &msg_buf);
-    if (r) {
-        txn->error.desc = error_message(r);
-        return HTTP_SERVER_ERROR;
-    }
-
-    /* Parse message body into XML tree */
-    buf_init_ro(&inbuf, buf_base(&msg_buf) + record->header_size,
-                record->size - record->header_size);
-    indoc = to_xml(&inbuf);
-    buf_free(&inbuf);
-    buf_free(&msg_buf);
-
-    root = xmlDocGetRootElement(indoc);
-    node = xmlFirstElementChild(root);
-    dtstamp = xmlNodeGetContent(node);
-    type = xmlNextElementSibling(node);
-
-    /* Translate DAV notification into CS notification */
-    notify = init_xml_response("notification", NS_CS, NULL, ns);
-    outdoc = notify->doc;
-
-    /* Calendar.app doesn't like separators in date-time */
-    time_from_iso8601((const char *) dtstamp, &t);
-    time_to_iso8601(t, datestr, RFC3339_DATETIME_MAX, 0);
-    xmlNewChild(notify, NULL, BAD_CAST "dtstamp", BAD_CAST datestr);
-
-    if (notify_type == SYSTEM_STATUS) {
-    }
-    else if (notify_type == SHARE_INVITE) {
-        xmlNodePtr invite, sharer = NULL, access = NULL, calcompset = NULL;
-        xmlChar *name = NULL;
-        struct buf buf = BUF_INITIALIZER;
-
-        /* Grab DAV elements that we need to construct CS notification */
-        for (node = xmlFirstElementChild(type); node;
-             node = xmlNextElementSibling(node)) {
-            if (!xmlStrncmp(node->name, BAD_CAST "invite-", 7)) {
-                resp = node;
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "sharer-resource-uri")) {
-                sharedurl = xmlFirstElementChild(node);
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "principal")) {
-                sharer = xmlFirstElementChild(node);
-                node2 = xmlNextElementSibling(sharer);
-                if (!xmlStrcmp(node2->name, BAD_CAST "prop")) {
-                    for (node2 = xmlFirstElementChild(node2); node2;
-                         node2 = xmlNextElementSibling(node2)) {
-                        if (!xmlStrcmp(node2->name, BAD_CAST "displayname")) {
-                            name = xmlNodeGetContent(node2);
-                        }
-                    }
-                }
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "share-access")) {
-                access = xmlFirstElementChild(node);
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
-                comment = xmlNodeGetContent(node);
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "prop")) {
-                for (node2 = xmlFirstElementChild(node); node2;
-                     node2 = xmlNextElementSibling(node2)) {
-                    if (!xmlStrcmp(node2->name,
-                                   BAD_CAST "supported-calendar-component-set")) {
-                        calcompset = node2;
-                    }
-                }
-            }
-        }
-
-        invite = xmlNewChild(notify, NULL, BAD_CAST "invite-notification", NULL);
-
-        xmlNewChild(invite, NULL, BAD_CAST "uid", BAD_CAST wdata->dav.resource);
-
-        /* Sharee href */
-        buf_reset(&buf);
-        buf_printf(&buf, "%s/%s/%s/", namespace_principal.prefix,
-                   USER_COLLECTION_PREFIX, txn->req_tgt.userid);
-        node = xml_add_href(invite, NULL, buf_cstring(&buf));
-        ensure_ns(ns, NS_DAV, node, XML_NS_DAV, "D");
-        xmlSetNs(node, ns[NS_DAV]);
-
-#if 0  /* XXX  Apple clients seem to always want "noresponse" */
-        xmlNewChild(invite, NULL, resp->name, NULL);
-#else
-        xmlNewChild(invite, NULL, BAD_CAST "invite-noresponse", NULL);
-#endif
-
-        node = xmlNewChild(invite, NULL, BAD_CAST "access", NULL);
-        xmlNewChild(node, NULL, access->name, NULL);
-        node = xmlNewChild(invite, NULL, BAD_CAST "hosturl", NULL);
-        xmlAddChild(node, xmlCopyNode(sharedurl, 1));
-        node = xmlNewChild(invite, NULL, BAD_CAST "organizer", NULL);
-        xmlAddChild(node, xmlCopyNode(sharer, 1));
-        if (name) {
-            xmlNewChild(node, NULL, BAD_CAST "common-name", name);
-            xmlFree(name);
-        }
-
-        if (comment) {
-            xmlNewChild(invite, NULL, BAD_CAST "summary", comment);
-            xmlFree(comment);
-        }
-        if (calcompset) {
-            xmlAddChild(invite, xmlCopyNode(calcompset, 1));
-        }
-
-        buf_free(&buf);
-    }
-    else if (notify_type == SHARE_REPLY) {
-        xmlNodePtr reply, sharee = NULL;
-
-        /* Grab DAV elements that we need to construct CS notification */
-        for (node = xmlFirstElementChild(type); node;
-             node = xmlNextElementSibling(node)) {
-            if (!xmlStrcmp(node->name, BAD_CAST "sharee")) {
-                for (node2 = xmlFirstElementChild(node); node2;
-                     node2 = xmlNextElementSibling(node2)) {
-                    if (!xmlStrcmp(node2->name, BAD_CAST "href")) {
-                        sharee = node2;
-                    }
-                    else if (!xmlStrncmp(node2->name, BAD_CAST "invite-", 7)) {
-                        resp = node2;
-                    }
-                }
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "href")) {
-                sharedurl = node;
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
-                comment = xmlNodeGetContent(node);
-            }
-        }
-
-        reply = xmlNewChild(notify, NULL, BAD_CAST "invite-reply", NULL);
-
-        xmlAddChild(reply, xmlCopyNode(sharee, 1));
-        xmlNewChild(reply, NULL, resp->name, NULL);
-        node = xmlNewChild(reply, NULL, BAD_CAST "hosturl", NULL);
-        xmlAddChild(node, xmlCopyNode(sharedurl, 1));
-
-        xmlNewChild(reply, NULL,
-                    BAD_CAST "in-reply-to", BAD_CAST wdata->dav.resource);
-
-        if (comment) {
-            xmlNewChild(reply, NULL, BAD_CAST "summary", comment);
-            xmlFree(comment);
-        }
-    }
-    else {
-        /* Unknown type - return as-is */
-        xmlFreeDoc(notify->doc);
-        notify = NULL;
-        outdoc = indoc;
-    }
-
-    /* Dump XML tree into a text buffer */
-    outbuf = from_xml(outdoc);
-
-    write_body(HTTP_OK, txn, buf_cstring(outbuf), buf_len(outbuf));
-
-  done:
-    if (dtstamp) xmlFree(dtstamp);
-    if (notify) xmlFreeDoc(notify->doc);
-    if (indoc) xmlFreeDoc(indoc);
-    buf_destroy(outbuf);
-    dlist_free(&dl);
-
-    return ret;
-}
-
-
-/* Perform a POST request on a WebDAV notification resource */
-int notify_post(struct transaction_t *txn)
-{
-    xmlNodePtr root = NULL, node, resp = NULL;
-    int rights, ret, r, legacy = 0, add = 0;
-    struct mailbox *mailbox = NULL, *shared = NULL;
-    struct webdav_db *webdavdb = NULL;
-    struct webdav_data *wdata;
-    struct dlist *dl = NULL, *data;
-    const char *type_str, *mboxname, *url_prefix;
-    char dtstamp[RFC3339_DATETIME_MAX], *owner = NULL, *resource = NULL;
-    xmlNodePtr notify = NULL, type, sharee;
-    xmlNsPtr ns[NUM_NAMESPACE];
-    xmlChar *comment = NULL, *freeme = NULL;
-
-    /* Check ACL for current user */
-    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
-    if (!(rights & DACL_ADMIN)) {
-        /* DAV:need-privileges */
-        txn->error.precond = DAV_NEED_PRIVS;
-        txn->error.resource = txn->req_tgt.path;
-        txn->error.rights = DACL_ADMIN;
-        return HTTP_NO_PRIVS;
-    }
-
-    if (txn->req_tgt.mbentry->server) {
-        /* Remote mailbox */
-        struct backend *be;
-
-        be = proxy_findserver(txn->req_tgt.mbentry->server,
-                              &http_protocol, httpd_userid,
-                              &backend_cached, NULL, NULL, httpd_in);
-        if (!be) return HTTP_UNAVAILABLE;
-
-        return http_pipe_req_resp(be, txn);
-    }
-
-    /* Local Mailbox */
-
-    /* Read body */
-    ret = parse_xml_body(txn, &root, DAVSHARING_CONTENT_TYPE);
-    if (!ret && !root) {
-        txn->error.desc = "Missing request body";
-        ret = HTTP_BAD_REQUEST;
-    }
-    if (ret) goto done;
-
-    /* Make sure its a invite-reply element */
-    if (xmlStrcmp(root->name, BAD_CAST "invite-reply")) {
-        txn->error.desc =
-            "Missing invite-reply element in POST request";
-        ret = HTTP_BAD_REQUEST;
-        goto done;
-    }
-
-    resource = txn->req_tgt.resource;
-    if (!resource) legacy = 1;
-
-    /* Fetch needed elements */
-    for (node = xmlFirstElementChild(root); node;
-         node = xmlNextElementSibling(node)) {
-        if (!xmlStrncmp(node->name, BAD_CAST "invite-", 7)) {
-            if (!xmlStrcmp(node->name, BAD_CAST "invite-accepted")) add = 1;
-            resp = node;
-        }
-        else if (legacy) {
-            if (!xmlStrcmp(node->name, BAD_CAST "in-reply-to")) {
-                freeme = xmlNodeGetContent(node);
-                resource = (char *) freeme;
-            }
-            else if (!xmlStrcmp(node->name, BAD_CAST "summary")) {
-                comment = xmlNodeGetContent(node);
-            }
-        }
-        else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
-            comment = xmlNodeGetContent(node);
-        }
-    }
-
-    if (!resp) {
-        txn->error.desc = "Missing invite response element in POST request";
-        ret = HTTP_BAD_REQUEST;
-        goto done;
-    }
-    if (!resource) {
-        txn->error.desc = "Missing in-reply-to element in POST request";
-        ret = HTTP_BAD_REQUEST;
-        goto done;
-    }
-
-    if (legacy) {
-        /* Locate notification mailbox for target user */
-        mboxlist_entry_free(&txn->req_tgt.mbentry);
-        txn->req_tgt.mbentry = NULL;
-        r = lookup_notify_collection(txn->req_tgt.userid, &txn->req_tgt.mbentry);
-        if (r) {
-            syslog(LOG_ERR, "lookup_notify_collection(%s) failed: %s",
-                   txn->req_tgt.userid, error_message(r));
-            txn->error.desc = error_message(r);
-            ret = HTTP_SERVER_ERROR;
-            goto done;
-        }
-    }
-
-    /* Open notification mailbox for reading */
-    r = mailbox_open_irl(txn->req_tgt.mbentry->name, &mailbox);
-    if (r) {
-        syslog(LOG_ERR, "mailbox_open_irl(%s) failed: %s",
-               txn->req_tgt.mbentry->name, error_message(r));
-        goto done;
-    }
-
-    /* Open the WebDAV DB corresponding to the mailbox */
-    webdavdb = webdav_open_mailbox(mailbox);
-
-    /* Find message UID for the resource */
-    webdav_lookup_resource(webdavdb, txn->req_tgt.mbentry->name,
-                           resource, &wdata, 0);
-    if (!wdata->dav.imap_uid) {
-        ret = HTTP_NOT_FOUND;
-        goto done;
-    }
-
-    /* Parse dlist representing notification type, and data */
-    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
-    dlist_getatom(dl, "T", &type_str);
-    if (strcmp(type_str, SHARE_INVITE_NOTIFICATION)) {
-        ret = HTTP_NOT_ALLOWED;
-        goto done;
-    }
-
-    dlist_getlist(dl, "D", &data);
-    dlist_getatom(data, "M", &mboxname);
-
-    /* [Un]subscribe */
-    r = mboxlist_changesub(mboxname, txn->req_tgt.userid,
-                           httpd_authstate, add, 0, 0);
-    if (r) {
-        syslog(LOG_ERR, "mboxlist_changesub(%s, %s) failed: %s",
-               mboxname, txn->req_tgt.userid, error_message(r));
-        txn->error.desc = error_message(r);
-        ret = HTTP_SERVER_ERROR;
-        goto done;
-    }
-
-    /* Set invite status */
-    r = mailbox_open_iwl(mboxname, &shared);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: failed to open mailbox %s for share reply",
-               mboxname);
-    }
-    else {
-        annotate_state_t *astate = NULL;
-
-        r = mailbox_get_annotate_state(shared, 0, &astate);
-        if (!r) {
-            const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
-            struct buf value = BUF_INITIALIZER;
-
-            buf_init_ro_cstr(&value, (char *) resp->name);
-            r = annotate_state_writemask(astate, annot,
-                                         txn->req_tgt.userid, &value);
-
-            if (shared->mbtype == MBTYPE_CALENDAR) {
-                /* Sharee's copy of calendar SHOULD default to transparent */
-                annot =
-                    DAV_ANNOT_NS "<" XML_NS_CALDAV ">schedule-calendar-transp";
-                buf_init_ro_cstr(&value, "transparent");
-                r = annotate_state_writemask(astate, annot,
-                                             txn->req_tgt.userid, &value);
-            }
-        }
-
-        mailbox_close(&shared);
-    }
-
-    /* Create share-reply-notification */
-    notify = init_xml_response("notification", NS_DAV, NULL, ns);
-
-    time_to_rfc3339(time(0), dtstamp, RFC3339_DATETIME_MAX);
-    xmlNewChild(notify, NULL, BAD_CAST "dtstamp", BAD_CAST dtstamp);
-
-    type = xmlNewChild(notify, NULL, BAD_CAST SHARE_REPLY_NOTIFICATION, NULL);
-
-    sharee = xmlNewChild(type, NULL, BAD_CAST "sharee", NULL);
-    buf_reset(&txn->buf);
-    buf_printf(&txn->buf, "%s/%s/%s/", namespace_principal.prefix,
-               USER_COLLECTION_PREFIX, txn->req_tgt.userid);
-    xml_add_href(sharee, NULL, buf_cstring(&txn->buf));
-
-    node = xmlNewChild(sharee, NULL, resp->name, NULL);
-
-    /* shared-url */
-    url_prefix = strstr(mboxname, config_getstring(IMAPOPT_CALENDARPREFIX)) ?
-        namespace_calendar.prefix : namespace_addressbook.prefix;
-    make_collection_url(&txn->buf, url_prefix, mboxname, "", &owner);
-
-    xml_add_href(type, NULL, buf_cstring(&txn->buf));
-
-    if (comment) {
-        xmlNewChild(type, NULL, BAD_CAST "comment", comment);
-        xmlFree(comment);
-    }
-
-    /* Create a resource name for the notifications -
-       We use a consistent naming scheme so that multiple notifications
-       of the same type for the same resource are coalesced (overwritten) */
-    buf_reset(&txn->buf);
-    buf_printf(&txn->buf, "%x-%x-%x-%x.xml",
-               strhash(XML_NS_DAV), strhash(SHARE_REPLY_NOTIFICATION),
-               strhash(mboxname), strhash(txn->req_tgt.userid));
-
-    r = send_notification(txn, notify->doc, owner, buf_cstring(&txn->buf));
-
-    if (add) {
-        /* Accepted - create URL of sharee's new collection */
-        make_collection_url(&txn->buf, url_prefix,
-                            mboxname, txn->req_tgt.userid, NULL);
-
-        if (legacy) {
-            /* Create CS:shared-as XML body */
-            xmlNodePtr shared_as = init_xml_response("shared-as", NS_CS, NULL, ns);
-            if (!shared_as) {
-                ret = HTTP_SERVER_ERROR;
-                goto done;
-            }
-
-            node = xml_add_href(shared_as, NULL, buf_cstring(&txn->buf));
-            ensure_ns(ns, NS_DAV, node, XML_NS_DAV, "D");
-            xmlSetNs(node, ns[NS_DAV]);
-            xml_response(HTTP_OK, txn, shared_as->doc);
-            xmlFreeDoc(shared_as->doc);
-            ret = 0;
-        }
-        else {
-            /* Add Location header */
-            txn->location = buf_cstring(&txn->buf);
-            ret = HTTP_CREATED;
-        }
-    }
-    else {
-        /* Declined */
-        ret = HTTP_NO_CONTENT;
-    }
-
-  done:
-    if (freeme) xmlFree(freeme);
-    if (root) xmlFreeDoc(root->doc);
-    if (notify) xmlFreeDoc(notify->doc);
-    webdav_close(webdavdb);
-    mailbox_close(&mailbox);
-    dlist_free(&dl);
-    free(owner);
-
-    return ret;
-}
-
-
-/* Perform a PUT request on a WebDAV notification resource */
-static int notify_put(struct transaction_t *txn, void *obj,
-                      struct mailbox *mailbox, const char *resource,
-                      void *destdb, unsigned flags __attribute__((unused)))
-{
-    struct webdav_db *db = (struct webdav_db *)destdb;
-    xmlDocPtr doc = (xmlDocPtr) obj;
-    xmlNodePtr root, dtstamp, type = NULL, node;
-    struct webdav_data *wdata;
-    struct index_record *oldrecord = NULL, record;
-    struct buf *xmlbuf;
-    int r;
-
-    /* Validate the data */
-    if (!doc) return HTTP_FORBIDDEN;
-
-    /* Find message UID for the resource */
-    webdav_lookup_resource(db, mailbox->name, resource, &wdata, 0);
-
-    if (wdata->dav.imap_uid) {
-        /* Fetch index record for the resource */
-        oldrecord = &record;
-        mailbox_find_index_record(mailbox, wdata->dav.imap_uid, oldrecord);
-    }
-
-    /* Get type of notification */
-    if ((root = xmlDocGetRootElement(doc)) &&
-        (dtstamp = xmlFirstElementChild(root))) {
-        type = xmlNextElementSibling(dtstamp);
-    }
-
-    /* Create and cache RFC 5322 header fields for resource */
-    if (type) {
-        struct buf buf = BUF_INITIALIZER;
-        xmlChar *value;
-        time_t t;
-        struct dlist *dl, *al;
-        xmlAttrPtr attr;
-
-        spool_replace_header(xstrdup("Subject"),
-                             xstrdup((char *) type->name), txn->req_hdrs);
-
-        /* Create a dlist representing type, namespace, and attribute(s) */
-        value = xmlNodeGetContent(dtstamp);
-        time_from_iso8601((const char *) value, &t);
-        xmlFree(value);
-
-        dl = dlist_newkvlist(NULL, "N");
-        dlist_setdate(dl, "S", t);
-        dlist_setatom(dl, "NS", (char *) type->ns->href);
-        dlist_setatom(dl, "T", (char *) type->name);
-
-        /* Add any attributes */
-        al = dlist_newkvlist(dl, "A");
-        for (attr = type->properties; attr; attr = attr->next) {
-            value = xmlNodeGetContent((xmlNodePtr) attr);
-            dlist_setmap(al, (char *) attr->name,
-                         (char *) value, xmlStrlen(value));
-            xmlFree(value);
-        }
-
-        /* Add any additional data */
-        al = dlist_newkvlist(dl, "D");
-        if (!xmlStrcmp(type->name, BAD_CAST SHARE_INVITE_NOTIFICATION)) {
-            for (node = xmlFirstElementChild(type); node;
-                 node = xmlNextElementSibling(node)) {
-                if (!xmlStrcmp(node->name, BAD_CAST "sharer-resource-uri")) {
-                    struct request_target_t tgt;
-                    const char *errstr;
-
-                    memset(&tgt, 0, sizeof(struct request_target_t));
-                    tgt.namespace = txn->req_tgt.namespace;
-                    value = xmlNodeGetContent(xmlFirstElementChild(node));
-                    calcarddav_parse_path((const char *) value, &tgt,
-                                          txn->req_tgt.mboxprefix, &errstr);
-                    xmlFree(value);
-                    free(tgt.userid);
-
-                    dlist_setatom(al, "M", tgt.mbentry->name);
-
-                    mboxlist_entry_free(&tgt.mbentry);
-                    break;
-                }
-            }
-        }
-
-        dlist_printbuf(dl, 1, &buf);
-        dlist_free(&dl);
-        spool_replace_header(xstrdup("Content-Description"),
-                             buf_release(&buf), txn->req_hdrs);
-    }
-
-    buf_reset(&txn->buf);
-    buf_printf(&txn->buf, "<%s-%ld@%s>", resource, time(0), config_servername);
-    spool_replace_header(xstrdup("Message-ID"),
-                         buf_release(&txn->buf), txn->req_hdrs);
-
-    buf_printf(&txn->buf, "attachment;\r\n\tfilename=\"%s\"", resource);
-    spool_replace_header(xstrdup("Content-Disposition"),
-                         buf_release(&txn->buf), txn->req_hdrs);
-
-    /* Dump XML response tree into a text buffer */
-    xmlbuf = from_xml(doc);
-    if (!buf_len(xmlbuf)) r = HTTP_SERVER_ERROR;
-    else {
-        /* Store the resource */
-        r = dav_store_resource(txn, buf_cstring(xmlbuf), buf_len(xmlbuf),
-                               mailbox, oldrecord, NULL);
-    }
-
-    buf_destroy(xmlbuf);
-
-    return r;
-}
-
-
-/* Callback to fetch DAV:notification-URL and CS:notification-URL */
-static int propfind_notifyurl(const xmlChar *name, xmlNsPtr ns,
-                              struct propfind_ctx *fctx,
-                              xmlNodePtr prop,
-                              xmlNodePtr resp __attribute__((unused)),
-                              struct propstat propstat[],
-                              void *rock __attribute__((unused)))
-{
-    xmlNodePtr node;
-
-    if (!(namespace_principal.enabled && fctx->req_tgt->userid))
-        return HTTP_NOT_FOUND;
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                        name, ns, NULL, 0);
-
-    buf_reset(&fctx->buf);
-    buf_printf(&fctx->buf, "%s/%s/%s/", namespace_notify.prefix,
-               USER_COLLECTION_PREFIX, fctx->req_tgt->userid);
-
-    if ((fctx->mode == PROPFIND_EXPAND) && xmlFirstElementChild(prop)) {
-        /* Return properties for this URL */
-        expand_property(prop, fctx, &namespace_notify, buf_cstring(&fctx->buf),
-                        &notify_parse_path, notify_props, node, 0);
-
-    }
-    else {
-        /* Return just the URL */
-        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
-    }
-
-    return 0;
-}
-
-
-/* Apple push notifications
-   https://github.com/apple/ccs-calendarserver/blob/master/doc/Extensions/caldav-pubsubdiscovery.txt
-*/
-int propfind_push_transports(const xmlChar *name, xmlNsPtr ns,
-                             struct propfind_ctx *fctx,
-                             xmlNodePtr prop __attribute__((unused)),
-                             xmlNodePtr resp,
-                             struct propstat propstat[],
-                             void *rock __attribute__((unused)))
-{
-    xmlNodePtr node, transport, subscription_url;
-
-    assert(fctx->req_tgt->namespace->id == URL_NS_CALENDAR ||
-           fctx->req_tgt->namespace->id == URL_NS_ADDRESSBOOK);
-
-    if (!namespace_applepush.enabled) return HTTP_NOT_FOUND;
-
-    /* Only on home sets */
-    if (fctx->req_tgt->collection) return HTTP_NOT_FOUND;
-
-    const char *aps_topic =
-        config_getstring(fctx->req_tgt->namespace->id == URL_NS_CALENDAR ?
-                         IMAPOPT_APS_TOPIC_CALDAV : IMAPOPT_APS_TOPIC_CARDDAV);
-    if (!aps_topic) {
-        syslog(LOG_DEBUG, "aps_topic_%s not configured,"
-               " can't build CS:push-transports response",
-               fctx->req_tgt->namespace->id == URL_NS_CALENDAR ?
-               "caldav" : "carddav");
-        return HTTP_NOT_FOUND;
-    }
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_CS], &propstat[PROPSTAT_OK],
-                        name, ns, NULL, 0);
-
-    transport = xmlNewChild(node, NULL, BAD_CAST "transport", NULL);
-    xmlNewProp(transport, BAD_CAST "type", BAD_CAST "APSD");
-
-    subscription_url =
-        xmlNewChild(transport, NULL, BAD_CAST "subscription-url", NULL);
-    xml_add_href(subscription_url, fctx->ns[NS_DAV], namespace_applepush.prefix);
-
-    xmlNewChild(transport, NULL, BAD_CAST "apsbundleid", BAD_CAST aps_topic);
-
-    // XXX from config, I think?
-    ensure_ns(fctx->ns, NS_MOBME, resp->parent, XML_NS_MOBME, "MM");
-    xmlNewChild(transport, fctx->ns[NS_MOBME],
-                BAD_CAST "env", BAD_CAST "PRODUCTION");
-
-    // XXX from config
-    xmlNewChild(transport, NULL,
-                BAD_CAST "refresh-interval", BAD_CAST "86400");
-
-    return 0;
-}
-
-int propfind_pushkey(const xmlChar *name, xmlNsPtr ns,
-                     struct propfind_ctx *fctx,
-                     xmlNodePtr prop __attribute__((unused)),
-                     xmlNodePtr resp __attribute__((unused)),
-                     struct propstat propstat[],
-                     void *rock __attribute__((unused)))
-{
-    if (!namespace_applepush.enabled) return HTTP_NOT_FOUND;
-
-    /* Only on collections */
-    if (!fctx->req_tgt->collection) return HTTP_NOT_FOUND;
-
-    /* key is userid and mailbox uniqueid */
-    buf_reset(&fctx->buf);
-    buf_printf(&fctx->buf, "%s/%s",
-               fctx->req_tgt->userid, fctx->mailbox->uniqueid);
-    xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                 name, ns, BAD_CAST buf_cstring(&fctx->buf), 0);
-
-    return 0;
-}
-
-
-struct userid_rights {
-    long positive;
-    long negative;
-};
-
-static void parse_acl(hash_table *table, const char *origacl)
-{
-    char *acl = xstrdupsafe(origacl);
-    char *thisid, *rights, *nextid;
-
-    for (thisid = acl; *thisid; thisid = nextid) {
-        struct userid_rights *id_rights;
-        int is_negative = 0;
-        int mask;
-
-        rights = strchr(thisid, '\t');
-        if (!rights) {
-            break;
-        }
-        *rights++ = '\0';
-
-        nextid = strchr(rights, '\t');
-        if (!nextid) {
-            rights[-1] = '\t';
-            break;
-        }
-        *nextid++ = '\0';
-
-        if (*thisid == '-') {
-            is_negative = 1;
-            thisid++;
-        }
-
-        id_rights = hash_lookup(thisid, table);
-        if (!id_rights) {
-            id_rights = xzmalloc(sizeof(struct userid_rights));
-            hash_insert(thisid, id_rights, table);
-        }
-
-        cyrus_acl_strtomask(rights, &mask);
-        /* XXX and if strtomask fails? */
-        if (is_negative) id_rights->negative |= mask;
-        else id_rights->positive |= mask;
-    }
-
-    free(acl);
-}
-
-struct invite_rock {
-    const char *owner;
-    int is_shared;
-    struct propfind_ctx *fctx;
-    xmlNodePtr node;
-    int legacy;
-};
-
-static void xml_add_sharee(const char *userid, void *data, void *rock)
-{
-    struct userid_rights *id_rights = (struct userid_rights *) data;
-    struct invite_rock *irock = (struct invite_rock *) rock;
-    int rights = id_rights->positive & ~id_rights->negative;
-    struct auth_state *authstate;
-    int isadmin;
-
-    if ((rights & DACL_SHARE) != DACL_SHARE) return;  /* not shared */
-    if (!strcmp(userid, irock->owner)) return;  /* user is owner */
-
-    authstate = auth_newstate(userid);
-    isadmin = global_authisa(authstate, IMAPOPT_ADMINS);
-    auth_freestate(authstate);
-    if (isadmin) return;  /* user is an admin */
-
-
-    irock->is_shared = 1;
-
-    if (irock->node) {
-        xmlNodePtr sharee, access;
-        const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
-        const char *resp = "invite-noresponse";
-        struct buf value = BUF_INITIALIZER;
-        int r;
-
-        sharee = xmlNewChild(irock->node, NULL,
-                             BAD_CAST (irock->legacy ? "user" : "sharee"), NULL);
-
-        buf_reset(&irock->fctx->buf);
-        if (strchr(userid, '@')) {
-            buf_printf(&irock->fctx->buf, "mailto:%s", userid);
-        }
-        else {
-            const char *domain = httpd_extradomain;
-            if (!domain) domain = config_defdomain;
-            if (!domain) domain = config_servername;
-
-            buf_printf(&irock->fctx->buf, "mailto:%s@%s", userid, domain);
-        }
-        xml_add_href(sharee, irock->fctx->ns[NS_DAV],
-                     buf_cstring(&irock->fctx->buf));
-
-        /* Lookup invite status */
-        r = annotatemore_lookupmask(irock->fctx->mbentry->name,
-                                    annot, userid, &value);
-        if (!r && buf_len(&value)) resp = buf_cstring(&value);
-        xmlNewChild(sharee, NULL, BAD_CAST resp, NULL);
-        buf_free(&value);
-
-        access = xmlNewChild(sharee, NULL,
-                             BAD_CAST (irock->legacy ? "access" :
-                                       "share-access"), NULL);
-        if ((rights & DACL_SHARERW) == DACL_SHARERW)
-            xmlNewChild(access, NULL, BAD_CAST "read-write", NULL);
-        else xmlNewChild(access, NULL, BAD_CAST "read", NULL);
-    }
-}
-
-
-void xml_add_shareaccess(struct propfind_ctx *fctx,
-                         xmlNodePtr resp, xmlNodePtr node, int legacy)
-{
-    if (mboxname_userownsmailbox(fctx->req_tgt->userid, fctx->mbentry->name)) {
-        hash_table table;
-        struct invite_rock irock = { fctx->req_tgt->userid, 0, NULL, NULL, 0 };
-
-        construct_hash_table(&table, 10, 1);
-        parse_acl(&table, fctx->mbentry->acl);
-        hash_enumerate(&table, &xml_add_sharee, &irock);
-
-        if (irock.is_shared) {
-            xmlNsPtr ns = fctx->ns[NS_DAV];
-
-            if (legacy) {
-                ensure_ns(fctx->ns, NS_CS, resp->parent, XML_NS_CS, "CS");
-                ns = fctx->ns[NS_CS];
-            }
-            xmlNewChild(node, ns, BAD_CAST "shared-owner", NULL);
-        }
-        else if (!legacy)
-            xmlNewChild(node, NULL, BAD_CAST "not-shared", NULL);
-
-        free_hash_table(&table, &free);
-    }
-    else if (legacy) {
-        ensure_ns(fctx->ns, NS_CS, resp->parent, XML_NS_CS, "CS");
-        xmlNewChild(node, fctx->ns[NS_CS], BAD_CAST "shared", NULL);
-    }
-    else {
-        int rights = httpd_myrights(httpd_authstate, fctx->mbentry);
-
-        if ((rights & DACL_SHARERW) == DACL_SHARERW)
-            xmlNewChild(node, NULL, BAD_CAST "read-write", NULL);
-        else
-            xmlNewChild(node, NULL, BAD_CAST "read", NULL);
-    }
-}
-
-
-/* Callback to fetch DAV:share-access */
-int propfind_shareaccess(const xmlChar *name, xmlNsPtr ns,
-                         struct propfind_ctx *fctx,
-                         xmlNodePtr prop __attribute__((unused)),
-                         xmlNodePtr resp,
-                         struct propstat propstat[],
-                         void *rock __attribute__((unused)))
-{
-    xmlNodePtr node;
-
-    if (!fctx->mbentry) return HTTP_NOT_FOUND;
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
-                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
-
-    xml_add_shareaccess(fctx, resp, node, 0 /* legacy */);
-
-    return 0;
-}
-
-
-/* Callback to fetch DAV:invite and CS:invite */
-int propfind_invite(const xmlChar *name, xmlNsPtr ns,
-                    struct propfind_ctx *fctx,
-                    xmlNodePtr prop __attribute__((unused)),
-                    xmlNodePtr resp __attribute__((unused)),
-                    struct propstat propstat[], void *rock)
-{
-    struct invite_rock irock = { fctx->req_tgt->userid, 0 /* is_shared */,
-                                 fctx, NULL, rock != 0 /* legacy */ };
-    xmlNodePtr node;
-
-    fctx->flags.cs_sharing = (rock != 0);
-
-    if (!fctx->mbentry) return HTTP_NOT_FOUND;
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
-                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
-    irock.node = node;
-
-    if (mboxname_userownsmailbox(fctx->req_tgt->userid, fctx->mbentry->name)) {
-        hash_table table;
-
-        construct_hash_table(&table, 10, 1);
-
-        parse_acl(&table, fctx->mbentry->acl);
-        hash_enumerate(&table, &xml_add_sharee, &irock);
-
-        free_hash_table(&table, &free);
-    }
-    else {
-        struct userid_rights id_rights = 
-            { httpd_myrights(httpd_authstate, fctx->mbentry), 0 /* neg */};
-
-        irock.owner = "";
-        xml_add_sharee(fctx->req_tgt->userid, &id_rights, &irock);
-    }
-
-    return 0;
-}
-
-
-/* Callback to fetch DAV:sharer-resource-uri and CS:shared-url */
-int propfind_sharedurl(const xmlChar *name, xmlNsPtr ns,
-                       struct propfind_ctx *fctx,
-                       xmlNodePtr prop __attribute__((unused)),
-                       xmlNodePtr resp __attribute__((unused)),
-                       struct propstat propstat[], void *rock)
-{
-    mbname_t *mbname;
-    const strarray_t *boxes;
-    int n, size;
-    xmlNodePtr node;
-
-    fctx->flags.cs_sharing = (rock != 0);
-
-    mbname = mbname_from_intname(fctx->mailbox->name);
-
-    if (!strcmpsafe(mbname_userid(mbname), fctx->req_tgt->userid)) {
-        mbname_free(&mbname);
-        return HTTP_NOT_FOUND;
-    }
-
-    buf_setcstr(&fctx->buf, fctx->req_tgt->namespace->prefix);
-
-    if (mbname_localpart(mbname)) {
-        const char *domain =
-            mbname_domain(mbname) ? mbname_domain(mbname) : httpd_extradomain;
-
-        buf_printf(&fctx->buf, "/%s/%s",
-                   USER_COLLECTION_PREFIX, mbname_localpart(mbname));
-        if (domain) buf_printf(&fctx->buf, "@%s", domain);
-    }
-    buf_putc(&fctx->buf, '/');
-
-    boxes = mbname_boxes(mbname);
-    size = strarray_size(boxes);
-    for (n = 1; n < size; n++) {
-        buf_appendcstr(&fctx->buf, strarray_nth(boxes, n));
-        buf_putc(&fctx->buf, '/');
-    }
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
-                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
-
-    xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
-
-    mbname_free(&mbname);
-
-    return 0;
-}
-
-
-/* Callback to fetch DAV:notificationtype */
-static int propfind_notifytype(const xmlChar *name, xmlNsPtr ns,
-                               struct propfind_ctx *fctx,
-                               xmlNodePtr prop __attribute__((unused)),
-                               xmlNodePtr resp __attribute__((unused)),
-                               struct propstat propstat[], void *rock)
-{
-    struct webdav_data *wdata = (struct webdav_data *) fctx->data;
-    xmlNodePtr node;
-    xmlNsPtr type_ns = NULL;
-    struct dlist *dl = NULL, *al, *item;
-    const char *ns_href, *type;
-    int i;
-
-    if (!wdata->filename) return HTTP_NOT_FOUND;
-
-    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
-                        name, ns, NULL, 0);
-
-    /* Parse dlist representing notification type, namespace, and attributes */
-    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
-    dlist_getatom(dl, "T", &type);
-    dlist_getatom(dl, "NS", &ns_href);
-    dlist_getlist(dl, "A", &al);
-
-    if (rock /* calendarserver-sharing */) {
-        if (!strcmp(type, SHARE_INVITE_NOTIFICATION))
-            type = "invite-notification";
-        else if (!strcmp(type, SHARE_REPLY_NOTIFICATION))
-            type = "invite-reply";
-    }
-    else {
-        /* Check if we already have this ns-href, otherwise create a new one */
-        type_ns = xmlSearchNsByHref(node->doc, node, BAD_CAST ns_href);
-        if (!type_ns) {
-            char prefix[20];
-            snprintf(prefix, sizeof(prefix), "X%X", strhash(ns_href) & 0xffff);
-            type_ns = xmlNewNs(node, BAD_CAST ns_href, BAD_CAST prefix);
-        }
-    }
-
-    /* Create node for type */
-    node = xmlNewChild(node, type_ns, BAD_CAST type, NULL);
-
-    /* Add attributes */
-    for (i = 0; (item = dlist_getchildn(al, i)); i++) {
-        xmlNewProp(node, BAD_CAST item->name, BAD_CAST dlist_cstring(item));
-    }
-
-    dlist_free(&dl);
-
-    return 0;
-}
-
-
-/* Parse request-target path in DAV notifications namespace */
-static int notify_parse_path(const char *path, struct request_target_t *tgt,
-                             const char **errstr)
-{
-    char *p;
-    size_t len;
-    mbname_t *mbname = NULL;
-
-    /* Make a working copy of target path */
-    strlcpy(tgt->path, path, sizeof(tgt->path));
-    tgt->tail = tgt->path + strlen(tgt->path);
-
-    p = tgt->path;
-
-    /* Sanity check namespace */
-    len = strlen(namespace_notify.prefix);
-    if (strlen(p) < len ||
-        strncmp(namespace_notify.prefix, p, len) ||
-        (path[len] && path[len] != '/')) {
-        *errstr = "Namespace mismatch request target path";
-        return HTTP_FORBIDDEN;
-    }
-
-    tgt->mboxprefix = config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX);
-
-    /* Default to bare-bones Allow bits */
-    tgt->allow &= ALLOW_READ_MASK;
-
-    /* Skip namespace */
-    p += len;
-    if (!*p || !*++p) return 0;
-
-    /* Check if we're in user space */
-    len = strcspn(p, "/");
-    if (!strncmp(p, USER_COLLECTION_PREFIX, len)) {
-        p += len;
-        if (!*p || !*++p) return 0;
-
-        /* Get user id */
-        len = strcspn(p, "/");
-        tgt->userid = xstrndup(p, len);
-
-        if (httpd_extradomain) {
-            char *at = strchr(tgt->userid, '@');
-            if (at && !strcmp(at+1, httpd_extradomain))
-                *at = 0;
-        }
-
-        p += len;
-        if (!*p || !*++p) goto done;
-    }
-    else return HTTP_NOT_FOUND;  /* need to specify a userid */
-
-
-    /* Get resource */
-    len = strcspn(p, "/");
-    tgt->resource = p;
-    tgt->reslen = len;
-
-    p += len;
-
-    if (*p) {
-//      *errstr = "Too many segments in request target path";
-        return HTTP_NOT_FOUND;
-    }
-
-  done:
-    /* Create mailbox name from the parsed path */
-
-    mbname = mbname_from_userid(tgt->userid);
-    mbname_push_boxes(mbname, config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX));
-
-    /* XXX - hack to allow @domain parts for non-domain-split users */
-    if (httpd_extradomain) {
-        /* not allowed to be cross domain */
-        if (mbname_localpart(mbname) &&
-            strcmpsafe(mbname_domain(mbname), httpd_extradomain))
-            return HTTP_NOT_FOUND;
-        mbname_set_domain(mbname, NULL);
-    }
-
-    const char *mboxname = mbname_intname(mbname);
-
-    if (*mboxname) {
-        /* Locate the mailbox */
-        int r = http_mlookup(mboxname, &tgt->mbentry, NULL);
-        if (r) {
-            syslog(LOG_ERR, "mlookup(%s) failed: %s",
-                   mboxname, error_message(r));
-            *errstr = error_message(r);
-            mbname_free(&mbname);
-
-            switch (r) {
-            case IMAP_PERMISSION_DENIED: return HTTP_FORBIDDEN;
-            case IMAP_MAILBOX_NONEXISTENT: return HTTP_NOT_FOUND;
-            default: return HTTP_SERVER_ERROR;
-            }
-        }
-    }
-
-    mbname_free(&mbname);
-
-    /* Set proper Allow bits based on path components */
-    tgt->allow |= ALLOW_ACL;
-
-    if (tgt->resource) tgt->allow |= ALLOW_POST | ALLOW_DELETE;
-
-    return 0;
-}
-
-
-static int propfind_csnotify_collection(struct propfind_ctx *fctx,
-                                        xmlNodePtr props)
-{
-    struct propfind_ctx my_fctx;
-    struct request_target_t tgt;
-    struct propfind_entry_list *elist;
-    const char *err = NULL;
-
-    /* Populate our propfind context for notifcation collection */
-    memset(&my_fctx, 0, sizeof(struct propfind_ctx));
-
-    buf_printf(&my_fctx.buf, "%s/%s/%s/", namespace_notify.prefix,
-               USER_COLLECTION_PREFIX, fctx->req_tgt->userid);
-
-    memset(&tgt, 0, sizeof(struct request_target_t));
-    tgt.namespace = &namespace_notify;
-    notify_parse_path(buf_cstring(&my_fctx.buf), &tgt, &err);
-
-    my_fctx.txn = fctx->txn;
-    my_fctx.req_tgt = &tgt;
-    my_fctx.mode = fctx->mode;
-    my_fctx.depth = fctx->depth;
-    my_fctx.prefer = fctx->prefer & PREFER_MIN;
-    my_fctx.userid = httpd_userid;
-    my_fctx.userisadmin = httpd_userisadmin;
-    my_fctx.authstate = httpd_authstate;
-    my_fctx.mbentry = NULL;
-    my_fctx.mailbox = NULL;
-    my_fctx.record = NULL;
-    my_fctx.reqd_privs = DACL_READ;
-    my_fctx.filter = NULL;
-    my_fctx.filter_crit = NULL;
-    my_fctx.open_db = notify_params.davdb.open_db;
-    my_fctx.close_db = notify_params.davdb.close_db;
-    my_fctx.lookup_resource = notify_params.davdb.lookup_resource;
-    my_fctx.foreach_resource = notify_params.davdb.foreach_resource;
-    my_fctx.proc_by_resource = &propfind_by_resource;
-    my_fctx.elist = NULL;
-    my_fctx.lprops = notify_params.propfind.lprops;
-    my_fctx.root = fctx->root;
-    my_fctx.ns = fctx->ns;
-    my_fctx.ns_table = fctx->ns_table;
-    my_fctx.ret = fctx->ret;
-
-    /* Parse the list of properties and build a list of callbacks */
-    preload_proplist(props, &my_fctx);
-
-    /* Add response for target collection */
-    propfind_by_collection(tgt.mbentry, &my_fctx);
-
-    free(tgt.userid);
-    mboxlist_entry_free(&tgt.mbentry);
-
-    /* Free the entry list */
-    elist = my_fctx.elist;
-    while (elist) {
-        struct propfind_entry_list *freeme = elist;
-        elist = elist->next;
-        xmlFree(freeme->name);
-        free(freeme);
-    }
-
-    buf_free(&my_fctx.buf);
-
-    return 0;
-}
-
-
 static void dav_parse_textmatch(xmlNodePtr node, struct text_match_t **match,
                                 struct filter_profile_t *profile,
                                 struct error_t *error)
diff -pruN 3.0.13-5/imap/http_dav.h 3.2.0-3/imap/http_dav.h
--- 3.0.13-5/imap/http_dav.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_dav.h	2020-04-24 02:03:00.000000000 +0000
@@ -81,6 +81,7 @@
 #define USER_COLLECTION_PREFIX  "user"
 #define GROUP_COLLECTION_PREFIX "group"
 
+#define LOCK_TOKEN_URL_SCHEME "urn:uuid:"
 #define SYNC_TOKEN_URL_SCHEME "data:,"
 
 #define SHARED_COLLECTION_DELIM '.'
@@ -101,11 +102,11 @@ enum {
 
 /* Cyrus-specific privileges */
 #define DACL_PROPCOL    ACL_WRITE       /* CY:write-properties-collection */
-#define DACL_PROPRES    ACL_ANNOTATEMSG /* CY:write-properties-resource */
+#define DACL_PROPRSRC   ACL_ANNOTATEMSG /* CY:write-properties-resource */
 #define DACL_MKCOL      ACL_CREATE      /* CY:make-collection */
-#define DACL_ADDRES     ACL_POST        /* CY:add-resource */
+#define DACL_ADDRSRC    ACL_POST        /* CY:add-resource */
 #define DACL_RMCOL      ACL_DELETEMBOX  /* CY:remove-collection */
-#define DACL_RMRES      (ACL_DELETEMSG\
+#define DACL_RMRSRC     (ACL_DELETEMSG\
                          |ACL_EXPUNGE)  /* CY:remove-resource */
 #define DACL_ADMIN      ACL_ADMIN       /* CY:admin (aggregates
                                            DAV:read-acl, DAV:write-acl,
@@ -118,11 +119,11 @@ enum {
                                            and CALDAV:read-free-busy) */
 #define DACL_WRITECONT  ACL_INSERT      /* DAV:write-content */
 #define DACL_WRITEPROPS (DACL_PROPCOL\
-                         |DACL_PROPRES) /* DAV:write-properties */
+                         |DACL_PROPRSRC)/* DAV:write-properties */
 #define DACL_BIND       (DACL_MKCOL\
-                         |DACL_ADDRES)  /* DAV:bind */
+                         |DACL_ADDRSRC) /* DAV:bind */
 #define DACL_UNBIND     (DACL_RMCOL\
-                         |DACL_RMRES)   /* DAV:unbind */
+                         |DACL_RMRSRC)  /* DAV:unbind */
 #define DACL_WRITE      (DACL_WRITECONT\
                          |DACL_WRITEPROPS\
                          |DACL_BIND\
@@ -171,14 +172,9 @@ enum {
                                            schedule-send-reply,
                                            schedule-send-freebusy) */
 
-/* Privileges assigned via WebDAV Sharing (draft-pot-webdav-resource-sharing) */
-#define DACL_SHARE      (DACL_READ|DACL_WRITEPROPS)
-#define DACL_SHARERW    (DACL_READ|DACL_WRITE)
-
-
 /* Index into preconditions array */
 enum {
-    /* WebDAV (RFC 4918) preconditons */
+    /* WebDAV (RFC 4918) preconditions */
     DAV_PROT_PROP = 1,
     DAV_BAD_LOCK_TOKEN,
     DAV_NEED_LOCK_TOKEN,
@@ -281,20 +277,43 @@ enum {
 };
 
 
+extern struct meth_params princ_params;
+
+/* Function to fetch resource validators */
+typedef int (*get_validators_t)(struct mailbox *mailbox, void *data,
+                                const char *userid, struct index_record *record,
+                                const char **etag, time_t *lastmod);
+
+/* Function to fetch resource modseq */
+typedef modseq_t (*get_modseq_t)(struct mailbox *mailbox,
+                                 void *data, const char *userid);
+
 typedef void *(*db_open_proc_t)(struct mailbox *mailbox);
-typedef void (*db_close_proc_t)(void *davdb);
+typedef int (*db_close_proc_t)(void *davdb);
 
-/* Function to lookup DAV 'resource' in 'mailbox', with optional 'lock',
+/* Function to lookup DAV 'resource' in 'mailbox',
  * placing the record in 'data'
  */
 typedef int (*db_lookup_proc_t)(void *davdb, const char *mailbox,
                                 const char *resource, void **data,
                                 int tombstones);
 
+/* Function to lookup DAV 'imapuid' in 'mailbox',
+ * placing the record in 'data'
+ */
+typedef int (*db_imapuid_proc_t)(void *davdb, const char *mailbox,
+                                 int uid, void **data, int tombstones);
+
 /* Function to process each DAV resource in 'mailbox' with 'cb' */
 typedef int (*db_foreach_proc_t)(void *davdb, const char *mailbox,
                                  int (*cb)(void *rock, void *data), void *rock);
 
+/* Function to process 'limit' DAV resources
+   updated since 'oldmodseq' in 'mailbox' with 'cb' */
+typedef int (*db_updates_proc_t)(void *davdb, modseq_t oldmodseq,
+                                 const char *mailbox, int kind, int limit,
+                                 int (*cb)(void *rock, void *data), void *rock);
+
 /* Context for fetching properties */
 struct propfind_entry_list;
 struct prop_entry;
@@ -316,11 +335,12 @@ struct propfind_ctx {
     int userisadmin;                    /* is userid an admin */
     struct auth_state *authstate;       /* authorization state for userid */
     void *davdb;                        /* DAV DB corresponding to collection */
-    const mbentry_t *mbentry;           /* mbentry correspondng to collection */
-    struct mailbox *mailbox;            /* mailbox correspondng to collection */
+    const mbentry_t *mbentry;           /* mbentry corresponding to collection */
+    struct mailbox *mailbox;            /* mailbox corresponding to collection */
     struct quota quota;                 /* quota info for collection */
     struct index_record *record;        /* cyrus.index record for resource */
     void *data;                         /* DAV record for resource */
+    get_validators_t get_validators;    /* fetch resource validators */
     struct buf msg_buf;                 /* mmap()'d resource file */
     void *obj;                          /* parsed resource */
     void (*free_obj)(void *);           /* free parsed object */
@@ -343,6 +363,7 @@ struct propfind_ctx {
     int *ret;                           /* Return code to pass up to caller */
     struct fctx_flags_t flags;          /* Return flags for this propfind */
     struct buf buf;                     /* Working buffer */
+    xmlBufferPtr xmlbuf;                /* Buffer for dumping XML nodes */
 };
 
 
@@ -400,8 +421,9 @@ enum {
     PROP_ALLPROP =      (1<<0),         /* Returned in <allprop> request */
     PROP_COLLECTION =   (1<<1),         /* Returned for collection */
     PROP_RESOURCE =     (1<<2),         /* Returned for resource */
-    PROP_PRESCREEN =    (1<<3),         /* Prescreen property using callback */
-    PROP_CLEANUP =      (1<<4)          /* Cleanup property using callback */
+    PROP_PERUSER =      (1<<3),         /* Per-user property */
+    PROP_PRESCREEN =    (1<<4),         /* Prescreen property using callback */
+    PROP_CLEANUP =      (1<<5)          /* Cleanup property using callback */
 };
 
 
@@ -427,7 +449,9 @@ struct davdb_params {
     db_proc_t commit_transaction;
     db_proc_t abort_transaction;
     db_lookup_proc_t lookup_resource;   /* lookup a specific resource */
+    db_imapuid_proc_t lookup_imapuid;   /* lookup a specific resource */
     db_foreach_proc_t foreach_resource; /* process all resources in a mailbox */
+    db_updates_proc_t foreach_update;   /* process updated resources in a mbox */
     /* XXX - convert these to lock management only.  For everything else,
      * we need to go via mailbox.c for replication support */
     db_write_proc_t write_resourceLOCKONLY;     /* write a specific resource */
@@ -458,13 +482,19 @@ struct mime_type_t {
     struct buf* (*from_object)(void *);
     void* (*to_object)(const struct buf *);
     void (*free)(void *);
-    const char* (*begin_stream)(struct buf *);
+    const char* (*begin_stream)(struct buf *, struct mailbox *mailbox,
+                                const char *prodid, const char *name,
+                                const char *desc, const char *color);
     void (*end_stream)(struct buf *);
 };
 
+/* meth_mkcol() parameters */
+typedef int (*mkcol_proc_t)(struct mailbox *mailbox);
+
 struct mkcol_params {
     unsigned location_precond;          /* precond code for bad location */
     uint32_t mbtype;                    /* mailbox type collection */
+    mkcol_proc_t proc;                  /* func to do post-create processing */
 };
 
 /*
@@ -481,8 +511,7 @@ typedef int (*import_proc_t)(struct tran
 /* POST "mode" bits */
 enum {
     POST_ADDMEMBER = (1<<0),
-    POST_SHARE     = (1<<1),
-    POST_BULK      = (1<<2)
+    POST_SHARE     = (1<<1)
 };
 
 /* meth_put() parameters */
@@ -498,7 +527,11 @@ struct copy_params {
 struct post_params {
     unsigned allowed;                   /* allowed generic POST "modes" */
     post_proc_t proc;                   /* special POST handling (optional) */
-    import_proc_t import;               /* func to import multiple rsrcs (opt) */
+    struct {
+        unsigned data_ns;               /* namespace of "data" property */
+        const char *data_prop;          /* name of "data" prop for CRUD (opt) */
+        import_proc_t import;           /* func to import multiple rsrcs (opt) */
+    } bulk;
 };
 
 struct put_params {
@@ -542,6 +575,8 @@ enum {
 struct meth_params {
     struct mime_type_t *mime_types;     /* array of MIME types and conv funcs */
     parse_path_t parse_path;            /* parse URI path & generate mboxname */
+    get_validators_t get_validators;    /* fetch resource validators */
+    get_modseq_t get_modseq;            /* fetch resource modseq */
     check_precond_t check_precond;      /* check headers for preconditions */
     struct davdb_params davdb;          /* DAV DB access functions */
     acl_proc_t acl_ext;                 /* special ACL handling (extensions) */
@@ -628,14 +663,15 @@ struct filter_profile_t {
 #define DAV_FILTER_ISNOTDEF_ERR \
     "is-not-defined can NOT be combined with other elements"
 
+void dav_get_synctoken(struct mailbox *mailbox,
+                       struct buf *buf, const char *prefix);
+
 void dav_parse_propfilter(xmlNodePtr root, struct prop_filter **prop,
                           struct filter_profile_t *profile,
                           struct error_t *error);
 void dav_free_propfilter(struct prop_filter *prop);
 int dav_apply_textmatch(xmlChar *text, struct text_match_t *match);
 
-int notify_post(struct transaction_t *txn);
-
 int report_expand_prop(struct transaction_t *txn, struct meth_params *rparams,
                        xmlNodePtr inroot, struct propfind_ctx *fctx);
 int report_acl_prin_prop(struct transaction_t *txn, struct meth_params *rparams,
@@ -646,15 +682,23 @@ int report_sync_col(struct transaction_t
                     xmlNodePtr inroot, struct propfind_ctx *fctx);
 
 
+unsigned long calcarddav_allow_cb(struct request_target_t *tgt);
+int dav_parse_req_target(struct transaction_t *txn,
+                         struct meth_params *params);
 int calcarddav_parse_path(const char *path, struct request_target_t *tgt,
-                          const char *mboxprefix, const char **errstr);
+                          const char *mboxprefix, const char **resultstr);
+int dav_get_validators(struct mailbox *mailbox, void *data,
+                       const char *userid, struct index_record *record,
+                       const char **etag, time_t *lastmod);
+modseq_t dav_get_modseq(struct mailbox *mailbox,
+                        void *data, const char *userid);
 int dav_check_precond(struct transaction_t *txn, struct meth_params *params,
                       struct mailbox *mailbox, const void *data,
                       const char *etag, time_t lastmod);
 int dav_store_resource(struct transaction_t *txn,
                        const char *data, size_t datalen,
                        struct mailbox *mailbox, struct index_record *oldrecord,
-                       strarray_t *imapflags);
+                       modseq_t createdmodseq, strarray_t *imapflags);
 int dav_premethod(struct transaction_t *txn);
 unsigned get_preferences(struct transaction_t *txn);
 struct mime_type_t *get_accept_type(const char **hdr, struct mime_type_t *types);
@@ -662,6 +706,9 @@ struct mime_type_t *get_accept_type(cons
 int parse_xml_body(struct transaction_t *txn, xmlNodePtr *root,
                    const char *mimetype);
 
+size_t make_collection_url(struct buf *buf, const char *urlprefix, int haszzzz,
+                           const mbname_t *mbname, const char *userid);
+
 /* Initialize an XML tree */
 xmlNodePtr init_xml_response(const char *resp, int ns,
                              xmlNodePtr req, xmlNsPtr *respNs);
@@ -677,7 +724,8 @@ void xml_add_lockdisc(xmlNodePtr node, c
 int ensure_ns(xmlNsPtr *respNs, int ns, xmlNodePtr node,
               const char *url, const char *prefix);
 
-int xml_add_response(struct propfind_ctx *fctx, long code, unsigned precond);
+int xml_add_response(struct propfind_ctx *fctx, long code, unsigned precond,
+                     const char *desc, const char *location);
 int propfind_by_resource(void *rock, void *data);
 int propfind_by_collection(const mbentry_t *mbentry, void *rock);
 int expand_property(xmlNodePtr inroot, struct propfind_ctx *fctx,
@@ -685,6 +733,9 @@ int expand_property(xmlNodePtr inroot, s
                     parse_path_t parse_path, const struct prop_entry *lprops,
                     xmlNodePtr root, int depth);
 
+int preload_proplist(xmlNodePtr proplist, struct propfind_ctx *fctx);
+void free_entry_list(struct propfind_entry_list *elist);
+
 /* DAV method processing functions */
 int meth_acl(struct transaction_t *txn, void *params);
 int meth_copy_move(struct transaction_t *txn, void *params);
@@ -702,10 +753,12 @@ int meth_unlock(struct transaction_t *tx
 
 
 /* PROPFIND callbacks */
+
 int propfind_getdata(const xmlChar *name, xmlNsPtr ns,
                      struct propfind_ctx *fctx,
                      xmlNodePtr prop, struct propstat propstat[],
-                     struct mime_type_t *mime_types, int precond,
+                     struct mime_type_t *mime_types,
+                     struct mime_type_t **out_type,
                      const char *data, unsigned long datalen);
 int propfind_fromdb(const xmlChar *name, xmlNsPtr ns,
                     struct propfind_ctx *fctx,
@@ -719,6 +772,10 @@ int propfind_creationdate(const xmlChar
                           struct propfind_ctx *fctx,
                           xmlNodePtr prop, xmlNodePtr resp,
                           struct propstat propstat[], void *rock);
+int propfind_collectionname(const xmlChar *name, xmlNsPtr ns,
+                            struct propfind_ctx *fctx,
+                            xmlNodePtr prop, xmlNodePtr resp,
+                            struct propstat propstat[], void *rock);
 int propfind_getlength(const xmlChar *name, xmlNsPtr ns,
                        struct propfind_ctx *fctx,
                        xmlNodePtr prop, xmlNodePtr resp,
@@ -745,6 +802,11 @@ int propfind_reportset(const xmlChar *na
                        xmlNodePtr prop, xmlNodePtr resp,
                        struct propstat propstat[], void *rock);
 
+int propfind_methodset(const xmlChar *name, xmlNsPtr ns,
+                       struct propfind_ctx *fctx,
+                       xmlNodePtr prop, xmlNodePtr,
+                       struct propstat propstat[], void *rock);
+
 int propfind_collationset(const xmlChar *name, xmlNsPtr ns,
                           struct propfind_ctx *fctx,
                           xmlNodePtr prop, xmlNodePtr resp,
@@ -817,26 +879,18 @@ int propfind_caluseraddr(const xmlChar *
                          struct propfind_ctx *fctx,
                          xmlNodePtr prop, xmlNodePtr resp,
                          struct propstat propstat[], void *rock);
-int propfind_calusertype(const xmlChar *name, xmlNsPtr ns,
+int propfind_caluseremail(const xmlChar *name, xmlNsPtr ns,
                          struct propfind_ctx *fctx,
                          xmlNodePtr prop, xmlNodePtr resp,
                          struct propstat propstat[], void *rock);
-int propfind_abookhome(const xmlChar *name, xmlNsPtr ns,
-                       struct propfind_ctx *fctx,
-                       xmlNodePtr prop, xmlNodePtr resp,
-                       struct propstat propstat[], void *rock);
-
-void xml_add_shareaccess(struct propfind_ctx *fctx,
-                         xmlNodePtr resp, xmlNodePtr node, int legacy);
-int propfind_shareaccess(const xmlChar *name, xmlNsPtr ns,
+int proppatch_caluseraddr(xmlNodePtr prop, unsigned set,
+                          struct proppatch_ctx *pctx,
+                          struct propstat propstat[], void *rock);
+int propfind_calusertype(const xmlChar *name, xmlNsPtr ns,
                          struct propfind_ctx *fctx,
                          xmlNodePtr prop, xmlNodePtr resp,
                          struct propstat propstat[], void *rock);
-int propfind_invite(const xmlChar *name, xmlNsPtr ns,
-                    struct propfind_ctx *fctx,
-                    xmlNodePtr prop, xmlNodePtr resp,
-                    struct propstat propstat[], void *rock);
-int propfind_sharedurl(const xmlChar *name, xmlNsPtr ns,
+int propfind_abookhome(const xmlChar *name, xmlNsPtr ns,
                        struct propfind_ctx *fctx,
                        xmlNodePtr prop, xmlNodePtr resp,
                        struct propstat propstat[], void *rock);
diff -pruN 3.0.13-5/imap/http_dav_sharing.c 3.2.0-3/imap/http_dav_sharing.c
--- 3.0.13-5/imap/http_dav_sharing.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_dav_sharing.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,2071 @@
+/* http_dav.c -- Routines for dealing with DAV properties in httpd
+ *
+ * Copyright (c) 1994-2011 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <sysexits.h>
+
+#include "httpd.h"
+#include "http_dav.h"
+#include "http_dav_sharing.h"
+#include "http_proxy.h"
+#include "proxy.h"
+#include "strhash.h"
+#include "syslog.h"
+#include "times.h"
+#include "user.h"
+#include "webdav_db.h"
+#include "xstrlcpy.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+#define DAVNOTIFICATION_CONTENT_TYPE \
+    "application/davnotification+xml; charset=utf-8"
+
+static struct webdav_db *auth_webdavdb = NULL;
+
+static void my_dav_init(struct buf *serverinfo);
+static int my_dav_auth(const char *userid);
+static void my_dav_reset(void);
+static void my_dav_shutdown(void);
+
+static unsigned long notify_allow_cb(struct request_target_t *tgt);
+
+static int notify_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr);
+
+static int notify_get(struct transaction_t *txn, struct mailbox *mailbox,
+                      struct index_record *record, void *data, void **obj);
+static int notify_put(struct transaction_t *txn, void *obj,
+                      struct mailbox *mailbox, const char *resource,
+                      void *davdb, unsigned flags);
+
+static int propfind_restype(const xmlChar *name, xmlNsPtr ns,
+                            struct propfind_ctx *fctx,
+                            xmlNodePtr prop, xmlNodePtr resp,
+                            struct propstat propstat[], void *rock);
+
+static int propfind_notifytype(const xmlChar *name, xmlNsPtr ns,
+                               struct propfind_ctx *fctx,
+                               xmlNodePtr prop, xmlNodePtr resp,
+                               struct propstat propstat[], void *rock);
+
+static struct buf *from_xml(xmlDocPtr doc)
+{
+    struct buf *buf = buf_new();
+    xmlChar *xml = NULL;
+    int len = 0;
+
+    /* Dump XML response tree into a text buffer */
+    xmlDocDumpFormatMemoryEnc(doc, &xml, &len, "utf-8",
+                              config_httpprettytelemetry);
+    if (xml) buf_initm(buf, (char *) xml, len);
+
+    return buf;
+}
+
+static xmlDocPtr to_xml(const struct buf *buf)
+{
+    xmlParserCtxtPtr ctxt;
+    xmlDocPtr doc = NULL;
+
+    ctxt = xmlNewParserCtxt();
+    if (ctxt) {
+        doc = xmlCtxtReadMemory(ctxt, buf_base(buf), buf_len(buf), NULL, NULL,
+                                XML_PARSE_NOWARNING);
+        xmlFreeParserCtxt(ctxt);
+    }
+
+    return doc;
+}
+
+static struct mime_type_t notify_mime_types[] = {
+    /* First item MUST be the default type and storage format */
+    { DAVNOTIFICATION_CONTENT_TYPE, NULL, "xml",
+      (struct buf* (*)(void *)) &from_xml,
+      (void * (*)(const struct buf*)) &to_xml,
+      (void (*)(void *)) &xmlFreeDoc, NULL, NULL
+    },
+    { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
+};
+
+/* Array of supported REPORTs */
+static const struct report_type_t notify_reports[] = {
+
+    /* WebDAV Versioning (RFC 3253) REPORTs */
+    { "expand-property", NS_DAV, "multistatus", &report_expand_prop,
+      DACL_READ, 0 },
+
+    /* WebDAV ACL (RFC 3744) REPORTs */
+    { "acl-principal-prop-set", NS_DAV, "multistatus", &report_acl_prin_prop,
+      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_NEED_PROPS | REPORT_DEPTH_ZERO },
+
+    /* WebDAV Sync (RFC 6578) REPORTs */
+    { "sync-collection", NS_DAV, "multistatus", &report_sync_col,
+      DACL_READ, REPORT_NEED_MBOX | REPORT_NEED_PROPS },
+
+    { NULL, 0, NULL, NULL, 0, 0 }
+};
+
+/* Array of known "live" properties */
+static const struct prop_entry notify_props[] = {
+
+    /* WebDAV (RFC 4918) properties */
+    { "creationdate", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      propfind_creationdate, NULL, NULL },
+    { "displayname", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PERUSER,
+      propfind_fromdb, proppatch_todb, NULL },
+    { "getcontentlanguage", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
+      propfind_fromhdr, NULL, "Content-Language" },
+    { "getcontentlength", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      propfind_getlength, NULL, NULL },
+    { "getcontenttype", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
+      propfind_fromhdr, NULL, "Content-Type" },
+    { "getetag", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      propfind_getetag, NULL, NULL },
+    { "getlastmodified", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      propfind_getlastmod, NULL, NULL },
+    { "resourcetype", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+      propfind_restype, NULL, NULL },
+
+    /* WebDAV Versioning (RFC 3253) properties */
+    { "supported-report-set", NS_DAV,
+      PROP_COLLECTION,
+      propfind_reportset, NULL, (void *) notify_reports },
+    { "supported-method-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_methodset, NULL, (void *) &notify_allow_cb },
+
+    /* WebDAV ACL (RFC 3744) properties */
+    { "owner", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_owner, NULL, NULL },
+    { "group", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "supported-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_supprivset, NULL, NULL },
+    { "current-user-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_curprivset, NULL, NULL },
+    { "acl", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_acl, NULL, NULL },
+    { "acl-restrictions", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_aclrestrict, NULL, NULL },
+    { "inherited-acl-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "principal-collection-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_princolset, NULL, NULL },
+
+    /* WebDAV Current Principal (RFC 5397) properties */
+    { "current-user-principal", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_curprin, NULL, NULL },
+
+    /* WebDAV Sync (RFC 6578) properties */
+    { "sync-token", NS_DAV,
+      PROP_COLLECTION,
+      propfind_sync_token, NULL, SYNC_TOKEN_URL_SCHEME },
+
+    /* WebDAV Notifications (draft-pot-webdav-notifications) properties */
+    { "notificationtype", NS_DAV,
+      PROP_RESOURCE,
+      propfind_notifytype, NULL, NULL },
+
+    /* Backwards compatibility with Apple notifications clients */
+    { "notificationtype", NS_CS,
+      PROP_RESOURCE,
+      propfind_notifytype, NULL, "calendarserver-sharing" },
+
+    /* Apple Calendar Server properties */
+    { "getctag", NS_CS,
+      PROP_ALLPROP | PROP_COLLECTION,
+      propfind_sync_token, NULL, "" },
+
+    { NULL, 0, 0, NULL, NULL, NULL }
+};
+
+static struct meth_params notify_params = {
+    notify_mime_types,
+    &notify_parse_path,
+    &dav_get_validators,
+    &dav_get_modseq,
+    &dav_check_precond,
+    { (db_open_proc_t) &webdav_open_mailbox,
+      (db_close_proc_t) &webdav_close,
+      (db_proc_t) &webdav_begin,
+      (db_proc_t) &webdav_commit,
+      (db_proc_t) &webdav_abort,
+      (db_lookup_proc_t) &webdav_lookup_resource,
+      (db_imapuid_proc_t) &webdav_lookup_imapuid,
+      (db_foreach_proc_t) &webdav_foreach,
+      (db_updates_proc_t) &webdav_get_updates,
+      (db_write_proc_t) &webdav_write,
+      (db_delete_proc_t) &webdav_delete },
+    NULL,                                       /* No ACL extensions */
+    { 0, &notify_put },
+    NULL,                                       /* No special DELETE handling */
+    &notify_get,
+    { 0, 0, NULL },                             /* No MKCOL handling */
+    NULL,                                       /* No PATCH handling */
+    { 0, &notify_post, { 0, NULL, NULL } },     /* No generic POST handling */
+    { 0, &notify_put },
+    { DAV_FINITE_DEPTH, notify_props},
+    notify_reports
+};
+
+
+/* Namespace for WebDAV notification collections */
+struct namespace_t namespace_notify = {
+    URL_NS_NOTIFY, 0, "notify", "/dav/notifications", NULL,
+    http_allow_noauth_get, /*authschemes*/0,
+    MBTYPE_COLLECTION,
+    (ALLOW_READ | ALLOW_POST | ALLOW_DELETE |
+     ALLOW_DAV | ALLOW_PROPPATCH | ALLOW_ACL),
+    &my_dav_init, &my_dav_auth, &my_dav_reset, &my_dav_shutdown,
+    &dav_premethod, /*bearer*/NULL,
+    {
+        { &meth_acl,            &notify_params },      /* ACL          */
+        { NULL,                 NULL },                /* BIND         */
+        { NULL,                 NULL },                /* CONNECT      */
+        { NULL,                 NULL },                /* COPY         */
+        { &meth_delete,         &notify_params },      /* DELETE       */
+        { &meth_get_head,       &notify_params },      /* GET          */
+        { &meth_get_head,       &notify_params },      /* HEAD         */
+        { NULL,                 NULL },                /* LOCK         */
+        { NULL,                 NULL },                /* MKCALENDAR   */
+        { NULL,                 NULL },                /* MKCOL        */
+        { NULL,                 NULL },                /* MOVE         */
+        { &meth_options,        &notify_parse_path },  /* OPTIONS      */
+        { NULL,                 NULL },                /* PATCH        */
+        { &meth_post,           &notify_params },      /* POST         */
+        { &meth_propfind,       &notify_params },      /* PROPFIND     */
+        { NULL,                 NULL },                /* PROPPATCH    */
+        { NULL,                 NULL },                /* PUT          */
+        { &meth_report,         &notify_params },      /* REPORT       */
+        { &meth_trace,          &notify_parse_path },  /* TRACE        */
+        { NULL,                 NULL },                /* UNBIND       */
+        { NULL,                 NULL },                /* UNLOCK       */
+    }
+};
+
+
+static void my_dav_init(struct buf *serverinfo __attribute__((unused)))
+{
+    if (!namespace_principal.enabled) return;
+
+    if (!config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX)) {
+        fatal("Required 'davnotificationsprefix' option is not set", EX_CONFIG);
+    }
+
+    namespace_notify.enabled = 1;
+
+    webdav_init();
+}
+
+
+static int lookup_notify_collection(const char *userid, mbentry_t **mbentry)
+{
+    mbname_t *mbname;
+    const char *notifyname;
+    int r;
+
+    /* Create notification mailbox name from the parsed path */
+    mbname = mbname_from_userid(userid);
+    mbname_push_boxes(mbname, config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX));
+
+    /* XXX - hack to allow @domain parts for non-domain-split users */
+    if (httpd_extradomain) {
+        /* not allowed to be cross domain */
+        if (mbname_localpart(mbname) &&
+            strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
+            r = HTTP_NOT_FOUND;
+            goto done;
+        }
+        mbname_set_domain(mbname, NULL);
+    }
+
+    /* Locate the mailbox */
+    notifyname = mbname_intname(mbname);
+    r = http_mlookup(notifyname, mbentry, NULL);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* Find location of INBOX */
+        char *inboxname = mboxname_user_mbox(userid, NULL);
+
+        int r1 = http_mlookup(inboxname, mbentry, NULL);
+        free(inboxname);
+        if (r1 == IMAP_MAILBOX_NONEXISTENT) {
+            r = IMAP_INVALID_USER;
+            goto done;
+        }
+
+        if (*mbentry) free((*mbentry)->name);
+        else *mbentry = mboxlist_entry_create();
+        (*mbentry)->name = xstrdup(notifyname);
+    }
+
+  done:
+    mbname_free(&mbname);
+
+    return r;
+}
+
+static int _create_notify_collection(const char *userid, struct mailbox **mailbox)
+{
+    /* lock the namespace lock and try again */
+    struct mboxlock *namespacelock = user_namespacelock(userid);
+
+    mbentry_t *mbentry = NULL;
+    int r = lookup_notify_collection(userid, &mbentry);
+
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        if (!mbentry) goto done;
+        else if (mbentry->server) {
+            proxy_findserver(mbentry->server, &http_protocol, httpd_userid,
+                             &backend_cached, NULL, NULL, httpd_in);
+            goto done;
+        }
+
+        r = mboxlist_createmailbox(mbentry->name, MBTYPE_COLLECTION,
+                                   NULL, 1 /* admin */, userid, NULL,
+                                   0, 0, 0, 0, mailbox);
+        /* we lost the race, that's OK */
+        if (r == IMAP_MAILBOX_LOCKED) r = 0;
+        if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                      mbentry->name, error_message(r));
+    }
+    else if (!r && mailbox) {
+        /* Open mailbox for writing */
+        r = mailbox_open_iwl(mbentry->name, mailbox);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
+                   mbentry->name, error_message(r));
+        }
+    }
+
+ done:
+    mboxname_release(&namespacelock);
+    mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+static int create_notify_collection(const char *userid, struct mailbox **mailbox)
+{
+    /* notifications collection */
+    mbentry_t *mbentry = NULL;
+    int r = lookup_notify_collection(userid, &mbentry);
+    if (r) {
+        mboxlist_entry_free(&mbentry);
+        return _create_notify_collection(userid, mailbox);
+    }
+
+    if (mailbox) {
+        /* Open mailbox for writing */
+        r = mailbox_open_iwl(mbentry->name, mailbox);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
+                   mbentry->name, error_message(r));
+        }
+    }
+
+    mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+static int my_dav_auth(const char *userid)
+{
+    if (httpd_userisadmin || httpd_userisanonymous ||
+        global_authisa(httpd_authstate, IMAPOPT_PROXYSERVERS)) {
+        /* admin, anonymous, or proxy from frontend - won't have DAV database */
+        return 0;
+    }
+    else if (config_mupdate_server && !config_getstring(IMAPOPT_PROXYSERVERS)) {
+        /* proxy-only server - won't have DAV databases */
+        return 0;
+    }
+    else {
+        /* Open WebDAV DB for 'userid' */
+        my_dav_reset();
+        auth_webdavdb = webdav_open_userid(userid);
+        if (!auth_webdavdb) {
+            syslog(LOG_ERR, "Unable to open WebDAV DB for userid: %s", userid);
+            return HTTP_UNAVAILABLE;
+        }
+    }
+
+    /* Auto-provision a notifications collection for 'userid' */
+    create_notify_collection(userid, NULL);
+
+    return 0;
+}
+
+
+static void my_dav_reset(void)
+{
+    if (auth_webdavdb) webdav_close(auth_webdavdb);
+    auth_webdavdb = NULL;
+}
+
+
+static void my_dav_shutdown(void)
+{
+    my_dav_reset();
+    webdav_done();
+}
+
+
+/* Perform a GET/HEAD request on a WebDAV notification resource */
+static int notify_get(struct transaction_t *txn, struct mailbox *mailbox,
+                      struct index_record *record, void *data,
+                      void **obj __attribute__((unused)))
+{
+    const char **hdr;
+    struct webdav_data *wdata = (struct webdav_data *) data;
+    struct dlist *dl = NULL, *al;
+    const char *type_str;
+    struct buf msg_buf = BUF_INITIALIZER;
+    struct buf inbuf, *outbuf = NULL;
+    xmlDocPtr indoc = NULL, outdoc;
+    xmlNodePtr notify = NULL, root, node, type;
+    xmlNodePtr resp = NULL, sharedurl = NULL, node2;
+    xmlNsPtr ns[NUM_NAMESPACE];
+    xmlChar *dtstamp = NULL, *comment = NULL;
+    char datestr[RFC3339_DATETIME_MAX];
+    time_t t;
+    enum {
+        SYSTEM_STATUS,
+        SHARE_INVITE,
+        SHARE_REPLY
+    } notify_type;
+    int r, ret = 0;
+
+    if (!record || !record->uid) return HTTP_NO_CONTENT;
+
+    if ((hdr = spool_getheader(txn->req_hdrs, "Accept")) &&
+        is_mediatype(DAVSHARING_CONTENT_TYPE, hdr[0])) {
+        return HTTP_CONTINUE;
+    }
+
+    /* If no Accept header is given or its not application/davsharing+xml,
+       assume its a legacy notification client and do a mime type translation
+       from application/davnotification+xml to application/xml */
+
+    /* Parse dlist representing notification type, and data */
+    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
+    dlist_getatom(dl, "T", &type_str);
+    dlist_getlist(dl, "D", &al);
+
+    if (!strcmp(type_str, SYSTEM_STATUS_NOTIFICATION)) {
+        notify_type = SYSTEM_STATUS;
+    }
+    else if (!strcmp(type_str, SHARE_INVITE_NOTIFICATION)) {
+        notify_type = SHARE_INVITE;
+    }
+    else if (!strcmp(type_str, SHARE_REPLY_NOTIFICATION)) {
+        notify_type = SHARE_REPLY;
+    }
+    else {
+        ret = HTTP_NOT_ACCEPTABLE;
+        goto done;
+    }
+
+    txn->resp_body.type = "application/xml";
+
+    if (txn->meth == METH_HEAD) {
+        ret = HTTP_CONTINUE;
+        goto done;
+    }
+
+
+    /* Load message containing the resource */
+    r = mailbox_map_record(mailbox, record, &msg_buf);
+    if (r) {
+        txn->error.desc = error_message(r);
+        return HTTP_SERVER_ERROR;
+    }
+
+    /* Parse message body into XML tree */
+    buf_init_ro(&inbuf, buf_base(&msg_buf) + record->header_size,
+                record->size - record->header_size);
+    indoc = to_xml(&inbuf);
+    buf_free(&inbuf);
+    buf_free(&msg_buf);
+
+    root = xmlDocGetRootElement(indoc);
+    node = xmlFirstElementChild(root);
+    dtstamp = xmlNodeGetContent(node);
+    type = xmlNextElementSibling(node);
+
+    /* Translate DAV notification into CS notification */
+    notify = init_xml_response("notification", NS_CS, NULL, ns);
+    outdoc = notify->doc;
+
+    /* Calendar.app doesn't like separators in date-time */
+    time_from_iso8601((const char *) dtstamp, &t);
+    time_to_iso8601(t, datestr, RFC3339_DATETIME_MAX, 0);
+    xmlNewChild(notify, NULL, BAD_CAST "dtstamp", BAD_CAST datestr);
+
+    if (notify_type == SYSTEM_STATUS) {
+    }
+    else if (notify_type == SHARE_INVITE) {
+        xmlNodePtr invite, sharer = NULL, access = NULL, calcompset = NULL;
+        xmlChar *name = NULL;
+        struct buf buf = BUF_INITIALIZER;
+
+        /* Grab DAV elements that we need to construct CS notification */
+        for (node = xmlFirstElementChild(type); node;
+             node = xmlNextElementSibling(node)) {
+            if (!xmlStrncmp(node->name, BAD_CAST "invite-", 7)) {
+                resp = node;
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "sharer-resource-uri")) {
+                sharedurl = xmlFirstElementChild(node);
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "principal")) {
+                sharer = xmlFirstElementChild(node);
+                node2 = xmlNextElementSibling(sharer);
+                if (!xmlStrcmp(node2->name, BAD_CAST "prop")) {
+                    for (node2 = xmlFirstElementChild(node2); node2;
+                         node2 = xmlNextElementSibling(node2)) {
+                        if (!xmlStrcmp(node2->name, BAD_CAST "displayname")) {
+                            name = xmlNodeGetContent(node2);
+                        }
+                    }
+                }
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "share-access")) {
+                access = xmlFirstElementChild(node);
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
+                comment = xmlNodeGetContent(node);
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "prop")) {
+                for (node2 = xmlFirstElementChild(node); node2;
+                     node2 = xmlNextElementSibling(node2)) {
+                    if (!xmlStrcmp(node2->name,
+                                   BAD_CAST "supported-calendar-component-set")) {
+                        calcompset = node2;
+                    }
+                }
+            }
+        }
+
+        invite = xmlNewChild(notify, NULL, BAD_CAST "invite-notification", NULL);
+
+        xmlNewChild(invite, NULL, BAD_CAST "uid", BAD_CAST wdata->dav.resource);
+
+        /* Sharee href */
+        buf_reset(&buf);
+        buf_printf(&buf, "%s/%s/%s/", namespace_principal.prefix,
+                   USER_COLLECTION_PREFIX, txn->req_tgt.userid);
+        node = xml_add_href(invite, NULL, buf_cstring(&buf));
+        ensure_ns(ns, NS_DAV, node, XML_NS_DAV, "D");
+        xmlSetNs(node, ns[NS_DAV]);
+
+#if 0  /* XXX  Apple clients seem to always want "noresponse" */
+        xmlNewChild(invite, NULL, resp->name, NULL);
+#else
+        xmlNewChild(invite, NULL, BAD_CAST "invite-noresponse", NULL);
+#endif
+
+        node = xmlNewChild(invite, NULL, BAD_CAST "access", NULL);
+        xmlNewChild(node, NULL, access->name, NULL);
+        node = xmlNewChild(invite, NULL, BAD_CAST "hosturl", NULL);
+        xmlAddChild(node, xmlCopyNode(sharedurl, 1));
+        node = xmlNewChild(invite, NULL, BAD_CAST "organizer", NULL);
+        xmlAddChild(node, xmlCopyNode(sharer, 1));
+        if (name) {
+            xmlNewChild(node, NULL, BAD_CAST "common-name", name);
+            xmlFree(name);
+        }
+
+        if (comment) {
+            xmlNewChild(invite, NULL, BAD_CAST "summary", comment);
+            xmlFree(comment);
+        }
+        if (calcompset) {
+            xmlAddChild(invite, xmlCopyNode(calcompset, 1));
+        }
+
+        buf_free(&buf);
+    }
+    else if (notify_type == SHARE_REPLY) {
+        xmlNodePtr reply, sharee = NULL;
+
+        /* Grab DAV elements that we need to construct CS notification */
+        for (node = xmlFirstElementChild(type); node;
+             node = xmlNextElementSibling(node)) {
+            if (!xmlStrcmp(node->name, BAD_CAST "sharee")) {
+                for (node2 = xmlFirstElementChild(node); node2;
+                     node2 = xmlNextElementSibling(node2)) {
+                    if (!xmlStrcmp(node2->name, BAD_CAST "href")) {
+                        sharee = node2;
+                    }
+                    else if (!xmlStrncmp(node2->name, BAD_CAST "invite-", 7)) {
+                        resp = node2;
+                    }
+                }
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "href")) {
+                sharedurl = node;
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
+                comment = xmlNodeGetContent(node);
+            }
+        }
+
+        reply = xmlNewChild(notify, NULL, BAD_CAST "invite-reply", NULL);
+
+        xmlAddChild(reply, xmlCopyNode(sharee, 1));
+        xmlNewChild(reply, NULL, resp->name, NULL);
+        node = xmlNewChild(reply, NULL, BAD_CAST "hosturl", NULL);
+        xmlAddChild(node, xmlCopyNode(sharedurl, 1));
+
+        xmlNewChild(reply, NULL,
+                    BAD_CAST "in-reply-to", BAD_CAST wdata->dav.resource);
+
+        if (comment) {
+            xmlNewChild(reply, NULL, BAD_CAST "summary", comment);
+            xmlFree(comment);
+        }
+    }
+    else {
+        /* Unknown type - return as-is */
+        xmlFreeDoc(notify->doc);
+        notify = NULL;
+        outdoc = indoc;
+    }
+
+    /* Dump XML tree into a text buffer */
+    outbuf = from_xml(outdoc);
+
+    write_body(HTTP_OK, txn, buf_cstring(outbuf), buf_len(outbuf));
+
+  done:
+    if (dtstamp) xmlFree(dtstamp);
+    if (notify) xmlFreeDoc(notify->doc);
+    if (indoc) xmlFreeDoc(indoc);
+    buf_destroy(outbuf);
+    dlist_free(&dl);
+
+    return ret;
+}
+
+
+HIDDEN int dav_send_notification(xmlDocPtr doc,
+                                 const char *userid, const char *resource)
+{
+    struct mailbox *mailbox = NULL;
+    struct webdav_db *webdavdb = NULL;
+    struct transaction_t txn;
+    int r;
+
+    /* XXX  Need to find location of user.
+       If remote need to do a PUT or possibly email */
+
+    /* Open notifications collection for writing */
+    r = create_notify_collection(userid, &mailbox);
+    if (r == IMAP_INVALID_USER) {
+        syslog(LOG_NOTICE,
+               "dav_send_notification(%s) failed: %s", userid, error_message(r));
+        return 0;
+    }
+    else if (r) {
+        syslog(LOG_ERR,
+               "dav_send_notification: create_notify_collection(%s) failed: %s",
+               userid, error_message(r));
+        return r;
+    }
+
+    /* Open the WebDAV DB corresponding to collection */
+    webdavdb = webdav_open_mailbox(mailbox);
+    if (!webdavdb) {
+        syslog(LOG_ERR, "dav_send_notification: unable to open WebDAV DB (%s)",
+               mailbox->name);
+        r = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Start with an empty (clean) transaction */
+    memset(&txn, 0, sizeof(struct transaction_t));
+
+    /* Create header cache */
+    if (!(txn.req_hdrs = spool_new_hdrcache())) {
+        syslog(LOG_ERR, "dav_send_notification: unable to create header cache");
+        r = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    spool_cache_header(xstrdup("Content-Type"),
+                       xstrdup(DAVNOTIFICATION_CONTENT_TYPE), txn.req_hdrs);
+
+    r = notify_put(&txn, doc, mailbox, resource, webdavdb, 0);
+    if (r != HTTP_CREATED && r != HTTP_NO_CONTENT) {
+        syslog(LOG_ERR,
+               "dav_send_notification: notify_put(%s, %s) failed: %s",
+               mailbox->name, resource, error_message(r));
+    }
+
+  done:
+    spool_free_hdrcache(txn.req_hdrs);
+    buf_free(&txn.buf);
+    webdav_close(webdavdb);
+    mailbox_close(&mailbox);
+
+    return r;
+}
+
+
+/* Perform a POST request on a WebDAV notification resource */
+HIDDEN int notify_post(struct transaction_t *txn)
+{
+    xmlNodePtr root = NULL, node, resp = NULL;
+    int rights, ret, r, legacy = 0, add = 0;
+    struct mailbox *shared = NULL;
+    struct webdav_db *webdavdb = NULL;
+    struct webdav_data *wdata;
+    struct dlist *dl = NULL, *data;
+    const char *type_str, *mboxname, *url_prefix;
+    char dtstamp[RFC3339_DATETIME_MAX], *resource = NULL;
+    xmlNodePtr notify = NULL, type, sharee;
+    xmlNsPtr ns[NUM_NAMESPACE];
+    xmlChar *comment = NULL, *freeme = NULL;
+    mbname_t *mbname = NULL;
+
+    /* Check ACL for current user */
+    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
+    if (!(rights & DACL_ADMIN)) {
+        /* DAV:need-privileges */
+        txn->error.precond = DAV_NEED_PRIVS;
+        txn->error.resource = txn->req_tgt.path;
+        txn->error.rights = DACL_ADMIN;
+        return HTTP_NO_PRIVS;
+    }
+
+    if (txn->req_tgt.mbentry->server) {
+        /* Remote mailbox */
+        struct backend *be;
+
+        be = proxy_findserver(txn->req_tgt.mbentry->server,
+                              &http_protocol, httpd_userid,
+                              &backend_cached, NULL, NULL, httpd_in);
+        if (!be) return HTTP_UNAVAILABLE;
+
+        return http_pipe_req_resp(be, txn);
+    }
+
+    /* Local Mailbox */
+
+    /* Read body */
+    ret = parse_xml_body(txn, &root, DAVSHARING_CONTENT_TYPE);
+    if (!ret && !root) {
+        txn->error.desc = "Missing request body";
+        ret = HTTP_BAD_REQUEST;
+    }
+    if (ret) goto done;
+
+    /* Make sure its a invite-reply element */
+    if (xmlStrcmp(root->name, BAD_CAST "invite-reply")) {
+        txn->error.desc =
+            "Missing invite-reply element in POST request";
+        ret = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    resource = txn->req_tgt.resource;
+    if (!resource) legacy = 1;
+
+    /* Fetch needed elements */
+    for (node = xmlFirstElementChild(root); node;
+         node = xmlNextElementSibling(node)) {
+        if (!xmlStrncmp(node->name, BAD_CAST "invite-", 7)) {
+            if (!xmlStrcmp(node->name, BAD_CAST "invite-accepted")) add = 1;
+            resp = node;
+        }
+        else if (legacy) {
+            if (!xmlStrcmp(node->name, BAD_CAST "in-reply-to")) {
+                freeme = xmlNodeGetContent(node);
+                resource = (char *) freeme;
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "summary")) {
+                comment = xmlNodeGetContent(node);
+            }
+        }
+        else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
+            comment = xmlNodeGetContent(node);
+        }
+    }
+
+    if (!resp) {
+        txn->error.desc = "Missing invite response element in POST request";
+        ret = HTTP_BAD_REQUEST;
+        goto done;
+    }
+    if (!resource) {
+        txn->error.desc = "Missing in-reply-to element in POST request";
+        ret = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    if (legacy) {
+        /* Locate notification mailbox for target user */
+        mboxlist_entry_free(&txn->req_tgt.mbentry);
+        txn->req_tgt.mbentry = NULL;
+        r = lookup_notify_collection(txn->req_tgt.userid, &txn->req_tgt.mbentry);
+        if (r) {
+            syslog(LOG_ERR, "lookup_notify_collection(%s) failed: %s",
+                   txn->req_tgt.userid, error_message(r));
+            txn->error.desc = error_message(r);
+            ret = HTTP_SERVER_ERROR;
+            goto done;
+        }
+    }
+
+    /* Open the WebDAV DB corresponding to the mailbox */
+    webdavdb = webdav_open_userid(txn->req_tgt.userid);
+
+    /* Find message UID for the resource */
+    webdav_lookup_resource(webdavdb, txn->req_tgt.mbentry->name,
+                           resource, &wdata, 0);
+    if (!wdata->dav.imap_uid) {
+        ret = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Parse dlist representing notification type, and data */
+    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
+    dlist_getatom(dl, "T", &type_str);
+    if (strcmp(type_str, SHARE_INVITE_NOTIFICATION)) {
+        ret = HTTP_NOT_ALLOWED;
+        goto done;
+    }
+
+    dlist_getlist(dl, "D", &data);
+    dlist_getatom(data, "M", &mboxname);
+
+    /* [Un]subscribe */
+    r = mboxlist_changesub(mboxname, txn->req_tgt.userid,
+                           httpd_authstate, add, 0, 0);
+    if (r) {
+        syslog(LOG_ERR, "mboxlist_changesub(%s, %s) failed: %s",
+               mboxname, txn->req_tgt.userid, error_message(r));
+        txn->error.desc = error_message(r);
+        ret = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Set invite status */
+    r = mailbox_open_iwl(mboxname, &shared);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: failed to open mailbox %s for share reply",
+               mboxname);
+    }
+    else {
+        annotate_state_t *astate = NULL;
+
+        r = mailbox_get_annotate_state(shared, 0, &astate);
+        if (!r) {
+            const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
+            struct buf value = BUF_INITIALIZER;
+
+            buf_init_ro_cstr(&value, (char *) resp->name);
+            r = annotate_state_writemask(astate, annot,
+                                         txn->req_tgt.userid, &value);
+
+            if (shared->mbtype == MBTYPE_CALENDAR) {
+                /* Sharee's copy of calendar SHOULD default to transparent */
+                annot =
+                    DAV_ANNOT_NS "<" XML_NS_CALDAV ">schedule-calendar-transp";
+                buf_init_ro_cstr(&value, "transparent");
+                r = annotate_state_writemask(astate, annot,
+                                             txn->req_tgt.userid, &value);
+            }
+        }
+
+        mailbox_close(&shared);
+    }
+
+    /* Create share-reply-notification */
+    notify = init_xml_response("notification", NS_DAV, NULL, ns);
+
+    time_to_rfc3339(time(0), dtstamp, RFC3339_DATETIME_MAX);
+    xmlNewChild(notify, NULL, BAD_CAST "dtstamp", BAD_CAST dtstamp);
+
+    type = xmlNewChild(notify, NULL, BAD_CAST SHARE_REPLY_NOTIFICATION, NULL);
+
+    sharee = xmlNewChild(type, NULL, BAD_CAST "sharee", NULL);
+    buf_reset(&txn->buf);
+    buf_printf(&txn->buf, "%s/%s/%s/", namespace_principal.prefix,
+               USER_COLLECTION_PREFIX, txn->req_tgt.userid);
+    xml_add_href(sharee, NULL, buf_cstring(&txn->buf));
+
+    node = xmlNewChild(sharee, NULL, resp->name, NULL);
+
+    /* shared-url */
+    url_prefix = strstr(mboxname, config_getstring(IMAPOPT_CALENDARPREFIX)) ?
+        namespace_calendar.prefix : namespace_addressbook.prefix;
+
+    mbname = mbname_from_intname(mboxname);
+    if (!mbname_domain(mbname)) mbname_set_domain(mbname, httpd_extradomain);
+
+    make_collection_url(&txn->buf, url_prefix, /*haszzzz*/0, mbname, "");
+
+    xml_add_href(type, NULL, buf_cstring(&txn->buf));
+
+    if (comment) {
+        xmlNewChild(type, NULL, BAD_CAST "comment", comment);
+        xmlFree(comment);
+    }
+
+    /* Create a resource name for the notifications -
+       We use a consistent naming scheme so that multiple notifications
+       of the same type for the same resource are coalesced (overwritten) */
+    buf_reset(&txn->buf);
+    buf_printf(&txn->buf, "%x-%x-%x-%x.xml",
+               strhash(XML_NS_DAV), strhash(SHARE_REPLY_NOTIFICATION),
+               strhash(mboxname), strhash(txn->req_tgt.userid));
+
+    r = dav_send_notification(notify->doc,
+                              mbname_userid(mbname), buf_cstring(&txn->buf));
+
+
+    if (add) {
+        /* Accepted - create URL of sharee's new collection */
+        make_collection_url(&txn->buf, url_prefix, /*haszzzz*/0,
+                            mbname, txn->req_tgt.userid);
+
+        if (legacy) {
+            /* Create CS:shared-as XML body */
+            xmlNodePtr shared_as = init_xml_response("shared-as", NS_CS, NULL, ns);
+            if (!shared_as) {
+                ret = HTTP_SERVER_ERROR;
+                goto done;
+            }
+
+            node = xml_add_href(shared_as, NULL, buf_cstring(&txn->buf));
+            ensure_ns(ns, NS_DAV, node, XML_NS_DAV, "D");
+            xmlSetNs(node, ns[NS_DAV]);
+            xml_response(HTTP_OK, txn, shared_as->doc);
+            xmlFreeDoc(shared_as->doc);
+            ret = 0;
+        }
+        else {
+            /* Add Location header */
+            txn->location = buf_cstring(&txn->buf);
+            ret = HTTP_CREATED;
+        }
+    }
+    else {
+        /* Declined */
+        ret = HTTP_NO_CONTENT;
+    }
+
+  done:
+    if (freeme) xmlFree(freeme);
+    if (root) xmlFreeDoc(root->doc);
+    if (notify) xmlFreeDoc(notify->doc);
+    webdav_close(webdavdb);
+    mbname_free(&mbname);
+    dlist_free(&dl);
+
+    return ret;
+}
+
+
+/* Perform a PUT request on a WebDAV notification resource */
+static int notify_put(struct transaction_t *txn, void *obj,
+                      struct mailbox *mailbox, const char *resource,
+                      void *destdb, unsigned flags __attribute__((unused)))
+{
+    struct webdav_db *db = (struct webdav_db *)destdb;
+    xmlDocPtr doc = (xmlDocPtr) obj;
+    xmlNodePtr root, dtstamp, type = NULL, node;
+    struct webdav_data *wdata;
+    struct index_record *oldrecord = NULL, record;
+    struct buf *xmlbuf;
+    int r;
+
+    /* Validate the data */
+    if (!doc) return HTTP_FORBIDDEN;
+
+    /* Find message UID for the resource */
+    webdav_lookup_resource(db, mailbox->name, resource, &wdata, 0);
+
+    if (wdata->dav.imap_uid) {
+        /* Fetch index record for the resource */
+        oldrecord = &record;
+        mailbox_find_index_record(mailbox, wdata->dav.imap_uid, oldrecord);
+    }
+
+    /* Get type of notification */
+    if ((root = xmlDocGetRootElement(doc)) &&
+        (dtstamp = xmlFirstElementChild(root))) {
+        type = xmlNextElementSibling(dtstamp);
+    }
+
+    /* Create and cache RFC 5322 header fields for resource */
+    if (type) {
+        struct buf buf = BUF_INITIALIZER;
+        xmlChar *value;
+        time_t t;
+        struct dlist *dl, *al;
+        xmlAttrPtr attr;
+
+        spool_replace_header(xstrdup("Subject"),
+                             xstrdup((char *) type->name), txn->req_hdrs);
+
+        /* Create a dlist representing type, namespace, and attribute(s) */
+        value = xmlNodeGetContent(dtstamp);
+        time_from_iso8601((const char *) value, &t);
+        xmlFree(value);
+
+        dl = dlist_newkvlist(NULL, "N");
+        dlist_setdate(dl, "S", t);
+        dlist_setatom(dl, "NS", (char *) type->ns->href);
+        dlist_setatom(dl, "T", (char *) type->name);
+
+        /* Add any attributes */
+        al = dlist_newkvlist(dl, "A");
+        for (attr = type->properties; attr; attr = attr->next) {
+            value = xmlNodeGetContent((xmlNodePtr) attr);
+            dlist_setmap(al, (char *) attr->name,
+                         (char *) value, xmlStrlen(value));
+            xmlFree(value);
+        }
+
+        /* Add any additional data */
+        al = dlist_newkvlist(dl, "D");
+        if (!xmlStrcmp(type->name, BAD_CAST SHARE_INVITE_NOTIFICATION)) {
+            for (node = xmlFirstElementChild(type); node;
+                 node = xmlNextElementSibling(node)) {
+                if (!xmlStrcmp(node->name, BAD_CAST "sharer-resource-uri")) {
+                    struct request_target_t tgt;
+                    struct meth_params *pparams;
+                    const char *path, *errstr;
+                    int i;
+
+                    value = xmlNodeGetContent(xmlFirstElementChild(node));
+                    path = (const char *) value;
+
+                    /* Find the namespace of the requested resource */
+                    for (i = 0; http_namespaces[i]; i++) {
+                        size_t len;
+
+                        /* Skip disabled namespaces */
+                        if (!http_namespaces[i]->enabled) continue;
+
+                        /* See if the prefix matches - terminated with NUL or '/' */
+                        len = strlen(http_namespaces[i]->prefix);
+                        if (!strncmp(path, http_namespaces[i]->prefix, len) &&
+                            (!path[len] || (path[len] == '/') || !strcmp(path, "*"))) {
+                            break;
+                        }
+                    }
+
+                    memset(&tgt, 0, sizeof(struct request_target_t));
+                    tgt.namespace = http_namespaces[i];
+                    pparams =
+                        (struct meth_params *) tgt.namespace->methods[METH_PUT].params;
+                    tgt.flags = TGT_DAV_SHARED;  // prevent old-style sharing redirect
+                    pparams->parse_path(path, &tgt, &errstr);
+                    xmlFree(value);
+                    free(tgt.userid);
+
+                    dlist_setatom(al, "M", tgt.mbentry->name);
+
+                    mboxlist_entry_free(&tgt.mbentry);
+                    break;
+                }
+            }
+        }
+
+        dlist_printbuf(dl, 1, &buf);
+        dlist_free(&dl);
+        spool_replace_header(xstrdup("Content-Description"),
+                             buf_release(&buf), txn->req_hdrs);
+    }
+
+    buf_reset(&txn->buf);
+    buf_printf(&txn->buf, "<%s-%ld@%s>", resource, time(0), config_servername);
+    spool_replace_header(xstrdup("Message-ID"),
+                         buf_release(&txn->buf), txn->req_hdrs);
+
+    buf_printf(&txn->buf, "attachment;\r\n\tfilename=\"%s\"", resource);
+    spool_replace_header(xstrdup("Content-Disposition"),
+                         buf_release(&txn->buf), txn->req_hdrs);
+
+    /* Dump XML response tree into a text buffer */
+    xmlbuf = from_xml(doc);
+    if (!buf_len(xmlbuf)) r = HTTP_SERVER_ERROR;
+    else {
+        /* Store the resource */
+        r = dav_store_resource(txn, buf_cstring(xmlbuf), buf_len(xmlbuf),
+                               mailbox, oldrecord, wdata->dav.createdmodseq, NULL);
+    }
+
+    buf_destroy(xmlbuf);
+
+    return r;
+}
+
+
+/* Determine allowed methods in notify namespace */
+static unsigned long notify_allow_cb(struct request_target_t *tgt)
+{
+    unsigned long allow = tgt->namespace->allow;
+
+    if (!tgt->resource) {
+        allow &= ~(ALLOW_DELETE | ALLOW_POST);
+    }
+
+    return allow;
+}
+
+
+/* Parse request-target path in DAV notifications namespace */
+static int notify_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr)
+{
+    char *p;
+    size_t len;
+    mbname_t *mbname = NULL;
+
+    /* Make a working copy of target path */
+    strlcpy(tgt->path, path, sizeof(tgt->path));
+    tgt->tail = tgt->path + strlen(tgt->path);
+
+    p = tgt->path;
+
+    /* Sanity check namespace */
+    len = strlen(namespace_notify.prefix);
+    if (strlen(p) < len ||
+        strncmp(namespace_notify.prefix, p, len) ||
+        (path[len] && path[len] != '/')) {
+        *resultstr = "Namespace mismatch request target path";
+        return HTTP_FORBIDDEN;
+    }
+
+    tgt->mboxprefix = config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX);
+
+    /* Default to bare-bones Allow bits */
+    tgt->allow &= ALLOW_READ_MASK;
+
+    /* Skip namespace */
+    p += len;
+    if (!*p || !*++p) return 0;
+
+    /* Check if we're in user space */
+    len = strcspn(p, "/");
+    if (!strncmp(p, USER_COLLECTION_PREFIX, len)) {
+        p += len;
+        if (!*p || !*++p) return 0;
+
+        /* Get user id */
+        len = strcspn(p, "/");
+        tgt->userid = xstrndup(p, len);
+
+        if (httpd_extradomain) {
+            char *at = strchr(tgt->userid, '@');
+            if (at && !strcmp(at+1, httpd_extradomain))
+                *at = 0;
+        }
+
+        p += len;
+        if (!*p || !*++p) goto done;
+    }
+    else return HTTP_NOT_FOUND;  /* need to specify a userid */
+
+
+    /* Get resource */
+    len = strcspn(p, "/");
+    tgt->resource = p;
+    tgt->reslen = len;
+
+    p += len;
+
+    if (*p) {
+//      *resultstr = "Too many segments in request target path";
+        return HTTP_NOT_FOUND;
+    }
+
+  done:
+    /* Create mailbox name from the parsed path */
+
+    mbname = mbname_from_userid(tgt->userid);
+    mbname_push_boxes(mbname, config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX));
+
+    /* XXX - hack to allow @domain parts for non-domain-split users */
+    if (httpd_extradomain) {
+        /* not allowed to be cross domain */
+        if (mbname_localpart(mbname) &&
+            strcmpsafe(mbname_domain(mbname), httpd_extradomain))
+            return HTTP_NOT_FOUND;
+        mbname_set_domain(mbname, NULL);
+    }
+
+    const char *mboxname = mbname_intname(mbname);
+
+    if (*mboxname) {
+        /* Locate the mailbox */
+        int r = http_mlookup(mboxname, &tgt->mbentry, NULL);
+        if (r) {
+            syslog(LOG_ERR, "mlookup(%s) failed: %s",
+                   mboxname, error_message(r));
+            *resultstr = error_message(r);
+            mbname_free(&mbname);
+
+            switch (r) {
+            case IMAP_PERMISSION_DENIED: return HTTP_FORBIDDEN;
+            case IMAP_MAILBOX_NONEXISTENT: return HTTP_NOT_FOUND;
+            default: return HTTP_SERVER_ERROR;
+            }
+        }
+    }
+
+    mbname_free(&mbname);
+
+    /* Set proper Allow bits based on path components */
+    tgt->allow |= ALLOW_ACL;
+
+    if (tgt->resource) tgt->allow |= ALLOW_POST | ALLOW_DELETE;
+
+    return 0;
+}
+
+
+struct userid_rights {
+    long positive;
+    long negative;
+};
+
+static void parse_acl(hash_table *table, const char *origacl)
+{
+    char *acl = xstrdupsafe(origacl);
+    char *thisid, *rights, *nextid;
+
+    for (thisid = acl; *thisid; thisid = nextid) {
+        struct userid_rights *id_rights;
+        int is_negative = 0;
+        int mask;
+
+        rights = strchr(thisid, '\t');
+        if (!rights) {
+            break;
+        }
+        *rights++ = '\0';
+
+        nextid = strchr(rights, '\t');
+        if (!nextid) {
+            rights[-1] = '\t';
+            break;
+        }
+        *nextid++ = '\0';
+
+        if (*thisid == '-') {
+            is_negative = 1;
+            thisid++;
+        }
+
+        id_rights = hash_lookup(thisid, table);
+        if (!id_rights) {
+            id_rights = xzmalloc(sizeof(struct userid_rights));
+            hash_insert(thisid, id_rights, table);
+        }
+
+        cyrus_acl_strtomask(rights, &mask);
+        /* XXX and if strtomask fails? */
+        if (is_negative) id_rights->negative |= mask;
+        else id_rights->positive |= mask;
+    }
+
+    free(acl);
+}
+
+struct invite_rock {
+    const char *owner;
+    int is_shared;
+    struct propfind_ctx *fctx;
+    xmlNodePtr node;
+    int legacy;
+};
+
+static void xml_add_sharee(const char *userid, void *data, void *rock)
+{
+    struct userid_rights *id_rights = (struct userid_rights *) data;
+    struct invite_rock *irock = (struct invite_rock *) rock;
+    int rights = id_rights->positive & ~id_rights->negative;
+    struct auth_state *authstate;
+    int isadmin;
+
+    if ((rights & DACL_SHARE) != DACL_SHARE) return;  /* not shared */
+    if (!strcmp(userid, irock->owner)) return;  /* user is owner */
+
+    authstate = auth_newstate(userid);
+    isadmin = global_authisa(authstate, IMAPOPT_ADMINS);
+    auth_freestate(authstate);
+    if (isadmin) return;  /* user is an admin */
+
+
+    irock->is_shared = 1;
+
+    if (irock->node) {
+        xmlNodePtr sharee, access;
+        const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
+        const char *resp = "invite-noresponse";
+        struct buf value = BUF_INITIALIZER;
+        int r;
+
+        sharee = xmlNewChild(irock->node, NULL,
+                             BAD_CAST (irock->legacy ? "user" : "sharee"), NULL);
+
+        buf_reset(&irock->fctx->buf);
+        if (strchr(userid, '@')) {
+            buf_printf(&irock->fctx->buf, "mailto:%s", userid);
+        }
+        else {
+            const char *domain = httpd_extradomain;
+            if (!domain) domain = config_defdomain;
+            if (!domain) domain = config_servername;
+
+            buf_printf(&irock->fctx->buf, "mailto:%s@%s", userid, domain);
+        }
+        xml_add_href(sharee, irock->fctx->ns[NS_DAV],
+                     buf_cstring(&irock->fctx->buf));
+
+        /* Lookup invite status */
+        r = annotatemore_lookupmask(irock->fctx->mbentry->name,
+                                    annot, userid, &value);
+        if (!r && buf_len(&value)) resp = buf_cstring(&value);
+        xmlNewChild(sharee, NULL, BAD_CAST resp, NULL);
+        buf_free(&value);
+
+        access = xmlNewChild(sharee, NULL,
+                             BAD_CAST (irock->legacy ? "access" :
+                                       "share-access"), NULL);
+        if ((rights & DACL_SHARERW) == DACL_SHARERW)
+            xmlNewChild(access, NULL, BAD_CAST "read-write", NULL);
+        else xmlNewChild(access, NULL, BAD_CAST "read", NULL);
+    }
+}
+
+
+HIDDEN void xml_add_shareaccess(struct propfind_ctx *fctx,
+                                xmlNodePtr resp, xmlNodePtr node, int legacy)
+{
+    if (mboxname_userownsmailbox(fctx->req_tgt->userid, fctx->mbentry->name)) {
+        hash_table table;
+        struct invite_rock irock = { fctx->req_tgt->userid, 0, NULL, NULL, 0 };
+
+        construct_hash_table(&table, 10, 1);
+        parse_acl(&table, fctx->mbentry->acl);
+        hash_enumerate(&table, &xml_add_sharee, &irock);
+
+        if (irock.is_shared) {
+            xmlNsPtr ns = fctx->ns[NS_DAV];
+
+            if (legacy) {
+                ensure_ns(fctx->ns, NS_CS, resp->parent, XML_NS_CS, "CS");
+                ns = fctx->ns[NS_CS];
+            }
+            xmlNewChild(node, ns, BAD_CAST "shared-owner", NULL);
+        }
+        else if (!legacy)
+            xmlNewChild(node, NULL, BAD_CAST "not-shared", NULL);
+
+        free_hash_table(&table, &free);
+    }
+    else if (legacy) {
+        ensure_ns(fctx->ns, NS_CS, resp->parent, XML_NS_CS, "CS");
+        xmlNewChild(node, fctx->ns[NS_CS], BAD_CAST "shared", NULL);
+    }
+    else {
+        int rights = httpd_myrights(httpd_authstate, fctx->mbentry);
+
+        if ((rights & DACL_SHARERW) == DACL_SHARERW)
+            xmlNewChild(node, NULL, BAD_CAST "read-write", NULL);
+        else
+            xmlNewChild(node, NULL, BAD_CAST "read", NULL);
+    }
+}
+
+
+/* Callback to fetch DAV:share-access */
+HIDDEN int propfind_shareaccess(const xmlChar *name, xmlNsPtr ns,
+                                struct propfind_ctx *fctx,
+                                xmlNodePtr prop __attribute__((unused)),
+                                xmlNodePtr resp,
+                                struct propstat propstat[],
+                                void *rock __attribute__((unused)))
+{
+    xmlNodePtr node;
+
+    if (!fctx->mbentry) return HTTP_NOT_FOUND;
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+
+    xml_add_shareaccess(fctx, resp, node, 0 /* legacy */);
+
+    return 0;
+}
+
+
+/* Callback to fetch DAV:invite and CS:invite */
+HIDDEN int propfind_invite(const xmlChar *name, xmlNsPtr ns,
+                           struct propfind_ctx *fctx,
+                           xmlNodePtr prop __attribute__((unused)),
+                           xmlNodePtr resp __attribute__((unused)),
+                           struct propstat propstat[], void *rock)
+{
+    struct invite_rock irock = { fctx->req_tgt->userid, 0 /* is_shared */,
+                                 fctx, NULL, rock != 0 /* legacy */ };
+    xmlNodePtr node;
+
+    fctx->flags.cs_sharing = (rock != 0);
+
+    if (!fctx->mbentry) return HTTP_NOT_FOUND;
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+    irock.node = node;
+
+    if (mboxname_userownsmailbox(fctx->req_tgt->userid, fctx->mbentry->name)) {
+        hash_table table;
+
+        construct_hash_table(&table, 10, 1);
+
+        parse_acl(&table, fctx->mbentry->acl);
+        hash_enumerate(&table, &xml_add_sharee, &irock);
+
+        free_hash_table(&table, &free);
+    }
+    else {
+        struct userid_rights id_rights = 
+            { httpd_myrights(httpd_authstate, fctx->mbentry), 0 /* neg */};
+
+        irock.owner = "";
+        xml_add_sharee(fctx->req_tgt->userid, &id_rights, &irock);
+    }
+
+    return 0;
+}
+
+
+/* Callback to fetch DAV:sharer-resource-uri and CS:shared-url */
+HIDDEN int propfind_sharedurl(const xmlChar *name, xmlNsPtr ns,
+                              struct propfind_ctx *fctx,
+                              xmlNodePtr prop __attribute__((unused)),
+                              xmlNodePtr resp __attribute__((unused)),
+                              struct propstat propstat[], void *rock)
+{
+    mbname_t *mbname;
+    const strarray_t *boxes;
+    int n, size;
+    xmlNodePtr node;
+
+    fctx->flags.cs_sharing = (rock != 0);
+
+    mbname = mbname_from_intname(fctx->mailbox->name);
+
+    if (!strcmpsafe(mbname_userid(mbname), fctx->req_tgt->userid)) {
+        mbname_free(&mbname);
+        return HTTP_NOT_FOUND;
+    }
+
+    buf_setcstr(&fctx->buf, fctx->req_tgt->namespace->prefix);
+
+    if (mbname_localpart(mbname)) {
+        const char *domain =
+            mbname_domain(mbname) ? mbname_domain(mbname) : httpd_extradomain;
+
+        buf_printf(&fctx->buf, "/%s/%s",
+                   USER_COLLECTION_PREFIX, mbname_localpart(mbname));
+        if (domain) buf_printf(&fctx->buf, "@%s", domain);
+    }
+    buf_putc(&fctx->buf, '/');
+
+    boxes = mbname_boxes(mbname);
+    size = strarray_size(boxes);
+    for (n = 1; n < size; n++) {
+        buf_appendcstr(&fctx->buf, strarray_nth(boxes, n));
+        buf_putc(&fctx->buf, '/');
+    }
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                        &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+
+    xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+
+    mbname_free(&mbname);
+
+    return 0;
+}
+
+
+/* Callback to fetch DAV:notification-URL and CS:notification-URL */
+HIDDEN int propfind_notifyurl(const xmlChar *name, xmlNsPtr ns,
+                              struct propfind_ctx *fctx,
+                              xmlNodePtr prop,
+                              xmlNodePtr resp __attribute__((unused)),
+                              struct propstat propstat[],
+                              void *rock __attribute__((unused)))
+{
+    xmlNodePtr node;
+
+    if (!(namespace_principal.enabled && fctx->req_tgt->userid))
+        return HTTP_NOT_FOUND;
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                        name, ns, NULL, 0);
+
+    buf_reset(&fctx->buf);
+    buf_printf(&fctx->buf, "%s/%s/%s/", namespace_notify.prefix,
+               USER_COLLECTION_PREFIX, fctx->req_tgt->userid);
+
+    if ((fctx->mode == PROPFIND_EXPAND) && xmlFirstElementChild(prop)) {
+        /* Return properties for this URL */
+        expand_property(prop, fctx, &namespace_notify, buf_cstring(&fctx->buf),
+                        &notify_parse_path, notify_props, node, 0);
+
+    }
+    else {
+        /* Return just the URL */
+        xml_add_href(node, fctx->ns[NS_DAV], buf_cstring(&fctx->buf));
+    }
+
+    return 0;
+}
+
+
+/* Callback to fetch DAV:resourcetype */
+static int propfind_restype(const xmlChar *name, xmlNsPtr ns,
+                            struct propfind_ctx *fctx,
+                            xmlNodePtr prop __attribute__((unused)),
+                            xmlNodePtr resp __attribute__((unused)),
+                            struct propstat propstat[],
+                            void *rock __attribute__((unused)))
+{
+    xmlNodePtr node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV],
+                                   &propstat[PROPSTAT_OK], name, ns, NULL, 0);
+
+    if (!fctx->record) {
+        xmlNewChild(node, NULL, BAD_CAST "collection", NULL);
+
+        if (fctx->req_tgt->userid) {
+            xmlNewChild(node, NULL, BAD_CAST "notifications", NULL);
+
+            ensure_ns(fctx->ns, NS_CS, resp->parent, XML_NS_CS, "CS");
+            xmlNewChild(node, fctx->ns[NS_CS], BAD_CAST "notification", NULL);
+        }
+    }
+
+    return 0;
+}
+
+
+/* Callback to fetch DAV:notificationtype */
+static int propfind_notifytype(const xmlChar *name, xmlNsPtr ns,
+                               struct propfind_ctx *fctx,
+                               xmlNodePtr prop __attribute__((unused)),
+                               xmlNodePtr resp __attribute__((unused)),
+                               struct propstat propstat[], void *rock)
+{
+    struct webdav_data *wdata = (struct webdav_data *) fctx->data;
+    xmlNodePtr node;
+    xmlNsPtr type_ns = NULL;
+    struct dlist *dl = NULL, *al, *item;
+    const char *ns_href, *type;
+    int i;
+
+    if (!wdata->filename) return HTTP_NOT_FOUND;
+
+    node = xml_add_prop(HTTP_OK, fctx->ns[NS_DAV], &propstat[PROPSTAT_OK],
+                        name, ns, NULL, 0);
+
+    /* Parse dlist representing notification type, namespace, and attributes */
+    dlist_parsemap(&dl, 1, 0, wdata->filename, strlen(wdata->filename));
+    dlist_getatom(dl, "T", &type);
+    dlist_getatom(dl, "NS", &ns_href);
+    dlist_getlist(dl, "A", &al);
+
+    if (rock /* calendarserver-sharing */) {
+        if (!strcmp(type, SHARE_INVITE_NOTIFICATION))
+            type = "invite-notification";
+        else if (!strcmp(type, SHARE_REPLY_NOTIFICATION))
+            type = "invite-reply";
+    }
+    else {
+        /* Check if we already have this ns-href, otherwise create a new one */
+        type_ns = xmlSearchNsByHref(node->doc, node, BAD_CAST ns_href);
+        if (!type_ns) {
+            char prefix[20];
+            snprintf(prefix, sizeof(prefix), "X%X", strhash(ns_href) & 0xffff);
+            type_ns = xmlNewNs(node, BAD_CAST ns_href, BAD_CAST prefix);
+        }
+    }
+
+    /* Create node for type */
+    node = xmlNewChild(node, type_ns, BAD_CAST type, NULL);
+
+    /* Add attributes */
+    for (i = 0; (item = dlist_getchildn(al, i)); i++) {
+        xmlNewProp(node, BAD_CAST item->name, BAD_CAST dlist_cstring(item));
+    }
+
+    dlist_free(&dl);
+
+    return 0;
+}
+
+
+HIDDEN int propfind_csnotify_collection(struct propfind_ctx *fctx,
+                                        xmlNodePtr props)
+{
+    struct propfind_ctx my_fctx;
+    struct request_target_t tgt;
+    const char *err = NULL;
+
+    /* Populate our propfind context for notification collection */
+    memset(&my_fctx, 0, sizeof(struct propfind_ctx));
+
+    buf_printf(&my_fctx.buf, "%s/%s/%s/", namespace_notify.prefix,
+               USER_COLLECTION_PREFIX, fctx->req_tgt->userid);
+
+    memset(&tgt, 0, sizeof(struct request_target_t));
+    tgt.namespace = &namespace_notify;
+    notify_parse_path(buf_cstring(&my_fctx.buf), &tgt, &err);
+
+    my_fctx.txn = fctx->txn;
+    my_fctx.req_tgt = &tgt;
+    my_fctx.mode = fctx->mode;
+    my_fctx.depth = fctx->depth;
+    my_fctx.prefer = fctx->prefer & PREFER_MIN;
+    my_fctx.userid = httpd_userid;
+    my_fctx.userisadmin = httpd_userisadmin;
+    my_fctx.authstate = httpd_authstate;
+    my_fctx.mbentry = NULL;
+    my_fctx.mailbox = NULL;
+    my_fctx.record = NULL;
+    my_fctx.reqd_privs = DACL_READ;
+    my_fctx.filter = NULL;
+    my_fctx.filter_crit = NULL;
+    my_fctx.open_db = notify_params.davdb.open_db;
+    my_fctx.close_db = notify_params.davdb.close_db;
+    my_fctx.lookup_resource = notify_params.davdb.lookup_resource;
+    my_fctx.foreach_resource = notify_params.davdb.foreach_resource;
+    my_fctx.proc_by_resource = &propfind_by_resource;
+    my_fctx.elist = NULL;
+    my_fctx.lprops = notify_params.propfind.lprops;
+    my_fctx.root = fctx->root;
+    my_fctx.ns = fctx->ns;
+    my_fctx.ns_table = fctx->ns_table;
+    my_fctx.ret = fctx->ret;
+    my_fctx.xmlbuf = fctx->xmlbuf;
+
+    /* Parse the list of properties and build a list of callbacks */
+    preload_proplist(props, &my_fctx);
+
+    /* Add response for target collection */
+    propfind_by_collection(tgt.mbentry, &my_fctx);
+
+    free(tgt.userid);
+    mboxlist_entry_free(&tgt.mbentry);
+
+    /* Free the entry list */
+    free_entry_list(my_fctx.elist);
+
+    buf_free(&my_fctx.buf);
+
+    return 0;
+}
+
+
+static const char *access_types[] = { "no-access", "read", "read-write" };
+
+static int set_share_access(const char *mboxname,
+                            const char *userid, int access)
+{
+    char r, rightstr[100];
+
+    /* Set access rights */
+    rightstr[0] = (access == SHARE_READWRITE) ? '+' : '-';
+
+    cyrus_acl_masktostr(DACL_SHARERW, rightstr+1);
+    r = mboxlist_setacl(&httpd_namespace, mboxname, userid, rightstr,
+                        httpd_userisadmin || httpd_userisproxyadmin,
+                        httpd_userid, httpd_authstate);
+    if (!r && access == SHARE_READONLY) {
+        rightstr[0] = '+';
+        cyrus_acl_masktostr(DACL_SHARE, rightstr+1);
+        r = mboxlist_setacl(&httpd_namespace, mboxname, userid, rightstr,
+                            httpd_userisadmin || httpd_userisproxyadmin,
+                            httpd_userid, httpd_authstate);
+    }
+
+    return r;
+}
+
+
+static xmlNodePtr get_props(struct request_target_t *req_tgt,
+                            const char *prop_names[],
+                            xmlNodePtr root, xmlNsPtr ns[],
+                            const struct prop_entry prop_list[])
+{
+    struct propstat propstat = { NULL, 0, 0 };
+    struct propfind_ctx fctx;
+    const struct prop_entry *prop;
+    const char **name;
+    xmlNodePtr node;
+
+    memset(&fctx, 0, sizeof(struct propfind_ctx));
+    fctx.req_tgt = req_tgt;
+    fctx.mbentry = req_tgt->mbentry;
+    fctx.root = root;
+    fctx.ns = ns;
+
+    for (prop = prop_list; prop->name; prop++) {
+        for (name = prop_names; *name; name++) {
+            if (!strcmp(*name, prop->name)) {
+                prop->get(BAD_CAST prop->name, ns[NS_DAV],
+                          &fctx, NULL, NULL, &propstat, NULL);
+            }
+        }
+    }
+
+    buf_free(&fctx.buf);
+
+    node = propstat.root->children;
+    xmlUnlinkNode(node);
+    xmlFreeNode(propstat.root);
+
+    return node;
+}
+
+
+HIDDEN int dav_create_invite(xmlNodePtr *notify, xmlNsPtr *ns,
+                             struct request_target_t *tgt,
+                             const struct prop_entry *live_props,
+                             const char *sharee, int access,
+                             xmlChar *content)
+{
+    static xmlNodePtr resp, share, comment, node;
+    struct buf buf = BUF_INITIALIZER;
+    const char *invite_principal_props[] = { "displayname", NULL };
+    const char *invite_collection_props[] = { "displayname", "resourcetype",
+                                              "supported-calendar-component-set",
+                                              NULL };
+    const char *annot = DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
+    const char *response = "invite-noresponse";
+    int r;
+
+    if (!*notify) {
+        /* Create share-invite-notification -
+           response and share-access will be replaced for each sharee */
+        char dtstamp[RFC3339_DATETIME_MAX];
+        xmlNodePtr type, princ;
+
+        *notify = init_xml_response("notification", NS_DAV, NULL, ns);
+        if (!*notify) return HTTP_SERVER_ERROR;
+
+        time_to_rfc3339(time(0), dtstamp, RFC3339_DATETIME_MAX);
+        xmlNewChild(*notify, NULL, BAD_CAST "dtstamp", BAD_CAST dtstamp);
+
+        type = xmlNewChild(*notify, NULL,
+                           BAD_CAST SHARE_INVITE_NOTIFICATION, NULL);
+
+        princ = xmlNewChild(type, NULL, BAD_CAST "principal", NULL);
+        buf_printf(&buf, "%s/%s/%s/", namespace_principal.prefix,
+                   USER_COLLECTION_PREFIX, tgt->userid);
+        xml_add_href(princ, NULL, buf_cstring(&buf));
+        buf_free(&buf);
+
+        node = get_props(tgt, invite_principal_props,
+                         *notify, ns, princ_params.propfind.lprops);
+        xmlAddChild(princ, node);
+
+        resp = xmlNewChild(type, NULL, BAD_CAST "invite-noresponse", NULL);
+
+        node = xmlNewChild(type, NULL, BAD_CAST "sharer-resource-uri", NULL);
+        xml_add_href(node, NULL, tgt->path);
+
+        node = xmlNewChild(type, NULL, BAD_CAST "share-access", NULL);
+        share = xmlNewChild(node, NULL, BAD_CAST "no-access", NULL);
+
+        node = get_props(tgt, invite_collection_props,
+                         *notify, ns, live_props);
+        xmlAddChild(type, node);
+
+        comment = xmlNewChild(type, NULL, BAD_CAST "comment", NULL);
+    }
+
+    /* Lookup invite status */
+    r = annotatemore_lookupmask(tgt->mbentry->name,
+                                annot, sharee, &buf);
+    if (!r && buf_len(&buf)) response = buf_cstring(&buf);
+
+    /* Patch in response and share-access */
+    node = xmlNewNode(ns[NS_DAV], BAD_CAST response);
+    buf_free(&buf);
+    xmlReplaceNode(resp, node);
+    xmlFreeNode(resp);
+    resp = node;
+
+    node = xmlNewNode(ns[NS_DAV], BAD_CAST access_types[access]);
+    xmlReplaceNode(share, node);
+    xmlFreeNode(share);
+    share = node;
+
+    xmlNodeSetContent(comment, content ? content : BAD_CAST "");
+
+    return 0;
+}
+
+
+HIDDEN int dav_post_share(struct transaction_t *txn, struct meth_params *pparams)
+{
+    xmlNodePtr root = NULL, node, sharee;
+    int rights, ret, legacy = 0;
+    struct buf resource = BUF_INITIALIZER;
+    xmlNodePtr notify = NULL;
+    xmlNsPtr ns[NUM_NAMESPACE];
+
+    /* Check ACL for current user */
+    rights = httpd_myrights(httpd_authstate, txn->req_tgt.mbentry);
+    if (!(rights & DACL_ADMIN)) {
+        /* DAV:need-privileges */
+        txn->error.precond = DAV_NEED_PRIVS;
+        txn->error.resource = txn->req_tgt.path;
+        txn->error.rights = DACL_ADMIN;
+        return HTTP_NO_PRIVS;
+    }
+
+    if (txn->req_tgt.mbentry->server) {
+        /* Remote mailbox */
+        struct backend *be;
+
+        be = proxy_findserver(txn->req_tgt.mbentry->server,
+                              &http_protocol, httpd_userid,
+                              &backend_cached, NULL, NULL, httpd_in);
+        if (!be) return HTTP_UNAVAILABLE;
+
+        return http_pipe_req_resp(be, txn);
+    }
+
+    /* Local mailbox */
+
+    /* Read body */
+    ret = parse_xml_body(txn, &root, DAVSHARING_CONTENT_TYPE);
+    if (!ret && !root) {
+        txn->error.desc = "Missing request body";
+        ret = HTTP_BAD_REQUEST;
+    }
+    if (ret) goto done;
+
+    /* Make sure its a share-resource element */
+    if (!xmlStrcmp(root->name, BAD_CAST "share")) legacy = 1;
+    else if (xmlStrcmp(root->name, BAD_CAST "share-resource")) {
+        txn->error.desc =
+            "Missing share-resource element in POST request";
+        ret = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    /* Process each sharee */
+    for (sharee = xmlFirstElementChild(root); sharee;
+         sharee = xmlNextElementSibling(sharee)) {
+        xmlChar *href = NULL, *content = NULL;
+        int access = SHARE_READONLY;
+
+        if (legacy) {
+            if (!xmlStrcmp(sharee->name, BAD_CAST "remove")) {
+                access = SHARE_NONE;
+            }
+            else if (xmlStrcmp(sharee->name, BAD_CAST "set")) continue;
+        }
+        else if (xmlStrcmp(sharee->name, BAD_CAST "sharee")) continue;
+
+        for (node = xmlFirstElementChild(sharee); node;
+             node = xmlNextElementSibling(node)) {
+            if (!xmlStrcmp(node->name, BAD_CAST "href")) {
+                href = xmlNodeGetContent(node);
+                if (access == SHARE_NONE) break;
+            }
+
+            if (legacy) {
+                if (!xmlStrcmp(node->name, BAD_CAST "read-write")) {
+                    access = SHARE_READWRITE;
+                }
+                else if (!xmlStrcmp(node->name, BAD_CAST "summary")) {
+                    content = xmlNodeGetContent(node);
+                }
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "share-access")) {
+                xmlNodePtr share = xmlFirstElementChild(node);
+
+                if (!xmlStrcmp(share->name, BAD_CAST "no-access")) {
+                    access = SHARE_NONE;
+                }
+                else if (!xmlStrcmp(share->name, BAD_CAST "read-write")) {
+                    access = SHARE_READWRITE;
+                }
+            }
+            else if (!xmlStrcmp(node->name, BAD_CAST "comment")) {
+                content = xmlNodeGetContent(node);
+            }
+        }
+
+        if (href) {
+            char *userid = NULL, *at;
+            int r;
+
+            if (!xmlStrncasecmp(href, BAD_CAST "mailto:", 7)) {
+                userid = xstrdup((char *) href + 7);
+                if ((at = strchr(userid, '@'))) {
+                    if (!config_virtdomains || !strcmp(at+1, config_defdomain)){
+                        *at = '\0';
+                    }
+                }
+            }
+            else if (!xmlStrncmp(href, BAD_CAST "DAV:", 4)) {
+                if (!xmlStrcmp(href + 4, BAD_CAST "all")) {
+                    userid = xstrdup("anyone");
+                }
+                else if (!xmlStrcmp(href + 4, BAD_CAST "unauthenticated")) {
+                    userid = xstrdup("anonymous");
+                }
+                else if (!xmlStrcmp(href + 4, BAD_CAST "authenticated")) {
+                    /* This needs to be done as anyone - anonymous */
+                    r = set_share_access(txn->req_tgt.mbentry->name,
+                                         "anyone", access);
+                    if (r) {
+                        syslog(LOG_NOTICE,
+                               "failed to set share access for"
+                               " 'anyone' on '%s': %s",
+                               txn->req_tgt.mbentry->name, error_message(r));
+                    }
+                    else userid = xstrdup("-anonymous");
+                }
+            }
+            else {
+                const char *errstr = NULL;
+                xmlURIPtr uri = parse_uri(METH_UNKNOWN,
+                                          (const char *) href, 1, &errstr);
+
+                if (uri) {
+                    struct request_target_t principal;
+
+                    memset(&principal, 0, sizeof(struct request_target_t));
+                    r = princ_params.parse_path((const char *) uri->path,
+                                                &principal, &errstr);
+                    if (!r && principal.userid) userid = principal.userid;
+                    else if (principal.userid) free(principal.userid);
+
+                    xmlFreeURI(uri);
+                }
+            }
+
+            if (!userid) {
+                /* XXX  set invite-invalid ? */
+                syslog(LOG_NOTICE, "could not parse userid from sharing href");
+            }
+            else {
+                /* Set access rights */
+                r = set_share_access(txn->req_tgt.mbentry->name,
+                                     userid, access);
+                if (r) {
+                    syslog(LOG_NOTICE,
+                           "failed to set share access for '%s' on '%s': %s",
+                           userid, txn->req_tgt.mbentry->name,
+                           error_message(r));
+                }
+                else {
+                    /* Notify sharee */
+                    r = dav_create_invite(&notify, ns, &txn->req_tgt,
+                                          pparams->propfind.lprops,
+                                          userid, access, content);
+
+                    /* Create a resource name for the notifications -
+                       We use a consistent naming scheme so that multiple
+                       notifications of the same type for the same resource
+                       are coalesced (overwritten) */
+                    buf_reset(&resource);
+                    buf_printf(&resource, "%x-%x-%x-%x.xml",
+                               strhash(XML_NS_DAV),
+                               strhash(SHARE_INVITE_NOTIFICATION),
+                               strhash(txn->req_tgt.mbentry->name),
+                               strhash(userid));
+
+                    r = dav_send_notification(notify->doc,
+                                              userid, buf_cstring(&resource));
+                }
+
+                free(userid);
+            }
+
+            xmlFree(href);
+        }
+        if (content) xmlFree(content);
+
+        ret = HTTP_NO_CONTENT;
+    }
+
+  done:
+    if (root) xmlFreeDoc(root->doc);
+    if (notify) xmlFreeDoc(notify->doc);
+    buf_free(&resource);
+
+    return ret;
+}
diff -pruN 3.0.13-5/imap/http_dav_sharing.h 3.2.0-3/imap/http_dav_sharing.h
--- 3.0.13-5/imap/http_dav_sharing.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_dav_sharing.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,96 @@
+/* http_dav_sharing.h -- Routines for dealing with DAV sharing in httpd
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef HTTP_DAV_SHARING_H
+#define HTTP_DAV_SHARING_H
+
+#include "httpd.h"
+
+#define DAVSHARING_CONTENT_TYPE "application/davsharing+xml"
+
+/* Privileges assigned via WebDAV Sharing (draft-pot-webdav-resource-sharing) */
+#define DACL_SHARE      (DACL_READ|DACL_WRITEPROPS)
+#define DACL_SHARERW    (DACL_READ|DACL_WRITE)
+
+#define SYSTEM_STATUS_NOTIFICATION  "systemstatus"
+#define SHARE_INVITE_NOTIFICATION   "share-invite-notification"
+#define SHARE_REPLY_NOTIFICATION    "share-reply-notification"
+
+enum {
+    SHARE_NONE = 0,
+    SHARE_READONLY,
+    SHARE_READWRITE
+};
+
+void xml_add_shareaccess(struct propfind_ctx *fctx,
+                         xmlNodePtr resp, xmlNodePtr node, int legacy);
+int propfind_shareaccess(const xmlChar *name, xmlNsPtr ns,
+                         struct propfind_ctx *fctx,
+                         xmlNodePtr prop, xmlNodePtr resp,
+                         struct propstat propstat[], void *rock);
+int propfind_invite(const xmlChar *name, xmlNsPtr ns,
+                    struct propfind_ctx *fctx,
+                    xmlNodePtr prop, xmlNodePtr resp,
+                    struct propstat propstat[], void *rock);
+int propfind_sharedurl(const xmlChar *name, xmlNsPtr ns,
+                       struct propfind_ctx *fctx,
+                       xmlNodePtr prop, xmlNodePtr resp,
+                       struct propstat propstat[], void *rock);
+int propfind_notifyurl(const xmlChar *name, xmlNsPtr ns,
+                              struct propfind_ctx *fctx,
+                              xmlNodePtr prop, xmlNodePtr resp,
+                              struct propstat propstat[], void *rock);
+
+int propfind_csnotify_collection(struct propfind_ctx *fctx, xmlNodePtr props);
+
+int dav_post_share(struct transaction_t *txn, struct meth_params *pparams);
+int dav_create_invite(xmlNodePtr *notify, xmlNsPtr *ns,
+                      struct request_target_t *tgt,
+                      const struct prop_entry *live_props,
+                      const char *sharee, int access, xmlChar *content);
+int dav_send_notification(xmlDocPtr doc,
+                          const char *userid, const char *resource);
+
+int notify_post(struct transaction_t *txn);
+
+#endif /* HTTP_DAV_SHARING_H */
diff -pruN 3.0.13-5/imap/http_dblookup.c 3.2.0-3/imap/http_dblookup.c
--- 3.0.13-5/imap/http_dblookup.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_dblookup.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,7 @@
 
 #include "carddav_db.h"
 #include "http_dav.h"
+#include "spool.h"
 #include "util.h"
 #include "xstrlcpy.h"
 
@@ -56,7 +57,7 @@ static int meth_get_db(struct transactio
 
 /* Namespace for DB lookups */
 struct namespace_t namespace_dblookup = {
-    URL_NS_DBLOOKUP, /*enabled*/1, "/dblookup", NULL,
+    URL_NS_DBLOOKUP, /*enabled*/1, "dblookup", "/dblookup", NULL,
     http_allow_noauth, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -64,6 +65,7 @@ struct namespace_t namespace_dblookup =
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get_db,         NULL },                 /* GET          */
@@ -132,7 +134,7 @@ static int get_email2uids(struct transac
     json_t *json;
     int ret = HTTP_NO_CONTENT;
     int i;
-    const char *mboxname = NULL;
+    char *mboxname = NULL;
     const char **mailboxhdrs;
     const char *mailbox = "Default";
 
@@ -147,7 +149,7 @@ static int get_email2uids(struct transac
     db = carddav_open_userid(userid);
     if (!db) goto done;
 
-    array = carddav_getemail2uids(db, key, mboxname);
+    array = carddav_getemail2details(db, key, mboxname, NULL);
     if (!array) goto done;
 
     json = json_array();
@@ -165,31 +167,26 @@ static int get_email2uids(struct transac
     ret = 0;
 
 done:
+    free(mboxname);
     free(result);
     if (array) strarray_free(array);
     if (db) carddav_close(db);
     return ret;
 }
 
-static int get_uid2groups(struct transaction_t *txn,
-                          const char *userid, const char *key)
+static int get_email2details(struct transaction_t *txn __attribute__((unused)),
+                             const char *userid, const char *key)
 {
     struct carddav_db *db = NULL;
     strarray_t *array = NULL;
     char *result = NULL;
-    json_t *json;
+    json_t *uids, *json;
     int ret = HTTP_NO_CONTENT;
     int i;
-    const char *mboxname = NULL;
-    const char **otheruserhdrs;
-    const char *otheruser = "";
+    char *mboxname = NULL;
     const char **mailboxhdrs;
     const char *mailbox = "Default";
-
-    otheruserhdrs = spool_getheader(txn->req_hdrs, "OtherUser");
-    if (otheruserhdrs) {
-        otheruser = otheruserhdrs[0];
-    }
+    int ispinned = 0;
 
     mailboxhdrs = spool_getheader(txn->req_hdrs, "Mailbox");
     if (mailboxhdrs) {
@@ -202,14 +199,16 @@ static int get_uid2groups(struct transac
     db = carddav_open_userid(userid);
     if (!db) goto done;
 
-    array = carddav_getuid2groups(db, key, mboxname, otheruser);
+    array = carddav_getemail2details(db, key, mboxname, &ispinned);
     if (!array) goto done;
 
-    json = json_pack("{}");
-    for (i = 0; i < strarray_size(array); i += 2) {
-        json_object_set_new(json, strarray_nth(array, i), json_string(strarray_nth(array, i+1)));
+    uids = json_array();
+    for (i = 0; i < strarray_size(array); i++) {
+        json_array_append_new(uids, json_string(strarray_nth(array, i)));
     }
 
+    json = json_pack("{s:o s:b}", "uids", uids, "isPinned", ispinned);
+
     result = json_dumps(json, JSON_PRESERVE_ORDER|JSON_COMPACT);
     json_decref(json);
 
@@ -220,13 +219,15 @@ static int get_uid2groups(struct transac
     ret = 0;
 
 done:
+    free(mboxname);
     free(result);
     if (array) strarray_free(array);
     if (db) carddav_close(db);
     return ret;
 }
 
-static int get_group(struct transaction_t *txn, const char *userid, const char *mboxname, const char *group)
+static int get_uid2groups(struct transaction_t *txn,
+                          const char *userid, const char *key)
 {
     struct carddav_db *db = NULL;
     strarray_t *array = NULL;
@@ -234,17 +235,34 @@ static int get_group(struct transaction_
     json_t *json;
     int ret = HTTP_NO_CONTENT;
     int i;
+    char *mboxname = NULL;
+    const char **otheruserhdrs;
+    const char *otheruser = "";
+    const char **mailboxhdrs;
+    const char *mailbox = "Default";
+
+    otheruserhdrs = spool_getheader(txn->req_hdrs, "OtherUser");
+    if (otheruserhdrs) {
+        otheruser = otheruserhdrs[0];
+    }
+
+    mailboxhdrs = spool_getheader(txn->req_hdrs, "Mailbox");
+    if (mailboxhdrs) {
+        mailbox = mailboxhdrs[0];
+    }
+
+    mboxname = mboxname_abook(userid, mailbox);
 
     /* XXX init just incase carddav not enabled? */
     db = carddav_open_userid(userid);
     if (!db) goto done;
 
-    array = carddav_getgroup(db, mboxname, group);
+    array = carddav_getuid2groups(db, key, mboxname, otheruser);
     if (!array) goto done;
 
-    json = json_array();
-    for (i = 0; i < strarray_size(array); i++) {
-        json_array_append_new(json, json_string(strarray_nth(array, i)));
+    json = json_pack("{}");
+    for (i = 0; i < strarray_size(array); i += 2) {
+        json_object_set_new(json, strarray_nth(array, i), json_string(strarray_nth(array, i+1)));
     }
 
     result = json_dumps(json, JSON_PRESERVE_ORDER|JSON_COMPACT);
@@ -257,6 +275,7 @@ static int get_group(struct transaction_
     ret = 0;
 
 done:
+    free(mboxname);
     free(result);
     if (array) strarray_free(array);
     if (db) carddav_close(db);
@@ -268,9 +287,6 @@ static int meth_get_db(struct transactio
 {
     const char **userhdrs;
     const char **keyhdrs;
-    char path[MAX_MAILBOX_PATH+1];
-    char *p;
-    mbname_t *mbname = NULL;
 
     userhdrs = spool_getheader(txn->req_hdrs, "User");
     keyhdrs = spool_getheader(txn->req_hdrs, "Key");
@@ -281,46 +297,22 @@ static int meth_get_db(struct transactio
     if (userhdrs[1]) return HTTP_NOT_ALLOWED;
     if (keyhdrs[1]) return HTTP_NOT_ALLOWED;
 
+    spool_cache_header(xstrdup(":dblookup"),
+                      strconcat(userhdrs[0], "/", keyhdrs[0], (char *)NULL),
+                      txn->req_hdrs);
+
+
     if (!strcmp(txn->req_uri->path, "/dblookup/email"))
         return get_email(txn, userhdrs[0], keyhdrs[0]);
 
     if (!strcmp(txn->req_uri->path, "/dblookup/email2uids"))
         return get_email2uids(txn, userhdrs[0], keyhdrs[0]);
 
+    if (!strcmp(txn->req_uri->path, "/dblookup/email2details"))
+        return get_email2details(txn, userhdrs[0], keyhdrs[0]);
+
     if (!strcmp(txn->req_uri->path, "/dblookup/uid2groups"))
         return get_uid2groups(txn, userhdrs[0], keyhdrs[0]);
 
-    strlcpy(path, keyhdrs[0], sizeof(path));
-    p = path + strlen(path);
-    while (p >= path && *p != '/') { p--; }
-    if (p < path)
-        return HTTP_BAD_REQUEST;
-    *p++ = '\0';
-
-    mbname = mbname_from_userid(userhdrs[0]);
-    mbname_push_boxes(mbname, config_getstring(IMAPOPT_ADDRESSBOOKPREFIX));
-    mbname_push_boxes(mbname, path);
-
-    /* XXX - hack to allow @domain parts for non-domain-split users */
-    if (httpd_extradomain) {
-        /* not allowed to be cross domain */
-        if (mbname_localpart(mbname) && strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
-            mbname_free(&mbname);
-            return HTTP_NOT_FOUND;
-        }
-        //free(parts.domain); - XXX fix when converting to real parts
-        mbname_set_domain(mbname, NULL);
-    }
-
-    const char *mboxname = mbname_intname(mbname);
-
-    int r;
-    if (!strcmp(txn->req_uri->path, "/dblookup/group"))
-        r = get_group(txn, userhdrs[0], mboxname, p);
-    else
-        r = HTTP_NOT_FOUND;
-
-    mbname_free(&mbname);
-
-    return r;
+    return HTTP_NOT_FOUND;
 }
diff -pruN 3.0.13-5/imap/httpd.c 3.2.0-3/imap/httpd.c
--- 3.0.13-5/imap/httpd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/httpd.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
-/* httpd.c -- HTTP/WebDAV/CalDAV server protocol parsing
+/* httpd.c -- HTTP/RSS/xDAV/JMAP/TZdist/iSchedule server protocol parsing
  *
- * Copyright (c) 1994-2011 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -54,6 +54,7 @@
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/param.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -64,9 +65,12 @@
 
 #include <sasl/sasl.h>
 #include <sasl/saslutil.h>
+#include <jansson.h>
 
 #include "httpd.h"
+#include "http_h2.h"
 #include "http_proxy.h"
+#include "http_ws.h"
 
 #include "acl.h"
 #include "assert.h"
@@ -76,16 +80,15 @@
 #include "tls.h"
 #include "map.h"
 
-#include "acl.h"
-#include "exitcodes.h"
 #include "imapd.h"
 #include "proc.h"
 #include "version.h"
+#include "stristr.h"
 #include "xstrlcpy.h"
 #include "xstrlcat.h"
-#include "sync_log.h"
 #include "telemetry.h"
 #include "backend.h"
+#include "prometheus.h"
 #include "proxy.h"
 #include "userdeny.h"
 #include "message.h"
@@ -106,473 +109,312 @@
 #include <libxml/HTMLtree.h>
 #include <libxml/uri.h>
 
+static unsigned accept_encodings = 0;
+
 #ifdef HAVE_ZLIB
 #include <zlib.h>
-#endif /* HAVE_ZLIB */
-
-#ifdef HAVE_BROTLI
-#include <brotli/encode.h>
 
-BrotliEncoderState *brotli_init()
+HIDDEN void *zlib_init()
 {
-    BrotliEncoderState *brotli = BrotliEncoderCreateInstance(NULL, NULL, NULL);
+    z_stream *zstrm = xzmalloc(sizeof(z_stream));
 
-    if (brotli) {
-        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_MODE,
-                                  BROTLI_DEFAULT_MODE);
-        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_QUALITY,
-                                  BROTLI_DEFAULT_QUALITY);
-        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_LGWIN,
-                                  BROTLI_DEFAULT_WINDOW);
-        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_LGBLOCK, 0);
+    /* Always use gzip format because IE incorrectly uses raw deflate */
+    if (deflateInit2(zstrm, Z_DEFAULT_COMPRESSION, Z_DEFLATED,
+                     16+MAX_WBITS /* gzip */,
+                     MAX_MEM_LEVEL, Z_DEFAULT_STRATEGY) != Z_OK) {
+        free(zstrm);
+        return NULL;
     }
-
-    return brotli;
-}
-#endif /* HAVE_BROTLI */
-
-
-static const char tls_message[] =
-    HTML_DOCTYPE
-    "<html>\n<head>\n<title>TLS Required</title>\n</head>\n" \
-    "<body>\n<h2>TLS is required prior to authentication</h2>\n" \
-    "Use <a href=\"%s\">%s</a> instead.\n" \
-    "</body>\n</html>\n";
-
-extern int optind;
-extern char *optarg;
-extern int opterr;
-
-#ifdef HAVE_SSL
-static SSL *tls_conn;
-#endif /* HAVE_SSL */
-
-sasl_conn_t *httpd_saslconn; /* the sasl connection context */
-
-static struct wildmat *allow_cors = NULL;
-int httpd_timeout, httpd_keepalive;
-char *httpd_userid = NULL;
-char *httpd_extrafolder = NULL;
-char *httpd_extradomain = NULL;
-struct auth_state *httpd_authstate = 0;
-int httpd_userisadmin = 0;
-int httpd_userisproxyadmin = 0;
-int httpd_userisanonymous = 1;
-static const char *httpd_clienthost = "[local]";
-const char *httpd_localip = NULL, *httpd_remoteip = NULL;
-struct protstream *httpd_out = NULL;
-struct protstream *httpd_in = NULL;
-struct protgroup *protin = NULL;
-static int httpd_logfd = -1;
-
-static sasl_ssf_t extprops_ssf = 0;
-int https = 0;
-int httpd_tls_done = 0;
-int httpd_tls_required = 0;
-unsigned avail_auth_schemes = 0; /* bitmask of available auth schemes */
-unsigned long config_httpmodules;
-int config_httpprettytelemetry;
-
-static time_t compile_time;
-struct buf serverinfo = BUF_INITIALIZER;
-
-int ignorequota = 0;
-int apns_enabled = 0;
-
-#ifdef HAVE_NGHTTP2
-
-static nghttp2_session_callbacks *http2_callbacks = NULL;
-
-#if OPENSSL_VERSION_NUMBER >= 0x10002000L
-static int alpn_select_cb(SSL *ssl __attribute__((unused)),
-                          const unsigned char **out, unsigned char *outlen,
-                          const unsigned char *in, unsigned int inlen,
-                          void *arg)
-{
-    int *is_h2 = (int *) arg;
-
-    if (nghttp2_select_next_protocol((u_char **) out, outlen, in, inlen) == 1) {
-        *is_h2 = 1;
-        return SSL_TLSEXT_ERR_OK;
+    else {
+        accept_encodings |= CE_DEFLATE | CE_GZIP;
+        return zstrm;
     }
-
-    return SSL_TLSEXT_ERR_NOACK;
 }
-#endif /* OPENSSL_VERSION_NUMBER >= 0x10002000L */
 
-static ssize_t http2_send_cb(nghttp2_session *session __attribute__((unused)),
-                             const uint8_t *data, size_t length,
-                             int flags __attribute__((unused)),
-                             void *user_data)
+HIDDEN int zlib_compress(struct transaction_t *txn, unsigned flags,
+                         const char *buf, unsigned len)
 {
-    struct http_connection *conn = (struct http_connection *) user_data;
-    struct protstream *pout = conn->pout;
-    int r;
-
-    r = prot_write(pout, (const char *) data, length);
+    z_stream *zstrm = txn->zstrm;
+    unsigned flush;
 
-    syslog(LOG_DEBUG, "http2_send_cb(%zu): %d", length, r);
-
-    if (r) return NGHTTP2_ERR_CALLBACK_FAILURE;
-
-    return length;
-}
-
-static ssize_t http2_recv_cb(nghttp2_session *session __attribute__((unused)),
-                             uint8_t *buf, size_t length,
-                             int flags __attribute__((unused)),
-                             void *user_data)
-{
-    struct http_connection *conn = (struct http_connection *) user_data;
-    struct protstream *pin = conn->pin;
-    ssize_t n;
+    if (flags & COMPRESS_START) deflateReset(zstrm);
 
-    
-    n = prot_read(pin, (char *) buf, length);
-    if (n) {
-        /* We received some data - don't block next time
-           Note: This callback gets called multiple times until it
-           would block.  We don't actually want to block and prevent
-           output from being submitted */
-        prot_NONBLOCK(pin);
-    }
+    if (txn->ws_ctx) flush = Z_SYNC_FLUSH;
     else {
-        /* No data -  block next time (for client timeout) */
-        prot_BLOCK(pin);
-
-        if (pin->eof) n = NGHTTP2_ERR_EOF;
-        else if (pin->error) n = NGHTTP2_ERR_CALLBACK_FAILURE;
-        else n = NGHTTP2_ERR_WOULDBLOCK;
+        /* Only flush for static content or on last (zero-length) chunk */
+        if (flags & COMPRESS_END) flush = Z_FINISH;
+        else flush = Z_NO_FLUSH;
     }
 
-    syslog(LOG_DEBUG,
-           "http2_recv_cb(%zu): n = %zd, eof = %d, err = '%s', errno = %d",
-           length, n, pin->eof, pin->error ? pin->error : "", errno);
-
-    return n;
-}
+    zstrm->next_in = (Bytef *) buf;
+    zstrm->avail_in = len;
 
-static ssize_t http2_data_source_read_cb(nghttp2_session *session __attribute__((unused)),
-                                         int32_t stream_id,
-                                         uint8_t *buf, size_t length,
-                                         uint32_t *data_flags,
-                                         nghttp2_data_source *source,
-                                         void *user_data __attribute__((unused)))
-{
-    struct protstream *s = source->ptr;
-    size_t n = prot_read(s, (char *) buf, length);
+    buf_ensure(&txn->zbuf, deflateBound(zstrm, zstrm->avail_in));
+    buf_reset(&txn->zbuf);
 
-    syslog(LOG_DEBUG,
-           "http2_data_source_read_cb(id=%d, len=%zu): n=%zu, eof=%d",
-           stream_id, length, n, !s->cnt);
+    do {
+        int zr;
 
-    if (!s->cnt) *data_flags |= NGHTTP2_DATA_FLAG_EOF;
+        if (!zstrm->avail_out) {
+            unsigned pending;
 
-    return n;
-}
-
-static int http2_begin_headers_cb(nghttp2_session *session,
-                                  const nghttp2_frame *frame, void *user_data)
-{
-    if (frame->hd.type != NGHTTP2_HEADERS ||
-        frame->headers.cat != NGHTTP2_HCAT_REQUEST) {
-        return 0;
-    }
+            zr = deflatePending(zstrm, &pending, Z_NULL);
+            if (zr != Z_OK) {
+                /* something went wrong */
+                syslog(LOG_ERR, "zlib deflate error: %d %s", zr, zstrm->msg);
+                return -1;
+            }
 
-    syslog(LOG_DEBUG, "http2_begin_headers_cb(id=%d, type=%d)",
-           frame->hd.stream_id, frame->hd.type);
+            buf_ensure(&txn->zbuf, pending);
+        }
 
-    struct transaction_t *txn = xzmalloc(sizeof(struct transaction_t));
+        zstrm->next_out = (Bytef *) txn->zbuf.s + txn->zbuf.len;
+        zstrm->avail_out = txn->zbuf.alloc - txn->zbuf.len;
 
-    txn->conn = (struct http_connection *) user_data;
-    txn->http2.stream_id = frame->hd.stream_id;
-    txn->meth = METH_UNKNOWN;
-    txn->flags.ver = VER_2;
-    txn->flags.vary = VARY_AE;
-    txn->req_line.ver = HTTP2_VERSION;
+        zr = deflate(zstrm, flush);
+        if (!(zr == Z_OK || zr == Z_STREAM_END || zr == Z_BUF_ERROR)) {
+            /* something went wrong */
+            syslog(LOG_ERR, "zlib deflate error: %d %s", zr, zstrm->msg);
+            return -1;
+        }
 
-    /* Create header cache */
-    if (!(txn->req_hdrs = spool_new_hdrcache())) {
-        syslog(LOG_ERR, "Unable to create header cache");
-        return NGHTTP2_ERR_CALLBACK_FAILURE;
-    }
+        txn->zbuf.len = txn->zbuf.alloc - zstrm->avail_out;
 
-    nghttp2_session_set_stream_user_data(session, frame->hd.stream_id, txn);
+    } while (!zstrm->avail_out);
 
     return 0;
 }
 
-static int http2_header_cb(nghttp2_session *session,
-                           const nghttp2_frame *frame,
-                           const uint8_t *name, size_t namelen,
-                           const uint8_t *value, size_t valuelen,
-                           uint8_t flags __attribute__((unused)),
-                           void *user_data __attribute__((unused)))
+static void zlib_done(z_stream *zstrm)
 {
-    if (frame->hd.type != NGHTTP2_HEADERS ||
-        frame->headers.cat != NGHTTP2_HCAT_REQUEST) {
-        return 0;
+    if (zstrm) {
+        deflateEnd(zstrm);
+        free(zstrm);
     }
+}
+#else /* !HAVE_ZLIB */
 
-    char *my_name, *my_value;
-    struct transaction_t *txn =
-        nghttp2_session_get_stream_user_data(session, frame->hd.stream_id);
+HIDDEN void *zlib_init() { return NULL; }
 
-    if (!txn) return 0;
+HIDDEN int zlib_compress(struct transaction_t *txn __attribute__((unused)),
+                         unsigned flags __attribute__((unused)),
+                         const char *buf __attribute__((unused)),
+                         unsigned len __attribute__((unused)))
+{
+    fatal("Compression requested, but no zlib", EX_SOFTWARE);
+}
 
-    my_name = xstrndup((const char *) name, namelen);
-    my_value = xstrndup((const char *) value, valuelen);
+static void zlib_done(void *zstrm __attribute__((unused))) { }
 
-    syslog(LOG_DEBUG, "http2_header_cb(%s: %s)", my_name, my_value);
+#endif /* HAVE_ZLIB */
 
-    if (my_name[0] == ':') {
-        switch (my_name[1]) {
-        case 'm': /* :method */
-            if (!strcmp("ethod", my_name+2)) txn->req_line.meth = my_value;
-            break;
 
-        case 's': /* :scheme */
-            break;
+#ifdef HAVE_BROTLI
+#include <brotli/encode.h>
 
-        case 'a': /* :authority */
-            break;
+HIDDEN void *brotli_init()
+{
+    BrotliEncoderState *brotli = BrotliEncoderCreateInstance(NULL, NULL, NULL);
 
-        case 'p': /* :path */
-            if (!strcmp("ath", my_name+2)) txn->req_line.uri = my_value;
-            break;
-        }
+    if (brotli) {
+        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_MODE,
+                                  BROTLI_DEFAULT_MODE);
+        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_QUALITY,
+                                  BROTLI_DEFAULT_QUALITY);
+        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_LGWIN,
+                                  BROTLI_DEFAULT_WINDOW);
+        BrotliEncoderSetParameter(brotli, BROTLI_PARAM_LGBLOCK,
+                                  BROTLI_MAX_INPUT_BLOCK_BITS);
     }
 
-    spool_cache_header(my_name, my_value, txn->req_hdrs);
-
-    return 0;
+    return brotli;
 }
 
-static int http2_data_chunk_recv_cb(nghttp2_session *session,
-                                    uint8_t flags __attribute__((unused)),
-                                    int32_t stream_id,
-                                    const uint8_t *data, size_t len,
-                                    void *user_data __attribute__((unused)))
-{
-    struct transaction_t *txn =
-        nghttp2_session_get_stream_user_data(session, stream_id);
-
-    if (!txn) return 0;
-
-    syslog(LOG_DEBUG, "http2_data_chunk_recv_cb(id=%d, len=%zu, txnflags=%#x)",
-           stream_id, len, txn->req_body.flags);
-
-    if (txn->req_body.flags & BODY_DISCARD) return 0;
-
-    if (len) {
-        txn->req_body.framing = FRAMING_HTTP2;
-        txn->req_body.len += len;
-        buf_appendmap(&txn->req_body.payload, (const char *) data, len);
+static int brotli_compress(struct transaction_t *txn,
+                           unsigned flags, const char *buf, unsigned len)
+{
+    /* Only flush for static content or on last (zero-length) chunk */
+    unsigned op = (flags & COMPRESS_END) ?
+        BROTLI_OPERATION_FINISH : BROTLI_OPERATION_FLUSH;
+    BrotliEncoderState *brotli = txn->brotli;
+    const uint8_t *next_in = (const uint8_t *) buf;
+    size_t avail_in = (size_t) len;
+
+    buf_ensure(&txn->zbuf, BrotliEncoderMaxCompressedSize(avail_in));
+    buf_reset(&txn->zbuf);
+
+    do {
+        uint8_t *next_out = (uint8_t *) txn->zbuf.s + txn->zbuf.len;
+        size_t avail_out = txn->zbuf.alloc - txn->zbuf.len;
+
+        if (!BrotliEncoderCompressStream(brotli, op,
+                                         &avail_in, &next_in,
+                                         &avail_out, &next_out, NULL)) {
+            syslog(LOG_ERR, "Brotli: Error while compressing data");
+            return -1;
+        }
+
+        txn->zbuf.len = txn->zbuf.alloc - avail_out;
+    } while (avail_in || BrotliEncoderHasMoreOutput(brotli));
+
+    if (BrotliEncoderIsFinished(brotli)) {
+        BrotliEncoderDestroyInstance(brotli);
+        txn->brotli = brotli_init();
     }
 
     return 0;
 }
 
-static int examine_request(struct transaction_t *txn);
+static void brotli_done(BrotliEncoderState *brotli)
+{
+    if (brotli) BrotliEncoderDestroyInstance(brotli);
+}
 
-static int client_need_auth(struct transaction_t *txn, int sasl_result);
+#else /* !HAVE_BROTLI */
 
-static void transaction_free(struct transaction_t *txn);
+HIDDEN void *brotli_init() { return NULL; }
 
-static int http2_frame_recv_cb(nghttp2_session *session,
-                               const nghttp2_frame *frame,
-                               void *user_data __attribute__((unused)))
+static int brotli_compress(struct transaction_t *txn __attribute__((unused)),
+                           unsigned flags __attribute__((unused)),
+                           const char *buf __attribute__((unused)),
+                           unsigned len __attribute__((unused)))
 {
-    int ret = 0;
-    struct transaction_t *txn =
-        nghttp2_session_get_stream_user_data(session, frame->hd.stream_id);
+    fatal("Brotli Compression requested, but not available", EX_SOFTWARE);
+}
 
-    if (!txn) return 0;
+static void brotli_done(void *brotli __attribute__((unused))) {}
 
-    syslog(LOG_DEBUG, "http2_frame_recv_cb(id=%d, type=%d, flags=%#x",
-           frame->hd.stream_id, frame->hd.type, frame->hd.flags);
+#endif /* HAVE_BROTLI */
 
-    switch (frame->hd.type) {
-    case NGHTTP2_HEADERS:
-        if (frame->headers.cat == NGHTTP2_HCAT_REQUEST) {
-            /* Examine request */
-            ret = examine_request(txn);
-
-            if (ret) {
-                txn->req_body.flags |= BODY_DISCARD;
-                error_response(ret, txn);
-                break;
-            }
 
-            if (txn->req_body.flags & BODY_CONTINUE) {
-                txn->req_body.flags &= ~BODY_CONTINUE;
-                response_header(HTTP_CONTINUE, txn);
-                break;
-            }
-        }
-
-        GCC_FALLTHROUGH
+#ifdef HAVE_ZSTD
+#include <zstd.h>
+#include <zstd_errors.h>
 
-    case NGHTTP2_DATA:
-        /* Check that the client request has finished */
-        if (!(frame->hd.flags & NGHTTP2_FLAG_END_STREAM)) break;
+HIDDEN void *zstd_init()
+{
+    ZSTD_CCtx *cctx = ZSTD_createCCtx();
 
-        /* Check that we still want to process the request */
-        if (txn->req_body.flags & BODY_DISCARD) break;
+    if (cctx) {
+        ZSTD_CCtx_setParameter(cctx, ZSTD_c_compressionLevel,
+                               ZSTD_CLEVEL_DEFAULT);
+        ZSTD_CCtx_setParameter(cctx, ZSTD_c_checksumFlag, 1);
+    }
 
-        /* Process the requested method */
-        if (txn->req_tgt.namespace->premethod) {
-            ret = txn->req_tgt.namespace->premethod(txn);
-        }
-        if (!ret) {
-            const struct method_t *meth_t =
-                &txn->req_tgt.namespace->methods[txn->meth];
+    return cctx;
+}
 
-            ret = (*meth_t->proc)(txn, meth_t->params);
-        }
+static int zstd_compress(struct transaction_t *txn,
+                         unsigned flags, const char *buf, unsigned len)
+{
+    /* Only flush for static content or on last (zero-length) chunk */
+    ZSTD_EndDirective mode = (flags & COMPRESS_END) ? ZSTD_e_end : ZSTD_e_flush;
+    ZSTD_inBuffer input = { buf, len, 0 };
+    ZSTD_CCtx *cctx = txn->zstd;
+    size_t remaining;
 
-        if (ret == HTTP_UNAUTHORIZED) {
-            /* User must authenticate */
-            ret = client_need_auth(txn, 0);
-        }
+    if (flags & COMPRESS_START) ZSTD_CCtx_reset(cctx, ZSTD_reset_session_only);
 
-        /* Handle errors (success responses handled by method functions) */
-        if (ret) error_response(ret, txn);
+    buf_ensure(&txn->zbuf, ZSTD_compressBound(len));
+    buf_reset(&txn->zbuf);
 
-        if (txn->flags.conn & CONN_CLOSE) {
-            syslog(LOG_DEBUG, "nghttp2_submit_goaway()");
+    ZSTD_outBuffer output = { txn->zbuf.s, txn->zbuf.alloc, 0 };
+    do {
+        remaining = ZSTD_compressStream2(cctx, &output, &input, mode);
 
-            nghttp2_submit_goaway(session, NGHTTP2_FLAG_NONE,
-                                  nghttp2_session_get_last_proc_stream_id(
-                                      txn->conn->http2_session),
-                                  NGHTTP2_NO_ERROR, NULL, 0);
+        if (ZSTD_isError(remaining)) {
+            syslog(LOG_ERR, "Zstandard: %s",
+                   ZSTD_getErrorString(ZSTD_getErrorCode(remaining)));
+            return -1;
         }
+    } while (remaining || (input.pos != input.size));
 
-        break;
-    }
+    buf_truncate(&txn->zbuf, output.pos);
 
     return 0;
 }
 
-static int http2_stream_close_cb(nghttp2_session *session, int32_t stream_id,
-                                 uint32_t error_code __attribute__((unused)),
-                                 void *user_data __attribute__((unused)))
+static void zstd_done(ZSTD_CCtx *cctx)
 {
-    struct transaction_t *txn =
-        nghttp2_session_get_stream_user_data(session, stream_id);
+    if (cctx) ZSTD_freeCCtx(cctx);
+}
 
-    syslog(LOG_DEBUG, "http2_stream_close_cb(id=%d)", stream_id);
+#else /* !HAVE_ZSTD */
 
-    if (txn) {
-        /* Memory cleanup */
-        transaction_free(txn);
-        free(txn);
-    }
-            
-    return 0;
+HIDDEN void *zstd_init() { return NULL; }
+
+static int zstd_compress(struct transaction_t *txn __attribute__((unused)),
+                           unsigned flags __attribute__((unused)),
+                           const char *buf __attribute__((unused)),
+                           unsigned len __attribute__((unused)))
+{
+    fatal("Zstandard Compression requested, but not available", EX_SOFTWARE);
 }
 
-static int http2_frame_not_send_cb(nghttp2_session *session,
-                                   const nghttp2_frame *frame,
-                                   int lib_error_code,
-                                   void *user_data __attribute__((unused)))
-{
-    syslog(LOG_DEBUG, "http2_frame_not_send_cb(id=%d)", frame->hd.stream_id);
-
-    /* Issue RST_STREAM so that stream does not hang around. */
-    nghttp2_submit_rst_stream(session, NGHTTP2_FLAG_NONE,
-                              frame->hd.stream_id, lib_error_code);
+static void zstd_done(void *brotli __attribute__((unused))) {}
 
-    return 0;
-}
+#endif /* HAVE_ZSTD */
 
 
-static int starthttp2(struct http_connection *conn, struct transaction_t *txn)
-{
-    int r;
-    nghttp2_settings_entry iv =
-        { NGHTTP2_SETTINGS_MAX_CONCURRENT_STREAMS, 100 };
-
-    r = nghttp2_session_server_new2(&conn->http2_session,
-                                    http2_callbacks, conn, conn->http2_options);
-    if (r) {
-        syslog(LOG_WARNING,
-               "nghttp2_session_server_new: %s", nghttp2_strerror(r));
-        return r;
-    }
-
-    if (txn && txn->flags.conn & CONN_UPGRADE) {
-        const char **hdr = spool_getheader(txn->req_hdrs, "HTTP2-Settings");
-        if (!hdr || hdr[1]) return 0;
-
-        /* base64url decode the settings.
-           Use the SASL base64 decoder after replacing the encoded values
-           for chars 62 and 63 and adding appropriate padding. */
-        unsigned outlen;
-        struct buf buf;
-        buf_init_ro_cstr(&buf, hdr[0]);
-        buf_replace_char(&buf, '-', '+');
-        buf_replace_char(&buf, '_', '/');
-        buf_appendmap(&buf, "==", (4 - (buf_len(&buf) % 4)) % 4);
-        r = sasl_decode64(buf_base(&buf), buf_len(&buf),
-                          (char *) buf_base(&buf), buf_len(&buf), &outlen);
-        if (r != SASL_OK) {
-            syslog(LOG_WARNING, "sasl_decode64 failed: %s",
-                   sasl_errstring(r, NULL, NULL));
-            buf_free(&buf);
-            return r;
-        }
-        r = nghttp2_session_upgrade2(conn->http2_session,
-                                     (const uint8_t *) buf_base(&buf),
-                                     outlen, txn->meth == METH_HEAD, NULL);
-        buf_free(&buf);
-        if (r) {
-            syslog(LOG_WARNING, "nghttp2_session_upgrade: %s",
-                   nghttp2_strerror(r));
-            return r;
-        }
+static const char tls_message[] =
+    HTML_DOCTYPE
+    "<html>\n<head>\n<title>TLS Required</title>\n</head>\n" \
+    "<body>\n<h2>TLS is required prior to authentication</h2>\n" \
+    "Use <a href=\"%s\">%s</a> instead.\n" \
+    "</body>\n</html>\n";
 
-        /* tell client to start h2c upgrade (RFC 7540) */
-        response_header(HTTP_SWITCH_PROT, txn);
+extern int optind;
+extern char *optarg;
+extern int opterr;
 
-        txn->flags.ver = VER_2;
-        txn->http2.stream_id =
-            nghttp2_session_get_last_proc_stream_id(conn->http2_session);
-    }
+sasl_conn_t *httpd_saslconn; /* the sasl connection context */
 
-    r = nghttp2_submit_settings(conn->http2_session, NGHTTP2_FLAG_NONE, &iv, 1);
-    if (r) {
-        syslog(LOG_ERR, "nghttp2_submit_settings: %s", nghttp2_strerror(r));
-        return r;
-    }
+static struct wildmat *allow_cors = NULL;
+int httpd_timeout, httpd_keepalive;
+char *httpd_authid = NULL;
+char *httpd_userid = NULL;
+char *httpd_extrafolder = NULL;
+char *httpd_extradomain = NULL;
+struct auth_state *httpd_authstate = 0;
+int httpd_userisadmin = 0;
+int httpd_userisproxyadmin = 0;
+int httpd_userisanonymous = 1;
+const char *httpd_localip = NULL, *httpd_remoteip = NULL;
+struct protstream *httpd_out = NULL;
+struct protstream *httpd_in = NULL;
+struct protgroup *protin = NULL;
 
-    return 0;
-}
-#else
-static int starthttp2(void *conn __attribute__((unused)),
-                      struct transaction_t *txn __attribute__((unused)))
-{
-    fatal("starthttp2() called, but no Nghttp2", EC_SOFTWARE);
-}
-#endif /* HAVE_NGHTTP2 */
+static sasl_ssf_t extprops_ssf = 0;
+int https = 0;
+int httpd_tls_required = 0;
+unsigned avail_auth_schemes = 0; /* bitmask of available auth schemes */
+unsigned long config_httpmodules;
+int config_httpprettytelemetry;
 
+static time_t compile_time;
+struct buf serverinfo = BUF_INITIALIZER;
 
-static void digest_send_success(struct transaction_t *txn,
-                                const char *name __attribute__((unused)),
-                                const char *data)
-{
-    simple_hdr(txn, "Authentication-Info", data);
-}
+int ignorequota = 0;
+int apns_enabled = 0;
 
 /* List of HTTP auth schemes that we support */
 struct auth_scheme_t auth_schemes[] = {
-    { AUTH_BASIC, "Basic", NULL, AUTH_SERVER_FIRST | AUTH_BASE64, NULL, NULL },
-    { AUTH_DIGEST, "Digest", HTTP_DIGEST_MECH, AUTH_NEED_REQUEST|AUTH_SERVER_FIRST,
-      &digest_send_success, digest_recv_success },
-    { AUTH_SPNEGO, "Negotiate", "GSS-SPNEGO", AUTH_BASE64, NULL, NULL },
-    { AUTH_NTLM, "NTLM", "NTLM", AUTH_NEED_PERSIST | AUTH_BASE64, NULL, NULL },
-    { AUTH_BEARER, "Bearer", NULL, AUTH_NEED_REQUEST|AUTH_SERVER_FIRST, NULL, NULL },
-    { -1, NULL, NULL, 0, NULL, NULL }
+      AUTH_SCHEME_BASIC,
+    { AUTH_SCRAM_SHA256, "SCRAM-SHA-256", "SCRAM-SHA-256",
+      AUTH_NEED_PERSIST | AUTH_SERVER_FIRST | AUTH_BASE64 |
+      AUTH_REALM_PARAM | AUTH_DATA_PARAM },
+    { AUTH_SCRAM_SHA1, "SCRAM-SHA-1", "SCRAM-SHA-1",
+      AUTH_NEED_PERSIST | AUTH_SERVER_FIRST | AUTH_BASE64 |
+      AUTH_REALM_PARAM | AUTH_DATA_PARAM },
+    { AUTH_DIGEST, "Digest", HTTP_DIGEST_MECH,
+      AUTH_NEED_REQUEST | AUTH_SERVER_FIRST },
+    { AUTH_SPNEGO, "Negotiate", "GSS-SPNEGO",
+      AUTH_BASE64 | AUTH_SUCCESS_WWW },
+    { AUTH_NTLM, "NTLM", "NTLM",
+      AUTH_NEED_PERSIST | AUTH_BASE64 },
+    { AUTH_BEARER, "Bearer", NULL,
+      AUTH_SERVER_FIRST | AUTH_REALM_PARAM },
+    { 0, NULL, NULL, 0 }
 };
 
 
@@ -599,7 +441,7 @@ struct backend **backend_cached = NULL;
 
 /* end PROXY stuff */
 
-static int starttls(struct transaction_t *txn, int *http2);
+static int starttls(struct transaction_t *txn, struct http_connection *conn);
 void usage(void);
 void shut_down(int code) __attribute__ ((noreturn));
 
@@ -612,19 +454,13 @@ static int parse_connection(struct trans
 static int parse_ranges(const char *hdr, unsigned long len,
                         struct range **ranges);
 static int proxy_authz(const char **authzid, struct transaction_t *txn);
-static void auth_success(struct transaction_t *txn, const char *userid);
+static int auth_success(struct transaction_t *txn, const char *userid);
 static int http_auth(const char *creds, struct transaction_t *txn);
 
 static int meth_get(struct transaction_t *txn, void *params);
 static int meth_propfind_root(struct transaction_t *txn, void *params);
 
-
-static struct {
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 static struct sasl_callback mysasl_cb[] = {
     { SASL_CB_GETOPT, (mysasl_cb_ft *) &mysasl_config, NULL },
@@ -635,32 +471,41 @@ static struct sasl_callback mysasl_cb[]
 
 /* Array of HTTP methods known by our server. */
 const struct known_meth_t http_methods[] = {
-    { "ACL",            0 },
-    { "BIND",           0 },
-    { "COPY",           METH_NOBODY },
-    { "DELETE",         METH_NOBODY },
-    { "GET",            METH_NOBODY },
-    { "HEAD",           METH_NOBODY },
-    { "LOCK",           0 },
-    { "MKCALENDAR",     0 },
-    { "MKCOL",          0 },
-    { "MOVE",           METH_NOBODY },
-    { "OPTIONS",        METH_NOBODY },
-    { "PATCH",          0 },
-    { "POST",           0 },
-    { "PROPFIND",       0 },
-    { "PROPPATCH",      0 },
-    { "PUT",            0 },
-    { "REPORT",         0 },
-    { "TRACE",          METH_NOBODY },
-    { "UNBIND",         0 },
-    { "UNLOCK",         METH_NOBODY },
-    { NULL,             0 }
+    { "ACL",            0,              CYRUS_HTTP_ACL_TOTAL },
+    { "BIND",           0,              CYRUS_HTTP_BIND_TOTAL },
+    { "CONNECT",        METH_NOBODY,    CYRUS_HTTP_CONNECT_TOTAL },
+    { "COPY",           METH_NOBODY,    CYRUS_HTTP_COPY_TOTAL },
+    { "DELETE",         METH_NOBODY,    CYRUS_HTTP_DELETE_TOTAL },
+    { "GET",            METH_NOBODY,    CYRUS_HTTP_GET_TOTAL },
+    { "HEAD",           METH_NOBODY,    CYRUS_HTTP_HEAD_TOTAL },
+    { "LOCK",           0,              CYRUS_HTTP_LOCK_TOTAL },
+    { "MKCALENDAR",     0,              CYRUS_HTTP_MKCALENDAR_TOTAL },
+    { "MKCOL",          0,              CYRUS_HTTP_MKCOL_TOTAL },
+    { "MOVE",           METH_NOBODY,    CYRUS_HTTP_MOVE_TOTAL },
+    { "OPTIONS",        METH_NOBODY,    CYRUS_HTTP_OPTIONS_TOTAL },
+    { "PATCH",          0,              CYRUS_HTTP_PATCH_TOTAL },
+    { "POST",           0,              CYRUS_HTTP_POST_TOTAL },
+    { "PROPFIND",       0,              CYRUS_HTTP_PROPFIND_TOTAL },
+    { "PROPPATCH",      0,              CYRUS_HTTP_PROPPATCH_TOTAL },
+    { "PUT",            0,              CYRUS_HTTP_PUT_TOTAL },
+    { "REPORT",         0,              CYRUS_HTTP_REPORT_TOTAL },
+    { "TRACE",          METH_NOBODY,    CYRUS_HTTP_TRACE_TOTAL },
+    { "UNBIND",         0,              CYRUS_HTTP_UNBIND_TOTAL },
+    { "UNLOCK",         METH_NOBODY,    CYRUS_HTTP_UNLOCK_TOTAL },
+    { NULL,             0,              0 }
+};
+
+/* WebSocket handler */
+static int ws_echo(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf, void **rock);
+
+static struct connect_params ws_params = {
+    "/", NULL /* sub-protocol */, &ws_echo
 };
 
 /* Namespace to fetch static content from filesystem */
 struct namespace_t namespace_default = {
-    URL_NS_DEFAULT, 1, "", NULL,
+    URL_NS_DEFAULT, 1, "default", "", NULL,
     http_allow_noauth, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -668,6 +513,7 @@ struct namespace_t namespace_default = {
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { &meth_connect,        &ws_params },           /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get,            NULL },                 /* GET          */
@@ -690,7 +536,10 @@ struct namespace_t namespace_default = {
 };
 
 /* Array of different namespaces and features supported by the server */
-struct namespace_t *namespaces[] = {
+struct namespace_t *http_namespaces[] = {
+#ifdef WITH_JMAP
+    &namespace_jmap,
+#endif
     &namespace_tzdist,          /* MUST be before namespace_calendar!! */
 #ifdef WITH_DAV
     &namespace_calendar,
@@ -700,29 +549,29 @@ struct namespace_t *namespaces[] = {
     &namespace_principal,       /* MUST be after namespace_cal & addr & drive */
     &namespace_notify,          /* MUST be after namespace_principal */
     &namespace_applepush,       /* MUST be after namespace_cal & addr */
-#ifdef HAVE_IANA_PARAMS
     &namespace_ischedule,
     &namespace_domainkey,
-#endif /* HAVE_IANA_PARAMS */
 #endif /* WITH_DAV */
     &namespace_rss,
     &namespace_dblookup,
     &namespace_admin,
+    &namespace_prometheus,
+    &namespace_cgi,
     &namespace_default,         /* MUST be present and be last!! */
     NULL,
 };
 
 
-static void httpd_reset(void)
+static void httpd_reset(struct http_connection *conn)
 {
     int i;
     int bytes_in = 0;
     int bytes_out = 0;
 
     /* Do any namespace specific cleanup */
-    for (i = 0; namespaces[i]; i++) {
-        if (namespaces[i]->enabled && namespaces[i]->reset)
-            namespaces[i]->reset();
+    for (i = 0; http_namespaces[i]; i++) {
+        if (http_namespaces[i]->enabled && http_namespaces[i]->reset)
+            http_namespaces[i]->reset();
     }
 
     /* Reset available authentication schemes */
@@ -742,6 +591,8 @@ static void httpd_reset(void)
     backend_cached = NULL;
     backend_current = NULL;
 
+    index_text_extractor_destroy();
+
     if (httpd_in) {
         prot_NONBLOCK(httpd_in);
         prot_fill(httpd_in);
@@ -766,18 +617,27 @@ static void httpd_reset(void)
     if (protin) protgroup_reset(protin);
 
 #ifdef HAVE_SSL
-    if (tls_conn) {
-        tls_reset_servertls(&tls_conn);
-        tls_conn = NULL;
+    if (conn->tls_ctx) {
+        tls_reset_servertls((SSL **) &conn->tls_ctx);
+        conn->tls_ctx = NULL;
     }
 #endif
 
+    xmlFreeParserCtxt(conn->xml);
+
+    http2_end_session(conn->sess_ctx);
+
     cyrus_reset_stdio();
 
-    httpd_clienthost = "[local]";
-    if (httpd_logfd != -1) {
-        close(httpd_logfd);
-        httpd_logfd = -1;
+    conn->clienthost = "[local]";
+    buf_free(&conn->logbuf);
+    if (conn->logfd != -1) {
+        close(conn->logfd);
+        conn->logfd = -1;
+    }
+    if (httpd_authid != NULL) {
+        free(httpd_authid);
+        httpd_authid = NULL;
     }
     if (httpd_userid != NULL) {
         free(httpd_userid);
@@ -800,21 +660,8 @@ static void httpd_reset(void)
         sasl_dispose(&httpd_saslconn);
         httpd_saslconn = NULL;
     }
-    httpd_tls_done = 0;
 
-    if(saslprops.iplocalport) {
-       free(saslprops.iplocalport);
-       saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-       free(saslprops.ipremoteport);
-       saslprops.ipremoteport = NULL;
-    }
-    if(saslprops.authid) {
-       free(saslprops.authid);
-       saslprops.authid = NULL;
-    }
-    saslprops.ssf = 0;
+    saslprops_reset(&saslprops);
 
     session_new_id();
 }
@@ -829,12 +676,12 @@ int service_init(int argc __attribute__(
 {
     int r, events, opt, i;
     int allow_trace = config_getswitch(IMAPOPT_HTTPALLOWTRACE);
+    unsigned long version;
+    unsigned int status, patch, fix, minor, major;
 
     LIBXML_TEST_VERSION
 
-    initialize_http_error_table();
-
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -844,28 +691,12 @@ int service_init(int argc __attribute__(
     /* load the SASL plugins */
     global_sasl_init(1, 1, mysasl_cb);
 
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for expunge */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* open the user deny db */
-    denydb_init(0);
-    denydb_open(/*create*/0);
-
-    /* open annotations.db, we'll need it for collection properties */
-    annotatemore_open();
-
     /* setup for sending IMAP IDLE notifications */
     idle_enabled();
 
     /* Set namespace */
     if ((r = mboxname_init_namespace(&httpd_namespace, 1)) != 0) {
-        syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     /* open the mboxevent system */
@@ -879,9 +710,8 @@ int service_init(int argc __attribute__(
         case 's': /* https (do TLS right away) */
             https = 1;
             if (!tls_enabled()) {
-                syslog(LOG_ERR, "https: required OpenSSL options not present");
                 fatal("https: required OpenSSL options not present",
-                      EC_CONFIG);
+                      EX_CONFIG);
             }
             break;
 
@@ -910,60 +740,59 @@ int service_init(int argc __attribute__(
     }
 
     /* Construct serverinfo string */
-    buf_printf(&serverinfo, "Cyrus-HTTP/%s Cyrus-SASL/%u.%u.%u",
-               cyrus_version(),
-               SASL_VERSION_MAJOR, SASL_VERSION_MINOR, SASL_VERSION_STEP);
-#ifdef HAVE_SSL
-    buf_printf(&serverinfo, " OpenSSL/%s", SHLIB_VERSION_NUMBER);
-#endif
+    buf_printf(&serverinfo,
+               "Cyrus-HTTP/%s Cyrus-SASL/%u.%u.%u Lib/XML%s Jansson/%s",
+               CYRUS_VERSION,
+               SASL_VERSION_MAJOR, SASL_VERSION_MINOR, SASL_VERSION_STEP,
+               LIBXML_DOTTED_VERSION, JANSSON_VERSION);
 
-#ifdef HAVE_NGHTTP2
-    buf_printf(&serverinfo, " Nghttp2/%s", NGHTTP2_VERSION);
+    http2_init(&serverinfo);
+    ws_init(&serverinfo);
 
-    /* Setup HTTP/2 callbacks */
-    if ((r = nghttp2_session_callbacks_new(&http2_callbacks))) {
-        syslog(LOG_WARNING,
-               "nghttp2_session_callbacks_new: %s", nghttp2_strerror(r));
-    }
-    else {
-        nghttp2_session_callbacks_set_send_callback(http2_callbacks,
-                                                    &http2_send_cb);
-        nghttp2_session_callbacks_set_recv_callback(http2_callbacks,
-                                                    &http2_recv_cb);
-        nghttp2_session_callbacks_set_on_begin_headers_callback(http2_callbacks,
-                                                                &http2_begin_headers_cb);
-        nghttp2_session_callbacks_set_on_header_callback(http2_callbacks,
-                                                         http2_header_cb);
-        nghttp2_session_callbacks_set_on_data_chunk_recv_callback(http2_callbacks,
-                                                                  http2_data_chunk_recv_cb);
-        nghttp2_session_callbacks_set_on_frame_recv_callback(http2_callbacks,
-                                                             http2_frame_recv_cb);
-        nghttp2_session_callbacks_set_on_stream_close_callback(http2_callbacks,
-                                                               &http2_stream_close_cb);
-        nghttp2_session_callbacks_set_on_frame_not_send_callback(http2_callbacks,
-                                                                 &http2_frame_not_send_cb);
-    }
-#endif /* HAVE_NGHTTP2 */
+#ifdef HAVE_SSL
+    version = OPENSSL_VERSION_NUMBER;
+    status  = version & 0x0f; version >>= 4;
+    patch   = version & 0xff; version >>= 8;
+    fix     = version & 0xff; version >>= 8;
+    minor   = version & 0xff; version >>= 8;
+    major   = version & 0xff;
+    
+    buf_printf(&serverinfo, " OpenSSL/%u.%u.%u", major, minor, fix);
+
+    if (status == 0) buf_appendcstr(&serverinfo, "-dev");
+    else if (status < 15) buf_printf(&serverinfo, "-beta%u", status);
+    else if (patch) buf_putc(&serverinfo, patch + 'a' - 1);
+#endif
 
 #ifdef HAVE_ZLIB
     buf_printf(&serverinfo, " Zlib/%s", ZLIB_VERSION);
 #endif
 #ifdef HAVE_BROTLI
-    uint32_t version = BrotliEncoderVersion();
-    buf_printf(&serverinfo, " Brotli/%u.%u.%u",
-               (version >> 24) & 0xfff, (version >> 12) & 0xfff, version & 0xfff);
+    version = BrotliEncoderVersion();
+    fix     = version & 0xfff; version >>= 12;
+    minor   = version & 0xfff; version >>= 12;
+    major   = version & 0xfff;
+
+    buf_printf(&serverinfo, " Brotli/%u.%u.%u", major, minor, fix);
+#endif
+#ifdef HAVE_ZSTD
+    buf_printf(&serverinfo, " Zstd/%s", ZSTD_versionString());
 #endif
-    buf_printf(&serverinfo, " LibXML/%s", LIBXML_DOTTED_VERSION);
+
+    /* Initialize libical */
+    ical_support_init();
 
     /* Do any namespace specific initialization */
     config_httpmodules = config_getbitfield(IMAPOPT_HTTPMODULES);
-    for (i = 0; namespaces[i]; i++) {
-        if (allow_trace) namespaces[i]->allow |= ALLOW_TRACE;
-        if (namespaces[i]->init) namespaces[i]->init(&serverinfo);
+    for (i = 0; http_namespaces[i]; i++) {
+        if (allow_trace) http_namespaces[i]->allow |= ALLOW_TRACE;
+        if (http_namespaces[i]->init) http_namespaces[i]->init(&serverinfo);
     }
 
     compile_time = calc_compile_time(__TIME__, __DATE__);
 
+    prometheus_increment(CYRUS_HTTP_READY_LISTENERS);
+
     return 0;
 }
 
@@ -990,23 +819,41 @@ int service_main(int argc __attribute__(
     struct auth_scheme_t *scheme;
     struct http_connection http_conn;
 
+    prometheus_decrement(CYRUS_HTTP_READY_LISTENERS);
+
     session_new_id();
 
     signals_poll();
 
-    sync_log_init();
-
     httpd_in = prot_new(0, 0);
     httpd_out = prot_new(1, 1);
     protgroup_insert(protin, httpd_in);
 
+    /* Setup HTTP connection */
+    memset(&http_conn, 0, sizeof(struct http_connection));
+    http_conn.pin = httpd_in;
+    http_conn.pout = httpd_out;
+    http_conn.logfd = -1;
+
+    /* Create XML parser context */
+    if (!(http_conn.xml = xmlNewParserCtxt())) {
+        fatal("Unable to create XML parser", EX_TEMPFAIL);
+    }
+
     /* Find out name of client host */
-    httpd_clienthost = get_clienthost(0, &httpd_localip, &httpd_remoteip);
+    http_conn.clienthost = get_clienthost(0, &httpd_localip, &httpd_remoteip);
+
+    if (httpd_localip && httpd_remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, httpd_remoteip);
+        buf_setcstr(&saslprops.iplocalport, httpd_localip);
+    }
 
     /* other params should be filled in */
-    if (sasl_server_new("HTTP", config_servername, NULL, NULL, NULL, NULL,
-                        SASL_USAGE_FLAGS, &httpd_saslconn) != SASL_OK)
-        fatal("SASL failed initializing: sasl_server_new()",EC_TEMPFAIL);
+    if (sasl_server_new("HTTP", config_servername, NULL,
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                        NULL, SASL_USAGE_FLAGS, &httpd_saslconn) != SASL_OK)
+        fatal("SASL failed initializing: sasl_server_new()",EX_TEMPFAIL);
 
     /* will always return something valid */
     secprops = mysasl_secprops(0);
@@ -1015,31 +862,23 @@ int service_main(int argc __attribute__(
     secprops->max_ssf = 0;                              /* "auth" only */
     secprops->maxbufsize = 0;                           /* don't need maxbuf */
     if (sasl_setprop(httpd_saslconn, SASL_SEC_PROPS, secprops) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
     if (sasl_setprop(httpd_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
-
-    if (httpd_localip) {
-        sasl_setprop(httpd_saslconn, SASL_IPLOCALPORT, httpd_localip);
-        saslprops.iplocalport = xstrdup(httpd_localip);
-    }
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
 
     if (httpd_remoteip) {
         char hbuf[NI_MAXHOST], *p;
 
-        sasl_setprop(httpd_saslconn, SASL_IPREMOTEPORT, httpd_remoteip);
-        saslprops.ipremoteport = xstrdup(httpd_remoteip);
-
         /* Create pre-authentication telemetry log based on client IP */
         strlcpy(hbuf, httpd_remoteip, NI_MAXHOST);
         if ((p = strchr(hbuf, ';'))) *p = '\0';
-        httpd_logfd = telemetry_log(hbuf, httpd_in, httpd_out, 0);
+        http_conn.logfd = telemetry_log(hbuf, httpd_in, httpd_out, 0);
     }
 
     /* See which auth schemes are available to us */
     avail_auth_schemes = 0; /* Reset auth schemes for each connection */
     if ((extprops_ssf >= 2) || config_getswitch(IMAPOPT_ALLOWPLAINTEXT)) {
-        avail_auth_schemes |= (1 << AUTH_BASIC);
+        avail_auth_schemes |=  AUTH_BASIC;
     }
     sasl_listmech(httpd_saslconn, NULL, NULL, " ", NULL,
                   &mechlist, NULL, &mechcount);
@@ -1047,7 +886,7 @@ int service_main(int argc __attribute__(
         mechlen = strcspn(mech, " \0");
         for (scheme = auth_schemes; scheme->name; scheme++) {
             if (scheme->saslmech && !strncmp(mech, scheme->saslmech, mechlen)) {
-                avail_auth_schemes |= (1 << scheme->idx);
+                avail_auth_schemes |= scheme->id;
                 break;
             }
         }
@@ -1055,32 +894,27 @@ int service_main(int argc __attribute__(
     httpd_tls_required =
         config_getswitch(IMAPOPT_TLS_REQUIRED) || !avail_auth_schemes;
 
-    proc_register(config_ident, httpd_clienthost, NULL, NULL, NULL);
+    proc_register(config_ident, http_conn.clienthost, NULL, NULL, NULL);
 
     /* Set inactivity timer */
-    httpd_timeout = config_getint(IMAPOPT_HTTPTIMEOUT);
+    httpd_timeout = config_getduration(IMAPOPT_HTTPTIMEOUT, 'm');
     if (httpd_timeout < 0) httpd_timeout = 0;
-    httpd_timeout *= 60;
     prot_settimeout(httpd_in, httpd_timeout);
     prot_setflushonread(httpd_in, httpd_out);
 
-    /* Setup HTTP connection */
-    memset(&http_conn, 0, sizeof(struct http_connection));
-    http_conn.pin = httpd_in;
-    http_conn.pout = httpd_out;
-
     /* we were connected on https port so we should do
-       TLS negotiation immediatly */
+       TLS negotiation immediately */
     if (https == 1) {
-        int r, http2 = 0;
-
-        r = starttls(NULL, &http2);
-        if (!r && http2) r = starthttp2(&http_conn, NULL);
-        if (r) shut_down(0);
+        if (starttls(NULL, &http_conn) != 0) shut_down(0);
+    }
+    else if (http2_preface(&http_conn)) {
+        /* HTTP/2 client connection preface */
+        if (http2_start_session(NULL, &http_conn) != 0)
+            fatal("Failed initializing HTTP/2 session", EX_TEMPFAIL);
     }
 
     /* Setup the signal handler for keepalive heartbeat */
-    httpd_keepalive = config_getint(IMAPOPT_HTTPKEEPALIVE);
+    httpd_keepalive = config_getduration(IMAPOPT_HTTPKEEPALIVE, 's');
     if (httpd_keepalive < 0) httpd_keepalive = 0;
     if (httpd_keepalive) {
         struct sigaction action;
@@ -1097,44 +931,22 @@ int service_main(int argc __attribute__(
         }
     }
 
-    if (config_getswitch(IMAPOPT_HTTPALLOWCOMPRESS)) {
-#ifdef HAVE_ZLIB
-        http_conn.zstrm = xzmalloc(sizeof(z_stream));
-        /* Always use gzip format because IE incorrectly uses raw deflate */
-        if (deflateInit2(http_conn.zstrm, Z_DEFAULT_COMPRESSION, Z_DEFLATED,
-                         16+MAX_WBITS /* gzip */,
-                         MAX_MEM_LEVEL, Z_DEFAULT_STRATEGY) != Z_OK) {
-            free(http_conn.zstrm);
-            http_conn.zstrm = NULL;
-        }
-#endif
-#ifdef HAVE_BROTLI
-        http_conn.brotli = brotli_init();
-#endif
-    }
+    index_text_extractor_init(httpd_in);
+
+    prometheus_increment(CYRUS_HTTP_CONNECTIONS_TOTAL);
+    prometheus_increment(CYRUS_HTTP_ACTIVE_CONNECTIONS);
 
     cmdloop(&http_conn);
 
+    prometheus_decrement(CYRUS_HTTP_ACTIVE_CONNECTIONS);
+
     /* Closing connection */
 
     /* cleanup */
     signal(SIGALRM, SIG_IGN);
-    httpd_reset();
+    httpd_reset(&http_conn);
 
-#ifdef HAVE_NGHTTP2
-    nghttp2_option_del(http_conn.http2_options);
-    nghttp2_session_del(http_conn.http2_session);
-#endif
-
-#ifdef HAVE_ZLIB
-    if (http_conn.zstrm) {
-        deflateEnd(http_conn.zstrm);
-        free(http_conn.zstrm);
-    }
-#endif
-#ifdef HAVE_BROTLI
-    if (http_conn.brotli) BrotliEncoderDestroyInstance(http_conn.brotli);
-#endif
+    prometheus_increment(CYRUS_HTTP_READY_LISTENERS);
 
     return 0;
 }
@@ -1152,7 +964,7 @@ void usage(void)
     prot_printf(httpd_out, "%s: usage: httpd [-C <alt_config>] [-s]\r\n",
                 error_message(HTTP_SERVER_ERROR));
     prot_flush(httpd_out);
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 
@@ -1170,9 +982,9 @@ void shut_down(int code)
     if (allow_cors) free_wildmats(allow_cors);
 
     /* Do any namespace specific cleanup */
-    for (i = 0; namespaces[i]; i++) {
-        if (namespaces[i]->enabled && namespaces[i]->shutdown)
-            namespaces[i]->shutdown();
+    for (i = 0; http_namespaces[i]; i++) {
+        if (http_namespaces[i]->enabled && http_namespaces[i]->shutdown)
+            http_namespaces[i]->shutdown();
     }
 
     xmlCleanupParser();
@@ -1189,16 +1001,7 @@ void shut_down(int code)
     }
     if (backend_cached) free(backend_cached);
 
-    sync_log_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    denydb_close();
-    denydb_done();
+    index_text_extractor_destroy();
 
     annotatemore_close();
 
@@ -1213,8 +1016,18 @@ void shut_down(int code)
         prot_flush(httpd_out);
         bytes_out = prot_bytes_out(httpd_out);
         prot_free(httpd_out);
+
+        /* one less active connection */
+        prometheus_decrement(CYRUS_HTTP_ACTIVE_CONNECTIONS);
+    }
+    else {
+        /* one less ready listener */
+        prometheus_decrement(CYRUS_HTTP_READY_LISTENERS);
     }
 
+    prometheus_increment(code ? CYRUS_HTTP_SHUTDOWN_TOTAL_STATUS_ERROR
+                              : CYRUS_HTTP_SHUTDOWN_TOTAL_STATUS_OK);
+
     if (protin) protgroup_free(protin);
 
     if (config_auditlog)
@@ -1226,9 +1039,9 @@ void shut_down(int code)
     tls_shutdown_serverengine();
 #endif
 
-#ifdef HAVE_NGHTTP2
-    nghttp2_session_callbacks_del(http2_callbacks);
-#endif
+    saslprops_free(&saslprops);
+
+    http2_done();
 
     cyrus_done();
 
@@ -1239,6 +1052,7 @@ void shut_down(int code)
 void fatal(const char* s, int code)
 {
     static int recurse_code = 0;
+    const char *fatal = "Fatal error: ";
 
     if (recurse_code) {
         /* We were called recursively. Just give up */
@@ -1250,28 +1064,27 @@ void fatal(const char* s, int code)
         prot_printf(httpd_out,
                     "HTTP/1.1 %s\r\n"
                     "Content-Type: text/plain\r\n"
-                    "Connection: close\r\n\r\n"
-                    "Fatal error: %s\r\n",
-                    error_message(HTTP_SERVER_ERROR), s);
+                    "Content-Length: %zu\r\n"
+                    "Connection: close\r\n"
+                    "\r\n"
+                    "%s%s\r\n",
+                    error_message(HTTP_SERVER_ERROR),
+                    strlen(fatal) + strlen(s) + 2, fatal, s);
         prot_flush(httpd_out);
     }
-    syslog(LOG_ERR, "Fatal error: %s", s);
+    syslog(LOG_ERR, "%s%s", fatal, s);
     shut_down(code);
 }
 
 
 #ifdef HAVE_SSL
-static int starttls(struct transaction_t *txn, int *http2)
+static int starttls(struct transaction_t *txn, struct http_connection *conn)
 {
     int https = (txn == NULL);
     int result;
-    int *layerp;
-    sasl_ssf_t ssf;
-    char *auth_id;
     SSL_CTX *ctx = NULL;
 
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
+    if (!conn) conn = txn->conn;
 
     result=tls_init_serverengine("http",
                                  5,        /* depth to verify */
@@ -1285,14 +1098,12 @@ static int starttls(struct transaction_t
         return HTTP_SERVER_ERROR;
     }
 
-#if (defined HAVE_NGHTTP2 && OPENSSL_VERSION_NUMBER >= 0x10002000L)
-    if (http2_callbacks) {
+    if (http2_enabled()) {
+#ifdef HAVE_TLS_ALPN
         /* enable TLS ALPN extension */
-        SSL_CTX_set_alpn_select_cb(ctx, alpn_select_cb, http2);
-    }
-#else
-    (void) http2; /* silence 'unused variable http2' warning */
+        SSL_CTX_set_alpn_select_cb(ctx, alpn_select_cb, conn);
 #endif
+    }
 
     if (!https) {
         /* tell client to start TLS upgrade (RFC 2817) */
@@ -1302,52 +1113,43 @@ static int starttls(struct transaction_t
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                https ? 180 : httpd_timeout,
-                               layerp,
-                               &auth_id,
-                               &tls_conn);
+                               &saslprops,
+                               (SSL **) &conn->tls_ctx);
 
     /* if error */
     if (result == -1) {
-        syslog(LOG_NOTICE, "starttls failed: %s", httpd_clienthost);
+        syslog(LOG_NOTICE, "starttls failed: %s", conn->clienthost);
 
         if (txn) txn->error.desc = "Error negotiating TLS";
         return HTTP_BAD_REQUEST;
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(httpd_saslconn, SASL_SSF_EXTERNAL, &ssf);
-    if (result == SASL_OK) {
-        saslprops.ssf = ssf;
-
-        result = sasl_setprop(httpd_saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    }
+    result = saslprops_set_tls(&saslprops, httpd_saslconn);
     if (result != SASL_OK) {
-        syslog(LOG_NOTICE, "sasl_setprop() failed: starttls()");
-
-        fatal("sasl_setprop() failed: starttls()", EC_TEMPFAIL);
-    }
-    if (saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
+        syslog(LOG_NOTICE, "saslprops_set_tls() failed: cmd_starttls()");
+        if (https == 0) {
+            fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
+        } else {
+            shut_down(0);
+        }
     }
-    if (auth_id) saslprops.authid = xstrdup(auth_id);
 
     /* tell the prot layer about our new layers */
-    prot_settls(httpd_in, tls_conn);
-    prot_settls(httpd_out, tls_conn);
+    prot_settls(httpd_in, conn->tls_ctx);
+    prot_settls(httpd_out, conn->tls_ctx);
 
-    httpd_tls_done = 1;
     httpd_tls_required = 0;
 
-    avail_auth_schemes |= (1 << AUTH_BASIC);
+    avail_auth_schemes |= AUTH_BASIC;
 
     return 0;
 }
 #else
 static int starttls(struct transaction_t *txn __attribute__((unused)),
-                    int *http2 __attribute__((unused)))
+                    struct http_connection *conn __attribute__((unused)))
 {
-    fatal("starttls() called, but no OpenSSL", EC_SOFTWARE);
+    fatal("starttls() called, but no OpenSSL", EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
 
@@ -1360,19 +1162,12 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("HTTP", config_servername, NULL, NULL, NULL, NULL,
-                          SASL_USAGE_FLAGS, conn);
+    ret = sasl_server_new("HTTP", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                          NULL, SASL_USAGE_FLAGS, conn);
     if(ret != SASL_OK) return ret;
 
-    if(saslprops.ipremoteport)
-       ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                          saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-       ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                          saslprops.iplocalport);
-    if(ret != SASL_OK) return ret;
     secprops = mysasl_secprops(0);
 
     /* no HTTP clients seem to use "auth-int" */
@@ -1384,17 +1179,12 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if(saslprops.ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     } else {
         ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &extprops_ssf);
     }
 
     if(ret != SASL_OK) return ret;
-
-    if(saslprops.authid) {
-       ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-       if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -1468,7 +1258,7 @@ static int client_need_auth(struct trans
 
         /* Check which response is required */
         if ((hdr = spool_getheader(txn->req_hdrs, "Upgrade")) &&
-            strstr(hdr[0], TLS_VERSION)) {
+            stristr(hdr[0], TLS_VERSION)) {
             /* Client (Murder proxy) supports RFC 2817 (TLS upgrade) */
 
             txn->flags.conn |= CONN_UPGRADE;
@@ -1482,7 +1272,7 @@ static int client_need_auth(struct trans
             struct buf *html = &txn->resp_body.payload;
 
             /* Create https URL */
-            hdr = spool_getheader(txn->req_hdrs, "Host");
+            hdr = spool_getheader(txn->req_hdrs, ":authority");
             buf_printf(&txn->buf, "https://%s", hdr[0]);
             if (strcmp(path, "*")) {
                 buf_appendcstr(&txn->buf, path);
@@ -1514,14 +1304,13 @@ static int client_need_auth(struct trans
 }
 
 
-static int examine_request(struct transaction_t *txn)
+static int check_method(struct transaction_t *txn)
 {
-    int ret = 0, r = 0, i;
-    const char **hdr, *query;
-    const struct namespace_t *namespace;
-    const struct method_t *meth_t;
+    const char **hdr;
     struct request_line_t *req_line = &txn->req_line;
 
+    if (txn->flags.redirect) return 0;
+
     /* Check for HTTP method override */
     if (!strcmp(req_line->meth, "POST") &&
         (hdr = spool_getheader(txn->req_hdrs, "X-HTTP-Method-Override"))) {
@@ -1536,27 +1325,38 @@ static int examine_request(struct transa
 
     if (txn->meth == METH_UNKNOWN) return HTTP_NOT_IMPLEMENTED;
 
-    /* Parse request-target URI */
-    if (!(txn->req_uri = parse_uri(txn->meth, req_line->uri, 1,
-                                   &txn->error.desc))) {
-        return HTTP_BAD_REQUEST;
-    }
+    return 0;
+}
+
+static int preauth_check_hdrs(struct transaction_t *txn)
+{
+    int ret = 0;
+    const char **hdr;
+
+    if (txn->flags.redirect) return 0;
 
     /* Check for mandatory Host header (HTTP/1.1+ only) */
-    if ((hdr = spool_getheader(txn->req_hdrs, "Host")) && hdr[1]) {
-        txn->error.desc = "Too many Host headers";
-        return HTTP_BAD_REQUEST;
+    if ((hdr = spool_getheader(txn->req_hdrs, "Host"))) {
+        if (hdr[1]) {
+            txn->error.desc = "Too many Host headers";
+            return HTTP_BAD_REQUEST;
+        }
+
+        /* Create an :authority pseudo header from Host */
+        spool_cache_header(xstrdup(":authority"),
+                           xstrdup(hdr[0]), txn->req_hdrs);
     }
-    else if (!hdr) {
+    else {
         switch (txn->flags.ver) {
         case VER_2:
-            /* HTTP/2 - create a Host header from :authority */
-            hdr = spool_getheader(txn->req_hdrs, ":authority");
-            spool_cache_header(xstrdup("Host"), xstrdup(hdr[0]), txn->req_hdrs);
-            break;
+            /* HTTP/2 - check for :authority pseudo header */
+            if (spool_getheader(txn->req_hdrs, ":authority")) break;
+
+            /* Fall through and create an :authority pseudo header */
+            GCC_FALLTHROUGH
 
         case VER_1_0:
-            /* HTTP/1.0 - create a Host header from URI */
+            /* HTTP/1.0 - create an :authority pseudo header from URI */
             if (txn->req_uri->server) {
                 buf_setcstr(&txn->buf, txn->req_uri->server);
                 if (txn->req_uri->port)
@@ -1564,9 +1364,8 @@ static int examine_request(struct transa
             }
             else buf_setcstr(&txn->buf, config_servername);
 
-            spool_cache_header(xstrdup("Host"),
-                               xstrdup(buf_cstring(&txn->buf)), txn->req_hdrs);
-            buf_reset(&txn->buf);
+            spool_cache_header(xstrdup(":authority"),
+                               buf_release(&txn->buf), txn->req_hdrs);
             break;
 
         case VER_1_1:
@@ -1591,67 +1390,76 @@ static int examine_request(struct transa
     if (txn->flags.conn & CONN_UPGRADE) {
         /* Read any request body (can't upgrade in middle of request) */
         txn->req_body.flags |= BODY_DECODE;
-        ret = http_read_body(httpd_in, httpd_out,
-                             txn->req_hdrs, &txn->req_body, &txn->error.desc);
+        ret = http_read_req_body(txn);
         if (ret) {
             txn->flags.conn = CONN_CLOSE;
             return ret;
         }
 
         if (txn->flags.upgrade & UPGRADE_TLS) {
-            int http2 = 0;
-            if ((ret = starttls(txn, &http2))) {
+            if ((ret = starttls(txn, NULL))) {
                 txn->flags.conn = CONN_CLOSE;
                 return ret;
             }
-            if (http2) txn->flags.upgrade |= UPGRADE_HTTP2;
+
+            /* Don't advertise TLS Upgrade anymore */
+            txn->flags.upgrade &= ~UPGRADE_TLS;
         }
 
         syslog(LOG_DEBUG, "upgrade flags: %#x  tls req: %d",
                txn->flags.upgrade, httpd_tls_required);
         if ((txn->flags.upgrade & UPGRADE_HTTP2) && !httpd_tls_required) {
-            if ((ret = starthttp2(txn->conn, httpd_tls_done ? NULL : txn))) {
+            if ((ret = http2_start_session(txn, NULL))) {
                 txn->flags.conn = CONN_CLOSE;
                 return ret;
             }
-        }
 
-        txn->flags.conn &= ~CONN_UPGRADE;
-        txn->flags.upgrade = 0;
+            /* Upgrade header field mechanism not available under HTTP/2 */
+            txn->flags.upgrade = 0;
+        }
     }
-    else if (!httpd_tls_done && txn->flags.ver == VER_1_1) {
+    else if (!txn->conn->tls_ctx && txn->flags.ver == VER_1_1) {
         /* Advertise available upgrade protocols */
-#ifdef HAVE_NGHTTP2
-        txn->flags.conn |= CONN_UPGRADE;
-        txn->flags.upgrade = UPGRADE_HTTP2;
-#endif
-        if (config_mupdate_server && config_getstring(IMAPOPT_PROXYSERVERS)) {
+        if (tls_enabled() &&
+            config_mupdate_server && config_getstring(IMAPOPT_PROXYSERVERS)) {
             txn->flags.upgrade |= UPGRADE_TLS;
-            txn->flags.conn |= CONN_UPGRADE;
         }
+        if (http2_enabled()) txn->flags.upgrade |= UPGRADE_HTTP2;
     }
 
-    query = URI_QUERY(txn->req_uri);
+    if (txn->flags.upgrade) txn->flags.conn |= CONN_UPGRADE;
+    else txn->flags.conn &= ~CONN_UPGRADE;
+
+    return 0;
+}
+
+
+static int check_namespace(struct transaction_t *txn)
+{
+    int i;
+    const char **hdr, *query = URI_QUERY(txn->req_uri);
+    const struct namespace_t *namespace;
+    const struct method_t *meth_t;
 
     /* Find the namespace of the requested resource */
-    for (i = 0; namespaces[i]; i++) {
+    for (i = 0; http_namespaces[i]; i++) {
         const char *path = txn->req_uri->path;
         size_t len;
 
         /* Skip disabled namespaces */
-        if (!namespaces[i]->enabled) continue;
+        if (!http_namespaces[i]->enabled) continue;
 
         /* Handle any /.well-known/ bootstrapping */
-        if (namespaces[i]->well_known) {
-            len = strlen(namespaces[i]->well_known);
-            if (!strncmp(path, namespaces[i]->well_known, len) &&
+        if (http_namespaces[i]->well_known) {
+            len = strlen(http_namespaces[i]->well_known);
+            if (!strncmp(path, http_namespaces[i]->well_known, len) &&
                 (!path[len] || path[len] == '/')) {
 
-                hdr = spool_getheader(txn->req_hdrs, "Host");
+                hdr = spool_getheader(txn->req_hdrs, ":authority");
                 buf_reset(&txn->buf);
                 buf_printf(&txn->buf, "%s://%s",
-                           https? "https" : "http", hdr[0]);
-                buf_appendcstr(&txn->buf, namespaces[i]->prefix);
+                           https ? "https" : "http", hdr[0]);
+                buf_appendcstr(&txn->buf, http_namespaces[i]->prefix);
                 buf_appendcstr(&txn->buf, path + len);
                 if (query) buf_printf(&txn->buf, "?%s", query);
                 txn->location = buf_cstring(&txn->buf);
@@ -1661,13 +1469,13 @@ static int examine_request(struct transa
         }
 
         /* See if the prefix matches - terminated with NUL or '/' */
-        len = strlen(namespaces[i]->prefix);
-        if (!strncmp(path, namespaces[i]->prefix, len) &&
+        len = strlen(http_namespaces[i]->prefix);
+        if (!strncmp(path, http_namespaces[i]->prefix, len) &&
             (!path[len] || (path[len] == '/') || !strcmp(path, "*"))) {
             break;
         }
     }
-    if ((namespace = namespaces[i])) {
+    if ((namespace = http_namespaces[i])) {
         txn->req_tgt.namespace = namespace;
         txn->req_tgt.allow = namespace->allow;
 
@@ -1692,11 +1500,22 @@ static int examine_request(struct transa
         avail_auth_schemes = (namespace->auth_schemes & avail_auth_schemes);
 
         /* Bearer auth must be advertised and supported by the namespace */
-        if ((namespace->auth_schemes & (1<<AUTH_BEARER)) && namespace->bearer) {
-            avail_auth_schemes |= (1<<AUTH_BEARER);
+        if ((namespace->auth_schemes & AUTH_BEARER) && namespace->bearer) {
+            avail_auth_schemes |= AUTH_BEARER;
         }
     }
 
+    return 0;
+}
+
+
+static int auth_check_hdrs(struct transaction_t *txn, int *sasl_result)
+{
+    int ret = 0, r = 0;
+    const char **hdr;
+
+    if (txn->flags.redirect) return 0;
+
     /* Perform authentication, if necessary */
     if ((hdr = spool_getheader(txn->req_hdrs, "Authorization"))) {
         if (httpd_userid) {
@@ -1718,7 +1537,20 @@ static int examine_request(struct transa
                 syslog(LOG_DEBUG, "auth failed - reinit");
                 reset_saslconn(&httpd_saslconn);
                 txn->auth_chal.scheme = NULL;
-                ret = HTTP_UNAUTHORIZED;
+                if (r == SASL_UNAVAIL) {
+                    /* The namespace to authenticate to is unavailable.
+                     * There could be any reason for this, e.g. the DAV
+                     * handler could have run into a timeout for the
+                     * user's dabatase. In any case, there's no sense
+                     * to challenge the client for authentication. */
+                    ret = HTTP_UNAVAILABLE;
+                }
+                else if (r == SASL_FAIL) {
+                    ret = HTTP_SERVER_ERROR;
+                }
+                else {
+                    ret = HTTP_UNAUTHORIZED;
+                }
             }
             else if (r == SASL_CONTINUE) {
                 /* Continue with multi-step authentication */
@@ -1753,7 +1585,7 @@ static int examine_request(struct transa
     }
 
     /* Perform proxy authorization, if necessary */
-    else if (saslprops.authid &&
+    else if (httpd_authid &&
              (hdr = spool_getheader(txn->req_hdrs, "Authorize-As")) &&
              *hdr[0]) {
         const char *authzid = hdr[0];
@@ -1767,24 +1599,21 @@ static int examine_request(struct transa
             ret = HTTP_UNAUTHORIZED;
         }
         else {
-            auth_success(txn, authzid);
+            ret = auth_success(txn, authzid);
         }
     }
 
-    /* Register service/module and method */
-    buf_printf(&txn->buf, "%s%s", config_ident,
-               namespace->well_known ? strrchr(namespace->well_known, '/') :
-               namespace->prefix);
-    proc_register(buf_cstring(&txn->buf), httpd_clienthost, httpd_userid,
-                  txn->req_line.uri, txn->req_line.meth);
-    buf_reset(&txn->buf);
+    *sasl_result = r;
+
+    return ret;
+}
+
 
-    /* Request authentication, if necessary */
-    if (!httpd_userid && namespace->need_auth(txn)) {
-        ret = HTTP_UNAUTHORIZED;
-    }
+static void postauth_check_hdrs(struct transaction_t *txn)
+{
+    const char **hdr;
 
-    if (ret) return client_need_auth(txn, r);
+    if (txn->flags.redirect) return;
 
     /* Check if this is a Cross-Origin Resource Sharing request */
     if (allow_cors && (hdr = spool_getheader(txn->req_hdrs, "Origin"))) {
@@ -1796,7 +1625,7 @@ static int examine_request(struct transa
 
             if ((https == o_https) &&
                 !strcasecmp(uri->server,
-                            *spool_getheader(txn->req_hdrs, "Host"))) {
+                            *spool_getheader(txn->req_hdrs, ":authority"))) {
                 txn->flags.cors = CORS_SIMPLE;
             }
             else {
@@ -1830,7 +1659,7 @@ static int examine_request(struct transa
 
        XXX  Do we want to support deflate even though M$
        doesn't implement it correctly (raw deflate vs. zlib)? */
-    if (txn->conn->zstrm &&
+    if (txn->zstrm &&
         txn->flags.ver == VER_1_1 &&
         (hdr = spool_getheader(txn->req_hdrs, "TE"))) {
         struct accept *e, *enc = parse_accept(hdr);
@@ -1845,23 +1674,38 @@ static int examine_request(struct transa
         }
         if (enc) free(enc);
     }
-    else if ((txn->conn->zstrm || txn->conn->brotli) &&
+    else if ((txn->zstrm || txn->brotli || txn->zstd) &&
              (hdr = spool_getheader(txn->req_hdrs, "Accept-Encoding"))) {
         struct accept *e, *enc = parse_accept(hdr);
         float qual = 0.0;
 
         for (e = enc; e && e->token; e++) {
-            if (e->qual > 0.0) {
-                /* Favor Brotli over GZIP if q values are equal */
-                if (txn->conn->brotli &&
-                    (e->qual >= qual) && !strcasecmp(e->token, "br")) {
-                    txn->resp_body.enc = CE_BR;
-                    qual = e->qual;
+            if (e->qual > 0.0 && e->qual >= qual) {
+                unsigned ce = CE_IDENTITY;
+                encode_proc_t proc = NULL;
+
+                if (txn->zstd && !strcasecmp(e->token, "zstd")) {
+                    ce = CE_ZSTD;
+                    proc = &zstd_compress;
+                }
+                else if (txn->brotli && !strcasecmp(e->token, "br")) {
+                    ce = CE_BR;
+                    proc = &brotli_compress;
+                }
+                else if (txn->zstrm && (!strcasecmp(e->token, "gzip") ||
+                                        !strcasecmp(e->token, "x-gzip"))) {
+                    ce = CE_GZIP;
+                    proc = &zlib_compress;
                 }
-                else if (txn->conn->zstrm &&
-                         (e->qual > qual) && (!strcasecmp(e->token, "gzip") ||
-                                              !strcasecmp(e->token, "x-gzip"))) {
-                    txn->resp_body.enc = CE_GZIP;
+                else {
+                    /* Unknown/unsupported */
+                    e->qual = 0.0;
+                }
+
+                /* Favor Zstandard over Brotli over GZIP if q values are equal */
+                if (e->qual > qual || txn->resp_body.enc.type < ce) {
+                    txn->resp_body.enc.type = ce;
+                    txn->resp_body.enc.proc = proc;
                     qual = e->qual;
                 }
             }
@@ -1869,11 +1713,156 @@ static int examine_request(struct transa
         }
         if (enc) free(enc);
     }
+}
+
+
+EXPORTED int examine_request(struct transaction_t *txn, const char *uri)
+{
+    int ret = 0, sasl_result = 0;
+    const char *query;
+    const struct namespace_t *namespace;
+    struct request_line_t *req_line = &txn->req_line;
+
+    if (!uri) uri = req_line->uri;
+
+    /* Check method */
+    if ((ret = check_method(txn))) return ret;
+
+    /* Parse request-target URI */
+    if (!(txn->req_uri = parse_uri(txn->meth, uri, 1, &txn->error.desc))) {
+        return HTTP_BAD_REQUEST;
+    }
+
+    /* Perform pre-authentication check of headers */
+    if ((ret = preauth_check_hdrs(txn))) return ret;
+
+    /* Find the namespace of the requested resource */
+    if ((ret = check_namespace(txn))) return ret;
+
+    /* Perform check of authentication headers */
+    ret = auth_check_hdrs(txn, &sasl_result);
+
+    if (ret && ret != HTTP_UNAUTHORIZED) return ret;
+
+    /* Register service/module and method */
+    namespace = txn->req_tgt.namespace;
+    buf_printf(&txn->buf, "%s%s", config_ident,
+               namespace->well_known ? strrchr(namespace->well_known, '/') :
+               namespace->prefix);
+    proc_register(buf_cstring(&txn->buf), txn->conn->clienthost, httpd_userid,
+                  txn->req_tgt.path, txn->req_line.meth);
+    buf_reset(&txn->buf);
+
+    /* Request authentication, if necessary */
+    if (!httpd_userid && namespace->need_auth(txn)) {
+        ret = HTTP_UNAUTHORIZED;
+    }
+
+    if (ret) return client_need_auth(txn, sasl_result);
 
     /* Parse any query parameters */
     construct_hash_table(&txn->req_qparams, 10, 1);
+    query = URI_QUERY(txn->req_uri);
     if (query) parse_query_params(txn, query);
 
+    /* Perform post-authentication check of headers */
+    postauth_check_hdrs(txn);
+
+    return 0;
+}
+
+
+EXPORTED int process_request(struct transaction_t *txn)
+{
+    int ret = 0;
+
+    if (txn->req_tgt.namespace->premethod) {
+        ret = txn->req_tgt.namespace->premethod(txn);
+    }
+    if (!ret) {
+        const struct method_t *meth_t =
+            &txn->req_tgt.namespace->methods[txn->meth];
+        
+        ret = (*meth_t->proc)(txn, meth_t->params);
+
+        prometheus_increment(
+            prometheus_lookup_label(http_methods[txn->meth].metric,
+                                    txn->req_tgt.namespace->name));
+    }
+
+    if (ret == HTTP_UNAUTHORIZED) {
+        /* User must authenticate */
+        ret = client_need_auth(txn, 0);
+    }
+
+    return ret;
+}
+
+
+static int http1_input(struct transaction_t *txn)
+{
+    struct request_line_t *req_line = &txn->req_line;
+    int ignore_empty = 1, ret = 0;
+
+    do {
+        /* Read request-line */
+        syslog(LOG_DEBUG, "read & parse request-line");
+        if (!prot_fgets(req_line->buf, MAX_REQ_LINE+1, httpd_in)) {
+            txn->error.desc = prot_error(httpd_in);
+            if (txn->error.desc && strcmp(txn->error.desc, PROT_EOF_STRING)) {
+                /* client timed out */
+                syslog(LOG_WARNING, "%s, closing connection", txn->error.desc);
+                ret = HTTP_TIMEOUT;
+            }
+            else {
+                /* client closed connection */
+                syslog(LOG_DEBUG, "client closed connection");
+            }
+
+            txn->flags.conn = CONN_CLOSE;
+            return ret;
+        }
+
+        /* Ignore 1 empty line before request-line per RFC 7230 Sec 3.5 */
+    } while (ignore_empty-- && (strcspn(req_line->buf, "\r\n") == 0));
+
+
+    /* Parse request-line = method SP request-target SP HTTP-version CRLF */
+    ret = parse_request_line(txn);
+
+    /* Parse headers */
+    if (!ret) {
+        ret = http_read_headers(httpd_in, 1 /* read_sep */,
+                                &txn->req_hdrs, &txn->error.desc);
+    }
+
+    if (ret) {
+        txn->flags.conn = CONN_CLOSE;
+        goto done;
+    }
+
+    /* Examine request */
+    ret = examine_request(txn, NULL);
+    if (ret) goto done;
+
+    /* Start method processing alarm (HTTP/1.1 only) */
+    if (txn->flags.ver == VER_1_1) alarm(httpd_keepalive);
+
+    /* Process the requested method */
+    ret = process_request(txn);
+
+  done:
+    /* Handle errors (success responses handled by method functions) */
+    if (ret) error_response(ret, txn);
+
+    /* Read and discard any unread request body */
+    if (!(txn->flags.conn & CONN_CLOSE)) {
+        txn->req_body.flags |= BODY_DISCARD;
+        if (http_read_req_body(txn)) {
+            txn->flags.conn = CONN_CLOSE;
+        }
+    }
+
     return 0;
 }
 
@@ -1889,7 +1878,7 @@ static void transaction_reset(struct tra
     memset(&txn->req_line, 0, sizeof(struct request_line_t));
 
     /* Reset Bearer auth scheme for each transaction */
-    avail_auth_schemes &= ~(1 << AUTH_BEARER);
+    avail_auth_schemes &= ~AUTH_BEARER;
 
     if (txn->req_uri) xmlFreeURI(txn->req_uri);
     txn->req_uri = NULL;
@@ -1911,25 +1900,27 @@ static void transaction_reset(struct tra
     txn->location = NULL;
     memset(&txn->error, 0, sizeof(struct error_t));
 
+    strarray_fini(&txn->resp_body.links);
     memset(&txn->resp_body, 0,  /* Don't zero the response payload buffer */
            sizeof(struct resp_body_t) - sizeof(struct buf));
     buf_reset(&txn->resp_body.payload);
 
+    /* Pre-allocate our working buffer */
     buf_reset(&txn->buf);
+    buf_ensure(&txn->buf, 1024);
 }
 
 
-static void transaction_free(struct transaction_t *txn)
+EXPORTED void transaction_free(struct transaction_t *txn)
 {
-#ifdef HAVE_NGHTTP2
-    size_t i;
+    transaction_reset(txn);
 
-    for (i = 0; i < HTTP2_MAX_HEADERS; i++) {
-        free(txn->http2.resp_hdrs[i].value);
-    }
-#endif /* HAVE_NGHTTP2 */
+    ws_end_channel(txn->ws_ctx);
+    http2_end_stream(txn->strm_ctx);
 
-    transaction_reset(txn);
+    zlib_done(txn->zstrm);
+    zstd_done(txn->zstd);
+    brotli_done(txn->brotli);
 
     buf_free(&txn->req_body.payload);
     buf_free(&txn->resp_body.payload);
@@ -1943,40 +1934,36 @@ static void transaction_free(struct tran
  */
 static void cmdloop(struct http_connection *conn)
 {
-    int empty = 0;
     struct transaction_t txn;
 
     /* Start with an empty (clean) transaction */
     memset(&txn, 0, sizeof(struct transaction_t));
     txn.conn = conn;
 
-    /* Pre-allocate our working buffer */
-    buf_ensure(&txn.buf, 1024);
+    if (config_getswitch(IMAPOPT_HTTPALLOWCOMPRESS)) {
+        txn.zstrm = zlib_init();
+        txn.zstd = zstd_init();
+        txn.brotli = brotli_init();
+    }
+
+    /* Enable command timer */
+    cmdtime_settimer(1);
 
-    for (;;) {
+    /* Enable provisional responses for long-running mailbox ops */
+    mailbox_set_wait_cb((mailbox_wait_cb_t *) &keepalive_response, &txn);
+
+    do {
         int ret = 0;
 
         /* Reset txn state */
         transaction_reset(&txn);
 
+        /* make sure nothing leaked */
+        assert(!open_mailboxes_exist());
+
         /* Check for input from client */
         do {
             /* Flush any buffered output */
-#ifdef HAVE_NGHTTP2
-            if (conn->http2_session &&
-                nghttp2_session_want_write(conn->http2_session)) {
-                /* Send queued frame(s) */
-                int r = nghttp2_session_send(conn->http2_session);
-                if (r) {
-                    syslog(LOG_ERR,
-                           "nghttp2_session_send: %s", nghttp2_strerror(r));
-                    /* XXX  can we do anything else here? */
-                    transaction_free(&txn);
-                    return;
-                }
-            }
-#endif /* HAVE_NGHTTP2 */
-
             prot_flush(httpd_out);
             if (backend_current) prot_flush(backend_current->out);
 
@@ -1985,7 +1972,8 @@ static void cmdloop(struct http_connecti
                 (httpd_userid &&
                  userdeny(httpd_userid, config_ident, txn.buf.s, txn.buf.alloc))) {
                 txn.error.desc = txn.buf.s;
-                ret = HTTP_UNAVAILABLE;
+                txn.flags.conn = CONN_CLOSE;
+                ret = HTTP_SHUTDOWN;
                 break;
             }
 
@@ -1993,168 +1981,36 @@ static void cmdloop(struct http_connecti
 
         } while (!proxy_check_input(protin, httpd_in, httpd_out,
                                     backend_current ? backend_current->in : NULL,
-                                    NULL, 0));
+                                    NULL, 30));
 
         
-#ifdef HAVE_NGHTTP2
-        if (conn->http2_session) {
-            syslog(LOG_DEBUG, "ret: %d, eof: %d, want read: %d", ret,
-                   httpd_in->eof, nghttp2_session_want_read(conn->http2_session));
-            if (nghttp2_session_want_read(conn->http2_session)) {
-                if (!ret) {
-                    /* Read frame(s) */
-                    int r = nghttp2_session_recv(conn->http2_session);
-                    if (!r) continue;
-                    else if (r != NGHTTP2_ERR_EOF) {
-                        syslog(LOG_WARNING, "nghttp2_session_recv: %s (%s)",
-                               nghttp2_strerror(r), prot_error(httpd_in));
-                        txn.error.desc = prot_error(httpd_in);
-                        ret = HTTP_TIMEOUT;
-                    }
-                }
-
-                if (ret) {
-                    /* Tell client we are closing session */
-                    syslog(LOG_WARNING, "%s, closing connection", txn.error.desc);
-                    syslog(LOG_DEBUG, "nghttp2_submit_goaway()");
-                    nghttp2_submit_goaway(conn->http2_session, NGHTTP2_FLAG_NONE,
-                                          nghttp2_session_get_last_proc_stream_id(
-                                              conn->http2_session),
-                                          NGHTTP2_NO_ERROR,
-                                          (const uint8_t *) txn.error.desc,
-                                          strlen(txn.error.desc));
-                    continue;
-                }
-            }
-            else if (ret) {
-                protgroup_free(protin);
-                shut_down(0);
-            }
-
-            /* client closed connection */
-            syslog(LOG_DEBUG, "client closed connection");
-            transaction_free(&txn);
-            return;
-        }
-#endif /* HAVE_NGHTTP2 */
-
-
-        if (ret) {
-            txn.flags.conn = CONN_CLOSE;
-            error_response(ret, &txn);
-            protgroup_free(protin);
-            shut_down(0);
-        }
-
-        /* Read request-line */
-        struct request_line_t *req_line = &txn.req_line;
-        syslog(LOG_DEBUG, "read & parse request-line");
-        if (!prot_fgets(req_line->buf, MAX_REQ_LINE+1, httpd_in)) {
-            txn.error.desc = prot_error(httpd_in);
-            if (txn.error.desc && strcmp(txn.error.desc, PROT_EOF_STRING)) {
-                /* client timed out */
-                syslog(LOG_WARNING, "%s, closing connection", txn.error.desc);
-                ret = HTTP_TIMEOUT;
-            }
-            else {
-                /* client closed connection */
-            }
-
-            txn.flags.conn = CONN_CLOSE;
-            goto done;
-        }
-
-        /* Ignore 1 empty line before request-line per RFC 7230 Sec 3.5 */
-        if (!empty++ && !strcspn(req_line->buf, "\r\n")) continue;
-        empty = 0;
-
-
-#ifdef HAVE_NGHTTP2
-        /* Check for HTTP/2 client connection preface */
-        if (http2_callbacks &&
-            !strncmp(NGHTTP2_CLIENT_MAGIC,
-                     req_line->buf, strlen(req_line->buf))) {
-            syslog(LOG_DEBUG, "HTTP/2 client connection preface");
-
-            /* Read remainder of preface */
-            prot_readbuf(httpd_in, &txn.req_body.payload,
-                         NGHTTP2_CLIENT_MAGIC_LEN - strlen(req_line->buf));
-
-            /* Tell library not to look for preface */
-            nghttp2_option_new(&conn->http2_options);
-            nghttp2_option_set_no_recv_client_magic(conn->http2_options, 1);
-
-            /* Start HTTP/2 */
-            ret = starthttp2(conn, &txn);
-            if (ret) {
-                /* XXX  what do we do here? */
-                transaction_free(&txn);
-                return;
-            }
-
-            continue;
-        }
-#endif /* HAVE_NGHTTP2 */
-
-
-        /* Parse request-line = method SP request-target SP HTTP-version CRLF */
-        ret = parse_request_line(&txn);
-
-        /* Parse headers */
-        if (!ret) {
-            ret = http_read_headers(httpd_in, 1 /* read_sep */,
-                                    &txn.req_hdrs, &txn.error.desc);
-        }
-
-        if (ret) {
-            txn.flags.conn = CONN_CLOSE;
-            goto done;
-        }
-
-        /* Examine request */
-        ret = examine_request(&txn);
-        if (ret) goto done;
-
-        /* Start method processing alarm (HTTP/1.1 only) */
-        if (txn.flags.ver == VER_1_1) alarm(httpd_keepalive);
+        /* Start command timer */
+        cmdtime_starttimer();
 
-        /* Process the requested method */
-        if (txn.req_tgt.namespace->premethod) {
-            ret = txn.req_tgt.namespace->premethod(&txn);
+        if (txn.conn->sess_ctx) {
+            /* HTTP/2 input */
+            http2_input(&txn);
         }
-        if (!ret) {
-            const struct method_t *meth_t =
-                &txn.req_tgt.namespace->methods[txn.meth];
-
-            ret = (*meth_t->proc)(&txn, meth_t->params);
+        else if (txn.ws_ctx) {
+            /* WebSocket over HTTP/1.1 input */
+            ws_input(&txn);
         }
-
-        if (ret == HTTP_UNAUTHORIZED) {
-            /* User must authenticate */
-            ret = client_need_auth(&txn, 0);
+        else if (!ret) {
+            /* HTTP/1.x request */
+            http1_input(&txn);
         }
 
-      done:
-        /* Handle errors (success responses handled by method functions) */
-        if (ret) error_response(ret, &txn);
-
-        /* Read and discard any unread request body */
-        if (!(txn.flags.conn & CONN_CLOSE)) {
-            txn.req_body.flags |= BODY_DISCARD;
-            if (http_read_body(httpd_in, httpd_out,
-                               txn.req_hdrs, &txn.req_body, &txn.error.desc)) {
-                txn.flags.conn = CONN_CLOSE;
-            }
+        if (ret == HTTP_SHUTDOWN) {
+            syslog(LOG_WARNING,
+                   "Shutdown file: \"%s\", closing connection", txn.error.desc);
+            protgroup_free(protin);
+            shut_down(0);
         }
 
-        if (txn.flags.conn & CONN_CLOSE) {
-            /* Memory cleanup */
-            transaction_free(&txn);
-            return;
-        }
+    } while (!(txn.flags.conn & CONN_CLOSE));
 
-        continue;
-    }
+    /* Memory cleanup */
+    transaction_free(&txn);
 }
 
 /****************************  Parsing Routines  ******************************/
@@ -2187,18 +2043,24 @@ EXPORTED xmlURIPtr parse_uri(unsigned me
         goto bad_request;
     }
     else if (p_uri->path) {
+        size_t pathlen = strlen(p_uri->path);
         if ((p_uri->path[0] != '/') &&
             (strcmp(p_uri->path, "*") || (meth != METH_OPTIONS))) {
             /* No special URLs except for "OPTIONS * HTTP/1.1" */
             *errstr = "Illegal request target URI";
             goto bad_request;
         }
-        else if (strstr(p_uri->path, "/..")) {
+        else if (strstr(p_uri->path, "/../")) {
+            /* Don't allow access up directory tree */
+            *errstr = "Illegal request target URI";
+            goto bad_request;
+        }
+        else if (pathlen >= 3 && !strcmp("/..", p_uri->path + pathlen - 3)) {
             /* Don't allow access up directory tree */
             *errstr = "Illegal request target URI";
             goto bad_request;
         }
-        else if (strlen(p_uri->path) > MAX_MAILBOX_PATH) {
+        else if (pathlen > MAX_MAILBOX_PATH) {
             *errstr = "Request target URI too long";
             goto bad_request;
         }
@@ -2217,10 +2079,6 @@ EXPORTED time_t calc_compile_time(const
 {
     struct tm tm;
     char month[4];
-    const char *monthname[] = {
-        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
-    };
 
     memset(&tm, 0, sizeof(struct tm));
     tm.tm_isdst = -1;
@@ -2297,26 +2155,28 @@ static int parse_connection(struct trans
                         spool_getheader(txn->req_hdrs, "Upgrade");
 
                     if (upgrade && upgrade[0]) {
-                        syslog(LOG_NOTICE,
-                               "client requested upgrade to %s", upgrade[0]);
-
-                        if (!httpd_tls_done && tls_enabled() &&
-                            !strncmp(upgrade[0], TLS_VERSION,
-                                     strcspn(upgrade[0], " ,"))) {
+                        if (!txn->conn->tls_ctx && tls_enabled() &&
+                            !strncasecmp(upgrade[0], TLS_VERSION,
+                                         strcspn(upgrade[0], " ,"))) {
                             /* Upgrade to TLS */
                             txn->flags.conn |= CONN_UPGRADE;
                             txn->flags.upgrade |= UPGRADE_TLS;
                         }
-#ifdef HAVE_NGHTTP2
-                        else if (http2_callbacks &&
-                                 !strncmp(upgrade[0],
-                                          NGHTTP2_CLEARTEXT_PROTO_VERSION_ID,
-                                          strcspn(upgrade[0], " ,"))) {
+                        else if (http2_enabled() &&
+                                 !strncasecmp(upgrade[0],
+                                              NGHTTP2_CLEARTEXT_PROTO_VERSION_ID,
+                                              strcspn(upgrade[0], " ,"))) {
                             /* Upgrade to HTTP/2 */
                             txn->flags.conn |= CONN_UPGRADE;
                             txn->flags.upgrade |= UPGRADE_HTTP2;
                         }
-#endif /* HAVE_NGHTTP2 */
+                        else if (ws_enabled() &&
+                                 !strncasecmp(upgrade[0], WS_TOKEN,
+                                              strcspn(upgrade[0], " ,"))) {
+                            /* Upgrade to WebSockets */
+                            txn->flags.conn |= CONN_UPGRADE;
+                            txn->flags.upgrade |= UPGRADE_WS;
+                        }
                         else {
                             /* Unknown/unsupported protocol - no upgrade */
                         }
@@ -2426,15 +2286,11 @@ void parse_query_params(struct transacti
 /* Create HTTP-date ('buf' must be at least 30 characters) */
 EXPORTED char *httpdate_gen(char *buf, size_t len, time_t t)
 {
-    static char *month[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                             "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-    static char *wday[] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
-
     struct tm *tm = gmtime(&t);
 
     snprintf(buf, len, "%3s, %02d %3s %4d %02d:%02d:%02d GMT",
              wday[tm->tm_wday],
-             tm->tm_mday, month[tm->tm_mon], tm->tm_year + 1900,
+             tm->tm_mday, monthname[tm->tm_mon], tm->tm_year + 1900,
              tm->tm_hour, tm->tm_min, tm->tm_sec);
 
     return buf;
@@ -2442,18 +2298,17 @@ EXPORTED char *httpdate_gen(char *buf, s
 
 
 /* Create an HTTP Status-Line given response code */
-EXPORTED const char *http_statusline(long code)
+EXPORTED const char *http_statusline(unsigned ver, long code)
 {
     static struct buf statline = BUF_INITIALIZER;
-    static unsigned tail = 0;
 
-    if (!tail) {
-        buf_setcstr(&statline, HTTP_VERSION);
-        buf_putc(&statline, ' ');
-        tail = buf_len(&statline);
+    if (ver == VER_2) buf_setcstr(&statline, HTTP2_VERSION);
+    else {
+        buf_setmap(&statline, HTTP_VERSION, HTTP_VERSION_LEN-1);
+        buf_putc(&statline, ver + '0');
     }
 
-    buf_truncate(&statline, tail);
+    buf_putc(&statline, ' ');
     buf_appendcstr(&statline, error_message(code));
     return buf_cstring(&statline);
 }
@@ -2476,33 +2331,16 @@ EXPORTED void simple_hdr(struct transact
 
     syslog(LOG_DEBUG, "simple_hdr(%s: %s)", name, buf_cstring(&buf));
 
-#ifdef HAVE_NGHTTP2
     if (txn->flags.ver == VER_2) {
-        if (txn->http2.num_resp_hdrs >= HTTP2_MAX_HEADERS) {
-            buf_free(&buf);
-            return;
-        }
-
-        nghttp2_nv *nv = &txn->http2.resp_hdrs[txn->http2.num_resp_hdrs];
-
-        free(nv->value);
-
-        nv->namelen = strlen(name);
-        nv->name = (uint8_t *) name;
-        nv->valuelen = buf_len(&buf);
-        nv->value = (uint8_t *) buf_release(&buf);
-        nv->flags = NGHTTP2_NV_FLAG_NO_COPY_VALUE;
-
-        txn->http2.num_resp_hdrs++;
-        return;
+        http2_add_header(txn, name, &buf);
     }
-#endif /* HAVE_NGHTTP2 */
-
-    prot_printf(txn->conn->pout, "%c%s: ", toupper(name[0]), name+1);
-    prot_puts(txn->conn->pout, buf_cstring(&buf));
-    prot_puts(txn->conn->pout, "\r\n");
+    else {
+        prot_printf(txn->conn->pout, "%c%s: ", toupper(name[0]), name+1);
+        prot_puts(txn->conn->pout, buf_cstring(&buf));
+        prot_puts(txn->conn->pout, "\r\n");
 
-    buf_free(&buf);
+        buf_free(&buf);
+    }
 }
 
 #define WWW_Authenticate(name, param)                           \
@@ -2511,31 +2349,39 @@ EXPORTED void simple_hdr(struct transact
 #define Access_Control_Expose(hdr)                              \
     simple_hdr(txn, "Access-Control-Expose-Headers", hdr)
 
-EXPORTED void comma_list_hdr(struct transaction_t *txn, const char *name,
-                             const char *vals[], unsigned flags, ...)
+static void comma_list_body(struct buf *buf,
+                            const char *vals[], unsigned flags, va_list args)
 {
-    struct buf buf = BUF_INITIALIZER;
     const char *sep = "";
-    va_list args;
     int i;
 
-    va_start(args, flags);
-
     for (i = 0; vals[i]; i++) {
         if (flags & (1 << i)) {
-            buf_appendcstr(&buf, sep);
-            buf_vprintf(&buf, vals[i], args);
+            buf_appendcstr(buf, sep);
+            if (args) buf_vprintf(buf, vals[i], args);
+            else buf_appendcstr(buf, vals[i]);
             sep = ", ";
         }
-        else {
+        else if (args) {
             /* discard any unused args */
             vsnprintf(NULL, 0, vals[i], args);
         }
     }
+}
+
+EXPORTED void comma_list_hdr(struct transaction_t *txn, const char *name,
+                             const char *vals[], unsigned flags, ...)
+{
+    struct buf buf = BUF_INITIALIZER;
+    va_list args;
+
+    va_start(args, flags);
+
+    comma_list_body(&buf, vals, flags, args);
 
     va_end(args);
 
-    simple_hdr(txn, name, buf_cstring(&buf));
+    simple_hdr(txn, name, "%s", buf_cstring(&buf));
 
     buf_free(&buf);
 }
@@ -2548,7 +2394,7 @@ EXPORTED void list_auth_schemes(struct t
 
     /* Advertise available schemes that can work with the type of connection */
     for (scheme = auth_schemes; scheme->name; scheme++) {
-        if ((avail_auth_schemes & (1 << scheme->idx)) &&
+        if ((avail_auth_schemes & scheme->id) &&
             !(conn_close && (scheme->flags & AUTH_NEED_PERSIST))) {
             auth_chal->param = NULL;
 
@@ -2567,7 +2413,8 @@ EXPORTED void allow_hdr(struct transacti
                         const char *name, unsigned allow)
 {
     const char *meths[] = {
-        "OPTIONS, GET, HEAD", "POST", "PUT", "PATCH", "DELETE", "TRACE", NULL
+        "OPTIONS, GET, HEAD", "POST", "PUT",
+        "PATCH", "DELETE", "TRACE", "CONNECT", NULL
     };
 
     comma_list_hdr(txn, name, meths, allow);
@@ -2597,7 +2444,7 @@ EXPORTED void accept_patch_hdr(struct tr
         sep = ", ";
     }
 
-    simple_hdr(txn, "Accept-Patch", buf_cstring(&buf));
+    simple_hdr(txn, "Accept-Patch", "%s", buf_cstring(&buf));
 
     buf_free(&buf);
 }
@@ -2609,109 +2456,71 @@ EXPORTED void content_md5_hdr(struct tra
 {
     char base64[MD5_BASE64_LEN+1];
 
-    sasl_encode64((char *) md5, MD5_DIGEST_LENGTH,
-                  base64, MD5_BASE64_LEN, NULL);
-    simple_hdr(txn, "Content-MD5", base64);
+    sasl_encode64((char *) md5, MD5_DIGEST_LENGTH, base64, MD5_BASE64_LEN, NULL);
+    simple_hdr(txn, "Content-MD5", "%s", base64);
 }
 
 EXPORTED void begin_resp_headers(struct transaction_t *txn, long code)
 {
-#ifdef HAVE_NGHTTP2
     if (txn->flags.ver == VER_2) {
-        txn->http2.num_resp_hdrs = 0;
+        http2_begin_headers(txn);
         if (code) simple_hdr(txn, ":status", "%.3s", error_message(code));
-        return;
     }
-#endif /* HAVE_NGHTTP2 */
-
-    if (code) prot_printf(txn->conn->pout, "%s\r\n", http_statusline(code));
-    return;
+    else if (code) prot_printf(txn->conn->pout, "%s\r\n",
+                               http_statusline(txn->flags.ver, code));
 }
 
 EXPORTED int end_resp_headers(struct transaction_t *txn, long code)
 {
-#ifdef HAVE_NGHTTP2
-    if (txn->flags.ver == VER_2) {
-        uint8_t flags = NGHTTP2_FLAG_NONE;
-        int r;
-
-        syslog(LOG_DEBUG,
-               "end_resp_headers(code = %ld, len = %ld, flags.te = %#x)",
-               code, txn->resp_body.len, txn->flags.te);
+    int r = 0;
 
-        switch (code) {
-        case 0:
-            /* Trailer */
-            flags = NGHTTP2_FLAG_END_STREAM;
-            break;
+    if (txn->flags.ver == VER_2) {
+        r = http2_end_headers(txn, code);
+    }
+    else {
+        /* CRLF terminating the header block */
+        prot_puts(txn->conn->pout, "\r\n");
+    }
 
-        case HTTP_CONTINUE:
-        case HTTP_PROCESSING:
-            /* Provisional response */
-            break;
+    return r;
+}
 
-        case HTTP_NO_CONTENT:
-        case HTTP_NOT_MODIFIED:
-            /* MUST NOT include a body */
-            flags = NGHTTP2_FLAG_END_STREAM;
-            break;
 
-        default:
-            if (txn->meth == METH_HEAD) {
-                /* MUST NOT include a body */
-                flags = NGHTTP2_FLAG_END_STREAM;
-            }
-            else if (!(txn->resp_body.len || (txn->flags.te & TE_CHUNKED))) {
-                /* Empty body */
-                flags = NGHTTP2_FLAG_END_STREAM;
-            }
-            break;
-        }
+/* Write end-to-end header (ignoring hop-by-hop) from cache to protstream. */
+static void write_cachehdr(const char *name, const char *contents,
+                           const char *raw __attribute__((unused)), void *rock)
+{
+    struct transaction_t *txn = (struct transaction_t *) rock;
+    const char **hdr, *hop_by_hop[] =
+        { "connection", "content-length", "content-type", "date", "forwarded",
+          "keep-alive", "location", "status", "strict-transport-security",
+          "upgrade", "via", NULL };
 
-        syslog(LOG_DEBUG, "%s(id=%d, flags=%#x)",
-               code ? "nghttp2_submit headers" : "nghttp2_submit_trailers",
-               txn->http2.stream_id, flags);
-
-        if (code) {
-            r = nghttp2_submit_headers(txn->conn->http2_session,
-                                       flags, txn->http2.stream_id, NULL,
-                                       txn->http2.resp_hdrs,
-                                       txn->http2.num_resp_hdrs, NULL);
-        }
-        else {
-            r = nghttp2_submit_trailer(txn->conn->http2_session,
-                                       txn->http2.stream_id,
-                                       txn->http2.resp_hdrs,
-                                       txn->http2.num_resp_hdrs);
-        }
-        if (r) {
-            syslog(LOG_ERR, "%s: %s",
-                   code ? "nghttp2_submit headers" : "nghttp2_submit_trailers",
-                   nghttp2_strerror(r));
-            return r;
-        }
+    /* Ignore private headers in our cache */
+    if (name[0] == ':') return;
 
-        return 0;
+    for (hdr = hop_by_hop; *hdr; hdr++) {
+        if (!strcasecmp(name, *hdr)) return;
     }
-#else
-    (void) code; /* silence 'unused variable code' warning */
-#endif /* HAVE_NGHTTP2 */
-
-    /* CRLF terminating the header block */
-    prot_puts(txn->conn->pout, "\r\n");
 
-    return 0;
+    simple_hdr(txn, name, "%s", contents);
 }
 
 
 EXPORTED void response_header(long code, struct transaction_t *txn)
 {
+    int i;
     time_t now;
     char datestr[30];
-    const char **hdr;
+    double cmdtime, nettime;
+    const char **hdr, *sep;
     struct auth_challenge_t *auth_chal = &txn->auth_chal;
     struct resp_body_t *resp_body = &txn->resp_body;
-    static struct buf log = BUF_INITIALIZER;
+    struct buf *logbuf = &txn->conn->logbuf;
+    const char *upgrd_tokens[] =
+        { TLS_VERSION, NGHTTP2_CLEARTEXT_PROTO_VERSION_ID, WS_TOKEN, NULL };
+    const char *te[] = { "deflate", "gzip", "chunked", NULL };
+    const char *ce[] = { "deflate", "gzip", "br", "zstd", NULL };
 
     /* Stop method processing alarm */
     alarm(0);
@@ -2727,15 +2536,13 @@ EXPORTED void response_header(long code,
         /* Final response */
         now = time(0);
         httpdate_gen(datestr, sizeof(datestr), now);
-        simple_hdr(txn, "Date", datestr);
-
-        if (txn->flags.ver == VER_2) break;
+        simple_hdr(txn, "Date", "%s", datestr);
 
-        /* Fall through and specify connection options - HTTP/1.x only */
+        /* Fall through and specify connection options and/or links */
         GCC_FALLTHROUGH
 
     case HTTP_SWITCH_PROT:
-        if (txn->flags.conn) {
+        if (txn->flags.conn && (txn->flags.ver < VER_2)) {
             /* Construct Connection header */
             const char *conn_tokens[] =
                 { "close", "Upgrade", "Keep-Alive", NULL };
@@ -2744,21 +2551,27 @@ EXPORTED void response_header(long code,
 
             if (txn->flags.upgrade) {
                 /* Construct Upgrade header */
-                const char *upgrd_tokens[] =
-                    { TLS_VERSION,
-#ifdef HAVE_NGHTTP2
-                      NGHTTP2_CLEARTEXT_PROTO_VERSION_ID,
-#endif
-                      NULL };
-
                 comma_list_hdr(txn, "Upgrade", upgrd_tokens, txn->flags.upgrade);
+
+                if (txn->flags.upgrade & UPGRADE_WS) {
+                    /* Add WebSocket headers */
+                    ws_add_resp_hdrs(txn);
+                }
             }
             if (txn->flags.conn & CONN_KEEPALIVE) {
                 simple_hdr(txn, "Keep-Alive", "timeout=%d", httpd_timeout);
             }
         }
 
-        if (code != HTTP_SWITCH_PROT) break;
+        /* Fall through and specify links */
+        GCC_FALLTHROUGH
+
+    case HTTP_EARLY_HINTS:
+        for (i = 0; i < strarray_size(&resp_body->links); i++) {
+            simple_hdr(txn, "Link", "%s", strarray_nth(&resp_body->links, i));
+        }
+
+        if (code >= HTTP_OK) break;
 
         /* Fall through as provisional response */
         GCC_FALLTHROUGH
@@ -2771,16 +2584,19 @@ EXPORTED void response_header(long code,
         /* Force the response to the client immediately */
         prot_flush(httpd_out);
 
-        return;
+        /* Restart method processing alarm (HTTP/1.1 only) */
+        if (!txn->ws_ctx && (txn->flags.ver == VER_1_1)) alarm(httpd_keepalive);
+
+        goto log;
     }
 
 
     /* Control Data */
-    if (httpd_tls_done) {
+    if (txn->conn->tls_ctx) {
         simple_hdr(txn, "Strict-Transport-Security", "max-age=600");
     }
     if (txn->location) {
-        simple_hdr(txn, "Location", txn->location);
+        simple_hdr(txn, "Location", "%s", txn->location);
     }
     if (txn->flags.mime) {
         simple_hdr(txn, "MIME-Version", "1.0");
@@ -2796,12 +2612,12 @@ EXPORTED void response_header(long code,
 
         if (txn->flags.cc & CC_MAXAGE) {
             httpdate_gen(datestr, sizeof(datestr), now + resp_body->maxage);
-            simple_hdr(txn, "Expires", datestr);
+            simple_hdr(txn, "Expires", "%s", datestr);
         }
     }
     if (txn->flags.cors) {
         /* Construct Cross-Origin Resource Sharing headers */
-        simple_hdr(txn, "Access-Control-Allow-Origin",
+        simple_hdr(txn, "Access-Control-Allow-Origin", "%s",
                       *spool_getheader(txn->req_hdrs, "Origin"));
         simple_hdr(txn, "Access-Control-Allow-Credentials", "true");
 
@@ -2811,15 +2627,16 @@ EXPORTED void response_header(long code,
             for (hdr = spool_getheader(txn->req_hdrs,
                                        "Access-Control-Request-Headers");
                  hdr && *hdr; hdr++) {
-                simple_hdr(txn, "Access-Control-Allow-Headers", *hdr);
+                simple_hdr(txn, "Access-Control-Allow-Headers", "%s", *hdr);
             }
             simple_hdr(txn, "Access-Control-Max-Age", "3600");
         }
     }
     if (txn->flags.vary && !(txn->flags.cc & CC_NOCACHE)) {
         /* Construct Vary header */
-        const char *vary_hdrs[] =
-            { "Accept", "Accept-Encoding", "Brief", "Prefer", NULL };
+        const char *vary_hdrs[] = { "Accept", "Accept-Encoding", "Brief",
+                                    "Prefer", "If-None-Match",
+                                    "CalDAV-Timezones", NULL };
 
         comma_list_hdr(txn, "Vary", vary_hdrs, txn->flags.vary);
     }
@@ -2838,18 +2655,16 @@ EXPORTED void response_header(long code,
     }
     else if (auth_chal->param) {
         /* Authentication completed with success data */
-        if (auth_chal->scheme->send_success) {
+        if (auth_chal->scheme->flags & AUTH_SUCCESS_WWW) {
             /* Special handling of success data for this scheme */
-            auth_chal->scheme->send_success(txn, auth_chal->scheme->name,
-                                            auth_chal->param);
+            WWW_Authenticate(auth_chal->scheme->name, auth_chal->param);
         }
         else {
             /* Default handling of success data */
-            WWW_Authenticate(auth_chal->scheme->name, auth_chal->param);
+            simple_hdr(txn, "Authentication-Info", "%s", auth_chal->param);
         }
     }
 
-    
     /* Response Context */
     if (txn->req_tgt.allow & ALLOW_ISCHEDULE) {
         simple_hdr(txn, "iSchedule-Version", "1.0");
@@ -2858,9 +2673,6 @@ EXPORTED void response_header(long code,
             simple_hdr(txn, "iSchedule-Capabilities", "%ld", resp_body->iserial);
         }
     }
-    if (resp_body->link) {
-        simple_hdr(txn, "Link", resp_body->link);
-    }
     if (resp_body->patch) {
         accept_patch_hdr(txn, resp_body->patch);
     }
@@ -2868,6 +2680,13 @@ EXPORTED void response_header(long code,
     switch (code) {
     case HTTP_OK:
         switch (txn->meth) {
+        case METH_CONNECT:
+            if (txn->ws_ctx) {
+                /* Add WebSocket headers */
+                ws_add_resp_hdrs(txn);
+            }
+            break;
+
         case METH_GET:
         case METH_HEAD:
             /* Construct Accept-Ranges header for GET and HEAD responses */
@@ -2877,7 +2696,7 @@ EXPORTED void response_header(long code,
 
         case METH_OPTIONS:
             if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-                simple_hdr(txn, "Server", buf_cstring(&serverinfo));
+                simple_hdr(txn, "Server", "%s", buf_cstring(&serverinfo));
             }
 
             if (!httpd_userid && !auth_chal->scheme) {
@@ -2929,11 +2748,10 @@ EXPORTED void response_header(long code,
 
     case HTTP_BAD_CE:
         /* Construct Accept-Encoding header for 415 response */
-#ifdef HAVE_ZLIB
-        simple_hdr(txn, "Accept-Encoding", "gzip, deflate");
-#else
-        simple_hdr(txn, "Accept-Encoding", "identity");
-#endif
+        if (accept_encodings) {
+            comma_list_hdr(txn, "Accept-Encoding", ce, accept_encodings);
+        }
+        else simple_hdr(txn, "Accept-Encoding", "identity");
         break;
     }
 
@@ -2953,14 +2771,14 @@ EXPORTED void response_header(long code,
     }
     if (resp_body->etag) {
         simple_hdr(txn, "ETag", "%s\"%s\"",
-                      resp_body->enc ? "W/" : "", resp_body->etag);
+                      resp_body->enc.proc ? "W/" : "", resp_body->etag);
         if (txn->flags.cors) Access_Control_Expose("ETag");
     }
     if (resp_body->lastmod) {
         /* Last-Modified MUST NOT be in the future */
         resp_body->lastmod = MIN(resp_body->lastmod, now);
         httpdate_gen(datestr, sizeof(datestr), resp_body->lastmod);
-        simple_hdr(txn, "Last-Modified", datestr);
+        simple_hdr(txn, "Last-Modified", "%s", datestr);
     }
 
 
@@ -2974,28 +2792,42 @@ EXPORTED void response_header(long code,
         if (txn->flags.cors) Access_Control_Expose("Preference-Applied");
     }
     if (resp_body->cmid) {
-        simple_hdr(txn, "Cal-Managed-ID", "\"%s\"", resp_body->cmid);
+        simple_hdr(txn, "Cal-Managed-ID", "%s", resp_body->cmid);
         if (txn->flags.cors) Access_Control_Expose("Cal-Managed-ID");
     }
     if (resp_body->type) {
-        simple_hdr(txn, "Content-Type", resp_body->type);
-
-        if (resp_body->fname) {
-            simple_hdr(txn, "Content-Disposition",
-                       "attachment; filename=\"%s\"", resp_body->fname);
+        simple_hdr(txn, "Content-Type", "%s", resp_body->type);
+        if (resp_body->dispo.fname) {
+            /* Construct Content-Disposition header */
+            const unsigned char *p = (const unsigned char *)resp_body->dispo.fname;
+            char *encfname = NULL;
+            for (p = (unsigned char *)resp_body->dispo.fname; p && *p; p++) {
+                if (*p >= 0x80) {
+                    encfname = charset_encode_mimexvalue(resp_body->dispo.fname, NULL);
+                    break;
+                }
+            }
+            if (encfname) {
+                simple_hdr(txn, "Content-Disposition", "%s; filename*=%s",
+                        resp_body->dispo.attach ? "attachment" : "inline",
+                        encfname);
+            }
+            else {
+                simple_hdr(txn, "Content-Disposition", "%s; filename=\"%s\"",
+                        resp_body->dispo.attach ? "attachment" : "inline",
+                        resp_body->dispo.fname);
+            }
+            free(encfname);
         }
-        if (txn->resp_body.enc) {
+        if (txn->resp_body.enc.proc) {
             /* Construct Content-Encoding header */
-            const char *ce[] =
-                { "deflate", "gzip", "br", NULL };
-
-            comma_list_hdr(txn, "Content-Encoding", ce, txn->resp_body.enc);
+            comma_list_hdr(txn, "Content-Encoding", ce, txn->resp_body.enc.type);
         }
         if (resp_body->lang) {
-            simple_hdr(txn, "Content-Language", resp_body->lang);
+            simple_hdr(txn, "Content-Language", "%s", resp_body->lang);
         }
         if (resp_body->loc) {
-            simple_hdr(txn, "Content-Location", resp_body->loc);
+            simple_hdr(txn, "Content-Location", "%s", resp_body->loc);
             if (txn->flags.cors) Access_Control_Expose("Content-Location");
         }
         if (resp_body->md5) {
@@ -3038,140 +2870,257 @@ EXPORTED void response_header(long code,
             /* HTTP/1.1 only - we use close-delimiting for HTTP/1.0 */
             if (txn->flags.ver == VER_1_1) {
                 /* Construct Transfer-Encoding header */
-                const char *te[] =
-                    { "deflate", "gzip", "chunked", NULL };
-
                 comma_list_hdr(txn, "Transfer-Encoding", te, txn->flags.te);
             }
 
             if (txn->flags.trailer & ~TRAILER_PROXY) {
                 /* Construct Trailer header */
-                const char *trailer_hdrs[] = { "Content-MD5", NULL };
+                const char *trailer_hdrs[] = { "Content-MD5", "CTag", NULL };
 
                 comma_list_hdr(txn, "Trailer", trailer_hdrs, txn->flags.trailer);
             }
         }
-        else if (resp_body->len || txn->meth != METH_HEAD) {
-            simple_hdr(txn, "Content-Length", "%lu", resp_body->len);
+        else {
+            /* Content-Length */
+            switch (txn->meth) {
+            case METH_CONNECT:
+                /* MUST NOT include per Section 4.3.6 of RFC 7231 */
+                break;
+
+            case METH_HEAD:
+                if (!resp_body->len) {
+                    /* We don't know if the length is zero or if it wasn't set -
+                       MUST NOT include if it doesn't match what would be
+                       returned for GET, per Section 3.3.2 of RFC 7231 */
+                    break;
+                }
+
+                GCC_FALLTHROUGH
+
+            default:
+                simple_hdr(txn, "Content-Length", "%lu", resp_body->len);
+                break;
+            }
         }
     }
 
 
+    /* Extra headers */
+    if (resp_body->extra_hdrs) {
+        spool_enum_hdrcache(resp_body->extra_hdrs, &write_cachehdr, txn);
+    }
+
+
     /* End of headers */
     end_resp_headers(txn, code);
 
 
+  log:
     /* Log the client request and our response */
-    buf_reset(&log);
+    buf_reset(logbuf);
+
     /* Add client data */
-    buf_printf(&log, "%s", httpd_clienthost);
-    if (httpd_userid) buf_printf(&log, " as \"%s\"", httpd_userid);
+    buf_printf(logbuf, "%s", txn->conn->clienthost);
+    if (httpd_userid) buf_printf(logbuf, " as \"%s\"", httpd_userid);
     if (txn->req_hdrs &&
         (hdr = spool_getheader(txn->req_hdrs, "User-Agent"))) {
-        buf_printf(&log, " with \"%s\"", hdr[0]);
+        buf_printf(logbuf, " with \"%s\"", hdr[0]);
         if ((hdr = spool_getheader(txn->req_hdrs, "X-Client")))
-            buf_printf(&log, " by \"%s\"", hdr[0]);
+            buf_printf(logbuf, " by \"%s\"", hdr[0]);
         else if ((hdr = spool_getheader(txn->req_hdrs, "X-Requested-With")))
-            buf_printf(&log, " by \"%s\"", hdr[0]);
+            buf_printf(logbuf, " by \"%s\"", hdr[0]);
     }
+
+    /* Add session id */
+    buf_printf(logbuf, " via SESSIONID=<%s>", session_id());
+
     /* Add request-line */
-    buf_appendcstr(&log, "; \"");
+    buf_appendcstr(logbuf, "; \"");
     if (txn->req_line.meth) {
-        buf_printf(&log, "%s",
+        buf_printf(logbuf, "%s",
                    txn->flags.override ? "POST" : txn->req_line.meth);
         if (txn->req_line.uri) {
-            buf_printf(&log, " %s", txn->req_line.uri);
+            buf_printf(logbuf, " %s", txn->req_line.uri);
             if (txn->req_line.ver) {
-                buf_printf(&log, " %s", txn->req_line.ver);
+                buf_printf(logbuf, " %s", txn->req_line.ver);
                 if (code != HTTP_URI_TOO_LONG && *txn->req_line.buf) {
-                    char *p = txn->req_line.ver + strlen(txn->req_line.ver) + 1;
-                    if (*p) buf_printf(&log, " %s", p);
+                    const char *p =
+                        txn->req_line.ver + strlen(txn->req_line.ver) + 1;
+                    if (*p) buf_printf(logbuf, " %s", p);
                 }
             }
         }
     }
-    buf_appendcstr(&log, "\"");
+    buf_appendcstr(logbuf, "\"");
+
     if (txn->req_hdrs) {
         /* Add any request modifying headers */
-        const char *sep = " (";
+        sep = " (";
 
         if (txn->flags.override) {
-            buf_printf(&log, "%smethod-override=%s", sep, txn->req_line.meth);
+            buf_printf(logbuf, "%smethod-override=%s", sep, txn->req_line.meth);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "Origin"))) {
-            buf_printf(&log, "%sorigin=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sorigin=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "Referer"))) {
-            buf_printf(&log, "%sreferer=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sreferer=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if (txn->flags.upgrade &&
+            (hdr = spool_getheader(txn->req_hdrs, "Upgrade"))) {
+            buf_printf(logbuf, "%supgrade=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if (code == HTTP_CONTINUE || code == HTTP_EXPECT_FAILED) {
+            hdr = spool_getheader(txn->req_hdrs, "Expect");
+            buf_printf(logbuf, "%sexpect=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, "Transfer-Encoding"))) {
+            buf_printf(logbuf, "%stx-encoding=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, "Content-Encoding"))) {
+            buf_printf(logbuf, "%scnt-encoding=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if (txn->auth_chal.scheme) {
+            buf_printf(logbuf, "%sauth=%s", sep, txn->auth_chal.scheme->name);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "Destination"))) {
-            buf_printf(&log, "%sdestination=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sdestination=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "Lock-Token"))) {
-            buf_printf(&log, "%slock-token=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%slock-token=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "If"))) {
-            buf_printf(&log, "%sif=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "If-Schedule-Tag-Match"))) {
-            buf_printf(&log, "%sif-schedule-tag-match=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif-schedule-tag-match=%s", sep, hdr[0]);
             sep = "; ";
         }
         else if ((hdr = spool_getheader(txn->req_hdrs, "If-Match"))) {
-            buf_printf(&log, "%sif-match=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif-match=%s", sep, hdr[0]);
             sep = "; ";
         }
         else if ((hdr = spool_getheader(txn->req_hdrs, "If-Unmodified-Since"))) {
-            buf_printf(&log, "%sif-unmodified-since=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif-unmodified-since=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "If-None-Match"))) {
-            buf_printf(&log, "%sif-none-match=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif-none-match=%s", sep, hdr[0]);
             sep = "; ";
         }
         else if ((hdr = spool_getheader(txn->req_hdrs, "If-Modified-Since"))) {
-            buf_printf(&log, "%sif-modified-since=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sif-modified-since=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, ":type"))) {
-            buf_printf(&log, "%stype=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%stype=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, ":token"))) {
+            buf_printf(logbuf, "%stoken=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, ":jmap"))) {
+            buf_printf(logbuf, "%sjmap=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, ":dblookup"))) {
+            buf_printf(logbuf, "%slookup=%s", sep, hdr[0]);
             sep = "; ";
         }
         if ((hdr = spool_getheader(txn->req_hdrs, "Depth"))) {
-            buf_printf(&log, "%sdepth=%s", sep, hdr[0]);
+            buf_printf(logbuf, "%sdepth=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, "Prefer"))) {
+            buf_printf(logbuf, "%sprefer=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        else if ((hdr = spool_getheader(txn->req_hdrs, "Brief"))) {
+            buf_printf(logbuf, "%sbrief=%s", sep, hdr[0]);
+            sep = "; ";
+        }
+        if ((hdr = spool_getheader(txn->req_hdrs, "CalDAV-Timezones"))) {
+            buf_printf(logbuf, "%scaldav-timezones=%s", sep, hdr[0]);
             sep = "; ";
         }
-        if (*sep == ';') buf_appendcstr(&log, ")");
+
+        if (*sep == ';') buf_appendcstr(logbuf, ")");
+    }
+
+    if (txn->flags.redirect) {
+        /* Add CGI local redirect */
+        buf_printf(logbuf, " => \"%s %s %s\"",
+                   txn->req_line.meth, txn->req_tgt.path, txn->req_line.ver);
     }
+
     /* Add response */
-    buf_printf(&log, " => \"%s %s\"",
-               txn->flags.ver == VER_2 ? HTTP2_VERSION : HTTP_VERSION,
-               error_message(code));
+    buf_printf(logbuf, " => \"%s\"", http_statusline(txn->flags.ver, code));
+
     /* Add any auxiliary response data */
+    sep = " (";
+    if (txn->strm_ctx) {
+        buf_printf(logbuf, "%sstream-id=%d", sep,
+                   http2_get_streamid(txn->strm_ctx));
+        sep = "; ";
+    }
+    if (code == HTTP_SWITCH_PROT || code == HTTP_UPGRADE) {
+        buf_printf(logbuf, "%supgrade=", sep);
+        comma_list_body(logbuf, upgrd_tokens, txn->flags.upgrade, NULL);
+        sep = "; ";
+    }
+    if (txn->flags.te) {
+        buf_printf(logbuf, "%stx-encoding=", sep);
+        comma_list_body(logbuf, te, txn->flags.te, NULL);
+        sep = "; ";
+    }
+    if (txn->resp_body.enc.proc) {
+        buf_printf(logbuf, "%scnt-encoding=", sep);
+        comma_list_body(logbuf, ce, txn->resp_body.enc.type, NULL);
+        sep = "; ";
+    }
     if (txn->location) {
-        buf_printf(&log, " (location=%s)", txn->location);
+        buf_printf(logbuf, "%slocation=%s", sep, txn->location);
+        sep = "; ";
     }
     else if (txn->flags.cors) {
-        buf_appendcstr(&log, " (allow-origin)");
+        buf_printf(logbuf, "%sallow-origin", sep);
+        sep = "; ";
     }
     else if (txn->error.desc) {
-        buf_printf(&log, " (error=%s)", txn->error.desc);
+        buf_printf(logbuf, "%serror=%s", sep, txn->error.desc);
+        sep = "; ";
     }
-    syslog(LOG_INFO, "%s", buf_cstring(&log));
+    if (*sep == ';') buf_appendcstr(logbuf, ")");
+
+    /* Add timing stats */
+    cmdtime_endtimer(&cmdtime, &nettime);
+    buf_printf(logbuf, " [timing: cmd=%f net=%f total=%f]",
+               cmdtime, nettime, cmdtime + nettime);
+
+    syslog(LOG_INFO, "%s", buf_cstring(logbuf));
 }
 
 
+#ifdef HAVE_DECLARE_OPTIMIZE
+EXPORTED inline void keepalive_response(struct transaction_t *txn)
+    __attribute__((always_inline, optimize("-O3")));
+#endif
 EXPORTED void keepalive_response(struct transaction_t *txn)
 {
     if (gotsigalrm) {
         response_header(HTTP_PROCESSING, txn);
-        alarm(httpd_keepalive);
     }
 }
 
@@ -3181,11 +3130,16 @@ EXPORTED void keepalive_response(struct
  *
  * An initial call with 'code' != 0 will output a response header
  * and the preamble.
+ *
  * All subsequent calls should have 'code' = 0 to output just a body part.
+ * A body part may include custom headers (exluding Content-Type and Length),
+ * which must be properly folded and must end with CRLF.
+ *
  * A final call with 'len' = 0 ends the multipart body.
  */
 EXPORTED void write_multipart_body(long code, struct transaction_t *txn,
-                          const char *buf, unsigned len)
+                                   const char *buf, unsigned len,
+                                   const char *part_headers)
 {
     static char boundary[100];
     struct buf *body = &txn->resp_body.payload;
@@ -3198,7 +3152,7 @@ EXPORTED void write_multipart_body(long
 
         /* Create multipart boundary */
         snprintf(boundary, sizeof(boundary), "%s-%ld-%ld-%ld",
-                 *spool_getheader(txn->req_hdrs, "Host"),
+                 *spool_getheader(txn->req_hdrs, ":authority"),
                  (long) getpid(), (long) time(0), (long) rand());
 
         /* Create Content-Type w/ boundary */
@@ -3226,7 +3180,11 @@ EXPORTED void write_multipart_body(long
                        txn->resp_body.range->last,
                        txn->resp_body.len);
         }
-        buf_printf(body, "Content-Length: %d\r\n\r\n", len);
+        buf_printf(body, "Content-Length: %d\r\n", len);
+        if (part_headers) {
+            buf_appendcstr(body, part_headers);
+        }
+        buf_appendcstr(body, "\r\n");
         write_body(0, txn, buf_cstring(body), buf_len(body));
 
         /* Output body-part data */
@@ -3257,7 +3215,7 @@ static void multipart_byteranges(struct
     /* Start multipart response */
     txn->resp_body.range = NULL;
     txn->resp_body.type = "multipart/byteranges";
-    write_multipart_body(HTTP_PARTIAL, txn, NULL, 0);
+    write_multipart_body(HTTP_PARTIAL, txn, NULL, 0, NULL);
 
     txn->resp_body.type = type;
     while (range) {
@@ -3267,7 +3225,7 @@ static void multipart_byteranges(struct
 
         /* Output range as body part */
         txn->resp_body.range = range;
-        write_multipart_body(0, txn, msg_base + offset, datalen);
+        write_multipart_body(0, txn, msg_base + offset, datalen, NULL);
 
         /* Cleanup */
         free(range);
@@ -3275,7 +3233,7 @@ static void multipart_byteranges(struct
     }
 
     /* End of multipart body */
-    write_multipart_body(0, txn, NULL, 0);
+    write_multipart_body(0, txn, NULL, 0, NULL);
 }
 
 
@@ -3309,100 +3267,25 @@ EXPORTED void write_body(long code, stru
 
         if (len < GZIP_MIN_LEN) {
             /* Don't compress small static content */
-            txn->resp_body.enc = CE_IDENTITY;
+            txn->resp_body.enc.type = CE_IDENTITY;
+            txn->resp_body.enc.proc = NULL;
             txn->flags.te = TE_NONE;
         }
     }
 
     /* Compress data */
-    if (txn->resp_body.enc == CE_BR) {
-#ifdef HAVE_BROTLI
-        /* Only flush for static content or on last (zero-length) chunk */
-        unsigned op = last_chunk ?
-            BROTLI_OPERATION_FINISH : BROTLI_OPERATION_FLUSH;
-        BrotliEncoderState *brotli = txn->conn->brotli;
-        const uint8_t *next_in = (const uint8_t *) buf;
-        size_t avail_in = (size_t) len;
-
-        buf_ensure(&txn->zbuf, BrotliEncoderMaxCompressedSize(avail_in));
-        buf_reset(&txn->zbuf);
+    if (txn->resp_body.enc.proc || txn->flags.te & ~TE_CHUNKED) {
+        unsigned flags = 0;
 
-        do {
-            uint8_t *next_out = (uint8_t *) txn->zbuf.s + txn->zbuf.len;
-            size_t avail_out = txn->zbuf.alloc - txn->zbuf.len;
-
-            if (!BrotliEncoderCompressStream(brotli, op,
-                                             &avail_in, &next_in,
-                                             &avail_out, &next_out, NULL)) {
-                syslog(LOG_ERR, "Brotli: Error while compressing data");
-                fatal("Brotli: Error while compressing data", EC_SOFTWARE);
-            }
-
-            txn->zbuf.len = txn->zbuf.alloc - avail_out;
-        } while (avail_in || BrotliEncoderHasMoreOutput(brotli));
+        if (code) flags |= COMPRESS_START;
+        if (last_chunk) flags |= COMPRESS_END;
 
-        buf = txn->zbuf.s;
-        outlen = txn->zbuf.len;
-
-        if (BrotliEncoderIsFinished(brotli)) {
-            BrotliEncoderDestroyInstance(brotli);
-            txn->conn->brotli = brotli_init();
+        if (txn->resp_body.enc.proc(txn, flags, buf, len) < 0) {
+            fatal("Error while compressing data", EX_SOFTWARE);
         }
-#else
-        /* XXX should never get here */
-        fatal("Brotli Compression requested, but not available", EC_SOFTWARE);
-#endif /* HAVE_BROTLI */
-    }
-    else if (txn->resp_body.enc || txn->flags.te & ~TE_CHUNKED) {
-#ifdef HAVE_ZLIB
-        /* Only flush for static content or on last (zero-length) chunk */
-        unsigned flush = last_chunk ? Z_FINISH : Z_NO_FLUSH;
-        z_stream *zstrm = txn->conn->zstrm;
-
-        if (code) deflateReset(zstrm);
-
-        zstrm->next_in = (Bytef *) buf;
-        zstrm->avail_in = len;
-
-        buf_ensure(&txn->zbuf, deflateBound(zstrm, zstrm->avail_in));
-        buf_reset(&txn->zbuf);
-
-        do {
-	    int zr;
-
-	    if (!zstrm->avail_out) {
-		unsigned pending;
-
-		zr = deflatePending(zstrm, &pending, Z_NULL);
-		if (zr != Z_OK) {
-		    /* something went wrong */
-		    syslog(LOG_ERR, "zlib deflate error: %d %s", zr, zstrm->msg);
-		    fatal("zlib: Error while compressing data", EC_SOFTWARE);
-		}
-
-		buf_ensure(&txn->zbuf, pending);
-	    }
-
-            zstrm->next_out = (Bytef *) txn->zbuf.s + txn->zbuf.len;
-            zstrm->avail_out = txn->zbuf.alloc - txn->zbuf.len;
-
-            zr = deflate(zstrm, flush);
-            if (!(zr == Z_OK || zr == Z_STREAM_END || zr == Z_BUF_ERROR)) {
-		/* something went wrong */
-		syslog(LOG_ERR, "zlib deflate error: %d %s", zr, zstrm->msg);
-                fatal("zlib: Error while compressing data", EC_SOFTWARE);
-            }
-
-            txn->zbuf.len = txn->zbuf.alloc - zstrm->avail_out;
-
-        } while (!zstrm->avail_out);
 
         buf = txn->zbuf.s;
         outlen = txn->zbuf.len;
-#else
-        /* XXX should never get here */
-        fatal("Compression requested, but no zlib", EC_SOFTWARE);
-#endif /* HAVE_ZLIB */
     }
 
     if (code) {
@@ -3467,7 +3350,7 @@ EXPORTED void write_body(long code, stru
             /* HTTP/1.0 doesn't support chunked - close-delimit the body */
             txn->flags.conn = CONN_CLOSE;
         }
-        else if (do_md5) txn->flags.trailer = TRAILER_CMD5;
+        else if (do_md5) txn->flags.trailer |= TRAILER_CMD5;
 
         response_header(code, txn);
 
@@ -3486,57 +3369,13 @@ EXPORTED void write_body(long code, stru
     }
 
     /* Output data */
-#ifdef HAVE_NGHTTP2
     if (txn->flags.ver == VER_2) {
-        int r;
-        uint8_t flags = NGHTTP2_FLAG_END_STREAM;
-        struct protstream *s = prot_readmap(buf + offset, outlen);
-        nghttp2_data_provider prd;
-
-        prd.source.ptr = s;
-        prd.read_callback = http2_data_source_read_cb;
-
-        if (txn->flags.te) {
-            if (!last_chunk) {
-                flags = NGHTTP2_FLAG_NONE;
-                if (outlen && (txn->flags.trailer & TRAILER_CMD5)) {
-                    MD5Update(&ctx, buf + offset, outlen);
-                }
-            }
-            else if (txn->flags.trailer) {
-                flags = NGHTTP2_FLAG_NONE;
-                if (txn->flags.trailer & TRAILER_CMD5) MD5Final(md5, &ctx);
-            }
-        }
-
-        syslog(LOG_DEBUG,
-               "nghttp2_submit_data(id=%d, len=%d, outlen=%d, flags=%#x)",
-               txn->http2.stream_id, len, outlen, flags);
-
-        r = nghttp2_submit_data(txn->conn->http2_session,
-                                flags, txn->http2.stream_id, &prd);
-        if (r) {
-            syslog(LOG_ERR, "nghttp2_submit_data: %s", nghttp2_strerror(r));
-        }
-        else {
-            r = nghttp2_session_send(txn->conn->http2_session);
-            if (r) {
-                syslog(LOG_ERR, "nghttp2_session_send: %s", nghttp2_strerror(r));
-            }
-        }
-
-        if (last_chunk && (txn->flags.trailer & TRAILER_CMD5)) {
-            begin_resp_headers(txn, 0);
-            content_md5_hdr(txn, md5);
-            end_resp_headers(txn, 0);
+        /* HTTP/2 chunk */
+        if (outlen || txn->flags.te) {
+            http2_data_chunk(txn, buf + offset, outlen, last_chunk, &ctx);
         }
-
-        prot_free(s);
-        return;
     }
-#endif /* HAVE_NGHTTP2 */
-
-    if (txn->flags.te && txn->flags.ver == VER_1_1) {
+    else if (txn->flags.te && txn->flags.ver == VER_1_1) {
         /* HTTP/1.1 chunk */
         if (outlen) {
             syslog(LOG_DEBUG, "write_body: chunk(%d)", outlen);
@@ -3553,10 +3392,14 @@ EXPORTED void write_body(long code, stru
 
             /* Trailer */
             if (txn->flags.trailer & TRAILER_CMD5) {
-                syslog(LOG_DEBUG, "write_body: trailer");
+                syslog(LOG_DEBUG, "write_body: trailer Content-MD5");
                 MD5Final(md5, &ctx);
                 content_md5_hdr(txn, md5);
             }
+            if ((txn->flags.trailer & TRAILER_CTAG) && txn->resp_body.ctag) {
+                syslog(LOG_DEBUG, "write_body: trailer CTag");
+                simple_hdr(txn, "CTag", "%s", txn->resp_body.ctag);
+            }
 
             if (txn->flags.trailer != TRAILER_PROXY) {
                 syslog(LOG_DEBUG, "write_body: CRLF");
@@ -3595,6 +3438,17 @@ EXPORTED void xml_response(long code, st
                               config_httpprettytelemetry);
 
     if (buf) {
+        if (txn->flags.te & TE_CHUNKED) {
+            /* Start of XML chunked response */
+            xmlChar *cp;
+            int n;
+
+            /* Leave root element open */
+            for (cp = buf + --bufsiz, n = 0; *cp != '/'; cp--, n++);
+            if (*(cp+1) == '>') memmove(cp, cp+1, n);  /* <root/> */
+            else bufsiz -= n+1;  /* </root> */
+        }
+
         /* Output the XML response */
         txn->resp_body.type = "application/xml; charset=utf-8";
 
@@ -3610,7 +3464,61 @@ EXPORTED void xml_response(long code, st
     }
 }
 
-EXPORTED void buf_printf_markup(struct buf *buf, unsigned level, const char *fmt, ...)
+/* Output a chunk of an XML response */
+EXPORTED void xml_partial_response(struct transaction_t *txn,
+                                   xmlDocPtr doc, xmlNodePtr node,
+                                   unsigned level, xmlBufferPtr *buf)
+{
+    const char *eol = "\n";
+    unsigned n;
+
+    if (!config_httpprettytelemetry) {
+        level = 0;
+        eol = "";
+    }
+
+    /* Start with clean buffer */
+    if (!*buf) *buf = xmlBufferCreate();
+
+    if (node) {
+        /* Add leading indent to buffer */
+        for (n = 0; n < level * MARKUP_INDENT; n++) xmlBufferCCat(*buf, " ");
+
+        /* Dump XML node into buffer */
+        xmlNodeDump(*buf, doc, node, level, config_httpprettytelemetry);
+
+        /* Add trailing EOL to buffer */
+        xmlBufferCCat(*buf, eol);
+    }
+    else {
+        /* End of chunked XML response */
+        xmlNodePtr root = xmlDocGetRootElement(doc);
+
+        /* Add close of root element to buffer */
+        xmlBufferCCat(*buf, "</");
+        if (root->ns->prefix) {
+            xmlBufferCat(*buf, root->ns->prefix);
+            xmlBufferCCat(*buf, ":");
+        }
+        xmlBufferCat(*buf, root->name);
+        xmlBufferCCat(*buf, ">");
+
+        /* Add trailing EOL to buffer */
+        xmlBufferCCat(*buf, eol);
+    }
+
+    if (txn) {
+        /* Output the XML buffer */
+        write_body(0, txn,
+                   (char *) xmlBufferContent(*buf), xmlBufferLength(*buf));
+
+        /* Reset the buffer for next chunk */
+        xmlBufferEmpty(*buf);
+    }
+}
+
+EXPORTED void buf_printf_markup(struct buf *buf, unsigned level,
+                                const char *fmt, ...)
 {
     va_list args;
     const char *eol = "\n";
@@ -3698,7 +3606,7 @@ EXPORTED void error_response(long code,
         unsigned level = 0;
 
         if (txn->req_hdrs &&
-            (hdr = spool_getheader(txn->req_hdrs, "Host")) &&
+            (hdr = spool_getheader(txn->req_hdrs, ":authority")) &&
             hdr[0] && *hdr[0]) {
             host = (char *) hdr[0];
             if ((port = strchr(host, ':'))) *port++ = '\0';
@@ -3707,8 +3615,8 @@ EXPORTED void error_response(long code,
             host = config_servername;
         }
         if (!port) {
-            port = (saslprops.iplocalport) ?
-                strchr(saslprops.iplocalport, ';')+1 : "";
+            port = (buf_len(&saslprops.iplocalport)) ?
+                strchr(buf_cstring(&saslprops.iplocalport), ';')+1 : "";
         }
 
         buf_printf_markup(html, level, HTML_DOCTYPE);
@@ -3763,7 +3671,7 @@ static int proxy_authz(const char **auth
     if (!(config_mupdate_server && config_getstring(IMAPOPT_PROXYSERVERS))) {
         /* Not a backend in a Murder - proxy authz is not allowed */
         syslog(LOG_NOTICE, "badlogin: %s %s %s %s",
-               httpd_clienthost, txn->auth_chal.scheme->name, saslprops.authid,
+               txn->conn->clienthost, txn->auth_chal.scheme->name, httpd_authid,
                "proxy authz attempted on non-Murder backend");
         return SASL_NOAUTHZ;
     }
@@ -3775,7 +3683,7 @@ static int proxy_authz(const char **auth
                                authzbuf, sizeof(authzbuf), &authzlen);
     if (status) {
         syslog(LOG_NOTICE, "badlogin: %s %s %s invalid user",
-               httpd_clienthost, txn->auth_chal.scheme->name,
+               txn->conn->clienthost, txn->auth_chal.scheme->name,
                beautify_string(*authzid));
         return status;
     }
@@ -3783,12 +3691,12 @@ static int proxy_authz(const char **auth
     /* See if auth'd user is allowed to proxy */
     status = mysasl_proxy_policy(httpd_saslconn, &httpd_proxyctx,
                                  authzbuf, authzlen,
-                                 saslprops.authid, strlen(saslprops.authid),
+                                 httpd_authid, strlen(httpd_authid),
                                  NULL, 0, NULL);
 
     if (status) {
         syslog(LOG_NOTICE, "badlogin: %s %s %s %s",
-               httpd_clienthost, txn->auth_chal.scheme->name, saslprops.authid,
+               txn->conn->clienthost, txn->auth_chal.scheme->name, httpd_authid,
                sasl_errdetail(httpd_saslconn));
         return status;
     }
@@ -3800,35 +3708,40 @@ static int proxy_authz(const char **auth
 
 
 /* Write cached header (redacting authorization credentials) to buffer. */
-static void log_cachehdr(const char *name, const char *contents, void *rock)
+HIDDEN void log_cachehdr(const char *name, const char *contents,
+                         const char *raw, void *rock)
 {
     struct buf *buf = (struct buf *) rock;
 
     /* Ignore private headers in our cache */
     if (name[0] == ':') return;
 
-    buf_printf(buf, "%c%s: ", toupper(name[0]), name+1);
-    if (!strcmp(name, "authorization")) {
+    if (!strcasecmp(name, "authorization")) {
         /* Replace authorization credentials with an ellipsis */
         const char *creds = strchr(contents, ' ') + 1;
-        buf_printf(buf, "%.*s%-*s\r\n", (int) (creds - contents), contents,
+        buf_printf(buf, "%c%s: %.*s%-*s\r\n", toupper(name[0]), name+1,
+                   (int) (creds - contents), contents,
                    (int) strlen(creds), "...");
     }
-    else buf_printf(buf, "%s\r\n", contents);
+    else if (raw)
+        buf_appendcstr(buf, raw);
+    else
+        buf_printf(buf, "%c%s: %s\r\n", toupper(name[0]), name+1, contents);
 }
 
 
-static void auth_success(struct transaction_t *txn, const char *userid)
+static int auth_success(struct transaction_t *txn, const char *userid)
 {
     struct auth_scheme_t *scheme = txn->auth_chal.scheme;
+    int logfd = txn->conn->logfd;
     int i;
 
     httpd_userid = xstrdup(userid);
     httpd_userisanonymous = is_userid_anonymous(httpd_userid);
 
     syslog(LOG_NOTICE, "login: %s %s %s%s %s SESSIONID=<%s>",
-           httpd_clienthost, httpd_userid, scheme->name,
-           httpd_tls_done ? "+TLS" : "", "User logged in",
+           txn->conn->clienthost, httpd_userid, scheme->name,
+           txn->conn->tls_ctx ? "+TLS" : "", "User logged in",
            session_id());
 
 
@@ -3844,34 +3757,43 @@ static void auth_success(struct transact
     buf_appendmap(&txn->buf,                            /* buffered input */
                   (const char *) httpd_in->ptr, httpd_in->cnt);
 
-    if (httpd_logfd != -1) {
+    if (logfd != -1) {
         /* Rewind log to current request and truncate it */
-        off_t end = lseek(httpd_logfd, 0, SEEK_END);
+        off_t end = lseek(logfd, 0, SEEK_END);
 
-        ftruncate(httpd_logfd, end - buf_len(&txn->buf));
+        if (ftruncate(logfd, end - buf_len(&txn->buf)))
+            syslog(LOG_ERR, "IOERROR: failed to truncate http log");
 
         /* Close existing telemetry log */
-        close(httpd_logfd);
+        close(logfd);
     }
 
     prot_setlog(httpd_in, PROT_NO_FD);
     prot_setlog(httpd_out, PROT_NO_FD);
 
     /* Create telemetry log based on new userid */
-    httpd_logfd = telemetry_log(httpd_userid, httpd_in, httpd_out, 0);
+    if (txn->conn->sess_ctx)
+        txn->conn->logfd = logfd = telemetry_log(userid, NULL, NULL, 0);
+    else
+        txn->conn->logfd = logfd = telemetry_log(userid, httpd_in, httpd_out, 0);
 
-    if (httpd_logfd != -1) {
+    if (logfd != -1) {
         /* Log credential-redacted request */
-        write(httpd_logfd, buf_cstring(&txn->buf), buf_len(&txn->buf));
+        if (write(logfd, buf_cstring(&txn->buf), buf_len(&txn->buf)) < 0)
+            syslog(LOG_ERR, "IOERROR: failed to write to http log");
     }
 
     buf_reset(&txn->buf);
 
     /* Do any namespace specific post-auth processing */
-    for (i = 0; namespaces[i]; i++) {
-        if (namespaces[i]->enabled && namespaces[i]->auth)
-            namespaces[i]->auth(httpd_userid);
+    for (i = 0; http_namespaces[i]; i++) {
+        if (http_namespaces[i]->enabled && http_namespaces[i]->auth) {
+            int ret = http_namespaces[i]->auth(httpd_userid);
+            if (ret) return ret;
+        }
     }
+
+    return 0;
 }
 
 /* Perform HTTP Authentication based on the given credentials ('creds').
@@ -3879,22 +3801,27 @@ static void auth_success(struct transact
  * May be called multiple times if auth scheme requires multiple steps.
  * SASL status between steps is maintained in 'status'.
  */
-#define BASE64_BUF_SIZE 21848   /* per RFC 4422: ((16K / 3) + 1) * 4  */
+#define MAX_AUTHPARAM_SIZE 10   /* "sid=,data=" */
+#define MAX_BASE64_SIZE 21848   /* per RFC 4422: ((16K / 3) + 1) * 4  */
+#define BASE64_BUF_SIZE (MAX_AUTHPARAM_SIZE +MAX_SESSIONID_SIZE +MAX_BASE64_SIZE)
 
 static int http_auth(const char *creds, struct transaction_t *txn)
 {
     struct auth_challenge_t *chal = &txn->auth_chal;
     static int status = SASL_OK;
-    int slen;
+    int slen, r;
     const char *clientin = NULL, *realm = NULL, *user, **authzid;
     unsigned int clientinlen = 0;
     struct auth_scheme_t *scheme;
     static char base64[BASE64_BUF_SIZE+1];
-    const void *canon_user;
+    const void *canon_user = NULL;
 
     /* Split credentials into auth scheme and response */
-    slen = strcspn(creds, " \0");
-    if ((clientin = strchr(creds, ' '))) clientinlen = strlen(++clientin);
+    slen = strcspn(creds, " ");
+    if ((clientin = strchr(creds + slen, ' '))) {
+        while (strchr(" ", *++clientin));  /* Trim leading 1*SP */
+        clientinlen = strlen(clientin);
+    }
 
     syslog(LOG_DEBUG,
            "http_auth: status=%d   scheme='%s'   creds='%.*s%s'",
@@ -3939,7 +3866,7 @@ static int http_auth(const char *creds,
         for (scheme = auth_schemes; scheme->name; scheme++) {
             if (slen && !strncasecmp(scheme->name, creds, slen)) {
                 /* Found a supported scheme, see if its available */
-                if (!(avail_auth_schemes & (1 << scheme->idx))) scheme = NULL;
+                if (!(avail_auth_schemes & scheme->id)) scheme = NULL;
                 break;
             }
         }
@@ -3952,70 +3879,77 @@ static int http_auth(const char *creds,
         syslog(LOG_DEBUG, "http_auth: found matching scheme: %s", scheme->name);
         chal->scheme = scheme;
         status = SASL_OK;
-    }
 
-    /* Base64 decode any client response, if necesary */
-    if (clientin && (scheme->flags & AUTH_BASE64)) {
-        int r = sasl_decode64(clientin, clientinlen,
-                              base64, BASE64_BUF_SIZE, &clientinlen);
-        if (r != SASL_OK) {
-            syslog(LOG_ERR, "Base64 decode failed: %s",
-                   sasl_errstring(r, NULL, NULL));
-            return r;
+        if (!clientin && (scheme->flags & AUTH_REALM_PARAM)) {
+            /* Get realm - based on namespace of URL */
+            switch (txn->req_tgt.namespace->id) {
+            case URL_NS_DEFAULT:
+            case URL_NS_PRINCIPAL:
+                realm = config_getstring(IMAPOPT_DAV_REALM);
+                break;
+
+            case URL_NS_CALENDAR:
+                realm = config_getstring(IMAPOPT_CALDAV_REALM);
+                break;
+
+            case URL_NS_ADDRESSBOOK:
+                realm = config_getstring(IMAPOPT_CARDDAV_REALM);
+                break;
+
+            case URL_NS_RSS:
+                realm = config_getstring(IMAPOPT_RSS_REALM);
+                break;
+            }
+            if (!realm) realm = config_servername;
+
+            /* Create initial challenge (base64 buffer is static) */
+            snprintf(base64, BASE64_BUF_SIZE, "realm=\"%s\"", realm);
+            chal->param = base64;
+            chal->scheme = NULL;  /* make sure we don't reset the SASL ctx */
+            return status;
         }
-        clientin = base64;
     }
 
-    /* Get realm - based on namespace of URL */
-    switch (txn->req_tgt.namespace->id) {
-    case URL_NS_DEFAULT:
-    case URL_NS_PRINCIPAL:
-        realm = config_getstring(IMAPOPT_DAV_REALM);
-        break;
+    /* Parse any auth parameters, if necessary */
+    if (clientin && (scheme->flags & AUTH_DATA_PARAM)) {
+        const char *sid = NULL;
+        unsigned int sid_len;
 
-    case URL_NS_CALENDAR:
-        realm = config_getstring(IMAPOPT_CALDAV_REALM);
-        break;
+        r = http_parse_auth_params(clientin, NULL /* realm */, NULL,
+                                   &sid, &sid_len, &clientin, &clientinlen);
+        if (r != SASL_OK) return r;
 
-    case URL_NS_ADDRESSBOOK:
-        realm = config_getstring(IMAPOPT_CARDDAV_REALM);
-        break;
+        if (sid) {
+            const char *mysid = session_id();
 
-    case URL_NS_RSS:
-        realm = config_getstring(IMAPOPT_RSS_REALM);
-        break;
+            if (sid_len != strlen(mysid) ||
+                strncmp(mysid, sid, sid_len)) {
+                syslog(LOG_ERR, "%s: Incorrect 'sid' parameter in credentials",
+                       scheme->name);
+                return SASL_BADAUTH;
+            }
+        }
     }
-    if (!realm) realm = config_servername;
-
-#ifdef SASL_HTTP_REQUEST
-    /* Setup SASL HTTP request, if necessary */
-    if (scheme->flags & AUTH_NEED_REQUEST) {
-        sasl_http_request_t sasl_http_req;
 
-        sasl_http_req.method = txn->req_line.meth;
-        sasl_http_req.uri = txn->req_line.uri;
-        sasl_http_req.entity = NULL;
-        sasl_http_req.elen = 0;
-        sasl_http_req.non_persist = txn->flags.conn & CONN_CLOSE;
-        sasl_setprop(httpd_saslconn, SASL_HTTP_REQUEST, &sasl_http_req);
+    /* Base64 decode any client response, if necessary */
+    if (clientin && (scheme->flags & AUTH_BASE64)) {
+        r = sasl_decode64(clientin, clientinlen,
+                          base64, BASE64_BUF_SIZE, &clientinlen);
+        if (r != SASL_OK) {
+            syslog(LOG_ERR, "Base64 decode failed: %s",
+                   sasl_errstring(r, NULL, NULL));
+            return r;
+        }
+        clientin = base64;
     }
-#endif /* SASL_HTTP_REQUEST */
 
-    if (scheme->idx == AUTH_BASIC) {
+    if (scheme->id == AUTH_BASIC) {
         /* Basic (plaintext) authentication */
         char *pass;
         char *extra;
         char *plus;
         char *domain;
 
-        if (!clientin) {
-            /* Create initial challenge (base64 buffer is static) */
-            snprintf(base64, BASE64_BUF_SIZE, "realm=\"%s\"", realm);
-            chal->param = base64;
-            chal->scheme = NULL;  /* make sure we don't reset the SASL ctx */
-            return status;
-        }
-
         /* Split credentials into <user> ':' <pass>.
          * We are working with base64 buffer, so we can modify it.
          */
@@ -4032,15 +3966,19 @@ static int http_auth(const char *creds,
         if (extra) *extra++ = '\0';
         plus = strchr(user, '+');
         if (plus) *plus++ = '\0';
+
         /* Verify the password */
-        char *realuser = domain ? strconcat(user, "@", domain, (char *)NULL) : xstrdup(user);
+        char *realuser =
+            domain ? strconcat(user, "@", domain, (char *) NULL) : xstrdup(user);
+
         status = sasl_checkpass(httpd_saslconn, realuser, strlen(realuser),
                                 pass, strlen(pass));
         memset(pass, 0, strlen(pass));          /* erase plaintext password */
 
         if (status) {
             syslog(LOG_NOTICE, "badlogin: %s Basic %s %s",
-                   httpd_clienthost, realuser, sasl_errdetail(httpd_saslconn));
+                   txn->conn->clienthost, realuser,
+                   sasl_errdetail(httpd_saslconn));
             free(realuser);
 
             /* Don't allow user probing */
@@ -4053,25 +3991,18 @@ static int http_auth(const char *creds,
         httpd_extrafolder = xstrdupnull(plus);
         httpd_extradomain = xstrdupnull(extra);
     }
-    else if (scheme->idx == AUTH_BEARER) {
+    else if (scheme->id == AUTH_BEARER) {
         /* Bearer authentication */
         assert(txn->req_tgt.namespace->bearer);
 
-        if (!clientin) {
-            /* Create initial challenge (base64 buffer is static) */
-            snprintf(base64, BASE64_BUF_SIZE, "realm=\"%s\"", realm);
-            chal->param = base64;
-            chal->scheme = NULL;  /* make sure we don't reset the SASL ctx */
-            return status;
-        }
-
         /* Call namespace bearer authentication.
          * We are working with base64 buffer, so the namespace can
          * write the canonicalized userid into the buffer */
         base64[0] = 0;
-        status = txn->req_tgt.namespace->bearer(clientin, base64, BASE64_BUF_SIZE);
+        status = txn->req_tgt.namespace->bearer(clientin,
+                                                base64, BASE64_BUF_SIZE);
         if (status) return status;
-        user = base64;
+        canon_user = user = base64;
 
         /* Successful authentication - fall through */
         httpd_extrafolder = NULL;
@@ -4079,9 +4010,24 @@ static int http_auth(const char *creds,
         httpd_authstate = auth_newstate(user);
     }
     else {
-        /* SASL-based authentication (Digest, Negotiate, NTLM) */
+        /* SASL-based authentication (SCRAM_*, Digest, Negotiate, NTLM) */
         const char *serverout = NULL;
         unsigned int serveroutlen = 0;
+        unsigned int auth_params_len = 0;
+
+#ifdef SASL_HTTP_REQUEST
+        /* Setup SASL HTTP request, if necessary */
+        sasl_http_request_t sasl_http_req;
+
+        if (scheme->flags & AUTH_NEED_REQUEST) {
+            sasl_http_req.method = txn->req_line.meth;
+            sasl_http_req.uri = txn->req_line.uri;
+            sasl_http_req.entity = NULL;
+            sasl_http_req.elen = 0;
+            sasl_http_req.non_persist = txn->flags.conn & CONN_CLOSE;
+            sasl_setprop(httpd_saslconn, SASL_HTTP_REQUEST, &sasl_http_req);
+        }
+#endif /* SASL_HTTP_REQUEST */
 
         if (status == SASL_CONTINUE) {
             /* Continue current authentication exchange */
@@ -4104,10 +4050,18 @@ static int http_auth(const char *creds,
             return status;
         }
 
-        /* Base64 encode any server challenge, if necesary */
+        /* Prepend any auth parameters, if necessary */
+        if (scheme->flags & AUTH_DATA_PARAM) {
+            auth_params_len = snprintf(base64,
+                                       MAX_AUTHPARAM_SIZE + MAX_SESSIONID_SIZE,
+                                       "sid=%s%s", session_id(),
+                                       serverout ? ",data=" : "");
+        }
+
+        /* Base64 encode any server challenge, if necessary */
         if (serverout && (scheme->flags & AUTH_BASE64)) {
-            int r = sasl_encode64(serverout, serveroutlen,
-                                   base64, BASE64_BUF_SIZE, NULL);
+            r = sasl_encode64(serverout, serveroutlen,
+                              base64 + auth_params_len, MAX_BASE64_SIZE, NULL);
             if (r != SASL_OK) {
                 syslog(LOG_ERR, "Base64 encode failed: %s",
                        sasl_errstring(r, NULL, NULL));
@@ -4130,7 +4084,7 @@ static int http_auth(const char *creds,
          */
     }
 
-    if (scheme->idx != AUTH_BEARER) {
+    if (!canon_user) {
         /* Get the userid from SASL - already canonicalized */
         status = sasl_getprop(httpd_saslconn, SASL_USERNAME, &canon_user);
         if (status != SASL_OK) {
@@ -4140,8 +4094,8 @@ static int http_auth(const char *creds,
         user = (const char *) canon_user;
     }
 
-    if (saslprops.authid) free(saslprops.authid);
-    saslprops.authid = xstrdup(user);
+    if (httpd_authid) free(httpd_authid);
+    httpd_authid = xstrdup(user);
 
     authzid = spool_getheader(txn->req_hdrs, "Authorize-As");
     if (authzid && *authzid[0]) {
@@ -4152,7 +4106,19 @@ static int http_auth(const char *creds,
         if (status) return status;
     }
 
-    auth_success(txn, user);
+    /* Post-process the successful authentication. */
+    r = auth_success(txn, user);
+    if (r == HTTP_UNAVAILABLE) {
+        status = SASL_UNAVAIL;
+    }
+    else if (r) {
+        /* Any error here comes after the user already logged in,
+         * so avoid to return SASL_BADAUTH. It would trigger the
+         * HTTP handler to send UNAUTHORIZED, and might confuse
+         * users that provided their correct credentials. */
+        syslog(LOG_ERR, "auth_success returned error: %s", error_message(r));
+        status = SASL_FAIL;
+    }
 
     return status;
 }
@@ -4295,7 +4261,8 @@ EXPORTED int check_precond(struct transa
 
     /* Step 2 */
     else if ((hdr = spool_getheader(hdrcache, "If-Unmodified-Since"))) {
-        if (time_from_rfc822(hdr[0], &since) < 0) return HTTP_BAD_REQUEST;
+        if (time_from_rfc5322(hdr[0], &since, DATETIME_FULL) < 0)
+            return HTTP_BAD_REQUEST;
 
         if (lastmod > since) return HTTP_PRECOND_FAILED;
 
@@ -4317,7 +4284,8 @@ EXPORTED int check_precond(struct transa
     /* Step 4 */
     else if ((txn->meth == METH_GET || txn->meth == METH_HEAD) &&
              (hdr = spool_getheader(hdrcache, "If-Modified-Since"))) {
-        if (time_from_rfc822(hdr[0], &since) < 0) return HTTP_BAD_REQUEST;
+        if (time_from_rfc5322(hdr[0], &since, DATETIME_FULL) < 0)
+            return HTTP_BAD_REQUEST;
 
         if (lastmod <= since) return HTTP_NOT_MODIFIED;
 
@@ -4329,7 +4297,7 @@ EXPORTED int check_precond(struct transa
         txn->meth == METH_GET && (hdr = spool_getheader(hdrcache, "Range"))) {
 
         if ((hdr = spool_getheader(hdrcache, "If-Range"))) {
-            time_from_rfc822(hdr[0], &since); /* error OK here, could be an etag */
+            time_from_rfc5322(hdr[0], &since, DATETIME_FULL); /* error OK here, could be an etag */
         }
 
         /* Only process Range if If-Range isn't present or validator matches */
@@ -4459,13 +4427,13 @@ static int list_well_known(struct transa
 
         /* Add the list of enabled /.well-known/ URLs */
         http_proto_host(txn->req_hdrs, &proto, &host);
-        for (i = 0; namespaces[i]; i++) {
+        for (i = 0; http_namespaces[i]; i++) {
 
-            if (namespaces[i]->enabled && namespaces[i]->well_known) {
+            if (http_namespaces[i]->enabled && http_namespaces[i]->well_known) {
                 buf_printf_markup(&body, level,
                                   "<li><a href=\"%s://%s%s\">%s</a></li>",
-                                  proto, host, namespaces[i]->prefix,
-                                  namespaces[i]->well_known);
+                                  proto, host, http_namespaces[i]->prefix,
+                                  http_namespaces[i]->well_known);
             }
         }
 
@@ -4485,6 +4453,51 @@ static int list_well_known(struct transa
 }
 
 
+/*
+ * WebSockets data callback (no sub-protocol): Echo back non-control messages.
+ *
+ * Can be tested with:
+ *   https://github.com/websockets/wscat
+ *   https://addons.mozilla.org/en-US/firefox/addon/simple-websocket-client/
+ *   https://chrome.google.com/webstore/detail/simple-websocket-client/gobngblklhkgmjhbpbdlkglbhhlafjnh
+ *   https://chrome.google.com/webstore/detail/web-socket-client/lifhekgaodigcpmnakfhaaaboididbdn
+ *
+ * WebSockets over HTTP/2 currently only available in:
+ *   https://www.google.com/chrome/browser/canary.html
+ */
+static int ws_echo(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf __attribute__((unused)),
+                   void **rock __attribute__((unused)))
+{
+    buf_init_ro(outbuf, buf_base(inbuf), buf_len(inbuf));
+
+    return 0;
+}
+
+
+HIDDEN int meth_connect(struct transaction_t *txn, void *params)
+{
+    struct connect_params *cparams = (struct connect_params *) params;
+
+    /* Bootstrap WebSockets over HTTP/2, if requested */
+    if ((txn->flags.ver != VER_2) ||
+        !ws_enabled() || !cparams || !cparams->endpoint) {
+        return HTTP_NOT_IMPLEMENTED;
+    }
+
+    if (strcmp(txn->req_uri->path, cparams->endpoint)) return HTTP_NOT_ALLOWED;
+
+    if (!(txn->flags.upgrade & UPGRADE_WS)) {
+        txn->error.desc = "Missing/unsupported :protocol value ";
+        return HTTP_BAD_REQUEST;
+    }
+
+    int ret = ws_start_channel(txn, cparams->subprotocol, cparams->data_cb);
+
+    return (ret == HTTP_UPGRADE) ? HTTP_BAD_REQUEST : ret;
+}
+
+
 #define WELL_KNOWN_PREFIX "/.well-known"
 
 /* Perform a GET/HEAD request */
@@ -4499,6 +4512,17 @@ static int meth_get(struct transaction_t
     size_t msg_size = 0;
     struct resp_body_t *resp_body = &txn->resp_body;
 
+    /* Upgrade to WebSockets over HTTP/1.1 on root, if requested */
+    if (!strcmp(txn->req_uri->path, "/")) {
+        if (txn->flags.upgrade & UPGRADE_WS) {
+            return ws_start_channel(txn, NULL, &ws_echo);
+        }
+        else if (ws_enabled()) {
+            txn->flags.upgrade |= UPGRADE_WS;
+            txn->flags.conn |= CONN_UPGRADE;
+        }
+    }
+
     /* Check if this is a request for /.well-known/ listing */
     len = strlen(WELL_KNOWN_PREFIX);
     if (!strncmp(txn->req_uri->path, WELL_KNOWN_PREFIX, len)) {
@@ -4560,7 +4584,8 @@ static int meth_get(struct transaction_t
                     resp_body->type = mtype->type;
                     if (!mtype->compressible) {
                         /* Never compress non-compressible resources */
-                        txn->resp_body.enc = CE_IDENTITY;
+                        txn->resp_body.enc.type = CE_IDENTITY;
+                        txn->resp_body.enc.proc = NULL;
                         txn->flags.te = TE_NONE;
                         txn->flags.vary &= ~VARY_AE;
                     }
@@ -4630,9 +4655,14 @@ EXPORTED int meth_options(struct transac
 
     /* Special case "*" - show all features/methods available on server */
     if (!strcmp(txn->req_uri->path, "*")) {
-        for (i = 0; namespaces[i]; i++) {
-            if (namespaces[i]->enabled)
-                txn->req_tgt.allow |= namespaces[i]->allow;
+        for (i = 0; http_namespaces[i]; i++) {
+            if (http_namespaces[i]->enabled)
+                txn->req_tgt.allow |= http_namespaces[i]->allow;
+        }
+
+        if (ws_enabled() && (txn->flags.ver == VER_2)) {
+            /* CONNECT allowed for bootstrapping WebSocket over HTTP/2 */
+            txn->req_tgt.allow |= ALLOW_CONNECT;
         }
     }
     else {
@@ -4641,6 +4671,11 @@ EXPORTED int meth_options(struct transac
             r = parse_path(txn->req_uri->path, &txn->req_tgt, &txn->error.desc);
             if (r) return r;
         }
+        else if (!strcmp(txn->req_uri->path, "/") &&
+                 ws_enabled() && (txn->flags.ver == VER_2)) {
+            /* WS 'echo' endpoint */
+            txn->req_tgt.allow |= ALLOW_CONNECT;
+        }
 
         if (txn->flags.cors) {
             const char **hdr =
@@ -4714,7 +4749,7 @@ static int meth_propfind_root(struct tra
 
 
 /* Write cached header to buf, excluding any that might have sensitive data. */
-static void trace_cachehdr(const char *name, const char *contents, void *rock)
+static void trace_cachehdr(const char *name, const char *contents, const char *raw, void *rock)
 {
     struct buf *buf = (struct buf *) rock;
     const char **hdr, *sensitive[] =
@@ -4725,8 +4760,11 @@ static void trace_cachehdr(const char *n
 
     for (hdr = sensitive; *hdr && strcmp(name, *hdr); hdr++);
 
-    if (!*hdr) buf_printf(buf, "%c%s: %s\r\n",
-                          toupper(name[0]), name+1, contents);
+    if (!*hdr) {
+        if (raw) buf_appendcstr(buf, raw);
+        else buf_printf(buf, "%c%s: %s\r\n",
+                            toupper(name[0]), name+1, contents);
+    }
 }
 
 /* Perform an TRACE request */
@@ -4823,3 +4861,31 @@ EXPORTED int http_allow_noauth(struct tr
 {
     return 0;
 }
+
+
+/* Read the body of a request */
+EXPORTED int http_read_req_body(struct transaction_t *txn)
+{
+    struct body_t *body = &txn->req_body;
+
+    syslog(LOG_DEBUG, "http_read_req_body(flags=%#x, framing=%d)",
+           body->flags, body->framing);
+
+    if (body->flags & BODY_DONE) return 0;
+    body->flags |= BODY_DONE;
+
+    if (body->flags & BODY_CONTINUE) {
+        body->flags &= ~BODY_CONTINUE;
+
+        if (body->flags & BODY_DISCARD) {
+            /* Don't care about the body and client hasn't sent it, we're done */
+            return 0;
+        }
+
+        /* Tell client to send the body */
+        response_header(HTTP_CONTINUE, txn);
+    }
+
+    /* Read body from client */
+    return http_read_body(txn->conn->pin, txn->req_hdrs, body, &txn->error.desc);
+}
diff -pruN 3.0.13-5/imap/httpd.h 3.2.0-3/imap/httpd.h
--- 3.0.13-5/imap/httpd.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/httpd.h	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
-/* httpd.h -- Common state for HTTP/RSS/WebDAV/CalDAV/iSchedule daemon
+/* httpd.h -- Common state for HTTP/RSS/xDAV/JMAP/TZdist/iSchedule daemon
  *
- * Copyright (c) 1994-2011 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -49,20 +49,20 @@
 #include <libxml/uri.h>
 #include <libical/ical.h>
 
-#ifdef HAVE_NGHTTP2
-#include <nghttp2/nghttp2.h>
-#endif /* HAVE_NGHTTP2 */
-
 #include "annotate.h" /* for strlist */
 #include "hash.h"
 #include "http_client.h"
 #include "mailbox.h"
+#include "prometheus.h"
 #include "spool.h"
 
 #define MAX_REQ_LINE    8000  /* minimum size per RFC 7230 */
 #define MARKUP_INDENT   2     /* # spaces to indent each line of markup */
 #define GZIP_MIN_LEN    300   /* minimum length of data to gzip */
 
+#define COMPRESS_START (1<<0)
+#define COMPRESS_END   (1<<1)
+
 #define DFLAG_UNBIND    "DAV:unbind"
 #define DFLAG_UNCHANGED "DAV:unchanged"
 
@@ -105,8 +105,10 @@
 struct known_meth_t {
     const char *name;
     unsigned flags;
+    enum prom_labelled_metric metric;
 };
 extern const struct known_meth_t http_methods[];
+extern struct namespace_t *http_namespaces[];
 
 /* Flags for known methods*/
 enum {
@@ -128,8 +130,13 @@ enum {
     URL_NS_TZDIST,
     URL_NS_RSS,
     URL_NS_DBLOOKUP,
+#ifdef WITH_JMAP
+    URL_NS_JMAP,
+#endif
     URL_NS_ADMIN,
-    URL_NS_APPLEPUSH
+    URL_NS_APPLEPUSH,
+    URL_NS_PROMETHEUS,
+    URL_NS_CGI,
 };
 
 /* Bitmask of features/methods to allow, based on URL */
@@ -140,11 +147,13 @@ enum {
     ALLOW_PATCH =       (1<<3), /* Patch resources */
     ALLOW_DELETE =      (1<<4), /* Delete resources/collections */
     ALLOW_TRACE =       (1<<5), /* TRACE a request */
+    ALLOW_CONNECT =     (1<<6), /* Establish a tunnel */
 
     ALLOW_DAV =         (1<<8), /* WebDAV specific methods/features */
     ALLOW_PROPPATCH  =  (1<<9), /* Modify properties */
     ALLOW_MKCOL =       (1<<10),/* Create collections */
     ALLOW_ACL =         (1<<11),/* Modify access control list */
+    ALLOW_USERDATA =    (1<<12),/* Store per-user data for resource */
 
     ALLOW_CAL =         (1<<16),/* CalDAV specific methods/features */
     ALLOW_CAL_SCHED =   (1<<17),/* CalDAV Scheduling specific features */
@@ -161,27 +170,25 @@ enum {
                           |ALLOW_PROPPATCH|ALLOW_MKCOL|ALLOW_ACL)
 
 
-struct transaction_t;
+typedef struct transaction_t txn_t;
 
 struct auth_scheme_t {
-    unsigned idx;               /* Index value of the scheme */
+    unsigned id;                /* Identifier of the scheme */
     const char *name;           /* HTTP auth scheme name */
     const char *saslmech;       /* Corresponding SASL mech name */
     unsigned flags;             /* Bitmask of requirements/features */
                                 /* Optional function to send success data */
-    void (*send_success)(struct transaction_t *txn,
-                         const char *name, const char *data);
-                                /* Optional function to recv success data */
-    const char *(*recv_success)(hdrcache_t hdrs);
 };
 
-/* Index into available schemes */
-enum {
-    AUTH_BASIC = 0,
-    AUTH_DIGEST,
-    AUTH_SPNEGO,
-    AUTH_NTLM,
-    AUTH_BEARER
+/* Auth scheme identifiers */
+enum {
+    AUTH_BASIC        = (1<<0),
+    AUTH_DIGEST       = (1<<1),
+    AUTH_SPNEGO       = (1<<2),
+    AUTH_NTLM         = (1<<3),
+    AUTH_BEARER       = (1<<4),
+    AUTH_SCRAM_SHA1   = (1<<5),
+    AUTH_SCRAM_SHA256 = (1<<6)
 };
 
 /* Auth scheme flags */
@@ -189,21 +196,25 @@ enum {
     AUTH_NEED_PERSIST = (1<<0), /* Persistent connection required */
     AUTH_NEED_REQUEST = (1<<1), /* Request-line required */
     AUTH_SERVER_FIRST = (1<<2), /* SASL mech is server-first */
-    AUTH_BASE64 =       (1<<3)  /* Base64 encode/decode auth data */
+    AUTH_BASE64       = (1<<3), /* Base64 encode/decode challenge/response */
+    AUTH_REALM_PARAM  = (1<<4), /* Need "realm" parameter in initial challenge */
+    AUTH_DATA_PARAM   = (1<<5), /* Challenge/credentials use auth-params */
+    AUTH_SUCCESS_WWW  = (1<<6)  /* Success data uses WWW-Authenticate header */
 };
 
+#define AUTH_SCHEME_BASIC { AUTH_BASIC, "Basic", NULL, \
+                            AUTH_SERVER_FIRST | AUTH_REALM_PARAM | AUTH_BASE64 }
+
 /* List of HTTP auth schemes that we support */
 extern struct auth_scheme_t auth_schemes[];
 
-extern const char *digest_recv_success(hdrcache_t hdrs);
-
 
 /* Request-line context */
 struct request_line_t {
     char buf[MAX_REQ_LINE+1];   /* working copy of request-line */
-    char *meth;                 /* method */
-    char *uri;                  /* request-target */
-    char *ver;                  /* HTTP-version */
+    const char *meth;           /* method */
+    const char *uri;            /* request-target */
+    const char *ver;            /* HTTP-version */
 };
 
 
@@ -231,12 +242,13 @@ enum {
     TGT_SCHED_OUTBOX,
     TGT_MANAGED_ATTACH,
     TGT_DRIVE_ROOT,
-    TGT_DRIVE_USER
+    TGT_DRIVE_USER,
+    TGT_USER_ZZZZ
 };
 
 /* Function to parse URI path and generate a mailbox name */
-typedef int (*parse_path_t)(const char *path,
-                            struct request_target_t *tgt, const char **errstr);
+typedef int (*parse_path_t)(const char *path, struct request_target_t *tgt,
+                            const char **resultstr);
 
 /* Auth challenge context */
 struct auth_challenge_t {
@@ -264,20 +276,29 @@ struct patch_doc_t {
     int (*proc)();                      /* Function to parse and apply doc */
 };
 
+typedef int (*encode_proc_t)(struct transaction_t *txn,
+                             unsigned flags, const char *buf, unsigned len);
+
 
 /* Meta-data for response body (payload & representation headers) */
 struct resp_body_t {
     ulong len;                          /* Content-Length   */
     struct range *range;                /* Content-Range    */
-    const char *fname;                  /* Content-Dispo    */
-    unsigned char enc;                  /* Content-Encoding */
+    struct {
+        const char *fname;
+        unsigned attach : 1;
+    } dispo;                            /* Content-Dispo    */
+    struct {
+        unsigned char type;
+        encode_proc_t proc;
+    } enc;                              /* Content-Encoding */
     const char *lang;                   /* Content-Language */
     const char *loc;                    /* Content-Location */
     const u_char *md5;                  /* Content-MD5      */
     const char *type;                   /* Content-Type     */
     const struct patch_doc_t *patch;    /* Accept-Patch     */
     unsigned prefs;                     /* Prefer           */
-    const char *link;                   /* Link             */
+    strarray_t links;                   /* Link(s)          */
     const char *lock;                   /* Lock-Token       */
     const char *ctag;                   /* CTag             */
     const char *etag;                   /* ETag             */
@@ -286,6 +307,7 @@ struct resp_body_t {
     const char *stag;                   /* Schedule-Tag     */
     const char *cmid;                   /* Cal-Managed-ID   */
     time_t iserial;                     /* iSched serial#   */
+    hdrcache_t extra_hdrs;              /* Extra headers    */
     struct buf payload;                 /* Payload          */
 };
 
@@ -293,47 +315,38 @@ struct resp_body_t {
 struct txn_flags_t {
     unsigned long ver      : 2;         /* HTTP version of request */
     unsigned long conn     : 3;         /* Connection opts on req/resp */
-    unsigned long upgrade  : 2;         /* Upgrade protocols */
+    unsigned long upgrade  : 3;         /* Upgrade protocols */
     unsigned long override : 1;         /* HTTP method override */
     unsigned long cors     : 3;         /* Cross-Origin Resource Sharing */
     unsigned long mime     : 1;         /* MIME-conformant response */
     unsigned long te       : 3;         /* Transfer-Encoding for resp */
     unsigned long cc       : 7;         /* Cache-Control directives for resp */
     unsigned long ranges   : 1;         /* Accept range requests for resource */
-    unsigned long vary     : 4;         /* Headers on which response varied */
-    unsigned long trailer  : 2;         /* Headers which will be in trailer */
+    unsigned long vary     : 6;         /* Headers on which response can vary */
+    unsigned long trailer  : 3;         /* Headers which will be in trailer */
+    unsigned long redirect : 1;         /* CGI local redirect */
 };
 
 /* HTTP connection context */
 struct http_connection {
     struct protstream *pin;             /* Input protstream */
     struct protstream *pout;            /* Output protstream */
+    const char *clienthost;             /* Name of client host */
+    int logfd;                          /* Telemetry log file */
+    struct buf logbuf;                  /* Telemetry log buffer */
 
-    void *zstrm;                        /* Zlib compression context */
-    void *brotli;                       /* Brotli compression context */
-
-#ifdef HAVE_NGHTTP2
-    nghttp2_session *http2_session;     /* HTTP/2 session context */
-    nghttp2_option *http2_options;      /* Config options for HTTP/2 session */
-};
+    void *tls_ctx;                      /* TLS context */
+    void *sess_ctx;                     /* HTTP/2+ session context */
 
-#define HTTP2_MAX_HEADERS  100
-
-/* HTTP/2 stream context */
-struct http2_stream {
-    int32_t stream_id;                  /* Stream ID */
-    size_t num_resp_hdrs;               /* Number of response headers */
-    nghttp2_nv resp_hdrs[HTTP2_MAX_HEADERS]; /* Array of response headers */
-#endif /* HAVE_NGHTTP2 */
+    xmlParserCtxtPtr xml;               /* XML parser content */
 };
 
 
 /* Transaction context */
 struct transaction_t {
     struct http_connection *conn;       /* Global connection context */
-#ifdef HAVE_NGHTTP2
-    struct http2_stream http2;          /* HTTP/2 stream data */
-#endif
+    void *strm_ctx;                     /* HTTP/2+ stream context */
+    void *ws_ctx;                       /* WebSocket channel context */
     unsigned meth;                      /* Index of Method to be performed */
     struct txn_flags_t flags;           /* Flags for this txn */
     struct request_line_t req_line;     /* Parsed request-line */
@@ -361,6 +374,10 @@ struct transaction_t {
                                            http_ischedule:
                                              - error desc string
                                         */
+
+    void *zstrm;                        /* Zlib compression context */
+    void *brotli;                       /* Brotli compression context */
+    void *zstd;                         /* Zstandard compression context */
 };
 
 /* HTTP version flags */
@@ -380,7 +397,8 @@ enum {
 /* Upgrade protocol flags */
 enum {
     UPGRADE_TLS =       (1<<0),
-    UPGRADE_HTTP2 =     (1<<1)
+    UPGRADE_HTTP2 =     (1<<1),
+    UPGRADE_WS =        (1<<2)
 };
 
 /* Cross-Origin Resource Sharing flags */
@@ -392,10 +410,11 @@ enum {
 
 /* Content-Encoding flags (coding of representation) */
 enum {
-    CE_IDENTITY =       0,      /* no encoding       */
-    CE_DEFLATE =        (1<<0), /* ZLIB   - RFC 1950 */
-    CE_GZIP =           (1<<1), /* GZIP   - RFC 1952 */
-    CE_BR =             (1<<2)  /* Brotli - RFC 7932 */
+    CE_IDENTITY =       0,      /* no encoding          */
+    CE_DEFLATE  =       (1<<0), /* ZLIB      - RFC 1950 */
+    CE_GZIP     =       (1<<1), /* GZIP      - RFC 1952 */
+    CE_BR       =       (1<<2), /* Brotli    - RFC 7932 */
+    CE_ZSTD     =       (1<<3)  /* Zstandard - RFC 8478 */
 };
 
 /* Cache-Control directive flags */
@@ -414,13 +433,16 @@ enum {
     VARY_ACCEPT =       (1<<0),
     VARY_AE =           (1<<1), /* Accept-Encoding */
     VARY_BRIEF =        (1<<2),
-    VARY_PREFER =       (1<<3)
+    VARY_PREFER =       (1<<3),
+    VARY_IFNONE =       (1<<4), /* If-None-Match */
+    VARY_CALTZ =        (1<<5)  /* CalDAV-Timezones */
 };
 
 /* Trailer header flags */
 enum {
     TRAILER_CMD5 =      (1<<0), /* Content-MD5 will be generated */
-    TRAILER_PROXY =     (1<<1)  /* Trailer(s) will be proxied from origin */
+    TRAILER_CTAG =      (1<<1), /* CTag will be returned */
+    TRAILER_PROXY =     (1<<2)  /* Trailer(s) will be proxied from origin */
 };
 
 typedef int (*premethod_proc_t)(struct transaction_t *txn);
@@ -431,21 +453,31 @@ struct method_t {
     void *params;               /* Parameters to pass to the method */
 };
 
+struct connect_params {
+    /* WebSocket parameters */
+    const char *endpoint;
+    const char *subprotocol;
+    int (*data_cb)(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf, void **rock);
+};
+
 struct namespace_t {
     unsigned id;                /* Namespace identifier */
     unsigned enabled;           /* Is this namespace enabled? */
+    const char *name;           /* Text name of this namespace ([A-Z][a-z][0-9]+) */
     const char *prefix;         /* Prefix of URL path denoting namespace */
     const char *well_known;     /* Any /.well-known/ URI */
-    int (*need_auth)(struct transaction_t *); /* Run prior unauthorized requests */
+    int (*need_auth)(txn_t *);  /* Function run prior to unauthorized requests */
     unsigned auth_schemes;      /* Bitmask of allowed auth schemes, 0 for any */
     int mboxtype;               /* What mbtype can be seen in this namespace? */
     unsigned long allow;        /* Bitmask of allowed features/methods */
     void (*init)(struct buf *); /* Function run during service startup */
-    void (*auth)(const char *); /* Function run after authentication */
+    int (*auth)(const char *);  /* Function run after authentication */
     void (*reset)(void);        /* Function run before change in auth */
     void (*shutdown)(void);     /* Function run during service shutdown */
-    int (*premethod)(struct transaction_t *); /* Func run prior to any method */
-    int (*bearer)(const char*, char *, size_t); /* Run to authenticate Bearer */
+    int (*premethod)(txn_t *);  /* Function run prior to any method */
+    int (*bearer)(const char *, /* Function run to authenticate Bearer token */
+                  char *, size_t);
     struct method_t methods[];  /* Array of functions to perform HTTP methods.
                                  * MUST be an entry for EACH method listed,
                                  * and in the SAME ORDER in which they appear
@@ -471,10 +503,15 @@ extern struct namespace_t namespace_driv
 extern struct namespace_t namespace_ischedule;
 extern struct namespace_t namespace_domainkey;
 extern struct namespace_t namespace_tzdist;
+#ifdef WITH_JMAP
+extern struct namespace_t namespace_jmap;
+#endif
 extern struct namespace_t namespace_rss;
 extern struct namespace_t namespace_dblookup;
 extern struct namespace_t namespace_admin;
 extern struct namespace_t namespace_applepush;
+extern struct namespace_t namespace_prometheus;
+extern struct namespace_t namespace_cgi;
 
 
 /* XXX  These should be included in struct transaction_t */
@@ -484,7 +521,6 @@ extern struct protstream *httpd_in;
 extern struct protstream *httpd_out;
 extern int https;
 extern sasl_conn_t *httpd_saslconn;
-extern int httpd_tls_done;
 extern int httpd_timeout;
 extern int httpd_userisadmin;
 extern int httpd_userisproxyadmin;
@@ -506,35 +542,59 @@ extern xmlURIPtr parse_uri(unsigned meth
 extern struct accept *parse_accept(const char **hdr);
 extern void parse_query_params(struct transaction_t *txn, const char *query);
 extern time_t calc_compile_time(const char *time, const char *date);
-extern const char *http_statusline(long code);
+extern const char *http_statusline(unsigned ver, long code);
 extern char *rfc3339date_gen(char *buf, size_t len, time_t t);
 extern char *httpdate_gen(char *buf, size_t len, time_t t);
 extern void begin_resp_headers(struct transaction_t *txn, long code);
 extern int end_resp_headers(struct transaction_t *txn, long code);
 extern void simple_hdr(struct transaction_t *txn,
-                       const char *name, const char *value, ...);
+                       const char *name, const char *value, ...)
+                      __attribute__((format(printf, 3, 4)));
+extern void content_md5_hdr(struct transaction_t *txn,
+                            const unsigned char *md5);
 extern void comma_list_hdr(struct transaction_t *txn,
                            const char *hdr, const char *vals[],
                            unsigned flags, ...);
 extern void response_header(long code, struct transaction_t *txn);
 extern void buf_printf_markup(struct buf *buf, unsigned level,
-                              const char *fmt, ...);
+                              const char *fmt, ...)
+                             __attribute__((format(printf, 3, 4)));
 extern void keepalive_response(struct transaction_t *txn);
 extern void error_response(long code, struct transaction_t *txn);
 extern void html_response(long code, struct transaction_t *txn, xmlDocPtr html);
 extern void xml_response(long code, struct transaction_t *txn, xmlDocPtr xml);
+extern void xml_partial_response(struct transaction_t *txn,
+                                 xmlDocPtr doc, xmlNodePtr node,
+                                 unsigned level, xmlBufferPtr *buf);
 extern void write_body(long code, struct transaction_t *txn,
                        const char *buf, unsigned len);
 extern void write_multipart_body(long code, struct transaction_t *txn,
-                                 const char *buf, unsigned len);
+                                 const char *buf, unsigned len,
+                                 const char *part_headers);
+
+extern int meth_connect(struct transaction_t *txn, void *params);
 extern int meth_options(struct transaction_t *txn, void *params);
 extern int meth_trace(struct transaction_t *txn, void *params);
 extern int etagcmp(const char *hdr, const char *etag);
 extern int check_precond(struct transaction_t *txn,
                          const char *etag, time_t lastmod);
 
+extern void log_cachehdr(const char *name, const char *contents,
+                         const char *raw, void *rock);
+
+extern int examine_request(struct transaction_t *txn, const char *uri);
+extern int process_request(struct transaction_t *txn);
+extern void transaction_free(struct transaction_t *txn);
+
 extern int httpd_myrights(struct auth_state *authstate, const mbentry_t *mbentry);
 extern int http_allow_noauth(struct transaction_t *txn);
 extern int http_allow_noauth_get(struct transaction_t *txn);
+extern int http_read_req_body(struct transaction_t *txn);
+
+extern void *zlib_init();
+extern int zlib_compress(struct transaction_t *txn, unsigned flags,
+                         const char *buf, unsigned len);
+
+extern void *brotli_init();
 
 #endif /* HTTPD_H */
diff -pruN 3.0.13-5/imap/http_err.et 3.2.0-3/imap/http_err.et
--- 3.0.13-5/imap/http_err.et	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_err.et	2020-04-24 02:03:00.000000000 +0000
@@ -42,7 +42,7 @@
 
 error_table http
 
-# HTTP/1.1 Response Status Codes (RFC 7231)
+# HTTP Response Status Codes (from draft-ietf-httpbis-semantics unless otherwise noted)
 
 # Informational 1xx (Interim connection status or request progress)
 
@@ -52,6 +52,12 @@ ec HTTP_CONTINUE,
 ec HTTP_SWITCH_PROT,
    "101 Switching Protocols"
 
+ec HTTP_PROCESSING,
+   "102 Processing"                      /* RFC 2518 (WebDAV) */
+
+ec HTTP_EARLY_HINTS,
+   "103 Early Hints"                     /* RFC 8297 (Indicating Hints) */
+
 
 # Successful 2xx (Request successfully received, understood, and accepted)
 
@@ -73,6 +79,18 @@ ec HTTP_NO_CONTENT,
 ec HTTP_RESET_CONTENT,
    "205 Reset Content"
 
+ec HTTP_PARTIAL,
+   "206 Partial Content"
+
+ec HTTP_MULTI_STATUS,
+   "207 Multi-Status"                    /* RFC 4918 (WebDAV) */
+
+ec HTTP_DUPLICATE,
+   "208 Already Reported"                /* RFC 5842 (Binding Extn to WebDAV) */
+
+ec HTTP_IM_USED,
+   "226 IM Used"                         /* RFC 3229 (Delta Encoding in HTTP) */
+
 
 # Redirection 3xx (Further action must be taken to complete the request)
 
@@ -88,18 +106,30 @@ ec HTTP_FOUND,
 ec HTTP_SEE_OTHER,
    "303 See Other"
 
+ec HTTP_NOT_MODIFIED,
+   "304 Not Modified"
+
 ec HTTP_USE_PROXY,
    "305 Use Proxy"
 
+ec HTTP_306,
+   "306 (Unused)"                        /* Formerly "Switch Proxy" */
+
 ec HTTP_TEMP_REDIRECT,
    "307 Temporary Redirect"
 
+ec HTTP_PERM_REDIRECT,
+   "308 Permanent Redirect"
+
 
 # Client Error 4xx (The request contains bad syntax or cannot be fulfilled)
 
 ec HTTP_BAD_REQUEST,
    "400 Bad Request"
 
+ec HTTP_UNAUTHORIZED,
+   "401 Unauthorized"
+
 ec HTTP_PAYMENT_REQUIRED,
    "402 Payment Required"
 
@@ -115,6 +145,9 @@ ec HTTP_NOT_ALLOWED,
 ec HTTP_NOT_ACCEPTABLE,
    "406 Not Acceptable"
 
+ec HTTP_PROXY_AUTH,
+   "407 Proxy Authentication Required"
+
 ec HTTP_TIMEOUT,
    "408 Request Timeout"
 
@@ -127,6 +160,9 @@ ec HTTP_GONE,
 ec HTTP_LENGTH_REQUIRED,
    "411 Length Required"
 
+ec HTTP_PRECOND_FAILED,
+   "412 Precondition Failed"
+
 ec HTTP_PAYLOAD_TOO_LARGE,
    "413 Payload Too Large"
 
@@ -136,140 +172,83 @@ ec HTTP_URI_TOO_LONG,
 ec HTTP_BAD_MEDIATYPE,
    "415 Unsupported Media Type"
 
-ec HTTP_EXPECT_FAILED,
-   "417 Expectation Failed"
-
-ec HTTP_UPGRADE,
-   "426 Upgrade Required"
-
-
-# Server Error 5xx (The server is incapable of performing the request)
-
-ec HTTP_SERVER_ERROR,
-   "500 Internal Server Error"
-
-ec HTTP_NOT_IMPLEMENTED,
-   "501 Not Implemented"
-
-ec HTTP_BAD_GATEWAY,
-   "502 Bad Gateway"
-
-ec HTTP_UNAVAILABLE,
-   "503 Service Unavailable"
-
-ec HTTP_GATEWAY_TIMEOUT,
-   "504 Gateway Timeout"
-
-ec HTTP_BAD_VERSION,
-   "505 HTTP Version Not Supported"
-
-
-
-# Conditional Requests (RFC 7232)
-
-ec HTTP_NOT_MODIFIED,
-   "304 Not Modified"
-
-ec HTTP_PRECOND_FAILED,
-   "412 Precondition Failed"
-
-
-
-# Range Requests (RFC 7233)
-
-ec HTTP_PARTIAL,
-   "206 Partial Content"
+ec HTTP_BAD_CE,
+   "415 Unsupported Media Type"          /* RFC 7694 (Client-Initiated C-E) */
 
 ec HTTP_BAD_RANGE,
    "416 Range Not Satisfiable"
 
+ec HTTP_EXPECT_FAILED,
+   "417 Expectation Failed"
 
-
-# Authentication (RFC 7235)
-
-ec HTTP_UNAUTHORIZED,
-   "401 Unauthorized"
-
-ec HTTP_PROXY_AUTH,
-   "407 Proxy Authentication Required"
-
-
-
-# Permanent Redirect (RFC 7538)
-
-ec HTTP_PERM_REDIRECT,
-   "308 Permanent Redirect"
-
-
-
-# HTTP/2 (RFC 7540)
+ec HTTP_418,
+   "418 (Unused)"                        /* Formerly "I'm a teapot" (RFC 2324) */
 
 ec HTTP_MISDIRECTED,
-   "421 Misdirected Request"
-
-
+   "421 Misdirected Request"             /* RFC 7540 (HTTP/2) */
 
-# Client-Initiated Content-Encoding (RFC 7694)
-
-# Used to differentiate between unsupported Content-Encoding and Content-Type
-ec HTTP_BAD_CE,
-   "415 Unsupported Media Type"
-
-
-
-# Legally Restricted (RFC 7725)
+ec HTTP_UNPROCESSABLE,
+   "422 Unprocessable Entity"
 
-ec HTTP_CENSORED,
-   "451 Unavailable For Legal Reasons"
+ec HTTP_LOCKED,
+   "423 Locked"                          /* RFC 4918 (WebDAV) */
 
+ec HTTP_FAILED_DEP,
+   "424 Failed Dependency"               /* RFC 4918 (WebDAV) */
 
+ec HTTP_TOO_EARLY,
+   "425 Too Early"                       /* RFC 8470 (Using Early Data) */
 
-# Additional HTTP Status Codes (RFC 6585)
+ec HTTP_UPGRADE,
+   "426 Upgrade Required"
 
 ec HTTP_PRECOND_REQUIRED,
-   "428 Precondition Required"
+   "428 Precondition Required"           /* RFC 6585 (Additional Status Codes) */
 
 ec HTTP_TOO_MANY_REQUESTS,
-   "429 Too Many Requests"
+   "429 Too Many Requests"               /* RFC 6585 (Additional Status Codes) */
 
 ec HTTP_HEADERS_TOO_LARGE,
-   "431 Request Header Fields Too Large"
-
-ec HTTP_NETWORK_AUTH,
-   "511 Network Authentication Required"
-
+   "431 Request Header Fields Too Large" /* RFC 6585 (Additional Status Codes) */
 
+ec HTTP_CENSORED,
+   "451 Unavailable For Legal Reasons"   /* RFC 7725 (Report Legal Obstacles) */
 
-# WebDAV (RFC 2518/4918)
 
-ec HTTP_PROCESSING,
-   "102 Processing"
+# Server Error 5xx (The server is incapable of performing the request)
 
-ec HTTP_MULTI_STATUS,
-   "207 Multi-Status"
+ec HTTP_SERVER_ERROR,
+   "500 Internal Server Error"
 
-ec HTTP_UNPROCESSABLE,
-   "422 Unprocessable Entity"
+ec HTTP_NOT_IMPLEMENTED,
+   "501 Not Implemented"
 
-ec HTTP_LOCKED,
-   "423 Locked"
+ec HTTP_BAD_GATEWAY,
+   "502 Bad Gateway"
 
-ec HTTP_FAILED_DEP,
-   "424 Failed Dependency"
+ec HTTP_UNAVAILABLE,
+   "503 Service Unavailable"
 
-ec HTTP_NO_STORAGE,
-   "507 Insufficient Storage"
+ec HTTP_SHUTDOWN,
+   "503 Service Unavailable"             /* Shutdown file vs other issues */
 
+ec HTTP_GATEWAY_TIMEOUT,
+   "504 Gateway Timeout"
 
+ec HTTP_BAD_VERSION,
+   "505 HTTP Version Not Supported"
 
-# Binding Extensions to WebDAV (RFC 5842)
+ec HTTP_VARIANT_NEGOTIATES,
+   "506 Variant Also Negotiates"         /* RFC 2295 (Transparent Content Neg) */
 
-ec HTTP_DUPLICATE,
-   "208 Already Reported"
+ec HTTP_NO_STORAGE,
+   "507 Insufficient Storage"            /* RFC 4918 (WebDAV) */
 
 ec HTTP_LOOP,
-   "508 Loop Detected"
+   "508 Loop Detected"                   /* RFC 5842 (Binding Extn to WebDAV) */
 
+ec HTTP_NETWORK_AUTH,
+   "511 Network Authentication Required" /* RFC 6585 (Additional Status Codes) */
 
 
 end
diff -pruN 3.0.13-5/imap/http_h2.c 3.2.0-3/imap/http_h2.c
--- 3.0.13-5/imap/http_h2.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_h2.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,1028 @@
+/* http_h2.c - HTTP/2 support functions
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+#include <sysexits.h>
+
+#include "httpd.h"
+#include "md5.h"
+#include "util.h"
+
+int (*alpn_select_cb)(SSL *ssl,
+                      const unsigned char **out, unsigned char *outlen,
+                      const unsigned char *in, unsigned int inlen,
+                      void *arg) = NULL;
+
+#ifdef HAVE_NGHTTP2
+
+#include <errno.h>
+#include <syslog.h>
+
+#include <sasl/saslutil.h>
+
+#include "http_h2.h"
+#include "http_ws.h"
+#include "prometheus.h"
+#include "retry.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+
+#define HTTP2_MAX_HEADERS  100
+
+/* HTTP/2 session context */
+struct http2_context {
+    nghttp2_session *session;           /* HTTP/2 session */
+    nghttp2_option *options;            /* Config options for HTTP/2 session */
+    unsigned ws_count;                  /* Count of WebSocket streams */
+};
+
+/* HTTP/2 stream context */
+struct http2_stream {
+    int32_t id;                         /* Stream ID */
+    size_t num_resp_hdrs;               /* Number of response headers */
+    nghttp2_nv resp_hdrs[HTTP2_MAX_HEADERS]; /* Array of response headers */
+};
+
+static nghttp2_session_callbacks *http2_callbacks = NULL;
+
+static int _alpn_select_cb(SSL *ssl __attribute__((unused)),
+                           const unsigned char **out, unsigned char *outlen,
+                           const unsigned char *in, unsigned int inlen,
+                           void *arg)
+{
+    struct http_connection *http_conn = (struct http_connection *) arg;
+
+    int r = nghttp2_select_next_protocol((u_char **) out, outlen, in, inlen);
+
+    switch (r) {
+    case 0: /* http/1.1 */
+        break;
+
+    case 1: /* h2 */
+        if (http2_start_session(NULL, http_conn) == 0) break;
+
+        /* Fall through as unsupported */
+        GCC_FALLTHROUGH
+
+    default:
+        return SSL_TLSEXT_ERR_NOACK;
+    }
+
+    return SSL_TLSEXT_ERR_OK;
+}
+
+static ssize_t send_cb(nghttp2_session *session __attribute__((unused)),
+                       const uint8_t *data, size_t length,
+                       int flags __attribute__((unused)),
+                       void *user_data)
+{
+    struct http_connection *conn = (struct http_connection *) user_data;
+    struct protstream *pout = conn->pout;
+    int r;
+
+    r = prot_write(pout, (const char *) data, length);
+
+    syslog(LOG_DEBUG, "http2_send_cb(%zu): %d", length, r);
+
+    if (r) return NGHTTP2_ERR_CALLBACK_FAILURE;
+
+    return length;
+}
+
+static ssize_t recv_cb(nghttp2_session *session __attribute__((unused)),
+                       uint8_t *buf, size_t length,
+                       int flags __attribute__((unused)),
+                       void *user_data)
+{
+    struct http_connection *conn = (struct http_connection *) user_data;
+    struct protstream *pin = conn->pin;
+    ssize_t n;
+
+    
+    n = prot_read(pin, (char *) buf, length);
+    if (n) {
+        /* We received some data - don't block next time
+           Note: This callback gets called multiple times until it
+           would block.  We don't actually want to block and prevent
+           output from being submitted */
+        prot_NONBLOCK(pin);
+    }
+    else if (!((struct http2_context *) conn->sess_ctx)->ws_count) {
+        /* No data (and no WebSockets) -  block next time (for client timeout) */
+        prot_BLOCK(pin);
+
+        if (pin->eof) n = NGHTTP2_ERR_EOF;
+        else if (pin->error) n = NGHTTP2_ERR_CALLBACK_FAILURE;
+        else n = NGHTTP2_ERR_WOULDBLOCK;
+    }
+
+    syslog(LOG_DEBUG,
+           "http2_recv_cb(%zu): n = %zd, eof = %d, err = '%s', errno = %m",
+           length, n, pin->eof, pin->error ? pin->error : "");
+
+    return n;
+}
+
+static ssize_t data_source_read_cb(nghttp2_session *sess __attribute__((unused)),
+                                   int32_t stream_id,
+                                   uint8_t *buf, size_t length,
+                                   uint32_t *data_flags,
+                                   nghttp2_data_source *source,
+                                   void *user_data __attribute__((unused)))
+{
+    struct protstream *s = source->ptr;
+    size_t n = prot_read(s, (char *) buf, length);
+
+    syslog(LOG_DEBUG,
+           "http2_data_source_read_cb(id=%d, len=%zu): n=%zu, eof=%d",
+           stream_id, length, n, !s->cnt);
+
+    if (!s->cnt) {
+        *data_flags |= NGHTTP2_DATA_FLAG_EOF;
+        prot_free(s);  /* Done with the protstream */
+    }
+
+    return n;
+}
+
+static int begin_headers_cb(nghttp2_session *session,
+                            const nghttp2_frame *frame, void *user_data)
+{
+    if (frame->hd.type != NGHTTP2_HEADERS ||
+        frame->headers.cat != NGHTTP2_HCAT_REQUEST) {
+        return 0;
+    }
+
+    syslog(LOG_DEBUG, "http2_begin_headers_cb(id=%d, type=%d)",
+           frame->hd.stream_id, frame->hd.type);
+
+    struct transaction_t *txn = xzmalloc(sizeof(struct transaction_t));
+
+    txn->conn = (struct http_connection *) user_data;
+    txn->meth = METH_UNKNOWN;
+    txn->flags.ver = VER_2;
+    txn->flags.vary = VARY_AE;
+    txn->req_line.ver = HTTP2_VERSION;
+
+    if (config_getswitch(IMAPOPT_HTTPALLOWCOMPRESS)) {
+        txn->zstrm = zlib_init();
+        txn->brotli = brotli_init();
+    }
+
+
+    struct http2_stream *strm = xzmalloc(sizeof(struct http2_stream));
+
+    strm->id = frame->hd.stream_id;
+    txn->strm_ctx = strm;
+
+    /* Create header cache */
+    if (!(txn->req_hdrs = spool_new_hdrcache())) {
+        syslog(LOG_ERR, "Unable to create header cache");
+        return NGHTTP2_ERR_CALLBACK_FAILURE;
+    }
+
+    nghttp2_session_set_stream_user_data(session, frame->hd.stream_id, txn);
+
+    return 0;
+}
+
+static int header_cb(nghttp2_session *session,
+                     const nghttp2_frame *frame,
+                     const uint8_t *name, size_t namelen,
+                     const uint8_t *value, size_t valuelen,
+                     uint8_t flags __attribute__((unused)),
+                     void *user_data __attribute__((unused)))
+{
+    if (frame->hd.type != NGHTTP2_HEADERS ||
+        frame->headers.cat != NGHTTP2_HCAT_REQUEST) {
+        return 0;
+    }
+
+    char *my_name, *my_value;
+    struct transaction_t *txn =
+        nghttp2_session_get_stream_user_data(session, frame->hd.stream_id);
+
+    if (!txn) return 0;
+
+    my_name = xstrndup((const char *) name, namelen);
+    my_value = xstrndup((const char *) value, valuelen);
+
+    syslog(LOG_DEBUG, "http2_header_cb(%s: %s)", my_name, my_value);
+
+    if (my_name[0] == ':') {
+        switch (my_name[1]) {
+        case 'm': /* :method */
+            if (!strcmp("ethod", my_name+2)) txn->req_line.meth = my_value;
+            break;
+
+        case 's': /* :scheme */
+            break;
+
+        case 'a': /* :authority */
+            break;
+
+        case 'p': /* :path, :protocol */
+            if (!strcmp("ath", my_name+2)) txn->req_line.uri = my_value;
+            else if (!strcmp("rotocol", my_name+2) &&
+                     !strcmp(my_value, WS_TOKEN)) {
+                txn->flags.upgrade |= UPGRADE_WS;
+            }
+            break;
+        }
+    }
+
+    spool_cache_header(my_name, my_value, txn->req_hdrs);
+
+    return 0;
+}
+
+static int data_chunk_recv_cb(nghttp2_session *session,
+                              uint8_t flags __attribute__((unused)),
+                              int32_t stream_id,
+                              const uint8_t *data, size_t len,
+                              void *user_data __attribute__((unused)))
+{
+    struct transaction_t *txn =
+        nghttp2_session_get_stream_user_data(session, stream_id);
+
+    if (!txn) return 0;
+
+    syslog(LOG_DEBUG, "http2_data_chunk_recv_cb(id=%d, len=%zu, txnflags=%#x)",
+           stream_id, len, txn->req_body.flags);
+
+    if (txn->req_body.flags & BODY_DISCARD) return 0;
+
+    if (len) {
+        txn->req_body.framing = FRAMING_HTTP2;
+        txn->req_body.len += len;
+        buf_appendmap(&txn->req_body.payload, (const char *) data, len);
+    }
+
+    return 0;
+}
+
+static int frame_recv_cb(nghttp2_session *session,
+                         const nghttp2_frame *frame,
+                         void *user_data __attribute__((unused)))
+{
+    int ret = 0;
+    struct transaction_t *txn =
+        nghttp2_session_get_stream_user_data(session, frame->hd.stream_id);
+    struct http2_context *ctx;
+    struct buf *logbuf = NULL;
+
+    if (!txn) return 0;
+
+    ctx = (struct http2_context *) txn->conn->sess_ctx;
+
+    syslog(LOG_DEBUG, "http2_frame_recv_cb(id=%d, type=%d, flags=%#x)",
+           frame->hd.stream_id, frame->hd.type, frame->hd.flags);
+
+    if ((txn->conn->logfd != -1) && (frame->hd.type <= NGHTTP2_HEADERS)) {
+        /* telemetry log */
+        logbuf = &txn->conn->logbuf;
+
+        buf_reset(logbuf);
+        buf_printf(logbuf, "<%ld<", time(NULL));   /* timestamp */
+        write(txn->conn->logfd, buf_base(logbuf), buf_len(logbuf));
+    }
+
+    switch (frame->hd.type) {
+    case NGHTTP2_HEADERS:
+        if (frame->headers.cat == NGHTTP2_HCAT_REQUEST) {
+            if (txn->conn->logfd != -1) {
+                /* telemetry log */
+                buf_reset(logbuf);
+                buf_printf(logbuf, "%s %s %s\r\n",         /* request-line*/
+                           txn->req_line.meth, txn->req_line.uri, HTTP2_VERSION);
+                spool_enum_hdrcache(txn->req_hdrs,            /* header fields */
+                                    &log_cachehdr, logbuf);
+                buf_appendcstr(logbuf, "\r\n");            /* CRLF */
+                write(txn->conn->logfd, buf_base(logbuf), buf_len(logbuf));
+            }
+
+            /* Examine request */
+            ret = examine_request(txn, NULL);
+
+            if (ret) {
+                txn->req_body.flags |= BODY_DISCARD;
+                error_response(ret, txn);
+                break;
+            }
+
+            if (txn->req_body.flags & BODY_CONTINUE) {
+                txn->req_body.flags &= ~BODY_CONTINUE;
+                response_header(HTTP_CONTINUE, txn);
+                break;
+            }
+        }
+
+        GCC_FALLTHROUGH
+
+    case NGHTTP2_DATA:
+        if (txn->ws_ctx) {
+            /* WebSocket over HTTP/2 input */
+            ws_input(txn);
+
+            if (txn->flags.conn & CONN_CLOSE) {
+                /* Issue RST_STREAM so that stream does not hang around. */
+                syslog(LOG_DEBUG, "nghttp2_submit_rst stream()");
+                nghttp2_submit_rst_stream(session, NGHTTP2_FLAG_NONE,
+                                          frame->hd.stream_id,
+                                          NGHTTP2_NO_ERROR);
+            }
+            break;
+        }
+
+        if (txn->conn->logfd != -1) {
+            /* telemetry log */
+            write(txn->conn->logfd, buf_base(&txn->req_body.payload),
+                  buf_len(&txn->req_body.payload));
+        }
+
+        if (txn->meth != METH_CONNECT) {
+            /* Check that the client request has finished */
+            if (!(frame->hd.flags & NGHTTP2_FLAG_END_STREAM)) break;
+              
+            /* Check that we still want to process the request */
+            if (txn->req_body.flags & BODY_DISCARD) break;
+        }
+
+        /* Process the requested method */
+        ret = process_request(txn);
+
+        /* Handle errors (success responses handled by method functions) */
+        if (ret) error_response(ret, txn);
+
+        if (txn->flags.conn & CONN_CLOSE) {
+            int32_t stream_id =
+                nghttp2_session_get_last_proc_stream_id(ctx->session);
+
+            syslog(LOG_DEBUG, "nghttp2_submit_goaway()");
+            nghttp2_submit_goaway(session, NGHTTP2_FLAG_NONE, stream_id,
+                                  NGHTTP2_NO_ERROR, NULL, 0);
+        }
+        else if (txn->ws_ctx) {
+            /* Increment WebSocket stream count */
+            ctx->ws_count++;
+        }
+
+        break;
+    }
+
+    return 0;
+}
+
+static int stream_close_cb(nghttp2_session *session, int32_t stream_id,
+                           uint32_t error_code,
+                           void *user_data __attribute__((unused)))
+{
+    struct transaction_t *txn =
+        nghttp2_session_get_stream_user_data(session, stream_id);
+
+    syslog(LOG_DEBUG, "http2_stream_close_cb(id=%d): '%s'",
+           stream_id, nghttp2_http2_strerror(error_code));
+
+    if (txn) {
+        if (txn->ws_ctx) {
+            /* Decrement WebSocket stream count */
+            struct http2_context *http2_ctx =
+                (struct http2_context *) txn->conn->sess_ctx;
+            if (--http2_ctx->ws_count == 0) {
+                /* No WebSockets -  block next time (for client timeout) */
+                prot_BLOCK(txn->conn->pin);
+            }
+        }
+
+        /* Memory cleanup */
+        transaction_free(txn);
+        free(txn);
+    }
+
+    return 0;
+}
+
+static int frame_not_send_cb(nghttp2_session *session,
+                             const nghttp2_frame *frame,
+                             int lib_error_code,
+                             void *user_data __attribute__((unused)))
+{
+    syslog(LOG_DEBUG, "http2_frame_not_send_cb(id=%d)", frame->hd.stream_id);
+
+    /* Issue RST_STREAM so that stream does not hang around. */
+    nghttp2_submit_rst_stream(session, NGHTTP2_FLAG_NONE,
+                              frame->hd.stream_id, lib_error_code);
+
+    return 0;
+}
+
+
+HIDDEN void http2_init(struct buf *serverinfo)
+{
+    int r;
+
+    buf_printf(serverinfo, " Nghttp2/%s", NGHTTP2_VERSION);
+
+    /* Setup HTTP/2 callbacks */
+    if ((r = nghttp2_session_callbacks_new(&http2_callbacks))) {
+        syslog(LOG_WARNING,
+               "nghttp2_session_callbacks_new: %s", nghttp2_strerror(r));
+        return;
+    }
+
+    nghttp2_session_callbacks_set_send_callback(http2_callbacks,
+                                                &send_cb);
+    nghttp2_session_callbacks_set_recv_callback(http2_callbacks,
+                                                &recv_cb);
+    nghttp2_session_callbacks_set_on_begin_headers_callback(http2_callbacks,
+                                                            &begin_headers_cb);
+    nghttp2_session_callbacks_set_on_header_callback(http2_callbacks,
+                                                     &header_cb);
+    nghttp2_session_callbacks_set_on_data_chunk_recv_callback(http2_callbacks,
+                                                              &data_chunk_recv_cb);
+    nghttp2_session_callbacks_set_on_frame_recv_callback(http2_callbacks,
+                                                         &frame_recv_cb);
+    nghttp2_session_callbacks_set_on_stream_close_callback(http2_callbacks,
+                                                           &stream_close_cb);
+    nghttp2_session_callbacks_set_on_frame_not_send_callback(http2_callbacks,
+                                                             &frame_not_send_cb);
+
+    /* Setup for ALPN */
+    alpn_select_cb = &_alpn_select_cb;
+}
+
+
+HIDDEN int http2_enabled()
+{
+    return (http2_callbacks != NULL);
+}
+
+HIDDEN void http2_done()
+{
+    nghttp2_session_callbacks_del(http2_callbacks);
+}
+
+
+HIDDEN int http2_preface(struct http_connection *conn)
+{
+    if (http2_enabled()) {
+        /* Check initial client input for HTTP/2 preface */
+        int c;
+
+        if (prot_lookahead(conn->pin,
+                           NGHTTP2_CLIENT_MAGIC, NGHTTP2_CLIENT_MAGIC_LEN, &c)) {
+            syslog(LOG_DEBUG, "HTTP/2 client connection preface");
+            return 1;
+        }
+    }
+
+    return 0;
+}
+
+
+#if HAVE_DECL_NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL
+static int nghttp2_extended_connect = 1;
+#else
+#define NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL 0x08
+static int nghttp2_extended_connect = 0;
+#endif
+
+HIDDEN int http2_start_session(struct transaction_t *txn,
+                               struct http_connection *conn)
+{
+    nghttp2_settings_entry iv[] = {
+        { NGHTTP2_SETTINGS_MAX_CONCURRENT_STREAMS, 100 },
+        { NGHTTP2_SETTINGS_ENABLE_CONNECT_PROTOCOL, 1 }  /* MUST be last */
+    };
+    size_t niv = (sizeof(iv) / sizeof(iv[0])) - !ws_enabled();
+    struct http2_context *ctx;
+    int r;
+
+    if (!conn) conn = txn->conn;
+
+    if (conn->sess_ctx) return 0;
+
+    ctx = xzmalloc(sizeof(struct http2_context));
+
+    r = nghttp2_option_new(&ctx->options);
+    if (r) {
+        syslog(LOG_WARNING,
+               "nghttp2_option_new: %s", nghttp2_strerror(r));
+        free(ctx);
+        return HTTP_SERVER_ERROR;
+    }
+
+    if (ws_enabled() && !nghttp2_extended_connect) {
+        /* Need to forcefully allow :scheme, :path, :protocol pseudo-headers
+           (this version of libnghttp2 doesn't understand extended CONNECT) */
+        nghttp2_option_set_no_http_messaging(ctx->options, 1);
+    }
+
+    r = nghttp2_session_server_new2(&ctx->session,
+                                    http2_callbacks, conn, ctx->options);
+    if (r) {
+        syslog(LOG_WARNING,
+               "nghttp2_session_server_new2: %s", nghttp2_strerror(r));
+        free(ctx);
+        return HTTP_SERVER_ERROR;
+    }
+
+    conn->sess_ctx = ctx;
+
+    if (txn && (txn->flags.conn & CONN_UPGRADE)) {
+        struct http2_stream *strm;
+        struct buf *buf = &txn->buf;
+        unsigned outlen;
+
+        const char **hdr = spool_getheader(txn->req_hdrs, "HTTP2-Settings");
+        if (!hdr || hdr[1]) return 0;
+
+        /* base64url decode the settings.
+           Use the SASL base64 decoder after replacing the encoded values
+           for chars 62 and 63 and adding appropriate padding. */
+        buf_setcstr(buf, hdr[0]);
+        buf_replace_char(buf, '-', '+');
+        buf_replace_char(buf, '_', '/');
+        buf_appendmap(buf, "==", (4 - (buf_len(buf) % 4)) % 4);
+        r = sasl_decode64(buf_base(buf), buf_len(buf),
+                          (char *) buf_base(buf), buf_len(buf), &outlen);
+        if (r != SASL_OK) {
+            syslog(LOG_WARNING, "sasl_decode64 failed: %s",
+                   sasl_errstring(r, NULL, NULL));
+        }
+        else {
+            r = nghttp2_session_upgrade2(ctx->session,
+                                         (const uint8_t *) buf_base(buf),
+                                         outlen, txn->meth == METH_HEAD, NULL);
+            if (r) {
+                syslog(LOG_WARNING, "nghttp2_session_upgrade: %s",
+                       nghttp2_strerror(r));
+            }
+        }
+
+        buf_reset(buf);
+        if (r) return HTTP_BAD_REQUEST;
+
+        /* tell client to start h2c upgrade (RFC 7540) */
+        response_header(HTTP_SWITCH_PROT, txn);
+
+        strm = xzmalloc(sizeof(struct http2_stream));
+        strm->id = nghttp2_session_get_last_proc_stream_id(ctx->session);
+        txn->strm_ctx = strm;
+        txn->flags.ver = VER_2;
+    }
+
+    /* Don't do telemetry logging in prot layer */
+    prot_setlog(conn->pin, PROT_NO_FD);
+    prot_setlog(conn->pout, PROT_NO_FD);
+
+    tcp_disable_nagle(1); /* output fd */
+
+    r = nghttp2_submit_settings(ctx->session, NGHTTP2_FLAG_NONE, iv, niv);
+    if (r) {
+        syslog(LOG_ERR, "nghttp2_submit_settings: %s", nghttp2_strerror(r));
+        return HTTP_SERVER_ERROR;
+    }
+
+    return 0;
+}
+
+
+HIDDEN void http2_end_session(void *http2_ctx)
+{
+    struct http2_context *ctx = (struct http2_context *) http2_ctx;
+
+    if (!ctx) return;
+
+    nghttp2_option_del(ctx->options);
+    nghttp2_session_del(ctx->session);
+    free(ctx);
+}
+
+
+HIDDEN void http2_output(struct transaction_t *txn)
+{
+    struct http2_context *ctx = (struct http2_context *) txn->conn->sess_ctx;
+
+    if (nghttp2_session_want_write(ctx->session)) {
+        /* Send queued frame(s) */
+        int r = nghttp2_session_send(ctx->session);
+        if (r) {
+            syslog(LOG_ERR, "nghttp2_session_send: %s", nghttp2_strerror(r));
+            txn->flags.conn = CONN_CLOSE;
+        }
+    }
+}
+
+
+HIDDEN void http2_input(struct transaction_t *txn)
+{
+    struct http2_context *ctx = (struct http2_context *) txn->conn->sess_ctx;
+    int want_read = nghttp2_session_want_read(ctx->session);
+    int goaway = txn->flags.conn & CONN_CLOSE;
+    nghttp2_error_code err = goaway ? NGHTTP2_REFUSED_STREAM : NGHTTP2_NO_ERROR;
+
+    syslog(LOG_DEBUG, "http2_input()  goaway: %d, eof: %d, want read: %d",
+           goaway, txn->conn->pin->eof, want_read);
+
+    if (want_read && !goaway) {
+        /* Read frame(s) */
+        int r = nghttp2_session_recv(ctx->session);
+
+        if (!r) {
+            /* Successfully received frames */
+            syslog(LOG_DEBUG, "nghttp2_session_recv: success");
+        }
+        else if (r == NGHTTP2_ERR_EOF) {
+            /* Client closed connection */
+            syslog(LOG_DEBUG, "client closed connection");
+            txn->flags.conn = CONN_CLOSE;
+        }
+        else {
+            /* Failure */
+            syslog(LOG_DEBUG, "nghttp2_session_recv: %s (%s)",
+                   nghttp2_strerror(r), prot_error(txn->conn->pin));
+            goaway = 1;
+
+            if (r == NGHTTP2_ERR_CALLBACK_FAILURE) {
+                /* Client timeout */
+                txn->error.desc = prot_error(txn->conn->pin);
+                err = NGHTTP2_REFUSED_STREAM;
+            }
+            else {
+                txn->error.desc = nghttp2_strerror(r);
+
+                if (r == NGHTTP2_ERR_NOMEM)
+                    err = NGHTTP2_INTERNAL_ERROR;
+                else if (r == NGHTTP2_ERR_BAD_CLIENT_MAGIC)
+                    err = NGHTTP2_PROTOCOL_ERROR;
+                else if (r == NGHTTP2_ERR_FLOODED)
+                    err = NGHTTP2_ENHANCE_YOUR_CALM;
+            }
+        }
+    }
+
+    if (goaway) {
+        /* Tell client we are closing session */
+        int32_t stream_id =
+            nghttp2_session_get_last_proc_stream_id(ctx->session);
+
+        syslog(LOG_WARNING, "%s, closing connection", txn->error.desc);
+
+        syslog(LOG_DEBUG, "nghttp2_submit_goaway()");
+        int r = nghttp2_submit_goaway(ctx->session,
+                                      NGHTTP2_FLAG_NONE, stream_id, err,
+                                      (const uint8_t *) txn->error.desc,
+                                      strlen(txn->error.desc));
+        if (r) {
+            syslog(LOG_ERR, "nghttp2_submit_goaway: %s", nghttp2_strerror(r));
+        }
+
+        txn->flags.conn = CONN_CLOSE;
+    }
+
+    /* Write frame(s) */
+    http2_output(txn);
+
+    return;
+}
+
+
+HIDDEN void http2_begin_headers(struct transaction_t *txn)
+{
+    struct http2_stream *strm = (struct http2_stream *) txn->strm_ctx;
+
+    strm->num_resp_hdrs = 0;
+
+    if (txn->conn->logfd != -1) {
+        /* telemetry log */
+        struct buf *logbuf = &txn->conn->logbuf;
+
+        buf_reset(logbuf);
+        buf_printf(logbuf, ">%ld>", time(NULL));  /* timestamp */
+        write(txn->conn->logfd, buf_base(logbuf), buf_len(logbuf));
+    }
+}
+
+
+HIDDEN void http2_add_header(struct transaction_t *txn,
+                             const char  *name, struct buf *value)
+{
+    struct http2_stream *strm = (struct http2_stream *) txn->strm_ctx;
+
+    if (strm->num_resp_hdrs >= HTTP2_MAX_HEADERS) {
+        buf_free(value);
+        return;
+    }
+    else {
+        nghttp2_nv *nv = &strm->resp_hdrs[strm->num_resp_hdrs];
+
+        free(nv->value);
+
+        nv->namelen = strlen(name);
+        nv->name = (uint8_t *) name;
+        nv->valuelen = buf_len(value);
+        nv->value = (uint8_t *) buf_release(value);
+        nv->flags = NGHTTP2_NV_FLAG_NO_COPY_VALUE;
+
+        strm->num_resp_hdrs++;
+
+        if (txn->conn->logfd != -1) {
+            /* telemetry log */
+            struct iovec iov[4];
+            int niov = 0;
+
+            if (name[0] == ':') {
+                /* :status */
+                WRITEV_ADD_TO_IOVEC(iov, niov, "HTTP/2 ", 7);
+            }
+            else {
+                WRITEV_ADD_TO_IOVEC(iov, niov, nv->name, nv->namelen);
+                WRITEV_ADD_TO_IOVEC(iov, niov, ": ", 2);
+            }
+            WRITEV_ADD_TO_IOVEC(iov, niov, nv->value, nv->valuelen);
+            WRITEV_ADD_TO_IOVEC(iov, niov, "\r\n", 2);
+            writev(txn->conn->logfd, iov, niov);
+        }
+    }
+}
+
+
+HIDDEN int http2_end_headers(struct transaction_t *txn, long code)
+{
+    struct http2_context *ctx = (struct http2_context *) txn->conn->sess_ctx;
+    struct http2_stream *strm = (struct http2_stream *) txn->strm_ctx;
+
+    uint8_t flags = NGHTTP2_FLAG_NONE;
+    int r;
+
+    syslog(LOG_DEBUG,
+           "end_resp_headers(code = %ld, len = %ld, flags.te = %#x)",
+           code, txn->resp_body.len, txn->flags.te);
+
+    if (txn->conn->logfd != -1) {
+        /* telemetry log */
+        write(txn->conn->logfd, "\r\n", 2);
+    }
+
+    switch (code) {
+    case 0:
+        /* Trailer */
+        flags = NGHTTP2_FLAG_END_STREAM;
+        break;
+
+    case HTTP_CONTINUE:
+    case HTTP_PROCESSING:
+        /* Provisional response */
+        break;
+
+    case HTTP_NO_CONTENT:
+    case HTTP_NOT_MODIFIED:
+        /* MUST NOT include a body */
+        flags = NGHTTP2_FLAG_END_STREAM;
+        break;
+
+    default:
+        if (txn->meth == METH_HEAD) {
+            /* MUST NOT include a body */
+            flags = NGHTTP2_FLAG_END_STREAM;
+        }
+        else if (!(txn->resp_body.len || (txn->flags.te & TE_CHUNKED))) {
+            /* Empty body */
+            flags = NGHTTP2_FLAG_END_STREAM;
+        }
+        break;
+    }
+
+    syslog(LOG_DEBUG, "%s(id=%d, flags=%#x)",
+           code ? "nghttp2_submit headers" : "nghttp2_submit_trailers",
+           strm->id, flags);
+
+    if (code) {
+        r = nghttp2_submit_headers(ctx->session, flags, strm->id, NULL,
+                                   strm->resp_hdrs, strm->num_resp_hdrs, NULL);
+    }
+    else {
+        r = nghttp2_submit_trailer(ctx->session, strm->id,
+                                   strm->resp_hdrs, strm->num_resp_hdrs);
+    }
+    if (r) {
+        syslog(LOG_ERR, "%s: %s",
+               code ? "nghttp2_submit headers" : "nghttp2_submit_trailers",
+               nghttp2_strerror(r));
+    }
+
+    return r;
+}
+
+
+HIDDEN int http2_data_chunk(struct transaction_t *txn,
+                            const char *data, unsigned datalen,
+                            int last_chunk, MD5_CTX *md5ctx)
+{
+    static unsigned char md5[MD5_DIGEST_LENGTH];
+    struct http2_context *ctx = (struct http2_context *) txn->conn->sess_ctx;
+    struct http2_stream *strm = (struct http2_stream *) txn->strm_ctx;
+    uint8_t flags = NGHTTP2_FLAG_END_STREAM;
+    nghttp2_data_provider prd;
+    int r;
+
+    syslog(LOG_DEBUG, "http2_data_chunk(datalen=%u, last=%d)",
+           datalen, last_chunk);
+
+    if (datalen && (txn->conn->logfd != -1)) {
+        /* telemetry log */
+        struct buf *logbuf = &txn->conn->logbuf;
+        struct iovec iov[2];
+        int niov = 0;
+
+        buf_reset(logbuf);
+        buf_printf(logbuf, ">%ld>", time(NULL));  /* timestamp */
+        WRITEV_ADD_TO_IOVEC(iov, niov,
+                            buf_base(logbuf), buf_len(logbuf));
+        WRITEV_ADD_TO_IOVEC(iov, niov, data, datalen);
+        writev(txn->conn->logfd, iov, niov);
+    }
+
+    /* NOTE: The protstream that we use as the data source MUST remain
+       available until the data source read callback has retrieved all data.
+       Also note that we need to make a copy of the data because data frames
+       may not be sent prior to the original pointer becoming invalid.
+    */
+    struct protstream *s = prot_readmap(xmemdup(data, datalen), datalen);
+    s->buf = s->ptr;
+    s->buf_size = datalen;
+
+    prd.source.ptr = s;
+    prd.read_callback = data_source_read_cb;
+
+    if (txn->flags.te) {
+        if (!last_chunk) {
+            flags = NGHTTP2_FLAG_NONE;
+            if (datalen && (txn->flags.trailer & TRAILER_CMD5)) {
+                MD5Update(md5ctx, data, datalen);
+            }
+        }
+        else if (txn->flags.trailer) {
+            flags = NGHTTP2_FLAG_NONE;
+            if (txn->flags.trailer & TRAILER_CMD5) MD5Final(md5, md5ctx);
+        }
+    }
+
+    syslog(LOG_DEBUG, "nghttp2_submit_data(id=%d, datalen=%d, flags=%#x)",
+           strm->id, datalen, flags);
+
+    r = nghttp2_submit_data(ctx->session, flags, strm->id, &prd);
+    if (r) {
+        syslog(LOG_ERR, "nghttp2_submit_data: %s", nghttp2_strerror(r));
+        return HTTP_SERVER_ERROR;
+    }
+    else {
+        http2_output(txn);
+
+        if (last_chunk && (txn->flags.trailer & ~TRAILER_PROXY)) {
+            begin_resp_headers(txn, 0);
+            if (txn->flags.trailer & TRAILER_CMD5) content_md5_hdr(txn, md5);
+            if ((txn->flags.trailer & TRAILER_CTAG) && txn->resp_body.ctag) {
+                simple_hdr(txn, "CTag", "%s", txn->resp_body.ctag);
+            }
+            end_resp_headers(txn, 0);
+        }
+    }
+
+    return 0;
+}
+
+HIDDEN int32_t http2_get_streamid(void *http2_strm)
+{
+    struct http2_stream *strm = (struct http2_stream *) http2_strm;
+
+    return strm ? strm->id : 0;
+}
+
+HIDDEN void http2_end_stream(void *http2_strm)
+{
+    struct http2_stream *strm = (struct http2_stream *) http2_strm;
+    int i;
+
+    if (!strm) return;
+
+    for (i = 0; i < HTTP2_MAX_HEADERS; i++) {
+        free(strm->resp_hdrs[i].value);
+    }
+    free(strm);
+}
+
+#else /* !HAVE_NGHTTP2 */
+
+HIDDEN void http2_init(struct buf *serverinfo __attribute__((unused))) {}
+
+HIDDEN int http2_enabled()
+{
+    return 0;
+}
+
+HIDDEN void http2_done() {}
+
+HIDDEN int http2_preface(struct http_connection *conn __attribute__((unused)))
+{
+    return 0;
+}
+
+HIDDEN int http2_start_session(struct transaction_t *txn __attribute__((unused)),
+                               struct http_connection *c __attribute__((unused)))
+{
+    fatal("http2_start() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN void http2_end_session(void *http2_ctx __attribute__((unused)))
+{
+}
+
+HIDDEN void http2_output(struct transaction_t *txn __attribute__((unused)))
+{
+    fatal("http2_output() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN void http2_input(struct transaction_t *txn __attribute__((unused)))
+{
+    fatal("http2_input() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN int http2_begin_headers(struct transaction_t *txn __attribute__((unused)))
+{
+    fatal("http2_begin_headers() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN void http2_add_header(struct transaction_t *txn __attribute__((unused)),
+                             const char *name __attribute__((unused)),
+                             struct buf *value __attribute__((unused)))
+{
+    fatal("http2_add_header() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN int http2_end_headers(struct transaction_t *txn __attribute__((unused)),
+                             long code __attribute__((unused)))
+{
+    fatal("http2_end_headers() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN int http2_data_chunk(struct transaction_t *txn __attribute__((unused)),
+                            const char *data __attribute__((unused)),
+                            unsigned datalen __attribute__((unused)),
+                            int last_chunk __attribute__((unused)),
+                            MD5_CTX *md5ctx __attribute__((unused)))
+{
+    fatal("http2_data_chunk() called, but no Nghttp2", EX_SOFTWARE);
+}
+
+HIDDEN int32_t http2_get_streamid(void *http2_strm __attribute__((unused)))
+{
+    return 0;
+}
+
+HIDDEN void http2_end_stream(void *http2_strm __attribute__((unused))) {}
+
+#endif /* HAVE_NGHTTP2 */
+
diff -pruN 3.0.13-5/imap/http_h2.h 3.2.0-3/imap/http_h2.h
--- 3.0.13-5/imap/http_h2.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_h2.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,101 @@
+/* httpd_h2.h -HTTP/2 support functions
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef HTTPD_H2_H
+#define HTTPD_H2_H
+
+#include <config.h>
+
+#ifdef HAVE_NGHTTP2
+#include <nghttp2/nghttp2.h>
+
+#else /* !HAVE_NGHTTP2 */
+
+#define NGHTTP2_CLEARTEXT_PROTO_VERSION_ID ""
+
+#endif /* HAVE_NGHTTP2 */
+
+#ifndef HAVE_SSL
+#define SSL void
+#endif
+
+#include "md5.h"
+
+extern int (*alpn_select_cb)(SSL *ssl,
+                             const unsigned char **out, unsigned char *outlen,
+                             const unsigned char *in, unsigned int inlen,
+                             void *arg);
+
+extern void http2_init(struct buf *serverinfo);
+
+extern int http2_enabled();
+
+extern void http2_done();
+
+extern int http2_preface(struct http_connection *conn);
+
+extern int http2_start_session(struct transaction_t *txn,
+                               struct http_connection *conn);
+
+extern void http2_end_session(void *http2_ctx);
+
+extern void http2_output(struct transaction_t *txn);
+
+extern void http2_input(struct transaction_t *txn);
+
+extern void http2_begin_headers(struct transaction_t *txn);
+
+extern void http2_add_header(struct transaction_t *txn,
+                             const char *name, struct buf *value);
+
+extern int http2_end_headers(struct transaction_t *txn, long code);
+
+extern int http2_data_chunk(struct transaction_t *txn,
+                            const char *data, unsigned datalen,
+                            int last_chunk, MD5_CTX *md5ctx);
+
+extern int32_t http2_get_streamid(void *http2_strm);
+
+extern void http2_end_stream(void *http2_strm);
+
+#endif /* HTTPD_H2_H */
diff -pruN 3.0.13-5/imap/http_ischedule.c 3.2.0-3/imap/http_ischedule.c
--- 3.0.13-5/imap/http_ischedule.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_ischedule.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,6 +47,7 @@
 #include <unistd.h>
 #endif
 #include <errno.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include <libical/ical.h>
@@ -116,7 +117,7 @@ static struct mime_type_t isched_mime_ty
 };
 
 struct namespace_t namespace_ischedule = {
-    URL_NS_ISCHEDULE, 0, "/ischedule", ISCHED_WELLKNOWN_URI,
+    URL_NS_ISCHEDULE, 0, "ischedule", "/ischedule", ISCHED_WELLKNOWN_URI,
     http_allow_noauth, /*authschemes*/0,
     /*mbtype*/0,
     (ALLOW_READ | ALLOW_POST | ALLOW_ISCHEDULE),
@@ -124,6 +125,7 @@ struct namespace_t namespace_ischedule =
     {
         { NULL,                 NULL }, /* ACL          */
         { NULL,                 NULL }, /* BIND         */
+        { NULL,                 NULL }, /* CONNECT      */
         { NULL,                 NULL }, /* COPY         */
         { NULL,                 NULL }, /* DELETE       */
         { &meth_get_isched,     NULL }, /* GET          */
@@ -146,7 +148,7 @@ struct namespace_t namespace_ischedule =
 };
 
 struct namespace_t namespace_domainkey = {
-    URL_NS_DOMAINKEY, 0, "/domainkeys", "/.well-known/domainkey",
+    URL_NS_DOMAINKEY, 0, "domainkey", "/domainkeys", "/.well-known/domainkey",
     http_allow_noauth, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -154,6 +156,7 @@ struct namespace_t namespace_domainkey =
     {
         { NULL,                 NULL }, /* ACL          */
         { NULL,                 NULL }, /* BIND         */
+        { NULL,                 NULL }, /* CONNECT      */
         { NULL,                 NULL }, /* COPY         */
         { NULL,                 NULL }, /* DELETE       */
         { &meth_get_domainkey,  NULL }, /* GET          */
@@ -293,7 +296,6 @@ static int meth_get_isched(struct transa
         meth = xmlNewChild(comp, NULL, BAD_CAST "method", NULL);
         xmlNewProp(meth, BAD_CAST "name", BAD_CAST "CANCEL");
 
-#ifdef HAVE_VPOLL
         comp = xmlNewChild(node, NULL, BAD_CAST "component", NULL);
         xmlNewProp(comp, BAD_CAST "name", BAD_CAST "VPOLL");
         meth = xmlNewChild(comp, NULL, BAD_CAST "method", NULL);
@@ -304,7 +306,6 @@ static int meth_get_isched(struct transa
         xmlNewProp(meth, BAD_CAST "name", BAD_CAST "REPLY");
         meth = xmlNewChild(comp, NULL, BAD_CAST "method", NULL);
         xmlNewProp(meth, BAD_CAST "name", BAD_CAST "CANCEL");
-#endif /* HAVE_VPOLL */
 
         comp = xmlNewChild(node, NULL, BAD_CAST "component", NULL);
         xmlNewProp(comp, BAD_CAST "name", BAD_CAST "VFREEBUSY");
@@ -448,8 +449,7 @@ static int meth_post_isched(struct trans
 
     /* Read body */
     txn->req_body.flags |= BODY_DECODE;
-    r = http_read_body(httpd_in, httpd_out,
-                       txn->req_hdrs, &txn->req_body, &txn->error.desc);
+    r = http_read_req_body(txn);
     if (r) {
         txn->flags.conn = CONN_CLOSE;
         return r;
@@ -468,7 +468,8 @@ static int meth_post_isched(struct trans
         authd = 1;
     }
     else if (!spool_getheader(txn->req_hdrs, "DKIM-Signature")) {
-        txn->error.desc = "No signature";
+        if (!config_getswitch(IMAPOPT_ISCHEDULE_DKIM_REQUIRED)) authd = 1;
+        else txn->error.desc = "No signature";
     }
     else {
         authd = dkim_auth(txn);
@@ -532,7 +533,7 @@ static int meth_post_isched(struct trans
         case ICAL_METHOD_CANCEL: {
             struct sched_data sched_data =
                 { 1, meth == ICAL_METHOD_REPLY, 0,
-                  ical, ICAL_SCHEDULEFORCESEND_NONE, NULL };
+                  ical, NULL, NULL, ICAL_SCHEDULEFORCESEND_NONE, NULL, NULL };
             xmlNodePtr root = NULL;
             xmlNsPtr ns[NUM_NAMESPACE];
             struct auth_state *authstate;
@@ -557,13 +558,14 @@ static int meth_post_isched(struct trans
                 while ((recipient = tok_next(&tok))) {
                     /* Is recipient remote or local? */
                     struct caldav_sched_param sparam;
-                    int r = caladdress_lookup(recipient, &sparam, /*myuserid*/NULL);
+                    int r = caladdress_lookup(recipient, &sparam, /*schedule_addresses*/NULL);
 
                     /* Don't allow scheduling with remote users via iSchedule */
                     if (sparam.flags & SCHEDTYPE_REMOTE) r = HTTP_FORBIDDEN;
+                    sched_param_fini(&sparam);
 
                     if (r) sched_data.status = REQSTAT_NOUSER;
-                    else sched_deliver(recipient, &sched_data, authstate);
+                    else sched_deliver(httpd_userid, recipient, &sched_data, authstate);
 
                     xml_add_schedresponse(root, NULL, BAD_CAST recipient,
                                           BAD_CAST sched_data.status);
@@ -614,6 +616,7 @@ int isched_send(struct caldav_sched_para
     icalproperty *prop;
     unsigned code;
     struct transaction_t txn;
+    struct http_connection conn;
 
     *xml = NULL;
     memset(&txn, 0, sizeof(struct transaction_t));
@@ -634,6 +637,11 @@ int isched_send(struct caldav_sched_para
                           &backend_cached, NULL, NULL, httpd_in);
     if (!be) return HTTP_UNAVAILABLE;
 
+    /* Setup HTTP connection for reading response */
+    memset(&conn, 0, sizeof(struct http_connection));
+    conn.pin = be->in;
+    txn.conn = &conn;
+
     /* Create iSchedule request body */
     body = icalcomponent_as_ical_string(ical);
     bodylen = strlen(body);
@@ -696,6 +704,9 @@ int isched_send(struct caldav_sched_para
         buf_printf(&hdrs, "\r\n");
     }
 
+    /* Don't send body until told to */
+    buf_appendcstr(&hdrs, "Expect: 100-continue\r\n");
+
     if (sparam->flags & SCHEDTYPE_REMOTE) {
 #ifdef WITH_DKIM
         DKIM *dkim = NULL;
@@ -750,11 +761,11 @@ int isched_send(struct caldav_sched_para
     /* Send request line */
     prot_printf(be->out, "POST %s %s\r\n", uri, HTTP_VERSION);
 
-    /* Send request headers and body */
+    /* Send request headers */
     prot_putbuf(be->out, &hdrs);
     prot_puts(be->out, "\r\n");
-    prot_write(be->out, body, bodylen);
 
+  response:
     /* Read response (req_hdr and req_body are actually the response) */
     txn.req_body.flags = BODY_DECODE;
     r = http_read_response(be, METH_POST, &code,
@@ -764,8 +775,25 @@ int isched_send(struct caldav_sched_para
 
     if (!r) {
         switch (code) {
+        case 100:  /* Continue */
+            /* Send request body (only ONCE for a given request) */
+            prot_write(be->out, body, bodylen);
+            bodylen = 0;
+
+            GCC_FALLTHROUGH
+            
+        case 102:
+        case 103:  /* Provisional */
+            goto response;
+
         case 200:  /* Successful */
+            /* Create XML parser context */
+            if (!(conn.xml = xmlNewParserCtxt())) {
+                fatal("Unable to create XML parser", EX_TEMPFAIL);
+            }
+
             r = parse_xml_body(&txn, xml, NULL);
+            xmlFreeParserCtxt(conn.xml);
             break;
 
         case 301:
@@ -783,6 +811,8 @@ int isched_send(struct caldav_sched_para
                     break;
                 }
             }
+
+            if (!bodylen) bodylen = strlen(body);  /* Need to send body again */
             goto redirect;
 
         default:
@@ -870,7 +900,8 @@ static DKIM_CBSTAT isched_get_key(DKIM *
 }
 
 
-static void dkim_cachehdr(const char *name, const char *contents, void *rock)
+static void dkim_cachehdr(const char *name, const char *contents,
+                          const char *raw __attribute__((unused)), void *rock)
 {
     struct buf *hdrfield = &tmpbuf;
     static const char *lastname = NULL;
@@ -979,6 +1010,8 @@ static int dkim_auth(struct transaction_
 #else
 static int dkim_auth(struct transaction_t *txn __attribute__((unused)))
 {
+    if (!config_getswitch(IMAPOPT_ISCHEDULE_DKIM_REQUIRED)) return 1;
+
     syslog(LOG_WARNING, "DKIM-Signature provided, but DKIM isn't supported");
 
     return 0;
@@ -1067,12 +1100,12 @@ static void isched_init(struct buf *serv
         namespace_ischedule.enabled = -1;
         buf_cstring(serverinfo);  // squash compiler warning when #undef WITH_DKIM
     }
-#ifdef WITH_DKIM
     else {
         namespace_ischedule.enabled =
             config_httpmodules & IMAP_ENUM_HTTPMODULES_ISCHEDULE;
     }
 
+#ifdef WITH_DKIM
     /* Add OpenDKIM version to serverinfo string */
     uint32_t ver = dkim_libversion();
     buf_printf(serverinfo, " OpenDKIM/%u.%u.%u",
diff -pruN 3.0.13-5/imap/http_jmap.c 3.2.0-3/imap/http_jmap.c
--- 3.0.13-5/imap/http_jmap.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_jmap.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,1071 @@
+/* http_jmap.c -- Routines for handling JMAP requests in httpd
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <errno.h>
+
+#include "acl.h"
+#include "append.h"
+#include "httpd.h"
+#include "http_jmap.h"
+#include "http_proxy.h"
+#include "http_ws.h"
+#include "mboxname.h"
+#include "proxy.h"
+#include "times.h"
+#include "syslog.h"
+#include "user.h"
+#include "xstrlcpy.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+#include "imap/jmap_err.h"
+
+
+#define JMAP_ROOT          "/jmap"
+#define JMAP_BASE_URL      JMAP_ROOT "/"
+#define JMAP_WS_COL        "ws/"
+#define JMAP_UPLOAD_COL    "upload/"
+#define JMAP_UPLOAD_TPL    "{accountId}/"
+#define JMAP_DOWNLOAD_COL  "download/"
+#define JMAP_DOWNLOAD_TPL  "{accountId}/{blobId}/{name}?accept={type}"
+
+struct namespace jmap_namespace;
+
+static time_t compile_time;
+
+
+/* Namespace callbacks */
+static void jmap_init(struct buf *serverinfo);
+static int  jmap_need_auth(struct transaction_t *txn);
+static int  jmap_auth(const char *userid);
+static void jmap_shutdown(void);
+
+/* HTTP method handlers */
+static int meth_get(struct transaction_t *txn, void *params);
+static int meth_options_jmap(struct transaction_t *txn, void *params);
+static int meth_post(struct transaction_t *txn, void *params);
+
+/* JMAP Requests */
+static int jmap_get_session(struct transaction_t *txn);
+static int jmap_download(struct transaction_t *txn);
+static int jmap_upload(struct transaction_t *txn);
+
+/* WebSocket handler */
+#define JMAP_WS_PROTOCOL   "jmap"
+
+static int jmap_ws(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf, void **rock);
+
+static struct connect_params ws_params = {
+    JMAP_BASE_URL JMAP_WS_COL, JMAP_WS_PROTOCOL, &jmap_ws
+};
+
+
+/* Namespace for JMAP */
+struct namespace_t namespace_jmap = {
+    URL_NS_JMAP, 0, "jmap", JMAP_ROOT, "/.well-known/jmap",
+    jmap_need_auth, /*authschemes*/0,
+    /*mbtype*/0, 
+    (ALLOW_READ | ALLOW_POST),
+    &jmap_init, &jmap_auth, NULL, &jmap_shutdown, NULL, /*bearer*/NULL,
+    {
+        { NULL,                 NULL },                 /* ACL          */
+        { NULL,                 NULL },                 /* BIND         */
+        { &meth_connect,        &ws_params },           /* CONNECT      */
+        { NULL,                 NULL },                 /* COPY         */
+        { NULL,                 NULL },                 /* DELETE       */
+        { &meth_get,            NULL },                 /* GET          */
+        { &meth_get,            NULL },                 /* HEAD         */
+        { NULL,                 NULL },                 /* LOCK         */
+        { NULL,                 NULL },                 /* MKCALENDAR   */
+        { NULL,                 NULL },                 /* MKCOL        */
+        { NULL,                 NULL },                 /* MOVE         */
+        { &meth_options_jmap,   NULL },                 /* OPTIONS      */
+        { NULL,                 NULL },                 /* PATCH        */
+        { &meth_post,           NULL },                 /* POST         */
+        { NULL,                 NULL },                 /* PROPFIND     */
+        { NULL,                 NULL },                 /* PROPPATCH    */
+        { NULL,                 NULL },                 /* PUT          */
+        { NULL,                 NULL },                 /* REPORT       */
+        { &meth_trace,          NULL },                 /* TRACE        */
+        { NULL,                 NULL },                 /* UNBIND       */
+        { NULL,                 NULL }                  /* UNLOCK       */
+    }
+};
+
+
+/*
+ * Namespace callbacks
+ */
+
+static jmap_settings_t my_jmap_settings = {
+    HASH_TABLE_INITIALIZER, NULL, { 0 }, PTRARRAY_INITIALIZER
+};
+
+static void jmap_init(struct buf *serverinfo)
+{
+#ifdef USE_XAPIAN
+#include "xapian_wrap.h"
+    buf_printf(serverinfo, " Xapian/%s", xapian_version_string());
+#endif
+
+    namespace_jmap.enabled =
+        config_httpmodules & IMAP_ENUM_HTTPMODULES_JMAP;
+
+    if (namespace_jmap.enabled && !config_getswitch(IMAPOPT_CONVERSATIONS)) {
+        syslog(LOG_ERR,
+               "ERROR: cannot enable %s module with conversations disabled",
+               namespace_jmap.name);
+        namespace_jmap.enabled = 0;
+    }
+
+    if (!namespace_jmap.enabled) return;
+
+    compile_time = calc_compile_time(__TIME__, __DATE__);
+
+    initialize_JMAP_error_table();
+
+    construct_hash_table(&my_jmap_settings.methods, 128, 0);
+    my_jmap_settings.server_capabilities = json_object();
+
+    jmap_core_init(&my_jmap_settings);
+    jmap_mail_init(&my_jmap_settings);
+    jmap_contact_init(&my_jmap_settings);
+    jmap_calendar_init(&my_jmap_settings);
+
+    if (ws_enabled()) {
+        json_object_set_new(my_jmap_settings.server_capabilities,
+                JMAP_URN_WEBSOCKET,
+                json_pack("{s:s s:b}",
+                          "webSocketUrl", "wss:" JMAP_BASE_URL JMAP_WS_COL,
+                          "supportsWebSocketPush", 0));
+    }
+}
+
+static int jmap_auth(const char *userid __attribute__((unused)))
+{
+    /* Set namespace */
+    mboxname_init_namespace(&jmap_namespace,
+                            httpd_userisadmin || httpd_userisproxyadmin);
+    return 0;
+}
+
+static int jmap_need_auth(struct transaction_t *txn __attribute__((unused)))
+{
+    /* All endpoints require authentication */
+    return HTTP_UNAUTHORIZED;
+}
+
+static void jmap_shutdown(void)
+{
+    free_hash_table(&my_jmap_settings.methods, NULL);
+    json_decref(my_jmap_settings.server_capabilities);
+}   
+
+
+/*
+ * HTTP method handlers
+ */
+
+enum {
+    JMAP_ENDPOINT_API,
+    JMAP_ENDPOINT_WS,
+    JMAP_ENDPOINT_UPLOAD,
+    JMAP_ENDPOINT_DOWNLOAD
+};
+
+static int jmap_parse_path(struct transaction_t *txn)
+{
+    struct request_target_t *tgt = &txn->req_tgt;
+    size_t len;
+    char *p;
+
+    if (*tgt->path) return 0;  /* Already parsed */
+
+    /* Make a working copy of target path */
+    strlcpy(tgt->path, txn->req_uri->path, sizeof(tgt->path));
+    p = tgt->path;
+
+    /* Sanity check namespace */
+    len = strlen(namespace_jmap.prefix);
+    if (strlen(p) < len ||
+        strncmp(namespace_jmap.prefix, p, len) ||
+        (tgt->path[len] && tgt->path[len] != '/')) {
+        txn->error.desc = "Namespace mismatch request target path";
+        return HTTP_FORBIDDEN;
+    }
+
+    /* Skip namespace */
+    p += len;
+    if (!*p) {
+        /* Canonicalize URL */
+        txn->location = JMAP_BASE_URL;
+        return HTTP_MOVED;
+    }
+
+    /* Check for path after prefix */
+    if (*++p) {
+        /* Get "collection" */
+        tgt->collection = p;
+
+        if (!strncmp(tgt->collection, JMAP_UPLOAD_COL,
+                          strlen(JMAP_UPLOAD_COL))) {
+            tgt->flags = JMAP_ENDPOINT_UPLOAD;
+            tgt->allow = ALLOW_POST;
+
+            /* Get "resource" which must be the accountId */
+            tgt->resource = tgt->collection + strlen(JMAP_UPLOAD_COL);
+        }
+        else if (!strncmp(tgt->collection,
+                          JMAP_DOWNLOAD_COL, strlen(JMAP_DOWNLOAD_COL))) {
+            tgt->flags = JMAP_ENDPOINT_DOWNLOAD;
+            tgt->allow = ALLOW_READ;
+
+            /* Get "resource" */
+            tgt->resource = tgt->collection + strlen(JMAP_DOWNLOAD_COL);
+        }
+        else if (ws_enabled() && !strcmp(tgt->collection, JMAP_WS_COL)) {
+            tgt->flags = JMAP_ENDPOINT_WS;
+            tgt->allow = (txn->flags.ver == VER_2) ? ALLOW_CONNECT : ALLOW_READ;
+        }
+        else {
+            return HTTP_NOT_FOUND;
+        }
+    }
+    else {
+        tgt->flags = JMAP_ENDPOINT_API;
+        tgt->allow = ALLOW_POST|ALLOW_READ;
+    }
+
+    return 0;
+}
+
+/* Perform a GET/HEAD request */
+static int meth_get(struct transaction_t *txn,
+                    void *params __attribute__((unused)))
+{
+    int r = jmap_parse_path(txn);
+
+    if (!(txn->req_tgt.allow & ALLOW_READ)) {
+        return HTTP_NOT_FOUND;
+    }
+    else if (r) return r;
+
+    if (txn->req_tgt.flags == JMAP_ENDPOINT_API) {
+        return jmap_get_session(txn);
+    }
+    else if (txn->req_tgt.flags == JMAP_ENDPOINT_DOWNLOAD) {
+        return jmap_download(txn);
+    }
+    /* Upgrade to WebSockets over HTTP/1.1 on WS endpoint, if requested */
+    else if ((txn->req_tgt.flags == JMAP_ENDPOINT_WS) &&
+             (txn->flags.upgrade & UPGRADE_WS)) {
+        return ws_start_channel(txn, JMAP_WS_PROTOCOL, &jmap_ws);
+    }
+
+    return HTTP_NO_CONTENT;
+}
+
+static int json_response(int code, struct transaction_t *txn, json_t *root)
+{
+    size_t flags = JSON_PRESERVE_ORDER;
+    char *buf;
+
+    /* Dump JSON object into a text buffer */
+    flags |= (config_httpprettytelemetry ? JSON_INDENT(2) : JSON_COMPACT);
+    buf = json_dumps(root, flags);
+    json_decref(root);
+
+    if (!buf) {
+        txn->error.desc = "Error dumping JSON object";
+        return HTTP_SERVER_ERROR;
+    }
+
+    /* Output the JSON object */
+    switch (code) {
+    case HTTP_OK:
+    case HTTP_CREATED:
+        txn->resp_body.type = "application/json; charset=utf-8";
+        break;
+    default:
+        txn->resp_body.type = "application/problem+json; charset=utf-8";
+        break;
+    }
+
+    write_body(code, txn, buf, strlen(buf));
+    free(buf);
+
+    return 0;
+}
+
+/* Perform a POST request */
+static int meth_post(struct transaction_t *txn,
+                     void *params __attribute__((unused)))
+{
+    int ret;
+    json_t *res = NULL;
+
+    ret = jmap_parse_path(txn);
+
+    if (ret) return ret;
+    if (!(txn->req_tgt.allow & ALLOW_POST)) {
+        return HTTP_NOT_ALLOWED;
+    }
+
+    /* Handle uploads */
+    if (txn->req_tgt.flags == JMAP_ENDPOINT_UPLOAD) {
+        return jmap_upload(txn);
+    }
+
+    /* Regular JMAP API request */
+    ret = jmap_api(txn, &res, &my_jmap_settings);
+
+    if (res) {
+        /* Output the JSON object */
+        ret = json_response(ret ? ret : HTTP_OK, txn, res);
+    }
+
+    syslog(LOG_DEBUG, ">>>> jmap_post: Exit\n");
+    return ret;
+}
+
+/* Perform an OPTIONS request */
+static int meth_options_jmap(struct transaction_t *txn, void *params)
+{
+    /* Parse the path */
+    int r = jmap_parse_path(txn);
+    if (r) return r;
+
+    return meth_options(txn, params);
+}
+
+
+/*
+ * JMAP Requests
+ */
+
+static char *parse_accept_header(const char **hdr)
+{
+    char *val = NULL;
+    struct accept *accept = parse_accept(hdr);
+    if (accept) {
+        char *type = NULL;
+        char *subtype = NULL;
+        struct param *params = NULL;
+        message_parse_type(accept->token, &type, &subtype, &params);
+        if (type && subtype && !strchr(type, '*') && !strchr(subtype, '*'))
+            val = xstrdup(accept->token);
+        free(type);
+        free(subtype);
+        param_free(&params);
+        struct accept *tmp;
+        for (tmp = accept; tmp && tmp->token; tmp++) {
+            free(tmp->token);
+        }
+        free(accept);
+    }
+    return val;
+}
+
+static int jmap_getblob_default_handler(jmap_req_t *req,
+                                        const char *blobid,
+                                        const char *accept_mime)
+{
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    struct body *body = NULL;
+    const struct body *part = NULL;
+    struct buf msg_buf = BUF_INITIALIZER;
+    struct buf blob = BUF_INITIALIZER;
+    char *decbuf = NULL;
+    int res = 0;
+
+    if (*blobid != 'G') {
+        req->txn->error.desc = "invalid blobid (doesn't start with G)";
+        return HTTP_BAD_REQUEST;
+    }
+
+    if (strlen(blobid) != 41) {
+        /* incomplete or incorrect blobid */
+        req->txn->error.desc = "invalid blobid (not 41 chars)";
+        return HTTP_BAD_REQUEST;
+    }
+
+    /* Find part containing blob */
+    int r = jmap_findblob(req, NULL/*accountid*/, blobid,
+                          &mbox, &mr, &body, &part, &msg_buf);
+    if (r) {
+        res = HTTP_NOT_FOUND; // XXX errors?
+        req->txn->error.desc = "failed to find blob by id";
+        goto done;
+    }
+
+    // default with no part is the whole message
+    const char *base = msg_buf.s;
+    size_t len = msg_buf.len;
+
+    if (part) {
+        // map into just this part
+        base += part->content_offset;
+        len = part->content_size;
+
+        // binary decode if needed
+        int encoding = part->charset_enc & 0xff;
+        base = charset_decode_mimebody(base, len, encoding, &decbuf, &len);
+    }
+
+    // success
+    buf_setmap(&blob, base, len);
+    req->txn->resp_body.type = accept_mime ? accept_mime : "application/octet-stream";
+    req->txn->resp_body.len = buf_len(&blob);
+    write_body(HTTP_OK, req->txn, buf_base(&blob), buf_len(&blob));
+    res = HTTP_OK;
+
+ done:
+    free(decbuf);
+    if (mbox) jmap_closembox(req, &mbox);
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    if (mr) {
+        msgrecord_unref(&mr);
+    }
+    buf_free(&msg_buf);
+    buf_free(&blob);
+    return res;
+}
+
+/* Handle a GET on the download endpoint */
+static int jmap_download(struct transaction_t *txn)
+{
+    const char *userid = txn->req_tgt.resource;
+    const char *slash = strchr(userid, '/');
+    if (!slash) {
+        /* XXX - error, needs AccountId */
+        return HTTP_NOT_FOUND;
+    }
+
+    const char *blobbase = slash + 1;
+    slash = strchr(blobbase, '/');
+    if (!slash) {
+        /* XXX - error, needs blobid */
+        txn->error.desc = "failed to find blobid";
+        return HTTP_BAD_REQUEST;
+    }
+    size_t bloblen = slash - blobbase;
+    const char *fname = slash + 1;
+
+    /* now we're allocating memory, so don't return from here! */
+
+    char *accountid = xstrndup(userid, strchr(userid, '/') - userid);
+    int res = 0;
+
+    struct conversations_state *cstate = NULL;
+    int r = conversations_open_user(accountid, 1/*shared*/, &cstate);
+    if (r) {
+        txn->error.desc = error_message(r);
+        res = (r == IMAP_MAILBOX_BADNAME) ? HTTP_NOT_FOUND : HTTP_SERVER_ERROR;
+        free(accountid);
+        return res;
+    }
+
+    char *blobid = NULL;
+    char *accept_mime = NULL;
+    struct buf blob = BUF_INITIALIZER;
+
+    /* Initialize request context */
+    struct jmap_req req;
+    jmap_initreq(&req);
+
+    req.userid = httpd_userid;
+    req.accountid = accountid;
+    req.cstate = cstate;
+    req.authstate = httpd_authstate;
+    req.txn = txn;
+
+    /* Initialize ACL mailbox cache for findblob */
+    hash_table mboxrights = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&mboxrights, 64, 0);
+    req.mboxrights = &mboxrights;
+
+    blobid = xstrndup(blobbase, bloblen);
+
+    struct strlist *param;
+    if ((param = hash_lookup("accept", &txn->req_qparams))) {
+        accept_mime = xstrdup(param->s);
+    }
+
+    const char **hdr;
+    if (!accept_mime && (hdr = spool_getheader(txn->req_hdrs, "Accept"))) {
+        accept_mime = parse_accept_header(hdr);
+    }
+
+    /* Set Content-Disposition header */
+    txn->resp_body.dispo.attach = fname != NULL;
+    txn->resp_body.dispo.fname = fname;
+
+    /* Call blob download handlers */
+    int i;
+    for (i = 0; i < ptrarray_size(&my_jmap_settings.getblob_handlers); i++) {
+        jmap_getblob_handler *h = ptrarray_nth(&my_jmap_settings.getblob_handlers, i);
+        res = h(&req, blobid, accept_mime);
+        if (res) break;
+    }
+    if (!res) {
+        /* Try default blob download handler */
+        res = jmap_getblob_default_handler(&req, blobid, accept_mime);
+        if (!res) res = HTTP_NOT_FOUND;
+    }
+
+    if (res != HTTP_OK) {
+        if (!txn->error.desc) txn->error.desc = error_message(res);
+        txn->resp_body.dispo.attach = 0;
+        txn->resp_body.dispo.fname = NULL;
+    }
+    else if (res == HTTP_OK) res = 0;
+
+    buf_free(&blob);
+    free_hash_table(&mboxrights, free);
+    conversations_commit(&cstate);
+    free(accept_mime);
+    free(accountid);
+    free(blobid);
+    jmap_finireq(&req);
+    return res;
+}
+
+static int lookup_upload_collection(const char *accountid, mbentry_t **mbentry)
+{
+    mbname_t *mbname;
+    const char *uploadname;
+    int r;
+
+    /* Create upload mailbox name from the parsed path */
+    mbname = mbname_from_userid(accountid);
+    mbname_push_boxes(mbname, config_getstring(IMAPOPT_JMAPUPLOADFOLDER));
+
+    /* XXX - hack to allow @domain parts for non-domain-split users */
+    if (httpd_extradomain) {
+        /* not allowed to be cross domain */
+        if (mbname_localpart(mbname) &&
+            strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
+            r = HTTP_NOT_FOUND;
+            goto done;
+        }
+        mbname_set_domain(mbname, NULL);
+    }
+
+    /* Locate the mailbox */
+    uploadname = mbname_intname(mbname);
+    r = http_mlookup(uploadname, mbentry, NULL);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* Find location of INBOX */
+        char *inboxname = mboxname_user_mbox(accountid, NULL);
+
+        int r1 = http_mlookup(inboxname, mbentry, NULL);
+        free(inboxname);
+        if (r1 == IMAP_MAILBOX_NONEXISTENT) {
+            r = IMAP_INVALID_USER;
+            goto done;
+        }
+
+        int rights = httpd_myrights(httpd_authstate, *mbentry);
+        if (!(rights & ACL_CREATE)) {
+            r = IMAP_PERMISSION_DENIED;
+            goto done;
+        }
+
+        if (*mbentry) free((*mbentry)->name);
+        else *mbentry = mboxlist_entry_create();
+        (*mbentry)->name = xstrdup(uploadname);
+    }
+    else if (!r) {
+        int rights = httpd_myrights(httpd_authstate, *mbentry);
+        if (!(rights & ACL_INSERT)) {
+            r = IMAP_PERMISSION_DENIED;
+            goto done;
+        }
+    }
+
+  done:
+    mbname_free(&mbname);
+    return r;
+}
+
+static int _create_upload_collection(const char *accountid,
+                                     struct mailbox **mailbox)
+{
+    /* upload collection */
+    struct mboxlock *namespacelock = user_namespacelock(accountid);
+    mbentry_t *mbentry = NULL;
+    int r = lookup_upload_collection(accountid, &mbentry);
+
+    if (r == IMAP_INVALID_USER) {
+        goto done;
+    }
+    else if (r == IMAP_PERMISSION_DENIED) {
+        goto done;
+    }
+    else if (r == IMAP_MAILBOX_NONEXISTENT) {
+        if (!mbentry) goto done;
+        else if (mbentry->server) {
+            proxy_findserver(mbentry->server, &http_protocol, httpd_userid,
+                             &backend_cached, NULL, NULL, httpd_in);
+            goto done;
+        }
+
+        r = mboxlist_createmailbox(mbentry->name, MBTYPE_COLLECTION,
+                                   NULL, 1 /* admin */, accountid,
+                                   httpd_authstate, 0, 0, 0, 0, mailbox);
+        /* we lost the race, that's OK */
+        if (r == IMAP_MAILBOX_LOCKED) r = 0;
+        else {
+            if (r) {
+                syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                        mbentry->name, error_message(r));
+            }
+            goto done;
+        }
+    }
+    else if (r) goto done;
+
+    if (mailbox) {
+        /* Open mailbox for writing */
+        r = mailbox_open_iwl(mbentry->name, mailbox);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
+                   mbentry->name, error_message(r));
+        }
+    }
+
+ done:
+    mboxname_release(&namespacelock);
+    mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+HIDDEN int jmap_open_upload_collection(const char *accountid,
+                                       struct mailbox **mailbox)
+{
+    /* upload collection */
+    mbentry_t *mbentry = NULL;
+    int r = lookup_upload_collection(accountid, &mbentry);
+    if (r) {
+        mboxlist_entry_free(&mbentry);
+        return _create_upload_collection(accountid, mailbox);
+    }
+
+    if (mailbox) {
+        /* Open mailbox for writing */
+        r = mailbox_open_iwl(mbentry->name, mailbox);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_open_iwl(%s) failed: %s",
+                   mbentry->name, error_message(r));
+        }
+    }
+
+    mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+/* Helper function to determine domain of data */
+enum {
+    DOMAIN_7BIT = 0,
+    DOMAIN_8BIT,
+    DOMAIN_BINARY
+};
+
+static int data_domain(const char *p, size_t n)
+{
+    int r = DOMAIN_7BIT;
+
+    while (n--) {
+        if (!*p) return DOMAIN_BINARY;
+        if (*p & 0x80) r = DOMAIN_8BIT;
+        p++;
+    }
+
+    return r;
+}
+
+/* Handle a POST on the upload endpoint */
+static int jmap_upload(struct transaction_t *txn)
+{
+    strarray_t flags = STRARRAY_INITIALIZER;
+
+    struct body *body = NULL;
+
+    int ret = HTTP_CREATED;
+    hdrcache_t hdrcache = txn->req_hdrs;
+    struct stagemsg *stage = NULL;
+    FILE *f = NULL;
+    const char **hdr;
+    time_t now = time(NULL);
+    struct appendstate as;
+    char *normalisedtype = NULL;
+    int rawmessage = 0;
+
+    struct mailbox *mailbox = NULL;
+    int r = 0;
+
+    /* Read body */
+    txn->req_body.flags |= BODY_DECODE;
+    r = http_read_req_body(txn);
+    if (r) {
+        txn->flags.conn = CONN_CLOSE;
+        return r;
+    }
+
+    const char *data = buf_base(&txn->req_body.payload);
+    size_t datalen = buf_len(&txn->req_body.payload);
+
+    if (datalen > (size_t) my_jmap_settings.limits[MAX_SIZE_UPLOAD]) {
+        txn->error.desc = "JSON upload byte size exceeds maxSizeUpload";
+        return HTTP_PAYLOAD_TOO_LARGE;
+    }
+
+    /* Resource must be {accountId}/ with no trailing path */
+    char *accountid = xstrdup(txn->req_tgt.resource);
+    char *slash = strchr(accountid, '/');
+    if (!slash || *(slash + 1) != '\0') {
+        ret = HTTP_NOT_FOUND;
+        goto done;
+    }
+    *slash = '\0';
+
+    r = jmap_open_upload_collection(accountid, &mailbox);
+    if (r) {
+        syslog(LOG_ERR, "jmap_upload: can't open upload collection for %s: %s",
+               error_message(r), accountid);
+        ret = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Prepare to stage the message */
+    if (!(f = append_newstage(mailbox->name, now, 0, &stage))) {
+        syslog(LOG_ERR, "append_newstage(%s) failed", mailbox->name);
+        txn->error.desc = "append_newstage() failed";
+        ret = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    const char *type = "application/octet-stream";
+    if ((hdr = spool_getheader(hdrcache, "Content-Type"))) {
+        type = hdr[0];
+    }
+    /* Remove CFWS and encodings from type */
+    normalisedtype = charset_decode_mimeheader(type, CHARSET_KEEPCASE);
+
+    if (!strcasecmp(normalisedtype, "message/rfc822")) {
+        struct protstream *stream = prot_readmap(data, datalen);
+        r = message_copy_strict(stream, f, datalen, 0);
+        prot_free(stream);
+        if (!r) {
+            rawmessage = 1;
+            goto wrotebody;
+        }
+        // otherwise we gotta clean up and make it an attachment
+        ftruncate(fileno(f), 0L);
+        fseek(f, 0L, SEEK_SET);
+    }
+
+    /* Create RFC 5322 header for resource */
+    if ((hdr = spool_getheader(hdrcache, "User-Agent"))) {
+        fprintf(f, "User-Agent: %s\r\n", hdr[0]);
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "From"))) {
+        fprintf(f, "From: %s\r\n", hdr[0]);
+    }
+    else {
+        char *mimehdr;
+
+        assert(!buf_len(&txn->buf));
+        if (strchr(httpd_userid, '@')) {
+            /* XXX  This needs to be done via an LDAP/DB lookup */
+            buf_printf(&txn->buf, "<%s>", httpd_userid);
+        }
+        else {
+            buf_printf(&txn->buf, "<%s@%s>", httpd_userid, config_servername);
+        }
+
+        mimehdr = charset_encode_mimeheader(buf_cstring(&txn->buf),
+                                            buf_len(&txn->buf), 0);
+        fprintf(f, "From: %s\r\n", mimehdr);
+        free(mimehdr);
+        buf_reset(&txn->buf);
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "Subject"))) {
+        fprintf(f, "Subject: %s\r\n", hdr[0]);
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "Date"))) {
+        fprintf(f, "Date: %s\r\n", hdr[0]);
+    }
+    else {
+        char datestr[80];
+        time_to_rfc5322(now, datestr, sizeof(datestr));
+        fprintf(f, "Date: %s\r\n", datestr);
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "Message-ID"))) {
+        fprintf(f, "Message-ID: %s\r\n", hdr[0]);
+    }
+
+    fprintf(f, "Content-Type: %s\r\n", type);
+
+    int domain = data_domain(data, datalen);
+    switch (domain) {
+        case DOMAIN_BINARY:
+            fputs("Content-Transfer-Encoding: BINARY\r\n", f);
+            break;
+        case DOMAIN_8BIT:
+            fputs("Content-Transfer-Encoding: 8BIT\r\n", f);
+            break;
+        default:
+            break; // no CTE == 7bit
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "Content-Disposition"))) {
+        fprintf(f, "Content-Disposition: %s\r\n", hdr[0]);
+    }
+
+    if ((hdr = spool_getheader(hdrcache, "Content-Description"))) {
+        fprintf(f, "Content-Description: %s\r\n", hdr[0]);
+    }
+
+    fprintf(f, "Content-Length: %u\r\n", (unsigned) datalen);
+
+    fputs("MIME-Version: 1.0\r\n\r\n", f);
+
+    /* Write the data to the file */
+    fwrite(data, datalen, 1, f);
+
+wrotebody:
+
+    fclose(f);
+
+    /* Prepare to append the message to the mailbox */
+    r = append_setup_mbox(&as, mailbox, httpd_userid, httpd_authstate,
+                          0, /*quota*/NULL, 0, 0, /*event*/0);
+    if (r) {
+        syslog(LOG_ERR, "append_setup(%s) failed: %s",
+               mailbox->name, error_message(r));
+        ret = HTTP_SERVER_ERROR;
+        txn->error.desc = "append_setup() failed";
+        goto done;
+    }
+
+    /* Append the message to the mailbox */
+    strarray_append(&flags, "\\Deleted");
+    strarray_append(&flags, "\\Expunged");  // custom flag to insta-expunge!
+    r = append_fromstage(&as, &body, stage, now, 0, &flags, 0, /*annots*/NULL);
+
+    if (r) {
+        append_abort(&as);
+        syslog(LOG_ERR, "append_fromstage(%s) failed: %s",
+               mailbox->name, error_message(r));
+        ret = HTTP_SERVER_ERROR;
+        txn->error.desc = "append_fromstage() failed";
+        goto done;
+    }
+
+    r = append_commit(&as);
+    if (r) {
+        syslog(LOG_ERR, "append_commit(%s) failed: %s",
+               mailbox->name, error_message(r));
+        ret = HTTP_SERVER_ERROR;
+        txn->error.desc = "append_commit() failed";
+        goto done;
+    }
+
+    char datestr[RFC3339_DATETIME_MAX];
+    time_to_rfc3339(now + 86400, datestr, RFC3339_DATETIME_MAX);
+
+    char blob_id[JMAP_BLOBID_SIZE];
+    jmap_set_blobid(rawmessage ? &body->guid : &body->content_guid, blob_id);
+
+    /* Create response object */
+    json_t *resp = json_pack("{s:s}", "accountId", accountid);
+    json_object_set_new(resp, "blobId", json_string(blob_id));
+    json_object_set_new(resp, "size", json_integer(datalen));
+    json_object_set_new(resp, "expires", json_string(datestr));
+    json_object_set_new(resp, "type", json_string(normalisedtype));
+
+    /* Output the JSON object */
+    ret = json_response(HTTP_CREATED, txn, resp);
+
+done:
+    free(normalisedtype);
+    free(accountid);
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    strarray_fini(&flags);
+    append_removestage(stage);
+    if (mailbox) {
+        if (r) mailbox_abort(mailbox);
+        else r = mailbox_commit(mailbox);
+        mailbox_close(&mailbox);
+    }
+
+    return ret;
+}
+
+/* Handle a GET on the session endpoint */
+static int jmap_get_session(struct transaction_t *txn)
+{
+    json_t *jsession = json_object();
+
+    /* URLs */
+    json_object_set_new(jsession, "username", json_string(httpd_userid));
+    json_object_set_new(jsession, "apiUrl", json_string(JMAP_BASE_URL));
+    json_object_set_new(jsession, "downloadUrl",
+            json_string(JMAP_BASE_URL JMAP_DOWNLOAD_COL JMAP_DOWNLOAD_TPL));
+    json_object_set_new(jsession, "uploadUrl",
+            json_string(JMAP_BASE_URL JMAP_UPLOAD_COL JMAP_UPLOAD_TPL));
+    /* TODO eventSourceUrl */
+
+    /* state */
+    char *inboxname = mboxname_user_mbox(httpd_userid, NULL);
+    struct buf state = BUF_INITIALIZER;
+    buf_printf(&state, MODSEQ_FMT, mboxname_readraclmodseq(inboxname));
+    json_object_set_new(jsession, "state", json_string(buf_cstring(&state)));
+    free(inboxname);
+    buf_free(&state);
+
+    /* capabilities */
+    json_object_set(jsession, "capabilities", my_jmap_settings.server_capabilities);
+    json_t *accounts = json_object();
+    json_t *primary_accounts = json_object();
+    jmap_accounts(accounts, primary_accounts);
+    json_object_set_new(jsession, "accounts", accounts);
+    json_object_set_new(jsession, "primaryAccounts", primary_accounts);
+
+    /* Response should not be cached */
+    txn->flags.cc |= CC_NOCACHE | CC_NOSTORE | CC_REVALIDATE;
+
+    /* Write the JSON response */
+    return json_response(HTTP_OK, txn, jsession);
+}
+
+
+/*
+ * WebSockets data callback ('jmap' sub-protocol): Process JMAP API request.
+ *
+ * Can be tested with:
+ *   https://github.com/websockets/wscat
+ *   https://chrome.google.com/webstore/detail/web-socket-client/lifhekgaodigcpmnakfhaaaboididbdn
+ *
+ * WebSockets over HTTP/2 currently only available in:
+ *   https://www.google.com/chrome/browser/canary.html
+ */
+static int jmap_ws(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf, void **rock)
+{
+    struct transaction_t **txnp = (struct transaction_t **) rock;
+    struct transaction_t *txn = *txnp;
+    json_t *res = NULL;
+    int ret;
+
+    if (!txn) {
+        /* Create a transaction rock to use for API requests */
+        txn = *txnp = xzmalloc(sizeof(struct transaction_t));
+        txn->meth = METH_UNKNOWN;
+        txn->req_body.flags = BODY_DONE;
+
+        /* Create header cache */
+        txn->req_hdrs = spool_new_hdrcache();
+        if (!txn->req_hdrs) {
+            free(txn);
+            return HTTP_SERVER_ERROR;
+        }
+
+        /* Set Content-Type of request payload */
+        spool_cache_header(xstrdup("Content-Type"),
+                           xstrdup("application/json"), txn->req_hdrs);
+    }
+    else if (!inbuf) {
+        /* Free transaction rock */
+        transaction_free(txn);
+        free(txn);
+        return 0;
+    }
+
+    /* Set request payload */
+    buf_init_ro(&txn->req_body.payload, buf_base(inbuf), buf_len(inbuf));
+
+    /* Process the API request */
+    ret = jmap_api(txn, &res, &my_jmap_settings);
+
+    /* Free request payload */
+    buf_free(&txn->req_body.payload);
+
+    if (logbuf) {
+        /* Log JMAP methods */
+        const char **hdr = spool_getheader(txn->req_hdrs, ":jmap");
+
+        if (hdr) buf_printf(logbuf, "; jmap=%s", hdr[0]);
+    }
+
+    if (!ret) {
+        /* Return the JSON object */
+        size_t flags = JSON_PRESERVE_ORDER;
+        char *buf;
+
+        /* Dump JSON object into a text buffer */
+        flags |= (config_httpprettytelemetry ? JSON_INDENT(2) : JSON_COMPACT);
+        buf = json_dumps(res, flags);
+        json_decref(res);
+
+        buf_initm(outbuf, buf, strlen(buf));
+    }
+
+    return ret;
+}
diff -pruN 3.0.13-5/imap/http_jmap.h 3.2.0-3/imap/http_jmap.h
--- 3.0.13-5/imap/http_jmap.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_jmap.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,55 @@
+/* http_jmap.h -- Routines for handling JMAP requests in httpd
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef HTTP_JMAP_H
+#define HTTP_JMAP_H
+
+#include "httpd.h"
+#include "jmap_api.h"
+
+extern struct namespace jmap_namespace;
+
+extern int jmap_open_upload_collection(const char *accountid,
+                                       struct mailbox **mailbox);
+
+#endif /* HTTP_JMAP_H */
diff -pruN 3.0.13-5/imap/http_prometheus.c 3.2.0-3/imap/http_prometheus.c
--- 3.0.13-5/imap/http_prometheus.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_prometheus.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,160 @@
+/* http_prometheus.c -- Routines for handling Prometheus requests in httpd
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include "imap/httpd.h"
+#include "imap/http_err.h"
+#include "imap/prometheus.h"
+
+static int prom_need_auth(struct transaction_t *txn);
+static void prom_init(struct buf *);
+static int prom_auth(const char *);
+static void prom_reset(void);
+static void prom_shutdown(void);
+static int prom_get(struct transaction_t *txn, void *params);
+
+struct namespace_t namespace_prometheus = {
+    URL_NS_PROMETHEUS,
+    /*enabled*/ 0,
+    "prometheus",
+    "/metrics",
+    /* XXX .well-known url*/ NULL,
+    prom_need_auth,
+    /* XXX auth schemes*/ 0,
+    /*mboxtype*/ 0,
+    (ALLOW_READ),
+    &prom_init,
+    &prom_auth,
+    &prom_reset,
+    &prom_shutdown,
+    /* XXX premethod */ NULL,
+    /* XXX bearer */ NULL,
+    {
+        { NULL,                 NULL },                 /* ACL          */
+        { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
+        { NULL,                 NULL },                 /* COPY         */
+        { NULL,                 NULL },                 /* DELETE       */
+        { &prom_get,            NULL },                 /* GET          */
+        { NULL,                 NULL },                 /* HEAD         */
+        { NULL,                 NULL },                 /* LOCK         */
+        { NULL,                 NULL },                 /* MKCALENDAR   */
+        { NULL,                 NULL },                 /* MKCOL        */
+        { NULL,                 NULL },                 /* MOVE         */
+        { &meth_options,        NULL },                 /* OPTIONS      */
+        { NULL,                 NULL },                 /* PATCH        */
+        { NULL,                 NULL },                 /* POST         */
+        { NULL,                 NULL },                 /* PROPFIND     */
+        { NULL,                 NULL },                 /* PROPPATCH    */
+        { NULL,                 NULL },                 /* PUT          */
+        { NULL,                 NULL },                 /* REPORT       */
+        { &meth_trace,          NULL },                 /* TRACE        */
+        { NULL,                 NULL },                 /* UNBIND       */
+        { NULL,                 NULL },                 /* UNLOCK       */
+    },
+};
+
+static int prom_need_auth(struct transaction_t *txn __attribute__((unused)))
+{
+    const char *need_auth = config_getstring(IMAPOPT_PROMETHEUS_NEED_AUTH);
+
+    if (!strcmp(need_auth, "none"))
+        return 0;
+
+    return HTTP_UNAUTHORIZED;
+}
+
+static void prom_init(struct buf *serverinfo __attribute__((unused)))
+{
+    namespace_prometheus.enabled =
+        (config_httpmodules & IMAP_ENUM_HTTPMODULES_PROMETHEUS)
+        && config_getswitch(IMAPOPT_PROMETHEUS_ENABLED);
+}
+
+static int prom_auth(const char *userid __attribute__((unused)))
+{
+    /* FIXME */
+    return 0;
+}
+
+static void prom_reset(void)
+{
+    /* FIXME */
+}
+
+static void prom_shutdown(void)
+{
+    /* FIXME */
+}
+
+static int prom_get(struct transaction_t *txn,
+                    void *params __attribute__((unused)))
+{
+    struct buf buf = BUF_INITIALIZER;
+    const char *mimetype = NULL;
+    int r;
+
+    if (strcmp(txn->req_uri->path, "/metrics"))
+        return HTTP_NOT_FOUND;
+
+    const char *need_auth = config_getstring(IMAPOPT_PROMETHEUS_NEED_AUTH);
+    if (!strcmp(need_auth, "admin") && !httpd_userisadmin)
+        return HTTP_UNAUTHORIZED;
+    if (!strcmp(need_auth, "user") && !httpd_userid)
+        return HTTP_UNAUTHORIZED;
+
+    r = prometheus_text_report(&buf, &mimetype);
+    if (r) {
+        txn->error.desc = error_message(r);
+        return HTTP_SERVER_ERROR;
+    }
+
+    txn->resp_body.type = mimetype;
+    txn->resp_body.len = buf_len(&buf);
+
+    write_body(HTTP_OK, txn, buf_cstring(&buf), buf_len(&buf));
+
+    buf_free(&buf);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/http_proxy.c 3.2.0-3/imap/http_proxy.c
--- 3.0.13-5/imap/http_proxy.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_proxy.c	2020-04-24 02:03:00.000000000 +0000
@@ -85,14 +85,6 @@ HIDDEN struct protocol_t http_protocol =
 };
 
 
-EXPORTED const char *digest_recv_success(hdrcache_t hdrs)
-{
-    const char **hdr = spool_getheader(hdrs, "Authentication-Info");
-
-    return (hdr ? hdr[0]: NULL);
-}
-
-
 static const char *callback_getdata(sasl_conn_t *conn,
                                     sasl_callback_t *callbacks,
                                     unsigned long callbackid)
@@ -105,14 +97,14 @@ static const char *callback_getdata(sasl
             switch (cb->id) {
             case SASL_CB_USER:
             case SASL_CB_AUTHNAME: {
-                sasl_getsimple_t *simple_cb = (sasl_getsimple_t *) cb->proc;
+                sasl_getsimple_t *simple_cb = (void *) cb->proc;
                 simple_cb(cb->context, cb->id, &result, NULL);
                 break;
             }
 
             case SASL_CB_PASS: {
                 sasl_secret_t *pass;
-                sasl_getsecret_t *pass_cb = (sasl_getsecret_t *) cb->proc;
+                sasl_getsecret_t *pass_cb = (void *) cb->proc;
                 pass_cb(conn, cb->context, cb->id, &pass);
                 result = (const char *) pass->data;
                 break;
@@ -128,8 +120,7 @@ static const char *callback_getdata(sasl
 #define BASE64_BUF_SIZE 21848   /* per RFC 2222bis: ((16K / 3) + 1) * 4  */
 
 static int login(struct backend *s, const char *userid,
-                 sasl_callback_t *cb, const char **status,
-                 int noauth __attribute__((unused)))
+                 sasl_callback_t *cb, const char **status, int noauth)
 {
     int r = 0;
     socklen_t addrsize;
@@ -142,9 +133,12 @@ static int login(struct backend *s, cons
     struct auth_scheme_t *scheme = NULL;
     unsigned need_tls = 0, tls_done = 0, auth_done = 0, clientoutlen;
     hdrcache_t hdrs = NULL;
+    char *sid = NULL;
 
     if (status) *status = NULL;
 
+    if (noauth) return 0;
+
     /* set the IP addresses */
     addrsize = sizeof(struct sockaddr_storage);
     if (getpeername(s->sock, (struct sockaddr *) &saddr_r, &addrsize) ||
@@ -195,6 +189,7 @@ static int login(struct backend *s, cons
         char base64[BASE64_BUF_SIZE+1];
         unsigned int serverinlen;
         struct body_t resp_body;
+        struct auth_scheme_t auth_scheme_basic = AUTH_SCHEME_BASIC;
 #ifdef SASL_HTTP_REQUEST
         sasl_http_request_t httpreq = { "OPTIONS",      /* Method */
                                         "*",            /* URI */
@@ -215,10 +210,20 @@ static int login(struct backend *s, cons
         /* Send Authorization and/or Upgrade request to server */
         prot_puts(s->out, "OPTIONS * HTTP/1.1\r\n");
         prot_printf(s->out, "Host: %s\r\n", s->hostname);
-        prot_printf(s->out, "User-Agent: %s\r\n", buf_cstring(&serverinfo));
+        prot_printf(s->out, "User-Agent: Cyrus/%s\r\n", CYRUS_VERSION);
         if (scheme) {
-            prot_printf(s->out, "Authorization: %s %s\r\n",
-                        scheme->name, clientout ? clientout : "");
+            prot_printf(s->out, "Authorization: %s", scheme->name);
+
+            if (clientout) {
+                prot_putc(' ', s->out);
+                if (scheme->flags & AUTH_DATA_PARAM) {
+                    if (sid) prot_printf(s->out, "sid=%s,", sid);
+                    prot_puts(s->out, "data=");
+                }
+                prot_write(s->out, clientout, clientoutlen);
+            }
+            prot_puts(s->out, "\r\n");
+
             prot_printf(s->out, "Authorize-As: %s\r\n",
                         userid ? userid : "anonymous");
         }
@@ -283,8 +288,17 @@ static int login(struct backend *s, cons
             break;
 
         case 200: /* OK */
-            if (scheme->recv_success &&
-                (serverin = scheme->recv_success(hdrs))) {
+            if ((hdr = spool_getheader(hdrs, "Authentication-Info"))) { 
+                /* Default handling of success data */
+                serverin = hdr[0];
+            }
+            else if (scheme && (scheme->flags & AUTH_SUCCESS_WWW) &&
+                     (hdr = spool_getheader(hdrs, "WWW-Authenticate"))) {
+                /* Special handling of success data for this scheme */
+                serverin = strchr(hdr[0], ' ');
+                if (serverin) serverin++;
+            }
+            if (serverin) {
                 /* Process success data */
                 serverinlen = strlen(serverin);
                 goto challenge;
@@ -318,7 +332,7 @@ static int login(struct backend *s, cons
                                 !((scheme->flags & AUTH_NEED_PERSIST) &&
                                   (resp_body.flags & BODY_CLOSE))) {
                                 /* Tag the scheme as available */
-                                avail_auth_schemes |= (1 << scheme->idx);
+                                avail_auth_schemes |= scheme->id;
 
                                 /* Add SASL-based schemes to SASL mech list */
                                 if (scheme->saslmech) {
@@ -370,11 +384,11 @@ static int login(struct backend *s, cons
                     }
                     else {
                         /* No matching SASL mechs - try Basic */
-                        scheme = &auth_schemes[AUTH_BASIC];
-                        if (!(avail_auth_schemes & (1 << scheme->idx))) {
+                        if (!(avail_auth_schemes & AUTH_BASIC)) {
                             need_tls = !tls_done;
                             break;  /* case 401 */
                         }
+                        scheme = &auth_scheme_basic;
                     }
 
                     /* Find the associated WWW-Authenticate header */
@@ -396,7 +410,7 @@ static int login(struct backend *s, cons
             if (serverin) {
                 /* Perform the next step in the auth exchange */
 
-                if (scheme->idx == AUTH_BASIC) {
+                if (scheme->id == AUTH_BASIC) {
                     /* Don't care about "realm" in server challenge */
                     const char *authid =
                         callback_getdata(s->saslconn, cb, SASL_CB_AUTHNAME);
@@ -409,6 +423,29 @@ static int login(struct backend *s, cons
                     auth_done = 1;
                 }
                 else {
+                    if (scheme->flags & AUTH_DATA_PARAM) {
+                        /* Parse parameters */
+                        const char *this_sid;
+                        unsigned int sid_len;
+
+                        r = http_parse_auth_params(serverin,
+                                                   NULL /* realm */, NULL,
+                                                   &this_sid, &sid_len,
+                                                   &serverin, &serverinlen);
+                        if ((r == SASL_OK) && this_sid) {
+                            if (!sid) sid = xstrndup(this_sid, sid_len);
+                            else if (sid_len != strlen(sid) ||
+                                     strncmp(this_sid, sid, sid_len)) {
+                                syslog(LOG_ERR,
+                                       "%s: Incorrect 'sid' parameter in challenge",
+                                       scheme->name);
+                                r = SASL_BADAUTH;
+                            }
+                        }
+
+                        if (r != SASL_OK) break;  /* case 401 */
+                    }
+
                     /* Base64 decode any server challenge, if necessary */
                     if (serverin && (scheme->flags & AUTH_BASE64)) {
                         r = sasl_decode64(serverin, serverinlen,
@@ -418,7 +455,7 @@ static int login(struct backend *s, cons
                         serverin = base64;
                     }
 
-                    /* SASL mech (Digest, Negotiate, NTLM) */
+                    /* SASL mech (SCRAM-*, Digest, Negotiate, NTLM) */
                     r = sasl_client_step(s->saslconn, serverin, serverinlen,
                                          NULL,          /* no prompts */
                                          &clientout, &clientoutlen);
@@ -431,6 +468,7 @@ static int login(struct backend *s, cons
     } while (need_tls || clientout);
 
   done:
+    free(sid);
     if (hdrs) spool_free_hdrcache(hdrs);
 
     if (r && status && !*status) *status = sasl_errstring(r, NULL, NULL);
@@ -449,7 +487,7 @@ static int ping(struct backend *s, const
     /* Send Authorization request to server */
     prot_puts(s->out, "OPTIONS * HTTP/1.1\r\n");
     prot_printf(s->out, "Host: %s\r\n", s->hostname);
-    prot_printf(s->out, "User-Agent: %s\r\n", buf_cstring(&serverinfo));
+    prot_printf(s->out, "User-Agent: Cyrus/%s\r\n", CYRUS_VERSION);
     prot_printf(s->out, "Authorize-As: %s\r\n", userid ? userid : "anonymous");
     prot_puts(s->out, "\r\n");
     prot_flush(s->out);
@@ -537,7 +575,7 @@ EXPORTED void http_proto_host(hdrcache_t
     else {
         /* Use our protocol and host */
         if (proto) *proto = https ? "https" : "http";
-        if (host) *host = *spool_getheader(req_hdrs, "Host");
+        if (host) *host = *spool_getheader(req_hdrs, ":authority");
     }
 }
 
@@ -549,19 +587,19 @@ static void write_forwarding_hdrs(struct
     const char **fwd = spool_getheader(hdrs, "Forwarded");
 
     /* Add any existing Via headers */
-    for (; via && *via; via++) simple_hdr(txn, "Via", *via);
+    for (; via && *via; via++) simple_hdr(txn, "Via", "%s", *via);
 
     /* Create our own Via header */
     simple_hdr(txn, "Via", (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) ?
                "%s %s (Cyrus/%s)" : "%s %s",
-               version+5, config_servername,cyrus_version());
+               version+5, config_servername, CYRUS_VERSION);
 
     /* Add any existing Forwarded headers */
-    for (; fwd && *fwd; fwd++) simple_hdr(txn, "Forwarded", *fwd);
+    for (; fwd && *fwd; fwd++) simple_hdr(txn, "Forwarded", "%s", *fwd);
 
     /* Create our own Forwarded header */
     if (proto) {
-        const char **host = spool_getheader(hdrs, "Host");
+        const char **host = spool_getheader(hdrs, ":authority");
         size_t len;
 
         assert(!buf_len(&txn->buf));
@@ -576,14 +614,15 @@ static void write_forwarding_hdrs(struct
             buf_printf(&txn->buf, ";for=%.*s", (int)len, httpd_localip);
         }
 
-        simple_hdr(txn, "Forwarded", buf_cstring(&txn->buf));
+        simple_hdr(txn, "Forwarded", "%s", buf_cstring(&txn->buf));
         buf_reset(&txn->buf);
     }
 }
 
 
 /* Write end-to-end header (ignoring hop-by-hop) from cache to protstream. */
-static void write_cachehdr(const char *name, const char *contents, void *rock)
+static void write_cachehdr(const char *name, const char *contents,
+                           const char *raw __attribute__((unused)), void *rock)
 {
     struct transaction_t *txn = (struct transaction_t *) rock;
     const char **hdr, *hop_by_hop[] =
@@ -594,7 +633,7 @@ static void write_cachehdr(const char *n
     /* Ignore private headers in our cache */
     if (name[0] == ':') return;
 
-    for (hdr = hop_by_hop; *hdr && strcmp(name, *hdr); hdr++);
+    for (hdr = hop_by_hop; *hdr && strcasecmp(name, *hdr); hdr++);
 
     if (!*hdr) {
         if (!strcmp(name, "max-forwards")) {
@@ -604,28 +643,12 @@ static void write_cachehdr(const char *n
             simple_hdr(txn, "Max-Forwards", "%lu", max-1);
         }
         else {
-            simple_hdr(txn, name, contents);
+            simple_hdr(txn, name, "%s", contents);
         }
     }
 }
 
 
-static long resp_code_to_http_err(unsigned code)
-{
-    int i, len, n_msgs = et_http_error_table.n_msgs;
-    const char * const *msgs = et_http_error_table.msgs;
-    char buf[100];
-
-    len = snprintf(buf, sizeof(buf), "%u ", code);
-
-    for (i = 0; i < n_msgs; i++) {
-        if (!strncmp(msgs[i], buf, len)) return et_http_error_table.base + i;
-    }
-
-    return HTTP_SERVER_ERROR;
-}
-
-
 /* Send a cached response to the client */
 static void send_response(struct transaction_t *txn, long code,
                           hdrcache_t hdrs, struct buf *body)
@@ -649,11 +672,7 @@ static void send_response(struct transac
         const char *conn_tokens[] =
             { "close", "Upgrade", "Keep-Alive", NULL };
         const char *upgrade_tokens[] =
-            { TLS_VERSION,
-#ifdef HAVE_NGHTTP2
-              NGHTTP2_CLEARTEXT_PROTO_VERSION_ID,
-#endif
-              NULL };
+            { TLS_VERSION, NGHTTP2_CLEARTEXT_PROTO_VERSION_ID, NULL };
 
         comma_list_hdr(txn, "Connection", conn_tokens, txn->flags.conn);
 
@@ -666,7 +685,7 @@ static void send_response(struct transac
         }
     }
 
-    if (httpd_tls_done) {
+    if (txn->conn->tls_ctx) {
         simple_hdr(txn, "Strict-Transport-Security", "max-age=600");
     }
 
@@ -680,11 +699,11 @@ static void send_response(struct transac
             txn->flags.te = TE_CHUNKED;
 
             if (txn->flags.ver == VER_1_1) {
-                simple_hdr(txn, "Transfer-Encoding", hdr[0]);
+                simple_hdr(txn, "Transfer-Encoding", "%s", hdr[0]);
             }
             if ((hdr = spool_getheader(hdrs, "Trailer"))) {
                 txn->flags.trailer = TRAILER_PROXY;
-                simple_hdr(txn, "Trailer", hdr[0]);
+                simple_hdr(txn, "Trailer", "%s", hdr[0]);
             }
         }
         else if ((hdr = spool_getheader(hdrs, "Content-Length"))) {
@@ -692,7 +711,7 @@ static void send_response(struct transac
                 /* Prevent end of stream */
                 txn->flags.te = TE_CHUNKED;
             }
-            else simple_hdr(txn, "Content-Length", hdr[0]);
+            else simple_hdr(txn, "Content-Length", "%s", hdr[0]);
         }
 
         end_resp_headers(txn, code);
@@ -733,7 +752,8 @@ static int pipe_resp_body(struct protstr
     char buf[PROT_BUFSIZE];
     const char **errstr = &txn->error.desc;
 
-    txn->resp_body.enc = CE_IDENTITY;
+    txn->resp_body.enc.type = CE_IDENTITY;
+    txn->resp_body.enc.proc = NULL;
     txn->flags.te = TE_NONE;
 
     if (resp_body->framing == FRAMING_UNKNOWN) {
@@ -861,7 +881,7 @@ EXPORTED int http_pipe_req_resp(struct b
      *
      * - Piece the Request Line back together
      * - Add/append-to Via: header
-     * - Add Expect:100-continue header (for synchonicity)
+     * - Add Expect:100-continue header (for synchronicity)
      * - Use all cached end-to-end headers from client
      * - Body will be sent using "chunked" TE, since we might not have it yet
      */
@@ -898,15 +918,14 @@ EXPORTED int http_pipe_req_resp(struct b
                                &resp_hdrs, NULL, &txn->error.desc);
         if (r) break;
 
-        http_err = resp_code_to_http_err(code);
+        http_err = http_status_to_code(code);
 
         if (code == 100) { /* Continue */
             if (!sent_body++) {
                 unsigned len;
 
                 /* Read body from client */
-                r = http_read_body(httpd_in, httpd_out, txn->req_hdrs,
-                                   &txn->req_body, &txn->error.desc);
+                r = http_read_req_body(txn);
                 if (r) {
                     /* Couldn't get the body and can't finish request */
                     txn->flags.conn = CONN_CLOSE;
@@ -935,8 +954,7 @@ EXPORTED int http_pipe_req_resp(struct b
         /* Don't pipe a 401 response (discard body).
            Frontend should send its own 401 since it will process auth */
         resp_body.flags |= BODY_DISCARD;
-        http_read_body(be->in, httpd_out,
-                       resp_hdrs, &resp_body, &txn->error.desc);
+        http_read_body(be->in, resp_hdrs, &resp_body, &txn->error.desc);
 
         r = HTTP_UNAUTHORIZED;
     }
@@ -1004,9 +1022,9 @@ EXPORTED int http_proxy_copy(struct back
          */
         prot_printf(src_be->out, "LOCK %s %s\r\n"
                                  "Host: %s\r\n"
-                                 "User-Agent: %s\r\n",
+                                 "User-Agent: Cyrus/%s\r\n",
                     txn->req_tgt.path, HTTP_VERSION,
-                    src_be->hostname, buf_cstring(&serverinfo));
+                    src_be->hostname, CYRUS_VERSION);
         write_hdr(src_be->out, "If", txn->req_hdrs);
         write_hdr(src_be->out, "If-Match", txn->req_hdrs);
         write_hdr(src_be->out, "If-Unmodified-Since", txn->req_hdrs);
@@ -1064,7 +1082,7 @@ EXPORTED int http_proxy_copy(struct back
 
         default:
             /* Send failure response to client */
-            http_err = resp_code_to_http_err(code);
+            http_err = http_status_to_code(code);
             send_response(txn, http_err, resp_hdrs, &resp_body.payload);
             goto done;
         }
@@ -1079,9 +1097,9 @@ EXPORTED int http_proxy_copy(struct back
      */
     prot_printf(src_be->out, "GET %s %s\r\n"
                              "Host: %s\r\n"
-                             "User-Agent: %s\r\n",
+                             "User-Agent: Cyrus/%s\r\n",
                 txn->req_tgt.path, HTTP_VERSION,
-                src_be->hostname, buf_cstring(&serverinfo));
+                src_be->hostname, CYRUS_VERSION);
     if (txn->meth != METH_MOVE) {
         write_hdr(src_be->out, "If", txn->req_hdrs);
         write_hdr(src_be->out, "If-Match", txn->req_hdrs);
@@ -1105,16 +1123,16 @@ EXPORTED int http_proxy_copy(struct back
 
     if (code != 200) {
         /* Send failure response to client */
-        http_err = resp_code_to_http_err(code);
+        http_err = http_status_to_code(code);
         send_response(txn, http_err, resp_hdrs, &resp_body.payload);
         goto done;
     }
 
 
     /*
-     * Send a synchonizing PUT request to dest backend:
+     * Send a synchronizing PUT request to dest backend:
      *
-     * - Add Expect:100-continue header (for synchonicity)
+     * - Add Expect:100-continue header (for synchronicity)
      * - Obey Overwrite by adding If-None-Match header
      * - Use any TE, Prefer, Accept* headers specified by client
      * - Use Content-Type, -Encoding, -Language headers from GET response
@@ -1122,10 +1140,10 @@ EXPORTED int http_proxy_copy(struct back
      */
     prot_printf(dest_be->out, "PUT %s %s\r\n"
                               "Host: %s\r\n"
-                              "User-Agent: %s\r\n"
+                              "User-Agent: Cyrus/%s\r\n"
                               "Expect: 100-continue\r\n",
                 *spool_getheader(txn->req_hdrs, "Destination"), HTTP_VERSION,
-                dest_be->hostname, buf_cstring(&serverinfo));
+                dest_be->hostname, CYRUS_VERSION);
     hdr = spool_getheader(txn->req_hdrs, "Overwrite");
     if (hdr && !strcmp(*hdr, "F"))
         prot_puts(dest_be->out, "If-None-Match: *\r\n");
@@ -1161,7 +1179,7 @@ EXPORTED int http_proxy_copy(struct back
     } while (code < 200);
 
     /* Send response to client */
-    http_err = resp_code_to_http_err(code);
+    http_err = http_status_to_code(code);
     send_response(txn, http_err, resp_hdrs, NULL);
     if (code != 204) {
         resp_body.framing = FRAMING_UNKNOWN;
@@ -1183,9 +1201,9 @@ EXPORTED int http_proxy_copy(struct back
          */
         prot_printf(src_be->out, "DELETE %s %s\r\n"
                                  "Host: %s\r\n"
-                                 "User-Agent: %s\r\n",
+                                 "User-Agent: Cyrus/%s\r\n",
                     txn->req_tgt.path, HTTP_VERSION,
-                    src_be->hostname, buf_cstring(&serverinfo));
+                    src_be->hostname, CYRUS_VERSION);
         if (lock) prot_printf(src_be->out, "If: (%s)\r\n", lock);
         prot_puts(src_be->out, "\r\n");
         prot_flush(src_be->out);
@@ -1216,10 +1234,10 @@ EXPORTED int http_proxy_copy(struct back
          */
         prot_printf(src_be->out, "UNLOCK %s %s\r\n"
                                  "Host: %s\r\n"
-                                 "User-Agent: %s\r\n"
+                                 "User-Agent: Cyrus/%s\r\n"
                                  "Lock-Token: %s\r\n\r\n",
                     txn->req_tgt.path, HTTP_VERSION,
-                    src_be->hostname, buf_cstring(&serverinfo), lock);
+                    src_be->hostname, CYRUS_VERSION, lock);
         prot_flush(src_be->out);
 
         /* Read response(s) from source backend until final resp or error */
diff -pruN 3.0.13-5/imap/http_proxy.h 3.2.0-3/imap/http_proxy.h
--- 3.0.13-5/imap/http_proxy.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_proxy.h	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 #define _HTTP_PROXY_H
 
 #include "backend.h"
+#include "http_h2.h"
 
 
 extern struct protocol_t http_protocol;
@@ -55,5 +56,6 @@ extern void http_proto_host(hdrcache_t r
 extern int http_pipe_req_resp(struct backend *be, struct transaction_t *txn);
 extern int http_proxy_copy(struct backend *src_be, struct backend *dest_be,
                            struct transaction_t *txn);
+extern long http_status_to_code(unsigned code);
 
 #endif /* _HTTP_PROXY_H */
diff -pruN 3.0.13-5/imap/http_rss.c 3.2.0-3/imap/http_rss.c
--- 3.0.13-5/imap/http_rss.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_rss.c	2020-04-24 02:03:00.000000000 +0000
@@ -108,7 +108,7 @@ static struct body *body_fetch_section(s
 
 /* Namespace for RSS feeds of mailboxes */
 struct namespace_t namespace_rss = {
-    URL_NS_RSS, 0, "/rss", NULL,
+    URL_NS_RSS, 0, "rss", "/rss", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -116,6 +116,7 @@ struct namespace_t namespace_rss = {
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get,            NULL },                 /* GET          */
@@ -323,7 +324,7 @@ static int meth_get(struct transaction_t
 
 /* Create a mailbox name from the request URL */
 static int rss_parse_path(const char *path, struct request_target_t *tgt,
-                          const char **errstr)
+                          const char **resultstr)
 {
     const char *start, *end;
     char mboxname[MAX_MAILBOX_BUFFER+1];
@@ -365,7 +366,7 @@ static int rss_parse_path(const char *pa
         if (r) {
             syslog(LOG_ERR, "mlookup(%s) failed: %s",
                    mboxname, error_message(r));
-            *errstr = error_message(r);
+            *resultstr = error_message(r);
 
             switch (r) {
             case IMAP_PERMISSION_DENIED: return HTTP_FORBIDDEN;
@@ -480,7 +481,7 @@ static int do_list(const char *name, voi
         else href = path;
 
         /* Populate new/updated node */
-        strncpy(node->name, name, len);
+        xstrncpy(node->name, name, len);
         node->name[len] = '\0';
         node->len = len;
         node->parent = last;
@@ -536,7 +537,7 @@ static int do_list(const char *name, voi
 
 static int list_cb(struct findall_data *data, void *rock)
 {
-    if (data && data->mbname)
+    if (data && data->is_exactmatch)
         return do_list(mbname_intname(data->mbname), rock);
     return do_list(NULL, rock);
 }
@@ -697,7 +698,8 @@ static int fetch_message(struct transact
     record->uid = uid;
     r = mailbox_reload_index_record(mailbox, record);
     if ((r == CYRUSDB_NOTFOUND) ||
-        (record->system_flags & (FLAG_DELETED|FLAG_EXPUNGED))) {
+        ((record->system_flags & FLAG_DELETED) ||
+         record->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
         txn->error.desc = "Message has been removed\r\n";
 
         /* Fill in Expires */
@@ -841,8 +843,8 @@ static int list_messages(struct transact
     }
 
     /* Get maximum age of items to display */
-    max_age = config_getint(IMAPOPT_RSS_MAXAGE);
-    if (max_age > 0) age_mark = time(0) - (max_age * 60 * 60 * 24);
+    max_age = config_getduration(IMAPOPT_RSS_MAXAGE, 'd');
+    if (max_age > 0) age_mark = time(0) - max_age;
 
     /* Get number of items to display */
     max_items = config_getint(IMAPOPT_RSS_MAXITEMS);
@@ -915,9 +917,9 @@ static int list_messages(struct transact
     buf_printf_markup(buf, --level, "</author>");
 
     /* <subtitle> - optional */
-    annotatemore_lookup(mailbox->name, "/comment", NULL, &attrib);
+    annotatemore_lookup(mailbox->name, "/comment", "", &attrib);
     if (age_mark) {
-        time_to_rfc822(age_mark, datestr, sizeof(datestr));
+        time_to_rfc5322(age_mark, datestr, sizeof(datestr));
         buf_printf_markup(buf, level,
                         "<subtitle>%s [posts since %s]</subtitle>",
                           buf_cstring(&attrib), datestr);
@@ -938,7 +940,7 @@ static int list_messages(struct transact
     /* <generator> - optional */
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
         buf_printf_markup(buf, level, "<generator>Cyrus HTTP %s</generator>",
-                          cyrus_version());
+                          CYRUS_VERSION);
     }
 
     write_body(HTTP_OK, txn, buf_cstring(buf), buf_len(buf));
diff -pruN 3.0.13-5/imap/http_tzdist.c 3.2.0-3/imap/http_tzdist.c
--- 3.0.13-5/imap/http_tzdist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_tzdist.c	2020-04-24 02:03:00.000000000 +0000
@@ -85,6 +85,7 @@ static time_t compile_time;
 static unsigned synctoken_prefix;
 static ptrarray_t *leap_seconds = NULL;
 static int geo_enabled = 0;
+static const char *zoneinfo_dir = NULL;
 static void tzdist_init(struct buf *serverinfo);
 static void tzdist_shutdown(void);
 static int meth_get(struct transaction_t *txn, void *params);
@@ -97,8 +98,10 @@ static int json_response(int code, struc
                          char **resp);
 static int json_error_response(struct transaction_t *txn, long tz_code,
                                struct strlist *param, icaltimetype *time);
-static struct buf *icaltimezone_as_tzfile(icalcomponent* comp);
-static struct buf *icaltimezone_as_tzfile_leap(icalcomponent* comp);
+static struct buf *icaltimezone_as_tzif(icalcomponent* comp);
+static struct buf *icaltimezone_as_tzif_leap(icalcomponent* comp);
+static struct buf *_icaltimezone_as_tzif(icalcomponent* ical, bit32 leapcnt,
+                                         icaltimetype *startp, icaltimetype *endp);
 
 struct observance {
     const char *name;
@@ -124,12 +127,12 @@ static struct mime_type_t tz_mime_types[
       (struct buf* (*)(void *)) &icalcomponent_as_jcal_string,
       NULL, NULL, NULL, NULL
     },
-    { "application/tzfile", NULL, "tz",
-      (struct buf* (*)(void *)) &icaltimezone_as_tzfile,
+    { "application/tzif", NULL, NULL,
+      (struct buf* (*)(void *)) &icaltimezone_as_tzif,
       NULL, NULL, NULL, NULL
     },
-    { "application/tzfile+leap", NULL, "tz",
-      (struct buf* (*)(void *)) &icaltimezone_as_tzfile_leap,
+    { "application/tzif-leap", NULL, NULL,
+      (struct buf* (*)(void *)) &icaltimezone_as_tzif_leap,
       NULL, NULL, NULL, NULL
     },
     { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
@@ -138,7 +141,7 @@ static struct mime_type_t tz_mime_types[
 
 /* Namespace for tzdist service */
 struct namespace_t namespace_tzdist = {
-    URL_NS_TZDIST, 0, "/tzdist", TZDIST_WELLKNOWN_URI,
+    URL_NS_TZDIST, 0, "tzdist", "/tzdist", TZDIST_WELLKNOWN_URI,
     http_allow_noauth, /*authschemes*/0,
     /*mbtype*/0,
     ALLOW_READ,
@@ -146,6 +149,7 @@ struct namespace_t namespace_tzdist = {
     {
         { NULL,                 NULL },                 /* ACL          */
         { NULL,                 NULL },                 /* BIND         */
+        { NULL,                 NULL },                 /* CONNECT      */
         { NULL,                 NULL },                 /* COPY         */
         { NULL,                 NULL },                 /* DELETE       */
         { &meth_get,            NULL },                 /* GET          */
@@ -190,8 +194,7 @@ static void open_shape_file(struct buf *
     buf_printf(serverinfo, " ShapeLib/%s", SHAPELIB_VERSION);
 
     /* Open the tz_world shape files */
-    snprintf(buf, sizeof(buf), "%s%s%s",
-             config_dir, FNAME_ZONEINFODIR, FNAME_WORLD_SHAPEFILE);
+    snprintf(buf, sizeof(buf), "%s%s", zoneinfo_dir, FNAME_WORLD_SHAPEFILE);
     if (!(tz_world.shp = SHPOpen(buf, "rb"))) {
         syslog(LOG_ERR, "Failed to open file %s", buf);
         return;
@@ -221,8 +224,7 @@ static void open_shape_file(struct buf *
     geo_enabled = tz_world.valid = 1;
 
     /* Open the tz_antarctica shape files (optional) */
-    snprintf(buf, sizeof(buf), "%s%s%s",
-             config_dir, FNAME_ZONEINFODIR, FNAME_AQ_SHAPEFILE);
+    snprintf(buf, sizeof(buf), "%s%s", zoneinfo_dir, FNAME_AQ_SHAPEFILE);
     if (!(tz_aq.shp = SHPOpen(buf, "rb"))) {
         syslog(LOG_NOTICE, "Failed to open file %s", buf);
         return;
@@ -469,7 +471,7 @@ static strarray_t *tzid_from_geo(struct
 
     if (!strarray_size(tzids)) {
         /* No tzids found in shapefile(s) */
-        char tzid_buf[19];
+        char tzid_buf[20];
 
         if (latitude <= -60) {
             /* Antarctic region - guess-timate offset from GMT based on:
@@ -492,21 +494,21 @@ static strarray_t *tzid_from_geo(struct
                 /* Uninhabited */
                 tzid = "Etc/GMT";
             }
-            else if (longitude >= 142.033333) {     /* 142*  2' */
+            else if (longitude >= 142.033333) {     /* 142° 2' */
                 /* Australian Claim (George V / Oates Lands) */
                 tzid = "Etc/GMT+10";
             }
-            else if (longitude >= 136.183333) {     /* 136* 11' */
+            else if (longitude >= 136.183333) {     /* 136° 11' */
                 /* French Claim (Adelie Land) */
                 tzid = "Etc/GMT+10";
             }
-            else if (longitude >= 44.633333) {      /*  44* 38' */
+            else if (longitude >= 44.633333) {      /*  44° 38' */
                 /* Australian Claim */
-                if (longitude >= 100.5) {           /* 100* 30' */
+                if (longitude >= 100.5) {           /* 100° 30' */
                     /* Wilkes Land */
                     tzid = "Etc/GMT+8";
                 }
-                else if (longitude >= 72.583333) {  /*  72* 35' */
+                else if (longitude >= 72.583333) {  /*  72° 35' */
                     /* Princess Elizabeth / Kaiser Wilhelm II / Queen Mary Lands */
                     tzid = "Etc/GMT+7";
                 }
@@ -554,8 +556,8 @@ static strarray_t *tzid_from_geo(struct
                XXX  Which offset does an exact multiple of +/- 7.5
                and +/- 180 degrees belong to?
             */
-            sprintf(tzid_buf, "Etc/GMT%+d",
-                    (int) (longitude + copysign(1.0, longitude) * 7.5) / 15);
+            snprintf(tzid_buf, sizeof(tzid_buf), "Etc/GMT%+d",
+                    (short) (longitude + copysign(1.0, longitude) * 7.5) / 15);
             tzid = tzid_buf;
         }
 
@@ -592,14 +594,13 @@ struct leapsec {
     long int sec;         /* leap seconds */
 };
 
-void read_leap_seconds()
+static void read_leap_seconds()
 {
     FILE *fp;
     char buf[1024];
     struct leapsec *leap;
 
-    snprintf(buf, sizeof(buf), "%s%s%s",
-             config_dir, FNAME_ZONEINFODIR, FNAME_LEAPSECFILE);
+    snprintf(buf, sizeof(buf), "%s%s", zoneinfo_dir, FNAME_LEAPSECFILE);
     if (!(fp = fopen(buf, "r"))) {
         syslog(LOG_ERR, "Failed to open file %s", buf);
         return;
@@ -648,6 +649,14 @@ static void tzdist_init(struct buf *serv
         return;
     }
 
+    /* Find configured zoneinfo_zir */
+    zoneinfo_dir = config_getstring(IMAPOPT_ZONEINFO_DIR);
+    if (!zoneinfo_dir) {
+        syslog(LOG_ERR, "zoneinfo_dir must be set for tzdist service");
+        namespace_tzdist.enabled = 0;
+        return;
+    }
+
     compile_time = calc_compile_time(__TIME__, __DATE__);
 
     buf_printf(&buf, "Cyrus TZdist: %s", config_servername);
@@ -660,11 +669,11 @@ static void tzdist_init(struct buf *serv
 
     read_leap_seconds();
     if (!leap_seconds || leap_seconds->count < 2) {
-        /* Disable application/tzfile+leap */
+        /* Disable application/tzif-leap */
         struct mime_type_t *mime;
 
         for (mime = tz_mime_types; mime->content_type; mime++) {
-            if (!strcmp(mime->content_type, "application/tzfile+leap")) {
+            if (!strcmp(mime->content_type, "application/tzif-leap")) {
                 mime->content_type = NULL;
                 break;
             }
@@ -900,6 +909,7 @@ static int action_capa(struct transactio
             buf_truncate(&txn->buf, strcspn(mime->content_type, ";"));
             json_array_append_new(formats, json_string(buf_cstring(&txn->buf)));
         }
+        buf_reset(&txn->buf);
 
         /* Update lastmod */
         lastmod = txn->resp_body.lastmod;
@@ -1278,7 +1288,8 @@ static void truncate_vtimezone(icalcompo
                                struct observance **proleptic,
                                icalcomponent **eternal_std,
                                icalcomponent **eternal_dst,
-                               icaltimetype *last_dtstart)
+                               icaltimetype *last_dtstart,
+                               int ms_compatible)
 {
     icaltimetype start = *startp, end = *endp;
     icalcomponent *comp, *nextc, *tomb_std = NULL, *tomb_day = NULL;
@@ -1457,6 +1468,9 @@ static void truncate_vtimezone(icalcompo
                 if (trunc_dtstart) {
                     /* Bump RRULE start to 1 year prior to our window open */
                     dtstart.year = start.year - 1;
+                    dtstart.month = start.month;
+                    dtstart.day = start.day;
+                    icaltime_normalize(dtstart);
                 }
 
                 ritr = icalrecur_iterator_new(rrule, dtstart);
@@ -1500,7 +1514,7 @@ static void truncate_vtimezone(icalcompo
                                 icalcomponent_add_property(comp, prop);
                             }
                         }
-                        else {
+                        else if (!eternal) {
                             /* Set UNTIL to previous onset */
                             rrule.until = prev_onset;
                             icalproperty_set_rrule(rrule_prop, rrule);
@@ -1515,6 +1529,19 @@ static void truncate_vtimezone(icalcompo
                     if (r < 0) {
                         /* Observance is prior to our window open -
                            check it vs tombstone */
+                        if (ms_compatible) {
+                            /* XXX  We don't want to move DTSTART of the RRULE
+                               as Outlook/Exchange doesn't appear to like
+                               truncating the frontend of RRULEs */
+                            need_tomb = 0;
+                            trunc_dtstart = 0;
+                            if (proleptic_prop) {
+                                icalcomponent_remove_property(vtz,
+                                                              proleptic_prop);
+                                icalproperty_free(proleptic_prop);
+                                proleptic_prop = NULL;
+                            }
+                        }
                         if (need_tomb) check_tombstone(&tombstone, &obs);
                     }
                     else {
@@ -1527,6 +1554,11 @@ static void truncate_vtimezone(icalcompo
                             dtstart = obs.onset;
                             trunc_dtstart = 0;
 
+                            if (last_dtstart &&
+                                icaltime_compare(dtstart, *last_dtstart) > 0) {
+                                *last_dtstart = dtstart;
+                            }
+
                             /* Check if new DSTART is within 1yr of UNTIL */
                             ydiff = rrule.until.year - recur.year;
                             if (!trunc_until && ydiff <= 1) {
@@ -1659,6 +1691,7 @@ static void truncate_vtimezone(icalcompo
         if (obsarray) {
             /* Add the tombstone to our array */
             tombstone.onset = start;
+            tombstone.is_gmt = tombstone.is_std = 1;
             icalarray_append(obsarray, &tombstone);
         }
 
@@ -1834,13 +1867,12 @@ static int action_get(struct transaction
         size_t msg_size = 0;
         icalcomponent *ical, *vtz;
         icalproperty *prop;
-        struct buf *buf;
+        struct buf *buf = NULL;
         int fd;
 
         /* Open, mmap, and parse the file */
         buf_reset(&pathbuf);
-        buf_printf(&pathbuf, "%s%s/%s.ics",
-                   config_dir, FNAME_ZONEINFODIR, tzid);
+        buf_printf(&pathbuf, "%s/%s.ics", zoneinfo_dir, tzid);
         path = buf_cstring(&pathbuf);
         if ((fd = open(path, O_RDONLY)) == -1) return HTTP_SERVER_ERROR;
 
@@ -1854,7 +1886,8 @@ static int action_get(struct transaction
         vtz = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
         prop = icalcomponent_get_first_property(vtz, ICAL_TZID_PROPERTY);
 
-        if (zi.type == ZI_LINK) {
+        if ((zi.type == ZI_LINK) &&
+            !icalcomponent_get_first_property(vtz, ICAL_TZIDALIASOF_PROPERTY)) {
             /* Add TZID-ALIAS-OF */
             const char *aliasof = icalproperty_get_tzid(prop);
             icalproperty *atzid = icalproperty_new_tzidaliasof(aliasof);
@@ -1896,8 +1929,20 @@ static int action_get(struct transaction
             /* Add truncation parameter(s) to TZURL */
             buf_printf(&pathbuf, "?%s", URI_QUERY(txn->req_uri));
 
-            /* Truncate the VTIMEZONE */
-            truncate_vtimezone(vtz, &start, &end, NULL, NULL, NULL, NULL, NULL);
+            if (!strncmp(mime->content_type, "application/tzif", 16)) {
+                /* Truncate and convert the VTIMEZONE */
+                bit32 leapcnt = 0;
+
+                if (!strcmp(mime->content_type + 16, "-leap"))
+                    leapcnt = leap_seconds->count - 2;
+
+                buf =_icaltimezone_as_tzif(ical, leapcnt, &start, &end);
+            }
+            else {
+                /* Truncate the VTIMEZONE */
+                truncate_vtimezone(vtz, &start, &end, NULL, NULL,
+                                   NULL, NULL, NULL, 0);
+            }
         }
 
         /* Set TZURL property */
@@ -1905,15 +1950,15 @@ static int action_get(struct transaction
         icalcomponent_add_property(vtz, prop);
 
         /* Convert to requested MIME type */
-        buf = mime->from_object(ical);
+        if (!buf) buf = mime->from_object(ical);
         datalen = buf_len(buf);
         data = buf_release(buf);
         buf_destroy(buf);
 
         /* Set Content-Disposition filename */
-        buf_reset(&pathbuf);
-        buf_printf(&pathbuf, "%s.%s", tzid, mime->file_ext);
-        resp_body->fname = buf_cstring(&pathbuf);
+        buf_setcstr(&pathbuf, tzid);
+        if (mime->file_ext) buf_printf(&pathbuf, ".%s", mime->file_ext);
+        resp_body->dispo.fname = buf_cstring(&pathbuf);
 
         txn->flags.vary |= VARY_ACCEPT;
 
@@ -1928,13 +1973,9 @@ static int action_get(struct transaction
 }
 
 
-static const char *dow[] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
-static const char *mon[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                             "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-
 #define CTIME_FMT "%s %s %2d %02d:%02d:%02d %4d"
 #define CTIME_ARGS(tt) \
-    dow[icaltime_day_of_week(tt)-1], mon[tt.month-1], \
+    wday[icaltime_day_of_week(tt)-1], monthname[tt.month-1], \
     tt.day, tt.hour, tt.minute, tt.second, tt.year
 
 
@@ -1972,7 +2013,7 @@ static int action_expand(struct transact
     /* Check requested format (debugging only) */
     if ((param = hash_lookup("format", &txn->req_qparams)) &&
         !strcmp(param->s, "application/zdump")) {
-        /* Mimic zdump(8) -V output for comparision:
+        /* Mimic zdump(8) -V output for comparison:
 
            For each zonename, print the times both one  second  before  and
            exactly at each detected time discontinuity, the time at one day
@@ -2039,8 +2080,7 @@ static int action_expand(struct transact
 
         /* Open, mmap, and parse the file */
         buf_reset(&pathbuf);
-        buf_printf(&pathbuf, "%s%s/%s.ics",
-                   config_dir, FNAME_ZONEINFODIR, tzid);
+        buf_printf(&pathbuf, "%s/%s.ics", zoneinfo_dir, tzid);
         path = buf_cstring(&pathbuf);
         if ((fd = open(path, O_RDONLY)) == -1) return HTTP_SERVER_ERROR;
 
@@ -2056,7 +2096,7 @@ static int action_expand(struct transact
         obsarray = icalarray_new(sizeof(struct observance), 20);
         vtz = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
         truncate_vtimezone(vtz, &start, &end, obsarray, &proleptic,
-                           NULL, NULL, NULL);
+                           NULL, NULL, NULL, 0);
 
         if (zdump) {
             struct buf *body = &txn->resp_body.payload;
@@ -2157,12 +2197,15 @@ static int json_response(int code, struc
                          char **resp)
 {
     size_t flags = JSON_PRESERVE_ORDER;
-    char *buf = NULL;
+    static char *buf = NULL;  /* keep generated data until next call */
+    char *json = NULL;
+
+    free(buf);
 
     if (root) {
         /* Dump JSON object into a text buffer */
         flags |= (config_httpprettytelemetry ? JSON_INDENT(2) : JSON_COMPACT);
-        buf = json_dumps(root, flags);
+        json = buf = json_dumps(root, flags);
         json_decref(root);
 
         if (!buf) {
@@ -2172,18 +2215,17 @@ static int json_response(int code, struc
         else if (resp) {
             if (*resp) free(*resp);
             *resp = buf;
+            buf = NULL;
         }
     }
-    else if (resp) buf = *resp;
+    else if (resp) json = *resp;
 
     /* Output the JSON object */
     if (code == HTTP_OK)
         txn->resp_body.type = "application/json; charset=utf-8";
     else
         txn->resp_body.type = "application/problem+json; charset=utf-8";
-    write_body(code, txn, buf, buf ? strlen(buf) : 0);
-
-    if (!resp && buf) free(buf);
+    write_body(code, txn, json, json ? strlen(json) : 0);
 
     return 0;
 }
@@ -2418,9 +2460,9 @@ static unsigned buf_append_rrule_as_posi
     return ver;
 }
 
-/* Convert VTIMEZONE into tzfile(5) format */
-static struct buf *_icaltimezone_as_tzfile(icalcomponent* ical,
-                                     bit32 leapcnt)
+/* Convert VTIMEZONE into tzif format (draft-murchison-tzdist-tzif) */
+static struct buf *_icaltimezone_as_tzif(icalcomponent* ical, bit32 leapcnt,
+                                         icaltimetype *startp, icaltimetype *endp)
 {
     icalcomponent *vtz, *eternal_std = NULL, *eternal_dst = NULL;
     icalarray *obsarray;
@@ -2440,27 +2482,29 @@ static struct buf *_icaltimezone_as_tzfi
         unsigned char idx;    /* index into 'types' array */
     } *times = NULL;
     struct ttinfo types[256]; /* only indexed by unsigned char */
-    struct buf *tzfile, posix = BUF_INITIALIZER, abbrev = BUF_INITIALIZER;
+    struct buf *tzif, posix = BUF_INITIALIZER, abbrev = BUF_INITIALIZER;
     struct observance *obs;
     unsigned do_bit64;
     struct leapsec *leap = NULL;
     bit32 leap_init = 0, leap_sec = 0;
 
-    tzfile = buf_new();
-    buf_init(tzfile);
+    tzif = buf_new();
 
     vtz = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
-    if (!vtz) return tzfile;
+    if (!vtz) return tzif;
 
     if (leapcnt) {
         leap = ptrarray_nth(leap_seconds, 1);
         leap_init = leap->sec;
     }
 
+    if (!startp) startp = &start;
+    if (!endp || icaltime_is_null_time(*endp)) endp = &end;
+
     /* Create an array of observances */
     obsarray = icalarray_new(sizeof(struct observance), 100);
-    truncate_vtimezone(vtz, &start, &end, obsarray,
-                       &proleptic, &eternal_std, &eternal_dst, &last_dtstart);
+    truncate_vtimezone(vtz, startp, endp, obsarray,
+                       &proleptic, &eternal_std, &eternal_dst, &last_dtstart, 0);
 
     /* Create an array of transitions */
     times = xmalloc((obsarray->num_elements+1) * sizeof(struct transition));
@@ -2480,7 +2524,7 @@ static struct buf *_icaltimezone_as_tzfi
         }
     }
 
-    /* Add two tzfile datasets:
+    /* Add two tzif datasets:
        The first using 32-bit times and the second using 64-bit times. */
     for (do_bit64 = 0; do_bit64 <= 1; do_bit64++) {
         long long int epoch = do_bit64 ? BIG_BANG : INT32_MIN;
@@ -2591,32 +2635,32 @@ static struct buf *_icaltimezone_as_tzfi
         /* Output dataset */
 
         /* Header */
-        buf_appendmap(tzfile, header, sizeof(header));
-        buf_appendbit32(tzfile, typecnt);           /* isgmtcnt */
-        buf_appendbit32(tzfile, typecnt);           /* isstdcnt */
-        buf_appendbit32(tzfile, leapcnt);           /* leapcnt */
-        buf_appendbit32(tzfile, timecnt);           /* timecnt */
-        buf_appendbit32(tzfile, typecnt);           /* typecnt */
-        buf_appendbit32(tzfile, buf_len(&abbrev));  /* charcnt */
+        buf_appendmap(tzif, header, sizeof(header));
+        buf_appendbit32(tzif, typecnt);           /* isgmtcnt */
+        buf_appendbit32(tzif, typecnt);           /* isstdcnt */
+        buf_appendbit32(tzif, leapcnt);           /* leapcnt */
+        buf_appendbit32(tzif, timecnt);           /* timecnt */
+        buf_appendbit32(tzif, typecnt);           /* typecnt */
+        buf_appendbit32(tzif, buf_len(&abbrev));  /* charcnt */
 
         /* Transition times */
         for (n = 0; n < timecnt; n++) {
-            if (do_bit64) buf_appendbit64(tzfile, times[n].t);
-            else buf_appendbit32(tzfile, times[n].t);
+            if (do_bit64) buf_appendbit64(tzif, times[n].t);
+            else buf_appendbit32(tzif, times[n].t);
         }
 
         /* Transition time indices */
-        for (n = 0; n < timecnt; n++) buf_putc(tzfile, times[n].idx);
+        for (n = 0; n < timecnt; n++) buf_putc(tzif, times[n].idx);
 
         /* Types structures */
         for (n = 0; n < typecnt; n++) {
-            buf_appendbit32(tzfile, types[n].offset);
-            buf_putc(tzfile, types[n].isdst);
-            buf_putc(tzfile, types[n].idx);
+            buf_appendbit32(tzif, types[n].offset);
+            buf_putc(tzif, types[n].isdst);
+            buf_putc(tzif, types[n].idx);
         }
 
         /* Abbreviation array */
-        buf_append(tzfile, &abbrev);
+        buf_append(tzif, &abbrev);
 
         /* Leap second records */
         if (leapcnt) {
@@ -2627,19 +2671,19 @@ static struct buf *_icaltimezone_as_tzfi
 
                 leap = ptrarray_nth(leap_seconds, leapidx);
                 t = leap->t + leap_sec;
-                if (do_bit64) buf_appendbit64(tzfile, t);
-                else buf_appendbit32(tzfile, t);
+                if (do_bit64) buf_appendbit64(tzif, t);
+                else buf_appendbit32(tzif, t);
 
                 leap_sec = leap->sec - leap_init;
-                buf_appendbit32(tzfile, leap_sec);
+                buf_appendbit32(tzif, leap_sec);
             }
         }
 
         /* Standard/wall indicators */
-        for (n = 0; n < typecnt; n++) buf_putc(tzfile, types[n].isstd);
+        for (n = 0; n < typecnt; n++) buf_putc(tzif, types[n].isstd);
 
         /* GMT/local indicators */
-        for (n = 0; n < typecnt; n++) buf_putc(tzfile, types[n].isgmt);
+        for (n = 0; n < typecnt; n++) buf_putc(tzif, types[n].isgmt);
     }
 
     free(times);
@@ -2647,7 +2691,7 @@ static struct buf *_icaltimezone_as_tzfi
 
 
     /* POSIX timezone string */
-    buf_putc(tzfile, '\n');
+    buf_putc(tzif, '\n');
 
     /* std offset [dst [offset] [,rule] ] */
     if (buf_len(&posix)) {
@@ -2658,29 +2702,29 @@ static struct buf *_icaltimezone_as_tzfi
         /* std name */
         prop = icalcomponent_get_first_property(eternal_std,
                                                 ICAL_TZNAME_PROPERTY);
-        buf_appendcstr(tzfile, icalproperty_get_tzname(prop));
+        buf_appendcstr(tzif, icalproperty_get_tzname(prop));
 
         /* std offset */
         prop = icalcomponent_get_first_property(eternal_std,
                                                 ICAL_TZOFFSETTO_PROPERTY);
         stdoff = icalproperty_get_tzoffsetto(prop);
-        buf_append_utcoffset_as_iso_string(tzfile, stdoff);
+        buf_append_utcoffset_as_iso_string(tzif, stdoff);
 
         /* dst name */
         prop = icalcomponent_get_first_property(eternal_dst,
                                                 ICAL_TZNAME_PROPERTY);
-        buf_appendcstr(tzfile, icalproperty_get_tzname(prop));
+        buf_appendcstr(tzif, icalproperty_get_tzname(prop));
 
         /* dst offset */
         prop = icalcomponent_get_first_property(eternal_dst,
                                                 ICAL_TZOFFSETTO_PROPERTY);
         dstoff = icalproperty_get_tzoffsetto(prop);
         if (dstoff - stdoff != 3600) {  /* default is 1hr from std */
-            buf_append_utcoffset_as_iso_string(tzfile, dstoff);
+            buf_append_utcoffset_as_iso_string(tzif, dstoff);
         }
 
         /* rule */
-        buf_append(tzfile, &posix);
+        buf_append(tzif, &posix);
     }
     else if (!eternal_dst &&
              !icalcomponent_get_tzuntil_property(vtz)) {
@@ -2690,34 +2734,36 @@ static struct buf *_icaltimezone_as_tzfi
         /* std name */
         if (obs->name[0] == ':' ||
             strcspn(obs->name, ",+-0123456789") < strlen(obs->name)) {
-            buf_printf(tzfile, "<%s>", obs->name);
+            buf_printf(tzif, "<%s>", obs->name);
         }
-        else buf_appendcstr(tzfile, obs->name);
+        else buf_appendcstr(tzif, obs->name);
 
         /* std offset */
-        buf_append_utcoffset_as_iso_string(tzfile, obs->offset_to);
+        buf_append_utcoffset_as_iso_string(tzif, obs->offset_to);
     }
-    buf_putc(tzfile, '\n');
+    buf_putc(tzif, '\n');
 
     buf_free(&posix);
     icalarray_free(obsarray);
 
-    return tzfile;
+    return tzif;
 }
 
 static void tzdist_truncate_vtimezone(icalcomponent *vtz,
-                                      icaltimetype *startp, icaltimetype *endp) {
-    truncate_vtimezone(vtz, startp, endp, NULL, NULL, NULL, NULL, NULL);
+                                      icaltimetype *startp, icaltimetype *endp)
+{
+    truncate_vtimezone(vtz, startp, endp, NULL, NULL, NULL, NULL, NULL,
+                       1 /* ms_compatible */);
 }
 
-static struct buf *icaltimezone_as_tzfile(icalcomponent* ical)
+static struct buf *icaltimezone_as_tzif(icalcomponent* ical)
 {
-    return _icaltimezone_as_tzfile(ical, 0);
+    return _icaltimezone_as_tzif(ical, 0, NULL, NULL);
 }
 
-static struct buf *icaltimezone_as_tzfile_leap(icalcomponent* ical)
+static struct buf *icaltimezone_as_tzif_leap(icalcomponent* ical)
 {
-    return _icaltimezone_as_tzfile(ical, leap_seconds->count - 2);
+    return _icaltimezone_as_tzif(ical, leap_seconds->count - 2, NULL, NULL);
 }
 
 static icaltimezone *tz_from_tzid(const char *tzid)
@@ -2760,7 +2806,7 @@ EXPORTED void icalcomponent_add_required
     /* Determine recurrence span. */
     comp = icalcomponent_get_first_real_component(ical);
     span = icalrecurrenceset_get_utc_timespan(ical, icalcomponent_isa(comp),
-                                              NULL, NULL, NULL);
+                                              NULL, NULL, NULL, NULL);
 
     /* Remove all VTIMEZONE components for known TZIDs. This operation is
      * a bit hairy: we could expunge a timezone which is in use by an ical
@@ -2777,7 +2823,7 @@ EXPORTED void icalcomponent_add_required
         prop = icalcomponent_get_first_property(tzcomp, ICAL_TZID_PROPERTY);
         if (prop) {
             const char *tzid = icalproperty_get_tzid(prop);
-            if (tz_from_tzid(tzid)) {
+            if (tzid && tz_from_tzid(tzid)) {
                 icalcomponent_remove_component(ical, tzcomp);
                 icalcomponent_free(tzcomp);
             }
@@ -2794,7 +2840,7 @@ EXPORTED void icalcomponent_add_required
 
         /* Clone tz to overwrite its TZID property. */
         icalcomponent *tzcomp =
-            icalcomponent_new_clone(icaltimezone_get_component(tz));
+            icalcomponent_clone(icaltimezone_get_component(tz));
         icalproperty *tzprop =
             icalcomponent_get_first_property(tzcomp, ICAL_TZID_PROPERTY);
         icalproperty_set_tzid(tzprop, icaltimezone_get_location(tz));
@@ -2802,9 +2848,20 @@ EXPORTED void icalcomponent_add_required
         /* Truncate the timezone to the events timespan. */
         tzdist_truncate_vtimezone(tzcomp, &span.start, &span.end);
 
-        /* Add TZUNTIL to timezone */
-        icalproperty *tzuntil = icalproperty_new_tzuntil(span.end);
-        icalcomponent_add_property(tzcomp, tzuntil);
+        if (icaltime_as_timet_with_zone(span.end, NULL) < caldav_eternity) {
+            /* Add TZUNTIL to timezone */
+            icalproperty *tzuntil = icalproperty_new_tzuntil(span.end);
+            icalcomponent_add_property(tzcomp, tzuntil);
+        }
+
+        /* Strip any COMMENT property */
+        /* XXX  These were added by KSM in a previous version of vzic,
+           but libical doesn't allow them in its restrictions checks */
+        tzprop = icalcomponent_get_first_property(tzcomp, ICAL_COMMENT_PROPERTY);
+        if (tzprop) {
+            icalcomponent_remove_property(tzcomp, tzprop);
+            icalproperty_free(tzprop);
+        }
 
         /* Add the truncated timezone. */
         icalcomponent_add_component(ical, tzcomp);
diff -pruN 3.0.13-5/imap/http_webdav.c 3.2.0-3/imap/http_webdav.c
--- 3.0.13-5/imap/http_webdav.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/http_webdav.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,9 +44,9 @@
 #include <config.h>
 
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 
-#include "exitcodes.h"
 #include "httpd.h"
 #include "http_dav.h"
 #include "http_proxy.h"
@@ -54,6 +54,7 @@
 #include "proxy.h"
 #include "spool.h"
 #include "tok.h"
+#include "user.h"
 #include "util.h"
 #include "webdav_db.h"
 #include "xstrlcpy.h"
@@ -65,12 +66,13 @@
 static struct webdav_db *auth_webdavdb = NULL;
 
 static void my_webdav_init(struct buf *serverinfo);
-static void my_webdav_auth(const char *userid);
+static int my_webdav_auth(const char *userid);
 static void my_webdav_reset(void);
 static void my_webdav_shutdown(void);
 
-static int webdav_parse_path(const char *path,
-                             struct request_target_t *tgt, const char **errstr);
+static unsigned long webdav_allow_cb(struct request_target_t *tgt);
+static int webdav_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr);
 
 static int webdav_get(struct transaction_t *txn, struct mailbox *mailbox,
                       struct index_record *record, void *data, void **obj);
@@ -116,7 +118,7 @@ static const struct report_type_t webdav
 
     /* WebDAV ACL (RFC 3744) REPORTs */
     { "acl-principal-prop-set", NS_DAV, "multistatus", &report_acl_prin_prop,
-      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_DEPTH_ZERO },
+      DACL_ADMIN, REPORT_NEED_MBOX | REPORT_NEED_PROPS | REPORT_DEPTH_ZERO },
 
     /* WebDAV Sync (RFC 6578) REPORTs */
     { "sync-collection", NS_DAV, "multistatus", &report_sync_col,
@@ -133,52 +135,73 @@ static const struct prop_entry webdav_pr
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_creationdate, NULL, NULL },
     { "displayname", NS_DAV,
-      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
-      propfind_fromdb, proppatch_todb, NULL },
-    { "getcontentlanguage", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE | PROP_PERUSER,
+      propfind_collectionname, proppatch_todb, NULL },
+    { "getcontentlanguage", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_fromhdr, NULL, "Content-Language" },
     { "getcontentlength", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getlength, NULL, NULL },
-    { "getcontenttype", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "getcontenttype", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_fromhdr, NULL, "Content-Type" },
-    { "getetag", NS_DAV, PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
+    { "getetag", NS_DAV,
+      PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getetag, NULL, NULL },
     { "getlastmodified", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_getlastmod, NULL, NULL },
-    { "lockdiscovery", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "lockdiscovery", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_lockdisc, NULL, NULL },
     { "resourcetype", NS_DAV,
       PROP_ALLPROP | PROP_COLLECTION | PROP_RESOURCE,
       propfind_restype, proppatch_restype, "addressbook" },
-    { "supportedlock", NS_DAV, PROP_ALLPROP | PROP_RESOURCE,
+    { "supportedlock", NS_DAV,
+      PROP_ALLPROP | PROP_RESOURCE,
       propfind_suplock, NULL, NULL },
 
     /* WebDAV Versioning (RFC 3253) properties */
-    { "supported-report-set", NS_DAV, PROP_COLLECTION,
+    { "supported-report-set", NS_DAV,
+      PROP_COLLECTION,
       propfind_reportset, NULL, (void *) webdav_reports },
+    { "supported-method-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      propfind_methodset, NULL, (void *) &webdav_allow_cb },
 
     /* WebDAV ACL (RFC 3744) properties */
-    { "owner", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "owner", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_owner, NULL, NULL },
-    { "group", NS_DAV, 0, NULL, NULL, NULL },
-    { "supported-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "group", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "supported-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_supprivset, NULL, NULL },
-    { "current-user-privilege-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "current-user-privilege-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_curprivset, NULL, NULL },
-    { "acl", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE | PROP_PRESCREEN,
       propfind_acl, NULL, NULL },
-    { "acl-restrictions", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "acl-restrictions", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_aclrestrict, NULL, NULL },
-    { "inherited-acl-set", NS_DAV, 0, NULL, NULL, NULL },
-    { "principal-collection-set", NS_DAV, PROP_COLLECTION | PROP_RESOURCE,
+    { "inherited-acl-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
+      NULL, NULL, NULL },
+    { "principal-collection-set", NS_DAV,
+      PROP_COLLECTION | PROP_RESOURCE,
       propfind_princolset, NULL, NULL },
 
     /* WebDAV Quota (RFC 4331) properties */
-    { "quota-available-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-available-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
-    { "quota-used-bytes", NS_DAV, PROP_COLLECTION,
+    { "quota-used-bytes", NS_DAV,
+      PROP_COLLECTION,
       propfind_quota, NULL, NULL },
 
     /* WebDAV Current Principal (RFC 5397) properties */
@@ -187,15 +210,18 @@ static const struct prop_entry webdav_pr
       propfind_curprin, NULL, NULL },
 
     /* WebDAV POST (RFC 5995) properties */
-    { "add-member", NS_DAV, PROP_COLLECTION,
+    { "add-member", NS_DAV,
+      PROP_COLLECTION,
       NULL,  /* Until Apple Contacts is fixed */ NULL, NULL },
 
     /* WebDAV Sync (RFC 6578) properties */
-    { "sync-token", NS_DAV, PROP_COLLECTION,
+    { "sync-token", NS_DAV,
+      PROP_COLLECTION,
       propfind_sync_token, NULL, SYNC_TOKEN_URL_SCHEME },
 
     /* Apple Calendar Server properties */
-    { "getctag", NS_CS, PROP_ALLPROP | PROP_COLLECTION,
+    { "getctag", NS_CS,
+      PROP_ALLPROP | PROP_COLLECTION,
       propfind_sync_token, NULL, "" },
 
     { NULL, 0, 0, NULL, NULL, NULL }
@@ -204,6 +230,8 @@ static const struct prop_entry webdav_pr
 struct meth_params webdav_params = {
     webdav_mime_types,
     &webdav_parse_path,
+    &dav_get_validators,
+    &dav_get_modseq,
     &dav_check_precond,
     { (db_open_proc_t) &webdav_open_mailbox,
       (db_close_proc_t) &webdav_close,
@@ -211,16 +239,18 @@ struct meth_params webdav_params = {
       (db_proc_t) &webdav_commit,
       (db_proc_t) &webdav_abort,
       (db_lookup_proc_t) &webdav_lookup_resource,
+      (db_imapuid_proc_t) &webdav_lookup_imapuid,
       (db_foreach_proc_t) &webdav_foreach,
+      (db_updates_proc_t) &webdav_get_updates,
       (db_write_proc_t) &webdav_write,
       (db_delete_proc_t) &webdav_delete },
     NULL,                                       /* No ACL extensions */
     { 0, &webdav_put },                         /* Allow duplicate UIDs */
     NULL,                                       /* No special DELETE handling */
     &webdav_get,
-    { 0, MBTYPE_COLLECTION },                   /* Allow any location */
+    { 0, MBTYPE_COLLECTION, NULL },             /* Allow any location */
     NULL,                                       /* No PATCH handling */
-    { POST_ADDMEMBER, NULL, NULL },             /* No special POST handling */
+    { POST_ADDMEMBER, NULL, { 0, NULL, NULL } },/* No special POST handling */
     { 0, &webdav_put },                         /* Allow any MIME type */
     { DAV_FINITE_DEPTH, webdav_props},
     webdav_reports
@@ -229,7 +259,7 @@ struct meth_params webdav_params = {
 
 /* Namespace for Webdav collections */
 struct namespace_t namespace_drive = {
-    URL_NS_DRIVE, 0, "/dav/drive", NULL,
+    URL_NS_DRIVE, 0, "drive", "/dav/drive", NULL,
     http_allow_noauth_get, /*authschemes*/0,
     MBTYPE_COLLECTION,
     (ALLOW_READ | ALLOW_POST | ALLOW_WRITE | ALLOW_DELETE |
@@ -239,6 +269,7 @@ struct namespace_t namespace_drive = {
     {
         { &meth_acl,            &webdav_params },      /* ACL          */
         { NULL,                 NULL },                /* BIND         */
+        { NULL,                 NULL },                /* CONNECT      */
         { &meth_copy_move,      &webdav_params },      /* COPY         */
         { &meth_delete,         &webdav_params },      /* DELETE       */
         { &meth_get_head,       &webdav_params },      /* GET          */
@@ -268,7 +299,7 @@ static void my_webdav_init(struct buf *s
     if (!namespace_drive.enabled) return;
 
     if (!config_getstring(IMAPOPT_DAVDRIVEPREFIX)) {
-        fatal("Required 'davdriveprefix' option is not set", EC_CONFIG);
+        fatal("Required 'davdriveprefix' option is not set", EX_CONFIG);
     }
 
     webdav_init();
@@ -277,30 +308,37 @@ static void my_webdav_init(struct buf *s
 }
 
 
-static void my_webdav_auth(const char *userid)
+static int my_webdav_auth(const char *userid)
 {
-    int r;
-
     if (httpd_userisadmin || httpd_userisanonymous ||
         global_authisa(httpd_authstate, IMAPOPT_PROXYSERVERS)) {
         /* admin, anonymous, or proxy from frontend - won't have DAV database */
-        return;
+        return 0;
     }
     else if (config_mupdate_server && !config_getstring(IMAPOPT_PROXYSERVERS)) {
         /* proxy-only server - won't have DAV databases */
+        return 0;
     }
     else {
         /* Open WebDAV DB for 'userid' */
         my_webdav_reset();
         auth_webdavdb = webdav_open_userid(userid);
-        if (!auth_webdavdb) fatal("Unable to open WebDAV DB", EC_IOERR);
+        if (!auth_webdavdb) {
+            syslog(LOG_ERR, "Unable to open WebDAV DB for userid: %s", userid);
+            return HTTP_UNAVAILABLE;
+        }
     }
 
     /* Auto-provision toplevel DAV drive collection for 'userid' */
     mbname_t *mbname = mbname_from_userid(userid);
     mbname_push_boxes(mbname, config_getstring(IMAPOPT_DAVDRIVEPREFIX));
-    r = mboxlist_lookup(mbname_intname(mbname), NULL, NULL);
+    int r = mboxlist_lookup(mbname_intname(mbname), NULL, NULL);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
+        struct mboxlock *namespacelock = user_namespacelock(userid);
+        // did we lose the race?  Nothing to do!
+        r = mboxlist_lookup(mbname_intname(mbname), NULL, NULL);
+        if (r != IMAP_MAILBOX_NONEXISTENT) goto done;
+
         /* Find location of INBOX */
         char *inboxname = mboxname_user_mbox(userid, NULL);
         mbentry_t *mbentry = NULL;
@@ -312,13 +350,14 @@ static void my_webdav_auth(const char *u
             proxy_findserver(mbentry->server, &http_protocol, httpd_userid,
                              &backend_cached, NULL, NULL, httpd_in);
             mboxlist_entry_free(&mbentry);
+            mboxname_release(&namespacelock);
             goto done;
         }
         mboxlist_entry_free(&mbentry);
 
         if (!r) {
             r = mboxlist_createmailbox(mbname_intname(mbname), MBTYPE_COLLECTION,
-                                       NULL, 0,
+                                       NULL, httpd_userisadmin || httpd_userisproxyadmin,
                                        userid, httpd_authstate,
                                        0, 0, 0, 0, NULL);
             if (r) syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
@@ -328,10 +367,13 @@ static void my_webdav_auth(const char *u
             syslog(LOG_ERR, "could not autoprovision DAV drive for userid %s: %s",
                    userid, error_message(r));
         }
+
+        mboxname_release(&namespacelock);
     }
 
  done:
     mbname_free(&mbname);
+    return 0;
 }
 
 
@@ -349,14 +391,30 @@ static void my_webdav_shutdown(void)
 }
 
 
+/* Determine allowed methods in WebDAV namespace */
+static unsigned long webdav_allow_cb(struct request_target_t *tgt)
+{
+    unsigned long allow = tgt->namespace->allow;
+
+    if (!tgt->userid) {
+        allow &= ALLOW_READ_MASK;
+    }
+    else if (tgt->resource) {
+        allow &= ~(ALLOW_MKCOL | ALLOW_POST);
+    }
+
+    return allow;
+}
+
+
 /* Parse request-target path in WebDAV namespace
  *
  * For purposes of PROPFIND and REPORT, we never assign tgt->collection.
  * All collections are treated as though they are at the root so both
  * contained resources and collection are listed.
  */
-static int webdav_parse_path(const char *path,
-                             struct request_target_t *tgt, const char **errstr)
+static int webdav_parse_path(const char *path, struct request_target_t *tgt,
+                             const char **resultstr)
 {
     char *p, *last = NULL;
     size_t len, lastlen = 0;
@@ -376,7 +434,7 @@ static int webdav_parse_path(const char
     if (strlen(p) < len ||
         strncmp(namespace_drive.prefix, p, len) ||
         (path[len] && path[len] != '/')) {
-        *errstr = "Namespace mismatch request target path";
+        *resultstr = "Namespace mismatch request target path";
         return HTTP_FORBIDDEN;
     }
 
@@ -481,7 +539,7 @@ static int webdav_parse_path(const char
         if (r) {
             syslog(LOG_ERR, "mlookup(%s) failed: %s",
                    mboxname, error_message(r));
-            *errstr = error_message(r);
+            *resultstr = error_message(r);
             mbname_free(&mbname);
 
             switch (r) {
@@ -516,7 +574,7 @@ static int webdav_get(struct transaction
         assert(!buf_len(&txn->buf));
         buf_printf(&txn->buf, "%s/%s", wdata->type, wdata->subtype);
         txn->resp_body.type = buf_cstring(&txn->buf);
-        txn->resp_body.fname = wdata->filename;
+        txn->resp_body.dispo.fname = wdata->filename;
         return HTTP_CONTINUE;
     }
 
@@ -645,7 +703,7 @@ static int webdav_put(struct transaction
 
     /* Store the resource */
     return dav_store_resource(txn, buf_base(buf), buf_len(buf),
-                              mailbox, oldrecord, NULL);
+                              mailbox, oldrecord, wdata->dav.createdmodseq, NULL);
 }
 
 
diff -pruN 3.0.13-5/imap/http_ws.c 3.2.0-3/imap/http_ws.c
--- 3.0.13-5/imap/http_ws.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_ws.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,849 @@
+/* http_ws.c - WebSockets support functions
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+#include <sysexits.h>
+
+#include "httpd.h"
+#include "util.h"
+
+#ifdef HAVE_WSLAY
+
+#include <errno.h>
+#include <syslog.h>
+
+#include <sasl/saslutil.h>
+
+#include "http_h2.h"
+#include "http_ws.h"
+#include "retry.h"
+#include "tok.h"
+#include "xsha1.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+
+
+#define WS_CKEY_LEN  24
+#define WS_AKEY_LEN  28
+#define WS_GUID      "258EAFA5-E914-47DA-95CA-C5AB0DC85B11"
+
+
+/* WebSocket Extension flags */
+enum {
+    EXT_PMCE_DEFLATE   = (1<<0)      /* Per-Message Compression Ext (RFC 7692) */
+};
+
+/* Supported WebSocket Extensions */
+static struct ws_extension {
+    const char *name;
+    unsigned flag;
+} extensions[] = {
+    { "permessage-deflate", EXT_PMCE_DEFLATE },
+    { NULL, 0 }
+};
+
+
+/* WebSocket channel context */
+struct ws_context {
+    wslay_event_context_ptr event;
+    const char *accept;
+    const char *protocol;
+    int (*data_cb)(struct buf *inbuf, struct buf *outbuf,
+                   struct buf *logbuf, void **rock);
+    void *cb_rock;
+    struct buf log;
+    int log_tail;
+    unsigned ext;                    /* Bitmask of negotiated extension(s) */
+
+    struct protstream *h2_pin;       /* Input protstream when under HTTP/2 */
+
+    union {
+        struct {
+            void *zstrm;             /* Zlib decompression context */
+            unsigned no_context : 1;
+            unsigned max_wbits;
+        } deflate;
+    } pmce;
+};
+
+
+static const char *wslay_str_opcode(uint8_t opcode)
+{
+    switch (opcode) {
+    case 0x0u:
+        return "Continuation";
+    case 0x1u:
+        return "Text";
+    case 0x2u:
+        return "Binary";
+    case 0x8u:
+        return "Close";
+    case 0x9u:
+        return "Ping";
+    case 0xau:
+        return "Pong";
+    default:
+        return "Unknown opcode";
+    }
+}
+
+static const char *wslay_strerror(int err_code)
+{
+    switch (err_code) {
+    case 0:
+        return "Success";
+    case WSLAY_ERR_WANT_READ:
+        return "Want to read more data from peer";
+    case WSLAY_ERR_WANT_WRITE:
+        return "Want to send more data to peer";
+    case WSLAY_ERR_PROTO:
+        return "Protocol error";
+    case WSLAY_ERR_INVALID_ARGUMENT:
+        return "Message is invalid";
+    case WSLAY_ERR_INVALID_CALLBACK:
+        return "Invalid callback";
+    case WSLAY_ERR_NO_MORE_MSG:
+        return "Could not queue message";
+    case WSLAY_ERR_CALLBACK_FAILURE:
+        return "The user callback function failed";
+    case WSLAY_ERR_WOULDBLOCK:
+        return "Operation would block";
+    case WSLAY_ERR_NOMEM:
+        return "Out of memory";
+    default:
+        return "Unknown error code";
+    }
+}
+
+static ssize_t send_cb(wslay_event_context_ptr ev,
+                       const uint8_t *data, size_t len,
+                       int flags, void *user_data)
+{
+    struct transaction_t *txn = (struct transaction_t *) user_data;
+    int r;
+
+    if (txn->conn->sess_ctx) {
+        int last_chunk =
+            (txn->flags.conn & CONN_CLOSE) && !(flags & WSLAY_MSG_MORE);
+
+        r = http2_data_chunk(txn, (const char *) data, len,
+                             last_chunk, NULL /* md5ctx */);
+    }
+    else {
+        r = prot_write(txn->conn->pout, (const char *) data, len);
+    }
+
+    syslog(LOG_DEBUG, "ws_send_cb(%zu): %d", len, r);
+
+    if (r) {
+        wslay_event_set_error(ev, WSLAY_ERR_CALLBACK_FAILURE);
+        return -1;
+    }
+
+    return len;
+}
+
+static ssize_t recv_cb(wslay_event_context_ptr ev,
+                       uint8_t *buf, size_t len,
+                       int flags __attribute__((unused)),
+                       void *user_data)
+{
+    struct transaction_t *txn = (struct transaction_t *) user_data;
+    struct protstream *pin = txn->conn->pin;
+    ssize_t n;
+
+    if (txn->conn->sess_ctx) {
+        pin = ((struct ws_context *) txn->ws_ctx)->h2_pin;
+    }
+
+    n = prot_read(pin, (char *) buf, len);
+    if (!n) {
+        /* No data */
+        if (pin->eof && !pin->fixedsize)
+            wslay_event_set_error(ev, WSLAY_ERR_NO_MORE_MSG);
+        else if (pin->error)
+            wslay_event_set_error(ev, WSLAY_ERR_CALLBACK_FAILURE);
+        else
+            wslay_event_set_error(ev, WSLAY_ERR_WOULDBLOCK);
+
+        n = -1;
+    }
+
+    syslog(LOG_DEBUG,
+           "ws_recv_cb(%zu): n = %zd, eof = %d, err = '%s', errno = %m",
+           len, n, pin->eof, pin->error ? pin->error : "");
+
+    return n;
+}
+
+static int zlib_decompress(struct transaction_t *txn,
+                           const char *buf, unsigned len)
+{
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+    z_stream *zstrm = ctx->pmce.deflate.zstrm;
+
+    zstrm->next_in = (Bytef *) buf;
+    zstrm->avail_in = len;
+
+    buf_reset(&txn->zbuf);
+
+    do {
+        int zr;
+
+        buf_ensure(&txn->zbuf, 4096);
+
+        zstrm->next_out = (Bytef *) txn->zbuf.s + txn->zbuf.len;
+        zstrm->avail_out = txn->zbuf.alloc - txn->zbuf.len;
+
+        zr = inflate(zstrm, Z_SYNC_FLUSH);
+        if (!(zr == Z_OK || zr == Z_STREAM_END || zr == Z_BUF_ERROR)) {
+            /* something went wrong */
+            syslog(LOG_ERR, "zlib deflate error: %d %s", zr, zstrm->msg);
+            return -1;
+        }
+
+        txn->zbuf.len = txn->zbuf.alloc - zstrm->avail_out;
+
+    } while (!zstrm->avail_out);
+
+    return 0;
+}
+
+#define COMP_FAILED_ERR    "Compressing message failed"
+#define DECOMP_FAILED_ERR  "Decompressing message failed"
+
+static void on_msg_recv_cb(wslay_event_context_ptr ev,
+                           const struct wslay_event_on_msg_recv_arg *arg,
+                           void *user_data)
+{
+    struct transaction_t *txn = (struct transaction_t *) user_data;
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+    struct buf inbuf = BUF_INITIALIZER, outbuf = BUF_INITIALIZER;
+    struct wslay_event_msg msgarg = { arg->opcode, NULL, 0 };
+    uint8_t rsv = WSLAY_RSV_NONE;
+    double cmdtime, nettime;
+    const char *err_msg;
+    int r, err_code = 0;
+
+    /* Place client request into a buf */
+    buf_init_ro(&inbuf, (const char *) arg->msg, arg->msg_length);
+
+    /* Decompress request, if necessary */
+    if (wslay_get_rsv1(arg->rsv)) {
+        /* Add trailing 4 bytes */
+        buf_appendmap(&inbuf, "\x00\x00\xff\xff", 4);
+
+        r = zlib_decompress(txn, buf_base(&inbuf), buf_len(&inbuf));
+        if (r) {
+            syslog(LOG_ERR, "on_msg_recv_cb(): zlib_decompress() failed");
+
+            err_code = WSLAY_CODE_PROTOCOL_ERROR;
+            err_msg = DECOMP_FAILED_ERR;
+            goto err;
+        }
+
+        buf_move(&inbuf, &txn->zbuf);
+    }
+
+    /* Log the uncompressed client request */
+    buf_truncate(&ctx->log, ctx->log_tail);
+    buf_appendcstr(&ctx->log, " (");
+    if (txn->strm_ctx) {
+        buf_printf(&ctx->log, "stream-id=%d; ",
+                   http2_get_streamid(txn->strm_ctx));
+    }
+    buf_printf(&ctx->log, "opcode=%s; rsv=0x%x; length=%ld",
+               wslay_str_opcode(arg->opcode), arg->rsv, arg->msg_length);
+
+    switch (arg->opcode) {
+    case WSLAY_CONNECTION_CLOSE:
+        buf_printf(&ctx->log, "; status=%d; msg='%s'", arg->status_code,
+                   buf_len(&inbuf) ? buf_cstring(&inbuf)+2 : "");
+        txn->flags.conn = CONN_CLOSE;
+        break;
+
+    case WSLAY_TEXT_FRAME:
+    case WSLAY_BINARY_FRAME:
+        if (txn->conn->logfd != -1) {
+            /* Telemetry logging */
+            struct iovec iov[2];
+            int niov = 0;
+
+            assert(!buf_len(&txn->buf));
+            buf_printf(&txn->buf, "<%ld<", time(NULL));  /* timestamp */
+            WRITEV_ADD_TO_IOVEC(iov, niov,
+                                buf_base(&txn->buf), buf_len(&txn->buf));
+            WRITEV_ADD_TO_IOVEC(iov, niov, buf_base(&inbuf), buf_len(&inbuf));
+            writev(txn->conn->logfd, iov, niov);
+            buf_reset(&txn->buf);
+        }
+
+        /* Process the request */
+        r = ctx->data_cb(&inbuf, &outbuf, &ctx->log, &ctx->cb_rock);
+        if (r) {
+
+            err_code = (r == HTTP_SERVER_ERROR ?
+                        WSLAY_CODE_INTERNAL_SERVER_ERROR :
+                        WSLAY_CODE_INVALID_FRAME_PAYLOAD_DATA);
+            err_msg = error_message(r);
+            goto err;
+        }
+
+        if (txn->conn->logfd != -1) {
+            /* Telemetry logging */
+            struct iovec iov[2];
+            int niov = 0;
+
+            assert(!buf_len(&txn->buf));
+            buf_printf(&txn->buf, ">%ld>", time(NULL));  /* timestamp */
+            WRITEV_ADD_TO_IOVEC(iov, niov,
+                                buf_base(&txn->buf), buf_len(&txn->buf));
+            WRITEV_ADD_TO_IOVEC(iov, niov, buf_base(&outbuf), buf_len(&outbuf));
+            writev(txn->conn->logfd, iov, niov);
+            buf_reset(&txn->buf);
+        }
+
+        /* Compress the server response, if supported by the client */
+        if (ctx->ext & EXT_PMCE_DEFLATE) {
+            r = zlib_compress(txn,
+                              ctx->pmce.deflate.no_context ? COMPRESS_START : 0,
+                              buf_base(&outbuf), buf_len(&outbuf));
+            if (r) {
+                syslog(LOG_ERR, "on_msg_recv_cb(): zlib_compress() failed");
+
+                err_code = WSLAY_CODE_INTERNAL_SERVER_ERROR;
+                err_msg = COMP_FAILED_ERR;
+                goto err;
+            }
+
+            /* Trim the trailing 4 bytes */
+            buf_truncate(&txn->zbuf, buf_len(&txn->zbuf) - 4);
+            buf_move(&outbuf, &txn->zbuf);
+
+            rsv |= WSLAY_RSV1_BIT;
+        }
+
+        /* Queue the server response */
+        msgarg.msg = (const uint8_t *) buf_base(&outbuf);
+        msgarg.msg_length = buf_len(&outbuf);
+        wslay_event_queue_msg_ex(ev, &msgarg, rsv);
+
+        /* Log the server response */
+        buf_printf(&ctx->log,
+                   ") => \"Success\" (opcode=%s; rsv=0x%x; length=%ld",
+                   wslay_str_opcode(msgarg.opcode), rsv, msgarg.msg_length);
+        break;
+    }
+
+  err:
+    if (err_code) {
+        size_t err_msg_len = strlen(err_msg);
+
+        syslog(LOG_DEBUG, "wslay_event_queue_close()");
+        wslay_event_queue_close(ev, err_code, (uint8_t *) err_msg, err_msg_len);
+
+        /* Log the server response */
+        buf_printf(&ctx->log,
+                   ") => \"Fail\" (opcode=%s; rsv=0x%x; length=%ld"
+                   "; status=%d; msg='%s'",
+                   wslay_str_opcode(WSLAY_CONNECTION_CLOSE), rsv, err_msg_len,
+                   err_code, err_msg);
+    }
+
+    /* Add timing stats */
+    cmdtime_endtimer(&cmdtime, &nettime);
+    buf_printf(&ctx->log, ") [timing: cmd=%f net=%f total=%f]",
+               cmdtime, nettime, cmdtime + nettime);
+
+    syslog(LOG_INFO, "%s", buf_cstring(&ctx->log));
+
+    buf_free(&inbuf);
+    buf_free(&outbuf);
+}
+
+
+HIDDEN void ws_init(struct buf *serverinfo)
+{
+    buf_printf(serverinfo, " Wslay/%s", WSLAY_VERSION);
+}
+
+
+HIDDEN int ws_enabled()
+{
+    return 1;
+}
+
+
+HIDDEN void ws_done()
+{
+    return;
+}
+
+/* Parse Sec-WebSocket-Extensions header(s) for interesting extensions */
+static void parse_extensions(struct transaction_t *txn)
+{
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+    const char **ext_hdr =
+        spool_getheader(txn->req_hdrs, "Sec-WebSocket-Extensions");
+    int i;
+
+    /* Look for interesting extensions.  Unknown == ignore */
+    for (i = 0; ext_hdr && ext_hdr[i]; i++) {
+        tok_t ext = TOK_INITIALIZER(ext_hdr[i], ",", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+        char *token;
+
+        while ((token = tok_next(&ext))) {
+            struct ws_extension *extp = extensions;
+            tok_t param;
+
+            tok_initm(&param, token, ";", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+            token = tok_next(&param);
+
+            /* Locate a matching extension */
+            while (extp->name && strcmp(token, extp->name)) extp++;
+
+            /* Check if client wants per-message compression */
+            if (extp->flag == EXT_PMCE_DEFLATE) {
+                unsigned client_max_wbits = MAX_WBITS;
+
+                ctx->pmce.deflate.max_wbits = MAX_WBITS;
+
+                /* Process parameters */
+                while ((token = tok_next(&param))) {
+                    char *value = strchr(token, '=');
+
+                    if (value) *value++ = '\0';
+
+                    if (!strcmp(token, "server_no_context_takeover")) {
+                        ctx->pmce.deflate.no_context = 1;
+                    }
+                    else if (!strcmp(token, "client_no_context_takeover")) {
+                        /* Don't HAVE to do anything here */
+                    }
+                    else if (!strcmp(token, "server_max_window_bits")) {
+                        if (value) {
+                            if (*value == '"') value++;
+                            ctx->pmce.deflate.max_wbits = atoi(value);
+                        }
+                        else ctx->pmce.deflate.max_wbits = 0;  /* force error */
+                    }
+                    else if (!strcmp(token, "client_max_window_bits")) {
+                        if (value) {
+                            if (*value == '"') value++;
+                            client_max_wbits = atoi(value);
+                        }
+                    }
+                }
+#ifdef HAVE_ZLIB
+                /* Reconfigure compression context for raw deflate */
+                if (txn->zstrm) deflateEnd(txn->zstrm);
+                else txn->zstrm = xmalloc(sizeof(z_stream));
+
+                if (deflateInit2(txn->zstrm, Z_DEFAULT_COMPRESSION, Z_DEFLATED,
+                                 -ctx->pmce.deflate.max_wbits,
+                                 MAX_MEM_LEVEL, Z_DEFAULT_STRATEGY) != Z_OK) {
+                    free(txn->zstrm);
+                    txn->zstrm = NULL;
+                }
+                if (txn->zstrm) {
+                    /* Configure decompression context for raw deflate */
+                    ctx->pmce.deflate.zstrm = xmalloc(sizeof(z_stream));
+                    if (inflateInit2(ctx->pmce.deflate.zstrm,
+                                     -client_max_wbits) != Z_OK) {
+                        free(ctx->pmce.deflate.zstrm);
+                        ctx->pmce.deflate.zstrm = NULL;
+                    }
+                }
+#endif /* HAVE_ZLIB */
+                if (ctx->pmce.deflate.zstrm) {
+                    /* Compression has been enabled */
+                    wslay_event_config_set_allowed_rsv_bits(ctx->event,
+                                                            WSLAY_RSV1_BIT);
+                    ctx->ext = extp->flag;
+                }
+            }
+
+            tok_fini(&param);
+        }
+
+        tok_fini(&ext);
+    }
+}
+
+
+HIDDEN int ws_start_channel(struct transaction_t *txn, const char *protocol,
+                            int (*data_cb)(struct buf *inbuf, struct buf *outbuf,
+                                           struct buf *logbuf, void **rock))
+{
+    int r;
+    const char **hdr, *accept = NULL;
+    wslay_event_context_ptr ev;
+    struct ws_context *ctx;
+    struct wslay_event_callbacks callbacks = {
+        recv_cb,
+        send_cb,
+        NULL,
+        NULL,
+        NULL,
+        NULL,
+        on_msg_recv_cb
+    };
+
+    /* Check for supported WebSocket version */
+    hdr = spool_getheader(txn->req_hdrs, "Sec-WebSocket-Version");
+    if (!hdr) {
+        txn->error.desc = "Missing WebSocket version";
+        return HTTP_BAD_REQUEST;
+    }
+    else if (hdr[1]) {
+        txn->error.desc = "Multiple WebSocket versions";
+        return HTTP_BAD_REQUEST;
+    }
+    else if (strcmp(hdr[0], WS_VERSION)) {
+        txn->error.desc = "Unsupported WebSocket version";
+        return HTTP_UPGRADE;
+    }
+
+    if (protocol) {
+        /* Check for supported WebSocket subprotocol */
+        int i, found = 0;
+
+        hdr = spool_getheader(txn->req_hdrs, "Sec-WebSocket-Protocol");
+        if (!hdr) {
+            txn->error.desc = "Missing WebSocket protocol";
+            return HTTP_BAD_REQUEST;
+        }
+
+        for (i = 0; !found && hdr[i]; i++) {
+            tok_t tok = TOK_INITIALIZER(hdr[i], ",", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+            char *token;
+
+            while ((token = tok_next(&tok))) {
+                if (!strcmp(token, protocol)) {
+                    found = 1;
+                    break;
+                }
+            }
+            tok_fini(&tok);
+        }
+        if (!found) {
+            txn->error.desc = "Unsupported WebSocket protocol";
+            return HTTP_BAD_REQUEST;
+        }
+    }
+
+    if (txn->flags.ver == VER_1_1) {
+        unsigned char sha1buf[SHA1_DIGEST_LENGTH];
+
+        /* Check for WebSocket client key */
+        hdr = spool_getheader(txn->req_hdrs, "Sec-WebSocket-Key");
+        if (!hdr) {
+            txn->error.desc = "Missing WebSocket client key";
+            return HTTP_BAD_REQUEST;
+        }
+        else if (hdr[1]) {
+            txn->error.desc = "Multiple WebSocket client keys";
+            return HTTP_BAD_REQUEST;
+        }
+        else if (strlen(hdr[0]) != WS_CKEY_LEN) {
+            txn->error.desc = "Invalid WebSocket client key";
+            return HTTP_BAD_REQUEST;
+        }
+
+        /* Create WebSocket accept key */
+        buf_setcstr(&txn->buf, hdr[0]);
+        buf_appendcstr(&txn->buf, WS_GUID);
+        xsha1((u_char *) buf_base(&txn->buf), buf_len(&txn->buf), sha1buf);
+
+        buf_ensure(&txn->buf, WS_AKEY_LEN+1);
+        accept = buf_base(&txn->buf);
+
+        r = sasl_encode64((char *) sha1buf, SHA1_DIGEST_LENGTH,
+                          (char *) accept, WS_AKEY_LEN+1, NULL);
+        if (r != SASL_OK) syslog(LOG_WARNING, "sasl_encode64: %d", r);
+    }
+
+    /* Create server context */
+    r = wslay_event_context_server_init(&ev, &callbacks, txn);
+    if (r) {
+        syslog(LOG_WARNING,
+               "wslay_event_context_init: %s", wslay_strerror(r));
+        return HTTP_SERVER_ERROR;
+    }
+
+    /* Create channel context */
+    ctx = xzmalloc(sizeof(struct ws_context));
+    ctx->event = ev;
+    ctx->accept = accept;
+    ctx->protocol = protocol;
+    ctx->data_cb = data_cb;
+    txn->ws_ctx = ctx;
+
+    /* Check for supported WebSocket extensions */
+    parse_extensions(txn);
+
+    /* Prepare log buffer */
+
+    /* Add client data */
+    buf_printf(&ctx->log, "%s", txn->conn->clienthost);
+    if (httpd_userid) buf_printf(&ctx->log, " as \"%s\"", httpd_userid);
+    if ((hdr = spool_getheader(txn->req_hdrs, "User-Agent"))) {
+        buf_printf(&ctx->log, " with \"%s\"", hdr[0]);
+        if ((hdr = spool_getheader(txn->req_hdrs, "X-Client")))
+            buf_printf(&ctx->log, " by \"%s\"", hdr[0]);
+        else if ((hdr = spool_getheader(txn->req_hdrs, "X-Requested-With")))
+            buf_printf(&ctx->log, " by \"%s\"", hdr[0]);
+    }
+
+    /* Add request-line */
+    buf_printf(&ctx->log, "; \"WebSocket/%s via %s\"",
+               protocol ? protocol : "echo" , txn->req_line.ver);
+    ctx->log_tail = buf_len(&ctx->log);
+
+    /* Tell client that WebSocket negotiation has succeeded */
+    if (txn->conn->sess_ctx) {
+        /* Treat WS data as chunked response */
+        txn->flags.te = TE_CHUNKED;
+
+        response_header(HTTP_OK, txn);
+
+        /* Force the response to the client immediately */
+        prot_flush(httpd_out);
+    }
+    else response_header(HTTP_SWITCH_PROT, txn);
+
+    /* Set connection as non-blocking */
+    prot_NONBLOCK(txn->conn->pin);
+
+    /* Don't do telemetry logging in prot layer */
+    prot_setlog(txn->conn->pin, PROT_NO_FD);
+    prot_setlog(txn->conn->pout, PROT_NO_FD);
+
+    return 0;
+}
+
+
+HIDDEN void ws_add_resp_hdrs(struct transaction_t *txn)
+{
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+
+    if (!ctx) {
+        simple_hdr(txn, "Sec-WebSocket-Version", "%s", WS_VERSION);
+        return;
+    }
+
+    if (ctx->accept) {
+        simple_hdr(txn, "Sec-WebSocket-Accept", "%s", ctx->accept);
+    }
+
+    if (ctx->protocol) {
+        simple_hdr(txn, "Sec-WebSocket-Protocol", "%s", ctx->protocol);
+    }
+
+    if (ctx->ext & EXT_PMCE_DEFLATE) {
+        simple_hdr(txn, "Sec-WebSocket-Extensions",
+                   "permessage-deflate%s; server_max_window_bits=%u",
+                   ctx->pmce.deflate.no_context ?
+                   "; server_no_context_takeover" : "",
+                   ctx->pmce.deflate.max_wbits);
+    }
+}
+
+
+HIDDEN void ws_end_channel(void *ws_ctx)
+{
+    struct ws_context *ctx = (struct ws_context *) ws_ctx;
+
+    if (!ctx) return;
+    
+    wslay_event_context_free(ctx->event);
+    buf_free(&ctx->log);
+
+    if (ctx->cb_rock) ctx->data_cb(NULL, NULL, NULL, &ctx->cb_rock);
+
+    if (ctx->pmce.deflate.zstrm) {
+        inflateEnd(ctx->pmce.deflate.zstrm);
+        free(ctx->pmce.deflate.zstrm);
+    }
+
+    free(ctx);
+}
+
+
+HIDDEN void ws_output(struct transaction_t *txn)
+{
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+    wslay_event_context_ptr ev = ctx->event;
+    int want_write = wslay_event_want_write(ev);
+
+    syslog(LOG_DEBUG, "ws_output()  eof: %d, want write: %d",
+           txn->conn->pin->eof, want_write);
+
+    if (want_write) {
+        /* Send queued frame(s) */
+        int r = wslay_event_send(ev);
+        if (r) {
+            syslog(LOG_ERR, "wslay_event_send: %s", wslay_strerror(r));
+            txn->flags.conn = CONN_CLOSE;
+        }
+    }
+}
+
+
+HIDDEN void ws_input(struct transaction_t *txn)
+{
+    struct ws_context *ctx = (struct ws_context *) txn->ws_ctx;
+    wslay_event_context_ptr ev = ctx->event;
+    int want_read = wslay_event_want_read(ev);
+    int want_write = wslay_event_want_write(ev);
+    int goaway = txn->flags.conn & CONN_CLOSE;
+
+    syslog(LOG_DEBUG, "ws_input()  eof: %d, want read: %d, want write: %d",
+           txn->conn->pin->eof, want_read, want_write);
+
+    if (want_read && !goaway) {
+        /* Read frame(s) */
+        if (txn->conn->sess_ctx) {
+            /* Data has been read into request body */
+            ctx->h2_pin = prot_readmap(buf_base(&txn->req_body.payload),
+                                       buf_len(&txn->req_body.payload));
+        }
+
+        int r = wslay_event_recv(ev);
+
+        if (txn->conn->sess_ctx) {
+            buf_reset(&txn->req_body.payload);
+            prot_free(ctx->h2_pin);
+        }
+
+        if (!r) {
+            /* Successfully received frames */
+            syslog(LOG_DEBUG, "ws_event_recv: success");
+        }
+        else if (r == WSLAY_ERR_NO_MORE_MSG) {
+            /* Client closed connection */
+            syslog(LOG_DEBUG, "client closed connection");
+            txn->flags.conn = CONN_CLOSE;
+        }
+        else {
+            /* Failure */
+            syslog(LOG_DEBUG, "ws_event_recv: %s (%s)",
+                   wslay_strerror(r), prot_error(txn->conn->pin));
+            goaway = 1;
+
+            if (r == WSLAY_ERR_CALLBACK_FAILURE) {
+                /* Client timeout */
+                txn->error.desc = prot_error(txn->conn->pin);
+            }
+            else {
+                txn->error.desc = wslay_strerror(r);
+            }
+        }
+    }
+    else if (!want_write) {
+        /* Connection is done */
+        syslog(LOG_DEBUG, "connection closed");
+        txn->flags.conn = CONN_CLOSE;
+    }
+
+    if (goaway) {
+        /* Tell client we are closing session */
+        syslog(LOG_WARNING, "%s, closing connection", txn->error.desc);
+
+        syslog(LOG_DEBUG, "wslay_event_queue_close()");
+        int r = wslay_event_queue_close(ev, WSLAY_CODE_GOING_AWAY,
+                                        (uint8_t *) txn->error.desc,
+                                        strlen(txn->error.desc));
+        if (r) {
+            syslog(LOG_ERR,
+                   "wslay_event_queue_close: %s", wslay_strerror(r));
+        }
+
+        txn->flags.conn = CONN_CLOSE;
+    }
+
+    /* Write frame(s) */
+    ws_output(txn);
+
+    return;
+}
+
+#else /* !HAVE_WSLAY */
+
+HIDDEN void ws_init(struct buf *serverinfo __attribute__((unused))) {}
+
+HIDDEN int ws_enabled()
+{
+    return 0;
+}
+
+HIDDEN void ws_done() {}
+
+HIDDEN int ws_start_channel(struct transaction_t *txn __attribute__((unused)),
+                            const char *protocol __attribute__((unused)),
+                            int (*data_cb)(struct buf *inbuf,
+                                           struct buf *outbuf,
+                                           struct buf *logbuf,
+                                           void **rock) __attribute__((unused)))
+{
+    fatal("ws_start() called, but no Wslay", EX_SOFTWARE);
+}
+
+HIDDEN void ws_add_resp_hdrs(struct transaction_t *txn __attribute__((unused)))
+{
+}
+
+HIDDEN void ws_end_channel(void *ws_ctx __attribute__((unused))) {}
+
+HIDDEN void ws_output(struct transaction_t *txn __attribute__((unused)))
+{
+    fatal("ws_output() called, but no Wslay", EX_SOFTWARE);
+}
+
+HIDDEN void ws_input(struct transaction_t *txn __attribute__((unused)))
+{
+    fatal("ws_input() called, but no Wslay", EX_SOFTWARE);
+}
+
+#endif /* HAVE_WSLAY */
diff -pruN 3.0.13-5/imap/http_ws.h 3.2.0-3/imap/http_ws.h
--- 3.0.13-5/imap/http_ws.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/http_ws.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,82 @@
+/* httpd_ws.h -WebSocket support functions
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef HTTPD_WS_H
+#define HTTPD_WS_H
+
+#include <config.h>
+
+#ifdef HAVE_WSLAY
+#include <wslay/wslay.h>
+
+/* Supported WebSocket version for Upgrade */
+#define WS_TOKEN         "websocket"
+#define WS_VERSION       "13"
+
+#else /* !HAVE_WSLAY */
+
+#define WS_TOKEN         ""
+#define WS_VERSION       ""
+
+#endif /* HAVE_WSLAY */
+
+
+extern void ws_init(struct buf *serverinfo);
+
+extern int ws_enabled();
+
+extern void ws_done();
+
+extern int ws_start_channel(struct transaction_t *txn, const char *sub_prot,
+                            int (*data_cb)(struct buf *inbuf, struct buf *outbuf,
+                                           struct buf *logbuf, void **rock));
+
+extern void ws_add_resp_hdrs(struct transaction_t *txn);
+
+extern void ws_end_channel(void *ws_ctx);
+
+extern void ws_output(struct transaction_t *txn);
+
+extern void ws_input(struct transaction_t *txn);
+
+#endif /* HTTPD_WS_H */
diff -pruN 3.0.13-5/imap/ical_apply_patch.c 3.2.0-3/imap/ical_apply_patch.c
--- 3.0.13-5/imap/ical_apply_patch.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/ical_apply_patch.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,53 @@
+/*
+ * Program for testing VPATCH application
+ */
+
+#include <stdio.h>
+#include <libical/ical.h>
+
+#include "ical_support.h"
+
+extern int optind, opterr;
+extern char *optarg;
+
+static char *read_stream(char *s, size_t size, void *d)
+{
+    return fgets(s, (int) size, (FILE*) d);
+}
+
+static icalcomponent *parse_file(const char *fname)
+{
+     icalcomponent *component = NULL;
+     FILE *stream = fopen(fname, "r");
+
+     if (!stream) return NULL;
+
+     icalparser *parser = icalparser_new();
+     icalparser_set_gen_data(parser, stream);
+
+     component = icalparser_parse(parser, read_stream);
+
+     icalparser_free(parser);
+     fclose(stream);
+
+     return component;
+ }
+
+int main(int argc, char *argv[])
+{
+    if (argc < 3) {
+        fprintf(stderr, "usage: %s <VCALENDAR_file> <VPATCH_file>\n", argv[0]);
+        exit(0);
+    }
+
+    icalcomponent *resource = parse_file(argv[1]);
+    icalcomponent *patch = parse_file(argv[2]);
+
+    icalcomponent_apply_vpatch(resource, patch, NULL, NULL);
+
+    printf("%s", icalcomponent_as_ical_string(resource));
+    icalcomponent_free(resource);
+    icalcomponent_free(patch);
+
+    exit(0);
+}
diff -pruN 3.0.13-5/imap/ical_support.c 3.2.0-3/imap/ical_support.c
--- 3.0.13-5/imap/ical_support.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ical_support.c	2020-05-04 03:28:02.000000000 +0000
@@ -44,14 +44,89 @@
 #include <config.h>
 
 #include <string.h>
+#include <sysexits.h>
+#include <syslog.h>
 
+
+#include "assert.h"
 #include "caldav_db.h"
+#include "global.h"
 #include "ical_support.h"
 #include "message.h"
+#include "strhash.h"
 #include "util.h"
 
 #ifdef HAVE_ICAL
 
+EXPORTED void ical_support_init(void)
+{
+    /* Initialize timezones path */
+    const char *tzpath = config_getstring(IMAPOPT_ZONEINFO_DIR);
+    icalarray *timezones;
+
+    if (tzpath) {
+        syslog(LOG_NOTICE, "using timezone data from zoneinfo_dir=%s", tzpath);
+        icaltimezone_set_zone_directory((char *) tzpath);
+        icaltimezone_set_tzid_prefix("");
+        icaltimezone_set_builtin_tzdata(1);
+    }
+    else {
+        syslog(LOG_NOTICE, "zoneinfo_dir is unset, libical will find "
+                           "its own timezone data");
+    }
+
+    /* make sure libical actually finds some timezone data! */
+    assert(icalerrno == 0);
+    timezones = icaltimezone_get_builtin_timezones();
+    if (icalerrno != 0) {
+        syslog(LOG_ERR, "libical error while loading timezones: %s",
+                        icalerror_strerror(icalerrno));
+    }
+
+    if (timezones->num_elements == 0) {
+        fatal("No timezones found! Please check/set zoneinfo_dir in imapd.conf",
+              EX_CONFIG);
+    }
+
+    if (config_debug) {
+        size_t i;
+
+        syslog(LOG_DEBUG, "%s: found " SIZE_T_FMT " timezones",
+                          __func__, timezones->num_elements);
+        for (i = 0; i < timezones->num_elements; i++) {
+            icaltimezone *tz = icalarray_element_at(timezones, i);
+            char *tzid = xstrdupsafe(icaltimezone_get_tzid(tz));
+            char *location = xstrdupsafe(icaltimezone_get_location(tz));
+            syslog(LOG_DEBUG, "%s: [" SIZE_T_FMT "] tzid=%s location=%s",
+                              __func__, i, tzid, location);
+            free(location);
+            free(tzid);
+        }
+    }
+}
+
+EXPORTED int cyrus_icalrestriction_check(icalcomponent *ical)
+{
+    icalcomponent *vtz;
+
+    /* Strip COMMENT properties from VTIMEZONEs */
+    /* XXX  These were added by KSM in a previous version of vzic,
+       but libical doesn't allow them in its restrictions checks */
+    for (vtz = icalcomponent_get_first_component(ical, ICAL_VTIMEZONE_COMPONENT);
+         vtz;
+         vtz = icalcomponent_get_next_component(ical, ICAL_VTIMEZONE_COMPONENT)) {
+        icalproperty *prop =
+            icalcomponent_get_first_property(vtz, ICAL_COMMENT_PROPERTY);
+
+        if (prop) {
+            icalcomponent_remove_property(vtz, prop);
+            icalproperty_free(prop);
+        }
+    }
+
+    return icalrestriction_check(ical);
+}
+
 #if (SIZEOF_TIME_T > 4)
 static time_t epoch    = (time_t) LONG_MIN;
 static time_t eternity = (time_t) LONG_MAX;
@@ -67,7 +142,7 @@ struct recurrence_data {
     icaltime_span span; /* for sorting, etc */
 };
 
-const char *icalparameter_get_value_as_string(icalparameter *param)
+EXPORTED const char *icalparameter_get_value_as_string(icalparameter *param)
 {
     char *buf;
 
@@ -79,7 +154,7 @@ const char *icalparameter_get_value_as_s
     return buf;
 }
 
-struct icaldatetimeperiodtype
+EXPORTED struct icaldatetimeperiodtype
 icalproperty_get_datetimeperiod(icalproperty *prop)
 {
     struct icaldatetimeperiodtype ret = { icaltime_null_time(),
@@ -120,6 +195,35 @@ icalproperty_get_datetimeperiod(icalprop
     return ret;
 }
 
+static struct icaltimetype icalcomponent_get_mydatetime(icalcomponent *comp, icalproperty *prop)
+{
+    icalcomponent *c;
+    icalparameter *param;
+    struct icaltimetype ret;
+
+    ret = icalvalue_get_datetime(icalproperty_get_value(prop));
+
+    if ((param = icalproperty_get_first_parameter(prop, ICAL_TZID_PARAMETER)) != NULL) {
+        const char *tzid = icalparameter_get_tzid(param);
+        icaltimezone *tz = NULL;
+
+        for (c = comp; c != NULL; c = icalcomponent_get_parent(c)) {
+            tz = icalcomponent_get_timezone(c, tzid);
+            if (tz != NULL)
+                break;
+        }
+
+        if (tz == NULL)
+            tz = icaltimezone_get_builtin_timezone_from_tzid(tzid);
+
+        if (tz != NULL)
+            ret = icaltime_set_timezone(&ret, tz);
+    }
+
+    return ret;
+}
+
+
 
 static int sort_overrides(const void *ap, const void *bp)
 {
@@ -187,7 +291,7 @@ static int span_compare_range(icaltime_s
     return 0; /* span overlaps range */
 }
 
-extern int icalcomponent_myforeach(icalcomponent *ical,
+EXPORTED int icalcomponent_myforeach(icalcomponent *ical,
                                    struct icalperiodtype range,
                                    const icaltimezone *floatingtz,
                                    int (*callback) (icalcomponent *comp,
@@ -282,7 +386,7 @@ extern int icalcomponent_myforeach(icalc
              prop;
              prop = icalcomponent_get_next_property(mastercomp,
                                                     ICAL_EXDATE_PROPERTY)) {
-            struct icaltimetype exdate = icalproperty_get_exdate(prop);
+            struct icaltimetype exdate = icalcomponent_get_mydatetime(mastercomp, prop);
             _add_override(overrides, exdate, exdate, NULL, floatingtz);
         }
     }
@@ -329,11 +433,9 @@ extern int icalcomponent_myforeach(icalc
 
             if (!span_compare_range(&recur_span, &range_span)) {
                 rrule_itr = icalrecur_iterator_new(recur, dtstart);
-#ifdef HAVE_RECUR_ITERATOR_START
-                if (icaltime_compare(range.start, dtstart) > 0) {
+                if (rrule_itr && (recur.count > 0)) {
                     icalrecur_iterator_set_start(rrule_itr, range.start);
                 }
-#endif
             }
         }
     }
@@ -394,13 +496,54 @@ extern int icalcomponent_myforeach(icalc
     return 0;
 }
 
+EXPORTED icalcomponent *icalcomponent_new_stream(struct mailbox *mailbox,
+                                                 const char *prodid,
+                                                 const char *name,
+                                                 const char *desc,
+                                                 const char *color)
+{
+    struct buf buf = BUF_INITIALIZER;
+    icalcomponent *ical;
+    icalproperty *prop;
+
+    buf_printf(&buf, "%x-%s-%u", strhash(config_servername),
+               mailbox->uniqueid, mailbox->i.uidvalidity);
 
-icalcomponent *ical_string_as_icalcomponent(const struct buf *buf)
+    ical = icalcomponent_vanew(ICAL_VCALENDAR_COMPONENT,
+                               icalproperty_new_version("2.0"),
+                               icalproperty_new_prodid(prodid),
+                               icalproperty_new_uid(buf_cstring(&buf)),
+                               icalproperty_new_lastmodified(
+                                   icaltime_from_timet_with_zone(mailbox->index_mtime,
+                                                                 0, NULL)),
+                               icalproperty_new_name(name),
+                               0);
+
+    buf_free(&buf);
+
+    prop = icalproperty_new_x(name);
+    icalproperty_set_x_name(prop, "X-WR-CALNAME");
+    icalcomponent_add_property(ical, prop);
+
+    if (desc) {
+        prop = icalproperty_new_description(desc);
+        icalcomponent_add_property(ical, prop);
+    }
+
+    if (color) {
+        prop = icalproperty_new_color(color);
+        icalcomponent_add_property(ical, prop);
+    }
+
+    return ical;
+}
+
+EXPORTED icalcomponent *ical_string_as_icalcomponent(const struct buf *buf)
 {
     return icalparser_parse_string(buf_cstring(buf));
 }
 
-struct buf *my_icalcomponent_as_ical_string(icalcomponent* comp)
+EXPORTED struct buf *my_icalcomponent_as_ical_string(icalcomponent* comp)
 {
     char *str = icalcomponent_as_ical_string_r(comp);
     struct buf *ret = buf_new();
@@ -410,9 +553,9 @@ struct buf *my_icalcomponent_as_ical_str
     return ret;
 }
 
-icalcomponent *record_to_ical(struct mailbox *mailbox,
+EXPORTED icalcomponent *record_to_ical(struct mailbox *mailbox,
                               const struct index_record *record,
-                              char **schedule_userid)
+                              strarray_t *schedule_addresses)
 {
     icalcomponent *ical = NULL;
     message_t *m = message_new_from_record(mailbox, record);
@@ -424,20 +567,32 @@ icalcomponent *record_to_ical(struct mai
     }
 
     /* extract the schedule user header */
-    if (schedule_userid) {
+    if (schedule_addresses) {
         buf_reset(&buf);
         if (!message_get_field(m, "x-schedule-user-address",
                                MESSAGE_DECODED|MESSAGE_TRIM, &buf)) {
-            if (buf.len) *schedule_userid = buf_release(&buf);
+            if (buf.len) {
+                strarray_t *vals = strarray_split(buf_cstring(&buf), ",", STRARRAY_TRIM);
+                int i;
+                for (i = 0; i < strarray_size(vals); i++) {
+                    const char *email = strarray_nth(vals, i);
+                    if (!strncasecmp(email, "mailto:", 7)) email += 7;
+                    strarray_add(schedule_addresses, email);
+                }
+                strarray_free(vals);
+            }
         }
     }
 
+    /* Remove all X-LIC-ERROR properties */
+    if (ical) icalcomponent_strip_errors(ical);
+
     buf_free(&buf);
     message_unref(&m);
     return ical;
 }
 
-const char *get_icalcomponent_errstr(icalcomponent *ical)
+EXPORTED const char *get_icalcomponent_errstr(icalcomponent *ical)
 {
     icalcomponent *comp;
 
@@ -483,7 +638,8 @@ const char *get_icalcomponent_errstr(ica
 }
 
 
-void icalcomponent_remove_invitee(icalcomponent *comp, icalproperty *prop)
+EXPORTED void icalcomponent_remove_invitee(icalcomponent *comp,
+                                           icalproperty *prop)
 {
     if (icalcomponent_isa(comp) == ICAL_VPOLL_COMPONENT) {
         icalcomponent *vvoter = icalproperty_get_parent(prop);
@@ -498,7 +654,7 @@ void icalcomponent_remove_invitee(icalco
 }
 
 
-icalproperty *icalcomponent_get_first_invitee(icalcomponent *comp)
+EXPORTED icalproperty *icalcomponent_get_first_invitee(icalcomponent *comp)
 {
     icalproperty *prop;
 
@@ -515,7 +671,7 @@ icalproperty *icalcomponent_get_first_in
     return prop;
 }
 
-icalproperty *icalcomponent_get_next_invitee(icalcomponent *comp)
+EXPORTED icalproperty *icalcomponent_get_next_invitee(icalcomponent *comp)
 {
     icalproperty *prop;
 
@@ -532,7 +688,7 @@ icalproperty *icalcomponent_get_next_inv
     return prop;
 }
 
-const char *icalproperty_get_invitee(icalproperty *prop)
+EXPORTED const char *icalproperty_get_invitee(icalproperty *prop)
 {
     const char *recip;
 
@@ -547,7 +703,8 @@ const char *icalproperty_get_invitee(ica
 }
 
 
-icaltimetype icalcomponent_get_recurrenceid_with_zone(icalcomponent *comp)
+EXPORTED icaltimetype
+icalcomponent_get_recurrenceid_with_zone(icalcomponent *comp)
 {
     icalproperty *prop =
         icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY);
@@ -557,8 +714,8 @@ icaltimetype icalcomponent_get_recurrenc
 }
 
 
-icalproperty *icalcomponent_get_x_property_by_name(icalcomponent *comp,
-                                                   const char *name)
+EXPORTED icalproperty *icalcomponent_get_x_property_by_name(icalcomponent *comp,
+                                                            const char *name)
 {
     icalproperty *prop;
 
@@ -569,16 +726,51 @@ icalproperty *icalcomponent_get_x_proper
     return prop;
 }
 
+EXPORTED icaltimetype icaltime_convert_to_utc(const struct icaltimetype tt,
+                                              icaltimezone *floating_zone)
+{
+    icaltimezone *from_zone = (icaltimezone *) tt.zone;
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+    struct icaltimetype ret = tt;
+
+    /* If it's a date do nothing */
+    if (tt.is_date) {
+        return ret;
+    }
+
+    if (tt.zone == utc) {
+        return ret;
+    }
+
+    /* If it's a floating time use the passed in zone */
+    if (from_zone == NULL) {
+        from_zone = floating_zone;
+
+        if (from_zone == NULL) {
+            /* Leave the time as floating */
+            return ret;
+        }
+    }
+
+    icaltimezone_convert_time(&ret, from_zone, utc);
+    ret.zone = utc;
+
+    return ret;
+}
+
 
 /* Get time period (start/end) of a component based in RFC 4791 Sec 9.9 */
-struct icalperiodtype icalcomponent_get_utc_timespan(icalcomponent *comp,
-                                                     icalcomponent_kind kind)
+EXPORTED struct icalperiodtype
+icalcomponent_get_utc_timespan(icalcomponent *comp,
+                               icalcomponent_kind kind,
+                               icaltimezone *floating_tz)
 {
-    icaltimezone *utc = icaltimezone_get_utc_timezone();
     struct icalperiodtype period;
 
-    period.start = icaltime_convert_to_zone(icalcomponent_get_dtstart(comp), utc);
-    period.end   = icaltime_convert_to_zone(icalcomponent_get_dtend(comp), utc);
+    period.start = icaltime_convert_to_utc(icalcomponent_get_dtstart(comp),
+                                           floating_tz);
+    period.end   = icaltime_convert_to_utc(icalcomponent_get_dtend(comp),
+                                           floating_tz);
     period.duration = icaldurationtype_null_duration();
 
     switch (kind) {
@@ -597,9 +789,7 @@ struct icalperiodtype icalcomponent_get_
         }
         break;
 
-#ifdef HAVE_VPOLL
     case ICAL_VPOLL_COMPONENT:
-#endif
     case ICAL_VTODO_COMPONENT: {
         struct icaltimetype due = (kind == ICAL_VPOLL_COMPONENT) ?
             icalcomponent_get_dtend(comp) : icalcomponent_get_due(comp);
@@ -632,14 +822,14 @@ struct icalperiodtype icalcomponent_get_
                       icalcomponent_get_first_property(comp, ICAL_COMPLETED_PROPERTY))) {
                 /* Has COMPLETED */
                 period.start =
-                    icaltime_convert_to_zone(icalproperty_get_completed(prop), utc);
+                    icaltime_convert_to_utc(icalproperty_get_completed(prop), NULL);
                 memcpy(&period.end, &period.start, sizeof(struct icaltimetype));
 
                 if ((prop =
                      icalcomponent_get_first_property(comp, ICAL_CREATED_PROPERTY))) {
                     /* Has CREATED */
                     struct icaltimetype created =
-                        icaltime_convert_to_zone(icalproperty_get_created(prop), utc);
+                        icaltime_convert_to_utc(icalproperty_get_created(prop), NULL);
                     if (icaltime_compare(created, period.start) < 0)
                         memcpy(&period.start, &created, sizeof(struct icaltimetype));
                     if (icaltime_compare(created, period.end) > 0)
@@ -650,7 +840,7 @@ struct icalperiodtype icalcomponent_get_
                       icalcomponent_get_first_property(comp, ICAL_CREATED_PROPERTY))) {
                 /* Has CREATED */
                 period.start =
-                    icaltime_convert_to_zone(icalproperty_get_created(prop), utc);
+                    icaltime_convert_to_utc(icalproperty_get_created(prop), NULL);
                 period.end = icaltime_from_timet_with_zone(caldav_eternity, 0, NULL);
             }
             else {
@@ -739,12 +929,13 @@ static void utc_timespan_cb(icalcomponen
 }
 
 /* Determine the UTC time span of all components within ical of type kind. */
-struct icalperiodtype icalrecurrenceset_get_utc_timespan(icalcomponent *ical,
-                                                         icalcomponent_kind kind,
-                                                         unsigned *is_recurring,
-                                                         void (*comp_cb)(icalcomponent*,
-                                                                         void*),
-                                                         void *cb_rock)
+EXPORTED struct icalperiodtype
+icalrecurrenceset_get_utc_timespan(icalcomponent *ical,
+                                   icalcomponent_kind kind,
+                                   icaltimezone *floating_tz,
+                                   unsigned *is_recurring,
+                                   void (*comp_cb)(icalcomponent*, void*),
+                                   void *cb_rock)
 {
     struct icalperiodtype span;
     icalcomponent *comp = icalcomponent_get_first_component(ical, kind);
@@ -760,7 +951,7 @@ struct icalperiodtype icalrecurrenceset_
         icalproperty *rrule;
 
         /* Get base dtstart and dtend */
-        period = icalcomponent_get_utc_timespan(comp, kind);
+        period = icalcomponent_get_utc_timespan(comp, kind, floating_tz);
 
         /* See if its a recurring event */
         rrule = icalcomponent_get_first_property(comp, ICAL_RRULE_PROPERTY);
@@ -832,177 +1023,847 @@ struct icalperiodtype icalrecurrenceset_
 
 EXPORTED void icaltime_set_utc(struct icaltimetype *t, int set)
 {
-#ifdef ICALTIME_HAS_IS_UTC
-    t->is_utc = set;
-#else
     icaltime_set_timezone(t, set ? icaltimezone_get_utc_timezone() : NULL);
-#endif
 }
 
 
-#ifndef HAVE_TZDIST_PROPS
+enum {
+    ACTION_UPDATE = 1,
+    ACTION_DELETE,
+    ACTION_SETPARAM
+};
 
-/* Functions to replace those not available in libical < v2.0 */
+enum {
+    SEGMENT_COMP = 1,
+    SEGMENT_PROP,
+    SEGMENT_PARAM
+};
 
-icalproperty *icalproperty_new_tzidaliasof(const char *v)
-{
-    icalproperty *prop = icalproperty_new_x(v);
-    icalproperty_set_x_name(prop, "TZID-ALIAS-OF");
-    return prop;
-}
+union match_criteria_t {
+    struct {
+        char *uid;                /* component UID (optional) */
+        icaltimetype rid;         /* component RECURRENCE-ID (optional) */
+    } comp;
+    struct {
+        char *param;              /* parameter name (optional) */
+        char *value;              /* prop/param value (optional) */
+        unsigned not:1;           /* not equal? */
+    } prop;
+};
 
-icalproperty *icalproperty_new_tzuntil(struct icaltimetype v)
-{
-    icalproperty *prop = icalproperty_new_x(icaltime_as_ical_string(v));
-    icalproperty_set_x_name(prop, "TZUNTIL");
-    return prop;
-}
+struct path_segment_t {
+    unsigned type;                    /* Is it comp, prop, or param segment? */
+    unsigned kind;                    /* libical kind of comp, prop, or param */
+    union match_criteria_t match;     /* match criteria (depends on 'type') */
+    unsigned action;                  /* patch action (create,update,setparam)*/
+    void *data;                       /* patch data (depends on 'action') */
 
-#endif /* HAVE_TZDIST_PROPS */
+    struct path_segment_t *sibling;
+    struct path_segment_t *child;
+};
 
+struct patch_data_t {
+    icalcomponent *patch;             /* component containing patch data */
+    struct path_segment_t *delete;    /* list of PATCH-DELETE actions */
+    struct path_segment_t *setparam;  /* list of PATCH-PARAMETER items */
+};
 
-#ifndef HAVE_VALARM_EXT_PROPS
+static int parse_target_path(char *path, struct path_segment_t **path_seg,
+                             unsigned action, void *data,
+                             const char **errstr)
+{
+    char *p, sep;
+    struct path_segment_t *tail = NULL, *new;
+
+    for (sep = *path++; sep == '/';) {
+        p = path + strcspn(path, "[/#");
+        if ((sep = *p)) *p++ = '\0';
+
+        new = xzmalloc(sizeof(struct path_segment_t));
+        new->type = SEGMENT_COMP;
+        new->kind = icalcomponent_string_to_kind(path);
+        /* Initialize RID as invalid time rather than NULL time
+           since NULL time is used for empty RID (master component) */
+        new->match.comp.rid.year = -1;
+
+        if (!*path_seg) *path_seg = new;
+        else tail->child = new;
+        tail = new;
+
+        path = p;
+
+        if (sep == '[') {
+            /* Parse comp-match */
+            const char *prefix = "UID=";
+            size_t prefix_len = strlen(prefix);
+
+            if (!(p = strchr(path, ']'))) {
+                *errstr = "Badly formatted comp-match";
+                return -1;
+            }
 
-/* Functions to replace those not available in libical < v1.0 */
+            /* Parse uid-match */
+            if (!strncmp(path, prefix, prefix_len)) {
+                path += prefix_len;
+                *p++ = '\0';
+                new->match.comp.uid = xstrdup(path);
+                sep = *p++;
+                path = p;
+            }
 
-icalproperty *icalproperty_new_acknowledged(struct icaltimetype v)
-{
-    icalproperty *prop = icalproperty_new_x(icaltime_as_ical_string(v));
-    icalproperty_set_x_name(prop, "ACKNOWLEDGED");
-    return prop;
-}
+            /* Parse rid-match */
+            if (sep == '[') {
+                prefix = "RID=";
+                prefix_len = strlen(prefix);
+
+                if (strncmp(path, prefix, prefix_len) ||
+                    !(p = strchr(path, ']'))) {
+                    *errstr = "Badly formatted rid-match";
+                    return -1;
+                }
 
-void icalproperty_set_acknowledged(icalproperty *prop, struct icaltimetype v)
-{
-    icalproperty_set_x(prop, icaltime_as_ical_string(v));
-}
+                path += prefix_len;
+                *p++ = '\0';
+                if (*path && strcmp(path, "M")) {
+                    new->match.comp.rid = icaltime_from_string(path);
+                    if (icaltime_is_null_time(new->match.comp.rid)) {
+                        *errstr = "Invalid recurrence-id";
+                        return -1;
+                    }
+                }
+                else new->match.comp.rid = icaltime_null_time();
 
-struct icaltimetype icalproperty_get_acknowledged(const icalproperty *prop)
-{
-    return icaltime_from_string(icalproperty_get_x(prop));
-}
+                sep = *p++;
+                path = p;
+            }
+        }
+    }
 
-#endif /* HAVE_VALARM_EXT_PROPS */
+    if (sep == '#' && !*path_seg) {
+        /* Parse prop-segment */
+        p = path + strcspn(path, "[;=");
+        if ((sep = *p)) *p++ = '\0';
+
+        new = xzmalloc(sizeof(struct path_segment_t));
+        new->type = SEGMENT_PROP;
+        new->kind = icalproperty_string_to_kind(path);
+
+        if (!*path_seg) *path_seg = new;
+        else tail->child = new;
+        tail = new;
+
+        path = p;
+
+        if (sep == '[') {
+            /* Parse prop-match (MUST start with '=' or '!' or '@') */
+            if (strspn(path, "=!@") != 1 || !(p = strchr(path, ']'))) {
+                *errstr = "Badly formatted prop-match";
+                return -1;
+            }
 
+            *p++ = '\0';
+            if (*path == '@') {
+                /* Parse param-match */
+                size_t namelen = strcspn(++path, "!=");
+                new->match.prop.param = xstrndup(path, namelen);
+                path += namelen;
+            }
 
-#ifdef HAVE_IANA_PARAMS
+            if (*path) {
+                /* Parse prop/param [not]equal value */
+                if (*path++ == '!') new->match.prop.not = 1;
+                new->match.prop.value = xstrdup(path);
+            }
 
-#ifndef HAVE_MANAGED_ATTACH_PARAMS
+            sep = *p++;
+            path = p;
+        }
 
-icalparameter* icalproperty_get_iana_parameter_by_name(icalproperty *prop,
-                                                       const char *name)
-{
-    icalparameter *param;
+        if (sep == ';') {
+            /* Parse param-segment */
+            p = path + strcspn(path, "=");
+            if ((sep = *p)) *p++ = '\0';
 
-    for (param = icalproperty_get_first_parameter(prop, ICAL_IANA_PARAMETER);
-         param && strcmp(icalparameter_get_iana_name(param), name);
-         param = icalproperty_get_next_parameter(prop, ICAL_IANA_PARAMETER));
+            new = xzmalloc(sizeof(struct path_segment_t));
+            new->type = SEGMENT_PARAM;
+            new->kind = icalparameter_string_to_kind(path);
 
-    return param;
-}
+            tail->child = new;
+            tail = new;
 
-/* Functions to replace those not available in libical < v2.0 */
+            path = p;
+        }
 
-icalparameter *icalparameter_new_filename(const char *fname)
-{
-    icalparameter *param = icalparameter_new(ICAL_IANA_PARAMETER);
+        if (sep == '=' && action == ACTION_DELETE) {
+            /* Parse value-segment */
+            new->data = xstrdup(path);
+        }
+        else if (sep != '\0') {
+            *errstr = "Invalid separator following prop-segment";
+            return -1;
+        }
+    }
+    else if (sep != '\0') {
+        *errstr = "Invalid separator following comp-segment";
+        return -1;
+    }
 
-    icalparameter_set_iana_name(param, "FILENAME");
-    icalparameter_set_iana_value(param, fname);
+    tail->action = action;
+    if (!tail->data) tail->data = data;
 
-    return param;
+    return 0;
 }
 
-void icalparameter_set_filename(icalparameter *param, const char *fname)
+static void apply_patch(struct path_segment_t *path_seg,
+                        void *parent, int *num_changes);
+
+static char *remove_single_value(const char *oldstr, const char *single)
 {
-    icalparameter_set_iana_value(param, fname);
+    char *newstr = NULL;
+    strarray_t *values = strarray_split(oldstr, ",", STRARRAY_TRIM);
+    int idx = strarray_find(values, single, 0);
+
+    if (idx >= 0) {
+        /* Found the single value, remove it, and create new string */
+        strarray_remove(values, idx);
+        newstr = strarray_join(values, ",");
+    }
+    strarray_free(values);
+
+    return newstr;
 }
 
-icalparameter *icalparameter_new_managedid(const char *id)
+/* Apply a patch action to a parameter segment */
+static void apply_patch_parameter(struct path_segment_t *path_seg,
+                                  icalproperty *parent, int *num_changes)
 {
-    icalparameter *param = icalparameter_new(ICAL_IANA_PARAMETER);
+    icalparameter *param =
+        icalproperty_get_first_parameter(parent, path_seg->kind);
+    if (!param) return;
 
-    icalparameter_set_iana_name(param, "MANAGED-ID");
-    icalparameter_set_iana_value(param, id);
+    if (path_seg->action == ACTION_DELETE) {
+        switch (path_seg->kind) {
+        case ICAL_MEMBER_PARAMETER:
+            /* Multi-valued parameter */
+            if (path_seg->data) {
+                /* Check if entire parameter value == single value */
+                const char *single = (const char *) path_seg->data;
+                const char *param_val = icalparameter_get_value_as_string(param);
+
+                if (strcmp(param_val, single)) {
+                    /* Not an exact match, try to remove single value */
+                    char *newval = remove_single_value(param_val, single);
+                    if (newval) {
+                        *num_changes += 1;
+                        icalparameter_set_member(param, newval);
+                        free(newval);
+                    }
+                    break;
+                }
+            }
 
-    return param;
+            /* Fall through and delete entire parameter */
+            GCC_FALLTHROUGH
+
+        default:
+            *num_changes += 1;
+            icalproperty_remove_parameter_by_ref(parent, param);
+            break;
+        }
+    }
 }
 
-const char *icalparameter_get_managedid(icalparameter *param)
+static int apply_param_match(icalproperty *prop, union match_criteria_t *match)
 {
-    return icalparameter_get_iana_value(param);
+    icalparameter_kind kind;
+    icalparameter *param;
+    int ret = 1;
+
+    /* XXX  Need to handle X- parameters */
+
+    kind = icalparameter_string_to_kind(match->prop.param);
+    param = icalproperty_get_first_parameter(prop, kind);
+    if (!param) {
+        /* property doesn't have this parameter */
+        ret = match->prop.not;
+    }
+    else if (match->prop.value) {
+        const char *param_val = icalparameter_get_value_as_string(param);
+
+        ret = !strcmp(match->prop.value, param_val);
+        if (match->prop.not) ret = !ret;  /* invert */
+    }
+
+    return ret;
 }
 
-void icalparameter_set_managedid(icalparameter *param, const char *id)
+/* Apply a patch action to a property segment */
+static void apply_patch_property(struct path_segment_t *path_seg,
+                                 icalcomponent *parent, int *num_changes)
 {
-    icalparameter_set_iana_value(param, id);
+    icalproperty *prop, *nextprop;
+    icalparameter *param;
+
+    /* Iterate through each property */
+    for (prop = icalcomponent_get_first_property(parent, path_seg->kind);
+         prop; prop = nextprop) {
+        nextprop = icalcomponent_get_next_property(parent, path_seg->kind);
+
+        /* Check prop-match */
+        int match = 1;
+        if (path_seg->match.prop.param) {
+            /* Check param-match */
+            match = apply_param_match(prop, &path_seg->match);
+        }
+        else if (path_seg->match.prop.value) {
+            /* Check prop-[not-]equal */
+            const char *prop_val = icalproperty_get_value_as_string(prop);
+
+            match = !strcmp(path_seg->match.prop.value, prop_val);
+            if (path_seg->match.prop.not) match = !match;  /* invert */
+        }
+        if (!match) continue;
+
+        if (path_seg->child) {
+            /* Recurse into next segment */
+            apply_patch(path_seg->child, prop, num_changes);
+        }
+        else if (path_seg->action == ACTION_DELETE) {
+            /* Delete existing property */
+            switch (path_seg->kind) {
+            case ICAL_RDATE_PROPERTY:
+            case ICAL_EXDATE_PROPERTY:
+            case ICAL_FREEBUSY_PROPERTY:
+            case ICAL_CATEGORIES_PROPERTY:
+            case ICAL_RESOURCES_PROPERTY:
+            case ICAL_ACCEPTRESPONSE_PROPERTY:
+            case ICAL_POLLPROPERTIES_PROPERTY:
+                /* Multi-valued property */
+                if (path_seg->data) {
+                    /* Check if entire property value == single value */
+                    const char *single = (const char *) path_seg->data;
+                    const char *propval = icalproperty_get_value_as_string(prop);
+
+                    if (strcmp(propval, single)) {
+                        /* Not an exact match, try to remove single value */
+                        char *newval = remove_single_value(propval, single);
+                        if (newval) {
+                            *num_changes += 1;
+                            icalproperty_set_value(prop,
+                                                   icalvalue_new_string(newval));
+                            free(newval);
+                        }
+                        break;
+                    }
+                }
+
+                /* Fall through and delete entire property */
+                GCC_FALLTHROUGH
+
+            default:
+                *num_changes += 1;
+                icalcomponent_remove_property(parent, prop);
+                icalproperty_free(prop);
+                break;
+            }
+        }
+        else if (path_seg->action == ACTION_SETPARAM) {
+            /* Set parameter(s) from those on PATCH-PARAMETER */
+            icalproperty *pp_prop = (icalproperty *) path_seg->data;
+
+            *num_changes += 1;
+            for (param = icalproperty_get_first_parameter(pp_prop,
+                                                          ICAL_ANY_PARAMETER);
+                 param;
+                 param = icalproperty_get_next_parameter(pp_prop,
+                                                         ICAL_ANY_PARAMETER)) {
+                icalproperty_set_parameter(prop, icalparameter_clone(param));
+            }
+        }
+    }
 }
 
-icalparameter *icalparameter_new_size(const char *sz)
+static void create_override(icalcomponent *master, struct icaltime_span *span,
+                            void *rock)
 {
-    icalparameter *param = icalparameter_new(ICAL_IANA_PARAMETER);
+    icalcomponent *new;
+    icalproperty *prop, *next;
+    struct icaltimetype dtstart, dtend, now;
+    const icaltimezone *tz = NULL;
+    const char *tzid;
+    int is_date;
+
+    now = icaltime_current_time_with_zone(icaltimezone_get_utc_timezone());
+
+    new = icalcomponent_clone(master);
+
+    for (prop = icalcomponent_get_first_property(new, ICAL_ANY_PROPERTY);
+         prop; prop = next) {
+        next = icalcomponent_get_next_property(new, ICAL_ANY_PROPERTY);
+
+        switch (icalproperty_isa(prop)) {
+        case ICAL_DTSTART_PROPERTY:
+            /* Set DTSTART for this recurrence */
+            dtstart = icalproperty_get_dtstart(prop);
+            is_date = icaltime_is_date(dtstart);
+            tz = icaltime_get_timezone(dtstart);
+
+            dtstart = icaltime_from_timet_with_zone(span->start, is_date, tz);
+            icaltime_set_timezone(&dtstart, tz);
+            icalproperty_set_dtstart(prop, dtstart);
+
+            /* Add RECURRENCE-ID for this recurrence */
+            prop = icalproperty_new_recurrenceid(dtstart);
+            tzid = icaltimezone_get_tzid((icaltimezone *) tz);
+            if (tzid) {
+                icalproperty_add_parameter(prop, icalparameter_new_tzid(tzid));
+            }
+            icalcomponent_add_property(new, prop);
+            break;
+
+        case ICAL_DTEND_PROPERTY:
+            /* Set DTEND for this recurrence */
+            dtend = icalproperty_get_dtend(prop);
+            is_date = icaltime_is_date(dtend);
+            tz = icaltime_get_timezone(dtend);
+
+            dtend = icaltime_from_timet_with_zone(span->end, is_date, tz);
+            icaltime_set_timezone(&dtend, tz);
+            icalproperty_set_dtend(prop, dtend);
+            break;
+
+        case ICAL_RRULE_PROPERTY:
+        case ICAL_RDATE_PROPERTY:
+        case ICAL_EXDATE_PROPERTY:
+            /* Remove recurrence properties */
+            icalcomponent_remove_property(new, prop);
+            icalproperty_free(prop);
+            break;
+
+        case ICAL_DTSTAMP_PROPERTY:
+            /* Update DTSTAMP */
+            icalproperty_set_dtstamp(prop, now);
+            break;
+
+        case ICAL_CREATED_PROPERTY:
+            /* Update CREATED */
+            icalproperty_set_created(prop, now);
+            break;
+
+        case ICAL_LASTMODIFIED_PROPERTY:
+            /* Update LASTMODIFIED */
+            icalproperty_set_lastmodified(prop, now);
+            break;
+
+        default:
+            break;
+        }
+    }
+
+    *((icalcomponent **) rock) = new;
+}
+
+/* Apply property updates */
+static void apply_property_updates(struct patch_data_t *patch,
+                                   icalcomponent *parent, int *num_changes)
+{
+    icalproperty *prop = NULL, *nextprop, *newprop;
+
+    for (newprop = icalcomponent_get_first_property(patch->patch,
+                                                    ICAL_ANY_PROPERTY);
+         newprop;
+         newprop = icalcomponent_get_next_property(patch->patch,
+                                                   ICAL_ANY_PROPERTY)) {
+        icalproperty_kind kind = icalproperty_isa(newprop);
+        icalparameter_patchaction action = ICAL_PATCHACTION_BYNAME;
+        icalparameter *actionp;
+        union match_criteria_t byparam;
+
+        memset(&byparam, 0, sizeof(union match_criteria_t));
+        newprop = icalproperty_clone(newprop);
+
+        actionp = icalproperty_get_first_parameter(newprop,
+                                                   ICAL_PATCHACTION_PARAMETER);
+        if (actionp) {
+            action = icalparameter_get_patchaction(actionp);
+            if (action == ICAL_PATCHACTION_X) {
+                /* libical treats DQUOTEd BYPARAM as X value */
+                const char *byparam_prefix = "BYPARAM@";
+                const char *x_val = icalparameter_get_xvalue(actionp);
+                if (!strncmp(x_val, byparam_prefix, strlen(byparam_prefix))) {
+                    /* Parse param-match */
+                    const char *p = x_val + strlen(byparam_prefix);
+                    size_t namelen = strcspn(p, "!=");
+                    byparam.prop.param = xstrndup(p, namelen);
+                    p += namelen;
+
+                    if (*p) {
+                        if (*p++ == '!') byparam.prop.not = 1;
+                        byparam.prop.value = xstrdup(p);
+                    }
+                    action = ICAL_PATCHACTION_BYPARAM;
+                }
+            }
+
+            icalproperty_remove_parameter_by_ref(newprop, actionp);
+            icalparameter_free(actionp);
+        }
+
+        if (action != ICAL_PATCHACTION_CREATE) {
+            /* Delete properties matching those being updated */
+            const char *value = icalproperty_get_value_as_string(newprop);
+
+            for (prop = icalcomponent_get_first_property(parent, kind);
+                 prop; prop = nextprop) {
+                int match = 1;
 
-    icalparameter_set_iana_name(param, "SIZE");
-    icalparameter_set_iana_value(param, sz);
+                nextprop = icalcomponent_get_next_property(parent, kind);
 
-    return param;
+                if (action == ICAL_PATCHACTION_BYVALUE) {
+                    match = !strcmp(value,
+                                    icalproperty_get_value_as_string(prop));
+                }
+                else if (action == ICAL_PATCHACTION_BYPARAM) {
+                    /* Check param-match */
+                    match = apply_param_match(prop, &byparam);
+                    free(byparam.prop.param);
+                    free(byparam.prop.value);
+                }
+                if (!match) continue;
+
+                icalcomponent_remove_property(parent, prop);
+                icalproperty_free(prop);
+            }
+        }
+
+        *num_changes += 1;
+        icalcomponent_add_property(parent, newprop);
+    }
 }
 
-const char *icalparameter_get_size(icalparameter *param)
+/* Apply property updates */
+static void apply_component_updates(struct patch_data_t *patch,
+                                    icalcomponent *parent, int *num_changes)
 {
-    return icalparameter_get_iana_value(param);
+    icalcomponent *comp, *nextcomp, *newcomp;
+
+    for (newcomp = icalcomponent_get_first_component(patch->patch,
+                                                     ICAL_ANY_COMPONENT);
+         newcomp;
+         newcomp = icalcomponent_get_next_component(patch->patch,
+                                                    ICAL_ANY_COMPONENT)){
+        icalcomponent_kind kind = icalcomponent_isa(newcomp);
+        const char *uid = icalcomponent_get_uid(newcomp);
+        icaltimetype rid = icalcomponent_get_recurrenceid(newcomp);
+
+        newcomp = icalcomponent_clone(newcomp);
+
+        /* Delete components matching those being updated */
+        for (comp = icalcomponent_get_first_component(parent, kind);
+             uid && comp; comp = nextcomp) {
+            const char *thisuid = icalcomponent_get_uid(comp);
+
+            nextcomp = icalcomponent_get_next_component(parent, kind);
+
+            if (thisuid &&  /* VALARMs make not have a UID */
+                (strcmp(uid, thisuid) ||
+                 icaltime_compare(rid, icalcomponent_get_recurrenceid(comp)))) {
+                /* skip */
+                continue;
+            }
+
+            icalcomponent_remove_component(parent, comp);
+            icalcomponent_free(comp);
+        }
+
+        *num_changes += 1;
+        icalcomponent_add_component(parent, newcomp);
+    }
 }
 
-void icalparameter_set_size(icalparameter *param, const char *sz)
+/* Apply a patch action to a component segment */
+static void apply_patch_component(struct path_segment_t *path_seg,
+                                 icalcomponent *parent, int *num_changes)
 {
-    icalparameter_set_iana_value(param, sz);
-}
+    icalcomponent *comp, *nextcomp, *master = NULL;
+
+    /* Iterate through each component */
+    if (path_seg->kind == ICAL_VCALENDAR_COMPONENT)
+        comp = parent;
+    else
+        comp = icalcomponent_get_first_component(parent, path_seg->kind);
+
+    for (; comp; comp = nextcomp) {
+        nextcomp = icalcomponent_get_next_component(parent, path_seg->kind);
+
+        /* Check comp-match */
+        if (path_seg->match.comp.uid &&
+            strcmpnull(path_seg->match.comp.uid, icalcomponent_get_uid(comp))) {
+            continue;  /* UID doesn't match */
+        }
 
-#endif /* HAVE_MANAGED_ATTACH_PARAMS */
+        if (icaltime_is_valid_time(path_seg->match.comp.rid)) {
+            icaltimetype recurid =
+                icalcomponent_get_recurrenceid_with_zone(comp);
 
+            if (icaltime_is_null_time(recurid)) master = comp;
+            if (icaltime_compare(recurid, path_seg->match.comp.rid)) {
+                if (!nextcomp && master) {
+                    /* Possibly add an override recurrence.
+                       Set start and end to coincide with recurrence */
+                    icalcomponent *override = NULL;
+                    struct icaltimetype start = path_seg->match.comp.rid;
+                    struct icaltimetype end =
+                        icaltime_add(start, icalcomponent_get_duration(master));
+                    icalcomponent_foreach_recurrence(master, start, end,
+                                                     &create_override,
+                                                     &override);
+                    if (!override) break;  /* Can't override - done */
 
-#ifndef HAVE_SCHEDULING_PARAMS
+                    /* Act on new overridden component */
+                    icalcomponent_add_component(parent, override);
+                    comp = override;
+                }
+                else continue;  /* RECURRENCE-ID doesn't match */
+            }
+            else {
+                /* RECURRENCE-ID matches - done after processing this comp */
+                nextcomp = NULL;
+            }
+        }
 
-/* Functions to replace those not available in libical < v1.0 */
+        if (path_seg->child) {
+            /* Recurse into next segment */
+            apply_patch(path_seg->child, comp, num_changes);
+        }
+        else if (path_seg->action == ACTION_DELETE) {
+            /* Delete existing component */
+            *num_changes += 1;
+            icalcomponent_remove_component(parent, comp);
+            icalcomponent_free(comp);
+        }
+        else if (path_seg->action == ACTION_UPDATE) {
+            /* Patch existing component */
+            struct patch_data_t *patch = (struct patch_data_t *) path_seg->data;
+            struct path_segment_t *path_seg2;
+
+            /* Process all PATCH-DELETEs first */
+            for (path_seg2 = patch->delete;
+                 path_seg2; path_seg2 = path_seg2->sibling) {
+                apply_patch(path_seg2, comp, num_changes);
+            }
 
-icalparameter_scheduleagent
-icalparameter_get_scheduleagent(icalparameter *param)
+            /* Process all PATCH-SETPARAMETERs second */
+            for (path_seg2 = patch->setparam;
+                 path_seg2; path_seg2 = path_seg2->sibling) {
+                apply_patch(path_seg2, comp, num_changes);
+            }
+
+            /* Process all components updates third */
+            apply_component_updates(patch, comp, num_changes);
+
+            /* Process all property updates last */
+            apply_property_updates(patch, comp, num_changes);
+        }
+    }
+}
+
+/* Apply a patch action to a target segment */
+static void apply_patch(struct path_segment_t *path_seg,
+                        void *parent, int *num_changes)
 {
-    const char *agent = NULL;
+    switch (path_seg->type) {
+    case SEGMENT_COMP:
+        apply_patch_component(path_seg, parent, num_changes);
+        break;
 
-    if (param) agent = icalparameter_get_iana_value(param);
+    case SEGMENT_PROP:
+        apply_patch_property(path_seg, parent, num_changes);
+        break;
 
-    if (!agent) return ICAL_SCHEDULEAGENT_NONE;
-    else if (!strcmp(agent, "SERVER")) return ICAL_SCHEDULEAGENT_SERVER;
-    else if (!strcmp(agent, "CLIENT")) return ICAL_SCHEDULEAGENT_CLIENT;
-    else return ICAL_SCHEDULEAGENT_X;
+    case SEGMENT_PARAM:
+        apply_patch_parameter(path_seg, parent, num_changes);
+        break;
+    }
 }
 
-icalparameter_scheduleforcesend
-icalparameter_get_scheduleforcesend(icalparameter *param)
+static void path_segment_free(struct path_segment_t *path_seg)
 {
-    const char *force = NULL;
+    struct path_segment_t *next;
+
+    for (; path_seg; path_seg = next) {
+        next = path_seg->child;
 
-    if (param) force = icalparameter_get_iana_value(param);
+        switch (path_seg->type) {
+        case SEGMENT_COMP:
+            free(path_seg->match.comp.uid);
+            break;
 
-    if (!force) return ICAL_SCHEDULEFORCESEND_NONE;
-    else if (!strcmp(force, "REQUEST")) return ICAL_SCHEDULEFORCESEND_REQUEST;
-    else if (!strcmp(force, "REPLY")) return ICAL_SCHEDULEFORCESEND_REPLY;
-    else return ICAL_SCHEDULEFORCESEND_X;
+        case SEGMENT_PROP:
+            free(path_seg->match.prop.param);
+            free(path_seg->match.prop.value);
+            break;
+
+        case SEGMENT_PARAM:
+            break;
+        }
+
+        free(path_seg);
+    }
 }
 
-icalparameter *icalparameter_new_schedulestatus(const char *stat)
+EXPORTED int icalcomponent_apply_vpatch(icalcomponent *ical,
+                                        icalcomponent *vpatch,
+                                        int *num_changes, const char **errstr)
 {
-    icalparameter *param = icalparameter_new(ICAL_IANA_PARAMETER);
+    icalcomponent *patch;
+    icalproperty *prop, *nextprop;
+    int r, junkcount;
+    const char *junkerr;
+
+    if (!num_changes) num_changes = &junkcount;
+    if (!errstr) errstr = &junkerr;
+
+    /* Process each patch sub-component */
+    for (patch = icalcomponent_get_first_component(vpatch, ICAL_ANY_COMPONENT);
+         patch;
+         patch = icalcomponent_get_next_component(vpatch, ICAL_ANY_COMPONENT)) {
+        r = 0;
+
+        if (icalcomponent_isa(patch) != ICAL_XPATCH_COMPONENT) {
+            /* Unknown patch action */
+            *errstr = "Unsupported patch action";
+            r = -1;
+            goto done;
+        }
+
+        /* This function is destructive of PATCH components, make a clone */
+        patch = icalcomponent_clone(patch);
+
+        prop = icalcomponent_get_first_property(patch,
+                                                ICAL_PATCHTARGET_PROPERTY);
+        if (!prop) {
+            *errstr = "Missing TARGET";
+            r = -1;
+            goto done;
+        }
 
-    icalparameter_set_iana_name(param, "SCHEDULE-STATUS");
-    icalparameter_set_iana_value(param, stat);
+        /* Parse PATCH-TARGET */
+        char *path = xstrdup(icalproperty_get_patchtarget(prop));
+        struct path_segment_t *target = NULL, *next;
+        struct patch_data_t patch_data = { patch, NULL, NULL };
 
-    return param;
+        icalcomponent_remove_property(patch, prop);
+        icalproperty_free(prop);
+
+        r = parse_target_path(path, &target, ACTION_UPDATE, &patch_data, errstr);
+        free(path);
+
+        if (r) goto done;
+        else if (!target || target->type != SEGMENT_COMP ||
+                 target->kind != ICAL_VCALENDAR_COMPONENT ||
+                 target->match.comp.uid) {
+            *errstr = "Initial segment of PATCH-TARGET"
+                " MUST be an unmatched VCALENDAR";
+            r = -1;
+            goto done;
+        }
+
+        /* Parse and remove all PATCH-DELETEs and PATCH-PARAMETERs */
+        for (prop = icalcomponent_get_first_property(patch, ICAL_ANY_PROPERTY);
+             prop; prop = nextprop) {
+
+            icalproperty_kind kind = icalproperty_isa(prop);
+            struct path_segment_t *ppath = NULL;
+
+            nextprop = icalcomponent_get_next_property(patch, ICAL_ANY_PROPERTY);
+
+            if (kind == ICAL_PATCHDELETE_PROPERTY) {
+                path = xstrdup(icalproperty_get_patchdelete(prop));
+
+                icalcomponent_remove_property(patch, prop);
+                icalproperty_free(prop);
+
+                r = parse_target_path(path, &ppath, ACTION_DELETE, NULL, errstr);
+                free(path);
+
+                if (r) goto done;
+                else if (!ppath ||
+                         (ppath->type == SEGMENT_COMP &&
+                          ppath->kind == ICAL_VCALENDAR_COMPONENT)) {
+                    *errstr = "Initial segment of PATCH-DELETE"
+                        " MUST NOT be VCALENDAR";
+                    r = -1;
+                    goto done;
+                }
+                else {
+                    /* Add this delete path to our list */
+                    ppath->sibling = patch_data.delete;
+                    patch_data.delete = ppath;
+                }
+            }
+            else if (kind == ICAL_PATCHPARAMETER_PROPERTY) {
+                path = xstrdup(icalproperty_get_patchparameter(prop));
+
+                icalcomponent_remove_property(patch, prop);
+
+                r = parse_target_path(path, &ppath,
+                                      ACTION_SETPARAM, prop, errstr);
+                free(path);
+
+                if (r) goto done;
+                else if (!ppath || ppath->type != SEGMENT_PROP) {
+                    *errstr = "Initial segment of PATCH-PARAMETER"
+                        " MUST be a property";
+                    r = -1;
+                    goto done;
+                }
+                else {
+                    /* Add this setparam path to our list */
+                    ppath->sibling = patch_data.setparam;
+                    patch_data.setparam = ppath;
+                }
+            }
+        }
+
+        /* Apply this patch to the target component */
+        apply_patch(target, ical, num_changes);
+
+      done:
+        if (patch) icalcomponent_free(patch);
+        if (target) {
+            /* Cleanup target paths */
+            path_segment_free(target);
+            for (target = patch_data.delete; target; target = next) {
+                next = target->sibling;
+                if (target->data) free(target->data);
+                path_segment_free(target);
+            }
+            for (target = patch_data.setparam; target; target = next) {
+                next = target->sibling;
+                if (target->data) icalproperty_free(target->data);
+                path_segment_free(target);
+            }
+        }
+
+        if (r) return r;
+    }
+
+    return 0;
 }
 
-#endif /* HAVE_SCHEDULING_PARAMS */
 
-#endif /* HAVE_IANA_PARAMS */
+#ifndef HAVE_RFC7986_COLOR
+
+/* Replacement for missing function in 3.0.0 <= libical < 3.0.5 */
+
+EXPORTED icalproperty *icalproperty_new_color(const char *v)
+{
+    icalproperty *prop = icalproperty_new_x(v);
+    icalproperty_set_x_name(prop, "COLOR");
+    return prop;
+}
+
+#endif /* HAVE_RFC7986_COLOR */
 
 #endif /* HAVE_ICAL */
diff -pruN 3.0.13-5/imap/ical_support.h 3.2.0-3/imap/ical_support.h
--- 3.0.13-5/imap/ical_support.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ical_support.h	2020-04-24 02:03:00.000000000 +0000
@@ -49,9 +49,27 @@
 #ifdef HAVE_ICAL
 
 #include <libical/ical.h>
+#undef icalerror_warn
+#define icalerror_warn(message) \
+{syslog(LOG_WARNING, "icalerror: %s(), %s:%d: %s\n", __FUNCTION__, __FILE__, __LINE__, message);}
 
 #include "mailbox.h"
 
+#define PER_USER_CAL_DATA \
+    DAV_ANNOT_NS "<" XML_NS_CYRUS ">per-user-calendar-data"
+
+#ifndef HAVE_NEW_CLONE_API
+/* Allow us to compile without #ifdef HAVE_NEW_CLONE_API everywhere */
+#define icalcomponent_clone           icalcomponent_new_clone
+#define icalproperty_clone            icalproperty_new_clone
+#define icalparameter_clone           icalparameter_new_clone
+#endif
+
+/* Initialize libical timezones. */
+extern void ical_support_init(void);
+
+extern int cyrus_icalrestriction_check(icalcomponent *ical);
+
 extern const char *icalparameter_get_value_as_string(icalparameter *param);
 extern struct icaldatetimeperiodtype
 icalproperty_get_datetimeperiod(icalproperty *prop);
@@ -59,7 +77,10 @@ extern time_t icaltime_to_timet(icaltime
 
 /* If range is a NULL period, callback() is executed for ALL occurrences,
    otherwise callback() is only executed for occurrences that overlap the range.
-   callback() returns true (1) while it wants more occurrences, 0 to finish */
+   callback() returns true (1) while it wants more occurrences, 0 to finish.
+   If comp is a VCALENDAR then in addition to the main component, any embedded
+   component with RECURRENCE-ID is included in the occurrences.
+   If comp is a VEVENT or similar, only RRULE and RDATEs are considered. */
 extern int icalcomponent_myforeach(icalcomponent *comp,
                                    struct icalperiodtype range,
                                    const icaltimezone *floatingtz,
@@ -70,12 +91,18 @@ extern int icalcomponent_myforeach(icalc
                                    void *callback_data);
 
 
+extern icalcomponent *icalcomponent_new_stream(struct mailbox *mailbox,
+                                               const char *prodid,
+                                               const char *name,
+                                               const char *desc,
+                                               const char *color);
+
 extern icalcomponent *ical_string_as_icalcomponent(const struct buf *buf);
 extern struct buf *my_icalcomponent_as_ical_string(icalcomponent* comp);
 
 extern icalcomponent *record_to_ical(struct mailbox *mailbox,
                                      const struct index_record *record,
-                                     char **schedule_userid);
+                                     strarray_t *schedule_addresses);
 
 extern const char *get_icalcomponent_errstr(icalcomponent *ical);
 
@@ -91,68 +118,41 @@ extern icalproperty *icalcomponent_get_x
                                                           const char *name);
 
 extern struct icalperiodtype icalcomponent_get_utc_timespan(icalcomponent *comp,
-                                                            icalcomponent_kind kind);
+                                                            icalcomponent_kind kind,
+                                                            icaltimezone *floating_tz);
 
 extern struct icalperiodtype icalrecurrenceset_get_utc_timespan(icalcomponent *ical,
                                                                 icalcomponent_kind kind,
+                                                                icaltimezone *floating_tz,
                                                                 unsigned *is_recurring,
                                                                 void (*comp_cb)(icalcomponent*,
                                                                                 void*),
                                                                 void *cb_rock);
 
 extern void icaltime_set_utc(struct icaltimetype *t, int set);
+extern icaltimetype icaltime_convert_to_utc(const struct icaltimetype tt,
+                                            icaltimezone *floating_zone);
 
+extern int icalcomponent_apply_vpatch(icalcomponent *ical,
+                                      icalcomponent *vpatch,
+                                      int *num_changes, const char **errstr);
 
-/* Functions not declared in in libical < v2.0 */
-
-#if !HAVE_DECL_ICALPROPERTY_GET_PARENT
-extern icalcomponent *icalproperty_get_parent(const icalproperty *property);
-#endif
-
-#if !HAVE_DECL_ICALRECUR_FREQ_TO_STRING
-extern const char *icalrecur_freq_to_string(icalrecurrencetype_frequency kind);
-#endif
-
-#if !HAVE_DECL_ICALRECUR_WEEKDAY_TO_STRING
-extern const char *icalrecur_weekday_to_string(icalrecurrencetype_weekday kind);
-#endif
-
-
-#ifdef HAVE_TZDIST_PROPS
+/* Functions that should be declared in libical */
+#define icaltimezone_set_zone_directory set_zone_directory
 
 #define icalcomponent_get_tzuntil_property(comp) \
     icalcomponent_get_first_property(comp, ICAL_TZUNTIL_PROPERTY)
 
-#else /* !HAVE_TZDIST_PROPS */
-
-/* Functions to replace those not available in libical < v2.0 */
-
-#define icalcomponent_get_tzuntil_property(comp) \
-    icalcomponent_get_x_property_by_name(comp, "TZUNTIL")
-
-extern icalproperty *icalproperty_new_tzidaliasof(const char *v);
-extern icalproperty *icalproperty_new_tzuntil(struct icaltimetype v);
-
-#endif /* HAVE_TZDIST_PROPS */
-
-
-#ifdef HAVE_VALARM_EXT_PROPS
-
 #define icalcomponent_get_acknowledged_property(comp) \
     icalcomponent_get_first_property(comp, ICAL_ACKNOWLEDGED_PROPERTY)
 
-#else /* !HAVE_VALARM_EXT_PROPS */
+#ifndef HAVE_RFC7986_COLOR
 
-/* Functions to replace those not available in libical < v1.0 */
-
-#define icalcomponent_get_acknowledged_property(comp) \
-    icalcomponent_get_x_property_by_name(comp, "ACKNOWLEDGED")
+/* Replacement for missing function in 3.0.0 <= libical < 3.0.5 */
 
-extern icalproperty *icalproperty_new_acknowledged(struct icaltimetype v);
-extern struct icaltimetype icalproperty_get_acknowledged(const icalproperty *prop);
-
-#endif /* HAVE_VALARM_EXT_PROPS */
+extern icalproperty *icalproperty_new_color(const char *v);
 
+#endif /* HAVE_RFC7986_COLOR */
 
 #ifndef HAVE_RSCALE
 
@@ -164,8 +164,6 @@ extern struct icaltimetype icalproperty_
 #endif /* HAVE_RSCALE */
 
 
-#ifdef HAVE_MANAGED_ATTACH_PARAMS
-
 /* Wrappers to fetch managed attachment parameters by kind */
 
 #define icalproperty_get_filename_parameter(prop) \
@@ -177,69 +175,6 @@ extern struct icaltimetype icalproperty_
 #define icalproperty_get_size_parameter(prop) \
     icalproperty_get_first_parameter(prop, ICAL_SIZE_PARAMETER)
 
-#elif defined(HAVE_IANA_PARAMS)
-
-/* Functions to replace those not available in libical < v2.0 */
-
-extern icalparameter* icalproperty_get_iana_parameter_by_name(icalproperty *prop,
-                                                              const char *name);
-
-extern icalparameter *icalparameter_new_filename(const char *fname);
-
-extern void icalparameter_set_filename(icalparameter *param, const char *fname);
-
-extern icalparameter *icalparameter_new_managedid(const char *id);
-
-extern const char *icalparameter_get_managedid(icalparameter *param);
-
-extern void icalparameter_set_managedid(icalparameter *param, const char *id);
-
-extern icalparameter *icalparameter_new_size(const char *sz);
-
-extern const char *icalparameter_get_size(icalparameter *param);
-
-extern void icalparameter_set_size(icalparameter *param, const char *sz);
-
-/* Wrappers to fetch managed attachment parameters by kind */
-
-#define icalproperty_get_filename_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "FILENAME")
-
-#define icalproperty_get_managedid_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "MANAGED-ID")
-
-#define icalproperty_get_size_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "SIZE")
-
-#else /* !HAVE_IANA_PARAMS */
-
-/* Dummy functions to allow compilation with libical < v0.48 */
-
-#define icalparameter_new_filename(fname) NULL
-
-#define icalparameter_set_filename(param, fname) (void) param
-
-#define icalparameter_new_managedid(id) NULL
-
-#define icalparameter_get_managedid(param) ""
-
-#define icalparameter_set_managedid(param, id) (void) param
-
-#define icalparameter_new_size(sz) NULL
-
-#define icalparameter_set_size(param, sz) (void) param
-
-#define icalproperty_get_filename_parameter(prop) NULL
-
-#define icalproperty_get_managedid_parameter(prop) NULL
-
-#define icalproperty_get_size_parameter(prop) NULL
-
-#endif /* HAVE_MANAGED_ATTACH_PARAMS */
-
-
-#ifdef HAVE_SCHEDULING_PARAMS
-
 /* Wrappers to fetch scheduling parameters by kind */
 
 #define icalproperty_get_scheduleagent_parameter(prop) \
@@ -251,66 +186,6 @@ extern void icalparameter_set_size(icalp
 #define icalproperty_get_schedulestatus_parameter(prop) \
     icalproperty_get_first_parameter(prop, ICAL_SCHEDULESTATUS_PARAMETER)
 
-#else /* !HAVE_SCHEDULING_PARAMS */
-
-typedef enum {
-    ICAL_SCHEDULEAGENT_X,
-    ICAL_SCHEDULEAGENT_SERVER,
-    ICAL_SCHEDULEAGENT_CLIENT,
-    ICAL_SCHEDULEAGENT_NONE
-} icalparameter_scheduleagent;
-
-typedef enum {
-    ICAL_SCHEDULEFORCESEND_X,
-    ICAL_SCHEDULEFORCESEND_REQUEST,
-    ICAL_SCHEDULEFORCESEND_REPLY,
-    ICAL_SCHEDULEFORCESEND_NONE
-} icalparameter_scheduleforcesend;
-
-
-#ifdef HAVE_IANA_PARAMS
-
-/* Functions to replace those not available in libical < v1.0 */
-
-extern icalparameter_scheduleagent
-icalparameter_get_scheduleagent(icalparameter *param);
-
-extern icalparameter_scheduleforcesend
-icalparameter_get_scheduleforcesend(icalparameter *param);
-
-extern icalparameter *icalparameter_new_schedulestatus(const char *stat);
-
-/* Wrappers to fetch scheduling parameters by kind */
-
-#define icalproperty_get_scheduleagent_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "SCHEDULE-AGENT")
-
-#define icalproperty_get_scheduleforcesend_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "SCHEDULE-FORCE-SEND")
-
-#define icalproperty_get_schedulestatus_parameter(prop) \
-    icalproperty_get_iana_parameter_by_name(prop, "SCHEDULE-STATUS")
-
-#else /* !HAVE_IANA_PARAMS */
-
-/* Dummy functions to allow compilation with libical < v0.48 */
-
-#define icalparameter_get_scheduleagent(param) ICAL_SCHEDULEAGENT_NONE
-
-#define icalparameter_get_scheduleforcesend(param) ICAL_SCHEDULEFORCESEND_NONE
-
-#define icalparameter_new_schedulestatus(stat) ((void) stat, NULL)
-
-#define icalproperty_get_scheduleagent_parameter(prop) NULL
-
-#define icalproperty_get_scheduleforcesend_parameter(prop) NULL
-
-#define icalproperty_get_schedulestatus_parameter(prop) NULL
-
-#endif /* HAVE_IANA_PARAMS */
-
-#endif /* HAVE_SCHEDULING_PARAMS */
-
 #endif /* HAVE_ICAL */
 
 #endif /* ICAL_SUPPORT_H */
diff -pruN 3.0.13-5/imap/icu_wrap.cpp 3.2.0-3/imap/icu_wrap.cpp
--- 3.0.13-5/imap/icu_wrap.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/icu_wrap.cpp	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,76 @@
+/* icu_wrap.c --  C++ hiding wrapper API for ICU
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+extern "C" {
+#include "config.h"
+#include "string.h"
+#include "xmalloc.h"
+};
+
+
+#include <unicode/ucnv.h>
+#include <unicode/unistr.h>
+#include <unicode/timezone.h>
+
+extern "C" char *icu_getIDForWindowsID(const char *id)
+{
+    UErrorCode status = U_ZERO_ERROR;
+
+    UConverter *utf8cnv = ucnv_open("utf-8", &status);
+    if (U_FAILURE(status)) return NULL;
+    icu::UnicodeString uWinID {id, -1, utf8cnv, status};
+    ucnv_close(utf8cnv);
+
+    icu::UnicodeString uID;
+    icu::TimeZone::getIDForWindowsID(uWinID, NULL, uID, status);
+
+    std::string str;
+    uID.toUTF8String(str);
+    if (!str.empty()) return xstrdup(str.c_str());
+
+    if (!strcasecmp(id, "Mid-Atlantic Standard Time")) {
+        /* ICU doesn't map this ID */
+        return xstrdup("Atlantic/South_Georgia");
+    }
+
+    return NULL;
+}
diff -pruN 3.0.13-5/imap/icu_wrap.h 3.2.0-3/imap/icu_wrap.h
--- 3.0.13-5/imap/icu_wrap.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/icu_wrap.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,48 @@
+/* icu_wrap.h --  C++ hiding wrapper API for ICU
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef __CYRUS_IMAP_ICU_WRAP__
+#define __CYRUS_IMAP_ICU_WRAP__
+
+extern char *icu_getIDForWindowsID(const char *tzid);
+
+#endif /* __CYRUS_IMAP_ICU_WRAP__ */
diff -pruN 3.0.13-5/imap/idle.c 3.2.0-3/imap/idle.c
--- 3.0.13-5/imap/idle.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/idle.c	2020-04-24 02:03:00.000000000 +0000
@@ -149,7 +149,7 @@ EXPORTED void idle_init(void)
 
 EXPORTED int idle_enabled(void)
 {
-    int idle_period = config_getint(IMAPOPT_IMAPIDLEPOLL);
+    int idle_period = config_getduration(IMAPOPT_IMAPIDLEPOLL, 's');
 
     /* only enabled if a positive period */
     return (idle_period > 0);
@@ -165,7 +165,7 @@ EXPORTED void idle_start(const char *mbo
      * matter if it fails, we'll still poll */
     r = idle_send_msg(IDLE_MSG_INIT, mboxname);
     if (r) {
-        int idle_timeout = config_getint(IMAPOPT_IMAPIDLEPOLL);
+        int idle_timeout = config_getduration(IMAPOPT_IMAPIDLEPOLL, 's');
         syslog(LOG_ERR, "IDLE: error sending message "
                         "INIT to idled for mailbox %s: %s. "
                         "Falling back to polling every %d seconds.",
@@ -184,7 +184,7 @@ EXPORTED int idle_wait(int otherfd)
     struct timeval timeout;
     int r;
     int flags = 0;
-    int idle_timeout = config_getint(IMAPOPT_IMAPIDLEPOLL);
+    int idle_timeout = config_getduration(IMAPOPT_IMAPIDLEPOLL, 's');
 
     if (!idle_enabled()) return 0;
 
diff -pruN 3.0.13-5/imap/idled.c 3.2.0-3/imap/idled.c
--- 3.0.13-5/imap/idled.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/idled.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,6 +45,7 @@
 #endif
 
 #include <sys/types.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/stat.h>
 #include <stdlib.h>
@@ -60,7 +61,6 @@
 #include "mboxlist.h"
 #include "xmalloc.h"
 #include "hash.h"
-#include "exitcodes.h"
 
 extern int optind;
 extern char *optarg;
@@ -282,24 +282,19 @@ int main(int argc, char **argv)
             break;
         default:
             fprintf(stderr, "invalid argument\n");
-            exit(EC_USAGE);
+            exit(EX_USAGE);
             break;
         }
     }
 
     cyrus_init(alt_config, "idled", 0, 0);
 
-    /* Set inactivity timer (convert from minutes to seconds) */
-    idle_timeout = config_getint(IMAPOPT_TIMEOUT);
-    if (idle_timeout < 30) idle_timeout = 30;
-    idle_timeout *= 60;
+    /* Set inactivity timer (minimum is 30 minutes) */
+    idle_timeout = config_getduration(IMAPOPT_TIMEOUT, 'm');
+    if (idle_timeout < 30 * 60) idle_timeout = 30 * 60;
 
     /* count the number of mailboxes */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-    mboxlist_allmbox("", &mbox_count_cb, &nmbox, /*incdel*/0);
-    mboxlist_close();
-    mboxlist_done();
+    mboxlist_allmbox("", &mbox_count_cb, &nmbox, /*flags*/0);
 
     signals_set_shutdown(shut_down);
     signals_add_handlers(0);
@@ -338,8 +333,14 @@ int main(int argc, char **argv)
 
     for (;;) {
         int n;
+        int sig;
 
-        signals_poll();
+        sig = signals_poll();
+        if (sig == SIGHUP && getenv("CYRUS_ISDAEMON")) {
+            /* XXX maybe don't restart if we have clients? */
+            syslog(LOG_DEBUG, "received SIGHUP, shutting down gracefully\n");
+            shut_down(0);
+        }
 
         /* check for shutdown file */
         if (shutdown_file(NULL, 0)) {
diff -pruN 3.0.13-5/imap/idle.h 3.2.0-3/imap/idle.h
--- 3.0.13-5/imap/idle.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/idle.h	2020-04-24 02:03:00.000000000 +0000
@@ -50,7 +50,7 @@ typedef enum {
     /* something noteworthy may have happened to the mailbox,
      * e.g. a delivery, so it needs to be checked */
     IDLE_MAILBOX =      0x1,
-    /* the shutdownfile may have been written, needing an ALERT reponse
+    /* the shutdownfile may have been written, needing an ALERT response
      * to be sent to any IMAP clients */
     IDLE_ALERT =        0x2,
     /* input was detected on the @otherfd, probably because the IMAP
diff -pruN 3.0.13-5/imap/idlemsg.c 3.2.0-3/imap/idlemsg.c
--- 3.0.13-5/imap/idlemsg.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/idlemsg.c	2020-04-24 02:03:00.000000000 +0000
@@ -69,13 +69,13 @@ static struct sockaddr_un idle_local;
 
 EXPORTED int idle_make_server_address(struct sockaddr_un *mysun)
 {
-    const char *idle_sock;
+    const char *idle_sock_opt;
 
     memset(mysun, 0, sizeof(*mysun));
     mysun->sun_family = AF_UNIX;
-    idle_sock = config_getstring(IMAPOPT_IDLESOCKET);
-    if (idle_sock) {
-        strlcpy(mysun->sun_path, idle_sock, sizeof(mysun->sun_path));
+    idle_sock_opt = config_getstring(IMAPOPT_IDLESOCKET);
+    if (idle_sock_opt) {
+        strlcpy(mysun->sun_path, idle_sock_opt, sizeof(mysun->sun_path));
     }
     else {
         /* TODO: detect overflow and fail */
diff -pruN 3.0.13-5/imap/imapd.c 3.2.0-3/imap/imapd.c
--- 3.0.13-5/imap/imapd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/imapd.c	2020-05-04 03:28:02.000000000 +0000
@@ -52,6 +52,7 @@
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -82,7 +83,6 @@
 #include "bufarray.h"
 #include "charset.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "idle.h"
 #include "global.h"
 #include "times.h"
@@ -102,6 +102,7 @@
 #include "mupdate-client.h"
 #include "partlist.h"
 #include "proc.h"
+#include "prometheus.h"
 #include "quota.h"
 #include "seen.h"
 #include "statuscache.h"
@@ -324,23 +325,28 @@ static struct capa_struct base_capabilit
     { "THREAD=ORDEREDSUBJECT", 2 },
     { "THREAD=REFERENCES",     2 },
     { "THREAD=REFS",           2 }, /* draft-ietf-morg-inthread */
-    { "ANNOTATEMORE",          2 },
+    { "ANNOTATEMORE",          2 }, /* legacy SETANNOTATION/GETANNOTATION commands */
     { "ANNOTATE-EXPERIMENT-1", 2 },
-    { "METADATA",              2 },
+    { "METADATA",              2 }, /* RFC 5464 */
     { "LIST-EXTENDED",         2 },
     { "LIST-STATUS",           2 },
-    { "LIST-MYRIGHTS",         2 }, /* not standard */
+    { "LIST-MYRIGHTS",         2 }, /* RFC 8440 */
     { "LIST-METADATA",         2 }, /* not standard */
     { "WITHIN",                2 },
     { "QRESYNC",               2 },
     { "SCAN",                  2 },
     { "XLIST",                 2 }, /* not standard */
     { "XMOVE",                 2 }, /* not standard */
-    { "MOVE",                  2 },
-    { "SPECIAL-USE",           2 },
-    { "CREATE-SPECIAL-USE",    2 },
-    { "DIGEST=SHA1",           2 }, /* not standard */
-    { "X-REPLICATION",         2 }, /* not standard */
+    { "MOVE",                  2 }, /* RFC 6851 */
+    { "SPECIAL-USE",           2 }, /* RFC 6154 */
+    { "CREATE-SPECIAL-USE",    2 }, /* RFC 6154 */
+    { "DIGEST=SHA1",           2 }, /* Cyrus custom */
+    { "X-REPLICATION",         2 }, /* Cyrus custom */
+    { "STATUS=SIZE",           2 }, /* RFC 8438 */
+    { "OBJECTID",              2 }, /* draft-ietf-extra-imap-objectid */
+    { "SAVEDATE",              2 }, /* draft-ietf-extra-imap-savedate */
+    { "X-CREATEDMODSEQ",       2 }, /* Cyrus custom */
+    { "PREVIEW=FUZZY",         2 }, /* draft-ietf-extra-imap-fetch-preview */
 
 #ifdef HAVE_SSL
     { "URLAUTH",               2 },
@@ -359,6 +365,7 @@ void fatal(const char *s, int code);
 static void cmdloop(void);
 static void cmd_login(char *tag, char *user);
 static void cmd_authenticate(char *tag, char *authtype, char *resp);
+static void cmd_unauthenticate(char *tag);
 static void cmd_noop(char *tag, char *cmd);
 static void capa_response(int flags);
 static void cmd_capability(char *tag);
@@ -502,13 +509,7 @@ extern int saslserver(sasl_conn_t *conn,
 /* Enable the resetting of a sasl_conn_t */
 static int reset_saslconn(sasl_conn_t **conn);
 
-static struct
-{
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 static int imapd_canon_user(sasl_conn_t *conn, void *context,
                             const char *user, unsigned ulen,
@@ -741,7 +742,13 @@ static void imapd_reset(void)
     disable_referrals = 0;
     supports_referrals = 0;
 
-    if (imapd_index) index_close(&imapd_index);
+    index_text_extractor_destroy();
+
+    if (imapd_index) {
+        if (config_getswitch(IMAPOPT_AUTOEXPUNGE) && index_hasrights(imapd_index, ACL_EXPUNGE))
+            index_expunge(imapd_index, NULL, 1);
+        index_close(&imapd_index);
+    }
 
     if (imapd_in) {
         /* Flush the incoming buffer */
@@ -769,7 +776,7 @@ static void imapd_reset(void)
 #ifdef HAVE_SSL
     if (tls_conn) {
         if (tls_reset_servertls(&tls_conn) == -1) {
-            fatal("tls_reset() failed", EC_TEMPFAIL);
+            fatal("tls_reset() failed", EX_TEMPFAIL);
         }
         tls_conn = NULL;
     }
@@ -811,19 +818,7 @@ static void imapd_reset(void)
     imapd_starttls_done = 0;
     plaintextloginalert = NULL;
 
-    if(saslprops.iplocalport) {
-        free(saslprops.iplocalport);
-        saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-        free(saslprops.ipremoteport);
-        saslprops.ipremoteport = NULL;
-    }
-    if(saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
-    }
-    saslprops.ssf = 0;
+    saslprops_reset(&saslprops);
 
     clear_id();
 }
@@ -836,7 +831,7 @@ int service_init(int argc, char **argv,
 {
     int opt, events;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -846,18 +841,6 @@ int service_init(int argc, char **argv,
     /* load the SASL plugins */
     global_sasl_init(1, 1, mysasl_cb);
 
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for real work */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* open the user deny db */
-    denydb_init(0);
-    denydb_open(0);
-
     /* setup for sending IMAP IDLE notifications */
     idle_init();
 
@@ -866,11 +849,9 @@ int service_init(int argc, char **argv,
     apns_enabled =
       (events & EVENT_APPLEPUSHSERVICE) && config_getstring(IMAPOPT_APS_TOPIC);
 
-    search_attr_init();
-
     /* create connection to the SNMP listener, if available. */
     snmp_connect(); /* ignore return code */
-    snmp_set_str(SERVER_NAME_VERSION,cyrus_version());
+    snmp_set_str(SERVER_NAME_VERSION,CYRUS_VERSION);
 
     while ((opt = getopt(argc, argv, "Np:sq")) != EOF) {
         switch (opt) {
@@ -879,7 +860,7 @@ int service_init(int argc, char **argv,
             if (!tls_enabled()) {
                 syslog(LOG_ERR, "imaps: required OpenSSL options not present");
                 fatal("imaps: required OpenSSL options not present",
-                      EC_CONFIG);
+                      EX_CONFIG);
             }
             break;
         case 'p': /* external protection */
@@ -897,20 +878,18 @@ int service_init(int argc, char **argv,
         }
     }
 
-    /* Initialize the annotatemore extention */
+    /* Initialize the annotatemore extension */
     if (config_mupdate_server)
         annotate_init(annotate_fetch_proxy, annotate_store_proxy);
     else
         annotate_init(NULL, NULL);
     annotatemore_open();
 
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        statuscache_open();
-    }
-
     /* Create a protgroup for input from the client and selected backend */
     protin = protgroup_new(2);
 
+    prometheus_increment(CYRUS_IMAP_READY_LISTENERS);
+
     return 0;
 }
 
@@ -931,6 +910,8 @@ int service_main(int argc __attribute__(
     struct io_count *io_count_start = NULL;
     struct io_count *io_count_stop = NULL;
 
+    prometheus_decrement(CYRUS_IMAP_READY_LISTENERS);
+
     if (config_iolog) {
         io_count_start = xmalloc (sizeof (struct io_count));
         io_count_stop = xmalloc (sizeof (struct io_count));
@@ -946,8 +927,6 @@ int service_main(int argc __attribute__(
     id_getcmdline(argc, argv);
 #endif
 
-    sync_log_init();
-
     imapd_in = prot_new(0, 0);
     imapd_out = prot_new(1, 1);
     protgroup_insert(protin, imapd_in);
@@ -955,34 +934,32 @@ int service_main(int argc __attribute__(
     /* Find out name of client host */
     imapd_clienthost = get_clienthost(0, &localip, &remoteip);
 
+    if (localip && remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, remoteip);
+        buf_setcstr(&saslprops.iplocalport, localip);
+    }
+
     /* create the SASL connection */
-    if (sasl_server_new("imap", config_servername,
-                        NULL, NULL, NULL, NULL, 0,
-                        &imapd_saslconn) != SASL_OK) {
-        fatal("SASL failed initializing: sasl_server_new()", EC_TEMPFAIL);
+    if (sasl_server_new("imap", config_servername, NULL,
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                        NULL, 0, &imapd_saslconn) != SASL_OK) {
+        fatal("SASL failed initializing: sasl_server_new()", EX_TEMPFAIL);
     }
 
     secprops = mysasl_secprops(0);
     if (sasl_setprop(imapd_saslconn, SASL_SEC_PROPS, secprops) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
     if (sasl_setprop(imapd_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
-
-    if (localip && remoteip) {
-        sasl_setprop(imapd_saslconn, SASL_IPREMOTEPORT, remoteip);
-        saslprops.ipremoteport = xstrdup(remoteip);
-        sasl_setprop(imapd_saslconn, SASL_IPLOCALPORT, localip);
-        saslprops.iplocalport = xstrdup(localip);
-    }
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
 
     imapd_tls_required = config_getswitch(IMAPOPT_TLS_REQUIRED);
 
     proc_register(config_ident, imapd_clienthost, NULL, NULL, NULL);
 
     /* Set inactivity timer */
-    imapd_timeout = config_getint(IMAPOPT_TIMEOUT);
-    if (imapd_timeout < 30) imapd_timeout = 30;
-    imapd_timeout *= 60;
+    imapd_timeout = config_getduration(IMAPOPT_TIMEOUT, 'm');
+    if (imapd_timeout < 30 * 60) imapd_timeout = 30 * 60;
     prot_settimeout(imapd_in, imapd_timeout);
     prot_setflushonread(imapd_in, imapd_out);
 
@@ -990,6 +967,8 @@ int service_main(int argc __attribute__(
        TLS negotiation immediately */
     if (imaps == 1) cmd_starttls(NULL, 1);
 
+    prometheus_increment(CYRUS_IMAP_CONNECTIONS_TOTAL);
+    prometheus_increment(CYRUS_IMAP_ACTIVE_CONNECTIONS);
     snmp_increment(TOTAL_CONNECTIONS, 1);
     snmp_increment(ACTIVE_CONNECTIONS, 1);
 
@@ -997,16 +976,21 @@ int service_main(int argc __attribute__(
     mboxname_init_namespace(&imapd_namespace, /*isadmin*/1);
     mboxevent_setnamespace(&imapd_namespace);
 
+    index_text_extractor_init(imapd_in);
+
     cmdloop();
 
     /* LOGOUT executed */
     prot_flush(imapd_out);
+    prometheus_decrement(CYRUS_IMAP_ACTIVE_CONNECTIONS);
     snmp_increment(ACTIVE_CONNECTIONS, -1);
 
     /* send a Logout event notification */
     if ((mboxevent = mboxevent_new(EVENT_LOGOUT))) {
-        mboxevent_set_access(mboxevent, saslprops.iplocalport,
-                             saslprops.ipremoteport, imapd_userid, NULL, 1);
+        mboxevent_set_access(mboxevent,
+                             buf_cstringnull_ifempty(&saslprops.iplocalport),
+                             buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                             imapd_userid, NULL, 1);
 
         mboxevent_notify(&mboxevent);
         mboxevent_free(&mboxevent);
@@ -1025,6 +1009,7 @@ int service_main(int argc __attribute__(
         free (io_count_stop);
     }
 
+    prometheus_increment(CYRUS_IMAP_READY_LISTENERS);
     return 0;
 }
 
@@ -1093,33 +1078,25 @@ void shut_down(int code)
     if (backend_cached) free(backend_cached);
     if (mupdate_h) mupdate_disconnect(&mupdate_h);
 
+    index_text_extractor_destroy();
+
     if (idling)
         idle_stop(index_mboxname(imapd_index));
 
-    if (imapd_index) index_close(&imapd_index);
+    if (imapd_index) {
+        if (config_getswitch(IMAPOPT_AUTOEXPUNGE) && index_hasrights(imapd_index, ACL_EXPUNGE))
+            index_expunge(imapd_index, NULL, 1);
+        index_close(&imapd_index);
+    }
 
-    sync_log_done();
     seen_done();
     mboxkey_done();
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    denydb_close();
-    denydb_done();
 
     annotatemore_close();
     annotate_done();
 
     idle_done();
 
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        statuscache_close();
-        statuscache_done();
-    }
-
     partlist_local_done();
 
     if (imapd_in) {
@@ -1137,8 +1114,16 @@ void shut_down(int code)
         prot_free(imapd_out);
 
         /* one less active connection */
+        prometheus_decrement(CYRUS_IMAP_ACTIVE_CONNECTIONS);
         snmp_increment(ACTIVE_CONNECTIONS, -1);
     }
+    else {
+        /* one less ready listener */
+        prometheus_decrement(CYRUS_IMAP_READY_LISTENERS);
+    }
+
+    prometheus_increment(code ? CYRUS_IMAP_SHUTDOWN_TOTAL_STATUS_ERROR
+                              : CYRUS_IMAP_SHUTDOWN_TOTAL_STATUS_OK);
 
     if (config_auditlog)
         syslog(LOG_NOTICE, "auditlog: traffic sessionid=<%s> bytes_in=<%d> bytes_out=<%d>",
@@ -1150,6 +1135,8 @@ void shut_down(int code)
     tls_shutdown_serverengine();
 #endif
 
+    saslprops_free(&saslprops);
+
     cyrus_done();
 
     exit(code);
@@ -1162,6 +1149,7 @@ EXPORTED void fatal(const char *s, int c
     if (recurse_code) {
         /* We were called recursively. Just give up */
         proc_cleanup();
+        prometheus_decrement(CYRUS_IMAP_ACTIVE_CONNECTIONS);
         snmp_increment(ACTIVE_CONNECTIONS, -1);
         exit(recurse_code);
     }
@@ -1230,12 +1218,12 @@ static void cmdloop(void)
     prot_printf(imapd_out, "]");
     if (config_serverinfo) prot_printf(imapd_out, " %s", config_servername);
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-        prot_printf(imapd_out, " Cyrus IMAP %s", cyrus_version());
+        prot_printf(imapd_out, " Cyrus IMAP %s", CYRUS_VERSION);
     }
     prot_printf(imapd_out, " server ready\r\n");
 
     /* clear cancelled flag if present before the next command */
-    cmd_cancelled();
+    cmd_cancelled(/*insearch*/0);
 
     motd_file();
 
@@ -1252,6 +1240,9 @@ static void cmdloop(void)
         /* Release any held index */
         index_release(imapd_index);
 
+        /* ensure we didn't leak anything! */
+        assert(!open_mailboxes_exist());
+
         /* Flush any buffered output */
         prot_flush(imapd_out);
         if (backend_current) prot_flush(backend_current->out);
@@ -1358,6 +1349,7 @@ static void cmdloop(void)
                 }
                 cmd_authenticate(tag.s, arg1.s, haveinitresp ? arg2.s : NULL);
 
+                /* prometheus stat is counted by cmd_authenticate based on success/failure */
                 snmp_increment(AUTHENTICATE_COUNT, 1);
             }
             else if (!imapd_userid) goto nologin;
@@ -1368,6 +1360,7 @@ static void cmdloop(void)
 
                 cmd_append(tag.s, arg1.s, NULL);
 
+                prometheus_increment(CYRUS_IMAP_APPEND_TOTAL);
                 snmp_increment(APPEND_COUNT, 1);
             }
             else goto badcmd;
@@ -1379,6 +1372,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_capability(tag.s);
 
+                prometheus_increment(CYRUS_IMAP_CAPABILITY_TOTAL);
                 snmp_increment(CAPABILITY_COUNT, 1);
             }
             else if (!imapd_userid) goto nologin;
@@ -1392,6 +1386,7 @@ static void cmdloop(void)
 
                 cmd_compress(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_COMPRESS_TOTAL);
                 snmp_increment(COMPRESS_COUNT, 1);
             }
 #endif /* HAVE_ZLIB */
@@ -1402,6 +1397,7 @@ static void cmdloop(void)
 
                 cmd_noop(tag.s, cmd.s);
 
+                prometheus_increment(CYRUS_IMAP_CHECK_TOTAL);
                 snmp_increment(CHECK_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Copy")) {
@@ -1419,6 +1415,7 @@ static void cmdloop(void)
 
                 cmd_copy(tag.s, arg1.s, arg2.s, usinguid, /*ismove*/0);
 
+                prometheus_increment(CYRUS_IMAP_COPY_TOTAL);
                 snmp_increment(COPY_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Create")) {
@@ -1436,6 +1433,7 @@ static void cmdloop(void)
                 cmd_create(tag.s, arg1.s, extargs, 0);
                 dlist_free(&extargs);
 
+                prometheus_increment(CYRUS_IMAP_CREATE_TOTAL);
                 snmp_increment(CREATE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Close")) {
@@ -1445,6 +1443,7 @@ static void cmdloop(void)
 
                 cmd_close(tag.s, cmd.s);
 
+                prometheus_increment(CYRUS_IMAP_CLOSE_TOTAL);
                 snmp_increment(CLOSE_COUNT, 1);
             }
             else goto badcmd;
@@ -1459,6 +1458,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_delete(tag.s, arg1.s, 0, 0);
 
+                prometheus_increment(CYRUS_IMAP_DELETE_TOTAL);
                 snmp_increment(DELETE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Deleteacl")) {
@@ -1471,6 +1471,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_setacl(tag.s, arg1.s, arg2.s, NULL);
 
+                prometheus_increment(CYRUS_IMAP_DELETEACL_TOTAL);
                 snmp_increment(DELETEACL_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Dump")) {
@@ -1488,6 +1489,7 @@ static void cmdloop(void)
                 if(c != '\n') goto extraargs;
 
                 cmd_dump(tag.s, arg1.s, uid_start);
+                prometheus_increment(CYRUS_IMAP_DUMP_TOTAL);
             /*  snmp_increment(DUMP_COUNT, 1);*/
             }
             else goto badcmd;
@@ -1507,6 +1509,7 @@ static void cmdloop(void)
 
                 cmd_expunge(tag.s, 0);
 
+                prometheus_increment(CYRUS_IMAP_EXPUNGE_TOTAL);
                 snmp_increment(EXPUNGE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Examine")) {
@@ -1517,6 +1520,7 @@ static void cmdloop(void)
 
                 cmd_select(tag.s, cmd.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_EXAMINE_TOTAL);
                 snmp_increment(EXAMINE_COUNT, 1);
             }
             else goto badcmd;
@@ -1534,6 +1538,7 @@ static void cmdloop(void)
 
                 cmd_fetch(tag.s, arg1.s, usinguid);
 
+                prometheus_increment(CYRUS_IMAP_FETCH_TOTAL);
                 snmp_increment(FETCH_COUNT, 1);
             }
             else goto badcmd;
@@ -1548,6 +1553,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_getacl(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_GETACL_TOTAL);
                 snmp_increment(GETACL_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Getannotation")) {
@@ -1557,6 +1563,7 @@ static void cmdloop(void)
 
                 cmd_getannotation(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_GETANNOTATION_TOTAL);
                 snmp_increment(GETANNOTATION_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Getmetadata")) {
@@ -1564,6 +1571,7 @@ static void cmdloop(void)
 
                 cmd_getmetadata(tag.s);
 
+                prometheus_increment(CYRUS_IMAP_GETMETADATA_TOTAL);
                 snmp_increment(GETANNOTATION_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Getquota")) {
@@ -1574,6 +1582,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_getquota(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_GETQUOTA_TOTAL);
                 snmp_increment(GETQUOTA_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Getquotaroot")) {
@@ -1584,6 +1593,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_getquotaroot(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_GETQUOTAROOT_TOTAL);
                 snmp_increment(GETQUOTAROOT_COUNT, 1);
             }
 #ifdef HAVE_SSL
@@ -1591,6 +1601,7 @@ static void cmdloop(void)
                 if (c != ' ') goto missingargs;
 
                 cmd_genurlauth(tag.s);
+                prometheus_increment(CYRUS_IMAP_GENURLAUTH_TOTAL);
             /*  snmp_increment(GENURLAUTH_COUNT, 1);*/
             }
 #endif
@@ -1602,6 +1613,7 @@ static void cmdloop(void)
                 if (c != ' ') goto missingargs;
                 cmd_id(tag.s);
 
+                prometheus_increment(CYRUS_IMAP_ID_TOTAL);
                 snmp_increment(ID_COUNT, 1);
             }
             else if (!imapd_userid) goto nologin;
@@ -1610,6 +1622,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_idle(tag.s);
 
+                prometheus_increment(CYRUS_IMAP_IDLE_TOTAL);
                 snmp_increment(IDLE_COUNT, 1);
             }
             else goto badcmd;
@@ -1623,12 +1636,14 @@ static void cmdloop(void)
 
                 cmd_login(tag.s, arg1.s);
 
+                /* prometheus stat is counted by cmd_login based on success/failure */
                 snmp_increment(LOGIN_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Logout")) {
                 if (c == '\r') c = prot_getc(imapd_in);
                 if (c != '\n') goto extraargs;
 
+                prometheus_increment(CYRUS_IMAP_LOGOUT_TOTAL);
                 snmp_increment(LOGOUT_COUNT, 1);
 
                 /* force any responses from our selected backend */
@@ -1656,6 +1671,7 @@ static void cmdloop(void)
                 getlistargs(tag.s, &listargs);
                 if (listargs.pat.count) cmd_list(tag.s, &listargs);
 
+                prometheus_increment(CYRUS_IMAP_LIST_TOTAL);
                 snmp_increment(LIST_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Lsub")) {
@@ -1677,6 +1693,7 @@ static void cmdloop(void)
 
                 cmd_list(tag.s, &listargs);
 
+                prometheus_increment(CYRUS_IMAP_LSUB_TOTAL);
                 snmp_increment(LSUB_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Listrights")) {
@@ -1687,6 +1704,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_listrights(tag.s, arg1.s, arg2.s);
 
+                prometheus_increment(CYRUS_IMAP_LISTRIGHTS_TOTAL);
                 snmp_increment(LISTRIGHTS_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Localappend")) {
@@ -1699,6 +1717,7 @@ static void cmdloop(void)
 
                 cmd_append(tag.s, arg1.s, *arg2.s ? arg2.s : NULL);
 
+                prometheus_increment(CYRUS_IMAP_APPEND_TOTAL);
                 snmp_increment(APPEND_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Localcreate")) {
@@ -1717,6 +1736,7 @@ static void cmdloop(void)
                 cmd_create(tag.s, arg1.s, extargs, 1);
                 dlist_free(&extargs);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_CREATE_TOTAL); */
                 /* xxxx snmp_increment(CREATE_COUNT, 1); */
             }
             else if (!strcmp(cmd.s, "Localdelete")) {
@@ -1728,6 +1748,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_delete(tag.s, arg1.s, 1, 1);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_DELETE_TOTAL); */
                 /* xxxx snmp_increment(DELETE_COUNT, 1); */
             }
             else goto badcmd;
@@ -1742,6 +1763,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_myrights(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_MYRIGHTS_TOTAL);
                 /* xxxx snmp_increment(MYRIGHTS_COUNT, 1); */
             }
             else if (!strcmp(cmd.s, "Mupdatepush")) {
@@ -1752,6 +1774,7 @@ static void cmdloop(void)
                 if(c != '\n') goto extraargs;
                 cmd_mupdatepush(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_MUPDATEPUSH_TOTAL);
                 /* xxxx snmp_increment(MUPDATEPUSH_COUNT, 1); */
             }
             else if (!strcmp(cmd.s, "Move")) {
@@ -1769,6 +1792,7 @@ static void cmdloop(void)
 
                 cmd_copy(tag.s, arg1.s, arg2.s, usinguid, /*ismove*/1);
 
+                prometheus_increment(CYRUS_IMAP_COPY_TOTAL);
                 snmp_increment(COPY_COUNT, 1);
             } else goto badcmd;
             break;
@@ -1780,6 +1804,7 @@ static void cmdloop(void)
 
                 cmd_noop(tag.s, cmd.s);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_NOOP_TOTAL); */
                 /* xxxx snmp_increment(NOOP_COUNT, 1); */
             }
             else if (!imapd_userid) goto nologin;
@@ -1788,6 +1813,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_namespace(tag.s);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_NAMESPACE_TOTAL); */
                 /* xxxx snmp_increment(NAMESPACE_COUNT, 1); */
             }
             else goto badcmd;
@@ -1810,13 +1836,14 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_rename(tag.s, arg1.s, arg2.s, havepartition ? arg3.s : 0);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_RENAME_TOTAL); */
                 /* xxxx snmp_increment(RENAME_COUNT, 1); */
             } else if(!strcmp(cmd.s, "Reconstruct")) {
                 recursive = 0;
                 if (c != ' ') goto missingargs;
                 c = getastring(imapd_in, imapd_out, &arg1);
                 if(c == ' ') {
-                    /* Optional RECURSEIVE argument */
+                    /* Optional RECURSIVE argument */
                     c = getword(imapd_in, &arg2);
                     if(!imparse_isatom(arg2.s))
                         goto extraargs;
@@ -1829,6 +1856,7 @@ static void cmdloop(void)
                 if(c != '\n') goto extraargs;
                 cmd_reconstruct(tag.s, arg1.s, recursive);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_RECONSTRUCT_TOTAL); */
                 /* snmp_increment(RECONSTRUCT_COUNT, 1); */
             }
             else if (!strcmp(cmd.s, "Rlist")) {
@@ -1848,6 +1876,7 @@ static void cmdloop(void)
 
                 cmd_list(tag.s, &listargs);
 
+                /* XXX prometheus_increment(prom_handle, CYRUS_IMAP_LIST_TOTAL); */
 /*              snmp_increment(LIST_COUNT, 1); */
             }
             else if (!strcmp(cmd.s, "Rlsub")) {
@@ -1867,6 +1896,7 @@ static void cmdloop(void)
 
                 cmd_list(tag.s, &listargs);
 
+                /* XXX prometheus_increment(prom_handle, CYRUS_IMAP_LSUB_TOTAL); */
 /*              snmp_increment(LSUB_COUNT, 1); */
             }
 #ifdef HAVE_SSL
@@ -1887,6 +1917,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_resetkey(tag.s, have_mbox ? arg1.s : 0,
                              have_mech ? arg2.s : 0);
+                /* XXX prometheus_increment(CYRUS_IMAP_RESETKEY_TOTAL); */
             /*  snmp_increment(RESETKEY_COUNT, 1);*/
             }
 #endif
@@ -1929,6 +1960,7 @@ static void cmdloop(void)
                 }
                 cmd_starttls(tag.s, 0);
 
+                prometheus_increment(CYRUS_IMAP_STARTTLS_TOTAL);
                 snmp_increment(STARTTLS_COUNT, 1);
                 continue;
             }
@@ -1944,6 +1976,7 @@ static void cmdloop(void)
 
                 cmd_store(tag.s, arg1.s, usinguid);
 
+                prometheus_increment(CYRUS_IMAP_STORE_TOTAL);
                 snmp_increment(STORE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Select")) {
@@ -1954,6 +1987,7 @@ static void cmdloop(void)
 
                 cmd_select(tag.s, cmd.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_SELECT_TOTAL);
                 snmp_increment(SELECT_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Search")) {
@@ -1964,6 +1998,7 @@ static void cmdloop(void)
 
                 cmd_search(tag.s, usinguid);
 
+                prometheus_increment(CYRUS_IMAP_SEARCH_TOTAL);
                 snmp_increment(SEARCH_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Subscribe")) {
@@ -1983,6 +2018,7 @@ static void cmdloop(void)
                 else {
                     cmd_changesub(tag.s, (char *)0, arg1.s, 1);
                 }
+                prometheus_increment(CYRUS_IMAP_SUBSCRIBE_TOTAL);
                 snmp_increment(SUBSCRIBE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Setacl")) {
@@ -1997,6 +2033,7 @@ static void cmdloop(void)
                 if (c != '\n') goto extraargs;
                 cmd_setacl(tag.s, arg1.s, arg2.s, arg3.s);
 
+                prometheus_increment(CYRUS_IMAP_SETACL_TOTAL);
                 snmp_increment(SETACL_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Setannotation")) {
@@ -2006,6 +2043,7 @@ static void cmdloop(void)
 
                 cmd_setannotation(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_SETANNOTATION_TOTAL);
                 snmp_increment(SETANNOTATION_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Setmetadata")) {
@@ -2015,7 +2053,8 @@ static void cmdloop(void)
 
                 cmd_setmetadata(tag.s, arg1.s);
 
-                snmp_increment(SETANNOTATION_COUNT, 1);
+                prometheus_increment(CYRUS_IMAP_SETMETADATA_TOTAL);
+                snmp_increment(SETMETADATA_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Setquota")) {
                 if (c != ' ') goto missingargs;
@@ -2023,6 +2062,7 @@ static void cmdloop(void)
                 if (c != ' ') goto missingargs;
                 cmd_setquota(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_SETQUOTA_TOTAL);
                 snmp_increment(SETQUOTA_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Sort")) {
@@ -2032,6 +2072,7 @@ static void cmdloop(void)
             sort:
                 cmd_sort(tag.s, usinguid);
 
+                prometheus_increment(CYRUS_IMAP_SORT_TOTAL);
                 snmp_increment(SORT_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Status")) {
@@ -2040,6 +2081,7 @@ static void cmdloop(void)
                 if (c != ' ') goto missingargs;
                 cmd_status(tag.s, arg1.s);
 
+                prometheus_increment(CYRUS_IMAP_STATUS_TOTAL);
                 snmp_increment(STATUS_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Scan")) {
@@ -2060,6 +2102,7 @@ static void cmdloop(void)
 
                 cmd_list(tag.s, &listargs);
 
+                prometheus_increment(CYRUS_IMAP_SCAN_TOTAL);
                 snmp_increment(SCAN_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Syncapply")) {
@@ -2115,6 +2158,7 @@ static void cmdloop(void)
             thread:
                 cmd_thread(tag.s, usinguid);
 
+                prometheus_increment(CYRUS_IMAP_THREAD_TOTAL);
                 snmp_increment(THREAD_COUNT, 1);
             }
             else goto badcmd;
@@ -2160,6 +2204,7 @@ static void cmdloop(void)
                     if (c != '\n') goto extraargs;
                     cmd_expunge(tag.s, arg1.s);
 
+                    prometheus_increment(CYRUS_IMAP_EXPUNGE_TOTAL);
                     snmp_increment(EXPUNGE_COUNT, 1);
                 }
                 else if (!strcmp(arg1.s, "xrunannotator")) {
@@ -2170,6 +2215,17 @@ static void cmdloop(void)
                     eatline(imapd_in, c);
                 }
             }
+            else if (!strcmp(cmd.s, "Unauthenticate")) {
+                if (!imapd_userisadmin) goto badcmd;
+
+                if (c == '\r') c = prot_getc(imapd_in);
+                if (c != '\n') goto extraargs;
+
+                cmd_unauthenticate(tag.s);
+
+                prometheus_increment(CYRUS_IMAP_UNAUTHENTICATE_TOTAL);
+                snmp_increment(UNAUTHENTICATE_COUNT, 1);
+            }
             else if (!strcmp(cmd.s, "Unsubscribe")) {
                 if (c != ' ') goto missingargs;
                 havenamespace = 0;
@@ -2188,6 +2244,7 @@ static void cmdloop(void)
                     cmd_changesub(tag.s, (char *)0, arg1.s, 0);
                 }
 
+                prometheus_increment(CYRUS_IMAP_UNSUBSCRIBE_TOTAL);
                 snmp_increment(UNSUBSCRIBE_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Unselect")) {
@@ -2197,6 +2254,7 @@ static void cmdloop(void)
 
                 cmd_close(tag.s, cmd.s);
 
+                prometheus_increment(CYRUS_IMAP_UNSELECT_TOTAL);
                 snmp_increment(UNSELECT_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Undump")) {
@@ -2207,6 +2265,7 @@ static void cmdloop(void)
                 if(c != ' ') goto missingargs;
 
                 cmd_undump(tag.s, arg1.s);
+                /* XXX prometheus_increment(CYRUS_IMAP_UNDUMP_TOTAL); */
             /*  snmp_increment(UNDUMP_COUNT, 1);*/
             }
 #ifdef HAVE_SSL
@@ -2214,6 +2273,7 @@ static void cmdloop(void)
                 if (c != ' ') goto missingargs;
 
                 cmd_urlfetch(tag.s);
+                /* XXX prometheus_increment(CYRUS_IMAP_URLFETCH_TOTAL); */
             /*  snmp_increment(URLFETCH_COUNT, 1);*/
             }
 #endif
@@ -2243,11 +2303,13 @@ static void cmdloop(void)
 
                 cmd_xbackup(tag.s, arg1.s, havechannel ? arg2.s : NULL);
 
+                prometheus_increment(CYRUS_IMAP_XBACKUP_TOTAL);
 //              snmp_increment(XBACKUP_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xconvfetch")) {
                 cmd_xconvfetch(tag.s);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_XCONVFETCH_TOTAL); */
 //              snmp_increment(XCONVFETCH_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xconvmultisort")) {
@@ -2255,6 +2317,7 @@ static void cmdloop(void)
                 if (!imapd_index && !backend_current) goto nomailbox;
                 cmd_xconvmultisort(tag.s);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_XCONVMULTISORT_TOTAL); */
 //              snmp_increment(XCONVMULTISORT_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xconvsort")) {
@@ -2262,6 +2325,7 @@ static void cmdloop(void)
                 if (!imapd_index && !backend_current) goto nomailbox;
                 cmd_xconvsort(tag.s, 0);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_XCONVSORT_TOTAL); */
 //              snmp_increment(XCONVSORT_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xconvupdates")) {
@@ -2269,6 +2333,7 @@ static void cmdloop(void)
                 if (!imapd_index && !backend_current) goto nomailbox;
                 cmd_xconvsort(tag.s, 1);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_XCONVUPDATES_TOTAL); */
 //              snmp_increment(XCONVUPDATES_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xfer")) {
@@ -2294,6 +2359,7 @@ static void cmdloop(void)
 
                 cmd_xfer(tag.s, arg1.s, arg2.s,
                          (havepartition ? arg3.s : NULL));
+                /* XXX prometheus_increment(CYRUS_IMAP_XFER_TOTAL); */
             /*  snmp_increment(XFER_COUNT, 1);*/
             }
             else if (!strcmp(cmd.s, "Xconvmeta")) {
@@ -2310,6 +2376,7 @@ static void cmdloop(void)
                 getlistargs(tag.s, &listargs);
                 if (listargs.pat.count) cmd_list(tag.s, &listargs);
 
+                prometheus_increment(CYRUS_IMAP_LIST_TOTAL);
                 snmp_increment(LIST_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xmove")) {
@@ -2326,6 +2393,7 @@ static void cmdloop(void)
                 c = getword(imapd_in, &arg1);
                 if (!arg1.len || !imparse_issequence(arg1.s)) goto badsequence;
                 cmd_xrunannotator(tag.s, arg1.s, usinguid);
+                /* XXX prometheus_increment(CYRUS_IMAP_XRUNANNOTATOR_TOTAL); */
 //              snmp_increment(XRUNANNOTATOR_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xsnippets")) {
@@ -2333,6 +2401,7 @@ static void cmdloop(void)
                 if (!imapd_index && !backend_current) goto nomailbox;
                 cmd_xsnippets(tag.s);
 
+                /* XXX prometheus_increment(CYRUS_IMAP_XSNIPPETS_TOTAL); */
 //              snmp_increment(XSNIPPETS_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xstats")) {
@@ -2342,6 +2411,7 @@ static void cmdloop(void)
                 /* XWARMUP doesn't need a mailbox to be selected */
                 if (c != ' ') goto missingargs;
                 cmd_xwarmup(tag.s);
+                /* XXX prometheus_increment(CYRUS_IMAP_XWARMUP_TOTAL); */
 //              snmp_increment(XWARMUP_COUNT, 1);
             }
             else if (!strcmp(cmd.s, "Xkillmy")) {
@@ -2533,7 +2603,7 @@ static void authentication_success(void)
 
     if (r) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     /* Make a copy of the external userid for use in proxying */
@@ -2541,8 +2611,10 @@ static void authentication_success(void)
 
     /* send a Login event notification */
     if ((mboxevent = mboxevent_new(EVENT_LOGIN))) {
-        mboxevent_set_access(mboxevent, saslprops.iplocalport,
-                             saslprops.ipremoteport, imapd_userid, NULL, 1);
+        mboxevent_set_access(mboxevent,
+                             buf_cstringnull_ifempty(&saslprops.iplocalport),
+                             buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                             imapd_userid, NULL, 1);
 
         mboxevent_notify(&mboxevent);
         mboxevent_free(&mboxevent);
@@ -2619,7 +2691,7 @@ static void cmd_login(char *tag, char *u
 
     if (r) {
         eatline(imapd_in, ' ');
-        syslog(LOG_NOTICE, "badlogin: %s plaintext %s invalid user",
+        syslog(LOG_NOTICE, "badlogin: %s plaintext (%s) invalid user",
                imapd_clienthost, beautify_string(user));
         prot_printf(imapd_out, "%s NO %s\r\n", tag,
                     error_message(IMAP_INVALID_USER));
@@ -2685,10 +2757,10 @@ static void cmd_login(char *tag, char *u
                                  strlen(canon_user),
                                  passwd,
                                  strlen(passwd))) != SASL_OK) {
-        syslog(LOG_NOTICE, "badlogin: %s plaintext %s %s",
+        syslog(LOG_NOTICE, "badlogin: %s plaintext (%s) [%s]",
                imapd_clienthost, canon_user, sasl_errdetail(imapd_saslconn));
 
-        failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+        failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
         if (failedloginpause != 0) {
             sleep(failedloginpause);
         }
@@ -2702,6 +2774,7 @@ static void cmd_login(char *tag, char *u
             prot_printf(imapd_out, "%s NO Login failed: %d\r\n", tag, r);
         }
 
+        prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_NO);
         snmp_increment_args(AUTHENTICATION_NO, 1,
                             VARIABLE_AUTH, 0 /* hash_simple("LOGIN") */,
                             VARIABLE_LISTEND);
@@ -2719,6 +2792,7 @@ static void cmd_login(char *tag, char *u
                 prot_printf(imapd_out, "%s NO Login failed: %d\r\n", tag, r);
             }
 
+            prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_NO);
             snmp_increment_args(AUTHENTICATION_NO, 1,
                                 VARIABLE_AUTH, 0 /* hash_simple("LOGIN") */,
                                 VARIABLE_LISTEND);
@@ -2730,6 +2804,7 @@ static void cmd_login(char *tag, char *u
             "User logged in SESSIONID=<%s>", session_id());
         reply = replybuf;
         imapd_userid = xstrdup((const char *) val);
+        prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_YES);
         snmp_increment_args(AUTHENTICATION_YES, 1,
                             VARIABLE_AUTH, 0 /*hash_simple("LOGIN") */,
                             VARIABLE_LISTEND);
@@ -2740,7 +2815,7 @@ static void cmd_login(char *tag, char *u
 
         /* Apply penalty only if not under layer */
         if (!imapd_starttls_done) {
-            int plaintextloginpause = config_getint(IMAPOPT_PLAINTEXTLOGINPAUSE);
+            int plaintextloginpause = config_getduration(IMAPOPT_PLAINTEXTLOGINPAUSE, 's');
             if (plaintextloginpause) {
                 sleep(plaintextloginpause);
             }
@@ -2789,6 +2864,7 @@ static void cmd_authenticate(char *tag,
 
     if (r) {
         const char *errorstring = NULL;
+        const char *userid = "-notset-";
 
         switch (r) {
         case IMAP_SASL_CANCEL:
@@ -2804,13 +2880,17 @@ static void cmd_authenticate(char *tag,
             break;
         default:
             /* failed authentication */
-            syslog(LOG_NOTICE, "badlogin: %s %s [%s]",
-                   imapd_clienthost, authtype, sasl_errdetail(imapd_saslconn));
+            if (sasl_result != SASL_NOUSER)
+                sasl_getprop(imapd_saslconn, SASL_USERNAME, (const void **) &userid);
 
+            syslog(LOG_NOTICE, "badlogin: %s %s (%s) [%s]",
+                   imapd_clienthost, authtype, userid, sasl_errdetail(imapd_saslconn));
+
+            prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_NO);
             snmp_increment_args(AUTHENTICATION_NO, 1,
                                 VARIABLE_AUTH, 0, /* hash_simple(authtype) */
                                 VARIABLE_LISTEND);
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
@@ -2894,6 +2974,7 @@ static void cmd_authenticate(char *tag,
         }
     }
 
+    prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_YES);
     snmp_increment_args(AUTHENTICATION_YES, 1,
                         VARIABLE_AUTH, 0, /* hash_simple(authtype) */
                         VARIABLE_LISTEND);
@@ -2920,6 +3001,85 @@ static void cmd_authenticate(char *tag,
 }
 
 /*
+ * Perform an UNAUTHENTICATE command
+ */
+static void cmd_unauthenticate(char *tag)
+{
+    /* Unselect any open mailbox */
+    if (backend_current) {
+        /* remote mailbox */
+        char mytag[128];
+
+        proxy_gentag(mytag, sizeof(mytag));
+        prot_printf(backend_current->out, "%s Unselect\r\n", mytag);
+        /* do not fatal() here, because we don't really care about this
+         * server anymore anyway */
+        pipe_until_tag(backend_current, mytag, 1);
+
+        /* remove backend_current from the protgroup */
+        protgroup_delete(protin, backend_current->in);
+
+        backend_current = NULL;
+    }
+    else if (imapd_index) {
+        if (config_getswitch(IMAPOPT_AUTOEXPUNGE) && index_hasrights(imapd_index, ACL_EXPUNGE))
+            index_expunge(imapd_index, NULL, 1);
+        index_close(&imapd_index);
+    }
+
+    /* Reset authentication state */
+    if (imapd_userid != NULL) {
+        free(imapd_userid);
+        imapd_userid = NULL;
+    }
+    if (proxy_userid != NULL) {
+        free(proxy_userid);
+        proxy_userid = NULL;
+    }
+    if (imapd_magicplus != NULL) {
+        free(imapd_magicplus);
+        imapd_magicplus = NULL;
+    }
+    if (imapd_authstate) {
+        auth_freestate(imapd_authstate);
+        imapd_authstate = NULL;
+    }
+    imapd_userisadmin = 0;
+    imapd_userisproxyadmin = 0;
+    plaintextloginalert = NULL;
+    saslprops_reset(&saslprops);
+    clear_id();
+
+    /* Reset client-enabled extensions */
+    client_capa = 0;
+
+    /* Send response
+       (MUST be done with current SASL and/or commpression layer still active) */
+    prot_printf(imapd_out, "%s OK [CAPABILITY ", tag);
+    capa_response(CAPA_PREAUTH);
+    prot_printf(imapd_out, "] %s\r\n", error_message(IMAP_OK_COMPLETED));
+    prot_flush(imapd_out);
+
+    /* Reset connection state (other than TLS) */
+#ifdef HAVE_ZLIB
+    if (imapd_compress_done) {
+        /* disable (de)compression on the prot layer */
+        prot_unsetcompress(imapd_in);
+        prot_unsetcompress(imapd_out);
+
+        imapd_compress_done = 0;
+    }
+#endif
+    if (imapd_saslconn) {
+        /* disable SASL on the prot layer */
+        prot_unsetsasl(imapd_out);
+        prot_unsetsasl(imapd_in);
+
+        reset_saslconn(&imapd_saslconn);
+    }
+}
+
+/*
  * Perform a NOOP command
  */
 static void cmd_noop(char *tag, char *cmd)
@@ -3124,11 +3284,10 @@ static void cmd_idle(char *tag)
     struct timespec deadline = { 0, 0 };
 
     if (idle_timeout == -1) {
-        idle_timeout = config_getint(IMAPOPT_IMAPIDLETIMEOUT);
+        idle_timeout = config_getduration(IMAPOPT_IMAPIDLETIMEOUT, 'm');
         if (idle_timeout <= 0) {
-            idle_timeout = config_getint(IMAPOPT_TIMEOUT);
+            idle_timeout = config_getduration(IMAPOPT_TIMEOUT, 'm');
         }
-        idle_timeout *= 60; /* unit is minutes */
     }
 
     if (idle_timeout > 0) {
@@ -3201,7 +3360,7 @@ static void cmd_idle(char *tag)
 
         /* get polling period */
         if (idle_period == -1) {
-            idle_period = config_getint(IMAPOPT_IMAPIDLEPOLL);
+            idle_period = config_getduration(IMAPOPT_IMAPIDLEPOLL, 's');
         }
 
         if (CAPA(backend_current, CAPA_IDLE)) {
@@ -3323,6 +3482,10 @@ static void capa_response(int flags)
         if (config_getswitch(IMAPOPT_PROXYD_DISABLE_MAILBOX_REFERRALS) &&
             !strcmp(capa, "MAILBOX-REFERRALS"))
             continue;
+        /* Don't show "ANNOTATEMORE" if not enabled by config */
+        if (!config_getswitch(IMAPOPT_ANNOTATION_ENABLE_LEGACY_COMMANDS) &&
+            !strcmp(capa, "ANNOTATEMORE"))
+            continue;
         /* Don't show if they're not shown at this level of login */
         if (!(base_capabilities[i].mask & flags))
             continue;
@@ -3365,6 +3528,10 @@ static void capa_response(int flags)
 
     if (!(flags & CAPA_POSTAUTH)) return;
 
+    if (imapd_authstate && imapd_userisadmin) {
+        prot_printf(imapd_out, " UNAUTHENTICATE");
+    }
+
     if (config_getswitch(IMAPOPT_CONVERSATIONS))
         prot_printf(imapd_out, " XCONVERSATIONS");
 
@@ -3719,6 +3886,8 @@ static void cmd_append(char *tag, char *
     struct appendstage *curstage;
     mbentry_t *mbentry = NULL;
 
+    memset(&appendstate, 0, sizeof(struct appendstate));
+
     /* See if we can append */
     char *intname = mboxname_from_external(name, &imapd_namespace, imapd_userid);
     r = mlookup(tag, name, intname, &mbentry);
@@ -3941,6 +4110,10 @@ static void cmd_append(char *tag, char *
                          EVENT_MESSAGE_APPEND);
     }
     if (!r) {
+        /* make sure appending to this mailbox is allowed */
+        r = insert_into_mailbox_allowed(appendstate.mailbox);
+    }
+    if (!r) {
         struct body *body;
 
         doappenduid = (appendstate.myrights & ACL_READ);
@@ -3950,13 +4123,15 @@ static void cmd_append(char *tag, char *
             curstage = stages.data[i];
             body = NULL;
             if (curstage->binary) {
-                r = message_parse_binary_file(curstage->f, &body);
+                /* XXX we might have fname here, but it's hidden inside opaque
+                 * curstage->stage field */
+                r = message_parse_binary_file(curstage->f, &body, NULL);
                 fclose(curstage->f);
                 curstage->f = NULL;
             }
             if (!r) {
                 r = append_fromstage(&appendstate, &body, curstage->stage,
-                                     curstage->internaldate,
+                                     curstage->internaldate, /*createdmodseq*/0,
                                      &curstage->flags, 0,
                                      curstage->annotations);
             }
@@ -3968,12 +4143,11 @@ static void cmd_append(char *tag, char *
                 body = NULL;
             }
         }
-
-        if (!r) {
-            r = append_commit(&appendstate);
-        } else {
-            append_abort(&appendstate);
-        }
+    }
+    if (!r) {
+        r = append_commit(&appendstate);
+    } else {
+        append_abort(&appendstate);
     }
 
     imapd_check(NULL, 1);
@@ -3984,17 +4158,24 @@ static void cmd_append(char *tag, char *
         prot_printf(imapd_out, "%s NO [BADURL \"%s\"] %s\r\n",
                     tag, url, parseerr);
     } else if (r) {
+        const char *respcode = "";
+        if (r == IMAP_MAILBOX_NOTSUPPORTED) {
+            respcode = "[CANNOT] ";
+        }
+        else if (r == IMAP_MESSAGE_TOO_LARGE) {
+            respcode = "[TOOBIG] ";
+        }
+        else if (r == IMAP_MAILBOX_NONEXISTENT &&
+                 mboxlist_createmailboxcheck(intname, 0, 0,
+                                             imapd_userisadmin,
+                                             imapd_userid, imapd_authstate,
+                                             NULL, NULL, 0) == 0) {
+            respcode = "[TRYCREATE] ";
+        }
         prot_printf(imapd_out, "%s NO %s%s\r\n",
-                    tag,
-                    (r == IMAP_MAILBOX_NONEXISTENT &&
-                     mboxlist_createmailboxcheck(intname, 0, 0,
-                                                 imapd_userisadmin,
-                                                 imapd_userid, imapd_authstate,
-                                                 NULL, NULL, 0) == 0)
-                    ? "[TRYCREATE] " : r == IMAP_MESSAGE_TOO_LARGE
-                    ? "[TOOBIG]" : "", error_message(r));
+                    tag, respcode, error_message(r));
     } else if (doappenduid) {
-        /* is this a space seperated list or sequence list? */
+        /* is this a space separated list or sequence list? */
         prot_printf(imapd_out, "%s OK [APPENDUID %lu ", tag, uidvalidity);
         if (appendstate.nummsg == 1) {
             prot_printf(imapd_out, "%u", appendstate.baseuid);
@@ -4106,6 +4287,7 @@ static void cmd_select(char *tag, char *
     struct backend *backend_next = NULL;
     struct index_init init;
     int wasopen = 0;
+    int allowdeleted = config_getswitch(IMAPOPT_ALLOWDELETED);
     struct vanished_params *v = &init.vanished;
 
     memset(&init, 0, sizeof(struct index_init));
@@ -4175,6 +4357,9 @@ static void cmd_select(char *tag, char *
                  */
                 ;
             }
+            else if (allowdeleted && !strcmp(arg.s, "VENDOR.CMU-INCLUDE-EXPUNGED")) {
+                init.want_expunged = 1;
+            }
             else {
                 prot_printf(imapd_out, "%s BAD Invalid %s modifier %s\r\n",
                             tag, cmd, arg.s);
@@ -4204,6 +4389,8 @@ static void cmd_select(char *tag, char *
     }
 
     if (imapd_index) {
+        if (config_getswitch(IMAPOPT_AUTOEXPUNGE) && index_hasrights(imapd_index, ACL_EXPUNGE))
+            index_expunge(imapd_index, NULL, 1);
         index_close(&imapd_index);
         wasopen = 1;
     }
@@ -4329,7 +4516,10 @@ static void cmd_select(char *tag, char *
     init.select = 1;
     if (!strcasecmpsafe(imapd_magicplus, "+dav")) init.want_dav = 1;
 
-    r = index_open(intname, &init, &imapd_index);
+    if (!imapd_userisadmin && !allowdeleted && mboxname_isdeletedmailbox(intname, NULL))
+        r = IMAP_MAILBOX_NONEXISTENT;
+    else
+        r = index_open(intname, &init, &imapd_index);
     if (!r) doclose = 1;
 
     if (!r && !index_hasrights(imapd_index, ACL_READ)) {
@@ -4394,7 +4584,7 @@ static void cmd_close(char *tag, char *c
     }
 
     /* local mailbox */
-    if ((cmd[0] == 'C') && index_hasrights(imapd_index, ACL_EXPUNGE)) {
+    if ((cmd[0] == 'C' || config_getswitch(IMAPOPT_AUTOEXPUNGE)) && index_hasrights(imapd_index, ACL_EXPUNGE)) {
         index_expunge(imapd_index, NULL, 1);
         /* don't tell changes here */
     }
@@ -4524,7 +4714,11 @@ badannotation:
             break;
 
         case 'B':
-            if (!strncmp(fetchatt.s, "BINARY[", 7) ||
+            if (!strcmp(fetchatt.s, "BASECID") &&
+                config_getswitch(IMAPOPT_CONVERSATIONS)) {
+                fa->fetchitems |= FETCH_BASECID;
+            }
+            else if (!strncmp(fetchatt.s, "BINARY[", 7) ||
                 !strncmp(fetchatt.s, "BINARY.PEEK[", 12) ||
                 !strncmp(fetchatt.s, "BINARY.SIZE[", 12)) {
                 int binsize = 0;
@@ -4554,7 +4748,9 @@ badannotation:
                 }
                 p++;
 
-                if (!binsize) PARSE_PARTIAL(oi.start_octet, oi.octet_count);
+                if (!binsize) {
+                    PARSE_PARTIAL(oi.start_octet, oi.octet_count);
+                }
 
                 if (*p) {
                     prot_printf(imapd_out, "%s BAD Junk after binary section\r\n", tag);
@@ -4705,6 +4901,9 @@ badannotation:
                 config_getswitch(IMAPOPT_CONVERSATIONS)) {
                 fa->fetchitems |= FETCH_CID;
             }
+            else if (!strcmp(fetchatt.s, "CREATEDMODSEQ")) {
+                fa->fetchitems |= FETCH_CREATEDMODSEQ;
+            }
             else goto badatt;
             break;
 
@@ -4719,6 +4918,9 @@ badannotation:
             if (!strcmp(fetchatt.s, "ENVELOPE")) {
                 fa->fetchitems |= FETCH_ENVELOPE;
             }
+            else if (!strcmp(fetchatt.s, "EMAILID")) {
+                fa->fetchitems |= FETCH_EMAILID;
+            }
             else goto badatt;
             break;
 
@@ -4745,13 +4947,59 @@ badannotation:
             else goto badatt;
             break;
 
+        case 'L':
+            if (!strcmp(fetchatt.s, "LASTUPDATED")) {
+                fa->fetchitems |= FETCH_LASTUPDATED;
+            }
+            else goto badatt;
+            break;
+
         case 'M':
-            if (!strcmp(fetchatt.s, "MODSEQ")) {
+            if (config_getswitch(IMAPOPT_CONVERSATIONS)
+                && !strcmp(fetchatt.s, "MAILBOXES")) {
+                fa->fetchitems |= FETCH_MAILBOXES;
+            }
+            else if (config_getswitch(IMAPOPT_CONVERSATIONS)
+                && !strcmp(fetchatt.s, "MAILBOXIDS")) {
+                fa->fetchitems |= FETCH_MAILBOXIDS;
+            }
+            else if (!strcmp(fetchatt.s, "MODSEQ")) {
                 fa->fetchitems |= FETCH_MODSEQ;
             }
             else goto badatt;
             break;
 
+        case 'P':
+            if (!strcmp(fetchatt.s, "PREVIEW")) {
+                fa->fetchitems |= FETCH_PREVIEW;
+                if (c == ' ') {
+                    c = prot_getc(imapd_in);
+                    if (c == '(') {
+                        c = ' ';
+                        while (c == ' ') {
+                            c = getword(imapd_in, &fieldname);
+                            if (strcasecmp(fieldname.s, "") && strcasecmp(fieldname.s, "FUZZY") && strcasecmp(fieldname.s, "LAZY=FUZZY")) {
+                                prot_printf(imapd_out, "%s BAD FETCH contains invalid preview algorithm name (%s)\r\n", tag, fieldname.s);
+                                eatline(imapd_in, c);
+                                goto freeargs;
+                            }
+                        }
+                        if (c == ')') c = prot_getc(imapd_in);
+                        else {
+                            prot_printf(imapd_out, "%s BAD PREVIEW list not finished.\r\n", tag);
+                            eatline(imapd_in, c);
+                            goto freeargs;
+                        }
+                    }
+                    else {
+                        prot_ungetc(c, imapd_in);
+                        c = ' ';
+                    }
+                }
+            }
+            else goto badatt;
+            break;
+
         case 'R':
             if (!strcmp(fetchatt.s, "RFC822")) {
                 fa->fetchitems |= FETCH_RFC822|FETCH_SETSEEN;
@@ -4830,6 +5078,20 @@ badannotation:
             else goto badatt;
             break;
 
+        case 'S':
+            if (!strcmp(fetchatt.s, "SAVEDATE")) {
+                fa->fetchitems |= FETCH_SAVEDATE;
+            }
+            else goto badatt;
+            break;
+
+        case 'T':
+            if (!strcmp(fetchatt.s, "THREADID")) {
+                fa->fetchitems |= FETCH_THREADID;
+            }
+            else goto badatt;
+            break;
+
         case 'U':
             if (!strcmp(fetchatt.s, "UID")) {
                 fa->fetchitems |= FETCH_UID;
@@ -4941,7 +5203,7 @@ badannotation:
         }
     }
 
-    if (fa->fetchitems & (FETCH_ANNOTATION|FETCH_FOLDER)) {
+    if (fa->fetchitems & (FETCH_ANNOTATION|FETCH_FOLDER|FETCH_MAILBOXES)) {
         fa->namespace = &imapd_namespace;
         fa->userid = imapd_userid;
     }
@@ -4949,6 +5211,17 @@ badannotation:
         fa->isadmin = imapd_userisadmin || imapd_userisproxyadmin;
         fa->authstate = imapd_authstate;
     }
+    if (config_getswitch(IMAPOPT_CONVERSATIONS)
+        && (fa->fetchitems & (FETCH_MAILBOXIDS|FETCH_MAILBOXES))) {
+        // annoyingly, this codepath COULD be called from xconv* commands, but it never is,
+        // in reality, so it's safe leaving this as shared
+        int r = conversations_open_user(imapd_userid, 0/*shared*/, &fa->convstate);
+        if (r) {
+            syslog(LOG_WARNING, "error opening conversations for %s: %s",
+                                imapd_userid,
+                                error_message(r));
+        }
+    }
 
     strarray_free(newfields);
     return 0;
@@ -4968,6 +5241,7 @@ static void fetchargs_fini (struct fetch
     strarray_fini(&fa->headers_not);
     strarray_fini(&fa->entries);
     strarray_fini(&fa->attribs);
+    conversations_commit(&fa->convstate);
 
     memset(fa, 0, sizeof(struct fetchargs));
 }
@@ -5202,6 +5476,7 @@ static int do_xbackup(const char *channe
         if (!mbname) continue;
         const char *userid = mbname_userid(mbname);
         const char *intname = mbname_intname(mbname);
+        const char *extname = mbname_extname(mbname, &imapd_namespace, NULL);
 
         if (userid) {
             syslog(LOG_INFO, "XBACKUP: replicating user %s", userid);
@@ -5223,14 +5498,14 @@ static int do_xbackup(const char *channe
         if (r) {
             prot_printf(imapd_out, "* NO %s %s (%s)\r\n",
                         userid ? "USER" : "MAILBOX",
-                        userid ? userid : intname,
+                        userid ? userid : extname,
                         error_message(r));
         }
         else {
             partial_success++;
             prot_printf(imapd_out, "* OK %s %s\r\n",
                         userid ? "USER" : "MAILBOX",
-                        userid ? userid : intname);
+                        userid ? userid : extname);
         }
         prot_flush(imapd_out);
 
@@ -5260,13 +5535,9 @@ done:
 static int xbackup_addmbox(struct findall_data *data, void *rock)
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
     ptrarray_t *list = (ptrarray_t *) rock;
 
-    if (!data->mbname) {
-        /* No partial matches */ /* FIXME ??? */
-        return 0;
-    }
-
     /* Only add shared mailboxes or user INBOXes */
     if (!mbname_localpart(data->mbname) ||
         (!mbname_isdeleted(data->mbname) &&
@@ -5284,7 +5555,7 @@ void cmd_xbackup(const char *tag,
                  const char *channel)
 {
     ptrarray_t list = PTRARRAY_INITIALIZER;
-    int i, r = 0;
+    int i, r;
 
     /* admins only please */
     if (!imapd_userisadmin && !imapd_userisproxyadmin) {
@@ -5366,7 +5637,8 @@ void cmd_xconvmeta(const char *tag)
         goto done;
     }
 
-    r = conversations_open_user(imapd_userid, &state);
+    // this one is OK, xconvmeta doesn't do an expunge
+    r = conversations_open_user(imapd_userid, 1/*shared*/, &state);
     if (r) {
         prot_printf(imapd_out, "%s BAD failed to open db: %s\r\n",
                     tag, error_message(r));
@@ -5523,7 +5795,8 @@ static int do_xconvfetch(struct dlist *c
     struct index_init init;
     int i;
 
-    r = conversations_open_user(imapd_userid, &state);
+    // this one expunges each mailbox it enters, so we need to lock exclusively
+    r = conversations_open_user(imapd_userid, 0/*shared*/, &state);
     if (r) goto out;
 
     construct_hash_table(&wanted_cids, 1024, 0);
@@ -5988,7 +6261,8 @@ void cmd_xconvsort(char *tag, int update
 
     /* open the conversations state first - we don't care if it fails,
      * because that probably just means it's already open */
-    conversations_open_mbox(index_mboxname(imapd_index), &cstate);
+    // this codepath might expunge, so we can't open shared
+    conversations_open_mbox(index_mboxname(imapd_index), 0/*shared*/, &cstate);
 
     if (updates) {
         /* in XCONVUPDATES, need to force a re-read from scratch into
@@ -6131,7 +6405,8 @@ static void cmd_xconvmultisort(char *tag
 
     /* open the conversations state first - we don't care if it fails,
      * because that probably just means it's already open */
-    conversations_open_mbox(index_mboxname(imapd_index), &cstate);
+    // this codepath might expunge, so we can't open shared
+    conversations_open_mbox(index_mboxname(imapd_index), 0/*shared*/, &cstate);
 
     /* need index loaded to even parse searchargs! */
     searchargs = new_searchargs(tag, GETSEARCH_CHARSET_FIRST,
@@ -6507,13 +6782,19 @@ static void cmd_copy(char *tag, char *se
   done:
 
     if (r && !(usinguid && r == IMAP_NO_NOSUCHMSG)) {
+        const char *respcode = "";
+        if (r == IMAP_MAILBOX_NOTSUPPORTED) {
+            respcode = "[CANNOT] ";
+        }
+        else if (r == IMAP_MAILBOX_NONEXISTENT &&
+                 mboxlist_createmailboxcheck(intname, 0, 0,
+                                             imapd_userisadmin,
+                                             imapd_userid, imapd_authstate,
+                                             NULL, NULL, 0) == 0) {
+            respcode = "[TRYCREATE] ";
+        }
         prot_printf(imapd_out, "%s NO %s%s\r\n", tag,
-                    (r == IMAP_MAILBOX_NONEXISTENT &&
-                     mboxlist_createmailboxcheck(intname, 0, 0,
-                                                 imapd_userisadmin,
-                                                 imapd_userid, imapd_authstate,
-                                                 NULL, NULL, 0) == 0)
-                    ? "[TRYCREATE] " : "", error_message(r));
+                    respcode, error_message(r));
     }
     else if (copyuid) {
             prot_printf(imapd_out, "%s OK [COPYUID %s] %s\r\n", tag,
@@ -6582,10 +6863,14 @@ static void cmd_create(char *tag, char *
 {
     int r = 0;
     int mbtype = 0;
+    int options = 0;
     const char *partition = NULL;
     const char *server = NULL;
+    const char *uniqueid = NULL;
     struct buf specialuse = BUF_INITIALIZER;
     struct dlist *use;
+    struct mailbox *mailbox = NULL;
+    char *mailboxid = NULL;
 
     /* We don't care about trailing hierarchy delimiters. */
     if (name[0] && name[strlen(name)-1] == imapd_namespace.hier_sep) {
@@ -6594,13 +6879,13 @@ static void cmd_create(char *tag, char *
 
     mbname_t *mbname = mbname_from_extname(name, &imapd_namespace, imapd_userid);
 
-    dlist_getatom(extargs, "PARTITION", &partition);
-    dlist_getatom(extargs, "SERVER", &server);
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(mbname_intname(mbname));
 
     const char *type = NULL;
 
     dlist_getatom(extargs, "PARTITION", &partition);
     dlist_getatom(extargs, "SERVER", &server);
+    dlist_getatom(extargs, "MAILBOXID", &uniqueid);
     if (dlist_getatom(extargs, "TYPE", &type)) {
         if (!strcasecmp(type, "CALENDAR")) mbtype |= MBTYPE_CALENDAR;
         else if (!strcasecmp(type, "COLLECTION")) mbtype |= MBTYPE_COLLECTION;
@@ -6629,12 +6914,15 @@ static void cmd_create(char *tag, char *
         }
         raw = strarray_join(su, " ");
         strarray_free(su);
-        r = specialuse_validate(imapd_userid, raw, &specialuse);
+        r = specialuse_validate(NULL, imapd_userid, raw, &specialuse);
         free(raw);
         if (r) {
             prot_printf(imapd_out, "%s NO [USEATTR] %s\r\n", tag, error_message(r));
             goto done;
         }
+
+        if (strstr(buf_cstring(&specialuse), "\\Snoozed"))
+            options |= OPT_IMAP_HAS_ALARMS;
     }
 
     // A non-admin is not allowed to specify the server nor partition on which
@@ -6642,7 +6930,7 @@ static void cmd_create(char *tag, char *
     //
     // However, this only applies to frontends. If we're a backend, a frontend will
     // proxy the partition it wishes to create the mailbox on.
-    if ((server || partition) && !imapd_userisadmin) {
+    if ((server || partition || uniqueid) && !imapd_userisadmin) {
         if (config_mupdate_config == IMAP_ENUM_MUPDATE_CONFIG_STANDARD ||
             config_mupdate_config == IMAP_ENUM_MUPDATE_CONFIG_UNIFIED) {
 
@@ -6759,14 +7047,29 @@ static void cmd_create(char *tag, char *
                     prot_printastring(s_conn->out, name);
 
                     // special use needs extended support, so pass through extargs
-                    if (specialuse.len) {
-                        prot_printf(s_conn->out, " (USE (%s)", buf_cstring(&specialuse));
+                    if (specialuse.len || uniqueid) {
+                        prot_printf(s_conn->out, " (");
+                        int printsp = 0;
+                        if (specialuse.len) {
+                            if (printsp) prot_putc(' ', s_conn->out);
+                            printsp = 1;
+                            prot_printf(s_conn->out, "USE (%s)", buf_cstring(&specialuse));
+                        }
 
                         if (partition) {
-                            prot_printf(s_conn->out, " PARTITION ");
+                            if (printsp) prot_putc(' ', s_conn->out);
+                            printsp = 1;
+                            prot_printf(s_conn->out, "PARTITION ");
                             prot_printastring(s_conn->out, partition);
                         }
 
+                        if (uniqueid) {
+                            if (printsp) prot_putc(' ', s_conn->out);
+                            printsp = 1;
+                            prot_printf(s_conn->out, "MAILBOXID ");
+                            prot_printastring(s_conn->out, uniqueid);
+                        }
+
                         prot_putc(')', s_conn->out);
                     }
 
@@ -6824,24 +7127,26 @@ static void cmd_create(char *tag, char *
     }
 
 localcreate:
-    r = mboxlist_createmailbox(
-            mbname_intname(mbname),                             // const char name
+    r = mboxlist_createmailbox_opts(
+            mbname_intname(mbname),                             // const char *name
             mbtype,                                             // int mbtype
-            partition,                                          // const char partition
+            partition,                                          // const char *partition
             imapd_userisadmin || imapd_userisproxyadmin,        // int isadmin
-            imapd_userid,                                       // const char userid
-            imapd_authstate,                                    // struct auth_state auth_state
+            imapd_userid,                                       // const char *userid
+            imapd_authstate,                                    // struct auth_state *auth_state
+            options,                                            // options
             localonly,                                          // int localonly
             localonly,                                          // int forceuser
             0,                                                  // int dbonly
             1,                                                  // int notify
-            NULL                                                // struct mailbox mailboxptr
+            uniqueid,                                           // const char *uniqueid
+            &mailbox                                            // struct mailbox **mailboxptr
         );
 
 #ifdef USE_AUTOCREATE
     // Clausing autocreate for the INBOX
     if (r == IMAP_PERMISSION_DENIED) {
-        if (!strcasecmp(name, "INBOX")) {
+        if (!strarray_size(mbname_boxes(mbname)) && !strcmpsafe(imapd_userid, mbname_userid(mbname))) {
             int autocreatequotastorage = config_getint(IMAPOPT_AUTOCREATE_QUOTA);
 
             if (autocreatequotastorage > 0) {
@@ -6856,7 +7161,7 @@ localcreate:
                         0,
                         0,
                         1,
-                        NULL
+                        &mailbox
                     );
 
                 if (r) {
@@ -6877,35 +7182,21 @@ localcreate:
                     newquotas[QUOTA_STORAGE] = autocreatequotastorage;
                     newquotas[QUOTA_MESSAGE] = autocreatequotamessage;
 
-                    (void) mboxlist_setquotas(mbname_intname(mbname), newquotas, 0);
-                } // (autocreatequotastorage > 0) || (autocreatequotamessage > 0)
-
-            } else { // (autocreatequotastorage = config_getint(IMAPOPT_AUTOCREATEQUOTA))
-                prot_printf(imapd_out, "%s NO %s\r\n", tag, error_message(IMAP_PERMISSION_DENIED));
-                goto done;
-
-            } // (autocreatequotastorage = config_getint(IMAPOPT_AUTOCREATEQUOTA))
-
-        } else { // (!strcasecmp(name, "INBOX"))
-            prot_printf(imapd_out, "%s NO %s\r\n", tag, error_message(IMAP_PERMISSION_DENIED));
-            goto done;
-        } // (!strcasecmp(name, "INBOX"))
-
-    } else if (r) { // (r == IMAP_PERMISSION_DENIED)
-        prot_printf(imapd_out, "%s NO %s\r\n", tag, error_message(r));
-        goto done;
-
-    } else { // (r == IMAP_PERMISSION_DENIED)
-        /* no error: carry on */
-    } // (r == IMAP_PERMISSION_DENIED)
+                    (void) mboxlist_setquotas(mbname_intname(mbname), newquotas, 0, 0);
+                }
+            }
+        }
+    }
+#endif
 
-#else // USE_AUTOCREATE
     if (r) {
         prot_printf(imapd_out, "%s NO %s\r\n", tag, error_message(r));
         goto done;
+    }
 
-    } // (r)
-#endif // USE_AUTOCREATE
+    /* Close newly created mailbox before writing annotations */
+    mailboxid = xstrdup(mailbox->uniqueid);
+    mailbox_close(&mailbox);
 
     if (specialuse.len) {
         r = annotatemore_write(mbname_intname(mbname), "/specialuse", mbname_userid(mbname), &specialuse);
@@ -6926,13 +7217,16 @@ localcreate:
         }
     }
 
-    prot_printf(imapd_out, "%s OK Completed\r\n", tag);
+    prot_printf(imapd_out, "%s OK [MAILBOXID (%s)] Completed\r\n", tag, mailboxid);
 
     imapd_check(NULL, 0);
 
 done:
+    mboxname_release(&namespacelock);
+    mailbox_close(&mailbox);
     buf_free(&specialuse);
     mbname_free(&mbname);
+    free(mailboxid);
 }
 
 /* Callback for use by cmd_delete */
@@ -6944,18 +7238,18 @@ static int delmbox(const mbentry_t *mben
         r = mboxlist_deletemailbox(mbentry->name,
                                    imapd_userisadmin || imapd_userisproxyadmin,
                                    imapd_userid, imapd_authstate, NULL,
-                                   0, 0, 0);
+                                   0, 0, 0, 0);
     } else if ((imapd_userisadmin || imapd_userisproxyadmin) &&
                mboxname_isdeletedmailbox(mbentry->name, NULL)) {
         r = mboxlist_deletemailbox(mbentry->name,
                                    imapd_userisadmin || imapd_userisproxyadmin,
                                    imapd_userid, imapd_authstate, NULL,
-                                   0, 0, 0);
+                                   0, 0, 0, 0);
     } else {
         r = mboxlist_delayed_deletemailbox(mbentry->name,
                                            imapd_userisadmin || imapd_userisproxyadmin,
                                            imapd_userid, imapd_authstate, NULL,
-                                           0, 0, 0);
+                                           0, 0, 0, 0);
     }
 
     if (r) {
@@ -6974,9 +7268,9 @@ static void cmd_delete(char *tag, char *
     int r;
     mbentry_t *mbentry = NULL;
     struct mboxevent *mboxevent = NULL;
+    mbname_t *mbname = mbname_from_extname(name, &imapd_namespace, imapd_userid);
 
-    char *intname = mboxname_from_external(name, &imapd_namespace, imapd_userid);
-    r = mlookup(NULL, NULL, intname, &mbentry);
+    r = mlookup(NULL, NULL, mbname_intname(mbname), &mbentry);
 
     if (!r && (mbentry->mbtype & MBTYPE_REMOTE)) {
         /* remote mailbox */
@@ -6987,7 +7281,7 @@ static void cmd_delete(char *tag, char *
             imapd_refer(tag, mbentry->server, name);
             referral_kick = 1;
             mboxlist_entry_free(&mbentry);
-            free(intname);
+            mbname_free(&mbname);
             return;
         }
 
@@ -7020,31 +7314,33 @@ static void cmd_delete(char *tag, char *
             prot_printf(imapd_out, "%s %s", tag, s->last_result.s);
         }
 
-        free(intname);
+        mbname_free(&mbname);
         return;
     }
     mboxlist_entry_free(&mbentry);
 
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(mbname_intname(mbname));
+
     mboxevent = mboxevent_new(EVENT_MAILBOX_DELETE);
 
     /* local mailbox */
     if (!r) {
         if (localonly || !mboxlist_delayed_delete_isenabled()) {
-            r = mboxlist_deletemailbox(intname,
+            r = mboxlist_deletemailbox(mbname_intname(mbname),
                                        imapd_userisadmin || imapd_userisproxyadmin,
                                        imapd_userid, imapd_authstate, mboxevent,
-                                       1-force, localonly, 0);
+                                       1-force, localonly, 0, 0);
         } else if ((imapd_userisadmin || imapd_userisproxyadmin) &&
-                   mboxname_isdeletedmailbox(intname, NULL)) {
-            r = mboxlist_deletemailbox(intname,
+                   mbname_isdeleted(mbname)) {
+            r = mboxlist_deletemailbox(mbname_intname(mbname),
                                        imapd_userisadmin || imapd_userisproxyadmin,
                                        imapd_userid, imapd_authstate, mboxevent,
-                                       0 /* checkacl */, localonly, 0);
+                                       0 /* checkacl */, localonly, 0, 0);
         } else {
-            r = mboxlist_delayed_deletemailbox(intname,
+            r = mboxlist_delayed_deletemailbox(mbname_intname(mbname),
                                                imapd_userisadmin || imapd_userisproxyadmin,
                                                imapd_userid, imapd_authstate, mboxevent,
-                                               1-force, 0, 0);
+                                               1-force, 0, 0, 0);
         }
     }
 
@@ -7055,17 +7351,18 @@ static void cmd_delete(char *tag, char *
 
     /* was it a top-level user mailbox? */
     /* localonly deletes are only per-mailbox */
-    if (!r && !localonly && mboxname_isusermailbox(intname, 1)) {
-        char *userid = mboxname_to_userid(intname);
+    if (!r && !localonly && mboxname_isusermailbox(mbname_intname(mbname), 1)) {
+        const char *userid = mbname_userid(mbname);
         if (userid) {
-            r = mboxlist_usermboxtree(userid, delmbox, NULL, 0);
+            r = mboxlist_usermboxtree(userid, NULL, delmbox, NULL, 0);
             if (!r) r = user_deletedata(userid, 1);
-            free(userid);
         }
     }
 
+    mboxname_release(&namespacelock);
+
     if (!r && config_getswitch(IMAPOPT_DELETE_UNSUBSCRIBE)) {
-        mboxlist_changesub(intname, imapd_userid, imapd_authstate,
+        mboxlist_changesub(mbname_intname(mbname), imapd_userid, imapd_authstate,
                            /* add */ 0, /* force */ 0, /* notify? */ 1);
     }
 
@@ -7081,7 +7378,7 @@ static void cmd_delete(char *tag, char *
         prot_printf(imapd_out, "%s OK %s\r\n", tag,
                     error_message(IMAP_OK_COMPLETED));
     }
-    free(intname);
+    mbname_free(&mbname);
 }
 
 struct renrock
@@ -7134,7 +7431,7 @@ static int renmbox(const mbentry_t *mben
     r = mboxlist_lookup_allow_all(text->newmailboxname, &newmbentry, NULL);
     /* XXX - otherwise we should probably reject now, but meh, save it for
      * a real cleanup */
-    if (!r && newmbentry->mbtype == MBTYPE_DELETED) {
+    if (!r && (newmbentry->mbtype & MBTYPE_DELETED)) {
         /* changing the unique id since last time? */
         if (strcmpsafe(mbentry->uniqueid, newmbentry->uniqueid)) {
             /* then the UIDVALIDITY must be higher than before */
@@ -7146,10 +7443,15 @@ static int renmbox(const mbentry_t *mben
 
 
     /* don't notify implied rename in mailbox hierarchy */
-    r = mboxlist_renamemailbox(mbentry->name, text->newmailboxname,
+    r = mboxlist_renamemailbox(mbentry, text->newmailboxname,
                                text->partition, uidvalidity,
                                1, imapd_userid, imapd_authstate, NULL, 0, 0,
-                               text->rename_user);
+                               text->rename_user, 0, 0, 0);
+
+    if (!r && config_getswitch(IMAPOPT_DELETE_UNSUBSCRIBE)) {
+        mboxlist_changesub(mbentry->name, imapd_userid, imapd_authstate,
+                           /* add */ 0, /* force */ 0, /* notify? */ 0);
+    }
 
     oldextname =
         mboxname_to_external(mbentry->name, &imapd_namespace, imapd_userid);
@@ -7181,6 +7483,18 @@ done:
     return r;
 }
 
+/* Callback for use by cmd_rename */
+static int checkrenmacl(const mbentry_t *mbentry, void *rock)
+{
+    const struct auth_state *auth_state = (struct auth_state *) rock;
+    long myrights = cyrus_acl_myrights(auth_state, mbentry->acl);
+
+    if (myrights & ACL_DELETEMBOX) return IMAP_OK_COMPLETED;
+
+    return (myrights & ACL_LOOKUP) ?
+        IMAP_PERMISSION_DENIED : IMAP_MAILBOX_NONEXISTENT;
+}
+
 /*
  * Perform a RENAME command
  */
@@ -7222,21 +7536,54 @@ static void cmd_rename(char *tag, char *
     }
 
     oldintname = mboxname_from_external(oldname, &imapd_namespace, imapd_userid);
-    strncpy(oldmailboxname, oldintname, MAX_MAILBOX_NAME);
+    xstrncpy(oldmailboxname, oldintname, MAX_MAILBOX_NAME);
     free(oldintname);
 
     newintname = mboxname_from_external(newname, &imapd_namespace, imapd_userid);
-    strncpy(newmailboxname, newintname, MAX_MAILBOX_NAME);
+    xstrncpy(newmailboxname, newintname, MAX_MAILBOX_NAME);
     free(newintname);
 
     olduser = mboxname_to_userid(oldmailboxname);
     newuser = mboxname_to_userid(newmailboxname);
 
+    struct mboxlock *oldnamespacelock = NULL;
+    struct mboxlock *newnamespacelock = NULL;
+
+    if (strcmpsafe(oldmailboxname, newmailboxname) < 0) {
+        oldnamespacelock = mboxname_usernamespacelock(oldmailboxname);
+        newnamespacelock = mboxname_usernamespacelock(newmailboxname);
+    }
+    else {
+        newnamespacelock = mboxname_usernamespacelock(newmailboxname);
+        oldnamespacelock = mboxname_usernamespacelock(oldmailboxname);
+    }
+
     /* Keep temporary copy: master is trashed */
     strcpy(oldmailboxname2, oldmailboxname);
     strcpy(newmailboxname2, newmailboxname);
 
     r = mlookup(NULL, NULL, oldmailboxname, &mbentry);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* Check if the base mailbox is an intermediate */
+        r = mboxlist_lookup_allow_all(oldmailboxname, &mbentry, 0);
+
+        if (!r) {
+            if (mbentry->mbtype & (MBTYPE_RESERVE | MBTYPE_DELETED)) {
+                r = IMAP_MAILBOX_NONEXISTENT;
+            }
+            else if (!imapd_userisadmin &&
+                     (mbentry->mbtype & MBTYPE_INTERMEDIATE)) {
+                /* Make sure we can rename the first child */
+                r = mboxlist_allmbox(oldmailboxname,
+                                     checkrenmacl, imapd_authstate, 0);
+                if (r == IMAP_OK_COMPLETED) r = 0;
+            }
+        }
+    }
+    if (r) {
+        prot_printf(imapd_out, "%s NO %s\r\n", tag, error_message(r));
+        goto done;
+    }
 
     if (!r && mbentry->mbtype & MBTYPE_REMOTE) {
         /* remote mailbox */
@@ -7424,7 +7771,6 @@ static void cmd_rename(char *tag, char *
     if (!r) {
         struct mboxevent *mboxevent = NULL;
         uint32_t uidvalidity = mbentry ? mbentry->uidvalidity : 0;
-        const char *partition = mbentry ? mbentry->partition : NULL;
 
         /* don't send rename notification if we only change the partition */
         if (strcmp(oldmailboxname, newmailboxname))
@@ -7435,7 +7781,7 @@ static void cmd_rename(char *tag, char *
         r = mboxlist_lookup_allow_all(newmailboxname, &newmbentry, NULL);
         /* XXX - otherwise we should probably reject now, but meh, save it for
          * a real cleanup */
-        if (!r && newmbentry->mbtype == MBTYPE_DELETED) {
+        if (!r && (newmbentry->mbtype & MBTYPE_DELETED)) {
             /* changing the unique id since last time? */
             if (!mbentry || strcmpsafe(mbentry->uniqueid, newmbentry->uniqueid)) {
                 /* then the UIDVALIDITY must be higher than before */
@@ -7445,11 +7791,11 @@ static void cmd_rename(char *tag, char *
         }
         mboxlist_entry_free(&newmbentry);
 
-        r = mboxlist_renamemailbox(oldmailboxname, newmailboxname,
-                                   location ? location : partition,
+        r = mboxlist_renamemailbox(mbentry, newmailboxname,
+                                   location ? location : mbentry->partition,
                                    0 /* uidvalidity */, imapd_userisadmin,
                                    imapd_userid, imapd_authstate, mboxevent,
-                                   0, 0, rename_user);
+                                   0, 0, rename_user, 0, 0, 0);
 
         /* it's OK to not exist if there are subfolders */
         if (r == IMAP_MAILBOX_NONEXISTENT && subcount && !rename_user &&
@@ -7465,6 +7811,11 @@ static void cmd_rename(char *tag, char *
         if (!r)
             mboxevent_notify(&mboxevent);
         mboxevent_free(&mboxevent);
+
+        if (!r && config_getswitch(IMAPOPT_DELETE_UNSUBSCRIBE)) {
+            mboxlist_changesub(oldmailboxname, imapd_userid, imapd_authstate,
+                               /* add */ 0, /* force */ 0, /* notify? */ 1);
+        }
     }
 
     /* If we're renaming a user, take care of changing quotaroot, ACL,
@@ -7499,7 +7850,7 @@ submboxes:
 
         /* add submailboxes; we pretend we're an admin since we successfully
            renamed the parent - we're using internal names here */
-        r = mboxlist_allmbox(oldmailboxname, renmbox, &rock, 0);
+        r = mboxlist_allmbox(oldmailboxname, renmbox, &rock, MBOXTREE_INTERMEDIATES);
     }
 
     /* take care of deleting old ACLs, subscriptions, seen state and quotas */
@@ -7526,6 +7877,8 @@ submboxes:
     }
 
 done:
+    mboxname_release(&oldnamespacelock);
+    mboxname_release(&newnamespacelock);
     mboxlist_entry_free(&mbentry);
     free(oldextname);
     free(newextname);
@@ -7595,7 +7948,7 @@ static void cmd_reconstruct(const char *
             ret = snprintf(buf, sizeof(buf), "%s/reconstruct", SBIN_DIR);
             if(ret < 0 || ret >= (int) sizeof(buf)) {
                 /* in child, so fatailing won't disconnect our user */
-                fatal("reconstruct buffer not sufficiently big", EC_CONFIG);
+                fatal("reconstruct buffer not sufficiently big", EX_CONFIG);
             }
 
             if(recursive) {
@@ -7656,7 +8009,7 @@ static void cmd_reconstruct(const char *
             ret = snprintf(buf, sizeof(buf), "%s/quota", SBIN_DIR);
             if(ret < 0 || ret >= (int) sizeof(buf)) {
                 /* in child, so fatailing won't disconnect our user */
-                fatal("quota buffer not sufficiently big", EC_CONFIG);
+                fatal("quota buffer not sufficiently big", EX_CONFIG);
             }
 
             execl(buf, buf, "-C", config_filename, "-f", quotaroot, NULL);
@@ -7824,6 +8177,11 @@ static void cmd_list(char *tag, struct l
         list_data(listargs);
     }
 
+    if (global_conversations) {
+        conversations_abort(&global_conversations);
+        global_conversations = NULL;
+    }
+
     strarray_fini(&listargs->pat);
     strarray_fini(&listargs->metaitems);
 
@@ -7843,11 +8201,6 @@ static void cmd_list(char *tag, struct l
             prot_printf(imapd_out, " %u calls", list_callback_calls);
         prot_printf(imapd_out, ")\r\n");
     }
-
-    if (global_conversations) {
-        conversations_abort(&global_conversations);
-        global_conversations = NULL;
-    }
 }
 
 /*
@@ -8122,6 +8475,7 @@ static void cmd_myrights(const char *tag
     char *intname = mboxname_from_external(name, &imapd_namespace, imapd_userid);
 
     r = mlookup(tag, name, intname, &mbentry);
+    free(intname);
     if (r == IMAP_MAILBOX_MOVED) return;
 
     if (!r) r = printmyrights(name, mbentry);
@@ -8137,7 +8491,6 @@ static void cmd_myrights(const char *tag
 
     prot_printf(imapd_out, "%s OK %s\r\n", tag,
                 error_message(IMAP_OK_COMPLETED));
-    free(intname);
 }
 
 /*
@@ -8153,7 +8506,10 @@ static void cmd_setacl(char *tag, const
 
     /* is it remote? */
     r = mlookup(tag, name, intname, &mbentry);
-    if (r == IMAP_MAILBOX_MOVED) return;
+    if (r == IMAP_MAILBOX_MOVED) goto done;
+
+    if (!config_getswitch(IMAPOPT_ALLOWSETACL))
+        r = IMAP_DISABLED;
 
     if (!r && (mbentry->mbtype & MBTYPE_REMOTE)) {
         /* remote mailbox */
@@ -8169,12 +8525,9 @@ static void cmd_setacl(char *tag, const
             /* They aren't an admin remotely, so let's refer them */
             imapd_refer(tag, mbentry->server, name);
             referral_kick = 1;
-            mboxlist_entry_free(&mbentry);
-            return;
+            goto done;
         }
 
-        mboxlist_entry_free(&mbentry);
-
         if (!r) {
             if (rights) {
                 prot_printf(s->out,
@@ -8209,12 +8562,9 @@ static void cmd_setacl(char *tag, const
             prot_printf(imapd_out, "%s %s", tag, s->last_result.s);
         }
 
-        free(intname);
-        return;
+        goto done;
     }
 
-    mboxlist_entry_free(&mbentry);
-
     /* local mailbox */
     if (!r) {
         char *err;
@@ -8225,8 +8575,7 @@ static void cmd_setacl(char *tag, const
             if (r) {
                 prot_printf(imapd_out, "%s BAD %s\r\n", tag, err);
                 free(err);
-                free(intname);
-                return;
+                goto done;
             }
         }
 
@@ -8246,7 +8595,10 @@ static void cmd_setacl(char *tag, const
         prot_printf(imapd_out, "%s OK %s\r\n", tag,
                     error_message(IMAP_OK_COMPLETED));
     }
+
+done:
     free(intname);
+    mboxlist_entry_free(&mbentry);
 }
 
 static void print_quota_used(struct protstream *o, const struct quota *q)
@@ -8578,7 +8930,7 @@ void cmd_setquota(const char *tag, const
         return;
     }
 
-    r = mboxlist_setquotas(intname, newquotas, force);
+    r = mboxlist_setquotas(intname, newquotas, 0, force);
 
     imapd_check(NULL, 0);
 out:
@@ -8605,20 +8957,13 @@ out:
  * this implements the STARTTLS command, as described in RFC 2595.
  * one caveat: it assumes that no external layer is currently present.
  * if a client executes this command, information about the external
- * layer that was passed on the command line is disgarded. this should
+ * layer that was passed on the command line is discarded. this should
  * be fixed.
  */
 /* imaps - whether this is an imaps transaction or not */
 static void cmd_starttls(char *tag, int imaps)
 {
     int result;
-    int *layerp;
-
-    char *auth_id;
-    sasl_ssf_t ssf;
-
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
 
     if (imapd_starttls_done == 1)
     {
@@ -8654,8 +8999,7 @@ static void cmd_starttls(char *tag, int
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                imaps ? 180 : imapd_timeout,
-                               layerp,
-                               &auth_id,
+                               &saslprops,
                                &tls_conn);
 
     /* if error */
@@ -8671,28 +9015,17 @@ static void cmd_starttls(char *tag, int
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(imapd_saslconn, SASL_SSF_EXTERNAL, &ssf);
-    if (result == SASL_OK) {
-        saslprops.ssf = ssf;
+    result = saslprops_set_tls(&saslprops, imapd_saslconn);
 
-        result = sasl_setprop(imapd_saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    }
     if (result != SASL_OK) {
-        syslog(LOG_NOTICE, "sasl_setprop() failed: cmd_starttls()");
+        syslog(LOG_NOTICE, "saslprops_set_tls() failed: cmd_starttls()");
         if (imaps == 0) {
-            fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
+            fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
         } else {
             shut_down(0);
         }
     }
 
-    if(saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
-    }
-    if(auth_id)
-        saslprops.authid = xstrdup(auth_id);
-
     /* tell the prot layer about our new layers */
     prot_settls(imapd_in, tls_conn);
     prot_settls(imapd_out, tls_conn);
@@ -8709,7 +9042,7 @@ void cmd_starttls(char *tag __attribute_
                   int imaps __attribute__((unused)))
 {
     fatal("cmd_starttls() executed, but starttls isn't implemented!",
-          EC_SOFTWARE);
+          EX_SOFTWARE);
 }
 #endif // (OPENSSL_VERSION_NUMBER >= 0x0090800fL)
 
@@ -8721,10 +9054,10 @@ static int parse_statusitems(unsigned *s
     int hasconv = config_getswitch(IMAPOPT_CONVERSATIONS);
 
     c = prot_getc(imapd_in);
-    if (c != '(') return EOF;
+    if (c != '(') goto bad;
 
     c = getword(imapd_in, &arg);
-    if (arg.s[0] == '\0') return EOF;
+    if (arg.s[0] == '\0') goto bad;
     for (;;) {
         lcase(arg.s);
         if (!strcmp(arg.s, "messages")) {
@@ -8739,12 +9072,21 @@ static int parse_statusitems(unsigned *s
         else if (!strcmp(arg.s, "uidvalidity")) {
             statusitems |= STATUS_UIDVALIDITY;
         }
+        else if (!strcmp(arg.s, "mailboxid")) {
+            statusitems |= STATUS_MAILBOXID;
+        }
         else if (!strcmp(arg.s, "unseen")) {
             statusitems |= STATUS_UNSEEN;
         }
+        else if (!strcmp(arg.s, "size")) {
+            statusitems |= STATUS_SIZE;
+        }
         else if (!strcmp(arg.s, "highestmodseq")) {
             statusitems |= STATUS_HIGHESTMODSEQ;
         }
+        else if (!strcmp(arg.s, "createdmodseq")) {
+            statusitems |= STATUS_CREATEDMODSEQ;
+        }
         else if (hasconv && !strcmp(arg.s, "xconvexists")) {
             statusitems |= STATUS_XCONVEXISTS;
         }
@@ -8758,7 +9100,7 @@ static int parse_statusitems(unsigned *s
             static char buf[200];
             snprintf(buf, 200, "Invalid Status attributes %s", arg.s);
             *errstr = buf;
-            return EOF;
+            goto bad;
         }
 
         if (c == ' ') c = getword(imapd_in, &arg);
@@ -8767,13 +9109,17 @@ static int parse_statusitems(unsigned *s
 
     if (c != ')') {
         *errstr = "Missing close parenthesis in Status";
-        return EOF;
+        goto bad;
     }
     c = prot_getc(imapd_in);
 
     /* success */
     *statusitemsp = statusitems;
     return c;
+
+bad:
+    if (c != EOF) prot_ungetc(c, imapd_in);
+    return EOF;
 }
 
 static int print_statusline(const char *extname, unsigned statusitems,
@@ -8802,25 +9148,38 @@ static int print_statusline(const char *
         prot_printf(imapd_out, "%cUIDVALIDITY %u", sepchar, sd->uidvalidity);
         sepchar = ' ';
     }
+    if (statusitems & STATUS_MAILBOXID) {
+        prot_printf(imapd_out, "%cMAILBOXID (%s)", sepchar, sd->mailboxid);
+        sepchar = ' ';
+    }
     if (statusitems & STATUS_UNSEEN) {
         prot_printf(imapd_out, "%cUNSEEN %u", sepchar, sd->unseen);
         sepchar = ' ';
     }
+    if (statusitems & STATUS_SIZE) {
+        prot_printf(imapd_out, "%cSIZE %llu", sepchar, sd->size);
+        sepchar = ' ';
+    }
+    if (statusitems & STATUS_CREATEDMODSEQ) {
+        prot_printf(imapd_out, "%cCREATEDMODSEQ " MODSEQ_FMT,
+                    sepchar, sd->createdmodseq);
+        sepchar = ' ';
+    }
     if (statusitems & STATUS_HIGHESTMODSEQ) {
         prot_printf(imapd_out, "%cHIGHESTMODSEQ " MODSEQ_FMT,
                     sepchar, sd->highestmodseq);
         sepchar = ' ';
     }
     if (statusitems & STATUS_XCONVEXISTS) {
-        prot_printf(imapd_out, "%cXCONVEXISTS %u", sepchar, sd->xconv.exists);
+        prot_printf(imapd_out, "%cXCONVEXISTS %u", sepchar, sd->xconv.threadexists);
         sepchar = ' ';
     }
     if (statusitems & STATUS_XCONVUNSEEN) {
-        prot_printf(imapd_out, "%cXCONVUNSEEN %u", sepchar, sd->xconv.unseen);
+        prot_printf(imapd_out, "%cXCONVUNSEEN %u", sepchar, sd->xconv.threadunseen);
         sepchar = ' ';
     }
     if (statusitems & STATUS_XCONVMODSEQ) {
-        prot_printf(imapd_out, "%cXCONVMODSEQ " MODSEQ_FMT, sepchar, sd->xconv.modseq);
+        prot_printf(imapd_out, "%cXCONVMODSEQ " MODSEQ_FMT, sepchar, sd->xconv.threadmodseq);
         sepchar = ' ';
     }
 
@@ -8829,7 +9188,7 @@ static int print_statusline(const char *
     return 0;
 }
 
-static int imapd_statusdata(const char *mailboxname, unsigned statusitems,
+static int imapd_statusdata(const mbentry_t *mbentry, unsigned statusitems,
                             struct statusdata *sd)
 {
     int r;
@@ -8839,7 +9198,7 @@ static int imapd_statusdata(const char *
     statusitems &= ~STATUS_CONVITEMS; /* strip them for the regular lookup */
 
     /* use the existing state if possible */
-    state = conversations_get_mbox(mailboxname);
+    state = conversations_get_mbox(mbentry->name);
 
     /* otherwise fetch a new one! */
     if (!state) {
@@ -8847,7 +9206,8 @@ static int imapd_statusdata(const char *
             conversations_abort(&global_conversations);
             global_conversations = NULL;
         }
-        r = conversations_open_mbox(mailboxname, &state);
+        // we never write anything in STATUS calls, so shared is fine
+        r = conversations_open_mbox(mbentry->name, 1/*shared*/, &state);
         if (r) {
             /* maybe the mailbox doesn't even have conversations - just ignore */
             goto nonconv;
@@ -8855,16 +9215,16 @@ static int imapd_statusdata(const char *
         global_conversations = state;
     }
 
-    r = conversation_getstatus(state, mailboxname, &sd->xconv);
+    r = conversation_getstatus(state, mbentry->name, &sd->xconv);
     if (r) return r;
 
 nonconv:
     /* use the index status if we can so we get the 'alive' Recent count */
-    if (!strcmpsafe(mailboxname, index_mboxname(imapd_index)) && imapd_index->mailbox)
+    if (!strcmpsafe(mbentry->name, index_mboxname(imapd_index)) && imapd_index->mailbox)
         return index_status(imapd_index, sd);
 
     /* fall back to generic lookup */
-    return status_lookup(mailboxname, imapd_userid, statusitems, sd);
+    return status_lookup_mbentry(mbentry, imapd_userid, statusitems, sd);
 }
 
 /*
@@ -8952,7 +9312,7 @@ static void cmd_status(char *tag, char *
         }
     }
 
-    if (!r) r = imapd_statusdata(intname, statusitems, &sdata);
+    if (!r) r = imapd_statusdata(mbentry, statusitems, &sdata);
 
     if (r) {
         prot_printf(imapd_out, "%s NO %s\r\n", tag,
@@ -9123,6 +9483,7 @@ static int parsecreateargs(struct dlist
 
  fail:
     dlist_free(&res);
+    if (c != EOF) prot_ungetc(c, imapd_in);
     return EOF;
 }
 
@@ -9485,7 +9846,10 @@ static int parse_metadata_store_data(con
                         "%s BAD Missing metadata entry\r\n", tag);
             goto baddata;
         }
-        lcase(entry.s);
+        /* DAV code uses case significant metadata entries, so if you log in with +dav,
+         * we make the metadata commands case significant! */
+        if (strcasecmpsafe(imapd_magicplus, "+dav"))
+            lcase(entry.s);
 
         /* get value */
         c = getbnstring(imapd_in, imapd_out, &value);
@@ -9616,14 +9980,12 @@ struct apply_rock {
 static int apply_cb(struct findall_data *data, void* rock)
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
+
     struct apply_rock *arock = (struct apply_rock *)rock;
     annotate_state_t *state = arock->state;
     int r;
 
-    /* Suppress any output of a partial match */
-    if (!data->mbname)
-        return 0;
-
     strlcpy(arock->lastname, mbname_intname(data->mbname), sizeof(arock->lastname));
 
     // malloc extra-long to have room for pattern shenanigans later
@@ -9737,26 +10099,32 @@ static void cmd_getannotation(const char
         goto freeargs;
     }
 
-    astate = annotate_state_new();
-    annotate_state_set_auth(astate,
-                            imapd_userisadmin || imapd_userisproxyadmin,
-                            imapd_userid, imapd_authstate);
-    if (!*mboxpat) {
-        r = annotate_state_set_server(astate);
-        if (!r)
-            r = annotate_state_fetch(astate, &entries, &attribs,
-                                     getannotation_response, NULL);
+    if (config_getswitch(IMAPOPT_ANNOTATION_ENABLE_LEGACY_COMMANDS)) {
+        astate = annotate_state_new();
+        annotate_state_set_auth(astate,
+                                imapd_userisadmin || imapd_userisproxyadmin,
+                                imapd_userid, imapd_authstate);
+        if (!*mboxpat) {
+            r = annotate_state_set_server(astate);
+            if (!r)
+                r = annotate_state_fetch(astate, &entries, &attribs,
+                                        getannotation_response, NULL);
+        }
+        else {
+            struct annot_fetch_rock arock;
+            arock.entries = &entries;
+            arock.attribs = &attribs;
+            arock.callback = getannotation_response;
+            arock.cbrock = NULL;
+            r = apply_mailbox_pattern(astate, mboxpat, annot_fetch_cb, &arock);
+        }
+        /* we didn't write anything */
+        annotate_state_abort(&astate);
     }
     else {
-        struct annot_fetch_rock arock;
-        arock.entries = &entries;
-        arock.attribs = &attribs;
-        arock.callback = getannotation_response;
-        arock.cbrock = NULL;
-        r = apply_mailbox_pattern(astate, mboxpat, annot_fetch_cb, &arock);
+        /* nope, sorry */
+        r = IMAP_PERMISSION_DENIED;
     }
-    /* we didn't write anything */
-    annotate_state_abort(&astate);
 
     imapd_check(NULL, 0);
 
@@ -10125,25 +10493,31 @@ static void cmd_setannotation(const char
         goto freeargs;
     }
 
-    astate = annotate_state_new();
-    annotate_state_set_auth(astate, imapd_userisadmin,
-                            imapd_userid, imapd_authstate);
-    if (!r) {
-        if (!*mboxpat) {
-            r = annotate_state_set_server(astate);
-            if (!r)
-                r = annotate_state_store(astate, entryatts);
-        }
-        else {
-            struct annot_store_rock arock;
-            arock.entryatts = entryatts;
-            r = apply_mailbox_pattern(astate, mboxpat, annot_store_cb, &arock);
+    if (config_getswitch(IMAPOPT_ANNOTATION_ENABLE_LEGACY_COMMANDS)) {
+        astate = annotate_state_new();
+        annotate_state_set_auth(astate, imapd_userisadmin,
+                                imapd_userid, imapd_authstate);
+        if (!r) {
+            if (!*mboxpat) {
+                r = annotate_state_set_server(astate);
+                if (!r)
+                    r = annotate_state_store(astate, entryatts);
+            }
+            else {
+                struct annot_store_rock arock;
+                arock.entryatts = entryatts;
+                r = apply_mailbox_pattern(astate, mboxpat, annot_store_cb, &arock);
+            }
         }
+        if (!r)
+            annotate_state_commit(&astate);
+        else
+            annotate_state_abort(&astate);
+    }
+    else {
+        /* nope, sorry */
+        r = IMAP_PERMISSION_DENIED;
     }
-    if (!r)
-        annotate_state_commit(&astate);
-    else
-        annotate_state_abort(&astate);
 
     imapd_check(NULL, 0);
 
@@ -10296,7 +10670,7 @@ syntax_error:
 
     /* Do a permissions check to avoid server DoS opportunity.  But we
      * only need read permission to warmup a mailbox.  Also, be careful
-     * to avoid telling the client about the existance of mailboxes to
+     * to avoid telling the client about the existence of mailboxes to
      * which he doesn't have LOOKUP rights. */
     r = IMAP_PERMISSION_DENIED;
     myrights = (mbentry->acl ? cyrus_acl_myrights(imapd_authstate, mbentry->acl) : 0);
@@ -10342,8 +10716,6 @@ syntax_error:
                 warmup_flags |= WARMUP_CONVERSATIONS;
             else if (!strcasecmp(arg.s, "annotations"))
                 warmup_flags |= WARMUP_ANNOTATIONS;
-            else if (!strcasecmp(arg.s, "folderstatus"))
-                warmup_flags |= WARMUP_FOLDERSTATUS;
             else if (!strcasecmp(arg.s, "search"))
                 warmup_flags |= WARMUP_SEARCH;
             else if (!strcasecmp(arg.s, "uids")) {
@@ -10494,21 +10866,25 @@ static void cmd_dump(char *tag, char *na
 static void cmd_undump(char *tag, char *name)
 {
     int r = 0;
-    char *intname = mboxname_from_external(name, &imapd_namespace, imapd_userid);
+    mbname_t *mbname = mbname_from_extname(name, &imapd_namespace, imapd_userid);
 
     /* administrators only please */
     if (!imapd_userisadmin)
         r = IMAP_PERMISSION_DENIED;
 
-    if (!r) r = mlookup(tag, name, intname, NULL);
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(mbname_intname(mbname));
+
+    if (!r) r = mlookup(tag, name, mbname_intname(mbname), NULL);
 
-    if (!r) r = undump_mailbox(intname, imapd_in, imapd_out, imapd_authstate);
+    if (!r) r = undump_mailbox(mbname_intname(mbname), imapd_in, imapd_out, imapd_authstate);
+
+    mboxname_release(&namespacelock);
 
     if (r) {
         prot_printf(imapd_out, "%s NO %s%s\r\n",
                     tag,
                     (r == IMAP_MAILBOX_NONEXISTENT &&
-                     mboxlist_createmailboxcheck(intname, 0, 0,
+                     mboxlist_createmailboxcheck(mbname_intname(mbname), 0, 0,
                                                  imapd_userisadmin,
                                                  imapd_userid, imapd_authstate,
                                                  NULL, NULL, 0) == 0)
@@ -10517,7 +10893,7 @@ static void cmd_undump(char *tag, char *
         prot_printf(imapd_out, "%s OK %s\r\n", tag,
                     error_message(IMAP_OK_COMPLETED));
     }
-    free(intname);
+    mbname_free(&mbname);
 }
 
 static int getresult(struct protstream *p, const char *tag)
@@ -10801,7 +11177,7 @@ static int backend_version(struct backen
      */
 
     /* It's like looking in the mirror and not suffering from schizophrenia */
-    if (strstr(be->banner, cyrus_version())) {
+    if (strstr(be->banner, CYRUS_VERSION)) {
         return MAILBOX_MINOR_VERSION;
     }
 
@@ -11101,11 +11477,10 @@ static int xfer_addusermbox(const mbentr
 
     struct xfer_item *item = xzmalloc(sizeof(struct xfer_item));
 
-    // re-read, because we don't have a handy clone function yet
-    int r = mboxlist_lookup(mbentry->name, &item->mbentry, 0);
-    if (r) return r;
+    item->mbentry = mboxlist_entry_copy(mbentry);
+
     char *extname = mboxname_to_external(item->mbentry->name, &imapd_namespace, imapd_userid);
-    strncpy(item->extname, extname, sizeof(item->extname));
+    xstrncpy(item->extname, extname, sizeof(item->extname));
     free(extname);
     item->mailbox = NULL;
     item->state = 0;
@@ -11147,7 +11522,7 @@ static int xfer_initialsync(struct xfer_
         }
         xfer->items = NULL;
 
-        r = mboxlist_usermboxtree(xfer->userid, xfer_addusermbox,
+        r = mboxlist_usermboxtree(xfer->userid, NULL, xfer_addusermbox,
                                   xfer, MBOXTREE_DELETED);
     }
     else {
@@ -11183,6 +11558,7 @@ static int sync_mailbox(struct mailbox *
     struct sync_folder *mfolder, *rfolder;
     struct sync_annot_list *annots = NULL;
     modseq_t xconvmodseq = 0;
+    modseq_t raclmodseq = 0;
     unsigned flags = SYNC_FLAG_LOGGING | SYNC_FLAG_LOCALONLY;
 
     if (!topart) topart = mailbox->part;
@@ -11190,7 +11566,7 @@ static int sync_mailbox(struct mailbox *
     part_list = sync_reserve_partlist(reserve_guids, topart);
 
     /* always send mailbox annotations */
-    r = read_annotations(mailbox, NULL, &annots);
+    r = read_annotations(mailbox, NULL, &annots, /*since_modseq*/0, /*flags*/0);
     if (r) {
         syslog(LOG_ERR, "sync_mailbox(): read annotations failed: %s '%s'",
                mailbox->name, error_message(r));
@@ -11206,6 +11582,10 @@ static int sync_mailbox(struct mailbox *
             goto cleanup;
         }
     }
+    /* raclmodseq */
+    if (config_getswitch(IMAPOPT_REVERSEACLS)) {
+        raclmodseq = mboxname_readraclmodseq(mailbox->name);
+    }
 
     master_folders = sync_folder_list_create();
     sync_folder_list_add(master_folders,
@@ -11224,6 +11604,8 @@ static int sync_mailbox(struct mailbox *
                          mailbox->i.pop3_show_after,
                          annots,
                          xconvmodseq,
+                         raclmodseq,
+                         mailbox->foldermodseq,
                          /* ispartial */0);
     annots = NULL; /* list took ownership */
 
@@ -11288,7 +11670,6 @@ static int xfer_finalsync(struct xfer_he
     struct dlist *kl = NULL;
     struct xfer_item *item;
     struct mailbox *mailbox = NULL;
-    mbentry_t newentry;
     unsigned flags = SYNC_FLAG_LOGGING | SYNC_FLAG_LOCALONLY;
     int r;
 
@@ -11343,14 +11724,16 @@ static int xfer_finalsync(struct xfer_he
 
         /* Step 3.5: Set mailbox as MOVING on local server */
         /* XXX - this code is awful... need a sane way to manage mbentries */
-        newentry.name = item->mbentry->name;
-        newentry.acl = item->mbentry->acl;
-        newentry.uniqueid = item->mbentry->uniqueid;
-        newentry.uidvalidity = item->mbentry->uidvalidity;
-        newentry.mbtype = item->mbentry->mbtype|MBTYPE_MOVING;
-        newentry.server = xfer->toserver;
-        newentry.partition = xfer->topart;
-        r = mboxlist_update(&newentry, 1);
+        mbentry_t *newmbentry = mboxlist_entry_create();
+        newmbentry->name = xstrdupnull(item->mbentry->name);
+        newmbentry->acl = xstrdupnull(item->mbentry->acl);
+        newmbentry->uniqueid = xstrdupnull(item->mbentry->uniqueid);
+        newmbentry->uidvalidity = item->mbentry->uidvalidity;
+        newmbentry->mbtype = item->mbentry->mbtype|MBTYPE_MOVING;
+        newmbentry->server = xstrdupnull(xfer->toserver);
+        newmbentry->partition = xstrdupnull(xfer->topart);
+        r = mboxlist_update(newmbentry, 1);
+        mboxlist_entry_free(&newmbentry);
 
         if (r) {
             syslog(LOG_ERR,
@@ -11465,7 +11848,7 @@ static int xfer_delete(struct xfer_heade
         newentry->acl = xstrdupnull(item->mbentry->acl);
         newentry->server = xstrdupnull(item->mbentry->server);
         newentry->partition = xstrdupnull(item->mbentry->partition);
-        newentry->mbtype = item->mbentry->mbtype|MBTYPE_DELETED;
+        newentry->mbtype = MBTYPE_DELETED;
         r = mboxlist_update(newentry, 1);
         mboxlist_entry_free(&newentry);
 
@@ -11479,9 +11862,9 @@ static int xfer_delete(struct xfer_heade
         /* note also that we need to remember to let proxyadmins do this */
         /* On a unified system, the subsequent MUPDATE PUSH on the remote
            should repopulate the local mboxlist entry */
-        r = mboxlist_deletemailbox(item->mbentry->name,
+        r = mboxlist_deletemailboxlock(item->mbentry->name,
                                    imapd_userisadmin || imapd_userisproxyadmin,
-                                   imapd_userid, imapd_authstate, NULL, 0, 1, 0);
+                                   imapd_userid, imapd_authstate, NULL, 0, 1, 0, 0);
         if (r) {
             syslog(LOG_ERR,
                    "Could not delete local mailbox during move of %s",
@@ -11593,7 +11976,7 @@ static int xfer_setquotaroot(struct xfer
     if (r == IMAP_QUOTAROOT_NONEXISTENT) return 0;
     if (r) return r;
 
-    /* note use of + to force the setting of a nonexistant
+    /* note use of + to force the setting of a nonexistent
      * quotaroot */
     char *extname = mboxname_to_external(mboxname, &imapd_namespace, imapd_userid);
     prot_printf(xfer->be->out, "Q01 SETQUOTA {" SIZE_T_FMT "+}\r\n+%s ",
@@ -11622,13 +12005,9 @@ struct xfer_list {
 static int xfer_addmbox(struct findall_data *data, void *rock)
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
     struct xfer_list *list = (struct xfer_list *) rock;
 
-    if (!data->mbentry || !data->mbname) {
-        /* No partial matches */
-        return 0;
-    }
-
     if (list->part && strcmp(data->mbentry->partition, list->part)) {
         /* Not on specified partition */
         return 0;
@@ -11641,7 +12020,7 @@ static int xfer_addmbox(struct findall_d
         struct xfer_item *mbox = xzmalloc(sizeof(struct xfer_item));
 
         mbox->mbentry = mboxlist_entry_copy(data->mbentry);
-        strncpy(mbox->extname, extname, sizeof(mbox->extname));
+        xstrncpy(mbox->extname, extname, sizeof(mbox->extname));
         if (mbname_localpart(data->mbname) && !list->allow_usersubs) {
             /* User INBOX */
             mbox->state = XFER_MOVING_USER;
@@ -11662,7 +12041,7 @@ static void cmd_xfer(const char *tag, co
     struct xfer_header *xfer = NULL;
     struct xfer_list list = { &imapd_namespace, imapd_userid, NULL, 0, NULL };
     struct xfer_item *item, *next;
-    char *intname = NULL;
+    mbname_t *mbname = mbname_from_extname(name, &imapd_namespace, imapd_userid);
 
     /* administrators only please */
     /* however, proxys can do this, if their authzid is an admin */
@@ -11683,20 +12062,13 @@ static void cmd_xfer(const char *tag, co
         mboxlist_findall(NULL, "*", 1, NULL, NULL, xfer_addmbox, &list);
     } else {
         /* mailbox pattern */
-        mbname_t *mbname;
-
-        intname = mboxname_from_external(name, &imapd_namespace, imapd_userid);
-
-        mbname = mbname_from_intname(intname);
         if (mbname_localpart(mbname) &&
             (mbname_isdeleted(mbname) || strarray_size(mbname_boxes(mbname)))) {
             /* targeted a user submailbox */
             list.allow_usersubs = 1;
         }
-        mbname_free(&mbname);
 
-        mboxlist_findall(NULL, name, 1, NULL, NULL, xfer_addmbox, &list);
-        free(intname);
+        mboxlist_findall(NULL, mbname_intname(mbname), 1, NULL, NULL, xfer_addmbox, &list);
     }
 
     r = xfer_init(toserver, &xfer);
@@ -11709,11 +12081,10 @@ static void cmd_xfer(const char *tag, co
          * to the destination backend as an admin, we take advantage of the fact
          * that admins *always* use a consistent mailbox naming scheme.
          * So, 'name' should be used in any command we send to a backend, and
-         * 'intname' is the internal name to be used for mupdate and findall.
+         * 'mbentry->name' is the internal name to be used for mupdate and findall.
          */
 
         r = 0;
-        intname = mbentry->name;
         xfer->topart = xstrdup(topart ? topart : mbentry->partition);
 
         /* if we are not moving a user, just move the one mailbox */
@@ -11723,7 +12094,7 @@ static void cmd_xfer(const char *tag, co
                    mbentry->name, xfer->toserver, xfer->topart);
 
             /* is the selected mailbox the one we're moving? */
-            if (!strcmpsafe(intname, index_mboxname(imapd_index))) {
+            if (!strcmpsafe(mbentry->name, index_mboxname(imapd_index))) {
                 r = IMAP_MAILBOX_LOCKED;
                 goto next;
             }
@@ -11734,7 +12105,7 @@ static void cmd_xfer(const char *tag, co
 
             r = do_xfer(xfer);
         } else {
-            xfer->userid = mboxname_to_userid(intname);
+            xfer->userid = xstrdupnull(mbname_userid(mbname));
 
             syslog(LOG_INFO, "XFER: user '%s' -> %s!%s",
                    xfer->userid, xfer->toserver, xfer->topart);
@@ -11745,8 +12116,8 @@ static void cmd_xfer(const char *tag, co
             } else if (!strcmp(xfer->userid, imapd_userid)) {
                 /* don't move your own inbox, that could be troublesome */
                 r = IMAP_MAILBOX_NOTSUPPORTED;
-            } else if (!strncmpsafe(intname, index_mboxname(imapd_index),
-                             strlen(intname))) {
+            } else if (!strncmpsafe(mbentry->name, index_mboxname(imapd_index),
+                             strlen(mbentry->name))) {
                 /* selected mailbox is in the namespace we're moving */
                 r = IMAP_MAILBOX_LOCKED;
             }
@@ -11754,7 +12125,7 @@ static void cmd_xfer(const char *tag, co
 
             if (!xfer->use_replication) {
                 /* set the quotaroot if needed */
-                r = xfer_setquotaroot(xfer, intname);
+                r = xfer_setquotaroot(xfer, mbentry->name);
                 if (r) goto next;
 
                 /* backport the seen file if needed */
@@ -11764,18 +12135,21 @@ static void cmd_xfer(const char *tag, co
                 }
             }
 
-            r = mboxlist_usermboxtree(xfer->userid, xfer_addusermbox,
+            r = mboxlist_usermboxtree(xfer->userid, NULL, xfer_addusermbox,
                                       xfer, MBOXTREE_DELETED);
 
+            struct mboxlock *namespacelock = user_namespacelock(xfer->userid);
             /* NOTE: mailboxes were added in reverse, so the inbox is
              * done last */
             r = do_xfer(xfer);
-            if (r) goto next;
 
-            /* this was a successful user move, and we need to delete
-               certain user meta-data (but not seen state!) */
-            syslog(LOG_INFO, "XFER: deleting user metadata");
-            user_deletedata(xfer->userid, 0);
+            if (!r) {
+                /* this was a successful user move, and we need to delete
+                   certain user meta-data (but not seen state!) */
+                syslog(LOG_INFO, "XFER: deleting user metadata");
+                user_deletedata(xfer->userid, 0);
+            }
+            mboxname_release(&namespacelock);
         }
 
       next:
@@ -11815,6 +12189,7 @@ static void cmd_xfer(const char *tag, co
     }
 
 done:
+    mbname_free(&mbname);
     if (xfer) xfer_done(&xfer);
 
     imapd_check(NULL, 0);
@@ -12147,6 +12522,7 @@ syntax_error:
     free(windowargs.anchorfolder);
     buf_free(&ext_folder);
     prot_printf(imapd_out, "%s BAD Syntax error in window arguments\r\n", tag);
+    if (c != EOF) prot_ungetc(c, imapd_in);
     return EOF;
 }
 
@@ -12166,6 +12542,7 @@ static int getlistselopts(char *tag, str
 {
     int c;
     static struct buf buf;
+    int allowdeleted = config_getswitch(IMAPOPT_ALLOWDELETED);
 
     if ( (c = prot_getc(imapd_in)) == ')')
         return prot_getc(imapd_in);
@@ -12179,7 +12556,7 @@ static int getlistselopts(char *tag, str
             prot_printf(imapd_out,
                         "%s BAD Invalid syntax in List command\r\n",
                         tag);
-            return EOF;
+            goto bad;
         }
 
         lcase(buf.s);
@@ -12189,6 +12566,10 @@ static int getlistselopts(char *tag, str
             args->ret |= LIST_RET_SUBSCRIBED;
         } else if (!strcmp(buf.s, "vendor.cmu-dav")) {
             args->sel |= LIST_SEL_DAV;
+        } else if (!strcmp(buf.s, "vendor.cmu-include-deleted") && allowdeleted) {
+            args->sel |= LIST_SEL_DELETED;
+        } else if (!strcmp(buf.s, "vendor.fm-include-nonexistent")) {
+            args->sel |= LIST_SEL_INTERMEDIATES;
         } else if (!strcmp(buf.s, "remote")) {
             args->sel |= LIST_SEL_REMOTE;
         } else if (!strcmp(buf.s, "recursivematch")) {
@@ -12211,7 +12592,7 @@ static int getlistselopts(char *tag, str
             prot_printf(imapd_out,
                         "%s BAD Invalid List selection option \"%s\"\r\n",
                         tag, buf.s);
-            return EOF;
+            goto bad;
         }
 
         if (c != ' ') break;
@@ -12220,7 +12601,7 @@ static int getlistselopts(char *tag, str
     if (c != ')') {
         prot_printf(imapd_out,
                     "%s BAD Missing close parenthesis for List selection options\r\n", tag);
-        return EOF;
+        goto bad;
     }
 
     if (args->sel & list_select_mod_opts
@@ -12228,10 +12609,14 @@ static int getlistselopts(char *tag, str
         prot_printf(imapd_out,
                     "%s BAD Invalid combination of selection options\r\n",
                     tag);
-        return EOF;
+        goto bad;
     }
 
     return prot_getc(imapd_in);
+
+bad:
+    if (c != EOF) prot_ungetc(c, imapd_in);
+    return EOF;
 }
 
 /*
@@ -12247,20 +12632,20 @@ static int getlistretopts(char *tag, str
     if (!*buf.s) {
         prot_printf(imapd_out,
                     "%s BAD Invalid syntax in List command\r\n", tag);
-        return EOF;
+        goto bad;
     }
     lcase(buf.s);
     if (strcasecmp(buf.s, "return")) {
         prot_printf(imapd_out,
                     "%s BAD Unexpected extra argument to List: \"%s\"\r\n",
                     tag, buf.s);
-        return EOF;
+        goto bad;
     }
 
     if (c != ' ' || (c = prot_getc(imapd_in)) != '(') {
         prot_printf(imapd_out,
                     "%s BAD Missing return argument list\r\n", tag);
-        return EOF;
+        goto bad;
     }
 
     if ( (c = prot_getc(imapd_in)) == ')')
@@ -12274,7 +12659,7 @@ static int getlistretopts(char *tag, str
         if (!*buf.s) {
             prot_printf(imapd_out,
                         "%s BAD Invalid syntax in List command\r\n", tag);
-            return EOF;
+            goto bad;
         }
 
         lcase(buf.s);
@@ -12306,7 +12691,7 @@ static int getlistretopts(char *tag, str
             prot_printf(imapd_out,
                         "%s BAD Invalid List return option \"%s\"\r\n",
                         tag, buf.s);
-            return EOF;
+            goto bad;
         }
 
         if (c != ' ') break;
@@ -12315,10 +12700,14 @@ static int getlistretopts(char *tag, str
     if (c != ')') {
         prot_printf(imapd_out,
                     "%s BAD Missing close parenthesis for List return options\r\n", tag);
-        return EOF;
+        goto bad;
     }
 
     return prot_getc(imapd_in);
+
+bad:
+    if (c != EOF) prot_ungetc(c, imapd_in);
+    return EOF;
 }
 
 /*
@@ -12346,7 +12735,7 @@ static int getdatetime(time_t *date)
     }
     buf[i] = '\0';
 
-    r = time_from_rfc3501(buf, date);
+    r = time_from_rfc5322(buf, date, DATETIME_FULL);
     if (r < 0)
         goto baddate;
 
@@ -12354,7 +12743,7 @@ static int getdatetime(time_t *date)
     return c;
 
  baddate:
-    prot_ungetc(c, imapd_in);
+    if (c != EOF) prot_ungetc(c, imapd_in);
     return EOF;
 }
 
@@ -12468,6 +12857,11 @@ static void list_response(const char *ex
     struct statusdata sdata = STATUSDATA_INIT;
     struct buf specialuse = BUF_INITIALIZER;
 
+    /* Intermediates don't actually exist */
+    if (mbentry && (mbentry->mbtype & MBTYPE_INTERMEDIATE)) {
+        attributes |= MBOX_ATTRIBUTE_NONEXISTENT;
+    }
+
     if ((attributes & MBOX_ATTRIBUTE_NONEXISTENT)) {
         if (!(listargs->cmd == LIST_CMD_EXTENDED)) {
             attributes |= MBOX_ATTRIBUTE_NOSELECT;
@@ -12612,7 +13006,7 @@ static void list_response(const char *ex
 
     /* can we read the status data ? */
     if ((listargs->ret & LIST_RET_STATUS) && mbentry) {
-        r = imapd_statusdata(mbentry->name, listargs->statusitems, &sdata);
+        r = imapd_statusdata(mbentry, listargs->statusitems, &sdata);
         if (r) {
             /* RFC 5819: the STATUS response MUST NOT be returned and the
              * LIST response MUST include the \NoSelect attribute. */
@@ -12667,13 +13061,34 @@ static void _addsubs(struct list_rock *r
 static int perform_output(const char *extname, const mbentry_t *mbentry, struct list_rock *rock)
 {
     /* skip non-responsive mailboxes early, so they don't break sub folder detection */
-    if (mbentry && !imapd_userisadmin) {
-        if (mbentry->mbtype == MBTYPE_NETNEWS) return 0;
+    if (!imapd_userisadmin) {
+        int mbtype = mbentry ? mbentry->mbtype : 0;
+
+        if (mbtype == MBTYPE_NETNEWS) return 0;
+        if ((mbtype & MBTYPE_INTERMEDIATE) &&
+            !(rock->listargs->sel & LIST_SEL_INTERMEDIATES)) return 0;
         if (!(rock->listargs->sel & LIST_SEL_DAV)) {
-            if (mboxname_iscalendarmailbox(mbentry->name, mbentry->mbtype)) return 0;
-            if (mboxname_isaddressbookmailbox(mbentry->name, mbentry->mbtype)) return 0;
-            if (mboxname_isdavdrivemailbox(mbentry->name, mbentry->mbtype)) return 0;
-            if (mboxname_isdavnotificationsmailbox(mbentry->name, mbentry->mbtype)) return 0;
+            char *intname = NULL, *freeme = NULL;
+            int skip = 0;
+
+            /* if we got here via subscribed_cb, mbentry isn't set */
+            if (mbentry) intname = mbentry->name;
+            else {
+                intname = freeme = mboxname_from_external(extname,
+                                                          &imapd_namespace,
+                                                          imapd_userid);
+            }
+            if (mboxname_iscalendarmailbox(intname, mbtype)    ||
+                mboxname_isaddressbookmailbox(intname, mbtype) ||
+                mboxname_isdavdrivemailbox(intname, mbtype)    ||
+                mboxname_issubmissionmailbox(intname, mbtype)    ||
+                mboxname_ispushsubscriptionmailbox(intname, mbtype)    ||
+                mboxname_isdavnotificationsmailbox(intname, mbtype)) {
+                skip = 1;
+            }
+            free(freeme);
+
+            if (skip) return 0;
         }
     }
 
@@ -12755,11 +13170,54 @@ static int perform_output(const char *ex
     return 1;
 }
 
+static void add_intermediates(const char *extname, struct list_rock *lrock)
+{
+    mbname_t *mbname = mbname_from_extname(extname,
+                                           &imapd_namespace, imapd_userid);
+    strarray_t inter = STRARRAY_INITIALIZER;
+
+    /* build a list of "missing" ancestors (youngest to oldest) */
+    while (strarray_size(mbname_boxes(mbname))) {
+        free(mbname_pop_boxes(mbname));
+
+        extname = mbname_extname(mbname, &imapd_namespace, imapd_userid);
+        if (!extname) break;  /* root of hierarchy */
+
+        if (lrock->last_name &&
+            mboxname_is_prefix(lrock->last_name, extname)) break;
+
+        strarray_push(&inter, extname);
+    }
+    mbname_free(&mbname);
+
+    /* output the ancestors (oldest to youngest) */
+    char *ancestor;
+    while ((ancestor = strarray_pop(&inter))) {
+        mbentry_t *mbentry = NULL;
+
+        if (!mboxlist_lookup_allow_all(ancestor, &mbentry, NULL)) {
+            mbentry->mbtype |= MBTYPE_INTERMEDIATE;  /* force \NonExistent */
+            perform_output(ancestor, mbentry, lrock);
+        }
+
+        mboxlist_entry_free(&mbentry);
+        free(ancestor);
+    }
+    strarray_fini(&inter);
+}
+
 /* callback for mboxlist_findall
  * used when the SUBSCRIBED selection option is NOT given */
 static int list_cb(struct findall_data *data, void *rockp)
 {
     struct list_rock *rock = (struct list_rock *)rockp;
+
+    // skip anything DELETED unless explicitly asked for
+    if (data && !imapd_userisadmin
+             && (!(rock->listargs->sel & LIST_SEL_DELETED) || !config_getswitch(IMAPOPT_ALLOWDELETED))
+             && mbname_isdeleted(data->mbname))
+        return 0;
+
     if (!data) {
         if (!(rock->last_attributes & MBOX_ATTRIBUTE_HASCHILDREN))
             rock->last_attributes |= MBOX_ATTRIBUTE_HASNOCHILDREN;
@@ -12780,16 +13238,25 @@ static int list_cb(struct findall_data *
      * if they're required but not yet set, but it's a little cheaper to
      * precalculate them now while we're iterating the mailboxes anyway.
      */
-    if (last_name_is_ancestor || (rock->last_name && !data->mbname && !strcmp(rock->last_name, extname)))
+    if (last_name_is_ancestor || (rock->last_name && !data->is_exactmatch && !strcmp(rock->last_name, extname)))
         rock->last_attributes |= MBOX_ATTRIBUTE_HASCHILDREN;
 
     else if (!(rock->last_attributes & MBOX_ATTRIBUTE_HASCHILDREN))
         rock->last_attributes |= MBOX_ATTRIBUTE_HASNOCHILDREN;
 
+    /* do we need to add "missing" intermediates? */
+    if ((rock->listargs->sel & LIST_SEL_INTERMEDIATES) &&
+        ((rock->listargs->sel & LIST_SEL_DAV) ||
+         !(data->mbentry->mbtype & MBTYPES_DAV)) &&
+        !mboxname_contains_parent(data->extname, rock->last_name)) {
+
+        add_intermediates(data->extname, rock);
+    }
+
     if (!perform_output(data->extname, data->mbentry, rock))
         return 0;
 
-    if (!data->mbname)
+    if (!data->is_exactmatch)
         rock->last_attributes |= MBOX_ATTRIBUTE_HASCHILDREN | MBOX_ATTRIBUTE_NONEXISTENT;
 
     else if (data->mb_category == MBNAME_ALTINBOX)
@@ -12818,10 +13285,10 @@ static int subscribed_cb(struct findall_
     list_callback_calls++;
 
     if (last_name_is_ancestor ||
-        (rock->last_name && !data->mbname && !strcmp(rock->last_name, extname)))
+        (rock->last_name && !data->is_exactmatch && !strcmp(rock->last_name, extname)))
         rock->last_attributes |= MBOX_ATTRIBUTE_HASCHILDREN;
 
-    if (data->mbname) { /* exact match */
+    if (data->is_exactmatch) {
         mbentry_t *mbentry = NULL;
         mboxlist_lookup(mbname_intname(data->mbname), &mbentry, NULL);
         perform_output(extname, mbentry, rock);
@@ -12996,7 +13463,7 @@ static int recursivematch_cb(struct find
     }
 
 
-    if (data->mbname) { /* exact match */
+    if (data->is_exactmatch) {
         entry->attributes |= MBOX_ATTRIBUTE_SUBSCRIBED;
         if (!data->mbentry) {
             mboxlist_lookup(mbname_intname(data->mbname), &entry->mbentry, NULL);
@@ -13036,7 +13503,8 @@ static void free_list_entry(void *rock)
     free(entry);
 }
 
-static void list_data_recursivematch(struct listargs *listargs) {
+static void list_data_recursivematch(struct listargs *listargs)
+{
     struct list_rock_recursivematch rock;
 
     rock.count = 0;
@@ -13240,9 +13708,10 @@ static int list_data_remote(struct backe
                 /* print status items */
                 const char *status_items[] = {
                     /* XXX  MUST be in same order as STATUS_* bitmask */
-                    "messages", "recent", "uidnext", "uidvalidity", "unseen",
-                    "highestmodseq", "xconvexists", "xconvunseen",
-                    "xconvmodseq", NULL
+                    "messages", "recent", "uidnext", "uidvalidity",
+                    "unseen", "uniqueid", "size", "highestmodseq",
+                    "xconvexists", "xconvunseen", "xconvmodseq",
+                    "createdmodseq", "sharedseen", NULL
                 };
 
                 c = '(';
@@ -13284,21 +13753,12 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("imap", config_servername,
-                          NULL, NULL, NULL,
+    ret = sasl_server_new("imap", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
                           NULL, 0, conn);
     if(ret != SASL_OK) return ret;
 
-    if(saslprops.ipremoteport)
-        ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                           saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-        ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                           saslprops.iplocalport);
-    if(ret != SASL_OK) return ret;
-
     secprops = mysasl_secprops(0);
     ret = sasl_setprop(*conn, SASL_SEC_PROPS, secprops);
     if(ret != SASL_OK) return ret;
@@ -13306,16 +13766,11 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if(saslprops.ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     } else {
         ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &extprops_ssf);
     }
     if(ret != SASL_OK) return ret;
-
-    if(saslprops.authid) {
-        ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-        if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -13555,7 +14010,7 @@ static void cmd_urlfetch(char *tag)
         }
         if (r) goto err;
 
-        if (!strcmp(index_mboxname(imapd_index), intname)) {
+        if (!strcmpnull(index_mboxname(imapd_index), intname)) {
             state = imapd_index;
         }
         else {
@@ -13586,10 +14041,10 @@ static void cmd_urlfetch(char *tag)
                                imapd_out, NULL);
         }
 
+    err:
         if (doclose)
             index_close(&state);
 
-    err:
         free(url.freeme);
 
         if (r) prot_printf(imapd_out, " NIL");
@@ -13955,7 +14410,7 @@ static void cmd_xforever(const char *tag
         sleep(1);
         prot_printf(imapd_out, "* FOREVER %u\r\n", n++);
         prot_flush(imapd_out);
-        r = cmd_cancelled();
+        r = cmd_cancelled(/*insearch*/0);
     }
 
     prot_printf(imapd_out, "%s OK %s\r\n", tag, error_message(r));
@@ -13985,7 +14440,7 @@ static void cmd_syncapply(const char *ta
     /* administrators only please */
     if (!imapd_userisadmin) {
         syslog(LOG_ERR, "SYNCERROR: invalid user %s trying to sync", imapd_userid);
-        prot_printf(imapd_out, "%s NO only admininstrators may use sync commands\r\n", tag);
+        prot_printf(imapd_out, "%s NO only administrators may use sync commands\r\n", tag);
         return;
     }
 
@@ -14010,7 +14465,7 @@ static void cmd_syncget(const char *tag,
     /* administrators only please */
     if (!imapd_userisadmin) {
         syslog(LOG_ERR, "SYNCERROR: invalid user %s trying to sync", imapd_userid);
-        prot_printf(imapd_out, "%s NO only admininstrators may use sync commands\r\n", tag);
+        prot_printf(imapd_out, "%s NO only administrators may use sync commands\r\n", tag);
         return;
     }
 
@@ -14086,10 +14541,12 @@ static void cmd_syncrestart(const char *
                  config_partitiondir(p->name), (unsigned long)getpid());
         rmdir(buf);
 
-        /* and the archive partition too */
-        snprintf(buf, MAX_MAILBOX_PATH, "%s/sync./%lu",
-                 config_archivepartitiondir(p->name), (unsigned long)getpid());
-        rmdir(buf);
+        if (config_getswitch(IMAPOPT_ARCHIVE_ENABLED)) {
+            /* and the archive partition too */
+            snprintf(buf, MAX_MAILBOX_PATH, "%s/sync./%lu",
+                    config_archivepartitiondir(p->name), (unsigned long)getpid());
+            rmdir(buf);
+        }
     }
     partition_list_free(pl);
 
@@ -14116,7 +14573,7 @@ static void cmd_syncrestore(const char *
     /* administrators only please */
     if (!imapd_userisadmin) {
         syslog(LOG_ERR, "SYNCERROR: invalid user %s trying to sync", imapd_userid);
-        prot_printf(imapd_out, "%s NO only admininstrators may use sync commands\r\n", tag);
+        prot_printf(imapd_out, "%s NO only administrators may use sync commands\r\n", tag);
         return;
     }
 
diff -pruN 3.0.13-5/imap/imapd.h 3.2.0-3/imap/imapd.h
--- 3.0.13-5/imap/imapd.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/imapd.h	2020-04-24 02:03:00.000000000 +0000
@@ -51,6 +51,7 @@
 #include "prot.h"
 #include "strarray.h"
 #include "search_expr.h"
+#include "search_sort.h"
 #include "conversations.h"
 
 /* Userid client has logged in as */
@@ -105,6 +106,7 @@ struct fetchargs {
     int isadmin;
     struct auth_state *authstate;
     hash_table *cidhash;          /* for XCONVFETCH */
+    struct conversations_state *convstate; /* for FETCH_MAILBOXIDS */
 };
 
 /* Bitmasks for fetchitems */
@@ -129,7 +131,18 @@ enum {
     FETCH_FILESIZE =            (1<<17),
     FETCH_CID =                 (1<<18),
     FETCH_FOLDER =              (1<<19),
-    FETCH_UIDVALIDITY =         (1<<20)
+    FETCH_UIDVALIDITY =         (1<<20),
+    FETCH_BASECID =             (1<<21),
+    FETCH_EMAILID =             (1<<22),
+    FETCH_THREADID =            (1<<23),
+    FETCH_SAVEDATE =            (1<<24),
+    FETCH_CREATEDMODSEQ =       (1<<25),
+    FETCH_MAILBOXIDS =          (1<<26),
+    FETCH_MAILBOXES =           (1<<27),
+    FETCH_PREVIEW =             (1<<28),
+    FETCH_LASTUPDATED =         (1<<29),
+
+    /* XXX fetchitems is an int, we're running low on bits */
 };
 
 enum {
@@ -219,51 +232,6 @@ struct searchargs {
     int isadmin;
 };
 
-/* Sort criterion */
-struct sortcrit {
-    unsigned key;               /* sort key */
-    int flags;                  /* key modifiers as defined below */
-    union {                     /* argument(s) to the sort key */
-        struct {
-            char *entry;
-            char *userid;
-        } annot;
-        struct {
-            char *name;
-        } flag;
-    } args;
-};
-
-/* Values for sort keys */
-enum {
-    SORT_SEQUENCE = 0,
-    SORT_ARRIVAL,       /* RFC 5256 */
-    SORT_CC,            /* RFC 5256 */
-    SORT_DATE,          /* RFC 5256 */
-    SORT_DISPLAYFROM,   /* RFC 5957 */
-    SORT_DISPLAYTO,     /* RFC 5957 */
-    SORT_FROM,          /* RFC 5256 */
-    SORT_SIZE,          /* RFC 5256 */
-    SORT_SUBJECT,       /* RFC 5256 */
-    SORT_TO,            /* RFC 5256 */
-    SORT_ANNOTATION,    /* RFC 5257 */
-    SORT_MODSEQ,        /* nonstandard */
-    SORT_UID,           /* nonstandard */
-    SORT_HASFLAG,       /* nonstandard */
-    SORT_CONVMODSEQ,    /* nonstandard */
-    SORT_CONVEXISTS,    /* nonstandard */
-    SORT_CONVSIZE,      /* nonstandard */
-    SORT_HASCONVFLAG,   /* nonstandard */
-    SORT_FOLDER,        /* nonstandard */
-    SORT_RELEVANCY,     /* RFC 6203 */
-    SORT_SPAMSCORE,     /* nonstandard */
-    SORT_GUID           /* nonstandard */
-    /* values > 255 are reserved for internal use */
-};
-
-/* Sort key modifier flag bits */
-#define SORT_REVERSE            (1<<0)      /* RFC 5256 */
-
 /* Windowing arguments for the XCONVSORT command */
 struct windowargs {
     int conversations;          /* whether to limit the results by
@@ -315,14 +283,21 @@ enum {
     STATUS_UIDNEXT =            (1<<2),
     STATUS_UIDVALIDITY =        (1<<3),
     STATUS_UNSEEN =             (1<<4),
-    STATUS_HIGHESTMODSEQ =      (1<<5),
-    STATUS_XCONVEXISTS =        (1<<6),
-    STATUS_XCONVUNSEEN =        (1<<7),
-    STATUS_XCONVMODSEQ =        (1<<8)
+    STATUS_MAILBOXID =          (1<<5),
+    STATUS_SIZE =               (1<<6),
+    STATUS_HIGHESTMODSEQ =      (1<<7),
+    STATUS_XCONVEXISTS =        (1<<8),
+    STATUS_XCONVUNSEEN =        (1<<9),
+    STATUS_XCONVMODSEQ =        (1<<10),
+    STATUS_CREATEDMODSEQ =      (1<<11),
+    STATUS_MBOPTIONS =          (1<<12)
     /* New items MUST be handled in imapd.c:list_data_remote() */
 };
 
 #define STATUS_CONVITEMS (STATUS_XCONVEXISTS|STATUS_XCONVUNSEEN|STATUS_XCONVMODSEQ)
+#define STATUS_MBENTRYITEMS (STATUS_MAILBOXID|STATUS_UIDVALIDITY)
+#define STATUS_INDEXITEMS (STATUS_MESSAGES|STATUS_UIDNEXT|STATUS_SIZE|STATUS_HIGHESTMODSEQ|STATUS_CREATEDMODSEQ|STATUS_MBOPTIONS)
+#define STATUS_SEENITEMS (STATUS_RECENT|STATUS_UNSEEN)
 
 struct getmetadata_options {
     size_t biggest;
@@ -362,7 +337,9 @@ enum {
     LIST_SEL_RECURSIVEMATCH =   (1<<2),
     LIST_SEL_SPECIALUSE =       (1<<3),
     LIST_SEL_DAV =              (1<<4),
-    LIST_SEL_METADATA =         (1<<5)
+    LIST_SEL_METADATA =         (1<<5),
+    LIST_SEL_INTERMEDIATES =    (1<<6),
+    LIST_SEL_DELETED =          (1<<7)
     /* New options MUST be handled in imapd.c:list_data_remote() */
 };
 
diff -pruN 3.0.13-5/imap/imap_err.et 3.2.0-3/imap/imap_err.et
--- 3.0.13-5/imap/imap_err.et	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/imap_err.et	2020-05-04 03:28:02.000000000 +0000
@@ -77,6 +77,9 @@ ec IMAP_MAILBOX_BADFORMAT,
 ec IMAP_SYNC_CHECKSUM,
    "Replication inconsistency detected"
 
+ec IMAP_SYNC_CHANGED,
+   "Mailbox has changed since last sync"
+
 ec IMAP_SYNC_BADSIEVE,
    "Sieve script compilation failure"
 
@@ -161,6 +164,9 @@ ec IMAP_BADURL,
 ec IMAP_ZERO_LENGTH_LITERAL,
    "Zero-length message literal"
 
+ec IMAP_DISABLED,
+   "Command is disabled by configuration"
+
 # following used only proxy/db operations
 ec IMAP_BAD_SERVER,
    "Invalid server requested"
@@ -253,6 +259,12 @@ ec IMAP_CANCELLED,
 ec IMAP_SEARCH_SLOW,
     "Search taking too long - try reducing the set of messages searched"
 
+ec IMAP_SEARCH_MUTABLE,
+    "Search is mutable"
+
+ec IMAP_SEARCH_NOT_SUPPORTED,
+    "Search is not supported"
+
 # Following used for internationalization of untagged BYE response
 
 ec IMAP_BYE_LOGOUT,
diff -pruN 3.0.13-5/imap/imapparse.c 3.2.0-3/imap/imapparse.c
--- 3.0.13-5/imap/imapparse.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/imapparse.c	2020-05-04 03:28:02.000000000 +0000
@@ -42,10 +42,10 @@
 #include <config.h>
 
 #include <ctype.h>
-#include <string.h>
 #include <limits.h>
+#include <string.h>
+#include <sysexits.h>
 
-#include "exitcodes.h"
 #include "global.h"
 #include "imparse.h"
 #include "search_expr.h"
@@ -74,7 +74,7 @@ EXPORTED int getword(struct protstream *
         }
         buf_putc(buf, c);
         if (config_maxword && buf_len(buf) > config_maxword) {
-            fatal("word too long", EC_IOERR);
+            fatal("word too long", EX_IOERR);
         }
     }
 }
@@ -83,9 +83,11 @@ EXPORTED int getword(struct protstream *
  * Parse an xstring
  * (astring, nstring or string based on type)
  */
+#ifdef HAVE_DECLARE_OPTIMIZE
 EXPORTED int getxstring(struct protstream *pin, struct protstream *pout,
                         struct buf *buf, enum getxstring_flags flags)
     __attribute__((optimize("-O3")));
+#endif
 EXPORTED int getxstring(struct protstream *pin, struct protstream *pout,
                         struct buf *buf, enum getxstring_flags flags)
 {
@@ -133,7 +135,7 @@ EXPORTED int getxstring(struct protstrea
             }
             buf_putc(buf, c);
             if (config_maxquoted && buf_len(buf) > config_maxquoted) {
-                fatal("quoted value too long", EC_IOERR);
+                fatal("quoted value too long", EX_IOERR);
             }
         }
 
@@ -182,6 +184,8 @@ EXPORTED int getxstring(struct protstrea
             buf_putc(buf, c);
         }
         buf_cstring(buf);
+        /* n.b. we've consumed an exact number of bytes according to the literal, do
+         * not unget anything even if we don't like the literal */
         if (!(flags & GXS_BINARY) && strlen(buf_cstring(buf)) != (unsigned)buf_len(buf))
             return EOF; /* Disallow imbedded NUL */
         return prot_getc(pin);
@@ -209,22 +213,40 @@ EXPORTED int getxstring(struct protstrea
         }
         else if ((flags & GXS_NIL)) {
             /*
-             * Look for "NIL"
+             * Look carefully for "NIL"
              */
             if (c == 'N') {
-                prot_ungetc(c, pin);
-                c = getword(pin, buf);
-                if (buf->len == 3 && !memcmp(buf->s, "NIL", 3)) {
-                    /* indicated NIL with a NULL buf.s pointer */
-                    buf_free(buf);
-                    return c;
+                int sep = 0;
+                int matched;
+
+                matched = prot_lookahead(pin, "IL", strlen("IL"), &sep);
+                if (matched == strlen("IL") + 1) {
+                    if (isspace(sep) || sep == '(' || sep == ')' || sep == '\"') {
+                        /* found NIL and a separator, consume it */
+                        prot_ungetc(c, pin);
+                        c = getword(pin, buf);
+                        /* indicate NIL with a NULL buf.s pointer */
+                        buf_free(buf);
+                        return c;
+                    }
+                }
+                else if (matched > 0) {
+                    /* partially matched NIL, but not enough buffer to be sure:
+                     * fall back to old behaviour */
+                    prot_ungetc(c, pin);
+                    c = getword(pin, buf);
+                    if (buf->len == 3 && !memcmp(buf->s, "NIL", 3)) {
+                        /* indicated NIL with a NULL buf.s pointer */
+                        buf_free(buf);
+                        return c;
+                    }
                 }
-                return EOF;
             }
         }
         goto fail;
     }
 
+    /* XXX i think we can never get to this line? */
     return EOF;
 
 fail:
@@ -236,19 +258,21 @@ fail:
 EXPORTED int getint32(struct protstream *pin, int32_t *num)
 {
     int32_t result = 0;
-    int c;
+    int c = EOF;
     int gotchar = 0;
 
     /* INT_MAX == 2147483647 */
     while ((c = prot_getc(pin)) != EOF && cyrus_isdigit(c)) {
         if (result > 214748364 || (result == 214748364 && (c > '7')))
-            fatal("num too big", EC_IOERR);
+            fatal("num too big", EX_IOERR);
         result = result * 10 + c - '0';
         gotchar = 1;
     }
 
-    if (!gotchar)
+    if (!gotchar) {
+        if (c != EOF) prot_ungetc(c, pin);
         return EOF;
+    }
 
     *num = result;
 
@@ -287,19 +311,21 @@ EXPORTED int getsint32(struct protstream
 EXPORTED int getuint32(struct protstream *pin, uint32_t *num)
 {
     uint32_t result = 0;
-    int c;
+    int c = EOF;
     int gotchar = 0;
 
     /* UINT_MAX == 4294967295U */
     while ((c = prot_getc(pin)) != EOF && cyrus_isdigit(c)) {
         if (result > 429496729 || (result == 429496729 && (c > '5')))
-            fatal("num too big", EC_IOERR);
+            fatal("num too big", EX_IOERR);
         result = result * 10 + c - '0';
         gotchar = 1;
     }
 
-    if (!gotchar)
+    if (!gotchar) {
+        if (c != EOF) prot_ungetc(c, pin);
         return EOF;
+    }
 
     *num = result;
 
@@ -309,19 +335,21 @@ EXPORTED int getuint32(struct protstream
 EXPORTED int getint64(struct protstream *pin, int64_t *num)
 {
     int64_t result = 0;
-    int c;
+    int c = EOF;
     int gotchar = 0;
 
     /* LLONG_MAX == 9223372036854775807LL */
     while ((c = prot_getc(pin)) != EOF && cyrus_isdigit(c)) {
         if (result > 922337203685477580LL || (result == 922337203685477580LL && (c > '7')))
-            fatal("num too big", EC_IOERR);
+            fatal("num too big", EX_IOERR);
         result = result * 10 + c - '0';
         gotchar = 1;
     }
 
-    if (!gotchar)
+    if (!gotchar) {
+        if (c != EOF) prot_ungetc(c, pin);
         return EOF;
+    }
 
     *num = result;
 
@@ -360,19 +388,21 @@ EXPORTED int getsint64(struct protstream
 EXPORTED int getuint64(struct protstream *pin, uint64_t *num)
 {
     uint64_t result = 0;
-    int c;
+    int c = EOF;
     int gotchar = 0;
 
     /* ULLONG_MAX == 18446744073709551615ULL */
     while ((c = prot_getc(pin)) != EOF && cyrus_isdigit(c)) {
         if (result > 1844674407370955161ULL || (result == 1844674407370955161ULL && (c > '5')))
-            fatal("num too big", EC_IOERR);
+            fatal("num too big", EX_IOERR);
         result = result * 10 + c - '0';
         gotchar = 1;
     }
 
-    if (!gotchar)
+    if (!gotchar) {
+        if (c != EOF) prot_ungetc(c, pin);
         return EOF;
+    }
 
     *num = result;
 
@@ -383,7 +413,7 @@ EXPORTED int getuint64(struct protstream
  * all were right with the world */
 EXPORTED int getmodseq(struct protstream *pin, modseq_t *num)
 {
-    int c;
+    int c = EOF;
     unsigned int i = 0;
     char buf[32];
     int gotchar = 0;
@@ -395,8 +425,10 @@ EXPORTED int getmodseq(struct protstream
         gotchar = 1;
     }
 
-    if (!gotchar || i == sizeof(buf))
+    if (!gotchar || i == sizeof(buf)) {
+        if (c != EOF) prot_ungetc(c, pin);
         return EOF;
+    }
 
     buf[i] = '\0';
     *num = strtoull(buf, NULL, 10);
@@ -552,7 +584,7 @@ static int get_search_return_opts(struct
     if (c != '(') {
         prot_printf(pout,
                     "%s BAD Missing return options in Search\r\n", searchargs->tag);
-        return EOF;
+        goto bad;
     }
 
     do {
@@ -579,7 +611,7 @@ static int get_search_return_opts(struct
             prot_printf(pout,
                         "%s BAD Invalid Search return option %s\r\n",
                         searchargs->tag, opt.s);
-            return EOF;
+            goto bad;
         }
 
     } while (c == ' ');
@@ -596,12 +628,16 @@ static int get_search_return_opts(struct
         prot_printf(pout,
                     "%s BAD Missing close parenthesis in Search\r\n",
                     searchargs->tag);
-        return EOF;
+        goto bad;
     }
 
     c = prot_getc(pin);
 
     return c;
+
+bad:
+    if (c != EOF) prot_ungetc(c, pin);
+    return EOF;
 }
 
 /*
@@ -620,32 +656,29 @@ static int get_search_annotation(struct
     struct buf value = BUF_INITIALIZER;
 
     if (c != ' ')
-        return EOF;
+        goto bad;
 
     /* parse the entry */
     c = getastring(pin, pout, &entry);
     if (!entry.len || c != ' ') {
-        c = EOF;
-        goto out;
+        goto bad;
     }
 
     /* parse the attrib */
     c = getastring(pin, pout, &attrib);
     if (!attrib.len || c != ' ') {
-        c = EOF;
-        goto out;
+        goto bad;
     }
     if (strcmp(attrib.s, "value") &&
         strcmp(attrib.s, "value.shared") &&
         strcmp(attrib.s, "value.priv")) {
-        c = EOF;
-        goto out;
+        goto bad;
     }
 
     /* parse the value */
     c = getbnstring(pin, pout, &value);
     if (c == EOF)
-        goto out;
+        goto bad;
 
     sa = xzmalloc(sizeof(*sa));
     sa->entry = buf_release(&entry);
@@ -658,11 +691,18 @@ static int get_search_annotation(struct
 
     *lp = sa;
 
-out:
     buf_free(&entry);
     buf_free(&attrib);
     buf_free(&value);
     return c;
+
+bad:
+    buf_free(&entry);
+    buf_free(&attrib);
+    buf_free(&value);
+
+    if (c != EOF) prot_ungetc(c, pin);
+    return EOF;
 }
 
 
@@ -679,7 +719,24 @@ static void string_match(search_expr_t *
 
     e = search_expr_new(parent, op);
     e->attr = attr;
-    e->value.s = charset_convert(val, base->charset, charset_flags);
+    e->value.s = charset_convert(val, base->charset, charset_flags|CHARSET_KEEPCASE);
+    if (!e->value.s) {
+        e->op = SEOP_FALSE;
+        e->attr = NULL;
+    }
+}
+
+static void bytestring_match(search_expr_t *parent, const char *val,
+                             const char *aname,
+                             struct searchargs *base __attribute__((unused)))
+{
+    search_expr_t *e;
+    const search_attr_t *attr = search_attr_find(aname);
+    enum search_op op = SEOP_MATCH;
+
+    e = search_expr_new(parent, op);
+    e->attr = attr;
+    e->value.s = xstrdupnull(val);
     if (!e->value.s) {
         e->op = SEOP_FALSE;
         e->attr = NULL;
@@ -708,14 +765,15 @@ static void indexflag_match(search_expr_
     e->value.u = flag;
 }
 
-static void convflag_match(search_expr_t *parent, const char *flagname, int not)
+static void convflag_match(search_expr_t *parent, const char *flagname, int not,
+                           int matchall)
 {
     search_expr_t *e;
 
     if (not)
         parent = search_expr_new(parent, SEOP_NOT);
     e = search_expr_new(parent, SEOP_MATCH);
-    e->attr = search_attr_find("convflags");
+    e->attr = search_attr_find(matchall ? "allconvflags" : "convflags");
     e->value.s = xstrdup(flagname);
 }
 
@@ -749,7 +807,7 @@ static int get_search_criterion(struct p
     int c;
     int keep_charset = 0;
     time_t start, end, now = time(0);
-    int32_t i32;
+    uint32_t u;
     int hasconv = config_getswitch(IMAPOPT_CONVERSATIONS);
 
     if (base->state & GETSEARCH_CHARSET_FIRST) {
@@ -859,19 +917,19 @@ static int get_search_criterion(struct p
             if (c != ' ') goto missingarg;
             c = getword(pin, &arg);
             lcase(arg.s);
-            convflag_match(parent, arg.s, /*not*/0);
+            convflag_match(parent, arg.s, /*not*/0, /*all*/0);
         }
         else if (hasconv && !strcmp(criteria.s, "convread")) {  /* nonstandard */
-            convflag_match(parent, "\\Seen", /*not*/0);
+            convflag_match(parent, "\\Seen", /*not*/0, /*all*/0);
         }
         else if (hasconv && !strcmp(criteria.s, "convunread")) {    /* nonstandard */
-            convflag_match(parent, "\\Seen", /*not*/1);
+            convflag_match(parent, "\\Seen", /*not*/1, /*all*/1);
         }
         else if (hasconv && !strcmp(criteria.s, "convseen")) {  /* nonstandard */
-            convflag_match(parent, "\\Seen", /*not*/0);
+            convflag_match(parent, "\\Seen", /*not*/0, /*all*/0);
         }
         else if (hasconv && !strcmp(criteria.s, "convunseen")) {    /* nonstandard */
-            convflag_match(parent, "\\Seen", /*not*/1);
+            convflag_match(parent, "\\Seen", /*not*/1, /*all*/1);
         }
         else if (hasconv && !strcmp(criteria.s, "convmodseq")) {    /* nonstandard */
             modseq_t ms;
@@ -915,6 +973,16 @@ static int get_search_criterion(struct p
         else goto badcri;
         break;
 
+    case 'e':
+        if (!strcmp(criteria.s, "emailid")) {   /* draft-gondwana-imap-uniqueid */
+            if (c != ' ') goto missingarg;
+            c = getastring(pin, pout, &arg);
+            if (c == EOF) goto missingarg;
+            bytestring_match(parent, arg.s, criteria.s, base);
+        }
+        else goto badcri;
+        break;
+
     case 'f':
         if (!strcmp(criteria.s, "flagged")) {           /* RFC 3501 */
             systemflag_match(parent, FLAG_FLAGGED, /*not*/0);
@@ -953,7 +1021,7 @@ static int get_search_criterion(struct p
 
             e = search_expr_new(parent, SEOP_MATCH);
             e->attr = search_attr_find_field(arg.s);
-            e->value.s = charset_convert(arg2.s, base->charset, charset_flags);
+            e->value.s = charset_convert(arg2.s, base->charset, charset_flags|CHARSET_KEEPCASE);
             if (!e->value.s) {
                 e->op = SEOP_FALSE;
                 e->attr = NULL;
@@ -977,11 +1045,11 @@ static int get_search_criterion(struct p
     case 'l':
         if (!strcmp(criteria.s, "larger")) {            /* RFC 3501 */
             if (c != ' ') goto missingarg;
-            c = getint32(pin, &i32);
+            c = getint32(pin, (int32_t *)&u);
             if (c == EOF) goto badnumber;
             e = search_expr_new(parent, SEOP_GT);
             e->attr = search_attr_find("size");
-            e->value.u = i32;
+            e->value.u = u;
         }
         else goto badcri;
         break;
@@ -1035,12 +1103,23 @@ static int get_search_criterion(struct p
             indexflag_match(parent, MESSAGE_RECENT, /*not*/1);
         }
         else if (!strcmp(criteria.s, "older")) {    /* RFC 5032 */
-            if (c != ' ') goto missingarg;
-            c = getint32(pin, &i32);
+#if SIZEOF_TIME_T >= 8
+            int64_t uu;
+#endif
+            if (c != ' ') goto missingarg;
+#if SIZEOF_TIME_T >= 8
+            c = getint64(pin, (int64_t *)&uu);
+#else
+            c = getint32(pin, (int32_t *)&u);
+#endif
             if (c == EOF) goto badinterval;
             e = search_expr_new(parent, SEOP_LE);
             e->attr = search_attr_find("internaldate");
-            e->value.t = now - i32;
+#if SIZEOF_TIME_T >= 8
+            e->value.t = now - uu;
+#else
+            e->value.t = now - u;
+#endif
         }
         else if (!strcmp(criteria.s, "on")) {   /* RFC 3501 */
             if (c != ' ') goto missingarg;
@@ -1065,7 +1144,35 @@ static int get_search_criterion(struct p
         break;
 
     case 's':
-        if (!strcmp(criteria.s, "seen")) {              /* RFC 3501 */
+        if (!strcmp(criteria.s, "savedatesupported")) {   /* draft-ietf-extra-imap-savedate */
+            // savedate is supported in index version 15+
+            e = search_expr_new(parent, SEOP_GE);
+            e->attr = search_attr_find("indexversion");
+            e->value.u = 15;
+        }
+        else if (!strcmp(criteria.s, "savedbefore")) {   /* draft-ietf-extra-imap-savedate */
+            if (c != ' ') goto missingarg;
+            c = get_search_date(pin, &start, &end);
+            if (c == EOF) goto baddate;
+            e = search_expr_new(parent, SEOP_LT);
+            e->attr = search_attr_find("savedate");
+            e->value.u = start;
+        }
+        else if (!strcmp(criteria.s, "savedon")) {   /* draft-ietf-extra-imap-savedate */
+            if (c != ' ') goto missingarg;
+            c = get_search_date(pin, &start, &end);
+            if (c == EOF) goto baddate;
+            date_range(parent, "savedate", start, end);
+        }
+        else if (!strcmp(criteria.s, "savedsince")) {    /* draft-ietf-extra-imap-savedate */
+            if (c != ' ') goto missingarg;
+            c = get_search_date(pin, &start, &end);
+            if (c == EOF) goto baddate;
+            e = search_expr_new(parent, SEOP_GE);
+            e->attr = search_attr_find("savedate");
+            e->value.u = start;
+        }
+        else if (!strcmp(criteria.s, "seen")) {              /* RFC 3501 */
             indexflag_match(parent, MESSAGE_SEEN, /*not*/0);
         }
         else if (!strcmp(criteria.s, "sentbefore")) {   /* RFC 3501 */
@@ -1100,11 +1207,11 @@ static int get_search_criterion(struct p
         }
         else if (!strcmp(criteria.s, "smaller")) {  /* RFC 3501 */
             if (c != ' ') goto missingarg;
-            c = getint32(pin, &i32);
+            c = getint32(pin, (int32_t *)&u);
             if (c == EOF) goto badnumber;
             e = search_expr_new(parent, SEOP_LT);
             e->attr = search_attr_find("size");
-            e->value.u = i32;
+            e->value.u = u;
         }
         else if (!strcmp(criteria.s, "spamabove")) {  /* nonstandard */
             if (c != ' ') goto missingarg;
@@ -1144,6 +1251,12 @@ static int get_search_criterion(struct p
             if (c == EOF) goto missingarg;
             string_match(parent, arg.s, criteria.s, base);
         }
+        else if (!strcmp(criteria.s, "threadid")) {   /* draft-gondwana-imap-uniqueid */
+            if (c != ' ') goto missingarg;
+            c = getastring(pin, pout, &arg);
+            if (c == EOF) goto missingarg;
+            bytestring_match(parent, arg.s, criteria.s, base);
+        }
         else goto badcri;
         break;
 
@@ -1211,12 +1324,23 @@ static int get_search_criterion(struct p
 
     case 'y':
         if (!strcmp(criteria.s, "younger")) {           /* RFC 5032 */
-            if (c != ' ') goto missingarg;
-            c = getint32(pin, &i32);
+#if SIZEOF_TIME_T >= 8
+            int64_t uu;
+#endif
+            if (c != ' ') goto missingarg;
+#if SIZEOF_TIME_T >= 8
+            c = getint64(pin, (int64_t *)&uu);
+#else
+            c = getint32(pin, (int32_t *)&u);
+#endif
             if (c == EOF) goto badinterval;
             e = search_expr_new(parent, SEOP_GE);
             e->attr = search_attr_find("internaldate");
-            e->value.t = now - i32;
+#if SIZEOF_TIME_T >= 8
+            e->value.t = now - uu;
+#else
+            e->value.t = now - u;
+#endif
         }
         else goto badcri;
         break;
diff -pruN 3.0.13-5/imap/imap_proxy.c 3.2.0-3/imap/imap_proxy.c
--- 3.0.13-5/imap/imap_proxy.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/imap_proxy.c	2020-05-04 03:28:02.000000000 +0000
@@ -45,6 +45,7 @@
 #include <ctype.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/un.h>
 
@@ -52,7 +53,6 @@
 #include "acl.h"
 #include "annotate.h"
 #include "backend.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "imap_proxy.h"
 #include "proxy.h"
@@ -162,7 +162,7 @@ static int pipe_response(struct backend
     if (tag) {
         taglen = strlen(tag);
         if(taglen >= sizeof(buf) + 1) {
-            fatal("tag too large",EC_TEMPFAIL);
+            fatal("tag too large",EX_TEMPFAIL);
         }
     }
 
@@ -179,7 +179,7 @@ static int pipe_response(struct backend
         if (!prot_fgets(buf, sizeof(buf), s->in)) {
             /* uh oh */
             if(s == backend_current && !force_notfatal)
-                fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+                fatal("Lost connection to selected backend", EX_UNAVAILABLE);
             proxy_downserver(s);
             return PROXY_NOCONNECTION;
         }
@@ -203,7 +203,7 @@ static int pipe_response(struct backend
                 default: /* huh? no result? */
                     if(s == backend_current && !force_notfatal)
                         fatal("Lost connection to selected backend",
-                              EC_UNAVAILABLE);
+                              EX_UNAVAILABLE);
                     proxy_downserver(s);
                     r = PROXY_NOCONNECTION;
                     break;
@@ -517,7 +517,7 @@ static void add_sub(strarray_t *subs, mb
         strarray_append(subs, mbentry->name);
     }
     else {
-        /* a decendent of mailbox is subscribed */
+        /* a descendent of mailbox is subscribed */
         struct buf child = BUF_INITIALIZER;
 
         buf_printf(&child, "%s.", mbentry->name);
@@ -527,7 +527,7 @@ static void add_sub(strarray_t *subs, mb
 
 static int is_extended_resp(const char *cmd, struct listargs *listargs)
 {
-    if (!(listargs->ret &&
+    if (!(listargs->ret &
           (LIST_RET_STATUS | LIST_RET_MYRIGHTS | LIST_RET_METADATA))) {
         /* backend won't be sending extended response data */
         return 0;
@@ -576,7 +576,7 @@ int pipe_lsub(struct backend *s, const c
 
         if(c == EOF) {
             if(s == backend_current && !force_notfatal)
-                fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+                fatal("Lost connection to selected backend", EX_UNAVAILABLE);
             proxy_downserver(s);
             r = PROXY_NOCONNECTION;
             goto out;
@@ -587,7 +587,7 @@ int pipe_lsub(struct backend *s, const c
             if(!prot_fgets(buf, sizeof(buf), s->in)) {
                 if(s == backend_current && !force_notfatal)
                     fatal("Lost connection to selected backend",
-                          EC_UNAVAILABLE);
+                          EX_UNAVAILABLE);
                 proxy_downserver(s);
                 r = PROXY_NOCONNECTION;
                 goto out;
@@ -609,7 +609,7 @@ int pipe_lsub(struct backend *s, const c
             default: /* huh? no result? */
                 if(s == backend_current && !force_notfatal)
                     fatal("Lost connection to selected backend",
-                          EC_UNAVAILABLE);
+                          EX_UNAVAILABLE);
                 proxy_downserver(s);
                 r = PROXY_NOCONNECTION;
                 break;
@@ -621,7 +621,7 @@ int pipe_lsub(struct backend *s, const c
 
         if(c == EOF) {
             if(s == backend_current && !force_notfatal)
-                fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+                fatal("Lost connection to selected backend", EX_UNAVAILABLE);
             proxy_downserver(s);
             r = PROXY_NOCONNECTION;
             goto out;
@@ -668,7 +668,7 @@ int pipe_lsub(struct backend *s, const c
             if(c != ' ') {
                 if(s == backend_current && !force_notfatal)
                     fatal("Bad LSUB response from selected backend",
-                          EC_UNAVAILABLE);
+                          EX_UNAVAILABLE);
                 proxy_downserver(s);
                 r = PROXY_NOCONNECTION;
                 goto out;
@@ -680,7 +680,7 @@ int pipe_lsub(struct backend *s, const c
             if(c != ' ') {
                 if(s == backend_current && !force_notfatal)
                     fatal("Bad LSUB response from selected backend",
-                          EC_UNAVAILABLE);
+                          EX_UNAVAILABLE);
                 proxy_downserver(s);
                 r = PROXY_NOCONNECTION;
                 goto out;
@@ -706,7 +706,7 @@ int pipe_lsub(struct backend *s, const c
             if(c != '\n') {
                 if(s == backend_current && !force_notfatal)
                     fatal("Bad LSUB response from selected backend",
-                          EC_UNAVAILABLE);
+                          EX_UNAVAILABLE);
                 proxy_downserver(s);
                 r = PROXY_NOCONNECTION;
                 goto out;
@@ -964,7 +964,7 @@ void proxy_copy(const char *tag, char *s
                 c = EOF;
                 break;
             }
-            /* looking at either SP seperating items or a RPAREN */
+            /* looking at either SP separating items or a RPAREN */
             if (c == ' ') { c = prot_getc(backend_current->in); }
             else if (c == ')') break;
             else { c = EOF; break; }
@@ -1019,7 +1019,7 @@ void proxy_copy(const char *tag, char *s
     }
     if (c == EOF) {
         /* uh oh, we're not happy */
-        fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+        fatal("Lost connection to selected backend", EX_UNAVAILABLE);
     }
 
     /* start the append */
@@ -1128,7 +1128,7 @@ void proxy_copy(const char *tag, char *s
                 c = EOF;
                 break;
             }
-            /* looking at either SP seperating items or a RPAREN */
+            /* looking at either SP separating items or a RPAREN */
             if (c == ' ') { c = prot_getc(backend_current->in); }
             else if (c == ')') break;
             else { c = EOF; break; }
@@ -1247,7 +1247,7 @@ int proxy_catenate_url(struct backend *s
     }
     if (c == EOF) {
         /* uh oh, we're not happy */
-        fatal("Lost connection to backend", EC_UNAVAILABLE);
+        fatal("Lost connection to backend", EX_UNAVAILABLE);
     }
 
     if (url->uidvalidity && (uidvalidity != url->uidvalidity)) {
@@ -1359,7 +1359,7 @@ int proxy_catenate_url(struct backend *s
     }
     if (c == EOF) {
         /* uh oh, we're not happy */
-        fatal("Lost connection to backend", EC_UNAVAILABLE);
+        fatal("Lost connection to backend", EX_UNAVAILABLE);
     }
 
   unselect:
@@ -1384,7 +1384,7 @@ int proxy_catenate_url(struct backend *s
     }
     if (c == EOF) {
         /* uh oh, we're not happy */
-        fatal("Lost connection to backend", EC_UNAVAILABLE);
+        fatal("Lost connection to backend", EX_UNAVAILABLE);
     }
 
     if (!r && !found) {
@@ -1395,13 +1395,13 @@ int proxy_catenate_url(struct backend *s
     return r;
 }
 
-/* Proxy GETANNOTATION commands to backend */
+/* Proxy GETMETADATA commands to backend */
 int annotate_fetch_proxy(const char *server, const char *mbox_pat,
                          const strarray_t *entry_pat,
                          const strarray_t *attribute_pat)
 {
     struct backend *be;
-    int i;
+    int i, j;
     char mytag[128];
 
     assert(server && mbox_pat && entry_pat && attribute_pat);
@@ -1414,12 +1414,23 @@ int annotate_fetch_proxy(const char *ser
     /* Send command to remote */
     proxy_gentag(mytag, sizeof(mytag));
     prot_printf(be->out, "%s GETANNOTATION \"%s\" (", mytag, mbox_pat);
-    for (i = 0 ; i < entry_pat->count ; i++) {
-        prot_printf(be->out, "%s\"%s\"", i ? " " : "", entry_pat->data[i]);
-    }
-    prot_printf(be->out, ") (");
-    for (i = 0 ; i < attribute_pat->count ; i++) {
-        prot_printf(be->out, "%s\"%s\"", i ? " " : "", attribute_pat->data[i]);
+    for (i = 0; i < entry_pat->count; i++) {
+        const char *entry = strarray_nth(entry_pat, i);
+
+        for (j = 0; j < attribute_pat->count; j++) {
+            const char *scope, *attr = strarray_nth(attribute_pat, j);
+            if (!strcmp(attr, "value.shared")) {
+                scope = "/shared";
+            }
+            else if (!strcmp(attr, "value.priv")) {
+                scope = "/private";
+            }
+            else {
+                syslog(LOG_ERR, "won't get deprecated annotation attribute %s", attr);
+                continue;
+            }
+            prot_printf(be->out, "%s%s%s", i ? " " : "", scope, entry);
+        }
     }
     prot_printf(be->out, ")\r\n");
     prot_flush(be->out);
@@ -1431,7 +1442,7 @@ int annotate_fetch_proxy(const char *ser
     return 0;
 }
 
-/* Proxy SETANNOTATION commands to backend */
+/* Proxy SETMETADATA commands to backend */
 int annotate_store_proxy(const char *server, const char *mbox_pat,
                          struct entryattlist *entryatts)
 {
@@ -1439,6 +1450,8 @@ int annotate_store_proxy(const char *ser
     struct entryattlist *e;
     struct attvaluelist *av;
     char mytag[128];
+    struct buf entrybuf = BUF_INITIALIZER;
+
 
     assert(server && mbox_pat && entryatts);
 
@@ -1449,17 +1462,34 @@ int annotate_store_proxy(const char *ser
 
     /* Send command to remote */
     proxy_gentag(mytag, sizeof(mytag));
-    prot_printf(be->out, "%s SETANNOTATION \"%s\" (", mytag, mbox_pat);
+    prot_printf(be->out, "%s SETMETADATA \"%s\" (", mytag, mbox_pat);
     for (e = entryatts; e; e = e->next) {
-        prot_printf(be->out, "\"%s\" (", e->entry);
-
         for (av = e->attvalues; av; av = av->next) {
-            prot_printf(be->out, "\"%s\" ", av->attrib);
-            prot_printmap(be->out, av->value.s, av->value.len);
-            prot_printf(be->out, "%s", av->next ? " " : "");
+            assert(av->attrib);
+            if (!strcmp(av->attrib, "value.shared")) {
+                buf_setcstr(&entrybuf, "/shared");
+            }
+            else if (!strcmp(av->attrib, "value.priv")) {
+                buf_setcstr(&entrybuf, "/private");
+            }
+            else {
+                syslog(LOG_ERR,
+                       "won't proxy annotation with deprecated attribute %s",
+                       av->attrib);
+                buf_free(&entrybuf);
+                return IMAP_INTERNAL;
+            }
+
+            buf_appendcstr(&entrybuf, e->entry);
+
+            /* Print the entry-value pair */
+            prot_printamap(be->out, entrybuf.s, entrybuf.len);
+            prot_putc(' ', be->out);
+            prot_printamap(be->out, av->value.s, av->value.len);
+
+            if (av->next) prot_putc(' ', be->out);
         }
-        prot_printf(be->out, ")");
-        if (e->next) prot_printf(be->out, " ");
+        if (e->next) prot_putc(' ', be->out);
     }
     prot_printf(be->out, ")\r\n");
     prot_flush(be->out);
@@ -1468,6 +1498,8 @@ int annotate_store_proxy(const char *ser
        messages. */
     pipe_until_tag(be, mytag, 0);
 
+    buf_free(&entrybuf);
+
     return 0;
 }
 
@@ -1574,7 +1606,7 @@ static void proxy_part_filldata(partlist
         }
         if (c == EOF) {
             /* uh oh, we're not happy */
-            fatal("Lost connection to backend", EC_UNAVAILABLE);
+            fatal("Lost connection to backend", EX_UNAVAILABLE);
         }
 
         /* unique id */
diff -pruN 3.0.13-5/imap/index.c 3.2.0-3/imap/index.c
--- 3.0.13-5/imap/index.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/index.c	2020-05-04 03:28:02.000000000 +0000
@@ -49,6 +49,7 @@
 #include <errno.h>
 #include <fcntl.h>
 #include <netinet/in.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <ctype.h>
 #include <stdlib.h>
@@ -56,18 +57,21 @@
 #ifdef USE_HTTPD
 /* For iCalendar indexing */
 #include <libical/ical.h>
+#include "vcard_support.h"
 #endif
 
 #include "acl.h"
 #include "annotate.h"
 #include "append.h"
 #include "assert.h"
+#include "backend.h"
 #include "charset.h"
 #include "conversations.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "hash.h"
 #include "hashu64.h"
+#include "http_client.h"
+#include "jmap_util.h"
 #include "global.h"
 #include "times.h"
 #include "imapd.h"
@@ -75,6 +79,7 @@
 #include "mailbox.h"
 #include "map.h"
 #include "message.h"
+#include "msgrecord.h"
 #include "parseaddr.h"
 #include "search_engines.h"
 #include "search_query.h"
@@ -99,7 +104,7 @@ EXPORTED unsigned client_capa;
 /* Forward declarations */
 static void index_refresh_locked(struct index_state *state);
 static void index_tellexists(struct index_state *state);
-static int index_lock(struct index_state *state);
+static int index_lock(struct index_state *state, int readonly);
 static void index_unlock(struct index_state *state);
 
 struct index_modified_flags {
@@ -143,10 +148,11 @@ static int index_copysetup(struct index_
                            struct copyargs *copyargs);
 static int index_storeflag(struct index_state *state,
                            struct index_modified_flags *modified_flags,
-                           uint32_t msgno, struct index_record *record,
+                           uint32_t msgno, msgrecord_t *msgrec,
                            struct storeargs *storeargs);
 static int index_store_annotation(struct index_state *state, uint32_t msgno,
-                           struct storeargs *storeargs);
+                           msgrecord_t *mrw, struct storeargs *storeargs,
+                           int *dirty);
 static int index_fetchreply(struct index_state *state, uint32_t msgno,
                             const struct fetchargs *fetchargs);
 static void index_printflags(struct index_state *state, uint32_t msgno,
@@ -160,7 +166,6 @@ static void index_get_ids(MsgData *msgda
 
 static int index_sort_compare(MsgData *md1, MsgData *md2,
                               const struct sortcrit *call_data);
-static int index_sort_compare_qsort(const void *v1, const void *v2);
 
 static void *index_thread_getnext(Thread *thread);
 static void index_thread_setnext(Thread *thread, Thread *next);
@@ -207,21 +212,16 @@ EXPORTED int index_reload_record(struct
     else {
         record->recno = im->recno;
         record->uid = im->uid;
-        r = mailbox_reload_index_record(state->mailbox, record);
+        r = mailbox_reload_index_record_dirty(state->mailbox, record);
     }
     /* NOTE: we have released the cyrus.index lock at this point, but are
      * still holding the mailbox name relock.  This means nobody can rewrite
      * the file under us - so the offsets are still guaranteed to be correct,
      * and all the immutable fields are unchanged.  That said, we can get a
      * read of a partially updated record which contains an invalid checksum
-     * due to incomplete concurrent changes to mutable fields.
-     *
-     * That's OK in just this case, because we're about to overwrite all the
-     * parsed mutable fields with the clean values we cached back when we had
-     * a cyrus.index lock and got a complete read. */
-    if (r == IMAP_MAILBOX_CHECKSUM) r = 0;
-
-    /* but other errors are still bad */
+     * due to incomplete concurrent changes to mutable fields.  That's why we
+     * used the _dirty API which ignores checksums.
+     * but other errors are still bad */
     if (r) return r;
 
     /* better be! */
@@ -230,6 +230,7 @@ EXPORTED int index_reload_record(struct
     /* restore mutable fields */
     record->modseq = im->modseq;
     record->system_flags = im->system_flags;
+    record->internal_flags = im->internal_flags;
     record->cache_offset = im->cache_offset;
     for (i = 0; i < MAX_USER_FLAGS/32; i++)
         record->user_flags[i] = im->user_flags[i];
@@ -239,20 +240,23 @@ EXPORTED int index_reload_record(struct
 
 static int index_rewrite_record(struct index_state *state,
                                 uint32_t msgno,
-                                struct index_record *record)
+                                struct index_record *record,
+                                int silent)
 {
     struct index_map *im = &state->map[msgno-1];
     int i;
-    int r;
 
     assert(record->uid == im->uid);
 
-    r = mailbox_rewrite_index_record(state->mailbox, record);
-    if (r) return r;
+    if (!silent) {
+        int r = mailbox_rewrite_index_record(state->mailbox, record);
+        if (r) return r;
+    }
 
     /* update tracking of mutable fields */
     im->modseq = record->modseq;
     im->system_flags = record->system_flags;
+    im->internal_flags = record->internal_flags;
     im->cache_offset = record->cache_offset;
     for (i = 0; i < MAX_USER_FLAGS/32; i++)
         im->user_flags[i] = record->user_flags[i];
@@ -264,6 +268,7 @@ EXPORTED void index_release(struct index
 {
     if (!state) return;
 
+    message_unref(&state->m);
     if (state->mailbox) {
         mailbox_close(&state->mailbox);
         state->mailbox = NULL; /* should be done by close anyway */
@@ -283,12 +288,12 @@ EXPORTED void index_close(struct index_s
 
     index_release(state);
 
-    free(state->map);
-    free(state->mboxname);
-    free(state->userid);
+    xfree(state->map);
+    xfree(state->mboxname);
+    xfree(state->userid);
     for (i = 0; i < MAX_USER_FLAGS; i++)
-        free(state->flagname[i]);
-    free(state);
+        xfree(state->flagname[i]);
+    xfree(state);
 
     *stateptr = NULL;
 }
@@ -325,7 +330,7 @@ EXPORTED int index_open_mailbox(struct m
     }
 
     if (state->mailbox->mbtype & MBTYPES_NONIMAP) {
-        if (state->want_dav && (state->mailbox->mbtype & MBTYPES_DAV)) {
+        if (state->want_dav) {
             /* User logged in using imapmagicplus token "dav" */
         }
         else if (state->mailbox->mbtype == state->want_mbtype) {
@@ -351,9 +356,9 @@ EXPORTED int index_open_mailbox(struct m
     return 0;
 
 fail:
-    free(state->mboxname);
-    free(state->userid);
-    free(state);
+    xfree(state->mboxname);
+    xfree(state->userid);
+    xfree(state);
     return r;
 }
 
@@ -389,7 +394,7 @@ EXPORTED int index_expunge(struct index_
     struct mboxevent *mboxevent = NULL;
     modseq_t oldmodseq;
 
-    r = index_lock(state);
+    r = index_lock(state, /*readonly*/0);
     if (r) return r;
 
     /* XXX - check if not mailbox->i.deleted count and need_deleted */
@@ -400,7 +405,7 @@ EXPORTED int index_expunge(struct index_
     for (msgno = 1; msgno <= state->exists; msgno++) {
         im = &state->map[msgno-1];
 
-        if (im->system_flags & FLAG_EXPUNGED)
+        if (im->internal_flags & FLAG_INTERNAL_EXPUNGED)
             continue; /* already expunged */
 
         if (need_deleted && !(im->system_flags & FLAG_DELETED))
@@ -427,11 +432,12 @@ EXPORTED int index_expunge(struct index_
         }
 
         /* set the flags */
-        record.system_flags |= FLAG_DELETED | FLAG_EXPUNGED;
+        record.system_flags |= FLAG_DELETED;
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
         numexpunged++;
         state->num_expunged++;
 
-        r = index_rewrite_record(state, msgno, &record);
+        r = index_rewrite_record(state, msgno, &record, /*silent*/0);
         if (r) break;
 
         /* avoid telling again (equivalent to STORE FLAGS.SILENT) */
@@ -516,9 +522,12 @@ static int index_writeseen(struct index_
     if (state->examining)
         return 0;
 
+    /* always dirty the mailbox, we may just be updating recent counts which doesn't bump the
+     * modseq because Recent is all sorts of evil */
+    mailbox_index_dirty(mailbox);
+
     /* already handled! Just update the header fields */
     if (state->internalseen) {
-        mailbox_index_dirty(mailbox);
         mailbox->i.recenttime = time(0);
         if (mailbox->i.recentuid < state->last_uid)
             mailbox->i.recentuid = state->last_uid;
@@ -628,17 +637,10 @@ static void index_refresh_locked(struct
      * last time plus however many new records might be unEXPUNGEd on the
      * end */
 
+    need_records = state->want_expunged ? mailbox->i.num_records : mailbox->i.exists;
     if (state->last_uid) {
         need_records = state->exists + (mailbox->i.last_uid - state->last_uid);
     }
-    else if (state->want_expunged) {
-        /* could need the lot! */
-        need_records = mailbox->i.num_records;
-    }
-    else {
-        /* init case */
-        need_records = mailbox->i.exists;
-    }
 
     /* make sure we have space */
     if (need_records >= state->mapsize) {
@@ -658,7 +660,7 @@ static void index_refresh_locked(struct
             /* NOTE: this same logic is repeated below for messages
              * past the end of recno (repack removing the trailing
              * records).  Make sure to keep them in sync */
-            if (!(im->system_flags & FLAG_EXPUNGED)) {
+            if (!(im->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
                 /* we don't even know the modseq of when it was wiped,
                  * but we can be sure it's since the last given highestmodseq,
                  * so simulate the lowest possible value.  This is fine for
@@ -673,7 +675,8 @@ static void index_refresh_locked(struct
             /* simulate expunged flag so we get an EXPUNGE response and
              * tell about unlinked so we don't get IO errors trying to
              * find the file */
-            im->system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+            im->internal_flags |= FLAG_INTERNAL_EXPUNGED |
+                FLAG_INTERNAL_UNLINKED;
             im = &state->map[msgno++];
 
             /* this one is expunged */
@@ -685,7 +688,7 @@ static void index_refresh_locked(struct
          * get its own msgno */
         if (!state->want_expunged
             && (msgno > state->exists || record->uid < im->uid)
-            && (record->system_flags & FLAG_EXPUNGED))
+            && (record->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         /* make sure our UID map is consistent */
@@ -693,6 +696,7 @@ static void index_refresh_locked(struct
             assert(im->uid == record->uid);
         }
         else {
+            memset(im, 0, sizeof(struct index_map));
             im->uid = record->uid;
         }
 
@@ -700,12 +704,19 @@ static void index_refresh_locked(struct
         im->recno = record->recno;
         im->modseq = record->modseq;
         im->system_flags = record->system_flags;
+        im->internal_flags = record->internal_flags;
         im->cache_offset = record->cache_offset;
         for (i = 0; i < MAX_USER_FLAGS/32; i++)
             im->user_flags[i] = record->user_flags[i];
 
+        /* re-calculate seen flags */
+        if (state->internalseen)
+            im->isseen = (im->system_flags & FLAG_SEEN) ? 1 : 0;
+        else
+            im->isseen = seqset_ismember(seenlist, im->uid) ? 1 : 0;
+
         /* for expunged records, just track the modseq */
-        if (im->system_flags & FLAG_EXPUNGED) {
+        if (im->internal_flags & FLAG_INTERNAL_EXPUNGED) {
             num_expunged++;
             /* http://www.rfc-editor.org/errata_search.php?rfc=5162
              * Errata ID: 1809 - if there are expunged records we
@@ -715,12 +726,6 @@ static void index_refresh_locked(struct
                 delayed_modseq = im->modseq - 1;
         }
         else {
-            /* re-calculate seen flags */
-            if (state->internalseen)
-                im->isseen = (im->system_flags & FLAG_SEEN) ? 1 : 0;
-            else
-                im->isseen = seqset_ismember(seenlist, im->uid) ? 1 : 0;
-
             if (msgno > state->exists) {
                 /* don't auto-tell new records */
                 im->told_modseq = im->modseq;
@@ -746,15 +751,15 @@ static void index_refresh_locked(struct
             }
         }
 
-        msgno++;
-
         /* make sure we don't overflow the memory we mapped */
         if (msgno > state->mapsize) {
             char buf[2048];
             sprintf(buf, "Exists wrong %u %u %u %u", msgno,
                     state->mapsize, mailbox->i.exists, mailbox->i.num_records);
-            fatal(buf, EC_IOERR);
+            fatal(buf, EX_IOERR);
         }
+
+        msgno++;
     }
     mailbox_iter_done(&iter);
 
@@ -766,12 +771,12 @@ static void index_refresh_locked(struct
         /* this is the same logic as the block above in the main loop,
          * see comments up there, and make sure the blocks are kept
          * in sync! */
-        if (!(im->system_flags & FLAG_EXPUNGED))
+        if (!(im->internal_flags & FLAG_INTERNAL_EXPUNGED))
             im->modseq = state->highestmodseq + 1;
         if (!delayed_modseq || im->modseq < delayed_modseq)
             delayed_modseq = im->modseq - 1;
         im->recno = 0;
-        im->system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+        im->internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
         im = &state->map[msgno++];
         num_expunged++;
     }
@@ -865,7 +870,9 @@ EXPORTED int index_check(struct index_st
 
     if (!state) return 0;
 
-    r = index_lock(state);
+    /* we don't write any records in here, but we want to write the recentuid if
+     * there were new emails delivered... */
+    r = index_lock(state, /*readonly*/0);
 
     /* Check for deleted mailbox  */
     if (r == IMAP_MAILBOX_NONEXISTENT) {
@@ -875,7 +882,7 @@ EXPORTED int index_check(struct index_st
                    "Mailbox %s has been (re)moved out from under client",
                    state->mboxname);
             mailbox_close(&state->mailbox);
-            fatal("Mailbox has been (re)moved", EC_IOERR);
+            fatal("Mailbox has been (re)moved", EX_IOERR);
         }
 
         if (state->exists && (client_capa & CAPA_QRESYNC)) {
@@ -946,7 +953,7 @@ struct seqset *index_vanished(struct ind
         struct mailbox_iter *iter = mailbox_iter_init(mailbox, params->modseq, 0);
         while ((msg = mailbox_iter_step(iter))) {
             const struct index_record *record = msg_record(msg);
-            if (!(record->system_flags & FLAG_EXPUNGED))
+            if (!(record->internal_flags & FLAG_INTERNAL_EXPUNGED))
                 continue;
             if (!params->sequence || seqset_ismember(seq, record->uid))
                 seqset_add(outlist, record->uid, 1);
@@ -1046,7 +1053,7 @@ static int _fetch_setseen(struct index_s
         record.system_flags |= FLAG_SEEN;
 
     /* need to bump modseq anyway, so always rewrite it */
-    r = index_rewrite_record(state, msgno, &record);
+    r = index_rewrite_record(state, msgno, &record, /*silent*/0);
     if (r) return r;
 
     mboxevent_extract_record(mboxevent, state->mailbox, &record);
@@ -1155,7 +1162,7 @@ EXPORTED int index_fetch(struct index_st
     int r;
     struct mboxevent *mboxevent = NULL;
 
-    r = index_lock(state);
+    r = index_lock(state, /*readonly*/0);  // can't be readonly because of FETCH_SETSEEN
     if (r) return r;
 
     seq = _parse_sequence(state, sequence, usinguid);
@@ -1241,7 +1248,7 @@ EXPORTED int index_store(struct index_st
         return IMAP_PERMISSION_DENIED;
     }
 
-    r = index_lock(state);
+    r = index_lock(state, /*readonly*/0);
     if (r) return r;
 
     mailbox = state->mailbox;
@@ -1262,7 +1269,7 @@ EXPORTED int index_store(struct index_st
             continue;
 
         /* if it's expunged already, skip it now */
-        if ((im->system_flags & FLAG_EXPUNGED))
+        if ((im->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         /* if it's changed already, skip it now */
@@ -1278,16 +1285,28 @@ EXPORTED int index_store(struct index_st
             continue;
         }
 
+        /* TODO(rsto): we need to keep index_reload_record here until we
+         * can make sure that the index map doesn't contain uncommitted
+         * changes for this msgno. See the comments in index_reload_record
+         * on how it releases the cyrus.index lock in the middle of action */
         r = index_reload_record(state, msgno, &record);
         if (r) goto out;
 
+        msgrecord_t *msgrec = msgrecord_from_index_record(state->mailbox, &record);
+
         switch (storeargs->operation) {
         case STORE_ADD_FLAGS:
         case STORE_REMOVE_FLAGS:
         case STORE_REPLACE_FLAGS:
-            r = index_storeflag(state, &modified_flags, msgno, &record, storeargs);
-            if (r)
-                break;
+            r = index_storeflag(state, &modified_flags, msgno, msgrec, storeargs);
+            if (r) goto doneloop;
+
+            // nothing to do?
+            if (!(modified_flags.added_flags | modified_flags.removed_flags))
+                goto doneloop;
+
+            r = msgrecord_rewrite(msgrec);
+            if (r) goto doneloop;
 
             if (modified_flags.added_flags) {
                 if (flagsset == NULL)
@@ -1296,7 +1315,7 @@ EXPORTED int index_store(struct index_st
                 mboxevent_add_flags(flagsset, mailbox->flagname,
                                     modified_flags.added_system_flags,
                                     modified_flags.added_user_flags);
-                mboxevent_extract_record(flagsset, mailbox, &record);
+                mboxevent_extract_msgrecord(flagsset, msgrec);
             }
             if (modified_flags.removed_flags) {
                 if (flagsclear == NULL)
@@ -1305,22 +1324,44 @@ EXPORTED int index_store(struct index_st
                 mboxevent_add_flags(flagsclear, mailbox->flagname,
                                     modified_flags.removed_system_flags,
                                     modified_flags.removed_user_flags);
-                mboxevent_extract_record(flagsclear, mailbox, &record);
+                mboxevent_extract_msgrecord(flagsclear, msgrec);
             }
-
             break;
 
-        case STORE_ANNOTATION:
-            r = index_store_annotation(state, msgno, storeargs);
+        case STORE_ANNOTATION: {
+            int dirty = 0;
+            r = index_store_annotation(state, msgno, msgrec, storeargs, &dirty);
+            if (r) goto doneloop;
+            if (!dirty) goto doneloop;
+
+            // rewrite message
+            r = msgrecord_rewrite(msgrec);
+            if (r) goto doneloop;
+
+            // XXX mboxevents?
+
             break;
+        }
 
         default:
             r = IMAP_INTERNAL;
             break;
         }
+        if (r) goto doneloop;
+
+        /* msgrecord_rewrite already took care of rewriting the index_record,
+         * but we want to stay up to date of the changes in the index_map.
+         * Pass the silent flag to index_rewrite_record. */
+        r = msgrecord_get_index_record(msgrec, &record);
+        if (r) goto doneloop;
+        r = index_rewrite_record(state, msgno, &record, /*silent*/1);
+
+doneloop:
+        msgrecord_unref(&msgrec);
         if (r) goto out;
     }
 
+
     /* let mboxevent_notify split FlagsSet into MessageRead, MessageTrash
      * and FlagsSet events */
     mboxevent_extract_mailbox(flagsset, mailbox);
@@ -1387,6 +1428,7 @@ EXPORTED int index_run_annotator(struct
     struct index_map *im;
     uint32_t msgno;
     struct appendstate as;
+    msgrecord_t *msgrec = NULL;
     int r = 0;
 
     /* We do the acl check here rather than in append_setup_mbox()
@@ -1398,7 +1440,7 @@ EXPORTED int index_run_annotator(struct
     if (!config_getstring(IMAPOPT_ANNOTATION_CALLOUT))
         return 0;
 
-    r = index_lock(state);
+    r = index_lock(state, /*readonly*/0);
     if (r) return r;
 
     r = append_setup_mbox(&as, state->mailbox,
@@ -1417,22 +1459,32 @@ EXPORTED int index_run_annotator(struct
             continue;
 
         /* if it's expunged already, skip it now */
-        if ((im->system_flags & FLAG_EXPUNGED))
+        if ((im->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         r = index_reload_record(state, msgno, &record);
         if (r) goto out;
 
-        r = append_run_annotator(&as, &record);
+        msgrec = msgrecord_from_index_record(state->mailbox, &record);
+
+        r = append_run_annotator(&as, msgrec);
         if (r) goto out;
 
-        r = index_rewrite_record(state, msgno, &record);
+        /* msgrecord_rewrite already took care of rewriting the index_record,
+         * but we want to stay up to date of the changes in the index_map.
+         * Pass the silent flag to index_rewrite_record. */
+        r = msgrecord_get_index_record(msgrec, &record);
         if (r) goto out;
+        r = index_rewrite_record(state, msgno, &record, /*silent*/1);
+        if (r) goto out;
+
+        msgrecord_unref(&msgrec);
     }
 
 out:
     seqset_free(seq);
 
+    if (msgrec) msgrecord_unref(&msgrec);
     if (!r) {
         r = append_commit(&as);
     }
@@ -1476,13 +1528,6 @@ EXPORTED int index_warmup(struct mboxlis
         r = warmup_file(fname, 0, 0);
         if (r) goto out;
     }
-    if (warmup_flags & WARMUP_FOLDERSTATUS) {
-        if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-            fname = tofree2 = statuscache_filename();
-            r = warmup_file(fname, 0, 0);
-            if (r) goto out;
-        }
-    }
     if (warmup_flags & WARMUP_SEARCH) {
         userid = mboxname_to_userid(mbentry->name);
         r = search_list_files(userid, &files);
@@ -1632,7 +1677,7 @@ EXPORTED int index_scan(struct index_sta
     listcount = index_prefilter_messages(msgno_list, state, &searchargs);
 
     for (listindex = 0; !n && listindex < listcount; listindex++) {
-        if (cmd_cancelled())
+        if (!(listindex % 128) && cmd_cancelled(/*insearch*/1))
             break;
         struct buf buf = BUF_INITIALIZER;
         struct index_record record;
@@ -1656,19 +1701,6 @@ EXPORTED int index_scan(struct index_sta
     return n;
 }
 
-EXPORTED message_t *index_get_message(struct index_state *state, uint32_t msgno)
-{
-    struct index_map *im = &state->map[msgno-1];
-    struct index_record record;
-    uint32_t indexflags = 0;
-    if (im->isseen) indexflags |= MESSAGE_SEEN;
-    if (im->isrecent) indexflags |= MESSAGE_RECENT;
-    if (index_reload_record(state, msgno, &record))
-        return NULL;
-    return message_new_from_index(state->mailbox, &record,
-                                  msgno, indexflags);
-}
-
 EXPORTED uint32_t index_getuid(struct index_state *state, uint32_t msgno)
 {
     assert(msgno <= state->exists);
@@ -1699,12 +1731,12 @@ out:
     return n;
 }
 
-static int index_lock(struct index_state *state)
+static int index_lock(struct index_state *state, int readonly)
 {
     int r;
 
     if (state->mailbox) {
-        if (state->examining) {
+        if (state->examining || readonly) {
             r = mailbox_lock_index(state->mailbox, LOCK_SHARED);
             if (r) return r;
         }
@@ -1714,7 +1746,7 @@ static int index_lock(struct index_state
         }
     }
     else {
-        if (state->examining) {
+        if (state->examining || readonly) {
             r = mailbox_open_irl(state->mboxname, &state->mailbox);
             if (r) return r;
         }
@@ -1740,15 +1772,11 @@ static int index_lock(struct index_state
 
 EXPORTED int index_status(struct index_state *state, struct statusdata *sdata)
 {
-    int items = STATUS_MESSAGES | STATUS_UIDNEXT | STATUS_UIDVALIDITY |
-                STATUS_HIGHESTMODSEQ | STATUS_RECENT | STATUS_UNSEEN;
-    int r;
-
-    r = index_lock(state);
+    int r = index_lock(state, /*readonly*/1);
     if (r) return r;
 
-    statuscache_fill(sdata, state->userid, state->mailbox, items,
-                     state->numrecent, state->numunseen);
+    status_fill_mailbox(state->mailbox, sdata);
+    status_fill_seen(state->userid, sdata, state->numrecent, state->numunseen);
 
     index_unlock(state);
     return 0;
@@ -1758,7 +1786,7 @@ EXPORTED int index_refresh(struct index_
 {
     int r;
 
-    r = index_lock(state);  /* calls index_refresh_locked */
+    r = index_lock(state, /*readonly*/1);  /* calls index_refresh_locked */
     if (r) return r;
     index_unlock(state);
     return 0;
@@ -1766,14 +1794,23 @@ EXPORTED int index_refresh(struct index_
 
 static void index_unlock(struct index_state *state)
 {
-    /* XXX - errors */
-
-    index_writeseen(state);
+    // only update seen if we've got a writelocked mailbox
+    if (mailbox_index_islocked(state->mailbox, 1))
+        index_writeseen(state);  // XXX: errors?
 
     /* grab the latest modseq */
     state->highestmodseq = state->mailbox->i.highestmodseq;
 
-    mailbox_unlock_index(state->mailbox, NULL);
+    if (state->mailbox->i.dirty) {
+        struct statusdata sdata = STATUSDATA_INIT;
+        status_fill_mailbox(state->mailbox, &sdata);
+        // we zero out recent data for everyone else
+        status_fill_seen(state->userid, &sdata, /*recent*/0, state->numunseen);
+        mailbox_unlock_index(state->mailbox, &sdata);
+    }
+    else {
+        mailbox_unlock_index(state->mailbox, NULL);
+    }
 }
 
 /*
@@ -1966,46 +2003,6 @@ out:
     return nmsg;
 }
 
-static int is_mutable_sort(struct sortcrit *sortcrit)
-{
-    int i;
-
-    if (!sortcrit) return 0;
-
-    for (i = 0; sortcrit[i].key; i++) {
-        switch (sortcrit[i].key) {
-            /* these are the mutable fields */
-            case SORT_ANNOTATION:
-            case SORT_MODSEQ:
-            case SORT_HASFLAG:
-            case SORT_CONVMODSEQ:
-            case SORT_CONVEXISTS:
-            case SORT_CONVSIZE:
-            case SORT_HASCONVFLAG:
-                return 1;
-            default:
-                break;
-        }
-    }
-
-    return 0;
-}
-
-/* This function will return a TRUE value if anything in the
- * sort or search criteria returns a MUTABLE ordering, i.e.
- * the user can take actions which will change the order in
- * which the results are returned.  For example, the base
- * case of UID sort and all messages is NOT mutable */
-static int is_mutable_ordering(struct sortcrit *sortcrit,
-                               struct searchargs *searchargs)
-{
-    if (is_mutable_sort(sortcrit))
-        return 1;
-    if (search_expr_is_mutable(searchargs->root))
-        return 1;
-    return 0;
-}
-
 #define UNPREDICTABLE       (-1)
 static int search_predict_total(struct index_state *state,
                                 struct conversations_state *cstate,
@@ -2020,8 +2017,8 @@ static int search_predict_total(struct i
         conversation_getstatus(cstate, index_mboxname(state), &convstatus);
         /* always grab xconvmodseq, so we report a growing
          * highestmodseq to all callers */
-        if (xconvmodseqp) *xconvmodseqp = convstatus.modseq;
-        exists = convstatus.exists;
+        if (xconvmodseqp) *xconvmodseqp = convstatus.threadmodseq;
+        exists = convstatus.threadexists;
     }
     else {
         if (xconvmodseqp) *xconvmodseqp = state->highestmodseq;
@@ -2046,12 +2043,12 @@ static int search_predict_total(struct i
 
     case SEC_CONVSEEN:
         assert(conversations);
-        assert(convstatus.exists >= convstatus.unseen);
-        return convstatus.exists - convstatus.unseen;
+        assert(convstatus.threadexists >= convstatus.threadunseen);
+        return convstatus.threadexists - convstatus.threadunseen;
 
     case SEC_CONVSEEN|SEC_NOT:
         assert(conversations);
-        return convstatus.unseen;
+        return convstatus.threadunseen;
 
     default:
         return UNPREDICTABLE;
@@ -2132,7 +2129,7 @@ EXPORTED int index_convsort(struct index
         struct index_map *im = &state->map[msg->msgno-1];
 
         /* can happen if we didn't "tellchanges" yet */
-        if (im->system_flags & FLAG_EXPUNGED)
+        if (im->internal_flags & FLAG_INTERNAL_EXPUNGED)
             continue;
 
         /* run the search program against all messages */
@@ -2379,7 +2376,7 @@ EXPORTED int index_convmultisort(struct
 
     xstats_add(SEARCH_RESULT, results.count);
     if (results.count) {
-        /* The untagged reponse would be XCONVMULTISORT but
+        /* The untagged response would be XCONVMULTISORT but
          * Mail::IMAPTalk has an undocumented hack whereby any untagged
          * response matching /sort/i is assumed to be a sequence of
          * numeric uids.  Meh. */
@@ -2510,8 +2507,9 @@ EXPORTED int index_snippets(struct index
             mailbox = state->mailbox;
         }
         else {
-            r = mailbox_open_iwl(snippetargs->mboxname, &mailbox);
+            r = mailbox_open_irl(snippetargs->mboxname, &mailbox);
             if (r) goto out;
+            mailbox_unlock_index(mailbox, NULL);
         }
 
         if (snippetargs->uidvalidity &&
@@ -2525,15 +2523,17 @@ EXPORTED int index_snippets(struct index
         for (i = 0 ; i < snippetargs->uids.count ; i++) {
             uint32_t uid = snippetargs->uids.data[i];
             struct index_record record;
-            message_t *msg;
 
-            /* This UID didn't appear in the old index file */
+            /* It's OK to do a dirty read, because we only care about
+             * the UID of the message */
             r = mailbox_find_index_record(mailbox, uid, &record);
+            if (r == IMAP_MAILBOX_CHECKSUM) r = 0;
             if (r) continue;
 
-            msg = message_new_from_record(mailbox, &record);
-            index_getsearchtext(msg, rx, /*snippet*/1);
-            message_unref(&msg);
+            if (state->m) message_set_from_record(mailbox, &record, state->m);
+            else state->m = message_new_from_record(mailbox, &record);
+
+            index_getsearchtext(state->m, NULL, rx, /*snippet*/1);
         }
 
         r = rx->end_mailbox(rx, mailbox);
@@ -2585,7 +2585,7 @@ EXPORTED int index_convupdates(struct in
     ptrarray_t changed = PTRARRAY_INITIALIZER;
     int total = 0;
     struct conversations_state *cstate = NULL;
-    int search_is_mutable = is_mutable_ordering(sortcrit, searchargs);
+    int is_mutable = search_is_mutable(sortcrit, searchargs->root);
     int r = 0;
 
     assert(windowargs);
@@ -2638,7 +2638,7 @@ EXPORTED int index_convupdates(struct in
         int in_search = 0;
 
         in_search = index_search_evaluate(state, searchargs->root, msg->msgno);
-        is_deleted = !!(im->system_flags & FLAG_EXPUNGED);
+        is_deleted = !!(im->internal_flags & FLAG_INTERNAL_EXPUNGED);
         is_new = (im->uid >= windowargs->uidnext);
         was_deleted = is_deleted && (im->modseq <= windowargs->modseq);
 
@@ -2664,7 +2664,7 @@ EXPORTED int index_convupdates(struct in
          * searches, possible an old exemplar? */
         if (!is_new &&
             !was_deleted &&
-            (in_search || (search_is_mutable && is_changed)) &&
+            (in_search || (is_mutable && is_changed)) &&
             (!windowargs->conversations || !hashu64_lookup(msg->cid, &old_seen_cids))) {
             was_old_exemplar = 1;
             if (windowargs->conversations)
@@ -2679,7 +2679,7 @@ EXPORTED int index_convupdates(struct in
         } else if (was_old_exemplar && is_new_exemplar) {
             if (is_changed) {
                 ptrarray_push(&changed, msg);
-                if (search_is_mutable) {
+                if (is_mutable) {
                     /* is the search is mutable, we're in a whole world of
                      * uncertainty about the client's state, so we just
                      * report the exemplar in all three lists and let the
@@ -2694,7 +2694,7 @@ EXPORTED int index_convupdates(struct in
         /* if this is the last message the client cares about ('upto')
          * then we can break early...unless its a mutable search or
          * we need to keep going to calculate an accurate total */
-        if (!search_is_mutable &&
+        if (!is_mutable &&
             !upto_pos &&
             msg->uid == windowargs->upto) {
             if (total != UNPREDICTABLE)
@@ -2859,6 +2859,7 @@ index_copy(struct index_state *state,
     struct mailbox *destmailbox = NULL;
     struct index_map *im;
     int is_same_user;
+    ptrarray_t *msgrecs = ptrarray_new();
 
     *copyuidp = NULL;
 
@@ -2897,6 +2898,10 @@ index_copy(struct index_state *state,
     r = mailbox_open_iwl(name, &destmailbox);
     if (r) goto done;
 
+    /* make sure copying into this mailbox is enabled */
+    r = insert_into_mailbox_allowed(destmailbox);
+    if (r) goto done;
+
     /* not moving or different quota root - need to check quota */
     if (!ismove || strcmpsafe(srcmailbox->quotaroot, destmailbox->quotaroot)) {
         for (i = 0; i < copyargs.nummsg; i++)
@@ -2913,8 +2918,11 @@ index_copy(struct index_state *state,
 
     docopyuid = (appendstate.myrights & ACL_READ);
 
-    r = append_copy(srcmailbox, &appendstate, copyargs.nummsg,
-                    copyargs.records, nolink, is_same_user);
+    for (i = 0; i < copyargs.nummsg; i++) {
+        msgrecord_t *mr = msgrecord_from_index_record(srcmailbox, &copyargs.records[i]);
+        ptrarray_append(msgrecs, mr);
+    }
+    r = append_copy(srcmailbox, &appendstate, msgrecs, nolink, is_same_user);
     if (r) {
         append_abort(&appendstate);
         goto done;
@@ -2966,6 +2974,11 @@ index_copy(struct index_state *state,
 done:
     free(copyargs.records);
     mailbox_close(&destmailbox);
+    for (i = 0; i < msgrecs->count; i++) {
+        msgrecord_t *mr = ptrarray_nth(msgrecs, i);
+        msgrecord_unref(&mr);
+    }
+    ptrarray_free(msgrecs);
 
     return r;
 }
@@ -3071,7 +3084,7 @@ EXPORTED int index_copy_remote(struct in
 /*
  * Returns the msgno of the message with UID 'uid'.
  * If no message with UID 'uid', returns the message with
- * the higest UID not greater than 'uid'.
+ * the highest UID not greater than 'uid'.
  */
 EXPORTED uint32_t index_finduid(struct index_state *state, uint32_t uid)
 {
@@ -3656,13 +3669,16 @@ static void index_tellexpunge(struct ind
     struct index_map *im;
     unsigned exists = state->exists;
 
+    // if we want expunged, we can't tell them!
+    if (state->want_expunged) return;
+
     vanishedlist = seqset_init(0, SEQ_SPARSE);
 
     for (oldmsgno = 1; oldmsgno <= exists; oldmsgno++) {
         im = &state->map[oldmsgno-1];
 
         /* inform about expunges */
-        if (im->system_flags & FLAG_EXPUNGED) {
+        if (im->internal_flags & FLAG_INTERNAL_EXPUNGED) {
             state->exists--;
             state->num_expunged--;
             /* they never knew about this one, skip */
@@ -3692,7 +3708,7 @@ static void index_tellexpunge(struct ind
     seqset_free(vanishedlist);
 
     /* highestmodseq can now come forward to real-time */
-    state->highestmodseq = state->mailbox->i.highestmodseq;
+    state->delayed_modseq = 0;
 }
 
 static void index_tellexists(struct index_state *state)
@@ -3793,6 +3809,126 @@ static int index_fetchannotations(struct
     return r;
 }
 
+struct fetch_mailbox_rock {
+    struct index_state *state;
+    int sep;
+    int wantname;
+    const struct fetchargs *fetchargs;
+};
+
+static int fetch_mailbox_cb(const conv_guidrec_t *rec, void *rock)
+{
+    static const int needrights = ACL_READ|ACL_LOOKUP;
+    struct fetch_mailbox_rock *fmb_rock = (struct fetch_mailbox_rock *) rock;
+    mbentry_t *mbentry = NULL;
+    int myrights = 0;
+    struct mailbox *mailbox = NULL;
+    msgrecord_t *msgrecord = NULL;
+    char *extname = NULL;
+    int r = 0;
+
+    assert(fmb_rock->state != NULL);
+    assert(fmb_rock->fetchargs != NULL);
+
+    /* convdb has flags: skip if flag deleted or flag internal expunged */
+    if (rec->version >= 1) {
+        if ((rec->system_flags & FLAG_DELETED)
+            || (rec->internal_flags & FLAG_INTERNAL_EXPUNGED))
+            goto done;
+    }
+
+    /* make sure we have appropriate rights */
+    r = mboxlist_lookup(rec->mboxname, &mbentry, NULL);
+    if (r) goto done;
+    myrights = cyrus_acl_myrights(fmb_rock->state->authstate, mbentry->acl);
+    if ((myrights & needrights) != needrights)
+        goto done;
+
+    /* convdb does not have flags: grab them from message record */
+    if (rec->version == 0) {
+        uint32_t system_flags, internal_flags;
+
+        r = mailbox_open_irl(rec->mboxname, &mailbox);
+        if (r) goto done;
+
+        r = msgrecord_find(mailbox, rec->uid, &msgrecord);
+        if (r) goto done;
+
+        r = msgrecord_get_systemflags(msgrecord, &system_flags);
+        if (!r) r = msgrecord_get_internalflags(msgrecord, &internal_flags);
+        if (r) goto done;
+
+        if ((system_flags & FLAG_DELETED)
+            || (internal_flags & FLAG_INTERNAL_EXPUNGED))
+            goto done;
+    }
+
+    if (fmb_rock->wantname) {
+        extname = mboxname_to_external(rec->mboxname,
+                                       fmb_rock->fetchargs->namespace,
+                                       fmb_rock->fetchargs->userid);
+    }
+
+    if (fmb_rock->sep)
+        prot_putc(fmb_rock->sep, fmb_rock->state->out);
+    prot_printf(fmb_rock->state->out, "%s",
+                fmb_rock->wantname ? extname : mbentry->uniqueid);
+    fmb_rock->sep = ' ';
+
+done:
+    if (extname) free(extname);
+    if (msgrecord) msgrecord_unref(&msgrecord);
+    if (mailbox) mailbox_close(&mailbox);
+    if (mbentry) mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+/*
+ * Helper function to send FETCH data for the MAILBOXES
+ * fetch item.
+ */
+static int index_fetchmailboxes(struct index_state *state,
+                                uint32_t msgno,
+                                const struct fetchargs *fetchargs)
+{
+    struct fetch_mailbox_rock rock = { state, 0, /*wantname*/ 1, fetchargs};
+    struct index_record record;
+    int r;
+
+    if (!fetchargs->convstate) return 0;
+
+    r = index_reload_record(state, msgno, &record);
+    if (r) return r;
+
+    return conversations_guid_foreach(fetchargs->convstate,
+                                      message_guid_encode(&record.guid),
+                                      &fetch_mailbox_cb,
+                                      &rock);
+}
+
+/*
+ * Helper function to send FETCH data for the MAILBOXIDS
+ * fetch item.
+ */
+static int index_fetchmailboxids(struct index_state *state,
+                                 uint32_t msgno,
+                                 const struct fetchargs *fetchargs)
+{
+    struct fetch_mailbox_rock rock = { state, 0, /*wantname*/ 0, fetchargs};
+    struct index_record record;
+    int r;
+
+    if (!fetchargs->convstate) return 0;
+
+    r = index_reload_record(state, msgno, &record);
+    if (r) return r;
+
+    return conversations_guid_foreach(fetchargs->convstate,
+                                      message_guid_encode(&record.guid),
+                                      &fetch_mailbox_cb,
+                                      &rock);
+}
+
 /*
  * Helper function to send * FETCH (FLAGS data.
  * Does not send the terminating close paren or CRLF.
@@ -3828,6 +3964,10 @@ static void index_fetchflags(struct inde
         prot_printf(state->out, "%c\\Deleted", sepchar);
         sepchar = ' ';
     }
+    if (state->want_expunged && (im->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+        prot_printf(state->out, "%c\\Expunged", sepchar);
+        sepchar = ' ';
+    }
     if (im->isseen) {
         prot_printf(state->out, "%c\\Seen", sepchar);
         sepchar = ' ';
@@ -3970,6 +4110,18 @@ static int index_fetchreply(struct index
                     sepchar, datebuf);
         sepchar = ' ';
     }
+
+    if (fetchitems & FETCH_LASTUPDATED) {
+        time_t msgdate = record.last_updated;
+        char datebuf[RFC3501_DATETIME_MAX+1];
+
+        time_to_rfc3501(msgdate, datebuf, sizeof(datebuf));
+
+        prot_printf(state->out, "%cLASTUPDATED \"%s\"",
+                    sepchar, datebuf);
+        sepchar = ' ';
+    }
+
     if (fetchitems & FETCH_MODSEQ || (ischanged && (client_capa & CAPA_CONDSTORE))) {
         prot_printf(state->out, "%cMODSEQ (" MODSEQ_FMT ")",
                     sepchar, record.modseq);
@@ -3987,6 +4139,26 @@ static int index_fetchreply(struct index
         prot_printf(state->out, ")");
         sepchar = ' ';
     }
+    if (fetchitems & FETCH_PREVIEW) {
+        prot_printf(state->out, "%cPREVIEW (FUZZY ", sepchar);
+        const char *annot = config_getstring(IMAPOPT_JMAP_PREVIEW_ANNOT);
+        if (annot && !strncmp(annot, "/shared/", 8)) {
+            struct buf previewbuf = BUF_INITIALIZER;
+            annotatemore_msg_lookup(mailbox->name, record.uid, annot+7,
+                                    /*userid*/"", &previewbuf);
+            if (buf_len(&previewbuf) > 256)
+                buf_truncate(&previewbuf, 256); // XXX - utf8 chars
+            prot_printastring(state->out, buf_cstring(&previewbuf));
+            buf_free(&previewbuf);
+        }
+        else {
+            prot_printf(state->out, "NIL");
+        }
+
+
+        prot_printf(state->out, ")");
+        sepchar = ' ';
+    }
     if (fetchitems & FETCH_FILESIZE) {
         unsigned int msg_size = buf.len;
         if (!buf.s) {
@@ -4008,6 +4180,14 @@ static int index_fetchreply(struct index
         prot_printf(state->out, "%cRFC822.SHA1 %s", sepchar, message_guid_encode(&tmpguid));
         sepchar = ' ';
     }
+    if (fetchitems & FETCH_EMAILID) {
+        char emailid[26];
+        emailid[0] = 'M';
+        memcpy(emailid+1, message_guid_encode(&record.guid), 24);
+        emailid[25] = '\0';
+        prot_printf(state->out, "%cEMAILID (%s)", sepchar, emailid);
+        sepchar = ' ';
+    }
     if ((fetchitems & FETCH_CID) &&
         config_getswitch(IMAPOPT_CONVERSATIONS)) {
         struct buf buf = BUF_INITIALIZER;
@@ -4019,6 +4199,54 @@ static int index_fetchreply(struct index
         buf_free(&buf);
         sepchar = ' ';
     }
+    if ((fetchitems & FETCH_THREADID)) {
+        char threadid[18];
+        if (!record.cid) {
+            threadid[0] = 'N';
+            threadid[1] = 'I';
+            threadid[2] = 'L';
+            threadid[3] = '\0';
+        }
+        else {
+            threadid[0] = 'T';
+            memcpy(threadid+1, conversation_id_encode(record.cid), 16);
+            threadid[17] = '\0';
+        }
+
+        prot_printf(state->out, "%cTHREADID (%s)", sepchar, threadid);
+        sepchar = ' ';
+    }
+    if (fetchitems & FETCH_SAVEDATE) {
+        time_t msgdate = record.savedate;
+        char datebuf[RFC3501_DATETIME_MAX+1];
+
+        // handle internaldate
+        if (!msgdate) msgdate = record.internaldate;
+
+        time_to_rfc3501(msgdate, datebuf, sizeof(datebuf));
+
+        prot_printf(state->out, "%cSAVEDATE \"%s\"",
+                    sepchar, datebuf);
+        sepchar = ' ';
+    }
+    if (fetchitems & FETCH_CREATEDMODSEQ) {
+        prot_printf(state->out, "%cCREATEDMODSEQ (" MODSEQ_FMT ")",
+                    sepchar, record.createdmodseq);
+        sepchar = ' ';
+    }
+
+    if ((fetchitems & FETCH_BASECID) &&
+        config_getswitch(IMAPOPT_CONVERSATIONS)) {
+        mailbox_read_basecid(mailbox, &record);
+        struct buf buf = BUF_INITIALIZER;
+        if (!record.basecid)
+            buf_appendcstr(&buf, "NIL");
+        else
+            buf_printf(&buf, CONV_FMT, record.basecid);
+        prot_printf(state->out, "%cBASECID %s", sepchar, buf_cstring(&buf));
+        buf_free(&buf);
+        sepchar = ' ';
+    }
     if ((fetchitems & FETCH_FOLDER)) {
         char *extname = mboxname_to_external(index_mboxname(state),
                                              fetchargs->namespace, fetchargs->userid);
@@ -4032,6 +4260,22 @@ static int index_fetchreply(struct index
                     state->mailbox->i.uidvalidity);
         sepchar = ' ';
     }
+    if (config_getswitch(IMAPOPT_CONVERSATIONS)) {
+        if (fetchitems & FETCH_MAILBOXES) {
+            prot_printf(state->out, "%cMAILBOXES (", sepchar);
+            r = index_fetchmailboxes(state, msgno, fetchargs);
+            r = 0;
+            prot_printf(state->out, ")");
+            sepchar = ' ';
+        }
+        if (fetchitems & FETCH_MAILBOXIDS) {
+            prot_printf(state->out, "%cMAILBOXIDS (", sepchar);
+            r = index_fetchmailboxids(state, msgno, fetchargs);
+            r = 0;
+            prot_printf(state->out, ")");
+            sepchar = ' ';
+        }
+    }
     if (fetchitems & FETCH_ENVELOPE) {
         if (!mailbox_cacherecord(mailbox, &record)) {
             prot_printf(state->out, "%cENVELOPE ", sepchar);
@@ -4243,7 +4487,7 @@ EXPORTED int index_urlfetch(struct index
     struct body *top = NULL, *body = NULL;
     size_t section_offset, section_size;
 
-    r = index_lock(state);
+    r = index_lock(state, /*readonly*/1); // XXX: do we need to stay locked for this entire function?
     if (r) return r;
 
     struct mailbox *mailbox = state->mailbox;
@@ -4444,7 +4688,7 @@ EXPORTED int index_urlfetch(struct index
  */
 static int index_storeflag(struct index_state *state,
                            struct index_modified_flags *modified_flags,
-                           uint32_t msgno, struct index_record *record,
+                           uint32_t msgno, msgrecord_t *msgrec,
                            struct storeargs *storeargs)
 {
     uint32_t old, new, keep;
@@ -4476,8 +4720,21 @@ static int index_storeflag(struct index_
         }
     }
 
-    keep = record->system_flags & FLAGS_INTERNAL;
-    old = record->system_flags & FLAGS_SYSTEM;
+    uint32_t system_flags;
+    uint32_t internal_flags;
+    uint32_t user_flags[MAX_USER_FLAGS/32];
+
+    r = msgrecord_get_systemflags(msgrec, &system_flags);
+    if (r) return r;
+
+    r = msgrecord_get_internalflags(msgrec, &internal_flags);
+    if (r) return r;
+
+    r = msgrecord_get_userflags(msgrec, user_flags);
+    if (r) return r;
+
+    keep = internal_flags;
+    old = system_flags & FLAGS_SYSTEM;
     new = storeargs->system_flags & FLAGS_SYSTEM;
 
     /* all other updates happen directly to the record */
@@ -4486,39 +4743,39 @@ static int index_storeflag(struct index_
             /* ACL_DELETE handled in index_store() */
             if ((old & FLAG_DELETED) != (new & FLAG_DELETED)) {
                 dirty++;
-                record->system_flags = (old & ~FLAG_DELETED) | (new & FLAG_DELETED);
+                system_flags = (old & ~FLAG_DELETED) | (new & FLAG_DELETED);
             }
         }
         else {
             if (!(state->myrights & ACL_DELETEMSG)) {
                 if ((old & ~FLAG_DELETED) != (new & ~FLAG_DELETED)) {
                     dirty++;
-                    record->system_flags = (old & FLAG_DELETED) | (new & ~FLAG_DELETED);
+                    system_flags = (old & FLAG_DELETED) | (new & ~FLAG_DELETED);
                 }
             }
             else {
                 if (old != new) {
                     dirty++;
-                    record->system_flags = new;
+                    system_flags = new;
                 }
             }
             for (i = 0; i < (MAX_USER_FLAGS/32); i++) {
-                if (record->user_flags[i] != storeargs->user_flags[i]) {
+                if (user_flags[i] != storeargs->user_flags[i]) {
                     uint32_t changed;
                     dirty++;
 
-                    changed = ~record->user_flags[i] & storeargs->user_flags[i];
+                    changed = ~user_flags[i] & storeargs->user_flags[i];
                     if (changed) {
                         modified_flags->added_user_flags[i] = changed;
                         modified_flags->added_flags++;
                     }
 
-                    changed = record->user_flags[i] & ~storeargs->user_flags[i];
+                    changed = user_flags[i] & ~storeargs->user_flags[i];
                     if (changed) {
                         modified_flags->removed_user_flags[i] = changed;
                         modified_flags->removed_flags++;
                     }
-                    record->user_flags[i] = storeargs->user_flags[i];
+                    user_flags[i] = storeargs->user_flags[i];
                 }
             }
         }
@@ -4528,13 +4785,13 @@ static int index_storeflag(struct index_
 
         if (~old & new) {
             dirty++;
-            record->system_flags = old | new;
+            system_flags = old | new;
         }
         for (i = 0; i < (MAX_USER_FLAGS/32); i++) {
-            added = ~record->user_flags[i] & storeargs->user_flags[i];
+            added = ~user_flags[i] & storeargs->user_flags[i];
             if (added) {
                 dirty++;
-                record->user_flags[i] |= storeargs->user_flags[i];
+                user_flags[i] |= storeargs->user_flags[i];
 
                 modified_flags->added_user_flags[i] = added;
                 modified_flags->added_flags++;
@@ -4546,13 +4803,13 @@ static int index_storeflag(struct index_
 
         if (old & new) {
             dirty++;
-            record->system_flags &= ~storeargs->system_flags;
+            system_flags &= ~storeargs->system_flags;
         }
         for (i = 0; i < (MAX_USER_FLAGS/32); i++) {
-            removed = record->user_flags[i] & storeargs->user_flags[i];
+            removed = user_flags[i] & storeargs->user_flags[i];
             if (removed) {
                 dirty++;
-                record->user_flags[i] &= ~storeargs->user_flags[i];
+                user_flags[i] &= ~storeargs->user_flags[i];
 
                 modified_flags->removed_user_flags[i] = removed;
                 modified_flags->removed_flags++;
@@ -4578,21 +4835,25 @@ static int index_storeflag(struct index_
     if (state->internalseen) {
         /* copy the seen flag from the index */
         if (im->isseen)
-            record->system_flags |= FLAG_SEEN;
+            system_flags |= FLAG_SEEN;
         else
-            record->system_flags &= ~FLAG_SEEN;
+            system_flags &= ~FLAG_SEEN;
     }
     /* add back the internal tracking flags */
-    record->system_flags |= keep;
+    system_flags |= keep;
 
-    modified_flags->added_system_flags = ~old & record->system_flags & FLAGS_SYSTEM;
+    modified_flags->added_system_flags = ~old & system_flags & FLAGS_SYSTEM;
     if (modified_flags->added_system_flags)
         modified_flags->added_flags++;
-    modified_flags->removed_system_flags = old & ~record->system_flags & FLAGS_SYSTEM;
+    modified_flags->removed_system_flags = old & ~system_flags & FLAGS_SYSTEM;
     if (modified_flags->removed_system_flags)
         modified_flags->removed_flags++;
 
-    r = index_rewrite_record(state, msgno, record);
+    r = msgrecord_set_systemflags(msgrec, system_flags);
+    if (r) return r;
+    r = msgrecord_set_internalflags(msgrec, internal_flags);
+    if (r) return r;
+    r = msgrecord_set_userflags(msgrec, user_flags);
     if (r) return r;
 
     /* if it's silent and unchanged, update the seen value, but
@@ -4611,31 +4872,36 @@ static int index_storeflag(struct index_
  */
 static int index_store_annotation(struct index_state *state,
                                   uint32_t msgno,
-                                  struct storeargs *storeargs)
+                                  msgrecord_t *msgrec,
+                                  struct storeargs *storeargs,
+                                  int *dirty)
 {
     modseq_t oldmodseq;
-    struct index_record record;
-    annotate_state_t *astate = NULL;
+    struct index_record *record;
     struct index_map *im = &state->map[msgno-1];
     int r;
 
-    r = index_reload_record(state, msgno, &record);
+    r = msgrecord_get_index_record_rw(msgrec, &record);
+    if (r) goto out;
+
+    r = index_reload_record(state, msgno, record);
     if (r) goto out;
 
-    oldmodseq = record.modseq;
+    oldmodseq = record->modseq;
 
-    r = mailbox_get_annotate_state(state->mailbox, record.uid, &astate);
+    r = msgrecord_annot_set_auth(msgrec, storeargs->isadmin, storeargs->userid,
+                                 storeargs->authstate);
     if (r) goto out;
-    annotate_state_set_auth(astate, storeargs->isadmin,
-                            storeargs->userid, storeargs->authstate);
-    r = annotate_state_store(astate, storeargs->entryatts);
+
+    r = msgrecord_annot_writeall(msgrec, storeargs->entryatts);
     if (r) goto out;
 
     /* It would be nice if the annotate layer told us whether it
      * actually made a change to the database, but it doesn't, so
      * we have to assume the message is dirty */
+    *dirty = 1;
 
-    r = index_rewrite_record(state, msgno, &record);
+    r = index_rewrite_record(state, msgno, record, /*silent*/1);
     if (r) goto out;
 
     /* if it's silent and unchanged, update the seen value */
@@ -4655,39 +4921,56 @@ EXPORTED int index_search_evaluate(struc
                                    uint32_t msgno)
 {
     struct index_map *im = &state->map[msgno-1];
-    int r;
-    message_t *m;
     struct index_record record;
 
-    r = index_reload_record(state, msgno, &record);
-    if (r) return r;
+    int always = search_expr_always_same(e);
+    if (always < 0) return 0;
+    if (always > 0) return 1;
+
+    // failure to load is an error!
+    int r = index_reload_record(state, msgno, &record);
+    if (r) return 0;
 
     xstats_inc(SEARCH_EVALUATE);
 
-    m = message_new_from_index(state->mailbox, &record, msgno,
-                               (im->isrecent ? MESSAGE_RECENT : 0) |
-                               (im->isseen ? MESSAGE_SEEN : 0));
-    r = search_expr_evaluate(m, e);
-    message_unref(&m);
-
-    return r;
+    int flags = (im->isrecent ? MESSAGE_RECENT : 0)
+              | (im->isseen ? MESSAGE_SEEN : 0);
+    if (state->m) message_set_from_index(state->mailbox, &record, msgno, flags, state->m);
+    else state->m = message_new_from_index(state->mailbox, &record, msgno, flags);
+    int match = search_expr_evaluate(state->m, e);
+
+    return match;
 }
 
+struct extractor_ctx {
+    struct backend *be;
+    struct protstream *clientin;
+    unsigned failed;
+};
+
 struct getsearchtext_rock
 {
     search_text_receiver_t *receiver;
     int indexed_headers;
     int charset_flags;
+    const strarray_t *partids;
+    int snippet_iteration; /* 0..no snippet, 1..first run, 2..second run */
+    struct extractor_ctx *ext;
 };
 
 static void stuff_part(search_text_receiver_t *receiver,
-                       int part, const struct buf *buf)
+                       int part,
+                       const struct message_guid *content_guid,
+                       const struct buf *buf)
 {
+    // don't try to index a zero length part
+    if (!buf_len(buf)) return;
+
     if (part == SEARCH_PART_HEADERS &&
         !config_getswitch(IMAPOPT_SEARCH_INDEX_HEADERS))
         return;
 
-    receiver->begin_part(receiver, part);
+    receiver->begin_part(receiver, part, content_guid);
     receiver->append_text(receiver, buf);
     receiver->end_part(receiver, part);
 }
@@ -4698,94 +4981,33 @@ static void extract_cb(const struct buf
     str->receiver->append_text(str->receiver, text);
 }
 
-static int getsearchtext_cb(int isbody, charset_t charset, int encoding,
-                            const char *type, const char *subtype,
-                            const struct param *type_params __attribute__((unused)),
-                            const char *disposition,
-                            const struct param *disposition_params,
-                            struct buf *data,
-                            void *rock)
+#ifdef USE_HTTPD
+static int extract_icalbuf(struct buf *raw, charset_t charset, int encoding,
+                           const struct message_guid *content_guid,
+                           struct getsearchtext_rock *str)
 {
-    struct getsearchtext_rock *str = (struct getsearchtext_rock *)rock;
-    char *q;
-    struct buf text = BUF_INITIALIZER;
-
-    if (!isbody) {
-        if (!str->indexed_headers) {
-            /* Only index the headers of the top message */
-            q = charset_decode_mimeheader(buf_cstring(data), str->charset_flags);
-            buf_init_ro_cstr(&text, q);
-            stuff_part(str->receiver, SEARCH_PART_HEADERS, &text);
-            free(q);
-            buf_free(&text);
-            str->indexed_headers = 1;
-        }
+    icalcomponent *comp = NULL, *ical = NULL;
+    const char *s;
+    int r = 0;
+    struct buf buf = BUF_INITIALIZER;
 
-        /* Index attachment file names */
-        const struct param *param;
-        if (disposition && !strcmp(disposition, "ATTACHMENT")) {
-            /* Look for "Content-Disposition: attachment;filename=" header */
-            for (param = disposition_params; param; param = param->next) {
-                if (strcmp(param->attribute, "FILENAME"))
-                    continue;
-                buf_init_ro_cstr(&text, param->value);
-                stuff_part(str->receiver, SEARCH_PART_ATTACHMENTNAME, &text);
-                buf_free(&text);
-            }
-        }
-        for(param = type_params; param; param = param->next) {
-            /* Look for "Content-Type: foo;name=" header */
-            if (strcmp(param->attribute, "NAME"))
-                continue;
-            buf_init_ro_cstr(&text, param->value);
-            stuff_part(str->receiver, SEARCH_PART_ATTACHMENTNAME, &text);
-            buf_free(&text);
-        }
-    }
-    else if (buf_len(data) > 50 && !memcmp(data->s, "-----BEGIN PGP MESSAGE-----", 27)) {
-        /* PGP encrypted body part - we don't want to index this,
-         * it's a ton of random base64 noise */
+    /* Parse the message into an iCalendar object */
+    const struct buf *icalbuf = NULL;
+    if (encoding || strcasecmp(charset_canon_name(charset), "utf-8")) {
+        char *tmp = charset_to_utf8(buf_cstring(raw), buf_len(raw), charset, encoding);
+        if (!tmp) return 0; /* could be a bogus header - ignore */
+        buf_initm(&buf, tmp, strlen(tmp));
+        icalbuf = &buf;
     }
-    else if (!strcmp(type, "TEXT")) {
-        /* body-like */
-        str->receiver->begin_part(str->receiver, SEARCH_PART_BODY);
-        charset_extract(extract_cb, str, data, charset, encoding, subtype,
-                        str->charset_flags);
-        str->receiver->end_part(str->receiver, SEARCH_PART_BODY);
+    else {
+        icalbuf = raw;
     }
-
-    return 0;
-}
-
-static void append_alnum(struct buf *buf, const char *ss)
-{
-    const unsigned char *s = (const unsigned char *)ss;
-
-    for ( ; *s ; ++s) {
-        if (Uisalnum(*s))
-            buf_putc(buf, *s);
-    }
-}
-
-#ifdef USE_HTTPD
-static int index_icalmessage(message_t *msg, struct getsearchtext_rock *str)
-{
-    icalcomponent *comp = NULL, *ical = NULL;
-    struct buf buf = BUF_INITIALIZER;
-    const char *s;
-    int r, enc = 0;
-
-    /* Parse the message into an iCalendar object */
-    r = message_get_encoding(msg, &enc);
-    if (r) return r;
-    r = message_get_field(msg, "rawbody", MESSAGE_RAW, &buf);
-    if (r) return r;
-    ical = icalparser_parse_string(buf_cstring(&buf));
+    ical = icalparser_parse_string(buf_cstring(icalbuf));
+    buf_reset(&buf);
     if (!ical) {
         r = IMAP_INTERNAL;
         goto done;
     }
-    buf_reset(&buf);
 
     for (comp = icalcomponent_get_first_real_component(ical);
          comp;
@@ -4798,8 +5020,8 @@ static int index_icalmessage(message_t *
         if ((s = icalcomponent_get_description(comp))) {
             buf_setcstr(&buf, s);
             charset_t utf8 = charset_lookupname("utf-8");
-            str->receiver->begin_part(str->receiver, SEARCH_PART_BODY);
-            charset_extract(extract_cb, str, &buf, utf8, enc, "calendar",
+            str->receiver->begin_part(str->receiver, SEARCH_PART_BODY, content_guid);
+            charset_extract(extract_cb, str, &buf, utf8, 0, "calendar",
                             str->charset_flags);
             str->receiver->end_part(str->receiver, SEARCH_PART_BODY);
             charset_free(&utf8);
@@ -4810,7 +5032,7 @@ static int index_icalmessage(message_t *
         if ((prop = icalcomponent_get_first_property(comp, ICAL_SUMMARY_PROPERTY))) {
             if ((s = icalproperty_get_summary(prop))) {
                 buf_setcstr(&buf, s);
-                stuff_part(str->receiver, SEARCH_PART_SUBJECT, &buf);
+                stuff_part(str->receiver, SEARCH_PART_SUBJECT, NULL, &buf);
                 buf_reset(&buf);
             }
         }
@@ -4827,7 +5049,7 @@ static int index_icalmessage(message_t *
                 } else {
                     buf_setcstr(&buf, s);
                 }
-                stuff_part(str->receiver, SEARCH_PART_FROM, &buf);
+                stuff_part(str->receiver, SEARCH_PART_FROM, NULL, &buf);
                 buf_reset(&buf);
             }
         }
@@ -4852,7 +5074,7 @@ static int index_icalmessage(message_t *
             }
         }
         if (buf.len) {
-            stuff_part(str->receiver, SEARCH_PART_TO, &buf);
+            stuff_part(str->receiver, SEARCH_PART_TO, NULL, &buf);
             buf_reset(&buf);
         }
 
@@ -4860,23 +5082,627 @@ static int index_icalmessage(message_t *
         if ((prop = icalcomponent_get_first_property(comp, ICAL_LOCATION_PROPERTY))) {
             if ((s = icalproperty_get_location(prop))) {
                 buf_setcstr(&buf, s);
-                stuff_part(str->receiver, SEARCH_PART_LOCATION, &buf);
+                stuff_part(str->receiver, SEARCH_PART_LOCATION, content_guid, &buf);
                 buf_reset(&buf);
             }
         }
     }
 
 done:
-    buf_free(&buf);
     if (ical) icalcomponent_free(ical);
+    buf_free(&buf);
+    return r;
+}
+
+static void _add_vcard_singlval(struct vparse_card *card, const char *key, struct buf *buf)
+{
+    struct vparse_entry *entry;
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (strcasecmp(entry->name, key)) continue;
+        const char *val = entry->v.value;
+        if (val && val[0]) {
+            if (buf_len(buf)) buf_putc(buf, ' ');
+            buf_appendcstr(buf, val);
+        }
+    }
+}
+
+static void _add_vcard_multival(struct vparse_card *card, const char *key, struct buf *buf)
+{
+    struct vparse_entry *entry;
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (strcasecmp(entry->name, key)) continue;
+        const strarray_t *sa = entry->v.values;
+        int i;
+        for (i = 0; i < strarray_size(sa); i++) {
+            const char *val = strarray_nth(sa, i);
+            if (val && val[0]) {
+                if (buf_len(buf)) buf_putc(buf, ' ');
+                buf_appendcstr(buf, val);
+            }
+        }
+    }
+}
+
+static int extract_vcardbuf(struct buf *raw, charset_t charset, int encoding,
+                            const struct message_guid *content_guid,
+                            struct getsearchtext_rock *str)
+{
+    struct vparse_card *vcard = NULL;
+    int r = 0;
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Parse the message into a vcard object */
+    const struct buf *vcardbuf = NULL;
+    if (encoding || strcasecmp(charset_canon_name(charset), "utf-8")) {
+        char *tmp = charset_to_utf8(buf_cstring(raw), buf_len(raw), charset, encoding);
+        if (!tmp) return 0; /* could be a bogus header - ignore */
+        buf_initm(&buf, tmp, strlen(tmp));
+        vcardbuf = &buf;
+    }
+    else {
+        vcardbuf = raw;
+    }
+
+    vcard = vcard_parse_string(buf_cstring(vcardbuf), /*repair*/1);
+    if (!vcard || !vcard->objects) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    buf_reset(&buf);
+
+    // these are all the things that we think might be interesting
+    _add_vcard_singlval(vcard->objects, "fn", &buf);
+    _add_vcard_singlval(vcard->objects, "email", &buf);
+    _add_vcard_singlval(vcard->objects, "tel", &buf);
+    _add_vcard_singlval(vcard->objects, "url", &buf);
+    _add_vcard_singlval(vcard->objects, "impp", &buf);
+    _add_vcard_singlval(vcard->objects, "x-social-profile", &buf);
+    _add_vcard_singlval(vcard->objects, "x-fm-online-other", &buf);
+    _add_vcard_singlval(vcard->objects, "nickname", &buf);
+    _add_vcard_singlval(vcard->objects, "note", &buf);
+
+    _add_vcard_multival(vcard->objects, "n", &buf);
+    _add_vcard_multival(vcard->objects, "org", &buf);
+    _add_vcard_multival(vcard->objects, "adr", &buf);
+
+    if (buf.len) {
+        charset_t utf8 = charset_lookupname("utf-8");
+        str->receiver->begin_part(str->receiver, SEARCH_PART_BODY, content_guid);
+        charset_extract(extract_cb, str, &buf, utf8, 0, "vcard",
+                        str->charset_flags);
+        str->receiver->end_part(str->receiver, SEARCH_PART_BODY);
+        charset_free(&utf8);
+        buf_reset(&buf);
+    }
+
+done:
+    if (vcard) vparse_free_card(vcard);
+    buf_free(&buf);
     return r;
 }
+
 #endif /* USE_HTTPD */
 
-EXPORTED int index_getsearchtext(message_t *msg,
+
+#define IDLE_TIMEOUT (5 * 60)  /* 5 min */
+
+struct backend_ctx {
+    char *path;
+    int timeout;
+};
+
+static int login(struct backend *s __attribute__((unused)),
+                 const char *userid __attribute__((unused)),
+                 sasl_callback_t *cb __attribute__((unused)),
+                 const char **status __attribute__((unused)),
+                 int noauth __attribute__((unused)))
+{
+    return 0;
+}
+
+static int ping(struct backend *s,
+                const char *userid __attribute__((unused)))
+{
+    struct backend_ctx *ctx = (struct backend_ctx *) s->context;
+    size_t hostlen = strcspn(s->hostname, "/");
+    hdrcache_t resp_hdrs = NULL;
+    struct body_t resp_body;
+    unsigned statuscode = 0;
+    const char *errstr;
+    int r = 0;
+
+    prot_printf(s->out,
+                "HEAD %s %s\r\n"
+                "Host: %.*s\r\n"
+                "User-Agent: Cyrus/%s\r\n"
+                "Connection: Keep-Alive\r\n"
+                "Keep-Alive: timeout=%u\r\n"
+                "Accept: text/plain\r\n"
+                "\r\n",
+                ctx->path, HTTP_VERSION,
+                (int) hostlen, s->hostname, CYRUS_VERSION, ctx->timeout);
+    prot_flush(s->out);
+
+    /* Read response(s) from backend until final response or error */
+    do {
+        resp_body.flags = BODY_DISCARD;
+        r = http_read_response(s, METH_HEAD, &statuscode,
+                               &resp_hdrs, &resp_body, &errstr);
+        if (r) {
+            break;
+        }
+    } while (statuscode < 200);
+
+    if (r) {
+        syslog(LOG_DEBUG, "extractor_ping: HEAD %s: failed (%s): %s",
+               ctx->path, error_message(r), errstr);
+    }
+    else {
+        syslog(LOG_DEBUG, "extractor_ping: HEAD %s: got status %u",
+               ctx->path, statuscode);
+    }
+
+    if (resp_hdrs) spool_free_hdrcache(resp_hdrs);
+
+    return r;
+}
+
+static int logout(struct backend *s __attribute__((unused)))
+{
+    return 0;
+}
+
+static void extractor_disconnect(struct backend *be)
+{
+    syslog(LOG_DEBUG, "extractor_disconnect(%p)", be);
+
+    if (!be || (be->sock == -1)) {
+        /* already disconnected */
+        return;
+    }
+
+    /* need to logout of server */
+    backend_disconnect(be);
+
+    /* remove the timeout */
+    if (be->timeout) prot_removewaitevent(be->clientin, be->timeout);
+    be->timeout = NULL;
+    be->clientin = NULL;
+}
+
+static struct prot_waitevent *
+extractor_timeout(struct protstream *s __attribute__((unused)),
+                  struct prot_waitevent *ev __attribute__((unused)),
+                  void *rock)
+{
+    struct backend *be = (struct backend *) rock;
+
+    syslog(LOG_DEBUG, "extractor_timeout(%p)", be);
+
+    /* too long since we last used the extractor - disconnect */
+    extractor_disconnect(be);
+
+    return NULL;
+}
+
+static struct protocol_t http =
+{ "http", "HTTP", TYPE_SPEC, { .spec = { &login, &ping, &logout } } };
+
+static int extractor_connect(const char *exturl, struct extractor_ctx *ext)
+{
+    struct backend *be;
+    struct backend_ctx *ctx = NULL;
+    struct buf buf = BUF_INITIALIZER;
+    const char *hostname;
+    char path[256];
+    time_t now = time(NULL);
+    int r = 0;
+
+    syslog(LOG_DEBUG, "extractor_connect(%s)", exturl);
+
+    if (!ext || ext->failed > 1) return IMAP_INTERNAL;
+
+    be = ext->be;
+    if (be) {
+        ctx = be->context;
+        hostname = be->hostname;
+    }
+    else {
+        char scheme[6], server[100], *p;
+        unsigned https, port;
+
+        /* Parse URL (cheesy parser without having to use libxml2) */
+        int n = sscanf(exturl, "%5[^:]://%99[^/]%255[^\n]",
+                       scheme, server, path);
+        if (n != 3 ||
+            strncmp(lcase(scheme), "http", 4) || (scheme[4] && scheme[4] != 's')) {
+            syslog(LOG_ERR,
+                   "extract_attachment: unexpected non-HTTP URL %s", exturl);
+            return IMAP_INTERNAL;
+        }
+
+        /* Normalize URL parts */
+        https = (scheme[4] == 's');
+        if (*(p = path + strlen(path) - 1) == '/') *p = '\0';
+        if ((p = strrchr(server, ':'))) {
+            *p++ = '\0';
+            port = atoi(p);
+        }
+        else port = https ? 443 : 80;
+
+        /* Build servername, port, and options */
+        buf_printf(&buf, "%s:%u%s/noauth", server, port, https ? "/tls" : "");
+        hostname = buf_cstring(&buf);
+    }
+
+    if (be && (be->sock != -1)) {
+        syslog(LOG_DEBUG, "extractor_connect: ping existing connection");
+
+        /* ping the extractor */
+        if (ping(be, NULL)) extractor_disconnect(be);
+    }
+
+    if (!be || (be->sock == -1)) {
+        /* Connect to extractor service */
+        syslog(LOG_DEBUG, "extractor_connect: %sconnect to %s",
+               be ? "re" : "", hostname);
+
+        be = ext->be = backend_connect(be, hostname,
+                                       &http, NULL, NULL, NULL, -1);
+
+        if (!be) {
+            syslog(LOG_ERR, "extract_connect: failed to connect to %s",
+                   hostname);
+            ext->failed++;
+            r = IMAP_IOERROR;
+        }
+        else if (!ctx) {
+            ctx = be->context = xzmalloc(sizeof(struct backend_ctx));
+            ctx->path = xstrdup(path);
+
+            if (ext->clientin) {
+                /* add a default timeout */
+                be->clientin = ext->clientin;
+                be->timeout = prot_addwaitevent(ext->clientin,
+                                                now + IDLE_TIMEOUT,
+                                                extractor_timeout, be);
+            }
+        }
+    }
+
+    if (be->timeout && ctx->timeout) be->timeout->mark = now + ctx->timeout;
+
+    buf_free(&buf);
+
+    return r;
+}
+
+
+static int extract_attachment(const char *type, const char *subtype,
+                              const struct param *type_params,
+                              const struct buf *data, int encoding,
+                              const struct message_guid *content_guid,
+                              struct getsearchtext_rock *str)
+{
+    struct extractor_ctx *ext = str->ext;
+    struct backend *be;
+    struct backend_ctx *ctx;
+    struct buf buf = BUF_INITIALIZER;
+    hdrcache_t hdrs = NULL;
+    struct body_t body = { 0, 0, 0, 0, 0, BUF_INITIALIZER };
+    const char *guidstr, *errstr = NULL;
+    size_t hostlen;
+    int r = 0;
+
+    if (!ext) return 0;
+
+    be = ext->be;
+    ctx = (struct backend_ctx *) be->context;
+    hostlen = strcspn(be->hostname, "/");
+
+    if (message_guid_isnull(content_guid)) {
+        syslog(LOG_DEBUG, "extract_attachment: ignoring null guid for %s/%s",
+                type ? type : "<null>", subtype ? subtype : "<null>");
+        return 0;
+    }
+
+    /* Fetch previously extracted text */
+    unsigned statuscode = 0;
+    guidstr = message_guid_encode(content_guid);
+    prot_printf(be->out,
+                "GET %s/%s %s\r\n"
+                "Host: %.*s\r\n"
+                "User-Agent: Cyrus/%s\r\n"
+                "Connection: Keep-Alive\r\n"
+                "Keep-Alive: timeout=%u\r\n"
+                "Accept: text/plain\r\n"
+                "\r\n",
+                ctx->path, guidstr, HTTP_VERSION,
+                (int) hostlen, be->hostname, CYRUS_VERSION,
+                ctx->timeout ? ctx->timeout : IDLE_TIMEOUT);
+    prot_flush(be->out);
+
+    /* Read GET response */
+    do {
+        r = http_read_response(be, METH_GET,
+                               &statuscode, &hdrs, &body, &errstr);
+        if (r) {
+            syslog(LOG_ERR,
+                   "extract_attachment: failed to read response for GET %s/%s",
+                   ctx->path, guidstr);
+            r = IMAP_IOERROR;
+            goto done;
+        }
+    } while (statuscode < 200);
+
+    syslog(LOG_DEBUG, "extract_attachment: GET %s/%s: got status %u",
+           ctx->path, guidstr, statuscode);
+
+    /* Abide by server's timeout, if any */
+    if (!ctx->timeout) {
+        const char **hdr, *p;
+
+        if ((hdr = spool_getheader(hdrs, "Keep-Alive")) &&
+            (p = strstr(hdr[0], "timeout="))) {
+            ctx->timeout = atoi(p+8);
+        }
+        else ctx->timeout = IDLE_TIMEOUT;
+
+        if (be->timeout) be->timeout->mark = time(NULL) + ctx->timeout;
+    }
+
+    if (statuscode == 404) {
+        /* Decode data */
+        struct buf decbuf = BUF_INITIALIZER;
+        if (encoding) {
+            if (charset_decode(&decbuf, buf_base(data), buf_len(data), encoding)) {
+                syslog(LOG_ERR, "extract_attachment: failed to decode data");
+                r = IMAP_IOERROR;
+                goto done;
+            }
+            data = &decbuf;
+        }
+
+        /* Build list of Content-Type parameters */
+        const struct param *param = type_params;
+        while (param && param->attribute) {
+            buf_putc(&buf, ';');
+            buf_appendcstr(&buf, param->attribute);
+            if (param->value) {
+                buf_putc(&buf, '=');
+                buf_appendcstr(&buf, param->value);
+            }
+            param = param->next;
+        }
+
+        /* Send attachment to service for text extraction */
+        prot_printf(be->out,
+                    "PUT %s/%s %s\r\n"
+                    "Host: %.*s\r\n"
+                    "User-Agent: Cyrus/%s\r\n"
+                    "Connection: Keep-Alive\r\n"
+                    "Keep-Alive: timeout=%u\r\n"
+                    "Accept: text/plain\r\n"
+                    "Content-Type: %s/%s%s\r\n"
+                    "Content-Length: %ld\r\n"
+                    "\r\n",
+                    ctx->path, guidstr, HTTP_VERSION,
+                    (int) hostlen, be->hostname, CYRUS_VERSION, ctx->timeout,
+                    type, subtype, buf_cstring(&buf), buf_len(data));
+        prot_putbuf(be->out, (struct buf *) data);
+        prot_flush(be->out);
+        buf_free(&decbuf);
+
+        /* Read PUT response */
+        body.flags = 0;
+        do {
+            r = http_read_response(be, METH_PUT,
+                                   &statuscode, &hdrs, &body, &errstr);
+            if (r) {
+                syslog(LOG_ERR,
+                       "extract_attachment: failed to read response for PUT %s/%s",
+                       ctx->path, guidstr);
+                r = IMAP_IOERROR;
+                goto done;
+            }
+        } while (statuscode < 200);
+
+        syslog(LOG_DEBUG, "extract_attachment: PUT %s/%s: got status %u",
+               ctx->path, guidstr, statuscode);
+    }
+
+    if (statuscode >= 400 && statuscode <= 499) {
+        /* indexer can't extract this for some reason, never try again */
+        goto done;
+    }
+    if (statuscode != 200 && statuscode != 201) {
+        /* any other status code is an error */
+        r = IMAP_IOERROR;
+        goto done;
+    }
+
+    /* Append extracted text */
+    if (buf_len(&body.payload)) {
+        str->receiver->begin_part(str->receiver, SEARCH_PART_ATTACHMENTBODY, content_guid);
+        str->receiver->append_text(str->receiver, &body.payload);
+        str->receiver->end_part(str->receiver, SEARCH_PART_ATTACHMENTBODY);
+    }
+
+done:
+    spool_free_hdrcache(hdrs);
+    buf_free(&body.payload);
+    buf_free(&buf);
+    return r;
+}
+
+static struct extractor_ctx *index_text_extractor = NULL;
+
+EXPORTED void index_text_extractor_init(struct protstream *clientin)
+{
+    syslog(LOG_DEBUG, "extractor_init(%p)", clientin);
+
+    index_text_extractor = xzmalloc(sizeof(struct extractor_ctx));
+    index_text_extractor->clientin = clientin;
+}
+
+EXPORTED void index_text_extractor_destroy(void)
+{
+    struct extractor_ctx *ext = index_text_extractor;
+
+    syslog(LOG_DEBUG, "extractor_destroy(%p)", ext);
+
+    if (!ext) return;
+
+    if (ext->be) {
+        struct backend *be = ext->be;
+
+        extractor_disconnect(be);
+        free(((struct backend_ctx *) be->context)->path);
+        free(be->context);
+        free(be);
+    }
+    free(ext);
+
+    index_text_extractor = NULL;
+}
+
+
+static int getsearchtext_cb(int isbody, charset_t charset, int encoding,
+                            const char *type, const char *subtype,
+                            const struct param *type_params __attribute__((unused)),
+                            const char *disposition,
+                            const struct param *disposition_params,
+                            const struct message_guid *content_guid,
+                            const char *part,
+                            struct buf *data,
+                            void *rock)
+{
+    struct getsearchtext_rock *str = (struct getsearchtext_rock *)rock;
+    char *q;
+    struct buf text = BUF_INITIALIZER;
+    int r = 0;
+
+    if (isbody && part && str->partids && strarray_find(str->partids, part, 0) < 0) {
+        /* Skip part */
+        return 0;
+    }
+
+    if (!isbody) {
+
+        if (str->snippet_iteration >= 2) goto done;
+
+        if (!str->indexed_headers) {
+            /* Only index the headers of the top message */
+            q = charset_decode_mimeheader(buf_cstring(data), str->charset_flags);
+            buf_init_ro_cstr(&text, q);
+            stuff_part(str->receiver, SEARCH_PART_HEADERS, NULL, &text);
+            free(q);
+            buf_free(&text);
+            str->indexed_headers = 1;
+        }
+
+        /* Index attachment file names */
+        const struct param *param;
+        if (disposition && !strcmp(disposition, "ATTACHMENT")) {
+            /* Look for "Content-Disposition: attachment;filename=" header */
+            for (param = disposition_params; param; param = param->next) {
+                if (!strcmp(param->attribute, "FILENAME")) {
+                    char *tmp = charset_decode_mimeheader(param->value, charset_flags);
+                    buf_init_ro_cstr(&text, tmp);
+                    stuff_part(str->receiver, SEARCH_PART_ATTACHMENTNAME, NULL, &text);
+                    buf_free(&text);
+                    free(tmp);
+                }
+                else if (!strcmp(param->attribute, "FILENAME*")) {
+                    char *xval = charset_parse_mimexvalue(param->value, NULL);
+                    if (!xval) xval = xstrdup(param->value);
+                    if (xval) {
+                        char *tmp = charset_decode_mimeheader(xval, charset_flags|CHARSET_MIME_UTF8);
+                        buf_init_ro_cstr(&text, tmp);
+                        stuff_part(str->receiver, SEARCH_PART_ATTACHMENTNAME, NULL, &text);
+                        buf_free(&text);
+                        free(tmp);
+                        free(xval);
+                    }
+                }
+            }
+        }
+        for(param = type_params; param; param = param->next) {
+            /* Look for "Content-Type: foo;name=" header */
+            if (strcmp(param->attribute, "NAME"))
+                continue;
+            char *tmp = charset_decode_mimeheader(param->value, charset_flags);
+            buf_init_ro_cstr(&text, tmp);
+            stuff_part(str->receiver, SEARCH_PART_ATTACHMENTNAME, NULL, &text);
+            buf_free(&text);
+            free(tmp);
+        }
+    }
+    else if (buf_len(data) > 50 && !memcmp(data->s, "-----BEGIN PGP MESSAGE-----", 27)) {
+        /* PGP encrypted body part - we don't want to index this,
+         * it's a ton of random base64 noise */
+    }
+    else if (isbody && !strcmp(type, "TEXT")) {
+
+        if (str->snippet_iteration >= 2) goto done;
+
+        if (!strcmp(subtype, "CALENDAR")) {
+#ifdef USE_HTTPD
+            extract_icalbuf(data, charset, encoding, content_guid, str);
+#endif /* USE_HTTPD */
+        }
+        else if (!strcmp(subtype, "VCARD")) {
+#ifdef USE_HTTPD
+            extract_vcardbuf(data, charset, encoding, content_guid, str);
+#endif /* USE_HTTPD */
+        }
+        else {
+            /* body-like */
+            str->receiver->begin_part(str->receiver, SEARCH_PART_BODY, content_guid);
+            charset_extract(extract_cb, str, data, charset, encoding, subtype,
+                            str->charset_flags);
+            str->receiver->end_part(str->receiver, SEARCH_PART_BODY);
+        }
+    }
+    else if (isbody && !strcmp(type, "APPLICATION")) {
+
+        /* Ignore attachments in first snippet generation pass */
+        if (str->snippet_iteration == 1) goto done;
+
+        /* Only generate snippets from named attachmend parts */
+        if (str->snippet_iteration >= 2 && !str->partids) goto done;
+
+        r = extract_attachment(type, subtype, type_params, data, encoding,
+                               content_guid, str);
+        if (r) {
+            syslog(LOG_ERR, "index: can't extract text from attachment: %s",
+                    error_message(r));
+            goto done;
+        }
+    }
+
+done:
+    return r;
+}
+
+static void append_alnum(struct buf *buf, const char *ss)
+{
+    const unsigned char *s = (const unsigned char *)ss;
+
+    for ( ; *s ; ++s) {
+        if (Uisalnum(*s))
+            buf_putc(buf, *s);
+    }
+}
+
+EXPORTED int index_getsearchtext(message_t *msg, const strarray_t *partids,
                                  search_text_receiver_t *receiver,
                                  int snippet)
 {
+    const char *exturl =
+        config_getstring(IMAPOPT_SEARCH_ATTACHMENT_EXTRACTOR_URL);
     struct getsearchtext_rock str;
     struct buf buf = BUF_INITIALIZER;
     int format = MESSAGE_SEARCH;
@@ -4895,45 +5721,70 @@ EXPORTED int index_getsearchtext(message
     r = receiver->begin_message(receiver, msg);
     if (r) return r;
 
+    memset(&str, 0, sizeof(struct getsearchtext_rock));
     str.receiver = receiver;
     str.indexed_headers = 0;
     str.charset_flags = charset_flags;
+    str.partids = partids;
+    str.snippet_iteration = 0;
+    if (exturl) {
+        str.ext = index_text_extractor;
+        r = extractor_connect(exturl, str.ext);
+        if (r) return r;
+    }
+
+    /* Search receiver can override text conversion */
+    if (receiver->index_charset_flags) {
+        str.charset_flags = receiver->index_charset_flags(str.charset_flags);
+    }
 
     if (snippet) {
-        str.charset_flags |= CHARSET_SNIPPET;
+        str.charset_flags |= CHARSET_KEEPCASE;
         format = MESSAGE_SNIPPET;
     }
 
-#ifdef USE_HTTPD
     /* Choose index scheme for Content=Type */
     if (!strcasecmp(type, "TEXT") && !strcasecmp(subtype, "CALENDAR")) {
+#ifdef USE_HTTPD
         /* An iCalendar entry. */
-        index_icalmessage(msg, &str);
+        struct buf buf = BUF_INITIALIZER;
+        int encoding = 0;
+        const char *charset_id = NULL;
+        charset_t charset = CHARSET_UNKNOWN_CHARSET;
+        const struct body *body = NULL;
+
+        r = message_get_field(msg, "rawbody", MESSAGE_RAW, &buf);
+        if (!r) r = message_get_cachebody(msg, &body);
+        if (!r) r = message_get_encoding(msg, &encoding);
+        if (!r) r = message_get_charset_id(msg, &charset_id);
+        if (!r) charset = charset_lookupname(charset_id);
+        if (charset != CHARSET_UNKNOWN_CHARSET)
+            r = extract_icalbuf(&buf, charset, encoding, &body->content_guid, &str);
+        charset_free(&charset);
+        buf_free(&buf);
+#endif
     }
     else {
-#endif
-        /* A regular message */
-        message_foreach_section(msg, getsearchtext_cb, &str);
-
         if (!message_get_field(msg, "From", format, &buf))
-            stuff_part(receiver, SEARCH_PART_FROM, &buf);
+            stuff_part(receiver, SEARCH_PART_FROM, NULL, &buf);
 
         if (!message_get_field(msg, "To", format, &buf))
-            stuff_part(receiver, SEARCH_PART_TO, &buf);
+            stuff_part(receiver, SEARCH_PART_TO, NULL, &buf);
 
         if (!message_get_field(msg, "Cc", format, &buf))
-            stuff_part(receiver, SEARCH_PART_CC, &buf);
+            stuff_part(receiver, SEARCH_PART_CC, NULL, &buf);
 
         if (!message_get_field(msg, "Bcc", format, &buf))
-            stuff_part(receiver, SEARCH_PART_BCC, &buf);
+            stuff_part(receiver, SEARCH_PART_BCC, NULL, &buf);
 
         if (!message_get_field(msg, "Subject", format, &buf))
-            stuff_part(receiver, SEARCH_PART_SUBJECT, &buf);
+            stuff_part(receiver, SEARCH_PART_SUBJECT, NULL, &buf);
 
         if (!message_get_field(msg, "List-Id", format, &buf))
-            stuff_part(receiver, SEARCH_PART_LISTID, &buf);
+            stuff_part(receiver, SEARCH_PART_LISTID, NULL, &buf);
+
         if (!message_get_field(msg, "Mailing-List", format, &buf))
-            stuff_part(receiver, SEARCH_PART_LISTID, &buf);
+            stuff_part(receiver, SEARCH_PART_LISTID, NULL, &buf);
 
         if (!message_get_leaf_types(msg, &types) && types.count) {
             /* We add three search terms: the type, subtype, and a combined
@@ -4942,7 +5793,7 @@ EXPORTED int index_getsearchtext(message
              * example if the original message has "application/x-pdf" then
              * we index "APPLICATION" "XPDF" "APPLICATION_XPDF".  */
 
-            receiver->begin_part(receiver, SEARCH_PART_TYPE);
+            receiver->begin_part(receiver, SEARCH_PART_TYPE, NULL);
             for (i = 0 ; i < types.count ; i+= 2) {
                 buf_reset(&buf);
 
@@ -4963,11 +5814,26 @@ EXPORTED int index_getsearchtext(message
             }
             receiver->end_part(receiver, SEARCH_PART_TYPE);
         }
-#ifdef USE_HTTPD
+
+        /* A regular message. Generate snippets in two passes. */
+        str.snippet_iteration = snippet ? 1 : 0;
+        r = message_foreach_section(msg, getsearchtext_cb, &str);
+        if (snippet) {
+            if (receiver->flush) {
+                r = receiver->flush(receiver);
+            }
+            if (!r) {
+                str.snippet_iteration = 2;
+                r = message_foreach_section(msg, getsearchtext_cb, &str);
+            }
+            if (r == IMAP_OK_COMPLETED) r = 0;
+        }
+        if (r) goto done;
     }
-#endif
 
     r = receiver->end_message(receiver);
+
+done:
     buf_free(&buf);
     strarray_fini(&types);
 
@@ -5000,6 +5866,11 @@ static int index_copysetup(struct index_
     else
         copyargs->records[copyargs->nummsg].system_flags &= ~FLAG_SEEN;
 
+    if (state->want_expunged && (im->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+        copyargs->records[copyargs->nummsg].system_flags &= ~FLAG_DELETED;
+        copyargs->records[copyargs->nummsg].internal_flags &= ~FLAG_INTERNAL_EXPUNGED;
+    }
+
     copyargs->nummsg++;
 
     return 0;
@@ -5025,7 +5896,7 @@ MsgData **index_msgdata_load(struct inde
     struct mailbox *mailbox = state->mailbox;
     struct index_record record;
     struct conversations_state *cstate = NULL;
-    conversation_t *conv = NULL;
+    conversation_t conv = CONVERSATION_INIT;
 
     if (!n) return NULL;
 
@@ -5050,6 +5921,7 @@ MsgData **index_msgdata_load(struct inde
         cur->uid = record.uid;
         cur->cid = record.cid;
         cur->system_flags = record.system_flags;
+        cur->internal_flags = record.internal_flags;
         message_guid_copy(&cur->guid, &record.guid);
         if (found_anchor && record.uid == anchor)
             *found_anchor = 1;
@@ -5059,7 +5931,6 @@ MsgData **index_msgdata_load(struct inde
 
         did_cache = did_env = did_conv = 0;
         tmpenv = NULL;
-        conv = NULL; /* XXX: use a hash to avoid re-reading? */
 
         for (j = 0; sortcrit[j].key; j++) {
             label = sortcrit[j].key;
@@ -5100,9 +5971,8 @@ MsgData **index_msgdata_load(struct inde
                 label == SORT_CONVEXISTS || label == SORT_CONVSIZE) && !did_conv) {
                 if (!cstate) cstate = conversations_get_mbox(index_mboxname(state));
                 assert(cstate);
-                if (conversation_load(cstate, record.cid, &conv))
+                if (conversation_load_advanced(cstate, record.cid, &conv, /*flags*/0))
                     continue;
-                if (!conv) conv = conversation_new(cstate);
                 did_conv++;
             }
 
@@ -5122,6 +5992,9 @@ MsgData **index_msgdata_load(struct inde
             case SORT_MODSEQ:
                 /* already copied above */
                 break;
+            case SORT_CREATEDMODSEQ:
+                cur->createdmodseq = record.createdmodseq;
+                break;
             case SORT_SIZE:
                 cur->size = record.size;
                 break;
@@ -5148,6 +6021,42 @@ MsgData **index_msgdata_load(struct inde
                 strarray_appendm(&cur->annot, buf_release(&value));
                 break;
             }
+            case SORT_SAVEDATE:
+                if (!strcmpnull(mailbox->uniqueid, sortcrit[j].args.mailbox.id)) {
+                    cur->savedate = record.savedate;
+                }
+                else {
+                    /* If not in mailboxId, we use receivedAt */
+                    cur->internaldate = record.internaldate;
+                }
+                break;
+            case SORT_SNOOZEDUNTIL:
+#ifdef WITH_JMAP
+                if ((record.internal_flags & FLAG_INTERNAL_SNOOZED) &&
+                    !strcmpnull(mailbox->uniqueid, sortcrit[j].args.mailbox.id)) {
+                    /* SAVEDATE == snoozed#until */
+                    cur->savedate = record.savedate;
+
+                    if (!cur->savedate) {
+                        /* Try fetching snoozed#until directly */
+                        json_t *snoozed =
+                            jmap_fetch_snoozed(mailbox->name, record.uid);
+
+                        if (snoozed) {
+                            time_from_iso8601(
+                                json_string_value(json_object_get(snoozed,
+                                                                  "until")),
+                                &cur->savedate);
+                            json_decref(snoozed);
+                        }
+                    }
+                }
+#endif
+                if (!cur->savedate) {
+                    /* If not snoozed in mailboxId, we use receivedAt */
+                    cur->internaldate = record.internaldate;
+                }
+                break;
             case LOAD_IDS:
                 index_get_ids(cur, envtokens, cacheitem_base(&record, CACHE_HEADERS),
                                               cacheitem_size(&record, CACHE_HEADERS));
@@ -5174,20 +6083,22 @@ MsgData **index_msgdata_load(struct inde
             }
             case SORT_HASCONVFLAG: {
                 const char *name = sortcrit[j].args.flag.name;
-                int idx = strarray_find_case(cstate->counted_flags, name, 0);
+                int idx = -1;
+                if (cstate->counted_flags)
+                    idx = strarray_find_case(cstate->counted_flags, name, 0);
                 /* flag exists in the conversation at all */
-                if (idx >= 0 && conv->counts[idx] > 0 && j < 31)
-                    cur->hasconvflag |= (1<<j);
+                if (idx >= 0 && conv.counts[idx] > 0 && j < 31)
+                    cur->hasflag |= (1<<j);
                 break;
             }
             case SORT_CONVEXISTS:
-                cur->convexists = conv->exists;
+                cur->convexists = conv.exists;
                 break;
             case SORT_CONVSIZE:
-                cur->convsize = conv->size;
+                cur->convsize = conv.size;
                 break;
             case SORT_CONVMODSEQ:
-                cur->convmodseq = conv->modseq;
+                cur->convmodseq = conv.modseq;
                 break;
             case SORT_RELEVANCY:
                 /* for now all messages have relevancy=100 */
@@ -5196,7 +6107,7 @@ MsgData **index_msgdata_load(struct inde
         }
 
         free(tmpenv);
-        conversation_free(conv);
+        conversation_fini(&conv);
     }
 
     return ptrs;
@@ -5482,8 +6393,15 @@ void index_get_ids(MsgData *msgdata, cha
 /*
  * Function for comparing two integers.
  */
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int numcmp(modseq_t n1, modseq_t n2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
 static int numcmp(modseq_t n1, modseq_t n2)
 {
+    if (n1 < n2) return -1;
+    if (n1 > n2) return 1;
+    return 0;
     return ((n1 < n2) ? -1 : (n1 > n2) ? 1 : 0);
 }
 
@@ -5515,6 +6433,13 @@ static int index_sort_compare(MsgData *m
             ret = numcmp(d1, d2);
             break;
         }
+        case SORT_SNOOZEDUNTIL:
+        case SORT_SAVEDATE: {
+            time_t d1 = md1->savedate ? md1->savedate : md1->internaldate;
+            time_t d2 = md2->savedate ? md2->savedate : md2->internaldate;
+            ret = numcmp(d1, d2);
+            break;
+        }
         case SORT_FROM:
             ret = strcmpsafe(md1->from, md2->from);
             break;
@@ -5534,6 +6459,9 @@ static int index_sort_compare(MsgData *m
         case SORT_MODSEQ:
             ret = numcmp(md1->modseq, md2->modseq);
             break;
+        case SORT_CREATEDMODSEQ:
+            ret = numcmp(md1->createdmodseq, md2->createdmodseq);
+            break;
         case SORT_DISPLAYFROM:
             ret = strcmpsafe(md1->displayfrom, md2->displayfrom);
             break;
@@ -5556,15 +6484,11 @@ static int index_sort_compare(MsgData *m
             ret = numcmp(md1->spamscore, md2->spamscore);
             break;
         case SORT_HASFLAG:
+        case SORT_HASCONVFLAG:
             if (i < 31)
                 ret = numcmp(md1->hasflag & (1<<i),
                              md2->hasflag & (1<<i));
             break;
-        case SORT_HASCONVFLAG:
-            if (i < 31)
-                ret = numcmp(md1->hasconvflag & (1<<i),
-                             md2->hasconvflag & (1<<i));
-            break;
         case SORT_FOLDER:
             if (md1->folder && md2->folder)
                 ret = strcmpsafe(md1->folder->mboxname, md2->folder->mboxname);
@@ -5578,10 +6502,72 @@ static int index_sort_compare(MsgData *m
         }
     } while (!ret && sortcrit[i++].key != SORT_SEQUENCE);
 
+    // must be multi-folder with the same UID!  tiebreaker is GUID
+    if (!ret) return message_guid_cmp(&md1->guid, &md2->guid);
+
     return (reverse ? -ret : ret);
 }
 
-static int index_sort_compare_qsort(const void *v1, const void *v2)
+static int sortcrit_is_uid(const struct sortcrit *sortcrit)
+{
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int sortcrit_is_reverse_uid(const struct sortcrit *sortcrit)
+{
+    if (!(sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int sortcrit_is_modseq(const struct sortcrit *sortcrit)
+{
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_MODSEQ)) return 0;
+    sortcrit++;
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int sortcrit_is_arrival(const struct sortcrit *sortcrit)
+{
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_ARRIVAL)) return 0;
+    sortcrit++;
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int sortcrit_is_reverse_arrival(const struct sortcrit *sortcrit)
+{
+    if (!(sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_ARRIVAL)) return 0;
+    sortcrit++;
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int sortcrit_is_reverse_flagged(const struct sortcrit *sortcrit)
+{
+    if (!(sortcrit->flags & SORT_REVERSE)) return 0;
+    // both HASFLAG and HASCONVFLAG have the same representation internally
+    if (!(sortcrit->key == SORT_HASFLAG ||
+          sortcrit->key == SORT_HASCONVFLAG)) return 0;
+    sortcrit++;
+    if (!(sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_ARRIVAL)) return 0;
+    sortcrit++;
+    if ((sortcrit->flags & SORT_REVERSE)) return 0;
+    if (!(sortcrit->key == SORT_SEQUENCE)) return 0;
+    return 1;
+}
+
+static int index_sort_compare_generic_qsort(const void *v1, const void *v2)
 {
     MsgData *md1 = *(MsgData **)v1;
     MsgData *md2 = *(MsgData **)v2;
@@ -5589,10 +6575,153 @@ static int index_sort_compare_qsort(cons
     return index_sort_compare(md1, md2, the_sortcrit);
 }
 
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_uid(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_uid(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md1->uid - md2->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_reverse_uid(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_reverse_uid(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md2->uid - md1->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_modseq(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_modseq(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md1->modseq - md2->modseq;
+    if (ret) return ret;
+
+    ret = md1->uid - md2->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_arrival(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_arrival(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md1->internaldate - md2->internaldate;
+    if (ret) return ret;
+
+    ret = md1->createdmodseq - md2->createdmodseq;
+    if (ret) return ret;
+
+    ret = md1->uid - md2->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_reverse_arrival(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_reverse_arrival(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md2->internaldate - md1->internaldate;
+    if (ret) return ret;
+
+    ret = md2->createdmodseq - md1->createdmodseq;
+    if (ret) return ret;
+
+    ret = md1->uid - md2->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+static inline int index_sort_compare_reverse_flagged(const void *v1, const void *v2)
+    __attribute__((pure, always_inline, optimize("-O3")));
+#endif
+static int index_sort_compare_reverse_flagged(const void *v1, const void *v2)
+{
+    MsgData *md1 = *(MsgData **)v1;
+    MsgData *md2 = *(MsgData **)v2;
+    int ret;
+
+    ret = md2->hasflag - md1->hasflag;
+    if (ret) return ret;
+
+    ret = md2->internaldate - md1->internaldate;
+    if (ret) return ret;
+
+    ret = md2->createdmodseq - md1->createdmodseq;
+    if (ret) return ret;
+
+    ret = md1->uid - md2->uid;
+    if (ret) return ret;
+
+    return message_guid_cmp(&md1->guid, &md2->guid);
+}
+
 void index_msgdata_sort(MsgData **msgdata, int n, const struct sortcrit *sortcrit)
 {
-    the_sortcrit = (struct sortcrit *)sortcrit;
-    qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_qsort);
+    if (sortcrit_is_uid(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_uid);
+    }
+    else if (sortcrit_is_reverse_uid(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_reverse_uid);
+    }
+    else if (sortcrit_is_modseq(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_modseq);
+    }
+    else if (sortcrit_is_arrival(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_arrival);
+    }
+    else if (sortcrit_is_reverse_arrival(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_reverse_arrival);
+    }
+    else if (sortcrit_is_reverse_flagged(sortcrit)) {
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_reverse_flagged);
+    }
+    else {
+        char *tmp = sortcrit_as_string(sortcrit);
+        syslog(LOG_DEBUG, "GENERICSORT: %s", tmp);
+        free(tmp);
+        the_sortcrit = (struct sortcrit *)sortcrit;
+        qsort(msgdata, n, sizeof(MsgData *), index_sort_compare_generic_qsort);
+    }
 }
 
 /*
@@ -5609,15 +6738,15 @@ void index_msgdata_free(MsgData **msgdat
 
         if (!md) continue;
 
-        free(md->cc);
-        free(md->from);
-        free(md->to);
-        free(md->displayfrom);
-        free(md->displayto);
-        free(md->xsubj);
-        free(md->msgid);
-        free(md->listid);
-        free(md->contenttype);
+        xfree(md->cc);
+        xfree(md->from);
+        xfree(md->to);
+        xfree(md->displayfrom);
+        xfree(md->displayto);
+        xfree(md->xsubj);
+        xfree(md->msgid);
+        xfree(md->listid);
+        xfree(md->contenttype);
         strarray_fini(&md->ref);
         strarray_fini(&md->annot);
     }
@@ -5870,7 +6999,7 @@ static int thread_is_descendent(Thread *
     if (parent == child)
         return 1;
 
-    /* search each child's decendents */
+    /* search each child's descendents */
     for (kid = parent->child; kid; kid = kid->next) {
         if (thread_is_descendent(kid, child))
             return 1;
@@ -6719,11 +7848,24 @@ EXPORTED extern unsigned long index_getl
                                              uint32_t msgno)
 {
     struct index_record record;
+    struct body *body = NULL;
+    unsigned long lines = 0;
 
     if (index_reload_record(state, msgno, &record))
         return 0;
 
-    return record.content_lines;
+    if (mailbox_cacherecord(state->mailbox, &record))
+        return 0;
+
+    message_read_bodystructure(&record, &body);
+    if (!body) return 0;
+
+    lines = body->content_lines;
+
+    message_free_body(body);
+    free(body);
+
+    return lines;
 }
 
 EXPORTED const char *index_mboxname(const struct index_state *state)
@@ -6798,10 +7940,11 @@ EXPORTED char *sortcrit_as_string(const
         "SIZE", "SUBJECT", "TO", "ANNOTATION",
         "MODSEQ", "UID", "HASFLAG", "CONVMODSEQ",
         "CONVEXISTS", "CONVSIZE", "HASCONVFLAG",
-        "FOLDER", "RELEVANCY"
+        "FOLDER", "RELEVANCY", "SPAMSCORE", "GUID",
+        "EMAILID", "THREADID", "SAVEDATE", "SNOOZEDUNTIL"
     };
 
-    for ( ; sortcrit->key ; sortcrit++) {
+    do {
         if (b.len)
             buf_putc(&b, ' ');
         if (sortcrit->flags & SORT_REVERSE)
@@ -6820,7 +7963,9 @@ EXPORTED char *sortcrit_as_string(const
                             "value.priv" : "value.shared");
             break;
         }
-    }
+        sortcrit++;
+    } while (sortcrit->key);
+
     return buf_release(&b);
 }
 
@@ -6838,8 +7983,43 @@ EXPORTED void freesortcrit(struct sortcr
             free(s[i].args.annot.entry);
             free(s[i].args.annot.userid);
             break;
+        case SORT_HASFLAG:
+        case SORT_HASCONVFLAG:
+            free(s[i].args.flag.name);
+            break;
+        case SORT_SAVEDATE:
+        case SORT_SNOOZEDUNTIL:
+            free(s[i].args.mailbox.id);
+            break;
         }
         i++;
     } while (s[i].key != SORT_SEQUENCE);
     free(s);
 }
+
+EXPORTED int insert_into_mailbox_allowed(struct mailbox *mailbox)
+{
+    int r = 0;
+
+    /* prohibit inserting into \Snoozed mailbox */
+    if (mailbox->i.options & OPT_IMAP_HAS_ALARMS) {
+        struct buf attrib = BUF_INITIALIZER;
+        char *userid = mboxname_to_userid(mailbox->name);
+
+        r = annotatemore_lookup(mailbox->name, "/specialuse", userid, &attrib);
+        free(userid);
+
+        if (!r && buf_len(&attrib)) {
+            strarray_t *specialuse =
+                strarray_split(buf_cstring(&attrib), NULL, 0);
+
+            if (strarray_find(specialuse, "\\Snoozed", 0) >= 0) {
+                r = IMAP_MAILBOX_NOTSUPPORTED;
+            }
+            strarray_free(specialuse);
+        }
+        buf_free(&attrib);
+    }
+
+    return r;
+}
diff -pruN 3.0.13-5/imap/index.h 3.2.0-3/imap/index.h
--- 3.0.13-5/imap/index.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/index.h	2020-04-24 02:03:00.000000000 +0000
@@ -96,11 +96,12 @@ struct index_init {
 struct index_map {
     modseq_t modseq;
     modseq_t told_modseq;
+    uint64_t cache_offset;
+    uint32_t user_flags[MAX_USER_FLAGS/32];
     uint32_t uid;
     uint32_t recno;
     uint32_t system_flags;
-    uint32_t cache_offset;
-    uint32_t user_flags[MAX_USER_FLAGS/32];
+    uint32_t internal_flags;
     unsigned int isseen:1;
     unsigned int isrecent:1;
 };
@@ -135,6 +136,7 @@ struct index_state {
     uint32_t want_mbtype;
     int want_expunged;
     unsigned num_expunged;
+    message_t *m;
 };
 
 struct copyargs {
@@ -154,17 +156,19 @@ typedef struct msgdata {
     time_t sentdate;            /* sent date & time of message
                                    from Date: header (adjusted by time zone) */
     time_t internaldate;        /* internaldate */
+    time_t savedate;            /* savedate */
     size_t size;                /* message size */
     modseq_t modseq;            /* modseq of record*/
+    modseq_t createdmodseq;     /* createdmodseq of record*/
     bit32 hasflag;              /* hasflag values (up to 32 of them) */
     struct message_guid guid;   /* message guid */
     uint32_t system_flags;      /* system flags */
+    uint32_t internal_flags;    /* internal flags */
 
     /* items from the conversations database */
     modseq_t convmodseq;        /* modseq of conversation */
     uint32_t convexists;        /* exists count of conversation */
     uint32_t convsize;          /* total size of messages in conversation */
-    bit32 hasconvflag;          /* hasconvflag values (up to 32 of them) */
 
     uint32_t spamscore;         /* x-spam-score header */
 
@@ -180,6 +184,8 @@ typedef struct msgdata {
     char *xsubj;                /* extracted subject text */
     unsigned xsubj_hash;        /* hash of extracted subject text */
     int is_refwd;               /* is message a reply or forward? */
+
+    /* items from the annotations database */
     strarray_t annot;           /* array of annotation attribute values
                                    (stored in order of sortcrit) */
 } MsgData;
@@ -218,8 +224,7 @@ enum index_warmup_flags
     WARMUP_INDEX            = (1<<0),
     WARMUP_CONVERSATIONS    = (1<<1),
     WARMUP_ANNOTATIONS      = (1<<2),
-    WARMUP_FOLDERSTATUS     = (1<<3),
-    WARMUP_SEARCH           = (1<<4),
+    WARMUP_SEARCH           = (1<<3),
     WARMUP_ALL              = (~WARMUP_SEARCH)
 };
 
@@ -300,7 +305,6 @@ extern int index_urlfetch(struct index_s
                           unsigned long start_octet, unsigned long octet_count,
                           struct protstream *pout, unsigned long *size);
 extern char *index_get_msgid(struct index_state *state, uint32_t msgno);
-extern struct message *index_get_message(struct index_state *state, uint32_t msgno);
 extern struct nntp_overview *index_overview(struct index_state *state,
                                             uint32_t msgno);
 extern char *index_getheader(struct index_state *state, uint32_t msgno,
@@ -330,7 +334,7 @@ extern int index_search_evaluate(struct
 extern int index_expunge(struct index_state *state, char *uidsequence,
                          int need_deleted);
 
-extern int index_getsearchtext(struct message *msg,
+extern int index_getsearchtext(struct message *msg, const strarray_t *partids,
                                struct search_text_receiver *receiver,
                                int snippet);
 
@@ -345,5 +349,9 @@ extern int index_reload_record(struct in
                                uint32_t msgno,
                                struct index_record *record);
 
+extern void index_text_extractor_init(struct protstream *clientin);
+extern void index_text_extractor_destroy(void);
+
+extern int insert_into_mailbox_allowed(struct mailbox *mailbox);
 
 #endif /* INDEX_H */
diff -pruN 3.0.13-5/imap/ipurge.c 3.2.0-3/imap/ipurge.c
--- 3.0.13-5/imap/ipurge.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/ipurge.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,18 +50,17 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <netinet/in.h>
 
 /* cyrus includes */
 #include "global.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "xmalloc.h"
 #include "mboxlist.h"
 #include "util.h"
-#include "sync_log.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -83,186 +82,209 @@ static int invertmatch = 0;
 
 /* for statistical purposes */
 typedef struct mbox_stats_s {
-
     uint64_t total;         /* total including those deleted */
     uint64_t total_bytes;
     uint64_t deleted;
     uint64_t deleted_bytes;
-
 } mbox_stats_t;
 
 static int dryrun = 0;
 static int verbose = 0;
 static int forceall = 0;
 
-static int purge_me(struct findall_data *, void *);
+/* current namespace */
+static struct namespace purge_namespace;
+
+static int purge_findall(struct findall_data *, void *);
 static unsigned purge_check(struct mailbox *mailbox,
                             const struct index_record *record,
                             void *rock);
+static void expand_mboxnames(int nmboxnames, const char **mboxnames);
 static int usage(const char *name);
 static void print_record(struct mailbox *mailbox,
                          const struct index_record *record);
 static void print_stats(mbox_stats_t *stats);
 
 int main (int argc, char *argv[]) {
-  int option;           /* getopt() returns an int */
-  char *alt_config = NULL;
+    int option;           /* getopt() returns an int */
+    char *alt_config = NULL;
+    int matchmailbox = 0;
+    int r;
 
-  while ((option = getopt(argc, argv, "C:hxd:b:k:m:fsXionv")) != EOF) {
-    switch (option) {
-    case 'C': /* alt config file */
-      alt_config = optarg;
-      break;
-    case 'd': {
-      if (optarg == 0) {
-        usage(argv[0]);
-      }
-      days = atoi(optarg) * 86400 /* nominal # of seconds in a 'day' */;
-    } break;
-    case 'b': {
-      if (optarg == 0) {
-        usage(argv[0]);
-      }
-      size = atoi(optarg);
-    } break;
-    case 'k': {
-      if (optarg == 0) {
-        usage(argv[0]);
-      }
-      size = atoi(optarg) * 1024; /* make it bytes */
-    } break;
-    case 'm': {
-      if (optarg == 0) {
-        usage(argv[0]);
-      }
-      size = atoi(optarg) * 1048576; /* 1024 * 1024 */
-    } break;
-    case 'n' : {
-      dryrun = 1;
-    } break;
-    case 'v' : {
-      verbose++;
-    } break;
-    case 'x' : {
-      exact = 1;
-    } break;
-    case 'f' : {
-      forceall = 1;
-    } break;
-    case 's' : {
-      skipflagged = 1;
-    } break;
-    case 'X' : {
-      use_sentdate = 0;
-    } break;
-    case 'i' : {
-      invertmatch = 1;
-    } break;
-    case 'o' : {
-      onlydeleted = 1;
-    } break;
-    case 'h':
-    default: usage(argv[0]);
+    while ((option = getopt(argc, argv, "C:hxd:b:k:m:fsMXionv")) != EOF) {
+        switch (option) {
+        case 'C': /* alt config file */
+            alt_config = optarg;
+            break;
+        case 'd':
+            if (optarg == 0) {
+                usage(argv[0]);
+            }
+            days = atoi(optarg) * 86400 /* nominal # of seconds in a 'day' */;
+            break;
+        case 'b':
+            if (optarg == 0) {
+                usage(argv[0]);
+            }
+            size = atoi(optarg);
+            break;
+        case 'k':
+            if (optarg == 0) {
+                usage(argv[0]);
+            }
+            size = atoi(optarg) * 1024; /* make it bytes */
+            break;
+        case 'm':
+            if (optarg == 0) {
+                usage(argv[0]);
+            }
+            size = atoi(optarg) * 1048576; /* 1024 * 1024 */
+            break;
+        case 'n':
+            dryrun = 1;
+            break;
+        case 'v':
+            verbose++;
+            break;
+        case 'x':
+            exact = 1;
+            break;
+        case 'f':
+            forceall = 1;
+            break;
+        case 's':
+            skipflagged = 1;
+            break;
+        case 'M':
+            matchmailbox = 1;
+            break;
+        case 'X':
+            use_sentdate = 0;
+            break;
+        case 'i':
+            invertmatch = 1;
+            break;
+        case 'o':
+            onlydeleted = 1;
+            break;
+        case 'h':
+        default:
+            usage(argv[0]);
+        }
     }
-  }
-  if ((days == -1 ) && (size == -1)) {
-    printf("One of these must be specified -d, -b -k, -m\n");
-    usage(argv[0]);
-  }
-
-  cyrus_init(alt_config, "ipurge", 0, CONFIG_NEED_PARTITION_DATA);
-
-  /* setup for mailbox event notifications */
-  mboxevent_init();
-  mboxevent_setnamespace(mboxname_get_adminnamespace());
-
-  mboxlist_init(0);
-  mboxlist_open(NULL);
-
-  /* open the quota db, we'll need it for expunge */
-  quotadb_init(0);
-  quotadb_open(NULL);
-
-  sync_log_init();
-
-  if (optind == argc) { /* do the whole partition */
-    mboxlist_findall(NULL, "*", 1, 0, 0, purge_me, NULL);
-  } else {
-    /* do all matching mailboxes in one pass */
-    strarray_t *array = strarray_new();
-    for (; optind < argc; optind++) {
-      strarray_append(array, argv[optind]);
+    if ((days == -1 ) && (size == -1)) {
+        printf("One of these must be specified -d, -b -k, -m\n");
+        usage(argv[0]);
     }
-    if (array->count)
-      mboxlist_findallmulti(NULL, array, 1, 0, 0, purge_me, NULL);
-    strarray_free(array);
-  }
 
-  sync_log_done();
+    cyrus_init(alt_config, "ipurge", 0, CONFIG_NEED_PARTITION_DATA);
 
-  quotadb_close();
-  quotadb_done();
+    /* Set namespace -- force standard (internal) */
+    if ((r = mboxname_init_namespace(&purge_namespace, 1)) != 0) {
+        fatal(error_message(r), EX_CONFIG);
+    }
+    mboxevent_setnamespace(&purge_namespace);
 
-  mboxlist_close();
-  mboxlist_done();
+    if (optind == argc) { /* do the whole partition */
+        mboxlist_findall(NULL, "*", 1, 0, 0, purge_findall, NULL);
+    } else if (matchmailbox) {
+        expand_mboxnames(argc-optind, (const char **)argv+optind);
+    } else {
+        /* do all matching mailboxes in one pass */
+        strarray_t *array = strarray_new();
+        for (; optind < argc; optind++) {
+            strarray_append(array, argv[optind]);
+        }
+        if (array->count)
+            mboxlist_findallmulti(NULL, array, 1, 0, 0, purge_findall, NULL);
+        strarray_free(array);
+    }
 
-  cyrus_done();
+    cyrus_done();
 
-  return 0;
+    return 0;
 }
 
 static int usage(const char *name)
 {
-  printf("usage: %s [-f] [-s] [-C <alt_config>] [-x] [-X] [-i] [-o] [-n] {-d days | -b bytes|-k Kbytes|-m Mbytes}\n\t[mboxpattern1 ... [mboxpatternN]]\n", name);
-  printf("\tthere are no defaults and at least one of -d, -b, -k, -m\n\tmust be specified\n");
-  printf("\tif no mboxpattern is given %s works on all mailboxes\n", name);
-  printf("\t -x specifies an exact match for days or size\n");
-  printf("\t -f force also to delete mail below user.* and INBOX.*\n");
-  printf("\t -s skip over messages that are flagged.\n");
-  printf("\t -X use delivery time instead of date header for date matches.\n");
-  printf("\t -i invert match logic: -x means not equal, date is for newer, size is for smaller.\n");
-  printf("\t -o only purge messages that are deleted.\n");
-  printf("\t -n only print messages that would be deleted (dry run).\n");
-  printf("\t -v enable verbose output/logging.\n");
-  exit(0);
+    printf("usage: %s [-f] [-s] [-C <alt_config>] [-x] [-X] [-i] [-o] [-n] {-d days | -b bytes|-k Kbytes|-m Mbytes}\n\t[mboxpattern1 ... [mboxpatternN]]\n", name);
+    printf("\tthere are no defaults and at least one of -d, -b, -k, -m\n\tmust be specified\n");
+    printf("\tif no mboxpattern is given %s works on all mailboxes\n", name);
+    printf("\t -x specifies an exact match for days or size\n");
+    printf("\t -f force also to delete mail below user.* and INBOX.*\n");
+    printf("\t -s skip over messages that are flagged.\n");
+    printf("\t -X use delivery time instead of date header for date matches.\n");
+    printf("\t -i invert match logic: -x means not equal, date is for newer, size is for smaller.\n");
+    printf("\t -M don't recurse mailboxes.\n");
+    printf("\t -o only purge messages that are deleted.\n");
+    printf("\t -n only print messages that would be deleted (dry run).\n");
+    printf("\t -v enable verbose output/logging.\n");
+    exit(0);
 }
 
 /* we don't check what comes in on matchlen and category, should we? */
-static int purge_me(struct findall_data *data, void *rock __attribute__((unused)))
+static int purge_one(const mbname_t *mbname)
 {
-    if (!data || !data->mbname) return 0;
     struct mailbox *mailbox = NULL;
     int r;
     mbox_stats_t stats;
-    const char *name = mbname_intname(data->mbname);
+    const char *name = mbname_intname(mbname);
 
     if (!forceall) {
         /* DON'T purge INBOX* and user.* */
-        if (mbname_userid(data->mbname))
+        if (mbname_userid(mbname))
             return 0;
     }
 
-  memset(&stats, '\0', sizeof(mbox_stats_t));
+    memset(&stats, '\0', sizeof(mbox_stats_t));
 
-  if (verbose) {
-      printf("Working on %s...\n", name);
-  }
-
-  r = mailbox_open_iwl(name, &mailbox);
-  if (r) { /* did we find it? */
-    syslog(LOG_ERR, "Couldn't find %s, check spelling", name);
-    return r;
-  }
+    if (verbose) {
+        printf("Working on %s...\n", name);
+    }
 
-  mailbox_expunge(mailbox, purge_check, &stats, NULL, EVENT_MESSAGE_EXPUNGE);
+    r = mailbox_open_iwl(name, &mailbox);
+    if (r) { /* did we find it? */
+        syslog(LOG_ERR, "Couldn't find %s, check spelling", name);
+        return r;
+    }
+
+    mailbox_expunge(mailbox, purge_check, &stats, NULL, EVENT_MESSAGE_EXPUNGE);
 
-  mailbox_close(&mailbox);
+    mailbox_close(&mailbox);
 
-  print_stats(&stats);
+    print_stats(&stats);
 
-  return 0;
+    return 0;
 }
 
+static int purge_findall(struct findall_data *data, void *rock __attribute__((unused)))
+{
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
+    return purge_one(data->mbname);
+}
+
+static int purge_mbentry(const mbentry_t *mbentry, void *rock __attribute__((unused)))
+{
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    int r = purge_one(mbname);
+    mbname_free(&mbname);
+    return r;
+}
+
+static void expand_mboxnames(int nmboxnames, const char **mboxnames)
+{
+    int i;
+
+    for (i = 0; i < nmboxnames; i++) {
+        /* Translate any separators in mailboxname */
+        char *intname = mboxname_from_external(mboxnames[i], &purge_namespace, NULL);
+        mboxlist_mboxtree(intname, purge_mbentry, NULL, MBOXTREE_SKIP_CHILDREN);
+        free(intname);
+    }
+}
+
+
 static void deleteit(bit32 msgsize, mbox_stats_t *stats)
 {
     stats->deleted++;
@@ -272,76 +294,76 @@ static void deleteit(bit32 msgsize, mbox
 /* thumbs up routine, checks date & size and returns yes or no for deletion */
 /* 0 = no, 1 = yes */
 static unsigned purge_check(struct mailbox *mailbox,
-                     const struct index_record *record,
-                     void *deciderock)
+                            const struct index_record *record,
+                            void *deciderock)
 {
-  time_t my_time;
-  time_t senttime;
-  mbox_stats_t *stats = (mbox_stats_t *) deciderock;
-
-  my_time = time(0);
-  senttime = use_sentdate ? record->sentdate : record->internaldate;
-
-  stats->total++;
-  stats->total_bytes += record->size;
-
-  if (skipflagged && record->system_flags & FLAG_FLAGGED)
-    return 0;
-
-  if (onlydeleted && !(record->system_flags & FLAG_DELETED))
-    return 0;
-
-  if (exact == 1) {
-    if (days >= 0) {
-      /*    printf("comparing %ld :: %ld\n", my_time, the_record->sentdate); */
-      if (((my_time - (time_t) senttime)/86400) == (days/86400)) {
-          if (invertmatch) return 0;
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      } else {
-          if (!invertmatch) return 0;
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
+    time_t my_time;
+    time_t senttime;
+    mbox_stats_t *stats = (mbox_stats_t *) deciderock;
+
+    my_time = time(0);
+    senttime = use_sentdate ? record->sentdate : record->internaldate;
+
+    stats->total++;
+    stats->total_bytes += record->size;
+
+    if (skipflagged && record->system_flags & FLAG_FLAGGED)
+        return 0;
+
+    if (onlydeleted && !(record->system_flags & FLAG_DELETED))
+        return 0;
+
+    if (exact == 1) {
+        if (days >= 0) {
+            /* printf("comparing %ld :: %ld\n", my_time, the_record->sentdate); */
+            if (((my_time - (time_t) senttime)/86400) == (days/86400)) {
+                if (invertmatch) return 0;
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            } else {
+                if (!invertmatch) return 0;
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+        }
+        if (size >= 0) {
+            /* check size */
+            if (record->size == (unsigned)size) {
+                if (invertmatch) return 0;
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            } else {
+                if (!invertmatch) return 0;
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+        }
+        return 0;
+    } else {
+        if (days >= 0) {
+            /* printf("comparing %ld :: %ld\n", my_time, the_record->sentdate); */
+            if (!invertmatch && ((my_time - (time_t) senttime) > days)) {
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+            if (invertmatch && ((my_time - (time_t) senttime) < days)) {
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+        }
+        if (size >= 0) {
+            /* check size */
+            if (!invertmatch && ((int) record->size > size)) {
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+                if (invertmatch && ((int) record->size < size)) {
+                deleteit(record->size, stats);
+                return dryrun ? print_record(mailbox, record), 0 : 1;
+            }
+        }
+        return 0;
     }
-    if (size >= 0) {
-      /* check size */
-        if (record->size == (unsigned)size) {
-          if (invertmatch) return 0;
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      } else {
-          if (!invertmatch) return 0;
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
-    }
-    return 0;
-  } else {
-    if (days >= 0) {
-      /*    printf("comparing %ld :: %ld\n", my_time, the_record->sentdate); */
-      if (!invertmatch && ((my_time - (time_t) senttime) > days)) {
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
-      if (invertmatch && ((my_time - (time_t) senttime) < days)) {
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
-    }
-    if (size >= 0) {
-      /* check size */
-        if (!invertmatch && ((int) record->size > size)) {
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
-        if (invertmatch && ((int) record->size < size)) {
-          deleteit(record->size, stats);
-          return dryrun ? print_record(mailbox, record), 0 : 1;
-      }
-    }
-    return 0;
-  }
 }
 
 static void print_record(struct mailbox *mailbox,
@@ -376,7 +398,8 @@ static void print_stats(mbox_stats_t *st
     printf("Total bytes       \t\t %llu\n", (long long unsigned)stats->total_bytes);
     printf("Deleted messages  \t\t %llu\n", (long long unsigned)stats->deleted);
     printf("Deleted bytes     \t\t %llu\n", (long long unsigned)stats->deleted_bytes);
-    printf("Remaining messages\t\t %llu\n", (long long unsigned)stats->total - stats->deleted);
+    printf("Remaining messages\t\t %llu\n",
+           (long long unsigned)stats->total - stats->deleted);
     printf("Remaining bytes   \t\t %llu\n",
-            (long long unsigned)stats->total_bytes - stats->deleted_bytes);
+           (long long unsigned)stats->total_bytes - stats->deleted_bytes);
 }
diff -pruN 3.0.13-5/imap/jcal.c 3.2.0-3/imap/jcal.c
--- 3.0.13-5/imap/jcal.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/jcal.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,6 +48,7 @@
 #include <syslog.h>
 
 #include "httpd.h"
+#include "ical_support.h"
 #include "json_support.h"
 #include "jcal.h"
 #include "xcal.h"
@@ -248,11 +249,9 @@ static void icalparameter_as_json_object
         kind_string = icalparameter_get_xname(param);
         break;
 
-#ifdef HAVE_IANA_PARAMS
     case ICAL_IANA_PARAMETER:
         kind_string = icalparameter_get_iana_name(param);
         break;
-#endif
 
     default:                    /* XXX: Is the default case here deliberate?? */
         kind_string = icalparameter_kind_to_string(kind);
@@ -847,28 +846,37 @@ EXPORTED icalcomponent *jcal_string_as_i
 }
 
 
-EXPORTED const char *begin_jcal(struct buf *buf)
+EXPORTED const char *begin_jcal(struct buf *buf, struct mailbox *mailbox,
+                                const char *prodid, const char *name,
+                                const char *desc, const char *color)
 {
+    icalcomponent *ical;
+    icalproperty *prop;
+    json_t *jprops;
+    char *jbuf;
+    size_t flags = JSON_PRESERVE_ORDER;
+
+    flags |= (config_httpprettytelemetry ? JSON_INDENT(2) : JSON_COMPACT);
+
+    /* Add toplevel properties */
+    ical = icalcomponent_new_stream(mailbox, prodid, name, desc, color);
+    jprops = json_array();
+
+    for (prop = icalcomponent_get_first_property(ical, ICAL_ANY_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(ical, ICAL_ANY_PROPERTY)) {
+
+        json_array_append_new(jprops, icalproperty_as_json_array(prop));
+    }
+    icalcomponent_free(ical);
+
+    jbuf = json_dumps(jprops, flags);
+    json_decref(jprops);
+
     /* Begin jCal stream */
     buf_reset(buf);
-    buf_printf_markup(buf, 0, "[");
-    buf_printf_markup(buf, 1, "\"vcalendar\",");
-    buf_printf_markup(buf, 1, "[");
-    buf_printf_markup(buf, 2, "[");
-    buf_printf_markup(buf, 3, "\"prodid\",");
-    buf_printf_markup(buf, 3, "{},");
-    buf_printf_markup(buf, 3, "\"text\",");
-    buf_printf_markup(buf, 3, "\"-//CyrusIMAP.org/Cyrus %s//EN\"",
-                      cyrus_version());
-    buf_printf_markup(buf, 2, "],");
-    buf_printf_markup(buf, 2, "[");
-    buf_printf_markup(buf, 3, "\"version\",");
-    buf_printf_markup(buf, 3, "{},");
-    buf_printf_markup(buf, 3, "\"text\",");
-    buf_printf_markup(buf, 3, "\"2.0\"");
-    buf_printf_markup(buf, 2, "]");
-    buf_printf_markup(buf, 1, "],");
-    buf_printf_markup(buf, 0, "[");
+    buf_printf(buf, "[ \"vcalendar\",\r\n%s, [\r\n", jbuf);
+    free(jbuf);
 
     return ",";
 }
@@ -877,5 +885,5 @@ EXPORTED const char *begin_jcal(struct b
 EXPORTED void end_jcal(struct buf *buf)
 {
     /* End jCal stream */
-    buf_setcstr(buf, "]]");
+    buf_setcstr(buf, "]]\r\n");
 }
diff -pruN 3.0.13-5/imap/jcal.h 3.2.0-3/imap/jcal.h
--- 3.0.13-5/imap/jcal.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/jcal.h	2020-04-24 02:03:00.000000000 +0000
@@ -50,5 +50,7 @@
 
 extern struct buf *icalcomponent_as_jcal_string(icalcomponent* comp);
 extern icalcomponent *jcal_string_as_icalcomponent(const struct buf *);
-extern const char *begin_jcal(struct buf *buf);
+extern const char *begin_jcal(struct buf *buf, struct mailbox *mailbox,
+                              const char *prodid, const char *name,
+                              const char *desc, const char *color);
 extern void end_jcal(struct buf *buf);
diff -pruN 3.0.13-5/imap/jmap_api.c 3.2.0-3/imap/jmap_api.c
--- 3.0.13-5/imap/jmap_api.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_api.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,3118 @@
+/* jmap_api.c -- Routines for handling JMAP API requests
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <sys/time.h>
+#include <sys/resource.h>
+
+#include <errno.h>
+
+#include "append.h"
+#include "bsearch.h"
+#include "cyrusdb.h"
+#include "hash.h"
+#include "httpd.h"
+#include "http_dav.h"
+#include "http_dav_sharing.h"
+#include "http_jmap.h"
+#include "mboxname.h"
+#include "msgrecord.h"
+#include "proxy.h"
+#include "times.h"
+#include "strhash.h"
+#include "syslog.h"
+#include "xstrlcpy.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+#include "imap/jmap_err.h"
+
+
+static json_t *extract_value(json_t *from, const char *path, ptrarray_t *refs);
+
+static json_t *extract_array_value(json_t *val, const char *idx,
+                                   const char *path, ptrarray_t *pool)
+{
+    if (!strcmp(idx, "*")) {
+        /* Build value from array traversal */
+        json_t *newval = json_pack("[]");
+        size_t i;
+        json_t *v;
+        json_array_foreach(val, i, v) {
+            json_t *x = extract_value(v, path, pool);
+            if (json_is_array(x)) {
+                /* JMAP spec: "If the result of applying the rest
+                 * of the pointer tokens to a value was itself an
+                 * array, its items should be included individually
+                 * in the output rather than including the array
+                 * itself." */
+                json_array_extend(newval, x);
+            } else if (x) {
+                json_array_append(newval, x);
+            } else {
+                json_decref(newval);
+                newval = NULL;
+            }
+        }
+        if (newval) {
+            ptrarray_add(pool, newval);
+        }
+        return newval;
+    }
+
+    /* Lookup array value by index */
+    const char *eot = NULL;
+    bit64 num;
+    if (parsenum(idx, &eot, 0, &num) || *eot) {
+        return NULL;
+    }
+    val = json_array_get(val, num);
+    if (!val) {
+        return NULL;
+    }
+    return extract_value(val, path, pool);
+}
+
+/* Extract the JSON value at position path from val.
+ *
+ * Return NULL, if the the value does not exist or if
+ * path is erroneous.
+ */
+static json_t *extract_value(json_t *val, const char *path, ptrarray_t *pool)
+{
+    /* Return value for empty path */
+    if (*path == '\0') {
+        return val;
+    }
+
+    /* Be lenient: root path '/' is optional */
+    if (*path == '/') {
+        path++;
+    }
+
+    /* Walk over path segments */
+    while (val && *path) {
+        const char *top = NULL;
+        char *p = NULL;
+
+        /* Extract next path segment */
+        if (!(top = strchr(path, '/'))) {
+            top = strchr(path, '\0');
+        }
+        p = jmap_pointer_decode(path, top - path);
+        if (*p == '\0') {
+            return NULL;
+        }
+
+        /* Extract array value */
+        if (json_is_array(val)) {
+            val = extract_array_value(val, p, top, pool);
+            free(p);
+            return val;
+        }
+
+        /* Value MUST be an object now */
+        if (!json_is_object(val)) {
+            free(p);
+            return NULL;
+        }
+        /* Step down into object tree */
+        val = json_object_get(val, p);
+        free(p);
+        path = *top ? top + 1 : top;
+    }
+
+    return val;
+}
+
+static int process_resultrefs(json_t *args, json_t *resp, json_t **err)
+{
+    json_t *ref;
+    const char *arg;
+    int ret = -1;
+
+    void *tmp;
+    json_object_foreach_safe(args, tmp, arg, ref) {
+        if (*arg != '#' || *(arg+1) == '\0') {
+            continue;
+        }
+
+        if (json_object_get(args, arg + 1)) {
+            *err = json_pack("{s:s, s:[s]}",
+                             "type", "invalidArguments", "arguments", arg);
+            goto fail;
+        }
+
+        const char *of, *path, *name;
+        json_t *res = NULL;
+
+        /* Parse result reference object */
+        of = json_string_value(json_object_get(ref, "resultOf"));
+        if (!of || *of == '\0') {
+            goto fail;
+        }
+        path = json_string_value(json_object_get(ref, "path"));
+        if (!path || *path == '\0') {
+            goto fail;
+        }
+        name = json_string_value(json_object_get(ref, "name"));
+        if (!name || *name == '\0') {
+            goto fail;
+        }
+
+        /* Lookup referenced response */
+        json_t *v;
+        size_t i;
+        json_array_foreach(resp, i, v) {
+            const char *tag = json_string_value(json_array_get(v, 2));
+            if (!tag || strcmp(tag, of)) {
+                continue;
+            }
+            const char *mname = json_string_value(json_array_get(v, 0));
+            if (!mname || strcmp(name, mname)) {
+                goto fail;
+            }
+            res = v;
+            break;
+        }
+        if (!res) goto fail;
+
+        /* Extract the reference argument value. */
+        /* We maintain our own pool of newly created JSON objects, since
+         * tracking reference counts across newly created JSON arrays is
+         * a pain. Rule: If you incref an existing JSON value or create
+         * an entirely new one, put it into the pool for cleanup. */
+        ptrarray_t pool = PTRARRAY_INITIALIZER;
+        json_t *val = extract_value(json_array_get(res, 1), path, &pool);
+        if (!val) goto fail;
+
+        /* Replace both key and value of the reference entry */
+        json_object_set(args, arg + 1, val);
+        json_object_del(args, arg);
+
+        /* Clean up reference counts of pooled JSON objects */
+        json_t *ref;
+        while ((ref = ptrarray_pop(&pool))) {
+            json_decref(ref);
+        }
+        ptrarray_fini(&pool);
+    }
+
+    return 0;
+
+  fail:
+    return ret;
+}
+
+static int parse_json_body(struct transaction_t *txn, json_t **req)
+{
+    const char **hdr;
+    json_error_t jerr;
+    int ret;
+
+    /* Check Content-Type */
+    if (!(hdr = spool_getheader(txn->req_hdrs, "Content-Type")) ||
+        !is_mediatype("application/json", hdr[0])) {
+        txn->error.desc = "This method requires a JSON request body";
+        return HTTP_BAD_MEDIATYPE;
+    }
+
+    /* Read body */
+    txn->req_body.flags |= BODY_DECODE;
+    ret = http_read_req_body(txn);
+    if (ret) {
+        txn->flags.conn = CONN_CLOSE;
+        return ret;
+    }
+
+    /* Parse the JSON request */
+    *req = json_loads(buf_cstring(&txn->req_body.payload), 0, &jerr);
+    if (!*req) {
+        buf_reset(&txn->buf);
+        buf_printf(&txn->buf,
+                   "Unable to parse JSON request body: %s", jerr.text);
+        txn->error.desc = buf_cstring(&txn->buf);
+        return JMAP_NOT_JSON;
+    }
+
+    return 0;
+}
+
+static int validate_request(struct transaction_t *txn, json_t *req,
+                            jmap_settings_t *settings)
+{
+    json_t *using = json_object_get(req, "using");
+    json_t *calls = json_object_get(req, "methodCalls");
+
+    if (!json_is_array(using) || !json_is_array(calls)) {
+        return JMAP_NOT_REQUEST;
+    }
+
+    /*
+     * XXX the following maximums are not enforced:
+     * maxConcurrentUpload
+     * maxConcurrentRequests
+     */
+
+    if (buf_len(&txn->req_body.payload) >
+        (size_t) settings->limits[MAX_SIZE_REQUEST]) {
+        return JMAP_LIMIT_SIZE;
+    }
+
+    size_t i;
+    json_t *val;
+    json_array_foreach(calls, i, val) {
+        if (json_array_size(val) != 3 ||
+                !json_is_string(json_array_get(val, 0)) ||
+                !json_is_object(json_array_get(val, 1)) ||
+                !json_is_string(json_array_get(val, 2))) {
+            return JMAP_NOT_REQUEST;
+        }
+        if (i >= (size_t) settings->limits[MAX_CALLS_IN_REQUEST]) {
+            return JMAP_LIMIT_CALLS;
+        }
+        const char *mname = json_string_value(json_array_get(val, 0));
+        mname = strchr(mname, '/');
+        if (!mname) continue;
+
+        if (!strcmp(mname, "get")) {
+            json_t *ids = json_object_get(json_array_get(val, 1), "ids");
+            if (json_array_size(ids) >
+                (size_t) settings->limits[MAX_OBJECTS_IN_GET]) {
+                return JMAP_LIMIT_OBJS_GET;
+            }
+        }
+        else if (!strcmp(mname, "set")) {
+            json_t *args = json_array_get(val, 1);
+            size_t size = json_object_size(json_object_get(args, "create"));
+            size += json_object_size(json_object_get(args, "update"));
+            size += json_array_size(json_object_get(args, "destroy"));
+            if (size > (size_t) settings->limits[MAX_OBJECTS_IN_SET]) {
+                return JMAP_LIMIT_OBJS_SET;
+            }
+        }
+    }
+
+    json_array_foreach(using, i, val) {
+        const char *s = json_string_value(val);
+        if (!s) {
+            return JMAP_NOT_REQUEST;
+        }
+        else if (!strcmp(s, "ietf:jmap")) {
+            syslog(LOG_DEBUG, "old capability %s used", s);
+        }
+        else if (!strcmp(s, "ietf:jmapmail")) {
+            syslog(LOG_DEBUG, "old capability %s used", s);
+        }
+        else if (!json_object_get(settings->server_capabilities, s))  {
+            return JMAP_UNKNOWN_CAPABILITY;
+        }
+    }
+
+    return 0;
+}
+
+HIDDEN int jmap_is_valid_id(const char *id)
+{
+    if (!id || *id == '\0') return 0;
+    const char *p;
+    for (p = id; *p; p++) {
+        if (('0' <= *p && *p <= '9'))
+            continue;
+        if (('a' <= *p && *p <= 'z') || ('A' <= *p && *p <= 'Z'))
+            continue;
+        if ((*p == '-') || (*p == '_'))
+            continue;
+        return 0;
+    }
+    return 1;
+}
+
+static void _make_created_ids(const char *creation_id, void *val, void *rock)
+{
+    json_t *jcreatedIds = rock;
+    const char *id = val;
+    json_object_set_new(jcreatedIds, creation_id, json_string(id));
+}
+
+static int jmap_error_response(struct transaction_t *txn,
+                               long code, json_t **res)
+{
+    long http_code = HTTP_BAD_REQUEST;
+    const char *type, *title, *limit = NULL;
+
+    /* Error string is encoded as type NUL title [ NUL limit ] */
+    type = error_message(code);
+    title = type + strlen(type) + 1;
+
+    switch (code) {
+    case JMAP_NOT_JSON:
+    case JMAP_NOT_REQUEST:
+    case JMAP_UNKNOWN_CAPABILITY:
+        break;
+
+    case JMAP_LIMIT_SIZE:
+        http_code = HTTP_PAYLOAD_TOO_LARGE;
+
+        GCC_FALLTHROUGH
+
+    case JMAP_LIMIT_CALLS:
+    case JMAP_LIMIT_OBJS_GET:
+    case JMAP_LIMIT_OBJS_SET:
+        limit = title + strlen(title) + 1;
+        break;
+
+    default:
+        /* Actually an HTTP code, not a JMAP error code */
+        return code;
+    }
+
+    if (txn->meth == METH_UNKNOWN) {
+        /* API request over WebSocket */
+        *res = json_pack("{s:s s:s s:s s:i}",
+                         "@type", "RequestError", "type", type, "title", title,
+                         "status", atoi(error_message(http_code)));
+    }
+    else {
+        *res = json_pack("{s:s s:s s:i}", "type", type, "title", title,
+                         "status", atoi(error_message(http_code)));
+    }
+    if (!*res) {
+        txn->error.desc = "Unable to create JSON response";
+        return HTTP_SERVER_ERROR;
+    }
+
+    if (limit) {
+        json_object_set_new(*res, "limit", json_string(limit));
+    }
+
+    if (txn->error.desc) {
+        json_object_set_new(*res, "detail", json_string(txn->error.desc));
+    }
+
+    return http_code;
+}
+
+
+HIDDEN int jmap_initreq(jmap_req_t *req)
+{
+    memset(req, 0, sizeof(struct jmap_req));
+    req->mboxes = ptrarray_new();
+    return 0;
+}
+
+struct _mboxcache_rec {
+    struct mailbox *mbox;
+    int refcount;
+    int rw;
+};
+
+HIDDEN void jmap_finireq(jmap_req_t *req)
+{
+    int i;
+
+    for (i = 0; i < req->mboxes->count; i++) {
+        struct _mboxcache_rec *rec = ptrarray_nth(req->mboxes, i);
+        syslog(LOG_ERR, "jmap: force-closing mailbox %s (refcount=%d)",
+                        rec->mbox->name, rec->refcount);
+        mailbox_close(&rec->mbox);
+        free(rec);
+    }
+    /* Fail after cleaning up open mailboxes */
+    assert(!req->mboxes->count);
+
+    ptrarray_free(req->mboxes);
+    req->mboxes = NULL;
+
+    jmap_mbentry_cache_free(req);
+
+    json_decref(req->perf_details);
+    req->perf_details = NULL;
+}
+
+static jmap_method_t *find_methodproc(const char *name, hash_table *jmap_methods)
+{
+    return hash_lookup(name, jmap_methods);
+}
+
+/* Return the ACL for mbentry for the authstate of userid.
+ * Lookup and store ACL rights in the mboxrights cache. */
+static int _rights_for_mbentry(struct auth_state *authstate,
+                               const mbentry_t *mbentry,
+                               hash_table *mboxrights)
+{
+    if (!mbentry) return 0;
+
+    /* Lookup cached rights */
+    int *rightsptr = hash_lookup(mbentry->name, mboxrights);
+    if (rightsptr) return *rightsptr;
+
+    int rights = 0;
+
+    /* Lookup ACL */
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+        // if it's an intermediate mailbox, we get rights from the parent
+        mbentry_t *parententry = NULL;
+        if (mboxlist_findparent(mbentry->name, &parententry))
+            rights = 0;
+        else
+            rights = httpd_myrights(authstate, parententry);
+        mboxlist_entry_free(&parententry);
+    }
+    else rights = httpd_myrights(authstate, mbentry);
+
+    /* Cache rights */
+    rightsptr = xmalloc(sizeof(int));
+    *rightsptr = rights;
+    hash_insert(mbentry->name, rightsptr, mboxrights);
+
+    mbname_free(&mbname);
+    return rights;
+}
+
+struct capabilities_rock {
+    const char *authuserid;
+    hash_table *mboxrights;
+    struct auth_state *authstate;
+
+    int is_visible;
+    int has_mail;
+    int has_contacts;
+    int has_calendars;
+};
+
+static int capabilities_cb(const mbentry_t *mbentry, void *vrock)
+{
+    struct capabilities_rock *rock = vrock;
+
+    if (!mbentry) return 0;
+
+    if ((mbentry->mbtype & MBTYPE_DELETED) ||
+        (mbentry->mbtype & MBTYPE_MOVING) ||
+        (mbentry->mbtype & MBTYPE_REMOTE) ||
+        (mbentry->mbtype & MBTYPE_RESERVE)) {
+        return 0;
+    }
+
+    int rights = _rights_for_mbentry(rock->authstate, mbentry, rock->mboxrights);
+    if (!(rights & ACL_LOOKUP)) return 0;
+    rock->is_visible = 1;
+
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    const strarray_t *boxes = mbname_boxes(mbname);
+    if (!rock->has_mail) {
+        rock->has_mail = mbentry->mbtype == MBTYPE_EMAIL;
+    }
+    if (!rock->has_contacts) {
+        rock->has_contacts = strarray_size(boxes) >= 1 &&
+            !strcmpsafe(config_getstring(IMAPOPT_ADDRESSBOOKPREFIX),
+                    strarray_nth(boxes, 0));
+    }
+    if (!rock->has_calendars) {
+        rock->has_calendars = strarray_size(boxes) >= 1 &&
+            !strcmpsafe(config_getstring(IMAPOPT_CALENDARPREFIX),
+                    strarray_nth(boxes, 0));
+    }
+    mbname_free(&mbname);
+
+    return 0;
+}
+
+static json_t *lookup_capabilities(const char *accountid,
+                                   const char *authuserid,
+                                   struct auth_state *authstate,
+                                   hash_table *mboxrights)
+{
+    // we need to know if we can write children of the inbox
+    mbentry_t *inboxentry = NULL;
+
+    char *inboxname = mboxname_user_mbox(accountid, NULL);
+    if (mboxlist_lookup(inboxname, &inboxentry, NULL)) {
+        free(inboxname);
+        return json_null();
+    }
+    free(inboxname);
+
+    int inboxrights = _rights_for_mbentry(authstate, inboxentry, mboxrights);
+    mboxlist_entry_free(&inboxentry);
+
+    json_t *capas = json_object();
+
+    int mayCreateTopLevel = (inboxrights & ACL_CREATE) ? 1 : 0;
+
+    if (!strcmp(authuserid, accountid)) {
+        /* Primary account has all capabilities */
+        jmap_core_capabilities(capas);
+        jmap_mail_capabilities(capas, mayCreateTopLevel);
+        jmap_emailsubmission_capabilities(capas);
+        jmap_vacation_capabilities(capas);
+        jmap_contact_capabilities(capas);
+        jmap_calendar_capabilities(capas);
+    }
+    else {
+        /* Lookup capabilities for shared account */
+        struct capabilities_rock rock = {
+            authuserid, mboxrights, httpd_authstate, 0, 0, 0, 0
+        };
+        mboxlist_usermboxtree(accountid, authstate, capabilities_cb,
+                              &rock, MBOXTREE_INTERMEDIATES);
+        if (rock.is_visible) {
+            jmap_core_capabilities(capas);
+            if (rock.has_mail) {
+                // we don't offer emailsubmission or vacation
+                // for shared accounts right now
+                jmap_mail_capabilities(capas, mayCreateTopLevel);
+            }
+            if (rock.has_contacts) {
+                jmap_contact_capabilities(capas);
+            }
+            if (rock.has_calendars) {
+                jmap_calendar_capabilities(capas);
+            }
+        }
+    }
+
+    if (!json_object_size(capas)) {
+        json_decref(capas);
+        capas = json_null();
+    }
+    return capas;
+}
+
+static void _free_json(void *val)
+{
+    json_decref((json_t *)val);
+}
+
+/* Perform an API request */
+HIDDEN int jmap_api(struct transaction_t *txn, json_t **res,
+                    jmap_settings_t *settings)
+{
+    json_t *jreq = NULL, *resp = NULL;
+    size_t i;
+    int ret, do_perf = 0;
+    char *account_inboxname = NULL;
+    int return_created_ids = 0;
+    hash_table created_ids = HASH_TABLE_INITIALIZER;
+    hash_table capabilities_by_accountid = HASH_TABLE_INITIALIZER;
+    hash_table mboxrights = HASH_TABLE_INITIALIZER;
+    strarray_t methods = STRARRAY_INITIALIZER;
+    ptrarray_t method_calls = PTRARRAY_INITIALIZER;
+    ptrarray_t processed_methods = PTRARRAY_INITIALIZER;
+    strarray_t using_capabilities = STRARRAY_INITIALIZER;
+
+    ret = parse_json_body(txn, &jreq);
+    if (ret) return jmap_error_response(txn, ret, res);
+
+    /* Validate Request object */
+    if ((ret = validate_request(txn, jreq, settings))) {
+        json_decref(jreq);
+        return jmap_error_response(txn, ret, res);
+    }
+
+    /* Start JSON response */
+    resp = json_array();
+    if (!resp) {
+        txn->error.desc = "Unable to create JSON response body";
+        ret = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Set up request-internal state */
+    construct_hash_table(&capabilities_by_accountid, 8, 0);
+    construct_hash_table(&mboxrights, 64, 0);
+    construct_hash_table(&created_ids, 1024, 0);
+
+    /* Parse client-supplied creation ids */
+    json_t *jcreatedIds = json_object_get(jreq, "createdIds");
+    if (json_is_object(jcreatedIds)) {
+        return_created_ids = 1;
+        const char *creation_id;
+        json_t *jval;
+        json_object_foreach(jcreatedIds, creation_id, jval) {
+            if (!json_is_string(jval)) {
+                txn->error.desc = "Invalid createdIds argument";
+                ret = HTTP_BAD_REQUEST;
+                goto done;
+            }
+            const char *id = json_string_value(jval);
+            if (!jmap_is_valid_id(creation_id) || !jmap_is_valid_id(id)) {
+                txn->error.desc = "Invalid createdIds argument";
+                ret = HTTP_BAD_REQUEST;
+                goto done;
+            }
+            hash_insert(creation_id, xstrdup(id), &created_ids);
+        }
+    }
+    else if (jcreatedIds && jcreatedIds != json_null()) {
+        txn->error.desc = "Invalid createdIds argument";
+        ret = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    json_t *jusing = json_object_get(jreq, "using");
+    for (i = 0; i < json_array_size(jusing); i++) {
+        strarray_add(&using_capabilities, json_string_value(json_array_get(jusing, i)));
+    }
+    /* Push client method calls on call stack */
+    json_t *jmethod_calls = json_object_get(jreq, "methodCalls");
+    for (i = json_array_size(jmethod_calls); i > 0; i--) {
+        json_t *mc = json_array_get(jmethod_calls, i-1);
+        ptrarray_push(&method_calls, json_incref(mc));
+    }
+
+    /* Process call stack */
+    do_perf = strarray_find(&using_capabilities, JMAP_PERFORMANCE_EXTENSION, 0) >= 0;
+    json_t *mc;
+    while ((mc = ptrarray_pop(&method_calls))) {
+        /* Send provisional response, if necessary */
+        keepalive_response(txn);
+
+        /* Mark method as processed */
+        ptrarray_push(&processed_methods, mc);
+
+        /* Process method */
+        const jmap_method_t *mp;
+        const char *mname = json_string_value(json_array_get(mc, 0));
+        json_t *args = json_array_get(mc, 1);
+        const char *tag = json_string_value(json_array_get(mc, 2));
+        int r = 0;
+
+        strarray_append(&methods, mname);
+        json_incref(args);
+
+        /* Find the message processor */
+        mp = find_methodproc(mname, &settings->methods);
+        if (!mp || strarray_find(&using_capabilities, mp->capability, 0) < 0) {
+            json_array_append_new(resp, json_pack("[s {s:s} s]",
+                        "error", "type", "unknownMethod", tag));
+            json_decref(args);
+            continue;
+        }
+
+        /* Validate accountId argument */
+        const char *accountid = httpd_userid;
+        json_t *err = NULL;
+        json_t *arg = json_object_get(args, "accountId");
+        if (arg && arg != json_null()) {
+            accountid = json_string_value(arg);
+        }
+        if (!accountid) {
+            err = json_pack("{s:s, s:[s]}",
+                    "type", "invalidArguments", "arguments", "accountId");
+            json_array_append_new(resp, json_pack("[s,o,s]", "error", err, tag));
+            json_decref(args);
+            continue;
+        }
+
+        /* Validate supported capabilities for this account */
+        json_t *account_capas = hash_lookup(accountid, &capabilities_by_accountid);
+        if (!account_capas) {
+            account_capas = lookup_capabilities(accountid, httpd_userid,
+                                                httpd_authstate, &mboxrights);
+            hash_insert(accountid, account_capas, &capabilities_by_accountid);
+        }
+        if (json_is_null(account_capas)) {
+            err = json_pack("{s:s}", "type", "accountNotFound");
+        }
+        else if (!json_object_get(account_capas, mp->capability)) {
+            err = json_pack("{s:s}", "type", "accountNotSupportedByMethod");
+        }
+        if (err) {
+            json_array_append_new(resp, json_pack("[s,o,s]", "error", err, tag));
+            json_decref(args);
+            continue;
+        }
+
+        /* Pre-process result references */
+        if (process_resultrefs(args, resp, &err)) {
+            if (!err) err = json_pack("{s:s}", "type", "resultReference");
+
+            json_array_append_new(resp, json_pack("[s,o,s]", "error", err, tag));
+            json_decref(args);
+            continue;
+        }
+
+        struct conversations_state *cstate = NULL;
+        r = conversations_open_user(accountid, mp->flags & JMAP_SHARED_CSTATE, &cstate);
+
+        if (r) {
+            txn->error.desc = error_message(r);
+            ret = HTTP_SERVER_ERROR;
+            json_decref(args);
+            goto done;
+        }
+
+        /* Initialize request context */
+        struct jmap_req req;
+        jmap_initreq(&req);
+
+        req.method = mname;
+        req.userid = httpd_userid;
+        req.accountid = accountid;
+        req.cstate = cstate;
+        req.authstate = httpd_authstate;
+        req.args = args;
+        req.response = resp;
+        req.tag = tag;
+        req.created_ids = &created_ids;
+        req.txn = txn;
+        req.mboxrights = &mboxrights;
+        req.method_calls = &method_calls;
+        req.using_capabilities = &using_capabilities;
+
+        if (do_perf) {
+            struct rusage usage;
+
+            getrusage(RUSAGE_SELF, &usage);
+            req.user_start = timeval_get_double(&usage.ru_utime);
+            req.sys_start = timeval_get_double(&usage.ru_stime);
+            req.real_start = now_ms() / 1000.0;
+            req.perf_details = json_object();
+        }
+
+        /* Read the current state data in */
+        account_inboxname = mboxname_user_mbox(accountid, NULL);
+        r = mboxname_read_counters(account_inboxname, &req.counters);
+        free(account_inboxname);
+        account_inboxname = NULL;
+        if (r) {
+            conversations_abort(&req.cstate);
+            txn->error.desc = error_message(r);
+            ret = HTTP_SERVER_ERROR;
+            jmap_finireq(&req);
+            json_decref(args);
+            goto done;
+        }
+
+        /* Call the message processor. */
+        r = mp->proc(&req);
+
+        /* Finalize request context */
+        jmap_finireq(&req);
+
+        if (r) {
+            conversations_abort(&req.cstate);
+            txn->error.desc = error_message(r);
+            ret = HTTP_SERVER_ERROR;
+            json_decref(args);
+            goto done;
+        }
+        conversations_commit(&req.cstate);
+
+        json_decref(args);
+    }
+
+    /* tell syslog which methods were called */
+    spool_replace_header(xstrdup(":jmap"),
+                         strarray_join(&methods, ","), txn->req_hdrs);
+
+
+    /* Build response */
+    if (txn->meth == METH_UNKNOWN) {
+        /* API request over WebSocket */
+        *res = json_pack("{s:s s:O}",
+                         "@type", "Response", "methodResponses", resp);
+    }
+    else {
+        *res = json_pack("{s:O}", "methodResponses", resp);
+    }
+    if (return_created_ids) {
+        json_t *jcreatedIds = json_object();
+        hash_enumerate(&created_ids, _make_created_ids, jcreatedIds);
+        json_object_set_new(*res, "createdIds", jcreatedIds);
+    }
+    char *user_inboxname = mboxname_user_mbox(httpd_userid, NULL);
+    struct buf state = BUF_INITIALIZER;
+    buf_printf(&state, MODSEQ_FMT, mboxname_readraclmodseq(user_inboxname));
+    free(user_inboxname);
+    json_object_set_new(*res, "sessionState", json_string(buf_cstring(&state)));
+    buf_free(&state);
+
+  done:
+    {
+        /* Clean up call stack */
+        json_t *jval;
+        while ((jval = ptrarray_pop(&processed_methods)))  {
+            json_decref(jval);
+        }
+        while ((jval = ptrarray_pop(&method_calls))) {
+            json_decref(jval);
+        }
+        ptrarray_fini(&processed_methods);
+        ptrarray_fini(&method_calls);
+    }
+    free_hash_table(&created_ids, free);
+    free_hash_table(&capabilities_by_accountid, _free_json);
+    free_hash_table(&mboxrights, free);
+    free(account_inboxname);
+    json_decref(jreq);
+    json_decref(resp);
+    strarray_fini(&methods);
+    strarray_fini(&using_capabilities);
+
+    return ret;
+}
+
+struct findaccounts_rock {
+    struct buf current_accountid;
+    int current_rights;
+    json_t *accounts;
+    const char *authuserid;
+};
+
+static void findaccounts_add(struct findaccounts_rock *rock)
+{
+    if (!buf_len(&rock->current_accountid))
+        return;
+
+    if (!(rock->current_rights & (ACL_LOOKUP|ACL_READ)))
+        return;
+
+    const char *accountid = buf_cstring(&rock->current_accountid);
+    int is_rw = rock->current_rights & ACL_READ_WRITE;
+    int is_primary = !strcmp(rock->authuserid, accountid);
+
+    json_t *account = json_object();
+    json_object_set_new(account, "name", json_string(accountid));
+    json_object_set_new(account, "isPrimary", json_boolean(is_primary));
+    json_object_set_new(account, "isPersonal", json_boolean(is_primary));
+    json_object_set_new(account, "isReadOnly", json_boolean(!is_rw));
+    json_object_set_new(rock->accounts, accountid, account);
+}
+
+static int findaccounts_cb(struct findall_data *data, void *vrock)
+{
+    if (!data || !data->mbentry) {
+        return 0;
+    }
+
+    struct findaccounts_rock *rock = vrock;
+    const mbentry_t *mbentry = data->mbentry;
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+
+    if (strcmp(buf_cstring(&rock->current_accountid), mbname_userid(mbname))) {
+        findaccounts_add(rock);
+        buf_setcstr(&rock->current_accountid, mbname_userid(mbname));
+        rock->current_rights = 0;
+    }
+    rock->current_rights |= httpd_myrights(httpd_authstate, data->mbentry);
+
+    mbname_free(&mbname);
+    return 0;
+}
+
+HIDDEN void jmap_accounts(json_t *accounts, json_t *primary_accounts)
+{
+    /* Find shared accounts */
+    strarray_t patterns = STRARRAY_INITIALIZER;
+    char *userpat = xstrdup("user.*");
+    userpat[4] = jmap_namespace.hier_sep;
+    strarray_append(&patterns, userpat);
+    struct findaccounts_rock rock = {
+        BUF_INITIALIZER, 0, accounts, httpd_userid
+    };
+    int r = mboxlist_findallmulti(&jmap_namespace, &patterns, 0, httpd_userid,
+                                  httpd_authstate, findaccounts_cb, &rock);
+    if (r) {
+        syslog(LOG_ERR, "Can't determine shared JMAP accounts for user %s: %s",
+                         httpd_userid, error_message(r));
+    }
+    findaccounts_add(&rock);
+
+    /* Add primary accout */
+    buf_setcstr(&rock.current_accountid, httpd_userid);
+    rock.current_rights = ACL_FULL;
+    findaccounts_add(&rock);
+
+    /* Determine account capabilities */
+    hash_table mboxrights = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&mboxrights, 64, 0);
+    json_t *jaccount;
+    const char *accountid;
+    json_object_foreach(accounts, accountid, jaccount) {
+        json_t *capas = lookup_capabilities(accountid, httpd_userid,
+                                            httpd_authstate, &mboxrights);
+        json_object_set_new(jaccount, "accountCapabilities", capas);
+    }
+    free_hash_table(&mboxrights, free);
+
+    json_t *jprimary = json_string(httpd_userid);
+    json_object_set(primary_accounts, JMAP_URN_MAIL, jprimary);
+    json_object_set(primary_accounts, JMAP_URN_SUBMISSION, jprimary);
+    json_object_set(primary_accounts, JMAP_URN_VACATION, jprimary);
+    json_object_set(primary_accounts, JMAP_CONTACTS_EXTENSION, jprimary);
+    json_object_set(primary_accounts, JMAP_CALENDARS_EXTENSION, jprimary);
+    json_decref(jprimary);
+
+    /* Clean up */
+    buf_free(&rock.current_accountid);
+    free(userpat);
+    strarray_fini(&patterns);
+}
+
+
+HIDDEN void jmap_add_subreq(jmap_req_t *req, const char *method,
+                            json_t *args, const char *client_id)
+{
+    if (!client_id) client_id = req->tag;
+    ptrarray_push(req->method_calls, json_pack("[s,o,s]", method, args, client_id));
+}
+
+const char *jmap_lookup_id(jmap_req_t *req, const char *creation_id)
+{
+    return hash_lookup(creation_id, req->created_ids);
+}
+
+const char *jmap_id_string_value(jmap_req_t *req, json_t *item)
+{
+    if (!item) return NULL;
+    if (!json_is_string(item)) return NULL;
+    const char *id = json_string_value(item);
+    if (*id == '#')
+        return jmap_lookup_id(req, id+1);
+    return id;
+}
+
+void jmap_add_id(jmap_req_t *req, const char *creation_id, const char *id)
+{
+    /* It's OK to overwrite existing ids, as per Foo/set:
+     * "A client SHOULD NOT reuse a creation id anywhere in the same API
+     * request. If a creation id is reused, the server MUST map the creation
+     * id to the most recently created item with that id."
+     */
+    hash_insert(creation_id, xstrdup(id), req->created_ids);
+}
+
+HIDDEN int jmap_openmbox(jmap_req_t *req, const char *name,
+                         struct mailbox **mboxp, int rw)
+{
+    int i, r;
+    struct _mboxcache_rec *rec;
+
+    for (i = 0; i < req->mboxes->count; i++) {
+        rec = (struct _mboxcache_rec*) ptrarray_nth(req->mboxes, i);
+        if (!strcmp(name, rec->mbox->name)) {
+            if (rw && !rec->rw) {
+                /* Lock promotions are not supported */
+                syslog(LOG_ERR, "jmapmbox: failed to grab write-lock"
+                       " on cached read-only mailbox %s", name);
+                return IMAP_INTERNAL;
+            }
+            /* Found a cached mailbox. Increment refcount. */
+            rec->refcount++;
+            *mboxp = rec->mbox;
+
+            return 0;
+        }
+    }
+
+    /* Add mailbox to cache */
+    if (req->force_openmbox_rw)
+        rw = 1;
+    r = rw ? mailbox_open_iwl(name, mboxp) : mailbox_open_irl(name, mboxp);
+    if (r) {
+        syslog(LOG_ERR, "jmap_openmbox(%s): %s", name, error_message(r));
+        return r;
+    }
+    rec = xzmalloc(sizeof(struct _mboxcache_rec));
+    rec->mbox = *mboxp;
+    rec->refcount = 1;
+    rec->rw = rw;
+    ptrarray_add(req->mboxes, rec);
+
+    return 0;
+}
+
+HIDDEN int jmap_isopenmbox(jmap_req_t *req, const char *name)
+{
+
+    int i;
+    struct _mboxcache_rec *rec;
+
+    for (i = 0; i < req->mboxes->count; i++) {
+        rec = (struct _mboxcache_rec*) ptrarray_nth(req->mboxes, i);
+        if (!strcmp(name, rec->mbox->name))
+            return 1;
+    }
+
+    return 0;
+}
+
+HIDDEN void jmap_closembox(jmap_req_t *req, struct mailbox **mboxp)
+{
+    struct _mboxcache_rec *rec = NULL;
+    int i;
+
+    if (mboxp == NULL || *mboxp == NULL) return;
+
+    for (i = 0; i < req->mboxes->count; i++) {
+        rec = (struct _mboxcache_rec*) ptrarray_nth(req->mboxes, i);
+        if (rec->mbox == *mboxp) {
+            if (!(--rec->refcount)) {
+                ptrarray_remove(req->mboxes, i);
+                mailbox_close(&rec->mbox);
+                free(rec);
+            }
+            *mboxp = NULL;
+            return;
+        }
+    }
+    syslog(LOG_INFO, "jmap: ignoring non-cached mailbox %s", (*mboxp)->name);
+}
+
+HIDDEN void jmap_set_blobid(const struct message_guid *guid, char *buf)
+{
+    buf[0] = 'G';
+    memcpy(buf+1, message_guid_encode(guid), 40);
+    buf[41] = '\0';
+}
+
+HIDDEN void jmap_set_emailid(const struct message_guid *guid, char *buf)
+{
+    buf[0] = 'M';
+    // appends NULL for us
+    bin_to_lchex(&guid->value, 12, buf+1);
+}
+
+HIDDEN void jmap_set_threadid(conversation_id_t cid, char *buf)
+{
+    buf[0] = 'T';
+    memcpy(buf+1, conversation_id_encode(cid), 16);
+    buf[17] = 0;
+}
+
+struct findblob_data {
+    jmap_req_t *req;
+    const char *from_accountid;
+    int is_shared_account;
+    struct mailbox *mbox;
+    msgrecord_t *mr;
+    char *part_id;
+};
+
+static int findblob_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct findblob_data *d = (struct findblob_data*) rock;
+    jmap_req_t *req = d->req;
+    int r = 0;
+
+    /* Check ACL */
+    if (d->is_shared_account) {
+        mbentry_t *mbentry = NULL;
+        r = mboxlist_lookup(rec->mboxname, &mbentry, NULL);
+        if (r) {
+            syslog(LOG_ERR, "jmap_findblob: no mbentry for %s", rec->mboxname);
+            return r;
+        }
+        int rights = jmap_myrights(req, mbentry);
+        mboxlist_entry_free(&mbentry);
+        if ((rights & (ACL_LOOKUP|ACL_READ)) != (ACL_LOOKUP|ACL_READ)) {
+            return 0;
+        }
+    }
+
+    r = jmap_openmbox(req, rec->mboxname, &d->mbox, 0);
+    if (r) return r;
+
+    r = msgrecord_find(d->mbox, rec->uid, &d->mr);
+    if (r) {
+        jmap_closembox(req, &d->mbox);
+        d->mr = NULL;
+        return r;
+    }
+
+    d->part_id = rec->part ? xstrdup(rec->part) : NULL;
+    return IMAP_OK_COMPLETED;
+}
+
+HIDDEN int jmap_findblob(jmap_req_t *req, const char *from_accountid,
+                         const char *blobid,
+                         struct mailbox **mbox, msgrecord_t **mr,
+                         struct body **body, const struct body **part,
+                         struct buf *blob)
+{
+    const char *accountid = from_accountid ? from_accountid : req->accountid;
+    struct findblob_data data = {
+        req,
+        /* from_accountid */
+        accountid,
+        /* is_shared_account */
+        strcmp(req->userid, accountid),
+        /* mbox */
+        NULL,
+        /* mr */
+        NULL,
+        /* part_id */
+        NULL
+    };
+    struct body *mybody = NULL;
+    const struct body *mypart = NULL;
+    int i, r;
+    struct conversations_state *cstate, *mycstate = NULL;
+
+    if (blobid[0] != 'G')
+        return IMAP_NOTFOUND;
+
+    if (strcmp(req->accountid, accountid)) {
+        cstate = conversations_get_user(accountid);
+        if (!cstate) {
+            r = conversations_open_user(accountid, 1/*shared*/, &mycstate);
+            if (r) goto done;
+
+            cstate = mycstate;
+        }
+    }
+    else {
+        cstate = req->cstate;
+    }
+
+    r = conversations_guid_foreach(cstate, blobid+1, findblob_cb, &data);
+    if (r != IMAP_OK_COMPLETED) {
+        if (!r) r = IMAP_NOTFOUND;
+        goto done;
+    }
+
+    /* Find part containing the data */
+    if (data.part_id) {
+        r = msgrecord_extract_bodystructure(data.mr, &mybody);
+        if (r) goto done;
+
+        ptrarray_t parts = PTRARRAY_INITIALIZER;
+        struct message_guid content_guid;
+
+        message_guid_decode(&content_guid, blobid+1);
+
+        ptrarray_push(&parts, mybody);
+        while ((mypart = ptrarray_shift(&parts))) {
+            if (!message_guid_cmp(&content_guid, &mypart->content_guid)) {
+                break;
+            }
+            if (!mypart->subpart) {
+                if (data.mbox->mbtype == MBTYPE_ADDRESSBOOK &&
+                    (mypart = jmap_contact_findblob(&content_guid, data.part_id,
+                                                    data.mbox, data.mr, blob))) {
+                    break;
+                }
+                continue;
+            }
+            ptrarray_push(&parts, mypart->subpart);
+            for (i = 1; i < mypart->numparts; i++)
+                ptrarray_push(&parts, mypart->subpart + i);
+        }
+        ptrarray_fini(&parts);
+
+        if (!mypart) {
+            r = IMAP_NOTFOUND;
+            goto done;
+        }
+    }
+
+    if (blob && !buf_base(blob)) {
+        /* Map the message into memory */
+        r = msgrecord_get_body(data.mr, blob);
+        if (r) goto done;
+    }
+
+    *mbox = data.mbox;
+    *mr = data.mr;
+    *part = mypart;
+    *body = mybody;
+    r = 0;
+
+done:
+    if (mycstate) {
+        conversations_commit(&mycstate);
+    }
+    if (r) {
+        if (data.mbox) jmap_closembox(req, &data.mbox);
+        if (mybody) message_free_body(mybody);
+    }
+    if (data.part_id) free(data.part_id);
+    return r;
+}
+
+static int findblob_exact_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct findblob_data *d = (struct findblob_data*) rock;
+    jmap_req_t *req = d->req;
+    int r = 0;
+
+    // we only want top-level blobs
+    if (rec->part) return 0;
+
+    /* Check ACL */
+    if (d->is_shared_account) {
+        mbentry_t *mbentry = NULL;
+        r = mboxlist_lookup(rec->mboxname, &mbentry, NULL);
+        if (r) {
+            syslog(LOG_ERR, "jmap_findblob: no mbentry for %s", rec->mboxname);
+            return r;
+        }
+        int rights = jmap_myrights(req, mbentry);
+        mboxlist_entry_free(&mbentry);
+        if ((rights & (ACL_LOOKUP|ACL_READ)) != (ACL_LOOKUP|ACL_READ)) {
+            return 0;
+        }
+    }
+
+    r = jmap_openmbox(req, rec->mboxname, &d->mbox, 0);
+    if (r) return r;
+
+    r = msgrecord_find(d->mbox, rec->uid, &d->mr);
+    if (r) {
+        jmap_closembox(req, &d->mbox);
+        d->mr = NULL;
+        return r;
+    }
+
+    return IMAP_OK_COMPLETED;
+}
+
+// we need to pass mbox so we can keep it open until the file has been used
+HIDDEN int jmap_findblob_exact(jmap_req_t *req, const char *from_accountid,
+                               const char *blobid,
+                               struct mailbox **mbox, msgrecord_t **mr)
+{
+    const char *accountid = from_accountid ? from_accountid : req->accountid;
+    struct findblob_data data = {
+        req,
+        /* from_accountid */
+        accountid,
+        /* is_shared_account */
+        strcmp(req->userid, accountid),
+        /* mbox */
+        NULL,
+        /* mr */
+        NULL,
+        /* part_id */
+        NULL,
+    };
+    int r;
+    struct conversations_state *cstate, *mycstate = NULL;
+
+    if (blobid[0] != 'G')
+        return IMAP_NOTFOUND;
+
+    if (strcmp(req->accountid, accountid)) {
+        cstate = conversations_get_user(accountid);
+        if (!cstate) {
+            r = conversations_open_user(accountid, 1/*shared*/, &mycstate);
+            if (r) goto done;
+
+            cstate = mycstate;
+        }
+    }
+    else {
+        cstate = req->cstate;
+    }
+
+    r = conversations_guid_foreach(cstate, blobid+1, findblob_exact_cb, &data);
+    if (r != IMAP_OK_COMPLETED) {
+        if (!r) r = IMAP_NOTFOUND;
+        goto done;
+    }
+
+    *mbox = data.mbox;
+    *mr = data.mr;
+    r = 0;
+
+done:
+    if (mycstate) {
+        conversations_commit(&mycstate);
+    }
+    if (r) {
+        if (data.mbox) jmap_closembox(req, &data.mbox);
+    }
+    return r;
+}
+
+HIDDEN int jmap_cmpstate(jmap_req_t* req, json_t *state, int mbtype)
+{
+    if (JNOTNULL(state)) {
+        const char *s = json_string_value(state);
+        if (!s) {
+            return -1;
+        }
+        modseq_t client_modseq = atomodseq_t(s);
+        modseq_t server_modseq = 0;
+        switch (mbtype) {
+         case MBTYPE_CALENDAR:
+             server_modseq = req->counters.caldavmodseq;
+             break;
+         case MBTYPE_ADDRESSBOOK:
+             server_modseq = req->counters.carddavmodseq;
+             break;
+         case MBTYPE_SUBMISSION:
+             server_modseq = req->counters.submissionmodseq;
+             break;
+         default:
+             server_modseq = req->counters.mailmodseq;
+        }
+        if (client_modseq < server_modseq)
+            return -1;
+        else if (client_modseq > server_modseq)
+            return 1;
+        else
+            return 0;
+    }
+    return 0;
+}
+
+HIDDEN modseq_t jmap_highestmodseq(jmap_req_t *req, int mbtype)
+{
+    modseq_t modseq;
+
+    /* Determine current counter by mailbox type. */
+    switch (mbtype) {
+        case MBTYPE_CALENDAR:
+            modseq = req->counters.caldavmodseq;
+            break;
+        case MBTYPE_ADDRESSBOOK:
+            modseq = req->counters.carddavmodseq;
+            break;
+        case MBTYPE_SUBMISSION:
+            modseq = req->counters.submissionmodseq;
+            break;
+        case 0:
+            modseq = req->counters.mailmodseq;
+            break;
+        default:
+            modseq = req->counters.highestmodseq;
+    }
+
+    return modseq;
+}
+
+HIDDEN json_t* jmap_getstate(jmap_req_t *req, int mbtype, int refresh)
+{
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    if (refresh)
+        assert (!mboxname_read_counters(inboxname, &req->counters));
+    struct buf buf = BUF_INITIALIZER;
+    json_t *state = NULL;
+    modseq_t modseq = jmap_highestmodseq(req, mbtype);
+
+    buf_printf(&buf, MODSEQ_FMT, modseq);
+    state = json_string(buf_cstring(&buf));
+    buf_free(&buf);
+
+    free(inboxname);
+    return state;
+}
+
+
+HIDDEN json_t *jmap_fmtstate(modseq_t modseq)
+{
+    struct buf buf = BUF_INITIALIZER;
+    json_t *state = NULL;
+    buf_printf(&buf, MODSEQ_FMT, modseq);
+    state = json_string(buf_cstring(&buf));
+    buf_free(&buf);
+    return state;
+}
+
+HIDDEN char *jmap_xhref(const char *mboxname, const char *resource)
+{
+    /* XXX - look up root path from namespace? */
+    struct buf buf = BUF_INITIALIZER;
+    char *owner = mboxname_to_userid(mboxname);
+
+    const char *prefix = NULL;
+    if (mboxname_isaddressbookmailbox(mboxname, 0)) {
+        prefix = namespace_addressbook.prefix;
+    }
+    else if (mboxname_iscalendarmailbox(mboxname, 0)) {
+        prefix = namespace_calendar.prefix;
+    }
+
+    /* Path to home-set */
+    buf_printf(&buf, "%s/%s/%s", prefix, USER_COLLECTION_PREFIX, httpd_userid);
+    if (!strchr(httpd_userid, '@') && httpd_extradomain) {
+        buf_printf(&buf, "@%s", httpd_extradomain);
+    }
+    buf_putc(&buf, '/');
+
+    if (strcmp(owner, httpd_userid)) {
+        /* Encode shared collection as: <owner> "." <mboxname> */
+        buf_appendcstr(&buf, owner);
+        if (!strchr(owner, '@') && httpd_extradomain) {
+            buf_printf(&buf, "@%s", httpd_extradomain);
+        }
+        buf_putc(&buf, SHARED_COLLECTION_DELIM);
+    }
+
+    /* Collection */
+    buf_printf(&buf, "%s", strrchr(mboxname, '.')+1);
+
+    if (resource)
+        buf_printf(&buf, "/%s", resource);
+    free(owner);
+    return buf_release(&buf);
+}
+
+HIDDEN int jmap_myrights(jmap_req_t *req, const mbentry_t *mbentry)
+{
+    return _rights_for_mbentry(req->authstate, mbentry, req->mboxrights);
+}
+
+// gotta have them all
+HIDDEN int jmap_hasrights(jmap_req_t *req, const mbentry_t *mbentry, int rights)
+{
+    int myrights = jmap_myrights(req, mbentry);
+    if ((myrights & rights) == rights) return 1;
+    return 0;
+}
+
+HIDDEN int jmap_myrights_byname(jmap_req_t *req, const char *mboxname)
+{
+    int *rightsptr = hash_lookup(mboxname, req->mboxrights);
+    if (rightsptr) return *rightsptr;
+
+    // if unable to read, that means no rights
+    int rights = 0;
+
+    mbentry_t *mbentry = NULL;
+    if (!jmap_mboxlist_lookup(mboxname, &mbentry, NULL)) {
+        rights = _rights_for_mbentry(req->authstate, mbentry, req->mboxrights);
+    }
+    mboxlist_entry_free(&mbentry);
+
+    return rights;
+}
+
+// gotta have them all
+HIDDEN int jmap_hasrights_byname(jmap_req_t *req, const char *mboxname,
+                                 int rights)
+{
+    int myrights = jmap_myrights_byname(req, mboxname);
+    if ((myrights & rights) == rights) return 1;
+    return 0;
+}
+
+HIDDEN void jmap_myrights_delete(jmap_req_t *req, const char *mboxname)
+{
+    int *rightsptr = hash_del(mboxname, req->mboxrights);
+    free(rightsptr);
+}
+
+/* Add performance stats to method response */
+static void jmap_add_perf(jmap_req_t *req, json_t *res)
+{
+    struct rusage usage;
+
+    getrusage(RUSAGE_SELF, &usage);
+
+    json_t *perf = json_pack("{s:f s:f s:f}",
+            "real", (now_ms() / 1000.0) - req->real_start,
+            "user", timeval_get_double(&usage.ru_utime) - req->user_start,
+            "sys", timeval_get_double(&usage.ru_stime) - req->sys_start);
+    json_object_set(perf, "details", req->perf_details); // incref
+
+    json_object_set_new(res, "performance", perf);
+}
+
+HIDDEN void jmap_ok(jmap_req_t *req, json_t *res)
+{
+    json_object_set_new(res, "accountId", json_string(req->accountid));
+
+    json_t *item = json_pack("[]");
+    json_array_append_new(item, json_string(req->method));
+    json_array_append_new(item, res);
+    json_array_append_new(item, json_string(req->tag));
+    json_array_append_new(req->response, item);
+
+    if (jmap_is_using(req, JMAP_PERFORMANCE_EXTENSION))
+        jmap_add_perf(req, res);
+}
+
+HIDDEN void jmap_error(jmap_req_t *req, json_t *err)
+{
+    json_array_append_new(req->response,
+            json_pack("[s,o,s]", "error", err, req->tag));
+}
+
+
+HIDDEN int jmap_parse_strings(json_t *arg,
+                              struct jmap_parser *parser, const char *prop)
+{
+    if (!json_is_array(arg)) {
+        jmap_parser_invalid(parser, prop);
+        return 0;
+    }
+    int valid = 1;
+    size_t i;
+    json_t *val;
+    json_array_foreach(arg, i, val) {
+        if (!json_is_string(val)) {
+            jmap_parser_push_index(parser, prop, i, NULL);
+            jmap_parser_invalid(parser, NULL);
+            jmap_parser_pop(parser);
+            valid = 0;
+        }
+    }
+    return valid;
+}
+
+
+HIDDEN const jmap_property_t *jmap_property_find(const char *name,
+                                                 const jmap_property_t props[])
+{
+    const jmap_property_t *prop;
+
+    for (prop = props; prop && prop->name; prop++) {
+        if (!strcmp(name, prop->name)) return prop;
+        else {
+            size_t len = strlen(prop->name);
+            if ((prop->name[len-1] == '*') && !strncmp(name, prop->name, len-1))
+                return prop;
+        }
+    }
+
+    return NULL;
+}
+
+
+/* Foo/get */
+
+HIDDEN void jmap_get_parse(jmap_req_t *req,
+                           struct jmap_parser *parser,
+                           const jmap_property_t valid_props[],
+                           int allow_null_ids,
+                           jmap_args_parse_cb args_parse,
+                           void *args_rock,
+                           struct jmap_get *get,
+                           json_t **err)
+{
+    json_t *jargs = req->args;
+    const char *key;
+    json_t *arg, *val;
+    size_t i;
+
+    memset(get, 0, sizeof(struct jmap_get));
+
+    get->list = json_array();
+    get->not_found = json_array();
+
+    json_object_foreach(jargs, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        else if (!strcmp(key, "ids")) {
+            if (json_is_array(arg)) {
+                get->ids = json_array();
+                /* JMAP spec requires: "If an identical id is included
+                 * more than once in the request, the server MUST only
+                 * include it once in either the list or notFound
+                 * argument of the response."
+                 * So let's weed out duplicate ids here. */
+                hash_table _dedup = HASH_TABLE_INITIALIZER;
+                construct_hash_table(&_dedup, json_array_size(arg) + 1, 0);
+                json_array_foreach(arg, i, val) {
+                    const char *id = json_string_value(val);
+                    if (!id) {
+                        jmap_parser_push_index(parser, "ids", i, NULL);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                        continue;
+                    }
+                    /* Weed out unknown creation ids and add the ids of known
+                     * creation ids to the requested ids list. THis might
+                     * cause a race if the Foo object pointed to by creation
+                     * id is deleted between parsing the request and answering
+                     * it. But re-checking creation ids for their existence
+                     * later in the control flow just shifts the problem */
+                    if (*id == '#') {
+                        const char *id2 = jmap_lookup_id(req, id + 1);
+                        if (!id2) {
+                            json_array_append_new(get->not_found,
+                                                  json_string(id));
+                            continue;
+                        }
+                        id = id2;
+                    }
+                    if (hash_lookup(id, &_dedup)) {
+                        continue;
+                    }
+                    json_array_append_new(get->ids, json_string(id));
+                }
+                free_hash_table(&_dedup, NULL);
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "ids");
+            }
+        }
+
+        else if (!strcmp(key, "properties")) {
+            if (json_is_array(arg)) {
+                get->props = xzmalloc(sizeof(hash_table));
+                construct_hash_table(get->props, json_array_size(arg) + 1, 0);
+                json_array_foreach(arg, i, val) {
+                    const char *name = json_string_value(val);
+                    const jmap_property_t *propdef = NULL;
+                    if (name) {
+                        propdef = jmap_property_find(name, valid_props);
+                        if (propdef && propdef->capability &&
+                            !jmap_is_using(req, propdef->capability)) {
+                            propdef = NULL;
+                        }
+                    }
+                    if (!propdef) {
+                        jmap_parser_push_index(parser, "properties", i, name);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                        continue;
+                    }
+                    hash_insert(name, (void*)1, get->props);
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "properties");
+            }
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser->invalid);
+        return;
+    }
+
+    if (!allow_null_ids && !JNOTNULL(get->ids)) {
+        *err = json_pack("{s:s, s:s}", "type", "requestTooLarge",
+                         "description", "ids must be specified");
+        return;
+    }
+
+    if (*err) return;
+
+    if (get->props == NULL) {
+        /* Initialize default properties */
+        int nvalid = 0;
+        const jmap_property_t *prop;
+        for (prop = valid_props; prop && prop->name; prop++) {
+            nvalid++;
+        }
+        get->props = xzmalloc(sizeof(hash_table));
+        construct_hash_table(get->props, nvalid + 1, 0);
+        for (prop = valid_props; prop && prop->name; prop++) {
+            if (prop->flags & JMAP_PROP_SKIP_GET) {
+                continue;
+            }
+            if (!prop->capability || jmap_is_using(req, prop->capability)) {
+                hash_insert(prop->name, (void*)1, get->props);
+            }
+        }
+    }
+    else {
+        const jmap_property_t *prop;
+        for (prop = valid_props; prop && prop->name; prop++) {
+            if (prop->flags & JMAP_PROP_ALWAYS_GET) {
+                if (!hash_lookup(prop->name, get->props)) {
+                    hash_insert(prop->name, (void*)1, get->props);
+                }
+            }
+        }
+    }
+
+    /* Number of ids checked in validate_request() */ 
+}
+
+HIDDEN void jmap_get_fini(struct jmap_get *get)
+{
+    free_hash_table(get->props, NULL);
+    free(get->props);
+    free(get->state);
+    json_decref(get->ids);
+    json_decref(get->list);
+    json_decref(get->not_found);
+}
+
+HIDDEN json_t *jmap_get_reply(struct jmap_get *get)
+{
+    json_t *res = json_object();
+    json_object_set_new(res, "state", json_string(get->state));
+    json_object_set(res, "list", get->list);
+    json_object_set(res, "notFound", get->not_found);
+    return res;
+}
+
+
+/* Foo/set */
+
+static void jmap_set_validate_props(jmap_req_t *req, json_t *jobj,
+                                    const jmap_property_t valid_props[],
+                                    json_t **err)
+{
+    json_t *invalid = json_array();
+    const char *path;
+    json_t *jval;
+
+    json_object_foreach(jobj, path, jval) {
+        /* Determine property name */
+        const char *pname = path;
+        char *tmp = NULL;
+        const char *slash = strchr(pname, '/');
+        if (slash) {
+            tmp = jmap_pointer_decode(pname, slash - path);
+            if (tmp) pname = tmp;
+        }
+        /* Validate against property spec */
+        const jmap_property_t *prop = jmap_property_find(pname, valid_props);
+        if (!prop) {
+            json_array_append_new(invalid, json_string(path));
+        }
+        else if (prop->capability && !jmap_is_using(req, prop->capability)) {
+            json_array_append_new(invalid, json_string(path));
+        }
+        /* XXX could check IMMUTABLE and SERVER_SET here, but we can't
+         * reject such properties if they match the current value */
+        if (tmp) free(tmp);
+    }
+    if (json_array_size(invalid)) {
+        *err = json_pack("{s:s s:o}",
+                "type", "invalidProperties",
+                "properties", invalid);
+    }
+    else {
+        json_decref(invalid);
+    }
+}
+
+HIDDEN void jmap_set_parse(jmap_req_t *req, struct jmap_parser *parser,
+                           const jmap_property_t valid_props[],
+                           jmap_args_parse_cb args_parse, void *args_rock,
+                           struct jmap_set *set, json_t **err)
+{
+    json_t *jargs = req->args;
+    memset(set, 0, sizeof(struct jmap_set));
+    set->create = json_object();
+    set->update = json_object();
+    set->destroy = json_array();
+    set->created = json_object();
+    set->updated = json_object();
+    set->destroyed = json_array();
+    set->not_created = json_object();
+    set->not_updated = json_object();
+    set->not_destroyed = json_object();
+
+    const char *key;
+    json_t *arg, *val;
+
+    json_object_foreach(jargs, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        /* ifInState */
+        else  if (!strcmp(key, "ifInState")) {
+            if (json_is_string(arg)) {
+                set->if_in_state = json_string_value(arg);
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "ifInState");
+            }
+        }
+
+        /* create */
+        else if (!strcmp(key, "create")) {
+            if (json_is_object(arg)) {
+                const char *id;
+                json_object_foreach(arg, id, val) {
+                    if (!json_is_object(val)) {
+                        jmap_parser_push(parser, "create");
+                        jmap_parser_invalid(parser, id);
+                        jmap_parser_pop(parser);
+                        continue;
+                    }
+                    json_object_set(set->create, id, val);
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "create");
+            }
+        }
+
+        /* update */
+        else if (!strcmp(key, "update")) {
+            if (json_is_object(arg)) {
+                const char *id;
+                json_object_foreach(arg, id, val) {
+                    if (!json_is_object(val)) {
+                        jmap_parser_push(parser, "update");
+                        jmap_parser_invalid(parser, id);
+                        jmap_parser_pop(parser);
+                        continue;
+                    }
+                    json_object_set(set->update, id, val);
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "update");
+            }
+        }
+
+        /* destroy */
+        else if (!strcmp(key, "destroy")) {
+            if (JNOTNULL(arg)) {
+                jmap_parse_strings(arg, parser, "destroy");
+                if (!json_array_size(parser->invalid)) {
+                    json_decref(set->destroy);
+                    set->destroy = json_incref(arg);
+                }
+            }
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser->invalid);
+    }
+
+    if (valid_props) {
+        json_t *jval;
+        /* Make sure no property is set without its capability */
+        json_object_foreach(json_object_get(jargs, "create"), key, jval) {
+            json_t *err = NULL;
+            jmap_set_validate_props(req, jval, valid_props, &err);
+            if (err) {
+                json_object_del(set->create, key);
+                json_object_set_new(set->not_created, key, err);
+            }
+        }
+        json_object_foreach(json_object_get(jargs, "update"), key, jval) {
+            json_t *err = NULL;
+            jmap_set_validate_props(req, jval, valid_props, &err);
+            if (err) {
+                json_object_del(set->update, key);
+                json_object_set_new(set->not_updated, key, err);
+            }
+        }
+        // TODO We could report the following set errors here:
+        // -invalidPatch
+        // - willDestroy
+    }
+}
+
+
+HIDDEN void jmap_set_fini(struct jmap_set *set)
+{
+    free(set->old_state);
+    free(set->new_state);
+    json_decref(set->create);
+    json_decref(set->update);
+    json_decref(set->destroy);
+    json_decref(set->created);
+    json_decref(set->updated);
+    json_decref(set->destroyed);
+    json_decref(set->not_created);
+    json_decref(set->not_updated);
+    json_decref(set->not_destroyed);
+}
+
+HIDDEN json_t *jmap_set_reply(struct jmap_set *set)
+{
+    json_t *res = json_object();
+    json_object_set_new(res, "oldState",
+            set->old_state ? json_string(set->old_state) : json_null());
+    json_object_set_new(res, "newState", json_string(set->new_state));
+    json_object_set(res, "created", json_object_size(set->created) ?
+            set->created : json_null());
+    json_object_set(res, "updated", json_object_size(set->updated) ?
+            set->updated : json_null());
+    json_object_set(res, "destroyed", json_array_size(set->destroyed) ?
+            set->destroyed : json_null());
+    json_object_set(res, "notCreated", json_object_size(set->not_created) ?
+            set->not_created : json_null());
+    json_object_set(res, "notUpdated", json_object_size(set->not_updated) ?
+            set->not_updated : json_null());
+    json_object_set(res, "notDestroyed", json_object_size(set->not_destroyed) ?
+            set->not_destroyed : json_null());
+    return res;
+}
+
+
+/* Foo/changes */
+
+HIDDEN void jmap_changes_parse(jmap_req_t *req,
+                               struct jmap_parser *parser,
+                               jmap_args_parse_cb args_parse,
+                               void *args_rock,
+                               struct jmap_changes *changes,
+                               json_t **err)
+{
+    json_t *jargs = req->args;
+    const char *key;
+    json_t *arg;
+
+    memset(changes, 0, sizeof(struct jmap_changes));
+    changes->created = json_array();
+    changes->updated = json_array();
+    changes->destroyed = json_array();
+
+    json_object_foreach(jargs, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        /* sinceState */
+        else if (!strcmp(key, "sinceState")) {
+            if (json_is_string(arg)) {
+                changes->since_modseq = atomodseq_t(json_string_value(arg));
+            }
+            else {
+                jmap_parser_invalid(parser, "sinceState");
+            }
+        }
+
+        /* maxChanges */
+        else if (!strcmp(key, "maxChanges")) {
+            if (json_is_integer(arg) && json_integer_value(arg) > 0) {
+                changes->max_changes = json_integer_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "maxChanges");
+            }
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser->invalid);
+    }
+    else if (!changes->since_modseq) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+    }
+}
+
+HIDDEN void jmap_changes_fini(struct jmap_changes *changes)
+{
+    json_decref(changes->created);
+    json_decref(changes->updated);
+    json_decref(changes->destroyed);
+}
+
+HIDDEN json_t *jmap_changes_reply(struct jmap_changes *changes)
+{
+    json_t *res = json_object();
+    json_object_set_new(res, "oldState", jmap_fmtstate(changes->since_modseq));
+    json_object_set_new(res, "newState", jmap_fmtstate(changes->new_modseq));
+    json_object_set_new(res, "hasMoreChanges",
+            json_boolean(changes->has_more_changes));
+    json_object_set(res, "created", changes->created);
+    json_object_set(res, "updated", changes->updated);
+    json_object_set(res, "destroyed", changes->destroyed);
+    return res;
+}
+
+
+/* Foo/copy */
+
+HIDDEN void jmap_copy_parse(jmap_req_t *req, struct jmap_parser *parser,
+                            jmap_args_parse_cb args_parse, void *args_rock,
+                            struct jmap_copy *copy, json_t **err)
+{
+    json_t *jargs = req->args;
+
+    memset(copy, 0, sizeof(struct jmap_copy));
+    copy->blob_copy = !strcmp(req->method, "Blob/copy");
+    copy->create = copy->blob_copy ? json_array() : json_object();
+    copy->created = json_object();
+    copy->not_created = json_object();
+
+    const char *key;
+    json_t *arg;
+
+    json_object_foreach(jargs, key, arg) {
+        /* fromAccountId */
+        if (!strcmp(key, "fromAccountId")) {
+            if (json_is_string(arg)) {
+                copy->from_account_id = json_string_value(arg);
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "fromAccountId");
+            }
+        }
+
+        /* accountId */
+        else if (!strcmp(key, "accountId")) {
+            /* JMAP request parser already set it */
+            assert(req->accountid);
+            continue;
+        }
+
+        /* blobIds */
+        else if (copy->blob_copy &&
+                 !strcmp(key, "blobIds") && json_is_array(arg)) {
+            struct buf buf = BUF_INITIALIZER;
+            json_t *id;
+            size_t i;
+            json_array_foreach(arg, i, id) {
+                if (!json_is_string(id)) {
+                    buf_printf(&buf, "blobIds[%zu]", i);
+                    jmap_parser_invalid(parser, buf_cstring(&buf));
+                    buf_reset(&buf);
+                }
+                else json_array_append(copy->create, id);
+            }
+        }
+
+        /* create */
+        else if (!copy->blob_copy &&
+                 !strcmp(key, "create") && json_is_object(arg)) {
+            jmap_parser_push(parser, "create");
+            const char *creation_id;
+            json_t *obj;
+            json_object_foreach(arg, creation_id, obj) {
+                if (!json_is_object(obj)) {
+                    jmap_parser_invalid(parser, creation_id);
+                }
+                else if (!json_is_string(json_object_get(obj, "id"))) {
+                    jmap_parser_push(parser, creation_id);
+                    jmap_parser_invalid(parser, "id");
+                    jmap_parser_pop(parser);
+                }
+                else json_object_set(copy->create, creation_id, obj);
+            }
+            jmap_parser_pop(parser);
+        }
+
+        /* onSuccessDestroyOriginal */
+        else if (!copy->blob_copy && !strcmp(key, "onSuccessDestroyOriginal") &&
+                 json_is_boolean(arg)) {
+            copy->on_success_destroy_original = json_boolean_value(arg);
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser->invalid);
+    }
+
+    if (!req->accountid || !copy->from_account_id ||
+        !strcmp(req->accountid, copy->from_account_id)) {
+        *err = json_pack("{s:s s:[s,s]}", "type", "invalidArguments",
+                "arguments", "accountId", "fromAccountId");
+    }
+}
+
+
+HIDDEN void jmap_copy_fini(struct jmap_copy *copy)
+{
+    json_decref(copy->create);
+    json_decref(copy->created);
+    json_decref(copy->not_created);
+}
+
+HIDDEN json_t *jmap_copy_reply(struct jmap_copy *copy)
+{
+    json_t *res = json_object();
+    json_object_set_new(res, "fromAccountId",
+                        json_string(copy->from_account_id));
+    json_object_set(res, copy->blob_copy ? "copied" : "created",
+                    json_object_size(copy->created) ?
+                    copy->created : json_null());
+    json_object_set(res, copy->blob_copy ? "notCopied" : "notCreated",
+                    json_object_size(copy->not_created) ?
+                    copy->not_created : json_null());
+    return res;
+}
+
+
+/* Foo/query */
+
+HIDDEN jmap_filter *jmap_buildfilter(json_t *arg, jmap_buildfilter_cb *parse)
+{
+    jmap_filter *f = (jmap_filter *) xzmalloc(sizeof(struct jmap_filter));
+    int pe;
+    const char *val;
+    int iscond = 1;
+
+    /* operator */
+    pe = jmap_readprop(arg, "operator", 0 /*mandatory*/, NULL, "s", &val);
+    if (pe > 0) {
+        if (!strncmp("AND", val, 3)) {
+            f->op = JMAP_FILTER_OP_AND;
+        } else if (!strncmp("OR", val, 2)) {
+            f->op = JMAP_FILTER_OP_OR;
+        } else if (!strncmp("NOT", val, 3)) {
+            f->op = JMAP_FILTER_OP_NOT;
+        }
+    }
+    iscond = f->op == JMAP_FILTER_OP_NONE;
+
+    /* conditions */
+    json_t *conds = json_object_get(arg, "conditions");
+    if (conds && !iscond && json_array_size(conds)) {
+        size_t i, n_conditions = json_array_size(conds);
+        for (i = 0; i < n_conditions; i++) {
+            json_t *cond = json_array_get(conds, i);
+            ptrarray_push(&f->conditions, jmap_buildfilter(cond, parse));
+        }
+    }
+
+    if (iscond) {
+        ptrarray_push(&f->conditions, parse(arg));
+    }
+
+    return f;
+}
+
+HIDDEN int jmap_filter_match(jmap_filter *f,
+                             jmap_filtermatch_cb *match, void *rock)
+{
+    if (f->op == JMAP_FILTER_OP_NONE) {
+        return match(ptrarray_head(&f->conditions), rock);
+    } else {
+        int i;
+        for (i = 0; i < ptrarray_size(&f->conditions); i++) {
+            int m = jmap_filter_match(ptrarray_nth(&f->conditions, i), match, rock);
+            if (m && f->op == JMAP_FILTER_OP_OR) {
+                return 1;
+            } else if (m && f->op == JMAP_FILTER_OP_NOT) {
+                return 0;
+            } else if (!m && f->op == JMAP_FILTER_OP_AND) {
+                return 0;
+            }
+        }
+        return f->op == JMAP_FILTER_OP_AND || f->op == JMAP_FILTER_OP_NOT;
+    }
+}
+
+HIDDEN void jmap_filter_free(jmap_filter *f, jmap_filterfree_cb *freecond)
+{
+    void *cond;
+
+    while ((cond = ptrarray_pop(&f->conditions))) {
+        if (f->op == JMAP_FILTER_OP_NONE) {
+            if (freecond) freecond(cond);
+        }
+        else {
+            jmap_filter_free(cond, freecond);
+        }
+    }
+    ptrarray_fini(&f->conditions);
+    free(f);
+}
+
+HIDDEN void jmap_filter_parse(jmap_req_t *req, struct jmap_parser *parser,
+                              json_t *filter, json_t *unsupported,
+                              jmap_filter_parse_cb parse_condition, void *cond_rock,
+                              json_t **err)
+{
+    json_t *arg, *val;
+    const char *s;
+    size_t i;
+
+    if (err && *err) return;
+
+    if (!JNOTNULL(filter) || json_typeof(filter) != JSON_OBJECT) {
+        jmap_parser_invalid(parser, NULL);
+        return;
+    }
+    arg = json_object_get(filter, "operator");
+    if ((s = json_string_value(arg))) {
+        if (strcmp("AND", s) && strcmp("OR", s) && strcmp("NOT", s)) {
+            jmap_parser_invalid(parser, "operator");
+        }
+        arg = json_object_get(filter, "conditions");
+        if (!json_array_size(arg)) {
+            jmap_parser_invalid(parser, "conditions");
+        }
+        json_array_foreach(arg, i, val) {
+            jmap_parser_push_index(parser, "conditions", i, NULL);
+            jmap_filter_parse(req, parser, val, unsupported, parse_condition, cond_rock, err);
+            jmap_parser_pop(parser);
+        }
+    } else if (arg) {
+        jmap_parser_invalid(parser, "operator");
+    } else {
+        parse_condition(req, parser, filter, unsupported, cond_rock, err);
+    }
+}
+
+HIDDEN void jmap_comparator_parse(jmap_req_t *req, struct jmap_parser *parser,
+                                  json_t *jsort, json_t *unsupported,
+                                  jmap_comparator_parse_cb comp_cb, void *comp_rock,
+                                  json_t **err)
+{
+    if (!json_is_object(jsort)) {
+        jmap_parser_invalid(parser, NULL);
+        return;
+    }
+
+    struct jmap_comparator comp = { NULL, 0, NULL };
+
+    /* property */
+    json_t *val = json_object_get(jsort, "property");
+    comp.property = json_string_value(val);
+    if (!comp.property) {
+        jmap_parser_invalid(parser, "property");
+    }
+
+    /* isAscending */
+    comp.is_ascending = 1;
+    val = json_object_get(jsort, "isAscending");
+    if (JNOTNULL(val)) {
+        if (!json_is_boolean(val)) {
+            jmap_parser_invalid(parser, "isAscending");
+        }
+        comp.is_ascending = json_boolean_value(val);
+    }
+
+    /* collation */
+    val = json_object_get(jsort, "collation");
+    if (JNOTNULL(val) && !json_is_string(val)) {
+        jmap_parser_invalid(parser, "collation");
+    }
+    comp.collation = json_string_value(val);
+
+
+    if (comp.property && !comp_cb(req, &comp, comp_rock, err)) {
+        struct buf buf = BUF_INITIALIZER;
+        json_array_append_new(unsupported,
+                json_string(jmap_parser_path(parser, &buf)));
+        buf_free(&buf);
+    }
+}
+
+HIDDEN void jmap_query_parse(jmap_req_t *req, struct jmap_parser *parser,
+                             jmap_args_parse_cb args_parse, void *args_rock,
+                             jmap_filter_parse_cb filter_cb, void *filter_rock,
+                             jmap_comparator_parse_cb comp_cb, void *comp_rock,
+                             struct jmap_query *query, json_t **err)
+{
+    json_t *jargs = req->args;
+    const char *key;
+    json_t *arg, *val;
+    size_t i;
+
+    memset(query, 0, sizeof(struct jmap_query));
+    query->ids = json_array();
+
+    json_t *unsupported_filter = json_array();
+    json_t *unsupported_sort = json_array();
+
+    json_object_foreach(jargs, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        /* filter */
+        else if (!strcmp(key, "filter")) {
+            if (json_is_object(arg)) {
+                jmap_parser_push(parser, "filter");
+                jmap_filter_parse(req, parser, arg, unsupported_filter,
+                                  filter_cb, filter_rock, err);
+                jmap_parser_pop(parser);
+                query->filter = arg;
+                if (err && *err) {
+                    goto done;
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "filter");
+            }
+        }
+
+        /* sort */
+        else if (!strcmp(key, "sort")) {
+            if (json_is_array(arg)) {
+                json_array_foreach(arg, i, val) {
+                    jmap_parser_push_index(parser, "sort", i, NULL);
+                    jmap_comparator_parse(req, parser, val, unsupported_sort,
+                                          comp_cb, comp_rock, err);
+                    jmap_parser_pop(parser);
+                    if (err && *err) {
+                        goto done;
+                    }
+                }
+                if (json_array_size(arg)) {
+                    query->sort = arg;
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "sort");
+            }
+        }
+
+        else if (!strcmp(key, "position")) {
+            if (json_is_integer(arg)) {
+                query->position = json_integer_value(arg);
+            }
+            else if (arg) {
+                jmap_parser_invalid(parser, "position");
+            }
+        }
+
+        else if (!strcmp(key, "anchor")) {
+            if (json_is_string(arg)) {
+                query->anchor = json_string_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "anchor");
+            }
+        }
+
+        else if (!strcmp(key, "anchorOffset")) {
+            if (json_is_integer(arg)) {
+                query->anchor_offset = json_integer_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "anchorOffset");
+            }
+        }
+
+        else if (!strcmp(key, "limit")) {
+            if (json_is_integer(arg) && json_integer_value(arg) >= 0) {
+                query->limit = json_integer_value(arg);
+                query->have_limit = 1;
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "limit");
+            }
+        }
+
+        else if (!strcmp(key, "calculateTotal")) {
+            if (json_is_boolean(arg)) {
+                query->calculate_total = json_boolean_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "calculateTotal");
+            }
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser->invalid);
+    }
+    else if (json_array_size(unsupported_filter)) {
+        *err = json_pack("{s:s s:O}", "type", "unsupportedFilter",
+                         "filters", unsupported_filter);
+    }
+    else if (json_array_size(unsupported_sort)) {
+        *err = json_pack("{s:s s:O}", "type", "unsupportedSort",
+                         "sort", unsupported_sort);
+    }
+
+done:
+    json_decref(unsupported_filter);
+    json_decref(unsupported_sort);
+}
+
+HIDDEN void jmap_query_fini(struct jmap_query *query)
+{
+    free(query->query_state);
+    json_decref(query->ids);
+}
+
+HIDDEN json_t *jmap_query_reply(struct jmap_query *query)
+{
+
+    json_t *res = json_object();
+    json_object_set(res, "filter", query->filter);
+    json_object_set(res, "sort", query->sort);
+    json_object_set_new(res, "queryState", json_string(query->query_state));
+    json_object_set_new(res, "canCalculateChanges",
+                        json_boolean(query->can_calculate_changes));
+    json_object_set_new(res, "position", json_integer(query->result_position));
+    json_object_set_new(res, "total", json_integer(query->total));
+    /* Special case total */
+    if (query->position > 0 && query->total && query->total < SSIZE_MAX) {
+        if (query->position > (ssize_t) query->total) {
+            json_decref(query->ids);
+            query->ids = json_array();
+        }
+    }
+    /* Special case limit 0 */
+    if (query->have_limit && query->limit == 0) {
+        json_array_clear(query->ids);
+    }
+    /* Special case clamped limit */
+    if (query->server_limit) {
+        json_object_set_new(res, "limit", json_integer(query->server_limit));
+    }
+
+    json_object_set(res, "ids", query->ids);
+    return res;
+}
+
+
+/* Foo/queryChanges */
+
+HIDDEN void jmap_querychanges_parse(jmap_req_t *req,
+                                    struct jmap_parser *parser,
+                                    jmap_args_parse_cb args_parse, void *args_rock,
+                                    jmap_filter_parse_cb filter_cb, void *filter_rock,
+                                    jmap_comparator_parse_cb comp_cb, void *comp_rock,
+                                    struct jmap_querychanges *query,
+                                    json_t **err)
+{
+    json_t *jargs = req->args;
+    const char *key;
+    json_t *arg, *val;
+    size_t i;
+
+    memset(query, 0, sizeof(struct jmap_querychanges));
+    query->removed = json_array();
+    query->added = json_array();
+
+    json_t *unsupported_filter = json_array();
+    json_t *unsupported_sort = json_array();
+
+    json_object_foreach(jargs, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        /* filter */
+        else if (!strcmp(key, "filter")) {
+            if (json_is_object(arg)) {
+                jmap_parser_push(parser, "filter");
+                jmap_filter_parse(req, parser, arg, unsupported_filter,
+                                  filter_cb, filter_rock, err);
+                jmap_parser_pop(parser);
+                query->filter = arg;
+                if (err && *err) {
+                    goto done;
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "filter");
+            }
+        }
+
+        /* sort */
+        else if (!strcmp(key, "sort")) {
+            if (json_is_array(arg)) {
+                json_array_foreach(arg, i, val) {
+                    jmap_parser_push_index(parser, "sort", i, NULL);
+                    jmap_comparator_parse(req, parser, val, unsupported_sort,
+                                          comp_cb, comp_rock, err);
+                    jmap_parser_pop(parser);
+                }
+                if (json_array_size(arg)) {
+                    query->sort = arg;
+                }
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "sort");
+            }
+        }
+
+        /* sinceQueryState */
+        else if (!strcmp(key, "sinceQueryState")) {
+            if (json_is_string(arg)) {
+                query->since_querystate = json_string_value(arg);
+            } else {
+                jmap_parser_invalid(parser, "sinceQueryState");
+            }
+        }
+
+        /* maxChanges */
+        else if (!strcmp(key, "maxChanges")) {
+            if (json_is_integer(arg) && json_integer_value(arg) > 0) {
+                query->max_changes = json_integer_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "maxChanges");
+            }
+        }
+
+        /* upToId */
+        else if (!strcmp(key, "upToId")) {
+            if (json_is_string(arg)) {
+                query->up_to_id = json_string_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "upToId");
+            }
+        }
+
+        /* calculateTotal */
+        else if (!strcmp(key, "calculateTotal")) {
+            if (json_is_boolean(arg)) {
+                query->calculate_total = json_boolean_value(arg);
+            } else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(parser, "calculateTotal");
+            }
+        }
+
+        else if (!args_parse || !args_parse(req, parser, key, arg, args_rock)) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+
+    if (query->since_querystate == NULL) {
+        jmap_parser_invalid(parser, "sinceQueryState");
+    }
+
+    if (json_array_size(parser->invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                         "arguments", parser->invalid);
+    }
+    else if (json_array_size(unsupported_filter)) {
+        *err = json_pack("{s:s s:O}", "type", "unsupportedFilter",
+                         "filters", unsupported_filter);
+    }
+    else if (json_array_size(unsupported_sort)) {
+        *err = json_pack("{s:s s:O}", "type", "unsupportedSort",
+                         "sort", unsupported_sort);
+    }
+
+done:
+    json_decref(unsupported_filter);
+    json_decref(unsupported_sort);
+}
+
+HIDDEN void jmap_querychanges_fini(struct jmap_querychanges *query)
+{
+    free(query->new_querystate);
+    json_decref(query->removed);
+    json_decref(query->added);
+}
+
+HIDDEN json_t *jmap_querychanges_reply(struct jmap_querychanges *query)
+{
+    json_t *res = json_object();
+    json_object_set(res, "filter", query->filter);
+    json_object_set(res, "sort", query->sort);
+    json_object_set_new(res, "oldQueryState",
+                        json_string(query->since_querystate));
+    json_object_set_new(res, "newQueryState",
+                        json_string(query->new_querystate));
+    json_object_set_new(res, "upToId", query->up_to_id ?
+            json_string(query->up_to_id) : json_null());
+    json_object_set(res, "removed", query->removed);
+    json_object_set(res, "added", query->added);
+    json_object_set_new(res, "total", json_integer(query->total));
+    return res;
+}
+
+static json_t *_json_has(int rights, int need)
+{
+  return (((rights & need) == need) ? json_true() : json_false());
+}
+
+/* create, update, delete */
+#define WRITERIGHTS  (ACL_WRITE|ACL_INSERT|ACL_SETSEEN|ACL_DELETEMSG|ACL_EXPUNGE|ACL_ANNOTATEMSG)
+
+HIDDEN json_t *jmap_get_sharewith(const mbentry_t *mbentry)
+{
+    char *aclstr = xstrdupnull(mbentry->acl);
+    char *owner = mboxname_to_userid(mbentry->name);
+    int iscalendar = (mbentry->mbtype & MBTYPE_CALENDAR);
+
+    json_t *sharewith = json_null();
+
+    char *userid;
+    char *nextid;
+    for (userid = aclstr; userid; userid = nextid) {
+        int rights;
+        char *rightstr;
+
+        rightstr = strchr(userid, '\t');
+        if (!rightstr) break;
+        *rightstr++ = '\0';
+
+        nextid = strchr(rightstr, '\t');
+        if (!nextid) break;
+        *nextid++ = '\0';
+
+        cyrus_acl_strtomask(rightstr, &rights);
+
+        // skip system users and owner
+        if (is_system_user(userid)) continue;
+        if (!strcmp(userid, owner)) continue;
+
+        // we've got one! Create the object if this is the first
+        if (!JNOTNULL(sharewith))
+            sharewith = json_pack("{}");
+
+        json_t *obj = json_pack("{}");
+        json_object_set_new(sharewith, userid, obj);
+
+        if (iscalendar)
+            json_object_set_new(obj, "mayReadFreeBusy",
+                                _json_has(rights, DACL_READFB));
+        json_object_set_new(obj, "mayRead",
+                                _json_has(rights, ACL_READ|ACL_LOOKUP));
+        json_object_set_new(obj, "mayWrite",
+                                _json_has(rights, WRITERIGHTS));
+        json_object_set_new(obj, "mayAdmin",
+                                _json_has(rights, ACL_ADMIN));
+    }
+
+    free(aclstr);
+    free(owner);
+
+    return sharewith;
+}
+
+struct acl_item {
+    unsigned int mayAdmin:1;
+    unsigned int mayWrite:1;
+    unsigned int mayPost:1;
+    unsigned int mayRead:1;
+    unsigned int mayReadFreeBusy:1;
+};
+
+struct acl_change {
+    struct acl_item old;
+    struct acl_item new;
+};
+
+struct invite_rock {
+    xmlNodePtr notify;
+    xmlNsPtr ns[NUM_NAMESPACE];
+    const char *owner;
+    const char *mboxname;
+    struct buf resource;
+    struct request_target_t tgt;
+    const struct prop_entry *live_props;
+};
+
+static unsigned access_from_acl_item(struct acl_item *item)
+{
+    unsigned access = 0;
+
+    if (item->mayReadFreeBusy)
+        access |= DACL_READFB;
+    if (item->mayRead)
+        access |= ACL_READ|ACL_LOOKUP|ACL_SETSEEN;
+    if (item->mayWrite)
+        access |= WRITERIGHTS;
+    if (item->mayPost)
+        access |= ACL_POST;
+    if (item->mayAdmin)
+        access |= ACL_ADMIN|ACL_CREATE|ACL_DELETEMBOX;
+
+    return access;
+}
+
+/* Create and send a sharing invite */
+static void send_dav_invite(const char *userid, void *val, void *rock)
+{
+    struct acl_change *change = (struct acl_change *) val;
+    struct invite_rock *irock = (struct invite_rock *) rock;
+    long old = access_from_acl_item(&change->old);
+    long new = access_from_acl_item(&change->new);
+
+    if (old != new) {
+        int access, r = 0;
+
+        if (!new) access = SHARE_NONE;
+        else if (change->new.mayWrite) access = SHARE_READWRITE;
+        else access = SHARE_READONLY;
+
+        if (!old || !new) {
+            /* Change subscription */
+            r = mboxlist_changesub(irock->mboxname, userid, httpd_authstate,
+                                   access != SHARE_NONE, 0, /*notify*/1);
+        }
+
+        if (!r) {
+            static const char *displayname_annot =
+                DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+            struct buf buf = BUF_INITIALIZER;
+            r = annotatemore_lookupmask(irock->mboxname, displayname_annot,
+                                        irock->owner, &buf);
+            /* Fall back to last part of mailbox name */
+            if (r || !buf_len(&buf)) {
+                buf_setcstr(&buf, strrchr(irock->mboxname, '.') + 1);
+            }
+            r = dav_create_invite(&irock->notify, irock->ns, &irock->tgt,
+                                  irock->live_props, userid, access,
+                                  BAD_CAST buf_cstring(&buf));
+            buf_free(&buf);
+        }
+        if (!r) {
+            /* Create a resource name for the notifications -
+               We use a consistent naming scheme so that multiple
+               notifications of the same type for the same resource
+               are coalesced (overwritten) */
+            buf_reset(&irock->resource);
+            buf_printf(&irock->resource, "%x-%x-%x-%x.xml",
+                       strhash(XML_NS_DAV),
+                       strhash(SHARE_INVITE_NOTIFICATION),
+                       strhash(irock->tgt.mbentry->name),
+                       strhash(userid));
+
+            r = dav_send_notification(irock->notify->doc,
+                                      userid, buf_cstring(&irock->resource));
+        }
+    }
+}
+
+static void add_useracls(const char *userid, void *val, void *rock)
+{
+    struct acl_change *change = val;
+    char **aclptr = rock;
+
+    unsigned access = access_from_acl_item(&change->new);
+
+    if (access)
+        cyrus_acl_set(aclptr, userid, ACL_MODE_SET, access, NULL, NULL);
+}
+
+HIDDEN int jmap_set_sharewith(struct mailbox *mbox,
+                              json_t *shareWith, int overwrite)
+{
+    hash_table user_access = HASH_TABLE_INITIALIZER;
+    int isdav = (mbox->mbtype & MBTYPES_DAV);
+    int iscalendar = (mbox->mbtype & MBTYPE_CALENDAR);
+    char *owner = mboxname_to_userid(mbox->name);
+    char *acl = xstrdup(mbox->acl);
+    struct acl_change *change;
+    const char *userid;
+    json_t *rights;
+    int r;
+    char *newacl = xstrdup("");  /* start with empty ACL */
+
+    if (json_is_null(shareWith)) overwrite = 1;
+
+    construct_hash_table(&user_access, 64, 0);
+
+    /* parse the existing ACL and calculate the types of shares */
+    char *nextid = NULL;
+    for (userid = acl; userid; userid = nextid) {
+        char *rightstr;
+        int access;
+
+        rightstr = strchr(userid, '\t');
+        if (!rightstr) break;
+        *rightstr++ = '\0';
+
+        nextid = strchr(rightstr, '\t');
+        if (!nextid) break;
+        *nextid++ = '\0';
+
+        /* Is this a shareable user? (not owner or admin) */
+        if (strcmp(userid, owner) && !is_system_user(userid)) {
+            int oldrights;
+            cyrus_acl_strtomask(rightstr, &oldrights);
+
+            /* Add regular user to our table */
+            change = xzmalloc(sizeof(struct acl_change));
+
+            if (oldrights & DACL_READFB)
+                change->old.mayReadFreeBusy = 1;
+            if (oldrights & (ACL_READ|ACL_LOOKUP))
+                change->old.mayRead = 1;
+            if ((oldrights & WRITERIGHTS) == WRITERIGHTS)
+                change->old.mayWrite = 1;
+            if (oldrights & ACL_ADMIN)
+                change->old.mayAdmin = 1;
+            if (isdav) change->old.mayPost = change->old.mayWrite;
+
+            /* unless we're overwriting, we start with the existing state */
+            if (!overwrite) change->new = change->old;
+
+            hash_insert(userid, (void *) change, &user_access);
+        }
+        else {
+            /* Add owner or system user to new ACL */
+            cyrus_acl_strtomask(rightstr, &access);
+
+            r = cyrus_acl_set(&newacl, userid,
+                              ACL_MODE_SET, access, NULL, NULL);
+            if (r) {
+                syslog(LOG_ERR, "cyrus_acl_set(%s, %s) failed: %s",
+                       mbox->name, userid, error_message(r));
+                goto done;
+            }
+        }
+    }
+
+    /* Patch the ACL from shareWith */
+    json_object_foreach(shareWith, userid, rights) {
+        const char *right;
+        json_t *val;
+
+        /* Validate user id and rights */
+        if (!(strlen(userid) && rights &&
+              (json_is_object(rights) || json_is_null(rights)))) {
+            continue;
+        }
+
+        /* skip system users and owner */
+        if (is_system_user(userid)) continue;
+        if (!strcmp(userid, owner)) continue;
+
+        change = hash_lookup(userid, &user_access);
+        if (!change) {
+            change = xzmalloc(sizeof(struct acl_change));
+            hash_insert(userid, (void *) change, &user_access);
+        }
+
+        if (json_is_null(rights)) {
+            /* remove user from ACL */
+            struct acl_item zero = {0,0,0,0,0};
+            if (change) change->new = zero;
+        }
+        else {
+            /* accumulate rights be granted and denied */
+            json_object_foreach(rights, right, val) {
+                unsigned set = json_boolean_value(val);
+
+                if (!strcmp(right, "mayAdmin"))
+                    change->new.mayAdmin = set;
+                else if (!strcmp(right, "mayWrite"))
+                    change->new.mayWrite = set;
+                else if (!strcmp(right, "mayRead"))
+                    change->new.mayRead = set;
+                else if (iscalendar && !strcmp(right, "mayReadFreeBusy"))
+                    change->new.mayReadFreeBusy = set;
+            }
+            if (isdav) change->new.mayPost = change->new.mayWrite;
+        }
+    }
+
+    /* add all the users back to the share ACL */
+    hash_enumerate_sorted(&user_access, add_useracls, &newacl, cmpstringp_raw);
+
+    /* ok, change the mailboxes database */
+    r = mboxlist_sync_setacls(mbox->name, newacl, mailbox_modseq_dirty(mbox));
+    if (r) {
+        syslog(LOG_ERR, "mboxlist_sync_setacls(%s) failed: %s",
+               mbox->name, error_message(r));
+    }
+    else {
+        /* ok, change the backup in cyrus.header */
+        r = mailbox_set_acl(mbox, newacl);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_set_acl(%s) failed: %s",
+                   mbox->name, error_message(r));
+        }
+    }
+
+    if (!r && isdav) {
+        /* Send sharing invites */
+        struct invite_rock irock;
+        struct meth_params *pparams;
+        mbname_t *mbname;
+        const char *errstr = NULL;
+
+        memset(&irock, 0, sizeof(struct invite_rock));
+        irock.owner = owner;
+
+        /* Find the DAV namespace for this mailbox */
+        if (iscalendar)
+            irock.tgt.namespace = &namespace_calendar;
+        else if (mbox->mbtype & MBTYPE_ADDRESSBOOK)
+            irock.tgt.namespace = &namespace_addressbook;
+        else
+            irock.tgt.namespace = &namespace_drive;
+
+        /* Get "live" properties for the namespace */
+        pparams = irock.tgt.namespace->methods[METH_PROPFIND].params;
+        irock.live_props = pparams->propfind.lprops;
+
+        /* Create DAV URL for this collection */
+        mbname = mbname_from_intname(mbox->name);
+        if (!mbname_domain(mbname)) mbname_set_domain(mbname, httpd_extradomain);
+
+        make_collection_url(&irock.resource, irock.tgt.namespace->prefix,
+                            /*haszzzz*/0, mbname, mbname_userid(mbname));
+
+        /* Create a request target for this collection */
+        irock.tgt.flags = TGT_DAV_SHARED;  // prevent old-style sharing redirect
+        r = pparams->parse_path(buf_cstring(&irock.resource), &irock.tgt, &errstr);
+
+        if (!r) {
+            /* Process each user */
+            irock.mboxname = mbox->name;
+            hash_enumerate(&user_access, send_dav_invite, &irock);
+        }
+
+        /* Cleanup */
+        if (irock.notify) xmlFreeDoc(irock.notify->doc);
+        mboxlist_entry_free(&irock.tgt.mbentry);
+        free(irock.tgt.userid);
+        buf_free(&irock.resource);
+        mbname_free(&mbname);
+    }
+
+  done:
+    free_hash_table(&user_access, &free);
+    free(owner);
+    free(newacl);
+    free(acl);
+
+    return r;
+}
+
+HIDDEN void jmap_parse_sharewith_patch(json_t *arg, json_t **shareWith)
+{
+    struct buf buf = BUF_INITIALIZER;
+    const char *field = NULL;
+    json_t *jval;
+
+    json_object_foreach(arg, field, jval) {
+        if (!strncmp(field, "shareWith/", 10))  {
+            const char *userid = field + 10;
+            const char *right = strchr(userid, '/');
+
+            if (!*shareWith) *shareWith = json_object();
+
+            if (right) {
+                /* individual right */
+                buf_setmap(&buf, userid, right - userid);
+                userid = buf_cstring(&buf);
+
+                json_t *rights = json_object_get(*shareWith, userid);
+                if (rights) {
+                    /* add to existing ShareRights for this userid */
+                    json_object_set(rights, right+1, jval);
+                }
+                else {
+                    /* create new ShareRights for this userid */
+                    json_object_set_new(*shareWith, userid,
+                                        json_pack("{s:o}", right+1, jval));
+                }
+            }
+            else {
+                /* complete ShareRights */
+                json_object_set(*shareWith, userid, jval);
+            }
+        }
+    }
+
+    buf_free(&buf);
+}
+
+HIDDEN int jmap_is_using(jmap_req_t *req, const char *capa)
+{
+    return strarray_find(req->using_capabilities, capa, 0) >= 0;
+}
+
+/*
+ * Lookup 'name' in the mailbox list, ignoring reserved/deleted records
+ */
+HIDDEN int jmap_mboxlist_lookup(const char *name,
+                                mbentry_t **entryptr, struct txn **tid)
+{
+    mbentry_t *entry = NULL;
+    int r;
+
+    r = mboxlist_lookup_allow_all(name, &entry, tid);
+
+    if (r) return r;
+
+    /* Ignore "reserved" entries, like they aren't there */
+    if (entry->mbtype & MBTYPE_RESERVE) {
+        mboxlist_entry_free(&entry);
+        return IMAP_MAILBOX_RESERVED;
+    }
+
+    /* Ignore "deleted" entries, like they aren't there */
+    if (entry->mbtype & MBTYPE_DELETED) {
+        mboxlist_entry_free(&entry);
+        return IMAP_MAILBOX_NONEXISTENT;
+    }
+
+    if (entryptr) *entryptr = entry;
+    else mboxlist_entry_free(&entry);
+
+    return 0;
+}
+
+static int _mbentry_by_uniqueid_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct hash_table *hash = rock;
+    hash_insert(mbentry->uniqueid, mboxlist_entry_copy(mbentry), hash);
+    return 0;
+}
+
+EXPORTED const mbentry_t *jmap_mbentry_by_uniqueid(jmap_req_t *req, const char *id)
+{
+    if (!req->mbentry_byid) {
+        req->mbentry_byid = xzmalloc(sizeof(struct hash_table));
+        construct_hash_table(req->mbentry_byid, 1024, 0);
+        mboxlist_usermboxtree(req->accountid, req->authstate,
+                              _mbentry_by_uniqueid_cb, req->mbentry_byid,
+                              MBOXTREE_INTERMEDIATES);
+    }
+
+    return (const mbentry_t *)hash_lookup(id, req->mbentry_byid);
+}
+
+EXPORTED mbentry_t *jmap_mbentry_by_uniqueid_copy(jmap_req_t *req, const char *id)
+{
+    const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, id);
+    if (!mbentry) return NULL;
+    return mboxlist_entry_copy(mbentry);
+}
+
+static void _free_mbentry(void *rock)
+{
+    mbentry_t *entry = rock;
+    mboxlist_entry_free(&entry);
+}
+
+EXPORTED void jmap_mbentry_cache_free(jmap_req_t *req)
+{
+    if (req->mbentry_byid) {
+        free_hash_table(req->mbentry_byid, _free_mbentry);
+        free(req->mbentry_byid);
+        req->mbentry_byid = NULL;
+    }
+}
diff -pruN 3.0.13-5/imap/jmap_api.h 3.2.0-3/imap/jmap_api.h
--- 3.0.13-5/imap/jmap_api.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_api.h	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,484 @@
+/* http_api.h -- Routines for handling JMAP API requests
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef JMAP_API_H
+#define JMAP_API_H
+
+#include "auth.h"
+#include "conversations.h"
+#include "hash.h"
+#include "jmap_util.h"
+#include "json_support.h"
+#include "mailbox.h"
+#include "mboxname.h"
+#include "msgrecord.h"
+#include "ptrarray.h"
+#include "strarray.h"
+
+#define JMAP_URN_CORE       "urn:ietf:params:jmap:core"
+#define JMAP_URN_MAIL       "urn:ietf:params:jmap:mail"
+#define JMAP_URN_SUBMISSION "urn:ietf:params:jmap:submission"
+#define JMAP_URN_VACATION   "urn:ietf:params:jmap:vacationresponse"
+#define JMAP_URN_WEBSOCKET  "urn:ietf:params:jmap:websocket"
+
+#define JMAP_CONTACTS_EXTENSION      "https://cyrusimap.org/ns/jmap/contacts"
+#define JMAP_CALENDARS_EXTENSION     "https://cyrusimap.org/ns/jmap/calendars"
+#define JMAP_MAIL_EXTENSION          "https://cyrusimap.org/ns/jmap/mail"
+#define JMAP_PERFORMANCE_EXTENSION   "https://cyrusimap.org/ns/jmap/performance"
+#define JMAP_DEBUG_EXTENSION         "https://cyrusimap.org/ns/jmap/debug"
+#define JMAP_QUOTA_EXTENSION         "https://cyrusimap.org/ns/jmap/quota"
+#define JMAP_SEARCH_EXTENSION        "https://cyrusimap.org/ns/jmap/search"
+
+enum {
+    MAX_SIZE_REQUEST = 0,
+    MAX_CALLS_IN_REQUEST,
+    MAX_CONCURRENT_REQUESTS,
+    MAX_OBJECTS_IN_GET,
+    MAX_OBJECTS_IN_SET,
+    MAX_SIZE_UPLOAD,
+    MAX_CONCURRENT_UPLOAD,
+    JMAP_NUM_LIMITS  /* MUST be last */
+};
+
+typedef struct jmap_req {
+    const char           *method;
+    const char           *userid;
+    const char           *accountid;
+    struct conversations_state *cstate;
+    struct auth_state    *authstate;
+    json_t               *args;
+    json_t               *response;
+    const char           *tag;
+    struct transaction_t *txn;
+    struct mboxname_counters counters;
+
+    double real_start;
+    double user_start;
+    double sys_start;
+    json_t *perf_details;
+
+    /* The JMAP request keeps its own cache of opened mailboxes,
+     * which can be used by calling jmap_openmbox. If the
+     * force_openmboxrw is set, this causes all following
+     * mailboxes to be opened read-writeable, irrespective if
+     * the caller asked for a read-only lock. This allows to
+     * prevent lock promotion conflicts, in case a cached mailbox
+     * was opened read-only by a helper but it now asked to be
+     * locked exclusively. Since the mailbox lock does not
+     * support lock promition, this would currently abort with
+     * an error. */
+    int force_openmbox_rw;
+
+    /* Internal state */
+    ptrarray_t *mboxes;
+    hash_table *mboxrights;
+    hash_table *created_ids;
+    hash_table *mbentry_byid;
+    ptrarray_t *method_calls;
+    const strarray_t *using_capabilities;
+} jmap_req_t;
+
+/* Write the contents of the blob identified by blobid on the
+ * HTTP transaction embedded in JMAP request req.
+ * If not NULL, accept_mime defines the requested MIME type,
+ * either defined in the Accept header or {type} URI template
+ * parameter.
+ *
+ * Return HTTP_OK if the blob has been written or any other
+ * HTTP status on error.
+ * Return zero if the next blob handler should be called. */
+typedef int jmap_getblob_handler(jmap_req_t *req,
+                                 const char *blobid,
+                                 const char *accept_mime);
+
+typedef struct {
+    hash_table methods;
+    json_t *server_capabilities;
+    long limits[JMAP_NUM_LIMITS];
+    ptrarray_t getblob_handlers; // array of jmap_getblob_handler
+} jmap_settings_t;
+
+typedef struct {
+    const char *name;
+    const char *capability;
+    int (*proc)(struct jmap_req *req);
+    int flags;
+} jmap_method_t;
+
+extern int jmap_api(struct transaction_t *txn, json_t **res,
+                    jmap_settings_t *settings);
+
+extern int jmap_initreq(jmap_req_t *req);
+extern void jmap_finireq(jmap_req_t *req);
+
+extern int jmap_is_using(jmap_req_t *req, const char *capa);
+
+#define JMAP_SHARED_CSTATE 1 << 0
+
+/* Protocol implementations */
+extern void jmap_core_init(jmap_settings_t *settings);
+extern void jmap_mail_init(jmap_settings_t *settings);
+extern void jmap_contact_init(jmap_settings_t *settings);
+extern void jmap_calendar_init(jmap_settings_t *settings);
+extern void jmap_vacation_init(jmap_settings_t *settings);
+
+extern void jmap_core_capabilities(json_t *account_capabilities);
+extern void jmap_mail_capabilities(json_t *account_capabilities, int mayCreateTopLevel);
+extern void jmap_emailsubmission_capabilities(json_t *account_capabilities);
+extern void jmap_vacation_capabilities(json_t *account_capabilities);
+extern void jmap_contact_capabilities(json_t *account_capabilities);
+extern void jmap_calendar_capabilities(json_t *account_capabilities);
+extern void jmap_vacation_capabilities(json_t *account_capabilities);
+
+extern void jmap_accounts(json_t *accounts, json_t *primary_accounts);
+
+/* Request-scoped mailbox cache */
+extern int  jmap_openmbox(jmap_req_t *req, const char *name,
+                          struct mailbox **mboxp, int rw);
+extern int  jmap_isopenmbox(jmap_req_t *req, const char *name);
+extern void jmap_closembox(jmap_req_t *req, struct mailbox **mboxp);
+
+extern int jmap_mboxlist_lookup(const char *name,
+                                mbentry_t **entryptr, struct txn **tid);
+
+/* Adds a JMAP sub request to be processed after req has
+ * finished. Method must be a regular JMAP method name,
+ * args the JSON-encoded method arguments. If client_id
+ * is NULL, the subrequest will use the same client id
+ * as req. The args argument will be unreferenced after
+ * completion. */
+extern void jmap_add_subreq(jmap_req_t *req, const char *method,
+                            json_t *args, const char *client_id);
+
+/* Creation ids */
+extern const char *jmap_lookup_id(jmap_req_t *req, const char *creation_id);
+extern const char *jmap_id_string_value(jmap_req_t *req, json_t *item);
+extern void jmap_add_id(jmap_req_t *req, const char *creation_id, const char *id);
+extern int jmap_is_valid_id(const char *id);
+
+/* Request-scoped cache of mailbox rights for authenticated user */
+
+extern int  jmap_myrights(jmap_req_t *req, const mbentry_t *mbentry);
+extern int  jmap_hasrights(jmap_req_t *req, const mbentry_t *mbentry,
+                           int rights);
+extern int  jmap_myrights_byname(jmap_req_t *req, const char *mboxname);
+extern int  jmap_hasrights_byname(jmap_req_t *req, const char *mboxname,
+                                  int rights);
+extern void jmap_myrights_delete(jmap_req_t *req, const char *mboxname);
+
+/* Blob services */
+extern int jmap_findblob(jmap_req_t *req, const char *accountid,
+                         const char *blobid,
+                         struct mailbox **mbox, msgrecord_t **mr,
+                         struct body **body, const struct body **part,
+                         struct buf *blob);
+extern int jmap_findblob_exact(jmap_req_t *req, const char *accountid,
+                               const char *blobid,
+                               struct mailbox **mbox, msgrecord_t **mr);
+
+extern const struct body *jmap_contact_findblob(struct message_guid *content_guid,
+                                                const char *part_id,
+                                                struct mailbox *mbox,
+                                                msgrecord_t *mr,
+                                                struct buf *blob);
+
+#define JMAP_BLOBID_SIZE 42
+extern void jmap_set_blobid(const struct message_guid *guid, char *buf);
+
+#define JMAP_EMAILID_SIZE 26
+extern void jmap_set_emailid(const struct message_guid *guid, char *buf);
+
+#define JMAP_THREADID_SIZE 18
+extern void jmap_set_threadid(conversation_id_t cid, char *buf);
+
+/* JMAP states */
+extern json_t* jmap_getstate(jmap_req_t *req, int mbtype, int refresh);
+extern json_t *jmap_fmtstate(modseq_t modseq);
+extern int jmap_cmpstate(jmap_req_t *req, json_t *state, int mbtype);
+extern modseq_t jmap_highestmodseq(jmap_req_t *req, int mbtype);
+
+/* Helpers for DAV-based JMAP types */
+extern char *jmap_xhref(const char *mboxname, const char *resource);
+
+/* Patch-object support */
+
+extern void jmap_ok(jmap_req_t *req, json_t *res);
+extern void jmap_error(jmap_req_t *req, json_t *err);
+
+extern int jmap_parse_strings(json_t *arg,
+                              struct jmap_parser *parser, const char *prop);
+
+typedef struct jmap_property {
+    const char *name;
+    const char *capability;
+    unsigned flags;
+} jmap_property_t;
+
+enum {
+    JMAP_PROP_SERVER_SET = (1<<0),
+    JMAP_PROP_IMMUTABLE  = (1<<1),
+    JMAP_PROP_SKIP_GET   = (1<<2), // skip in Foo/get if not requested by client
+    JMAP_PROP_ALWAYS_GET = (1<<3)  // always include in Foo/get
+};
+
+extern const jmap_property_t *jmap_property_find(const char *name,
+                                                 const jmap_property_t props[]);
+
+
+/* Foo/get */
+
+struct jmap_get {
+    /* Request arguments */
+    json_t *ids;
+    json_t *properties;
+    hash_table *props;
+
+    /* Response fields */
+    char *state;
+    json_t *list;
+    json_t *not_found;
+};
+
+typedef int jmap_args_parse_cb(jmap_req_t *, struct jmap_parser *,
+                               const char *arg, json_t *val, void *);
+
+extern void jmap_get_parse(jmap_req_t *req, struct jmap_parser *parser,
+                           const jmap_property_t valid_props[],
+                           int allow_null_ids,
+                           jmap_args_parse_cb args_parse, void *args_rock,
+                           struct jmap_get *get,
+                           json_t **err);
+
+extern void jmap_get_fini(struct jmap_get *get);
+extern json_t *jmap_get_reply(struct jmap_get *get);
+
+
+/* Foo/set */
+
+struct jmap_set {
+    /* Request arguments */
+    const char *if_in_state;
+    json_t *create;
+    json_t *update;
+    json_t *destroy;
+
+    /* Response fields */
+    char *old_state;
+    char *new_state;
+    json_t *created;
+    json_t *updated;
+    json_t *destroyed;
+    json_t *not_created;
+    json_t *not_updated;
+    json_t *not_destroyed;
+};
+
+extern void jmap_set_parse(jmap_req_t *req, struct jmap_parser *parser,
+                           const jmap_property_t valid_props[],
+                           jmap_args_parse_cb args_parse, void *args_rock,
+                           struct jmap_set *set, json_t **err);
+extern void jmap_set_fini(struct jmap_set *set);
+extern json_t *jmap_set_reply(struct jmap_set *set);
+
+
+/* Foo/changes */
+
+struct jmap_changes {
+    /* Request arguments */
+    modseq_t since_modseq;
+    size_t max_changes;
+
+    /* Response fields */
+    modseq_t new_modseq;
+    short has_more_changes;
+    json_t *created;
+    json_t *updated;
+    json_t *destroyed;
+};
+
+extern void jmap_changes_parse(jmap_req_t *req, struct jmap_parser *parser,
+                               jmap_args_parse_cb args_parse, void *args_rock,
+                               struct jmap_changes *changes, json_t **err);
+extern void jmap_changes_fini(struct jmap_changes *changes);
+extern json_t *jmap_changes_reply(struct jmap_changes *changes);
+
+
+/* Foo/copy */
+
+struct jmap_copy {
+    /* Request arguments */
+    const char *from_account_id;
+    json_t *create;
+    int blob_copy;
+    int on_success_destroy_original;
+
+    /* Response fields */
+    json_t *created;
+    json_t *not_created;
+};
+
+extern void jmap_copy_parse(jmap_req_t *req, struct jmap_parser *parser,
+                            jmap_args_parse_cb args_parse, void *args_rock,
+                            struct jmap_copy *copy, json_t **err);
+extern void jmap_copy_fini(struct jmap_copy *copy);
+extern json_t *jmap_copy_reply(struct jmap_copy *copy);
+
+
+/* Foo/query */
+
+struct jmap_query {
+    /* Request arguments */
+    json_t *filter;
+    json_t *sort;
+    ssize_t position;
+    const char *anchor;
+    ssize_t anchor_offset;
+    size_t limit;
+    int have_limit;
+    int calculate_total;
+    int sort_savedate;
+
+    /* Response fields */
+    char *query_state;
+    int can_calculate_changes;
+    size_t result_position;
+    size_t server_limit;
+    size_t total;
+    json_t *ids;
+};
+
+enum jmap_filter_op   {
+    JMAP_FILTER_OP_NONE = 0,
+    JMAP_FILTER_OP_AND,
+    JMAP_FILTER_OP_OR,
+    JMAP_FILTER_OP_NOT
+};
+
+typedef struct jmap_filter {
+    enum jmap_filter_op op;
+    ptrarray_t conditions;
+} jmap_filter;
+
+typedef void* jmap_buildfilter_cb(json_t* arg);
+typedef int   jmap_filtermatch_cb(void* cond, void* rock);
+typedef void  jmap_filterfree_cb(void* cond);
+
+extern jmap_filter *jmap_buildfilter(json_t *arg, jmap_buildfilter_cb *parse);
+extern int jmap_filter_match(jmap_filter *f,
+                             jmap_filtermatch_cb *match, void *rock);
+extern void jmap_filter_free(jmap_filter *f, jmap_filterfree_cb *freecond);
+
+typedef void jmap_filter_parse_cb(jmap_req_t *req, struct jmap_parser *parser,
+                                  json_t *filter, json_t *unsupported,
+                                  void *rock, json_t **err);
+
+extern void jmap_filter_parse(jmap_req_t *req, struct jmap_parser *parser,
+                              json_t *filter, json_t *unsupported,
+                              jmap_filter_parse_cb parse_condition, void *cond_rock,
+                              json_t **err /* fatal, non-parsing error */);
+
+struct jmap_comparator {
+    const char *property;
+    short is_ascending;
+    const char *collation;
+};
+
+typedef int jmap_comparator_parse_cb(jmap_req_t *req, struct jmap_comparator *comp,
+                                     void *rock, json_t **err);
+
+extern void jmap_comparator_parse(jmap_req_t *req, struct jmap_parser *parser,
+                                  json_t *jsort, json_t *unsupported,
+                                  jmap_comparator_parse_cb comp_cb, void *comp_rock,
+                                  json_t **err);
+
+extern void jmap_query_parse(jmap_req_t *req, struct jmap_parser *parser,
+                             jmap_args_parse_cb args_parse, void *args_rock,
+                             jmap_filter_parse_cb filter_cb, void *filter_rock,
+                             jmap_comparator_parse_cb comp_cb, void *comp_rock,
+                             struct jmap_query *query, json_t **err);
+
+extern void jmap_query_fini(struct jmap_query *query);
+
+extern json_t *jmap_query_reply(struct jmap_query *query);
+
+
+/* Foo/queryChanges */
+
+struct jmap_querychanges {
+    /* Request arguments */
+    json_t *filter;
+    json_t *sort;
+    const char *since_querystate;
+    size_t max_changes;
+    const char *up_to_id;
+    int calculate_total;
+
+    /* Response fields */
+    char *new_querystate;
+    size_t total;
+    json_t *removed;
+    json_t *added;
+};
+
+extern void jmap_querychanges_parse(jmap_req_t *req,
+                                    struct jmap_parser *parser,
+                                    jmap_args_parse_cb args_parse, void *args_rock,
+                                    jmap_filter_parse_cb filter_cb, void *filter_rock,
+                                    jmap_comparator_parse_cb comp_cb, void *sort_rock,
+                                    struct jmap_querychanges *query,
+                                    json_t **err);
+
+extern void jmap_querychanges_fini(struct jmap_querychanges *query);
+
+extern json_t *jmap_querychanges_reply(struct jmap_querychanges *query);
+
+extern json_t *jmap_get_sharewith(const mbentry_t *mbentry);
+extern int jmap_set_sharewith(struct mailbox *mbox,
+                              json_t *shareWith, int overwrite);
+extern void jmap_parse_sharewith_patch(json_t *arg, json_t **shareWith);
+
+extern void jmap_mbentry_cache_free(jmap_req_t *req);
+extern const mbentry_t *jmap_mbentry_by_uniqueid(jmap_req_t *req, const char *id);
+extern mbentry_t *jmap_mbentry_by_uniqueid_copy(jmap_req_t *req, const char *id);
+
+#endif /* JMAP_API_H */
diff -pruN 3.0.13-5/imap/jmap_calendar.c 3.2.0-3/imap/jmap_calendar.c
--- 3.0.13-5/imap/jmap_calendar.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_calendar.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,4777 @@
+/* jmap_calendar.c -- Routines for handling JMAP calendar messages
+ *
+ * Copyright (c) 1994-2014 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <ctype.h>
+#include <errno.h>
+#include <assert.h>
+#include <string.h>
+#include <syslog.h>
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+#include "acl.h"
+#include "annotate.h"
+#include "caldav_db.h"
+#include "cyr_qsort_r.h"
+#include "global.h"
+#include "hash.h"
+#include "httpd.h"
+#include "http_caldav.h"
+#include "http_caldav_sched.h"
+#include "http_dav.h"
+#include "http_jmap.h"
+#include "http_proxy.h"
+#include "ical_support.h"
+#include "json_support.h"
+#include "jmap_ical.h"
+#include "search_query.h"
+#include "stristr.h"
+#include "times.h"
+#include "user.h"
+#include "util.h"
+#include "xmalloc.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+static int jmap_calendar_get(struct jmap_req *req);
+static int jmap_calendar_changes(struct jmap_req *req);
+static int jmap_calendar_set(struct jmap_req *req);
+static int jmap_calendarevent_get(struct jmap_req *req);
+static int jmap_calendarevent_changes(struct jmap_req *req);
+static int jmap_calendarevent_query(struct jmap_req *req);
+static int jmap_calendarevent_set(struct jmap_req *req);
+static int jmap_calendarevent_copy(struct jmap_req *req);
+
+static int jmap_calendarevent_getblob(jmap_req_t *req, const char *blobid,
+                                      const char *accept);
+
+#define JMAPCACHE_CALVERSION 19
+
+jmap_method_t jmap_calendar_methods_standard[] = {
+    // we have no standard for JMAP calendars yet!
+    { NULL, NULL, NULL, 0}
+};
+
+jmap_method_t jmap_calendar_methods_nonstandard[] = {
+    {
+        "Calendar/get",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendar_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Calendar/changes",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendar_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Calendar/set",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendar_set,
+        /*flags*/0
+    },
+    {
+        "CalendarEvent/get",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendarevent_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "CalendarEvent/changes",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendarevent_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "CalendarEvent/query",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendarevent_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "CalendarEvent/set",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendarevent_set,
+        /*flags*/0
+    },
+    {
+        "CalendarEvent/copy",
+        JMAP_CALENDARS_EXTENSION,
+        &jmap_calendarevent_copy,
+        /*flags*/0
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+HIDDEN void jmap_calendar_init(jmap_settings_t *settings)
+{
+    jmap_method_t *mp;
+
+    for (mp = jmap_calendar_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(settings->server_capabilities,
+                JMAP_CALENDARS_EXTENSION, json_object());
+
+        for (mp = jmap_calendar_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+
+    ptrarray_append(&settings->getblob_handlers, jmap_calendarevent_getblob);
+}
+
+HIDDEN void jmap_calendar_capabilities(json_t *account_capabilities)
+{
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(account_capabilities, JMAP_CALENDARS_EXTENSION, json_object());
+    }
+}
+
+/* Helper flags for CalendarEvent/set */
+#define JMAP_CREATE     (1<<0) /* Current request is a create. */
+#define JMAP_UPDATE     (1<<1) /* Current request is an update. */
+#define JMAP_DESTROY    (1<<2) /* Current request is a destroy. */
+
+/* Return a non-zero value if uid maps to a special-purpose calendar mailbox,
+ * that may not be read or modified by the user. */
+static int jmap_calendar_isspecial(mbname_t *mbname) {
+    if (!mboxname_iscalendarmailbox(mbname_intname(mbname), 0)) return 1;
+
+    const strarray_t *boxes = mbname_boxes(mbname);
+    const char *lastname = strarray_nth(boxes, boxes->count - 1);
+
+    /* Don't return user.foo.#calendars */
+    if (!strcmp(lastname, config_getstring(IMAPOPT_CALENDARPREFIX))) {
+        return 1;
+    }
+
+    /* SCHED_INBOX  and SCHED_OUTBOX end in "/", so trim them */
+    if (!strncmp(lastname, SCHED_INBOX, strlen(SCHED_INBOX)-1)) return 1;
+    if (!strncmp(lastname, SCHED_OUTBOX, strlen(SCHED_OUTBOX)-1)) return 1;
+    if (!strncmp(lastname, MANAGED_ATTACH, strlen(MANAGED_ATTACH)-1)) return 1;
+    return 0;
+}
+
+struct getcalendars_rock {
+    struct jmap_req *req;
+    struct jmap_get *get;
+    int skip_hidden;
+};
+
+static json_t *get_schedule_address_set(const char *userid,
+                                        const char *mboxname)
+{
+    struct buf attrib = BUF_INITIALIZER;
+    json_t *val = json_array();
+    static const char *annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
+    int r = annotatemore_lookupmask(mboxname, annot, httpd_userid, &attrib);
+    if (r || !attrib.len) {
+        // fetch from my own principal
+        char *prinmbox = mboxname_user_mbox(httpd_userid, "#calendars");
+        r = annotatemore_lookupmask(prinmbox, annot, httpd_userid, &attrib);
+        free(prinmbox);
+    }
+    if (!r && attrib.len) {
+        strarray_t *values = strarray_split(buf_cstring(&attrib), ",", STRARRAY_TRIM);
+        int i;
+        for (i = 0; i < strarray_size(values); i++) {
+            const char *item = strarray_nth(values, i);
+            if (!strncasecmp(item, "mailto:", 7)) item += 7;
+            char *value = strconcat("mailto:", item, NULL);
+            json_array_append_new(val, json_string(value));
+            free(value);
+        }
+        strarray_free(values);
+    }
+    else if (strchr(userid, '@')) {
+        char *value = strconcat("mailto:", userid, NULL);
+        json_array_append_new(val, json_string(value));
+        free(value);
+    }
+    else {
+        const char *domain = httpd_extradomain ? httpd_extradomain : config_defdomain;
+        char *value = strconcat("mailto:", userid, "@", domain, NULL);
+        json_array_append_new(val, json_string(value));
+        free(value);
+    }
+    buf_free(&attrib);
+    return val;
+}
+
+static int getcalendars_cb(const mbentry_t *mbentry, void *vrock)
+{
+    struct getcalendars_rock *rock = vrock;
+    mbname_t *mbname = NULL;
+    int r = 0;
+
+    /* Only calendars... */
+    if (!(mbentry->mbtype & MBTYPE_CALENDAR)) return 0;
+
+    /* ...which are at least readable or visible... */
+    if (!jmap_hasrights(rock->req, mbentry, DACL_READ))
+        return rock->skip_hidden ? 0 : IMAP_PERMISSION_DENIED;
+
+    // needed for some fields
+    int rights = jmap_myrights(rock->req, mbentry);
+
+    /* ...and contain VEVENTs. */
+    struct buf attrib = BUF_INITIALIZER;
+    static const char *calcompset_annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">supported-calendar-component-set";
+    unsigned long supported_components = -1; /* ALL component types by default. */
+    r = annotatemore_lookupmask(mbentry->name, calcompset_annot,
+                                rock->req->accountid, &attrib);
+    if (attrib.len) {
+        supported_components = strtoul(buf_cstring(&attrib), NULL, 10);
+        buf_free(&attrib);
+    }
+    if (!(supported_components & CAL_COMP_VEVENT)) {
+        goto done;
+    }
+
+    /* OK, we want this one... */
+    mbname = mbname_from_intname(mbentry->name);
+    /* ...unless it's one of the special names. */
+    if (jmap_calendar_isspecial(mbname)) {
+        r = 0;
+        goto done;
+    }
+
+    json_t *obj = json_pack("{}");
+
+    const strarray_t *boxes = mbname_boxes(mbname);
+    const char *id = strarray_nth(boxes, boxes->count-1);
+    json_object_set_new(obj, "id", json_string(id));
+
+    if (jmap_wantprop(rock->get->props, "x-href")) {
+        // XXX - should the x-ref for a shared calendar point
+        // to the authenticated user's calendar home?
+        char *xhref = jmap_xhref(mbentry->name, NULL);
+        json_object_set_new(obj, "x-href", json_string(xhref));
+        free(xhref);
+    }
+
+    if (jmap_wantprop(rock->get->props, "name")) {
+        buf_reset(&attrib);
+        static const char *displayname_annot =
+            DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+        r = annotatemore_lookupmask(mbentry->name, displayname_annot,
+                                    httpd_userid, &attrib);
+        /* fall back to last part of mailbox name */
+        if (r || !attrib.len) buf_setcstr(&attrib, id);
+        json_object_set_new(obj, "name", json_string(buf_cstring(&attrib)));
+        buf_free(&attrib);
+    }
+
+    if (jmap_wantprop(rock->get->props, "color")) {
+        struct buf attrib = BUF_INITIALIZER;
+        static const char *color_annot =
+            DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-color";
+        r = annotatemore_lookupmask(mbentry->name, color_annot,
+                                    httpd_userid, &attrib);
+        if (buf_len(&attrib))
+            json_object_set_new(obj, "color", json_string(buf_cstring(&attrib)));
+        buf_free(&attrib);
+    }
+
+    if (jmap_wantprop(rock->get->props, "sortOrder")) {
+        long sort_order = 0;
+        buf_reset(&attrib);
+        static const char *order_annot =
+            DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-order";
+        r = annotatemore_lookupmask(mbentry->name, order_annot,
+                                    httpd_userid, &attrib);
+        if (!r && attrib.len) {
+            char *ptr;
+            long val = strtol(buf_cstring(&attrib), &ptr, 10);
+            if (ptr && *ptr == '\0') {
+                sort_order = val;
+            }
+            else {
+                /* Ignore, but report non-numeric calendar-order values */
+                syslog(LOG_WARNING, "sortOrder: strtol(%s) failed",
+                       buf_cstring(&attrib));
+            }
+        }
+        json_object_set_new(obj, "sortOrder", json_integer(sort_order));
+        buf_free(&attrib);
+    }
+
+    if (jmap_wantprop(rock->get->props, "isVisible")) {
+        int is_visible = 1;
+        buf_reset(&attrib);
+        static const char *color_annot =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">X-FM-isVisible";
+        r = annotatemore_lookupmask(mbentry->name, color_annot,
+                                    httpd_userid, &attrib);
+        if (!r && attrib.len) {
+            const char *val = buf_cstring(&attrib);
+            if (!strncmp(val, "true", 4) || !strncmp(val, "1", 1)) {
+                is_visible = 1;
+            } else if (!strncmp(val, "false", 5) || !strncmp(val, "0", 1)) {
+                is_visible = 0;
+            } else {
+                /* Report invalid value and fall back to default. */
+                syslog(LOG_WARNING,
+                       "isVisible: invalid annotation value: %s", val);
+                is_visible = 1;
+            }
+        }
+        json_object_set_new(obj, "isVisible", json_boolean(is_visible));
+        buf_free(&attrib);
+    }
+
+    if (jmap_wantprop(rock->get->props, "isSubscribed")) {
+        int is_subscribed;
+        if (mboxname_userownsmailbox(httpd_userid, mbentry->name)) {
+            /* Users always subscribe their own calendars */
+            is_subscribed = 1;
+        }
+        else {
+            /* Lookup mailbox subscriptions */
+            is_subscribed = mboxlist_checksub(mbentry->name, httpd_userid) == 0;
+        }
+        json_object_set_new(obj, "isSubscribed", json_boolean(is_subscribed));
+    }
+
+    int writerights = DACL_WRITECONT|DACL_WRITEPROPS;
+
+    if (jmap_wantprop(rock->get->props, "mayReadFreeBusy")) {
+        json_object_set_new(obj, "mayReadFreeBusy",
+                            ((rights & DACL_READFB) == DACL_READFB) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayReadItems")) {
+        json_object_set_new(obj, "mayReadItems",
+                            ((rights & DACL_READ) == DACL_READ) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayAddItems")) {
+        json_object_set_new(obj, "mayAddItems",
+                            ((rights & writerights) == writerights) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayModifyItems")) {
+        json_object_set_new(obj, "mayModifyItems",
+                            ((rights & writerights) == writerights) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayRemoveItems")) {
+        json_object_set_new(obj, "mayRemoveItems",
+                            ((rights & DACL_RMRSRC) == DACL_RMRSRC) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayRename")) {
+        json_object_set_new(obj, "mayRename",
+                            ((rights & (DACL_RMCOL|DACL_MKCOL)) == (DACL_RMCOL|DACL_MKCOL)) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayDelete")) {
+        json_object_set_new(obj, "mayDelete",
+                            ((rights & DACL_RMCOL) == DACL_RMCOL) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "mayAdmin")) {
+        json_object_set_new(obj, "mayAdmin",
+                            ((rights & ACL_ADMIN) == ACL_ADMIN) ? json_true() : json_false());
+    }
+
+    if (jmap_wantprop(rock->get->props, "shareWith")) {
+        json_t *sharewith = jmap_get_sharewith(mbentry);
+        json_object_set_new(obj, "shareWith", sharewith);
+    }
+
+    if (jmap_wantprop(rock->get->props, "scheduleAddressSet")) {
+        json_t *set = get_schedule_address_set(rock->req->userid, mbentry->name);
+        json_object_set_new(obj, "scheduleAddressSet", set);
+    }
+
+    json_array_append_new(rock->get->list, obj);
+
+done:
+    buf_free(&attrib);
+    mbname_free(&mbname);
+    return r;
+}
+
+static const jmap_property_t calendar_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "name",
+        NULL,
+        0
+    },
+    {
+        "color",
+        NULL,
+        0
+    },
+    {
+        "sortOrder",
+        NULL,
+        0
+    },
+    {
+        "isVisible",
+        NULL,
+        0
+    },
+    {
+        "isSubscribed",
+        NULL,
+        0
+    },
+    {
+        "mayReadFreeBusy",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayReadItems",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayAddItems",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayModifyItems",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayRemoveItems",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayRename",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mayDelete",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+
+    /* FM extensions (do ALL of these get through to Cyrus?) */
+    {
+        "mayAdmin",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "syncedFrom",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+    {
+        "isEventsPublic",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+    {
+        "isFreeBusyPublic",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+    {
+        "eventsUrl",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "freeBusyUrl",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "calDavUrl",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "shareWith",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+    {
+        "x-href",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "scheduleAddressSet",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+
+    { NULL, NULL, 0 }
+};
+
+static int jmap_calendar_get(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+    int r = 0;
+
+    r = caldav_create_defaultcalendars(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        jmap_error(req, json_pack("{s:s}", "type", "accountNoCalendars"));
+        return 0;
+    } else if (r) return r;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, calendar_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build callback data */
+    struct getcalendars_rock rock = { req, &get, 1 /*skiphidden*/ };
+
+    /* Does the client request specific mailboxes? */
+    if (JNOTNULL(get.ids)) {
+        size_t i;
+        json_t *jval;
+
+        rock.skip_hidden = 0; /* complain about missing ACL rights */
+        json_array_foreach(get.ids, i, jval) {
+            const char *id = json_string_value(jval);
+            char *mboxname = caldav_mboxname(req->accountid, id);
+            mbentry_t *mbentry = NULL;
+
+            r = mboxlist_lookup(mboxname, &mbentry, NULL);
+            if (r == IMAP_NOTFOUND || !mbentry) {
+                json_array_append(get.not_found, jval);
+                r = 0;
+            }
+            else {
+                r = getcalendars_cb(mbentry, &rock);
+                if (r == IMAP_PERMISSION_DENIED) {
+                    json_array_append(get.not_found, jval);
+                    r = 0;
+                }
+            }
+
+            if (mbentry) mboxlist_entry_free(&mbentry);
+            free(mboxname);
+            if (r) goto done;
+        }
+    }
+    else {
+        // XXX: replace with a function which only looks inside INBOX.#calendars
+        r = mboxlist_usermboxtree(req->accountid, req->authstate, &getcalendars_cb, &rock, MBOXTREE_INTERMEDIATES);
+        if (r) goto done;
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return r;
+}
+
+struct calendarchanges_rock {
+    jmap_req_t *req;
+    struct jmap_changes *changes;
+};
+
+static int getcalendarchanges_cb(const mbentry_t *mbentry, void *vrock)
+{
+    struct calendarchanges_rock *rock = (struct calendarchanges_rock *) vrock;
+    mbname_t *mbname = NULL;
+    jmap_req_t *req = rock->req;
+    int r = 0;
+
+    /* Ignore old changes. */
+    if (mbentry->foldermodseq <= rock->changes->since_modseq) {
+        goto done;
+    }
+
+    /* Ignore any mailboxes that aren't (possibly deleted) calendars. */
+    if (!mboxname_iscalendarmailbox(mbentry->name, mbentry->mbtype))
+        return 0;
+
+    /* Ignore mailboxes that are hidden from us. */
+    /* XXX Deleted mailboxes loose their ACL so we can't determine
+     * if they ever could be read by the authenticated user. We
+     * need to leak these deleted entries to not mess up client state. */
+    if (!(mbentry->mbtype & MBTYPE_DELETED) || strcmpsafe(mbentry->acl, "")) {
+        if (!jmap_hasrights(req, mbentry, DACL_READ)) return 0;
+    }
+
+    /* Ignore special-purpose calendar mailboxes. */
+    mbname = mbname_from_intname(mbentry->name);
+    if (jmap_calendar_isspecial(mbname)) {
+        goto done;
+    }
+
+    /* Ignore calendars that don't store VEVENTs */
+    struct buf attrib = BUF_INITIALIZER;
+    static const char *calcompset_annot =
+        DAV_ANNOT_NS "<" XML_NS_CALDAV ">supported-calendar-component-set";
+    unsigned long supported_components = -1; /* ALL component types by default. */
+    r = annotatemore_lookupmask(mbentry->name, calcompset_annot,
+                                rock->req->accountid, &attrib);
+    if (attrib.len) {
+        supported_components = strtoul(buf_cstring(&attrib), NULL, 10);
+        buf_free(&attrib);
+    }
+    if (!(supported_components & CAL_COMP_VEVENT)) {
+        goto done;
+    }
+
+    const strarray_t *boxes = mbname_boxes(mbname);
+    const char *id = strarray_nth(boxes, boxes->count-1);
+
+    /* Report this calendar as created, updated or destroyed. */
+    if (mbentry->mbtype & MBTYPE_DELETED) {
+        if (mbentry->createdmodseq <= rock->changes->since_modseq)
+            json_array_append_new(rock->changes->destroyed, json_string(id));
+    }
+    else {
+        if (mbentry->createdmodseq <= rock->changes->since_modseq)
+            json_array_append_new(rock->changes->updated, json_string(id));
+        else
+            json_array_append_new(rock->changes->created, json_string(id));
+    }
+
+done:
+    mbname_free(&mbname);
+    return r;
+}
+
+static int jmap_calendar_changes(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+    json_t *err = NULL;
+    int r = 0;
+
+    r = caldav_create_defaultcalendars(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        jmap_error(req, json_pack("{s:s}", "type", "accountNoCalendars"));
+        return 0;
+    } else if (r) goto done;
+
+    /* Parse request */
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Lookup any changes. */
+    char *mboxname = caldav_mboxname(req->accountid, NULL);
+    struct calendarchanges_rock rock = { req, &changes };
+
+    r = mboxlist_mboxtree(mboxname, getcalendarchanges_cb, &rock,
+                          MBOXTREE_TOMBSTONES|MBOXTREE_SKIP_ROOT);
+    free(mboxname);
+    if (r) {
+        jmap_error(req, json_pack("{s:s}", "type", "cannotCalculateChanges"));
+        r = 0;
+        goto done;
+    }
+
+    /* Determine new state.  XXX  what about max_changes? */
+    changes.new_modseq = /*changes.has_more_changes ? rock.highestmodseq :*/
+        jmap_highestmodseq(req, MBTYPE_CALENDAR);
+
+    /* Build response */
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+  done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    if (r) {
+        jmap_error(req, jmap_server_error(r));
+    }
+    return 0;
+}
+
+/* jmap calendar APIs */
+
+struct setcalendar_props {
+    const char *name;
+    const char *color;
+    int sortOrder;
+    int isVisible;
+    int isSubscribed;
+    json_t *scheduleAddressSet;
+    struct {
+        json_t *With;
+        int overwrite_acl;
+    } share;
+    long comp_types;
+};              
+
+/* Update the calendar properties in the calendar mailbox named mboxname.
+ * NULL values and negative integers are ignored. Return 0 on success. */
+static int setcalendars_update(jmap_req_t *req,
+                               const char *mboxname,
+                               struct setcalendar_props *props)
+{
+    struct mailbox *mbox = NULL;
+    annotate_state_t *astate = NULL;
+    struct buf val = BUF_INITIALIZER;
+    int r;
+
+    if (!jmap_hasrights_byname(req, mboxname, DACL_READ))
+        return IMAP_MAILBOX_NONEXISTENT;
+
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r) {
+        syslog(LOG_ERR, "jmap_openmbox(req, %s) failed: %s",
+                mboxname, error_message(r));
+        return r;
+    }
+
+    r = mailbox_get_annotate_state(mbox, 0, &astate);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: failed to open annotations %s: %s",
+                mbox->name, error_message(r));
+    }
+    /* name */
+    if (!r && props->name) {
+        buf_setcstr(&val, props->name);
+        static const char *displayname_annot =
+            DAV_ANNOT_NS "<" XML_NS_DAV ">displayname";
+        r = annotate_state_writemask(astate, displayname_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    displayname_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+    /* color */
+    if (!r && props->color) {
+        buf_setcstr(&val, props->color);
+        static const char *color_annot =
+            DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-color";
+        r = annotate_state_writemask(astate, color_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    color_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+    /* sortOrder */
+    if (!r && props->sortOrder >= 0) {
+        buf_printf(&val, "%d", props->sortOrder);
+        static const char *sortOrder_annot =
+            DAV_ANNOT_NS "<" XML_NS_APPLE ">calendar-order";
+        r = annotate_state_writemask(astate, sortOrder_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    sortOrder_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+    /* isVisible */
+    if (!r && props->isVisible >= 0) {
+        buf_setcstr(&val, props->isVisible ? "true" : "false");
+        static const char *visible_annot =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">X-FM-isVisible";
+        r = annotate_state_writemask(astate, visible_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    visible_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+    /* scheduleAddressSet */
+    if (!r && json_is_array(props->scheduleAddressSet)) {
+        static const char *annot =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
+        strarray_t *array = strarray_new();
+        size_t i;
+        json_t *jval;
+        json_array_foreach(props->scheduleAddressSet, i, jval) {
+            strarray_add(array, json_string_value(jval));
+        }
+        char *joined = strarray_join(array, ",");
+        buf_setcstr(&val, joined);
+        r = annotate_state_writemask(astate, annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                   annot, error_message(r));
+        }
+        free(joined);
+        strarray_free(array);
+        buf_reset(&val);
+    }
+
+    /* isSubscribed */
+    if (!r && props->isSubscribed >= 0) {
+        /* Update subscription database */
+        r = mboxlist_changesub(mboxname, req->userid, req->authstate,
+                               props->isSubscribed, 0, /*notify*/1);
+
+        /* Set invite status for CalDAV */
+        buf_setcstr(&val, props->isSubscribed ? "invite-accepted" : "invite-declined");
+        static const char *invite_annot =
+            DAV_ANNOT_NS "<" XML_NS_DAV ">invite-status";
+        r = annotate_state_writemask(astate, invite_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    invite_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+    /* shareWith */
+    if (!r && props->share.With) {
+        r = jmap_set_sharewith(mbox,
+                               props->share.With, props->share.overwrite_acl);
+        if (!r) {
+            char *userid = mboxname_to_userid(mbox->name);
+            r = caldav_update_shareacls(userid);
+            free(userid);
+        }
+    }
+
+    /* supported components */
+    if (!r && props->comp_types >= 0) {
+        const char *comp_annot =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">supported-calendar-component-set";
+        buf_printf(&val, "%lu", (unsigned long) props->comp_types);
+        r = annotate_state_writemask(astate, comp_annot, req->userid, &val);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    comp_annot, error_message(r));
+        }
+        buf_reset(&val);
+    }
+
+    buf_free(&val);
+    if (r) {
+        mailbox_abort(mbox);
+    }
+    jmap_closembox(req, &mbox);
+    return r;
+}
+
+/* Delete the calendar mailbox named mboxname for the userid in req. */
+static int setcalendars_destroy(jmap_req_t *req, const char *mboxname)
+{
+    if (!jmap_hasrights_byname(req, mboxname, DACL_READ))
+        return IMAP_NOTFOUND;
+    if (!jmap_hasrights_byname(req, mboxname, DACL_RMCOL))
+        return IMAP_PERMISSION_DENIED;
+
+    char *userid = mboxname_to_userid(mboxname);
+    struct caldav_db *db = caldav_open_userid(userid);
+    if (!db) {
+        syslog(LOG_ERR, "caldav_open_mailbox failed for user %s", userid);
+        free(userid);
+        return IMAP_INTERNAL;
+    }
+    /* XXX 
+     * JMAP spec says that: "A calendar MAY be deleted that is currently
+     * associated with one or more events. In this case, the events belonging
+     * to this calendar MUST also be deleted. Conceptually, this MUST happen
+     * prior to the calendar itself being deleted, and MUST generate a push
+     * event that modifies the calendarState for the account, and has a
+     * clientId of null, to indicate that a change has been made to the
+     * calendar data not explicitly requested by the client."
+     *
+     * Need the Events API for this requirement.
+     */
+    int r = caldav_delmbox(db, mboxname);
+    if (r) {
+        syslog(LOG_ERR, "failed to delete mailbox from caldav_db: %s",
+                error_message(r));
+        free(userid);
+        return r;
+    }
+    jmap_myrights_delete(req, mboxname);
+
+    /* Remove from subscriptions db */
+    mboxlist_changesub(mboxname, req->userid, req->authstate, 0, 1, 0);
+
+    struct mboxevent *mboxevent = mboxevent_new(EVENT_MAILBOX_DELETE);
+    if (mboxlist_delayed_delete_isenabled()) {
+        r = mboxlist_delayed_deletemailbox(mboxname,
+                httpd_userisadmin || httpd_userisproxyadmin,
+                httpd_userid, req->authstate, mboxevent,
+                1 /* checkacl */, 0 /* local_only */, 0 /* force */,
+                0 /* keep_intermediaries */);
+    } else {
+        r = mboxlist_deletemailbox(mboxname,
+                httpd_userisadmin || httpd_userisproxyadmin,
+                httpd_userid, req->authstate, mboxevent,
+                1 /* checkacl */, 0 /* local_only */, 0 /* force */,
+                0 /* keep_intermediaries */);
+    }
+    mboxevent_free(&mboxevent);
+
+    if (!r) r = caldav_update_shareacls(userid);
+
+    int rr = caldav_close(db);
+    if (!r) r = rr;
+
+    free(userid);
+
+    return r;
+}
+
+static int jmap_calendar_set(struct jmap_req *req)
+{
+    struct mboxlock *namespacelock = user_namespacelock(req->accountid);
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+    json_t *err = NULL;
+    int r = 0;
+
+    /* Parse arguments */
+    jmap_set_parse(req, &parser, calendar_props, NULL, NULL, &set, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    if (set.if_in_state) {
+        /* TODO rewrite state function to use char* not json_t* */
+        json_t *jstate = json_string(set.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_CALENDAR)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            json_decref(jstate);
+            goto done;
+        }
+        json_decref(jstate);
+        set.old_state = xstrdup(set.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/0);
+        set.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+
+    r = caldav_create_defaultcalendars(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        json_t *err = json_pack("{s:s}", "type", "accountNoCalendars");
+        json_array_append_new(req->response, json_pack("[s,o,s]",
+                    "error", err, req->tag));
+        r = 0;
+        goto done;
+    }
+    if (r) {
+        goto done;
+    }
+
+    /* create */
+    const char *key;
+    json_t *arg, *record;
+    json_object_foreach(set.create, key, arg) {
+        /* Validate calendar id. */
+        if (!strlen(key)) {
+            json_t *err= json_pack("{s:s}", "type", "invalidArguments");
+            json_object_set_new(set.not_created, key, err);
+            continue;
+        }
+
+        /* Parse and validate properties. */
+        json_t *invalid = json_pack("[]"), *shareWith = NULL;
+        const char *name = NULL;
+        const char *color = NULL;
+        int32_t sortOrder = 0;
+        int isVisible = 1;
+        int isSubscribed = 1;
+        int pe; /* parse error */
+        short flag;
+        json_t *scheduleAddressSet = NULL;
+
+        /* Mandatory properties. */
+        pe = jmap_readprop(arg, "name", 1,  invalid, "s", &name);
+        if (pe > 0 && strnlen(name, 256) == 256) {
+            json_array_append_new(invalid, json_string("name"));
+        }
+
+        jmap_readprop(arg, "color", 0,  invalid, "s", &color);
+
+        pe = jmap_readprop(arg, "sortOrder", 0,  invalid, "i", &sortOrder);
+        if (pe > 0 && sortOrder < 0) {
+            json_array_append_new(invalid, json_string("sortOrder"));
+        }
+        jmap_readprop(arg, "isVisible", 0,  invalid, "b", &isVisible);
+        pe = jmap_readprop(arg, "isSubscribed", 0,  invalid, "b", &isSubscribed);
+        if (pe > 0 && !strcmp(req->accountid, req->userid)) {
+            if (!isSubscribed) {
+                /* XXX unsubscribing own calendars isn't supported */
+                json_array_append_new(invalid, json_string("isSubscribed"));
+            }
+            else {
+                isSubscribed = -1; // ignore
+            }
+        }
+
+        /* Optional properties. */
+        jmap_readprop(arg, "shareWith", 0,  invalid, "o", &shareWith);
+
+        jmap_readprop(arg, "scheduleAddressSet", 0,  invalid, "o", &scheduleAddressSet);
+
+        /* Optional properties. If present, these MUST be set to true. */
+        flag = 1; jmap_readprop(arg, "mayReadFreeBusy", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayReadFreeBusy"));
+        }
+        flag = 1; jmap_readprop(arg, "mayReadItems", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayReadItems"));
+        }
+        flag = 1; jmap_readprop(arg, "mayAddItems", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayAddItems"));
+        }
+        flag = 1; jmap_readprop(arg, "mayModifyItems", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayModifyItems"));
+        }
+        flag = 1; jmap_readprop(arg, "mayRemoveItems", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayRemoveItems"));
+        }
+        flag = 1; jmap_readprop(arg, "mayRename", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayRename"));
+        }
+        flag = 1; jmap_readprop(arg, "mayDelete", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayDelete"));
+        }
+        flag = 1; jmap_readprop(arg, "mayAdmin", 0,  invalid, "b", &flag);
+        if (!flag) {
+            json_array_append_new(invalid, json_string("mayAdmin"));
+        }
+
+        /* Report any property errors and bail out. */
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s, s:o}",
+                                    "type", "invalidProperties",
+                                    "properties", invalid);
+            json_object_set_new(set.not_created, key, err);
+            continue;
+        }
+        json_decref(invalid);
+
+        /* Make sure we are allowed to create the calendar */
+        char *parentname = caldav_mboxname(req->accountid, NULL);
+        mbentry_t *mbparent = NULL;
+        mboxlist_lookup(parentname, &mbparent, NULL);
+        free(parentname);
+        if (!jmap_hasrights(req, mbparent, DACL_MKCOL)) {
+            json_t *err = json_pack("{s:s}", "type", "accountReadOnly");
+            json_object_set_new(set.not_created, key, err);
+            mboxlist_entry_free(&mbparent);
+            continue;
+        }
+        mboxlist_entry_free(&mbparent);
+
+        /* Create the calendar */
+        char *uid = xstrdup(makeuuid());
+        char *mboxname = caldav_mboxname(req->accountid, uid);
+        r = mboxlist_createmailbox(mboxname, MBTYPE_CALENDAR,
+                                   NULL /* partition */,
+                                   httpd_userisadmin || httpd_userisproxyadmin,
+                                   httpd_userid, httpd_authstate,
+                                   /*localonly*/0, /*forceuser*/0,
+                                   /*dbonly*/0, /*notify*/0,
+                                   /*mailboxptr*/NULL);
+        if (r) {
+            syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                   mboxname, error_message(r));
+            if (r == IMAP_PERMISSION_DENIED) {
+                json_t *err = json_pack("{s:s}", "type", "accountReadOnly");
+                json_object_set_new(set.not_created, key, err);
+            }
+            free(mboxname);
+            goto done;
+        }
+        struct setcalendar_props props = {
+            name, color, sortOrder, isVisible, isSubscribed, scheduleAddressSet,
+            { shareWith, /*overwrite_acl*/ 1}, config_types_to_caldav_types()
+        };
+        r = setcalendars_update(req, mboxname, &props);
+        if (r) {
+            free(uid);
+            int rr = mboxlist_delete(mboxname);
+            if (rr) {
+                syslog(LOG_ERR, "could not delete mailbox %s: %s",
+                       mboxname, error_message(rr));
+            }
+            free(mboxname);
+            goto done;
+        }
+
+        /* Report calendar as created. */
+        record = json_pack("{s:s}", "id", uid);
+
+        /* Add additional properties */
+        if (jmap_is_using(req, JMAP_CALENDARS_EXTENSION)) {
+            json_t *addrset = get_schedule_address_set(req->userid, mboxname);
+            if (addrset) json_object_set_new(record, "scheduleAddressSet", addrset);
+        }
+
+        json_object_set_new(set.created, key, record);
+        jmap_add_id(req, key, uid);
+        free(uid);
+        free(mboxname);
+    }
+
+    /* update */
+    const char *uid;
+    json_object_foreach(set.update, uid, arg) {
+
+        /* Validate uid */
+        if (!uid) {
+            continue;
+        }
+        if (uid && uid[0] == '#') {
+            const char *newuid = jmap_lookup_id(req, uid + 1);
+            if (!newuid) {
+                json_t *err = json_pack("{s:s}", "type", "notFound");
+                json_object_set_new(set.not_updated, uid, err);
+                continue;
+            }
+            uid = newuid;
+        }
+
+        /* Parse and validate properties. */
+        json_t *invalid = json_pack("[]"), *shareWith = NULL;
+
+        char *mboxname = caldav_mboxname(req->accountid, uid);
+        const char *name = NULL;
+        const char *color = NULL;
+        int32_t sortOrder = -1;
+        int isVisible = -1;
+        int isSubscribed = -1;
+        int overwrite_acl = 1;
+        int flag;
+        json_t *scheduleAddressSet = NULL;
+        int pe = 0; /* parse error */
+        pe = jmap_readprop(arg, "name", 0,  invalid, "s", &name);
+        if (pe > 0 && strnlen(name, 256) == 256) {
+            json_array_append_new(invalid, json_string("name"));
+        }
+        jmap_readprop(arg, "color", 0,  invalid, "s", &color);
+        pe = jmap_readprop(arg, "sortOrder", 0,  invalid, "i", &sortOrder);
+        if (pe > 0 && sortOrder < 0) {
+            json_array_append_new(invalid, json_string("sortOrder"));
+        }
+        jmap_readprop(arg, "isVisible", 0,  invalid, "b", &isVisible);
+        pe = jmap_readprop(arg, "isSubscribed", 0,  invalid, "b", &isSubscribed);
+        if (pe > 0 && !strcmp(req->accountid, req->userid)) {
+            if (!isSubscribed) {
+                /* XXX unsubscribing own calendars isn't supported */
+                json_array_append_new(invalid, json_string("isSubscribed"));
+            }
+            else {
+                isSubscribed = -1; // ignore
+            }
+        }
+
+        /* Is shareWith overwritten or patched? */
+        jmap_parse_sharewith_patch(arg, &shareWith);
+        if (shareWith) {
+            overwrite_acl = 0;
+            json_object_set_new(arg, "shareWith", shareWith);
+        }
+        pe = jmap_readprop(arg, "shareWith", 0,  invalid, "o", &shareWith);
+        if (pe > 0 && !jmap_hasrights_byname(req, mboxname, ACL_ADMIN)) {
+            json_array_append_new(invalid, json_string("shareWith"));
+        }
+
+        jmap_readprop(arg, "scheduleAddressSet", 0,  invalid, "o", &scheduleAddressSet);
+
+        /* The mayFoo properties are immutable and MUST NOT set. */
+        pe = jmap_readprop(arg, "mayReadFreeBusy", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayReadFreeBusy"));
+        }
+        pe = jmap_readprop(arg, "mayReadItems", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayReadItems"));
+        }
+        pe = jmap_readprop(arg, "mayAddItems", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayAddItems"));
+        }
+        pe = jmap_readprop(arg, "mayModifyItems", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayModifyItems"));
+        }
+        pe = jmap_readprop(arg, "mayRemoveItems", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayRemoveItems"));
+        }
+        pe = jmap_readprop(arg, "mayRename", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayRename"));
+        }
+        pe = jmap_readprop(arg, "mayDelete", 0,  invalid, "b", &flag);
+        if (pe > 0) {
+            json_array_append_new(invalid, json_string("mayDelete"));
+        }
+
+        /* Report any property errors and bail out. */
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s, s:o}",
+                                    "type", "invalidProperties",
+                                    "properties", invalid);
+            json_object_set_new(set.not_updated, uid, err);
+            free(mboxname);
+            continue;
+        }
+        json_decref(invalid);
+
+        /* Make sure we don't mess up special calendars */
+        mbname_t *mbname = mbname_from_intname(mboxname);
+        if (!mbname || jmap_calendar_isspecial(mbname)) {
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_updated, uid, err);
+            mbname_free(&mbname);
+            free(mboxname);
+            continue;
+        }
+        mbname_free(&mbname);
+
+        /* Update the calendar */
+        struct setcalendar_props props = {
+            name, color, sortOrder, isVisible, isSubscribed, scheduleAddressSet,
+            { shareWith, overwrite_acl}, /*comp_types*/ -1
+        };
+        r = setcalendars_update(req, mboxname, &props);
+        free(mboxname);
+        if (r == IMAP_NOTFOUND || r == IMAP_MAILBOX_NONEXISTENT) {
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_updated, uid, err);
+            r = 0;
+            continue;
+        }
+        else if (r == IMAP_PERMISSION_DENIED) {
+            json_t *err = json_pack("{s:s}", "type", "accountReadOnly");
+            json_object_set_new(set.not_updated, uid, err);
+            r = 0;
+            continue;
+        }
+
+        /* Report calendar as updated. */
+        json_object_set_new(set.updated, uid, json_null());
+    }
+
+
+    /* destroy */
+    size_t index;
+    json_t *juid;
+
+    json_array_foreach(set.destroy, index, juid) {
+
+        /* Validate uid */
+        const char *uid = json_string_value(juid);
+        if (!uid) {
+            continue;
+        }
+        if (uid && uid[0] == '#') {
+            const char *newuid = jmap_lookup_id(req, uid + 1);
+            if (!newuid) {
+                json_t *err = json_pack("{s:s}", "type", "notFound");
+                json_object_set_new(set.not_destroyed, uid, err);
+                continue;
+            }
+            uid = newuid;
+        }
+
+        /* Do not allow to remove the default calendar. */
+        char *mboxname = caldav_mboxname(req->accountid, NULL);
+        static const char *defaultcal_annot =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">schedule-default-calendar";
+        struct buf attrib = BUF_INITIALIZER;
+        r = annotatemore_lookupmask(mboxname, defaultcal_annot,
+                                    req->accountid, &attrib);
+        free(mboxname);
+        const char *defaultcal = "Default";
+        if (!r && attrib.len) {
+            defaultcal = buf_cstring(&attrib);
+        }
+        if (!strcmp(uid, defaultcal)) {
+            /* XXX - The isDefault set error is not documented in the spec. */
+            json_t *err = json_pack("{s:s}", "type", "isDefault");
+            json_object_set_new(set.not_destroyed, uid, err);
+            buf_free(&attrib);
+            continue;
+        }
+        buf_free(&attrib);
+
+        /* Make sure we don't delete special calendars */
+        mboxname = caldav_mboxname(req->accountid, uid);
+        mbname_t *mbname = mbname_from_intname(mboxname);
+        if (!mbname || jmap_calendar_isspecial(mbname)) {
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_destroyed, uid, err);
+            mbname_free(&mbname);
+            free(mboxname);
+            continue;
+        }
+        mbname_free(&mbname);
+
+        /* Destroy calendar. */
+        r = setcalendars_destroy(req, mboxname);
+        free(mboxname);
+        if (r == IMAP_NOTFOUND || r == IMAP_MAILBOX_NONEXISTENT) {
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_destroyed, uid, err);
+            r = 0;
+            continue;
+        } else if (r == IMAP_PERMISSION_DENIED) {
+            json_t *err = json_pack("{s:s}", "type", "accountReadOnly");
+            json_object_set_new(set.not_destroyed, uid, err);
+            r = 0;
+            continue;
+        } else if (r) {
+            goto done;
+        }
+
+        /* Report calendar as destroyed. */
+        json_array_append_new(set.destroyed, json_string(uid));
+    }
+
+
+    // TODO refactor jmap_getstate to return a string, once
+    // all code has been migrated to the new JMAP parser.
+    json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/1);
+    set.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    jmap_ok(req, jmap_set_reply(&set));
+
+done:
+    mboxname_release(&namespacelock);
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    return r;
+}
+
+static const char *_encode_calendarevent_blobid(struct caldav_data *cdata,
+                                                const char *userid,
+                                                struct buf *dst)
+{
+    /* Set iCalendar smart blob prefix */
+    buf_putc(dst, 'I');
+
+    /* Encode iCalendar UID */
+    char *b64uid =
+        jmap_encode_base64_nopad(cdata->ical_uid, strlen(cdata->ical_uid));
+    if (!b64uid) {
+        buf_reset(dst);
+        return NULL;
+    }
+    buf_appendcstr(dst, b64uid);
+    free(b64uid);
+
+    /* Encode modseq */
+    buf_printf(dst, "-" MODSEQ_FMT, cdata->dav.modseq);
+
+    /* Encode user id */
+    if (userid) {
+        buf_putc(dst, '-');
+        char *b64userid = jmap_encode_base64_nopad(userid, strlen(userid));
+        if (!b64userid) {
+            buf_reset(dst);
+            return NULL;
+        }
+        buf_appendcstr(dst, b64userid);
+        free(b64userid);
+    }
+
+    return buf_cstring(dst);
+}
+
+static int _decode_calendarevent_blobid(const char *blobid,
+                                        char **uidptr,
+                                        modseq_t *modseqptr,
+                                        char **useridptr)
+{
+    char *uid = NULL;
+    modseq_t modseq = 0;
+    char *userid = NULL;
+    int is_valid = 0;
+
+    /* Decode iCalendar UID */
+    const char *base = blobid+1;
+    const char *p = strchr(base, '-');
+    if (!p) goto done;
+    uid = jmap_decode_base64_nopad(base, p-base);
+    if (!uid) goto done;
+    base = p + 1;
+
+    /* Decode modseq */
+    if (*base == '\0') goto done;
+    char *endptr = NULL;
+    errno = 0;
+    modseq = strtoull(base, &endptr, 10);
+    if (errno == ERANGE || (*endptr && *endptr != '-')) {
+        goto done;
+    }
+    base = endptr;
+
+    /* Decode userid */
+    if (*base == '-') {
+        base += 1;
+        size_t len = strlen(base);
+        if (len) {
+            userid = jmap_decode_base64_nopad(base, len);
+            if (!userid) goto done;
+        }
+        base += len;
+    }
+
+    /* All done */
+    *uidptr = uid;
+    *modseqptr = modseq;
+    *useridptr = userid;
+    is_valid = 1;
+
+done:
+    if (!is_valid) {
+        free(uid);
+        free(userid);
+    }
+    return is_valid;
+}
+
+
+struct calendarevent_getblob_rock {
+    jmap_req_t *req;
+    struct buf *buf;
+};
+
+static int _calendarevent_getblob_cb(const char *mailbox __attribute__((unused)),
+                                     uint32_t uid __attribute__((unused)),
+                                     const char *entry __attribute__((unused)),
+                                     const char *userid,
+                                     const struct buf *value,
+                                     const struct annotate_metadata *mdata __attribute__((unused)),
+                                     void *vrock)
+{
+    if (!buf_len(value)) return 0;
+
+    struct calendarevent_getblob_rock *rock = vrock;
+    jmap_req_t *req = rock->req;
+    struct buf *buf = rock->buf;
+
+    /* Parse the value and fetch the patch */
+    struct dlist *dl;
+    const char *vpatchstr = NULL;
+    dlist_parsemap(&dl, 1, 0, buf_base(value), buf_len(value));
+    dlist_getatom(dl, "VPATCH", &vpatchstr);
+    if (vpatchstr) buf_setcstr(buf, vpatchstr);
+    dlist_free(&dl);
+    if (!buf_len(buf)) return 0;
+
+    /* Write VPATCH blob */
+    char *part_headers = NULL;
+    if (userid) part_headers = strconcat("X-UserId: ", userid, "\r\n", NULL);
+    req->txn->resp_body.type = "text/calendar; component=VPATCH";
+    req->txn->resp_body.len = buf_len(buf);
+    write_multipart_body(0, req->txn, buf_base(buf), buf_len(buf), part_headers);
+    free(part_headers);
+
+    return 0;
+}
+
+static int jmap_calendarevent_getblob(jmap_req_t *req,
+                                      const char *blobid,
+                                      const char *accept_mime)
+{
+    struct caldav_db *db = NULL;
+    struct caldav_data *cdata = NULL;
+    struct mailbox *mailbox = NULL;
+    icalcomponent *ical = NULL;
+    char *uid = NULL;
+    char *userid = NULL;
+    modseq_t modseq;
+    struct buf buf = BUF_INITIALIZER;
+    int res = 0;
+    int r;
+
+    if (*blobid != 'I') return 0;
+
+    if (!_decode_calendarevent_blobid(blobid, &uid, &modseq, &userid)) {
+        res = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    /* Validate user id */
+    if ((userid && strcmp(userid, req->userid)) || (!userid && (!httpd_userisadmin))) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Lookup uid in CaldavDB */
+    db = caldav_open_userid(req->accountid);
+    if (!db) {
+        req->txn->error.desc = "no calendar db";
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+    if (caldav_lookup_uid(db, uid, &cdata)) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Validate modseq */
+    if (modseq != cdata->dav.modseq) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Open mailbox, we need it now */
+    if ((r = jmap_openmbox(req, cdata->dav.mailbox, &mailbox, 0))) {
+        req->txn->error.desc = error_message(r);
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Make sure client can handle blob type. */
+    if (accept_mime) {
+        if (userid) {
+            if (strcmp(accept_mime, "application/octet-stream") &&
+                strcmp(accept_mime, "text/calendar")) {
+                res = HTTP_NOT_ACCEPTABLE;
+                goto done;
+            }
+        }
+        else if (strcmp(accept_mime, "multipart/mixed")) {
+            res = HTTP_NOT_ACCEPTABLE;
+            goto done;
+        }
+    }
+
+    /* Load iCalendar data */
+    if (userid) {
+        /* Fetch ical resource with personalized data */
+        ical = caldav_record_to_ical(mailbox, cdata, req->userid, NULL);
+    }
+    else {
+        /* Fetch ical resource without personalized data */
+        struct index_record record;
+        if (!mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record)) {
+            ical = record_to_ical(mailbox, &record, NULL);
+        }
+    }
+    if (!ical) {
+        req->txn->error.desc = "failed to load record";
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Write blob to socket */
+    if (userid) {
+        /* Set Content headers */
+        if (accept_mime) {
+            if (strcmp(accept_mime, "application/octet-stream") &&
+                strcmp(accept_mime, "text/calendar")) {
+                res = HTTP_NOT_ACCEPTABLE;
+                goto done;
+            }
+        }
+        char *content_type = NULL;
+        if (!accept_mime || !strcmp(accept_mime, "text/calendar")) {
+            const char *comp_type = caldav_comp_type_as_string(cdata->comp_type);
+            if (comp_type) {
+                content_type = strconcat("text/calendar; component=", comp_type, NULL);
+                req->txn->resp_body.type = content_type;
+            }
+        }
+        if (!req->txn->resp_body.type) {
+            req->txn->resp_body.type = accept_mime;
+        }
+
+        /* Write body */
+        buf_setcstr(&buf, icalcomponent_as_ical_string(ical));
+        req->txn->resp_body.len = buf_len(&buf);
+        write_body(HTTP_OK, req->txn, buf_base(&buf), buf_len(&buf));
+        free(content_type);
+        res = HTTP_OK;
+    }
+    else {
+        /* Iniitialize multipart body */
+        if (accept_mime && strcmp(accept_mime, "multipart/mixed")) {
+            res = HTTP_NOT_ACCEPTABLE;
+            goto done;
+        }
+        req->txn->resp_body.type = "multipart/mixed";
+        write_multipart_body(HTTP_OK, req->txn, NULL, 0, NULL);
+
+        /* Set main component Content headers */
+        char *content_type = NULL;
+        const char *comp_type = caldav_comp_type_as_string(cdata->comp_type);
+        if (comp_type) {
+            content_type = strconcat("text/calendar; component=", comp_type, NULL);
+            req->txn->resp_body.type = content_type;
+        }
+        else req->txn->resp_body.type = "text/calendar";
+
+        /* Write main component body */
+        buf_setcstr(&buf, icalcomponent_as_ical_string(ical));
+        req->txn->resp_body.len = buf_len(&buf);
+        write_multipart_body(0, req->txn, buf_base(&buf), buf_len(&buf), NULL);
+
+        /* Write userdata parts */
+        struct calendarevent_getblob_rock rock = { req, &buf };
+        annotatemore_findall(cdata->dav.mailbox, cdata->dav.imap_uid,
+                             PER_USER_CAL_DATA, 0, _calendarevent_getblob_cb,
+                             &rock, 0);
+
+        write_multipart_body(0, req->txn, NULL, 0, NULL);
+
+        free(content_type);
+        res = HTTP_OK;
+    }
+
+done:
+    if (res != HTTP_OK && !req->txn->error.desc) {
+        const char *desc = NULL;
+        switch (res) {
+            case HTTP_BAD_REQUEST:
+                desc = "invalid calendar event blobid";
+                break;
+            case HTTP_NOT_FOUND:
+                desc = "failed to find blob by calendar blobid";
+                break;
+            default:
+                desc = error_message(res);
+        }
+        req->txn->error.desc = desc;
+    }
+    if (ical) icalcomponent_free(ical);
+    if (mailbox) jmap_closembox(req, &mailbox);
+    if (db) caldav_close(db);
+    buf_free(&buf);
+    free(userid);
+    free(uid);
+    return res;
+}
+
+struct event_id {
+    const char *raw; /* as requested by client */
+    char *uid;
+    char *recurid;
+};
+
+/* Return NULL if id is neither a simple UID or structured id */
+static struct event_id *parse_eventid(const char *id)
+{
+    struct event_id *eid = xzmalloc(sizeof(struct event_id));
+    const char *p;
+
+    if ((p = strchr(id, ';')) == NULL) {
+        eid->raw = id;
+        eid->uid = xstrdup(id);
+        return eid;
+    }
+    if (*p + 1 == '\0') {
+        free(eid);
+        return NULL;
+    }
+    eid->raw = id;
+    eid->uid = xstrndup(id, p - id);
+    eid->recurid = xstrdup(p + 1);
+
+    return eid;
+}
+
+static void free_eventid(struct event_id **eidptr)
+{
+    if (eidptr == NULL || *eidptr == NULL) return;
+
+    struct event_id *eid = *eidptr;
+    free(eid->uid);
+    free(eid->recurid);
+    free(eid);
+    *eidptr = NULL;
+}
+
+struct getcalendarevents_rock {
+    struct caldav_db *db;
+    struct jmap_req *req;
+    struct jmap_get *get;
+    struct mailbox *mailbox;
+    hashu64_table jmapcache;
+    ptrarray_t *want_eventids;
+    int check_acl;
+};
+
+struct recurid_instanceof_rock {
+    icaltimetype recurid;
+    int found;
+};
+
+static int _recurid_instanceof_cb(icalcomponent *comp __attribute__((unused)),
+                                  icaltimetype start,
+                                  icaltimetype end __attribute__((unused)),
+                                  void *vrock)
+{
+    struct recurid_instanceof_rock *rock = vrock;
+    int cmp = icaltime_compare(start, rock->recurid);
+    if (cmp == 0) {
+        rock->found = 1;
+    }
+    return cmp < 0;
+}
+
+static int _recurid_is_instanceof(icaltimetype recurid, icalcomponent *ical, int rrule_only)
+{
+    icaltimetype tstart = recurid;
+    icaltime_adjust(&tstart, -1, 0, 0, 0);
+    icaltimetype tend = recurid;
+    icaltime_adjust(&tend, 1, 0, 0, 0);
+    struct icalperiodtype timerange = {
+        tstart, tend, icaldurationtype_null_duration()
+    };
+    struct recurid_instanceof_rock rock = { recurid, 0 };
+    icalcomponent *mycomp = NULL;
+
+    if (rrule_only) {
+        if (icalcomponent_isa(ical) == ICAL_VCALENDAR_COMPONENT) {
+            /* Find the master component */
+            icalcomponent *comp = icalcomponent_get_first_real_component(ical);
+            icalcomponent_kind kind = icalcomponent_isa(comp);
+            icalcomponent *mastercomp = NULL;
+
+            for (; comp; comp = icalcomponent_get_next_component(ical, kind)) {
+                if (!icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY)) {
+                    mastercomp = comp;
+                    break;
+                }
+            }
+            if (!mastercomp) {
+                return 0;
+            }
+            ical = mastercomp;
+        }
+        if (icalcomponent_get_first_property(ical, ICAL_RDATE_PROPERTY)) {
+            /* Remove RDATEs */
+            mycomp = icalcomponent_clone(ical);
+            icalproperty *next;
+            icalproperty *prop = icalcomponent_get_first_property(mycomp, ICAL_RDATE_PROPERTY);
+            for ( ; prop; prop = next) {
+                next = icalcomponent_get_next_property(mycomp, ICAL_RDATE_PROPERTY);
+                icalcomponent_remove_property(mycomp, prop);
+                icalproperty_free(prop);
+            }
+            ical = mycomp;
+        }
+    }
+
+    icalcomponent_myforeach(ical, timerange, NULL, _recurid_instanceof_cb, &rock);
+    int found = rock.found;
+    if (mycomp) icalcomponent_free(mycomp);
+    return found;
+}
+
+static void getcalendarevents_filterinstance(json_t *myevent,
+                                             hash_table *props,
+                                             const char *id,
+                                             const char *ical_uid)
+{
+    json_object_del(myevent, "recurrenceOverrides");
+    json_object_del(myevent, "recurrenceRule");
+    jmap_filterprops(myevent, props);
+    json_object_set_new(myevent, "id", json_string(id));
+    json_object_set_new(myevent, "uid", json_string(ical_uid));
+    json_object_set_new(myevent, "@type", json_string("jsevent"));
+}
+
+static int getcalendarevents_getinstances(json_t *jsevent,
+                                           struct caldav_data *cdata,
+                                           icalcomponent *ical,
+                                           struct getcalendarevents_rock *rock)
+{
+    jmap_req_t *req = rock->req;
+    icalcomponent *myical = NULL;
+    int r = 0;
+
+    int i;
+    for (i = 0; i < ptrarray_size(rock->want_eventids); i++) {
+        struct event_id *eid = ptrarray_nth(rock->want_eventids, i);
+
+        if (eid->recurid == NULL) {
+            /* Client requested main event */
+            json_t *myevent = json_deep_copy(jsevent);
+            jmap_filterprops(myevent, rock->get->props);
+            json_object_set_new(myevent, "id", json_string(cdata->ical_uid));
+            json_object_set_new(myevent, "uid", json_string(cdata->ical_uid));
+            json_object_set_new(myevent, "@type", json_string("jsevent"));
+            json_array_append_new(rock->get->list, myevent);
+            continue;
+        }
+
+        /* Client requested event recurrence instance */
+        json_t *override = json_object_get(
+                json_object_get(jsevent, "recurrenceOverrides"), eid->recurid);
+        if (override) {
+            if (json_object_get(override, "excluded") != json_true()) {
+                /* Instance is a recurrence override */
+                json_t *myevent = jmap_patchobject_apply(jsevent, override, NULL);
+                getcalendarevents_filterinstance(myevent, rock->get->props, eid->raw, cdata->ical_uid);
+                if (json_object_get(override, "start") == NULL) {
+                    json_object_set_new(myevent, "start", json_string(eid->recurid));
+                }
+                json_object_set_new(myevent, "recurrenceId", json_string(eid->recurid));
+                json_array_append_new(rock->get->list, myevent);
+            }
+            else {
+                /* Instance is excluded */
+                json_array_append_new(rock->get->not_found, json_string(eid->raw));
+            }
+        }
+        else {
+            /* Check if RRULE generates an instance at this timestamp */
+            if (!ical) {
+                /* Open calendar mailbox. */
+                if (!rock->mailbox || strcmp(rock->mailbox->name, cdata->dav.mailbox)) {
+                    jmap_closembox(req, &rock->mailbox);
+                    r = jmap_openmbox(req, cdata->dav.mailbox, &rock->mailbox, 0);
+                    if (r) goto done;
+                }
+                myical = caldav_record_to_ical(rock->mailbox, cdata, httpd_userid, NULL);
+                if (!myical) {
+                    syslog(LOG_ERR, "caldav_record_to_ical failed for record %u:%s",
+                            cdata->dav.imap_uid, rock->mailbox->name);
+                    json_array_append_new(rock->get->not_found, json_string(eid->raw));
+                    continue;
+                }
+                else ical = myical;
+            }
+            struct jmapical_datetime timestamp = JMAPICAL_DATETIME_INITIALIZER;
+            if (jmapical_localdatetime_from_string(eid->recurid, &timestamp) < 0) {
+                json_array_append_new(rock->get->not_found, json_string(eid->raw));
+                continue;
+            }
+            icaltimetype icalrecurid = jmapical_datetime_to_icaltime(&timestamp, NULL);
+            if (!_recurid_is_instanceof(icalrecurid, ical, 1/*rrule_only*/)) {
+                json_array_append_new(rock->get->not_found, json_string(eid->raw));
+                continue;
+            }
+
+            /* Build instance */
+            struct buf buf = BUF_INITIALIZER;
+            jmapical_localdatetime_as_string(&timestamp, &buf);
+            json_t *jstart = json_string(buf_cstring(&buf));
+            buf_free(&buf);
+
+            json_t *myevent = json_deep_copy(jsevent);
+            getcalendarevents_filterinstance(myevent, rock->get->props, eid->raw, cdata->ical_uid);
+            json_object_set_new(myevent, "start", jstart);
+            json_object_set_new(myevent, "recurrenceId", json_string(eid->recurid));
+            json_array_append_new(rock->get->list, myevent);
+        }
+    }
+
+done:
+    if (myical) icalcomponent_free(myical);
+    return r;
+}
+
+static int getcalendarevents_cb(void *vrock, struct caldav_data *cdata)
+{
+    struct getcalendarevents_rock *rock = vrock;
+    int r = 0;
+    icalcomponent* ical = NULL;
+    json_t *jsevent = NULL;
+    jmap_req_t *req = rock->req;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+
+    if (!cdata->dav.alive)
+        return 0;
+
+    /* Check component type and ACL */
+    if (cdata->comp_type != CAL_COMP_VEVENT ||
+       !jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        return 0;
+    }
+
+    if (cdata->jmapversion == JMAPCACHE_CALVERSION) {
+        json_error_t jerr;
+        jsevent = json_loads(cdata->jmapdata, 0, &jerr);
+        if (jsevent) goto gotevent;
+    }
+
+    /* Open calendar mailbox. */
+    if (!rock->mailbox || strcmp(rock->mailbox->name, cdata->dav.mailbox)) {
+        jmap_closembox(req, &rock->mailbox);
+        r = jmap_openmbox(req, cdata->dav.mailbox, &rock->mailbox, 0);
+        if (r) goto done;
+    }
+
+    /* Load message containing the resource and parse iCal data */
+    ical = caldav_record_to_ical(rock->mailbox, cdata, httpd_userid, &schedule_addresses);
+    if (!ical) {
+        syslog(LOG_ERR, "caldav_record_to_ical failed for record %u:%s",
+                cdata->dav.imap_uid, rock->mailbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Convert to JMAP */
+    jsevent = jmapical_tojmap(ical, NULL);
+    if (!jsevent) {
+        syslog(LOG_ERR, "jmapical_tojson: can't convert %u:%s",
+                cdata->dav.imap_uid, rock->mailbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+    icalcomponent_free(ical);
+    ical = NULL;
+
+    /* Add participant id */
+    const char *participant_id = NULL;
+    int i;
+    for (i = 0; i < strarray_size(&schedule_addresses); i++) {
+        const char *test = strarray_nth(&schedule_addresses, i);
+        if (!strncasecmp(test, "mailto:", 7)) test += 7;
+        const char *key;
+        json_t *participant;
+        json_object_foreach(json_object_get(jsevent, "participants"), key, participant) {
+            const char *email = json_string_value(json_object_get(participant, "email"));
+            if (!email) continue;
+            if (!strncasecmp(email, "mailto:", 7)) email += 7;
+            if (!strcasecmp(email, test)) {
+                participant_id = key;
+                break;
+            }
+        }
+        if (participant_id) break;
+    }
+    json_object_set_new(jsevent, "participantId", participant_id ?
+            json_string(participant_id) : json_null());
+
+    /* Add to cache */
+    hashu64_insert(cdata->dav.rowid, json_dumps(jsevent, 0), &rock->jmapcache);
+
+gotevent:
+
+    /* Add JMAP-only fields. */
+    if (jmap_wantprop(rock->get->props, "x-href")) {
+        char *xhref = jmap_xhref(cdata->dav.mailbox, cdata->dav.resource);
+        json_object_set_new(jsevent, "x-href", json_string(xhref));
+        free(xhref);
+    }
+    if (jmap_wantprop(rock->get->props, "calendarId")) {
+        json_object_set_new(jsevent, "calendarId",
+                            json_string(strrchr(cdata->dav.mailbox, '.')+1));
+    }
+    if (jmap_wantprop(rock->get->props, "blobId")) {
+        json_t *jblobid = json_null();
+        struct buf blobid = BUF_INITIALIZER;
+        if (_encode_calendarevent_blobid(cdata, req->userid, &blobid)) {
+            jblobid = json_string(buf_cstring(&blobid));
+        }
+        buf_free(&blobid);
+        json_object_set_new(jsevent, "blobId", jblobid);
+    }
+    if (jmap_wantprop(rock->get->props, "debugBlobId")) {
+        json_t *jblobid = json_null();
+        if (httpd_userisadmin) {
+            struct buf blobid = BUF_INITIALIZER;
+            if (_encode_calendarevent_blobid(cdata, NULL, &blobid)) {
+                jblobid = json_string(buf_cstring(&blobid));
+            }
+            buf_free(&blobid);
+        }
+        json_object_set_new(jsevent, "debugBlobId", jblobid);
+    }
+
+    if (rock->want_eventids == NULL) {
+        /* Client requested all events */
+        jmap_filterprops(jsevent, rock->get->props);
+        json_object_set_new(jsevent, "id", json_string(cdata->ical_uid));
+        json_object_set_new(jsevent, "uid", json_string(cdata->ical_uid));
+        json_object_set_new(jsevent, "@type", json_string("jsevent"));
+        json_array_append_new(rock->get->list, jsevent);
+    }
+    else {
+        /* Client requested specific event ids */
+        r = getcalendarevents_getinstances(jsevent, cdata, ical, rock);
+        json_decref(jsevent);
+        if (r) goto done;
+    }
+
+done:
+    strarray_fini(&schedule_addresses);
+    if (ical) icalcomponent_free(ical);
+    return r;
+}
+
+static const jmap_property_t event_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "calendarId",
+        NULL,
+        0
+    },
+    {
+        "participantId",
+        NULL,
+        0
+    },
+
+    /* JSCalendar common properties */
+    {
+        "@type",
+        NULL,
+        0
+    },
+    {
+        "uid",
+        NULL,
+        0
+    },
+    {
+        "relatedTo",
+        NULL,
+        0
+    },
+    {
+        "prodId",
+        NULL,
+        0
+    },
+    {
+        "created",
+        NULL,
+        0
+    },
+    {
+        "updated",
+        NULL,
+        0
+    },
+    {
+        "sequence",
+        NULL,
+        0
+    },
+    {
+        "method",
+        NULL,
+        0
+    },
+    {
+        "title",
+        NULL,
+        0
+    },
+    {
+        "description",
+        NULL,
+        0
+    },
+    {
+        "descriptionContentType",
+        NULL,
+        0
+    },
+    {
+        "locations",
+        NULL,
+        0
+    },
+    {
+        "virtualLocations",
+        NULL,
+        0
+    },
+    {
+        "links",
+        NULL,
+        0
+    },
+    {
+        "locale",
+        NULL,
+        0
+    },
+    {
+        "keywords",
+        NULL,
+        0
+    },
+    {
+        "categories",
+        NULL,
+        0
+    },
+    {
+        "color",
+        NULL,
+        0
+    },
+    {
+        "recurrenceId",
+        NULL,
+        0
+    },
+    {
+        "recurrenceRule",
+        NULL,
+        0
+    },
+    {
+        "recurrenceOverrides",
+        NULL,
+        0
+    },
+    {
+        "excluded",
+        NULL,
+        0
+    },
+    {
+        "priority",
+        NULL,
+        0
+    },
+    {
+        "freeBusyStatus",
+        NULL,
+        0
+    },
+    {
+        "privacy",
+        NULL,
+        0
+    },
+    {
+        "replyTo",
+        NULL,
+        0
+    },
+    {
+        "participants",
+        NULL,
+        0
+    },
+    {
+        "useDefaultAlerts",
+        NULL,
+        0
+    },
+    {
+        "alerts",
+        NULL,
+        0
+    },
+    {
+        "localizations",
+        NULL,
+        0
+    },
+
+    /* JSEvent properties */
+    {
+        "start",
+        NULL,
+        0
+    },
+    {
+        "timeZone",
+        NULL,
+        0
+    },
+    {
+        "duration",
+        NULL,
+        0
+    },
+    {
+        "showWithoutTime",
+        NULL,
+        0
+    },
+    {
+        "status",
+        NULL,
+        0
+    },
+
+    /* FM specific */
+    {
+        "x-href",
+        JMAP_CALENDARS_EXTENSION,
+        0
+    },
+    {
+        "blobId",
+        JMAP_CALENDARS_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_SKIP_GET
+    },
+    {
+        "debugBlobId",
+        JMAP_DEBUG_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_SKIP_GET
+    },
+    { NULL, NULL, 0 }
+};
+
+static void cachecalendarevents_cb(uint64_t rowid, void *payload, void *vrock)
+{
+    const char *eventrep = payload;
+    struct getcalendarevents_rock *rock = vrock;
+
+    // there's no way to return errors, but luckily it doesn't matter if we
+    // fail to cache
+    caldav_write_jmapcache(rock->db, rowid, httpd_userid,
+                           JMAPCACHE_CALVERSION, eventrep);
+}
+
+static int jmap_calendarevent_get(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    struct caldav_db *db = NULL;
+    json_t *err = NULL;
+    int r = 0;
+
+    r = caldav_create_defaultcalendars(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        jmap_error(req, json_pack("{s:s}", "type", "accountNoCalendars"));
+        return 0;
+    } else if (r) return r;
+
+    /* Build callback data */
+    int checkacl = strcmp(req->accountid, req->userid);
+    struct getcalendarevents_rock rock = { NULL /* db */,
+                                           req, &get,
+                                           NULL /* mbox */,
+                                           HASHU64_TABLE_INITIALIZER, /* cache */
+                                           NULL, /* want_eventids */
+                                           checkacl };
+
+    construct_hashu64_table(&rock.jmapcache, 512, 0);
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, event_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    rock.db = db = caldav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR,
+               "caldav_open_mailbox failed for user %s", req->accountid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Does the client request specific events? */
+    if (json_array_size(get.ids)) {
+        size_t i;
+        json_t *jval;
+        hash_table eventids_by_uid = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&eventids_by_uid, json_array_size(get.ids), 0);
+
+        /* Split into single-valued uids and event recurrence instance ids */
+        json_array_foreach(get.ids, i, jval) {
+            const char *id = json_string_value(jval);
+            struct event_id *eid = parse_eventid(id);
+            if (eid) {
+                ptrarray_t *eventids = hash_lookup(eid->uid, &eventids_by_uid);
+                if (!eventids) {
+                    eventids = ptrarray_new();
+                    hash_insert(eid->uid, eventids, &eventids_by_uid);
+                }
+                ptrarray_append(eventids, eid);
+            }
+            else json_array_append(get.not_found, jval);
+        }
+
+        /* Lookup events by UID */
+        hash_iter *iter = hash_table_iter(&eventids_by_uid);
+        while (hash_iter_next(iter)) {
+            const char *uid = hash_iter_key(iter);
+            size_t nseen = json_array_size(get.list) + json_array_size(get.not_found);
+            rock.want_eventids = hash_iter_val(iter);
+            r = caldav_get_events(db, httpd_userid, NULL, uid, &getcalendarevents_cb, &rock);
+            if (r) break;
+            if (nseen == json_array_size(get.list) + json_array_size(get.not_found)) {
+                /* caldavdb silently ignores non-existent uids */
+                int j;
+                for (j = 0; j < ptrarray_size(rock.want_eventids); j++) {
+                    struct event_id *eid = ptrarray_nth(rock.want_eventids, j);
+                    json_array_append_new(rock.get->not_found, json_string(eid->raw));
+                }
+            }
+        }
+        hash_iter_free(&iter);
+
+        /* Clean up memory */
+        iter = hash_table_iter(&eventids_by_uid);
+        while (hash_iter_next(iter)) {
+            ptrarray_t *eventids = hash_iter_val(iter);
+            struct event_id *eid;
+            while ((eid = ptrarray_pop(eventids))) {
+                free_eventid(&eid);
+            }
+            ptrarray_free(eventids);
+        }
+        hash_iter_free(&iter);
+        free_hash_table(&eventids_by_uid, NULL);
+    } else if (json_is_null(get.ids) || get.ids == NULL) {
+        /* Return all visible events */
+        r = caldav_get_events(db, httpd_userid, NULL, NULL, &getcalendarevents_cb, &rock);
+    }
+    if (r) goto done;
+
+    if (hashu64_count(&rock.jmapcache)) {
+        r = caldav_begin(db);
+        if (!r) hashu64_enumerate(&rock.jmapcache, cachecalendarevents_cb, &rock);
+        if (r) caldav_abort(db);
+        else r = caldav_commit(db);
+        if (r) goto done;
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    if (db) caldav_close(db);
+    if (rock.mailbox) jmap_closembox(req, &rock.mailbox);
+    free_hashu64_table(&rock.jmapcache, free);
+    return r;
+}
+
+static int setcalendarevents_schedule(jmap_req_t *req,
+                                      strarray_t *schedule_addresses,
+                                      icalcomponent *oldical,
+                                      icalcomponent *ical,
+                                      int mode)
+{
+    /* Determine if any scheduling is required. */
+    icalcomponent *src = mode & JMAP_DESTROY ? oldical : ical;
+    icalcomponent *comp =
+        icalcomponent_get_first_component(src, ICAL_VEVENT_COMPONENT);
+    icalproperty *prop =
+        icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
+    if (!prop) return 0;
+    const char *organizer = icalproperty_get_organizer(prop);
+    if (!organizer) return 0;
+    if (!strncasecmp(organizer, "mailto:", 7)) organizer += 7;
+
+    const char **hdr =
+        spool_getheader(req->txn->req_hdrs, "Schedule-Address");
+    if (hdr) strarray_append(schedule_addresses, hdr[0]);
+
+    if (!strarray_size(schedule_addresses)) {
+        const char *annotname =
+            DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
+        char *mailboxname = caldav_mboxname(req->userid, NULL);
+        struct buf attrib = BUF_INITIALIZER;
+        int r = annotatemore_lookupmask(mailboxname, annotname,
+                                        req->userid, &attrib);
+        if (!r && buf_len(&attrib)) {
+            strarray_t *values = strarray_split(buf_cstring(&attrib), ",", STRARRAY_TRIM);
+            int i;
+            for (i = 0; i < strarray_size(values); i++) {
+                const char *item = strarray_nth(values, i);
+                if (!strncasecmp(item, "mailto:", 7)) item += 7;
+                strarray_append(schedule_addresses, item);
+            }
+            strarray_free(values);
+        }
+        else if (strchr(req->userid, '@')) {
+            strarray_append(schedule_addresses, req->userid);
+        }
+        else {
+            const char *domain = httpd_extradomain ? httpd_extradomain : config_defdomain;
+            strarray_appendm(schedule_addresses, strconcat(req->userid, "@", domain, NULL));
+        }
+        free(mailboxname);
+        buf_free(&attrib);
+    }
+    /* Validate create/update. */
+    if (oldical && (mode & (JMAP_CREATE|JMAP_UPDATE))) {
+        /* Don't allow ORGANIZER to be updated */
+        const char *oldorganizer = NULL;
+
+        icalcomponent *oldcomp = NULL;
+        icalproperty *prop = NULL;
+        oldcomp =
+            icalcomponent_get_first_component(oldical, ICAL_VEVENT_COMPONENT);
+        if (oldcomp) {
+            prop = icalcomponent_get_first_property(oldcomp,
+                                                    ICAL_ORGANIZER_PROPERTY);
+        }
+        if (prop) oldorganizer = icalproperty_get_organizer(prop);
+        if (oldorganizer) {
+            if (!strncasecmp(oldorganizer, "mailto:", 7)) oldorganizer += 7;
+            if (strcasecmp(oldorganizer, organizer)) {
+                /* XXX This should become a set error. */
+                return 0;
+            }
+        }
+    }
+
+    if (organizer &&
+            /* XXX Hack for Outlook */ icalcomponent_get_first_invitee(comp)) {
+        /* Send scheduling message. */
+        if (strarray_find_case(schedule_addresses, organizer, 0) >= 0) {
+            /* Organizer scheduling object resource */
+            sched_request(req->userid, schedule_addresses, organizer, oldical, ical);
+        } else {
+            /* Attendee scheduling object resource */
+            int omit_reply = 0;
+            if (oldical && (mode & JMAP_DESTROY)) {
+                for (prop = icalcomponent_get_first_property(comp, ICAL_ATTENDEE_PROPERTY);
+                     prop;
+                     prop = icalcomponent_get_next_property(comp, ICAL_ATTENDEE_PROPERTY)) {
+                    const char *addr = icalproperty_get_attendee(prop);
+                    if (!addr || strncasecmp(addr, "mailto:", 7) || strcasecmp(strarray_nth(schedule_addresses, 0), addr+7))
+                        continue;
+                    icalparameter *param = icalproperty_get_first_parameter(prop, ICAL_PARTSTAT_PARAMETER);
+                    omit_reply = !param || icalparameter_get_partstat(param) == ICAL_PARTSTAT_NEEDSACTION;
+                    break;
+                }
+            }
+            if (!omit_reply && strarray_size(schedule_addresses))
+                sched_reply(req->userid, schedule_addresses, oldical, ical);
+        }
+    }
+
+    return 0;
+}
+
+static void remove_itip_properties(icalcomponent *ical)
+{
+    icalproperty *prop, *next;
+    icalproperty_kind kind = ICAL_METHOD_PROPERTY;
+
+    for (prop = icalcomponent_get_first_property(ical, kind);
+         prop;
+         prop = next) {
+
+        next = icalcomponent_get_next_property(ical, kind);
+        icalcomponent_remove_property(ical, prop);
+        icalproperty_free(prop);
+    }
+
+}
+
+static int setcalendarevents_create(jmap_req_t *req,
+                                    const char *account_id,
+                                    json_t *event,
+                                    struct caldav_db *db,
+                                    json_t *invalid,
+                                    json_t *create)
+{
+    int r, pe;
+    int needrights = DACL_WRITEPROPS|DACL_WRITECONT;
+    char *uid = NULL;
+
+    struct mailbox *mbox = NULL;
+    char *mboxname = NULL;
+    char *resource = NULL;
+
+    icalcomponent *ical = NULL;
+    const char *calendarId = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+
+    if ((uid = (char *) json_string_value(json_object_get(event, "uid")))) {
+        /* Use custom iCalendar UID from request object */
+        uid = xstrdup(uid);
+    }  else {
+        /* Create a iCalendar UID */
+        uid = xstrdup(makeuuid());
+    }
+
+    /* Validate calendarId */
+    pe = jmap_readprop(event, "calendarId", 1, invalid, "s", &calendarId);
+    if (pe > 0 && *calendarId &&*calendarId == '#') {
+        calendarId = jmap_lookup_id(req, calendarId + 1);
+        if (!calendarId) {
+            json_array_append_new(invalid, json_string("calendarId"));
+        }
+    }
+    if (json_array_size(invalid)) {
+        free(uid);
+        return 0;
+    }
+
+    /* Determine mailbox and resource name of calendar event.
+     * We attempt to reuse the UID as DAV resource name; but
+     * only if it looks like a reasonable URL path segment. */
+    struct buf buf = BUF_INITIALIZER;
+    mboxname = caldav_mboxname(account_id, calendarId);
+    const char *p;
+    for (p = uid; *p; p++) {
+        if ((*p >= '0' && *p <= '9') ||
+            (*p >= 'a' && *p <= 'z') ||
+            (*p >= 'A' && *p <= 'Z') ||
+            (*p == '@' || *p == '.') ||
+            (*p == '_' || *p == '-')) {
+            continue;
+        }
+        break;
+    }
+    if (*p == '\0' && p - uid >= 16 && p - uid <= 200) {
+        buf_setcstr(&buf, uid);
+    } else {
+        buf_setcstr(&buf, makeuuid());
+    }
+    buf_appendcstr(&buf, ".ics");
+    resource = buf_newcstring(&buf);
+    buf_free(&buf);
+
+    /* Check permissions. */
+    if (!jmap_hasrights_byname(req, mboxname, needrights)) {
+        json_array_append_new(invalid, json_string("calendarId"));
+        r = 0; goto done;
+    }
+
+    /* Open mailbox for writing */
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r) {
+        syslog(LOG_ERR, "jmap_openmbox(req, %s) failed: %s", mboxname, error_message(r));
+        if (r == IMAP_MAILBOX_NONEXISTENT) {
+            json_array_append_new(invalid, json_string("calendarId"));
+            r = 0;
+        }
+        goto done;
+    }
+
+    /* Convert the JMAP calendar event to ical. */
+    if (!json_object_get(event, "uid")) {
+        json_object_set_new(event, "uid", json_string(uid));
+    }
+
+    if (!json_object_get(event, "created") || !json_object_get(event, "updated")) {
+        char datestr[RFC3339_DATETIME_MAX+1];
+        time_to_rfc3339(time(NULL), datestr, RFC3339_DATETIME_MAX);
+        datestr[RFC3339_DATETIME_MAX] = '\0';
+        if (!json_object_get(event, "created")) {
+            json_object_set_new(event, "created", json_string(datestr));
+        }
+        if (!json_object_get(event, "updated")) {
+            json_object_set_new(event, "updated", json_string(datestr));
+        }
+    }
+    ical = jmapical_toical(event, NULL, invalid);
+
+    // check that participantId is either not present or is a valid participant
+    json_t *jparticipantId = json_object_get(event, "participantId");
+    if (json_is_string(jparticipantId)) {
+        const char *participant_id = json_string_value(jparticipantId);
+        json_t *participants = json_object_get(event, "participants");
+        json_t *participant = json_object_get(participants, participant_id);
+        const char *email = json_string_value(json_object_get(participant, "email"));
+        if (email) strarray_addfirst_case(&schedule_addresses, email);
+        else json_array_append_new(invalid, json_string("participantId"));
+    }
+    else if (JNOTNULL(jparticipantId)) {
+        json_array_append_new(invalid, json_string("participantId"));
+    }
+
+    if (json_array_size(invalid)) {
+        r = 0;
+        goto done;
+    } else if (!ical) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Handle scheduling. */
+    r = setcalendarevents_schedule(req, &schedule_addresses,
+                                   NULL, ical, JMAP_CREATE);
+    if (r) goto done;
+
+    /* Remove METHOD property */
+    remove_itip_properties(ical);
+
+    /* Store the VEVENT. */
+    struct transaction_t txn;
+    memset(&txn, 0, sizeof(struct transaction_t));
+    txn.req_hdrs = spool_new_hdrcache();
+    /* XXX - fix userid */
+
+    /* Locate the mailbox */
+    r = http_mlookup(mbox->name, &txn.req_tgt.mbentry, NULL);
+    if (r) {
+        syslog(LOG_ERR, "mlookup(%s) failed: %s", mbox->name, error_message(r));
+    }
+    else {
+        r = caldav_store_resource(&txn, ical, mbox, resource, 0,
+                                  db, 0, httpd_userid, &schedule_addresses);
+    }
+    mboxlist_entry_free(&txn.req_tgt.mbentry);
+    spool_free_hdrcache(txn.req_hdrs);
+    buf_free(&txn.buf);
+    if (r && r != HTTP_CREATED && r != HTTP_NO_CONTENT) {
+        syslog(LOG_ERR, "caldav_store_resource failed for user %s: %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+    r = 0;
+    json_object_set_new(create, "uid", json_string(uid));
+
+    char *xhref = jmap_xhref(mbox->name, resource);
+    json_object_set_new(create, "x-href", json_string(xhref));
+    free(xhref);
+
+    if (jmap_is_using(req, JMAP_CALENDARS_EXTENSION)) {
+        struct caldav_data *cdata = NULL;
+        r = caldav_lookup_uid(db, uid, &cdata);
+        if (!r) {
+            struct buf blobid = BUF_INITIALIZER;
+            if (_encode_calendarevent_blobid(cdata, req->userid, &blobid)) {
+                json_object_set_new(create, "blobId",
+                        json_string(buf_cstring(&blobid)));
+            }
+            buf_reset(&blobid);
+            if (_encode_calendarevent_blobid(cdata, NULL, &blobid)) {
+                json_object_set_new(create, "debugBlobId",
+                        json_string(buf_cstring(&blobid)));
+            }
+            buf_free(&blobid);
+        }
+    }
+
+done:
+    if (mbox) jmap_closembox(req, &mbox);
+    if (ical) icalcomponent_free(ical);
+    strarray_fini(&schedule_addresses);
+    free(resource);
+    free(mboxname);
+    free(uid);
+    return r;
+}
+
+static int eventpatch_updates_peruserprops_only(json_t *jdiff, const char *participant_id)
+{
+    strarray_t userprops = STRARRAY_INITIALIZER;
+    if (participant_id) {
+        strarray_appendm(&userprops,
+                strconcat("participants/", participant_id, "/participationStatus", NULL));
+        strarray_appendm(&userprops,
+                strconcat("participants/", participant_id, "/participationComment", NULL));
+        strarray_appendm(&userprops,
+                strconcat("participants/", participant_id, "/expectReply", NULL));
+    }
+
+    const char *prop;
+    json_t *jval;
+    int ret = 1;
+    void *tmp;
+
+    json_object_foreach_safe(jdiff, tmp, prop, jval) {
+        if (!strcmp(prop, "recurrenceOverrides")) {
+            const char *recurid;
+            json_t *joverride;
+            json_object_foreach(jval, recurid, joverride) {
+                if (!eventpatch_updates_peruserprops_only(joverride, participant_id)) {
+                    ret = 0;
+                    goto done;
+                }
+            }
+            continue;
+        }
+        else if (!strcmp(prop, "participants")) {
+            /* Patches *all* participants */
+            ret = 0;
+            goto done;
+        }
+        else if (!strncmp(prop, "recurrenceOverrides/", 20)) {
+            /* Does prop point *into* an override? */
+            const char *p = strchr(prop + 21, '/');
+            if (!p) {
+                /* Override value is a JSON object */
+                if (!eventpatch_updates_peruserprops_only(jval, participant_id)) {
+                    ret = 0;
+                    goto done;
+                }
+                continue;
+            }
+            /* fall through */
+            prop = p + 1;
+        }
+
+        if (strcmp(prop, "keywords") &&
+            strcmp(prop, "color") &&
+            strcmp(prop, "freeBusyStatus") &&
+            strcmp(prop, "useDefaultAlerts") &&
+            strcmp(prop, "alerts") &&
+            strncmp(prop, "alerts/", 7) &&
+            (!participant_id || strarray_find(&userprops, prop, 0) < 0)) {
+            /* Patches some non-user property */
+            ret = 0;
+            goto done;
+        }
+    }
+
+done:
+    strarray_fini(&userprops);
+    return ret;
+}
+
+static int eventpatch_updates_recurrenceoverrides(json_t *event_patch)
+{
+    const char *prop;
+    json_t *jval;
+    json_object_foreach(event_patch, prop, jval) {
+        if (!strncmp(prop, "recurrenceOverrides/", 20) && strchr(prop + 21, '/')) {
+            return 1;
+        }
+    }
+    return 0;
+}
+
+static int setcalendarevents_apply_patch(json_t *event_patch,
+                                         icalcomponent *oldical,
+                                         const char *recurid,
+                                         json_t *invalid,
+                                         strarray_t *schedule_addresses,
+                                         icalcomponent **newical,
+                                         json_t *update,
+                                         json_t **err)
+{
+    json_t *old_event = NULL;
+    json_t *new_event = NULL;
+    int r = 0;
+
+    old_event = jmapical_tojmap(oldical, NULL);
+    if (!old_event) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+    json_object_del(old_event, "updated");
+
+    /* Add participant id to old_event */
+    const char *participant_id = NULL;
+    int i;
+    for (i = 0; i < strarray_size(schedule_addresses); i++) {
+        const char *test = strarray_nth(schedule_addresses, i);
+        if (!strncasecmp(test, "mailto:", 7)) test += 7;
+        const char *key;
+        json_t *participant;
+        json_object_foreach(json_object_get(old_event, "participants"), key, participant) {
+            const char *email = json_string_value(json_object_get(participant, "email"));
+            if (!email) continue;
+            if (!strncasecmp(email, "mailto:", 7)) email += 7;
+            if (!strcasecmp(email, test)) {
+                participant_id = key;
+                break;
+            }
+        }
+        if (participant_id) break;
+    }
+    json_object_set_new(old_event, "participantId", participant_id ?
+            json_string(participant_id) : json_null());
+
+
+    if (recurid) {
+        /* Update or create an override */
+        struct jmapical_datetime recuriddt = JMAPICAL_DATETIME_INITIALIZER;
+        if (jmapical_localdatetime_from_string(recurid, &recuriddt) < 0) {
+            r = IMAP_NOTFOUND;
+            goto done;
+        }
+        icaltimetype icalrecurid = jmapical_datetime_to_icaltime(&recuriddt, NULL);
+
+        int is_rdate = !_recurid_is_instanceof(icalrecurid, oldical, 1/*rrule_only*/);
+
+        json_t *old_overrides = json_object_get(old_event, "recurrenceOverrides");
+        json_t *old_override = json_object_get(old_overrides, recurid);
+        json_t *new_instance = NULL;
+        json_t *new_override = NULL;
+        if (old_override) {
+            /* Patch an existing override */
+            json_t *old_instance = jmap_patchobject_apply(old_event, old_override, NULL);
+            new_instance = jmap_patchobject_apply(old_instance, event_patch, invalid);
+            json_decref(old_instance);
+        }
+        else {
+            /* Create a new override */
+            new_instance = jmap_patchobject_apply(old_event, event_patch, invalid);
+        }
+        if (!new_instance) {
+            *err = json_pack("{s:s}", "type", "invalidPatch");
+            goto done;
+        }
+        json_object_del(new_instance, "recurrenceRule");
+        json_object_del(new_instance, "recurrenceOverrides");
+        new_override = jmap_patchobject_create(old_event, new_instance);
+        json_object_del(new_override, "@type");
+        json_object_del(new_override, "method");
+        json_object_del(new_override, "prodId");
+        json_object_del(new_override, "recurrenceId");
+        json_object_del(new_override, "recurrenceRule");
+        json_object_del(new_override, "recurrenceOverrides");
+        json_object_del(new_override, "relatedTo");
+        json_object_del(new_override, "replyTo");
+        json_object_del(new_override, "uid");
+        json_decref(new_instance);
+
+        if (json_boolean_value(json_object_get(new_override, "excluded"))) {
+            if (is_rdate) {
+                /* No need to set it in recurrenceOverrides */
+                json_decref(new_override);
+                new_override = NULL;
+            }
+            else if (json_object_size(new_override) > 1) {
+                /* Normalize excluded override */
+                json_decref(new_override);
+                new_override = json_pack("{s:b}", "excluded", 1);
+            }
+        }
+        else if (json_object_size(new_override) == 0) {
+            if (!is_rdate) {
+                /* No need to set it in recurrenceOverrides */
+                json_decref(new_override);
+                new_override = NULL;
+            }
+        }
+
+        /* Create the new JSEvent */
+        new_event = json_deep_copy(old_event);
+        json_t *new_overrides = json_object_get(new_event, "recurrenceOverrides");
+        if (new_override) {
+            /* Update or create override */
+            if (new_overrides == NULL || json_is_null(new_overrides)) {
+                new_overrides = json_object();
+                json_object_set_new(new_event, "recurrenceOverrides", new_overrides);
+            }
+            json_object_set_new(new_overrides, recurid, new_override);
+        } else {
+            /* Remove existing override */
+            json_object_del(new_overrides, recurid);
+        }
+    }
+    else {
+        /* Update a regular event */
+        if (eventpatch_updates_recurrenceoverrides(event_patch)) {
+            /* Split patch into main event and override patches */
+            json_t *mainevent_patch = json_object();
+            json_t *overrides_patch = json_object();
+            const char *key;
+            json_t *jval;
+            json_object_foreach(event_patch, key, jval) {
+                if (!strncmp(key, "recurrenceOverrides/", 20)) {
+                    json_object_set(overrides_patch, key, jval);
+                }
+                else {
+                    json_object_set(mainevent_patch, key, jval);
+                }
+            }
+
+            /* Apply patch to main event */
+            json_t *old_mainevent = json_deep_copy(old_event);
+            json_object_del(old_mainevent, "recurrenceOverrides");
+            new_event = jmap_patchobject_apply(old_mainevent, mainevent_patch, invalid);
+            if (!new_event) {
+                *err = json_pack("{s:s}", "type", "invalidPatch");
+                json_decref(old_mainevent);
+                goto done;
+            }
+
+            /* Expand current overrides from patched main event */
+            json_t *old_overrides = json_object_get(old_event, "recurrenceOverrides");
+            json_t *old_exp_overrides = json_object();
+            json_t *old_override;
+            const char *recurid;
+            json_object_foreach(old_overrides, recurid, old_override) {
+                if (json_boolean_value(json_object_get(old_override, "excluded"))) {
+                    json_object_set(old_exp_overrides, recurid, old_override);
+                    continue;
+                }
+                json_t *override = jmap_patchobject_apply(new_event, old_override, NULL);
+                if (override) {
+                    json_object_set_new(old_exp_overrides, recurid, override);
+                }
+            }
+            if (!json_object_size(old_exp_overrides)) {
+                json_decref(old_exp_overrides);
+                old_exp_overrides = json_null();
+            }
+
+            /* Apply override patches to expanded overrides */
+            json_t *new_exp_overrides = NULL;
+            if (json_object_size(old_exp_overrides)) {
+                json_t *old_wrapper = json_pack("{s:O}", "recurrenceOverrides", old_exp_overrides);
+                json_t *new_wrapper = jmap_patchobject_apply(old_wrapper, overrides_patch, invalid);
+                if (!new_wrapper) {
+                    *err = json_pack("{s:s}", "type", "invalidPatch");
+                    json_decref(old_wrapper);
+                    goto done;
+                }
+                new_exp_overrides = json_incref(json_object_get(new_wrapper, "recurrenceOverrides"));
+                json_decref(old_wrapper);
+                json_decref(new_wrapper);
+            }
+
+            /* Diff patched overrides with patched main event */
+            json_t *new_overrides = json_object();
+            struct buf buf = BUF_INITIALIZER;
+            json_object_foreach(new_exp_overrides, recurid, jval) {
+                /* Don't diff excluded overrides */
+                if (json_boolean_value(json_object_get(jval, "excluded"))) {
+                    json_object_set(new_overrides, recurid, jval);
+                    continue;
+                }
+                /* Don't diff replaced overrides */
+                buf_setcstr(&buf, "recurrenceOverrides/");
+                buf_appendcstr(&buf, recurid);
+                if (json_object_get(overrides_patch, buf_cstring(&buf))) {
+                    json_object_set(new_overrides, recurid, jval);
+                    continue;
+                }
+                /* Diff updated override */
+                json_t *new_override = jmap_patchobject_create(new_event, jval);
+                if (!new_override) continue;
+                json_object_set_new(new_overrides, recurid, new_override);
+            }
+            buf_free(&buf);
+            if (!json_object_size(new_overrides)) {
+                json_decref(new_overrides);
+                new_overrides = json_null();
+            }
+
+            /* Combine new main event with new overrides */
+            json_object_set_new(new_event, "recurrenceOverrides", new_overrides);
+
+            json_decref(mainevent_patch);
+            json_decref(overrides_patch);
+            json_decref(old_exp_overrides);
+            json_decref(new_exp_overrides);
+            json_decref(old_mainevent);
+        }
+        else {
+            /* The happy path - just apply the patch as provided */
+            new_event = jmap_patchobject_apply(old_event, event_patch, invalid);
+            if (!new_event) {
+                *err = json_pack("{s:s}", "type", "invalidPatch");
+                goto done;
+            }
+        }
+    }
+
+    // check that participantId is either not present or is a valid participant
+    participant_id = NULL;
+    json_t *jparticipantId = json_object_get(new_event, "participantId");
+    if (json_is_string(jparticipantId)) {
+        participant_id = json_string_value(jparticipantId);
+        json_t *participants = json_object_get(new_event, "participants");
+        json_t *participant = json_object_get(participants, participant_id);
+        const char *email = json_string_value(json_object_get(participant, "email"));
+        if (email) strarray_addfirst_case(schedule_addresses, email);
+        else json_array_append_new(invalid, json_string("participantId"));
+    }
+    else if (JNOTNULL(jparticipantId)) {
+        json_array_append_new(invalid, json_string("participantId"));
+    }
+
+    /* Determine if to bump sequence */
+    json_t *jdiff = jmap_patchobject_create(old_event, new_event);
+    json_object_del(jdiff, "updated");
+    if (!eventpatch_updates_peruserprops_only(jdiff, participant_id)) {
+        json_int_t oldseq = json_integer_value(json_object_get(old_event, "sequence"));
+        json_int_t newseq = json_integer_value(json_object_get(new_event, "sequence"));
+        if (newseq <= oldseq) {
+            json_int_t newseq = oldseq + 1;
+            json_object_set_new(new_event, "sequence", json_integer(newseq));
+            json_object_set_new(update, "sequence", json_integer(newseq));
+        }
+    }
+    json_decref(jdiff);
+
+    /* Convert to iCalendar */
+    *newical = jmapical_toical(new_event, oldical, invalid);
+
+done:
+    json_decref(new_event);
+    json_decref(old_event);
+    return r;
+}
+
+static int setcalendarevents_update(jmap_req_t *req,
+                                    json_t *event_patch,
+                                    struct event_id *eid,
+                                    struct caldav_db *db,
+                                    json_t *invalid,
+                                    json_t *update,
+                                    json_t **err)
+{
+    int r, pe;
+    int needrights = DACL_RMRSRC|DACL_WRITEPROPS|DACL_WRITECONT;
+
+    struct caldav_data *cdata = NULL;
+    struct mailbox *mbox = NULL;
+    char *mboxname = NULL;
+    struct mailbox *dstmbox = NULL;
+    char *dstmboxname = NULL;
+    struct mboxevent *mboxevent = NULL;
+    char *resource = NULL;
+
+    icalcomponent *oldical = NULL;
+    icalcomponent *ical = NULL;
+    struct index_record record;
+    const char *calendarId = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+
+    /* Validate calendarId */
+    pe = jmap_readprop(event_patch, "calendarId", 0, invalid, "s", &calendarId);
+    if (pe > 0 && *calendarId && *calendarId == '#') {
+        calendarId = jmap_lookup_id(req, calendarId + 1);
+        if (!calendarId) {
+            json_array_append_new(invalid, json_string("calendarId"));
+        }
+    }
+    if (json_array_size(invalid)) {
+        r = 0;
+        goto done;
+    }
+
+    /* Determine mailbox and resource name of calendar event. */
+    r = caldav_lookup_uid(db, eid->uid, &cdata);
+    if (r && r != CYRUSDB_NOTFOUND) {
+        syslog(LOG_ERR,
+               "caldav_lookup_uid(%s) failed: %s", eid->uid, error_message(r));
+        goto done;
+    }
+    if (r == CYRUSDB_NOTFOUND || !cdata->dav.alive ||
+            !cdata->dav.rowid || !cdata->dav.imap_uid ||
+            cdata->comp_type != CAL_COMP_VEVENT) {
+        r = IMAP_NOTFOUND;
+        goto done;
+    }
+    mboxname = xstrdup(cdata->dav.mailbox);
+    resource = xstrdup(cdata->dav.resource);
+
+    /* Check permissions. */
+    if (!jmap_hasrights_byname(req, mboxname, needrights)) {
+        json_array_append_new(invalid, json_string("calendarId"));
+        r = 0;
+        goto done;
+    }
+
+    /* Open mailbox for writing */
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        json_array_append_new(invalid, json_string("calendarId"));
+        r = 0;
+        goto done;
+    }
+    else if (r) {
+        syslog(LOG_ERR, "jmap_openmbox(req, %s) failed: %s",
+                mboxname, error_message(r));
+        goto done;
+    }
+
+    /* Fetch index record for the resource */
+    memset(&record, 0, sizeof(struct index_record));
+    r = mailbox_find_index_record(mbox, cdata->dav.imap_uid, &record);
+    if (r == IMAP_NOTFOUND) {
+        json_array_append_new(invalid, json_string("calendarId"));
+        r = 0;
+        goto done;
+    } else if (r) {
+        syslog(LOG_ERR, "mailbox_index_record(0x%x) failed: %s",
+                cdata->dav.imap_uid, error_message(r));
+        goto done;
+    }
+    /* Load VEVENT from record, personalizing as needed. */
+    oldical = caldav_record_to_ical(mbox, cdata, httpd_userid, &schedule_addresses);
+    if (!oldical) {
+        syslog(LOG_ERR, "record_to_ical failed for record %u:%s",
+                cdata->dav.imap_uid, mbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+    /* Apply patch */
+    r = setcalendarevents_apply_patch(event_patch, oldical, eid->recurid,
+                                      invalid, &schedule_addresses, &ical, update, err);
+    if (json_array_size(invalid)) {
+        r = 0;
+        goto done;
+    }
+    else if (r) goto done;
+
+    if (calendarId) {
+        /* Check, if we need to move the event. */
+        dstmboxname = caldav_mboxname(req->accountid, calendarId);
+        if (strcmp(mbox->name, dstmboxname)) {
+            /* Check permissions */
+            if (!jmap_hasrights_byname(req, dstmboxname, needrights)) {
+                json_array_append_new(invalid, json_string("calendarId"));
+                r = 0;
+                goto done;
+            }
+            /* Open destination mailbox for writing. */
+            r = jmap_openmbox(req, dstmboxname, &dstmbox, 1);
+            if (r == IMAP_MAILBOX_NONEXISTENT) {
+                json_array_append_new(invalid, json_string("calendarId"));
+                r = 0;
+                goto done;
+            } else if (r) {
+                syslog(LOG_ERR, "jmap_openmbox(req, %s) failed: %s",
+                        dstmboxname, error_message(r));
+                goto done;
+            }
+        }
+    }
+
+    /* Handle scheduling. */
+    r = setcalendarevents_schedule(req, &schedule_addresses,
+                                   oldical, ical, JMAP_UPDATE);
+    if (r) goto done;
+
+
+    if (dstmbox) {
+        /* Expunge the resource from mailbox. */
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
+        mboxevent = mboxevent_new(EVENT_MESSAGE_EXPUNGE);
+        r = mailbox_rewrite_index_record(mbox, &record);
+        if (r) {
+            syslog(LOG_ERR, "mailbox_rewrite_index_record (%s) failed: %s",
+                    cdata->dav.mailbox, error_message(r));
+            jmap_closembox(req, &mbox);
+            goto done;
+        }
+        mboxevent_extract_record(mboxevent, mbox, &record);
+        mboxevent_extract_mailbox(mboxevent, mbox);
+        mboxevent_set_numunseen(mboxevent, mbox, -1);
+        mboxevent_set_access(mboxevent, NULL, NULL,
+                             req->userid, cdata->dav.mailbox, 0);
+        jmap_closembox(req, &mbox);
+        mboxevent_notify(&mboxevent);
+        mboxevent_free(&mboxevent);
+
+        /* Close the mailbox we moved the event from. */
+        jmap_closembox(req, &mbox);
+        mbox = dstmbox;
+        dstmbox = NULL;
+        free(mboxname);
+        mboxname = dstmboxname;
+        dstmboxname = NULL;
+    }
+
+    /* Remove METHOD property */
+    remove_itip_properties(ical);
+
+    /* Store the updated VEVENT. */
+    struct transaction_t txn;
+    memset(&txn, 0, sizeof(struct transaction_t));
+    txn.req_hdrs = spool_new_hdrcache();
+    /* XXX - fix userid */
+    r = http_mlookup(mbox->name, &txn.req_tgt.mbentry, NULL);
+    if (r) {
+        syslog(LOG_ERR, "mlookup(%s) failed: %s", mbox->name, error_message(r));
+    }
+    else {
+        r = caldav_store_resource(&txn, ical, mbox, resource, record.createdmodseq,
+                                  db, 0, httpd_userid, &schedule_addresses);
+    }
+    transaction_free(&txn);
+    if (r && r != HTTP_CREATED && r != HTTP_NO_CONTENT) {
+        syslog(LOG_ERR, "caldav_store_resource failed for user %s: %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+    r = 0;
+
+done:
+    if (mbox) jmap_closembox(req, &mbox);
+    if (dstmbox) jmap_closembox(req, &dstmbox);
+    if (ical) icalcomponent_free(ical);
+    if (oldical) icalcomponent_free(oldical);
+    strarray_fini(&schedule_addresses);
+    free(dstmboxname);
+    free(resource);
+    free(mboxname);
+    return r;
+}
+
+static int setcalendarevents_destroy(jmap_req_t *req,
+                                     struct event_id *eid,
+                                     struct caldav_db *db)
+{
+    int r;
+    int needrights = DACL_RMRSRC;
+
+    struct caldav_data *cdata = NULL;
+    struct mailbox *mbox = NULL;
+    char *mboxname = NULL;
+    struct mboxevent *mboxevent = NULL;
+    char *resource = NULL;
+
+    icalcomponent *oldical = NULL;
+    icalcomponent *ical = NULL;
+    struct index_record record;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+
+    if (eid->recurid) {
+        /* Destroying a recurrence instance is setting it excluded */
+        json_t *event_patch = json_pack("{s:b}", "excluded", 1);
+        json_t *invalid = json_array();
+        json_t *update = NULL;
+        json_t *err = NULL;
+        r = setcalendarevents_update(req, event_patch, eid, db, invalid, update, &err);
+        json_decref(event_patch);
+        json_decref(update);
+        if (err || (!r && json_array_size(invalid))) {
+            r = IMAP_INTERNAL;
+            json_decref(err);
+        }
+        json_decref(invalid);
+        return r;
+    }
+
+    /* Determine mailbox and resource name of calendar event. */
+    r = caldav_lookup_uid(db, eid->uid, &cdata);
+    if (r) {
+        syslog(LOG_ERR,
+               "caldav_lookup_uid(%s) failed: %s", eid->uid, cyrusdb_strerror(r));
+        r = CYRUSDB_NOTFOUND ? IMAP_NOTFOUND : IMAP_INTERNAL;
+        goto done;
+    }
+    mboxname = xstrdup(cdata->dav.mailbox);
+    resource = xstrdup(cdata->dav.resource);
+
+    /* Check permissions. */
+    if (!jmap_hasrights_byname(req, mboxname, DACL_READ)) {
+        r = IMAP_NOTFOUND;
+        goto done;
+    }
+    if (!jmap_hasrights_byname(req, mboxname, needrights)) {
+        r = IMAP_PERMISSION_DENIED;
+        goto done;
+    }
+
+    /* Open mailbox for writing */
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r) {
+        syslog(LOG_ERR, "jmap_openmbox(req, %s) failed: %s",
+                mboxname, error_message(r));
+        goto done;
+    }
+
+    /* Fetch index record for the resource. Need this for scheduling. */
+    memset(&record, 0, sizeof(struct index_record));
+    r = mailbox_find_index_record(mbox, cdata->dav.imap_uid, &record);
+    if (r) {
+        syslog(LOG_ERR, "mailbox_index_record(0x%x) failed: %s",
+                cdata->dav.imap_uid, error_message(r));
+        goto done;
+    }
+    /* Load VEVENT from record. */
+    oldical = record_to_ical(mbox, &record, &schedule_addresses);
+    if (!oldical) {
+        syslog(LOG_ERR, "record_to_ical failed for record %u:%s",
+                cdata->dav.imap_uid, mbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Handle scheduling. */
+    r = setcalendarevents_schedule(req, &schedule_addresses,
+                                   oldical, ical, JMAP_DESTROY);
+    if (r) goto done;
+
+
+    /* Expunge the resource from mailbox. */
+    record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
+    mboxevent = mboxevent_new(EVENT_MESSAGE_EXPUNGE);
+    r = mailbox_rewrite_index_record(mbox, &record);
+    if (r) {
+        syslog(LOG_ERR, "mailbox_rewrite_index_record (%s) failed: %s",
+                cdata->dav.mailbox, error_message(r));
+        jmap_closembox(req, &mbox);
+        goto done;
+    }
+    mboxevent_extract_record(mboxevent, mbox, &record);
+    mboxevent_extract_mailbox(mboxevent, mbox);
+    mboxevent_set_numunseen(mboxevent, mbox, -1);
+    mboxevent_set_access(mboxevent, NULL, NULL,
+                         req->userid, cdata->dav.mailbox, 0);
+    jmap_closembox(req, &mbox);
+    mboxevent_notify(&mboxevent);
+    mboxevent_free(&mboxevent);
+
+done:
+    if (mbox) jmap_closembox(req, &mbox);
+    if (oldical) icalcomponent_free(oldical);
+    strarray_fini(&schedule_addresses);
+    free(resource);
+    free(mboxname);
+    return r;
+}
+
+static struct event_id *setcalendarevents_parse_id(jmap_req_t *req, const char *id)
+{
+    if (id && id[0] == '#') {
+        const char *newid = jmap_lookup_id(req, id + 1);
+        if (!newid) return NULL;
+        id = newid;
+    }
+    return parse_eventid(id);
+}
+
+
+static int jmap_calendarevent_set(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+    json_t *err = NULL;
+    struct caldav_db *db = NULL;
+    struct event_id *eid = NULL;
+    const char *id;
+    int r = 0;
+
+    /* Parse arguments */
+    jmap_set_parse(req, &parser, event_props, NULL, NULL, &set, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    if (set.if_in_state) {
+        /* TODO rewrite state function to use char* not json_t* */
+        json_t *jstate = json_string(set.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_CALENDAR)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            goto done;
+        }
+        json_decref(jstate);
+        set.old_state = xstrdup(set.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/0);
+        set.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+
+    r = caldav_create_defaultcalendars(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        json_t *err = json_pack("{s:s}", "type", "accountNoCalendars");
+        json_array_append_new(req->response, json_pack("[s,o,s]",
+                    "error", err, req->tag));
+        return 0;
+    } else if (r) return r;
+
+    db = caldav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR, "caldav_open_mailbox failed for user %s", req->userid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+
+    /* create */
+    const char *key;
+    json_t *arg;
+    json_object_foreach(set.create, key, arg) {
+        /* Validate calendar event id. */
+        if (!strlen(key)) {
+            json_t *err= json_pack("{s:s}", "type", "invalidArguments");
+            json_object_set_new(set.not_created, key, err);
+            continue;
+        }
+
+        /* Create the calendar event. */
+        json_t *invalid = json_pack("[]");
+        json_t *create = json_pack("{}");
+        r = setcalendarevents_create(req, req->accountid, arg, db, invalid, create);
+        if (r) {
+            json_t *err;
+            switch (r) {
+                case HTTP_FORBIDDEN:
+                case IMAP_PERMISSION_DENIED:
+                    err = json_pack("{s:s}", "type", "forbidden");
+                    break;
+                case IMAP_QUOTA_EXCEEDED:
+                    err = json_pack("{s:s}", "type", "overQuota");
+                    break;
+                default:
+                    err = jmap_server_error(r);
+            }
+            json_object_set_new(set.not_created, key, err);
+            json_decref(create);
+            r = 0;
+            continue;
+        }
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s s:o}",
+                                    "type", "invalidProperties",
+                                    "properties", invalid);
+            json_object_set_new(set.not_created, key, err);
+            json_decref(create);
+            continue;
+        }
+        json_decref(invalid);
+
+        /* Report calendar event as created. */
+        const char *uid = json_string_value(json_object_get(create, "uid"));
+        json_object_set_new(create, "id", json_string(uid));
+        json_object_set_new(set.created, key, create);
+        jmap_add_id(req, key, uid);
+    }
+
+
+    /* update */
+    json_object_foreach(set.update, id, arg) {
+        free_eventid(&eid);
+
+        eid = setcalendarevents_parse_id(req, id);
+        if (!eid) {
+            json_object_set_new(set.not_updated, id,
+                    json_pack("{s:s}", "type", "notFound"));
+            continue;
+        }
+
+        const char *uidval = NULL;
+        if ((uidval = json_string_value(json_object_get(arg, "uid")))) {
+            /* The uid property must match the current iCalendar UID */
+            if (strcmp(uidval, eid->uid)) {
+                json_t *err = json_pack(
+                    "{s:s, s:o}",
+                    "type", "invalidProperties",
+                    "properties", json_pack("[s]"));
+                json_object_set_new(set.not_updated, eid->raw, err);
+                continue;
+            }
+        }
+
+        /* Update the calendar event. */
+        json_t *invalid = json_pack("[]");
+        json_t *update = json_pack("{}");
+        json_t *err = NULL;
+        r = setcalendarevents_update(req, arg, eid, db, invalid, update, &err);
+        if (r || err) {
+            if (!err) {
+                switch (r) {
+                    case IMAP_NOTFOUND:
+                        err = json_pack("{s:s}", "type", "notFound");
+                        break;
+                    case HTTP_FORBIDDEN:
+                    case IMAP_PERMISSION_DENIED:
+                        err = json_pack("{s:s}", "type", "forbidden");
+                        break;
+                    case HTTP_NO_STORAGE:
+                    case IMAP_QUOTA_EXCEEDED:
+                        err = json_pack("{s:s}", "type", "overQuota");
+                        break;
+                    default:
+                        err = jmap_server_error(r);
+                }
+            }
+            json_object_set_new(set.not_updated, eid->raw, err);
+            json_decref(invalid);
+            json_decref(update);
+            r = 0;
+            continue;
+        }
+
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack(
+                "{s:s, s:o}", "type", "invalidProperties",
+                "properties", invalid);
+            json_object_set_new(set.not_updated, eid->raw, err);
+            json_decref(update);
+            continue;
+        }
+        json_decref(invalid);
+
+        if(!json_object_size(update)) {
+            json_decref(update);
+            update = json_null();
+        }
+
+        /* Report calendar event as updated. */
+        json_object_set_new(set.updated, eid->raw, update);
+    }
+    free_eventid(&eid);
+
+
+    /* destroy */
+    size_t index;
+    json_t *juid;
+
+    json_array_foreach(set.destroy, index, juid) {
+        free_eventid(&eid);
+
+        const char *id = json_string_value(juid);
+        if (!id) continue;
+
+        eid = setcalendarevents_parse_id(req, id);
+        if (!eid) {
+            json_object_set_new(set.not_destroyed, id,
+                    json_pack("{s:s}", "type", "notFound"));
+            continue;
+        }
+
+        /* Destroy the calendar event. */
+        r = setcalendarevents_destroy(req, eid, db);
+        if (r == IMAP_NOTFOUND) {
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_destroyed, eid->raw, err);
+            r = 0;
+            continue;
+        } else if (r == IMAP_PERMISSION_DENIED) {
+            json_t *err = json_pack("{s:s}", "type", "forbidden");
+            json_object_set_new(set.not_destroyed, eid->raw, err);
+            r = 0;
+            continue;
+        } else if (r) {
+            goto done;
+        }
+
+        /* Report calendar event as destroyed. */
+        json_array_append_new(set.destroyed, json_string(eid->raw));
+    }
+    free_eventid(&eid);
+
+
+    // TODO refactor jmap_getstate to return a string, once
+    // all code has been migrated to the new JMAP parser.
+    json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/1);
+    set.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    jmap_ok(req, jmap_set_reply(&set));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    if (db) caldav_close(db);
+    free_eventid(&eid);
+    return r;
+}
+
+struct geteventchanges_rock {
+    jmap_req_t *req;
+    struct jmap_changes *changes;
+    size_t seen_records;
+    modseq_t highestmodseq;
+    int check_acl;
+    hash_table *mboxrights;
+};
+
+static void strip_spurious_deletes(struct geteventchanges_rock *urock)
+{
+    /* if something is mentioned in both DELETEs and UPDATEs, it's probably
+     * a move.  O(N*M) algorithm, but there are rarely many, and the alternative
+     * of a hash will cost more */
+    unsigned i, j;
+
+    for (i = 0; i < json_array_size(urock->changes->destroyed); i++) {
+        const char *del = json_string_value(json_array_get(urock->changes->destroyed, i));
+
+        for (j = 0; j < json_array_size(urock->changes->updated); j++) {
+            const char *up =
+                json_string_value(json_array_get(urock->changes->updated, j));
+            if (!strcmpsafe(del, up)) {
+                json_array_remove(urock->changes->destroyed, i--);
+                break;
+            }
+        }
+    }
+}
+
+static int geteventchanges_cb(void *vrock, struct caldav_data *cdata)
+{
+    struct geteventchanges_rock *rock = vrock;
+    jmap_req_t *req = rock->req;
+    struct jmap_changes *changes = rock->changes;
+
+    /* Check permissions */
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ))
+        return 0;
+
+    if (cdata->comp_type != CAL_COMP_VEVENT)
+        return 0;
+
+    /* Count, but don't process items that exceed the maximum record count. */
+    if (changes->max_changes && ++(rock->seen_records) > changes->max_changes) {
+        changes->has_more_changes = 1;
+        return 0;
+    }
+
+    /* Report item as updated or destroyed. */
+    if (cdata->dav.alive) {
+        if (cdata->dav.createdmodseq <= changes->since_modseq)
+            json_array_append_new(changes->updated, json_string(cdata->ical_uid));
+        else
+            json_array_append_new(changes->created, json_string(cdata->ical_uid));
+    } else {
+        if (cdata->dav.createdmodseq <= changes->since_modseq)
+            json_array_append_new(changes->destroyed, json_string(cdata->ical_uid));
+    }
+
+    if (cdata->dav.modseq > rock->highestmodseq) {
+        rock->highestmodseq = cdata->dav.modseq;
+    }
+
+    return 0;
+}
+
+static int jmap_calendarevent_changes(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+    json_t *err = NULL;
+    struct caldav_db *db;
+    struct geteventchanges_rock rock = {
+        req,
+        &changes,
+        0            /*seen_records*/,
+        0            /*highestmodseq*/,
+        strcmp(req->accountid, req->userid) /* check_acl */,
+        NULL         /*mboxrights*/
+    };
+    int r = 0;
+
+    db = caldav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR, "caldav_open_mailbox failed for user %s", req->accountid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Parse request */
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Lookup changes. */
+    r = caldav_get_updates(db, changes.since_modseq, NULL /*mboxname*/,
+                           CAL_COMP_VEVENT, 
+                           changes.max_changes ? (int) changes.max_changes + 1 : -1,
+                           &geteventchanges_cb, &rock);
+    if (r) goto done;
+    strip_spurious_deletes(&rock);
+
+    /* Determine new state. */
+    changes.new_modseq = changes.has_more_changes ?
+        rock.highestmodseq : jmap_highestmodseq(req, MBTYPE_CALENDAR);
+
+    /* Build response */
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+  done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    if (rock.mboxrights) {
+        free_hash_table(rock.mboxrights, free);
+        free(rock.mboxrights);
+    }
+    if (db) caldav_close(db);
+    if (r) {
+        jmap_error(req, jmap_server_error(r));
+    }
+    return 0;
+}
+
+static void eventquery_read_timerange(json_t *filter, time_t *before, time_t *after)
+{
+    *before = caldav_eternity;
+    *after = caldav_epoch;
+
+    if (!JNOTNULL(filter)) {
+        return;
+    }
+
+    if (json_object_get(filter, "conditions")) {
+        json_t *val;
+        size_t i;
+        time_t bf, af;
+
+        json_array_foreach(json_object_get(filter, "conditions"), i, val) {
+            const char *op =
+                json_string_value(json_object_get(filter, "operator"));
+            bf = caldav_eternity;
+            af = caldav_epoch;
+
+            eventquery_read_timerange(val, &bf, &af);
+
+            if (bf != caldav_eternity) {
+                if (!strcmp(op, "OR")) {
+                    if (*before == caldav_eternity || *before < bf) {
+                        *before = bf;
+                    }
+                }
+                else if (!strcmp(op, "AND")) {
+                    if (*before == caldav_eternity || *before > bf) {
+                        *before = bf;
+                    }
+                }
+                else if (!strcmp(op, "NOT")) {
+                    if (*after == caldav_epoch || *after < bf) {
+                        *after = bf;
+                    }
+                }
+            }
+
+            if (af != caldav_epoch) {
+                if (!strcmp(op, "OR")) {
+                    if (*after == caldav_epoch || *after > af) {
+                        *after = af;
+                    }
+                }
+                else if (!strcmp(op, "AND")) {
+                    if (*after == caldav_epoch || *after < af) {
+                        *after = af;
+                    }
+                }
+                else if (!strcmp(op, "NOT")) {
+                    if (*before == caldav_eternity || *before < af) {
+                        *before = af;
+                    }
+                }
+            }
+        }
+    } else {
+        const char *sb = json_string_value(json_object_get(filter, "before"));
+        const char *sa = json_string_value(json_object_get(filter, "after"));
+
+        if (!sb || time_from_iso8601(sb, before) == -1) {
+            *before = caldav_eternity;
+        }
+        if (!sa || time_from_iso8601(sa, after) == -1) {
+            *after = caldav_epoch;
+        }
+    }
+}
+
+static int eventquery_have_textsearch(json_t *filter)
+{
+    if (!JNOTNULL(filter))
+        return 0;
+
+    json_t *jval;
+    size_t i;
+    json_array_foreach(json_object_get(filter, "conditions"), i, jval) {
+        if (eventquery_have_textsearch(jval))
+            return 1;
+    }
+
+    if (json_object_get(filter, "inCalendars") ||
+        json_object_get(filter, "text") ||
+        json_object_get(filter, "title") ||
+        json_object_get(filter, "description") ||
+        json_object_get(filter, "location") ||
+        json_object_get(filter, "owner") ||
+        json_object_get(filter, "attendee")) {
+        return 1;
+    }
+
+    return 0;
+}
+
+struct eventquery_match {
+    char *ical_uid;
+    char *utcstart;
+    icalcomponent *ical;
+    char *recurid;
+};
+
+static void eventquery_match_fini(struct eventquery_match *match)
+{
+    if (!match) return;
+    free(match->ical_uid);
+    free(match->utcstart);
+    free(match->recurid);
+    if (match->ical) icalcomponent_free(match->ical);
+}
+
+static void eventquery_match_free(struct eventquery_match **matchp) {
+    if (!matchp || !*matchp) return;
+    eventquery_match_fini(*matchp);
+    free(*matchp);
+    *matchp = NULL;
+}
+
+struct eventquery_cmp_rock {
+    enum caldav_sort *sort;
+    size_t nsort;
+};
+
+static int eventquery_cmp(const void *va, const void *vb, void *vrock)
+{
+    enum caldav_sort *sort = ((struct eventquery_cmp_rock*)vrock)->sort;
+    size_t nsort = ((struct eventquery_cmp_rock*)vrock)->nsort;
+    struct eventquery_match *ma = (struct eventquery_match*) *(void**)va;
+    struct eventquery_match *mb = (struct eventquery_match*) *(void**)vb;
+    size_t i;
+
+    for (i = 0; i < nsort; i++) {
+        int ret = 0;
+        switch (sort[i] & ~CAL_SORT_DESC) {
+            case CAL_SORT_UID:
+                ret = strcmp(ma->ical_uid, mb->ical_uid);
+                break;
+            case CAL_SORT_START:
+                ret = strcmp(ma->utcstart, mb->utcstart);
+                break;
+            default:
+                ret = 0;
+        }
+        if (ret)
+            return sort[i] & CAL_SORT_DESC ? -ret : ret;
+    }
+
+    return 0;
+}
+
+struct eventquery_rock {
+    jmap_req_t *req;
+    int expandrecur;
+    struct mailbox *mailbox;
+    ptrarray_t *matches;
+};
+
+static int eventquery_cb(void *vrock, struct caldav_data *cdata)
+{
+    struct eventquery_rock *rock = vrock;
+    jmap_req_t *req = rock->req;
+
+    if (!cdata->dav.alive || cdata->comp_type != CAL_COMP_VEVENT) {
+        return 0;
+    }
+    if (!jmap_hasrights_byname(rock->req, cdata->dav.mailbox, DACL_READ)) {
+        return 0;
+    }
+
+    struct eventquery_match *match = xzmalloc(sizeof(struct eventquery_match));
+    match->ical_uid = xstrdup(cdata->ical_uid);
+    match->utcstart = xstrdup(cdata->dtstart);
+    if (rock->expandrecur) {
+        /* Load iCalendar data */
+        if (!rock->mailbox || strcmp(rock->mailbox->name, cdata->dav.mailbox)) {
+            if (rock->mailbox) {
+                jmap_closembox(req, &rock->mailbox);
+            }
+            int r = jmap_openmbox(req, cdata->dav.mailbox, &rock->mailbox, 0);
+            if (r) return r;
+        }
+        match->ical = caldav_record_to_ical(rock->mailbox, cdata, req->userid, NULL);
+        if (!match->ical) {
+            syslog(LOG_ERR, "%s: can't load ical for ical uid %s",
+                    __func__, cdata->ical_uid);
+            eventquery_match_free(&match);
+            return IMAP_INTERNAL;
+        }
+    }
+    ptrarray_append(rock->matches, match);
+
+    return 0;
+}
+
+static void eventquery_textsearch_match(search_expr_t *parent, const char *s, const char *name)
+{
+    search_expr_t *e;
+    const search_attr_t *attr = search_attr_find(name);
+
+    e = search_expr_new(parent, SEOP_FUZZYMATCH);
+    e->attr = attr;
+    e->value.s = xstrdup(s);
+    if (!e->value.s) {
+        e->op = SEOP_FALSE;
+        e->attr = NULL;
+    }
+}
+
+static search_expr_t *eventquery_textsearch_build(jmap_req_t *req,
+                                                  json_t *filter,
+                                                  search_expr_t *parent)
+{
+    search_expr_t *this, *e;
+    const char *s;
+    size_t i;
+    json_t *val, *arg;
+
+    if (!JNOTNULL(filter)) {
+        return search_expr_new(parent, SEOP_TRUE);
+    }
+
+    if ((s = json_string_value(json_object_get(filter, "operator")))) {
+        enum search_op op = SEOP_UNKNOWN;
+
+        if (!strcmp("AND", s)) {
+            op = SEOP_AND;
+        } else if (!strcmp("OR", s)) {
+            op = SEOP_OR;
+        } else if (!strcmp("NOT", s)) {
+            op = SEOP_NOT;
+        }
+
+        this = search_expr_new(parent, op);
+        e = op == SEOP_NOT ? search_expr_new(this, SEOP_OR) : this;
+
+        json_array_foreach(json_object_get(filter, "conditions"), i, val) {
+            eventquery_textsearch_build(req, val, e);
+        }
+    } else {
+        this = search_expr_new(parent, SEOP_AND);
+
+        if ((arg = json_object_get(filter, "inCalendars"))) {
+            e = search_expr_new(this, SEOP_OR);
+            json_array_foreach(arg, i, val) {
+                const char *id = json_string_value(val);
+                search_expr_t *m = search_expr_new(e, SEOP_MATCH);
+                m->attr = search_attr_find("folder");
+                m->value.s = caldav_mboxname(req->accountid, id);
+            }
+        }
+
+        if ((s = json_string_value(json_object_get(filter, "text")))) {
+            e = search_expr_new(this, SEOP_OR);
+            eventquery_textsearch_match(e, s, "body");
+            eventquery_textsearch_match(e, s, "subject");
+            eventquery_textsearch_match(e, s, "from");
+            eventquery_textsearch_match(e, s, "to");
+            eventquery_textsearch_match(e, s, "location");
+        }
+        if ((s = json_string_value(json_object_get(filter, "title")))) {
+            eventquery_textsearch_match(this, s, "subject");
+        }
+        if ((s = json_string_value(json_object_get(filter, "description")))) {
+            eventquery_textsearch_match(this, s, "body");
+        }
+        if ((s = json_string_value(json_object_get(filter, "location")))) {
+            eventquery_textsearch_match(this, s, "location");
+        }
+        if ((s = json_string_value(json_object_get(filter, "owner")))) {
+            eventquery_textsearch_match(this, s, "from");
+        }
+        if ((s = json_string_value(json_object_get(filter, "attendee")))) {
+            eventquery_textsearch_match(this, s, "to");
+        }
+    }
+
+    return this;
+}
+
+
+static int eventquery_search_run(jmap_req_t *req,
+                                 json_t *filter,
+                                 struct caldav_db *db,
+                                 time_t before, time_t after,
+                                 enum caldav_sort *sort,
+                                 size_t nsort,
+                                 int expandrecur,
+                                 ptrarray_t *matches)
+{
+    int r, i;
+    struct searchargs *searchargs = NULL;
+    struct index_init init;
+    struct index_state *state = NULL;
+    search_query_t *query = NULL;
+    struct sortcrit *sortcrit = NULL;
+    struct buf buf = BUF_INITIALIZER;
+    char *icalbefore = NULL;
+    char *icalafter = NULL;
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+    struct mailbox *mailbox = NULL;
+    const char *wantuid = json_string_value(json_object_get(filter, "uid"));
+
+    if (before != caldav_eternity) {
+        icaltimetype t = icaltime_from_timet_with_zone(before, 0, utc);
+        icalbefore = icaltime_as_ical_string_r(t);
+    }
+    if (after != caldav_epoch) {
+        icaltimetype t = icaltime_from_timet_with_zone(after, 0, utc);
+        icalafter = icaltime_as_ical_string_r(t);
+    }
+
+    /* Build searchargs */
+    searchargs = new_searchargs(NULL, GETSEARCH_CHARSET_FIRST,
+            &jmap_namespace, req->accountid, req->authstate, 0);
+    searchargs->root = eventquery_textsearch_build(req, filter, NULL);
+
+    sortcrit = xzmalloc(2 * sizeof(struct sortcrit));
+    sortcrit[0].key = SORT_FOLDER;
+    sortcrit[1].key = SORT_SEQUENCE;
+
+    /* Run the search query */
+    memset(&init, 0, sizeof(init));
+    init.userid = req->accountid;
+    init.authstate = req->authstate;
+    init.want_expunged = 0;
+    init.want_mbtype = MBTYPE_CALENDAR;
+    init.examine_mode = 1;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    r = index_open(inboxname, &init, &state);
+    free(inboxname);
+    if (r) goto done;
+
+    query = search_query_new(state, searchargs);
+    query->sortcrit = sortcrit;
+    query->multiple = 1;
+    query->need_ids = 1;
+    query->want_expunged = 0;
+    query->want_mbtype = MBTYPE_CALENDAR;
+    r = search_query_run(query);
+    if (r && r != IMAP_NOTFOUND) goto done;
+
+    /* Process result */
+    for (i = 0 ; i < query->merged_msgdata.count; i++) {
+        MsgData *md = ptrarray_nth(&query->merged_msgdata, i);
+
+        search_folder_t *folder = md->folder;
+        if (!folder || !jmap_hasrights_byname(req, folder->mboxname, DACL_READ)) {
+            continue;
+        }
+
+        struct caldav_data *cdata;
+        if (caldav_lookup_imapuid(db, folder->mboxname, md->uid, &cdata, 0) == 0) {
+
+            /* Check time-range */
+            if (icalafter && strcmp(cdata->dtend, icalafter) <= 0)
+                continue;
+            if (icalbefore && strcmp(cdata->dtstart, icalbefore) >= 0)
+                continue;
+
+            if (wantuid && strcmp(wantuid, cdata->ical_uid))
+                continue;
+
+            struct eventquery_match *match = xzmalloc(sizeof(struct eventquery_match));
+            match->ical_uid = xstrdup(cdata->ical_uid);
+            match->utcstart = xstrdup(cdata->dtstart);
+            if (expandrecur) {
+                /* Load iCalendar data */
+                if (!mailbox || strcmp(mailbox->name, cdata->dav.mailbox)) {
+                    if (mailbox) {
+                        jmap_closembox(req, &mailbox);
+                    }
+                    r = jmap_openmbox(req, cdata->dav.mailbox, &mailbox, 0);
+                    if (r) goto done;
+                }
+
+                match->ical = caldav_record_to_ical(mailbox, cdata, req->userid, NULL);
+                if (!match->ical) {
+                    syslog(LOG_ERR, "%s: can't load ical for ical uid %s",
+                           __func__, cdata->ical_uid);
+                    free(match->ical_uid);
+                    free(match->utcstart);
+                    free(match);
+                    r = IMAP_INTERNAL;
+                    goto done;
+                }
+            }
+            ptrarray_append(matches, match);
+        }
+    }
+
+    if (!expandrecur) {
+        struct eventquery_cmp_rock rock = { sort, nsort };
+        cyr_qsort_r(matches->data, matches->count, sizeof(void*),
+                    (int(*)(const void*, const void*, void*))eventquery_cmp, &rock);
+    }
+
+    r = 0;
+
+done:
+    index_close(&state);
+    if (searchargs) freesearchargs(searchargs);
+    if (sortcrit) freesortcrit(sortcrit);
+    if (query) search_query_free(query);
+    jmap_closembox(req, &mailbox);
+    free(icalbefore);
+    free(icalafter);
+    buf_free(&buf);
+    return r;
+}
+
+struct eventquery_fastpath_rock {
+    jmap_req_t *req;
+    struct jmap_query *query;
+};
+
+static int eventquery_fastpath_cb(void *rock, struct caldav_data *cdata)
+{
+    jmap_req_t *req = ((struct eventquery_fastpath_rock*)rock)->req;
+    struct jmap_query *query = ((struct eventquery_fastpath_rock*)rock)->query;
+
+    assert(query->position >= 0);
+
+    /* Check type and permissions */
+    if (!cdata->dav.alive || cdata->comp_type != CAL_COMP_VEVENT) {
+        return 0;
+    }
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        return 0;
+    }
+
+    query->total++;
+
+    /* Check search window */
+    if (query->have_limit && json_array_size(query->ids) >= query->limit) {
+        return 0;
+    }
+    if (query->position && (size_t) query->position <= query->total - 1) {
+        return 0;
+    }
+
+    json_array_append_new(query->ids, json_string(cdata->ical_uid));
+
+    return 0;
+}
+
+struct eventquery_recur_rock {
+    ptrarray_t *matches;
+    struct buf *buf;
+};
+
+static const char *eventquery_recur_make_recurid(icalcomponent *comp,
+                                                 icaltimetype start,
+                                                 struct buf *buf)
+{
+    struct jmapical_datetime recuriddt = JMAPICAL_DATETIME_INITIALIZER;
+
+    icalproperty *prop;
+    if ((prop = icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY))) {
+        /* Recurrence override. */
+        jmapical_datetime_from_icalprop(prop, &recuriddt);
+    }
+    else {
+        /* RDATE or regular reccurence instance */
+        for (prop = icalcomponent_get_first_property(comp, ICAL_RDATE_PROPERTY);
+             prop;
+             prop = icalcomponent_get_next_property(comp, ICAL_RDATE_PROPERTY)) {
+            /* Read subseconds from RDATE */
+            struct icaldatetimeperiodtype tval = icalproperty_get_rdate(prop);
+            if (icaltime_compare(tval.time, start)) {
+                /* XXX - could handle PERIOD type here */
+                struct jmapical_datetime tmpdt = JMAPICAL_DATETIME_INITIALIZER;
+                jmapical_datetime_from_icalprop(prop, &tmpdt);
+                recuriddt.nano = tmpdt.nano;
+                break;
+            }
+        }
+        if (!recuriddt.nano) {
+            /* Read subseconds from DTSTART */
+            jmapical_datetime_from_icaltime(start, &recuriddt);
+            prop = icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY);
+            struct jmapical_datetime tmpdt = JMAPICAL_DATETIME_INITIALIZER;
+            if (prop) jmapical_datetime_from_icalprop(prop, &tmpdt);
+            recuriddt.nano = tmpdt.nano;
+        }
+    }
+
+    buf_reset(buf);
+    jmapical_localdatetime_as_string(&recuriddt, buf);
+    return buf_cstring(buf);
+}
+
+static int eventquery_recur_cb(icalcomponent *comp,
+                               icaltimetype start,
+                               icaltimetype end __attribute__((unused)),
+                               void *vrock)
+{
+    struct eventquery_recur_rock *rock = vrock;
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+    icaltimetype utcstart = icaltime_convert_to_zone(start, utc);
+
+    struct eventquery_match *match = xzmalloc(sizeof(struct eventquery_match));
+    match->ical_uid = xstrdup(icalcomponent_get_uid(comp));
+    match->utcstart = xstrdup(icaltime_as_ical_string(utcstart));
+    match->recurid = xstrdup(eventquery_recur_make_recurid(comp, start, rock->buf));
+    ptrarray_append(rock->matches, match);
+
+    return 1;
+}
+
+static int eventquery_run(jmap_req_t *req,
+                          struct jmap_query *query,
+                          int expandrecur,
+                          json_t **err)
+{
+    time_t before = caldav_eternity;
+    time_t after = caldav_epoch;
+    int r = HTTP_NOT_IMPLEMENTED;
+    enum caldav_sort *sort = NULL;
+    size_t nsort = 0;
+
+    /* Sanity check arguments */
+    eventquery_read_timerange(query->filter, &before, &after);
+    if (expandrecur && before == caldav_eternity) {
+        /* Reject unbounded time-ranges for recurrence expansion */
+        *err = json_pack("{s:s s:[s] s:s}", "type", "invalidArguments",
+                "arguments", "expandRecurrences",
+                "description","upper time-range filter MUST be set");
+        return 0;
+    }
+
+    ptrarray_t matches = PTRARRAY_INITIALIZER;
+
+    /* Open Caldav DB */
+    struct caldav_db *db = caldav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR, "%s:%s: can't open caldav db for %s",
+                        __FILE__, __func__, req->accountid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Parse sort */
+    if (json_array_size(query->sort)) {
+        nsort = json_array_size(query->sort);
+        sort = xzmalloc(nsort * sizeof(enum caldav_sort));
+        json_t *jval;
+        size_t i;
+        json_array_foreach(query->sort, i, jval) {
+            const char *prop = json_string_value(json_object_get(jval, "property"));
+            if (!strcmp(prop, "start"))
+                sort[i] = CAL_SORT_START;
+            else if (!strcmp(prop, "uid"))
+                sort[i] = CAL_SORT_UID;
+            else
+                sort[i] = CAL_SORT_NONE;
+            if (json_object_get(jval, "isAscending") == json_false()) {
+                sort[i] |= CAL_SORT_DESC;
+            }
+        }
+    }
+
+    int have_textsearch = eventquery_have_textsearch(query->filter);
+
+    /* Attempt to fast-path trivial query */
+
+    if (!have_textsearch && !expandrecur && query->position >= 0 && !query->anchor) {
+        struct eventquery_fastpath_rock rock = { req, query };
+        const char *wantuid = json_string_value(json_object_get(query->filter, "uid"));
+        if (wantuid) {
+            /* Super fast path!  We only want a single UID */
+            struct caldav_data *cdata = NULL;
+            r = caldav_lookup_uid(db, wantuid, &cdata);
+            if (!r) eventquery_fastpath_cb(&rock, cdata);
+            if (r == CYRUSDB_NOTFOUND) r = 0;
+        }
+        else {
+            /* Fast-path: we can offload most processing to Caldav DB. */
+            r = caldav_foreach_timerange(db, NULL, after, before, sort, nsort,
+                                         eventquery_fastpath_cb, &rock);
+        }
+        goto done;
+    }
+
+    /* Handle non-trivial query */
+
+    if (have_textsearch) {
+        /* Query and sort matches in search backend. */
+        r = eventquery_search_run(req, query->filter, db, before, after,
+                                  sort, nsort, expandrecur, &matches);
+        if (r) goto done;
+    }
+    else {
+        /* Query and sort matches in Caldav DB. */
+        struct eventquery_rock rock = { req, expandrecur, NULL, &matches };
+        enum caldav_sort mboxsort = CAL_SORT_MAILBOX;
+        r = caldav_foreach_timerange(db, NULL, after, before,
+                                     expandrecur ? &mboxsort : sort,
+                                     expandrecur ? 1 : nsort,
+                                     eventquery_cb, &rock);
+        jmap_closembox(req, &rock.mailbox);
+    }
+
+    if (expandrecur) {
+        /* Expand and sort recurrence instance matches */
+        icaltimezone *utc = icaltimezone_get_utc_timezone();
+        struct icalperiodtype timerange = {
+            icaltime_from_timet_with_zone(after, 0, utc),
+            icaltime_from_timet_with_zone(before, 0, utc),
+            icaldurationtype_null_duration()
+        };
+        ptrarray_t mymatches = PTRARRAY_INITIALIZER;
+        struct buf buf = BUF_INITIALIZER;
+        struct eventquery_match *match;
+        while ((match = ptrarray_pop(&matches))) {
+            icalcomponent *comp = icalcomponent_get_first_real_component(match->ical);
+            icalcomponent_kind kind = icalcomponent_isa(comp);
+
+            int is_recurring = 0;
+            for (; comp; comp = icalcomponent_get_next_component(match->ical, kind)) {
+                if (icalcomponent_get_first_property(comp, ICAL_RRULE_PROPERTY) ||
+                    icalcomponent_get_first_property(comp, ICAL_RDATE_PROPERTY)) {
+                    is_recurring = 1;
+                    break;
+                }
+            }
+
+            if (is_recurring) {
+                /* Expand all instances, we need them for totals */
+                /* XXX - need tooManyRecurrenceInstances error ? */
+                struct eventquery_recur_rock rock = { &mymatches, &buf };
+                icalcomponent_myforeach(match->ical, timerange, utc,
+                                        eventquery_recur_cb, &rock);
+                eventquery_match_free(&match);
+            }
+            else ptrarray_append(&mymatches, match);
+        }
+        buf_free(&buf);
+
+        ptrarray_fini(&matches);
+        matches = mymatches;
+
+        struct eventquery_cmp_rock rock = { sort, nsort };
+        cyr_qsort_r(matches.data, matches.count, sizeof(void*), eventquery_cmp, &rock);
+    }
+
+    query->total = ptrarray_size(&matches);
+
+    /* Determine start position of result list */
+    size_t startpos = 0;
+    if (query->anchor) {
+        size_t j;
+        for (j = 0; j < (size_t) ptrarray_size(&matches); j++) {
+            struct eventquery_match *m = ptrarray_nth(&matches, j);
+            if (!strcmp(query->anchor, m->ical_uid)) {
+                /* Found anchor */
+                if (query->anchor_offset < 0) {
+                    startpos = (size_t) -query->anchor_offset > j ?
+                        0 : j + query->anchor_offset;
+                }
+                else {
+                    startpos = j + query->anchor_offset;
+                }
+                break;
+            }
+        }
+    }
+    else if (query->position < 0) {
+        startpos = -query->position > ptrarray_size(&matches) ?
+            0 : ptrarray_size(&matches) + query->position;
+    }
+    else startpos = query->position;
+
+    /* Build result list */
+    size_t i;
+    struct buf buf = BUF_INITIALIZER;
+    for (i = startpos; i < (size_t) ptrarray_size(&matches); i++) {
+        if (query->have_limit && json_array_size(query->ids) >= query->limit) {
+            break;
+        }
+        struct eventquery_match *m = ptrarray_nth(&matches, i);
+        const char *id;
+        if (m->recurid) {
+            buf_setcstr(&buf, m->ical_uid);
+            buf_putc(&buf, ';');
+            buf_appendcstr(&buf, m->recurid);
+            id = buf_cstring(&buf);
+        }
+        else id = m->ical_uid;
+        json_array_append_new(query->ids, json_string(id));
+    }
+    buf_free(&buf);
+
+done:
+    if (db) caldav_close(db);
+    if (ptrarray_size(&matches)) {
+        int j;
+        for (j = 0; j < ptrarray_size(&matches); j++) {
+            struct eventquery_match *match = ptrarray_nth(&matches, j);
+            eventquery_match_free(&match);
+        }
+    }
+    ptrarray_fini(&matches);
+    free(sort);
+    return r;
+}
+
+static void validatefilter(jmap_req_t *req __attribute__((unused)),
+                           struct jmap_parser *parser,
+                           json_t *filter,
+                           json_t *unsupported __attribute__((unused)),
+                           void *rock __attribute__((unused)),
+                           json_t **err __attribute__((unused)))
+{
+    const char *field;
+    json_t *arg;
+
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "inCalendars")) {
+            if (!(json_is_array(arg) && json_array_size(arg))) {
+                jmap_parser_invalid(parser, field);
+            }
+            else {
+                size_t i;
+                json_t *uid;
+                json_array_foreach(arg, i, uid) {
+                    const char *id = json_string_value(uid);
+                    if (!id || id[0] == '#') {
+                        jmap_parser_push_index(parser, field, i, id);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                    }
+                }
+            }
+        }
+        else if (!strcmp(field, "before") ||
+                 !strcmp(field, "after")) {
+            const char *s;
+            if ((s = json_string_value(arg))) {
+                int is_valid = 0;
+                size_t len = strlen(s);
+                if (len && s[len-1] == 'Z') {
+                    /* Validate UTCDateTime */
+                    struct tm tm;
+                    memset(&tm, 0, sizeof(struct tm));
+                    tm.tm_isdst = -1;
+                    const char *p = strptime(s, "%Y-%m-%dT%H:%M:%S", &tm);
+                    is_valid = p && *p == 'Z';
+                }
+                if (!is_valid) jmap_parser_invalid(parser, field);
+            }
+            else jmap_parser_invalid(parser, field);
+        }
+        else if (!strcmp(field, "text") ||
+                 !strcmp(field, "title") ||
+                 !strcmp(field, "description") ||
+                 !strcmp(field, "location") ||
+                 !strcmp(field, "uid") ||
+                 !strcmp(field, "owner") ||
+                 !strcmp(field, "attendee")) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+static int validatecomparator(jmap_req_t *req __attribute__((unused)),
+                              struct jmap_comparator *comp,
+                              void *rock __attribute__((unused)),
+                              json_t **err __attribute__((unused)))
+{
+    /* Reject any collation */
+    if (comp->collation) {
+        return 0;
+    }
+    if (!strcmp(comp->property, "start") ||
+        !strcmp(comp->property, "uid")) {
+        return 1;
+    }
+    return 0;
+}
+
+static int _calendarevent_queryargs_parse(jmap_req_t *req __attribute__((unused)),
+                                          struct jmap_parser *parser __attribute__((unused)),
+                                          const char *argname,
+                                          json_t *argval,
+                                          void *rock)
+{
+    if (strcmp(argname, "expandRecurrences")) return 0;
+
+    if (json_is_boolean(argval)) {
+        int *expandrecur = rock;
+        *expandrecur = json_boolean_value(argval);
+    }
+    else {
+        jmap_parser_invalid(parser, argname);
+    }
+    return 1;
+}
+
+static int jmap_calendarevent_query(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_query query;
+    int expandrecur = 0;
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_query_parse(req, &parser,
+                     _calendarevent_queryargs_parse, &expandrecur,
+                     validatefilter, NULL,
+                     validatecomparator, NULL,
+                     &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+    if (json_array_size(parser.invalid)) {
+        err = json_pack("{s:s}", "type", "invalidArguments");
+        json_object_set(err, "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    int r = eventquery_run(req, &query, expandrecur, &err);
+    if (r || err) {
+        if (!err) err = jmap_server_error(r);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_CALENDAR, /*refresh*/0);
+    query.query_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    json_t *res = jmap_query_reply(&query);
+    jmap_ok(req, res);
+
+done:
+    jmap_query_fini(&query);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static void _calendarevent_copy(jmap_req_t *req,
+                                json_t *jevent,
+                                struct caldav_db *src_db,
+                                struct caldav_db *dst_db,
+                                json_t **new_event,
+                                json_t **set_err)
+{
+    struct jmap_parser myparser = JMAP_PARSER_INITIALIZER;
+    icalcomponent *src_ical = NULL;
+    json_t *dst_event = NULL;
+    struct mailbox *src_mbox = NULL;
+    strarray_t schedule_addresses = STRARRAY_INITIALIZER;
+    int r = 0;
+
+    /* Read mandatory properties */
+    const char *src_id = json_string_value(json_object_get(jevent, "id"));
+    const char *dst_calendar_id = json_string_value(json_object_get(jevent, "calendarId"));
+    if (!src_id) {
+        jmap_parser_invalid(&myparser, "id");
+    }
+    if (!dst_calendar_id) {
+        jmap_parser_invalid(&myparser, "calendarId");
+    }
+    if (json_array_size(myparser.invalid)) {
+        *set_err = json_pack("{s:s s:O}", "type", "invalidProperties",
+                                          "properties", myparser.invalid);
+        goto done;
+    }
+
+    /* Lookup event */
+    struct caldav_data *cdata = NULL;
+    r = caldav_lookup_uid(src_db, src_id, &cdata);
+    if (r && r != CYRUSDB_NOTFOUND) {
+        syslog(LOG_ERR, "caldav_lookup_uid(%s) failed: %s", src_id, error_message(r));
+        goto done;
+    }
+    if (r == CYRUSDB_NOTFOUND || !cdata->dav.alive || !cdata->dav.rowid ||
+            !cdata->dav.imap_uid || cdata->comp_type != CAL_COMP_VEVENT) {
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+
+    /* Read source event */
+    r = jmap_openmbox(req, cdata->dav.mailbox, &src_mbox, /*rw*/0);
+    if (r) goto done;
+    src_ical = caldav_record_to_ical(src_mbox, cdata, httpd_userid, &schedule_addresses);
+    if (!src_ical) {
+        syslog(LOG_ERR, "calendarevent_copy: can't convert %s to JMAP", src_id);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Patch JMAP event */
+    json_t *src_event = jmapical_tojmap(src_ical, NULL);
+    if (src_event) {
+        dst_event = jmap_patchobject_apply(src_event, jevent, NULL);
+    }
+    json_decref(src_event);
+    if (!dst_event) {
+        syslog(LOG_ERR, "calendarevent_copy: can't convert to ical: %s", src_id);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Create event */
+    json_t *invalid = json_array();
+    *new_event = json_pack("{}");
+    r = setcalendarevents_create(req, req->accountid, dst_event,
+                                 dst_db, invalid, *new_event);
+    if (r || json_array_size(invalid)) {
+        if (!r) {
+            *set_err = json_pack("{s:s s:o}", "type", "invalidProperties",
+                                              "properties", invalid);
+        }
+        goto done;
+    }
+    json_decref(invalid);
+    json_object_set(*new_event, "id", json_object_get(*new_event, "uid"));
+
+done:
+    if (r && *set_err == NULL) {
+        if (r == CYRUSDB_NOTFOUND)
+            *set_err = json_pack("{s:s}", "type", "notFound");
+        else
+            *set_err = jmap_server_error(r);
+        return;
+    }
+    jmap_closembox(req, &src_mbox);
+    strarray_fini(&schedule_addresses);
+    if (src_ical) icalcomponent_free(src_ical);
+    json_decref(dst_event);
+    jmap_parser_fini(&myparser);
+}
+
+static int jmap_calendarevent_copy(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_copy copy;
+    json_t *err = NULL;
+    struct caldav_db *src_db = NULL;
+    struct caldav_db *dst_db = NULL;
+    json_t *destroy_events = json_array();
+
+    /* Parse request */
+    jmap_copy_parse(req, &parser, NULL, NULL, &copy, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    src_db = caldav_open_userid(copy.from_account_id);
+    if (!src_db) {
+        jmap_error(req, json_pack("{s:s}", "type", "fromAccountNotFound"));
+        goto done;
+    }
+    dst_db = caldav_open_userid(req->accountid);
+    if (!dst_db) {
+        jmap_error(req, json_pack("{s:s}", "type", "toAccountNotFound"));
+        goto done;
+    }
+
+    /* Process request */
+    const char *creation_id;
+    json_t *jevent;
+    json_object_foreach(copy.create, creation_id, jevent) {
+        /* Copy event */
+        json_t *set_err = NULL;
+        json_t *new_event = NULL;
+
+        _calendarevent_copy(req, jevent, src_db, dst_db, &new_event, &set_err);
+        if (set_err) {
+            json_object_set_new(copy.not_created, creation_id, set_err);
+            continue;
+        }
+
+        // copy the ID for later deletion
+        json_array_append(destroy_events, json_object_get(jevent, "id"));
+
+        /* Report event as created */
+        json_object_set_new(copy.created, creation_id, new_event);
+        const char *event_id = json_string_value(json_object_get(new_event, "id"));
+        jmap_add_id(req, creation_id, event_id);
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_copy_reply(&copy));
+
+    /* Destroy originals, if requested */
+    if (copy.on_success_destroy_original && json_array_size(destroy_events)) {
+        json_t *subargs = json_object();
+        json_object_set(subargs, "destroy", destroy_events);
+        json_object_set_new(subargs, "accountId", json_string(copy.from_account_id));
+        jmap_add_subreq(req, "CalendarEvent/set", subargs, NULL);
+    }
+
+done:
+    json_decref(destroy_events);
+    if (src_db) caldav_close(src_db);
+    if (dst_db) caldav_close(dst_db);
+    jmap_parser_fini(&parser);
+    jmap_copy_fini(&copy);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_contact.c 3.2.0-3/imap/jmap_contact.c
--- 3.0.13-5/imap/jmap_contact.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_contact.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,4256 @@
+/* jmap_contact.c -- Routines for handling JMAP contact messages
+ *
+ * Copyright (c) 1994-2014 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+#include <errno.h>
+
+#include "annotate.h"
+#include "carddav_db.h"
+#include "cyr_qsort_r.h"
+#include "global.h"
+#include "hash.h"
+#include "http_carddav.h"
+#include "http_dav.h"
+#include "http_jmap.h"
+#include "json_support.h"
+#include "mailbox.h"
+#include "mboxname.h"
+#include "stristr.h"
+#include "times.h"
+#include "util.h"
+#include "vcard_support.h"
+#include "xapian_wrap.h"
+#include "xmalloc.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+static int jmap_contactgroup_get(struct jmap_req *req);
+static int jmap_contactgroup_changes(struct jmap_req *req);
+static int jmap_contactgroup_set(struct jmap_req *req);
+static int jmap_contactgroup_query(struct jmap_req *req);
+static int jmap_contact_get(struct jmap_req *req);
+static int jmap_contact_changes(struct jmap_req *req);
+static int jmap_contact_query(struct jmap_req *req);
+static int jmap_contact_set(struct jmap_req *req);
+static int jmap_contact_copy(struct jmap_req *req);
+
+static int _contact_set_create(jmap_req_t *req, unsigned kind,
+                               json_t *jcard, struct carddav_data *cdata,
+                               struct mailbox **mailbox, json_t *item,
+                               json_t *invalid);
+static int required_set_rights(json_t *props);
+static int _json_to_card(struct jmap_req *req,
+                         struct carddav_data *cdata,
+                         struct vparse_card *card,
+                         json_t *arg, strarray_t *flags,
+                         struct entryattlist **annotsp,
+                         json_t *invalid);
+
+static json_t *jmap_contact_from_vcard(struct vparse_card *card,
+                                       struct mailbox *mailbox,
+                                       struct index_record *record);
+
+static int jmap_contact_getblob(jmap_req_t *req, const char *blobid,
+                                const char *accept);
+
+#define JMAPCACHE_CONTACTVERSION 1
+
+jmap_method_t jmap_contact_methods_standard[] = {
+    { NULL, NULL, NULL, 0}
+};
+
+jmap_method_t jmap_contact_methods_nonstandard[] = {
+    {
+        "ContactGroup/get",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contactgroup_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "ContactGroup/changes",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contactgroup_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "ContactGroup/set",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contactgroup_set,
+        /*flags*/0
+    },
+    {
+        "ContactGroup/query",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contactgroup_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Contact/get",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contact_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Contact/changes",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contact_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Contact/query",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contact_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Contact/set",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contact_set,
+        /*flags*/0
+    },
+    {
+        "Contact/copy",
+        JMAP_CONTACTS_EXTENSION,
+        &jmap_contact_copy,
+        /*flags*/0
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+static char *_prodid = NULL;
+
+HIDDEN void jmap_contact_init(jmap_settings_t *settings)
+{
+    jmap_method_t *mp;
+    for (mp = jmap_contact_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(settings->server_capabilities,
+                JMAP_CONTACTS_EXTENSION, json_object());
+
+        for (mp = jmap_contact_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+
+    ptrarray_append(&settings->getblob_handlers, jmap_contact_getblob);
+
+    /* Initialize PRODID value
+     *
+     * XXX - OS X 10.11.6 Contacts is not unfolding PRODID lines, so make
+     * sure that PRODID never exceeds the 75 octet limit without CRLF */
+    struct buf prodidbuf = BUF_INITIALIZER;
+    size_t max_len = 68; /* 75 - strlen("PRODID:") */
+    buf_printf(&prodidbuf, "-//CyrusIMAP.org//Cyrus %s//EN", CYRUS_VERSION);
+    if (buf_len(&prodidbuf) > max_len) {
+        buf_truncate(&prodidbuf, max_len - 6);
+        buf_appendcstr(&prodidbuf, "..//EN");
+    }
+    _prodid = buf_release(&prodidbuf);
+}
+
+HIDDEN void jmap_contact_capabilities(json_t *account_capabilities)
+{
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(account_capabilities, JMAP_CONTACTS_EXTENSION, json_object());
+    }
+}
+
+struct changes_rock {
+    jmap_req_t *req;
+    struct jmap_changes *changes;
+    size_t seen_records;
+    modseq_t highestmodseq;
+};
+
+static void strip_spurious_deletes(struct changes_rock *urock)
+{
+    /* if something is mentioned in both DELETEs and UPDATEs, it's probably
+     * a move.  O(N*M) algorithm, but there are rarely many, and the alternative
+     * of a hash will cost more */
+    unsigned i, j;
+
+    for (i = 0; i < json_array_size(urock->changes->destroyed); i++) {
+        const char *del =
+            json_string_value(json_array_get(urock->changes->destroyed, i));
+
+        for (j = 0; j < json_array_size(urock->changes->updated); j++) {
+            const char *up =
+                json_string_value(json_array_get(urock->changes->updated, j));
+            if (!strcmpsafe(del, up)) {
+                json_array_remove(urock->changes->destroyed, i--);
+                break;
+            }
+        }
+    }
+}
+
+/*****************************************************************************
+ * JMAP Contacts API
+ ****************************************************************************/
+
+struct cards_rock {
+    struct carddav_db *db;
+    struct jmap_req *req;
+    struct jmap_get *get;
+    struct mailbox *mailbox;
+    hashu64_table jmapcache;
+    int rows;
+};
+
+static json_t *jmap_group_from_vcard(struct vparse_card *vcard)
+{
+    struct vparse_entry *ventry = NULL;
+    json_t *obj = json_pack("{}");
+
+    json_t *contactids = json_pack("[]");
+    json_t *otherids = json_pack("{}");
+
+    for (ventry = vcard->properties; ventry; ventry = ventry->next) {
+        const char *name = ventry->name;
+        const char *propval = ventry->v.value;
+
+        if (!name) continue;
+        if (!propval) continue;
+
+        if (!strcasecmp(name, "fn")) {
+            json_object_set_new(obj, "name", json_string(propval));
+        }
+
+        else if (!strcasecmp(name, "x-addressbookserver-member")) {
+            if (strncmp(propval, "urn:uuid:", 9)) continue;
+            json_array_append_new(contactids, json_string(propval+9));
+        }
+
+        else if (!strcasecmp(name, "x-fm-otheraccount-member")) {
+            if (strncmp(propval, "urn:uuid:", 9)) continue;
+            struct vparse_param *param = vparse_get_param(ventry, "userid");
+            if (!param) continue;
+            json_t *object = json_object_get(otherids, param->value);
+            if (!object) {
+                object = json_array();
+                json_object_set_new(otherids, param->value, object);
+            }
+            json_array_append_new(object, json_string(propval+9));
+        }
+    }
+
+    json_object_set_new(obj, "contactIds", contactids);
+    json_object_set_new(obj, "otherAccountContactIds", otherids);
+
+    return obj;
+}
+
+static int getgroups_cb(void *rock, struct carddav_data *cdata)
+{
+    struct cards_rock *crock = (struct cards_rock *) rock;
+    struct index_record record;
+    jmap_req_t *req = crock->req;
+    json_t *obj = NULL;
+    char *xhref;
+    int r;
+
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ))
+        return 0;
+
+    if (cdata->jmapversion == JMAPCACHE_CONTACTVERSION) {
+        json_error_t jerr;
+        obj = json_loads(cdata->jmapdata, 0, &jerr);
+        if (obj) goto gotvalue;
+    }
+
+    if (!crock->mailbox || strcmp(crock->mailbox->name, cdata->dav.mailbox)) {
+        mailbox_close(&crock->mailbox);
+        r = mailbox_open_irl(cdata->dav.mailbox, &crock->mailbox);
+        if (r) return r;
+    }
+
+    r = mailbox_find_index_record(crock->mailbox, cdata->dav.imap_uid, &record);
+    if (r) return r;
+
+    /* Load message containing the resource and parse vcard data */
+    struct vparse_card *vcard = record_to_vcard(crock->mailbox, &record);
+    if (!vcard || !vcard->objects) {
+        syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
+                cdata->dav.imap_uid, crock->mailbox->name);
+        vparse_free_card(vcard);
+        return IMAP_INTERNAL;
+    }
+
+    obj = jmap_group_from_vcard(vcard->objects);
+
+    vparse_free_card(vcard);
+
+    hashu64_insert(cdata->dav.rowid, json_dumps(obj, 0), &crock->jmapcache);
+
+gotvalue:
+
+    json_object_set_new(obj, "id", json_string(cdata->vcard_uid));
+    json_object_set_new(obj, "uid", json_string(cdata->vcard_uid));
+
+    json_object_set_new(obj, "addressbookId",
+                        json_string(strrchr(cdata->dav.mailbox, '.')+1));
+
+    xhref = jmap_xhref(cdata->dav.mailbox, cdata->dav.resource);
+    json_object_set_new(obj, "x-href", json_string(xhref));
+    free(xhref);
+
+    json_array_append_new(crock->get->list, obj);
+
+    crock->rows++;
+
+    return 0;
+}
+
+static const jmap_property_t contact_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "uid",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "isFlagged",
+        NULL,
+        0
+    },
+    {
+        "avatar",
+        NULL,
+        0
+    },
+    {
+        "prefix",
+        NULL,
+        0
+    },
+    {
+        "firstName",
+        NULL,
+        0
+    },
+    {
+        "lastName",
+        NULL,
+        0
+    },
+    {
+        "suffix",
+        NULL,
+        0
+    },
+    {
+        "nickname",
+        NULL,
+        0
+    },
+    {
+        "birthday",
+        NULL,
+        0
+    },
+    {
+        "anniversary",
+        NULL,
+        0
+    },
+    {
+        "company",
+        NULL,
+        0
+    },
+    {
+        "department",
+        NULL,
+        0
+    },
+    {
+        "jobTitle",
+        NULL,
+        0
+    },
+    {
+        "emails",
+        NULL,
+        0
+    },
+    {
+        "phones",
+        NULL,
+        0
+    },
+    {
+        "online",
+        NULL,
+        0
+    },
+    {
+        "addresses",
+        NULL,
+        0
+    },
+    {
+        "notes",
+        NULL,
+        0
+    },
+
+    /* FM extensions */
+    {
+        "addressbookId",
+        JMAP_CONTACTS_EXTENSION,
+        0
+    },
+    {
+        "x-href",
+        JMAP_CONTACTS_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    }, // AJAXUI only
+    {
+        "x-hasPhoto",
+        JMAP_CONTACTS_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    }, // AJAXUI only
+    {
+        "importance",
+        JMAP_CONTACTS_EXTENSION,
+        0
+    },  // JMAPUI only
+    {
+        "blobId",
+        JMAP_CONTACTS_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_SKIP_GET
+    },
+
+    { NULL, NULL, 0 }
+};
+
+static const jmap_property_t group_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "uid",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "name",
+        NULL,
+        0
+    },
+    {
+        "contactIds",
+        NULL,
+        0
+    },
+
+    // FM extensions */
+    {
+        "addressbookId",
+        JMAP_CONTACTS_EXTENSION,
+        0
+    },
+    {
+        "x-href",
+        JMAP_CONTACTS_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    }, // AJAXUI only
+    {
+        "otherAccountContactIds",
+        JMAP_CONTACTS_EXTENSION,
+        0
+    }, // Both AJAXUI and JMAPUI
+
+    { NULL, NULL, 0 }
+};
+
+static int _contact_getargs_parse(jmap_req_t *req __attribute__((unused)),
+                                  struct jmap_parser *parser __attribute__((unused)),
+                                  const char *key,
+                                  json_t *arg,
+                                  void *rock)
+{
+    const char **addressbookId = (const char **) rock;
+    int r = 1;
+
+    /* Non-JMAP spec addressbookId argument */
+    if (!strcmp(key, "addressbookId") && json_is_string(arg)) {
+        *addressbookId = json_string_value(arg);
+    }
+
+    else r = 0;
+
+    return r;
+}
+
+static void cachecards_cb(uint64_t rowid, void *payload, void *vrock)
+{
+    const char *eventrep = payload;
+    struct cards_rock *rock = vrock;
+
+    // there's no way to return errors, but luckily it doesn't matter if we
+    // fail to cache
+    carddav_write_jmapcache(rock->db, rowid,
+                            JMAPCACHE_CONTACTVERSION, eventrep);
+}
+
+static int _contacts_get(struct jmap_req *req, carddav_cb_t *cb, int kind)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+    struct carddav_db *db = NULL;
+    int r = 0;
+
+    r = carddav_create_defaultaddressbook(req->accountid);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* The account exists but does not have a root mailbox. */
+        jmap_error(req, json_pack("{s:s}", "type", "accountNoAddressbooks"));
+        return 0;
+    } else if (r) return r;
+
+    /* Build callback data */
+    struct cards_rock rock = { NULL, req, &get, NULL /*mailbox*/,
+                               HASHU64_TABLE_INITIALIZER, 0 /*rows */ };
+
+    construct_hashu64_table(&rock.jmapcache, 512, 0);
+
+    /* Parse request */
+    char *mboxname = NULL;
+    const char *addressbookId = NULL;
+    jmap_get_parse(req, &parser,
+                   kind == CARDDAV_KIND_GROUP ? group_props : contact_props,
+                   /* allow_null_ids */ 1,
+                   &_contact_getargs_parse, &addressbookId, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    rock.db = db = carddav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR,
+               "carddav_open_mailbox failed for user %s", req->accountid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    mboxname = addressbookId ?
+        carddav_mboxname(req->accountid, addressbookId) : NULL;
+
+    /* Does the client request specific events? */
+    if (JNOTNULL(get.ids)) {
+        size_t i;
+        json_t *jval;
+        json_array_foreach(get.ids, i, jval) {
+            rock.rows = 0;
+            const char *id = json_string_value(jval);
+
+            r = carddav_get_cards(db, mboxname, id, kind, cb, &rock);
+            if (r || !rock.rows) {
+                json_array_append(get.not_found, jval);
+            }
+            r = 0; // we don't ever fail the whole request from this
+        }
+    }
+    else {
+        rock.rows = 0;
+        r = carddav_get_cards(db, mboxname, NULL, kind, cb, &rock);
+        if (r) goto done;
+    }
+
+    if (hashu64_count(&rock.jmapcache)) {
+        r = carddav_begin(db);
+        if (!r) hashu64_enumerate(&rock.jmapcache, cachecards_cb, &rock);
+        if (r) carddav_abort(db);
+        else r = carddav_commit(db);
+        if (r) goto done;
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_ADDRESSBOOK, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+  done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    free(mboxname);
+    mailbox_close(&rock.mailbox);
+    free_hashu64_table(&rock.jmapcache, free);
+    carddav_close(db);
+    return r;
+}
+
+static int jmap_contactgroup_get(struct jmap_req *req)
+{
+    return _contacts_get(req, &getgroups_cb, CARDDAV_KIND_GROUP);
+}
+
+static const char *_json_array_get_string(const json_t *obj, size_t index)
+{
+    const json_t *jval = json_array_get(obj, index);
+    if (!jval) return NULL;
+    const char *val = json_string_value(jval);
+    return val;
+}
+
+
+static int getchanges_cb(void *rock, struct carddav_data *cdata)
+{
+    struct changes_rock *urock = (struct changes_rock *) rock;
+    struct dav_data dav = cdata->dav;
+    const char *uid = cdata->vcard_uid;
+
+    if (!jmap_hasrights_byname(urock->req, dav.mailbox, DACL_READ))
+        return 0;
+
+    /* Count, but don't process items that exceed the maximum record count. */
+    if (urock->changes->max_changes &&
+        ++(urock->seen_records) > urock->changes->max_changes) {
+        urock->changes->has_more_changes = 1;
+        return 0;
+    }
+
+    /* Report item as updated or destroyed. */
+    if (dav.alive) {
+        if (dav.createdmodseq <= urock->changes->since_modseq)
+            json_array_append_new(urock->changes->updated, json_string(uid));
+        else
+            json_array_append_new(urock->changes->created, json_string(uid));
+    } else {
+        if (dav.createdmodseq <= urock->changes->since_modseq)
+            json_array_append_new(urock->changes->destroyed, json_string(uid));
+    }
+
+    /* Fetch record to determine modseq. */
+    if (dav.modseq > urock->highestmodseq) {
+        urock->highestmodseq = dav.modseq;
+    }
+
+    return 0;
+}
+
+static int _contacts_changes(struct jmap_req *req, int kind)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+    json_t *err = NULL;
+    struct carddav_db *db = carddav_open_userid(req->accountid);
+    if (!db) return -1;
+    int r = -1;
+
+    /* Parse request */
+    char *mboxname = NULL;
+    const char *addressbookId = NULL;
+    jmap_changes_parse(req, &parser, &_contact_getargs_parse, &addressbookId,
+                       &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    mboxname = addressbookId ?
+        carddav_mboxname(req->accountid, addressbookId) : NULL;
+
+    r = carddav_create_defaultaddressbook(req->accountid);
+    if (r) goto done;
+
+    /* Lookup updates. */
+    struct changes_rock rock = { req, &changes, 0 /*seen_records*/, 0 /*highestmodseq*/};
+    r = carddav_get_updates(db, changes.since_modseq, mboxname, kind,
+                            -1 /*max_records*/, &getchanges_cb, &rock);
+    if (r) goto done;
+
+    strip_spurious_deletes(&rock);
+
+    /* Determine new state. */
+    changes.new_modseq = changes.has_more_changes ?
+        rock.highestmodseq : jmap_highestmodseq(req, MBTYPE_ADDRESSBOOK);
+
+    /* Build response */
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+  done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    carddav_close(db);
+    free(mboxname);
+
+    return r;
+}
+
+static int jmap_contactgroup_changes(struct jmap_req *req)
+{
+    return _contacts_changes(req, CARDDAV_KIND_GROUP);
+}
+
+static const char *_resolve_contactid(struct jmap_req *req, const char *id)
+{
+    if (id && *id == '#') {
+        return jmap_lookup_id(req, id + 1);
+    }
+    return id;
+}
+
+static int _add_group_entries(struct jmap_req *req,
+                              struct vparse_card *card, json_t *members,
+                              json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "X-ADDRESSBOOKSERVER-MEMBER");
+    int r = 0;
+    size_t index;
+    struct buf buf = BUF_INITIALIZER;
+
+    for (index = 0; index < json_array_size(members); index++) {
+        const char *item = _json_array_get_string(members, index);
+        const char *uid = _resolve_contactid(req, item);
+        if (!item || !uid) {
+            buf_printf(&buf, "contactIds[%zu]", index);
+            json_array_append_new(invalid, json_string(buf_cstring(&buf)));
+            buf_reset(&buf);
+            continue;
+        }
+        buf_setcstr(&buf, "urn:uuid:");
+        buf_appendcstr(&buf, uid);
+        vparse_add_entry(card, NULL,
+                         "X-ADDRESSBOOKSERVER-MEMBER", buf_cstring(&buf));
+        buf_reset(&buf);
+    }
+
+    buf_free(&buf);
+    return r;
+}
+
+static int _add_othergroup_entries(struct jmap_req *req,
+                                   struct vparse_card *card, json_t *members,
+                                   json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "X-FM-OTHERACCOUNT-MEMBER");
+    int r = 0;
+    struct buf buf = BUF_INITIALIZER;
+    const char *key;
+    json_t *arg;
+    json_object_foreach(members, key, arg) {
+        unsigned i;
+        for (i = 0; i < json_array_size(arg); i++) {
+            const char *item = json_string_value(json_array_get(arg, i));
+            const char *uid = _resolve_contactid(req, item);
+            if (!item || !uid) {
+                buf_printf(&buf, "otherAccountContactIds[%s]", key);
+                json_array_append_new(invalid, json_string(buf_cstring(&buf)));
+                buf_reset(&buf);
+                continue;
+            }
+            buf_setcstr(&buf, "urn:uuid:");
+            buf_appendcstr(&buf, uid);
+            struct vparse_entry *entry =
+                vparse_add_entry(card, NULL,
+                                 "X-FM-OTHERACCOUNT-MEMBER", buf_cstring(&buf));
+            vparse_add_param(entry, "USERID", key);
+            buf_reset(&buf);
+        }
+    }
+    buf_free(&buf);
+    return r;
+}
+
+static void _contacts_set(struct jmap_req *req, unsigned kind)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+    json_t *err = NULL;
+    int r = 0;
+
+    struct mailbox *mailbox = NULL;
+    struct mailbox *newmailbox = NULL;
+
+    struct carddav_db *db = carddav_open_userid(req->accountid);
+    if (!db) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Parse arguments */
+    jmap_set_parse(req, &parser,
+                   kind == CARDDAV_KIND_GROUP ? group_props : contact_props,
+                   NULL, NULL, &set, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    if (set.if_in_state) {
+        /* TODO rewrite state function to use char* not json_t* */
+        json_t *jstate = json_string(set.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_ADDRESSBOOK)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            json_decref(jstate);
+            goto done;
+        }
+        json_decref(jstate);
+        set.old_state = xstrdup(set.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_ADDRESSBOOK, /*refresh*/0);
+        set.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+
+    r = carddav_create_defaultaddressbook(req->accountid);
+    if (r) goto done;
+
+    /* create */
+    const char *key;
+    json_t *arg;
+    json_object_foreach(set.create, key, arg) {
+        json_t *invalid = json_pack("[]");
+        json_t *item = json_pack("{}");
+        r = _contact_set_create(req, kind, arg,
+                                NULL, &mailbox, item, invalid);
+        if (r) {
+            json_t *err;
+            switch (r) {
+                case HTTP_FORBIDDEN:
+                case IMAP_PERMISSION_DENIED:
+                    err = json_pack("{s:s}", "type", "forbidden");
+                    break;
+                case IMAP_QUOTA_EXCEEDED:
+                    err = json_pack("{s:s}", "type", "overQuota");
+                    break;
+                default:
+                    err = jmap_server_error(r);
+            }
+            json_object_set_new(set.not_created, key, err);
+            r = 0;
+            json_decref(item);
+            json_decref(invalid);
+            continue;
+        }
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s s:o}",
+                                    "type", "invalidProperties",
+                                    "properties", invalid);
+            json_object_set_new(set.not_created, key, err);
+            json_decref(item);
+            continue;
+        }
+        json_decref(invalid);
+
+        /* Report contact as created. */
+        json_object_set_new(set.created, key, item);
+
+        /* Register creation id */
+        jmap_add_id(req, key, json_string_value(json_object_get(item, "id")));
+    }
+
+    /* update */
+    const char *uid;
+    json_object_foreach(set.update, uid, arg) {
+        struct carddav_data *cdata = NULL;
+        r = carddav_lookup_uid(db, uid, &cdata);
+        uint32_t olduid;
+        char *resource = NULL;
+        int do_move = 0;
+        json_t *jupdated = NULL;
+
+        /* is it a valid contact? */
+        if (r || !cdata || !cdata->dav.imap_uid || cdata->kind != kind) {
+            r = 0;
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_updated, uid, err);
+            continue;
+        }
+
+        json_t *abookid = json_object_get(arg, "addressbookId");
+        if (abookid && json_string_value(abookid)) {
+            const char *mboxname =
+                mboxname_abook(req->accountid, json_string_value(abookid));
+            if (strcmp(mboxname, cdata->dav.mailbox)) {
+                /* move */
+                if (!jmap_hasrights_byname(req, mboxname, DACL_WRITECONT)) {
+                    json_t *err = json_pack("{s:s s:[s]}",
+                                            "type", "invalidProperties",
+                                            "properties", "addressbookId");
+                    json_object_set_new(set.not_updated, uid, err);
+                    continue;
+                }
+                r = jmap_openmbox(req, mboxname, &newmailbox, 1);
+                if (r) {
+                    syslog(LOG_ERR, "IOERROR: failed to open %s", mboxname);
+                    goto done;
+                }
+                do_move = 1;
+            }
+            json_object_del(arg, "addressbookId");
+        }
+
+        int needrights = do_move ?
+            (DACL_READ | DACL_RMRSRC) : required_set_rights(arg);
+
+        if (!jmap_hasrights_byname(req, cdata->dav.mailbox, needrights)) {
+            int rights = jmap_myrights_byname(req, cdata->dav.mailbox);
+            json_t *err = json_pack("{s:s}", "type",
+                                    rights & ACL_READ ?
+                                    "accountReadOnly" : "notFound");
+            json_object_set_new(set.not_updated, uid, err);
+            continue;
+        }
+
+        if (!mailbox || strcmp(mailbox->name, cdata->dav.mailbox)) {
+            jmap_closembox(req, &mailbox);
+            r = jmap_openmbox(req, cdata->dav.mailbox, &mailbox, 1);
+            if (r) {
+                syslog(LOG_ERR, "IOERROR: failed to open %s",
+                       cdata->dav.mailbox);
+                goto done;
+            }
+        }
+
+        struct index_record record;
+
+        r = mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record);
+        if (r) goto done;
+
+        olduid = cdata->dav.imap_uid;
+        resource = xstrdup(cdata->dav.resource);
+
+        struct entryattlist *annots = NULL;
+        strarray_t *flags = NULL;
+
+        /* Load message containing the resource and parse vcard data */
+        struct vparse_card *vcard = record_to_vcard(mailbox, &record);
+        if (!vcard || !vcard->objects) {
+            syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
+                   cdata->dav.imap_uid, mailbox->name);
+            r = 0;
+            json_t *err = json_pack("{s:s}", "type", "parseError");
+            json_object_set_new(set.not_updated, uid, err);
+            goto finish;
+        }
+
+        struct vparse_card *card = vcard->objects;
+        vparse_replace_entry(card, NULL, "VERSION", "3.0");
+        vparse_replace_entry(card, NULL, "PRODID", _prodid);
+
+        json_t *invalid = json_pack("[]");
+
+        if (kind == CARDDAV_KIND_GROUP) {
+            json_t *namep = NULL;
+            json_t *members = NULL;
+            json_t *others = NULL;
+            json_t *jval;
+            const char *key;
+
+            json_object_foreach(arg, key, jval) {
+                if (!strcmp(key, "name")) {
+                    if (json_is_string(jval))
+                        namep = jval;
+                    else json_array_append_new(invalid, json_string("name"));
+                }
+                else if (!strcmp(key, "contactIds")) {
+                    members = jval;
+                }
+                else if (!strcmp(key, "otherAccountContactIds")) {
+                    others = jval;
+                }
+                else if (!strncmp(key, "otherAccountContactIds/", 23)) {
+                    /* Read and apply patch to current card */
+                    json_t *jcurrent = jmap_group_from_vcard(card);
+                    if (!jcurrent) {
+                        syslog(LOG_ERR, "can't read vcard %u:%s for update",
+                                cdata->dav.imap_uid, mailbox->name);
+                        r = 0;
+                        json_t *err = json_pack("{s:s s:s}",
+                                "type", "serverError", "description", "invalid current card");
+                        json_object_set_new(set.not_updated, uid, err);
+                        goto finish;
+                    }
+                    jupdated = jmap_patchobject_apply(jcurrent, arg, NULL);
+                    json_decref(jcurrent);
+                    if (JNOTNULL(jupdated)) {
+                        json_object_del(jupdated, "addressbookId");
+                        /* Now read the updated property value */
+                        others = json_object_get(jupdated, "otherAccountContactIds");
+                    }
+                }
+                else if (!strcmp(key, "id") || !strcmp(key, "uid")) {
+                    if (cdata && strcmpnull(cdata->vcard_uid, json_string_value(jval))) {
+                        json_array_append_new(invalid, json_string(key));
+                    }
+                }
+            }
+
+            if (namep) {
+                const char *name = json_string_value(namep);
+                if (name) {
+                    vparse_replace_entry(card, NULL, "FN", name);
+                    vparse_replace_entry(card, NULL, "N", name);
+                }
+            }
+            else if (!vparse_get_entry(card, NULL, "N")) {
+                struct vparse_entry *entry = vparse_get_entry(card, NULL, "FN");
+                if (entry) vparse_replace_entry(card, NULL, "N", entry->v.value);
+            }
+            if (members) {
+                _add_group_entries(req, card, members, invalid);
+            }
+            if (others) {
+                _add_othergroup_entries(req, card, others, invalid);
+            }
+        }
+        else {
+            flags = mailbox_extract_flags(mailbox, &record, req->accountid);
+            annots = mailbox_extract_annots(mailbox, &record);
+
+            r = _json_to_card(req, cdata, card, arg, flags, &annots, invalid);
+            if (r == HTTP_NO_CONTENT) {
+                r = 0;
+                if (!newmailbox) {
+                    /* just bump the modseq
+                       if in the same mailbox and no data change */
+                    syslog(LOG_NOTICE, "jmap: touch contact %s/%s",
+                           req->accountid, resource);
+                    if (strarray_find_case(flags, "\\Flagged", 0) >= 0)
+                        record.system_flags |= FLAG_FLAGGED;
+                    else
+                        record.system_flags &= ~FLAG_FLAGGED;
+                    annotate_state_t *state = NULL;
+                    r = mailbox_get_annotate_state(mailbox, record.uid, &state);
+                    annotate_state_set_auth(state, 0,
+                                            req->accountid, req->authstate);
+                    if (!r) r = annotate_state_store(state, annots);
+                    if (!r) r = mailbox_rewrite_index_record(mailbox, &record);
+                    if (!r) json_object_set_new(set.updated, uid, json_null());
+                    goto finish;
+                }
+            }
+        }
+
+        if (!r && !json_array_size(invalid)) {
+            syslog(LOG_NOTICE, "jmap: update %s %s/%s",
+                   kind == CARDDAV_KIND_GROUP ? "group" : "contact",
+                   req->accountid, resource);
+            r = carddav_store(newmailbox ? newmailbox : mailbox, card, resource,
+                              record.createdmodseq, flags, annots, req->accountid,
+                              req->authstate, ignorequota);
+            if (!r)
+                r = carddav_remove(mailbox, olduid,
+                                   /*isreplace*/!newmailbox, req->accountid);
+        }
+
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s s:O}",
+                                    "type", "invalidProperties",
+                                    "properties", invalid);
+            json_object_set_new(set.not_updated, uid, err);
+            goto finish;
+        }
+        else if (r) {
+            json_t *err = NULL;
+            switch (r) {
+                case HTTP_FORBIDDEN:
+                case IMAP_PERMISSION_DENIED:
+                    err = json_pack("{s:s}", "type", "forbidden");
+                    break;
+                case IMAP_QUOTA_EXCEEDED:
+                    err = json_pack("{s:s}", "type", "overQuota");
+                    break;
+                default:
+                    err = jmap_server_error(r);
+            }
+            json_object_set_new(set.not_updated, uid, err);
+            goto finish;
+        }
+        else json_object_set_new(set.updated, uid, json_null());
+
+      finish:
+        strarray_free(flags);
+        freeentryatts(annots);
+        jmap_closembox(req, &newmailbox);
+        vparse_free_card(vcard);
+        free(resource);
+        json_decref(jupdated);
+        json_decref(invalid);
+        r = 0;
+    }
+
+
+    /* destroy */
+    size_t index;
+    for (index = 0; index < json_array_size(set.destroy); index++) {
+        const char *uid = _json_array_get_string(set.destroy, index);
+        if (!uid) {
+            json_t *err = json_pack("{s:s}", "type", "invalidArguments");
+            json_object_set_new(set.not_destroyed, uid, err);
+            continue;
+        }
+        struct carddav_data *cdata = NULL;
+        uint32_t olduid;
+        r = carddav_lookup_uid(db, uid, &cdata);
+
+        /* is it a valid contact? */
+        if (r || !cdata || !cdata->dav.imap_uid || cdata->kind != kind) {
+            r = 0;
+            json_t *err = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_destroyed, uid, err);
+            continue;
+        }
+        olduid = cdata->dav.imap_uid;
+
+        if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_RMRSRC)) {
+            int rights = jmap_myrights_byname(req, cdata->dav.mailbox);
+            json_t *err = json_pack("{s:s}", "type",
+                                    rights & ACL_READ ?
+                                    "accountReadOnly" : "notFound");
+            json_object_set_new(set.not_destroyed, uid, err);
+            continue;
+        }
+
+        if (!mailbox || strcmp(mailbox->name, cdata->dav.mailbox)) {
+            jmap_closembox(req, &mailbox);
+            r = jmap_openmbox(req, cdata->dav.mailbox, &mailbox, 1);
+            if (r) goto done;
+        }
+
+        syslog(LOG_NOTICE,
+               "jmap: remove %s %s/%s",
+               kind == CARDDAV_KIND_GROUP ? "group" : "contact",
+               req->accountid, uid);
+        r = carddav_remove(mailbox, olduid, /*isreplace*/0, req->accountid);
+        if (r) {
+            syslog(LOG_ERR, "IOERROR: Contact%s/set remove failed for %s %u",
+                   kind == CARDDAV_KIND_GROUP ? "Group" : "",
+                   mailbox->name, olduid);
+            goto done;
+        }
+
+        json_array_append_new(set.destroyed, json_string(uid));
+    }
+
+    /* force modseq to stable */
+    if (mailbox) mailbox_unlock_index(mailbox, NULL);
+
+    // TODO refactor jmap_getstate to return a string, once
+    // all code has been migrated to the new JMAP parser.
+    json_t *jstate = jmap_getstate(req, MBTYPE_ADDRESSBOOK, /*refresh*/1);
+    set.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    jmap_ok(req, jmap_set_reply(&set));
+    r = 0;
+
+done:
+    if (r) jmap_error(req, jmap_server_error(r));
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    jmap_closembox(req, &newmailbox);
+    jmap_closembox(req, &mailbox);
+
+    carddav_close(db);
+}
+
+static int jmap_contactgroup_set(struct jmap_req *req)
+{
+    _contacts_set(req, CARDDAV_KIND_GROUP);
+    return 0;
+}
+
+/* Extract separate y,m,d from YYYY-MM-DD or (with ignore_hyphens) YYYYMMDD
+ *
+ * This handles birthday/anniversary and BDAY/ANNIVERSARY for JMAP and vCard
+ *
+ * JMAP dates are _always_ YYYY-MM-DD, so use require_hyphens = 1
+ *
+ * For vCard, this handles "date-value" from RFC2426 (which is "date" from
+ * RFC2425), used by BDAY (ANNIVERSARY isn't in vCard 3). vCard 4 says BDAY and
+ * ANNIVERSARY is date-and-or-time, which is far more complicated. I haven't
+ * seen that in the wild yet and hope I never do.
+ */
+static int _parse_date(const char *date, unsigned *y,
+                       unsigned *m, unsigned *d, int require_hyphens)
+{
+    /* there isn't a convenient libc function that will let us convert parts of
+     * a string to integer and only take digit characters, so we just pull it
+     * apart ourselves */
+
+    const char *yp = NULL, *mp = NULL, *dp = NULL;
+
+    /* getting pointers to the ymd components, skipping hyphens if necessary.
+     * format checking as we go. no need to strlen() beforehand, it will fall
+     * out of the range checks. */
+    yp = date;
+    if (yp[0] < '0' || yp[0] > '9' ||
+        yp[1] < '0' || yp[1] > '9' ||
+        yp[2] < '0' || yp[2] > '9' ||
+        yp[3] < '0' || yp[3] > '9') return -1;
+
+    mp = &yp[4];
+
+    if (*mp == '-') mp++;
+    else if (require_hyphens) return -1;
+
+    if (mp[0] < '0' || mp[0] > '9' ||
+        mp[1] < '0' || mp[1] > '9') return -1;
+
+    dp = &mp[2];
+
+    if (*dp == '-') dp++;
+    else if (require_hyphens) return -1;
+
+    if (dp[0] < '0' || dp[0] > '9' ||
+        dp[1] < '0' || dp[1] > '9') return -1;
+
+    if (dp[2] != '\0') return -1;
+
+    /* convert to integer. ascii digits are 0x30-0x37, so we can take bottom
+     * four bits and multiply */
+    *y =
+        (yp[0] & 0xf) * 1000 +
+        (yp[1] & 0xf) * 100 +
+        (yp[2] & 0xf) * 10 +
+        (yp[3] & 0xf);
+
+    *m =
+        (mp[0] & 0xf) * 10 +
+        (mp[1] & 0xf);
+
+    *d =
+        (dp[0] & 0xf) * 10 +
+        (dp[1] & 0xf);
+
+    return 0;
+}
+
+static void _date_to_jmap(struct vparse_entry *entry, struct buf *buf)
+{
+    if (!entry)
+        goto no_date;
+
+    unsigned y, m, d;
+    if (_parse_date(entry->v.value, &y, &m, &d, 0))
+        goto no_date;
+
+    if (y < 1604 || m > 12 || d > 31)
+        goto no_date;
+
+    const struct vparse_param *param;
+    for (param = entry->params; param; param = param->next) {
+        if (!strcasecmp(param->name, "x-apple-omit-year"))
+            /* XXX compare value with actual year? */
+            y = 0;
+        if (!strcasecmp(param->name, "x-fm-no-month"))
+            m = 0;
+        if (!strcasecmp(param->name, "x-fm-no-day"))
+            d = 0;
+    }
+
+    /* sigh, magic year 1604 has been seen without X-APPLE-OMIT-YEAR, making
+     * me wonder what the bloody point is */
+    if (y == 1604)
+        y = 0;
+
+    buf_reset(buf);
+    buf_printf(buf, "%04d-%02d-%02d", y, m, d);
+    return;
+
+no_date:
+    buf_setcstr(buf, "0000-00-00");
+}
+
+static const char *_servicetype(const char *type)
+{
+    /* add new services here */
+    if (!strcasecmp(type, "aim")) return "AIM";
+    if (!strcasecmp(type, "facebook")) return "Facebook";
+    if (!strcasecmp(type, "flickr")) return "Flickr";
+    if (!strcasecmp(type, "gadugadu")) return "GaduGadu";
+    if (!strcasecmp(type, "github")) return "GitHub";
+    if (!strcasecmp(type, "googletalk")) return "GoogleTalk";
+    if (!strcasecmp(type, "icq")) return "ICQ";
+    if (!strcasecmp(type, "jabber")) return "Jabber";
+    if (!strcasecmp(type, "linkedin")) return "LinkedIn";
+    if (!strcasecmp(type, "msn")) return "MSN";
+    if (!strcasecmp(type, "myspace")) return "MySpace";
+    if (!strcasecmp(type, "qq")) return "QQ";
+    if (!strcasecmp(type, "skype")) return "Skype";
+    if (!strcasecmp(type, "twitter")) return "Twitter";
+    if (!strcasecmp(type, "yahoo")) return "Yahoo";
+
+    syslog(LOG_NOTICE, "unknown service type %s", type);
+    return type;
+}
+
+/* Convert the VCARD card to jmap properties */
+static json_t *jmap_contact_from_vcard(struct vparse_card *card,
+                                       struct mailbox *mailbox,
+                                       struct index_record *record)
+{
+    strarray_t *empty = NULL;
+    json_t *obj = json_pack("{}");
+    struct buf buf = BUF_INITIALIZER;
+    struct vparse_entry *entry;
+
+    const strarray_t *n = vparse_multival(card, "n");
+    const strarray_t *org = vparse_multival(card, "org");
+    if (!n) n = empty ? empty : (empty = strarray_new());
+    if (!org) org = empty ? empty : (empty = strarray_new());
+
+    /* name fields: Family; Given; Middle; Prefix; Suffix. */
+
+    const char *family = strarray_safenth(n, 0);
+    json_object_set_new(obj, "lastName", json_string(family));
+
+    /* JMAP doesn't have a separate field for Middle (aka "Additional
+     * Names"), so we just mash them into firstName. See reverse of this in
+     * _json_to_card */
+    const char *given = strarray_safenth(n, 1);
+    const char *middle = strarray_safenth(n, 2);
+    buf_setcstr(&buf, given);
+    if (*middle) {
+        buf_putc(&buf, ' ');
+        buf_appendcstr(&buf, middle);
+    }
+    json_object_set_new(obj, "firstName", json_string(buf_cstring(&buf)));
+
+    const char *prefix = strarray_safenth(n, 3);
+    json_object_set_new(obj, "prefix",
+                        json_string(prefix)); /* just prefix */
+
+    const char *suffix = strarray_safenth(n, 4);
+    json_object_set_new(obj, "suffix",
+                        json_string(suffix)); /* just suffix */
+
+    json_object_set_new(obj, "company",
+                        json_string(strarray_safenth(org, 0)));
+    json_object_set_new(obj, "department",
+                        json_string(strarray_safenth(org, 1)));
+
+    /* we used to store jobTitle in ORG[2] instead of TITLE, which confused
+     * CardDAV clients. that's fixed, but there's now lots of cards with it
+     * stored in the wrong place, so check both */
+    const char *item = vparse_stringval(card, "title");
+    if (!item)
+        item = strarray_safenth(org, 2);
+    json_object_set_new(obj, "jobTitle", json_string(item));
+
+    json_t *adr = json_array();
+
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (strcasecmp(entry->name, "adr")) continue;
+        json_t *item = json_pack("{}");
+
+        /* XXX - type and label */
+        const strarray_t *a = entry->v.values;
+
+        const struct vparse_param *param;
+        const char *type = "other";
+        const char *label = NULL;
+        for (param = entry->params; param; param = param->next) {
+            if (!strcasecmp(param->name, "type")) {
+                if (!strcasecmp(param->value, "home")) {
+                    type = "home";
+                }
+                else if (!strcasecmp(param->value, "work")) {
+                    type = "work";
+                }
+                else if (!strcasecmp(param->value, "billing")) {
+                    type = "billing";
+                }
+                else if (!strcasecmp(param->value, "postal")) {
+                    type = "postal";
+                }
+            }
+            else if (!strcasecmp(param->name, "label")) {
+                label = param->value;
+            }
+        }
+        json_object_set_new(item, "type", json_string(type));
+        json_object_set_new(item, "label", label ? json_string(label) : json_null());
+
+        const char *pobox = strarray_safenth(a, 0);
+        const char *extended = strarray_safenth(a, 1);
+        const char *street = strarray_safenth(a, 2);
+        buf_reset(&buf);
+        if (*pobox) {
+            buf_appendcstr(&buf, pobox);
+            if (extended || street) buf_putc(&buf, '\n');
+        }
+        if (*extended) {
+            buf_appendcstr(&buf, extended);
+            if (street) buf_putc(&buf, '\n');
+        }
+        if (*street) {
+            buf_appendcstr(&buf, street);
+        }
+
+        json_object_set_new(item, "street",
+                            json_string(buf_cstring(&buf)));
+        json_object_set_new(item, "locality",
+                            json_string(strarray_safenth(a, 3)));
+        json_object_set_new(item, "region",
+                            json_string(strarray_safenth(a, 4)));
+        json_object_set_new(item, "postcode",
+                            json_string(strarray_safenth(a, 5)));
+        json_object_set_new(item, "country",
+                            json_string(strarray_safenth(a, 6)));
+
+        json_array_append_new(adr, item);
+    }
+
+    json_object_set_new(obj, "addresses", adr);
+
+    /* emails - we need to open code this, because it's repeated */
+    json_t *emails = json_array();
+
+    int defaultIndex = -1;
+    int i = 0;
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (strcasecmp(entry->name, "email")) continue;
+        json_t *item = json_pack("{}");
+        const struct vparse_param *param;
+        const char *type = "other";
+        const char *label = NULL;
+        for (param = entry->params; param; param = param->next) {
+            if (!strcasecmp(param->name, "type")) {
+                if (!strcasecmp(param->value, "home")) {
+                    type = "personal";
+                }
+                else if (!strcasecmp(param->value, "work")) {
+                    type = "work";
+                }
+                else if (!strcasecmp(param->value, "pref")) {
+                    if (defaultIndex < 0)
+                        defaultIndex = i;
+                }
+            }
+            else if (!strcasecmp(param->name, "label")) {
+                label = param->value;
+            }
+        }
+        json_object_set_new(item, "type", json_string(type));
+        if (label) json_object_set_new(item, "label", json_string(label));
+
+        json_object_set_new(item, "value", json_string(entry->v.value));
+
+        json_array_append_new(emails, item);
+        i++;
+    }
+
+    if (defaultIndex < 0)
+        defaultIndex = 0;
+    int size = json_array_size(emails);
+    for (i = 0; i < size; i++) {
+        json_t *item = json_array_get(emails, i);
+        json_object_set_new(item, "isDefault",
+                            i == defaultIndex ? json_true() : json_false());
+    }
+
+    json_object_set_new(obj, "emails", emails);
+
+    /* address - we need to open code this, because it's repeated */
+    json_t *phones = json_array();
+
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (strcasecmp(entry->name, "tel")) continue;
+        json_t *item = json_pack("{}");
+        const struct vparse_param *param;
+        const char *type = "other";
+        const char *label = NULL;
+        for (param = entry->params; param; param = param->next) {
+            if (!strcasecmp(param->name, "type")) {
+                if (!strcasecmp(param->value, "home")) {
+                    type = "home";
+                }
+                else if (!strcasecmp(param->value, "work")) {
+                    type = "work";
+                }
+                else if (!strcasecmp(param->value, "cell")) {
+                    type = "mobile";
+                }
+                else if (!strcasecmp(param->value, "mobile")) {
+                    type = "mobile";
+                }
+                else if (!strcasecmp(param->value, "fax")) {
+                    type = "fax";
+                }
+                else if (!strcasecmp(param->value, "pager")) {
+                    type = "pager";
+                }
+            }
+            else if (!strcasecmp(param->name, "label")) {
+                label = param->value;
+            }
+        }
+        json_object_set_new(item, "type", json_string(type));
+        if (label) json_object_set_new(item, "label", json_string(label));
+
+        json_object_set_new(item, "value", json_string(entry->v.value));
+
+        json_array_append_new(phones, item);
+    }
+
+    json_object_set_new(obj, "phones", phones);
+
+    /* address - we need to open code this, because it's repeated */
+    json_t *online = json_array();
+
+    for (entry = card->properties; entry; entry = entry->next) {
+        if (!strcasecmp(entry->name, "url")) {
+            json_t *item = json_pack("{}");
+            const struct vparse_param *param;
+            const char *label = NULL;
+            for (param = entry->params; param; param = param->next) {
+                if (!strcasecmp(param->name, "label")) {
+                    label = param->value;
+                }
+            }
+            json_object_set_new(item, "type", json_string("uri"));
+            if (label) json_object_set_new(item, "label", json_string(label));
+            json_object_set_new(item, "value", json_string(entry->v.value));
+            json_array_append_new(online, item);
+        }
+        if (!strcasecmp(entry->name, "impp")) {
+            json_t *item = json_pack("{}");
+            const struct vparse_param *param;
+            const char *label = NULL;
+            for (param = entry->params; param; param = param->next) {
+                if (!strcasecmp(param->name, "x-service-type")) {
+                    label = _servicetype(param->value);
+                }
+            }
+            json_object_set_new(item, "type", json_string("username"));
+            if (label) json_object_set_new(item, "label", json_string(label));
+            json_object_set_new(item, "value", json_string(entry->v.value));
+            json_array_append_new(online, item);
+        }
+        if (!strcasecmp(entry->name, "x-social-profile")) {
+            json_t *item = json_pack("{}");
+            const struct vparse_param *param;
+            const char *label = NULL;
+            const char *value = NULL;
+            for (param = entry->params; param; param = param->next) {
+                if (!strcasecmp(param->name, "type")) {
+                    label = _servicetype(param->value);
+                }
+                if (!strcasecmp(param->name, "x-user")) {
+                    value = param->value;
+                }
+            }
+            json_object_set_new(item, "type", json_string("username"));
+            if (label) json_object_set_new(item, "label", json_string(label));
+            json_object_set_new(item, "value",
+                                json_string(value ? value : entry->v.value));
+            json_array_append_new(online, item);
+        }
+        if (!strcasecmp(entry->name, "x-fm-online-other")) {
+            json_t *item = json_pack("{}");
+            const struct vparse_param *param;
+            const char *label = NULL;
+            for (param = entry->params; param; param = param->next) {
+                if (!strcasecmp(param->name, "label")) {
+                    label = param->value;
+                }
+            }
+            json_object_set_new(item, "type", json_string("other"));
+            if (label) json_object_set_new(item, "label", json_string(label));
+            json_object_set_new(item, "value", json_string(entry->v.value));
+            json_array_append_new(online, item);
+        }
+    }
+
+    json_object_set_new(obj, "online", online);
+
+    item = vparse_stringval(card, "nickname");
+    json_object_set_new(obj, "nickname", json_string(item ? item : ""));
+
+    entry = vparse_get_entry(card, NULL, "anniversary");
+    _date_to_jmap(entry, &buf);
+    json_object_set_new(obj, "anniversary", json_string(buf_cstring(&buf)));
+
+    entry = vparse_get_entry(card, NULL, "bday");
+    _date_to_jmap(entry, &buf);
+    json_object_set_new(obj, "birthday", json_string(buf_cstring(&buf)));
+
+    item = vparse_stringval(card, "note");
+    json_object_set_new(obj, "notes", json_string(item ? item : ""));
+
+    item = vparse_stringval(card, "photo");
+    json_object_set_new(obj, "x-hasPhoto",
+                        item ? json_true() : json_false());
+
+    struct vparse_entry *photo = vparse_get_entry(card, NULL, "photo");
+    struct message_guid guid;
+    char *type = NULL;
+    json_t *file;
+
+    if (photo &&
+        (size = vcard_prop_decode_value(photo, NULL, &type, &guid))) {
+        char blob_id[JMAP_BLOBID_SIZE];
+        jmap_set_blobid(&guid, blob_id);
+
+        file = json_pack("{s:s s:i s:s? s:n}",
+                         "blobId", blob_id, "size", size,
+                         "type", type, "name");
+    }
+    else file = json_null();
+
+    json_object_set_new(obj, "avatar", file);
+    free(type);
+
+    // record properties
+
+    json_object_set_new(obj, "isFlagged",
+                        record->system_flags & FLAG_FLAGGED ? json_true() :
+                        json_false());
+
+    const char *annot = DAV_ANNOT_NS "<" XML_NS_CYRUS ">importance";
+    // NOTE: using buf_free here because annotatemore_msg_lookup uses
+    // buf_init_ro on the buffer, which blats the base pointer.
+    buf_free(&buf);
+    annotatemore_msg_lookup(mailbox->name, record->uid, annot, "", &buf);
+    double val = 0;
+    if (buf.len) val = strtod(buf_cstring(&buf), NULL);
+
+    // need to keep the x- version while AJAXUI is around
+    json_object_set_new(obj, "importance", json_real(val));
+
+    /* XXX - other fields */
+
+    buf_free(&buf);
+    if (empty) strarray_free(empty);
+
+    return obj;
+}
+
+static const char *_encode_contact_blobid(struct carddav_data *cdata,
+                                          struct buf *dst)
+{
+    /* Set vCard smart blob prefix */
+    buf_putc(dst, 'V');
+
+    /* Encode vCard UID */
+    char *b64uid =
+        jmap_encode_base64_nopad(cdata->vcard_uid, strlen(cdata->vcard_uid));
+    if (!b64uid) {
+        buf_reset(dst);
+        return NULL;
+    }
+    buf_appendcstr(dst, b64uid);
+    free(b64uid);
+
+    /* Encode modseq */
+    buf_printf(dst, "-" MODSEQ_FMT, cdata->dav.modseq);
+
+    return buf_cstring(dst);
+}
+
+static int _decode_contact_blobid(const char *blobid,
+                                  char **uidptr,
+                                  modseq_t *modseqptr)
+{
+    char *uid = NULL;
+    modseq_t modseq = 0;
+    int is_valid = 0;
+
+    /* Decode vCard UID */
+    const char *base = blobid+1;
+    const char *p = strchr(base, '-');
+    if (!p) goto done;
+    uid = jmap_decode_base64_nopad(base, p-base);
+    if (!uid) goto done;
+    base = p + 1;
+
+    /* Decode modseq */
+    if (*base == '\0') goto done;
+    char *endptr = NULL;
+    errno = 0;
+    modseq = strtoull(base, &endptr, 10);
+    if (errno == ERANGE || (*endptr && *endptr != '-')) {
+        goto done;
+    }
+    base = endptr;
+
+    /* All done */
+    *uidptr = uid;
+    *modseqptr = modseq;
+    is_valid = 1;
+
+done:
+    if (!is_valid) {
+        free(uid);
+    }
+    return is_valid;
+}
+
+static int jmap_contact_getblob(jmap_req_t *req,
+                                const char *blobid,
+                                const char *accept_mime)
+{
+    struct carddav_db *db = NULL;
+    struct carddav_data *cdata = NULL;
+    struct mailbox *mailbox = NULL;
+    struct vparse_card *vcard = NULL;
+    char *uid = NULL;
+    modseq_t modseq;
+    struct buf buf = BUF_INITIALIZER;
+    int res = 0;
+    int r;
+
+    if (*blobid != 'V') return 0;
+
+    if (!_decode_contact_blobid(blobid, &uid, &modseq)) {
+        res = HTTP_BAD_REQUEST;
+        goto done;
+    }
+
+    /* Lookup uid in CarddavDB */
+    db = carddav_open_userid(req->accountid);
+    if (!db) {
+        req->txn->error.desc = "no addressbook db";
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+    if (carddav_lookup_uid(db, uid, &cdata)) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Validate modseq */
+    if (modseq != cdata->dav.modseq) {
+        res = HTTP_NOT_FOUND;
+        goto done;
+    }
+
+    /* Open mailbox, we need it now */
+    if ((r = jmap_openmbox(req, cdata->dav.mailbox, &mailbox, 0))) {
+        req->txn->error.desc = error_message(r);
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Make sure client can handle blob type. */
+    if (accept_mime) {
+        if (strcmp(accept_mime, "application/octet-stream") &&
+            strcmp(accept_mime, "text/vcard")) {
+            res = HTTP_NOT_ACCEPTABLE;
+            goto done;
+        }
+    }
+
+    /* Load vCard data */
+    struct index_record record;
+    if (!mailbox_find_index_record(mailbox, cdata->dav.imap_uid, &record)) {
+        vcard = record_to_vcard(mailbox, &record);
+    }
+    if (!vcard) {
+        req->txn->error.desc = "failed to load record";
+        res = HTTP_SERVER_ERROR;
+        goto done;
+    }
+
+    /* Write blob to socket */
+    char *content_type = NULL;
+    if (!accept_mime || !strcmp(accept_mime, "text/vcard")) {
+        struct vparse_entry *entry =
+            vparse_get_entry(vcard->objects, NULL, "VERSION");
+        if (entry) {
+            content_type =
+                strconcat("text/calendar; version=", entry->v.value, NULL);
+            req->txn->resp_body.type = content_type;
+        }
+    }
+    if (!req->txn->resp_body.type) {
+        req->txn->resp_body.type = accept_mime;
+    }
+
+    /* Write body */
+    vparse_tobuf(vcard, &buf);
+    req->txn->resp_body.len = buf_len(&buf);
+    write_body(HTTP_OK, req->txn, buf_base(&buf), buf_len(&buf));
+    free(content_type);
+    res = HTTP_OK;
+
+done:
+    if (res != HTTP_OK && !req->txn->error.desc) {
+        const char *desc = NULL;
+        switch (res) {
+            case HTTP_BAD_REQUEST:
+                desc = "invalid contact blobid";
+                break;
+            case HTTP_NOT_FOUND:
+                desc = "failed to find blob by contact blobid";
+                break;
+            default:
+                desc = error_message(res);
+        }
+        req->txn->error.desc = desc;
+    }
+    if (vcard) vparse_free_card(vcard);
+    if (mailbox) jmap_closembox(req, &mailbox);
+    if (db) carddav_close(db);
+    buf_free(&buf);
+    free(uid);
+    return res;
+}
+
+static int getcontacts_cb(void *rock, struct carddav_data *cdata)
+{
+    struct cards_rock *crock = (struct cards_rock *) rock;
+    struct index_record record;
+    json_t *obj = NULL;
+    int r = 0;
+
+    if (!jmap_hasrights_byname(crock->req, cdata->dav.mailbox, DACL_READ))
+        return 0;
+
+    if (cdata->jmapversion == JMAPCACHE_CONTACTVERSION) {
+        json_error_t jerr;
+        obj = json_loads(cdata->jmapdata, 0, &jerr);
+        goto gotvalue;
+    }
+
+    if (!crock->mailbox || strcmp(crock->mailbox->name, cdata->dav.mailbox)) {
+        mailbox_close(&crock->mailbox);
+        r = mailbox_open_irl(cdata->dav.mailbox, &crock->mailbox);
+        if (r) return r;
+    }
+
+    r = mailbox_find_index_record(crock->mailbox, cdata->dav.imap_uid, &record);
+    if (r) return r;
+
+    /* Load message containing the resource and parse vcard data */
+    struct vparse_card *vcard = record_to_vcard(crock->mailbox, &record);
+    if (!vcard || !vcard->objects) {
+        syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
+                cdata->dav.imap_uid, crock->mailbox->name);
+        vparse_free_card(vcard);
+        return IMAP_INTERNAL;
+    }
+
+    /* Convert the VCARD to a JMAP contact. */
+    obj = jmap_contact_from_vcard(vcard->objects, crock->mailbox, &record);
+    vparse_free_card(vcard);
+
+gotvalue:
+    jmap_filterprops(obj, crock->get->props);
+
+    if (jmap_wantprop(crock->get->props, "x-href")) {
+        char *xhref = jmap_xhref(cdata->dav.mailbox, cdata->dav.resource);
+        json_object_set_new(obj, "x-href", json_string(xhref));
+        free(xhref);
+    }
+    if (jmap_wantprop(crock->get->props, "blobId")) {
+        json_t *jblobid = json_null();
+        struct buf blobid = BUF_INITIALIZER;
+        if (_encode_contact_blobid(cdata, &blobid)) {
+            jblobid = json_string(buf_cstring(&blobid));
+        }
+        buf_free(&blobid);
+        json_object_set_new(obj, "blobId", jblobid);
+    }
+
+    json_object_set_new(obj, "id", json_string(cdata->vcard_uid));
+    json_object_set_new(obj, "uid", json_string(cdata->vcard_uid));
+
+    json_object_set_new(obj, "addressbookId",
+                        json_string(strrchr(cdata->dav.mailbox, '.')+1));
+
+    json_array_append_new(crock->get->list, obj);
+    crock->rows++;
+
+    return 0;
+}
+
+static int jmap_contact_get(struct jmap_req *req)
+{
+    return _contacts_get(req, &getcontacts_cb, CARDDAV_KIND_CONTACT);
+}
+
+static int jmap_contact_changes(struct jmap_req *req)
+{
+    return _contacts_changes(req, CARDDAV_KIND_CONTACT);
+}
+
+struct contact_textfilter {
+    strarray_t terms;
+    bitvector_t matched_terms;
+    strarray_t phrases;
+    bitvector_t matched_phrases;
+    int is_any;
+};
+
+static int contact_textfilter_add_to_termset(const char *term, void *termset)
+{
+    hash_insert(term, (void*)1, (hash_table*)termset);
+    return 0;
+}
+
+static int contact_textfilter_add_to_strarray(const char *term, void *sa)
+{
+    strarray_append((strarray_t*)sa, term);
+    return 0;
+}
+
+static struct contact_textfilter *contact_textfilter_new(const char *query)
+{
+    struct contact_textfilter *f = xzmalloc(sizeof(struct contact_textfilter));
+    struct buf buf = BUF_INITIALIZER;
+    const char *p, *q;
+    int in_phrase = 0;
+    xapian_doc_t *doc = xapian_doc_new();
+
+    /* Parse query string into loose terms and phrases */
+    for (p = query, q = query; *p; p++) {
+        if (in_phrase) {
+            if (*p == '\'' || *(p+1) == '\0') {
+                // end of phrase
+                if (*p != '\'') {
+                    buf_putc(&buf, *p);
+                }
+                if (buf_len(&buf)) {
+                    strarray_append(&f->phrases, buf_cstring(&buf));
+                    buf_reset(&buf);
+                }
+                in_phrase = 0;
+            }
+            else if (*p == '\\') {
+                // escape character within phrase
+                switch (*(p+1)) {
+                    case '"':
+                    case '\'':
+                    case '\\':
+                        buf_putc(&buf, *(p+1));
+                        p++;
+                        break;
+                    default:
+                        buf_putc(&buf, *p);
+                }
+            }
+            else buf_putc(&buf, *p);
+        }
+        else {
+            if (*p == '\'' || *(p+1) == '\0') {
+                // end of loose terms
+                if (q) {
+                    const char *end = *p == '\'' ? p : p + 1;
+                    xapian_doc_index_text(doc, q, end - q);
+                }
+                if (*p == '\'') {
+                    //start of phrase
+                    in_phrase = 1;
+                }
+                q = NULL;
+            }
+            else if (!q) {
+                // start of loose terms
+                q = p;
+            }
+        }
+    }
+
+    /* Add loose terms to matcher */
+    xapian_doc_foreach_term(doc, contact_textfilter_add_to_strarray, &f->terms);
+
+    /* Initialize state */
+    bv_init(&f->matched_phrases);
+    bv_init(&f->matched_terms);
+    bv_setsize(&f->matched_phrases, (unsigned) strarray_size(&f->phrases));
+    bv_setsize(&f->matched_terms, (unsigned) strarray_size(&f->terms));
+
+    xapian_doc_close(doc);
+    buf_free(&buf);
+    return f;
+}
+
+static int contact_textfilter_match(struct contact_textfilter *f, const char *text, hash_table *termset)
+{
+    int matches = 0;
+
+    if (!f->is_any) {
+        bv_clearall(&f->matched_phrases);
+        bv_clearall(&f->matched_terms);
+    }
+
+    /* Validate phrase search */
+    int i;
+    for (i = 0; i < strarray_size(&f->phrases); i++) {
+        const char *phrase = strarray_nth(&f->phrases, i);
+        if (stristr(text, phrase)) {
+            bv_set(&f->matched_phrases, i);
+            if (f->is_any) {
+                matches = 1;
+                goto done;
+            }
+        }
+        else if (!f->is_any) goto done;
+    }
+
+    /* Validate loose term search */
+    if (!termset->size) {
+        /* Extract terms from text and store result in termset */
+        xapian_doc_t *doc = xapian_doc_new();
+        xapian_doc_index_text(doc, text, strlen(text));
+        if (!xapian_doc_termcount(doc)) {
+            xapian_doc_close(doc);
+            goto done;
+        }
+        construct_hash_table(termset, xapian_doc_termcount(doc), 0);
+        xapian_doc_foreach_term(doc, contact_textfilter_add_to_termset, termset);
+        xapian_doc_close(doc);
+    }
+    for (i = 0; i < strarray_size(&f->terms); i++) {
+        const char *term = strarray_nth(&f->terms, i);
+        if (hash_lookup(term, termset)) {
+            bv_set(&f->matched_terms, i);
+            if (f->is_any) {
+                matches = 1;
+                goto done;
+            }
+        }
+        else if (!f->is_any) goto done;
+    }
+
+    /* All loose terms and phrases matched */
+    matches = 1;
+
+done:
+    return matches;
+}
+
+static void contact_textfilter_reset(struct contact_textfilter *f)
+{
+    bv_clearall(&f->matched_phrases);
+    bv_clearall(&f->matched_terms);
+}
+
+
+static void contact_textfilter_free(struct contact_textfilter *f)
+{
+    if (f) {
+        strarray_fini(&f->terms);
+        bv_fini(&f->matched_terms);
+        strarray_fini(&f->phrases);
+        bv_fini(&f->matched_phrases);
+        free(f);
+    }
+}
+
+static int contact_textfilter_matched_all(struct contact_textfilter *f)
+{
+    return bv_count(&f->matched_terms) == (unsigned) strarray_size(&f->terms) &&
+           bv_count(&f->matched_phrases) == (unsigned) strarray_size(&f->phrases);
+}
+
+struct named_termset {
+    const char *propname;
+    hash_table termset;
+};
+
+struct contactsquery_filter_rock {
+    struct carddav_db *carddavdb;
+    struct carddav_data *cdata;
+    json_t *entry;
+    ptrarray_t cached_termsets; // list of named_termset
+};
+
+struct contact_filter {
+    hash_table *inContactGroup;
+    json_t *isFlagged;
+    const char *uid;
+    struct contact_textfilter *prefix;
+    struct contact_textfilter *firstName;
+    struct contact_textfilter *lastName;
+    struct contact_textfilter *suffix;
+    struct contact_textfilter *nickname;
+    struct contact_textfilter *company;
+    struct contact_textfilter *department;
+    struct contact_textfilter *jobTitle;
+    struct contact_textfilter *email;
+    struct contact_textfilter *phone;
+    struct contact_textfilter *online;
+    struct contact_textfilter *address;
+    struct contact_textfilter *notes;
+    struct contact_textfilter *text;
+};
+
+static int contact_filter_match_textval(const char *val,
+                                        struct contact_textfilter *propfilter,
+                                        struct contact_textfilter *textfilter,
+                                        hash_table *termset)
+{
+    if (propfilter) {
+        /* Fail early if propfilter does not match */
+        if (val && !contact_textfilter_match(propfilter, val, termset)) {
+            return 0;
+        }
+    }
+    if (textfilter) {
+        /* Don't care if textfilter matches */
+        if (val && !contact_textfilter_matched_all(textfilter)) {
+            contact_textfilter_match(textfilter, val, termset);
+        }
+    }
+
+    return 1;
+}
+
+static hash_table *getorset_termset(ptrarray_t *cached_termsets, const char *propname)
+{
+    int i;
+    for (i = 0; i < ptrarray_size(cached_termsets); i++) {
+        struct named_termset *nts = ptrarray_nth(cached_termsets, i);
+        if (!strcmp(nts->propname, propname)) return &nts->termset;
+    }
+    struct named_termset *nts = xzmalloc(sizeof(struct named_termset));
+    nts->propname = propname;
+    ptrarray_append(cached_termsets, nts);
+    return &nts->termset;
+}
+
+static int contact_filter_match_textprop(json_t *jentry, const char *propname,
+                                         struct contact_textfilter *propfilter,
+                                         struct contact_textfilter *textfilter,
+                                         ptrarray_t *cached_termsets)
+{
+
+    /* Skip matching if possible */
+    if (!propfilter && (!textfilter || contact_textfilter_matched_all(textfilter)))
+        return 1;
+
+    /* Evaluate search on text value */
+    hash_table *termset = getorset_termset(cached_termsets, propname);
+    const char *val = json_string_value(json_object_get(jentry, propname));
+    return contact_filter_match_textval(val, propfilter, textfilter, termset);
+}
+
+static int contact_filter_match_contactinfo(json_t *jentry, const char *propname,
+                                            struct contact_textfilter *propfilter,
+                                            struct contact_textfilter *textfilter,
+                                            ptrarray_t *cached_termsets)
+{
+    /* Skip matching if possible */
+    if (!propfilter && (!textfilter || contact_textfilter_matched_all(textfilter)))
+        return 1;
+
+    /* Combine values into text buffer */
+    json_t *jlist = json_object_get(jentry, propname);
+    struct buf buf = BUF_INITIALIZER;
+    json_t *jinfo;
+    size_t i;
+    json_array_foreach(jlist, i, jinfo) {
+        const char *val = json_string_value(json_object_get(jinfo, "value"));
+        if (!val) continue;
+        if (i) buf_putc(&buf, ' ');
+        buf_appendcstr(&buf, val);
+    }
+    if (propfilter && !buf_len(&buf))
+        return 0;
+
+    /* Evaluate search on text buffer */
+    hash_table *termset = getorset_termset(cached_termsets, propname);
+    int ret = contact_filter_match_textval(buf_cstring(&buf), propfilter, textfilter, termset);
+    buf_free(&buf);
+    return ret;
+}
+
+static int contact_filter_match_addresses(json_t *jentry, const char *propname,
+                                          struct contact_textfilter *propfilter,
+                                          struct contact_textfilter *textfilter,
+                                          ptrarray_t *cached_termsets)
+{
+    /* Skip matching if possible */
+    if (!propfilter && (!textfilter || contact_textfilter_matched_all(textfilter)))
+        return 1;
+
+    /* Combine values into text buffer */
+    json_t *jlist = json_object_get(jentry, propname);
+    struct buf buf = BUF_INITIALIZER;
+    json_t *jaddr;
+    size_t i;
+    json_array_foreach(jlist, i, jaddr) {
+        const char *val;
+        if ((val = json_string_value(json_object_get(jaddr, "street")))) {
+            buf_putc(&buf, ' ');
+            buf_appendcstr(&buf, val);
+        }
+        if ((val = json_string_value(json_object_get(jaddr, "locality")))) {
+            buf_putc(&buf, ' ');
+            buf_appendcstr(&buf, val);
+        }
+        if ((val = json_string_value(json_object_get(jaddr, "region")))) {
+            buf_putc(&buf, ' ');
+            buf_appendcstr(&buf, val);
+        }
+        if ((val = json_string_value(json_object_get(jaddr, "postcode")))) {
+            buf_putc(&buf, ' ');
+            buf_appendcstr(&buf, val);
+        }
+        if ((val = json_string_value(json_object_get(jaddr, "country")))) {
+            buf_putc(&buf, ' ');
+            buf_appendcstr(&buf, val);
+        }
+    }
+    if (propfilter && !buf_len(&buf))
+        return 0;
+
+    /* Evaluate search on text buffer */
+    hash_table *termset = getorset_termset(cached_termsets, propname);
+    int ret = contact_filter_match_textval(buf_cstring(&buf), propfilter, textfilter, termset);
+    buf_free(&buf);
+    return ret;
+}
+
+/* Match the contact in rock against filter. */
+static int contact_filter_match(void *vf, void *rock)
+{
+    struct contact_filter *f = (struct contact_filter *) vf;
+    struct contactsquery_filter_rock *cfrock = (struct contactsquery_filter_rock*) rock;
+    json_t *contact = cfrock->entry;
+    struct carddav_data *cdata = cfrock->cdata;
+    struct carddav_db *db = cfrock->carddavdb;
+
+    /* uid */
+    if (f->uid && strcmpsafe(cdata->vcard_uid, f->uid)) {
+        return 0;
+    }
+
+    /* isFlagged */
+    if (JNOTNULL(f->isFlagged)) {
+        json_t *isFlagged = json_object_get(contact, "isFlagged");
+        if (f->isFlagged != isFlagged) {
+            return 0;
+        }
+    }
+
+    /* Match text filters */
+    if (f->text) contact_textfilter_reset(f->text);
+    if (!contact_filter_match_textprop(contact, "prefix", f->prefix, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "firstName", f->firstName, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "lastName", f->lastName, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "suffix", f->suffix, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "nickname", f->nickname, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "company", f->company, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "department", f->department, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "jobTitle", f->jobTitle, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_textprop(contact, "notes", f->notes, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_contactinfo(contact, "emails", f->email, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_contactinfo(contact, "phones", f->phone, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_contactinfo(contact, "online", f->online, f->text, &cfrock->cached_termsets) ||
+        !contact_filter_match_addresses(contact, "addresses", f->address, f->text, &cfrock->cached_termsets)) {
+        return 0;
+    }
+
+    if (f->text && !contact_textfilter_matched_all(f->text)) return 0;
+
+    /* inContactGroup */
+    if (f->inContactGroup) {
+        /* XXX Calling carddav_db for every contact isn't really efficient. If
+         * this turns out to be a performance issue, the carddav_db API might
+         * support lookup contacts by group ids. */
+        strarray_t *gids = carddav_getuid_groups(db, cdata->vcard_uid);
+        if (!gids) {
+            syslog(LOG_INFO,
+                   "carddav_getuid_groups(%s) returned NULL group array",
+                   cdata->vcard_uid);
+            return 0;
+        }
+        int i, m = 0;
+        for (i = 0; i < gids->count; i++) {
+            if (hash_lookup(strarray_nth(gids, i), f->inContactGroup)) {
+                m = 1;
+                break;
+            }
+        }
+        strarray_free(gids);
+        if (!m) return 0;
+    }
+
+    /* All matched. */
+    return 1;
+}
+
+/* Free the memory allocated by this contact filter. */
+static void contact_filter_free(void *vf)
+{
+    struct contact_filter *f = (struct contact_filter*) vf;
+    if (f->inContactGroup) {
+        free_hash_table(f->inContactGroup, NULL);
+        free(f->inContactGroup);
+    }
+    contact_textfilter_free(f->prefix);
+    contact_textfilter_free(f->firstName);
+    contact_textfilter_free(f->lastName);
+    contact_textfilter_free(f->suffix);
+    contact_textfilter_free(f->nickname);
+    contact_textfilter_free(f->company);
+    contact_textfilter_free(f->department);
+    contact_textfilter_free(f->jobTitle);
+    contact_textfilter_free(f->email);
+    contact_textfilter_free(f->phone);
+    contact_textfilter_free(f->online);
+    contact_textfilter_free(f->address);
+    contact_textfilter_free(f->notes);
+    contact_textfilter_free(f->text);
+    free(f);
+}
+
+/* Parse the JMAP Contact FilterCondition in arg.
+ * Report any invalid properties in invalid, prefixed by prefix.
+ * Return NULL on error. */
+static void *contact_filter_parse(json_t *arg)
+{
+    struct contact_filter *f =
+        (struct contact_filter *) xzmalloc(sizeof(struct contact_filter));
+
+    /* inContactGroup */
+    json_t *inContactGroup = json_object_get(arg, "inContactGroup");
+    if (inContactGroup) {
+        f->inContactGroup = xmalloc(sizeof(struct hash_table));
+        construct_hash_table(f->inContactGroup,
+                             json_array_size(inContactGroup)+1, 0);
+        size_t i;
+        json_t *val;
+        json_array_foreach(inContactGroup, i, val) {
+            const char *id;
+            if (json_unpack(val, "s", &id) != -1) {
+                hash_insert(id, (void*)1, f->inContactGroup);
+            }
+        }
+    }
+
+    /* isFlagged */
+    f->isFlagged = json_object_get(arg, "isFlagged");
+
+    /* prefix */
+    if (JNOTNULL(json_object_get(arg, "prefix"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "prefix", 0, NULL, "s", &s) > 0) {
+            f->prefix = contact_textfilter_new(s);
+        }
+    }
+    /* firstName */
+    if (JNOTNULL(json_object_get(arg, "firstName"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "firstName", 0, NULL, "s", &s) > 0) {
+            f->firstName = contact_textfilter_new(s);
+        }
+    }
+    /* lastName */
+    if (JNOTNULL(json_object_get(arg, "lastName"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "lastName", 0, NULL, "s", &s) > 0) {
+            f->lastName = contact_textfilter_new(s);
+        }
+    }
+    /* suffix */
+    if (JNOTNULL(json_object_get(arg, "suffix"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "suffix", 0, NULL, "s", &s) > 0) {
+            f->suffix = contact_textfilter_new(s);
+        }
+    }
+    /* nickname */
+    if (JNOTNULL(json_object_get(arg, "nickname"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "nickname", 0, NULL, "s", &s) > 0) {
+            f->nickname = contact_textfilter_new(s);
+        }
+    }
+    /* company */
+    if (JNOTNULL(json_object_get(arg, "company"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "company", 0, NULL, "s", &s) > 0) {
+            f->company = contact_textfilter_new(s);
+        }
+    }
+    /* department */
+    if (JNOTNULL(json_object_get(arg, "department"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "department", 0, NULL, "s", &s) > 0) {
+            f->department = contact_textfilter_new(s);
+        }
+    }
+    /* jobTitle */
+    if (JNOTNULL(json_object_get(arg, "jobTitle"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "jobTitle", 0, NULL, "s", &s) > 0) {
+            f->jobTitle = contact_textfilter_new(s);
+        }
+    }
+    /* email */
+    if (JNOTNULL(json_object_get(arg, "email"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "email", 0, NULL, "s", &s) > 0) {
+            f->email = contact_textfilter_new(s);
+        }
+    }
+    /* phone */
+    if (JNOTNULL(json_object_get(arg, "phone"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "phone", 0, NULL, "s", &s) > 0) {
+            f->phone = contact_textfilter_new(s);
+        }
+    }
+    /* online */
+    if (JNOTNULL(json_object_get(arg, "online"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "online", 0, NULL, "s", &s) > 0) {
+            f->online = contact_textfilter_new(s);
+        }
+    }
+    /* address */
+    if (JNOTNULL(json_object_get(arg, "address"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "address", 0, NULL, "s", &s) > 0) {
+            f->address = contact_textfilter_new(s);
+        }
+    }
+    /* notes */
+    if (JNOTNULL(json_object_get(arg, "notes"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "notes", 0, NULL, "s", &s) > 0) {
+            f->notes = contact_textfilter_new(s);
+        }
+    }
+    /* text */
+    if (JNOTNULL(json_object_get(arg, "text"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "text", 0, NULL, "s", &s) > 0) {
+            f->text = contact_textfilter_new(s);
+        }
+    }
+    /* uid */
+    if (JNOTNULL(json_object_get(arg, "uid"))) {
+        jmap_readprop(arg, "uid", 0, NULL, "s", &f->uid);
+    }
+
+    return f;
+}
+
+static void contact_filter_validate(jmap_req_t *req __attribute__((unused)),
+                                    struct jmap_parser *parser,
+                                    json_t *filter,
+                                    json_t *unsupported __attribute__((unused)),
+                                    void *rock __attribute__((unused)),
+                                    json_t **err __attribute__((unused)))
+{
+    const char *field;
+    json_t *arg;
+
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "inContactGroup")) {
+            if (!json_is_array(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+            else {
+                jmap_parse_strings(arg, parser, field);
+            }
+        }
+        else if (!strcmp(field, "isFlagged")) {
+            if (!json_is_boolean(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "text") ||
+                 !strcmp(field, "prefix") ||
+                 !strcmp(field, "firstName") ||
+                 !strcmp(field, "lastName") ||
+                 !strcmp(field, "suffix") ||
+                 !strcmp(field, "nickname") ||
+                 !strcmp(field, "company") ||
+                 !strcmp(field, "department") ||
+                 !strcmp(field, "jobTitle") ||
+                 !strcmp(field, "email") ||
+                 !strcmp(field, "phone") ||
+                 !strcmp(field, "online") ||
+                 !strcmp(field, "address") ||
+                 !strcmp(field, "uid") ||
+                 !strcmp(field, "notes")) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+static int contact_comparator_validate(jmap_req_t *req __attribute__((unused)),
+                              struct jmap_comparator *comp,
+                              void *rock __attribute__((unused)),
+                              json_t **err __attribute__((unused)))
+{
+    /* Reject any collation */
+    if (comp->collation) {
+        return 0;
+    }
+    if (!strcmp(comp->property, "isFlagged") ||
+        !strcmp(comp->property, "firstName") ||
+        !strcmp(comp->property, "lastName") ||
+        !strcmp(comp->property, "nickname") ||
+        !strcmp(comp->property, "company") ||
+        !strcmp(comp->property, "uid")) {
+        return 1;
+    }
+    return 0;
+}
+
+struct contactgroup_filter {
+    const char *uid;
+    struct contact_textfilter *name;
+    struct contact_textfilter *text;
+};
+
+/* Match the contact in rock against filter. */
+static int contactgroup_filter_match(void *vf, void *rock)
+{
+    struct contactgroup_filter *f = (struct contactgroup_filter *) vf;
+    struct contactsquery_filter_rock *cfrock = (struct contactsquery_filter_rock*) rock;
+    struct carddav_data *cdata = cfrock->cdata;
+    json_t *group = cfrock->entry;
+
+    /* uid */
+    if (f->uid && strcmpsafe(cdata->vcard_uid, f->uid)) {
+        return 0;
+    }
+    /* Match text filters */
+    if (f->text) {
+        contact_textfilter_reset(f->text);
+    }
+    if (!contact_filter_match_textprop(group, "name", f->name, f->text, &cfrock->cached_termsets)) {
+        return 0;
+    }
+    if (f->text && !contact_textfilter_matched_all(f->text)) {
+        return 0;
+    }
+
+    /* All matched. */
+    return 1;
+}
+
+/* Free the memory allocated by this contact filter. */
+static void contactgroup_filter_free(void *vf)
+{
+    struct contactgroup_filter *f = vf;
+    contact_textfilter_free(f->name);
+    contact_textfilter_free(f->text);
+    free(vf);
+}
+
+static void *contactgroup_filter_parse(json_t *arg)
+{
+    struct contactgroup_filter *f =
+        (struct contactgroup_filter *) xzmalloc(sizeof(struct contactgroup_filter));
+
+    /* uid */
+    if (JNOTNULL(json_object_get(arg, "uid"))) {
+        jmap_readprop(arg, "uid", 0, NULL, "s", &f->uid);
+    }
+    /* text */
+    if (JNOTNULL(json_object_get(arg, "text"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "text", 0, NULL, "s", &s) > 0) {
+            f->text = contact_textfilter_new(s);
+        }
+    }
+    /* name */
+    if (JNOTNULL(json_object_get(arg, "name"))) {
+        const char *s = NULL;
+        if (jmap_readprop(arg, "name", 0, NULL, "s", &s) > 0) {
+            f->name = contact_textfilter_new(s);
+        }
+    }
+
+    return f;
+}
+
+static void contactgroup_filter_validate(jmap_req_t *req __attribute__((unused)),
+                                         struct jmap_parser *parser,
+                                         json_t *filter,
+                                         json_t *unsupported __attribute__((unused)),
+                                         void *rock __attribute__((unused)),
+                                         json_t **err __attribute__((unused)))
+{
+    const char *field;
+    json_t *arg;
+
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "uid") ||
+            !strcmp(field, "text") ||
+            !strcmp(field, "name")) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+static int contactgroup_comparator_validate(jmap_req_t *req __attribute__((unused)),
+                              struct jmap_comparator *comp,
+                              void *rock __attribute__((unused)),
+                              json_t **err __attribute__((unused)))
+{
+    /* Reject any collation */
+    if (comp->collation) {
+        return 0;
+    }
+    if (!strcmp(comp->property, "uid")) {
+        return 1;
+    }
+    return 0;
+}
+
+struct contactsquery_rock {
+    jmap_req_t *req;
+    struct jmap_query *query;
+    jmap_filter *filter;
+
+    struct mailbox *mailbox;
+    struct carddav_db *carddavdb;
+    unsigned kind;
+    int build_response;
+    ptrarray_t entries;
+};
+
+static int _contactsquery_cb(void *rock, struct carddav_data *cdata)
+{
+    struct contactsquery_rock *crock = (struct contactsquery_rock*) rock;
+    struct index_record record;
+    json_t *entry = NULL;
+    int r = 0;
+
+    if (!cdata->dav.alive || !cdata->dav.rowid || !cdata->dav.imap_uid) {
+        return 0;
+    }
+
+    /* Ignore anything but the requested kind. */
+    if (cdata->kind != crock->kind) {
+        return 0;
+    }
+
+    if (!jmap_hasrights_byname(crock->req, cdata->dav.mailbox, DACL_READ))
+        return 0;
+
+    if (cdata->jmapversion == JMAPCACHE_CONTACTVERSION) {
+        json_error_t jerr;
+        entry = json_loads(cdata->jmapdata, 0, &jerr);
+        if (entry) goto gotvalue;
+    }
+
+    /* Open mailbox. */
+    if (!crock->mailbox || strcmp(crock->mailbox->name, cdata->dav.mailbox)) {
+        mailbox_close(&crock->mailbox);
+        r = mailbox_open_irl(cdata->dav.mailbox, &crock->mailbox);
+        if (r) goto done;
+    }
+
+    /* Load record. */
+    r = mailbox_find_index_record(crock->mailbox, cdata->dav.imap_uid, &record);
+    if (r) goto done;
+
+    /* Load contact from record. */
+    struct vparse_card *vcard = record_to_vcard(crock->mailbox, &record);
+    if (!vcard || !vcard->objects) {
+        syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
+                cdata->dav.imap_uid, crock->mailbox->name);
+        vparse_free_card(vcard);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Convert the VCARD to a JMAP contact. */
+    /* XXX If this conversion turns out to waste too many cycles, then first
+     * initialize props with any non-NULL field in filter f or its subconditions.
+     */
+    entry = crock->kind == CARDDAV_KIND_GROUP ?
+        jmap_group_from_vcard(vcard->objects) :
+        jmap_contact_from_vcard(vcard->objects, crock->mailbox, &record);
+    vparse_free_card(vcard);
+
+gotvalue:
+
+
+    if (crock->filter) {
+        /* Match the contact against the filter */
+        struct contactsquery_filter_rock cfrock = {
+            crock->carddavdb, cdata, entry, PTRARRAY_INITIALIZER
+        };
+        /* Match filter */
+        jmap_filtermatch_cb *matcher = crock->kind == CARDDAV_KIND_GROUP ?
+            contactgroup_filter_match : contact_filter_match;
+        int matches = jmap_filter_match(crock->filter, matcher, &cfrock);
+        /* Free text search cached_termsets */
+        int i;
+        for (i = 0; i < ptrarray_size(&cfrock.cached_termsets); i++) {
+            struct named_termset *nts = ptrarray_nth(&cfrock.cached_termsets, i);
+            free_hash_table(&nts->termset, NULL);
+            free(nts);
+        }
+        ptrarray_fini(&cfrock.cached_termsets);
+        /* Skip non-matching entries */
+        if (!matches) goto done;
+    }
+
+    /* Update statistics */
+    crock->query->total++;
+
+    if (crock->build_response) {
+        struct jmap_query *query = crock->query;
+        /* Apply windowing and build response ids */
+        if (query->position > 0 && query->position > (ssize_t) query->total - 1) {
+            goto done;
+        }
+        if (query->limit && json_array_size(query->ids) >= query->limit) {
+            goto done;
+        }
+        if (!json_array_size(query->ids)) {
+            query->result_position = query->total - 1;
+        }
+        json_array_append_new(query->ids, json_string(cdata->vcard_uid));
+    }
+    else {
+        /* Keep matching entries for post-processing */
+        json_object_set_new(entry, "id", json_string(cdata->vcard_uid));
+        json_object_set_new(entry, "uid", json_string(cdata->vcard_uid));
+        ptrarray_append(&crock->entries, entry);
+        entry = NULL;
+    }
+
+done:
+    if (entry) json_decref(entry);
+    return r;
+}
+
+enum contactsquery_sort {
+    CONTACTS_SORT_NONE = 0,
+    CONTACTS_SORT_UID,
+    /* Comparators for Contact */
+    CONTACTS_SORT_ISFLAGGED,
+    CONTACTS_SORT_FIRSTNAME,
+    CONTACTS_SORT_LASTNAME,
+    CONTACTS_SORT_NICKNAME,
+    CONTACTS_SORT_COMPANY,
+    /* Comparators for ContactGroup */
+    CONTACTS_SORT_NAME,
+    /* Flag for descencding sort */
+    CONTACTS_SORT_DESC = 0x80,
+};
+
+enum contactsquery_sort *buildsort(json_t *jsort)
+{
+    enum contactsquery_sort *sort =
+        xzmalloc((json_array_size(jsort) + 1) * sizeof(enum contactsquery_sort));
+
+    size_t i;
+    json_t *jcomp;
+    json_array_foreach(jsort, i, jcomp) {
+        const char *prop = json_string_value(json_object_get(jcomp, "property"));
+        if (!strcmp(prop, "uid"))
+            sort[i] = CONTACTS_SORT_UID;
+        /* Comparators for Contact */
+        else if (!strcmp(prop, "isFlagged"))
+            sort[i] = CONTACTS_SORT_ISFLAGGED;
+        else if (!strcmp(prop, "firstName"))
+            sort[i] = CONTACTS_SORT_FIRSTNAME;
+        else if (!strcmp(prop, "lastName"))
+            sort[i] = CONTACTS_SORT_LASTNAME;
+        else if (!strcmp(prop, "nickname"))
+            sort[i] = CONTACTS_SORT_NICKNAME;
+        else if (!strcmp(prop, "company"))
+            sort[i] = CONTACTS_SORT_COMPANY;
+        /* Comparators for ContactGroup */
+        else if (!strcmp(prop, "name"))
+            sort[i] = CONTACTS_SORT_NAME;
+
+        if (json_object_get(jcomp, "isAscending") == json_false())
+            sort[i] |= CONTACTS_SORT_DESC;
+    }
+
+    return sort;
+}
+
+static int _contactsquery_cmp(const void *va, const void *vb, void *rock)
+{
+    enum contactsquery_sort *sort = rock;
+    json_t *ja = (json_t*) *(void**)va;
+    json_t *jb = (json_t*) *(void**)vb;
+
+    enum contactsquery_sort *comp;
+    for (comp = sort; *comp != CONTACTS_SORT_NONE; comp++) {
+        int ret = 0;
+        switch (*comp & ~CONTACTS_SORT_DESC) {
+            case CONTACTS_SORT_UID:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "uid")),
+                                 json_string_value(json_object_get(jb, "uid")));
+                break;
+            case CONTACTS_SORT_FIRSTNAME:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "firstName")),
+                                 json_string_value(json_object_get(jb, "firstName")));
+                break;
+            case CONTACTS_SORT_LASTNAME:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "lastName")),
+                                 json_string_value(json_object_get(jb, "lastName")));
+                break;
+            case CONTACTS_SORT_NICKNAME:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "nickname")),
+                                 json_string_value(json_object_get(jb, "nickname")));
+                break;
+            case CONTACTS_SORT_COMPANY:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "company")),
+                                 json_string_value(json_object_get(jb, "company")));
+                break;
+            case CONTACTS_SORT_NAME:
+                ret = strcmpsafe(json_string_value(json_object_get(ja, "name")),
+                                 json_string_value(json_object_get(jb, "name")));
+                break;
+            case CONTACTS_SORT_ISFLAGGED:
+                ret = json_boolean_value(json_object_get(ja, "isFlagged")) -
+                      json_boolean_value(json_object_get(jb, "isFlagged"));
+                break;
+        }
+        if (ret)
+            return (*comp & CONTACTS_SORT_DESC) ? -ret : ret;
+    }
+
+    return 0;
+}
+
+static int _contactsquery(struct jmap_req *req, unsigned kind)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_query query;
+    struct carddav_db *db;
+    jmap_filter *parsed_filter = NULL;
+    int r = 0;
+
+    db = carddav_open_userid(req->accountid);
+    if (!db) {
+        syslog(LOG_ERR,
+               "carddav_open_userid failed for user %s", req->accountid);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_query_parse(req, &parser, NULL, NULL,
+                     kind == CARDDAV_KIND_GROUP ?
+                        contactgroup_filter_validate :
+                        contact_filter_validate,
+                     NULL,
+                     kind == CARDDAV_KIND_GROUP ?
+                        contactgroup_comparator_validate :
+                        contact_comparator_validate,
+                     NULL,
+                     &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+    if (json_array_size(parser.invalid)) {
+        err = json_pack("{s:s}", "type", "invalidArguments");
+        json_object_set(err, "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build filter */
+    json_t *filter = json_object_get(req->args, "filter");
+    const char *wantuid = NULL;
+    if (JNOTNULL(filter)) {
+        parsed_filter = jmap_buildfilter(filter,
+                kind == CARDDAV_KIND_GROUP ?
+                    contactgroup_filter_parse : contact_filter_parse);
+        wantuid = json_string_value(json_object_get(filter, "uid"));
+    }
+
+    /* Does this query have a complex sort? */
+    int is_complexsort;
+    if (json_array_size(query.sort) == 1) {
+        json_t *jcomp = json_array_get(query.sort, 0);
+        const char *prop = json_string_value(json_object_get(jcomp, "property"));
+        is_complexsort = strcmpsafe("uid", prop);
+    }
+    else is_complexsort = json_array_size(query.sort) > 0;
+
+    /* Inspect every entry in this accounts addressbook mailboxes. */
+    struct contactsquery_rock rock = {
+        req,
+        &query,
+        parsed_filter,
+        NULL /*mailbox*/,
+        db,
+        kind,
+        1 /*build_result*/,
+        PTRARRAY_INITIALIZER
+    };
+    if (wantuid) {
+        /* Fast-path single filter condition by UID */
+        struct carddav_data *cdata = NULL;
+        r = carddav_lookup_uid(db, wantuid, &cdata);
+        if (!r) _contactsquery_cb(&rock, cdata);
+        if (r == CYRUSDB_NOTFOUND) r = 0;
+    }
+    else if (!is_complexsort && query.position >= 0 && !query.anchor) {
+        /* Fast-path simple query with carddav db */
+        enum carddav_sort sort = CARD_SORT_UID; /* ignored if nsort == 0 */
+        size_t nsort = 0;
+        if (json_array_size(query.sort)) {
+            json_t *jcomp = json_array_get(query.sort, 0);
+            if (json_object_get(jcomp, "isAscending") == json_false()) {
+                sort |= CARD_SORT_DESC;
+            }
+            nsort = 1;
+        }
+        r = carddav_foreach_sort(db, NULL, &sort, nsort, _contactsquery_cb, &rock);
+    }
+    else {
+        /* Run carddav db query and apply custom sort */
+        rock.build_response = 0;
+        r = carddav_foreach(db, NULL, _contactsquery_cb, &rock);
+        if (!r) {
+            /* Sort entries */
+            enum contactsquery_sort *sort = buildsort(query.sort);
+            cyr_qsort_r(rock.entries.data, rock.entries.count, sizeof(void*),
+                        _contactsquery_cmp, sort);
+            free(sort);
+            /* Build result ids */
+            int i;
+            for (i = 0; i < ptrarray_size(&rock.entries); i++) {
+                json_t *entry = ptrarray_nth(&rock.entries, i);
+                json_array_append(query.ids, json_object_get(entry, "uid"));
+                json_decref(entry);
+            }
+            /* Determine start position of result window */
+            size_t startpos = 0;
+            if (query.anchor) {
+                /* Look for anchor in result ids */
+                size_t anchor_pos = 0;
+                for ( ; anchor_pos < json_array_size(query.ids); anchor_pos++) {
+                    json_t *jid = json_array_get(query.ids, anchor_pos);
+                    if (!strcmpsafe(query.anchor, json_string_value(jid))) break;
+                }
+                /* Determine start of windowed result ids */
+                if (anchor_pos < json_array_size(query.ids)) {
+                    if (query.anchor_offset < 0) {
+                        startpos = (size_t) -query.anchor_offset > anchor_pos ?
+                            0 : anchor_pos + query.anchor_offset;
+                    }
+                    else {
+                        startpos = anchor_pos + query.anchor_offset;
+                    }
+                }
+                else err = json_pack("{s:s}", "type", "anchorNotFound");
+            }
+            else if (query.position < 0) {
+                startpos = (size_t) -query.position > json_array_size(query.ids) ?
+                    0 : json_array_size(query.ids) + query.position;
+            }
+            else startpos = query.position;
+            /* Apply window to result list */
+            if (startpos < json_array_size(query.ids)) {
+                json_t *windowed_ids = json_array();
+                size_t j;
+                for (j = startpos; j < json_array_size(query.ids); j++) {
+                    if (!query.limit || json_array_size(windowed_ids) < query.limit) {
+                        json_array_append(windowed_ids, json_array_get(query.ids, j));
+                    }
+                    else break;
+                }
+                json_decref(query.ids);
+                query.ids = windowed_ids;
+                query.result_position = startpos;
+            }
+            else {
+                json_decref(query.ids);
+                query.ids = json_array();
+            }
+            ptrarray_fini(&rock.entries);
+        }
+    }
+    /* Clean up callback state */
+    if (rock.mailbox) mailbox_close(&rock.mailbox);
+    /* Handle callback errors */
+    if (r || err) {
+        if (!err) err = jmap_server_error(r);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_ADDRESSBOOK, /*refresh*/0);
+    query.query_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    json_t *res = jmap_query_reply(&query);
+    jmap_ok(req, res);
+
+done:
+    jmap_query_fini(&query);
+    jmap_parser_fini(&parser);
+    if (parsed_filter) {
+        jmap_filter_free(parsed_filter, kind == CARDDAV_KIND_GROUP ?
+            contactgroup_filter_free : contact_filter_free);
+    }
+    if (db) carddav_close(db);
+    return 0;
+}
+
+static int jmap_contact_query(struct jmap_req *req)
+{
+    return _contactsquery(req, CARDDAV_KIND_CONTACT);
+}
+
+static int jmap_contactgroup_query(struct jmap_req *req)
+{
+    return _contactsquery(req, CARDDAV_KIND_GROUP);
+}
+
+static struct vparse_entry *_card_multi(struct vparse_card *card,
+                                        const char *name, char sepchar)
+{
+    struct vparse_entry *res = vparse_get_entry(card, NULL, name);
+    if (!res) {
+        res = vparse_add_entry(card, NULL, name, NULL);
+        res->multivaluesep = sepchar;
+        res->v.values = strarray_new();
+    }
+    return res;
+}
+
+static int _emails_to_card(struct vparse_card *card,
+                           json_t *arg, json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "email");
+
+    int i;
+    int size = json_array_size(arg);
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < size; i++) {
+        json_t *item = json_array_get(arg, i);
+
+        buf_printf(&buf, "emails[%d]", i);
+        const char *prefix = buf_cstring(&buf);
+
+        /* Parse properties. */
+        const char *type = NULL;
+        const char *label = NULL;
+        const char *value = NULL;
+
+        jmap_readprop_full(item, prefix, "type", 1, invalid, "s", &type);
+        if (type) {
+            if (strcmp(type, "personal") && strcmp(type, "work") && strcmp(type, "other")) {
+                char *tmp = strconcat(prefix, ".type", NULL);
+                json_array_append_new(invalid, json_string(tmp));
+                free(tmp);
+            }
+        }
+        jmap_readprop_full(item, prefix, "value", 1, invalid, "s", &value);
+        if (JNOTNULL(json_object_get(item, "label"))) {
+            jmap_readprop_full(item, prefix, "label", 1, invalid, "s", &label);
+        }
+        json_t *jisDefault = json_object_get(item, "isDefault");
+
+        /* Bail out for any property errors. */
+        if (!type || !value || json_array_size(invalid)) {
+            buf_free(&buf);
+            return -1;
+        }
+
+        /* Update card. */
+        struct vparse_entry *entry =
+            vparse_add_entry(card, NULL, "EMAIL", value);
+
+        if (!strcmpsafe(type, "personal"))
+            type = "home";
+        if (strcmpsafe(type, "other"))
+            vparse_add_param(entry, "TYPE", type);
+
+        if (label)
+            vparse_add_param(entry, "LABEL", label);
+
+        if (jisDefault && json_is_true(jisDefault))
+            vparse_add_param(entry, "TYPE", "pref");
+
+        buf_reset(&buf);
+    }
+    buf_free(&buf);
+    return 0;
+}
+
+static int _phones_to_card(struct vparse_card *card,
+                           json_t *arg, json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "tel");
+
+    int i;
+    int size = json_array_size(arg);
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < size; i++) {
+        json_t *item = json_array_get(arg, i);
+
+        buf_printf(&buf, "phones[%d]", i);
+        const char *prefix = buf_cstring(&buf);
+
+        /* Parse properties. */
+        const char *type = NULL;
+        const char *label = NULL;
+        const char *value = NULL;
+
+        jmap_readprop_full(item, prefix, "type", 1, invalid, "s", &type);
+        if (type) {
+            if (strcmp(type, "home") && strcmp(type, "work") && strcmp(type, "mobile") &&
+                strcmp(type, "fax") && strcmp(type, "pager") && strcmp(type, "other")) {
+                char *tmp = strconcat(prefix, ".type", NULL);
+                json_array_append_new(invalid, json_string(tmp));
+                free(tmp);
+            }
+        }
+        jmap_readprop_full(item, prefix, "value", 1, invalid, "s", &value);
+        if (JNOTNULL(json_object_get(item, "label"))) {
+            jmap_readprop_full(item, prefix, "label", 1, invalid, "s", &label);
+        }
+
+        /* Bail out for any property errors. */
+        if (!type || !value || json_array_size(invalid)) {
+            buf_free(&buf);
+            return -1;
+        }
+
+        /* Update card. */
+        struct vparse_entry *entry = vparse_add_entry(card, NULL, "TEL", value);
+
+        if (!strcmp(type, "mobile"))
+            vparse_add_param(entry, "TYPE", "CELL");
+        else if (strcmp(type, "other"))
+            vparse_add_param(entry, "TYPE", type);
+
+        if (label)
+            vparse_add_param(entry, "LABEL", label);
+
+        buf_reset(&buf);
+    }
+    buf_free(&buf);
+    return 0;
+}
+
+static int _is_im(const char *type)
+{
+    /* add new services here */
+    if (!strcasecmp(type, "aim")) return 1;
+    if (!strcasecmp(type, "facebook")) return 1;
+    if (!strcasecmp(type, "gadugadu")) return 1;
+    if (!strcasecmp(type, "googletalk")) return 1;
+    if (!strcasecmp(type, "icq")) return 1;
+    if (!strcasecmp(type, "jabber")) return 1;
+    if (!strcasecmp(type, "msn")) return 1;
+    if (!strcasecmp(type, "qq")) return 1;
+    if (!strcasecmp(type, "skype")) return 1;
+    if (!strcasecmp(type, "twitter")) return 1;
+    if (!strcasecmp(type, "yahoo")) return 1;
+
+    return 0;
+}
+
+static int _online_to_card(struct vparse_card *card,
+                           json_t *arg, json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "url");
+    vparse_delete_entries(card, NULL, "impp");
+    vparse_delete_entries(card, NULL, "x-social-profile");
+    vparse_delete_entries(card, NULL, "x-fm-online-other");
+
+    int i;
+    int size = json_array_size(arg);
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < size; i++) {
+        json_t *item = json_array_get(arg, i);
+
+        buf_printf(&buf, "online[%d]", i);
+        const char *prefix = buf_cstring(&buf);
+
+        /* Parse properties. */
+        const char *type = NULL;
+        const char *label = NULL;
+        const char *value = NULL;
+
+        jmap_readprop_full(item, prefix, "type", 1, invalid, "s", &type);
+        if (type) {
+            if (strcmp(type, "uri") && strcmp(type, "username") && strcmp(type, "other")) {
+                char *tmp = strconcat(prefix, ".type", NULL);
+                json_array_append_new(invalid, json_string(tmp));
+                free(tmp);
+            }
+        }
+        jmap_readprop_full(item, prefix, "value", 1, invalid, "s", &value);
+        if (JNOTNULL(json_object_get(item, "label"))) {
+            jmap_readprop_full(item, prefix, "label", 1, invalid, "s", &label);
+        }
+
+        /* Bail out for any property errors. */
+        if (!type || !value || json_array_size(invalid)) {
+            buf_free(&buf);
+            return -1;
+        }
+
+        /* Update card. */
+        if (!strcmp(type, "uri")) {
+            struct vparse_entry *entry =
+                vparse_add_entry(card, NULL, "URL", value);
+            if (label)
+                vparse_add_param(entry, "LABEL", label);
+        }
+        else if (!strcmp(type, "username")) {
+            if (label && _is_im(label)) {
+                struct vparse_entry *entry =
+                    vparse_add_entry(card, NULL, "IMPP", value);
+                vparse_add_param(entry, "X-SERVICE-TYPE", label);
+            }
+            else {
+                struct vparse_entry *entry =
+                    vparse_add_entry(card, NULL, "X-SOCIAL-PROFILE", ""); // XXX - URL calculated, ick
+                if (label)
+                    vparse_add_param(entry, "TYPE", label);
+                vparse_add_param(entry, "X-USER", value);
+            }
+        }
+        else if (!strcmp(type, "other")) {
+            struct vparse_entry *entry =
+                vparse_add_entry(card, NULL, "X-FM-ONLINE-OTHER", value);
+            if (label)
+                vparse_add_param(entry, "LABEL", label);
+        }
+    }
+    buf_free(&buf);
+    return 0;
+}
+
+static int _addresses_to_card(struct vparse_card *card,
+                              json_t *arg, json_t *invalid)
+{
+    vparse_delete_entries(card, NULL, "adr");
+
+    int i;
+    int size = json_array_size(arg);
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < size; i++) {
+        json_t *item = json_array_get(arg, i);
+
+        buf_printf(&buf, "addresses[%d]", i);
+        const char *prefix = buf_cstring(&buf);
+
+        /* Parse properties. */
+        const char *type = NULL;
+        const char *label = NULL;
+        const char *street = NULL;
+        const char *locality = NULL;
+        const char *region = NULL;
+        const char *postcode = NULL;
+        const char *country = NULL;
+        int pe; /* parse error */
+
+        /* Mandatory */
+        pe = jmap_readprop_full(item, prefix, "type", 1, invalid, "s", &type);
+        if (type) {
+            if (strcmp(type, "home") && strcmp(type, "work") && strcmp(type, "billing") &&
+                strcmp(type, "postal") && strcmp(type, "other")) {
+                char *tmp = strconcat(prefix, ".type", NULL);
+                json_array_append_new(invalid, json_string(tmp));
+                free(tmp);
+            }
+        }
+        pe = jmap_readprop_full(item, prefix, "street", 1, invalid, "s", &street);
+        pe = jmap_readprop_full(item, prefix, "locality", 1, invalid, "s", &locality);
+        pe = jmap_readprop_full(item, prefix, "region", 1, invalid, "s", &region);
+        pe = jmap_readprop_full(item, prefix, "postcode", 1, invalid, "s", &postcode);
+        pe = jmap_readprop_full(item, prefix, "country", 1, invalid, "s", &country);
+
+        /* Optional */
+        if (JNOTNULL(json_object_get(item, "label"))) {
+            pe = jmap_readprop_full(item, prefix, "label", 0, invalid, "s", &label);
+        }
+
+        /* Bail out for any property errors. */
+        if (!type || !street || !locality ||
+            !region || !postcode || !country || pe < 0) {
+            buf_free(&buf);
+            return -1;
+        }
+
+        /* Update card. */
+        struct vparse_entry *entry = vparse_add_entry(card, NULL, "ADR", NULL);
+
+        if (strcmpsafe(type, "other"))
+            vparse_add_param(entry, "TYPE", type);
+
+        if (label)
+            vparse_add_param(entry, "LABEL", label);
+
+        entry->multivaluesep = ';';
+        entry->v.values = strarray_new();
+        strarray_append(entry->v.values, ""); // PO Box
+        strarray_append(entry->v.values, ""); // Extended Address
+        strarray_append(entry->v.values, street);
+        strarray_append(entry->v.values, locality);
+        strarray_append(entry->v.values, region);
+        strarray_append(entry->v.values, postcode);
+        strarray_append(entry->v.values, country);
+
+        buf_reset(&buf);
+    }
+
+    buf_free(&buf);
+    return 0;
+}
+
+static int _date_to_card(struct vparse_card *card,
+                         const char *key, json_t *jval)
+{
+    if (!jval)
+        return -1;
+    const char *val = json_string_value(jval);
+    if (!val)
+        return -1;
+
+    /* JMAP dates are always YYYY-MM-DD */
+    unsigned y, m, d;
+    if (_parse_date(val, &y, &m, &d, 1))
+        return -1;
+
+    /* range checks. month and day just get basic sanity checks because we're
+     * not carrying a full calendar implementation here. JMAP says zero is valid
+     * so we'll allow that and deal with it later on */
+    if (m > 12 || d > 31)
+        return -1;
+
+    /* all years are valid in JMAP, but ISO8601 only allows Gregorian ie >= 1583.
+     * moreover, iOS uses 1604 as a magic number for "unknown", so we'll say 1605
+     * is the minimum */
+    if (y > 0 && y < 1605)
+        return -1;
+
+    /* everything in range. now comes the fun bit. vCard v3 says BDAY is
+     * YYYY-MM-DD. It doesn't reference ISO8601 (vCard v4 does) and make no
+     * provision for "unknown" date components, so there's no way to represent
+     * JMAP's "unknown" values. Apple worked around this for year by using the
+     * year 1604 and adding the parameter X-APPLE-OMIT-YEAR=1604 (value
+     * apparently ignored). We will use a similar hack for month and day so we
+     * can convert it back into a JMAP date */
+
+    int no_year = 0;
+    if (y == 0) {
+        no_year = 1;
+        y = 1604;
+    }
+
+    int no_month = 0;
+    if (m == 0) {
+        no_month = 1;
+        m = 1;
+    }
+
+    int no_day = 0;
+    if (d == 0) {
+        no_day = 1;
+        d = 1;
+    }
+
+    vparse_delete_entries(card, NULL, key);
+
+    /* no values, we're done! */
+    if (no_year && no_month && no_day)
+        return 0;
+
+    /* build the value */
+    static char buf[11];
+    snprintf(buf, sizeof(buf), "%04d-%02d-%02d", y, m, d);
+    struct vparse_entry *entry = vparse_add_entry(card, NULL, key, buf);
+
+    /* set all the round-trip flags, sigh */
+    if (no_year)
+        vparse_add_param(entry, "X-APPLE-OMIT-YEAR", "1604");
+    if (no_month)
+        vparse_add_param(entry, "X-FM-NO-MONTH", "1");
+    if (no_day)
+        vparse_add_param(entry, "X-FM-NO-DAY", "1");
+
+    return 0;
+}
+
+static int _kv_to_card(struct vparse_card *card, const char *key, json_t *jval)
+{
+    if (!jval)
+        return -1;
+    const char *val = json_string_value(jval);
+    if (!val)
+        return -1;
+    vparse_replace_entry(card, NULL, key, val);
+    return 0;
+}
+
+static int _blob_to_card(struct jmap_req *req,
+                         struct vparse_card *card, const char *key, json_t *file)
+{
+    struct buf blob_buf = BUF_INITIALIZER;
+    msgrecord_t *mr = NULL;
+    struct mailbox *mbox = NULL;
+    struct body *body = NULL;
+    const struct body *part = NULL;
+    const char *blobid = NULL;
+    const char *accountid = NULL;
+    char *encbuf = NULL;
+    char *decbuf = NULL;
+    json_t *val;
+    int r = -1;
+
+    if (!file) goto done;
+
+    /* Extract blobId */
+    val = json_object_get(file, "blobId");
+    if (val) blobid = json_string_value(val);
+    if (!blobid) goto done;
+
+    /* Find body part containing blob */
+    accountid = json_string_value(json_object_get(file, "accountId"));
+    r = jmap_findblob(req, accountid, blobid,
+                      &mbox, &mr, &body, &part, &blob_buf);
+    if (r) goto done;
+
+    /* Fetch blob contents and decode */
+    const char *base = buf_base(&blob_buf);
+    size_t len = buf_len(&blob_buf);
+
+    if (part) {
+        /* Map into body part */
+        base += part->content_offset;
+        len = part->content_size;
+
+        /* Determine encoding */
+        int encoding = part->charset_enc & 0xff;
+        base = charset_decode_mimebody(base, len, encoding, &decbuf, &len);
+    }
+
+    /* Pre-flight base64 encoder to determine length */
+    size_t len64 = 0;
+    charset_encode_mimebody(NULL, len, NULL, &len64, NULL, 0 /* no wrap */);
+
+    /* Now encode the blob */
+    encbuf = xmalloc(len64+1);
+    charset_encode_mimebody(base, len, encbuf, &len64, NULL, 0 /* no wrap */);
+    encbuf[len64] = '\0';
+    base = encbuf;
+
+    /* (Re)write vCard property */
+    vparse_delete_entries(card, NULL, key);
+
+    struct vparse_entry *entry = vparse_add_entry(card, NULL, key, base);
+
+    vparse_add_param(entry, "ENCODING", "b");
+
+    val = json_object_get(file, "type");
+    if (JNOTNULL(val)) {
+        r = -1;
+        const char *type = json_string_value(val);
+        if (!type) goto done;
+        char *subtype = xstrdupnull(strchr(type, '/'));
+        if (!subtype) goto done;
+
+        vparse_add_param(entry, "TYPE", ucase(subtype+1));
+        free(subtype);
+    }
+
+    r = 0;
+
+  done:
+    free(decbuf);
+    free(encbuf);
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    buf_free(&blob_buf);
+
+    return r;
+}
+
+static void _make_fn(struct vparse_card *card)
+{
+    struct vparse_entry *n = vparse_get_entry(card, NULL, "N");
+    strarray_t *name = strarray_new();
+    const char *v;
+
+    if (n) {
+        v = strarray_safenth(n->v.values, 3); // prefix
+        if (*v) strarray_append(name, v);
+
+        v = strarray_safenth(n->v.values, 1); // first
+        if (*v) strarray_append(name, v);
+
+        v = strarray_safenth(n->v.values, 2); // middle
+        if (*v) strarray_append(name, v);
+
+        v = strarray_safenth(n->v.values, 0); // last
+        if (*v) strarray_append(name, v);
+
+        v = strarray_safenth(n->v.values, 4); // suffix
+        if (*v) strarray_append(name, v);
+    }
+
+    if (!strarray_size(name)) {
+        v = vparse_stringval(card, "NICKNAME");
+        if (v && v[0]) strarray_append(name, v);
+    }
+
+    char *fn = NULL;
+    if (strarray_size(name))
+        fn = strarray_join(name, " ");
+    else
+        fn = xstrdup(" ");
+
+    strarray_free(name);
+    vparse_replace_entry(card, NULL, "FN", fn);
+    free(fn);
+}
+
+static int _json_to_card(struct jmap_req *req,
+                         struct carddav_data *cdata,
+                         struct vparse_card *card,
+                         json_t *arg, strarray_t *flags,
+                         struct entryattlist **annotsp,
+                         json_t *invalid)
+{
+    const char *key;
+    json_t *jval;
+    struct vparse_entry *n = vparse_get_entry(card, NULL, "N");
+    int name_is_dirty = 0;
+    int has_noncontent = 0;
+    int record_is_dirty = 0;
+
+    /* we'll be updating you later anyway... create early so that it's
+     * at the top of the card */
+    if (!n) {
+        /* _card_multi repeats some work, but we don't care */
+        n = _card_multi(card, "N", ';');
+        record_is_dirty = 1;
+    }
+
+    if (!vparse_get_entry(card, NULL, "FN")) {
+        /* adding first to get position near the top */
+        vparse_add_entry(card, NULL, "FN", "No Name");
+        name_is_dirty = 1;
+    }
+
+    json_object_foreach(arg, key, jval) {
+        if (cdata) {
+            if (!strcmp(key, "id")) {
+                if (strcmpnull(cdata->vcard_uid, json_string_value(jval))) {
+                    json_array_append_new(invalid, json_string("id"));
+                }
+                continue;
+            }
+            if (!strcmp(key, "uid")) {
+                if (strcmpnull(cdata->vcard_uid, json_string_value(jval))) {
+                    json_array_append_new(invalid, json_string("uid"));
+                }
+                continue;
+            }
+            else if (!strcmp(key, "x-href")) {
+                char *xhref = jmap_xhref(cdata->dav.mailbox, cdata->dav.resource);
+                if (strcmpnull(json_string_value(jval), xhref)) {
+                    json_array_append_new(invalid, json_string("x-href"));
+                }
+                free(xhref);
+                continue;
+            }
+            else if (!strcmp(key, "x-hasPhoto")) {
+                if ((vparse_stringval(card, "photo") && !json_is_true(jval)) ||
+                    !json_is_false(jval)) {
+                    json_array_append_new(invalid, json_string("x-hasPhoto"));
+                }
+                continue;
+            }
+        }
+
+        if (!strcmp(key, "uid")) {
+            if (!json_is_string(jval)) {
+                json_array_append_new(invalid, json_string("uid"));
+            }
+        }
+        else if (!strcmp(key, "isFlagged")) {
+            has_noncontent = 1;
+            if (json_is_true(jval)) {
+                strarray_add_case(flags, "\\Flagged");
+            } else if (json_is_false(jval)) {
+                strarray_remove_all_case(flags, "\\Flagged");
+            } else {
+                json_array_append_new(invalid, json_string("isFlagged"));
+            }
+        }
+        else if (!strcmp(key, "importance")) {
+            has_noncontent = 1;
+            double dval = json_number_value(jval);
+            const char *ns = DAV_ANNOT_NS "<" XML_NS_CYRUS ">importance";
+            const char *attrib = "value.shared";
+            struct buf buf = BUF_INITIALIZER;
+            if (dval) {
+                buf_printf(&buf, "%e", dval);
+            }
+            setentryatt(annotsp, ns, attrib, &buf);
+            buf_free(&buf);
+        }
+        else if (!strcmp(key, "avatar")) {
+            if (!json_is_null(jval)) {
+                int r = _blob_to_card(req, card, "PHOTO", jval);
+                if (r) {
+                    json_array_append_new(invalid, json_string("avatar"));
+                    continue;
+                }
+                record_is_dirty = 1;
+            }
+        }
+        else if (!strcmp(key, "prefix")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("prefix"));
+                continue;
+            }
+
+            name_is_dirty = 1;
+            strarray_set(n->v.values, 3, val);
+        }
+        else if (!strcmp(key, "firstName")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("firstName"));
+                continue;
+            }
+            name_is_dirty = 1;
+            /* JMAP doesn't have a separate field for Middle (aka "Additional
+             * Names"), so any extra names are probably in firstName, and we
+             * should split them out. See reverse of this in getcontacts_cb */
+            const char *middle = strchr(val, ' ');
+            if (middle) {
+                /* multiple worlds, first to First, rest to Middle */
+                strarray_setm(n->v.values, 1, xstrndup(val, middle-val));
+                strarray_set(n->v.values, 2, ++middle);
+            }
+            else {
+                /* single word, set First, clear Middle */
+                strarray_set(n->v.values, 1, val);
+                strarray_set(n->v.values, 2, "");
+            }
+        }
+        else if (!strcmp(key, "lastName")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("lastName"));
+                continue;
+            }
+            name_is_dirty = 1;
+            strarray_set(n->v.values, 0, val);
+        }
+        else if (!strcmp(key, "suffix")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("suffix"));
+                continue;
+            }
+            name_is_dirty = 1;
+            strarray_set(n->v.values, 4, val);
+        }
+        else if (!strcmp(key, "nickname")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("nickname"));
+                continue;
+            }
+            struct vparse_entry *nick = _card_multi(card, "NICKNAME", ',');
+            strarray_truncate(nick->v.values, 0);
+            if (*val) strarray_set(nick->v.values, 0, val);
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "birthday")) {
+            int r = _date_to_card(card, "BDAY", jval);
+            if (r) {
+                json_array_append_new(invalid, json_string("birthday"));
+                continue;
+            }
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "anniversary")) {
+            int r = _date_to_card(card, "ANNIVERSARY", jval);
+            if (r) {
+                json_array_append_new(invalid, json_string("anniversary"));
+                continue;
+            }
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "jobTitle")) {
+            int r = _kv_to_card(card, "TITLE", jval);
+            if (r) {
+                json_array_append_new(invalid, json_string("jobTitle"));
+                continue;
+            }
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "company")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("company"));
+                continue;
+            }
+            struct vparse_entry *org = _card_multi(card, "ORG", ';');
+            strarray_set(org->v.values, 0, val);
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "department")) {
+            const char *val = json_string_value(jval);
+            if (!val) {
+                json_array_append_new(invalid, json_string("department"));
+                continue;
+            }
+            struct vparse_entry *org = _card_multi(card, "ORG", ';');
+            strarray_set(org->v.values, 1, val);
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "emails")) {
+            int r = _emails_to_card(card, jval, invalid);
+            if (r) continue;
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "phones")) {
+            int r = _phones_to_card(card, jval, invalid);
+            if (r) continue;
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "online")) {
+            int r = _online_to_card(card, jval, invalid);
+            if (r) continue;
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "addresses")) {
+            int r = _addresses_to_card(card, jval, invalid);
+            if (r) continue;
+            record_is_dirty = 1;
+        }
+        else if (!strcmp(key, "notes")) {
+            int r = _kv_to_card(card, "NOTE", jval);
+            if (r) {
+                json_array_append_new(invalid, json_string("notes"));
+                continue;
+            }
+            record_is_dirty = 1;
+        }
+        else {
+            json_array_append_new(invalid, json_string(key));
+        }
+    }
+
+    if (json_array_size(invalid)) return -1;
+
+    if (name_is_dirty) {
+        _make_fn(card);
+        record_is_dirty = 1;
+    }
+
+    if (!record_is_dirty && has_noncontent)
+        return HTTP_NO_CONTENT;  /* no content */
+
+    return 0;
+}
+
+static int required_set_rights(json_t *props)
+{
+    int needrights = 0;
+    const char *name;
+    json_t *val;
+
+    json_object_foreach(props, name, val) {
+        if (!strcmp(name, "id") ||
+            !strcmp(name, "x-href") ||
+            !strcmp(name, "x-hasPhoto") ||
+            !strcmp(name, "addressbookId")) {
+            /* immutable */
+        }
+        else if (!strcmp(name, "importance")) {
+            /* writing shared meta-data (per RFC 5257) */
+            needrights |= DACL_PROPRSRC;
+        }
+        else if (!strcmp(name, "isFlagged")) {
+            /* writing private meta-data */
+            needrights |= DACL_PROPCOL;
+        }
+        else {
+            /* writing vCard data */
+            needrights |= DACL_WRITECONT | DACL_RMRSRC;
+        }
+    }
+
+    return needrights;
+}
+
+static int _contact_set_create(jmap_req_t *req, unsigned kind,
+                               json_t *jcard, struct carddav_data *cdata,
+                               struct mailbox **mailbox, json_t *item,
+                               json_t *invalid)
+{
+    struct entryattlist *annots = NULL;
+    strarray_t *flags = NULL;
+    struct vparse_card *card = NULL;
+    char *uid = NULL;
+    int r = 0;
+    char *resourcename = NULL;
+
+    if ((uid = (char *) json_string_value(json_object_get(jcard, "uid")))) {
+        /* Use custom vCard UID from request object */
+        uid = xstrdup(uid);
+    }  else {
+        /* Create a vCard UID */
+        uid = xstrdup(makeuuid());
+        json_object_set_new(item, "uid", json_string(uid));
+    }
+
+    /* Determine mailbox and resource name of card.
+     * We attempt to reuse the UID as DAV resource name; but
+     * only if it looks like a reasonable URL path segment. */
+    struct buf buf = BUF_INITIALIZER;
+    const char *p;
+    for (p = uid; *p; p++) {
+        if ((*p >= '0' && *p <= '9') ||
+            (*p >= 'a' && *p <= 'z') ||
+            (*p >= 'A' && *p <= 'Z') ||
+            (p > uid &&
+                (*p == '@' || *p == '.' ||
+                 *p == '_' || *p == '-'))) {
+            continue;
+        }
+        break;
+    }
+    if (*p == '\0' && p - uid >= 16 && p - uid <= 200) {
+        buf_setcstr(&buf, uid);
+    } else {
+        buf_setcstr(&buf, makeuuid());
+    }
+    buf_appendcstr(&buf, ".vcf");
+    resourcename = buf_newcstring(&buf);
+    buf_free(&buf);
+
+    const char *addressbookId = "Default";
+    json_t *abookid = json_object_get(jcard, "addressbookId");
+    if (abookid && json_string_value(abookid)) {
+        /* XXX - invalid arguments */
+        addressbookId = json_string_value(abookid);
+    }
+    else {
+        json_object_set_new(item, "addressbookId", json_string(addressbookId));
+    }
+    char *mboxname = mboxname_abook(req->accountid, addressbookId);
+    json_object_del(jcard, "addressbookId");
+    addressbookId = NULL;
+
+    int needrights = required_set_rights(jcard);
+
+    /* Check permissions. */
+    if (!jmap_hasrights_byname(req, mboxname, needrights)) {
+        json_array_append_new(invalid, json_string("addressbookId"));
+        goto done;
+    }
+
+    card = vparse_new_card("VCARD");
+    vparse_add_entry(card, NULL, "PRODID", _prodid);
+    vparse_add_entry(card, NULL, "VERSION", "3.0");
+    vparse_add_entry(card, NULL, "UID", uid);
+
+    /* we need to create and append a record */
+    if (!*mailbox || strcmp((*mailbox)->name, mboxname)) {
+        jmap_closembox(req, mailbox);
+        r = jmap_openmbox(req, mboxname, mailbox, 1);
+        if (r == IMAP_MAILBOX_NONEXISTENT) {
+            json_array_append_new(invalid, json_string("addressbookId"));
+            r = 0;
+            goto done;
+        }
+        else if (r) goto done;
+    }
+
+    const char *name = NULL;
+    const char *logfmt = NULL;
+
+    if (kind == CARDDAV_KIND_GROUP) {
+        jmap_readprop(jcard, "name", 1, invalid, "s", &name);
+
+        vparse_add_entry(card, NULL, "N", name);
+        vparse_add_entry(card, NULL, "FN", name);
+        vparse_add_entry(card, NULL, "X-ADDRESSBOOKSERVER-KIND", "group");
+
+        /* it's legal to create an empty group */
+        json_t *members = json_object_get(jcard, "contactIds");
+        if (members) {
+            _add_group_entries(req, card, members, invalid);
+        }
+
+        /* it's legal to create an empty group */
+        json_t *others = json_object_get(jcard, "otherAccountContactIds");
+        if (others) {
+            _add_othergroup_entries(req, card, others, invalid);
+        }
+
+        logfmt = "jmap: create group %s/%s/%s (%s)";
+    }
+    else {
+        flags = strarray_new();
+        r = _json_to_card(req, cdata, card, jcard, flags, &annots, invalid);
+
+        logfmt = "jmap: create contact %s/%s (%s)";
+    }
+
+    if (r || json_array_size(invalid)) {
+        r = 0;
+        goto done;
+    }
+
+    syslog(LOG_NOTICE, logfmt, req->accountid, mboxname, uid, name);
+    r = carddav_store(*mailbox, card, resourcename, 0, flags, annots,
+                      req->accountid, req->authstate, ignorequota);
+    if (r && r != HTTP_CREATED && r != HTTP_NO_CONTENT) {
+        syslog(LOG_ERR, "carddav_store failed for user %s: %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+    r = 0;
+
+    json_object_set_new(item, "id", json_string(uid));
+
+done:
+    vparse_free_card(card);
+    free(mboxname);
+    free(resourcename);
+    strarray_free(flags);
+    freeentryatts(annots);
+    free(uid);
+
+    return r;
+}
+
+static int jmap_contact_set(struct jmap_req *req)
+{
+    _contacts_set(req, CARDDAV_KIND_CONTACT);
+    return 0;
+}
+
+const struct body *jmap_contact_findblob(struct message_guid *content_guid,
+                                         const char *part_id,
+                                         struct mailbox *mbox,
+                                         msgrecord_t *mr,
+                                         struct buf *blob)
+{
+    const struct body *ret = NULL;
+    struct index_record record;
+    struct vparse_card *vcard;
+    const char *proppath = strstr(part_id, "/VCARD#");
+
+    if (!proppath) return NULL;
+
+    msgrecord_get_index_record(mr, &record);
+    vcard = record_to_vcard(mbox, &record);
+
+    if (vcard) {
+        static struct body subpart;
+        struct buf propval = BUF_INITIALIZER;
+        char *type = NULL;
+        struct vparse_entry *entry =
+            vparse_get_entry(vcard->objects, NULL, proppath+7);
+
+        memset(&subpart, 0, sizeof(struct body));
+
+        if (entry && vcard_prop_decode_value(entry, &propval,
+                                             &type, &subpart.content_guid) &&
+            !message_guid_cmp(content_guid, &subpart.content_guid)) {
+            /* Build a body part for the property */
+            subpart.charset_enc = ENCODING_NONE;
+            subpart.encoding = "BINARY";
+            subpart.header_offset = 0;
+            subpart.content_size = buf_len(&propval);
+            ret = &subpart;
+
+            buf_reset(blob);
+            buf_printf(blob, "User-Agent: Cyrus-JMAP/%s\r\n", CYRUS_VERSION);
+
+            struct buf from = BUF_INITIALIZER;
+            if (strchr(httpd_userid, '@')) {
+                /* XXX  This needs to be done via an LDAP/DB lookup */
+                buf_printf(&from, "<%s>", httpd_userid);
+            }
+            else {
+                buf_printf(&from, "<%s@%s>", httpd_userid, config_servername);
+            }
+            
+            char *mimehdr = charset_encode_mimeheader(buf_cstring(&from),
+                                                      buf_len(&from), 0);
+
+            buf_printf(blob, "From: %s\r\n", mimehdr);
+            free(mimehdr);
+            buf_free(&from);
+
+            char datestr[80];
+            time_to_rfc5322(time(NULL), datestr, sizeof(datestr));
+            buf_printf(blob, "Date: %s\r\n", datestr);
+
+            if (!type) type = xstrdup("application/octet-stream");
+            buf_printf(blob, "Content-Type: %s\r\n", type);
+
+            buf_printf(blob, "Content-Transfer-Encoding: %s\r\n",
+                       subpart.encoding);
+
+            buf_printf(blob, "Content-Length: %u\r\n", subpart.content_size);
+
+            buf_appendcstr(blob, "MIME-Version: 1.0\r\n\r\n");
+
+            subpart.content_offset = subpart.header_size = buf_len(blob);
+
+            buf_append(blob, &propval);
+            buf_free(&propval);
+        }
+        else buf_free(&propval);
+
+        free(type);
+        vparse_free_card(vcard);
+    }
+
+    return ret;
+}
+
+static void _contact_copy(jmap_req_t *req,
+                          json_t *jcard,
+                          struct carddav_db *src_db,
+                          json_t **new_card,
+                          json_t **set_err)
+{
+    struct jmap_parser myparser = JMAP_PARSER_INITIALIZER;
+    struct vparse_card *vcard = NULL;
+    json_t *dst_card = NULL;
+    struct mailbox *src_mbox = NULL;
+    struct mailbox *dst_mbox = NULL;
+    int r = 0;
+
+    /* Read mandatory properties */
+    const char *src_id = json_string_value(json_object_get(jcard, "id"));
+    if (!src_id) {
+        jmap_parser_invalid(&myparser, "id");
+    }
+    if (json_array_size(myparser.invalid)) {
+        *set_err = json_pack("{s:s s:O}", "type", "invalidProperties",
+                                          "properties", myparser.invalid);
+        goto done;
+    }
+
+    /* Lookup event */
+    struct carddav_data *cdata = NULL;
+    r = carddav_lookup_uid(src_db, src_id, &cdata);
+    if (r && r != CYRUSDB_NOTFOUND) {
+        syslog(LOG_ERR, "carddav_lookup_uid(%s) failed: %s",
+               src_id, error_message(r));
+        goto done;
+    }
+    if (r == CYRUSDB_NOTFOUND || !cdata->dav.alive ||
+        !cdata->dav.rowid || !cdata->dav.imap_uid) {
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+    if (!jmap_hasrights_byname(req, cdata->dav.mailbox, DACL_READ)) {
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+
+    /* Read source event */
+    r = jmap_openmbox(req, cdata->dav.mailbox, &src_mbox, /*rw*/0);
+    if (r) goto done;
+    struct index_record record;
+    r = mailbox_find_index_record(src_mbox, cdata->dav.imap_uid, &record);
+    if (!r) vcard = record_to_vcard(src_mbox, &record);
+    if (!vcard || !vcard->objects) {
+        syslog(LOG_ERR, "contact_copy: can't convert %s to JMAP", src_id);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Patch JMAP event */
+    json_t *src_card = jmap_contact_from_vcard(vcard->objects, src_mbox, &record);
+    if (src_card) {
+        json_t *avatar = json_object_get(src_card, "avatar");
+        if (avatar) {
+            /* _blob_to_card() needs to know in which account to find blob */
+            json_object_set(avatar, "accountId",
+                            json_object_get(req->args, "fromAccountId"));
+        }
+        json_object_del(src_card, "x-href");  // immutable and WILL change
+        json_object_del(src_card, "x-hasPhoto");  // immutable and WILL change
+        dst_card = jmap_patchobject_apply(src_card, jcard, NULL);
+    }
+    json_decref(src_card);
+
+    /* Create vcard */
+    json_t *invalid = json_array();
+    json_t *item = json_object();
+    r = _contact_set_create(req, CARDDAV_KIND_CONTACT, dst_card,
+                           cdata, &dst_mbox, item, invalid);
+    if (r || json_array_size(invalid)) {
+        if (!r) {
+            *set_err = json_pack("{s:s s:o}", "type", "invalidProperties",
+                                              "properties", invalid);
+        }
+        json_decref(item);
+        goto done;
+    }
+    json_decref(invalid);
+
+    *new_card = item;
+
+done:
+    if (r && *set_err == NULL) {
+        if (r == CYRUSDB_NOTFOUND)
+            *set_err = json_pack("{s:s}", "type", "notFound");
+        else
+            *set_err = jmap_server_error(r);
+        return;
+    }
+    jmap_closembox(req, &dst_mbox);
+    jmap_closembox(req, &src_mbox);
+    if (vcard) vparse_free_card(vcard);
+    json_decref(dst_card);
+    jmap_parser_fini(&myparser);
+}
+
+static int jmap_contact_copy(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_copy copy;
+    json_t *err = NULL;
+    struct carddav_db *src_db = NULL;
+    json_t *destroy_cards = json_array();
+
+    /* Parse request */
+    jmap_copy_parse(req, &parser, NULL, NULL, &copy, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    src_db = carddav_open_userid(copy.from_account_id);
+    if (!src_db) {
+        jmap_error(req, json_pack("{s:s}", "type", "fromAccountNotFound"));
+        goto done;
+    }
+
+    /* Process request */
+    const char *creation_id;
+    json_t *jcard;
+    json_object_foreach(copy.create, creation_id, jcard) {
+        /* Copy event */
+        json_t *set_err = NULL;
+        json_t *new_card = NULL;
+
+        _contact_copy(req, jcard, src_db, /*dst_db,*/ &new_card, &set_err);
+        if (set_err) {
+            json_object_set_new(copy.not_created, creation_id, set_err);
+            continue;
+        }
+
+        // extract the id for later deletion
+        json_array_append(destroy_cards, json_object_get(jcard, "id"));
+
+        /* Report event as created */
+        json_object_set_new(copy.created, creation_id, new_card);
+        const char *card_id = json_string_value(json_object_get(new_card, "id"));
+        jmap_add_id(req, creation_id, card_id);
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_copy_reply(&copy));
+
+    /* Destroy originals, if requested */
+    if (copy.on_success_destroy_original && json_array_size(destroy_cards)) {
+        json_t *subargs = json_object();
+        json_object_set(subargs, "destroy", destroy_cards);
+        json_object_set_new(subargs, "accountId", json_string(copy.from_account_id));
+        jmap_add_subreq(req, "Contact/set", subargs, NULL);
+    }
+
+done:
+    json_decref(destroy_cards);
+    if (src_db) carddav_close(src_db);
+    jmap_parser_fini(&parser);
+    jmap_copy_fini(&copy);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_core.c 3.2.0-3/imap/jmap_core.c
--- 3.0.13-5/imap/jmap_core.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_core.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,616 @@
+/* jmap_core.c -- Routines for handling JMAP Core requests
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <errno.h>
+
+#include <string.h>
+#include <syslog.h>
+
+#include "acl.h"
+#include "append.h"
+#include "http_jmap.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+#include "imap/jmap_err.h"
+
+
+/* JMAP Core API Methods */
+static int jmap_blob_get(jmap_req_t *req);
+static int jmap_blob_copy(jmap_req_t *req);
+static int jmap_core_echo(jmap_req_t *req);
+
+/* JMAP extension methods */
+static int jmap_quota_get(jmap_req_t *req);
+
+jmap_method_t jmap_core_methods_standard[] = {
+    {
+        "Blob/copy",
+        JMAP_URN_CORE,
+        &jmap_blob_copy,
+        0/*flags*/
+    },
+    {
+        "Blob/get",
+        JMAP_URN_CORE,
+        &jmap_blob_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Core/echo",
+        JMAP_URN_CORE,
+        &jmap_core_echo,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+jmap_method_t jmap_core_methods_nonstandard[] = {
+    {
+        "Quota/get",
+        JMAP_QUOTA_EXTENSION,
+        &jmap_quota_get,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+HIDDEN void jmap_core_init(jmap_settings_t *settings)
+{
+#define _read_opt(val, optkey) \
+    val = config_getint(optkey); \
+    if (val <= 0) { \
+        syslog(LOG_ERR, "jmap: invalid property value: %s", \
+                imapopts[optkey].optname); \
+        val = 0; \
+    }
+    _read_opt(settings->limits[MAX_SIZE_UPLOAD],
+              IMAPOPT_JMAP_MAX_SIZE_UPLOAD);
+    settings->limits[MAX_SIZE_UPLOAD] *= 1024;
+    _read_opt(settings->limits[MAX_CONCURRENT_UPLOAD],
+              IMAPOPT_JMAP_MAX_CONCURRENT_UPLOAD);
+    _read_opt(settings->limits[MAX_SIZE_REQUEST],
+              IMAPOPT_JMAP_MAX_SIZE_REQUEST);
+    settings->limits[MAX_SIZE_REQUEST] *= 1024;
+    _read_opt(settings->limits[MAX_CONCURRENT_REQUESTS],
+              IMAPOPT_JMAP_MAX_CONCURRENT_REQUESTS);
+    _read_opt(settings->limits[MAX_CALLS_IN_REQUEST],
+              IMAPOPT_JMAP_MAX_CALLS_IN_REQUEST);
+    _read_opt(settings->limits[MAX_OBJECTS_IN_GET],
+              IMAPOPT_JMAP_MAX_OBJECTS_IN_GET);
+    _read_opt(settings->limits[MAX_OBJECTS_IN_SET],
+              IMAPOPT_JMAP_MAX_OBJECTS_IN_SET);
+#undef _read_opt
+
+    json_object_set_new(settings->server_capabilities,
+            JMAP_URN_CORE,
+            json_pack("{s:i s:i s:i s:i s:i s:i s:i s:o}",
+                "maxSizeUpload",
+                settings->limits[MAX_SIZE_UPLOAD],
+                "maxConcurrentUpload",
+                settings->limits[MAX_CONCURRENT_UPLOAD],
+                "maxSizeRequest",
+                settings->limits[MAX_SIZE_REQUEST],
+                "maxConcurrentRequests",
+                settings->limits[MAX_CONCURRENT_REQUESTS],
+                "maxCallsInRequest",
+                settings->limits[MAX_CALLS_IN_REQUEST],
+                "maxObjectsInGet",
+                settings->limits[MAX_OBJECTS_IN_GET],
+                "maxObjectsInSet",
+                settings->limits[MAX_OBJECTS_IN_SET],
+                "collationAlgorithms", json_array()));
+
+    jmap_method_t *mp;
+    for (mp = jmap_core_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(settings->server_capabilities,
+                JMAP_QUOTA_EXTENSION, json_object());
+        json_object_set_new(settings->server_capabilities,
+                JMAP_PERFORMANCE_EXTENSION, json_object());
+        json_object_set_new(settings->server_capabilities,
+                JMAP_DEBUG_EXTENSION, json_object());
+
+        for (mp = jmap_core_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+
+}
+
+HIDDEN void jmap_core_capabilities(json_t *account_capabilities)
+{
+    json_object_set_new(account_capabilities,
+            JMAP_URN_CORE, json_object());
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(account_capabilities,
+                JMAP_QUOTA_EXTENSION, json_object());
+
+        json_object_set_new(account_capabilities,
+                JMAP_PERFORMANCE_EXTENSION, json_object());
+
+        json_object_set_new(account_capabilities,
+                JMAP_DEBUG_EXTENSION, json_object());
+    }
+}
+
+/*
+ * JMAP Core API Methods
+ */
+
+/* Core/echo method */
+static int jmap_core_echo(jmap_req_t *req)
+{
+    json_array_append_new(req->response,
+                          json_pack("[s,O,s]", "Core/echo", req->args, req->tag));
+    return 0;
+}
+
+static int jmap_copyblob(jmap_req_t *req,
+                         const char *blobid,
+                         const char *from_accountid,
+                         struct mailbox *to_mbox)
+{
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    struct body *body = NULL;
+    const struct body *part = NULL;
+    struct buf msg_buf = BUF_INITIALIZER;
+    FILE *to_fp = NULL;
+    struct stagemsg *stage = NULL;
+
+    int r = jmap_findblob(req, from_accountid, blobid,
+                          &mbox, &mr, &body, &part, &msg_buf);
+    if (r) return r;
+
+    /* Create staging file */
+    time_t internaldate = time(NULL);
+    if (!(to_fp = append_newstage(to_mbox->name, internaldate, 0, &stage))) {
+        syslog(LOG_ERR, "jmap_copyblob(%s): append_newstage(%s) failed",
+                blobid, mbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Copy blob. Keep the original MIME headers, we wouldn't really
+     * know which ones are safe to rewrite for arbitrary blobs. */
+    if (part) {
+        fwrite(buf_base(&msg_buf) + part->header_offset,
+               part->header_size + part->content_size, 1, to_fp);
+    }
+    else {
+        fwrite(buf_base(&msg_buf), buf_len(&msg_buf), 1, to_fp);
+    }
+    if (ferror(to_fp)) {
+        syslog(LOG_ERR, "jmap_copyblob(%s): tofp=%s: %s",
+               blobid, append_stagefname(stage), strerror(errno));
+        r = IMAP_IOERROR;
+        goto done;
+    }
+    fclose(to_fp);
+    to_fp = NULL;
+
+    /* Append blob to mailbox */
+    struct body *to_body = NULL;
+    struct appendstate as;
+    r = append_setup_mbox(&as, to_mbox, httpd_userid, httpd_authstate,
+            0, /*quota*/NULL, 0, 0, /*event*/0);
+    if (r) {
+        syslog(LOG_ERR, "jmap_copyblob(%s): append_setup_mbox: %s",
+                blobid, error_message(r));
+        goto done;
+    }
+    strarray_t flags = STRARRAY_INITIALIZER;
+    strarray_append(&flags, "\\Deleted");
+    strarray_append(&flags, "\\Expunged");  // custom flag to insta-expunge!
+	r = append_fromstage(&as, &to_body, stage, 0, internaldate, &flags, 0, NULL);
+    strarray_fini(&flags);
+	if (r) {
+        syslog(LOG_ERR, "jmap_copyblob(%s): append_fromstage: %s",
+                blobid, error_message(r));
+		append_abort(&as);
+		goto done;
+	}
+	message_free_body(to_body);
+	free(to_body);
+	r = append_commit(&as);
+	if (r) {
+        syslog(LOG_ERR, "jmap_copyblob(%s): append_commit: %s",
+                blobid, error_message(r));
+        goto done;
+    }
+
+done:
+    if (stage) append_removestage(stage);
+    if (to_fp) fclose(to_fp);
+    buf_free(&msg_buf);
+    message_free_body(body);
+    free(body);
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    return r;
+}
+
+/* Blob/copy method */
+static int jmap_blob_copy(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_copy copy;
+    json_t *val, *err = NULL;
+    size_t i = 0;
+    int r = 0;
+    struct mailbox *to_mbox = NULL;
+
+    /* Parse request */
+    jmap_copy_parse(req, &parser, NULL, NULL, &copy, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto cleanup;
+    }
+
+    /* Check if we can upload to toAccountId */
+    r = jmap_open_upload_collection(req->accountid, &to_mbox);
+    if (r == IMAP_PERMISSION_DENIED) {
+        json_array_foreach(copy.create, i, val) {
+            json_object_set(copy.not_created, json_string_value(val),
+                    json_pack("{s:s}", "type", "toAccountNotFound"));
+        }
+        goto done;
+    } else if (r) {
+        syslog(LOG_ERR, "jmap_blob_copy: jmap_create_upload_collection(%s): %s",
+               req->accountid, error_message(r));
+        goto cleanup;
+    }
+
+    /* Copy blobs one by one. XXX should we batch copy here? */
+    json_array_foreach(copy.create, i, val) {
+        const char *blobid = json_string_value(val);
+        r = jmap_copyblob(req, blobid, copy.from_account_id, to_mbox);
+        if (r == IMAP_NOTFOUND || r == IMAP_PERMISSION_DENIED) {
+            json_object_set_new(copy.not_created, blobid,
+                    json_pack("{s:s}", "type", "blobNotFound"));
+        }
+        else if (r) goto cleanup;
+        else json_object_set_new(copy.created, blobid, json_string(blobid));
+    }
+
+done:
+    /* Build response */
+    jmap_ok(req, jmap_copy_reply(&copy));
+    r = 0;
+
+cleanup:
+    jmap_parser_fini(&parser);
+    jmap_copy_fini(&copy);
+    mailbox_close(&to_mbox);
+    return r;
+}
+
+/* Blob/get method */
+
+struct getblob_rec {
+    const char *blob_id;
+    uint32_t uid;
+    char *part;
+};
+
+struct getblob_cb_rock {
+    jmap_req_t *req;
+    const char *blob_id;
+    hash_table *getblobs_by_mboxname;
+};
+
+static int getblob_cb(const conv_guidrec_t* rec, void* vrock)
+{
+    struct getblob_cb_rock *rock = vrock;
+
+    struct getblob_rec *getblob = xzmalloc(sizeof(struct getblob_rec));
+    getblob->blob_id = rock->blob_id;
+    getblob->uid = rec->uid;
+    getblob->part = xstrdupnull(rec->part);
+
+    ptrarray_t *getblobs = hash_lookup(rec->mboxname, rock->getblobs_by_mboxname);
+    if (!getblobs) {
+        getblobs = ptrarray_new();
+        hash_insert(rec->mboxname, getblobs, rock->getblobs_by_mboxname);
+    }
+    ptrarray_append(getblobs, getblob);
+
+    return 0;
+}
+
+static const jmap_property_t blob_props[] = {
+    {
+        "mailboxIds",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "threadIds",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "emailIds",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_blob_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+    json_t *jval;
+    size_t i;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, blob_props, /*allow_null_ids*/0,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Sort blob lookups by mailbox */
+    hash_table getblobs_by_mboxname = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&getblobs_by_mboxname, 128, 0);
+    json_array_foreach(get.ids, i, jval) {
+        const char *blob_id = json_string_value(jval);
+        if (*blob_id == 'G') {
+            struct getblob_cb_rock rock = { req, blob_id, &getblobs_by_mboxname };
+            int r = conversations_guid_foreach(req->cstate, blob_id + 1, getblob_cb, &rock);
+            if (r) {
+                syslog(LOG_ERR, "jmap_blob_get: can't lookup guid %s: %s",
+                        blob_id, error_message(r));
+            }
+        }
+    }
+
+    /* Lookup blobs by mailbox */
+    json_t *found = json_object();
+    hash_iter *iter = hash_table_iter(&getblobs_by_mboxname);
+    while (hash_iter_next(iter)) {
+        const char *mboxname = hash_iter_key(iter);
+        ptrarray_t *getblobs = hash_iter_val(iter);
+        struct mailbox *mbox = NULL;
+
+        /* Open mailbox */
+        if (!jmap_hasrights_byname(req, mboxname, ACL_READ|ACL_LOOKUP)) {
+            continue;
+        }
+        int r = jmap_openmbox(req, mboxname, &mbox, 0);
+        if (r) {
+            syslog(LOG_ERR, "jmap_blob_get: can't open mailbox %s: %s",
+                    mboxname, error_message(r));
+            continue;
+        }
+
+        int j;
+        for (j = 0; j < ptrarray_size(getblobs); j++) {
+            struct getblob_rec *getblob = ptrarray_nth(getblobs, j);
+
+            /* Read message record */
+            struct message_guid guid;
+            bit64 cid;
+            msgrecord_t *mr = NULL;
+            r = msgrecord_find(mbox, getblob->uid, &mr);
+            if (!r) r = msgrecord_get_guid(mr, &guid);
+            if (!r) r = msgrecord_get_cid(mr, &cid);
+            msgrecord_unref(&mr);
+            if (r) {
+                syslog(LOG_ERR, "jmap_blob_get: can't read msgrecord %s:%d: %s",
+                        mboxname, getblob->uid, error_message(r));
+                continue;
+            }
+
+            /* Report Blob entry */
+            json_t *jblob = json_object_get(found, getblob->blob_id);
+            if (!jblob) {
+                jblob = json_object();
+                json_object_set_new(found, getblob->blob_id, jblob);
+            }
+            if (jmap_wantprop(get.props, "mailboxIds")) {
+                json_t *jmailboxIds = json_object_get(jblob, "mailboxIds");
+                if (!jmailboxIds) {
+                    jmailboxIds = json_object();
+                    json_object_set_new(jblob, "mailboxIds", jmailboxIds);
+                }
+                json_object_set_new(jmailboxIds, mbox->uniqueid, json_true());
+            }
+            if (jmap_wantprop(get.props, "emailIds")) {
+                json_t *jemailIds = json_object_get(jblob, "emailIds");
+                if (!jemailIds) {
+                    jemailIds = json_object();
+                    json_object_set_new(jblob, "emailIds", jemailIds);
+                }
+                char emailid[JMAP_EMAILID_SIZE];
+                jmap_set_emailid(&guid, emailid);
+                json_object_set_new(jemailIds, emailid, json_true());
+            }
+            if (jmap_wantprop(get.props, "threadIds")) {
+                json_t *jthreadIds = json_object_get(jblob, "threadIds");
+                if (!jthreadIds) {
+                    jthreadIds = json_object();
+                    json_object_set_new(jblob, "threadIds", jthreadIds);
+                }
+                char threadid[JMAP_THREADID_SIZE];
+                jmap_set_threadid(cid, threadid);
+                json_object_set_new(jthreadIds, threadid, json_true());
+            }
+        }
+
+       jmap_closembox(req, &mbox);
+    }
+
+    /* Clean up memory */
+    hash_iter_reset(iter);
+    while (hash_iter_next(iter)) {
+        ptrarray_t *getblobs = hash_iter_val(iter);
+        struct getblob_rec *getblob;
+        while ((getblob = ptrarray_pop(getblobs))) {
+            free(getblob->part);
+            free(getblob);
+        }
+        ptrarray_free(getblobs);
+    }
+    hash_iter_free(&iter);
+    free_hash_table(&getblobs_by_mboxname, NULL);
+
+    /* Report found blobs */
+    if (json_object_size(found)) {
+        const char *blob_id;
+        json_t *jblob;
+        json_object_foreach(found, blob_id, jblob) {
+            json_array_append(get.list, jblob);
+        }
+    }
+
+    /* Report unknown or erroneous blobs */
+    json_array_foreach(get.ids, i, jval) {
+        const char *blob_id = json_string_value(jval);
+        if (!json_object_get(found, blob_id)) {
+            json_array_append_new(get.not_found, json_string(blob_id));
+        }
+    }
+
+    json_decref(found);
+
+    /* Reply */
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
+
+/* Quota/get method */
+static const jmap_property_t quota_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "used",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "total",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_quota_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, quota_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    int want_mail_quota = !get.ids || json_is_null(get.ids);
+    size_t i;
+    json_t *jval;
+    json_array_foreach(get.ids, i, jval) {
+        if (strcmp("mail", json_string_value(jval))) {
+            json_array_append(get.not_found, jval);
+        }
+        else want_mail_quota = 1;
+    }
+
+    if (want_mail_quota) {
+        struct quota quota;
+        quota_init(&quota, inboxname);
+        int r = quota_read(&quota, NULL, 0);
+        if (!r) {
+            quota_t total = quota.limits[QUOTA_STORAGE] * quota_units[QUOTA_STORAGE];
+            quota_t used = quota.useds[QUOTA_STORAGE];
+            json_t *jquota = json_object();
+            json_object_set_new(jquota, "id", json_string("mail"));
+            json_object_set_new(jquota, "used", json_integer(used));
+            json_object_set_new(jquota, "total", json_integer(total));
+            json_array_append_new(get.list, jquota);
+        }
+        else {
+            syslog(LOG_ERR, "jmap_quota_get: can't read quota for %s: %s",
+                    inboxname, error_message(r));
+            json_array_append_new(get.not_found, json_string("mail"));
+        }
+        quota_free(&quota);
+    }
+
+
+    modseq_t quotamodseq = mboxname_readquotamodseq(inboxname);
+    struct buf buf = BUF_INITIALIZER;
+    buf_printf(&buf, MODSEQ_FMT, quotamodseq);
+    get.state = buf_release(&buf);
+
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    free(inboxname);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_err.et 3.2.0-3/imap/jmap_err.et
--- 3.0.13-5/imap/jmap_err.et	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_err.et	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,70 @@
+# jmap_err.et -- Error codes for the Cyrus JMAP Service
+#
+# Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in
+#    the documentation and/or other materials provided with the
+#    distribution.
+#
+# 3. The name "Carnegie Mellon University" must not be used to
+#    endorse or promote products derived from this software without
+#    prior written permission. For permission or any legal
+#    details, please contact
+#      Carnegie Mellon University
+#      Center for Technology Transfer and Enterprise Creation
+#      4615 Forbes Avenue
+#      Suite 302
+#      Pittsburgh, PA  15213
+#      (412) 268-7393, fax: (412) 268-7395
+#      innovation@andrew.cmu.edu
+#
+# 4. Redistributions of any form whatsoever must retain the following
+#    acknowledgment:
+#    "This product includes software developed by Computing Services
+#     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+#
+# CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+# AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+# FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+# OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+#
+
+# Use "JMAP" as the name rather than "jmap" because it hashes too close to "imap"
+#
+# We encode both the JSON error 'type and 'title' in a single string
+
+error_table JMAP
+
+ec JMAP_NOT_JSON,
+   "urn:ietf:params:jmap:error:notJSON\0Request body did not parse as I-JSON"
+
+ec JMAP_NOT_REQUEST,
+   "urn:ietf:params:jmap:error:notRequest\0JSON request body is not a JMAP Request object"
+
+ec JMAP_UNKNOWN_CAPABILITY,
+   "urn:ietf:params:jmap:error:unknownCapability\0JMAP request uses unsupported capabilities"
+
+ec JMAP_LIMIT_SIZE,
+   "urn:ietf:params:jmap:error:limit\0JMAP request exceeds a server limit\0maxSizeRequest"
+
+ec JMAP_LIMIT_CALLS,
+   "urn:ietf:params:jmap:error:limit\0JMAP request exceeds a server limit\0maxCallsInRequest"
+
+ec JMAP_LIMIT_OBJS_GET,
+   "urn:ietf:params:jmap:error:limit\0JMAP request exceeds a server limit\0maxObjectsInGet"
+
+ec JMAP_LIMIT_OBJS_SET,
+   "urn:ietf:params:jmap:error:limit\0JMAP request exceeds a server limit\0maxObjectsInSet"
+
+end
diff -pruN 3.0.13-5/imap/jmap_ical.c 3.2.0-3/imap/jmap_ical.c
--- 3.0.13-5/imap/jmap_ical.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_ical.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,5063 @@
+/* jmap_ical.c --Routines to convert calendar events between JMAP and iCalendar
+ *
+ * Copyright (c) 1994-2016 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+
+#include "acl.h"
+#include "annotate.h"
+#include "append.h"
+#include "caldav_db.h"
+#include "carddav_db.h"
+#include "global.h"
+#include "hash.h"
+#include "httpd.h"
+#include "http_caldav.h"
+#include "http_carddav.h"
+#include "http_caldav_sched.h"
+#include "http_dav.h"
+#include "http_jmap.h"
+#include "http_proxy.h"
+#include "ical_support.h"
+#include "icu_wrap.h"
+#include "json_support.h"
+#include "mailbox.h"
+#include "mboxlist.h"
+#include "mboxname.h"
+#include "parseaddr.h"
+#include "seen.h"
+#include "statuscache.h"
+#include "stristr.h"
+#include "times.h"
+#include "util.h"
+#include "vcard_support.h"
+#include "version.h"
+#include "xmalloc.h"
+#include "xsha1.h"
+#include "xstrlcat.h"
+#include "xstrlcpy.h"
+#include "zoneinfo_db.h"
+
+/* for sasl_encode64 */
+#include <sasl/sasl.h>
+#include <sasl/saslutil.h>
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+#include "jmap_ical.h"
+
+static int is_valid_jmapid(const char *s)
+{
+    if (!s) return 0;
+    size_t i;
+    for (i = 0; s[i] && i < 256; i++) {
+        char c = s[i];
+        if (!((('0' <= c) && (c <= '9')) ||
+              (('a' <= c) && (c <= 'z')) ||
+              (('A' <= c) && (c <= 'Z')) ||
+              ((c == '-' || c == '_')))) {
+            return 0;
+        }
+    }
+    return i > 0 && s[i] == '\0';
+}
+
+/* Forward declarations */
+static json_t *calendarevent_from_ical(icalcomponent *comp, hash_table *props, icalcomponent *master);
+static void calendarevent_to_ical(icalcomponent *comp, icalcomponent *oldical,
+                                  struct jmap_parser *parser, json_t *jsevent);
+
+static char *sha1key(const char *val)
+{
+    unsigned char dest[SHA1_DIGEST_LENGTH];
+    char idbuf[2*SHA1_DIGEST_LENGTH+1];
+    int r;
+
+    xsha1((const unsigned char *) val, strlen(val), dest);
+    r = bin_to_hex(dest, SHA1_DIGEST_LENGTH, idbuf, BH_LOWER);
+    assert(r == 2*SHA1_DIGEST_LENGTH);
+    idbuf[2*SHA1_DIGEST_LENGTH] = '\0';
+    return xstrdup(idbuf);
+}
+
+static char *mailaddr_from_uri(const char *uri)
+{
+    if (!uri || strncasecmp(uri, "mailto:", 7)) {
+        return NULL;
+    }
+    uri += 7;
+    const char *p = strchr(uri, '?');
+    if (!p) return address_canonicalise(uri);
+
+    char *tmp = xstrndup(uri, p - uri);
+    char *ret = address_canonicalise(uri);
+    free(tmp);
+    return ret;
+}
+
+static char *normalized_uri(const char *uri)
+{
+    const char *col = strchr(uri, ':');
+    if (!col) return xstrdupnull(uri);
+
+    struct buf buf = BUF_INITIALIZER;
+    buf_setmap(&buf, uri, col - uri);
+    buf_lcase(&buf);
+    buf_appendcstr(&buf, col);
+    return buf_release(&buf);
+}
+
+static char *mailaddr_to_uri(const char *addr)
+{
+    struct buf buf = BUF_INITIALIZER;
+    buf_setcstr(&buf, "mailto:");
+    buf_appendcstr(&buf, addr);
+    return buf_release(&buf);
+}
+
+static void remove_icalxparam(icalproperty *prop, const char *name)
+{
+    icalparameter *param, *next;
+
+    for (param = icalproperty_get_first_parameter(prop, ICAL_ANY_PARAMETER);
+         param;
+         param = next) {
+
+        next = icalproperty_get_next_parameter(prop, ICAL_ANY_PARAMETER);
+        if (strcasecmpsafe(icalparameter_get_xname(param), name)) {
+            continue;
+        }
+        icalproperty_remove_parameter_by_ref(prop, param);
+    }
+}
+
+
+static const char*
+get_icalxparam_value(icalproperty *prop, const char *name)
+{
+    icalparameter *param;
+
+    for (param = icalproperty_get_first_parameter(prop, ICAL_ANY_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_ANY_PARAMETER)) {
+
+        if (strcasecmpsafe(icalparameter_get_xname(param), name)) {
+            continue;
+        }
+        return icalparameter_get_xvalue(param);
+    }
+
+    return NULL;
+}
+
+static void
+set_icalxparam(icalproperty *prop, const char *name, const char *val, int purge)
+{
+    icalparameter *param;
+
+    if (purge) remove_icalxparam(prop, name);
+
+    param = icalparameter_new(ICAL_X_PARAMETER);
+    icalparameter_set_xname(param, name);
+    icalparameter_set_xvalue(param, val);
+    icalproperty_add_parameter(prop, param);
+}
+
+/* Compare the value of the first occurences of property kind in components
+ * a and b. Return 0 if they match or if both do not contain kind. Note that
+ * this function does not define an order on property values, so it can't be
+ * used for sorting. */
+int compare_icalprop(icalcomponent *a, icalcomponent *b,
+                     icalproperty_kind kind) {
+    icalproperty *pa, *pb;
+    icalvalue *va, *vb;
+
+    pa = icalcomponent_get_first_property(a, kind);
+    pb = icalcomponent_get_first_property(b, kind);
+    if (!pa && !pb) {
+        return 0;
+    }
+
+    va = icalproperty_get_value(pa);
+    vb = icalproperty_get_value(pb);
+    enum icalparameter_xliccomparetype cmp = icalvalue_compare(va, vb);
+    return cmp != ICAL_XLICCOMPARETYPE_EQUAL;
+}
+
+static const char*
+get_icalxprop_value(icalcomponent *comp, const char *name)
+{
+    icalproperty *prop;
+
+    for (prop = icalcomponent_get_first_property(comp, ICAL_X_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_X_PROPERTY)) {
+
+        if (strcasecmp(icalproperty_get_x_name(prop), name)) {
+            continue;
+        }
+        return icalproperty_get_value_as_string(prop);
+    }
+
+    return NULL;
+}
+
+/* Remove and deallocate any x-properties with name in comp. */
+static void remove_icalxprop(icalcomponent *comp, const char *name)
+{
+    icalproperty *prop, *next;
+    icalproperty_kind kind = ICAL_X_PROPERTY;
+
+    for (prop = icalcomponent_get_first_property(comp, kind);
+         prop;
+         prop = next) {
+
+        next = icalcomponent_get_next_property(comp, kind);
+
+        if (strcasecmp(icalproperty_get_x_name(prop), name))
+            continue;
+
+        icalcomponent_remove_property(comp, prop);
+        icalproperty_free(prop);
+    }
+}
+
+static char *xjmapid_from_ical(icalproperty *prop)
+{
+    const char *id = (char *) get_icalxparam_value(prop, JMAPICAL_XPARAM_ID);
+    if (id) return xstrdup(id);
+    return sha1key(icalproperty_as_ical_string(prop));
+}
+
+static void xjmapid_to_ical(icalproperty *prop, const char *id)
+{
+    struct buf buf = BUF_INITIALIZER;
+    icalparameter *param;
+
+    buf_setcstr(&buf, JMAPICAL_XPARAM_ID);
+    buf_appendcstr(&buf, "=");
+    buf_appendcstr(&buf, id);
+    param = icalparameter_new_from_string(buf_cstring(&buf));
+    icalproperty_add_parameter(prop, param);
+
+    buf_free(&buf);
+}
+
+HIDDEN int jmapical_datetime_has_zero_time(const struct jmapical_datetime *dt)
+{
+    return dt->hour == 0 && dt->minute == 0 && dt->second == 0 && dt->nano == 0;
+}
+
+HIDDEN struct icaltimetype jmapical_datetime_to_icaldate(const struct jmapical_datetime *dt)
+{
+    struct icaltimetype icaldt = icaltime_null_time();
+    icaldt.year = dt->year;
+    icaldt.month = dt->month;
+    icaldt.day = dt->day;
+    icaldt.hour = dt->hour;
+    icaldt.minute = dt->minute;
+    icaldt.second = dt->second;
+    icaldt.is_date = 1;
+    return icaldt;
+}
+
+HIDDEN icaltimetype jmapical_datetime_to_icaltime(const struct jmapical_datetime *dt,
+                                                  const icaltimezone* zone)
+{
+    struct icaltimetype icaldt = icaltime_null_time();
+    icaldt.year = dt->year;
+    icaldt.month = dt->month;
+    icaldt.day = dt->day;
+    icaldt.hour = dt->hour;
+    icaldt.minute = dt->minute;
+    icaldt.second = dt->second;
+    icaldt.is_date = 0;
+    icaldt.zone = zone;
+    return icaldt;
+}
+
+
+HIDDEN void jmapical_datetime_from_icaltime(icaltimetype icaldt, struct jmapical_datetime *dt)
+{
+    memset(dt, 0, sizeof(struct jmapical_datetime));
+    dt->year = icaldt.year;
+    dt->month = icaldt.month;
+    dt->day = icaldt.day;
+    dt->hour = icaldt.hour;
+    dt->minute = icaldt.minute;
+    dt->second = icaldt.second;
+}
+
+HIDDEN int jmapical_datetime_compare(const struct jmapical_datetime *a,
+                                     const struct jmapical_datetime *b)
+{
+    if (a->year != b->year)
+        return a->year > b->year ? 1 : -1;
+    if (a->month != b->month)
+        return a->month > b->month ? 1 : -1;
+    if (a->day != b->day)
+        return a->day > b->day ? 1 : -1;
+    if (a->hour != b->hour)
+        return a->hour > b->hour ? 1 : -1;
+    if (a->minute != b->minute)
+        return a->minute > b->minute ? 1 : -1;
+    if (a->second != b->second)
+        return a->second > b->second ? 1 : -1;
+    if (a->nano != b->nano)
+        return a->nano > b->nano ? 1 : -1;
+    return 0;
+}
+
+static void format_datetime(const struct jmapical_datetime *dt, struct buf *dst)
+{
+    buf_reset(dst);
+    buf_printf(dst, "%04d-%02d-%02dT%02d:%02d:%02d",
+            dt->year, dt->month, dt->day, dt->hour, dt->minute, dt->second);
+    if (dt->nano) {
+        buf_printf(dst, ".%.9llu", dt->nano);
+        int n = buf_len(dst);
+        const char *b = buf_base(dst);
+        while (b[n-1] == '0') n--;
+        buf_truncate(dst, n);
+    }
+    buf_cstring(dst);
+}
+
+HIDDEN void jmapical_localdatetime_as_string(const struct jmapical_datetime *dt, struct buf *dst)
+{
+    format_datetime(dt, dst);
+    buf_cstring(dst);
+}
+
+HIDDEN void jmapical_utcdatetime_as_string(const struct jmapical_datetime *dt, struct buf *dst)
+{
+    format_datetime(dt, dst);
+    buf_putc(dst, 'Z');
+    buf_cstring(dst);
+}
+
+static const char *parse_fracsec(const char *val, bit64 *nanoptr)
+{
+    const char *end = NULL;
+    bit64 nano = 0;
+    if (parsenum(val, &end, 9, &nano) >= 0) {
+        /* Normalize to nanoseconds */
+        ssize_t i, n = end - val;
+        for (i = 0; i < 9 - n; i++) {
+            nano *= 10;
+        }
+        /* Skip remaining fractional seconds */
+        while (isdigit(*end)) end++;
+        /* No trailing zeros allowed */
+        if (end[-1] == '0') {
+            return NULL;
+        }
+        *nanoptr = nano;
+        return end;
+    }
+    else return NULL;
+}
+
+static const char *parse_datetime(const char *val, struct jmapical_datetime *dt)
+{
+    struct tm tm;
+    memset(&tm, 0, sizeof(struct tm));
+    tm.tm_isdst = -1;
+
+    const char *p = strptime(val, "%Y-%m-%dT%H:%M:%S", &tm);
+    if (!p) return NULL;
+
+    memset(dt, 0, sizeof(struct jmapical_datetime));
+    dt->year = tm.tm_year + 1900;
+    dt->month = tm.tm_mon + 1;
+    dt->day = tm.tm_mday;
+    dt->hour = tm.tm_hour;
+    dt->minute = tm.tm_min;
+    dt->second = tm.tm_sec;
+
+    if (*p == '.') p = parse_fracsec(p+1, &dt->nano);
+
+    return p;
+}
+
+HIDDEN int jmapical_localdatetime_from_string(const char *val, struct jmapical_datetime *dt)
+{
+    const char *p = parse_datetime(val, dt);
+    return (!p || p[0] != '\0') ? -1 : 0;
+}
+
+HIDDEN int jmapical_utcdatetime_from_string(const char *val, struct jmapical_datetime *dt)
+{
+    const char *p = parse_datetime(val, dt);
+    return (!p || p[0] != 'Z' || p[1] != '\0') ? -1 : 0;
+}
+
+static void subseconds_from_icalprop(icalproperty *prop, bit64 *nanoptr)
+{
+    *nanoptr = 0;
+    const char *subsecs = get_icalxparam_value(prop, "SUBSECOND");
+    if (subsecs && *subsecs == '0') {
+        /* Parse subseconds, ignoring invalid values */
+        while (*subsecs == '0') subsecs++;
+        if (*subsecs == '.') {
+            const char *end = parse_fracsec(subsecs+1, nanoptr);
+            if (!end || end[0] != '\0') *nanoptr = 0;
+        }
+    }
+}
+
+HIDDEN int jmapical_datetime_from_icalprop(icalproperty *prop, struct jmapical_datetime *dt)
+{
+    icaltimetype icaldt = icalvalue_get_datetimedate(icalproperty_get_value(prop));
+    if (!icaltime_is_valid_time(icaldt)) return -1;
+
+    jmapical_datetime_from_icaltime(icaldt, dt);
+    subseconds_from_icalprop(prop, &dt->nano);
+
+    return 0;
+}
+
+HIDDEN int jmapical_duration_has_zero_time(const struct jmapical_duration *dur)
+{
+    return dur->hours == 0 && dur->minutes == 0 &&
+           dur->seconds == 0 && dur->nanos == 0;
+}
+
+static struct icaldurationtype duration_to_icalduration(const struct jmapical_duration *dur)
+{
+    struct icaldurationtype icaldur = icaldurationtype_null_duration();
+
+    icaldur.is_neg = dur->is_neg;
+    icaldur.days = dur->days;
+    icaldur.weeks = dur->weeks;
+    icaldur.hours = dur->hours;
+    icaldur.minutes = dur->minutes;
+    icaldur.seconds = dur->seconds;
+
+    return icaldur;
+}
+
+HIDDEN void jmapical_duration_from_icalduration(struct icaldurationtype icaldur,
+                                                struct jmapical_duration *dur)
+{
+    memset(dur, 0, sizeof(struct jmapical_duration));
+    dur->is_neg = icaldur.is_neg;
+    dur->days = icaldur.days;
+    dur->weeks = icaldur.weeks;
+    dur->hours = icaldur.hours;
+    dur->minutes = icaldur.minutes;
+    dur->seconds = icaldur.seconds;
+}
+
+HIDDEN void jmapical_duration_between(time_t t1, bit64 t1nanos,
+                                      time_t t2, bit64 t2nanos,
+                                      struct jmapical_duration *dur)
+{
+    const icaltimezone *utc = icaltimezone_get_utc_timezone();
+    int is_neg = t1 > t2 || (t1 == t2 && t1nanos > t2nanos);
+    bit64 nanos = 0;
+
+    time_t tx = is_neg ? t2 : t1;
+    bit64 txnanos = is_neg ? t2nanos : t1nanos;
+
+    time_t ty = is_neg ? t1 : t2;
+    bit64 tynanos = is_neg ? t1nanos : t2nanos;
+
+    if (txnanos < tynanos) {
+        nanos = tynanos - txnanos;
+    }
+    else if (txnanos > tynanos) {
+        nanos = (1000000000 - txnanos) + tynanos;
+        if (tx != ty) ty -= 1;
+    }
+
+    icaltimetype icaltx = icaltime_from_timet_with_zone(tx, 0, utc);
+    icaltimetype icalty = icaltime_from_timet_with_zone(ty, 0, utc);
+    struct icaldurationtype icaldur = icaltime_subtract(icalty, icaltx);
+    icaldur.is_neg = is_neg;
+    jmapical_duration_from_icalduration(icaldur, dur);
+    dur->nanos = nanos;
+}
+
+HIDDEN int jmapical_duration_from_string(const char *val, struct jmapical_duration *dur)
+{
+    bit64 nanos = 0;
+    char *myval = NULL;
+
+    const char *fracsec = strchr(val, '.');
+    if (fracsec) {
+        // Parse fractional seconds.
+        const char *p = parse_fracsec(fracsec + 1, &nanos);
+        if (!p || p[0] != 'S' || p[1] != '\0') return -1;
+        // Truncate to iCalendar duration.
+        myval = xstrdup(val);
+        myval[fracsec-val] = 'S';
+        myval[fracsec-val+1] = '\0';
+        val = myval;
+    }
+
+    // Parse iCalendar duration.
+    struct icaldurationtype icaldur = icaldurationtype_from_string(val);
+    free(myval);
+    if (icaldurationtype_is_bad_duration(icaldur)) return -1;
+    jmapical_duration_from_icalduration(icaldur, dur);
+    dur->nanos = nanos;
+
+    return 0;
+}
+
+HIDDEN void jmapical_duration_as_string(const struct jmapical_duration *dur, struct buf *buf)
+{
+    struct icaldurationtype icaldur = duration_to_icalduration(dur);
+    char *tmp = icaldurationtype_as_ical_string_r(icaldur);
+
+    buf_setcstr(buf, tmp);
+    if (dur->nanos) {
+        const char *b = buf_base(buf);
+        int n = buf_len(buf);
+        /* Append fracsec part */
+        if (b[n-1] == 'S') {
+            buf_truncate(buf, n-1);
+        }
+        else {
+            buf_putc(buf, '0');
+        }
+        buf_printf(buf, ".%.9llu", dur->nanos);
+        /* Truncate trailing zeros */
+        b = buf_base(buf);
+        n = buf_len(buf);
+        while (b[n-1] == '0') n--;
+        buf_truncate(buf, n);
+        buf_putc(buf, 'S');
+    }
+
+    free(tmp);
+    buf_cstring(buf);
+}
+
+static icaltimezone *tz_from_tzid(const char *tzid)
+{
+    icaltimezone *tz = NULL;
+
+    if (!tzid)
+        return NULL;
+
+    /* libical doesn't return the UTC singleton for Etc/UTC */
+    if (!strcmp(tzid, "Etc/UTC") || !strcmp(tzid, "UTC"))
+        return icaltimezone_get_utc_timezone();
+
+    tz = icaltimezone_get_builtin_timezone(tzid);
+
+    if (!tz) {
+        /* see if its a MS Windows TZID */
+        char *my_tzid = icu_getIDForWindowsID(tzid);
+
+        if (!my_tzid) return NULL;
+
+        tz = icaltimezone_get_builtin_timezone(my_tzid);
+
+        free(my_tzid);
+    }
+
+    return tz;
+}
+
+/* Determine the Olson TZID, if any, of the ical property prop. */
+static const char *tzid_from_icalprop(icalproperty *prop, int guess) {
+    const char *tzid = NULL;
+    icalparameter *param = NULL;
+
+    if (prop) param = icalproperty_get_first_parameter(prop, ICAL_TZID_PARAMETER);
+    if (param) tzid = icalparameter_get_tzid(param);
+    /* Check if the tzid already corresponds to an Olson name. */
+    if (tzid) {
+        icaltimezone *tz = tz_from_tzid(tzid);
+        if (!tz && guess) {
+            /* Try to guess the timezone. */
+            icalvalue *val = icalproperty_get_value(prop);
+            icaltimetype dt = icalvalue_get_datetime(val);
+            tzid = dt.zone ? icaltimezone_get_location((icaltimezone*) dt.zone) : NULL;
+            tzid = tzid && tz_from_tzid(tzid) ? tzid : NULL;
+        } else if (tz) return icaltimezone_get_location(tz);
+    } else {
+        icalvalue *val = icalproperty_get_value(prop);
+        icaltimetype dt = icalvalue_get_datetime(val);
+        if (icaltime_is_valid_time(dt) && icaltime_is_utc(dt)) {
+            tzid = "Etc/UTC";
+        }
+    }
+    return tzid;
+}
+
+/* Determine the Olson TZID, if any, of the first ical property of
+ * kind in component comp. */
+static const char *tzid_from_ical(icalcomponent *comp,
+                                  icalproperty_kind kind) {
+    icalproperty *prop = icalcomponent_get_first_property(comp, kind);
+    if (!prop) {
+        return NULL;
+    }
+    return tzid_from_icalprop(prop, 1/*guess*/);
+}
+
+static struct icaltimetype dtstart_from_ical(icalcomponent *comp)
+{
+    struct icaltimetype dt = icalcomponent_get_dtstart(comp);
+
+    const char *tzid = tzid_from_ical(comp, ICAL_DTSTART_PROPERTY);
+    /* Seen in the wild: a floating DTSTART and a DTEND with TZID */
+    if (!tzid) tzid = tzid_from_ical(comp, ICAL_DTEND_PROPERTY);
+    if (!tzid) return dt;
+
+    icaltimezone* tz = tz_from_tzid(tzid);
+    if (tz && dt.zone && tz != dt.zone) {
+        dt = icaltime_convert_to_zone(dt, tz);
+    }
+    else if (!dt.zone) dt.zone = tz;
+
+    return dt;
+}
+
+static struct icaltimetype dtend_from_ical(icalcomponent *comp)
+{
+    struct icaltimetype dtend;
+    icalproperty *prop;
+    struct icaltimetype dtstart = dtstart_from_ical(comp);
+
+    if ((prop = icalcomponent_get_first_property(comp, ICAL_DTEND_PROPERTY))) {
+        dtend = icalproperty_get_dtend(prop);
+        const char *tzid = tzid_from_icalprop(prop, 1);
+        icaltimezone* tz = tzid ? tz_from_tzid(tzid) : NULL;
+        if (tz && dtend.zone && tz != dtend.zone) {
+            dtend = icaltime_convert_to_zone(dtend, tz);
+        }
+        else if (!dtend.zone) dtend.zone = tz;
+    }
+    else dtend = icalcomponent_get_dtend(comp);
+
+    /* Normalize floating DTEND to DTSTART time zone, if any */
+    if (!dtend.zone) dtend.zone = dtstart.zone;
+
+    return dtend;
+}
+
+
+/* Compare int in ascending order. */
+static int compare_int(const void *aa, const void *bb)
+{
+    const int *a = aa, *b = bb;
+    return (*a < *b) ? -1 : (*a > *b);
+}
+
+/* Return the identity of i. This is a helper for recur_byX. */
+static int identity_int(int i) {
+    return i;
+}
+
+/*
+ * Conversion from iCalendar to JMAP
+ */
+
+static json_t* relatedto_from_ical(icalcomponent*);
+
+/* Convert at most nmemb entries in the ical recurrence byDay/Month/etc array
+ * named byX using conv. Return a new JSON array, sorted in ascending order. */
+static json_t* recurrence_byX_fromical(short byX[], size_t nmemb, int (*conv)(int)) {
+    json_t *jbd = json_pack("[]");
+
+    size_t i;
+    int tmp[nmemb];
+    for (i = 0; i < nmemb && byX[i] != ICAL_RECURRENCE_ARRAY_MAX; i++) {
+        tmp[i] = conv(byX[i]);
+    }
+
+    size_t n = i;
+    qsort(tmp, n, sizeof(int), compare_int);
+    for (i = 0; i < n; i++) {
+        json_array_append_new(jbd, json_pack("i", tmp[i]));
+    }
+
+    return jbd;
+}
+
+/* Convert the ical recurrence recur to a JMAP recurrenceRule */
+static json_t*
+recurrence_from_ical(icalcomponent *comp)
+{
+    char *s = NULL;
+    size_t i;
+    struct buf buf = BUF_INITIALIZER;
+    icalproperty *prop;
+    struct icalrecurrencetype rrule;
+
+    prop = icalcomponent_get_first_property(comp, ICAL_RRULE_PROPERTY);
+    if (!prop) {
+        return json_null();
+    }
+    rrule = icalproperty_get_rrule(prop);
+    if (rrule.freq == ICAL_NO_RECURRENCE) {
+        return json_null();
+    }
+
+    json_t *recur = json_pack("{s:s}", "@type", "RecurrenceRule");
+
+    /* frequency */
+    s = lcase(xstrdup(icalrecur_freq_to_string(rrule.freq)));
+    json_object_set_new(recur, "frequency", json_string(s));
+    free(s);
+
+    json_object_set_new(recur, "interval", json_pack("i", rrule.interval));
+
+#ifdef HAVE_RSCALE
+    /* rscale */
+    if (rrule.rscale) {
+        s = xstrdup(rrule.rscale);
+        s = lcase(s);
+        json_object_set_new(recur, "rscale", json_string(s));
+        free(s);
+    } else json_object_set_new(recur, "rscale", json_string("gregorian"));
+
+    /* skip */
+    const char *skip = NULL;
+    switch (rrule.skip) {
+        case ICAL_SKIP_BACKWARD:
+            skip = "backward";
+            break;
+        case ICAL_SKIP_FORWARD:
+            skip = "forward";
+            break;
+        case ICAL_SKIP_OMIT:
+            /* fall through */
+        default:
+            skip = "omit";
+    }
+    json_object_set_new(recur, "skip", json_string(skip));
+#endif
+
+    /* firstDayOfWeek */
+    s = xstrdup(icalrecur_weekday_to_string(rrule.week_start));
+    s = lcase(s);
+    json_object_set_new(recur, "firstDayOfWeek", json_string(s));
+    free(s);
+
+    /* byDay */
+    json_t *jbd = json_pack("[]");
+    for (i = 0; i < ICAL_BY_DAY_SIZE; i++) {
+        json_t *jday;
+        icalrecurrencetype_weekday weekday;
+        int pos;
+
+        if (rrule.by_day[i] == ICAL_RECURRENCE_ARRAY_MAX) {
+            break;
+        }
+
+        jday = json_pack("{}");
+        weekday = icalrecurrencetype_day_day_of_week(rrule.by_day[i]);
+
+        s = xstrdup(icalrecur_weekday_to_string(weekday));
+        s = lcase(s);
+        json_object_set_new(jday, "day", json_string(s));
+        free(s);
+
+        pos = icalrecurrencetype_day_position(rrule.by_day[i]);
+        if (pos) {
+            json_object_set_new(jday, "nthOfPeriod", json_integer(pos));
+        }
+
+        if (json_object_size(jday)) {
+            json_array_append_new(jbd, jday);
+        } else {
+            json_decref(jday);
+        }
+    }
+    if (json_array_size(jbd)) {
+        json_object_set_new(recur, "byDay", jbd);
+    } else {
+        json_decref(jbd);
+    }
+
+    /* byMonth */
+    json_t *jbm = json_pack("[]");
+    for (i = 0; i < ICAL_BY_MONTH_SIZE; i++) {
+        short bymonth;
+
+        if (rrule.by_month[i] == ICAL_RECURRENCE_ARRAY_MAX) {
+            break;
+        }
+
+        bymonth = rrule.by_month[i];
+        buf_printf(&buf, "%d", icalrecurrencetype_month_month(bymonth));
+        if (icalrecurrencetype_month_is_leap(bymonth)) {
+            buf_appendcstr(&buf, "L");
+        }
+        json_array_append_new(jbm, json_string(buf_cstring(&buf)));
+        buf_reset(&buf);
+
+    }
+    if (json_array_size(jbm)) {
+        json_object_set_new(recur, "byMonth", jbm);
+    } else {
+        json_decref(jbm);
+    }
+
+    if (rrule.by_month_day[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "byMonthDay",
+                recurrence_byX_fromical(rrule.by_month_day,
+                    ICAL_BY_MONTHDAY_SIZE, &identity_int));
+    }
+    if (rrule.by_year_day[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "byYearDay",
+                recurrence_byX_fromical(rrule.by_year_day,
+                    ICAL_BY_YEARDAY_SIZE, &identity_int));
+    }
+    if (rrule.by_week_no[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "byWeekNo",
+                recurrence_byX_fromical(rrule.by_week_no,
+                    ICAL_BY_WEEKNO_SIZE, &identity_int));
+    }
+    if (rrule.by_hour[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "byHour",
+                recurrence_byX_fromical(rrule.by_hour,
+                    ICAL_BY_HOUR_SIZE, &identity_int));
+    }
+    if (rrule.by_minute[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "byMinute",
+                recurrence_byX_fromical(rrule.by_minute,
+                    ICAL_BY_MINUTE_SIZE, &identity_int));
+    }
+    if (rrule.by_second[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "bySecond",
+                recurrence_byX_fromical(rrule.by_second,
+                    ICAL_BY_SECOND_SIZE, &identity_int));
+    }
+    if (rrule.by_set_pos[0] != ICAL_RECURRENCE_ARRAY_MAX) {
+        json_object_set_new(recur, "bySetPosition",
+                recurrence_byX_fromical(rrule.by_set_pos,
+                    ICAL_BY_SETPOS_SIZE, &identity_int));
+    }
+
+    if (rrule.count != 0) {
+        /* Recur count takes precedence over until. */
+        json_object_set_new(recur, "count", json_integer(rrule.count));
+    } else if (!icaltime_is_null_time(rrule.until)) {
+        /* Convert iCalendar UNTIL to start timezone */
+        const char *tzid = NULL;
+        icalproperty *dtstart_prop =
+            icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY);
+        if (dtstart_prop) {
+            icalparameter *tzid_param =
+                icalproperty_get_first_parameter(dtstart_prop, ICAL_TZID_PARAMETER);
+            if (tzid_param) tzid = icalparameter_get_tzid(tzid_param);
+        }
+        icaltimezone *tz = tz_from_tzid(tzid);
+        icaltimetype dtuntil;
+        if (rrule.until.is_date) {
+            dtuntil = rrule.until;
+            dtuntil.hour = 23;
+            dtuntil.minute = 59;
+            dtuntil.second = 59;
+            dtuntil.is_date = 0;
+        }
+        else {
+            dtuntil = icaltime_convert_to_zone(rrule.until, tz);
+        }
+        struct jmapical_datetime until = JMAPICAL_DATETIME_INITIALIZER;
+        jmapical_datetime_from_icaltime(dtuntil, &until);
+        struct buf buf = BUF_INITIALIZER;
+        jmapical_localdatetime_as_string(&until, &buf);
+        json_object_set_new(recur, "until", json_string(buf_cstring(&buf)));
+        buf_free(&buf);
+    }
+
+    if (!json_object_size(recur)) {
+        json_decref(recur);
+        recur = json_null();
+    }
+
+    buf_free(&buf);
+    return recur;
+}
+
+static json_t*
+override_rdate_from_ical(icalproperty *prop)
+{
+    /* returns a JSON object with a single key value pair */
+    json_t *override = json_pack("{}");
+    json_t *o = json_pack("{}");
+    struct icaldatetimeperiodtype rdate = icalproperty_get_rdate(prop);
+    struct buf buf = BUF_INITIALIZER;
+    struct jmapical_datetime rdatedt = JMAPICAL_DATETIME_INITIALIZER;
+
+    if (!icaltime_is_null_time(rdate.time)) {
+        jmapical_datetime_from_icaltime(rdate.time, &rdatedt);
+    } else {
+        /* PERIOD */
+        jmapical_datetime_from_icaltime(rdate.period.start, &rdatedt);
+
+        /* Determine duration */
+        struct icaldurationtype icaldur;
+        if (!icaltime_is_null_time(rdate.period.end)) {
+            icaldur = icaltime_subtract(rdate.period.end, rdate.period.start);
+        } else {
+            icaldur = rdate.period.duration;
+        }
+        struct jmapical_duration dur = JMAPICAL_DURATION_INITIALIZER;
+        jmapical_duration_from_icalduration(icaldur, &dur);
+        jmapical_duration_as_string(&dur, &buf);
+        json_object_set_new(o, "duration", json_string(buf_cstring(&buf)));
+        buf_reset(&buf);
+    }
+
+    if (!icaltime_is_null_time(rdate.time) ||
+        !icaltime_is_null_time(rdate.period.start)) {
+        subseconds_from_icalprop(prop, &rdatedt.nano);
+        jmapical_localdatetime_as_string(&rdatedt, &buf);
+        json_object_set_new(override, buf_cstring(&buf), o);
+        buf_reset(&buf);
+    }
+
+    if (!json_object_size(override)) {
+        json_decref(override);
+        json_decref(o);
+        override = NULL;
+    }
+
+    buf_free(&buf);
+    return override;
+}
+
+static json_t*
+override_exdate_from_ical(icalproperty *prop, const char *tzid_start)
+{
+    json_t *override = json_pack("{}");
+    icaltimetype exdate = icalproperty_get_exdate(prop);
+
+    const char *tzid_xdate = tzid_from_icalprop(prop, 1);
+    if (tzid_start && tzid_xdate && strcmp(tzid_start, tzid_xdate)) {
+        icaltimezone *tz_xdate = tz_from_tzid(tzid_xdate);
+        icaltimezone *tz_start = tz_from_tzid(tzid_start);
+        if (tz_xdate && tz_start) {
+            if (exdate.zone) exdate.zone = tz_xdate;
+            exdate = icaltime_convert_to_zone(exdate, tz_start);
+        }
+    }
+
+    if (!icaltime_is_null_time(exdate)) {
+        struct jmapical_datetime exdatedt = JMAPICAL_DATETIME_INITIALIZER;
+        jmapical_datetime_from_icaltime(exdate, &exdatedt);
+        subseconds_from_icalprop(prop, &exdatedt.nano);
+        struct buf buf = BUF_INITIALIZER;
+        jmapical_localdatetime_as_string(&exdatedt, &buf);
+        json_object_set_new(override, buf_cstring(&buf), json_pack("{s:b}", "excluded", 1));
+        buf_free(&buf);
+    }
+
+    if (!json_object_size(override)) {
+        json_decref(override);
+        override = NULL;
+    }
+
+    return override;
+}
+
+static json_t*
+overrides_from_ical(icalcomponent *comp, json_t *event, const char *tzid_start)
+{
+    icalproperty *prop;
+    json_t *overrides = json_pack("{}");
+    const char *uid = icalcomponent_get_uid(comp);
+
+    /* RDATE */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_RDATE_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_RDATE_PROPERTY)) {
+
+        json_t *override = override_rdate_from_ical(prop);
+        if (override) {
+            json_object_update(overrides, override);
+            json_decref(override);
+        }
+    }
+
+    /* EXDATE */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_EXDATE_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_EXDATE_PROPERTY)) {
+
+        json_t *override = override_exdate_from_ical(prop, tzid_start);
+        if (override) {
+            json_object_update(overrides, override);
+            json_decref(override);
+        }
+    }
+
+    /* VEVENT exceptions */
+    json_t *exceptions = json_pack("{}");
+    icalcomponent *excomp, *ical;
+
+    ical = icalcomponent_get_parent(comp);
+    for (excomp = icalcomponent_get_first_component(ical, ICAL_VEVENT_COMPONENT);
+         excomp;
+         excomp = icalcomponent_get_next_component(ical, ICAL_VEVENT_COMPONENT)) {
+
+        if (excomp == comp) continue; /* skip toplevel promoted object */
+
+        /* Skip unrelated VEVENTs */
+        const char *exuid = icalcomponent_get_uid(excomp);
+        if (strcmpsafe(exuid, uid)) continue;
+
+        /* Convert VEVENT exception to JMAP */
+        json_t *ex = calendarevent_from_ical(excomp, NULL, comp);
+        if (!ex) continue;
+
+        /* Recurrence-id */
+        /* Convert the recurrence-id into the timezone of the main event.
+         * Some clients generate the recurrence id as UTC date time,
+         * even if the main VEVENT has a DTSTART with a TZID */
+        icaltimetype icalrecurid = icalcomponent_get_recurrenceid(excomp);
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY))) {
+            icalrecurid.is_date = icalproperty_get_dtstart(prop).is_date;
+            if (!icalrecurid.is_date) {
+                icalparameter *tzid_param =
+                    icalproperty_get_first_parameter(prop, ICAL_TZID_PARAMETER);
+                if (tzid_param) {
+                    const char *start_tzid = icalparameter_get_tzid(tzid_param);
+                    if (start_tzid) {
+                        icaltimezone *start_tz = tz_from_tzid(start_tzid);
+                        if (start_tz) {
+                            icalrecurid = icaltime_convert_to_zone(icalrecurid, start_tz);
+                        }
+                    }
+                }
+            }
+        }
+
+        /* Format recurrence id */
+        struct jmapical_datetime exrecurdt = JMAPICAL_DATETIME_INITIALIZER;
+        jmapical_datetime_from_icaltime(icalrecurid, &exrecurdt);
+        // Set subseconds
+        prop = icalcomponent_get_first_property(excomp, ICAL_RECURRENCEID_PROPERTY);
+        if (prop) subseconds_from_icalprop(prop, &exrecurdt.nano);
+        if (!exrecurdt.nano) {
+            prop = icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY);
+            if (prop) subseconds_from_icalprop(prop, &exrecurdt.nano);
+        }
+        struct buf buf = BUF_INITIALIZER;
+        jmapical_localdatetime_as_string(&exrecurdt, &buf);
+        char *recurid = buf_release(&buf);
+
+        /* start */
+        const char *exstart = json_string_value(json_object_get(ex, "start"));
+        if (exstart && !strcmp(exstart, recurid)) {
+            json_object_del(ex, "start");
+        }
+
+        /* Create override patch */
+        json_t *diff = jmap_patchobject_create(event, ex);
+        json_object_del(diff, "@type");
+        json_object_del(diff, "uid");
+        json_object_del(diff, "relatedTo");
+        json_object_del(diff, "prodId");
+        json_object_del(diff, "method");
+        json_object_del(diff, "recurrenceId");
+        json_object_del(diff, "recurrenceRule");
+        json_object_del(diff, "recurrenceOverrides");
+        json_object_del(diff, "replyTo");
+        if (json_is_null(json_object_get(diff, "start"))) {
+            json_object_del(diff, "start");
+        }
+        if (json_is_null(json_object_get(diff, "showWithoutTime"))) {
+            json_object_del(diff, "showWithoutTime");
+        }
+
+        /* Set override at recurrence id */
+        json_object_set_new(exceptions, recurid, diff);
+        json_decref(ex);
+        free(recurid);
+    }
+
+    json_object_update(overrides, exceptions);
+    json_decref(exceptions);
+
+    if (!json_object_size(overrides)) {
+        json_decref(overrides);
+        overrides = json_null();
+    }
+
+    return overrides;
+}
+
+static int match_uri(const char *uri1, const char *uri2)
+{
+    const char *col1 = strchr(uri1, ':');
+    const char *col2 = strchr(uri2, ':');
+
+    if (col1 == NULL && col2 == NULL) {
+        return !strcmp(uri1, uri2);
+    }
+    else if (col1 && col2 && (col1-uri1) == (col2-uri2)) {
+        size_t schemelen = col1-uri1;
+        return !strncasecmp(uri1, uri2, schemelen) &&
+               !strcmp(uri1+schemelen, uri2+schemelen);
+    }
+    else return 0;
+}
+
+static json_t*
+rsvpto_from_ical(icalproperty *prop)
+{
+    json_t *rsvpTo = json_object();
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Read RVSP methods defined in RSVP-URI x-parameters. A RSVP-URI
+     * x-parameter value is of the form method:uri. If no method is defined,
+     * it's interpreted as the "web" method for legacy reasons. */
+    icalparameter *param, *next;
+    for (param = icalproperty_get_first_parameter(prop, ICAL_X_PARAMETER);
+            param;
+            param = next) {
+
+        next = icalproperty_get_next_parameter(prop, ICAL_X_PARAMETER);
+        if (strcasecmp(icalparameter_get_xname(param), JMAPICAL_XPARAM_RSVP_URI)) {
+            continue;
+        }
+
+        const char *val = icalparameter_get_xvalue(param);
+        const char *col1 = strchr(val, ':');
+        const char *col2 = col1 ? strchr(col1 + 1, ':') : NULL;
+        if (!col2) {
+            json_object_set_new(rsvpTo, "web", json_string(val));
+        } else {
+            buf_setmap(&buf, val, col1 - val);
+            json_object_set_new(rsvpTo, buf_cstring(&buf), json_string(col1 + 1));
+        }
+    }
+
+    /* Read URI from property value and check if this URI already is defined.
+     * If it isn't, this could be because an iCalendar client updated the
+     * property value, but kept the RSVP x-params. */
+    const char *caladdress = icalproperty_get_value_as_string(prop);
+    int caladdress_is_defined = 0;
+    json_t *jval;
+    const char *key;
+    json_object_foreach(rsvpTo, key, jval) {
+        if (match_uri(caladdress, json_string_value(jval))) {
+            caladdress_is_defined = 1;
+            break;
+        }
+    }
+    if (!caladdress_is_defined) {
+        if (!strncasecmp(caladdress, "mailto:", 7))
+            json_object_set_new(rsvpTo, "imip", json_string(caladdress));
+        else
+            json_object_set_new(rsvpTo, "other", json_string(caladdress));
+    }
+
+    if (!json_object_size(rsvpTo)) {
+        json_decref(rsvpTo);
+        rsvpTo = json_null();
+    }
+
+    buf_free(&buf);
+    return rsvpTo;
+}
+
+static json_t *participant_from_ical(icalproperty *prop,
+                                     hash_table *id_by_uri,
+                                     icalproperty *orga)
+{
+    json_t *p = json_pack("{s:s}", "@type", "Participant");
+    icalparameter *param;
+    struct buf buf = BUF_INITIALIZER;
+
+    /* FIXME invitedBy */
+
+    /* sendTo */
+    json_t *sendTo = rsvpto_from_ical(prop);
+    json_object_set_new(p, "sendTo", sendTo ? sendTo : json_null());
+
+    /* email */
+    char *email = NULL;
+    param = icalproperty_get_first_parameter(prop, ICAL_EMAIL_PARAMETER);
+    if (param) {
+        email = xstrdupnull(icalparameter_get_value_as_string(param));
+    }
+    else if (json_object_get(sendTo, "imip")) {
+        const char *uri = json_string_value(json_object_get(sendTo, "imip"));
+        email = mailaddr_from_uri(uri);
+    }
+    json_object_set_new(p, "email", email ? json_string(email) : json_null());
+    free(email);
+
+    /* name */
+    const char *name = NULL;
+    param = icalproperty_get_first_parameter(prop, ICAL_CN_PARAMETER);
+    if (param) {
+        name = icalparameter_get_cn(param);
+    }
+    json_object_set_new(p, "name", json_string(name ? name : ""));
+
+    /* kind */
+    const char *kind = NULL;
+    param = icalproperty_get_first_parameter(prop, ICAL_CUTYPE_PARAMETER);
+    if (param) {
+        icalparameter_cutype cutype = icalparameter_get_cutype(param);
+        switch (cutype) {
+            case ICAL_CUTYPE_INDIVIDUAL:
+                kind = "individual";
+                break;
+            case ICAL_CUTYPE_GROUP:
+                kind = "group";
+                break;
+            case ICAL_CUTYPE_RESOURCE:
+                kind = "resource";
+                break;
+            case ICAL_CUTYPE_ROOM:
+                kind = "location";
+                break;
+            default:
+                kind = "unknown";
+        }
+    }
+    if (kind) {
+        json_object_set_new(p, "kind", json_string(kind));
+    }
+
+    /* roles */
+    json_t *roles = json_object();
+    icalparameter_role ical_role = ICAL_ROLE_REQPARTICIPANT;
+    param = icalproperty_get_first_parameter(prop, ICAL_ROLE_PARAMETER);
+    if (param) {
+        ical_role = icalparameter_get_role(param);
+        switch (ical_role) {
+            case ICAL_ROLE_OPTPARTICIPANT:
+                json_object_set_new(roles, "optional", json_true());
+                break;
+            case ICAL_ROLE_NONPARTICIPANT:
+                json_object_set_new(roles, "informational", json_true());
+                break;
+            case ICAL_ROLE_CHAIR:
+                json_object_set_new(roles, "chair", json_true());
+                json_object_set_new(roles, "attendee", json_true());
+                break;
+            default:
+                json_object_set_new(roles, "attendee", json_true());
+                break;  // nothing to add
+        }
+    }
+    for (param = icalproperty_get_first_parameter(prop, ICAL_X_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_X_PARAMETER)) {
+
+        if (strcmp(icalparameter_get_xname(param), JMAPICAL_XPARAM_ROLE))
+            continue;
+
+        buf_setcstr(&buf, icalparameter_get_xvalue(param));
+        json_object_set_new(roles, buf_lcase(&buf), json_true());
+    }
+    if (!json_object_get(roles, "owner")) {
+        const char *o = icalproperty_get_organizer(orga);
+        const char *a = icalproperty_get_attendee(prop);
+        if (!strcasecmpsafe(o, a)) {
+            json_object_set_new(roles, "owner", json_true());
+            json_object_set_new(roles, "attendee", json_true());
+        }
+    }
+    if (!json_object_size(roles)) {
+        json_object_set_new(roles, "attendee", json_true());
+    }
+    json_object_set_new(p, "roles", roles);
+
+    /* locationId */
+    const char *locid;
+    if ((locid = get_icalxparam_value(prop, JMAPICAL_XPARAM_LOCATIONID))) {
+        json_object_set_new(p, "locationId", json_string(locid));
+    }
+
+    /* participationStatus */
+    const char *partstat = NULL;
+    icalproperty *partstat_prop = prop;
+    while (!partstat) {
+        param = icalproperty_get_first_parameter(partstat_prop, ICAL_PARTSTAT_PARAMETER);
+        if (!param) break;
+        icalparameter_partstat pst = icalparameter_get_partstat(param);
+        switch (pst) {
+            case ICAL_PARTSTAT_ACCEPTED:
+                partstat = "accepted";
+                break;
+            case ICAL_PARTSTAT_DECLINED:
+                partstat = "declined";
+                break;
+            case ICAL_PARTSTAT_TENTATIVE:
+                partstat = "tentative";
+                break;
+            case ICAL_PARTSTAT_NEEDSACTION:
+                partstat = "needs-action";
+                break;
+            case ICAL_PARTSTAT_DELEGATED:
+                partstat = "delegated";
+                break;
+            default:
+                partstat = "none";
+        }
+    }
+    if (!partstat || !strcmp(partstat,  "none"))
+        partstat = "needs-action";
+    json_object_set_new(p, "participationStatus", json_string(partstat));
+
+    /* expectReply */
+    int expect_reply = 0;
+    param = icalproperty_get_first_parameter(prop, ICAL_RSVP_PARAMETER);
+    if (param) {
+        icalparameter_rsvp val = icalparameter_get_rsvp(param);
+        expect_reply = val == ICAL_RSVP_TRUE;
+    }
+    json_object_set_new(p, "expectReply", json_boolean(expect_reply));
+
+    /* delegatedTo */
+    json_t *delegatedTo = json_object();
+    for (param = icalproperty_get_first_parameter(prop, ICAL_DELEGATEDTO_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_DELEGATEDTO_PARAMETER)) {
+
+        char *uri = normalized_uri(icalparameter_get_delegatedto(param));
+        const char *to_id = hash_lookup(uri, id_by_uri);
+        free(uri);
+        if (to_id) json_object_set_new(delegatedTo, to_id, json_true());
+    }
+    if (json_object_size(delegatedTo)) {
+        json_object_set_new(p, "delegatedTo", delegatedTo);
+    }
+    else {
+        json_decref(delegatedTo);
+    }
+
+    /* delegatedFrom */
+    json_t *delegatedFrom = json_object();
+    for (param = icalproperty_get_first_parameter(prop, ICAL_DELEGATEDFROM_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_DELEGATEDFROM_PARAMETER)) {
+
+        char *uri = normalized_uri(icalparameter_get_delegatedfrom(param));
+        const char *from_id = hash_lookup(uri, id_by_uri);
+        free(uri);
+        if (from_id) json_object_set_new(delegatedFrom, from_id, json_true());
+    }
+    if (json_object_size(delegatedFrom)) {
+        json_object_set_new(p, "delegatedFrom", delegatedFrom);
+    }
+    else {
+        json_decref(delegatedFrom);
+    }
+
+    /* memberof */
+    json_t *memberOf = json_object();
+    for (param = icalproperty_get_first_parameter(prop, ICAL_MEMBER_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_MEMBER_PARAMETER)) {
+
+        char *uri = normalized_uri(icalparameter_get_member(param));
+        char *id = xstrdupnull(hash_lookup(uri, id_by_uri));
+        if (!id) id = sha1key(uri);
+        json_object_set_new(memberOf, id, json_true());
+        free(id);
+        free(uri);
+    }
+    if (json_object_size(memberOf)) {
+        json_object_set_new(p, "memberOf", memberOf);
+    } else {
+        json_decref(memberOf);
+    }
+
+    /* linkIds */
+    json_t *linkIds = json_object();
+    for (param = icalproperty_get_first_parameter(prop, ICAL_X_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_X_PARAMETER)) {
+
+        if (strcmp(icalparameter_get_xname(param), JMAPICAL_XPARAM_LINKID))
+            continue;
+
+        buf_setcstr(&buf, icalparameter_get_xvalue(param));
+        json_object_set_new(linkIds, buf_lcase(&buf), json_true());
+    }
+    if (json_object_size(linkIds)) {
+        json_object_set_new(p, "linkIds", linkIds);
+    }
+    else {
+        json_decref(linkIds);
+    } 
+
+    /* scheduleSequence */
+    long schedule_sequence = 0;
+    const char *xval = get_icalxparam_value(prop, JMAPICAL_XPARAM_SEQUENCE);
+    if (xval) {
+        bit64 res;
+        if (parsenum(xval, &xval, strlen(xval), &res) == 0) {
+            schedule_sequence = res;
+        }
+    }
+    json_object_set_new(p, "scheduleSequence", json_integer(schedule_sequence));
+
+    /* scheduleUpdated */
+    if ((xval = get_icalxparam_value(prop, JMAPICAL_XPARAM_DTSTAMP))) {
+        icaltimetype icaltstamp = icaltime_from_string(xval);
+        if (!icaltime_is_null_time(icaltstamp) && !icaltstamp.is_date &&
+                icaltstamp.zone == icaltimezone_get_utc_timezone()) {
+            struct jmapical_datetime tstamp = JMAPICAL_DATETIME_INITIALIZER;
+            jmapical_datetime_from_icaltime(icaltstamp, &tstamp); // XXX subseconds
+            jmapical_utcdatetime_as_string(&tstamp, &buf);
+            json_object_set_new(p, "scheduleUpdated", json_string(buf_cstring(&buf)));
+            buf_reset(&buf);
+        }
+    }
+
+    /* participationComment */
+    const char *comment = get_icalxparam_value(prop, JMAPICAL_XPARAM_COMMENT);
+    if (comment) {
+        json_object_set_new(p, "participationComment", json_string(comment));
+    }
+
+    buf_free(&buf);
+    return p;
+}
+
+static json_t*
+participant_from_icalorganizer(icalproperty *orga)
+{
+    json_t *jorga = json_pack("{s:s}", "@type", "Participant");
+
+    /* name */
+    icalparameter *param;
+    const char *name = NULL;
+    if ((param = icalproperty_get_first_parameter(orga, ICAL_CN_PARAMETER))) {
+        name = icalparameter_get_cn(param);
+    }
+    json_object_set_new(jorga, "name", json_string(name ? name : ""));
+
+    /* roles */
+    json_object_set_new(jorga, "roles", json_pack("{s:b}", "owner", 1));
+
+    /* sendTo */
+    /* email */
+    const char *caladdress = icalproperty_get_value_as_string(orga);
+    if (!strncasecmp(caladdress, "mailto:", 7)) {
+        json_object_set_new(jorga, "sendTo", json_pack("{s:s}", "imip", caladdress));
+        char *email = mailaddr_from_uri(caladdress);
+        json_object_set_new(jorga, "email", json_string(email));
+        free(email);
+    }
+    else {
+        json_object_set_new(jorga, "sendTo", json_pack("{s:s}", "other", caladdress));
+        json_object_set_new(jorga, "email", json_null());
+    }
+
+    /* Set default values */
+    json_object_set_new(jorga, "participationStatus", json_string("needs-action"));
+    json_object_set_new(jorga, "scheduleSequence", json_integer(0));
+    json_object_set_new(jorga, "expectReply", json_false());
+
+    return jorga;
+}
+
+/* Convert the ical ORGANIZER/ATTENDEEs in comp to CalendarEvent participants */
+static json_t*
+participants_from_ical(icalcomponent *comp)
+{
+    struct hash_table attendee_by_uri = HASH_TABLE_INITIALIZER;
+    struct hash_table id_by_uri = HASH_TABLE_INITIALIZER;
+    icalproperty *prop;
+    json_t *participants = json_object();
+
+    /* Collect all attendees in a map to lookup delegates and their ids. */
+    construct_hash_table(&attendee_by_uri, 32, 0);
+    construct_hash_table(&id_by_uri, 32, 0);
+    for (prop = icalcomponent_get_first_property(comp, ICAL_ATTENDEE_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_ATTENDEE_PROPERTY)) {
+
+        /* Map normalized URI to ATTENDEE */
+        char *uri = normalized_uri(icalproperty_get_value_as_string(prop));
+        hash_insert(uri, prop, &attendee_by_uri);
+
+        /* Map mailto:URI to ID */
+        char *id = xstrdupnull(get_icalxparam_value(prop, JMAPICAL_XPARAM_ID));
+        if (!id) id = sha1key(uri);
+        hash_insert(uri, id, &id_by_uri);
+        free(uri);
+    }
+
+
+    /* Map ATTENDEE to JSCalendar */
+    icalproperty *orga = icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
+    for (prop = icalcomponent_get_first_property(comp, ICAL_ATTENDEE_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_ATTENDEE_PROPERTY)) {
+
+        char *uri = normalized_uri(icalproperty_get_value_as_string(prop));
+        const char *id = hash_lookup(uri, &id_by_uri);
+        json_t *p = participant_from_ical(prop, &id_by_uri, orga);
+        json_object_set_new(participants, id, p);
+        free(uri);
+    }
+
+    if (orga) {
+        const char *caladdress = icalproperty_get_value_as_string(orga);
+        char *uri = normalized_uri(caladdress);
+        if (!hash_lookup(uri, &attendee_by_uri)) {
+            /* Add a default participant for the organizer. */
+            char *id = xstrdupnull(get_icalxparam_value(orga, JMAPICAL_XPARAM_ID));
+            if (!id) id = sha1key(uri);
+            json_t *jorga = participant_from_icalorganizer(orga);
+            json_object_set_new(participants, id, jorga);
+            free(id);
+        }
+        free(uri);
+    }
+
+    if (!json_object_size(participants)) {
+        json_decref(participants);
+        participants = json_null();
+    }
+    free_hash_table(&attendee_by_uri, NULL);
+    free_hash_table(&id_by_uri, free);
+    return participants;
+}
+
+static json_t*
+link_from_ical(icalproperty *prop)
+{
+    /* href */
+    const char *href = NULL;
+    if (icalproperty_isa(prop) == ICAL_ATTACH_PROPERTY) {
+        icalattach *attach = icalproperty_get_attach(prop);
+        /* Ignore ATTACH properties with value BINARY. */
+        if (!attach || !icalattach_get_is_url(attach)) {
+            return NULL;
+        }
+        href = icalattach_get_url(attach);
+    }
+    else if (icalproperty_isa(prop) == ICAL_URL_PROPERTY) {
+        href = icalproperty_get_value_as_string(prop);
+    }
+    if (!href || *href == '\0') return NULL;
+
+    json_t *link = json_pack("{s:s: s:s}", "@type", "Link", "href", href);
+    icalparameter *param = NULL;
+    const char *s;
+
+    /* cid */
+    if ((s = get_icalxparam_value(prop, JMAPICAL_XPARAM_CID))) {
+        json_object_set_new(link, "cid", json_string(s));
+    }
+
+    /* contentType */
+    param = icalproperty_get_first_parameter(prop, ICAL_FMTTYPE_PARAMETER);
+    if (param && ((s = icalparameter_get_fmttype(param)))) {
+        json_object_set_new(link, "contentType", json_string(s));
+    }
+
+    /* title - reuse the same x-param as Apple does for their locations  */
+    if ((s = get_icalxparam_value(prop, JMAPICAL_XPARAM_TITLE))) {
+        json_object_set_new(link, "title", json_string(s));
+    }
+
+    /* size */
+    json_int_t size = -1;
+    param = icalproperty_get_size_parameter(prop);
+    if (param) {
+        if ((s = icalparameter_get_size(param))) {
+            char *ptr;
+            size = strtol(s, &ptr, 10);
+            json_object_set_new(link, "size",
+                    ptr && *ptr == '\0' ? json_integer(size) : json_null());
+        }
+    }
+
+    /* rel */
+    const char *rel = get_icalxparam_value(prop, JMAPICAL_XPARAM_REL);
+    if (!rel && icalproperty_isa(prop) == ICAL_URL_PROPERTY) {
+        rel = "describedby";
+    }
+    json_object_set_new(link, "rel", json_string(rel));
+
+    /* display */
+    if ((s = get_icalxparam_value(prop, JMAPICAL_XPARAM_DISPLAY))) {
+        json_object_set_new(link, "display", json_string(s));
+    }
+
+
+    return link;
+}
+
+static json_t*
+links_from_ical(icalcomponent *comp)
+{
+    icalproperty* prop;
+    json_t *ret = json_pack("{}");
+
+    /* Read iCalendar ATTACH properties */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_ATTACH_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_ATTACH_PROPERTY)) {
+
+        char *id = xstrdupnull(get_icalxparam_value(prop, JMAPICAL_XPARAM_ID));
+        if (!id) id = sha1key(icalproperty_get_value_as_string(prop));
+        json_t *link = link_from_ical(prop);
+        if (link) json_object_set_new(ret, id, link);
+        free(id);
+    }
+
+    /* Read iCalendar URL property. Should only be one. */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_URL_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_URL_PROPERTY)) {
+
+        char *id = xstrdupnull(get_icalxparam_value(prop, JMAPICAL_XPARAM_ID));
+        if (!id) id = sha1key(icalproperty_get_value_as_string(prop));
+        json_t *link = link_from_ical(prop);
+        if (link) json_object_set_new(ret, id, link);
+        free(id);
+    }
+
+    if (!json_object_size(ret)) {
+        json_decref(ret);
+        ret = json_null();
+    }
+
+    return ret;
+}
+
+/* Convert the VALARMS in the VEVENT comp to CalendarEvent alerts.
+ * Adds any ATTACH properties found in VALARM components to the
+ * event 'links' property. */
+static json_t*
+alerts_from_ical(icalcomponent *comp)
+{
+    json_t* alerts = json_pack("{}");
+    icalcomponent* alarm;
+    struct buf buf = BUF_INITIALIZER;
+
+    for (alarm = icalcomponent_get_first_component(comp, ICAL_VALARM_COMPONENT);
+         alarm;
+         alarm = icalcomponent_get_next_component(comp, ICAL_VALARM_COMPONENT)) {
+
+        icalproperty* prop;
+        json_t *alert = json_pack("{s:s}", "@type", "Alert");
+
+        /* alert id */
+        char *id = (char *) icalcomponent_get_uid(alarm);
+        if (!id) {
+            id = sha1key(icalcomponent_as_ical_string(alarm));
+        } else {
+            id = xstrdup(id);
+        }
+
+        /* Determine TRIGGER and RELATED parameter */
+        struct icaltriggertype trigger = {
+            icaltime_null_time(), icaldurationtype_null_duration()
+        };
+        icalparameter_related related = ICAL_RELATED_START;
+        icalproperty *triggerprop = icalcomponent_get_first_property(alarm, ICAL_TRIGGER_PROPERTY);
+        if (triggerprop) {
+            trigger = icalproperty_get_trigger(triggerprop);
+            icalparameter *param = icalproperty_get_first_parameter(triggerprop, ICAL_RELATED_PARAMETER);
+            if (param) {
+                related = icalparameter_get_related(param);
+                if (related != ICAL_RELATED_START && related != ICAL_RELATED_END) {
+                    free(id);
+                    continue;
+                }
+            }
+        }
+
+        /* trigger */
+        json_t *jtrigger = json_object();
+        if (!icaldurationtype_is_null_duration(trigger.duration) ||
+             icaltime_is_null_time(trigger.time)) {
+
+            /* Convert to offset trigger */
+            json_object_set_new(jtrigger, "@type", json_string("OffsetTrigger"));
+            struct jmapical_duration duration = JMAPICAL_DURATION_INITIALIZER;
+            jmapical_duration_from_icalduration(trigger.duration, &duration);
+            subseconds_from_icalprop(triggerprop, &duration.nanos);
+
+            /* relativeTo */
+            const char *relative_to = related == ICAL_RELATED_START ?  "start" : "end";
+            json_object_set_new(jtrigger, "relativeTo", json_string(relative_to));
+
+            /* offset*/
+            jmapical_duration_as_string(&duration, &buf);
+            json_object_set_new(jtrigger, "offset", json_string(buf_cstring(&buf)));
+            buf_reset(&buf);
+        } else {
+            /* Convert to absolute trigger */
+            json_object_set_new(jtrigger, "@type", json_string("AbsoluteTrigger"));
+
+            struct jmapical_datetime when = JMAPICAL_DATETIME_INITIALIZER;
+            jmapical_datetime_from_icalprop(triggerprop, &when);
+            jmapical_utcdatetime_as_string(&when, &buf);
+
+            /* when */
+            json_object_set_new(jtrigger, "when", json_string(buf_cstring(&buf)));
+        }
+        json_object_set_new(alert, "trigger", jtrigger);
+
+        /*  action */
+        const char *action = "display";
+        prop = icalcomponent_get_first_property(alarm, ICAL_ACTION_PROPERTY);
+        if (prop && icalproperty_get_action(prop) == ICAL_ACTION_EMAIL) {
+            action = "email";
+        }
+        json_object_set_new(alert, "action", json_string(action));
+
+        /* acknowledged */
+        if ((prop = icalcomponent_get_acknowledged_property(alarm))) {
+			struct jmapical_datetime tstamp = JMAPICAL_DATETIME_INITIALIZER;
+			jmapical_datetime_from_icalprop(prop, &tstamp);
+			jmapical_utcdatetime_as_string(&tstamp, &buf);
+			json_t *jval = json_string(buf_cstring(&buf));
+			buf_reset(&buf);
+			json_object_set_new(alert, "acknowledged", jval);
+        }
+
+        /* relatedTo */
+        json_t *jrelatedto = relatedto_from_ical(alarm);
+        if (JNOTNULL(jrelatedto)) {
+            json_object_set_new(alert, "relatedTo", jrelatedto);
+        }
+
+        json_object_set_new(alerts, id, alert);
+        free(id);
+    }
+
+    if (!json_object_size(alerts)) {
+        json_decref(alerts);
+        alerts = json_null();
+    }
+
+    buf_free(&buf);
+    return alerts;
+}
+
+
+
+/* Convert a VEVENT ical component to CalendarEvent keywords */
+static json_t*
+keywords_from_ical(icalcomponent *comp)
+{
+    icalproperty* prop;
+    json_t *ret = json_object();
+
+    for (prop = icalcomponent_get_first_property(comp, ICAL_CATEGORIES_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_CATEGORIES_PROPERTY)) {
+        json_object_set_new(ret, icalproperty_get_categories(prop), json_true());
+    }
+    if (!json_object_size(ret)) {
+        json_decref(ret);
+        ret = json_null();
+    }
+
+    return ret;
+}
+
+/* Convert a VEVENT ical component to CalendarEvent relatedTo */
+static json_t*
+relatedto_from_ical(icalcomponent *comp)
+{
+    icalproperty* prop;
+    json_t *ret = json_pack("{}");
+
+    for (prop = icalcomponent_get_first_property(comp, ICAL_RELATEDTO_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_RELATEDTO_PROPERTY)) {
+
+        const char *uid = icalproperty_get_value_as_string(prop);
+        if (!uid || !strlen(uid)) continue;
+
+        icalparameter *param = NULL;
+        json_t *relation = json_object();
+        for (param = icalproperty_get_first_parameter(prop, ICAL_RELTYPE_PARAMETER);
+             param;
+             param = icalproperty_get_next_parameter(prop, ICAL_RELTYPE_PARAMETER)) {
+
+            const char *reltype = icalparameter_get_xvalue(param);
+            if (reltype && *reltype) {
+                char *s = lcase(xstrdup(reltype));
+                json_object_set_new(relation, s, json_true());
+                free(s);
+            }
+            else json_object_set_new(relation, "parent", json_true());
+        }
+
+        json_object_set_new(ret, uid, json_pack("{s:s s:o}",
+                    "@type", "Relation", "relation", relation));
+
+    }
+
+    if (!json_object_size(ret)) {
+        json_decref(ret);
+        ret = json_null();
+    }
+
+    return ret;
+}
+
+static json_t* location_from_ical(icalproperty *prop, json_t *links)
+{
+    icalparameter *param;
+    json_t *loc = json_pack("{s:s}", "@type", "Location");
+
+    /* name */
+    const char *name = icalvalue_get_text(icalproperty_get_value(prop));
+    json_object_set_new(loc, "name", json_string(name ? name : ""));
+
+    /* rel */
+    const char *rel = get_icalxparam_value(prop, JMAPICAL_XPARAM_REL);
+    if (rel) json_object_set_new(loc, "relativeTo", json_string(rel));
+
+    /* description */
+    const char *desc = get_icalxparam_value(prop, JMAPICAL_XPARAM_DESCRIPTION);
+    if (desc) json_object_set_new(loc, "description", json_string(desc));
+
+    /* timeZone */
+    const char *tzid = get_icalxparam_value(prop, JMAPICAL_XPARAM_TZID);
+    if (tzid) json_object_set_new(loc, "timeZone", json_string(tzid));
+
+    /* coordinates */
+    const char *coord = get_icalxparam_value(prop, JMAPICAL_XPARAM_GEO);
+    if (coord) json_object_set_new(loc, "coordinates", json_string(coord));
+
+    /* linkIds (including altrep) */
+    json_t *linkids = json_object();
+    for (param = icalproperty_get_first_parameter(prop, ICAL_X_PARAMETER);
+         param;
+         param = icalproperty_get_next_parameter(prop, ICAL_X_PARAMETER)) {
+
+        if (strcasecmp(icalparameter_get_xname(param), JMAPICAL_XPARAM_LINKID)) {
+            continue;
+        }
+        const char *s = icalparameter_get_xvalue(param);
+        if (!s) continue;
+        json_object_set_new(linkids, s, json_true());
+    }
+    const char *altrep = NULL;
+    param = icalproperty_get_first_parameter(prop, ICAL_ALTREP_PARAMETER);
+    if (param) altrep = icalparameter_get_altrep(param);
+    if (altrep) {
+        char *tmp = sha1key(altrep);
+        json_object_set_new(links, tmp, json_pack("{s:s}", "href", altrep));
+        json_object_set_new(linkids, tmp, json_true());
+        free(tmp);
+    }
+    if (!json_object_size(linkids)) {
+        json_decref(linkids);
+        linkids = NULL;
+    }
+    else json_object_set_new(loc, "linkIds", linkids);
+
+    return loc;
+}
+
+static json_t *coordinates_from_ical(icalproperty *prop)
+{
+    /* Use verbatim coordinate string, rather than the parsed ical value */
+    const char *p, *val = icalproperty_get_value_as_string(prop);
+    struct buf buf = BUF_INITIALIZER;
+    json_t *c;
+
+    p = strchr(val, ';');
+    if (!p) return NULL;
+
+    buf_setcstr(&buf, "geo:");
+    buf_appendmap(&buf, val, p-val);
+    buf_appendcstr(&buf, ",");
+    val = p + 1;
+    buf_appendcstr(&buf, val);
+
+    c = json_string(buf_cstring(&buf));
+    buf_free(&buf);
+    return c;
+}
+
+static json_t*
+locations_from_ical(icalcomponent *comp, json_t *links)
+{
+    icalproperty* prop;
+    json_t *loc, *locations = json_pack("{}");
+    char *id;
+
+    /* Handle end locations */
+    const char *tzidstart = tzid_from_ical(comp, ICAL_DTSTART_PROPERTY);
+    const char *tzidend = tzid_from_ical(comp, ICAL_DTEND_PROPERTY);
+    if (tzidstart && tzidend && strcmp(tzidstart, tzidend)) {
+        prop = icalcomponent_get_first_property(comp, ICAL_DTEND_PROPERTY);
+        id = xjmapid_from_ical(prop);
+        loc = json_pack("{s:s s:s}", "timeZone", tzidend, "relativeTo", "end");
+        json_object_set_new(locations, id, loc);
+        free(id);
+    }
+
+    /* LOCATION */
+    if ((prop = icalcomponent_get_first_property(comp, ICAL_LOCATION_PROPERTY))) {
+        id = xjmapid_from_ical(prop);
+        if ((loc = location_from_ical(prop, links))) {
+            json_object_set_new(locations, id, loc);
+        }
+        free(id);
+    }
+
+    /* GEO */
+    if ((prop = icalcomponent_get_first_property(comp, ICAL_GEO_PROPERTY))) {
+        json_t *coord = coordinates_from_ical(prop);
+        if (coord) {
+            loc = json_pack("{s:o}", "coordinates", coord);
+            id = xjmapid_from_ical(prop);
+            json_object_set_new(locations, id, loc);
+            free(id);
+        }
+    }
+
+    /* Lookup X-property locations */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_X_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_X_PROPERTY)) {
+
+        const char *name = icalproperty_get_property_name(prop);
+
+        /* X-APPLE-STRUCTURED-LOCATION */
+        /* FIXME Most probably,
+         * a X-APPLE-STRUCTURED-LOCATION may occur only once and
+         * always comes with a LOCATION. But who knows for sure? */
+        if (!strcmp(name, "X-APPLE-STRUCTURED-LOCATION")) {
+            const char *title, *uri;
+            icalvalue *val;
+
+            val = icalproperty_get_value(prop);
+            if (icalvalue_isa(val) != ICAL_URI_VALUE) continue;
+
+            uri = icalvalue_as_ical_string(val);
+            if (strncmp(uri, "geo:", 4)) continue;
+
+            loc = json_pack("{s:s}", "coordinates", uri);
+            if ((title = get_icalxparam_value(prop, JMAPICAL_XPARAM_TITLE))) {
+                json_object_set_new(loc, "name", json_string(title));
+            }
+
+            id = xjmapid_from_ical(prop);
+            json_object_set_new(locations, id, loc);
+            free(id);
+            continue;
+        }
+
+        if (strcmp(name, JMAPICAL_XPROP_LOCATION)) {
+            continue;
+        }
+
+        /* X-JMAP-LOCATION */
+        id = xjmapid_from_ical(prop);
+        loc = location_from_ical(prop, links);
+        if (loc) json_object_set_new(locations, id, loc);
+        free(id);
+    }
+
+    if (!json_object_size(locations)) {
+        json_decref(locations);
+        locations = json_null();
+    }
+
+    return locations;
+}
+
+static json_t*
+virtuallocations_from_ical(icalcomponent *comp)
+{
+    icalproperty* prop;
+    json_t *locations = json_pack("{}");
+
+    for (prop = icalcomponent_get_first_property(comp, ICAL_CONFERENCE_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(comp, ICAL_CONFERENCE_PROPERTY)) {
+
+        char *id = xjmapid_from_ical(prop);
+        json_t *loc = json_pack("{s:s}", "@type", "VirtualLocation");
+
+        const char *uri = icalproperty_get_value_as_string(prop);
+        if (uri) json_object_set_new(loc, "uri", json_string(uri));
+
+        const char *name = "";
+        icalparameter *param = icalproperty_get_first_parameter(prop, ICAL_LABEL_PARAMETER);
+        if (param) name = icalparameter_get_label(param);
+        if (!name) name = "";
+        json_object_set_new(loc, "name", json_string(name));
+
+        const char *desc = get_icalxparam_value(prop, JMAPICAL_XPARAM_DESCRIPTION);
+        if (desc) json_object_set_new(loc, "description", json_string(desc));
+
+        if (uri) json_object_set_new(locations, id, loc);
+        free(id);
+    }
+
+    if (!json_object_size(locations)) {
+        json_decref(locations);
+        locations = json_null();
+    }
+
+    return locations;
+}
+
+static void duration_from_vevent(icalcomponent *comp, struct jmapical_duration *dur)
+{
+    struct icaldurationtype icaldur = icaldurationtype_null_duration();
+    struct icaltimetype dtstart = dtstart_from_ical(comp);
+    struct icaltimetype dtend = dtend_from_ical(comp);
+    bit64 nanos = 0;
+
+    if (!icaltime_is_null_time(dtend)) {
+        time_t tstart = icaltime_as_timet_with_zone(dtstart, dtstart.zone);
+        time_t tend = icaltime_as_timet_with_zone(dtend, dtend.zone);
+
+        icalproperty *prop;
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_DTEND_PROPERTY))) {
+            bit64 startnanos = 0;
+            bit64 endnanos = 0;
+            subseconds_from_icalprop(prop, &endnanos);
+            if ((prop = icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY))) {
+                subseconds_from_icalprop(prop, &startnanos);
+            }
+            struct jmapical_duration utcduration = JMAPICAL_DURATION_INITIALIZER;
+            jmapical_duration_between(tstart, startnanos, tend, endnanos, &utcduration);
+            icaldur = duration_to_icalduration(&utcduration);
+            nanos = utcduration.nanos;
+        }
+        else if ((prop = icalcomponent_get_first_property(comp, ICAL_DURATION_PROPERTY))) {
+            subseconds_from_icalprop(prop, &nanos);
+            icaldur = icaldurationtype_from_int((int)(tend - tstart));
+            if (icaldurationtype_is_bad_duration(icaldur) || icaldur.is_neg) {
+                icaldur = icaldurationtype_null_duration();
+                nanos = 0;
+            }
+        }
+    }
+
+    jmapical_duration_from_icalduration(icaldur, dur);
+    dur->nanos = nanos;
+}
+
+static json_t*
+locale_from_ical(icalcomponent *comp)
+{
+    icalproperty *sum, *dsc;
+    icalparameter *param = NULL;
+    const char *lang = NULL;
+
+    sum = icalcomponent_get_first_property(comp, ICAL_SUMMARY_PROPERTY);
+    dsc = icalcomponent_get_first_property(comp, ICAL_DESCRIPTION_PROPERTY);
+
+    if (sum) {
+        param = icalproperty_get_first_parameter(sum, ICAL_LANGUAGE_PARAMETER);
+    }
+    if (!param && dsc) {
+        param = icalproperty_get_first_parameter(dsc, ICAL_LANGUAGE_PARAMETER);
+    }
+    if (param) {
+        lang = icalparameter_get_language(param);
+    }
+
+    return lang ? json_string(lang) : json_null();
+}
+
+/* Convert the libical VEVENT comp to a CalendarEvent 
+ *
+ * master: if not NULL, treat comp as a VEVENT exception
+ * props:  if not NULL, only convert properties named as keys
+ */
+static json_t*
+calendarevent_from_ical(icalcomponent *comp, hash_table *props, icalcomponent *master)
+{
+    icalproperty* prop = NULL;
+    int is_exception = master != NULL;
+    hash_table *wantprops = NULL;
+    json_t *event = json_pack("{s:s}", "@type", "jsevent");
+    struct buf buf = BUF_INITIALIZER;
+
+    if (jmap_wantprop(props, "recurrenceOverrides") && !is_exception) {
+        /* Fetch all properties if recurrenceOverrides are requested,
+         * otherwise we might return incomplete override patches */
+        wantprops = props;
+        props = NULL;
+    }
+
+    /* Handle bogus mix of floating and time zoned types */
+    const char *tzid_start = tzid_from_ical(comp, ICAL_DTSTART_PROPERTY);
+    if (!tzid_start) tzid_start = tzid_from_ical(comp, ICAL_DTEND_PROPERTY);
+
+    /* start */
+    if (jmap_wantprop(props, "start")) {
+        struct jmapical_datetime start = JMAPICAL_DATETIME_INITIALIZER;
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_DTSTART_PROPERTY))) {
+            bit64 nano = 0;
+            subseconds_from_icalprop(prop, &nano);
+            icaltimetype dtstart = dtstart_from_ical(comp);
+            jmapical_datetime_from_icaltime(dtstart, &start);
+            start.nano = nano;
+        }
+        jmapical_localdatetime_as_string(&start, &buf);
+        json_object_set_new(event, "start", json_string(buf_cstring(&buf)));
+        buf_reset(&buf);
+    }
+
+    /* timeZone */
+    if (jmap_wantprop(props, "timeZone")) {
+        json_object_set_new(event, "timeZone", tzid_start ?
+                json_string(tzid_start) : json_null());
+    }
+
+    /* duration */
+    if (jmap_wantprop(props, "duration")) {
+        struct jmapical_duration dur = JMAPICAL_DURATION_INITIALIZER;
+        duration_from_vevent(comp, &dur);
+        jmapical_duration_as_string(&dur, &buf);
+        json_object_set_new(event, "duration", json_string(buf_cstring(&buf)));
+        buf_reset(&buf);
+    }
+
+    /* showWithoutTime */
+    if (jmap_wantprop(props, "showWithoutTime")) {
+        int show_without_time = 0;
+        const char *strval = get_icalxprop_value(comp, "SHOW-WITHOUT-TIME");
+        if (strval) {
+            show_without_time = !strcasecmp(strval, "TRUE");
+        }
+        else {
+            show_without_time = icaltime_is_date(icalcomponent_get_dtstart(comp));
+        }
+        json_object_set_new(event, "showWithoutTime", json_boolean(show_without_time));
+    }
+
+    /* uid */
+    const char *uid = icalcomponent_get_uid(comp);
+    if (uid && !is_exception) {
+        json_object_set_new(event, "uid", json_string(uid));
+    }
+
+    /* relatedTo */
+    if (jmap_wantprop(props, "relatedTo") && !is_exception) {
+        json_object_set_new(event, "relatedTo", relatedto_from_ical(comp));
+    }
+
+    /* prodId */
+    if (jmap_wantprop(props, "prodId") && !is_exception) {
+        icalcomponent *ical = icalcomponent_get_parent(comp);
+        const char *prodid = NULL;
+        prop = icalcomponent_get_first_property(ical, ICAL_PRODID_PROPERTY);
+        if (prop) prodid = icalproperty_get_prodid(prop);
+        json_object_set_new(event, "prodId",
+                prodid ? json_string(prodid) : json_null());
+    }
+
+    /* created */
+    if (jmap_wantprop(props, "created")) {
+        struct jmapical_datetime created = JMAPICAL_DATETIME_INITIALIZER;
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_CREATED_PROPERTY))) {
+            jmapical_datetime_from_icalprop(prop, &created);
+            jmapical_utcdatetime_as_string(&created, &buf);
+            json_t *jval = json_string(buf_cstring(&buf));
+            buf_reset(&buf);
+            json_object_set_new(event, "created", jval);
+        }
+    }
+
+    /* updated */
+    if (jmap_wantprop(props, "updated")) {
+        struct jmapical_datetime updated = JMAPICAL_DATETIME_INITIALIZER;
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_DTSTAMP_PROPERTY))) {
+            jmapical_datetime_from_icalprop(prop, &updated);
+            jmapical_utcdatetime_as_string(&updated, &buf);
+            json_t* jval = json_string(buf_cstring(&buf));
+            buf_reset(&buf);
+            json_object_set_new(event, "updated", jval);
+        }
+    }
+
+    /* sequence */
+    if (jmap_wantprop(props, "sequence")) {
+        json_object_set_new(event, "sequence",
+                json_integer(icalcomponent_get_sequence(comp)));
+    }
+
+    /* priority */
+    if (jmap_wantprop(props, "priority")) {
+        int priority = 0;
+        prop = icalcomponent_get_first_property(comp, ICAL_PRIORITY_PROPERTY);
+        if (prop) priority = icalproperty_get_priority(prop);
+        json_object_set_new(event, "priority", json_integer(priority));
+    }
+
+    /* title */
+    if (jmap_wantprop(props, "title")) {
+        const char *title= "";
+        prop = icalcomponent_get_first_property(comp, ICAL_SUMMARY_PROPERTY);
+        if (prop) {
+            title = icalproperty_get_summary(prop);
+            if (!title) title = "";
+        }
+        json_object_set_new(event, "title", json_string(title));
+    }
+
+    /* description */
+    if (jmap_wantprop(props, "description") || jmap_wantprop(props, "descriptionContentType")) {
+        const char *desc = "";
+        prop = icalcomponent_get_first_property(comp, ICAL_DESCRIPTION_PROPERTY);
+        if (prop) {
+            desc = icalproperty_get_description(prop);
+            if (!desc) desc = "";
+        }
+        if (jmap_wantprop(props, "description")) {
+            json_object_set_new(event, "description", json_string(desc));
+        }
+        if (jmap_wantprop(props, "descriptionContentType")) {
+            json_object_set_new(event, "descriptionContentType", json_string("text/plain"));
+        }
+    }
+
+    /* method */
+    if (jmap_wantprop(props, "method")) {
+        icalcomponent *ical = icalcomponent_get_parent(comp);
+        if (ical) {
+            icalproperty_method icalmethod = icalcomponent_get_method(ical);
+            if (icalmethod != ICAL_METHOD_NONE) {
+                char *method = xstrdupsafe(icalenum_method_to_string(icalmethod));
+                lcase(method);
+                json_object_set_new(event, "method", json_string(method));
+                free(method);
+            }
+        }
+    }
+
+    /* color */
+    if (jmap_wantprop(props, "color")) {
+        prop = icalcomponent_get_first_property(comp, ICAL_COLOR_PROPERTY);
+        if (prop) {
+            json_object_set_new(event, "color",
+                    json_string(icalproperty_get_color(prop)));
+        }
+    }
+
+    /* keywords */
+    if (jmap_wantprop(props, "keywords")) {
+        json_object_set_new(event, "keywords", keywords_from_ical(comp));
+    }
+
+    /* links */
+    if (jmap_wantprop(props, "links")) {
+        json_object_set_new(event, "links", links_from_ical(comp));
+    }
+
+    /* locale */
+    if (jmap_wantprop(props, "locale")) {
+        json_object_set_new(event, "locale", locale_from_ical(comp));
+    }
+
+    /* locations */
+    if (jmap_wantprop(props, "locations")) {
+        json_t *links = json_object();
+        json_object_set_new(event, "locations", locations_from_ical(comp, links));
+        if (json_object_size(links)) {
+            if (JNOTNULL(json_object_get(event, "links"))) {
+                json_object_update(json_object_get(event, "links"), links);
+            } else {
+                json_object_set(event, "links", links);
+            }
+        }
+        json_decref(links);
+    }
+
+    /* virtualLocations */
+    if (jmap_wantprop(props, "virtualLocations")) {
+        json_object_set_new(event, "virtualLocations", virtuallocations_from_ical(comp));
+    }
+
+    /* recurrenceRule */
+    if (jmap_wantprop(props, "recurrenceRule") && !is_exception) {
+        json_object_set_new(event, "recurrenceRule", recurrence_from_ical(comp));
+    }
+
+    /* status */
+    if (jmap_wantprop(props, "status")) {
+        const char *status = "confirmed";
+        switch (icalcomponent_get_status(comp)) {
+            case ICAL_STATUS_TENTATIVE:
+                status = "tentative";
+                break;
+            case ICAL_STATUS_CONFIRMED:
+                status = "confirmed";
+                break;
+            case ICAL_STATUS_CANCELLED:
+                status = "cancelled";
+                break;
+            default:
+                status = "confirmed";
+        }
+        json_object_set_new(event, "status", json_string(status));
+    }
+
+    /* freeBusyStatus */
+    if (jmap_wantprop(props, "freeBusyStatus")) {
+        const char *fbs = "busy";
+        if ((prop = icalcomponent_get_first_property(comp,
+                                                     ICAL_TRANSP_PROPERTY))) {
+            if (icalproperty_get_transp(prop) == ICAL_TRANSP_TRANSPARENT) {
+                fbs = "free";
+            }
+        }
+        json_object_set_new(event, "freeBusyStatus", json_string(fbs));
+    }
+
+    /* privacy */
+    if (jmap_wantprop(props, "privacy")) {
+        const char *prv = "public";
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_CLASS_PROPERTY))) {
+            switch (icalproperty_get_class(prop)) {
+                case ICAL_CLASS_CONFIDENTIAL:
+                    prv = "secret";
+                    break;
+                case ICAL_CLASS_PRIVATE:
+                    prv = "private";
+                    break;
+                default:
+                    prv = "public";
+            }
+        }
+        json_object_set_new(event, "privacy", json_string(prv));
+    }
+
+    /* replyTo */
+    if (jmap_wantprop(props, "replyTo") && !is_exception) {
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY))) {
+            json_object_set_new(event, "replyTo",rsvpto_from_ical(prop));
+        }
+    }
+
+    /* participants */
+    if (jmap_wantprop(props, "participants")) {
+        json_object_set_new(event, "participants", participants_from_ical(comp));
+    }
+
+    /* useDefaultAlerts */
+    if (jmap_wantprop(props, "useDefaultAlerts")) {
+        const char *v = get_icalxprop_value(comp, JMAPICAL_XPROP_USEDEFALERTS);
+        json_object_set_new(event, "useDefaultAlerts",
+                json_boolean(v && !strcasecmp(v, "true")));
+    }
+
+    /* alerts */
+    if (jmap_wantprop(props, "alerts")) {
+        json_object_set_new(event, "alerts", alerts_from_ical(comp));
+    }
+
+    /* recurrenceOverrides - must be last to generate patches */
+    if (jmap_wantprop(props, "recurrenceOverrides") && !is_exception) {
+        json_object_set_new(event, "recurrenceOverrides",
+                overrides_from_ical(comp, event, tzid_start));
+    }
+
+    if (wantprops) {
+        jmap_filterprops(event, wantprops);
+    }
+
+    buf_free(&buf);
+    return event;
+}
+
+json_t*
+jmapical_tojmap_all(icalcomponent *ical, hash_table *props)
+{
+    icalcomponent* comp;
+
+    /* Locate all main VEVENTs. */
+    ptrarray_t todo = PTRARRAY_INITIALIZER;
+    icalcomponent *firstcomp =
+        icalcomponent_get_first_component(ical, ICAL_VEVENT_COMPONENT);
+    for (comp = firstcomp;
+         comp;
+         comp = icalcomponent_get_next_component(ical, ICAL_VEVENT_COMPONENT)) {
+
+        icalproperty *recurid = icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY);
+        if (recurid) continue;
+
+        if (icalcomponent_get_uid(comp) == NULL) continue;
+
+        ptrarray_append(&todo, comp);
+    }
+    /* magic promote to toplevel for the first item */
+    if (firstcomp && !ptrarray_size(&todo)) {
+        ptrarray_append(&todo, firstcomp);
+    }
+    else if (!ptrarray_size(&todo)) {
+        return json_array();
+    }
+
+    /* Convert the VEVENTs to JMAP. */
+    json_t *events = json_array();
+    while ((comp = ptrarray_pop(&todo))) {
+        json_t *jsevent = calendarevent_from_ical(comp, props, NULL);
+        if (jsevent) json_array_append_new(events, jsevent);
+    }
+
+    ptrarray_fini(&todo);
+    return events;
+}
+
+json_t*
+jmapical_tojmap(icalcomponent *ical, hash_table *props)
+{
+    json_t *jsevents = jmapical_tojmap_all(ical, props);
+    json_t *ret = NULL;
+    if (json_array_size(jsevents)) {
+        ret = json_incref(json_array_get(jsevents, 0));
+    }
+    json_decref(jsevents);
+    return ret;
+}
+
+/*
+ * Convert to iCalendar from JMAP
+ */
+
+static int validate_type(struct jmap_parser *parser, json_t *jobj, const char *wanttype)
+{
+    json_t *jtype = json_object_get(jobj, "@type");
+    if (jtype && jtype != json_null()) {
+        if (!json_is_string(jtype) || strcasecmp(json_string_value(jtype), wanttype)) {
+            jmap_parser_invalid(parser, "@type");
+            return 0;
+        }
+    }
+    return 1;
+}
+
+static void relatedto_to_ical(icalcomponent *, struct jmap_parser *, json_t *);
+
+/* defined in http_tzdist */
+extern void icalcomponent_add_required_timezones(icalcomponent *ical);
+
+/* Remove and deallocate any properties of kind in comp. */
+static void remove_icalprop(icalcomponent *comp, icalproperty_kind kind)
+{
+    icalproperty *prop, *next;
+
+    for (prop = icalcomponent_get_first_property(comp, kind);
+         prop;
+         prop = next) {
+
+        next = icalcomponent_get_next_property(comp, kind);
+        icalcomponent_remove_property(comp, prop);
+        icalproperty_free(prop);
+    }
+}
+
+static void subseconds_to_icalprop(icalproperty *prop, bit64 nano)
+{
+    if (!nano) return;
+
+    struct buf buf = BUF_INITIALIZER;
+    buf_printf(&buf, "0.%llu", nano);
+
+    /* Truncate trailing zeros */
+    int n = buf_len(&buf);
+    const char *b = buf_base(&buf);
+    while (b[n-1] == '0') n--;
+    buf_truncate(&buf, n);
+
+    set_icalxparam(prop, "SUBSECOND", buf_cstring(&buf), 1);
+    buf_free(&buf);
+}
+
+/* Add or overwrite the datetime property kind in comp. If tz is not NULL, set
+ * the TZID parameter on the property. Also take care to purge conflicting
+ * datetime properties such as DTEND and DURATION. */
+static icalproperty *insert_icaltimeprop(icalcomponent *comp,
+                                         icaltimetype dt,
+                                         bit64 nano,
+                                         int remove_existing,
+                                         enum icalproperty_kind kind)
+{
+    icalproperty *prop;
+
+    /* Purge existing property. */
+    if (remove_existing) {
+        remove_icalprop(comp, kind);
+    }
+
+    /* Resolve DTEND/DURATION conflicts. */
+    if (kind == ICAL_DTEND_PROPERTY) {
+        remove_icalprop(comp, ICAL_DURATION_PROPERTY);
+    } else if (kind == ICAL_DURATION_PROPERTY) {
+        remove_icalprop(comp, ICAL_DTEND_PROPERTY);
+    }
+
+    /* backwards compatible way to set date or datetime */
+    icalvalue *val =
+        dt.is_date ? icalvalue_new_date(dt) : icalvalue_new_datetime(dt);
+    if (!val) {
+        syslog(LOG_ERR, "insert_icaltimeprop: invalid time value");
+        return NULL;
+    }
+
+    /* Set the new property. */
+    prop = icalproperty_new(kind);
+    icalproperty_set_value(prop, val);
+    if (dt.zone && !icaltime_is_utc(dt)) {
+        icalparameter *param =
+            icalproperty_get_first_parameter(prop, ICAL_TZID_PARAMETER);
+        /* XXX libical uses non-const icaltimezone pointer for read-only */
+        const char *tzid = icaltimezone_get_location((icaltimezone*)dt.zone);
+        if (param) {
+            icalparameter_set_tzid(param, tzid);
+        } else {
+            icalproperty_add_parameter(prop,icalparameter_new_tzid(tzid));
+        }
+    }
+    if (!dt.is_date) subseconds_to_icalprop(prop, nano);
+    icalcomponent_add_property(comp, prop);
+    return prop;
+}
+
+static int location_is_endtimezone(json_t *loc)
+{
+    const char *rel = json_string_value(json_object_get(loc, "relativeTo"));
+    if (!rel) return 0;
+    return json_object_get(loc, "timeZone") && !strcmp(rel, "end");
+}
+
+/* Update the start and end properties of VEVENT comp, as defined by
+ * the JMAP calendarevent event. */
+static void
+startend_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *event)
+{
+    json_t *jprop;
+
+    /* timeZone */
+    icaltimezone *tzstart = NULL;
+    jprop = json_object_get(event, "timeZone");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        tzstart = tz_from_tzid(val);
+        if (!tzstart) {
+            jmap_parser_invalid(parser, "timeZone");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "timeZone");
+    }
+
+    /* Read end timezone */
+    icaltimezone *tzend = tzstart;
+    const char *endzone_location_id = NULL;
+    json_t *locations = json_object_get(event, "locations");
+    if (json_is_object(locations)) {
+        json_t *jval;
+        const char *id;
+        jmap_parser_push(parser, "locations");
+        json_object_foreach(locations, id, jval) {
+            if (!location_is_endtimezone(jval)) {
+                continue;
+            }
+            /* Pick the first location with timeZone and rel=end */
+            jmap_parser_push(parser, id);
+            endzone_location_id = id;
+            json_t *timeZone = json_object_get(jval, "timeZone");
+            if (json_is_string(timeZone)) {
+                tzend = tz_from_tzid(json_string_value(timeZone));
+                if (!tzend || !tzstart) {
+                    jmap_parser_invalid(parser, "timeZone");
+                }
+            }
+            else if (JNOTNULL(jprop)) {
+                jmap_parser_invalid(parser, "timeZone");
+            }
+            jmap_parser_pop(parser);
+            break;
+        }
+        jmap_parser_pop(parser);
+    } else if (JNOTNULL(locations)) {
+        jmap_parser_invalid(parser, "locations");
+    }
+
+    /* Read duration */
+    struct jmapical_duration dur = JMAPICAL_DURATION_INITIALIZER;
+    jprop = json_object_get(event, "duration");
+    if (json_is_string(jprop)) {
+        if (jmapical_duration_from_string(json_string_value(jprop), &dur) < 0) {
+            jmap_parser_invalid(parser, "duration");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "duration");
+    }
+
+    /* Read start */
+    struct jmapical_datetime start = JMAPICAL_DATETIME_INITIALIZER;
+    jprop = json_object_get(event, "start");
+    if (json_is_string(jprop)) {
+        if (jmapical_localdatetime_from_string(json_string_value(jprop), &start) < 0) {
+            jmap_parser_invalid(parser, "start");
+        }
+    } else {
+        jmap_parser_invalid(parser, "start");
+    }
+
+    /* Bail out for property errors */
+    if (json_array_size(parser->invalid))
+        return;
+
+    /* Purge and rebuild start and end */
+    remove_icalprop(comp, ICAL_DTSTART_PROPERTY);
+    remove_icalprop(comp, ICAL_DTEND_PROPERTY);
+    remove_icalprop(comp, ICAL_DURATION_PROPERTY);
+
+    /* Add DTSTART */
+    int is_date = 0;
+    if (!tzstart && !tzend && jmapical_datetime_has_zero_time(&start) &&
+            jmapical_duration_has_zero_time(&dur)) {
+        /* Determine if to store DTSTART as DATE type */
+        is_date = 1;
+        /* Check recurrence frequency */
+        json_t *jrrule = json_object_get(event, "recurrenceRule");
+        if (json_is_object(jrrule)) {
+            const char *freq = json_string_value(json_object_get(jrrule, "frequency"));
+            if (!strcmpsafe(freq, "hourly") ||
+                !strcmpsafe(freq, "minutely") ||
+                !strcmpsafe(freq, "secondly")) {
+                is_date = 0;
+            }
+            else {
+                /* Check that all overrides have zero time */
+                json_t *joverrides = json_object_get(event, "recurrenceOverrides");
+                const char *recuridval;
+                json_t *jval;
+                json_object_foreach(joverrides, recuridval, jval) {
+                    struct jmapical_datetime recurid = JMAPICAL_DATETIME_INITIALIZER;
+                    if ((jmapical_localdatetime_from_string(recuridval, &recurid) >= 0) &&
+                            !jmapical_datetime_has_zero_time(&recurid)) {
+                        is_date = 0;
+                        break;
+                    }
+                }
+            }
+        }
+        if (json_object_get(event, "showWithoutTime") == json_false()) {
+            /* Explicitly set to false. Keep start as floating time. */
+            is_date = 0;
+        }
+    }
+
+    struct icaltimetype dtstart = is_date ?
+        jmapical_datetime_to_icaldate(&start) :
+        jmapical_datetime_to_icaltime(&start, tzstart);
+    insert_icaltimeprop(comp, dtstart, start.nano, 1, ICAL_DTSTART_PROPERTY);
+    if (tzstart != tzend) {
+        /* Add DTEND */
+        struct icaldurationtype icaldur = duration_to_icalduration(&dur);
+        bit64 endnanos = start.nano + dur.nanos;
+        icaldur.seconds += endnanos / 1000000000;
+        endnanos %= 1000000000;
+        icaltimetype dtend = icaltime_add(dtstart, icaldur);
+        dtend = icaltime_convert_to_zone(dtend, tzend);
+        icalproperty *prop = insert_icaltimeprop(comp, dtend, endnanos, 1, ICAL_DTEND_PROPERTY);
+        if (prop) xjmapid_to_ical(prop, endzone_location_id);
+    } else {
+        /* Add DURATION */
+        struct icaldurationtype icaldur = duration_to_icalduration(&dur);
+        icalproperty *prop = icalproperty_new_duration(icaldur);
+        subseconds_to_icalprop(prop, dur.nanos);
+        icalcomponent_add_property(comp, prop);
+    }
+
+    json_t *jshowWithoutTime = json_object_get(event, "showWithoutTime");
+    if (json_is_boolean(jshowWithoutTime)) {
+        int show_without_time = json_boolean_value(jshowWithoutTime);
+        /* Only set in iCalendar if it isn't implied by DTSTART value type */
+        if ((is_date == 0) != (show_without_time == 0)) {
+            icalproperty *prop = icalproperty_new(ICAL_X_PROPERTY);
+            icalproperty_set_x_name(prop, "SHOW-WITHOUT-TIME");
+            icalvalue *icalval = icalvalue_new_boolean(show_without_time);
+            icalproperty_set_value(prop, icalval);
+            icalcomponent_add_property(comp, prop);
+        }
+    }
+    else if (JNOTNULL(jshowWithoutTime)) {
+        jmap_parser_invalid(parser, "showWithoutTime");
+    }
+
+}
+
+static void
+participant_roles_to_ical(icalproperty *prop,
+                          struct jmap_parser *parser,
+                          json_t *roles,
+                          int is_replyto)
+{
+    if (!json_object_size(roles)) {
+        jmap_parser_invalid(parser, "roles");
+        return;
+    }
+
+    const char *key;
+    json_t *jval;
+    jmap_parser_push(parser, "roles");
+    json_object_foreach(roles, key, jval) {
+        if (jval != json_true()) {
+            jmap_parser_invalid(parser, key);
+        }
+    }
+    jmap_parser_pop(parser);
+
+    icalparameter_role ical_role = ICAL_ROLE_REQPARTICIPANT;
+    int has_chair = json_object_get(roles, "chair") == json_true();
+    int has_optional = json_object_get(roles, "optional") == json_true();
+    int has_informational = json_object_get(roles, "informational") == json_true();
+
+    /* Try to map roles to iCalendar without falling back to X-ROLE */
+    if (has_chair && ical_role == ICAL_ROLE_REQPARTICIPANT) {
+        /* Can use iCalendar ROLE=CHAIR parameter */
+        ical_role = ICAL_ROLE_CHAIR;
+    }
+    if (has_optional && ical_role == ICAL_ROLE_REQPARTICIPANT) {
+        /* Can use iCalendar ROLE=OPT-PARTICIPANT parameter */
+        ical_role = ICAL_ROLE_OPTPARTICIPANT;
+    }
+    if (has_informational && ical_role == ICAL_ROLE_REQPARTICIPANT) {
+        /* Can use iCalendar ROLE=NON-PARTICIPANT parameter */
+        ical_role = ICAL_ROLE_NONPARTICIPANT;
+    }
+
+    /* Map roles */
+    json_object_foreach(roles, key, jval) {
+        if (!strcasecmp(key, "ATTENDEE")) continue;
+        if (!strcasecmp(key, "OWNER") && is_replyto) continue;  // ORGANIZER
+        if (!strcasecmp(key, "CHAIR") && ical_role == ICAL_ROLE_CHAIR) continue;
+        if (!strcasecmp(key, "OPTIONAL") && ical_role == ICAL_ROLE_OPTPARTICIPANT) continue;
+        if (!strcasecmp(key, "INFORMATIONAL") && ical_role == ICAL_ROLE_NONPARTICIPANT) continue;
+        // everything else needs an XROLE
+        set_icalxparam(prop, JMAPICAL_XPARAM_ROLE, key, 0);
+    }
+
+    if (ical_role != ICAL_ROLE_REQPARTICIPANT) {
+        icalparameter *param = icalparameter_new_role(ical_role);
+        icalproperty_add_parameter(prop, param);
+    }
+}
+
+static int is_valid_rsvpmethod(const char *s)
+{
+    if (!s) return 0;
+    size_t i;
+    for (i = 0; s[i]; i++) {
+        if (!isascii(s[i]) || !isalpha(s[i])) {
+            return 0;
+        }
+    }
+    return i > 0;
+}
+
+static int
+participant_equals(json_t *jpart1, json_t *jpart2)
+{
+    /* Special-case sendTo URI values */
+    json_t *jsendTo1 = json_object_get(jpart1, "sendTo");
+    json_t *jsendTo2 = json_object_get(jpart2, "sendTo");
+    if (jsendTo1 == NULL || jsendTo1 == json_null()) {
+        json_t *jemail = json_object_get(jpart1, "email");
+        if (json_is_string(jemail)) {
+            char *tmp = strconcat("mailto:", json_string_value(jemail), NULL);
+            json_object_set_new(jpart1, "sendTo", json_pack("{s:s}", "imip", tmp));
+            free(tmp);
+        }
+        jsendTo1 = json_object_get(jpart1, "sendTo");
+    }
+    if (jsendTo2 == NULL || jsendTo2 == json_null()) {
+        json_t *jemail = json_object_get(jpart2, "email");
+        if (json_is_string(jemail)) {
+            char *tmp = strconcat("mailto:", json_string_value(jemail), NULL);
+            json_object_set_new(jpart2, "sendTo", json_pack("{s:s}", "imip", tmp));
+            free(tmp);
+        }
+        jsendTo2 = json_object_get(jpart2, "sendTo");
+    }
+    if (json_object_size(jsendTo1) != json_object_size(jsendTo2)) return 0;
+    if (JNOTNULL(jsendTo1)) {
+        json_t *juri1;
+        const char *method;
+        json_object_foreach(jsendTo1, method, juri1) {
+            json_t *juri2 = json_object_get(jsendTo2, method);
+            if (!juri2) return 0;
+            const char *uri1 = json_string_value(juri1);
+            const char *uri2 = json_string_value(juri2);
+            if (!uri1 || !uri2 || !match_uri(uri1, uri2)) return 0;
+        }
+    }
+
+    json_t *jval1 = json_copy(jpart1);
+    json_t *jval2 = json_copy(jpart2);
+    json_object_del(jval1, "sendTo");
+    json_object_del(jval2, "sendTo");
+
+    /* Remove default values */
+    if (!strcmpsafe(json_string_value(json_object_get(jval1, "name")), ""))
+        json_object_del(jval1, "name");
+    if (!strcmpsafe(json_string_value(json_object_get(jval2, "name")), ""))
+        json_object_del(jval2, "name");
+
+    if (!strcmpsafe(json_string_value(json_object_get(jval1, "participationStatus")), "needs-action"))
+        json_object_del(jval1, "participationStatus");
+    if (!strcmpsafe(json_string_value(json_object_get(jval2, "participationStatus")), "needs-action"))
+        json_object_del(jval2, "participationStatus");
+
+    if (!json_boolean_value(json_object_get(jval1, "expectReply")))
+        json_object_del(jval1, "expectReply");
+    if (!json_boolean_value(json_object_get(jval2, "expectReply")))
+        json_object_del(jval2, "expectReply");
+
+    if (json_integer_value(json_object_get(jval1, "scheduleSequence")) == 0)
+        json_object_del(jval1, "scheduleSequence");
+    if (json_integer_value(json_object_get(jval2, "scheduleSequence")) == 0)
+        json_object_del(jval2, "scheduleSequence");
+
+    /* Unify JSON null to NULL */
+    json_t *jprop;
+    const char *key;
+    void *tmp;
+    json_object_foreach_safe(jval1, tmp, key, jprop) {
+        if (json_is_null(jprop)) json_object_del(jval1, key);
+    }
+    json_object_foreach_safe(jval2, tmp, key, jprop) {
+        if (json_is_null(jprop)) json_object_del(jval2, key);
+    }
+
+    int is_equal = json_equal(jval1, jval2);
+    json_decref(jval1);
+    json_decref(jval2);
+    return is_equal;
+}
+
+
+
+static void
+participant_to_ical(icalcomponent *comp,
+                    struct jmap_parser *parser,
+                    const char *id,
+                    json_t *jpart,
+                    json_t *participants,
+                    json_t *links,
+                    const char *orga_uri,
+                    hash_table *caladdress_by_participant_id)
+{
+    const char *caladdress = hash_lookup(id, caladdress_by_participant_id);
+    icalproperty *prop = icalproperty_new_attendee(caladdress);
+    set_icalxparam(prop, JMAPICAL_XPARAM_ID, id, 1);
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+
+    icalproperty *orga = icalcomponent_get_first_property(comp, ICAL_ORGANIZER_PROPERTY);
+    int is_orga = match_uri(caladdress, orga_uri);
+    if (is_orga) set_icalxparam(orga, JMAPICAL_XPARAM_ID, id, 1);
+
+    /* name */
+    json_t *jname = json_object_get(jpart, "name");
+    if (json_is_string(jname)) {
+        const char *name = json_string_value(jname);
+        icalproperty_add_parameter(prop, icalparameter_new_cn(name));
+        if (is_orga) {
+            icalproperty_add_parameter(orga, icalparameter_new_cn(name));
+        }
+    }
+    else if (JNOTNULL(jname)) {
+        jmap_parser_invalid(parser, "name");
+    }
+
+    /* sendTo */
+    json_t *sendTo = json_object_get(jpart, "sendTo");
+    if (json_object_size(sendTo)) {
+        jmap_parser_push(parser, "sendTo");
+        struct buf buf = BUF_INITIALIZER;
+
+        /* Only set RSVP URI x-params if not trivial */
+        int set_rsvp_uris = 0;
+        if (json_object_size(sendTo) > 1) {
+            set_rsvp_uris = 1;
+        }
+        else {
+            const char *method = json_object_iter_key(json_object_iter(sendTo));
+            set_rsvp_uris = strcmp(method, "imip") && strcmp(method, "other");
+        }
+
+        const char *key;
+        json_t *jval;
+        /* Process RSVP URIs */
+        json_object_foreach(sendTo, key, jval) {
+            if (!is_valid_rsvpmethod(key) || !json_is_string(jval)) {
+                jmap_parser_invalid(parser, key);
+                continue;
+            }
+            if (!set_rsvp_uris) continue;
+
+            buf_setcstr(&buf, key);
+            buf_putc(&buf, ':');
+            buf_appendcstr(&buf, json_string_value(jval));
+            set_icalxparam(prop, JMAPICAL_XPARAM_RSVP_URI, buf_cstring(&buf), 0);
+        }
+
+        buf_free(&buf);
+        jmap_parser_pop(parser);
+    }
+    else if (JNOTNULL(sendTo)) {
+        jmap_parser_invalid(parser, "sendTo");
+    }
+
+    /* email */
+    json_t *jemail = json_object_get(jpart, "email");
+    if (json_is_string(jemail)) {
+        const char *uri = icalproperty_get_value_as_string(prop);
+        const char *email = json_string_value(jemail);
+        if (!match_uri(uri, email)) {
+            icalproperty_add_parameter(prop, icalparameter_new_email(email));
+            if (is_orga) {
+                icalproperty_add_parameter(orga, icalparameter_new_email(email));
+            }
+        }
+    }
+    else if (JNOTNULL(jemail)) {
+        jmap_parser_invalid(parser, "email");
+    }
+
+    /* kind */
+    json_t *kind = json_object_get(jpart, "kind");
+    if (json_is_string(kind)) {
+        icalparameter *param = NULL;
+        char *tmp = ucase(xstrdup(json_string_value(kind)));
+        icalparameter_cutype cu;
+        if (!strcmp(tmp, "LOCATION"))
+            cu = ICAL_CUTYPE_ROOM;
+        else
+            cu = icalparameter_string_to_enum(tmp);
+        switch (cu) {
+            case ICAL_CUTYPE_INDIVIDUAL:
+            case ICAL_CUTYPE_GROUP:
+            case ICAL_CUTYPE_RESOURCE:
+            case ICAL_CUTYPE_ROOM:
+                param = icalparameter_new_cutype(cu);
+                icalproperty_add_parameter(prop, param);
+                break;
+            default:
+                /* ignore */ ;
+        }
+        free(tmp);
+    }
+    else if (JNOTNULL(kind)) {
+        jmap_parser_invalid(parser, "kind");
+    }
+
+    /* roles */
+    json_t *roles = json_object_get(jpart, "roles");
+    if (json_object_size(roles)) {
+        participant_roles_to_ical(prop, parser, roles, is_orga);
+    }
+    else if (roles) {
+        jmap_parser_invalid(parser, "roles");
+    }
+
+    /* locationId */
+    json_t *locationId = json_object_get(jpart, "locationId");
+    if (json_is_string(locationId)) {
+        const char *s = json_string_value(locationId);
+        set_icalxparam(prop, JMAPICAL_XPARAM_LOCATIONID, s, 1);
+    }
+    else if (JNOTNULL(locationId)) {
+        jmap_parser_invalid(parser, "locationId");
+    }
+
+    /* participationStatus */
+    icalparameter_partstat ps = ICAL_PARTSTAT_NONE;
+    json_t *participationStatus = json_object_get(jpart, "participationStatus");
+    if (json_is_string(participationStatus)) {
+        char *tmp = ucase(xstrdup(json_string_value(participationStatus)));
+        ps = icalparameter_string_to_enum(tmp);
+        switch (ps) {
+            case ICAL_PARTSTAT_NEEDSACTION:
+            case ICAL_PARTSTAT_ACCEPTED:
+            case ICAL_PARTSTAT_DECLINED:
+            case ICAL_PARTSTAT_TENTATIVE:
+                break;
+            default:
+                jmap_parser_invalid(parser, "participationStatus");
+                ps = ICAL_PARTSTAT_NONE;
+        }
+        free(tmp);
+    }
+    else if (JNOTNULL(participationStatus)) {
+        jmap_parser_invalid(parser, "participationStatus");
+    }
+    if (ps != ICAL_PARTSTAT_NONE) {
+        icalproperty_add_parameter(prop, icalparameter_new_partstat(ps));
+    }
+
+    /* expectReply */
+    json_t *expectReply = json_object_get(jpart, "expectReply");
+    if (json_is_boolean(expectReply)) {
+        icalparameter *param = NULL;
+        if (expectReply == json_true()) {
+            param = icalparameter_new_rsvp(ICAL_RSVP_TRUE);
+            if (ps == ICAL_PARTSTAT_NONE) {
+                icalproperty_add_parameter(prop,
+                        icalparameter_new_partstat(ICAL_PARTSTAT_NEEDSACTION));
+            }
+        }
+        else {
+            param = icalparameter_new_rsvp(ICAL_RSVP_FALSE);
+        }
+        icalproperty_add_parameter(prop, param);
+    }
+    else if (JNOTNULL(expectReply)) {
+        jmap_parser_invalid(parser, "expectReply");
+    }
+
+    /* delegatedTo */
+    json_t *delegatedTo = json_object_get(jpart, "delegatedTo");
+    if (json_object_size(delegatedTo)) {
+        const char *id;
+        json_t *jval;
+        json_object_foreach(delegatedTo, id, jval) {
+            json_t *delegatee = json_object_get(participants, id);
+            if (is_valid_jmapid(id) && delegatee && jval == json_true()) {
+                const char *uri = hash_lookup(id, caladdress_by_participant_id);
+                if (uri) {
+                    icalproperty_add_parameter(prop, icalparameter_new_delegatedto(uri));
+                }
+            }
+            else {
+                jmap_parser_push(parser, "delegatedTo");
+                jmap_parser_invalid(parser, id);
+                jmap_parser_pop(parser);
+            }
+        }
+    }
+    else if (JNOTNULL(delegatedTo)) {
+        jmap_parser_invalid(parser, "delegatedTo");
+    }
+
+    /* delegatedFrom */
+    json_t *delegatedFrom = json_object_get(jpart, "delegatedFrom");
+    if (json_object_size(delegatedFrom)) {
+        const char *id;
+        json_t *jval;
+        json_object_foreach(delegatedFrom, id, jval) {
+            json_t *delegator = json_object_get(participants, id);
+            if (is_valid_jmapid(id) && delegator && jval == json_true()) {
+                const char *uri = hash_lookup(id, caladdress_by_participant_id);
+                if (uri) {
+                    icalproperty_add_parameter(prop, icalparameter_new_delegatedfrom(uri));
+                }
+            }
+            else {
+                jmap_parser_push(parser, "delegatedFrom");
+                jmap_parser_invalid(parser, id);
+                jmap_parser_pop(parser);
+            }
+        }
+    }
+    else if (JNOTNULL(delegatedFrom)) {
+        jmap_parser_invalid(parser, "delegatedFrom");
+    }
+
+    /* memberOf */
+    json_t *memberOf = json_object_get(jpart, "memberOf");
+    if (json_object_size(memberOf)) {
+        const char *id;
+        json_t *jval;
+        json_object_foreach(memberOf, id, jval) {
+            json_t *group = json_object_get(participants, id);
+            if (is_valid_jmapid(id) && group && jval == json_true()) {
+                const char *uri = hash_lookup(id, caladdress_by_participant_id);
+                if (uri) {
+                    icalproperty_add_parameter(prop, icalparameter_new_member(uri));
+                }
+            }
+            else {
+                jmap_parser_push(parser, "memberOf");
+                jmap_parser_invalid(parser, id);
+                jmap_parser_pop(parser);
+            }
+        }
+    }
+    else if (JNOTNULL(memberOf)) {
+        jmap_parser_invalid(parser, "memberOf");
+    }
+
+    /* linkIds */
+    json_t *linkIds = json_object_get(jpart, "linkIds");
+    if (json_object_size(linkIds)) {
+        const char *id;
+        json_t *jval;
+        json_object_foreach(linkIds, id, jval) {
+            if (!is_valid_jmapid(id) || !json_object_get(links, id) || jval != json_true()) {
+                jmap_parser_push(parser, "linkIds");
+                jmap_parser_invalid(parser, id);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            set_icalxparam(prop, JMAPICAL_XPARAM_LINKID, id, 0);
+        }
+    }
+    else if (JNOTNULL(linkIds)) {
+        jmap_parser_invalid(parser, "linkIds");
+    }
+
+    /* scheduleSequence */
+    json_t *scheduleSequence = json_object_get(jpart, "scheduleSequence");
+    if (json_is_integer(scheduleSequence) && json_integer_value(scheduleSequence) >= 0) {
+        struct buf buf = BUF_INITIALIZER;
+        buf_printf(&buf, "%lld", json_integer_value(scheduleSequence));
+        set_icalxparam(prop, JMAPICAL_XPARAM_SEQUENCE, buf_cstring(&buf), 0);
+        buf_free(&buf);
+    }
+    else if (JNOTNULL(scheduleSequence)) {
+        jmap_parser_invalid(parser, "scheduleSequence");
+    }
+
+    /* scheduleUpdated */
+    json_t *scheduleUpdated = json_object_get(jpart, "scheduleUpdated");
+    if (json_is_string(scheduleUpdated)) {
+        struct jmapical_datetime tstamp = JMAPICAL_DATETIME_INITIALIZER;
+        if (jmapical_utcdatetime_from_string(json_string_value(scheduleUpdated), &tstamp) >= 0) {
+            icaltimetype icaltstamp = jmapical_datetime_to_icaltime(&tstamp, utc);
+            char *tmp = icaltime_as_ical_string_r(icaltstamp);
+            set_icalxparam(prop, JMAPICAL_XPARAM_DTSTAMP, tmp, 0);
+            free(tmp);
+        }
+        else {
+            jmap_parser_invalid(parser, "scheduleSequence");
+        }
+    }
+    else if (JNOTNULL(scheduleUpdated)) {
+        jmap_parser_invalid(parser, "scheduleSequence");
+    }
+
+    /* participationComment */
+    json_t *jcomment = json_object_get(jpart, "participationComment");
+    if (json_is_string(jcomment)) {
+        const char *comment = json_string_value(jcomment);
+        if (*comment) {
+            set_icalxparam(prop, JMAPICAL_XPARAM_COMMENT, comment, 1);
+        }
+    }
+    else if (JNOTNULL(jcomment)) {
+        jmap_parser_invalid(parser, "participationComment");
+    }
+
+    if (is_orga) {
+        /* We might get away by not creating an ATTENDEE, if the
+         * participant is owner of the event and all its JSCalendar
+         * properties can be mapped to the ORGANIZER property. */
+        json_t *jorga = participant_from_icalorganizer(orga);
+        if (participant_equals(jorga, jpart)) {
+            icalproperty_free(prop);
+            prop = NULL;
+        }
+        json_decref(jorga);
+        if (!prop) return;
+    }
+
+    icalcomponent_add_property(comp, prop);
+}
+
+/* Create or update the ORGANIZER and ATTENDEEs in the VEVENT component comp as
+ * defined by the participants and replyTo property. */
+static void
+participants_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *event)
+{
+    /* Purge existing ATTENDEEs and ORGANIZER */
+    remove_icalprop(comp, ICAL_ATTENDEE_PROPERTY);
+    remove_icalprop(comp, ICAL_ORGANIZER_PROPERTY);
+
+    json_t *jval = NULL;
+    const char *key = NULL;
+
+    /* If participants are set, replyTo must be set */
+    json_t *replyTo = json_object_get(event, "replyTo");
+    if (JNOTNULL(replyTo) && !json_object_size(replyTo)) {
+        jmap_parser_invalid(parser, "replyTo");
+    }
+    json_t *participants = json_object_get(event, "participants");
+    if (JNOTNULL(participants) && !json_object_size(participants)) {
+        jmap_parser_invalid(parser, "participants");
+    }
+    if (JNOTNULL(replyTo) != JNOTNULL(participants)) {
+        jmap_parser_invalid(parser, "replyTo");
+        jmap_parser_invalid(parser, "participants");
+        return;
+    }
+    else if (!JNOTNULL(replyTo)) return;
+
+    /* OK, there's both replyTo and participants set. */
+
+    /* Parse replyTo */
+    jmap_parser_push(parser, "replyTo");
+    json_object_foreach(replyTo, key, jval) {
+        if (!is_valid_rsvpmethod(key) || !json_is_string(jval)) {
+            jmap_parser_invalid(parser, key);
+            continue;
+        }
+    }
+    jmap_parser_pop(parser);
+
+    /* Map participant ids to their iCalendar CALADDRESS */
+    hash_table caladdress_by_participant_id = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&caladdress_by_participant_id, json_object_size(participants)+1, 0);
+    json_object_foreach(participants, key, jval) {
+        if (!is_valid_jmapid(key)) continue;
+        char *caladdress = NULL;
+        json_t *sendTo = json_object_get(jval, "sendTo");
+        if (json_object_get(sendTo, "imip")) {
+            caladdress = xstrdup(json_string_value(json_object_get(sendTo, "imip")));
+        }
+        else if (json_object_get(sendTo, "other")) {
+            caladdress = xstrdup(json_string_value(json_object_get(sendTo, "other")));
+        }
+        else if (json_object_size(sendTo)) {
+            const char *anymethod = json_object_iter_key(json_object_iter(sendTo));
+            caladdress = xstrdup(json_string_value(json_object_get(sendTo, anymethod)));
+        }
+        else if (json_object_get(jval, "email")) {
+            caladdress = mailaddr_to_uri(json_string_value(json_object_get(jval, "email")));
+        }
+        if (!caladdress) continue; /* reported later as error */
+        hash_insert(key, caladdress, &caladdress_by_participant_id);
+    }
+
+    /* Pick the ORGANIZER URI */
+    const char *orga_method = NULL;
+    if (json_object_get(replyTo, "imip")) {
+        orga_method = "imip";
+    }
+    else if (json_object_get(replyTo, "other")) {
+        orga_method = "other";
+    }
+    else {
+        orga_method = json_object_iter_key(json_object_iter(replyTo));
+    }
+    const char *orga_uri = json_string_value(json_object_get(replyTo, orga_method));
+
+    /* Create the ORGANIZER property */
+    icalproperty *orga = icalproperty_new_organizer(orga_uri);
+    /* Keep track of the RSVP URIs and their method */
+    if (json_object_size(replyTo) > 1 || (strcmp(orga_method, "imip") && strcmp(orga_method, "other"))) {
+        struct buf buf = BUF_INITIALIZER;
+        json_object_foreach(replyTo, key, jval) {
+            buf_setcstr(&buf, key);
+            buf_putc(&buf, ':');
+            buf_appendcstr(&buf, json_string_value(jval));
+            set_icalxparam(orga, JMAPICAL_XPARAM_RSVP_URI, buf_cstring(&buf), 0);
+        }
+        buf_free(&buf);
+    }
+    icalcomponent_add_property(comp, orga);
+
+
+    /* Process participants */
+    jmap_parser_push(parser, "participants");
+    json_t *links = json_object_get(event, "links");
+    json_object_foreach(participants, key, jval) {
+        jmap_parser_push(parser, key);
+        if (!is_valid_jmapid(key)) {
+            jmap_parser_invalid(parser, NULL);
+            jmap_parser_pop(parser);
+            continue;
+        }
+
+        validate_type(parser, jval, "Participant");
+
+        const char *caladdress = hash_lookup(key, &caladdress_by_participant_id);
+        if (!caladdress) {
+            jmap_parser_invalid(parser, "sendTo");
+            jmap_parser_invalid(parser, "email");
+            jmap_parser_pop(parser);
+            continue;
+        }
+
+        /* Map participant to iCalendar */
+        participant_to_ical(comp, parser, key, jval, participants, links,
+                            orga_uri, &caladdress_by_participant_id);
+        jmap_parser_pop(parser);
+    }
+    jmap_parser_pop(parser);
+
+    free_hash_table(&caladdress_by_participant_id, free);
+}
+
+static int is_valid_regrel(const char *rel)
+{
+    // RFC 8288, section 3.3, reg-rel-type:
+    const char *p = rel;
+    while ((('a' <= *p) && (*p <= 'z')) ||
+           (('0' <= *p) && (*p <= '9')) ||
+           ((*p == '.') && p > rel) ||
+           ((*p == '-') && p > rel)) {
+        p++;
+    }
+    return *p == '\0' && p > rel;
+}
+
+static icalproperty* findprop_byid(icalcomponent *comp, const char *id,
+                                   icalproperty_kind kind)
+{
+    icalproperty *prop = NULL;
+    char *oldid = NULL;
+
+    for (prop = icalcomponent_get_first_property(comp, kind);
+         prop;
+         prop = icalcomponent_get_next_property(comp, kind)) {
+
+        oldid = xstrdupnull(get_icalxparam_value(prop, JMAPICAL_XPARAM_ID));
+        if (!oldid) oldid = sha1key(icalproperty_get_value_as_string(prop));
+        if (!strcmp(id, oldid)) break;
+    }
+
+    free(oldid);
+    return prop;
+}
+
+static void
+links_to_ical(icalcomponent *comp, icalcomponent *oldcomp,
+              struct jmap_parser *parser, json_t *links)
+{
+    icalproperty *prop;
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Purge existing attachments */
+    remove_icalprop(comp, ICAL_ATTACH_PROPERTY);
+    remove_icalprop(comp, ICAL_URL_PROPERTY);
+
+    jmap_parser_push(parser, "links");
+
+    const char *id;
+    json_t *link;
+    json_object_foreach(links, id, link) {
+        const char *href = NULL;
+        const char *contenttype = NULL;
+        const char *title = NULL;
+        const char *rel = NULL;
+        const char *cid = NULL;
+        const char *display = NULL;
+        json_int_t size = -1;
+        json_t *jprop = NULL;
+
+        jmap_parser_push(parser, id);
+        if (!is_valid_jmapid(id)) {
+            jmap_parser_invalid(parser, id);
+            jmap_parser_pop(parser);
+            continue;
+        }
+
+        validate_type(parser, link, "Link");
+
+        /* href */
+        href = json_string_value(json_object_get(link, "href"));
+        if (!href || !strlen(href)) {
+            jmap_parser_invalid(parser, "href");
+            href = NULL;
+        }
+
+        /* contentType */
+        jprop = json_object_get(link, "contentType");
+        if (json_is_string(jprop)) {
+            contenttype = json_string_value(jprop);
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "type");
+        }
+
+        /* title */
+        jprop = json_object_get(link, "title");
+        if (json_is_string(jprop)) {
+            title = json_string_value(jprop);
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "title");
+        }
+
+        /* cid */
+        jprop = json_object_get(link, "cid");
+        if (json_is_string(jprop)) {
+            cid = json_string_value(jprop);
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "cid");
+        }
+
+        /* display */
+        jprop = json_object_get(link, "display");
+        if (json_is_string(jprop)) {
+            display = json_string_value(jprop);
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "display");
+        }
+
+        /* rel */
+        jprop = json_object_get(link, "rel");
+        if (json_is_string(jprop)) {
+            rel = json_string_value(jprop);
+            if (!is_valid_regrel(rel)) {
+                jmap_parser_invalid(parser, "rel");
+            }
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "rel");
+        }
+
+        /* size */
+        jprop = json_object_get(link, "size");
+        if (json_is_integer(jprop)) {
+            size = json_integer_value(jprop);
+            if (size < 0) {
+                jmap_parser_invalid(parser, "size");
+            }
+        } else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "size");
+        }
+
+        jmap_parser_pop(parser);
+
+        if (href && !json_array_size(parser->invalid)) {
+
+            /* Make Link objects stick to their iCalendar type */
+            icalproperty_kind oldkind = ICAL_NO_PROPERTY;
+            if (oldcomp) {
+                /* XXX - A Link object that previously mapped to a URL
+                 * property again maps to a URL property in the
+                 * new component. That violates RFC 5545 and
+                 * RFC 7986 which both limit the number of URLs per
+                 * component to one. But the CalDAV client that
+                 * generated the previous component chose to not
+                 * conform to that requirement, so we stick to that. */
+                prop = findprop_byid(oldcomp, id, ICAL_URL_PROPERTY);
+                if (!prop) {
+                    prop = findprop_byid(oldcomp, id, ICAL_ATTACH_PROPERTY);
+                }
+                if (prop) {
+                    oldkind = icalproperty_isa(prop);
+                }
+            }
+            icalproperty_kind kind = oldkind;
+
+            /* Determine iCalendar type by Link properties */
+            if (kind == ICAL_NO_PROPERTY) {
+                if (!strcmpsafe(rel, "describedby") &&
+                    !cid && !contenttype && !display &&
+                    !icalcomponent_get_first_property(comp, ICAL_URL_PROPERTY)) {
+
+                    kind = ICAL_URL_PROPERTY;
+                }
+                else kind = ICAL_ATTACH_PROPERTY;
+            }
+
+            /* Build iCalendar property */
+            if (kind == ICAL_URL_PROPERTY) {
+                prop = icalproperty_new(ICAL_URL_PROPERTY);
+                icalproperty_set_value(prop, icalvalue_new_uri(href));
+            }
+            else {
+                icalattach *icalatt = icalattach_new_from_url(href);
+                prop = icalproperty_new_attach(icalatt);
+                icalattach_unref(icalatt);
+            }
+
+            /* contentType */
+            if (contenttype) {
+                icalproperty_add_parameter(prop,
+                        icalparameter_new_fmttype(contenttype));
+            }
+
+            /* rel */
+            if (rel && (kind != ICAL_URL_PROPERTY || strcmp(rel, "describedby")))
+                set_icalxparam(prop, JMAPICAL_XPARAM_REL, rel, 1);
+
+            /* title */
+            if (title) {
+                set_icalxparam(prop, JMAPICAL_XPARAM_TITLE, title, 1);
+            }
+
+            /* cid */
+            if (cid) set_icalxparam(prop, JMAPICAL_XPARAM_CID, cid, 1);
+
+            /* size */
+            if (size >= 0) {
+                buf_printf(&buf, "%"JSON_INTEGER_FORMAT, size);
+                icalproperty_add_parameter(prop,
+                        icalparameter_new_size(buf_cstring(&buf)));
+                buf_reset(&buf);
+            }
+
+            /* Set custom id */
+            set_icalxparam(prop, JMAPICAL_XPARAM_ID, id, 1);
+
+            /* display */
+            if (display) set_icalxparam(prop, JMAPICAL_XPARAM_DISPLAY, display, 1);
+
+            /* Add ATTACH property. */
+            icalcomponent_add_property(comp, prop);
+        }
+        buf_free(&buf);
+    }
+
+    jmap_parser_pop(parser);
+}
+
+static void
+description_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *jsevent)
+{
+    remove_icalprop(comp, ICAL_DESCRIPTION_PROPERTY);
+
+    const char *desc = NULL;
+
+    json_t *jprop = json_object_get(jsevent, "description");
+    if (json_is_string(jprop)) {
+        desc = json_string_value(jprop);
+    }
+    else if JNOTNULL(jprop) {
+        jmap_parser_invalid(parser, "description");
+    }
+
+    jprop = json_object_get(jsevent, "descriptionContentType");
+    if (json_is_string(jprop)) {
+        const char *content_type = json_string_value(jprop);
+        /* FIXME
+         * We'd like to support HTML descriptions, but with iCalendar being
+         * our storage format there really isn't a good way to deal with
+         * that. We can't rely on iCalendar clients correctly handling the
+         * ALTREP parameters on DESCRIPTION, and we don't want to make the
+         * CalDAV PUT code deal with comparing old vs new descriptions to
+         * try figuring out what the client did.
+         * This should become more sane to handle if we start using
+         * JSCalendar for storage.
+         */
+        if (content_type && strcasecmp(content_type, "TEXT/PLAIN")) {
+            jmap_parser_invalid(parser, "descriptionContentType");
+        }
+    }
+    else if JNOTNULL(jprop) {
+        jmap_parser_invalid(parser, "descriptionContentType");
+    }
+
+    if (desc && strlen(desc)) icalcomponent_set_description(comp, desc);
+}
+
+/* Create or update the VALARMs in the VEVENT component comp as defined by the
+ * JMAP alerts. */
+static void
+alerts_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *alerts)
+{
+    icalcomponent *alarm, *next;
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+
+    /* Purge all VALARMs. */
+    for (alarm = icalcomponent_get_first_component(comp, ICAL_VALARM_COMPONENT);
+         alarm;
+         alarm = next) {
+        next = icalcomponent_get_next_component(comp, ICAL_VALARM_COMPONENT);
+        icalcomponent_remove_component(comp, alarm);
+        icalcomponent_free(alarm);
+    }
+
+    if (!JNOTNULL(alerts)) {
+        return;
+    }
+
+    const char *id;
+    json_t *alert;
+    jmap_parser_push(parser, "alerts");
+    json_object_foreach(alerts, id, alert) {
+        icalproperty *prop;
+        icalparameter *param;
+
+        if (!is_valid_jmapid(id)) {
+            jmap_parser_invalid(parser, id);
+            continue;
+        }
+        jmap_parser_push(parser, id);
+
+        validate_type(parser, alert, "Alert");
+
+        alarm = icalcomponent_new_valarm();
+        icalcomponent_set_uid(alarm, id);
+
+        /* trigger */
+        struct icaltriggertype trigger = {
+            icaltime_null_time(), icaldurationtype_null_duration()
+        };
+        json_t *jtrigger = json_object_get(alert, "trigger");
+        if (json_is_object(jtrigger)) {
+            const char *triggertype = json_string_value(json_object_get(jtrigger, "@type"));
+            if (!strcmpsafe(triggertype, "OffsetTrigger")) {
+                jmap_parser_push(parser, "trigger");
+
+                /* offset */
+                struct jmapical_duration offset = JMAPICAL_DURATION_INITIALIZER;
+                json_t *joffset = json_object_get(jtrigger, "offset");
+                if (json_is_string(joffset)) {
+                    if (jmapical_duration_from_string(json_string_value(joffset), &offset) < 0) {
+                        jmap_parser_invalid(parser, "offset");
+                    }
+                } else {
+                    jmap_parser_invalid(parser, "offset");
+                }
+
+                /* relativeTo */
+                icalparameter_related rel = ICAL_RELATED_START;
+                json_t *jrelativeTo = json_object_get(jtrigger, "relativeTo");
+                if (json_is_string(jrelativeTo)) {
+                    const char *val = json_string_value(jrelativeTo);
+                    if (!strcmp(val, "start")) {
+                        rel = ICAL_RELATED_START;
+                    } else if (!strcmp(val, "end")) {
+                        rel = ICAL_RELATED_END;
+                    } else {
+                        jmap_parser_invalid(parser, "relativeTo");
+                    }
+                } else if (JNOTNULL(jrelativeTo)) {
+                    jmap_parser_invalid(parser, "relativeTo");
+                }
+
+                jmap_parser_pop(parser);
+
+                /* Add offset trigger */
+                trigger.duration = duration_to_icalduration(&offset);
+                prop = icalproperty_new_trigger(trigger);
+                subseconds_to_icalprop(prop, offset.nanos);
+                param = icalparameter_new_related(rel);
+                icalproperty_add_parameter(prop, param);
+                icalcomponent_add_property(alarm, prop);
+            }
+            else if (!strcmpsafe(triggertype, "AbsoluteTrigger")) {
+                jmap_parser_push(parser, "trigger");
+
+                json_t *jwhen = json_object_get(jtrigger, "when");
+                struct jmapical_datetime when = JMAPICAL_DATETIME_INITIALIZER;
+                if (json_is_string(jwhen) &&
+                    jmapical_utcdatetime_from_string(json_string_value(jwhen), &when) >= 0) {
+
+                    /* Add absolute trigger */
+                    trigger.time = jmapical_datetime_to_icaltime(&when, utc);
+                    prop = icalproperty_new_trigger(trigger);
+                    subseconds_to_icalprop(prop, when.nano);
+                    icalcomponent_add_property(alarm, prop);
+                }
+                else jmap_parser_invalid(parser, "when");
+
+                jmap_parser_pop(parser);
+            }
+            else {
+                /* XXX should preserve unknown triggers */
+            }
+        }
+        else jmap_parser_invalid(parser, "trigger");
+
+        /* acknowledged */
+        json_t *jacknowledged = json_object_get(alert, "acknowledged");
+        if (json_is_string(jacknowledged)) {
+            struct jmapical_datetime acktime = JMAPICAL_DATETIME_INITIALIZER;
+            if (jmapical_utcdatetime_from_string(json_string_value(jacknowledged), &acktime) >= 0) {
+                prop = icalproperty_new_acknowledged(jmapical_datetime_to_icaltime(&acktime, utc));
+                subseconds_to_icalprop(prop, acktime.nano);
+                icalcomponent_add_property(alarm, prop);
+            } else {
+                jmap_parser_invalid(parser, "acknowledged");
+            }
+        } else if (JNOTNULL(jacknowledged)) {
+            jmap_parser_invalid(parser, "acknowledged");
+        }
+
+        /* action */
+        icalproperty_action action = ICAL_ACTION_DISPLAY;
+        json_t *jaction = json_object_get(alert, "action");
+        if (json_is_string(jaction)) {
+            const char *val = json_string_value(jaction);
+            if (!strcmp(val, "email")) {
+                action = ICAL_ACTION_EMAIL;
+            } else if (!strcmp(val, "display")) {
+                action = ICAL_ACTION_DISPLAY;
+            } else {
+                jmap_parser_invalid(parser, "action");
+            }
+        } else if (JNOTNULL(jaction)) {
+            jmap_parser_invalid(parser, "action");
+        }
+        prop = icalproperty_new_action(action);
+        icalcomponent_add_property(alarm, prop);
+
+        /* relatedTo */
+        json_t *jrelatedto = json_object_get(alert, "relatedTo");
+        if (json_is_object(jrelatedto)) {
+            relatedto_to_ical(alarm, parser, jrelatedto);
+        }
+        else if (JNOTNULL(jrelatedto)) {
+            jmap_parser_invalid(parser, "relatedTo");
+        }
+
+        if (action == ICAL_ACTION_EMAIL) {
+            /* ATTENDEE */
+            const char *annotname = DAV_ANNOT_NS "<" XML_NS_CALDAV ">calendar-user-address-set";
+            char *mailboxname = caldav_mboxname(httpd_userid, NULL);
+            struct buf buf = BUF_INITIALIZER;
+            int r = annotatemore_lookupmask(mailboxname, annotname, httpd_userid, &buf);
+
+            char *recipient = NULL;
+
+            if (!r && buf_len(&buf)) {
+                strarray_t *values = strarray_split(buf_cstring(&buf), ",", STRARRAY_TRIM);
+                const char *item = strarray_nth(values, 0);
+                if (!strncasecmp(item, "mailto:", 7)) item += 7;
+                recipient = strconcat("mailto:", item, NULL);
+                strarray_free(values);
+            }
+            else if (strchr(httpd_userid, '@')) {
+                recipient = strconcat("mailto:", httpd_userid, NULL);
+            }
+            else {
+                recipient = strconcat("mailto:", httpd_userid, "@", config_defdomain, NULL);
+            }
+
+            icalcomponent_add_property(alarm, icalproperty_new_attendee(recipient));
+            free(recipient);
+
+            buf_free(&buf);
+            free(mailboxname);
+
+            /* SUMMARY */
+            const char *summary = icalcomponent_get_summary(comp);
+            if (!summary) summary = "Your event alert";
+            icalcomponent_add_property(alarm, icalproperty_new_summary(summary));
+        }
+
+        /* DESCRIPTION is required for both email and display */
+        const char *desc = icalcomponent_get_summary(comp);
+        if (!desc || *desc == '\0') desc = icalcomponent_get_description(comp);
+        if (!desc || *desc == '\0') desc = "reminder";
+        icalcomponent_add_property(alarm, icalproperty_new_description(desc));
+
+        icalcomponent_add_component(comp, alarm);
+        jmap_parser_pop(parser);
+    }
+    jmap_parser_pop(parser);
+
+}
+
+/* Convert and print the JMAP byX recurrence value to ical into buf, otherwise
+ * report the erroneous fieldName as invalid. If lower or upper is not NULL,
+ * make sure that every byX value is within these bounds. */
+static void recurrence_byX_to_ical(json_t *rrule,
+                                   struct jmap_parser *parser,
+                                   const char *fieldName,
+                                   struct buf *icalbuf,
+                                   const char *tag,
+                                   int lower,
+                                   int upper,
+                                   int allow_zero)
+{
+    json_t *byX = json_object_get(rrule, fieldName);
+    if (!json_array_size(byX)) {
+        if (JNOTNULL(byX) && !json_is_array(byX)) {
+            jmap_parser_invalid(parser, fieldName);
+        }
+        return;
+    }
+
+    /* Convert the array. */
+    buf_printf(icalbuf, ";%s=", tag);
+    size_t i;
+    for (i = 0; i < json_array_size(byX); i++) {
+        int val;
+        int err = json_unpack(json_array_get(byX, i), "i", &val);
+        if (!err && !allow_zero && !val) {
+            err = 1;
+        }
+        if (!err && ((lower != INT_MIN && val < lower) || (upper != INT_MAX && val > upper))) {
+            err = 2;
+        }
+        if (err) {
+            jmap_parser_push_index(parser, fieldName, i, NULL);
+            jmap_parser_invalid(parser, NULL);
+            jmap_parser_pop(parser);
+            continue;
+        }
+        /* Convert the byX value to ical. */
+        if (i) buf_printf(icalbuf, "%c", ',');
+        buf_printf(icalbuf, "%d", val);
+    }
+}
+
+/* Create or overwrite the RRULE in the VEVENT component comp as defined by the
+ * JMAP recurrence. */
+static void
+recurrence_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *rrule)
+{
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Purge existing RRULE. */
+    icalproperty *prop, *next;
+    for (prop = icalcomponent_get_first_property(comp, ICAL_RRULE_PROPERTY);
+         prop;
+         prop = next) {
+        next = icalcomponent_get_next_property(comp, ICAL_RRULE_PROPERTY);
+        icalcomponent_remove_property(comp, prop);
+        icalproperty_free(prop);
+    }
+    if (!JNOTNULL(rrule)) {
+        return;
+    }
+
+    jmap_parser_push(parser, "recurrenceRule");
+
+    validate_type(parser, rrule, "RecurrenceRule");
+
+    /* frequency */
+    const char *freq = NULL;
+    json_t *jprop = json_object_get(rrule, "frequency");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        if (!strcasecmp(val, "yearly") ||
+            !strcasecmp(val, "monthly") ||
+            !strcasecmp(val, "weekly") ||
+            !strcasecmp(val, "daily") ||
+            !strcasecmp(val, "hourly") ||
+            !strcasecmp(val, "minutely") ||
+            !strcasecmp(val, "secondly")) {
+            freq = val;
+        }
+    }
+    if (freq) {
+        buf_printf(&buf, "FREQ=%s", freq);
+    } else {
+        jmap_parser_invalid(parser, "frequency");
+    }
+
+    /* interval */
+    int interval = 1;
+    jprop = json_object_get(rrule, "interval");
+    if (json_is_integer(jprop)) {
+        interval = json_integer_value(jprop);
+        if (interval > 1) {
+            buf_printf(&buf, ";INTERVAL=%d", interval);
+        } else if (interval < 1) {
+            jmap_parser_invalid(parser, "interval");
+        }
+    }
+
+    /* skip */
+    char *skip = NULL;
+    jprop = json_object_get(rrule, "skip");
+    if (json_is_string(jprop)) {
+        skip = xstrdup(json_string_value(jprop));
+        ucase(skip);
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "skip");
+    }
+
+    /* rscale */
+    jprop = json_object_get(rrule, "rscale");
+    if (json_is_string(jprop)) {
+        char *rscale = xstrdup(json_string_value(jprop));
+        ucase(rscale);
+        /* Only include RSCALE/SKIP when required to not break legacy clients */
+        if (strcmp(rscale, "GREGORIAN") || (skip && strcmp(skip, "OMIT"))) {
+            buf_printf(&buf, ";RSCALE=%s", rscale);
+            if (skip) buf_printf(&buf, ";SKIP=%s", skip);
+        }
+        free(rscale);
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "rscale");
+    }
+    free(skip);
+
+    /* firstDayOfWeek */
+    jprop = json_object_get(rrule, "firstDayOfWeek");
+    if (json_is_string(jprop)) {
+        char *day = xstrdup(json_string_value(jprop));
+        ucase(day);
+        if (icalrecur_string_to_weekday(day) != ICAL_NO_WEEKDAY) {
+            buf_printf(&buf, ";WKST=%s", day);
+        } else {
+            jmap_parser_invalid(parser, "firstDayOfWeek");
+        }
+        free(day);
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "firstDayOfWeek");
+    }
+
+    /* byDay */
+    json_t *byday = json_object_get(rrule, "byDay");
+    if (json_array_size(byday) > 0) {
+        size_t i;
+        json_t *bd;
+
+        jmap_parser_push(parser, "byDay");
+        buf_appendcstr(&buf, ";BYDAY=");
+        json_array_foreach(byday, i, bd) {
+            char *day = NULL;
+            json_int_t nth = 0;
+            jmap_parser_push_index(parser, "byDay", i, NULL);
+
+            /* day */
+            day = xstrdupnull(json_string_value(json_object_get(bd, "day")));
+            if (day) {
+                ucase(day);
+                if (icalrecur_string_to_weekday(day) == ICAL_NO_WEEKDAY) {
+                    free(day);
+                    day = NULL;
+                }
+            }
+            if (!day) jmap_parser_invalid(parser, "day");
+
+            /* nthOfPeriod */
+            json_t *jnth = json_object_get(bd, "nthOfPeriod");
+            if (json_is_integer(jnth)) {
+                nth = json_integer_value(jnth);
+            }
+            else if (JNOTNULL(jnth)) {
+                jmap_parser_invalid(parser, "nthOfPeriod");
+            }
+
+            /* Append day */
+            if (!json_array_size(parser->invalid)) {
+                if (i > 0) buf_appendcstr(&buf, ",");
+                if (nth) buf_printf(&buf, "%+"JSON_INTEGER_FORMAT, nth);
+                buf_appendcstr(&buf, day);
+            }
+
+            free(day);
+            jmap_parser_pop(parser);
+        }
+    } else if (byday) {
+        jmap_parser_invalid(parser, "byDay");
+    }
+
+    /* byMonth */
+    json_t *bymonth = json_object_get(rrule, "byMonth");
+    if (json_is_array(bymonth)) {
+        size_t i;
+        json_t *jval;
+        buf_printf(&buf, ";BYMONTH=");
+        json_array_foreach(bymonth, i, jval) {
+            const char *s = json_string_value(jval);
+            jmap_parser_push_index(parser, "byMonth", i, NULL);
+            if (!s) {
+                jmap_parser_invalid(parser, NULL);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            int val;
+            char leap = 0, dummy = 0;
+            int matched = sscanf(s, "%2d%c%c", &val, &leap, &dummy);
+            if (matched < 1 || matched > 2 || (leap && leap != 'L') || val < 1) {
+                jmap_parser_invalid(parser, NULL);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            if (i) buf_putc(&buf, ',');
+            buf_printf(&buf, "%d", val);
+            if (leap) buf_putc(&buf, 'L');
+            jmap_parser_pop(parser);
+        }
+    }
+    else if (JNOTNULL(bymonth)) {
+        jmap_parser_invalid(parser, "byMonth");
+    }
+
+    /* byYearDay */
+    recurrence_byX_to_ical(rrule, parser, "byYearDay", &buf, "BYYEARDAY", -366, 366, 0);
+    /* byWeekNo */
+    recurrence_byX_to_ical(rrule, parser, "byWeekNo", &buf, "BYWEEKNO", -53, 53, 0);
+    /* byMonthDay */
+    recurrence_byX_to_ical(rrule, parser, "byMonthDay", &buf, "BYMONTHDAY", -31, 31, 0);
+    /* byHour */
+    recurrence_byX_to_ical(rrule, parser, "byHour", &buf, "BYHOUR", 0, 23, 1);
+    /* byMinute */
+    recurrence_byX_to_ical(rrule, parser, "byMinute", &buf, "BYMINUTE", 0, 59, 1);
+    /* bySecond */
+    recurrence_byX_to_ical(rrule, parser, "bySecond", &buf, "BYSECOND", 0, 59, 1);
+    /* bySetPosition */
+    recurrence_byX_to_ical(rrule, parser, "bySetPosition", &buf,"BYSETPOS", INT_MIN, INT_MAX, 1);
+
+    if (json_object_get(rrule, "count") && json_object_get(rrule, "until")) {
+        jmap_parser_invalid(parser, "count");
+        jmap_parser_invalid(parser, "until");
+    }
+
+    /* count */
+    jprop = json_object_get(rrule, "count");
+    if (json_is_integer(jprop)) {
+        int count = json_integer_value(jprop);
+        if (count > 0 && !json_object_get(rrule, "until")) {
+            buf_printf(&buf, ";COUNT=%d", count);
+        } else {
+            jmap_parser_invalid(parser, "count");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "count");
+    }
+
+    /* until */
+    jprop = json_object_get(rrule, "until");
+    if (json_is_string(jprop)) {
+        struct jmapical_datetime until = JMAPICAL_DATETIME_INITIALIZER;
+        if (jmapical_localdatetime_from_string(json_string_value(jprop), &until) >= 0) {
+            int is_date = icalcomponent_get_dtstart(comp).is_date;
+            icaltimezone *tzstart = tz_from_tzid(tzid_from_ical(comp, ICAL_DTSTART_PROPERTY));
+            icaltimetype untilutc;
+            /* XXX we don't set SUBSECOND on RRULEs, because clients such
+             * as iOS reject the whole RRULE for unknown rrule fields */
+            if (is_date) {
+                untilutc = jmapical_datetime_to_icaldate(&until);
+            }
+            else {
+                icaltimetype untillocal = jmapical_datetime_to_icaltime(&until, tzstart);
+                icaltimezone *utc = icaltimezone_get_utc_timezone();
+                untilutc = icaltime_convert_to_zone(untillocal, utc);
+            }
+            buf_printf(&buf, ";UNTIL=%s", icaltime_as_ical_string(untilutc));
+        } else {
+            jmap_parser_invalid(parser, "until");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "until");
+    }
+
+    if (!json_array_size(parser->invalid)) {
+        /* Add RRULE to component */
+        struct icalrecurrencetype rt =
+            icalrecurrencetype_from_string(buf_ucase(&buf));
+        if (rt.freq != ICAL_NO_RECURRENCE) {
+            icalcomponent_add_property(comp, icalproperty_new_rrule(rt));
+        } else {
+            syslog(LOG_ERR, "jmap_ical: generated bogus RRULE: %s", buf_cstring(&buf));
+            jmap_parser_invalid(parser, NULL);
+        }
+    }
+
+    jmap_parser_pop(parser);
+    buf_free(&buf);
+}
+
+/* Create or overwrite JMAP keywords in comp */
+static void
+keywords_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *keywords)
+{
+    icalproperty *prop, *next;
+
+    /* Purge existing keywords from component */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_CATEGORIES_PROPERTY);
+         prop;
+         prop = next) {
+
+        next = icalcomponent_get_next_property(comp, ICAL_CATEGORIES_PROPERTY);
+        icalcomponent_remove_property(comp, prop);
+        icalproperty_free(prop);
+    }
+
+    /* Add keywords */
+    json_t *jval;
+    const char *keyword;
+    json_object_foreach(keywords, keyword, jval) {
+        if (jval != json_true()) {
+            jmap_parser_push(parser, "keywords");
+            jmap_parser_invalid(parser, keyword);
+            jmap_parser_pop(parser);
+            continue;
+        }
+        // FIXME known bug: libical doesn't properly
+        // handle multi-values separated by comma,
+        // if a single entry contains a comma.
+        prop = icalproperty_new_categories(keyword);
+        icalcomponent_add_property(comp, prop);
+    }
+}
+
+/* Create or overwrite JMAP relatedTo in comp */
+static void
+relatedto_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *relatedTo)
+{
+    icalproperty *prop, *next;
+    icalparameter *param;
+
+    /* Purge existing relatedTo properties from component */
+    for (prop = icalcomponent_get_first_property(comp, ICAL_RELATEDTO_PROPERTY);
+         prop;
+         prop = next) {
+
+        next = icalcomponent_get_next_property(comp, ICAL_RELATEDTO_PROPERTY);
+        icalcomponent_remove_property(comp, prop);
+        icalproperty_free(prop);
+    }
+    if (relatedTo == NULL || relatedTo == json_null()) return;
+
+    /* Add relatedTo */
+    const char *uid = NULL;
+    json_t *relationObj = NULL;
+    jmap_parser_push(parser, "relatedTo");
+    json_object_foreach(relatedTo, uid, relationObj) {
+        jmap_parser_push(parser, uid);
+
+        validate_type(parser, relationObj, "Relation");
+
+        /* relation */
+        json_t *relation = json_object_get(relationObj, "relation");
+        if (json_object_size(relation)) {
+            prop = icalproperty_new_relatedto(uid);
+            json_t *jval;
+            const char *reltype;
+            jmap_parser_push(parser, "relation");
+            json_object_foreach(relation, reltype, jval) {
+                if (jval == json_true()) {
+                    char *s = ucase(xstrdup(reltype));
+                    param = icalparameter_new(ICAL_RELTYPE_PARAMETER);
+                    icalparameter_set_xvalue(param, s);
+                    icalproperty_add_parameter(prop, param);
+                    free(s);
+                }
+                else {
+                    jmap_parser_invalid(parser, reltype);
+                }
+            }
+            icalcomponent_add_property(comp, prop);
+            jmap_parser_pop(parser);
+        }
+        else if (json_is_object(relation) || relation == NULL || relation == json_null()) {
+            icalcomponent_add_property(comp, icalproperty_new_relatedto(uid));
+        }
+        else if (!json_is_object(relation)) {
+            jmap_parser_invalid(parser, "relation");
+        }
+
+        jmap_parser_pop(parser);
+    }
+    jmap_parser_pop(parser);
+}
+
+static int
+validate_location(json_t *loc, struct jmap_parser *parser, json_t *links)
+{
+    size_t invalid_cnt = json_array_size(parser->invalid);
+    json_t *jprop = NULL;
+    json_t *jtype = json_object_get(links, "@type");
+
+    validate_type(parser, loc, "Location");
+
+    /* At least one property other than rel MUST be set */
+    if ((json_object_size(loc) == 0) ||
+        (json_object_size(loc) == 1 && !JNOTNULL(jtype) &&
+         json_object_get(loc, "relativeTo")) ||
+        (json_object_size(loc) == 2 && JNOTNULL(jtype) &&
+         json_object_get(loc, "relativeTo"))) {
+        jmap_parser_invalid(parser, NULL);
+        return 0;
+    }
+
+    jprop = json_object_get(loc, "name");
+    if (JNOTNULL(jprop) && !json_is_string(jprop))
+        jmap_parser_invalid(parser, "name");
+
+    jprop = json_object_get(loc, "description");
+    if (JNOTNULL(jprop) && !json_is_string(jprop))
+        jmap_parser_invalid(parser, "description");
+
+    jprop = json_object_get(loc, "relativeTo");
+    if (JNOTNULL(jprop) && !json_is_string(jprop))
+        jmap_parser_invalid(parser, "relativeTo");
+
+    jprop = json_object_get(loc, "coordinates");
+    if (JNOTNULL(jprop) && !json_is_string(jprop))
+        jmap_parser_invalid(parser, "coordinates");
+
+    jprop = json_object_get(loc, "timeZone");
+    if (json_is_string(jprop)) {
+        if (!tz_from_tzid(json_string_value(jprop)))
+            jmap_parser_invalid(parser, "timeZone");
+    }
+    else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "timeZone");
+    }
+
+    /* linkIds */
+    const char *id;
+    json_t *jval;
+    json_t *linkids = json_object_get(loc, "linkIds");
+    if (JNOTNULL(linkids) && json_is_object(linkids)) {
+        jmap_parser_push(parser, "linkIds");
+        json_object_foreach(linkids, id, jval) {
+            if (!is_valid_jmapid(id) || !json_object_get(links, id) || jval != json_true()) {
+                jmap_parser_invalid(parser, id);
+            }
+        }
+        jmap_parser_pop(parser);
+    }
+    else if (JNOTNULL(linkids)) {
+        jmap_parser_invalid(parser, "linkIds");
+    }
+
+    /* Location is valid, if no invalid property has been added */
+    return json_array_size(parser->invalid) == invalid_cnt;
+}
+
+static void
+location_to_ical(icalcomponent *comp, const char *id, json_t *loc)
+{
+    const char *name = json_string_value(json_object_get(loc, "name"));
+    const char *rel = json_string_value(json_object_get(loc, "relativeTo"));
+
+    /* Gracefully handle bogus values */
+    if (rel && !strcmp(rel, "unknown")) rel = NULL;
+
+    /* Determine which property kind to use for this location.
+     * Always try to create at least one LOCATION, even if CONFERENCE
+     * would be more appropriate, to gracefully handle legacy clients. */
+    icalproperty *prop;
+    if (!icalcomponent_get_first_property(comp, ICAL_LOCATION_PROPERTY)) {
+        prop = icalproperty_new(ICAL_LOCATION_PROPERTY);
+    } else {
+        prop = icalproperty_new(ICAL_X_PROPERTY);
+        icalproperty_set_x_name(prop, JMAPICAL_XPROP_LOCATION);
+    }
+
+    /* Keep user-supplied location id */
+    xjmapid_to_ical(prop, id);
+
+    /* name, rel */
+    icalvalue *val = icalvalue_new_from_string(ICAL_TEXT_VALUE, name);
+    icalproperty_set_value(prop, val); // XXX doesn't support empty string
+    if (rel) set_icalxparam(prop, JMAPICAL_XPARAM_REL, rel, 0);
+
+    /* description, timeZone, coordinates */
+    const char *s = json_string_value(json_object_get(loc, "description"));
+    if (s) set_icalxparam(prop, JMAPICAL_XPARAM_DESCRIPTION, s, 0);
+    s = json_string_value(json_object_get(loc, "timeZone"));
+    if (s) set_icalxparam(prop, JMAPICAL_XPARAM_TZID, s, 0);
+    s = json_string_value(json_object_get(loc, "coordinates"));
+    if (s) set_icalxparam(prop, JMAPICAL_XPARAM_GEO, s, 0);
+
+    /* linkIds */
+    json_t *jval;
+    const char *key;
+    json_object_foreach(json_object_get(loc, "linkIds"), key, jval) {
+        set_icalxparam(prop, JMAPICAL_XPARAM_LINKID, key, 0);
+    }
+
+    icalcomponent_add_property(comp, prop);
+}
+
+/* Create or overwrite the JMAP locations in comp */
+static void
+locations_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *locations, json_t *links)
+{
+    json_t *loc;
+    const char *id;
+
+    /* Purge existing locations */
+    remove_icalprop(comp, ICAL_LOCATION_PROPERTY);
+    remove_icalprop(comp, ICAL_GEO_PROPERTY);
+    remove_icalxprop(comp, JMAPICAL_XPROP_LOCATION);
+    remove_icalxprop(comp, "X-APPLE-STRUCTURED-LOCATION");
+
+    /* Bail out if no location needs to be set */
+    if (!JNOTNULL(locations)) {
+        return;
+    }
+
+    /* Add locations */
+    jmap_parser_push(parser, "locations");
+    json_object_foreach(locations, id, loc) {
+        /* Validate the location id */
+        if (!is_valid_jmapid(id)) {
+            jmap_parser_invalid(parser, id);
+            continue;
+        }
+        jmap_parser_push(parser, id);
+        /* Validate and add location */
+        if (validate_location(loc, parser, links)) {
+            location_to_ical(comp, id, loc);
+        }
+        jmap_parser_pop(parser);
+    }
+    jmap_parser_pop(parser);
+}
+
+/* Create or overwrite the JMAP virtualLocations in comp */
+static void
+virtuallocations_to_ical(icalcomponent *comp, struct jmap_parser *parser, json_t *locations)
+{
+    json_t *loc;
+    const char *id;
+
+    remove_icalprop(comp, ICAL_CONFERENCE_PROPERTY);
+    if (!JNOTNULL(locations)) {
+        return;
+    }
+
+    jmap_parser_push(parser, "virtualLocations");
+    json_object_foreach(locations, id, loc) {
+        /* Validate the location id */
+        if (!is_valid_jmapid(id)) {
+            jmap_parser_invalid(parser, id);
+            continue;
+        }
+
+        jmap_parser_push(parser, id);
+
+        validate_type(parser, loc, "VirtualLocation");
+
+        icalproperty *prop = icalproperty_new(ICAL_CONFERENCE_PROPERTY);
+        xjmapid_to_ical(prop, id);
+
+        /* uri */
+        json_t *juri = json_object_get(loc, "uri");
+        if (json_is_string(juri)) {
+            const char *uri = json_string_value(juri);
+            icalvalue *val = icalvalue_new_from_string(ICAL_URI_VALUE, uri);
+            icalproperty_set_value(prop, val);
+        }
+        else {
+            jmap_parser_invalid(parser, "uri");
+        }
+
+        /* name */
+        json_t *jname = json_object_get(loc, "name");
+        if (json_is_string(juri)) {
+            const char *name = json_string_value(jname);
+            icalproperty_add_parameter(prop, icalparameter_new_label(name));
+        }
+        else {
+            jmap_parser_invalid(parser, "uri");
+        }
+
+
+        /* description */
+        json_t *jdescription = json_object_get(loc, "description");
+        if (json_is_string(jdescription)) {
+            const char *desc = json_string_value(jdescription);
+            set_icalxparam(prop, JMAPICAL_XPARAM_DESCRIPTION, desc, 0);
+        }
+        else if (JNOTNULL(jdescription)) {
+            jmap_parser_invalid(parser, "description");
+        }
+
+        icalcomponent_add_property(comp, prop);
+        jmap_parser_pop(parser);
+    }
+    jmap_parser_pop(parser);
+}
+
+static void set_language_icalprop(icalcomponent *comp, icalproperty_kind kind,
+                                  const char *lang)
+{
+    icalproperty *prop;
+    icalparameter *param;
+
+    prop = icalcomponent_get_first_property(comp, kind);
+    if (!prop) return;
+
+    icalproperty_remove_parameter_by_kind(prop, ICAL_LANGUAGE_PARAMETER);
+    if (!lang) return;
+
+    param = icalparameter_new(ICAL_LANGUAGE_PARAMETER);
+    icalparameter_set_language(param, lang);
+    icalproperty_add_parameter(prop, param);
+}
+
+static void
+overrides_to_ical(icalcomponent *comp, icalcomponent *oldical,
+                  struct jmap_parser *parser, json_t *overrides)
+{
+    icalcomponent *excomp, *next, *ical;
+
+    /* Purge EXDATE, RDATE */
+    remove_icalprop(comp, ICAL_RDATE_PROPERTY);
+    remove_icalprop(comp, ICAL_EXDATE_PROPERTY);
+
+    /* Remove existing VEVENT exceptions */
+    ical = icalcomponent_get_parent(comp);
+    for (excomp = icalcomponent_get_first_component(ical, ICAL_VEVENT_COMPONENT);
+         excomp;
+         excomp = next) {
+
+        next = icalcomponent_get_next_component(ical, ICAL_VEVENT_COMPONENT);
+        if (excomp == comp) continue;
+        icalcomponent_remove_component(ical, excomp);
+    }
+
+    if (json_is_null(overrides)) return;
+
+    /* Determine value type of main event DTSTART */
+    int is_date = icalcomponent_get_dtstart(comp).is_date;
+    icaltimezone *tzstart = tz_from_tzid(tzid_from_ical(comp, ICAL_DTSTART_PROPERTY));
+
+    /* Convert current master event to JMAP */
+    json_t *master = calendarevent_from_ical(comp, NULL, NULL);
+    if (!master) return;
+    json_object_del(master, "recurrenceRule");
+    json_object_del(master, "recurrenceOverrides");
+
+    jmap_parser_push(parser, "recurrenceOverrides");
+    json_t *joverride;
+    const char *recuridval;
+    json_object_foreach(overrides, recuridval, joverride) {
+        struct jmapical_datetime recurid = JMAPICAL_DATETIME_INITIALIZER;
+
+        if (jmapical_localdatetime_from_string(recuridval, &recurid) < 0) {
+            jmap_parser_invalid(parser, recuridval);
+            continue;
+        }
+        else if (is_date && !jmapical_datetime_has_zero_time(&recurid)) {
+            jmap_parser_invalid(parser, recuridval);
+            continue;
+        }
+
+        json_t *excluded = json_object_get(joverride, "excluded");
+        if (excluded == json_true()) {
+            if (json_object_size(joverride) == 1) {
+                /* Add EXDATE */
+                struct icaltimetype exdate = is_date ?
+                    jmapical_datetime_to_icaldate(&recurid) :
+                    jmapical_datetime_to_icaltime(&recurid, tzstart);
+                insert_icaltimeprop(comp, exdate, recurid.nano, 0, ICAL_EXDATE_PROPERTY);
+            }
+            else {
+                /* excluded overrides MUST NOT define any other property */
+                jmap_parser_invalid(parser, recuridval);
+            }
+        } else if (!json_object_size(joverride)) {
+            /* Add RDATE */
+            struct icaltimetype rdate = is_date ?
+                jmapical_datetime_to_icaldate(&recurid) :
+                jmapical_datetime_to_icaltime(&recurid, tzstart);
+            insert_icaltimeprop(comp, rdate, recurid.nano, 0, ICAL_RDATE_PROPERTY);
+        } else {
+            /* Add VEVENT exception */
+            json_t *myoverride = json_copy(joverride); // shallow copy
+
+            /* JMAP spec: "A pointer MUST NOT start with one of the following
+             * prefixes; any patch with a such a key MUST be ignored" */
+            const char *key;
+            json_t *jval;
+            json_object_foreach(joverride, key, jval) {
+                if (!strcmp(key, "@type") ||
+                    !strcmp(key, "uid") ||
+                    !strcmp(key, "relatedTo") ||
+                    !strcmp(key, "prodId") ||
+                    !strcmp(key, "method") ||
+                    !strcmp(key, "recurrenceId") ||
+                    !strcmp(key, "recurrenceRule") ||
+                    !strcmp(key, "recurrenceOverrides") ||
+                    !strcmp(key, "replyTo") ||
+                    !strcmp(key, "participantId")) {
+
+                    json_object_del(myoverride, key);
+                }
+            }
+            if (!json_object_size(myoverride)) {
+                json_decref(myoverride);
+                continue;
+            }
+
+            /* If the override doesn't have a custom start date, use
+             * the LocalDate in the recurrenceOverrides object key */
+            if (!json_object_get(myoverride, "start")) {
+                json_object_set_new(myoverride, "start", json_string(recuridval));
+            }
+
+            /* Create overridden event from patch and master event */
+            json_t *ex;
+            if (!(ex = jmap_patchobject_apply(master, myoverride, NULL))) {
+                jmap_parser_invalid(parser, recuridval);
+                json_decref(myoverride);
+                continue;
+            }
+
+            /* Create a new VEVENT for this override */
+            excomp = icalcomponent_new_vevent();
+            struct icaltimetype icalrecurid = is_date ?
+                jmapical_datetime_to_icaldate(&recurid) :
+                jmapical_datetime_to_icaltime(&recurid, tzstart);
+            insert_icaltimeprop(excomp, icalrecurid, recurid.nano, 1, ICAL_RECURRENCEID_PROPERTY);
+            icalcomponent_set_uid(excomp, icalcomponent_get_uid(comp));
+
+            /* Convert the override event to iCalendar */
+            jmap_parser_push(parser, recuridval);
+            /* recurrenceId */
+            json_t *jrecurrenceId = json_object_get(myoverride, "recurrenceId");
+            if (json_is_string(jrecurrenceId)) {
+                const char *val = json_string_value(jrecurrenceId);
+                struct jmapical_datetime dt = JMAPICAL_DATETIME_INITIALIZER;
+                if (jmapical_localdatetime_from_string(val, &dt) < 0 ||
+                    jmapical_datetime_compare(&dt, &recurid) != 0) {
+                    jmap_parser_invalid(parser, "recurrenceId");
+                }
+            }
+            else if (jrecurrenceId) {
+                jmap_parser_invalid(parser, "recurrenceId");
+            }
+            calendarevent_to_ical(excomp, oldical, parser, ex);
+            jmap_parser_pop(parser);
+
+            /* Add the exception */
+            icalcomponent_add_component(ical, excomp);
+            json_decref(ex);
+            json_decref(myoverride);
+        }
+    }
+    jmap_parser_pop(parser);
+
+    json_decref(master);
+}
+
+/* Create or overwrite the iCalendar properties in VEVENT comp based on the
+ * properties the JMAP calendar event. This writes a *complete* jsevent and
+ * does not implement patch object semantics.
+ */
+static void
+calendarevent_to_ical(icalcomponent *comp, icalcomponent *oldical,
+                      struct jmap_parser *parser, json_t *event)
+{
+    icalproperty *prop = NULL;
+    icaltimezone *utc = icaltimezone_get_utc_timezone();
+    icalcomponent *oldcomp = NULL;
+
+    /* Caller must set UID and RECURRENCEID in iCalendar */
+    const char *uid = icalcomponent_get_uid(comp);
+    if (!uid) {
+        jmap_parser_invalid(parser, "uid");
+        return;
+    }
+    int is_exc = icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY) != NULL;
+
+    /* Locate previous version of this component, if any */
+    if (oldical) {
+        char *recurid = NULL;
+        if ((prop = icalcomponent_get_first_property(comp, ICAL_RECURRENCEID_PROPERTY)))  {
+            icaltimetype recuridt = icalcomponent_get_recurrenceid(comp);
+            recurid = icaltime_as_ical_string_r(recuridt);
+        }
+        /* Lookup main VEVENT in old component */
+        icalcomponent *maincomp = NULL;
+        icalcomponent *tmp;
+        for (tmp = icalcomponent_get_first_component(oldical, ICAL_VEVENT_COMPONENT);
+             tmp && !maincomp;
+             tmp = icalcomponent_get_next_component(oldical, ICAL_VEVENT_COMPONENT)) {
+
+            if (strcmpsafe(uid, icalcomponent_get_uid(tmp))) continue;
+
+            if (!icalcomponent_get_first_property(tmp, ICAL_RECURRENCEID_PROPERTY)) {
+                maincomp = tmp;
+            }
+        }
+        if (recurid) {
+            /* Lookup VEVENT exception in old component, if any */
+            for (tmp = icalcomponent_get_first_component(oldical, ICAL_VEVENT_COMPONENT);
+                 tmp && !oldcomp;
+                 tmp = icalcomponent_get_next_component(oldical, ICAL_VEVENT_COMPONENT)) {
+
+                if (strcmpsafe(uid, icalcomponent_get_uid(tmp))) continue;
+
+                if (icalcomponent_get_first_property(tmp, ICAL_RECURRENCEID_PROPERTY)) {
+                    icaltimetype tmprecuridt = icalcomponent_get_recurrenceid(tmp);
+                    char *tmprecurid = icaltime_as_ical_string_r(tmprecuridt);
+                    if (!strcmpsafe(recurid, tmprecurid)) {
+                        oldcomp = tmp;
+                    }
+                    free(tmprecurid);
+                }
+            }
+        }
+        if (!oldcomp) oldcomp = maincomp;
+        free(recurid);
+    }
+
+    json_t *jprop = json_object_get(event, "excluded");
+    if (jprop && jprop != json_false()) {
+        jmap_parser_invalid(parser, "excluded");
+    }
+
+    jprop = json_object_get(event, "@type");
+    if (JNOTNULL(jprop) && json_is_string(jprop)) {
+        if (strcmp(json_string_value(jprop), "jsevent")) {
+            jmap_parser_invalid(parser, "@type");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "@type");
+    }
+
+    /* start, duration, timeZone */
+    startend_to_ical(comp, parser, event);
+
+    /* excluded - validate, but ignore */
+    jprop = json_object_get(event, "excluded");
+    if (jprop && !json_is_boolean(jprop)) {
+        jmap_parser_invalid(parser, "excluded");
+    }
+
+    /* relatedTo */
+    jprop = json_object_get(event, "relatedTo");
+    if (json_is_null(jprop) || json_object_size(jprop)) {
+        relatedto_to_ical(comp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "relatedTo");
+    }
+
+    /* sequence */
+    jprop = json_object_get(event, "sequence");
+    if (json_is_integer(jprop)) {
+        json_int_t val = json_integer_value(jprop);
+        if (val >= 0 && val <= INT_MAX) {
+            icalcomponent_set_sequence(comp, (int)val);
+        }
+        else jmap_parser_invalid(parser, "sequence");
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "sequence");
+    }
+
+    /* prodId */
+    if (!is_exc) {
+        struct buf buf = BUF_INITIALIZER;
+        const char *prod_id = NULL;
+
+        jprop = json_object_get(event, "prodId");
+        if (json_is_string(jprop)) {
+            prod_id = json_string_value(jprop);
+        }
+        else if (JNOTNULL(jprop)) {
+            jmap_parser_invalid(parser, "prodId");
+        }
+
+        if (!prod_id) {
+            /* Use same product id like jcal.c */
+            buf_setcstr(&buf, "-//CyrusIMAP.org/Cyrus ");
+            buf_appendcstr(&buf, CYRUS_VERSION);
+            buf_appendcstr(&buf, "//EN");
+            prod_id = buf_cstring(&buf);
+        }
+        /* Set PRODID in the VCALENDAR */
+        icalcomponent *ical = icalcomponent_get_parent(comp);
+        remove_icalprop(ical, ICAL_PRODID_PROPERTY);
+        prop = icalproperty_new_prodid(prod_id);
+        icalcomponent_add_property(ical, prop);
+        buf_free(&buf);
+    }
+
+    /* created */
+    jprop = json_object_get(event, "created");
+    if (json_is_string(jprop)) {
+        struct jmapical_datetime tstamp = JMAPICAL_DATETIME_INITIALIZER;
+        if (jmapical_utcdatetime_from_string(json_string_value(jprop), &tstamp) >= 0) {
+            icaltimetype dt = jmapical_datetime_to_icaltime(&tstamp, utc);
+            insert_icaltimeprop(comp, dt, tstamp.nano, 1, ICAL_CREATED_PROPERTY);
+        }
+        else {
+            jmap_parser_invalid(parser, "created");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "created");
+    }
+
+    /* updated */
+    jprop = json_object_get(event, "updated");
+    if (json_is_string(jprop)) {
+        struct jmapical_datetime tstamp = JMAPICAL_DATETIME_INITIALIZER;
+        if (jmapical_utcdatetime_from_string(json_string_value(jprop), &tstamp) >= 0) {
+            icaltimetype dt = jmapical_datetime_to_icaltime(&tstamp, utc);
+            insert_icaltimeprop(comp, dt, tstamp.nano, 1, ICAL_DTSTAMP_PROPERTY);
+        }
+        else {
+            jmap_parser_invalid(parser, "updated");
+        }
+    } else if (jprop == NULL) {
+        icaltimetype now = \
+            icaltime_current_time_with_zone(icaltimezone_get_utc_timezone());
+        insert_icaltimeprop(comp, now, 0, 1, ICAL_DTSTAMP_PROPERTY);
+    } else {
+        jmap_parser_invalid(parser, "updated");
+    }
+
+    jprop = json_object_get(event, "priority");
+    if (json_integer_value(jprop) >= 0 || json_integer_value(jprop) <= 9) {
+        remove_icalprop(comp, ICAL_PRIORITY_PROPERTY);
+        prop = icalproperty_new_priority(json_integer_value(jprop));
+        icalcomponent_add_property(comp, prop);
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "priority");
+    }
+
+    /* title */
+    jprop = json_object_get(event, "title");
+    if (json_is_string(jprop)) {
+        const char *summary = json_string_value(jprop);
+        if (strlen(summary)) icalcomponent_set_summary(comp, summary);
+    }
+    else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "title");
+    }
+
+    /* description and descriptionContentType */
+    description_to_ical(comp, parser, event);
+
+    /* method */
+    jprop = json_object_get(event, "method");
+    if (json_is_string(jprop)) {
+        const char *method = json_string_value(jprop);
+        icalproperty_method icalmethod = icalenum_string_to_method(method);
+        if (icalmethod != ICAL_METHOD_NONE && !is_exc) {
+            icalcomponent *ical = icalcomponent_get_parent(comp);
+            icalcomponent_set_method(ical, icalmethod);
+        }
+        else {
+            jmap_parser_invalid(parser, "method");
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "method");
+    }
+
+    /* color */
+    jprop = json_object_get(event, "color");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        if (strlen(val)) {
+            prop = icalproperty_new_color(val);
+            icalcomponent_add_property(comp, prop);
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "color");
+    }
+
+    /* keywords */
+    jprop = json_object_get(event, "keywords");
+    if (json_is_null(jprop) || json_is_object(jprop)) {
+        keywords_to_ical(comp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "keywords");
+    }
+
+    /* links */
+    jprop = json_object_get(event, "links");
+    if (json_is_null(jprop) || json_object_size(jprop)) {
+        links_to_ical(comp, oldcomp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "links");
+    }
+
+    /* locale */
+    jprop = json_object_get(event, "locale");
+    if (json_is_string(jprop)) {
+        set_language_icalprop(comp, ICAL_SUMMARY_PROPERTY, NULL);
+        set_language_icalprop(comp, ICAL_DESCRIPTION_PROPERTY, NULL);
+        const char *val = json_string_value(jprop);
+        if (strlen(val)) {
+            set_language_icalprop(comp, ICAL_SUMMARY_PROPERTY, val);
+        }
+    } else if (json_is_null(jprop)) {
+        set_language_icalprop(comp, ICAL_SUMMARY_PROPERTY, NULL);
+        set_language_icalprop(comp, ICAL_DESCRIPTION_PROPERTY, NULL);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "locale");
+    }
+
+    /* locations */
+    jprop = json_object_get(event, "locations");
+    if (json_is_null(jprop) || json_object_size(jprop)) {
+        json_t *links = json_object_get(event, "links");
+        locations_to_ical(comp, parser, jprop, links);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "locations");
+    }
+
+    /* virtualLocations */
+    jprop = json_object_get(event, "virtualLocations");
+    if (json_is_null(jprop) || json_object_size(jprop)) {
+        virtuallocations_to_ical(comp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "virtualLocations");
+    }
+
+    /* recurrenceRule */
+    jprop = json_object_get(event, "recurrenceRule");
+    if (json_is_null(jprop) || json_is_object(jprop)) {
+        if (!is_exc) recurrence_to_ical(comp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "recurrenceRule");
+    }
+
+    /* status */
+    enum icalproperty_status status = ICAL_STATUS_NONE;
+    jprop = json_object_get(event, "status");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        if (!strcmp(val, "confirmed")) {
+            status = ICAL_STATUS_CONFIRMED;
+        } else if (!strcmp(val, "cancelled")) {
+            status = ICAL_STATUS_CANCELLED;
+        } else if (!strcmp(val, "tentative")) {
+            status = ICAL_STATUS_TENTATIVE;
+        } else {
+            jmap_parser_invalid(parser, "status");
+        }
+    } else if (json_is_null(jprop) || !jprop) {
+        status = ICAL_STATUS_CONFIRMED;
+    } else {
+        jmap_parser_invalid(parser, "status");
+    }
+    if (status != ICAL_STATUS_NONE) {
+        remove_icalprop(comp, ICAL_STATUS_PROPERTY);
+        icalcomponent_set_status(comp, status);
+    }
+
+    /* freeBusyStatus */
+    jprop = json_object_get(event, "freeBusyStatus");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        enum icalproperty_transp v = ICAL_TRANSP_NONE;
+        if (!strcmp(val, "free")) {
+            v = ICAL_TRANSP_TRANSPARENT;
+        } else if (!strcmp(val, "busy")) {
+            v = ICAL_TRANSP_OPAQUE;
+        } else {
+            jmap_parser_invalid(parser, "freeBusyStatus");
+        }
+        if (v != ICAL_TRANSP_NONE) {
+            prop = icalcomponent_get_first_property(comp, ICAL_TRANSP_PROPERTY);
+            if (prop) {
+                icalproperty_set_transp(prop, v);
+            } else {
+                icalcomponent_add_property(comp, icalproperty_new_transp(v));
+            }
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "freeBusyStatus");
+    }
+
+    /* privacy */
+    jprop = json_object_get(event, "privacy");
+    if (json_is_string(jprop)) {
+        const char *val = json_string_value(jprop);
+        enum icalproperty_class v = ICAL_CLASS_NONE;
+        if (!strcmp(val, "public")) {
+            v = ICAL_CLASS_PUBLIC;
+        } else if (!strcmp(val, "private")) {
+            v = ICAL_CLASS_PRIVATE;
+        } else if (!strcmp(val, "secret")) {
+            v = ICAL_CLASS_CONFIDENTIAL;
+        } else {
+            jmap_parser_invalid(parser, "privacy");
+        }
+        if (v != ICAL_CLASS_NONE) {
+            prop = icalcomponent_get_first_property(comp, ICAL_CLASS_PROPERTY);
+            if (prop) {
+                icalproperty_set_class(prop, v);
+            } else {
+                icalcomponent_add_property(comp, icalproperty_new_class(v));
+            }
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "privacy");
+    }
+
+    /* replyTo and participants */
+    participants_to_ical(comp, parser, event);
+
+    /* participantId: readonly */
+
+    /* useDefaultAlerts */
+    jprop = json_object_get(event, "useDefaultAlerts");
+    if (json_is_boolean(jprop)) {
+        remove_icalxprop(comp, JMAPICAL_XPROP_USEDEFALERTS);
+        if (json_boolean_value(jprop)) {
+            icalvalue *icalval = icalvalue_new_boolean(1);
+            prop = icalproperty_new(ICAL_X_PROPERTY);
+            icalproperty_set_x_name(prop, JMAPICAL_XPROP_USEDEFALERTS);
+            icalproperty_set_value(prop, icalval);
+            icalcomponent_add_property(comp, prop);
+        }
+    } else if (JNOTNULL(jprop)) {
+        jmap_parser_invalid(parser, "useDefaultAlerts");
+    }
+
+    /* alerts */
+    jprop = json_object_get(event, "alerts");
+    if (json_is_null(jprop) || json_object_size(jprop)) {
+        alerts_to_ical(comp, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "alerts");
+    }
+
+    /* recurrenceOverrides - must be last to apply patches */
+    jprop = json_object_get(event, "recurrenceOverrides");
+    if (json_is_null(jprop) || json_is_object(jprop)) {
+        overrides_to_ical(comp, oldical, parser, jprop);
+    } else if (jprop) {
+        jmap_parser_invalid(parser, "recurrenceOverrides");
+    }
+}
+
+icalcomponent*
+jmapical_toical(json_t *jsevent, icalcomponent *oldical, json_t *invalid)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    icalcomponent *ical = NULL;
+
+    /* uid */
+    const char *uid = json_string_value(json_object_get(jsevent, "uid"));
+    if (uid) {
+        /* Create a new VCALENDAR. */
+        ical = icalcomponent_new_vcalendar();
+        icalcomponent_add_property(ical, icalproperty_new_version("2.0"));
+        icalcomponent_add_property(ical, icalproperty_new_calscale("GREGORIAN"));
+
+        /* Create a new VEVENT. */
+        icaltimezone *utc = icaltimezone_get_utc_timezone();
+        struct icaltimetype now =
+            icaltime_from_timet_with_zone(time(NULL), 0, utc);
+        icalcomponent *comp = icalcomponent_new_vevent();
+        icalcomponent_set_uid(comp, uid);
+        icalcomponent_set_sequence(comp, 0);
+        icalcomponent_set_dtstamp(comp, now);
+        icalcomponent_add_property(comp, icalproperty_new_created(now));
+        icalcomponent_add_component(ical, comp);
+
+        /* Convert the JMAP calendar event to ical. */
+        calendarevent_to_ical(comp, oldical, &parser, jsevent);
+        icalcomponent_add_required_timezones(ical);
+    }
+    else jmap_parser_invalid(&parser, "uid");
+
+    /* Report any property errors. */
+    if (json_array_size(parser.invalid)) {
+        if (invalid) json_array_extend(invalid, parser.invalid);
+        if (ical) icalcomponent_free(ical);
+        ical = NULL;
+    }
+
+    jmap_parser_fini(&parser);
+    return ical;
+}
+
+const char *
+jmapical_strerror(int err)
+{
+    switch (err) {
+        case 0:
+            return "jmapical: success";
+        case JMAPICAL_ERROR_CALLBACK:
+            return "jmapical: callback error";
+        case JMAPICAL_ERROR_MEMORY:
+            return "jmapical: no memory";
+        case JMAPICAL_ERROR_ICAL:
+            return "jmapical: iCalendar error";
+        case JMAPICAL_ERROR_PROPS:
+            return "jmapical: property error";
+        case JMAPICAL_ERROR_UID:
+            return "jmapical: iCalendar uid error";
+        default:
+            return "jmapical: unknown error";
+    }
+}
+
+/*
+ * Construct a jevent string for an iCalendar component.
+ */
+EXPORTED struct buf *icalcomponent_as_jevent_string(icalcomponent *ical)
+{
+    struct buf *ret;
+    json_t *jcal;
+    size_t flags = JSON_PRESERVE_ORDER;
+    char *buf;
+
+    if (!ical) return NULL;
+
+    jcal = jmapical_tojmap(ical, NULL);
+
+    flags |= (config_httpprettytelemetry ? JSON_INDENT(2) : JSON_COMPACT);
+    buf = json_dumps(jcal, flags);
+
+    json_decref(jcal);
+
+    ret = buf_new();
+    buf_initm(ret, buf, strlen(buf));
+
+    return ret;
+}
+
+EXPORTED icalcomponent *jevent_string_as_icalcomponent(const struct buf *buf)
+{
+    json_t *obj;
+    json_error_t jerr;
+    icalcomponent *ical;
+    const char *str = buf_cstring(buf);
+
+    if (!str) return NULL;
+
+    obj = json_loads(str, 0, &jerr);
+    if (!obj) {
+        syslog(LOG_WARNING, "json parse error: '%s'", jerr.text);
+        return NULL;
+    }
+
+    ical = jmapical_toical(obj, NULL, NULL);
+
+    json_decref(obj);
+
+    return ical;
+}
diff -pruN 3.0.13-5/imap/jmap_ical.h 3.2.0-3/imap/jmap_ical.h
--- 3.0.13-5/imap/jmap_ical.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_ical.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,185 @@
+/* jmap_ical.h --Routines to convert JMAP calendar events and iCalendar
+ *
+ * Copyright (c) 1994-2016 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef JMAPICAL_H
+#define JMAPICAL_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <jansson.h>
+#include <libical/ical.h>
+
+#define JMAPICAL_ERROR_UNKNOWN  -1
+#define JMAPICAL_ERROR_CALLBACK 1
+#define JMAPICAL_ERROR_MEMORY   2
+#define JMAPICAL_ERROR_ICAL     3
+#define JMAPICAL_ERROR_PROPS    4
+#define JMAPICAL_ERROR_UID      5
+
+/* Custom iCalendar properties */
+#define JMAPICAL_XPROP_LOCATION      "X-JMAP-LOCATION"
+/* FIXME libical doesn't parse USEDEFAULTALERTS, must use X-prefix */
+#define JMAPICAL_XPROP_USEDEFALERTS  "X-JMAP-USEDEFAULTALERTS"
+
+/* Custom iCalendar parameters */
+#define JMAPICAL_XPARAM_CID           "X-JMAP-CID"
+#define JMAPICAL_XPARAM_DESCRIPTION   "X-JMAP-DESCRIPTION"
+#define JMAPICAL_XPARAM_DISPLAY       "X-JMAP-DISPLAY"
+#define JMAPICAL_XPARAM_FEATURE       "X-JMAP-FEATURE"
+#define JMAPICAL_XPARAM_GEO           "X-JMAP-GEO"
+#define JMAPICAL_XPARAM_ID            "X-JMAP-ID"
+#define JMAPICAL_XPARAM_LINKID        "X-JMAP-LINKID"
+#define JMAPICAL_XPARAM_LOCATIONID    "X-JMAP-LOCATIONID"
+#define JMAPICAL_XPARAM_NAME          "X-JMAP-NAME"
+#define JMAPICAL_XPARAM_REL           "X-JMAP-REL"
+#define JMAPICAL_XPARAM_ROLE          "X-JMAP-ROLE"
+#define JMAPICAL_XPARAM_RSVP_URI      "X-JMAP-RSVP-URI"
+#define JMAPICAL_XPARAM_TZID          "X-JMAP-TZID"
+
+#define JMAPICAL_XPARAM_DTSTAMP       "X-DTSTAMP" /* used for iMIP ATTENDEE replies */
+#define JMAPICAL_XPARAM_SEQUENCE      "X-SEQUENCE" /*used for iMIP ATTENDEE replies */
+#define JMAPICAL_XPARAM_COMMENT       "X-COMMENT" /*used for iMIP ATTENDEE replies */
+#define JMAPICAL_XPARAM_TITLE         "X-TITLE" /* Apple uses that for locations */
+
+
+/* Converts the iCalendar component ical to JSCalendar.
+ * Returns NULL on error.
+ */
+json_t* jmapical_tojmap(icalcomponent *ical, hash_table *props);
+
+/* Converts the iCalendar component ical to an array of JSCalendar objects.
+ * Returns NULL on error.
+ */
+json_t *jmapical_tojmap_all(icalcomponent *ical, hash_table *props);
+
+/* Convert the jsevent to iCalendar.
+ * The oldical argument points to the previous VCALENDAR of the event,
+ * or NULL.
+ * Returns a new ical component, or NULL on error.
+ */
+icalcomponent* jmapical_toical(json_t *jsevent, icalcomponent *oldical,
+                               json_t *invalid);
+void icalcomponent_add_required_timezones(icalcomponent *ical);
+
+/* for CalDAV content negotiation */
+struct buf *icalcomponent_as_jevent_string(icalcomponent *ical);
+icalcomponent *jevent_string_as_icalcomponent(const struct buf *buf);
+
+/* Base type for JSCalendar LocalDateTime and UTCDateTime */
+
+struct jmapical_datetime {
+    int year;
+    int month; // Jan=1
+    int day;
+    int hour;
+    int minute;
+    int second;
+    bit64 nano;
+};
+
+#define JMAPICAL_DATETIME_INITIALIZER { 0, 0, 0, 0, 0, 0, 0 };
+
+/* True if all components are zero */
+extern int jmapical_datetime_has_zero_time(const struct jmapical_datetime *dt);
+
+/* Convert DateTime to ical date, truncating time components */
+extern struct icaltimetype jmapical_datetime_to_icaldate(const struct jmapical_datetime *dt);
+
+/* Convert DateTime to ical time, truncating subseconds */
+extern icaltimetype jmapical_datetime_to_icaltime(const struct jmapical_datetime *dt,
+                                                  const icaltimezone* zone);
+
+/* Convert ical time to DateTime with zero subseconds  */
+extern void jmapical_datetime_from_icaltime(icaltimetype icaldt, struct jmapical_datetime *dt);
+
+/* Compare DateTime a and b, using semantics suitable for qsort */
+extern int jmapical_datetime_compare(const struct jmapical_datetime *a,
+                                     const struct jmapical_datetime *b);
+
+/* Convert icaltime value and subseconds parameter to DateTime */
+extern int jmapical_datetime_from_icalprop(icalproperty *prop, struct jmapical_datetime *dt);
+
+/* JSCalendar LocalDateTime */
+extern void jmapical_localdatetime_as_string(const struct jmapical_datetime *dt, struct buf *dst);
+extern int jmapical_localdatetime_from_string(const char *val, struct jmapical_datetime *dt);
+
+/* JSCalendar UTCDateTime */
+extern void jmapical_utcdatetime_as_string(const struct jmapical_datetime *dt, struct buf *dst);
+extern int jmapical_utcdatetime_from_string(const char *val, struct jmapical_datetime *dt);
+
+/* JSCalendar Duration */
+
+struct jmapical_duration {
+    int is_neg;
+    unsigned int days;
+    unsigned int weeks;
+    unsigned int hours;
+    unsigned int minutes;
+    unsigned int seconds;
+    bit64 nanos;
+};
+
+#define JMAPICAL_DURATION_INITIALIZER { 0, 0, 0, 0, 0, 0, 0 }
+
+/* True if all components are zero */
+extern int jmapical_duration_has_zero_time(const struct jmapical_duration *dur);
+
+/* Convert ical duration to Duration with zero subseconds */
+extern void jmapical_duration_from_icalduration(struct icaldurationtype icaldur,
+                                                struct jmapical_duration *dur);
+
+/* Calculate time-range between t1 and t2 into Duration dur */
+extern void jmapical_duration_between(time_t t1, bit64 t1nanos,
+                                      time_t t2, bit64 t2nanos,
+                                      struct jmapical_duration *dur);
+
+extern void jmapical_duration_as_string(const struct jmapical_duration *dur, struct buf *buf);
+extern int jmapical_duration_from_string(const char *val, struct jmapical_duration *dur);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif 
diff -pruN 3.0.13-5/imap/jmap_mailbox.c 3.2.0-3/imap/jmap_mailbox.c
--- 3.0.13-5/imap/jmap_mailbox.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mailbox.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,3674 @@
+/* jmap_mailbox.c -- Routines for handling JMAP Mailboxes messages
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+
+#include "acl.h"
+#include "annotate.h"
+#include "bsearch.h"
+#include "cyr_qsort_r.h"
+#include "http_jmap.h"
+#include "jmap_mail.h"
+#include "json_support.h"
+#include "mailbox.h"
+#include "mappedfile.h"
+#include "mboxlist.h"
+#include "mboxname.h"
+#include "msgrecord.h"
+#include "statuscache.h"
+#include "stristr.h"
+#include "user.h"
+#include "util.h"
+#include "xmalloc.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+
+static int jmap_mailbox_get(jmap_req_t *req);
+static int jmap_mailbox_set(jmap_req_t *req);
+static int jmap_mailbox_changes(jmap_req_t *req);
+static int jmap_mailbox_query(jmap_req_t *req);
+static int jmap_mailbox_querychanges(jmap_req_t *req);
+
+struct rolesort_data {
+    const char *name;
+    int order;
+};
+
+static struct rolesort_data ROLESORT[] = {
+    { "inbox", 1 },
+    { "archive", 3 },
+    { "drafts", 4 },
+    { "sent", 5 },
+    { "junk", 6 },
+    { "trash", 7 },
+    { "xtemplates", 9 },
+    { NULL, 10 }  // default
+};
+
+static jmap_method_t jmap_mailbox_methods_standard[] = {
+    {
+        "Mailbox/get",
+        JMAP_URN_MAIL,
+        &jmap_mailbox_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Mailbox/set",
+        JMAP_URN_MAIL,
+        &jmap_mailbox_set,
+        /*flags*/0
+    },
+    {
+        "Mailbox/changes",
+        JMAP_URN_MAIL,
+        &jmap_mailbox_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Mailbox/query",
+        JMAP_URN_MAIL,
+        &jmap_mailbox_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Mailbox/queryChanges",
+        JMAP_URN_MAIL,
+        &jmap_mailbox_querychanges,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+static jmap_method_t jmap_mailbox_methods_nonstandard[] = {
+    { NULL, NULL, NULL, 0}
+};
+
+HIDDEN void jmap_mailbox_init(jmap_settings_t *settings)
+{
+    jmap_method_t *mp;
+    for (mp = jmap_mailbox_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        for (mp = jmap_mailbox_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+}
+
+HIDDEN void jmap_mailbox_capabilities(json_t *account_capabilities
+                                      __attribute__((unused)))
+{
+}
+
+
+/*
+ * Mailboxes
+ */
+
+struct shared_mboxes {
+    int is_owner;
+    strarray_t mboxes;
+    jmap_req_t *req;
+};
+
+/*
+ * We distinguish shared mailboxes by the following types:
+ *
+ * it is trivially _MBOX_VISIBLE, without checking ACL rights.
+ * - _SHAREDMBOX_HIDDEN: this mailbox is not visible at all to the
+ *                       currently authenticated account
+ * - _SHAREDMBOX_PARENT: this mailbox is not readable, but it is
+ *                       the parent mailbox of a shared mailbox.
+ *                       E.g. it is reported in Mailbox/get but
+ *                       some of its properties are anonymised.
+ * - _SHAREDMBOX_SHARED: this mailbox is fully readable by the current
+ *                       user, that is, its ACL provides at least
+ *                       ACL_LOOKUP and ACL_READ rights
+ *
+ * If the mailbox is a child of the authenticated user's INBOX,
+ * it is trivially _SHAREDMBOX_SHARED, without checking ACL rights.
+ */
+enum shared_mbox_type {
+    _SHAREDMBOX_HIDDEN,
+    _SHAREDMBOX_PARENT,
+    _SHAREDMBOX_SHARED
+};
+
+static int _shared_mboxes_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct shared_mboxes *sm = rock;
+    int needrights = ACL_LOOKUP|ACL_READ;
+
+    if (jmap_hasrights(sm->req, mbentry, needrights))
+        strarray_append(&sm->mboxes, mbentry->name);
+
+    return 0;
+}
+
+struct shared_mboxes *_shared_mboxes_new(jmap_req_t *req, int flags)
+{
+    struct shared_mboxes *sm = xzmalloc(sizeof(struct shared_mboxes));
+    sm->req = req;
+
+    if (!strcmp(req->userid, req->accountid)) {
+        /* Trivial - all mailboxes are visible */
+        sm->is_owner = 1;
+        return sm;
+    }
+
+    /* Gather shared mailboxes */
+    int r = mboxlist_usermboxtree(req->accountid, req->authstate,
+                                  _shared_mboxes_cb, sm, flags);
+    if (r) {
+        free(sm);
+        sm = NULL;
+    }
+    strarray_sort(&sm->mboxes, cmpstringp_mbox);
+    return sm;
+}
+
+static void _shared_mboxes_free(struct shared_mboxes *sm)
+{
+    if (!sm) return;
+    strarray_fini(&sm->mboxes);
+    free(sm);
+}
+
+static enum shared_mbox_type _shared_mbox_type(struct shared_mboxes *sm,
+                                               const char *name)
+{
+    /* Handle trivial cases */
+    if (sm->is_owner)
+        return _SHAREDMBOX_SHARED;
+    if (sm->mboxes.count == 0)
+        return _SHAREDMBOX_HIDDEN;
+
+    /* This is a worst case O(n) search, which *could* turn out to
+     * be an issue if caller iterates over all mailboxes of an
+     * account with lots of mailboxes. */
+    int i = 0;
+    for (i = 0; i < sm->mboxes.count; i++) {
+        const char *sharedname = strarray_nth(&sm->mboxes, i);
+        int cmp = bsearch_compare_mbox(sharedname, name);
+        if (!cmp)
+            return _SHAREDMBOX_SHARED;
+
+        if (cmp > 0 && mboxname_is_prefix(sharedname, name)) {
+            // if this isn't a user's INBOX, then it's definitely a
+            // parent, so show it
+            mbname_t *mbname = mbname_from_intname(name);
+            if (strarray_size(mbname_boxes(mbname))) {
+                mbname_free(&mbname);
+                return _SHAREDMBOX_PARENT;
+            }
+            mbname_free(&mbname);
+
+            // if it is the INBOX, then only show if it's a parent of
+            // a mailbox which is user.foo.INBOX.etc
+            mbname_t *sharedmbname = mbname_from_intname(sharedname);
+            if (!strcmpsafe(strarray_nth(mbname_boxes(sharedmbname), 0), "INBOX")) {
+                mbname_free(&sharedmbname);
+                return _SHAREDMBOX_PARENT;
+            }
+            mbname_free(&sharedmbname);
+
+            // otherwise fall through, because there might be a later member
+            // of mboxes for which this name is a parent.  We could theoretically
+            // avoid recalculating "mbname" here, but the complexity of cleanup
+            // isn't worth the trouble.
+        }
+    }
+
+    return _SHAREDMBOX_HIDDEN;
+}
+
+struct _mbox_find_specialuse_rock {
+    jmap_req_t *req;
+    const char *use;
+    char *mboxname;
+    char *uniqueid;
+};
+
+static int _mbox_find_specialuse_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct _mbox_find_specialuse_rock *d = (struct _mbox_find_specialuse_rock *)rock;
+    struct buf attrib = BUF_INITIALIZER;
+    jmap_req_t *req = d->req;
+
+    if (!mbentry || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+        return 0;
+    }
+
+    annotatemore_lookup(mbentry->name, "/specialuse", req->accountid, &attrib);
+
+    if (attrib.len) {
+        strarray_t *uses = strarray_split(buf_cstring(&attrib), " ", STRARRAY_TRIM);
+        if (strarray_find_case(uses, d->use, 0) >= 0) {
+            d->mboxname = xstrdup(mbentry->name);
+            d->uniqueid = xstrdup(mbentry->uniqueid);
+        }
+        strarray_free(uses);
+    }
+
+    buf_free(&attrib);
+
+    if (d->mboxname) return CYRUSDB_DONE;
+    return 0;
+}
+
+static int _mbox_find_specialuse(jmap_req_t *req, const char *use,
+                                 char **mboxnameptr,
+                                 char **uniqueidptr)
+{
+    /* \\Inbox is magical */
+    if (!strcasecmp(use, "\\Inbox")) {
+        char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+        mbentry_t *mbentry = NULL;
+        int r = mboxlist_lookup(inboxname, &mbentry, NULL);
+        if (!r) {
+            if (mboxnameptr) *mboxnameptr = xstrdup(inboxname);
+            if (uniqueidptr) *uniqueidptr = xstrdup(mbentry->uniqueid);
+        }
+        free(inboxname);
+        mboxlist_entry_free(&mbentry);
+        return r;
+    }
+
+    struct _mbox_find_specialuse_rock rock = { req, use, NULL, NULL };
+    int ret = mboxlist_usermboxtree(req->accountid, req->authstate, _mbox_find_specialuse_cb, &rock, MBOXTREE_INTERMEDIATES);
+
+    if (mboxnameptr) {
+        *mboxnameptr = rock.mboxname;
+    } else free(rock.mboxname);
+
+    if (uniqueidptr) {
+        *uniqueidptr = rock.uniqueid;
+    } else free(rock.uniqueid);
+
+    return ret == CYRUSDB_DONE ? 0 : IMAP_NOTFOUND;
+}
+
+static char *_mbox_get_role(jmap_req_t *req, const mbname_t *mbname)
+{
+    struct buf buf = BUF_INITIALIZER;
+    char *role = NULL;
+
+    /* Inbox is special. */
+    if (!strarray_size(mbname_boxes(mbname)))
+        return xstrdup("inbox");
+
+    /* XXX How to determine the templates role? */
+
+    /* Does this mailbox have an IMAP special use role? */
+    annotatemore_lookup(mbname_intname(mbname), "/specialuse",
+                        req->accountid, &buf);
+    if (buf.len) {
+        strarray_t *uses = strarray_split(buf_cstring(&buf), " ", STRARRAY_TRIM);
+        if (uses->count) {
+            /* In IMAP, a mailbox may have multiple roles. But in JMAP we only
+             * return the first specialuse flag. */
+            const char *use = strarray_nth(uses, 0);
+            if (use[0] == '\\') {
+                role = xstrdup(use+1);
+                lcase(role);
+            }
+        }
+        strarray_free(uses);
+    }
+
+    buf_free(&buf);
+
+    return role;
+}
+
+static char *_mbox_get_name(const char *account_id, const mbname_t *mbname)
+{
+    struct buf attrib = BUF_INITIALIZER;
+
+    const char *annot = IMAP_ANNOT_NS "displayname";
+    int r = annotatemore_lookup(mbname_intname(mbname), annot, account_id, &attrib);
+    if (!r && attrib.len) {
+        /* We got a mailbox with a displayname annotation. Use it. */
+        char *name = buf_release(&attrib);
+        buf_free(&attrib);
+        return name;
+    }
+    buf_free(&attrib);
+
+    /* No displayname annotation. Most probably this mailbox was
+     * created via IMAP. In any case, determine name from the the
+     * last segment of the mailboxname hierarchy. */
+    char *extname;
+    const strarray_t *boxes = mbname_boxes(mbname);
+    if (strarray_size(boxes)) {
+        extname = xstrdup(strarray_nth(boxes, strarray_size(boxes)-1));
+        /* Decode extname from IMAP UTF-7 to UTF-8. Or fall back to extname. */
+        charset_t cs = charset_lookupname("imap-utf-7");
+        char *decoded = charset_to_utf8(extname, strlen(extname),
+                                        cs, ENCODING_NONE);
+        if (decoded) {
+            free(extname);
+            extname = decoded;
+        }
+        charset_free(&cs);
+    } else {
+        extname = xstrdup("Inbox");
+    }
+    return extname;
+}
+
+static int _mbox_get_roleorder(jmap_req_t *req, const mbname_t *mbname)
+{
+    char *role = _mbox_get_role(req, mbname);
+    int role_order = 10;
+
+    if (role) {
+        int i;
+        for (i = 0; ROLESORT[i].name; i++) {
+            if (!strcmp(role, ROLESORT[i].name)) {
+                role_order = ROLESORT[i].order;
+                break;
+            }
+        }
+    }
+
+    free(role);
+    return role_order;
+}
+
+static int _mbox_get_sortorder(jmap_req_t *req, const mbname_t *mbname)
+{
+    struct buf attrib = BUF_INITIALIZER;
+    int sort_order = -1;
+
+    /* Ignore lookup errors here. */
+    const char *annot = IMAP_ANNOT_NS "sortorder";
+    annotatemore_lookupmask(mbname_intname(mbname), annot, httpd_userid, &attrib);
+    if (attrib.len) {
+        uint64_t t = str2uint64(buf_cstring(&attrib));
+        if (t < INT_MAX) {
+            sort_order = (int) t;
+        } else {
+            syslog(LOG_ERR, "%s: bogus sortorder annotation value for %s",
+                   mbname_intname(mbname), httpd_userid);
+        }
+    }
+
+    buf_free(&attrib);
+
+    if (sort_order < 0)
+        sort_order = _mbox_get_roleorder(req, mbname);
+
+    return sort_order;
+}
+
+static int _findparent(const char *mboxname, mbentry_t **mbentryp)
+{
+    mbentry_t *mbentry = NULL;
+    int r = mboxlist_findparent_allow_all(mboxname, &mbentry);
+    if (r) return r;
+
+    /* Ignore "reserved" entries, like they aren't there */
+    if (mbentry->mbtype & MBTYPE_RESERVE) {
+        mboxlist_entry_free(&mbentry);
+        return IMAP_MAILBOX_NONEXISTENT;
+    }
+
+    /* Ignore "deleted" entries, like they aren't there */
+    if (mbentry->mbtype & MBTYPE_DELETED) {
+        mboxlist_entry_free(&mbentry);
+        return IMAP_MAILBOX_NONEXISTENT;
+    }
+
+    *mbentryp = mbentry;
+    return 0;
+}
+
+static int _mbox_get_readcounts(jmap_req_t *req,
+                                mbname_t *mbname,
+                                hash_table *props,
+                                json_t *obj)
+{
+    conv_status_t convstatus = CONV_STATUS_INIT;
+    int r = conversation_getstatus(req->cstate,
+                 mbname_intname(mbname), &convstatus);
+    if (r) {
+        syslog(LOG_ERR, "conversation_getstatus(%s): %s",
+                mbname_intname(mbname), error_message(r));
+        return r;
+    }
+    if (jmap_wantprop(props, "totalEmails")) {
+        json_object_set_new(obj, "totalEmails",
+                json_integer(convstatus.emailexists));
+    }
+    if (jmap_wantprop(props, "unreadEmails")) {
+        json_object_set_new(obj, "unreadEmails",
+                json_integer(convstatus.emailunseen));
+    }
+    if (jmap_wantprop(props, "totalThreads")) {
+        json_object_set_new(obj, "totalThreads",
+                json_integer(convstatus.threadexists));
+    }
+    if (jmap_wantprop(props, "unreadThreads")) {
+        json_object_set_new(obj, "unreadThreads",
+                json_integer(convstatus.threadunseen));
+    }
+    return 0;
+}
+
+static void _mbox_is_inbox(mbname_t *mbname, int *is_inbox, int *parent_is_inbox)
+{
+    if (is_inbox) {
+        *is_inbox = strarray_size(mbname_boxes(mbname)) == 0;
+    }
+    if (parent_is_inbox) {
+        *parent_is_inbox = strarray_size(mbname_boxes(mbname)) == 1;
+    }
+}
+
+static json_t *_mbox_get_myrights(jmap_req_t *req, const mbentry_t *mbentry)
+{
+    int rights = jmap_myrights(req, mbentry);
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    mbentry_t *parent = NULL;
+    _findparent(mbname_intname(mbname), &parent);
+    int is_inbox = 0;
+    _mbox_is_inbox(mbname, &is_inbox, NULL);
+
+    json_t *jrights = json_object();
+    json_object_set_new(jrights, "mayReadItems",
+            json_boolean(rights & ACL_READ));
+    json_object_set_new(jrights, "mayAddItems",
+            json_boolean(rights & ACL_INSERT));
+    json_object_set_new(jrights, "mayRemoveItems",
+            json_boolean(rights & ACL_DELETEMSG));
+    json_object_set_new(jrights, "mayCreateChild",
+            json_boolean(rights & ACL_CREATE));
+    json_object_set_new(jrights, "mayDelete",
+            json_boolean((rights & ACL_DELETEMBOX) && !is_inbox));
+    json_object_set_new(jrights, "maySubmit",
+            json_boolean(rights & ACL_POST));
+    json_object_set_new(jrights, "maySetSeen",
+            json_boolean(rights & ACL_SETSEEN));
+    json_object_set_new(jrights, "maySetKeywords",
+            json_boolean(rights & ACL_WRITE));
+    // non-standard
+    json_object_set_new(jrights, "mayAdmin",
+            json_boolean(rights & ACL_ADMIN));
+
+    int mayRename = 0;
+    if (!is_inbox && (rights & ACL_DELETEMBOX)) {
+        mayRename = jmap_hasrights(req, parent, ACL_CREATE);
+    }
+    json_object_set_new(jrights, "mayRename", json_boolean(mayRename));
+
+    mboxlist_entry_free(&parent);
+    mbname_free(&mbname);
+    return jrights;
+}
+
+static json_t *_mbox_get(jmap_req_t *req,
+                         const mbentry_t *mbentry,
+                         hash_table *roles,
+                         hash_table *props,
+                         enum shared_mbox_type share_type,
+                         strarray_t *sublist)
+{
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    mbentry_t *parent = NULL;
+    json_t *obj = NULL;
+    int r = 0;
+
+    int is_inbox = 0, parent_is_inbox = 0;
+    _mbox_is_inbox(mbname, &is_inbox, &parent_is_inbox);
+    char *role = _mbox_get_role(req, mbname);
+
+    if (jmap_wantprop(props, "myRights") || jmap_wantprop(props, "parentId")) {
+        /* Need to lookup parent mailbox */
+        _findparent(mbname_intname(mbname), &parent);
+    }
+
+    /* Build JMAP mailbox response. */
+    obj = json_object();
+
+    json_object_set_new(obj, "id", json_string(mbentry->uniqueid));
+    if (jmap_wantprop(props, "name")) {
+        char *name = _mbox_get_name(req->accountid, mbname);
+        if (!name) goto done;
+        json_object_set_new(obj, "name", json_string(name));
+        free(name);
+    }
+
+    if (jmap_wantprop(props, "parentId")) {
+        json_object_set_new(obj, "parentId",
+                (is_inbox || parent_is_inbox || !parent) ?
+                json_null() : json_string(parent->uniqueid));
+    }
+
+    if (jmap_wantprop(props, "myRights")) {
+        json_object_set_new(obj, "myRights", _mbox_get_myrights(req, mbentry));
+    }
+    if (jmap_wantprop(props, "role")) {
+        if (role && !hash_lookup(role, roles)) {
+            /* In JMAP, only one mailbox have a role. First one wins. */
+            json_object_set_new(obj, "role", json_string(role));
+            hash_insert(role, (void*)1, roles);
+        } else {
+            json_object_set_new(obj, "role", json_null());
+        }
+    }
+
+    if (jmap_wantprop(props, "shareWith")) {
+        json_t *sharewith = jmap_get_sharewith(mbentry);
+        json_object_set_new(obj, "shareWith", sharewith);
+    }
+
+    if (share_type == _SHAREDMBOX_SHARED && !(mbentry->mbtype & MBTYPE_INTERMEDIATE)) {
+        if (jmap_wantprop(props, "totalThreads") || jmap_wantprop(props, "unreadThreads") ||
+            jmap_wantprop(props, "totalEmails") || jmap_wantprop(props, "unreadEmails")) {
+            r = _mbox_get_readcounts(req, mbname, props, obj);
+            if (r) goto done;
+        }
+        if (jmap_wantprop(props, "sortOrder")) {
+            int sortOrder = _mbox_get_sortorder(req, mbname);
+            json_object_set_new(obj, "sortOrder", json_integer(sortOrder));
+        }
+        if (jmap_wantprop(props, "isSeenShared") || jmap_wantprop(props, "storageUsed")) {
+            struct statusdata sdata = STATUSDATA_INIT;
+            int r = status_lookup_mbentry(mbentry, req->userid,
+                                          STATUS_MBOPTIONS, &sdata);
+            if (r) {
+                syslog(LOG_ERR, "getstatus(%s): %s",
+                        mbname_intname(mbname), error_message(r));
+                goto done;
+            }
+            if (jmap_wantprop(props, "isSeenShared")) {
+                json_object_set_new(obj, "isSeenShared",
+                                    json_boolean(sdata.mboptions & OPT_IMAP_SHAREDSEEN));
+            }
+            if (jmap_wantprop(props, "storageUsed")) {
+                json_object_set_new(obj, "storageUsed", json_integer(sdata.size));
+            }
+        }
+    }
+    else {
+        if (jmap_wantprop(props, "totalEmails")) {
+            json_object_set_new(obj, "totalEmails", json_integer(0));
+        }
+        if (jmap_wantprop(props, "unreadEmails")) {
+            json_object_set_new(obj, "unreadEmails", json_integer(0));
+        }
+        if (jmap_wantprop(props, "totalThreads")) {
+            json_object_set_new(obj, "totalThreads", json_integer(0));
+        }
+        if (jmap_wantprop(props, "unreadThreads")) {
+            json_object_set_new(obj, "unreadThreads", json_integer(0));
+        }
+        if (jmap_wantprop(props, "sortOrder")) {
+            json_object_set_new(obj, "sortOrder", json_integer(0));
+        }
+        if (jmap_wantprop(props, "isSeenShared")) {
+            json_object_set_new(obj, "isSeenShared", json_false());
+        }
+        if (jmap_wantprop(props, "storageUsed")) {
+            json_object_set_new(obj, "storageUsed", json_integer(0));
+        }
+    }
+
+    if (jmap_wantprop(props, "isSubscribed")) {
+        int is_subscribed =
+            sublist && strarray_find(sublist, mbentry->name, 0) >= 0;
+        json_object_set_new(obj, "isSubscribed", json_boolean(is_subscribed));
+    }
+
+done:
+    if (r) {
+        syslog(LOG_ERR, "_mbox_get: %s", error_message(r));
+    }
+    free(role);
+    mboxlist_entry_free(&parent);
+    mbname_free(&mbname);
+    return obj;
+}
+
+struct jmap_mailbox_get_cb_rock {
+    jmap_req_t *req;
+    struct jmap_get *get;
+    hash_table *roles;
+    hash_table *want;
+    struct shared_mboxes *shared_mboxes;
+    strarray_t *sublist;
+};
+
+static int jmap_mailbox_get_cb(const mbentry_t *mbentry, void *_rock)
+{
+    struct jmap_mailbox_get_cb_rock *rock = _rock;
+    jmap_req_t *req = rock->req;
+    json_t *list = (json_t *) rock->get->list, *obj;
+
+    /* Don't list special-purpose mailboxes. */
+    if ((mbentry->mbtype & MBTYPE_DELETED) ||
+        (mbentry->mbtype & MBTYPE_MOVING) ||
+        (mbentry->mbtype & MBTYPE_REMOTE) ||  /* XXX ?*/
+        (mbentry->mbtype & MBTYPE_RESERVE) || /* XXX ?*/
+        (mbentry->mbtype & MBTYPES_NONIMAP)) {
+        return 0;
+    }
+
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    const char *topbox = strarray_nth(mbname_boxes(mbname), 0);
+
+    /* skip INBOX.INBOX magic intermediate */
+    if (strarray_size(mbname_boxes(mbname)) == 1 && !strcmp(topbox, "INBOX")) {
+        mbname_free(&mbname);
+        return 0;
+    }
+
+    /* skip any of our magic mailboxes */
+    if (!strcmpsafe(topbox, config_getstring(IMAPOPT_CALENDARPREFIX))
+     || !strcmpsafe(topbox, config_getstring(IMAPOPT_ADDRESSBOOKPREFIX))
+     || !strcmpsafe(topbox, config_getstring(IMAPOPT_DAVNOTIFICATIONSPREFIX))
+     || !strcmpsafe(topbox, config_getstring(IMAPOPT_JMAPUPLOADFOLDER))) {
+        mbname_free(&mbname);
+        return 0;
+    }
+
+    mbname_free(&mbname);
+
+    /* Do we need to process this mailbox? */
+    if (rock->want && !hash_lookup(mbentry->uniqueid, rock->want))
+        return 0;
+
+    /* Check share_type for this mailbox */
+    enum shared_mbox_type share_type =
+        _shared_mbox_type(rock->shared_mboxes, mbentry->name);
+    if (share_type == _SHAREDMBOX_HIDDEN)
+        return 0;
+
+    /* Convert mbox to JMAP object. */
+    obj = _mbox_get(req, mbentry, rock->roles, rock->get->props, share_type, rock->sublist);
+    if (!obj) {
+        syslog(LOG_INFO, "could not convert mailbox %s to JMAP", mbentry->name);
+        return IMAP_INTERNAL;
+    }
+    json_array_append_new(list, obj);
+
+    /* Move this mailbox of the lookup list */
+    if (rock->want) {
+        hash_del(mbentry->uniqueid, rock->want);
+        // are we done looking?
+        if (!hash_numrecords(rock->want))
+            return IMAP_OK_COMPLETED;
+    }
+
+    return 0;
+}
+
+static void jmap_mailbox_get_notfound(const char *id, void *data __attribute__((unused)), void *rock)
+{
+    json_array_append_new((json_t*) rock, json_string(id));
+}
+
+static const jmap_property_t mailbox_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "name",
+        NULL,
+        0
+    },
+    {
+        "parentId",
+        NULL,
+        0
+    },
+    {
+        "role",
+        NULL,
+        0
+    },
+    {
+        "sortOrder",
+        NULL,
+        0
+    },
+    {
+        "totalEmails",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "unreadEmails",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "totalThreads",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "unreadThreads",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "myRights",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "isSubscribed",
+        NULL,
+        0
+    },
+
+    /* FM extensions (do ALL of these get through to Cyrus?) */
+    {
+        "isCollapsed",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "hidden",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "sort",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "identityRef",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "autoLearn",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "learnAsSpam",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "autoPurge",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "purgeOlderThanDays",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "onlyPurgeDeleted",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "suppressDuplicates",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "shareWith",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "isSeenShared",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "storageUsed",
+        JMAP_MAIL_EXTENSION,
+        JMAP_PROP_SERVER_SET
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_mailbox_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, mailbox_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        jmap_parser_fini(&parser);
+        jmap_get_fini(&get);
+        return 0;
+    }
+
+    /* Build callback data */
+    struct shared_mboxes *shared_mboxes = _shared_mboxes_new(req, /*flags*/0);
+    strarray_t *sublist = NULL;
+    if (jmap_wantprop(get.props, "isSubscribed")) {
+        sublist = mboxlist_sublist(req->userid);
+    }
+    struct jmap_mailbox_get_cb_rock rock = { req, &get, NULL, NULL, shared_mboxes, sublist };
+    rock.roles = (hash_table *) xmalloc(sizeof(hash_table));
+    construct_hash_table(rock.roles, 8, 0);
+
+    /* Does the client request specific mailboxes? */
+    if (JNOTNULL(get.ids)) {
+        size_t i;
+        json_t *val;
+        /* Make a set of request ids to know when to stop mboxlist*/
+        rock.want = (hash_table *) xmalloc(sizeof(hash_table));
+        construct_hash_table(rock.want, json_array_size(get.ids) + 1, 0);
+        json_array_foreach(get.ids, i, val) {
+            hash_insert(json_string_value(val), (void*)1, rock.want);
+        }
+    }
+
+    /* Lookup and process the mailboxes. Irrespective if the client
+     * defined a subset of mailbox ids to fetch, we traverse the
+     * complete mailbox list, until we either reach the end of the
+     * list or have found all requested ids. This is probably more
+     * performant than looking up each mailbox by unique id separately
+     * but will degrade if clients just fetch a small subset of
+     * all mailbox ids. XXX Optimise this codepath if the ids[] array
+     * length is small */
+    mboxlist_usermboxtree(req->accountid, req->authstate,
+                          jmap_mailbox_get_cb, &rock, MBOXTREE_INTERMEDIATES);
+
+    /* Report if any requested mailbox has not been found */
+    if (rock.want) {
+        hash_enumerate(rock.want, jmap_mailbox_get_notfound, get.not_found);
+    }
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+    _shared_mboxes_free(shared_mboxes);
+    free_hash_table(rock.want, NULL);
+    free(rock.want);
+    free_hash_table(rock.roles, NULL);
+    free(rock.roles);
+    strarray_free(rock.sublist);
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
+
+typedef struct {
+    /* op indicates the filter type:
+     * - SEOP_AND/OR/NOT/TRUE/FALSE: if the filter is a filter operator
+     * - SEOP_UNKNOWN: if the filter is a filter condition
+     */
+    enum search_op op;
+    ptrarray_t args; /* array of mboxquery_filter_t */
+    /* Arguments for the filter operator or condition. */
+    json_t *jparent_id;
+    const char *name;
+    json_t *role;
+    json_t *has_any_role;
+    json_t *is_subscribed;
+} mboxquery_filter_t;
+
+typedef struct {
+    int sort_as_tree;
+    int filter_as_tree;
+} mboxquery_args_t;
+
+typedef struct {
+    jmap_req_t *req;
+    mboxquery_filter_t *filter;
+    ptrarray_t sort;    /* Sort criteria (mboxquery_sort_t) */
+    ptrarray_t result;  /* Result records (mboxquery_record_t) */
+    struct shared_mboxes *shared_mboxes;
+    strarray_t *sublist;
+    int include_tombstones;
+    int include_hidden;
+
+    int need_name;
+    int need_sort_order;
+    int need_role;
+    int need_role_order;
+    int need_sublist;
+    const mboxquery_args_t *args;
+} mboxquery_t;
+
+typedef struct {
+    char *id;
+    mbname_t *mbname;
+    char *mboxname;
+    char *jmapname;
+    char *parent_id; // NULL for top-level
+    int sort_order;
+    int role_order;
+    modseq_t foldermodseq;
+    modseq_t createdmodseq;
+    int mbtype;
+    enum shared_mbox_type shared_mbtype;
+    int matches; // non-zero, if filter matches
+} mboxquery_record_t;
+
+typedef struct {
+    char *field;
+    int desc;
+} mboxquery_sort_t;
+
+static void _mboxquery_filter_free(mboxquery_filter_t *filter)
+{
+    if (!filter) return;
+
+    int i;
+    for (i = 0; i < filter->args.count; i++) {
+        if (filter->op != SEOP_UNKNOWN) {
+            _mboxquery_filter_free(ptrarray_nth(&filter->args, i));
+        }
+    }
+    ptrarray_fini(&filter->args);
+    free(filter);
+}
+
+static void _mboxquery_record_fini(mboxquery_record_t *rec)
+{
+    if (!rec) return;
+
+    free(rec->id);
+    mbname_free(&rec->mbname);
+    free(rec->mboxname);
+    free(rec->parent_id);
+    free(rec->jmapname);
+}
+
+static void _mboxquery_free(mboxquery_t **qptr)
+{
+    int i;
+    mboxquery_t *q = *qptr;
+
+    for (i = 0; i < q->result.count; i++) {
+        mboxquery_record_t *rec = ptrarray_nth(&q->result, i);
+        _mboxquery_record_fini(rec);
+        free(rec);
+    }
+    ptrarray_fini(&q->result);
+
+    _mboxquery_filter_free(q->filter);
+
+    for (i = 0; i < q->sort.count; i++) {
+        mboxquery_sort_t *crit = ptrarray_nth(&q->sort, i);
+        free(crit->field);
+        free(crit);
+    }
+    ptrarray_fini(&q->sort);
+    _shared_mboxes_free(q->shared_mboxes);
+    strarray_free(q->sublist);
+
+    free(q);
+    *qptr = NULL;
+}
+
+static int _mboxquery_eval_filter(mboxquery_t *query,
+                                  mboxquery_filter_t *filter,
+                                  mboxquery_record_t *rec)
+{
+    if (filter->op == SEOP_TRUE)
+        return 1;
+    if (filter->op == SEOP_FALSE)
+        return 0;
+
+    int i;
+    if (filter->op != SEOP_UNKNOWN) {
+        for (i = 0; i < filter->args.count; i++) {
+            mboxquery_filter_t *arg = ptrarray_nth(&filter->args, i);
+            int m = _mboxquery_eval_filter(query, arg, rec);
+            if (m && filter->op == SEOP_OR)
+                return 1;
+            else if (m && filter->op == SEOP_NOT)
+                return 0;
+            else if (!m && filter->op == SEOP_AND)
+                return 0;
+        }
+        return filter->op == SEOP_AND || filter->op == SEOP_NOT;
+    }
+    else {
+        if (JNOTNULL(filter->has_any_role) || filter->role) {
+            mbname_t *mbname = mbname_from_intname(rec->mboxname);
+            char *role = _mbox_get_role(query->req, mbname);
+            int has_role = role != NULL;
+            int is_match = 1;
+            if (has_role) {
+                if (filter->has_any_role == json_false()) is_match = 0;
+                else if (filter->role == json_null()) is_match = 0;
+                else if (filter->role) {
+                    is_match = !strcmp(json_string_value(filter->role), role);
+                }
+            }
+            else {
+                if (filter->has_any_role == json_true()) is_match = 0;
+                else if (JNOTNULL(filter->role)) is_match = 0;
+            }
+            free(role);
+            mbname_free(&mbname);
+            if (!is_match) return 0;
+        }
+        if (filter->jparent_id) {
+            if (rec->parent_id) {
+                const char *want_parent = json_string_value(filter->jparent_id);
+                if (strcmpsafe(rec->parent_id, want_parent)) return 0;
+            }
+            else if (!json_is_null(filter->jparent_id)) return 0;
+        }
+        if (filter->name && !stristr(rec->jmapname, filter->name)) {
+            return 0;
+        }
+        if (JNOTNULL(filter->is_subscribed)) {
+            int want_subscribed = json_boolean_value(filter->is_subscribed);
+            int is_subscribed = strarray_find(query->sublist, rec->mboxname, 0);
+            if (want_subscribed && is_subscribed < 0) return 0;
+        }
+        return 1;
+    }
+}
+
+static mboxquery_filter_t *_mboxquery_build_filter(mboxquery_t *query, json_t *jfilter)
+{
+    mboxquery_filter_t *filter = xzmalloc(sizeof(mboxquery_filter_t));
+    filter->op = SEOP_TRUE;
+
+    const char *s = json_string_value(json_object_get(jfilter, "operator"));
+    if (s) {
+        if (!strcmp(s, "AND"))
+            filter->op = SEOP_AND;
+        else if (!strcmp(s, "OR"))
+            filter->op = SEOP_OR;
+        else if (!strcmp(s, "NOT"))
+            filter->op = SEOP_NOT;
+        size_t i;
+        json_t *val;
+        json_array_foreach(json_object_get(jfilter, "conditions"), i, val) {
+            ptrarray_append(&filter->args, _mboxquery_build_filter(query, val));
+        }
+    }
+    else {
+        filter->op = SEOP_UNKNOWN;
+        filter->jparent_id = json_object_get(jfilter, "parentId");
+        filter->name = json_string_value(json_object_get(jfilter, "name"));
+        filter->role = json_object_get(jfilter, "role");
+        filter->has_any_role = json_object_get(jfilter, "hasAnyRole");
+        filter->is_subscribed = json_object_get(jfilter, "isSubscribed");
+        if (filter->role || filter->has_any_role) {
+            query->need_role = 1;
+        }
+        if (filter->is_subscribed) {
+            query->need_sublist = 1;
+        }
+        if (filter->name) {
+            query->need_name = 1;
+        }
+    }
+    return filter;
+}
+
+static mboxquery_t *_mboxquery_new(jmap_req_t *req, json_t *filter, json_t *sort)
+{
+    mboxquery_t *q = xzmalloc(sizeof(mboxquery_t));
+    q->req = req;
+    q->shared_mboxes = _shared_mboxes_new(req, /*flags*/0);
+
+    /* Prepare filter */
+    q->filter = _mboxquery_build_filter(q, filter);
+
+    /* Prepare sort */
+    size_t i;
+    json_t *jval;
+    json_array_foreach(sort, i, jval) {
+        mboxquery_sort_t *crit = xzmalloc(sizeof(mboxquery_sort_t));
+        const char *prop = json_string_value(json_object_get(jval, "property"));
+        crit->field = xstrdup(prop);
+        crit->desc = json_object_get(jval, "isAscending") == json_false();
+        ptrarray_append(&q->sort, crit);
+    }
+    ptrarray_init(&q->result);
+
+    return q;
+}
+
+static int _mboxquery_compar QSORT_R_COMPAR_ARGS(const void **a,
+                                                 const void **b,
+                                                 void *rock)
+{
+    const mboxquery_record_t *pa = *a;
+    const mboxquery_record_t *pb = *b;
+    const mboxquery_t *query = rock;
+    int i;
+
+    for (i = 0; i < query->sort.count; i++) {
+        mboxquery_sort_t *crit = ptrarray_nth(&query->sort, i);
+        int cmp = 0;
+        int sign = crit->desc ? -1 : 1;
+
+        if (!strcmp(crit->field, "name"))
+            cmp = strcmp(pa->jmapname, pb->jmapname) * sign;
+        else if (!strcmp(crit->field, "role"))
+            cmp = (pa->role_order - pb->role_order) * sign;
+        else if (!strcmp(crit->field, "sortOrder"))
+            cmp = (pa->sort_order - pb->sort_order) * sign;
+
+        if (cmp) return cmp;
+    }
+
+    return strcmp(pa->id, pb->id);
+}
+
+static int _mboxquery_cb(const mbentry_t *mbentry, void *rock)
+{
+    mboxquery_t *q = rock;
+
+    if (mbentry->mbtype & MBTYPES_NONIMAP)
+        return 0;
+
+    if ((mbentry->mbtype & MBTYPE_DELETED) && !q->include_tombstones)
+        return 0;
+
+    enum shared_mbox_type shared_mbtype = _shared_mbox_type(q->shared_mboxes, mbentry->name);
+    if (shared_mbtype == _SHAREDMBOX_HIDDEN && !q->include_hidden)
+        return 0;
+
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+
+    /* skip INBOX.INBOX magic intermediate */
+    if (strarray_size(mbname_boxes(mbname)) == 1 &&
+        !strcmp(strarray_nth(mbname_boxes(mbname), 0), "INBOX")) {
+        if (mbname) mbname_free(&mbname);
+        return 0;
+    }
+
+    int r = 0;
+
+    /* Create record */
+    mboxquery_record_t *rec = xzmalloc(sizeof(mboxquery_record_t));
+
+    if (strarray_size(mbname_boxes(mbname)) > 1) {
+        mbentry_t *mbparent = NULL;
+        r = _findparent(mbentry->name, &mbparent);
+        if (r && r != IMAP_MAILBOX_NONEXISTENT) {
+            goto done;
+        }
+        else if (!r) {
+            rec->parent_id = xstrdup(mbparent->uniqueid);
+        }
+        mboxlist_entry_free(&mbparent);
+        r = 0;
+    }
+
+    rec->id = xstrdup(mbentry->uniqueid);
+    rec->mbname = mbname;
+    mbname = NULL; // takes ownership
+    rec->foldermodseq = mbentry->foldermodseq;
+    rec->createdmodseq = mbentry->createdmodseq;
+    rec->mbtype = mbentry->mbtype;
+    rec->shared_mbtype = shared_mbtype;
+    rec->mboxname = xstrdup(mbentry->name);
+
+    if (q->need_name) {
+        rec->jmapname = _mbox_get_name(q->req->accountid, rec->mbname);
+    }
+    if (q->need_sort_order) {
+        rec->sort_order = _mbox_get_sortorder(q->req, rec->mbname);
+    }
+    if (q->need_role_order) {
+        rec->role_order = _mbox_get_roleorder(q->req, rec->mbname);
+    }
+    ptrarray_append(&q->result, rec);
+
+done:
+    if (mbname) mbname_free(&mbname);
+    return r;
+}
+
+static int _mboxquery_run(mboxquery_t *query, const mboxquery_args_t *args)
+{
+    /* Prepare internal query context. */
+    int i;
+    for (i = 0; i < ptrarray_size(&query->sort); i++) {
+        mboxquery_sort_t *crit = ptrarray_nth(&query->sort, i);
+        if (!strcmp(crit->field, "name")) {
+            query->need_name = 1;
+        }
+        else if (!strcmp(crit->field, "role")) {
+            query->need_role_order = 1;
+        }
+        else if (!strcmp(crit->field, "sortOrder")) {
+            query->need_sort_order = 1;
+        }
+    }
+    query->args = args;
+    if (query->need_sublist) {
+        query->sublist = mboxlist_sublist(query->req->userid);
+        if (!query->sublist) {
+            syslog(LOG_ERR, "jmap: mboxquery_run: could not load sublist");
+            return IMAP_INTERNAL;
+        }
+    }
+
+    /* Lookup mailboxes */
+    int flags = MBOXTREE_INTERMEDIATES;
+    if (query->include_tombstones) flags |= MBOXTREE_TOMBSTONES|MBOXTREE_DELETED;
+    int r = mboxlist_usermboxtree(query->req->accountid, query->req->authstate,
+                                  _mboxquery_cb, query, flags);
+    if (r) goto done;
+
+    /* Apply comparators */
+    cyr_qsort_r(query->result.data, query->result.count, sizeof(void*),
+                (int(*)(const void*, const void*, void*)) _mboxquery_compar, query);
+
+    /* Build in-memory tree */
+    hash_table recs_by_parentid = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&recs_by_parentid, ptrarray_size(&query->result) + 1, 0);
+    for (i = 0; i < ptrarray_size(&query->result); i++) {
+        mboxquery_record_t *rec = ptrarray_nth(&query->result, i);
+        const char *parent_id = rec->parent_id ? rec->parent_id : "";
+        ptrarray_t *recs = hash_lookup(parent_id, &recs_by_parentid);
+        if (!recs) {
+            recs = ptrarray_new();
+            hash_insert(parent_id, recs, &recs_by_parentid);
+        }
+        ptrarray_append(recs, rec);
+    }
+
+    /* Sort as tree */
+    if (query->args->sort_as_tree) {
+        /* Reset result list */
+        ptrarray_truncate(&query->result, 0);
+        /* Add top-level nodes */
+        ptrarray_t work = PTRARRAY_INITIALIZER;
+        ptrarray_t *root = hash_lookup("", &recs_by_parentid);
+        if (root) {
+            for (i = ptrarray_size(root) - 1; i >= 0; i--) {
+                ptrarray_push(&work, ptrarray_nth(root, i));
+            }
+        }
+        /* Descend tree */
+        mboxquery_record_t *rec;
+        while ((rec = ptrarray_pop(&work))) {
+            ptrarray_push(&query->result, rec);
+            ptrarray_t *children = hash_lookup(rec->id, &recs_by_parentid);
+            if (!children) continue;
+            for (i = ptrarray_size(children) - 1; i >= 0; i--) {
+                ptrarray_push(&work, ptrarray_nth(children, i));
+            }
+        }
+        ptrarray_fini(&work);
+    }
+
+    /* Apply filter */
+    for (i = 0; i < ptrarray_size(&query->result); i++) {
+        mboxquery_record_t *rec = ptrarray_nth(&query->result, i);
+        rec->matches = _mboxquery_eval_filter(query, query->filter, rec);
+    }
+
+    /* Filter as tree */
+    if (query->args->filter_as_tree) {
+        /* Add top-level nodes */
+        ptrarray_t work = PTRARRAY_INITIALIZER;
+        ptrarray_t *root = hash_lookup("", &recs_by_parentid);
+        if (root) {
+            for (i = 0; i < ptrarray_size(root); i++) {
+                ptrarray_push(&work, ptrarray_nth(root, i));
+            }
+        }
+        /* Descend tree */
+        mboxquery_record_t *rec;
+        while ((rec = ptrarray_pop(&work))) {
+            ptrarray_t *children = hash_lookup(rec->id, &recs_by_parentid);
+            if (!children) continue;
+            for (i = 0; i < ptrarray_size(children); i++) {
+                mboxquery_record_t *child = ptrarray_nth(children, i);
+                if (!rec->matches) child->matches = 0;
+                ptrarray_push(&work, child);
+            }
+        }
+        ptrarray_fini(&work);
+    }
+
+    /* Prune result */
+    int newlen = 0;
+    for (i = 0; i < ptrarray_size(&query->result); i++) {
+        mboxquery_record_t *rec = ptrarray_nth(&query->result, i);
+        if (!rec->matches) {
+            _mboxquery_record_fini(rec);
+            free(rec);
+        }
+        else ptrarray_set(&query->result, newlen++, rec);
+    }
+    ptrarray_truncate(&query->result, newlen);
+
+    /* Free tree model */
+    hash_iter *it = hash_table_iter(&recs_by_parentid);
+    while (hash_iter_next(it)) {
+        ptrarray_t *recs = hash_iter_val(it);
+        ptrarray_free(recs);
+    }
+    hash_iter_free(&it);
+    free_hash_table(&recs_by_parentid, NULL);
+
+done:
+    return r;
+}
+
+
+static int _mboxquery_can_calculate_changes(mboxquery_t *mbquery)
+{
+    /* XXX Mailbox/queryChanges currently has to overreport mailboxes
+     * in removed if the filter criteria includes annotations. This
+     * workaround is OK for a user's owned mailbox, but we don't want
+     * to leak mailboxes for shared accounts */
+    return !strcmp(mbquery->req->userid, mbquery->req->accountid);
+}
+
+static int _mbox_query(jmap_req_t *req, struct jmap_query *query,
+                       const mboxquery_args_t *args)
+{
+    int r = 0;
+
+    /* Prepare query */
+    mboxquery_t *mbquery = _mboxquery_new(req, query->filter, query->sort);
+
+    /* Run the query */
+    r = _mboxquery_run(mbquery, args);
+    if (r) goto done;
+
+    query->total = mbquery->result.count;
+
+    /* Apply query */
+    ssize_t i, frompos = 0;
+    int seen_anchor = 0;
+    ssize_t skip_anchor = 0;
+    ssize_t result_pos = -1;
+    modseq_t highest_modseq = 0;
+
+    /* Set position of first result */
+    if (!query->anchor) {
+        if (query->position > 0) {
+            frompos = query->position;
+        }
+        else if (query->position < 0) {
+            frompos = mbquery->result.count + query->position ;
+            if (frompos < 0) frompos = 0;
+        }
+    }
+
+    for (i = frompos; i < mbquery->result.count; i++) {
+        mboxquery_record_t *rec = ptrarray_nth(&mbquery->result, i);
+
+        /* Check anchor */
+        if (query->anchor) {
+            if (!seen_anchor) {
+                seen_anchor = !strcmp(rec->id, query->anchor);
+                if (!seen_anchor) {
+                    continue;
+                }
+                /* Found the anchor! Now apply anchor offsets */
+                if (query->anchor_offset > 0) {
+                    skip_anchor = query->anchor_offset;
+                    continue;
+                }
+                else if (query->anchor_offset < 0) {
+                    /* Prefill result list with all, but the current record */
+                    size_t lo = -query->anchor_offset < i ? i + query->anchor_offset : 0;
+                    size_t hi = query->limit ? lo + query->limit : (size_t) i;
+                    result_pos = lo;
+                    while (lo < hi && lo < (size_t) i) {
+                        mboxquery_record_t *p = ptrarray_nth(&mbquery->result, lo);
+                        json_array_append_new(query->ids, json_string(p->id));
+                        lo++;
+                    }
+                }
+            }
+            if (skip_anchor && --skip_anchor) continue;
+        }
+
+        /* Check limit. */
+        if (query->limit && query->limit <= json_array_size(query->ids)) {
+            break;
+        }
+
+        /* Add to result list. */
+        if (result_pos == -1) {
+            result_pos = i;
+        }
+        if (highest_modseq < rec->foldermodseq) {
+            highest_modseq = rec->foldermodseq;
+        }
+        json_array_append_new(query->ids, json_string(rec->id));
+    }
+    if (query->anchor && !seen_anchor) {
+        json_decref(query->ids);
+        query->ids = json_array();
+    }
+    if (result_pos >= 0) {
+        query->result_position = result_pos;
+    }
+
+    struct buf buf = BUF_INITIALIZER;
+    buf_printf(&buf, MODSEQ_FMT, highest_modseq);
+    query->query_state = buf_release(&buf);
+    query->can_calculate_changes = _mboxquery_can_calculate_changes(mbquery);
+
+done:
+    _mboxquery_free(&mbquery);
+    return r;
+}
+
+static int _mboxquery_parse_comparator(jmap_req_t *req __attribute__((unused)),
+                                       struct jmap_comparator *comp,
+                                       void *rock __attribute__((unused)),
+                                       json_t **err __attribute__((unused)))
+{
+    /* Reject unsupported properties */
+    if (strcmp(comp->property, "sortOrder") &&
+        strcmp(comp->property, "role") &&
+        strcmp(comp->property, "name")) {
+        return 0;
+    }
+    /* Reject any collation */
+    if (comp->collation) {
+        return 0;
+    }
+    return 1;
+}
+
+static void _mboxquery_parse_filter(jmap_req_t *req __attribute__((unused)),
+                                    struct jmap_parser *parser,
+                                    json_t *filter,
+                                    json_t *unsupported __attribute__((unused)),
+                                    void *rock __attribute__((unused)),
+                                    json_t **err __attribute__((unused)))
+{
+    json_t *val;
+    const char *field;
+
+    json_object_foreach(filter, field, val) {
+        if (!strcmp(field, "parentId") ||
+            !strcmp(field, "role")) {
+            if (!(json_is_string(val) || json_is_null(val))) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "name")) {
+            if (!json_is_string(val)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "isSubscribed") ||
+                 !strcmp(field, "hasAnyRole")) {
+            if (!json_is_boolean(val)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+static int _mboxquery_parse_args(jmap_req_t *req __attribute__((unused)),
+                                 struct jmap_parser *parser __attribute__((unused)),
+                                 const char *key,
+                                 json_t *arg,
+                                 void *rock)
+{
+    mboxquery_args_t *args = (mboxquery_args_t*) rock;
+
+    if (!strcmp(key, "sortAsTree") && json_is_boolean(arg)) {
+        args->sort_as_tree = json_boolean_value(arg);
+        return 1;
+    }
+    else if (!strcmp(key, "filterAsTree") && json_is_boolean(arg)) {
+        args->filter_as_tree = json_boolean_value(arg);
+        return 1;
+    }
+    else return 0;
+}
+
+static int jmap_mailbox_query(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_query query;
+    mboxquery_args_t args = { 0, 0 };
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_query_parse(req, &parser,
+                     _mboxquery_parse_args, &args,
+                     _mboxquery_parse_filter, NULL,
+                     _mboxquery_parse_comparator, NULL,
+                     &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Search for the mailboxes */
+    int r = _mbox_query(req, &query, &args);
+    if (r) {
+        jmap_error(req, jmap_server_error(r));
+        goto done;
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_query_reply(&query));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_query_fini(&query);
+    return 0;
+}
+
+struct mboxquerychanges_rock {
+    hash_table *removed;
+    modseq_t sincemodseq;
+};
+
+static int _mboxquerychanges_cb(const mbentry_t *mbentry, void *vrock)
+{
+    struct mboxquerychanges_rock *rock = vrock;
+    if (mbentry->foldermodseq > rock->sincemodseq) {
+        hash_insert(mbentry->uniqueid, (void*)1, rock->removed);
+    }
+    return 0;
+}
+
+static int jmap_mailbox_querychanges(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_querychanges query;
+    mboxquery_args_t args = { 0, 0 };
+    int r = 0;
+
+    /* Parse arguments */
+    json_t *err = NULL;
+    jmap_querychanges_parse(req, &parser,
+                            _mboxquery_parse_args, &args,
+                            _mboxquery_parse_filter, NULL,
+                            _mboxquery_parse_comparator, NULL,
+                            &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    modseq_t sincemodseq = atomodseq_t(query.since_querystate);
+    if (!sincemodseq) {
+        jmap_error(req, json_pack("{s:s}", "type", "cannotCalculateChanges"));
+        goto done;
+    }
+
+    /* Prepare query */
+    mboxquery_t *mbquery = _mboxquery_new(req, query.filter, query.sort);
+    if (!_mboxquery_can_calculate_changes(mbquery)) {
+        jmap_error(req, json_pack("{s:s}", "type", "cannotCalculateChanges"));
+        goto done;
+    }
+
+    /* Run the query */
+    mbquery->include_tombstones = 1;
+    mbquery->include_hidden = 1;
+    mbquery->need_name = 1;
+    r = _mboxquery_run(mbquery, &args);
+    if (r) goto done;
+
+    hash_table removed = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&removed, mbquery->result.count + 1, 0);
+    if (mbquery->need_role) {
+        /* The filter includes a condition on role (or hasAnyRole).
+         * We don't keep a history of annotations, so we can't tell
+         * if the mailbox was a match previously and now isn't.
+         * XXX the workaround is to report all mailboxes in removed,
+         * until we have a sane way of tracking annotation changes */
+
+        struct mboxquerychanges_rock rock = { &removed, sincemodseq };
+        int r = mboxlist_usermboxtree(req->accountid, req->authstate,
+                                      _mboxquerychanges_cb, &rock,
+                                      MBOXTREE_TOMBSTONES|
+                                      MBOXTREE_DELETED|
+                                      MBOXTREE_INTERMEDIATES);
+        if (r) goto done;
+    }
+
+    modseq_t highestmodseq = sincemodseq;
+    ssize_t i;
+    for (i = 0; i < mbquery->result.count; i++) {
+        mboxquery_record_t *mbrec = ptrarray_nth(&mbquery->result, i);
+        if (mbrec->mbtype & MBTYPE_DELETED) {
+            if (mbrec->foldermodseq > sincemodseq) {
+                hash_insert(mbrec->id, (void*)1, &removed);
+            }
+        }
+        else if (!jmap_hasrights_byname(req, mbrec->mboxname, ACL_LOOKUP)) {
+            if (mbrec->createdmodseq <= sincemodseq) {
+                hash_insert(mbrec->id, (void*)1, &removed);
+            }
+        }
+        else if (mbrec->foldermodseq > sincemodseq && mbrec->shared_mbtype != _SHAREDMBOX_HIDDEN) {
+            json_array_append_new(query.added, json_pack("{s:s s:i}", "id", mbrec->id, "index", i));
+            hash_insert(mbrec->id, (void*)1, &removed);
+            if (highestmodseq < mbrec->foldermodseq) {
+                highestmodseq = mbrec->foldermodseq;
+            }
+        }
+    }
+    hash_iter *iter = hash_table_iter(&removed);
+    while (hash_iter_next(iter)) {
+        json_array_append_new(query.removed, json_string(hash_iter_key(iter)));
+    }
+    hash_iter_free(&iter);
+    free_hash_table(&removed, NULL);
+    _mboxquery_free(&mbquery);
+
+    /* Build response */
+    struct buf buf = BUF_INITIALIZER;
+    buf_printf(&buf, MODSEQ_FMT, highestmodseq);
+    query.new_querystate = buf_release(&buf);
+    jmap_ok(req, jmap_querychanges_reply(&query));
+
+done:
+    if (r) {
+        jmap_error(req, jmap_server_error(r));
+    }
+    jmap_querychanges_fini(&query);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+/* Combine the UTF-8 encoded JMAP mailbox name and its parent IMAP mailbox
+ * name to a IMAP mailbox name. Does not check for uniqueness.
+ *
+ * Return the malloced, combined name, or NULL on error. */
+static char *_mbox_newname(const char *name, const char *parentname, int is_toplevel)
+{
+    charset_t cs = CHARSET_UNKNOWN_CHARSET;
+    char *mboxname = NULL;
+
+    cs = charset_lookupname("utf-8");
+    if (cs == CHARSET_UNKNOWN_CHARSET) {
+        /* huh? */
+        syslog(LOG_INFO, "charset utf-8 is unknown");
+        goto done;
+    }
+
+    /* Encode mailbox name in IMAP UTF-7 */
+    char *s = charset_to_imaputf7(name, strlen(name), cs, ENCODING_NONE);
+    if (!s) {
+        syslog(LOG_ERR, "Could not convert mailbox name to IMAP UTF-7.");
+        goto done;
+    }
+    mbname_t *mbname = mbname_from_intname(parentname);
+    if (!is_toplevel && !strarray_size(mbname_boxes(mbname)))
+        mbname_push_boxes(mbname, "INBOX");
+    mbname_push_boxes(mbname, s);
+    free(s);
+    mboxname = xstrdup(mbname_intname(mbname));
+    mbname_free(&mbname);
+
+done:
+    charset_free(&cs);
+    return mboxname;
+}
+
+static char *_mbox_tmpname(const char *name, const char *parentname, int is_toplevel)
+{
+    int retries = 0;
+    do {
+        /* Make temporary name */
+        struct buf buf = BUF_INITIALIZER;
+        buf_printf(&buf, "tmp_%s_%s", name, makeuuid());
+        char *mboxname = _mbox_newname(buf_cstring(&buf), parentname, is_toplevel);
+        buf_free(&buf);
+        /* Make sure no such mailbox exists */
+        int r = jmap_mboxlist_lookup(mboxname, NULL, NULL);
+        if (r == IMAP_MAILBOX_NONEXISTENT) {
+            return mboxname;
+        }
+        /* Log any error and retry. */
+        if (r) {
+            syslog(LOG_ERR, "jmap: _mbox_tmpname(%s): %s",
+                    buf_cstring(&buf), error_message(r));
+        }
+    } while (retries < 3);
+    return NULL;
+}
+
+static int _mbox_has_children_cb(const mbentry_t *mbentry __attribute__ ((unused)), void *rock) {
+    int *has_child = (int *) rock;
+    *has_child = 1;
+    return IMAP_OK_COMPLETED;
+}
+
+static int _mbox_has_children(const char *mboxname)
+{
+    int has_child = 0;
+    mboxlist_mboxtree(mboxname, _mbox_has_children_cb, &has_child, MBOXTREE_SKIP_ROOT);
+    return has_child;
+}
+
+struct mboxset_args {
+    char *creation_id;
+    char *mbox_id;
+    char *name;
+    char *parent_id;
+    char *specialuse; // empty string means delete
+    int is_subscribed; /* -1 if not set */
+    int is_seenshared; /* -1 if not set */
+    int is_toplevel;
+    int sortorder;
+    json_t *shareWith; /* NULL if not set */
+    int overwrite_acl;
+    json_t *jargs; // original JSON arguments
+};
+
+static void _mbox_setargs_fini(struct mboxset_args *args)
+{
+    free(args->creation_id);
+    free(args->mbox_id);
+    free(args->parent_id);
+    free(args->name);
+    free(args->specialuse);
+    json_decref(args->jargs);
+}
+
+static char *_mbox_role_to_specialuse(const char *role)
+{
+    if (!role) return NULL;
+    if (!role[0]) return NULL;
+    char *specialuse = strconcat("\\", role, (char *)NULL);
+    specialuse[1] = toupper(specialuse[1]);
+    return specialuse;
+}
+
+EXPORTED int jmap_mailbox_find_role(jmap_req_t *req, const char *role,
+                                    char **mboxnameptr,
+                                    char **uniqueidptr)
+{
+    char *specialuse = _mbox_role_to_specialuse(role);
+    int r = 0;
+
+    if (specialuse) {
+        r = _mbox_find_specialuse(req, specialuse, mboxnameptr, uniqueidptr);
+    }
+
+    free(specialuse);
+
+    return r;
+}
+
+static void _mbox_setargs_parse(json_t *jargs,
+                                struct jmap_parser *parser,
+                                struct mboxset_args *args,
+                                jmap_req_t *req,
+                                int is_create)
+{
+    /* Initialize arguments */
+    memset(args, 0, sizeof(struct mboxset_args));
+    args->sortorder = -1;
+    args->overwrite_acl = 1;
+    args->jargs = json_incref(jargs);
+
+    /* id */
+    json_t *jid = json_object_get(jargs, "id");
+    if (json_is_string(jid) && !is_create) {
+        args->mbox_id = xstrdup(json_string_value(jid));
+    }
+    else if (JNOTNULL(jid) && is_create) {
+        jmap_parser_invalid(parser, "id");
+    }
+
+    /* name */
+    json_t *jname = json_object_get(jargs, "name");
+    if (json_is_string(jname)) {
+        char *name = charset_utf8_normalize(json_string_value(jname));
+        size_t len = strlen(name);
+        int is_valid = 0;
+        size_t i;
+        for (i = 0; i < len; i++) {
+            if (iscntrl(name[i])) {
+                is_valid = 0;
+                break;
+            }
+            else if (!isspace(name[i])) {
+                is_valid = 1;
+            }
+        }
+        if (is_valid) {
+            args->name = name;
+        }
+        else {
+            /* Empty string, bogus characters or just whitespace */
+            jmap_parser_invalid(parser, "name");
+            free(name);
+        }
+    }
+    else if (is_create) {
+        jmap_parser_invalid(parser, "name");
+    }
+
+    /* parentId */
+    json_t *jparentId = json_object_get(jargs, "parentId");
+    if (json_is_string(jparentId)) {
+        const char *parent_id = json_string_value(jparentId);
+        if (parent_id && (*parent_id != '#' || *(parent_id + 1))) {
+            args->parent_id = xstrdup(parent_id);
+        }
+        if (!args->parent_id) {
+            jmap_parser_invalid(parser, "parentId");
+        }
+    } else if (jparentId == json_null() || (is_create && !jparentId)) {
+        args->is_toplevel = 1;
+    }
+
+    /* role */
+    json_t *jrole = json_object_get(jargs, "role");
+    if (json_is_string(jrole)) {
+        const char *role = json_string_value(jrole);
+        int is_valid = 1;
+        if (!strcmp(role, "inbox")) {
+            /* inbox role is server-set */
+            is_valid = 0;
+        } else {
+            char *specialuse = _mbox_role_to_specialuse(role);
+            struct buf buf = BUF_INITIALIZER;
+            // XXX: we should be passing the mailbox name to specialuse_validate to allow
+            // setting the current role back on a mailbox...
+            int r = specialuse_validate(NULL, req->userid, specialuse, &buf);
+            if (r) is_valid = 0;
+            else args->specialuse = buf_release(&buf);
+            free(specialuse);
+            buf_free(&buf);
+        }
+        if (!is_valid) {
+            jmap_parser_invalid(parser, "role");
+        }
+    }
+    else if (jrole == json_null()) {
+        args->specialuse = xstrdup("");
+    }
+    else if (JNOTNULL(jrole)) {
+        jmap_parser_invalid(parser, "role");
+    }
+
+    /* sortOrder */
+    json_t *jsortOrder = json_object_get(jargs, "sortOrder");
+    if (json_is_integer(jsortOrder)) {
+        args->sortorder = json_integer_value(jsortOrder);
+        if (args->sortorder < 0 || args->sortorder >= INT_MAX) {
+            jmap_parser_invalid(parser, "sortOrder");
+        }
+    }
+    else if (JNOTNULL(jsortOrder)) {
+        jmap_parser_invalid(parser, "sortOrder");
+    }
+
+    /* isSubscribed */
+    json_t *jisSubscribed = json_object_get(jargs, "isSubscribed");
+    if (json_is_boolean(jisSubscribed)) {
+        args->is_subscribed = json_boolean_value(jisSubscribed);
+    }
+    else if (jisSubscribed) {
+        jmap_parser_invalid(parser, "isSubscribed");
+    }
+    else {
+        args->is_subscribed = -1;
+    }
+
+    /* isSeenShared */
+    json_t *jisSeenShared = json_object_get(jargs, "isSeenShared");
+    if (json_is_boolean(jisSeenShared)) {
+        args->is_seenshared = json_boolean_value(jisSeenShared);
+    }
+    else if (jisSeenShared) {
+        jmap_parser_invalid(parser, "isSeenShared");
+    }
+    else {
+        args->is_seenshared = -1;
+    }
+
+    if (!is_create) {
+        /* Is shareWith overwritten or patched? */
+        json_t *shareWith = NULL;
+        jmap_parse_sharewith_patch(jargs, &shareWith);
+        if (shareWith) {
+            args->overwrite_acl = 0;
+            json_object_set_new(jargs, "shareWith", shareWith);
+        }
+    }
+
+    /* shareWith */
+    args->shareWith = json_object_get(jargs, "shareWith");
+    if (args->shareWith && JNOTNULL(args->shareWith) &&
+        !json_is_object(args->shareWith)) {
+        jmap_parser_invalid(parser, "shareWith");
+    }
+
+    /* All of these are server-set. */
+    json_t *jrights = json_object_get(jargs, "myRights");
+    if (json_is_object(jrights) && !is_create) {
+        /* Update allows clients to set myRights, as long as
+         * it doesn't change their values. Don't bother with
+         * that during parsing, just make sure that it is
+         * syntactically valid. */
+        const char *right;
+        json_t *jval;
+        jmap_parser_push(parser, "myRights");
+        json_object_foreach(jrights, right, jval) {
+            if (!json_is_boolean(jval))
+                jmap_parser_invalid(parser, right);
+        }
+        jmap_parser_pop(parser);
+    }
+    else if (JNOTNULL(jrights)) {
+        jmap_parser_invalid(parser, "myRights");
+    }
+
+    if (json_object_get(jargs, "totalEmails") && is_create)
+        jmap_parser_invalid(parser, "totalEmails");
+    if (json_object_get(jargs, "unreadEmails") && is_create)
+        jmap_parser_invalid(parser, "unreadEmails");
+    if (json_object_get(jargs, "totalThreads") && is_create)
+        jmap_parser_invalid(parser, "totalThreads");
+    if (json_object_get(jargs, "unreadThreads") && is_create)
+        jmap_parser_invalid(parser, "unreadThreads");
+}
+
+static int _mbox_set_annots(jmap_req_t *req,
+                            struct mboxset_args *args,
+                            const char *mboxname)
+{
+    int r = 0;
+    struct buf buf = BUF_INITIALIZER;
+
+    if (args->name) {
+        /* Set displayname annotation on mailbox. This is a PRIVATE annotation,
+         * on the account owner */
+        buf_setcstr(&buf, args->name);
+        static const char *displayname_annot = IMAP_ANNOT_NS "displayname";
+        r = annotatemore_write(mboxname, displayname_annot, req->accountid, &buf);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    displayname_annot, error_message(r));
+            goto done;
+        }
+        buf_reset(&buf);
+    }
+
+    /* Set specialuse.  This is a PRIVATE annotation on the account owner */
+    if (args->specialuse) {
+        buf_setcstr(&buf, args->specialuse);
+        static const char *annot = "/specialuse";
+        r = annotatemore_write(mboxname, annot, req->accountid, &buf);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    annot, error_message(r));
+            goto done;
+        }
+        buf_reset(&buf);
+    }
+
+    if (args->sortorder >= 0) {
+        /* Set sortOrder annotation on mailbox.  This is a masked private annotation
+         * for the authenticated user */
+        buf_printf(&buf, "%d", args->sortorder);
+        static const char *sortorder_annot = IMAP_ANNOT_NS "sortorder";
+        r = annotatemore_writemask(mboxname, sortorder_annot, httpd_userid, &buf);
+        if (r) {
+            syslog(LOG_ERR, "failed to write annotation %s: %s",
+                    sortorder_annot, error_message(r));
+            goto done;
+        }
+    }
+
+done:
+    buf_free(&buf);
+    return r;
+}
+
+enum mboxset_runmode { _MBOXSET_FAIL, _MBOXSET_SKIP, _MBOXSET_TMPNAME };
+
+struct mboxset_result {
+    json_t *err;
+    int skipped;
+    char *old_imapname;
+    char *new_imapname;
+    char *tmp_imapname;
+};
+
+static void _mboxset_result_fini(struct mboxset_result *result)
+{
+    json_decref(result->err);
+    free(result->old_imapname);
+    free(result->new_imapname);
+    free(result->tmp_imapname);
+}
+
+#define MBOXSET_RESULT_INITIALIZER { NULL, 0, NULL, NULL, NULL }
+
+
+static void _mbox_create(jmap_req_t *req, struct mboxset_args *args,
+                         enum mboxset_runmode mode,
+                         json_t **mbox, struct mboxset_result *result,
+                         strarray_t *update_intermediaries)
+{
+    char *mboxname = NULL;
+    int r = 0;
+    mbentry_t *mbinbox = NULL, *mbentry = NULL;
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct mailbox *mailbox = NULL;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    jmap_mboxlist_lookup(inboxname, &mbinbox, NULL);
+    free(inboxname);
+
+    /* Lookup parent creation id, if any. This also deals with
+     * bogus Mailbox/set operations that attempt to create
+     * cycles in the mailbox tree: they'll all fail due to
+     * unresolvable parentIds. */
+    const char *parent_id = args->parent_id;
+    if (parent_id && *parent_id == '#') {
+        parent_id = jmap_lookup_id(req, parent_id + 1);
+        if (!parent_id) {
+            if (mode == _MBOXSET_SKIP) {
+                result->skipped = 1;
+            }
+            else {
+                jmap_parser_invalid(&parser, "parentId");
+            }
+            goto done;
+        }
+    }
+    parent_id = args->is_toplevel ? mbinbox->uniqueid : parent_id;
+
+    /* Check parent exists and has the proper ACL. */
+    const mbentry_t *mbparent = jmap_mbentry_by_uniqueid(req, parent_id);
+    if (!mbparent || !jmap_hasrights(req, mbparent, ACL_CREATE)) {
+        jmap_parser_invalid(&parser, "parentId");
+        goto done;
+    }
+
+    /* Encode the mailbox name for IMAP. */
+    mboxname = _mbox_newname(args->name, mbparent->name, args->is_toplevel);
+    if (!mboxname) {
+        syslog(LOG_ERR, "could not encode mailbox name");
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Check if a mailbox with this name exists */
+    r = jmap_mboxlist_lookup(mboxname, NULL, NULL);
+    if (r == 0) {
+        if (mode == _MBOXSET_SKIP) {
+            result->skipped = 1;
+            goto done;
+        }
+        else if (mode == _MBOXSET_TMPNAME) {
+            result->new_imapname = xstrdup(mboxname);
+            result->old_imapname = NULL;
+            result->tmp_imapname = _mbox_tmpname(args->name, mbparent->name, args->is_toplevel);
+            if (!result->tmp_imapname) {
+                syslog(LOG_ERR, "jmap: no mailbox tmpname for %s", mboxname);
+                r = IMAP_INTERNAL;
+                goto done;
+            }
+            free(mboxname);
+            mboxname = xstrdup(result->tmp_imapname);
+            /* Keep on processing with tmpname */
+        }
+        else {
+            syslog(LOG_ERR, "jmap: mailbox already exists: %s", mboxname);
+            jmap_parser_invalid(&parser, "name");
+            goto done;
+        }
+    }
+    else if (r != IMAP_MAILBOX_NONEXISTENT) {
+        goto done;
+    }
+    r = 0;
+
+    /* Create mailbox */
+    uint32_t options = 0;
+    if (args->is_seenshared > 0) options |= OPT_IMAP_SHAREDSEEN;
+    if (args->specialuse && !strcmp("\\Snoozed", args->specialuse))
+        options |= OPT_IMAP_HAS_ALARMS;
+
+    r = mboxlist_createsync(mboxname, 0 /* MBTYPE */,
+            NULL /* partition */,
+            req->userid, req->authstate,
+            options, 0 /* uidvalidity */,
+            0 /* createdmodseq */,
+            0 /* highestmodseq */,
+            0 /* foldermodseq */, NULL /* acl */,
+            NULL /* uniqueid */, 0 /* local_only */,
+            1, /* keep_intermediaries */
+            args->shareWith ? &mailbox : NULL);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                mboxname, error_message(r));
+        goto done;
+    }
+    strarray_add(update_intermediaries, mboxname);
+
+     /* invalidate ACL cache */
+    jmap_myrights_delete(req, mboxname);
+    jmap_mbentry_cache_free(req);
+
+    /* shareWith */
+    if (args->shareWith) {
+        r = jmap_set_sharewith(mailbox, args->shareWith, args->overwrite_acl);
+        mailbox_close(&mailbox);
+    }
+    if (r) goto done;
+
+    /* Write annotations and isSubscribed */
+    r = _mbox_set_annots(req, args, mboxname);
+    if (!r && args->is_subscribed > 0) {
+        r = mboxlist_changesub(mboxname, req->userid, httpd_authstate, 1, 0, 0);
+    }
+    if (r) goto done;
+
+    /* Lookup and return the new mailbox id */
+    r = jmap_mboxlist_lookup(mboxname, &mbentry, NULL);
+    if (r) goto done;
+    *mbox = json_pack("{s:s}", "id", mbentry->uniqueid);
+    /* Set server defaults */
+    if (args->is_subscribed < 0) {
+        json_object_set_new(*mbox, "isSubscribed", json_false());
+    }
+    if (args->is_seenshared < 0) {
+        json_object_set_new(*mbox, "isSeenShared", json_false());
+    }
+    if (args->sortorder < 0) {
+        mbname_t *mbname = mbname_from_intname(mboxname);
+        json_object_set_new(*mbox, "sortOrder", json_integer(_mbox_get_sortorder(req, mbname)));
+        mbname_free(&mbname);
+    }
+
+done:
+    if (json_array_size(parser.invalid)) {
+        result->err = json_pack("{s:s}", "type", "invalidProperties");
+        json_object_set(result->err, "properties", parser.invalid);
+    }
+    else if (r) {
+        result->err = jmap_server_error(r);
+    }
+    free(mboxname);
+    mboxlist_entry_free(&mbinbox);
+    mboxlist_entry_free(&mbentry);
+    jmap_parser_fini(&parser);
+}
+
+static int _mbox_update_validate_serverset(jmap_req_t *req,
+                                           struct mboxset_args *args,
+                                           struct jmap_parser *parser,
+                                           mbentry_t *mbentry)
+{
+    /* Validate read counts */
+    if (json_object_get(args->jargs, "totalEmails") ||
+        json_object_get(args->jargs, "unreadEmails") ||
+        json_object_get(args->jargs, "totalThreads") ||
+        json_object_get(args->jargs, "unreadThreads")) {
+
+        mbname_t *mbname = mbname_from_intname(mbentry->name);
+        json_t *tmp = json_object();
+        int r = _mbox_get_readcounts(req, mbname, NULL, tmp);
+        if (!r) {
+            json_t *jval = json_object_get(args->jargs, "totalEmails");
+            if (jval && !json_equal(jval, json_object_get(tmp, "totalEmails"))) {
+                jmap_parser_invalid(parser, "totalEmails");
+            }
+            jval = json_object_get(args->jargs, "unreadEmails");
+            if (jval && !json_equal(jval, json_object_get(tmp, "unreadEmails"))) {
+                jmap_parser_invalid(parser, "unreadEmails");
+            }
+            jval = json_object_get(args->jargs, "totalThreads");
+            if (jval && !json_equal(jval, json_object_get(tmp, "totalThreads"))) {
+                jmap_parser_invalid(parser, "totalThreads");
+            }
+            jval = json_object_get(args->jargs, "unreadThreads");
+            if (jval && !json_equal(jval, json_object_get(tmp, "unreadThreads"))) {
+                jmap_parser_invalid(parser, "unreadThreads");
+            }
+        }
+        json_decref(tmp);
+        mbname_free(&mbname);
+        if (r) return r;
+    }
+
+    /* Validate myRights */
+    json_t *jpatch = json_copy(args->jargs);
+    const char *propname;
+    json_t *jval;
+    void *vtmp;
+    json_object_foreach_safe(jpatch, vtmp, propname, jval) {
+        if (strcmp(propname, "myRights") && strncmp(propname, "myRights/", 9)) {
+            json_object_del(jpatch, propname);
+        }
+    }
+    json_t *jcurRights = _mbox_get_myrights(req, mbentry);
+    json_t *jold = json_pack("{s:o}", "myRights", json_copy(jcurRights));
+    json_t *invalid = json_array();
+    json_t *jnew = jmap_patchobject_apply(jold, jpatch, invalid);
+    if (json_array_size(invalid) == 0) {
+        json_t *jnewRights = json_object_get(jnew, "myRights");
+        if (!json_equal(jcurRights, jnewRights)) {
+            jmap_parser_invalid(parser, "myRights");
+        }
+    }
+    else json_array_extend(parser->invalid, invalid);
+    json_decref(jnew);
+    json_decref(jold);
+    json_decref(invalid);
+    json_decref(jpatch);
+    json_decref(jcurRights);
+
+    return 0;
+}
+
+static void _mbox_update(jmap_req_t *req, struct mboxset_args *args,
+                         enum mboxset_runmode mode,
+                         struct mboxset_result *result,
+                         strarray_t *update_intermediaries)
+{
+    /* So many names... manage them in our own string pool */
+    ptrarray_t strpool = PTRARRAY_INITIALIZER;
+    int r = 0;
+    mbentry_t *mbinbox = NULL, *mbparent = NULL, *mbentry = NULL;
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    jmap_mboxlist_lookup(inboxname, &mbinbox, NULL);
+    free(inboxname);
+
+    const char *parent_id = args->parent_id;
+    if (parent_id && *parent_id == '#') {
+        parent_id = jmap_lookup_id(req, parent_id + 1);
+        if (!parent_id) {
+            if (mode == _MBOXSET_SKIP) {
+                result->skipped = 1;
+            }
+            else {
+                jmap_parser_invalid(&parser, "parentId");
+            }
+            goto done;
+        }
+    }
+
+    /* Lookup current mailbox entry */
+    mbentry = jmap_mbentry_by_uniqueid_copy(req, args->mbox_id);
+    if (!mbentry || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+        mboxlist_entry_free(&mbentry);
+        result->err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+
+    /* Validate server-set properties */
+    _mbox_update_validate_serverset(req, args, &parser, mbentry);
+
+    /* Determine current mailbox and parent names */
+    char *oldmboxname = NULL;
+    char *oldparentname = NULL;
+    int was_toplevel = 0;
+    int is_inbox = 0;
+    if (strcmp(args->mbox_id, mbinbox->uniqueid)) {
+        oldmboxname = xstrdup(mbentry->name);
+        r = _findparent(oldmboxname, &mbparent);
+        if (r) {
+            syslog(LOG_INFO, "_findparent(%s) failed: %s",
+                            oldmboxname, error_message(r));
+            goto done;
+        }
+        oldparentname = xstrdup(mbparent->name);
+        ptrarray_append(&strpool, oldparentname);
+
+        // calculate whether mailbox is toplevel
+        mbname_t *mbname = mbname_from_intname(oldmboxname);
+        was_toplevel = strarray_size(mbname_boxes(mbname)) == 1;
+        mbname_free(&mbname);
+    }
+    else {
+        if (parent_id || args->is_toplevel) {
+            // thou shalt not move INBOX
+           jmap_parser_invalid(&parser, "parentId");
+           goto done;
+        }
+        is_inbox = 1;
+
+        oldmboxname = xstrdup(mbinbox->name);
+    }
+    ptrarray_append(&strpool, oldmboxname);
+
+    /* Now parent_id always has a proper mailbox id */
+    parent_id = args->is_toplevel ? mbinbox->uniqueid : parent_id;
+
+    /* Do we need to move this mailbox to a new parent? */
+    const char *parentname = oldparentname;
+    int is_toplevel = was_toplevel;
+    int force_rename = 0;
+
+    if (!is_inbox && (parent_id || args->is_toplevel)) {
+        /* Compare old parent with new parent. */
+        char *newparentname = NULL;
+
+        mbentry_t *pmbentry = jmap_mbentry_by_uniqueid_copy(req, parent_id);
+        if (pmbentry && jmap_hasrights(req, pmbentry, ACL_LOOKUP)) {
+            newparentname = xstrdup(pmbentry->name);
+        }
+        mboxlist_entry_free(&pmbentry);
+
+        int new_toplevel = args->is_toplevel;
+        if (!newparentname) {
+            jmap_parser_invalid(&parser, "parentId");
+            goto done;
+        }
+        ptrarray_append(&strpool, newparentname);
+
+        /* Reject cycles in mailbox tree. */
+        char *pname = xstrdup(newparentname);
+        while (_findparent(pname, &pmbentry) == 0) {
+            if (!strcmp(args->mbox_id, pmbentry->uniqueid)) {
+                jmap_parser_invalid(&parser, "parentId");
+                free(pname);
+                mboxlist_entry_free(&pmbentry);
+                goto done;
+            }
+            free(pname);
+            pname = xstrdup(pmbentry->name);
+            mboxlist_entry_free(&pmbentry);
+        }
+        mboxlist_entry_free(&pmbentry);
+        free(pname);
+
+        /* Is this a move to a new parent? */
+        if (strcmpsafe(oldparentname, newparentname) || was_toplevel != new_toplevel) {
+            /* Check ACL of mailbox */
+            if (!jmap_hasrights_byname(req, oldparentname, ACL_DELETEMBOX)) {
+                result->err = json_pack("{s:s}", "type", "forbidden");
+                goto done;
+            }
+
+            /* Reset pointers to parent */
+            mboxlist_entry_free(&mbparent);
+            jmap_mboxlist_lookup(newparentname, &mbparent, NULL);
+
+            /* Check ACL of new parent - need WRITE to set displayname annot */
+            if (!jmap_hasrights(req, mbparent, ACL_CREATE|ACL_WRITE)) {
+                jmap_parser_invalid(&parser, "parentId");
+                goto done;
+            }
+
+            force_rename = 1;
+            parentname = newparentname;
+            is_toplevel = new_toplevel;
+        }
+    }
+
+    const char *mboxname = oldmboxname;
+
+    /* Do we need to rename the mailbox? But only if it isn't the INBOX! */
+    if (!is_inbox && (args->name || force_rename)) {
+        mbname_t *mbname = mbname_from_intname(oldmboxname);
+        char *oldname = _mbox_get_name(req->accountid, mbname);
+        mbname_free(&mbname);
+        ptrarray_append(&strpool, oldname);
+        char *name = oldname;
+        if (args->name && strcmp(name, args->name)) {
+            name = args->name;
+            force_rename = 1;
+        }
+
+        /* Do old and new mailbox names differ? */
+        if (force_rename) {
+
+            /* Determine the unique IMAP mailbox name. */
+            char *newmboxname = _mbox_newname(name, parentname, is_toplevel);
+            if (!newmboxname) {
+                syslog(LOG_ERR, "_mbox_newname returns NULL: can't rename %s", mboxname);
+                r = IMAP_INTERNAL;
+                goto done;
+            }
+            ptrarray_append(&strpool, newmboxname);
+
+            r = jmap_mboxlist_lookup(newmboxname, NULL, NULL);
+            if (r == 0) {
+                if (mode == _MBOXSET_SKIP) {
+                    result->skipped = 1;
+                    goto done;
+                }
+                else if (mode == _MBOXSET_TMPNAME) {
+                    result->new_imapname = xstrdup(newmboxname);
+                    result->old_imapname = xstrdup(oldmboxname);
+                    result->tmp_imapname = _mbox_tmpname(name, parentname, is_toplevel);
+                    if (!result->tmp_imapname) {
+                        syslog(LOG_ERR, "jmap: no mailbox tmpname for %s", newmboxname);
+                        r = IMAP_INTERNAL;
+                        goto done;
+                    }
+                    newmboxname = xstrdup(result->tmp_imapname);
+                    ptrarray_append(&strpool, newmboxname);
+                    /* Keep on processing with tmpname */
+                }
+                else {
+                    syslog(LOG_ERR, "jmap: mailbox already exists: %s", newmboxname);
+                    jmap_parser_invalid(&parser, "name");
+                    goto done;
+                }
+            }
+            else if (r != IMAP_MAILBOX_NONEXISTENT) {
+                goto done;
+            }
+            r = 0;
+
+            /* Rename the mailbox. */
+            if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+                r = mboxlist_promote_intermediary(oldmboxname);
+                if (r) goto done;
+            }
+            struct mboxevent *mboxevent = mboxevent_new(EVENT_MAILBOX_RENAME);
+            r = mboxlist_renametree(oldmboxname, newmboxname,
+                    NULL /* partition */, 0 /* uidvalidity */,
+                    httpd_userisadmin, req->userid, httpd_authstate,
+                    mboxevent,
+                    0 /* local_only */, 0 /* forceuser */, 0 /* ignorequota */,
+                    1 /* keep_intermediaries */, 1 /* move_subscription */);
+            mboxevent_free(&mboxevent);
+            mboxlist_entry_free(&mbentry);
+            jmap_mboxlist_lookup(newmboxname, &mbentry, NULL);
+            strarray_add(update_intermediaries, oldmboxname);
+            strarray_add(update_intermediaries, newmboxname);
+
+            /* Keep track of old IMAP name */
+            if (!result->old_imapname)
+                result->old_imapname = xstrdup(oldmboxname);
+
+            /* invalidate ACL cache */
+            jmap_myrights_delete(req, oldmboxname);
+            jmap_myrights_delete(req, newmboxname);
+            jmap_mbentry_cache_free(req);
+
+            if (r) {
+                syslog(LOG_ERR, "mboxlist_renametree(old=%s new=%s): %s",
+                        oldmboxname, newmboxname, error_message(r));
+                goto done;
+            }
+            mboxname = newmboxname;  // cheap and nasty change!
+        }
+    }
+
+    /* Write annotations and isSubscribed */
+    if (args->name || args->specialuse || args->sortorder >= 0) {
+        if (!jmap_hasrights(req, mbentry, ACL_WRITE)) {
+            mboxlist_entry_free(&mbentry);
+            result->err = json_pack("{s:s}", "type", "forbidden");
+            goto done;
+        }
+        if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+            r = mboxlist_promote_intermediary(mbentry->name);
+            if (r) goto done;
+            mboxlist_entry_free(&mbentry);
+            jmap_mboxlist_lookup(mboxname, &mbentry, NULL);
+        }
+        if (!r) r = _mbox_set_annots(req, args, mboxname);
+    }
+    if (!r && args->is_subscribed >= 0) {
+        r = mboxlist_changesub(mboxname, req->userid, httpd_authstate,
+                               args->is_subscribed, 0, 0);
+    }
+    if (!r && (args->shareWith || args->is_seenshared >= 0)) {
+        struct mailbox *mbox = NULL;
+        uint32_t newopts;
+
+        r = jmap_openmbox(req, mboxname, &mbox, 1);
+        if (r) goto done;
+
+        if (args->shareWith) {
+            r = jmap_set_sharewith(mbox, args->shareWith, args->overwrite_acl);
+        }
+
+        if (!r && args->is_seenshared >= 0) {
+            newopts = mbox->i.options;
+            if (args->is_seenshared) newopts |= OPT_IMAP_SHAREDSEEN;
+            else newopts &= ~OPT_IMAP_SHAREDSEEN;
+
+            /* only mark dirty if there's been a change */
+            if (mbox->i.options != newopts) {
+                mailbox_index_dirty(mbox);
+                mailbox_modseq_dirty(mbox);
+                mbox->i.options = newopts;
+                mboxlist_update_foldermodseq(mbox->name, mbox->i.highestmodseq);
+            }
+        }
+        jmap_closembox(req, &mbox);
+    }
+    if (r) goto done;
+
+done:
+    if (json_array_size(parser.invalid)) {
+        result->err = json_pack("{s:s}", "type", "invalidProperties");
+        json_object_set(result->err, "properties", parser.invalid);
+    }
+    else if (r && result->err == NULL) {
+        result->err = jmap_server_error(r);
+    }
+    jmap_parser_fini(&parser);
+    while (strpool.count) free(ptrarray_pop(&strpool));
+    ptrarray_fini(&strpool);
+    mboxlist_entry_free(&mbinbox);
+    mboxlist_entry_free(&mbparent);
+    mboxlist_entry_free(&mbentry);
+}
+
+static void _mbox_destroy(jmap_req_t *req, const char *mboxid, int remove_msgs,
+                          enum mboxset_runmode mode,
+                          struct mboxset_result *result, strarray_t *update_intermediaries)
+{
+    int r = 0;
+    mbentry_t *mbinbox = NULL, *mbentry = NULL;
+    int is_intermediate = 0;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    jmap_mboxlist_lookup(inboxname, &mbinbox, NULL);
+    free(inboxname);
+
+    /* Do not allow to remove INBOX. */
+    if (!strcmpsafe(mboxid, mbinbox->uniqueid)) {
+        result->err = json_pack("{s:s}", "type", "forbidden");
+        goto done;
+    }
+
+    /* Lookup mailbox by id. */
+    mbentry = jmap_mbentry_by_uniqueid_copy(req, mboxid);
+    if (!mbentry) {
+        result->err = json_pack("{s:s}", "type", "notFound");
+        goto done;
+    }
+    /* Check ACL */
+    if (!jmap_hasrights(req, mbentry, ACL_DELETEMBOX)) {
+        result->err = json_pack("{s:s}", "type", "forbidden");
+        goto done;
+    }
+    is_intermediate = mbentry->mbtype & MBTYPE_INTERMEDIATE;
+
+    /* Check if the mailbox has any children. */
+    if (_mbox_has_children(mbentry->name)) {
+        if (mode == _MBOXSET_SKIP) {
+            result->skipped = 1;
+        }
+        else {
+            result->err = json_pack("{s:s}", "type", "mailboxHasChild");
+        }
+        goto done;
+    }
+
+    if (!remove_msgs && !is_intermediate) {
+        /* Check if the mailbox has any messages */
+        struct mailbox *mbox = NULL;
+        struct mailbox_iter *iter = NULL;
+
+        r = jmap_openmbox(req, mbentry->name, &mbox, 0);
+        if (r) goto done;
+        iter = mailbox_iter_init(mbox, 0, ITER_SKIP_EXPUNGED);
+        if (mailbox_iter_step(iter) != NULL) {
+            result->err = json_pack("{s:s}", "type", "mailboxHasEmail");
+        }
+        mailbox_iter_done(&iter);
+        jmap_closembox(req, &mbox);
+        if (result->err) goto done;
+    }
+
+    /* Destroy mailbox. */
+    struct mboxevent *mboxevent = mboxevent_new(EVENT_MAILBOX_DELETE);
+    if (mboxlist_delayed_delete_isenabled()) {
+        r = mboxlist_delayed_deletemailbox(mbentry->name,
+                httpd_userisadmin || httpd_userisproxyadmin,
+                req->userid, req->authstate, mboxevent,
+                1 /* checkacl */, 0 /* local_only */, 0 /* force */,
+                1 /* keep_intermediaries */);
+    }
+    else {
+        r = mboxlist_deletemailbox(mbentry->name,
+                httpd_userisadmin || httpd_userisproxyadmin,
+                req->userid, req->authstate, mboxevent,
+                1 /* checkacl */, 0 /* local_only */, 0 /* force */,
+                1 /* keep_intermediaries */);
+    }
+    mboxevent_free(&mboxevent);
+
+    if (r == IMAP_PERMISSION_DENIED) {
+        result->err = json_pack("{s:s}", "type", "forbidden");
+        r = 0;
+        goto done;
+    }
+    else if (r == IMAP_MAILBOX_NONEXISTENT) {
+        if (!is_intermediate) {
+            result->err = json_pack("{s:s}", "type", "notFound");
+        }
+        r = 0;
+        goto done;
+    }
+    else if (r) {
+        goto done;
+    }
+
+    /* Remove subscription */
+    int r2 = mboxlist_changesub(mbentry->name, req->userid, httpd_authstate, 0, 0, 0);
+    if (r2) {
+        syslog(LOG_ERR, "jmap: mbox_destroy: can't unsubscribe %s:%s",
+                mbentry->name, error_message(r2));
+    }
+
+    strarray_add(update_intermediaries, mbentry->name);
+
+    /* invalidate ACL cache */
+    jmap_myrights_delete(req, mbentry->name);
+    jmap_mbentry_cache_free(req);
+
+    /* Keep track of the deleted mailbox name */
+    result->old_imapname = xstrdup(mbentry->name);
+
+done:
+    if (r) {
+        if (result->err == NULL)
+            result->err = jmap_server_error(r);
+        syslog(LOG_ERR, "failed to delete mailbox(%s): %s",
+               mboxid, error_message(r));
+    }
+    mboxlist_entry_free(&mbinbox);
+    mboxlist_entry_free(&mbentry);
+}
+
+struct mboxset {
+    struct jmap_set super;
+    ptrarray_t create;
+    ptrarray_t update;
+    strarray_t destroy;
+    int on_destroy_remove_msgs;
+};
+
+struct toposort {
+    hash_table *parent_id_by_id;
+    strarray_t *dst;
+    hash_table visited;
+    int is_cyclic;
+};
+
+static void _toposort_cb(const char *id, void *data, void *rock)
+{
+    struct toposort *topo = rock;
+    const char *parent_id = data;
+
+    /* Return cyclic graphs in any order */
+    if (topo->is_cyclic) {
+        if (hash_lookup(id, &topo->visited) == NULL &&
+            hash_lookup(id, topo->parent_id_by_id)) {
+            strarray_append(topo->dst, id);
+        }
+        return;
+    }
+    /* Check if node is already visited */
+    void *v = hash_lookup(id, &topo->visited);
+    if (v) {
+        if (v == (void*)1) {
+            /* Temporary mark indiciates a cycle */
+            topo->is_cyclic = 1;
+        }
+        return;
+    }
+    /* Mark this node temporarily */
+    hash_insert(id, (void*)1, &topo->visited);
+    /* Visit parent */
+    char *grandparent_id = hash_lookup(parent_id, topo->parent_id_by_id);
+    if (grandparent_id)
+        _toposort_cb(parent_id, grandparent_id, rock);
+    /* Mark this node permanently */
+    hash_insert(id, (void*)2, &topo->visited);
+    /* Append key node to list */
+    if (hash_lookup(id, topo->parent_id_by_id)) {
+        strarray_append(topo->dst, id);
+    }
+}
+
+static int _toposort(hash_table *parent_id_by_id, strarray_t *dst)
+{
+    struct toposort topo = { parent_id_by_id, dst, HASH_TABLE_INITIALIZER, 0 };
+    construct_hash_table(&topo.visited, hash_numrecords(parent_id_by_id) + 1, 0);
+    hash_enumerate(topo.parent_id_by_id, _toposort_cb, &topo);
+    free_hash_table(&topo.visited, NULL);
+    free_hash_table(&topo.visited, NULL);
+    return topo.is_cyclic ? -1 : 0;
+}
+
+struct mboxset_ops {
+    ptrarray_t *put;
+    strarray_t *del;
+    int is_cyclic;
+};
+
+static void _mboxset_ops_free(struct mboxset_ops *ops)
+{
+    ptrarray_free(ops->put);
+    strarray_free(ops->del);
+    free(ops);
+}
+
+static struct mboxset_ops *_mboxset_newops(jmap_req_t *req, struct mboxset *set)
+{
+    int i;
+
+    struct mboxset_ops *ops = xzmalloc(sizeof(struct mboxset_ops));
+    ops->put = ptrarray_new();
+    ops->del = strarray_new();
+
+    /* Sort create and update operations, parent before child */
+    if (ptrarray_size(&set->create) || ptrarray_size(&set->update)) {
+        hash_table args_by_id = HASH_TABLE_INITIALIZER;
+        hash_table parent_id_by_id = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&parent_id_by_id,
+                ptrarray_size(&set->create) || ptrarray_size(&set->update), 0);
+        construct_hash_table(&args_by_id,
+                ptrarray_size(&set->create) || ptrarray_size(&set->update), 0);
+
+        struct buf buf = BUF_INITIALIZER;
+        for (i = 0; i < ptrarray_size(&set->create); i++) {
+            struct mboxset_args *args = ptrarray_nth(&set->create, i);
+            if (!args->parent_id) {
+                ptrarray_append(ops->put, args);
+                continue;
+            }
+            buf_putc(&buf, '#');
+            buf_appendcstr(&buf, args->creation_id);
+            hash_insert(buf_cstring(&buf), args->parent_id, &parent_id_by_id);
+            hash_insert(buf_cstring(&buf), args, &args_by_id);
+            buf_reset(&buf);
+        }
+        buf_free(&buf);
+        for (i = 0; i < ptrarray_size(&set->update); i++) {
+            struct mboxset_args *args = ptrarray_nth(&set->update, i);
+            if (!args->parent_id) {
+                ptrarray_append(ops->put, args);
+                continue;
+            }
+            hash_insert(args->mbox_id, args->parent_id, &parent_id_by_id);
+            hash_insert(args->mbox_id, args, &args_by_id);
+        }
+        strarray_t tmp = STRARRAY_INITIALIZER;
+        if (_toposort(&parent_id_by_id, &tmp) < 0) {
+            ops->is_cyclic = 1;
+        }
+        for (i = 0; i < strarray_size(&tmp); i++) {
+            const char *id = strarray_nth(&tmp, i);
+            ptrarray_append(ops->put, hash_lookup(id, &args_by_id));
+        }
+        strarray_fini(&tmp);
+        free_hash_table(&parent_id_by_id, NULL);
+        free_hash_table(&args_by_id, NULL);
+    }
+
+    /* Sort delete operations, children before parent */
+    if (strarray_size(&set->destroy)) {
+        hash_table parent_id_by_id = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&parent_id_by_id, set->destroy.count + 1, 0);
+        for (i = 0; i < strarray_size(&set->destroy); i++) {
+            const char *mbox_id = strarray_nth(&set->destroy, i);
+            const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mbox_id);
+            if (!mbentry || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+                json_object_set_new(set->super.not_destroyed, mbox_id,
+                        json_pack("{s:s}", "type", "notFound"));
+                continue;
+            }
+            mbentry_t *parent = NULL;
+            if (_findparent(mbentry->name, &parent) == 0) {
+                hash_insert(mbox_id, xstrdup(parent->uniqueid), &parent_id_by_id);
+            }
+            else {
+                strarray_append(ops->del, mbox_id);
+            }
+            mboxlist_entry_free(&parent);
+        }
+        strarray_t tmp = STRARRAY_INITIALIZER;
+        _toposort(&parent_id_by_id, &tmp); /* destroy can't be cyclic */
+        for (i = tmp.count - 1; i >= 0; i--)
+            strarray_append(ops->del, strarray_nth(&tmp, i));
+        strarray_fini(&tmp);
+        free_hash_table(&parent_id_by_id, free);
+    }
+
+    return ops;
+}
+
+static void _mboxset_run(jmap_req_t *req, struct mboxset *set,
+                         struct mboxset_ops *ops,
+                         enum mboxset_runmode mode,
+                         strarray_t *update_intermediaries)
+{
+    int i;
+    strarray_t skipped_del = STRARRAY_INITIALIZER;
+    ptrarray_t skipped_put = PTRARRAY_INITIALIZER;
+    ptrarray_t tmp_renames = PTRARRAY_INITIALIZER;
+    struct tmp_rename {
+        char *old_imapname;
+        char *new_imapname;
+        char *tmp_imapname;
+    };
+
+    /* Run create and update operations */
+    for (i = 0; i < ptrarray_size(ops->put); i++) {
+        struct mboxset_args *args = ptrarray_nth(ops->put, i);
+        /* Create */
+        if (args->creation_id) {
+            json_t *mbox = NULL;
+            struct mboxset_result result = MBOXSET_RESULT_INITIALIZER;
+            _mbox_create(req, args, mode, &mbox, &result, update_intermediaries);
+            if (result.err) {
+                json_object_set(set->super.not_created,
+                        args->creation_id, result.err);
+            }
+            else if (result.skipped) {
+                ptrarray_append(&skipped_put, args);
+            }
+            else {
+                json_object_set_new(set->super.created, args->creation_id, mbox);
+                jmap_add_id(req, args->creation_id,
+                        json_string_value(json_object_get(mbox, "id")));
+                if (result.tmp_imapname) {
+                    struct tmp_rename *tmp = xzmalloc(sizeof(struct tmp_rename));
+                    tmp->old_imapname = xstrdupnull(result.old_imapname);
+                    tmp->new_imapname = xstrdup(result.new_imapname);
+                    tmp->tmp_imapname = xstrdup(result.tmp_imapname);
+                    ptrarray_append(&tmp_renames, tmp);
+                }
+            }
+            _mboxset_result_fini(&result);
+        }
+        /* Update */
+        else {
+            struct mboxset_result result = MBOXSET_RESULT_INITIALIZER;
+            _mbox_update(req, args, mode, &result, update_intermediaries);
+            if (result.err) {
+                json_object_set(set->super.not_updated,
+                        args->mbox_id, result.err);
+            }
+            else if (result.skipped) {
+                ptrarray_append(&skipped_put, args);
+            }
+            else {
+                json_object_set(set->super.updated, args->mbox_id, json_null());
+                if (result.tmp_imapname) {
+                    struct tmp_rename *tmp = xzmalloc(sizeof(struct tmp_rename));
+                    tmp->old_imapname = xstrdupnull(result.old_imapname);
+                    tmp->new_imapname = xstrdup(result.new_imapname);
+                    tmp->tmp_imapname = xstrdup(result.tmp_imapname);
+                    ptrarray_append(&tmp_renames, tmp);
+                }
+            }
+            _mboxset_result_fini(&result);
+        }
+    }
+    ptrarray_truncate(ops->put, 0);
+    for (i = 0; i < ptrarray_size(&skipped_put); i++)
+        ptrarray_append(ops->put, ptrarray_nth(&skipped_put, i));
+
+    /* Run destroy operations */
+    for (i = 0; i < strarray_size(ops->del); i++) {
+        const char *mbox_id = strarray_nth(ops->del, i);
+        struct mboxset_result result = MBOXSET_RESULT_INITIALIZER;
+        _mbox_destroy(req, mbox_id, set->on_destroy_remove_msgs, mode, &result, update_intermediaries);
+        if (result.err) {
+            json_object_set(set->super.not_destroyed, mbox_id, result.err);
+        }
+        else if (result.skipped) {
+            strarray_append(&skipped_del, mbox_id);
+        }
+        else {
+            json_array_append_new(set->super.destroyed, json_string(mbox_id));
+        }
+        _mboxset_result_fini(&result);
+    }
+    strarray_truncate(ops->del, 0);
+    for (i = 0; i < strarray_size(&skipped_del); i++)
+        strarray_append(ops->del, strarray_nth(&skipped_del, i));
+
+    /* Handle renames */
+    for (i = 0; i < ptrarray_size(&tmp_renames); i++) {
+        struct tmp_rename *tmp = ptrarray_nth(&tmp_renames, i);
+        struct mboxevent *mboxevent = mboxevent_new(EVENT_MAILBOX_RENAME);
+        int r = mboxlist_renametree(tmp->tmp_imapname, tmp->new_imapname,
+                NULL /* partition */, 0 /* uidvalidity */,
+                httpd_userisadmin, req->userid, httpd_authstate,
+                mboxevent,
+                0 /* local_only */, 0 /* forceuser */, 0 /* ignorequota */,
+                1 /* keep_intermediaries */, 1 /* move_subscription */);
+        strarray_add(update_intermediaries, tmp->tmp_imapname);
+        strarray_add(update_intermediaries, tmp->new_imapname);
+        mboxevent_free(&mboxevent);
+        if (r) {
+            syslog(LOG_ERR, "jmap: mailbox rename failed half-way: old=%s tmp=%s new=%s: %s",
+                    tmp->old_imapname ? tmp->old_imapname : "null",
+                    tmp->tmp_imapname, tmp->new_imapname, error_message(r));
+        }
+        /* invalidate ACL cache */
+        if (tmp->old_imapname) jmap_myrights_delete(req, tmp->old_imapname);
+        jmap_mbentry_cache_free(req);
+        jmap_myrights_delete(req, tmp->tmp_imapname);
+        jmap_myrights_delete(req, tmp->new_imapname);
+        free(tmp->old_imapname);
+        free(tmp->new_imapname);
+        free(tmp->tmp_imapname);
+        free(tmp);
+    }
+
+    ptrarray_fini(&skipped_put);
+    strarray_fini(&skipped_del);
+    ptrarray_fini(&tmp_renames);
+}
+
+struct mboxset_entry {
+    char *parent_id;
+    char *name;
+    int is_deleted;
+};
+
+static void _mboxset_entry_free(void *entryp)
+{
+    struct mboxset_entry *entry = entryp;
+    free(entry->parent_id);
+    free(entry->name);
+    free(entryp);
+}
+
+struct mboxset_state {
+    const char *account_id;
+    int has_conflict;
+    hash_table *id_by_imapname;
+    hash_table *entry_by_id;
+    hash_table *siblings_by_parent_id;
+};
+
+static int _mboxset_state_mboxlist_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct mboxset_state *state = rock;
+    // annoyingly, MBTYPE_EMAIL isn't a flag of its own, it's just the absence of other flags, so we can't
+    // match that one with '&'.
+    if (mbentry->mbtype == MBTYPE_EMAIL || (mbentry->mbtype & MBTYPE_INTERMEDIATE)) {
+        hash_insert(mbentry->name, xstrdup(mbentry->uniqueid), state->id_by_imapname);
+    }
+    return 0;
+}
+
+static void _mboxset_state_mkentry_cb(const char *imapname, void *idptr, void *rock)
+{
+    struct mboxset_state *state = rock;
+    char *mbox_id = idptr;
+
+    /* Make entry */
+    struct mboxset_entry *entry = xzmalloc(sizeof(struct mboxset_entry));
+    mbname_t *mbname = mbname_from_intname(imapname);
+    entry->name = _mbox_get_name(state->account_id, mbname);
+
+    /* Find parent */
+    mbentry_t *pmbentry = NULL;
+    if (_findparent(imapname, &pmbentry) == 0) {
+        entry->parent_id = xstrdup(pmbentry->uniqueid);
+    }
+    mboxlist_entry_free(&pmbentry);
+
+    /* Add entry */
+    hash_insert(mbox_id, entry, state->entry_by_id);
+    mbname_free(&mbname);
+}
+
+static void _mboxset_state_conflict_cb(const char *id, void *data, void *rock)
+{
+    struct mboxset_state *state = rock;
+    struct mboxset_entry *entry = data;
+
+    if (state->has_conflict || entry->is_deleted) {
+        return;
+    }
+    if (entry->parent_id == NULL) {
+        /* This is the INBOX. There can't be a conflict. */
+        return;
+    }
+    struct mboxset_entry *parent = hash_lookup(entry->parent_id, state->entry_by_id);
+    if (!parent) {
+        /* This is an internal error in the state. It can't be valid. */
+        state->has_conflict = 1;
+        return;
+    }
+    /* A mailbox must not have a deleted parent. */
+    if (parent->is_deleted) {
+        state->has_conflict = 1;
+        return;
+    }
+    /* A mailbox must not have siblings with the same name. */
+    strarray_t *siblings = hash_lookup(entry->parent_id, state->siblings_by_parent_id);
+    if (!siblings) {
+        siblings = strarray_new();
+        hash_insert(entry->parent_id, siblings, state->siblings_by_parent_id);
+    }
+    int i;
+    for (i = 0; i < strarray_size(siblings); i++) {
+        if (!strcasecmp(entry->name, strarray_nth(siblings, i))) {
+            state->has_conflict = 1;
+            return;
+        }
+    }
+    strarray_append(siblings, entry->name);
+    /* A mailbox must not be parent of its parents. */
+    const char *parent_id = entry->parent_id;
+    while (parent_id) {
+        if (!strcmp(id, parent_id)) {
+            state->has_conflict = 1;
+            return;
+        }
+        struct mboxset_entry *parent_entry = hash_lookup(parent_id, state->entry_by_id);
+        if (!parent_entry || parent_entry->is_deleted) break;
+        parent_id = parent_entry->parent_id;
+    }
+}
+
+static int _mboxset_state_is_valid(const char *account_id, struct mboxset_ops *ops)
+{
+    /* Create in-memory mailbox tree */
+    struct mboxset_state *state = xzmalloc(sizeof(struct mboxset_state));
+    state->account_id = account_id;
+
+    hash_table *id_by_imapname = xzmalloc(sizeof(struct hash_table));
+    construct_hash_table(id_by_imapname, 1024, 0);
+    state->id_by_imapname = id_by_imapname;
+
+    hash_table *entry_by_id = xzmalloc(sizeof(struct hash_table));
+    construct_hash_table(entry_by_id, 1024, 0);
+    state->entry_by_id = entry_by_id;
+
+    hash_table *siblings_by_parent_id = xzmalloc(sizeof(struct hash_table));
+    construct_hash_table(siblings_by_parent_id, 1024, 0);
+    state->siblings_by_parent_id = siblings_by_parent_id;
+
+    /* Map current mailboxes by IMAP name to id */
+    mboxlist_usermboxtree(account_id, NULL, _mboxset_state_mboxlist_cb, state,
+                          MBOXTREE_INTERMEDIATES);
+    char *inboxname = mboxname_user_mbox(account_id, NULL);
+    const char *inbox_id = hash_lookup(inboxname, id_by_imapname);
+    free(inboxname);
+
+    /* Create entries for current mailboxes */
+    hash_enumerate(id_by_imapname, _mboxset_state_mkentry_cb, state);
+
+    int i;
+    int is_valid = 0;
+
+    /* Apply create and update */
+    for (i = 0; i < ptrarray_size(ops->put); i++) {
+        struct mboxset_args *args = ptrarray_nth(ops->put, i);
+        struct buf buf = BUF_INITIALIZER;
+        if (args->creation_id) {
+            struct mboxset_entry *entry = xzmalloc(sizeof(struct mboxset_entry));
+            entry->parent_id = xstrdup(args->parent_id ? args->parent_id : inbox_id);
+            entry->name = xstrdup(args->name);
+            buf_putc(&buf, '#');
+            buf_appendcstr(&buf, args->creation_id);
+            hash_insert(buf_cstring(&buf), entry, entry_by_id);
+            buf_reset(&buf);
+        }
+        else {
+            struct mboxset_entry *entry = hash_lookup(args->mbox_id, entry_by_id);
+            if (!entry) goto done;
+            if (args->name) {
+                free(entry->name);
+                entry->name = xstrdup(args->name);
+            }
+            if (args->parent_id) {
+                free(entry->parent_id);
+                entry->parent_id = xstrdup(args->parent_id);
+            }
+        }
+        buf_free(&buf);
+    }
+    /* Apply destroy */
+    for (i = 0; i < strarray_size(ops->del); i++) {
+        struct mboxset_entry *entry = hash_lookup(strarray_nth(ops->del, i), entry_by_id);
+        if (!entry) goto done;
+        entry->is_deleted = 1;
+    }
+
+    /* Check state for conflicts. */
+    hash_enumerate(entry_by_id, _mboxset_state_conflict_cb, state);
+    is_valid = !state->has_conflict;
+
+done:
+    free_hash_table(state->entry_by_id, _mboxset_entry_free);
+    free(state->entry_by_id);
+    free_hash_table(state->id_by_imapname, free);
+    free(state->id_by_imapname);
+    free_hash_table(state->siblings_by_parent_id, (void(*)(void*))strarray_free);
+    free(state->siblings_by_parent_id);
+    free(state);
+
+    return is_valid;
+}
+
+
+static void _mboxset(jmap_req_t *req, struct mboxset *set)
+{
+    /* Mailbox/set operations are allowed to introduce inconsistencies in the
+     * mailbox tree, as long as they are resolved after applying all operations
+     * in the request. However, if the final state is not valid, the spec
+     * requires that "each creation, modification or destruction of an object
+     * should be processed sequentially and accepted/rejected based on the
+     * current server state."
+     *
+     * Cyrus IMAP neither supports transactions on mailboxes nor invalid
+     * temporary states. To work around these limitations the Mailbox/set
+     * command is implemented as follows:
+     *
+     * 1. Sort the Mailbox/set operations topologically: create and update
+     * operations are sorted together by parentId, parent before child.
+     * Destroy operations are sorted child to parent. A topological sort is not
+     * possible for cyclic operations and can never result in a valid final
+     * state. The sort routine will in this case return an arbitrary order,
+     * and we'll fail early for any conflicts and are done.
+     *
+     * 2. Run all operations, skipping any that either depends on a
+     * non-existent parent, results in a mailboxHasChild conflict or
+     * introduces a name-clash between siblings. All other operations either
+     * succeed or fail permanently, and are removed from the working set of
+     * operations. If there's no more operations left, we're done.
+     *
+     * 3. Generate an in-memory representation of the current mailbox state,
+     * then apply all pending operations to this model. If the resulting state
+     * is invalid, we'll run the operations, let them fail for any conflict
+     * and are done.
+     *
+     * 4. Run the pending operations and work around name-conflicts by using
+     * temporary mailbox names for name-clashes. As the final state is known
+     * to be valid and the operations are still topologically sorted, this must
+     * always resolve any remaining conflicts.
+     *
+     * 5. For any temporary renames in step 4, rename the temporary mailbox
+     * name to the requested name.
+     *
+     * All operations must now have either resulted in success or a permanent
+     * error.
+     */
+    struct mboxset_ops *ops = _mboxset_newops(req, set);
+    strarray_t update_intermediaries = STRARRAY_INITIALIZER;
+
+    /* Apply Mailbox/set operations */
+    if (ops->is_cyclic) {
+        _mboxset_run(req, set, ops, _MBOXSET_FAIL, &update_intermediaries);
+    }
+    else {
+        _mboxset_run(req, set, ops, _MBOXSET_SKIP, &update_intermediaries);
+        if (ptrarray_size(ops->put) || strarray_size(ops->del)) {
+            if (_mboxset_state_is_valid(req->accountid, ops)) {
+                _mboxset_run(req, set, ops, _MBOXSET_TMPNAME, &update_intermediaries);
+            }
+            else {
+                _mboxset_run(req, set, ops, _MBOXSET_FAIL, &update_intermediaries);
+            }
+        }
+    }
+
+    /* Fetch mailbox state */
+    json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/1);
+    set->super.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    /* Prune intermediary mailbox trees without any children. Do this
+     * after we fetched the mailbox state, so clients are forced to
+     * resync their mailbox trees after the Mailbox/set. */
+    int i;
+    for (i = 0; i < strarray_size(&update_intermediaries); i++) {
+        const char *old_imapname = strarray_nth(&update_intermediaries, i);
+        /* XXX - we know these are mailboxes, so mbtype 0 is OK, but it's not an
+         * ideal interface */
+        mboxlist_update_intermediaries(old_imapname, 0, 0);
+        /* XXX error handling? */
+    }
+
+    assert(ptrarray_size(ops->put) == 0);
+    assert(strarray_size(ops->del) == 0);
+    _mboxset_ops_free(ops);
+    strarray_fini(&update_intermediaries);
+}
+
+static int _mboxset_args_parse(jmap_req_t *req __attribute__((unused)),
+                               struct jmap_parser *parser __attribute__((unused)),
+                               const char *key,
+                               json_t *arg,
+                               void *rock)
+{
+    struct mboxset *set = (struct mboxset *) rock;
+    int r = 1;
+
+    if (!strcmp(key, "onDestroyRemoveMessages") && json_is_boolean(arg)) {
+        set->on_destroy_remove_msgs = json_boolean_value(arg);
+    }
+
+    else if (!strcmp(key, "onDestroyRemoveEmails") && json_is_boolean(arg)) {
+        set->on_destroy_remove_msgs = json_boolean_value(arg);
+    }
+
+    else r = 0;
+
+    return r;
+}
+
+static void _mboxset_parse(jmap_req_t *req,
+                           struct jmap_parser *parser,
+                           struct mboxset *set,
+                           json_t **err)
+{
+    json_t *jarg;
+    size_t i;
+    memset(set, 0, sizeof(struct mboxset));
+
+    jmap_set_parse(req, parser, mailbox_props, &_mboxset_args_parse,
+                   set, &set->super, err);
+    if (*err) return;
+
+    /* create */
+    const char *creation_id = NULL;
+    json_object_foreach(set->super.create, creation_id, jarg) {
+        struct jmap_parser myparser = JMAP_PARSER_INITIALIZER;
+        struct mboxset_args *args = xzmalloc(sizeof(struct mboxset_args));
+        json_t *set_err = NULL;
+
+        _mbox_setargs_parse(jarg, &myparser, args, req, /*is_create*/1);
+        args->creation_id = xstrdup(creation_id);
+        if (json_array_size(myparser.invalid)) {
+            set_err = json_pack("{s:s}", "type", "invalidProperties");
+            json_object_set(set_err, "properties", myparser.invalid);
+            json_object_set_new(set->super.not_created, creation_id, set_err);
+            jmap_parser_fini(&myparser);
+            _mbox_setargs_fini(args);
+            free(args);
+            continue;
+        }
+        ptrarray_append(&set->create, args);
+        jmap_parser_fini(&myparser);
+    }
+
+    /* update */
+    json_t *will_destroy = json_object();
+    json_array_foreach(set->super.destroy, i, jarg) {
+        json_object_set_new(will_destroy, json_string_value(jarg), json_true());
+    }
+    const char *mbox_id = NULL;
+    json_object_foreach(set->super.update, mbox_id, jarg) {
+        /* Parse Mailbox/set arguments  */
+        struct jmap_parser myparser = JMAP_PARSER_INITIALIZER;
+        struct mboxset_args *args = xzmalloc(sizeof(struct mboxset_args));
+        _mbox_setargs_parse(jarg, &myparser, args, req, /*is_create*/0);
+        if (args->mbox_id && strcmp(args->mbox_id, mbox_id)) {
+            jmap_parser_invalid(&myparser, "id");
+        }
+        if (!args->mbox_id) args->mbox_id = xstrdup(mbox_id);
+        if (json_array_size(myparser.invalid)) {
+            json_t *err = json_pack("{s:s}", "type", "invalidProperties");
+            json_object_set(err, "properties", myparser.invalid);
+            json_object_set_new(set->super.not_updated, mbox_id, err);
+            jmap_parser_fini(&myparser);
+            _mbox_setargs_fini(args);
+            free(args);
+            continue;
+        }
+        if (json_object_get(will_destroy, args->mbox_id)) {
+            json_t *err = json_pack("{s:s}", "type", "willDestroy");
+            json_object_set_new(set->super.not_updated, mbox_id, err);
+            jmap_parser_fini(&myparser);
+            _mbox_setargs_fini(args);
+            free(args);
+            continue;
+        }
+        ptrarray_append(&set->update, args);
+        jmap_parser_fini(&myparser);
+    }
+    json_decref(will_destroy);
+
+    /* destroy */
+    json_array_foreach(set->super.destroy, i, jarg) {
+        strarray_append(&set->destroy, json_string_value(jarg));
+    }
+}
+
+static void _mboxset_fini(struct mboxset *set)
+{
+    jmap_set_fini(&set->super);
+
+    struct mboxset_args *args = NULL;
+    while ((args = ptrarray_pop(&set->create))) {
+        _mbox_setargs_fini(args);
+        free(args);
+    }
+    ptrarray_fini(&set->create);
+    while ((args = ptrarray_pop(&set->update))) {
+        _mbox_setargs_fini(args);
+        free(args);
+    }
+    ptrarray_fini(&set->update);
+    strarray_fini(&set->destroy);
+}
+
+static int jmap_mailbox_set(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct mboxset set;
+
+    /* Parse arguments */
+    json_t *arg_err = NULL;
+    _mboxset_parse(req, &parser, &set, &arg_err);
+    if (arg_err) {
+        jmap_error(req, arg_err);
+        goto done;
+    }
+    if (set.super.if_in_state) {
+        json_t *jstate = json_string(set.super.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_EMAIL)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            goto done;
+        }
+        json_decref(jstate);
+        set.super.old_state = xstrdup(set.super.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/0);
+        set.super.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+    struct mboxlock *namespacelock = user_namespacelock(req->accountid);
+    _mboxset(req, &set);
+    mboxname_release(&namespacelock);
+    jmap_ok(req, jmap_set_reply(&set.super));
+
+done:
+    jmap_parser_fini(&parser);
+    _mboxset_fini(&set);
+    return 0;
+}
+
+struct _mbox_changes_data {
+    json_t *created;          /* maps mailbox ids to {id:foldermodseq} */
+    json_t *updated;        /* maps mailbox ids to {id:foldermodseq} */
+    json_t *destroyed;      /* maps mailbox ids to {id:foldermodseq} */
+    modseq_t since_modseq;
+    int *only_counts_changed;
+    jmap_req_t *req;
+};
+
+static int _mbox_changes_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct _mbox_changes_data *data = rock;
+    modseq_t modseq, mbmodseq;
+    jmap_req_t *req = data->req;
+
+    /* Ignore anything but regular mailboxes */
+    if (mbentry->mbtype & ~(MBTYPE_DELETED | MBTYPE_INTERMEDIATE)) {
+        return 0;
+    }
+
+    /* Lookup status. */
+    if (!(mbentry->mbtype & (MBTYPE_DELETED | MBTYPE_INTERMEDIATE))) {
+        struct statusdata sdata = STATUSDATA_INIT;
+        int r = status_lookup_mbentry(mbentry, data->req->userid,
+                                      STATUS_HIGHESTMODSEQ, &sdata);
+        if (r) return r;
+        mbmodseq = sdata.highestmodseq;
+    } else {
+        mbmodseq = mbentry->foldermodseq;
+    }
+
+    /* Ignore old changes */
+    if (mbmodseq <= data->since_modseq) {
+        return 0;
+    }
+
+    /* Did any of the mailbox metadata change? */
+    if (mbentry->foldermodseq > data->since_modseq) {
+        *(data->only_counts_changed) = 0;
+    }
+
+    /* Is this a more recent update for an id that we have already seen?
+     * (check all three) */
+    json_t *old[3];
+    old[0] = data->created;
+    old[1] = data->updated;
+    old[2] = data->destroyed;
+    int i;
+    for (i = 0; i < 3; i++) {
+        json_t *val = json_object_get(old[i], mbentry->uniqueid);
+        if (!val) continue;
+        modseq = (modseq_t)json_integer_value(json_object_get(val, "modseq"));
+        if (modseq <= mbmodseq) {
+            json_object_del(old[i], mbentry->uniqueid);
+        } else {
+            return 0;
+        }
+    }
+
+    /* OK, report that update. Note that we even report hidden mailboxes
+     * in order to allow clients remove unshared and deleted mailboxes */
+    json_t *dest = NULL;
+
+    if ((mbentry->mbtype & MBTYPE_DELETED) || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+        if (mbentry->createdmodseq <= data->since_modseq)
+            dest = data->destroyed;
+    } else {
+        if (mbentry->createdmodseq <= data->since_modseq)
+            dest = data->updated;
+        else
+            dest = data->created;
+    }
+
+    if (dest)
+        json_object_set_new(dest, mbentry->uniqueid,
+                            json_pack("{s:s s:i}", "id", mbentry->uniqueid, "modseq", mbmodseq));
+
+    return 0;
+}
+
+static int _mbox_changes_cmp(const void **pa, const void **pb)
+{
+    const json_t *a = *pa, *b = *pb;
+    modseq_t ma, mb;
+
+    ma = (modseq_t) json_integer_value(json_object_get(a, "modseq"));
+    mb = (modseq_t) json_integer_value(json_object_get(b, "modseq"));
+
+    if (ma < mb)
+        return -1;
+    if (ma > mb)
+        return 1;
+    return 0;
+}
+
+static int _mbox_changes(jmap_req_t *req,
+                         struct jmap_changes *changes,
+                         int *only_counts_changed)
+{
+    *only_counts_changed = 1;
+
+    ptrarray_t updates = PTRARRAY_INITIALIZER;
+    struct _mbox_changes_data data = {
+        json_pack("{}"),
+        json_pack("{}"),
+        json_pack("{}"),
+        changes->since_modseq,
+        only_counts_changed,
+        req
+    };
+    modseq_t windowmodseq;
+    const char *id;
+    json_t *val;
+    int r, i;
+
+
+    /* Search for updates */
+    r = mboxlist_usermboxtree(req->accountid, req->authstate,
+                              _mbox_changes_cb, &data,
+                              MBOXTREE_TOMBSTONES|
+                              MBOXTREE_INTERMEDIATES);
+    if (r) goto done;
+
+    /* Sort updates by modseq */
+    json_object_foreach(data.created, id, val) {
+        ptrarray_add(&updates, val);
+    }
+    json_object_foreach(data.updated, id, val) {
+        ptrarray_add(&updates, val);
+    }
+    json_object_foreach(data.destroyed, id, val) {
+        ptrarray_add(&updates, val);
+    }
+    ptrarray_sort(&updates, _mbox_changes_cmp);
+
+    /* Build result */
+    changes->has_more_changes = 0;
+    windowmodseq = 0;
+    for (i = 0; i < updates.count; i++) {
+        json_t *update = ptrarray_nth(&updates, i);
+        const char *id = json_string_value(json_object_get(update, "id"));
+        modseq_t modseq = json_integer_value(json_object_get(update, "modseq"));
+
+        if (changes->max_changes && ((size_t) i) >= changes->max_changes) {
+            changes->has_more_changes = 1;
+            break;
+        }
+
+        if (windowmodseq < modseq)
+            windowmodseq = modseq;
+
+        if (json_object_get(data.created, id)) {
+            json_array_append_new(changes->created, json_string(id));
+        } else if (json_object_get(data.updated, id)) {
+            json_array_append_new(changes->updated, json_string(id));
+        } else {
+            json_array_append_new(changes->destroyed, json_string(id));
+        }
+    }
+
+    if ((json_array_size(changes->created) == 0 &&
+         json_array_size(changes->updated) == 0 &&
+         json_array_size(changes->destroyed) == 0) ||
+        (json_array_size(changes->created) > 0) ||
+        (json_array_size(changes->destroyed) > 0)) {
+        *only_counts_changed = 0;
+    }
+
+    changes->new_modseq = changes->has_more_changes ?
+        windowmodseq : jmap_highestmodseq(req, 0);
+
+done:
+    if (data.created) json_decref(data.created);
+    if (data.updated) json_decref(data.updated);
+    if (data.destroyed) json_decref(data.destroyed);
+    ptrarray_fini(&updates);
+    return r;
+}
+
+static int jmap_mailbox_changes(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Search for updates */
+    int only_counts_changed = 0;
+    int r = _mbox_changes(req, &changes, &only_counts_changed);
+    if (r) {
+        syslog(LOG_ERR, "jmap: Mailbox/changes: %s", error_message(r));
+        jmap_error(req, jmap_server_error(r));
+        goto done;
+    }
+
+    /* Build response */
+    json_t *res = jmap_changes_reply(&changes);
+    json_t *changed_props = json_null();
+    if (only_counts_changed) {
+        changed_props = json_pack("[s,s,s,s]",
+                "totalEmails", "unreadEmails", "totalThreads", "unreadThreads");
+    }
+    json_object_set_new(res, "updatedProperties", changed_props);
+    jmap_ok(req, res);
+
+done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_mail.c 3.2.0-3/imap/jmap_mail.c
--- 3.0.13-5/imap/jmap_mail.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mail.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,12715 @@
+/* jmap_mail.c -- Routines for handling JMAP mail messages
+ *
+ * Copyright (c) 1994-2014 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+#include <sys/mman.h>
+
+#include <sasl/saslutil.h>
+
+#ifdef HAVE_LIBCHARDET
+#include <chardet/chardet.h>
+#endif
+
+#include "acl.h"
+#include "annotate.h"
+#include "append.h"
+#include "bsearch.h"
+#include "carddav_db.h"
+#include "cyr_qsort_r.h"
+#include "hashset.h"
+#include "http_dav.h"
+#include "http_jmap.h"
+#include "http_proxy.h"
+#include "jmap_ical.h"
+#include "jmap_mail.h"
+#include "jmap_mail_query.h"
+#include "json_support.h"
+#include "mailbox.h"
+#include "mappedfile.h"
+#include "mboxevent.h"
+#include "mboxlist.h"
+#include "mboxname.h"
+#include "msgrecord.h"
+#include "notify.h"
+#include "parseaddr.h"
+#include "proxy.h"
+#include "search_query.h"
+#include "seen.h"
+#include "smtpclient.h"
+#include "statuscache.h"
+#include "stristr.h"
+#include "sync_log.h"
+#include "times.h"
+#include "util.h"
+#include "xmalloc.h"
+#include "xsha1.h"
+#include "xstrnchr.h"
+
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+static int jmap_email_query(jmap_req_t *req);
+static int jmap_email_querychanges(jmap_req_t *req);
+static int jmap_email_get(jmap_req_t *req);
+static int jmap_email_set(jmap_req_t *req);
+static int jmap_email_changes(jmap_req_t *req);
+static int jmap_email_import(jmap_req_t *req);
+static int jmap_email_parse(jmap_req_t *req);
+static int jmap_email_copy(jmap_req_t *req);
+static int jmap_email_matchmime_method(jmap_req_t *req);
+static int jmap_searchsnippet_get(jmap_req_t *req);
+static int jmap_thread_get(jmap_req_t *req);
+static int jmap_thread_changes(jmap_req_t *req);
+
+/*
+ * Possibly to be implemented:
+ * - Email/removeAttachments
+ * - Email/report
+ * - Identity/changes
+ * - Identity/set
+ */
+
+static jmap_method_t jmap_mail_methods_standard[] = {
+    {
+        "Email/query",
+        JMAP_URN_MAIL,
+        &jmap_email_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Email/queryChanges",
+        JMAP_URN_MAIL,
+        &jmap_email_querychanges,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Email/get",
+        JMAP_URN_MAIL,
+        &jmap_email_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Email/set",
+        JMAP_URN_MAIL,
+        &jmap_email_set,
+        /*flags*/0
+    },
+    {
+        "Email/changes",
+        JMAP_URN_MAIL,
+        &jmap_email_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Email/import",
+        JMAP_URN_MAIL,
+        &jmap_email_import,
+        /*flags*/0
+    },
+    {
+        "Email/parse",
+        JMAP_URN_MAIL,
+        &jmap_email_parse,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Email/copy",
+        JMAP_URN_MAIL,
+        &jmap_email_copy,
+        /*flags*/ 0
+    },
+    {
+        "Email/matchMime",
+        JMAP_MAIL_EXTENSION,
+        &jmap_email_matchmime_method,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "SearchSnippet/get",
+        JMAP_URN_MAIL,
+        &jmap_searchsnippet_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Thread/get",
+        JMAP_URN_MAIL,
+        &jmap_thread_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Thread/changes",
+        JMAP_URN_MAIL,
+        &jmap_thread_changes,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+static jmap_method_t jmap_mail_methods_nonstandard[] = {
+    { NULL, NULL, NULL, 0}
+};
+
+/* NULL terminated list of supported jmap_email_query sort fields */
+struct email_sortfield {
+    const char *name;
+    const char *capability;
+};
+
+static struct email_sortfield email_sortfields[] = {
+    {
+        "receivedAt",
+        NULL
+    },
+    {
+        "sentAt",
+        NULL
+    },
+    {
+        "from",
+        NULL
+    },
+    {
+        "id",
+        NULL
+    },
+    {
+        "emailstate",
+        NULL
+    },
+    {
+        "size",
+        NULL
+    },
+    {
+        "subject",
+        NULL
+    },
+    {
+        "to",
+        NULL
+    },
+    {
+        "hasKeyword",
+        NULL
+    },
+    {
+        "someInThreadHaveKeyword",
+        NULL
+    },
+    {
+        "addedDates",
+        JMAP_MAIL_EXTENSION
+    },
+    {
+        "threadSize",
+        JMAP_MAIL_EXTENSION
+    },
+    {
+        "spamScore",
+        JMAP_MAIL_EXTENSION
+    },
+    {
+        "snoozedUntil",
+        JMAP_MAIL_EXTENSION
+    },
+    {
+        NULL,
+        NULL
+    }
+};
+
+#define JMAP_MAIL_MAX_MAILBOXES_PER_EMAIL 20
+#define JMAP_MAIL_MAX_KEYWORDS_PER_EMAIL 100 /* defined in mailbox_user_flag */
+
+HIDDEN void jmap_mail_init(jmap_settings_t *settings)
+{
+    jmap_method_t *mp;
+    for (mp = jmap_mail_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    json_object_set_new(settings->server_capabilities,
+            JMAP_URN_MAIL, json_object());
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(settings->server_capabilities,
+                JMAP_SEARCH_EXTENSION, json_object());
+        json_object_set_new(settings->server_capabilities,
+                JMAP_MAIL_EXTENSION, json_object());
+
+        for (mp = jmap_mail_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+
+    jmap_emailsubmission_init(settings);
+    jmap_mailbox_init(settings);
+    jmap_vacation_init(settings);
+}
+
+HIDDEN void jmap_mail_capabilities(json_t *account_capabilities, int mayCreateTopLevel)
+{
+    json_t *sortopts = json_array();
+    struct email_sortfield *sp;
+    int support_extensions = config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS);
+
+    for (sp = email_sortfields; sp->name; sp++) {
+        if (sp->capability && !support_extensions) continue;
+        json_array_append_new(sortopts, json_string(sp->name));
+    }
+
+    long max_size_attachments_per_email =
+        config_getint(IMAPOPT_JMAP_MAIL_MAX_SIZE_ATTACHMENTS_PER_EMAIL);
+
+    max_size_attachments_per_email *= 1024;
+    if (max_size_attachments_per_email <= 0) {
+        syslog(LOG_ERR, "jmap: invalid property value: %s",
+                imapopts[IMAPOPT_JMAP_MAIL_MAX_SIZE_ATTACHMENTS_PER_EMAIL].optname);
+        max_size_attachments_per_email = 0;
+    }
+
+    json_t *email_capabilities = json_pack("{s:i s:i s:i s:o, s:b}",
+            "maxMailboxesPerEmail", JMAP_MAIL_MAX_MAILBOXES_PER_EMAIL,
+            "maxKeywordsPerEmail", JMAP_MAIL_MAX_KEYWORDS_PER_EMAIL,
+            "maxSizeAttachmentsPerEmail", max_size_attachments_per_email,
+            "emailsListSortOptions", sortopts,
+            "mayCreateTopLevelMailbox", mayCreateTopLevel);
+
+    json_object_set_new(account_capabilities, JMAP_URN_MAIL, email_capabilities);
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        json_object_set_new(account_capabilities, JMAP_SEARCH_EXTENSION, json_object());
+        json_object_set_new(account_capabilities, JMAP_MAIL_EXTENSION, json_object());
+    }
+
+    jmap_mailbox_capabilities(account_capabilities);
+}
+
+#define JMAP_HAS_ATTACHMENT_FLAG "$HasAttachment"
+
+typedef enum MsgType {
+        MSG_IS_ROOT = 0,
+        MSG_IS_ATTACHED = 1,
+} MsgType;
+
+/*
+ * Emails
+ */
+
+static char *_decode_to_utf8(const char *charset,
+                             const char *data, size_t datalen,
+                             const char *encoding,
+                             int *is_encoding_problem)
+{
+    charset_t cs = charset_lookupname(charset);
+    char *text = NULL;
+    int enc = encoding_lookupname(encoding);
+
+    if (cs == CHARSET_UNKNOWN_CHARSET || enc == ENCODING_UNKNOWN) {
+        syslog(LOG_INFO, "decode_to_utf8 error (%s, %s)", charset, encoding);
+        *is_encoding_problem = 1;
+        goto done;
+    }
+    text = charset_to_utf8(data, datalen, cs, enc);
+    if (!text) {
+        *is_encoding_problem = 1;
+        goto done;
+    }
+
+    size_t textlen = strlen(text);
+    struct char_counts counts = charset_count_validutf8(text, textlen);
+    *is_encoding_problem = counts.invalid || counts.replacement;
+
+    const char *charset_id = charset_canon_name(cs);
+    if (!strncasecmp(charset_id, "UTF-32", 6)) {
+        /* Special-handle UTF-32. Some clients announce the wrong endianess. */
+        if (counts.invalid || counts.replacement) {
+            charset_t guess_cs = CHARSET_UNKNOWN_CHARSET;
+            if (!strcasecmp(charset_id, "UTF-32") || !strcasecmp(charset_id, "UTF-32BE"))
+                guess_cs = charset_lookupname("UTF-32LE");
+            else
+                guess_cs = charset_lookupname("UTF-32BE");
+            char *guess = charset_to_utf8(data, datalen, guess_cs, enc);
+            if (guess) {
+                struct char_counts guess_counts = charset_count_validutf8(guess, strlen(guess));
+                if (guess_counts.valid > counts.valid) {
+                    free(text);
+                    text = guess;
+                    counts = guess_counts;
+                }
+            }
+            charset_free(&guess_cs);
+        }
+    }
+
+#ifdef HAVE_LIBCHARDET
+    if (counts.invalid || counts.replacement) {
+        static Detect *d = NULL;
+        if (!d) d = detect_init();
+
+        DetectObj *obj = detect_obj_init();
+        if (!obj) goto done;
+        detect_reset(&d);
+
+        struct buf buf = BUF_INITIALIZER;
+        charset_decode(&buf, data, datalen, enc);
+        buf_cstring(&buf);
+        if (detect_handledata_r(&d, buf_base(&buf), buf_len(&buf), &obj) == CHARDET_SUCCESS) {
+            charset_t guess_cs = charset_lookupname(obj->encoding);
+            if (guess_cs != CHARSET_UNKNOWN_CHARSET) {
+                char *guess = charset_to_utf8(data, datalen, guess_cs, enc);
+                if (guess) {
+                    struct char_counts guess_counts = charset_count_validutf8(guess, strlen(guess));
+                    if (guess_counts.valid > counts.valid) {
+                        free(text);
+                        text = guess;
+                        counts = guess_counts;
+                    }
+                    else {
+                        free(guess);
+                    }
+                }
+                charset_free(&guess_cs);
+            }
+        }
+        detect_obj_free(&obj);
+        buf_free(&buf);
+    }
+#endif
+
+done:
+    charset_free(&cs);
+    return text;
+}
+
+static char *_decode_mimeheader(const char *raw)
+{
+    if (!raw) return NULL;
+
+    int is_8bit = 0;
+    const char *p;
+    for (p = raw; *p; p++) {
+        if (*p & 0x80) {
+            is_8bit = 1;
+            break;
+        }
+    }
+
+    char *val = NULL;
+    if (is_8bit) {
+        int err = 0;
+        val = _decode_to_utf8("utf-8", raw, strlen(raw), NULL, &err);
+    }
+    if (!val) {
+        val = charset_decode_mimeheader(raw, CHARSET_KEEPCASE);
+    }
+    return val;
+}
+
+struct headers {
+    json_t *raw; /* JSON array of EmailHeader */
+    json_t *all; /* JSON object: lower-case header name => list of values */
+    struct buf buf;
+};
+
+enum header_form {
+    HEADER_FORM_UNKNOWN          = 0, /* MUST be zero so we can cast to void* */
+    HEADER_FORM_RAW              = 1 << 0,
+    HEADER_FORM_TEXT             = 1 << 1,
+    HEADER_FORM_ADDRESSES        = 1 << 2,
+    HEADER_FORM_GROUPEDADDRESSES = 1 << 3,
+    HEADER_FORM_MESSAGEIDS       = 1 << 4,
+    HEADER_FORM_DATE             = 1 << 5,
+    HEADER_FORM_URLS             = 1 << 6
+};
+
+#define HEADERS_INITIALIZER \
+    { json_array(), json_object(), BUF_INITIALIZER }
+
+static void _headers_init(struct headers *headers) {
+    headers->raw = json_array();
+    headers->all = json_object();
+    memset(&headers->buf, 0, sizeof(struct buf));
+}
+
+static void _headers_fini(struct headers *headers) {
+    json_decref(headers->all);
+    json_decref(headers->raw);
+    buf_free(&headers->buf);
+}
+
+static void _headers_put_new(struct headers *headers, json_t *header, int shift)
+{
+    const char *name = json_string_value(json_object_get(header, "name"));
+
+    if (headers->raw == NULL)
+        headers->raw = json_array();
+    if (headers->all == NULL)
+        headers->all = json_object();
+
+    /* Append (or shift) the raw header to the in-order header list */
+    if (shift)
+        json_array_insert(headers->raw, 0, header);
+    else
+        json_array_append(headers->raw, header);
+
+    /* Append the raw header to the list of all equal-named headers */
+    buf_setcstr(&headers->buf, name);
+    const char *lcasename = buf_lcase(&headers->buf);
+    json_t *all = json_object_get(headers->all, lcasename);
+    if (!all) {
+        all = json_array();
+        json_object_set_new(headers->all, lcasename, all);
+    }
+
+    if (shift)
+        json_array_insert_new(all, 0, header);
+    else
+        json_array_append_new(all, header);
+}
+
+static void _headers_add_new(struct headers *headers, json_t *header)
+{
+    if (!header) return;
+    _headers_put_new(headers, header, 0);
+}
+
+static void _headers_shift_new(struct headers *headers, json_t *header)
+{
+    if (!header) return;
+    _headers_put_new(headers, header, 1);
+}
+
+static json_t* _headers_get(struct headers *headers, const char *name)
+{
+    char *lcasename = lcase(xstrdup(name));
+    json_t *jheader = json_object_get(headers->all, lcasename);
+    free(lcasename);
+    return jheader;
+}
+
+static int _headers_have(struct headers *headers, const char *name)
+{
+    return _headers_get(headers, name) != NULL;
+}
+
+static int _headers_from_mime_cb(const char *key, const char *val, void *_rock)
+{
+    struct headers *headers = _rock;
+    _headers_add_new(headers, json_pack("{s:s s:s}", "name", key, "value", val));
+    return 0;
+}
+
+static void _headers_from_mime(const char *base, size_t len, struct headers *headers)
+{
+    message_foreach_header(base, len, _headers_from_mime_cb, headers);
+}
+
+static json_t *_header_as_raw(const char *raw, enum header_form form __attribute__((unused)))
+{
+    if (!raw) return json_null();
+    size_t len = strlen(raw);
+    if (len > 1 && raw[len-1] == '\n' && raw[len-2] == '\r') len -= 2;
+    return json_stringn(raw, len);
+}
+
+static json_t *_header_as_date(const char *raw, enum header_form form __attribute__((unused)))
+{
+    if (!raw) return json_null();
+
+    time_t t;
+    if (time_from_rfc5322(raw, &t, DATETIME_FULL) == -1) {
+        if (!strchr(raw, '\r')) return json_null();
+        char *tmp = charset_unfold(raw, strlen(raw), CHARSET_UNFOLD_SKIPWS);
+        int r = time_from_rfc5322(tmp, &t, DATETIME_FULL);
+        free(tmp);
+        if (r == -1) return json_null();
+    }
+
+    char cbuf[RFC3339_DATETIME_MAX+1];
+    cbuf[RFC3339_DATETIME_MAX] = '\0';
+    time_to_rfc3339(t, cbuf, RFC3339_DATETIME_MAX+1);
+    return json_string(cbuf);
+}
+
+static json_t *_header_as_text(const char *raw, enum header_form form __attribute__((unused)))
+{
+    if (!raw) return json_null();
+
+    /* TODO this could be optimised to omit unfolding, decoding
+     * or normalisation, or all, if ASCII */
+    /* Unfold and remove CRLF */
+    char *unfolded = charset_unfold(raw, strlen(raw), 0);
+    char *p = strchr(unfolded, '\r');
+    while (p && *(p + 1) != '\n') {
+        p = strchr(p + 1, '\r');
+    }
+    if (p) *p = '\0';
+
+    /* Trim starting SP */
+    const char *trimmed = unfolded;
+    while (isspace(*trimmed)) {
+        trimmed++;
+    }
+
+    /* Decode header */
+    char *decoded = _decode_mimeheader(trimmed);
+
+    /* Convert to Unicode NFC */
+    char *normalized = charset_utf8_normalize(decoded);
+
+    json_t *result = json_string(normalized);
+    free(normalized);
+    free(decoded);
+    free(unfolded);
+    return result;
+}
+
+static void _remove_ws(char *s)
+{
+    char *d = s;
+    do {
+        while (isspace(*s))
+            s++;
+    } while ((*d++ = *s++));
+}
+
+static json_t *_header_as_messageids(const char *raw, enum header_form form __attribute__((unused)))
+{
+    if (!raw) return json_null();
+    json_t *msgids = json_array();
+    char *unfolded = charset_unfold(raw, strlen(raw), CHARSET_UNFOLD_SKIPWS);
+
+    const char *p = unfolded;
+
+    while (*p) {
+        /* Skip preamble */
+        while (isspace(*p) || *p == ',') p++;
+        if (!*p) break;
+
+        /* Find end of id */
+        const char *q = p;
+        if (*p == '<') {
+            while (*q && *q != '>') q++;
+        }
+        else {
+            while (*q && !isspace(*q)) q++;
+        }
+
+        /* Read id */
+        char *val = xstrndup(*p == '<' ? p + 1 : p,
+                             *q == '>' ? q - p - 1 : q - p);
+        if (*p == '<') {
+            _remove_ws(val);
+        }
+        if (*val) {
+            /* calculate the value that would be created if this was
+             * fed back into an Email/set and make sure it would
+             * validate */
+            char *msgid = strconcat("<", val, ">", NULL);
+            int r = conversations_check_msgid(msgid, strlen(msgid));
+            if (!r) json_array_append_new(msgids, json_string(val));
+            free(msgid);
+        }
+        free(val);
+
+        /* Reset iterator */
+        p = *q ? q + 1 : q;
+    }
+
+
+    if (!json_array_size(msgids)) {
+        json_decref(msgids);
+        msgids = json_null();
+    }
+    free(unfolded);
+    return msgids;
+}
+
+static json_t *_emailaddresses_from_addr(struct address *addr, enum header_form form)
+{
+    if (!addr) return json_null();
+
+    json_t *result = json_array();
+
+    const char *groupname = NULL;
+    json_t *addresses = json_array();
+
+    struct buf buf = BUF_INITIALIZER;
+    while (addr) {
+        const char *domain = addr->domain;
+        if (!strcmpsafe(domain, "unspecified-domain")) {
+            domain = NULL;
+        }
+        if (!addr->name && addr->mailbox && !domain) {
+            /* Start of group. */
+            if (form == HEADER_FORM_GROUPEDADDRESSES) {
+                if (form == HEADER_FORM_GROUPEDADDRESSES) {
+                    if (groupname || json_array_size(addresses)) {
+                        json_t *group = json_object();
+                        json_object_set_new(group, "name",
+                                groupname ? json_string(groupname) : json_null());
+                        json_object_set_new(group, "addresses", addresses);
+                        json_array_append_new(result, group);
+                        addresses = json_array();
+                    }
+                    groupname = NULL;
+                }
+                groupname = addr->mailbox;
+            }
+        }
+        else if (!addr->name && !addr->mailbox) {
+            /* End of group */
+            if (form == HEADER_FORM_GROUPEDADDRESSES) {
+                if (groupname || json_array_size(addresses)) {
+                    json_t *group = json_object();
+                    json_object_set_new(group, "name",
+                            groupname ? json_string(groupname) : json_null());
+                    json_object_set_new(group, "addresses", addresses);
+                    json_array_append_new(result, group);
+                    addresses = json_array();
+                }
+                groupname = NULL;
+            }
+        }
+        else {
+            /* Regular address */
+            json_t *jemailaddr = json_pack("{}");
+            if (addr->name) {
+                char *tmp = _decode_mimeheader(addr->name);
+                if (tmp) json_object_set_new(jemailaddr, "name", json_string(tmp));
+                free(tmp);
+            } else {
+                json_object_set_new(jemailaddr, "name", json_null());
+            }
+            if (addr->mailbox) {
+                buf_setcstr(&buf, addr->mailbox);
+                if (domain) {
+                    buf_putc(&buf, '@');
+                    buf_appendcstr(&buf, domain);
+                }
+                json_object_set_new(jemailaddr, "email", json_string(buf_cstring(&buf)));
+                buf_reset(&buf);
+            } else {
+                json_object_set_new(jemailaddr, "email", json_null());
+            }
+            json_array_append_new(addresses, jemailaddr);
+        }
+        addr = addr->next;
+    }
+    buf_free(&buf);
+
+    if (form == HEADER_FORM_GROUPEDADDRESSES) {
+        if (groupname || json_array_size(addresses)) {
+            json_t *group = json_object();
+            json_object_set_new(group, "name",
+                    groupname ? json_string(groupname) : json_null());
+            json_object_set_new(group, "addresses", addresses);
+            json_array_append_new(result, group);
+        }
+        else json_decref(addresses);
+    }
+    else {
+        json_decref(result);
+        result = addresses;
+    }
+
+    return result;
+}
+
+
+static json_t *_header_as_addresses(const char *raw, enum header_form form)
+{
+    if (!raw) return json_null();
+
+    struct address *addrs = NULL;
+    parseaddr_list(raw, &addrs);
+    json_t *result = _emailaddresses_from_addr(addrs, form);
+    parseaddr_free(addrs);
+    return result;
+}
+
+static json_t *_header_as_urls(const char *raw, enum header_form form __attribute__((unused)))
+{
+    if (!raw) return json_null();
+
+    /* A poor man's implementation of RFC 2369, returning anything
+     * between < and >. */
+    json_t *urls = json_array();
+    const char *base = raw;
+    const char *top = raw + strlen(raw);
+    while (base < top) {
+        const char *lo = strchr(base, '<');
+        if (!lo) break;
+        const char *hi = strchr(lo, '>');
+        if (!hi) break;
+        char *tmp = charset_unfold(lo + 1, hi - lo - 1, CHARSET_UNFOLD_SKIPWS);
+        _remove_ws(tmp);
+        if (*tmp) json_array_append_new(urls, json_string(tmp));
+        free(tmp);
+        base = hi + 1;
+    }
+    if (!json_array_size(urls)) {
+        json_decref(urls);
+        urls = json_null();
+    }
+    return urls;
+}
+
+struct header_prop {
+    char *lcasename;
+    char *name;
+    const char *prop;
+    enum header_form form;
+    int all;
+};
+
+static void _header_prop_fini(struct header_prop *prop)
+{
+    free(prop->lcasename);
+    free(prop->name);
+}
+
+static void _header_prop_free(struct header_prop *prop)
+{
+    _header_prop_fini(prop);
+    free(prop);
+}
+
+static struct header_prop *_header_parseprop(const char *s)
+{
+    strarray_t *fields = strarray_split(s + 7, ":", 0);
+    const char *f0, *f1, *f2;
+    int is_valid = 1;
+    enum header_form form = HEADER_FORM_RAW;
+    char *lcasename = NULL, *name = NULL;
+
+    /* Initialize allowed header forms by lower-case header name. Any
+     * header in this map is allowed to be requested either as Raw
+     * or the form of the map value (casted to void* because C...).
+     * Any header not found in this map is allowed to be requested
+     * in any form. */
+    static hash_table allowed_header_forms = HASH_TABLE_INITIALIZER;
+    if (allowed_header_forms.size == 0) {
+        /* TODO initialize with all headers in RFC5322 and RFC2369 */
+        construct_hash_table(&allowed_header_forms, 32, 0);
+        hash_insert("bcc",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("cc",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("content-type",
+                (void*) HEADER_FORM_RAW,
+                &allowed_header_forms);
+        hash_insert("comment",
+                (void*) HEADER_FORM_TEXT,
+                &allowed_header_forms);
+        hash_insert("date",
+                (void*) HEADER_FORM_DATE,
+                &allowed_header_forms);
+        hash_insert("from",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("in-reply-to",
+                (void*) HEADER_FORM_MESSAGEIDS,
+                &allowed_header_forms);
+        hash_insert("list-archive",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("list-help",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("list-owner",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("list-post",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("list-subscribe",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("list-unsubscribe",
+                (void*) HEADER_FORM_URLS,
+                &allowed_header_forms);
+        hash_insert("message-id",
+                (void*) HEADER_FORM_MESSAGEIDS,
+                &allowed_header_forms);
+        hash_insert("references",
+                (void*) HEADER_FORM_MESSAGEIDS,
+                &allowed_header_forms);
+        hash_insert("reply-to",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-date",
+                (void*) HEADER_FORM_DATE,
+                &allowed_header_forms);
+        hash_insert("resent-from",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-message-id",
+                (void*) HEADER_FORM_MESSAGEIDS,
+                &allowed_header_forms);
+        hash_insert("resent-reply-to",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-sender",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-to",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-cc",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("resent-bcc",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("sender",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+        hash_insert("subject",
+                (void*) HEADER_FORM_TEXT,
+                &allowed_header_forms);
+        hash_insert("to",
+                (void*) (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES),
+                &allowed_header_forms);
+    }
+
+    /* Parse property string into fields */
+    f0 = f1 = f2 = NULL;
+    switch (fields->count) {
+        case 3:
+            f2 = strarray_nth(fields, 2);
+            /* fallthrough */
+        case 2:
+            f1 = strarray_nth(fields, 1);
+            /* fallthrough */
+        case 1:
+            f0 = strarray_nth(fields, 0);
+            lcasename = lcase(xstrdup(f0));
+            name = xstrdup(f0);
+            break;
+        default:
+            strarray_free(fields);
+            return NULL;
+    }
+
+    if (f2 && (strcmp(f2, "all") || !strcmp(f1, "all"))) {
+        strarray_free(fields);
+        free(lcasename);
+        free(name);
+        return NULL;
+    }
+    if (f1) {
+        if (!strcmp(f1, "asRaw"))
+            form = HEADER_FORM_RAW;
+        else if (!strcmp(f1, "asText"))
+            form = HEADER_FORM_TEXT;
+        else if (!strcmp(f1, "asAddresses"))
+            form = HEADER_FORM_ADDRESSES;
+        else if (!strcmp(f1, "asGroupedAddresses"))
+            form = HEADER_FORM_GROUPEDADDRESSES;
+        else if (!strcmp(f1, "asMessageIds"))
+            form = HEADER_FORM_MESSAGEIDS;
+        else if (!strcmp(f1, "asDate"))
+            form = HEADER_FORM_DATE;
+        else if (!strcmp(f1, "asURLs"))
+            form = HEADER_FORM_URLS;
+        else if (strcmp(f1, "all"))
+            is_valid = 0;
+    }
+
+    /* Validate requested header form */
+    if (is_valid && form != HEADER_FORM_RAW) {
+        enum header_form allowed_form = (enum header_form) \
+                                         hash_lookup(lcasename, &allowed_header_forms);
+        if (allowed_form != HEADER_FORM_UNKNOWN && !(form & allowed_form)) {
+            is_valid = 0;
+        }
+    }
+
+    struct header_prop *hprop = NULL;
+    if (is_valid) {
+        hprop = xzmalloc(sizeof(struct header_prop));
+        hprop->lcasename = lcasename;
+        hprop->name = name;
+        hprop->prop = s;
+        hprop->form = form;
+        hprop->all = f2 != NULL || (f1 && !strcmp(f1, "all"));
+    }
+    else {
+        free(lcasename);
+        free(name);
+    }
+    strarray_free(fields);
+    return hprop;
+}
+
+/* Generate a preview of text of at most len bytes, excluding the zero
+ * byte.
+ *
+ * Consecutive whitespaces, including newlines, are collapsed to a single
+ * blank. If text is longer than len and len is greater than 4, then return
+ * a string  ending in '...' and holding as many complete UTF-8 characters,
+ * that the total byte count of non-zero characters is at most len.
+ *
+ * The input string must be properly encoded UTF-8 */
+static char *_email_extract_preview(const char *text, size_t len)
+{
+    unsigned char *dst, *d, *t;
+    size_t n;
+
+    if (!text) {
+        return NULL;
+    }
+
+    /* Replace all whitespace with single blanks. */
+    dst = (unsigned char *) xzmalloc(len+1);
+    for (t = (unsigned char *) text, d = dst; *t && d < (dst+len); ++t, ++d) {
+        *d = isspace(*t) ? ' ' : *t;
+        if (isspace(*t)) {
+            while(isspace(*++t))
+                ;
+            --t;
+        }
+    }
+    n = d - dst;
+
+    /* Anything left to do? */
+    if (n < len || len <= 4) {
+        return (char*) dst;
+    }
+
+    /* Append trailing ellipsis. */
+    dst[--n] = '.';
+    dst[--n] = '.';
+    dst[--n] = '.';
+    while (n && (dst[n] & 0xc0) == 0x80) {
+        dst[n+2] = 0;
+        dst[--n] = '.';
+    }
+    if (dst[n] >= 0x80) {
+        dst[n+2] = 0;
+        dst[--n] = '.';
+    }
+    return (char *) dst;
+}
+
+struct _email_mailboxes_rock {
+    jmap_req_t *req;
+    json_t *mboxs;
+};
+
+static int _email_mailboxes_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct _email_mailboxes_rock *data = (struct _email_mailboxes_rock*) rock;
+    json_t *mboxs = data->mboxs;
+    jmap_req_t *req = data->req;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    uint32_t system_flags, internal_flags;
+    int r;
+
+    if (rec->part) return 0;
+
+    static int needrights = ACL_READ|ACL_LOOKUP;
+    if (!jmap_hasrights_byname(req, rec->mboxname, needrights))
+        return 0;
+
+    r = jmap_openmbox(req, rec->mboxname, &mbox, 0);
+    if (r) return r;
+
+    // we only want regular mailboxes!
+    if (mbox->mbtype & MBTYPES_NONIMAP) goto done;
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (r) goto done;
+
+    r = msgrecord_get_systemflags(mr, &system_flags);
+    if (r) goto done;
+
+    r = msgrecord_get_internalflags(mr, &internal_flags);
+    if (r) goto done;
+
+    if (!r) {
+        char datestr[RFC3339_DATETIME_MAX];
+        time_t t;
+        int exists = 1;
+
+        if (system_flags & FLAG_DELETED || internal_flags & FLAG_INTERNAL_EXPUNGED) {
+            exists = 0;
+            r = msgrecord_get_lastupdated(mr, &t);
+        }
+        else {
+            r = msgrecord_get_savedate(mr, &t);
+        }
+
+        if (r) goto done;
+        time_to_rfc3339(t, datestr, RFC3339_DATETIME_MAX);
+
+        json_t *mboxdata = json_object_get(mboxs, mbox->uniqueid);
+        if (!mboxdata) {
+            mboxdata = json_object();
+            json_object_set_new(mboxs, mbox->uniqueid, mboxdata);
+        }
+
+        if (exists) {
+            json_t *prev = json_object_get(mboxdata, "added");
+            if (prev) {
+                const char *val = json_string_value(prev);
+                // we want the FIRST date it was added to the mailbox, so skip if this is newer
+                if (strcmp(datestr, val) >= 0) goto done;
+            }
+
+            json_object_set_new(mboxdata, "added", json_string(datestr));
+        }
+        else {
+            json_t *prev = json_object_get(mboxdata, "removed");
+            if (prev) {
+                const char *val = json_string_value(prev);
+                // we want the LAST date it was removed from the mailbox, so skip if this is older
+                if (strcmp(datestr, val) <= 0) goto done;
+            }
+
+            json_object_set_new(mboxdata, "removed", json_string(datestr));
+        }
+    }
+
+
+done:
+    if (mr) msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    return r;
+}
+
+static char *_emailbodies_to_plain(struct emailbodies *bodies, const struct buf *msg_buf)
+{
+    if (bodies->textlist.count == 1) {
+        int is_encoding_problem = 0;
+        struct body *textbody = ptrarray_nth(&bodies->textlist, 0);
+        char *text = _decode_to_utf8(textbody->charset_id,
+                                     msg_buf->s + textbody->content_offset,
+                                     textbody->content_size,
+                                     textbody->encoding,
+                                     &is_encoding_problem);
+        return text;
+    }
+
+    /* Concatenate all plain text bodies and replace any
+     * inlined images with placeholders. */
+    int i;
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < bodies->textlist.count; i++) {
+        struct body *part = ptrarray_nth(&bodies->textlist, i);
+
+        if (i) buf_appendcstr(&buf, "\n");
+
+        if (!strcmp(part->type, "TEXT")) {
+            int is_encoding_problem = 0;
+            char *t = _decode_to_utf8(part->charset_id,
+                                      msg_buf->s + part->content_offset,
+                                      part->content_size,
+                                      part->encoding,
+                                      &is_encoding_problem);
+            if (t) buf_appendcstr(&buf, t);
+            free(t);
+        }
+        else if (!strcmp(part->type, "IMAGE")) {
+            struct param *param;
+            const char *fname = NULL;
+            for (param = part->disposition_params; param; param = param->next) {
+                if (!strncasecmp(param->attribute, "filename", 8)) {
+                    fname =param->value;
+                    break;
+                }
+            }
+            buf_appendcstr(&buf, "[Inline image");
+            if (fname) {
+                buf_appendcstr(&buf, ":");
+                buf_appendcstr(&buf, fname);
+            }
+            buf_appendcstr(&buf, "]");
+        }
+    }
+    return buf_release(&buf);
+}
+
+/* Replace any <HTML> and </HTML> tags in t with <DIV> and </DIV>,
+ * writing results into buf */
+static void _html_concat_div(struct buf *buf, const char *t)
+{
+    const char *top = t + strlen(t);
+    const char *p = t, *q = p;
+
+    while (*q) {
+        const char *tag = NULL;
+        if (q < top - 5 && !strncasecmp(q, "<html", 5) &&
+                (*(q+5) == '>' || isspace(*(q+5)))) {
+            /* Found a <HTML> tag */
+            tag = "<div>";
+        }
+        else if (q < top - 6 && !strncasecmp(q, "</html", 6) &&
+                (*(q+6) == '>' || isspace(*(q+6)))) {
+            /* Found a </HTML> tag */
+            tag = "</div>";
+        }
+
+        /* No special tag? */
+        if (!tag) {
+            q++;
+            continue;
+        }
+
+        /* Append whatever we saw since the last HTML tag. */
+        buf_appendmap(buf, p, q - p);
+
+        /* Look for the end of the tag and replace it, even if
+         * it prematurely ends at the end of the buffer . */
+        while (*q && *q != '>') { q++; }
+        buf_appendcstr(buf, tag);
+        if (*q) q++;
+
+        /* Prepare for next loop */
+        p = q;
+    }
+    buf_appendmap(buf, p, q - p);
+}
+
+
+static char *_emailbodies_to_html(struct emailbodies *bodies, const struct buf *msg_buf)
+{
+    if (bodies->htmllist.count == 1) {
+        const struct body *part = ptrarray_nth(&bodies->htmllist, 0);
+        int is_encoding_problem = 0;
+        char *html = _decode_to_utf8(part->charset_id,
+                                     msg_buf->s + part->content_offset,
+                                     part->content_size,
+                                     part->encoding,
+                                     &is_encoding_problem);
+        return html;
+    }
+
+    /* Concatenate all TEXT bodies, enclosing PLAIN text
+     * in <div> and replacing <html> tags in HTML bodies
+     * with <div>. */
+    int i;
+    struct buf buf = BUF_INITIALIZER;
+    for (i = 0; i < bodies->htmllist.count; i++) {
+        struct body *part = ptrarray_nth(&bodies->htmllist, i);
+
+        /* XXX htmllist might include inlined images but we
+         * currently ignore them. After all, there should
+         * already be an <img> tag for their Content-Id
+         * header value. If this turns out to be not enough,
+         * we can insert the <img> tags here. */
+        if (strcasecmp(part->type, "TEXT")) {
+            continue;
+        }
+
+        if (!i)
+            buf_appendcstr(&buf, "<html>"); // XXX use HTML5?
+
+        int is_encoding_problem = 0;
+        char *t = _decode_to_utf8(part->charset_id,
+                                  msg_buf->s + part->content_offset,
+                                  part->content_size,
+                                  part->encoding,
+                                  &is_encoding_problem);
+        if (t && !strcmp(part->subtype, "HTML")) {
+            _html_concat_div(&buf, t);
+        }
+        else if (t) {
+            buf_appendcstr(&buf, "<div>");
+            buf_appendcstr(&buf, t);
+            buf_appendcstr(&buf, "</div>");
+        }
+        free(t);
+
+        if (i == bodies->htmllist.count - 1)
+            buf_appendcstr(&buf, "</html>");
+    }
+    return buf_release(&buf);
+}
+
+static void _html_to_plain_cb(const struct buf *buf, void *rock)
+{
+    struct buf *dst = (struct buf*) rock;
+    const char *p;
+    int seenspace = 0;
+
+    /* Just merge multiple space into one. That's similar to
+     * charset_extract's MERGE_SPACE but since we don't want
+     * it to canonify the text into search form */
+    for (p = buf_base(buf); p < buf_base(buf) + buf_len(buf) && *p; p++) {
+        if (*p == ' ') {
+            if (seenspace) continue;
+            seenspace = 1;
+        } else {
+            seenspace = 0;
+        }
+        buf_appendmap(dst, p, 1);
+    }
+}
+
+static char *_html_to_plain(const char *html) {
+    struct buf src = BUF_INITIALIZER;
+    struct buf dst = BUF_INITIALIZER;
+    charset_t utf8 = charset_lookupname("utf8");
+    char *text;
+    char *tmp, *q;
+    const char *p;
+
+    /* Replace <br> and <p> with newlines */
+    q = tmp = xstrdup(html);
+    p = html;
+    while (*p) {
+        if (!strncmp(p, "<br>", 4) || !strncmp(p, "</p>", 4)) {
+            *q++ = '\n';
+            p += 4;
+        }
+        else if (!strncmp(p, "p>", 3)) {
+            p += 3;
+        } else {
+            *q++ = *p++;
+        }
+    }
+    *q = 0;
+
+    /* Strip html tags */
+    buf_init_ro(&src, tmp, q - tmp);
+    buf_setcstr(&dst, "");
+    charset_extract(&_html_to_plain_cb, &dst,
+            &src, utf8, ENCODING_NONE, "HTML", CHARSET_KEEPCASE);
+    buf_cstring(&dst);
+
+    /* Trim text */
+    buf_trim(&dst);
+    text = buf_releasenull(&dst);
+    if (!strlen(text)) {
+        free(text);
+        text = NULL;
+    }
+
+    buf_free(&src);
+    free(tmp);
+    charset_free(&utf8);
+
+    return text;
+}
+
+static const char *_guid_from_id(const char *msgid)
+{
+    return msgid + 1;
+}
+
+static conversation_id_t _cid_from_id(const char *thrid)
+{
+    conversation_id_t cid = 0;
+    if (thrid[0] == 'T')
+        conversation_id_decode(&cid, thrid+1);
+    return cid;
+}
+
+/*
+ * Lookup all mailboxes where msgid is contained in.
+ *
+ * The return value is a JSON object keyed by the mailbox unique id,
+ * and its mailbox name as value.
+ */
+static json_t *_email_mailboxes(jmap_req_t *req, const char *msgid)
+{
+    struct _email_mailboxes_rock data = { req, json_pack("{}") };
+    conversations_guid_foreach(req->cstate, _guid_from_id(msgid), _email_mailboxes_cb, &data);
+    return data.mboxs;
+}
+
+
+
+static void _email_read_annot(const jmap_req_t *req, msgrecord_t *mr,
+                              const char *annot, struct buf *buf)
+{
+    if (!strncmp(annot, "/shared/", 8)) {
+        msgrecord_annot_lookup(mr, annot+7, /*userid*/"", buf);
+    }
+    else if (!strncmp(annot, "/private/", 9)) {
+        msgrecord_annot_lookup(mr, annot+7, req->userid, buf);
+    }
+    else {
+        msgrecord_annot_lookup(mr, annot, "", buf);
+    }
+}
+
+static json_t *_email_read_jannot(const jmap_req_t *req, msgrecord_t *mr,
+                                  const char *annot, int structured)
+{
+    struct buf buf = BUF_INITIALIZER;
+    json_t *annotvalue = NULL;
+
+    _email_read_annot(req, mr, annot, &buf);
+
+    if (buf_len(&buf)) {
+        if (structured) {
+            json_error_t jerr;
+            annotvalue = json_loads(buf_cstring(&buf), JSON_DECODE_ANY, &jerr);
+            /* XXX - log error? */
+        }
+        else {
+            annotvalue = json_string(buf_cstring(&buf));
+        }
+
+        if (!annotvalue) {
+            syslog(LOG_ERR, "jmap: annotation %s has bogus value", annot);
+        }
+    }
+    buf_free(&buf);
+    return annotvalue;
+}
+
+
+struct _email_find_rock {
+    jmap_req_t *req;
+    char *mboxname;
+    uint32_t uid;
+};
+
+static int _email_find_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct _email_find_rock *d = (struct _email_find_rock*) rock;
+    jmap_req_t *req = d->req;
+
+    if (rec->part) return 0;
+
+    /* Make sure we are allowed to read this mailbox */
+    if (!jmap_hasrights_byname(req, rec->mboxname, ACL_READ))
+        return 0;
+
+    int r = 0;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    uint32_t system_flags;
+    uint32_t internal_flags;
+
+    r = jmap_openmbox(req, rec->mboxname, &mbox, 0);
+    if (r) {
+        // we want to keep looking and see if we can find a mailbox we can open
+        syslog(LOG_ERR, "IOERROR: email_find_cb failed to open %s: %s",
+               rec->mboxname, error_message(r));
+        goto done;
+    }
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (!r) r = msgrecord_get_systemflags(mr, &system_flags);
+    if (!r) r = msgrecord_get_internalflags(mr, &internal_flags);
+    if (r) {
+        // we want to keep looking and see if we can find a message we can read
+        syslog(LOG_ERR, "IOERROR: email_find_cb failed to find message %u in mailbox %s: %s",
+               rec->uid, rec->mboxname, error_message(r));
+        goto done;
+    }
+
+    // if it's deleted, skip
+    if ((system_flags & FLAG_DELETED) || (internal_flags & FLAG_INTERNAL_EXPUNGED))
+        goto done;
+
+    d->mboxname = xstrdup(rec->mboxname);
+    d->uid = rec->uid;
+
+done:
+    jmap_closembox(req, &mbox);
+    msgrecord_unref(&mr);
+    return d->mboxname ? IMAP_OK_COMPLETED : 0;
+}
+
+static int _email_find_in_account(jmap_req_t *req,
+                                  const char *account_id,
+                                  const char *email_id,
+                                  char **mboxnameptr,
+                                  uint32_t *uidptr)
+{
+    struct _email_find_rock rock = { req, NULL, 0 };
+    int r;
+
+    /* must be prefixed with 'M' */
+    if (email_id[0] != 'M')
+        return IMAP_NOTFOUND;
+    /* this is on a 24 character prefix only */
+    if (strlen(email_id) != 25)
+        return IMAP_NOTFOUND;
+    /* Open conversation state, if not already open */
+    struct conversations_state *mycstate = NULL;
+    if (strcmp(req->accountid, account_id)) {
+        r = conversations_open_user(account_id, 1/*shared*/, &mycstate);
+        if (r) return r;
+    }
+    else {
+        mycstate = req->cstate;
+    }
+    r = conversations_guid_foreach(mycstate, _guid_from_id(email_id),
+                                   _email_find_cb, &rock);
+    if (mycstate != req->cstate) {
+        conversations_commit(&mycstate);
+    }
+    /* Set return values */
+    if (r == IMAP_OK_COMPLETED)
+        r = 0;
+    else if (!rock.mboxname)
+        r = IMAP_NOTFOUND;
+    *mboxnameptr = rock.mboxname;
+    *uidptr = rock.uid;
+    return r;
+}
+
+HIDDEN int jmap_email_find(jmap_req_t *req,
+                           const char *email_id,
+                           char **mboxnameptr,
+                           uint32_t *uidptr)
+{
+    return _email_find_in_account(req, req->accountid, email_id, mboxnameptr, uidptr);
+}
+
+struct email_getcid_rock {
+    jmap_req_t *req;
+    int checkacl;
+    conversation_id_t cid;
+};
+
+static int _email_get_cid_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct email_getcid_rock *d = (struct email_getcid_rock *)rock;
+    if (rec->part) return 0;
+    if (!rec->cid) return 0;
+    /* Make sure we are allowed to read this mailbox */
+    if (d->checkacl && !jmap_hasrights_byname(d->req, rec->mboxname, ACL_READ))
+            return 0;
+    d->cid = rec->cid;
+    return IMAP_OK_COMPLETED;
+}
+
+static int _email_get_cid(jmap_req_t *req, const char *msgid,
+                           conversation_id_t *cidp)
+{
+    int r;
+
+    /* must be prefixed with 'M' */
+    if (msgid[0] != 'M')
+        return IMAP_NOTFOUND;
+    /* this is on a 24 character prefix only */
+    if (strlen(msgid) != 25)
+        return IMAP_NOTFOUND;
+
+    int checkacl = strcmp(req->userid, req->accountid);
+    struct email_getcid_rock rock = { req, checkacl, 0 };
+    r = conversations_guid_foreach(req->cstate, _guid_from_id(msgid), _email_get_cid_cb, &rock);
+    if (r == IMAP_OK_COMPLETED) {
+        *cidp = rock.cid;
+        r = 0;
+    }
+    return r;
+}
+
+struct email_expunge_check {
+    jmap_req_t *req;
+    modseq_t since_modseq;
+    int status;
+};
+
+static int _email_is_expunged_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct email_expunge_check *check = rock;
+    msgrecord_t *mr = NULL;
+    struct mailbox *mbox = NULL;
+    uint32_t flags;
+    int r = 0;
+
+    if (rec->part) return 0;
+
+    r = jmap_openmbox(check->req, rec->mboxname, &mbox, 0);
+    if (r) return r;
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (!r) {
+        uint32_t internal_flags;
+        modseq_t createdmodseq;
+        r = msgrecord_get_systemflags(mr, &flags);
+        if (!r) msgrecord_get_internalflags(mr, &internal_flags);
+        if (!r) msgrecord_get_createdmodseq(mr, &createdmodseq);
+        if (!r) {
+            /* OK, this is a legit record, let's check it out */
+            if (createdmodseq <= check->since_modseq)
+                check->status |= 1;  /* contains old messages */
+            if (!((flags & FLAG_DELETED) || (internal_flags & FLAG_INTERNAL_EXPUNGED)))
+                check->status |= 2;  /* contains alive messages */
+        }
+        msgrecord_unref(&mr);
+    }
+
+    jmap_closembox(check->req, &mbox);
+    return 0;
+}
+
+static void _email_search_perf_attr(const search_attr_t *attr, strarray_t *perf_filters)
+{
+    const char *cost = NULL;
+
+    switch (search_attr_cost(attr)) {
+        case SEARCH_COST_INDEX:
+            cost = "index";
+            break;
+        case SEARCH_COST_CONV:
+            cost = "conversations";
+            break;
+        case SEARCH_COST_ANNOT:
+            cost = "annotations";
+            break;
+        case SEARCH_COST_CACHE:
+            cost = search_attr_is_fuzzable(attr) ? "xapian" : "cache";
+            break;
+        case SEARCH_COST_BODY:
+            cost = search_attr_is_fuzzable(attr) ? "xapian" : "body";
+            break;
+        default:
+            ; // ignore
+    }
+
+    if (cost) strarray_add(perf_filters, cost);
+}
+
+static void _email_search_string(search_expr_t *parent,
+                                 const char *s,
+                                 const char *name,
+                                 strarray_t *perf_filters)
+{
+    charset_t utf8 = charset_lookupname("utf-8");
+    search_expr_t *e;
+    const search_attr_t *attr = search_attr_find(name);
+    enum search_op op;
+
+    assert(attr);
+
+    op = search_attr_is_fuzzable(attr) ? SEOP_FUZZYMATCH : SEOP_MATCH;
+
+    e = search_expr_new(parent, op);
+    e->attr = attr;
+    e->value.s = charset_convert(s, utf8, charset_flags);
+    if (!e->value.s) {
+        e->op = SEOP_FALSE;
+        e->attr = NULL;
+    }
+
+    _email_search_perf_attr(attr, perf_filters);
+    charset_free(&utf8);
+}
+
+static void _email_search_type(search_expr_t *parent, const char *s, strarray_t *perf_filters)
+{
+    strarray_t types = STRARRAY_INITIALIZER;
+
+    /* Handle type wildcards */
+    // XXX: due to Xapian's 64 character indexing limitation, we're not prefixing application_
+    // to the Microsoft types
+    if (!strcasecmp(s, "image")) {
+        strarray_append(&types, "image_gif");
+        strarray_append(&types, "image_jpeg");
+        strarray_append(&types, "image_pjpeg");
+        strarray_append(&types, "image_jpg");
+        strarray_append(&types, "image_png");
+        strarray_append(&types, "image_bmp");
+        strarray_append(&types, "image_tiff");
+    }
+    else if (!strcasecmp(s, "document")) {
+        strarray_append(&types, "application_msword");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.wordprocessingml.document");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.wordprocessingml.template");
+        strarray_append(&types, "application_vnd.sun.xml.writer");
+        strarray_append(&types, "application_vnd.sun.xml.writer.template");
+        strarray_append(&types, "application_vnd.oasis.opendocument.text");
+        strarray_append(&types, "application_vnd.oasis.opendocument.text-template");
+        strarray_append(&types, "application_x-iwork-pages-sffpages");
+        strarray_append(&types, "application_vnd.apple.pages");
+    }
+    else if (!strcasecmp(s, "spreadsheet")) {
+        strarray_append(&types, "application_vnd.ms-excel");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.spreadsheetml.sheet");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.spreadsheetml.template");
+        strarray_append(&types, "application_vnd.sun.xml.calc");
+        strarray_append(&types, "application_vnd.sun.xml.calc.template");
+        strarray_append(&types, "application_vnd.oasis.opendocument.spreadsheet");
+        strarray_append(&types, "application_vnd.oasis.opendocument.spreadsheet-template");
+        strarray_append(&types, "application_x-iwork-numbers-sffnumbers");
+        strarray_append(&types, "application_vnd.apple.numbers");
+    }
+    else if (!strcasecmp(s, "presentation")) {
+        strarray_append(&types, "application_vnd.ms-powerpoint");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.presentationml.presentation");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.presentationml.template");
+        strarray_append(&types, "vnd.openxmlformats-officedocument.presentationml.slideshow");
+        strarray_append(&types, "application_vnd.sun.xml.impress");
+        strarray_append(&types, "application_vnd.sun.xml.impress.template");
+        strarray_append(&types, "application_vnd.oasis.opendocument.presentation");
+        strarray_append(&types, "application_vnd.oasis.opendocument.presentation-template");
+        strarray_append(&types, "application_x-iwork-keynote-sffkey");
+        strarray_append(&types, "application_vnd.apple.keynote");
+    }
+    else if (!strcasecmp(s, "email")) {
+        strarray_append(&types, "message_rfc822");
+    }
+    else if (!strcasecmp(s, "pdf")) {
+        strarray_append(&types, "application_pdf");
+    }
+    else {
+        /* FUZZY contenttype is indexed as `type_subtype` */
+        char *tmp = xstrdup(s);
+        char *p = strchr(tmp, '/');
+        if (p) *p = '_';
+        strarray_append(&types, tmp);
+        free(tmp);
+    }
+
+    /* Build expression */
+    search_expr_t *p = (types.count > 1) ? search_expr_new(parent, SEOP_OR) : parent;
+    const search_attr_t *attr = search_attr_find("contenttype");
+    do {
+        search_expr_t *e = search_expr_new(p, SEOP_FUZZYMATCH);
+        e->attr = attr;
+        struct buf buf = BUF_INITIALIZER;
+        char *orig = strarray_pop(&types);
+        const unsigned char *s = (const unsigned char *)orig;
+        for ( ; *s ; ++s) {
+            if (Uisalnum(*s) || *s == '_')
+                buf_putc(&buf, *s);
+        }
+        e->value.s = buf_release(&buf);
+        free(orig);
+        buf_free(&buf);
+    } while (types.count);
+    _email_search_perf_attr(attr, perf_filters);
+
+    strarray_fini(&types);
+}
+
+static void _email_search_keyword(search_expr_t *parent, const char *keyword, strarray_t *perf_filters)
+{
+    search_expr_t *e;
+    if (!strcasecmp(keyword, "$Seen")) {
+        e = search_expr_new(parent, SEOP_MATCH);
+        e->attr = search_attr_find("indexflags");
+        e->value.u = MESSAGE_SEEN;
+    }
+    else if (!strcasecmp(keyword, "$Draft")) {
+        e = search_expr_new(parent, SEOP_MATCH);
+        e->attr = search_attr_find("systemflags");
+        e->value.u = FLAG_DRAFT;
+    }
+    else if (!strcasecmp(keyword, "$Flagged")) {
+        e = search_expr_new(parent, SEOP_MATCH);
+        e->attr = search_attr_find("systemflags");
+        e->value.u = FLAG_FLAGGED;
+    }
+    else if (!strcasecmp(keyword, "$Answered")) {
+        e = search_expr_new(parent, SEOP_MATCH);
+        e->attr = search_attr_find("systemflags");
+        e->value.u = FLAG_ANSWERED;
+    }
+    else {
+        e = search_expr_new(parent, SEOP_MATCH);
+        e->attr = search_attr_find("keyword");
+        e->value.s = xstrdup(keyword);
+    }
+    _email_search_perf_attr(e->attr, perf_filters);
+}
+
+static void _email_search_threadkeyword(search_expr_t *parent, const char *keyword,
+                                        int matchall, strarray_t *perf_filters)
+{
+    const char *flag = jmap_keyword_to_imap(keyword);
+    if (!flag) return;
+
+    search_expr_t *e = search_expr_new(parent, SEOP_MATCH);
+    e->attr = search_attr_find(matchall ? "allconvflags" : "convflags");
+    e->value.s = xstrdup(flag);
+    _email_search_perf_attr(e->attr, perf_filters);
+}
+
+static void _email_search_contactgroup(search_expr_t *parent,
+                                       const char *groupid,
+                                       const char *attrname,
+                                       hash_table *contactgroups,
+                                       strarray_t *perf_filters)
+{
+    if (!contactgroups || !contactgroups->size) return;
+
+    strarray_t *members = hash_lookup(groupid, contactgroups);
+    if (members && strarray_size(members)) {
+        charset_t utf8 = charset_lookupname("utf-8");
+        const search_attr_t *attr = search_attr_find(attrname);
+        search_expr_t *e = search_expr_new(parent, SEOP_FUZZYMATCH);
+        e->attr = attr;
+        e->value.list = strarray_new();
+        int i;
+        for (i = 0; i < strarray_size(members); i++) {
+            char *s = charset_convert(strarray_nth(members, i), utf8, charset_flags);
+            strarray_appendm(e->value.list, s);
+        }
+        charset_free(&utf8);
+        _email_search_perf_attr(e->attr, perf_filters);
+    }
+    else {
+         search_expr_new(parent, SEOP_FALSE);
+    }
+}
+
+/* ====================================================================== */
+
+static void _emailsearch_folders_internalise(struct index_state *state,
+                                             const union search_value *v,
+                                             void **internalisedp)
+{
+    if (state && v) {
+        *internalisedp = mailbox_get_cstate(state->mailbox);
+    }
+}
+
+struct jmap_search_folder_match_rock {
+    const strarray_t *folders;
+    intptr_t is_otherthan;
+};
+
+static int _emailsearch_folders_match_cb(const conv_guidrec_t *rec, void *rock)
+{
+    if ((rec->system_flags & FLAG_DELETED) ||
+        (rec->internal_flags & FLAG_INTERNAL_EXPUNGED)) return 0;
+
+    // TODO we could match for mboxid, once the mailbox-id patch lands
+    struct jmap_search_folder_match_rock *myrock = rock;
+    int pos = strarray_find(myrock->folders, rec->mboxname, 0);
+    return ((pos >= 0) == (myrock->is_otherthan == 0)) ? IMAP_OK_COMPLETED : 0;
+}
+
+static int _emailsearch_folders_match(message_t *m, const union search_value *v,
+                                      void *internalised,
+                                      void *data1)
+{
+    struct conversations_state *cstate = internalised;
+    if (!cstate) return 0;
+    const struct message_guid *guid = NULL;
+    int r = message_get_guid(m, &guid);
+    if (r) return 0;
+    struct jmap_search_folder_match_rock rock = { v->list, (intptr_t) data1 };
+    r = conversations_guid_foreach(cstate, message_guid_encode(guid),
+                                   _emailsearch_folders_match_cb, &rock);
+    return r == IMAP_OK_COMPLETED;
+}
+
+static void _emailsearch_folders_serialise(struct buf *buf,
+                                           const union search_value *v)
+{
+    char *tmp = strarray_join(v->list, " ");
+    buf_putc(buf, '(');
+    buf_appendcstr(buf, tmp);
+    buf_putc(buf, ')');
+    free(tmp);
+}
+
+static int _emailsearch_folders_unserialise(struct protstream* prot,
+                                            union search_value *v)
+{
+    struct dlist *dl = NULL;
+
+    int c = dlist_parse_asatomlist(&dl, 0, prot);
+    if (c == EOF) return EOF;
+
+    strarray_t *folders = strarray_new();
+    struct buf tmp = BUF_INITIALIZER;
+    struct dlist_print_iter *iter = dlist_print_iter_new(dl, /*printkeys*/ 0);
+    while (iter && dlist_print_iter_step(iter, &tmp)) {
+        if (buf_len(&tmp)) strarray_append(folders, buf_cstring(&tmp));
+        buf_reset(&tmp);
+    }
+    dlist_print_iter_free(&iter);
+    buf_free(&tmp);
+    v->list = folders;
+    return c;
+}
+
+static void _emailsearch_folders_duplicate(union search_value *new,
+                                           const union search_value *old)
+{
+    new->list = strarray_dup(old->list);
+}
+
+static void _emailsearch_folders_free(union search_value *v)
+{
+    strarray_free(v->list);
+}
+
+static const search_attr_t _emailsearch_folders_attr = {
+    "jmap_folders",
+    SEA_MUTABLE,
+    SEARCH_PART_NONE,
+    SEARCH_COST_CONV,
+    _emailsearch_folders_internalise,
+    /*cmp*/NULL,
+    _emailsearch_folders_match,
+    _emailsearch_folders_serialise,
+    _emailsearch_folders_unserialise,
+    /*get_countability*/NULL,
+    _emailsearch_folders_duplicate,
+    _emailsearch_folders_free,
+    (void*)0 /*is_otherthan*/
+};
+
+static const search_attr_t _emailsearch_folders_otherthan_attr = {
+    "jmap_folders_otherthan",
+    SEA_MUTABLE,
+    SEARCH_PART_NONE,
+    SEARCH_COST_CONV,
+    _emailsearch_folders_internalise,
+    /*cmp*/NULL,
+    _emailsearch_folders_match,
+    _emailsearch_folders_serialise,
+    _emailsearch_folders_unserialise,
+    /*get_countability*/NULL,
+    _emailsearch_folders_duplicate,
+    _emailsearch_folders_free,
+    (void*)1 /*is_otherthan*/
+};
+
+
+/* ====================================================================== */
+
+static search_expr_t *_email_buildsearchexpr(jmap_req_t *req, json_t *filter,
+                                             search_expr_t *parent,
+                                             hash_table *contactgroups,
+                                             strarray_t *perf_filters)
+{
+    search_expr_t *this, *e;
+    json_t *val;
+    const char *s;
+    size_t i;
+    time_t t;
+
+    if (!JNOTNULL(filter)) {
+        return search_expr_new(parent, SEOP_TRUE);
+    }
+
+    if ((s = json_string_value(json_object_get(filter, "operator")))) {
+        enum search_op op = SEOP_UNKNOWN;
+
+        if (!strcmp("AND", s)) {
+            op = SEOP_AND;
+        } else if (!strcmp("OR", s)) {
+            op = SEOP_OR;
+        } else if (!strcmp("NOT", s)) {
+            op = SEOP_NOT;
+        }
+
+        this = search_expr_new(parent, op);
+        e = op == SEOP_NOT ? search_expr_new(this, SEOP_OR) : this;
+
+        json_array_foreach(json_object_get(filter, "conditions"), i, val) {
+            _email_buildsearchexpr(req, val, e, contactgroups, perf_filters);
+        }
+    } else {
+        this = search_expr_new(parent, SEOP_AND);
+
+        /* zero properties evaluate to true */
+        search_expr_new(this, SEOP_TRUE);
+
+        if ((s = json_string_value(json_object_get(filter, "after")))) {
+            time_from_iso8601(s, &t);
+            e = search_expr_new(this, SEOP_GE);
+            e->attr = search_attr_find("internaldate");
+            e->value.u = t;
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "before")))) {
+            time_from_iso8601(s, &t);
+            e = search_expr_new(this, SEOP_LE);
+            e->attr = search_attr_find("internaldate");
+            e->value.u = t;
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "body")))) {
+            _email_search_string(this, s, "body", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "cc")))) {
+            _email_search_string(this, s, "cc", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "bcc")))) {
+            _email_search_string(this, s, "bcc", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "from")))) {
+            _email_search_string(this, s, "from", perf_filters);
+        }
+        if (json_is_true(json_object_get(filter, "fromAnyContact"))) {
+            _email_search_contactgroup(this, "", "fromlist", contactgroups, perf_filters);
+        }
+        if (json_is_true(json_object_get(filter, "toAnyContact"))) {
+            _email_search_contactgroup(this, "", "tolist", contactgroups, perf_filters);
+        }
+        if (json_is_true(json_object_get(filter, "ccAnyContact"))) {
+            _email_search_contactgroup(this, "", "cclist", contactgroups, perf_filters);
+        }
+        if (json_is_true(json_object_get(filter, "bccAnyContact"))) {
+            _email_search_contactgroup(this, "", "bcclist", contactgroups, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "fromContactGroupId")))) {
+            _email_search_contactgroup(this, s, "fromlist", contactgroups, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "toContactGroupId")))) {
+            _email_search_contactgroup(this, s, "tolist", contactgroups, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "ccContactGroupId")))) {
+            _email_search_contactgroup(this, s, "cclist", contactgroups, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "bccContactGroupId")))) {
+            _email_search_contactgroup(this, s, "bcclist", contactgroups, perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "hasAttachment")))) {
+            e = val == json_false() ? search_expr_new(this, SEOP_NOT) : this;
+            e = search_expr_new(e, SEOP_MATCH);
+            e->attr = search_attr_find("keyword");
+            e->value.s = xstrdup(JMAP_HAS_ATTACHMENT_FLAG);
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "attachmentName")))) {
+            _email_search_string(this, s, "attachmentname", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "attachmentType")))) {
+            _email_search_type(this, s, perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "header")))) {
+            const char *k, *v;
+            charset_t utf8 = charset_lookupname("utf-8");
+            search_expr_t *e;
+
+            if (json_array_size(val) == 2) {
+                k = json_string_value(json_array_get(val, 0));
+                v = json_string_value(json_array_get(val, 1));
+            } else {
+                k = json_string_value(json_array_get(val, 0));
+                v = ""; /* Empty string matches any value */
+            }
+
+            e = search_expr_new(this, SEOP_MATCH);
+            e->attr = search_attr_find_field(k);
+            e->value.s = charset_convert(v, utf8, charset_flags);
+            if (!e->value.s) {
+                e->op = SEOP_FALSE;
+                e->attr = NULL;
+            }
+            _email_search_perf_attr(e->attr, perf_filters);
+            charset_free(&utf8);
+        }
+        if ((val = json_object_get(filter, "inMailbox"))) {
+            strarray_t *folders = strarray_new();
+            const char *mboxid = json_string_value(val);
+            const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mboxid);
+            if (mbentry && jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+                strarray_append(folders, mbentry->name);
+            }
+            if (strarray_size(folders)) {
+                search_expr_t *e = search_expr_new(this, SEOP_MATCH);
+                e->attr = &_emailsearch_folders_attr;
+                e->value.list = folders;
+                strarray_add(perf_filters, "mailbox");
+            }
+        }
+
+        if ((val = json_object_get(filter, "inMailboxOtherThan"))) {
+            strarray_t *folders = strarray_new();
+            json_t *jmboxid;
+            json_array_foreach(val, i, jmboxid) {
+                const char *mboxid = json_string_value(jmboxid);
+                const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mboxid);
+                if (mbentry && jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+                    strarray_append(folders, mbentry->name);
+                }
+            }
+            if (strarray_size(folders)) {
+                search_expr_t *e = search_expr_new(this, SEOP_MATCH);
+                e->attr = &_emailsearch_folders_otherthan_attr;
+                e->value.list = folders;
+                strarray_add(perf_filters, "mailbox");
+            }
+        }
+
+        if (JNOTNULL((val = json_object_get(filter, "allInThreadHaveKeyword")))) {
+            /* This shouldn't happen, validate_sort should have reported
+             * allInThreadHaveKeyword as unsupported. Let's ignore this
+             * filter and return false positives. */
+            _email_search_threadkeyword(this, json_string_value(val), 1, perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "someInThreadHaveKeyword")))) {
+            _email_search_threadkeyword(this, json_string_value(val), 0, perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "noneInThreadHaveKeyword")))) {
+            e = search_expr_new(this, SEOP_NOT);
+            _email_search_threadkeyword(e, json_string_value(val), 0, perf_filters);
+        }
+
+        if (JNOTNULL((val = json_object_get(filter, "hasKeyword")))) {
+            _email_search_keyword(this, json_string_value(val), perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "notKeyword")))) {
+            e = search_expr_new(this, SEOP_NOT);
+            _email_search_keyword(e, json_string_value(val), perf_filters);
+        }
+
+        if (JNOTNULL((val = json_object_get(filter, "maxSize")))) {
+            e = search_expr_new(this, SEOP_LE);
+            e->attr = search_attr_find("size");
+            e->value.u = json_integer_value(val);
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if (JNOTNULL((val = json_object_get(filter, "minSize")))) {
+            e = search_expr_new(this, SEOP_GE);
+            e->attr = search_attr_find("size");
+            e->value.u = json_integer_value(val);
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "sinceEmailState")))) {
+            /* non-standard */
+            e = search_expr_new(this, SEOP_GT);
+            e->attr = search_attr_find("modseq");
+            e->value.u = atomodseq_t(s);
+            _email_search_perf_attr(e->attr, perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "subject")))) {
+            _email_search_string(this, s, "subject", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "text")))) {
+            _email_search_string(this, s, "text", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "attachmentBody")))) {
+            _email_search_string(this, s, "attachmentbody", perf_filters);
+        }
+        if ((s = json_string_value(json_object_get(filter, "to")))) {
+            _email_search_string(this, s, "to", perf_filters);
+        }
+    }
+
+    return this;
+}
+
+static search_expr_t *_email_buildsearch(jmap_req_t *req, json_t *filter,
+                                         hash_table *contactgroups,
+                                         strarray_t *perf_filters)
+{
+    search_expr_t *root = _email_buildsearchexpr(req, filter, /*parent*/NULL,
+                                                 contactgroups, perf_filters);
+
+    /* The search API internally optimises for IMAP folder queries
+     * and we'd like to benefit from this also for JMAP. To do so,
+     * we try to convert as many inMailboxId expressions to IMAP
+     * mailbox matches as possible. This includes the first
+     * inMailboxId that is part of a positive AND and any inMailboxId
+     * that is part of a positive OR expression. */
+    ptrarray_t todo = PTRARRAY_INITIALIZER;
+    int found_and_match = 0;
+    struct work {
+        search_expr_t *e;
+        int in_or;
+    };
+    struct work *w = xmalloc(sizeof(struct work));
+    w->e = root;
+    w->in_or = 0;
+    ptrarray_push(&todo, w);
+    while ((w = ptrarray_pop(&todo))) {
+        if (w->e->op == SEOP_MATCH) {
+            if (!strcmp(w->e->attr->name, "jmap_folders") &&
+                w->e->attr->data1 == 0 &&
+                strarray_size(w->e->value.list) == 1) {
+                /* Its's an inMailboxId expression */
+                if (w->in_or || !found_and_match) {
+                    char *folder = strarray_pop(w->e->value.list);
+                    _emailsearch_folders_free(&w->e->value);
+                    const search_attr_t *attr = search_attr_find("folder");
+                    w->e->value.s = folder;
+                    w->e->attr = attr;
+                    found_and_match = !w->in_or;
+                }
+            }
+        }
+        else if (w->e->op == SEOP_AND || w->e->op == SEOP_OR) {
+            search_expr_t *c;
+            for (c = w->e->children; c; c = c->next) {
+                struct work *ww = xmalloc(sizeof(struct work));
+                ww->e = c;
+                ww->in_or = w->in_or || w->e->op == SEOP_OR;
+                ptrarray_push(&todo, ww);
+            }
+        }
+        free(w);
+    }
+    ptrarray_fini(&todo);
+
+    return root;
+}
+
+static void _email_contactfilter_initreq(jmap_req_t *req, struct email_contactfilter *cfilter)
+{
+    const char *addressbookid = json_string_value(json_object_get(req->args, "addressbookId"));
+    jmap_email_contactfilter_init(req->accountid, addressbookid, cfilter);
+}
+
+static void _email_parse_filter_cb(jmap_req_t *req,
+                                   struct jmap_parser *parser,
+                                   json_t *filter,
+                                   json_t *unsupported,
+                                   void *rock,
+                                   json_t **err)
+{
+    struct email_contactfilter *cfilter = rock;
+
+    /* Parse filter */
+    jmap_email_filtercondition_parse(parser, filter, unsupported,
+                                     req->using_capabilities);
+    if (json_array_size(parser->invalid)) return;
+
+    /* Gather contactgroups */
+    int r = jmap_email_contactfilter_from_filtercondition(parser, filter, cfilter);
+    if (r) {
+        *err = jmap_server_error(r);
+        return;
+    }
+
+    const char *field;
+    json_t *arg;
+
+    /* Validate permissions */
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "inMailbox")) {
+            if (json_is_string(arg)) {
+                const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, json_string_value(arg));
+                if (!mbentry || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+                    jmap_parser_invalid(parser, field);
+                }
+            }
+        }
+        else if (!strcmp(field, "inMailboxOtherThan")) {
+            if (json_is_array(arg)) {
+                size_t i;
+                json_t *val;
+                json_array_foreach(arg, i, val) {
+                    const char *s = json_string_value(val);
+                    int is_valid = 0;
+                    if (s) {
+                        const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, s);
+                        is_valid = mbentry && jmap_hasrights(req, mbentry, ACL_LOOKUP);
+                    }
+                    if (!is_valid) {
+                        jmap_parser_push_index(parser, field, i, s);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                    }
+                }
+            }
+        }
+    }
+}
+
+static struct sortcrit *_email_buildsort(json_t *sort, int *sort_savedate)
+{
+    json_t *jcomp;
+    size_t i, j = 0;
+    struct sortcrit *sortcrit;
+
+    sortcrit = xzmalloc((json_array_size(sort) + 3) * sizeof(struct sortcrit));
+
+    json_array_foreach(sort, i, jcomp) {
+        const char *prop = json_string_value(json_object_get(jcomp, "property"));
+
+        if (json_object_get(jcomp, "isAscending") == json_false()) {
+            sortcrit[j].flags |= SORT_REVERSE;
+        }
+
+        /* Note: add any new sort criteria also to is_supported_email_sort */
+
+        if (!strcmp(prop, "receivedAt")) {
+            sortcrit[j].key = SORT_ARRIVAL;
+        }
+        else if (!strcmp(prop, "sentAt")) {
+            sortcrit[j].key = SORT_DATE;
+        }
+        else if (!strcmp(prop, "from")) {
+            sortcrit[j].key = SORT_DISPLAYFROM;
+        }
+        else if (!strcmp(prop, "id")) {
+            sortcrit[j].key = SORT_GUID;
+        }
+        else if (!strcmp(prop, "emailState")) {
+            sortcrit[j].key = SORT_MODSEQ;
+        }
+        else if (!strcmp(prop, "size")) {
+            sortcrit[j].key = SORT_SIZE;
+        }
+        else if (!strcmp(prop, "subject")) {
+            sortcrit[j].key = SORT_SUBJECT;
+        }
+        else if (!strcmp(prop, "to")) {
+            sortcrit[j].key = SORT_DISPLAYTO;
+        }
+        else if (!strcmp(prop, "hasKeyword")) {
+            const char *name = json_string_value(json_object_get(jcomp, "keyword"));
+            const char *flagname = jmap_keyword_to_imap(name);
+            if (flagname) {
+                sortcrit[j].key = SORT_HASFLAG;
+                sortcrit[j].args.flag.name = xstrdup(flagname);
+            }
+        }
+        else if (!strcmp(prop, "someInThreadHaveKeyword")) {
+            const char *name = json_string_value(json_object_get(jcomp, "keyword"));
+            const char *flagname = jmap_keyword_to_imap(name);
+            if (flagname) {
+                sortcrit[j].key = SORT_HASCONVFLAG;
+                sortcrit[j].args.flag.name = xstrdup(flagname);
+            }
+        }
+        // FM specific
+        else if (!strcmp(prop, "addedDates") || !strcmp(prop, "snoozedUntil")) {
+            const char *mboxid =
+                json_string_value(json_object_get(jcomp, "mailboxId"));
+
+            if (sort_savedate) *sort_savedate = 1;
+            sortcrit[j].key = (*prop == 's') ? SORT_SNOOZEDUNTIL : SORT_SAVEDATE;
+            sortcrit[j].args.mailbox.id = xstrdupnull(mboxid);
+        }
+        else if (!strcmp(prop, "threadSize")) {
+            sortcrit[j].key = SORT_CONVSIZE;
+        }
+        else if (!strcmp(prop, "spamScore")) {
+            sortcrit[j].key = SORT_SPAMSCORE;
+        }
+
+        j++;
+    }
+
+    sortcrit[j+0].key = SORT_ARRIVAL;
+    sortcrit[j+0].flags |= SORT_REVERSE;
+    sortcrit[j+1].key = SORT_GUID;
+    sortcrit[j+1].flags |= SORT_REVERSE;
+    sortcrit[j+2].key = SORT_SEQUENCE;
+    sortcrit[j+2].flags |= SORT_REVERSE;
+
+    return sortcrit;
+}
+
+static void _email_querychanges_added(struct jmap_querychanges *query,
+                                      const char *email_id)
+{
+    json_t *item = json_pack("{s:s,s:i}", "id", email_id, "index", query->total-1);
+    json_array_append_new(query->added, item);
+}
+
+static void _email_querychanges_destroyed(struct jmap_querychanges *query,
+                                          const char *email_id)
+{
+    json_array_append_new(query->removed, json_string(email_id));
+}
+
+struct emailsearch {
+    int want_expunged;
+    int ignore_timer;
+    int is_mutable;
+    search_expr_t *expr;
+    struct sortcrit *sort;
+    char *hash;
+    strarray_t perf_filters;
+    int sort_savedate;
+    /* Internal state for UID search */
+    search_query_t *query;
+    struct searchargs *args;
+    struct index_state *state;
+    struct index_init init;
+};
+
+static void _emailsearch_free(struct emailsearch *search)
+{
+    if (!search) return;
+
+    search_expr_free(search->expr);
+    freesortcrit(search->sort);
+    strarray_fini(&search->perf_filters);
+    free(search->hash);
+
+    index_close(&search->state);
+    search_query_free(search->query);
+    freesearchargs(search->args);
+
+    free(search);
+}
+
+static char *_emailsearch_hash(search_expr_t *expr, struct sortcrit *sort)
+{
+    struct buf buf = BUF_INITIALIZER;
+    if (expr) {
+        search_expr_t *mysearch = search_expr_duplicate(expr);
+        search_expr_normalise(&mysearch);
+        char *tmp = search_expr_serialise(mysearch);
+        buf_appendcstr(&buf, tmp);
+        free(tmp);
+        search_expr_free(mysearch);
+    }
+    else {
+        buf_appendcstr(&buf, "noquery");
+    }
+    if (sort) {
+        char *tmp = sortcrit_as_string(sort);
+        buf_appendcstr(&buf, tmp);
+        free(tmp);
+    }
+    else {
+        buf_appendcstr(&buf, "nosort");
+    }
+    unsigned char raw_sha1[SHA1_DIGEST_LENGTH];
+    xsha1((const unsigned char *) buf_base(&buf), buf_len(&buf), raw_sha1);
+    size_t hex_size = (SHA1_DIGEST_LENGTH << 1);
+    char hex_sha1[hex_size + 1];
+    bin_to_lchex(raw_sha1, SHA1_DIGEST_LENGTH, hex_sha1);
+    hex_sha1[hex_size] = '\0';
+    buf_free(&buf);
+    return xstrdup(hex_sha1);
+}
+
+#define FNAME_EMAILSEARCH_DB "/jmap_emailsearch.db"
+#define EMAILSEARCH_DB "twoskip"
+
+static char *emailsearch_getcachepath(void)
+{
+    return xstrdupnull(config_getstring(IMAPOPT_JMAP_EMAILSEARCH_DB_PATH));
+}
+
+static int _jmap_checkfolder(const char *mboxname, void *rock)
+{
+    jmap_req_t *req = (jmap_req_t *)rock;
+
+    // we only want to look in folders that the user is allowed to read
+    if (jmap_hasrights_byname(req, mboxname, ACL_READ))
+        return 1;
+
+    return 0;
+}
+
+static struct emailsearch* _emailsearch_new(jmap_req_t *req,
+                                            json_t *filter,
+                                            json_t *jsort,
+                                            hash_table *contactgroups,
+                                            int want_expunged,
+                                            int ignore_timer)
+{
+    struct emailsearch* search = xzmalloc(sizeof(struct emailsearch));
+
+    search->expr = _email_buildsearch(req, filter, contactgroups, &search->perf_filters);
+
+    if (json_array_size(jsort)) {
+        search->sort = _email_buildsort(jsort, &search->sort_savedate);
+    }
+    else {
+        struct sortcrit *sort = search->sort;
+        sort = xzmalloc(3 * sizeof(struct sortcrit));
+        sort[0].key = SORT_ARRIVAL;
+        sort[0].flags |= SORT_REVERSE;
+        sort[1].key = SORT_GUID;
+        sort[1].flags |= SORT_REVERSE;
+        sort[2].key = SORT_SEQUENCE;
+        sort[2].flags |= SORT_REVERSE;
+        search->sort = sort;
+    }
+
+    search->hash = _emailsearch_hash(search->expr, search->sort);
+    search->is_mutable = search_is_mutable(search->sort, search->expr);
+    search->want_expunged = want_expunged;
+    search->ignore_timer = ignore_timer;
+
+    return search;
+}
+
+static int _emailsearch_run_uidsearch(jmap_req_t *req, struct emailsearch *search,
+                                      const ptrarray_t **msgdataptr)
+{
+    int r = 0;
+
+    /* Build search args */
+    search->args = new_searchargs(NULL/*tag*/, GETSEARCH_CHARSET_FIRST,
+            &jmap_namespace, req->accountid, req->authstate, 0);
+    search->args->root = search_expr_duplicate(search->expr);
+
+    /* Build index state */
+    search->init.userid = req->accountid;
+    search->init.authstate = req->authstate;
+    search->init.want_expunged = search->want_expunged;
+    search->init.examine_mode = 1;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    r = index_open(inboxname, &search->init, &search->state);
+    free(inboxname);
+    if (r) {
+        syslog(LOG_ERR, "jmap: %s: %s", __func__, error_message(r));
+        freesearchargs(search->args);
+        free(search);
+        goto done;
+    }
+
+    /* Build query */
+    search->query = search_query_new(search->state, search->args);
+    search->query->sortcrit = search->sort;
+    search->query->multiple = 1;
+    search->query->need_ids = 1;
+    search->query->verbose = 0;
+    search->query->want_expunged = search->want_expunged;
+    search->query->ignore_timer = search->ignore_timer;
+    search->query->checkfolder = _jmap_checkfolder;
+    search->query->checkfolderrock = req;
+    search->query->attachments_in_any = jmap_is_using(req, JMAP_SEARCH_EXTENSION);
+    r = search_query_run(search->query);
+    if (r) {
+        syslog(LOG_ERR, "jmap: %s: %s", __func__, error_message(r));
+        return r;
+    }
+    *msgdataptr = &search->query->merged_msgdata;
+
+done:
+    return r;
+}
+
+static int _email_parse_comparator(jmap_req_t *req,
+                                   struct jmap_comparator *comp,
+                                   void *rock __attribute__((unused)),
+                                   json_t **err __attribute__((unused)))
+{
+    /* Reject any collation */
+    if (comp->collation) {
+        return 0;
+    }
+
+    /* Search in list of supported sortFields */
+    struct email_sortfield *sp = email_sortfields;
+    for (sp = email_sortfields; sp->name; sp++) {
+        if (!strcmp(sp->name, comp->property)) {
+            return !sp->capability || jmap_is_using(req, sp->capability);
+        }
+    }
+
+    return 0;
+}
+
+struct jmap_emailquery {
+    struct jmap_query super;
+    int collapse_threads;
+    int want_partids;
+    int disable_guidsearch;
+    json_t *partids;
+};
+
+static void jmap_emailquery_init(struct jmap_emailquery *q)
+{
+    memset(q, 0, sizeof(struct jmap_emailquery));
+    q->partids = json_object();
+}
+
+static json_t *jmap_emailquery_reply(jmap_req_t *req, struct jmap_emailquery *q)
+{
+    json_t *res = jmap_query_reply(&q->super);
+    if (jmap_is_using(req, JMAP_SEARCH_EXTENSION)) {
+        if (q->want_partids) {
+            json_object_set(res, "partIds",
+                    json_object_size(q->partids) ?  q->partids : json_null());
+        }
+    }
+    return res;
+}
+
+static void jmap_emailquery_fini(struct jmap_emailquery *q)
+{
+    jmap_query_fini(&q->super);
+    q->collapse_threads = 0;
+    q->want_partids = 0;
+    json_decref(q->partids);
+}
+
+static char *_email_make_querystate(modseq_t modseq, uint32_t uid,
+                                    modseq_t addrbook_modseq)
+{
+    struct buf buf = BUF_INITIALIZER;
+    buf_printf(&buf, MODSEQ_FMT ":%u", modseq, uid);
+    if (addrbook_modseq) {
+        buf_printf(&buf, ",addrbook:" MODSEQ_FMT, addrbook_modseq);
+    }
+    return buf_release(&buf);
+}
+
+static int _email_read_querystate(const char *s, modseq_t *modseq, uint32_t *uid,
+                                  modseq_t *addrbook_modseq)
+{
+    char sentinel = 0;
+
+    /* Parse mailbox modseq and uid */
+    int n = sscanf(s, MODSEQ_FMT ":%u%c", modseq, uid, &sentinel);
+    if (n <= 2) return n == 2;
+    else if (sentinel != ',') return 0;
+
+    /* Parse addrbook modseq */
+    s = strchr(s, ',') + 1;
+    if (strncmp(s, "addrbook:", 9)) return 0;
+    s += 9;
+    n = sscanf(s, MODSEQ_FMT "%c", addrbook_modseq, &sentinel);
+    if (n != 1) return 0;
+
+    /* Parsed successfully */
+    return 1;
+}
+
+struct cached_emailquery {
+    char *ids;         /* zero-terminated id strings */
+    size_t ids_count;  /* count of ids in ids array */
+    size_t id_size;    /* byte-length of an id, excluding 0 byte */
+};
+
+#define _CACHED_EMAILQUERY_INITIALIZER { NULL, 0, 0 }
+
+static void _cached_emailquery_fini(struct cached_emailquery *cache_record)
+{
+    free(cache_record->ids);
+}
+
+#define _EMAILSEARCH_CACHE_VERSION 0x2
+
+static int _email_query_writecache(struct db *cache_db,
+                                   const char *cache_key,
+                                   modseq_t current_modseq,
+                                   strarray_t *email_ids)
+{
+    int r = 0;
+
+    /* Serialise cache record preamble */
+    struct buf buf = BUF_INITIALIZER;
+    buf_appendbit32(&buf, _EMAILSEARCH_CACHE_VERSION);
+    buf_appendbit64(&buf, current_modseq);
+    /* Serialise email ids */
+    buf_appendbit64(&buf, strarray_size(email_ids));
+    if (strarray_size(email_ids)) {
+        const char *email_id = strarray_nth(email_ids, 0);
+        size_t email_id_len = strlen(email_id);
+        buf_appendbit64(&buf, email_id_len);
+        int i;
+        for (i = 0; i < strarray_size(email_ids); i++) {
+            const char *email_id = strarray_nth(email_ids, i);
+            if (strlen(email_id) != email_id_len) {
+                syslog(LOG_ERR, "jmap: email id %s has length %zd,"
+                                "expected %zd - aborting cache",
+                                email_id, strlen(email_id), email_id_len);
+                r = CYRUSDB_INTERNAL;
+                goto done;
+            }
+            buf_appendcstr(&buf, email_id);
+            buf_putc(&buf, '\0');
+        }
+    }
+    /* Store cache record */
+    r = cyrusdb_store(cache_db, cache_key, strlen(cache_key),
+            buf_base(&buf), buf_len(&buf), NULL);
+
+done:
+    buf_free(&buf);
+    return r;
+}
+
+static int _email_query_readcache(struct db *cache_db,
+                                  const char *cache_key,
+                                  modseq_t current_modseq,
+                                  struct cached_emailquery *cache_record)
+{
+    /* Load cache record */
+    const char *data = NULL;
+    size_t datalen = 0;
+    int r = cyrusdb_fetch(cache_db, cache_key, strlen(cache_key), &data, &datalen, NULL);
+    if (r) {
+        if (r != CYRUSDB_NOTFOUND) {
+            syslog(LOG_ERR, "jmap: can't fetch cached email search (%s): %s",
+                    cache_key, cyrusdb_strerror(r));
+        }
+        return r;
+    }
+
+    /* Read cache record preamble */
+    const char *p = data;
+    uint32_t version = ntohl(((bit32*)(p))[0]); p += 4;
+    if (version != _EMAILSEARCH_CACHE_VERSION) {
+        syslog(LOG_ERR, "jmap: unexpected cache version %d (%s)", version, cache_key);
+        r = CYRUSDB_EXISTS;
+        goto done;
+    }
+    modseq_t cached_modseq = ntohll(((bit64*)(p))[0]); p += 8;
+    if (cached_modseq != current_modseq) {
+        r = CYRUSDB_EXISTS;
+        goto done;
+    }
+
+    /* Read email ids */
+    size_t ids_count = ntohll(((bit64*)(p))[0]); p += 8;
+    cache_record->ids_count= ids_count;
+    if (ids_count) {
+        size_t id_size = ntohll(((bit64*)(p))[0]); p += 8;
+        cache_record->id_size = id_size;
+        size_t ids_size = ids_count * (id_size + 1);
+        cache_record->ids = xmalloc(ids_size);
+        memcpy(cache_record->ids, p, ids_size);
+        p += ids_size;
+    }
+
+    /* Check end of record */
+    if (p != data + datalen) {
+        syslog(LOG_ERR, "jmap: invalid query cache entry %s", cache_key);
+        r = CYRUSDB_NOTFOUND;
+        goto done;
+    }
+
+done:
+    if (r) {
+        _cached_emailquery_fini(cache_record);
+        cyrusdb_delete(cache_db, cache_key, strlen(cache_key), NULL, 0);
+        return r == CYRUSDB_EXISTS? CYRUSDB_NOTFOUND : r;
+    }
+    return 0;
+}
+
+static int _email_query_can_calculate_changes(struct emailsearch *search)
+{
+    /* can calculate changes for mutable sort, but not mutable search */
+    return search->is_mutable > 1 ? 0 : 1;
+}
+
+// GUID search
+
+enum guidsearch_op {
+    GSEOP_NONE = 0,
+    GSEOP_TRUE,
+    GSEOP_FALSE,
+    GSEOP_INMAILBOX,
+    GSEOP_INMAILBOX_OTHERTHAN,
+    GSEOP_KEYWORD,
+    GSEOP_AND,
+    GSEOP_OR,
+    GSEOP_NOT
+};
+
+union guidsearch_value {
+    uint32_t num;
+    bitvector_t nums;
+};
+
+struct guidsearch_expr {
+    enum guidsearch_op op;
+    ptrarray_t children;
+    union guidsearch_value v;
+};
+
+struct guidsearch_msg {
+    bitvector_t folders;
+    uint32_t system_flags;
+    uint32_t internaldate;
+    conversation_id_t cid;
+};
+
+#define GUIDSEARCH_MSG_INTIIALIZER { \
+    BV_INITIALIZER, 0, 0, 0 \
+}
+
+static void guidsearch_msg_init(struct guidsearch_msg *msg,
+                                uint32_t numfolders)
+{
+    bv_init(&msg->folders);
+    bv_setsize(&msg->folders, numfolders);
+    msg->system_flags = 0;
+    msg->cid = 0;
+}
+
+static void guidsearch_msg_reset(struct guidsearch_msg *msg)
+{
+    bv_clearall(&msg->folders);
+    msg->system_flags = 0;
+    msg->internaldate = 0;
+    msg->cid = 0;
+}
+
+static void guidsearch_msg_fini(struct guidsearch_msg *msg)
+{
+    bv_fini(&msg->folders);
+}
+
+static void guidsearch_expr_free(struct guidsearch_expr *e)
+{
+    if (!e) return;
+
+    int i;
+    for (i = 0; i < ptrarray_size(&e->children); i++) {
+        guidsearch_expr_free(ptrarray_nth(&e->children, i));
+    }
+    ptrarray_fini(&e->children);
+
+    if (e->op == GSEOP_INMAILBOX_OTHERTHAN) {
+        bv_fini(&e->v.nums);
+    }
+
+    free(e);
+}
+
+__attribute__((unused)) // used for debugging
+static void guidsearch_expr_serialise(struct buf *buf, struct guidsearch_expr *e)
+{
+    if (!e) return;
+
+    switch (e->op) {
+        case GSEOP_NONE:
+            buf_appendcstr(buf, "NONE");
+            break;
+        case GSEOP_TRUE:
+            buf_appendcstr(buf, "TRUE");
+            break;
+        case GSEOP_FALSE:
+            buf_appendcstr(buf, "FALSE");
+            break;
+        case GSEOP_INMAILBOX:
+            buf_appendcstr(buf, "INMAILBOX");
+            break;
+        case GSEOP_INMAILBOX_OTHERTHAN:
+            buf_appendcstr(buf, "INMAILBOX_OTHERTHAN");
+            break;
+        case GSEOP_KEYWORD:
+            buf_appendcstr(buf, "KEYWORD");
+            break;
+        case GSEOP_AND:
+            buf_appendcstr(buf, "AND");
+            break;
+        case GSEOP_OR:
+            buf_appendcstr(buf, "OR");
+            break;
+        case GSEOP_NOT:
+            buf_appendcstr(buf, "NOT");
+            break;
+        default:
+            buf_appendcstr(buf, "XXX");
+            break;
+    }
+
+    if (ptrarray_size(&e->children)) {
+        buf_putc(buf, '(');
+        int i;
+        for (i = 0; i < ptrarray_size(&e->children); i++) {
+            struct guidsearch_expr *c = ptrarray_nth(&e->children, i);
+            guidsearch_expr_serialise(buf, c);
+            if (i < ptrarray_size(&e->children) - 1) {
+                buf_putc(buf, ' ');
+            }
+        }
+        buf_putc(buf, ')');
+    }
+}
+
+static int guidsearch_expr_eval(struct guidsearch_expr *e,
+                                struct guidsearch_msg *msg)
+{
+    if (!e) return 1;
+
+    switch (e->op) {
+        case GSEOP_AND:
+            {
+                int i;
+                for (i = 0; i < ptrarray_size(&e->children); i++) {
+                    if (!guidsearch_expr_eval(ptrarray_nth(&e->children, i), msg)) {
+                        return 0;
+                    }
+                }
+                return 1;
+            }
+        case GSEOP_OR:
+            {
+                int i;
+                for (i = 0; i < ptrarray_size(&e->children); i++) {
+                    if (guidsearch_expr_eval(ptrarray_nth(&e->children, i), msg)) {
+                        return 1;
+                    }
+                }
+                return 0;
+            }
+        case GSEOP_NOT:
+            {
+                int i;
+                for (i = 0; i < ptrarray_size(&e->children); i++) {
+                    if (guidsearch_expr_eval(ptrarray_nth(&e->children, i), msg)) {
+                        return 0;
+                    }
+                }
+                return 1;
+            }
+        case GSEOP_TRUE:
+            return 1;
+        case GSEOP_FALSE:
+            return 0;
+        case GSEOP_INMAILBOX:
+            return bv_isset(&msg->folders, e->v.num);
+        case GSEOP_INMAILBOX_OTHERTHAN:
+            {
+                int i;
+                for (i = bv_first_set(&msg->folders); i != -1;
+                     i = bv_next_set(&msg->folders, i+1)) {
+                    if (!bv_isset(&e->v.nums, i)) return 1;
+                }
+                return 0;
+            }
+        case GSEOP_KEYWORD:
+            return (msg->system_flags & e->v.num) != 0;
+        default:
+            return 1;
+    }
+}
+
+static struct guidsearch_expr *guidsearch_expr_build(search_expr_t *parent,
+                                                     search_expr_t *e,
+                                                     hash_table *foldernum_by_mboxname)
+{
+    if (!e) return NULL;
+
+    struct guidsearch_expr *ge = NULL;
+
+    switch (e->op) {
+        case SEOP_AND:
+            {
+                ge = xzmalloc(sizeof(struct guidsearch_expr));
+                ge->op = GSEOP_AND;
+                search_expr_t *c;
+                for (c = e->children ; c; c = c->next) {
+                    struct guidsearch_expr *gc =
+                        guidsearch_expr_build(e, c, foldernum_by_mboxname);
+                    if (!gc || gc->op == GSEOP_TRUE) {
+                        guidsearch_expr_free(gc);
+                        continue;
+                    }
+                    else if (gc->op == GSEOP_FALSE) {
+                        guidsearch_expr_free(ge);
+                        return gc;
+                    }
+                    else {
+                        ptrarray_append(&ge->children, gc);
+                    }
+                }
+                if (ptrarray_size(&ge->children) == 1) {
+                    struct guidsearch_expr *gc = ptrarray_pop(&ge->children);
+                    guidsearch_expr_free(ge);
+                    ge = gc;
+                }
+                else if (!ptrarray_size(&ge->children)) {
+                    guidsearch_expr_free(ge);
+                    ge = NULL;
+                }
+            }
+            break;
+        case SEOP_OR:
+            {
+                ge = xzmalloc(sizeof(struct guidsearch_expr));
+                ge->op = GSEOP_OR;
+                search_expr_t *c;
+                for (c = e->children ; c; c = c->next) {
+                    struct guidsearch_expr *gc =
+                        guidsearch_expr_build(e, c, foldernum_by_mboxname);
+                    if (!gc || gc->op == GSEOP_FALSE) {
+                        guidsearch_expr_free(gc);
+                        continue;
+                    }
+                    else if (gc->op == GSEOP_TRUE) {
+                        guidsearch_expr_free(ge);
+                        return gc;
+                    }
+                    else {
+                        ptrarray_append(&ge->children, gc);
+                    }
+                }
+                if (ptrarray_size(&ge->children) == 1) {
+                    struct guidsearch_expr *gc = ptrarray_pop(&ge->children);
+                    guidsearch_expr_free(ge);
+                    ge = gc;
+                }
+                else if (!ptrarray_size(&ge->children)) {
+                    guidsearch_expr_free(ge);
+                    ge = NULL;
+                }
+            }
+            break;
+        case SEOP_NOT:
+            {
+                ge = xzmalloc(sizeof(struct guidsearch_expr));
+                ge->op = GSEOP_NOT;
+                search_expr_t *c;
+                for (c = e->children ; c; c = c->next) {
+                    struct guidsearch_expr *gc =
+                        guidsearch_expr_build(e, c, foldernum_by_mboxname);
+                    if (!gc || gc->op == GSEOP_FALSE) {
+                        guidsearch_expr_free(gc);
+                        continue;
+                    }
+                    else if (gc->op == GSEOP_TRUE) {
+                        guidsearch_expr_free(ge);
+                        gc->op = GSEOP_FALSE;
+                        return gc;
+                    }
+                    else {
+                        ptrarray_append(&ge->children, gc);
+                    }
+                }
+                if (!ptrarray_size(&ge->children)) {
+                    guidsearch_expr_free(ge);
+                    ge = NULL;
+                }
+            }
+            break;
+        case SEOP_TRUE:
+        case SEOP_FALSE:
+            {
+                if (parent) {
+                    ge = xzmalloc(sizeof(struct guidsearch_expr));
+                    ge->op = e->op == SEOP_TRUE ? GSEOP_TRUE : GSEOP_FALSE;
+                }
+            }
+            break;
+        case SEOP_MATCH:
+            {
+                if (e->attr == search_attr_find("folder")) {
+                    // inMailbox filter, IMAP-style
+                    ge = xzmalloc(sizeof(struct guidsearch_expr));
+                    ge->op = GSEOP_INMAILBOX;
+                    void *vv = hash_lookup(e->value.s, foldernum_by_mboxname);
+                    if (vv) {
+                        ge->v.num = (uint32_t)((uintptr_t)vv - 1);
+                    }
+                    else {
+                        free(ge);
+                        ge = NULL;
+                    }
+                }
+                else if (e->attr == &_emailsearch_folders_attr) {
+                    // inMailbox filter, JMAP-style
+                    ge = xzmalloc(sizeof(struct guidsearch_expr));
+                    // jmap_folders attribute supports multiple mailboxes,
+                    // even if inMailbox JMAP argument is single-valued.
+                    ge->op = GSEOP_AND;
+                    int i;
+                    for (i = 0; i < strarray_size(e->value.list); i++) {
+                        struct guidsearch_expr *gc =
+                            xzmalloc(sizeof(struct guidsearch_expr));
+                        gc->op = GSEOP_INMAILBOX;
+                        const char *mboxname = strarray_nth(e->value.list, i);
+                        void *vv = hash_lookup(mboxname, foldernum_by_mboxname);
+                        if (vv) {
+                            gc->v.num = (uint32_t)((uintptr_t)vv - 1);
+                            ptrarray_append(&ge->children, gc);
+                        }
+                        else free(gc);
+                    }
+                    if (ptrarray_size(&ge->children) == 1) {
+                        struct guidsearch_expr *gc =
+                            ptrarray_nth(&ge->children, 0);
+                        ptrarray_fini(&ge->children);
+                        free(ge);
+                        ge = gc;
+                    }
+                    else if (!ptrarray_size(&ge->children)) {
+                        ge->op = SEOP_FALSE;
+                    }
+                }
+                else if (e->attr == &_emailsearch_folders_otherthan_attr) {
+                    // inMailboxOtherThan filter
+                    ge = xzmalloc(sizeof(struct guidsearch_expr));
+                    ge->op = GSEOP_INMAILBOX_OTHERTHAN;
+                    bv_init(&ge->v.nums);
+                    bv_setsize(&ge->v.nums, hash_numrecords(foldernum_by_mboxname));
+                    int i;
+                    for (i = 0; i < strarray_size(e->value.list); i++) {
+                        const char *mboxname = strarray_nth(e->value.list, i);
+                        void *vv = hash_lookup(mboxname, foldernum_by_mboxname);
+                        if (vv) {
+                            bv_set(&ge->v.nums, (uint32_t)((uintptr_t)vv - 1));
+                        }
+                    }
+                }
+                else if (e->attr == search_attr_find("systemflags") &&
+                        (e->value.u & (FLAG_DRAFT|FLAG_FLAGGED|FLAG_ANSWERED))) {
+                    // hasKeyword or notKeyword
+                    ge = xzmalloc(sizeof(struct guidsearch_expr));
+                    ge->op = GSEOP_KEYWORD;
+                    ge->v.num = e->value.u;
+                }
+            }
+            break;
+        default:
+            ;
+    }
+
+    return ge;
+}
+
+static int rank_guidsearch_expr(search_expr_t *parent, search_expr_t *e)
+{
+    if (!e) return 0;
+
+    /* Ranks are:
+     * 0x0: expr is not supported
+     * 0x1: expr is supported but does not require Xapian
+     * 0x2: expr requires Xapian
+     *
+     * Keep this in sync with guidsearch_expr_build or there be dragons.
+     */
+    switch (e->op) {
+        case SEOP_AND:
+        case SEOP_OR:
+        case SEOP_NOT:
+            {
+                int rank = 0;
+                int seen_rank3 = 0;
+                search_expr_t *child;
+                for (child = e->children ; child ; child = child->next) {
+                    int childrank = rank_guidsearch_expr(e, child);
+                    if (childrank == 0) return 0;
+                    if (childrank == 3) {
+                        if (e->op == SEOP_OR && seen_rank3) {
+                            /*
+                             * TODO We currently reject any disjunctions where
+                             * more than one child filters by both Xapian and
+                             * non-Xapian criteria. That's overly restrictive
+                             * but allows to err on the safe side.
+                             *
+                             * The following filter is an example that would
+                             * produce bogus results if we evaluate it on the
+                             * current GUID implementation:
+                             *
+                             * OR(AND(text:foo inMailbox:A),
+                             *    AND(text:Bar inMailbox:B))
+                             *
+                             * It ANDs Xapian with non-Xapian criteria. GUID
+                             * search would evaluate it by first searching for
+                             * all GUIDs that match the 'text' filter criteria,
+                             * then evaluate the inMailbox filters on these
+                             * GUIDs. This would produce a bogus result if a
+                             * message with text:bar also exists in mailbox A!
+                             * */
+                            return 0;
+                        }
+                        else seen_rank3 = 1;
+                    }
+                    rank |= childrank;
+                }
+                return rank;
+            }
+        case SEOP_LT:
+        case SEOP_LE:
+        case SEOP_GT:
+        case SEOP_GE:
+            // TODO support receivedAt?
+            return 0;
+        case SEOP_MATCH:
+            if (e->attr == search_attr_find("folder") ||
+                e->attr == &_emailsearch_folders_attr ||
+                e->attr == &_emailsearch_folders_otherthan_attr) {
+                // inMailbox or inMailboxOtherThan
+                return 1;
+            }
+            else if (e->attr == search_attr_find("systemflags") &&
+                    (e->value.u & (FLAG_DRAFT|FLAG_FLAGGED|FLAG_ANSWERED))) {
+                // hasKeyword or notKeyword
+                return 1;
+            }
+            else return 0;
+        case SEOP_TRUE:
+        case SEOP_FALSE:
+            return parent != NULL ? 1 : 0;
+        case SEOP_FUZZYMATCH:
+            return 2;
+        default:
+            return 0;
+    }
+
+    return 0;
+}
+
+static int is_guidsearch_sort(struct sortcrit *sort)
+{
+    if (sort) {
+        for ( ; sort->key != SORT_SEQUENCE; sort++) {
+            if (sort->key != SORT_GUID && sort->key != SORT_ARRIVAL)
+                return 0;
+        }
+    }
+    return 1;
+}
+
+struct guidsearch_match {
+    char guidrep[MESSAGE_GUID_SIZE*2+1];
+    uint32_t internaldate;
+    conversation_id_t cid;
+};
+
+struct guidsearch_rock {
+    jmap_req_t *req;
+    bitvector_t readable_folders;
+    int want_expunged;
+    char prevguid[MESSAGE_GUID_SIZE*2+1];
+    struct guidsearch_msg msg;
+    struct guidsearch_expr *msgexpr;
+    struct guidsearch_match *result;
+    size_t total;
+};
+
+static void _query_guidsearch_postprocess_match(struct guidsearch_rock *rock)
+{
+    if (rock->msgexpr) {
+        /* Evaluate non-Xapian filter conditions */
+        if (!guidsearch_expr_eval(rock->msgexpr, &rock->msg)) {
+            return;
+        }
+    }
+
+    /* Append match to result */
+    struct guidsearch_match *match = rock->result + rock->total;
+    memcpy(match->guidrep, rock->prevguid, MESSAGE_GUID_SIZE*2);
+    match->guidrep[MESSAGE_GUID_SIZE*2] = '\0';
+    match->internaldate = rock->msg.internaldate;
+    match->cid = rock->msg.cid;
+    rock->total++;
+}
+
+static int _query_guidsearch_cb(const conv_guidrec_t *rec,
+                                size_t nguids, void *vrock)
+{
+    if (!nguids) return 0; // not a single match!
+
+    if (rec->version < 1) {
+        /* Legacy conversations.db. Guid search was just a waste of time. */
+        syslog(LOG_ERR, "jmap: %s: G record for %s:%d has legacy version 0. "
+                "Aborting guidsearch.", __func__, rec->mboxname, rec->uid);
+        return IMAP_SEARCH_NOT_SUPPORTED;
+    }
+
+    /* Ignore parts */ // TODO could set partIds
+    if (rec->part) return 0;
+
+    struct guidsearch_rock *rock = vrock;
+
+    /* Filter ACL and expunged messages */
+    if (!bv_isset(&rock->readable_folders, rec->foldernum) ||
+       (!rock->want_expunged &&
+        ((rec->system_flags & FLAG_DELETED) ||
+         (rec->internal_flags & FLAG_INTERNAL_EXPUNGED)))) {
+            return 0;
+    }
+
+    if (rock->result == NULL) {
+        /* First time we see any match candidate */
+        rock->result = xmalloc(nguids * sizeof(struct guidsearch_match));
+    }
+
+    if (!rock->prevguid[0] || memcmp(rec->guidrep, rock->prevguid, MESSAGE_GUID_SIZE*2)) {
+        /* Post-process previous match */
+        if (rock->prevguid[0]) {
+            _query_guidsearch_postprocess_match(rock);
+            guidsearch_msg_reset(&rock->msg);
+        }
+        /* Reset message state with this guid */
+        memcpy(rock->prevguid, rec->guidrep, MESSAGE_GUID_SIZE*2);
+        rock->prevguid[MESSAGE_GUID_SIZE*2] = '\0';
+        bv_set(&rock->msg.folders, rec->foldernum);
+        rock->msg.system_flags = rec->system_flags;
+        rock->msg.internaldate = rec->internaldate;
+        rock->msg.cid = rec->cid;
+    }
+    else {
+        /* Update message state for same guid */
+        bv_set(&rock->msg.folders, rec->foldernum);
+        rock->msg.system_flags |= rec->system_flags;
+        if (rec->internaldate < rock->msg.internaldate) {
+            rock->msg.internaldate = rec->internaldate;
+        }
+    }
+
+    return 0;
+}
+
+static int _guidsearch_match_cmp QSORT_R_COMPAR_ARGS(const void *va,
+                                                     const void *vb,
+                                                     void *rock)
+{
+    const struct guidsearch_match *a = va;
+    const struct guidsearch_match *b = vb;
+    const struct sortcrit *sort = rock;
+
+    while (sort->key != SORT_SEQUENCE) {
+        int ret;
+        switch (sort->key) {
+            case SORT_ARRIVAL:
+                ret = a->internaldate < b->internaldate ? -1 :
+                      a->internaldate > b->internaldate ?  1 : 0;
+                break;
+            case SORT_GUID:
+                ret = memcmp(a->guidrep, b->guidrep, MESSAGE_GUID_SIZE*2);
+                break;
+            default:
+                syslog(LOG_ERR, "%s: ignoring unexpected sort %d", __func__, sort->key);
+                ret = 0;
+        }
+        if (ret) {
+            return (sort->flags & SORT_REVERSE) ? -ret : ret;
+        }
+        sort++;
+    }
+
+    return 0;
+}
+
+static int _email_query_guidsearch(jmap_req_t *req, struct jmap_emailquery *q,
+                                   struct emailsearch *search,
+                                   json_t **err __attribute__((unused)))
+{
+    int exprrank = rank_guidsearch_expr(NULL, search->expr);
+    if (exprrank < 2 || !is_guidsearch_sort(search->sort)) {
+        return IMAP_SEARCH_NOT_SUPPORTED;
+    }
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    struct mailbox *inbox = NULL;
+    search_builder_t *bx = NULL;
+    int r = 0;
+
+    // TODO cache guid search?
+
+    r = jmap_openmbox(req, inboxname, &inbox, 0); // XXX need write lock?
+    if (r) goto done;
+
+    bx = search_begin_search(inbox, 0);
+    if (!bx) {
+        syslog(LOG_ERR, "jmap: %s: can't begin search for %s",
+                        __func__,  inbox->name);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    struct conversations_state *cstate = mailbox_get_cstate(inbox);
+    if (!cstate) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Initialize callback state */
+    struct guidsearch_rock rock = {
+        req,
+        BV_INITIALIZER,
+        search->want_expunged,
+        { 0 },
+        GUIDSEARCH_MSG_INTIIALIZER,
+        NULL,
+        NULL,
+        0
+    };
+
+    /* Determine readable folders for userid */
+    uint32_t numfolders = conversations_num_folders(cstate);
+    bv_setsize(&rock.readable_folders, numfolders);
+    if (strcmp(req->userid, req->accountid)) {
+        // Filter all folders that can't be read by userid
+        uint32_t num;
+        for (num = 0; num < numfolders; num++) {
+            const char *mboxname = conversations_folder_name(cstate, num);
+            if (jmap_hasrights_byname(req, mboxname, ACL_READ|ACL_LOOKUP)) {
+                bv_set(&rock.readable_folders, num);
+            }
+        }
+    }
+    else {
+        // All user-owned mailboxes are readable
+        bv_setall(&rock.readable_folders);
+    }
+
+    /* Filter all folders that aren't regular mailboxes */
+    uint32_t num;
+    for (num = 0; num < numfolders; num++) {
+        const char *mboxname = conversations_folder_name(cstate, num);
+        mbentry_t *mbentry = NULL;
+        if (mboxlist_lookup_allow_all(mboxname, &mbentry, NULL) ||
+            mbentry->mbtype != MBTYPE_EMAIL) {
+            bv_clear(&rock.readable_folders, num);
+        }
+        mboxlist_entry_free(&mbentry);
+    }
+
+    /* Prepare post-processing filter for guid callback */
+    if (exprrank & 0x1) {
+        hash_table foldernum_by_mboxname = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&foldernum_by_mboxname, numfolders+1, 0);
+        uint32_t num;
+        for (num = 0; num < numfolders; num++) {
+            const char *mboxname = conversations_folder_name(cstate, num);
+            hash_insert(mboxname, (void*)((uintptr_t)num+1), &foldernum_by_mboxname);
+        }
+        rock.msgexpr = guidsearch_expr_build(NULL, search->expr,
+                                            &foldernum_by_mboxname);
+        free_hash_table(&foldernum_by_mboxname, NULL);
+    }
+
+    /* Run query */
+    search_build_query(bx, search->expr);
+    guidsearch_msg_init(&rock.msg, numfolders);
+    r = bx->run_guidsearch(bx, _query_guidsearch_cb, &rock);
+    if (rock.prevguid[0]) {
+        _query_guidsearch_postprocess_match(&rock);
+    }
+    guidsearch_msg_fini(&rock.msg);
+    guidsearch_expr_free(rock.msgexpr);
+    bv_fini(&rock.readable_folders);
+    if (r == IMAP_SEARCH_NOT_SUPPORTED) {
+        free(rock.result);
+        goto done;
+    }
+    else if (r && r != IMAP_OK_COMPLETED) {
+        free(rock.result);
+        goto done;
+    }
+    r = 0;
+
+    /* Build result */
+    if (rock.total) {
+        cyr_qsort_r(rock.result, rock.total, sizeof(struct guidsearch_match),
+                    _guidsearch_match_cmp, search->sort);
+        if (q->collapse_threads) {
+            struct hashset *seen_threads = hashset_new(sizeof(conversation_id_t));
+            size_t i, j;
+            for (i = 0, j = 0; i < rock.total; i++) {
+                struct guidsearch_match *match = rock.result + i;
+                if (hashset_add(seen_threads, &match->cid)) {
+                    if (i != j) {
+                        memcpy(rock.result + j, match, sizeof(struct guidsearch_match));
+                    }
+                    j++;
+                }
+            }
+            hashset_free(&seen_threads);
+            rock.total = j;
+        }
+    }
+    char email_id[JMAP_EMAILID_SIZE];
+    struct message_guid guid;
+    size_t pos;
+    if (q->super.anchor) {
+        pos = 0;
+    }
+    else if (q->super.position < 0) {
+        size_t delta = (size_t) -q->super.position;
+        pos = delta < rock.total ? rock.total - delta : 0;
+    }
+    else if ((size_t)q->super.position < rock.total) {
+        pos = q->super.position;
+    } else {
+        pos = rock.total;
+    }
+    int found_anchor = 0;
+    size_t i;
+    for (i = pos; i < rock.total; i++) {
+        if (q->super.have_limit &&
+                json_array_size(q->super.ids) == q->super.limit) {
+            break;
+        }
+        struct guidsearch_match *match = rock.result + i;
+        message_guid_decode(&guid, match->guidrep);
+        jmap_set_emailid(&guid, email_id);
+        if (q->super.anchor && !found_anchor) {
+            if (!strcmp(email_id, q->super.anchor)) {
+                /* Found anchor */
+                found_anchor = 1;
+                if (q->super.anchor_offset < 0) {
+                    /* Fill matches including current match */
+                    size_t delta = -q->super.anchor_offset;
+                    size_t j = delta < i ? i - delta : 0;
+                    pos = j;
+                    for ( ; j <= i; j++) {
+                        if (q->super.have_limit &&
+                                json_array_size(q->super.ids) == q->super.limit) {
+                            break;
+                        }
+                        match = rock.result + j;
+                        message_guid_decode(&guid, match->guidrep);
+                        jmap_set_emailid(&guid, email_id);
+                        json_array_append_new(q->super.ids, json_string(email_id));
+                    }
+                }
+                else if (q->super.anchor_offset > 0) {
+                    /* Skip to anchor offset */
+                    i += q->super.anchor_offset - 1;
+                    pos = i + 1;
+                }
+                else {
+                    /* Add anchor */
+                    json_array_append_new(q->super.ids, json_string(email_id));
+                    pos = i;
+                }
+            }
+            continue;
+        }
+        json_array_append_new(q->super.ids, json_string(email_id));
+    }
+    q->super.result_position = pos;
+    q->super.total = rock.total;
+    free(rock.result);
+
+    /* Set response fields */
+    if (jmap_is_using(req, JMAP_PERFORMANCE_EXTENSION)) {
+        json_object_set_new(req->perf_details, "isCached", json_false());
+        json_object_set_new(req->perf_details, "isGuidSearch", json_true());
+    }
+
+done:
+    if (bx) search_end_search(bx);
+    jmap_closembox(req, &inbox);
+    free(inboxname);
+    return r;
+}
+
+static int _email_query_uidsearch(jmap_req_t *req,
+                                  struct jmap_emailquery *q,
+                                  struct emailsearch *search,
+                                  json_t **err)
+{
+    modseq_t current_modseq = jmap_highestmodseq(req, MBTYPE_EMAIL);
+    char *cache_fname = NULL;
+    char *cache_key = NULL;
+    struct db *cache_db = NULL;
+    int is_cached = 0;
+    int r = 0;
+
+    /* Open cache */
+    cache_fname = emailsearch_getcachepath();
+    if (cache_fname) {
+        int flags = CYRUSDB_CREATE|CYRUSDB_CONVERT;
+        int r = cyrusdb_open(EMAILSEARCH_DB, cache_fname, flags, &cache_db);
+        if (r) {
+            syslog(LOG_WARNING, "jmap: can't open email search cache %s: %s",
+                    cache_fname, cyrusdb_strerror(r));
+        }
+    }
+
+    /* Make cache key */
+    cache_key = strconcat(req->accountid,
+            "/", q->collapse_threads ?  "collapsed" : "uncollapsed",
+            "/", search->hash, NULL
+    );
+
+    /* Lookup cache */
+    if (cache_db) {
+        struct cached_emailquery cache_record = _CACHED_EMAILQUERY_INITIALIZER;
+        int r = _email_query_readcache(cache_db, cache_key, current_modseq, &cache_record);
+        if (!r) {
+            size_t from = q->super.position;
+            if (q->super.anchor) {
+                size_t i;
+                for (i = 0; i < cache_record.ids_count; i++) {
+                    const char *email_id = cache_record.ids + i * (cache_record.id_size + 1);
+                    if (!strcmp(email_id, q->super.anchor)) {
+                        if (q->super.anchor_offset < 0) {
+                            size_t neg_offset = (size_t) -q->super.anchor_offset;
+                            from = neg_offset < i ? i - neg_offset : 0;
+                        }
+                        else {
+                            from = i + q->super.anchor_offset;
+                        }
+                        break;
+                    }
+                }
+                if (i == cache_record.ids_count) {
+                    *err = json_pack("{s:s}", "type", "anchorNotFound");
+                }
+            }
+            else if (q->super.position < 0) {
+                ssize_t sposition = (ssize_t) cache_record.ids_count + q->super.position;
+                from = sposition < 0 ? 0 : sposition;
+            }
+            size_t to = q->super.limit ? from + q->super.limit : cache_record.ids_count;
+            if (to > cache_record.ids_count) to = cache_record.ids_count;
+            size_t i;
+            for (i = from; i < to; i++) {
+                const char *email_id = cache_record.ids + i * (cache_record.id_size + 1);
+                json_array_append_new(q->super.ids, json_string(email_id));
+            }
+            q->super.total = cache_record.ids_count;
+            q->super.result_position = from < q->super.total ? from : q->super.total;
+            is_cached = 1;
+        }
+        _cached_emailquery_fini(&cache_record);
+    }
+
+    /* Set cache info */
+    if (jmap_is_using(req, JMAP_PERFORMANCE_EXTENSION)) {
+        json_object_set_new(req->perf_details, "isCached", json_boolean(is_cached));
+        json_object_set_new(req->perf_details, "isGuidSearch", json_false());
+    }
+    if (is_cached) goto done;
+
+    /* Run search */
+    const ptrarray_t *msgdata = NULL;
+    r = _emailsearch_run_uidsearch(req, search, &msgdata);
+    if (r) {
+        *err = jmap_server_error(r);
+        goto done;
+    }
+
+    // TODO cache emailId -> threadId on the request context
+
+    /* Initialize search result loop */
+    size_t anchor_position = (size_t)-1;
+    char email_id[JMAP_EMAILID_SIZE];
+
+    struct hashset *seen_emails = hashset_new(12);
+    struct hashset *seen_threads = hashset_new(8);
+    struct hashset *savedates = NULL;
+
+    /* List of all matching email ids */
+    strarray_t email_ids = STRARRAY_INITIALIZER;
+
+    int found_anchor = 0;
+
+    if (search->sort_savedate) {
+        /* Build hashset of messages with savedates */
+        int j;
+
+        savedates = hashset_new(12);
+
+        for (j = 0; j < msgdata->count; j++) {
+            MsgData *md = ptrarray_nth(msgdata, j);
+
+            /* Skip expunged or hidden messages */
+            if (md->system_flags & FLAG_DELETED ||
+                md->internal_flags & FLAG_INTERNAL_EXPUNGED)
+                continue;
+
+            if (md->savedate) hashset_add(savedates, &md->guid.value);
+        }
+    }
+
+    int i;
+    for (i = 0 ; i < msgdata->count; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        /* Skip expunged or hidden messages */
+        if (md->system_flags & FLAG_DELETED ||
+            md->internal_flags & FLAG_INTERNAL_EXPUNGED)
+            continue;
+
+        /* Is there another copy of this message with a targeted savedate? */
+        if (!md->savedate &&
+            savedates && hashset_exists(savedates, &md->guid.value))
+            continue;
+
+        /* Have we seen this message already? */
+        if (!hashset_add(seen_emails, &md->guid.value))
+            continue;
+        if (q->collapse_threads && !hashset_add(seen_threads, &md->cid))
+            continue;
+
+        /* This message matches the query. */
+        size_t result_count = json_array_size(q->super.ids);
+        q->super.total++;
+        jmap_set_emailid(&md->guid, email_id);
+
+        if (cache_db) strarray_append(&email_ids, email_id);
+
+        /* Apply query window, if any */
+        if (q->super.anchor) {
+            if (!strcmp(email_id, q->super.anchor)) {
+                found_anchor = 1;
+                /* Recalculate the search result */
+                json_t *anchored_ids = json_pack("[]");
+                size_t j;
+                /* Set countdown to enter the anchor window */
+                if (q->super.anchor_offset > 0) {
+                    anchor_position = q->super.anchor_offset;
+                } else {
+                    anchor_position = 0;
+                }
+                /* Readjust the result list */
+                if (q->super.anchor_offset < 0) {
+                    size_t neg_offset = (size_t) -q->super.anchor_offset;
+                    size_t from = neg_offset < result_count ? result_count - neg_offset : 0;
+                    for (j = from; j < result_count; j++) {
+                        json_array_append(anchored_ids, json_array_get(q->super.ids, j));
+                    }
+                }
+                json_decref(q->super.ids);
+                q->super.ids = anchored_ids;
+                result_count = json_array_size(q->super.ids);
+
+                /* Adjust the window position for this anchor. */
+                q->super.result_position =
+                    q->super.total - json_array_size(anchored_ids) - 1;
+            }
+            if (anchor_position != (size_t)-1 && anchor_position) {
+                /* Found the anchor but haven't yet entered its window */
+                anchor_position--;
+                /* But this message still counts to the window position */
+                q->super.result_position++;
+                continue;
+            }
+        }
+        else if (q->super.position > 0 && q->super.total < ((size_t) q->super.position) + 1) {
+            continue;
+        }
+
+        /* Apply limit for positive positions. */
+        if (q->super.limit && q->super.position >= 0 &&
+            result_count && q->super.limit <= result_count) {
+            continue;
+        }
+
+        /* Add message to result */
+        json_array_append_new(q->super.ids, json_string(email_id));
+        if (md->folder && md->folder->partids.size) {
+            const strarray_t *partids = hashu64_lookup(md->uid, &md->folder->partids);
+            if (partids && strarray_size(partids)) {
+                json_t *jpartids = json_array();
+                int k;
+                for (k = 0; k < strarray_size(partids); k++) {
+                    const char *partid = strarray_nth(partids, k);
+                    json_array_append_new(jpartids, json_string(partid));
+                }
+                json_object_set_new(q->partids, email_id, jpartids);
+            }
+        }
+        if (!json_object_get(q->partids, email_id)) {
+            json_object_set_new(q->partids, email_id, json_null());
+        }
+    }
+    hashset_free(&seen_threads);
+    hashset_free(&seen_emails);
+    if (savedates) hashset_free(&savedates);
+
+    if (!q->super.anchor) {
+        if (q->super.position >= 0) {
+            if ((size_t) q->super.position < q->super.total) {
+                q->super.result_position = q->super.position;
+            }
+            else q->super.result_position = q->super.total;
+        }
+        else {
+            /* Slice negative position from all matching ids */
+            json_t *result = json_array();
+            if (json_array_size(q->super.ids)) {
+                size_t from = 0;
+                if (((size_t)-q->super.position) < json_array_size(q->super.ids)) {
+                    from = json_array_size(q->super.ids) - ((size_t)-q->super.position);
+                }
+                size_t i;
+                for (i = from; i < json_array_size(q->super.ids); i++) {
+                    if (!q->super.have_limit || q->super.limit > json_array_size(result)) {
+                        json_array_append(result, json_array_get(q->super.ids, i)); // incref
+                    }
+                    else break;
+                }
+                q->super.result_position = from;
+            }
+            else q->super.result_position = 0;
+            json_decref(q->super.ids);
+            q->super.ids = result;
+        }
+    }
+    else if (!found_anchor) {
+        *err = json_pack("{s:s}", "type", "anchorNotFound");
+    }
+
+    /* Cache search result */
+    if (cache_db) {
+        int r = _email_query_writecache(cache_db, cache_key, current_modseq, &email_ids);
+        if (r) {
+            syslog(LOG_ERR, "jmap: can't cache email search (%s): %s",
+                    cache_key, cyrusdb_strerror(r));
+            r = 0;
+        }
+    }
+    strarray_fini(&email_ids);
+
+done:
+    if (cache_db) {
+        int rr = cyrusdb_close(cache_db);
+        if (rr) {
+            syslog(LOG_ERR, "jmap: can't close email search cache %s: %s",
+                    cache_fname, cyrusdb_strerror(r));
+        }
+    }
+    free(cache_key);
+    free(cache_fname);
+    return r;
+}
+
+static void _email_query(jmap_req_t *req, struct jmap_emailquery *q,
+                         hash_table *contactgroups,
+                         json_t **err)
+{
+    struct emailsearch *search = _emailsearch_new(req, q->super.filter,
+                                                  q->super.sort,
+                                                  contactgroups, 0, 0);
+    if (!search) {
+        *err = jmap_server_error(IMAP_INTERNAL);
+        goto done;
+    }
+
+    /* make query state */
+    modseq_t modseq = jmap_highestmodseq(req, MBTYPE_EMAIL);
+    modseq_t addrbook_modseq = contactgroups->size ?
+        jmap_highestmodseq(req, MBTYPE_ADDRESSBOOK) : 0;
+
+    /* set search cost info */
+    if (jmap_is_using(req, JMAP_PERFORMANCE_EXTENSION)) {
+        int i;
+        json_t *jfilters = json_array();
+        for (i = 0; i < strarray_size(&search->perf_filters); i++) {
+            const char *cost = strarray_nth(&search->perf_filters, i);
+            json_array_append_new(jfilters, json_string(cost));
+        }
+        json_object_set_new(req->perf_details, "filters", jfilters);
+    }
+
+    /* Try to fetch matching guids directly from Xapian */
+    int r = 0;
+    int is_guidsearch = 0;
+    if (!q->disable_guidsearch && !q->super.calculate_total &&
+        (q->super.limit || !q->super.have_limit) && !q->want_partids) {
+        r = _email_query_guidsearch(req, q, search, err);
+        if (r == IMAP_SEARCH_NOT_SUPPORTED) {
+            /* Fallback to UID search */
+            r = 0;
+        }
+        else if (r) goto done;
+        else is_guidsearch = 1;
+    }
+    if (!is_guidsearch) {
+        r = _email_query_uidsearch(req, q, search, err);
+    }
+
+    q->super.can_calculate_changes = _email_query_can_calculate_changes(search);
+    q->super.query_state = _email_make_querystate(modseq, 0, addrbook_modseq);
+
+done:
+    if (r && *err == NULL) *err = jmap_server_error(r);
+    _emailsearch_free(search);
+}
+
+static int _email_queryargs_parse(jmap_req_t *req,
+                                  struct jmap_parser *parser __attribute__((unused)),
+                                  const char *key,
+                                  json_t *arg,
+                                  void *rock)
+{
+    struct jmap_emailquery *query = rock;
+    int r = 1;
+
+    if (!strcmp(key, "collapseThreads") && json_is_boolean(arg)) {
+        query->collapse_threads = json_boolean_value(arg);
+    }
+    else if (!strcmp(key, "addressbookId") && json_is_string(arg) &&
+             jmap_is_using(req, JMAP_MAIL_EXTENSION)) {
+
+        /* Lookup addrbook */
+        char *addrbookname = carddav_mboxname(req->accountid, json_string_value(arg));
+        mbentry_t *mbentry = NULL;
+        int is_valid = 0;
+        if (!mboxlist_lookup(addrbookname, &mbentry, NULL)) {
+            is_valid = jmap_hasrights(req, mbentry, ACL_LOOKUP) &&
+                       mbentry->mbtype == MBTYPE_ADDRESSBOOK;
+        }
+        mboxlist_entry_free(&mbentry);
+        free(addrbookname);
+        return is_valid;
+    }
+    else if (!strcmp(key, "wantPartIds") && json_is_boolean(arg) &&
+            jmap_is_using(req, JMAP_SEARCH_EXTENSION)) {
+        query->want_partids = json_boolean_value(arg);
+    }
+    else if (!strcmp(key, "disableGuidSearch") && json_is_boolean(arg) &&
+            jmap_is_using(req, JMAP_PERFORMANCE_EXTENSION)) {
+        query->disable_guidsearch = json_boolean_value(arg);
+    }
+    else r = 0;
+
+    return r;
+}
+
+static int jmap_email_query(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_emailquery query;
+    struct email_contactfilter contactfilter;
+    int r = 0;
+
+    _email_contactfilter_initreq(req, &contactfilter);
+    jmap_emailquery_init(&query);
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_query_parse(req, &parser,
+                     _email_queryargs_parse, &query,
+                     _email_parse_filter_cb, &contactfilter,
+                     _email_parse_comparator, NULL,
+                     &query.super, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+    if (json_array_size(parser.invalid)) {
+        err = json_pack("{s:s}", "type", "invalidArguments");
+        json_object_set(err, "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+    else if (r) {
+        jmap_error(req, jmap_server_error(r));
+        goto done;
+    }
+
+    /* Run query */
+    _email_query(req, &query, &contactfilter.contactgroups, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    json_t *res = jmap_emailquery_reply(req, &query);
+    json_object_set(res, "collapseThreads", json_boolean(query.collapse_threads));
+    if (jmap_is_using(req, JMAP_DEBUG_EXTENSION)) {
+        /* List language stats */
+        const struct search_engine *engine = search_engine();
+        if (engine->list_lang_stats) {
+            ptrarray_t lstats = PTRARRAY_INITIALIZER;
+            int r = engine->list_lang_stats(req->accountid, &lstats);
+            if (!r) {
+                json_t *jstats = json_object();
+                struct search_lang_stats *lstat;
+                while ((lstat = ptrarray_pop(&lstats))) {
+                    json_t *jstat = json_pack("{s:f}", "weight", lstat->weight);
+                    json_object_set_new(jstats, lstat->iso_lang, jstat);
+                    free(lstat->iso_lang);
+                    free(lstat);
+                }
+                json_object_set_new(res, "debug",
+                        json_pack("{s:o}", "languageStats", jstats));
+            }
+            ptrarray_fini(&lstats);
+        }
+    }
+    jmap_ok(req, res);
+
+done:
+    jmap_email_contactfilter_fini(&contactfilter);
+    jmap_emailquery_fini(&query);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static void _email_querychanges_collapsed(jmap_req_t *req,
+                                          struct jmap_querychanges *query,
+                                          struct email_contactfilter *contactfilter,
+                                          json_t **err)
+{
+    modseq_t since_modseq;
+    uint32_t since_uid;
+    uint32_t num_changes = 0;
+    modseq_t addrbook_modseq = 0;
+    int is_guidsearch = 0;
+
+    if (!_email_read_querystate(query->since_querystate,
+                                &since_modseq, &since_uid,
+                                &addrbook_modseq)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+    if (addrbook_modseq && addrbook_modseq != jmap_highestmodseq(req, MBTYPE_ADDRESSBOOK)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+    if (is_guidsearch) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+
+    struct emailsearch *search = _emailsearch_new(req, query->filter, query->sort,
+                                                  &contactfilter->contactgroups,
+                                                  /*want_expunged*/1, /*ignore_timer*/0);
+    if (!search) {
+        *err = jmap_server_error(IMAP_INTERNAL);
+        goto done;
+    }
+    if (!_email_query_can_calculate_changes(search)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        goto done;
+    }
+
+    /* Run search */
+    const ptrarray_t *msgdata = NULL;
+    int r = _emailsearch_run_uidsearch(req, search, &msgdata);
+    if (r) {
+        if (r == IMAP_SEARCH_SLOW) {
+            *err = json_pack("{s:s, s:s}", "type", "cannotCalculateChanges",
+                                           "description", "search too slow");
+        }
+        else {
+            *err = jmap_server_error(r);
+        }
+        goto done;
+    }
+
+    /* Prepare result loop */
+    char email_id[JMAP_EMAILID_SIZE];
+    int found_up_to = 0;
+    size_t mdcount = msgdata->count;
+
+    hash_table touched_ids = HASH_TABLE_INITIALIZER;
+    memset(&touched_ids, 0, sizeof(hash_table));
+    construct_hash_table(&touched_ids, mdcount + 1, 0);
+
+    hashu64_table touched_cids = HASH_TABLE_INITIALIZER;
+    memset(&touched_cids, 0, sizeof(hashu64_table));
+    construct_hashu64_table(&touched_cids, mdcount + 1, 0);
+
+    /* touched_ids contains values for each email_id:
+     * 1 - email has been modified
+     * 2 - email has been seen (aka: non-expunged record shown)
+     * 4 - email has been reported removed
+     * 8 - email has been reported added
+     */
+
+    /* touched_cids contains values for each thread
+     * 1 - thread has been modified
+     * 2 - thread has been seen (aka: exemplar shown)
+     * 4 - thread has had an expunged shown (aka: possible old exemplar passed)
+     * 8 - thread is finished (aka: old exemplar definitely passed)
+     */
+
+    // phase 1: find messages and threads which have been modified
+    size_t i;
+    for (i = 0 ; i < mdcount; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        // for this phase, we only care that it has a change
+        if (md->modseq <= since_modseq) {
+            if (search->is_mutable) {
+                modseq_t modseq = 0;
+                conversation_get_modseq(req->cstate, md->cid, &modseq);
+                if (modseq > since_modseq)
+                    hashu64_insert(md->cid, (void*)1, &touched_cids);
+            }
+            continue;
+        }
+
+        jmap_set_emailid(&md->guid, email_id);
+
+        hash_insert(email_id, (void*)1, &touched_ids);
+        hashu64_insert(md->cid, (void*)1, &touched_cids);
+    }
+
+    // phase 2: report messages that need it
+    for (i = 0 ; i < mdcount; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        jmap_set_emailid(&md->guid, email_id);
+
+        int is_expunged = (md->system_flags & FLAG_DELETED) ||
+                (md->internal_flags & FLAG_INTERNAL_EXPUNGED);
+
+        size_t touched_id = (size_t)hash_lookup(email_id, &touched_ids);
+        size_t new_touched_id = touched_id;
+
+        size_t touched_cid = (size_t)hashu64_lookup(md->cid, &touched_cids);
+        size_t new_touched_cid = touched_cid;
+
+        if (is_expunged) {
+            // don't need to tell changes any more
+            if (found_up_to) goto doneloop;
+
+            // nothing to do if not changed (could not be old exemplar)
+            if (!(touched_id & 1)) goto doneloop;
+
+            // could not possibly be old exemplar
+            if (!search->is_mutable && (touched_cid & 8)) goto doneloop;
+
+            // add the destroy notice
+            if (!(touched_id & 4)) {
+                _email_querychanges_destroyed(query, email_id);
+                new_touched_id |= 4;
+                new_touched_cid |= 4;
+            }
+
+            goto doneloop;
+        }
+
+        // this is the exemplar for the cid
+        if (!(touched_cid & 2)) {
+            query->total++;
+            new_touched_cid |= 2;
+        }
+
+        if (found_up_to) goto doneloop;
+
+        // if it's a changed cid, see if we should tell
+        if ((touched_cid & 1)) {
+            // haven't told the exemplar yet?  This is the exemplar!
+            if (!(touched_cid & 2)) {
+                // not yet told in any way, and this ID hasn't been told at all
+                if (touched_cid == 1 && touched_id == 0 && !search->is_mutable) {
+                    // this is both old AND new exemplar, horray.  We don't
+                    // need to tell anything
+                    new_touched_cid |= 8;
+                    goto doneloop;
+                }
+
+                // have to tell both a remove and an add for the exemplar
+                if (!(touched_id & 4)) {
+                    _email_querychanges_destroyed(query, email_id);
+                    new_touched_id |= 4;
+                    num_changes++;
+                }
+                if (!(touched_id & 8)) {
+                    _email_querychanges_added(query, email_id);
+                    new_touched_id |= 8;
+                    num_changes++;
+                }
+                new_touched_cid |= 4;
+                goto doneloop;
+            }
+            // otherwise we've already told the exemplar.
+
+            // could not possibly be old exemplar
+            if (!search->is_mutable && (touched_cid & 8)) goto doneloop;
+
+            // OK, maybe this alive message WAS the old examplar
+            if (!(touched_id & 4)) {
+                _email_querychanges_destroyed(query, email_id);
+                new_touched_id |= 4;
+                new_touched_cid |= 4;
+            }
+
+            // and if this message is a stopper (must have been a candidate
+            // for old exemplar) then stop
+            if (!(touched_id & 1)) {
+                new_touched_cid |= 8;
+            }
+        }
+
+    doneloop:
+        if (query->max_changes && (num_changes > query->max_changes)) {
+            *err = json_pack("{s:s}", "type", "tooManyChanges");
+            break;
+        }
+        if (new_touched_id != touched_id)
+            hash_insert(email_id, (void*)new_touched_id, &touched_ids);
+        if (new_touched_cid != touched_cid)
+            hashu64_insert(md->cid, (void*)new_touched_cid, &touched_cids);
+        // if the search is mutable, later changes could have
+        // been earlier once, so no up_to_id is possible
+        if (!found_up_to && !search->is_mutable
+                         && query->up_to_id
+                         && !strcmp(email_id, query->up_to_id)) {
+            found_up_to = 1;
+        }
+    }
+
+    free_hash_table(&touched_ids, NULL);
+    free_hashu64_table(&touched_cids, NULL);
+
+    modseq_t modseq = jmap_highestmodseq(req, MBTYPE_EMAIL);
+    query->new_querystate = _email_make_querystate(modseq, 0, addrbook_modseq);
+
+done:
+    _emailsearch_free(search);
+}
+
+static void _email_querychanges_uncollapsed(jmap_req_t *req,
+                                            struct jmap_querychanges *query,
+                                            struct email_contactfilter *contactfilter,
+                                            json_t **err)
+{
+    modseq_t since_modseq;
+    uint32_t since_uid;
+    uint32_t num_changes = 0;
+    modseq_t addrbook_modseq = 0;
+    int is_guidsearch = 0;
+
+    if (!_email_read_querystate(query->since_querystate,
+                                &since_modseq, &since_uid,
+                                &addrbook_modseq)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+    if (addrbook_modseq && addrbook_modseq != jmap_highestmodseq(req, MBTYPE_ADDRESSBOOK)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+    if (is_guidsearch) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        return;
+    }
+
+    struct emailsearch *search = _emailsearch_new(req, query->filter, query->sort,
+                                                  &contactfilter->contactgroups,
+                                                  /*want_expunged*/1, /*ignore_timer*/0);
+    if (!search) {
+        *err = jmap_server_error(IMAP_INTERNAL);
+        goto done;
+    }
+    if (!_email_query_can_calculate_changes(search)) {
+        *err = json_pack("{s:s}", "type", "cannotCalculateChanges");
+        goto done;
+    }
+
+    /* Run search */
+    const ptrarray_t *msgdata = NULL;
+    int r = _emailsearch_run_uidsearch(req, search, &msgdata);
+    if (r) {
+        if (r == IMAP_SEARCH_SLOW) {
+            *err = json_pack("{s:s, s:s}", "type", "cannotCalculateChanges",
+                                           "description", "search too slow");
+        }
+        else {
+            *err = jmap_server_error(r);
+        }
+        goto done;
+    }
+
+    /* Prepare result loop */
+    char email_id[JMAP_EMAILID_SIZE];
+    int found_up_to = 0;
+    size_t mdcount = msgdata->count;
+
+    hash_table touched_ids = HASH_TABLE_INITIALIZER;
+    memset(&touched_ids, 0, sizeof(hash_table));
+    construct_hash_table(&touched_ids, mdcount + 1, 0);
+
+    /* touched_ids contains values for each email_id:
+     * 1 - email has been modified
+     * 2 - email has been seen (aka: non-expunged record shown)
+     * 4 - email has been reported removed
+     * 8 - email has been reported added
+     */
+
+    // phase 1: find messages which have been modified
+    size_t i;
+    for (i = 0 ; i < mdcount; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        // for this phase, we only care that it has a change
+        if (md->modseq <= since_modseq) continue;
+
+        jmap_set_emailid(&md->guid, email_id);
+
+        hash_insert(email_id, (void*)1, &touched_ids);
+    }
+
+    // phase 2: report messages that need it
+    for (i = 0 ; i < mdcount; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        jmap_set_emailid(&md->guid, email_id);
+
+        int is_expunged = (md->system_flags & FLAG_DELETED) ||
+                (md->internal_flags & FLAG_INTERNAL_EXPUNGED);
+
+        size_t touched_id = (size_t)hash_lookup(email_id, &touched_ids);
+        size_t new_touched_id = touched_id;
+
+        if (is_expunged) {
+            // don't need to tell changes any more
+            if (found_up_to) continue;
+
+            // nothing to do if not changed
+            if (!(touched_id & 1)) continue;
+
+            // add the destroy notice
+            if (!(touched_id & 4)) {
+                _email_querychanges_destroyed(query, email_id);
+                new_touched_id |= 4;
+            }
+
+            goto doneloop;
+        }
+
+        // this is an exemplar
+        if (!(touched_id & 2)) {
+            query->total++;
+            new_touched_id |= 2;
+        }
+
+        if (found_up_to) goto doneloop;
+
+        // if it's changed, tell about that
+        if ((touched_id & 1)) {
+            if (!search->is_mutable && touched_id == 1 && md->modseq <= since_modseq) {
+                // this is the exemplar, and it's unchanged,
+                // and we haven't told a removed yet, so we
+                // can just suppress everything
+                new_touched_id |= 4 | 8;
+                goto doneloop;
+            }
+
+            // otherwise we're going to have to tell both, if we haven't already
+            if (!(touched_id & 4)) {
+                _email_querychanges_destroyed(query, email_id);
+                new_touched_id |= 4;
+                num_changes++;
+            }
+            if (!(touched_id & 8)) {
+                _email_querychanges_added(query, email_id);
+                new_touched_id |= 8;
+                num_changes++;
+            }
+        }
+
+    doneloop:
+        if (query->max_changes && (num_changes > query->max_changes)) {
+            *err = json_pack("{s:s}", "type", "tooManyChanges");
+            break;
+        }
+        if (new_touched_id != touched_id)
+            hash_insert(email_id, (void*)new_touched_id, &touched_ids);
+        // if the search is mutable, later changes could have
+        // been earlier once, so no up_to_id is possible
+        if (!found_up_to && !search->is_mutable
+                         && query->up_to_id
+                         && !strcmp(email_id, query->up_to_id)) {
+            found_up_to = 1;
+        }
+    }
+
+    free_hash_table(&touched_ids, NULL);
+
+    modseq_t modseq = jmap_highestmodseq(req, MBTYPE_EMAIL);
+    query->new_querystate = _email_make_querystate(modseq, 0, addrbook_modseq);
+
+done:
+    _emailsearch_free(search);
+}
+
+static int jmap_email_querychanges(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_querychanges query;
+    struct jmap_emailquery emailquery;
+    struct email_contactfilter contactfilter;
+
+    _email_contactfilter_initreq(req, &contactfilter);
+    jmap_emailquery_init(&emailquery);
+
+    /* Parse arguments */
+    json_t *err = NULL;
+    jmap_querychanges_parse(req, &parser,
+                            _email_queryargs_parse, &emailquery,
+                            _email_parse_filter_cb, &contactfilter,
+                            _email_parse_comparator, NULL,
+                            &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    if (json_array_size(parser.invalid)) {
+        err = json_pack("{s:s}", "type", "invalidArguments");
+        json_object_set(err, "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Query changes */
+    if (emailquery.collapse_threads)
+        _email_querychanges_collapsed(req, &query, &contactfilter, &err);
+    else
+        _email_querychanges_uncollapsed(req, &query, &contactfilter, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    json_t *res = jmap_querychanges_reply(&query);
+    json_object_set(res, "collapseThreads",
+            json_boolean(emailquery.collapse_threads));
+    jmap_ok(req, res);
+
+done:
+    jmap_email_contactfilter_fini(&contactfilter);
+    jmap_emailquery_fini(&emailquery);
+    jmap_querychanges_fini(&query);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static void _email_changes(jmap_req_t *req, struct jmap_changes *changes, json_t **err)
+{
+    /* Run search */
+    json_t *filter = json_pack("{s:o}", "sinceEmailState",
+                               jmap_fmtstate(changes->since_modseq));
+    json_t *sort = json_pack("[{s:s}]", "property", "emailState");
+
+    struct emailsearch *search = _emailsearch_new(req, filter, sort,
+                                                  /*contactgroups*/NULL,
+                                                  /*want_expunged*/1,
+                                                  /*ignore_timer*/1);
+    if (!search) {
+        *err = jmap_server_error(IMAP_INTERNAL);
+        goto done;
+    }
+
+    const ptrarray_t *msgdata = NULL;
+    int r = _emailsearch_run_uidsearch(req, search, &msgdata);
+    if (r) {
+        *err = jmap_server_error(r);
+        goto done;
+    }
+
+    /* Process results */
+    char email_id[JMAP_EMAILID_SIZE];
+    size_t changes_count = 0;
+    modseq_t highest_modseq = 0;
+    int i;
+    hash_table seen_ids = HASH_TABLE_INITIALIZER;
+    memset(&seen_ids, 0, sizeof(hash_table));
+    construct_hash_table(&seen_ids, msgdata->count + 1, 0);
+
+    for (i = 0 ; i < msgdata->count; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        jmap_set_emailid(&md->guid, email_id);
+
+        /* Skip already seen messages */
+        if (hash_lookup(email_id, &seen_ids)) continue;
+        hash_insert(email_id, (void*)1, &seen_ids);
+
+        /* Apply limit, if any */
+        if (changes->max_changes && ++changes_count > changes->max_changes) {
+            changes->has_more_changes = 1;
+            break;
+        }
+
+        /* Keep track of the highest modseq */
+        if (highest_modseq < md->modseq)
+            highest_modseq = md->modseq;
+
+        struct email_expunge_check rock = { req, changes->since_modseq, 0 };
+        int r = conversations_guid_foreach(req->cstate, _guid_from_id(email_id),
+                                           _email_is_expunged_cb, &rock);
+        if (r) {
+            *err = jmap_server_error(r);
+            goto done;
+        }
+
+        /* Check the message status - status is a bitfield with:
+         * 1: a message exists which was created on or before since_modseq
+         * 2: a message exists which is not deleted
+         *
+         * from those facts we can determine ephemeral / destroyed / created / updated
+         * and we don't need to tell about ephemeral (all created since last time, but none left)
+         */
+        switch (rock.status) {
+        default:
+            break; /* all messages were created AND deleted since previous state! */
+        case 1:
+            /* only expunged messages exist */
+            json_array_append_new(changes->destroyed, json_string(email_id));
+            break;
+        case 2:
+            /* alive, and all messages are created since previous modseq */
+            json_array_append_new(changes->created, json_string(email_id));
+            break;
+        case 3:
+            /* alive, and old */
+            json_array_append_new(changes->updated, json_string(email_id));
+            break;
+        }
+    }
+    free_hash_table(&seen_ids, NULL);
+
+    /* Set new state */
+    changes->new_modseq = changes->has_more_changes ?
+        highest_modseq : jmap_highestmodseq(req, MBTYPE_EMAIL);
+
+done:
+    json_decref(filter);
+    json_decref(sort);
+    _emailsearch_free(search);
+}
+
+static int jmap_email_changes(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Search for updates */
+    _email_changes(req, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static void _thread_changes(jmap_req_t *req, struct jmap_changes *changes, json_t **err)
+{
+    conversation_t conv = CONVERSATION_INIT;
+
+    /* Run search */
+    json_t *filter = json_pack("{s:o}", "sinceEmailState",
+                               jmap_fmtstate(changes->since_modseq));
+    json_t *sort = json_pack("[{s:s}]", "property", "emailState");
+    struct emailsearch *search = _emailsearch_new(req, filter, sort,
+                                                  /*contactgroups*/NULL,
+                                                  /*want_expunged*/1,
+                                                  /*ignore_timer*/1);
+    if (!search) {
+        *err = jmap_server_error(IMAP_INTERNAL);
+        goto done;
+    }
+
+    const ptrarray_t *msgdata = NULL;
+    int r = _emailsearch_run_uidsearch(req, search, &msgdata);
+    if (r) {
+        *err = jmap_server_error(r);
+        goto done;
+    }
+
+    /* Process results */
+    size_t changes_count = 0;
+    modseq_t highest_modseq = 0;
+    int i;
+
+    struct hashset *seen_threads = hashset_new(8);
+
+    char thread_id[JMAP_THREADID_SIZE];
+
+    for (i = 0 ; i < msgdata->count; i++) {
+        MsgData *md = ptrarray_nth(msgdata, i);
+
+        /* Skip already seen threads */
+        if (!hashset_add(seen_threads, &md->cid)) continue;
+
+        /* Apply limit, if any */
+        if (changes->max_changes && ++changes_count > changes->max_changes) {
+            changes->has_more_changes = 1;
+            break;
+        }
+
+        /* Keep track of the highest modseq */
+        if (highest_modseq < md->modseq)
+            highest_modseq = md->modseq;
+
+        /* Determine if the thread got changed or destroyed */
+        if (conversation_load_advanced(req->cstate, md->cid, &conv, /*flags*/0))
+            continue;
+
+        /* Report thread */
+        jmap_set_threadid(md->cid, thread_id);
+        if (conv.exists) {
+            if (conv.createdmodseq <= changes->since_modseq)
+                json_array_append_new(changes->updated, json_string(thread_id));
+            else
+                json_array_append_new(changes->created, json_string(thread_id));
+        }
+        else {
+            if (conv.createdmodseq <= changes->since_modseq)
+                json_array_append_new(changes->destroyed, json_string(thread_id));
+        }
+
+        conversation_fini(&conv);
+        memset(&conv, 0, sizeof(conversation_t));
+    }
+    hashset_free(&seen_threads);
+
+    /* Set new state */
+    changes->new_modseq = changes->has_more_changes ?
+        highest_modseq : jmap_highestmodseq(req, MBTYPE_EMAIL);
+
+done:
+    conversation_fini(&conv);
+    json_decref(filter);
+    json_decref(sort);
+    _emailsearch_free(search);
+}
+
+static int jmap_thread_changes(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Search for updates */
+    _thread_changes(req, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static int _snippet_get_cb(struct mailbox *mbox __attribute__((unused)),
+                           uint32_t uid __attribute__((unused)),
+                           int part, const char *s, void *rock)
+{
+    const char *propname = NULL;
+    json_t *snippet = rock;
+
+    if (part == SEARCH_PART_SUBJECT) {
+        propname = "subject";
+    }
+    else if (part == SEARCH_PART_BODY || part == SEARCH_PART_ATTACHMENTBODY) {
+        propname = "preview";
+    }
+
+    if (propname) {
+        json_object_set_new(snippet, propname, json_string(s));
+    }
+
+    /* Avoid costly attachment body snippets, if possible */
+    return part == SEARCH_PART_BODY ? IMAP_OK_COMPLETED : 0;
+}
+
+static int _snippet_get(jmap_req_t *req, json_t *filter,
+                        json_t *messageids, json_t *jemailpartids,
+                        json_t **snippets, json_t **notfound)
+{
+    struct index_state *state = NULL;
+    void *intquery = NULL;
+    search_builder_t *bx = NULL;
+    search_text_receiver_t *rx = NULL;
+    struct mailbox *mbox = NULL;
+    struct searchargs *searchargs = NULL;
+    struct index_init init;
+    json_t *snippet = NULL;
+    int r = 0;
+    json_t *val;
+    size_t i;
+    char *mboxname = NULL;
+    static search_snippet_markup_t markup = { "<mark>", "</mark>", "..." };
+    strarray_t partids = STRARRAY_INITIALIZER;
+
+    *snippets = json_pack("[]");
+    *notfound = json_pack("[]");
+
+    /* Build searchargs */
+    strarray_t perf_filters = STRARRAY_INITIALIZER;
+    searchargs = new_searchargs(NULL/*tag*/, GETSEARCH_CHARSET_FIRST,
+                                &jmap_namespace, req->userid, req->authstate, 0);
+    searchargs->root = _email_buildsearch(req, filter, /*contactgroups*/NULL, &perf_filters);
+    strarray_fini(&perf_filters);
+
+    /* Build the search query */
+    memset(&init, 0, sizeof(init));
+    init.userid = req->userid;
+    init.authstate = req->authstate;
+    init.examine_mode = 1;
+
+    char *inboxname = mboxname_user_mbox(req->accountid, NULL);
+    r = index_open(inboxname, &init, &state);
+    free(inboxname);
+    if (r) goto done;
+
+    bx = search_begin_search(state->mailbox, SEARCH_MULTIPLE);
+    if (!bx) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    search_build_query(bx, searchargs->root);
+    if (!bx->get_internalised) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+    intquery = bx->get_internalised(bx);
+    search_end_search(bx);
+    if (!intquery) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Set up snippet callback context */
+    snippet = json_pack("{}");
+    rx = search_begin_snippets(intquery, 0, &markup, _snippet_get_cb, snippet);
+    if (!rx) {
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Convert the snippets */
+    json_array_foreach(messageids, i, val) {
+        message_t *msg;
+        msgrecord_t *mr = NULL;
+        uint32_t uid;
+
+        const char *msgid = json_string_value(val);
+
+        r = jmap_email_find(req, msgid, &mboxname, &uid);
+        if (r) {
+            if (r == IMAP_NOTFOUND) {
+                json_array_append_new(*notfound, json_string(msgid));
+            }
+            r = 0;
+            continue;
+        }
+
+        r = jmap_openmbox(req, mboxname, &mbox, 0);
+        if (r) goto done;
+
+        r = msgrecord_find(mbox, uid, &mr);
+        if (r) goto doneloop;
+
+        r = msgrecord_get_message(mr, &msg);
+        if (r) goto doneloop;
+
+        json_t *jpartids = json_object_get(jemailpartids, msgid);
+        if (jpartids) {
+            json_t *jpartid;
+            size_t j;
+            json_array_foreach(jpartids, j, jpartid) {
+                strarray_append(&partids, json_string_value(jpartid));
+            }
+        }
+        json_object_set_new(snippet, "emailId", json_string(msgid));
+        json_object_set_new(snippet, "subject", json_null());
+        json_object_set_new(snippet, "preview", json_null());
+
+        r = rx->begin_mailbox(rx, mbox, /*incremental*/0);
+        r = index_getsearchtext(msg, jpartids ? &partids : NULL, rx, 1);
+        if (!r || r == IMAP_OK_COMPLETED) {
+            json_array_append_new(*snippets, json_deep_copy(snippet));
+            r = 0;
+        }
+        int r2 = rx->end_mailbox(rx, mbox);
+        if (!r) r = r2;
+
+        json_object_clear(snippet);
+        strarray_truncate(&partids, 0);
+        msgrecord_unref(&mr);
+
+doneloop:
+        if (mr) msgrecord_unref(&mr);
+        jmap_closembox(req, &mbox);
+        free(mboxname);
+        mboxname = NULL;
+        if (r) goto done;
+    }
+
+    if (!json_array_size(*notfound)) {
+        json_decref(*notfound);
+        *notfound = json_null();
+    }
+
+done:
+    if (rx) search_end_snippets(rx);
+    if (snippet) json_decref(snippet);
+    if (intquery) search_free_internalised(intquery);
+    if (mboxname) free(mboxname);
+    if (mbox) jmap_closembox(req, &mbox);
+    if (searchargs) freesearchargs(searchargs);
+    strarray_fini(&partids);
+    index_close(&state);
+
+    return r;
+}
+
+static int _email_filter_contains_text(json_t *filter)
+{
+    if (JNOTNULL(filter)) {
+        json_t *val;
+        size_t i;
+
+        if (JNOTNULL(json_object_get(filter, "text"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "subject"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "body"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "attachmentBody"))) {
+            return 1;
+        }
+
+        /* We don't generate snippets for headers, but we
+         * might find header text in the body or subject again. */
+        if (JNOTNULL(json_object_get(filter, "header"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "from"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "to"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "cc"))) {
+            return 1;
+        }
+        if (JNOTNULL(json_object_get(filter, "bcc"))) {
+            return 1;
+        }
+
+        json_array_foreach(json_object_get(filter, "conditions"), i, val) {
+            if (_email_filter_contains_text(val)) {
+                return 1;
+            }
+        }
+    }
+    return 0;
+}
+
+static int jmap_searchsnippet_get(jmap_req_t *req)
+{
+    int r = 0;
+    const char *key;
+    json_t *arg, *jfilter = NULL, *jmessageids = NULL, *jemailpartids = NULL;
+    json_t *snippets, *notfound;
+    struct buf buf = BUF_INITIALIZER;
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct email_contactfilter contactfilter;
+    json_t *err = NULL;
+
+    _email_contactfilter_initreq(req, &contactfilter);
+
+    /* Parse and validate arguments. */
+    json_t *unsupported_filter = json_pack("[]");
+
+    json_object_foreach(req->args, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        /* filter */
+        else if (!strcmp(key, "filter")) {
+            jfilter = arg;
+            if (JNOTNULL(jfilter)) {
+                jmap_parser_push(&parser, "filter");
+                jmap_filter_parse(req, &parser, jfilter, unsupported_filter,
+                                  _email_parse_filter_cb, &contactfilter, &err);
+                jmap_parser_pop(&parser);
+                if (err) break;
+            }
+        }
+
+        /* messageIds */
+        else if (!strcmp(key, "emailIds")) {
+            jmessageids = arg;
+            if (json_array_size(jmessageids)) {
+                jmap_parse_strings(jmessageids, &parser, "emailIds");
+            }
+            else if (!json_is_array(jmessageids)) {
+                jmap_parser_invalid(&parser, "emailIds");
+            }
+        }
+
+        /* partIds */
+        else if (jmap_is_using(req, JMAP_SEARCH_EXTENSION) && !strcmp(key, "partIds")) {
+            jemailpartids = arg;
+            int is_valid = 1;
+            if (json_is_object(jemailpartids)) {
+                const char *email_id;
+                json_t *jpartids;
+                json_object_foreach(jemailpartids, email_id, jpartids) {
+                    if (json_is_array(jpartids)) {
+                        size_t i;
+                        json_t *jpartid;
+                        json_array_foreach(jpartids, i, jpartid) {
+                            if (!json_is_string(jpartid)) {
+                                is_valid = 0;
+                                break;
+                            }
+                        }
+                    }
+                    else if (json_is_null(jpartids)) {
+                        /* JSON null means: no parts */
+                        continue;
+                    }
+                    if (!is_valid) break;
+                }
+            }
+            else is_valid = json_is_null(jemailpartids);
+            if (!is_valid) {
+                jmap_parser_invalid(&parser, "partIds");
+            }
+        }
+        else jmap_parser_invalid(&parser, key);
+        if (!json_object_size(jemailpartids)) {
+            jemailpartids = NULL;
+        }
+    }
+
+    /* Bail out for argument errors */
+    if (err) {
+        jmap_error(req, err);
+        json_decref(unsupported_filter);
+        goto done;
+    }
+    else if (json_array_size(parser.invalid)) {
+        jmap_error(req, json_pack("{s:s, s:O}", "type", "invalidArguments",
+                    "arguments", parser.invalid));
+        json_decref(unsupported_filter);
+        goto done;
+    }
+    /* Report unsupported filters */
+    if (json_array_size(unsupported_filter)) {
+        jmap_error(req, json_pack("{s:s, s:o}", "type", "unsupportedFilter",
+                    "filters", unsupported_filter));
+        goto done;
+    }
+    json_decref(unsupported_filter);
+
+    if (json_array_size(jmessageids) && _email_filter_contains_text(jfilter)) {
+        /* Render snippets */
+        r = _snippet_get(req, jfilter, jmessageids, jemailpartids, &snippets, &notfound);
+        if (r) goto done;
+    } else {
+        /* Trivial, snippets cant' match */
+        size_t i;
+        json_t *val;
+
+        snippets = json_pack("[]");
+        notfound = json_null();
+
+        json_array_foreach(jmessageids, i, val) {
+            json_array_append_new(snippets, json_pack("{s:s s:n s:n}",
+                        "emailId", json_string_value(val),
+                        "subject", "preview"));
+        }
+    }
+
+    /* Prepare response. */
+    json_t *res = json_pack("{s:o s:o}",
+                            "list", snippets, "notFound", notfound);
+    if (jfilter) json_object_set(res, "filter", jfilter);
+    jmap_ok(req, res);
+
+done:
+    jmap_email_contactfilter_fini(&contactfilter);
+    jmap_parser_fini(&parser);
+    buf_free(&buf);
+    return r;
+}
+
+static int _thread_is_shared_cb(const conv_guidrec_t *rec, void *rock)
+{
+    if (rec->part) return 0;
+    if (rec->internal_flags & FLAG_INTERNAL_EXPUNGED) return 0;
+    jmap_req_t *req = (jmap_req_t *)rock;
+    static int needrights = ACL_READ|ACL_LOOKUP;
+    if (jmap_hasrights_byname(req, rec->mboxname, needrights))
+        return IMAP_OK_COMPLETED;
+    return 0;
+}
+
+static int _thread_get(jmap_req_t *req, json_t *ids,
+                       json_t *list, json_t *not_found)
+{
+    conversation_t conv = CONVERSATION_INIT;
+    json_t *val;
+    size_t i;
+    int r = 0;
+
+    json_array_foreach(ids, i, val) {
+        conv_thread_t *thread;
+        char email_id[JMAP_EMAILID_SIZE];
+
+        const char *threadid = json_string_value(val);
+
+        memset(&conv, 0, sizeof(conversation_t));
+        r = conversation_load_advanced(req->cstate, _cid_from_id(threadid),
+                                       &conv, CONV_WITHTHREAD);
+        if (r || !conv.thread) {
+            json_array_append_new(not_found, json_string(threadid));
+            continue;
+        }
+
+        int is_own_account = !strcmp(req->userid, req->accountid);
+        json_t *ids = json_pack("[]");
+        for (thread = conv.thread; thread; thread = thread->next) {
+            if (!is_own_account) {
+                const char *guidrep = message_guid_encode(&thread->guid);
+                int r = conversations_guid_foreach(req->cstate, guidrep,
+                                                   _thread_is_shared_cb, req);
+                if (r != IMAP_OK_COMPLETED) {
+                    if (r) {
+                        syslog(LOG_ERR, "jmap: _thread_is_shared_cb(%s): %s",
+                                guidrep, error_message(r));
+                    }
+                    continue;
+                }
+            }
+            jmap_set_emailid(&thread->guid, email_id);
+            json_array_append_new(ids, json_string(email_id));
+        }
+
+        /* if we didn't find any visible IDs, then the thread doesn't really
+           exist for this user */
+        if (!json_array_size(ids)) {
+            json_decref(ids);
+            json_array_append_new(not_found, json_string(threadid));
+            continue;
+        }
+
+        json_t *jthread = json_pack("{s:s s:o}", "id", threadid, "emailIds", ids);
+        json_array_append_new(list, jthread);
+
+        conversation_fini(&conv);
+    }
+
+    r = 0;
+
+    conversation_fini(&conv);
+    return r;
+}
+
+static const jmap_property_t thread_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "emailIds",
+        NULL,
+        0
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_thread_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, thread_props, /*allow_null_ids*/0,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Find threads */
+    int r = _thread_get(req, get.ids, get.list, get.not_found);
+    if (r) {
+        syslog(LOG_ERR, "jmap: Thread/get: %s", error_message(r));
+        jmap_error(req, jmap_server_error(r));
+        goto done;
+    }
+
+    json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
+
+struct email_getcontext {
+    struct seen *seendb;           /* Seen database for shared accounts */
+    hash_table seenseq_by_mbox_id; /* Cached seen sequences */
+};
+
+static void _email_getcontext_fini(struct email_getcontext *ctx)
+{
+    free_hash_table(&ctx->seenseq_by_mbox_id, (void(*)(void*))seqset_free);
+    seen_close(&ctx->seendb);
+}
+
+struct email_getargs {
+    /* Email/get arguments */
+    hash_table *props; /* owned by JMAP get or process stack */
+    hash_table *bodyprops;
+    ptrarray_t want_headers;     /* array of header_prop */
+    ptrarray_t want_bodyheaders; /* array of header_prop */
+    short fetch_text_body;
+    short fetch_html_body;
+    short fetch_all_body;
+    size_t max_body_bytes;
+    /* Request-scoped context */
+    struct email_getcontext ctx;
+};
+
+#define _EMAIL_GET_ARGS_INITIALIZER \
+    { \
+        NULL, \
+        NULL, \
+        PTRARRAY_INITIALIZER, \
+        PTRARRAY_INITIALIZER, \
+        0, \
+        0, \
+        0, \
+        0, \
+        { \
+            NULL, \
+            HASH_TABLE_INITIALIZER \
+        } \
+    };
+
+/* Initialized in email_get_parse. *Not* thread-safe */
+static hash_table _email_get_default_bodyprops = HASH_TABLE_INITIALIZER;
+static hash_table _email_parse_default_props = HASH_TABLE_INITIALIZER;
+
+static void _email_getargs_fini(struct email_getargs *args)
+{
+    if (args->bodyprops && args->bodyprops != &_email_get_default_bodyprops) {
+        free_hash_table(args->bodyprops, NULL);
+        free(args->bodyprops);
+    }
+    args->bodyprops = NULL;
+
+    struct header_prop *prop;
+    while ((prop = ptrarray_pop(&args->want_headers))) {
+        _header_prop_fini(prop);
+        free(prop);
+    }
+    ptrarray_fini(&args->want_headers);
+    while ((prop = ptrarray_pop(&args->want_bodyheaders))) {
+        _header_prop_fini(prop);
+        free(prop);
+    }
+    ptrarray_fini(&args->want_bodyheaders);
+    _email_getcontext_fini(&args->ctx);
+}
+
+/* A wrapper to aggregate JMAP keywords over a set of message records.
+ * Notably the $seen keyword is a pain to map from IMAP to JMAP:
+ * (1) it must only be reported if the IMAP \Seen flag is set on
+ *     all non-deleted index records.
+ * (2) it must be read from seen.db for shared mailboxes
+ */
+struct email_keywords {
+    const char *userid;
+    hash_table counts;
+    size_t totalmsgs;
+    hash_table *seenseq_by_mbox_id;
+    struct seen *seendb;
+};
+
+#define _EMAIL_KEYWORDS_INITIALIZER { NULL, HASH_TABLE_INITIALIZER, 0, NULL, NULL }
+
+/* Initialize the keyword aggregator for the authenticated userid.
+ *
+ * The seenseq hash table is used to read cached sequence sets
+ * read from seen.db per mailbox. If the hash table does not
+ * contain a sequence for the respective mailbox id, it is read
+ * from seen.db and stored in the map.
+ * Callers must free any entries in seenseq_by_mbox_id. */
+static void _email_keywords_init(struct email_keywords *keywords,
+                                 const char *userid,
+                                 struct seen *seendb,
+                                 hash_table *seenseq_by_mbox_id)
+{
+    construct_hash_table(&keywords->counts, 64, 0);
+    keywords->userid = userid;
+    keywords->seendb = seendb;
+    keywords->seenseq_by_mbox_id = seenseq_by_mbox_id;
+}
+
+static void _email_keywords_fini(struct email_keywords *keywords)
+{
+    free_hash_table(&keywords->counts, NULL);
+}
+
+static void _email_keywords_add_keyword(struct email_keywords *keywords,
+                                        const char *keyword)
+{
+    uintptr_t count = (uintptr_t) hash_lookup(keyword, &keywords->counts);
+    hash_insert(keyword, (void*) count+1, &keywords->counts);
+}
+
+static int _email_keywords_add_msgrecord(struct email_keywords *keywords,
+                                         msgrecord_t *mr)
+{
+    uint32_t uid, system_flags, internal_flags;
+    uint32_t user_flags[MAX_USER_FLAGS/32];
+    struct mailbox *mbox = NULL;
+
+    int r = msgrecord_get_uid(mr, &uid);
+    if (r) goto done;
+    r = msgrecord_get_mailbox(mr, &mbox);
+    if (r) goto done;
+    r = msgrecord_get_systemflags(mr, &system_flags);
+    if (r) goto done;
+    r = msgrecord_get_internalflags(mr, &internal_flags);
+    if (r) goto done;
+    if (system_flags & FLAG_DELETED || internal_flags & FLAG_INTERNAL_EXPUNGED) goto done;
+    r = msgrecord_get_userflags(mr, user_flags);
+    if (r) goto done;
+
+    int read_seendb = !mailbox_internal_seen(mbox, keywords->userid);
+
+    /* Read system flags */
+    if ((system_flags & FLAG_DRAFT))
+        _email_keywords_add_keyword(keywords, "$draft");
+    if ((system_flags & FLAG_FLAGGED))
+        _email_keywords_add_keyword(keywords, "$flagged");
+    if ((system_flags & FLAG_ANSWERED))
+        _email_keywords_add_keyword(keywords, "$answered");
+    if (!read_seendb && system_flags & FLAG_SEEN)
+        _email_keywords_add_keyword(keywords, "$seen");
+
+    /* Read user flags */
+    struct buf buf = BUF_INITIALIZER;
+    int i;
+    for (i = 0 ; i < MAX_USER_FLAGS ; i++) {
+        if (mbox->flagname[i] && (user_flags[i/32] & 1<<(i&31))) {
+            buf_setcstr(&buf, mbox->flagname[i]);
+            _email_keywords_add_keyword(keywords, buf_lcase(&buf));
+        }
+    }
+    buf_free(&buf);
+
+    if (read_seendb) {
+        /* Read $seen keyword from seen.db for shared accounts */
+        struct seqset *seenseq = hash_lookup(mbox->uniqueid, keywords->seenseq_by_mbox_id);
+        if (!seenseq) {
+            struct seendata sd = SEENDATA_INITIALIZER;
+            int r = seen_read(keywords->seendb, mbox->uniqueid, &sd);
+            if (!r) {
+                seenseq = seqset_parse(sd.seenuids, NULL, sd.lastuid);
+                hash_insert(mbox->uniqueid, seenseq, keywords->seenseq_by_mbox_id);
+                seen_freedata(&sd);
+            }
+            else {
+                syslog(LOG_ERR, "Could not read seen state for %s (%s)",
+                        keywords->userid, error_message(r));
+            }
+        }
+
+        if (seenseq && seqset_ismember(seenseq, uid))
+            _email_keywords_add_keyword(keywords, "$seen");
+    }
+
+    /* Count message */
+    keywords->totalmsgs++;
+
+done:
+    return r;
+}
+
+static json_t *_email_keywords_to_jmap(struct email_keywords *keywords)
+{
+    json_t *jkeywords = json_object();
+    hash_iter *kwiter = hash_table_iter(&keywords->counts);
+    while (hash_iter_next(kwiter)) {
+        const char *keyword = hash_iter_key(kwiter);
+        uintptr_t count = (uintptr_t) hash_iter_val(kwiter);
+        if (strcasecmp(keyword, "$seen") || count == keywords->totalmsgs) {
+            json_object_set_new(jkeywords, keyword, json_true());
+        }
+    }
+    hash_iter_free(&kwiter);
+    return jkeywords;
+}
+
+
+struct email_get_keywords_rock {
+    jmap_req_t *req;
+    struct email_keywords keywords;
+};
+
+static int _email_get_keywords_cb(const conv_guidrec_t *rec, void *vrock)
+{
+    struct email_get_keywords_rock *rock = vrock;
+    jmap_req_t *req = rock->req;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+
+    if (rec->part) return 0;
+
+    if (!jmap_hasrights_byname(req, rec->mboxname, ACL_READ|ACL_LOOKUP)) return 0;
+
+    /* Fetch system flags */
+    int r = jmap_openmbox(req, rec->mboxname, &mbox, 0);
+    if (r) return r;
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (r) goto done;
+
+    r = _email_keywords_add_msgrecord(&rock->keywords, mr);
+
+done:
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    return r;
+}
+
+static int _email_get_keywords(jmap_req_t *req,
+                               struct email_getcontext *ctx,
+                               const char *msgid,
+                               json_t **jkeywords)
+{
+    /* Initialize seen.db and sequence set cache */
+    if (ctx->seendb == NULL && strcmp(req->accountid, req->userid)) {
+        int r = seen_open(req->userid, SEEN_CREATE, &ctx->seendb);
+        if (r) return r;
+    }
+    if (ctx->seenseq_by_mbox_id.size == 0) {
+        construct_hash_table(&ctx->seenseq_by_mbox_id, 128, 0);
+    }
+    /* Gather keywords for all message records */
+    struct email_get_keywords_rock rock = { req, _EMAIL_KEYWORDS_INITIALIZER };
+    _email_keywords_init(&rock.keywords, req->userid, ctx->seendb, &ctx->seenseq_by_mbox_id);
+    int r = conversations_guid_foreach(req->cstate, _guid_from_id(msgid),
+                                       _email_get_keywords_cb, &rock);
+    *jkeywords = _email_keywords_to_jmap(&rock.keywords);
+    _email_keywords_fini(&rock.keywords);
+    return r;
+}
+
+struct email_get_snoozed_rock {
+    jmap_req_t *req;
+    json_t *snoozed;
+};
+
+static int _email_get_snoozed_cb(const conv_guidrec_t *rec, void *vrock)
+{
+    struct email_get_snoozed_rock *rock = vrock;
+
+    if (rec->part) return 0;
+
+    if (!jmap_hasrights_byname(rock->req, rec->mboxname, ACL_READ|ACL_LOOKUP))
+        return 0;
+
+    if (FLAG_INTERNAL_SNOOZED ==
+        (rec->internal_flags & (FLAG_INTERNAL_SNOOZED|FLAG_INTERNAL_EXPUNGED))) {
+        /* Fetch snoozed annotation */
+        rock->snoozed = jmap_fetch_snoozed(rec->mboxname, rec->uid);
+    }
+
+    /* Short-circuit the foreach if we find a snoozed message */
+    return (rock->snoozed != NULL);
+}
+
+static void _email_parse_wantheaders(json_t *jprops,
+                                     struct jmap_parser *parser,
+                                     const char *prop_name,
+                                     ptrarray_t *want_headers)
+{
+    size_t i;
+    json_t *jval;
+    json_array_foreach(jprops, i, jval) {
+        const char *s = json_string_value(jval);
+        if (!s || strncmp(s, "header:", 7))
+            continue;
+        struct header_prop *hprop;
+        if ((hprop = _header_parseprop(s))) {
+            ptrarray_append(want_headers, hprop);
+        }
+        else {
+            jmap_parser_push_index(parser, prop_name, i, s);
+            jmap_parser_invalid(parser, NULL);
+            jmap_parser_pop(parser);
+        }
+    }
+}
+
+static void _email_init_default_props(hash_table *props)
+{
+    /* Initialize process-owned default property list */
+    construct_hash_table(props, 32, 0);
+    if (props == &_email_get_default_bodyprops) {
+        hash_insert("blobId",      (void*)1, props);
+        hash_insert("charset",     (void*)1, props);
+        hash_insert("cid",         (void*)1, props);
+        hash_insert("disposition", (void*)1, props);
+        hash_insert("language",    (void*)1, props);
+        hash_insert("location",    (void*)1, props);
+        hash_insert("name",        (void*)1, props);
+        hash_insert("partId",      (void*)1, props);
+        hash_insert("size",        (void*)1, props);
+        hash_insert("type",        (void*)1, props);
+    }
+    else {
+        hash_insert("attachments",   (void*)1, props);
+        hash_insert("bcc",           (void*)1, props);
+        hash_insert("bodyValues",    (void*)1, props);
+        hash_insert("cc",            (void*)1, props);
+        hash_insert("from",          (void*)1, props);
+        hash_insert("hasAttachment", (void*)1, props);
+        hash_insert("htmlBody",      (void*)1, props);
+        hash_insert("inReplyTo",     (void*)1, props);
+        hash_insert("messageId",     (void*)1, props);
+        hash_insert("preview",       (void*)1, props);
+        hash_insert("references",    (void*)1, props);
+        hash_insert("replyTo",       (void*)1, props);
+        hash_insert("sender",        (void*)1, props);
+        hash_insert("sentAt",        (void*)1, props);
+        hash_insert("subject",       (void*)1, props);
+        hash_insert("textBody",      (void*)1, props);
+        hash_insert("to",            (void*)1, props);
+    }
+}
+
+static int _email_getargs_parse(jmap_req_t *req __attribute__((unused)),
+                                struct jmap_parser *parser,
+                                const char *key,
+                                json_t *arg,
+                                void *rock)
+{
+    struct email_getargs *args = (struct email_getargs *) rock;
+    int r = 1;
+
+    /* bodyProperties */
+    if (!strcmp(key, "bodyProperties")) {
+        if (jmap_parse_strings(arg, parser, "bodyProperties")) {
+            size_t i;
+            json_t *val;
+
+            args->bodyprops = xzmalloc(sizeof(hash_table));
+            construct_hash_table(args->bodyprops, json_array_size(arg) + 1, 0);
+            json_array_foreach(arg, i, val) {
+                hash_insert(json_string_value(val), (void*)1, args->bodyprops);
+            }
+        }
+        /* header:Xxx properties */
+        _email_parse_wantheaders(arg, parser, "bodyProperties",
+                                 &args->want_bodyheaders);
+    }
+
+    /* fetchTextBodyValues */
+    else if (!strcmp(key, "fetchTextBodyValues") && json_is_boolean(arg)) {
+        args->fetch_text_body = json_boolean_value(arg);
+    }
+
+    /* fetchHTMLBodyValues */
+    else if (!strcmp(key, "fetchHTMLBodyValues") && json_is_boolean(arg)) {
+        args->fetch_html_body = json_boolean_value(arg);
+    }
+
+    /* fetchAllBodyValues */
+    else if (!strcmp(key, "fetchAllBodyValues") && json_is_boolean(arg)) {
+        args->fetch_all_body = json_boolean_value(arg);
+    }
+
+    /* maxBodyValueBytes */
+    else if (!strcmp(key, "maxBodyValueBytes") &&
+             json_is_integer(arg) && json_integer_value(arg) > 0) {
+        args->max_body_bytes = json_integer_value(arg);
+    }
+
+    else r = 0;
+
+    return r;
+}
+
+struct cyrusmsg {
+    msgrecord_t *mr;                 /* Message record for top-level message */
+    const struct body *part0;        /* Root body-part */
+    const struct body *rfc822part;   /* RFC822 root part for embedded message */
+    const struct buf *mime;          /* Raw MIME buffer */
+    json_t *imagesize_by_part;       /* FastMail-specific extension */
+
+    message_t *_m;                   /* Message loaded from message record */
+    struct body *_mybody;            /* Bodystructure */
+    struct buf _mymime;              /* Raw MIME buffer */
+    struct headers *_headers;        /* Parsed part0 headers. Don't free. */
+    hash_table *_headers_by_part_id; /* Parsed subpart headers. Don't free. */
+    ptrarray_t _headers_mempool;     /* Allocated headers memory */
+};
+
+static void _cyrusmsg_free(struct cyrusmsg **msgptr)
+{
+    if (msgptr == NULL || *msgptr == NULL) return;
+
+    struct cyrusmsg *msg = *msgptr;
+    if (msg->_mybody) {
+        message_free_body(msg->_mybody);
+        free(msg->_mybody);
+    }
+    buf_free(&msg->_mymime);
+    json_decref(msg->imagesize_by_part);
+    if (msg->_headers_by_part_id) {
+        free_hash_table(msg->_headers_by_part_id, NULL);
+        free(msg->_headers_by_part_id);
+    }
+    struct headers *hdrs;
+    while ((hdrs = ptrarray_pop(&msg->_headers_mempool))) {
+        _headers_fini(hdrs);
+        free(hdrs);
+    }
+    ptrarray_fini(&msg->_headers_mempool);
+    free(*msgptr);
+    *msgptr = NULL;
+}
+
+static int _cyrusmsg_from_record(msgrecord_t *mr, struct cyrusmsg **msgptr)
+{
+    struct cyrusmsg *msg = xzmalloc(sizeof(struct cyrusmsg));
+    msg->mr = mr;
+    *msgptr = msg;
+    return 0;
+}
+
+static int _cyrusmsg_from_rfc822body(msgrecord_t *mr,
+                                     const struct body *body,
+                                     struct cyrusmsg **msgptr)
+{
+    struct cyrusmsg *msg = xzmalloc(sizeof(struct cyrusmsg));
+    msg->mr = mr;
+    msg->part0 = body;
+    msg->rfc822part = body;
+    *msgptr = msg;
+    return 0;
+}
+
+static void _cyrusmsg_init_partids(struct body *body, const char *part_id)
+{
+    if (!body) return;
+
+    if (!strcmp(body->type, "MULTIPART")) {
+        struct buf buf = BUF_INITIALIZER;
+        int i;
+        for (i = 0; i < body->numparts; i++) {
+            struct body *subpart = body->subpart + i;
+            if (part_id) buf_printf(&buf, "%s.", part_id);
+            buf_printf(&buf, "%d", i + 1);
+            subpart->part_id = buf_release(&buf);
+            _cyrusmsg_init_partids(subpart, subpart->part_id);
+        }
+        free(body->part_id);
+        body->part_id = NULL;
+        buf_free(&buf);
+    }
+    else {
+        struct buf buf = BUF_INITIALIZER;
+        if (!body->part_id) {
+            if (part_id) buf_printf(&buf, "%s.", part_id);
+            buf_printf(&buf, "%d", 1);
+            body->part_id = buf_release(&buf);
+        }
+        buf_free(&buf);
+
+        if (!strcmp(body->type, "MESSAGE") &&
+            !strcmp(body->subtype, "RFC822")) {
+            _cyrusmsg_init_partids(body->subpart, body->part_id);
+        }
+    }
+}
+
+
+static int _cyrusmsg_from_buf(const struct buf *buf, struct cyrusmsg **msgptr)
+{
+    /* No more return from here */
+    struct body *mybody = xzmalloc(sizeof(struct body));
+    struct protstream *pr = prot_readmap(buf_base(buf), buf_len(buf));
+
+    /* Pre-run compliance check */
+    int r = message_copy_strict(pr, /*to*/NULL, buf_len(buf), /*allow_null*/0);
+    if (r) goto done;
+
+    /* Parse message */
+    r = message_parse_mapped(buf_base(buf), buf_len(buf), mybody, NULL);
+    if (r || !mybody->subpart) {
+        r = IMAP_MESSAGE_BADHEADER;
+        goto done;
+    }
+
+    /* parse_mapped doesn't set part ids */
+    _cyrusmsg_init_partids(mybody->subpart, NULL);
+
+    struct cyrusmsg *msg = xzmalloc(sizeof(struct cyrusmsg));
+    msg->_mybody = mybody;
+    msg->part0 = mybody;
+    msg->rfc822part = mybody;
+    msg->mime = buf;
+    *msgptr = msg;
+
+done:
+    if (pr) prot_free(pr);
+    if (r && mybody) {
+        message_free_body(mybody);
+        free(mybody);
+    }
+    return r;
+}
+
+static int _cyrusmsg_need_part0(struct cyrusmsg *msg)
+{
+    if (msg->part0)
+        return 0;
+    if (!msg->mr)
+        return IMAP_INTERNAL;
+
+    int r = msgrecord_extract_bodystructure(msg->mr, &msg->_mybody);
+    if (r) return r;
+    msg->part0 = msg->_mybody;
+    return 0;
+}
+
+static int _cyrusmsg_need_mime(struct cyrusmsg *msg)
+{
+    if (msg->mime) return 0;
+    if (msg->mr == NULL) {
+        return IMAP_INTERNAL;
+    }
+    int r = msgrecord_get_body(msg->mr, &msg->_mymime);
+    msg->mime = &msg->_mymime;
+    if (r) return r;
+    return 0;
+}
+
+static int _cyrusmsg_get_headers(struct cyrusmsg *msg,
+                                 const struct body *part,
+                                 struct headers **headersptr)
+{
+
+    if (part == NULL && msg->_headers) {
+        *headersptr = msg->_headers;
+        return 0;
+    }
+    else if (part && part->part_id) {
+        if (msg->_headers_by_part_id) {
+            *headersptr = hash_lookup(part->part_id, msg->_headers_by_part_id);
+            if (*headersptr) return 0;
+        }
+        else {
+            msg->_headers_by_part_id = xzmalloc(sizeof(hash_table));
+            construct_hash_table(msg->_headers_by_part_id, 64, 0);
+        }
+    }
+
+    /* Prefetch body structure */
+    int r = _cyrusmsg_need_part0(msg);
+    if (r) return r;
+
+    /* Prefetch MIME message */
+    r = _cyrusmsg_need_mime(msg);
+    if (r) return r;
+    const struct body *header_part = part ? part : msg->part0;
+
+    struct headers *headers = xmalloc(sizeof(struct headers));
+    _headers_init(headers);
+    _headers_from_mime(msg->mime->s + header_part->header_offset,
+                       header_part->header_size, headers);
+
+    if (part && part->part_id)
+        hash_insert(part->part_id, headers, msg->_headers_by_part_id);
+    else if (part == NULL)
+        msg->_headers = headers;
+    ptrarray_append(&msg->_headers_mempool, headers);
+    *headersptr = headers;
+    return 0;
+}
+
+static json_t * _email_get_header(struct cyrusmsg *msg,
+                                  const struct body *part,
+                                  const char *lcasename,
+                                  enum header_form want_form,
+                                  int want_all)
+{
+    if (!part) {
+        if (msg->rfc822part) {
+            part = msg->rfc822part->subpart;
+        }
+        else {
+            int r = _cyrusmsg_need_part0(msg);
+            if (r) return json_null();
+            part = msg->part0;
+        }
+    }
+
+    /* Try to read the header from the parsed body part */
+    if (part && !want_all && want_form != HEADER_FORM_RAW) {
+        json_t *jval = NULL;
+        if (!strcmp("messageId", lcasename)) {
+            jval = want_form == HEADER_FORM_MESSAGEIDS ?
+                _header_as_messageids(part->message_id, want_form) : json_null();
+        }
+        else if (!strcmp("inReplyTo", lcasename)) {
+            jval = want_form == HEADER_FORM_MESSAGEIDS ?
+                _header_as_messageids(part->in_reply_to, want_form) : json_null();
+        }
+        if (!strcmp("subject", lcasename)) {
+            jval = want_form == HEADER_FORM_TEXT ?
+                _header_as_text(part->subject, want_form) : json_null();
+        }
+        if (!strcmp("from", lcasename)) {
+            jval = want_form & (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES) ?
+                _emailaddresses_from_addr(part->from, want_form) : json_null();
+        }
+        else if (!strcmp("to", lcasename)) {
+            jval = want_form & (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES) ?
+                _emailaddresses_from_addr(part->to, want_form) : json_null();
+        }
+        else if (!strcmp("cc", lcasename)) {
+            jval = want_form & (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES) ?
+                _emailaddresses_from_addr(part->cc, want_form) : json_null();
+        }
+        else if (!strcmp("bcc", lcasename)) {
+            jval = want_form & (HEADER_FORM_ADDRESSES|HEADER_FORM_GROUPEDADDRESSES) ?
+                _emailaddresses_from_addr(part->bcc, want_form) : json_null();
+        }
+        else if (!strcmp("sentAt", lcasename)) {
+            jval = json_null();
+            if (want_form == HEADER_FORM_DATE) {
+                struct offsettime t;
+                if (offsettime_from_rfc5322(part->date, &t, DATETIME_FULL) != -1) {
+                    char datestr[30];
+                    offsettime_to_iso8601(&t, datestr, 30, 1);
+                    jval = json_string(datestr);
+                }
+            }
+        }
+        if (jval) return jval;
+    }
+
+    /* Determine header form converter */
+    json_t* (*conv)(const char *raw, enum header_form want_form);
+    switch (want_form) {
+        case HEADER_FORM_TEXT:
+            conv = _header_as_text;
+            break;
+        case HEADER_FORM_DATE:
+            conv = _header_as_date;
+            break;
+        case HEADER_FORM_ADDRESSES:
+        case HEADER_FORM_GROUPEDADDRESSES:
+            conv = _header_as_addresses;
+            break;
+        case HEADER_FORM_MESSAGEIDS:
+            conv = _header_as_messageids;
+            break;
+        case HEADER_FORM_URLS:
+            conv = _header_as_urls;
+            break;
+        default:
+            conv = _header_as_raw;
+    }
+
+    /* Try to read the value from the index record or header cache */
+    if (msg->mr && part == msg->part0 && !msg->rfc822part &&
+            !want_all && want_form != HEADER_FORM_RAW) {
+        if (!msg->_m) {
+            int r = msgrecord_get_message(msg->mr, &msg->_m);
+            if (r) return json_null();
+        }
+        struct buf buf = BUF_INITIALIZER;
+        int r = message_get_field(msg->_m, lcasename, MESSAGE_RAW|MESSAGE_LAST, &buf);
+        if (r) return json_null();
+        json_t *jval = NULL;
+        if (buf_len(&buf)) jval = conv(buf_cstring(&buf), want_form);
+        buf_free(&buf);
+        if (jval) return jval;
+    }
+
+    /* Read the raw MIME headers */
+    struct headers *partheaders = NULL;
+    int r = _cyrusmsg_get_headers(msg, part, &partheaders);
+    if (r) return json_null();
+
+    /* Lookup array of EmailHeader objects by name */
+    json_t *jheaders = json_object_get(partheaders->all, lcasename);
+    if (!jheaders || !json_array_size(jheaders)) {
+        return want_all ? json_array() : json_null();
+    }
+
+    /* Convert header values */
+    if (want_all) {
+        json_t *allvals = json_array();
+        size_t i;
+        for (i = 0; i < json_array_size(jheaders); i++) {
+            json_t *jheader = json_array_get(jheaders, i);
+            json_t *jheaderval = json_object_get(jheader, "value");
+            json_array_append_new(allvals, conv(json_string_value(jheaderval), want_form));
+        }
+        return allvals;
+    }
+
+    json_t *jheader = json_array_get(jheaders, json_array_size(jheaders) - 1);
+    json_t *jheaderval = json_object_get(jheader, "value");
+    return conv(json_string_value(jheaderval), want_form);
+}
+
+static int _email_get_meta(jmap_req_t *req,
+                           struct email_getargs *args,
+                           struct cyrusmsg *msg,
+                           json_t *email)
+{
+    int r = 0;
+    hash_table *props = args->props;
+    char email_id[JMAP_EMAILID_SIZE];
+
+    if (msg->rfc822part) {
+        if (jmap_wantprop(props, "id")) {
+            json_object_set_new(email, "id", json_null());
+        }
+        if (jmap_wantprop(props, "blobId")) {
+            char blob_id[JMAP_BLOBID_SIZE];
+            jmap_set_blobid(&msg->rfc822part->content_guid, blob_id);
+            json_object_set_new(email, "blobId", json_string(blob_id));
+        }
+        if (jmap_wantprop(props, "threadId"))
+            json_object_set_new(email, "threadId", json_null());
+        if (jmap_wantprop(props, "mailboxIds"))
+            json_object_set_new(email, "mailboxIds", json_null());
+        if (jmap_wantprop(props, "keywords"))
+            json_object_set_new(email, "keywords", json_object());
+        if (jmap_wantprop(props, "size")) {
+            size_t size = msg->rfc822part->header_size + msg->rfc822part->content_size;
+            json_object_set_new(email, "size", json_integer(size));
+        }
+        if (jmap_wantprop(props, "receivedAt"))
+            json_object_set_new(email, "receivedAt", json_null());
+        return 0;
+    }
+
+    /* This is a top-level messages with a regular index record. */
+
+    /* Determine message id */
+    struct message_guid guid;
+    r = msgrecord_get_guid(msg->mr, &guid);
+    if (r) goto done;
+
+    jmap_set_emailid(&guid, email_id);
+
+    /* id */
+    if (jmap_wantprop(props, "id")) {
+        json_object_set_new(email, "id", json_string(email_id));
+    }
+
+    /* blobId */
+    if (jmap_wantprop(props, "blobId")) {
+        char blob_id[JMAP_BLOBID_SIZE];
+        jmap_set_blobid(&guid, blob_id);
+        json_object_set_new(email, "blobId", json_string(blob_id));
+    }
+
+    /* threadid */
+    if (jmap_wantprop(props, "threadId")) {
+        bit64 cid;
+        r = msgrecord_get_cid(msg->mr, &cid);
+        if (r) goto done;
+        char thread_id[JMAP_THREADID_SIZE];
+        jmap_set_threadid(cid, thread_id);
+        json_object_set_new(email, "threadId", json_string(thread_id));
+    }
+
+    /* mailboxIds */
+    if (jmap_wantprop(props, "mailboxIds") ||
+        jmap_wantprop(props, "addedDates") || jmap_wantprop(props, "removedDates")) {
+        json_t *mboxids =
+            jmap_wantprop(props, "mailboxIds") ? json_object() : NULL;
+        json_t *added =
+            jmap_wantprop(props, "addedDates") ? json_object() : NULL;
+        json_t *removed =
+            jmap_wantprop(props, "removedDates") ? json_object() : NULL;
+        json_t *mailboxes = _email_mailboxes(req, email_id);
+
+        json_t *val;
+        const char *mboxid;
+        json_object_foreach(mailboxes, mboxid, val) {
+            json_t *exists = json_object_get(val, "added");
+
+            if (exists) {
+                if (mboxids) json_object_set_new(mboxids, mboxid, json_true());
+                if (added) json_object_set(added, mboxid, exists);
+            }
+            else if (removed) {
+                json_object_set(removed, mboxid, json_object_get(val, "removed"));
+            }
+        }
+        json_decref(mailboxes);
+        if (mboxids) json_object_set_new(email, "mailboxIds", mboxids);
+        if (removed) json_object_set_new(email, "removedDates", removed);
+        if (added) json_object_set_new(email, "addedDates", added);
+    }
+
+    /* keywords */
+    if (jmap_wantprop(props, "keywords")) {
+        json_t *keywords = NULL;
+        r = _email_get_keywords(req, &args->ctx, email_id, &keywords);
+        if (r) goto done;
+        json_object_set_new(email, "keywords", keywords);
+    }
+
+    /* size */
+    if (jmap_wantprop(props, "size")) {
+        uint32_t size;
+        r = msgrecord_get_size(msg->mr, &size);
+        if (r) goto done;
+        json_object_set_new(email, "size", json_integer(size));
+    }
+
+    /* receivedAt */
+    if (jmap_wantprop(props, "receivedAt")) {
+        char datestr[RFC3339_DATETIME_MAX];
+        time_t t;
+        r = msgrecord_get_internaldate(msg->mr, &t);
+        if (r) goto done;
+        time_to_rfc3339(t, datestr, RFC3339_DATETIME_MAX);
+        json_object_set_new(email, "receivedAt", json_string(datestr));
+    }
+
+    /* FastMail-extension properties */
+    if (jmap_wantprop(props, "trustedSender")) {
+        json_t *trusted_sender = NULL;
+        int has_trusted_flag = 0;
+        r = msgrecord_hasflag(msg->mr, "$IsTrusted", &has_trusted_flag);
+        if (r) goto done;
+        if (has_trusted_flag) {
+            struct buf buf = BUF_INITIALIZER;
+            _email_read_annot(req, msg->mr, "/vendor/messagingengine.com/trusted", &buf);
+            if (buf_len(&buf)) {
+                trusted_sender = json_string(buf_cstring(&buf));
+            }
+            buf_free(&buf);
+        }
+        json_object_set_new(email, "trustedSender", trusted_sender ?
+                trusted_sender : json_null());
+    }
+
+    if (jmap_wantprop(props, "spamScore")) {
+        int r = 0;
+        struct buf buf = BUF_INITIALIZER;
+        json_t *jval = json_null();
+        if (!msg->_m) r = msgrecord_get_message(msg->mr, &msg->_m);
+        if (!r) r = message_get_field(msg->_m, "x-spam-score", MESSAGE_RAW, &buf);
+        if (!r && buf_len(&buf)) jval = json_real(atof(buf_cstring(&buf)));
+        json_object_set_new(email, "spamScore", jval);
+        buf_free(&buf);
+    }
+
+    if (jmap_wantprop(props, "snoozed")) {
+        struct email_get_snoozed_rock rock = { req, NULL };
+
+        /* Look for the first snoozed copy of this email_id */
+        conversations_guid_foreach(req->cstate, _guid_from_id(email_id),
+                                   _email_get_snoozed_cb, &rock);
+
+        json_object_set_new(email, "snoozed",
+                            rock.snoozed ? rock.snoozed : json_null());
+    }
+
+done:
+    return r;
+}
+
+static int _email_get_headers(jmap_req_t *req __attribute__((unused)),
+                              struct email_getargs *args,
+                              struct cyrusmsg *msg,
+                              json_t *email)
+{
+    int r = 0;
+    hash_table *props = args->props;
+
+    if (jmap_wantprop(props, "headers") || args->want_headers.count) {
+        /* headers */
+        if (jmap_wantprop(props, "headers")) {
+            struct headers *headers = NULL;
+            r = _cyrusmsg_get_headers(msg, NULL, &headers);
+            if (r) return r;
+            json_object_set(email, "headers", headers->raw); /* incref! */
+        }
+        /* headers:Xxx */
+        if (ptrarray_size(&args->want_headers)) {
+            int i;
+            for (i = 0; i < ptrarray_size(&args->want_headers); i++) {
+                struct header_prop *want_header = ptrarray_nth(&args->want_headers, i);
+                json_t *jheader = _email_get_header(msg, NULL, want_header->lcasename,
+                                      want_header->form, want_header->all);
+                json_object_set_new(email, want_header->prop, jheader);
+            }
+        }
+    }
+
+    /* references */
+    if (jmap_wantprop(props, "references")) {
+        json_t *references = _email_get_header(msg, NULL, "references",
+                                               HEADER_FORM_MESSAGEIDS,/*all*/0);
+        json_object_set_new(email, "references", references);
+    }
+    /* sender */
+    if (jmap_wantprop(props, "sender")) {
+        json_t *sender = _email_get_header(msg, NULL, "sender",
+                                           HEADER_FORM_ADDRESSES,/*all*/0);
+        json_object_set_new(email, "sender", sender);
+    }
+    /* replyTo */
+    if (jmap_wantprop(props, "replyTo")) {
+        json_t *replyTo = _email_get_header(msg, NULL, "reply-to",
+                                            HEADER_FORM_ADDRESSES, /*all*/0);
+        json_object_set_new(email, "replyTo", replyTo);
+    }
+
+    /* The following fields are all read from the body-part structure */
+    const struct body *part = NULL;
+    if (jmap_wantprop(props, "messageId") ||
+        jmap_wantprop(props, "inReplyTo") ||
+        jmap_wantprop(props, "from") ||
+        jmap_wantprop(props, "to") ||
+        jmap_wantprop(props, "cc") ||
+        jmap_wantprop(props, "bcc") ||
+        jmap_wantprop(props, "subject") ||
+        jmap_wantprop(props, "sentAt")) {
+        if (msg->rfc822part) {
+            part = msg->rfc822part->subpart;
+        }
+        else {
+            r = _cyrusmsg_need_part0(msg);
+            if (r) return r;
+            part = msg->part0;
+        }
+    }
+    /* messageId */
+    if (jmap_wantprop(props, "messageId")) {
+        json_object_set_new(email, "messageId",
+                _header_as_messageids(part->message_id, HEADER_FORM_MESSAGEIDS));
+    }
+    /* inReplyTo */
+    if (jmap_wantprop(props, "inReplyTo")) {
+        json_object_set_new(email, "inReplyTo",
+                _header_as_messageids(part->in_reply_to, HEADER_FORM_MESSAGEIDS));
+    }
+    /* from */
+    if (jmap_wantprop(props, "from")) {
+        json_object_set_new(email, "from",
+                _emailaddresses_from_addr(part->from, HEADER_FORM_ADDRESSES));
+    }
+    /* to */
+    if (jmap_wantprop(props, "to")) {
+        json_object_set_new(email, "to",
+                _emailaddresses_from_addr(part->to, HEADER_FORM_ADDRESSES));
+    }
+    /* cc */
+    if (jmap_wantprop(props, "cc")) {
+        json_object_set_new(email, "cc",
+                _emailaddresses_from_addr(part->cc, HEADER_FORM_ADDRESSES));
+    }
+    /* bcc */
+    if (jmap_wantprop(props, "bcc")) {
+        json_object_set_new(email, "bcc",
+                _emailaddresses_from_addr(part->bcc, HEADER_FORM_ADDRESSES));
+    }
+    /* subject */
+    if (jmap_wantprop(props, "subject")) {
+        json_object_set_new(email, "subject",
+                _header_as_text(part->subject, HEADER_FORM_TEXT));
+    }
+    /* sentAt */
+    if (jmap_wantprop(props, "sentAt")) {
+        json_t *jsent_at = json_null();
+        struct offsettime t;
+        if (offsettime_from_rfc5322(part->date, &t, DATETIME_FULL) != -1) {
+            char datestr[30];
+            offsettime_to_iso8601(&t, datestr, 30, 1);
+            jsent_at = json_string(datestr);
+        }
+        json_object_set_new(email, "sentAt", jsent_at);
+    }
+
+    return r;
+}
+
+static json_t *_email_get_bodypart(jmap_req_t *req,
+                                   struct email_getargs *args,
+                                   struct cyrusmsg *msg,
+                                   const struct body *part)
+{
+    struct buf buf = BUF_INITIALIZER;
+    struct param *param;
+
+    hash_table *bodyprops = args->bodyprops;
+    ptrarray_t *want_bodyheaders = &args->want_bodyheaders;
+
+    json_t *jbodypart = json_object();
+
+    /* partId */
+    if (jmap_wantprop(bodyprops, "partId")) {
+        json_t *jpart_id = json_null();
+        if (strcasecmp(part->type, "MULTIPART"))
+            jpart_id = json_string(part->part_id);
+        json_object_set_new(jbodypart, "partId", jpart_id);
+    }
+
+    /* blobId */
+    if (jmap_wantprop(bodyprops, "blobId")) {
+        json_t *jblob_id = json_null();
+        if (!message_guid_isnull(&part->content_guid)) {
+            char blob_id[JMAP_BLOBID_SIZE];
+            jmap_set_blobid(&part->content_guid, blob_id);
+            jblob_id = json_string(blob_id);
+        }
+        json_object_set_new(jbodypart, "blobId", jblob_id);
+    }
+
+    /* size */
+    if (jmap_wantprop(bodyprops, "size")) {
+        size_t size = 0;
+        if (part->numparts && strcasecmp(part->type, "MESSAGE")) {
+            /* Multipart */
+            size = 0;
+        }
+        else if (part->charset_enc & 0xff) {
+            if (part->decoded_content_size == 0) {
+                char *tmp = NULL;
+                size_t tmp_size;
+                int r = _cyrusmsg_need_mime(msg);
+                if (!r)  {
+                    charset_decode_mimebody(msg->mime->s + part->content_offset,
+                            part->content_size, part->charset_enc, &tmp, &tmp_size);
+                    size = tmp_size;
+                    free(tmp);
+                }
+            }
+            else {
+                size = part->decoded_content_size;
+            }
+        }
+        else {
+            size = part->content_size;
+        }
+        json_object_set_new(jbodypart, "size", json_integer(size));
+    }
+
+    /* headers */
+    if (jmap_wantprop(bodyprops, "headers") || want_bodyheaders->count) {
+        /* headers */
+        if (jmap_wantprop(bodyprops, "headers")) {
+            struct headers *headers = NULL;
+            int r = _cyrusmsg_get_headers(msg, part, &headers);
+            if (!r) {
+                json_object_set(jbodypart, "headers", headers->raw); /* incref! */
+            }
+            else {
+                json_object_set(jbodypart, "headers", json_null());
+            }
+        }
+        /* headers:Xxx */
+        if (ptrarray_size(want_bodyheaders)) {
+            int i;
+            for (i = 0; i < ptrarray_size(want_bodyheaders); i++) {
+                struct header_prop *want_header = ptrarray_nth(want_bodyheaders, i);
+                json_t *jheader = _email_get_header(msg, part, want_header->lcasename,
+                                                    want_header->form, want_header->all);
+                json_object_set_new(jbodypart, want_header->prop, jheader);
+            }
+        }
+    }
+
+    /* name */
+    if (jmap_wantprop(bodyprops, "name")) {
+        const char *fname = NULL;
+        char *val = NULL;
+        int is_extended = 0;
+
+        /* Lookup name parameter. Disposition header has precedence */
+        for (param = part->disposition_params; param; param = param->next) {
+            if (!strncasecmp(param->attribute, "filename", 8)) {
+                is_extended = param->attribute[8] == '*';
+                fname = param->value;
+                break;
+            }
+        }
+        /* Lookup Content-Type parameters */
+        if (!fname) {
+            for (param = part->params; param; param = param->next) {
+                if (!strncasecmp(param->attribute, "name", 4)) {
+                    is_extended = param->attribute[4] == '*';
+                    fname = param->value;
+                    break;
+                }
+            }
+        }
+
+        /* Decode header value */
+        if (fname && is_extended) {
+            val = charset_parse_mimexvalue(fname, NULL);
+        }
+        if (fname && !val) {
+            val = charset_parse_mimeheader(fname, CHARSET_KEEPCASE|CHARSET_MIME_UTF8);
+        }
+        json_object_set_new(jbodypart, "name", val ?
+                json_string(val) : json_null());
+        free(val);
+    }
+
+    /* type */
+    if (jmap_wantprop(bodyprops, "type")) {
+        buf_setcstr(&buf, part->type);
+        if (part->subtype) {
+            buf_appendcstr(&buf, "/");
+            buf_appendcstr(&buf, part->subtype);
+        }
+        json_object_set_new(jbodypart, "type", json_string(buf_lcase(&buf)));
+    }
+
+    /* charset */
+    if (jmap_wantprop(bodyprops, "charset")) {
+        json_t *jcharset = json_null();
+
+        if (msg->mr) {
+            int cache_version = 0;
+            msgrecord_get_cache_version(msg->mr, &cache_version);
+            if (cache_version >= 10) {
+                /* Read charset from bodystructure */
+                if (part->charset_id) {
+                    jcharset = json_string(part->charset_id);
+                }
+            }
+        }
+        if (json_is_null(jcharset)) {
+            /* Read charset from header */
+            json_t *jrawheader = _email_get_header(msg, part, "content-type",
+                                                   HEADER_FORM_RAW, /*all*/0);
+            if (JNOTNULL(jrawheader)) {
+                const char *hdr = json_string_value(jrawheader);
+                char *type = NULL;
+                char *subtype = NULL;
+                struct param *param = NULL;
+                message_parse_type(hdr, &type, &subtype, &param);
+                struct param *p;
+                for (p = param; p; p = p->next) {
+                    if (!strcasecmpsafe("charset", p->attribute)) {
+                        if (p->value) {
+                            struct buf buf = BUF_INITIALIZER;
+                            buf_setcstr(&buf, p->value);
+                            buf_trim(&buf);
+                            if (buf_len(&buf)) {
+                                jcharset = json_string(buf_cstring(&buf));
+                            }
+                            buf_free(&buf);
+                        }
+                    }
+                }
+                json_decref(jrawheader);
+                param_free(&param);
+                free(type);
+                free(subtype);
+            }
+        }
+        if (json_is_null(jcharset) && !strcasecmp(part->type, "TEXT")) {
+            /* Use default text charset */
+            jcharset = json_string("us-ascii");
+        }
+        json_object_set_new(jbodypart, "charset", jcharset);
+    }
+
+    /* disposition */
+    if (jmap_wantprop(bodyprops, "disposition")) {
+        json_t *jdisp = json_null();
+        if (part->disposition) {
+            char *disp = lcase(xstrdup(part->disposition));
+            jdisp = json_string(disp);
+            free(disp);
+        }
+        json_object_set_new(jbodypart, "disposition", jdisp);
+    }
+
+
+    /* cid */
+    if (jmap_wantprop(bodyprops, "cid")) {
+        json_t *jcid = _email_get_header(msg, part, "content-id",
+                                         HEADER_FORM_MESSAGEIDS, /*all*/0);
+        json_object_set(jbodypart, "cid", json_array_size(jcid) ?
+                json_array_get(jcid, 0) : json_null());
+        json_decref(jcid);
+    }
+
+
+    /* language */
+    if (jmap_wantprop(bodyprops, "language")) {
+        json_t *jlanguage = json_null();
+        json_t *jrawheader = _email_get_header(msg, part, "content-language",
+                                               HEADER_FORM_RAW, /*all*/0);
+        if (JNOTNULL(jrawheader)) {
+            /* Split by space and comma and aggregate into array */
+            const char *s = json_string_value(jrawheader);
+            jlanguage = json_array();
+            int i;
+            char *tmp = charset_unfold(s, strlen(s), 0);
+            strarray_t *ls = strarray_split(tmp, "\t ,", STRARRAY_TRIM);
+            for (i = 0; i < ls->count; i++) {
+                json_array_append_new(jlanguage, json_string(strarray_nth(ls, i)));
+            }
+            strarray_free(ls);
+            free(tmp);
+        }
+        if (!json_array_size(jlanguage)) {
+            json_decref(jlanguage);
+            jlanguage = json_null();
+        }
+        json_object_set_new(jbodypart, "language", jlanguage);
+        json_decref(jrawheader);
+    }
+
+
+    /* location */
+    if (jmap_wantprop(bodyprops, "location")) {
+        json_object_set_new(jbodypart, "location", part->location ?
+                json_string(part->location) : json_null());
+    }
+
+    /* subParts */
+    if (!strcmp(part->type, "MULTIPART")) {
+        json_t *subparts = json_array();
+        int i;
+        for (i = 0; i < part->numparts; i++) {
+            struct body *subpart = part->subpart + i;
+            json_array_append_new(subparts,
+                    _email_get_bodypart(req, args, msg, subpart));
+
+        }
+        json_object_set_new(jbodypart, "subParts", subparts);
+    }
+    else if (jmap_wantprop(bodyprops, "subParts")) {
+        json_object_set_new(jbodypart, "subParts", json_array());
+    }
+
+
+    /* FastMail extension properties */
+    if (jmap_wantprop(bodyprops, "imageSize")) {
+        json_t *imagesize = json_null();
+        if (msg->mr && msg->imagesize_by_part == NULL) {
+            /* This is the first attempt to read the vendor annotation.
+             * Load the annotation value, if any, for top-level messages.
+             * Use JSON null for an unsuccessful attempt, so we know not
+             * to try again. */
+            msg->imagesize_by_part = _email_read_jannot(req, msg->mr,
+                    "/vendor/messagingengine.com/imagesize", 1);
+            if (!msg->imagesize_by_part)
+                msg->imagesize_by_part = json_null();
+        }
+        imagesize = json_object_get(msg->imagesize_by_part, part->part_id);
+        json_object_set(jbodypart, "imageSize", imagesize ? imagesize : json_null());
+    }
+    if (jmap_wantprop(bodyprops, "isDeleted")) {
+        json_object_set_new(jbodypart, "isDeleted",
+                json_boolean(!strcmp(part->type, "TEXT") &&
+                             !strcmp(part->subtype, "X-ME-REMOVED-FILE")));
+    }
+
+    buf_free(&buf);
+    return jbodypart;
+}
+
+static json_t * _email_get_bodyvalue(struct body *part,
+                                     const struct buf *msg_buf,
+                                     size_t max_body_bytes,
+                                     int is_html)
+{
+    json_t *jbodyvalue = NULL;
+    int is_encoding_problem = 0;
+    int is_truncated = 0;
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Decode into UTF-8 buffer */
+    char *raw = _decode_to_utf8(part->charset_id,
+            msg_buf->s + part->content_offset,
+            part->content_size, part->encoding,
+            &is_encoding_problem);
+    if (!raw) goto done;
+
+    /* In-place remove CR characters from buffer */
+    size_t i, j, rawlen = strlen(raw);
+    for (i = 0, j = 0; j < rawlen; j++) {
+        if (raw[j] != '\r') raw[i++] = raw[j];
+    }
+    raw[i] = '\0';
+
+    /* Initialize return value */
+    buf_appendcstr(&buf, raw);
+    free(raw);
+
+    /* Truncate buffer */
+    if (buf_len(&buf) && max_body_bytes && max_body_bytes < buf_len(&buf)) {
+        /* Cut of excess bytes */
+        buf_truncate(&buf, max_body_bytes);
+        is_truncated = 1;
+        /* Clip to sane UTF-8 */
+        /* XXX do not split between combining characters */
+        const unsigned char *base = (unsigned char *) buf_base(&buf);
+        const unsigned char *top = base + buf_len(&buf);
+        const unsigned char *p = top - 1;
+        while (p >= base && ((*p & 0xc0) == 0x80))
+            p--;
+        if (p >= base) {
+            ssize_t have_bytes = top - p;
+            ssize_t need_bytes = 0;
+            unsigned char hi_nibble = *p & 0xf0;
+            switch (hi_nibble) {
+                case 0xf0:
+                    need_bytes = 4;
+                    break;
+                case 0xe0:
+                    need_bytes = 3;
+                    break;
+                case 0xc0:
+                    need_bytes = 2;
+                    break;
+                default:
+                    need_bytes = 1;
+            }
+            if (have_bytes < need_bytes)
+                buf_truncate(&buf, p - base);
+        }
+        else {
+            buf_reset(&buf);
+        }
+    }
+
+    /* Truncate HTML */
+    if (buf_len(&buf) && max_body_bytes && is_html) {
+        /* Truncate any trailing '<' start tag character without closing '>' */
+        const char *base = buf_base(&buf);
+        const char *top  = base + buf_len(&buf);
+        const char *p;
+        for (p = top - 1; *p != '>' && p >= base; p--) {
+            if (*p == '<') {
+                buf_truncate(&buf, p - base + 1);
+                is_truncated = 1;
+                break;
+            }
+        }
+    }
+
+done:
+    jbodyvalue = json_pack("{s:s s:b s:b}",
+            "value", buf_cstring(&buf),
+            "isEncodingProblem", is_encoding_problem,
+            "isTruncated", is_truncated);
+    buf_free(&buf);
+    return jbodyvalue;
+}
+
+static int _email_get_bodies(jmap_req_t *req,
+                             struct email_getargs *args,
+                             struct cyrusmsg *msg,
+                             json_t *email)
+{
+    struct emailbodies bodies = EMAILBODIES_INITIALIZER;
+    hash_table *props = args->props;
+    int r = 0;
+
+    const struct body *part;
+    if (msg->rfc822part) {
+        part = msg->rfc822part->subpart;
+    }
+    else {
+        r = _cyrusmsg_need_part0(msg);
+        if (r) return r;
+        part =  msg->part0;
+    }
+
+    /* Dissect message into its parts */
+    r = jmap_emailbodies_extract(part, &bodies);
+    if (r) goto done;
+
+    /* bodyStructure */
+    if (jmap_wantprop(props, "bodyStructure")) {
+        json_object_set_new(email, "bodyStructure",
+                _email_get_bodypart(req, args, msg, part));
+    }
+
+    /* bodyValues */
+    if (jmap_wantprop(props, "bodyValues")) {
+        json_t *body_values = json_object();
+        /* Determine which body value parts to fetch */
+        int i;
+        ptrarray_t parts = PTRARRAY_INITIALIZER;
+        if (args->fetch_text_body || args->fetch_all_body) {
+            for (i = 0; i < bodies.textlist.count; i++)
+                ptrarray_append(&parts, ptrarray_nth(&bodies.textlist, i));
+        }
+        if (args->fetch_html_body || args->fetch_all_body) {
+            for (i = 0; i < bodies.htmllist.count; i++)
+                ptrarray_append(&parts, ptrarray_nth(&bodies.htmllist, i));
+        }
+        if (args->fetch_all_body) {
+            for (i = 0; i < bodies.attslist.count; i++) {
+                struct body *part = ptrarray_nth(&bodies.attslist, i);
+                if (!strcmpsafe(part->type, "TEXT")) {
+                    /* we weed out duplicate parts later */
+                    ptrarray_append(&parts, ptrarray_nth(&bodies.attslist, i));
+                }
+            }
+        }
+        if (parts.count) {
+            r = _cyrusmsg_need_mime(msg);
+            if (r) goto done;
+        }
+        /* Fetch body values */
+        for (i = 0; i < parts.count; i++) {
+            struct body *part = ptrarray_nth(&parts, i);
+            if (strcmp("TEXT", part->type)) {
+                continue;
+            }
+            /* Ignore duplicate list entries */
+            if (part->part_id && json_object_get(body_values, part->part_id)) {
+                continue;
+            }
+            json_object_set_new(body_values, part->part_id,
+                    _email_get_bodyvalue(part, msg->mime, args->max_body_bytes,
+                                         !strcmp("HTML", part->subtype)));
+        }
+        ptrarray_fini(&parts);
+        json_object_set_new(email, "bodyValues", body_values);
+    }
+
+    /* textBody */
+    if (jmap_wantprop(props, "textBody")) {
+        json_t *text_body = json_array();
+        int i;
+        for (i = 0; i < bodies.textlist.count; i++) {
+            struct body *part = ptrarray_nth(&bodies.textlist, i);
+            json_array_append_new(text_body,
+                    _email_get_bodypart(req, args, msg, part));
+        }
+        json_object_set_new(email, "textBody", text_body);
+    }
+
+    /* htmlBody */
+    if (jmap_wantprop(props, "htmlBody")) {
+        json_t *html_body = json_array();
+        int i;
+        for (i = 0; i < bodies.htmllist.count; i++) {
+            struct body *part = ptrarray_nth(&bodies.htmllist, i);
+            json_array_append_new(html_body,
+                    _email_get_bodypart(req, args, msg, part));
+        }
+        json_object_set_new(email, "htmlBody", html_body);
+    }
+
+    /* attachments */
+    if (jmap_wantprop(props, "attachments")) {
+        json_t *attachments = json_array();
+        int i;
+        for (i = 0; i < bodies.attslist.count; i++) {
+            struct body *part = ptrarray_nth(&bodies.attslist, i);
+            json_array_append_new(attachments,
+                    _email_get_bodypart(req, args, msg, part));
+        }
+        json_object_set_new(email, "attachments", attachments);
+    }
+
+    /* calendarEvents -- non-standard */
+    if (jmap_wantprop(props, "calendarEvents")) {
+        json_t *calendar_events = json_object();
+        int i;
+        for (i = 0; i < bodies.attslist.count; i++) {
+            struct body *part = ptrarray_nth(&bodies.attslist, i);
+            /* Process text/calendar attachments and files ending with .ics */
+            if (strcmp(part->type, "TEXT") || strcmp(part->subtype, "CALENDAR")) {
+                int has_ics_attachment = 0;
+                struct param *param = part->disposition_params;
+                while (param) {
+                    if (!strcasecmp(param->attribute, "FILENAME")) {
+                        size_t len = strlen(param->value);
+                        if (len > 4 && !strcasecmp(param->value + len-4, ".ICS")) {
+                            has_ics_attachment = 1;
+                        }
+                    }
+                    param = param->next;
+                }
+                if (!has_ics_attachment)
+                    continue;
+            }
+            /* Parse decoded data to iCalendar object */
+            r = _cyrusmsg_need_mime(msg);
+            if (r) goto done;
+            char *decbuf = NULL;
+            size_t declen = 0;
+            const char *rawical = charset_decode_mimebody(msg->mime->s + part->content_offset,
+                    part->content_size, part->charset_enc, &decbuf, &declen);
+            if (!rawical) continue;
+            struct buf buf = BUF_INITIALIZER;
+            buf_setmap(&buf, rawical, declen);
+            icalcomponent *ical = ical_string_as_icalcomponent(&buf);
+            buf_free(&buf);
+            free(decbuf);
+            if (!ical) continue;
+            /* Parse iCalendar object to JSCalendar */
+            json_t *jsevents = jmapical_tojmap_all(ical, NULL);
+            if (json_array_size(jsevents)) {
+                json_object_set_new(calendar_events, part->part_id, jsevents);
+            }
+            icalcomponent_free(ical);
+        }
+        if (!json_object_size(calendar_events)) {
+            json_decref(calendar_events);
+            calendar_events = json_null();
+        }
+        json_object_set_new(email, "calendarEvents", calendar_events);
+    }
+
+    /* hasAttachment */
+    if (jmap_wantprop(props, "hasAttachment")) {
+        int has_att = 0;
+        if (msg->rfc822part == NULL) {
+            msgrecord_hasflag(msg->mr, JMAP_HAS_ATTACHMENT_FLAG, &has_att);
+        }
+        else {
+            has_att = bodies.attslist.count > 0;
+        }
+        json_object_set_new(email, "hasAttachment", json_boolean(has_att));
+    }
+
+    /* preview */
+    if (jmap_wantprop(props, "preview")) {
+        const char *preview_annot = config_getstring(IMAPOPT_JMAP_PREVIEW_ANNOT);
+        if (preview_annot && msg->rfc822part == NULL) {
+            json_t *preview = _email_read_jannot(req, msg->mr, preview_annot, /*structured*/0);
+            json_object_set_new(email, "preview", preview ? preview : json_string(""));
+        }
+        else {
+            r = _cyrusmsg_need_mime(msg);
+            if (r) goto done;
+            /* TODO optimise for up to PREVIEW_LEN bytes */
+            char *text = _emailbodies_to_plain(&bodies, msg->mime);
+            if (!text) {
+                char *html = _emailbodies_to_html(&bodies, msg->mime);
+                if (html) text = _html_to_plain(html);
+                free(html);
+            }
+            if (text) {
+                size_t len = config_getint(IMAPOPT_JMAP_PREVIEW_LENGTH);
+                char *preview = _email_extract_preview(text, len);
+                json_object_set_new(email, "preview", json_string(preview));
+                free(preview);
+                free(text);
+            }
+        }
+    }
+
+done:
+    jmap_emailbodies_fini(&bodies);
+    return r;
+}
+
+static int _email_from_msg(jmap_req_t *req,
+                           struct email_getargs *args,
+                           struct cyrusmsg *msg,
+                           json_t **emailptr)
+{
+    json_t *email = json_object();
+    int r = 0;
+
+    r = _email_get_meta(req, args, msg, email);
+    if (r) goto done;
+
+    r = _email_get_headers(req, args, msg, email);
+    if (r) goto done;
+
+    r = _email_get_bodies(req, args, msg, email);
+    if (r) goto done;
+
+    *emailptr = email;
+done:
+
+    if (r) json_decref(email);
+    return r;
+}
+
+
+static int _email_from_record(jmap_req_t *req,
+                              struct email_getargs *args,
+                              msgrecord_t *mr,
+                              json_t **emailptr)
+{
+    struct cyrusmsg *msg = NULL;
+    int r = _cyrusmsg_from_record(mr, &msg);
+    if (!r) r = _email_from_msg(req, args, msg, emailptr);
+    _cyrusmsg_free(&msg);
+    return r;
+}
+
+static int _email_from_rfc822body(jmap_req_t *req,
+                                  struct email_getargs *args,
+                                  msgrecord_t *mr,
+                                  const struct body *body,
+                                  json_t **emailptr)
+{
+    struct cyrusmsg *msg = NULL;
+    int r = _cyrusmsg_from_rfc822body(mr, body, &msg);
+    if (!r) r = _email_from_msg(req, args, msg, emailptr);
+    _cyrusmsg_free(&msg);
+    return r;
+}
+
+static int _email_from_buf(jmap_req_t *req,
+                           struct email_getargs *args,
+                           const struct buf *buf,
+                           const char *encoding,
+                           json_t **emailptr)
+{
+    struct buf mybuf = BUF_INITIALIZER;
+    buf_setcstr(&mybuf, "Content-Type: message/rfc822\r\n");
+    if (encoding) {
+        if (!strcasecmp(encoding, "BASE64")) {
+            char *tmp = NULL;
+            size_t tmp_size = 0;
+            charset_decode_mimebody(buf_base(buf), buf_len(buf),
+                    ENCODING_BASE64, &tmp, &tmp_size);
+            buf_appendcstr(&mybuf, "Content-Transfer-Encoding: binary\r\n");
+            /* Append base64-decoded body */
+            buf_appendcstr(&mybuf, "\r\n");
+            buf_appendmap(&mybuf, tmp, tmp_size);
+            free(tmp);
+        }
+        else {
+            buf_appendcstr(&mybuf, "Content-Transfer-Encoding: ");
+            buf_appendcstr(&mybuf, encoding);
+            buf_appendcstr(&mybuf, "\r\n");
+            /* Append encoded body */
+            buf_appendcstr(&mybuf, "\r\n");
+            buf_append(&mybuf, buf);
+        }
+    }
+    else {
+        /* Append raw body */
+        buf_appendcstr(&mybuf, "\r\n");
+        buf_append(&mybuf, buf);
+    }
+
+    struct cyrusmsg *msg = NULL;
+    int r = _cyrusmsg_from_buf(&mybuf, &msg);
+    if (!r) r = _email_from_msg(req, args, msg, emailptr);
+    buf_free(&mybuf);
+    _cyrusmsg_free(&msg);
+    return r;
+}
+
+HIDDEN int jmap_email_get_with_props(jmap_req_t *req,
+                                     hash_table *props,
+                                     msgrecord_t *mr,
+                                     json_t **msgp)
+{
+    struct email_getargs args = _EMAIL_GET_ARGS_INITIALIZER;
+    args.props = props;
+    int r = _email_from_record(req, &args, mr, msgp);
+    args.props = NULL;
+    _email_getargs_fini(&args);
+    return r;
+}
+
+static int _isthreadsonly(json_t *jargs)
+{
+    json_t *arg = json_object_get(jargs, "properties");
+    if (!json_is_array(arg)) return 0;
+    if (json_array_size(arg) != 1) return 0;
+    const char *s = json_string_value(json_array_get(arg, 0));
+    if (strcmpsafe(s, "threadId")) return 0;
+    return 1;
+}
+
+static void jmap_email_get_threadsonly(jmap_req_t *req, struct jmap_get *get)
+{
+    size_t i;
+    json_t *val;
+    json_array_foreach(get->ids, i, val) {
+        const char *id = json_string_value(val);
+        conversation_id_t cid = 0;
+
+        int r = _email_get_cid(req, id, &cid);
+        if (!r && cid) {
+            char thread_id[JMAP_THREADID_SIZE];
+            jmap_set_threadid(cid, thread_id);
+            json_t *msg = json_pack("{s:s, s:s}", "id", id, "threadId", thread_id);
+            json_array_append_new(get->list, msg);
+        }
+        else {
+            json_array_append_new(get->not_found, json_string(id));
+        }
+        if (r) {
+            syslog(LOG_ERR, "jmap: Email/get(%s): %s", id, error_message(r));
+        }
+    }
+}
+
+struct _warmup_mboxcache_cb_rock {
+    jmap_req_t *req;
+    ptrarray_t mboxes;
+};
+
+static int _warmup_mboxcache_cb(const conv_guidrec_t *rec, void* vrock)
+{
+    struct _warmup_mboxcache_cb_rock *rock = vrock;
+    int i;
+    for (i = 0; i < ptrarray_size(&rock->mboxes); i++) {
+        struct mailbox *mbox = ptrarray_nth(&rock->mboxes, i);
+        if (!strcmp(rec->mboxname, mbox->name)) {
+            return 0;
+        }
+    }
+    struct mailbox *mbox = NULL;
+    int r = jmap_openmbox(rock->req, rec->mboxname, &mbox, /*rw*/0);
+    if (!r) {
+        ptrarray_append(&rock->mboxes, mbox);
+    }
+    return r;
+}
+
+static void jmap_email_get_full(jmap_req_t *req, struct jmap_get *get, struct email_getargs *args)
+{
+    size_t i;
+    json_t *val;
+
+    /* Warm up the mailbox cache by opening all mailboxes */
+    struct _warmup_mboxcache_cb_rock rock = { req, PTRARRAY_INITIALIZER };
+    json_array_foreach(get->ids, i, val) {
+        const char *email_id = json_string_value(val);
+        if (email_id[0] != 'M' || strlen(email_id) != 25) {
+            continue;
+        }
+        int r = conversations_guid_foreach(req->cstate, _guid_from_id(email_id),
+                                           _warmup_mboxcache_cb, &rock);
+        if (r) {
+            /* Ignore errors, they'll be handled in email_find */
+            syslog(LOG_WARNING, "__warmup_mboxcache_cb(%s): %s", email_id, error_message(r));
+            continue;
+        }
+    }
+
+    /* Process emails one after the other */
+    json_array_foreach(get->ids, i, val) {
+        const char *id = json_string_value(val);
+        char *mboxname = NULL;
+        msgrecord_t *mr = NULL;
+        json_t *msg = NULL;
+        struct mailbox *mbox = NULL;
+
+        uint32_t uid;
+        int r = jmap_email_find(req, id, &mboxname, &uid);
+        if (!r) {
+            r = jmap_openmbox(req, mboxname, &mbox, 0);
+            if (!r) {
+                r = msgrecord_find(mbox, uid, &mr);
+                if (!r) {
+                    r = _email_from_record(req, args, mr, &msg);
+                }
+                jmap_closembox(req, &mbox);
+            }
+        }
+        if (!r && msg) {
+            json_array_append_new(get->list, msg);
+        }
+        else {
+            json_array_append_new(get->not_found, json_string(id));
+        }
+        if (r) {
+            syslog(LOG_ERR, "jmap: Email/get(%s): %s", id, error_message(r));
+        }
+
+        free(mboxname);
+        msgrecord_unref(&mr);
+    }
+
+    /* Close cached mailboxes */
+    struct mailbox *mbox = NULL;
+    while ((mbox = ptrarray_pop(&rock.mboxes))) {
+        jmap_closembox(req, &mbox);
+    }
+    ptrarray_fini(&rock.mboxes);
+}
+
+static const jmap_property_t email_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "blobId",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "threadId",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "mailboxIds",
+        NULL,
+        0
+    },
+    {
+        "keywords",
+        NULL,
+        0
+    },
+    {
+        "size",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "receivedAt",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "headers",
+        NULL,
+        JMAP_PROP_IMMUTABLE | JMAP_PROP_SKIP_GET
+    },
+    {
+        "header:*",
+        NULL,
+        JMAP_PROP_IMMUTABLE | JMAP_PROP_SKIP_GET
+    },
+    {
+        "messageId",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "inReplyTo",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "references",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "sender",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "from",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "to",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "cc",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "bcc",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "replyTo",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "subject",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "sentAt",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "bodyStructure",
+        NULL,
+        JMAP_PROP_IMMUTABLE | JMAP_PROP_SKIP_GET
+    },
+    {
+        "bodyValues",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "textBody",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "htmlBody",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "attachments",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "hasAttachment",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "preview",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+
+    /* FM extensions (do ALL of these get through to Cyrus?) */
+    {
+        "addedDates",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "removedDates",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "trustedSender",
+        JMAP_MAIL_EXTENSION,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "spamScore",
+        JMAP_MAIL_EXTENSION,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "calendarEvents",
+        JMAP_MAIL_EXTENSION,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "isDeleted",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "imageSize",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "snoozed",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_email_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    struct email_getargs args = _EMAIL_GET_ARGS_INITIALIZER;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, email_props, /*allow_null_ids*/0,
+                   &_email_getargs_parse, &args, &get, &err);
+    if (!err) {
+        /* header:Xxx properties */
+        json_t *jprops = json_object_get(req->args, "properties");
+        if (JNOTNULL(jprops)) {
+            _email_parse_wantheaders(jprops, &parser, "properties",
+                                     &args.want_headers);
+        }
+
+        if (json_array_size(parser.invalid)) {
+            err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                            "arguments", parser.invalid);
+        }
+    }
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* properties - already parsed in jmap_get_parse */
+    args.props = get.props;
+
+    /* Set default body properties, if not set by client */
+    if (args.bodyprops == NULL) {
+        args.bodyprops = &_email_get_default_bodyprops;
+
+        if (args.bodyprops->size == 0) {
+            _email_init_default_props(args.bodyprops);
+        }
+    }
+
+    if (_isthreadsonly(req->args))
+        jmap_email_get_threadsonly(req, &get);
+    else
+        jmap_email_get_full(req, &get, &args);
+
+    json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/0);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    _email_getargs_fini(&args);
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
+
+static int jmap_email_parse(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct email_getargs getargs = _EMAIL_GET_ARGS_INITIALIZER;
+    const char *key;
+    json_t *arg, *jblobIds = NULL;
+    hash_table *props = NULL;
+
+    /* Parse request */
+    json_object_foreach(req->args, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        else if (!strcmp(key, "blobIds")) {
+            jblobIds = arg;
+            jmap_parse_strings(jblobIds, &parser, "blobIds");
+        }
+
+        else if (!strcmp(key, "properties")) {
+            if (json_is_array(arg)) {
+                size_t i;
+                json_t *val;
+                props = xzmalloc(sizeof(hash_table));
+                construct_hash_table(props, json_array_size(arg) + 1, 0);
+                json_array_foreach(arg, i, val) {
+                    const char *s = json_string_value(val);
+                    if (!s) {
+                        jmap_parser_push_index(&parser, "properties", i, s);
+                        jmap_parser_invalid(&parser, NULL);
+                        jmap_parser_pop(&parser);
+                        continue;
+                    }
+                    hash_insert(s, (void*)1, props);
+                }
+                getargs.props = props;
+            }
+            else if (JNOTNULL(arg)) {
+                jmap_parser_invalid(&parser, "properties");
+            }
+        }
+
+        else if (!_email_getargs_parse(req, &parser, key, arg, &getargs)) {
+            jmap_parser_invalid(&parser, key);
+        }
+    }
+
+    if (json_array_size(parser.invalid)) {
+        json_t *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                                "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Set default properties, if not set by client */
+    if (getargs.props == NULL) {
+        getargs.props = &_email_parse_default_props;
+
+        if (getargs.props->size == 0) {
+            _email_init_default_props(getargs.props);
+        }
+    }
+
+    /* Set default body properties, if not set by client */
+    if (getargs.bodyprops == NULL) {
+        getargs.bodyprops = &_email_get_default_bodyprops;
+
+        if (getargs.bodyprops->size == 0) {
+            _email_init_default_props(getargs.bodyprops);
+        }
+    }
+
+    /* Process request */
+    json_t *parsed = json_object();
+    json_t *notParsable = json_array();
+    json_t *notFound = json_array();
+    json_t *jval;
+    size_t i;
+    json_array_foreach(jblobIds, i, jval) {
+        const char *blobid = json_string_value(jval);
+        struct mailbox *mbox = NULL;
+        msgrecord_t *mr = NULL;
+        struct body *body = NULL;
+        const struct body *part = NULL;
+
+        int r = jmap_findblob(req, NULL/*accountid*/, blobid,
+                              &mbox, &mr, &body, &part, NULL);
+        if (r) {
+            json_array_append_new(notFound, json_string(blobid));
+            continue;
+        }
+
+        json_t *email = NULL;
+        if (part && (strcmp(part->type, "MESSAGE") || !strcmpnull(part->encoding, "BASE64"))) {
+            struct buf msg_buf = BUF_INITIALIZER;
+            r = msgrecord_get_body(mr, &msg_buf);
+            if (!r) {
+                struct buf buf = BUF_INITIALIZER;
+                buf_init_ro(&buf, buf_base(&msg_buf) + part->content_offset,
+                        part->content_size);
+                r = _email_from_buf(req, &getargs, &buf, part->encoding, &email);
+                buf_free(&buf);
+            }
+            buf_free(&msg_buf);
+            if (r) {
+                syslog(LOG_ERR, "jmap: Email/parse(%s): %s", blobid, error_message(r));
+            }
+        }
+        else if (part) {
+            _email_from_rfc822body(req, &getargs, mr, part, &email);
+        }
+        else if (body) {
+            _email_from_record(req, &getargs, mr, &email);
+        }
+
+        if (email) {
+            json_object_set_new(parsed, blobid, email);
+        }
+        else {
+            json_array_append_new(notParsable, json_string(blobid));
+        }
+        msgrecord_unref(&mr);
+        jmap_closembox(req, &mbox);
+        message_free_body(body);
+        free(body);
+    }
+
+    /* Build response */
+    json_t *res = json_object();
+    if (!json_object_size(parsed)) {
+        json_decref(parsed);
+        parsed = json_null();
+    }
+    if (!json_array_size(notParsable)) {
+        json_decref(notParsable);
+        notParsable = json_null();
+    }
+    if (!json_array_size(notFound)) {
+        json_decref(notFound);
+        notFound = json_null();
+    }
+    json_object_set_new(res, "parsed", parsed);
+    json_object_set_new(res, "notParsable", notParsable);
+    json_object_set_new(res, "notFound", notFound);
+    jmap_ok(req, res);
+
+done:
+	_email_getargs_fini(&getargs);
+    jmap_parser_fini(&parser);
+    free_hash_table(props, NULL);
+    free(props);
+    return 0;
+}
+
+static char *_mime_make_boundary()
+{
+    char *boundary, *p, *q;
+
+    boundary = xstrdup(makeuuid());
+    for (p = boundary, q = boundary; *p; p++) {
+        if (*p != '-') *q++ = *p;
+    }
+    *q = 0;
+
+    return boundary;
+}
+
+/* A soft limit for MIME header lengths when generating MIME from JMAP.
+ * See the header_from_Xxx functions for usage. */
+#define MIME_MAX_HEADER_LENGTH 78
+
+const char QSTRINGCHAR[256] = {
+/* control chars 9 (TAB), 10 (LF), 13 (CR) and space (32)
+ * are not permitted, all other control characters obsolete */
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+/* All printable ASCII characters (decimal values between 33 and 126) */
+/* are safe to use in quoted string. 1=use verbatim, 2=escape */
+/* XXX 32 (space) is allowed here, as most MUAs expect that */
+    1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0,
+/* all high bits are unsafe */
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+static void _mime_write_xparam(struct buf *buf, const char *name, const char *value)
+{
+    /* Encode header value */
+    struct buf valbuf = BUF_INITIALIZER;
+    int is_qstring = 1;
+    const char *p;
+    for (p = value; *p && is_qstring; p++) {
+        switch (QSTRINGCHAR[(unsigned char)*p]) {
+            case 0:
+                is_qstring = 0;
+                break;
+            case 2:
+                buf_putc(&valbuf, '\\');
+                /* fall through */
+            default:
+                buf_putc(&valbuf, *p);
+        }
+    }
+    char *xvalue = is_qstring ? buf_release(&valbuf) : charset_encode_mimexvalue(value, NULL);
+
+    /* Attempt to stuff header in one line */
+    if (strlen(name) + strlen(xvalue) + 1 < MIME_MAX_HEADER_LENGTH) {
+        if (is_qstring)
+            buf_printf(buf, ";%s=\"%s\"", name, xvalue);
+        else
+            buf_printf(buf, ";%s*=%s", name, xvalue);
+        goto done;
+    }
+
+    /* Break value into continuations */
+    int section = 0;
+    p = xvalue;
+    struct buf line = BUF_INITIALIZER;
+    buf_appendcstr(&line, ";\r\n ");
+    while (*p) {
+        /* Build parameter continuation line. */
+        buf_printf(&line, "%s*%d*=", name, section);
+        /* Write at least one character of the value */
+        if (is_qstring)
+            buf_putc(&line, '"');
+        int n = buf_len(&line) + 1;
+        do {
+            buf_putc(&line, *p);
+            n++;
+            p++;
+            if (!is_qstring && *p == '%' && n >= MIME_MAX_HEADER_LENGTH - 2)
+                break;
+        } while (*p && n < MIME_MAX_HEADER_LENGTH);
+        if (is_qstring)
+            buf_putc(&line, '"');
+        /* Write line */
+        buf_append(buf, &line);
+        /* Prepare next iteration */
+        if (*p) buf_appendcstr(buf, ";\r\n ");
+        buf_reset(&line);
+        section++;
+    }
+    buf_free(&line);
+
+done:
+    buf_free(&valbuf);
+    free(xvalue);
+}
+
+static int _copy_msgrecords(struct auth_state *authstate,
+                            const char *user_id,
+                            struct namespace *namespace,
+                            struct mailbox *src,
+                            struct mailbox *dst,
+                            ptrarray_t *msgrecs)
+{
+    struct appendstate as;
+    int r;
+    int nolink = !config_getswitch(IMAPOPT_SINGLEINSTANCESTORE);
+
+    r = append_setup_mbox(&as, dst, user_id, authstate,
+            ACL_INSERT, NULL, namespace, 0, EVENT_MESSAGE_COPY);
+    if (r) goto done;
+
+    r = append_copy(src, &as, msgrecs, nolink,
+                    mboxname_same_userid(src->name, dst->name));
+    if (r) {
+        append_abort(&as);
+        goto done;
+    }
+
+    r = append_commit(&as);
+    if (r) goto done;
+
+    sync_log_mailbox_double(src->name, dst->name);
+done:
+    return r;
+}
+
+static int _copy_msgrecord(struct auth_state *authstate,
+                           const char *user_id,
+                           struct namespace *namespace,
+                           struct mailbox *src,
+                           struct mailbox *dst,
+                           msgrecord_t *mrw)
+{
+
+    if (!strcmp(src->uniqueid, dst->uniqueid))
+        return 0;
+
+    ptrarray_t msgrecs = PTRARRAY_INITIALIZER;
+    ptrarray_add(&msgrecs, mrw);
+    int r = _copy_msgrecords(authstate, user_id, namespace, src, dst, &msgrecs);
+    ptrarray_fini(&msgrecs);
+    return r;
+}
+
+/* A subset of all messages within an IMAP mailbox. */
+struct email_mboxrec {
+    char *mboxname;     /* IMAP mailbox name */
+    char *mbox_id;      /* Cyrus-internal unique mailbox id */
+    ptrarray_t uidrecs; /* Array of struct email_uidrec */
+};
+
+/* A single mailboxname/UID pair of the JMAP email identified by
+ * email_id. Each email has 1 or more uid records, but uid
+ * records may represent expunged messages. */
+struct email_uidrec {
+    struct email_mboxrec *mboxrec; /* owning mailboxrec */
+    char *email_id;                /* JMAP email id */
+    uint32_t uid;                  /* IMAP uid in mbox */
+    int is_new;                    /* Used by Email/set{update} */
+    int is_snoozed;                /* Used by Email/set{update} */
+};
+
+static void _email_multiexpunge(jmap_req_t *req, struct mailbox *mbox,
+                                ptrarray_t *uidrecs, json_t *errors)
+{
+    int r;
+    struct mboxevent *mboxevent = NULL;
+    msgrecord_t *mrw = NULL;
+    uint32_t system_flags, internal_flags;
+
+    mboxevent = mboxevent_new(EVENT_MESSAGE_EXPUNGE);
+
+    int j;
+    int didsome = 0;
+    for (j = 0; j < ptrarray_size(uidrecs); j++) {
+        struct email_uidrec *uidrec = ptrarray_nth(uidrecs, j);
+        // skip known errors
+        if (json_object_get(errors, uidrec->email_id)) {
+             continue;
+        }
+        // load the record
+        if (mrw) msgrecord_unref(&mrw);
+        r = msgrecord_find(mbox, uidrec->uid, &mrw);
+        if (!r) r = msgrecord_get_systemflags(mrw, &system_flags);
+        if (!r) r = msgrecord_get_internalflags(mrw, &internal_flags);
+        // already expunged, skip (aka: will be reported as success)
+        if (internal_flags & FLAG_INTERNAL_EXPUNGED) continue;
+        // update the flags
+        if (!r) r = msgrecord_add_systemflags(mrw, FLAG_DELETED);
+        if (!r) r = msgrecord_add_internalflags(mrw, FLAG_INTERNAL_EXPUNGED);
+        if (!r) r = msgrecord_rewrite(mrw);
+        if (!r) {
+            mboxevent_extract_msgrecord(mboxevent, mrw);
+            didsome++;
+        }
+        // if errors, record the issue
+        if (r) json_object_set_new(errors, uidrec->email_id, jmap_server_error(r));
+    }
+    if (mrw) msgrecord_unref(&mrw);
+
+    /* Report mailbox event if anything to say */
+    if (didsome) {
+        mboxevent_extract_mailbox(mboxevent, mbox);
+        mboxevent_set_numunseen(mboxevent, mbox, -1);
+        mboxevent_set_access(mboxevent, NULL, NULL, req->userid, mbox->name, 0);
+        mboxevent_notify(&mboxevent);
+    }
+    mboxevent_free(&mboxevent);
+}
+
+struct email_append_detail {
+    char blob_id[JMAP_BLOBID_SIZE];
+    char email_id[JMAP_EMAILID_SIZE];
+    char thread_id[JMAP_THREADID_SIZE];
+    size_t size;
+};
+
+static void _email_append(jmap_req_t *req,
+                          json_t *mailboxids,
+                          strarray_t *keywords,
+                          time_t internaldate,
+                          json_t *snoozed,
+                          int has_attachment,
+                          const char *sourcefile,
+                          int(*writecb)(jmap_req_t* req, FILE* fp, void* rock, json_t **err),
+                          void *rock,
+                          struct email_append_detail *detail,
+                          json_t **err)
+{
+    int fd;
+    void *addr;
+    FILE *f = NULL;
+    char *mboxname = NULL, *last = NULL;
+    const char *id;
+    struct stagemsg *stage = NULL;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_INITIALIZER;
+    json_t *val, *mailboxes = NULL;
+    size_t len;
+    int r = 0;
+    time_t savedate = 0;
+
+    if (json_object_size(mailboxids) > JMAP_MAIL_MAX_MAILBOXES_PER_EMAIL) {
+        *err = json_pack("{s:s}", "type", "tooManyMailboxes");
+        goto done;
+    }
+    else if (strarray_size(keywords) > JMAP_MAIL_MAX_KEYWORDS_PER_EMAIL) {
+        *err = json_pack("{s:s}", "type", "tooManyKeywords");
+        goto done;
+    }
+
+    if (!internaldate) internaldate = time(NULL);
+
+    /* Pick the mailbox to create the message in, prefer \Snoozed then \Drafts */
+    mailboxes = json_pack("{}"); /* maps mailbox ids to mboxnames */
+    json_object_foreach(mailboxids, id, val) {
+        const char *mboxid = id;
+        /* Lookup mailbox */
+        if (mboxid && mboxid[0] == '#') {
+            mboxid = jmap_lookup_id(req, mboxid + 1);
+        }
+        if (!mboxid) continue;
+        const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mboxid);
+        if (!mbentry || !jmap_hasrights(req, mbentry, ACL_LOOKUP)) {
+            r = IMAP_MAILBOX_NONEXISTENT;
+            goto done;
+        }
+
+        /* Convert intermediary mailbox to real mailbox */
+        if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+            r = mboxlist_promote_intermediary(mbentry->name);
+            if (r) goto done;
+        }
+
+        if (json_is_string(val)) {
+            /* We flagged this mailboxId as the $snoozed mailbox */
+            if (mboxname) free(mboxname);
+            mboxname = xstrdup(mbentry->name);
+        }
+        else if (!mboxname) {
+            mbname_t *mbname = mbname_from_intname(mbentry->name);
+
+            /* Is this the draft mailbox? */
+            struct buf buf = BUF_INITIALIZER;
+            annotatemore_lookup(mbname_intname(mbname), "/specialuse",
+                                req->accountid, &buf);
+            if (buf.len) {
+                strarray_t *uses = strarray_split(buf_cstring(&buf), " ", STRARRAY_TRIM);
+                if (strarray_find_case(uses, "\\Drafts", 0)) {
+                    if (mboxname) free(mboxname);
+                    mboxname = xstrdup(mbentry->name);
+                }
+                strarray_free(uses);
+            }
+            buf_free(&buf);
+            mbname_free(&mbname);
+        }
+
+        /* If we haven't picked a mailbox, remember the last one. */
+        if (last) free(last);
+        if (!mboxname) last = xstrdup(mbentry->name);
+
+        /* Map mailbox id to mailbox name. */
+        json_object_set_new(mailboxes, mboxid, json_string(mbentry->name));
+    }
+
+    /* If we haven't picked a mailbox, pick the last one. */
+    if (!mboxname) mboxname = last;
+    if (!mboxname) {
+        char *s = json_dumps(mailboxids, 0);
+        syslog(LOG_ERR, "_email_append: invalid mailboxids: %s", s);
+        free(s);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Create the message in the destination mailbox */
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r) goto done;
+
+    if (sourcefile) {
+        if (!(f = append_newstage_full(mbox->name, internaldate, 0, &stage, sourcefile))) {
+            syslog(LOG_ERR, "append_newstage(%s) failed", mbox->name);
+            r = HTTP_SERVER_ERROR;
+            goto done;
+        }
+    }
+    else {
+        /* Write the message to the filesystem */
+        if (!(f = append_newstage(mbox->name, internaldate, 0, &stage))) {
+            syslog(LOG_ERR, "append_newstage(%s) failed", mbox->name);
+            r = HTTP_SERVER_ERROR;
+            goto done;
+        }
+        r = writecb(req, f, rock, err);
+        if (r) goto done;
+        if (fflush(f)) {
+            r = IMAP_IOERROR;
+            goto done;
+        }
+    }
+    fseek(f, 0L, SEEK_END);
+    len = ftell(f);
+
+    /* Generate a GUID from the raw file content */
+    fd = fileno(f);
+    if ((addr = mmap(NULL, len, PROT_READ, MAP_PRIVATE, fd, 0))) {
+        struct message_guid guid;
+        message_guid_generate(&guid, addr, len);
+        jmap_set_emailid(&guid, detail->email_id);
+        jmap_set_blobid(&guid, detail->blob_id);
+        detail->size = len;
+        munmap(addr, len);
+    } else {
+        r = IMAP_IOERROR;
+        goto done;
+    }
+    fclose(f);
+    f = NULL;
+
+    /*  Check if a message with this GUID already exists and is
+     *  visible for the authenticated user. */
+    char *exist_mboxname = NULL;
+    uint32_t exist_uid;
+    r = jmap_email_find(req, detail->email_id, &exist_mboxname, &exist_uid);
+    free(exist_mboxname);
+    if (r != IMAP_NOTFOUND) {
+        if (!r) r = IMAP_MAILBOX_EXISTS;
+        goto done;
+    }
+
+    /* Great, that's a new message! */
+    struct body *body = NULL;
+    struct appendstate as;
+
+    /* Prepare flags */
+    strarray_t flags = STRARRAY_INITIALIZER;
+    int i;
+    for (i = 0; i < strarray_size(keywords); i++) {
+        const char *flag = jmap_keyword_to_imap(strarray_nth(keywords, i));
+        if (flag) strarray_append(&flags, flag);
+    }
+    if (has_attachment) {
+        strarray_add(&flags, "$hasattachment");
+    }
+
+    /* Append the message to the mailbox. */
+    qdiffs[QUOTA_MESSAGE] = 1;
+    qdiffs[QUOTA_STORAGE] = len;
+    r = append_setup_mbox(&as, mbox, req->userid, httpd_authstate,
+            0, qdiffs, 0, 0, EVENT_MESSAGE_NEW);
+    if (r) goto done;
+
+    struct entryattlist *annots = NULL;
+    if (json_is_object(snoozed)) {
+        const char *annot = IMAP_ANNOT_NS "snoozed";
+        const char *attrib = "value.shared";
+        struct buf buf = BUF_INITIALIZER;
+        char *json = json_dumps(snoozed, JSON_COMPACT);
+
+        buf_initm(&buf, json, strlen(json));
+        setentryatt(&annots, annot, attrib, &buf);
+        buf_free(&buf);
+
+        /* Add \snoozed pseudo-flag */
+        strarray_add(&flags, "\\snoozed");
+
+        /* Extract until and use it as savedate */
+        time_from_iso8601(json_string_value(json_object_get(snoozed, "until")),
+                          &savedate);
+    }
+    r = append_fromstage_full(&as, &body, stage, internaldate, savedate, 0,
+                         flags.count ? &flags : NULL, 0, annots);
+    freeentryatts(annots);
+    if (r) {
+        append_abort(&as);
+        goto done;
+    }
+    strarray_fini(&flags);
+    message_free_body(body);
+    free(body);
+
+    r = append_commit(&as);
+    if (r) goto done;
+
+    /* Load message record */
+    r = msgrecord_find(mbox, mbox->i.last_uid, &mr);
+    if (r) goto done;
+
+    bit64 cid;
+    r = msgrecord_get_cid(mr, &cid);
+    if (r) goto done;
+    jmap_set_threadid(cid, detail->thread_id);
+
+    /* Complete message creation */
+    if (stage) {
+        append_removestage(stage);
+        stage = NULL;
+    }
+    json_object_del(mailboxes, mbox->uniqueid);
+
+    /* Make sure there is enough quota for all mailboxes */
+    qdiffs[QUOTA_STORAGE] = len;
+    if (json_object_size(mailboxes)) {
+        char foundroot[MAX_MAILBOX_BUFFER];
+        json_t *deltas = json_pack("{}");
+        const char *mbname;
+
+        /* Count message delta for each quota root */
+        json_object_foreach(mailboxes, id, val) {
+            mbname = json_string_value(val);
+            if (quota_findroot(foundroot, sizeof(foundroot), mbname)) {
+                json_t *delta = json_object_get(deltas, mbname);
+                delta = json_integer(json_integer_value(delta) + 1);
+                json_object_set_new(deltas, mbname, delta);
+            }
+        }
+
+        /* Check quota for each quota root. */
+        json_object_foreach(deltas, mbname, val) {
+            struct quota quota;
+            quota_t delta = json_integer_value(val);
+
+            quota_init(&quota, mbname);
+            r = quota_check(&quota, QUOTA_STORAGE, delta * qdiffs[QUOTA_STORAGE]);
+            if (!r) r = quota_check(&quota, QUOTA_MESSAGE, delta);
+            quota_free(&quota);
+            if (r) break;
+        }
+        json_decref(deltas);
+        if (r) goto done;
+    }
+
+    /* Copy the message to all remaining mailboxes */
+    json_object_foreach(mailboxes, id, val) {
+        const char *dstname = json_string_value(val);
+        struct mailbox *dst = NULL;
+
+        if (!strcmp(mboxname, dstname))
+            continue;
+
+        r = jmap_openmbox(req, dstname, &dst, 1);
+        if (r) goto done;
+
+        r = _copy_msgrecord(httpd_authstate, req->userid, &jmap_namespace,
+                            mbox, dst, mr);
+
+        jmap_closembox(req, &dst);
+        if (r) goto done;
+    }
+
+done:
+    if (f) fclose(f);
+    append_removestage(stage);
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    free(mboxname);
+    json_decref(mailboxes);
+    if (r && *err == NULL) {
+        switch (r) {
+            case IMAP_PERMISSION_DENIED:
+                *err = json_pack("{s:s}", "type", "forbidden");
+                break;
+            case IMAP_MAILBOX_EXISTS:
+                *err = json_pack("{s:s s:s}", "type", "alreadyExists", "existingId", detail->email_id);
+                break;
+            case IMAP_QUOTA_EXCEEDED:
+                *err = json_pack("{s:s}", "type", "overQuota");
+                break;
+            case IMAP_MESSAGE_CONTAINSNULL:
+            case IMAP_MESSAGE_CONTAINSNL:
+            case IMAP_MESSAGE_CONTAINS8BIT:
+            case IMAP_MESSAGE_BADHEADER:
+            case IMAP_MESSAGE_NOBLANKLINE:
+                *err = json_pack("{s:s s:s}", "type", "invalidEmail",
+                        "description", error_message(r));
+                break;
+            default:
+                *err = jmap_server_error(r);
+        }
+    }
+}
+
+struct emailpart {
+    /* Mandatory fields */
+    struct headers headers;       /* raw headers */
+    /* Optional fields */
+    json_t *jpart;                /* original EmailBodyPart JSON object */
+    json_t *jbody;                /* EmailBodyValue for text bodies */
+    char *blob_id;                /* blobId to dump contents from */
+    ptrarray_t subparts;          /* array of emailpart pointers */
+    char *type;                   /* Content-Type main type */
+    char *subtype;                /* Content-Type subtype */
+    char *charset;                /* Content-Type charset parameter */
+    char *boundary;               /* Content-Type boundary parameter */
+    char *disposition;            /* Content-Disposition without parameters */
+    char *filename;               /* Content-Disposition filename parameter */
+};
+
+static void _emailpart_fini(struct emailpart *part)
+{
+    if (!part) return;
+
+    struct emailpart *subpart;
+    while ((subpart = ptrarray_pop(&part->subparts))) {
+        _emailpart_fini(subpart);
+        free(subpart);
+    }
+    ptrarray_fini(&part->subparts);
+    json_decref(part->jpart);
+    json_decref(part->jbody);
+    _headers_fini(&part->headers);
+    free(part->type);
+    free(part->subtype);
+    free(part->boundary);
+    free(part->charset);
+    free(part->disposition);
+    free(part->filename);
+    free(part->blob_id);
+}
+
+struct email {
+    struct headers headers; /* parsed headers */
+    json_t *jemail;               /* original Email JSON object */
+    struct emailpart *body;       /* top-level MIME part */
+    time_t internaldate;          /* RFC 3501 internaldate aka receivedAt */
+    int has_attachment;           /* set the HasAttachment flag */
+    json_t *snoozed;              /* set snoozed annotation */
+};
+
+static void _email_fini(struct email *email)
+{
+    if (!email) return;
+    _headers_fini(&email->headers);
+    json_decref(email->jemail);
+    _emailpart_fini(email->body);
+    free(email->body);
+}
+
+static json_t *_header_make(const char *header_name, const char *prop_name, struct buf *val)
+{
+    char *tmp = buf_release(val);
+    json_t *jheader = json_pack("{s:s s:s}", "name", header_name, "value", tmp);
+    free(tmp);
+    if (prop_name) json_object_set_new(jheader, "prop", json_string(prop_name));
+    return jheader;
+}
+
+typedef json_t* (*header_from_t)(json_t *jval,
+                                 struct jmap_parser *parser,
+                                 const char *prop_name,
+                                 const char *header_name,
+                                 enum header_form form);
+
+static json_t *_header_from_raw(json_t *jraw,
+                                struct jmap_parser *parser,
+                                const char *prop_name,
+                                const char *header_name,
+                                enum header_form form __attribute__((unused)))
+{
+    /* Verbatim use header value in raw form */
+    if (json_is_string(jraw)) {
+        json_t *jheader = json_pack("{s:s s:O s:s}",
+                "name", header_name, "value", jraw, "prop", prop_name);
+        return jheader;
+    }
+    else {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+}
+
+static json_t *_header_from_text(json_t *jtext,
+                                 struct jmap_parser *parser,
+                                 const char *prop_name,
+                                 const char *header_name,
+                                 enum header_form form __attribute__((unused)))
+{
+    /* Parse a Text header into raw form */
+    if (json_is_string(jtext)) {
+        size_t prefix_len = strlen(header_name) + 2;
+        const char *s = json_string_value(jtext);
+        /* Q-encoding will fold lines for us */
+        int force_quote = prefix_len + strlen(s) > MIME_MAX_HEADER_LENGTH;
+        char *tmp = charset_encode_mimeheader(s, strlen(s), force_quote);
+        struct buf val = BUF_INITIALIZER;
+        /* If text got force-quoted the first line of the Q-encoded
+         * text might spill over the soft 78-character limit due to
+         * the Header name prefix. Looking at how most of the mail
+         * clients are doing this, this seems not to be an issue and
+         * allows us to not start the header value with a line fold. */
+        buf_setcstr(&val, tmp);
+        free(tmp);
+        return _header_make(header_name, prop_name, &val);
+    }
+    else {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+}
+
+static json_t *_header_from_strings(const strarray_t *vals,
+                                    const char *prop_name,
+                                    const char *header_name)
+{
+    size_t line_len = strlen(header_name) + 2;
+    struct buf val = BUF_INITIALIZER;
+    int i;
+
+    for (i = 0; i < strarray_size(vals); i++) {
+        const char *s = strarray_nth(vals, i);
+        size_t s_len = strlen(s);
+        if (line_len + s_len + 1 > MIME_MAX_HEADER_LENGTH) {
+            buf_appendcstr(&val, "\r\n ");
+            line_len = 1;
+        }
+        else if (i) {
+            buf_putc(&val, ' ');
+            line_len++;
+        }
+        buf_appendcstr(&val, s);
+        line_len += s_len;
+    }
+
+    return _header_make(header_name, prop_name, &val);
+}
+
+
+static json_t *_header_from_addresses(json_t *addrs,
+                                       struct jmap_parser *parser,
+                                       const char *prop_name,
+                                       const char *header_name,
+                                       enum header_form form)
+{
+    json_t *groups = form == HEADER_FORM_GROUPEDADDRESSES ?
+        addrs : json_pack("[{s:n s:O}]", "name", "addresses", addrs);
+
+    json_t *group;
+    size_t i;
+    struct buf emailbuf = BUF_INITIALIZER;
+    struct buf buf = BUF_INITIALIZER;
+    json_t *ret = NULL;
+    strarray_t vals = STRARRAY_INITIALIZER;
+
+    json_array_foreach(groups, i, group) {
+
+        const char *groupname = NULL;
+        json_t *jgroupname = json_object_get(group, "name");
+        if (json_is_string(jgroupname)) {
+            groupname = json_string_value(jgroupname);
+        }
+        else if (JNOTNULL(jgroupname)) {
+            jmap_parser_push_index(parser, prop_name, i, NULL);
+            jmap_parser_invalid(parser, "name");
+            jmap_parser_pop(parser);
+        }
+
+        if (groupname) {
+            buf_setcstr(&buf, groupname);
+            buf_putc(&buf, ':');
+            buf_putc(&buf, ' ');
+            strarray_append(&vals, buf_cstring(&buf));
+            buf_reset(&buf);
+        }
+
+        json_t *addrs = json_object_get(group, "addresses");
+        if (!json_is_array(addrs)) {
+            jmap_parser_push_index(parser, prop_name, i, NULL);
+            jmap_parser_invalid(parser, "addresses");
+            jmap_parser_pop(parser);
+        }
+        if (json_array_size(parser->invalid)) {
+            goto done;
+        }
+
+        json_t *addr;
+        size_t j;
+        json_array_foreach(addrs, j, addr) {
+            json_t *jname = json_object_get(addr, "name");
+            if (!json_is_string(jname) && JNOTNULL(jname)) {
+                if (form == HEADER_FORM_GROUPEDADDRESSES) {
+                    jmap_parser_push_index(parser, prop_name, i, NULL);
+                    jmap_parser_push_index(parser, "addresses", j, NULL);
+                    jmap_parser_invalid(parser, "name");
+                    jmap_parser_pop(parser);
+                    jmap_parser_pop(parser);
+                }
+                else {
+                    jmap_parser_push_index(parser, prop_name, j, NULL);
+                    jmap_parser_invalid(parser, "name");
+                    jmap_parser_pop(parser);
+                }
+            }
+
+            json_t *jemail = json_object_get(addr, "email");
+            if (!json_is_string(jemail) && JNOTNULL(jemail)) {
+                if (form == HEADER_FORM_GROUPEDADDRESSES) {
+                    jmap_parser_push_index(parser, prop_name, i, NULL);
+                    jmap_parser_push_index(parser, "addresses", j, NULL);
+                    jmap_parser_invalid(parser, "email");
+                    jmap_parser_pop(parser);
+                    jmap_parser_pop(parser);
+                }
+                else {
+                    jmap_parser_push_index(parser, prop_name, j, NULL);
+                    jmap_parser_invalid(parser, "email");
+                    jmap_parser_pop(parser);
+                }
+            }
+
+            if (json_array_size(parser->invalid))
+                goto done;
+            if (!JNOTNULL(jname) && !JNOTNULL(jemail))
+                continue;
+
+            const char *name = json_string_value(jname);
+            const char *email = json_string_value (jemail);
+            if (!name && !email) continue;
+
+            /* Trim whitespace from email */
+            if (email) {
+                buf_setcstr(&emailbuf, email);
+                buf_trim(&emailbuf);
+                email = buf_cstring(&emailbuf);
+            }
+
+            if (name && strlen(name) && email) {
+                enum name_type { ATOM, QUOTED_STRING, HIGH_BIT } name_type = ATOM;
+                const char *p;
+                for (p = name; *p; p++) {
+                    char c = *p;
+                    /* Check for ATOM characters */
+                    if (('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z'))
+                        continue;
+                    if ('0' <= c && c <= '9')
+                        continue;
+                    if (strchr("!#$%&'*+-/=?^_`{|}~", c))
+                        continue;
+                    if (c < 0) {
+                        /* Contains at least one high bit character. */
+                        name_type = HIGH_BIT;
+                        break;
+                    }
+                    else {
+                        /* Requires at least a quoted string, but could
+                         * still contain a high bit at a later position. */
+                        name_type = QUOTED_STRING;
+                    }
+                }
+                if (name_type == ATOM) {
+                    buf_setcstr(&buf, name);
+                }
+                else if (name_type == QUOTED_STRING) {
+                    buf_putc(&buf, '"');
+                    for (p = name; *p; p++) {
+                        if (*p == '"' || *p == '\\' || *p == '\r') {
+                            buf_putc(&buf, '\\');
+                        }
+                        buf_putc(&buf, *p);
+                    }
+                    buf_putc(&buf, '"');
+                }
+                else if (name_type == HIGH_BIT) {
+                    char *xname = charset_encode_mimephrase(name);
+                    buf_appendcstr(&buf, xname);
+                    free(xname);
+                }
+                buf_printf(&buf, " <%s>", email);
+            } else if (email) {
+                buf_setcstr(&buf, email);
+            }
+            if (j < json_array_size(addrs) - 1 || i < json_array_size(groups) - 1) {
+                buf_putc(&buf, ',');
+            }
+            strarray_append(&vals, buf_cstring(&buf));
+            buf_reset(&emailbuf);
+            buf_reset(&buf);
+        }
+
+        if (groupname)
+            strarray_append(&vals, ";");
+    }
+
+    ret = _header_from_strings(&vals, prop_name, header_name);
+
+done:
+    if (groups != addrs) json_decref(groups);
+    strarray_fini(&vals);
+    buf_free(&emailbuf);
+    buf_free(&buf);
+    return ret;
+}
+
+static json_t *_header_from_messageids(json_t *jmessageids,
+                                       struct jmap_parser *parser,
+                                       const char *prop_name,
+                                       const char *header_name,
+                                       enum header_form form __attribute__((unused)))
+{
+    if (!json_array_size(jmessageids)) {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+
+    size_t i;
+    json_t *jval;
+    struct buf val = BUF_INITIALIZER;
+    struct buf msgid = BUF_INITIALIZER;
+    strarray_t vals = STRARRAY_INITIALIZER;
+    json_t *ret = NULL;
+
+    json_array_foreach(jmessageids, i, jval) {
+        const char *s = json_string_value(jval);
+        if (!s) {
+            jmap_parser_invalid(parser, prop_name);
+            goto done;
+        }
+        buf_setcstr(&msgid, s);
+        buf_trim(&msgid);
+        buf_putc(&val, '<');
+        buf_appendcstr(&val, buf_cstring(&msgid));
+        buf_putc(&val, '>');
+        if (conversations_check_msgid(buf_base(&val), buf_len(&val))) {
+            jmap_parser_invalid(parser, prop_name);
+            goto done;
+        }
+        strarray_append(&vals, buf_cstring(&val));
+        buf_reset(&val);
+    }
+    ret = _header_from_strings(&vals, prop_name, header_name);
+
+done:
+    strarray_fini(&vals);
+    buf_free(&msgid);
+    buf_free(&val);
+    return ret;
+}
+
+static json_t *_header_from_date(json_t *jdate,
+                                 struct jmap_parser *parser,
+                                 const char *prop_name,
+                                 const char *header_name,
+                                 enum header_form form __attribute__((unused)))
+{
+    const char *s = json_string_value(jdate);
+    if (!s) {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+
+    struct offsettime t;
+    int n = offsettime_from_iso8601(s, &t);
+    if (n <= 0 || s[n] != '\0') {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+    char fmt[RFC5322_DATETIME_MAX+1];
+    memset(fmt, 0, RFC5322_DATETIME_MAX+1);
+    offsettime_to_rfc5322(&t, fmt, RFC5322_DATETIME_MAX+1);
+
+    struct buf val = BUF_INITIALIZER;
+    buf_setcstr(&val, fmt);
+    return _header_make(header_name, prop_name, &val);
+}
+
+static json_t *_header_from_urls(json_t *jurls,
+                                 struct jmap_parser *parser,
+                                 const char *prop_name,
+                                 const char *header_name,
+                                 enum header_form form __attribute__((unused)))
+{
+    if (!json_array_size(jurls)) {
+        jmap_parser_invalid(parser, prop_name);
+        return NULL;
+    }
+
+    size_t i;
+    json_t *jval;
+    struct buf val = BUF_INITIALIZER;
+    strarray_t vals = STRARRAY_INITIALIZER;
+    json_t *ret = NULL;
+
+    json_array_foreach(jurls, i, jval) {
+        const char *s = json_string_value(jval);
+        if (!s) {
+            jmap_parser_invalid(parser, prop_name);
+            goto done;
+        }
+
+        buf_appendcstr(&val, "<");
+        buf_appendcstr(&val, s);
+        buf_appendcstr(&val, ">");
+        if (i < json_array_size(jurls) - 1) {
+            buf_putc(&val, ',');
+        }
+        strarray_append(&vals, buf_cstring(&val));
+        buf_reset(&val);
+    }
+    ret = _header_from_strings(&vals, prop_name, header_name);
+
+done:
+    strarray_fini(&vals);
+    buf_free(&val);
+    return ret;
+}
+
+static void _headers_parseprops(json_t *jobject,
+                           struct jmap_parser *parser,
+                           struct headers *headers)
+{
+    const char *field;
+    json_t *jval;
+    json_object_foreach(jobject, field, jval) {
+        if (strncmp(field, "header:", 7))
+            continue;
+        /* Parse header or reject if invalid form */
+        struct header_prop *hprop = _header_parseprop(field);
+        if (!hprop) {
+            jmap_parser_invalid(parser, field);
+            continue;
+        }
+        /* Reject redefinition of header */
+        if (json_object_get(headers->all, hprop->lcasename)) {
+            _header_prop_free(hprop);
+            jmap_parser_invalid(parser, field);
+            continue;
+        }
+        /* Parse header value */
+        header_from_t cb = NULL;
+        switch (hprop->form) {
+            case HEADER_FORM_RAW:
+                cb = _header_from_raw;
+                break;
+            case HEADER_FORM_TEXT:
+                cb = _header_from_text;
+                break;
+            case HEADER_FORM_ADDRESSES:
+            case HEADER_FORM_GROUPEDADDRESSES:
+                cb = _header_from_addresses;
+                break;
+            case HEADER_FORM_MESSAGEIDS:
+                cb = _header_from_messageids;
+                break;
+            case HEADER_FORM_DATE:
+                cb = _header_from_date;
+                break;
+            case HEADER_FORM_URLS:
+                cb = _header_from_urls;
+                break;
+            default:
+                syslog(LOG_ERR, "jmap: unknown header form: %d", hprop->form);
+                jmap_parser_invalid(parser, field);
+        }
+        if (!jval || jval == json_null()) {
+            /* ignore null headers */
+            _header_prop_free(hprop);
+            continue;
+        }
+        if (hprop->all) {
+            size_t i;
+            json_t *jall = jval;
+            json_array_foreach(jall, i, jval) {
+                jmap_parser_push_index(parser, field, i, NULL);
+                json_t *jheader = cb(jval, parser, field, hprop->name, hprop->form);
+                if (jheader) _headers_add_new(headers, jheader);
+                jmap_parser_pop(parser);
+            }
+        }
+        else {
+            json_t *jheader = cb(jval, parser, field, hprop->name, hprop->form);
+            if (jheader) _headers_add_new(headers, jheader);
+        }
+        _header_prop_free(hprop);
+    }
+}
+
+static void _emailpart_parse_headers(json_t *jpart,
+                                     struct jmap_parser *parser,
+                                     struct emailpart *part)
+{
+    /* headers */
+    if (JNOTNULL(json_object_get(jpart, "headers"))) {
+        jmap_parser_invalid(parser, "headers");
+    }
+
+    /* header:Xxx */
+    const char *lcasename = NULL;
+    json_t *jheaders;
+    _headers_parseprops(jpart, parser, &part->headers);
+    /* Validate Content-Xxx headers */
+    json_object_foreach(part->headers.all, lcasename, jheaders) {
+        if (strncmp(lcasename, "content-", 8))
+            continue;
+
+        json_t *jheader = json_array_get(jheaders, 0);
+        const char *name = json_string_value(json_object_get(jheader, "name"));
+        const char *val = json_string_value(json_object_get(jheader, "value"));
+        const char *prop = json_string_value(json_object_get(jheader, "prop"));
+
+        /* Reject re-definition of Content-Xxx headers */
+        if (json_array_size(jheaders) > 1) {
+            size_t j;
+            json_array_foreach(jheaders, j, jheader) {
+                prop = json_string_value(json_object_get(jheader, "prop"));
+                jmap_parser_invalid(parser, prop);
+            }
+            continue;
+        }
+        if (!strcasecmp(name, "Content-Type")) {
+            /* Validate Content-Type */
+            struct param *type_params = NULL;
+            message_parse_type(val, &part->type, &part->subtype, &type_params);
+            if (part->type  && part->subtype) {
+                struct param *param = type_params;
+                while (param) {
+                    if (!strcasecmp(param->attribute, "BOUNDARY")) {
+                        part->boundary = xstrdupnull(param->value);
+                    }
+                    if (!strcasecmp(param->attribute, "CHARSET")) {
+                        part->charset = xstrdupnull(param->value);
+                    }
+                    param = param->next;
+                }
+                /* Headers for multipart MUST specify a boundary */
+                if (!strcasecmp(part->type, "MULTIPART") && !part->boundary)
+                    jmap_parser_invalid(parser, prop);
+                /* Headers for bodyparts with partId MUST NOT specify a charset */
+                if (JNOTNULL(json_object_get(jpart, "partId")) && part->charset)
+                    jmap_parser_invalid(parser, prop);
+            }
+            else {
+                jmap_parser_invalid(parser, prop);
+            }
+            param_free(&type_params);
+        }
+        else if (!strcasecmp(name, "Content-Disposition")) {
+            /* Validate Content-Disposition */
+            struct param *disp_params = NULL;
+            message_parse_disposition(val, &part->disposition, &disp_params);
+            if (!part->disposition) {
+                jmap_parser_invalid(parser, prop);
+                continue;
+            }
+            param_free(&disp_params);
+        }
+        else if (!strcasecmp(name, "Content-Transfer-Encoding")) {
+            /* Always reject Content-Transfer-Encoding */
+            jmap_parser_invalid(parser, prop);
+        }
+    }
+}
+
+static struct emailpart *_emailpart_parse(json_t *jpart,
+                                          struct jmap_parser *parser,
+                                          json_t *bodies)
+{
+    if (!json_is_object(jpart)) {
+        jmap_parser_invalid(parser, NULL);
+        return NULL;
+    }
+
+    struct buf buf = BUF_INITIALIZER;
+    struct emailpart *part = xzmalloc(sizeof(struct emailpart));
+    part->jpart = json_incref(jpart);
+
+    json_t *jval;
+
+    /* partId */
+    json_t *jpartId = json_object_get(jpart, "partId");
+    if (JNOTNULL(jpartId) && !json_is_string(jpartId)) {
+        jmap_parser_invalid(parser, "partId");
+    }
+
+    /* blobId */
+    jval = json_object_get(jpart, "blobId");
+    if (JNOTNULL(jval) && json_is_string(jval)) {
+        part->blob_id = xstrdup(json_string_value(jval));
+    }
+    else if (JNOTNULL(jval)) {
+        jmap_parser_invalid(parser, "blobId");
+    }
+
+    /* size */
+    jval = json_object_get(jpart, "size");
+    if (JNOTNULL(jval) && (!json_is_integer(jval) || JNOTNULL(jpartId))) {
+        jmap_parser_invalid(parser, "size");
+    }
+
+    /* Parse headers */
+    _emailpart_parse_headers(jpart, parser, part);
+
+    /* Parse convenience header properties */
+    int seen_header;
+
+    /* cid */
+    json_t *jcid = json_object_get(jpart, "cid");
+    seen_header = _headers_have(&part->headers, "Content-Id");
+    if (json_is_string(jcid) && !seen_header) {
+        const char *cid = json_string_value(jcid);
+        buf_setcstr(&buf, "<");
+        buf_appendcstr(&buf, cid);
+        buf_appendcstr(&buf, ">");
+        _headers_add_new(&part->headers, _header_make("Content-Id", "cid", &buf));
+    }
+    else if (JNOTNULL(jcid)) {
+        jmap_parser_invalid(parser, "cid");
+    }
+
+    /* language */
+    json_t *jlanguage = json_object_get(jpart, "language");
+    seen_header = _headers_have(&part->headers, "Content-Language");
+    if (json_is_array(jlanguage) && !seen_header) {
+        strarray_t vals = STRARRAY_INITIALIZER;
+        size_t i;
+        json_t *jval;
+        struct buf buf = BUF_INITIALIZER;
+        json_array_foreach(jlanguage, i, jval) {
+            const char *lang = json_string_value(jval);
+            if (!lang) {
+                jmap_parser_push_index(parser, "language", i, NULL);
+                jmap_parser_invalid(parser, NULL);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            buf_setcstr(&buf, lang);
+            if (i < json_array_size(jlanguage) - 1) {
+                buf_putc(&buf, ',');
+            }
+            strarray_append(&vals, buf_cstring(&buf));
+        }
+        _headers_add_new(&part->headers, _header_from_strings(&vals, "language", "Content-Language"));
+        buf_free(&buf);
+        strarray_fini(&vals);
+    }
+    else if (JNOTNULL(jlanguage)) {
+        jmap_parser_invalid(parser, "language");
+    }
+
+    /* location */
+    json_t *jlocation = json_object_get(jpart, "location");
+    seen_header = _headers_have(&part->headers, "Content-Location");
+    if (json_is_string(jlocation) && !seen_header) {
+        buf_setcstr(&buf, json_string_value(jlocation));
+        _headers_add_new(&part->headers, _header_make("Content-Location", "location", &buf));
+    }
+    else if (JNOTNULL(jlocation)) {
+        jmap_parser_invalid(parser, "location");
+    }
+
+    /* Check Content-Type and Content-Disposition header properties */
+    int have_type_header = _headers_have(&part->headers, "Content-Type");
+    int have_disp_header = _headers_have(&part->headers, "Content-Disposition");
+    /* name */
+    json_t *jname = json_object_get(jpart, "name");
+    if (json_is_string(jname) && !have_type_header && !have_disp_header) {
+        part->filename = xstrdup(json_string_value(jname));
+    }
+    else if (JNOTNULL(jname)) {
+        jmap_parser_invalid(parser, "name");
+    }
+    /* disposition */
+    json_t *jdisposition = json_object_get(jpart, "disposition");
+    if (json_is_string(jdisposition) && !have_disp_header) {
+        /* Build Content-Disposition header */
+        part->disposition = xstrdup(json_string_value(jdisposition));
+        buf_setcstr(&buf, part->disposition);
+        if (part->filename) {
+            _mime_write_xparam(&buf, "filename", part->filename);
+        }
+        _headers_add_new(&part->headers,
+                _header_make("Content-Disposition", "disposition", &buf));
+    }
+    else if (JNOTNULL(jdisposition)) {
+        jmap_parser_invalid(parser, "disposition");
+    }
+    else if (jname) {
+        /* Make Content-Disposition header */
+        part->disposition = xstrdup("attachment");
+        buf_printf(&buf, "attachment");
+        _mime_write_xparam(&buf, "filename", part->filename);
+        _headers_add_new(&part->headers,
+                _header_make("Content-Disposition", "name", &buf));
+    }
+    /* charset */
+    json_t *jcharset = json_object_get(jpart, "charset");
+    if (json_is_string(jcharset) && !have_type_header && !JNOTNULL(jpartId)) {
+        part->charset = xstrdup(json_string_value(jcharset));
+    }
+    else if (JNOTNULL(jcharset)) {
+        jmap_parser_invalid(parser, "charset");
+    }
+    /* type */
+    json_t *jtype = json_object_get(jpart, "type");
+    if (JNOTNULL(jtype) && json_is_string(jtype) && !have_type_header) {
+		const char *type = json_string_value(jtype);
+        struct param *type_params = NULL;
+        /* Validate type value */
+        message_parse_type(type, &part->type, &part->subtype, &type_params);
+        if (part->type && part->subtype && !type_params) {
+            /* Build Content-Type header */
+            if (!strcasecmp(part->type, "MULTIPART")) {
+                /* Make boundary */
+                part->boundary = _mime_make_boundary();
+            }
+            buf_reset(&buf);
+            buf_printf(&buf, "%s/%s", part->type, part->subtype);
+            buf_lcase(&buf);
+            if (part->charset) {
+                buf_appendcstr(&buf, "; charset=");
+                buf_appendcstr(&buf, part->charset);
+            }
+            if (part->filename) {
+                /* Check if filename can be encoded as quoted string */
+                struct buf valbuf = BUF_INITIALIZER;
+                int is_qstring = 1;
+                const char *p;
+                for (p = part->filename; *p && is_qstring; p++) {
+                    switch (QSTRINGCHAR[(unsigned char)*p]) {
+                        case 0:
+                            is_qstring = 0;
+                            break;
+                        case 2:
+                            buf_putc(&valbuf, '\\');
+                            /* fall through */
+                        default:
+                            buf_putc(&valbuf, *p);
+                    }
+                }
+                /* Encode and write header value */
+                char *value;
+                if (!is_qstring || buf_len(&valbuf) > MIME_MAX_HEADER_LENGTH) {
+                    value = charset_encode_mimeheader(part->filename, 0, /*qpencode*/1);
+                    if (strlen(value) > MIME_MAX_HEADER_LENGTH) {
+                        buf_appendcstr(&buf, ";\r\n ");
+                    }
+                    else buf_appendcstr(&buf, "; ");
+                }
+                else {
+                    value = buf_release(&valbuf);
+                    buf_appendcstr(&buf, "; ");
+                }
+                buf_appendcstr(&buf, "name=\"");
+                buf_appendcstr(&buf, value);
+                buf_appendcstr(&buf, "\"");
+                buf_free(&valbuf);
+                free(value);
+            }
+            if (part->boundary) {
+                buf_appendcstr(&buf, ";\r\n boundary=");
+                buf_appendcstr(&buf, part->boundary);
+            }
+            _headers_add_new(&part->headers,
+                    _header_make("Content-Type", "type", &buf));
+        }
+        else {
+            jmap_parser_invalid(parser, "type");
+        }
+        param_free(&type_params);
+    }
+    else if (JNOTNULL(jtype)) {
+        jmap_parser_invalid(parser, "type");
+    }
+
+    /* Validate by type */
+    const char *part_id = json_string_value(json_object_get(jpart, "partId"));
+    const char *blob_id = json_string_value(json_object_get(jpart, "blobId"));
+    json_t *subParts = json_object_get(jpart, "subParts");
+    json_t *bodyValue = part_id ? json_object_get(bodies, part_id) : NULL;
+
+    if (part_id && blob_id)
+        jmap_parser_invalid(parser, "blobId");
+    if (part_id && !bodyValue)
+        jmap_parser_invalid(parser, "partId");
+
+    if (subParts || (part->type && !strcasecmp(part->type, "MULTIPART"))) {
+        /* Parse sub parts */
+        if (json_array_size(subParts)) {
+            size_t i;
+            json_t *subPart;
+            json_array_foreach(subParts, i, subPart) {
+                jmap_parser_push_index(parser, "subParts", i, NULL);
+                struct emailpart *subpart = _emailpart_parse(subPart, parser, bodies);
+                if (subpart) ptrarray_append(&part->subparts, subpart);
+                jmap_parser_pop(parser);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, "subParts");
+        }
+        /* Must not have a body value */
+        if (JNOTNULL(bodyValue))
+            jmap_parser_invalid(parser, "partId");
+        /* Must not have a blobId */
+        if (blob_id)
+            jmap_parser_invalid(parser, "blobId");
+    }
+    else if (part_id || (part->type && !strcasecmp(part->type, "TEXT"))) {
+        /* Must have a text body as blob or bodyValue */
+        if ((bodyValue == NULL) == (blob_id == NULL))
+            jmap_parser_invalid(parser, "blobId");
+        /* Must not have sub parts */
+        if (JNOTNULL(subParts))
+            jmap_parser_invalid(parser, "subParts");
+    }
+    else {
+        /* Must have a blob id */
+        if (!blob_id)
+            jmap_parser_invalid(parser, "blobId");
+        /* Must not have a text body */
+        if (bodyValue)
+            jmap_parser_invalid(parser, "partId");
+        /* Must not have sub parts */
+        if (JNOTNULL(subParts))
+            jmap_parser_invalid(parser, "subParts");
+    }
+
+    buf_free(&buf);
+
+    if (json_array_size(parser->invalid)) {
+        _emailpart_fini(part);
+        free(part);
+        return NULL;
+    }
+
+    /* Finalize part definition */
+    part->jbody = json_incref(bodyValue);
+
+    return part;
+}
+
+static struct emailpart *_emailpart_new_multi(const char *subtype,
+                                               ptrarray_t *subparts)
+{
+    struct emailpart *part = xzmalloc(sizeof(struct emailpart));
+    int i;
+
+    part->type = xstrdup("multipart");
+    part->subtype = xstrdup(subtype);
+    part->boundary = _mime_make_boundary();
+    struct buf val = BUF_INITIALIZER;
+    buf_printf(&val, "%s/%s;boundary=%s",
+            part->type, part->subtype, part->boundary);
+    _headers_add_new(&part->headers,
+            _header_make("Content-Type", NULL, &val));
+    for (i = 0; i < subparts->count; i++)
+        ptrarray_append(&part->subparts, ptrarray_nth(subparts, i));
+
+    return part;
+}
+
+static struct emailpart *_email_buildbody(struct emailpart *text_body,
+                                          struct emailpart *html_body,
+                                          ptrarray_t *attachments)
+{
+    struct emailpart *root = NULL;
+
+    /* Split attachments into inlined, emails and other files */
+    ptrarray_t attached_emails = PTRARRAY_INITIALIZER;
+    ptrarray_t attached_files = PTRARRAY_INITIALIZER;
+    ptrarray_t inlined_files = PTRARRAY_INITIALIZER;
+    int i;
+    for (i = 0; i < attachments->count; i++) {
+        struct emailpart *part = ptrarray_nth(attachments, i);
+        if (part->type && !strcasecmp(part->type, "MESSAGE")) {
+            ptrarray_append(&attached_emails, part);
+        }
+        else if (part->disposition && !strcasecmp(part->disposition, "INLINE") &&
+                 (text_body || html_body)) {
+            ptrarray_append(&inlined_files, part);
+        }
+        else {
+            ptrarray_append(&attached_files, part);
+        }
+    }
+
+    /* Make MIME part for embedded emails. */
+    struct emailpart *emails = NULL;
+    if (attached_emails.count >= 2)
+        emails = _emailpart_new_multi("digest", &attached_emails);
+    else if (attached_emails.count == 1)
+        emails = ptrarray_nth(&attached_emails, 0);
+
+    /* Make MIME part for text bodies. */
+    struct emailpart *text = NULL;
+    if (text_body && html_body) {
+        ptrarray_t alternatives = PTRARRAY_INITIALIZER;
+        ptrarray_append(&alternatives, text_body);
+        ptrarray_append(&alternatives, html_body);
+        text = _emailpart_new_multi("alternative", &alternatives);
+        ptrarray_fini(&alternatives);
+    }
+    else if (text_body)
+        text = text_body;
+    else if (html_body)
+        text = html_body;
+
+    /* Make MIME part for inlined attachments, if any. */
+    if (text && inlined_files.count) {
+        struct emailpart *related = _emailpart_new_multi("related", &inlined_files);
+        ptrarray_insert(&related->subparts, 0, text);
+        text = related;
+    }
+
+    /* Choose top-level MIME part. */
+    if (attached_files.count) {
+        struct emailpart *mixed = _emailpart_new_multi("mixed", &attached_files);
+        if (emails) ptrarray_insert(&mixed->subparts, 0, emails);
+        if (text) ptrarray_insert(&mixed->subparts, 0, text);
+        root = mixed;
+    }
+    else if (text && emails) {
+        ptrarray_t wrapped = PTRARRAY_INITIALIZER;
+        ptrarray_append(&wrapped, text);
+        ptrarray_append(&wrapped, emails);
+        root = _emailpart_new_multi("mixed", &wrapped);
+        ptrarray_fini(&wrapped);
+    }
+    else if (text)
+        root = text;
+    else if (emails)
+        root = emails;
+    else
+        root = NULL;
+
+    ptrarray_fini(&attached_emails);
+    ptrarray_fini(&attached_files);
+    ptrarray_fini(&inlined_files);
+    return root;
+}
+
+
+static void _email_parse_bodies(json_t *jemail,
+                                struct jmap_parser *parser,
+                                struct email *email)
+{
+    /* bodyValues */
+    json_t *bodyValues = json_object_get(jemail, "bodyValues");
+    if (json_is_object(bodyValues)) {
+        const char *part_id;
+        json_t *bodyValue;
+        jmap_parser_push(parser, "bodyValues");
+        json_object_foreach(bodyValues, part_id, bodyValue) {
+            jmap_parser_push(parser, part_id);
+            if (json_is_object(bodyValue)) {
+                json_t *jval = json_object_get(bodyValue, "value");
+                if (!json_is_string(jval)) {
+                    jmap_parser_invalid(parser, "value");
+                }
+                jval = json_object_get(bodyValue, "isEncodingProblem");
+                if (JNOTNULL(jval) && jval != json_false()) {
+                    jmap_parser_invalid(parser, "isEncodingProblem");
+                }
+                jval = json_object_get(bodyValue, "isTruncated");
+                if (JNOTNULL(jval) && jval != json_false()) {
+                    jmap_parser_invalid(parser, "isTruncated");
+                }
+            }
+            else {
+                jmap_parser_invalid(parser, NULL);
+            }
+            jmap_parser_pop(parser);
+        }
+        jmap_parser_pop(parser);
+    }
+    else if (JNOTNULL(bodyValues)) {
+        jmap_parser_invalid(parser, "bodyValues");
+    }
+
+    /* bodyStructure */
+    json_t *jbody = json_object_get(jemail, "bodyStructure");
+    if (json_is_object(jbody)) {
+        jmap_parser_push(parser, "bodyStructure");
+        email->body = _emailpart_parse(jbody, parser, bodyValues);
+        jmap_parser_pop(parser);
+        /* Top-level body part MUST NOT redefine headers in Email */
+        if (email->body) {
+            const char *name;
+            json_t *jheader;
+            json_object_foreach(email->body->headers.all, name, jheader) {
+                if (json_object_get(email->headers.all, name)) {
+                    /* Report offending header property */
+                    json_t *jprop = json_object_get(jheader, "prop");
+                    const char *prop = json_string_value(jprop);
+                    if (prop) prop = "bodyStructure";
+                    jmap_parser_invalid(parser, prop);
+                }
+            }
+        }
+    }
+    else if (JNOTNULL(jbody)) {
+        jmap_parser_invalid(parser, "bodyStructure");
+    }
+
+    json_t *jtextBody = json_object_get(jemail, "textBody");
+    json_t *jhtmlBody = json_object_get(jemail, "htmlBody");
+    json_t *jattachments = json_object_get(jemail, "attachments");
+
+    struct emailpart *text_body = NULL;
+    struct emailpart *html_body = NULL;
+    ptrarray_t attachments = PTRARRAY_INITIALIZER; /* array of struct emailpart* */
+
+    if (JNOTNULL(jbody)) {
+        /* bodyStructure and fooBody are mutually exclusive */
+        if (JNOTNULL(jtextBody)) {
+            jmap_parser_invalid(parser, "textBody");
+        }
+        if (JNOTNULL(jhtmlBody)) {
+            jmap_parser_invalid(parser, "htmlBody");
+        }
+        if (JNOTNULL(jattachments)) {
+            jmap_parser_invalid(parser, "attachments");
+        }
+    }
+    else {
+        /* textBody */
+        if (json_array_size(jtextBody) == 1) {
+            json_t *jpart = json_array_get(jtextBody, 0);
+            jmap_parser_push_index(parser, "textBody", 0, NULL);
+            text_body = _emailpart_parse(jpart, parser, bodyValues);
+            if (text_body) {
+                if (!text_body->type) {
+                    /* Set default type */
+                    text_body->type = xstrdup("text");
+                    text_body->subtype = xstrdup("plain");
+                    struct buf val = BUF_INITIALIZER;
+                    buf_setcstr(&val, "text/plain");
+                    _headers_add_new(&text_body->headers,
+                            _header_make("Content-Type", NULL, &val));
+                }
+                else if (strcasecmp(text_body->type, "text") ||
+                         strcasecmp(text_body->subtype, "plain")) {
+                    jmap_parser_invalid(parser, "type");
+                }
+            }
+            jmap_parser_pop(parser);
+        }
+        else if (JNOTNULL(jtextBody)) {
+            jmap_parser_invalid(parser, "textBody");
+        }
+        /* htmlBody */
+        if (json_array_size(jhtmlBody) == 1) {
+            json_t *jpart = json_array_get(jhtmlBody, 0);
+            jmap_parser_push_index(parser, "htmlBody", 0, NULL);
+            html_body = _emailpart_parse(jpart, parser, bodyValues);
+            jmap_parser_pop(parser);
+            if (html_body) {
+                if (!html_body->type) {
+                    /* Set default type */
+                    html_body->type = xstrdup("text");
+                    html_body->subtype = xstrdup("html");
+                    struct buf val = BUF_INITIALIZER;
+                    buf_setcstr(&val, "text/html");
+                    _headers_add_new(&html_body->headers,
+                            _header_make("Content-Type", NULL, &val));
+                }
+                else if (strcasecmp(html_body->type, "text") ||
+                         strcasecmp(html_body->subtype, "html")) {
+                    jmap_parser_invalid(parser, "htmlBody");
+                }
+            }
+        }
+        else if (JNOTNULL(jhtmlBody)) {
+            jmap_parser_invalid(parser, "htmlBody");
+        }
+        /* attachments */
+        if (json_is_array(jattachments)) {
+            size_t i;
+            json_t *jpart;
+            struct emailpart *attpart;
+            int have_inlined = 0;
+            json_array_foreach(jattachments, i, jpart) {
+                jmap_parser_push_index(parser, "attachments", i, NULL);
+                attpart = _emailpart_parse(jpart, parser, bodyValues);
+                if (attpart) {
+                    if (!have_inlined && attpart->disposition) {
+                        have_inlined = !strcasecmp(attpart->disposition, "INLINE");
+                    }
+                    ptrarray_append(&attachments, attpart);
+                }
+                jmap_parser_pop(parser);
+            }
+            if (have_inlined && !html_body) {
+                /* Reject inlined attachments without a HTML body. The client
+                 * is free to produce whatever it wants by setting bodyStructure,
+                 * but for the convenience properties we require sane inputs. */
+                jmap_parser_invalid(parser, "htmlBody");
+            }
+        }
+        else if (JNOTNULL(jattachments)) {
+            jmap_parser_invalid(parser, "attachments");
+        }
+    }
+
+    /* calendarEvents is read-only */
+    if (JNOTNULL(json_object_get(jemail, "calendarEvents"))) {
+        jmap_parser_invalid(parser, "calendarEvents");
+    }
+
+    if (!email->body) {
+        /* Build email body from convenience body properties */
+        email->body = _email_buildbody(text_body, html_body, &attachments);
+    }
+
+    ptrarray_fini(&attachments);
+
+    /* Look through all parts if any part is an attachment.
+     * If so, set the hasAttachment flag. */
+    if (email->body) {
+        ptrarray_t work = PTRARRAY_INITIALIZER;
+        ptrarray_append(&work, email->body);
+
+        while (!email->has_attachment && work.count) {
+            struct emailpart *part = ptrarray_pop(&work);
+            if (part->disposition && strcasecmp(part->disposition, "INLINE")) {
+                email->has_attachment = 1;
+            }
+            else if (part->filename) {
+                email->has_attachment = 1;
+            }
+            else if (part->type && strcasecmp(part->type, "TEXT") &&
+                     strcasecmp(part->type, "MULTIPART") &&
+                     (!part->disposition || strcasecmp(part->disposition, "INLINE"))) {
+                email->has_attachment = 1;
+            }
+            else if (part->blob_id && (!part->type || strcasecmp(part->type, "TEXT"))) {
+                email->has_attachment = 1;
+            }
+            else {
+                int i;
+                for (i = 0; i < part->subparts.count; i++) {
+                    struct emailpart *subpart = ptrarray_nth(&part->subparts, i);
+                    ptrarray_append(&work, subpart);
+                }
+            }
+        }
+        ptrarray_fini(&work);
+    }
+}
+
+static void _email_snoozed_parse(json_t *snoozed,
+                                 struct jmap_parser *parser)
+{
+    const char *field;
+    json_t *jval;
+
+    jmap_parser_push(parser, "snoozed");
+    json_object_foreach(snoozed, field, jval) {
+        if (!strcmp(field, "until")) {
+            if (!json_is_utcdate(jval)) {
+                jmap_parser_invalid(parser, "until");
+            }
+        }
+        else if (!strcmp(field, "setKeywords")) {
+            const char *keyword;
+            json_t *jbool;
+
+            jmap_parser_push(parser, "setKeywords");
+            json_object_foreach(jval, keyword, jbool) {
+                if (!json_is_boolean(jbool) ||
+                    !jmap_email_keyword_is_valid(keyword)) {
+                    jmap_parser_invalid(parser, keyword);
+                }
+            }
+            jmap_parser_pop(parser);
+        }
+        else if (strcmp(field, "moveToMailboxId")) {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+    jmap_parser_pop(parser);
+}
+
+/* Parse a JMAP Email into its internal representation for creation. */
+static void _parse_email(json_t *jemail,
+                         struct jmap_parser *parser,
+                         struct email *email)
+{
+    email->jemail = json_incref(jemail);
+
+    /* mailboxIds */
+    json_t *jmailboxIds = json_object_get(jemail, "mailboxIds");
+    if (json_object_size(jmailboxIds)) {
+        const char *mailboxid;
+        json_t *jval;
+        jmap_parser_push(parser, "mailboxIds");
+        json_object_foreach(jmailboxIds, mailboxid, jval) {
+            if (*mailboxid == '\0' || jval != json_true()) {
+                jmap_parser_invalid(parser, NULL);
+                break;
+            }
+        }
+        jmap_parser_pop(parser);
+    }
+    else {
+        jmap_parser_invalid(parser, "mailboxIds");
+    }
+
+    /* keywords */
+    json_t *jkeywords = json_object_get(jemail, "keywords");
+    if (json_is_object(jkeywords)) {
+        const char *keyword;
+        json_t *jval;
+        jmap_parser_push(parser, "keywords");
+        json_object_foreach(jkeywords, keyword, jval) {
+            if (jval != json_true() || !jmap_email_keyword_is_valid(keyword)) {
+                jmap_parser_invalid(parser, keyword);
+            }
+        }
+        jmap_parser_pop(parser);
+    }
+    else if (JNOTNULL(jkeywords)) {
+        jmap_parser_invalid(parser, "keywords");
+    }
+
+    /* headers */
+    if (JNOTNULL(json_object_get(jemail, "headers"))) {
+        jmap_parser_invalid(parser, "headers");
+    }
+    /* header:Xxx */
+    _headers_parseprops(jemail, parser, &email->headers);
+    size_t i;
+    json_t *jheader;
+    json_array_foreach(email->headers.raw, i, jheader) {
+        const char *name = json_string_value(json_object_get(jheader, "name"));
+        const char *val = json_string_value(json_object_get(jheader, "value"));
+        /* Reject Content-Xxx headers in Email/headers */
+        if (!strncasecmp("Content-", name, 8)) {
+            char *tmp = strconcat("header:", name, NULL);
+            jmap_parser_invalid(parser, tmp);
+            free(tmp);
+        }
+        else if (!strcasecmp("Message-ID", name) || !strcasecmp("In-Reply-To", name)) {
+            /* conversations.db will barf if these are invalid raw headers,
+             * so make sure we reject invalid values here. */
+            if (conversations_check_msgid(val, strlen(val))) {
+                char *tmp = strconcat("header:", name, NULL);
+                jmap_parser_invalid(parser, tmp);
+                free(tmp);
+            }
+        }
+    }
+
+    /* Parse convenience header properties - in order as serialised */
+    struct buf buf = BUF_INITIALIZER;
+    json_t *prop;
+    int seen_header;
+
+    /* messageId */
+    prop = json_object_get(jemail, "messageId");
+    seen_header = _headers_have(&email->headers, "Message-Id");
+    if (json_array_size(prop) == 1 && !seen_header) {
+        _headers_add_new(&email->headers, _header_from_messageids(prop,
+                    parser, "messageId", "Message-Id", HEADER_FORM_MESSAGEIDS));
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "messageId");
+    }
+    /* inReplyTo */
+    prop = json_object_get(jemail, "inReplyTo");
+    seen_header = _headers_have(&email->headers, "In-Reply-To");
+    if (json_is_array(prop) && !seen_header) {
+        _headers_add_new(&email->headers, _header_from_messageids(prop,
+                    parser, "inReplyTo", "In-Reply-To", HEADER_FORM_MESSAGEIDS));
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "inReplyTo");
+    }
+    /* references */
+    prop = json_object_get(jemail, "references");
+    seen_header = _headers_have(&email->headers, "References");
+    if (json_is_array(prop) && !seen_header) {
+        _headers_add_new(&email->headers, _header_from_messageids(prop,
+                    parser, "references", "References", HEADER_FORM_MESSAGEIDS));
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "references");
+    }
+    /* sentAt */
+    prop = json_object_get(jemail, "sentAt");
+    seen_header = _headers_have(&email->headers, "Date");
+    if (json_is_string(prop) && !seen_header) {
+        _headers_add_new(&email->headers, _header_from_date(prop,
+                    parser, "sentAt", "Date", HEADER_FORM_DATE));
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "sentAt");
+    }
+    /* receivedAt */
+    prop = json_object_get(jemail, "receivedAt");
+    if (json_is_utcdate(prop)) {
+        time_from_iso8601(json_string_value(prop), &email->internaldate);
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "receivedAt");
+    }
+    /* from */
+    prop = json_object_get(jemail, "from");
+    seen_header = _headers_have(&email->headers, "From");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "from",
+                        "From", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "from");
+    }
+    /* replyTo */
+    prop = json_object_get(jemail, "replyTo");
+    seen_header = _headers_have(&email->headers, "Reply-To");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "replyTo",
+                        "Reply-To", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "replyTo");
+    }
+    /* sender */
+    prop = json_object_get(jemail, "sender");
+    seen_header = _headers_have(&email->headers, "Sender");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "sender",
+                        "Sender", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "sender");
+    }
+    /* to */
+    prop = json_object_get(jemail, "to");
+    seen_header = _headers_have(&email->headers, "To");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "to",
+                        "To", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "to");
+    }
+    /* cc */
+    prop = json_object_get(jemail, "cc");
+    seen_header = _headers_have(&email->headers, "Cc");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "cc",
+                        "Cc", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "cc");
+    }
+    /* bcc */
+    prop = json_object_get(jemail, "bcc");
+    seen_header = _headers_have(&email->headers, "Bcc");
+    if (json_is_array(prop) && !seen_header) {
+        if ((jheader = _header_from_addresses(prop, parser, "bcc",
+                        "Bcc", HEADER_FORM_ADDRESSES))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "bcc");
+    }
+    /* subject */
+    prop = json_object_get(jemail, "subject");
+    seen_header = _headers_have(&email->headers, "Subject");
+    if (json_is_string(prop) && !seen_header) {
+        if ((jheader = _header_from_text(prop, parser, "subject",
+                        "Subject", HEADER_FORM_TEXT))) {
+            _headers_add_new(&email->headers, jheader);
+        }
+    }
+    else if (JNOTNULL(prop)) {
+        jmap_parser_invalid(parser, "subject");
+    }
+    buf_free(&buf);
+
+    /* Parse bodies */
+    _email_parse_bodies(jemail, parser, email);
+
+    /* Is snoozed being set? */
+    json_t *snoozed = json_object_get(jemail, "snoozed");
+    if (json_is_object(snoozed)) {
+        _email_snoozed_parse(snoozed, parser);
+    }
+    else if (JNOTNULL(snoozed)) {
+        jmap_parser_invalid(parser, "snoozed");
+    }
+    email->snoozed = snoozed;
+}
+
+static void _emailpart_blob_to_mime(jmap_req_t *req,
+                                    FILE *fp,
+                                    struct emailpart *emailpart,
+                                    json_t *missing_blobs)
+{
+    struct buf blob_buf = BUF_INITIALIZER;
+    msgrecord_t *mr = NULL;
+    struct mailbox *mbox = NULL;
+    struct body *body = NULL;
+    const struct body *part = NULL;
+
+    /* Find body part containing blob */
+    int r = jmap_findblob(req, NULL/*accountid*/, emailpart->blob_id,
+                          &mbox, &mr, &body, &part, &blob_buf);
+    if (r) goto done;
+
+    uint32_t size;
+    r = msgrecord_get_size(mr, &size);
+    if (r) goto done;
+
+    /* Fetch blob contents and headers */
+    const char *content = blob_buf.s;
+    size_t content_size = blob_buf.len;
+    const char *src_encoding = NULL;
+    if (part) {
+        content += part->content_offset;
+        content_size = part->content_size;
+        src_encoding = part->encoding;
+    }
+
+    /* Determine target encoding */
+    const char *encoding = src_encoding;
+    char *encbuf = NULL;
+
+    if (!strcasecmpsafe(emailpart->type, "MESSAGE")) {
+        if (!strcasecmpsafe(src_encoding, "BASE64")) {
+            /* This is a MESSAGE and hence it is only allowed
+             * to be in 7bit, 8bit or binary encoding. Base64
+             * is not allowed, so let's decode the blob and
+             * assume it to be in binary encoding. */
+            encoding = "BINARY";
+            content = charset_decode_mimebody(content, content_size,
+                    ENCODING_BASE64, &encbuf, &content_size);
+        }
+    }
+    else if (strcasecmpsafe(src_encoding, "QUOTED-PRINTABLE") &&
+             strcasecmpsafe(src_encoding, "BASE64")) {
+        /* Encode text to quoted-printable, if it isn't an attachment */
+        if (!strcasecmpsafe(emailpart->type, "TEXT") &&
+            (!strcasecmpsafe(emailpart->subtype, "PLAIN") ||
+             !strcasecmpsafe(emailpart->subtype, "HTML")) &&
+            (!emailpart->disposition || !strcasecmp(emailpart->disposition, "INLINE"))) {
+            encoding = "QUOTED-PRINTABLE";
+            size_t lenqp = 0;
+            encbuf = charset_qpencode_mimebody(content, content_size, 0, &lenqp);
+            content = encbuf;
+            content_size = lenqp;
+        }
+        /* Encode all other types to base64 */
+        else {
+            encoding = "BASE64";
+            size_t len64 = 0;
+            /* Pre-flight encoder to determine length */
+            charset_encode_mimebody(NULL, content_size, NULL, &len64, NULL, 1 /* wrap */);
+            if (len64) {
+                /* Now encode the body */
+                encbuf = xmalloc(len64);
+                charset_encode_mimebody(content, content_size, encbuf, &len64, NULL, 1 /* wrap */);
+            }
+            content = encbuf;
+            content_size = len64;
+        }
+    }
+
+    /* Write headers defined by client. */
+    size_t i;
+    json_t *jheader;
+    json_array_foreach(emailpart->headers.raw, i, jheader) {
+        json_t *jval = json_object_get(jheader, "name");
+        const char *name = json_string_value(jval);
+        jval = json_object_get(jheader, "value");
+        const char *value = json_string_value(jval);
+        fprintf(fp, "%s: %s\r\n", name, value);
+    }
+
+    /* Write encoding header, if required */
+    if (encoding) {
+        fputs("Content-Transfer-Encoding: ", fp);
+        fputs(encoding, fp);
+        fputs("\r\n", fp);
+    }
+    /* Write body */
+    fputs("\r\n", fp);
+    if (content_size) fwrite(content, 1, content_size, fp);
+    free(encbuf);
+
+done:
+    if (r) json_array_append_new(missing_blobs, json_string(emailpart->blob_id));
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    buf_free(&blob_buf);
+}
+
+static void _emailpart_text_to_mime(FILE *fp, struct emailpart *part)
+{
+    json_t *jval = json_object_get(part->jbody, "value");
+    const char *text = json_string_value(jval);
+    size_t len = strlen(text);
+
+    /* Check and sanitise text */
+    int has_long_lines = 0;
+    int is_7bit = 1;
+    const char *p = text;
+    const char *base = text;
+    const char *top = text + len;
+    const char *last_lf = p;
+    struct buf txtbuf = BUF_INITIALIZER;
+    for (p = base; p < top; p++) {
+        /* Keep track of line-length and high-bit bytes */
+        if (p - last_lf > 998)
+            has_long_lines = 1;
+        if (*p == '\n')
+            last_lf = p;
+        if (*p & 0x80)
+            is_7bit = 0;
+        /* Omit CR */
+        if (*p == '\r')
+            continue;
+        /* Expand LF to CRLF */
+        if (*p == '\n')
+            buf_putc(&txtbuf, '\r');
+        buf_putc(&txtbuf, *p);
+    }
+    const char *charset = NULL;
+    if (!is_7bit) charset = "utf-8";
+
+    /* Write headers */
+    size_t i;
+    json_t *jheader;
+    json_array_foreach(part->headers.raw, i, jheader) {
+        json_t *jval = json_object_get(jheader, "name");
+        const char *name = json_string_value(jval);
+        jval = json_object_get(jheader, "value");
+        const char *value = json_string_value(jval);
+        if (!strcasecmp(name, "Content-Type") && charset) {
+            /* Clients are forbidden to set charset on TEXT bodies,
+             * so make sure we properly set the parameter value. */
+            fprintf(fp, "%s: %s;charset=%s\r\n", name, value, charset);
+        }
+        else {
+            fprintf(fp, "%s: %s\r\n", name, value);
+        }
+    }
+    /* Write body */
+    if (!is_7bit || has_long_lines) {
+        /* Write quoted printable */
+        size_t qp_len = 0;
+        char *qp_text = charset_qpencode_mimebody(txtbuf.s, txtbuf.len, 1, &qp_len);
+        fputs("Content-Transfer-Encoding: quoted-printable\r\n", fp);
+        fputs("\r\n", fp);
+        fwrite(qp_text, 1, qp_len, fp);
+        free(qp_text);
+    }
+    else {
+        /*  Write plain */
+        fputs("\r\n", fp);
+        fwrite(buf_cstring(&txtbuf), 1, buf_len(&txtbuf), fp);
+    }
+
+    buf_free(&txtbuf);
+}
+
+static void _emailpart_to_mime(jmap_req_t *req, FILE *fp,
+                               struct emailpart *part,
+                               json_t *missing_blobs)
+{
+    if (part->subparts.count) {
+        /* Write raw headers */
+        size_t i;
+        json_t *jheader;
+        json_array_foreach(part->headers.raw, i, jheader) {
+            json_t *jval = json_object_get(jheader, "name");
+            const char *name = json_string_value(jval);
+            jval = json_object_get(jheader, "value");
+            const char *value = json_string_value(jval);
+            fprintf(fp, "%s: %s\r\n", name, value);
+        }
+        /* Write default Content-Type, if not set */
+        if (!_headers_have(&part->headers, "Content-Type")) {
+            part->boundary = _mime_make_boundary();
+            fputs("Content-Type: multipart/mixed;boundary=", fp);
+            fputs(part->boundary, fp);
+            fputs("\r\n", fp);
+        }
+        /* Write sub parts */
+        int j;
+        int is_digest = part->type && !strcasecmp(part->type, "MULTIPART") &&
+                        part->subtype && !strcasecmp(part->subtype, "DIGEST");
+        for (j = 0; j < part->subparts.count; j++) {
+            struct emailpart *subpart = ptrarray_nth(&part->subparts, j);
+            if (is_digest && !subpart->type && subpart->blob_id) {
+                /* multipart/digest changes the default content type of this
+                 * part from text/plain to message/rfc822, so make sure that
+                 * emailpart_blob_to_mime will properly deal with it */
+                subpart->type = xstrdup("MESSAGE");
+                subpart->subtype = xstrdup("RFC822");
+            }
+            fprintf(fp, "\r\n--%s\r\n", part->boundary);
+            _emailpart_to_mime(req, fp, subpart, missing_blobs);
+        }
+        fprintf(fp, "\r\n--%s--\r\n", part->boundary);
+    }
+    else if (part->jbody) {
+        _emailpart_text_to_mime(fp, part);
+    }
+    else if (part->blob_id) {
+        _emailpart_blob_to_mime(req, fp, part, missing_blobs);
+    }
+}
+
+static int _email_have_toplevel_header(struct email *email, const char *lcasename)
+{
+    json_t *header = json_object_get(email->headers.all, lcasename);
+    if (!header && email->body) {
+        header = json_object_get(email->body->headers.all, lcasename);
+    }
+    return JNOTNULL(header);
+}
+
+static int _email_to_mime(jmap_req_t *req, FILE *fp, void *rock, json_t **err)
+{
+    struct email *email = rock;
+    json_t *header;
+    size_t i;
+
+    /* Set mandatory and quasi-mandatory headers */
+    if (!_email_have_toplevel_header(email, "mime-version")) {
+        header = json_pack("{s:s s:s}", "name", "Mime-Version", "value", "1.0");
+        _headers_shift_new(&email->headers, header);
+    }
+    if (!_email_have_toplevel_header(email, "user-agent")) {
+        char *tmp = strconcat("Cyrus-JMAP/", CYRUS_VERSION, NULL);
+        header = json_pack("{s:s s:s}", "name", "User-Agent", "value", tmp);
+        _headers_shift_new(&email->headers, header);
+        free(tmp);
+    }
+    if (!_email_have_toplevel_header(email, "message-id")) {
+        struct buf buf = BUF_INITIALIZER;
+        buf_printf(&buf, "<%s@%s>", makeuuid(), config_servername);
+        header = json_pack("{s:s s:s}", "name", "Message-Id", "value", buf_cstring(&buf));
+        _headers_shift_new(&email->headers, header);
+        buf_free(&buf);
+    }
+    if (!_email_have_toplevel_header(email, "date")) {
+        char fmt[RFC5322_DATETIME_MAX+1];
+        memset(fmt, 0, RFC5322_DATETIME_MAX+1);
+        time_to_rfc5322(time(NULL), fmt, RFC5322_DATETIME_MAX+1);
+        header = json_pack("{s:s s:s}", "name", "Date", "value", fmt);
+        _headers_shift_new(&email->headers, header);
+    }
+    if (!_email_have_toplevel_header(email, "from")) {
+        header = json_pack("{s:s s:s}", "name", "From", "value", req->userid);
+        _headers_shift_new(&email->headers, header);
+    }
+
+    /* Write headers */
+    json_array_foreach(email->headers.raw, i, header) {
+        json_t *jval;
+        jval = json_object_get(header, "name");
+        const char *name = json_string_value(jval);
+        jval = json_object_get(header, "value");
+        const char *value = json_string_value(jval);
+        fprintf(fp, "%s: %s\r\n", name, value);
+    }
+
+    json_t *missing_blobs = json_array();
+    if (email->body) _emailpart_to_mime(req, fp, email->body, missing_blobs);
+    if (json_array_size(missing_blobs)) {
+        *err = json_pack("{s:s s:o}", "type", "blobNotFound",
+                "notFound", missing_blobs);
+    }
+    else {
+        json_decref(missing_blobs);
+    }
+
+    return 0;
+}
+
+static void _append_validate_mboxids(jmap_req_t *req,
+                                     json_t *jmailboxids,
+                                     struct jmap_parser *parser,
+                                     int *have_snoozed_mboxid)
+{
+    char *snoozed_mboxname = NULL, *snoozed_uniqueid = NULL;
+    const char *mbox_id;
+    json_t *jval;
+    void *tmp;
+
+    jmap_mailbox_find_role(req, "snoozed", &snoozed_mboxname, &snoozed_uniqueid);
+
+    jmap_parser_push(parser, "mailboxIds");
+    json_object_foreach_safe(jmailboxids, tmp, mbox_id, jval) {
+        int need_rights = ACL_LOOKUP|ACL_INSERT;
+        int is_valid = 1;
+        if (*mbox_id == '$') {
+            /* Lookup mailbox by role */
+            const char *role = mbox_id + 1;
+            char *uniqueid = NULL;
+            char *mboxname = NULL;
+            if (snoozed_uniqueid && !strcmp(role, "snoozed") &&
+                jmap_hasrights_byname(req, snoozed_mboxname, need_rights)) {
+                /* Flag this mailboxId as being $snoozed */
+                json_object_del(jmailboxids, mbox_id);
+                json_object_set_new(jmailboxids,
+                                    snoozed_uniqueid, json_string("$snoozed"));
+                *have_snoozed_mboxid = 1;
+            }
+            else if (!jmap_mailbox_find_role(req, role, &mboxname, &uniqueid) &&
+                jmap_hasrights_byname(req, mboxname, need_rights)) {
+                json_object_del(jmailboxids, mbox_id);
+                json_object_set_new(jmailboxids, uniqueid, json_true());
+            }
+            else {
+                jmap_parser_invalid(parser, NULL);
+                is_valid = 0;
+            }
+            free(uniqueid);
+            free(mboxname);
+        }
+        else {
+            /* Lookup mailbox by id */
+            const mbentry_t *mbentry = NULL;
+            if (*mbox_id == '#') {
+                mbox_id = jmap_lookup_id(req, mbox_id + 1);
+            }
+            if (mbox_id) {
+                mbentry = jmap_mbentry_by_uniqueid(req, mbox_id);
+            }
+            if (!mbentry || !jmap_hasrights(req, mbentry, need_rights)) {
+                jmap_parser_invalid(parser, NULL);
+                is_valid = 0;
+            }
+            else if (!strcmpnull(snoozed_uniqueid, mbentry->uniqueid)) {
+                /* Flag this mailboxId as being $snoozed */
+                json_object_set_new(jmailboxids,
+                                    mbox_id, json_string("$snoozed"));
+                *have_snoozed_mboxid = 1;
+            }
+        }
+        if (!is_valid) break;
+    }
+    jmap_parser_pop(parser);
+
+    free(snoozed_mboxname);
+    free(snoozed_uniqueid);
+}
+
+static void _email_create(jmap_req_t *req,
+                          json_t *jemail,
+                          json_t **new_email,
+                          json_t **set_err)
+{
+    strarray_t keywords = STRARRAY_INITIALIZER;
+    int r = 0, have_snoozed_mboxid = 0;
+    *set_err = NULL;
+    struct email_append_detail detail;
+    memset(&detail, 0, sizeof(struct email_append_detail));
+
+    /* Parse Email object into internal representation */
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct email email = { HEADERS_INITIALIZER, NULL, NULL, time(NULL), 0, NULL };
+    _parse_email(jemail, &parser, &email);
+
+    /* Validate mailboxIds */
+    json_t *jmailboxids = json_copy(json_object_get(jemail, "mailboxIds"));
+    _append_validate_mboxids(req, jmailboxids, &parser, &have_snoozed_mboxid);
+
+    /* Validate snoozed + mailboxIds */
+    if (json_is_object(email.snoozed) && !have_snoozed_mboxid) {
+        jmap_parser_invalid(&parser, "snoozed");
+    }
+    if (json_array_size(parser.invalid)) {
+        *set_err = json_pack("{s:s s:O}", "type", "invalidProperties",
+                "properties", parser.invalid);
+        goto done;
+    }
+
+    /* Gather keywords */
+    json_t *jkeywords = json_object_get(jemail, "keywords");
+    if (json_object_size(jkeywords)) {
+        json_t *jval;
+        const char *keyword;
+        json_object_foreach(jkeywords, keyword, jval) {
+            if (!strcasecmp(keyword, JMAP_HAS_ATTACHMENT_FLAG)) {
+                continue;
+            }
+            strarray_append(&keywords, keyword);
+        }
+    }
+    if (keywords.count > MAX_USER_FLAGS) {
+        *set_err = json_pack("{s:s}",  "type", "tooManyKeywords");
+        goto done;
+    }
+
+    /* Append MIME-encoded Email to mailboxes and write keywords */
+
+    _email_append(req, jmailboxids, &keywords, email.internaldate, email.snoozed,
+                  config_getswitch(IMAPOPT_JMAP_SET_HAS_ATTACHMENT) ?
+                  email.has_attachment : 0, NULL, _email_to_mime, &email,
+                  &detail, set_err);
+    if (*set_err) goto done;
+
+    /* Return newly created Email object */
+    *new_email = json_pack("{s:s, s:s, s:s, s:i}",
+         "id", detail.email_id,
+         "blobId", detail.blob_id,
+         "threadId", detail.thread_id,
+         "size", detail.size);
+    *set_err = NULL;
+
+done:
+    if (r && *set_err == NULL) {
+        syslog(LOG_ERR, "jmap: email_create: %s", error_message(r));
+        if (r == IMAP_QUOTA_EXCEEDED)
+            *set_err = json_pack("{s:s}", "type", "overQuota");
+        else
+            *set_err = jmap_server_error(r);
+    }
+    json_decref(jmailboxids);
+    strarray_fini(&keywords);
+    jmap_parser_fini(&parser);
+    _email_fini(&email);
+}
+
+static int _email_uidrec_compareuid_cb(const void **pa, const void **pb)
+{
+    const struct email_uidrec *a = *pa;
+    const struct email_uidrec *b = *pb;
+    if (a->uid < b->uid)
+        return -1;
+    else if (a->uid > b->uid)
+        return 1;
+    else
+        return 0;
+}
+
+static void _email_mboxrec_free(struct email_mboxrec *mboxrec)
+{
+    struct email_uidrec *uidrec;
+    while ((uidrec = ptrarray_pop(&mboxrec->uidrecs))) {
+        free(uidrec->email_id);
+        free(uidrec);
+    }
+    ptrarray_fini(&mboxrec->uidrecs);
+    free(mboxrec->mboxname);
+    free(mboxrec->mbox_id);
+    free(mboxrec);
+}
+
+static void _email_mboxrecs_free(ptrarray_t **mboxrecsptr)
+{
+    if (mboxrecsptr == NULL || *mboxrecsptr == NULL) return;
+
+    ptrarray_t *mboxrecs = *mboxrecsptr;
+    int i;
+    for (i = 0; i < ptrarray_size(mboxrecs); i++) {
+        _email_mboxrec_free(ptrarray_nth(mboxrecs, i));
+    }
+    ptrarray_free(mboxrecs);
+    *mboxrecsptr = NULL;
+}
+
+struct email_mboxrecs_make_rock {
+    jmap_req_t *req;
+    const char *email_id;
+    ptrarray_t *mboxrecs;
+};
+
+static int _email_mboxrecs_read_cb(const conv_guidrec_t *rec, void *_rock)
+{
+    struct email_mboxrecs_make_rock *rock = _rock;
+    ptrarray_t *mboxrecs = rock->mboxrecs;
+
+    /* don't process emails that have this email attached! */
+    if (rec->part) return 0;
+
+    if (!jmap_hasrights_byname(rock->req, rec->mboxname, ACL_READ|ACL_LOOKUP)) return 0;
+
+    /* Check if there's already a mboxrec for this mailbox. */
+    int i;
+    struct email_mboxrec *mboxrec = NULL;
+    for (i = 0; i < ptrarray_size(mboxrecs); i++) {
+        struct email_mboxrec *p = ptrarray_nth(mboxrecs, i);
+        if (!strcmp(rec->mboxname, p->mboxname)) {
+            mboxrec = p;
+            break;
+        }
+    }
+    if (mboxrec == NULL) {
+        mbentry_t *mbentry = NULL;
+        int r = mboxlist_lookup(rec->mboxname, &mbentry, NULL);
+        if (r) return r;
+
+        // we only want regular mailboxes!
+        if (mbentry->mbtype & MBTYPES_NONIMAP) {
+            mboxlist_entry_free(&mbentry);
+            return 0;
+        }
+
+        mboxrec = xzmalloc(sizeof(struct email_mboxrec));
+        mboxrec->mboxname = xstrdup(rec->mboxname);
+        mboxrec->mbox_id = xstrdup(mbentry->uniqueid);
+        ptrarray_append(mboxrecs, mboxrec);
+        mboxlist_entry_free(&mbentry);
+    }
+
+    struct email_uidrec *uidrec = xzmalloc(sizeof(struct email_uidrec));
+    uidrec->mboxrec = mboxrec;
+    uidrec->email_id = xstrdup(rock->email_id);
+    uidrec->uid = rec->uid;
+    uidrec->is_snoozed =
+        ((rec->internal_flags & (FLAG_INTERNAL_SNOOZED | FLAG_INTERNAL_EXPUNGED))
+         == FLAG_INTERNAL_SNOOZED);
+    ptrarray_append(&mboxrec->uidrecs, uidrec);
+
+    return 0;
+}
+
+static void _email_mboxrecs_read(jmap_req_t *req,
+                                 struct conversations_state *cstate,
+                                 strarray_t *email_ids,
+                                 json_t *set_errors,
+                                 ptrarray_t **mboxrecsptr)
+{
+    ptrarray_t *mboxrecs = ptrarray_new();
+
+    int i;
+    for (i = 0; i < strarray_size(email_ids); i++) {
+        const char *email_id = strarray_nth(email_ids, i);
+        if (email_id[0] != 'M' || strlen(email_id) != 25) {
+            // not a valid emailId
+            continue;
+        }
+
+        struct email_mboxrecs_make_rock rock = { req, email_id, mboxrecs };
+        int r = conversations_guid_foreach(cstate, _guid_from_id(email_id),
+                                           _email_mboxrecs_read_cb, &rock);
+        if (r) {
+            json_t *err = (r == IMAP_NOTFOUND || r == IMAP_PERMISSION_DENIED) ?
+                json_pack("{s:s}", "notFound") : jmap_server_error(r);
+            json_object_set_new(set_errors, email_id, err);
+            _email_mboxrecs_free(&mboxrecs);
+        }
+    }
+
+    // sort the UID lists
+    for (i = 0; i < ptrarray_size(mboxrecs); i++) {
+        struct email_mboxrec *p = ptrarray_nth(mboxrecs, i);
+        ptrarray_sort(&p->uidrecs, _email_uidrec_compareuid_cb);
+    }
+
+    *mboxrecsptr = mboxrecs;
+}
+
+/* Parsed JMAP Email/set#{update} argument. */
+struct email_update {
+    const char *email_id;     /* Id of updated JMAP email */
+    json_t *keywords;         /* JMAP Email/set keywords argument */
+    int patch_keywords;       /* True if keywords is a patch object */
+    json_t *full_keywords;    /* Patched JMAP keywords across index records */
+    json_t *mailboxids;       /* JMAP Email/set mailboxIds argument */
+    int patch_mailboxids;     /* True if mailboxids is a patch object */
+    json_t *snoozed;          /* JMAP Email/set snoozed argument */
+    int patch_snoozed;        /* True if snoozed is a patch object */
+    struct email_uidrec *snoozed_uidrec; /* Currently snoozed email */
+    char *snooze_in_mboxid;   /* Snooze the email in this mailboxid */
+};
+
+static void _email_update_free(struct email_update *update)
+{
+    json_decref(update->keywords);
+    json_decref(update->full_keywords);
+    json_decref(update->mailboxids);
+    json_decref(update->snoozed);
+    free(update->snooze_in_mboxid);
+    free(update);
+}
+
+struct modified_flags {
+    int added_flags;
+    bit32 added_system_flags;
+    bit32 added_user_flags[MAX_USER_FLAGS/32];
+    int removed_flags;
+    bit32 removed_system_flags;
+    bit32 removed_user_flags[MAX_USER_FLAGS/32];
+};
+
+/* Overwrite or patch the JMAP keywords on message record mrw.
+ * If add_seen_uids or del_seen_uids is not NULL, then
+ * the record UID is added to respective sequence set,
+ * if the flag must be set or deleted. */
+static int _email_setflags(json_t *keywords, int patch_keywords,
+                           msgrecord_t *mrw,
+                           struct seqset *add_seen_uids,
+                           struct seqset *del_seen_uids,
+                           struct modified_flags *modflags)
+{
+    uint32_t internal_flags = 0;
+    struct mailbox *mbox = NULL;
+    uint32_t uid = 0;
+
+    int r = msgrecord_get_mailbox(mrw, &mbox);
+    if (r) return r;
+    r = msgrecord_get_uid(mrw, &uid);
+    if (r) goto done;
+    r = msgrecord_get_internalflags(mrw, &internal_flags);
+    if (r) goto done;
+    if (internal_flags & FLAG_INTERNAL_EXPUNGED) goto done;
+
+    uint32_t old_system_flags = 0;
+    r = msgrecord_get_systemflags(mrw, &old_system_flags);
+    if (r) goto done;
+
+    uint32_t old_user_flags[MAX_USER_FLAGS/32];
+    r = msgrecord_get_userflags(mrw, old_user_flags);
+    if (r) goto done;
+
+    /* Determine if to patch or reset flags */
+    uint32_t new_system_flags = 0;
+    uint32_t new_user_flags[MAX_USER_FLAGS/32];
+    if (patch_keywords) {
+        new_system_flags = old_system_flags;
+        memcpy(new_user_flags, old_user_flags, sizeof(old_user_flags));
+    }
+    else {
+        new_system_flags = (old_system_flags & ~FLAGS_SYSTEM) |
+                           (old_system_flags & FLAG_DELETED);
+        memset(new_user_flags, 0, sizeof(new_user_flags));
+    }
+
+    /* Update flags */
+    json_t *jval;
+    const char *keyword;
+    json_object_foreach(keywords, keyword, jval) {
+        if (!strcasecmp(keyword, "$Flagged")) {
+            if (jval == json_true())
+                new_system_flags |= FLAG_FLAGGED;
+            else
+                new_system_flags &= ~FLAG_FLAGGED;
+        }
+        else if (!strcasecmp(keyword, "$Answered")) {
+            if (jval == json_true())
+                new_system_flags |= FLAG_ANSWERED;
+            else
+                new_system_flags &= ~FLAG_ANSWERED;
+        }
+        else if (!strcasecmp(keyword, "$Seen")) {
+            if (jval == json_true()) {
+                if (add_seen_uids)
+                    seqset_add(add_seen_uids, uid, 1);
+                else
+                    new_system_flags |= FLAG_SEEN;
+            }
+            else {
+                if (del_seen_uids)
+                    seqset_add(del_seen_uids, uid, 1);
+                else
+                    new_system_flags &= ~FLAG_SEEN;
+            }
+        }
+        else if (!strcasecmp(keyword, "$Draft")) {
+            if (jval == json_true())
+                new_system_flags |= FLAG_DRAFT;
+            else
+                new_system_flags &= ~FLAG_DRAFT;
+        }
+        else {
+            int userflag;
+            r = mailbox_user_flag(mbox, keyword, &userflag, 1);
+            if (r) goto done;
+            if (jval == json_true())
+                new_user_flags[userflag/32] |= 1<<(userflag&31);
+            else
+                new_user_flags[userflag/32] &= ~(1<<(userflag&31));
+        }
+    }
+    if (!patch_keywords && del_seen_uids) {
+        if (json_object_get(keywords, "$seen") == NULL) {
+            seqset_add(del_seen_uids, uid, 1);
+        }
+    }
+
+    /* Write flags to record */
+    r = msgrecord_set_systemflags(mrw, new_system_flags);
+    if (r) goto done;
+    r = msgrecord_set_userflags(mrw, new_user_flags);
+    if (r) goto done;
+    r = msgrecord_rewrite(mrw);
+
+    /* Determine flag delta */
+    memset(modflags, 0, sizeof(struct modified_flags));
+    modflags->added_system_flags = ~old_system_flags & new_system_flags & FLAGS_SYSTEM;
+    if (modflags->added_system_flags) {
+        modflags->added_flags = 1;
+    }
+    modflags->removed_system_flags = old_system_flags & ~new_system_flags & FLAGS_SYSTEM;
+    if (modflags->removed_system_flags) {
+        modflags->removed_flags = 1;
+    }
+
+    size_t i;
+    for (i = 0; i < MAX_USER_FLAGS/32; i++) {
+        modflags->added_user_flags[i] = ~old_user_flags[i] & new_user_flags[i];
+        if (modflags->added_user_flags[i]) {
+            modflags->added_flags = 1;
+        }
+        modflags->removed_user_flags[i] = old_user_flags[i] & ~new_user_flags[i];
+        if (modflags->removed_user_flags[i]) {
+            modflags->removed_flags = 1;
+        }
+    }
+
+done:
+    return r;
+}
+
+struct email_bulkupdate {
+    jmap_req_t *req;                /* JMAP Email/set request context */
+    hash_table updates_by_email_id; /* Map to ptrarray of email_update */
+    hash_table uidrecs_by_email_id; /* Map to ptrarray of email_uidrec, excluding expunged */
+    hash_table plans_by_mbox_id;    /* Map to email_updateplan */
+    json_t *set_errors;             /* JMAP SetError by email id */
+    struct seen *seendb;            /* Seen database for shared mailboxes, or NULL */
+    ptrarray_t *cur_mboxrecs;       /* List of current mbox and UI recs, including expunged */
+    ptrarray_t *new_mboxrecs;       /* New mbox and UID records allocated by planner */
+};
+
+#define _EMAIL_BULKUPDATE_INITIALIZER {\
+    NULL, \
+    HASH_TABLE_INITIALIZER, \
+    HASH_TABLE_INITIALIZER, \
+    HASH_TABLE_INITIALIZER, \
+    json_object(), \
+    NULL, \
+    NULL, \
+    ptrarray_new() \
+}
+
+static void _email_update_parse(json_t *jemail,
+                                struct jmap_parser *parser,
+                                struct email_update *update)
+{
+    struct buf buf = BUF_INITIALIZER;
+
+    /* Are keywords overwritten or patched? */
+    json_t *keywords = json_object_get(jemail, "keywords");
+    if (keywords == NULL) {
+        /* Collect keywords as patch */
+        const char *field = NULL;
+        json_t *jval;
+        keywords = json_object();
+        json_object_foreach(jemail, field, jval) {
+            if (strncmp(field, "keywords/", 9))  {
+                continue;
+            }
+            const char *keyword = field + 9;
+            if (!jmap_email_keyword_is_valid(keyword) || (jval != json_true() && jval != json_null())) {
+                jmap_parser_push(parser, "keywords");
+                jmap_parser_invalid(parser, keyword);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            else if (!strcasecmp(keyword, JMAP_HAS_ATTACHMENT_FLAG)) {
+                continue;
+            }
+            /* At least one keyword gets patched */
+            update->patch_keywords = 1;
+            /* Normalize keywords to lowercase */
+            buf_setcstr(&buf, keyword);
+            buf_lcase(&buf);
+            json_object_set(keywords, buf_cstring(&buf), jval);
+        }
+        if (!json_object_size(keywords)) {
+            json_decref(keywords);
+            keywords = NULL;
+        }
+    }
+    else if (json_is_object(keywords)) {
+        /* Overwrite keywords */
+        json_t *normalized_keywords = json_object();
+        const char *keyword;
+        json_t *jval;
+        json_object_foreach(keywords, keyword, jval) {
+            if (!jmap_email_keyword_is_valid(keyword) || jval != json_true()) {
+                jmap_parser_push(parser, "keywords");
+                jmap_parser_invalid(parser, keyword);
+                jmap_parser_pop(parser);
+                continue;
+            }
+            else if (!strcasecmp(keyword, JMAP_HAS_ATTACHMENT_FLAG)) {
+                continue;
+            }
+            buf_setcstr(&buf, keyword);
+            buf_lcase(&buf);
+            json_object_set(normalized_keywords, buf_cstring(&buf), jval);
+        }
+        keywords = normalized_keywords;
+    }
+    else if (JNOTNULL(keywords)) {
+        jmap_parser_invalid(parser, "keywords");
+    }
+    update->keywords = keywords;
+
+    /* Are mailboxes being overwritten or patched? */
+    json_t *mailboxids = json_copy(json_object_get(jemail, "mailboxIds"));
+    if (mailboxids == NULL) {
+        /* Collect mailboxids as patch */
+        const char *field = NULL;
+        json_t *jval;
+        mailboxids = json_object();
+        /* Check if mailboxIds are patched */
+        json_object_foreach(jemail, field, jval) {
+            if (strncmp(field, "mailboxIds/", 11)) {
+                continue;
+            }
+            const char *mailboxid = field + 11;
+            update->patch_mailboxids = 1;
+            if (jval == json_true() || jval == json_null()) {
+                json_object_set(mailboxids, mailboxid, jval);
+            }
+            else {
+                jmap_parser_push(parser, "mailboxIds");
+                jmap_parser_invalid(parser, mailboxid);
+                jmap_parser_pop(parser);
+            }
+        }
+        if (json_object_size(mailboxids) == 0) {
+            json_decref(mailboxids);
+            mailboxids = NULL;
+        }
+    }
+    update->mailboxids = mailboxids;
+
+    /* Is snoozed being overwritten or patched? */
+    json_t *snoozed = json_copy(json_object_get(jemail, "snoozed"));
+    if (snoozed == NULL) {
+        /* Collect fields as patch */
+        const char *field = NULL;
+        json_t *jval;
+
+        snoozed = json_object();
+        json_object_foreach(jemail, field, jval) {
+            int invalid = 0;
+
+            if (strncmp(field, "snoozed/", 8)) {
+                continue;
+            }
+
+            const char *subfield = field +8;
+            if (!strcmp(subfield, "until")) {
+                if (!json_is_utcdate(jval)) invalid = 1;
+            }
+            else if (!strncmp(subfield, "setKeywords/", 12)) {
+                const char *keyword = subfield + 12;
+                if (!(json_is_boolean(jval) || json_is_null(jval)) ||
+                    !jmap_email_keyword_is_valid(keyword)) invalid = 1;
+            }
+            else if (!strcmp(subfield, "moveToMailboxId")) {
+                if (!json_is_string(jval)) invalid = 1;
+            }
+            else invalid = 1;
+
+            if (invalid) {
+                jmap_parser_invalid(parser, field);
+            }
+            else {
+                /* At least one field gets patched */
+                update->patch_snoozed = 1;
+                json_object_set(snoozed, subfield, jval);
+            }
+        }
+        if (json_object_size(snoozed) == 0) {
+            json_decref(snoozed);
+            snoozed = NULL;
+        }
+    }
+    else if (json_is_object(snoozed)) {
+        _email_snoozed_parse(snoozed, parser);
+    }
+    else if (JNOTNULL(snoozed)) {
+        jmap_parser_invalid(parser, "snoozed");
+    }
+    update->snoozed = snoozed;
+
+    buf_free(&buf);
+}
+
+/* A plan to create, update or destroy messages per mailbox */
+struct email_updateplan {
+    char *mboxname;       /* Mailbox IMAP name */
+    char *mbox_id;        /* Mailbox unique id */
+    struct mailbox *mbox; /* Write-locked mailbox */
+    ptrarray_t copy;      /* Array of array of email_uidrec, grouped by mailbox */
+    ptrarray_t setflags;  /* Array of email_uidrec */
+    ptrarray_t delete;    /* Array of email_uidrec */
+    ptrarray_t snooze;    /* Array of email_uidrec */
+    int needrights;       /* Required ACL bits set */
+    int use_seendb;       /* Set if this mailbox requires seen.db */
+    struct email_mboxrec *mboxrec; /* Mailbox record */
+    struct seendata old_seendata;   /* Lock-read seen data from database */
+    struct seqset *old_seenseq;     /* Parsed seen sequence before update */
+};
+
+void _email_updateplan_free_p(void* p)
+{
+    struct email_updateplan *plan = p;
+    seqset_free(plan->old_seenseq);
+    seen_freedata(&plan->old_seendata);
+    free(plan->mboxname);
+    free(plan->mbox_id);
+    ptrarray_t *tmp;
+    while ((tmp = ptrarray_pop(&plan->copy))) {
+        ptrarray_free((ptrarray_t*)tmp);
+    }
+    ptrarray_fini(&plan->copy);
+    ptrarray_fini(&plan->setflags);
+    ptrarray_fini(&plan->delete);
+    ptrarray_fini(&plan->snooze);
+    free(plan);
+}
+
+void _ptrarray_free_p(void *p)
+{
+    ptrarray_free((ptrarray_t*)p);
+}
+
+
+void _email_bulkupdate_close(struct email_bulkupdate *bulk)
+{
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        jmap_closembox(bulk->req, &plan->mbox);
+    }
+    seen_close(&bulk->seendb); /* force-close on error */
+    hash_iter_free(&iter);
+    free_hash_table(&bulk->uidrecs_by_email_id, _ptrarray_free_p);
+    free_hash_table(&bulk->updates_by_email_id, NULL);
+    free_hash_table(&bulk->plans_by_mbox_id, _email_updateplan_free_p);
+    _email_mboxrecs_free(&bulk->cur_mboxrecs);
+    _email_mboxrecs_free(&bulk->new_mboxrecs);
+    json_decref(bulk->set_errors);
+}
+
+static struct email_updateplan *_email_bulkupdate_addplan(struct email_bulkupdate *bulk,
+                                                          struct mailbox *mbox,
+                                                          struct email_mboxrec *mboxrec)
+{
+    struct email_updateplan *plan = xzmalloc(sizeof(struct email_updateplan));
+    plan->mbox = mbox;
+    plan->mbox_id = xstrdup(mbox->uniqueid);
+    plan->mboxname = xstrdup(mbox->name);
+    plan->mboxrec = mboxrec;
+    plan->use_seendb = !mailbox_internal_seen(plan->mbox, bulk->req->userid);
+    hash_insert(plan->mbox_id, plan, &bulk->plans_by_mbox_id);
+    return plan;
+}
+
+static void _email_updateplan_error(struct email_updateplan *plan, int errcode, json_t *set_errors)
+{
+    json_t *err;
+    switch (errcode) {
+        case IMAP_PERMISSION_DENIED:
+            err = json_pack("{s:s}", "type", "forbidden");
+            break;
+        case IMAP_QUOTA_EXCEEDED:
+            err = json_pack("{s:s}", "type", "overQuota");
+            break;
+        default:
+            err = jmap_server_error(errcode);
+    }
+    int i;
+    for (i = 0; i < ptrarray_size(&plan->copy); i++) {
+        struct email_uidrec *uidrec = ptrarray_nth(&plan->copy, i);
+        if (json_object_get(set_errors, uidrec->email_id)) {
+            continue;
+        }
+        json_object_set(set_errors, uidrec->email_id, err);
+    }
+    for (i = 0; i < ptrarray_size(&plan->setflags); i++) {
+        struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, i);
+        if (json_object_get(set_errors, uidrec->email_id)) {
+            continue;
+        }
+        json_object_set(set_errors, uidrec->email_id, err);
+    }
+    for (i = 0; i < ptrarray_size(&plan->delete); i++) {
+        struct email_uidrec *uidrec = ptrarray_nth(&plan->delete, i);
+        if (json_object_get(set_errors, uidrec->email_id)) {
+            continue;
+        }
+        json_object_set(set_errors, uidrec->email_id, err);
+    }
+    for (i = 0; i < ptrarray_size(&plan->snooze); i++) {
+        struct email_uidrec *uidrec = ptrarray_nth(&plan->snooze, i);
+        if (json_object_get(set_errors, uidrec->email_id)) {
+            continue;
+        }
+        json_object_set(set_errors, uidrec->email_id, err);
+    }
+    json_decref(err);
+}
+
+static void _email_bulkupdate_plan_mailboxids(struct email_bulkupdate *bulk, ptrarray_t *updates)
+{
+    hash_table copyupdates_by_mbox_id = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&copyupdates_by_mbox_id, ptrarray_size(updates)+1, 0);
+
+    int i;
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        const char *email_id = update->email_id;
+
+        if (json_object_get(bulk->set_errors, email_id)) {
+            continue;
+        }
+        ptrarray_t *current_uidrecs = hash_lookup(email_id, &bulk->uidrecs_by_email_id);
+
+        if (update->snooze_in_mboxid) {
+            /* Update/delete existing snoozeDetails */
+
+            if (update->snoozed) {
+                /* Make a new copy of current snoozed message */
+                ptrarray_t *copyupdates =
+                    hash_lookup(update->snooze_in_mboxid,
+                                &copyupdates_by_mbox_id);
+                if (copyupdates == NULL) {
+                    copyupdates = ptrarray_new();
+                    hash_insert(update->snooze_in_mboxid,
+                                copyupdates, &copyupdates_by_mbox_id);
+                }
+                ptrarray_append(copyupdates, update);
+            }
+
+            if (update->snoozed_uidrec &&
+                !strcmp(update->snooze_in_mboxid,
+                        update->snoozed_uidrec->mboxrec->mbox_id)) {
+                /* Delete current snoozed message from mailbox */
+                struct email_updateplan *plan =
+                    hash_lookup(update->snooze_in_mboxid, &bulk->plans_by_mbox_id);
+                ptrarray_append(&plan->delete, update->snoozed_uidrec);
+                plan->needrights |= ACL_EXPUNGE|ACL_DELETEMSG;
+            }
+        }
+
+        if (!update->mailboxids) {
+            continue;
+        }
+
+        if (update->patch_mailboxids) {
+            const char *mbox_id = NULL;
+            json_t *jval = NULL;
+            json_object_foreach(update->mailboxids, mbox_id, jval) {
+                /* Patch the mailbox */
+                if (jval == json_true()) {
+                    /* Lookup the uid record of this email in this mailbox, can be NULL. */
+                    struct email_uidrec *uidrec = NULL;
+                    int j;
+                    for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+                        struct email_uidrec *tmp = ptrarray_nth(current_uidrecs, j);
+                        if (!strcmp(mbox_id, tmp->mboxrec->mbox_id)) {
+                            uidrec = tmp;
+                            break;
+                        }
+                    }
+                    if (uidrec) {
+                        /* This email is patched to stay in it's mailbox. Whatever. */
+                    }
+                    else {
+                        /* This is a new mailbox for this email. Copy it over. */
+                        ptrarray_t *copyupdates = hash_lookup(mbox_id, &copyupdates_by_mbox_id);
+                        if (copyupdates == NULL) {
+                            copyupdates = ptrarray_new();
+                            hash_insert(mbox_id, copyupdates, &copyupdates_by_mbox_id);
+                        }
+                        /* XXX  Use ptrarray_add() here to avoid duplicating
+                           an update already done above via snooze */
+                        ptrarray_add(copyupdates, update);
+                    }
+                }
+                else {
+                    /* Delete all instances of this email in this mailbox. */
+                    struct email_updateplan *plan = hash_lookup(mbox_id, &bulk->plans_by_mbox_id);
+                    int j;
+                    for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+                        struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, j);
+                        if (!strcmp(mbox_id, uidrec->mboxrec->mbox_id)) {
+                            ptrarray_append(&plan->delete, uidrec);
+                            plan->needrights |= ACL_EXPUNGE|ACL_DELETEMSG;
+                        }
+                    }
+                }
+            }
+        }
+        else {
+            json_t *mailboxids = json_deep_copy(update->mailboxids);
+            int j;
+
+            /* For all current uid records of this email, determine if to
+             * keep, create or delete them in their respective mailbox. */
+
+            for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+                struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, j);
+                struct email_mboxrec *mboxrec = uidrec->mboxrec;
+                struct email_updateplan *plan = hash_lookup(mboxrec->mbox_id, &bulk->plans_by_mbox_id);
+                json_t *keep = json_object_get(mailboxids, mboxrec->mbox_id);
+
+                if (keep) {
+                    /* Keep message in mailbox */
+                    json_object_del(mailboxids, mboxrec->mbox_id);
+                }
+                else {
+                    /* Delete message from mailbox */
+                    ptrarray_append(&plan->delete, uidrec);
+                    plan->needrights |= ACL_EXPUNGE|ACL_DELETEMSG;
+                }
+            }
+
+            /* Copy message to any new mailboxes which weren't seen in uidrecs */
+            const char *mbox_id;
+            json_t *jval;
+            json_object_foreach(mailboxids, mbox_id, jval) {
+                ptrarray_t *copyupdates = hash_lookup(mbox_id, &copyupdates_by_mbox_id);
+                if (copyupdates == NULL) {
+                    copyupdates = ptrarray_new();
+                    hash_insert(mbox_id, copyupdates, &copyupdates_by_mbox_id);
+                }
+                ptrarray_append(copyupdates, update);
+            }
+            json_decref(mailboxids);
+        }
+    }
+
+    /* Cluster copy operations by mailbox */
+
+    hash_iter *iter = hash_table_iter(&copyupdates_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        const char *dst_mbox_id = hash_iter_key(iter);
+        ptrarray_t *updates = hash_iter_val(iter);
+
+        /* Determine the number of messages per source mailbox which
+         * could be copied into the destination mailbox. */
+
+        hash_table src_mbox_id_counts = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&src_mbox_id_counts, ptrarray_size(updates)*8+1, 0);
+        int i;
+        for (i = 0; i < ptrarray_size(updates); i++) {
+            struct email_update *update = ptrarray_nth(updates, i);
+            ptrarray_t *current_uidrecs = hash_lookup(update->email_id, &bulk->uidrecs_by_email_id);
+            int j;
+            for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+                struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, j);
+                const char *src_mbox_id = uidrec->mboxrec->mbox_id;
+                uintptr_t count = (uintptr_t) hash_lookup(src_mbox_id, &src_mbox_id_counts);
+                hash_insert(src_mbox_id, (void*) count++, &src_mbox_id_counts);
+            }
+        }
+
+        /* For each copy update, pick the uid record from the source mailbox
+         * that minimizes append_copy calls between mailboxes. */
+
+        for (i = 0; i < ptrarray_size(updates); i++) {
+            struct email_update *update = ptrarray_nth(updates, i);
+            ptrarray_t *current_uidrecs = hash_lookup(update->email_id, &bulk->uidrecs_by_email_id);
+
+            int j;
+            struct email_uidrec *pick_uidrec = ptrarray_nth(current_uidrecs, 0);
+            uintptr_t best_count = (uintptr_t) hash_lookup(pick_uidrec->mboxrec->mbox_id, &src_mbox_id_counts);
+            for (j = 1; j < ptrarray_size(current_uidrecs); j++) {
+                struct email_uidrec *tmp = ptrarray_nth(current_uidrecs, j);
+                uintptr_t count = (uintptr_t) hash_lookup(tmp->mboxrec->mbox_id, &src_mbox_id_counts);
+                if (count > best_count) {
+                    pick_uidrec = tmp;
+                    best_count = count;
+                }
+            }
+
+            /* Add the picked uid record to its slot in the copy plan */
+            struct email_updateplan *plan = hash_lookup(dst_mbox_id, &bulk->plans_by_mbox_id);
+            ptrarray_t *pick_uidrecs = NULL;
+            for (j = 0; j < ptrarray_size(&plan->copy); j++) {
+                ptrarray_t *copy_uidrecs = ptrarray_nth(&plan->copy, j);
+                struct email_uidrec *tmp = ptrarray_nth(copy_uidrecs, 0);
+                if (!strcmp(tmp->mboxrec->mbox_id, pick_uidrec->mboxrec->mbox_id)) {
+                    /* We found an existing slot in the copy plan */
+                    pick_uidrecs = copy_uidrecs;
+                    break;
+                }
+            }
+            if (pick_uidrecs == NULL) {
+                pick_uidrecs = ptrarray_new();
+                ptrarray_append(&plan->copy, pick_uidrecs);
+            }
+            ptrarray_append(pick_uidrecs, pick_uidrec);
+            plan->needrights |= ACL_INSERT;
+        }
+        free_hash_table(&src_mbox_id_counts, NULL);
+    }
+    hash_iter_free(&iter);
+
+    free_hash_table(&copyupdates_by_mbox_id, _ptrarray_free_p);
+}
+
+static void _email_bulkupdate_checklimits(struct email_bulkupdate *bulk)
+{
+    /* Validate mailbox counts per email */
+    hash_table mbox_ids_by_email_id = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&mbox_ids_by_email_id, hash_numrecords(&bulk->uidrecs_by_email_id)+1, 0);
+
+    /* Collect current mailboxes per email */
+    hash_iter *iter = hash_table_iter(&bulk->uidrecs_by_email_id);
+    while (hash_iter_next(iter)) {
+        ptrarray_t *uidrecs = hash_iter_val(iter);
+        int i;
+        for (i = 0; i < ptrarray_size(uidrecs); i++) {
+            struct email_uidrec *uidrec = ptrarray_nth(uidrecs, i);
+            strarray_t *mbox_ids = hash_lookup(uidrec->email_id, &mbox_ids_by_email_id);
+            if (!mbox_ids) {
+                mbox_ids = strarray_new();
+                hash_insert(uidrec->email_id, mbox_ids, &mbox_ids_by_email_id);
+            }
+            strarray_add(mbox_ids, uidrec->mboxrec->mbox_id);
+        }
+    }
+    hash_iter_free(&iter);
+    /* Apply plans to mailbox counts */
+    iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        int i;
+        for (i = 0; i < ptrarray_size(&plan->copy); i++) {
+            ptrarray_t *uidrecs = ptrarray_nth(&plan->copy, i);
+            int j;
+            for (j = 0; j < ptrarray_size(uidrecs); j++) {
+                struct email_uidrec *uidrec = ptrarray_nth(uidrecs, j);
+                strarray_t *mbox_ids = hash_lookup(uidrec->email_id, &mbox_ids_by_email_id);
+                if (!mbox_ids) {
+                    mbox_ids = strarray_new();
+                    hash_insert(uidrec->email_id, mbox_ids, &mbox_ids_by_email_id);
+                }
+                strarray_add(mbox_ids, plan->mbox_id);
+            }
+        }
+        for (i = 0; i < ptrarray_size(&plan->delete); i++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->delete, i);
+            strarray_t *mbox_ids = hash_lookup(uidrec->email_id, &mbox_ids_by_email_id);
+            if (!mbox_ids) {
+                mbox_ids = strarray_new();
+                hash_insert(uidrec->email_id, mbox_ids, &mbox_ids_by_email_id);
+            }
+            strarray_remove_all(mbox_ids, plan->mbox_id);
+        }
+    }
+    hash_iter_free(&iter);
+    /* Validate mailbox counts */
+    iter = hash_table_iter(&mbox_ids_by_email_id);
+    while (hash_iter_next(iter)) {
+        const char *email_id = hash_iter_key(iter);
+        strarray_t *mbox_ids = hash_iter_val(iter);
+        if (!mbox_ids) continue;
+        if (strarray_size(mbox_ids) > JMAP_MAIL_MAX_MAILBOXES_PER_EMAIL) {
+            if (json_object_get(bulk->set_errors, email_id) == NULL) {
+                json_object_set_new(bulk->set_errors, email_id,
+                        json_pack("{s:s}", "type", "tooManyMailboxes"));
+            }
+        }
+        strarray_free(mbox_ids);
+    }
+    hash_iter_free(&iter);
+    free_hash_table(&mbox_ids_by_email_id, NULL);
+
+    /* Validate keyword counts. This assumes keyword patches already
+     * have been replaced with the complete set of patched keywords. */
+    iter = hash_table_iter(&bulk->updates_by_email_id);
+    while (hash_iter_next(iter)) {
+        struct email_update *update = hash_iter_val(iter);
+        if (json_object_get(bulk->set_errors, update->email_id)) {
+            continue;
+        }
+        if (json_object_size(update->keywords) > JMAP_MAIL_MAX_KEYWORDS_PER_EMAIL) {
+            json_object_set_new(bulk->set_errors, update->email_id,
+                    json_pack("{s:s}", "type", "tooManyKeywords"));
+        }
+    }
+    hash_iter_free(&iter);
+}
+
+static json_t *_email_bulkupdate_aggregate_keywords(struct email_bulkupdate *bulk,
+                                                    const char *email_id,
+                                                    hash_table *seenseq_by_mbox_id)
+{
+    ptrarray_t *current_uidrecs = hash_lookup(email_id, &bulk->uidrecs_by_email_id);
+    struct email_keywords keywords = _EMAIL_KEYWORDS_INITIALIZER;
+    _email_keywords_init(&keywords, bulk->req->userid, bulk->seendb, seenseq_by_mbox_id);
+
+    int i;
+    for (i = 0; i < ptrarray_size(current_uidrecs); i++) {
+        struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, i);
+        struct email_updateplan *plan = hash_lookup(uidrec->mboxrec->mbox_id,
+                                                    &bulk->plans_by_mbox_id);
+        msgrecord_t *mr = NULL;
+        int r = msgrecord_find(plan->mbox, uidrec->uid, &mr);
+        if (!r) _email_keywords_add_msgrecord(&keywords, mr);
+        if (r) {
+            if (!json_object_get(bulk->set_errors, uidrec->email_id)) {
+                json_object_set_new(bulk->set_errors, uidrec->email_id,
+                        jmap_server_error(r));
+            }
+        }
+        msgrecord_unref(&mr);
+    }
+    json_t *aggregated_keywords = _email_keywords_to_jmap(&keywords);
+    _email_keywords_fini(&keywords);
+    return aggregated_keywords;
+}
+
+static int _flag_update_changes_seen(json_t *new, json_t *old)
+{
+    int is_seen = json_object_get(new, "$seen") ? 1 : 0;
+    int was_seen = (old && json_object_get(old, "$seen")) ? 1 : 0;
+    return is_seen != was_seen;
+}
+
+static int _flag_update_changes_not_seen(json_t *new, json_t *old)
+{
+    const char *name;
+    json_t *val;
+
+    json_object_foreach(new, name, val) {
+        if (!strcmp(name, "$seen")) continue;
+        int was_seen = (old && json_object_get(old, name)) ? 1 : 0;
+        if (!was_seen) return 1;
+    }
+
+    if (old) {
+        json_object_foreach(old, name, val) {
+            if (!strcmp(name, "$seen")) continue;
+            int is_seen = json_object_get(new, name) ? 1 : 0;
+            if (!is_seen) return 1;
+        }
+    }
+
+
+    return 0;
+}
+
+static void _email_bulkupdate_plan_keywords(struct email_bulkupdate *bulk, ptrarray_t *updates)
+{
+    int i;
+
+    /* Open seen.db, if required */
+    if (strcmp(bulk->req->accountid, bulk->req->userid)) {
+        int r = seen_open(bulk->req->userid, SEEN_CREATE, &bulk->seendb);
+        if (r) {
+            /* There's something terribly wrong. Abort all updates. */
+            syslog(LOG_ERR, "_email_bulkupdate_plan_keywords: can't open seen.db: %s",
+                            error_message(r));
+            for (i = 0; i < ptrarray_size(updates); i++) {
+                struct email_update *update = ptrarray_nth(updates, i);
+                if (json_object_get(bulk->set_errors, update->email_id) == NULL) {
+                    json_object_set_new(bulk->set_errors, update->email_id,
+                            jmap_server_error(r));
+                }
+            }
+            return;
+        }
+    }
+
+    /* Add uid records to each mailboxes setflags plan */
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        const char *email_id = update->email_id;
+
+        if (!update->keywords || json_object_get(bulk->set_errors, email_id)) {
+            continue;
+        }
+        ptrarray_t *current_uidrecs = hash_lookup(email_id, &bulk->uidrecs_by_email_id);
+
+        int j;
+        for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, j);
+            struct email_mboxrec *mboxrec = uidrec->mboxrec;
+            struct email_updateplan *plan = hash_lookup(mboxrec->mbox_id, &bulk->plans_by_mbox_id);
+
+            if (!jmap_hasrights_byname(bulk->req, plan->mboxname, ACL_READ|ACL_LOOKUP)) {
+                continue;
+            }
+            if (!update->mailboxids) {
+                /* Add keyword update to all current uid records */
+                ptrarray_append(&plan->setflags, uidrec);
+            }
+            else {
+                /* Add keyword update to all current records that won't be deleted */
+                json_t *jval = json_object_get(update->mailboxids, mboxrec->mbox_id);
+                if (jval == json_true() || (jval == NULL && update->patch_mailboxids)) {
+                    ptrarray_append(&plan->setflags, uidrec);
+                }
+            }
+        }
+    }
+
+    hash_table seenseq_by_mbox_id = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&seenseq_by_mbox_id, hash_numrecords(&bulk->plans_by_mbox_id)+1, 0);
+
+    /* Plan keyword updates per mailbox */
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        if (plan->use_seendb) {
+            /* Read seen sequence set */
+            int r = seen_lockread(bulk->seendb, plan->mbox->uniqueid, &plan->old_seendata);
+            if (!r) {
+                plan->old_seenseq = seqset_parse(plan->old_seendata.seenuids, NULL, 0);
+                if (!hash_lookup(plan->mbox_id, &seenseq_by_mbox_id))
+                    hash_insert(plan->mbox_id, seqset_dup(plan->old_seenseq), &seenseq_by_mbox_id);
+            }
+            else {
+                int j;
+                for (j = 0; j < ptrarray_size(&plan->setflags); j++) {
+                    struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, j);
+                    if (json_object_get(bulk->set_errors, uidrec->email_id) == NULL) {
+                        json_object_set_new(bulk->set_errors, uidrec->email_id,
+                                jmap_server_error(r));
+                    }
+                }
+            }
+        }
+
+        /* Determine the ACL and keywords for all new uid records */
+        for (i = 0; i < ptrarray_size(&plan->copy); i++) {
+            ptrarray_t *copy_uidrecs = ptrarray_nth(&plan->copy, i);
+            int j;
+            for (j = 0; j < ptrarray_size(copy_uidrecs); j++) {
+                struct email_uidrec *uidrec = ptrarray_nth(copy_uidrecs, j);
+                if (json_object_get(bulk->set_errors, uidrec->email_id)) {
+                    continue;
+                }
+                struct email_update *update = hash_lookup(uidrec->email_id,
+                                                          &bulk->updates_by_email_id);
+
+                if (!update->full_keywords) {
+                    /* Determine the full set of keywords to write on this record */
+                    if (!update->keywords) {
+                        /* Write the combined keywords of all records of this email */
+                        update->full_keywords = _email_bulkupdate_aggregate_keywords(bulk,
+                                                     uidrec->email_id, &seenseq_by_mbox_id);
+                    }
+                    else if (update->patch_keywords) {
+                        /* Write the patched, combined keywords */
+                        json_t *aggregated_keywords = _email_bulkupdate_aggregate_keywords(bulk,
+                                uidrec->email_id, &seenseq_by_mbox_id);
+                        update->full_keywords = jmap_patchobject_apply(aggregated_keywords,
+                                update->keywords, NULL);
+                        json_decref(aggregated_keywords);
+                    }
+                    else {
+                        /* Write the keywords defined in the update */
+                        update->full_keywords = json_incref(update->keywords);
+                    }
+                }
+
+                /* Determine required ACL rights */
+                if (_flag_update_changes_seen(update->full_keywords, NULL))
+                    plan->needrights |= ACL_SETSEEN;
+                if (_flag_update_changes_not_seen(update->full_keywords, NULL))
+                    plan->needrights |= ACL_WRITE;
+                /* XXX - what about annotations? */
+            }
+        }
+
+        /* Determine ACL for all existing uid records with updated keywords */
+        for (i = 0; i < ptrarray_size(&plan->setflags); i++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, i);
+            if (json_object_get(bulk->set_errors, uidrec->email_id)) {
+                continue;
+            }
+            struct email_update *update = hash_lookup(uidrec->email_id,
+                                                      &bulk->updates_by_email_id);
+
+            /* Convert flags to JMAP keywords */
+            struct email_keywords keywords = _EMAIL_KEYWORDS_INITIALIZER;
+            _email_keywords_init(&keywords, bulk->req->userid, bulk->seendb, &seenseq_by_mbox_id);
+            msgrecord_t *mr = NULL;
+            int r = msgrecord_find(plan->mbox, uidrec->uid, &mr);
+            if (!r) _email_keywords_add_msgrecord(&keywords, mr);
+            if (r) {
+                json_object_set_new(bulk->set_errors, uidrec->email_id,
+                        jmap_server_error(r));
+            }
+            msgrecord_unref(&mr);
+            json_t *current_keywords = _email_keywords_to_jmap(&keywords);
+            _email_keywords_fini(&keywords);
+            json_t *new_keywords;
+            if (update->patch_keywords) {
+                new_keywords = jmap_patchobject_apply(current_keywords, update->keywords, NULL);
+            }
+            else {
+                new_keywords = json_incref(update->keywords);
+            }
+
+            /* Determine required ACL rights */
+            if (_flag_update_changes_seen(new_keywords, current_keywords))
+                plan->needrights |= ACL_SETSEEN;
+            if (_flag_update_changes_not_seen(new_keywords, current_keywords))
+                plan->needrights |= ACL_WRITE;
+            /* XXX - what about annotations? */
+
+            json_decref(new_keywords);
+            json_decref(current_keywords);
+        }
+    }
+    hash_iter_free(&iter);
+
+    free_hash_table(&seenseq_by_mbox_id, (void(*)(void*))seqset_free);
+}
+
+static void _email_bulkupdate_plan_snooze(struct email_bulkupdate *bulk,
+                                          ptrarray_t *updates)
+{
+    char *snoozed_mboxid = NULL, *inboxid = NULL;
+
+    jmap_mailbox_find_role(bulk->req, "snoozed", NULL, &snoozed_mboxid);
+    jmap_mailbox_find_role(bulk->req, "inbox", NULL, &inboxid);
+
+    int i;
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        const char *email_id = update->email_id;
+        int invalid = 0, find_mbox = 0;
+
+        if (json_object_get(bulk->set_errors, email_id)) {
+            continue;
+        }
+        ptrarray_t *current_uidrecs =
+            hash_lookup(email_id, &bulk->uidrecs_by_email_id);
+
+        /* Lookup the currently snoozed copy of this email_id */
+        int j;
+        for (j = 0; j < ptrarray_size(current_uidrecs); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(current_uidrecs, j);
+            if (uidrec->is_snoozed) {
+                update->snoozed_uidrec = uidrec;
+                break;
+            }
+        }
+
+        if (update->snoozed_uidrec) {
+            const char *current_mboxid =
+                update->snoozed_uidrec->mboxrec->mbox_id;
+            struct email_updateplan *plan =
+                hash_lookup(current_mboxid, &bulk->plans_by_mbox_id);
+
+            if (update->snoozed) {
+                /* Updating/removing snoozeDetails */
+                json_t *jval = NULL;
+
+                if (update->patch_snoozed) {
+                    const char *current_mboxname =
+                        update->snoozed_uidrec->mboxrec->mboxname;
+                    json_t *orig =
+                        jmap_fetch_snoozed(current_mboxname,
+                                           update->snoozed_uidrec->uid);
+                    json_t *patch = update->snoozed;
+                  
+                    update->snoozed = jmap_patchobject_apply(orig, patch, NULL);
+                    json_decref(orig);
+                    json_decref(patch);
+                }
+
+                if (update->mailboxids) {
+                    jval = json_object_get(update->mailboxids, current_mboxid);
+                }
+                if (!update->mailboxids || jval == json_true() ||
+                     (jval == NULL && update->patch_mailboxids)) {
+                    /* This message is NOT being deleted -
+                       Update/remove snoozed */
+                    update->snooze_in_mboxid = xstrdup(current_mboxid);
+                    update->snoozed_uidrec->is_snoozed = 0;
+                    ptrarray_append(&plan->snooze, update->snoozed_uidrec);
+                }
+                else if (!json_is_null(update->snoozed)) {
+                    /* Determine which mailbox to use for the snoozed email */
+                    find_mbox = 1;
+                }
+            }
+            else if (update->mailboxids) {
+                /* No change to snoozeDetails -
+                   Check if this message is being deleted */
+                json_t *jval =
+                    json_object_get(update->mailboxids, current_mboxid);
+
+                if (jval == json_null() ||
+                    (jval == NULL && !update->patch_mailboxids)) {
+                    /* This message is being deleted - Remove snoozed */
+                    update->snooze_in_mboxid = xstrdup(current_mboxid);
+                    update->snoozed_uidrec->is_snoozed = 0;
+                    ptrarray_append(&plan->snooze, update->snoozed_uidrec);
+                }
+            }
+        }
+        else if (json_is_object(update->snoozed)) {
+            /* Setting snoozeDetails */
+            if (!update->mailboxids) {
+                /* invalidProperties */
+                invalid = 1;
+            }
+            else {
+                /* Determine which mailbox to use for the snoozed email */
+                find_mbox = 1;
+            }
+        }
+
+        if (find_mbox) {
+            /* Determine which mailbox to use for the snoozed email */
+            const char *movetoid =
+                json_string_value(json_object_get(update->snoozed,
+                                                  "moveToMailboxId"));
+
+            if (json_is_true(json_object_get(update->mailboxids,
+                                             snoozed_mboxid))) {
+                /* Being added to \snoozed mailbox */
+                update->snooze_in_mboxid = xstrdup(snoozed_mboxid);
+            }
+            else if (movetoid &&
+                     json_is_true(json_object_get(update->mailboxids,
+                                                  movetoid))) {
+                /* Being added to moveToMailboxId */
+                update->snooze_in_mboxid = xstrdup(movetoid);
+            }
+            else if (json_is_true(json_object_get(update->mailboxids,
+                                                  inboxid))) {
+                /* Being added to Inbox */
+                update->snooze_in_mboxid = xstrdup(inboxid);
+            }
+            else {
+                const char *mbox_id = NULL;
+                json_t *jval = NULL;
+
+                json_object_foreach(update->mailboxids, mbox_id, jval) {
+                    if (json_is_true(jval)) {
+                        /* Use the first mailbox being added to */
+                        update->snooze_in_mboxid = xstrdup(mbox_id);
+                        break;
+                    }
+                }
+
+                if (!update->snooze_in_mboxid) {
+                    /* invalidProperties */
+                    invalid = 1;
+                }
+            }
+        }
+
+        if (invalid) {
+            json_object_set_new(bulk->set_errors, email_id,
+                                json_pack("{s:s s:[s,s]}",
+                                          "type", "invalidProperties",
+                                          "properties", "mailboxIds", "snoozed"));
+        }
+    }
+
+    free(snoozed_mboxid);
+    free(inboxid);
+}
+
+
+static void _email_bulkupdate_plan(struct email_bulkupdate *bulk, ptrarray_t *updates)
+{
+    int i;
+
+    /* Pre-process snooze updates */
+    _email_bulkupdate_plan_snooze(bulk, updates);
+
+    /* Plan mailbox copies, moves and deletes */
+    _email_bulkupdate_plan_mailboxids(bulk, updates);
+
+    /* Pre-process keyword updates */
+    _email_bulkupdate_plan_keywords(bulk, updates);
+
+    /* Check mailbox count and keyword limits per email */
+    _email_bulkupdate_checklimits(bulk);
+
+    /* Validate plans */
+    strarray_t erroneous_plans = STRARRAY_INITIALIZER;
+
+    /* Check permissions */
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        if (!jmap_hasrights_byname(bulk->req, plan->mboxname, plan->needrights)) {
+            _email_updateplan_error(plan, IMAP_PERMISSION_DENIED, bulk->set_errors);
+            strarray_append(&erroneous_plans, plan->mbox_id);
+        }
+    }
+    hash_iter_reset(iter);
+    if (!config_getswitch(IMAPOPT_SINGLEINSTANCESTORE)) {
+        /* Check quota */
+        while (hash_iter_next(iter)) {
+            struct email_updateplan *plan = hash_iter_val(iter);
+            quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_INITIALIZER;
+            int i;
+            for (i = 0; i < ptrarray_size(&plan->copy); i++) {
+                qdiffs[QUOTA_MESSAGE] += ptrarray_size(ptrarray_nth(&plan->copy, i));
+            }
+            qdiffs[QUOTA_MESSAGE] -= ptrarray_size(&plan->delete);
+            int r = mailbox_quota_check(plan->mbox, qdiffs);
+            if (r) {
+                _email_updateplan_error(plan, r, bulk->set_errors);
+                strarray_append(&erroneous_plans, plan->mbox_id);
+            }
+        }
+    }
+    hash_iter_free(&iter);
+
+    /* Remove erroneous plans */
+    for (i = 0; i < strarray_size(&erroneous_plans); i++) {
+        const char *mbox_id = strarray_nth(&erroneous_plans, i);
+        struct email_updateplan *plan = hash_del(mbox_id, &bulk->plans_by_mbox_id);
+        if (!plan) continue;
+        jmap_closembox(bulk->req, &plan->mbox);
+        _email_updateplan_free_p(plan);
+    }
+    strarray_fini(&erroneous_plans);
+
+    /* Sort UID records arrays */
+    iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        for (i = 0; i < ptrarray_size(&plan->copy); i++) {
+            ptrarray_t *uidrecs = ptrarray_nth(&plan->copy, i);
+            ptrarray_sort(uidrecs, _email_uidrec_compareuid_cb);
+        }
+        ptrarray_sort(&plan->setflags, _email_uidrec_compareuid_cb);
+        ptrarray_sort(&plan->delete, _email_uidrec_compareuid_cb);
+        ptrarray_sort(&plan->snooze, _email_uidrec_compareuid_cb);
+    }
+    hash_iter_free(&iter);
+}
+
+static void _email_bulkupdate_open(jmap_req_t *req, struct email_bulkupdate *bulk, ptrarray_t *updates)
+{
+    int i;
+    bulk->req = req;
+
+    /* Map mailbox creation ids and role to mailbox identifiers */
+    for(i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        if (!update->mailboxids) continue;
+
+        void *tmp;
+        const char *mbox_id;
+        json_t *jval;
+        json_object_foreach_safe(update->mailboxids, tmp, mbox_id, jval) {
+            int is_valid = 1;
+            if (*mbox_id == '$') {
+                const char *role = mbox_id + 1;
+                char *mboxname = NULL;
+                char *uniqueid = NULL;
+                if (!jmap_mailbox_find_role(bulk->req, role, &mboxname, &uniqueid)) {
+                    json_object_del(update->mailboxids, mbox_id);
+                    json_object_set(update->mailboxids, uniqueid, jval);
+                }
+                else is_valid = 0;
+                free(uniqueid);
+                free(mboxname);
+            }
+            else if (*mbox_id == '#') {
+                const char *resolved_mbox_id = jmap_lookup_id(req, mbox_id + 1);
+                if (resolved_mbox_id) {
+                    json_object_del(update->mailboxids, mbox_id);
+                    json_object_set(update->mailboxids, resolved_mbox_id, jval);
+                }
+                else is_valid = 0;
+            }
+            if (!is_valid) {
+                if (json_object_get(bulk->set_errors, update->email_id) == NULL) {
+                    json_object_set_new(bulk->set_errors, update->email_id,
+                            json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                                "properties", "mailboxIds"));
+                }
+            }
+        }
+    }
+
+    /* Map updates to their email id */
+    construct_hash_table(&bulk->updates_by_email_id, ptrarray_size(updates)+1, 0);
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        hash_insert(update->email_id, update, &bulk->updates_by_email_id);
+    }
+
+    /* Determine uid records per mailbox */
+    strarray_t email_ids = STRARRAY_INITIALIZER;
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        if (json_object_get(bulk->set_errors, update->email_id)) {
+            continue;
+        }
+        strarray_append(&email_ids, update->email_id);
+    }
+    _email_mboxrecs_read(req, req->cstate, &email_ids, bulk->set_errors, &bulk->cur_mboxrecs);
+
+    /* Open current mailboxes */
+    size_t mboxhash_size = ptrarray_size(updates) * JMAP_MAIL_MAX_MAILBOXES_PER_EMAIL + 1;
+    construct_hash_table(&bulk->plans_by_mbox_id, mboxhash_size, 0);
+    construct_hash_table(&bulk->uidrecs_by_email_id, strarray_size(&email_ids)+1, 0);
+    for (i = 0; i < ptrarray_size(bulk->cur_mboxrecs); i++) {
+        struct email_mboxrec *mboxrec = ptrarray_nth(bulk->cur_mboxrecs, i);
+        struct email_updateplan *plan = hash_lookup(mboxrec->mbox_id, &bulk->plans_by_mbox_id);
+        if (!plan) {
+            struct mailbox *mbox = NULL;
+            const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mboxrec->mbox_id);
+            int r = 0;
+            if (mbentry && mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+                r = mboxlist_promote_intermediary(mbentry->name);
+            }
+            else if (!mbentry) {
+                r = IMAP_MAILBOX_NONEXISTENT;
+            }
+            if (!r) r = jmap_openmbox(req, mboxrec->mboxname, &mbox, /*rw*/1);
+            if (r) {
+                int j;
+                for (j = 0; j < ptrarray_size(&mboxrec->uidrecs); j++) {
+                    struct email_uidrec *uidrec = ptrarray_nth(&mboxrec->uidrecs, j);
+                    if (json_object_get(bulk->set_errors, uidrec->email_id) == NULL) {
+                        json_object_set_new(bulk->set_errors, uidrec->email_id,
+                                json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                                    "properties", "mailboxIds"));
+                    }
+                }
+                continue;
+            }
+            plan = _email_bulkupdate_addplan(bulk, mbox, mboxrec);
+        }
+        /* Map email ids to their list of non-deleted uid records. */
+        int j;
+        for (j = 0; j < ptrarray_size(&mboxrec->uidrecs); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&mboxrec->uidrecs, j);
+            if (json_object_get(bulk->set_errors, uidrec->email_id)) {
+                continue;
+            }
+            /* Check if the uid record is expunged */
+            msgrecord_t *mr = NULL;
+            uint32_t system_flags = 0, internal_flags = 0;
+            int r = msgrecord_find(plan->mbox, uidrec->uid, &mr);
+            if (!r) r = msgrecord_get_systemflags(mr, &system_flags);
+            if (!r) r = msgrecord_get_internalflags(mr, &internal_flags);
+            if ((system_flags & FLAG_DELETED) || (internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+                r = IMAP_NOTFOUND;
+            }
+            msgrecord_unref(&mr);
+            if (r) continue;
+
+            ptrarray_t *current_uidrecs = hash_lookup(uidrec->email_id, &bulk->uidrecs_by_email_id);
+            if (current_uidrecs == NULL) {
+                current_uidrecs = ptrarray_new();
+                hash_insert(uidrec->email_id, current_uidrecs, &bulk->uidrecs_by_email_id);
+            }
+            ptrarray_append(current_uidrecs, uidrec);
+        }
+    }
+    /* An email with no current uidrecs is expunged */
+    for (i = 0; i < strarray_size(&email_ids); i++) {
+        const char *email_id = strarray_nth(&email_ids, i);
+        if (json_object_get(bulk->set_errors, email_id)) {
+            continue;
+        }
+        if (!hash_lookup(email_id, &bulk->uidrecs_by_email_id)) {
+            json_object_set_new(bulk->set_errors, email_id,
+                    json_pack("{s:s}", "type", "notFound"));
+        }
+    }
+    strarray_fini(&email_ids);
+
+    /* Open new mailboxes that haven't been opened already */
+    for (i = 0; i < ptrarray_size(updates); i++) {
+        struct email_update *update = ptrarray_nth(updates, i);
+        if (!update->mailboxids) {
+            continue;
+        }
+        json_t *jval;
+        const char *mbox_id;
+        void *tmp;
+        json_object_foreach_safe(update->mailboxids, tmp, mbox_id, jval) {
+            struct mailbox *mbox = NULL;
+            const mbentry_t *mbentry = jmap_mbentry_by_uniqueid(req, mbox_id);
+            if (mbentry) {
+                int r = 0;
+                if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+                    r = mboxlist_promote_intermediary(mbentry->name);
+                }
+                if (!r) jmap_openmbox(req, mbentry->name, &mbox, /*rw*/1);
+            }
+            if (mbox) {
+                if (!hash_lookup(mbox->uniqueid, &bulk->plans_by_mbox_id)) {
+                    struct email_mboxrec *mboxrec = xzmalloc(sizeof(struct email_mboxrec));
+                    mboxrec->mboxname = xstrdup(mbox->name);
+                    mboxrec->mbox_id = xstrdup(mbox->uniqueid);
+                    ptrarray_append(bulk->new_mboxrecs, mboxrec);
+                    _email_bulkupdate_addplan(bulk, mbox, mboxrec);
+                }
+                else jmap_closembox(req, &mbox); // already reference counted
+            }
+            else {
+                json_object_set_new(bulk->set_errors, update->email_id,
+                        json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                            "properties", "mailboxIds"));
+            }
+        }
+    }
+
+
+    /* Map updates to update plan */
+    _email_bulkupdate_plan(bulk, updates);
+}
+
+static void _email_bulkupdate_dump(struct email_bulkupdate *bulk, json_t *jdump)
+{
+    int i;
+    struct buf buf = BUF_INITIALIZER;
+
+    json_t *jcur_mboxrecs = json_object();
+    for (i = 0; i < ptrarray_size(bulk->cur_mboxrecs); i++) {
+        struct email_mboxrec *mboxrec = ptrarray_nth(bulk->cur_mboxrecs, i);
+        json_t *jrecs = json_array();
+        int j;
+        for (j = 0; j < ptrarray_size(&mboxrec->uidrecs); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&mboxrec->uidrecs, j);
+            json_array_append_new(jrecs, json_pack("{s:s s:i}",
+                        "emailId", uidrec->email_id, "uid", uidrec->uid));
+        }
+        json_object_set_new(jcur_mboxrecs, mboxrec->mboxname, jrecs);
+    }
+    json_object_set_new(jdump, "curMboxrecs", jcur_mboxrecs);
+
+    json_t *jemails = json_object();
+    hash_iter *iter = hash_table_iter(&bulk->uidrecs_by_email_id);
+    while (hash_iter_next(iter)) {
+        const char *email_id = hash_iter_key(iter);
+        ptrarray_t *uidrecs = hash_iter_val(iter);
+        json_t *juidrecs = json_array();
+        int j;
+        for (j = 0; j < ptrarray_size(uidrecs); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(uidrecs, j);
+            buf_printf(&buf, "%s:%d", uidrec->mboxrec->mboxname, uidrec->uid);
+            json_array_append_new(juidrecs, json_string(buf_cstring(&buf)));
+            buf_reset(&buf);
+        }
+        json_object_set_new(jemails, email_id, juidrecs);
+    }
+    hash_iter_free(&iter);
+    json_object_set_new(jdump, "emails", jemails);
+
+    json_t *jmailboxes = json_object();
+    json_t *jplans = json_object();
+    iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        json_object_set_new(jmailboxes, plan->mboxname, json_string(plan->mbox_id));
+
+        json_t *jplan = json_object();
+
+        json_t *jcopy = json_array();
+        int j;
+        for (j = 0; j < ptrarray_size(&plan->copy); j++) {
+            ptrarray_t *uidrecs = ptrarray_nth(&plan->copy, j);
+            int k;
+            for (k = 0; k < ptrarray_size(uidrecs); k++) {
+                struct email_uidrec *uidrec = ptrarray_nth(uidrecs, k);
+                buf_printf(&buf, "%s:%d", uidrec->mboxrec->mboxname, uidrec->uid);
+                json_array_append_new(jcopy, json_string(buf_cstring(&buf)));
+                buf_reset(&buf);
+            }
+        }
+        json_object_set_new(jplan, "copy", jcopy);
+
+        json_t *jsetflags = json_array();
+        for (j = 0; j < ptrarray_size(&plan->setflags); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, j);
+            json_array_append_new(jsetflags, json_integer(uidrec->uid));
+        }
+        json_object_set_new(jplan, "setflags", jsetflags);
+
+        json_t *jdelete = json_array();
+        for (j = 0; j < ptrarray_size(&plan->delete); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->delete, j);
+            json_array_append_new(jdelete, json_integer(uidrec->uid));
+        }
+        json_object_set_new(jplan, "delete", jdelete);
+
+        json_t *jsnooze = json_array();
+        for (j = 0; j < ptrarray_size(&plan->snooze); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->snooze, j);
+            json_array_append_new(jsnooze, json_integer(uidrec->uid));
+        }
+        json_object_set_new(jplan, "snooze", jsnooze);
+
+        json_object_set_new(jplans, plan->mboxname, jplan);
+    }
+    hash_iter_free(&iter);
+    json_object_set_new(jdump, "plans", jplans);
+    json_object_set_new(jdump, "mailboxes", jmailboxes);
+
+    buf_free(&buf);
+}
+
+static void _email_bulkupdate_exec_copy(struct email_bulkupdate *bulk)
+{
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        struct mailbox *dst_mbox = plan->mbox;
+        int j;
+        for (j = 0; j < ptrarray_size(&plan->copy); j++) {
+            ptrarray_t *src_uidrecs = ptrarray_nth(&plan->copy, j);
+            ptrarray_t src_msgrecs = PTRARRAY_INITIALIZER;
+
+            if (!ptrarray_size(src_uidrecs)) continue;
+
+            /* Lookup the source mailbox plan of the first entry. */
+            struct email_uidrec *tmp = ptrarray_nth(src_uidrecs, 0);
+            const char *src_mbox_id = tmp->mboxrec->mbox_id;
+            struct email_updateplan *src_plan = hash_lookup(src_mbox_id, &bulk->plans_by_mbox_id);
+            struct mailbox *src_mbox = src_plan->mbox;
+            uint32_t last_uid_before_copy = dst_mbox->i.last_uid;
+
+            /* Bulk copy messages per mailbox to destination */
+            int k;
+            for (k = 0; k < ptrarray_size(src_uidrecs); k++) {
+                struct email_uidrec *src_uidrec = ptrarray_nth(src_uidrecs, k);
+                if (json_object_get(bulk->set_errors, src_uidrec->email_id)) {
+                    continue;
+                }
+                msgrecord_t *mrw = msgrecord_from_uid(src_mbox, src_uidrec->uid);
+                ptrarray_append(&src_msgrecs, mrw);
+            }
+            int r = _copy_msgrecords(httpd_authstate, bulk->req->userid, &jmap_namespace,
+                                     src_mbox, dst_mbox, &src_msgrecs);
+            if (r) {
+                for (k = 0; k < ptrarray_size(src_uidrecs); k++) {
+                    struct email_uidrec *src_uidrec = ptrarray_nth(src_uidrecs, k);
+                    if (json_object_get(bulk->set_errors, src_uidrec->email_id)) {
+                        continue;
+                    }
+                    json_object_set_new(bulk->set_errors, src_uidrec->email_id, jmap_server_error(r));
+                }
+            }
+            for (k = 0; k < ptrarray_size(&src_msgrecs); k++) {
+                msgrecord_t *mrw = ptrarray_nth(&src_msgrecs, k);
+                msgrecord_unref(&mrw);
+            }
+            ptrarray_fini(&src_msgrecs);
+
+            for (k = 0; k < ptrarray_size(src_uidrecs); k++) {
+                struct email_uidrec *src_uidrec = ptrarray_nth(src_uidrecs, k);
+                if (json_object_get(bulk->set_errors, src_uidrec->email_id)) {
+                    continue;
+                }
+
+                /* Create new uid record */
+                struct email_uidrec *new_uidrec = xzmalloc(sizeof(struct email_uidrec));
+                new_uidrec->email_id = xstrdup(src_uidrec->email_id);
+                new_uidrec->uid = last_uid_before_copy + k + 1;
+                new_uidrec->mboxrec = plan->mboxrec;
+                new_uidrec->is_new = 1;
+                ptrarray_append(&plan->mboxrec->uidrecs, new_uidrec);
+
+                /* Add new record to setflags plan if keywords are updated */
+                /* XXX append_copy should take new flags as parameter */
+                struct email_update *update = hash_lookup(src_uidrec->email_id,
+                                                          &bulk->updates_by_email_id);
+                if (update->keywords || update->full_keywords) {
+                    ptrarray_append(&plan->setflags, new_uidrec);
+                }
+
+                /* Add new record to snooze plan if copied to snooze folder */
+                if (update->snoozed) {
+                    if (json_is_object(update->snoozed) &&
+                        !strcmpnull(plan->mbox_id, update->snooze_in_mboxid)) {
+                        /* Only flag as snoozed (add \snoozed and annotation) if:
+                           - SnoozeDetails != json_null() AND
+                           - this mailbox is the mailbox in which it is snoozed
+                        */
+                        new_uidrec->is_snoozed = 1;
+                    }
+                    ptrarray_append(&plan->snooze, new_uidrec);
+                }
+            }
+
+        }
+    }
+    hash_iter_free(&iter);
+}
+
+static void _email_bulkupdate_exec_setflags(struct email_bulkupdate *bulk)
+{
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        int j;
+        struct seqset *add_seenseq = NULL;
+        struct seqset *del_seenseq = NULL;
+        uint32_t last_uid = plan->mbox->i.last_uid;
+
+        struct mboxevent *flagsset = mboxevent_new(EVENT_FLAGS_SET);
+        int notify_flagsset = 0;
+        struct mboxevent *flagsclear = mboxevent_new(EVENT_FLAGS_CLEAR);
+        int notify_flagsclear = 0;
+
+        if (plan->use_seendb) {
+            add_seenseq = seqset_init(0, SEQ_SPARSE);
+            del_seenseq = seqset_init(0, SEQ_SPARSE);
+        }
+
+        /* Re-sort uid records before processing. */
+        ptrarray_sort(&plan->setflags, _email_uidrec_compareuid_cb);
+
+        /* Process uid records */
+        for (j = 0; j < ptrarray_size(&plan->setflags); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, j);
+            if (json_object_get(bulk->set_errors, uidrec->email_id)) {
+                continue;
+            }
+            const char *email_id = uidrec->email_id;
+            struct email_update *update = hash_lookup(email_id, &bulk->updates_by_email_id);
+
+            /* Determine if to write the aggregated or updated JMAP keywords */
+            json_t *keywords = uidrec->is_new ? update->full_keywords : update->keywords;
+            int patch_keywords = uidrec->is_new ? 0 : update->patch_keywords;
+
+            /* Write keywords */
+            struct modified_flags modflags;
+            memset(&modflags, 0, sizeof(struct modified_flags));
+            msgrecord_t *mrw = msgrecord_from_uid(plan->mbox, uidrec->uid);
+            int r = _email_setflags(keywords, patch_keywords, mrw,
+                                    add_seenseq, del_seenseq, &modflags);
+            if (!r) {
+                if (modflags.added_flags) {
+                    mboxevent_add_flags(flagsset, plan->mbox->flagname,
+                                        modflags.added_system_flags,
+                                        modflags.added_user_flags);
+                    mboxevent_extract_msgrecord(flagsset, mrw);
+                    notify_flagsset = 1;
+                }
+                if (modflags.removed_flags) {
+                    mboxevent_add_flags(flagsclear, plan->mbox->flagname,
+                                        modflags.removed_system_flags,
+                                        modflags.removed_user_flags);
+                    mboxevent_extract_msgrecord(flagsclear, mrw);
+                    notify_flagsclear = 1;
+                }
+                msgrecord_unref(&mrw);
+                if (last_uid < uidrec->uid) {
+                    last_uid = uidrec->uid;
+                }
+            }
+            else {
+                json_object_set_new(bulk->set_errors, email_id, jmap_server_error(r));
+            }
+        }
+        /* Write seen db for shared mailboxes */
+        if (plan->use_seendb) {
+            if (add_seenseq || del_seenseq) {
+                struct seqset *new_seenseq = seqset_init(0, SEQ_SPARSE);
+                if (del_seenseq->len) {
+                    uint32_t uid;
+                    while ((uid = seqset_getnext(plan->old_seenseq)))
+                        if (!seqset_ismember(del_seenseq, uid))
+                            seqset_add(new_seenseq, uid, 1);
+                }
+                else {
+                    seqset_join(new_seenseq, plan->old_seenseq);
+                }
+                if (add_seenseq->len)
+                    seqset_join(new_seenseq, add_seenseq);
+                struct seendata sd = SEENDATA_INITIALIZER;
+                sd.seenuids = seqset_cstring(new_seenseq);
+                if (!sd.seenuids) sd.seenuids = xstrdup("");
+                sd.lastread = time(NULL);
+                sd.lastchange = plan->mbox->i.last_appenddate;
+                sd.lastuid = last_uid;
+                int r = seen_write(bulk->seendb, plan->mbox->uniqueid, &sd);
+                if (r) {
+                    for (j = 0; j < ptrarray_size(&plan->setflags); j++) {
+                        struct email_uidrec *uidrec = ptrarray_nth(&plan->setflags, j);
+                        if (json_object_get(bulk->set_errors, uidrec->email_id) == NULL) {
+                            json_object_set_new(bulk->set_errors, uidrec->email_id,
+                                                jmap_server_error(r));
+                        }
+                    }
+                }
+                seqset_free(add_seenseq);
+                seqset_free(del_seenseq);
+                seqset_free(new_seenseq);
+                seen_freedata(&sd);
+            }
+        }
+        if (notify_flagsset) {
+            mboxevent_extract_mailbox(flagsset, plan->mbox);
+            mboxevent_set_numunseen(flagsset, plan->mbox, -1);
+            mboxevent_set_access(flagsset, NULL, NULL, bulk->req->userid,
+                                 plan->mbox->name, 0);
+            mboxevent_notify(&flagsset);
+        }
+        if (notify_flagsclear) {
+            mboxevent_extract_mailbox(flagsclear, plan->mbox);
+            mboxevent_set_numunseen(flagsclear, plan->mbox, -1);
+            mboxevent_set_access(flagsclear, NULL, NULL, bulk->req->userid,
+                                 plan->mbox->name, 0);
+            mboxevent_notify(&flagsclear);
+        }
+        mboxevent_free(&flagsset);
+        mboxevent_free(&flagsclear);
+    }
+    hash_iter_free(&iter);
+}
+
+static void _email_bulkupdate_exec_delete(struct email_bulkupdate *bulk)
+{
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        _email_multiexpunge(bulk->req, plan->mbox, &plan->delete, bulk->set_errors);
+    }
+    hash_iter_free(&iter);
+}
+
+static void _email_bulkupdate_exec_snooze(struct email_bulkupdate *bulk)
+{
+    hash_iter *iter = hash_table_iter(&bulk->plans_by_mbox_id);
+    while (hash_iter_next(iter)) {
+        struct email_updateplan *plan = hash_iter_val(iter);
+        int j;
+
+        /* Process uid records */
+        for (j = 0; j < ptrarray_size(&plan->snooze); j++) {
+            struct email_uidrec *uidrec = ptrarray_nth(&plan->snooze, j);
+            if (json_object_get(bulk->set_errors, uidrec->email_id)) {
+                continue;
+            }
+            const char *email_id = uidrec->email_id;
+            struct email_update *update =
+                hash_lookup(email_id, &bulk->updates_by_email_id);
+
+            /* Write annotation */
+            msgrecord_t *mrw = msgrecord_from_uid(plan->mbox, uidrec->uid);
+            uint32_t internalflags = 0;
+            int r = IMAP_MAILBOX_NONEXISTENT;
+            time_t savedate = 0;
+
+            if (mrw) r = msgrecord_get_internalflags(mrw, &internalflags);
+            if (!r) r = msgrecord_get_savedate(mrw, &savedate);
+
+            if (!r) {
+                const char *annot = IMAP_ANNOT_NS "snoozed";
+                struct buf val = BUF_INITIALIZER;
+
+                if (uidrec->is_snoozed) {
+                    /* Set/update annotation */
+                    char *json = json_dumps(update->snoozed, JSON_COMPACT);
+
+                    buf_initm(&val, json, strlen(json));
+
+                    /* Extract until and use it as savedate */
+                    time_from_iso8601(json_string_value(json_object_get(update->snoozed, "until")),
+                                      &savedate);
+
+                    internalflags |= FLAG_INTERNAL_SNOOZED;
+                }
+                else {
+                    /* Delete annotation */
+                    internalflags &= ~FLAG_INTERNAL_SNOOZED;
+                }
+
+                r = msgrecord_annot_write(mrw, annot, "", &val);
+                if (!r) r = msgrecord_set_internalflags(mrw, internalflags);
+                if (!r) r = msgrecord_set_savedate(mrw, savedate);
+                if (!r) r = msgrecord_rewrite(mrw);
+                msgrecord_unref(&mrw);
+                buf_free(&val);
+            }
+
+            if (r) {
+                json_object_set_new(bulk->set_errors, email_id, jmap_server_error(r));
+            }
+        }
+    }
+    hash_iter_free(&iter);
+}
+
+
+static void _email_bulkupdate_exec(struct email_bulkupdate *bulk,
+                                   json_t *updated,
+                                   json_t *not_updated,
+                                   json_t *debug)
+{
+    /*  Execute plans */
+    _email_bulkupdate_exec_copy(bulk);
+    _email_bulkupdate_exec_setflags(bulk);
+    _email_bulkupdate_exec_snooze(bulk);
+    _email_bulkupdate_exec_delete(bulk);
+
+    /* Report results */
+    hash_iter *iter = hash_table_iter(&bulk->updates_by_email_id);
+    while (hash_iter_next(iter)) {
+        const char *email_id = hash_iter_key(iter);
+        json_t *err = json_object_get(bulk->set_errors, email_id);
+        if (err) {
+            json_object_set(not_updated, email_id, err);
+        }
+        else {
+            json_object_set_new(updated, email_id, json_pack("{s:s}", "id", email_id));
+        }
+    }
+    hash_iter_free(&iter);
+
+    if (debug) _email_bulkupdate_dump(bulk, debug);
+}
+
+
+/* Execute the sequence of JMAP Email/set/{update} arguments in bulk. */
+static void _email_update_bulk(jmap_req_t *req,
+                               json_t *update,
+                               json_t *updated,
+                               json_t *not_updated,
+                               json_t *debug)
+{
+    struct email_bulkupdate bulkupdate = _EMAIL_BULKUPDATE_INITIALIZER;
+    ptrarray_t updates = PTRARRAY_INITIALIZER;
+    int i;
+
+    /* Bulk updates are implemented to minimize the number of Cyrus mailbox
+     * open and close calls. This is achieved by the following steps:
+     *
+     * (1) Parse all update arguments.
+     *
+     * (2) For each updated email, determine its mailboxes and UID records.
+     *     Keep note of all mailboxes where the email is currently contained
+     *     in, deleted from or copied to. Open all these mailboxes and create
+     *     an empty update plan for each mailbox.
+     *
+     * (3) For each email, determine the required update operations per
+     *     mailbox:
+     *
+     *     (3.1) If the email keywords are updated, add the email's
+     *           UID record to the `setflags` field of the according
+     *           mailbox update plan.
+     *
+     *     (3.2) If the email mailboxes are updated, determine which
+     *           mailboxes to delete the UID record from, and where
+     *           to copy an existing UID record to. For each mailbox,
+     *           determine all the UID records that are copied into it.
+     *           Cluster all these UID records such that the number
+     *           of mailboxes to copy from is minimized.
+     *
+     * (4) Check required permissions and quota for each mailbox. For
+     *     any failed mailbox check, mark all updates of emails that
+     *     affect this mailbox as failed.
+     *
+     * (5) Check email-scoped limits such as mailbox count and keywords per
+     *     email. Mark all erroneous emails as not updated.
+     *
+     * (6) Execute the update plans. Apply copy first, followed by setflags,
+     *     followed by deletes.
+     *
+     * (7) Report all updated emails and close all mailboxes.
+     *
+     */
+
+    /* Parse updates and add valid updates to todo list. */
+    const char *email_id;
+    json_t *jval;
+    bulkupdate.req = req;
+    json_object_foreach(update, email_id, jval) {
+        struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+        struct email_update *update = xzmalloc(sizeof(struct email_update));
+        update->email_id = email_id;
+        _email_update_parse(jval, &parser, update);
+        if (json_array_size(parser.invalid)) {
+            json_object_set_new(not_updated, email_id,
+                    json_pack("{s:s s:O}", "type", "invalidProperties",
+                        "properties", parser.invalid));
+            _email_update_free(update);
+        }
+        else {
+            ptrarray_append(&updates, update);
+        }
+        jmap_parser_fini(&parser);
+    }
+    if (ptrarray_size(&updates)) {
+        /* Build and execute bulk update */
+        _email_bulkupdate_open(req, &bulkupdate, &updates);
+        _email_bulkupdate_exec(&bulkupdate, updated, not_updated, debug);
+        _email_bulkupdate_close(&bulkupdate);
+    }
+    else {
+        /* just clean up the memory we allocated above */
+        _email_mboxrecs_free(&bulkupdate.new_mboxrecs);
+        json_decref(bulkupdate.set_errors);
+    }
+
+    for (i = 0; i < ptrarray_size(&updates); i++) {
+        _email_update_free(ptrarray_nth(&updates, i));
+    }
+    ptrarray_fini(&updates);
+}
+
+static void _email_destroy_bulk(jmap_req_t *req,
+                                json_t *destroy,
+                                json_t *destroyed,
+                                json_t *not_destroyed)
+{
+    ptrarray_t *mboxrecs = NULL;
+    strarray_t email_ids = STRARRAY_INITIALIZER;
+    size_t iz;
+    json_t *jval;
+    int i;
+
+    /* Map email ids to mailbox name and UID */
+    json_array_foreach(destroy, iz, jval) {
+        strarray_append(&email_ids, json_string_value(jval));
+    }
+    _email_mboxrecs_read(req, req->cstate, &email_ids, not_destroyed, &mboxrecs);
+
+    /* Check mailbox ACL for shared accounts. */
+    if (strcmp(req->accountid, req->userid)) {
+        for (i = 0; i < ptrarray_size(mboxrecs); i++) {
+            struct email_mboxrec *mboxrec = ptrarray_nth(mboxrecs, i);
+            if (!jmap_hasrights_byname(req, mboxrec->mboxname, ACL_DELETEMSG)) {
+                /* Mark all messages of this mailbox as failed */
+                int j;
+                for (j = 0; j < ptrarray_size(&mboxrec->uidrecs); j++) {
+                    struct email_uidrec *uidrec = ptrarray_nth(&mboxrec->uidrecs, j);
+                    if (!json_object_get(not_destroyed, uidrec->email_id)) {
+                        json_object_set_new(not_destroyed, uidrec->email_id,
+                                            json_pack("{s:s}", "type", "forbidden"));
+                    }
+                }
+                /* Remove this mailbox from the todo list */
+                ptrarray_remove(mboxrecs, i--);
+                _email_mboxrec_free(mboxrec);
+            }
+        }
+    }
+
+    /* Expunge messages in bulk per mailbox */
+    for (i = 0; i < ptrarray_size(mboxrecs); i++) {
+        struct email_mboxrec *mboxrec = ptrarray_nth(mboxrecs, i);
+        struct mailbox *mbox = NULL;
+        int j;
+        int r = jmap_openmbox(req, mboxrec->mboxname, &mbox, 1);
+        if (!r) {
+            /* Expunge messages one by one, marking any failed message */
+            _email_multiexpunge(req, mbox, &mboxrec->uidrecs, not_destroyed);
+        }
+        else {
+            /* Mark all messages of this mailbox as failed */
+            for (j = 0; j < ptrarray_size(&mboxrec->uidrecs); j++) {
+                struct email_uidrec *uidrec = ptrarray_nth(&mboxrec->uidrecs, j);
+                if (!json_object_get(not_destroyed, uidrec->email_id)) {
+                    json_object_set_new(not_destroyed, uidrec->email_id,
+                            jmap_server_error(r));
+                }
+            }
+        }
+        jmap_closembox(req, &mbox);
+    }
+
+    /* Report successful destroys */
+    json_array_foreach(destroy, iz, jval) {
+        const char *email_id = json_string_value(jval);
+        if (!json_object_get(not_destroyed, email_id))
+            json_array_append(destroyed, jval);
+    }
+
+    _email_mboxrecs_free(&mboxrecs);
+    strarray_fini(&email_ids);
+}
+
+static int jmap_email_set(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+
+    json_t *err = NULL;
+    jmap_set_parse(req, &parser, email_props, NULL, NULL, &set, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    if (set.if_in_state) {
+        /* TODO rewrite state function to use char* not json_t* */
+        json_t *jstate = json_string(set.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_EMAIL)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            goto done;
+        }
+        json_decref(jstate);
+        set.old_state = xstrdup(set.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/0);
+        set.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+
+    json_t *email;
+    const char *creation_id;
+    json_object_foreach(set.create, creation_id, email) {
+        json_t *set_err = NULL;
+        json_t *new_email = NULL;
+        /* Create message */
+        _email_create(req, email, &new_email, &set_err);
+        if (set_err) {
+            json_object_set_new(set.not_created, creation_id, set_err);
+            continue;
+        }
+        /* Report message as created */
+        json_object_set_new(set.created, creation_id, new_email);
+        const char *msg_id = json_string_value(json_object_get(new_email, "id"));
+        jmap_add_id(req, creation_id, msg_id);
+    }
+
+    json_t *debug_bulkupdate = NULL;
+    if (jmap_is_using(req, JMAP_DEBUG_EXTENSION)) {
+        debug_bulkupdate = json_object();
+    }
+    _email_update_bulk(req, set.update, set.updated, set.not_updated, debug_bulkupdate);
+
+    _email_destroy_bulk(req, set.destroy, set.destroyed, set.not_destroyed);
+
+    // TODO refactor jmap_getstate to return a string, once
+    // all code has been migrated to the new JMAP parser.
+    json_t *jstate = jmap_getstate(req, MBTYPE_EMAIL, /*refresh*/1);
+    set.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    json_t *reply = jmap_set_reply(&set);
+    if (jmap_is_using(req, JMAP_DEBUG_EXTENSION)) {
+        json_object_set_new(reply, "debug",
+                json_pack("{s:o}", "bulkUpdate", debug_bulkupdate));
+    }
+    jmap_ok(req, reply);
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    return 0;
+}
+
+struct _email_import_rock {
+    struct buf buf;
+};
+
+static int _email_import_cb(jmap_req_t *req __attribute__((unused)),
+                            FILE *out,
+                            void *rock,
+                            json_t **err __attribute__((unused)))
+{
+    struct _email_import_rock *data = (struct _email_import_rock*) rock;
+    const char *base = data->buf.s;
+    size_t len = data->buf.len;
+    struct protstream *stream = prot_readmap(base, len);
+    int r = message_copy_strict(stream, out, len, 0);
+    prot_free(stream);
+    return r;
+}
+
+struct msgimport_checkacl_rock {
+    jmap_req_t *req;
+    json_t *mailboxes;
+};
+
+static int msgimport_checkacl_cb(const mbentry_t *mbentry, void *xrock)
+{
+    struct msgimport_checkacl_rock *rock = xrock;
+    jmap_req_t *req = rock->req;
+
+    if (!json_object_get(rock->mailboxes, mbentry->uniqueid))
+        return 0;
+
+    int needrights = ACL_INSERT|ACL_ANNOTATEMSG;
+    if (!jmap_hasrights(req, mbentry, needrights))
+        return IMAP_PERMISSION_DENIED;
+
+    return 0;
+}
+
+static void _email_import(jmap_req_t *req,
+                          json_t *jemail_import,
+                          json_t **new_email,
+                          json_t **err)
+{
+    const char *blob_id = json_string_value(json_object_get(jemail_import, "blobId"));
+    json_t *jmailbox_ids = json_object_get(jemail_import, "mailboxIds");
+    char *mboxname = NULL;
+    struct _email_import_rock content = { BUF_INITIALIZER };
+    int has_attachment = 0;
+
+    /* Force write locks on mailboxes. */
+    req->force_openmbox_rw = 1;
+
+    /* Gather keywords */
+    strarray_t keywords = STRARRAY_INITIALIZER;
+    const json_t *val;
+    const char *keyword;
+    json_object_foreach(json_object_get(jemail_import, "keywords"), keyword, val) {
+        if (!strcasecmp(keyword, JMAP_HAS_ATTACHMENT_FLAG)) {
+            continue;
+        }
+        strarray_append(&keywords, keyword);
+    }
+
+    /* check for internaldate */
+    time_t internaldate = 0;
+    const char *received_at = json_string_value(json_object_get(jemail_import, "receivedAt"));
+    if (received_at) {
+        time_from_iso8601(received_at, &internaldate);
+    }
+
+    /* check for snoozed */
+    json_t *snoozed = json_object_get(jemail_import, "snoozed");
+
+    /* Check mailboxes for ACL */
+    if (strcmp(req->userid, req->accountid)) {
+        struct msgimport_checkacl_rock rock = { req, jmailbox_ids };
+        int r = mboxlist_usermboxtree(req->accountid, req->authstate, msgimport_checkacl_cb, &rock, MBOXTREE_INTERMEDIATES);
+        if (r) {
+            *err = json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                    "properties", "mailboxIds");
+            goto done;
+        }
+    }
+
+    /* Start import */
+    struct email_append_detail detail;
+    memset(&detail, 0, sizeof(struct email_append_detail));
+
+    /* Lookup blob */
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+
+    /* see if we can get a direct email! */
+    const char *sourcefile = NULL;
+    int r = jmap_findblob_exact(req, NULL/*accountid*/, blob_id,
+                                &mbox, &mr);
+    if (!r) r = msgrecord_get_fname(mr, &sourcefile);
+    if (!r) r = msgrecord_get_body(mr, &content.buf);
+    if (!r) goto gotrecord;
+
+    /* better clean up before we go the slow path */
+    buf_reset(&content.buf);
+    sourcefile = NULL;
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+
+    struct body *body = NULL;
+    const struct body *part = NULL;
+    struct buf msg_buf = BUF_INITIALIZER;
+    r = jmap_findblob(req, NULL/*accountid*/, blob_id,
+                      &mbox, &mr, &body, &part, &msg_buf);
+    if (r) {
+        if (r == IMAP_NOTFOUND || r == IMAP_PERMISSION_DENIED)
+            *err = json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                    "properties", "blobId");
+        else
+            *err = jmap_server_error(r);
+        goto done;
+    }
+
+    /* Decode blob */
+    const char *blob_base = buf_base(&msg_buf);
+    size_t blob_len = buf_len(&msg_buf);
+    if (part) {
+        blob_base += part->content_offset;
+        blob_len = part->content_size;
+
+        int enc = encoding_lookupname(part->encoding);
+        if (enc != ENCODING_NONE) {
+            char *tmp;
+            size_t dec_len;
+            const char *dec = charset_decode_mimebody(blob_base, blob_len, enc, &tmp, &dec_len);
+            buf_setmap(&content.buf, dec, dec_len);
+            free(tmp);
+        }
+        else {
+            buf_setmap(&content.buf, blob_base, blob_len);
+        }
+    }
+    else {
+        buf_setmap(&content.buf, blob_base, blob_len);
+    }
+
+    message_free_body(body);
+    free(body);
+
+gotrecord:
+
+    /* Determine $hasAttachment flag */
+    if (config_getswitch(IMAPOPT_JMAP_SET_HAS_ATTACHMENT)) {
+        /* Parse email */
+        json_t *email = NULL;
+        struct email_getargs getargs = _EMAIL_GET_ARGS_INITIALIZER;
+        getargs.props = xzmalloc(sizeof(hash_table));
+        construct_hash_table(getargs.props, 1, 0);
+
+        hash_insert("hasAttachment", (void*)1, getargs.props);
+        _email_from_buf(req, &getargs, &content.buf, NULL, &email);
+        has_attachment = json_boolean_value(json_object_get(email, "hasAttachment"));
+
+        free_hash_table(getargs.props, NULL);
+        free(getargs.props);
+        getargs.props = NULL;
+        _email_getargs_fini(&getargs);
+        json_decref(email);
+    }
+
+    /* Write the message to the file system */
+    _email_append(req, jmailbox_ids, &keywords, internaldate, snoozed,
+                  has_attachment, sourcefile, _email_import_cb, &content, &detail, err);
+
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+
+    if (*err) goto done;
+
+    *new_email = json_pack("{s:s, s:s, s:s, s:i}",
+         "id", detail.email_id,
+         "blobId", detail.blob_id,
+         "threadId", detail.thread_id,
+         "size", detail.size);
+
+done:
+    strarray_fini(&keywords);
+    buf_free(&content.buf);
+    free(mboxname);
+}
+
+static int jmap_email_import(jmap_req_t *req)
+{
+    json_t *created = json_pack("{}");
+    json_t *not_created = json_pack("{}");
+
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    const char *key;
+    json_t *arg, *emails = NULL;
+    const char *id;
+    json_t *jemail_import;
+    int have_snoozed_mboxid = 0;
+
+    /* Parse request */
+    json_object_foreach(req->args, key, arg) {
+        if (!strcmp(key, "accountId")) {
+            /* already handled in jmap_api() */
+        }
+
+        else if (!strcmp(key, "emails")) {
+            if (json_is_object(arg)) {
+                emails = arg;
+                jmap_parser_push(&parser, "emails");
+                json_object_foreach(emails, id, jemail_import) {
+                    if (!json_is_object(jemail_import)) {
+                        jmap_parser_invalid(&parser, id);
+                    }
+                }
+                jmap_parser_pop(&parser);
+            }
+        }
+
+        else {
+            jmap_parser_invalid(&parser, key);
+        }
+    }
+
+    /* emails is a required argument */
+    if (!emails) jmap_parser_invalid(&parser, "emails");
+
+    if (json_array_size(parser.invalid)) {
+        json_t *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                                "arguments", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    json_object_foreach(emails, id, jemail_import) {
+        /* Parse import */
+        struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+        json_t *jval;
+        const char *s;
+
+        /* blobId */
+        s = json_string_value(json_object_get(jemail_import, "blobId"));
+        if (!s) {
+            jmap_parser_invalid(&parser, "blobId");
+        }
+
+        /* keywords */
+        json_t *keywords = json_object_get(jemail_import, "keywords");
+        if (json_is_object(keywords)) {
+            jmap_parser_push(&parser, "keywords");
+            json_object_foreach(keywords, s, jval) {
+                if (jval != json_true() || !jmap_email_keyword_is_valid(s)) {
+                    jmap_parser_invalid(&parser, s);
+                }
+            }
+            jmap_parser_pop(&parser);
+        }
+        else if (JNOTNULL(keywords)) {
+            jmap_parser_invalid(&parser, "keywords");
+        }
+
+        /* receivedAt */
+        json_t *jrecv = json_object_get(jemail_import, "receivedAt");
+        if (JNOTNULL(jrecv)) {
+            if (!json_is_utcdate(jrecv)) {
+                jmap_parser_invalid(&parser, "receivedAt");
+            }
+        }
+
+        /* Validate mailboxIds */
+        json_t *jmailboxids = json_copy(json_object_get(jemail_import, "mailboxIds"));
+        if (json_object_size(jmailboxids)) {
+            _append_validate_mboxids(req, jmailboxids, &parser, &have_snoozed_mboxid);
+        }
+        else {
+            jmap_parser_invalid(&parser, "mailboxIds");
+        }
+
+        /* Validate snoozed + mailboxIds */
+        json_t *snoozed = json_object_get(jemail_import, "snoozed");
+        if (JNOTNULL(snoozed) &&
+            !(json_is_utcdate(json_object_get(snoozed, "until")) &&
+              have_snoozed_mboxid)) {
+            jmap_parser_invalid(&parser, "snoozed");
+        }
+
+        json_t *invalid = json_incref(parser.invalid);
+        jmap_parser_fini(&parser);
+        if (json_array_size(invalid)) {
+            json_t *err = json_pack("{s:s}", "type", "invalidProperties");
+            json_object_set_new(err, "properties", invalid);
+            json_object_set_new(not_created, id, err);
+            json_decref(jmailboxids);
+            continue;
+        }
+        json_decref(invalid);
+
+        /* Process import */
+        json_t *orig_mailboxids = json_incref(json_object_get(jemail_import, "mailboxIds"));
+        json_object_set_new(jemail_import, "mailboxIds", jmailboxids);
+        json_t *new_email = NULL;
+        json_t *err = NULL;
+        _email_import(req, jemail_import, &new_email, &err);
+        if (err) {
+            json_object_set_new(not_created, id, err);
+        }
+        else {
+            /* Successful import */
+            json_object_set_new(created, id, new_email);
+            const char *newid = json_string_value(json_object_get(new_email, "id"));
+            jmap_add_id(req, id, newid);
+        }
+        json_object_set_new(jemail_import, "mailboxIds", orig_mailboxids);
+    }
+
+    /* Reply */
+    jmap_ok(req, json_pack("{s:s s:O s:O}",
+                "accountId", req->accountid,
+                "created", created,
+                "notCreated", not_created));
+
+done:
+    json_decref(created);
+    json_decref(not_created);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+struct _email_copy_checkmbox_rock {
+    jmap_req_t *req;           /* JMAP request context */
+    json_t *dst_mboxids;       /* mailboxIds argument */
+    strarray_t *dst_mboxnames; /* array of destination mailbox names */
+};
+
+static int _email_copy_checkmbox_cb(const mbentry_t *mbentry, void *_rock)
+{
+    struct _email_copy_checkmbox_rock *rock = _rock;
+
+    /* Ignore anything but regular and intermediate mailboxes */
+    if (!mbentry || (mbentry->mbtype & ~MBTYPE_INTERMEDIATE)) {
+        return 0;
+    }
+    if (!json_object_get(rock->dst_mboxids, mbentry->uniqueid)) {
+        return 0;
+    }
+
+    /* Check read-write ACL rights */
+    int needrights = ACL_LOOKUP|ACL_READ|ACL_WRITE|ACL_INSERT|
+                     ACL_SETSEEN|ACL_ANNOTATEMSG;
+    if (!jmap_hasrights(rock->req, mbentry, needrights))
+        return IMAP_PERMISSION_DENIED;
+
+    /* Mark this mailbox as found */
+    strarray_append(rock->dst_mboxnames, mbentry->name);
+    size_t want_count = json_object_size(rock->dst_mboxids);
+    size_t have_count = strarray_size(rock->dst_mboxnames);
+    return want_count == have_count ? IMAP_OK_COMPLETED : 0;
+}
+
+struct _email_copy_writeprops_rock {
+    /* Input values */
+    jmap_req_t *req;
+    const char *received_at;
+    json_t *keywords;
+    struct seen *seendb;
+    /* Return values */
+    conversation_id_t cid; /* Thread id of copied message */
+    uint32_t size;         /* Byte size of copied message */
+};
+
+static int _email_copy_writeprops_cb(const conv_guidrec_t* rec, void* _rock)
+{
+    struct _email_copy_writeprops_rock *rock = _rock;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    jmap_req_t *req = rock->req;
+    struct mboxevent *flagsset = mboxevent_new(EVENT_FLAGS_SET);
+    struct mboxevent *flagsclear = mboxevent_new(EVENT_FLAGS_CLEAR);
+    int notify_flagsset = 0;
+    int notify_flagsclear = 0;
+
+    if (rec->part) {
+        return 0;
+    }
+
+    /* Overwrite message record */
+    int r = jmap_openmbox(rock->req, rec->mboxname, &mbox, /*rw*/1);
+    if (!r) r = msgrecord_find(mbox, rec->uid, &mr);
+    if (!r && rock->received_at) {
+        time_t internal_date;
+        time_from_iso8601(rock->received_at, &internal_date);
+        r = msgrecord_set_internaldate(mr, internal_date);
+    }
+    if (!r) {
+        /* Write the keywords. There's lots of ceremony around seen.db */
+        struct seqset *seenseq = NULL;
+        struct seqset *addseen = NULL;
+        struct seqset *delseen = NULL;
+
+        /* Read the current seen sequence from seen.db */
+        int need_seendb = !mailbox_internal_seen(mbox, req->userid);
+        if (need_seendb) {
+            delseen = seqset_init(0, SEQ_SPARSE);
+            addseen = seqset_init(0, SEQ_SPARSE);
+            struct seendata sd = SEENDATA_INITIALIZER;
+            int r = seen_lockread(rock->seendb, mbox->uniqueid, &sd);
+            if (!r) {
+                seenseq = seqset_parse(sd.seenuids, NULL, sd.lastuid);
+                seen_freedata(&sd);
+            }
+        }
+
+        /* Write the flags on the record */
+        struct modified_flags modflags;
+        memset(&modflags, 0, sizeof(struct modified_flags));
+        if (!r) r = _email_setflags(rock->keywords, 0, mr, addseen, delseen, &modflags);
+        if (!r) {
+            if (modflags.added_flags) {
+                mboxevent_extract_msgrecord(flagsset, mr);
+                mboxevent_add_flags(flagsset, mbox->flagname,
+                                    modflags.added_system_flags,
+                                    modflags.added_user_flags);
+                notify_flagsset = 1;
+            }
+            if (modflags.removed_flags) {
+                mboxevent_extract_msgrecord(flagsclear, mr);
+                mboxevent_add_flags(flagsclear, mbox->flagname,
+                                    modflags.removed_system_flags,
+                                    modflags.removed_user_flags);
+                notify_flagsclear = 1;
+            }
+        }
+
+        /* Write back changes to seen.db */
+        if (!r && need_seendb && (addseen->len || delseen->len)) {
+            if (delseen->len) {
+                struct seqset *newseen = seqset_init(0, SEQ_SPARSE);
+                uint32_t uid;
+                while ((uid = seqset_getnext(seenseq))) {
+                    if (!seqset_ismember(delseen, uid)) {
+                        seqset_add(newseen, uid, 1);
+                    }
+                }
+                seqset_free(seenseq);
+                seenseq = newseen;
+            }
+            else if (addseen->len) {
+                seqset_add(seenseq, rec->uid, 1);
+            }
+
+            struct seendata sd = SEENDATA_INITIALIZER;
+            sd.seenuids = seqset_cstring(seenseq);
+            if (!sd.seenuids) sd.seenuids = xstrdup("");
+            sd.lastread = time(NULL);
+            sd.lastchange = mbox->i.last_appenddate;
+            sd.lastuid = mbox->i.last_uid;
+            r = seen_write(rock->seendb, mbox->uniqueid, &sd);
+            seen_freedata(&sd);
+        }
+
+        seqset_free(delseen);
+        seqset_free(addseen);
+        seqset_free(seenseq);
+    }
+    if (!r) r = msgrecord_rewrite(mr);
+    if (r) goto done;
+
+    /* Write mboxevents */
+    if (notify_flagsset) {
+        mboxevent_extract_mailbox(flagsset, mbox);
+        mboxevent_set_numunseen(flagsset, mbox, -1);
+        mboxevent_set_access(flagsset, NULL, NULL, req->userid, mbox->name, 0);
+        mboxevent_notify(&flagsset);
+    }
+    if (notify_flagsclear) {
+        mboxevent_extract_mailbox(flagsclear, mbox);
+        mboxevent_set_numunseen(flagsclear, mbox, -1);
+        mboxevent_set_access(flagsclear, NULL, NULL, req->userid, mbox->name, 0);
+        mboxevent_notify(&flagsclear);
+    }
+
+    /* Read output values */
+    if (!rock->cid) rock->cid = rec->cid;
+    if (!rock->size) r = msgrecord_get_size(mr, &rock->size);
+
+done:
+    mboxevent_free(&flagsset);
+    mboxevent_free(&flagsclear);
+    if (mr) msgrecord_unref(&mr);
+    jmap_closembox(rock->req, &mbox);
+    return r;
+}
+
+struct _email_exists_rock {
+    jmap_req_t *req;
+    int exists;
+};
+
+static int _email_exists_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct _email_exists_rock *data = (struct _email_exists_rock*) rock;
+    jmap_req_t *req = data->req;
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+    uint32_t internal_flags;
+    int r = 0;
+
+    r = jmap_openmbox(req, rec->mboxname, &mbox, 0);
+    if (r) return r;
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (r) goto done;
+
+    r = msgrecord_get_internalflags(mr, &internal_flags);
+    if (r) goto done;
+
+    if (!(internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+        data->exists = 1;
+        r = CYRUSDB_DONE;
+    }
+
+done:
+    if (mr) msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+    return r;
+}
+
+struct emailcopy_pickrecord_rock {
+    jmap_req_t *req;
+    struct mailbox *mbox;
+    msgrecord_t *mr;
+    struct email_keywords keywords;
+    int gather_keywords;
+};
+
+static int _email_copy_pickrecord_cb(const conv_guidrec_t *rec, void *vrock)
+{
+    struct emailcopy_pickrecord_rock *rock = vrock;
+    jmap_req_t *req = rock->req;
+
+    /* Make sure we are allowed to read this mailbox */
+    if (!jmap_hasrights_byname(req, rec->mboxname, ACL_READ)) return 0;
+
+    struct mailbox *mbox = NULL;
+    msgrecord_t *mr = NULL;
+
+    /* Check if this record is expunged */
+    int r = jmap_openmbox(req, rec->mboxname, &mbox, 0);
+    if (r) goto done;
+
+    r = msgrecord_find(mbox, rec->uid, &mr);
+    if (r) goto done;
+    uint32_t system_flags;
+    uint32_t internal_flags;
+    r = msgrecord_get_systemflags(mr, &system_flags);
+    if (!r) msgrecord_get_internalflags(mr, &internal_flags);
+    if (system_flags & FLAG_DELETED || internal_flags & FLAG_INTERNAL_EXPUNGED) {
+        msgrecord_unref(&mr);
+        jmap_closembox(req, &mbox);
+        goto done;
+    }
+
+    /* Aggregate message record flags into JMAP keywords */
+    if (rock->gather_keywords) {
+        _email_keywords_add_msgrecord(&rock->keywords, mr);
+    }
+
+    /* Keep this message record as source to copy from? */
+    if (!rock->mbox) {
+        rock->mbox = mbox;
+        rock->mr = mr;
+    }
+    else {
+        msgrecord_unref(&mr);
+        jmap_closembox(req, &mbox);
+    }
+
+done:
+    return r;
+}
+
+static void _email_copy(jmap_req_t *req, json_t *copy_email,
+                        const char *from_account_id,
+                        struct seen *seendb,
+                        json_t **new_email, json_t **err)
+{
+    strarray_t dst_mboxnames = STRARRAY_INITIALIZER;
+    struct mailbox *src_mbox = NULL;
+    msgrecord_t *src_mr = NULL;
+    char *src_mboxname = NULL;
+    int r = 0;
+    char *blob_id = NULL;
+    json_t *new_keywords = NULL;
+    json_t *jmailboxids = json_copy(json_object_get(copy_email, "mailboxIds"));
+
+    /* Support mailboxids by role */
+    const char *mbox_id;
+    json_t *jval;
+    void *tmp;
+    json_object_foreach_safe(jmailboxids, tmp, mbox_id, jval) {
+        if (*mbox_id != '$') continue;
+        const char *role = mbox_id + 1;
+        char *uniqueid = NULL;
+        if (jmap_mailbox_find_role(req, role, NULL, &uniqueid) == 0) {
+            json_object_del(jmailboxids, mbox_id);
+            json_object_set_new(jmailboxids, uniqueid, jval);
+        }
+        else {
+            *err = json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                    "properties", "mailboxIds");
+        }
+        free(uniqueid);
+        if (*err) goto done;
+    }
+
+    const char *email_id = json_string_value(json_object_get(copy_email, "id"));
+    uint32_t src_size = 0;
+
+    /* Lookup source message record and gather JMAP keywords */
+    new_keywords = json_deep_copy(json_object_get(copy_email, "keywords"));
+    if (json_is_null(new_keywords)) {
+        new_keywords = NULL;
+    }
+    hash_table seenseq_by_mbox_id = HASH_TABLE_INITIALIZER;
+    construct_hash_table(&seenseq_by_mbox_id, 32, 0);
+    struct emailcopy_pickrecord_rock pickrecord_rock = {
+        req, NULL, NULL, _EMAIL_KEYWORDS_INITIALIZER, 0
+    };
+    if (!new_keywords) {
+        _email_keywords_init(&pickrecord_rock.keywords, req->userid, seendb, &seenseq_by_mbox_id);
+        pickrecord_rock.gather_keywords = 1;
+    }
+    if (strcmp(from_account_id, req->accountid)) {
+        struct conversations_state *mycstate = NULL;
+        r = conversations_open_user(from_account_id, 0/*shared*/, &mycstate);
+        if (!r) r = conversations_guid_foreach(mycstate, _guid_from_id(email_id),
+                _email_copy_pickrecord_cb, &pickrecord_rock);
+        if (!r) r = conversations_commit(&mycstate);
+    }
+    else {
+        r = conversations_guid_foreach(req->cstate, _guid_from_id(email_id),
+                _email_copy_pickrecord_cb, &pickrecord_rock);
+    }
+    if (!r && pickrecord_rock.mbox) {
+        src_mbox = pickrecord_rock.mbox;
+        src_mr = pickrecord_rock.mr;
+        if (!new_keywords) {
+            new_keywords = _email_keywords_to_jmap(&pickrecord_rock.keywords);
+        }
+        r = msgrecord_get_size(src_mr, &src_size);
+    }
+    else if (!r) {
+        r = IMAP_NOTFOUND;
+    }
+    free_hash_table(&seenseq_by_mbox_id, (void (*)(void *)) seqset_free);
+    _email_keywords_fini(&pickrecord_rock.keywords);
+    if (r) {
+        if (r == IMAP_NOTFOUND || r == IMAP_PERMISSION_DENIED) {
+            *err = json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                    "properties", "id");
+            r = 0;
+        }
+        goto done;
+    }
+
+    /* Override hasAttachment flag */
+    int has_attachment = 0;
+    r = msgrecord_hasflag(src_mr, JMAP_HAS_ATTACHMENT_FLAG, &has_attachment);
+    if (r) goto done;
+    if (has_attachment)
+        json_object_set_new(new_keywords, JMAP_HAS_ATTACHMENT_FLAG, json_true());
+    else
+        json_object_del(new_keywords, JMAP_HAS_ATTACHMENT_FLAG);
+
+
+    struct message_guid guid;
+    r = msgrecord_get_guid(src_mr, &guid);
+    if (r) goto done;
+    blob_id = xstrdup(message_guid_encode(&guid));
+
+    /* Check if email already exists in to_account */
+    struct _email_exists_rock data = { req, 0 };
+    conversations_guid_foreach(req->cstate, blob_id, _email_exists_cb, &data);
+    if (data.exists) {
+        *err = json_pack("{s:s s:s}", "type", "alreadyExists", "existingId", email_id);
+        goto done;
+    }
+
+    /* Lookup mailbox names and make sure they are all writeable */
+    struct _email_copy_checkmbox_rock checkmbox_rock = {
+        req, jmailboxids, &dst_mboxnames
+    };
+    r = mboxlist_usermboxtree(req->accountid, httpd_authstate,
+                              _email_copy_checkmbox_cb, &checkmbox_rock,
+                              MBOXTREE_INTERMEDIATES);
+    if (r != IMAP_OK_COMPLETED) {
+        if (r == 0 || r == IMAP_PERMISSION_DENIED) {
+            *err = json_pack("{s:s s:[s]}", "type", "invalidProperties",
+                    "properties", "mailboxIds");
+            r = 0;
+        }
+        goto done;
+    }
+
+    /* Copy message record to mailboxes */
+    char *dst_mboxname;
+    while ((dst_mboxname = strarray_pop(&dst_mboxnames))) {
+        mbentry_t *mbentry = NULL;
+        r = jmap_mboxlist_lookup(dst_mboxname, &mbentry, NULL);
+        if (!r && (mbentry->mbtype & MBTYPE_INTERMEDIATE)) {
+            r = mboxlist_promote_intermediary(dst_mboxname);
+        }
+        if (!r) {
+            struct mailbox *dst_mbox = NULL;
+            r = jmap_openmbox(req, dst_mboxname, &dst_mbox, /*rw*/1);
+            if (!r) {
+                r = _copy_msgrecord(httpd_authstate, req->accountid,
+                        &jmap_namespace, src_mbox, dst_mbox, src_mr);
+            }
+            jmap_closembox(req, &dst_mbox);
+            free(dst_mboxname);
+        }
+        mboxlist_entry_free(&mbentry);
+        if (r) goto done;
+    }
+
+    /* Rewrite new message record properties and lookup thread id */
+    const char *receivedAt = json_string_value(json_object_get(copy_email, "receivedAt"));
+    struct _email_copy_writeprops_rock writeprops_rock = {
+        req, receivedAt, new_keywords, seendb, /*cid*/0, /*size*/0
+    };
+    r = conversations_guid_foreach(req->cstate, email_id + 1,
+                                   _email_copy_writeprops_cb, &writeprops_rock);
+
+    if (!r) {
+        char thread_id[JMAP_THREADID_SIZE];
+        jmap_set_threadid(writeprops_rock.cid, thread_id);
+        *new_email = json_pack("{s:s s:s s:s s:i}",
+                "id", email_id,
+                "blobId", blob_id,
+                "threadId", thread_id,
+                "size", src_size);
+    }
+
+done:
+    json_decref(jmailboxids);
+    if (r && *err == NULL) {
+        *err = jmap_server_error(r);
+    }
+    free(src_mboxname);
+    free(blob_id);
+    strarray_fini(&dst_mboxnames);
+    if (src_mr) msgrecord_unref(&src_mr);
+    jmap_closembox(req, &src_mbox);
+    json_decref(new_keywords);
+}
+
+static void _email_copy_validate_props(json_t *jemail, json_t **err)
+{
+    struct jmap_parser myparser = JMAP_PARSER_INITIALIZER;
+
+    /* Validate properties */
+    json_t *prop, *id = NULL, *mailboxids = NULL;;
+    const char *pname;
+    json_object_foreach(jemail, pname, prop) {
+        if (!strcmp(pname, "id")) {
+            if (!json_is_string(prop)) {
+                jmap_parser_invalid(&myparser, "id");
+            }
+            id = prop;
+        }
+        else if (!strcmp(pname, "mailboxIds")) {
+            jmap_parser_push(&myparser, "mailboxIds");
+            const char *mbox_id;
+            json_t *jbool;
+            json_object_foreach(prop, mbox_id, jbool) {
+                if (!strlen(mbox_id) || jbool != json_true()) {
+                    jmap_parser_invalid(&myparser, NULL);
+                    break;
+                }
+            }
+            jmap_parser_pop(&myparser);
+            mailboxids = prop;
+        }
+        else if (!strcmp(pname, "keywords")) {
+            if (json_is_object(prop)) {
+                jmap_parser_push(&myparser, "keywords");
+                const char *keyword;
+                json_t *jbool;
+                json_object_foreach(prop, keyword, jbool) {
+                    if (!jmap_email_keyword_is_valid(keyword) ||
+                        jbool != json_true()) {
+                        jmap_parser_invalid(&myparser, keyword);
+                    }
+                }
+                jmap_parser_pop(&myparser);
+            }
+            else {
+                jmap_parser_invalid(&myparser, "keywords");
+            }
+        }
+        else if (!strcmp(pname, "receivedAt")) {
+            if (!json_is_utcdate(prop)) {
+                jmap_parser_invalid(&myparser, "receivedAt");
+            }
+        }
+        else {
+            jmap_parser_invalid(&myparser, pname);
+        }
+    }
+    /* Check mandatory properties */
+    if (!id) {
+        jmap_parser_invalid(&myparser, "id");
+    }
+    if (!mailboxids) {
+        jmap_parser_invalid(&myparser, "mailboxIds");
+    }
+    /* Reject invalid properties... */
+    if (json_array_size(myparser.invalid)) {
+        *err = json_pack("{s:s s:O}",
+                         "type", "invalidProperties",
+                         "properties", myparser.invalid);
+    }
+
+    jmap_parser_fini(&myparser);
+}
+
+static int jmap_email_copy(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_copy copy;
+    json_t *err = NULL;
+    struct seen *seendb = NULL;
+    json_t *destroy_emails = json_array();
+
+    /* Parse request */
+    jmap_copy_parse(req, &parser, NULL, NULL, &copy, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    int r = seen_open(req->userid, SEEN_CREATE, &seendb);
+    if (r) {
+        syslog(LOG_ERR, "jmap_email_copy: can't open seen.db: %s",
+                        error_message(r));
+        jmap_error(req, jmap_server_error(r));
+        goto done;
+    }
+
+    /* Process request */
+    const char *creation_id;
+    json_t *copy_email;
+    json_object_foreach(copy.create, creation_id, copy_email) {
+        json_t *set_err = NULL;
+        json_t *new_email = NULL;
+
+        /* Validate create */
+        _email_copy_validate_props(copy_email, &set_err);
+        if (set_err) {
+            json_object_set_new(copy.not_created, creation_id, set_err);
+            continue;
+        }
+
+        /* Copy message */
+        _email_copy(req, copy_email, copy.from_account_id,
+                    seendb, &new_email, &set_err);
+        if (set_err) {
+            json_object_set_new(copy.not_created, creation_id, set_err);
+            continue;
+        }
+
+        /* Note the source ID for deletion */
+        json_array_append(destroy_emails, json_object_get(copy_email, "id"));
+
+        /* Report the message as created */
+        json_object_set_new(copy.created, creation_id, new_email);
+        const char *msg_id = json_string_value(json_object_get(new_email, "id"));
+        jmap_add_id(req, creation_id, msg_id);
+    }
+
+    /* Build response */
+    jmap_ok(req, jmap_copy_reply(&copy));
+
+    /* Destroy originals, if requested */
+    if (copy.on_success_destroy_original && json_array_size(destroy_emails)) {
+        json_t *subargs = json_object();
+        json_object_set(subargs, "destroy", destroy_emails);
+        json_object_set_new(subargs, "accountId", json_string(copy.from_account_id));
+        jmap_add_subreq(req, "Email/set", subargs, NULL);
+    }
+
+done:
+    json_decref(destroy_emails);
+    jmap_parser_fini(&parser);
+    jmap_copy_fini(&copy);
+    seen_close(&seendb);
+    return 0;
+}
+
+static int jmap_email_matchmime_method(jmap_req_t *req)
+{
+    json_t *jfilter = json_object_get(req->args, "filter");
+    json_t *jmime = json_object_get(req->args, "mime");
+    json_t *err = NULL;
+
+    struct buf mime = BUF_INITIALIZER;
+    buf_setcstr(&mime, json_string_value(jmime));
+    int matches = jmap_email_matchmime(&mime, jfilter, req->accountid, time(NULL), &err);
+    buf_free(&mime);
+    if (!err) {
+        json_t *res = json_pack("{s:O s:b}", "filter", jfilter, "matches", matches);
+        jmap_ok(req, res);
+    }
+    else {
+        jmap_error(req, err);
+    }
+
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_mail.h 3.2.0-3/imap/jmap_mail.h
--- 3.0.13-5/imap/jmap_mail.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mail.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,69 @@
+/* jmap_mail.h -- Routines for handling JMAP mail messages
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef JMAP_MAIL_H
+#define JMAP_MAIL_H
+
+#include <config.h>
+
+#include "hash.h"
+#include "http_jmap.h"
+#include "jmap_util.h"
+#include "json_support.h"
+#include "msgrecord.h"
+
+extern int jmap_email_find(jmap_req_t *req, const char *email_id,
+                           char **mboxnameptr, uint32_t *uidptr);
+extern int jmap_email_get_with_props(jmap_req_t *req, hash_table *props,
+                                     msgrecord_t *mr, json_t **msgp);
+
+extern void jmap_emailsubmission_init(jmap_settings_t *settings);
+extern void jmap_emailsubmission_capabilities(json_t *jcapabilities);
+
+extern void jmap_mailbox_init(jmap_settings_t *settings);
+extern void jmap_mailbox_capabilities(json_t *jcapabilities);
+
+extern int jmap_mailbox_find_role(jmap_req_t *req, const char *role,
+                                  char **mboxnameptr, char **uniqueid);
+
+#endif /* JMAP_MAIL_H */
diff -pruN 3.0.13-5/imap/jmap_mail_query.c 3.2.0-3/imap/jmap_mail_query.c
--- 3.0.13-5/imap/jmap_mail_query.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mail_query.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,996 @@
+/* jmap_util.c -- Helper routines for JMAP
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <string.h>
+#include <syslog.h>
+
+#include "libconfig.h"
+
+#include "jmap_mail_query.h"
+#include "jmap_util.h"
+#include "json_support.h"
+
+#ifndef JMAP_URN_MAIL
+#define JMAP_URN_MAIL                "urn:ietf:params:jmap:mail"
+#endif
+#ifndef JMAP_MAIL_EXTENSION
+#define JMAP_MAIL_EXTENSION          "https://cyrusimap.org/ns/jmap/mail"
+#endif
+#ifndef JMAP_SEARCH_EXTENSION
+#define JMAP_SEARCH_EXTENSION        "https://cyrusimap.org/ns/jmap/search"
+#endif
+
+static int _email_threadkeyword_is_valid(const char *keyword)
+{
+    /* \Seen is always supported */
+    if (!strcasecmp(keyword, "$Seen"))
+        return 1;
+
+    const char *counted_flags = config_getstring(IMAPOPT_CONVERSATIONS_COUNTED_FLAGS);
+    if (!counted_flags)
+        return 0;
+
+    /* We really shouldn't do all this string mangling for each keyword */
+    strarray_t *flags = strarray_split(counted_flags, " ", STRARRAY_TRIM);
+    int i, is_supported = 0;
+    for (i = 0; i < flags->count; i++) {
+        const char *flag = strarray_nth(flags, i);
+        const char *kw = keyword;
+        if (*flag == '\\') { // special case \ => $
+            flag++;
+            if (*kw != '$') continue;
+            kw++;
+        }
+        if (!strcasecmp(flag, kw)) {
+            is_supported = 1;
+            break;
+        }
+    }
+    strarray_free(flags);
+
+    return is_supported;
+}
+
+
+HIDDEN void jmap_email_filtercondition_parse(struct jmap_parser *parser,
+                                             json_t *filter,
+                                             json_t *unsupported,
+                                             const strarray_t *capabilities)
+{
+    const char *field, *s = NULL;
+    json_t *arg;
+
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "inMailbox")) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "inMailboxOtherThan")) {
+            if (!json_is_array(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "before") ||
+                 !strcmp(field, "after")) {
+            if (!json_is_utcdate(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "minSize") ||
+                 !strcmp(field, "maxSize")) {
+            if (!json_is_integer(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "allInThreadHaveKeyword") ||
+                 !strcmp(field, "someInThreadHaveKeyword") ||
+                 !strcmp(field, "noneInThreadHaveKeyword")) {
+            if (!json_is_string(arg) ||
+                !(s = json_string_value(arg)) ||
+                !jmap_email_keyword_is_valid(s)) {
+                jmap_parser_invalid(parser, field);
+            }
+            else if (!_email_threadkeyword_is_valid(s)) {
+                json_array_append_new(unsupported, json_pack("{s:s}", field, s));
+            }
+        }
+        else if (!strcmp(field, "hasKeyword") ||
+                 !strcmp(field, "notKeyword")) {
+            if (!json_is_string(arg) ||
+                !jmap_email_keyword_is_valid(json_string_value(arg))) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "hasAttachment")) {
+            if (!json_is_boolean(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "text") ||
+                 !strcmp(field, "from") ||
+                 !strcmp(field, "to") ||
+                 !strcmp(field, "cc") ||
+                 !strcmp(field, "bcc") ||
+                 !strcmp(field, "subject") ||
+                 !strcmp(field, "body") ||
+                 (strarray_find(capabilities, JMAP_MAIL_EXTENSION, 0) >= 0 &&
+                  (!strcmp(field, "attachmentName") ||    /* FM-specific */
+                   !strcmp(field, "attachmentType"))) ||  /* FM-specific */
+                 (strarray_find(capabilities, JMAP_SEARCH_EXTENSION, 0) >= 0 &&
+                   !strcmp(field, "attachmentBody"))) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "header")) {
+            if (!json_is_array(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+            else {
+                switch (json_array_size(arg)) {
+                case 2:
+                    s = json_string_value(json_array_get(arg, 1));
+                    if (!s || !strlen(s)) {
+                        jmap_parser_push_index(parser, field, 1, s);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                    }
+
+                    GCC_FALLTHROUGH
+
+                case 1:
+                    s = json_string_value(json_array_get(arg, 0));
+                    if (!s || !strlen(s)) {
+                        jmap_parser_push_index(parser, field, 0, s);
+                        jmap_parser_invalid(parser, NULL);
+                        jmap_parser_pop(parser);
+                    }
+                    break;
+
+                default:
+                    jmap_parser_invalid(parser, field);
+                }
+            }
+        }
+        else if (strarray_find(capabilities, JMAP_MAIL_EXTENSION, 0) >= 0 &&
+                 (!strcmp(field, "fromContactGroupId") ||
+                  !strcmp(field, "toContactGroupId") ||
+                  !strcmp(field, "ccContactGroupId") ||
+                  !strcmp(field, "bccContactGroupId"))) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (strarray_find(capabilities, JMAP_MAIL_EXTENSION, 0) >= 0 &&
+                 (!strcmp(field, "fromAnyContact") ||
+                  !strcmp(field, "toAnyContact") ||
+                  !strcmp(field, "ccAnyContact") ||
+                  !strcmp(field, "bccAnyContact"))) {
+            if (!json_is_boolean(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+HIDDEN void jmap_email_filter_parse(struct jmap_parser *parser,
+                                    json_t *filter,
+                                    json_t *unsupported,
+                                    const strarray_t *capabilities)
+{
+    if (!JNOTNULL(filter) || json_typeof(filter) != JSON_OBJECT) {
+        jmap_parser_invalid(parser, NULL);
+        return;
+    }
+    json_t *jop = json_object_get(filter, "operator");
+    if (json_is_string(jop)) {
+        const char *op = json_string_value(jop);
+        if (strcmp("AND", op) && strcmp("OR", op) && strcmp("NOT", op)) {
+            jmap_parser_invalid(parser, "operator");
+        }
+        json_t *jconds = json_object_get(filter, "conditions");
+        if (!json_array_size(jconds)) {
+            jmap_parser_invalid(parser, "conditions");
+        }
+        size_t i;
+        json_t *jcond;
+        json_array_foreach(jconds, i, jcond) {
+            jmap_parser_push_index(parser, "conditions", i, NULL);
+            jmap_email_filter_parse(parser, jcond, unsupported, capabilities);
+            jmap_parser_pop(parser);
+        }
+    } else if (jop) {
+        jmap_parser_invalid(parser, "operator");
+    } else {
+        jmap_email_filtercondition_parse(parser, filter, unsupported, capabilities);
+    }
+}
+
+#ifdef WITH_DAV
+
+#include "annotate.h"
+#include "carddav_db.h"
+#include "global.h"
+#include "hash.h"
+#include "index.h"
+#include "search_query.h"
+#include "times.h"
+#include "xapian_wrap.h"
+
+HIDDEN void jmap_email_contactfilter_init(const char *accountid,
+                                          const char *addressbookid,
+                                          struct email_contactfilter *cfilter)
+{
+    memset(cfilter, 0, sizeof(struct email_contactfilter));
+    cfilter->accountid = accountid;
+    if (addressbookid) {
+        cfilter->addrbook = carddav_mboxname(accountid, addressbookid);
+    }
+}
+
+HIDDEN void jmap_email_contactfilter_fini(struct email_contactfilter *cfilter)
+{
+    if (cfilter->carddavdb) {
+        carddav_close(cfilter->carddavdb);
+    }
+    free(cfilter->addrbook);
+    free_hash_table(&cfilter->contactgroups, (void(*)(void*))strarray_free);
+}
+
+
+static int _get_sharedaddressbook_cb(const mbentry_t *mbentry, void *rock)
+{
+    mbname_t **mbnamep = rock;
+    if (!mbentry) return 0;
+    if (!(mbentry->mbtype & MBTYPE_ADDRESSBOOK)) return 0;
+    mbname_t *mbname = mbname_from_intname(mbentry->name);
+    if (!strcmpsafe(strarray_nth(mbname_boxes(mbname), -1), "Shared")) {
+        *mbnamep = mbname;
+        return CYRUSDB_DONE;
+    }
+    mbname_free(&mbname);
+    return 0;
+}
+
+
+static mbname_t *_get_sharedaddressbookuser(const char *userid)
+{
+    mbname_t *res = NULL;
+    int flags = MBOXTREE_PLUS_RACL|MBOXTREE_SKIP_ROOT|MBOXTREE_SKIP_CHILDREN;
+    // XXX - do we need to pass req->authstate right through??
+    int r = mboxlist_usermboxtree(userid, NULL, _get_sharedaddressbook_cb, &res, flags);
+    if (r == CYRUSDB_DONE)
+        return res;
+    mbname_free(&res);
+    return NULL;
+}
+
+
+static const struct contactfilters_t {
+    const char *field;
+    int isany;
+} contactfilters[] = {
+  { "fromContactGroupId", 0 },
+  { "toContactGroupId", 0 },
+  { "ccContactGroupId", 0 },
+  { "bccContactGroupId", 0 },
+  { "fromAnyContact", 1 },
+  { "toAnyContact", 1 },
+  { "ccAnyContact", 1 },
+  { "bccAnyContact", 1 },
+  { NULL, 0 }
+};
+
+HIDDEN int jmap_email_contactfilter_from_filtercondition(struct jmap_parser *parser,
+                                                         json_t *filter,
+                                                         struct email_contactfilter *cfilter)
+{
+    int havefield = 0;
+    const struct contactfilters_t *c;
+    mbname_t *othermb = NULL;
+    int r = 0;
+
+    /* prefilter to see if there are any fields that we will need to look up */
+    for (c = contactfilters; c->field; c++) {
+        json_t *arg = json_object_get(filter, c->field);
+        if (!arg) continue;
+        const char *groupid = c->isany ? (json_is_true(arg) ? "" : NULL) : json_string_value(arg);
+        if (!groupid) continue; // avoid looking up if invalid!
+        havefield = 1;
+        break;
+    }
+    if (!havefield) goto done;
+
+    /* ensure we have preconditions for lookups */
+    if (!cfilter->contactgroups.size) {
+        /* Initialize groups lookup table */
+        construct_hash_table(&cfilter->contactgroups, 32, 0);
+    }
+
+    if (!cfilter->carddavdb) {
+        /* Open CardDAV db first time we need it */
+        cfilter->carddavdb = carddav_open_userid(cfilter->accountid);
+        if (!cfilter->carddavdb) {
+            syslog(LOG_ERR, "jmap: carddav_open_userid(%s) failed",
+                   cfilter->accountid);
+            r = CYRUSDB_INTERNAL;
+            goto done;
+        }
+    }
+
+    othermb = _get_sharedaddressbookuser(cfilter->accountid);
+    if (othermb) {
+        int r2 = carddav_set_otheruser(cfilter->carddavdb, mbname_userid(othermb));
+        if (r2) syslog(LOG_NOTICE, "DBNOTICE: failed to open otheruser %s contacts for %s",
+                 mbname_userid(othermb), cfilter->accountid);
+    }
+
+    /* fetch members for each filter referenced */
+
+    for (c = contactfilters; c->field; c++) {
+        json_t *arg = json_object_get(filter, c->field);
+        if (!arg) continue;
+        const char *groupid = c->isany ? (json_is_true(arg) ? "" : NULL) : json_string_value(arg);
+        if (!groupid) continue;
+        if (hash_lookup(groupid, &cfilter->contactgroups)) continue;
+
+        /* Lookup group member email addresses */
+        strarray_t *members = carddav_getgroup(cfilter->carddavdb, cfilter->addrbook, groupid, othermb);
+        if (!members) {
+            jmap_parser_invalid(parser, c->field);
+        }
+        else {
+            hash_insert(groupid, members, &cfilter->contactgroups);
+        }
+    }
+
+done:
+    mbname_free(&othermb);
+    return r;
+}
+
+HIDDEN void jmap_emailbodies_fini(struct emailbodies *bodies)
+{
+    ptrarray_fini(&bodies->attslist);
+    ptrarray_fini(&bodies->textlist);
+    ptrarray_fini(&bodies->htmllist);
+}
+
+static int _email_extract_bodies_internal(const struct body *parts,
+                                          int nparts,
+                                          const char *multipart_type,
+                                          int in_alternative,
+                                          ptrarray_t *textlist,
+                                          ptrarray_t *htmllist,
+                                          ptrarray_t *attslist)
+{
+    int i;
+
+    enum parttype { OTHER, PLAIN, HTML, MULTIPART, INLINE_MEDIA, MESSAGE };
+
+    int textlist_count = textlist ? textlist->count : -1;
+    int htmllist_count = htmllist ? htmllist->count : -1;
+
+    for (i = 0; i < nparts; i++) {
+        const struct body *part = parts + i;
+
+        /* Determine part type */
+        enum parttype parttype = OTHER;
+        if (!strcmp(part->type, "TEXT") && !strcmp(part->subtype, "PLAIN"))
+            parttype = PLAIN;
+        else if (!strcmp(part->type, "TEXT") && !strcmp(part->subtype, "RICHTEXT"))
+            parttype = PLAIN; // RFC 1341
+        else if (!strcmp(part->type, "TEXT") && !strcmp(part->subtype, "ENRICHED"))
+            parttype = PLAIN; // RFC 1563
+        else if (!strcmp(part->type, "TEXT") && !strcmp(part->subtype, "HTML"))
+            parttype = HTML;
+        else if (!strcmp(part->type, "MULTIPART"))
+            parttype = MULTIPART;
+        else if (!strcmp(part->type, "IMAGE") || !strcmp(part->type, "AUDIO") || !strcmp(part->type, "VIDEO"))
+            parttype = INLINE_MEDIA;
+
+        /* Determine disposition name, if any. */
+        const char *dispname = NULL;
+        struct param *param;
+        for (param = part->disposition_params; param; param = param->next) {
+            if (!strncasecmp(param->attribute, "filename", 8)) {
+                dispname = param->value;
+                break;
+            }
+        }
+        if (!dispname) {
+            for (param = part->params; param; param = param->next) {
+                if (!strncasecmp(param->attribute, "name", 4)) {
+                    dispname = param->value;
+                    break;
+                }
+            }
+        }
+        /* Determine if it's an inlined part */
+        int is_inline =
+            (!part->disposition || strcmp(part->disposition, "ATTACHMENT")) &&
+            /* Must be one of the allowed body types */
+            (parttype == PLAIN || parttype == HTML || parttype == INLINE_MEDIA) &&
+             /* If multipart/related, only the first part can be inline
+              * If a text part with a filename, and not the first item in the
+              * multipart, assume it is an attachment */
+             (i == 0 || (strcmp(multipart_type, "RELATED") &&
+                         (parttype == INLINE_MEDIA || !dispname)));
+        /* Handle by part type */
+        if (parttype == MULTIPART) {
+            _email_extract_bodies_internal(part->subpart, part->numparts,
+                    part->subtype,
+                    in_alternative || !strcmp(part->subtype, "ALTERNATIVE"),
+                    textlist, htmllist, attslist);
+        }
+        else if (is_inline) {
+            if (!strcmp(multipart_type, "ALTERNATIVE")) {
+                if (parttype == PLAIN && textlist) {
+                    ptrarray_append(textlist, (void*) part);
+                }
+                else if (parttype == HTML && htmllist) {
+                    ptrarray_append(htmllist, (void*) part);
+                }
+                else {
+                    ptrarray_append(attslist, (void*) part);
+                }
+                continue;
+            }
+            else if (in_alternative) {
+                if (parttype == PLAIN)
+                    htmllist = NULL;
+                if (parttype == HTML)
+                    textlist = NULL;
+            }
+            if (textlist)
+                ptrarray_append(textlist, (void*) part);
+            if (htmllist)
+                ptrarray_append(htmllist, (void*) part);
+            if ((!textlist || !htmllist) && parttype == INLINE_MEDIA)
+                ptrarray_append(attslist, (void*) part);
+        }
+        else {
+            ptrarray_append(attslist, (void*) part);
+        }
+    }
+
+    if (!strcmp(multipart_type, "ALTERNATIVE")) {
+        int j;
+        /* Found HTML part only */
+        if (textlist && htmllist && textlist_count == textlist->count) {
+            for (j = htmllist_count; j < htmllist->count; j++)
+                ptrarray_append(textlist, ptrarray_nth(htmllist, j));
+        }
+        /* Found TEXT part only */
+        if (htmllist && textlist && htmllist_count == htmllist->count) {
+            for (j = textlist_count; j < textlist->count; j++)
+                ptrarray_append(htmllist, ptrarray_nth(textlist, j));
+        }
+    }
+
+    return 0;
+}
+
+HIDDEN int jmap_emailbodies_extract(const struct body *root,
+                                     struct emailbodies *bodies)
+{
+    return _email_extract_bodies_internal(root, 1, "MIXED", 0,
+            &bodies->textlist, &bodies->htmllist,
+            &bodies->attslist);
+}
+
+struct matchmime_receiver {
+    struct search_text_receiver super;
+    xapian_dbw_t *dbw;
+    struct buf buf;
+};
+
+static int _matchmime_tr_begin_mailbox(search_text_receiver_t *rx __attribute__((unused)),
+                                       struct mailbox *mailbox __attribute__((unused)),
+                                       int incremental __attribute__((unused)))
+{
+    return 0;
+}
+
+static uint32_t _matchmime_tr_first_unindexed_uid(search_text_receiver_t *rx __attribute__((unused)))
+{
+    return 1;
+}
+
+static int _matchmime_tr_is_indexed(search_text_receiver_t *rx __attribute__((unused)),
+                                    message_t *msg __attribute__((unused)))
+{
+    return 0;
+}
+
+static int _matchmime_tr_begin_message(search_text_receiver_t *rx, message_t *msg)
+{
+    const struct message_guid *guid;
+    int r = message_get_guid(msg, &guid);
+    if (r) return r;
+
+    struct matchmime_receiver *tr = (struct matchmime_receiver *) rx;
+    return xapian_dbw_begin_doc(tr->dbw, guid, 'G');
+}
+
+static void _matchmime_tr_begin_part(search_text_receiver_t *rx __attribute__((unused)),
+                                     int part __attribute__((unused)),
+                                     const struct message_guid *content_guid __attribute__((unused)))
+{
+}
+
+static void _matchmime_tr_append_text(search_text_receiver_t *rx,
+                                      const struct buf *text)
+{
+    struct matchmime_receiver *tr = (struct matchmime_receiver *) rx;
+    buf_append(&tr->buf, text);
+}
+
+static void _matchmime_tr_end_part(search_text_receiver_t *rx, int part)
+{
+    struct matchmime_receiver *tr = (struct matchmime_receiver *) rx;
+    xapian_dbw_doc_part(tr->dbw, &tr->buf, part);
+    buf_reset(&tr->buf);
+}
+
+static int _matchmime_tr_end_message(search_text_receiver_t *rx)
+{
+    struct matchmime_receiver *tr = (struct matchmime_receiver *) rx;
+    return xapian_dbw_end_doc(tr->dbw);
+}
+
+static int _matchmime_tr_end_mailbox(search_text_receiver_t *rx __attribute__((unused)),
+                                     struct mailbox *mailbox __attribute__((unused)))
+{
+    return 0;
+}
+
+static int _matchmime_tr_flush(search_text_receiver_t *rx __attribute__((unused)))
+{
+    return 0;
+}
+
+static int _matchmime_tr_audit_mailbox(search_text_receiver_t *rx __attribute__((unused)),
+                                       bitvector_t *unindexed __attribute__((unused)))
+{
+    return 0;
+}
+
+static int _matchmime_tr_index_charset_flags(int base_flags)
+{
+    return base_flags | CHARSET_KEEPCASE;
+}
+
+static int _email_matchmime_evaluate_xcb(void *data __attribute__((unused)),
+                                         size_t n, void *rock)
+{
+    int *matches = rock;
+    /* There's just a single message in the in-memory database,
+     * so no need to check the message guid in the search result. */
+    *matches = n > 0;
+    return 0;
+}
+
+static xapian_query_t *_email_matchmime_contactgroup(const char *groupid,
+                                                     int part,
+                                                     xapian_db_t *db,
+                                                     struct email_contactfilter *cfilter)
+{
+    if (!cfilter->contactgroups.size) return NULL;
+
+    xapian_query_t *xq = NULL;
+    strarray_t *members = hash_lookup(groupid, &cfilter->contactgroups);
+    if (members && strarray_size(members)) {
+        ptrarray_t xsubqs = PTRARRAY_INITIALIZER;
+        int i;
+        for (i = 0; i < strarray_size(members); i++) {
+            const char *member = strarray_nth(members, i);
+            xapian_query_t *xsubq = xapian_query_new_match(db, part, member);
+            if (xsubq) ptrarray_append(&xsubqs, xsubq);
+        }
+        if (ptrarray_size(&xsubqs)) {
+            xq = xapian_query_new_compound(db, /*is_or*/1,
+                    (xapian_query_t **) xsubqs.data, xsubqs.count);
+        }
+        ptrarray_fini(&xsubqs);
+    }
+    return xq;
+}
+
+static int _email_matchmime_evaluate(json_t *filter,
+                                     message_t *m,
+                                     xapian_db_t *db,
+                                     struct email_contactfilter *cfilter,
+                                     time_t internaldate)
+{
+    json_t *conditions = json_object_get(filter, "conditions");
+    if (json_is_array(conditions)) {
+
+        /* Evaluate FilterOperator */
+
+        const char *strop = json_string_value(json_object_get(filter, "operator"));
+        enum search_op op = SEOP_UNKNOWN;
+        int matches;
+
+        if (!strcasecmpsafe(strop, "AND")) {
+            op = SEOP_AND;
+            matches = 1;
+        }
+        else if (!strcasecmpsafe(strop, "OR")) {
+            op = SEOP_OR;
+            matches = json_array_size(conditions) == 0;
+        }
+        else if (!strcasecmpsafe(strop, "NOT")) {
+            op = SEOP_NOT;
+            matches = json_array_size(conditions) != 0;
+        }
+        else return 0;
+
+        json_t *condition;
+        size_t i;
+        json_array_foreach(conditions, i, condition) {
+            int cond_matches = _email_matchmime_evaluate(condition, m, db, cfilter, internaldate);
+            if (op == SEOP_AND && !cond_matches) {
+                return 0;
+            }
+            if (op == SEOP_OR && cond_matches) {
+                return 1;
+            }
+            if (op == SEOP_NOT && cond_matches) {
+                return 0;
+            }
+        }
+
+        return matches;
+    }
+
+    /* Evaluate FilterCondition */
+
+    int matches = 1;
+
+    /* Xapian-backed criteria */
+    ptrarray_t xqs = PTRARRAY_INITIALIZER;
+    const char *match;
+    if ((match = json_string_value(json_object_get(filter, "text")))) {
+        ptrarray_t childqueries = PTRARRAY_INITIALIZER;
+        int i;
+        for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
+            if (i == SEARCH_PART_ATTACHMENTBODY)
+                continue;
+            void *xq = xapian_query_new_match(db, i, match);
+            if (xq) ptrarray_push(&childqueries, xq);
+        }
+        xapian_query_t *xq = xapian_query_new_compound(db, /*is_or*/1,
+                                       (xapian_query_t **)childqueries.data,
+                                       childqueries.count);
+        if (xq) ptrarray_append(&xqs, xq);
+        ptrarray_fini(&childqueries);
+    }
+    if ((match = json_string_value(json_object_get(filter, "from")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_FROM, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "to")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_TO, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "cc")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_CC, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "bcc")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_BCC, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "subject")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_SUBJECT, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "body")))) {
+        xapian_query_t *xq = xapian_query_new_match(db, SEARCH_PART_BODY, match);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "fromContactGroupId")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup(match, SEARCH_PART_FROM, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "toContactGroupId")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup(match, SEARCH_PART_TO, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "ccContactGroupId")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup(match, SEARCH_PART_CC, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((match = json_string_value(json_object_get(filter, "bccContactGroupId")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup(match, SEARCH_PART_BCC, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((json_is_true(json_object_get(filter, "fromAnyContact")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup("", SEARCH_PART_FROM, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((json_is_true(json_object_get(filter, "toAnyContact")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup("", SEARCH_PART_TO, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((json_is_true(json_object_get(filter, "ccAnyContact")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup("", SEARCH_PART_CC, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+    if ((json_is_true(json_object_get(filter, "bccAnyContact")))) {
+        xapian_query_t *xq = _email_matchmime_contactgroup("", SEARCH_PART_BCC, db, cfilter);
+        if (xq) ptrarray_append(&xqs, xq);
+    }
+
+    if (xqs.count) {
+        matches = 0;
+        xapian_query_t *xq = xapian_query_new_compound(db, /*is_or*/0,
+                (xapian_query_t **) xqs.data, xqs.count);
+        xapian_query_run(db, xq, 0, _email_matchmime_evaluate_xcb, &matches);
+        xapian_query_free(xq);
+    }
+    ptrarray_fini(&xqs);
+    if (!matches) return 0;
+
+    /* size */
+    if (json_object_get(filter, "minSize") || json_object_get(filter, "maxSize")) {
+        uint32_t size;
+        if (message_get_size(m, &size) == 0) {
+            json_int_t jint;
+            if ((jint = json_integer_value(json_object_get(filter, "minSize"))) > 0) {
+                if (size < jint) return 0;
+            }
+            if ((jint = json_integer_value(json_object_get(filter, "maxSize"))) > 0) {
+                if (size > jint) return 0;
+            }
+        }
+    }
+
+    json_t *jval;
+
+    /* hasAttachment */
+    if (JNOTNULL(jval = json_object_get(filter, "hasAttachment"))) {
+        const struct body *body;
+        if (message_get_cachebody(m, &body) == 0) {
+            struct emailbodies bodies = EMAILBODIES_INITIALIZER;
+            if (jmap_emailbodies_extract(body, &bodies) == 0) {
+                int have = ptrarray_size(&bodies.attslist) > 0;
+                int want = jval == json_true();
+                if (have != want) {
+                    matches = 0;
+                }
+            }
+            jmap_emailbodies_fini(&bodies);
+        }
+    }
+
+    /* header */
+    if (JNOTNULL((jval = json_object_get(filter, "header")))) {
+        const char *hdr, *val;
+
+        if (json_array_size(jval) == 2) {
+            hdr = json_string_value(json_array_get(jval, 0));
+            val = json_string_value(json_array_get(jval, 1));
+        } else {
+            hdr = json_string_value(json_array_get(jval, 0));
+            val = NULL; // match any value
+        }
+
+        matches = 0;
+
+        /* Replicate match_header logic in search_expr.c */
+        char *lhdr = lcase(xstrdup(hdr));
+        struct buf buf = BUF_INITIALIZER;
+        int r = message_get_field(m, lhdr,
+                MESSAGE_DECODED|MESSAGE_APPEND|MESSAGE_MULTIPLE, &buf);
+        if (!r) {
+            if (val) {
+                charset_t utf8 = charset_lookupname("utf-8");
+                char *v = NULL;
+                if ((v = charset_convert(val, utf8, charset_flags))) {
+                    comp_pat *pat = charset_compilepat(v);
+                    if (pat) {
+                        matches = charset_searchstring(v, pat, buf.s, buf.len,
+                                                       charset_flags);
+                    }
+                    charset_freepat(pat);
+                }
+                free(v);
+                charset_free(&utf8);
+            }
+            else {
+                matches = buf_len(&buf) > 0;
+            }
+        }
+        buf_free(&buf);
+        free(lhdr);
+
+        if (!matches) return 0;
+    }
+
+    /* before */
+    if (JNOTNULL(jval = json_object_get(filter, "before"))) {
+        time_t t;
+        time_from_iso8601(json_string_value(jval), &t);
+        if (internaldate >= t) return 0;
+    }
+    /* after */
+    if (JNOTNULL(jval = json_object_get(filter, "after"))) {
+        time_t t;
+        time_from_iso8601(json_string_value(jval), &t);
+        if (internaldate < t) return 0;
+    }
+
+    return matches;
+}
+
+HIDDEN int jmap_email_matchmime(struct buf *mime,
+                                json_t *jfilter,
+                                const char *accountid,
+                                time_t internaldate,
+                                json_t **err)
+{
+    int r = 0;
+    xapian_dbw_t *dbw = NULL;
+    message_t *m = NULL;
+    int matches = 0;
+
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    strarray_t capabilities = STRARRAY_INITIALIZER;
+    struct email_contactfilter cfilter;
+
+    json_t *unsupported = json_array();
+
+    /* Parse filter */
+    strarray_append(&capabilities, JMAP_URN_MAIL);
+    strarray_append(&capabilities, JMAP_MAIL_EXTENSION);
+    jmap_email_filter_parse(&parser, jfilter, unsupported, &capabilities);
+
+    /* Gather contactgroup ids */
+    jmap_email_contactfilter_init(accountid, /*addressbookid*/NULL, &cfilter);
+    ptrarray_t work = PTRARRAY_INITIALIZER;
+    ptrarray_push(&work, jfilter);
+    json_t *jf;
+    while ((jf = ptrarray_pop(&work))) {
+        size_t i;
+        json_t *jval;
+        json_array_foreach(json_object_get(jf, "conditions"), i, jval) {
+            ptrarray_push(&work, jval);
+        }
+        r = jmap_email_contactfilter_from_filtercondition(&parser, jf, &cfilter);
+        if (r) break;
+
+    }
+    ptrarray_fini(&work);
+    if (r) {
+        syslog(LOG_ERR, "jmap_matchmime: can't load contactgroups from filter: %s",
+                error_message(r));
+        *err = jmap_server_error(r);
+        goto done;
+    }
+    else if (json_array_size(parser.invalid)) {
+        *err = json_pack("{s:s s:O}", "type", "invalidArguments",
+                "arguments", parser.invalid);
+        goto done;
+    }
+    else if (json_array_size(unsupported)) {
+        *err = json_pack("{s:s s:O}", "type", "unsupportedFilter",
+                         "filters", unsupported);
+        goto done;
+    }
+
+    /* Parse message into memory */
+    m = message_new_from_data(buf_base(mime), buf_len(mime));
+    if (!m) {
+        syslog(LOG_ERR, "jmap_matchmime: can't create Cyrus message");
+        *err = jmap_server_error(r);
+        goto done;
+    }
+
+    /* Open in-memory search index */
+    r = xapian_dbw_openmem(&dbw);
+    if (r) {
+        syslog(LOG_ERR, "jmap_matchmime: can't open in-memory search backend: %s",
+                error_message(r));
+        *err = jmap_server_error(r);
+        goto done;
+    }
+
+    /* Index message bodies in-memory */
+    struct matchmime_receiver tr = {
+        {
+            _matchmime_tr_begin_mailbox,
+            _matchmime_tr_first_unindexed_uid,
+            _matchmime_tr_is_indexed,
+            _matchmime_tr_begin_message,
+            _matchmime_tr_begin_part,
+            _matchmime_tr_append_text,
+            _matchmime_tr_end_part,
+            _matchmime_tr_end_message,
+            _matchmime_tr_end_mailbox,
+            _matchmime_tr_flush,
+            _matchmime_tr_audit_mailbox,
+            _matchmime_tr_index_charset_flags,
+        },
+        dbw, BUF_INITIALIZER
+    };
+    r = index_getsearchtext(m, NULL, (struct search_text_receiver*) &tr, /*snippet*/0);
+    if (r) {
+        syslog(LOG_ERR, "jmap_matchmime: can't index MIME message: %s",
+                error_message(r));
+        *err = jmap_server_error(r);
+        goto done;
+    }
+    buf_free(&tr.buf);
+
+    /* Evaluate filter */
+    xapian_db_t *db = NULL;
+    r = xapian_db_opendbw(dbw, &db);
+    if (r) {
+        syslog(LOG_ERR, "jmap_matchmime: can't open query backend: %s",
+                error_message(r));
+        *err = jmap_server_error(r);
+        goto done;
+    }
+    matches = _email_matchmime_evaluate(jfilter, m, db, &cfilter, internaldate);
+    xapian_db_close(db);
+
+done:
+    jmap_email_contactfilter_fini(&cfilter);
+    jmap_parser_fini(&parser);
+    strarray_fini(&capabilities);
+    json_decref(unsupported);
+    xapian_dbw_close(dbw);
+    message_unref(&m);
+    return matches;
+}
+
+#endif /* WITH_DAV */
+
diff -pruN 3.0.13-5/imap/jmap_mail_query.h 3.2.0-3/imap/jmap_mail_query.h
--- 3.0.13-5/imap/jmap_mail_query.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mail_query.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,123 @@
+/* jmap_mail_query.h -- Helper routines for JMAP Email queries.
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef JMAP_MAIL_QUERY_H
+#define JMAP_MAIL_QUERY_H
+
+#include <jansson.h>
+
+#include "strarray.h"
+
+#include "jmap_util.h"
+
+extern void jmap_email_filtercondition_parse(struct jmap_parser *parser,
+                                             json_t *filter,
+                                             json_t *unsupported,
+                                             const strarray_t *capabilities);
+
+extern void jmap_email_filter_parse(struct jmap_parser *parser,
+                                    json_t *filter,
+                                    json_t *unsupported,
+                                    const strarray_t *capabilities);
+
+#ifdef WITH_DAV
+
+#include <time.h>
+
+#include "hash.h"
+#include "ptrarray.h"
+
+#include "carddav_db.h"
+#include "message.h"
+
+struct email_contactfilter {
+    const char *accountid;
+    struct carddav_db *carddavdb;
+    char *addrbook;
+    hash_table contactgroups; /* maps groupid to emails (strarray) */
+};
+
+extern void jmap_email_contactfilter_init(const char *accountid,
+                                          const char *addressbookid,
+                                          struct email_contactfilter *cfilter);
+extern void jmap_email_contactfilter_fini(struct email_contactfilter *cfilter);
+
+extern int jmap_email_contactfilter_from_filtercondition(struct jmap_parser *parser,
+                                                         json_t *filter,
+                                                         struct email_contactfilter *cfilter);
+
+struct emailbodies {
+    ptrarray_t attslist;
+    ptrarray_t textlist;
+    ptrarray_t htmllist;
+};
+
+#define EMAILBODIES_INITIALIZER { \
+    PTRARRAY_INITIALIZER, \
+    PTRARRAY_INITIALIZER, \
+    PTRARRAY_INITIALIZER \
+}
+
+extern void jmap_emailbodies_fini(struct emailbodies *bodies);
+
+extern int jmap_emailbodies_extract(const struct body *root,
+                                    struct emailbodies *bodies);
+
+/* Matches MIME message mime against the JMAP Email query
+ * filter.
+ *
+ * Contact groups are looked up in the default addressbook
+ * of accountid. Before/after filters are matched against
+ * internaldate.
+ *
+ * Returns non-zero if filter matches.
+ * On error, sets the JMAP error in err. */
+extern int jmap_email_matchmime(struct buf *mime,
+                                json_t *jfilter,
+                                const char *accountid,
+                                time_t internaldate,
+                                json_t **err);
+
+#endif /* WITH_DAV */
+
+#endif /* JMAP_MAIL_QUERY_H */
diff -pruN 3.0.13-5/imap/jmap_mail_submission.c 3.2.0-3/imap/jmap_mail_submission.c
--- 3.0.13-5/imap/jmap_mail_submission.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_mail_submission.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,2279 @@
+/* jmap_mail_submission.c -- Routines for handling JMAP mail submission
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+#include <limits.h>
+#include <errno.h>
+
+#include "acl.h"
+#include "append.h"
+#include "http_jmap.h"
+#include "http_proxy.h"
+#include "jmap_mail.h"
+#include "jmap_util.h"
+#include "json_support.h"
+#include "parseaddr.h"
+#include "proxy.h"
+#include "smtpclient.h"
+#include "sync_support.h"
+#include "times.h"
+#include "user.h"
+#include "util.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/http_err.h"
+#include "imap/imap_err.h"
+
+#define JMAP_SUBID_SIZE 12
+
+static int jmap_emailsubmission_get(jmap_req_t *req);
+static int jmap_emailsubmission_set(jmap_req_t *req);
+static int jmap_emailsubmission_changes(jmap_req_t *req);
+static int jmap_emailsubmission_query(jmap_req_t *req);
+static int jmap_emailsubmission_querychanges(jmap_req_t *req);
+static int jmap_identity_get(jmap_req_t *req);
+
+static jmap_method_t jmap_emailsubmission_methods_standard[] = {
+    {
+        "EmailSubmission/get",
+        JMAP_URN_SUBMISSION,
+        &jmap_emailsubmission_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "EmailSubmission/set",
+        JMAP_URN_SUBMISSION,
+        &jmap_emailsubmission_set,
+       /*flags*/0
+    },
+    {
+        "EmailSubmission/changes",
+        JMAP_URN_SUBMISSION,
+        &jmap_emailsubmission_changes,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "EmailSubmission/query",
+        JMAP_URN_SUBMISSION,
+        &jmap_emailsubmission_query,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "EmailSubmission/queryChanges",
+        JMAP_URN_SUBMISSION,
+        &jmap_emailsubmission_querychanges,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "Identity/get",
+        JMAP_URN_SUBMISSION,
+        &jmap_identity_get,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+static jmap_method_t jmap_emailsubmission_methods_nonstandard[] = {
+    { NULL, NULL, NULL, 0}
+};
+
+HIDDEN void jmap_emailsubmission_init(jmap_settings_t *settings)
+{
+    jmap_method_t *mp;
+    for (mp = jmap_emailsubmission_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    json_object_set_new(settings->server_capabilities,
+            JMAP_URN_SUBMISSION, json_object());
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        for (mp = jmap_emailsubmission_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+}
+
+HIDDEN void jmap_emailsubmission_capabilities(json_t *account_capabilities)
+{
+    static json_t *submit_capabilities = NULL;
+    smtpclient_t *smp = NULL;
+
+    if (!submit_capabilities && !smtpclient_open(&smp)) {
+        /* determine extensions from submission server */
+        json_t *submit_ext = json_object();
+        const char *smtp_capa[] = { "FUTURERELEASE", "SIZE", "DSN",
+                                    "DELIVERBY", "MT-PRIORITY", NULL };
+        const char **capa;
+        struct buf buf = BUF_INITIALIZER;
+        int delay_time = config_getduration(IMAPOPT_JMAP_MAX_DELAYED_SEND, 's');
+        if (delay_time < 0) delay_time = 0;
+
+        for (capa = smtp_capa; *capa; capa++) {
+            const char *args = smtpclient_has_ext(smp, *capa);
+
+            if (args) {
+                strarray_t *sa = strarray_split(args, NULL, STRARRAY_TRIM);
+                json_t *jargs = json_array();
+                int i;
+
+                for (i = 0; i < strarray_size(sa); i++) {
+                    buf_setcstr(&buf, strarray_nth(sa, i));
+                    json_array_append_new(jargs, json_string(buf_lcase(&buf)));
+                }
+                strarray_free(sa);
+
+                buf_setcstr(&buf, *capa);
+                json_object_set_new(submit_ext, buf_lcase(&buf), jargs);
+            }
+        }
+        smtpclient_close(&smp);
+        buf_free(&buf);
+        submit_capabilities = json_pack("{s:i s:o}",
+                                        "maxDelayedSend", delay_time,
+                                        "submissionExtensions", submit_ext);
+    }
+
+    json_object_set(account_capabilities, JMAP_URN_SUBMISSION, submit_capabilities);
+}
+
+static int _emailsubmission_address_parse(json_t *addr,
+                                          struct jmap_parser *parser,
+                                          time_t *holduntil)
+{
+    int is_valid = 0;
+
+    if (holduntil) *holduntil = 0;
+
+    json_t *email = json_object_get(addr, "email");
+    if (email && json_string_value(email)) {
+        struct address *a = NULL;
+        parseaddr_list(json_string_value(email), &a);
+        if (a && !a->invalid && a->mailbox && a->domain && !a->next) {
+            is_valid = 1;
+        }
+        parseaddr_free(a);
+    }
+    else {
+        jmap_parser_invalid(parser, "email");
+    }
+
+    const char *key;
+    json_t *val;
+    json_t *parameters = json_object_get(addr, "parameters");
+    jmap_parser_push(parser, "parameters");
+    json_object_foreach(parameters, key, val) {
+        if (!smtp_is_valid_esmtp_keyword(key)) {
+            jmap_parser_invalid(parser, key);
+        }
+        else if (JNOTNULL(val) && !json_is_string(val)) {
+            /* We'll xtext-encode any non-esmtp values later */
+            jmap_parser_invalid(parser, key);
+        }
+        if (holduntil) {
+            if (!strcasecmp(key, "HOLDFOR")) {
+                const char *nptr = json_string_value(val);
+                char *endptr = NULL;
+                unsigned long interval = strtoul(nptr, &endptr, 10);
+                time_t now = time(0);
+
+                if (*endptr != '\0' || interval > 99999999 /* per RFC 4865 */) {
+                    jmap_parser_invalid(parser, key);
+                }
+                else *holduntil = now + interval;
+            }
+            else if (!strcasecmp(key, "HOLDUNTIL")) {
+                if (time_from_iso8601(json_string_value(val), holduntil) < 0) {
+                    jmap_parser_invalid(parser, key);
+                }
+            }
+        }
+    }
+    jmap_parser_pop(parser);
+
+    return is_valid;
+}
+
+static int lookup_submission_collection(const char *accountid,
+                                        mbentry_t **mbentry)
+{
+    mbname_t *mbname;
+    const char *submissionname;
+    int r;
+
+    /* Create submission mailbox name from the parsed path */
+    mbname = mbname_from_userid(accountid);
+    mbname_push_boxes(mbname, config_getstring(IMAPOPT_JMAPSUBMISSIONFOLDER));
+
+    /* XXX - hack to allow @domain parts for non-domain-split users */
+    if (httpd_extradomain) {
+        /* not allowed to be cross domain */
+        if (mbname_localpart(mbname) &&
+            strcmpsafe(mbname_domain(mbname), httpd_extradomain)) {
+            r = HTTP_NOT_FOUND;
+            goto done;
+        }
+        mbname_set_domain(mbname, NULL);
+    }
+
+    /* Locate the mailbox */
+    submissionname = mbname_intname(mbname);
+    r = http_mlookup(submissionname, mbentry, NULL);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* Find location of INBOX */
+        char *inboxname = mboxname_user_mbox(accountid, NULL);
+
+        int r1 = http_mlookup(inboxname, mbentry, NULL);
+        free(inboxname);
+        if (r1 == IMAP_MAILBOX_NONEXISTENT) {
+            r = IMAP_INVALID_USER;
+            goto done;
+        }
+
+        int rights = httpd_myrights(httpd_authstate, *mbentry);
+        if (!(rights & ACL_CREATE)) {
+            r = IMAP_PERMISSION_DENIED;
+            goto done;
+        }
+
+        if (*mbentry) free((*mbentry)->name);
+        else *mbentry = mboxlist_entry_create();
+        (*mbentry)->name = xstrdup(submissionname);
+    }
+    else if (!r) {
+        int rights = httpd_myrights(httpd_authstate, *mbentry);
+        if (!(rights & ACL_INSERT)) {
+            r = IMAP_PERMISSION_DENIED;
+            goto done;
+        }
+    }
+
+  done:
+    mbname_free(&mbname);
+    return r;
+}
+
+
+static int ensure_submission_collection(const char *accountid,
+                                        mbentry_t **mbentryp,
+                                        int *created)
+{
+    mbentry_t *mbentry = NULL;
+    if (created) *created = 0;
+
+    /* submission collection */
+    int r = lookup_submission_collection(accountid, &mbentry);
+    if (!r) { // happy path
+        if (mbentryp) *mbentryp = mbentry;
+        else mboxlist_entry_free(&mbentry);
+        return 0;
+    }
+
+    // otherwise, clean up ready for next attempt
+    mboxlist_entry_free(&mbentry);
+
+    struct mboxlock *namespacelock = user_namespacelock(accountid);
+
+    // did we lose the race?
+    r = lookup_submission_collection(accountid, &mbentry);
+
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        if (created) *created = 1;
+
+        if (!mbentry) goto done;
+        else if (mbentry->server) {
+            proxy_findserver(mbentry->server, &http_protocol, httpd_userid,
+                             &backend_cached, NULL, NULL, httpd_in);
+            goto done;
+        }
+
+        int options = config_getint(IMAPOPT_MAILBOX_DEFAULT_OPTIONS)
+            | OPT_POP3_NEW_UIDL | OPT_IMAP_HAS_ALARMS;
+        r = mboxlist_createmailbox_opts(mbentry->name, MBTYPE_SUBMISSION,
+                                        NULL, 1 /* admin */, accountid,
+                                        httpd_authstate,
+                                        options, 0, 0, 0, 0, NULL, NULL);
+        if (r) {
+            syslog(LOG_ERR, "IOERROR: failed to create %s (%s)",
+                   mbentry->name, error_message(r));
+        }
+    }
+
+ done:
+    mboxname_release(&namespacelock);
+    if (mbentryp && !r) *mbentryp = mbentry;
+    else mboxlist_entry_free(&mbentry);
+    return r;
+}
+
+static int store_submission(struct mailbox *mailbox,
+                            struct buf *msg, time_t holduntil,
+                            json_t *emailsubmission,
+                            json_t **new_submission)
+{
+    struct stagemsg *stage = NULL;
+    struct appendstate as;
+    strarray_t flags = STRARRAY_INITIALIZER;
+    struct buf buf = BUF_INITIALIZER;
+    struct body *body = NULL;
+    char datestr[80], *from;
+    size_t msglen = buf_len(msg);
+    FILE *f = NULL;
+    int r;
+    time_t now = time(0);
+    time_t internaldate = holduntil;
+
+    if (!holduntil) {
+        /* Already sent */
+        msglen = 0;
+        internaldate = now;
+        strarray_append(&flags, "\\Answered");
+        if (config_getswitch(IMAPOPT_JMAPSUBMISSION_DELETEONSEND)) {
+            /* delete the EmailSubmission object immediately */
+            strarray_append(&flags, "\\Deleted");
+            // this non-standard flag is magic and works on the append layer
+            strarray_append(&flags, "\\Expunged");
+        }
+    }
+
+    /* Prepare to stage the message */
+    if (!(f = append_newstage(mailbox->name, internaldate, 0, &stage))) {
+        syslog(LOG_ERR, "append_newstage(%s) failed", mailbox->name);
+        r = IMAP_IOERROR;
+        goto done;
+    }
+
+    /* Stage the message to send as message/rfc822 */
+    time_to_rfc5322(now, datestr, sizeof(datestr));
+
+    if (strchr(httpd_userid, '@')) {
+        /* XXX  This needs to be done via an LDAP/DB lookup */
+        buf_printf(&buf, "<%s>", httpd_userid);
+    }
+    else {
+        buf_printf(&buf, "<%s@%s>", httpd_userid, config_servername);
+    }
+
+    from = charset_encode_mimeheader(buf_cstring(&buf), buf_len(&buf), 0);
+
+    fprintf(f, "MIME-Version: 1.0\r\n"
+            "Date: %s\r\n"
+            "From: %s\r\n"
+            "Subject: JMAP EmailSubmission for %s\r\n"
+            "Content-Type: message/rfc822\r\n"
+            "Content-Length: %ld\r\n"
+            "%s: ", datestr, from,
+            json_string_value(json_object_get(emailsubmission, "emailId")),
+            msglen, JMAP_SUBMISSION_HDR);
+    free(from);
+
+    /* Add JMAP submission object as content of header field */
+    size_t size = json_dumpb(emailsubmission, NULL, 0, 0);
+    buf_truncate(&buf, size);
+    size = json_dumpb(emailsubmission,
+                      (char *) buf_base(&buf), size, JSON_COMPACT);
+    r = fwrite(buf_base(&buf), size, 1, f);
+    buf_free(&buf);
+    if (!r) {
+        r = IMAP_IOERROR;
+        goto done;
+    }
+    fputs("\r\n\r\n", f);
+
+    /* Add submitted message */
+    if ((msglen && !fwrite(buf_base(msg), msglen, 1, f)) || fflush(f)) {
+        r = IMAP_IOERROR;
+        goto done;
+    }
+    fclose(f);
+
+    /* Prepare to append the message to the mailbox */
+    r = append_setup_mbox(&as, mailbox, httpd_userid, httpd_authstate,
+                          0, /*quota*/NULL, 0, 0, /*event*/0);
+    if (r) {
+        syslog(LOG_ERR, "append_setup(%s) failed: %s",
+               mailbox->name, error_message(r));
+        goto done;
+    }
+
+    /* Append the message to the mailbox */
+    r = append_fromstage(&as, &body, stage, internaldate, 0, &flags, 0, /*annots*/NULL);
+
+    if (r) {
+        append_abort(&as);
+        syslog(LOG_ERR, "append_fromstage(%s) failed: %s",
+               mailbox->name, error_message(r));
+        goto done;
+    }
+
+    r = append_commit(&as);
+    if (r) {
+        syslog(LOG_ERR, "append_commit(%s) failed: %s",
+               mailbox->name, error_message(r));
+        goto done;
+    }
+
+    /* Create id from message UID, using 'S' prefix */
+    char sub_id[JMAP_SUBID_SIZE];
+    sprintf(sub_id, "S%u", mailbox->i.last_uid);
+
+    char sendat[RFC3339_DATETIME_MAX];
+    time_to_rfc3339(internaldate, sendat, RFC3339_DATETIME_MAX);
+
+    // XXX: we should include all the other fields from the spec
+    *new_submission = json_pack("{s:s, s:s, s:s}",
+         "id", sub_id,
+         "undoStatus", (holduntil ? "pending" : "final"),
+         "sendAt", sendat
+    );
+
+  done:
+    if (body) {
+        message_free_body(body);
+        free(body);
+    }
+    strarray_fini(&flags);
+    append_removestage(stage);
+    if (mailbox) {
+        if (r) mailbox_abort(mailbox);
+        else r = mailbox_commit(mailbox);
+    }
+
+    return r;
+}
+
+static void _emailsubmission_create(jmap_req_t *req,
+                                    struct mailbox *submbox,
+                                    json_t *emailsubmission,
+                                    json_t **new_submission,
+                                    json_t **set_err,
+                                    smtpclient_t **sm, char **emailid)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct buf buf = BUF_INITIALIZER;
+
+    /* messageId */
+    json_t *jemailId = json_object_get(emailsubmission, "emailId");
+    const char *msgid = jmap_id_string_value(req, jemailId);
+    if (!msgid) {
+        jmap_parser_invalid(&parser, "emailId");
+    }
+    *emailid = xstrdupnull(msgid);
+
+    /* identityId */
+    const char *identityid = NULL;
+    json_t *jidentityId = json_object_get(emailsubmission, "identityId");
+    if (json_is_string(jidentityId)) {
+        identityid = json_string_value(jidentityId);
+        if (strcmp(identityid, req->userid)) {
+            jmap_parser_invalid(&parser, "identityId");
+        }
+    }
+    else {
+        jmap_parser_invalid(&parser, "identityId");
+    }
+
+    /* envelope */
+    time_t holduntil = 0;
+    json_t *envelope = json_object_get(emailsubmission, "envelope");
+    if (JNOTNULL(envelope)) {
+        jmap_parser_push(&parser, "envelope");
+        json_t *from = json_object_get(envelope, "mailFrom");
+        if (json_object_size(from)) {
+            jmap_parser_push(&parser, "mailFrom");
+            _emailsubmission_address_parse(from, &parser, &holduntil);
+            jmap_parser_pop(&parser);
+        }
+        else {
+            jmap_parser_invalid(&parser, "mailFrom");
+        }
+        json_t *rcpt = json_object_get(envelope, "rcptTo");
+        if (json_array_size(rcpt)) {
+            size_t i;
+            json_t *addr;
+            json_array_foreach(rcpt, i, addr) {
+                jmap_parser_push_index(&parser, "rcptTo", i, NULL);
+                _emailsubmission_address_parse(addr, &parser, NULL);
+                jmap_parser_pop(&parser);
+            }
+        }
+        else {
+            jmap_parser_invalid(&parser, "rcptTo");
+        }
+        jmap_parser_pop(&parser);
+    } else {
+        envelope = NULL;
+    }
+
+    /* Reject read-only properties */
+    if (json_object_get(emailsubmission, "id")) {
+        jmap_parser_invalid(&parser, "id");
+    }
+    if (json_object_get(emailsubmission, "threadId")) {
+        jmap_parser_invalid(&parser, "threadId");
+    }
+    if (json_object_get(emailsubmission, "sendAt")) {
+        jmap_parser_invalid(&parser, "sendAt");
+    }
+    if (json_object_get(emailsubmission, "undoStatus")) {
+        jmap_parser_invalid(&parser, "undoStatus");
+    }
+    if (json_object_get(emailsubmission, "deliveryStatus")) {
+        jmap_parser_invalid(&parser, "deliveryStatus");
+    }
+    if (json_object_get(emailsubmission, "dsnBlobIds")) {
+        jmap_parser_invalid(&parser, "dsnBlobIds");
+    }
+    if (json_object_get(emailsubmission, "mdnBlobIds")) {
+        jmap_parser_invalid(&parser, "mdnBlobIds");
+    }
+
+    if (json_array_size(parser.invalid)) {
+        *set_err = json_pack("{s:s}", "type", "invalidProperties");
+        json_object_set(*set_err, "properties", parser.invalid);
+        jmap_parser_fini(&parser);
+        return;
+    }
+    jmap_parser_fini(&parser);
+
+    /* No more returns from here on */
+    char *mboxname = NULL;
+    uint32_t uid = 0;
+    struct mailbox *mbox = NULL;
+    json_t *myenvelope = NULL;
+    msgrecord_t *mr = NULL;
+    json_t *msg = NULL;
+    int r = 0;
+    int fd_msg = -1;
+
+    /* Lookup the message */
+    r = jmap_email_find(req, msgid, &mboxname, &uid);
+    if (r) {
+        if (r == IMAP_NOTFOUND) {
+            *set_err = json_pack("{s:s}", "type", "emailNotFound");
+        }
+        goto done;
+    }
+
+    /* Check ACL */
+    if (!jmap_hasrights_byname(req, mboxname, ACL_READ)) {
+        *set_err = json_pack("{s:s}", "type", "emailNotFound");
+        goto done;
+    }
+
+    /* Open the mailboxes */
+    r = jmap_openmbox(req, mboxname, &mbox, 1);
+    if (r) goto done;
+
+    /* Load the message */
+    mr = msgrecord_from_uid(mbox, uid);
+    if (!mr) {
+        /* That's a never-should-happen error */
+        syslog(LOG_ERR, "Unexpected null msgrecord at %s:%d",
+               __FILE__, __LINE__);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    /* Extract envelope from message */
+    if (!envelope) {
+        hash_table props = HASH_TABLE_INITIALIZER;
+        construct_hash_table(&props, 8, 0);
+        hash_insert("sender", (void*)1, &props);
+        hash_insert("from", (void*)1, &props);
+        hash_insert("to", (void*)1, &props);
+        hash_insert("cc", (void*)1, &props);
+        hash_insert("bcc", (void*)1, &props);
+        hash_insert("replyTo", (void*)1, &props);
+        r = jmap_email_get_with_props(req, &props, mr, &msg);
+        free_hash_table(&props, NULL);
+        if (r) goto done;
+
+        myenvelope = json_object();
+        envelope = myenvelope;
+
+        /* Determine MAIL FROM */
+        json_t *jfrom = json_object_get(json_object_get(msg, "sender"), "email");
+        if (!jfrom) {
+            jfrom = json_object_get(msg, "from");
+            jfrom = json_object_get(json_array_get(jfrom, 0), "email");
+        }
+        if (!jfrom) {
+            *set_err = json_pack("{s:s}", "type", "notPermittedFrom");
+            goto done;
+        }
+        const char *from = json_string_value(jfrom);
+        /* TODO If the address found from this is not allowed by the identity
+         * associated with this submission, the email property from the identity
+         * MUST be used instead. */
+        json_object_set_new(myenvelope, "mailFrom",
+                            json_pack("{s:s}", "email", from));
+
+        /* Determine RCPT TO */
+        json_t *rcpts = json_pack("{}"); /* deduplicated set of recipients */
+        json_t *rcptTo = json_array();   /* envelope rcptTo value */
+        size_t i;
+        const char *s;
+        json_t *jval;
+        json_array_foreach(json_object_get(msg, "to"), i, jval) {
+            s = json_string_value(json_object_get(jval, "email"));
+            if (s) json_object_set(rcpts, s, json_true());
+        }
+        json_array_foreach(json_object_get(msg, "cc"), i, jval) {
+            s = json_string_value(json_object_get(jval, "email"));
+            if (s) json_object_set(rcpts, s, json_true());
+        }
+        json_array_foreach(json_object_get(msg, "bcc"), i, jval) {
+            s = json_string_value(json_object_get(jval, "email"));
+            if (s) json_object_set(rcpts, s, json_true());
+        }
+        json_object_foreach(rcpts, s, jval) {
+            json_array_append_new(rcptTo, json_pack("{s:s}", "email", s));
+        }
+        json_decref(rcpts);
+        json_object_set_new(myenvelope, "rcptTo", rcptTo);
+    }
+
+    /* Validate envelope */
+    if (!json_array_size(json_object_get(envelope, "rcptTo"))) {
+        *set_err = json_pack("{s:s}", "type", "noRecipients");
+        goto done;
+    }
+
+    /* Open the message file */
+    const char *fname;
+    r = msgrecord_get_fname(mr, &fname);
+    if (r) goto done;
+
+    fd_msg = open(fname, 0);
+    if (fd_msg == -1) {
+        syslog(LOG_ERR, "_email_submissioncreate: can't open %s: %m", fname);
+        r = IMAP_IOERROR;
+        goto done;
+    }
+
+    struct stat sbuf;
+    if (fstat(fd_msg, &sbuf) == -1) {
+        syslog(LOG_ERR, "_email_submissioncreate: can't fstat %s: %m", fname);
+        goto done;
+    }
+
+    buf_refresh_mmap(&buf, 1, fd_msg, fname, sbuf.st_size, mbox->name);
+    if (!buf_len(&buf)) {
+        syslog(LOG_ERR, "_email_submissioncreate: can't mmap %s: %m", fname);
+        r = IMAP_IOERROR;
+        goto done;
+    }
+
+    /* Fetch and set threadId */
+    char thread_id[JMAP_THREADID_SIZE];
+    bit64 cid;
+
+    r = msgrecord_get_cid(mr, &cid);
+    if (r) goto done;
+
+    jmap_set_threadid(cid, thread_id);
+    json_object_set_new(emailsubmission, "threadId", json_string(thread_id));
+
+    /* Close the message record and mailbox. There's a race
+     * with us still keeping the file descriptor to the
+     * message open. But we don't want to long-lock the
+     * mailbox while sending the mail over to a SMTP host */
+    msgrecord_unref(&mr);
+    jmap_closembox(req, &mbox);
+
+    if (!*sm) {
+        /* Open the SMTP connection */
+        r = smtpclient_open(sm);
+        if (r) goto done;
+    }
+    smtpclient_set_auth(*sm, req->userid);
+
+    /* Prepare envelope */
+    smtp_envelope_t smtpenv = SMTP_ENVELOPE_INITIALIZER;
+    jmap_emailsubmission_envelope_to_smtp(&smtpenv, envelope);
+
+    if (holduntil) {
+        /* Pre-flight the message */
+        smtpclient_set_size(*sm, buf_len(&buf));
+        r = smtpclient_sendprot(*sm, &smtpenv, NULL);
+    }
+    else {
+        /* Send message */
+        r = smtpclient_send(*sm, &smtpenv, &buf);
+    }
+    if (r) {
+        int i, max = 0;
+        json_t *invalid = NULL;
+        const char *desc = smtpclient_get_resp_text(*sm);
+
+        syslog(LOG_ERR, "jmap: can't create message submission: %s",
+               desc ? desc : error_message(r));
+
+        switch (r) {
+        case IMAP_MESSAGE_TOO_LARGE:
+            *set_err = json_pack("{s:s s:i}", "type", "tooLarge",
+                                 "maxSize", smtpclient_get_maxsize(*sm));
+            break;
+
+        case IMAP_MAILBOX_DISABLED:
+            for (i = 0; i < smtpenv.rcpts.count; i++) {
+                smtp_addr_t *addr = ptrarray_nth(&smtpenv.rcpts, i);
+                max += addr->completed;
+            }
+            *set_err = json_pack("{s:s s:i}", "type", "tooManyRecipients",
+                                 "maxRecipients", max);
+            break;
+
+        case IMAP_MAILBOX_NONEXISTENT:
+            invalid = json_array();
+            for (i = 0; i < smtpenv.rcpts.count; i++) {
+                smtp_addr_t *addr = ptrarray_nth(&smtpenv.rcpts, i);
+                if (!addr->completed) {
+                    json_array_append_new(invalid, json_string(addr->addr));
+                }
+            }
+            *set_err = json_pack("{s:s s:o}", "type", "invalidRecipients",
+                                 "invalidRecipients", invalid);
+            break;
+
+        case IMAP_REMOTE_DENIED: {
+            char *err = NULL;
+            const char *p;
+
+            if (smtpclient_has_ext(*sm, "ENHANCEDSTATUSCODES")) {
+                p = strchr(desc, ' ');
+                if (p) {
+                    desc = p+1;
+                    while (*desc == ' ') desc++;  /* trim leading whitespace */
+                }
+            }
+            if ((p = strstr(desc, "[jmapError:"))) {
+                p += 11;
+                const char *q = strchr(p, ']');
+                if (q) {
+                    err = xstrndup(p, q - p);
+                    desc = q+1;
+                    while (*desc == ' ') desc++;  /* trim leading whitespace */
+                }
+            }
+            if (!err) err = xstrdup("forbiddenToSend");
+            *set_err = json_pack("{s:s s:s}",
+                                 "type", err, "description", desc);
+            free(err);
+            break;
+        }
+
+        default:
+            *set_err = json_pack("{s:s s:s}", "type", "smtpProtocolError",
+                                 "description", desc);
+            break;
+        }
+    }
+    smtp_envelope_fini(&smtpenv);
+
+    if (r) goto done;
+
+    /* Replace any creation id with actual emailId */
+    json_object_set_new(emailsubmission, "emailId", json_string(msgid));
+
+    r = store_submission(submbox, &buf, holduntil,
+                         emailsubmission, new_submission);
+
+done:
+    if (r && *set_err == NULL) {
+       *set_err = jmap_server_error(r);
+    }
+    if (fd_msg != -1) close(fd_msg);
+    if (msg) json_decref(msg);
+    if (mr) msgrecord_unref(&mr);
+    if (mbox) jmap_closembox(req, &mbox);
+    if (myenvelope) json_decref(myenvelope);
+    free(mboxname);
+    buf_free(&buf);
+}
+
+static message_t *msg_from_subid(struct mailbox *submbox, const char *id)
+{
+    message_t *msg = NULL;
+    uint32_t uid = 0;
+
+    if (id[0] == 'S' && id[1] != '-' && strlen(id) < JMAP_SUBID_SIZE) {
+        char *endptr = NULL;
+
+        uid = strtoul(id+1, &endptr, 10);
+
+        if (*endptr || errno == ERANGE || uid > UINT_MAX) uid = 0;
+    }
+
+    if (uid) {
+        struct index_record record;
+        int r = mailbox_find_index_record(submbox, uid, &record);
+
+        if (!r && record.uid && !(record.internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+            msg = message_new_from_record(submbox, &record);
+        }
+    }
+
+    return msg;
+}
+
+static json_t *fetch_submission(message_t *msg)
+{
+    struct buf buf = BUF_INITIALIZER;
+    json_t *sub = NULL;
+
+    int r = message_get_field(msg, JMAP_SUBMISSION_HDR,
+                              MESSAGE_DECODED|MESSAGE_TRIM, &buf);
+
+    if (!r && buf_len(&buf)) {
+        json_error_t jerr;
+        sub = json_loadb(buf_base(&buf), buf_len(&buf),
+                         JSON_DISABLE_EOF_CHECK, &jerr);
+    }
+    buf_free(&buf);
+
+    return sub;
+}
+
+static void _emailsubmission_update(struct mailbox *submbox,
+                                    const char *id,
+                                    json_t *emailsubmission,
+                                    json_t **set_err,
+                                    char **emailid)
+{
+    message_t *msg = msg_from_subid(submbox, id);
+    const struct index_record *record;
+    json_t *sub = NULL;
+    int r = 0;
+
+    if (!msg) {
+        /* Not a valid id */
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        return;
+    }
+    record = msg_record(msg);
+
+    sub = fetch_submission(msg);
+    if (!sub) {
+        if (!r) r = IMAP_IOERROR;
+
+        *set_err = json_pack("{s:s, s:s}", "type", "serverFail", "description", error_message(r));
+        goto done;
+    }
+
+    *emailid = xstrdupnull(json_string_value(json_object_get(sub, "emailId")));
+
+    const char *arg;
+    json_t *val;
+    int do_cancel = 0;
+    json_object_foreach(emailsubmission, arg, val) {
+        /* Make sure values in update match */
+        if (!json_equal(val, json_object_get(sub, arg))) {
+            /* Check the values that /get adds to the object */
+            switch (json_typeof(val)) {
+            case JSON_STRING:
+            {
+                const char *strval = json_string_value(val);
+
+                if (!strcmp(arg, "id") && !strcmp(strval, id)) {
+                    continue;
+                }
+                else if (!strcmp(arg, "sendAt")) {
+                    time_t t = 0;
+                    if (time_from_iso8601(strval, &t) == (int) strlen(strval) &&
+                        t == record->internaldate) {
+                        continue;
+                    }
+                }
+                else if (!strcmp(arg, "undoStatus")) {
+                    if (record->system_flags & FLAG_ANSWERED) {
+                        if (!strcmp(strval, "final")) continue;
+
+                        /* Already sent */
+                        *set_err = json_pack("{s:s}", "type", "cannotUnsend");
+                    }
+                    else if (record->system_flags & FLAG_FLAGGED) {
+                        if (!strcmp(strval, "canceled")) continue;
+                    }
+                    else if (!strcmp(strval, "pending")) {
+                        continue;
+                    }
+                    else if (!strcmp(strval, "canceled")) {
+                        do_cancel = 1;
+                        continue;
+                    }
+                }
+                break;
+            }
+
+            case JSON_NULL:
+                if (!strcmp(arg, "deliveryStatus")) continue;
+                break;
+
+            case JSON_ARRAY:
+                if (json_array_size(val) == 0 &&
+                    (!strcmp(arg, "dsnBlobIds") ||
+                     !strcmp(arg, "mdnBlobIds"))) {
+                    continue;
+                }
+                break;
+
+            default:
+                break;
+            }
+
+            if (!*set_err)
+                *set_err = json_pack("{s:s}", "type", "invalidProperties");
+            break;
+        }
+    }
+    json_decref(sub);
+
+    if (*set_err) goto done;
+
+    if (do_cancel) {
+        struct index_record newrecord;
+
+        memcpy(&newrecord, record, sizeof(struct index_record));
+        newrecord.system_flags |= FLAG_FLAGGED;
+        if (config_getswitch(IMAPOPT_JMAPSUBMISSION_DELETEONSEND)) {
+            newrecord.system_flags |= FLAG_DELETED;
+            newrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
+        }
+
+        r = mailbox_rewrite_index_record(submbox, &newrecord);
+        if (r) *set_err = json_pack("{s:s, s:s}", "type", "serverFail", "description", error_message(r));
+    }
+
+  done:
+    message_unref(&msg);
+}
+
+static void _emailsubmission_destroy(struct mailbox *submbox,
+                                     const char *id,
+                                     json_t **set_err,
+                                     char **emailid)
+{
+    message_t *msg = msg_from_subid(submbox, id);
+    struct index_record newrecord;
+    json_t *sub = NULL;
+    int r = 0;
+
+    if (!msg) {
+        /* Not a valid id */
+        *set_err = json_pack("{s:s}", "type", "notFound");
+        return;
+    }
+    const struct index_record *record = msg_record(msg);
+
+    sub = fetch_submission(msg);
+    if (!sub) {
+        if (!r) r = IMAP_IOERROR;
+
+        *set_err = json_pack("{s:s, s:s}", "type", "serverFail", "description", error_message(r));
+        goto done;
+    }
+
+    *emailid = xstrdupnull(json_string_value(json_object_get(sub, "emailId")));
+
+    memcpy(&newrecord, record, sizeof(struct index_record));
+    newrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
+
+    r = mailbox_rewrite_index_record(submbox, &newrecord);
+    if (r) *set_err = json_pack("{s:s, s:s}", "type", "serverFail", "description", error_message(r));
+
+done:
+    json_decref(sub);
+    message_unref(&msg);
+}
+
+static int getsubmission(struct jmap_get *get,
+                         const char *id, message_t *msg)
+{
+    json_t *sub = NULL;
+    int r = 0;
+
+    sub = fetch_submission(msg);
+    if (sub) {
+        /* id */
+        json_object_set_new(sub, "id", json_string(id));
+
+        /* identityId */
+        if (!jmap_wantprop(get->props, "identityId")) {
+            json_object_del(sub, "identityId");
+        }
+
+        /* emailId */
+        if (!jmap_wantprop(get->props, "emailId")) {
+            json_object_del(sub, "emailId");
+        }
+
+        /* threadId */
+        if (!jmap_wantprop(get->props, "threadId")) {
+            json_object_del(sub, "threadId");
+        }
+
+        /* envelope */
+        if (!jmap_wantprop(get->props, "envelope")) {
+            json_object_del(sub, "envelope");
+        }
+
+        /* senddAt */
+        if (jmap_wantprop(get->props, "sendAt")) {
+            char datestr[RFC3339_DATETIME_MAX];
+            time_t t;
+
+            r = message_get_internaldate(msg, &t);
+            if (r) goto done;
+
+            time_to_rfc3339(t, datestr, RFC3339_DATETIME_MAX);
+            json_object_set_new(sub, "sendAt", json_string(datestr));
+        }
+
+        /* undoStatus */
+        if (jmap_wantprop(get->props, "undoStatus")) {
+            uint32_t system_flags;
+            const char *status = "pending";
+
+            r = message_get_systemflags(msg, &system_flags);
+            if (r) goto done;
+
+            if (system_flags & FLAG_ANSWERED) {
+                status = "final";
+            }
+            else if (system_flags & FLAG_FLAGGED) {
+                status = "canceled";
+            }
+
+            json_object_set_new(sub, "undoStatus", json_string(status));
+        }
+
+        /* deliveryStatus */
+        if (jmap_wantprop(get->props, "deliveryStatus")) {
+            json_object_set_new(sub, "deliveryStatus", json_null());
+        }
+
+        /* dsnBlobIds */
+        if (jmap_wantprop(get->props, "dsnBlobIds")) {
+            json_object_set_new(sub, "dsnBlobIds", json_array());
+        }
+
+        /* mdnBlobIds */
+        if (jmap_wantprop(get->props, "mdnBlobIds")) {
+            json_object_set_new(sub, "mdnBlobIds", json_array());
+        }
+    }
+
+  done:
+    if (!r && sub) {
+        json_array_append_new(get->list, sub);
+    }
+    else {
+        json_array_append_new(get->not_found, json_string(id));
+
+        if (sub) json_decref(sub);
+
+        if (r) {
+            syslog(LOG_ERR,
+                   "jmap: EmailSubmission/get(%s): %s", id, error_message(r));
+        }
+    }
+
+    return r;
+}
+
+static const jmap_property_t submission_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "identityId",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "emailId",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "threadId",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "envelope",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "sendAt",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE
+    },
+    {
+        "undoStatus",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "deliveryStatus",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "dsnBlobIds",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    {
+        "mdnBlobIds",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+    { NULL, NULL, 0 }
+};
+
+static int jmap_emailsubmission_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+    mbentry_t *mbentry = NULL;
+    int created = 0;
+    struct mailbox *mbox = NULL;
+
+    jmap_get_parse(req, &parser, submission_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    int r = ensure_submission_collection(req->accountid,
+                                         &mbentry, &created);
+    if (r) {
+        syslog(LOG_ERR,
+               "jmap_emailsubmission_get: ensure_submission_collection(%s): %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+
+    r = jmap_openmbox(req, mbentry->name, &mbox, 0);
+    mboxlist_entry_free(&mbentry);
+    if (r) goto done;
+
+    /* Does the client request specific events? */
+    if (JNOTNULL(get.ids)) {
+        size_t i;
+        json_t *val;
+
+        json_array_foreach(get.ids, i, val) {
+            const char *id = json_string_value(val);
+            message_t *msg = msg_from_subid(mbox, id);
+
+            if (!msg) {
+                /* Not a valid id */
+                json_array_append_new(get.not_found, json_string(id));
+                continue;
+            }
+
+            r = getsubmission(&get, id, msg);
+            message_unref(&msg);
+        }
+    }
+    else {
+        struct mailbox_iter *iter = mailbox_iter_init(mbox, 0, ITER_SKIP_EXPUNGED);
+        const message_t *msg;
+        while ((msg = mailbox_iter_step(iter))) {
+            char id[JMAP_SUBID_SIZE];
+            uint32_t uid;
+
+            r = message_get_uid((message_t *) msg, &uid);
+            if (r) continue;
+
+            /* Create id from message UID, using 'S' prefix */
+            sprintf(id, "S%u", uid);
+            r = getsubmission(&get, id, (message_t *) msg);
+        }
+        mailbox_iter_done(&iter);
+    }
+
+    jmap_closembox(req, &mbox);
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_SUBMISSION, /*refresh*/ created);
+    get.state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
+
+struct submission_set_args {
+    json_t *onSuccessUpdate;
+    json_t *onSuccessDestroy;
+};
+
+static int _submission_setargs_parse(jmap_req_t *req,
+                                     struct jmap_parser *parser,
+                                     const char *key,
+                                     json_t *arg,
+                                     void *rock)
+{
+    struct submission_set_args *set = (struct submission_set_args *) rock;
+    int r = 1;
+
+    if (!strcmp(key, "onSuccessUpdateEmail")) {
+        // need urn:ietf:params:jmap:mail to update emails
+        if (!jmap_is_using(req, JMAP_URN_MAIL)) return 0;
+        if (json_is_object(arg)) {
+            json_t *jval;
+            const char *emailsubmission_id;
+            json_object_foreach(arg, emailsubmission_id, jval) {
+                if (!json_is_object(jval)) {
+                    jmap_parser_push(parser, "onSuccessUpdateEmail");
+                    jmap_parser_invalid(parser, emailsubmission_id);
+                    jmap_parser_pop(parser);
+                }
+            }
+            set->onSuccessUpdate = arg;
+        }
+        else if (JNOTNULL(arg)) r = 0;
+    }
+
+    else if (!strcmp(key, "onSuccessDestroyEmail") && JNOTNULL(arg)) {
+        // need urn:ietf:params:jmap:mail to destroy emails
+        if (!jmap_is_using(req, JMAP_URN_MAIL)) return 0;
+        jmap_parse_strings(arg, parser, "onSuccessDestroyEmail");
+        set->onSuccessDestroy = arg;
+    }
+
+    else r = 0;
+
+    return r;
+}
+
+static int jmap_emailsubmission_set(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+    struct submission_set_args sub_args = { NULL, NULL };
+    json_t *err = NULL;
+    struct mailbox *submbox = NULL;
+    mbentry_t *mbentry = NULL;
+    json_t *success_emailids = json_object();
+
+    /* Parse request */
+    jmap_set_parse(req, &parser, submission_props,
+                   &_submission_setargs_parse, &sub_args,
+                   &set, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Validate submissionIds in onSuccessXxxEmail */
+    if (JNOTNULL(sub_args.onSuccessUpdate)) {
+        const char *id;
+        json_t *jemail;
+
+        jmap_parser_push(&parser, "onSuccessUpdateEmail");
+        json_object_foreach(sub_args.onSuccessUpdate, id, jemail) {
+            int found;
+
+            if (*id == '#') {
+                found = json_object_get(set.create, id+1) != NULL;
+            }
+            else {
+                found = json_object_get(set.update, id) != NULL;
+                if (!found) found = json_array_find(set.destroy, id) >= 0;
+            }
+
+            if (!found) jmap_parser_invalid(&parser, id);
+        }
+        jmap_parser_pop(&parser);
+    }
+
+    if (JNOTNULL(sub_args.onSuccessDestroy)) {
+        size_t i;
+        json_t *jid;
+
+        jmap_parser_push(&parser, "onSuccessDestroyEmail");
+        json_array_foreach(sub_args.onSuccessDestroy, i, jid) {
+            const char *id = json_string_value(jid);
+            int found;
+
+            if (*id == '#') {
+                found = json_object_get(set.create, id+1) != NULL;
+            }
+            else {
+                found = json_object_get(set.update, id) != NULL;
+                if (!found) found = json_array_find(set.destroy, id) >= 0;
+            }
+
+            if (!found) jmap_parser_invalid(&parser, id);
+        }
+        jmap_parser_pop(&parser);
+    }
+
+    if (json_array_size(parser.invalid)) {
+        err = json_pack("{s:s}", "type", "invalidProperties");
+        json_object_set(err, "properties", parser.invalid);
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Process request */
+
+    int r = ensure_submission_collection(req->accountid, &mbentry, NULL);
+    if (r) {
+        syslog(LOG_ERR,
+               "jmap_emailsubmission_set: ensure_submission_collection(%s): %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+
+    r = jmap_openmbox(req, mbentry->name, &submbox, 1);
+    assert(submbox);
+    mboxlist_entry_free(&mbentry);
+    if (r) goto done;
+
+    if (set.if_in_state) {
+        /* TODO rewrite state function to use char* not json_t* */
+        json_t *jstate = json_string(set.if_in_state);
+        if (jmap_cmpstate(req, jstate, MBTYPE_SUBMISSION)) {
+            jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+            json_decref(jstate);
+            goto done;
+        }
+        json_decref(jstate);
+        set.old_state = xstrdup(set.if_in_state);
+    }
+    else {
+        json_t *jstate = jmap_getstate(req, MBTYPE_SUBMISSION, /*refresh*/0);
+        set.old_state = xstrdup(json_string_value(jstate));
+        json_decref(jstate);
+    }
+
+    /* create */
+    json_t *jsubmission;
+    const char *creation_id;
+    smtpclient_t *sm = NULL;
+    json_object_foreach(set.create, creation_id, jsubmission) {
+        json_t *set_err = NULL;
+        json_t *new_submission = NULL;
+        char *emailid = NULL;
+        _emailsubmission_create(req, submbox, jsubmission,
+                                &new_submission, &set_err, &sm, &emailid);
+        if (set_err) {
+            json_object_set_new(set.not_created, creation_id, set_err);
+            free(emailid);
+            continue;
+        }
+        const char *id = json_string_value(json_object_get(new_submission, "id"));
+        json_object_set_new(set.created, creation_id, new_submission);
+        json_object_set_new(success_emailids, id, json_string(emailid));
+        free(emailid);
+    }
+    if (sm) smtpclient_close(&sm);
+
+    /* update */
+    const char *id;
+    json_object_foreach(set.update, id, jsubmission) {
+        json_t *set_err = NULL;
+        char *emailid = NULL;
+        _emailsubmission_update(submbox, id, jsubmission, &set_err, &emailid);
+        if (set_err) {
+            json_object_set_new(set.not_updated, id, set_err);
+            free(emailid);
+            continue;
+        }
+        json_object_set_new(set.updated, id, json_pack("{s:s}", "id", id));
+        json_object_set_new(success_emailids, id, json_string(emailid));
+        free(emailid);
+    }
+
+    /* destroy */
+    size_t i;
+    json_t *jsubmissionId;
+    json_array_foreach(set.destroy, i, jsubmissionId) {
+        const char *id = json_string_value(jsubmissionId);
+        json_t *set_err = NULL;
+        char *emailid = NULL;
+        _emailsubmission_destroy(submbox, id, &set_err, &emailid);
+        if (set_err) {
+            json_object_set_new(set.not_destroyed, id, set_err);
+            free(emailid);
+            continue;
+        }
+        json_array_append_new(set.destroyed, json_string(id));
+        json_object_set_new(success_emailids, id, json_string(emailid));
+        free(emailid);
+    }
+
+    /* force modseq to stable */
+    if (submbox) mailbox_unlock_index(submbox, NULL);
+
+    // TODO refactor jmap_getstate to return a string, once
+    // all code has been migrated to the new JMAP parser.
+    json_t *jstate = jmap_getstate(req, MBTYPE_SUBMISSION, /*refresh*/1);
+    set.new_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+
+    jmap_ok(req, jmap_set_reply(&set));
+
+    /* Process onSuccessXxxEmail */
+    if (JNOTNULL(sub_args.onSuccessUpdate) ||
+        JNOTNULL(sub_args.onSuccessDestroy)) {
+        json_t *subargs = json_object();
+
+        json_object_set_new(subargs, "accountId", json_string(req->accountid));
+
+        if (JNOTNULL(sub_args.onSuccessUpdate)) {
+            json_t *updateEmails = json_object();
+            const char *jid;
+            json_t *jemail;
+
+            json_object_foreach(sub_args.onSuccessUpdate, jid, jemail) {
+                const char *id = jid;
+                if (*id == '#') {
+                    json_t *jsuccess = json_object_get(set.created, id+1);
+                    if (jsuccess)
+                        id = json_string_value(json_object_get(jsuccess, "id"));
+                }
+                const char *emailid = json_string_value(json_object_get(success_emailids, id));
+                if (emailid) json_object_set(updateEmails, emailid, jemail);
+            }
+
+            json_object_set_new(subargs, "update", updateEmails);
+        }
+
+        if (JNOTNULL(sub_args.onSuccessDestroy)) {
+            json_t *destroyEmails = json_array();
+            size_t i;
+            json_t *jid;
+            json_array_foreach(sub_args.onSuccessDestroy, i, jid) {
+                const char *id = json_string_value(jid);
+                if (*id == '#') {
+                    json_t *jsuccess = json_object_get(set.created, id+1);
+                    if (jsuccess)
+                        id = json_string_value(json_object_get(jsuccess, "id"));
+                }
+                const char *emailid = json_string_value(json_object_get(success_emailids, id));
+                if (emailid) json_array_append_new(destroyEmails, json_string(emailid));
+            }
+
+            json_object_set_new(subargs, "destroy", destroyEmails);
+        }
+
+        jmap_add_subreq(req, "Email/set", subargs, NULL);
+    }
+
+done:
+    jmap_closembox(req, &submbox);
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    json_decref(success_emailids);
+    return 0;
+}
+
+static int jmap_emailsubmission_changes(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_changes changes;
+    struct mailbox *mbox = NULL;
+    mbentry_t *mbentry = NULL;
+
+    json_t *err = NULL;
+    jmap_changes_parse(req, &parser, NULL, NULL, &changes, &err);
+    if (err) {
+        jmap_error(req, err);
+        return 0;
+    }
+
+    int r = ensure_submission_collection(req->accountid, &mbentry, NULL);
+    if (r) {
+        syslog(LOG_ERR,
+               "jmap_emailsubmission_changes: ensure_submission_collection(%s): %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+
+    r = jmap_openmbox(req, mbentry->name, &mbox, 0);
+    mboxlist_entry_free(&mbentry);
+    if (r) goto done;
+
+    struct mailbox_iter *iter = mailbox_iter_init(mbox, changes.since_modseq, 0);
+    const message_t *msg;
+    size_t changes_count = 0;
+    modseq_t highest_modseq = 0;
+    while ((msg = mailbox_iter_step(iter))) {
+        char id[JMAP_SUBID_SIZE];
+        const struct index_record *record = msg_record(msg);
+
+        /* Create id from message UID, using 'S' prefix */
+        sprintf(id, "S%u", record->uid);
+
+        /* Skip any submissions created AND deleted since modseq */
+        if ((record->internal_flags & FLAG_INTERNAL_EXPUNGED) &&
+            record->createdmodseq > changes.since_modseq) continue;
+
+        /* Apply limit, if any */
+        if (changes.max_changes && ++changes_count > changes.max_changes) {
+            changes.has_more_changes = 1;
+            break;
+        }
+
+        /* Keep track of the highest modseq */
+        if (highest_modseq < record->modseq) highest_modseq = record->modseq;
+
+        /* Add change to the proper array */
+        if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
+            json_array_append_new(changes.destroyed, json_string(id));
+        }
+        else if (record->createdmodseq > changes.since_modseq) {
+            json_array_append_new(changes.created, json_string(id));
+        }
+        else {
+            json_array_append_new(changes.updated, json_string(id));
+        }
+    }
+    mailbox_iter_done(&iter);
+
+    jmap_closembox(req, &mbox);
+
+    /* Set new state */
+    // XXX - this is wrong!  If we want to do this, we need to sort all the changes by
+    // their modseq and then only send some of them.  Otherwise consider the following:
+    // UID=1 HMS=5
+    // UID=3 HMS=15
+    // UID=4 HMS=10
+    // if we issued a query for changes since 6, max_changes 1 - we'd get back
+    // has_more_changes: true, new_modseq 15, and we'd never see UID=4 as having changed.
+    changes.new_modseq = changes.has_more_changes ?
+        highest_modseq : jmap_highestmodseq(req, MBTYPE_SUBMISSION);
+
+    jmap_ok(req, jmap_changes_reply(&changes));
+
+done:
+    jmap_changes_fini(&changes);
+    jmap_parser_fini(&parser);
+    return 0;
+}
+
+static void _emailsubmission_filter_parse(jmap_req_t *req __attribute__((unused)),
+                                          struct jmap_parser *parser,
+                                          json_t *filter,
+                                          json_t *unsupported __attribute__((unused)),
+                                          void *rock __attribute__((unused)),
+                                          json_t **err __attribute__((unused)))
+{
+    const char *field;
+    json_t *arg;
+
+    json_object_foreach(filter, field, arg) {
+        if (!strcmp(field, "emailIds") ||
+            !strcmp(field, "identityIds") ||
+            !strcmp(field, "threadIds")) {
+            if (!json_is_array(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+            else {
+                jmap_parse_strings(arg, parser, field);
+            }
+        }
+        else if (!strcmp(field, "undoStatus")) {
+            if (!json_is_string(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else if (!strcmp(field, "before") ||
+                 !strcmp(field, "after")) {
+            if (!json_is_utcdate(arg)) {
+                jmap_parser_invalid(parser, field);
+            }
+        }
+        else {
+            jmap_parser_invalid(parser, field);
+        }
+    }
+}
+
+
+static int _emailsubmission_comparator_parse(jmap_req_t *req __attribute__((unused)),
+                                             struct jmap_comparator *comp,
+                                             void *rock __attribute__((unused)),
+                                             json_t **err __attribute__((unused)))
+{
+    if (comp->collation) {
+        return 0;
+    }
+    if (!strcmp(comp->property, "emailId") ||
+        !strcmp(comp->property, "threadId") ||
+        !strcmp(comp->property, "sentAt")) {
+        return 1;
+    }
+    return 0;
+}
+
+#if (SIZEOF_TIME_T > 4)
+static time_t epoch    = (time_t) LONG_MIN;
+static time_t eternity = (time_t) LONG_MAX;
+#else
+static time_t epoch    = (time_t) INT_MIN;
+static time_t eternity = (time_t) INT_MAX;
+#endif
+
+typedef struct submission_filter {
+    strarray_t *identityIds;
+    strarray_t *emailIds;
+    strarray_t *threadIds;
+    const char *undoStatus;
+    time_t before;
+    time_t after;
+} submission_filter;
+
+/* Parse the JMAP EmailSubmission FilterCondition in arg.
+ * Report any invalid properties in invalid, prefixed by prefix.
+ * Return NULL on error. */
+static void *submission_filter_build(json_t *arg)
+{
+    submission_filter *f =
+        (submission_filter *) xzmalloc(sizeof(struct submission_filter));
+
+    f->before = eternity;
+    f->after = epoch;
+
+    /* identityIds */
+    json_t *identityIds = json_object_get(arg, "identityIds");
+    if (identityIds) {
+        f->identityIds = strarray_new();
+        size_t i;
+        json_t *val;
+        json_array_foreach(identityIds, i, val) {
+            const char *id;
+            if (json_unpack(val, "s", &id) != -1) {
+                strarray_append(f->identityIds, id);
+            }
+        }
+    }
+
+    /* emailIds */
+    json_t *emailIds = json_object_get(arg, "emailIds");
+    if (emailIds) {
+        f->emailIds = strarray_new();
+        size_t i;
+        json_t *val;
+        json_array_foreach(emailIds, i, val) {
+            const char *id;
+            if (json_unpack(val, "s", &id) != -1) {
+                strarray_append(f->emailIds, id);
+            }
+        }
+    }
+
+    /* threadIds */
+    json_t *threadIds = json_object_get(arg, "threadIds");
+    if (threadIds) {
+        f->threadIds = strarray_new();
+        size_t i;
+        json_t *val;
+        json_array_foreach(threadIds, i, val) {
+            const char *id;
+            if (json_unpack(val, "s", &id) != -1) {
+                strarray_append(f->threadIds, id);
+            }
+        }
+    }
+
+    /* undoStatus */
+    if (JNOTNULL(json_object_get(arg, "undoStatus"))) {
+        jmap_readprop(arg, "undoStatus", 0, NULL, "s", &f->undoStatus);
+    }
+
+    /* before */
+    if (JNOTNULL(json_object_get(arg, "before"))) {
+        const char *utcDate;
+        jmap_readprop(arg, "before", 0, NULL, "s", &utcDate);
+        time_from_iso8601(utcDate, &f->before);
+    }
+
+    /* after */
+    if (JNOTNULL(json_object_get(arg, "after"))) {
+        const char *utcDate;
+        jmap_readprop(arg, "after", 0, NULL, "s", &utcDate);
+        time_from_iso8601(utcDate, &f->after);
+    }
+
+    return f;
+}
+
+typedef struct submission_filter_rock {
+    const message_t *msg;
+    const char *emailId;
+    const char *threadId;
+    json_t *submission;
+} submission_filter_rock;
+
+/* Match the submission in rock against filter. */
+static int submission_filter_match(void *vf, void *rock)
+{
+    submission_filter *f = (submission_filter *) vf;
+    submission_filter_rock *sfrock = (submission_filter_rock*) rock;
+    const struct index_record *record = msg_record(sfrock->msg);
+
+    /* before */
+    if (record->internaldate >= f->before) return 0;
+
+    /* after */
+    if (record->internaldate < f->after) return 0;
+
+    /* undoStatus */
+    if (f->undoStatus) {
+        if (record->system_flags & FLAG_ANSWERED) {
+            if (strcmp(f->undoStatus, "final")) return 0;
+        }
+        else if (record->system_flags & FLAG_FLAGGED) {
+            if (strcmp(f->undoStatus, "canceled")) return 0;
+        }
+        else {
+            if (strcmp(f->undoStatus, "pending")) return 0;
+        }
+    }
+
+    /* identityIds / emailIds / ThreadIds */
+    if (f->identityIds || f->emailIds || f->threadIds) {
+        sfrock->submission = fetch_submission((message_t *) sfrock->msg);
+
+        if (!sfrock->submission) return 0;
+
+        if (f->identityIds) {
+            const char *identityId =
+                json_string_value(json_object_get(sfrock->submission,
+                                                  "identityId"));
+
+            if (strarray_find(f->identityIds, identityId, 0) == -1) return 0;
+        }
+        if (f->emailIds) {
+            sfrock->emailId =
+                json_string_value(json_object_get(sfrock->submission,
+                                                  "emailId"));
+
+            if (strarray_find(f->emailIds, sfrock->emailId, 0) == -1) return 0;
+        }
+        if (f->threadIds) {
+            sfrock->threadId =
+                json_string_value(json_object_get(sfrock->submission,
+                                                  "threadId"));
+
+            if (strarray_find(f->threadIds, sfrock->threadId, 0) == -1) return 0;
+        }
+    }
+
+    /* All matched. */
+    return 1;
+}
+
+/* Free the memory allocated by this submission filter. */
+static void submission_filter_free(void *vf)
+{
+    submission_filter *f = (submission_filter*) vf;
+    if (f->identityIds) strarray_free(f->identityIds);
+    if (f->emailIds) strarray_free(f->emailIds);
+    if (f->threadIds) strarray_free(f->threadIds);
+    free(f);
+}
+
+static struct sortcrit *sub_buildsort(json_t *sort, int *need_submission)
+{
+    json_t *jcomp;
+    size_t i;
+    struct sortcrit *sortcrit;
+
+    *need_submission = 0;
+
+    sortcrit = xzmalloc((json_array_size(sort) + 1) * sizeof(struct sortcrit));
+
+    json_array_foreach(sort, i, jcomp) {
+        const char *prop = json_string_value(json_object_get(jcomp, "property"));
+
+        if (json_object_get(jcomp, "isAscending") == json_false()) {
+            sortcrit[i].flags |= SORT_REVERSE;
+        }
+
+        /* Note: add any new sort criteria also to is_supported_msglist_sort */
+
+        if (!strcmp(prop, "emailId")) {
+            sortcrit[i].key = SORT_EMAILID;
+            *need_submission = 1;
+        }
+        else if (!strcmp(prop, "threadId")) {
+            sortcrit[i].key = SORT_THREADID;
+            *need_submission = 1;
+        }
+        else if (!strcmp(prop, "sentAt")) {
+            sortcrit[i].key = SORT_ARRIVAL;
+        }
+    }
+
+    i = json_array_size(sort);
+    sortcrit[i].key = SORT_UID;
+
+    return sortcrit;
+}
+
+struct sub_match {
+    char id[JMAP_SUBID_SIZE];
+    uint32_t uid;
+    time_t sentAt;
+    const char *emailId;
+    const char *threadId;
+    json_t *submission;
+    struct sortcrit *sortcrit;
+};
+
+/*
+ * Comparison function for sorting EmailSubmissions.
+ */
+static int sub_sort_compare(const void **vp1, const void **vp2)
+{
+    struct sub_match *m1 = (struct sub_match *) *vp1;
+    struct sub_match *m2 = (struct sub_match *) *vp2;
+    const struct sortcrit *sortcrit = m1->sortcrit;
+    int reverse, ret = 0, i = 0;
+
+    for (i = 0; !ret && sortcrit[i].key != SORT_UID; i++) {
+        /* determine sort order from reverse flag bit */
+        reverse = sortcrit[i].flags & SORT_REVERSE;
+
+        switch (sortcrit[i].key) {
+        case SORT_ARRIVAL:
+            ret = m1->sentAt - m2->sentAt;
+            break;
+        case SORT_EMAILID:
+            if (!m1->emailId) {
+                m1->emailId =
+                    json_string_value(json_object_get(m1->submission,
+                                                      "emailId"));
+            }
+            if (!m2->emailId) {
+                m2->emailId =
+                    json_string_value(json_object_get(m2->submission,
+                                                      "emailId"));
+            }
+            ret = strcmpsafe(m1->emailId, m2->emailId);
+            break;
+        case SORT_THREADID:
+            if (!m1->threadId) {
+                m1->threadId =
+                    json_string_value(json_object_get(m1->submission,
+                                                      "threadId"));
+            }
+            if (!m2->threadId) {
+                m2->threadId =
+                    json_string_value(json_object_get(m2->submission,
+                                                      "threadId"));
+            }
+            ret = strcmpsafe(m1->threadId, m2->threadId);
+            break;
+        }
+    }
+
+    // tiebreaker is UID
+    if (!ret) return (m1->uid - m2->uid);
+
+    return (reverse ? -ret : ret);
+}
+
+static int jmap_emailsubmission_query(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_query query;
+    struct mailbox *mbox = NULL;
+    mbentry_t *mbentry = NULL;
+    int created = 0;
+    jmap_filter *parsed_filter = NULL;
+    struct sortcrit *sortcrit = NULL;
+
+    /* Parse request */
+    json_t *err = NULL;
+    jmap_query_parse(req, &parser, NULL, NULL,
+                     _emailsubmission_filter_parse, NULL,
+                     _emailsubmission_comparator_parse, NULL,
+                     &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    int r = ensure_submission_collection(req->accountid, &mbentry, &created);
+    if (r) {
+        syslog(LOG_ERR,
+               "jmap_emailsubmission_changes: ensure_submission_collection(%s): %s",
+               req->accountid, error_message(r));
+        goto done;
+    }
+
+    r = jmap_openmbox(req, mbentry->name, &mbox, 0);
+    mboxlist_entry_free(&mbentry);
+    if (r) goto done;
+
+    /* Build filter */
+    json_t *filter = json_object_get(req->args, "filter");
+    if (JNOTNULL(filter)) {
+        parsed_filter = jmap_buildfilter(filter, submission_filter_build);
+    }
+
+    /* Build sortcrit */
+    int need_submission = 0;
+    json_t *sort = json_object_get(req->args, "sort");
+    if (JNOTNULL(sort)) {
+        sortcrit = sub_buildsort(sort, &need_submission);
+    }
+
+    ptrarray_t matches = PTRARRAY_INITIALIZER;
+    struct sub_match *anchor = NULL;
+    struct mailbox_iter *iter = mailbox_iter_init(mbox, 0, ITER_SKIP_EXPUNGED);
+    const message_t *msg;
+    while ((msg = mailbox_iter_step(iter))) {
+        const struct index_record *record = msg_record(msg);
+        submission_filter_rock sfrock = { msg, NULL, NULL, NULL };
+
+        if (query.filter) {
+            int match = jmap_filter_match(parsed_filter,
+                                          &submission_filter_match, &sfrock);
+            if (!match) {
+                if (sfrock.submission) json_decref(sfrock.submission);
+                continue;
+            }
+        }
+
+        /* Add record of the match to our array */
+        struct sub_match *match = xmalloc(sizeof(struct sub_match));
+
+        /* Create id from message UID, using 'S' prefix */
+        sprintf(match->id, "S%u", record->uid);
+        match->uid = record->uid;
+        match->sentAt = record->internaldate;
+        match->emailId = sfrock.emailId;
+        match->threadId = sfrock.threadId;
+        match->submission = sfrock.submission;
+        if (!match->submission && need_submission)
+            match->submission = fetch_submission((message_t *) msg);
+        match->sortcrit = sortcrit;
+        ptrarray_append(&matches, match);
+
+        if (query.anchor && !strcmp(query.anchor, match->id)) {
+            /* Mark record corresponding to anchor */
+            anchor = match;
+        }
+
+        query.total++;
+    }
+    mailbox_iter_done(&iter);
+
+    jmap_closembox(req, &mbox);
+
+    /* Sort results */
+    if (sortcrit) {
+        ptrarray_sort(&matches, &sub_sort_compare);
+    }
+
+    /* Process results */
+    if (query.anchor) {
+        query.position = ptrarray_find(&matches, anchor, 0);
+        if (query.position < 0) {
+            query.position = query.total;
+        }
+        else {
+            query.position += query.anchor_offset;
+        }
+    }
+    else if (query.position < 0) {
+        query.position += query.total;
+    }
+    if (query.position < 0) query.position = 0;
+
+    size_t i;
+    for (i = 0; i < query.total; i++) {
+        struct sub_match *match = ptrarray_nth(&matches, i);
+
+        /* Apply position and limit */
+        if (i >= (size_t) query.position &&
+            (!query.limit || query.limit > json_array_size(query.ids))) {
+            /* Add the submission identifier */
+            json_array_append_new(query.ids, json_string(match->id));
+        }
+
+        json_decref(match->submission);
+        free(match);
+    }
+    ptrarray_fini(&matches);
+    free(sortcrit);
+
+    /* Build response */
+    json_t *jstate = jmap_getstate(req, MBTYPE_SUBMISSION, /*refresh*/ created);
+    query.query_state = xstrdup(json_string_value(jstate));
+    json_decref(jstate);
+    query.result_position = query.position;
+    query.can_calculate_changes = 0;
+    jmap_ok(req, jmap_query_reply(&query));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_query_fini(&query);
+    if (parsed_filter) jmap_filter_free(parsed_filter, submission_filter_free);
+    return 0;
+}
+
+static int jmap_emailsubmission_querychanges(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_querychanges query;
+
+    /* Parse arguments */
+    json_t *err = NULL;
+    jmap_querychanges_parse(req, &parser, NULL, NULL,
+                            _emailsubmission_filter_parse, NULL,
+                            _emailsubmission_comparator_parse, NULL,
+                            &query, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Refuse all attempts to calculcate list updates */
+    jmap_error(req, json_pack("{s:s}", "type", "cannotCalculateChanges"));
+
+done:
+    jmap_querychanges_fini(&query);
+    jmap_parser_fini(&parser);
+    return 0;
+
+}
+
+/* Identity/get method */
+static const jmap_property_t identity_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "name",
+        NULL,
+        0
+    },
+    {
+        "email",
+        NULL,
+        JMAP_PROP_IMMUTABLE
+    },
+    {
+        "replyTo",
+        NULL,
+        0
+    },
+    {
+        "bcc",
+        NULL,
+        0
+    },
+    {
+        "textSignature",
+        NULL,
+        0
+    },
+    {
+        "htmlSignature",
+        NULL,
+        0
+    },
+    {
+        "mayDelete",
+        NULL,
+        JMAP_PROP_SERVER_SET
+    },
+
+    /* FM extensions (do ALL of these get through to Cyrus?) */
+    {
+        "displayName",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "addBccOnSMTP",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "saveSentToMailboxId",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "saveOnSMTP",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "useForAutoReply",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "isAutoConfigured",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "enableExternalSMTP",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpServer",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpPort",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpSSL",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpUser",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpPassword",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "smtpRemoteService",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+    {
+        "popLinkId",
+        JMAP_MAIL_EXTENSION,
+        0
+    },
+
+    { NULL, NULL, 0 }
+};
+
+static int jmap_identity_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, identity_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Build response */
+    json_t *me = json_pack("{s:s}", "id", req->userid);
+    if (jmap_wantprop(get.props, "name")) {
+        json_object_set_new(me, "name", json_string(""));
+    }
+    if (jmap_wantprop(get.props, "email")) {
+        json_object_set_new(me, "email",
+                json_string(strchr(req->userid, '@') ? req->userid : ""));
+    }
+
+    if (jmap_wantprop(get.props, "mayDelete")) {
+        json_object_set_new(me, "mayDelete", json_false());
+    }
+    if (json_array_size(get.ids)) {
+        size_t i;
+        json_t *val;
+        json_array_foreach(get.ids, i, val) {
+            if (strcmp(json_string_value(val), req->userid)) {
+                json_array_append(get.not_found, val);
+            }
+            else {
+                json_array_append(get.list, me);
+            }
+        }
+    } else if (!JNOTNULL(get.ids)) {
+        json_array_append(get.list, me);
+    }
+    json_decref(me);
+
+    /* Reply */
+    get.state = xstrdup("0");
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+    return 0;
+}
diff -pruN 3.0.13-5/imap/jmap_util.c 3.2.0-3/imap/jmap_util.c
--- 3.0.13-5/imap/jmap_util.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_util.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,548 @@
+/* jmap_util.c -- Helper routines for JMAP
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#include <string.h>
+#include <syslog.h>
+
+#include <sasl/saslutil.h>
+
+#include "annotate.h"
+#include "carddav_db.h"
+#include "global.h"
+#include "hash.h"
+#include "index.h"
+#include "jmap_util.h"
+#include "json_support.h"
+#include "search_query.h"
+#include "times.h"
+#include "xapian_wrap.h"
+
+EXPORTED int jmap_readprop_full(json_t *root, const char *prefix, const char *name,
+                              int mandatory, json_t *invalid, const char *fmt,
+                              void *dst)
+{
+    int r = 0;
+    json_t *jval = json_object_get(root, name);
+    if (!jval && mandatory) {
+        r = -1;
+    } else if (jval) {
+        json_error_t err;
+        if (json_unpack_ex(jval, &err, 0, fmt, dst)) {
+            r = -2;
+        } else {
+            r = 1;
+        }
+    }
+    if (r < 0 && prefix) {
+        struct buf buf = BUF_INITIALIZER;
+        buf_printf(&buf, "%s.%s", prefix, name);
+        json_array_append_new(invalid, json_string(buf_cstring(&buf)));
+        buf_free(&buf);
+    } else if (r < 0) {
+        json_array_append_new(invalid, json_string(name));
+    }
+    return r;
+}
+
+EXPORTED int jmap_pointer_needsencode(const char *src)
+{
+    return strchr(src, '/') || strchr(src, '~');
+}
+
+EXPORTED char* jmap_pointer_encode(const char *src)
+{
+    struct buf buf = BUF_INITIALIZER;
+    const char *base, *top;
+    buf_ensure(&buf, strlen(src));
+
+    base = src;
+    top = base;
+    while (*base) {
+        for (top = base; *top && *top != '~' && *top != '/'; top++)
+            ;
+        if (!*top) break;
+
+        buf_appendmap(&buf, base, top-base);
+        if (*top == '~') {
+            buf_appendmap(&buf, "~0", 2);
+            top++;
+        } else if (*top == '/') {
+            buf_appendmap(&buf, "~1", 2);
+            top++;
+        }
+        base = top;
+    }
+    buf_appendmap(&buf, base, top-base);
+    return buf_release(&buf);
+}
+
+EXPORTED char *jmap_pointer_decode(const char *src, size_t len)
+{
+    struct buf buf = BUF_INITIALIZER;
+    const char *base, *top, *end;
+
+    buf_ensure(&buf, len);
+    end = src + len;
+
+    base = src;
+    while (base < end && (top = strchr(base, '~')) && top < end) {
+        buf_appendmap(&buf, base, top-base);
+
+        if (top < end-1 && *(top+1) == '0') {
+            buf_appendcstr(&buf, "~");
+            base = top + 2;
+        } else if (top < end-1 && *(top+1) == '1') {
+            buf_appendcstr(&buf, "/");
+            base = top + 2;
+        } else {
+            buf_appendcstr(&buf, "~");
+            base = top + 1;
+        }
+    }
+    if (base < end) {
+        buf_appendmap(&buf, base, end-base);
+    }
+
+    return buf_release(&buf);
+}
+
+EXPORTED json_t* jmap_patchobject_apply(json_t *val, json_t *patch, json_t *invalid)
+{
+    const char *path;
+    json_t *newval, *dst;
+
+    dst = json_deep_copy(val);
+    json_object_foreach(patch, path, newval) {
+        /* Start traversal at root object */
+        json_t *it = dst;
+        const char *base = path, *top;
+        /* Find path in object tree */
+        while ((top = strchr(base, '/'))) {
+            char *name = jmap_pointer_decode(base, top-base);
+            it = json_object_get(it, name);
+            free(name);
+            base = top + 1;
+        }
+        if (!it) {
+            /* No such path in 'val' */
+            if (invalid) {
+                json_array_append_new(invalid, json_string(path));
+            }
+            json_decref(dst);
+            return NULL;
+        }
+        /* Replace value at path */
+        char *name = jmap_pointer_decode(base, strlen(base));
+        if (newval == json_null()) {
+            json_object_del(it, name);
+        } else {
+            json_object_set(it, name, newval);
+        }
+        free(name);
+    }
+
+    return dst;
+}
+
+static void jmap_patchobject_set(json_t *diff, struct buf *path,
+                                 const char *key, json_t *val)
+{
+    char *enckey = jmap_pointer_encode(key);
+    size_t len = buf_len(path);
+    if (len) buf_appendcstr(path, "/");
+    buf_appendcstr(path, enckey);
+    json_object_set(diff, buf_cstring(path), val);
+    buf_truncate(path, len);
+    free(enckey);
+}
+
+static void jmap_patchobject_diff(json_t *diff, struct buf *path,
+                                  json_t *src, json_t *dst)
+{
+    if (!json_is_object(src) || !json_is_object(dst))
+        return;
+
+    const char *key;
+    json_t *val;
+
+    // Add any properties that are set in dst but not in src
+    json_object_foreach(dst, key, val) {
+        if (json_object_get(src, key) == NULL) {
+            jmap_patchobject_set(diff, path, key, val);
+        }
+    }
+
+    // Remove any properties that are set in src but not in dst
+    json_object_foreach(src, key, val) {
+        if (json_object_get(dst, key) == NULL) {
+            jmap_patchobject_set(diff, path, key, json_null());
+        }
+    }
+
+    // Handle properties that exist in both src and dst
+    json_object_foreach(dst, key, val) {
+        json_t *srcval = json_object_get(src, key);
+        if (!srcval) {
+            continue;
+        }
+        if (json_typeof(val) != JSON_OBJECT) {
+            if (!json_equal(val, srcval)) {
+                jmap_patchobject_set(diff, path, key, val);
+            }
+        }
+        else if (json_typeof(srcval) != JSON_OBJECT) {
+            jmap_patchobject_set(diff, path, key, val);
+        }
+        else {
+            char *enckey = jmap_pointer_encode(key);
+            size_t len = buf_len(path);
+            if (len) buf_appendcstr(path, "/");
+            buf_appendcstr(path, enckey);
+            jmap_patchobject_diff(diff, path, srcval, val);
+            buf_truncate(path, len);
+            free(enckey);
+        }
+    }
+}
+
+EXPORTED json_t *jmap_patchobject_create(json_t *src, json_t *dst)
+{
+    json_t *diff = json_object();
+    struct buf buf = BUF_INITIALIZER;
+
+    jmap_patchobject_diff(diff, &buf, src, dst);
+
+    buf_free(&buf);
+    return diff;
+}
+
+EXPORTED void jmap_filterprops(json_t *jobj, hash_table *props)
+{
+    if (!props) return;
+
+    const char *key;
+    json_t *jval;
+    void *tmp;
+    json_object_foreach_safe(jobj, tmp, key, jval) {
+        if (!hash_lookup(key, props)) {
+            json_object_del(jobj, key);
+        }
+    }
+}
+
+static void address_to_smtp(smtp_addr_t *smtpaddr, json_t *addr)
+{
+    smtpaddr->addr = xstrdup(json_string_value(json_object_get(addr, "email")));
+
+    const char *key;
+    json_t *val;
+    struct buf xtext = BUF_INITIALIZER;
+    json_object_foreach(json_object_get(addr, "parameters"), key, val) {
+        /* We never take AUTH at face value */
+        if (!strcasecmp(key, "AUTH")) {
+            continue;
+        }
+        /* We handle FUTURERELEASE ourselves */
+        else if (!strcasecmp(key, "HOLDFOR") || !strcasecmp(key, "HOLDUNTIL")) {
+            continue;
+        }
+        /* Encode xtext value */
+        if (json_is_string(val)) {
+            const char *p;
+            for (p = json_string_value(val); *p; p++) {
+                if (('!' <= *p && *p <= '~') && *p != '=' && *p != '+') {
+                    buf_putc(&xtext, *p);
+                }
+                else buf_printf(&xtext, "+%02X", *p);
+            }
+        }
+        /* Build parameter */
+        smtp_param_t *param = xzmalloc(sizeof(smtp_param_t));
+        param->key = xstrdup(key);
+        param->val = buf_len(&xtext) ? xstrdup(buf_cstring(&xtext)) : NULL;
+        ptrarray_append(&smtpaddr->params, param);
+        buf_reset(&xtext);
+    }
+    buf_free(&xtext);
+}
+
+EXPORTED void jmap_emailsubmission_envelope_to_smtp(smtp_envelope_t *smtpenv,
+                                                    json_t *env)
+{
+    address_to_smtp(&smtpenv->from, json_object_get(env, "mailFrom"));
+    size_t i;
+    json_t *val;
+    json_array_foreach(json_object_get(env, "rcptTo"), i, val) {
+        smtp_addr_t *smtpaddr = xzmalloc(sizeof(smtp_addr_t));
+        address_to_smtp(smtpaddr, val);
+        ptrarray_append(&smtpenv->rcpts, smtpaddr);
+    }
+}
+
+EXPORTED json_t *jmap_fetch_snoozed(const char *mbox, uint32_t uid)
+{
+    /* get the snoozed annotation */
+    const char *annot = IMAP_ANNOT_NS "snoozed";
+    struct buf value = BUF_INITIALIZER;
+    json_t *snooze = NULL;
+    int r;
+
+    r = annotatemore_msg_lookup(mbox, uid, annot, "", &value);
+
+    if (!r) {
+        if (!buf_len(&value)) {
+            /* get the legacy snoozed-until annotation */
+            annot = IMAP_ANNOT_NS "snoozed-until";
+
+            r = annotatemore_msg_lookup(mbox, uid, annot, "", &value);
+            if (!r && buf_len(&value)) {
+                /* build a SnoozeDetails object from the naked "until" value */
+                snooze = json_pack("{s:s}",
+                                   "until", json_string(buf_cstring(&value)));
+            }
+        }
+        else {
+            json_error_t jerr;
+
+            snooze = json_loads(buf_cstring(&value), 0, &jerr);
+        }
+    }
+
+    buf_free(&value);
+
+    return snooze;
+}
+
+EXPORTED int jmap_email_keyword_is_valid(const char *keyword)
+{
+    const char *p;
+
+    if (*keyword == '\0') {
+        return 0;
+    }
+    if (strlen(keyword) > 255) {
+        return 0;
+    }
+    for (p = keyword; *p; p++) {
+        if (*p < 0x21 || *p > 0x7e) {
+            return 0;
+        }
+        switch(*p) {
+            case '(':
+            case ')':
+            case '{':
+            case ']':
+            case '%':
+            case '*':
+            case '"':
+            case '\\':
+                return 0;
+            default:
+                ;
+        }
+    }
+    return 1;
+}
+
+EXPORTED const char *jmap_keyword_to_imap(const char *keyword)
+{
+    if (!strcasecmp(keyword, "$Seen")) {
+        return "\\Seen";
+    }
+    else if (!strcasecmp(keyword, "$Flagged")) {
+        return "\\Flagged";
+    }
+    else if (!strcasecmp(keyword, "$Answered")) {
+        return "\\Answered";
+    }
+    else if (!strcasecmp(keyword, "$Draft")) {
+        return "\\Draft";
+    }
+    else if (jmap_email_keyword_is_valid(keyword)) {
+        return keyword;
+    }
+    return NULL;
+}
+
+HIDDEN void jmap_parser_fini(struct jmap_parser *parser)
+{
+    strarray_fini(&parser->path);
+    json_decref(parser->invalid);
+    buf_free(&parser->buf);
+}
+
+HIDDEN void jmap_parser_push(struct jmap_parser *parser, const char *prop)
+{
+    strarray_push(&parser->path, prop);
+}
+
+HIDDEN void jmap_parser_push_index(struct jmap_parser *parser, const char *prop,
+                                   size_t index, const char *name)
+{
+    /* TODO make this more clever: won't need to printf most of the time */
+    buf_reset(&parser->buf);
+    if (name) buf_printf(&parser->buf, "%s[%zu:%s]", prop, index, name);
+    else buf_printf(&parser->buf, "%s[%zu]", prop, index);
+    strarray_push(&parser->path, buf_cstring(&parser->buf));
+    buf_reset(&parser->buf);
+}
+
+HIDDEN void jmap_parser_push_name(struct jmap_parser *parser,
+                                  const char *prop, const char *name)
+{
+    /* TODO make this more clever: won't need to printf most of the time */
+    buf_reset(&parser->buf);
+    buf_printf(&parser->buf, "%s{%s}", prop, name);
+    strarray_push(&parser->path, buf_cstring(&parser->buf));
+    buf_reset(&parser->buf);
+}
+
+HIDDEN void jmap_parser_pop(struct jmap_parser *parser)
+{
+    free(strarray_pop(&parser->path));
+}
+
+HIDDEN const char* jmap_parser_path(struct jmap_parser *parser, struct buf *buf)
+{
+    int i;
+    buf_reset(buf);
+
+    for (i = 0; i < parser->path.count; i++) {
+        const char *p = strarray_nth(&parser->path, i);
+        if (jmap_pointer_needsencode(p)) {
+            char *tmp = jmap_pointer_encode(p);
+            buf_appendcstr(buf, tmp);
+            free(tmp);
+        } else {
+            buf_appendcstr(buf, p);
+        }
+        if ((i + 1) < parser->path.count) {
+            buf_appendcstr(buf, "/");
+        }
+    }
+
+    return buf_cstring(buf);
+}
+
+HIDDEN void jmap_parser_invalid(struct jmap_parser *parser, const char *prop)
+{
+    if (prop)
+        jmap_parser_push(parser, prop);
+
+    json_array_append_new(parser->invalid,
+            json_string(jmap_parser_path(parser, &parser->buf)));
+
+    if (prop)
+        jmap_parser_pop(parser);
+}
+
+HIDDEN json_t *jmap_server_error(int r)
+{
+    return json_pack("{s:s, s:s}",
+                     "type", "serverError",
+                     "description", error_message(r));
+}
+
+HIDDEN char *jmap_encode_base64_nopad(const char *data, size_t len)
+{
+    if (!len) return NULL;
+
+    /* Encode data */
+    size_t b64len = ((len + 2) / 3) << 2;
+    char *b64 = xzmalloc(b64len + 1);
+    if (sasl_encode64(data, len, b64, b64len + 1, NULL) != SASL_OK) {
+        free(b64);
+        return NULL;
+    }
+    /* Remove padding */
+    char *end = b64 + strlen(b64) - 1;
+    while (*end == '=') {
+        *end = '\0';
+        end--;
+    }
+
+    return b64;
+}
+
+HIDDEN char *jmap_decode_base64_nopad(const char *b64, size_t b64len)
+{
+    /* Pad base64 data. */
+    size_t myb64len = b64len;
+    switch (b64len % 4) {
+        case 3:
+            myb64len += 1;
+            break;
+        case 2:
+            myb64len += 2;
+            break;
+        case 1:
+            return NULL;
+        default:
+            ; // do nothing
+    }
+    char *myb64 = xzmalloc(myb64len+1);
+    memcpy(myb64, b64, b64len);
+    switch (myb64len - b64len) {
+        case 2:
+            myb64[b64len+1] = '=';
+            // fall through
+        case 1:
+            myb64[b64len] = '=';
+            break;
+        default:
+            ; // do nothing
+    }
+    /* Decode data. */
+    size_t datalen = ((4 * myb64len / 3) + 3) & ~3;
+    char *data = xzmalloc(datalen + 1);
+    if (sasl_decode64(myb64, myb64len, data, datalen, NULL) != SASL_OK) {
+        free(data);
+        free(myb64);
+        return NULL;
+    }
+
+    free(myb64);
+    return data;
+}
diff -pruN 3.0.13-5/imap/jmap_util.h 3.2.0-3/imap/jmap_util.h
--- 3.0.13-5/imap/jmap_util.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_util.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,115 @@
+/* jmap_util.h -- Helper routines for JMAP
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#ifndef JMAP_UTIL_H
+#define JMAP_UTIL_H
+
+#include <jansson.h>
+
+#include "hash.h"
+#include "message.h"
+#include "smtpclient.h"
+
+#define JMAP_SUBMISSION_HDR "Content-Description"
+
+#define jmap_wantprop(props, name) \
+    ((props) ? (hash_lookup(name, props) != NULL) : 1)
+
+#define jmap_readprop(root, name,  mandatory, invalid, fmt, dst) \
+    jmap_readprop_full((root), NULL, (name), (mandatory), (invalid), (fmt), (dst))
+
+extern int jmap_readprop_full(json_t *root, const char *prefix, const char *name,
+                              int mandatory, json_t *invalid, const char *fmt,
+                              void *dst);
+
+/* Apply patch to a deep copy of val and return the result.
+ * Return NULL on error. If invalid is a JSON array, then
+ * the erroneous path in patch is appended as JSON string */
+extern json_t* jmap_patchobject_apply(json_t *val, json_t *patch, json_t *invalid);
+
+/* Create a patch-object that transforms src into dst. */
+extern json_t *jmap_patchobject_create(json_t *src, json_t *dst);
+
+/* Return non-zero src and its RFC6901 encoding differ */
+extern int jmap_pointer_needsencode(const char *src);
+
+/* Encode src according to RFC6901 */
+extern char *jmap_pointer_encode(const char *src);
+
+/* Decode src according to RFC6901 */
+extern char *jmap_pointer_decode(const char *src, size_t len);
+
+/* Remove all properties in jobj that have no key in props */
+extern void jmap_filterprops(json_t *jobj, hash_table *props);
+
+extern void jmap_emailsubmission_envelope_to_smtp(smtp_envelope_t *smtpenv,
+                                                  json_t *env);
+
+extern json_t *jmap_fetch_snoozed(const char *mbox, uint32_t uid);
+
+extern int jmap_email_keyword_is_valid(const char *keyword);
+extern const char *jmap_keyword_to_imap(const char *keyword);
+
+/* JMAP request parser */
+struct jmap_parser {
+    struct buf buf;
+    strarray_t path;
+    json_t *invalid;
+};
+
+#define JMAP_PARSER_INITIALIZER { BUF_INITIALIZER, STRARRAY_INITIALIZER, json_array() }
+
+extern void jmap_parser_fini(struct jmap_parser *parser);
+extern void jmap_parser_push(struct jmap_parser *parser, const char *prop);
+extern void jmap_parser_push_index(struct jmap_parser *parser,
+                                   const char *prop, size_t index, const char *name);
+extern void jmap_parser_pop(struct jmap_parser *parser);
+extern const char* jmap_parser_path(struct jmap_parser *parser, struct buf *buf);
+extern void jmap_parser_invalid(struct jmap_parser *parser, const char *prop);
+
+extern json_t *jmap_server_error(int r);
+
+extern char *jmap_encode_base64_nopad(const char *data, size_t len);
+extern char *jmap_decode_base64_nopad(const char *b64, size_t b64len);
+
+#endif /* JMAP_UTIL_H */
diff -pruN 3.0.13-5/imap/jmap_vacation.c 3.2.0-3/imap/jmap_vacation.c
--- 3.0.13-5/imap/jmap_vacation.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/jmap_vacation.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,591 @@
+/* jmap_vacation.c -- Routines for handling JMAP vacation responses
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <config.h>
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#include <ctype.h>
+#include <string.h>
+#include <syslog.h>
+#include <assert.h>
+#include <errno.h>
+
+#include "hash.h"
+#include "http_jmap.h"
+#include "json_support.h"
+#include "map.h"
+#include "sieve/sieve_interface.h"
+#include "sieve/bc_parse.h"
+#include "sync_support.h"
+#include "user.h"
+#include "util.h"
+
+static int jmap_vacation_get(jmap_req_t *req);
+static int jmap_vacation_set(jmap_req_t *req);
+
+jmap_method_t jmap_vacation_methods_standard[] = {
+    {
+        "VacationResponse/get",
+        JMAP_URN_VACATION,
+        &jmap_vacation_get,
+        JMAP_SHARED_CSTATE
+    },
+    {
+        "VacationResponse/set",
+        JMAP_URN_VACATION,
+        &jmap_vacation_set,
+        JMAP_SHARED_CSTATE
+    },
+    { NULL, NULL, NULL, 0}
+};
+
+jmap_method_t jmap_vacation_methods_nonstandard[] = {
+    { NULL, NULL, NULL, 0}
+};
+
+static int sieve_vacation_enabled = 0;
+
+HIDDEN void jmap_vacation_init(jmap_settings_t *settings)
+{
+    if (!config_getswitch(IMAPOPT_JMAP_VACATION)) return;
+
+#ifdef USE_SIEVE
+    unsigned long config_ext = config_getbitfield(IMAPOPT_SIEVE_EXTENSIONS);
+    unsigned long required =
+        IMAP_ENUM_SIEVE_EXTENSIONS_VACATION   |
+        IMAP_ENUM_SIEVE_EXTENSIONS_RELATIONAL |
+        IMAP_ENUM_SIEVE_EXTENSIONS_DATE;
+
+    sieve_vacation_enabled = ((config_ext & required) == required);
+#endif /* USE_SIEVE */
+
+    if (!sieve_vacation_enabled) return;
+
+    jmap_method_t *mp;
+    for (mp = jmap_vacation_methods_standard; mp->name; mp++) {
+        hash_insert(mp->name, mp, &settings->methods);
+    }
+
+    json_object_set_new(settings->server_capabilities,
+            JMAP_URN_VACATION, json_object());
+
+    if (config_getswitch(IMAPOPT_JMAP_NONSTANDARD_EXTENSIONS)) {
+        for (mp = jmap_vacation_methods_nonstandard; mp->name; mp++) {
+            hash_insert(mp->name, mp, &settings->methods);
+        }
+    }
+
+}
+
+HIDDEN void jmap_vacation_capabilities(json_t *account_capabilities)
+{
+    if (!sieve_vacation_enabled) return;
+
+    json_object_set_new(account_capabilities, JMAP_URN_VACATION, json_object());
+}
+
+/* VacationResponse/get method */
+static const jmap_property_t vacation_props[] = {
+    {
+        "id",
+        NULL,
+        JMAP_PROP_SERVER_SET | JMAP_PROP_IMMUTABLE | JMAP_PROP_ALWAYS_GET
+    },
+    {
+        "isEnabled",
+        NULL,
+        0
+    },
+    {
+        "fromDate",
+        NULL,
+        0
+    },
+    {
+        "toDate",
+        NULL,
+        0
+    },
+    {
+        "subject",
+        NULL,
+        0
+    },
+    {
+        "textBody",
+        NULL,
+        0
+    },
+    {
+        "htmlBody",
+        NULL,
+        0
+    },
+
+    { NULL, NULL, 0 }
+};
+
+#define SCRIPT_NAME      "jmap_vacation"
+#define SCRIPT_SUFFIX    ".script"
+#define BYTECODE_SUFFIX  ".bc"
+#define DEFAULTBC_NAME   "defaultbc"
+
+#define STATUS_ACTIVE    (1<<0)
+#define STATUS_CUSTOM    (1<<1)
+#define STATUS_ENABLE    (1<<2)
+
+#define SCRIPT_HEADER    "/* Generated by Cyrus JMAP - DO NOT EDIT\r\n\r\n"
+
+#define DEFAULT_MESSAGE  "I'm away at the moment." \
+    "  I'll read your message and get back to you as soon as I can."
+
+#define NO_INCLUDE_ERROR "Can not enable the vacation response" \
+    " because the active Sieve script does not" \
+    " properly include the 'jmap_vacation' script."
+
+static char *vacation_state(const char *userid)
+{
+    const char *sieve_dir = user_sieve_path(userid);
+    char *bcname = strconcat(sieve_dir, "/" SCRIPT_NAME BYTECODE_SUFFIX, NULL);
+    struct buf buf = BUF_INITIALIZER;
+    struct stat sbuf;
+    time_t state = 0;
+
+    if (!stat(bcname, &sbuf)) state = sbuf.st_mtime;
+    free(bcname);
+
+    buf_printf(&buf, "%ld", state);
+
+    return buf_release(&buf);
+}
+
+static json_t *vacation_read(const char *userid, unsigned *status)
+{
+    const char *sieve_dir = user_sieve_path(userid);
+    char *scriptname = strconcat(sieve_dir, "/" SCRIPT_NAME SCRIPT_SUFFIX, NULL);
+    json_t *vacation = NULL;
+    int fd;
+
+    /* Parse JMAP from vacation script */
+    if ((fd = open(scriptname, O_RDONLY)) != -1) {
+        const char *base = NULL, *json;
+        size_t len = 0;
+
+        map_refresh(fd, 1, &base, &len, MAP_UNKNOWN_LEN, scriptname, NULL);
+        json = strstr(base, SCRIPT_HEADER);
+        if (json) {
+            json_error_t jerr;
+
+            json += strlen(SCRIPT_HEADER);
+            vacation = json_loadb(json, len - (json - base),
+                                  JSON_DISABLE_EOF_CHECK, &jerr);
+        }
+        map_free(&base, &len);
+        close(fd);
+    }
+
+    free(scriptname);
+
+    if (vacation) {
+        int isEnabled =
+            json_boolean_value(json_object_get(vacation, "isEnabled"));
+        int isActive = 0;
+
+#ifdef USE_SIEVE
+        /* Check if vacation script is really active */
+        char *defaultbc = strconcat(sieve_dir, "/" DEFAULTBC_NAME, NULL);
+        char *activebc =  sieve_getdefaultbcfname(defaultbc);
+
+        if (activebc) {
+            const char *filename = activebc + strlen(sieve_dir) + 1;
+
+            if (!strcmp(filename, SCRIPT_NAME BYTECODE_SUFFIX)) {
+                /* Vacation script itself is active */
+                isActive = 1;
+            }
+            else if ((fd = open(activebc, O_RDONLY)) != -1) {
+                /* Parse active bytecode to see if vacation script is included */
+                bytecode_input_t *bc = NULL;
+                const char *base = NULL;
+                size_t len = 0;
+                int i, version, requires;
+
+                if (status) *status |= STATUS_CUSTOM;
+
+                map_refresh(fd, 1, &base, &len, MAP_UNKNOWN_LEN, activebc, NULL);
+                bc = (bytecode_input_t *) base;
+
+                i = bc_header_parse(bc, &version, &requires);
+                while (i > 0 && i < (int) len) {
+                    commandlist_t cmd;
+
+                    i = bc_action_parse(bc, i, version, &cmd);
+                    if (cmd.type == B_INCLUDE &&
+                        cmd.u.inc.location == B_PERSONAL &&
+                        !strcmp(cmd.u.inc.script, SCRIPT_NAME)) {
+                        /* Found it! */
+                        isActive = 1;
+                        break;
+                    }
+                    else if (cmd.type == B_IF) {
+                        /* Skip over test */
+                        i = cmd.u.i.testend;
+                    }
+                }
+
+                map_free(&base, &len);
+                close(fd);
+            }
+        }
+
+        free(activebc);
+        free(defaultbc);
+#endif /* USE_SIEVE */
+
+        isEnabled = isActive && isEnabled;
+        json_object_set_new(vacation, "isEnabled", json_boolean(isEnabled));
+
+        if (status && isActive) *status |= STATUS_ACTIVE;
+    }
+    else {
+        /* Build empty response */
+        vacation = json_pack("{ s:s s:b s:n s:n s:n s:s s:n }",
+                             "id", "singleton", "isEnabled", 0,
+                             "fromDate", "toDate", "subject",
+                             "textBody", DEFAULT_MESSAGE, "htmlBody");
+    }
+
+    return vacation;
+}
+
+static void vacation_get(const char *userid, struct jmap_get *get)
+{
+    /* Read script */
+    json_t *vacation = vacation_read(userid, NULL);
+
+    /* Strip unwanted properties */
+    if (!jmap_wantprop(get->props, "isEnabled"))
+        json_object_del(vacation, "isEnabled");
+    if (!jmap_wantprop(get->props, "fromDate"))
+        json_object_del(vacation, "fromDate");
+    if (!jmap_wantprop(get->props, "toDate"))
+        json_object_del(vacation, "toDate");
+    if (!jmap_wantprop(get->props, "subject"))
+        json_object_del(vacation, "subject");
+    if (!jmap_wantprop(get->props, "textBody"))
+        json_object_del(vacation, "textBody");
+    if (!jmap_wantprop(get->props, "htmlBody"))
+        json_object_del(vacation, "htmlBody");
+
+    /* Add object to list */
+    json_array_append_new(get->list, vacation);
+}
+
+static int jmap_vacation_get(jmap_req_t *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_get get;
+    json_t *err = NULL;
+
+    /* Parse request */
+    jmap_get_parse(req, &parser, vacation_props, /*allow_null_ids*/1,
+                   NULL, NULL, &get, &err);
+    if (err) {
+        jmap_error(req, err);
+        goto done;
+    }
+
+    /* Does the client request specific responses? */
+    if (JNOTNULL(get.ids)) {
+        json_t *jval;
+        size_t i;
+
+        json_array_foreach(get.ids, i, jval) {
+            const char *id = json_string_value(jval);
+
+            if (!strcmp(id, "singleton"))
+                vacation_get(req->accountid, &get);
+            else
+                json_array_append(get.not_found, jval);
+        }
+    }
+    else vacation_get(req->accountid, &get);
+
+    /* Build response */
+    get.state = vacation_state(req->accountid);
+    jmap_ok(req, jmap_get_reply(&get));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_get_fini(&get);
+
+    return 0;
+}
+
+static void vacation_update(const char *userid, const char *id,
+                            json_t *patch, struct jmap_set *set)
+{
+    /* Parse and validate properties. */
+    unsigned status = 0;
+    json_t *vacation = vacation_read(userid, &status);
+    json_t *prop, *jerr, *invalid = json_pack("[]");
+    int r;
+
+    prop = json_object_get(patch, "isEnabled");
+    if (!json_is_boolean(prop))
+        json_array_append_new(invalid, json_string("isEnabled"));
+    else if (json_is_true(prop) &&
+             !json_equal(prop, json_object_get(vacation, "isEnabled"))) {
+        /* isEnabled changing from false to true */
+        status |= STATUS_ENABLE;
+    }
+
+    prop = json_object_get(patch, "fromDate");
+    if (JNOTNULL(prop) && !json_is_utcdate(prop))
+        json_array_append_new(invalid, json_string("fromDate"));
+
+    prop = json_object_get(patch, "toDate");
+    if (JNOTNULL(prop) && !json_is_utcdate(prop))
+        json_array_append_new(invalid, json_string("toDate"));
+
+    prop = json_object_get(patch, "subject");
+    if (JNOTNULL(prop) && !json_is_string(prop))
+        json_array_append_new(invalid, json_string("subject"));
+
+    prop = json_object_get(patch, "textBody");
+    if (JNOTNULL(prop) && !json_is_string(prop))
+        json_array_append_new(invalid, json_string("textBody"));
+
+    prop = json_object_get(patch, "htmlBody");
+    if (JNOTNULL(prop) && !json_is_string(prop))
+        json_array_append_new(invalid, json_string("htmlBody"));
+
+    /* Report any property errors and bail out. */
+    if (json_array_size(invalid)) {
+        jerr = json_pack("{s:s, s:o}",
+                         "type", "invalidProperties", "properties", invalid);
+        json_object_set_new(set->not_updated, id, jerr);
+        json_decref(vacation);
+        return;
+    }
+    json_decref(invalid);
+
+    if (status == (STATUS_ENABLE | STATUS_CUSTOM)) {
+        /* Custom script with no include -- fail */
+        jerr = json_pack("{s:s, s:s}",
+                         "type", "forbidden", "description", NO_INCLUDE_ERROR);
+        json_object_set_new(set->not_updated, id, jerr);
+        json_decref(vacation);
+        return;
+    }
+
+    /* Update VacationResponse object */
+
+    json_t *new_vacation = jmap_patchobject_apply(vacation, patch, NULL);
+    json_decref(vacation);
+    vacation = new_vacation;
+
+    /* Dump VacationResponse JMAP object in a comment */
+    size_t size = json_dumpb(vacation, NULL, 0, JSON_COMPACT);
+    struct buf data = BUF_INITIALIZER;
+
+    buf_setcstr(&data, SCRIPT_HEADER);
+    buf_ensure(&data, size);
+    json_dumpb(vacation,
+               (char *) buf_base(&data) + buf_len(&data), size, JSON_COMPACT);
+    buf_truncate(&data, buf_len(&data) + size);
+    buf_appendcstr(&data, "\r\n\r\n*/\r\n\r\n");
+
+    /* Create actual sieve rule */
+    int isEnabled = json_boolean_value(json_object_get(vacation, "isEnabled"));
+    const char *fromDate =
+        json_string_value(json_object_get(vacation, "fromDate"));
+    const char *toDate =
+        json_string_value(json_object_get(vacation, "toDate"));
+    const char *subject =
+        json_string_value(json_object_get(vacation, "subject"));
+    const char *textBody =
+        json_string_value(json_object_get(vacation, "textBody"));
+    const char *htmlBody =
+        json_string_value(json_object_get(vacation, "htmlBody"));
+
+    /* Add required extensions */
+    buf_printf(&data, "require [ \"vacation\"%s ];\r\n\r\n",
+               (fromDate || toDate) ? ", \"date\", \"relational\"" : "");
+
+    /* Add isEnabled and date tests */
+    buf_printf(&data, "if allof (%s", isEnabled ? "true" : "false");
+    if (fromDate) {
+        buf_printf(&data, ",\r\n%10scurrentdate :zone \"+0000\""
+                   " :value \"ge\" \"iso8601\" \"%s\"", "", fromDate);
+    }
+    if (toDate) {
+        buf_printf(&data, ",\r\n%10scurrentdate :zone \"+0000\""
+                   " :value \"lt\" \"iso8601\" \"%s\"", "", toDate);
+    }
+    buf_appendcstr(&data, ")\r\n{\r\n");
+
+    /* Add vacation action */
+    buf_appendcstr(&data, "  vacation");
+    if (subject) buf_printf(&data, " :subject \"%s\"", subject);
+    /* XXX  Need to add :addresses */
+    /* XXX  Should we add :fcc ? */
+
+    if (htmlBody) {
+        const char *boundary = makeuuid();
+        char *text = NULL;
+
+        if (!textBody) textBody = text = charset_extract_plain(htmlBody);
+
+        buf_appendcstr(&data, " :mime text:\r\n");
+        buf_printf(&data,
+                   "Content-Type: multipart/alternative; boundary=%s\r\n"
+                   "\r\n--%s\r\n", boundary, boundary);
+        buf_appendcstr(&data,
+                       "Content-Type: text/plain; charset=utf-8\r\n\r\n");
+        buf_printf(&data, "%s\r\n\r\n--%s\r\n", textBody, boundary);
+        buf_appendcstr(&data,
+                       "Content-Type: text/html; charset=utf-8\r\n\r\n");
+        buf_printf(&data, "%s\r\n\r\n--%s--\r\n", htmlBody, boundary);
+        free(text);
+    }
+    else {
+        buf_printf(&data, " text:\r\n%s",
+                   textBody ? textBody : DEFAULT_MESSAGE);
+    }
+    buf_appendcstr(&data, "\r\n.\r\n;\r\n}\r\n");
+
+    /* Store script */
+    r = sync_sieve_upload(userid, SCRIPT_NAME SCRIPT_SUFFIX,
+                          time(NULL), buf_base(&data), buf_len(&data));
+    buf_free(&data);
+    json_decref(vacation);
+
+    const char *err = NULL;
+    if (r) err = "Failed to update vacation response";
+    else if (status == STATUS_ENABLE) {
+        /* Activate vacation script */
+        r = sync_sieve_activate(userid, SCRIPT_NAME BYTECODE_SUFFIX);
+        if (r) err = "Failed to enable vacation response";
+    }
+
+    if (r) {
+        /* Failure to upload or activate */
+        jerr = json_pack("{s:s s:s}", "type", "serverError", "description", err);
+        json_object_set_new(set->not_updated, id, jerr);
+        r = 0;
+    }
+    else {
+        /* Report vacation as updated. */
+        json_object_set_new(set->updated, id, json_null());
+    }
+}
+
+static int jmap_vacation_set(struct jmap_req *req)
+{
+    struct jmap_parser parser = JMAP_PARSER_INITIALIZER;
+    struct jmap_set set;
+    json_t *jerr = NULL;
+    int r = 0;
+
+    /* Parse arguments */
+    jmap_set_parse(req, &parser, vacation_props, NULL, NULL, &set, &jerr);
+    if (jerr) {
+        jmap_error(req, jerr);
+        goto done;
+    }
+
+    set.old_state = vacation_state(req->accountid);
+
+    if (set.if_in_state && strcmp(set.if_in_state, set.old_state)) {
+        jmap_error(req, json_pack("{s:s}", "type", "stateMismatch"));
+        goto done;
+    }
+
+
+    /* create */
+    const char *key;
+    json_t *arg;
+    json_object_foreach(set.create, key, arg) {
+        jerr= json_pack("{s:s}", "type", "singleton");
+        json_object_set_new(set.not_created, key, jerr);
+    }
+
+
+    /* update */
+    const char *uid;
+    json_object_foreach(set.update, uid, arg) {
+
+        /* Validate uid */
+        if (!uid) {
+            continue;
+        }
+        if (strcmp(uid, "singleton")) {
+            jerr = json_pack("{s:s}", "type", "notFound");
+            json_object_set_new(set.not_updated, uid, jerr);
+            continue;
+        }
+
+        vacation_update(req->accountid, uid, arg, &set);
+    }
+
+
+    /* destroy */
+    size_t index;
+    json_t *juid;
+
+    json_array_foreach(set.destroy, index, juid) {
+        json_t *err= json_pack("{s:s}", "type", "singleton");
+        json_object_set_new(set.not_destroyed, json_string_value(juid), err);
+    }
+
+    set.new_state = vacation_state(req->accountid);
+    jmap_ok(req, jmap_set_reply(&set));
+
+done:
+    jmap_parser_fini(&parser);
+    jmap_set_fini(&set);
+    return r;
+}
diff -pruN 3.0.13-5/imap/json_support.c 3.2.0-3/imap/json_support.c
--- 3.0.13-5/imap/json_support.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/json_support.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,98 @@
+/* json_support.c -- Helper functions for jansson and JSON
+ *
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+
+#include <config.h>
+
+#include <string.h>
+#include <time.h>
+
+#include "json_support.h"
+
+int json_is_utcdate(json_t *json)
+{
+    const char *s = NULL;
+    struct tm date;
+
+    if (!json_is_string(json)) return 0;
+
+    s = strptime(json_string_value(json), "%Y-%m-%dT%H:%M:%SZ", &date);
+    return (s && *s == '\0');
+}
+
+int json_array_find(json_t *array, const char *needle)
+{
+    size_t i;
+    json_t *val;
+
+    json_array_foreach(array, i, val) {
+        if (!strcmp(needle, json_string_value(val))) return i;
+    }
+
+    return -1;
+}
+
+#ifdef NEED_JANSSON_JSON_DUMPB
+/* https://jansson.readthedocs.io/en/2.11/apiref.html#c.json_dumpb */
+EXPORTED size_t json_dumpb(const json_t *json,
+                           char *buffer, size_t size, size_t flags)
+{
+    char *s;
+    size_t slen;
+
+    s = json_dumps(json, flags);
+    if (!s) return 0;
+    slen = strlen(s);
+
+    if (slen > size) {
+        free(s);
+        return slen;
+    }
+
+    /* n.b. json_dumpb() does NOT nul-terminate the buffer! */
+    memcpy(buffer, s, slen);
+    free(s);
+
+    return slen;
+}
+#endif
diff -pruN 3.0.13-5/imap/json_support.h 3.2.0-3/imap/json_support.h
--- 3.0.13-5/imap/json_support.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/imap/json_support.h	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-/* json_support.h -- Helper functions for jansson
+/* json_support.h -- Helper functions for jansson and JSON
  *
- * Copyright (c) 1994-2015 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -46,9 +46,12 @@
 #define JSON_SUPPORT_H
 
 #include <config.h>
-
 #include <jansson.h>
 
+#include "util.h"
+
+#define JNOTNULL(item)          ((item) ? (json_is_null(item) == 0) : 0)
+
 /* jansson replacement functions for those missing in older versions */
 
 #ifndef json_boolean
@@ -69,6 +72,15 @@
           _iter_ = json_object_iter_next(obj, _iter_))
 #endif /* json_object_foreach */
 
+#ifndef json_object_foreach_safe
+#define json_object_foreach_safe(object, n, key, value)     \
+    for(key = json_object_iter_key(json_object_iter(object)), \
+            n = json_object_iter_next(object, json_object_key_to_iter(key)); \
+        key && (value = json_object_iter_value(json_object_key_to_iter(key))); \
+        key = json_object_iter_key(n), \
+n = json_object_iter_next(object, json_object_key_to_iter(key)))
+#endif /* json_object_foreach_safe */
+
 #ifndef json_array_foreach
 #define json_array_foreach(array, index, value)                 \
     for (index = 0;                                             \
@@ -77,4 +89,14 @@
          index++)
 #endif /* json_array_foreach */
 
+EXPORTED int json_is_utcdate(json_t *json);
+
+EXPORTED int json_array_find(json_t *array, const char *needle);
+
+#ifdef NEED_JANSSON_JSON_DUMPB
+/* https://jansson.readthedocs.io/en/2.11/apiref.html#c.json_dumpb */
+EXPORTED size_t json_dumpb(const json_t *json,
+                           char *buffer, size_t size, size_t flags);
+#endif
+
 #endif /* JSON_SUPPORT_H */
diff -pruN 3.0.13-5/imap/lmtpd.c 3.2.0-3/imap/lmtpd.c
--- 3.0.13-5/imap/lmtpd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtpd.c	2020-05-04 03:28:02.000000000 +0000
@@ -52,6 +52,7 @@
 #include <ctype.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <sys/wait.h>
@@ -72,11 +73,9 @@
 #endif
 #include "backend.h"
 #ifdef WITH_DAV
-#include "caldav_db.h"
 #include "carddav_db.h"
 #endif
 #include "duplicate.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "idle.h"
 #include "mailbox.h"
@@ -87,10 +86,11 @@
 #include "message.h"
 #include "mupdate.h"
 #include "notify.h"
+#include "prometheus.h"
 #include "prot.h"
 #include "proxy.h"
-#include "statuscache.h"
 #include "telemetry.h"
+#include "times.h"
 #include "tls.h"
 #include "userdeny.h"
 #include "util.h"
@@ -101,6 +101,7 @@
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
+#include "imap/lmtp_err.h"
 #include "imap/lmtpstats.h"
 
 #include "lmtpd.h"
@@ -109,8 +110,6 @@
 #include "lmtp_sieve.h"
 #endif
 
-#include "sync_log.h"
-
 #include "iostat.h"
 
 /* forward declarations */
@@ -148,6 +147,7 @@ static int dupelim = 1;         /* elimi
                                    same message-id */
 static int singleinstance = 1;  /* attempt single instance store */
 static int isproxy = 0;
+static strarray_t *excluded_specialuse = NULL;
 
 static struct stagemsg *stage = NULL;
 
@@ -196,15 +196,13 @@ int service_init(int argc __attribute__(
 
     singleinstance = config_getswitch(IMAPOPT_SINGLEINSTANCESTORE);
 
+    excluded_specialuse =
+        strarray_split(config_getstring(IMAPOPT_LMTP_EXCLUDE_SPECIALUSE),
+                       NULL, STRARRAY_TRIM);
+
     global_sasl_init(1, 1, mysasl_cb);
 
-    /* so we can do mboxlist operations */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* so we can do quota operations */
-    quotadb_init(0);
-    quotadb_open(NULL);
+    initialize_lmtp_error_table();
 
     if (config_mupdate_server &&
         (config_mupdate_config == IMAP_ENUM_MUPDATE_CONFIG_STANDARD) &&
@@ -226,45 +224,27 @@ int service_init(int argc __attribute__(
             /* initialize duplicate delivery database */
             if (duplicate_init(NULL) != 0) {
                 fatal("lmtpd: unable to init duplicate delivery database",
-                      EC_SOFTWARE);
+                      EX_SOFTWARE);
             }
         }
 
-        /* open the user deny db */
-        denydb_init(0);
-        denydb_open(0);
-
-#ifdef WITH_DAV
-        /* so we can do DAV operations */
-        caldav_init();
-        carddav_init();
-#endif
-
-        /* Initialize the annotatemore db (for sieve on shared mailboxes) */
-        annotate_init(NULL, NULL);
-        annotatemore_open();
-
-        /* setup for statuscache invalidation */
-        statuscache_open();
-
         /* setup for sending IMAP IDLE notifications */
         idle_init();
-
-        /* setup for mailbox event notifications */
-        mboxevent_init();
     }
 
     /* Set namespace */
     if ((r = mboxname_init_namespace(&lmtpd_namespace, 0)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     mboxevent_setnamespace(&lmtpd_namespace);
 
     /* create connection to the SNMP listener, if available. */
     snmp_connect(); /* ignore return code */
-    snmp_set_str(SERVER_NAME_VERSION, cyrus_version());
+    snmp_set_str(SERVER_NAME_VERSION, CYRUS_VERSION);
+
+    prometheus_increment(CYRUS_LMTP_READY_LISTENERS);
 
     return 0;
 }
@@ -280,14 +260,14 @@ int service_main(int argc, char **argv,
     struct io_count *io_count_start = NULL;
     struct io_count *io_count_stop = NULL;
 
+    prometheus_decrement(CYRUS_LMTP_READY_LISTENERS);
+
     if (config_iolog) {
         io_count_start = xmalloc (sizeof (struct io_count));
         io_count_stop = xmalloc (sizeof (struct io_count));
         read_io_count(io_count_start);
     }
 
-    sync_log_init();
-
     deliver_in = prot_new(0, 0);
     deliver_out = prot_new(1, 1);
     prot_setflushonread(deliver_in, deliver_out);
@@ -304,11 +284,17 @@ int service_main(int argc, char **argv,
         }
     }
 
+    prometheus_increment(CYRUS_LMTP_CONNECTIONS_TOTAL);
+    prometheus_increment(CYRUS_LMTP_ACTIVE_CONNECTIONS);
+
     snmp_increment(TOTAL_CONNECTIONS, 1);
     snmp_increment(ACTIVE_CONNECTIONS, 1);
 
     lmtpmode(&mylmtp, deliver_in, deliver_out, 0);
 
+    prometheus_decrement(CYRUS_LMTP_ACTIVE_CONNECTIONS);
+    snmp_increment(ACTIVE_CONNECTIONS, -1);
+
     /* free session state */
     if (deliver_in) prot_free(deliver_in);
     if (deliver_out) prot_free(deliver_out);
@@ -331,6 +317,8 @@ int service_main(int argc, char **argv,
         free (io_count_stop);
     }
 
+    prometheus_increment(CYRUS_LMTP_READY_LISTENERS);
+
     return 0;
 }
 
@@ -343,8 +331,8 @@ void service_abort(int error)
 static void usage(void)
 {
     fprintf(stderr, "421-4.3.0 usage: lmtpd [-C <alt_config>] [-a]\r\n");
-    fprintf(stderr, "421 4.3.0 %s\n", cyrus_version());
-    exit(EC_USAGE);
+    fprintf(stderr, "421 4.3.0 %s\n", CYRUS_VERSION);
+    exit(EX_USAGE);
 }
 
 struct fuzz_rock {
@@ -473,6 +461,38 @@ static int mlookup(const char *name, mbe
     return r;
 }
 
+static int delivery_enabled_for_mailbox(const char *mailboxname)
+{
+    struct buf attrib = BUF_INITIALIZER;
+    char *userid = NULL;
+    strarray_t *specialuse = NULL;
+    int r = 0;
+
+    if (!mboxname_isusermailbox(mailboxname, 0)) return 0;
+
+    /* test if the mailbox has a special-use attribute in the exclude list */
+    if (strarray_size(excluded_specialuse) > 0) {
+        userid = mboxname_to_userid(mailboxname);
+
+        r = annotatemore_lookup(mailboxname, "/specialuse", userid, &attrib);
+        if (r) {
+            /* XXX  allow delivery or no? */
+            goto done; /* XXX - return -1?  Failure? */
+        }
+
+        specialuse = strarray_split(buf_cstring(&attrib), NULL, 0);
+
+        if (strarray_intersect_case(specialuse, excluded_specialuse))
+            r = IMAP_MAILBOX_SPECIALUSE;
+    }
+
+done:
+    strarray_free(specialuse);
+    buf_free(&attrib);
+    free(userid);
+    return r;
+}
+
 /* places msg in mailbox mailboxname.
  * if you wish to use single instance store, pass stage as non-NULL
  * if you want to deliver message regardless of duplicates, pass id as NULL
@@ -484,7 +504,8 @@ int deliver_mailbox(FILE *f,
                     struct message_content *content,
                     struct stagemsg *stage,
                     unsigned size,
-                    const strarray_t *flags,
+                    struct imap4flags *imap4flags,
+                    struct entryattlist *annotations,
                     const char *authuser,
                     const struct auth_state *authstate,
                     char *id,
@@ -492,6 +513,7 @@ int deliver_mailbox(FILE *f,
                     char *notifyheader,
                     const char *mailboxname,
                     char *date,
+                    time_t savedate,
                     int quotaoverride,
                     int acloverride)
 {
@@ -502,6 +524,14 @@ int deliver_mailbox(FILE *f,
     char *uuid = NULL;
     duplicate_key_t dkey = DUPLICATE_INITIALIZER;
     quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_INITIALIZER;
+    time_t internaldate = 0;
+
+    if (!savedate) {
+        /* make sure delivery is enabled for this mailbox */
+        r = delivery_enabled_for_mailbox(mailboxname);
+        if (r) return r;
+    }
+    /* Otherwise, this is snooze via Sieve */
 
     /* open the mailbox separately so we can hold it open until
      * after the duplicate elimination is done */
@@ -546,13 +576,32 @@ int deliver_mailbox(FILE *f,
     if (!r && !content->body) {
         /* parse the message body if we haven't already,
            and keep the file mmap'ed */
-        r = message_parse_file(f, &content->base, &content->len, &content->body);
+        r = message_parse_file(f, &content->base, &content->len,
+                               &content->body, NULL);
+        /* If the body contains received_date, we should always use that. */
+        if (content->body->received_date)
+            time_from_rfc5322(content->body->received_date, &internaldate,
+                              DATETIME_FULL);
     }
 
     if (!r) {
-        r = append_fromstage(&as, &content->body, stage, 0,
-                             flags, !singleinstance,
-                             /*annotations*/NULL);
+        const strarray_t *flags = NULL;
+
+        if (imap4flags) {
+            flags = imap4flags->flags;
+
+            if (imap4flags->authstate != authstate) {
+                /* Flags get set as owner of Sieve script */
+                int owner_rights =
+                    cyrus_acl_myrights(imap4flags->authstate, mailbox->acl);
+
+                as.myrights |= (owner_rights & ~ACL_POST);
+            }
+        }
+
+        r = append_fromstage_full(&as, &content->body, stage,
+                                  internaldate, savedate, /*createdmodseq*/0,
+                                  flags, !singleinstance, annotations);
 
         if (r) {
             append_abort(&as);
@@ -634,7 +683,7 @@ static void deliver_remote(message_data_
         remote = proxy_findserver(d->server, &lmtp_protocol, "",
                                   &backend_cached, NULL, NULL, NULL);
         if (remote) {
-            int txn_timeout = config_getint(IMAPOPT_LMTPTXN_TIMEOUT);
+            int txn_timeout = config_getduration(IMAPOPT_LMTPTXN_TIMEOUT, 's');
             if (txn_timeout)
                 prot_settimeout(remote->in, txn_timeout);
             lmtp_runtxn(remote, lt);
@@ -664,7 +713,7 @@ static void deliver_remote(message_data_
                 break;
             case nosieve:
                 /* this is the only delivery we're attempting for this rcpt */
-                msg_setrcpt_status(msgdata, j, lt->rcpt[i].r);
+                msg_setrcpt_status(msgdata, j, lt->rcpt[i].r, lt->rcpt[i].resp);
                 status[j] = done;
                 break;
             case done:
@@ -681,7 +730,7 @@ static void deliver_remote(message_data_
     }
 }
 
-EXPORTED int deliver_local(deliver_data_t *mydata, const strarray_t *flags,
+EXPORTED int deliver_local(deliver_data_t *mydata, struct imap4flags *imap4flags,
                            const mbname_t *origmbname)
 {
     message_data_t *md = mydata->m;
@@ -691,30 +740,33 @@ EXPORTED int deliver_local(deliver_data_
     /* case 1: shared mailbox request */
     if (!mbname_userid(origmbname)) {
         return deliver_mailbox(md->f, mydata->content, mydata->stage,
-                               md->size, flags,
+                               md->size, imap4flags, NULL,
                                mydata->authuser, mydata->authstate, md->id,
                                NULL, mydata->notifyheader,
-                               mbname_intname(origmbname), md->date, quotaoverride, 0);
+                               mbname_intname(origmbname), md->date,
+                               0 /*savedate*/, quotaoverride, 0);
     }
 
     mbname_t *mbname = mbname_dup(origmbname);
 
     if (strarray_size(mbname_boxes(mbname))) {
         ret = deliver_mailbox(md->f, mydata->content, mydata->stage,
-                              md->size, flags,
+                              md->size, imap4flags, NULL,
                               mydata->authuser, mydata->authstate, md->id,
                               mbname_userid(mbname), mydata->notifyheader,
-                              mbname_intname(mbname), md->date, quotaoverride, 0);
+                              mbname_intname(mbname), md->date,
+                              0 /*savedate*/, quotaoverride, 0);
 
         if (ret == IMAP_MAILBOX_NONEXISTENT &&
             config_getswitch(IMAPOPT_LMTP_FUZZY_MAILBOX_MATCH)) {
             if (fuzzy_match(mbname)) {
                 /* try delivery to a fuzzy matched mailbox */
                 ret = deliver_mailbox(md->f, mydata->content, mydata->stage,
-                                      md->size, flags,
+                                      md->size, imap4flags, NULL,
                                       mydata->authuser, mydata->authstate, md->id,
                                       mbname_userid(mbname), mydata->notifyheader,
-                                      mbname_intname(mbname), md->date, quotaoverride, 0);
+                                      mbname_intname(mbname), md->date,
+                                      0 /*savedate*/, quotaoverride, 0);
             }
         }
     }
@@ -725,10 +777,11 @@ EXPORTED int deliver_local(deliver_data_
         struct auth_state *authstate = auth_newstate(mbname_userid(mbname));
 
         ret = deliver_mailbox(md->f, mydata->content, mydata->stage,
-                              md->size, flags,
+                              md->size, imap4flags, NULL,
                               mbname_userid(mbname), authstate, md->id,
                               mbname_userid(mbname), mydata->notifyheader,
-                              mbname_intname(mbname), md->date, quotaoverride, 1);
+                              mbname_intname(mbname), md->date,
+                              0 /*savedate*/, quotaoverride, 1);
 
         if (authstate) auth_freestate(authstate);
     }
@@ -788,8 +841,15 @@ int deliver(message_data_t *msgdata, cha
             /* local mailbox */
             mydata.cur_rcpt = n;
 #ifdef USE_SIEVE
-            sieve_interp_t *interp = setup_sieve();
+            struct sieve_interp_ctx ctx = { mbname_userid(mbname), NULL };
+            sieve_interp_t *interp = setup_sieve(&ctx);
+
+            sieve_srs_init();
             r = run_sieve(mbname, interp, &mydata);
+#ifdef WITH_DAV
+            if (ctx.carddavdb) carddav_close(ctx.carddavdb);
+#endif
+            sieve_srs_free();
             sieve_interp_free(&interp);
             /* if there was no sieve script, or an error during execution,
                r is non-zero and we'll do normal delivery */
@@ -806,7 +866,7 @@ int deliver(message_data_t *msgdata, cha
 
         setstatus:
 
-        msg_setrcpt_status(msgdata, n, r);
+        msg_setrcpt_status(msgdata, n, r, NULL);
 
         mboxlist_entry_free(&mbentry);
     }
@@ -885,6 +945,7 @@ EXPORTED void fatal(const char* s, int c
 
     if(recurse_code) {
         /* We were called recursively. Just give up */
+        prometheus_decrement(CYRUS_LMTP_ACTIVE_CONNECTIONS);
         snmp_increment(ACTIVE_CONNECTIONS, -1);
         exit(recurse_code);
     }
@@ -923,30 +984,12 @@ void shut_down(int code)
     }
     if (backend_cached) free(backend_cached);
 
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
+    if (excluded_specialuse) strarray_free(excluded_specialuse);
 
     if (!isproxy) {
         if (dupelim)
             duplicate_done();
 
-        denydb_close();
-        denydb_done();
-
-#ifdef WITH_DAV
-        carddav_done();
-        caldav_done();
-#endif
-
-        annotatemore_close();
-        annotate_done();
-
-        statuscache_close();
-        statuscache_done();
-
         idle_done();
     }
 
@@ -957,10 +1000,17 @@ void shut_down(int code)
         prot_flush(deliver_out);
 
         /* one less active connection */
+        prometheus_decrement(CYRUS_LMTP_ACTIVE_CONNECTIONS);
         snmp_increment(ACTIVE_CONNECTIONS, -1);
     }
+    else {
+        /* one less ready listener */
+
+        prometheus_decrement(CYRUS_LMTP_READY_LISTENERS);
+    }
 
-    sync_log_done();
+    prometheus_increment(code ? CYRUS_LMTP_SHUTDOWN_TOTAL_STATUS_ERROR
+                              : CYRUS_LMTP_SHUTDOWN_TOTAL_STATUS_OK);
 
     cyrus_done();
 
diff -pruN 3.0.13-5/imap/lmtpd.h 3.2.0-3/imap/lmtpd.h
--- 3.0.13-5/imap/lmtpd.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtpd.h	2020-04-24 02:03:00.000000000 +0000
@@ -67,16 +67,22 @@ typedef struct deliver_data {
     const struct auth_state *authstate;
 } deliver_data_t;
 
+struct imap4flags {
+    const strarray_t *flags;
+    const struct auth_state *authstate;
+};
+
 /* forward declarations */
 extern int deliver_local(deliver_data_t *mydata,
-                         const strarray_t *flags,
+                         struct imap4flags *imap4flags,
                          const mbname_t *mbname);
 
 extern int deliver_mailbox(FILE *f,
                            struct message_content *content,
                            struct stagemsg *stage,
                            unsigned size,
-                           const strarray_t *flags,
+                           struct imap4flags *imap4flags,
+                           struct entryattlist *annotations,
                            const char *authuser,
                            const struct auth_state *authstate,
                            char *id,
@@ -84,6 +90,7 @@ extern int deliver_mailbox(FILE *f,
                            char *notifyheader,
                            const char *mailboxname,
                            char *date,
+                           time_t savedate,
                            int quotaoverride,
                            int acloverride);
 
diff -pruN 3.0.13-5/imap/lmtpengine.c 3.2.0-3/imap/lmtpengine.c
--- 3.0.13-5/imap/lmtpengine.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtpengine.c	2020-05-04 03:28:02.000000000 +0000
@@ -51,6 +51,7 @@
 #include <string.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <errno.h>
 #include <sys/types.h>
@@ -71,13 +72,14 @@
 #include "prot.h"
 #include "times.h"
 #include "global.h"
-#include "exitcodes.h"
+#include "prometheus.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "version.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
+#include "imap/lmtp_err.h"
 #include "imap/lmtpstats.h"
 #include "imap/mupdate_err.h"
 
@@ -92,6 +94,7 @@ struct address_data {
     mbname_t *mbname;
     int ignorequota;
     int status;
+    strarray_t *resp;
 };
 
 struct clientdata {
@@ -117,7 +120,7 @@ struct clientdata {
     int starttls_done;
 };
 
-/* defined in lmtpd.c or lmtpproxyd.c */
+/* defined in lmtpd.c */
 extern int deliver_logfd;
 
 extern int saslserver(sasl_conn_t *conn, const char *mech,
@@ -126,12 +129,7 @@ extern int saslserver(sasl_conn_t *conn,
                       struct protstream *pin, struct protstream *pout,
                       int *sasl_result, char **success_data);
 
-static struct {
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 
 #ifdef USING_SNMPGEN
@@ -151,15 +149,22 @@ static int roundToK(int x)
 #define roundToK(x)
 #endif /* USING_SNMPGEN */
 
-static void send_lmtp_error(struct protstream *pout, int r)
+static void send_lmtp_error(struct protstream *pout, int r, strarray_t *resp)
 {
+    int code;
+
+    if (resp) {
+        int i;
+
+        for (i = 0; i < strarray_size(resp); i++) {
+            prot_puts(pout, strarray_nth(resp, i));
+        }
+        return;
+    }
+
     switch (r) {
     case 0:
-        prot_printf(pout, "250 2.1.5 Ok SESSIONID=<%s>\r\n", session_id());
-        break;
-
-    case IMAP_IOERROR:
-        prot_printf(pout, "451 4.3.0 System I/O error\r\n");
+        code = LMTP_OK;
         break;
 
     case IMAP_SERVER_UNAVAILABLE:
@@ -167,103 +172,73 @@ static void send_lmtp_error(struct prots
     case MUPDATE_NOAUTH:
     case MUPDATE_TIMEOUT:
     case MUPDATE_PROTOCOL_ERROR:
-        prot_printf(pout, "451 4.4.3 Remote server unavailable\r\n");
+        code = LMTP_SERVER_FAILURE;
         break;
 
     case IMAP_NOSPACE:
-        prot_printf(pout, "451 4.3.1 cannot create file: out of space\r\n");
-        break;
-
-    case IMAP_AGAIN:
-        prot_printf(pout, "451 4.3.0 transient system error\r\n");
+        code = LMTP_SERVER_FULL;
         break;
 
     case IMAP_PERMISSION_DENIED:
         if (LMTP_LONG_ERROR_MSGS) {
-            prot_printf(pout,
-"550-You do not have permission to post a message to this mailbox.\r\n"
-"550-Please contact the owner of this mailbox in order to submit\r\n"
-"550-your message, or %s if you believe you\r\n"
-"550-received this message in error.\r\n"
-"550 5.7.1 Permission denied\r\n",
+            prot_printf(pout, error_message(LMTP_NOT_AUTHORIZED_LONG),
                         config_getstring(IMAPOPT_POSTMASTER));
-        } else {
-            prot_printf(pout, "550 5.7.1 Permission denied\r\n");
         }
+        code = LMTP_NOT_AUTHORIZED;
         break;
 
     case IMAP_QUOTA_EXCEEDED:
         if(config_getswitch(IMAPOPT_LMTP_OVER_QUOTA_PERM_FAILURE)) {
             /* Not Default - Perm Failure */
-            prot_printf(pout, "552 5.2.2 Over quota SESSIONID=<%s>\r\n", session_id());
+            code = LMTP_MAILBOX_FULL_PERM;
         } else {
             /* Default - Temp Failure */
-            prot_printf(pout, "452 4.2.2 Over quota SESSIONID=<%s>\r\n", session_id());
+            code = LMTP_MAILBOX_FULL;
         }
         break;
 
     case IMAP_MAILBOX_BADFORMAT:
     case IMAP_MAILBOX_NOTSUPPORTED:
-        prot_printf(pout, "451 4.2.0 Mailbox has an invalid format\r\n");
+        code = LMTP_MAILBOX_ERROR;
         break;
 
     case IMAP_MAILBOX_MOVED:
-        prot_printf(pout, "451 4.2.1 Mailbox Moved\r\n");
-        break;
-
     case IMAP_MAILBOX_RESERVED:
-        prot_printf(pout, "451 4.2.1 Mailbox Reserved\r\n");
-        break;
-
     case IMAP_MAILBOX_DISABLED:
-        prot_printf(pout,
-                    "450 4.2.1 Mailbox disabled, not accepting messages\r\n");
+        code = LMTP_MAILBOX_DISABLED;
         break;
 
     case IMAP_MESSAGE_CONTAINSNULL:
-        prot_printf(pout, "554 5.6.0 Message contains NUL characters\r\n");
-        break;
-
     case IMAP_MESSAGE_CONTAINSNL:
-        prot_printf(pout, "554 5.6.0 Message contains bare newlines\r\n");
-        break;
-
     case IMAP_MESSAGE_CONTAINS8BIT:
-        prot_printf(pout, "554 5.6.0 Message contains non-ASCII characters in headers\r\n");
-        break;
-
     case IMAP_MESSAGE_BADHEADER:
-        prot_printf(pout, "554 5.6.0 Message contains invalid header\r\n");
-        break;
-
     case IMAP_MESSAGE_NOBLANKLINE:
-        prot_printf(pout,
-                    "554 5.6.0 Message has no header/body separator\r\n");
+        code = LMTP_MESSAGE_INVALID;
         break;
 
     case IMAP_MAILBOX_NONEXISTENT:
         /* XXX Might have been moved to other server */
         if (LMTP_LONG_ERROR_MSGS) {
-            prot_printf(pout,
-"550-Mailbox unknown.  Either there is no mailbox associated with this\r\n"
-"550-name or you do not have authorization to see it.\r\n"
-"550 5.1.1 User unknown\r\n");
-        } else {
-            prot_printf(pout, "550 5.1.1 User unknown\r\n");
+            prot_puts(pout, error_message(LMTP_USER_UNKNOWN_LONG));
         }
+        code = LMTP_USER_UNKNOWN;
         break;
 
     case IMAP_PROTOCOL_BAD_PARAMETERS:
-        prot_printf(pout, "501 5.5.4 Syntax error in parameters\r\n");
+        code = LMTP_PROTOCOL_ERROR;
         break;
 
+    case IMAP_IOERROR:
+    case IMAP_AGAIN:
     case MUPDATE_BADPARAM:
     default:
         /* Some error we're not expecting. */
-        prot_printf(pout, "451 4.3.0 Unexpected internal error: %s\r\n",
-                    error_message(r));
+        code = LMTP_SYSTEM_ERROR;
         break;
     }
+
+    prot_printf(pout, error_message(code), error_message(r), session_id());
+    prot_puts(pout, "\r\n");
 }
 
 /* ----- this section defines functions on message_data_t.
@@ -316,6 +291,7 @@ static void msg_free(message_data_t *m)
     if (m->rcpt) {
         for (i = 0; i < m->rcpt_num; i++) {
             mbname_free(&m->rcpt[i]->mbname);
+            strarray_free(m->rcpt[i]->resp);
             free(m->rcpt[i]);
         }
         free(m->rcpt);
@@ -371,10 +347,13 @@ int msg_getrcpt_ignorequota(message_data
 
 /* set a recipient status; 'r' should be an IMAP error code that will be
    translated into an LMTP status code */
-void msg_setrcpt_status(message_data_t *m, int rcpt_num, int r)
+void msg_setrcpt_status(message_data_t *m, int rcpt_num, int r, strarray_t *resp)
 {
     assert(0 <= rcpt_num && rcpt_num < m->rcpt_num);
-    m->rcpt[rcpt_num]->status = r;
+    if (!m->rcpt[rcpt_num]->status) {
+        m->rcpt[rcpt_num]->status = r;
+        m->rcpt[rcpt_num]->resp = resp;
+    }
 }
 
 void *msg_getrock(message_data_t *m)
@@ -504,7 +483,7 @@ static char *parseaddr(char *s)
                 if (*p & 128 && !lmtp_strict_rfc2821) {
                     /* this prevents us from becoming a backscatter
                        source if our MTA allows 8bit in local-part
-                       of adresses. */
+                       of addresses. */
                     *p = 'X';
                 }
                 if (*p <= ' ' || (*p & 128) ||
@@ -609,7 +588,7 @@ static int savemsg(struct clientdata *cd
     int nrcpts = m->rcpt_num;
     time_t now = time(NULL);
     static unsigned msgid_count = 0;
-    char datestr[RFC822_DATETIME_MAX+1], tls_info[250] = "";
+    char datestr[RFC5322_DATETIME_MAX+1], tls_info[250] = "";
     const char *skipheaders[] = {
         "Return-Path",  /* need to remove (we add our own) */
         NULL
@@ -653,10 +632,10 @@ static int savemsg(struct clientdata *cd
     }
 
     /* add a received header */
-    time_to_rfc822(now, datestr, sizeof(datestr));
+    time_to_rfc5322(now, datestr, sizeof(datestr));
     addlen = 8 + strlen(cd->lhlo_param) + strlen(cd->clienthost);
     if (m->authuser) addlen += 28 + strlen(m->authuser) + 5; /* +5 for ssf */
-    addlen += 25 + strlen(config_servername) + strlen(cyrus_version());
+    addlen += 25 + strlen(config_servername) + strlen(CYRUS_VERSION);
 #ifdef HAVE_SSL
     if (cd->tls_conn) {
         addlen += 3 + tls_get_info(cd->tls_conn, tls_info, sizeof(tls_info));
@@ -680,7 +659,7 @@ static int savemsg(struct clientdata *cd
     /* We are always atleast "with LMTPA" -- no unauth delivery */
     p += sprintf(p, " by %s", config_servername);
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-        p += sprintf(p, " (Cyrus %s)", cyrus_version());
+        p += sprintf(p, " (Cyrus %s)", CYRUS_VERSION);
     }
     p += sprintf(p, " with LMTP%s%s",
                  cd->starttls_done ? "S" : "",
@@ -695,12 +674,14 @@ static int savemsg(struct clientdata *cd
     fold[nfold++] = p;
     p += sprintf(p, " %s", datestr);
 
-    fprintf(f, "Received: ");
+    struct buf rbuf = BUF_INITIALIZER;
+    buf_setcstr(&rbuf, "Received: ");
     for (i = 0, p = addbody; i < nfold; p = fold[i], i++) {
-        fprintf(f, "%.*s\r\n\t", (int) (fold[i] - p), p);
+        buf_printf(&rbuf, "%.*s\r\n\t", (int) (fold[i] - p), p);
     }
-    fprintf(f, "%s\r\n", p);
-    spool_cache_header(xstrdup("Received"), addbody, m->hdrcache);
+    buf_printf(&rbuf, "%s\r\n", p);
+    fputs(buf_cstring(&rbuf), f);
+    spool_append_header_raw(xstrdup("Received"), addbody, buf_release(&rbuf), m->hdrcache);
 
     char *sid = xstrdup(session_id());
     fprintf(f, "X-Cyrus-Session-Id: %s\r\n", sid);
@@ -760,6 +741,9 @@ static int savemsg(struct clientdata *cd
         clean_retpath(m->return_path);
     }
 
+    /* get offset of message body */
+    m->body_offset = ftell(f);
+
     r |= spool_copy_msg(cd->pin, f);
     if (r) {
         fclose(f);
@@ -768,7 +752,7 @@ static int savemsg(struct clientdata *cd
             func->removespool(m);
         }
         while (nrcpts--) {
-            send_lmtp_error(cd->pout, r);
+            send_lmtp_error(cd->pout, r, NULL);
         }
         return r;
     }
@@ -877,7 +861,7 @@ static int process_recipient(char *addr,
         return IMAP_MAILBOX_NONEXISTENT;
     }
 
-    address_data_t *ret = (address_data_t *) xmalloc(sizeof(address_data_t));
+    address_data_t *ret = (address_data_t *) xzmalloc(sizeof(address_data_t));
     ret->mbname = mbname;
     ret->ignorequota = ignorequota;
     msg->rcpt[msg->rcpt_num] = ret;
@@ -919,19 +903,10 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("lmtp", config_servername,
-                         NULL, NULL, NULL,
-                         NULL, 0, conn);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.ipremoteport)
-       ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                          saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-       ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                          saslprops.iplocalport);
+    ret = sasl_server_new("lmtp", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                          NULL, 0, conn);
     if(ret != SASL_OK) return ret;
 
     secprops = mysasl_secprops(SASL_SEC_NOANONYMOUS);
@@ -941,14 +916,9 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if(saslprops.ssf) {
-       ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     }
     if(ret != SASL_OK) return ret;
-
-    if(saslprops.authid) {
-       ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-       if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -968,9 +938,6 @@ void lmtpmode(struct lmtp_func *func,
 
     const char *localip, *remoteip;
 
-    sasl_ssf_t ssf;
-    char *auth_id;
-
     sasl_security_properties_t *secprops = NULL;
 
     /* setup the clientdata structure */
@@ -993,14 +960,7 @@ void lmtpmode(struct lmtp_func *func,
     msg_new(&msg, func->namespace);
 
     /* don't leak old connections */
-    if(saslprops.iplocalport) {
-        free(saslprops.iplocalport);
-        saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-        free(saslprops.ipremoteport);
-        saslprops.ipremoteport = NULL;
-    }
+    saslprops_reset(&saslprops);
 
     /* determine who we're talking to */
     cd.clienthost = get_clienthost(fd, &localip, &remoteip);
@@ -1008,6 +968,10 @@ void lmtpmode(struct lmtp_func *func,
         /* we're not connected to a internet socket! */
         func->preauth = 1;
     }
+    else if (localip && remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, remoteip);
+        buf_setcstr(&saslprops.iplocalport, localip);
+    }
 
     syslog(LOG_DEBUG, "connection from %s%s",
            cd.clienthost,
@@ -1015,10 +979,12 @@ void lmtpmode(struct lmtp_func *func,
 
     /* Setup SASL to go.  We need to do this *after* we decide if
      *  we are preauthed or not. */
-    if (sasl_server_new("lmtp", config_servername, NULL, NULL,
-                        NULL, (func->preauth ? localauth_override_cb : NULL),
+    if (sasl_server_new("lmtp", config_servername, NULL,
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                        (func->preauth ? localauth_override_cb : NULL),
                         0, &cd.conn) != SASL_OK) {
-        fatal("SASL failed initializing: sasl_server_new()", EC_TEMPFAIL);
+        fatal("SASL failed initializing: sasl_server_new()", EX_TEMPFAIL);
     }
 
     /* set my allowable security properties */
@@ -1027,25 +993,22 @@ void lmtpmode(struct lmtp_func *func,
     sasl_setprop(cd.conn, SASL_SEC_PROPS, secprops);
 
     if (func->preauth) {
+        const char *auth_id = "postman";
+
         cd.authenticated = EXTERNAL_AUTHED;     /* we'll allow commands,
                                                    but we still accept
                                                    the AUTH command */
-        ssf = 2;
-        auth_id = "postman";
-        if (sasl_setprop(cd.conn, SASL_SSF_EXTERNAL, &ssf) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
-        if (sasl_setprop(cd.conn, SASL_AUTH_EXTERNAL, auth_id) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
+        saslprops.ssf = 2;
+        buf_setcstr(&saslprops.authid, auth_id);
+        if (saslprops_set_tls(&saslprops, cd.conn) != SASL_OK)
+            fatal("saslprops_set_tls() failed: preauth",EX_TEMPFAIL);
 
         deliver_logfd = telemetry_log(auth_id, pin, pout, 0);
-    } else {
-        if(localip) sasl_setprop(cd.conn, SASL_IPLOCALPORT,  &localip );
-        if(remoteip) sasl_setprop(cd.conn, SASL_IPREMOTEPORT, &remoteip);
     }
 
     prot_printf(pout, "220 %s", config_servername);
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-        prot_printf(pout, " Cyrus LMTP %s", cyrus_version());
+        prot_printf(pout, " Cyrus LMTP %s", CYRUS_VERSION);
     }
     prot_printf(pout, " server ready\r\n");
 
@@ -1117,6 +1080,7 @@ void lmtpmode(struct lmtp_func *func,
 
               if (r) {
                   const char *errorstring = NULL;
+                  const char *userid = "-notset-";
 
                   switch (r) {
                   case IMAP_SASL_CANCEL:
@@ -1137,9 +1101,13 @@ void lmtpmode(struct lmtp_func *func,
                           continue;
                       }
                       else {
-                          syslog(LOG_ERR, "badlogin: %s %s %s",
-                                 cd.clienthost, mech, sasl_errdetail(cd.conn));
+                          if (r != SASL_NOUSER)
+                              sasl_getprop(cd.conn, SASL_USERNAME, (const void **) &userid);
+
+                          syslog(LOG_ERR, "badlogin: %s %s (%s) [%s]",
+                                 cd.clienthost, mech, userid, sasl_errdetail(cd.conn));
 
+                          prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_NO);
                           snmp_increment_args(AUTHENTICATION_NO, 1,
                                               VARIABLE_AUTH, hash_simple(mech),
                                               VARIABLE_LISTEND);
@@ -1174,6 +1142,8 @@ void lmtpmode(struct lmtp_func *func,
               deliver_logfd = telemetry_log(user, pin, pout, 0);
 
               /* authenticated successfully! */
+
+              prometheus_increment(CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_YES);
               snmp_increment_args(AUTHENTICATION_YES,1,
                                   VARIABLE_AUTH, hash_simple(mech),
                                   VARIABLE_LISTEND);
@@ -1215,6 +1185,10 @@ void lmtpmode(struct lmtp_func *func,
                     continue;
                 }
 
+                prometheus_increment(CYRUS_LMTP_RECEIVED_MESSAGES_TOTAL);
+                prometheus_apply_delta(CYRUS_LMTP_RECEIVED_BYTES_TOTAL, msg->size);
+                prometheus_apply_delta(CYRUS_LMTP_RECEIVED_RECIPIENTS_TOTAL, msg->rcpt_num);
+
                 snmp_increment(mtaReceivedMessages, 1);
                 snmp_increment(mtaReceivedVolume, roundToK(msg->size));
                 snmp_increment(mtaReceivedRecipients, msg->rcpt_num);
@@ -1223,9 +1197,13 @@ void lmtpmode(struct lmtp_func *func,
                 func->deliver(msg, msg->authuser, msg->authstate, msg->ns);
                 for (j = 0; j < msg->rcpt_num; j++) {
                     if (!msg->rcpt[j]->status) delivered++;
-                    send_lmtp_error(pout, msg->rcpt[j]->status);
+                    send_lmtp_error(pout, msg->rcpt[j]->status,
+                                    msg->rcpt[j]->resp);
                 }
 
+                prometheus_increment(CYRUS_LMTP_TRANSMITTED_MESSAGES_TOTAL);
+                prometheus_apply_delta(CYRUS_LMTP_TRANSMITTED_BYTES_TOTAL, delivered * msg->size);
+
                 snmp_increment(mtaTransmittedMessages, delivered);
                 snmp_increment(mtaTransmittedVolume,
                                roundToK(delivered * msg->size));
@@ -1296,7 +1274,7 @@ void lmtpmode(struct lmtp_func *func,
                 }
                 tmp = buf+10+strlen(msg->return_path);
 
-                /* is any other whitespace allow seperating? */
+                /* is any other whitespace allow separating? */
                 while (*tmp == ' ') {
                     tmp++;
                     switch (*tmp) {
@@ -1448,7 +1426,7 @@ void lmtpmode(struct lmtp_func *func,
                                       msg);
                 if (rcpt) free(rcpt); /* malloc'd in parseaddr() */
                 if (r) {
-                    send_lmtp_error(pout, r);
+                    send_lmtp_error(pout, r, NULL);
                     continue;
                 }
                 msg->rcpt_num++;
@@ -1473,17 +1451,10 @@ void lmtpmode(struct lmtp_func *func,
 #ifdef HAVE_SSL
             if (!strcasecmp(buf, "starttls") && tls_enabled() &&
                 !func->preauth) { /* don't need TLS for preauth'd connect */
-                int *layerp;
-                sasl_ssf_t ssf;
-                char *auth_id;
 
                 /* XXX  discard any input pipelined after STARTTLS */
                 prot_flush(pin);
 
-                /* SASL and openssl have different ideas
-                   about whether ssf is signed */
-                layerp = (int *) &ssf;
-
                 if (cd.starttls_done == 1) {
                     prot_printf(pout, "454 4.3.3 %s\r\n",
                                 "Already successfully executed STARTTLS");
@@ -1515,8 +1486,7 @@ void lmtpmode(struct lmtp_func *func,
                 r=tls_start_servertls(0, /* read */
                                       1, /* write */
                                       360, /* 6 minutes */
-                                      layerp,
-                                      &auth_id,
+                                      &saslprops,
                                       &(cd.tls_conn));
 
                 /* if error */
@@ -1527,22 +1497,11 @@ void lmtpmode(struct lmtp_func *func,
                 }
 
                 /* tell SASL about the negotiated layer */
-                r=sasl_setprop(cd.conn, SASL_SSF_EXTERNAL, &ssf);
-                if (r != SASL_OK)
-                    fatal("sasl_setprop(SASL_SSF_EXTERNAL) failed: STARTTLS",
-                          EC_TEMPFAIL);
-                saslprops.ssf = ssf;
-
-                r=sasl_setprop(cd.conn, SASL_AUTH_EXTERNAL, auth_id);
-                if (r != SASL_OK)
-                    fatal("sasl_setprop(SASL_AUTH_EXTERNAL) failed: STARTTLS",
-                          EC_TEMPFAIL);
-                if(saslprops.authid) {
-                    free(saslprops.authid);
-                    saslprops.authid = NULL;
+                r = saslprops_set_tls(&saslprops, cd.conn);
+                if (r != SASL_OK) {
+                    fatal("saslprops_set_tls() failed: STARTTLS", EX_TEMPFAIL);
                 }
-                if(auth_id) {
-                    saslprops.authid = xstrdup(auth_id);
+                if (buf_len(&saslprops.authid)) {
                     cd.authenticated = TLSCERT_AUTHED;
                 }
 
@@ -1580,6 +1539,7 @@ void lmtpmode(struct lmtp_func *func,
 
     /* security */
     if (cd.conn) sasl_dispose(&cd.conn);
+    saslprops_reset(&saslprops);
 
     cd.starttls_done = 0;
 #ifdef HAVE_SSL
@@ -1682,15 +1642,23 @@ static int ask_code(const char *s)
    if a read failed, '*code == 400', a temporary failure.
 
    returns an IMAP error code. */
-static int getlastresp(char *buf, int len, int *code, struct protstream *pin)
+static int getlastresp(char *buf, int len, int *code, struct protstream *pin,
+                       strarray_t **sa)
 {
+    *code = 0;
+
     do {
         if (!prot_fgets(buf, len, pin)) {
             *code = 400;
             return IMAP_SERVER_UNAVAILABLE;
         }
+
+        if (!*code) *code = ask_code(buf);
+        if (sa && (*code == 550)) {
+            if (!*sa) *sa = strarray_new();
+            strarray_append(*sa, buf);
+        }
     } while (ISCONT(buf));
-    *code = ask_code(buf);
 
     return 0;
 }
@@ -1767,7 +1735,7 @@ int lmtp_runtxn(struct backend *conn, st
 
     /* rset */
     prot_printf(conn->out, "RSET\r\n");
-    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in);
+    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in, NULL);
     if (!ISGOOD(code)) {
         goto failall;
     }
@@ -1790,7 +1758,7 @@ int lmtp_runtxn(struct backend *conn, st
                     txn->auth && txn->auth[0] ? txn->auth : "<>");
     }
     prot_printf(conn->out, "\r\n");
-    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in);
+    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in, NULL);
     if (!ISGOOD(code)) {
         goto failall;
     }
@@ -1803,7 +1771,7 @@ int lmtp_runtxn(struct backend *conn, st
             prot_printf(conn->out, " IGNOREQUOTA");
         }
         prot_printf(conn->out, "\r\n");
-        r = getlastresp(buf, sizeof(buf)-1, &code, conn->in);
+        r = getlastresp(buf, sizeof(buf)-1, &code, conn->in, NULL);
         if (r) {
             goto failall;
         }
@@ -1816,7 +1784,7 @@ int lmtp_runtxn(struct backend *conn, st
         } else if (PERMFAIL(code)) {
             if(txn->tempfail_unknown_mailbox &&
                txn->rcpt[j].r == IMAP_MAILBOX_NONEXISTENT) {
-                /* If there is a nonexistant error, we have been told
+                /* If there is a nonexistent error, we have been told
                  * to mask it (e.g. proxy got out-of-date mupdate data) */
                 txn->rcpt[j].result = RCPT_TEMPFAIL;
                 txn->rcpt[j].r = IMAP_AGAIN;
@@ -1836,7 +1804,7 @@ int lmtp_runtxn(struct backend *conn, st
 
     /* data */
     prot_printf(conn->out, "DATA\r\n");
-    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in);
+    r = getlastresp(buf, sizeof(buf)-1, &code, conn->in, NULL);
     if (r) {
         goto failall;
     }
@@ -1854,7 +1822,8 @@ int lmtp_runtxn(struct backend *conn, st
     for (j = 0; j < txn->rcpt_num; j++) {
         if (txn->rcpt[j].result == RCPT_GOOD) {
             /* expecting a status code for this recipient */
-            r = getlastresp(buf, sizeof(buf)-1, &code, conn->in);
+            r = getlastresp(buf, sizeof(buf)-1, &code, conn->in,
+                            &txn->rcpt[j].resp);
             if (r) {
                 /* technically, some recipients might've succeeded here,
                    but we'll be paranoid */
diff -pruN 3.0.13-5/imap/lmtpengine.h 3.2.0-3/imap/lmtpengine.h
--- 3.0.13-5/imap/lmtpengine.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtpengine.h	2020-04-24 02:03:00.000000000 +0000
@@ -56,6 +56,7 @@ typedef struct address_data address_data
 struct message_data {
     struct protstream *data;    /* message in temp file */
     FILE *f;                    /* FILE * corresponding */
+    long body_offset;           /* offset of msg body in file */
 
     char *id;                   /* message id */
     int size;                   /* size of message */
@@ -96,7 +97,7 @@ int msg_getrcpt_ignorequota(message_data
 
 /* set a recipient status; 'r' should be an IMAP error code that will be
    translated into an LMTP status code */
-void msg_setrcpt_status(message_data_t *m, int rcpt_num, int r);
+void msg_setrcpt_status(message_data_t *m, int rcpt_num, int r, strarray_t *resp);
 
 void *msg_getrock(message_data_t *m);
 void msg_setrock(message_data_t *m, void *rock);
@@ -163,10 +164,11 @@ struct lmtp_txn {
         } result;
         int r;                  /* if non-zero,
                                    a more descriptive error code */
+        strarray_t *resp;
     } rcpt[1];
 };
 
-#define LMTP_TXN_ALLOC(n) (xmalloc(sizeof(struct lmtp_txn) + \
+#define LMTP_TXN_ALLOC(n) (xzmalloc(sizeof(struct lmtp_txn) + \
                                    ((n) * (sizeof(struct lmtp_rcpt)))))
 
 int lmtp_runtxn(struct backend *conn, struct lmtp_txn *txn);
diff -pruN 3.0.13-5/imap/lmtp_err.et 3.2.0-3/imap/lmtp_err.et
--- 3.0.13-5/imap/lmtp_err.et	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/lmtp_err.et	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,92 @@
+# lmtp_err.et -- Error codes for the Cyrus LMTP server
+#
+# Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in
+#    the documentation and/or other materials provided with the
+#    distribution.
+#
+# 3. The name "Carnegie Mellon University" must not be used to
+#    endorse or promote products derived from this software without
+#    prior written permission. For permission or any legal
+#    details, please contact
+#      Carnegie Mellon University
+#      Center for Technology Transfer and Enterprise Creation
+#      4615 Forbes Avenue
+#      Suite 302
+#      Pittsburgh, PA  15213
+#      (412) 268-7393, fax: (412) 268-7395
+#      innovation@andrew.cmu.edu
+#
+# 4. Redistributions of any form whatsoever must retain the following
+#    acknowledgment:
+#    "This product includes software developed by Computing Services
+#     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+#
+# CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+# AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+# FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+# OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+#
+
+error_table lmtp
+
+# Enhanced Mail System Status Codes (RFC 3463)
+
+ec LMTP_OK,
+   "250 2.1.5 Ok SESSIONID=<%2$s>"
+
+ec LMTP_MAILBOX_ERROR,
+   "451 4.2.0 %s"
+
+ec LMTP_MAILBOX_DISABLED,
+   "451 4.2.1 %s"
+
+ec LMTP_SYSTEM_ERROR,
+   "451 4.3.0 %s"
+
+ec LMTP_SERVER_FULL,
+   "451 4.3.1 %s"
+
+ec LMTP_SERVER_FAILURE,
+   "451 4.4.3 %s"
+
+ec LMTP_MAILBOX_FULL,
+   "452 4.2.2 %s SESSIONID=<%s>"
+
+ec LMTP_PROTOCOL_ERROR,
+   "501 5.5.4 %s"
+
+ec LMTP_USER_UNKNOWN_LONG,
+   "550-Mailbox unknown.  Either there is no mailbox associated with this\r\n550-name or you do not have authorization to see it.\r\n"
+
+ec LMTP_USER_UNKNOWN,
+   "550 5.1.1 User unknown"
+
+ec LMTP_NOT_AUTHORIZED_LONG,
+   "550-You do not have permission to post a message to this mailbox.\r\n550-Please contact the owner of this mailbox in order to submit\r\n550-your message, or %s if you believe you\r\n550-received this message in error.\r\n"
+
+ec LMTP_NOT_AUTHORIZED,
+   "550 5.7.1 %s"
+
+ec LMTP_MESSAGE_REJECTED,
+   "550 5.7.1 Message refused"
+
+ec LMTP_MAILBOX_FULL_PERM,
+   "552 5.2.2 %s SESSIONID=<%s>"
+
+ec LMTP_MESSAGE_INVALID,
+   "554 5.6.0 %s"
+
+end
diff -pruN 3.0.13-5/imap/lmtp_sieve.c 3.2.0-3/imap/lmtp_sieve.c
--- 3.0.13-5/imap/lmtp_sieve.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtp_sieve.c	2020-05-04 03:28:02.000000000 +0000
@@ -49,6 +49,7 @@
 #include <pwd.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <time.h>
 #include <sys/types.h>
@@ -59,16 +60,21 @@
 #include "assert.h"
 #include "auth.h"
 #include "duplicate.h"
-#include "exitcodes.h"
 #include "global.h"
+#include "imapurl.h"
 #include "lmtpd.h"
 #include "lmtp_sieve.h"
 #include "lmtpengine.h"
+#include "map.h"
 #include "notify.h"
+#include "prometheus.h"
 #include "prot.h"
 #include "times.h"
 #include "sieve/sieve_interface.h"
 #include "smtpclient.h"
+#include "strhash.h"
+#include "tok.h"
+#include "user.h"
 #include "util.h"
 #include "version.h"
 #include "xmalloc.h"
@@ -77,6 +83,7 @@
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
+#include "imap/lmtp_err.h"
 #include "imap/lmtpstats.h"
 
 static int sieve_usehomedir = 0;
@@ -87,10 +94,14 @@ typedef struct script_data {
     const mbname_t *mbname;
     const struct auth_state *authstate;
     const struct namespace *ns;
+
+    int edited_header;
 } script_data_t;
 
 static int autosieve_createfolder(const char *userid, const struct auth_state *auth_state,
                                   const char *internalname, int createsievefolder);
+static deliver_data_t *setup_special_delivery(deliver_data_t *mydata);
+static void cleanup_special_delivery(deliver_data_t *mydata);
 
 static char *make_sieve_db(const char *user)
 {
@@ -119,20 +130,139 @@ static int getheader(void *v, const char
     }
 }
 
+/* adds the header "head" with body "body" to msg */
+static int addheader(void *sc, void *mc,
+                     const char *head, const char *body, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = ((deliver_data_t *) mc)->m;
+
+    if (head == NULL || body == NULL) return SIEVE_FAIL;
+
+    if (index < 0)
+        spool_append_header(xstrdup(head), xstrdup(body), m->hdrcache);
+    else
+        spool_prepend_header(xstrdup(head), xstrdup(body), m->hdrcache);
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+/* deletes (instance "index" of) the header "head" from msg */
+static int deleteheader(void *sc, void *mc, const char *head, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = ((deliver_data_t *) mc)->m;
+
+    if (head == NULL) return SIEVE_FAIL;
+
+    if (!index) spool_remove_header(xstrdup(head), m->hdrcache);
+    else spool_remove_header_instance(xstrdup(head), index, m->hdrcache);
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+static char *mboxname_from_externalUTF8(const char *extname,
+                                        const struct namespace *ns,
+                                        const char *userid)
+{
+    char *intname, *freeme = NULL;
+
+    if (config_getswitch(IMAPOPT_SIEVE_UTF8FILEINTO)) {
+        freeme = xmalloc(5 * strlen(extname) + 1);
+        UTF8_to_mUTF7(freeme, extname);
+        extname = freeme;
+    }
+
+    intname = mboxname_from_external(extname, ns, userid);
+    free(freeme);
+
+    return intname;
+}
+
 static int getmailboxexists(void *sc, const char *extname)
 {
     script_data_t *sd = (script_data_t *)sc;
-    char *intname = mboxname_from_external(extname, sd->ns, mbname_userid(sd->mbname));
+    char *intname = mboxname_from_externalUTF8(extname, sd->ns,
+                                               mbname_userid(sd->mbname));
     int r = mboxlist_lookup(intname, NULL, NULL);
     free(intname);
     return r ? 0 : 1; /* 0 => exists */
 }
 
+static int getmailboxidexists(void *sc, const char *extname)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    const char *userid = mbname_userid(sd->mbname);
+    char *intname = mboxlist_find_uniqueid(extname, userid, sd->authstate);
+    int exists = 0;
+
+    if (intname &&
+        !mboxname_isdeletedmailbox(intname, NULL) &&
+        !mboxname_isnonimapmailbox(intname, 0)) {
+        exists = 1;
+    }
+
+    free(intname);
+    return exists;
+}
+
+static int getspecialuseexists(void *sc, const char *extname, strarray_t *uses)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    const char *userid = mbname_userid(sd->mbname);
+    int i, r = 1;
+
+    if (extname) {
+        char *intname = mboxname_from_externalUTF8(extname, sd->ns, userid);
+        struct buf attrib = BUF_INITIALIZER;
+
+        annotatemore_lookup(intname, "/specialuse", userid, &attrib);
+
+        /* \\Inbox is magical */
+        if (mboxname_isusermailbox(intname, 1) &&
+            mboxname_userownsmailbox(userid, intname)) {
+            if (buf_len(&attrib)) buf_putc(&attrib, ' ');
+            buf_appendcstr(&attrib, "\\Inbox");
+        }
+
+        if (buf_len(&attrib)) {
+            strarray_t *haystack = strarray_split(buf_cstring(&attrib), " ", 0);
+
+            for (i = 0; i < strarray_size(uses); i++) {
+                if (strarray_find_case(haystack, strarray_nth(uses, i), 0) < 0) {
+                    r = 0;
+                    break;
+                }
+            }
+            strarray_free(haystack);
+        }
+        else r = 0;
+
+        buf_free(&attrib);
+        free(intname);
+    }
+    else {
+        for (i = 0; i < strarray_size(uses); i++) {
+            char *intname = mboxlist_find_specialuse(strarray_nth(uses, i), userid);
+            if (!intname) r = 0;
+            free(intname);
+            if (!r) break;
+        }
+    }
+
+    return r;
+}
+
 static int getmetadata(void *sc, const char *extname, const char *keyname, char **res)
 {
     script_data_t *sd = (script_data_t *)sc;
     struct buf attrib = BUF_INITIALIZER;
-    char *intname = extname ? mboxname_from_external(extname, sd->ns, mbname_userid(sd->mbname)) : xstrdup("");
+    char *intname = !extname ? xstrdup("") :
+        mboxname_from_externalUTF8(extname, sd->ns, mbname_userid(sd->mbname));
     int r;
     if (!strncmp(keyname, "/private/", 9)) {
         r = annotatemore_lookup(intname, keyname+8, mbname_userid(sd->mbname), &attrib);
@@ -168,7 +298,7 @@ static int getsize(void *mc, int *size)
 }
 
 /* we use the temp field in message_data to avoid having to malloc memory
-   to return, and we also can't expose our the receipients to the message */
+   to return, and we also can't expose our the recipients to the message */
 static int getenvelope(void *mc, const char *field, const char ***contents)
 {
     deliver_data_t *mydata = (deliver_data_t *) mc;
@@ -195,6 +325,59 @@ static int getenvelope(void *mc, const c
     }
 }
 
+static int getenvironment(void *sc __attribute__((unused)),
+                          const char *keyname, char **res)
+{
+    *res = NULL;
+
+    switch (*keyname) {
+    case 'd':
+        if (!strcmp(keyname, "domain")) {
+            const char *domain = strchr(config_servername, '.');
+
+            if (domain) domain++;
+            else domain = "";
+
+            *res = xstrdup(domain);
+        }
+        break;
+
+    case 'h':
+        if (!strcmp(keyname, "host")) *res = xstrdup(config_servername);
+        break;
+
+    case 'l':
+        if (!strcmp(keyname, "location")) *res = xstrdup("MDA");
+        break;
+
+    case 'n':
+        if (!strcmp(keyname, "name")) *res = xstrdup("Cyrus LMTP");
+        break;
+
+    case 'p':
+        if (!strcmp(keyname, "phase")) *res = xstrdup("during");
+        break;
+
+    case 'r':
+        if (!strncmp(keyname, "remote-", 7)) {
+            const char *localip, *remoteip,
+                *remotehost = get_clienthost(0, &localip, &remoteip);
+
+            if (!strcmp(keyname+7, "host"))
+                *res = xstrndup(remotehost, strcspn(remotehost, " ["));
+            else if (remoteip && !strcmp(keyname+7, "ip"))
+                *res = xstrndup(remoteip, strcspn(remoteip, ";"));
+        }
+        break;
+
+    case 'v':
+        if (!strcmp(keyname, "version")) *res = xstrdup(CYRUS_VERSION);
+        break;
+    }
+
+    return (*res ? SIEVE_OK : SIEVE_FAIL);
+}
+
 static int getbody(void *mc, const char **content_types,
                    sieve_bodypart_t ***parts)
 {
@@ -205,7 +388,8 @@ static int getbody(void *mc, const char
     if (!mydata->content->body) {
         /* parse the message body if we haven't already */
         r = message_parse_file(m->f, &mydata->content->base,
-                               &mydata->content->len, &mydata->content->body);
+                               &mydata->content->len, &mydata->content->body,
+                               NULL);
     }
 
     /* XXX currently struct bodypart as defined in message.h is the same as
@@ -246,34 +430,29 @@ static int getinclude(void *sc, const ch
 
 static int global_outgoing_count = 0;
 
-static int send_rejection(const char *origid,
+static int send_rejection(const char *userid,
+                          const char *origid,
                           const char *rejto,
                           const char *origreceip,
                           const char *mailreceip,
                           const char *reason,
                           struct protstream *file)
 {
-    FILE *sm;
-    const char *smbuf[10];
     char buf[8192], *namebuf;
-    int i, sm_stat;
+    int i, r = 0;
     time_t t;
-    char datestr[RFC822_DATETIME_MAX+1];
-    pid_t sm_pid, p;
+    char datestr[RFC5322_DATETIME_MAX+1];
+    pid_t p;
     duplicate_key_t dkey = DUPLICATE_INITIALIZER;
+    struct buf msgbuf = BUF_INITIALIZER;
+    smtp_envelope_t sm_env = SMTP_ENVELOPE_INITIALIZER;
+    smtpclient_t *sm = NULL;
+
+    /* Initialize SMTP envelope */
+    smtp_envelope_set_from(&sm_env, "<>");
+    smtp_envelope_add_rcpt(&sm_env, rejto);
 
-    smbuf[0] = "sendmail";
-    smbuf[1] = "-i";            /* ignore dots */
-    smbuf[2] = "-f";
-    smbuf[3] = "<>";
-    smbuf[4] = "--";
-    smbuf[5] = rejto;
-    smbuf[6] = NULL;
-    sm_pid = open_sendmail(smbuf, &sm);
-    if (sm == NULL) {
-        return -1;
-    }
-
+    /* Build message */
     t = time(NULL);
     p = getpid();
     snprintf(buf, sizeof(buf), "<cmu-sieve-%d-%d-%d@%s>", (int) p, (int) t,
@@ -281,97 +460,344 @@ static int send_rejection(const char *or
 
     namebuf = make_sieve_db(mailreceip);
 
-    time_to_rfc822(t, datestr, sizeof(datestr));
+    time_to_rfc5322(t, datestr, sizeof(datestr));
 
     dkey.id = buf;
     dkey.to = namebuf;
     dkey.date = datestr;
     duplicate_mark(&dkey, t, 0);
 
-    fprintf(sm, "Message-ID: %s\r\n", buf);
-    fprintf(sm, "Date: %s\r\n", datestr);
+    buf_printf(&msgbuf, "Message-ID: %s\r\n", buf);
+    buf_printf(&msgbuf, "Date: %s\r\n", datestr);
 
-    fprintf(sm, "X-Sieve: %s\r\n", SIEVE_VERSION);
-    fprintf(sm, "From: Mail Sieve Subsystem <%s>\r\n",
+    buf_printf(&msgbuf, "X-Sieve: %s\r\n", SIEVE_VERSION);
+    buf_printf(&msgbuf, "From: Mail Sieve Subsystem <%s>\r\n",
             config_getstring(IMAPOPT_POSTMASTER));
-    fprintf(sm, "To: <%s>\r\n", rejto);
-    fprintf(sm, "MIME-Version: 1.0\r\n");
-    fprintf(sm, "Content-Type: "
+    buf_printf(&msgbuf, "To: <%s>\r\n", rejto);
+    buf_printf(&msgbuf, "MIME-Version: 1.0\r\n");
+    buf_printf(&msgbuf, "Content-Type: "
             "multipart/report; report-type=disposition-notification;"
             "\r\n\tboundary=\"%d/%s\"\r\n", (int) p, config_servername);
-    fprintf(sm, "Subject: Automatically rejected mail\r\n");
-    fprintf(sm, "Auto-Submitted: auto-replied (rejected)\r\n");
-    fprintf(sm, "\r\nThis is a MIME-encapsulated message\r\n\r\n");
+    buf_printf(&msgbuf, "Subject: Automatically rejected mail\r\n");
+    buf_printf(&msgbuf, "Auto-Submitted: auto-replied (rejected)\r\n");
+    buf_printf(&msgbuf, "\r\nThis is a MIME-encapsulated message\r\n\r\n");
 
     /* this is the human readable status report */
-    fprintf(sm, "--%d/%s\r\n", (int) p, config_servername);
-    fprintf(sm, "Content-Type: text/plain; charset=utf-8\r\n");
-    fprintf(sm, "Content-Disposition: inline\r\n");
-    fprintf(sm, "Content-Transfer-Encoding: 8bit\r\n\r\n");
+    buf_printf(&msgbuf, "--%d/%s\r\n", (int) p, config_servername);
+    buf_printf(&msgbuf, "Content-Type: text/plain; charset=utf-8\r\n");
+    buf_printf(&msgbuf, "Content-Disposition: inline\r\n");
+    buf_printf(&msgbuf, "Content-Transfer-Encoding: 8bit\r\n\r\n");
 
-    fprintf(sm, "Your message was automatically rejected by Sieve, a mail\r\n"
+    buf_printf(&msgbuf, "Your message was automatically rejected by Sieve, a mail\r\n"
             "filtering language.\r\n\r\n");
-    fprintf(sm, "The following reason was given:\r\n%s\r\n\r\n", reason);
+    buf_printf(&msgbuf, "The following reason was given:\r\n%s\r\n\r\n", reason);
 
     /* this is the MDN status report */
-    fprintf(sm, "--%d/%s\r\n"
+    buf_printf(&msgbuf, "--%d/%s\r\n"
             "Content-Type: message/disposition-notification\r\n\r\n",
             (int) p, config_servername);
-    fprintf(sm, "Reporting-UA: %s; Cyrus %s/%s\r\n",
-            config_servername, cyrus_version(), SIEVE_VERSION);
+    buf_printf(&msgbuf, "Reporting-UA: %s; Cyrus %s/%s\r\n",
+            config_servername, CYRUS_VERSION, SIEVE_VERSION);
     if (origreceip)
-        fprintf(sm, "Original-Recipient: rfc822; %s\r\n", origreceip);
-    fprintf(sm, "Final-Recipient: rfc822; %s\r\n", mailreceip);
+        buf_printf(&msgbuf, "Original-Recipient: rfc822; %s\r\n", origreceip);
+    buf_printf(&msgbuf, "Final-Recipient: rfc822; %s\r\n", mailreceip);
     if (origid)
-        fprintf(sm, "Original-Message-ID: %s\r\n", origid);
-    fprintf(sm, "Disposition: "
+        buf_printf(&msgbuf, "Original-Message-ID: %s\r\n", origid);
+    buf_printf(&msgbuf, "Disposition: "
             "automatic-action/MDN-sent-automatically; deleted\r\n");
-    fprintf(sm, "\r\n");
+    buf_printf(&msgbuf, "\r\n");
 
     /* this is the original message */
-    fprintf(sm, "--%d/%s\r\nContent-Type: message/rfc822\r\n\r\n",
+    buf_printf(&msgbuf, "--%d/%s\r\nContent-Type: message/rfc822\r\n\r\n",
             (int) p, config_servername);
     prot_rewind(file);
     while ((i = prot_read(file, buf, sizeof(buf))) > 0) {
-        fwrite(buf, i, 1, sm);
+        buf_appendmap(&msgbuf, buf, i);
+    }
+    buf_printf(&msgbuf, "\r\n\r\n");
+    buf_printf(&msgbuf, "--%d/%s--\r\n", (int) p, config_servername);
+
+    /* Send the mail */
+    sm = NULL;
+    r = smtpclient_open(&sm);
+    if (!r) {
+        smtpclient_set_auth(sm, userid);
+        r = smtpclient_send(sm, &sm_env, &msgbuf);
+    }
+    if (r) {
+        syslog(LOG_ERR, "sieve: send_rejection: SMTP error: %s",
+                error_message(r));
+    }
+    smtpclient_close(&sm);
+
+    smtp_envelope_fini(&sm_env);
+    buf_free(&msgbuf);
+    return r;
+}
+
+#ifdef USE_SRS
+#include <srs2.h>
+
+static srs_t *srs_engine = NULL;
+
+#define SRS_INIT_FAIL_UNLESS(x)                 \
+    if ((srs_status = (x)) != SRS_SUCCESS) {    \
+        goto END;                               \
+    }
+
+void sieve_srs_init(void)
+{
+    const char *srs_domain = config_getstring(IMAPOPT_SRS_DOMAIN);
+    char *saved_secrets = NULL;
+    int srs_status = SRS_SUCCESS;
+
+    if (!srs_engine && srs_domain && *srs_domain) {
+        /* SRS enabled and not yet initialized */
+        int srs_alwaysrewrite = config_getswitch(IMAPOPT_SRS_ALWAYSREWRITE);
+        int srs_hashlength = config_getint(IMAPOPT_SRS_HASHLENGTH);
+        const char *srs_separator = config_getstring(IMAPOPT_SRS_SEPARATOR);
+        const char *srs_secrets = config_getstring(IMAPOPT_SRS_SECRETS);
+
+        SRS_INIT_FAIL_UNLESS(srs_set_malloc((srs_malloc_t)xmalloc,
+                                            (srs_realloc_t)xrealloc,
+                                            (srs_free_t)free));
+
+        srs_engine = srs_new();
+        SRS_INIT_FAIL_UNLESS(srs_set_alwaysrewrite(srs_engine,
+                                                   srs_alwaysrewrite));
+
+        if (srs_hashlength > 0) {
+            SRS_INIT_FAIL_UNLESS(srs_set_hashlength(srs_engine,
+                                                    srs_hashlength));
+        }
+        if (srs_separator) {
+            SRS_INIT_FAIL_UNLESS(srs_set_separator(srs_engine,
+                                                   srs_separator[0]));
+        }
+
+        if (srs_secrets) {
+            char *secret = NULL;
+
+            saved_secrets = xstrdup(srs_secrets);
+            secret = strtok(saved_secrets, ", \t\r\n");
+            while (secret) {
+                SRS_INIT_FAIL_UNLESS(srs_add_secret(srs_engine, secret));
+                secret = strtok(NULL, ", \t\r\n");
+            }
+        }
     }
-    fprintf(sm, "\r\n\r\n");
-    fprintf(sm, "--%d/%s--\r\n", (int) p, config_servername);
 
-    fclose(sm);
-    while (waitpid(sm_pid, &sm_stat, 0) < 0);
+  END:
+    if (saved_secrets) free(saved_secrets);
 
-    return sm_stat;     /* sendmail exit value */
+    if (srs_status != SRS_SUCCESS) {
+        sieve_srs_free();
+
+        syslog(LOG_ERR, "sieve SRS configuration error: %s",
+               srs_strerror(srs_status));
+    }
+}
+
+void sieve_srs_free(void)
+{
+    if (srs_engine) {
+        srs_free(srs_engine);
+        srs_engine = NULL;
+    }
 }
 
-static int send_forward(const char *forwardto,
+/**
+ * Performs SRS forward rewriting.
+ * If rewriting failed, or SRS is disabled, NULL pointer is returned. Otherwise
+ * caller is responsible of freeing the resulting address.
+ *
+ * @param return_path   address to rewrite
+ * @return rewritten address, or NULL
+ */
+static char *sieve_srs_forward(char *return_path)
+{
+    const char *srs_domain = config_getstring(IMAPOPT_SRS_DOMAIN);
+    char *srs_return_path = NULL;
+    int srs_status;
+
+    if (!srs_engine) {
+        /* SRS not enabled */
+        return NULL;
+    }
+
+    srs_status = srs_forward_alloc(srs_engine, &srs_return_path,
+                                   return_path, srs_domain);
+
+    if (srs_status != SRS_SUCCESS) {
+        syslog(LOG_ERR, "sieve SRS forward failed (%s, %s): %s",
+               return_path, srs_domain, srs_strerror(srs_status));
+        if (srs_return_path) {
+            free(srs_return_path);
+            srs_return_path = NULL;
+        }
+    }
+
+    return srs_return_path;
+}
+
+#else /* !USE_SRS */
+
+void sieve_srs_init(void) { return; }
+void sieve_srs_free(void) { return; }
+
+static char *sieve_srs_forward(char *return_path __attribute__((unused)))
+{
+    return NULL;
+}
+
+#endif /* USE_SRS */
+
+#ifdef WITH_DAV
+#include <libxml/uri.h>
+
+static char *get_addrbook_mboxname(const char *list, const char *userid)
+{
+    const char *addrbook_urn_full = "urn:ietf:params:sieve:addrbook:";
+    const char *addrbook_urn_abbrev = ":addrbook:";
+    char *abook = NULL, *mboxname = NULL;
+
+    /* percent-decode list URI */
+    char *uri = xmlURIUnescapeString(list, strlen(list), NULL);
+
+    if (!strncmp(uri, addrbook_urn_full, strlen(addrbook_urn_full))) {
+        abook = xstrdup(uri + strlen(addrbook_urn_full));
+    }
+    else if (!strncmp(uri, addrbook_urn_abbrev, strlen(addrbook_urn_abbrev))) {
+        abook = xstrdup(uri + strlen(addrbook_urn_abbrev));
+    }
+
+    free(uri);
+
+    if (!abook) return NULL;
+
+    /* MUST match default addressbook case-insensitively */
+    if (!strcasecmp(abook, "Default")) {
+        abook[0] = 'D';
+        lcase(abook+1);
+    }
+
+    /* construct mailbox name of addressbook */
+    mboxname = carddav_mboxname(userid, abook);
+
+    /* see if addressbook mailbox exists */
+    if (mboxlist_lookup(mboxname, NULL, NULL) == 0) return mboxname;
+    else {
+        free(mboxname);
+        return NULL;
+    }
+}
+
+static int listvalidator(void *ic, const char *list)
+{
+    struct sieve_interp_ctx *ctx = (struct sieve_interp_ctx *) ic;
+    char *abook = get_addrbook_mboxname(list, ctx->userid);
+    int ret = abook ? SIEVE_OK : SIEVE_FAIL;
+
+    free(abook);
+
+    return ret;
+}
+
+static int listcompare(const char *text, size_t tlen __attribute__((unused)),
+                       const char *list, strarray_t *match_vars, void *rock)
+{
+    struct sieve_interp_ctx *ctx = (struct sieve_interp_ctx *) rock;
+    char *abook = get_addrbook_mboxname(list, ctx->userid);
+    int ret = 0;
+
+    if (!abook) return 0;
+
+    if (!ctx->carddavdb) {
+        /* open user's CardDAV DB */
+        ctx->carddavdb = carddav_open_userid(ctx->userid);
+    }
+    if (ctx->carddavdb) {
+        /* search for email address in addressbook */
+        strarray_t *uids =
+            carddav_getemail2details(ctx->carddavdb, text, abook, NULL);
+        ret = strarray_size(uids);
+
+        strarray_free(uids);
+    }
+
+    if (ret && match_vars) {
+        /* found a match - set $0 */
+        strarray_add(match_vars, text);
+    }
+
+    free(abook);
+
+    return ret;
+}
+
+static int list_addresses(void *rock, struct carddav_data *cdata)
+{
+    smtp_envelope_t *sm_env = rock;
+    int i;
+
+    /* XXX  Lookup up emails for vcard */
+    if (!cdata->emails) return 0;
+    for (i = 0; i < strarray_size(cdata->emails); i++) {
+        /* Find preferred address */
+        smtp_envelope_add_rcpt(sm_env, strarray_nth(cdata->emails, i));
+    }
+
+    return 0;
+}
+#endif /* WITH_DAV */
+
+static int send_forward(sieve_redirect_context_t *rc,
+                        struct sieve_interp_ctx *ctx,
                         char *return_path,
                         struct protstream *file)
 {
-    FILE *sm;
-    const char *smbuf[10];
-    int sm_stat;
+    int r = 0;
     char buf[1024];
-    pid_t sm_pid;
     int body = 0, skip;
+    char *srs_return_path = NULL;
+    smtp_envelope_t sm_env = SMTP_ENVELOPE_INITIALIZER;
+    struct buf msgbuf = BUF_INITIALIZER;
+    smtpclient_t *sm = NULL;
+
+    srs_return_path = sieve_srs_forward(return_path);
+    if (srs_return_path) {
+        smtp_envelope_set_from(&sm_env, srs_return_path);
+    }
+    else if (return_path && *return_path) {
+        smtp_envelope_set_from(&sm_env, return_path);
+    }
+    else {
+        smtp_envelope_set_from(&sm_env, "<>");
+    }
 
-    smbuf[0] = "sendmail";
-    smbuf[1] = "-i";            /* ignore dots */
-    smbuf[2] = "-f";
-    if (return_path && *return_path) {
-        smbuf[3] = return_path;
-    } else {
-        smbuf[3] = "<>";
-    }
-    smbuf[4] = "--";
-    smbuf[5] = forwardto;
-    smbuf[6] = NULL;
-    sm_pid = open_sendmail(smbuf, &sm);
+    if (rc->is_ext_list) {
+#ifdef WITH_DAV
+        char *abook = get_addrbook_mboxname(rc->addr, ctx->userid);
 
-    if (sm == NULL) {
-        return -1;
+        if (abook && !ctx->carddavdb) {
+            /* open user's CardDAV DB */
+            ctx->carddavdb = carddav_open_userid(ctx->userid);
+        }
+        if (!(abook && ctx->carddavdb)) {
+            r = SIEVE_FAIL;
+            free(abook);
+            goto done;
+        }
+        carddav_foreach(ctx->carddavdb, abook, &list_addresses, &sm_env);
+        free(abook);
+#endif
+    }
+    else {
+        smtp_envelope_add_rcpt(&sm_env, rc->addr);
     }
 
+    if (srs_return_path) free(srs_return_path);
+
     prot_rewind(file);
     while (prot_fgets(buf, sizeof(buf), file)) {
         if (!body && buf[0] == '\r' && buf[1] == '\n') {
@@ -388,25 +814,36 @@ static int send_forward(const char *forw
         }
 
         do {
-            if (!skip) fwrite(buf, strlen(buf), 1, sm);
+            if (!skip) buf_appendcstr(&msgbuf, buf);
         } while (buf[strlen(buf)-1] != '\n' &&
                  prot_fgets(buf, sizeof(buf), file));
     }
 
-    fclose(sm);
-    while (waitpid(sm_pid, &sm_stat, 0) < 0);
+    r = smtpclient_open(&sm);
+    if (r) goto done;
 
-    return sm_stat;     /* sendmail exit value */
+    smtpclient_set_auth(sm, ctx->userid);
+    smtpclient_set_notify(sm, rc->dsn_notify);
+    smtpclient_set_ret(sm, rc->dsn_ret);
+    smtpclient_set_by(sm, rc->deliverby);
+    r = smtpclient_send(sm, &sm_env, &msgbuf);
+    smtpclient_close(&sm);
+
+done:
+    smtp_envelope_fini(&sm_env);
+    buf_free(&msgbuf);
+    return r;
 }
 
 
-static int sieve_redirect(void *ac,
-                          void *ic __attribute__((unused)),
+static int sieve_redirect(void *ac, void *ic,
                           void *sc, void *mc, const char **errmsg)
 {
     sieve_redirect_context_t *rc = (sieve_redirect_context_t *) ac;
+    struct sieve_interp_ctx *ctx = (struct sieve_interp_ctx *) ic;
     script_data_t *sd = (script_data_t *) sc;
-    message_data_t *m = ((deliver_data_t *) mc)->m;
+    deliver_data_t *mdata = (deliver_data_t *) mc;
+    message_data_t *m = mdata->m;
     char buf[8192], *sievedb = NULL;
     duplicate_key_t dkey = DUPLICATE_INITIALIZER;
     int res;
@@ -426,22 +863,34 @@ static int sieve_redirect(void *ac,
         }
     }
 
-    if ((res = send_forward(rc->addr, m->return_path, m->data)) == 0) {
+    if (sd->edited_header) {
+        mdata = setup_special_delivery(mdata);
+        if (!mdata) return SIEVE_FAIL;
+        else m = mdata->m;
+    }
+
+    res = send_forward(rc, ctx, m->return_path, m->data);
+
+    if (sd->edited_header) cleanup_special_delivery(mdata);
+
+    if (res == 0) {
         /* mark this message as redirected */
         if (sievedb) duplicate_mark(&dkey, time(NULL), 0);
 
+        prometheus_increment(CYRUS_LMTP_SIEVE_REDIRECT_TOTAL);
         snmp_increment(SIEVE_REDIRECT, 1);
         syslog(LOG_INFO, "sieve redirected: %s to: %s",
                m->id ? m->id : "<nomsgid>", rc->addr);
         if (config_auditlog)
-            syslog(LOG_NOTICE, "auditlog: redirect sessionid=<%s> message-id=%s target=<%s>",
-                   session_id(), m->id ? m->id : "<nomsgid>", rc->addr);
+            syslog(LOG_NOTICE,
+                   "auditlog: redirect sessionid=<%s> message-id=%s target=<%s> userid=<%s>",
+                   session_id(), m->id ? m->id : "<nomsgid>", rc->addr, ctx->userid);
         return SIEVE_OK;
     } else {
         if (res == -1) {
             *errmsg = "Could not spawn sendmail process";
         } else {
-            *errmsg = sendmail_errstr(res);
+            *errmsg = error_message(res);
         }
         return SIEVE_FAIL;
     }
@@ -455,6 +904,7 @@ static int sieve_discard(void *ac __attr
 {
     message_data_t *md = ((deliver_data_t *) mc)->m;
 
+    prometheus_increment(CYRUS_LMTP_SIEVE_DISCARD_TOTAL);
     snmp_increment(SIEVE_DISCARD, 1);
 
     /* ok, we won't file it, but log it */
@@ -467,16 +917,58 @@ static int sieve_discard(void *ac __attr
     return SIEVE_OK;
 }
 
-static int sieve_reject(void *ac,
-                        void *ic __attribute__((unused)),
+static int sieve_reject(void *ac, void *ic,
                         void *sc, void *mc, const char **errmsg)
 {
     sieve_reject_context_t *rc = (sieve_reject_context_t *) ac;
+    struct sieve_interp_ctx *ctx = (struct sieve_interp_ctx *) ic;
     script_data_t *sd = (script_data_t *) sc;
-    message_data_t *md = ((deliver_data_t *) mc)->m;
+    deliver_data_t *mydata = (deliver_data_t *) mc;
+    message_data_t *md = mydata->m;
     const char **body;
     const char *origreceip;
-    int res;
+    int res, need_encode = 0;
+
+    /* Per RFC 5429, reject can do LMTP reject if reason string is US-ASCII */
+    const char *cp;
+    for (cp = rc->msg; *cp; cp++) {
+        if (!isascii(*cp)) {
+            need_encode = 1;
+            break;
+        }
+    }
+
+    if (rc->is_extended || (config_getswitch(IMAPOPT_SIEVE_USE_LMTP_REJECT) && !need_encode)) {
+        char *msg = need_encode ?
+            charset_qpencode_mimebody(rc->msg, strlen(rc->msg), 0, NULL) :
+            xstrdup(rc->msg);
+        strarray_t *resp = strarray_new();
+        struct buf buf = BUF_INITIALIZER;
+        const char *cur, *next;
+        tok_t tok;
+
+        tok_initm(&tok, msg, "\r\n", 0);
+        for (cur = tok_next(&tok); (next = tok_next(&tok)); cur = next) {
+            buf_printf(&buf, "550-5.7.1 %s\r\n", cur);
+            strarray_appendm(resp, buf_release(&buf));
+        }
+        buf_printf(&buf, "550 5.7.1 %s\r\n", cur);
+        strarray_appendm(resp, buf_release(&buf));
+        free(msg);
+
+        msg_setrcpt_status(md, mydata->cur_rcpt, LMTP_MESSAGE_REJECTED, resp);
+
+        prometheus_increment(CYRUS_LMTP_SIEVE_REJECT_TOTAL);
+        snmp_increment(SIEVE_REJECT, 1);
+        syslog(LOG_INFO, "sieve LMTP rejected: %s",
+               md->id ? md->id : "<nomsgid>");
+        if (config_auditlog)
+            syslog(LOG_NOTICE,
+                   "auditlog: LMTP reject sessionid=<%s> message-id=%s userid=<%s>",
+                   session_id(), md->id ? md->id : "<nomsgid>", ctx->userid);
+
+        return SIEVE_OK;
+    }
 
     if (md->return_path == NULL) {
         /* return message to who?!? */
@@ -488,33 +980,110 @@ static int sieve_reject(void *ac,
         syslog(LOG_INFO, "sieve: discarded reject to <> for %s id %s",
                mbname_userid(sd->mbname), md->id ? md->id : "<nomsgid>");
         if (config_auditlog)
-            syslog(LOG_NOTICE, "auditlog: discard-reject sessionid=<%s> message-id=%s",
-                   session_id(), md->id ? md->id : "<nomsgid>");
+            syslog(LOG_NOTICE,
+                   "auditlog: discard-reject sessionid=<%s> message-id=%s userid=<%s>",
+                   session_id(), md->id ? md->id : "<nomsgid>", ctx->userid);
         return SIEVE_OK;
     }
 
     body = msg_getheader(md, "original-recipient");
     origreceip = body ? body[0] : NULL;
-    if ((res = send_rejection(md->id, md->return_path,
+    if ((res = send_rejection(ctx->userid, md->id, md->return_path,
                               origreceip, mbname_recipient(sd->mbname, ((deliver_data_t *) mc)->ns),
                               rc->msg, md->data)) == 0) {
+        prometheus_increment(CYRUS_LMTP_SIEVE_REJECT_TOTAL);
         snmp_increment(SIEVE_REJECT, 1);
         syslog(LOG_INFO, "sieve rejected: %s to: %s",
                md->id ? md->id : "<nomsgid>", md->return_path);
         if (config_auditlog)
-            syslog(LOG_NOTICE, "auditlog: reject sessionid=<%s> message-id=%s target=<%s>",
-                   session_id(), md->id ? md->id : "<nomsgid>", md->return_path);
+            syslog(LOG_NOTICE,
+                   "auditlog: reject sessionid=<%s> message-id=%s target=<%s> userid=<%s>",
+                   session_id(), md->id ? md->id : "<nomsgid>", md->return_path,
+                   ctx->userid);
         return SIEVE_OK;
     } else {
         if (res == -1) {
             *errmsg = "Could not spawn sendmail process";
         } else {
-            *errmsg = sendmail_errstr(res);
+            *errmsg = error_message(res);
         }
         return SIEVE_FAIL;
     }
 }
 
+static void dump_header(const char *name, const char *value, const char *raw, void *rock)
+{
+    FILE *f = (FILE *)rock;
+
+    if (raw) fputs(raw, f);
+    else fprintf(f, "%s: %s\r\n", name, value);
+}
+
+static deliver_data_t *setup_special_delivery(deliver_data_t *mydata)
+{
+    static deliver_data_t dd;
+    static message_data_t md;
+    static struct message_content mc;
+
+    memcpy(&dd, mydata, sizeof(deliver_data_t));
+    dd.m = memcpy(&md, mydata->m, sizeof(message_data_t));
+    dd.content = &mc;
+    memset(&mc, 0, sizeof(struct message_content));
+
+    /* build the mailboxname from the recipient address */
+    const mbname_t *origmbname = msg_getrcpt(mydata->m, mydata->cur_rcpt);
+
+    /* do the userid */
+    mbname_t *mbname = mbname_dup(origmbname);
+    if (mbname_userid(mbname)) {
+        mbname_truncate_boxes(mbname, 0);
+    }
+
+    const char *intname = mbname_intname(mbname);
+    md.f = append_newstage(intname, time(0),
+                           strhash(intname) /* unique msgnum for modified msg */,
+                           &dd.stage);
+    if (md.f) {
+        char buf[4096];
+
+        /* write updated message headers */
+        spool_enum_hdrcache(mydata->m->hdrcache, &dump_header, md.f);
+
+        /* get offset of message body */
+        md.body_offset = ftell(md.f);
+
+        /* write message body */
+        fseek(mydata->m->f, mydata->m->body_offset, SEEK_SET);
+        while (fgets(buf, sizeof(buf), mydata->m->f)) fputs(buf, md.f);
+        fflush(md.f);
+
+        /* XXX  do we look for updated Date and Message-ID? */
+        md.size = ftell(md.f);
+        md.data = prot_new(fileno(md.f), 0);
+
+        mydata = &dd;
+    }
+    else mydata = NULL;
+
+    mbname_free(&mbname);
+
+    return mydata;
+}
+
+static void cleanup_special_delivery(deliver_data_t *mydata)
+{
+    fclose(mydata->m->f);
+    prot_free(mydata->m->data);
+    append_removestage(mydata->stage);
+    if (mydata->content->base) {
+        map_free(&mydata->content->base, &mydata->content->len);
+        if (mydata->content->body) {
+            message_free_body(mydata->content->body);
+            free(mydata->content->body);
+        }
+    }
+}
+
 static int sieve_fileinto(void *ac,
                           void *ic __attribute__((unused)),
                           void *sc,
@@ -526,41 +1095,254 @@ static int sieve_fileinto(void *ac,
     deliver_data_t *mdata = (deliver_data_t *) mc;
     message_data_t *md = mdata->m;
     int quotaoverride = msg_getrcpt_ignorequota(md, mdata->cur_rcpt);
-    char namebuf[MAX_MAILBOX_BUFFER];
-    int ret;
+    struct imap4flags imap4flags = { fc->imapflags, sd->authstate };
+    int ret = IMAP_MAILBOX_NONEXISTENT;
 
-    char *intname = mboxname_from_external(fc->mailbox, sd->ns, mbname_userid(sd->mbname));
-    strncpy(namebuf, intname, sizeof(namebuf));
-    free(intname);
+    const char *userid = mbname_userid(sd->mbname);
+    char *intname = NULL;
+
+    if (sd->edited_header) {
+        mdata = setup_special_delivery(mdata);
+        if (!mdata) return SIEVE_FAIL;
+        else md = mdata->m;
+    }
+
+    if (fc->mailboxid) {
+        intname = mboxlist_find_uniqueid(fc->mailboxid, userid, sd->authstate);
+        if (intname &&
+            (mboxname_isdeletedmailbox(intname, NULL) ||
+             mboxname_isnonimapmailbox(intname, 0))) {
+            free(intname);
+            intname = NULL;
+        }
+    }
+    if (!intname) {
+        if (fc->specialuse) {
+            intname = mboxname_from_external(fc->specialuse, sd->ns, userid);
+            ret = mboxlist_lookup(intname, NULL, NULL);
+            if (ret) free(intname);
+        }
+        if (ret) {
+            intname = mboxname_from_externalUTF8(fc->mailbox, sd->ns, userid);
+        }
+    }
+
+    // didn't resolve a name, this will always fail
+    if (!intname) goto done;
 
     ret = deliver_mailbox(md->f, mdata->content, mdata->stage, md->size,
-                          fc->imapflags,
-                          mbname_userid(sd->mbname), sd->authstate, md->id,
-                          mbname_userid(sd->mbname), mdata->notifyheader,
-                          namebuf, md->date, quotaoverride, 0);
+                          &imap4flags, NULL, userid, sd->authstate, md->id,
+                          userid, mdata->notifyheader,
+                          intname, md->date, 0 /*savedate*/, quotaoverride, 0);
 
     if (ret == IMAP_MAILBOX_NONEXISTENT) {
         /* if "plus" folder under INBOX, then try to create it */
-        ret = autosieve_createfolder(mbname_userid(sd->mbname), sd->authstate, namebuf, fc->do_create);
+        ret = autosieve_createfolder(userid, sd->authstate,
+                                     intname, fc->do_create);
 
         /* Try to deliver the mail again. */
-        if (!ret)
+        if (!ret) {
+            if (fc->specialuse) {
+                /* Attempt to add special-use flag to newly created mailbox */
+                struct buf specialuse = BUF_INITIALIZER;
+                int r = specialuse_validate(NULL, userid, fc->specialuse, &specialuse);
+
+                if (!r) {
+                    annotatemore_write(intname, "/specialuse",
+                                       userid, &specialuse);
+                }
+                buf_free(&specialuse);
+            }
+
             ret = deliver_mailbox(md->f, mdata->content, mdata->stage, md->size,
-                                  fc->imapflags,
-                                  mbname_userid(sd->mbname), sd->authstate, md->id,
-                                  mbname_userid(sd->mbname), mdata->notifyheader,
-                                  namebuf, md->date, quotaoverride, 0);
+                                  &imap4flags, NULL, userid, sd->authstate, md->id,
+                                  userid, mdata->notifyheader,
+                                  intname, md->date, 0 /*savedate*/, quotaoverride, 0);
+        }
     }
 
+done:
+    if (sd->edited_header) cleanup_special_delivery(mdata);
+
     if (!ret) {
+        prometheus_increment(CYRUS_LMTP_SIEVE_FILEINTO_TOTAL);
         snmp_increment(SIEVE_FILEINTO, 1);
-        return SIEVE_OK;
+        ret = SIEVE_OK;
     } else {
         *errmsg = error_message(ret);
-        return SIEVE_FAIL;
+        ret = SIEVE_FAIL;
     }
+
+    free(intname);
+
+    return ret;
 }
 
+#ifdef HAVE_JANSSON
+#include <jansson.h>
+
+static void add_keywords(strarray_t *flags, json_t *set_keywords, int add)
+{
+    int i;
+
+    for (i = 0; i < strarray_size(flags); i++) {
+        const char *flag = strarray_nth(flags, i);
+
+        if (!strcasecmp(flag, "\\Seen")) flag = "$Seen";
+        else if (!strcasecmp(flag, "\\Flagged")) flag = "$Flagged";
+        else if (!strcasecmp(flag, "\\Answered")) flag = "$Answered";
+        else if (!strcasecmp(flag, "\\Draft")) flag = "$Draft";
+
+        json_object_set_new(set_keywords, flag,
+                            add ? json_true() : json_false());
+    }
+}
+
+static int sieve_snooze(void *ac,
+                        void *ic __attribute__((unused)),
+                        void *sc,
+                        void *mc,
+                        const char **errmsg __attribute__((unused)))
+{
+    sieve_snooze_context_t *sn = (sieve_snooze_context_t *) ac;
+    script_data_t *sd = (script_data_t *) sc;
+    deliver_data_t *mdata = (deliver_data_t *) mc;
+    message_data_t *md = mdata->m;
+    int quotaoverride = msg_getrcpt_ignorequota(md, mdata->cur_rcpt);
+    const char *userid = mbname_userid(sd->mbname);
+    int ret = IMAP_MAILBOX_NONEXISTENT;
+
+    if (sd->edited_header) {
+        mdata = setup_special_delivery(mdata);
+        if (!mdata) return SIEVE_FAIL;
+        else md = mdata->m;
+    }
+
+    char *intname = mboxlist_find_specialuse("\\Snoozed", userid);
+    if (!intname) goto done;
+
+    /* Determine until time */
+    time_t now = time(NULL), until;
+    struct tm *tm = localtime(&now);
+    int i, day_inc = -1;
+    unsigned t;
+    char tbuf[26];
+
+    if (sn->days & (1 << tm->tm_wday)) {
+        /* We have times for today - see if a future one is still available */
+        unsigned today_sec = 3600 * tm->tm_hour + 60 * tm->tm_min + tm->tm_sec;
+
+        for (i = 0; i < arrayu64_size(sn->times); i++) {
+            t = arrayu64_nth(sn->times, i);
+            if (t >= today_sec) {
+                day_inc = 0;
+                break;
+            }
+        }
+    }
+    if (day_inc == -1) {
+        /* Use first time on next available day */
+        t = arrayu64_nth(sn->times, 0);
+
+        /* Find next available day */
+        for (i = tm->tm_wday+1; i < 14; i++) {
+            if (sn->days & (1 << (i % 7))) {
+                day_inc = i - tm->tm_wday;
+                break;
+            }
+        }
+    }
+
+    tm->tm_mday += day_inc;
+    tm->tm_hour = t / 3600;
+    tm->tm_min = (t % 3600) / 60;
+    tm->tm_sec = t % 60;
+    until = mktime(tm);
+    time_to_iso8601(until, tbuf, sizeof(tbuf), 1);
+
+    /* Create snoozeDetails annotation */
+    json_t *snoozed = json_pack("{s:s}", "until", tbuf);
+
+    if (sn->awaken_mbox) {
+        char *awaken = NULL;
+        const char *awakenid = NULL;
+        mbentry_t *mbentry = NULL;
+
+        if (sn->is_mboxid) {
+            awaken = mboxlist_find_uniqueid(sn->awaken_mbox,
+                                            userid, sd->authstate);
+            if (awaken) awakenid = sn->awaken_mbox;
+        }
+        else {
+            awaken = mboxname_from_external(sn->awaken_mbox, sd->ns, userid);
+            ret = mboxlist_lookup(awaken, &mbentry, NULL);
+            if (!ret) awakenid = mbentry->uniqueid;
+        }
+
+        if (awakenid) {
+            json_object_set_new(snoozed, "moveToMailboxId",
+                                json_string(awakenid));
+        }
+
+        mboxlist_entry_free(&mbentry);
+        free(awaken);
+    }
+
+    if (sn->addflags || sn->removeflags) {
+        json_t *set_keywords = json_object();
+
+        if (sn->addflags) {
+            add_keywords(sn->addflags, set_keywords, 1);
+        }
+        if (sn->removeflags) {
+            add_keywords(sn->removeflags, set_keywords, 0);
+        }
+
+        json_object_set_new(snoozed, "setKeywords", set_keywords);
+    }
+
+    struct entryattlist *annots = NULL;
+    const char *annot = IMAP_ANNOT_NS "snoozed";
+    const char *attrib = "value.shared";
+    struct buf buf = BUF_INITIALIZER;
+    char *json = json_dumps(snoozed, JSON_COMPACT);
+
+    json_decref(snoozed);
+    buf_initm(&buf, json, strlen(json));
+    setentryatt(&annots, annot, attrib, &buf);
+    buf_free(&buf);
+
+    /* Add \snoozed pseudo-flag */
+    strarray_t *imapflags = strarray_dup(sn->imapflags);
+    strarray_add(imapflags, "\\snoozed");
+
+    struct imap4flags imap4flags = { imapflags, sd->authstate };
+    ret = deliver_mailbox(md->f, mdata->content, mdata->stage, md->size,
+                          &imap4flags, annots, userid, sd->authstate, md->id,
+                          userid, mdata->notifyheader,
+                          intname, md->date, until, quotaoverride, 0);
+
+    strarray_free(imapflags);
+    freeentryatts(annots);
+
+done:
+    if (sd->edited_header) cleanup_special_delivery(mdata);
+
+    if (!ret) {
+        prometheus_increment(CYRUS_LMTP_SIEVE_SNOOZE_TOTAL);
+        snmp_increment(SIEVE_SNOOZE, 1);
+        ret = SIEVE_OK;
+    } else {
+        *errmsg = error_message(ret);
+        ret = SIEVE_FAIL;
+    }
+
+    free(intname);
+
+    return ret;
+}
+#endif /* HAVE_JANSSON */
+
 static int sieve_keep(void *ac,
                       void *ic __attribute__((unused)),
                       void *sc, void *mc, const char **errmsg)
@@ -568,11 +1350,20 @@ static int sieve_keep(void *ac,
     sieve_keep_context_t *kc = (sieve_keep_context_t *) ac;
     script_data_t *sd = (script_data_t *) sc;
     deliver_data_t *mydata = (deliver_data_t *) mc;
+    struct imap4flags imap4flags = { kc->imapflags, sd->authstate };
     int ret;
 
-    ret = deliver_local(mydata, kc->imapflags, sd->mbname);
+    if (sd->edited_header) {
+        mydata = setup_special_delivery(mydata);
+        if (!mydata) return SIEVE_FAIL;
+    }
+
+    ret = deliver_local(mydata, &imap4flags, sd->mbname);
 
+    if (sd->edited_header) cleanup_special_delivery(mydata);
+ 
     if (!ret) {
+        prometheus_increment(CYRUS_LMTP_SIEVE_KEEP_TOTAL);
         snmp_increment(SIEVE_KEEP, 1);
         return SIEVE_OK;
     } else {
@@ -594,6 +1385,7 @@ static int sieve_notify(void *ac,
         script_data_t *sd = (script_data_t *) script_context;
         int nopt = 0;
 
+        prometheus_increment(CYRUS_LMTP_SIEVE_NOTIFY_TOTAL);
         snmp_increment(SIEVE_NOTIFY, 1);
 
         /* count options */
@@ -624,6 +1416,7 @@ static int autorespond(void *ac,
     duplicate_key_t dkey = DUPLICATE_INITIALIZER;
     char *id;
 
+    prometheus_increment(CYRUS_LMTP_SIEVE_AUTORESPOND_TOTAL);
     snmp_increment(SIEVE_VACATION_TOTAL, 1);
 
     now = time(NULL);
@@ -660,48 +1453,120 @@ static int autorespond(void *ac,
     return ret;
 }
 
-static int send_response(void *ac,
-                         void *ic __attribute__((unused)),
+static void do_fcc(script_data_t *sdata, sieve_fileinto_context_t *fcc,
+                   struct buf *header, const char *msg, struct buf *footer)
+{
+    struct appendstate as;
+    const char *userid;
+    char *intname;
+    int r = IMAP_MAILBOX_NONEXISTENT;
+
+    userid = mbname_userid(sdata->mbname);
+
+    if (fcc->specialuse) {
+        intname = mboxname_from_external(fcc->specialuse, sdata->ns, userid);
+        r = mboxlist_lookup(intname, NULL, NULL);
+        if (r) free(intname);
+    }
+    if (r) intname = mboxname_from_externalUTF8(fcc->mailbox, sdata->ns, userid);
+
+    r = mboxlist_lookup(intname, NULL, NULL);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        r = autosieve_createfolder(userid, sdata->authstate,
+                                   intname, fcc->do_create);
+
+        if (!r && fcc->specialuse) {
+            /* Attempt to add special-use flag to newly created mailbox */
+            struct buf specialuse = BUF_INITIALIZER;
+            int r2 = specialuse_validate(NULL, userid, fcc->specialuse, &specialuse);
+
+            if (!r2) {
+                annotatemore_write(intname, "/specialuse", userid, &specialuse);
+            }
+            buf_free(&specialuse);
+        }
+    }
+    if (!r) {
+        r = append_setup(&as, intname, userid, sdata->authstate,
+                         0, NULL, NULL, 0, EVENT_MESSAGE_APPEND);
+    }
+    if (!r) {
+        struct stagemsg *stage;
+        /* post-date by 1 sec in an effort to have
+           the FCC threaded AFTER the incoming message */
+        time_t internaldate = time(NULL) + 1;
+        FILE *f = append_newstage(intname, internaldate,
+                                  strhash(intname) /* unique msgnum for reply */,
+                                  &stage);
+        if (f) {
+            struct body *body = NULL;
+
+            fprintf(f, "%s%s%s",
+                    buf_cstring(header), msg, buf_cstring(footer));
+            fclose(f);
+
+            r = append_fromstage(&as, &body, stage,
+                                 internaldate, /* createdmodseq */ 0,
+                                 fcc->imapflags, 0, /* annotations */ NULL);
+            if (!r) r = append_commit(&as);
+
+            if (body) {
+                message_free_body(body);
+                free(body);
+            }
+
+            append_removestage(stage);
+        }
+        if (r || !f) append_abort(&as);
+    }
+
+    if (r) {
+        syslog(LOG_NOTICE, "sieve fcc '%s' failed: %s",
+               fcc->mailbox, error_message(r));
+    }
+
+    free(intname);
+}
+
+static int send_response(void *ac, void *ic,
                          void *sc, void *mc, const char **errmsg)
 {
-    FILE *sm;
-    const char *smbuf[10];
     char outmsgid[8192], *sievedb, *subj;
-    int i, sl, sm_stat;
+    int i, sl, ret, r;
     time_t t;
-    char datestr[RFC822_DATETIME_MAX+1];
-    pid_t sm_pid, p;
+    char datestr[RFC5322_DATETIME_MAX+1];
+    pid_t p;
     sieve_send_response_context_t *src = (sieve_send_response_context_t *) ac;
     message_data_t *md = ((deliver_data_t *) mc)->m;
     script_data_t *sdata = (script_data_t *) sc;
     duplicate_key_t dkey = DUPLICATE_INITIALIZER;
+    struct buf header = BUF_INITIALIZER, footer = BUF_INITIALIZER;
+    struct buf msgbuf = BUF_INITIALIZER;
+    struct sieve_interp_ctx *ctx = (struct sieve_interp_ctx *) ic;
+    smtp_envelope_t sm_env = SMTP_ENVELOPE_INITIALIZER;
+    smtpclient_t *sm = NULL;
 
-    smbuf[0] = "sendmail";
-    smbuf[1] = "-i";            /* ignore dots */
-    smbuf[2] = "-f";
-    smbuf[3] = "<>";
-    smbuf[4] = "--";
-    smbuf[5] = src->addr;
-    smbuf[6] = NULL;
-    sm_pid = open_sendmail(smbuf, &sm);
-    if (sm == NULL) {
-        *errmsg = "Could not spawn sendmail process";
-        return -1;
-    }
+    smtp_envelope_set_from(&sm_env, "<>");
+    smtp_envelope_add_rcpt(&sm_env, src->addr);
 
     t = time(NULL);
     p = getpid();
     snprintf(outmsgid, sizeof(outmsgid), "<cmu-sieve-%d-%d-%d@%s>",
              (int) p, (int) t, global_outgoing_count++, config_servername);
 
-    fprintf(sm, "Message-ID: %s\r\n", outmsgid);
+    buf_printf(&header, "Message-ID: %s\r\n", outmsgid);
+
+    time_to_rfc5322(t, datestr, sizeof(datestr));
+    buf_printf(&header, "Date: %s\r\n", datestr);
+
+    buf_printf(&header, "X-Sieve: %s\r\n", SIEVE_VERSION);
 
-    time_to_rfc822(t, datestr, sizeof(datestr));
-    fprintf(sm, "Date: %s\r\n", datestr);
+    if (strchr(src->fromaddr, '<'))
+        buf_printf(&header, "From: %s\r\n", src->fromaddr);
+    else
+        buf_printf(&header, "From: <%s>\r\n", src->fromaddr);
 
-    fprintf(sm, "X-Sieve: %s\r\n", SIEVE_VERSION);
-    fprintf(sm, "From: <%s>\r\n", src->fromaddr);
-    fprintf(sm, "To: <%s>\r\n", src->addr);
+    buf_printf(&header, "To: <%s>\r\n", src->addr);
     /* check that subject is sane */
     sl = strlen(src->subj);
     for (i = 0; i < sl; i++)
@@ -709,32 +1574,42 @@ static int send_response(void *ac,
             src->subj[i] = '\0';
             break;
         }
-    subj = charset_encode_mimeheader(src->subj, strlen(src->subj));
-    fprintf(sm, "Subject: %s\r\n", subj);
+    subj = charset_encode_mimeheader(src->subj, strlen(src->subj), 0);
+    buf_printf(&header, "Subject:%s %s\r\n",  /* fold before long header body */
+               strlen(subj) > 69 ? "\r\n" : "", subj);
     free(subj);
-    if (md->id) fprintf(sm, "In-Reply-To: %s\r\n", md->id);
-    fprintf(sm, "Auto-Submitted: auto-replied (vacation)\r\n");
-    fprintf(sm, "MIME-Version: 1.0\r\n");
+    if (md->id) buf_printf(&header, "In-Reply-To: %s\r\n", md->id);
+    buf_printf(&header, "Auto-Submitted: auto-replied (vacation)\r\n");
+    buf_printf(&header, "MIME-Version: 1.0\r\n");
     if (src->mime) {
-        fprintf(sm, "Content-Type: multipart/mixed;"
+        buf_printf(&header, "Content-Type: multipart/mixed;"
                 "\r\n\tboundary=\"%d/%s\"\r\n", (int) p, config_servername);
-        fprintf(sm, "\r\nThis is a MIME-encapsulated message\r\n\r\n");
-        fprintf(sm, "--%d/%s\r\n", (int) p, config_servername);
+        buf_printf(&header, "\r\n");
+        buf_printf(&header, "This is a MIME-encapsulated message\r\n");
+        buf_printf(&header, "\r\n--%d/%s\r\n", (int) p, config_servername);
     } else {
-        fprintf(sm, "Content-Type: text/plain; charset=utf-8\r\n");
-        fprintf(sm, "Content-Transfer-Encoding: 8bit\r\n");
-        fprintf(sm, "\r\n");
+        buf_printf(&header, "Content-Type: text/plain; charset=utf-8\r\n");
+        buf_printf(&header, "Content-Transfer-Encoding: 8bit\r\n");
+        buf_printf(&header, "\r\n");
     }
 
-    fprintf(sm, "%s\r\n", src->msg);
-
+    buf_printf(&footer, "\r\n");
     if (src->mime) {
-        fprintf(sm, "\r\n--%d/%s--\r\n", (int) p, config_servername);
+        buf_printf(&footer, "\r\n--%d/%s--\r\n", (int) p, config_servername);
+    }
+
+    buf_append(&msgbuf, &header);
+    buf_appendcstr(&msgbuf, src->msg);
+    buf_append(&msgbuf, &footer);
+
+    r = smtpclient_open(&sm);
+    if (!r) {
+        smtpclient_set_auth(sm, ctx->userid);
+        r = smtpclient_send(sm, &sm_env, &msgbuf);
     }
-    fclose(sm);
-    while (waitpid(sm_pid, &sm_stat, 0) < 0);
+    smtpclient_close(&sm);
 
-    if (sm_stat == 0) { /* sendmail exit value */
+    if (r == 0) {
         sievedb = make_sieve_db(mbname_recipient(sdata->mbname, ((deliver_data_t *) mc)->ns));
 
         dkey.id = outmsgid;
@@ -742,13 +1617,25 @@ static int send_response(void *ac,
         dkey.date = ((deliver_data_t *) mc)->m->date;
         duplicate_mark(&dkey, t, 0);
 
+        if (src->fcc.mailbox) {
+            do_fcc(sdata, &src->fcc, &header, src->msg, &footer);
+        }
+
+        prometheus_increment(CYRUS_LMTP_SIEVE_AUTORESPOND_SENT_TOTAL);
         snmp_increment(SIEVE_VACATION_REPLIED, 1);
 
-        return SIEVE_OK;
+        ret = SIEVE_OK;
     } else {
-        *errmsg = sendmail_errstr(sm_stat);
-        return SIEVE_FAIL;
+        *errmsg = error_message(r);
+        ret = SIEVE_FAIL;
     }
+
+    buf_free(&header);
+    buf_free(&footer);
+    buf_free(&msgbuf);
+    smtp_envelope_fini(&sm_env);
+
+    return ret;
 }
 
 /* vacation support */
@@ -759,6 +1646,95 @@ static sieve_vacation_t vacation = {
     &send_response,             /* send_response() */
 };
 
+static int sieve_duplicate_check(void *dc,
+                                 void *ic __attribute__((unused)),
+                                 void *sc,
+                                 void *mc __attribute__((unused)),
+                                 const char **errmsg __attribute__((unused)))
+{
+    sieve_duplicate_context_t *dtc = (sieve_duplicate_context_t *) dc;
+    script_data_t *sd = (script_data_t *) sc;
+    time_t t, now = time(NULL);;
+    duplicate_key_t dkey = DUPLICATE_INITIALIZER;
+
+    dkey.id = dtc->id;
+    dkey.to = make_sieve_db(mbname_userid(sd->mbname));
+    dkey.date = "";  /* no date on these, ID is custom */
+    t = duplicate_check(&dkey);
+
+    if (t && now < t) {
+        /* active tracking record */
+        duplicate_log(&dkey, "sieve-duplicate");
+        return 1;
+    }
+
+    /* no active tracking record */
+    return 0;
+}
+
+static int sieve_duplicate_track(void *dc,
+                                 void *ic __attribute__((unused)),
+                                 void *sc,
+                                 void *mc __attribute__((unused)),
+                                 const char **errmsg __attribute__((unused)))
+{
+    sieve_duplicate_context_t *dtc = (sieve_duplicate_context_t *) dc;
+    script_data_t *sd = (script_data_t *) sc;
+    time_t now = time(NULL);
+    duplicate_key_t dkey = DUPLICATE_INITIALIZER;
+
+    dkey.id = dtc->id;
+    dkey.to = make_sieve_db(mbname_userid(sd->mbname));
+    dkey.date = "";  /* no date on these, ID is custom */
+    duplicate_mark(&dkey, now + dtc->seconds, 0);
+
+    return SIEVE_OK;
+}
+
+/* duplicate support */
+static sieve_duplicate_t duplicate = {
+    0, /* max expiration */
+    &sieve_duplicate_check,
+    &sieve_duplicate_track,
+};
+
+#ifdef WITH_JMAP
+#include "jmap_mail_query.h"
+
+static int jmapquery(void *sc, void *mc, const char *json)
+{
+    script_data_t *sd = (script_data_t *) sc;
+    message_data_t *md = ((deliver_data_t *) mc)->m;
+    struct buf msg = BUF_INITIALIZER;
+    const char *userid = mbname_userid(sd->mbname);
+    json_error_t jerr;
+    json_t *jfilter, *err = NULL;
+    int r;
+
+    /* Create filter from json */
+    jfilter = json_loads(json, 0, &jerr);
+    if (!jfilter) return 0;
+
+    /* mmap the staged message file */
+    buf_refresh_mmap(&msg, 1, fileno(md->f), md->id, md->size, NULL);
+
+    /* Run query */
+    r = jmap_email_matchmime(&msg, jfilter, userid, time(NULL), &err);
+
+    if (err) {
+        char *errstr = json_dumps(err, JSON_COMPACT);
+        syslog(LOG_ERR, "sieve: jmapquery error: %s", errstr);
+        free(errstr);
+        r = SIEVE_RUN_ERROR;
+    }
+
+    json_decref(jfilter);
+    buf_free(&msg);
+
+    return r;
+}
+#endif
+
 static int sieve_parse_error_handler(int lineno, const char *msg,
                                      void *ic __attribute__((unused)),
                                      void *sc)
@@ -784,15 +1760,30 @@ static int sieve_execute_error_handler(c
     return SIEVE_OK;
 }
 
-sieve_interp_t *setup_sieve(void)
+void sieve_log(void *sc, void *mc, const char *text)
+{
+    script_data_t *sd = (script_data_t *) sc;
+    message_data_t *md = ((deliver_data_t *) mc)->m;
+
+    syslog(LOG_INFO, "sieve log: userid=%s messageid=%s text=%s",
+           mbname_userid(sd->mbname), md->id ? md->id : "(null)", text);
+}
+
+sieve_interp_t *setup_sieve(struct sieve_interp_ctx *ctx)
 {
     sieve_interp_t *interp = NULL;
     int res;
     static strarray_t mark = STRARRAY_INITIALIZER;
+    static strarray_t methods = STRARRAY_INITIALIZER;
 
     if (!mark.count)
         strarray_append(&mark, "\\flagged");
 
+    if (!methods.count) {
+        /* XXX  is there an imapd.conf option for this? */
+        strarray_append(&methods, "mailto:");
+    }
+
     sieve_usehomedir = config_getswitch(IMAPOPT_SIEVEUSEHOMEDIR);
     if (!sieve_usehomedir) {
         sieve_dir = config_getstring(IMAPOPT_SIEVEDIR);
@@ -800,7 +1791,7 @@ sieve_interp_t *setup_sieve(void)
         sieve_dir = NULL;
     }
 
-    interp = sieve_interp_alloc(NULL);
+    interp = sieve_interp_alloc(ctx);
     assert(interp != NULL);
 
     sieve_register_redirect(interp, &sieve_redirect);
@@ -809,23 +1800,47 @@ sieve_interp_t *setup_sieve(void)
     sieve_register_fileinto(interp, &sieve_fileinto);
     sieve_register_keep(interp, &sieve_keep);
     sieve_register_imapflags(interp, &mark);
-    sieve_register_notify(interp, &sieve_notify);
+    sieve_register_notify(interp, &sieve_notify, &methods);
     sieve_register_size(interp, &getsize);
     sieve_register_mailboxexists(interp, &getmailboxexists);
+    sieve_register_mailboxidexists(interp, &getmailboxidexists);
+    sieve_register_specialuseexists(interp, &getspecialuseexists);
     sieve_register_metadata(interp, &getmetadata);
     sieve_register_header(interp, &getheader);
+    sieve_register_addheader(interp, &addheader);
+    sieve_register_deleteheader(interp, &deleteheader);
     sieve_register_fname(interp, &getfname);
 
     sieve_register_envelope(interp, &getenvelope);
+    sieve_register_environment(interp, &getenvironment);
     sieve_register_body(interp, &getbody);
     sieve_register_include(interp, &getinclude);
 
+    sieve_register_logger(interp, &sieve_log); 
+
     res = sieve_register_vacation(interp, &vacation);
     if (res != SIEVE_OK) {
         syslog(LOG_ERR, "sieve_register_vacation() returns %d\n", res);
-        fatal("sieve_register_vacation()", EC_SOFTWARE);
+        fatal("sieve_register_vacation()", EX_SOFTWARE);
+    }
+
+    duplicate.max_expiration =
+        config_getduration(IMAPOPT_SIEVE_DUPLICATE_MAX_EXPIRATION, 's');
+    res = sieve_register_duplicate(interp, &duplicate);
+    if (res != SIEVE_OK) {
+        syslog(LOG_ERR, "sieve_register_duplicate() returns %d\n", res);
+        fatal("sieve_register_duplicate()", EX_SOFTWARE);
     }
 
+#ifdef WITH_DAV
+    sieve_register_extlists(interp, &listvalidator, &listcompare);
+#endif
+#ifdef WITH_JMAP
+    sieve_register_jmapquery(interp, &jmapquery);
+#endif
+#ifdef HAVE_JANSSON
+    sieve_register_snooze(interp, &sieve_snooze);
+#endif
     sieve_register_parse_error(interp, &sieve_parse_error_handler);
     sieve_register_execute_error(interp, &sieve_execute_error_handler);
 
@@ -930,6 +1945,7 @@ int run_sieve(const mbname_t *mbname, si
 
     sdata.mbname = mbname;
     sdata.ns = msgdata->ns;
+    sdata.edited_header = 0;
 
     if (mbname_userid(mbname)) {
         sdata.authstate = freeauthstate = auth_newstate(mbname_userid(mbname));
@@ -996,22 +2012,30 @@ static int autosieve_createfolder(const
         strarray_free(create);
     }
 
-    if (createsievefolder) {
-        /* Folder is already in internal namespace format */
-        r = mboxlist_createmailbox(internalname, 0, NULL,
-                                   0, userid, auth_state, 0, 0, 0, 1, NULL);
-        if (!r) {
-            mboxlist_changesub(internalname, userid, auth_state, 1, 1, 1);
-            syslog(LOG_DEBUG, "autosievefolder: User %s, folder %s creation succeeded",
-                   userid, internalname);
-            return 0;
-        } else {
-            syslog(LOG_ERR, "autosievefolder: User %s, folder %s creation failed. %s",
-                   userid, internalname, error_message(r));
-            return r;
-        }
+    // unless configured to create it, drop out now
+    if (!createsievefolder) return IMAP_MAILBOX_NONEXISTENT;
+
+    // lock the namespace and check again before trying to create
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(internalname);
+
+    // did we lose the race?
+    r = mboxlist_lookup(internalname, 0, 0);
+    if (r != IMAP_MAILBOX_NONEXISTENT) goto done;
+
+    r = mboxlist_createmailbox(internalname, 0, NULL,
+                               0, userid, auth_state, 0, 0, 0, 1, NULL);
+    if (r) {
+        syslog(LOG_ERR, "autosievefolder: User %s, folder %s creation failed. %s",
+               userid, internalname, error_message(r));
+        goto done;
     }
 
-    return IMAP_MAILBOX_NONEXISTENT;
+    mboxlist_changesub(internalname, userid, auth_state, 1, 1, 1);
+    syslog(LOG_DEBUG, "autosievefolder: User %s, folder %s creation succeeded",
+           userid, internalname);
+
+done:
+    mboxname_release(&namespacelock);
+    return r;
 }
 
diff -pruN 3.0.13-5/imap/lmtp_sieve.h 3.2.0-3/imap/lmtp_sieve.h
--- 3.0.13-5/imap/lmtp_sieve.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/lmtp_sieve.h	2020-04-24 02:03:00.000000000 +0000
@@ -46,7 +46,21 @@
 #include "lmtpd.h"
 #include "sieve/sieve_interface.h"
 
-sieve_interp_t *setup_sieve(void);
-int run_sieve(const mbname_t *mbname, sieve_interp_t *interp, deliver_data_t *mydata);
+#ifdef WITH_DAV
+#include "carddav_db.h"
+#else
+struct carddav_db { };
+#endif
+
+struct sieve_interp_ctx {
+    const char *userid;
+    struct carddav_db *carddavdb;
+};
+
+sieve_interp_t *setup_sieve(struct sieve_interp_ctx *ctx);
+int run_sieve(const mbname_t *mbname,
+              sieve_interp_t *interp, deliver_data_t *mydata);
+void sieve_srs_init(void);
+void sieve_srs_free(void);
 
 #endif /* LMTP_SIEVE_H */
diff -pruN 3.0.13-5/imap/lmtpstats.c 3.2.0-3/imap/lmtpstats.c
--- 3.0.13-5/imap/lmtpstats.c	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/imap/lmtpstats.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,521 +0,0 @@
-
-/* lmtpstats.c -- automatically generated from /home/ellie/fastmail/cyrus-imapd/imap/lmtpstats.snmp by snmpgen */
-
-
-
-#ifdef USING_SNMPGEN
-
-
-
-/* We disable this code for now since it doesn't actually work and wastes
-
- * resources.  At some point in time, we'll make it work again as it would
-
- * be useful to gather aggregate statistics on what commands are being used
-
- * so we can better tune the server.  This change closes bug #1191.
-
- * New bug 1267 opened to re-enable the feature.
-
- */
-
-
-
-#ifdef HAVE_UNISTD_H
-
-#include <unistd.h>
-
-#endif
-
-#include <stdio.h>
-
-#include <stdlib.h>
-
-#include <errno.h>
-
-#include <string.h>
-
-#include <sys/types.h>
-
-#include <sys/socket.h>
-
-#include <sys/un.h>
-
-#include <fcntl.h>
-
-#include <stdarg.h>
-
-
-
-#include "index.h"
-
-#include "lmtpstats.h"
-
-
-
-extern int close(int);
-
-
-
-int variable_value[2+1];
-
-int variable_tmpvalue[2+1];
-
-
-
-int varvalue(lmtpstats_variable_t var)
-
-{
-
-    if (variable_tmpvalue[var]!=-1)
-
-        return variable_tmpvalue[var];
-
-
-
-    return variable_value[var];
-
-}
-
-
-
-const char *snmp_getdescription(lmtpstats_t evt)
-
-{
-
-    switch (evt) {
-
-        case mtaTransmittedVolume: return "Kbytes stored to disk";
-        case AUTHENTICATION_NO: return "Failed authentication of given mechanism";
-        case SIEVE_REJECT: return "sieve rejects";
-        case SIEVE_MESSAGES_PROCESSED: return "Number of messages processed by Sieve scripts";
-        case mtaReceivedVolume: return "Kbytes received";
-        case mtaReceivedMessages: return "Messages we've received";
-        case SIEVE_KEEP: return "sieve messages kept";
-        case mtaTransmittedMessages: return "Messages stored to disk";
-        case SIEVE_VACATION_REPLIED: return "vacation messages sent";
-        case SIEVE_DISCARD: return "sieve discards";
-        case SIEVE_VACATION_TOTAL: return "vacation messages considered";
-        case SERVER_NAME_VERSION: return "Name and version string for server";
-        case SIEVE_NOTIFY: return "sieve notifications sent";
-        case SERVER_UPTIME: return "Amount of time server has been running";
-        case mtaReceivedRecipients: return "Recipients accepted";
-        case SIEVE_REDIRECT: return "sieve redirects";
-        case mtaSuccessfulConvertedMessages: return "Messages converted because of 8bit foo";
-        case SIEVE_FILEINTO: return "sieve fileintos";
-        case ACTIVE_CONNECTIONS: return "Count of the active number of connections";
-        case TOTAL_CONNECTIONS: return "Count of the total number of connections since the beginning of time";
-        case AUTHENTICATION_YES: return "Successful authentication of given mechanism";
-
-    }
-
-    return NULL;
-
-}
-
-
-
-const char *snmp_getoid(const char *name __attribute__((unused)),
-
-                        lmtpstats_t evt, char *buf, int buflen)
-
-{
-
-    switch (evt) {
-
-        case mtaTransmittedVolume: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.6",varvalue(VARIABLE_MTA)); return buf;
-        case AUTHENTICATION_NO: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.2.%d.1",varvalue(VARIABLE_AUTH)); return buf;
-        case SIEVE_REJECT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.3"); return buf;
-        case SIEVE_MESSAGES_PROCESSED: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.0"); return buf;
-        case mtaReceivedVolume: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.4",varvalue(VARIABLE_MTA)); return buf;
-        case mtaReceivedMessages: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.1",varvalue(VARIABLE_MTA)); return buf;
-        case SIEVE_KEEP: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.5"); return buf;
-        case mtaTransmittedMessages: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.3",varvalue(VARIABLE_MTA)); return buf;
-        case SIEVE_VACATION_REPLIED: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.7"); return buf;
-        case SIEVE_DISCARD: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.2"); return buf;
-        case SIEVE_VACATION_TOTAL: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.8"); return buf;
-        case SERVER_NAME_VERSION: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.3.0"); return buf;
-        case SIEVE_NOTIFY: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.6"); return buf;
-        case SERVER_UPTIME: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.3.1"); return buf;
-        case mtaReceivedRecipients: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.7",varvalue(VARIABLE_MTA)); return buf;
-        case SIEVE_REDIRECT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.1"); return buf;
-        case mtaSuccessfulConvertedMessages: snprintf(buf,buflen,"1.3.6.1.2.1.28.1.%d.10",varvalue(VARIABLE_MTA)); return buf;
-        case SIEVE_FILEINTO: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.3.4.4"); return buf;
-        case ACTIVE_CONNECTIONS: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.1.2"); return buf;
-        case TOTAL_CONNECTIONS: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.1.1"); return buf;
-        case AUTHENTICATION_YES: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.2.2.%d.0",varvalue(VARIABLE_AUTH)); return buf;
-
-    }
-
-    return NULL;
-
-}
-
-
-
-#define SOCK_PATH "/tmp/.snmp_door"
-
-
-
-static int mysock = -1;
-
-static struct sockaddr_un remote;
-
-static int sockaddr_len = 0;
-
-
-
-static void snmp_send(char *str)
-
-{
-
-    if (mysock == -1) return;
-
-
-
-    if (sendto(mysock, str, strlen(str), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return;
-
-    }
-
-
-
-    return;
-
-}
-
-
-
-int snmp_connect(void)
-
-{
-
-    int s;
-
-    int fdflags;
-
-    int lup;
-
-
-
-    if ((s = socket(AF_UNIX, SOCK_DGRAM, 0)) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    for (lup=0;lup < 2+1; lup++)
-
-        variable_tmpvalue[lup] = -1;
-
-
-
-    remote.sun_family = AF_UNIX;
-
-    strlcpy(remote.sun_path, SOCK_PATH, sizeof(remote.sun_path));
-
-    sockaddr_len = strlen(remote.sun_path) + sizeof(remote.sun_family);
-
-
-
-    /* put us in non-blocking mode */
-
-    fdflags = fcntl(s, F_GETFD, 0);
-
-    if (fdflags != -1) fdflags = fcntl(s, F_SETFL, O_NONBLOCK | fdflags);
-
-    if (fdflags == -1) { close(s); return -1; }
-
-
-
-    mysock = s;
-
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.2.1\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.2.2\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.2.3\n");
-    snmp_send("R 1.3.6.1.2.1.28.1\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.3.4\n");
-
-    return 0;
-
-}
-
-
-
-int snmp_close(void)
-
-{
-
-    if (mysock > -1)
-
-        close(mysock);
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_increment_args(lmtpstats_t cmd, int incr, ...)
-
-{
-
-    char tosend[256]; /* xxx UDP max size??? */
-
-    char buf[256];
-
-
-
-      va_list ap; /* varargs thing */
-
-      lmtpstats_variable_t vval;
-
-      int ival;
-
-
-
-      if (mysock == -1) return 1;
-
-
-
-      va_start(ap, incr);
-
-
-
-      do {
-
-          vval = va_arg(ap, lmtpstats_variable_t); /* get the next arg */
-
-
-
-          if (vval!=VARIABLE_LISTEND)
-
-          {
-
-              ival = va_arg(ap, int); /* get the next arg */
-
-              variable_tmpvalue[vval] = ival;
-
-          }
-
-
-
-      } while ( vval != VARIABLE_LISTEND);
-
-
-
-      va_end(ap);
-
-
-
-    snprintf(tosend, sizeof(tosend),"C %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), incr);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    /* set tmp variables back */
-
-    va_start(ap, incr);
-
-
-
-      do {
-
-          vval = va_arg(ap, lmtpstats_variable_t); /* get the next arg */
-
-
-
-          if (vval!=VARIABLE_LISTEND)
-
-          {
-
-              ival = va_arg(ap, int); /* get the next arg */
-
-              variable_tmpvalue[vval] = -1;
-
-          }
-
-
-
-      } while ( vval != VARIABLE_LISTEND);
-
-
-
-      va_end(ap);
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_increment(lmtpstats_t cmd, int incr)
-
-{
-
-    char tosend[256]; /* xxx UDP max size??? */
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"C %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), incr);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_set(lmtpstats_t cmd, int value)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"I %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), value);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-int snmp_set_str(lmtpstats_t cmd, char *value)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"S %s %s\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), value);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-int snmp_set_time(lmtpstats_t cmd, time_t t)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"T %s %lu\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), t);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-/* should use SNMPDEFINE's as parameter */
-
-int snmp_set_oid(lmtpstats_t cmd, char *str)
-
-{
-
-   return snmp_set_str(cmd,str);
-
-}
-
-
-
-void snmp_setvariable(lmtpstats_variable_t name, int value)
-
-{
-
-    variable_value[name] = value;
-
-}
-
-
-
-#endif
-
-
-
-
-
diff -pruN 3.0.13-5/imap/lmtpstats.h 3.2.0-3/imap/lmtpstats.h
--- 3.0.13-5/imap/lmtpstats.h	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/imap/lmtpstats.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,160 +0,0 @@
-
-/* lmtpstats.h -- statistics push interface
-
- * generated automatically from /home/ellie/fastmail/cyrus-imapd/imap/lmtpstats.snmp by snmpgen
-
- *
-
- * Copyright 2000 Carnegie Mellon University
-
- *
-
- * No warranty, yadda yadda
-
- */
-
-
-
-#ifndef lmtpstats_H
-
-#define lmtpstats_H
-
-
-
-#define SNMPDEFINE_cmusieve "1.3.6.1.4.1.3.2.2.3.3"
-#define SNMPDEFINE_cmutree "1.3.6.1.4.1.3.2.2.3"
-#define SNMPDEFINE_mgmt "1.3.6.1.2"
-#define SNMPDEFINE_mib2 "1.3.6.1.2.1"
-#define SNMPDEFINE_cmulmtp "1.3.6.1.4.1.3.2.2.3.2"
-#define SNMPDEFINE_mtamib "1.3.6.1.2.1.28"
-
-
-
-#ifndef USING_SNMPGEN
-
-
-
-#define snmp_connect()
-
-#define snmp_close()
-
-#define snmp_increment(a, b)
-
-#define snmp_increment_args(a, b, c, d, e)
-
-#define snmp_set(a, b)
-
-#define snmp_set_str(a, b)
-
-#define snmp_set_oid(a, b)
-
-#define snmp_set_time(a, b)
-
-#define snmp_getdescription(a)
-
-#define snmp_getoid(a, b, c, d)
-
-#define snmp_setvariable(a, b)
-
-
-
-typedef void lmtpstats_t;
-
-
-
-#else
-
-
-
-typedef enum {
-
-    mtaTransmittedVolume,
-    AUTHENTICATION_NO,
-    SIEVE_REJECT,
-    SIEVE_MESSAGES_PROCESSED,
-    mtaReceivedVolume,
-    mtaReceivedMessages,
-    SIEVE_KEEP,
-    mtaTransmittedMessages,
-    SIEVE_VACATION_REPLIED,
-    SIEVE_DISCARD,
-    SIEVE_VACATION_TOTAL,
-    SERVER_NAME_VERSION,
-    SIEVE_NOTIFY,
-    SERVER_UPTIME,
-    mtaReceivedRecipients,
-    SIEVE_REDIRECT,
-    mtaSuccessfulConvertedMessages,
-    SIEVE_FILEINTO,
-    ACTIVE_CONNECTIONS,
-    TOTAL_CONNECTIONS,
-    AUTHENTICATION_YES
-} lmtpstats_t;
-
-
-
-typedef enum {
-
-    VARIABLE_LISTEND,
-    VARIABLE_AUTH,
-    VARIABLE_MTA
-
-
-} lmtpstats_variable_t;
-
-
-
-int snmp_connect(void);
-
-
-
-int snmp_close(void);
-
-
-
-/* only valid on counters */
-
-int snmp_increment(lmtpstats_t cmd, int);
-
-int snmp_increment_args(lmtpstats_t cmd, int incr, ...);
-
-
-
-/* only valid on values */
-
-int snmp_set(lmtpstats_t cmd, int);
-
-
-
-int snmp_set_str(lmtpstats_t cmd, char *value);
-
-
-
-int snmp_set_oid(lmtpstats_t cmd, char *str);
-
-
-
-int snmp_set_time(lmtpstats_t cmd, time_t t);
-
-
-
-const char *snmp_getdescription(lmtpstats_t cmd);
-
-
-
-const char *snmp_getoid(const char *name, lmtpstats_t cmd, char* buf, int buflen);
-
-
-
-void snmp_setvariable(lmtpstats_variable_t, int);
-
-
-
-#endif /* USING_SNMPGEN */
-
-
-
-#endif /* lmtpstats_H */
-
-
-
diff -pruN 3.0.13-5/imap/lmtpstats.snmp 3.2.0-3/imap/lmtpstats.snmp
--- 3.0.13-5/imap/lmtpstats.snmp	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/imap/lmtpstats.snmp	2020-04-24 02:03:00.000000000 +0000
@@ -106,6 +106,7 @@ C,SIEVE_REDIRECT        ,"sieve redirect
 C,SIEVE_DISCARD         ,"sieve discards",auto
 C,SIEVE_REJECT          ,"sieve rejects",auto
 C,SIEVE_FILEINTO        ,"sieve fileintos",auto
+C,SIEVE_SNOOZE          ,"sieve snoozes",auto
 C,SIEVE_KEEP            ,"sieve messages kept",auto
 C,SIEVE_NOTIFY          ,"sieve notifications sent",auto
 C,SIEVE_VACATION_REPLIED,"vacation messages sent",auto
diff -pruN 3.0.13-5/imap/mailbox.c 3.2.0-3/imap/mailbox.c
--- 3.0.13-5/imap/mailbox.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mailbox.c	2020-05-04 03:28:02.000000000 +0000
@@ -54,6 +54,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <utime.h>
 
@@ -86,7 +87,6 @@
 #endif /* WITH_DAV */
 #include "crc32.h"
 #include "md5.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "imparse.h"
 #include "cyr_lock.h"
@@ -105,7 +105,6 @@
 #include "statuscache.h"
 #include "strarray.h"
 #include "sync_log.h"
-#include "vcard_support.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "xstrlcat.h"
@@ -119,6 +118,10 @@
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
+#include "imap/mailbox_header_cache.h"
+
+static mailbox_wait_cb_t *mailbox_wait_cb = NULL;
+static void *mailbox_wait_cb_rock = NULL;
 
 struct mailboxlist {
     struct mailboxlist *next;
@@ -137,14 +140,33 @@ static struct mailboxlist *open_mailboxe
 /* for repack */
 struct mailbox_repack {
     struct mailbox *mailbox;
-    struct index_header i;
+    struct mailbox newmailbox;
     struct seqset *seqset;
+    struct synccrcs crcs;
     char *userid;
-    int old_version;
-    int newindex_fd;
     ptrarray_t caches;
 };
 
+static struct MsgFlagMap msgflagmap[] = {
+    {"AN", (int)FLAG_ANSWERED},
+    {"FL", (int)FLAG_FLAGGED},
+    {"DE", (int)FLAG_DELETED},
+    {"DR", (int)FLAG_DRAFT},
+    {"SE", (int)FLAG_SEEN},
+    {"SN", (int)FLAG_INTERNAL_SNOOZED},
+    {"SP", (int)FLAG_INTERNAL_SPLITCONVERSATION},
+    {"NC", (int)FLAG_INTERNAL_NEEDS_CLEANUP},
+    {"AR", (int)FLAG_INTERNAL_ARCHIVED},
+    {"UN", (int)FLAG_INTERNAL_UNLINKED},
+    {"EX", (int)FLAG_INTERNAL_EXPUNGED}
+    /* ZZ -> invalid file found on disk */
+};
+/* The length of the msgflagmap list * 2 +
+ * Total number of separators possible
+ * = 33 bytes
+ */
+#define FLAGMAPSTR_MAXLEN (1 + 3 *(sizeof(msgflagmap) / sizeof(struct MsgFlagMap)))
+
 static int mailbox_index_unlink(struct mailbox *mailbox);
 static int mailbox_index_repack(struct mailbox *mailbox, int version);
 static void mailbox_repack_abort(struct mailbox_repack **repackptr);
@@ -160,6 +182,42 @@ static int mailbox_abort_dav(struct mail
 static int mailbox_delete_dav(struct mailbox *mailbox);
 #endif
 
+static inline void flags_to_str_internal(uint32_t flags, char *flagstr)
+{
+    size_t i, len = 0;
+    size_t map_size;
+    char *p;
+
+    p = flagstr;
+    memset(p, 0, FLAGMAPSTR_MAXLEN);
+    map_size = sizeof(msgflagmap) / sizeof(struct MsgFlagMap);
+
+    for (i = 0; i <  map_size && len < FLAGMAPSTR_MAXLEN; i++) {
+        if (flags & msgflagmap[i].flag) {
+            if (p != flagstr) {
+                *p++ = '|';
+                len++;
+            }
+
+            *p++ = msgflagmap[i].code[0];
+            *p++ = msgflagmap[i].code[1];
+            len += 2;
+        }
+    }
+}
+
+static void flags_to_str(struct index_record *record, char *flagstr)
+{
+    uint32_t flags = record->system_flags | record->internal_flags;
+
+    flags_to_str_internal(flags, flagstr);
+}
+
+EXPORTED int open_mailboxes_exist()
+{
+    return open_mailboxes ? 1 : 0;
+}
+
 static struct mailboxlist *create_listitem(const char *name)
 {
     struct mailboxlist *item = xmalloc(sizeof(struct mailboxlist));
@@ -216,7 +274,7 @@ static void remove_listitem(struct mailb
         previtem = item;
     }
 
-    fatal("didn't find item in list", EC_SOFTWARE);
+    fatal("didn't find item in list", EX_SOFTWARE);
 }
 
 EXPORTED const char *mailbox_meta_fname(struct mailbox *mailbox, int metafile)
@@ -272,7 +330,7 @@ EXPORTED const char *mailbox_record_fnam
     object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED) ;
 #endif
 
-    if (!object_storage_enabled && (record->system_flags & FLAG_ARCHIVED))
+    if (!object_storage_enabled && (record->internal_flags & FLAG_INTERNAL_ARCHIVED))
         return mailbox_archive_fname(mailbox, record->uid);
     else
         return mailbox_spool_fname(mailbox, record->uid);
@@ -291,87 +349,6 @@ EXPORTED const char *mailbox_datapath(st
 }
 
 /*
- * Names of the headers we cache in the cyrus.cache file.
- *
- * Changes to this list probably require bumping the cache version
- * number (obviously)
- *
- * note that header names longer than MAX_CACHED_HEADER_SIZE
- * won't be cached regardless
- *
- * xxx can we get benefits by requireing this list to be sorted?
- * (see is_cached_header())
- *
- */
-const struct mailbox_header_cache mailbox_cache_headers[] = {
-    /* things we have always cached */
-    { "priority", 0 },
-    { "references", 0 },
-    { "resent-from", 0 },
-    { "newsgroups", 0 },
-    { "followup-to", 0 },
-
-    /* x headers that we may want to cache anyway */
-    { "x-mailer", 1 },
-    { "x-trace", 1 },
-
-    /* outlook express seems to want these */
-    { "x-ref", 2  },
-    { "x-priority", 2 },
-    { "x-msmail-priority", 2 },
-    { "x-msoesrec", 2 },
-
-    /* for efficient FastMail interface display */
-    { "x-spam-score", 3 },
-    { "x-resolved-to", 3 },
-    { "x-delivered-to", 3 },
-    { "x-mail-from", 3 },
-    { "x-truedomain-domain", 3 },
-
-    /* for conversations */
-    { "x-me-message-id", 4 },
-
-    /* for delivery matching */
-    { "x-cyrus-session-id", 4 },
-
-    /* things to never cache */
-    { "bcc", BIT32_MAX },
-    { "cc", BIT32_MAX },
-    { "date", BIT32_MAX },
-    { "delivery-date", BIT32_MAX },
-    { "envelope-to", BIT32_MAX },
-    { "from", BIT32_MAX },
-    { "in-reply-to", BIT32_MAX },
-    { "mime-version", BIT32_MAX },
-    { "reply-to", BIT32_MAX },
-    { "received", BIT32_MAX },
-    { "return-path", BIT32_MAX },
-    { "sender", BIT32_MAX },
-    { "subject", BIT32_MAX },
-    { "to", BIT32_MAX },
-
-    /* signatures tend to be large, and are useless without the body */
-    { "dkim-signature", BIT32_MAX },
-    { "domainkey-signature", BIT32_MAX },
-    { "domainkey-x509", BIT32_MAX },
-
-    /* older versions of PINE (before 4.56) need message-id in the cache too
-     * though technically it is a waste of space because it is in
-     * ENVELOPE.  We should probably uncomment the following at some
-     * future point [ken3 notes this may also be useful to have here for
-     * threading so we can avoid parsing the envelope] */
-    /* { "message-id", BIT32_MAX }, */
-
-    /* apple-specific headers that their clients fetch frequently */
-    { "x-universally-unique-identifier", 6 },
-    { "x-uniform-type-identifier", 6 },
-    { "x-apple-base-url", 6 },
-    { "x-apple-mail-remote-attachments", 6 },
-};
-const int MAILBOX_NUM_CACHE_HEADERS =
-  sizeof(mailbox_cache_headers)/sizeof(struct mailbox_header_cache);
-
-/*
  *  Function to test if a header is in the cache
  *
  *  Assume cache entry version 1, unless other data is found
@@ -379,16 +356,21 @@ const int MAILBOX_NUM_CACHE_HEADERS =
  */
 static inline unsigned is_cached_header(const char *hdr)
 {
-    int i;
+    size_t len;
+    struct mailbox_header_cache *thdr;
 
-    /* xxx if we can sort the header list we can do better here */
-    for (i=0; i<MAILBOX_NUM_CACHE_HEADERS; i++) {
-        if (!strcmp(mailbox_cache_headers[i].name, hdr))
-            return mailbox_cache_headers[i].min_cache_version;
-    }
+    len = strlen(hdr);
+    if (len >= MAX_CACHED_HEADER_SIZE)
+        return BIT32_MAX;
+
+    thdr = mailbox_header_cache_lookup(hdr, len);
+
+    if (thdr)
+        return thdr->min_cache_version;
 
     /* Don't Cache X- headers unless explicitly configured to*/
-    if ((hdr[0] == 'x') && (hdr[1] == '-')) return BIT32_MAX;
+    if (((hdr[0] == 'x') || (hdr[0] == 'X')) &&
+        (hdr[1] == '-')) return BIT32_MAX;
 
     /* Everything else we cache in version 1 */
     return 1;
@@ -401,19 +383,7 @@ static inline unsigned is_cached_header(
  */
 EXPORTED unsigned mailbox_cached_header(const char *s)
 {
-    char hdr[MAX_CACHED_HEADER_SIZE];
-    int i;
-
-    /* Generate lower case copy of string */
-    /* xxx sometimes the caller has already generated this ..
-     * maybe we can just require callers to do it? */
-    for (i=0 ; *s && (i < (MAX_CACHED_HEADER_SIZE - 1)) ; i++)
-        hdr[i] = tolower(*s++);
-
-    if (*s) return BIT32_MAX;   /* Input too long for match */
-    hdr[i] = '\0';
-
-    return is_cached_header(hdr);
+    return is_cached_header(s);
 }
 
 /* Same as mailbox_cached_header, but for use on a header
@@ -432,7 +402,7 @@ HIDDEN unsigned mailbox_cached_header_in
             buf[i] = '\0';
             return is_cached_header(buf);
         } else {
-            buf[i] = tolower(text[i]);
+            buf[i] = text[i];
         }
     }
 
@@ -486,7 +456,7 @@ EXPORTED struct buf *cacheitem_buf(const
 /* parse a single cache record from the mapped file - creates buf
  * records which point into the map, so you can't free it while
  * you still have them around! */
-static int cache_parserecord(struct mappedfile *cachefile, size_t cache_offset,
+static int cache_parserecord(struct mappedfile *cachefile, uint64_t cache_offset,
                              struct cacherecord *crec)
 {
     const struct buf *buf = mappedfile_buf(cachefile);
@@ -631,7 +601,7 @@ static struct mappedfile *mailbox_cachef
 {
     const char *fname;
 
-    if (record->system_flags & FLAG_ARCHIVED)
+    if (record->internal_flags & FLAG_INTERNAL_ARCHIVED)
         fname = mailbox_meta_fname(mailbox, META_ARCHIVECACHE);
     else
         fname = mailbox_meta_fname(mailbox, META_CACHE);
@@ -644,12 +614,12 @@ static struct mappedfile *repack_cachefi
 {
     const char *fname;
 
-    if (record->system_flags & FLAG_ARCHIVED)
+    if (record->internal_flags & FLAG_INTERNAL_ARCHIVED)
         fname = mailbox_meta_newfname(repack->mailbox, META_ARCHIVECACHE);
     else
         fname = mailbox_meta_newfname(repack->mailbox, META_CACHE);
 
-    return cache_getfile(&repack->caches, fname, /*readonly*/0, repack->i.generation_no);
+    return cache_getfile(&repack->caches, fname, /*readonly*/0, repack->newmailbox.i.generation_no);
 }
 
 /* return the offset for the start of the record! */
@@ -694,12 +664,19 @@ static int mailbox_append_cache(struct m
     return 0;
 }
 
-EXPORTED int mailbox_cacherecord(struct mailbox *mailbox,
-                                 const struct index_record *record)
+enum mbcache_rewrite_t {
+    MBCACHE_NOPARSE,
+    MBCACHE_PARSEONLY,
+    MBCACHE_REWRITE
+};
+
+static int mailbox_cacherecord_internal(struct mailbox *mailbox,
+                                        const struct index_record *record,
+                                        enum mbcache_rewrite_t rewrite)
 {
     struct mappedfile *cachefile;
-    bit32 crc;
-    int r = 0;
+    bit32 crc = 0;
+    int r = IMAP_IOERROR;
 
     /* we do something nasty here to work around lazy loading while still
      * giving const protection to records which are only used for read */
@@ -741,32 +718,49 @@ err:
         syslog(LOG_ERR, "IOERROR: missing cache offset for %s uid %u",
                mailbox->name, record->uid);
     else if (r)
-        syslog(LOG_ERR, "IOERROR: invalid cache record for %s uid %u (%s)",
-               mailbox->name, record->uid, error_message(r));
+        syslog(LOG_ERR, "IOERROR: invalid cache record for %s uid %u (%s) %d at %llu",
+               mailbox->name, record->uid, error_message(r), crc, (long long unsigned)record->cache_offset);
+
+    if (rewrite == MBCACHE_NOPARSE)
+        return r;
 
     /* parse the file again */
-    {
-        /* parse directly into the cache for this record */
-        const char *fname = mailbox_record_fname(mailbox, record);
-        if (!fname) {
-            syslog(LOG_ERR, "IOERROR: no spool file for %s uid %u",
-                   mailbox->name, record->uid);
-            return IMAP_IOERROR;
-        }
 
-        r = message_parse(fname, backdoor);
+    /* parse directly into the cache for this record */
+    const char *fname = mailbox_record_fname(mailbox, record);
+    if (!fname) {
+        syslog(LOG_ERR, "IOERROR: no spool file for %s uid %u",
+               mailbox->name, record->uid);
+        return IMAP_IOERROR;
+    }
+
+    /* parse into the file and zero the cache offset */
+    r = message_parse(fname, backdoor);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: failed to parse message for %s uid %u",
+               mailbox->name, record->uid);
+        return r;
+    }
+    backdoor->cache_offset = 0;
+
+    if (rewrite == MBCACHE_REWRITE) {
+        r = mailbox_append_cache(mailbox, backdoor);
         if (r) {
-            syslog(LOG_ERR, "IOERROR: failed to parse message for %s uid %u",
+            syslog(LOG_ERR, "IOERROR: failed to append cache for %s uid %u",
                    mailbox->name, record->uid);
             return r;
         }
-
-        backdoor->cache_offset = 0;
     }
 
     return 0;
 }
 
+EXPORTED int mailbox_cacherecord(struct mailbox *mailbox, const struct index_record *record)
+{
+    enum mbcache_rewrite_t rewrite = mailbox_index_islocked(mailbox, 1) ? MBCACHE_REWRITE : MBCACHE_PARSEONLY;
+    return mailbox_cacherecord_internal(mailbox, record, rewrite);
+}
+
 static int mailbox_abort_cache(struct mailbox *mailbox)
 {
     if (!mailbox->caches.count)
@@ -837,10 +831,10 @@ static int _map_local_record(const struc
 
     if (fstat(msgfd, &sbuf) == -1) {
         syslog(LOG_ERR, "IOERROR: fstat on %s: %m", fname);
-        fatal("can't fstat message file", EC_OSFILE);
+        fatal("can't fstat message file", EX_OSFILE);
     }
 
-    buf_init_mmap(buf, /*onceonly*/1, msgfd, fname, sbuf.st_size, mailbox->name);
+    buf_refresh_mmap(buf, /*onceonly*/1, msgfd, fname, sbuf.st_size, mailbox->name);
     close(msgfd);
 
     return 0;
@@ -981,7 +975,8 @@ static int mailbox_open_advanced(const c
     if (r) {
         /* locked is not an error - just means we asked for NONBLOCKING */
         if (r != IMAP_MAILBOX_LOCKED)
-            syslog(LOG_ERR, "IOERROR: locking %s: %m", mailbox->name);
+            syslog(LOG_ERR, "IOERROR: locking %s: %s",
+                   mailbox->name, error_message(r));
         goto done;
     }
 
@@ -1007,6 +1002,7 @@ static int mailbox_open_advanced(const c
      * we will just use what we were passed */
     mailbox->acl = xstrdup(mbentry->acl);
     mailbox->mbtype = mbentry->mbtype;
+    mailbox->foldermodseq = mbentry->foldermodseq;
 
     mboxlist_entry_free(&mbentry);
 
@@ -1095,27 +1091,33 @@ EXPORTED int mailbox_setversion(struct m
     if (version && mailbox->i.minor_version != version) {
         /* need to re-set the version! */
         struct mailboxlist *listitem = find_listitem(mailbox->name);
-        int r;
+
         assert(listitem);
+        assert(&listitem->m == mailbox);
 
-        /* release any existing locks */
+        /* we need an exclusive lock on the listitem because we're renaming
+         * index files, so release locks and then go full exclusive */
         mailbox_unlock_index(mailbox, NULL);
+        r = mailbox_mboxlock_reopen(listitem, LOCK_EXCLUSIVE);
 
-        r = mailbox_mboxlock_reopen(listitem, LOCK_NONBLOCKING);
         /* we need to re-open the index because we dropped the mboxname lock,
          * so the file may have changed */
         if (!r) r = mailbox_open_index(mailbox);
+
         /* lock_internal so DELETED doesn't cause it to appear to be
          * NONEXISTENT */
         if (!r) r = mailbox_lock_index_internal(mailbox, LOCK_EXCLUSIVE);
+
+        /* perform the actual repack! */
         if (!r) r = mailbox_index_repack(mailbox, version);
 
-        /* and let's just update the counts too */
+        /* NOTE: this leaves the mailbox in an unlocked state internally, so
+         * let's release all the acutal locks */
         mailbox_unlock_index(mailbox, NULL);
-        if (!r) r = mailbox_mboxlock_reopen(listitem, LOCK_EXCLUSIVE);
-        if (!r) r = mailbox_open_index(mailbox);
-        if (!r) r = mailbox_lock_index_internal(mailbox, LOCK_EXCLUSIVE);
-        if (!r) r = mailbox_index_recalc(mailbox);
+
+        /* we're also still holding an exclusive namelock in the listitem,
+         * but that's OK because the only caller will be calling mailbox_close
+         * immediately afterwards */
     }
 
     return r;
@@ -1329,18 +1331,13 @@ done:
 }
 
 /* set a new ACL - only dirty if changed */
-EXPORTED int mailbox_set_acl(struct mailbox *mailbox, const char *acl,
-                    int dirty_modseq)
+EXPORTED int mailbox_set_acl(struct mailbox *mailbox, const char *acl)
 {
-    if (mailbox->acl) {
-        if (!strcmp(mailbox->acl, acl))
-            return 0; /* no change */
-        free(mailbox->acl);
-    }
+    if (!strcmpsafe(mailbox->acl, acl))
+        return 0; /* no change */
+    free(mailbox->acl);
     mailbox->acl = xstrdup(acl);
     mailbox->header_dirty = 1;
-    if (dirty_modseq)
-        mailbox_modseq_dirty(mailbox);
     return 0;
 }
 
@@ -1375,9 +1372,6 @@ EXPORTED int mailbox_user_flag(struct ma
     int userflag;
     int emptyflag = -1;
 
-    if (!imparse_isatom(flag))
-        return IMAP_INVALID_IDENTIFIER;
-
     for (userflag = 0; userflag < MAX_USER_FLAGS; userflag++) {
         if (mailbox->flagname[userflag]) {
             if (!strcasecmp(flag, mailbox->flagname[userflag]))
@@ -1406,6 +1400,9 @@ EXPORTED int mailbox_user_flag(struct ma
         if (!mailbox_index_islocked(mailbox, 1))
             return IMAP_MAILBOX_LOCKED;
 
+        if (!imparse_isatom(flag))
+            return IMAP_INVALID_IDENTIFIER;
+
         /* set the flag and mark the header dirty */
         userflag = emptyflag;
         mailbox->flagname[userflag] = xstrdup(flag);
@@ -1507,22 +1504,22 @@ EXPORTED strarray_t *mailbox_extract_fla
 static int load_annot_cb(const char *mailbox __attribute__((unused)),
                          uint32_t uid __attribute__((unused)),
                          const char *entry, const char *userid,
-                         const struct buf *value, void *rock)
+                         const struct buf *value,
+                         const struct annotate_metadata *mdata __attribute__((unused)),
+                         void *rock)
 {
     struct entryattlist **eal = (struct entryattlist **)rock;
-    if (!userid) userid = "";
     const char *attrib = (userid[0] ? "value.priv" : "value.shared");
     setentryatt(eal, entry, attrib, value);
     return 0;
 }
 
-
 EXPORTED struct entryattlist *mailbox_extract_annots(const struct mailbox *mailbox,
                                                      const struct index_record *record)
 {
     struct entryattlist *annots = NULL;
-    int r = annotatemore_findall(mailbox->name, record->uid, "*",
-                                 load_annot_cb, &annots);
+    int r = annotatemore_findall(mailbox->name, record->uid, "*", /*modseq*/0,
+                                 load_annot_cb, &annots, /*flags*/0);
     if (r) return NULL;
     return annots;
 }
@@ -1532,7 +1529,7 @@ static int mailbox_buf_to_index_header(c
 {
     uint32_t crc;
     bit32 qannot;
-    size_t minlen;
+    size_t headerlen;
 
     if (len < OFFSET_MINOR_VERSION+4)
         return IMAP_MAILBOX_BADFORMAT;
@@ -1545,24 +1542,30 @@ static int mailbox_buf_to_index_header(c
     switch (i->minor_version) {
     case 6:
     case 7:
-        minlen = 76;
+        headerlen = 76;
         break;
     case 8:
-        minlen = 92;
+        headerlen = 92;
         break;
     case 9:
     case 10:
-        minlen = 96;
+        headerlen = 96;
         break;
     case 12:
     case 13:
-        minlen = 128;
+        headerlen = 128;
+        break;
+    case 14:
+    case 15:
+    case 16:
+        headerlen = 160;
         break;
     default:
         return IMAP_MAILBOX_BADFORMAT;
     }
-    if (len < minlen)
+    if (len < headerlen)
         return IMAP_MAILBOX_BADFORMAT;
+
     i->start_offset = ntohl(*((bit32 *)(buf+OFFSET_START_OFFSET)));
     i->record_size = ntohl(*((bit32 *)(buf+OFFSET_RECORD_SIZE)));
     i->num_records = ntohl(*((bit32 *)(buf+OFFSET_NUM_RECORDS)));
@@ -1577,8 +1580,10 @@ static int mailbox_buf_to_index_header(c
     i->options = ntohl(*((bit32 *)(buf+OFFSET_MAILBOX_OPTIONS)));
     i->leaked_cache_records = ntohl(*((bit32 *)(buf+OFFSET_LEAKED_CACHE)));
     if (i->minor_version < 8) goto done;
+
     i->highestmodseq = align_ntohll(buf+OFFSET_HIGHESTMODSEQ);
     if (i->minor_version < 12) goto done;
+
     i->deletedmodseq = align_ntohll(buf+OFFSET_DELETEDMODSEQ);
     i->exists = ntohl(*((bit32 *)(buf+OFFSET_EXISTS)));
     i->first_expunged = ntohl(*((bit32 *)(buf+OFFSET_FIRST_EXPUNGED)));
@@ -1588,17 +1593,27 @@ static int mailbox_buf_to_index_header(c
     i->recentuid = ntohl(*((bit32 *)(buf+OFFSET_RECENTUID)));
     i->recenttime = ntohl(*((bit32 *)(buf+OFFSET_RECENTTIME)));
 
-    if (i->minor_version > 12) {
-        i->pop3_show_after = ntohl(*((bit32 *)(buf+OFFSET_POP3_SHOW_AFTER)));
-        qannot = ntohl(*((bit32 *)(buf+OFFSET_QUOTA_ANNOT_USED)));
-        /* this field is stored as a 32b unsigned on disk but 64b signed
-         * in memory, so we need to be careful about sign extension */
-        i->quota_annot_used = (quota_t)((unsigned long long)qannot);
-        i->synccrcs.annot = ntohl(*((bit32 *)(buf+OFFSET_SYNCCRCS_ANNOT)));
-    }
+    if (i->minor_version < 13) goto crc;
+
+    i->pop3_show_after = ntohl(*((bit32 *)(buf+OFFSET_POP3_SHOW_AFTER)));
+    qannot = ntohl(*((bit32 *)(buf+OFFSET_QUOTA_ANNOT_USED)));
+    /* this field is stored as a 32b unsigned on disk but 64b signed
+     * in memory, so we need to be careful about sign extension */
+    i->quota_annot_used = (quota_t)((unsigned long long)qannot);
+    i->synccrcs.annot = ntohl(*((bit32 *)(buf+OFFSET_SYNCCRCS_ANNOT)));
+
+    if (i->minor_version < 14) goto crc;
 
-    crc = ntohl(*((bit32 *)(buf+OFFSET_HEADER_CRC)));
-    if (crc != crc32_map(buf, OFFSET_HEADER_CRC))
+    i->unseen = ntohl(*((bit32 *)(buf+OFFSET_UNSEEN)));
+
+    if (i->minor_version < 16) goto crc;
+
+    i->createdmodseq = align_ntohll(buf+OFFSET_MAILBOX_CREATEDMODSEQ);
+
+crc:
+    /* CRC is always the last 4 bytes */
+    crc = ntohl(*((bit32 *)(buf+headerlen-4)));
+    if (crc != crc32_map(buf, headerlen-4))
         return IMAP_MAILBOX_CHECKSUM;
 
 done:
@@ -1681,11 +1696,11 @@ static int mailbox_read_index_header(str
 /*
  * Read an index record from a mapped index file
  */
-static int mailbox_buf_to_index_record(const char *buf,
-                                       int version,
-                                       struct index_record *record)
+static int mailbox_buf_to_index_record(const char *buf, int version,
+                                       struct index_record *record, int dirty)
 {
     uint32_t crc;
+    uint32_t stored_system_flags = 0;
     int n;
 
     /* tracking fields - initialise */
@@ -1698,14 +1713,23 @@ static int mailbox_buf_to_index_record(c
     record->size = ntohl(*((bit32 *)(buf+OFFSET_SIZE)));
     record->header_size = ntohl(*((bit32 *)(buf+OFFSET_HEADER_SIZE)));
     record->gmtime = ntohl(*((bit32 *)(buf+OFFSET_GMTIME)));
-    record->cache_offset = ntohl(*((bit32 *)(buf+OFFSET_CACHE_OFFSET)));
+    uint64_t cache_offset_field = ntohl(*((bit32 *)(buf+OFFSET_CACHE_OFFSET)));
     record->last_updated = ntohl(*((bit32 *)(buf+OFFSET_LAST_UPDATED)));
-    record->system_flags = ntohl(*((bit32 *)(buf+OFFSET_SYSTEM_FLAGS)));
+    stored_system_flags = ntohl(*((bit32 *)(buf+OFFSET_SYSTEM_FLAGS)));
+
+    /* de-serialise system flags and internal flags */
+    record->system_flags = stored_system_flags & 0x000000ff;
+    record->internal_flags = stored_system_flags & 0xff000000;
+
     for (n = 0; n < MAX_USER_FLAGS/32; n++) {
         record->user_flags[n] = ntohl(*((bit32 *)(buf+OFFSET_USER_FLAGS+4*n)));
     }
-    record->content_lines = ntohl(*((bit32 *)(buf+OFFSET_CONTENT_LINES)));
-    record->cache_version = ntohl(*((bit32 *)(buf+OFFSET_CACHE_VERSION)));
+    uint64_t cache_version_field = ntohl(*((bit32 *)(buf+OFFSET_CACHE_VERSION)));
+
+    /* keep the low bits of the version field for the version */
+    record->cache_version = cache_version_field & 0xffff;
+    /* use the high bits of the version field to extend the cache offset */
+    record->cache_offset = cache_offset_field | ((cache_version_field & 0xffff0000) << 16);
 
     if (version < 8)
         return 0;
@@ -1722,9 +1746,11 @@ static int mailbox_buf_to_index_record(c
         return 0;
 
     /* THRID got inserted before cache_crc32 in version 12 */
-    if (version == 12) {
+    if (version < 13) {
         record->cache_crc = ntohl(*((bit32 *)(buf+88)));
 
+        if (dirty) return 0;
+        /* check CRC32 */
         crc = crc32_map(buf, 92);
         if (crc != ntohl(*((bit32 *)(buf+92))))
             return IMAP_MAILBOX_CHECKSUM;
@@ -1732,8 +1758,26 @@ static int mailbox_buf_to_index_record(c
     }
 
     record->cid = ntohll(*(bit64 *)(buf+OFFSET_THRID));
+    if (version > 14) {
+        record->savedate = ntohl(*((bit32 *)(buf+OFFSET_SAVEDATE)));
+    }
+
+    /* createdmodseq was added in version 16, pushing the CRCs down */
+    if (version < 16) {
+        record->cache_crc = ntohl(*((bit32 *)(buf+96)));
+
+        if (dirty) return 0;
+        /* check CRC32 */
+        crc = crc32_map(buf, 100);
+        if (crc != ntohl(*((bit32 *)(buf+100))))
+            return IMAP_MAILBOX_CHECKSUM;
+        return 0;
+    }
+
+    record->createdmodseq = ntohll(*(bit64 *)(buf+OFFSET_CREATEDMODSEQ));
     record->cache_crc = ntohl(*((bit32 *)(buf+OFFSET_CACHE_CRC)));
 
+    if (dirty) return 0;
     /* check CRC32 */
     crc = crc32_map(buf, OFFSET_RECORD_CRC);
     if (crc != ntohl(*((bit32 *)(buf+OFFSET_RECORD_CRC))))
@@ -1755,7 +1799,7 @@ static struct index_change *_find_change
     return NULL;
 }
 
-static void _store_change(struct mailbox *mailbox, struct index_record *record, int flags)
+static int _store_change(struct mailbox *mailbox, struct index_record *record, int flags)
 {
     struct index_change *change = _find_change(mailbox, record->recno);
 
@@ -1768,16 +1812,48 @@ static void _store_change(struct mailbox
             mailbox->index_changes = xrealloc(mailbox->index_changes, sizeof(struct index_change) * mailbox->index_change_alloc);
         }
 
+        change = &mailbox->index_changes[mailbox->index_change_count-1];
+        memset(change, 0, sizeof(struct index_change));
+
         /* stitch into place */
         uint32_t pos = record->recno % INDEX_MAP_SIZE;
-        mailbox->index_changes[mailbox->index_change_count-1].mapnext = mailbox->index_change_map[pos];
+        change->mapnext = mailbox->index_change_map[pos];
         mailbox->index_change_map[pos] = mailbox->index_change_count; /* always non-zero */
-        change = &mailbox->index_changes[mailbox->index_change_count-1];
     }
 
     /* finally always copy the data into place */
     change->record = *record;
     change->flags = flags;
+
+    if (mailbox_cacherecord(mailbox, record)) {
+        /* failed to load cache record */
+        free(change->msgid);
+        change->msgid = xstrdup("unknown");
+    }
+    else {
+        char *c_env = xstrndup(cacheitem_base(record, CACHE_ENVELOPE) + 1,
+                               cacheitem_size(record, CACHE_ENVELOPE) - 2);
+        char *envtokens[NUMENVTOKENS];
+        parse_cached_envelope(c_env, envtokens, NUMENVTOKENS);
+        free(change->msgid);
+        change->msgid = xstrdup(envtokens[ENV_MSGID] ? envtokens[ENV_MSGID] : "unknown");
+        free(c_env);
+    }
+
+    annotate_state_t *astate = NULL;
+    int r = mailbox_get_annotate_state(mailbox, record->uid, &astate);
+    if (r) return r;
+
+    struct buf annotval = BUF_INITIALIZER;
+    if (record->cid && record->basecid && record->basecid != record->cid)
+        buf_printf(&annotval, "%016llx", record->basecid);
+
+    r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "basethrid", "", &annotval);
+    buf_free(&annotval);
+
+    if (r) return r;
+
+    return 0;
 }
 
 static int _commit_one(struct mailbox *mailbox, struct index_change *change)
@@ -1807,23 +1883,32 @@ static int _commit_one(struct mailbox *m
 
     /* audit logging */
     if (config_auditlog) {
+        char flagstr[FLAGMAPSTR_MAXLEN];
+        flags_to_str(record, flagstr);
         if (change->flags & CHANGE_ISAPPEND)
+            /* note: messageid doesn't have <> wrappers because it already includes them */
             syslog(LOG_NOTICE, "auditlog: append sessionid=<%s> "
-                    "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> sysflags=<%u> guid=<%s>",
-                session_id(), mailbox->name, mailbox->uniqueid, record->uid,
-                record->modseq, record->system_flags, message_guid_encode(&record->guid));
+                   "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> "
+                   "sysflags=<%s> guid=<%s> messageid=%s",
+                   session_id(), mailbox->name, mailbox->uniqueid, record->uid,
+                   record->modseq, flagstr,
+                   message_guid_encode(&record->guid), change->msgid);
 
-        if ((record->system_flags & FLAG_EXPUNGED) && !(change->flags & CHANGE_WASEXPUNGED))
+        if ((record->internal_flags & FLAG_INTERNAL_EXPUNGED) && !(change->flags & CHANGE_WASEXPUNGED))
             syslog(LOG_NOTICE, "auditlog: expunge sessionid=<%s> "
-                   "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> sysflags=<%u> guid=<%s>",
-                session_id(), mailbox->name, mailbox->uniqueid, record->uid,
-                record->modseq, record->system_flags, message_guid_encode(&record->guid));
+                   "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> "
+                   "sysflags=<%s> guid=<%s>",
+                   session_id(), mailbox->name, mailbox->uniqueid, record->uid,
+                   record->modseq, flagstr,
+                   message_guid_encode(&record->guid));
 
-        if ((record->system_flags & FLAG_UNLINKED) && !(change->flags & CHANGE_WASUNLINKED))
+        if ((record->internal_flags & FLAG_INTERNAL_UNLINKED) && !(change->flags & CHANGE_WASUNLINKED))
             syslog(LOG_NOTICE, "auditlog: unlink sessionid=<%s> "
-                   "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> sysflags=<%u> guid=<%s>",
-                session_id(), mailbox->name, mailbox->uniqueid, record->uid,
-                record->modseq, record->system_flags, message_guid_encode(&record->guid));
+                   "mailbox=<%s> uniqueid=<%s> uid=<%u> modseq=<%llu> "
+                   "sysflags=<%s> guid=<%s>",
+                   session_id(), mailbox->name, mailbox->uniqueid, record->uid,
+                   record->modseq, flagstr,
+                   message_guid_encode(&record->guid));
     }
 
     return 0;
@@ -1831,6 +1916,10 @@ static int _commit_one(struct mailbox *m
 
 static void _cleanup_changes(struct mailbox *mailbox)
 {
+    uint32_t i;
+    for (i = 0; i < mailbox->index_change_count; i++) {
+        free(mailbox->index_changes[i].msgid);
+    }
     free(mailbox->index_changes);
     mailbox->index_changes = NULL;
     mailbox->index_change_count = 0;
@@ -1865,8 +1954,8 @@ static int _commit_changes(struct mailbo
     qsort(mailbox->index_changes, mailbox->index_change_count,
           sizeof(struct index_change), change_compar);
 
-    for (i = 1; i <= mailbox->index_change_count; i++) {
-        r = _commit_one(mailbox, &mailbox->index_changes[i-1]);
+    for (i = 0; i < mailbox->index_change_count; i++) {
+        r = _commit_one(mailbox, &mailbox->index_changes[i]);
         if (r) return r; /* DAMN, we're screwed */
     }
 
@@ -1881,6 +1970,27 @@ static int _commit_changes(struct mailbo
     return 0;
 }
 
+EXPORTED int mailbox_reload_index_record_dirty(struct mailbox *mailbox,
+                                               struct index_record *record)
+{
+    unsigned recno = record->recno;
+    unsigned offset = mailbox->i.start_offset + (recno-1) * mailbox->i.record_size;
+
+    if (offset + mailbox->i.record_size > mailbox->index_size) {
+        syslog(LOG_ERR,
+               "IOERROR: index record %u for %s past end of file",
+               recno, mailbox->name);
+        return IMAP_IOERROR;
+    }
+
+    const char *buf = mailbox->index_base + offset;
+    mailbox_buf_to_index_record(buf, mailbox->i.minor_version, record, 1);
+    record->recno = recno;
+
+    return 0;
+}
+
+
 /*
  * Read an index record from a mailbox
  */
@@ -1909,13 +2019,32 @@ static int mailbox_read_index_record(str
 
     buf = mailbox->index_base + offset;
 
-    r = mailbox_buf_to_index_record(buf, mailbox->i.minor_version, record);
+    r = mailbox_buf_to_index_record(buf, mailbox->i.minor_version, record, 0);
 
     record->recno = recno;
 
     return r;
 }
 
+EXPORTED int mailbox_read_basecid(struct mailbox *mailbox, const struct index_record *record)
+{
+    if (record->basecid) return 0;
+
+    if (record->internal_flags & FLAG_INTERNAL_SPLITCONVERSATION) {
+        struct buf annotval = BUF_INITIALIZER;
+        mailbox_annotation_lookup(mailbox, record->uid, IMAP_ANNOT_NS "basethrid", "", &annotval);
+        if (annotval.len == 16) {
+            const char *p = buf_cstring(&annotval);
+            /* we have a new canonical CID */
+            struct index_record *backdoor = (struct index_record *)record;
+            parsehex(p, &p, 16, &backdoor->basecid);
+        }
+        buf_free(&annotval);
+    }
+
+    return 0;
+}
+
 EXPORTED int mailbox_has_conversations(struct mailbox *mailbox)
 {
     char *path;
@@ -1928,6 +2057,10 @@ EXPORTED int mailbox_has_conversations(s
     if (mboxname_isdeletedmailbox(mailbox->name, NULL))
         return 0;
 
+    /* we never store data about submission mailboxes */
+    if (mboxname_issubmissionmailbox(mailbox->name, mailbox->mbtype))
+        return 0;
+
     path = conversations_getmboxpath(mailbox->name);
     if (!path) return 0;
     free(path);
@@ -1935,17 +2068,29 @@ EXPORTED int mailbox_has_conversations(s
     return 1;
 }
 
-static int mailbox_lock_conversations(struct mailbox *mailbox)
+static int mailbox_lock_conversations(struct mailbox *mailbox, int locktype)
 {
     /* does this mailbox have conversations? */
     if (!mailbox_has_conversations(mailbox))
         return 0;
 
     /* already locked */
-    if (conversations_get_mbox(mailbox->name))
+    struct conversations_state *cstate = conversations_get_mbox(mailbox->name);
+    if (cstate) {
+        if (locktype == LOCK_EXCLUSIVE) assert (!cstate->is_shared);
         return 0;
+    }
 
-    return conversations_open_mbox(mailbox->name, &mailbox->local_cstate);
+    if (locktype == LOCK_EXCLUSIVE) {
+        return conversations_open_mbox(mailbox->name, 0/*shared*/, &mailbox->local_cstate);
+    }
+    else if (locktype == LOCK_SHARED) {
+        return conversations_open_mbox(mailbox->name, 1/*shared*/, &mailbox->local_cstate);
+    }
+    else {
+        /* this function does not support nonblocking locks */
+        fatal("invalid locktype for conversations", EX_SOFTWARE);
+    }
 }
 
 #ifdef WITH_DAV
@@ -2005,7 +2150,7 @@ static uint32_t mailbox_getuid(struct ma
 /*
  * Returns the recno of the message with UID 'uid'.
  * If no message with UID 'uid', returns the message with
- * the higest UID not greater than 'uid'.
+ * the highest UID not greater than 'uid'.
  */
 static uint32_t mailbox_finduid(struct mailbox *mailbox, uint32_t uid)
 {
@@ -2079,7 +2224,7 @@ static int mailbox_lock_index_internal(s
     }
     else {
         /* this function does not support nonblocking locks */
-        fatal("invalid locktype for index", EC_SOFTWARE);
+        fatal("invalid locktype for index", EX_SOFTWARE);
     }
 
     /* double check that the index exists and has at least enough
@@ -2114,20 +2259,28 @@ static int mailbox_lock_index_internal(s
     if (sbuf.st_ino != mailbox->header_file_ino) {
         r = mailbox_read_header(mailbox, NULL);
         if (r) {
-            syslog(LOG_ERR, "IOERROR: reading header for %s: %m",
-                   mailbox->name);
+            syslog(LOG_ERR, "IOERROR: reading header for %s: %s",
+                   mailbox->name, error_message(r));
             mailbox_unlock_index(mailbox, NULL);
             return r;
         }
     }
 
+    /* release caches */
+    int i;
+    for (i = 0; i < mailbox->caches.count; i++) {
+        struct mappedfile *cachefile = ptrarray_nth(&mailbox->caches, i);
+        mappedfile_close(&cachefile);
+    }
+    ptrarray_fini(&mailbox->caches);
+
     /* note: it's guaranteed by our outer cyrus.lock lock that the
      * cyrus.index and cyrus.cache files are never rewritten, so
      * we're safe to just extend the map if needed */
     r = mailbox_read_index_header(mailbox);
     if (r) {
-        syslog(LOG_ERR, "IOERROR: refreshing index for %s: %m",
-               mailbox->name);
+        syslog(LOG_ERR, "IOERROR: refreshing index for %s: %s",
+               mailbox->name, error_message(r));
         mailbox_unlock_index(mailbox, NULL);
         return r;
     }
@@ -2147,12 +2300,10 @@ EXPORTED int mailbox_lock_index(struct m
 {
     int r = 0;
 
-    /* XXX: only lock convdb if we're in read-write mode.  This is kinda
-     * bogus really, but there's no way to get a read lock on convdb */
-    if (locktype != LOCK_SHARED) {
-        r = mailbox_lock_conversations(mailbox);
-        if (r) return r;
-    }
+    /* always lock the conversations DB, since if we have the index file
+     * locked at all, we can't open it later */
+    r = mailbox_lock_conversations(mailbox, locktype);
+    if (r) return r;
 
     r = mailbox_lock_index_internal(mailbox, locktype);
     if (r) return r;
@@ -2174,6 +2325,7 @@ EXPORTED int mailbox_lock_index(struct m
  */
 EXPORTED void mailbox_unlock_index(struct mailbox *mailbox, struct statusdata *sdata)
 {
+    struct statusdata mysdata = STATUSDATA_INIT;
     struct timeval endtime;
     double timediff;
     int r;
@@ -2195,14 +2347,18 @@ EXPORTED void mailbox_unlock_index(struc
     if (mailbox->has_changed) {
         if (updatenotifier) updatenotifier(mailbox->name);
         sync_log_mailbox(mailbox->name);
-        statuscache_invalidate(mailbox->name, sdata);
+
+        if (!sdata) {
+            status_fill_mailbox(mailbox, &mysdata);
+            sdata = &mysdata;
+        }
 
         mailbox->has_changed = 0;
     }
-    else if (sdata) {
-        /* updated data, always write */
+
+    // we always write if given new statusdata, or if we changed the mailbox
+    if (sdata)
         statuscache_invalidate(mailbox->name, sdata);
-    }
 
     if (mailbox->index_locktype) {
         if (lock_unlock(mailbox->index_fd, index_fname))
@@ -2226,16 +2382,6 @@ EXPORTED void mailbox_unlock_index(struc
     }
 }
 
-EXPORTED int mailbox_yield_index(struct mailbox *mailbox)
-{
-    int locktype = mailbox->index_locktype;
-
-    if (!locktype) return 0;
-
-    mailbox_unlock_index(mailbox, NULL);
-    return mailbox_lock_index(mailbox, locktype);
-}
-
 /*
  * Write the header file for 'mailbox'
  */
@@ -2327,6 +2473,7 @@ static bit32 mailbox_index_header_to_buf
 {
     bit32 crc;
     bit32 options = i->options & MAILBOX_OPT_VALID;
+    size_t headerlen = INDEX_HEADER_SIZE;
 
     memset(buf, 0, INDEX_HEADER_SIZE); /* buffer is always this big, and aligned */
 
@@ -2390,9 +2537,21 @@ static bit32 mailbox_index_header_to_buf
         *((bit32 *)(buf+OFFSET_SYNCCRCS_ANNOT)) = htonl(i->synccrcs.annot);
     }
 
+    if (i->minor_version > 13) {
+        *((bit32 *)(buf+OFFSET_UNSEEN)) = htonl(i->unseen);
+    }
+    else {
+        /* we expanded the file size in version 14 */
+        headerlen = 128;
+    }
+
+    if (i->minor_version > 15) {
+        align_htonll(buf+OFFSET_MAILBOX_CREATEDMODSEQ, i->createdmodseq);
+    }
+
     /* Update checksum */
-    crc = htonl(crc32_map((char *)buf, OFFSET_HEADER_CRC));
-    *((bit32 *)(buf+OFFSET_HEADER_CRC)) = crc;
+    crc = htonl(crc32_map((char *)buf, headerlen-4));
+    *((bit32 *)(buf+headerlen-4)) = crc;
 
     return crc;
 }
@@ -2426,7 +2585,8 @@ HIDDEN int mailbox_commit_quota(struct m
 
     assert(mailbox_index_islocked(mailbox, 1));
 
-    quota_update_useds(mailbox->quotaroot, quota_usage, mailbox->name);
+    quota_update_useds(mailbox->quotaroot, quota_usage,
+                       mailbox->name, mailbox->silentchanges);
     /* XXX - fail upon issue?  It's tempting */
 
     return 0;
@@ -2534,6 +2694,14 @@ EXPORTED int mailbox_commit(struct mailb
             session_id(), mailbox->name, mailbox->uniqueid,
             mailbox->i.highestmodseq);
 
+    if (mailbox->modseq_dirty) {
+        struct mboxevent *mboxevent = mboxevent_new(EVENT_MAILBOX_MODSEQ);
+        mboxevent_extract_mailbox(mboxevent, mailbox);
+        mboxevent_set_access(mboxevent, NULL, NULL, "", mailbox->name, 0);
+        mboxevent_notify(&mboxevent);
+        mboxevent_free(&mboxevent);
+    }
+
     /* remove all dirty flags! */
     mailbox->i.dirty = 0;
     mailbox->modseq_dirty = 0;
@@ -2553,9 +2721,15 @@ static bit32 mailbox_index_record_to_buf
 {
     int n;
     bit32 crc;
+    uint32_t system_flags = 0;
 
     memset(buf, 0, INDEX_RECORD_SIZE);
 
+    /* keep the low bits of the offset in the offset field */
+    uint32_t cache_offset_field = record->cache_offset & 0xffffffff;
+    /* mix in the high bits of the offset to the top half of the version field */
+    uint32_t cache_version_field = (uint32_t)record->cache_version | (record->cache_offset & 0xffff00000000) >> 16;
+
     *((bit32 *)(buf+OFFSET_UID)) = htonl(record->uid);
     *((bit32 *)(buf+OFFSET_INTERNALDATE)) = htonl(record->internaldate);
     *((bit32 *)(buf+OFFSET_SENTDATE)) = htonl(record->sentdate);
@@ -2568,14 +2742,23 @@ static bit32 mailbox_index_record_to_buf
         /* content_offset was always the same */
         *((bit32 *)(buf+OFFSET_GMTIME)) = htonl(record->header_size);
     }
-    *((bit32 *)(buf+OFFSET_CACHE_OFFSET)) = htonl(record->cache_offset);
+    *((bit32 *)(buf+OFFSET_CACHE_OFFSET)) = htonl(cache_offset_field);
     *((bit32 *)(buf+OFFSET_LAST_UPDATED)) = htonl(record->last_updated);
-    *((bit32 *)(buf+OFFSET_SYSTEM_FLAGS)) = htonl(record->system_flags);
+
+    /* serialise system flags and internal flags */
+    system_flags = record->system_flags | record->internal_flags;
+    *((bit32 *)(buf+OFFSET_SYSTEM_FLAGS)) = htonl(system_flags);
+
     for (n = 0; n < MAX_USER_FLAGS/32; n++) {
         *((bit32 *)(buf+OFFSET_USER_FLAGS+4*n)) = htonl(record->user_flags[n]);
     }
-    *((bit32 *)(buf+OFFSET_CONTENT_LINES)) = htonl(record->content_lines);
-    *((bit32 *)(buf+OFFSET_CACHE_VERSION)) = htonl(record->cache_version);
+    if (version > 14) {
+        *((bit32 *)(buf+OFFSET_SAVEDATE)) = htonl(record->savedate);
+    }
+    else {
+        *((bit32 *)(buf+OFFSET_SAVEDATE)) = 0; // blank out old content_lines
+    }
+    *((bit32 *)(buf+OFFSET_CACHE_VERSION)) = htonl(cache_version_field);
 
     /* versions less than 8 had no modseq */
     if (version < 8) {
@@ -2585,7 +2768,7 @@ static bit32 mailbox_index_record_to_buf
     /* versions 8 and 9 only had a smaller UUID, which we will ignore,
      * but the modseq existed and was at offset 72 and 76 */
     if (version < 10) {
-        *((bit32 *)(buf+72)) = htonl(record->modseq);
+        *((bit64 *)(buf+72)) = htonll(record->modseq);
         return 0;
     }
 
@@ -2603,6 +2786,16 @@ static bit32 mailbox_index_record_to_buf
     }
 
     *((bit64 *)(buf+OFFSET_THRID)) = htonll(record->cid);
+
+    /* version 16 added createdmodseq, pushing the CRCs down */
+    if (version < 16) {
+        *((bit32 *)(buf+96)) = htonl(record->cache_crc);
+        crc = crc32_map((char *)buf, 100);
+        *((bit32 *)(buf+100)) = htonl(crc);
+        return crc;
+    }
+
+    *((bit64 *)(buf+OFFSET_CREATEDMODSEQ)) = htonll(record->createdmodseq);
     *((bit32 *)(buf+OFFSET_CACHE_CRC)) = htonl(record->cache_crc);
 
     /* calculate the checksum */
@@ -2629,7 +2822,7 @@ static void header_update_counts(struct
     int num = is_add ? 1 : -1;
 
     /* we don't track counts for EXPUNGED records */
-    if (record->system_flags & FLAG_EXPUNGED)
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return;
 
     /* update mailbox header fields */
@@ -2642,6 +2835,9 @@ static void header_update_counts(struct
     if (record->system_flags & FLAG_DELETED)
         i->deleted += num;
 
+    if (!(record->system_flags & FLAG_SEEN))
+        i->unseen += num;
+
     if (is_add) {
         i->exists++;
         i->quota_mailbox_used += record->size;
@@ -2661,6 +2857,7 @@ static void header_update_counts(struct
 
 struct annot_calc_rock
 {
+    struct mailbox *mailbox;
     uint32_t annot;
     quota_t used;
 };
@@ -2674,7 +2871,7 @@ static uint32_t crc_basic(const struct m
     int flag;
 
     /* expunged flags have no sync CRC */
-    if (record->system_flags & FLAG_EXPUNGED)
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return 0;
 
     /* calculate an XORed CRC32 over all the flags on the message, so no
@@ -2717,7 +2914,10 @@ static uint32_t crc_annot(unsigned int u
     struct buf buf = BUF_INITIALIZER;
     uint32_t res = 0;
 
-    buf_printf(&buf, "%u %s %s ", uid, entry, userid ? userid : "");
+    // ignore everything with a NULL userid, it's bogus!
+    if (!userid) return 0;
+
+    buf_printf(&buf, "%u %s %s ", uid, entry, userid);
     buf_append(&buf, value);
     res = crc32_buf(&buf);
     buf_free(&buf);
@@ -2725,20 +2925,52 @@ static uint32_t crc_annot(unsigned int u
     return res;
 }
 
-static uint32_t crc_virtannot(struct mailbox *mailbox __attribute__((unused)),
-                              const struct index_record *record)
+static int mailbox_is_virtannot(struct mailbox *mailbox, const char *entry)
 {
-    uint32_t crc = 0;
+    if (mailbox->i.minor_version < 13) return 0;
+    // thrid was introduced in v13
+    if (!strcmp(entry, IMAP_ANNOT_NS "thrid")) return 1;
+
+    if (mailbox->i.minor_version < 15) return 0;
+    // savedate was introduced in v15
+    if (!strcmp(entry, IMAP_ANNOT_NS "savedate")) return 1;
+
+    if (mailbox->i.minor_version < 16) return 0;
+    // createdmodseq was introduced in v15
+    if (!strcmp(entry, IMAP_ANNOT_NS "createdmodseq")) return 1;
+
+    return 0;
+}
+
 
-    if (record->system_flags & FLAG_EXPUNGED)
+static uint32_t crc_virtannot(struct mailbox *mailbox,
+                              const struct index_record *record)
+{
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return 0;
 
-    if (record->cid) {
-        struct buf buf = BUF_INITIALIZER;
+    uint32_t crc = 0;
+    struct buf buf = BUF_INITIALIZER;
+
+    if (record->cid && mailbox->i.minor_version >= 13) {
         buf_printf(&buf, "%llx", record->cid);
-        crc ^= crc_annot(record->uid, IMAP_ANNOT_NS "thrid", NULL, &buf);
-        buf_free(&buf);
+        crc ^= crc_annot(record->uid, IMAP_ANNOT_NS "thrid", "", &buf);
+        buf_reset(&buf);
+    }
+
+    if (record->savedate && mailbox->i.minor_version >= 15) {
+        buf_printf(&buf, "%lu", record->savedate);
+        crc ^= crc_annot(record->uid, IMAP_ANNOT_NS "savedate", "", &buf);
+        buf_reset(&buf);
+    }
+
+    if (record->createdmodseq && mailbox->i.minor_version >= 16) {
+        buf_printf(&buf, "%llu", record->createdmodseq);
+        crc ^= crc_annot(record->uid, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+        buf_reset(&buf);
     }
+
+    buf_free(&buf);
     return crc;
 }
 
@@ -2747,25 +2979,32 @@ EXPORTED void mailbox_annot_changed(stru
                            const char *entry,
                            const char *userid,
                            const struct buf *oldval,
-                           const struct buf *newval)
+                           const struct buf *newval,
+                           int silent)
 {
     /* update sync_crc - NOTE, only per-message annotations count */
     if (uid) {
         /* check that the record isn't already expunged */
         struct index_record record;
         int r = mailbox_find_index_record(mailbox, uid, &record);
-        if (r || record.system_flags & FLAG_EXPUNGED)
+        if (r || record.internal_flags & FLAG_INTERNAL_EXPUNGED)
             return;
-        if (oldval->len)
-            mailbox->i.synccrcs.annot ^= crc_annot(uid, entry, userid, oldval);
-        if (newval->len)
-            mailbox->i.synccrcs.annot ^= crc_annot(uid, entry, userid, newval);
+        if (!mailbox_is_virtannot(mailbox, entry)) {
+            if (oldval->len)
+                mailbox->i.synccrcs.annot ^= crc_annot(uid, entry, userid, oldval);
+            if (newval->len)
+                mailbox->i.synccrcs.annot ^= crc_annot(uid, entry, userid, newval);
+        }
     }
 
-    /* we are dirtying both index and quota */
-    mailbox_index_dirty(mailbox);
+    if (!silent) {
+        /* we are dirtying modseq for any annotation change */
+        mailbox_modseq_dirty(mailbox);
+        /* and we're dirtying foldermodseq if it's a mailbox level annotation */
+        if (!uid) mboxlist_update_foldermodseq(mailbox->name, mailbox->i.highestmodseq);
+    }
+    /* we always dirty the quota */
     mailbox_quota_dirty(mailbox);
-    mboxlist_foldermodseq_dirty(mailbox);
 
     /* corruption prevention - check we don't go negative */
     if (mailbox->i.quota_annot_used > (quota_t)oldval->len)
@@ -2776,17 +3015,18 @@ EXPORTED void mailbox_annot_changed(stru
     mailbox->i.quota_annot_used += newval->len;
 }
 
-static int calc_one_annot(const char *mailbox __attribute__((unused)),
+static int calc_one_annot(const char *mboxname __attribute__((unused)),
                           uint32_t uid,
                           const char *entry,
                           const char *userid,
                           const struct buf *value,
+                          const struct annotate_metadata *mdata __attribute__((unused)),
                           void *rock)
 {
     struct annot_calc_rock *cr = (struct annot_calc_rock *)rock;
 
     /* update sync_crc - NOTE, only per-message annotations count */
-    if (uid)
+    if (uid && !mailbox_is_virtannot(cr->mailbox, entry))
         cr->annot ^= crc_annot(uid, entry, userid, value);
 
     /* always count the size */
@@ -2799,13 +3039,13 @@ static void mailbox_annot_update_counts(
                                         const struct index_record *record,
                                         int is_add)
 {
-    struct annot_calc_rock cr = { 0, 0 };
+    struct annot_calc_rock cr = { mailbox, 0, 0 };
 
     /* expunged records don't count */
-    if (record && record->system_flags & FLAG_EXPUNGED) return;
+    if (record && record->internal_flags & FLAG_INTERNAL_EXPUNGED) return;
 
     annotatemore_findall(mailbox->name, record ? record->uid : 0, /* all entries*/"*",
-                         calc_one_annot, &cr);
+                         /*modseq*/0, calc_one_annot, &cr, /*flags*/0);
 
     if (record)
         mailbox->i.synccrcs.annot ^= cr.annot;
@@ -2829,7 +3069,7 @@ EXPORTED struct synccrcs mailbox_synccrc
 {
     annotate_state_t *astate = NULL;
     const message_t *msg;
-    struct synccrcs crcs = { 0, 0 };
+    struct synccrcs crcs = { CRC_INIT_BASIC, CRC_INIT_ANNOT };
 
     if (!force)
         return mailbox->i.synccrcs;
@@ -2847,9 +3087,9 @@ EXPORTED struct synccrcs mailbox_synccrc
         crcs.basic ^= crc_basic(mailbox, record);
         crcs.annot ^= crc_virtannot(mailbox, record);
 
-        struct annot_calc_rock cr = { 0, 0 };
+        struct annot_calc_rock cr = { mailbox, 0, 0 };
         annotatemore_findall(mailbox->name, record->uid, /* all entries*/"*",
-                             calc_one_annot, &cr);
+                             /*modseq*/0, calc_one_annot, &cr, /*flags*/0);
 
         crcs.annot ^= cr.annot;
     }
@@ -2892,11 +3132,12 @@ EXPORTED int mailbox_index_recalc(struct
     mailbox->i.answered = 0;
     mailbox->i.flagged = 0;
     mailbox->i.deleted = 0;
+    mailbox->i.unseen = 0;
     mailbox->i.exists = 0;
     mailbox->i.quota_mailbox_used = 0;
     mailbox->i.quota_annot_used = 0;
-    mailbox->i.synccrcs.basic = 0;
-    mailbox->i.synccrcs.annot = 0;
+    mailbox->i.synccrcs.basic = CRC_INIT_BASIC;
+    mailbox->i.synccrcs.annot = CRC_INIT_ANNOT;
 
     /* mailbox level annotations */
     mailbox_annot_update_counts(mailbox, NULL, 1);
@@ -2936,7 +3177,7 @@ static int mailbox_update_carddav(struct
     if (!new) goto done;
 
     /* phantom record - never really existed here */
-    if (!old && (new->system_flags & FLAG_UNLINKED))
+    if (!old && (new->internal_flags & FLAG_INTERNAL_UNLINKED))
         goto done;
 
     r = mailbox_cacherecord(mailbox, new);
@@ -2960,7 +3201,7 @@ static int mailbox_update_carddav(struct
     /* does it still come from this UID? */
     if (cdata->dav.imap_uid > new->uid) goto done;
 
-    if (new->system_flags & FLAG_UNLINKED) {
+    if (new->internal_flags & FLAG_INTERNAL_UNLINKED) {
         /* is there an existing record? */
         if (!cdata->dav.imap_uid) goto done;
 
@@ -2969,13 +3210,26 @@ static int mailbox_update_carddav(struct
     }
     else if (cdata->dav.imap_uid == new->uid) {
         /* just a flag change on an existing record */
+        struct vparse_card *vcard = record_to_vcard(mailbox, new);
+        int ispinned = (new->system_flags & FLAG_FLAGGED) ? 1 : 0;
+
+        if (!vcard || !vcard->objects) {
+            syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
+                   cdata->dav.imap_uid, mailbox->name);
+            r = IMAP_MAILBOX_BADFORMAT; // XXX better error?
+            vparse_free_card(vcard);
+            goto done;
+        }
+
         cdata->dav.modseq = new->modseq;
-        cdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
-        r = carddav_write(carddavdb, cdata);
+        cdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
+        r = carddav_writecard(carddavdb, cdata, vcard->objects, ispinned);
+        vparse_free_card(vcard);
     }
     else {
         /* Load message containing the resource and parse vcard data */
         struct vparse_card *vcard = record_to_vcard(mailbox, new);
+        int ispinned = (new->system_flags & FLAG_FLAGGED) ? 1 : 0;
 
         if (!vcard || !vcard->objects) {
             syslog(LOG_ERR, "record_to_vcard failed for record %u:%s",
@@ -2990,12 +3244,13 @@ static int mailbox_update_carddav(struct
         cdata->dav.resource = resource;
         cdata->dav.imap_uid = new->uid;
         cdata->dav.modseq = new->modseq;
-        cdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
+        cdata->dav.createdmodseq = new->createdmodseq;
+        cdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
 
         if (!cdata->dav.creationdate)
             cdata->dav.creationdate = new->internaldate;
 
-        r = carddav_writecard(carddavdb, cdata, vcard->objects);
+        r = carddav_writecard(carddavdb, cdata, vcard->objects, ispinned);
 
         vparse_free_card(vcard);
     }
@@ -3017,14 +3272,14 @@ static int mailbox_update_caldav(struct
     struct caldav_data *cdata = NULL;
     const char *resource = NULL;
     const char *sched_tag = NULL;
-    unsigned tzbyref = 0;
+    unsigned tzbyref = 0, shared = 0;
     int r = 0;
 
     /* conditions in which there's nothing to do */
     if (!new) goto done;
 
     /* phantom record - never really existed at all */
-    if (!old && (new->system_flags & FLAG_UNLINKED))
+    if (!old && (new->internal_flags & FLAG_INTERNAL_UNLINKED))
         goto done;
 
     r = mailbox_cacherecord(mailbox, new);
@@ -3042,6 +3297,9 @@ static int mailbox_update_caldav(struct
         else if (!strcmp(param->attribute, "TZ-BY-REF")) {
             tzbyref = !strcasecmp(param->value, "TRUE");
         }
+        else if (!strcmp(param->attribute, "PER-USER-DATA")) {
+            shared = !strcasecmp(param->value, "TRUE");
+        }
     }
 
     caldavdb = mailbox_open_caldav(mailbox);
@@ -3052,7 +3310,7 @@ static int mailbox_update_caldav(struct
     /* has this record already been replaced?  Don't write anything */
     if (cdata->dav.imap_uid > new->uid) goto done;
 
-    if (new->system_flags & FLAG_UNLINKED) {
+    if (new->internal_flags & FLAG_INTERNAL_UNLINKED) {
         /* is there an existing record? */
         if (!cdata->dav.imap_uid) goto done;
 
@@ -3063,18 +3321,19 @@ static int mailbox_update_caldav(struct
         r = caldav_delete(caldavdb, cdata->dav.rowid);
     }
     else if (cdata->dav.imap_uid == new->uid) {
-        if (new->system_flags & FLAG_EXPUNGED) {
+        if (new->internal_flags & FLAG_INTERNAL_EXPUNGED) {
             /* remove associated alarms */
             caldav_alarm_delete_record(cdata->dav.mailbox, cdata->dav.imap_uid);
         }
-        else {
-            /* make sure record is up to date */
+        else if (!new->silent) {
+            /* make sure record is up to date - see add below for description of
+             * why we don't touch silent records */
             caldav_alarm_touch_record(mailbox, new);
         }
 
         /* just a flags update to an existing record */
         cdata->dav.modseq = new->modseq;
-        cdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
+        cdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
         r = caldav_write(caldavdb, cdata);
     }
     else {
@@ -3098,13 +3357,19 @@ static int mailbox_update_caldav(struct
         cdata->dav.mailbox = mailbox->name;
         cdata->dav.imap_uid = new->uid;
         cdata->dav.modseq = new->modseq;
-        cdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
+        cdata->dav.createdmodseq = new->createdmodseq;
+        cdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
         cdata->dav.resource = resource;
         cdata->sched_tag = sched_tag;
         cdata->comp_flags.tzbyref = tzbyref;
+        cdata->comp_flags.shared = shared;
 
         /* add new ones unless this record is expunged */
-        if (cdata->dav.alive) {
+        /* we need to skip silent records (replication)
+         * because the lastalarm annotation won't be set yet -
+         * instead, we have an explicit sync from the annotation
+         * which is done after the annotations are written in sync_support.c */
+        if (cdata->dav.alive && !new->silent) {
             r = caldav_alarm_add_record(mailbox, new, ical);
             if (r) goto alarmdone;
         }
@@ -3137,7 +3402,7 @@ static int mailbox_update_webdav(struct
     if (!new) goto done;
 
     /* phantom record - never really existed here */
-    if (!old && (new->system_flags & FLAG_EXPUNGED))
+    if (!old && new->internal_flags & FLAG_INTERNAL_EXPUNGED)
         goto done;
 
     r = mailbox_cacherecord(mailbox, new);
@@ -3159,7 +3424,7 @@ static int mailbox_update_webdav(struct
     /* if updated by a newer UID, skip - this record doesn't refer to the current item */
     if (wdata->dav.imap_uid > new->uid) goto done;
 
-    if (new->system_flags & FLAG_UNLINKED) {
+    if (new->internal_flags & FLAG_INTERNAL_UNLINKED) {
         /* is there an existing record? */
         if (!wdata->dav.imap_uid) goto done;
 
@@ -3169,7 +3434,7 @@ static int mailbox_update_webdav(struct
     else if (wdata->dav.imap_uid == new->uid) {
         /* just a flags update to an existing record */
         wdata->dav.modseq = new->modseq;
-        wdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
+        wdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
         wdata->ref_count *= wdata->dav.alive;
         r = webdav_write(webdavdb, wdata);
     }
@@ -3190,7 +3455,8 @@ static int mailbox_update_webdav(struct
         wdata->dav.mailbox = mailbox->name;
         wdata->dav.imap_uid = new->uid;
         wdata->dav.modseq = new->modseq;
-        wdata->dav.alive = (new->system_flags & FLAG_EXPUNGED) ? 0 : 1;
+        wdata->dav.createdmodseq = new->createdmodseq;
+        wdata->dav.alive = (new->internal_flags & FLAG_INTERNAL_EXPUNGED) ? 0 : 1;
         wdata->ref_count *= wdata->dav.alive;
         wdata->dav.resource = resource;
         wdata->filename = body->description;
@@ -3286,12 +3552,73 @@ static int mailbox_abort_dav(struct mail
 
 #endif // WITH_DAV
 
+#ifdef WITH_JMAP
+static int mailbox_update_email_alarms(struct mailbox *mailbox,
+                                       const struct index_record *old,
+                                       struct index_record *new)
+{
+    int r = 0;
+
+    if (!(mailbox->i.options & OPT_IMAP_HAS_ALARMS))
+        return 0;
+
+    /* never have alarms on deleted mailboxes */
+    if (mboxname_isdeletedmailbox(mailbox->name, NULL))
+        return 0;
+
+    /* remove associated alarms if deleted */
+    if (!new || new->internal_flags & FLAG_INTERNAL_EXPUNGED) {
+        r = caldav_alarm_delete_record(mailbox->name, new->uid);
+    }
+
+    /* remove associated alarms if canceled or final */
+    else if ((mailbox->mbtype & MBTYPE_SUBMISSION) &&
+             (new->system_flags & (FLAG_FLAGGED | FLAG_ANSWERED))) {
+        r = caldav_alarm_delete_record(mailbox->name, new->uid);
+    }
+
+    /* touch or create otherwise */
+    else if (old && (old->uid == new->uid)) {
+        r = caldav_alarm_touch_record(mailbox, new);
+    }
+    else {
+        r = caldav_alarm_add_record(mailbox, new, NULL);
+    }
+
+    return r;
+}
+
+EXPORTED int mailbox_add_email_alarms(struct mailbox *mailbox)
+{
+    const message_t *msg;
+    int r = 0;
+
+    if (!(mailbox->i.options & OPT_IMAP_HAS_ALARMS))
+        return 0;
+
+    if (mboxname_isdeletedmailbox(mailbox->name, NULL))
+        return 0;
+
+    struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_UNLINKED);
+    while ((msg = mailbox_iter_step(iter))) {
+        const struct index_record *record = msg_record(msg);
+        struct index_record copyrecord = *record;
+        r = mailbox_update_email_alarms(mailbox, NULL, &copyrecord);
+        if (r) break;
+        /* in THEORY there maybe changes here that we should be saving... */
+    }
+    mailbox_iter_done(&iter);
+
+    return r;
+}
+#endif // WITH_JMAP
+
 EXPORTED struct conversations_state *mailbox_get_cstate(struct mailbox *mailbox)
 {
     if (!mailbox_has_conversations(mailbox))
         return NULL;
 
-    mailbox_lock_conversations(mailbox);
+    mailbox_lock_conversations(mailbox, mailbox->is_readonly ? LOCK_SHARED : LOCK_EXCLUSIVE);
 
     return conversations_get_mbox(mailbox->name);
 }
@@ -3306,13 +3633,13 @@ static int mailbox_update_conversations(
         return 0;
 
     /* handle unlinked items as if they didn't exist */
-    if (old && (old->system_flags & FLAG_UNLINKED)) old = NULL;
-    if (new && (new->system_flags & FLAG_UNLINKED)) new = NULL;
+    if (old && (old->internal_flags & FLAG_INTERNAL_UNLINKED)) old = NULL;
+    if (new && (new->internal_flags & FLAG_INTERNAL_UNLINKED)) new = NULL;
 
     if (!old && !new)
         return 0;
 
-    return conversations_update_record(cstate, mailbox, old, new);
+    return conversations_update_record(cstate, mailbox, old, new, /*allowrenumber*/1);
 }
 
 
@@ -3330,7 +3657,7 @@ EXPORTED int mailbox_get_xconvmodseq(str
     r = conversation_getstatus(cstate, mailbox->name, &status);
     if (r) return r;
 
-    *modseqp = status.modseq;
+    *modseqp = status.threadmodseq;
 
     return 0;
 }
@@ -3347,8 +3674,8 @@ EXPORTED int mailbox_update_xconvmodseq(
     r = conversation_getstatus(cstate, mailbox->name, &status);
     if (r) return r;
 
-    if (newmodseq > status.modseq || (force && newmodseq < status.modseq)) {
-        status.modseq = newmodseq;
+    if (newmodseq > status.threadmodseq || (force && newmodseq < status.threadmodseq)) {
+        status.threadmodseq = newmodseq;
         r = conversation_setstatus(cstate, mailbox->name, &status);
     }
 
@@ -3368,6 +3695,11 @@ static int mailbox_update_indexes(struct
     if (r) return r;
 #endif
 
+#ifdef WITH_JMAP
+    r = mailbox_update_email_alarms(mailbox, old, new);
+    if (r) return r;
+#endif
+
     r = mailbox_update_conversations(mailbox, old, new);
     if (r) return r;
 
@@ -3401,7 +3733,7 @@ EXPORTED int mailbox_rewrite_index_recor
     struct index_record oldrecord;
     int expunge_mode = config_getenum(IMAPOPT_EXPUNGE_MODE);
     int immediate = (expunge_mode == IMAP_ENUM_EXPUNGE_MODE_IMMEDIATE ||
-                     expunge_mode == IMAP_ENUM_EXPUNGE_MODE_DEFAULT ||
+                     expunge_mode == IMAP_ENUM_EXPUNGE_MODE_SEMIDELAYED ||
                      mailbox->i.minor_version < 12);
     int changeflags = 0;
 
@@ -3415,10 +3747,20 @@ EXPORTED int mailbox_rewrite_index_recor
                mailbox->name, record->uid);
         return r;
     }
+    mailbox_read_basecid(mailbox, &oldrecord);
+
+    /* OK, we need to decide how to handle basecid.  Three cases here:
+     * 1) basecid is already set - keep it
+     * 2) basecid is zero, but the system flag says it should be readable, set it from oldrecord
+     * 3) basecid is zero, system flag is zero - keep zero
+     * we only need code for case #2
+     */
+    if (!record->basecid && (record->internal_flags & FLAG_INTERNAL_SPLITCONVERSATION))
+        record->basecid = oldrecord.basecid;
 
-    if (oldrecord.system_flags & FLAG_EXPUNGED)
+    if (oldrecord.internal_flags & FLAG_INTERNAL_EXPUNGED)
         changeflags |= CHANGE_WASEXPUNGED;
-    if (oldrecord.system_flags & FLAG_UNLINKED)
+    if (oldrecord.internal_flags & FLAG_INTERNAL_UNLINKED)
         changeflags |= CHANGE_WASUNLINKED;
 
     /* the UID has to match, of course, for it to be the same
@@ -3426,27 +3768,27 @@ EXPORTED int mailbox_rewrite_index_recor
      * too?  Maybe replication should be more strict about it */
     assert(record->uid == oldrecord.uid);
     assert(message_guid_equal(&oldrecord.guid, &record->guid));
-    assert(record->modseq >= oldrecord.modseq);
 
-    if (oldrecord.system_flags & FLAG_EXPUNGED) {
+    if (oldrecord.internal_flags & FLAG_INTERNAL_EXPUNGED) {
         /* it is a sin to unexpunge a message.  unexpunge.c copies
          * the data from the old record and appends it with a new
          * UID, which is righteous in the eyes of the IMAP client */
-        assert(record->system_flags & FLAG_EXPUNGED);
+        assert(record->internal_flags & FLAG_INTERNAL_EXPUNGED);
     }
 
-    if (oldrecord.system_flags & FLAG_ARCHIVED) {
+    if (oldrecord.internal_flags & FLAG_INTERNAL_ARCHIVED) {
         /* it is also a sin to unarchive a message, except in the
          * the very odd case of a reconstruct.  So let's see about
          * that */
-        if (!(record->system_flags & FLAG_ARCHIVED))
+        if (!(record->internal_flags & FLAG_INTERNAL_ARCHIVED))
             syslog(LOG_ERR, "IOERROR: bogus removal of archived flag for %s %u",
                    mailbox->name, record->uid);
     }
 
     /* handle immediate expunges here... */
-    if (immediate && (record->system_flags & FLAG_EXPUNGED))
-        record->system_flags |= FLAG_UNLINKED | FLAG_NEEDS_CLEANUP;
+    if (immediate && (record->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+        record->internal_flags |= FLAG_INTERNAL_UNLINKED | FLAG_INTERNAL_NEEDS_CLEANUP;
+    }
 
     /* make sure highestmodseq gets updated unless we're
      * being silent about it (i.e. marking an already EXPUNGED
@@ -3460,8 +3802,9 @@ EXPORTED int mailbox_rewrite_index_recor
         record->modseq = mailbox->i.highestmodseq;
         record->last_updated = mailbox->last_updated;
     }
+    assert(record->modseq >= oldrecord.modseq);
 
-    if (record->system_flags & FLAG_UNLINKED) {
+    if (record->internal_flags & FLAG_INTERNAL_UNLINKED) {
         /* mark required actions */
         if (expunge_mode == IMAP_ENUM_EXPUNGE_MODE_IMMEDIATE
             || mailbox->i.minor_version < 12)
@@ -3477,25 +3820,30 @@ EXPORTED int mailbox_rewrite_index_recor
     r = mailbox_update_indexes(mailbox, &oldrecord, record);
     if (r) return r;
 
-    if ((record->system_flags & FLAG_EXPUNGED) && !(changeflags & CHANGE_WASEXPUNGED)) {
+    if ((record->internal_flags & FLAG_INTERNAL_EXPUNGED) && !(changeflags & CHANGE_WASEXPUNGED)) {
         if (!mailbox->i.first_expunged || mailbox->i.first_expunged > record->last_updated)
             mailbox->i.first_expunged = record->last_updated;
         mailbox_annot_update_counts(mailbox, &oldrecord, 0);
     }
 
-    _store_change(mailbox, record, changeflags);
+    r = _store_change(mailbox, record, changeflags);
+    if (r) return r;
 
-    if (config_auditlog)
+    if (config_auditlog) {
+        char oldflags[FLAGMAPSTR_MAXLEN], sysflags[FLAGMAPSTR_MAXLEN];
+        flags_to_str(&oldrecord, oldflags);
+        flags_to_str(record, sysflags);
         syslog(LOG_NOTICE, "auditlog: touched sessionid=<%s> "
                "mailbox=<%s> uniqueid=<%s> uid=<%u> guid=<%s> cid=<%s> "
-               "modseq=<" MODSEQ_FMT "> oldflags=<%u> sysflags=<%u>",
-            session_id(), mailbox->name, mailbox->uniqueid,
-            record->uid, message_guid_encode(&record->guid),
-            conversation_id_encode(record->cid), record->modseq,
-            oldrecord.system_flags, record->system_flags);
+               "modseq=<" MODSEQ_FMT "> oldflags=<%s> sysflags=<%s>",
+               session_id(), mailbox->name, mailbox->uniqueid,
+               record->uid, message_guid_encode(&record->guid),
+               conversation_id_encode(record->cid), record->modseq,
+               oldflags, sysflags);
+    }
 
     /* expunged tracking */
-    if (record->system_flags & FLAG_EXPUNGED && (!mailbox->i.first_expunged || mailbox->i.first_expunged > record->last_updated))
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED && (!mailbox->i.first_expunged || mailbox->i.first_expunged > record->last_updated))
         mailbox->i.first_expunged = record->last_updated;
 
     return 0;
@@ -3555,7 +3903,13 @@ EXPORTED int mailbox_append_index_record
     else {
         mailbox_modseq_dirty(mailbox);
         record->modseq = mailbox->i.highestmodseq;
+        if (!record->createdmodseq || record->createdmodseq > record->modseq)
+            record->createdmodseq = record->modseq;
         record->last_updated = mailbox->last_updated;
+        if (!record->savedate) {
+            // store the time of actual append if requested
+            record->savedate = mailbox->last_updated;
+        }
     }
 
     int object_storage_enabled = 0 ;
@@ -3563,10 +3917,10 @@ EXPORTED int mailbox_append_index_record
     object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED) ;
 #endif
 
-    if (!(record->system_flags & FLAG_UNLINKED)) {
+    if (!(record->internal_flags & FLAG_INTERNAL_UNLINKED)) {
         /* make the file timestamp correct */
         settime.actime = settime.modtime = record->internaldate;
-        if (!(object_storage_enabled && record->system_flags & FLAG_ARCHIVED ))  // mabe there is no file in directory.
+        if (!(object_storage_enabled && (record->internal_flags & FLAG_INTERNAL_ARCHIVED)))  // mabe there is no file in directory.
             if (utime(mailbox_record_fname(mailbox, record), &settime) == -1)
                 return IMAP_IOERROR;
 
@@ -3581,79 +3935,92 @@ EXPORTED int mailbox_append_index_record
 
     record->recno = mailbox->i.num_records + 1;
 
-    _store_change(mailbox, record, changeflags);
-
     mailbox->i.last_uid = record->uid;
     mailbox->i.num_records = record->recno;
 
+    r = _store_change(mailbox, record, changeflags);
+    if (r) return r;
+
     /* expunged tracking */
-    if (record->system_flags & FLAG_EXPUNGED && (!mailbox->i.first_expunged || mailbox->i.first_expunged > record->last_updated))
+    if ((record->internal_flags & FLAG_INTERNAL_EXPUNGED) && (!mailbox->i.first_expunged || mailbox->i.first_expunged > record->last_updated))
         mailbox->i.first_expunged = record->last_updated;
 
     return 0;
 }
 
+EXPORTED void mailbox_cleanup_uid(struct mailbox *mailbox, uint32_t uid, const char *flagstr)
+{
+    const char *spoolfname = mailbox_spool_fname(mailbox, uid);
+    const char *archivefname = mailbox_archive_fname(mailbox, uid);
+
+    if (unlink(spoolfname) == 0) {
+        if (config_auditlog) {
+            syslog(LOG_NOTICE, "auditlog: unlink sessionid=<%s> "
+                   "mailbox=<%s> uniqueid=<%s> uid=<%u> sysflags=<%s>",
+                   session_id(), mailbox->name, mailbox->uniqueid,
+                   uid, flagstr);
+        }
+    }
+
+    if (strcmp(spoolfname, archivefname)) {
+        if (unlink(archivefname) == 0) {
+            if (config_auditlog) {
+                syslog(LOG_NOTICE, "auditlog: unlinkarchive sessionid=<%s> "
+                       "mailbox=<%s> uniqueid=<%s> uid=<%u> sysflags=<%s>",
+                       session_id(), mailbox->name, mailbox->uniqueid,
+                       uid, flagstr);
+            }
+        }
+    }
+}
+
 static void mailbox_record_cleanup(struct mailbox *mailbox,
                                    struct index_record *record)
 {
-    const char *spoolfname = mailbox_spool_fname(mailbox, record->uid);
-    const char *archivefname = mailbox_archive_fname(mailbox, record->uid);
-    int object_storage_enabled = 0;
-#if defined ENABLE_OBJECTSTORE
-    object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED);
-#endif
-    int r;
-
-    if (object_storage_enabled) {
 #if defined ENABLE_OBJECTSTORE
+    if (config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED)) {
         /* we always remove the spool file here, because we've archived it */
-        if (record->system_flags & FLAG_ARCHIVED)
+        if (record->system_flags & FLAG_INTERNAL_ARCHIVED)
             unlink(spoolfname);
 
         /* if the record is also deleted, we remove the objectstore copy */
-        if (record->system_flags & FLAG_UNLINKED)
+        if (record->system_flags & FLAG_INTERNAL_UNLINKED)
             objectstore_delete(mailbox, record);
-#endif
-    }
 
-    else if (record->system_flags & FLAG_UNLINKED) {
-        /* try to delete both */
+        return;
+    }
+#endif
 
-        if (unlink(spoolfname) == 0) {
-            if (config_auditlog)
-                syslog(LOG_NOTICE, "auditlog: unlink sessionid=<%s> "
-                       "mailbox=<%s> uniqueid=<%s> uid=<%u> sysflags=<%u>",
-                       session_id(), mailbox->name, mailbox->uniqueid,
-                       record->uid, record->system_flags);
-        }
+    if (record->internal_flags & FLAG_INTERNAL_UNLINKED) {
+        char flagstr[FLAGMAPSTR_MAXLEN];
+        flags_to_str(record, flagstr);
 
-        if (strcmp(spoolfname, archivefname)) {
-            if (unlink(archivefname) == 0) {
-                if (config_auditlog)
-                    syslog(LOG_NOTICE, "auditlog: unlinkarchive sessionid=<%s> "
-                            "mailbox=<%s> uniqueid=<%s> uid=<%u> sysflags=<%u>",
-                            session_id(), mailbox->name, mailbox->uniqueid,
-                            record->uid, record->system_flags);
-            }
-        }
+        /* remove both files */
+        mailbox_cleanup_uid(mailbox, record->uid, flagstr);
 
-        r = mailbox_get_annotate_state(mailbox, record->uid, NULL);
+        int r = mailbox_get_annotate_state(mailbox, record->uid, NULL);
         if (r) {
             syslog(LOG_ERR, "IOERROR: failed to open annotations %s %u: %s",
                    mailbox->name, record->uid, error_message(r));
-            return;
         }
 
         r = annotate_msg_cleanup(mailbox, record->uid);
         if (r) {
             syslog(LOG_ERR, "IOERROR: failed to cleanup annotations %s %u: %s",
                    mailbox->name, record->uid, error_message(r));
-            return;
         }
+
+        return;
     }
 
-    else if (strcmp(spoolfname, archivefname)) {
-        if (record->system_flags & FLAG_ARCHIVED) {
+    /* file is still alive - check if there's anything to clean up */
+
+    const char *spoolfname = mailbox_spool_fname(mailbox, record->uid);
+    const char *archivefname = mailbox_archive_fname(mailbox, record->uid);
+
+    /* don't cleanup if it's the same file! */
+    if (strcmp(spoolfname, archivefname)) {
+        if (record->internal_flags & FLAG_INTERNAL_ARCHIVED) {
             /* XXX - stat to make sure the other file exists first? - we mostly
             *  trust that we didn't do stupid things everywhere else, so maybe not */
             unlink(spoolfname);
@@ -3663,8 +4030,6 @@ static void mailbox_record_cleanup(struc
             unlink(archivefname);
         }
     }
-
-    /* else: nothing to cleanup if it's the same file! */
 }
 
 /* need a mailbox exclusive lock, we're removing files */
@@ -3682,12 +4047,13 @@ static int mailbox_index_unlink(struct m
     struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, 0);
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
-        /* still gotta check for FLAG_UNLINKED, because it may have been
+        /* still gotta check for FLAG_INTERNAL_UNLINKED, because it may have been
          * created by old code.  Woot */
-        if (record->system_flags & (FLAG_NEEDS_CLEANUP | FLAG_UNLINKED)) {
+        if ((record->internal_flags & FLAG_INTERNAL_NEEDS_CLEANUP) ||
+            record->internal_flags & FLAG_INTERNAL_UNLINKED) {
             struct index_record copyrecord = *record;
             mailbox_record_cleanup(mailbox, &copyrecord);
-            copyrecord.system_flags &= ~FLAG_NEEDS_CLEANUP;
+            copyrecord.internal_flags &= ~FLAG_INTERNAL_NEEDS_CLEANUP;
             copyrecord.silent = 1;
             /* XXX - error handling */
             mailbox_rewrite_index_record(mailbox, &copyrecord);
@@ -3713,61 +4079,82 @@ static int mailbox_repack_setup(struct m
     unsigned char *buf = ibuf.buf;
     int n;
 
+    /* if we're changing version at all, recalculate counts up-front */
+    if (version != mailbox->i.minor_version) {
+        /* NOTE: this maps in annot_state in mailbox, which will get copied
+         * into newmailbox below, which means all the annotate stuff later
+         * is going to be good!  The counters will be updated in the original
+         * mailbox index, but that's OK because we recalc everything at the
+         * end */
+        int r = mailbox_index_recalc(mailbox);
+        if (r) goto fail;
+    }
+
     /* init */
     repack->mailbox = mailbox;
-    repack->i = mailbox->i; /* struct copy */
-    repack->newindex_fd = -1;
+    repack->crcs = mailbox->i.synccrcs;
+    repack->newmailbox = *mailbox; // struct copy
+    repack->newmailbox.index_fd = -1;
 
     /* new files */
     fname = mailbox_meta_newfname(mailbox, META_INDEX);
-    repack->newindex_fd = open(fname, O_RDWR|O_TRUNC|O_CREAT, 0666);
-    if (repack->newindex_fd == -1) {
+    repack->newmailbox.index_fd = open(fname, O_RDWR|O_TRUNC|O_CREAT, 0666);
+    if (repack->newmailbox.index_fd == -1) {
         syslog(LOG_ERR, "IOERROR: failed to create %s: %m", fname);
         goto fail;
     }
 
     /* update the generation number */
-    repack->i.generation_no++;
+    repack->newmailbox.i.generation_no++;
 
     /* track the version number */
-    repack->old_version = repack->i.minor_version;
-    repack->i.minor_version = version;
+    repack->newmailbox.i.minor_version = version;
     switch (version) {
     case 6:
-        repack->i.start_offset = 76;
-        repack->i.record_size = 60;
+        repack->newmailbox.i.start_offset = 76;
+        repack->newmailbox.i.record_size = 60;
         break;
     case 7:
-        repack->i.start_offset = 76;
-        repack->i.record_size = 72;
+        repack->newmailbox.i.start_offset = 76;
+        repack->newmailbox.i.record_size = 72;
         break;
     case 8:
-        repack->i.start_offset = 92;
-        repack->i.record_size = 80;
+        repack->newmailbox.i.start_offset = 92;
+        repack->newmailbox.i.record_size = 80;
         break;
     case 9:
-        repack->i.start_offset = 96;
-        repack->i.record_size = 80;
+        repack->newmailbox.i.start_offset = 96;
+        repack->newmailbox.i.record_size = 80;
         break;
     case 10:
-        repack->i.start_offset = 96;
-        repack->i.record_size = 88;
+        repack->newmailbox.i.start_offset = 96;
+        repack->newmailbox.i.record_size = 88;
         break;
     /* 11 was FastMail internal */
     case 12:
-        repack->i.start_offset = 128;
-        repack->i.record_size = 96;
+        repack->newmailbox.i.start_offset = 128;
+        repack->newmailbox.i.record_size = 96;
         break;
     case 13:
-        repack->i.start_offset = 128;
-        repack->i.record_size = 104;
+        repack->newmailbox.i.start_offset = 128;
+        repack->newmailbox.i.record_size = 104;
+        break;
+    case 14:
+        /* version 15 just repurposed a field */
+    case 15:
+        repack->newmailbox.i.start_offset = 160;
+        repack->newmailbox.i.record_size = 104;
+        break;
+    case 16:
+        repack->newmailbox.i.start_offset = 160;
+        repack->newmailbox.i.record_size = 112;
         break;
     default:
-        fatal("index version not supported", EC_SOFTWARE);
+        fatal("index version not supported", EX_SOFTWARE);
     }
 
     /* upgrades or downgrades across version 12 boundary?  Sort out seen state */
-    if (version >= 12 && repack->old_version < 12) {
+    if (version >= 12 && mailbox->i.minor_version < 12) {
         /* we need to read the current seen state for the owner */
         struct seendata sd = SEENDATA_INITIALIZER;
         int r = IMAP_MAILBOX_NONEXISTENT;
@@ -3784,13 +4171,13 @@ static int mailbox_repack_setup(struct m
         }
 
         if (!r) {
-            repack->i.recentuid = sd.lastuid;
-            repack->i.recenttime = sd.lastchange;
+            repack->newmailbox.i.recentuid = sd.lastuid;
+            repack->newmailbox.i.recenttime = sd.lastchange;
             repack->seqset = seqset_parse(sd.seenuids, NULL, sd.lastuid);
             seen_freedata(&sd);
         }
     }
-    else if (version < 12 && repack->old_version >= 12) {
+    else if (version < 12 && mailbox->i.minor_version >= 12) {
         if (mailbox->i.options & OPT_IMAP_SHAREDSEEN)
             repack->userid = xstrdup("anyone");
         else
@@ -3801,29 +4188,28 @@ static int mailbox_repack_setup(struct m
             repack->seqset = seqset_init(mailbox->i.last_uid, SEQ_MERGE);
     }
 
-    /* zero out some values */
-    repack->i.num_records = 0;
-    repack->i.quota_mailbox_used = 0;
-    repack->i.num_records = 0;
-    /*
-     * Note, we don't recalculate the mailbox' sync CRC on repack, because
-     * the sync CRC may depend on annotation values which we don't want to
-     * go looking up at this time.  A call to mailbox_index_recalc() will
-     * however recalculate the sync CRC from scratch.
-     */
-    repack->i.answered = 0;
-    repack->i.deleted = 0;
-    repack->i.flagged = 0;
-    repack->i.exists = 0;
-    repack->i.first_expunged = 0;
-    repack->i.leaked_cache_records = 0;
+    /* we'll count the records as they get added */
+    repack->newmailbox.i.num_records = 0;
+    /* we're recreating caches, so there'll be nothing leaked */
+    repack->newmailbox.i.leaked_cache_records = 0;
 
     /* prepare initial header buffer */
-    mailbox_index_header_to_buf(&repack->i, buf);
+    mailbox_index_header_to_buf(&repack->newmailbox.i, buf);
 
-    n = retry_write(repack->newindex_fd, buf, repack->i.start_offset);
+    n = retry_write(repack->newmailbox.index_fd, buf, repack->newmailbox.i.start_offset);
     if (n == -1) goto fail;
 
+    if (version != mailbox->i.minor_version) {
+        /* we're might be reading this file as we go, so let's
+         * start the job by mapping the new file into the newmailbox!
+         */
+        repack->newmailbox.index_size = 0;
+        repack->newmailbox.index_base = NULL;
+        repack->newmailbox.index_len = 0;
+        int r = mailbox_refresh_index_map(&repack->newmailbox);
+        if (r) goto fail;
+    }
+
     *repackptr = repack;
     return 0;
 
@@ -3849,16 +4235,13 @@ static int mailbox_repack_add(struct mai
     r = cache_append_record(cachefile, record);
     if (r) return r;
 
-    /* update counters */
-    header_update_counts(&repack->i, record, 1);
-
     /* write the index record out */
-    mailbox_index_record_to_buf(record, repack->i.minor_version, buf);
-    n = retry_write(repack->newindex_fd, buf, repack->i.record_size);
+    mailbox_index_record_to_buf(record, repack->newmailbox.i.minor_version, buf);
+    n = retry_write(repack->newmailbox.index_fd, buf, repack->newmailbox.i.record_size);
     if (n == -1)
         return IMAP_IOERROR;
 
-    repack->i.num_records++;
+    repack->newmailbox.i.num_records++;
 
     return 0;
 }
@@ -3873,7 +4256,7 @@ static void mailbox_repack_abort(struct
     seqset_free(repack->seqset);
 
     /* close and remove index */
-    xclose(repack->newindex_fd);
+    xclose(repack->newmailbox.index_fd);
     unlink(mailbox_meta_newfname(repack->mailbox, META_INDEX));
 
     /* close and remove all new caches */
@@ -3888,6 +4271,13 @@ static void mailbox_repack_abort(struct
     }
     ptrarray_fini(&repack->caches);
 
+    // drop the map if we've mapped in the newmailbox index separately
+    if (repack->newmailbox.index_base != repack->mailbox->index_base) {
+        map_free(&repack->newmailbox.index_base, &repack->newmailbox.index_len);
+    }
+
+    mailbox_abort(repack->mailbox);
+
     free(repack->userid);
     free(repack);
     *repackptr = NULL;
@@ -3906,22 +4296,39 @@ HIDDEN int mailbox_repack_commit(struct
 
     assert(repack);
 
-    repack->i.last_repack_time = time(0);
+    /* if we changed versions, we'll re-calculate counts on the new mailbox too */
+    if (repack->newmailbox.i.minor_version != repack->mailbox->i.minor_version) {
+        r = mailbox_refresh_index_map(&repack->newmailbox);
+        if (r) goto fail;
+        r = mailbox_index_recalc(&repack->newmailbox);
+        if (r) goto fail;
+    }
 
-    assert(repack->i.synccrcs.basic == repack->mailbox->i.synccrcs.basic);
-    assert(repack->i.synccrcs.annot == repack->mailbox->i.synccrcs.annot);
+    if (repack->newmailbox.i.minor_version >= 10 &&
+            repack->mailbox->i.minor_version >= 10 &&
+            !mailbox_crceq(repack->newmailbox.i.synccrcs, repack->crcs)) {
+        syslog(LOG_ERR, "IOERROR: CRC mismatch on repack commit: %s (%u %u) (%u %u)",
+               repack->mailbox->name,
+               repack->crcs.basic, repack->newmailbox.i.synccrcs.basic,
+               repack->crcs.annot, repack->newmailbox.i.synccrcs.annot);
+        r = IMAP_MAILBOX_CHECKSUM;
+        goto fail;
+    }
+
+    repack->newmailbox.i.last_repack_time = time(0);
 
-    if (repack->old_version >= 12 && repack->i.minor_version < 12
+    if (repack->mailbox->i.minor_version >= 12 && repack->newmailbox.i.minor_version < 12
         && repack->seqset && repack->userid) {
         struct seendata sd = SEENDATA_INITIALIZER;
         struct seen *seendb = NULL;
         int r = seen_open(repack->userid, SEEN_CREATE, &seendb);
         if (!r) r = seen_lockread(seendb, repack->mailbox->uniqueid, &sd);
         if (!r) {
-            sd.lastuid = repack->i.last_uid;
+            sd.lastuid = repack->newmailbox.i.last_uid;
             sd.seenuids = seqset_cstring(repack->seqset);
+            if (!sd.seenuids) sd.seenuids = xstrdup("");
             sd.lastread = time(NULL);
-            sd.lastchange = repack->i.last_appenddate;
+            sd.lastchange = repack->newmailbox.i.last_appenddate;
             r = seen_write(seendb, repack->mailbox->uniqueid, &sd);
             /* XXX - syslog on errors? */
         }
@@ -3930,19 +4337,19 @@ HIDDEN int mailbox_repack_commit(struct
     }
 
     /* rewrite the header with updated details */
-    mailbox_index_header_to_buf(&repack->i, buf);
+    mailbox_index_header_to_buf(&repack->newmailbox.i, buf);
 
-    if (lseek(repack->newindex_fd, 0, SEEK_SET) < 0)
+    if (lseek(repack->newmailbox.index_fd, 0, SEEK_SET) < 0)
         goto fail;
 
-    if (retry_write(repack->newindex_fd, buf, repack->i.start_offset) < 0)
+    if (retry_write(repack->newmailbox.index_fd, buf, repack->newmailbox.i.start_offset) < 0)
         goto fail;
 
     /* ensure everything is committed to disk */
-    if (fsync(repack->newindex_fd) < 0)
+    if (fsync(repack->newmailbox.index_fd) < 0)
         goto fail;
 
-    xclose(repack->newindex_fd);
+    xclose(repack->newmailbox.index_fd);
 
     /* NOTE: cache files need committing before index is renamed */
     for (i = 0; i < repack->caches.count; i++) {
@@ -3982,6 +4389,11 @@ HIDDEN int mailbox_repack_commit(struct
 
     strarray_fini(&cachefiles);
 
+    // drop the map if we've mapped in the newmailbox index separately
+    if (repack->newmailbox.index_base != repack->mailbox->index_base) {
+        map_free(&repack->newmailbox.index_base, &repack->newmailbox.index_len);
+    }
+
     seqset_free(repack->seqset);
     free(repack->userid);
     free(repack);
@@ -3991,6 +4403,7 @@ HIDDEN int mailbox_repack_commit(struct
  fail:
     strarray_fini(&cachefiles);
     mailbox_repack_abort(repackptr);
+    if (!r) r = IMAP_IOERROR;
     return r;
 }
 
@@ -4000,6 +4413,7 @@ static int mailbox_index_repack(struct m
     struct mailbox_repack *repack = NULL;
     const message_t *msg;
     struct mailbox_iter *iter = NULL;
+    struct buf buf = BUF_INITIALIZER;
     int r = IMAP_IOERROR;
 
     syslog(LOG_INFO, "Repacking mailbox %s version %d", mailbox->name, version);
@@ -4011,49 +4425,130 @@ static int mailbox_index_repack(struct m
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
         struct index_record copyrecord = *record;
+        int needs_cache_upgrade = 0;
+        annotate_state_t *astate = NULL;
 
-        /* version changes? */
-        if (repack->old_version < 12 && repack->i.minor_version >= 12) {
-            const char *fname = mailbox_record_fname(mailbox, &copyrecord);
+        r = mailbox_get_annotate_state(mailbox, record->uid, &astate);
+        if (r) goto done;
 
+        /* version changes? */
+        if (mailbox->i.minor_version < 12 && repack->newmailbox.i.minor_version >= 12) {
             if (seqset_ismember(repack->seqset, copyrecord.uid))
                 copyrecord.system_flags |= FLAG_SEEN;
             else
                 copyrecord.system_flags &= ~FLAG_SEEN;
 
-            /* XXX - re-parse the record iff upgrading past 12 */
-            if (message_parse(fname, &copyrecord)) {
-                /* failed to parse, don't try to write out record */
-                copyrecord.crec.len = 0;
-                /* and the record is expunged too! */
-                copyrecord.system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
-                syslog(LOG_ERR, "IOERROR: FATAL - failed to parse file for %s %u, expunging",
-                       repack->mailbox->name, copyrecord.uid);
-            }
+            needs_cache_upgrade = 1;
+
         }
-        if (repack->old_version >= 12 && repack->i.minor_version < 12) {
+        if (mailbox->i.minor_version >= 12 && repack->newmailbox.i.minor_version < 12) {
             if (repack->seqset)
                 seqset_add(repack->seqset, copyrecord.uid, copyrecord.system_flags & FLAG_SEEN ? 1 : 0);
             copyrecord.system_flags &= ~FLAG_SEEN;
         }
 
+        /* force cache upgrade across version 15 repack */
+        if (repack->newmailbox.i.minor_version >= 15 && record->cache_version < 9)
+            needs_cache_upgrade = 1;
+
         /* better handle the cleanup just in case it's unlinked too */
-        /* still gotta check for FLAG_UNLINKED, because it may have been
+        /* still gotta check for FLAG_INTERNAL_UNLINKED, because it may have been
          * created by old code.  Woot */
-        if (copyrecord.system_flags & (FLAG_NEEDS_CLEANUP | FLAG_UNLINKED)) {
+        if (copyrecord.internal_flags & (FLAG_INTERNAL_NEEDS_CLEANUP | FLAG_INTERNAL_UNLINKED)) {
             mailbox_record_cleanup(mailbox, &copyrecord);
-            copyrecord.system_flags &= ~FLAG_NEEDS_CLEANUP;
+            copyrecord.internal_flags &= ~FLAG_INTERNAL_NEEDS_CLEANUP;
             /* no need to rewrite - it's already being written to the new file */
         }
 
         /* we aren't keeping unlinked files, that's kind of the point */
-        if (copyrecord.system_flags & FLAG_UNLINKED) {
+        if (copyrecord.internal_flags & FLAG_INTERNAL_UNLINKED) {
             /* track the modseq for QRESYNC purposes */
-            if (copyrecord.modseq > repack->i.deletedmodseq)
-                repack->i.deletedmodseq = copyrecord.modseq;
+            if (copyrecord.modseq > repack->newmailbox.i.deletedmodseq)
+                repack->newmailbox.i.deletedmodseq = copyrecord.modseq;
             continue;
         }
 
+        if (needs_cache_upgrade) {
+            const char *fname = mailbox_record_fname(mailbox, &copyrecord);
+
+            if (message_parse(fname, &copyrecord)) {
+                /* failed to parse, don't try to write out record */
+                copyrecord.crec.len = 0;
+                /* and the record is expunged too! */
+                copyrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
+                syslog(LOG_ERR, "IOERROR: FATAL - failed to parse file for %s %u, expunging",
+                       repack->mailbox->name, copyrecord.uid);
+            }
+        }
+
+        /* virtual annotations */
+        if (mailbox->i.minor_version < 13 && repack->newmailbox.i.minor_version >= 13) {
+            /* extract CID */
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record->uid, IMAP_ANNOT_NS "thrid", "", &buf);
+            if (buf.len == 16) {
+                const char *p = buf_cstring(&buf);
+                parsehex(p, &p, 16, &copyrecord.cid);
+            }
+            buf_reset(&buf);
+            r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "thrid", "", &buf);
+            if (r) goto done;
+        }
+        if (mailbox->i.minor_version >= 13 && repack->newmailbox.i.minor_version < 13) {
+            if (record->cid) {
+                buf_reset(&buf);
+                buf_printf(&buf, "%llx", record->cid);
+                r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "thrid", "", &buf);
+                if (r) goto done;
+            }
+        }
+
+        if (mailbox->i.minor_version < 15 && repack->newmailbox.i.minor_version >= 15) {
+            /* extract CID */
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record->uid, IMAP_ANNOT_NS "savedate", "", &buf);
+            if (buf.len) {
+                const char *p = buf_cstring(&buf);
+                bit64 newval;
+                parsenum(p, &p, 0, &newval);
+                copyrecord.savedate = newval;
+            }
+            buf_reset(&buf);
+            r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "savedate", "", &buf);
+            if (r) goto done;
+        }
+        if (mailbox->i.minor_version >= 15 && repack->newmailbox.i.minor_version < 15) {
+            if (record->savedate) {
+                buf_reset(&buf);
+                buf_printf(&buf, "%lu", record->savedate);
+                r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "savedate", "", &buf);
+                if (r) goto done;
+            }
+        }
+
+        if (mailbox->i.minor_version < 16 && repack->newmailbox.i.minor_version >= 16) {
+            /* extract CID */
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record->uid, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+            if (buf.len) {
+                const char *p = buf_cstring(&buf);
+                bit64 newval;
+                parsenum(p, &p, 0, &newval);
+                copyrecord.createdmodseq = newval;
+            }
+            buf_reset(&buf);
+            r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+            if (r) goto done;
+        }
+        if (mailbox->i.minor_version >= 16 && repack->newmailbox.i.minor_version < 16) {
+            if (record->createdmodseq) {
+                buf_reset(&buf);
+                buf_printf(&buf, "%llu", record->createdmodseq);
+                r = annotate_state_writesilent(astate, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+                if (r) goto done;
+            }
+        }
+
         /* read in the old cache record */
         r = mailbox_cacherecord(mailbox, &copyrecord);
         if (r) goto done;
@@ -4063,10 +4558,11 @@ static int mailbox_index_repack(struct m
     }
 
     /* we unlinked any "needs unlink" in the process */
-    repack->i.options &= ~(OPT_MAILBOX_NEEDS_REPACK|OPT_MAILBOX_NEEDS_UNLINK);
+    repack->newmailbox.i.options &= ~(OPT_MAILBOX_NEEDS_REPACK|OPT_MAILBOX_NEEDS_UNLINK);
 
 done:
     mailbox_iter_done(&iter);
+    buf_free(&buf);
     if (r) mailbox_repack_abort(&repack);
     else r = mailbox_repack_commit(&repack);
     return r;
@@ -4100,8 +4596,8 @@ EXPORTED unsigned mailbox_should_archive
                                          const struct index_record *record,
                                          void *rock)
 {
-    int archive_days = config_getint(IMAPOPT_ARCHIVE_DAYS);
-    time_t cutoff = time(0) - (archive_days * 86400);
+    int archive_after = config_getduration(IMAPOPT_ARCHIVE_AFTER, 'd');
+    time_t cutoff = time(0) - archive_after;
     if (rock) cutoff = *((time_t *)rock);
 
     int archive_size = config_getint(IMAPOPT_ARCHIVE_MAXSIZE);
@@ -4110,7 +4606,7 @@ EXPORTED unsigned mailbox_should_archive
     int keepflagged = config_getswitch(IMAPOPT_ARCHIVE_KEEPFLAGGED);
 
     /* never pull messages back from the archives */
-    if (record->system_flags & FLAG_ARCHIVED)
+    if (record->internal_flags & FLAG_INTERNAL_ARCHIVED)
         return 1;
 
     /* first check if we're archiving anything */
@@ -4126,7 +4622,7 @@ EXPORTED unsigned mailbox_should_archive
         return 1;
 
     /* anything already deleted */
-    if (record->system_flags & FLAG_EXPUNGED)
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return 1;
 
     /* Calendar and Addressbook are small files and need to be hot */
@@ -4182,7 +4678,7 @@ EXPORTED void mailbox_archive(struct mai
         const struct index_record *record = msg_record(msg);
         const char *action = NULL;
         if (decideproc(mailbox, record, deciderock)) {
-            if (record->system_flags & FLAG_ARCHIVED)
+            if (record->internal_flags & FLAG_INTERNAL_ARCHIVED)
                 continue;
             copyrecord = *record;
             srcname = mailbox_spool_fname(mailbox, copyrecord.uid);
@@ -4210,12 +4706,12 @@ EXPORTED void mailbox_archive(struct mai
                     syslog(LOG_ERR, "unlink(%s) failed: %m", srcname);
             }
 #endif
-            copyrecord.system_flags |= FLAG_ARCHIVED | FLAG_NEEDS_CLEANUP;
+            copyrecord.internal_flags |= FLAG_INTERNAL_ARCHIVED | FLAG_INTERNAL_NEEDS_CLEANUP;
             action = "archive";
         }
         else
         {
-            if (!(record->system_flags & FLAG_ARCHIVED))
+            if (!(record->internal_flags & FLAG_INTERNAL_ARCHIVED))
                 continue;
             copyrecord = *record;
             destname = mailbox_spool_fname(mailbox, copyrecord.uid);
@@ -4242,15 +4738,15 @@ EXPORTED void mailbox_archive(struct mai
             }
 #endif
 
-            copyrecord.system_flags &= ~FLAG_ARCHIVED;
-            copyrecord.system_flags |= FLAG_NEEDS_CLEANUP;
+            copyrecord.internal_flags &= ~FLAG_INTERNAL_ARCHIVED;
+            copyrecord.internal_flags |= FLAG_INTERNAL_NEEDS_CLEANUP;
             action = "unarchive";
         }
 
         if (!object_storage_enabled){
             /* got a file to copy! */
             if (strcmp(srcname, destname)) {
-                r = cyrus_copyfile(srcname, destname, COPYFILE_MKDIR);
+                r = cyrus_copyfile(srcname, destname, COPYFILE_MKDIR|COPYFILE_KEEPTIME);
                 if (r) {
                     syslog(LOG_ERR, "IOERROR archive %s %u failed to copyfile (%s => %s): %s",
                            mailbox->name, copyrecord.uid, srcname, destname, error_message(r));
@@ -4274,11 +4770,15 @@ EXPORTED void mailbox_archive(struct mai
             continue;
         mailbox->i.options |= OPT_MAILBOX_NEEDS_UNLINK;
 
-        if (config_auditlog)
-            syslog(LOG_NOTICE, "auditlog: %s sessionid=<%s> mailbox=<%s> uniqueid=<%s> uid=<%u> guid=<%s> cid=<%s> sysflags=<%u>",
-                    action, session_id(), mailbox->name, mailbox->uniqueid, copyrecord.uid,
-                    message_guid_encode(&copyrecord.guid), conversation_id_encode(copyrecord.cid),
-                    copyrecord.system_flags);
+        if (config_auditlog) {
+            char flagstr[FLAGMAPSTR_MAXLEN];
+            flags_to_str(&copyrecord, flagstr);
+            syslog(LOG_NOTICE, "auditlog: %s sessionid=<%s> mailbox=<%s> "
+                   "uniqueid=<%s> uid=<%u> guid=<%s> cid=<%s> sysflags=<%s>",
+                   action, session_id(), mailbox->name, mailbox->uniqueid,
+                   copyrecord.uid, message_guid_encode(&copyrecord.guid),
+                   conversation_id_encode(copyrecord.cid), flagstr);
+        }
     }
     mailbox_iter_done(&iter);
 
@@ -4302,7 +4802,7 @@ EXPORTED void mailbox_remove_files_from_
     struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, flags);
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
-        if (!(record->system_flags & FLAG_ARCHIVED))
+        if (!(record->internal_flags & FLAG_INTERNAL_ARCHIVED))
             continue;
 #if defined ENABLE_OBJECTSTORE
         if (object_storage_enabled)
@@ -4352,7 +4852,7 @@ EXPORTED int mailbox_expunge(struct mail
 
             struct index_record copyrecord = *record;
             /* mark deleted */
-            copyrecord.system_flags |= FLAG_EXPUNGED;
+            copyrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
 
             r = mailbox_rewrite_index_record(mailbox, &copyrecord);
             if (r) {
@@ -4397,13 +4897,13 @@ EXPORTED int mailbox_expunge_cleanup(str
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
         /* already unlinked, skip it (but dirty so we mark a repack is needed) */
-        if (record->system_flags & FLAG_UNLINKED) {
+        if (record->internal_flags & FLAG_INTERNAL_UNLINKED) {
             dirty = 1;
             continue;
         }
 
         /* not actually expunged, skip it */
-        if (!(record->system_flags & FLAG_EXPUNGED))
+        if (!(record->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         /* not stale enough yet, skip it - but track the updated time
@@ -4419,7 +4919,7 @@ EXPORTED int mailbox_expunge_cleanup(str
         numdeleted++;
 
         struct index_record copyrecord = *record;
-        copyrecord.system_flags |= FLAG_UNLINKED;
+        copyrecord.internal_flags |= FLAG_INTERNAL_UNLINKED;
         copyrecord.silent = 1;
         if (mailbox_rewrite_index_record(mailbox, &copyrecord)) {
             syslog(LOG_ERR, "IOERROR: failed to mark unlinked %s %u (recno %d)",
@@ -4464,11 +4964,14 @@ EXPORTED int mailbox_internal_seen(const
  */
 unsigned mailbox_count_unseen(struct mailbox *mailbox)
 {
+    assert(mailbox_index_islocked(mailbox, 0));
+
+    if (mailbox->i.minor_version > 13)
+        return mailbox->i.unseen;
+
     const message_t *msg;
     unsigned count = 0;
 
-    assert(mailbox_index_islocked(mailbox, 0));
-
     struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
@@ -4489,6 +4992,7 @@ EXPORTED int mailbox_create(const char *
                    const char *uniqueid,
                    int options,
                    unsigned uidvalidity,
+                   modseq_t createdmodseq,
                    modseq_t highestmodseq,
                    struct mailbox **mailboxptr)
 {
@@ -4513,7 +5017,7 @@ EXPORTED int mailbox_create(const char *
 
     /* if we can't get an exclusive lock first try, there's something
      * racy going on! */
-    /* an exclusive lock around the non-execlusive lock to avoid create
+    /* an exclusive lock around the non-exclusive lock to avoid create
      * races on fixed names like calendar Inbox and Outbox */
     struct mboxlock *mblock = NULL;
     r = mboxname_lock("$CREATE", &mblock, LOCK_EXCLUSIVE);
@@ -4525,6 +5029,8 @@ EXPORTED int mailbox_create(const char *
     mailbox->acl = xstrdup(acl);
     mailbox->mbtype = mbtype;
     mailbox->uniqueid = xstrdup(uniqueid);
+    // if we've been given a highestmodseq, we don't update it
+    if (highestmodseq) mailbox->silentchanges = 1;
 
     hasquota = quota_findroot(quotaroot, sizeof(quotaroot), name);
 
@@ -4557,6 +5063,15 @@ EXPORTED int mailbox_create(const char *
         goto done;
     }
 
+    /* open conversations FIRST */
+    r = mailbox_lock_conversations(mailbox, LOCK_EXCLUSIVE);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: locking conversations %s %s",
+               mailbox->name, error_message(r));
+        r = IMAP_IOERROR;
+        goto done;
+    }
+
     fname = mailbox_meta_fname(mailbox, META_INDEX);
     if (!fname) {
         syslog(LOG_ERR, "IOERROR: Mailbox name too long (%s)", mailbox->name);
@@ -4576,13 +5091,6 @@ EXPORTED int mailbox_create(const char *
         goto done;
     }
     mailbox->index_locktype = LOCK_EXCLUSIVE;
-    r = mailbox_lock_conversations(mailbox);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: locking conversations %s %s",
-               mailbox->name, error_message(r));
-        r = IMAP_IOERROR;
-        goto done;
-    }
 
     if (hasquota) {
         mailbox_set_quotaroot(mailbox, quotaroot);
@@ -4602,6 +5110,10 @@ EXPORTED int mailbox_create(const char *
     else
         mboxname_setmodseq(mailbox->name, highestmodseq, mbtype, /*dofolder*/1);
 
+    /* and created modseq */
+    if (!createdmodseq || createdmodseq > highestmodseq)
+        createdmodseq = highestmodseq;
+
     /* init non-zero fields */
     mailbox_index_dirty(mailbox);
     mailbox->i.minor_version = MAILBOX_MINOR_VERSION;
@@ -4609,7 +5121,10 @@ EXPORTED int mailbox_create(const char *
     mailbox->i.record_size = INDEX_RECORD_SIZE;
     mailbox->i.options = options;
     mailbox->i.uidvalidity = uidvalidity;
+    mailbox->i.createdmodseq = createdmodseq;
     mailbox->i.highestmodseq = highestmodseq;
+    mailbox->i.synccrcs.basic = CRC_INIT_BASIC;
+    mailbox->i.synccrcs.annot = CRC_INIT_ANNOT;
 
     /* initialise header size field so appends calculate the
      * correct map size */
@@ -4667,7 +5182,7 @@ static void mailbox_delete_files(const c
 
     if(strlen(buf) >= sizeof(buf) - 2) {
         syslog(LOG_ERR, "IOERROR: Path too long (%s)", buf);
-        fatal("path too long", EC_OSFILE);
+        fatal("path too long", EX_OSFILE);
     }
 
     tail = buf + strlen(buf);
@@ -4689,7 +5204,7 @@ static void mailbox_delete_files(const c
             if(strlen(buf) + strlen(f->d_name) >= sizeof(buf)) {
                 syslog(LOG_ERR, "IOERROR: Path too long (%s + %s)",
                        buf, f->d_name);
-                fatal("Path too long", EC_OSFILE);
+                fatal("Path too long", EX_OSFILE);
             }
             strcpy(tail, f->d_name);
             unlink(buf);
@@ -4705,7 +5220,7 @@ static int chkchildren(const mbentry_t *
 {
     const char *part = (const char *)rock;
 
-    if (!strcmp(part, mbentry->partition))
+    if (!strcmpnull(part, mbentry->partition))
         return CYRUSDB_DONE;
 
     return 0;
@@ -4738,7 +5253,7 @@ EXPORTED int mailbox_add_dav(struct mail
 
 #endif /* WITH_DAV */
 
-EXPORTED int mailbox_add_conversations(struct mailbox *mailbox)
+EXPORTED int mailbox_add_conversations(struct mailbox *mailbox, int silent)
 {
     const message_t *msg;
     int r = 0;
@@ -4749,7 +5264,7 @@ EXPORTED int mailbox_add_conversations(s
 
     /* add record for mailbox */
     conv_status_t status = CONV_STATUS_INIT;
-    status.modseq = mailbox->i.highestmodseq;
+    status.threadmodseq = mailbox->i.highestmodseq;
     r = conversation_setstatus(cstate, mailbox->name, &status);
     if (r) return r;
 
@@ -4761,13 +5276,27 @@ EXPORTED int mailbox_add_conversations(s
             continue;
 
         struct index_record copyrecord = *record;
-        r = mailbox_update_conversations(mailbox, NULL, &copyrecord);
+        copyrecord.silent = silent;
+        r = conversations_update_record(cstate, mailbox, NULL, &copyrecord, 1);
         if (r) break;
 
         if (copyrecord.cid == record->cid)
             continue;
 
-        /* we had a cid change? */
+        assert(!silent); // can't change cid if silent!
+
+        /* remove this record again */
+        r = conversations_update_record(cstate, mailbox, &copyrecord, NULL, 0);
+        if (r) break;
+
+        /* we had a cid change, so rewrite will try to correct the counts, so we
+         * need to add this one in again */
+        struct index_record oldrecord = *record;
+        /* add the old record that's going away */
+        r = conversations_update_record(cstate, mailbox, NULL, &oldrecord, 0);
+        if (r) break;
+
+        /* and finally to the update that will reverse those two actions again */
         r = mailbox_rewrite_index_record(mailbox, &copyrecord);
         if (r) break;
     }
@@ -4791,7 +5320,7 @@ static int mailbox_delete_conversations(
         if (!record->cid)
             continue;
 
-        r = mailbox_update_conversations(mailbox, record, NULL);
+        r = conversations_update_record(cstate, mailbox, record, NULL, 0);
         if (r) break;
     }
     mailbox_iter_done(&iter);
@@ -4850,6 +5379,16 @@ static int mailbox_delete_internal(struc
     return 0;
 }
 
+#ifdef WITH_JMAP
+static int mailbox_delete_alarms(struct mailbox *mailbox)
+{
+    if (!(mailbox->i.options & OPT_IMAP_HAS_ALARMS))
+        return 0;
+
+    return caldav_alarm_delete_mailbox(mailbox->name);
+}
+#endif /* WITH_JMAP */
+
 #ifdef WITH_DAV
 static int mailbox_delete_caldav(struct mailbox *mailbox)
 {
@@ -4920,6 +5459,11 @@ EXPORTED int mailbox_delete(struct mailb
     r = mailbox_delete_conversations(mailbox);
     if (r) return r;
 
+#ifdef WITH_JMAP
+    r = mailbox_delete_alarms(mailbox);
+    if (r) return r;
+#endif /* WITH_JMAP */
+
 #ifdef WITH_DAV
     r = mailbox_delete_dav(mailbox);
     if (r) return r;
@@ -4965,7 +5509,7 @@ HIDDEN int mailbox_delete_cleanup(struct
     object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED);
 #endif
 
-    strncpy(nbuf, name, sizeof(nbuf));
+    xstrncpy(nbuf, name, sizeof(nbuf));
     ntail = nbuf + strlen(nbuf);
 
     if (mailbox && object_storage_enabled){
@@ -5071,20 +5615,20 @@ EXPORTED int mailbox_copy_files(struct m
         const struct index_record *record = msg_record(msg);
         xstrncpy(oldbuf, mailbox_record_fname(mailbox, record),
                 MAX_MAILBOX_PATH);
-        if (!object_storage_enabled && record->system_flags & FLAG_ARCHIVED)
+        if (!object_storage_enabled && record->internal_flags & FLAG_INTERNAL_ARCHIVED)
             xstrncpy(newbuf, mboxname_archivepath(newpart, newname, newuniqueid, record->uid),
                     MAX_MAILBOX_PATH);
         else
             xstrncpy(newbuf, mboxname_datapath(newpart, newname, newuniqueid, record->uid),
                     MAX_MAILBOX_PATH);
 
-        if (!(object_storage_enabled && record->system_flags & FLAG_ARCHIVED ))    // if object storage do not move file
+        if (!(object_storage_enabled && record->internal_flags & FLAG_INTERNAL_ARCHIVED))    // if object storage do not move file
            r = mailbox_copyfile(oldbuf, newbuf, 0);
 
         if (r) break;
 
 #if defined ENABLE_OBJECTSTORE
-        if (object_storage_enabled && record->system_flags & FLAG_ARCHIVED) {
+        if (object_storage_enabled && record->internal_flags & FLAG_INTERNAL_ARCHIVED) {
             static struct mailbox new_mailbox;
             memset(&new_mailbox, 0, sizeof(struct mailbox));
             new_mailbox.name = (char*) newname;
@@ -5109,6 +5653,7 @@ HIDDEN int mailbox_rename_copy(struct ma
                         const char *newpartition,
                         unsigned uidvalidity,
                         const char *userid, int ignorequota,
+                        int silent,
                         struct mailbox **newmailboxptr)
 {
     int r;
@@ -5132,11 +5677,14 @@ HIDDEN int mailbox_rename_copy(struct ma
     if (!uidvalidity)
         uidvalidity = mboxname_nextuidvalidity(newname, oldmailbox->i.uidvalidity);
 
+    modseq_t highestmodseq = silent ? oldmailbox->i.highestmodseq : 0;
+
     /* Create new mailbox */
     r = mailbox_create(newname, oldmailbox->mbtype, newpartition,
                        oldmailbox->acl, (userid ? NULL : oldmailbox->uniqueid),
                        oldmailbox->i.options, uidvalidity,
-                       oldmailbox->i.highestmodseq, &newmailbox);
+                       oldmailbox->i.createdmodseq,
+                       highestmodseq, &newmailbox);
 
     if (r) return r;
 
@@ -5190,8 +5738,8 @@ HIDDEN int mailbox_rename_copy(struct ma
     /* re-set the UIDVALIDITY, it will have been the old one in the index header */
     mailbox_index_dirty(newmailbox);
     newmailbox->i.uidvalidity = uidvalidity;
-    /* and bump the modseq too */
-    mailbox_modseq_dirty(newmailbox);
+    /* unless on a replica, bump the modseq too */
+    if (!silent) mailbox_modseq_dirty(newmailbox);
 
     /* NOTE: in the case of renaming a user to another user, we
      * don't rename the conversations DB - instead we re-create
@@ -5213,10 +5761,10 @@ HIDDEN int mailbox_rename_copy(struct ma
     }
     else {
         /* have to handle each one separately */
+        if (newcstate)
+            r = mailbox_add_conversations(newmailbox, /*silent*/0);
         if (oldcstate)
             r = mailbox_delete_conversations(oldmailbox);
-        if (newcstate)
-            r = mailbox_add_conversations(newmailbox);
     }
     if (r) goto fail;
 
@@ -5281,9 +5829,11 @@ EXPORTED int mailbox_rename_cleanup(stru
  */
 EXPORTED int mailbox_copyfile(const char *from, const char *to, int nolink)
 {
-    int flags = COPYFILE_MKDIR;
+    int flags = COPYFILE_MKDIR|COPYFILE_KEEPTIME;
     if (nolink) flags |= COPYFILE_NOLINK;
 
+    if (mailbox_wait_cb) mailbox_wait_cb(mailbox_wait_cb_rock);
+
     if (cyrus_copyfile(from, to, flags))
         return IMAP_IOERROR;
 
@@ -5489,8 +6039,8 @@ static void cleanup_stale_expunged(struc
     for (erecno = 1; erecno <= expunge_num; erecno++) {
         struct index_record record;
         bufp = expunge_base + eoffset + (erecno-1)*expungerecord_size;
-        mailbox_buf_to_index_record(bufp, eversion, &record);
-        record.system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+        mailbox_buf_to_index_record(bufp, eversion, &record, 0);
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
         mailbox_record_cleanup(mailbox, &record);
     }
 
@@ -5547,7 +6097,7 @@ static int mailbox_reconstruct_create(co
          * no point trying to rescue anything else... */
         mailbox_close(&mailbox);
         r = mailbox_create(name, mbentry->mbtype, mbentry->partition, mbentry->acl,
-                           mbentry->uniqueid, options, 0, 0, mbptr);
+                           mbentry->uniqueid, options, 0, 0, 0, mbptr);
         mboxlist_entry_free(&mbentry);
         return r;
     }
@@ -5627,7 +6177,7 @@ static int mailbox_reconstruct_acl(struc
             r = mboxlist_lookup(mailbox->name, &mbentry, NULL);
             if (!r) {
                 if ((flags & RECONSTRUCT_PREFER_MBOXLIST) && mbentry->acl) {
-                    mailbox_set_acl(mailbox, mbentry->acl, /*dirty_modseq*/0);
+                    mailbox_set_acl(mailbox, mbentry->acl);
                 }
                 else {
                     free(mbentry->acl);
@@ -5677,8 +6227,13 @@ static int records_match(const char *mbo
                mboxname, new->uid);
         match = 0;
     }
-    if (old->content_lines != new->content_lines) {
-        printf("%s uid %u mismatch: content_lines\n",
+    if (old->savedate != new->savedate) {
+        printf("%s uid %u mismatch: savedate\n",
+               mboxname, new->uid);
+        match = 0;
+    }
+    if (old->createdmodseq != new->createdmodseq) {
+        printf("%s uid %u mismatch: createdmodseq\n",
                mboxname, new->uid);
         match = 0;
     }
@@ -5747,7 +6302,7 @@ static int mailbox_reconstruct_compare_u
 #if defined ENABLE_OBJECTSTORE
     int object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED) ;
 
-    if (object_storage_enabled && record->system_flags & FLAG_ARCHIVED){  // put the file on spool temporarily
+    if (object_storage_enabled && record->system_flags & FLAG_INTERNAL_ARCHIVED){  // put the file on spool temporarily
         remove_temp_spool_file = 1;
         r = objectstore_get(mailbox, record, fname);
     }
@@ -5766,7 +6321,7 @@ static int mailbox_reconstruct_compare_u
 
     if (!have_file) {
         /* well, that's OK if it's supposed to be missing! */
-        if (record->system_flags & FLAG_UNLINKED){
+        if (record->internal_flags & FLAG_INTERNAL_UNLINKED) {
             r = 0 ;
             goto out;
         }
@@ -5781,13 +6336,13 @@ static int mailbox_reconstruct_compare_u
 
         /* otherwise we have issues, mark it unlinked */
         unlink(fname);
-        record->system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+        record->internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
         mailbox->i.options |= OPT_MAILBOX_NEEDS_REPACK;
         r = mailbox_rewrite_index_record(mailbox, record);
         goto out;
     }
 
-    if (mailbox_cacherecord(mailbox, record) || record->crec.len == 0) {
+    if (mailbox_cacherecord_internal(mailbox, record, MBCACHE_NOPARSE) || record->crec.len == 0) {
         re_parse = 1;
         re_pack = 1; /* cache record will have to be rewritten */
     }
@@ -5825,7 +6380,7 @@ static int mailbox_reconstruct_compare_u
                 goto out;
             }
 
-            if (record->system_flags & FLAG_EXPUNGED) {
+            if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
                 /* already expunged, just unlink it */
                 printf("%s uid %u already expunged, unlinking\n",
                        mailbox->name, record->uid);
@@ -5835,7 +6390,8 @@ static int mailbox_reconstruct_compare_u
             }
             else if (flags & RECONSTRUCT_GUID_REWRITE) {
                 /* treat this file as discovered */
-                add_found(discovered, record->uid, record->system_flags & FLAG_ARCHIVED);
+                add_found(discovered, record->uid,
+                          (record->internal_flags & FLAG_INTERNAL_ARCHIVED));
                 printf("%s uid %u marking for uid upgrade\n",
                        mailbox->name, record->uid);
                 syslog(LOG_ERR, "%s uid %u marking for uid upgrade",
@@ -5853,7 +6409,7 @@ static int mailbox_reconstruct_compare_u
             if (do_unlink) {
                 /* rewrite with the original so we don't break the
                  * expectation that GUID never changes */
-                copy.system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+                copy.internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
                 mailbox->i.options |= OPT_MAILBOX_NEEDS_UNLINK;
                 r = mailbox_rewrite_index_record(mailbox, &copy);
                 goto out;
@@ -5881,7 +6437,7 @@ static int mailbox_reconstruct_compare_u
 
         /* otherwise we have issues, mark it unlinked */
         unlink(fname);
-        record->system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+        record->internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
         mailbox->i.options |= OPT_MAILBOX_NEEDS_REPACK;
         r = mailbox_rewrite_index_record(mailbox, record);
         goto out;
@@ -5935,11 +6491,22 @@ static int mailbox_reconstruct_compare_u
     }
 
     /* rewrite the cache record */
-    if (re_pack || record->cache_crc != copy.cache_crc) {
+    if (re_pack || !record->cache_offset || record->cache_crc != copy.cache_crc) {
+        int32_t oldcrc = copy.cache_crc;
+        int32_t newcrc = record->cache_crc;
+        size_t oldoff = record->cache_offset;
         mailbox->i.options |= OPT_MAILBOX_NEEDS_REPACK;
         record->cache_offset = 0;
         r = mailbox_append_cache(mailbox, record);
         if (r) goto out ;
+        printf("%s rewrote cache for %u (offset %llu to %llu, crc %u to %u/%u)\n",
+               mailbox->name, record->uid,
+               (long long unsigned)oldoff, (long long unsigned)record->cache_offset,
+               oldcrc, newcrc, record->cache_crc);
+        syslog(LOG_NOTICE, "%s rewrote cache for %u (offset %llu to %llu, crc %u to %u/%u)",
+               mailbox->name, record->uid,
+               (long long unsigned)oldoff, (long long unsigned)record->cache_offset,
+               oldcrc, newcrc, record->cache_crc);
     }
 
     r = mailbox_rewrite_index_record(mailbox, record);
@@ -5963,10 +6530,10 @@ static int mailbox_reconstruct_append(st
 
     memset(&record, 0, sizeof(struct index_record));
 
-    int remove_temp_spool_file = 0 ;
-    int object_storage_enabled = 0 ;
+    int remove_temp_spool_file = 0;
+    int object_storage_enabled = 0;
 #if defined ENABLE_OBJECTSTORE
-    object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED) ;
+    object_storage_enabled = config_getswitch(IMAPOPT_OBJECT_STORAGE_ENABLED);
 #endif
 
     if (isarchive && !object_storage_enabled)
@@ -5977,19 +6544,19 @@ static int mailbox_reconstruct_append(st
 #if defined ENABLE_OBJECTSTORE
     if (object_storage_enabled)
     {
-        uint32_t i , count = 0 ;
-        struct message *list = get_list_of_message (mailbox, &count) ;
+        uint32_t i , count = 0;
+        struct message *list = get_list_of_message (mailbox, &count);
         for (i = 0; i < count; i++) {
-            if (uid == list [i].message_uid){
+            if (uid == list[i].message_uid){
 
-                record.uid = uid ;
-                record.guid = list [i].message_guid ;
+                record.uid = uid;
+                record.guid = list[i].message_guid;
                 remove_temp_spool_file = 1;
                 r = objectstore_get(mailbox, &record, fname);
-                break ;
+                break;
             }
         }
-        discard_list( ) ;
+        discard_list();
     }
 #endif
 
@@ -6009,12 +6576,11 @@ static int mailbox_reconstruct_append(st
     if (r) {
         syslog(LOG_ERR, "%s uid %u not found", mailbox->name, uid);
         printf("%s uid %u not found", mailbox->name, uid);
-        if (!make_changes){
-            r = 0 ;
-            goto out;
-        }
-        unlink(fname);
-        r = 0 ;
+        r = 0;
+
+        if (make_changes)
+            unlink(fname);
+
         goto out;
     }
 
@@ -6022,7 +6588,7 @@ static int mailbox_reconstruct_append(st
     if (r) goto out;
 
     if (isarchive)
-        record.system_flags |= FLAG_ARCHIVED;
+        record.internal_flags |= FLAG_INTERNAL_ARCHIVED;
 
     /* copy the timestamp from the file if not calculated */
     if (!record.internaldate)
@@ -6154,7 +6720,7 @@ static int mailbox_wipe_index_record(str
            record->recno <= mailbox->i.num_records);
 
     record->uid = 0;
-    record->system_flags |= FLAG_EXPUNGED | FLAG_UNLINKED;
+    record->internal_flags |= FLAG_INTERNAL_EXPUNGED | FLAG_INTERNAL_UNLINKED;
 
     mailbox->i.options |= OPT_MAILBOX_NEEDS_REPACK;
     mailbox_index_dirty(mailbox);
@@ -6186,6 +6752,7 @@ static int addannot_uid(const char *mail
                         const char *entry __attribute__((unused)),
                         const char *userid __attribute__((unused)),
                         const struct buf *value __attribute__((unused)),
+                        const struct annotate_metadata *mdata __attribute__((unused)),
                         void *rock)
 {
     struct found_uids *annots = (struct found_uids *)rock;
@@ -6206,7 +6773,7 @@ static int find_annots(struct mailbox *m
     int r = 0;
 
     r = annotatemore_findall(mailbox->name, ANNOTATE_ANY_UID, "*",
-                             addannot_uid, annots);
+                             /*modseq*/0, addannot_uid, annots, /*flags*/0);
     if (r) return r;
 
     /* make sure UIDs are sorted for comparison */
@@ -6265,6 +6832,7 @@ EXPORTED int mailbox_reconstruct(const c
     int have_file;
     uint32_t last_seen_uid = 0;
     bit32 valid_user_flags[MAX_USER_FLAGS/32];
+    struct buf buf = BUF_INITIALIZER;
 
     if (make_changes && !(flags & RECONSTRUCT_QUIET)) {
         syslog(LOG_NOTICE, "reconstructing %s", name);
@@ -6285,6 +6853,14 @@ EXPORTED int mailbox_reconstruct(const c
     r = mailbox_reconstruct_uniqueid(mailbox, flags);
     if (r) goto close;
 
+    /* open and lock the annotation state */
+    r = mailbox_get_annotate_state(mailbox, ANNOTATE_ANY_UID, NULL);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: failed to open annotations %s: %s",
+               mailbox->name, error_message(r));
+        goto close;
+    }
+
     /* Validate user flags */
     for (i = 0; i < MAX_USER_FLAGS/32; i++) {
         valid_user_flags[i] = 0;
@@ -6360,17 +6936,17 @@ EXPORTED int mailbox_reconstruct(const c
             }
             else {
                 if (files.found[files.pos].isarchive) {
-                    if (!(record.system_flags & FLAG_ARCHIVED)) {
+                    if (!(record.internal_flags & FLAG_INTERNAL_ARCHIVED)) {
                         /* oops, it's really archived - let's fix that right now */
-                        record.system_flags |= FLAG_ARCHIVED;
+                        record.internal_flags |= FLAG_INTERNAL_ARCHIVED;
                         printf("Marking file as archived %s %u\n", mailbox->name, record.uid);
                         mailbox_rewrite_index_record(mailbox, &record);
                     }
                 }
                 else {
-                    if (record.system_flags & FLAG_ARCHIVED) {
+                    if (record.internal_flags & FLAG_INTERNAL_ARCHIVED) {
                         /* oops, non-archived copy exists, let's use that */
-                        record.system_flags &= ~FLAG_ARCHIVED;
+                        record.internal_flags &= ~FLAG_INTERNAL_ARCHIVED;
                         printf("Marking file as not archived %s %u\n", mailbox->name, record.uid);
                         mailbox_rewrite_index_record(mailbox, &record);
                     }
@@ -6385,6 +6961,45 @@ EXPORTED int mailbox_reconstruct(const c
                                                flags, have_file,
                                                &discovered);
         if (r) goto close;
+
+        if (mailbox->i.minor_version >= 13) {
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "thrid", "", &buf);
+            if (!buf.len) mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "thrid", NULL, &buf);
+            if (buf.len) {
+                syslog(LOG_NOTICE, "removing stale thrid for %u", record.uid);
+                printf("removing stale thrid for %u\n", record.uid);
+                buf_reset(&buf);
+                r = mailbox_annotation_write(mailbox, record.uid, IMAP_ANNOT_NS "thrid", "", &buf);
+                if (r) goto close;
+            }
+        }
+
+        if (mailbox->i.minor_version >= 15) {
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "savedate", "", &buf);
+            if (!buf.len) mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "savedate", NULL, &buf);
+            if (buf.len) {
+                syslog(LOG_NOTICE, "removing stale savedate for %u", record.uid);
+                printf("removing stale savedate for %u\n", record.uid);
+                buf_reset(&buf);
+                r = mailbox_annotation_write(mailbox, record.uid, IMAP_ANNOT_NS "savedate", "", &buf);
+                if (r) goto close;
+            }
+        }
+
+        if (mailbox->i.minor_version >= 16) {
+            buf_reset(&buf);
+            mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+            if (!buf.len) mailbox_annotation_lookup(mailbox, record.uid, IMAP_ANNOT_NS "createdmodseq", NULL, &buf);
+            if (buf.len) {
+                syslog(LOG_NOTICE, "removing stale createdmodseq for %u", record.uid);
+                printf("removing stale createdmodseq for %u\n", record.uid);
+                buf_reset(&buf);
+                r = mailbox_annotation_write(mailbox, record.uid, IMAP_ANNOT_NS "createdmodseq", "", &buf);
+                if (r) goto close;
+            }
+        }
     }
 
     /* add discovered messages before last_uid to the list in order */
@@ -6477,6 +7092,7 @@ close:
     free_found(&annots);
     free_found(&delannots);
     mailbox_close(&mailbox);
+    buf_free(&buf);
     return r;
 }
 
@@ -6488,12 +7104,13 @@ EXPORTED struct mailbox_iter *mailbox_it
     iter->mailbox = mailbox;
     iter->changedsince = changedsince;
     iter->num_records = mailbox->i.num_records;
+    iter->msg = message_new();
 
     /* calculate which system_flags to skip over */
     if (flags & ITER_SKIP_UNLINKED)
-        iter->skipflags |= FLAG_UNLINKED;
+        iter->skipflags |= FLAG_INTERNAL_UNLINKED;
     if (flags & ITER_SKIP_EXPUNGED)
-        iter->skipflags |= FLAG_EXPUNGED;
+        iter->skipflags |= FLAG_INTERNAL_EXPUNGED;
     if (flags & ITER_SKIP_DELETED)
         iter->skipflags |= FLAG_DELETED;
 
@@ -6508,12 +7125,14 @@ EXPORTED void mailbox_iter_startuid(stru
 
 EXPORTED const message_t *mailbox_iter_step(struct mailbox_iter *iter)
 {
+    if (mailbox_wait_cb) mailbox_wait_cb(mailbox_wait_cb_rock);
+
     for (iter->recno++; iter->recno <= iter->num_records; iter->recno++) {
-        message_unref(&iter->msg);
-        iter->msg = message_new_from_mailbox(iter->mailbox, iter->recno);
+        message_set_from_mailbox(iter->mailbox, iter->recno, iter->msg);
         const struct index_record *record = msg_record(iter->msg);
         if (!record->uid) continue; /* can happen on damaged mailboxes */
         if ((record->system_flags & iter->skipflags)) continue;
+        if ((record->internal_flags & iter->skipflags)) continue;
         if (iter->changedsince && record->modseq <= iter->changedsince) continue;
         return iter->msg;
     }
@@ -6580,24 +7199,31 @@ EXPORTED int mailbox_annotation_write(st
                                       const struct buf *value)
 {
     annotate_state_t *state = NULL;
-    int r;
+    int r = 0;
+    struct buf oldvalue = BUF_INITIALIZER;
+
+    annotatemore_msg_lookup(mailbox->name, uid, entry, userid, &oldvalue);
+    if (oldvalue.len == value->len && (!value->len || !memcmp(oldvalue.s, value->s, value->len)))
+        goto done;
 
     struct index_record record;
     memset(&record, 0, sizeof(struct index_record));
     r = mailbox_find_index_record(mailbox, uid, &record);
-    if (r) return r;
+    if (r) goto done;
 
     r = mailbox_get_annotate_state(mailbox, uid, &state);
-    if (r) return r;
+    if (r) goto done;
 
     r = annotate_state_write(state, entry, userid, value);
-    if (r) return r;
+    if (r) goto done;
 
     /* need to touch the modseq */
     r = mailbox_rewrite_index_record(mailbox, &record);
-    if (r) return r;
+    if (r) goto done;
 
-    return 0;
+done:
+    buf_free(&oldvalue);
+    return r;
 }
 
 EXPORTED int mailbox_annotation_writemask(struct mailbox *mailbox, uint32_t uid,
@@ -6605,24 +7231,34 @@ EXPORTED int mailbox_annotation_writemas
                                           const struct buf *value)
 {
     annotate_state_t *state = NULL;
-    int r;
+    int r = 0;
+    struct buf oldvalue = BUF_INITIALIZER;
+
+    /* we don't lookupmask here - because we want to still write the value as the
+     * user's own value rather than the masked value, regardless of whether they
+     * have the same content */
+    annotatemore_msg_lookup(mailbox->name, uid, entry, userid, &oldvalue);
+    if (oldvalue.len == value->len && (!value->len || !memcmp(oldvalue.s, value->s, value->len)))
+        goto done;
 
     struct index_record record;
     memset(&record, 0, sizeof(struct index_record));
     r = mailbox_find_index_record(mailbox, uid, &record);
-    if (r) return r;
+    if (r) goto done;
 
     r = mailbox_get_annotate_state(mailbox, uid, &state);
-    if (r) return r;
+    if (r) goto done;
 
     r = annotate_state_writemask(state, entry, userid, value);
-    if (r) return r;
+    if (r) goto done;
 
     /* need to touch the modseq */
     r = mailbox_rewrite_index_record(mailbox, &record);
-    if (r) return r;
+    if (r) goto done;
 
-    return 0;
+done:
+    buf_free(&oldvalue);
+    return r;
 }
 
 EXPORTED int mailbox_annotation_lookup(struct mailbox *mailbox, uint32_t uid,
@@ -6676,3 +7312,21 @@ int mailbox_cid_rename(struct mailbox *m
 
     return r;
 }
+
+EXPORTED void mailbox_set_wait_cb(void (*cb)(void *), void *rock)
+{
+    mailbox_wait_cb = cb;
+    mailbox_wait_cb_rock = rock;
+}
+
+/* if either CRC is zero for a field, then we consider it to match.
+ * this lets us bootstrap the case where CRCs weren't being calculated,
+ * and also allows a client with incomplete local information to request
+ * a change be made on a sync_server without having to fetch all the
+ * data first just to calculate the CRC */
+EXPORTED int mailbox_crceq(struct synccrcs a, struct synccrcs b)
+{
+    if (a.basic && b.basic && a.basic != b.basic) return 0;
+    if (a.annot && b.annot && a.annot != b.annot) return 0;
+    return 1;
+}
diff -pruN 3.0.13-5/imap/mailbox.h 3.2.0-3/imap/mailbox.h
--- 3.0.13-5/imap/mailbox.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mailbox.h	2020-05-04 03:28:02.000000000 +0000
@@ -74,8 +74,8 @@
  * make sure all the mailbox upgrade and downgrade code in mailbox.c is
  * changed to be able to convert both backwards and forwards between the
  * new version and all supported previous versions */
-#define MAILBOX_MINOR_VERSION   13
-#define MAILBOX_CACHE_MINOR_VERSION 6
+#define MAILBOX_MINOR_VERSION   16
+#define MAILBOX_CACHE_MINOR_VERSION 10
 
 #define FNAME_HEADER "/cyrus.header"
 #define FNAME_INDEX "/cyrus.index"
@@ -87,6 +87,11 @@
 #endif
 #define FNAME_ANNOTATIONS "/cyrus.annotations"
 
+#define CRC_INIT_BASIC 0
+// annot value should be visible as an integer via replication protocol,
+// so let's make it easy to see there
+#define CRC_INIT_ANNOT 12345678
+
 enum meta_filename {
   META_HEADER = 1,
   META_INDEX,
@@ -111,14 +116,14 @@ enum meta_filename {
 #define NUM_CACHE_FIELDS 10
 
 struct cacheitem {
-    unsigned offset;
-    unsigned len;
+    size_t offset;
+    size_t len;
 };
 
 struct cacherecord {
     const struct buf *buf;
-    unsigned offset;
-    unsigned len;
+    size_t offset;
+    size_t len;
     struct cacheitem item[NUM_CACHE_FIELDS];
 };
 
@@ -130,12 +135,16 @@ struct statusdata {
     uint32_t recent;
     uint32_t uidnext;
     uint32_t uidvalidity;
+    const char *mailboxid;
     uint32_t unseen;
+    uint32_t mboptions;
+    quota_t size;
+    modseq_t createdmodseq;
     modseq_t highestmodseq;
     conv_status_t xconv;
 };
 
-#define STATUSDATA_INIT { NULL, 0, 0, 0, 0, 0, 0, 0, CONV_STATUS_INIT }
+#define STATUSDATA_INIT { NULL, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, CONV_STATUS_INIT }
 
 struct index_record {
     uint32_t uid;
@@ -144,20 +153,23 @@ struct index_record {
     uint32_t size;
     uint32_t header_size;
     time_t gmtime;
-    uint32_t cache_offset;
+    size_t cache_offset;
     time_t last_updated;
     uint32_t system_flags;
+    uint32_t internal_flags;
     uint32_t user_flags[MAX_USER_FLAGS/32];
-    uint32_t content_lines;
-    uint32_t cache_version;
+    time_t savedate;
+    uint16_t cache_version;
     struct message_guid guid;
     modseq_t modseq;
     bit64 cid;
+    modseq_t createdmodseq;
     bit32 cache_crc;
 
     /* metadata */
     uint32_t recno;
     int silent;
+    bit64 basecid;
     struct cacherecord crec;
 };
 
@@ -186,6 +198,7 @@ struct index_header {
     uint32_t deleted;
     uint32_t answered;
     uint32_t flagged;
+    uint32_t unseen;
 
     uint32_t options;
     uint32_t leaked_cache_records;
@@ -195,6 +208,8 @@ struct index_header {
     time_t first_expunged;
     time_t last_repack_time;
 
+    modseq_t createdmodseq;
+
     bit32 header_file_crc;
     struct synccrcs synccrcs;
 
@@ -211,6 +226,7 @@ struct index_header {
 
 struct index_change {
     struct index_record record;
+    char *msgid;
     uint32_t mapnext;
     uint32_t flags;
 };
@@ -240,6 +256,7 @@ struct mailbox {
     uint32_t mbtype;
     char *part;
     char *acl;
+    modseq_t foldermodseq;
 
     struct index_header i;
 
@@ -331,10 +348,18 @@ struct mailbox_iter {
                           /* Spares - only use these if the index */
                           /*  record size remains the same */
 #define OFFSET_SYNCCRCS_ANNOT 120 /* SYNC_CRC of the annotations */
-#define OFFSET_HEADER_CRC 124 /* includes all zero for the spares! */
+#define OFFSET_UNSEEN 124         /* total number of UNSEEN messages (owner) */
 /* NEXT UPDATE - add Bug #3562 "TOTAL_MAILBOX_USED" field, 64 bit
  * value which counts the total size of all files included expunged
- * files.  This will need a header size change, hence putting it off */
+ * files. We've created the header space now, but will also need code
+ * changes, so holding off */
+#define OFFSET_MAILBOX_CREATEDMODSEQ 128 /* MODSEQ at creation time */
+#define OFFSET_SPARE0 136
+#define OFFSET_SPARE1 140
+#define OFFSET_SPARE2 144
+#define OFFSET_SPARE3 148
+#define OFFSET_SPARE4 152
+#define OFFSET_HEADER_CRC 156 /* includes all zero for the spares! */
 
 /* Offsets of index_record fields in index/expunge file
  *
@@ -352,32 +377,41 @@ struct mailbox_iter {
 #define OFFSET_LAST_UPDATED 28
 #define OFFSET_SYSTEM_FLAGS 32
 #define OFFSET_USER_FLAGS 36
-#define OFFSET_CONTENT_LINES 52 /* added for nntpd */
+#define OFFSET_SAVEDATE 52 /* added in v15 */
 #define OFFSET_CACHE_VERSION 56
 #define OFFSET_MESSAGE_GUID 60
 #define OFFSET_MODSEQ 80 /* CONDSTORE (64-bit modseq) */
 #define OFFSET_THRID 88       /* conversation id, added in v13 */
-#define OFFSET_CACHE_CRC 96 /* CRC32 of cache record */
-#define OFFSET_RECORD_CRC 100
+#define OFFSET_CREATEDMODSEQ 96 /* modseq of creation time, added in v16 */
+#define OFFSET_CACHE_CRC 104 /* CRC32 of cache record */
+#define OFFSET_RECORD_CRC 108
 
 #define INDEX_HEADER_SIZE (OFFSET_HEADER_CRC+4)
 #define INDEX_RECORD_SIZE (OFFSET_RECORD_CRC+4)
 
-#define FLAG_ANSWERED (1<<0)
-#define FLAG_FLAGGED (1<<1)
-#define FLAG_DELETED (1<<2)
-#define FLAG_DRAFT (1<<3)
-#define FLAG_SEEN (1<<4)
-#define FLAG_NEEDS_CLEANUP (1<<28)
-#define FLAG_ARCHIVED (1<<29)
-#define FLAG_UNLINKED (1<<30)
-#define FLAG_EXPUNGED (1U<<31)
+typedef enum _MsgFlags {
+    FLAG_ANSWERED           = (1<<0),
+    FLAG_FLAGGED            = (1<<1),
+    FLAG_DELETED            = (1<<2),
+    FLAG_DRAFT              = (1<<3),
+    FLAG_SEEN               = (1<<4),
+} MsgFlags;
+
+typedef enum _MsgInternalFlags {
+    FLAG_INTERNAL_SNOOZED            = (1<<26),
+    FLAG_INTERNAL_SPLITCONVERSATION  = (1<<27),
+    FLAG_INTERNAL_NEEDS_CLEANUP      = (1<<28),
+    FLAG_INTERNAL_ARCHIVED           = (1<<29),
+    FLAG_INTERNAL_UNLINKED           = (1<<30),
+    FLAG_INTERNAL_EXPUNGED           = (1U<<31),
+} MsgInternalFlags;
 
 #define FLAGS_SYSTEM   (FLAG_ANSWERED|FLAG_FLAGGED|FLAG_DELETED|FLAG_DRAFT|FLAG_SEEN)
-#define FLAGS_INTERNAL (FLAG_NEEDS_CLEANUP|FLAG_ARCHIVED|FLAG_UNLINKED|FLAG_EXPUNGED)
-/* for replication */
-#define FLAGS_LOCAL    (FLAG_NEEDS_CLEANUP|FLAG_ARCHIVED|FLAG_UNLINKED)
-#define FLAGS_GLOBAL   (FLAGS_SYSTEM|FLAG_EXPUNGED)
+#define FLAGS_INTERNAL (FLAG_INTERNAL_SPLITCONVERSATION |       \
+                        FLAG_INTERNAL_NEEDS_CLEANUP |           \
+                        FLAG_INTERNAL_ARCHIVED |                \
+                        FLAG_INTERNAL_UNLINKED |                \
+                        FLAG_INTERNAL_EXPUNGED)
 
 #define OPT_POP3_NEW_UIDL (1<<0)        /* added for Outlook stupidity */
 /* NOTE: not used anymore - but don't reuse it */
@@ -387,13 +421,17 @@ struct mailbox_iter {
  * struct annotate_mailbox_flags */
 #define OPT_IMAP_SHAREDSEEN (1<<2)      /* added for shared \Seen flag */
 #define OPT_IMAP_DUPDELIVER (1<<3)      /* added to allow duplicate delivery */
+
+#define OPT_IMAP_HAS_ALARMS (1<<4)      /* messages in mailbox have alarms */
+
 #define OPT_MAILBOX_NEEDS_UNLINK (1<<29)        /* files to be unlinked */
 #define OPT_MAILBOX_NEEDS_REPACK (1<<30)        /* repacking to do */
 #define OPT_MAILBOX_DELETED (1U<<31)    /* mailbox is deleted an awaiting cleanup */
 
 #define MAILBOX_OPTIONS_MASK (OPT_POP3_NEW_UIDL | \
                               OPT_IMAP_SHAREDSEEN | \
-                              OPT_IMAP_DUPDELIVER)
+                              OPT_IMAP_DUPDELIVER | \
+                              OPT_IMAP_HAS_ALARMS) 
 #define MAILBOX_CLEANUP_MASK (OPT_MAILBOX_NEEDS_UNLINK | \
                               OPT_MAILBOX_NEEDS_REPACK | \
                               OPT_MAILBOX_DELETED)
@@ -411,14 +449,7 @@ struct mailbox_iter {
 #define RECONSTRUCT_IGNORE_ODDFILES (1<<8)
 #define RECONSTRUCT_PREFER_MBOXLIST (1<<9)
 
-struct mailbox_header_cache {
-    const char *name; /* Name of header */
-    bit32 min_cache_version; /* Cache version it appeared in */
-};
-
 #define MAX_CACHED_HEADER_SIZE 32 /* Max size of a cached header name */
-extern const struct mailbox_header_cache mailbox_cache_headers[];
-extern const int MAILBOX_NUM_CACHE_HEADERS;
 
 /* Aligned buffer for manipulating index header/record fields */
 typedef union {
@@ -431,7 +462,7 @@ typedef union {
 /* CACHE_ITEM_BIT32: Convert to host byte order */
 /* CACHE_ITEM_LEN: Get the length out */
 /* CACHE_ITEM_NEXT: Return a pointer to the next entry.  Sizes are
- * 4-byte aligned, so round up to the next 4 byte boundry */
+ * 4-byte aligned, so round up to the next 4 byte boundary */
 #define CACHE_ITEM_BIT32(ptr) (ntohl(*((bit32 *)(ptr))))
 #define CACHE_ITEM_LEN(ptr) CACHE_ITEM_BIT32(ptr)
 #define CACHE_ITEM_NEXT(ptr) ((ptr)+4+((3+CACHE_ITEM_LEN(ptr))&~3))
@@ -468,6 +499,14 @@ enum {
 };
 #define NUMENVTOKENS (10)
 
+/*
+ * This structure maintains a list of FLAG_ to the string literal mapping.
+ */
+struct MsgFlagMap {
+    const char *code;
+    MsgFlags flag;
+};
+
 unsigned mailbox_cached_header(const char *s);
 unsigned mailbox_cached_header_inline(const char *text);
 
@@ -493,6 +532,8 @@ extern unsigned mailbox_should_archive(s
                                        const struct index_record *record,
                                        void *rock);
 
+extern int open_mailboxes_exist();
+
 /* map individual messages in */
 extern int mailbox_map_record(struct mailbox *mailbox, const struct index_record *record, struct buf *buf);
 
@@ -529,16 +570,20 @@ extern int mailbox_write_header(struct m
 extern void mailbox_index_dirty(struct mailbox *mailbox);
 extern modseq_t mailbox_modseq_dirty(struct mailbox *mailbox);
 extern int mailbox_reload_index_record(struct mailbox *mailbox,
-                                     struct index_record *record);
+                                       struct index_record *record);
+extern int mailbox_reload_index_record_dirty(struct mailbox *mailbox,
+                                             struct index_record *record);
 extern int mailbox_rewrite_index_record(struct mailbox *mailbox,
                                         struct index_record *record);
 extern int mailbox_append_index_record(struct mailbox *mailbox,
                                        struct index_record *record);
 extern int mailbox_find_index_record(struct mailbox *mailbox, uint32_t uid,
                                      struct index_record *record);
+extern int mailbox_read_basecid(struct mailbox *mailbox,
+                                const struct index_record *record);
+
 
-extern int mailbox_set_acl(struct mailbox *mailbox, const char *acl,
-                           int dirty_modseq);
+extern int mailbox_set_acl(struct mailbox *mailbox, const char *acl);
 extern int mailbox_set_quotaroot(struct mailbox *mailbox, const char *quotaroot);
 extern int mailbox_user_flag(struct mailbox *mailbox, const char *flag,
                              int *flagnum, int create);
@@ -574,12 +619,10 @@ extern void mailbox_remove_files_from_ob
 extern int mailbox_cleanup(struct mailbox *mailbox, int iscurrentdir,
                            mailbox_decideproc_t *decideproc, void *deciderock);
 extern void mailbox_unlock_index(struct mailbox *mailbox, struct statusdata *sd);
-/* unlock and immediately lock again with the same type */
-extern int mailbox_yield_index(struct mailbox *mailbox);
 
 extern int mailbox_create(const char *name, uint32_t mbtype, const char *part, const char *acl,
                           const char *uniqueid, int options, unsigned uidvalidity,
-                          modseq_t highestmodseq,
+                          modseq_t createdmodseq, modseq_t highestmodseq,
                           struct mailbox **mailboxptr);
 
 extern int mailbox_copy_files(struct mailbox *mailbox, const char *newpart,
@@ -590,6 +633,7 @@ extern int mailbox_rename_copy(struct ma
                                const char *newname, const char *newpart,
                                unsigned uidvalidity,
                                const char *userid, int ignorequota,
+                               int silent,
                                struct mailbox **newmailboxptr);
 extern int mailbox_rename_cleanup(struct mailbox **mailboxptr, int isinbox);
 
@@ -612,7 +656,8 @@ void mailbox_annot_changed(struct mailbo
                            const char *entry,
                            const char *userid,
                            const struct buf *oldval,
-                           const struct buf *newval);
+                           const struct buf *newval,
+                           int silent);
 
 extern int mailbox_get_annotate_state(struct mailbox *mailbox,
                                       unsigned int uid,
@@ -645,17 +690,24 @@ extern void mailbox_iter_done(struct mai
 struct synccrcs mailbox_synccrcs(struct mailbox *mailbox, int recalc);
 
 extern int mailbox_add_dav(struct mailbox *mailbox);
+extern int mailbox_add_email_alarms(struct mailbox *mailbox);
 
 /* Rename a CID.  Note - this is just one mailbox! */
 extern int mailbox_cid_rename(struct mailbox *mailbox,
                               conversation_id_t from_cid,
                               conversation_id_t to_cid);
-extern int mailbox_add_conversations(struct mailbox *mailbox);
+extern int mailbox_add_conversations(struct mailbox *mailbox, int silent);
 extern int mailbox_get_xconvmodseq(struct mailbox *mailbox, modseq_t *);
 extern int mailbox_update_xconvmodseq(struct mailbox *mailbox, modseq_t, int force);
 extern int mailbox_has_conversations(struct mailbox *mailbox);
 
 extern struct conversations_state *mailbox_get_cstate(struct mailbox *mailbox);
 
+typedef void mailbox_wait_cb_t(void *rock);
+extern void mailbox_set_wait_cb(mailbox_wait_cb_t *cb, void *rock);
+
+extern void mailbox_cleanup_uid(struct mailbox *mailbox, uint32_t uid, const char *flagstr);
+
+extern int mailbox_crceq(struct synccrcs a, struct synccrcs b);
 
 #endif /* INCLUDED_MAILBOX_H */
diff -pruN 3.0.13-5/imap/mailbox_header_cache.gperf 3.2.0-3/imap/mailbox_header_cache.gperf
--- 3.0.13-5/imap/mailbox_header_cache.gperf	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/mailbox_header_cache.gperf	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,100 @@
+%{
+/* mailbox_header_cache.h -- Lookup functions for mailbox headers we cache in
+                             the cyrus.cache file
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+ /* Command-line: gperf --ignore-case -p -j1 -i 1 -g -o -t -H mailbox_header_cache_hash -N mailbox_header_cache_lookup -k1,3,$ mailbox_header_cache.gperf */
+#include "util.h"
+%}
+struct mailbox_header_cache {
+    const char *name;
+    bit32 min_cache_version;
+};
+%%
+"priority", 0
+"references", 0
+"resent-from", 0
+"newsgroups", 0
+"followup-to", 0
+"x-mailer", 1
+"x-trace", 1
+"x-ref", 2
+"x-priority", 2
+"x-msmail-priority", 2
+"x-msoesrec", 2
+"x-spam-score", 3
+"x-resolved-to", 3
+"x-delivered-to", 3
+"x-mail-from", 3
+"x-truedomain-domain", 3
+"x-me-message-id", 4
+"x-cyrus-session-id", 4
+"bcc", BIT32_MAX
+"cc", BIT32_MAX
+"date", BIT32_MAX
+"delivery-date", BIT32_MAX
+"envelope-to", BIT32_MAX
+"from", BIT32_MAX
+"in-reply-to", BIT32_MAX
+"mime-version", BIT32_MAX
+"reply-to", 7
+"received", BIT32_MAX
+"return-path", BIT32_MAX
+"sender", 7
+"subject", BIT32_MAX
+"to", BIT32_MAX
+"dkim-signature", BIT32_MAX
+"domainkey-signature", BIT32_MAX
+"domainkey-x509", BIT32_MAX
+"message-id", BIT32_MAX
+"x-universally-unique-identifier", 6
+"x-uniform-type-identifier", 6
+"x-apple-base-url", 6
+"x-apple-mail-remote-attachments", 6
+"arc-seal", BIT32_MAX
+"arc-message-signature", BIT32_MAX
+"arc-authentication-results", BIT32_MAX
+"authentication-results", BIT32_MAX
+"received-spf", BIT32_MAX
+"archived-at", BIT32_MAX
+"listbox-message-date", BIT32_MAX
+"topicbox-message-uuid", BIT32_MAX
+"topicbox-policy-reasoning", BIT32_MAX
diff -pruN 3.0.13-5/imap/mailbox_header_cache.h 3.2.0-3/imap/mailbox_header_cache.h
--- 3.0.13-5/imap/mailbox_header_cache.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/mailbox_header_cache.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,307 @@
+/* ANSI-C code produced by gperf version 3.1 */
+/* Command-line: gperf --ignore-case --initializer-suffix=,0 -p -j1 -i 1 -g -o -t -H mailbox_header_cache_hash -N mailbox_header_cache_lookup -k'1,3,$' imap/mailbox_header_cache.gperf  */
+
+#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
+      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
+      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
+      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
+      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
+      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
+      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
+      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
+      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
+      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
+      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
+      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
+      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
+      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
+      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
+      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
+      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
+      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
+      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
+      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
+      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
+      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
+      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
+/* The character set is not based on ISO-646.  */
+#error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gperf@gnu.org>."
+#endif
+
+#line 1 "imap/mailbox_header_cache.gperf"
+
+/* mailbox_header_cache.h -- Lookup functions for mailbox headers we cache in
+                             the cyrus.cache file
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+ /* Command-line: gperf --ignore-case -p -j1 -i 1 -g -o -t -H mailbox_header_cache_hash -N mailbox_header_cache_lookup -k1,3,$ mailbox_header_cache.gperf */
+#include "util.h"
+#line 47 "imap/mailbox_header_cache.gperf"
+struct mailbox_header_cache {
+    const char *name;
+    bit32 min_cache_version;
+};
+
+#define TOTAL_KEYWORDS 49
+#define MIN_WORD_LENGTH 2
+#define MAX_WORD_LENGTH 31
+#define MIN_HASH_VALUE 4
+#define MAX_HASH_VALUE 65
+/* maximum key range = 62, duplicates = 0 */
+
+#ifndef GPERF_DOWNCASE
+#define GPERF_DOWNCASE 1
+static unsigned char gperf_downcase[256] =
+  {
+      0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
+     15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,  26,  27,  28,  29,
+     30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,
+     45,  46,  47,  48,  49,  50,  51,  52,  53,  54,  55,  56,  57,  58,  59,
+     60,  61,  62,  63,  64,  97,  98,  99, 100, 101, 102, 103, 104, 105, 106,
+    107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
+    122,  91,  92,  93,  94,  95,  96,  97,  98,  99, 100, 101, 102, 103, 104,
+    105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
+    120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134,
+    135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
+    150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164,
+    165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179,
+    180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194,
+    195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209,
+    210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224,
+    225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239,
+    240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254,
+    255
+  };
+#endif
+
+#ifndef GPERF_CASE_STRCMP
+#define GPERF_CASE_STRCMP 1
+static int
+gperf_case_strcmp (register const char *s1, register const char *s2)
+{
+  for (;;)
+    {
+      unsigned char c1 = gperf_downcase[(unsigned char)*s1++];
+      unsigned char c2 = gperf_downcase[(unsigned char)*s2++];
+      if (c1 != 0 && c1 == c2)
+        continue;
+      return (int)c1 - (int)c2;
+    }
+}
+#endif
+
+#ifdef __GNUC__
+__inline
+#else
+#ifdef __cplusplus
+inline
+#endif
+#endif
+static unsigned int
+mailbox_header_cache_hash (register const char *str, register size_t len)
+{
+  static unsigned char asso_values[] =
+    {
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66,  3, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 35, 66, 66,
+      66, 66, 66, 66, 66,  1,  2,  1,  2,  1,
+      26,  2, 15, 23, 66, 66, 10,  1, 27, 17,
+      12, 66,  7,  2, 18, 16, 21,  8,  1, 13,
+      66, 66, 66, 66, 66, 66, 66,  1,  2,  1,
+       2,  1, 26,  2, 15, 23, 66, 66, 10,  1,
+      27, 17, 12, 66,  7,  2, 18, 16, 21,  8,
+       1, 13, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+      66, 66, 66, 66, 66, 66
+    };
+  register unsigned int hval = len;
+
+  switch (hval)
+    {
+      default:
+        hval += asso_values[(unsigned char)str[2]];
+      /*FALLTHROUGH*/
+      case 2:
+      case 1:
+        hval += asso_values[(unsigned char)str[0]];
+        break;
+    }
+  return hval + asso_values[(unsigned char)str[len - 1]];
+}
+
+struct mailbox_header_cache *
+mailbox_header_cache_lookup (register const char *str, register size_t len)
+{
+  static struct mailbox_header_cache wordlist[] =
+    {
+      {"",0}, {"",0}, {"",0}, {"",0},
+#line 71 "imap/mailbox_header_cache.gperf"
+      {"cc", BIT32_MAX},
+      {"",0}, {"",0},
+#line 70 "imap/mailbox_header_cache.gperf"
+      {"bcc", BIT32_MAX},
+      {"",0}, {"",0}, {"",0}, {"",0}, {"",0},
+#line 62 "imap/mailbox_header_cache.gperf"
+      {"x-msoesrec", 2},
+#line 66 "imap/mailbox_header_cache.gperf"
+      {"x-mail-from", 3},
+#line 87 "imap/mailbox_header_cache.gperf"
+      {"message-id", BIT32_MAX},
+#line 63 "imap/mailbox_header_cache.gperf"
+      {"x-spam-score", 3},
+#line 57 "imap/mailbox_header_cache.gperf"
+      {"x-mailer", 1},
+#line 79 "imap/mailbox_header_cache.gperf"
+      {"received", BIT32_MAX},
+#line 68 "imap/mailbox_header_cache.gperf"
+      {"x-me-message-id", 4},
+#line 92 "imap/mailbox_header_cache.gperf"
+      {"arc-seal", BIT32_MAX},
+#line 54 "imap/mailbox_header_cache.gperf"
+      {"resent-from", 0},
+#line 69 "imap/mailbox_header_cache.gperf"
+      {"x-cyrus-session-id", 4},
+#line 85 "imap/mailbox_header_cache.gperf"
+      {"domainkey-signature", BIT32_MAX},
+#line 93 "imap/mailbox_header_cache.gperf"
+      {"arc-message-signature", BIT32_MAX},
+#line 72 "imap/mailbox_header_cache.gperf"
+      {"date", BIT32_MAX},
+#line 73 "imap/mailbox_header_cache.gperf"
+      {"delivery-date", BIT32_MAX},
+#line 58 "imap/mailbox_header_cache.gperf"
+      {"x-trace", 1},
+#line 90 "imap/mailbox_header_cache.gperf"
+      {"x-apple-base-url", 6},
+#line 82 "imap/mailbox_header_cache.gperf"
+      {"subject", BIT32_MAX},
+#line 94 "imap/mailbox_header_cache.gperf"
+      {"arc-authentication-results", BIT32_MAX},
+#line 97 "imap/mailbox_header_cache.gperf"
+      {"archived-at", BIT32_MAX},
+#line 61 "imap/mailbox_header_cache.gperf"
+      {"x-msmail-priority", 2},
+#line 98 "imap/mailbox_header_cache.gperf"
+      {"listbox-message-date", BIT32_MAX},
+#line 65 "imap/mailbox_header_cache.gperf"
+      {"x-delivered-to", 3},
+#line 91 "imap/mailbox_header_cache.gperf"
+      {"x-apple-mail-remote-attachments", 6},
+#line 60 "imap/mailbox_header_cache.gperf"
+      {"x-priority", 2},
+#line 83 "imap/mailbox_header_cache.gperf"
+      {"to", BIT32_MAX},
+#line 64 "imap/mailbox_header_cache.gperf"
+      {"x-resolved-to", 3},
+#line 59 "imap/mailbox_header_cache.gperf"
+      {"x-ref", 2},
+#line 84 "imap/mailbox_header_cache.gperf"
+      {"dkim-signature", BIT32_MAX},
+#line 77 "imap/mailbox_header_cache.gperf"
+      {"mime-version", BIT32_MAX},
+#line 81 "imap/mailbox_header_cache.gperf"
+      {"sender", 7},
+#line 95 "imap/mailbox_header_cache.gperf"
+      {"authentication-results", BIT32_MAX},
+#line 78 "imap/mailbox_header_cache.gperf"
+      {"reply-to", 7},
+#line 53 "imap/mailbox_header_cache.gperf"
+      {"references", 0},
+#line 96 "imap/mailbox_header_cache.gperf"
+      {"received-spf", BIT32_MAX},
+#line 55 "imap/mailbox_header_cache.gperf"
+      {"newsgroups", 0},
+#line 75 "imap/mailbox_header_cache.gperf"
+      {"from", BIT32_MAX},
+#line 89 "imap/mailbox_header_cache.gperf"
+      {"x-uniform-type-identifier", 6},
+#line 74 "imap/mailbox_header_cache.gperf"
+      {"envelope-to", BIT32_MAX},
+#line 80 "imap/mailbox_header_cache.gperf"
+      {"return-path", BIT32_MAX},
+#line 86 "imap/mailbox_header_cache.gperf"
+      {"domainkey-x509", BIT32_MAX},
+#line 99 "imap/mailbox_header_cache.gperf"
+      {"topicbox-message-uuid", BIT32_MAX},
+#line 76 "imap/mailbox_header_cache.gperf"
+      {"in-reply-to", BIT32_MAX},
+#line 88 "imap/mailbox_header_cache.gperf"
+      {"x-universally-unique-identifier", 6},
+#line 52 "imap/mailbox_header_cache.gperf"
+      {"priority", 0},
+#line 100 "imap/mailbox_header_cache.gperf"
+      {"topicbox-policy-reasoning", BIT32_MAX},
+      {"",0}, {"",0}, {"",0}, {"",0}, {"",0}, {"",0},
+#line 56 "imap/mailbox_header_cache.gperf"
+      {"followup-to", 0},
+#line 67 "imap/mailbox_header_cache.gperf"
+      {"x-truedomain-domain", 3}
+    };
+
+  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
+    {
+      register unsigned int key = mailbox_header_cache_hash (str, len);
+
+      if (key <= MAX_HASH_VALUE)
+        {
+          register const char *s = wordlist[key].name;
+
+          if ((((unsigned char)*str ^ (unsigned char)*s) & ~32) == 0 && !gperf_case_strcmp (str, s))
+            return &wordlist[key];
+        }
+    }
+  return 0;
+}
diff -pruN 3.0.13-5/imap/mbdump.c 3.2.0-3/imap/mbdump.c
--- 3.0.13-5/imap/mbdump.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mbdump.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <errno.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <fcntl.h>
@@ -62,7 +63,6 @@
 #ifdef WITH_DAV
 #include "dav_util.h"
 #endif
-#include "exitcodes.h"
 #include "global.h"
 #include "map.h"
 #include "mappedfile.h"
@@ -166,7 +166,7 @@ static void downgrade_record(const struc
     for (n = 0; n < MAX_USER_FLAGS/32; n++) {
         *((bit32 *)(buf+OFFSET_USER_FLAGS+4*n)) = htonl(record->user_flags[n]);
     }
-    *((bit32 *)(buf+OFFSET_CONTENT_LINES)) = htonl(record->content_lines);
+    *((bit32 *)(buf+OFFSET_SAVEDATE)) = 0;
     *((bit32 *)(buf+OFFSET_CACHE_VERSION)) = htonl(record->cache_version);
     message_guid_export(&record->guid, buf+OFFSET_MESSAGE_GUID);
     *((bit64 *)(buf+UP_modseqbase)) = htonll(record->modseq);
@@ -238,7 +238,7 @@ static int dump_index(struct mailbox *ma
         /* we have to make sure expunged records don't get the
          * file copied, or a reconstruct could bring them back
          * to life!  It we're not creating an expunged file... */
-        if (record->system_flags & FLAG_EXPUNGED) {
+        if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
             if (oldversion < 9) seqset_add(expunged_seq, record->uid, 1);
             continue;
         }
@@ -274,7 +274,7 @@ static int dump_index(struct mailbox *ma
         while ((msg = mailbox_iter_step(iter))) {
             const struct index_record *record = msg_record(msg);
             /* ignore non-expunged records */
-            if (!(record->system_flags & FLAG_EXPUNGED))
+            if (!(record->internal_flags & FLAG_INTERNAL_EXPUNGED))
                 continue;
             downgrade_record(record, rbuf, oldversion);
             n = retry_write(oldindex_fd, rbuf, record_size);
@@ -343,7 +343,9 @@ static int dump_annotations(const char *
                             uint32_t uid  __attribute__((unused)),
                             const char *entry,
                             const char *userid,
-                            const struct buf *value, void *rock)
+                            const struct buf *value,
+                            const struct annotate_metadata *mdata __attribute__((unused)),
+                            void *rock)
 {
     struct dump_annotation_rock *ctx = (struct dump_annotation_rock *)rock;
 
@@ -389,7 +391,7 @@ static int dump_file(int first, int sync
         /* we need to check real file size since actual mmap size may be larger */
         if (stat(filename, &sbuf) == -1) {
             syslog(LOG_ERR, "IOERROR: stat on %s: %m", filename);
-            fatal("can't stat message file", EC_OSFILE);
+            fatal("can't stat message file", EX_OSFILE);
         }
         if ((unsigned long)sbuf.st_size > flen) {
            syslog(LOG_ERR, "IOERROR: size mismatch on %s", filename);
@@ -408,7 +410,7 @@ static int dump_file(int first, int sync
 
         if (fstat(filefd, &sbuf) == -1) {
             syslog(LOG_ERR, "IOERROR: fstat on %s: %m", filename);
-            fatal("can't fstat message file", EC_OSFILE);
+            fatal("can't fstat message file", EX_OSFILE);
         }
 
         base = NULL;
@@ -607,8 +609,8 @@ EXPORTED int dump_mailbox(const char *ta
         struct dump_annotation_rock actx;
         actx.tag = tag;
         actx.pout = pout;
-        annotatemore_findall(mailbox->name, 0, "*", dump_annotations,
-                             (void *) &actx);
+        annotatemore_findall(mailbox->name, 0, "*", /*modseq*/0,
+                             dump_annotations, (void *) &actx, /*flags*/0);
     }
 
     /* Dump user files if this is an inbox */
@@ -647,7 +649,7 @@ EXPORTED int dump_mailbox(const char *ta
                 break;
             }
             default:
-                fatal("unknown user data file", EC_OSFILE);
+                fatal("unknown user data file", EX_OSFILE);
             }
 
             r = dump_file(0, !tag, pin, pout, fname, ftag, NULL, 0);
@@ -816,7 +818,7 @@ static int cleanup_seen_subfolders(const
     snprintf(buf, sizeof(buf), "%s.", mbname);
 
     r = seen_open(userid, SEEN_SILENT, &seendb);
-    if (!r) mboxlist_allmbox(buf, cleanup_seen_cb, seendb, /*incdel*/0);
+    if (!r) mboxlist_allmbox(buf, cleanup_seen_cb, seendb, /*flags*/0);
     seen_close(&seendb);
 
     free(userid);
@@ -828,7 +830,8 @@ EXPORTED int undump_mailbox(const char *
                    struct protstream *pin, struct protstream *pout,
                    struct auth_state *auth_state __attribute((unused)))
 {
-    struct buf file, data;
+    struct buf file = BUF_INITIALIZER;
+    struct buf data = BUF_INITIALIZER;
     int c;
     int r = 0;
     int curfile = -1;
@@ -847,9 +850,6 @@ EXPORTED int undump_mailbox(const char *
     quota_t quotalimit = -1;
     annotate_state_t *astate = NULL;
 
-    memset(&file, 0, sizeof(file));
-    memset(&data, 0, sizeof(data));
-
     /* Set a Quota (may be -1 for "unlimited") */
     for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
        newquotas[res] = QUOTA_UNLIMITED;
@@ -903,7 +903,7 @@ EXPORTED int undump_mailbox(const char *
         r = mboxlist_lookup(mbname, &mbentry, NULL);
         if (!r) r = mailbox_create(mbname, mbentry->mbtype,
                                    mbentry->partition, mbentry->acl,
-                                   mbentry->uniqueid, 0, 0, 0, &mailbox);
+                                   mbentry->uniqueid, 0, 0, 0, 0, &mailbox);
         mboxlist_entry_free(&mbentry);
     }
     if(r) goto done;
@@ -1062,7 +1062,7 @@ EXPORTED int undump_mailbox(const char *
             digit = c - '0';
             /* check for overflow */
             if (size > cutoff || (size == cutoff && digit > cutlim)) {
-                fatal("literal too big", EC_IOERR);
+                fatal("literal too big", EX_IOERR);
             }
             size = size*10 + digit;
         }
@@ -1265,7 +1265,7 @@ EXPORTED int undump_mailbox(const char *
             }
         }
         if (res < QUOTA_NUMRESOURCES) {
-            mboxlist_setquotas(mbname, newquotas, 0);
+            mboxlist_setquotas(mbname, newquotas, 0, 0);
         }
     }
 
@@ -1296,7 +1296,7 @@ EXPORTED int undump_mailbox(const char *
             }
 
             if (changed) {
-                r = quota_update_useds(mailbox->quotaroot, quota_usage, NULL);
+                r = quota_update_useds(mailbox->quotaroot, quota_usage, NULL, 0);
                 if (r) goto done2;
             }
         }
diff -pruN 3.0.13-5/imap/mbdump.h 3.2.0-3/imap/mbdump.h
--- 3.0.13-5/imap/mbdump.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mbdump.h	2020-04-24 02:03:00.000000000 +0000
@@ -55,7 +55,7 @@
  * after the first send.
  *
  * (note that this assumes server LITERAL+ support, but we don't care since
- * this is a Cyrus-only extention)
+ * this is a Cyrus-only extension)
  */
 extern int dump_mailbox(const char *tag, struct mailbox *mailbox, uint32_t uid_start,
                         int oldversion,
diff -pruN 3.0.13-5/imap/mbexamine.c 3.2.0-3/imap/mbexamine.c
--- 3.0.13-5/imap/mbexamine.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mbexamine.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
@@ -72,7 +73,6 @@
 #endif
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "index.h"
 #include "global.h"
 #include "mailbox.h"
@@ -147,12 +147,9 @@ int main(int argc, char **argv)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&mbexamine_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
 
@@ -165,8 +162,7 @@ int main(int argc, char **argv)
         mboxlist_findall(&mbexamine_namespace, argv[i], 1, 0, 0, cb, NULL);
     }
 
-    mboxlist_close();
-    mboxlist_done();
+    cyrus_done();
 
     exit(0);
 }
@@ -178,7 +174,7 @@ static void usage(void)
             "       mbexamine [-C <alt_config>] [-u uid] mailbox...\n"
             "       mbexamine [-C <alt_config>] -q mailbox...\n"
             "       mbexamine [-C <alt_config>] -c mailbox...\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static void print_rec(const char *name, const struct buf *citem)
@@ -198,7 +194,8 @@ static int do_examine(struct findall_dat
     int j;
 
     /* don't want partial matches */
-    if (!data || !data->mbname) return 0;
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
 
     signals_poll();
 
@@ -253,6 +250,9 @@ static int do_examine(struct findall_dat
         if (mailbox->i.options & OPT_IMAP_DUPDELIVER) {
             printf(" IMAP_DUPDELIVER");
         }
+        if (mailbox->i.options & OPT_IMAP_HAS_ALARMS) {
+            printf(" IMAP_HAS_ALARMS");
+        }
     }
     printf("\n");
     printf("  Last POP3 Login: (%ld) %s", mailbox->i.pop3_last_login,
@@ -276,14 +276,13 @@ static int do_examine(struct findall_dat
             flag = 1;
         }
 
-        printf("%06u> UID:%08u   INT_DATE:%lu SENTDATE:%lu SIZE:%-6u\n",
+        printf("%06u> UID:%08u"
+               "   INT_DATE:%lu SENTDATE:%lu SAVEDATE:%lu SIZE:%-6u\n",
                msgno, record->uid, record->internaldate,
-               record->sentdate, record->size);
+               record->sentdate, record->savedate, record->size);
         printf("      > HDRSIZE:%-6u LASTUPD :%lu SYSFLAGS:%08X",
                record->header_size, record->last_updated,
                record->system_flags);
-        if (mailbox->i.minor_version >= 5)
-            printf("   LINES:%-6u\n", record->content_lines);
 
         if (mailbox->i.minor_version >= 6)
             printf("      > CACHEVER:%-2u", record->cache_version);
@@ -302,19 +301,26 @@ static int do_examine(struct findall_dat
 
         printf("\n");
 
-    	printf("      > SYSTEMFLAGS:");
-    	if (record->system_flags & FLAG_EXPUNGED) printf(" FLAG_EXPUNGED");
-    	if (record->system_flags & FLAG_UNLINKED) printf(" FLAG_UNLINKED");
-    	if (record->system_flags & FLAG_ARCHIVED) printf(" FLAG_ARCHIVED");
-    	if (record->system_flags & FLAG_NEEDS_CLEANUP) printf(" FLAG_NEEDS_CLEANUP");
-
-    	if (record->system_flags & FLAG_SEEN) printf(" FLAG_SEEN");
-    	if (record->system_flags & FLAG_DRAFT) printf(" FLAG_DRAFT");
-    	if (record->system_flags & FLAG_DELETED) printf(" FLAG_DELETED");
-    	if (record->system_flags & FLAG_FLAGGED) printf(" FLAG_FLAGGED");
-    	if (record->system_flags & FLAG_ANSWERED) printf(" FLAG_ANSWERED");
+        printf("      > INTERNALFLAGS:");
+        if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
+            printf(" FLAG_INTERNAL_EXPUNGED");
+        if (record->internal_flags & FLAG_INTERNAL_UNLINKED)
+            printf(" FLAG_INTERNAL_UNLINKED");
+        if (record->internal_flags & FLAG_INTERNAL_ARCHIVED)
+            printf(" FLAG_INTERNAL_ARCHIVED");
+        if (record->internal_flags & FLAG_INTERNAL_NEEDS_CLEANUP)
+            printf(" FLAG_INTERNAL_NEEDS_CLEANUP");
+        if (record->internal_flags & FLAG_INTERNAL_SNOOZED)
+            printf(" FLAG_INTERNAL_SNOOZED");
+
+        printf("      > SYSTEMFLAGS:");
+        if (record->system_flags & FLAG_SEEN) printf(" FLAG_SEEN");
+        if (record->system_flags & FLAG_DRAFT) printf(" FLAG_DRAFT");
+        if (record->system_flags & FLAG_DELETED) printf(" FLAG_DELETED");
+        if (record->system_flags & FLAG_FLAGGED) printf(" FLAG_FLAGGED");
+        if (record->system_flags & FLAG_ANSWERED) printf(" FLAG_ANSWERED");
 
-    	printf("\n");
+        printf("\n");
 
         printf("      > USERFLAGS:");
         for (j=(MAX_USER_FLAGS/32)-1; j>=0; j--) {
@@ -360,7 +366,8 @@ static int do_quota(struct findall_data
     struct stat sbuf;
 
     /* don't want partial matches */
-    if (!data || !data->mbname) return 0;
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
 
     signals_poll();
 
@@ -430,7 +437,8 @@ static int do_compare(struct findall_dat
     uint32_t *uids = NULL, nalloc, count = 0, msgno;
 
     /* don't want partial matches */
-    if (!data || !data->mbname) return 0;
+    if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
 
     signals_poll();
 
@@ -496,7 +504,7 @@ static int do_compare(struct findall_dat
         do {
             struct index_record fs_record = { .uid = 0 };
             const struct buf *citem, empty_buf = BUF_INITIALIZER;
-            char sent[RFC822_DATETIME_MAX+1] = "";
+            char sent[RFC5322_DATETIME_MAX+1] = "";
 
             if (msgno < count) {
                 char fname[100];
@@ -537,11 +545,11 @@ static int do_compare(struct findall_dat
                 printf("\t%-50u", fs_record.size);
             printf("\n");
 
-            if (record) time_to_rfc822(record->sentdate, sent, sizeof(sent));
+            if (record) time_to_rfc5322(record->sentdate, sent, sizeof(sent));
             printf("   Date: %-50s", sent);
 
             if (fs_record.uid && !message_guid_isnull(&fs_record.guid)) {
-                time_to_rfc822(fs_record.sentdate, sent, sizeof(sent));
+                time_to_rfc5322(fs_record.sentdate, sent, sizeof(sent));
                 printf("\t%-50s", sent);
             }
             printf("\n");
diff -pruN 3.0.13-5/imap/mboxevent.c 3.2.0-3/imap/mboxevent.c
--- 3.0.13-5/imap/mboxevent.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxevent.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,10 +42,10 @@
  */
 #include <config.h>
 #include "imap/mboxevent.h"
-#ifdef ENABLE_MBOXEVENT
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <time.h>
 #include <unistd.h>
@@ -58,7 +58,6 @@
 #include "caldav_db.h"
 #include "carddav_db.h"
 #endif /* WITH_DAV */
-#include "exitcodes.h"
 #include "global.h"
 #include "imapurl.h"
 #include "libconfig.h"
@@ -69,6 +68,7 @@
 #include "map.h"
 #include "mboxevent.h"
 #include "mboxname.h"
+#include "msgrecord.h"
 #include "notify.h"
 #include "global.h"
 
@@ -80,7 +80,7 @@
                         EVENT_MESSAGE_TRASH)
 
 #define MAILBOX_EVENTS (EVENT_MAILBOX_CREATE|EVENT_MAILBOX_DELETE|\
-                        EVENT_MAILBOX_RENAME|EVENT_ACL_CHANGE)
+                        EVENT_MAILBOX_RENAME|EVENT_ACL_CHANGE|EVENT_MAILBOX_MODSEQ)
 
 #define SUBS_EVENTS    (EVENT_MAILBOX_SUBSCRIBE|EVENT_MAILBOX_UNSUBSCRIBE)
 
@@ -144,12 +144,16 @@ static struct mboxevent event_template =
     { EVENT_CONVUNSEEN, "vnd.fastmail.convUnseen", EVENT_PARAM_INT, { 0 }, 0 },
     { EVENT_MESSAGE_CID, "vnd.fastmail.cid", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_COUNTERS, "vnd.fastmail.counters", EVENT_PARAM_STRING, { 0 }, 0 },
+    { EVENT_MESSAGE_EMAILID, "vnd.cmu.emailid", EVENT_PARAM_STRING, { 0 }, 0 },
+    { EVENT_MESSAGE_THREADID, "vnd.cmu.threadid", EVENT_PARAM_STRING, { 0 }, 0 },
 
     /* calendar params for calalarmd/notifyd */
     { EVENT_CALENDAR_ALARM_TIME, "alarmTime", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_CALENDAR_ALARM_RECIPIENTS, "alarmRecipients", EVENT_PARAM_ARRAY, { 0 }, 0 },
     { EVENT_CALENDAR_USER_ID, "userId", EVENT_PARAM_STRING, { 0 }, 0 },
+    { EVENT_CALENDAR_CALENDAR_ID, "calendarId", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_CALENDAR_CALENDAR_NAME, "calendarName", EVENT_PARAM_STRING, { 0 }, 0 },
+    { EVENT_CALENDAR_CALENDAR_COLOR, "calendarColor", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_CALENDAR_UID, "uid", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_CALENDAR_ACTION, "action", EVENT_PARAM_STRING, { 0 }, 0 },
     { EVENT_CALENDAR_SUMMARY, "summary", EVENT_PARAM_STRING, { 0 }, 0 },
@@ -188,6 +192,19 @@ static char *json_formatter(enum event_t
 static int filled_params(enum event_type type, struct mboxevent *mboxevent);
 static int mboxevent_expected_param(enum event_type type, enum event_param param);
 
+static int mboxevent_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    /* do nothing */
+}
+
+static void init_internal() {
+    if (!mboxevent_initialized) {
+        mboxevent_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
+
 EXPORTED int mboxevent_init(void)
 {
     const char *options;
@@ -237,6 +254,8 @@ EXPORTED int mboxevent_init(void)
     if (groups & IMAP_ENUM_EVENT_GROUPS_APPLEPUSHSERVICE)
         enabled_events |= APPLEPUSHSERVICE_EVENTS;
 
+    mboxevent_initialized = 1;
+
     return enabled_events;
 }
 
@@ -257,6 +276,8 @@ static int mboxevent_enabled_for_mailbox
     int i = 0;
     int r = 0;
 
+    init_internal();
+
     if (!enable_subfolder && !mboxname_isusermailbox(mailbox->name, 1)) {
         enabled = 0;
         goto done;
@@ -291,6 +312,9 @@ done:
 EXPORTED struct mboxevent *mboxevent_new(enum event_type type)
 {
     struct mboxevent *mboxevent = NULL;
+
+    init_internal();
+
     /* event notification is completely disabled */
     if (!notifier)
         return NULL;
@@ -412,7 +436,9 @@ static int mboxevent_expected_calendar_p
     case EVENT_CALENDAR_ALARM_TIME:
     case EVENT_CALENDAR_ALARM_RECIPIENTS:
     case EVENT_CALENDAR_USER_ID:
+    case EVENT_CALENDAR_CALENDAR_ID:
     case EVENT_CALENDAR_CALENDAR_NAME:
+    case EVENT_CALENDAR_CALENDAR_COLOR:
     case EVENT_CALENDAR_UID:
     case EVENT_CALENDAR_ACTION:
     case EVENT_CALENDAR_SUMMARY:
@@ -523,6 +549,12 @@ static int mboxevent_expected_param(enum
     case EVENT_MESSAGE_CID:
         return (extra_params & IMAP_ENUM_EVENT_EXTRA_PARAMS_VND_FASTMAIL_CID) &&
                (type & (EVENT_MESSAGE_APPEND|EVENT_MESSAGE_NEW));
+    case EVENT_MESSAGE_EMAILID:
+        return (extra_params & IMAP_ENUM_EVENT_EXTRA_PARAMS_VND_CMU_EMAILID) &&
+               (type & (EVENT_MESSAGE_APPEND|EVENT_MESSAGE_NEW));
+    case EVENT_MESSAGE_THREADID:
+        return (extra_params & IMAP_ENUM_EVENT_EXTRA_PARAMS_VND_CMU_THREADID) &&
+               (type & (EVENT_MESSAGE_APPEND|EVENT_MESSAGE_NEW));
     case EVENT_MESSAGES:
         if (type & (EVENT_QUOTA_EXCEED|EVENT_QUOTA_WITHIN))
             return 1;
@@ -606,6 +638,8 @@ EXPORTED void mboxevent_notify(struct mb
     if (!*mboxevents)
         return;
 
+    init_internal();
+
     /* loop over the chained list of events */
     for (event = *mboxevents; event; event = event->next) {
         if (event->type == EVENT_CANCELLED)
@@ -720,7 +754,7 @@ EXPORTED void mboxevent_notify(struct mb
     return;
 }
 
-void mboxevent_add_flags(struct mboxevent *event, char *flagnames[MAX_USER_FLAGS],
+EXPORTED void mboxevent_add_flags(struct mboxevent *event, char *flagnames[MAX_USER_FLAGS],
                          bit32 system_flags, bit32 user_flags[MAX_USER_FLAGS/32])
 {
     unsigned flag, flagmask = 0;
@@ -763,7 +797,7 @@ void mboxevent_add_flags(struct mboxeven
     }
 }
 
-void mboxevent_add_flag(struct mboxevent *event, const char *flag)
+EXPORTED void mboxevent_add_flag(struct mboxevent *event, const char *flag)
 {
     if (!event)
         return;
@@ -784,6 +818,8 @@ EXPORTED void mboxevent_set_access(struc
     if (!event)
         return;
 
+    init_internal();
+
     /* only notify Logout after successful Login */
     if (!userid && event->type & EVENT_LOGOUT) {
         event->type = EVENT_CANCELLED;
@@ -843,6 +879,8 @@ EXPORTED void mboxevent_set_acl(struct m
     if (!event)
         return;
 
+    init_internal();
+
     FILL_STRING_PARAM(event, EVENT_ACL_SUBJECT, xstrdup(identifier));
     // If rights == 0x0, perhaps this is a Deleteacl command, that
     // deletes the rights for a subject, rather than a *setting* the
@@ -850,7 +888,7 @@ EXPORTED void mboxevent_set_acl(struct m
     if (rights == 0x0) {
         // Pretend it is filled, but do it with null or mboxevent_free
         // will trip.
-        FILL_STRING_PARAM(event, EVENT_ACL_RIGHTS, '\0');
+        FILL_STRING_PARAM(event, EVENT_ACL_RIGHTS, NULL);
     } else {
         FILL_STRING_PARAM(event, EVENT_ACL_RIGHTS, xstrdup(rights));
     }
@@ -864,6 +902,8 @@ EXPORTED void mboxevent_extract_record(s
     if (!event)
         return;
 
+    init_internal();
+
     /* add modseq only on first call, cancel otherwise */
     if (mboxevent_expected_param(event->type, EVENT_MODSEQ)) {
         if (event->uidset == NULL || (seqset_first(event->uidset) == seqset_last(event->uidset))) {
@@ -908,6 +948,32 @@ EXPORTED void mboxevent_extract_record(s
                           xstrdup(conversation_id_encode(record->cid)));
     }
 
+    /* add message EMAILID */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_EMAILID)) {
+        char emailid[26];
+        emailid[0] = 'M';
+        memcpy(emailid+1, message_guid_encode(&record->guid), 24);
+        emailid[25] = '\0';
+        FILL_STRING_PARAM(event, EVENT_MESSAGE_EMAILID, xstrdup(emailid));
+    }
+
+    /* add message THREADID */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_THREADID)) {
+        char threadid[18];
+        if (!record->cid) {
+            threadid[0] = 'N';
+            threadid[1] = 'I';
+            threadid[2] = 'L';
+            threadid[3] = '\0';
+        }
+        else {
+            threadid[0] = 'T';
+            memcpy(threadid+1, conversation_id_encode(record->cid), 16);
+            threadid[17] = '\0';
+        }
+        FILL_STRING_PARAM(event, EVENT_MESSAGE_THREADID, xstrdup(threadid));
+    }
+
     /* add vnd.cmu.envelope */
     if (mboxevent_expected_param(event->type, EVENT_ENVELOPE)) {
         FILL_STRING_PARAM(event, EVENT_ENVELOPE,
@@ -969,6 +1035,191 @@ EXPORTED void mboxevent_extract_record(s
 #endif // WITH_DAV
 }
 
+EXPORTED void mboxevent_extract_msgrecord(struct mboxevent *event, msgrecord_t *msgrec)
+{
+    int r;
+    uint32_t uid;
+
+    if (!event)
+        return;
+
+    init_internal();
+
+    if ((r = msgrecord_get_uid(msgrec, &uid))) {
+        syslog(LOG_ERR, "mboxevent: can't extract uid: %s", error_message(r));
+        return;
+    }
+
+    /* add modseq only on first call, cancel otherwise */
+    if (mboxevent_expected_param(event->type, EVENT_MODSEQ)) {
+        modseq_t modseq = 0;
+        if ((r = msgrecord_get_modseq(msgrec, &modseq))) {
+            syslog(LOG_ERR, "mboxevent: can't extract modseq: %s", error_message(r));
+            return;
+        }
+        if (event->uidset == NULL || (seqset_first(event->uidset) == seqset_last(event->uidset))) {
+            FILL_UNSIGNED_PARAM(event, EVENT_MODSEQ, modseq);
+        }
+        else {
+            /* From RFC 5423:
+             * modseq May be included with any notification referring
+             * to one message.
+             *
+             * thus cancel inclusion of modseq parameter
+             */
+            event->params[EVENT_MODSEQ].filled = 0;
+        }
+    }
+
+    /* add UID to uidset */
+    if (event->uidset == NULL)
+        event->uidset = seqset_init(0, SEQ_SPARSE);
+    seqset_add(event->uidset, uid, 1);
+
+    if (event->type == EVENT_CANCELLED)
+        return;
+
+    /* add Message-Id to midset or NIL if doesn't exists */
+    if (mboxevent_expected_param(event->type, (EVENT_MIDSET))) {
+        char *msgid = NULL;
+        if ((r = msgrecord_get_cache_env(msgrec, ENV_MSGID, &msgid))) {
+            syslog(LOG_ERR, "mboxevent: can't extract msgid: %s", error_message(r));
+            return;
+        }
+        strarray_add(&event->midset, msgid ? msgid : "NIL");
+        free(msgid);
+    }
+
+    /* add message size */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_SIZE)) {
+        uint32_t size;
+        if ((r = msgrecord_get_size(msgrec, &size))) {
+            syslog(LOG_ERR, "mboxevent: can't extract size: %s", error_message(r));
+            return;
+        }
+        FILL_UNSIGNED_PARAM(event, EVENT_MESSAGE_SIZE, size);
+    }
+
+    /* add message CID */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_CID)) {
+        bit64 cid;
+        if ((r = msgrecord_get_cid(msgrec, &cid))) {
+            syslog(LOG_ERR, "mboxevent: can't extract cid: %s", error_message(r));
+            return;
+        }
+        FILL_STRING_PARAM(event, EVENT_MESSAGE_CID,
+                          xstrdup(conversation_id_encode(cid)));
+    }
+
+    /* add message EMAILID */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_EMAILID)) {
+        struct message_guid guid;
+        if ((r = msgrecord_get_guid(msgrec, &guid))) {
+            syslog(LOG_ERR, "mboxevent: can't extract guid: %s", error_message(r));
+            return;
+        }
+        char emailid[26];
+        emailid[0] = 'M';
+        memcpy(emailid+1, message_guid_encode(&guid), 24);
+        emailid[25] = '\0';
+        FILL_STRING_PARAM(event, EVENT_MESSAGE_EMAILID, xstrdup(emailid));
+    }
+
+    /* add message THREADID */
+    if (mboxevent_expected_param(event->type, EVENT_MESSAGE_THREADID)) {
+        bit64 cid;
+        if ((r = msgrecord_get_cid(msgrec, &cid))) {
+            syslog(LOG_ERR, "mboxevent: can't extract cid: %s", error_message(r));
+            return;
+        }
+        char threadid[18];
+        if (!cid) {
+            threadid[0] = 'N';
+            threadid[1] = 'I';
+            threadid[2] = 'L';
+            threadid[3] = '\0';
+        }
+        else {
+            threadid[0] = 'T';
+            memcpy(threadid+1, conversation_id_encode(cid), 16);
+            threadid[17] = '\0';
+        }
+        FILL_STRING_PARAM(event, EVENT_MESSAGE_THREADID, xstrdup(threadid));
+    }
+
+    /* add vnd.cmu.envelope */
+    if (mboxevent_expected_param(event->type, EVENT_ENVELOPE)) {
+        char *env;
+        if ((r = msgrecord_get_cache_item(msgrec, CACHE_ENVELOPE, &env))) {
+            syslog(LOG_ERR, "mboxevent: can't extract cache envelope: %s", error_message(r));
+            return;
+        }
+        FILL_STRING_PARAM(event, EVENT_ENVELOPE, env);
+    }
+
+    /* add bodyStructure */
+    if (mboxevent_expected_param(event->type, EVENT_BODYSTRUCTURE)) {
+        char *bs;
+        if ((r = msgrecord_get_cache_item(msgrec, CACHE_BODYSTRUCTURE, &bs))) {
+            syslog(LOG_ERR, "mboxevent: can't extract cached bodystructure: %s", error_message(r));
+            return;
+        }
+        FILL_STRING_PARAM(event, EVENT_BODYSTRUCTURE, bs);
+    }
+
+#ifdef WITH_DAV
+    /* add caldav items */
+    struct mailbox *mailbox;
+    r = msgrecord_get_mailbox(msgrec, &mailbox);
+    if (r) return;
+
+    if ((mailbox->mbtype & (MBTYPES_DAV)) &&
+        (mboxevent_expected_param(event->type, EVENT_DAV_FILENAME) ||
+         mboxevent_expected_param(event->type, EVENT_DAV_UID))) {
+        struct body *body = NULL;
+        const char *resource = NULL;
+        struct param *param;
+
+        r = msgrecord_extract_bodystructure(msgrec, &body);
+        if (r) return;
+
+        for (param = body->disposition_params; param; param = param->next) {
+            if (!strcmp(param->attribute, "FILENAME")) {
+                resource = param->value;
+            }
+        }
+
+        if (resource) {
+            FILL_STRING_PARAM(event, EVENT_DAV_FILENAME, xstrdup(resource));
+        }
+
+        if (mboxevent_expected_param(event->type, EVENT_DAV_UID)) {
+            if (mailbox->mbtype & MBTYPE_ADDRESSBOOK) {
+                struct carddav_db *carddavdb = NULL;
+                struct carddav_data *cdata = NULL;
+                carddavdb = mailbox_open_carddav(mailbox);
+                carddav_lookup_resource(carddavdb, mailbox->name, resource, &cdata, 1);
+                FILL_STRING_PARAM(event, EVENT_DAV_UID, xstrdup(cdata->vcard_uid));
+            }
+            else if (mailbox->mbtype & MBTYPE_CALENDAR) {
+                struct caldav_db *caldavdb = NULL;
+                struct caldav_data *cdata = NULL;
+                caldavdb = mailbox_open_caldav(mailbox);
+                caldav_lookup_resource(caldavdb, mailbox->name, resource, &cdata, 1);
+                FILL_STRING_PARAM(event, EVENT_DAV_UID, xstrdup(cdata->ical_uid));
+            }
+            else {
+                /* don't bail for MBTYPE_COLLECTION or any new things */
+                FILL_STRING_PARAM(event, EVENT_DAV_UID, xstrdup(""));
+            }
+        }
+
+        if (body) message_free_body(body);
+        free(body);
+    }
+#endif // WITH_DAV
+}
+
 void mboxevent_extract_copied_record(struct mboxevent *event,
                                      const struct mailbox *mailbox,
                                      struct index_record *record)
@@ -990,6 +1241,100 @@ void mboxevent_extract_copied_record(str
         mboxevent_extract_old_mailbox(event, mailbox);
 }
 
+void mboxevent_extract_copied_msgrecord(struct mboxevent *event,
+                                        msgrecord_t *msgrec)
+{
+    int first = 0;
+    uint32_t uid;
+
+    if (!event)
+        return;
+
+    /* add the source message's UID to oldUidset */
+    if (event->olduidset == NULL) {
+        event->olduidset = seqset_init(0, SEQ_SPARSE);
+        first = 1;
+    }
+    msgrecord_get_uid(msgrec, &uid);
+    seqset_add(event->olduidset, uid, 1);
+
+    /* generate an IMAP URL to reference the old mailbox */
+    if (first) {
+        struct mailbox *mailbox = NULL;
+        msgrecord_get_mailbox(msgrec, &mailbox);
+        mboxevent_extract_old_mailbox(event, mailbox);
+    }
+}
+
+void mboxevent_extract_content_msgrec(struct mboxevent *event,
+                               msgrecord_t *msgrec, FILE* content)
+{
+    const char *base = NULL;
+    size_t offset, size, truncate, len = 0;
+    uint32_t record_size, header_size;
+
+    if (!event)
+        return;
+
+    if (!mboxevent_expected_param(event->type, EVENT_MESSAGE_CONTENT))
+        return;
+
+    if (msgrecord_get_size(msgrec, &record_size) ||
+        msgrecord_get_header_size(msgrec, &header_size)) {
+        syslog(LOG_ERR, "mobxevent: can't determine content size");
+        return;
+    }
+
+    truncate = config_getint(IMAPOPT_EVENT_CONTENT_SIZE);
+
+    switch (config_getenum(IMAPOPT_EVENT_CONTENT_INCLUSION_MODE)) {
+    /*  include message up to 'truncate' in size with the notification */
+    case IMAP_ENUM_EVENT_CONTENT_INCLUSION_MODE_STANDARD:
+        if (!truncate || record_size <= truncate) {
+            offset = 0;
+            size = record_size;
+        }
+        else {
+            /* XXX RFC 5423 suggests to include a URLAUTH [RFC4467] reference
+             * for larger messages. IMAP URL of mailboxID seems enough though */
+            return;
+        }
+        break;
+    /* include message truncated to a size of 'truncate' */
+    case IMAP_ENUM_EVENT_CONTENT_INCLUSION_MODE_MESSAGE:
+        offset = 0;
+        size = (truncate && (record_size > truncate)) ?
+                truncate : record_size;
+        break;
+    /* include headers truncated to a size of 'truncate' */
+    case IMAP_ENUM_EVENT_CONTENT_INCLUSION_MODE_HEADER:
+        offset = 0;
+        size = (truncate && (header_size > truncate)) ?
+                truncate : header_size;
+        break;
+    /* include body truncated to a size of 'truncate' */
+    case IMAP_ENUM_EVENT_CONTENT_INCLUSION_MODE_BODY:
+        offset = header_size;
+        size = (truncate && ((record_size - header_size) > truncate)) ?
+                truncate : record_size - header_size;
+        break;
+    /* include full headers and body truncated to a size of 'truncate' */
+    case IMAP_ENUM_EVENT_CONTENT_INCLUSION_MODE_HEADERBODY:
+        offset = 0;
+        size = (truncate && ((record_size - header_size) > truncate)) ?
+                header_size + truncate : record_size;
+        break;
+    /* never happen */
+    default:
+        return;
+    }
+
+    map_refresh(fileno(content), 1, &base, &len, record_size, "new message", 0);
+    FILL_STRING_PARAM(event, EVENT_MESSAGE_CONTENT, xstrndup(base+offset, size));
+    map_free(&base, &len);
+}
+
+
 void mboxevent_extract_content(struct mboxevent *event,
                                const struct index_record *record, FILE* content)
 {
@@ -1062,9 +1407,10 @@ void mboxevent_extract_quota(struct mbox
 
     switch(res) {
     case QUOTA_STORAGE:
-        if (mboxevent_expected_param(event->type, EVENT_QUOTA_STORAGE)
-            && quota->limits[res] >= 0) {
+        if (mboxevent_expected_param(event->type, EVENT_QUOTA_STORAGE)) {
+            if (quota->limits[res] >= 0) {
                 FILL_UNSIGNED_PARAM(event, EVENT_QUOTA_STORAGE, quota->limits[res]);
+            }
         }
         if (mboxevent_expected_param(event->type, EVENT_DISK_USED)) {
             FILL_UNSIGNED_PARAM(event, EVENT_DISK_USED,
@@ -1123,6 +1469,8 @@ EXPORTED void mboxevent_set_numunseen(st
     if (!event)
         return;
 
+    init_internal();
+
     if (mboxevent_expected_param(event->type, EVENT_UNSEEN_MESSAGES)) {
         unsigned count = (numunseen >= 0) ? (unsigned)numunseen
                                           : mailbox_count_unseen(mailbox);
@@ -1142,6 +1490,8 @@ EXPORTED void mboxevent_extract_mailbox(
     if (!event)
         return;
 
+    init_internal();
+
     /* mboxevent_extract_mailbox should be called only once */
     if (event->params[EVENT_URI].filled)
         return;
@@ -1212,11 +1562,11 @@ EXPORTED void mboxevent_extract_mailbox(
             conversation_getstatus(cstate, mailbox->name, &status);
 
         if (mboxevent_expected_param(event->type, EVENT_CONVEXISTS)) {
-            FILL_UNSIGNED_PARAM(event, EVENT_CONVEXISTS, status.exists);
+            FILL_UNSIGNED_PARAM(event, EVENT_CONVEXISTS, status.threadexists);
         }
 
         if (mboxevent_expected_param(event->type, EVENT_CONVUNSEEN)) {
-            FILL_UNSIGNED_PARAM(event, EVENT_CONVUNSEEN, status.unseen);
+            FILL_UNSIGNED_PARAM(event, EVENT_CONVUNSEEN, status.threadunseen);
         }
     }
 
@@ -1225,12 +1575,13 @@ EXPORTED void mboxevent_extract_mailbox(
         struct buf value = BUF_INITIALIZER;
 
         int r = mboxname_read_counters(mailbox->name, &counters);
-        if (!r) buf_printf(&value, "%u %llu %llu %llu %llu %llu %llu %llu %llu %llu %u",
+        if (!r) buf_printf(&value, "%u %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %u",
                            counters.version, counters.highestmodseq,
                            counters.mailmodseq, counters.caldavmodseq,
                            counters.carddavmodseq, counters.notesmodseq,
                            counters.mailfoldersmodseq, counters.caldavfoldersmodseq,
                            counters.carddavfoldersmodseq, counters.notesfoldersmodseq,
+                           counters.quotamodseq, counters.raclmodseq,
                            counters.uidvalidity);
 
         FILL_STRING_PARAM(event, EVENT_COUNTERS, buf_release(&value));
@@ -1354,8 +1705,10 @@ static const char *event_to_name(enum ev
         return "ApplePushService";
     case EVENT_APPLEPUSHSERVICE_DAV:
         return "ApplePushServiceDAV";
+    case EVENT_MAILBOX_MODSEQ:
+        return "MailboxModseq";
     default:
-        fatal("Unknown message event", EC_SOFTWARE);
+        fatal("Unknown message event", EX_SOFTWARE);
     }
 
     /* never happen */
@@ -1498,128 +1851,3 @@ static int filled_params(enum event_type
     return ret;
 }
 #endif /* NDEBUG */
-
-#else /* !ENABLE_MBOXEVENT */
-
-EXPORTED int mboxevent_init(void)
-{
-    return 0;
-}
-
-EXPORTED void mboxevent_setnamespace(struct namespace *n __attribute__((unused)))
-{
-}
-
-EXPORTED struct mboxevent *mboxevent_new(enum event_type type __attribute__((unused)))
-{
-    return NULL;
-}
-
-struct mboxevent *mboxevent_enqueue(enum event_type type __attribute__((unused)),
-                                    struct mboxevent **mboxevents __attribute__((unused)))
-{
-    return NULL;
-}
-
-EXPORTED void mboxevent_free(struct mboxevent **mboxevent __attribute__((unused)))
-{
-}
-
-void mboxevent_freequeue(struct mboxevent **mboxevent __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_notify(struct mboxevent **mboxevents __attribute__((unused)))
-{
-}
-
-void mboxevent_add_flags(struct mboxevent *event __attribute__((unused)),
-                         char *flagnames[MAX_USER_FLAGS] __attribute__((unused)),
-                         bit32 system_flags __attribute__((unused)),
-                         bit32 user_flags[MAX_USER_FLAGS/32] __attribute__((unused)))
-{
-}
-
-void mboxevent_add_flag(struct mboxevent *event __attribute__((unused)),
-                        const char *flag __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_access(struct mboxevent *event __attribute__((unused)),
-                                   const char *serveraddr __attribute__((unused)),
-                                   const char *clientaddr __attribute__((unused)),
-                                   const char *userid __attribute__((unused)),
-                                   const char *mailboxname __attribute__((unused)),
-                                   const int ext_name __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_acl(struct mboxevent *event __attribute__((unused)),
-                                const char *identifier __attribute__((unused)),
-                                const char *rights __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_extract_record(struct mboxevent *event __attribute__((unused)),
-                                       struct mailbox *mailbox __attribute__((unused)),
-                                       struct index_record *record __attribute__((unused)))
-{
-}
-
-void mboxevent_extract_copied_record(struct mboxevent *event __attribute__((unused)),
-                                     const struct mailbox *mailbox __attribute__((unused)),
-                                     struct index_record *record __attribute__((unused)))
-{
-}
-
-void mboxevent_extract_content(struct mboxevent *event __attribute__((unused)),
-                               const struct index_record *record __attribute__((unused)),
-                               FILE* content __attribute__((unused)))
-{
-}
-
-void mboxevent_extract_quota(struct mboxevent *event __attribute__((unused)),
-                             const struct quota *quota __attribute__((unused)),
-                             enum quota_resource res __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_numunseen(struct mboxevent *event __attribute__((unused)),
-                                      struct mailbox *mailbox __attribute__((unused)),
-                                      int numunseen __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_extract_mailbox(struct mboxevent *event __attribute__((unused)),
-                                        struct mailbox *mailbox __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_client_id(const char *id __attribute__((unused)))
-{
-}
-
-void mboxevent_extract_old_mailbox(struct mboxevent *event __attribute__((unused)),
-                                   const struct mailbox *mailbox __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_applepushservice(struct mboxevent *event __attribute__((unused)),
-                                             struct applepushserviceargs *applepushserviceargs __attribute__((unused)),
-                                             strarray_t *notif_mailboxes __attribute__((unused)),
-                                             const char *userid __attribute__((unused)))
-{
-}
-
-EXPORTED void mboxevent_set_applepushservice_dav(struct mboxevent *event __attribute__((unused)),
-                                                 const char *aps_topic __attribute__((unused)),
-                                                 const char *device_token __attribute__((unused)),
-                                                 const char *userid __attribute__((unused)),
-                                                 const char *mailbox_userid __attribute__((unused)),
-                                                 const char *mailbox_uniqueid __attribute__((unused)),
-                                                 int mbtype __attribute__((unused)),
-                                                 unsigned int expiry __attribute__((unused)))
-{
-}
-
-#endif /* !ENABLE_MBOXEVENT */
diff -pruN 3.0.13-5/imap/mboxevent.h 3.2.0-3/imap/mboxevent.h
--- 3.0.13-5/imap/mboxevent.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxevent.h	2020-04-24 02:03:00.000000000 +0000
@@ -50,6 +50,9 @@
 #include "mailbox.h"
 #include "mboxname.h"
 
+/* Forward declaration to avoid circular dependency */
+typedef struct msgrecord msgrecord_t;
+
 /*
  * event types defined in RFC 5423 - Internet Message Store Events
  */
@@ -84,7 +87,8 @@ enum event_type {
     EVENT_CALENDAR_ALARM      = (1<<22),
     /* Other */
     EVENT_APPLEPUSHSERVICE     = (1<<23),
-    EVENT_APPLEPUSHSERVICE_DAV = (1<<24)
+    EVENT_APPLEPUSHSERVICE_DAV = (1<<24),
+    EVENT_MAILBOX_MODSEQ       = (1<<25)
 };
 
 /*
@@ -133,10 +137,14 @@ enum event_param {
     EVENT_CONVUNSEEN,
     EVENT_MESSAGE_CID,
     EVENT_COUNTERS,
+    EVENT_MESSAGE_EMAILID,
+    EVENT_MESSAGE_THREADID,
     EVENT_CALENDAR_ALARM_TIME,
     EVENT_CALENDAR_ALARM_RECIPIENTS,
     EVENT_CALENDAR_USER_ID,
+    EVENT_CALENDAR_CALENDAR_ID,
     EVENT_CALENDAR_CALENDAR_NAME,
+    EVENT_CALENDAR_CALENDAR_COLOR,
     EVENT_CALENDAR_UID,
     EVENT_CALENDAR_ACTION,
     EVENT_CALENDAR_SUMMARY,
@@ -300,12 +308,26 @@ void mboxevent_extract_record(struct mbo
                               struct index_record *record);
 
 /*
+ * Extract data from the given message record to fill these event parameters :
+ * - uidset from UID
+ * - vnd.cmu.midset from Message-Id in ENVELOPE structure
+ * - messageSize
+ * - bodyStructure
+ *
+ * Called once per message and always before mboxevent_extract_mailbox
+ */
+void mboxevent_extract_msgrecord(struct mboxevent *event, msgrecord_t *msgrec);
+
+
+/*
  * Fill event parameter about the copied message.
  * Called once per message and always before mboxevent_extract_mailbox
  */
 void mboxevent_extract_copied_record(struct mboxevent *event,
                                      const struct mailbox *mailbox, struct index_record *record);
 
+extern void mboxevent_extract_copied_msgrecord(struct mboxevent *event, msgrecord_t *msgrec);
+
 /*
  * Extract message content to include to event notification
  */
@@ -313,6 +335,12 @@ void mboxevent_extract_content(struct mb
                                const struct index_record *record, FILE* content);
 
 /*
+ * Extract message content to include to event notification
+ */
+void mboxevent_extract_content_msgrec(struct mboxevent *event,
+                               msgrecord_t *msgrec, FILE* content);
+
+/*
  * Extract quota limit, quota usage and quota root to include to event
  * notification
  */
diff -pruN 3.0.13-5/imap/mboxlist.c 3.2.0-3/imap/mboxlist.c
--- 3.0.13-5/imap/mboxlist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxlist.c	2020-05-04 03:28:02.000000000 +0000
@@ -52,6 +52,7 @@
 #include <sys/stat.h>
 #include <sys/uio.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include <sys/ipc.h>
@@ -59,6 +60,7 @@
 
 #include "acl.h"
 #include "annotate.h"
+#include "bsearch.h"
 #include "glob.h"
 #include "assert.h"
 #include "global.h"
@@ -66,7 +68,6 @@
 #include "util.h"
 #include "mailbox.h"
 #include "mboxevent.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "partlist.h"
@@ -91,6 +92,7 @@ cyrus_acl_canonproc_t mboxlist_ensureOwn
 static struct db *mbdb;
 
 static int mboxlist_dbopen = 0;
+static int mboxlist_initialized = 0;
 
 static int mboxlist_opensubs(const char *userid, struct db **ret);
 static void mboxlist_closesubs(struct db *sub);
@@ -98,6 +100,8 @@ static void mboxlist_closesubs(struct db
 static int mboxlist_rmquota(const mbentry_t *mbentry, void *rock);
 static int mboxlist_changequota(const mbentry_t *mbentry, void *rock);
 
+static void init_internal();
+
 EXPORTED mbentry_t *mboxlist_entry_create(void)
 {
     mbentry_t *ret = xzmalloc(sizeof(mbentry_t));
@@ -114,6 +118,7 @@ EXPORTED mbentry_t *mboxlist_entry_copy(
     copy->mtime = src->mtime;
     copy->uidvalidity = src->uidvalidity;
     copy->mbtype = src->mbtype;
+    copy->createdmodseq = src->createdmodseq;
     copy->foldermodseq = src->foldermodseq;
 
     copy->partition = xstrdupnull(src->partition);
@@ -201,6 +206,12 @@ EXPORTED const char *mboxlist_mbtype_to_
         buf_putc(&buf, 'b');
     if (mbtype & MBTYPE_ADDRESSBOOK)
         buf_putc(&buf, 'a');
+    if (mbtype & MBTYPE_INTERMEDIATE)
+        buf_putc(&buf, 'i');
+    if (mbtype & MBTYPE_SUBMISSION)
+        buf_putc(&buf, 's');
+    if (mbtype & MBTYPE_PUSHSUBSCRIPTION)
+        buf_putc(&buf, 'p');
 
     return buf_cstring(&buf);
 }
@@ -228,6 +239,9 @@ static char *mboxlist_entry_cstring(cons
     if (mbentry->uidvalidity)
         dlist_setnum32(dl, "V", mbentry->uidvalidity);
 
+    if (mbentry->createdmodseq)
+        dlist_setnum64(dl, "C", mbentry->createdmodseq);
+
     if (mbentry->foldermodseq)
         dlist_setnum64(dl, "F", mbentry->foldermodseq);
 
@@ -319,6 +333,9 @@ EXPORTED uint32_t mboxlist_string_to_mbt
         case 'd':
             mbtype |= MBTYPE_DELETED;
             break;
+        case 'i':
+            mbtype |= MBTYPE_INTERMEDIATE;
+            break;
         case 'm':
             mbtype |= MBTYPE_MOVING;
             break;
@@ -328,6 +345,12 @@ EXPORTED uint32_t mboxlist_string_to_mbt
         case 'r':
             mbtype |= MBTYPE_REMOTE;
             break;
+        case 'p':
+            mbtype |= MBTYPE_PUSHSUBSCRIPTION;
+            break;
+        case 's':
+            mbtype |= MBTYPE_SUBMISSION;
+            break;
         case 'z':
             mbtype |= MBTYPE_RESERVE;
             break;
@@ -360,31 +383,34 @@ int parseentry_cb(int type, struct dlist
         if (rock->doingacl) {
             buf_append(rock->aclbuf, &d->kbuf);
             buf_putc(rock->aclbuf, '\t');
-            buf_append(rock->aclbuf, &d->buf);
+            buf_appendcstr(rock->aclbuf, d->data);
             buf_putc(rock->aclbuf, '\t');
         }
         else {
             const char *key = buf_cstring(&d->kbuf);
-            if (!strcmp(key, "F")) {
-                rock->mbentry->foldermodseq = atoll(buf_cstring(&d->buf));
+            if (!strcmp(key, "C")) {
+                rock->mbentry->createdmodseq = atomodseq_t(d->data);
+            }
+            else if (!strcmp(key, "F")) {
+                rock->mbentry->foldermodseq = atomodseq_t(d->data);
             }
             else if (!strcmp(key, "I")) {
-                rock->mbentry->uniqueid = buf_newcstring(&d->buf);
+                rock->mbentry->uniqueid = xstrdupnull(d->data);
             }
             else if (!strcmp(key, "M")) {
-                rock->mbentry->mtime = atoi(buf_cstring(&d->buf));
+                rock->mbentry->mtime = atoi(d->data);
             }
             else if (!strcmp(key, "P")) {
-                rock->mbentry->partition = buf_newcstring(&d->buf);
+                rock->mbentry->partition = xstrdupnull(d->data);
             }
             else if (!strcmp(key, "S")) {
-                rock->mbentry->server = buf_newcstring(&d->buf);
+                rock->mbentry->server = xstrdupnull(d->data);
             }
             else if (!strcmp(key, "T")) {
-                rock->mbentry->mbtype = mboxlist_string_to_mbtype(buf_cstring(&d->buf));
+                rock->mbentry->mbtype = mboxlist_string_to_mbtype(d->data);
             }
             else if (!strcmp(key, "V")) {
-                rock->mbentry->uidvalidity = atol(buf_cstring(&d->buf));
+                rock->mbentry->uidvalidity = atol(d->data);
             }
         }
     }
@@ -397,6 +423,8 @@ int parseentry_cb(int type, struct dlist
  *
  * full dlist format is:
  *  A: _a_cl
+ *  C  _c_reatedmodseq
+ *  F: _f_oldermodseq
  *  I: unique_i_d
  *  M: _m_time
  *  P: _p_artition
@@ -497,6 +525,8 @@ static int mboxlist_mylookup(const char
     const char *data;
     size_t datalen;
 
+    init_internal();
+
     r = mboxlist_read(name, &data, &datalen, tid, wrlock);
     if (r) return r;
 
@@ -512,6 +542,8 @@ EXPORTED int mboxlist_lookup(const char
     mbentry_t *entry = NULL;
     int r;
 
+    init_internal();
+
     r = mboxlist_mylookup(name, &entry, tid, 0);
 
     if (r) return r;
@@ -528,6 +560,12 @@ EXPORTED int mboxlist_lookup(const char
         return IMAP_MAILBOX_NONEXISTENT;
     }
 
+    /* Ignore "intermediate" entries, like they aren't there */
+    if (entry->mbtype & MBTYPE_INTERMEDIATE) {
+        mboxlist_entry_free(&entry);
+        return IMAP_MAILBOX_NONEXISTENT;
+    }
+
     if (entryptr) *entryptr = entry;
     else mboxlist_entry_free(&entry);
 
@@ -555,7 +593,7 @@ static int _find_specialuse(const mbentr
     annotatemore_lookup(mbentry->name, "/specialuse", d->userid, &attrib);
 
     if (attrib.len) {
-        strarray_t *uses = strarray_split(buf_cstring(&attrib), " ", 0);
+        strarray_t *uses = strarray_split(buf_cstring(&attrib), NULL, 0);
         if (strarray_find_case(uses, d->use, 0) >= 0)
             d->mboxname = xstrdup(mbentry->name);
         strarray_free(uses);
@@ -570,12 +608,15 @@ static int _find_specialuse(const mbentr
 
 EXPORTED char *mboxlist_find_specialuse(const char *use, const char *userid)
 {
+    init_internal();
+    assert(userid);
+
     /* \\Inbox is magical */
     if (!strcasecmp(use, "\\Inbox"))
         return mboxname_user_mbox(userid, NULL);
 
     struct _find_specialuse_data rock = { use, userid, NULL };
-    mboxlist_usermboxtree(userid, _find_specialuse, &rock, MBOXTREE_SKIP_ROOT);
+    mboxlist_usermboxtree(userid, NULL, _find_specialuse, &rock, MBOXTREE_SKIP_ROOT);
     return rock.mboxname;
 }
 
@@ -587,17 +628,28 @@ struct _find_uniqueid_data {
 static int _find_uniqueid(const mbentry_t *mbentry, void *rock) {
     struct _find_uniqueid_data *d = (struct _find_uniqueid_data *) rock;
     int r = 0;
-    if (!strcmp(d->uniqueid, mbentry->uniqueid)) {
+    if (!strcmpsafe(d->uniqueid, mbentry->uniqueid)) {
         d->mboxname = xstrdup(mbentry->name);
         r = CYRUSDB_DONE;
     }
     return r;
 }
 
-EXPORTED char *mboxlist_find_uniqueid(const char *uniqueid, const char *userid)
+// calling this function without a userid is fine, it will scan the entire server!
+EXPORTED char *mboxlist_find_uniqueid(const char *uniqueid, const char *userid,
+                                      const struct auth_state *auth_state)
 {
     struct _find_uniqueid_data rock = { uniqueid, NULL };
-    mboxlist_usermboxtree(userid, _find_uniqueid, &rock, MBOXTREE_PLUS_RACL);
+
+    int flags = MBOXTREE_INTERMEDIATES|MBOXTREE_PLUS_RACL;
+
+    init_internal();
+
+    if (userid)
+        mboxlist_usermboxtree(userid, auth_state, _find_uniqueid, &rock, flags);
+    else
+        mboxlist_allmbox("", _find_uniqueid, &rock, flags);
+
     return rock.mboxname;
 }
 
@@ -609,6 +661,8 @@ HIDDEN int mboxlist_findstage(const char
     mbentry_t *mbentry = NULL;
     int r;
 
+    init_internal();
+
     assert(stagedir != NULL);
 
     /* Find mailbox */
@@ -649,6 +703,19 @@ static int user_is_in(const strarray_t *
     return 0;
 }
 
+static int mboxlist_update_raclmodseq(const char *acluser)
+{
+    char *aclusermbox = mboxname_user_mbox(acluser, NULL);
+    mbentry_t *raclmbentry = NULL;
+    if (mboxlist_lookup(aclusermbox, &raclmbentry, NULL) == 0) {
+        mboxname_nextraclmodseq(aclusermbox, 0);
+        sync_log_mailbox(aclusermbox);
+    }
+    mboxlist_entry_free(&raclmbentry);
+    free(aclusermbox);
+    return 0;
+}
+
 static int mboxlist_update_racl(const char *name, const mbentry_t *oldmbentry, const mbentry_t *newmbentry, struct txn **txn)
 {
     static strarray_t *admins = NULL;
@@ -661,37 +728,35 @@ static int mboxlist_update_racl(const ch
 
     if (!admins) admins = strarray_split(config_getstring(IMAPOPT_ADMINS), NULL, 0);
 
-    if (oldmbentry && oldmbentry->mbtype != MBTYPE_DELETED)
+    if (oldmbentry && !(oldmbentry->mbtype & MBTYPE_DELETED))
         oldusers = strarray_split(oldmbentry->acl, "\t", 0);
 
-    if (newmbentry && newmbentry->mbtype != MBTYPE_DELETED)
+    if (newmbentry && !(newmbentry->mbtype & MBTYPE_DELETED))
         newusers = strarray_split(newmbentry->acl, "\t", 0);
 
     if (oldusers) {
         for (i = 0; i+1 < strarray_size(oldusers); i+=2) {
             const char *acluser = strarray_nth(oldusers, i);
-            const char *aclval = strarray_nth(oldusers, i+1);
-            if (!strchr(aclval, 'l')) continue; /* non-lookup ACLs can be skipped */
             if (!strcmpsafe(userid, acluser)) continue;
             if (strarray_find(admins, acluser, 0) >= 0) continue;
             if (user_is_in(newusers, acluser)) continue;
             mboxlist_racl_key(!!userid, acluser, name, &buf);
             r = cyrusdb_delete(mbdb, buf.s, buf.len, txn, /*force*/1);
             if (r) goto done;
+            mboxlist_update_raclmodseq(acluser);
         }
     }
 
     if (newusers) {
         for (i = 0; i+1 < strarray_size(newusers); i+=2) {
             const char *acluser = strarray_nth(newusers, i);
-            const char *aclval = strarray_nth(newusers, i+1);
-            if (!strchr(aclval, 'l')) continue; /* non-lookup ACLs can be skipped */
             if (!strcmpsafe(userid, acluser)) continue;
             if (strarray_find(admins, acluser, 0) >= 0) continue;
             if (user_is_in(oldusers, acluser)) continue;
             mboxlist_racl_key(!!userid, acluser, name, &buf);
             r = cyrusdb_store(mbdb, buf.s, buf.len, "", 0, txn);
             if (r) goto done;
+            mboxlist_update_raclmodseq(acluser);
         }
     }
 
@@ -722,14 +787,12 @@ static int mboxlist_update_entry(const c
 
         if (!r && config_auditlog) {
             /* XXX is there a difference between "" and NULL? */
-            if (old && strcmpsafe(old->acl, mbentry->acl)) {
-                syslog(LOG_NOTICE, "auditlog: acl sessionid=<%s> "
-                                   "mailbox=<%s> uniqueid=<%s> "
-                                   "oldacl=<%s> acl=<%s>",
-                       session_id(),
-                       name, mbentry->uniqueid,
-                       old->acl, mbentry->acl);
-            }
+            syslog(LOG_NOTICE, "auditlog: acl sessionid=<%s> "
+                               "mailbox=<%s> uniqueid=<%s> mbtype=<%s> "
+                               "oldacl=<%s> acl=<%s> foldermodseq=<%llu>",
+                   session_id(),
+                   name, mbentry->uniqueid, mboxlist_mbtype_to_string(mbentry->mbtype),
+                   old ? old->acl : "NONE", mbentry->acl, mbentry->foldermodseq);
         }
     }
     else {
@@ -750,6 +813,8 @@ EXPORTED int mboxlist_update(mbentry_t *
     int r = 0, r2 = 0;
     struct txn *tid = NULL;
 
+    init_internal();
+
     r = mboxlist_update_entry(mbentry->name, mbentry, &tid);
 
     if (!r)
@@ -795,17 +860,34 @@ EXPORTED int mboxlist_update(mbentry_t *
     return r;
 }
 
-EXPORTED int mboxlist_findparent(const char *mboxname,
-                               mbentry_t **mbentryp)
+static void assert_namespacelocked(const char *mboxname)
+{
+    char *userid = mboxname_to_userid(mboxname);
+    assert(user_isnamespacelocked(userid));
+    free(userid);
+}
+
+static int _findparent(const char *mboxname, mbentry_t **mbentryp, int allow_all)
 {
     mbentry_t *mbentry = NULL;
     mbname_t *mbname = mbname_from_intname(mboxname);
     int r = IMAP_MAILBOX_NONEXISTENT;
 
+    init_internal();
+
     while (strarray_size(mbname_boxes(mbname))) {
         free(mbname_pop_boxes(mbname));
+        /* skip exactly INBOX, since it's not a real intermediate folder,
+         * and the parent of INBOX.INBOX.foo is INBOX */
+        if (strarray_size(mbname_boxes(mbname)) == 1 &&
+            !strcmp(strarray_nth(mbname_boxes(mbname), 0), "INBOX")) {
+            free(mbname_pop_boxes(mbname));
+        }
         mboxlist_entry_free(&mbentry);
-        r = mboxlist_lookup(mbname_intname(mbname), &mbentry, NULL);
+        if (allow_all)
+            r = mboxlist_lookup_allow_all(mbname_intname(mbname), &mbentry, NULL);
+        else
+            r = mboxlist_lookup(mbname_intname(mbname), &mbentry, NULL);
         if (r != IMAP_MAILBOX_NONEXISTENT)
             break;
     }
@@ -820,6 +902,18 @@ EXPORTED int mboxlist_findparent(const c
     return r;
 }
 
+EXPORTED int mboxlist_findparent(const char *mboxname,
+                               mbentry_t **mbentryp)
+{
+    return _findparent(mboxname, mbentryp, 0);
+}
+
+EXPORTED int mboxlist_findparent_allow_all(const char *mboxname,
+                                            mbentry_t **mbentryp)
+{
+    return _findparent(mboxname, mbentryp, 1);
+}
+
 static int mboxlist_create_partition(const char *mboxname,
                                      const char *part,
                                      char **out)
@@ -1007,6 +1101,8 @@ EXPORTED int mboxlist_createmailboxcheck
     char *acl = NULL;
     int r = 0;
 
+    init_internal();
+
     r = mboxlist_create_namecheck(name, userid, auth_state,
                                   isadmin, forceuser);
     if (r) goto done;
@@ -1031,6 +1127,151 @@ EXPORTED int mboxlist_createmailboxcheck
     return r;
 }
 
+/* PLEASE NOTE - ALWAYS CALL AFTER MAKING THE CHANGES, as this function
+ * will check for children when deciding whether to create or remove
+ * intermediate folders */
+EXPORTED int mboxlist_update_intermediaries(const char *frommboxname,
+                                            int mbtype, modseq_t modseq)
+{
+    mbentry_t *mbentry = NULL;
+    mbname_t *mbname = mbname_from_intname(frommboxname);
+    int r = 0;
+
+    /* only use intermediates for non-deleted user mailboxes */
+    if (mbname_isdeleted(mbname) || !mbname_userid(mbname))
+        goto out;
+
+    for (; strarray_size(mbname_boxes(mbname)); free(mbname_pop_boxes(mbname))) {
+
+        /* check for magic INBOX */
+        if (strarray_size(mbname_boxes(mbname)) == 1 &&
+            !strcmp(strarray_nth(mbname_boxes(mbname), 0), "INBOX")) {
+            /* don't generate magic INBOX intermediate, JMAP doesn't use it */
+            goto out;
+        }
+
+        const char *mboxname = mbname_intname(mbname);
+
+        mboxlist_entry_free(&mbentry);
+        r = mboxlist_mylookup(mboxname, &mbentry, NULL, 0);
+        if (r == IMAP_MAILBOX_NONEXISTENT) r = 0;
+        if (r) goto out;
+
+        if (mbentry) {
+            if (mbentry->mbtype & MBTYPE_DELETED) {
+                /* fall through to create a new intermediate */
+            }
+            else if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+                /* existing intermediate - delete unless it still has children */
+                if (mboxlist_haschildren(mboxname))
+                    continue;
+
+                /* bump modseq, we're removing a thing that can be seen */
+                if (!modseq)
+                    modseq = mboxname_nextmodseq(mboxname, mbentry->foldermodseq,
+                                                 mbtype, 1 /* dofolder */);
+
+                mbentry_t *newmbentry = mboxlist_entry_copy(mbentry);
+                newmbentry->mbtype = MBTYPE_DELETED;
+                newmbentry->foldermodseq = modseq;
+
+                syslog(LOG_NOTICE,
+                       "mboxlist: deleting intermediate with no children: %s (%s)",
+                       mboxname, mbentry->uniqueid);
+                r = mboxlist_update_entry(mboxname, newmbentry, NULL);
+                mboxlist_entry_free(&newmbentry);
+                if (r) goto out;
+                sync_log_mailbox(mboxname);
+
+                /* we've changed the type, we're done at this level */
+                continue;
+            }
+            else {
+                /* real mailbox, we're done at this level */
+                continue;
+            }
+        }
+
+        /* if there's no children, there's no need for intermediates */
+        if (!mboxlist_haschildren(mboxname))
+            continue;
+
+        /* bump modseq, we're adding a thing that can be seen */
+        if (!modseq)
+            modseq = mboxname_nextmodseq(mboxname,
+                                         mbentry ? mbentry->foldermodseq : 0,
+                                         mbtype, 1 /* dofolder */);
+
+        mbentry_t *newmbentry = mboxlist_entry_create();
+        newmbentry->uniqueid = xstrdupnull(makeuuid());
+        newmbentry->createdmodseq = modseq;
+        newmbentry->foldermodseq = modseq;
+        newmbentry->mbtype = MBTYPE_INTERMEDIATE;
+        newmbentry->foldermodseq = modseq;
+
+        syslog(LOG_NOTICE,
+               "mboxlist: creating intermediate with children: %s (%s)",
+               mboxname, newmbentry->uniqueid);
+        r = mboxlist_update_entry(mboxname, newmbentry, NULL);
+        mboxlist_entry_free(&newmbentry);
+        if (r) goto out;
+        sync_log_mailbox(mboxname);
+    }
+
+out:
+    mboxlist_entry_free(&mbentry);
+    mbname_free(&mbname);
+
+    return r;
+}
+
+EXPORTED int mboxlist_promote_intermediary(const char *mboxname)
+{
+    mbentry_t *mbentry = NULL, *parent = NULL;
+    struct mailbox *mailbox = NULL;
+    int r = 0;
+    struct txn *tid = NULL;
+
+    r = mboxlist_lookup_allow_all(mboxname, &mbentry, &tid);
+    if (r || !(mbentry->mbtype & MBTYPE_INTERMEDIATE)) goto done;
+
+    r = mboxlist_findparent(mboxname, &parent);
+    if (r) goto done;
+
+    r = mboxlist_create_partition(mboxname, parent->partition,
+                                  &mbentry->partition);
+    if (r) goto done;
+    mbentry->mbtype = 0; // intermediaries are always standard
+    free(mbentry->acl);
+    mbentry->acl = xstrdupnull(parent->acl);
+
+    r = mailbox_create(mboxname, mbentry->mbtype,
+                       mbentry->partition, parent->acl,
+                       mbentry->uniqueid, 0 /* options */,
+                       mbentry->uidvalidity,
+                       mbentry->createdmodseq,
+                       mbentry->foldermodseq, &mailbox);
+    if (r) goto done;
+
+    r = mailbox_add_conversations(mailbox, /*silent*/1);
+    if (r) goto done;
+
+    r = mboxlist_update_entry(mboxname, mbentry, &tid);
+    if (r) goto done;
+
+done:
+    mailbox_close(&mailbox);
+    if (tid) {
+        if (r) cyrusdb_abort(mbdb, tid);
+        else {
+            r = cyrusdb_commit(mbdb, tid);
+        }
+    }
+    mboxlist_entry_free(&mbentry);
+    mboxlist_entry_free(&parent);
+    return r;
+}
+
 /*
  * Create a mailbox
  *
@@ -1038,7 +1279,7 @@ EXPORTED int mboxlist_createmailboxcheck
  * 2. verify parent ACL's if need to
  * 3. create the local mailbox locally (exclusive lock) and keep it locked
  * 4. open mupdate connection if necessary
- * 5. create mupdate entry (CRASH: mupdate inconsistant)
+ * 5. create mupdate entry (CRASH: mupdate inconsistent)
  *
  */
 
@@ -1047,9 +1288,12 @@ static int mboxlist_createmailbox_full(c
                                 int isadmin, const char *userid,
                                 const struct auth_state *auth_state,
                                 int options, unsigned uidvalidity,
+                                modseq_t createdmodseq,
                                 modseq_t highestmodseq,
+                                modseq_t foldermodseq,
                                 const char *copyacl, const char *uniqueid,
                                 int localonly, int forceuser, int dbonly,
+                                int keep_intermediaries,
                                 struct mailbox **mboxptr)
 {
     int r;
@@ -1063,6 +1307,8 @@ static int mboxlist_createmailbox_full(c
                                   isadmin, forceuser);
     if (r) goto done;
 
+    assert_namespacelocked(mboxname);
+
     if (copyacl) {
         acl = xstrdup(copyacl);
     }
@@ -1077,9 +1323,9 @@ static int mboxlist_createmailbox_full(c
     if (!dbonly && !isremote) {
         /* Filesystem Operations */
         r = mailbox_create(mboxname, mbtype, newpartition, acl, uniqueid,
-                           options, uidvalidity, highestmodseq, &newmailbox);
+                           options, uidvalidity, createdmodseq, highestmodseq, &newmailbox);
         if (r) goto done; /* CREATE failed */
-        r = mailbox_add_conversations(newmailbox);
+        r = mailbox_add_conversations(newmailbox, /*silent*/0);
         if (r) goto done;
     }
 
@@ -1091,10 +1337,16 @@ static int mboxlist_createmailbox_full(c
     if (newmailbox) {
         newmbentry->uniqueid = xstrdupnull(newmailbox->uniqueid);
         newmbentry->uidvalidity = newmailbox->i.uidvalidity;
-        newmbentry->foldermodseq = newmailbox->i.highestmodseq;
+        newmbentry->createdmodseq = newmailbox->i.createdmodseq;
+        newmbentry->foldermodseq = foldermodseq ? foldermodseq : newmailbox->i.highestmodseq;
     }
     r = mboxlist_update_entry(mboxname, newmbentry, NULL);
 
+    if (!r && !keep_intermediaries) {
+        /* create any missing intermediaries */
+        r = mboxlist_update_intermediaries(mboxname, mbtype, newmbentry->foldermodseq);
+    }
+
     if (r) {
         syslog(LOG_ERR, "DBERROR: failed to insert to mailboxes list %s: %s",
                mboxname, cyrusdb_strerror(r));
@@ -1132,6 +1384,24 @@ done:
     return r;
 }
 
+EXPORTED int mboxlist_createmailboxlock(const char *name, int mbtype,
+                           const char *partition,
+                           int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           int localonly, int forceuser, int dbonly,
+                           int notify, struct mailbox **mailboxptr)
+{
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(name);
+
+    int r = mboxlist_createmailbox_unq(name, mbtype, partition, isadmin,
+                                      userid, auth_state, localonly,
+                                      forceuser, dbonly, notify, NULL,
+                                      mailboxptr);
+
+    mboxname_release(&namespacelock);
+    return r;
+}
+
 EXPORTED int mboxlist_createmailbox(const char *name, int mbtype,
                            const char *partition,
                            int isadmin, const char *userid,
@@ -1139,26 +1409,65 @@ EXPORTED int mboxlist_createmailbox(cons
                            int localonly, int forceuser, int dbonly,
                            int notify, struct mailbox **mailboxptr)
 {
+    return mboxlist_createmailbox_unq(name, mbtype, partition, isadmin,
+                                      userid, auth_state, localonly,
+                                      forceuser, dbonly, notify, NULL,
+                                      mailboxptr);
+}
+
+EXPORTED int mboxlist_createmailbox_unq(const char *name, int mbtype,
+                           const char *partition,
+                           int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           int localonly, int forceuser, int dbonly,
+                           int notify, const char *uniqueid,
+                           struct mailbox **mailboxptr)
+{
     int options = config_getint(IMAPOPT_MAILBOX_DEFAULT_OPTIONS)
                   | OPT_POP3_NEW_UIDL;
+
+    return mboxlist_createmailbox_opts(name, mbtype, partition, isadmin, userid,
+                                       auth_state, options, localonly, forceuser,
+                                       dbonly, notify, uniqueid, mailboxptr);
+}
+
+EXPORTED int mboxlist_createmailbox_opts(const char *name, int mbtype,
+                                         const char *partition,
+                                         int isadmin, const char *userid,
+                                         const struct auth_state *auth_state,
+                                         int options, int localonly,
+                                         int forceuser, int dbonly,
+                                         int notify, const char *uniqueid,
+                                         struct mailbox **mailboxptr)
+{
     int r;
     struct mailbox *mailbox = NULL;
     uint32_t uidvalidity = 0;
-
-    /* check if a previous deleted mailbox existed */
+    modseq_t createdmodseq = 0;
     mbentry_t *oldmbentry = NULL;
+
+    init_internal();
+
+    /* check if a mailbox tombstone or intermediate record exists */
     r = mboxlist_lookup_allow_all(name, &oldmbentry, NULL);
-    if (!r && oldmbentry->mbtype == MBTYPE_DELETED) {
-        /* then the UIDVALIDITY must be higher than before */
-        if (uidvalidity <= oldmbentry->uidvalidity)
-            uidvalidity = oldmbentry->uidvalidity+1;
+    if (!r) {
+        if (oldmbentry->mbtype & MBTYPE_DELETED) {
+            /* then the UIDVALIDITY must be higher than before */
+            if (uidvalidity <= oldmbentry->uidvalidity)
+                uidvalidity = oldmbentry->uidvalidity+1;
+        }
+        else if (oldmbentry->mbtype & MBTYPE_INTERMEDIATE) {
+            /* then use the existing mailbox ID and createdmodseq */
+            if (!uniqueid) uniqueid = oldmbentry->uniqueid;
+            createdmodseq = oldmbentry->createdmodseq;
+        }
     }
-    mboxlist_entry_free(&oldmbentry);
 
     r = mboxlist_createmailbox_full(name, mbtype, partition,
                                     isadmin, userid, auth_state,
-                                    options, uidvalidity, 0, NULL, NULL, localonly,
-                                    forceuser, dbonly, &mailbox);
+                                    options, uidvalidity, createdmodseq, 0, 0, NULL,
+                                    uniqueid, localonly,
+                                    forceuser, dbonly, 0, &mailbox);
 
     if (notify && !r) {
         /* send a MailboxCreate event notification */
@@ -1173,6 +1482,8 @@ EXPORTED int mboxlist_createmailbox(cons
     if (mailboxptr && !r) *mailboxptr = mailbox;
     else mailbox_close(&mailbox);
 
+    mboxlist_entry_free(&oldmbentry);
+
     return r;
 }
 
@@ -1180,15 +1491,20 @@ EXPORTED int mboxlist_createsync(const c
                         const char *partition,
                         const char *userid, const struct auth_state *auth_state,
                         int options, unsigned uidvalidity,
+                        modseq_t createdmodseq,
                         modseq_t highestmodseq,
+                        modseq_t foldermodseq,
                         const char *acl, const char *uniqueid,
-                        int local_only, struct mailbox **mboxptr)
+                        int local_only, int keep_intermediaries,
+                        struct mailbox **mboxptr)
 {
     return mboxlist_createmailbox_full(name, mbtype, partition,
                                        1, userid, auth_state,
                                        options, uidvalidity,
-                                       highestmodseq, acl, uniqueid,
-                                       local_only, 1, 0, mboxptr);
+                                       createdmodseq, highestmodseq,
+                                       foldermodseq, acl, uniqueid,
+                                       local_only, 1, 0,
+                                       keep_intermediaries, mboxptr);
 }
 
 /* insert an entry for the proxy */
@@ -1308,7 +1624,8 @@ mboxlist_delayed_deletemailbox(const cha
                                struct mboxevent *mboxevent,
                                int checkacl,
                                int localonly,
-                               int force)
+                               int force,
+                               int keep_intermediaries)
 {
     mbentry_t *mbentry = NULL;
     strarray_t existing = STRARRAY_INITIALIZER;
@@ -1316,6 +1633,8 @@ mboxlist_delayed_deletemailbox(const cha
     int r = 0;
     long myrights;
 
+    init_internal();
+
     if (!isadmin && force) return IMAP_PERMISSION_DENIED;
 
     /* delete of a user.X folder */
@@ -1334,11 +1653,20 @@ mboxlist_delayed_deletemailbox(const cha
     }
 
     if (!isadmin && mbname_userid(mbname)) {
-        struct buf attrib = BUF_INITIALIZER;
-        annotatemore_lookup(mbname_intname(mbname), "/specialuse", mbname_userid(mbname), &attrib);
-        if (attrib.len)
-            r = IMAP_MAILBOX_SPECIALUSE;
-        buf_free(&attrib);
+        const char *protect = config_getstring(IMAPOPT_SPECIALUSE_PROTECT);
+        if (protect) {
+            struct buf attrib = BUF_INITIALIZER;
+            annotatemore_lookup(mbname_intname(mbname), "/specialuse", mbname_userid(mbname), &attrib);
+            if (attrib.len) {
+                strarray_t *check = strarray_split(protect, NULL, STRARRAY_TRIM);
+                strarray_t *uses = strarray_split(buf_cstring(&attrib), NULL, 0);
+                if (strarray_intersect_case(uses, check))
+                    r = IMAP_MAILBOX_SPECIALUSE;
+                strarray_free(uses);
+                strarray_free(check);
+            }
+            buf_free(&attrib);
+        }
         if (r) goto done;
     }
 
@@ -1368,13 +1696,15 @@ mboxlist_delayed_deletemailbox(const cha
     mboxname_todeleted(name, newname, 1);
 
     /* Get mboxlist_renamemailbox to do the hard work. No ACL checks needed */
-    r = mboxlist_renamemailbox((char *)name, newname, mbentry->partition,
+    r = mboxlist_renamemailbox(mbentry, newname, mbentry->partition,
                                0 /* uidvalidity */,
                                1 /* isadmin */, userid,
                                auth_state,
                                mboxevent,
                                localonly /* local_only */,
-                               force, 1);
+                               force, 1,
+                               keep_intermediaries,
+                               0 /* move_subscription */, 0 /* silent */);
 
 done:
     strarray_fini(&existing);
@@ -1397,12 +1727,13 @@ done:
  * 7. delete from mupdate
  *
  */
-EXPORTED int mboxlist_deletemailbox(const char *name, int isadmin,
-                                    const char *userid,
-                                    const struct auth_state *auth_state,
-                                    struct mboxevent *mboxevent,
-                                    int checkacl,
-                                    int local_only, int force)
+EXPORTED int mboxlist_deletemailbox_full(const char *name, int isadmin,
+                                         const char *userid,
+                                         const struct auth_state *auth_state,
+                                         struct mboxevent *mboxevent,
+                                         int checkacl,
+                                         int local_only, int force,
+                                         int keep_intermediaries, int silent)
 {
     mbentry_t *mbentry = NULL;
     int r = 0;
@@ -1411,8 +1742,12 @@ EXPORTED int mboxlist_deletemailbox(cons
     int isremote = 0;
     mupdate_handle *mupdate_h = NULL;
 
+    init_internal();
+
     if (!isadmin && force) return IMAP_PERMISSION_DENIED;
 
+    assert_namespacelocked(name);
+
     /* delete of a user.X folder */
     mbname_t *mbname = mbname_from_intname(name);
     if (mbname_userid(mbname) && !strarray_size(mbname_boxes(mbname))) {
@@ -1429,11 +1764,20 @@ EXPORTED int mboxlist_deletemailbox(cons
     }
 
     if (!isadmin && mbname_userid(mbname)) {
-        struct buf attrib = BUF_INITIALIZER;
-        annotatemore_lookup(mbname_intname(mbname), "/specialuse", mbname_userid(mbname), &attrib);
-        if (attrib.len)
-            r = IMAP_MAILBOX_SPECIALUSE;
-        buf_free(&attrib);
+        const char *protect = config_getstring(IMAPOPT_SPECIALUSE_PROTECT);
+        if (protect) {
+            struct buf attrib = BUF_INITIALIZER;
+            annotatemore_lookup(mbname_intname(mbname), "/specialuse", mbname_userid(mbname), &attrib);
+            if (attrib.len) {
+                strarray_t *check = strarray_split(protect, NULL, STRARRAY_TRIM);
+                strarray_t *uses = strarray_split(buf_cstring(&attrib), NULL, 0);
+                if (strarray_intersect_case(uses, check))
+                    r = IMAP_MAILBOX_SPECIALUSE;
+                strarray_free(uses);
+                strarray_free(check);
+            }
+            buf_free(&attrib);
+        }
         if (r) goto done;
     }
 
@@ -1463,6 +1807,7 @@ EXPORTED int mboxlist_deletemailbox(cons
     /* Lock the mailbox if it isn't a remote mailbox */
     if (!isremote) {
         r = mailbox_open_iwl(name, &mailbox);
+        if (!r) mailbox->silentchanges = silent;
     }
     if (r && !force) goto done;
 
@@ -1487,15 +1832,23 @@ EXPORTED int mboxlist_deletemailbox(cons
 
     if (!isremote && !mboxname_isdeletedmailbox(name, NULL)) {
         /* store a DELETED marker */
+        int haschildren = mboxlist_haschildren(name);
         mbentry_t *newmbentry = mboxlist_entry_create();
         newmbentry->name = xstrdupnull(name);
-        newmbentry->mbtype = MBTYPE_DELETED;
+        newmbentry->mbtype = haschildren ? MBTYPE_INTERMEDIATE : MBTYPE_DELETED;
         if (mailbox) {
             newmbentry->uniqueid = xstrdupnull(mailbox->uniqueid);
             newmbentry->uidvalidity = mailbox->i.uidvalidity;
+            newmbentry->createdmodseq = mailbox->i.createdmodseq;
             newmbentry->foldermodseq = mailbox_modseq_dirty(mailbox);
         }
         r = mboxlist_update(newmbentry, /*localonly*/1);
+
+        /* any other updated intermediates get the same modseq */
+        if (!r && !keep_intermediaries) {
+            r = mboxlist_update_intermediaries(mbentry->name, mbentry->mbtype, newmbentry->foldermodseq);
+        }
+
         mboxlist_entry_free(&newmbentry);
     }
     else {
@@ -1511,6 +1864,7 @@ EXPORTED int mboxlist_deletemailbox(cons
         if (r && !force) goto done;
     }
 
+
     /* delete underlying mailbox */
     if (!isremote && mailbox) {
         /* only on a real delete do we delete from the remote end as well */
@@ -1524,6 +1878,7 @@ EXPORTED int mboxlist_deletemailbox(cons
             mboxevent_free(&mboxevent);
     }
 
+
  done:
     mailbox_close(&mailbox);
     mboxlist_entry_free(&mbentry);
@@ -1532,72 +1887,251 @@ EXPORTED int mboxlist_deletemailbox(cons
     return r;
 }
 
+EXPORTED int mboxlist_deletemailbox(const char *name, int isadmin,
+                                    const char *userid,
+                                    const struct auth_state *auth_state,
+                                    struct mboxevent *mboxevent,
+                                    int checkacl,
+                                    int local_only, int force,
+                                    int keep_intermediaries)
+{
+    return mboxlist_deletemailbox_full(name, isadmin, userid, auth_state,
+                                       mboxevent, checkacl, local_only, force,
+                                       keep_intermediaries, /*silent*/0);
+}
+
+EXPORTED int mboxlist_deletemailboxlock(const char *name, int isadmin,
+                                    const char *userid,
+                                    const struct auth_state *auth_state,
+                                    struct mboxevent *mboxevent,
+                                    int checkacl,
+                                    int local_only, int force,
+                                    int keep_intermediaries)
+{
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(name);
+
+    int r = mboxlist_deletemailbox(name, isadmin, userid, auth_state, mboxevent,
+                                   checkacl, local_only, force, keep_intermediaries);
+
+    mboxname_release(&namespacelock);
+    return r;
+}
+
 static int _rename_check_specialuse(const char *oldname, const char *newname)
 {
+    const char *protect = config_getstring(IMAPOPT_SPECIALUSE_PROTECT);
+    if (!protect) return 0;
+
     mbname_t *old = mbname_from_intname(oldname);
     mbname_t *new = mbname_from_intname(newname);
     struct buf attrib = BUF_INITIALIZER;
     int r = 0;
     if (mbname_userid(old))
         annotatemore_lookup(oldname, "/specialuse", mbname_userid(old), &attrib);
+
     /* we have specialuse? */
     if (attrib.len) {
-        /* then target must be a single-depth mailbox too */
-        if (strarray_size(mbname_boxes(new)) != 1)
-            r = IMAP_MAILBOX_SPECIALUSE;
-        /* and have a userid as well */
-        if (!mbname_userid(new))
-            r = IMAP_MAILBOX_SPECIALUSE;
-        /* and not be deleted */
-        if (mbname_isdeleted(new))
-            r = IMAP_MAILBOX_SPECIALUSE;
+        strarray_t *check = strarray_split(protect, NULL, STRARRAY_TRIM);
+        strarray_t *uses = strarray_split(buf_cstring(&attrib), NULL, 0);
+        if (strarray_intersect_case(uses, check)) {
+            /* then target must be a single-depth mailbox too */
+            if (strarray_size(mbname_boxes(new)) != 1)
+                r = IMAP_MAILBOX_SPECIALUSE;
+            /* and have a userid as well */
+            if (!mbname_userid(new))
+                r = IMAP_MAILBOX_SPECIALUSE;
+            /* and not be deleted */
+            if (mbname_isdeleted(new))
+                r = IMAP_MAILBOX_SPECIALUSE;
+        }
+        strarray_free(uses);
+        strarray_free(check);
     }
+
     mbname_free(&new);
     mbname_free(&old);
     buf_free(&attrib);
     return r;
 }
 
+struct renmboxdata {
+    size_t ol;
+    size_t nl;
+    char newname[MAX_MAILBOX_NAME+1];
+    const struct auth_state *authstate;
+    const char *partition;
+    const char *userid;
+    int local_only;
+    int ignorequota;
+    int found;
+    int keep_intermediaries;
+    int move_subscription;
+};
+
+static int renamecheck(const mbentry_t *mbentry, void *rock)
+{
+    struct renmboxdata *text = (struct renmboxdata *)rock;
+    int r;
+
+    text->found++;
+
+    if((text->nl + strlen(mbentry->name + text->ol)) >= MAX_MAILBOX_NAME)
+        return IMAP_MAILBOX_BADNAME;
+
+    strcpy(text->newname + text->nl, mbentry->name + text->ol);
+
+    /* force create, but don't ignore policy.  This is a filthy hack that
+       will go away when we refactor this code */
+    r = mboxlist_createmailboxcheck(text->newname, 0, text->partition, 1,
+                                    text->userid, text->authstate, NULL, NULL, 2);
+    return r;
+}
+
+static int dorename(const mbentry_t *mbentry, void *rock)
+{
+    struct renmboxdata *text = (struct renmboxdata *)rock;
+    int r;
+
+    if((text->nl + strlen(mbentry->name + text->ol)) >= MAX_MAILBOX_NAME)
+        return IMAP_MAILBOX_BADNAME;
+
+    strcpy(text->newname + text->nl, mbentry->name + text->ol);
+
+    r = mboxlist_renamemailbox(mbentry, text->newname,
+                               text->partition, /*uidvalidity*/0,
+                               /*isadmin*/1, text->userid,
+                               text->authstate,
+                               /*mboxevent*/NULL,
+                               text->local_only, /*forceuser*/1, text->ignorequota,
+                               text->keep_intermediaries,
+                               text->move_subscription, /*silent*/0);
+
+    return r;
+}
+
+EXPORTED int mboxlist_renametree(const char *oldname, const char *newname,
+                                 const char *partition, unsigned uidvalidity,
+                                 int isadmin, const char *userid,
+                                 const struct auth_state *auth_state,
+                                 struct mboxevent *mboxevent,
+                                 int local_only, int forceuser, int ignorequota,
+                                 int keep_intermediaries, int move_subscription)
+{
+    struct renmboxdata rock;
+    memset(&rock, 0, sizeof(struct renmboxdata));
+    rock.ol = strlen(oldname);
+    rock.nl = strlen(newname);
+    memcpy(rock.newname, newname, rock.nl);
+    rock.partition = partition;
+    rock.authstate = auth_state;
+    rock.userid = userid;
+    rock.local_only = local_only;
+    rock.ignorequota = ignorequota;
+    rock.keep_intermediaries = keep_intermediaries;
+    rock.move_subscription = move_subscription;
+    mbentry_t *mbentry = NULL;
+    int r;
+
+    /* first check that we can rename safely */
+    r = mboxlist_mboxtree(oldname, renamecheck, &rock, 0);
+    if (r) return r;
+
+    r = mboxlist_lookup_allow_all(oldname, &mbentry, 0);
+    if (r) return r;
+
+    if (mbentry->mbtype & (MBTYPE_RESERVE | MBTYPE_DELETED)) {
+        mboxlist_entry_free(&mbentry);
+        return IMAP_MAILBOX_NONEXISTENT;
+    }
+
+    // rename the root mailbox
+    r = mboxlist_renamemailbox(mbentry, newname,
+                               partition, uidvalidity,
+                               isadmin, userid,
+                               auth_state,
+                               mboxevent,
+                               local_only, forceuser, ignorequota,
+                               keep_intermediaries, move_subscription, /*silent*/0);
+    mboxlist_entry_free(&mbentry);
+
+    // special-case only children exist
+    if (r == IMAP_MAILBOX_NONEXISTENT && rock.found) r = 0;
+    if (r) return r;
+
+    // now the children
+    r = mboxlist_mboxtree(oldname, dorename, &rock, MBOXTREE_SKIP_ROOT);
+    return r;
+}
+
 /*
  * Rename/move a single mailbox (recursive renames are handled at a
  * higher level).  This only supports local mailboxes.  Remote
  * mailboxes are handled up in imapd.c
  */
-EXPORTED int mboxlist_renamemailbox(const char *oldname, const char *newname,
-                           const char *partition, unsigned uidvalidity,
-                           int isadmin, const char *userid,
-                           const struct auth_state *auth_state,
-                           struct mboxevent *mboxevent,
-                           int local_only, int forceuser, int ignorequota)
+EXPORTED int mboxlist_renamemailbox(const mbentry_t *mbentry,
+                                    const char *newname,
+                                    const char *partition, unsigned uidvalidity,
+                                    int isadmin, const char *userid,
+                                    const struct auth_state *auth_state,
+                                    struct mboxevent *mboxevent,
+                                    int local_only, int forceuser,
+                                    int ignorequota, int keep_intermediaries,
+                                    int move_subscription, int silent)
 {
     int r;
+    const char *oldname = mbentry->name;
     int mupdatecommiterror = 0;
     long myrights;
     int isusermbox = 0; /* Are we renaming someone's inbox */
     int partitionmove = 0;
     struct mailbox *oldmailbox = NULL;
     struct mailbox *newmailbox = NULL;
+    strarray_t inter = STRARRAY_INITIALIZER;
     struct txn *tid = NULL;
     const char *root = NULL;
     char *newpartition = NULL;
     mupdate_handle *mupdate_h = NULL;
     mbentry_t *newmbentry = NULL;
 
-    /* 1. open mailbox */
-    r = mailbox_open_iwl(oldname, &oldmailbox);
-    if (r) return r;
+    init_internal();
 
-    myrights = cyrus_acl_myrights(auth_state, oldmailbox->acl);
+    assert_namespacelocked(mbentry->name);
+    assert_namespacelocked(newname);
+
+    /* special-case: intermediate mailbox */
+    if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+        r = mboxlist_create_namecheck(newname, userid, auth_state,
+                                      isadmin, forceuser);
+        if (r) goto done;
+        newmbentry = mboxlist_entry_copy(mbentry);
+        free(newmbentry->name);
+        newmbentry->name = xstrdupnull(newname);
+        if (!silent) {
+            newmbentry->foldermodseq = mboxname_nextmodseq(newname, newmbentry->foldermodseq,
+                                                           newmbentry->mbtype, 1);
+        }
+
+        /* skip ahead to the database update */
+        goto dbupdate;
+    }
+
+    myrights = cyrus_acl_myrights(auth_state, mbentry->acl);
 
     /* check the ACLs up-front */
     if (!isadmin) {
         if (!(myrights & ACL_DELETEMBOX)) {
             r = (myrights & ACL_LOOKUP) ?
                 IMAP_PERMISSION_DENIED : IMAP_MAILBOX_NONEXISTENT;
-            goto done;
+            return r;
         }
     }
 
+    /* 1. open mailbox */
+    r = mailbox_open_iwl(oldname, &oldmailbox);
+    if (r) return r;
+
+    oldmailbox->silentchanges = silent;
+
     /* 2. verify valid move */
     /* XXX - handle remote mailbox */
 
@@ -1647,7 +2181,10 @@ EXPORTED int mboxlist_renamemailbox(cons
         newmbentry->acl = xstrdupnull(oldmailbox->acl);
         newmbentry->uidvalidity = oldmailbox->i.uidvalidity;
         newmbentry->uniqueid = xstrdupnull(oldmailbox->uniqueid);
-        newmbentry->foldermodseq = oldmailbox->i.highestmodseq; /* bump regardless, it's rare */
+        newmbentry->createdmodseq = oldmailbox->i.createdmodseq;
+        newmbentry->foldermodseq = silent ? oldmailbox->foldermodseq
+                                          : mboxname_nextmodseq(newname, oldmailbox->foldermodseq,
+                                                                oldmailbox->mbtype, 1);
 
         r = mboxlist_update_entry(newname, newmbentry, &tid);
         if (r) goto done;
@@ -1701,7 +2238,7 @@ EXPORTED int mboxlist_renamemailbox(cons
     /* Rename the actual mailbox */
     r = mailbox_rename_copy(oldmailbox, newname, newpartition, uidvalidity,
                             isusermbox ? userid : NULL, ignorequota,
-                            &newmailbox);
+                            silent, &newmailbox);
 
     if (r) goto done;
 
@@ -1715,8 +2252,11 @@ EXPORTED int mboxlist_renamemailbox(cons
     newmbentry->acl = xstrdupnull(newmailbox->acl);
     newmbentry->uidvalidity = newmailbox->i.uidvalidity;
     newmbentry->uniqueid = xstrdupnull(newmailbox->uniqueid);
+    newmbentry->createdmodseq = newmailbox->i.createdmodseq;
     newmbentry->foldermodseq = newmailbox->i.highestmodseq;
 
+  dbupdate:
+
     do {
         r = 0;
 
@@ -1724,11 +2264,12 @@ EXPORTED int mboxlist_renamemailbox(cons
         if (!isusermbox) {
             /* store a DELETED marker */
             mbentry_t *oldmbentry = mboxlist_entry_create();
-            oldmbentry->name = xstrdupnull(oldmailbox->name);
+            oldmbentry->name = xstrdupnull(mbentry->name);
             oldmbentry->mbtype = MBTYPE_DELETED;
-            oldmbentry->uidvalidity = oldmailbox->i.uidvalidity;
-            oldmbentry->uniqueid = xstrdupnull(oldmailbox->uniqueid);
-            oldmbentry->foldermodseq = mailbox_modseq_dirty(oldmailbox);
+            oldmbentry->uidvalidity = mbentry->uidvalidity;
+            oldmbentry->uniqueid = xstrdupnull(mbentry->uniqueid);
+            oldmbentry->createdmodseq = mbentry->createdmodseq;
+            oldmbentry->foldermodseq = newmbentry->foldermodseq;
 
             r = mboxlist_update_entry(oldname, oldmbentry, &tid);
 
@@ -1759,6 +2300,7 @@ EXPORTED int mboxlist_renamemailbox(cons
 
     /* 3. Commit transaction */
     r = cyrusdb_commit(mbdb, tid);
+
     tid = NULL;
     if (r) {
         syslog(LOG_ERR, "DBERROR: rename failed on commit %s %s: %s",
@@ -1767,6 +2309,23 @@ EXPORTED int mboxlist_renamemailbox(cons
         goto done;
     }
 
+    /* Move subscription */
+    if (move_subscription) {
+        int is_subscribed = mboxlist_checksub(oldname, userid) == 0;
+        int r2 = mboxlist_changesub(oldname, userid, auth_state, 0, 0, 0);
+        if (r2) {
+            syslog(LOG_ERR, "CHANGESUB: can't unsubscribe %s: %s",
+                    oldname, error_message(r2));
+        }
+        if (is_subscribed) {
+            r2 = mboxlist_changesub(newname, userid, auth_state, 1, 0, 0);
+            if (r2) {
+                syslog(LOG_ERR, "CHANGESUB: can't subscribe %s: %s",
+                        newname, error_message(r2));
+            }
+        }
+    }
+
     if (!local_only && config_mupdate_server) {
         /* commit the mailbox in MUPDATE */
         char *loc = strconcat(config_servername, "!", newpartition, (char *)NULL);
@@ -1792,6 +2351,11 @@ EXPORTED int mboxlist_renamemailbox(cons
     if (!r && newmailbox)
         r = mailbox_commit(newmailbox);
 
+    if (!keep_intermediaries) {
+        if (!r) r = mboxlist_update_intermediaries(oldname, newmbentry->mbtype, newmbentry->foldermodseq);
+        if (!r) r = mboxlist_update_intermediaries(newname, newmbentry->mbtype, newmbentry->foldermodseq);
+    }
+
     if (r) {
         /* rollback DB changes if it was an mupdate failure */
         if (mupdatecommiterror) {
@@ -1874,11 +2438,16 @@ EXPORTED int mboxlist_renamemailbox(cons
             free(olduniqueid);
             free(oldpartition);
         }
+        else if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+            /* no event notification */
+            if (mboxevent) mboxevent->type = EVENT_CANCELLED;
+        }
         else
             abort(); /* impossible, in theory */
     }
 
     /* free memory */
+    strarray_fini(&inter);
     free(newpartition);
     mboxlist_entry_free(&newmbentry);
 
@@ -1931,6 +2500,8 @@ EXPORTED int mboxlist_setacl(const struc
     char *newacl = NULL;
     struct txn *tid = NULL;
 
+    init_internal();
+
     /* round trip identifier to potentially strip domain */
     mbname_t *mbname = mbname_from_userid(identifier);
     /* XXX - enforce cross domain restrictions */
@@ -2063,6 +2634,7 @@ EXPORTED int mboxlist_setacl(const struc
         /* ok, change the database */
         free(mbentry->acl);
         mbentry->acl = xstrdupnull(newacl);
+        mbentry->foldermodseq = mailbox_modseq_dirty(mailbox);
 
         r = mboxlist_update_entry(name, mbentry, &tid);
 
@@ -2086,7 +2658,7 @@ EXPORTED int mboxlist_setacl(const struc
     /* 4. Change backup copy (cyrus.header) */
     /* we already have it locked from above */
     if (!r && !(mbentry->mbtype & MBTYPE_REMOTE)) {
-        mailbox_set_acl(mailbox, newacl, 1);
+        mailbox_set_acl(mailbox, newacl);
         /* want to commit immediately to ensure ordering */
         r = mailbox_commit(mailbox);
     }
@@ -2143,6 +2715,18 @@ EXPORTED int mboxlist_setacl(const struc
     return r;
 }
 
+/* change the ACL for mailbox 'name' when we have nothing but the name and the new value */
+EXPORTED int mboxlist_updateacl_raw(const char *name, const char *newacl)
+{
+    struct mailbox *mailbox = NULL;
+    int r = mailbox_open_iwl(name, &mailbox);
+    if (!r) r = mboxlist_sync_setacls(name, newacl, mailbox_modseq_dirty(mailbox));
+    if (!r) r = mailbox_set_acl(mailbox, newacl);
+    if (!r) r = mailbox_commit(mailbox);
+    mailbox_close(&mailbox);
+    return r;
+}
+
 /*
  * Change the ACL for mailbox 'name'.  We already have it locked
  * and have written the backup copy to the header, so there's
@@ -2155,51 +2739,58 @@ EXPORTED int mboxlist_setacl(const struc
  *
  */
 EXPORTED int
-mboxlist_sync_setacls(const char *name, const char *newacl)
+mboxlist_sync_setacls(const char *name, const char *newacl, modseq_t foldermodseq)
 {
     mbentry_t *mbentry = NULL;
     int r;
     struct txn *tid = NULL;
 
+    init_internal();
+
     /* 1. Start Transaction */
     /* lookup the mailbox to make sure it exists and get its acl */
     do {
         r = mboxlist_mylookup(name, &mbentry, &tid, 1);
     } while(r == IMAP_AGAIN);
+    if (r) goto done;
+
+    // nothing to change, great
+    if (!strcmpsafe(mbentry->acl, newacl) && mbentry->foldermodseq >= foldermodseq)
+        goto done;
 
     /* Can't do this to an in-transit or reserved mailbox */
-    if (!r && mbentry->mbtype & (MBTYPE_MOVING | MBTYPE_RESERVE | MBTYPE_DELETED)) {
+    if (mbentry->mbtype & (MBTYPE_MOVING | MBTYPE_RESERVE | MBTYPE_DELETED)) {
         r = IMAP_MAILBOX_NOTSUPPORTED;
+        goto done;
     }
 
     /* 2. Set DB Entry */
-    if (!r) {
-        /* ok, change the database */
-        free(mbentry->acl);
-        mbentry->acl = xstrdupnull(newacl);
+    free(mbentry->acl);
+    mbentry->acl = xstrdupnull(newacl);
+    if (mbentry->foldermodseq < foldermodseq)
+        mbentry->foldermodseq = foldermodseq;
 
-        r = mboxlist_update_entry(name, mbentry, &tid);
+    r = mboxlist_update_entry(name, mbentry, &tid);
 
-        if (r) {
-            syslog(LOG_ERR, "DBERROR: error updating acl %s: %s",
-                   name, cyrusdb_strerror(r));
-            r = IMAP_IOERROR;
-        }
+    if (r) {
+        syslog(LOG_ERR, "DBERROR: error updating acl %s: %s",
+               name, cyrusdb_strerror(r));
+        r = IMAP_IOERROR;
+        goto done;
     }
 
     /* 3. Commit transaction */
-    if (!r) {
-        r = cyrusdb_commit(mbdb, tid);
-        if (r) {
-            syslog(LOG_ERR, "DBERROR: failed on commit %s: %s",
-                   name, cyrusdb_strerror(r));
-            r = IMAP_IOERROR;
-        }
-        tid = NULL;
+    r = cyrusdb_commit(mbdb, tid);
+    if (r) {
+        syslog(LOG_ERR, "DBERROR: failed on commit %s: %s",
+               name, cyrusdb_strerror(r));
+        r = IMAP_IOERROR;
+        goto done;
     }
+    tid = NULL;
 
     /* 4. Change mupdate entry  */
-    if (!r && config_mupdate_server) {
+    if (config_mupdate_server) {
         mupdate_handle *mupdate_h = NULL;
         /* commit the update to MUPDATE */
         char buf[MAX_PARTITION_LEN + HOSTNAME_SIZE + 2];
@@ -2212,7 +2803,7 @@ mboxlist_sync_setacls(const char *name,
                    name);
         } else {
             r = mupdate_activate(mupdate_h, name, buf, newacl);
-            if(r) {
+            if (r) {
                 syslog(LOG_ERR,
                        "MUPDATE: can't update mailbox entry for '%s'",
                        name);
@@ -2221,7 +2812,9 @@ mboxlist_sync_setacls(const char *name,
         mupdate_disconnect(&mupdate_h);
     }
 
-    if (r && tid) {
+done:
+
+    if (tid) {
         /* if we are mid-transaction, abort it! */
         int r2 = cyrusdb_abort(mbdb, tid);
         if (r2) {
@@ -2251,7 +2844,8 @@ struct find_rock {
     mbname_t *mbname;
     mbentry_t *mbentry;
     int matchlen;
-    findall_cb *proc;
+    findall_p *p;
+    findall_cb *cb;
     void *procrock;
 };
 
@@ -2313,17 +2907,30 @@ static int find_p(void *rockp,
     if (rock->mbentry->mbtype & MBTYPE_DELETED)
         goto nomatch;
 
+    /* only admins and mailbox owners see intermediates */
+    if (rock->mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+        if (rock->isadmin ||
+            mboxname_userownsmailbox(rock->userid, intname)) goto good;
+        else goto nomatch;
+    }
+
     /* check acl */
     if (!rock->isadmin) {
-        /* always suppress deleted for non-admin */
-        if (mbname_isdeleted(rock->mbname)) goto nomatch;
-
-        /* check the acls */
         if (!(cyrus_acl_myrights(rock->auth_state, rock->mbentry->acl) & ACL_LOOKUP)) goto nomatch;
     }
 
 good:
-    return 1;
+    if (rock->p) {
+        struct findall_data fdata = { extname, 0, rock->mbentry, rock->mbname, 0 };
+        /* mbname confirms that it's an exact match */
+        if (rock->matchlen == (int) strlen(extname))
+            fdata.is_exactmatch = 1;
+        if (!rock->p(&fdata, rock->procrock)) goto nomatch;
+        return 1;
+    }
+    else {
+        return 1;
+    }
 
 nomatch:
     mboxlist_entry_free(&rock->mbentry);
@@ -2354,7 +2961,7 @@ static int find_cb(void *rockp,
     const char *extname = mbname_extname(rock->mbname, rock->namespace, rock->userid);
     testname = xstrndup(extname, rock->matchlen);
 
-    struct findall_data fdata = { testname, rock->mb_category, rock->mbentry, NULL };
+    struct findall_data fdata = { testname, rock->mb_category, rock->mbentry, rock->mbname, 0 };
 
     if (rock->singlepercent) {
         char sep = rock->namespace->hier_sep;
@@ -2372,7 +2979,7 @@ static int find_cb(void *rockp,
             }
 
             if (matchlen == (int)strlen(testname)) {
-                r = (*rock->proc)(&fdata, rock->procrock);
+                r = (*rock->cb)(&fdata, rock->procrock);
                 if (r) goto done;
             }
 
@@ -2383,9 +2990,9 @@ static int find_cb(void *rockp,
 
     /* mbname confirms that it's an exact match */
     if (rock->matchlen == (int)strlen(extname))
-        fdata.mbname = rock->mbname;
+        fdata.is_exactmatch = 1;
 
-    r = (*rock->proc)(&fdata, rock->procrock);
+    r = (*rock->cb)(&fdata, rock->procrock);
 
  done:
     free(testname);
@@ -2396,9 +3003,9 @@ static int find_cb(void *rockp,
 
 struct allmb_rock {
     struct mboxlist_entry *mbentry;
-    int flags;
     mboxlist_cb *proc;
     void *rock;
+    int flags;
 };
 
 static int allmbox_cb(void *rock,
@@ -2438,15 +3045,19 @@ static int allmbox_p(void *rock,
     if (!(mbrock->flags & MBOXTREE_TOMBSTONES) && (mbrock->mbentry->mbtype & MBTYPE_DELETED))
         return 0;
 
+    if (!(mbrock->flags & MBOXTREE_INTERMEDIATES) && (mbrock->mbentry->mbtype & MBTYPE_INTERMEDIATE))
+        return 0;
+
     return 1; /* process this record */
 }
 
-EXPORTED int mboxlist_allmbox(const char *prefix, mboxlist_cb *proc, void *rock, int incdel)
+EXPORTED int mboxlist_allmbox(const char *prefix, mboxlist_cb *proc, void *rock, int flags)
 {
-    struct allmb_rock mbrock = { NULL, 0, proc, rock };
+    struct allmb_rock mbrock = { NULL, proc, rock, flags };
     int r = 0;
 
-    if (incdel) mbrock.flags |= MBOXTREE_TOMBSTONES;
+    init_internal();
+
     if (!prefix) prefix = "";
 
     r = cyrusdb_foreach(mbdb, prefix, strlen(prefix),
@@ -2459,9 +3070,11 @@ EXPORTED int mboxlist_allmbox(const char
 
 EXPORTED int mboxlist_mboxtree(const char *mboxname, mboxlist_cb *proc, void *rock, int flags)
 {
-    struct allmb_rock mbrock = { NULL, flags, proc, rock };
+    struct allmb_rock mbrock = { NULL, proc, rock, flags };
     int r = 0;
 
+    init_internal();
+
     if (!(flags & MBOXTREE_SKIP_ROOT)) {
         r = cyrusdb_forone(mbdb, mboxname, strlen(mboxname), allmbox_p, allmbox_cb, &mbrock, 0);
         if (r) goto done;
@@ -2479,10 +3092,10 @@ EXPORTED int mboxlist_mboxtree(const cha
         const char *p = strchr(mboxname, '!');
         const char *dp = config_getstring(IMAPOPT_DELETEDPREFIX);
         if (p) {
-            buf_printf(&buf, "%.*s!%s.%s", (int)(p-mboxname), mboxname, dp, p+1);
+            buf_printf(&buf, "%.*s!%s.%s.", (int)(p-mboxname), mboxname, dp, p+1);
         }
         else {
-            buf_printf(&buf, "%s.%s", dp, mboxname);
+            buf_printf(&buf, "%s.%s.", dp, mboxname);
         }
         const char *prefix = buf_cstring(&buf);
         r = cyrusdb_foreach(mbdb, prefix, strlen(prefix), allmbox_p, allmbox_cb, &mbrock, 0);
@@ -2516,6 +3129,8 @@ EXPORTED int mboxlist_set_racls(int enab
     int r = 0;
     int now = !cyrusdb_fetch(mbdb, "$RACL", 5, NULL, NULL, &tid);
 
+    init_internal();
+
     if (now && !enabled) {
         syslog(LOG_NOTICE, "removing reverse acl support");
         /* remove */
@@ -2523,7 +3138,7 @@ EXPORTED int mboxlist_set_racls(int enab
     }
     else if (enabled && !now) {
         /* add */
-        struct allmb_rock mbrock = { NULL, 0, racls_add_cb, &tid };
+        struct allmb_rock mbrock = { NULL, racls_add_cb, &tid, 0 };
         /* we can't use mboxlist_allmbox because it doesn't do transactions */
         syslog(LOG_NOTICE, "adding reverse acl support");
         r = cyrusdb_foreach(mbdb, "", 0, allmbox_p, allmbox_cb, &mbrock, &tid);
@@ -2571,6 +3186,9 @@ EXPORTED int mboxlist_alluser(user_cb *p
 {
     struct alluser_rock urock;
     int r = 0;
+
+    init_internal();
+
     urock.prev = NULL;
     urock.proc = proc;
     urock.rock = rock;
@@ -2594,40 +3212,88 @@ static int racl_cb(void *rock,
     return 0;
 }
 
-EXPORTED int mboxlist_usermboxtree(const char *userid, mboxlist_cb *proc,
-                                   void *rock, int flags)
+static int mboxlist_racl_matches(struct db *db,
+                                 int isuser, const char *userid,
+                                 const struct auth_state *auth_state,
+                                 const char *mboxprefix, size_t len,
+                                 strarray_t *matches)
+{
+    struct buf raclprefix = BUF_INITIALIZER;
+    strarray_t *groups = NULL;
+    struct raclrock raclrock = { 0, matches };
+    int i;
+
+    /* direct access by userid */
+    mboxlist_racl_key(isuser, userid, NULL, &raclprefix);
+    /* this is the prefix */
+    raclrock.prefixlen = buf_len(&raclprefix);
+    /* we only need to look inside the prefix still, but we keep the length
+     * in raclrock pointing to the start of the mboxname part of the key so
+     * we get correct names in matches */
+    if (len) buf_appendmap(&raclprefix, mboxprefix, len);
+    cyrusdb_foreach(db,
+                    buf_cstring(&raclprefix),
+                    buf_len(&raclprefix),
+                    NULL, racl_cb, &raclrock, NULL);
+
+    /* indirect access via group membership: same logic as userid, but per group */
+    if (auth_state)
+        groups = auth_groups(auth_state);
+    if (groups) {
+        for (i = 0; i < strarray_size(groups); i++) {
+            mboxlist_racl_key(isuser, strarray_nth(groups, i), NULL, &raclprefix);
+            raclrock.prefixlen = buf_len(&raclprefix);
+            if (len) buf_appendmap(&raclprefix, mboxprefix, len);
+
+            cyrusdb_foreach(db,
+                            buf_cstring(&raclprefix),
+                            buf_len(&raclprefix),
+                            NULL, racl_cb, &raclrock, NULL);
+        }
+
+        strarray_free(groups);
+    }
+
+    strarray_sort(matches, cmpstringp_mbox);
+    strarray_uniq(matches);
+
+    buf_free(&raclprefix);
+    return 0;
+}
+
+/* auth_state parameter is optional, but is needed for proper expansion
+ * of group RACLs if flags contains MBOXTREE_PLUS_RACL */
+EXPORTED int mboxlist_usermboxtree(const char *userid,
+                                   const struct auth_state *auth_state,
+                                   mboxlist_cb *proc, void *rock, int flags)
 {
     char *inbox = mboxname_user_mbox(userid, 0);
     int r = mboxlist_mboxtree(inbox, proc, rock, flags);
 
     if (flags & MBOXTREE_PLUS_RACL) {
-        struct allmb_rock mbrock = { NULL, flags, proc, rock };
         /* we're using reverse ACLs */
-        struct buf buf = BUF_INITIALIZER;
+        struct allmb_rock mbrock = { NULL, proc, rock, flags };
+        int i;
         strarray_t matches = STRARRAY_INITIALIZER;
 
         /* user items */
-        mboxlist_racl_key(1, userid, NULL, &buf);
-        /* this is the prefix */
-        struct raclrock raclrock = { buf.len, &matches };
-        /* we only need to look inside the prefix still, but we keep the length
-         * in raclrock pointing to the start of the mboxname part of the key so
-         * we get correct names in matches */
-        r = cyrusdb_foreach(mbdb, buf.s, buf.len, NULL, racl_cb, &raclrock, NULL);
-        buf_reset(&buf);
+        mboxlist_racl_matches(mbdb, 1, userid, auth_state, NULL, 0, &matches);
+        for (i = 0; !r && i < strarray_size(&matches); i++) {
+            const char *mboxname = strarray_nth(&matches, i);
+            r = cyrusdb_forone(mbdb, mboxname, strlen(mboxname),
+                               allmbox_p, allmbox_cb, &mbrock, 0);
+        }
 
         /* shared items */
-        mboxlist_racl_key(0, userid, NULL, &buf);
-        raclrock.prefixlen = buf.len;
-        if (!r) r = cyrusdb_foreach(mbdb, buf.s, buf.len, NULL, racl_cb, &raclrock, NULL);
-
-        /* XXX - later we need to sort the array when we've added groups */
-        int i;
+        strarray_fini(&matches);
+        strarray_init(&matches);
+        mboxlist_racl_matches(mbdb, 0, userid, auth_state, NULL, 0, &matches);
         for (i = 0; !r && i < strarray_size(&matches); i++) {
             const char *mboxname = strarray_nth(&matches, i);
-            r = cyrusdb_forone(mbdb, mboxname, strlen(mboxname), allmbox_p, allmbox_cb, &mbrock, 0);
+            r = cyrusdb_forone(mbdb, mboxname, strlen(mboxname),
+                               allmbox_p, allmbox_cb, &mbrock, 0);
         }
-        buf_free(&buf);
+
         strarray_fini(&matches);
         mboxlist_entry_free(&mbrock.mbentry);
     }
@@ -2639,20 +3305,22 @@ EXPORTED int mboxlist_usermboxtree(const
 static int mboxlist_find_category(struct find_rock *rock, const char *prefix, size_t len)
 {
     int r = 0;
+
+    init_internal();
+
     if (!rock->issubs && !rock->isadmin && !cyrusdb_fetch(rock->db, "$RACL", 5, NULL, NULL, NULL)) {
         /* we're using reverse ACLs */
-        struct buf buf = BUF_INITIALIZER;
         strarray_t matches = STRARRAY_INITIALIZER;
-        mboxlist_racl_key(rock->mb_category == MBNAME_OTHERUSER, rock->userid, NULL, &buf);
-        /* this is the prefix */
-        struct raclrock raclrock = { buf.len, &matches };
-        /* we only need to look inside the prefix still, but we keep the length
-         * in raclrock pointing to the start of the mboxname part of the key so
-         * we get correct names in matches */
-        if (len) buf_appendmap(&buf, prefix, len);
-        r = cyrusdb_foreach(rock->db, buf.s, buf.len, NULL, racl_cb, &raclrock, NULL);
-        /* XXX - later we need to sort the array when we've added groups */
         int i;
+
+        mboxlist_racl_matches(rock->db,
+                              (rock->mb_category == MBNAME_OTHERUSER),
+                              rock->userid,
+                              rock->auth_state,
+                              prefix, len,
+                              &matches);
+
+        /* now call the callbacks */
         for (i = 0; !r && i < strarray_size(&matches); i++) {
             const char *key = strarray_nth(&matches, i);
             r = cyrusdb_forone(rock->db, key, strlen(key), &find_p, &find_cb, rock, NULL);
@@ -2674,7 +3342,7 @@ static int mboxlist_find_category(struct
  * 'proc' with the name of the mailbox.  If 'proc' ever returns
  * a nonzero value, mboxlist_findall immediately stops searching
  * and returns that value.  'rock' is passed along as an argument to proc in
- * case it wants some persistant storage or extra data.
+ * case it wants some persistent storage or extra data.
  */
 /* Find all mailboxes that match 'pattern'. */
 
@@ -2684,6 +3352,7 @@ static int mboxlist_do_find(struct find_
     int isadmin = rock->isadmin;
 
     int crossdomains = config_getswitch(IMAPOPT_CROSSDOMAINS);
+    int allowdeleted = config_getswitch(IMAPOPT_ALLOWDELETED);
     char inbox[MAX_MAILBOX_BUFFER];
     size_t inboxlen = 0;
     size_t prefixlen, len;
@@ -2789,7 +3458,8 @@ static int mboxlist_do_find(struct find_
             if (r) goto done;
 
             /* reset the the namebuffer */
-            r = (*rock->proc)(NULL, rock->procrock);
+            if (rock->cb)
+                r = (*rock->cb)(NULL, rock->procrock);
             if (r) goto done;
         }
 
@@ -2802,7 +3472,8 @@ static int mboxlist_do_find(struct find_
         /* "Alt Prefix" folders */
         if (rock->namespace->isalt) {
             /* reset the the namebuffer */
-            r = (*rock->proc)(NULL, rock->procrock);
+            if (rock->cb)
+                r = (*rock->cb)(NULL, rock->procrock);
             if (r) goto done;
 
             rock->mb_category = MBNAME_ALTINBOX;
@@ -2849,7 +3520,8 @@ static int mboxlist_do_find(struct find_
             size_t thislen = (isadmin || crossdomains) ? 0 : strlen(domainpat);
 
             /* reset the the namebuffer */
-            r = (*rock->proc)(NULL, rock->procrock);
+            if (rock->cb)
+                r = (*rock->cb)(NULL, rock->procrock);
             if (r) goto done;
 
             r = mboxlist_find_category(rock, domainpat, thislen);
@@ -2871,7 +3543,8 @@ static int mboxlist_do_find(struct find_
             rock->mb_category = MBNAME_SHARED;
 
             /* reset the the namebuffer */
-            r = (*rock->proc)(NULL, rock->procrock);
+            if (rock->cb)
+                r = (*rock->cb)(NULL, rock->procrock);
             if (r) goto done;
 
             /* iterate through all the non-user folders on the server */
@@ -2880,8 +3553,43 @@ static int mboxlist_do_find(struct find_
         }
     }
 
+    /* finally deleted namespaces - first the owner */
+    if (!isadmin && allowdeleted && userid) {
+        char prefix[MAX_MAILBOX_BUFFER];
+        char *inboxcopy = xstrndup(inbox, inboxlen);
+        mboxname_todeleted(inboxcopy, prefix, /*withtime*/0);
+        free(inboxcopy);
+        size_t prefixlen = strlen(prefix);
+        prefix[prefixlen] = '.';
+
+        rock->mb_category = MBNAME_OWNERDELETED;
+
+        /* reset the the namebuffer */
+        if (rock->cb)
+            r = (*rock->cb)(NULL, rock->procrock);
+        if (r) goto done;
+
+        r = cyrusdb_foreach(rock->db, prefix, prefixlen+1, &find_p, &find_cb, rock, NULL);
+        if (r) goto done;
+    }
+
+    /* and everything else */
+    if (isadmin || (allowdeleted && rock->namespace->accessible[NAMESPACE_SHARED])) {
+        rock->mb_category = MBNAME_OTHERDELETED;
+
+        /* reset the the namebuffer */
+        if (rock->cb)
+            r = (*rock->cb)(NULL, rock->procrock);
+        if (r) goto done;
+
+        /* iterate through all the non-user folders on the server */
+        r = mboxlist_find_category(rock, domainpat, domainlen);
+        if (r) goto done;
+    }
+
     /* finish with a reset call always */
-    r = (*rock->proc)(NULL, rock->procrock);
+    if (rock->cb)
+        r = (*rock->cb)(NULL, rock->procrock);
 
  done:
     for (i = 0; i < rock->globs.count; i++) {
@@ -2898,8 +3606,20 @@ EXPORTED int mboxlist_findallmulti(struc
                                    const char *userid, const struct auth_state *auth_state,
                                    findall_cb *proc, void *rock)
 {
+    return mboxlist_findallmulti_withp(namespace, patterns, isadmin,
+                                       userid, auth_state,
+                                       NULL, proc, rock);
+}
+
+EXPORTED int mboxlist_findallmulti_withp(struct namespace *namespace,
+                                   const strarray_t *patterns, int isadmin,
+                                   const char *userid, const struct auth_state *auth_state,
+                                   findall_p *p, findall_cb *cb, void *rock)
+{
     int r = 0;
 
+    init_internal();
+
     if (!namespace) namespace = mboxname_get_adminnamespace();
 
     struct find_rock cbrock;
@@ -2909,7 +3629,8 @@ EXPORTED int mboxlist_findallmulti(struc
     cbrock.db = mbdb;
     cbrock.isadmin = isadmin;
     cbrock.namespace = namespace;
-    cbrock.proc = proc;
+    cbrock.p = p;
+    cbrock.cb = cb;
     cbrock.procrock = rock;
     cbrock.userid = userid;
     if (userid) {
@@ -2927,10 +3648,23 @@ EXPORTED int mboxlist_findall(struct nam
                               const char *userid, const struct auth_state *auth_state,
                               findall_cb *proc, void *rock)
 {
+    return mboxlist_findall_withp(namespace, pattern, isadmin,
+                                  userid, auth_state,
+                                  NULL, proc, rock);
+}
+
+EXPORTED int mboxlist_findall_withp(struct namespace *namespace,
+                              const char *pattern, int isadmin,
+                              const char *userid, const struct auth_state *auth_state,
+                              findall_p *p, findall_cb *cb, void *rock)
+{
     strarray_t patterns = STRARRAY_INITIALIZER;
     strarray_append(&patterns, pattern);
 
-    int r = mboxlist_findallmulti(namespace, &patterns, isadmin, userid, auth_state, proc, rock);
+    init_internal();
+
+    int r = mboxlist_findallmulti_withp(namespace, &patterns, isadmin, userid, auth_state,
+                                  p, cb, rock);
 
     strarray_fini(&patterns);
 
@@ -2942,6 +3676,16 @@ EXPORTED int mboxlist_findone(struct nam
                               const char *userid, const struct auth_state *auth_state,
                               findall_cb *proc, void *rock)
 {
+    return mboxlist_findone_withp(namespace, intname, isadmin,
+                                  userid, auth_state,
+                                  NULL, proc, rock);
+}
+
+EXPORTED int mboxlist_findone_withp(struct namespace *namespace,
+                              const char *intname, int isadmin,
+                              const char *userid, const struct auth_state *auth_state,
+                              findall_p *p, findall_cb *cb, void *rock)
+{
     int r = 0;
 
     if (!namespace) namespace = mboxname_get_adminnamespace();
@@ -2949,11 +3693,14 @@ EXPORTED int mboxlist_findone(struct nam
     struct find_rock cbrock;
     memset(&cbrock, 0, sizeof(struct find_rock));
 
+    init_internal();
+
     cbrock.auth_state = auth_state;
     cbrock.db = mbdb;
     cbrock.isadmin = isadmin;
     cbrock.namespace = namespace;
-    cbrock.proc = proc;
+    cbrock.p = p;
+    cbrock.cb = cb;
     cbrock.procrock = rock;
     cbrock.userid = userid;
     if (userid) {
@@ -2982,11 +3729,17 @@ static int exists_cb(const mbentry_t *mb
     return CYRUSDB_DONE; /* one is enough */
 }
 
+struct changequota_rock {
+    const char *root;
+    int silent;
+};
+
 /*
  * Set all the resource quotas on, or create a quota root.
  */
 EXPORTED int mboxlist_setquotas(const char *root,
-                       quota_t newquotas[QUOTA_NUMRESOURCES], int force)
+                       quota_t newquotas[QUOTA_NUMRESOURCES],
+                       modseq_t quotamodseq, int force)
 {
     struct quota q;
     int r;
@@ -2995,6 +3748,9 @@ EXPORTED int mboxlist_setquotas(const ch
     struct mboxevent *mboxevents = NULL;
     struct mboxevent *quotachange_event = NULL;
     struct mboxevent *quotawithin_event = NULL;
+    int silent = quotamodseq ? 1 : 0;
+
+    init_internal();
 
     if (!root[0] || root[0] == '.' || strchr(root, '/')
         || strchr(root, '*') || strchr(root, '%') || strchr(root, '?')) {
@@ -3041,7 +3797,9 @@ EXPORTED int mboxlist_setquotas(const ch
             }
         }
         if (changed) {
-            r = quota_write(&q, &tid);
+            if (quotamodseq)
+                q.modseq = quotamodseq;
+            r = quota_write(&q, silent, &tid);
 
             if (quotachange_event == NULL) {
                 quotachange_event = mboxevent_enqueue(EVENT_QUOTA_CHANGE, &mboxevents);
@@ -3092,7 +3850,9 @@ EXPORTED int mboxlist_setquotas(const ch
 
     /* initialise the quota */
     memcpy(q.limits, newquotas, sizeof(q.limits));
-    r = quota_write(&q, &tid);
+    if (quotamodseq)
+        q.modseq = quotamodseq;
+    r = quota_write(&q, silent, &tid);
     if (r) goto done;
 
     /* prepare a QuotaChange event notification */
@@ -3107,7 +3867,8 @@ EXPORTED int mboxlist_setquotas(const ch
 
     /* recurse through mailboxes, setting the quota and finding
      * out the usage */
-    mboxlist_mboxtree(root, mboxlist_changequota, (void *)root, 0);
+    struct changequota_rock crock = { root, silent };
+    mboxlist_mboxtree(root, mboxlist_changequota, &crock, 0);
 
     quota_changelockrelease();
 
@@ -3133,6 +3894,8 @@ EXPORTED int mboxlist_unsetquota(const c
     struct quota q;
     int r=0;
 
+    init_internal();
+
     if (!root[0] || root[0] == '.' || strchr(root, '/')
         || strchr(root, '*') || strchr(root, '%') || strchr(root, '?')) {
         return IMAP_MAILBOX_BADNAME;
@@ -3154,7 +3917,7 @@ EXPORTED int mboxlist_unsetquota(const c
      */
     mboxlist_mboxtree(root, mboxlist_rmquota, (void *)root, /*flags*/0);
 
-    r = quota_deleteroot(root);
+    r = quota_deleteroot(root, 0);
     quota_changelockrelease();
 
     if (!r) sync_log_quota(root);
@@ -3164,21 +3927,23 @@ EXPORTED int mboxlist_unsetquota(const c
     return r;
 }
 
-EXPORTED modseq_t mboxlist_foldermodseq_dirty(struct mailbox *mailbox)
+EXPORTED int mboxlist_update_foldermodseq(const char *name, modseq_t foldermodseq)
 {
     mbentry_t *mbentry = NULL;
-    modseq_t ret = 0;
 
-    if (mboxlist_mylookup(mailbox->name, &mbentry, NULL, 0))
-        return 0;
+    init_internal();
 
-    ret = mbentry->foldermodseq = mailbox_modseq_dirty(mailbox);
+    int r = mboxlist_mylookup(name, &mbentry, NULL, 0);
+    if (r) return r;
 
-    mboxlist_update(mbentry, 0);
+    if (mbentry->foldermodseq < foldermodseq) {
+        mbentry->foldermodseq = foldermodseq;
+        r = mboxlist_update(mbentry, 0);
+    }
 
     mboxlist_entry_free(&mbentry);
 
-    return ret;
+    return r;
 }
 
 /*
@@ -3236,11 +4001,11 @@ static int mboxlist_changequota(const mb
 {
     int r = 0;
     struct mailbox *mailbox = NULL;
-    const char *root = (const char *) rock;
+    struct changequota_rock *crock = rock;
     int res;
     quota_t quota_usage[QUOTA_NUMRESOURCES];
 
-    assert(root);
+    assert(crock->root);
 
     r = mailbox_open_iwl(mbentry->name, &mailbox);
     if (r) goto done;
@@ -3250,7 +4015,7 @@ static int mboxlist_changequota(const mb
     if (mailbox->quotaroot) {
         quota_t quota_diff[QUOTA_NUMRESOURCES];
 
-        if (strlen(mailbox->quotaroot) >= strlen(root)) {
+        if (strlen(mailbox->quotaroot) >= strlen(crock->root)) {
             /* Part of a child quota root - skip */
             goto done;
         }
@@ -3260,22 +4025,22 @@ static int mboxlist_changequota(const mb
             quota_diff[res] = -quota_usage[res];
         }
         r = quota_update_useds(mailbox->quotaroot, quota_diff,
-                               mailbox->name);
+                               mailbox->name, crock->silent);
     }
 
     /* update (or set) the quotaroot */
-    r = mailbox_set_quotaroot(mailbox, root);
+    r = mailbox_set_quotaroot(mailbox, crock->root);
     if (r) goto done;
 
     /* update the new quota root */
-    r = quota_update_useds(root, quota_usage, mailbox->name);
+    r = quota_update_useds(crock->root, quota_usage, mailbox->name, crock->silent);
 
  done:
     mailbox_close(&mailbox);
 
     if (r) {
         syslog(LOG_ERR, "LOSTQUOTA: unable to change quota root for %s to %s: %s",
-               mbentry->name, root, error_message(r));
+               mbentry->name, crock->root, error_message(r));
     }
 
     /* Note, we're a callback, and it's not a huge tragedy if we
@@ -3283,12 +4048,46 @@ static int mboxlist_changequota(const mb
     return 0;
 }
 
+EXPORTED int mboxlist_haschildren(const char *mboxname)
+{
+    int exists = 0;
+
+    mboxlist_mboxtree(mboxname, exists_cb, &exists, MBOXTREE_SKIP_ROOT);
+
+    return exists;
+}
+
+EXPORTED void mboxlist_done(void)
+{
+    /* DB->done() handled by cyrus_done() */
+}
+
+static void done_cb(void*rock __attribute__((unused)))
+{
+    if (mboxlist_dbopen) {
+        mboxlist_close();
+    }
+    mboxlist_done();
+}
+
+static void init_internal()
+{
+    if (!mboxlist_initialized) {
+        mboxlist_init(0);
+    }
+    if (!mboxlist_dbopen) {
+        mboxlist_open(NULL);
+    }
+}
+
 /* must be called after cyrus_init */
 EXPORTED void mboxlist_init(int myflags)
 {
     if (myflags & MBOXLIST_SYNC) {
         cyrusdb_sync(DB);
     }
+    cyrus_modules_add(done_cb, NULL);
+    mboxlist_initialized = 1;
 }
 
 EXPORTED void mboxlist_open(const char *fname)
@@ -3305,6 +4104,8 @@ EXPORTED void mboxlist_open(const char *
         fname = tofree;
     }
 
+    mboxlist_init(0);
+
     flags = CYRUSDB_CREATE;
     if (config_getswitch(IMAPOPT_IMPROVED_MBOXLIST_SORT)) {
         flags |= CYRUSDB_MBOXSORT;
@@ -3315,8 +4116,8 @@ EXPORTED void mboxlist_open(const char *
         syslog(LOG_ERR, "DBERROR: opening %s: %s", fname,
                cyrusdb_strerror(ret));
             /* Exiting TEMPFAIL because Sendmail thinks this
-               EC_OSFILE == permanent failure. */
-        fatal("can't read mailboxes file", EC_TEMPFAIL);
+               EX_OSFILE == permanent failure. */
+        fatal("can't read mailboxes file", EX_TEMPFAIL);
     }
 
     free(tofree);
@@ -3338,11 +4139,6 @@ EXPORTED void mboxlist_close(void)
     }
 }
 
-EXPORTED void mboxlist_done(void)
-{
-    /* DB->done() handled by cyrus_done() */
-}
-
 /*
  * Open the subscription list for 'userid'.
  *
@@ -3393,8 +4189,22 @@ EXPORTED int mboxlist_findsubmulti(struc
                                    findall_cb *proc, void *rock,
                                    int force)
 {
+    return mboxlist_findsubmulti_withp(namespace, patterns, isadmin,
+                                       userid, auth_state,
+                                       NULL, proc, rock,
+                                       force);
+}
+
+EXPORTED int mboxlist_findsubmulti_withp(struct namespace *namespace,
+                                   const strarray_t *patterns, int isadmin,
+                                   const char *userid, const struct auth_state *auth_state,
+                                   findall_p *p, findall_cb *cb, void *rock,
+                                   int force)
+{
     int r = 0;
 
+    init_internal();
+
     if (!namespace) namespace = mboxname_get_adminnamespace();
 
     struct find_rock cbrock;
@@ -3412,7 +4222,8 @@ EXPORTED int mboxlist_findsubmulti(struc
     cbrock.isadmin = isadmin;
     cbrock.issubs = 1;
     cbrock.namespace = namespace;
-    cbrock.proc = proc;
+    cbrock.p = p;
+    cbrock.cb = cb;
     cbrock.procrock = rock;
     cbrock.userid = userid;
     if (userid) {
@@ -3433,10 +4244,25 @@ EXPORTED int mboxlist_findsub(struct nam
                               findall_cb *proc, void *rock,
                               int force)
 {
+    return mboxlist_findsub_withp(namespace, pattern, isadmin,
+                                  userid, auth_state,
+                                  NULL, proc, rock,
+                                  force);
+}
+
+EXPORTED int mboxlist_findsub_withp(struct namespace *namespace,
+                              const char *pattern, int isadmin,
+                              const char *userid, const struct auth_state *auth_state,
+                              findall_p *p, findall_cb *cb, void *rock,
+                              int force)
+{
     strarray_t patterns = STRARRAY_INITIALIZER;
     strarray_append(&patterns, pattern);
 
-    int r = mboxlist_findsubmulti(namespace, &patterns, isadmin, userid, auth_state, proc, rock, force);
+    init_internal();
+
+    int r = mboxlist_findsubmulti_withp(namespace, &patterns, isadmin, userid, auth_state,
+                                  p, cb, rock, force);
 
     strarray_fini(&patterns);
 
@@ -3458,6 +4284,8 @@ EXPORTED strarray_t *mboxlist_sublist(co
     strarray_t *list = strarray_new();
     int r;
 
+    init_internal();
+
     /* open subs DB */
     r = mboxlist_opensubs(userid, &subs);
     if (r) goto done;
@@ -3502,6 +4330,8 @@ static int usersubs_cb(void *rock, const
         mboxname_userownsmailbox(mbrock->userid, mboxname)) return 0;
 
     r = mboxlist_lookup(mboxname, &mbrock->mbentry, NULL);
+    if (r == IMAP_MAILBOX_NONEXISTENT) return 0;
+
     if (r) {
         syslog(LOG_INFO, "mboxlist_lookup(%s) failed: %s",
                mboxname, error_message(r));
@@ -3518,6 +4348,8 @@ EXPORTED int mboxlist_usersubs(const cha
     struct submb_rock mbrock = { NULL, userid, flags, proc, rock };
     int r = 0;
 
+    init_internal();
+
     /* open subs DB */
     r = mboxlist_opensubs(userid, &subs);
     if (r) return r;
@@ -3543,6 +4375,8 @@ EXPORTED int mboxlist_checksub(const cha
     const char *val;
     size_t vallen;
 
+    init_internal();
+
     r = mboxlist_opensubs(userid, &subs);
 
     if (!r) r = cyrusdb_fetch(subs, name, strlen(name), &val, &vallen, NULL);
@@ -3566,6 +4400,8 @@ EXPORTED int mboxlist_changesub(const ch
     struct db *subs;
     struct mboxevent *mboxevent;
 
+    init_internal();
+
     if ((r = mboxlist_opensubs(userid, &subs)) != 0) {
         return r;
     }
diff -pruN 3.0.13-5/imap/mboxlist.h 3.2.0-3/imap/mboxlist.h
--- 3.0.13-5/imap/mboxlist.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxlist.h	2020-05-04 03:28:02.000000000 +0000
@@ -56,21 +56,42 @@
  */
 #define MAX_PARTITION_LEN 64
 
-/* flags for types of mailboxes */
-#define MBTYPE_REMOTE (1<<0) /* Not on this server (part is remote host) */
-#define MBTYPE_RESERVE (1<<1) /* Reserved [mupdate/imapd] /
-                               Rename Target [imapd] (part is normal, but
-                               you are not allowed to create this mailbox,
-                               even though it doesn't actually exist */
-#define MBTYPE_NETNEWS (1<<2) /* Netnews Mailbox - NO LONGER USED */
-#define MBTYPE_MOVING (1<<3) /* Mailbox in mid-transfer (part is remotehost!localpart) */
-#define MBTYPE_DELETED (1<<4) /* Mailbox has been deleted, but not yet cleaned up */
-#define MBTYPE_CALENDAR (1<<5) /* CalDAV Calendar Mailbox */
-#define MBTYPE_ADDRESSBOOK (1<<6) /* CardDAV Addressbook Mailbox */
-#define MBTYPE_COLLECTION (1<<7) /* WebDAV Collection Mailbox */
+/* Flags for types of mailboxes
+ *
+ * Historically, mbtype was a bitmask, which is why this set of defines looks
+ * like a bitmask.  But, that was a mistake, which we have almost-entirely
+ * moved away from.
+ *
+ * Nowadays, an mbtype should properly only ever be a single one of these
+ * values, not a bitmask.
+ *
+ * The MBTYPES_DAV and MBTYPES_NONIMAP masks remain because they remain
+ * useful for checking the flavour of an mbtype, but do not take them as
+ * indicative of good style!  Generally, if you need to set an mbtype, set
+ * it to one value, and if you need to compare an mbtype, compare it against
+ * one value.
+ */
+#define MBTYPE_EMAIL            0  /* default mbtype is zero */
+#define MBTYPE_REMOTE       (1<<0) /* Not on this server (part is remote host) */
+#define MBTYPE_RESERVE      (1<<1) /* Reserved [mupdate/imapd] /
+                                      Rename Target [imapd] (part is normal, but
+                                      you are not allowed to create this mailbox,
+                                      even though it doesn't actually exist) */
+#define MBTYPE_NETNEWS      (1<<2) /* Netnews Mailbox - NO LONGER USED */
+#define MBTYPE_MOVING       (1<<3) /* Mailbox in mid-transfer
+                                      (part is remotehost!localpart) */
+#define MBTYPE_DELETED      (1<<4) /* Mailbox has been deleted,
+                                      but not yet cleaned up */
+#define MBTYPE_CALENDAR     (1<<5) /* CalDAV Calendar Mailbox */
+#define MBTYPE_ADDRESSBOOK  (1<<6) /* CardDAV Addressbook Mailbox */
+#define MBTYPE_COLLECTION   (1<<7) /* WebDAV Collection Mailbox */
+#define MBTYPE_INTERMEDIATE (1<<8) /* Place holder
+                                      for non-existent ancestor mailboxes */
+#define MBTYPE_SUBMISSION   (1<<9) /* JMAP Mail Submission Mailbox */
+#define MBTYPE_PUSHSUBSCRIPTION   (1<<10) /* JMAP Push Subscriptions */
 
-#define MBTYPES_DAV (MBTYPE_CALENDAR|MBTYPE_ADDRESSBOOK|MBTYPE_COLLECTION)
-#define MBTYPES_NONIMAP (MBTYPE_NETNEWS|MBTYPES_DAV)
+#define MBTYPES_DAV     (MBTYPE_CALENDAR|MBTYPE_ADDRESSBOOK|MBTYPE_COLLECTION)
+#define MBTYPES_NONIMAP (MBTYPE_NETNEWS|MBTYPES_DAV|MBTYPE_SUBMISSION|MBTYPE_PUSHSUBSCRIPTION)
 
 /* master name of the mailboxes file */
 #define FNAME_MBOXLIST "/mailboxes.db"
@@ -83,6 +104,7 @@ struct mboxlist_entry {
     char *ext_name;
     time_t mtime;
     uint32_t uidvalidity;
+    modseq_t createdmodseq;
     modseq_t foldermodseq;
     int mbtype;
     char *partition;
@@ -121,7 +143,8 @@ int mboxlist_lookup_allow_all(const char
                                    struct txn **tid);
 
 char *mboxlist_find_specialuse(const char *use, const char *userid);
-char *mboxlist_find_uniqueid(const char *uniqueid, const char *userid);
+char *mboxlist_find_uniqueid(const char *uniqueid, const char *userid,
+                             const struct auth_state *auth_state);
 
 
 /* insert/delete stub entries */
@@ -153,12 +176,43 @@ int mboxlist_createmailbox(const char *n
                            int localonly, int forceuser, int dbonly,
                            int notify, struct mailbox **mailboxptr);
 
+/* create mailbox with wrapping namespacelock */
+int mboxlist_createmailboxlock(const char *name, int mbtype,
+                           const char *partition,
+                           int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           int localonly, int forceuser, int dbonly,
+                           int notify, struct mailbox **mailboxptr);
+
+
+/* create mailbox with uniqueid */
+int mboxlist_createmailbox_unq(const char *name, int mbtype,
+                           const char *partition,
+                           int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           int localonly, int forceuser, int dbonly,
+                           int notify, const char *uniqueid,
+                           struct mailbox **mailboxptr);
+
+/* create mailbox with options and uniqueid */
+int mboxlist_createmailbox_opts(const char *name, int mbtype,
+                                const char *partition,
+                                int isadmin, const char *userid,
+                                const struct auth_state *auth_state,
+                                int options, int localonly,
+                                int forceuser, int dbonly,
+                                int notify, const char *uniqueid,
+                                struct mailbox **mailboxptr);
+
 /* create mailbox from sync */
 int mboxlist_createsync(const char *name, int mbtype, const char *partition,
                         const char *userid, const struct auth_state *auth_state,
                         int options, unsigned uidvalidity,
-                        modseq_t highestmodseq, const char *acl,
+                        modseq_t createdmodseq,
+                        modseq_t highestmodseq,
+                        modseq_t foldermodseq, const char *acl,
                         const char *uniqueid, int local_only,
+                        int keep_intermediaries,
                         struct mailbox **mboxptr);
 
 /* delated delete */
@@ -169,8 +223,7 @@ mboxlist_delayed_deletemailbox(const cha
                                const struct auth_state *auth_state,
                                struct mboxevent *mboxevent,
                                int checkacl,
-                               int localonly,
-                               int force);
+                               int localonly, int force, int keep_intermediaries);
 /* Delete a mailbox. */
 /* setting local_only disables any communication with the mupdate server
  * and deletes the mailbox from the filesystem regardless of if it is
@@ -182,16 +235,39 @@ int mboxlist_deletemailbox(const char *n
                            const struct auth_state *auth_state,
                            struct mboxevent *mboxevent,
                            int checkacl,
-                           int local_only, int force);
+                           int local_only, int force, int keep_intermediaries);
+/* same but with silent */
+int mboxlist_deletemailbox_full(const char *name, int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           struct mboxevent *mboxevent,
+                           int checkacl,
+                           int local_only, int force,
+                           int keep_intermediaries, int silent);
+/* same but wrap with a namespacelock */
+int mboxlist_deletemailboxlock(const char *name, int isadmin, const char *userid,
+                           const struct auth_state *auth_state,
+                           struct mboxevent *mboxevent,
+                           int checkacl,
+                           int local_only, int force, int keep_intermediaries);
 
+/* rename a tree of mailboxes - renames mailbox plus any children */
+int mboxlist_renametree(const char *oldname, const char *newname,
+                        const char *partition, unsigned uidvalidity,
+                        int isadmin, const char *userid,
+                        const struct auth_state *auth_state,
+                        struct mboxevent *mboxevent,
+                        int local_only, int forceuser, int ignorequota,
+                        int keep_intermediaries, int move_subscription);
 /* Rename/move a mailbox (hierarchical) */
 /* prepare MailboxRename notification if mboxevent is not NULL */
-int mboxlist_renamemailbox(const char *oldname, const char *newname,
+int mboxlist_renamemailbox(const mbentry_t *mbentry, const char *newname,
                            const char *partition, unsigned uidvalidity,
                            int isadmin, const char *userid,
                            const struct auth_state *auth_state,
                            struct mboxevent *mboxevent,
-                           int local_only, int forceuser, int ignorequota);
+                           int local_only, int forceuser, int ignorequota,
+                           int keep_intermediaries, int move_subscription,
+                           int silent);
 
 /* change ACL */
 int mboxlist_setacl(const struct namespace *namespace, const char *name,
@@ -199,19 +275,23 @@ int mboxlist_setacl(const struct namespa
                     const char *userid, const struct auth_state *auth_state);
 
 /* Change all ACLs on mailbox */
-int mboxlist_sync_setacls(const char *name, const char *acl);
+int mboxlist_updateacl_raw(const char *name, const char *acl);
+int mboxlist_sync_setacls(const char *name, const char *acl, modseq_t foldermodseq);
+int mboxlist_update_foldermodseq(const char *name, modseq_t foldermodseq);
 
 int mboxlist_set_racls(int enabled);
 
-modseq_t mboxlist_foldermodseq_dirty(struct mailbox *mailbox);
+int mboxlist_cleanup_deletedentries(const mbentry_t *mbentry, time_t mark);
 
 struct findall_data {
     const char *extname;
     int mb_category;
     const mbentry_t *mbentry;
     const mbname_t *mbname;
+    int is_exactmatch;
 };
 
+typedef int findall_p(struct findall_data *data, void *rock);
 typedef int findall_cb(struct findall_data *data, void *rock);
 
 /* Find all mailboxes that match 'pattern'. */
@@ -228,27 +308,43 @@ int mboxlist_findone(struct namespace *n
                      const char *userid, const struct auth_state *auth_state,
                      findall_cb *proc, void *rock);
 
+int mboxlist_findall_withp(struct namespace *namespace,
+                     const char *pattern, int isadmin,
+                     const char *userid, const struct auth_state *auth_state,
+                     findall_p *p, findall_cb *cb, void *rock);
+int mboxlist_findallmulti_withp(struct namespace *namespace,
+                          const strarray_t *patterns, int isadmin,
+                          const char *userid, const struct auth_state *auth_state,
+                          findall_p *p, findall_cb *cb, void *rock);
+int mboxlist_findone_withp(struct namespace *namespace,
+                     const char *intname, int isadmin,
+                     const char *userid, const struct auth_state *auth_state,
+                     findall_p *p, findall_cb *cb, void *rock);
+
 /* Find a mailbox's parent (if any) */
 int mboxlist_findparent(const char *mboxname,
                         mbentry_t **mbentryp);
 
+int mboxlist_findparent_allow_all(const char *mboxname,
+                                  mbentry_t **mbentryp);
+
 /* direct access to subs DB */
 typedef int user_cb(const char *userid, void *rock);
 int mboxlist_alluser(user_cb *proc, void *rock);
 
 typedef int mboxlist_cb(const mbentry_t *mbentry, void *rock);
 
-int mboxlist_visible(const char *userid, const struct auth_state *auth_state,
-                     mboxlist_cb *proc, void *rock, int incdel);
-int mboxlist_allmbox(const char *prefix, mboxlist_cb *proc, void *rock, int incdel);
 #define MBOXTREE_TOMBSTONES (1<<0)
 #define MBOXTREE_DELETED (1<<1)
 #define MBOXTREE_SKIP_ROOT (1<<2)
 #define MBOXTREE_SKIP_CHILDREN (1<<3)
 #define MBOXTREE_SKIP_PERSONAL (1<<4)
 #define MBOXTREE_PLUS_RACL (1<<5)
+#define MBOXTREE_INTERMEDIATES (1<<6)
+int mboxlist_allmbox(const char *prefix, mboxlist_cb *proc, void *rock, int flags);
 int mboxlist_mboxtree(const char *mboxname, mboxlist_cb *proc, void *rock, int flags);
-int mboxlist_usermboxtree(const char *userid, mboxlist_cb *proc, void *rock, int flags);
+int mboxlist_usermboxtree(const char *userid, const struct auth_state *auth_state,
+                          mboxlist_cb *proc, void *rock, int flags);
 int mboxlist_usersubs(const char *userid, mboxlist_cb *proc, void *rock, int flags);
 
 strarray_t *mboxlist_sublist(const char *userid);
@@ -265,6 +361,17 @@ int mboxlist_findsubmulti(struct namespa
                           findall_cb *proc, void *rock,
                           int force);
 
+int mboxlist_findsub_withp(struct namespace *namespace,
+                     const char *pattern, int isadmin,
+                     const char *userid, const struct auth_state *auth_state,
+                     findall_p *p, findall_cb *cb, void *rock,
+                     int force);
+int mboxlist_findsubmulti_withp(struct namespace *namespace,
+                          const strarray_t *patterns, int isadmin,
+                          const char *userid, const struct auth_state *auth_state,
+                          findall_p *p, findall_cb *cb, void *rock,
+                          int force);
+
 /* given a mailbox 'name', where should we stage messages for it?
    'stagedir' should be MAX_MAILBOX_PATH. */
 int mboxlist_findstage(const char *name, char *stagedir, size_t sd_len);
@@ -279,9 +386,14 @@ int mboxlist_changesub(const char *name,
 
 /* set or create quota root */
 int mboxlist_setquotas(const char *root,
-                       quota_t newquotas[QUOTA_NUMRESOURCES], int force);
+                       quota_t newquotas[QUOTA_NUMRESOURCES],
+                       modseq_t modseq, int force);
 int mboxlist_unsetquota(const char *root);
 
+/* handle interemediates */
+int mboxlist_update_intermediaries(const char *mboxname, int mbtype, modseq_t modseq);
+int mboxlist_haschildren(const char *mboxname);
+
 /* open the mailboxes db */
 void mboxlist_open(const char *name);
 
@@ -301,4 +413,7 @@ int mboxlist_abort(struct txn *tid);
 
 int mboxlist_delayed_delete_isenabled(void);
 
+/* Promote an intermediary mailbox to a real mailbox. */
+int mboxlist_promote_intermediary(const char *mboxname);
+
 #endif
diff -pruN 3.0.13-5/imap/mboxname.c 3.2.0-3/imap/mboxname.c
--- 3.0.13-5/imap/mboxname.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxname.c	2020-05-04 03:28:02.000000000 +0000
@@ -45,6 +45,7 @@
 #include <errno.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
@@ -53,7 +54,6 @@
 #include "assert.h"
 #include "byteorder64.h"
 #include "crc32.h"
-#include "exitcodes.h"
 #include "glob.h"
 #include "global.h"
 #include "mailbox.h"
@@ -174,7 +174,7 @@ static void remove_lockitem(struct mboxl
         previtem = item;
     }
 
-    fatal("didn't find item in list", EC_SOFTWARE);
+    fatal("didn't find item in list", EX_SOFTWARE);
 }
 
 /* name locking support */
@@ -241,6 +241,8 @@ done:
 
 EXPORTED void mboxname_release(struct mboxlock **mboxlockptr)
 {
+    if (!*mboxlockptr) return;
+
     struct mboxlocklist *lockitem;
     struct mboxlock *lock = *mboxlockptr;
 
@@ -257,6 +259,19 @@ EXPORTED void mboxname_release(struct mb
     remove_lockitem(lockitem);
 }
 
+EXPORTED int mboxname_islocked(const char *mboxname)
+{
+    return find_lockitem(mboxname) ? 1 : 0;
+}
+
+EXPORTED struct mboxlock *mboxname_usernamespacelock(const char *mboxname)
+{
+    mbname_t *mbname = mbname_from_intname(mboxname);
+    struct mboxlock *lock = user_namespacelock(mbname_userid(mbname));
+    mbname_free(&mbname);
+    return lock;
+}
+
 /******************** mbname stuff **********************/
 
 static void _mbdirty(mbname_t *mbname)
@@ -343,7 +358,7 @@ EXPORTED mbname_t *mbname_from_userid(co
 
     mbname->userid = xstrdup(userid); // may as well cache it
 
-    p = strchr(userid, '@');
+    p = strrchr(userid, '@');
     if (p) {
         mbname->localpart = xstrndup(userid, p - userid);
         const char *domain = p+1;
@@ -366,7 +381,7 @@ EXPORTED mbname_t *mbname_from_recipient
     mbname->recipient = xstrdup(recipient); // may as well cache it
     mbname->extns = ns;
 
-    const char *at = strchr(recipient, '@');
+    const char *at = strrchr(recipient, '@');
     if (at) {
         mbname->localpart = xstrndup(recipient, at - recipient);
         const char *domain = at+1;
@@ -576,7 +591,7 @@ EXPORTED mbname_t *mbname_from_extname(c
     mbname_t *userparts = mbname_from_userid(userid);
 
     if (admindomains) {
-        p = strchr(mbname->extname, '@');
+        p = strrchr(mbname->extname, '@');
         if (p) {
             *p = '\0';
             if (strcmpsafe(p+1, config_defdomain))
@@ -629,7 +644,7 @@ EXPORTED mbname_t *mbname_from_extname(c
             free(strarray_shift(mbname->boxes));
             mbname->localpart = strarray_shift(mbname->boxes);
             if (crossdomains && mbname->localpart) {
-                char *p = strchr(mbname->localpart, '@');
+                char *p = strrchr(mbname->localpart, '@');
                 if (p) {
                     *p = '\0';
                     if (strcmpsafe(p+1, config_defdomain))
@@ -649,8 +664,8 @@ EXPORTED mbname_t *mbname_from_extname(c
             free(strarray_shift(mbname->boxes));
             if (crossdomains) {
                 const char *toplevel = strarray_nth(mbname->boxes, 0);
-                if (toplevel && strchr(toplevel, '@')) {
-                    char *p = (char *)strchr(toplevel, '@');
+                if (toplevel && strrchr(toplevel, '@')) {
+                    char *p = (char *)strrchr(toplevel, '@');
                     *p = '\0';
                     if (strcmpsafe(p+1, config_defdomain))
                         mbname->domain = xstrdup(p+1);
@@ -711,7 +726,7 @@ EXPORTED mbname_t *mbname_from_extname(c
         free(strarray_shift(mbname->boxes));
         mbname->localpart = strarray_shift(mbname->boxes);
         if (crossdomains && mbname->localpart) {
-            char *p = strchr(mbname->localpart, '@');
+            char *p = strrchr(mbname->localpart, '@');
             if (p) {
                 *p = '\0';
                 if (strcmpsafe(p+1, config_defdomain))
@@ -920,7 +935,10 @@ EXPORTED const char *mbname_recipient(co
 EXPORTED int mbname_category(const mbname_t *mbname, const struct namespace *ns, const char *userid)
 {
     if (!mbname_localpart(mbname)) return MBNAME_SHARED;
-    if (mbname_isdeleted(mbname)) return MBNAME_SHARED;
+    if (mbname_isdeleted(mbname)) {
+        if (strcmpsafe(mbname_userid(mbname), userid)) return MBNAME_OTHERDELETED;
+        return MBNAME_OWNERDELETED;
+    }
 
     if (strcmpsafe(mbname_userid(mbname), userid)) return MBNAME_OTHERUSER;
 
@@ -1128,8 +1146,8 @@ EXPORTED const char *mbname_extname(cons
         goto end;
     }
 
-    /* other users */
-    if (strcmpsafe(mbname_userid(mbname), userid)) {
+    /* other users or DELETED */
+    if (mbname->is_deleted || strcmpsafe(mbname_userid(mbname), userid)) {
         buf_appendcstr(&buf, "user");
         buf_putc(&buf, ns->hier_sep);
         _append_extbuf(ns, &buf, mbname_localpart(mbname));
@@ -1287,7 +1305,7 @@ EXPORTED int mboxname_userownsmailbox(co
 
 /*
  * If (internal) mailbox 'name' is a user's mailbox (optionally INBOX),
- * returns the userid, otherwise returns NULL.
+ * returns 1, otherwise returns 0.
  */
 EXPORTED int mboxname_isusermailbox(const char *name, int isinbox)
 {
@@ -1304,6 +1322,26 @@ EXPORTED int mboxname_isusermailbox(cons
 }
 
 /*
+ * If (internal) mailbox 'name' is a user's Trash folder returns 1,
+ * otherwise returns 0
+ * XXX: use roles rather than hard coded name?
+ */
+EXPORTED int mboxname_isusertrash(const char *name)
+{
+    mbname_t *mbname = mbname_from_intname(name);
+    int res = 0;
+
+    if (mbname_localpart(mbname) && !mbname_isdeleted(mbname)) {
+        const strarray_t *boxes = mbname_boxes(mbname);
+        if (strarray_size(boxes) == 1 && !strcmpsafe(strarray_nth(boxes, 0), "Trash"))
+            res = 1;
+    }
+
+    mbname_free(&mbname);
+    return res;
+}
+
+/*
  * If (internal) mailbox 'name' is a DELETED mailbox
  * returns boolean
  */
@@ -1414,20 +1452,41 @@ EXPORTED int mboxname_isnotesmailbox(con
 }
 
 /*
- * If (internal) mailbox 'name' is a user's mail outbox
+ * If (internal) mailbox 'name' is a user's #jmapsubmission mailbox
+ * returns boolean
+ */
+EXPORTED int mboxname_issubmissionmailbox(const char *name, int mbtype)
+{
+    if (mbtype & MBTYPE_SUBMISSION) return 1;  /* Only works on backends */
+    int res = 0;
+
+    mbname_t *mbname = mbname_from_intname(name);
+    const strarray_t *boxes = mbname_boxes(mbname);
+    const char *prefix = config_getstring(IMAPOPT_JMAPSUBMISSIONFOLDER);
+    if (strarray_size(boxes) && !strcmpsafe(prefix, strarray_nth(boxes, 0)))
+        res = 1;
+
+    mbname_free(&mbname);
+    return res;
+}
+
+/*
+ * If (internal) mailbox 'name' is a user's #jmappushsubscription mailbox
  * returns boolean
  */
-EXPORTED int mboxname_isoutbox(const char *name)
+EXPORTED int mboxname_ispushsubscriptionmailbox(const char *name, int mbtype)
 {
+    if (mbtype & MBTYPE_PUSHSUBSCRIPTION) return 1;  /* Only works on backends */
+    int res = 0;
 
-    int isoutbox = 0;
-    /* XXX - use specialuse for this later */
     mbname_t *mbname = mbname_from_intname(name);
     const strarray_t *boxes = mbname_boxes(mbname);
-    if (mbname_localpart(mbname) && strarray_size(boxes) == 1 && !strcmp(strarray_nth(boxes, 0), "Outbox"))
-        isoutbox = 1;
+    const char *prefix = config_getstring(IMAPOPT_JMAPPUSHSUBSCRIPTIONFOLDER);
+    if (strarray_size(boxes) && !strcmpsafe(prefix, strarray_nth(boxes, 0)))
+        res = 1;
+
     mbname_free(&mbname);
-    return isoutbox;
+    return res;
 }
 
 EXPORTED char *mboxname_user_mbox(const char *userid, const char *subfolder)
@@ -1604,8 +1663,8 @@ HIDDEN int mboxname_policycheck(const ch
                     return IMAP_MAILBOX_BADNAME;
                 }
                 ucs4 = (c1 << 10) | (c2 << 4) | (c3 >> 2);
-                if ((ucs4 & 0xff80) == 0 || (ucs4 & 0xf800) == 0xd800) {
-                    /* US-ASCII or multi-word character */
+                if ((ucs4 & 0xff80) == 0) {
+                    /* US-ASCII character */
                     return IMAP_MAILBOX_BADNAME;
                 }
                 if (*name == '-') {
@@ -1623,8 +1682,8 @@ HIDDEN int mboxname_policycheck(const ch
                     return IMAP_MAILBOX_BADNAME;
                 }
                 ucs4 = ((c3 & 0x03) << 14) | (c4 << 8) | (c5 << 2) | (c6 >> 4);
-                if ((ucs4 & 0xff80) == 0 || (ucs4 & 0xf800) == 0xd800) {
-                    /* US-ASCII or multi-word character */
+                if ((ucs4 & 0xff80) == 0) {
+                    /* US-ASCII character */
                     return IMAP_MAILBOX_BADNAME;
                 }
                 if (*name == '-') {
@@ -1641,8 +1700,8 @@ HIDDEN int mboxname_policycheck(const ch
                     return IMAP_MAILBOX_BADNAME;
                 }
                 ucs4 = ((c6 & 0x0f) << 12) | (c7 << 6) | c8;
-                if ((ucs4 & 0xff80) == 0 || (ucs4 & 0xf800) == 0xd800) {
-                    /* US-ASCII or multi-word character */
+                if ((ucs4 & 0xff80) == 0) {
+                    /* US-ASCII character */
                     return IMAP_MAILBOX_BADNAME;
                 }
             }
@@ -1901,7 +1960,7 @@ EXPORTED char *mboxname_metapath(const c
     case 0:
         break;
     default:
-        fatal("Unknown meta file requested", EC_SOFTWARE);
+        fatal("Unknown meta file requested", EX_SOFTWARE);
     }
 
     if (*confkey)
@@ -1985,6 +2044,31 @@ EXPORTED int mboxname_make_parent(char *
     return 1;
 }
 
+EXPORTED int mboxname_contains_parent(const char *mboxname, const char *prev)
+{
+    /* no names, definitely can't be parent! */
+    if (!mboxname) return 0;
+    if (!prev) return 0;
+
+    char *parent = xstrdup(mboxname);
+
+    /* this mailbox is just "user"? prev will always contain that */
+    if (!mboxname_make_parent(parent)) {
+        free(parent);
+        return 1;
+    }
+
+    if (mboxname_is_prefix(prev, parent)) {
+        /* it's not different?  Great - there's no missing intermediate */
+        free(parent);
+        return 1;
+    }
+
+    /* OK, it doesn't contain the parent for sure */
+    free(parent);
+    return 0;
+}
+
 /* NOTE: caller must free, which is different from almost every
  * other interface in the whole codebase.  Grr */
 EXPORTED char *mboxname_conf_getpath(const mbname_t *mbname, const char *suffix)
@@ -1994,36 +2078,69 @@ EXPORTED char *mboxname_conf_getpath(con
 
     if (mbname->domain) {
         if (mbname->localpart) {
-            fname = strconcat(config_dir,
-                              FNAME_DOMAINDIR,
-                              dir_hash_b(mbname->domain, config_fulldirhash, d),
-                              "/", mbname->domain,
-                              FNAME_USERDIR,
-                              dir_hash_b(mbname->localpart, config_fulldirhash, c),
-                              "/", mbname->localpart, ".", suffix,
-                              (char *)NULL);
+            if (suffix) {
+                fname = strconcat(config_dir,
+                                  FNAME_DOMAINDIR,
+                                  dir_hash_b(mbname->domain, config_fulldirhash, d),
+                                  "/", mbname->domain,
+                                  FNAME_USERDIR,
+                                  dir_hash_b(mbname->localpart, config_fulldirhash, c),
+                                  "/", mbname->localpart, ".", suffix,
+                                  (char *)NULL);
+            }
+            else {
+                fname = strconcat(config_dir,
+                                  FNAME_DOMAINDIR,
+                                  dir_hash_b(mbname->domain, config_fulldirhash, d),
+                                  "/", mbname->domain,
+                                  FNAME_USERDIR,
+                                  dir_hash_b(mbname->localpart, config_fulldirhash, c),
+                                  (char *)NULL);
+            }
         }
         else {
-            fname = strconcat(config_dir,
-                              FNAME_DOMAINDIR,
-                              dir_hash_b(mbname->domain, config_fulldirhash, d),
-                              "/", mbname->domain,
-                              "/", FNAME_SHAREDPREFIX, ".", suffix,
-                              (char *)NULL);
+            if (suffix) {
+                fname = strconcat(config_dir,
+                                  FNAME_DOMAINDIR,
+                                  dir_hash_b(mbname->domain, config_fulldirhash, d),
+                                  "/", mbname->domain,
+                                  "/", FNAME_SHAREDPREFIX, ".", suffix,
+                                  (char *)NULL);
+            }
+            else {
+                fname = strconcat(config_dir,
+                                  FNAME_DOMAINDIR,
+                                  dir_hash_b(mbname->domain, config_fulldirhash, d),
+                                  "/", mbname->domain,
+                                  (char *)NULL);
+            }
         }
     }
     else {
         if (mbname->localpart) {
-            fname = strconcat(config_dir,
-                              FNAME_USERDIR,
-                              dir_hash_b(mbname->localpart, config_fulldirhash, c),
-                              "/", mbname->localpart, ".", suffix,
-                              (char *)NULL);
+            if (suffix) {
+                fname = strconcat(config_dir,
+                                  FNAME_USERDIR,
+                                  dir_hash_b(mbname->localpart, config_fulldirhash, c),
+                                  "/", mbname->localpart, ".", suffix,
+                                  (char *)NULL);
+            }
+            else {
+                fname = strconcat(config_dir,
+                                  FNAME_USERDIR,
+                                  dir_hash_b(mbname->localpart, config_fulldirhash, c),
+                                  (char *)NULL);
+            }
         }
         else {
-            fname = strconcat(config_dir,
-                              "/", FNAME_SHAREDPREFIX, ".", suffix,
-                              (char *)NULL);
+            if (suffix) {
+                fname = strconcat(config_dir,
+                                  "/", FNAME_SHAREDPREFIX, ".", suffix,
+                                  (char *)NULL);
+            }
+            else {
+                fname = xstrdup(config_dir);
+            }
         }
     }
 
@@ -2071,7 +2188,7 @@ static bit64 mboxname_readval_old(const
     return fileval;
 }
 
-#define MV_VERSION 3
+#define MV_VERSION 5
 
 #define MV_OFF_GENERATION 0
 #define MV_OFF_VERSION 4
@@ -2084,9 +2201,13 @@ static bit64 mboxname_readval_old(const
 #define MV_OFF_CALDAVFOLDERSMODSEQ 56
 #define MV_OFF_CARDDAVFOLDERSMODSEQ 64
 #define MV_OFF_NOTESFOLDERSMODSEQ 72
-#define MV_OFF_UIDVALIDITY 80
-#define MV_OFF_CRC 84
-#define MV_LENGTH 88
+#define MV_OFF_QUOTAMODSEQ 80
+#define MV_OFF_RACLMODSEQ 88
+#define MV_OFF_SUBMISSIONMODSEQ 96
+#define MV_OFF_SUBMISSIONFOLDERSMODSEQ 104
+#define MV_OFF_UIDVALIDITY 112
+#define MV_OFF_CRC 116
+#define MV_LENGTH 120
 
 /* NOTE: you need a MV_LENGTH byte base here */
 static int mboxname_buf_to_counters(const char *base, size_t len, struct mboxname_counters *vals)
@@ -2166,6 +2287,46 @@ static int mboxname_buf_to_counters(cons
         vals->uidvalidity = ntohl(*((uint32_t *)(base+80)));
         break;
 
+    case 4:
+        if (len != 104) return IMAP_MAILBOX_CHECKSUM;
+        if (crc32_map(base, 100) != ntohl(*((uint32_t *)(base+100))))
+            return IMAP_MAILBOX_CHECKSUM;
+
+        vals->highestmodseq = ntohll(*((uint64_t *)(base+8)));
+        vals->mailmodseq = ntohll(*((uint64_t *)(base+16)));
+        vals->caldavmodseq = ntohll(*((uint64_t *)(base+24)));
+        vals->carddavmodseq = ntohll(*((uint64_t *)(base+32)));
+        vals->notesmodseq = ntohll(*((uint64_t *)(base+40)));
+        vals->mailfoldersmodseq = ntohll(*((uint64_t *)(base+48)));
+        vals->caldavfoldersmodseq = ntohll(*((uint64_t *)(base+56)));
+        vals->carddavfoldersmodseq = ntohll(*((uint64_t *)(base+64)));
+        vals->notesfoldersmodseq = ntohll(*((uint64_t *)(base+72)));
+        vals->quotamodseq = ntohll(*((uint64_t *)(base+80)));
+        vals->raclmodseq = ntohll(*((uint64_t *)(base+88)));
+        vals->uidvalidity = ntohl(*((uint32_t *)(base+96)));
+        break;
+
+    case 5:
+        if (len != 120) return IMAP_MAILBOX_CHECKSUM;
+        if (crc32_map(base, 116) != ntohl(*((uint32_t *)(base+116))))
+            return IMAP_MAILBOX_CHECKSUM;
+
+        vals->highestmodseq = ntohll(*((uint64_t *)(base+8)));
+        vals->mailmodseq = ntohll(*((uint64_t *)(base+16)));
+        vals->caldavmodseq = ntohll(*((uint64_t *)(base+24)));
+        vals->carddavmodseq = ntohll(*((uint64_t *)(base+32)));
+        vals->notesmodseq = ntohll(*((uint64_t *)(base+40)));
+        vals->mailfoldersmodseq = ntohll(*((uint64_t *)(base+48)));
+        vals->caldavfoldersmodseq = ntohll(*((uint64_t *)(base+56)));
+        vals->carddavfoldersmodseq = ntohll(*((uint64_t *)(base+64)));
+        vals->notesfoldersmodseq = ntohll(*((uint64_t *)(base+72)));
+        vals->quotamodseq = ntohll(*((uint64_t *)(base+80)));
+        vals->raclmodseq = ntohll(*((uint64_t *)(base+88)));
+        vals->submissionmodseq = ntohll(*((uint64_t *)(base+96)));
+        vals->submissionfoldersmodseq = ntohll(*((uint64_t *)(base+104)));
+        vals->uidvalidity = ntohl(*((uint32_t *)(base+112)));
+        break;
+
     default:
         return IMAP_MAILBOX_BADFORMAT;
     }
@@ -2188,6 +2349,10 @@ static void mboxname_counters_to_buf(con
     align_htonll(base+MV_OFF_CARDDAVFOLDERSMODSEQ, vals->carddavfoldersmodseq);
     align_htonll(base+MV_OFF_NOTESFOLDERSMODSEQ, vals->notesfoldersmodseq);
     *((uint32_t *)(base+MV_OFF_UIDVALIDITY)) = htonl(vals->uidvalidity);
+    align_htonll(base+MV_OFF_QUOTAMODSEQ, vals->quotamodseq);
+    align_htonll(base+MV_OFF_RACLMODSEQ, vals->raclmodseq);
+    align_htonll(base+MV_OFF_SUBMISSIONMODSEQ, vals->submissionmodseq);
+    align_htonll(base+MV_OFF_SUBMISSIONFOLDERSMODSEQ, vals->submissionfoldersmodseq);
     *((uint32_t *)(base+MV_OFF_CRC)) = htonl(crc32_map(base, MV_OFF_CRC));
 }
 
@@ -2410,7 +2575,14 @@ EXPORTED int mboxname_read_counters(cons
     return r;
 }
 
-static modseq_t mboxname_domodseq(const char *mboxname, modseq_t last, int mbtype, int dofolder, modseq_t add)
+enum domodseq { MAILBOXMODSEQ, QUOTAMODSEQ, RACLMODSEQ };
+
+static modseq_t mboxname_domodseq(const char *mboxname,
+                                  modseq_t last,
+                                  enum domodseq domodseq,
+                                  int mbtype,   // for MAILBOXMODSEQ
+                                  int dofolder, // for MAILBOXMODSEQ
+                                  modseq_t add)
 {
     struct mboxname_counters counters;
     struct mboxname_counters oldcounters;
@@ -2427,21 +2599,35 @@ static modseq_t mboxname_domodseq(const
 
     oldcounters = counters;
 
-    if (mboxname_isaddressbookmailbox(mboxname, mbtype)) {
-        typemodseqp = &counters.carddavmodseq;
-        foldersmodseqp = &counters.carddavfoldersmodseq;
-    }
-    else if (mboxname_iscalendarmailbox(mboxname, mbtype)) {
-        typemodseqp = &counters.caldavmodseq;
-        foldersmodseqp = &counters.caldavfoldersmodseq;
-    }
-    else if (mboxname_isnotesmailbox(mboxname, mbtype)) {
-        typemodseqp = &counters.notesmodseq;
-        foldersmodseqp = &counters.notesfoldersmodseq;
+    if (domodseq == MAILBOXMODSEQ) {
+        if (mboxname_isaddressbookmailbox(mboxname, mbtype)) {
+            typemodseqp = &counters.carddavmodseq;
+            foldersmodseqp = &counters.carddavfoldersmodseq;
+        }
+        else if (mboxname_iscalendarmailbox(mboxname, mbtype)) {
+            typemodseqp = &counters.caldavmodseq;
+            foldersmodseqp = &counters.caldavfoldersmodseq;
+        }
+        else if (mboxname_isnotesmailbox(mboxname, mbtype)) {
+            typemodseqp = &counters.notesmodseq;
+            foldersmodseqp = &counters.notesfoldersmodseq;
+        }
+        else if (mboxname_issubmissionmailbox(mboxname, mbtype)) {
+            typemodseqp = &counters.submissionmodseq;
+            foldersmodseqp = &counters.submissionfoldersmodseq;
+        }
+        else {
+            typemodseqp = &counters.mailmodseq;
+            foldersmodseqp = &counters.mailfoldersmodseq;
+        }
     }
-    else {
-        typemodseqp = &counters.mailmodseq;
-        foldersmodseqp = &counters.mailfoldersmodseq;
+    else if (domodseq == QUOTAMODSEQ) {
+        typemodseqp = &counters.quotamodseq;
+        dofolder = 0;
+    }
+    else if (domodseq == RACLMODSEQ) {
+        typemodseqp = &counters.raclmodseq;
+        dofolder = 0;
     }
 
     /* make sure all counters are at least the old value */
@@ -2469,12 +2655,61 @@ static modseq_t mboxname_domodseq(const
 
 EXPORTED modseq_t mboxname_nextmodseq(const char *mboxname, modseq_t last, int mbtype, int dofolder)
 {
-    return mboxname_domodseq(mboxname, last, mbtype, dofolder, 1);
+    return mboxname_domodseq(mboxname, last, MAILBOXMODSEQ, mbtype, dofolder, 1);
 }
 
 EXPORTED modseq_t mboxname_setmodseq(const char *mboxname, modseq_t last, int mbtype, int dofolder)
 {
-    return mboxname_domodseq(mboxname, last, mbtype, dofolder, 0);
+    return mboxname_domodseq(mboxname, last, MAILBOXMODSEQ, mbtype, dofolder, 0);
+}
+
+EXPORTED modseq_t mboxname_readquotamodseq(const char *mboxname)
+{
+    struct mboxname_counters counters;
+
+    if (!config_getswitch(IMAPOPT_CONVERSATIONS))
+        return 0;
+
+    if (mboxname_read_counters(mboxname, &counters))
+        return 0;
+
+    return counters.quotamodseq;
+}
+
+EXPORTED modseq_t mboxname_nextquotamodseq(const char *mboxname, modseq_t last)
+{
+    return mboxname_domodseq(mboxname, last, QUOTAMODSEQ, 0, 0, 1);
+}
+
+EXPORTED modseq_t mboxname_setquotamodseq(const char *mboxname, modseq_t last)
+{
+    return mboxname_domodseq(mboxname, last, QUOTAMODSEQ, 0, 0, 0);
+}
+
+EXPORTED modseq_t mboxname_readraclmodseq(const char *mboxname)
+{
+    struct mboxname_counters counters;
+
+    if (!config_getswitch(IMAPOPT_CONVERSATIONS))
+        return 0;
+
+    if (!mboxname_isusermailbox(mboxname, /*isinbox*/1))
+        return 0;  // raclmodseq is only defined on user inboxes
+
+    if (mboxname_read_counters(mboxname, &counters))
+        return 0;
+
+    return counters.raclmodseq;
+}
+
+EXPORTED modseq_t mboxname_nextraclmodseq(const char *mboxname, modseq_t last)
+{
+    return mboxname_domodseq(mboxname, last, RACLMODSEQ, 0, 0, 1);
+}
+
+EXPORTED modseq_t mboxname_setraclmodseq(const char *mboxname, modseq_t last)
+{
+    return mboxname_domodseq(mboxname, last, RACLMODSEQ, 0, 0, 0);
 }
 
 EXPORTED uint32_t mboxname_readuidvalidity(const char *mboxname)
@@ -2539,4 +2774,30 @@ EXPORTED uint32_t mboxname_setuidvalidit
     return val;
 }
 
+EXPORTED char *mboxname_common_ancestor(const char *mboxname1, const char *mboxname2)
+{
+    mbname_t *mbname1 = mbname_from_intname(mboxname1);
+    mbname_t *mbname2 = mbname_from_intname(mboxname2);
+    char *ancestor = NULL;
 
+    if (!mbname_same_userid(mbname1, mbname2))
+        goto done;
+
+    const strarray_t *boxes1 = mbname_boxes(mbname1);
+    const strarray_t *boxes2 = mbname_boxes(mbname2);
+    int len = boxes1->count < boxes2->count ? boxes1->count : boxes2->count;
+    int i;
+    for (i = 0; i < len - 1; i++) {
+        if (strcmp(strarray_nth(boxes1, i), strarray_nth(boxes2, i)))
+            break;
+    }
+    if (i > 0) {
+        mbname_truncate_boxes(mbname1, i);
+        ancestor = xstrdup(mbname_intname(mbname1));
+    }
+
+done:
+    mbname_free(&mbname1);
+    mbname_free(&mbname2);
+    return ancestor;
+}
diff -pruN 3.0.13-5/imap/mboxname.h 3.2.0-3/imap/mboxname.h
--- 3.0.13-5/imap/mboxname.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mboxname.h	2020-05-04 03:28:02.000000000 +0000
@@ -64,7 +64,9 @@ enum { MBNAME_INBOX = 1,
        MBNAME_ALTPREFIX = 4,
        MBNAME_OWNER = 5,
        MBNAME_OTHERUSER = 6,
-       MBNAME_SHARED = 7 };
+       MBNAME_SHARED = 7,
+       MBNAME_OWNERDELETED = 8,
+       MBNAME_OTHERDELETED = 9 };
 
 /* structure holding server namespace info */
 struct namespace {
@@ -125,6 +127,8 @@ char *mboxname_to_external(const char *i
 int mboxname_lock(const char *mboxname, struct mboxlock **mboxlockptr,
                   int locktype);
 void mboxname_release(struct mboxlock **mboxlockptr);
+int mboxname_islocked(const char *mboxname);
+struct mboxlock *mboxname_usernamespacelock(const char *mboxname);
 
 /* Create namespace based on config options. */
 int mboxname_init_namespace(struct namespace *namespace, int isadmin);
@@ -140,6 +144,8 @@ int mboxname_userownsmailbox(const char
  */
 int mboxname_isusermailbox(const char *name, int isinbox);
 
+int mboxname_isusertrash(const char *name);
+
 /*
  * If (internal) mailbox 'name' is in the DELETED namespace.
  * If timestampp is not NULL, the delete timestamp encoded in
@@ -177,13 +183,34 @@ int mboxname_isdavnotificationsmailbox(c
  */
 int mboxname_isnotesmailbox(const char *name, int mbtype);
 
-/* If (internal) mailbox is a user's mail outbox,
+/*
+ * If (internal) mailbox 'name' is a user's #jmapsubmission mailbox
+ * returns boolean
+ */
+int mboxname_issubmissionmailbox(const char *name, int mbtype);
+
+/*
+ * If (internal) mailbox 'name' is a user's #jmappushsubscription mailbox
  * returns boolean
  */
-int mboxname_isoutbox(const char *name);
+int mboxname_ispushsubscriptionmailbox(const char *name, int mbtype);
+
+#define mboxname_isnonimapmailbox(name, mbtype)            \
+    (mboxname_iscalendarmailbox(name, mbtype)              \
+     || mboxname_isaddressbookmailbox(name, mbtype)        \
+     || mboxname_isdavdrivemailbox(name, mbtype)           \
+     || mboxname_isdavnotificationsmailbox(name, mbtype)   \
+     || mboxname_isnotesmailbox(name, mbtype)              \
+     || mboxname_issubmissionmailbox(name, mbtype)         \
+     || mboxname_ispushsubscriptionmailbox(name, mbtype))
 
 /* check if one mboxname is a parent or same as the other */
 int mboxname_is_prefix(const char *longstr, const char *shortstr);
+/* check if one mboxname contains the parent of the other mboxname */
+int mboxname_contains_parent(const char *mboxname, const char *prev);
+/* Return the internal mailbox name that is ancestor to mboxname1
+ * and mboxname2. Return NULL for INBOX or different owners. */
+char *mboxname_common_ancestor(const char *mboxname1, const char *mboxname2);
 
 void mboxname_hash(char *buf, size_t buf_len,
                    const char *root,
@@ -245,6 +272,7 @@ void mboxname_todeleted(const char *name
  */
 int mboxname_make_parent(char *namebuf);
 
+
 char *mboxname_conf_getpath(const mbname_t *mbname,
                             const char *suffix);
 
@@ -262,6 +290,10 @@ struct mboxname_counters {
     modseq_t caldavfoldersmodseq;
     modseq_t carddavfoldersmodseq;
     modseq_t notesfoldersmodseq;
+    modseq_t quotamodseq;
+    modseq_t raclmodseq;
+    modseq_t submissionmodseq;
+    modseq_t submissionfoldersmodseq;
     uint32_t uidvalidity;
 };
 
@@ -271,5 +303,11 @@ modseq_t mboxname_setmodseq(const char *
 uint32_t mboxname_readuidvalidity(const char *mboxname);
 uint32_t mboxname_nextuidvalidity(const char *mboxname, uint32_t last);
 uint32_t mboxname_setuidvalidity(const char *mboxname, uint32_t val);
+modseq_t mboxname_readquotamodseq(const char *mboxname);
+modseq_t mboxname_nextquotamodseq(const char *mboxname, modseq_t last);
+modseq_t mboxname_setquotamodseq(const char *mboxname, modseq_t val);
+modseq_t mboxname_readraclmodseq(const char *mboxname);
+modseq_t mboxname_nextraclmodseq(const char *mboxname, modseq_t last);
+modseq_t mboxname_setraclmodseq(const char *mboxname, modseq_t val);
 
 #endif
diff -pruN 3.0.13-5/imap/mbpath.c 3.2.0-3/imap/mbpath.c
--- 3.0.13-5/imap/mbpath.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mbpath.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,16 +48,17 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 #include <sys/param.h>
 
 #include "util.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "xmalloc.h"
 #include "mboxlist.h"
+#include "user.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -68,89 +69,211 @@ extern char *optarg;
 /* current namespace */
 static struct namespace mbpath_namespace;
 
-static int
-usage(void) {
-  fprintf(stderr,"usage: mbpath [-C <alt_config>] [-q] [-s] [-m] <mailbox name>...\n");
-  fprintf(stderr,"\t-q\tquietly drop any error messages\n");
-  fprintf(stderr,"\t-s\tstop on error\n");
-  fprintf(stderr,"\t-m\toutput the path to the metadata files (if different from the message files)\n");
-  exit(-1);
+static int usage(const char *error)
+{
+    fprintf(stderr,"usage: mbpath [-C <alt_config>] [-l] [-m] [-q] [-s] [-u] [-a|A|D|M|S|U] <mailbox name>...\n");
+    fprintf(stderr, "\n");
+    fprintf(stderr,"\t-a\tprint all values with prefixes\n");
+    fprintf(stderr,"\t-l\tlocal only (exit with error for remote/nonexistent)\n");
+    fprintf(stderr,"\t-m\toutput the path to the metadata files (if different from the message files)\n");
+    fprintf(stderr,"\t-q\tquietly drop any error messages\n");
+    fprintf(stderr,"\t-s\tstop on error\n");
+    fprintf(stderr,"\t-u\targuments are user, not mailbox\n");
+    fprintf(stderr,"\t-A\tpartition archive directory\n");
+    fprintf(stderr,"\t-D\tpartition data directory (*default*)\n");
+    fprintf(stderr,"\t-M\tpartition metadata file directory (duplicate of -m)\n");
+    fprintf(stderr,"\t-S\tsieve directory for the user\n");
+    fprintf(stderr,"\t-U\tuser files directory (seen, sub, etc)\n");
+    if (error) {
+        fprintf(stderr,"\n");
+        fprintf(stderr,"ERROR: %s", error);
+    }
+    exit(-1);
 }
 
-int
-main(int argc, char **argv)
+int main(int argc, char **argv)
 {
-  mbentry_t *mbentry = NULL;
-  int rc, i, quiet = 0, stop_on_error=0, metadata=0;
-  int opt;              /* getopt() returns an int */
-  char *alt_config = NULL;
-
-  while ((opt = getopt(argc, argv, "C:qsm")) != EOF) {
-    switch(opt) {
-    case 'C': /* alt config file */
-      alt_config = optarg;
-      break;
-    case 'q':
-      quiet = 1;
-      break;
-    case 's':
-      stop_on_error = 1;
-      break;
-    case 'm':
-        metadata = 1;
-        break;
+    mbentry_t *mbentry = NULL;
+    int r, i;
+    int opt;              /* getopt() returns an int */
+    char *alt_config = NULL;
+
+    // capture options
+    int quiet = 0;
+    int stop_on_error = 0;
+    int localonly = 0;
+    int usermode = 0;
+    int doall = 0;
+    int doA = 0;
+    int doD = 1; // default
+    int doM = 0;
+    int doS = 0;
+    int doU = 0;
+    int sel = 0;
+
+    while ((opt = getopt(argc, argv, "C:almqsuADMSU")) != EOF) {
+        switch(opt) {
+        case 'C': /* alt config file */
+            alt_config = optarg;
+            break;
+
+        case 'a':
+            if (sel)
+                usage("Duplicate selectors given");
+            doall = 1;
+            doD = 0;
+            sel = 1;
+            break;
+
+        case 'l':
+            localonly = 1;
+            break;
+
+        case 'm':
+            if (sel)
+                usage("Duplicate selectors given");
+            doM = 1;
+            doD = 0;
+            sel = 1;
+            break;
+
+        case 'q':
+            quiet = 1;
+            break;
+
+        case 's':
+            stop_on_error = 1;
+            break;
+
+        case 'u':
+            usermode = 1;
+            break;
+
+        case 'A':
+            if (sel)
+                usage("Duplicate selectors given");
+            doA = 1;
+            doD = 0;
+            sel = 1;
+            break;
+
+        case 'D':
+            if (sel)
+                usage("Duplicate selectors given");
+            sel = 1;
+            break;
+
+        case 'M':
+            if (sel)
+                usage("Duplicate selectors given");
+            doM = 1;
+            doD = 0;
+            sel = 1;
+            break;
+
+        case 'S':
+            if (sel)
+                usage("Duplicate selectors given");
+            doS = 1;
+            doD = 0;
+            sel = 1;
+            break;
+
+        case 'U':
+            if (sel)
+                usage("Duplicate selectors given");
+            doU = 1;
+            doD = 0;
+            sel = 1;
+            break;
 
-    default:
-      usage();
+        default:
+            usage(NULL);
+        }
     }
-  }
 
-  cyrus_init(alt_config, "mbpath", 0, 0);
+    cyrus_init(alt_config, "mbpath", 0, 0);
 
-  if ((rc = mboxname_init_namespace(&mbpath_namespace, 1)) != 0) {
-    fatal(error_message(rc), -1);
-  }
-
-  mboxlist_init(0);
-  mboxlist_open(NULL);
-
-  for (i = optind; i < argc; i++) {
-    /* Translate mailboxname */
-    char *intname = mboxname_from_external(argv[i], &mbpath_namespace, NULL);
-    if ((rc = mboxlist_lookup(intname, &mbentry, NULL)) == 0) {
-      if (mbentry->mbtype & MBTYPE_REMOTE) {
-        printf("%s!%s\n", mbentry->server, mbentry->partition);
-      } else if (metadata) {
-        const char *path = mbentry_metapath(mbentry, 0, 0);
-        printf("%s\n", path);
-      }
-      else {
-        const char *path = mbentry_datapath(mbentry, 0);
-        printf("%s\n", path);
-      }
-      mboxlist_entry_free(&mbentry);
-    } else {
-      if (!quiet && (rc == IMAP_MAILBOX_NONEXISTENT)) {
-        fprintf(stderr, "Invalid mailbox name: %s\n", argv[i]);
-      }
-      if (stop_on_error) {
-        if (quiet) {
-          fatal("", -1);
-        } else {
-          fatal("Error in processing mailbox. Stopping\n", -1);
-        }
-      }
+
+    r = mboxname_init_namespace(&mbpath_namespace, 1);
+    if (r) {
+        fatal(error_message(r), -1);
     }
-    free(intname);
-  }
 
-  mboxlist_close();
-  mboxlist_done();
+    for (i = optind; i < argc; i++) {
+        /* Translate mailboxname */
+        mbname_t *mbname = NULL;
+        if (usermode) {
+            mbname = mbname_from_userid(argv[i]);
+        }
+        else {
+            mbname = mbname_from_extname(argv[i], &mbpath_namespace, NULL);
+        }
+        r = mboxlist_lookup(mbname_intname(mbname), &mbentry, NULL);
+        if (!r) {
+            if (mbentry->mbtype & MBTYPE_REMOTE) {
+                if (localonly) {
+                    if (stop_on_error) {
+                        if (quiet) {
+                            fatal("", -1);
+                        }
+                        else {
+                            fatal("Non-local mailbox. Stopping\n", -1);
+                        }
+                    }
+                }
+                else {
+                    // ignore all selectors and just print this
+                    printf("%s!%s\n", mbentry->server, mbentry->partition);
+                }
+            }
+            else {
+                if (doall || doA) {
+                    const char *path = mboxname_archivepath(mbentry->partition, mbentry->name, mbentry->uniqueid, 0);
+                    if (doall) printf("Archive: ");
+                    printf("%s\n", path);
+                }
+                if (doall || doD) {
+                    const char *path = mboxname_datapath(mbentry->partition, mbentry->name, mbentry->uniqueid, 0);
+                    if (doall) printf("Data: ");
+                    printf("%s\n", path);
+                }
+                if (doall || doM) {
+                    const char *path = mboxname_metapath(mbentry->partition, mbentry->name, mbentry->uniqueid, 0, 0);
+                    if (doall) printf("Meta: ");
+                    printf("%s\n", path);
+                }
+                if (doall || doS) {
+                    const char *path = user_sieve_path(mbname_userid(mbname));
+                    if (doall) printf("Sieve: ");
+                    printf("%s\n", path);
+                }
+                if (doall || doU) {
+                    // different interface - caller must free
+                    char *path = mboxname_conf_getpath(mbname, NULL);
+                    if (doall) printf("User: ");
+                    printf("%s\n", path);
+                    free(path);
+                }
+            }
+        }
+        else {
+            if (!quiet && (r == IMAP_MAILBOX_NONEXISTENT)) {
+                fprintf(stderr, "Invalid mailbox name: %s\n", argv[i]);
+            }
+            if (stop_on_error) {
+                if (quiet) {
+                    fatal("", -1);
+                }
+                else {
+                    fatal("Error in processing mailbox. Stopping\n", -1);
+                }
+            }
+        }
+        mbname_free(&mbname);
+    }
 
-  cyrus_done();
+    cyrus_done();
 
-  return 0;
+    return 0;
 }
-
-/* $Header: /mnt/data/cyrus/cvsroot/src/cyrus/imap/mbpath.c,v 1.23 2010/01/06 17:01:37 murch Exp $ */
-
diff -pruN 3.0.13-5/imap/mbtool.c 3.2.0-3/imap/mbtool.c
--- 3.0.13-5/imap/mbtool.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mbtool.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
@@ -72,7 +73,6 @@
 #endif
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "index.h"
 #include "global.h"
 #include "mailbox.h"
@@ -142,15 +142,9 @@ int main(int argc, char **argv)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&mbtool_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
 
@@ -158,12 +152,6 @@ int main(int argc, char **argv)
         mboxlist_findall(&mbtool_namespace, argv[i], 1, 0, 0, do_cmd, &cmd);
     }
 
-    mboxlist_close();
-    mboxlist_done();
-
-    annotatemore_close();
-    annotate_done();
-
     exit(0);
 }
 
@@ -176,7 +164,7 @@ static void usage(void)
     fprintf(stderr, "    -t    normalise internaldates in specified mailboxes\n");
     fprintf(stderr, "\nOptions:\n");
     fprintf(stderr, "    -C alt_config  use alternate imapd.conf file\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /*
@@ -186,8 +174,8 @@ static int do_timestamp(const mbname_t *
 {
     int r = 0;
     struct mailbox *mailbox = NULL;
-    char olddate[RFC822_DATETIME_MAX+1];
-    char newdate[RFC822_DATETIME_MAX+1];
+    char olddate[RFC5322_DATETIME_MAX+1];
+    char newdate[RFC5322_DATETIME_MAX+1];
 
     signals_poll();
 
@@ -211,8 +199,8 @@ static int do_timestamp(const mbname_t *
 
         struct index_record copyrecord = *record;
 
-        time_to_rfc822(copyrecord.internaldate, olddate, sizeof(olddate));
-        time_to_rfc822(copyrecord.gmtime, newdate, sizeof(newdate));
+        time_to_rfc5322(copyrecord.internaldate, olddate, sizeof(olddate));
+        time_to_rfc5322(copyrecord.gmtime, newdate, sizeof(newdate));
         printf("  %u: %s => %s\n", copyrecord.uid, olddate, newdate);
 
         /* switch internaldate */
@@ -264,12 +252,14 @@ static int do_reid(const mbname_t *mbnam
 int do_cmd(struct findall_data *data, void *rock)
 {
     if (!data) return 0;
+    if (!data->is_exactmatch) return 0;
+
     int *valp = (int *)rock;
 
-    if (*valp == CMD_TIME && data->mbname != NULL)
+    if (*valp == CMD_TIME)
         return do_timestamp(data->mbname);
 
-    if (*valp == CMD_REID && data->mbname != NULL)
+    if (*valp == CMD_REID)
         return do_reid(data->mbname);
 
     return 0;
diff -pruN 3.0.13-5/imap/message.c 3.2.0-3/imap/message.c
--- 3.0.13-5/imap/message.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message.c	2020-05-04 03:28:02.000000000 +0000
@@ -49,6 +49,7 @@
 #include <stdio.h>
 #include <ctype.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <sys/uio.h>
@@ -60,7 +61,6 @@
 #include "assert.h"
 #include "crc32.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "prot.h"
 #include "hash.h"
 #include "map.h"
@@ -71,6 +71,7 @@
 #include "parseaddr.h"
 #include "charset.h"
 #include "stristr.h"
+#include "user.h"
 #include "util.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -80,6 +81,7 @@
 #include "retry.h"
 #include "rfc822tok.h"
 #include "times.h"
+#include "xstrnchr.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -100,28 +102,27 @@ struct msg {
 
 #define MAX_FIELDNAME_LENGTH   256
 
-/* (draft standard) MIME tspecials */
-#define TSPECIALS "()<>@,;:\\\"/[]?="
-
 /* Default MIME Content-type */
 #define DEFAULT_CONTENT_TYPE "TEXT/PLAIN; CHARSET=us-ascii"
 
 static int message_parse_body(struct msg *msg,
+                              struct body *body,
+                              const char *defaultContentType,
+                              strarray_t *boundaries,
+                              const char *efname);
+static int message_parse_headers(struct msg *msg,
                                  struct body *body,
                                  const char *defaultContentType,
-                                 strarray_t *boundaries);
+                                 strarray_t *boundaries,
+                                 const char *efname);
 
-static int message_parse_headers(struct msg *msg,
-                                    struct body *body,
-                                    const char *defaultContentType,
-                                    strarray_t *boundaries);
 static void message_parse_address(const char *hdr, struct address **addrp);
 static void message_parse_encoding(const char *hdr, char **hdrp);
 static void message_parse_charset(const struct body *body,
                                   int *encoding, charset_t *charset);
 static void message_parse_header(const char *hdr, struct buf *buf);
-static void message_parse_type(const char *hdr, struct body *body);
-static void message_parse_disposition(const char *hdr, struct body *body);
+static void message_parse_bodytype(const char *hdr, struct body *body);
+static void message_parse_bodydisposition(const char *hdr, struct body *body);
 static void message_parse_params(const char *hdr, struct param **paramp);
 static void message_fold_params(struct param **paramp);
 static void message_parse_language(const char *hdr, struct param **paramp);
@@ -129,11 +130,13 @@ static void message_parse_rfc822space(co
 static void message_parse_received_date(const char *hdr, char **hdrp);
 
 static void message_parse_multipart(struct msg *msg,
-                                       struct body *body,
-                                       strarray_t *boundaries);
+                                    struct body *body,
+                                    strarray_t *boundaries,
+                                    const char *efname);
 static void message_parse_content(struct msg *msg,
-                                     struct body *body,
-                                     strarray_t *boundaries);
+                                  struct body *body,
+                                  strarray_t *boundaries,
+                                  const char *efname);
 
 static char *message_getline(struct buf *, struct msg *msg);
 static int message_pendingboundary(const char *s, int slen, strarray_t *);
@@ -149,8 +152,6 @@ static void message_write_searchaddr(str
 static int message_need(const message_t *m, unsigned int need);
 static void message_yield(message_t *m, unsigned int yield);
 
-static void param_free(struct param **paramp);
-
 /*
  * Convert a string to uppercase.  Returns the string.
  *
@@ -170,8 +171,9 @@ static char *message_ucase(char *s)
 }
 
 /*
- * Copy a message of 'size' bytes from 'from' to 'to',
- * ensuring minimal RFC-822 compliance.
+ * Check a message 'from' of 'size' bytes for minimal RFC-822 compliance.
+ * The message is read from 'from'. If 'to' is not NULL, the message
+ * is copied to 'to', otherwise an in-memory buffer of 'from' is checked.
  *
  * Caller must have initialized config_* routines (with cyrus_init) to read
  * imapd.conf before calling.
@@ -187,6 +189,7 @@ EXPORTED int message_copy_strict(struct
     int reject8bit = config_getswitch(IMAPOPT_REJECT8BIT);
     int munge8bit = config_getswitch(IMAPOPT_MUNGE8BIT);
     int inheader = 1, blankline = 1;
+    struct buf tmp = BUF_INITIALIZER;
 
     while (size) {
         n = prot_read(from, buf, size > 4096 ? 4096 : size);
@@ -239,33 +242,76 @@ EXPORTED int message_copy_strict(struct
             }
         }
 
-        fwrite(buf, 1, n, to);
+        if (to)
+            fwrite(buf, 1, n, to);
+        else
+            buf_appendmap(&tmp, buf, n);
     }
 
-    if (r) return r;
-    fflush(to);
-    if (ferror(to) || fsync(fileno(to))) {
-        syslog(LOG_ERR, "IOERROR: writing message: %m");
-        return IMAP_IOERROR;
+    if (r) goto done;
+
+    if (to) {
+        fflush(to);
+        if (ferror(to) || fsync(fileno(to))) {
+            syslog(LOG_ERR, "IOERROR: writing message: %m");
+            r = IMAP_IOERROR;
+            goto done;
+        }
+        rewind(to);
     }
-    rewind(to);
 
     /* Go back and check headers */
     sawnl = 1;
+    const char *cur = buf_base(&tmp);
+    const char *top = buf_base(&tmp) + buf_len(&tmp);
     for (;;) {
-        if (!fgets(buf, sizeof(buf), to)) {
-            return sawnl ? 0 : IMAP_MESSAGE_BADHEADER;
+        /* Read headers into buffer */
+        if (to) {
+            if (!fgets(buf, sizeof(buf), to)) {
+                r = sawnl ? 0 : IMAP_MESSAGE_BADHEADER;
+                goto done;
+            }
+        }
+        else {
+            if (cur >= top) {
+                r = sawnl ? 0 : IMAP_MESSAGE_BADHEADER;
+                goto done;
+            }
+            const char *q = strchr(cur, '\n');
+            if (q == NULL) {
+                q = cur + sizeof(buf);
+                if (q > top) q = top;
+            }
+            else {
+                q++;
+            }
+            if (q > cur + sizeof(buf) - 1) {
+                q = cur + sizeof(buf) - 1;
+            }
+            memcpy(buf, cur, q - cur);
+            buf[q-cur] = '\0';
+            cur = q;
         }
 
         /* End of header section */
-        if (sawnl && buf[0] == '\r') return 0;
+        if (sawnl && buf[0] == '\r') {
+            r = 0;
+            goto done;
+        }
 
         /* Check for valid header name */
         if (sawnl && buf[0] != ' ' && buf[0] != '\t') {
-            if (buf[0] == ':') return IMAP_MESSAGE_BADHEADER;
-      if (strstr(buf, "From ") != buf)
-            for (p = (unsigned char *)buf; *p != ':'; p++) {
-                if (*p <= ' ') return IMAP_MESSAGE_BADHEADER;
+            if (buf[0] == ':') {
+                r = IMAP_MESSAGE_BADHEADER;
+                goto done;
+            }
+            if (strstr(buf, "From ") != buf) {
+                for (p = (unsigned char *)buf; *p && *p != ':'; p++) {
+                    if (*p <= ' ') {
+                        r = IMAP_MESSAGE_BADHEADER;
+                        goto done;
+                    }
+                }
             }
         }
 
@@ -276,6 +322,9 @@ EXPORTED int message_copy_strict(struct
 
         sawnl = (p > (unsigned char *)buf) && (p[-1] == '\n');
     }
+done:
+    buf_free(&tmp);
+    return r;
 }
 
 EXPORTED int message_parse(const char *fname, struct index_record *record)
@@ -287,7 +336,7 @@ EXPORTED int message_parse(const char *f
     f = fopen(fname, "r");
     if (!f) return IMAP_IOERROR;
 
-    r = message_parse_file(f, NULL, NULL, &body);
+    r = message_parse_file(f, NULL, NULL, &body, fname);
     if (!r) r = message_create_record(record, body);
 
     fclose(f);
@@ -309,8 +358,9 @@ EXPORTED int message_parse(const char *f
  * and returned to the caller.  The caller MUST unmap the file.
  */
 EXPORTED int message_parse_file(FILE *infile,
-                       const char **msg_base, size_t *msg_len,
-                       struct body **body)
+                                const char **msg_base, size_t *msg_len,
+                                struct body **body,
+                                const char *efname)
 {
     int fd = fileno(infile);
     struct stat sbuf;
@@ -327,8 +377,12 @@ EXPORTED int message_parse_file(FILE *in
     *msg_len = 0;
 
     if (fstat(fd, &sbuf) == -1) {
-        syslog(LOG_ERR, "IOERROR: fstat on new message in spool: %m");
-        fatal("can't fstat message file", EC_OSFILE);
+        if (efname)
+            syslog(LOG_ERR, "IOERROR: fstat on new message in spool (%s): %m",
+                   efname);
+        else
+            syslog(LOG_ERR, "IOERROR: fstat on new message in spool: %m");
+        fatal("can't fstat message file", EX_OSFILE);
     }
     map_refresh(fd, 1, msg_base, msg_len, sbuf.st_size,
                 "new message", 0);
@@ -337,7 +391,7 @@ EXPORTED int message_parse_file(FILE *in
         return IMAP_IOERROR; /* zero length file? */
 
     if (!*body) *body = (struct body *) xzmalloc(sizeof(struct body));
-    r = message_parse_mapped(*msg_base, *msg_len, *body);
+    r = message_parse_mapped(*msg_base, *msg_len, *body, efname);
 
     if (unmap) map_free(msg_base, msg_len);
 
@@ -357,7 +411,8 @@ EXPORTED int message_parse_file(FILE *in
  *
  * XXX can we do this with mmap()?
  */
-EXPORTED int message_parse_binary_file(FILE *infile, struct body **body)
+EXPORTED int message_parse_binary_file(FILE *infile, struct body **body,
+                                       const char *efname)
 {
     int fd = fileno(infile);
     struct stat sbuf;
@@ -365,8 +420,12 @@ EXPORTED int message_parse_binary_file(F
     size_t n;
 
     if (fstat(fd, &sbuf) == -1) {
-        syslog(LOG_ERR, "IOERROR: fstat on new message in spool: %m");
-        fatal("can't fstat message file", EC_OSFILE);
+        if (efname)
+            syslog(LOG_ERR, "IOERROR: fstat on new message in spool (%s): %m",
+                   efname);
+        else
+            syslog(LOG_ERR, "IOERROR: fstat on new message in spool: %m");
+        fatal("can't fstat message file", EX_OSFILE);
     }
     msg.len = sbuf.st_size;
     msg.base = xmalloc(msg.len);
@@ -377,13 +436,17 @@ EXPORTED int message_parse_binary_file(F
 
     n = retry_read(fd, (char*) msg.base, msg.len);
     if (n != msg.len) {
-        syslog(LOG_ERR, "IOERROR: reading binary file in spool: %m");
+        if (efname)
+            syslog(LOG_ERR, "IOERROR: reading binary file in spool (%s): %m",
+                   efname);
+        else
+            syslog(LOG_ERR, "IOERROR: reading binary file in spool: %m");
         return IMAP_IOERROR;
     }
 
     if (!*body) *body = (struct body *) xzmalloc(sizeof(struct body));
     message_parse_body(&msg, *body,
-                       DEFAULT_CONTENT_TYPE, (strarray_t *)0);
+                       DEFAULT_CONTENT_TYPE, NULL, efname);
 
     (*body)->filesize = msg.len;
 
@@ -395,7 +458,11 @@ EXPORTED int message_parse_binary_file(F
     free((char*) msg.base);
 
     if (n != msg.len || fsync(fd)) {
-        syslog(LOG_ERR, "IOERROR: rewriting binary file in spool: %m");
+        if (efname)
+            syslog(LOG_ERR, "IOERROR: rewriting binary file in spool (%s): %m",
+                   efname);
+        else
+            syslog(LOG_ERR, "IOERROR: rewriting binary file in spool: %m");
         return IMAP_IOERROR;
     }
 
@@ -406,7 +473,7 @@ EXPORTED int message_parse_binary_file(F
  * Parse the message at 'msg_base' of length 'msg_len'.
  */
 EXPORTED int message_parse_mapped(const char *msg_base, unsigned long msg_len,
-                         struct body *body)
+                                  struct body *body, const char *efname)
 {
     struct msg msg;
 
@@ -415,17 +482,22 @@ EXPORTED int message_parse_mapped(const
     msg.offset = 0;
     msg.encode = 0;
 
-    message_parse_body(&msg, body,
-                       DEFAULT_CONTENT_TYPE, (strarray_t *)0);
+    message_parse_body(&msg, body, DEFAULT_CONTENT_TYPE, NULL, efname);
 
     body->filesize = msg_len;
 
     message_guid_generate(&body->guid, msg_base, msg_len);
 
     if (body->filesize != body->header_size + body->content_size) {
-        syslog(LOG_NOTICE, "IOERROR: size mismatch on parse %s (%d, %d)",
-               message_guid_encode(&body->guid), (int)body->filesize,
-               (int)(body->header_size + body->content_size));
+        if (efname)
+            syslog(LOG_NOTICE, "IOERROR: size mismatch on parse %s (%s) (%d, %d)",
+                   message_guid_encode(&body->guid), efname,
+                   (int)body->filesize,
+                   (int)(body->header_size + body->content_size));
+        else
+            syslog(LOG_NOTICE, "IOERROR: size mismatch on parse %s (%d, %d)",
+                   message_guid_encode(&body->guid), (int)body->filesize,
+                   (int)(body->header_size + body->content_size));
     }
 
     return 0;
@@ -523,7 +595,7 @@ static void message_find_part(struct bod
         /* matching part, sanity check the size against the mmap'd file */
         if (body->content_offset + body->content_size > msg_len) {
             syslog(LOG_ERR, "IOERROR: body part exceeds size of message file");
-            fatal("body part exceeds size of message file", EC_OSFILE);
+            fatal("body part exceeds size of message file", EX_OSFILE);
         }
 
         if (!body->decoded_body) {
@@ -532,7 +604,7 @@ static void message_find_part(struct bod
             message_parse_charset(body, &encoding, &charset);
             if (charset == CHARSET_UNKNOWN_CHARSET)
                 /* try ASCII */
-                charset = charset_lookupname("US-ASCII");
+                charset = charset_lookupname("us-ascii");
             body->decoded_body = charset_to_utf8(
                 msg_base + body->content_offset, body->content_size,
                 charset, encoding); /* returns a cstring */
@@ -541,7 +613,7 @@ static void message_find_part(struct bod
 
         /* grow the array and add the new part */
         *parts = xrealloc(*parts, (*n+2)*sizeof(struct bodypart *));
-        (*parts)[*n] = xmalloc(sizeof(struct bodypart));
+        (*parts)[*n] = xzmalloc(sizeof(struct bodypart));
         strlcpy((*parts)[*n]->section, section, sizeof((*parts)[*n]->section));
         (*parts)[*n]->decoded_body = body->decoded_body;
         (*parts)[++(*n)] = NULL;
@@ -588,24 +660,16 @@ EXPORTED void message_fetch_part(struct
 HIDDEN int message_create_record(struct index_record *record,
                           const struct body *body)
 {
-    if (!record->internaldate) {
-        if (body->received_date &&
-                config_getenum(IMAPOPT_INTERNALDATE_HEURISTIC)
-                == IMAP_ENUM_INTERNALDATE_HEURISTIC_RECEIVEDHEADER)
-            time_from_rfc822(body->received_date, &record->internaldate);
-    }
-
     /* used for sent time searching, truncated to day with no TZ */
-    if (day_from_rfc822(body->date, &record->sentdate) < 0)
+    if (time_from_rfc5322(body->date, &record->sentdate, DATETIME_DATE_ONLY) < 0)
         record->sentdate = 0;
 
     /* used for sent time sorting, full gmtime of Date: header */
-    if (time_from_rfc822(body->date, &record->gmtime) < 0)
+    if (time_from_rfc5322(body->date, &record->gmtime, DATETIME_FULL) < 0)
         record->gmtime = 0;
 
     record->size = body->filesize;
     record->header_size = body->header_size;
-    record->content_lines = body->content_lines;
     message_guid_copy(&record->guid, &body->guid);
 
     message_write_cache(record, body);
@@ -635,18 +699,12 @@ static void body_add_content_guid(const
     base = charset_decode_mimebody(base, len, encoding, &decbuf, &len);
     if (base) {
         message_guid_generate(&body->content_guid, base, len);
-        /* mix in type and charset */
-        struct iovec iov[3];
-        iov[0].iov_base = body->type;
-        iov[1].iov_base = body->subtype;
-        iov[2].iov_base = cs ? (char *)charset_name(cs) : NULL;
-        iov[0].iov_len = iov[0].iov_base ? strlen(iov[0].iov_base) : 0;
-        iov[1].iov_len = iov[1].iov_base ? strlen(iov[1].iov_base) : 0;
-        iov[2].iov_len = iov[2].iov_base ? strlen(iov[2].iov_base) : 0;
-        uint32_t crc = crc32_iovec(iov, 3);
-        message_guid_permute32(&body->content_guid, crc);
+        body->decoded_content_size = len;
+    }
+    else {
+        message_guid_set_null(&body->content_guid);
+        body->decoded_content_size = 0;
     }
-    else message_guid_set_null(&body->content_guid);
     charset_free(&cs);
     free(decbuf);
 }
@@ -657,13 +715,13 @@ static void body_add_content_guid(const
  */
 static int message_parse_body(struct msg *msg, struct body *body,
                               const char *defaultContentType,
-                              strarray_t *boundaries)
+                              strarray_t *boundaries,
+                              const char *efname)
 {
     strarray_t newboundaries = STRARRAY_INITIALIZER;
     int sawboundary;
 
     memset(body, 0, sizeof(struct body));
-    buf_init(&body->cacheheaders);
 
     /* No passed-in boundary structure, create a new, empty one */
     if (!boundaries) {
@@ -674,26 +732,39 @@ static int message_parse_body(struct msg
 
 
     sawboundary = message_parse_headers(msg, body, defaultContentType,
-                                        boundaries);
+                                        boundaries, efname);
+
+    /* Charset id and encoding id are stored in the binary
+     * bodystructure, but we don't have that one here. */
+    struct param *param = body->params;
+    while (param) {
+        if (!strcasecmp(param->attribute, "CHARSET")) {
+            body->charset_id = xstrdupnull(param->value);
+            break;
+        }
+        param = param->next;
+    }
+
+    body->charset_enc = encoding_lookupname(body->encoding);
 
     /* Recurse according to type */
     if (strcmp(body->type, "MULTIPART") == 0) {
         if (!sawboundary) {
-            message_parse_multipart(msg, body, boundaries);
+            message_parse_multipart(msg, body, boundaries, efname);
         }
     }
     else if (strcmp(body->type, "MESSAGE") == 0 &&
         strcmp(body->subtype, "RFC822") == 0) {
         const char *base = msg->base + msg->offset;
-        body->subpart = (struct body *)xmalloc(sizeof(struct body));
+        body->subpart = (struct body *)xzmalloc(sizeof(struct body));
 
         if (sawboundary) {
             memset(body->subpart, 0, sizeof(struct body));
-            message_parse_type(DEFAULT_CONTENT_TYPE, body->subpart);
+            message_parse_bodytype(DEFAULT_CONTENT_TYPE, body->subpart);
         }
         else {
             message_parse_body(msg, body->subpart,
-                               DEFAULT_CONTENT_TYPE, boundaries);
+                               DEFAULT_CONTENT_TYPE, boundaries, efname);
 
             /* Calculate our size/lines information */
             body->content_size = body->subpart->header_size +
@@ -707,12 +778,11 @@ static int message_parse_body(struct msg
 
             /* it's nice to have a GUID for the message/rfc822 itself */
             body_add_content_guid(base, body);
-
         }
     }
     else {
         if (!sawboundary) {
-            message_parse_content(msg, body, boundaries);
+            message_parse_content(msg, body, boundaries, efname);
         }
     }
 
@@ -727,7 +797,8 @@ static int message_parse_body(struct msg
  */
 static int message_parse_headers(struct msg *msg, struct body *body,
                                  const char *defaultContentType,
-                                 strarray_t *boundaries)
+                                 strarray_t *boundaries,
+                                 const char *efname)
 {
     struct buf headers = BUF_INITIALIZER;
     char *next;
@@ -779,8 +850,14 @@ static int message_parse_headers(struct
 
             /* check if we've hit a limit and flag it */
             if (maxlines && body->header_lines > maxlines) {
-                syslog(LOG_ERR, "ERROR: message has more than %d header lines, not caching any more",
-                       maxlines);
+                if (efname)
+                    syslog(LOG_ERR, "ERROR: message (%s) has more than %d header lines"
+                                    "not caching any more",
+                           efname, maxlines);
+                else
+                    syslog(LOG_ERR, "ERROR: message has more than %d header lines"
+                                    "not caching any more",
+                           maxlines);
                 have_max = 1;
                 continue;
             }
@@ -806,7 +883,7 @@ static int message_parse_headers(struct
                 message_parse_string(value, &body->description);
                 break;
             case RFC822_CONTENT_DISPOSITION:
-                message_parse_disposition(value, body);
+                message_parse_bodydisposition(value, body);
                 break;
             case RFC822_CONTENT_ID:
                 message_parse_string(value, &body->id);
@@ -835,7 +912,7 @@ static int message_parse_headers(struct
                 }
                 break;
             case RFC822_CONTENT_TYPE:
-                message_parse_type(value, body);
+                message_parse_bodytype(value, body);
                 break;
             case RFC822_DATE:
                 message_parse_string(value, &body->date);
@@ -882,7 +959,7 @@ static int message_parse_headers(struct
 
     /* If didn't find Content-Type: header, use the passed-in default type */
     if (!body->type) {
-        message_parse_type(defaultContentType, body);
+        message_parse_bodytype(defaultContentType, body);
     }
     buf_free(&headers);
     return sawboundary;
@@ -941,7 +1018,7 @@ static void message_parse_encoding(const
 
     /* Find end of encoding token */
     for (p = hdr; *p && !Uisspace(*p) && *p != '('; p++) {
-        if (*p < ' ' || strchr(TSPECIALS, *p)) return;
+        if (*p < ' ' || strchr(MIME_TSPECIALS, *p)) return;
     }
     len = p - hdr;
 
@@ -961,7 +1038,7 @@ static void message_parse_charset(const
 {
 
     int encoding = ENCODING_NONE;
-    charset_t charset = charset_lookupname("US-ASCII");
+    charset_t charset = charset_lookupname("us-ascii");
     struct param *param;
 
 
@@ -1102,38 +1179,39 @@ message_parse_header(const char *hdr, st
 /*
  * Parse a Content-Type from a header.
  */
-static void message_parse_type(const char *hdr, struct body *body)
+EXPORTED void message_parse_type(const char *hdr, char **typep, char **subtypep, struct param **paramp)
 {
     const char *type;
     int typelen;
     const char *subtype;
     int subtypelen;
-
-    /* If we saw this header already, discard the earlier value */
-    if (body->type) {
-        free(body->type);
-        free(body->subtype);
-        body->type = body->subtype = NULL;
-        param_free(&body->params);
-    }
+    char *decbuf = NULL;
 
     /* Skip leading whitespace, ignore header if blank */
     message_parse_rfc822space(&hdr);
     if (!hdr) return;
 
+    /* Very old versions of macOS Mail.app encode the Content-Type header
+     * in MIME words, if the attachment name contains non-ASCII characters */
+    if (strlen(hdr) > 2 && hdr[0] == '=' && hdr[1] == '?') {
+        int flags = CHARSET_KEEPCASE;
+        decbuf = charset_decode_mimeheader(hdr, flags);
+        if (strcmpsafe(decbuf, hdr)) hdr = decbuf;
+    }
+
     /* Find end of type token */
     type = hdr;
     for (; *hdr && !Uisspace(*hdr) && *hdr != '/' && *hdr != '('; hdr++) {
-        if (*hdr < ' ' || strchr(TSPECIALS, *hdr)) return;
+        if (*hdr < ' ' || strchr(MIME_TSPECIALS, *hdr)) goto done;
     }
     typelen = hdr - type;
 
     /* Skip whitespace after type */
     message_parse_rfc822space(&hdr);
-    if (!hdr) return;
+    if (!hdr) goto done;
 
     /* Ignore header if no '/' character */
-    if (*hdr++ != '/') return;
+    if (*hdr++ != '/') goto done;
 
     /* Skip whitespace before subtype, ignore header if no subtype */
     message_parse_rfc822space(&hdr);
@@ -1142,7 +1220,7 @@ static void message_parse_type(const cha
     /* Find end of subtype token */
     subtype = hdr;
     for (; *hdr && !Uisspace(*hdr) && *hdr != ';' && *hdr != '('; hdr++) {
-        if (*hdr < ' ' || strchr(TSPECIALS, *hdr)) return;
+        if (*hdr < ' ' || strchr(MIME_TSPECIALS, *hdr)) goto done;
     }
     subtypelen = hdr - subtype;
 
@@ -1150,34 +1228,68 @@ static void message_parse_type(const cha
     message_parse_rfc822space(&hdr);
 
     /* Ignore header if not at end of header or parameter delimiter */
-    if (hdr && *hdr != ';') return;
+    if (hdr && *hdr != ';') goto done;
 
     /* Save content type & subtype */
-    body->type = message_ucase(xstrndup(type, typelen));
-    body->subtype = message_ucase(xstrndup(subtype, subtypelen));
+    *typep = message_ucase(xstrndup(type, typelen));
+    *subtypep = message_ucase(xstrndup(subtype, subtypelen));
 
     /* Parse parameter list */
     if (hdr) {
-        message_parse_params(hdr+1, &body->params);
-        message_fold_params(&body->params);
+        message_parse_params(hdr+1, paramp);
+        message_fold_params(paramp);
+        if (decbuf && paramp && *paramp) {
+            /* The type header was erroneously encoded as a RFC2407 encoded word
+             * (rather than encoding its attributes), and the parameter values
+             * might now contain non-ASCII characters. Let's reencode them. */
+            struct param *param = *paramp;
+            for (; param; param = param->next) {
+                const char *attr = param->attribute;
+                /* Skip extended parameters */
+                size_t attrlen = strlen(attr);
+                if (!attrlen || attr[attrlen-1] == '*') continue;
+                /* Check if the parameter value has non-ASCII characters */
+                int has_highbit = 0;
+                const char *val = param->value;
+                for (val = param->value; *val && !has_highbit; val++) {
+                    has_highbit = *val & 0x80;
+                }
+                if (!has_highbit) continue;
+                /* Reencode the parameter value */
+                char *encvalue = charset_encode_mimeheader(param->value, strlen(param->value), 0);
+                if (encvalue) {
+                    free(param->value);
+                    param->value = encvalue;
+                }
+            }
+        }
     }
+
+done:
+    free(decbuf);
+}
+
+static void message_parse_bodytype(const char *hdr, struct body *body)
+{
+    /* If we saw this header already, discard the earlier value */
+    if (body->type) {
+        free(body->type);
+        free(body->subtype);
+        body->type = body->subtype = NULL;
+        param_free(&body->params);
+    }
+
+    message_parse_type(hdr, &body->type, &body->subtype, &body->params);
 }
 
 /*
  * Parse a Content-Disposition from a header.
  */
-static void message_parse_disposition(const char *hdr, struct body *body)
+EXPORTED void message_parse_disposition(const char *hdr, char **hdrp, struct param **paramp)
 {
     const char *disposition;
     int dispositionlen;
 
-    /* If we saw this header already, discard the earlier value */
-    if (body->disposition) {
-        free(body->disposition);
-        body->disposition = NULL;
-        param_free(&body->disposition_params);
-    }
-
     /* Skip leading whitespace, ignore header if blank */
     message_parse_rfc822space(&hdr);
     if (!hdr) return;
@@ -1185,7 +1297,7 @@ static void message_parse_disposition(co
     /* Find end of disposition token */
     disposition = hdr;
     for (; *hdr && !Uisspace(*hdr) && *hdr != ';' && *hdr != '('; hdr++) {
-        if (*hdr < ' ' || strchr(TSPECIALS, *hdr)) return;
+        if (*hdr < ' ' || strchr(MIME_TSPECIALS, *hdr)) return;
     }
     dispositionlen = hdr - disposition;
 
@@ -1196,13 +1308,28 @@ static void message_parse_disposition(co
     if (hdr && *hdr != ';') return;
 
     /* Save content disposition */
-    body->disposition = message_ucase(xstrndup(disposition, dispositionlen));
+    *hdrp = message_ucase(xstrndup(disposition, dispositionlen));
 
     /* Parse parameter list */
     if (hdr) {
-        message_parse_params(hdr+1, &body->disposition_params);
-        message_fold_params(&body->disposition_params);
+        message_parse_params(hdr+1, paramp);
+        message_fold_params(paramp);
+    }
+}
+
+/*
+ * Parse a Content-Disposition from a header.
+ */
+static void message_parse_bodydisposition(const char *hdr, struct body *body)
+{
+    /* If we saw this header already, discard the earlier value */
+    if (body->disposition) {
+        free(body->disposition);
+        body->disposition = NULL;
+        param_free(&body->disposition_params);
     }
+
+    message_parse_disposition(hdr, &body->disposition, &body->disposition_params);
 }
 
 /*
@@ -1232,7 +1359,7 @@ static void message_parse_params(const c
         /* Find end of attribute */
         attribute = hdr;
         for (; *hdr && !Uisspace(*hdr) && *hdr != '=' && *hdr != '('; hdr++) {
-            if (*hdr < ' ' || strchr(TSPECIALS, *hdr)) goto skip;
+            if (*hdr < ' ' || strchr(MIME_TSPECIALS, *hdr)) goto skip;
         }
         attributelen = hdr - attribute;
 
@@ -1250,6 +1377,7 @@ static void message_parse_params(const c
         /* Find end of value */
         value = hdr;
         if (*hdr == '\"') {
+            /* Parse quoted-string */
             hdr++;
             while (*hdr && *hdr != '\"') {
                 if (*hdr == '\\') {
@@ -1266,9 +1394,29 @@ static void message_parse_params(const c
             if (!*hdr++) return;
         }
         else {
-            for (; *hdr && !Uisspace(*hdr) && *hdr != ';' && *hdr != '('; hdr++) {
-                if (*hdr < ' ' || strchr(TSPECIALS, *hdr)) goto skip;
+            /* Parse token (leniently allow space and tspecials) */
+            const char *endval = hdr;
+            while (*hdr && *hdr != ';' && *hdr != '(') {
+                if (*hdr == '\r') {
+                    /* Skip FWS and stop at CRLF */
+                    if (hdr[1] == '\n' && (hdr[2] == ' ' || hdr[2] == '\t')) {
+                        hdr += 2;
+                        continue;
+                    }
+                    else break;
+                }
+                if (*hdr < ' ' && *hdr != '\t') {
+                    /* Reject control characters */
+                    goto skip;
+                }
+                if (*hdr != ' ' && *hdr != '\t') {
+                    /* Keep last non-WSP position */
+                    endval = hdr;
+                }
+                hdr++;
             }
+            /* Right-strip white space */
+            hdr = endval + 1;
         }
         valuelen = hdr - value;
 
@@ -1384,7 +1532,7 @@ static void message_fold_params(struct p
                         while (*from) {
                             if (*from <= ' ' || *from >= 0x7f ||
                                 *from == '*' || *from == '\'' ||
-                                *from == '%' || strchr(TSPECIALS, *from)) {
+                                *from == '%' || strchr(MIME_TSPECIALS, *from)) {
                                 *to++ = '%';
                                 to += bin_to_hex(from, 1, to, BH_UPPER);
                             } else {
@@ -1430,7 +1578,7 @@ static void message_fold_params(struct p
                         while (*from) {
                             if (*from <= ' ' || *from >= 0x7f ||
                                 *from == '*' || *from == '\'' ||
-                                *from == '%' || strchr(TSPECIALS, *from)) {
+                                *from == '%' || strchr(MIME_TSPECIALS, *from)) {
                                 *to++ = '%';
                                 to += bin_to_hex(from, 1, to, BH_UPPER);
                             } else {
@@ -1572,7 +1720,7 @@ static void message_parse_rfc822space(co
  * Parse the content of a MIME multipart body-part
  */
 static void message_parse_multipart(struct msg *msg, struct body *body,
-                                    strarray_t *boundaries)
+                                    strarray_t *boundaries, const char *efname)
 {
     struct body preamble, epilogue;
     struct param *boundary;
@@ -1594,7 +1742,7 @@ static void message_parse_multipart(stru
 
     if (!boundary) {
         /* Invalid MIME--treat as zero-part multipart */
-        message_parse_content(msg, body, boundaries);
+        message_parse_content(msg, body, boundaries, efname);
         return;
     }
 
@@ -1603,7 +1751,7 @@ static void message_parse_multipart(stru
     depth = boundaries->count;
 
     /* Parse preamble */
-    message_parse_content(msg, &preamble, boundaries);
+    message_parse_content(msg, &preamble, boundaries, efname);
 
     /* Parse the component body-parts */
     while (boundaries->count == depth &&
@@ -1611,7 +1759,7 @@ static void message_parse_multipart(stru
         body->subpart = (struct body *)xrealloc((char *)body->subpart,
                                  (body->numparts+1)*sizeof(struct body));
         message_parse_body(msg, &body->subpart[body->numparts],
-                           defaultContentType, boundaries);
+                           defaultContentType, boundaries, efname);
         if (msg->offset == msg->len &&
             body->subpart[body->numparts].boundary_size == 0) {
             /* hit the end of the message, therefore end all pending
@@ -1623,7 +1771,7 @@ static void message_parse_multipart(stru
 
     if (boundaries->count == depth-1) {
         /* Parse epilogue */
-        message_parse_content(msg, &epilogue, boundaries);
+        message_parse_content(msg, &epilogue, boundaries, efname);
     }
     else if (body->numparts) {
         /*
@@ -1672,7 +1820,14 @@ static void message_parse_multipart(stru
 
     /* check if we've hit a limit and flag it */
     if (limit && depth == limit) {
-        syslog(LOG_ERR, "ERROR: mime boundary limit %i exceeded, not parsing anymore", limit);
+        if (efname)
+            syslog(LOG_ERR, "ERROR: mime boundary limit %i exceeded, "
+                            "not parsing anymore (%s)",
+                   limit, efname);
+        else
+            syslog(LOG_ERR, "ERROR: mime boundary limit %i exceeded, "
+                            "not parsing anymore",
+                   limit);
     }
 }
 
@@ -1680,7 +1835,8 @@ static void message_parse_multipart(stru
  * Parse the content of a generic body-part
  */
 static void message_parse_content(struct msg *msg, struct body *body,
-                                  strarray_t *boundaries)
+                                  strarray_t *boundaries,
+                                  const char *efname __attribute__((unused)))
 {
     const char *line, *endline;
     unsigned long s_offset = msg->offset;
@@ -1734,7 +1890,7 @@ static void message_parse_content(struct
 
         /* Determine encoded size */
         charset_encode_mimebody(NULL, body->content_size, NULL,
-                                &b64_size, NULL);
+                                &b64_size, NULL, 1 /* wrap */);
 
         delta = b64_size - body->content_size;
 
@@ -1749,7 +1905,7 @@ static void message_parse_content(struct
         charset_encode_mimebody(msg->base + s_offset + delta,
                                 body->content_size,
                                 (char*) msg->base + s_offset,
-                                NULL, &b64_lines);
+                                NULL, &b64_lines, 1 /* wrap */);
 
         /* Adjust buffer position and length to account for encoding */
         msg->offset += delta;
@@ -1883,8 +2039,7 @@ EXPORTED int message_write_cache(struct
 
     /* initialise data structures */
     buf_reset(&cacheitem_buffer);
-    for (i = 0; i < NUM_CACHE_FIELDS; i++)
-        buf_init(&ib[i]);
+    memset(ib, 0, sizeof(ib));
 
     toplevel.type = "MESSAGE";
     toplevel.subtype = "RFC822";
@@ -1973,7 +2128,7 @@ EXPORTED void message_write_body(struct
             static struct body zerotextbody;
 
             if (!zerotextbody.type) {
-                message_parse_type(DEFAULT_CONTENT_TYPE, &zerotextbody);
+                message_parse_bodytype(DEFAULT_CONTENT_TYPE, &zerotextbody);
             }
             message_write_body(buf, &zerotextbody, newformat);
             return;
@@ -2258,6 +2413,8 @@ static void message_write_nocharset(stru
     if (body) message_guid_export(&body->content_guid, guidbuf);
     else memset(&guidbuf, 0, MESSAGE_GUID_SIZE);
     buf_appendmap(buf, guidbuf, MESSAGE_GUID_SIZE);
+    buf_appendbit32(buf, body ? body->decoded_content_size : 0);
+    buf_appendbit32(buf, body ? body->content_lines : 0);
 }
 
 /*
@@ -2381,7 +2538,7 @@ static void message_write_charset(struct
     if (charset != CHARSET_UNKNOWN_CHARSET) {
         size_t itemsize;
 
-        name = charset_name(charset);
+        name = charset_alias_name(charset);
         len = strlen(name);
 
         /* charset name length is a multiple of cache item size,
@@ -2404,10 +2561,15 @@ static void message_write_charset(struct
     }
     charset_free(&charset);
 
+    /* NOTE - this stuff doesn't really belong in a method called
+     * message_write_charset, but it's the fields that are always
+     * written immediately after the charset! */
     char guidbuf[MESSAGE_GUID_SIZE];
     if (body) message_guid_export(&body->content_guid, guidbuf);
     else memset(&guidbuf, 0, MESSAGE_GUID_SIZE);
     buf_appendmap(buf, guidbuf, MESSAGE_GUID_SIZE);
+    buf_appendbit32(buf, body ? body->decoded_content_size : 0);
+    buf_appendbit32(buf, body ? body->content_lines : 0);
 }
 
 /*
@@ -2468,7 +2630,7 @@ static void message_write_searchaddr(str
     }
 }
 
-static void param_free(struct param **paramp)
+EXPORTED void param_free(struct param **paramp)
 {
     struct param *param, *nextparam;
 
@@ -2660,7 +2822,7 @@ EXPORTED char *parse_nstring(char **str)
     return val;
 }
 
-HIDDEN void message_parse_env_address(char *str, struct address *addr)
+EXPORTED void message_parse_env_address(char *str, struct address *addr)
 {
     if (*str == '(') str++; /* skip ( */
     addr->name = parse_nstring(&str);
@@ -2674,7 +2836,7 @@ HIDDEN void message_parse_env_address(ch
 
 /*
  * Read an nstring from cached bodystructure.
- * Analog to mesage_write_nstring().
+ * Analog to message_write_nstring().
  * If 'copy' is set, returns a freshly allocated copy of the string,
  * otherwise is returns a pointer to the string which will be overwritten
  * on the next call to message_read_nstring()
@@ -2756,7 +2918,7 @@ static int message_read_addrpart(struct
 
 /*
  * Read an address list from cached bodystructure.
- * Analog to mesage_write_address()
+ * Analog to message_write_address()
  */
 static int message_read_address(struct protstream *strm, struct address **addrp)
 {
@@ -2765,12 +2927,11 @@ static int message_read_address(struct p
     if ((c = prot_getc(strm)) == '(') {
         /* parse list */
         struct address *addr;
-        struct buf buf;
         unsigned nameoff = 0, rtoff = 0, mboxoff = 0, domoff = 0;
 
         do {
+            struct buf buf = BUF_INITIALIZER;
             *addrp = addr = (struct address *) xzmalloc(sizeof(struct address));
-            buf_init(&buf);
 
             /* opening '(' */
             c = prot_getc(strm);
@@ -2789,7 +2950,7 @@ static int message_read_address(struct p
 
             /* addr parts must now point into our freeme string */
             if (buf.len) {
-                char *freeme = addr->freeme = buf.s;
+                char *freeme = addr->freeme = buf_release(&buf);
 
                 if (addr->name) addr->name = freeme+nameoff;
                 if (addr->route) addr->route = freeme+rtoff;
@@ -2797,6 +2958,8 @@ static int message_read_address(struct p
                 if (addr->domain) addr->domain = freeme+domoff;
             }
 
+            buf_free(&buf);
+
             /* get ready to append the next address */
             addrp = &addr->next;
 
@@ -2815,7 +2978,7 @@ static int message_read_address(struct p
 
 /*
  * Read a cached envelope response.
- * Analog to mesage_write_envelope()
+ * Analog to message_write_envelope()
  */
 static int message_read_envelope(struct protstream *strm, struct body *body)
 {
@@ -2861,12 +3024,10 @@ static int message_read_envelope(struct
 
 /*
  * Read cached bodystructure response.
- * Analog to mesage_write_body()
+ * Analog to message_write_body()
  */
 static int message_read_body(struct protstream *strm, struct body *body, const char *part_id)
 {
-#define prot_peek(strm) prot_ungetc(prot_getc(strm), strm)
-
     int c;
     struct buf buf = BUF_INITIALIZER;
 
@@ -3021,7 +3182,7 @@ done:
 
 /*
  * Read cached binary bodystructure.
- * Analog to mesage_write_section()
+ * Analog to message_write_section()
  */
 static void message_read_binarybody(struct body *body, const char **sect,
                                     uint32_t cache_version)
@@ -3053,6 +3214,10 @@ static void message_read_binarybody(stru
         p += 5 * CACHE_ITEM_SIZE_SKIP;
         if (cache_version >= 5)
             p += MESSAGE_GUID_SIZE;
+        if (cache_version >= 8)
+            p += CACHE_ITEM_SIZE_SKIP;
+        if (cache_version >= 9)
+            p += CACHE_ITEM_SIZE_SKIP;
     }
     else {
         /* read header part */
@@ -3084,6 +3249,15 @@ static void message_read_binarybody(stru
         }
         if (cache_version >= 5)
             p = message_guid_import(&body->content_guid, p);
+
+        if (cache_version >= 8) {
+            body->decoded_content_size = CACHE_ITEM_BIT32(p);
+            p += CACHE_ITEM_SIZE_SKIP;
+        }
+        if (cache_version >= 9) {
+            body->content_lines = CACHE_ITEM_BIT32(p);
+            p += CACHE_ITEM_SIZE_SKIP;
+        }
     }
 
     /* read body parts */
@@ -3116,6 +3290,15 @@ static void message_read_binarybody(stru
         }
         if (cache_version >= 5)
             p = message_guid_import(&subpart[i].content_guid, p);
+
+        if (cache_version >= 8) {
+            subpart[i].decoded_content_size = CACHE_ITEM_BIT32(p);
+            p += CACHE_ITEM_SIZE_SKIP;
+        }
+        if (cache_version >= 9) {
+            subpart[i].content_lines = CACHE_ITEM_BIT32(p);
+            p += CACHE_ITEM_SIZE_SKIP;
+        }
     }
 
     /* read sub-parts */
@@ -3237,6 +3420,28 @@ static int is_valid_rfc2822_inreplyto(co
     return (!*p || *p == '<');
 }
 
+/* XXX - refactor this whole thing to an "open or create" API */
+static int getconvmailbox(const char *mboxname, struct mailbox **mailboxptr)
+{
+    int r = mailbox_open_iwl(mboxname, mailboxptr);
+    if (r != IMAP_MAILBOX_NONEXISTENT) return r;
+
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(mboxname);
+
+    // try again - maybe we lost the race!
+    r = mailbox_open_iwl(mboxname, mailboxptr);
+    if (r == IMAP_MAILBOX_NONEXISTENT) {
+        /* create the mailbox - it's OK to do as admin because this only ever gets
+         * a user subfolder for this conversations.db owner */
+        r = mboxlist_createmailbox(mboxname, MBTYPE_COLLECTION, NULL, 1 /* admin */, NULL, NULL,
+                                   0, 0, 0, 0, mailboxptr);
+    }
+
+    mboxname_release(&namespacelock);
+
+    return r;
+}
+
 /*
  * Update the conversations database for the given
  * mailbox, to account for the given message.
@@ -3244,6 +3449,7 @@ static int is_valid_rfc2822_inreplyto(co
  * we need out of the cache item in @record.
  */
 EXPORTED int message_update_conversations(struct conversations_state *state,
+                                          struct mailbox *mailbox,
                                           struct index_record *record,
                                           conversation_t **convp)
 {
@@ -3253,12 +3459,13 @@ EXPORTED int message_update_conversation
     strarray_t msgidlist = STRARRAY_INITIALIZER;
     arrayu64_t matchlist = ARRAYU64_INITIALIZER;
     arrayu64_t cids = ARRAYU64_INITIALIZER;
+    int mustkeep = 0;
     conversation_t *conv = NULL;
     const char *msubj = NULL;
     int i;
     int j;
     int r = 0;
-    char *msgid = NULL;
+    struct mailbox *local_mailbox = NULL;
 
     /*
      * Gather all the msgids mentioned in the message, starting with
@@ -3322,11 +3529,12 @@ EXPORTED int message_update_conversation
 
     for (i = 0 ; i < 4 ; i++) {
         int hcount = 0;
+        char *msgid = NULL;
         while ((msgid = find_msgid(hdrs[i], &hdrs[i])) != NULL) {
             hcount++;
             if (hcount > 20) {
                 free(msgid);
-                syslog(LOG_NOTICE, "too many references, skipping the rest");
+                syslog(LOG_DEBUG, "too many references, skipping the rest");
                 break;
             }
             /*
@@ -3346,6 +3554,12 @@ EXPORTED int message_update_conversation
                 continue;
             }
 
+            /* won't be accepted as valid, ignore it! */
+            if (conversations_check_msgid(msgid, strlen(msgid))) {
+                free(msgid);
+                continue;
+            }
+
             strarray_appendm(&msgidlist, msgid);
 
             /* Lookup the conversations database to work out which
@@ -3361,7 +3575,7 @@ EXPORTED int message_update_conversation
                 if (r) goto out;
                 /* [IRIS-1576] if X-ME-Message-ID says the messages are
                 * linked, ignore any difference in Subject: header fields. */
-                if (!conv || i == 3 || !strcmpsafe(conv->subject, msubj))
+                if (!conv || i == 3 || !conv->subject || !strcmpsafe(conv->subject, msubj))
                     arrayu64_add(&matchlist, cid);
             }
 
@@ -3370,21 +3584,90 @@ EXPORTED int message_update_conversation
         }
     }
 
+    /* calculate the CID if needed */
     if (!record->silent) {
-        if (!record->cid) record->cid = conversations_guid_cid_lookup(state, message_guid_encode(&record->guid));
+        /* match for GUID, it always has the same CID */
+        conversation_id_t currentcid = conversations_guid_cid_lookup(state, message_guid_encode(&record->guid));
+        if (currentcid) {
+            // would love to have this, but might hit bogus broken existing data...
+            // assert(record->cid == 0 || record->cid == currentcid);
+            record->cid = currentcid;
+            mustkeep = 1;
+        }
         if (!record->cid) record->cid = arrayu64_max(&matchlist);
-        if (!record->cid) record->cid = generate_conversation_id(record);
+        if (!record->cid) {
+            record->cid = generate_conversation_id(record);
+            if (record->cid) mustkeep = 1;
+        }
+        if (!mustkeep && !record->basecid) {
+            /* try finding a CID in the match list, or if we came in with it */
+            struct buf annotkey = BUF_INITIALIZER;
+            struct buf annotval = BUF_INITIALIZER;
+            buf_printf(&annotkey, "%snewcid/%016llx", IMAP_ANNOT_NS, record->cid);
+            r = annotatemore_lookup(state->annotmboxname, buf_cstring(&annotkey), "", &annotval);
+            if (annotval.len == 16) {
+                const char *p = buf_cstring(&annotval);
+                /* we have a new canonical CID */
+                record->basecid = record->cid;
+                r = parsehex(p, &p, 16, &record->cid);
+            }
+            else {
+                r = 0; /* we're just going to pretend this wasn't found, worst case we split
+                        * more than we should */
+            }
+            buf_free(&annotkey);
+            buf_free(&annotval);
+            if (r) goto out;
+        }
     }
 
     if (!record->cid) goto out;
+    if (!record->basecid) record->basecid = record->cid;
 
     r = conversation_load(state, record->cid, &conv);
     if (r) goto out;
 
-    if (!conv) conv = conversation_new(state);
+    if (!conv) conv = conversation_new();
+
+    uint32_t max_thread = config_getint(IMAPOPT_CONVERSATIONS_MAX_THREAD);
+    if (conv->exists >= max_thread && !mustkeep && !record->silent) {
+        /* time to reset the conversation */
+        conversation_id_t was = record->cid;
+        record->cid = generate_conversation_id(record);
+
+        syslog(LOG_NOTICE, "splitting conversation for %s %u base:%016llx was:%016llx now:%016llx",
+               mailbox->name, record->uid, record->basecid, was, record->cid);
 
-    /* Create the subject header if not already set */
-    if (!conv->subject)
+        if (!record->basecid) record->basecid = was;
+
+        conversation_free(conv);
+        r = conversation_load(state, record->cid, &conv);
+        if (r) goto out;
+        if (!conv) conv = conversation_new();
+
+        /* and update the pointer for next time */
+        if (strcmpsafe(state->annotmboxname, mailbox->name)) {
+            r = getconvmailbox(state->annotmboxname, &local_mailbox);
+            if (r) goto out;
+            mailbox = local_mailbox;
+        }
+
+        struct annotate_state *astate = NULL;
+        r = mailbox_get_annotate_state(mailbox, 0, &astate);
+        if (r) goto out;
+
+        struct buf annotkey = BUF_INITIALIZER;
+        struct buf annotval = BUF_INITIALIZER;
+        buf_printf(&annotkey, "%snewcid/%016llx", IMAP_ANNOT_NS, record->basecid);
+        buf_printf(&annotval, "%016llx", record->cid);
+        r = annotate_state_write(astate, buf_cstring(&annotkey), "", &annotval);
+        buf_free(&annotkey);
+        buf_free(&annotval);
+        if (r) goto out;
+    }
+
+    /* Create the subject header if not already set and this isn't a Draft */
+    if (!conv->subject && !(record->system_flags & FLAG_DRAFT))
         conv->subject = xstrdupnull(msubj);
 
     /*
@@ -3392,13 +3675,17 @@ EXPORTED int message_update_conversation
      * not already mentioned.  Note that add_msgid does the right
      * thing[tm] when the cid already exists.
      */
+
     for (i = 0 ; i < msgidlist.count ; i++) {
-        r = conversations_add_msgid(state, strarray_nth(&msgidlist, i), record->cid);
+        r = conversations_add_msgid(state, strarray_nth(&msgidlist, i), record->basecid);
         if (r) goto out;
     }
 
+    /* mark that it's split so basecid gets saved */
+    if (record->basecid != record->cid)
+        record->internal_flags |= FLAG_INTERNAL_SPLITCONVERSATION;
+
 out:
-    free(msgid);
     strarray_fini(&msgidlist);
     arrayu64_fini(&matchlist);
     arrayu64_fini(&cids);
@@ -3406,13 +3693,16 @@ out:
     free(c_env);
     free(c_me_msgid);
     buf_free(&msubject);
+    if (local_mailbox)
+        mailbox_close(&local_mailbox);
 
     if (r)
         conversation_free(conv);
     else if (convp)
         *convp = conv;
     else {
-        r = conversation_save(state, record->cid, conv);
+        // no emailcounts needed here, because we haven't changec counts for any messages
+        r = conversation_save(state, record->cid, conv, NULL);
         conversation_free(conv);
     }
 
@@ -3460,12 +3750,19 @@ static void message_free(message_t *m)
 
     message_yield(m, M_ALL);
 
-    free(m->filename);
-    m->filename = NULL;
-
     free(m);
 }
 
+EXPORTED void message_set_from_data(const char *base, size_t len, message_t *m)
+{
+    assert(m->refcount == 1);
+    message_yield(m, M_ALL);
+    memset(m, 0, sizeof(message_t));
+    buf_init_ro(&m->map, base, len);
+    m->have = m->given = M_MAP;
+    m->refcount = 1;
+}
+
 EXPORTED message_t *message_new_from_data(const char *base, size_t len)
 {
     message_t *m = message_new();
@@ -3474,6 +3771,17 @@ EXPORTED message_t *message_new_from_dat
     return m;
 }
 
+EXPORTED void message_set_from_mailbox(struct mailbox *mailbox, unsigned int recno, message_t *m)
+{
+    assert(m->refcount == 1);
+    message_yield(m, M_ALL);
+    memset(m, 0, sizeof(message_t));
+    m->mailbox = mailbox;
+    m->record.recno = recno;
+    m->have = m->given = M_MAILBOX;
+    m->refcount = 1;
+}
+
 EXPORTED message_t *message_new_from_mailbox(struct mailbox *mailbox, unsigned int recno)
 {
     message_t *m = message_new();
@@ -3483,6 +3791,20 @@ EXPORTED message_t *message_new_from_mai
     return m;
 }
 
+EXPORTED void message_set_from_record(struct mailbox *mailbox,
+                                      const struct index_record *record,
+                                      message_t *m)
+{
+    assert(m->refcount == 1);
+    message_yield(m, M_ALL);
+    memset(m, 0, sizeof(message_t));
+    assert(record->uid > 0);
+    m->mailbox = mailbox;
+    m->record = *record;
+    m->have = m->given = M_MAILBOX|M_RECORD|M_UID;
+    m->refcount = 1;
+}
+
 EXPORTED message_t *message_new_from_record(struct mailbox *mailbox,
                                             const struct index_record *record)
 {
@@ -3494,6 +3816,24 @@ EXPORTED message_t *message_new_from_rec
     return m;
 }
 
+EXPORTED void message_set_from_index(struct mailbox *mailbox,
+                                     const struct index_record *record,
+                                     uint32_t msgno,
+                                     uint32_t indexflags,
+                                     message_t *m)
+{
+    assert(m->refcount == 1);
+    message_yield(m, M_ALL);
+    memset(m, 0, sizeof(message_t));
+    assert(record->uid > 0);
+    m->mailbox = mailbox;
+    m->record = *record;
+    m->msgno = msgno;
+    m->indexflags = indexflags;
+    m->have = m->given = M_MAILBOX|M_RECORD|M_UID|M_INDEX;
+    m->refcount = 1;
+}
+
 EXPORTED message_t *message_new_from_index(struct mailbox *mailbox,
                                            const struct index_record *record,
                                            uint32_t msgno,
@@ -3604,7 +3944,7 @@ static int message_need(const message_t
         r = message_need(m, M_MAP);
         if (r) return r;
         m->body = (struct body *)xzmalloc(sizeof(struct body));
-        r = message_parse_mapped(m->map.s, m->map.len, m->body);
+        r = message_parse_mapped(m->map.s, m->map.len, m->body, NULL);
         if (r) return r;
         found(M_CACHEBODY|M_FULLBODY);
     }
@@ -3631,7 +3971,7 @@ static void message_yield(message_t *m,
 
     /* nothing to free for these - they're not constructed
      * or have no dynamically allocated memory */
-    yield &= ~(M_MAILBOX|M_RECORD|M_FILENAME|M_UID|M_CACHE);
+    yield &= ~(M_MAILBOX|M_RECORD|M_UID|M_CACHE);
 
     if ((yield & M_MAP)) {
         buf_free(&m->map);
@@ -3645,6 +3985,12 @@ static void message_yield(message_t *m,
         m->have &= ~M_BODY;
     }
 
+    if ((yield & M_FILENAME)) {
+        free(m->filename);
+        m->filename = NULL;
+        m->have &= ~M_FILENAME;
+    }
+
     /* Check we yielded everything we could */
     assert((yield & m->have) == 0);
 }
@@ -3756,7 +4102,7 @@ err:
     return EOF;
 }
 
-static int parse_bodystructure_part(struct protstream *prot, struct body *body)
+static int parse_bodystructure_part(struct protstream *prot, struct body *body, const char *part_id)
 {
     int c;
     int r = 0;
@@ -3779,7 +4125,13 @@ badformat:
             body->subpart = (struct body *)xrealloc((char *)body->subpart,
                                           body->numparts*sizeof(struct body));
 
-            r = parse_bodystructure_part(prot, &body->subpart[body->numparts-1]);
+            buf_reset(&buf);
+            if (part_id) buf_printf(&buf, "%s.", part_id);
+            buf_printf(&buf, "%d", body->numparts);
+            char *part_id = buf_release(&buf);
+            struct body *subbody = &body->subpart[body->numparts-1];
+            r = parse_bodystructure_part(prot, subbody, part_id);
+            subbody->part_id = part_id;
             if (r) goto out;
 
             c = prot_getc(prot);
@@ -3846,7 +4198,7 @@ badformat:
             if (r) goto out;
 
             /* process body */
-            r = parse_bodystructure_part(prot, body->subpart);
+            r = parse_bodystructure_part(prot, body->subpart, part_id);
             if (r) goto out;
 
             /* skip trailing space (parse_bs_part doesn't eat it) */
@@ -3885,23 +4237,30 @@ out:
 }
 
 static int parse_bodystructure_sections(const char **cachestrp, const char *cacheend,
-                                        struct body *body, uint32_t cache_version)
+                                        struct body *body, uint32_t cache_version,
+                                        const char *part_id)
 {
     struct body *this;
     int nsubparts;
     int part;
     uint32_t cte;
+    struct buf buf = BUF_INITIALIZER;
+    int r = 0;
 
-    if (*cachestrp + 4 > cacheend)
-        return IMAP_MAILBOX_BADFORMAT;
+    if (*cachestrp + 4 > cacheend) {
+        r = IMAP_MAILBOX_BADFORMAT;
+        goto done;
+    }
 
     nsubparts = CACHE_ITEM_BIT32(*cachestrp);
     *cachestrp += 4;
 
     /* XXX - this size needs increasing for charset sizes and sha1s depending on version,
      * it won't crash, but it may overrun while reading */
-    if (*cachestrp + 4*5*nsubparts > cacheend)
-        return IMAP_MAILBOX_BADFORMAT;
+    if (*cachestrp + 4*5*nsubparts > cacheend) {
+        r = IMAP_MAILBOX_BADFORMAT;
+        goto done;
+    }
 
     if (strcmp(body->type, "MESSAGE") == 0
         && strcmp(body->subtype, "RFC822") == 0) {
@@ -3913,8 +4272,10 @@ static int parse_bodystructure_sections(
              * Nested parts of a message/rfc822 containing a multipart
              * are the sub-parts of the multipart.
              */
-            if (body->subpart->numparts + 1 != nsubparts)
-                return IMAP_MAILBOX_BADFORMAT;
+            if (body->subpart->numparts + 1 != nsubparts) {
+                r = IMAP_MAILBOX_BADFORMAT;
+                goto done;
+            }
 
             body->subpart->header_offset = CACHE_ITEM_BIT32(*cachestrp+0*4);
             body->subpart->header_size = CACHE_ITEM_BIT32(*cachestrp+1*4);
@@ -3926,6 +4287,16 @@ static int parse_bodystructure_sections(
             if (cache_version >= 5)
                 *cachestrp = message_guid_import(&body->subpart->content_guid, *cachestrp);
 
+            if (cache_version >= 8) {
+                body->subpart->decoded_content_size = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
+
+            if (cache_version >= 9) {
+                body->subpart->content_lines = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
+
             for (part = 0; part < body->subpart->numparts; part++) {
                 this = &body->subpart->subpart[part];
                 this->header_offset = CACHE_ITEM_BIT32(*cachestrp+0*4);
@@ -3945,13 +4316,30 @@ static int parse_bodystructure_sections(
                 /* CACHE_MINOR_VERSION 5 adds a sha1 after the charset */
                 if (cache_version >= 5)
                     *cachestrp = message_guid_import(&this->content_guid, *cachestrp);
+
+                /* CACHE_MINOR_VERSION 8 adds the decoded content size after sha1 */
+                if (cache_version >= 8) {
+                    this->decoded_content_size = CACHE_ITEM_BIT32(*cachestrp);
+                    *cachestrp += CACHE_ITEM_SIZE_SKIP;
+                }
+
+                /* CACHE_MINOR_VERSION 9 adds the number of content lines after the decoded size */
+                if (cache_version >= 9) {
+                    this->content_lines = CACHE_ITEM_BIT32(*cachestrp);
+                    *cachestrp += CACHE_ITEM_SIZE_SKIP;
+                }
             }
 
             /* and parse subparts */
             for (part = 0; part < body->subpart->numparts; part++) {
                 this = &body->subpart->subpart[part];
-                if (parse_bodystructure_sections(cachestrp, cacheend, this, cache_version))
-                    return IMAP_MAILBOX_BADFORMAT;
+                buf_reset(&buf);
+                if (part_id) buf_printf(&buf, "%s.", part_id);
+                buf_printf(&buf, "%d", part + 1);
+                if (parse_bodystructure_sections(cachestrp, cacheend, this, cache_version, buf_cstring(&buf))) {
+                    r = IMAP_MAILBOX_BADFORMAT;
+                    goto done;
+                }
             }
         }
         else {
@@ -3961,8 +4349,10 @@ static int parse_bodystructure_sections(
              * is the message body.
              */
 
-            if (2 != nsubparts)
-                return IMAP_MAILBOX_BADFORMAT;
+            if (2 != nsubparts) {
+                r = IMAP_MAILBOX_BADFORMAT;
+                goto done;
+            }
 
             /* data is the same in body, just grab the first one */
             body->subpart->header_offset = CACHE_ITEM_BIT32(*cachestrp+0*4);
@@ -3973,6 +4363,10 @@ static int parse_bodystructure_sections(
             *cachestrp += 5*4;
             if (cache_version >= 5)
                 *cachestrp += MESSAGE_GUID_SIZE;
+            if (cache_version >= 8)
+                *cachestrp += 1*4;
+            if (cache_version >= 9)
+                *cachestrp += 1*4;
             *cachestrp += 4*4;
 
             if (strcmp(body->subpart->type, "MULTIPART") == 0) {
@@ -3989,14 +4383,33 @@ static int parse_bodystructure_sections(
                  * deprecated */
                 if (cache_version >= 4)
                     *cachestrp += (cte >> 16) & 0xffff;
+
+                if (!body->subpart->part_id) {
+                    buf_reset(&buf);
+                    if (part_id) buf_printf(&buf, "%s.", part_id);
+                    buf_printf(&buf, "%d", 1);
+                    body->subpart->part_id = buf_release(&buf);
+                }
             }
             /* CACHE_MINOR_VERSION 5 adds a sha1 after the charset */
             if (cache_version >= 5)
                 *cachestrp = message_guid_import(&body->subpart->content_guid, *cachestrp);
 
+            if (cache_version >= 8) {
+                body->subpart->decoded_content_size = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
+
+            if (cache_version >= 9) {
+                body->subpart->content_lines = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
+
             /* and parse subpart */
-            if (parse_bodystructure_sections(cachestrp, cacheend, body->subpart, cache_version))
-                return IMAP_MAILBOX_BADFORMAT;
+            if (parse_bodystructure_sections(cachestrp, cacheend, body->subpart, cache_version, body->part_id)) {
+                r = IMAP_MAILBOX_BADFORMAT;
+                goto done;
+            }
         }
     }
     else if (body->numparts) {
@@ -4004,11 +4417,17 @@ static int parse_bodystructure_sections(
          * Cannot fetch part 0 of a multipart.
          * Nested parts of a multipart are the sub-parts.
          */
-        if (body->numparts + 1 != nsubparts)
-            return IMAP_MAILBOX_BADFORMAT;
+        if (body->numparts + 1 != nsubparts) {
+            r = IMAP_MAILBOX_BADFORMAT;
+            goto done;
+        }
         *cachestrp += 5*4;
         if (cache_version >= 5)
             *cachestrp += MESSAGE_GUID_SIZE;
+        if (cache_version >= 8)
+            *cachestrp += 4;
+        if (cache_version >= 9)
+            *cachestrp += 4;
         for (part = 0; part < body->numparts; part++) {
             this = &body->subpart[part];
             this->header_offset = CACHE_ITEM_BIT32(*cachestrp+0*4);
@@ -4022,24 +4441,45 @@ static int parse_bodystructure_sections(
                 *cachestrp += (cte >> 16) & 0xffff;
 
             if (cache_version >= 5)
-                *cachestrp = message_guid_import(&body->subpart->content_guid, *cachestrp);
+                *cachestrp = message_guid_import(&this->content_guid, *cachestrp);
+
+            if (cache_version >= 8) {
+                this->decoded_content_size = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
+
+            if (cache_version >= 9) {
+                this->content_lines = CACHE_ITEM_BIT32(*cachestrp);
+                *cachestrp += CACHE_ITEM_SIZE_SKIP;
+            }
         }
 
         for (part = 0; part < body->numparts; part++) {
             this = &body->subpart[part];
-            if (parse_bodystructure_sections(cachestrp, cacheend, this, cache_version))
-                return IMAP_MAILBOX_BADFORMAT;
+            buf_reset(&buf);
+            if (part_id) buf_printf(&buf, "%s.", part_id);
+            buf_printf(&buf, "%d", part + 1);
+            if (parse_bodystructure_sections(cachestrp, cacheend, this, cache_version, buf_cstring(&buf))) {
+                r = IMAP_MAILBOX_BADFORMAT;
+                goto done;
+            }
         }
     }
     else {
         /*
          * Leaf section--no part 0 or nested parts
          */
-        if (nsubparts != 0)
-            return IMAP_MAILBOX_BADFORMAT;
+        if (nsubparts != 0) {
+            r = IMAP_MAILBOX_BADFORMAT;
+            goto done;
+        }
+        if (!body->part_id)
+            body->part_id = xstrdupnull(part_id);
     }
 
-    return 0;
+done:
+    buf_free(&buf);
+    return r;
 }
 
 static int message_parse_cbodystructure(message_t *m)
@@ -4060,7 +4500,7 @@ static int message_parse_cbodystructure(
     prot_setisclient(prot, 1);  /* don't crash parsing literals */
 
     m->body = xzmalloc(sizeof(struct body));
-    r = parse_bodystructure_part(prot, m->body);
+    r = parse_bodystructure_part(prot, m->body, NULL);
     if (r) syslog(LOG_ERR, "IOERROR: parsing body structure for %s %u (%.*s)",
                   m->mailbox->name, m->record.uid,
                   (int)cacheitem_size(&m->record, CACHE_BODYSTRUCTURE),
@@ -4072,7 +4512,7 @@ static int message_parse_cbodystructure(
     toplevel.subtype = "RFC822";
     toplevel.subpart = m->body;
 
-    r = parse_bodystructure_sections(&cachestr, cacheend, &toplevel, m->record.cache_version);
+    r = parse_bodystructure_sections(&cachestr, cacheend, &toplevel, m->record.cache_version, NULL);
     if (r) syslog(LOG_ERR, "IOERROR: parsing section structure for %s %u (%.*s)",
                   m->mailbox->name, m->record.uid,
                   (int)cacheitem_size(&m->record, CACHE_BODYSTRUCTURE),
@@ -4096,14 +4536,14 @@ static int message_map_file(message_t *m
 
     if (fstat(fd, &sbuf) == -1) {
         syslog(LOG_ERR, "IOERROR: fstat on %s: %m", fname);
-        fatal("can't fstat message file", EC_OSFILE);
+        fatal("can't fstat message file", EX_OSFILE);
     }
     if (!S_ISREG(sbuf.st_mode)) {
         close(fd);
         return EINVAL;
     }
     buf_free(&m->map);
-    buf_init_mmap(&m->map, /*onceonly*/1, fd, fname, sbuf.st_size,
+    buf_refresh_mmap(&m->map, /*onceonly*/1, fd, fname, sbuf.st_size,
                   m->mailbox ? m->mailbox->name : NULL);
     close(fd);
 
@@ -4134,6 +4574,8 @@ static int body_foreach_section(struct b
                                     const struct param *type_params,
                                     const char *disposition,
                                     const struct param *disposition_params,
+                                    const struct message_guid *content_guid,
+                                    const char *part,
                                     struct buf *data, void *rock),
                                 void *rock)
 {
@@ -4156,7 +4598,7 @@ static int body_foreach_section(struct b
             msg.len = body->header_size;
             msg.offset = 0;
             msg.encode = 0;
-            message_parse_headers(&msg, tmpbody, "text/plain", &boundaries);
+            message_parse_headers(&msg, tmpbody, "text/plain", &boundaries, NULL);
 
             disposition = tmpbody->disposition;
             disposition_params = tmpbody->disposition_params;
@@ -4164,7 +4606,8 @@ static int body_foreach_section(struct b
 
         buf_init_ro(&data, message->map.s + body->header_offset, body->header_size);
         r = proc(/*isbody*/0, CHARSET_UNKNOWN_CHARSET, 0, body->type, body->subtype,
-                 body->params, disposition, disposition_params, &data, rock);
+                 body->params, disposition, disposition_params, &body->content_guid,
+                 body->part_id, &data, rock);
         buf_free(&data);
 
         if (tmpbody) {
@@ -4181,16 +4624,18 @@ static int body_foreach_section(struct b
         message_parse_charset(body, &encoding, &charset);
         buf_init_ro(&data, message->map.s + body->content_offset, body->content_size);
         r = proc(/*isbody*/1, charset, encoding, body->type, body->subtype,
-                 body->params, NULL, NULL, &data, rock);
+                 body->params, NULL, NULL, &body->content_guid, body->part_id,
+                 &data, rock);
         buf_free(&data);
         charset_free(&charset);
-
         if (r) return r;
     } else {
         buf_init_ro(&data, message->map.s + body->content_offset, body->content_size);
-        r = proc(/*isbody*/1, CHARSET_UNKNOWN_CHARSET, 0,
-                body->type, body->subtype, body->params, NULL, NULL, &data, rock);
+        r = proc(/*isbody*/1, CHARSET_UNKNOWN_CHARSET, encoding_lookupname(body->encoding),
+                 body->type, body->subtype, body->params, NULL, NULL,
+                 &body->content_guid, body->part_id, &data, rock);
         buf_free(&data);
+        if (r) return r;
     }
 
     for (i = 0; i < body->numparts; i++) {
@@ -4198,7 +4643,7 @@ static int body_foreach_section(struct b
         if (r) return r;
     }
 
-    return 0;
+    return r;
 }
 
 
@@ -4217,6 +4662,8 @@ EXPORTED int message_foreach_section(mes
                                      const struct param *type_params,
                                      const char *disposition,
                                      const struct param *disposition_params,
+                                     const struct message_guid *content_guid,
+                                     const char *part,
                                      struct buf *data,
                                      void *rock),
                          void *rock)
@@ -4290,9 +4737,15 @@ EXPORTED const struct index_record *msg_
 EXPORTED int message_get_size(message_t *m, uint32_t *sizep)
 {
     int r = message_need(m, M_RECORD);
-    if (r) return r;
-    *sizep = m->record.size;
-    return 0;
+    if (!r) {
+        *sizep = m->record.size;
+        return 0;
+    }
+    r = message_need(m, M_MAP);
+    if (!r) {
+        *sizep = buf_len(&m->map);
+    }
+    return r;
 }
 
 EXPORTED uint32_t msg_size(const message_t *m)
@@ -4360,8 +4813,16 @@ EXPORTED int msg_msgno(const message_t *
 EXPORTED int message_get_guid(message_t *m, const struct message_guid **guidp)
 {
     int r = message_need(m, M_RECORD);
-    if (r) return r;
-    *guidp = &m->record.guid;
+    if (!r) {
+        *guidp = &m->record.guid;
+        return 0;
+    }
+    if (message_guid_isnull(&m->guid)) {
+        r = message_need(m, M_MAP);
+        if (r) return r;
+        message_guid_generate(&m->guid, buf_base(&m->map), buf_len(&m->map));
+    }
+    *guidp = &m->guid;
     return 0;
 }
 
@@ -4389,6 +4850,14 @@ EXPORTED int message_get_systemflags(mes
     return 0;
 }
 
+EXPORTED int message_get_internalflags(message_t *m, uint32_t *flagsp)
+{
+    int r = message_need(m, M_RECORD);
+    if (r) return r;
+    *flagsp = m->record.internal_flags;
+    return 0;
+}
+
 EXPORTED int message_get_indexflags(message_t *m, uint32_t *flagsp)
 {
     int r = message_need(m, M_INDEX);
@@ -4397,6 +4866,23 @@ EXPORTED int message_get_indexflags(mess
     return 0;
 }
 
+EXPORTED int message_get_savedate(message_t *m, time_t *datep)
+{
+    int r = message_need(m, M_RECORD);
+    if (r) return r;
+    *datep = m->record.savedate;
+    if (!*datep) *datep = m->record.internaldate;
+    return 0;
+}
+
+EXPORTED int message_get_indexversion(message_t *m, uint32_t *versionp)
+{
+    int r = message_need(m, M_MAILBOX);
+    if (r) return r;
+    *versionp = m->mailbox->i.minor_version;
+    return 0;
+}
+
 EXPORTED int message_get_sentdate(message_t *m, time_t *datep)
 {
     int r = message_need(m, M_RECORD);
@@ -4429,31 +4915,47 @@ EXPORTED int message_get_fname(message_t
     return 0;
 }
 
+/* XXX despite the name, this actually gives back ALL the values of the
+ * XXX named header, unless flags contains MESSAGE_LAST
+ */
 static void extract_one(struct buf *buf,
                         const char *name,
-                        int format,
+                        int flags,
                         int has_name,
                         int isutf8,
                         struct buf *raw)
 {
     char *p = NULL;
 
-    if (has_name && !(format & MESSAGE_FIELDNAME)) {
+    if (raw->len && (flags & MESSAGE_LAST)) {
+        /* Skip all but the last header value */
+        const char *q = raw->s;
+        const char *last = raw->s;
+        while ((p = strnchr(q, '\r', raw->s + raw->len - q))) {
+            if (p >= raw->s + raw->len - 2)
+                break;
+            if (*(p+1) == '\n' && *(p+2) && !isspace(*(p+2)))
+                last = p + 2;
+            q = p + 1;
+        }
+        if (last != raw->s)
+            buf_remove(raw, 0, last - raw->s);
+        p = NULL;
+    }
+
+    if (has_name && !(flags & MESSAGE_FIELDNAME)) {
         /* remove the fieldname and colon */
         int pos = buf_findchar(raw, 0, ':');
         assert(pos > 0);
         buf_remove(raw, 0, pos+1);
     }
-    else if (!has_name && (format & MESSAGE_FIELDNAME)) {
+    else if (!has_name && (flags & MESSAGE_FIELDNAME)) {
         /* insert a fieldname and colon */
         buf_insertcstr(raw, 0, ":");
         buf_insertcstr(raw, 0, name);
     }
 
-    if (!(format & MESSAGE_APPEND))
-        buf_reset(buf);
-
-    switch (format & _MESSAGE_FORMAT_MASK) {
+    switch (flags & _MESSAGE_FORMAT_MASK) {
     case MESSAGE_RAW:
         /* Logically, we're appending to the resulting buffer.
          * However if the buf is empty we can save a memory copy
@@ -4497,7 +4999,7 @@ static void extract_one(struct buf *buf,
         break;
     }
 
-    if (format & MESSAGE_TRIM)
+    if (flags & MESSAGE_TRIM)
         buf_trim(buf);
 
     free(p);
@@ -4526,53 +5028,69 @@ EXPORTED int message_get_field(message_t
         return 0;
     }
 
+    if (!(flags & MESSAGE_APPEND))
+        buf_reset(buf);
+
+    /* Attempt to read field from the least-cost source available */
+    int found_field = 0;
+
     /* the 5 standalone cache fields */
     if (!strcasecmp(hdr, "from")) {
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        buf_setmap(&raw, cacheitem_base(&m->record, CACHE_FROM),
-                         cacheitem_size(&m->record, CACHE_FROM));
-        if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
-            buf_reset(&raw);
-        hasname = 0;
-        isutf8 = 1;
+        if (!r) {
+            buf_setmap(&raw, cacheitem_base(&m->record, CACHE_FROM),
+                    cacheitem_size(&m->record, CACHE_FROM));
+            if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
+                buf_reset(&raw);
+            hasname = 0;
+            isutf8 = 1;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
     else if (!strcasecmp(hdr, "to")) {
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        buf_setmap(&raw, cacheitem_base(&m->record, CACHE_TO),
-                         cacheitem_size(&m->record, CACHE_TO));
-        if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
-            buf_reset(&raw);
-        hasname = 0;
-        isutf8 = 1;
+        if (!r) {
+            buf_setmap(&raw, cacheitem_base(&m->record, CACHE_TO),
+                    cacheitem_size(&m->record, CACHE_TO));
+            if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
+                buf_reset(&raw);
+            hasname = 0;
+            isutf8 = 1;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
     else if (!strcasecmp(hdr, "cc")) {
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        buf_setmap(&raw, cacheitem_base(&m->record, CACHE_CC),
-                         cacheitem_size(&m->record, CACHE_CC));
-        if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
-            buf_reset(&raw);
-        hasname = 0;
-        isutf8 = 1;
+        if (!r) {
+            buf_setmap(&raw, cacheitem_base(&m->record, CACHE_CC),
+                    cacheitem_size(&m->record, CACHE_CC));
+            if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
+                buf_reset(&raw);
+            hasname = 0;
+            isutf8 = 1;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
     else if (!strcasecmp(hdr, "bcc")) {
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        buf_setmap(&raw, cacheitem_base(&m->record, CACHE_BCC),
-                         cacheitem_size(&m->record, CACHE_BCC));
-        if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
-            buf_reset(&raw);
-        hasname = 0;
-        isutf8 = 1;
+        if (!r) {
+            buf_setmap(&raw, cacheitem_base(&m->record, CACHE_BCC),
+                    cacheitem_size(&m->record, CACHE_BCC));
+            if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
+                buf_reset(&raw);
+            hasname = 0;
+            isutf8 = 1;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
     else if (!strcasecmp(hdr, "subject")) {
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        message1_get_subject(&m->record, &raw);
-        hasname = 0;
-        isutf8 = 1;
+        if (!r) {
+            message1_get_subject(&m->record, &raw);
+            hasname = 0;
+            isutf8 = 1;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
 
     /* message-id is from the envelope */
@@ -4580,32 +5098,40 @@ EXPORTED int message_get_field(message_t
         char *envtokens[NUMENVTOKENS];
         char *c_env;
         int r = message_need(m, M_CACHE);
-        if (r) return r;
-        c_env = xstrndup(cacheitem_base(&m->record, CACHE_ENVELOPE) + 1,
-                         cacheitem_size(&m->record, CACHE_ENVELOPE) - 2);
-        parse_cached_envelope(c_env, envtokens, NUMENVTOKENS);
-        if (envtokens[ENV_MSGID])
-            buf_appendcstr(&raw, envtokens[ENV_MSGID]);
-        free(c_env);
-        if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
-            buf_reset(&raw);
-        hasname = 0;
-    }
-
-    else if (mailbox_cached_header(hdr) != BIT32_MAX) {
-        /* it's in the cache */
-        char *headers = NULL;
-        int r = message_need(m, M_CACHE);
-        if (r) return r;
-        headers = xstrndup(cacheitem_base(&m->record, CACHE_HEADERS),
-                           cacheitem_size(&m->record, CACHE_HEADERS));
-        strarray_append(&want, hdr);
-        message_pruneheader(headers, &want, NULL);
-        buf_appendcstr(&raw, headers);
-        free(headers);
-        hasname = 1;
+        if (!r) {
+            c_env = xstrndup(cacheitem_base(&m->record, CACHE_ENVELOPE) + 1,
+                    cacheitem_size(&m->record, CACHE_ENVELOPE) - 2);
+            parse_cached_envelope(c_env, envtokens, NUMENVTOKENS);
+            if (envtokens[ENV_MSGID])
+                buf_appendcstr(&raw, envtokens[ENV_MSGID]);
+            free(c_env);
+            if (raw.len == 3 && raw.s[0] == 'N' && raw.s[1] == 'I' && raw.s[2] == 'L')
+                buf_reset(&raw);
+            hasname = 0;
+            found_field = 1;
+        } else if (r != IMAP_NOTFOUND) return r;
     }
     else {
+        int r = message_need(m, M_RECORD);
+        unsigned cache_version = mailbox_cached_header(hdr);
+        if (!r && m->record.cache_version >= cache_version) {
+            /* it's in the cache */
+            char *headers = NULL;
+            int r = message_need(m, M_CACHE);
+            if (r) return r;
+            headers = xstrndup(cacheitem_base(&m->record, CACHE_HEADERS),
+                      cacheitem_size(&m->record, CACHE_HEADERS));
+            strarray_append(&want, hdr);
+            message_pruneheader(headers, &want, NULL);
+            buf_appendcstr(&raw, headers);
+            free(headers);
+            hasname = 1;
+            found_field = 1;
+        } else if (r && r != IMAP_NOTFOUND) return r;
+    }
+
+    if (!found_field) {
+        /* fall back to read field from raw headers */
         char *headers = NULL;
         int r = message_need(m, M_MAP|M_CACHEBODY);
         if (r) return r;
@@ -4615,6 +5141,7 @@ EXPORTED int message_get_field(message_t
         buf_appendcstr(&raw, headers);
         free(headers);
         hasname = 1;
+        found_field = 1;
     }
 
     if (raw.len)
@@ -4630,37 +5157,42 @@ EXPORTED int message_foreach_header(cons
                                     int(*cb)(const char*, const char*, void*),
                                     void *rock)
 {
-    char *tmp, *key;
-    int r;
-
-    tmp = charset_unfold(headers, len, 0);
-    if (!tmp) return IMAP_INTERNAL;
+    struct buf key = BUF_INITIALIZER;
+    struct buf val = BUF_INITIALIZER;
+    const char *top = headers + len;
+    const char *hdr = headers;
+    int r = 0;
 
-    key = tmp;
-    while (key && *key) {
-        /* Look for the key-value separator. */
-        char *val = strchr(key, ':');
-        if (!val || val == key) {
-            break;
+    while (hdr < top) {
+        /* Look for colon separating header name from value */
+        const char *p = memchr(hdr, ':', top - hdr);
+        if (!p) {
+            r = IMAP_INTERNAL;
+            goto done;
         }
-        *val++ = '\0';
-
-        /* Look for end of header. */
-        char *eol = strchr(val, '\r');
-        while (eol && (*++eol != '\n'))
-            eol = strchr(eol, '\r');
-        if (eol) {
-            *(eol-1) = '\0';
-            ++eol;
+        buf_setmap(&key, hdr, p - hdr);
+        p++;
+        /* Extract raw header value, skipping over folding CRLF */
+        const char *q = p;
+        while (q < top && (q = memchr(q, '\n', top - q))) {
+            if ((++q == top) || (*q != ' ' && *q != '\t'))
+                break;
         }
-
-        r = cb(key, val, rock);
+        if (!q) q = top;
+        /* Chomp of trailing CRLF */
+        buf_setmap(&val, p, q - p >= 2 ? q - p - 2 : 0);
+        /* Call callback for header */
+        r = cb(buf_cstring(&key), buf_cstring(&val), rock);
         if (r) break;
-
-        key = eol;
+        /* Prepare next iteration */
+        buf_reset(&key);
+        buf_reset(&val);
+        hdr = q;
     }
 
-    free(tmp);
+done:
+    buf_free(&key);
+    buf_free(&val);
     return r;
 }
 
@@ -4687,3 +5219,19 @@ EXPORTED int message_get_encoding(messag
     *encp = m->body->charset_enc;
     return 0;
 }
+
+EXPORTED int message_get_charset_id(message_t *m, const char **strp)
+{
+    int r = message_need(m, M_CACHEBODY);
+    if (r) return r;
+    *strp = m->body->charset_id;
+    return 0;
+}
+
+EXPORTED int message_get_cachebody(message_t *m, const struct body **bodyp)
+{
+    int r = message_need(m, M_CACHEBODY);
+    if (r) return r;
+    *bodyp = m->body;
+    return 0;
+}
diff -pruN 3.0.13-5/imap/message_guid.c 3.2.0-3/imap/message_guid.c
--- 3.0.13-5/imap/message_guid.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message_guid.c	2020-04-24 02:03:00.000000000 +0000
@@ -63,7 +63,7 @@
  *   be stored on disk.
  *
  * Textual:
- *   Textual represenatation for Message GUID for passing over the wire
+ *   Textual representation for Message GUID for passing over the wire
  *   Currently BASE64 string + '\0'.
  *
  */
@@ -89,17 +89,6 @@ EXPORTED void message_guid_generate(stru
     xsha1((const unsigned char *) msg_base, msg_len, guid->value);
 }
 
-EXPORTED void message_guid_permute32(struct message_guid *guid, uint32_t val)
-{
-    if (message_guid_isnull(guid))
-        return;
-
-    uint32_t base = ntohl(*((uint32_t *)(guid->value + MESSAGE_GUID_SIZE - 4)));
-
-    /* XOR in the 32 bits */
-    *((uint32_t *)(guid->value + MESSAGE_GUID_SIZE - 4)) = base ^ val;
-}
-
 /* message_guid_copy() ***************************************************
  *
  * Copy GUID
@@ -230,7 +219,7 @@ EXPORTED const char *message_guid_import
 EXPORTED const char *message_guid_encode(const struct message_guid *guid)
 {
     static char text[2*MESSAGE_GUID_SIZE+1];
-    int r = bin_to_hex(&guid->value, MESSAGE_GUID_SIZE, text, BH_LOWER);
+    int r = bin_to_lchex(&guid->value, MESSAGE_GUID_SIZE, text);
     assert(r == 2*MESSAGE_GUID_SIZE);
     return text;
 }
diff -pruN 3.0.13-5/imap/message_guid.h 3.2.0-3/imap/message_guid.h
--- 3.0.13-5/imap/message_guid.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message_guid.h	2020-04-24 02:03:00.000000000 +0000
@@ -64,8 +64,6 @@ struct message_guid {
 void message_guid_generate(struct message_guid *guid,
                            const char *msg_base, unsigned long msg_len);
 
-void message_guid_permute32(struct message_guid *guid, uint32_t val);
-
 /* Copy a GUID */
 void message_guid_copy(struct message_guid *dst, const struct message_guid *src);
 
diff -pruN 3.0.13-5/imap/message.h 3.2.0-3/imap/message.h
--- 3.0.13-5/imap/message.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message.h	2020-05-04 03:28:02.000000000 +0000
@@ -43,14 +43,6 @@
 #ifndef INCLUDED_MESSAGE_H
 #define INCLUDED_MESSAGE_H
 
-#ifndef P
-#ifdef __STDC__
-#define P(x) x
-#else
-#define P(x) ()
-#endif
-#endif
-
 #include <stdio.h>
 
 #include "prot.h"
@@ -59,6 +51,9 @@
 #include "util.h"
 #include "charset.h"
 
+/* (draft standard) MIME tspecials */
+#define MIME_TSPECIALS "()<>@,;:\\\"/[]?="
+
 /*
  * Parsed form of a body-part
  */
@@ -126,6 +121,9 @@ struct body {
      */
     char *decoded_body;
 
+    /* Decoded content size, or 0 if unknown */
+    uint32_t decoded_content_size;
+
     /* Message GUID. Only filled in at top level */
     struct message_guid guid;
 };
@@ -136,8 +134,10 @@ struct param {
     char *attribute;
     char *value;
 };
-extern int message_copy_strict P((struct protstream *from, FILE *to,
-                                  unsigned size, int allow_null));
+extern void param_free(struct param **paramp);
+
+extern int message_copy_strict(struct protstream *from, FILE *to,
+                               unsigned size, int allow_null);
 
 extern int message_parse(const char *fname, struct index_record *record);
 
@@ -154,30 +154,35 @@ struct bodypart {
 };
 
 
-extern void parse_cached_envelope P((char *env, char *tokens[], int tokens_size));
+extern void parse_cached_envelope(char *env, char *tokens[], int tokens_size);
 
-extern int message_parse_mapped P((const char *msg_base, unsigned long msg_len,
-                                   struct body *body));
-extern int message_parse_binary_file P((FILE *infile, struct body **body));
-extern int message_parse_file P((FILE *infile,
-                                 const char **msg_base, size_t *msg_len,
-                                 struct body **body));
+extern int message_parse_mapped(const char *msg_base, unsigned long msg_len,
+                                struct body *body, const char *efname);
+extern int message_parse_binary_file(FILE *infile, struct body **body,
+                                     const char *efname);
+extern int message_parse_file(FILE *infile,
+                              const char **msg_base, size_t *msg_len,
+                              struct body **body,
+                              const char *efname);
 extern void message_parse_string(const char *hdr, char **hdrp);
 extern void message_pruneheader(char *buf, const strarray_t *headers,
                                 const strarray_t *headers_not);
-extern void message_fetch_part P((struct message_content *msg,
-                                  const char **content_types,
-                                  struct bodypart ***parts));
+extern void message_fetch_part(struct message_content *msg,
+                               const char **content_types,
+                               struct bodypart ***parts);
 extern void message_write_nstring(struct buf *buf, const char *s);
 extern void message_write_nstring_map(struct buf *buf, const char *s, unsigned int len);
 extern void message_write_body(struct buf *buf, const struct body *body,
                                   int newformat);
 extern void message_write_xdrstring(struct buf *buf, const struct buf *s);
-extern int message_write_cache P((struct index_record *record, const struct body *body));
+extern int message_write_cache(struct index_record *record, const struct body *body);
+
+extern int message_create_record(struct index_record *message_index,
+                                 const struct body *body);
+extern void message_free_body(struct body *body);
 
-extern int message_create_record P((struct index_record *message_index,
-                                    const struct body *body));
-extern void message_free_body P((struct body *body));
+extern void message_parse_type(const char *hdr, char **typep, char **subtypep, struct param **paramp);
+extern void message_parse_disposition(const char *hdr, char **hdpr, struct param **paramp);
 
 /* NOTE - scribbles on its input */
 extern void message_parse_env_address(char *str, struct address *addr);
@@ -187,8 +192,12 @@ extern char *parse_nstring(char **str);
 extern void message_read_bodystructure(const struct index_record *record,
                                        struct body **body);
 
-extern int message_update_conversations(struct conversations_state *, struct index_record *, conversation_t **);
+extern int message_update_conversations(struct conversations_state *, struct mailbox *, struct index_record *, conversation_t **);
 
+/* Call proc for each header in headers, which must contain valid
+ * MIME header bytes. Header keys and values passed to the callback
+ * are zero-terminated strings. Header values are not unfolded and
+ * omit the terminated CR LF sequence. */
 extern int message_foreach_header(const char *headers, size_t len,
                    int (*proc)(const char *key, const char *val, void *rock),
                    void *rock);
@@ -199,8 +208,7 @@ extern int message_foreach_header(const
 typedef struct message message_t;
 struct mailbox;
 
-/* Flags for use as the 'format' argument to
- * message_get_field() and part_get_field(). */
+/* Flags for use as the 'flags' argument to message_get_field(). */
 enum message_format
 {
     /* Original raw octets from the on-the-wire RFC5322 format,
@@ -227,6 +235,7 @@ enum message_format
     /* This flag can be OR'd into the format argument to request that
      * all the fields of the given name are returned.  Normally only
      * the first is returned, which is faster. */
+    /* XXX this flag is not implemented, but is effectively always set! */
     MESSAGE_MULTIPLE=           (1<<6),
 
     /* This flag can be OR'd into the format argument to request that
@@ -234,9 +243,14 @@ enum message_format
      * first. */
     MESSAGE_APPEND=             (1<<7),
 
-    /* This flag can be OR'd into hte format argument to request that
+    /* This flag can be OR'd into the format argument to request that
      * leading and trailing space be trimmed from the buffer */
-    MESSAGE_TRIM=               (1<<8)
+    MESSAGE_TRIM=               (1<<8),
+
+    /* This flag can be OR'd into the format argument to request that
+     * only the last field of the given name is returned.  Normally only
+     * the first is returned, which is faster. */
+    MESSAGE_LAST=               (1<<9),
 };
 
 enum message_indexflags
@@ -256,17 +270,32 @@ extern message_t *message_new_from_index
                                          uint32_t msgno,
                                          uint32_t indexflags);
 extern message_t *message_new_from_filename(const char *filename);
+extern void message_set_from_data(const char *base, size_t len,
+                                  message_t *m);
+extern void message_set_from_mailbox(struct mailbox *mailbox,
+                                     unsigned int recno,
+                                     message_t *m);
+extern void message_set_from_index(struct mailbox *,
+                                   const struct index_record *,
+                                   uint32_t msgno,
+                                   uint32_t indexflags,
+                                   message_t *m);
+extern void message_set_from_record(struct mailbox *,
+                                    const struct index_record *,
+                                    message_t *m);
+
+extern int message_get_indexversion(message_t *m, uint32_t *versionp);
 
 extern message_t *message_ref(message_t *m);
 extern void message_unref(message_t **m);
 
 extern int message_get_field(message_t *m, const char *name,
                              int format, struct buf *buf);
-extern int message_get_header(message_t *m, int format, struct buf *buf);
-extern int message_get_body(message_t *m, int format, struct buf *buf);
+extern int message_get_cachebody(message_t *m, const struct body **bodyp);
+extern int message_get_body(message_t *m, struct buf *buf);
 extern int message_get_type(message_t *m, const char **strp);
 extern int message_get_subtype(message_t *m, const char **strp);
-extern int message_get_charset(message_t *m, int *csp);
+extern int message_get_charset_id(message_t *m, const char **strp);
 extern int message_get_encoding(message_t *m, int *encp);
 extern int message_get_num_parts(message_t *m, unsigned int *np);
 extern int message_get_messageid(message_t *m, struct buf *buf);
@@ -286,8 +315,10 @@ extern int message_get_cid(message_t *m,
 extern int message_get_guid(message_t *m, const struct message_guid **guidp);
 extern int message_get_internaldate(message_t *m, time_t *);
 extern int message_get_spamscore(message_t *m, uint32_t *scorep);
+extern int message_get_savedate(message_t *m, time_t *);
 extern int message_get_sentdate(message_t *m, time_t *);
 extern int message_get_modseq(message_t *m, modseq_t *modseqp);
+extern int message_get_internalflags(message_t *m, uint32_t *flagsp);
 extern int message_get_systemflags(message_t *m, uint32_t *);
 extern int message_get_userflags(message_t *m, uint32_t *flagsp);
 extern int message_get_indexflags(message_t *m, uint32_t *);
@@ -300,6 +331,8 @@ extern int message_foreach_section(messa
                                const struct param *type_params,
                                const char *disposition,
                                const struct param *disposition_params,
+                               const struct message_guid *content_guid,
+                               const char *part,
                                struct buf *data,
                                void *rock),
                    void *rock);
diff -pruN 3.0.13-5/imap/message_priv.h 3.2.0-3/imap/message_priv.h
--- 3.0.13-5/imap/message_priv.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message_priv.h	2020-04-24 02:03:00.000000000 +0000
@@ -90,6 +90,9 @@ struct message
     struct body *body;
     char **envelope;
     struct index_record record;
+
+    /* fallback fields for messages without record */
+    struct message_guid guid;
 };
 
 
diff -pruN 3.0.13-5/imap/message_test.c 3.2.0-3/imap/message_test.c
--- 3.0.13-5/imap/message_test.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/message_test.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/stat.h>
@@ -53,7 +54,6 @@
 /* cyrus includes */
 #include "assert.h"
 #include "bsearch.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "index.h"
 #include "search_engines.h"
@@ -61,7 +61,6 @@
 #include "mailbox.h"
 #include "mboxlist.h"
 #include "message.h"
-#include "sysexits.h"
 #include "util.h"
 #include "xmalloc.h"
 
@@ -116,12 +115,14 @@ static int dump_one_section(int partno,
                             const struct param *type_params __attribute__((unused)),
                             const char *disposition __attribute__((unused)),
                             const struct param *disposition_params __attribute__((unused)),
+                            const struct message_guid *content_guid __attribute__((unused)),
+                            const char *part __attribute__((unused)),
                             struct buf *data,
                             void *rock __attribute__((unused)))
 {
 #define MAX_TEXT    512
     printf("SECTION partno=%d length=%llu subtype=%s charset=%s encoding=%s\n",
-            partno, (unsigned long long)data->len, subtype, charset_name(charset), encoding_name(encoding));
+            partno, (unsigned long long)data->len, subtype, charset_alias_name(charset), encoding_name(encoding));
     dump_buf(stdout, data);
     return 0;
 #undef MAX_TEXT
@@ -203,9 +204,6 @@ int main(int argc, char **argv)
 
     cyrus_init(alt_config, "message_test", 0, CONFIG_NEED_PARTITION_DATA);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     if (mboxname && record_flag) {
         struct mailbox *mailbox = NULL;
         struct index_record record;
@@ -292,9 +290,6 @@ int main(int argc, char **argv)
         buf_free(&buf);
     }
 
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return r;
@@ -309,7 +304,7 @@ static int usage(const char *name)
     fprintf(stderr, "-p         dump message part tree\n");
     fprintf(stderr, "-s         dump text sections\n");
     fprintf(stderr, "-t         dump output from search text receiver\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 void fatal(const char* s, int code)
diff -pruN 3.0.13-5/imap/msgrecord.c 3.2.0-3/imap/msgrecord.c
--- 3.0.13-5/imap/msgrecord.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/msgrecord.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,805 @@
+/* msgrecord.c -- Message records encapsulate message metadata
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include <assert.h>
+#include <stdint.h>
+#include <syslog.h>
+
+#include "mailbox.h"
+#include "msgrecord.h"
+
+/* generated headers are not necessarily in current directory */
+#include "imap/imap_err.h"
+
+struct msgrecord {
+    int refcount;
+    int isappend;
+
+    uint32_t have;
+    struct mailbox *mbox;
+    struct index_record record;
+    message_t *msg;
+    annotate_state_t *annot_state;
+};
+
+#define M_MAILBOX       (1<<0)      /* an open mailbox* */
+#define M_RECORD        (1<<2)      /* a valid index_record */
+#define M_RECNO         (1<<3)      /* valid UID in index_record */
+#define M_UID           (1<<4)      /* valid UID in index_record */
+#define M_CACHE         (1<<5)      /* mmap()ed cyrus.cache */
+#define M_MESSAGE       (1<<16)     /* message object - not in message_priv */
+#define M_ANNOTATIONS   (1<<17)     /* annotations - not in message_priv */
+#define M_ALL           (~0U)       /* everything */
+
+static int msgrecord_need(msgrecord_t *mr, unsigned int need)
+{
+#define is_missing(flags)    ((need & ~(mr->have)) & (flags))
+#define found(flags)         (mr->have |= (flags))
+    int r = 0;
+
+    if (!is_missing(M_ALL))
+        return 0;       /* easy, we already have it */
+
+    if (is_missing(M_MAILBOX)) {
+        /* We can't get this for ourselves,
+         * it needs to be passed in by the caller */
+        return IMAP_NOTFOUND;
+    }
+
+    if (is_missing(M_RECORD)) {
+        assert(!mr->isappend);
+        r = msgrecord_need(mr, M_MAILBOX);
+        if (r) return r;
+
+        if (is_missing(M_RECNO) && is_missing(M_UID)) {
+            /* need some way to find the record! */
+            return IMAP_NOTFOUND;
+        }
+        r = mailbox_reload_index_record(mr->mbox, &mr->record);
+        if (r) return r;
+
+        found(M_RECORD|M_RECNO|M_UID);
+    }
+
+    if (is_missing(M_MESSAGE)) {
+        r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+
+        mr->msg = message_new_from_record(mr->mbox, &mr->record);
+        if (mr->msg) {
+            found(M_MESSAGE);
+        }
+        // else error??
+    }
+
+    if (is_missing(M_CACHE)) {
+        r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+        r = mailbox_cacherecord(mr->mbox, &mr->record);
+        if (r) return r;
+        found(M_CACHE);
+    }
+
+    if (is_missing(M_ANNOTATIONS)) {
+        if (mr->isappend) {
+            syslog(LOG_ERR, "msgrecord: msgrecord msut be appended");
+            return IMAP_NOTFOUND;
+        }
+        r = msgrecord_need(mr, M_MAILBOX|M_UID);
+        if (r) return r;
+        r = mailbox_get_annotate_state(mr->mbox, mr->record.uid, &mr->annot_state);
+        if (r) return r;
+        found(M_ANNOTATIONS);
+    }
+
+#undef is_missing
+#undef found
+
+    return r;
+}
+
+EXPORTED msgrecord_t *msgrecord_new(struct mailbox *mbox)
+{
+    msgrecord_t *mr = xzmalloc(sizeof(struct msgrecord));
+
+    mr->mbox = mbox;
+    mr->have = M_MAILBOX|M_RECORD;
+    mr->refcount++;
+    mr->isappend = 1;
+
+    return mr;
+}
+
+EXPORTED msgrecord_t *msgrecord_from_uid(struct mailbox *mbox, uint32_t uid)
+{
+    msgrecord_t *mr = xzmalloc(sizeof(struct msgrecord));
+
+    mr->mbox = mbox;
+    mr->record.uid = uid;
+    mr->have = M_MAILBOX|M_UID;
+    mr->refcount++;
+    mr->isappend = 0;
+
+    return mr;
+}
+
+EXPORTED void msgrecord_set_from_recno(struct mailbox *mbox, uint32_t recno, msgrecord_t *mr)
+{
+    assert(mr->refcount == 1);
+
+    memset(mr, 0, sizeof(msgrecord_t));
+    mr->mbox = mbox;
+    mr->record.recno = recno;
+    mr->have = M_MAILBOX|M_RECNO;
+    mr->isappend = 0;
+    mr->refcount = 1;
+}
+
+EXPORTED msgrecord_t *msgrecord_from_recno(struct mailbox *mbox, uint32_t recno)
+{
+    msgrecord_t *mr = xzmalloc(sizeof(struct msgrecord));
+
+    mr->mbox = mbox;
+    mr->record.recno = recno;
+    mr->have = M_MAILBOX|M_RECNO;
+    mr->refcount++;
+    mr->isappend = 0;
+
+    return mr;
+}
+
+EXPORTED msgrecord_t *msgrecord_from_index_record(struct mailbox *mbox,
+                                                  struct index_record *record)
+{
+    assert(record->recno);
+    assert(record->uid);
+
+    msgrecord_t *mr = xzmalloc(sizeof(struct msgrecord));
+
+    mr->mbox = mbox;
+    mr->record = *record; // copy all the fields
+    mr->have = M_MAILBOX|M_UID|M_RECNO|M_RECORD;
+    mr->refcount++;
+    mr->isappend = 0;
+
+    return mr;
+}
+
+EXPORTED msgrecord_t *msgrecord_copy_msgrecord(struct mailbox *mbox,
+                                               msgrecord_t *mr)
+{
+    /* need to have record, annotations and cache read in before we copy */
+    assert(!msgrecord_need(mr, M_RECORD|M_CACHE|M_ANNOTATIONS));
+
+    msgrecord_t *res = msgrecord_from_index_record(mbox ? mbox : mr->mbox, &mr->record);
+    /* new records are appends */
+    res->isappend = 1;
+
+    /* these were for the old record, so wipe them */
+    res->have &= ~(M_UID|M_RECNO);
+    res->record.uid = 0;
+    res->record.recno = 0;
+
+    return res;
+}
+
+
+static void msgrecord_free(msgrecord_t *mr)
+{
+    if (mr->msg) message_unref(&mr->msg);
+    free(mr);
+}
+
+EXPORTED void msgrecord_unref(msgrecord_t **mrp)
+{
+    msgrecord_t *mr;
+
+    if (!mrp) return;
+    mr = (msgrecord_t*) *mrp;
+    if (!mr) return;
+
+    assert(mr->refcount >= 1);
+    if (--mr->refcount == 0) {
+        msgrecord_free(mr);
+    }
+    *mrp = NULL;
+}
+
+EXPORTED int msgrecord_get_systemflags(msgrecord_t *mr, uint32_t *flags)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *flags = mr->record.system_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_internalflags(msgrecord_t *mr, uint32_t *flags)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *flags = mr->record.internal_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_userflags(msgrecord_t *mr,
+                                     uint32_t flags[MAX_USER_FLAGS/32])
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    memcpy(flags, mr->record.user_flags, sizeof(uint32_t)*(MAX_USER_FLAGS/32));
+    return 0;
+}
+
+EXPORTED int msgrecord_hasflag(msgrecord_t *mr, const char *flag, int *has)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *has = mailbox_record_hasflag(mr->mbox, &mr->record, flag);
+    return 0;
+}
+
+EXPORTED int msgrecord_get_internaldate(msgrecord_t *mr, time_t *t)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *t = mr->record.internaldate;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_savedate(msgrecord_t *mr, time_t *t)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    if (mr->record.savedate)
+        *t = mr->record.savedate;
+    else
+        *t = mr->record.internaldate;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_lastupdated(msgrecord_t *mr, time_t *t)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *t = mr->record.last_updated;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_cid(msgrecord_t *mr, bit64 *cid)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *cid = mr->record.cid;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_size(msgrecord_t *mr, uint32_t *size)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *size = mr->record.size;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_header_size(msgrecord_t *mr, uint32_t *header_size)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *header_size = mr->record.header_size;
+    return 0;
+
+}
+
+EXPORTED int msgrecord_get_guid(msgrecord_t *mr, struct message_guid *guid)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *guid = mr->record.guid;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_uid(msgrecord_t *mr, uint32_t *uid)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *uid = mr->record.uid;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_modseq(msgrecord_t *mr, modseq_t *modseq)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *modseq = mr->record.modseq;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_createdmodseq(msgrecord_t *mr, modseq_t *modseq)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *modseq = mr->record.createdmodseq;
+    return 0;
+}
+
+EXPORTED int msgrecord_load_cache(msgrecord_t *mr)
+{
+    return msgrecord_need(mr, M_CACHE);
+}
+
+EXPORTED int msgrecord_get_cache_version(msgrecord_t *mr, int *cache_version)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *cache_version = mr->record.cache_version;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_cache_env(msgrecord_t *mr, int token, char **tok)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *tok = mailbox_cache_get_env(mr->mbox, &mr->record, token);
+    return 0;
+}
+
+EXPORTED int msgrecord_get_cache_item(msgrecord_t *mr, int field, char **item)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    *item = xstrndup(cacheitem_base(&mr->record, field),
+                     cacheitem_size(&mr->record, field));
+    return 0;
+}
+
+EXPORTED int msgrecord_get_mailbox(msgrecord_t *mr, struct mailbox **mboxp)
+{
+    int r = msgrecord_need(mr, M_MAILBOX);
+    if (r) return r;
+    *mboxp = mr->mbox;
+    return 0;
+}
+
+
+EXPORTED int msgrecord_get_message(msgrecord_t *mr, message_t **msg)
+{
+    int r = msgrecord_need(mr, M_MESSAGE);
+    if (r) return r;
+    *msg = mr->msg;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_messageid(msgrecord_t *mr, struct buf *buf)
+{
+    int r = msgrecord_need(mr, M_MESSAGE);
+    if (r) return r;
+    return message_get_messageid(mr->msg, buf);
+}
+
+EXPORTED int msgrecord_get_body(msgrecord_t *mr, struct buf *buf)
+{
+    int  r;
+    if (!mr->isappend) {
+        r = msgrecord_need(mr, M_CACHE);
+        if (r) return r;
+    }
+
+    /* Map the message into memory */
+    r = mailbox_map_record(mr->mbox, &mr->record, buf);
+    if (r) return r;
+
+    return 0;
+}
+
+EXPORTED int msgrecord_extract_bodystructure(msgrecord_t *mr, struct body **body)
+{
+    int r = msgrecord_need(mr, M_CACHE);
+    if (r) return r;
+    message_read_bodystructure(&mr->record, body);
+    return 0;
+}
+
+EXPORTED int msgrecord_get_index_record(msgrecord_t *mr,
+                                        struct index_record *record)
+{
+    int r = msgrecord_need(mr, M_RECORD);
+    if (r) return r;
+    *record = mr->record;
+    return 0;
+}
+
+EXPORTED int msgrecord_get_fname(msgrecord_t *mr, const char **fname)
+{
+    int r = msgrecord_need(mr, M_RECORD);
+    if (r) return r;
+    *fname = mailbox_record_fname(mr->mbox, &mr->record);
+    return 0;
+}
+
+
+EXPORTED int msgrecord_annot_lookup(msgrecord_t *mr, const char *entry,
+                                    const char *userid, struct buf *value)
+{
+    int r = msgrecord_need(mr, M_MAILBOX|M_UID|M_ANNOTATIONS);
+    if (r) return r;
+
+    return annotatemore_msg_lookup(mr->mbox->name, mr->record.uid, entry, userid, value);
+}
+
+
+EXPORTED int msgrecord_annot_findall(msgrecord_t *mr,
+                                     const char *entry,
+                                     annotatemore_find_proc_t proc,
+                                     void *rock)
+{
+    int r = msgrecord_need(mr, M_MAILBOX|M_UID|M_ANNOTATIONS);
+    if (r) return r;
+    return annotatemore_findall(mr->mbox->name, mr->record.uid, entry, /*modseq*/0,
+                                proc, rock, /*flags*/0);
+}
+
+EXPORTED int msgrecord_annot_set_auth(msgrecord_t *mr, int isadmin,
+                                      const char *userid,
+                                      const struct auth_state *authstate)
+{
+    int r = msgrecord_need(mr, M_ANNOTATIONS);
+    if (r) return r;
+    annotate_state_begin(mr->annot_state); /* safe to call multiple times */
+    annotate_state_set_auth(mr->annot_state, isadmin, userid, authstate);
+    return 0;
+}
+
+EXPORTED int msgrecord_annot_write(msgrecord_t *mr,
+                                   const char *entry,
+                                   const char *userid,
+                                   const struct buf *value)
+{
+    int r = msgrecord_need(mr, M_ANNOTATIONS);
+    if (r) return r;
+    annotate_state_begin(mr->annot_state);
+
+    return annotate_state_write(mr->annot_state, entry, userid, value);
+}
+
+EXPORTED int msgrecord_annot_writeall(msgrecord_t *mr, struct entryattlist *l)
+{
+    int r = msgrecord_need(mr, M_ANNOTATIONS);
+    if (r) return r;
+    annotate_state_begin(mr->annot_state);
+
+    return annotate_state_store(mr->annot_state, l);
+}
+
+EXPORTED int msgrecord_extract_annots(msgrecord_t *mr,
+                                      struct entryattlist **annots)
+{
+    int r = msgrecord_need(mr, M_MAILBOX|M_RECORD|M_ANNOTATIONS);
+    if (r) return r;
+    // XXX - is there a way to get error return?
+    *annots = mailbox_extract_annots(mr->mbox, &mr->record);
+    return 0;
+}
+
+EXPORTED int msgrecord_extract_flags(msgrecord_t *mr,
+                                     const char *userid,
+                                     strarray_t **flags)
+{
+    int r = msgrecord_need(mr, M_MAILBOX|M_RECORD);
+    if (r) return r;
+    *flags = mailbox_extract_flags(mr->mbox, &mr->record, userid);
+    return *flags == NULL ? IMAP_INTERNAL : 0;
+}
+
+EXPORTED int msgrecord_get_index_record_rw(msgrecord_t *mr,
+                                           struct index_record **record)
+{
+    int r = msgrecord_need(mr, M_MAILBOX);
+    if (r) return r;
+
+    assert(mailbox_index_islocked(mr->mbox, 1));
+
+    r = msgrecord_need(mr, M_RECORD);
+    if (r) return r;
+    *record = &mr->record;
+    return 0;
+}
+
+EXPORTED int msgrecord_add_systemflags(msgrecord_t *mr, uint32_t system_flags)
+{
+    mr->record.system_flags |= system_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_add_internalflags(msgrecord_t *mr, uint32_t internal_flags)
+{
+    mr->record.internal_flags |= internal_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_uid(msgrecord_t *mr, uint32_t uid)
+{
+    assert(mr->isappend);
+    int r = msgrecord_need(mr, M_MAILBOX);
+    if (r) return r;
+    assert(mailbox_index_islocked(mr->mbox, 1));
+    assert(mr->mbox->i.last_uid < uid);
+    mr->record.uid = uid;
+    mr->have |= M_UID;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_cid(msgrecord_t *mr, bit64 cid)
+{
+    mr->record.cid = cid;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_systemflags(msgrecord_t *mr, uint32_t system_flags)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.system_flags = system_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_internalflags(msgrecord_t *mr, uint32_t internal_flags)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.internal_flags = internal_flags;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_userflags(msgrecord_t *mr,
+                                     uint32_t user_flags[MAX_USER_FLAGS/32])
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    memcpy(mr->record.user_flags, user_flags, sizeof(uint32_t)*(MAX_USER_FLAGS/32));
+    return 0;
+}
+
+EXPORTED int msgrecord_set_userflag(msgrecord_t *mr, uint32_t userflag, int val)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    if (val)
+        mr->record.user_flags[userflag/32] |= 1<<(userflag&31);
+    else
+        mr->record.user_flags[userflag/32] &= ~(1<<(userflag&31));
+    return 0;
+}
+
+EXPORTED int msgrecord_set_cache_offset(msgrecord_t *mr, size_t offset)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.cache_offset = offset;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_internaldate(msgrecord_t *mr, time_t internaldate)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.internaldate = internaldate;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_savedate(msgrecord_t *mr, time_t savedate)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.savedate = savedate;
+    return 0;
+}
+
+EXPORTED int msgrecord_set_bodystructure(msgrecord_t *mr, struct body *body)
+{
+    return message_create_record(&mr->record, body);
+}
+
+EXPORTED int msgrecord_set_createdmodseq(msgrecord_t *mr, modseq_t modseq)
+{
+    if (!mr->isappend) {
+        int r = msgrecord_need(mr, M_RECORD);
+        if (r) return r;
+    }
+    mr->record.createdmodseq = modseq;
+    return 0;
+}
+
+EXPORTED int msgrecord_should_archive(msgrecord_t *mr, void *rock)
+{
+    return mailbox_should_archive(mr->mbox, &mr->record, rock);
+}
+
+/* mailbox.c code goes here */
+
+static int msgrecord_find_internal(struct mailbox *mbox,
+                                           uint32_t uid,
+                                           uint32_t recno,
+                                           msgrecord_t **mrp)
+{
+    int r = 0;
+    msgrecord_t *mr = NULL;
+    struct buf buf = BUF_INITIALIZER;
+
+    assert(uid || recno);
+
+    /* lookup the message record */
+    if (recno) {
+        mr = msgrecord_from_recno(mbox, recno);
+    }
+    else {
+        mr = msgrecord_from_uid(mbox, uid);
+    }
+    /* make sure we have an index_record */
+    r = msgrecord_need(mr, M_RECORD);
+    if (r) {
+        msgrecord_unref(&mr);
+        goto done;
+    }
+    mr->isappend = 0;
+    *mrp = mr;
+
+done:
+    buf_free(&buf);
+    return r;
+}
+
+EXPORTED int msgrecord_find(struct mailbox *mbox,
+                            uint32_t uid,
+                            msgrecord_t **mrp)
+{
+    return msgrecord_find_internal(mbox, uid, /*recno*/0, mrp);
+}
+
+EXPORTED int msgrecord_find_latest(struct mailbox *mbox, msgrecord_t **mr)
+{
+
+   return msgrecord_find_internal(mbox, mbox->i.last_uid, /*recno*/0, mr);
+}
+
+EXPORTED int msgrecord_find_index_record(struct mailbox *mbox,
+                                         struct index_record record,
+                                         msgrecord_t **mrp)
+{
+    int r;
+    msgrecord_t *mr = NULL;
+
+    r = record.recno ?
+        msgrecord_find_internal(mbox, 0, record.recno, &mr) :
+        msgrecord_find_internal(mbox, record.uid, 0, &mr);
+    if (r) goto done;
+    *mrp = mr;
+
+done:
+    return r;
+}
+
+static int msgrecord_save(msgrecord_t *mr)
+{
+    int r = 0;
+
+    if (!mailbox_index_islocked(mr->mbox, 1)) {
+        syslog(LOG_ERR, "msgrecord: need mailbox lock to save %s:%d",
+                mr->mbox->name, mr->record.uid);
+        return IMAP_INTERNAL;
+    }
+    if (mr->isappend) {
+        r = mailbox_append_index_record(mr->mbox, &mr->record);
+        mr->isappend = 0;
+    }
+    else {
+        r = msgrecord_need(mr, M_RECORD);
+        if (!r) r = mailbox_rewrite_index_record(mr->mbox, &mr->record);
+    }
+    return r;
+}
+
+EXPORTED int msgrecord_append(msgrecord_t *mr)
+{
+    if (!mr->isappend) {
+        syslog(LOG_ERR, "msgrecord: can't append, record %s:%d already exists",
+                mr->mbox->name, mr->record.uid);
+        return IMAP_INTERNAL;
+    }
+    return msgrecord_save(mr);
+}
+
+EXPORTED int msgrecord_rewrite(msgrecord_t *mr)
+{
+    if (mr->isappend) {
+        syslog(LOG_ERR, "msgrecord: can't rewrite, record must be appended");
+        return IMAP_INTERNAL;
+    }
+    return msgrecord_save(mr);
+}
diff -pruN 3.0.13-5/imap/msgrecord.h 3.2.0-3/imap/msgrecord.h
--- 3.0.13-5/imap/msgrecord.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/msgrecord.h	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,136 @@
+/* msgrecord.h -- Message records encapsulate message metadata
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef INCLUDED_MSGRECORD_H
+#define INCLUDED_MSGRECORD_H
+
+#include "annotate.h"
+
+typedef struct msgrecord msgrecord_t;
+struct mailbox;
+
+extern int msgrecord_find(struct mailbox *mbox, uint32_t uid, msgrecord_t **mr);
+extern int msgrecord_find_index_record(struct mailbox *mbox, struct index_record record,
+                                       msgrecord_t **mrp);
+extern int msgrecord_append(msgrecord_t *mr);
+extern int msgrecord_rewrite(msgrecord_t *mr);
+
+extern msgrecord_t *msgrecord_new(struct mailbox *mbox);
+extern msgrecord_t *msgrecord_from_uid(struct mailbox *mbox, uint32_t uid);
+extern msgrecord_t *msgrecord_from_recno(struct mailbox *mbox, uint32_t recno);
+extern msgrecord_t *msgrecord_from_index_record(struct mailbox *mbox, struct index_record *record);
+extern msgrecord_t *msgrecord_copy_msgrecord(struct mailbox *mbox, msgrecord_t *mr);
+extern void msgrecord_unref(msgrecord_t **mr);
+
+extern void msgrecord_set_from_recno(struct mailbox *mbox, uint32_t recno, msgrecord_t *mr);
+
+/* Getters: all pointer values are owned by msgrecord */
+extern int msgrecord_get_body(msgrecord_t *mr, struct buf *buf);
+extern int msgrecord_get_cid(msgrecord_t *mr, bit64 *cid);
+extern int msgrecord_get_guid(msgrecord_t *mr, struct message_guid *guid);
+extern int msgrecord_get_uid(msgrecord_t *mr, uint32_t *uid);
+extern int msgrecord_get_messageid(msgrecord_t *mr, struct buf *buf);
+extern int msgrecord_get_modseq(msgrecord_t *mr, modseq_t *modseq);
+extern int msgrecord_get_createdmodseq(msgrecord_t *mr, modseq_t *modseq);
+extern int msgrecord_get_internaldate(msgrecord_t *mr, time_t *t);
+extern int msgrecord_get_savedate(msgrecord_t *mr, time_t *t);
+extern int msgrecord_get_lastupdated(msgrecord_t *mr, time_t *t);
+extern int msgrecord_get_message(msgrecord_t *mr, message_t **msg);
+extern int msgrecord_get_size(msgrecord_t *mr, uint32_t *size);
+extern int msgrecord_get_header_size(msgrecord_t *mr, uint32_t *header_size);
+extern int msgrecord_get_systemflags(msgrecord_t *mr, uint32_t *flags);
+extern int msgrecord_get_internalflags(msgrecord_t *mr, uint32_t *flags);
+extern int msgrecord_hasflag(msgrecord_t *mr, const char *flag, int *has);
+extern int msgrecord_get_index_record(msgrecord_t *mr, struct index_record *record);
+extern int msgrecord_get_index_record_rw(msgrecord_t *mr, struct index_record **record);
+extern int msgrecord_get_userflags(msgrecord_t *mr, uint32_t user_flags[MAX_USER_FLAGS/32]);
+extern int msgrecord_get_fname(msgrecord_t *mr, const char **fname);
+extern int msgrecord_get_cache_version(msgrecord_t *mr, int *cache_version);
+extern int msgrecord_get_cache_env(msgrecord_t *mr, int token, char **tok);
+extern int msgrecord_get_cache_item(msgrecord_t *mr, int field, char **item);
+extern int msgrecord_get_mailbox(msgrecord_t *mr, struct mailbox **mailboxptr);
+
+/* Extract: all pointer values are owned by caller */
+extern int msgrecord_extract_flags(msgrecord_t *mr, const char *userid, strarray_t **flags);
+extern int msgrecord_extract_bodystructure(msgrecord_t *mr, struct body **body);
+
+extern int msgrecord_load_cache(msgrecord_t *mr);
+
+/* Setters and mutating functions */
+
+// TODO(rsto): also strarray variant */
+extern int msgrecord_set_systemflags(msgrecord_t *mr, uint32_t system_flags);
+extern int msgrecord_add_systemflags(msgrecord_t *mr, uint32_t system_flags);
+extern int msgrecord_set_internalflags(msgrecord_t *mr, uint32_t internal_flags);
+extern int msgrecord_add_internalflags(msgrecord_t *mr, uint32_t internal_flags);
+extern int msgrecord_set_userflags(msgrecord_t *mr, uint32_t user_flags[MAX_USER_FLAGS/32]);
+extern int msgrecord_set_userflag(msgrecord_t *mr, uint32_t user_flag, int bit);
+extern int msgrecord_set_uid(msgrecord_t *mr, uint32_t uid);
+extern int msgrecord_set_cid(msgrecord_t *mr, bit64 cid);
+extern int msgrecord_set_bodystructure(msgrecord_t *mr, struct body *body);
+extern int msgrecord_set_internaldate(msgrecord_t *mr, time_t internaldate);
+extern int msgrecord_set_savedate(msgrecord_t *mr, time_t savedate);
+extern int msgrecord_set_cache_offset(msgrecord_t *mr, size_t offset);
+extern int msgrecord_set_createdmodseq(msgrecord_t *mr, modseq_t modseq);
+
+/* A light-weight layer above annotations. */
+extern int msgrecord_annot_lookup(msgrecord_t *mr, const char *entry,
+                                  const char *userid, struct buf *value);
+extern int msgrecord_annot_findall(msgrecord_t *mr, const char *entry,
+                                   annotatemore_find_proc_t proc,
+                                   void *rock);
+extern int msgrecord_annot_write(msgrecord_t *mr, const char *entry,
+                                 const char *userid, const struct buf *value);
+extern int msgrecord_annot_writeall(msgrecord_t *mr, struct entryattlist *l);
+
+extern int msgrecord_annot_set_auth(msgrecord_t *mr, int isadmin,
+                                    const char *userid,
+                                    const struct auth_state *authstate);
+
+extern int msgrecord_extract_annots(msgrecord_t *mr,
+                                    struct entryattlist **annots);
+
+/* misc */
+extern int msgrecord_should_archive(msgrecord_t *mr, void *rock);
+
+
+#endif /* INCLUDED_MSGRECORD_H */
diff -pruN 3.0.13-5/imap/mupdate.c 3.2.0-3/imap/mupdate.c
--- 3.0.13-5/imap/mupdate.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mupdate.c	2020-04-24 02:03:00.000000000 +0000
@@ -51,6 +51,7 @@
 #include <ctype.h>
 #include <signal.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <errno.h>
 
@@ -75,7 +76,6 @@
 
 #include "strarray.h"
 #include "assert.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mailbox.h"
 #include "mboxlist.h"
@@ -136,15 +136,7 @@ struct conn {
 
     char clienthost[NI_MAXHOST*2+1];
 
-    struct
-    {
-        char *ipremoteport;
-        char ipremoteport_buf[60];
-        char *iplocalport;
-        char iplocalport_buf[60];
-        sasl_ssf_t ssf;
-        char *authid;
-    } saslprops;
+    struct saslprops_t saslprops;
 
     /* UPDATE command handling */
     const char *streaming; /* tag */
@@ -281,20 +273,16 @@ static struct conn *conn_new(int fd)
     strlcpy(C->clienthost, clienthost, sizeof(C->clienthost));
 
     if (localip && remoteip) {
-        strlcpy(C->saslprops.ipremoteport_buf, remoteip,
-                sizeof(C->saslprops.ipremoteport_buf));
-        C->saslprops.ipremoteport = C->saslprops.ipremoteport_buf;
-        strlcpy(C->saslprops.iplocalport_buf, remoteip,
-                sizeof(C->saslprops.iplocalport_buf));
-        C->saslprops.iplocalport = C->saslprops.iplocalport_buf;
+        buf_setcstr(&C->saslprops.ipremoteport, remoteip);
+        buf_setcstr(&C->saslprops.iplocalport, localip);
     }
     pthread_mutex_unlock(&clienthost_mutex); /* UNLOCK */
 
     /* create sasl connection */
     r = sasl_server_new("mupdate",
                         config_servername, NULL,
-                        C->saslprops.iplocalport,
-                        C->saslprops.ipremoteport,
+                        buf_cstringnull_ifempty(&C->saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&C->saslprops.ipremoteport),
                         NULL, 0,
                         &C->saslconn);
     if (r != SASL_OK) {
@@ -310,13 +298,6 @@ static struct conn *conn_new(int fd)
     /* set my allowable security properties */
     sasl_setprop(C->saslconn, SASL_SEC_PROPS, mysasl_secprops(SASL_SEC_NOANONYMOUS));
 
-    /* Clear Buffers */
-    memset(&(C->tag), 0, sizeof(struct buf));
-    memset(&(C->cmd), 0, sizeof(struct buf));
-    memset(&(C->arg1), 0, sizeof(struct buf));
-    memset(&(C->arg2), 0, sizeof(struct buf));
-    memset(&(C->arg3), 0, sizeof(struct buf));
-
     return C;
 }
 
@@ -384,7 +365,7 @@ static void conn_free(struct conn *C)
 
     if (C->saslconn) sasl_dispose(&C->saslconn);
 
-    if (C->saslprops.authid) free(C->saslprops.authid);
+    saslprops_free(&C->saslprops);
 
     /* free struct bufs */
     buf_free(&(C->tag));
@@ -497,34 +478,34 @@ int service_init(int argc, char **argv,
     int opt, autoselect = 0;
     pthread_t t;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
 
     /* Do minor configuration checking */
     workers_to_start = config_getint(IMAPOPT_MUPDATE_WORKERS_START);
 
     if (config_getint(IMAPOPT_MUPDATE_WORKERS_MAX) < config_getint(IMAPOPT_MUPDATE_WORKERS_MINSPARE)) {
         syslog(LOG_CRIT, "Maximum total worker threads is less than minimum spare worker threads");
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     if (workers_to_start < config_getint(IMAPOPT_MUPDATE_WORKERS_MINSPARE)) {
         syslog(LOG_CRIT, "Starting worker threads is less than minimum spare worker threads");
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     if (config_getint(IMAPOPT_MUPDATE_WORKERS_MAXSPARE) < workers_to_start) {
         syslog(LOG_CRIT, "Maximum spare worker threads is less than starting worker threads");
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     if (config_getint(IMAPOPT_MUPDATE_WORKERS_MINSPARE) > workers_to_start) {
         syslog(LOG_CRIT, "Minimum spare worker threads is greater than starting worker threads");
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     if (config_getint(IMAPOPT_MUPDATE_WORKERS_MAX) < workers_to_start) {
         syslog(LOG_CRIT, "Maximum total worker threads is less than starting worker threads");
-        return EC_SOFTWARE;
+        return EX_SOFTWARE;
     }
 
     /* set signal handlers */
@@ -556,12 +537,12 @@ int service_init(int argc, char **argv,
          * to the slave.  We can probably fix this by prepending
          * config_servername onto the entries before updating the slaves.
          */
-        fatal("cannot run mupdate master on a unified server", EC_USAGE);
+        fatal("cannot run mupdate master on a unified server", EX_USAGE);
     }
 
     if (pipe(conn_pipe) == -1) {
         syslog(LOG_ERR, "could not setup connection signaling pipe %m");
-        return EC_OSERR;
+        return EX_OSERR;
     }
 
     database_init();
@@ -578,7 +559,7 @@ int service_init(int argc, char **argv,
             pthread_detach(t);
         } else {
             syslog(LOG_ERR, "could not start client thread");
-            return EC_SOFTWARE;
+            return EX_SOFTWARE;
         }
 
         /* Wait until they sync the database */
@@ -594,7 +575,7 @@ int service_init(int argc, char **argv,
             pthread_detach(t);
         } else {
             syslog(LOG_ERR, "could not start placebo kick thread");
-            return EC_SOFTWARE;
+            return EX_SOFTWARE;
         }
 
         mupdate_ready();
@@ -607,7 +588,7 @@ int service_init(int argc, char **argv,
             pthread_detach(t);
         } else {
             syslog(LOG_ERR, "could not start client thread");
-            return EC_SOFTWARE;
+            return EX_SOFTWARE;
         }
     }
 
@@ -1031,7 +1012,7 @@ int service_main_fd(int fd,
 
         syslog(LOG_CRIT,
                "write to conn_pipe to signal new connection failed: %m");
-        return EC_TEMPFAIL;
+        return EX_TEMPFAIL;
     }
     return 0;
 }
@@ -1055,7 +1036,7 @@ static void dobanner(struct conn *c)
     if (!masterp) {
         if (!config_mupdate_server)
             fatal("mupdate server was not specified for slave",
-                  EC_TEMPFAIL);
+                  EX_TEMPFAIL);
 
         snprintf(slavebuf, sizeof(slavebuf), "mupdate://%s",
                  config_mupdate_server);
@@ -1079,7 +1060,7 @@ static void dobanner(struct conn *c)
     prot_printf(c->pout,
                 "* OK MUPDATE \"%s\" \"Cyrus IMAP\" \"%s\" \"%s\"\r\n",
                 config_servername,
-                cyrus_version(), masterp ? "(master)" : slavebuf);
+                CYRUS_VERSION, masterp ? "(master)" : slavebuf);
 
     prot_flush(c->pout);
 }
@@ -1199,7 +1180,7 @@ static void *thread_main(void *rock __at
         if (prot_select(protin, conn_pipe[0],
                        &protout, &connflag, NULL) == -1) {
             syslog(LOG_ERR, "prot_select() failed in thread_main: %m");
-            fatal("prot_select() failed in thread_main", EC_TEMPFAIL);
+            fatal("prot_select() failed in thread_main", EX_TEMPFAIL);
         }
 
         /* we've got work to do */
@@ -1238,7 +1219,7 @@ static void *thread_main(void *rock __at
             if (read(conn_pipe[0], &new_fd, sizeof(new_fd)) == -1) {
                 syslog(LOG_CRIT,
                        "read from conn_pipe for new connection failed: %m");
-                fatal("conn_pipe read failed", EC_TEMPFAIL);
+                fatal("conn_pipe read failed", EX_TEMPFAIL);
             }
         } else {
             new_fd = NO_NEW_CONNECTION;
@@ -1362,7 +1343,7 @@ static void *thread_main(void *rock __at
             if (write(conn_pipe[1], &NO_NEW_CONNECTION,
                      sizeof(NO_NEW_CONNECTION)) == -1) {
                 fatal("write to conn_pipe to signal docmd done failed",
-                      EC_TEMPFAIL);
+                      EX_TEMPFAIL);
             }
         }
 
@@ -1391,10 +1372,6 @@ static void *thread_main(void *rock __at
 static void database_init(void)
 {
     pthread_mutex_lock(&mailboxes_mutex); /* LOCK */
-
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     pthread_mutex_unlock(&mailboxes_mutex); /* UNLOCK */
 }
 
@@ -1508,6 +1485,7 @@ static void cmd_authenticate(struct conn
 
     if (r) {
         const char *errorstring = NULL;
+        const char *userid = "-notset-";
 
         switch (r) {
         case IMAP_SASL_CANCEL:
@@ -1522,14 +1500,17 @@ static void cmd_authenticate(struct conn
                         tag, errorstring ? errorstring : "");
             break;
         default:
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
 
-            syslog(LOG_ERR, "badlogin: %s %s %s",
+            if (r != SASL_NOUSER)
+                sasl_getprop(C->saslconn, SASL_USERNAME, (const void **) &userid);
+
+            syslog(LOG_ERR, "badlogin: %s %s (%s) [%s]",
                    C->clienthost,
-                   mech, sasl_errdetail(C->saslconn));
+                   mech, userid, sasl_errdetail(C->saslconn));
 
             prot_printf(C->pout, "%s NO \"%s\"\r\n", tag,
                         sasl_errstring((r == SASL_NOUSER ? SASL_BADAUTH : r),
@@ -1879,7 +1860,7 @@ static void cmd_list(struct conn *C, con
     if (C->list_prefix) C->list_prefix_len = strlen(C->list_prefix);
     else C->list_prefix_len = 0;
 
-    mboxlist_allmbox("", sendupdate, (void*)C, /*incdel*/0);
+    mboxlist_allmbox("", sendupdate, (void*)C, /*flags*/0);
 
     C->streaming = NULL;
     C->list_prefix = NULL;
@@ -1926,7 +1907,7 @@ static void cmd_startupdate(struct conn
     C->streaming_hosts = partial;
 
     /* dump initial list */
-    mboxlist_allmbox("", sendupdate, (void*)C, /*incdel*/0);
+    mboxlist_allmbox("", sendupdate, (void*)C, /*flags*/0);
 
     pthread_mutex_unlock(&mailboxes_mutex); /* UNLOCK */
 
@@ -1978,13 +1959,6 @@ static void sendupdates(struct conn *C,
 static void cmd_starttls(struct conn *C, const char *tag)
 {
     int result;
-    int *layerp;
-
-    char *auth_id;
-    sasl_ssf_t ssf;
-
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
 
     result=tls_init_serverengine("mupdate",
                                  5,        /* depth to verify */
@@ -2007,8 +1981,7 @@ static void cmd_starttls(struct conn *C,
     result=tls_start_servertls(C->pin->fd, /* read */
                                C->pout->fd, /* write */
                                180, /* 3 minutes */
-                               layerp,
-                               &auth_id,
+                               &C->saslprops,
                                &C->tlsconn);
 
     /* if error */
@@ -2021,22 +1994,10 @@ static void cmd_starttls(struct conn *C,
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(C->saslconn, SASL_SSF_EXTERNAL, &ssf);
+    result = saslprops_set_tls(&C->saslprops, C->saslconn);
     if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
+        fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
     }
-    C->saslprops.ssf = ssf;
-
-    result = sasl_setprop(C->saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
-    }
-    if (C->saslprops.authid) {
-        free(C->saslprops.authid);
-        C->saslprops.authid = NULL;
-    }
-    if (auth_id)
-        C->saslprops.authid = xstrdup(auth_id);
 
     /* tell the prot layer about our new layers */
     prot_settls(C->pin, C->tlsconn);
@@ -2054,7 +2015,7 @@ void cmd_starttls(struct conn *C __attri
                   const char *tag __attribute__((unused)))
 {
     fatal("cmd_starttls() executed, but starttls isn't implemented!",
-          EC_SOFTWARE);
+          EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
 
@@ -2098,7 +2059,7 @@ void cmd_compress(struct conn *C __attri
                   const char *alg __attribute__((unused)))
 {
     fatal("cmd_compress() executed, but COMPRESS isn't implemented!",
-          EC_SOFTWARE);
+          EX_SOFTWARE);
 }
 #endif /* HAVE_ZLIB */
 
@@ -2120,19 +2081,10 @@ static int reset_saslconn(struct conn *c
 
     sasl_dispose(&c->saslconn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("mupdate", config_servername,
-                         NULL, NULL, NULL,
-                         NULL, 0, &c->saslconn);
-    if (ret != SASL_OK) return ret;
-
-    if (c->saslprops.ipremoteport)
-       ret = sasl_setprop(c->saslconn, SASL_IPREMOTEPORT,
-                          c->saslprops.ipremoteport);
-    if (ret != SASL_OK) return ret;
-
-    if (c->saslprops.iplocalport)
-       ret = sasl_setprop(c->saslconn, SASL_IPLOCALPORT,
-                          c->saslprops.iplocalport);
+    ret = sasl_server_new("mupdate", config_servername, NULL,
+                          buf_cstringnull_ifempty(&c->saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&c->saslprops.ipremoteport),
+                          NULL, 0, &c->saslconn);
     if (ret != SASL_OK) return ret;
 
     secprops = mysasl_secprops(SASL_SEC_NOANONYMOUS);
@@ -2142,14 +2094,9 @@ static int reset_saslconn(struct conn *c
 
     /* If we have TLS/SSL info, set it */
     if (c->saslprops.ssf) {
-        ret = sasl_setprop(c->saslconn, SASL_SSF_EXTERNAL, &c->saslprops.ssf);
+        ret = saslprops_set_tls(&c->saslprops, c->saslconn);
     }
     if (ret != SASL_OK) return ret;
-
-    if (c->saslprops.authid) {
-        ret = sasl_setprop(c->saslconn, SASL_AUTH_EXTERNAL, c->saslprops.authid);
-        if (ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -2406,13 +2353,13 @@ int mupdate_synchronize(struct mbent_que
 
     rock.boxes = &local_boxes;
 
-    mboxlist_allmbox("", sync_findall_cb, (void*)&rock, /*incdel*/0);
+    mboxlist_allmbox("", sync_findall_cb, (void*)&rock, /*flags*/0);
 
     /* Traverse both lists, compare the names */
     /* If they match, ensure that location and acl are correct, if so,
        move on, if not, fix them */
     /* If the local is before the next remote, delete it */
-    /* If the next remote is before theis local, insert it and try again */
+    /* If the next remote is before the local, insert it and try again */
     for(l = local_boxes.head, r = remote_boxes->head; l && r;
         l = local_boxes.head, r = remote_boxes->head)
     {
@@ -2559,7 +2506,7 @@ void mupdate_ready(void)
 
     if (ready_for_connections) {
         syslog(LOG_CRIT, "mupdate_ready called when already ready");
-        fatal("mupdate_ready called when already ready", EC_TEMPFAIL);
+        fatal("mupdate_ready called when already ready", EX_TEMPFAIL);
     }
 
     ready_for_connections = 1;
diff -pruN 3.0.13-5/imap/mupdate-client.c 3.2.0-3/imap/mupdate-client.c
--- 3.0.13-5/imap/mupdate-client.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mupdate-client.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,6 +48,7 @@
 #include <ctype.h>
 #include <sasl/sasl.h>
 #include <sasl/saslutil.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <stdarg.h>
 #ifdef HAVE_UNISTD_H
@@ -62,7 +63,6 @@
 #include <sys/select.h>
 #endif
 
-#include "exitcodes.h"
 #include "global.h"
 #include "mupdate.h"
 #include "prot.h"
@@ -108,7 +108,7 @@ EXPORTED int mupdate_connect(const char
     if (!server) {
         server = config_mupdate_server;
         if (server == NULL) {
-            fatal("couldn't get mupdate server name", EC_UNAVAILABLE);
+            fatal("couldn't get mupdate server name", EX_UNAVAILABLE);
         }
     }
 
@@ -791,7 +791,7 @@ EXPORTED void kick_mupdate(void)
         syslog(LOG_ERR, "kick_mupdate: configured socket path '%s' is too long"
                         " (maximum length is " SIZE_T_FMT ")",
                         buf_cstring(&addrbuf), sizeof(srvaddr.sun_path) - 1);
-        fatal("socket path too long", EC_CONFIG);
+        fatal("socket path too long", EX_CONFIG);
     }
 
     memset((char *)&srvaddr, 0, sizeof(srvaddr));
diff -pruN 3.0.13-5/imap/mupdate-client.h 3.2.0-3/imap/mupdate-client.h
--- 3.0.13-5/imap/mupdate-client.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mupdate-client.h	2020-04-24 02:03:00.000000000 +0000
@@ -95,7 +95,7 @@ int mupdate_find(mupdate_handle *handle,
 /* Callbacks for mupdate_scarf and mupdate_list */
 /* cmd is one of DELETE, MAILBOX, RESERVE */
 /* context is as provided to mupdate_scarf */
-/* FIXME/xxx: "cmd" can probabally go away and instead
+/* FIXME/xxx: "cmd" can probably go away and instead
  * we just use the t in mdata */
 typedef int (*mupdate_callback)(struct mupdate_mailboxdata *mdata,
                                 const char *cmd, void *context);
diff -pruN 3.0.13-5/imap/mupdate-slave.c 3.2.0-3/imap/mupdate-slave.c
--- 3.0.13-5/imap/mupdate-slave.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/mupdate-slave.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #include <signal.h>
 #include <sasl/sasl.h>
 #include <sasl/saslutil.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <stdarg.h>
 #ifdef HAVE_UNISTD_H
@@ -67,7 +68,6 @@
 #include "global.h"
 #include "mpool.h"
 #include "mupdate.h"
-#include "exitcodes.h"
 
 /* Returns file descriptor of kick socket (or does not return) */
 static int open_kick_socket(void)
@@ -80,7 +80,7 @@ static int open_kick_socket(void)
     s = socket(AF_UNIX, SOCK_STREAM, 0);
     if (s == -1) {
         syslog(LOG_ERR, "socket: %m");
-        fatal("socket failed", EC_OSERR);
+        fatal("socket failed", EX_OSERR);
     }
 
     strlcpy(fnamebuf, config_dir, sizeof(fnamebuf));
@@ -97,12 +97,12 @@ static int open_kick_socket(void)
     chmod(fnamebuf, 0777); /* for DUX */
     if (r == -1) {
         syslog(LOG_ERR, "bind: %s: %m", fnamebuf);
-        fatal("bind failed", EC_OSERR);
+        fatal("bind failed", EX_OSERR);
     }
     r = listen(s, 10);
     if (r == -1) {
         syslog(LOG_ERR, "listen: %m");
-        fatal("listen failed", EC_OSERR);
+        fatal("listen failed", EX_OSERR);
     }
 
     return s;
@@ -298,12 +298,12 @@ void *mupdate_client_start(void *rock __
     srand(time(NULL) * getpid());
 
     if(!config_mupdate_server) {
-        fatal("couldn't get mupdate server name", EC_UNAVAILABLE);
+        fatal("couldn't get mupdate server name", EX_UNAVAILABLE);
     }
 
     retry_delay = config_getint(IMAPOPT_MUPDATE_RETRY_DELAY);
     if(retry_delay < 0) {
-        fatal("invalid value for mupdate_retry_delay", EC_UNAVAILABLE);
+        fatal("invalid value for mupdate_retry_delay", EX_UNAVAILABLE);
     }
 
     while(1) {
diff -pruN 3.0.13-5/imap/nntpd.c 3.2.0-3/imap/nntpd.c
--- 3.0.13-5/imap/nntpd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/nntpd.c	2020-04-24 02:03:00.000000000 +0000
@@ -63,6 +63,7 @@
 #include <sys/types.h>
 #include <sys/wait.h>
 #include <sys/param.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -80,7 +81,6 @@
 #include "auth.h"
 #include "backend.h"
 #include "duplicate.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "hash.h"
 #include "idle.h"
@@ -236,13 +236,7 @@ extern int saslserver(sasl_conn_t *conn,
                       struct protstream *pin, struct protstream *pout,
                       int *sasl_result, char **success_data);
 
-static struct
-{
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 static struct sasl_callback mysasl_cb[] = {
     { SASL_CB_GETOPT, (mysasl_cb_ft *) &mysasl_config, NULL },
@@ -312,7 +306,7 @@ static int read_response(struct backend
     if (!prot_fgets(buf, sizeof(buf), s->in)) {
         /* uh oh */
         if (s == backend_current && !force_notfatal)
-            fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+            fatal("Lost connection to selected backend", EX_UNAVAILABLE);
         proxy_downserver(s);
         return IMAP_SERVER_UNAVAILABLE;
     }
@@ -331,7 +325,7 @@ static int pipe_to_end_of_response(struc
         if (!prot_fgets(buf, sizeof(buf), s->in)) {
             /* uh oh */
             if (s == backend_current && !force_notfatal)
-                fatal("Lost connection to selected backend", EC_UNAVAILABLE);
+                fatal("Lost connection to selected backend", EX_UNAVAILABLE);
             proxy_downserver(s);
             return IMAP_SERVER_UNAVAILABLE;
         }
@@ -411,19 +405,7 @@ static void nntp_reset(void)
     nntp_tls_comp = NULL;
     nntp_starttls_done = 0;
 
-    if(saslprops.iplocalport) {
-       free(saslprops.iplocalport);
-       saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-       free(saslprops.ipremoteport);
-       saslprops.ipremoteport = NULL;
-    }
-    if(saslprops.authid) {
-       free(saslprops.authid);
-       saslprops.authid = NULL;
-    }
-    saslprops.ssf = 0;
+    saslprops_reset(&saslprops);
 
     nntp_exists = 0;
     nntp_current = 0;
@@ -443,7 +425,7 @@ int service_init(int argc __attribute__(
 
     initialize_nntp_error_table();
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -463,21 +445,9 @@ int service_init(int argc __attribute__(
     if (duplicate_init(NULL) != 0) {
         syslog(LOG_ERR,
                "unable to init duplicate delivery database\n");
-        fatal("unable to init duplicate delivery database", EC_SOFTWARE);
+        fatal("unable to init duplicate delivery database", EX_SOFTWARE);
     }
 
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for expunge */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* open the user deny db */
-    denydb_init(0);
-    denydb_open(0);
-
     /* setup for sending IMAP IDLE notifications */
     idle_init();
 
@@ -488,7 +458,7 @@ int service_init(int argc __attribute__(
             if (!tls_enabled()) {
                 syslog(LOG_ERR, "nntps: required OpenSSL options not present");
                 fatal("nntps: required OpenSSL options not present",
-                      EC_CONFIG);
+                      EX_CONFIG);
             }
             break;
 
@@ -509,10 +479,6 @@ int service_init(int argc __attribute__(
         }
     }
 
-    /* Initialize the annotatemore extention */
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
     newsmaster = (char *) config_getstring(IMAPOPT_NEWSMASTER);
     newsmaster_authstate = auth_newstate(newsmaster);
 
@@ -538,8 +504,6 @@ int service_main(int argc __attribute__(
 
     signals_poll();
 
-    sync_log_init();
-
     nntp_in = prot_new(0, 0);
     nntp_out = prot_new(1, 1);
     protgroup_insert(protin, nntp_in);
@@ -547,27 +511,26 @@ int service_main(int argc __attribute__(
     /* Find out name of client host */
     nntp_clienthost = get_clienthost(0, &localip, &remoteip);
 
+    if (localip && remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, remoteip);
+        buf_setcstr(&saslprops.iplocalport, localip);
+    }
+
     /* other params should be filled in */
-    if (sasl_server_new("nntp", config_servername, NULL, NULL, NULL,
+    if (sasl_server_new("nntp", config_servername, NULL,
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
                         NULL, SASL_SUCCESS_DATA, &nntp_saslconn) != SASL_OK)
-        fatal("SASL failed initializing: sasl_server_new()",EC_TEMPFAIL);
+        fatal("SASL failed initializing: sasl_server_new()",EX_TEMPFAIL);
 
     /* will always return something valid */
     secprops = mysasl_secprops(0);
     sasl_setprop(nntp_saslconn, SASL_SEC_PROPS, secprops);
     sasl_setprop(nntp_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf);
 
-    if (localip) {
-        sasl_setprop(nntp_saslconn, SASL_IPLOCALPORT, localip);
-        saslprops.iplocalport = xstrdup(localip);
-    }
-
     if (remoteip) {
         char hbuf[NI_MAXHOST], *p;
 
-        sasl_setprop(nntp_saslconn, SASL_IPREMOTEPORT, remoteip);
-        saslprops.ipremoteport = xstrdup(remoteip);
-
         /* Create pre-authentication telemetry log based on client IP */
         strlcpy(hbuf, remoteip, NI_MAXHOST);
         if ((p = strchr(hbuf, ';'))) *p = '\0';
@@ -577,9 +540,8 @@ int service_main(int argc __attribute__(
     nntp_tls_required = config_getswitch(IMAPOPT_TLS_REQUIRED);
 
     /* Set inactivity timer */
-    nntp_timeout = config_getint(IMAPOPT_NNTPTIMEOUT);
-    if (nntp_timeout < 3) nntp_timeout = 3;
-    nntp_timeout *= 60;
+    nntp_timeout = config_getduration(IMAPOPT_NNTPTIMEOUT, 'm');
+    if (nntp_timeout < 3 * 60) nntp_timeout = 3 * 60;
     prot_settimeout(nntp_in, nntp_timeout);
     prot_setflushonread(nntp_in, nntp_out);
 
@@ -594,7 +556,7 @@ int service_main(int argc __attribute__(
     }
     if (config_serverinfo) prot_printf(nntp_out, " %s", config_servername);
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-        prot_printf(nntp_out, " Cyrus NNTP %s", cyrus_version());
+        prot_printf(nntp_out, " Cyrus NNTP %s", CYRUS_VERSION);
     }
     if (shutdown) {
         prot_printf(nntp_out, "server unavailable, %s\r\n", unavail);
@@ -625,7 +587,7 @@ static void usage(void)
 {
     prot_printf(nntp_out, "503 usage: nntpd [-C <alt_config>] [-s]\r\n");
     prot_flush(nntp_out);
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /*
@@ -653,22 +615,8 @@ void shut_down(int code)
     }
     if (backend_cached) free(backend_cached);
 
-    sync_log_done();
-
     duplicate_done();
 
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    denydb_close();
-    denydb_done();
-
-    annotatemore_close();
-    annotate_done();
-
     idle_done();
 
     partlist_local_done();
@@ -693,6 +641,8 @@ void shut_down(int code)
     if (newsgroups) free_wildmats(newsgroups);
     auth_freestate(newsmaster_authstate);
 
+    saslprops_free(&saslprops);
+
     cyrus_done();
 
     exit(code);
@@ -725,20 +675,12 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("nntp", config_servername,
-                         NULL, NULL, NULL,
-                         NULL, SASL_SUCCESS_DATA, conn);
+    ret = sasl_server_new("nntp", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                          NULL, SASL_SUCCESS_DATA, conn);
     if(ret != SASL_OK) return ret;
 
-    if(saslprops.ipremoteport)
-       ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                          saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-       ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                          saslprops.iplocalport);
-    if(ret != SASL_OK) return ret;
     secprops = mysasl_secprops(0);
     ret = sasl_setprop(*conn, SASL_SEC_PROPS, secprops);
     if(ret != SASL_OK) return ret;
@@ -746,17 +688,12 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if(saslprops.ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     } else {
         ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &extprops_ssf);
     }
 
     if(ret != SASL_OK) return ret;
-
-    if(saslprops.authid) {
-       ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-       if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -1601,7 +1538,7 @@ static int getuserpass(struct protstream
         }
         buf_putc(buf, c);
         if (buf_len(buf) > MAX_NNTP_ARG) {
-            fatal("argument too long", EC_IOERR);
+            fatal("argument too long", EX_IOERR);
         }
     }
 }
@@ -1828,7 +1765,7 @@ static void cmd_capabilities(char *keywo
     prot_printf(nntp_out, "VERSION 2\r\n");
     if (nntp_authstate || (config_serverinfo == IMAP_ENUM_SERVERINFO_ON)) {
         prot_printf(nntp_out,
-                    "IMPLEMENTATION Cyrus NNTP %s\r\n", cyrus_version());
+                    "IMPLEMENTATION Cyrus NNTP %s\r\n", CYRUS_VERSION);
     }
 
     /* add STARTTLS */
@@ -1972,7 +1909,7 @@ static void cmd_article(int part, char *
                     break;
                 }
                 else if (part == ARTICLE_BODY) {
-                    /* start outputing text */
+                    /* start outputting text */
                     output = 1;
                     continue;
                 }
@@ -2081,9 +2018,9 @@ static void cmd_authinfo_pass(char *pass
                             strlen(nntp_userid),
                             pass,
                             strlen(pass))!=SASL_OK) {
-        syslog(LOG_NOTICE, "badlogin: %s plaintext %s %s",
+        syslog(LOG_NOTICE, "badlogin: %s plaintext (%s) [%s]",
                nntp_clienthost, nntp_userid, sasl_errdetail(nntp_saslconn));
-        failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+        failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
         if (failedloginpause != 0) {
             sleep(failedloginpause);
         }
@@ -2188,6 +2125,7 @@ static void cmd_authinfo_sasl(char *cmd,
     if (r) {
         int code;
         const char *errorstring = NULL;
+        const char *userid = "-notset-";
 
         switch (r) {
         case IMAP_SASL_CANCEL:
@@ -2218,10 +2156,13 @@ static void cmd_authinfo_sasl(char *cmd,
                 code = 481;
             }
 
-            syslog(LOG_NOTICE, "badlogin: %s %s [%s]",
-                   nntp_clienthost, mech, sasl_errdetail(nntp_saslconn));
+            if (sasl_result != SASL_NOUSER)
+                sasl_getprop(nntp_saslconn, SASL_USERNAME, (const void **) &userid);
+
+            syslog(LOG_NOTICE, "badlogin: %s %s (%s) [%s]",
+                   nntp_clienthost, mech, userid, sasl_errdetail(nntp_saslconn));
 
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
@@ -2608,7 +2549,9 @@ static int newsgroups_cb(const char *mai
                   uint32_t uid __attribute__((unused)),
                   const char *entry __attribute__((unused)),
                   const char *userid,
-                  const struct buf *value, void *rock)
+                  const struct buf *value,
+                  const struct annotate_metadata *mdata __attribute__((unused)),
+                  void *rock)
 {
     struct wildmat *wild = (struct wildmat *) rock;
 
@@ -2723,8 +2666,8 @@ static void cmd_list(char *arg1, char *a
 
         strcpy(pattern, newsprefix);
         strcat(pattern, "*");
-        annotatemore_findall(pattern, 0, "/comment",
-                             newsgroups_cb, lrock.wild);
+        annotatemore_findall(pattern, 0, "/comment", /*modseq*/0,
+                             newsgroups_cb, lrock.wild, /*flags*/0);
 
         prot_printf(nntp_out, ".\r\n");
 
@@ -2779,7 +2722,7 @@ static void cmd_mode(char *arg)
             prot_printf(nntp_out, " %s", config_servername);
         }
         if (nntp_authstate || (config_serverinfo == IMAP_ENUM_SERVERINFO_ON)) {
-            prot_printf(nntp_out, " Cyrus NNTP %s", cyrus_version());
+            prot_printf(nntp_out, " Cyrus NNTP %s", CYRUS_VERSION);
         }
         prot_printf(nntp_out, " server ready, posting %s\r\n",
                     (nntp_capa & MODE_READ) ? "allowed" : "prohibited");
@@ -3122,9 +3065,9 @@ static int savemsg(message_data_t *m, FI
     /* get date */
     if ((body = spool_getheader(m->hdrcache, "date")) == NULL) {
         /* no date, create one */
-        char datestr[RFC822_DATETIME_MAX+1];
+        char datestr[RFC5322_DATETIME_MAX+1];
 
-        time_to_rfc822(now, datestr, sizeof(datestr));
+        time_to_rfc5322(now, datestr, sizeof(datestr));
         m->date = xstrdup(datestr);
         fprintf(f, "Date: %s\r\n", datestr);
         spool_cache_header(xstrdup("Date"), xstrdup(datestr), m->hdrcache);
@@ -3363,7 +3306,7 @@ static int deliver(message_data_t *msg)
             if (!r) {
                 prot_rewind(msg->data);
                 if (stage) {
-                    r = append_fromstage(&as, &body, stage, 0,
+                    r = append_fromstage(&as, &body, stage, 0, 0,
                                          NULL, !singleinstance,
                                          /*annotations*/NULL);
                 } else {
@@ -3461,7 +3404,7 @@ static int rmgroup(message_data_t *msg)
 
     if (!r) r = mboxlist_deletemailbox(mailboxname, 0,
                                        newsmaster, newsmaster_authstate,
-                                       1, 0, 0);
+                                       1, 0, 0, 0);
 
     if (!r) sync_log_mailbox(mailboxname);
 
@@ -3475,6 +3418,7 @@ static int mvgroup(message_data_t *msg)
     char *group;
     char oldmailboxname[MAX_MAILBOX_BUFFER];
     char newmailboxname[MAX_MAILBOX_BUFFER];
+    struct mbentry_t *mbentry = NULL;
 
     /* isolate old newsgroup */
     group = msg->control + 7; /* skip "mvgroup" */
@@ -3492,8 +3436,12 @@ static int mvgroup(message_data_t *msg)
     snprintf(newmailboxname, sizeof(newmailboxname), "%s%.*s",
              newsprefix, (int)len, group);
 
-    r = mboxlist_renamemailbox(oldmailboxname, newmailboxname, NULL, 0,
-                               newsmaster, newsmaster_authstate, 0, 0, 0);
+    r = mlookup(oldmailboxname, &mbentry);
+    if (r) return r;
+
+    r = mboxlist_renamemailbox(mbentry, newmailboxname, NULL, 0,
+                               newsmaster, newsmaster_authstate, 0, 0, 0, 0, 0);
+    mboxlist_entry_free(&mbentry);
 
     /* XXX check body of message for useful MIME parts */
 
@@ -3831,23 +3779,12 @@ static void feedpeer(char *peer, message
 
 static void news2mail(message_data_t *msg)
 {
-    struct buf attrib = BUF_INITIALIZER;
+    struct buf attrib = BUF_INITIALIZER, msgbuf = BUF_INITIALIZER;
     int n, r;
-    FILE *sm;
-    static strarray_t smbuf = STRARRAY_INITIALIZER;
-    static int smbuf_basic_count;
-    int sm_stat;
-    pid_t sm_pid;
     char buf[4096], to[1024] = "";
 
-    if (!smbuf.count) {
-        strarray_append(&smbuf, "sendmail");
-        strarray_append(&smbuf, "-i");          /* ignore dots */
-        strarray_append(&smbuf, "-f");
-        strarray_append(&smbuf, "<>");
-        strarray_append(&smbuf, "--");
-        smbuf_basic_count = smbuf.count;
-    }
+    smtp_envelope_t sm_env = SMTP_ENVELOPE_INITIALIZER;
+    smtp_envelope_set_from(&sm_env, "<>");
 
     for (n = 0; n < msg->rcpt.count ; n++) {
         /* see if we want to send this to a mailing list */
@@ -3857,10 +3794,9 @@ static void news2mail(message_data_t *ms
                                 &attrib);
         if (r) continue;
 
-        /* add the email address to our argv[] and to our To: header */
+        /* add the email address to the RCPT envelope and to our To: header */
         if (attrib.s) {
-            strarray_append(&smbuf, buf_cstring(&attrib));
-
+            smtp_envelope_add_rcpt(&sm_env, buf_cstring(&attrib));
             if (to[0]) strlcat(to, ", ", sizeof(to));
             strlcat(to, buf_cstring(&attrib), sizeof(to));
         }
@@ -3868,11 +3804,13 @@ static void news2mail(message_data_t *ms
     buf_free(&attrib);
 
     /* send the message */
-    if (smbuf.count > smbuf_basic_count) {
-        sm_pid = open_sendmail((const char **)smbuf.data, &sm);
+    if (sm_env.rcpts.count) {
+        smtpclient_t *sm = NULL;
 
-        if (!sm)
-            syslog(LOG_ERR, "news2mail: could not spawn sendmail process");
+        r = smtpclient_open(&sm);
+
+        if (r)
+            syslog(LOG_ERR, "news2mail: could not open SMTP client: %s", error_message(r));
         else {
             int body = 0, skip, found_to = 0;
 
@@ -3884,7 +3822,7 @@ static void news2mail(message_data_t *ms
                     body = 1;
 
                     /* insert a To: header if the message doesn't have one */
-                    if (!found_to) fprintf(sm, "To: %s\r\n", to);
+                    if (!found_to) buf_printf(&msgbuf, "To: %s\r\n", to);
                 }
 
                 skip = 0;
@@ -3892,7 +3830,7 @@ static void news2mail(message_data_t *ms
                     /* munge various news-specific headers */
                     if (!strncasecmp(buf, "Newsgroups:", 11)) {
                         /* rename Newsgroups: to X-Newsgroups: */
-                        fprintf(sm, "X-");
+                        buf_appendcstr(&msgbuf, "X-");
                     } else if (!strncasecmp(buf, "Xref:", 5) ||
                                !strncasecmp(buf, "Path:", 5) ||
                                !strncasecmp(buf, "NNTP-Posting-", 13)) {
@@ -3901,7 +3839,7 @@ static void news2mail(message_data_t *ms
                     } else if (!strncasecmp(buf, "To:", 3)) {
                         /* insert our mailing list RCPTs first, and then
                            fold the header to accomodate the original RCPTs */
-                        fprintf(sm, "To: %s,\r\n", to);
+                        buf_printf(&msgbuf, "To: %s,\r\n", to);
                         /* overwrite the original "To:" with spaces */
                         memset(buf, ' ', 3);
                         found_to = 1;
@@ -3912,26 +3850,29 @@ static void news2mail(message_data_t *ms
                 }
 
                 do {
-                    if (!skip) fprintf(sm, "%s", buf);
+                    if (!skip) buf_appendcstr(&msgbuf, buf);
                 } while (buf[strlen(buf)-1] != '\n' &&
                          fgets(buf, sizeof(buf), msg->f));
             }
 
             /* Protect against messages not ending in CRLF */
-            if (buf[strlen(buf)-1] != '\n') fprintf(sm, "\r\n");
-
-            fclose(sm);
-            while (waitpid(sm_pid, &sm_stat, 0) < 0);
+            if (buf[strlen(buf)-1] != '\n') buf_appendcstr(&msgbuf, "\r\n");
 
-            if (sm_stat) /* sendmail exit value */
-                syslog(LOG_ERR, "news2mail failed: %s",
-                       sendmail_errstr(sm_stat));
         }
 
-        /* free the RCPTs */
-        strarray_truncate(&smbuf, smbuf_basic_count);
+        r = smtpclient_open(&sm);
+        if (!r) {
+            r = smtpclient_send(sm, &sm_env, &msgbuf);
+        }
+        if (r) {
+            syslog(LOG_ERR, "news2mail failed: %s", error_message(r));
+        }
+        smtpclient_close(&sm);
     }
 
+    smtp_envelope_fini(&sm_env);
+    buf_free(&msgbuf);
+
     return;
 }
 
@@ -4064,9 +4005,6 @@ static void cmd_post(char *msgid, int mo
 static void cmd_starttls(int nntps)
 {
     int result;
-    int *layerp;
-    sasl_ssf_t ssf;
-    char *auth_id;
 
     if (nntp_starttls_done == 1) {
         prot_printf(nntp_out, "502 %s\r\n",
@@ -4079,9 +4017,6 @@ static void cmd_starttls(int nntps)
         return;
     }
 
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
-
     result=tls_init_serverengine("nntp",
                                  5,        /* depth to verify */
                                  !nntps,   /* can client auth? */
@@ -4094,7 +4029,7 @@ static void cmd_starttls(int nntps)
         if (nntps == 0)
             prot_printf(nntp_out, "580 %s\r\n", "Error initializing TLS");
         else
-            fatal("tls_init() failed",EC_TEMPFAIL);
+            fatal("tls_init() failed",EX_TEMPFAIL);
 
         return;
     }
@@ -4109,8 +4044,7 @@ static void cmd_starttls(int nntps)
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                nntps ? 180 : nntp_timeout,
-                               layerp,
-                               &auth_id,
+                               &saslprops,
                                &tls_conn);
 
     /* if error */
@@ -4126,28 +4060,16 @@ static void cmd_starttls(int nntps)
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(nntp_saslconn, SASL_SSF_EXTERNAL, &ssf);
-    if (result == SASL_OK) {
-        saslprops.ssf = ssf;
-        result = sasl_setprop(nntp_saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    }
-
+    result = saslprops_set_tls(&saslprops, nntp_saslconn);
     if (result != SASL_OK) {
-        syslog(LOG_NOTICE, "sasl_setprop() failed: cmd_starttls()");
+        syslog(LOG_NOTICE, "saslprops_set_tls() failed: cmd_starttls()");
         if (nntps == 0) {
-            fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
+            fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
         } else {
             shut_down(0);
         }
     }
 
-    if(saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
-    }
-    if(auth_id)
-        saslprops.authid = xstrdup(auth_id);
-
     /* tell the prot layer about our new layers */
     prot_settls(nntp_in, tls_conn);
     prot_settls(nntp_out, tls_conn);
@@ -4171,7 +4093,7 @@ static void cmd_starttls(int nntps)
 static void cmd_starttls(int nntps __attribute__((unused)))
 {
     /* XXX should never get here */
-    fatal("cmd_starttls() called, but no OpenSSL", EC_SOFTWARE);
+    fatal("cmd_starttls() called, but no OpenSSL", EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
 
diff -pruN 3.0.13-5/imap/notify.c 3.2.0-3/imap/notify.c
--- 3.0.13-5/imap/notify.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/notify.c	2020-05-04 03:28:02.000000000 +0000
@@ -47,6 +47,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <syslog.h>
+#include <sys/mman.h>
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
@@ -69,8 +70,6 @@
 
 #define FNAME_NOTIFY_SOCK "/socket/notify"
 
-#define NOTIFY_MAXSIZE 8192
-
 static int add_arg(char *buf, int max_size, const char *arg, int *buflen)
 {
     const char *myarg = (arg ? arg : "");
@@ -153,78 +152,6 @@ out:
     dlist_free(&res);
 }
 
-EXPORTED int notify_at(time_t when, const char *method,
-            const char *class, const char *priority,
-            const char *user, const char *mboxname,
-            int nopt, const char **options,
-            const char *message)
-{
-    struct mailbox *mailbox = NULL;
-    char datestr[RFC822_DATETIME_MAX+1];
-    int i;
-    int r = mailbox_open_iwl("#events", &mailbox);
-    struct buf buf = BUF_INITIALIZER;
-
-    FILE *f;
-    quota_t qdiffs[QUOTA_NUMRESOURCES] = QUOTA_DIFFS_DONTCARE_INITIALIZER;
-    struct appendstate as;
-    struct stagemsg *stage = NULL;
-
-    if (r == IMAP_MAILBOX_NONEXISTENT) {
-        r = mboxlist_createmailbox("#events", 0, config_defpartition, 1,
-                                   "cyrus", NULL, 0, 0, 0, 0, NULL);
-        if (!r) r = mailbox_open_iwl("#events", &mailbox);
-    }
-    if (r) goto done;
-
-    /* Prepare to stage the message */
-    f = append_newstage(mailbox->name, when, 0, &stage);
-    if (!f) {
-        r = IMAP_IOERROR;
-        goto done;
-    }
-
-    syslog(LOG_NOTICE, "APPENDING TO STAGE: %s (%u)", mailbox->name, (unsigned)when);
-    time_to_rfc822(when, datestr, sizeof(datestr));
-    fprintf(f, "Date: %s\r\n", datestr);
-    fprintf(f, "Method: %s\r\n", charset_encode_mimeheader(method, 0));
-    fprintf(f, "Class: %s\r\n", charset_encode_mimeheader(class, 0));
-    fprintf(f, "Priority: %s\r\n", charset_encode_mimeheader(priority, 0));
-    fprintf(f, "User: %s\r\n", charset_encode_mimeheader(user, 0));
-    fprintf(f, "Mailbox: %s\r\n", charset_encode_mimeheader(mboxname, 0));
-    for (i = 0; i < nopt; i++)
-        fprintf(f, "Option: %s\r\n", charset_encode_mimeheader(options[i], 0));
-    fprintf(f, "Message: %s\r\n", charset_encode_mimeheader(message, 0));
-    fprintf(f, "\r\n");
-
-    fclose(f);
-    f = NULL;
-
-    r = append_setup_mbox(&as, mailbox, "cyrus", NULL,
-                          0, qdiffs, 0, 0, 0);
-    if (r) goto done;
-
-    struct body *body = NULL;
-    r = append_fromstage(&as, &body, stage, when, 0, 0, 0);
-    if (body) {
-        message_free_body(body);
-        free(body);
-    }
-    if (r) goto done;
-
-    r = append_commit(&as);
-    if (r) goto done;
-
-done:
-    append_removestage(stage);
-    append_abort(&as);
-    mailbox_close(&mailbox);
-    buf_free(&buf);
-    if (f) fclose(f);
-
-    return r;
-}
-
 EXPORTED void notify(const char *method,
             const char *class, const char *priority,
             const char *user, const char *mailbox,
@@ -237,6 +164,8 @@ EXPORTED void notify(const char *method,
     char buf[NOTIFY_MAXSIZE] = "", noptstr[20];
     int buflen = 0;
     int i, r = 0;
+    unsigned bufsiz;
+    socklen_t optlen;
 
     if (!strncmp(notify_sock, "dlist:", 6)) {
         notify_dlist(notify_sock+6, method, class, priority,
@@ -262,6 +191,17 @@ EXPORTED void notify(const char *method,
                 FNAME_NOTIFY_SOCK, sizeof(sun_data.sun_path));
     }
 
+    /* Get send buffer size */
+    optlen = sizeof(bufsiz);
+    r = getsockopt(soc, SOL_SOCKET, SO_SNDBUF, &bufsiz, &optlen);
+    if (r == -1) {
+        syslog(LOG_ERR, "unable to getsockopt(SO_SNDBUF) on notify socket: %m");
+        goto out;
+    }
+
+    /* Use minimum of 1/10 of send buffer size (-overhead) NOTIFY_MAXSIZE */
+    bufsiz = MIN(bufsiz / 10 - 32, NOTIFY_MAXSIZE);
+
     /*
      * build request of the form:
      *
@@ -269,21 +209,21 @@ EXPORTED void notify(const char *method,
      *   nopt NUL N(option NUL) message NUL
      */
 
-    r = add_arg(buf, sizeof(buf), method, &buflen);
-    if (!r) r = add_arg(buf, sizeof(buf), class, &buflen);
-    if (!r) r = add_arg(buf, sizeof(buf), priority, &buflen);
-    if (!r) r = add_arg(buf, sizeof(buf), user, &buflen);
-    if (!r) r = add_arg(buf, sizeof(buf), mailbox, &buflen);
+    r = add_arg(buf, bufsiz, method, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, class, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, priority, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, user, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, mailbox, &buflen);
 
     snprintf(noptstr, sizeof(noptstr), "%d", nopt);
-    if (!r) r = add_arg(buf, sizeof(buf), noptstr, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, noptstr, &buflen);
 
     for (i = 0; !r && i < nopt; i++) {
-        r = add_arg(buf, sizeof(buf), options[i], &buflen);
+        r = add_arg(buf, bufsiz, options[i], &buflen);
     }
 
-    if (!r) r = add_arg(buf, sizeof(buf), message, &buflen);
-    if (!r && fname) r = add_arg(buf, sizeof(buf), fname, &buflen);
+    if (!r) r = add_arg(buf, bufsiz, message, &buflen);
+    if (!r && fname) r = add_arg(buf, bufsiz, fname, &buflen);
 
     if (r) {
         syslog(LOG_ERR, "notify datagram too large, %s, %s",
diff -pruN 3.0.13-5/imap/notify.h 3.2.0-3/imap/notify.h
--- 3.0.13-5/imap/notify.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/notify.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,16 +43,12 @@
 #ifndef NOTIFY_H
 #define NOTIFY_H
 
+#define NOTIFY_MAXSIZE 65536  /* 64k */
+
 void notify(const char *method,
             const char *class, const char *priority,
             const char *user, const char *mailbox,
             int nopt, const char **options,
             const char *message, const char *fname);
 
-int notify_at(time_t when, const char *method,
-            const char *class, const char *priority,
-            const char *user, const char *mboxname,
-            int nopt, const char **options,
-            const char *message);
-
 #endif /* NOTIFY_H */
diff -pruN 3.0.13-5/imap/objectstore_caringo.c 3.2.0-3/imap/objectstore_caringo.c
--- 3.0.13-5/imap/objectstore_caringo.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/objectstore_caringo.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* objectstore_carringo.c
+/* objectstore_caringo.c
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  * Copyright (c) 2015 OpenIO, as a part of Cyrus
@@ -142,14 +142,14 @@ int objectstore_put (struct mailbox *mai
             syslog(LOG_ERR, "IOERROR: fstat on %s", fname);
         }
 
-        buf_init_mmap(&buffer, /*onceonly*/1, msgfd, fname, sbuf.st_size, mailbox->name);
+        buf_refresh_mmap(&buffer, /*onceonly*/1, msgfd, fname, sbuf.st_size, mailbox->name);
         close(msgfd);
         rc = write_named_object  (buffer.s, sbuf.st_size, obj_def->user, obj_def->filename) ;
         if (rc == HTTP_CREATED ) {
-            syslog(LOG_INFO, "Carringo: file name %s write in bucket %s", fname, obj_def->user  );
+            syslog(LOG_INFO, "Caringo: file name %s write in bucket %s", fname, obj_def->user  );
             rc = 0;
         } else {
-            syslog(LOG_ERR, "Carringo: file name  %s write error: [record:%u] (%d) in bucket %s",
+            syslog(LOG_ERR, "Caringo: file name  %s write error: [record:%u] (%d) in bucket %s",
                     fname, record->uid, rc, obj_def->user );
             rc = -1;
         }
@@ -175,10 +175,10 @@ int objectstore_get (struct mailbox *mai
         rc = read_named_object (buffer.s, len, obj_def->user, obj_def->filename) ;
 
         if (rc == HTTP_OK ) {
-            syslog(LOG_INFO, "Carringo: file name %s read from bucket %s", fname, obj_def->user  );
+            syslog(LOG_INFO, "Caringo: file name %s read from bucket %s", fname, obj_def->user  );
             rc = 0;
         } else {
-            syslog(LOG_ERR, "Carringo: file name  %s read error: [record:%u] (%d) from bucket %s",
+            syslog(LOG_ERR, "Caringo: file name  %s read error: [record:%u] (%d) from bucket %s",
                     fname, record->uid, rc, obj_def->user );
             rc = -1 ;
         }
@@ -220,10 +220,10 @@ int objectstore_delete (struct mailbox *
         rc = delete_named_object (obj_def->user, obj_def->filename) ;
 
         if (rc == HTTP_OK ) {
-            syslog(LOG_INFO, "Carringo: file name %s deleted from bucket %s", obj_def->filename, obj_def->user  );
+            syslog(LOG_INFO, "Caringo: file name %s deleted from bucket %s", obj_def->filename, obj_def->user  );
             rc = 0;
         } else {
-            syslog(LOG_ERR, "Carringo: file name  %s delete error : [record:%u] (%d) from bucket %s",
+            syslog(LOG_ERR, "Caringo: file name  %s delete error : [record:%u] (%d) from bucket %s",
                     obj_def->filename, record->uid, rc, obj_def->user );
             rc = -1 ;
         }
diff -pruN 3.0.13-5/imap/objectstore_db.c 3.2.0-3/imap/objectstore_db.c
--- 3.0.13-5/imap/objectstore_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/objectstore_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -228,7 +228,7 @@ static char *pack_update_message (const
     // SQL statement: UPDATE user_msg SET list_info = '{"mboxs":{"uid":mailbox1 "uid":mailbox2}}' WHERE msg_guid = 'message_guid';
     char *sql = "UPDATE user_msg SET list_info = " ;
     char *sql_where = "WHERE msg_guid = " ;
-    int final_lenght = strlen (sql) +
+    int final_length = strlen (sql) +
             2 + strlen(TOKEN_MBOX) + 1 + 4 + //  "'{" + TOKEN_MBOX + "{" ... + "}}' "
                 strlen(sql_where)  +         //
             1 + 40 + 1 +                     //  "'" + msg_guid (40) + "'"
@@ -236,9 +236,9 @@ static char *pack_update_message (const
 
     int i;
     for (i=0; i < message_info.mailboxes; i++){
-        final_lenght += strlen ( message_info.mailbox [i]) + strlen (TOKEN_UID) + 1;
+        final_length += strlen ( message_info.mailbox [i]) + strlen (TOKEN_UID) + 1;
     }
-    char *list_info = malloc ( final_lenght ) ;
+    char *list_info = malloc ( final_length ) ;
     sprintf ( list_info, "%s'{%s{", sql, TOKEN_MBOX) ;
     int j = strlen (list_info) ;
     for (i=0; i < message_info.mailboxes; i++){
@@ -252,20 +252,20 @@ static char *pack_update_message (const
 static char *pack_insert_message (const char *msg_guid, char *mailbox_name){
     // SQL statement: INSERT INTO user_msg (msg_guid,list_info) values ('message_guid', '{"mboxs":{"uid":mailbox}}' )
     char *sql = "INSERT INTO user_msg (msg_guid,list_info) values " ;
-    int final_lenght = strlen (sql) +
+    int final_length = strlen (sql) +
             2 + 40 + strlen(TOKEN_MBOX) + 5 + 1 + strlen(TOKEN_UID) + //  "('" + msg_guid (40) + "', '{" + TOKEN_MBOX  + "{" + TOKEN_UID
             strlen (mailbox_name) +  5 + 1 ;                          //  "}}' )" +  1
-    char *list_info = malloc ( final_lenght ) ;
+    char *list_info = malloc ( final_length ) ;
     sprintf ( list_info, "%s('%s', '{%s{%s%s}}' )", sql, msg_guid , TOKEN_MBOX, TOKEN_UID, mailbox_name) ;
     return list_info ;
 }
 
 static char *pack_other_message (char *sql_cmd, const char *msg_guid){   // used with: SQL_SELECT_CMD SQL_DELETE_CMD
 
-    int final_lenght = strlen (sql_cmd) +
+    int final_length = strlen (sql_cmd) +
             1 + 40 + 1 + 1 ;           //  "('" + msg_guid (40) + "'" + EOS
 
-    char *list_info = malloc ( final_lenght ) ;
+    char *list_info = malloc ( final_length ) ;
     sprintf ( list_info, "%s'%s'", sql_cmd, msg_guid) ;
     return list_info ;
 }
@@ -320,7 +320,7 @@ static sqldb_t *open_db_userid (struct m
                       "msg_guid    CHAR (40)   PRIMARY KEY     NOT NULL," \
                       "list_info   TEXT                        NOT NULL);";
 
-    db = sqldb_open(path , sql_table , 1.0, NULL) ;
+    db = sqldb_open(path , sql_table , 1.0, NULL, SQLDB_DEFAULT_TIMEOUT) ;
 
     if (db && bkeep_db_open)
     {
@@ -421,7 +421,7 @@ EXPORTED int add_message_guid (struct ma
         else
             sqldb_close(&db);
     }
-    return (rc == SQLITE_OK) ;
+    return rc == SQLITE_OK;
 }
 
 
diff -pruN 3.0.13-5/imap/objectstore_openio.c 3.2.0-3/imap/objectstore_openio.c
--- 3.0.13-5/imap/objectstore_openio.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/objectstore_openio.c	2020-04-24 02:03:00.000000000 +0000
@@ -130,12 +130,12 @@ static int openio_sds_lazy_init (void)
         return ENOTSUP;
     }
 
-    v = config_getint(IMAPOPT_OPENIO_RAWX_TIMEOUT);
+    v = config_getduration(IMAPOPT_OPENIO_RAWX_TIMEOUT, 's');
     rc = oio_sds_configure(sds, OIOSDS_CFG_TIMEOUT_RAWX, &v, sizeof(int));
     if (0 != rc)
         syslog(LOG_WARNING, "OIOSDS: could not set the query timeout to rawx services: %m");
 
-    v = config_getint(IMAPOPT_OPENIO_PROXY_TIMEOUT);
+    v = config_getduration(IMAPOPT_OPENIO_PROXY_TIMEOUT, 's');
     rc = oio_sds_configure(sds, OIOSDS_CFG_TIMEOUT_PROXY, &v, sizeof(int));
     if (0 != rc)
         syslog(LOG_WARNING, "OIOSDS: could not set the query timeout to proxy services: %m");
diff -pruN 3.0.13-5/imap/pop3d.c 3.2.0-3/imap/pop3d.c
--- 3.0.13-5/imap/pop3d.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/pop3d.c	2020-04-24 02:03:00.000000000 +0000
@@ -52,6 +52,7 @@
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/param.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -72,7 +73,6 @@
 #include "global.h"
 #include "tls.h"
 
-#include "exitcodes.h"
 #include "imapd.h"
 #include "mailbox.h"
 #include "mboxevent.h"
@@ -91,7 +91,6 @@
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
 
-#include "sync_log.h"
 #include "statuscache.h"
 
 #include "iostat.h"
@@ -216,13 +215,7 @@ extern int saslserver(sasl_conn_t *conn,
 /* Enable the resetting of a sasl_conn_t */
 static int reset_saslconn(sasl_conn_t **conn);
 
-static struct
-{
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 static int popd_canon_user(sasl_conn_t *conn, void *context,
                            const char *user, unsigned ulen,
@@ -404,19 +397,7 @@ static void popd_reset(void)
     }
     popd_starttls_done = 0;
 
-    if(saslprops.iplocalport) {
-       free(saslprops.iplocalport);
-       saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-       free(saslprops.ipremoteport);
-       saslprops.ipremoteport = NULL;
-    }
-    if(saslprops.authid) {
-       free(saslprops.authid);
-       saslprops.authid = NULL;
-    }
-    saslprops.ssf = 0;
+    saslprops_reset(&saslprops);
 
     popd_exists = 0;
 }
@@ -432,7 +413,7 @@ int service_init(int argc __attribute__(
     int r;
     int opt;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -442,33 +423,13 @@ int service_init(int argc __attribute__(
     /* load the SASL plugins */
     global_sasl_init(1, 1, mysasl_cb);
 
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for expunge */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* open the user deny db */
-    denydb_init(0);
-    denydb_open(0);
-
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        /* open statuscache db to optimize handling an empty maildrop */
-        statuscache_open();
-    }
-
     /* setup for sending IMAP IDLE notifications */
     idle_init();
 
-    /* setup for mailbox event notifications */
-    mboxevent_init();
-
     /* Set namespace */
     if ((r = mboxname_init_namespace(&popd_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     mboxevent_setnamespace(&popd_namespace);
@@ -480,7 +441,7 @@ int service_init(int argc __attribute__(
             if (!tls_enabled()) {
                 syslog(LOG_ERR, "pop3s: required OpenSSL options not present");
                 fatal("pop3s: required OpenSSL options not present",
-                      EC_CONFIG);
+                      EX_CONFIG);
             }
             break;
 
@@ -521,8 +482,6 @@ int service_main(int argc __attribute__(
 
     signals_poll();
 
-    sync_log_init();
-
     popd_in = prot_new(0, 0);
     popd_out = prot_new(1, 1);
 
@@ -533,35 +492,34 @@ int service_main(int argc __attribute__(
     /* Find out name of client host */
     popd_clienthost = get_clienthost(0, &localip, &remoteip);
 
+    if (localip && remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, remoteip);
+        buf_setcstr(&saslprops.iplocalport, localip);
+    }
+
     /* other params should be filled in */
-    if (sasl_server_new("pop", config_servername, NULL, NULL, NULL,
+    if (sasl_server_new("pop", config_servername, NULL,
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
                         NULL, 0, &popd_saslconn) != SASL_OK)
-        fatal("SASL failed initializing: sasl_server_new()",EC_TEMPFAIL);
+        fatal("SASL failed initializing: sasl_server_new()",EX_TEMPFAIL);
 
     /* will always return something valid */
     secprops = mysasl_secprops(0);
     if (sasl_setprop(popd_saslconn, SASL_SEC_PROPS, secprops) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
     if (sasl_setprop(popd_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf) != SASL_OK)
-        fatal("Failed to set SASL property", EC_TEMPFAIL);
+        fatal("Failed to set SASL property", EX_TEMPFAIL);
 
     if (localip) {
         popd_haveaddr = 1;
-        sasl_setprop(popd_saslconn, SASL_IPLOCALPORT, localip);
-        saslprops.iplocalport = xstrdup(localip);
-    }
-
-    if (remoteip) {
-        sasl_setprop(popd_saslconn, SASL_IPREMOTEPORT, remoteip);
-        saslprops.ipremoteport = xstrdup(remoteip);
     }
 
     popd_tls_required = config_getswitch(IMAPOPT_TLS_REQUIRED);
 
     /* Set inactivity timer */
-    popd_timeout = config_getint(IMAPOPT_POPTIMEOUT);
-    if (popd_timeout < 10) popd_timeout = 10;
-    popd_timeout *= 60;
+    popd_timeout = config_getduration(IMAPOPT_POPTIMEOUT, 'm');
+    if (popd_timeout < 10 * 60) popd_timeout = 10 * 60;
     prot_settimeout(popd_in, popd_timeout);
     prot_setflushonread(popd_in, popd_out);
 
@@ -583,7 +541,7 @@ int service_main(int argc __attribute__(
     prot_printf(popd_out, "+OK");
     if (config_serverinfo) prot_printf(popd_out, " %s", config_servername);
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
-        prot_printf(popd_out, " Cyrus POP3 %s", cyrus_version());
+        prot_printf(popd_out, " Cyrus POP3 %s", CYRUS_VERSION);
     }
     prot_printf(popd_out, " server ready %s\r\n", popd_apop_chal);
 
@@ -593,7 +551,8 @@ int service_main(int argc __attribute__(
 
     /* send a Logout event notification */
     if ((mboxevent = mboxevent_new(EVENT_LOGOUT))) {
-        mboxevent_set_access(mboxevent, saslprops.iplocalport,
+        mboxevent_set_access(mboxevent,
+                             buf_cstringnull_ifempty(&saslprops.iplocalport),
                              NULL, popd_userid, NULL, 1);
 
         mboxevent_notify(&mboxevent);
@@ -629,7 +588,7 @@ static void usage(void)
 {
     prot_printf(popd_out, "-ERR usage: pop3d [-C <alt_config>] [-k] [-s]\r\n");
     prot_flush(popd_out);
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /*
@@ -661,24 +620,11 @@ void shut_down(int code)
     syslog(LOG_NOTICE, "counts: retr=<%d> top=<%d> dele=<%d>",
                        count_retr, count_top, count_dele);
 
-    sync_log_done();
-
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        statuscache_close();
-        statuscache_done();
-    }
-
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    denydb_close();
-    denydb_done();
-
     idle_done();
 
+    /* make sure we didn't leak */
+    assert(!open_mailboxes_exist());
+
     if (popd_in) {
         prot_NONBLOCK(popd_in);
         prot_fill(popd_in);
@@ -700,6 +646,8 @@ void shut_down(int code)
     tls_shutdown_serverengine();
 #endif
 
+    saslprops_free(&saslprops);
+
     cyrus_done();
 
     if (config_iolog) {
@@ -784,7 +732,7 @@ void kpop(void)
     socklen_t len;
 
     if (!popd_haveaddr) {
-        fatal("Cannot get client's IP address", EC_OSERR);
+        fatal("Cannot get client's IP address", EX_OSERR);
     }
 
     srvtab = config_getstring(IMAPOPT_SRVTAB);
@@ -856,11 +804,12 @@ static int expunge_deleted(void)
         if (r) break;
 
         /* already expunged? skip */
-        if (record.system_flags & FLAG_EXPUNGED)
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
             continue;
 
         /* mark expunged */
-        record.system_flags |= FLAG_DELETED | FLAG_EXPUNGED;
+        record.system_flags |= FLAG_DELETED;
+        record.internal_flags |= FLAG_INTERNAL_EXPUNGED;
         numexpunged++;
 
         /* store back to the mailbox */
@@ -948,7 +897,7 @@ static void cmdloop(void)
         if (p > inputbuf && p[-1] == '\n') *--p = '\0';
         if (p > inputbuf && p[-1] == '\r') *--p = '\0';
 
-        /* Parse into keword and argument */
+        /* Parse into keyword and argument */
         for (p = inputbuf; *p && !Uisspace(*p); p++);
         if (*p) {
             *p++ = '\0';
@@ -986,7 +935,7 @@ static void cmdloop(void)
         if (!strcmp(inputbuf, "quit")) {
             if (!arg) {
                 int pollpadding =config_getint(IMAPOPT_POPPOLLPADDING);
-                int minpollsec = config_getint(IMAPOPT_POPMINPOLL)*60;
+                int minpollsec = config_getduration(IMAPOPT_POPMINPOLL, 'm');
 
                 /* check preconditions! */
                 if (!popd_mailbox)
@@ -1279,12 +1228,6 @@ void uidl_msg(uint32_t msgno)
 static void cmd_starttls(int pop3s)
 {
     int result;
-    int *layerp;
-    sasl_ssf_t ssf;
-    char *auth_id;
-
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
 
     if (popd_starttls_done == 1)
     {
@@ -1320,8 +1263,7 @@ static void cmd_starttls(int pop3s)
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                pop3s ? 180 : popd_timeout,
-                               layerp,
-                               &auth_id,
+                               &saslprops,
                                &tls_conn);
 
     /* if error */
@@ -1337,28 +1279,16 @@ static void cmd_starttls(int pop3s)
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(popd_saslconn, SASL_SSF_EXTERNAL, &ssf);
-    if (result == SASL_OK) {
-        saslprops.ssf = ssf;
-
-        result = sasl_setprop(popd_saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    }
+    result = saslprops_set_tls(&saslprops, popd_saslconn);
     if (result != SASL_OK) {
-        syslog(LOG_NOTICE, "sasl_setprop() failed: cmd_starttls()");
+        syslog(LOG_NOTICE, "saslprops_set_tls() failed: cmd_starttls()");
         if (pop3s == 0) {
-            fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
+            fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
         } else {
             shut_down(0);
         }
     }
 
-    if(saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
-    }
-    if(auth_id)
-        saslprops.authid = xstrdup(auth_id);
-
     /* tell the prot layer about our new layers */
     prot_settls(popd_in, tls_conn);
     prot_settls(popd_out, tls_conn);
@@ -1369,7 +1299,7 @@ static void cmd_starttls(int pop3s)
 #else
 static void cmd_starttls(int pop3s __attribute__((unused)))
 {
-    fatal("cmd_starttls() called, but no OpenSSL", EC_SOFTWARE);
+    fatal("cmd_starttls() called, but no OpenSSL", EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
 
@@ -1406,7 +1336,7 @@ static void cmd_apop(char *response)
                popd_clienthost, popd_apop_chal,
                sasl_errdetail(popd_saslconn));
 
-        failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+        failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
         if (failedloginpause != 0) {
             sleep(failedloginpause);
         }
@@ -1477,7 +1407,7 @@ static void cmd_user(char *user)
              strlen(userbuf) + 6 >= MAX_MAILBOX_BUFFER) {
         prot_printf(popd_out, "-ERR [AUTH] Invalid user\r\n");
         syslog(LOG_NOTICE,
-               "badlogin: %s plaintext %s invalid user",
+               "badlogin: %s plaintext (%s) invalid user",
                popd_clienthost, beautify_string(user));
     }
     else {
@@ -1538,9 +1468,9 @@ static void cmd_pass(char *pass)
                             strlen(popd_userid),
                             pass,
                             strlen(pass))!=SASL_OK) {
-        syslog(LOG_NOTICE, "badlogin: %s plaintext %s %s",
+        syslog(LOG_NOTICE, "badlogin: %s plaintext (%s) [%s]",
                popd_clienthost, popd_userid, sasl_errdetail(popd_saslconn));
-        failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+        failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
         if (failedloginpause != 0) {
             sleep(failedloginpause);
         }
@@ -1580,7 +1510,7 @@ static void cmd_pass(char *pass)
                popd_starttls_done ? "+TLS" : "", "User logged in", session_id());
 
         if ((!popd_starttls_done) &&
-            (plaintextloginpause = config_getint(IMAPOPT_PLAINTEXTLOGINPAUSE))
+            (plaintextloginpause = config_getduration(IMAPOPT_PLAINTEXTLOGINPAUSE, 's'))
              != 0) {
             sleep(plaintextloginpause);
         }
@@ -1600,8 +1530,8 @@ static void cmd_pass(char *pass)
  */
 static void cmd_capa(void)
 {
-    int minpoll = config_getint(IMAPOPT_POPMINPOLL) * 60;
-    int expire = config_getint(IMAPOPT_POPEXPIRETIME);
+    int minpoll = config_getduration(IMAPOPT_POPMINPOLL, 'm');
+    int expire = config_getduration(IMAPOPT_POPEXPIRETIME, 'd');
     int mechcount;
     const char *mechlist;
 
@@ -1623,6 +1553,7 @@ static void cmd_capa(void)
     if (expire < 0) {
         prot_printf(popd_out, "EXPIRE NEVER\r\n");
     } else {
+        expire /= (24 * 60 * 60);
         prot_printf(popd_out, "EXPIRE %d\r\n", expire);
     }
 
@@ -1642,7 +1573,7 @@ static void cmd_capa(void)
     if (popd_authstate || (config_serverinfo == IMAP_ENUM_SERVERINFO_ON)) {
         prot_printf(popd_out,
                     "IMPLEMENTATION Cyrus POP3 %s\r\n",
-                    cyrus_version());
+                    CYRUS_VERSION);
     }
 
     prot_printf(popd_out, ".\r\n");
@@ -1713,6 +1644,7 @@ static void cmd_auth(char *arg)
 
     if (r) {
         const char *errorstring = NULL;
+        const char *userid = "-notset-";
 
         switch (r) {
         case IMAP_SASL_CANCEL:
@@ -1729,15 +1661,19 @@ static void cmd_auth(char *arg)
         default:
             /* failed authentication */
             if (authtype) {
-                syslog(LOG_NOTICE, "badlogin: %s %s %s",
-                       popd_clienthost, authtype,
+                if (sasl_result != SASL_NOUSER)
+                    sasl_getprop(popd_saslconn, SASL_USERNAME,
+                                 (const void **) &userid);
+
+                syslog(LOG_NOTICE, "badlogin: %s %s (%s) [%s]",
+                       popd_clienthost, authtype, userid,
                        sasl_errstring(sasl_result, NULL, NULL));
             } else {
                 syslog(LOG_NOTICE, "badlogin: %s %s",
                        popd_clienthost, authtype);
             }
 
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
@@ -1794,10 +1730,10 @@ static void cmd_auth(char *arg)
            popd_userid, popd_subfolder ? popd_subfolder : "",
            authtype, popd_starttls_done ? "+TLS" : "", "User logged in", session_id());
 
-    sasl_getprop(popd_saslconn, SASL_SSF, &val);
-    saslprops.ssf = *((sasl_ssf_t *) val);
-
     if (!openinbox()) {
+        sasl_getprop(popd_saslconn, SASL_SSF, &val);
+        saslprops.ssf = *((sasl_ssf_t *) val);
+
         prot_setsasl(popd_in,  popd_saslconn);
         prot_setsasl(popd_out, popd_saslconn);
     }
@@ -1821,8 +1757,10 @@ int openinbox(void)
 
     /* send a Login event notification */
     if ((mboxevent = mboxevent_new(EVENT_LOGIN))) {
-        mboxevent_set_access(mboxevent, saslprops.iplocalport,
-                             saslprops.ipremoteport, popd_userid, NULL, 0);
+        mboxevent_set_access(mboxevent,
+                             buf_cstringnull_ifempty(&saslprops.iplocalport),
+                             buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                             popd_userid, NULL, 0);
 
         mboxevent_notify(&mboxevent);
         mboxevent_free(&mboxevent);
@@ -1899,7 +1837,7 @@ int openinbox(void)
         }
     }
     else if (config_getswitch(IMAPOPT_STATUSCACHE) &&
-             !(r = statuscache_lookup(mbname_intname(mbname), popd_userid, STATUS_MESSAGES, &sdata)) &&
+             !(r = status_lookup_mbname(mbname, popd_userid, STATUS_MESSAGES, &sdata)) &&
              !sdata.messages) {
         /* local mailbox (empty) -- don't bother opening the mailbox */
         syslog(LOG_INFO, "optimized mode for empty maildrop: %s", popd_userid);
@@ -1938,13 +1876,14 @@ int openinbox(void)
             goto fail;
         }
 
-        if ((minpoll = config_getint(IMAPOPT_POPMINPOLL)) &&
-            popd_mailbox->i.pop3_last_login + 60*minpoll > popd_login_time) {
+        if ((minpoll = config_getduration(IMAPOPT_POPMINPOLL, 'm')) &&
+            popd_mailbox->i.pop3_last_login + minpoll > popd_login_time) {
             syslog(LOG_ERR, "%s: Logins must be at least %d minute%s apart",
-                        mbname_intname(mbname), minpoll, minpoll > 1 ? "s" : "");
+                        mbname_intname(mbname),
+                        minpoll / 60, minpoll / 60 > 1 ? "s" : "");
             prot_printf(popd_out,
                         "-ERR [LOGIN-DELAY] Logins must be at least %d minute%s apart\r\n",
-                        minpoll, minpoll > 1 ? "s" : "");
+                        minpoll / 60, minpoll / 60 > 1 ? "s" : "");
             mailbox_close(&popd_mailbox);
             goto fail;
         }
@@ -2106,20 +2045,12 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("pop", config_servername,
-                         NULL, NULL, NULL,
+    ret = sasl_server_new("pop", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
                          NULL, 0, conn);
     if(ret != SASL_OK) return ret;
 
-    if(saslprops.ipremoteport)
-       ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                          saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-       ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                          saslprops.iplocalport);
-    if(ret != SASL_OK) return ret;
     secprops = mysasl_secprops(0);
     ret = sasl_setprop(*conn, SASL_SEC_PROPS, secprops);
     if(ret != SASL_OK) return ret;
@@ -2127,17 +2058,12 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if(saslprops.ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     } else {
         ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &extprops_ssf);
     }
 
     if(ret != SASL_OK) return ret;
-
-    if(saslprops.authid) {
-       ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-       if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -2204,7 +2130,7 @@ static int update_seen(void)
         record.recno = popd_map[msgno-1].recno;
         if (mailbox_reload_index_record(popd_mailbox, &record))
             continue;
-        if (record.system_flags & FLAG_EXPUNGED)
+        if (record.internal_flags & FLAG_INTERNAL_EXPUNGED)
             continue; /* already expunged */
         if (record.system_flags & FLAG_SEEN)
             continue; /* already seen */
diff -pruN 3.0.13-5/imap/proc.c 3.2.0-3/imap/proc.c
--- 3.0.13-5/imap/proc.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/proc.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,12 +48,12 @@
 #include <unistd.h>
 #endif
 #include <signal.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/stat.h>
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "proc.h"
 #include "retry.h"
@@ -90,10 +90,10 @@ static char *proc_getpath(pid_t pid, int
         const char *procpath = config_getstring(IMAPOPT_PROC_PATH);
 
         if (procpath[0] != '/')
-            fatal("proc path must be fully qualified", EC_CONFIG);
+            fatal("proc path must be fully qualified", EX_CONFIG);
 
         if (strlen(procpath) < 2)
-            fatal("proc path must not be '/'", EC_CONFIG);
+            fatal("proc path must not be '/'", EX_CONFIG);
 
         buf_setcstr(&buf, procpath);
 
@@ -135,14 +135,14 @@ EXPORTED int proc_register(const char *s
     procfile = fopen(newfname, "w+");
     if (!procfile) {
         if (cyrus_mkdir(newfname, 0755) == -1) {
-            fatal("couldn't create proc directory", EC_IOERR);
+            fatal("couldn't create proc directory", EX_IOERR);
         }
         else {
             syslog(LOG_NOTICE, "created proc directory");
             procfile = fopen(newfname, "w+");
             if (!procfile) {
                 syslog(LOG_ERR, "IOERROR: creating %s: %m", newfname);
-                fatal("can't write proc file", EC_IOERR);
+                fatal("can't write proc file", EX_IOERR);
             }
         }
     }
@@ -158,7 +158,7 @@ EXPORTED int proc_register(const char *s
     if (rename(newfname, procfname)) {
         syslog(LOG_ERR, "IOERROR: renaming %s to %s: %m", newfname, procfname);
         unlink(newfname);
-        fatal("can't write proc file", EC_IOERR);
+        fatal("can't write proc file", EX_IOERR);
     }
 
     setproctitle("%s: %s %s %s %s", servicename, clienthost, userid, mailbox, cmd);
diff -pruN 3.0.13-5/imap/proc.h 3.2.0-3/imap/proc.h
--- 3.0.13-5/imap/proc.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/proc.h	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,8 @@ typedef int procdata_t(pid_t pid,
                        const char *cmd, void *rock);
 
 extern void setproctitle_init(int argc, char **argv, char **envp);
-extern void setproctitle(const char *fmt, ...);
+extern void setproctitle(const char *fmt, ...)
+                        __attribute__((format(printf, 1, 2)));
 
 extern int proc_register(const char *servicename, const char *clienthost,
                          const char *userid, const char *mailbox, const char *cmd);
diff -pruN 3.0.13-5/imap/promdatagen 3.2.0-3/imap/promdatagen
--- 3.0.13-5/imap/promdatagen	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/promdatagen	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,298 @@
+#!/usr/bin/perl
+# promdatagen - generate promdata.[ch] files
+
+# Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in
+#    the documentation and/or other materials provided with the
+#    distribution.
+
+# 3. The name "Carnegie Mellon University" must not be used to
+#    endorse or promote products derived from this software without
+#    prior written permission. For permission or any legal
+#    details, please contact
+#      Carnegie Mellon University
+#      Center for Technology Transfer and Enterprise Creation
+#      4615 Forbes Avenue
+#      Suite 302
+#      Pittsburgh, PA  15213
+#      (412) 268-7393, fax: (412) 268-7395
+#      innovation@andrew.cmu.edu
+
+# 4. Redistributions of any form whatsoever must retain the following
+#    acknowledgment:
+#    "This product includes software developed by Computing Services
+#     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+
+# CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+# AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+# FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+# OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+
+use warnings;
+use strict;
+
+use Data::Dumper;
+use Getopt::Std;
+
+my %types = ( counter => 'PROM_METRIC_COUNTER', gauge => 'PROM_METRIC_GAUGE' );
+
+my %options;
+my @metrics;
+my @labels;
+
+sub output_header;
+sub output_source;
+
+die "usage\n" if not getopts("h:c:v", \%options);
+
+my $lineno = 0;
+while (my $line = <>) {
+    $lineno ++;
+
+    chomp $line;
+    $line =~ s{#.*$}{};             # eat comments
+    $line =~ s{\s+$}{};             # eat trailing whitespace
+    next if $line =~ m{^\s*$};      # eat empty lines
+
+    if ($line =~ m{^\s*metric\s}) {
+        # parse a metric:
+        # metric counter imap_connections_total  The total number of IMAP connections
+        $line =~ s{^\s*metric\s+}{};
+        my ($type, $name, $help) = split /\s+/, $line, 3;
+    
+        if (not exists $types{$type}) {
+            die "\"$type\" is not a valid type at line $lineno\n";
+        }
+
+        if ($name !~ m{^[a-z][a-z0-9_]*$}) {
+            die "\"$name\" is not a valid metric name at line $lineno\n";
+        }
+
+        push @metrics, { type => $type, name => $name, help => $help };
+
+    }
+    elsif ($line =~ m{^\s*label\s}) {
+        # parse a label:
+        # label imap_authenticate_count result yes no
+        $line =~ s{^\s*label\s+}{};
+        my ($name, $label, @values) = split /\s+/, $line;
+
+        if (not scalar grep { $_->{name} eq $name } @metrics) {
+            die "cannot define label \"$label\" for unknown metric \"$name\" at line $lineno\n";
+        }
+
+        if ($label !~ m{^[a-z][a-z0-9_]*$}) {
+            die "\"$label\" is not a valid label at line $lineno\n";
+        }
+
+        foreach my $v (@values) {
+            if ($v !~ m{^[a-z][a-z0-9_]*$}) {
+                die "\"$v\" is not a valid value at line $lineno\n";
+            }
+        }
+
+        foreach my $metric (@metrics) {
+            if ($metric->{name} eq $name) {
+                if (exists $metric->{label} ) {
+                    die "cannot define more than one label for metric \"$name\" at line $lineno\n";
+                }
+                $metric->{label} = { name => $name, label => $label, values => [ @values ] };
+                push @labels, $metric->{label};
+                last;
+            }
+        }
+    }
+    else {
+        warn "skipping unparseable line at line $lineno: $line\n";
+        next;
+    }
+}
+
+output_header($options{h}, \@metrics, \@labels) if $options{h};
+output_source($options{c}, \@metrics, \@labels) if $options{c};
+
+exit 0;
+
+sub output_header
+{
+    my ($fname, $metrics, $labels) = @_;
+
+    open my $header, '>', $fname or die "$fname: $!\n";
+    print $header "#ifndef INCLUDE_PROMDATA_H\n#define INCLUDE_PROMDATA_H\n";
+    print $header "/* generated from $ARGV */\n";
+
+    print $header <<OKAY;
+
+#include <sys/types.h>
+
+#include <stdint.h>
+
+enum prom_metric_type {
+    PROM_METRIC_COUNTER   = 0,
+    PROM_METRIC_GAUGE     = 1,
+    PROM_METRIC_HISTOGRAM = 2, /* unused */
+    PROM_METRIC_SUMMARY   = 3, /* unused */
+    PROM_METRIC_CONTINUED = 4, /* internal use only */
+};
+extern const char *prom_metric_type_names[];
+
+OKAY
+
+    print $header "enum prom_metric_id {\n";
+    my $first = 1;
+    foreach my $metric (@{$metrics}) {
+        if (exists $metric->{label}) {
+            foreach my $v (@{$metric->{label}->{values}}) {
+                print $header "    \U$metric->{name}_$metric->{label}->{label}_$v\E";
+                print $header q{ = 0} if $first;
+                $first = 0;
+                print $header qq{,\n};
+            }
+        }
+        else {
+            print $header q{    }, uc($metric->{name});
+            print $header q{ = 0} if $first;
+            $first = 0;
+            print $header qq{,\n};
+        }
+    }
+    print $header "\n    PROM_NUM_METRICS /* n.b. leave last! */\n";
+    print $header "};\n\n";
+
+    print $header "enum prom_labelled_metric {\n";
+    $first = 1;
+    foreach my $label (@{$labels}) {
+        print $header "    \U$label->{name}\E";
+        print $header q{ = 0} if $first;
+        $first = 0;
+        print $header qq{,\n};
+    }
+    print $header "\n    PROM_NUM_LABELLED_METRICS /* n.b. leave last! */\n";
+    print $header "};\n";
+
+print $header <<OKAY;
+
+struct prom_label_lookup_value {
+    const char *value;
+    enum prom_metric_id id;
+};
+
+extern const struct prom_label_lookup_value *prom_label_lookup_table[];
+
+OKAY
+
+    print $header <<OKAY;
+
+struct prom_metric_desc {
+    const char *name;
+    enum prom_metric_type type;
+    const char *help;
+    const char *label;
+};
+extern const struct prom_metric_desc prom_metric_descs[];
+
+struct prom_metric {
+    double value;
+    int64_t last_updated;
+};
+
+struct prom_stats {
+    char  ident[512];   /* XXX places upper limit on service names */
+    struct prom_metric metrics[PROM_NUM_METRICS];
+};
+#define PROM_STATS_INITIALIZER { {0}, {{0, 0}} }
+
+OKAY
+
+    print $header "#endif\n";
+    close $header;
+}
+
+sub output_source
+{
+    my ($fname, $metrics, $labels) = @_;
+
+    open my $source, '>', $fname or die "$fname: $!\n";
+
+    print $source <<OKAY;
+/* generated from $ARGV */
+
+#include <config.h>
+
+#include "imap/promdata.h" /* XXX */
+
+EXPORTED const char *prom_metric_type_names[] = {
+    "counter",
+    "gauge",
+    "histogram",
+    "summary",
+    NULL,
+};
+
+OKAY
+
+    print $source "EXPORTED const struct prom_metric_desc prom_metric_descs[] = {\n";
+    foreach my $metric (@{$metrics}) {
+        if (exists $metric->{label}) {
+            my $first = 1;
+            foreach my $v (@{$metric->{label}->{values}}) {
+                printf $source '    { "%s", %s, ',
+                            $metric->{name},
+                            ($first ? $types{$metric->{type}} : "PROM_METRIC_CONTINUED");
+                if ($first && defined $metric->{help}) {
+                    printf $source '"%s", ', $metric->{help};
+                }
+                else {
+                    print $source "NULL, ";
+                }
+                printf $source '"%s=\\"%s\\""', $metric->{label}->{label}, $v;
+                print $source " },\n";
+                $first = 0;
+            }
+        }
+        else {
+            printf $source '    { "%s", %s, ',
+                        $metric->{name},
+                        $types{$metric->{type}};
+            if (defined $metric->{help}) {
+                printf $source '"%s",', $metric->{help};
+            }
+            else {
+                print $source "NULL,";
+            }
+            print $source " NULL },\n";
+        }
+    }
+    print $source "    { NULL, 0, NULL, NULL },\n";
+    print $source "};\n\n";
+
+    foreach my $label(@{$labels}) {
+        print $source "static const struct prom_label_lookup_value ";
+        print $source "\U$label->{name}_$label->{label}\E_values[] = {\n";
+        foreach my $value(sort @{$label->{values}}) {
+            print $source "    { \"$value\", \U$label->{name}_$label->{label}_$value\E },\n";
+        }
+        print $source "    { NULL, 0 },\n";
+        print $source "};\n\n";
+    }
+
+    print $source "EXPORTED const struct prom_label_lookup_value *prom_label_lookup_table[] = {\n";
+    foreach my $label (@{$labels}) {
+        print $source "    \U$label->{name}_$label->{label}\E_values,\n";
+    }
+    print $source "};\n";
+
+    close $source;
+}
diff -pruN 3.0.13-5/imap/promdata.p 3.2.0-3/imap/promdata.p
--- 3.0.13-5/imap/promdata.p	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/promdata.p	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,140 @@
+# Prometheus metric definitions file
+#
+# metric <type> <name> <description>
+#   * type is one of "counter" or "gauge"
+#   * name must be [a-z0-9_] only
+#   * description is free text until EOL but don't be silly
+#
+# label <metric> <key> <values...>
+#   * metric is the name of an already defined metric
+#   * key must be [a-z0-9_] only
+#   * values must be [a-z0-9_] only and are whitespace delimited until EOL
+#
+# Each metric may have zero or one labels applied to it
+#
+# '#' begins a comment
+#
+# There is not currently a line-continuation character supported by the parser,
+# so this file will contain long lines!
+
+metric counter cyrus_imap_connections_total             The total number of IMAP connections
+metric gauge   cyrus_imap_active_connections            The number of currently active IMAP connections
+metric gauge   cyrus_imap_ready_listeners               The number of currently ready IMAP listeners
+metric counter cyrus_imap_shutdown_total                The number of IMAP process shutdowns
+    label cyrus_imap_shutdown_total status ok error
+metric counter cyrus_imap_append_total                  The total number of IMAP APPENDs
+metric counter cyrus_imap_authenticate_total            The total number of IMAP AUTHENTICATEs
+    label cyrus_imap_authenticate_total result yes no
+metric counter cyrus_imap_capability_total              The total number of IMAP CAPABILITYs
+metric counter cyrus_imap_compress_total                The total number of IMAP COMPRESSs
+metric counter cyrus_imap_check_total                   The total number of IMAP checks
+metric counter cyrus_imap_copy_total                    The total number of IMAP COPYs
+metric counter cyrus_imap_create_total                  The total number of IMAP CREATEs
+metric counter cyrus_imap_close_total                   The total number of IMAP CLOSEs
+metric counter cyrus_imap_delete_total                  The total number of IMAP DELETEs
+metric counter cyrus_imap_deleteacl_total               The total number of IMAP DELETEACLs
+metric counter cyrus_imap_dump_total                    The total number of IMAP DUMPs
+metric counter cyrus_imap_expunge_total                 The total number of IMAP EXPUNGEs
+metric counter cyrus_imap_examine_total                 The total number of IMAP EXAMINEs
+metric counter cyrus_imap_fetch_total                   The total number of IMAP FETCHs
+metric counter cyrus_imap_getacl_total                  The total number of IMAP GETACLs
+metric counter cyrus_imap_getannotation_total           The total number of IMAP SETANNOTATIONs
+metric counter cyrus_imap_getmetadata_total             The total number of IMAP GETMETADATAs
+metric counter cyrus_imap_getquota_total                The total number of IMAP GETQUOTAs
+metric counter cyrus_imap_getquotaroot_total            The total number of IMAP GETQUOTAROOTs
+metric counter cyrus_imap_genurlauth_total              The total number of IMAP GENURLAUTHs
+metric counter cyrus_imap_id_total                      The total number of IMAP IDs
+metric counter cyrus_imap_idle_total                    The total number of IMAP IDLEs
+metric counter cyrus_imap_logout_total                  The total number of IMAP LOGOUTs
+metric counter cyrus_imap_list_total                    The total number of IMAP LISTs
+metric counter cyrus_imap_lsub_total                    The total number of IMAP LSUBs
+metric counter cyrus_imap_listrights_total              The total number of IMAP LISTRIGHTSs
+metric counter cyrus_imap_myrights_total                The total number of IMAP MYRIGHTSs
+metric counter cyrus_imap_mupdatepush_total             The total number of IMAP MUPDATEPUSHs
+metric counter cyrus_imap_starttls_total                The total number of IMAP STARTTLSs
+metric counter cyrus_imap_store_total                   The total number of IMAP STOREs
+metric counter cyrus_imap_select_total                  The total number of IMAP SELECTs
+metric counter cyrus_imap_search_total                  The total number of IMAP SEARCHs
+metric counter cyrus_imap_subscribe_total               The total number of IMAP SUBSCRIBEs
+metric counter cyrus_imap_setacl_total                  The total number of IMAP SETACLs
+metric counter cyrus_imap_setannotation_total           The total number of IMAP SETANNOTATIONs
+metric counter cyrus_imap_setmetadata_total             The total number of IMAP SETMETADATAs
+metric counter cyrus_imap_setquota_total                The total number of IMAP SETQUOTAs
+metric counter cyrus_imap_sort_total                    The total number of IMAP SORTs
+metric counter cyrus_imap_status_total                  The total number of IMAP STATUSs
+metric counter cyrus_imap_scan_total                    The total number of IMAP SCANs
+metric counter cyrus_imap_thread_total                  The total number of IMAP THREADs
+metric counter cyrus_imap_unauthenticate_total          The total number of IMAP UNAUTHENTICATEs
+metric counter cyrus_imap_unsubscribe_total             The total number of IMAP UNSUBSCRIBEs
+metric counter cyrus_imap_unselect_total                The total number of IMAP UNSELECTs
+metric counter cyrus_imap_xbackup_total                 The total number of IMAP XBACKUPs
+
+metric counter cyrus_lmtp_connections_total             The total number of LMTP connections
+metric gauge   cyrus_lmtp_active_connections            The number of active LMTP connections
+metric gauge   cyrus_lmtp_ready_listeners               The number of currently ready LMTP listeners
+metric counter cyrus_lmtp_shutdown_total                The number of LMTP process shutdowns
+    label cyrus_lmtp_shutdown_total status ok error
+metric counter cyrus_lmtp_authenticate_total            The total number of IMAP AUTHENTICATEs
+    label cyrus_lmtp_authenticate_total result yes no
+metric counter cyrus_lmtp_received_messages_total       The number of messages received
+metric counter cyrus_lmtp_received_bytes_total          The number of received bytes
+metric counter cyrus_lmtp_received_recipients_total     The number of received recipients
+metric counter cyrus_lmtp_transmitted_messages_total    The number of messages transmitted
+metric counter cyrus_lmtp_transmitted_bytes_total       The number of bytes transmitted
+metric counter cyrus_lmtp_sieve_redirect_total          The number of sieve REDIRECTs
+metric counter cyrus_lmtp_sieve_discard_total           The number of sieve DISCARDs
+metric counter cyrus_lmtp_sieve_reject_total            The number of sieve REJECTs
+metric counter cyrus_lmtp_sieve_fileinto_total          The number of sieve FILEINTOs
+metric counter cyrus_lmtp_sieve_snooze_total            The number of sieve SNOOZEs
+metric counter cyrus_lmtp_sieve_keep_total              The number of sieve KEEPs
+metric counter cyrus_lmtp_sieve_notify_total            The number of sieve NOTIFYs
+metric counter cyrus_lmtp_sieve_autorespond_total       The number of sieve AUTORESPONDs considered
+metric counter cyrus_lmtp_sieve_autorespond_sent_total  The number of sieve AUTORESPONDs sent
+
+metric counter cyrus_http_connections_total       The total number of HTTP connections
+metric gauge   cyrus_http_active_connections      The number of active HTTP connections
+metric gauge   cyrus_http_ready_listeners         The number of currently ready HTTP listeners
+metric counter cyrus_http_shutdown_total          The number of HTTP process shutdowns
+    label cyrus_http_shutdown_total status ok error
+metric counter cyrus_http_acl_total               The total number of HTTP ACLs
+    label cyrus_http_acl_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_bind_total              The total number of HTTP BINDs
+    label cyrus_http_bind_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_connect_total           The total number of HTTP CONNECTvs
+    label cyrus_http_connect_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_copy_total              The total number of HTTP COPYs
+    label cyrus_http_copy_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_delete_total            The total number of HTTP DELETEs
+    label cyrus_http_delete_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_get_total               The total number of HTTP GETs
+    label cyrus_http_get_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_head_total              The total number of HTTP HEADs
+    label cyrus_http_head_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_lock_total              The total number of HTTP LOCKs
+    label cyrus_http_lock_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_mkcalendar_total        The total number of HTTP MKCALENDARs
+    label cyrus_http_mkcalendar_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_mkcol_total             The total number of HTTP MKCOLs
+    label cyrus_http_mkcol_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_move_total              The total number of HTTP MOVEs
+    label cyrus_http_move_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_options_total           The total number of HTTP OPTIONSs
+    label cyrus_http_options_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_patch_total             The total number of HTTP PATCHs
+    label cyrus_http_patch_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_post_total              The total number of HTTP POSTs
+    label cyrus_http_post_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_propfind_total          The total number of HTTP PROPFINDs
+    label cyrus_http_propfind_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_proppatch_total         The total number of HTTP PROPPATCHs
+    label cyrus_http_proppatch_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_put_total               The total number of HTTP PUTs
+    label cyrus_http_put_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_report_total            The total number of HTTP REPORTs
+    label cyrus_http_report_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_trace_total             The total number of HTTP TRACEs
+    label cyrus_http_trace_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_unbind_total            The total number of HTTP UNBINDs
+    label cyrus_http_unbind_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
+metric counter cyrus_http_unlock_total            The total number of HTTP UNLOCKs
+    label cyrus_http_unlock_total namespace default admin applepush calendar freebusy addressbook principal notify dblookup ischedule domainkeys jmap prometheus rss tzdist drive cgi
diff -pruN 3.0.13-5/imap/prometheus.c 3.2.0-3/imap/prometheus.c
--- 3.0.13-5/imap/prometheus.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/prometheus.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,385 @@
+/* prometheus.c -- Aggregate statistics for prometheus
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include <config.h>
+
+#include <sys/types.h>
+
+#include <dirent.h>
+#include <errno.h>
+#include <string.h>
+#include <sysexits.h>
+#include <syslog.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "lib/assert.h"
+#include "lib/cyr_lock.h"
+#include "lib/libconfig.h"
+#include "lib/map.h"
+#include "lib/ptrarray.h"
+#include "lib/util.h"
+
+#include "imap/global.h"
+#include "imap/imap_err.h"
+#include "imap/prometheus.h"
+
+struct prometheus_handle {
+    struct mappedfile *mf;
+};
+
+static struct prometheus_handle *promhandle = NULL;
+static int prometheus_enabled = -1;
+
+static void prometheus_init(void);
+static void prometheus_done(void *rock __attribute__((unused)));
+
+EXPORTED const char *prometheus_stats_dir(void)
+{
+    static struct buf statsdir = BUF_INITIALIZER;
+    const char *tmp;
+
+    if (buf_len(&statsdir) > 0) return buf_cstring(&statsdir);
+
+    if ((tmp = config_getstring(IMAPOPT_PROMETHEUS_STATS_DIR))) {
+        if (tmp[0] != '/')
+            fatal("prometheus_stats_dir must be fully qualified", EX_CONFIG);
+
+        if (strlen(tmp) < 2)
+            fatal("prometheus_stats_dir must not be '/'", EX_CONFIG);
+
+        buf_setcstr(&statsdir, tmp);
+
+        if (statsdir.s[statsdir.len-1] != '/')
+            buf_putc(&statsdir, '/');
+    }
+    else {
+        buf_setcstr(&statsdir, config_dir);
+        buf_appendcstr(&statsdir, FNAME_PROM_STATS_DIR);
+        buf_putc(&statsdir, '/');
+    }
+
+    return buf_cstring(&statsdir);
+}
+
+static void prometheus_init(void)
+{
+    char fname[PATH_MAX];
+    struct prometheus_handle *handle = NULL;
+    struct prom_stats stats = PROM_STATS_INITIALIZER;
+    int r;
+
+    if (promhandle != NULL) return;
+
+    prometheus_enabled = config_getswitch(IMAPOPT_PROMETHEUS_ENABLED);
+    if (!prometheus_enabled) return;
+
+    r = snprintf(stats.ident, sizeof(stats.ident), "%s", config_ident);
+    if (r < 0 || (size_t) r >= sizeof(stats.ident))
+        syslog(LOG_WARNING, "service name '%s' is longer than " SIZE_T_FMT
+                            " characters - prometheus label will be truncated",
+                            config_ident,
+                            sizeof(stats.ident) - 1);
+
+    r = snprintf(fname, sizeof(fname), "%s%jd",
+                 prometheus_stats_dir(), (intmax_t) getpid());
+    if (r < 0 || (size_t) r >= sizeof(fname))
+        fatal("unable to register stats for prometheus", EX_CONFIG);
+
+    r = cyrus_mkdir(fname, 0755);
+    if (r) return;
+
+    handle = xzmalloc(sizeof(*handle));
+    r = mappedfile_open(&handle->mf, fname, MAPPEDFILE_CREATE | MAPPEDFILE_RW);
+    if (r) goto error;
+
+    r = mappedfile_writelock(handle->mf);
+    if (r) goto error;
+
+    r = mappedfile_pwrite(handle->mf, &stats, sizeof(stats), 0);
+    if (r != sizeof(stats)) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_pwrite: expected to write " SIZE_T_FMT "bytes, "
+                        "actually wrote %d",
+                        sizeof(stats), r);
+        goto error;
+    }
+
+    r = mappedfile_commit(handle->mf);
+    if (r) goto error;
+
+    r = mappedfile_unlock(handle->mf);
+    if (r) goto error;
+
+    promhandle = handle;
+    cyrus_modules_add(&prometheus_done, NULL);
+    return;
+
+error:
+    if (handle) {
+        if (handle->mf) {
+            mappedfile_unlock(handle->mf);
+            mappedfile_close(&handle->mf);
+        }
+        free(handle);
+    }
+    promhandle = NULL;
+}
+
+static void prometheus_done(void *rock __attribute__((unused)))
+{
+    struct prom_stats accum = PROM_STATS_INITIALIZER;
+    struct prom_stats thisproc = PROM_STATS_INITIALIZER;
+    struct mappedfile *doneprocs = NULL;
+    char *doneprocs_fname = NULL;
+    char *doneprocs_lock_fname;
+    int doneprocs_lock_fd;
+    int i, r = 0;
+    int unlinked = 0;
+
+    if (!promhandle) return; /* make double-call safe */
+
+    /* hold a lock on .doneprocs.lock - this keeps promstatsd from double
+     * counting while we're juggling files */
+    doneprocs_lock_fname = strconcat(prometheus_stats_dir(), ".",
+                                     FNAME_PROM_DONEPROCS, ".lock", NULL);
+
+    doneprocs_lock_fd = open(doneprocs_lock_fname, O_CREAT|O_TRUNC|O_RDWR, 0644);
+    if (doneprocs_lock_fd == -1) {
+        syslog(LOG_ERR, "can't open doneprocs lock: %s (%m)", doneprocs_lock_fname);
+        goto done;
+    }
+    if (lock_setlock(doneprocs_lock_fd, /*ex*/1, /*nb*/0, doneprocs_lock_fname)) {
+        syslog(LOG_ERR, "can't get exclusive lock on %s", doneprocs_lock_fname);
+        close(doneprocs_lock_fd);
+        doneprocs_lock_fd = -1;
+        goto done;
+    }
+
+    /* load existing doneprocs stats */
+    doneprocs_fname = strconcat(prometheus_stats_dir(), FNAME_PROM_DONEPROCS,
+                                ".", config_ident, NULL);
+    r = mappedfile_open(&doneprocs, doneprocs_fname, MAPPEDFILE_CREATE | MAPPEDFILE_RW);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_open(%s): %s",
+                        doneprocs_fname, error_message(r));
+        goto done;
+    }
+
+    r = mappedfile_writelock(doneprocs);
+    if (r) goto done;
+
+    memcpy(&accum, mappedfile_base(doneprocs), mappedfile_size(doneprocs));
+    if (accum.ident[0] == '\0') {
+        snprintf(accum.ident, sizeof(accum.ident), "%s", config_ident);
+    }
+
+    /* read stats from this process */
+    r = mappedfile_readlock(promhandle->mf);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_open(%s): %s",
+                        doneprocs_fname, error_message(r));
+        goto done;
+    }
+    memcpy(&thisproc, mappedfile_base(promhandle->mf), mappedfile_size(promhandle->mf));
+    mappedfile_unlock(promhandle->mf);
+
+    /* unlink per-process stats file, we don't need it anymore */
+    r = unlink(mappedfile_fname(promhandle->mf));
+    if (r && errno != ENOENT) goto done;
+    unlinked = 1;
+
+    /* accumulate the statistics */
+    for (i = 0; i < PROM_NUM_METRICS; i++) {
+        accum.metrics[i].value += thisproc.metrics[i].value;
+        accum.metrics[i].last_updated = MAX(accum.metrics[i].last_updated,
+                                            thisproc.metrics[i].last_updated);
+    }
+
+    /* and write it out */
+    r = mappedfile_pwrite(doneprocs, &accum, sizeof(accum), 0);
+    if (r != sizeof(accum)) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_pwrite: expected to write " SIZE_T_FMT "bytes, "
+                        "actually wrote %d",
+                        sizeof(accum), r);
+        goto done;
+    }
+
+    mappedfile_commit(doneprocs);
+
+done:
+    free(doneprocs_fname);
+
+    if (!unlinked) {
+        syslog(LOG_NOTICE, "per-process prometheus statistics file not removed");
+    }
+    mappedfile_close(&promhandle->mf);
+
+    free(promhandle);
+    promhandle = NULL;
+
+    mappedfile_unlock(doneprocs);
+    mappedfile_close(&doneprocs);
+
+    /* release .doneprocs.lock */
+    if (doneprocs_lock_fd != -1) {
+        unlink(doneprocs_lock_fname);
+        lock_unlock(doneprocs_lock_fd, doneprocs_lock_fname);
+        close(doneprocs_lock_fd);
+    }
+    free(doneprocs_lock_fname);
+}
+
+/* use the prometheus_increment() and prometheus_decrement() wrapper macros
+ * for readability if that's all you're doing.
+ */
+EXPORTED void prometheus_apply_delta(enum prom_metric_id metric_id,
+                                     double delta)
+{
+    struct prom_metric metric;
+    size_t offset;
+    int r;
+
+    if (!prometheus_enabled) return;
+
+    if (!promhandle) prometheus_init();
+
+    if (!prometheus_enabled) return;
+
+    assert(metric_id >= 0 && metric_id < PROM_NUM_METRICS);
+
+    r = mappedfile_writelock(promhandle->mf);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_writelock unable to obtain lock on %s",
+                        mappedfile_fname(promhandle->mf));
+        return;
+    }
+
+    offset = offsetof(struct prom_stats, metrics) + metric_id * sizeof(metric);
+    memcpy(&metric, mappedfile_base(promhandle->mf) + offset, sizeof(metric));
+    if (delta < 0) {
+        /* counters must not be decremented */
+        assert(prom_metric_descs[metric_id].type != PROM_METRIC_COUNTER);
+    }
+    metric.value = metric.value + delta;
+    metric.last_updated = now_ms();
+
+    r = mappedfile_pwrite(promhandle->mf, &metric, sizeof(metric), offset);
+    if (r != sizeof(metric)) {
+        syslog(LOG_ERR, "IOERROR: mappedfile_pwrite: expected to write "
+                        SIZE_T_FMT " bytes, actually wrote %d",
+                        sizeof(metric), r);
+    }
+    else {
+        mappedfile_commit(promhandle->mf);
+    }
+
+    mappedfile_unlock(promhandle->mf);
+}
+
+EXPORTED int prometheus_text_report(struct buf *buf, const char **mimetype)
+{
+    char *report_fname = NULL;
+    struct mappedfile *mf = NULL;
+    int r;
+
+    if (!prometheus_enabled) return IMAP_INTERNAL;
+
+    report_fname = strconcat(prometheus_stats_dir(), FNAME_PROM_REPORT, NULL);
+
+    r = mappedfile_open(&mf, report_fname, 0);
+    if (r) {
+        free(report_fname);
+        return r;
+    }
+
+    r = mappedfile_readlock(mf);
+    if (!r) {
+        buf_setmap(buf, mappedfile_base(mf), mappedfile_size(mf));
+        if (mimetype)
+            *mimetype = "text/plain; version=0.0.4";
+    }
+
+    mappedfile_unlock(mf);
+    mappedfile_close(&mf);
+    free(report_fname);
+
+    if (r) return r;
+
+    report_fname = strconcat(prometheus_stats_dir(), FNAME_PROM_MASTER_REPORT, NULL);
+
+    r = mappedfile_open(&mf, report_fname, 0);
+    if (r) {
+        free(report_fname);
+        return 0; /* no master.txt yet? no worries */
+    }
+
+    r = mappedfile_readlock(mf);
+    if (!r) {
+        buf_appendmap(buf, mappedfile_base(mf), mappedfile_size(mf));
+    }
+
+    mappedfile_unlock(mf);
+    mappedfile_close(&mf);
+    free(report_fname);
+
+    return 0;
+}
+
+EXPORTED enum prom_metric_id prometheus_lookup_label(enum prom_labelled_metric metric,
+                                                     const char *value)
+{
+    size_t i;
+
+    assert(metric >= 0 && metric < PROM_NUM_LABELLED_METRICS);
+
+    for (i = 0; prom_label_lookup_table[metric][i].value != NULL; i++) {
+        const struct prom_label_lookup_value *v = &prom_label_lookup_table[metric][i];
+
+        int cmp = strcmp(v->value, value);
+        if (cmp == 0) /* found it */
+            return v->id;
+        if (cmp > 0) /* gone too far, not found */
+            break;
+    }
+
+    fatal("invalid metric value -- compile time bug", EX_SOFTWARE);
+}
diff -pruN 3.0.13-5/imap/prometheus.h 3.2.0-3/imap/prometheus.h
--- 3.0.13-5/imap/prometheus.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/prometheus.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,76 @@
+/* prometheus.h -- Aggregate statistics for prometheus
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef INCLUDE_IMAP_PROMETHEUS_H
+#define INCLUDE_IMAP_PROMETHEUS_H
+
+#include <config.h>
+#include <stddef.h>
+#include <stdint.h>
+
+#include "lib/mappedfile.h"
+#include "lib/util.h"
+
+#include "imap/promdata.h"
+
+#define FNAME_PROM_REPORT "report.txt"
+#define FNAME_PROM_MASTER_REPORT "master.txt"
+#define FNAME_PROM_DONEPROCS "doneprocs"
+#define FNAME_PROM_STATS_DIR "/stats"
+
+extern const char *prometheus_stats_dir(void);
+
+#define prometheus_increment(metric_id) \
+    prometheus_apply_delta(metric_id, 1)
+
+#define prometheus_decrement(metric_id) \
+    prometheus_apply_delta(metric_id, -1)
+
+extern void prometheus_apply_delta(enum prom_metric_id metric_id,
+                                   double delta);
+
+extern int prometheus_text_report(struct buf *buf, const char **mimetype);
+
+extern enum prom_metric_id prometheus_lookup_label(enum prom_labelled_metric metric,
+                                                   const char *value);
+
+#endif
diff -pruN 3.0.13-5/imap/promstatsd.c 3.2.0-3/imap/promstatsd.c
--- 3.0.13-5/imap/promstatsd.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/promstatsd.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,773 @@
+/* promstatsd.c - daemon for collating statistics for Prometheus
+ *
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include <config.h>
+
+#include <sys/types.h>
+
+#include <dirent.h>
+#include <errno.h>
+#include <inttypes.h>
+#include <math.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <sysexits.h>
+#include <syslog.h>
+#include <unistd.h>
+
+#include "lib/bsearch.h"
+#include "lib/cyr_lock.h"
+#include "lib/hash.h"
+#include "lib/retry.h"
+#include "lib/strarray.h"
+#include "lib/util.h"
+
+#include "imap/global.h"
+#include "imap/mboxlist.h"
+#include "imap/mboxname.h"
+#include "imap/prometheus.h"
+#include "imap/quota.h"
+
+/* globals so that shut_down() can clean up */
+static struct buf report_buf = BUF_INITIALIZER;
+static struct mappedfile *report_file = NULL;
+
+static void shut_down(int ec) __attribute__((noreturn));
+static void shut_down(int ec)
+{
+    mappedfile_close(&report_file);
+    buf_free(&report_buf);
+    cyrus_done();
+    exit(ec);
+}
+
+EXPORTED void fatal(const char *msg, int err)
+{
+    syslog(LOG_CRIT, "%s", msg);
+    syslog(LOG_NOTICE, "exiting");
+
+    shut_down(err);
+}
+
+static const char *argv0 = NULL;
+static void usage(void)
+{
+    fprintf(stderr, "Usage:\n");
+    fprintf(stderr, "    %s [-C alt_config] [-v] [-f frequency] [-d]\n", argv0);
+    fprintf(stderr, "    %s [-C alt_config] [-v] -c\n", argv0);
+    exit(EX_USAGE);
+}
+
+static void save_argv0(const char *s)
+{
+    const char *slash = strrchr(s, '/');
+    if (slash)
+        argv0 = slash + 1;
+    else
+        argv0 = s;
+}
+
+static int do_cleanup(void)
+{
+    const char *basedir = prometheus_stats_dir();
+    DIR *dh;
+    struct dirent *dirent;
+
+    dh = opendir(basedir);
+    if (!dh) {
+        if (errno == ENOENT) return 0; /* nothing to do */
+        syslog(LOG_ERR, "IOERROR: opendir(%s): %m", basedir);
+        return EX_IOERR;
+    }
+
+    while ((dirent = readdir(dh))) {
+        char path[PATH_MAX];
+        int r;
+
+        if (dirent->d_name[0] == '.') continue;
+
+        r = snprintf(path, sizeof(path), "%s%s", basedir, dirent->d_name);
+        if (r < 0 || (size_t) r >= sizeof(path)) {
+            syslog(LOG_ERR, "IOERROR: path too long: %s%s", basedir, dirent->d_name);
+            continue;
+        }
+
+        unlink(path);
+    }
+
+    closedir(dh);
+    return 0;
+}
+
+enum promdir_foreach_mode {
+    PROMDIR_FOREACH_PIDS,
+    PROMDIR_FOREACH_DONEPROCS,
+};
+typedef int promdir_foreach_cb(const struct prom_stats *stats, void *rock);
+static int promdir_foreach(promdir_foreach_cb *proc, enum promdir_foreach_mode mode, void *rock)
+{
+    const char *basedir;
+    DIR *dh;
+    struct dirent *dirent;
+    int r = 0;
+
+    basedir = prometheus_stats_dir();
+
+    dh = opendir(basedir);
+    if (!dh) {
+        syslog(LOG_ERR, "IOERROR: prometheus_foreach opendir(%s): %m", basedir);
+        return -1;
+    }
+
+    while ((dirent = readdir(dh))) {
+        char fname[PATH_MAX];
+        struct prom_stats stats;
+        struct mappedfile *mf = NULL;
+
+        /* skip filenames we don't care about */
+        if (dirent->d_name[0] == '.') continue;
+        if (mode == PROMDIR_FOREACH_PIDS && !cyrus_isdigit(dirent->d_name[0])) continue;
+        if (mode == PROMDIR_FOREACH_DONEPROCS && dirent->d_name[0] != 'd') continue;
+
+        r = snprintf(fname, sizeof(fname), "%s%s", basedir, dirent->d_name);
+        if (r < 0 || (size_t) r >= sizeof(fname)) {
+            syslog(LOG_ERR, "IOERROR: path too long: %s%s", basedir, dirent->d_name);
+            continue;
+        }
+
+        r = mappedfile_open(&mf, fname, 0);
+        if (r) continue;
+        r = mappedfile_readlock(mf);
+        if (!r) {
+            memcpy(&stats, mappedfile_base(mf), mappedfile_size(mf));
+            mappedfile_unlock(mf);
+        }
+        mappedfile_close(&mf);
+
+        r = proc(&stats, rock);
+        if (r) break;
+    }
+
+    closedir(dh);
+
+    return r;
+}
+
+static int accum_stats(const struct prom_stats *stats, void *rock)
+{
+    struct prom_stats *stats_copy;
+    hash_table *h = (hash_table *) rock;
+    int i;
+
+    stats_copy = hash_lookup(stats->ident, h);
+    if (!stats_copy) {
+        stats_copy = xzmalloc(sizeof *stats_copy);
+        strcpy(stats_copy->ident, stats->ident);
+        hash_insert(stats->ident, stats_copy, h);
+    }
+
+    for (i = 0; i < PROM_NUM_METRICS; i++) {
+        stats_copy->metrics[i].value += stats->metrics[i].value;
+        stats_copy->metrics[i].last_updated = MAX(stats_copy->metrics[i].last_updated,
+                                                  stats->metrics[i].last_updated);
+    }
+
+    return 0;
+}
+
+struct format_metric_rock {
+    struct buf *buf;
+    enum prom_metric_id metric;
+};
+
+static void format_metric(const char *key __attribute__((unused)),
+                          void *data, void *rock)
+{
+    struct prom_stats *stats = (struct prom_stats *) data;
+    struct format_metric_rock *fmrock = (struct format_metric_rock *) rock;
+
+    /* don't report service/metric combinations that have never been seen */
+    if (!stats->metrics[fmrock->metric].last_updated)
+        return;
+
+    buf_appendcstr(fmrock->buf, prom_metric_descs[fmrock->metric].name);
+    buf_printf(fmrock->buf, "{service=\"%s\"", stats->ident);
+    if (prom_metric_descs[fmrock->metric].label)
+        buf_printf(fmrock->buf, ",%s", prom_metric_descs[fmrock->metric].label);
+    buf_printf(fmrock->buf, "} %0.f %" PRId64 "\n",
+                            stats->metrics[fmrock->metric].value,
+                            stats->metrics[fmrock->metric].last_updated);
+}
+
+static void do_collate_report(struct buf *buf)
+{
+    hash_table all_stats = HASH_TABLE_INITIALIZER;
+    char *doneprocs_lock_fname;
+    int doneprocs_lock_fd;
+    int i;
+
+    buf_reset(buf);
+    construct_hash_table(&all_stats, 128, 0);
+
+    /* hold a lock on .doneprocs.lock while reading stats files - this ensures
+     * process cleanups won't lead to double counts while we're collating */
+    doneprocs_lock_fname = strconcat(prometheus_stats_dir(), ".",
+                                     FNAME_PROM_DONEPROCS, ".lock", NULL);
+
+    doneprocs_lock_fd = open(doneprocs_lock_fname, O_CREAT|O_TRUNC|O_RDWR, 0644);
+    if (doneprocs_lock_fd == -1) {
+        syslog(LOG_ERR, "can't open doneprocs lock: %s (%m)", doneprocs_lock_fname);
+        free_hash_table(&all_stats, NULL);
+        return;
+    }
+    if (lock_setlock(doneprocs_lock_fd, /*ex*/1, /*nb*/0, doneprocs_lock_fname)) {
+        syslog(LOG_ERR, "can't get exclusive lock on %s", doneprocs_lock_fname);
+        close(doneprocs_lock_fd);
+        doneprocs_lock_fd = -1;
+        free(doneprocs_lock_fname);
+        free_hash_table(&all_stats, NULL);
+        return;
+    }
+
+    /* slurp up and accumulate doneprocs stats */
+    promdir_foreach(&accum_stats, PROMDIR_FOREACH_DONEPROCS, &all_stats);
+
+    /* slurp up and accumulate current stats */
+    promdir_foreach(&accum_stats, PROMDIR_FOREACH_PIDS, &all_stats);
+
+    syslog(LOG_DEBUG, "updating prometheus report for %d services",
+                      hash_numrecords(&all_stats));
+
+    /* release .doneprocs.lock */
+    unlink(doneprocs_lock_fname);
+    lock_unlock(doneprocs_lock_fd, doneprocs_lock_fname);
+    close(doneprocs_lock_fd);
+    free(doneprocs_lock_fname);
+
+    /* format it into buf */
+    for (i = 0; i < PROM_NUM_METRICS; i++) {
+        if (prom_metric_descs[i].help) {
+            buf_printf(buf, "# HELP %s %s\n", prom_metric_descs[i].name,
+                            prom_metric_descs[i].help);
+        }
+        if (prom_metric_descs[i].type != PROM_METRIC_CONTINUED) {
+            buf_printf(buf, "# TYPE %s %s\n", prom_metric_descs[i].name,
+                            prom_metric_type_names[prom_metric_descs[i].type]);
+        }
+
+        struct format_metric_rock fmrock = { buf, i };
+        hash_enumerate(&all_stats, &format_metric, &fmrock);
+    }
+
+    /* clean up the copy */
+    free_hash_table(&all_stats, free);
+}
+
+struct partition_data {
+    int64_t n_users;
+    int64_t n_mailboxes;
+    int64_t n_deleted;
+    hash_table shared;
+
+    double quota_commitment[QUOTA_NUMRESOURCES];
+
+    int64_t timestamp;
+};
+
+static void free_partition_data(void *ptr)
+{
+    struct partition_data *pdata = (struct partition_data *) ptr;
+
+    free_hash_table(&pdata->shared, free);
+    memset(pdata, 0, sizeof *pdata);
+    free(pdata);
+}
+
+/* Tricky optimisation to avoid excess unlocking in twoskip:
+ * instead of using the cb hook, we use the p hook and ALWAYS return 0.
+ * We wouldn't need this if cyrusdb had a real readonly foreach API
+ */
+static int count_users_mailboxes(struct findall_data *data, void *rock)
+{
+    hash_table *h = (hash_table *) rock;
+    struct partition_data *pdata;
+
+    /* don't want partial matches */
+    if (!data || !data->is_exactmatch) return 0;
+
+    /* don't want intermediates XXX unless we do? in which case count them! */
+    if (!data->mbentry->partition) return 0;
+
+    pdata = hash_lookup(data->mbentry->partition, h);
+    if (!pdata) {
+        pdata = malloc(sizeof *pdata);
+        memset(pdata, 0, sizeof *pdata);
+        construct_hash_table(&pdata->shared, 10, 0); /* 10 shared namespaces probably enough */
+        hash_insert(data->mbentry->partition, pdata, h);
+    }
+
+    if (mbname_isdeleted(data->mbname)) {
+        pdata->n_deleted ++;
+        pdata->timestamp = now_ms();
+    }
+    else if (mbname_category(data->mbname, mboxname_get_adminnamespace(), NULL)
+             == MBNAME_SHARED) {
+        const char *namespace = strarray_nth(mbname_boxes(data->mbname), 0);
+        int64_t *n_shared = hash_lookup(namespace, &pdata->shared);
+        if (!n_shared) {
+            n_shared = malloc(sizeof *n_shared);
+            *n_shared = 0;
+            hash_insert(namespace, n_shared, &pdata->shared);
+        }
+
+        (*n_shared)++;
+        pdata->timestamp = now_ms();
+    }
+    else if (mbname_userid(data->mbname) &&
+        !strarray_size(mbname_boxes(data->mbname))) {
+        pdata->n_users ++;
+        pdata->n_mailboxes ++; /* an inbox is also a mailbox */
+        pdata->timestamp = now_ms();
+    }
+    else {
+        pdata->n_mailboxes ++;
+        pdata->timestamp = now_ms();
+    }
+
+    return 0;
+}
+
+struct quota_rock {
+    struct quota *quota;
+    hash_table *data;
+    hash_table *seen;
+};
+
+static int quota_cb(const mbentry_t *mbentry, void *rock)
+{
+    struct quota_rock *qrock = (struct quota_rock *) rock;
+    struct partition_data *pdata;
+    const char *partition;
+    char qroot[MAX_MAILBOX_NAME];
+    int res;
+
+    /* don't count if it belongs to a different quotaroot */
+    if (quota_findroot(qroot, sizeof(qroot), mbentry->name)
+        && strcmp(qroot, qrock->quota->root) != 0) {
+        return 0;
+    }
+
+    /* no partition? nothing to count */
+    if (!mbentry->partition) {
+        return 0;
+    }
+
+    partition = mbentry->partition;
+    if (hash_lookup(partition, qrock->seen)) {
+        /* seen this partition for this quotaroot already, don't double count it */
+        return 0;
+    }
+
+    pdata = hash_lookup(partition, qrock->data);
+
+    for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
+        struct quota *q = qrock->quota;
+        double dv = q->limits[res] < 0 ? INFINITY : q->limits[res];
+
+        pdata->quota_commitment[res] += dv;
+    }
+    pdata->timestamp = now_ms();
+
+    hash_insert(partition, (void *) 1, qrock->seen);
+    return 0;
+}
+
+static int count_quota_commitments(struct quota *quota, void *rock)
+{
+    struct quota_rock *qrock = (struct quota_rock *) rock;
+    hash_table seen = HASH_TABLE_INITIALIZER;
+    int r;
+
+    construct_hash_table(&seen, 10, 0); /* XXX */
+    qrock->seen = &seen;
+    qrock->quota = quota;
+
+    r = mboxlist_mboxtree(quota->root, quota_cb, qrock, 0);
+
+    qrock->quota = NULL;
+    free_hash_table(&seen, NULL);
+    qrock->seen = NULL;
+
+    return r;
+}
+
+static void pname_cb(const char *key,
+                     void *data __attribute__((unused)),
+                     void *rock)
+{
+    strarray_append((strarray_t *) rock, key);
+}
+
+static strarray_t *get_partition_names(hash_table *h)
+{
+    strarray_t *names = strarray_new();
+    hash_enumerate(h, pname_cb, names);
+    strarray_sort(names, cmpstringp_raw);
+    return names;
+}
+
+#define FORMAT_USAGE_INT64(metric, type, help, member, buf, pnames, h) \
+do {                                                                         \
+    const char *___metric = (metric);                                        \
+    const char *___type = (type);                                            \
+    const char *___help = (help);                                            \
+    struct buf *___buf = (buf);                                              \
+    const strarray_t *___pnames = (pnames);                                  \
+    hash_table *___h = (h);                                                  \
+    int i;                                                                   \
+                                                                             \
+    buf_printf(___buf, "# HELP %s %s\n", ___metric, ___help);                \
+    buf_printf(___buf, "# TYPE %s %s\n", ___metric, ___type);                \
+                                                                             \
+    for (i = 0; i < strarray_size(___pnames); i++) {                         \
+        struct partition_data *pdata =                                       \
+            hash_lookup(strarray_nth(___pnames, i), ___h);                   \
+                                                                             \
+        buf_printf(___buf, "%s{partition=\"%s\"} %" PRId64 " %" PRId64 "\n", \
+                        ___metric,                                           \
+                        strarray_nth(___pnames, i),                          \
+                        pdata->member,                                       \
+                        pdata->timestamp);                                   \
+    }                                                                        \
+} while(0)
+
+struct shared_mailbox_rock {
+    struct buf *buf;
+    char *partition;
+    int64_t timestamp;
+};
+
+static void format_usage_shared_mailbox(const char *key, void *data, void *rock)
+{
+    struct shared_mailbox_rock *smrock = (struct shared_mailbox_rock *) rock;
+    int64_t n_shared = *(int64_t *) data;
+
+    buf_printf(smrock->buf, "%s{partition=\"%s\",namespace=\"%s\"}",
+                            "cyrus_usage_shared_mailboxes",
+                            smrock->partition,
+                            key);
+    buf_printf(smrock->buf, " %" PRId64 " %" PRId64 "\n",
+                            n_shared,
+                            smrock->timestamp);
+}
+
+static void format_usage_shared_mailboxes(struct buf *buf,
+                                          const strarray_t *pnames,
+                                          hash_table *h)
+{
+    int i;
+
+    buf_printf(buf, "# HELP %s %s\n",
+                    "cyrus_usage_shared_mailboxes",
+                    "The number of shared Cyrus mailboxes");
+    buf_appendcstr(buf, "# TYPE cyrus_usage_shared_mailboxes gauge\n");
+
+    for (i = 0; i < strarray_size(pnames); i++) {
+        struct shared_mailbox_rock smrock;
+        struct partition_data *pdata;
+
+        smrock.buf = buf;
+        smrock.partition = (char *) strarray_nth(pnames, i); /* n.b. casting away const */
+
+        pdata = hash_lookup(smrock.partition, h);
+        smrock.timestamp = pdata->timestamp;
+
+        hash_enumerate(&pdata->shared, format_usage_shared_mailbox, &smrock);
+    }
+}
+
+static void format_usage_quota_commitment(struct buf *buf,
+                                          const strarray_t *pnames,
+                                          hash_table *h)
+{
+    int i, res;
+    buf_printf(buf, "# HELP %s %s\n",
+                    "cyrus_usage_quota_commitment",
+                    "The amount of quota committed");
+    buf_appendcstr(buf, "# TYPE cyrus_usage_quota_commitment gauge\n");
+
+    for (i = 0; i < strarray_size(pnames); i++) {
+        struct partition_data *pdata = hash_lookup(strarray_nth(pnames, i), h);
+
+        for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
+            buf_printf(buf, "%s{partition=\"%s\",resource=\"%s\"}",
+                            "cyrus_usage_quota_commitment",
+                            strarray_nth(pnames, i),
+                            quota_names[res]);
+            buf_printf(buf, " %.0f %" PRId64 "\n",
+                            pdata->quota_commitment[res],
+                            pdata->timestamp);
+        }
+    }
+}
+
+static void do_collate_usage(struct buf *buf)
+{
+    hash_table h = HASH_TABLE_INITIALIZER;
+    strarray_t *partition_names = NULL;
+    int r;
+    int64_t starttime;
+
+    construct_hash_table(&h, 10, 0); /* 10 partitions is probably enough right */
+
+    starttime = now_ms();
+    r = mboxlist_findall_withp(NULL /* admin namespace */,
+                               "*", 1,
+                               NULL, NULL,
+                               count_users_mailboxes, NULL, &h);
+    syslog(LOG_DEBUG, "counted users and mailboxes in %f seconds",
+                      (now_ms() - starttime) / 1000.0);
+
+    if (!r) {
+        struct quota_rock rock = { NULL, &h, NULL };
+
+        starttime = now_ms();
+        r = quota_foreach(NULL, count_quota_commitments, &rock, NULL);
+        syslog(LOG_DEBUG, "counted quota commitments in %f seconds",
+                          (now_ms() - starttime) / 1000.0);
+
+    }
+
+    /* need to invert the hash table on output, so build a list of its keys */
+    partition_names = get_partition_names(&h);
+
+    FORMAT_USAGE_INT64("cyrus_usage_deleted_mailboxes", "gauge",
+                       "The number of deleted Cyrus mailboxes",
+                       n_deleted,
+                       buf, partition_names, &h);
+
+    FORMAT_USAGE_INT64("cyrus_usage_users", "gauge",
+                       "The number of Cyrus user Inboxes",
+                       n_users,
+                       buf, partition_names, &h);
+
+    FORMAT_USAGE_INT64("cyrus_usage_mailboxes", "gauge",
+                       "The number of Cyrus mailboxes",
+                       n_mailboxes,
+                       buf, partition_names, &h);
+
+    format_usage_shared_mailboxes(buf, partition_names, &h);
+
+    format_usage_quota_commitment(buf, partition_names, &h);
+
+    strarray_free(partition_names);
+    free_hash_table(&h, free_partition_data);
+}
+
+static void do_write_report(struct mappedfile *mf, const struct buf *report)
+{
+    int r;
+
+    r = mappedfile_writelock(mf);
+    if (r) fatal("couldn't write lock report file", EX_IOERR);
+
+    r = mappedfile_pwritebuf(mf, report, 0);
+    if (r < 0) fatal("error writing report file", EX_IOERR);
+
+    mappedfile_truncate(mf, buf_len(report));
+
+    r = mappedfile_commit(mf);
+    if (r) fatal("error committing report file", EX_IOERR);
+
+    mappedfile_unlock(mf);
+}
+
+int main(int argc, char **argv)
+{
+    save_argv0(argv[0]);
+
+    const char *alt_config = NULL;
+    int call_debugger = 0;
+    char *report_fname = NULL;
+    struct mappedfile *report_file = NULL;
+    const char *p;
+    int cleanup = 0;
+    int debugmode = 0;
+    int verbose = 0;
+    int frequency = 0;
+    int oneshot = 0;
+    int opt;
+    int r;
+
+    p = getenv("CYRUS_VERBOSE");
+    if (p) verbose = atoi(p) + 1;
+
+    while ((opt = getopt(argc, argv, "C:D1cdf:v")) != -1) {
+        switch (opt) {
+        case 'C': /* alt config file */
+            alt_config = optarg;
+            break;
+
+        case 'D': /* run gdb */
+            call_debugger = 1;
+            break;
+
+        case '1': /* produce report once and exit */
+            oneshot = 1;
+            break;
+
+        case 'c': /* cleanup stats directory and exit */
+            cleanup = 1;
+            break;
+
+        case 'd': /* debug mode (no fork) */
+            debugmode = 1;
+            break;
+
+        case 'f': /* set frequency */
+            frequency = atoi(optarg);
+            if (frequency <= 0) usage();
+            break;
+
+        case 'v': /* verbose */
+            verbose ++;
+            break;
+
+        default:
+            usage();
+            break;
+        }
+    }
+
+    cyrus_init(alt_config, "promstatsd", 0, 0);
+    signals_set_shutdown(shut_down);
+    signals_add_handlers(0);
+
+    if (cleanup) {
+        shut_down(do_cleanup());
+    }
+
+    if (!config_getswitch(IMAPOPT_PROMETHEUS_ENABLED)) {
+        fatal("Prometheus metrics are not being tracked."
+              "  Set prometheus_enable in imapd.conf",
+              EX_CONFIG);
+    }
+
+    /* fork unless we were given the -d option or we're running as a daemon */
+    if (oneshot == 0 && debugmode == 0 && !getenv("CYRUS_ISDAEMON")) {
+        pid_t pid = fork();
+
+        if (pid == -1) {
+            fatal("fork failed", EX_OSERR);
+        }
+
+        if (pid != 0) { /* parent */
+            exit(0);
+        }
+    }
+
+    if (call_debugger) {
+        char debugbuf[1024];
+        int ret;
+        const char *debugger = config_getstring(IMAPOPT_DEBUG_COMMAND);
+        if (debugger) {
+            snprintf(debugbuf, sizeof(debugbuf), debugger,
+                     argv[0], getpid(), "promstatsd");
+            syslog(LOG_DEBUG, "running external debugger: %s", debugbuf);
+            ret = system(debugbuf); /* run debugger */
+            syslog(LOG_DEBUG, "debugger returned exit status: %d", ret);
+        }
+    }
+
+    if (frequency <= 0)
+        frequency = config_getduration(IMAPOPT_PROMETHEUS_UPDATE_FREQ, 's');
+    if (frequency <= 0)
+        frequency = 10;
+
+    report_fname = strconcat(prometheus_stats_dir(), FNAME_PROM_REPORT, NULL);
+    syslog(LOG_DEBUG, "updating %s every %d seconds", report_fname, frequency);
+
+    unlink(report_fname);
+    r = mappedfile_open(&report_file, report_fname, MAPPEDFILE_CREATE | MAPPEDFILE_RW);
+    free(report_fname);
+    if (r) fatal("couldn't open report file", EX_IOERR);
+
+    for (;;) {
+        int sig;
+        int64_t starttime;
+
+        sig = signals_poll();
+        if (sig == SIGHUP && getenv("CYRUS_ISDAEMON")) {
+            syslog(LOG_DEBUG, "received SIGHUP, shutting down gracefully\n");
+            shut_down(0);
+        }
+
+        /* check for shutdown file */
+        if (shutdown_file(NULL, 0)) {
+            if (verbose || debugmode)
+                syslog(LOG_DEBUG, "Detected shutdown file\n");
+            shut_down(0);
+        }
+
+        starttime = now_ms();
+        do_collate_report(&report_buf);
+        syslog(LOG_DEBUG, "collated service report in %f seconds",
+                (now_ms() - starttime) / 1000.0);
+
+        starttime = now_ms();
+        do_collate_usage(&report_buf);
+        syslog(LOG_DEBUG, "collated usage report in %f seconds",
+                (now_ms() - starttime) / 1000.0);
+
+        do_write_report(report_file, &report_buf);
+
+        if (oneshot) {
+            shut_down(0);
+        }
+
+        /* then wait around a bit */
+        sleep(frequency); /* XXX substract elapsed time? */
+    }
+
+    /* NOTREACHED */
+    shut_down(EX_SOFTWARE);
+}
diff -pruN 3.0.13-5/imap/protocol.h 3.2.0-3/imap/protocol.h
--- 3.0.13-5/imap/protocol.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/protocol.h	2020-04-24 02:03:00.000000000 +0000
@@ -63,7 +63,7 @@ enum {
     CAPA_COMPRESS       = (1 << 2)
 
     /*
-      protocol specific capabilites MUST be in the range
+      protocol specific capabilities MUST be in the range
       (1 << 3) .. (1 << MAX_CAPA)
     */
 };
diff -pruN 3.0.13-5/imap/proxy.c 3.2.0-3/imap/proxy.c
--- 3.0.13-5/imap/proxy.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/proxy.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,11 +46,11 @@
 #include <signal.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/un.h>
 
 #include "backend.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mupdate-client.h"
 #include "proxy.h"
@@ -227,7 +227,7 @@ EXPORTED int proxy_check_input(struct pr
                     timeout_sec ? &timeout : NULL);
     if (n == -1 && errno != EINTR) {
         syslog(LOG_ERR, "prot_select() failed in proxy_check_input(): %m");
-        fatal("prot_select() failed in proxy_check_input()", EC_TEMPFAIL);
+        fatal("prot_select() failed in proxy_check_input()", EX_TEMPFAIL);
     }
 
     if (n && protout) {
@@ -253,7 +253,7 @@ EXPORTED int proxy_check_input(struct pr
             else {
                 /* XXX shouldn't get here !!! */
                 fatal("unknown protstream returned by prot_select in proxy_check_input()",
-                      EC_SOFTWARE);
+                      EX_SOFTWARE);
             }
 
             if (pout) {
@@ -275,7 +275,7 @@ EXPORTED int proxy_check_input(struct pr
                     else {
                         /* uh oh, we're not happy */
                         fatal("Lost connection to input stream",
-                              EC_UNAVAILABLE);
+                              EX_UNAVAILABLE);
                     }
                 }
                 else {
diff -pruN 3.0.13-5/imap/pushstats.c 3.2.0-3/imap/pushstats.c
--- 3.0.13-5/imap/pushstats.c	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/imap/pushstats.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,582 +0,0 @@
-
-/* pushstats.c -- automatically generated from /home/ellie/fastmail/cyrus-imapd/imap/pushstats.snmp by snmpgen */
-
-
-
-#ifdef USING_SNMPGEN
-
-
-
-/* We disable this code for now since it doesn't actually work and wastes
-
- * resources.  At some point in time, we'll make it work again as it would
-
- * be useful to gather aggregate statistics on what commands are being used
-
- * so we can better tune the server.  This change closes bug #1191.
-
- * New bug 1267 opened to re-enable the feature.
-
- */
-
-
-
-#ifdef HAVE_UNISTD_H
-
-#include <unistd.h>
-
-#endif
-
-#include <stdio.h>
-
-#include <stdlib.h>
-
-#include <errno.h>
-
-#include <string.h>
-
-#include <sys/types.h>
-
-#include <sys/socket.h>
-
-#include <sys/un.h>
-
-#include <fcntl.h>
-
-#include <stdarg.h>
-
-
-
-#include "index.h"
-
-#include "pushstats.h"
-
-
-
-extern int close(int);
-
-
-
-int variable_value[1+1];
-
-int variable_tmpvalue[1+1];
-
-
-
-int varvalue(pushstats_variable_t var)
-
-{
-
-    if (variable_tmpvalue[var]!=-1)
-
-        return variable_tmpvalue[var];
-
-
-
-    return variable_value[var];
-
-}
-
-
-
-const char *snmp_getdescription(pushstats_t evt)
-
-{
-
-    switch (evt) {
-
-        case UNSELECT_COUNT: return "Number of unselect";
-        case GETQUOTAROOT_COUNT: return "Number of getquotaroot";
-        case EXAMINE_COUNT: return "Number of examine";
-        case SETANNOTATION_COUNT: return "Number of setannotation";
-        case TOTAL_CONNECTIONS: return "Count of the total number of connections since the beginning of time";
-        case LSUB_COUNT: return "Number of lsub";
-        case LOGOUT_COUNT: return "Number of logout";
-        case GETANNOTATION_COUNT: return "Number of getannotation";
-        case ACTIVE_CONNECTIONS: return "Count of the active number of connections";
-        case SETACL_COUNT: return "Number of setacl";
-        case CLOSE_COUNT: return "Number of close";
-        case LOGIN_COUNT: return "Number of login";
-        case PARTIAL_COUNT: return "Number of partial";
-        case AUTHENTICATION_NO: return "Failed authentication of given mechanism";
-        case APPEND_COUNT: return "Number of append";
-        case FETCH_COUNT: return "Number of fetch";
-        case CREATE_COUNT: return "Number of create";
-        case LIST_COUNT: return "Number of list";
-        case NOOP_COUNT: return "Number of noop";
-        case GETQUOTA_COUNT: return "Number of getquota";
-        case UNSUBSCRIBE_COUNT: return "Number of unsubscribe";
-        case SETQUOTA_COUNT: return "Number of setquota";
-        case CAPABILITY_COUNT: return "Number of capability";
-        case BBOARD_COUNT: return "Number of bboard";
-        case LISTRIGHTS_COUNT: return "Number of listrights";
-        case FIND_COUNT: return "Number of find";
-        case CHECK_COUNT: return "Number of check";
-        case AUTHENTICATION_YES: return "Successful authentication of given mechanism";
-        case SORT_COUNT: return "Number of sort";
-        case SERVER_NAME_VERSION: return "Name and version string for server";
-        case SELECT_COUNT: return "Number of select";
-        case IDLE_COUNT: return "Number of idle";
-        case COMPRESS_COUNT: return "Number of compress";
-        case GETUIDS_COUNT: return "Number of getuids";
-        case DELETEACL_COUNT: return "Number of deleteacl";
-        case STORE_COUNT: return "Number of store";
-        case THREAD_COUNT: return "Number of thread";
-        case EXPUNGE_COUNT: return "Number of expunge";
-        case NAMESPACE_COUNT: return "Number of namespace";
-        case SERVER_UPTIME: return "Amount of time server has been running";
-        case AUTHENTICATE_COUNT: return "Number of authenticate";
-        case GETACL_COUNT: return "Number of getacl";
-        case STARTTLS_COUNT: return "Number of starttls";
-        case SEARCH_COUNT: return "Number of search";
-        case MYRIGHTS_COUNT: return "Number of myrights";
-        case DELETE_COUNT: return "Number of delete";
-        case STATUS_COUNT: return "Number of status";
-        case SCAN_COUNT: return "Number of list";
-        case COPY_COUNT: return "Number of copy";
-        case SUBSCRIBE_COUNT: return "Number of subscribe";
-        case ID_COUNT: return "Number of id";
-        case RENAME_COUNT: return "Number of rename";
-
-    }
-
-    return NULL;
-
-}
-
-
-
-const char *snmp_getoid(const char *name __attribute__((unused)),
-
-                        pushstats_t evt, char *buf, int buflen)
-
-{
-
-    switch (evt) {
-
-        case UNSELECT_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.45"); return buf;
-        case GETQUOTAROOT_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.18"); return buf;
-        case EXAMINE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.12"); return buf;
-        case SETANNOTATION_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.39"); return buf;
-        case TOTAL_CONNECTIONS: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.1.1"); return buf;
-        case LSUB_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.25"); return buf;
-        case LOGOUT_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.23"); return buf;
-        case GETANNOTATION_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.16"); return buf;
-        case ACTIVE_CONNECTIONS: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.1.2"); return buf;
-        case SETACL_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.38"); return buf;
-        case CLOSE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.7"); return buf;
-        case LOGIN_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.22"); return buf;
-        case PARTIAL_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.30"); return buf;
-        case AUTHENTICATION_NO: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.2.%d.1",varvalue(VARIABLE_AUTH)); return buf;
-        case APPEND_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.1"); return buf;
-        case FETCH_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.13"); return buf;
-        case CREATE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.6"); return buf;
-        case LIST_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.24"); return buf;
-        case NOOP_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.28"); return buf;
-        case GETQUOTA_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.17"); return buf;
-        case UNSUBSCRIBE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.44"); return buf;
-        case SETQUOTA_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.40"); return buf;
-        case CAPABILITY_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.3"); return buf;
-        case BBOARD_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.2"); return buf;
-        case LISTRIGHTS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.26"); return buf;
-        case FIND_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.14"); return buf;
-        case CHECK_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.4"); return buf;
-        case AUTHENTICATION_YES: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.2.%d.0",varvalue(VARIABLE_AUTH)); return buf;
-        case SORT_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.42"); return buf;
-        case SERVER_NAME_VERSION: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.3.0"); return buf;
-        case SELECT_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.35"); return buf;
-        case IDLE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.21"); return buf;
-        case COMPRESS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.8"); return buf;
-        case GETUIDS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.19"); return buf;
-        case DELETEACL_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.10"); return buf;
-        case STORE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.34"); return buf;
-        case THREAD_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.43"); return buf;
-        case EXPUNGE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.11"); return buf;
-        case NAMESPACE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.29"); return buf;
-        case SERVER_UPTIME: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.3.1"); return buf;
-        case AUTHENTICATE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.0"); return buf;
-        case GETACL_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.15"); return buf;
-        case STARTTLS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.33"); return buf;
-        case SEARCH_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.36"); return buf;
-        case MYRIGHTS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.27"); return buf;
-        case DELETE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.9"); return buf;
-        case STATUS_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.41"); return buf;
-        case SCAN_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.32"); return buf;
-        case COPY_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.5"); return buf;
-        case SUBSCRIBE_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.37"); return buf;
-        case ID_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.20"); return buf;
-        case RENAME_COUNT: snprintf(buf,buflen,"1.3.6.1.4.1.3.2.2.3.1.4.31"); return buf;
-
-    }
-
-    return NULL;
-
-}
-
-
-
-#define SOCK_PATH "/tmp/.snmp_door"
-
-
-
-static int mysock = -1;
-
-static struct sockaddr_un remote;
-
-static int sockaddr_len = 0;
-
-
-
-static void snmp_send(char *str)
-
-{
-
-    if (mysock == -1) return;
-
-
-
-    if (sendto(mysock, str, strlen(str), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return;
-
-    }
-
-
-
-    return;
-
-}
-
-
-
-int snmp_connect(void)
-
-{
-
-    int s;
-
-    int fdflags;
-
-    int lup;
-
-
-
-    if ((s = socket(AF_UNIX, SOCK_DGRAM, 0)) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    for (lup=0;lup < 1+1; lup++)
-
-        variable_tmpvalue[lup] = -1;
-
-
-
-    remote.sun_family = AF_UNIX;
-
-    strlcpy(remote.sun_path, SOCK_PATH, sizeof(remote.sun_path));
-
-    sockaddr_len = strlen(remote.sun_path) + sizeof(remote.sun_family);
-
-
-
-    /* put us in non-blocking mode */
-
-    fdflags = fcntl(s, F_GETFD, 0);
-
-    if (fdflags != -1) fdflags = fcntl(s, F_SETFL, O_NONBLOCK | fdflags);
-
-    if (fdflags == -1) { close(s); return -1; }
-
-
-
-    mysock = s;
-
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.1.1\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.1.2\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.1.3\n");
-    snmp_send("R 1.3.6.1.4.1.3.2.2.3.1.4\n");
-
-    return 0;
-
-}
-
-
-
-int snmp_close(void)
-
-{
-
-    if (mysock > -1)
-
-        close(mysock);
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_increment_args(pushstats_t cmd, int incr, ...)
-
-{
-
-    char tosend[256]; /* xxx UDP max size??? */
-
-    char buf[256];
-
-
-
-      va_list ap; /* varargs thing */
-
-      pushstats_variable_t vval;
-
-      int ival;
-
-
-
-      if (mysock == -1) return 1;
-
-
-
-      va_start(ap, incr);
-
-
-
-      do {
-
-          vval = va_arg(ap, pushstats_variable_t); /* get the next arg */
-
-
-
-          if (vval!=VARIABLE_LISTEND)
-
-          {
-
-              ival = va_arg(ap, int); /* get the next arg */
-
-              variable_tmpvalue[vval] = ival;
-
-          }
-
-
-
-      } while ( vval != VARIABLE_LISTEND);
-
-
-
-      va_end(ap);
-
-
-
-    snprintf(tosend, sizeof(tosend),"C %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), incr);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    /* set tmp variables back */
-
-    va_start(ap, incr);
-
-
-
-      do {
-
-          vval = va_arg(ap, pushstats_variable_t); /* get the next arg */
-
-
-
-          if (vval!=VARIABLE_LISTEND)
-
-          {
-
-              ival = va_arg(ap, int); /* get the next arg */
-
-              variable_tmpvalue[vval] = -1;
-
-          }
-
-
-
-      } while ( vval != VARIABLE_LISTEND);
-
-
-
-      va_end(ap);
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_increment(pushstats_t cmd, int incr)
-
-{
-
-    char tosend[256]; /* xxx UDP max size??? */
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"C %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), incr);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 0;
-
-}
-
-
-
-int snmp_set(pushstats_t cmd, int value)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"I %s %d\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), value);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-int snmp_set_str(pushstats_t cmd, char *value)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"S %s %s\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), value);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-int snmp_set_time(pushstats_t cmd, time_t t)
-
-{
-
-    char tosend[256];
-
-    char buf[256];
-
-
-
-    if (mysock == -1) return 1;
-
-
-
-    snprintf(tosend, sizeof(tosend),"T %s %lu\n",snmp_getoid(NULL,cmd,buf,sizeof(buf)), t);
-
-
-
-    if (sendto(mysock, tosend, strlen(tosend), 0, (struct sockaddr *) &remote, sockaddr_len) == -1) {
-
-        return 1;
-
-    }
-
-
-
-    return 1;
-
-}
-
-
-
-/* should use SNMPDEFINE's as parameter */
-
-int snmp_set_oid(pushstats_t cmd, char *str)
-
-{
-
-   return snmp_set_str(cmd,str);
-
-}
-
-
-
-void snmp_setvariable(pushstats_variable_t name, int value)
-
-{
-
-    variable_value[name] = value;
-
-}
-
-
-
-#endif
-
-
-
-
-
diff -pruN 3.0.13-5/imap/pushstats.h 3.2.0-3/imap/pushstats.h
--- 3.0.13-5/imap/pushstats.h	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/imap/pushstats.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,186 +0,0 @@
-
-/* pushstats.h -- statistics push interface
-
- * generated automatically from /home/ellie/fastmail/cyrus-imapd/imap/pushstats.snmp by snmpgen
-
- *
-
- * Copyright 2000 Carnegie Mellon University
-
- *
-
- * No warranty, yadda yadda
-
- */
-
-
-
-#ifndef pushstats_H
-
-#define pushstats_H
-
-
-
-#define SNMPDEFINE_cmuimap "1.3.6.1.4.1.3.2.2.3.1"
-#define SNMPDEFINE_cmutree "1.3.6.1.4.1.3.2.2.3"
-
-
-
-#ifndef USING_SNMPGEN
-
-
-
-#define snmp_connect()
-
-#define snmp_close()
-
-#define snmp_increment(a, b)
-
-#define snmp_increment_args(a, b, c, d, e)
-
-#define snmp_set(a, b)
-
-#define snmp_set_str(a, b)
-
-#define snmp_set_oid(a, b)
-
-#define snmp_set_time(a, b)
-
-#define snmp_getdescription(a)
-
-#define snmp_getoid(a, b, c, d)
-
-#define snmp_setvariable(a, b)
-
-
-
-typedef void pushstats_t;
-
-
-
-#else
-
-
-
-typedef enum {
-
-    UNSELECT_COUNT,
-    GETQUOTAROOT_COUNT,
-    EXAMINE_COUNT,
-    SETANNOTATION_COUNT,
-    TOTAL_CONNECTIONS,
-    LSUB_COUNT,
-    LOGOUT_COUNT,
-    GETANNOTATION_COUNT,
-    ACTIVE_CONNECTIONS,
-    SETACL_COUNT,
-    CLOSE_COUNT,
-    LOGIN_COUNT,
-    PARTIAL_COUNT,
-    AUTHENTICATION_NO,
-    APPEND_COUNT,
-    FETCH_COUNT,
-    CREATE_COUNT,
-    LIST_COUNT,
-    NOOP_COUNT,
-    GETQUOTA_COUNT,
-    UNSUBSCRIBE_COUNT,
-    SETQUOTA_COUNT,
-    CAPABILITY_COUNT,
-    BBOARD_COUNT,
-    LISTRIGHTS_COUNT,
-    FIND_COUNT,
-    CHECK_COUNT,
-    AUTHENTICATION_YES,
-    SORT_COUNT,
-    SERVER_NAME_VERSION,
-    SELECT_COUNT,
-    IDLE_COUNT,
-    COMPRESS_COUNT,
-    GETUIDS_COUNT,
-    DELETEACL_COUNT,
-    STORE_COUNT,
-    THREAD_COUNT,
-    EXPUNGE_COUNT,
-    NAMESPACE_COUNT,
-    SERVER_UPTIME,
-    AUTHENTICATE_COUNT,
-    GETACL_COUNT,
-    STARTTLS_COUNT,
-    SEARCH_COUNT,
-    MYRIGHTS_COUNT,
-    DELETE_COUNT,
-    STATUS_COUNT,
-    SCAN_COUNT,
-    COPY_COUNT,
-    SUBSCRIBE_COUNT,
-    ID_COUNT,
-    RENAME_COUNT
-} pushstats_t;
-
-
-
-typedef enum {
-
-    VARIABLE_LISTEND,
-    VARIABLE_AUTH
-
-
-} pushstats_variable_t;
-
-
-
-int snmp_connect(void);
-
-
-
-int snmp_close(void);
-
-
-
-/* only valid on counters */
-
-int snmp_increment(pushstats_t cmd, int);
-
-int snmp_increment_args(pushstats_t cmd, int incr, ...);
-
-
-
-/* only valid on values */
-
-int snmp_set(pushstats_t cmd, int);
-
-
-
-int snmp_set_str(pushstats_t cmd, char *value);
-
-
-
-int snmp_set_oid(pushstats_t cmd, char *str);
-
-
-
-int snmp_set_time(pushstats_t cmd, time_t t);
-
-
-
-const char *snmp_getdescription(pushstats_t cmd);
-
-
-
-const char *snmp_getoid(const char *name, pushstats_t cmd, char* buf, int buflen);
-
-
-
-void snmp_setvariable(pushstats_variable_t, int);
-
-
-
-#endif /* USING_SNMPGEN */
-
-
-
-#endif /* pushstats_H */
-
-
-
diff -pruN 3.0.13-5/imap/pushstats.snmp 3.2.0-3/imap/pushstats.snmp
--- 3.0.13-5/imap/pushstats.snmp	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/pushstats.snmp	2020-04-24 02:03:00.000000000 +0000
@@ -127,9 +127,11 @@ C,SEARCH_COUNT,"Number of search", auto
 C,SUBSCRIBE_COUNT,"Number of subscribe", auto
 C,SETACL_COUNT,"Number of setacl", auto
 C,SETANNOTATION_COUNT,"Number of setannotation", auto
+C,SETMETADATA_COUNT,"Number of setmetadata", auto
 C,SETQUOTA_COUNT,"Number of setquota", auto
 C,STATUS_COUNT,"Number of status", auto
 C,SORT_COUNT,"Number of sort", auto
 C,THREAD_COUNT,"Number of thread", auto
+C,UNAUTHENTICATE_COUNT,"Number of unauthenticate", auto
 C,UNSUBSCRIBE_COUNT,"Number of unsubscribe", auto
 C,UNSELECT_COUNT,"Number of unselect", auto
diff -pruN 3.0.13-5/imap/quota.c 3.2.0-3/imap/quota.c
--- 3.0.13-5/imap/quota.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/quota.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include <stdio.h>
 #include <errno.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
@@ -74,7 +75,6 @@
 
 #include "bsearch.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -103,10 +103,10 @@ struct quotaentry {
 /* forward declarations */
 static void usage(void);
 static void reportquota(void);
-static int buildquotalist(char *domain, char **roots, int nroots);
-static int fixquotas(char *domain, char **roots, int nroots);
+static int buildquotalist(char *domain, char **roots, int nroots, int isuser);
+static int fixquotas(char *domain, char **roots, int nroots, int isuser);
 static int fixquota_dopass(char *domain, char **roots, int nroots,
-                           mboxlist_cb *pass);
+                           mboxlist_cb *pass, int isuser);
 static int fixquota_fixroot(struct mailbox *mailbox, const char *root);
 static int fixquota_finish(int thisquota);
 static int (*compar)(const char *s1, const char *s2);
@@ -116,6 +116,7 @@ static int (*compar)(const char *s1, con
 static struct quotaentry *quotaroots;
 static int quota_num = 0, quota_alloc = 0;
 static int quota_todo = 0;
+static int flag_reportonly = 0;
 
 static int test_sync_mode = 0;
 
@@ -126,11 +127,12 @@ int main(int argc,char **argv)
     int opt;
     int i;
     int fflag = 0;
+    int isuser = 0;
     int r, code = 0;
     int do_report = 1;
     char *alt_config = NULL, *domain = NULL;
 
-    while ((opt = getopt(argc, argv, "C:d:fqJZ")) != EOF) {
+    while ((opt = getopt(argc, argv, "C:d:fqJZu")) != EOF) {
         switch (opt) {
         case 'C': /* alt config file */
             alt_config = optarg;
@@ -148,6 +150,14 @@ int main(int argc,char **argv)
             fflag = 1;
             break;
 
+        case 'u':
+            isuser = 1;
+            break;
+
+        case 'n':
+            flag_reportonly = 1;
+            break;
+
         case 'J':
             jsonout = json_object();
             break;
@@ -171,7 +181,7 @@ int main(int argc,char **argv)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&quota_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     if (config_getswitch(IMAPOPT_IMPROVED_MBOXLIST_SORT))
@@ -186,25 +196,19 @@ int main(int argc,char **argv)
     mboxlist_init(0);
     mboxlist_open(NULL);
 
-    quotadb_init(0);
-    quotadb_open(NULL);
-
     quota_changelock();
 
     if (!r)
-        r = buildquotalist(domain, argv+optind, argc-optind);
+        r = buildquotalist(domain, argv+optind, argc-optind, isuser);
 
     if (!r && fflag)
-        r = fixquotas(domain, argv+optind, argc-optind);
+        r = fixquotas(domain, argv+optind, argc-optind, isuser);
 
     quota_changelockrelease();
 
     if (r) code = convert_code(r);
     else if (do_report) reportquota();
 
-    quotadb_close();
-    quotadb_done();
-
     mboxlist_close();
     mboxlist_done();
 
@@ -223,16 +227,24 @@ int main(int argc,char **argv)
 static void usage(void)
 {
     fprintf(stderr,
-            "usage: quota [-C <alt_config>] [-d <domain>] [-f] [-q] [prefix]...\n");
-    exit(EC_USAGE);
+            "usage: quota [-C <alt_config>] [-d <domain>] [-f] [-q] [-u] [mailbox-spec]...\n");
+    exit(EX_USAGE);
 }
 
-static void errmsg(const char *fmt, const char *arg, int err)
+static void
+__attribute__((format(printf, 2, 3)))
+errmsg(int err, const char *fmt, ...)
 {
     char buf[1024];
     size_t len;
+    va_list ap;
+
+    /* XXX handling of 'len' here smells bad */
+
+    va_start(ap, fmt);
+    len = vsnprintf(buf, sizeof(buf), fmt, ap);
+    va_end(ap);
 
-    len = snprintf(buf, sizeof(buf), fmt, arg);
     if (len < sizeof(buf))
         len += snprintf(buf+len, sizeof(buf)-len, ": %s", error_message(err));
     if ((err == IMAP_IOERROR) && (len < sizeof(buf)))
@@ -327,8 +339,8 @@ static int fixquota_addroot(struct quota
     quota_init(&localq, quotaroots[quota_num].name);
     r = quota_read(&localq, &tid, 1);
     if (r) {
-        errmsg("failed reading quota record for '%s'",
-               q->root, r);
+        errmsg(r, "failed reading quota record for '%s'",
+               q->root);
         goto done;
     }
 
@@ -337,10 +349,10 @@ static int fixquota_addroot(struct quota
         free(localq.scanmbox);
         localq.scanmbox = NULL;
 
-        r = quota_write(&localq, &tid);
+        r = quota_write(&localq, 0, &tid);
         if (r) {
-            errmsg("failed writing quota record for '%s'",
-                   q->root, r);
+            errmsg(r, "failed writing quota record for '%s'",
+                   q->root);
             goto done;
         }
     }
@@ -363,7 +375,7 @@ done:
 /*
  * Build the list of quota roots in 'quota'
  */
-int buildquotalist(char *domain, char **roots, int nroots)
+int buildquotalist(char *domain, char **roots, int nroots, int isuser)
 {
     int i, r = 0;
     char buf[MAX_MAILBOX_BUFFER], *tail;
@@ -380,7 +392,7 @@ int buildquotalist(char *domain, char **
     if (!nroots) {
         r = quota_foreach(buf, fixquota_addroot, buf, NULL);
         if (r) {
-            errmsg("failed building quota list for '%s'", buf, IMAP_IOERROR);
+            errmsg(IMAP_IOERROR, "failed building quota list for '%s'", buf);
         }
     }
 
@@ -389,12 +401,18 @@ int buildquotalist(char *domain, char **
      * with the matching prefixes.
      */
     for (i = 0; i < nroots; i++) {
-        strlcpy(tail, roots[i], sizeof(buf) - domainlen);
+        if (isuser) {
+            char *res = mboxname_user_mbox(roots[i], NULL);
+            strlcpy(buf, res, sizeof(buf));
+            free(res);
+        }
+        else {
+            strlcpy(tail, roots[i], sizeof(buf) - domainlen);
+        }
         /* XXX - namespace fixes here */
-
         r = quota_foreach(buf, fixquota_addroot, buf, NULL);
         if (r) {
-            errmsg("failed building quota list for '%s'", buf, IMAP_IOERROR);
+            errmsg(IMAP_IOERROR, "failed building quota list for '%s'", buf);
             break;
         }
     }
@@ -466,13 +484,13 @@ static int fixquota_dombox(const mbentry
 
     r = findroot(mbentry->name, &thisquota);
     if (r) {
-        errmsg("failed finding quotaroot for mailbox '%s'", mbentry->name, r);
+        errmsg(r, "failed finding quotaroot for mailbox '%s'", mbentry->name);
         goto done;
     }
 
     r = mailbox_open_iwl(mbentry->name, &mailbox);
     if (r) {
-        errmsg("failed opening header for mailbox '%s'", mbentry->name, r);
+        errmsg(r, "failed opening header for mailbox '%s'", mbentry->name);
         goto done;
     }
 
@@ -514,7 +532,7 @@ static int fixquota_dombox(const mbentry
         free(localq.scanmbox);
         localq.scanmbox = xstrdup(mbentry->name);
 
-        r = quota_write(&localq, &txn);
+        r = quota_write(&localq, 0, &txn);
         quota_free(&localq);
 
         if (r) {
@@ -542,7 +560,7 @@ int fixquota_fixroot(struct mailbox *mai
            root ? root : "(none)");
 
     r = mailbox_set_quotaroot(mailbox, root);
-    if (r) errmsg("failed writing header for mailbox '%s'", mailbox->name, r);
+    if (r) errmsg(r, "failed writing header for mailbox '%s'", mailbox->name);
 
     return r;
 }
@@ -561,9 +579,10 @@ int fixquota_finish(int thisquota)
     if (!quotaroots[thisquota].refcount) {
         quotaroots[thisquota].deleted = 1;
         fprintf(stderr, "%s: removed\n", root);
-        r = quota_deleteroot(root);
+        if (!flag_reportonly)
+            r = quota_deleteroot(root, 0);
         if (r) {
-            errmsg("failed deleting quotaroot '%s'", root, r);
+            errmsg(r, "failed deleting quotaroot '%s'", root);
         }
         return r;
     }
@@ -572,7 +591,7 @@ int fixquota_finish(int thisquota)
     quota_init(&localq, root);
     r = quota_read(&localq, &tid, 1);
     if (r) {
-        errmsg("failed reading quotaroot '%s'", root, r);
+        errmsg(r, "failed reading quotaroot '%s'", root);
         goto done;
     }
 
@@ -584,7 +603,8 @@ int fixquota_finish(int thisquota)
                 quota_names[res],
                 localq.useds[res],
                 localq.scanuseds[res]);
-            localq.useds[res] = localq.scanuseds[res];
+            if (!flag_reportonly)
+                localq.useds[res] = localq.scanuseds[res];
         }
     }
 
@@ -592,9 +612,9 @@ int fixquota_finish(int thisquota)
     free(localq.scanmbox);
     localq.scanmbox = NULL;
 
-    r = quota_write(&localq, &tid);
+    r = quota_write(&localq, 0, &tid);
     if (r) {
-        errmsg("failed writing quotaroot: '%s'", root, r);
+        errmsg(r, "failed writing quotaroot: '%s'", root);
         goto done;
     }
 
@@ -611,7 +631,7 @@ done:
  * Run a pass over all the quota roots
  */
 int fixquota_dopass(char *domain, char **roots, int nroots,
-                    mboxlist_cb *cb)
+                    mboxlist_cb *cb, int isuser)
 {
     int i, r = 0;
     char buf[MAX_MAILBOX_BUFFER], *tail;
@@ -626,9 +646,9 @@ int fixquota_dopass(char *domain, char *
 
     /* basic case - everything (potentially limited by domain still) */
     if (!nroots) {
-        r = mboxlist_allmbox(buf, cb, buf, /*incdel*/0);
+        r = mboxlist_allmbox(buf, cb, buf, /*flags*/0);
         if (r) {
-            errmsg("processing mbox list for '%s'", buf, IMAP_IOERROR);
+            errmsg(IMAP_IOERROR, "processing mbox list for '%s'", buf);
         }
     }
 
@@ -637,11 +657,17 @@ int fixquota_dopass(char *domain, char *
      * with the matching prefixes.
      */
     for (i = 0; i < nroots; i++) {
-        strlcpy(tail, roots[i], sizeof(buf) - domainlen);
-
-        r = mboxlist_allmbox(buf, cb, buf, /*incdel*/0);
+        if (isuser) {
+            char *inbox = mboxname_user_mbox(roots[i], NULL);
+            r = mboxlist_usermboxtree(roots[i], NULL, cb, inbox, /*flags*/0);
+            free(inbox);
+        }
+        else {
+            strlcpy(tail, roots[i], sizeof(buf) - domainlen);
+            r = mboxlist_allmbox(buf, cb, buf, /*flags*/0);
+        }
         if (r) {
-            errmsg("processing mbox list for '%s'", buf, IMAP_IOERROR);
+            errmsg(IMAP_IOERROR, "processing mbox list for '%s'", buf);
             break;
         }
     }
@@ -652,11 +678,11 @@ int fixquota_dopass(char *domain, char *
 /*
  * Fix all the quota roots
  */
-int fixquotas(char *domain, char **roots, int nroots)
+int fixquotas(char *domain, char **roots, int nroots, int isuser)
 {
     int r;
 
-    r = fixquota_dopass(domain, roots, nroots, fixquota_dombox);
+    r = fixquota_dopass(domain, roots, nroots, fixquota_dombox, isuser);
 
     while (!r && quota_todo < quota_num) {
         r = fixquota_finish(quota_todo);
diff -pruN 3.0.13-5/imap/quota_db.c 3.2.0-3/imap/quota_db.c
--- 3.0.13-5/imap/quota_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/quota_db.c	2020-05-04 03:28:02.000000000 +0000
@@ -48,11 +48,11 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "cyrusdb.h"
 #include "dlist.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mailbox.h"
 #include "mboxname.h"
@@ -74,6 +74,9 @@ HIDDEN struct db *qdb;
  * them to something more general and use them elsewhere */
 static struct mboxlock *qchangelock;
 
+static void init_internal();
+
+static int quota_initialized = 0;
 static int quota_dbopen = 0;
 
 /* keywords used when storing fields in the new quota db format */
@@ -157,6 +160,7 @@ static int quota_parseval(const char *da
     int res = QUOTA_STORAGE;
     struct dlist *dl = NULL;
     quota_t temp;
+    modseq_t modseq = 0;
 
     /* new dlist format */
     if (data[0] == '%') {
@@ -177,15 +181,17 @@ static int quota_parseval(const char *da
         if (iswrite) {
             struct dlist *scan = dlist_getchild(dl, "SCAN");
             const char *mboxname = NULL;
-            if (!scan) goto done;
-            if (!dlist_getatom(scan, "MBOX", &mboxname)) goto done;
-            quota->scanmbox = xstrdup(mboxname);
-            for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
-                struct dlist *val = dlist_getchild(scan, quota_db_names[res]);
-                if (val) quota->scanuseds[res] = dlist_num(val);
+            if (scan && dlist_getatom(scan, "MBOX", &mboxname)) {
+                quota->scanmbox = xstrdup(mboxname);
+                for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
+                    struct dlist *val = dlist_getchild(scan, quota_db_names[res]);
+                    if (val) quota->scanuseds[res] = dlist_num(val);
+                }
             }
         }
 
+        dlist_getnum64(dl, "MODSEQ", &modseq);
+
         goto done;
     }
 
@@ -217,6 +223,7 @@ static int quota_parseval(const char *da
     }
 
 done:
+    quota->modseq = modseq;
     r = 0;
 out:
     dlist_free(&dl);
@@ -234,6 +241,8 @@ EXPORTED int quota_read(struct quota *qu
     const char *data;
     size_t datalen;
 
+    init_internal();
+
     if (!quota->root || !(qrlen = strlen(quota->root)))
         return IMAP_QUOTAROOT_NONEXISTENT;
 
@@ -340,6 +349,8 @@ static int do_onequota(void *rock,
     char *root = xstrndup(key, keylen);
     int iswrite = fd->tid ? 1 : 0;
 
+    init_internal();
+
     quota_init(&quota, root);
 
     /* XXX - error if not parsable? */
@@ -360,6 +371,8 @@ EXPORTED int quota_foreach(const char *p
     char *search = prefix ? (char *)prefix : "";
     struct quota_foreach_t foreach_d;
 
+    init_internal();
+
     foreach_d.proc = proc;
     foreach_d.rock = rock;
     foreach_d.tid = tid;
@@ -399,7 +412,7 @@ EXPORTED void quota_abort(struct txn **t
 /*
  * Write out the quota entry 'quota'
  */
-EXPORTED int quota_write(struct quota *quota, struct txn **tid)
+EXPORTED int quota_write(struct quota *quota, int silent, struct txn **tid)
 {
     int r;
     int qrlen;
@@ -407,11 +420,21 @@ EXPORTED int quota_write(struct quota *q
     struct buf buf = BUF_INITIALIZER;
     struct dlist *dl = NULL;
 
+    init_internal();
+
     if (!quota->root) return IMAP_QUOTAROOT_NONEXISTENT;
 
     qrlen = strlen(quota->root);
     if (!qrlen) return IMAP_QUOTAROOT_NONEXISTENT;
 
+    if (mboxname_isusermailbox(quota->root, /*isinbox*/0)) {
+        if (silent)
+            quota->modseq = mboxname_setquotamodseq(quota->root, quota->modseq);
+        else
+            quota->modseq = mboxname_nextquotamodseq(quota->root, quota->modseq);
+
+    }
+
     dl = dlist_newkvlist(NULL, NULL);
 
     for (res = 0; res < QUOTA_NUMRESOURCES; res++) {
@@ -428,6 +451,8 @@ EXPORTED int quota_write(struct quota *q
             dlist_setnum64(scan, quota_db_names[res], quota->scanuseds[res]);
     }
 
+    dlist_setnum64(dl, "MODSEQ", quota->modseq);
+
     dlist_printbuf(dl, 0, &buf);
 
     r = cyrusdb_store(qdb, quota->root, qrlen, buf.s, buf.len, tid);
@@ -455,13 +480,16 @@ EXPORTED int quota_write(struct quota *q
 
 EXPORTED int quota_update_useds(const char *quotaroot,
                        const quota_t diff[QUOTA_NUMRESOURCES],
-                       const char *mboxname)
+                       const char *mboxname,
+                       int silent)
 {
     struct quota q;
     struct txn *tid = NULL;
     int r = 0;
     struct mboxevent *mboxevents = NULL;
 
+    init_internal();
+
     if (!quotaroot || !*quotaroot)
         return IMAP_QUOTAROOT_NONEXISTENT;
 
@@ -488,7 +516,7 @@ EXPORTED int quota_update_useds(const ch
                 mboxevent_extract_quota(mboxevent, &q, res);
             }
         }
-        r = quota_write(&q, &tid);
+        r = quota_write(&q, silent, &tid);
     }
 
     if (r) {
@@ -520,6 +548,8 @@ EXPORTED int quota_check_useds(const cha
     struct quota q;
     int res;
 
+    init_internal();
+
     /*
      * We are always allowed to *reduce* usage even if it doesn't get us
      * below the quota.  As a side effect this allows our caller to pass
@@ -554,10 +584,12 @@ done:
 /*
  * Remove the quota root 'quota'
  */
-EXPORTED int quota_deleteroot(const char *quotaroot)
+EXPORTED int quota_deleteroot(const char *quotaroot, int silent)
 {
     int r;
 
+    init_internal();
+
     if (!quotaroot || !*quotaroot)
         return IMAP_QUOTAROOT_NONEXISTENT;
 
@@ -566,7 +598,8 @@ EXPORTED int quota_deleteroot(const char
     switch (r) {
     case CYRUSDB_OK:
     case CYRUSDB_NOTFOUND:  /* shouldn't happen anyway */
-        return 0;
+        r = 0;
+        break;
 
     case CYRUSDB_AGAIN:
         return IMAP_AGAIN;
@@ -576,6 +609,11 @@ EXPORTED int quota_deleteroot(const char
                quotaroot, cyrusdb_strerror(r));
         return IMAP_IOERROR;
     }
+
+    if (!silent && mboxname_isusermailbox(quotaroot, /*isinbox*/0)) {
+        mboxname_nextquotamodseq(quotaroot, 0);
+    }
+    return r;
 }
 
 /*
@@ -588,6 +626,8 @@ EXPORTED int quota_findroot(char *ret, s
 {
     char *tail, *p, *mbox;
 
+    init_internal();
+
     strlcpy(ret, name, retlen);
 
     /* find the start of the unqualified mailbox name */
@@ -607,12 +647,31 @@ EXPORTED int quota_findroot(char *ret, s
     return (cyrusdb_fetch(qdb, ret, strlen(ret), NULL, NULL, NULL) == 0);
 }
 
+static void done_cb(void*rock __attribute__((unused)))
+{
+    if (quota_dbopen) {
+        quotadb_close();
+    }
+    quotadb_done();
+}
+
+static void init_internal() {
+    if (!quota_initialized) {
+        quotadb_init(0);
+        quota_initialized = 1;
+    }
+    if (!quota_dbopen) {
+        quotadb_open(NULL);
+    }
+}
+
 /* must be called after cyrus_init */
 EXPORTED void quotadb_init(int myflags)
 {
     if (myflags & QUOTADB_SYNC) {
         cyrusdb_sync(QDB);
     }
+    cyrus_modules_add(done_cb, NULL);
 }
 
 EXPORTED void quotadb_open(const char *fname)
@@ -638,8 +697,8 @@ EXPORTED void quotadb_open(const char *f
         syslog(LOG_ERR, "DBERROR: opening %s: %s", fname,
                cyrusdb_strerror(ret));
             /* Exiting TEMPFAIL because Sendmail thinks this
-               EC_OSFILE == permanent failure. */
-        fatal("can't read quotas file", EC_TEMPFAIL);
+               EX_OSFILE == permanent failure. */
+        fatal("can't read quotas file", EX_TEMPFAIL);
     }
 
     free(tofree);
@@ -647,6 +706,13 @@ EXPORTED void quotadb_open(const char *f
     quota_dbopen = 1;
 }
 
+EXPORTED int quotadb_foreach(const char *prefix, size_t prefixlen,
+                             foreach_p *p, foreach_cb *cb, void *rock)
+{
+    init_internal();
+    return cyrusdb_foreach(qdb, prefix, prefixlen, p, cb, rock, NULL);
+}
+
 EXPORTED void quotadb_close(void)
 {
     int r;
@@ -664,6 +730,7 @@ EXPORTED void quotadb_close(void)
 EXPORTED void quotadb_done(void)
 {
     /* DB->done() handled by cyrus_done() */
+    quota_initialized = 0;
 }
 
 EXPORTED int quota_is_overquota(const struct quota *quota, enum quota_resource res,
diff -pruN 3.0.13-5/imap/quota.h 3.2.0-3/imap/quota.h
--- 3.0.13-5/imap/quota.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/quota.h	2020-05-04 03:28:02.000000000 +0000
@@ -50,6 +50,7 @@
 #endif
 
 #include "cyrusdb.h"
+#include "util.h"
 #include <config.h>
 
 #define FNAME_QUOTADB "/quotas.db"
@@ -58,8 +59,6 @@
 typedef long long int quota_t;
 #define QUOTA_T_FMT      "%lld"
 
-extern struct db *qdb;
-
 enum quota_resource {
     QUOTA_STORAGE       =0,
     QUOTA_MESSAGE       =1,
@@ -83,6 +82,8 @@ struct quota {
     /* information for scanning */
     char *scanmbox;
     quota_t scanuseds[QUOTA_NUMRESOURCES];
+
+    modseq_t modseq;
 };
 
 /* special value to indicate no limit applies */
@@ -111,15 +112,16 @@ extern void quota_commit(struct txn **ti
 
 extern void quota_abort(struct txn **tid);
 
-extern int quota_write(struct quota *quota, struct txn **tid);
+extern int quota_write(struct quota *quota, int silent, struct txn **tid);
 
 extern int quota_update_useds(const char *quotaroot,
                               const quota_t diff[QUOTA_NUMRESOURCES],
-                              const char *mboxname);
+                              const char *mboxname,
+                              int silent);
 extern int quota_check_useds(const char *quotaroot,
                              const quota_t diff[QUOTA_NUMRESOURCES]);
 
-extern int quota_deleteroot(const char *quotaroot);
+extern int quota_deleteroot(const char *quotaroot, int silent);
 
 extern int quota_findroot(char *ret, size_t retlen, const char *name);
 
@@ -129,6 +131,10 @@ extern int quota_foreach(const char *pre
 /* open the quotas db */
 void quotadb_open(const char *fname);
 
+/* iterate all entries starting with prefix */
+extern int quotadb_foreach(const char *prefix, size_t prefixlen,
+                           foreach_p *p, foreach_cb *cb, void *rock);
+
 /* close the database */
 void quotadb_close(void);
 
diff -pruN 3.0.13-5/imap/reconstruct.c 3.2.0-3/imap/reconstruct.c
--- 3.0.13-5/imap/reconstruct.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/reconstruct.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
 /* reconstruct.c -- program to reconstruct a mailbox
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -50,10 +50,12 @@
 #include <errno.h>
 #include <string.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
 #include <sys/stat.h>
+#include <libgen.h>
 #ifdef HAVE_ZLIB
 #include <zlib.h>
 #endif
@@ -78,15 +80,9 @@
 #include "acl.h"
 #include "assert.h"
 #include "bsearch.h"
-#ifdef WITH_DAV
-#include "caldav_db.h"
-#include "carddav_db.h"
-#include "webdav_db.h"
-#endif
 #include "crc32.h"
 #include "hash.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "map.h"
 #include "message.h"
@@ -101,7 +97,6 @@
 #include "quota.h"
 #include "seen.h"
 #include "util.h"
-#include "sync_log.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -119,6 +114,9 @@ struct reconstruct_rock {
     hash_table visited;
 };
 
+/* Program name */
+static const char *progname = NULL;
+
 /* forward declarations */
 static void do_mboxlist(void);
 static int do_reconstruct_p(const mbentry_t *mbentry, void *rock);
@@ -144,6 +142,8 @@ int main(int argc, char **argv)
     char *start_part = NULL;
     struct reconstruct_rock rrock = { NULL, HASH_TABLE_INITIALIZER };
 
+    progname = basename(argv[0]);
+
     construct_hash_table(&unqid_table, 2047, 1);
 
     while ((opt = getopt(argc, argv, "C:kp:rmfsxgGqRUMIoOnV:u")) != EOF) {
@@ -242,11 +242,9 @@ int main(int argc, char **argv)
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&recon_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    sync_log_init();
-
     if (mflag) {
         if (rflag || fflag || optind != argc) {
             cyrus_done();
@@ -255,25 +253,13 @@ int main(int argc, char **argv)
         do_mboxlist();
     }
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-#ifdef WITH_DAV
-    caldav_init();
-    carddav_init();
-    webdav_init();
-#endif
-
     /* Deal with nonexistent mailboxes */
     if (start_part) {
         /* We were handed a mailbox that does not exist currently */
         if(optind == argc) {
             fprintf(stderr,
                     "When using -p, you must specify a mailbox to attempt to reconstruct.");
-            exit(EC_USAGE);
+            exit(EX_USAGE);
         }
 
         /* do any of the mailboxes exist in mboxlist already? */
@@ -281,7 +267,7 @@ int main(int argc, char **argv)
         for (i = optind; i < argc; i++) {
             if (strchr(argv[i],'%') || strchr(argv[i],'*')) {
                 fprintf(stderr, "Using wildcards with -p is not supported.\n");
-                exit(EC_USAGE);
+                exit(EX_USAGE);
             }
 
             /* Translate mailboxname */
@@ -296,7 +282,7 @@ int main(int argc, char **argv)
                 fprintf(stderr,
                         "Mailbox %s already exists.  Cannot specify -p.\n",
                         argv[i]);
-                exit(EC_USAGE);
+                exit(EX_USAGE);
             }
             free(intname);
         }
@@ -307,8 +293,8 @@ int main(int argc, char **argv)
             char *intname = mboxname_from_external(argv[i], &recon_namespace, NULL);
 
             /* don't notify mailbox creation here */
-            r = mboxlist_createmailbox(intname, 0, start_part, 1,
-                                       "cyrus", NULL, 0, 0, !xflag, 0, NULL);
+            r = mboxlist_createmailboxlock(intname, 0, start_part, 1,
+                                           NULL, NULL, 0, 0, !xflag, 0, NULL);
             if (r) {
                 fprintf(stderr, "could not create %s\n", argv[i]);
             }
@@ -326,7 +312,7 @@ int main(int argc, char **argv)
         if (rflag || dousers) {
             fprintf(stderr, "please specify a mailbox to recurse from\n");
             cyrus_done();
-            exit(EC_USAGE);
+            exit(EX_USAGE);
         }
         assert(!rflag);
         buf_setcstr(&buf, "*");
@@ -336,7 +322,7 @@ int main(int argc, char **argv)
 
     for (i = optind; i < argc; i++) {
         if (dousers) {
-            mboxlist_usermboxtree(argv[i], do_reconstruct_p, &rrock,
+            mboxlist_usermboxtree(argv[i], NULL, do_reconstruct_p, &rrock,
                                   MBOXTREE_TOMBSTONES|MBOXTREE_DELETED);
             continue;
         }
@@ -374,8 +360,8 @@ int main(int argc, char **argv)
         /* create p (database only) and reconstruct it */
         /* partition is defined by the parent mailbox */
         /* don't notify mailbox creation here */
-        r = mboxlist_createmailbox(name, 0, NULL, 1,
-                                   "cyrus", NULL, 0, 0, !xflag, 0, NULL);
+        r = mboxlist_createmailboxlock(name, 0, NULL, 1,
+                                       NULL, NULL, 0, 0, !xflag, 0, NULL);
         if (r) {
             fprintf(stderr, "createmailbox %s: %s\n",
                     name, error_message(r));
@@ -394,20 +380,7 @@ int main(int argc, char **argv)
 
     buf_free(&buf);
 
-    sync_log_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
     partlist_local_done();
-#ifdef WITH_DAV
-    webdav_done();
-    carddav_done();
-    caldav_done();
-#endif
 
     cyrus_done();
 
@@ -416,10 +389,31 @@ int main(int argc, char **argv)
 
 static void usage(void)
 {
-    fprintf(stderr,
-            "usage: reconstruct [-C <alt_config>] [-p partition] [-ksrfxu] mailbox...\n");
-    fprintf(stderr, "       reconstruct [-C <alt_config>] -m\n");
-    exit(EC_USAGE);
+    fprintf(stderr, "Usage: %s [OPTIONS]\n", progname);
+    fprintf(stderr, "A tool to reconstruct mailboxes.\n");
+    fprintf(stderr, "\n");
+
+    fprintf(stderr, "-C <config-file>   use <config-file> instead of config from imapd.conf");
+    fprintf(stderr, "-p <partition>     use this indicated partition for search\n");
+    fprintf(stderr, "-x                 do not import metadata, create new\n");
+    fprintf(stderr, "-r                 recursively reconstruct\n");
+    fprintf(stderr, "-f                 examine filesystem underneath the mailbox\n");
+    fprintf(stderr, "-s                 don't stat underlying files\n");
+    fprintf(stderr, "-q                 run quietly\n");
+    fprintf(stderr, "-n                 do not make changes\n");
+    fprintf(stderr, "-G                 force re-parsing(checks GUID correctness)\n");
+    fprintf(stderr, "-R                 perform UID upgrade operation on GUID mismatched files\n");
+    fprintf(stderr, "-U                 use this if there are corrupt message files in spool\n");
+    fprintf(stderr, "                   WARNING: this option deletes corrupted message files permanently\n");
+    fprintf(stderr, "-o                 ignore odd files in mailbox disk directories\n");
+    fprintf(stderr, "-O                 delete odd files(unlike -o)\n");
+    fprintf(stderr, "-M                 prefer mailboxes.db over cyrus.header\n");
+    fprintf(stderr, "-V <version>       Change the cyrus.index minor version to the version specified\n");
+    fprintf(stderr, "-u                 give usernames instead of mailbox prefixes\n");
+
+    fprintf(stderr, "\n");
+
+    exit(EX_USAGE);
 }
 
 /*
@@ -427,7 +421,7 @@ static void usage(void)
  */
 static int do_reconstruct_p(const mbentry_t *mbentry, void *rock)
 {
-    if ((mbentry->mbtype & MBTYPE_DELETED))
+    if ((mbentry->mbtype & (MBTYPE_DELETED|MBTYPE_INTERMEDIATE)))
         return 0;
 
     mboxlist_findone(&recon_namespace, mbentry->name, 1, 0, 0,
@@ -450,7 +444,7 @@ static int do_reconstruct(struct findall
     const char *name = NULL;
 
     /* ignore partial matches */
-    if (!data->mbname) return 0;
+    if (!data->is_exactmatch) return 0;
 
     signals_poll();
 
@@ -459,11 +453,13 @@ static int do_reconstruct(struct findall
     /* don't repeat */
     if (hash_lookup(name, &rrock->visited)) return 0;
 
-    r = mailbox_reconstruct(name, reconstruct_flags);
-    if (r) {
-        com_err(name, r, "%s",
-                (r == IMAP_IOERROR) ? error_message(errno) : "Failed to reconstruct mailbox");
-        return 0;
+    if (!setversion) {
+        r = mailbox_reconstruct(name, reconstruct_flags);
+        if (r) {
+            com_err(name, r, "%s",
+                    (r == IMAP_IOERROR) ? error_message(errno) : "Failed to reconstruct mailbox");
+            return 0;
+        }
     }
 
     r = mailbox_open_iwl(name, &mailbox);
@@ -501,14 +497,15 @@ static int do_reconstruct(struct findall
 
     strncpy(outpath, mailbox_meta_fname(mailbox, META_HEADER), MAX_MAILBOX_NAME);
 
-    if (setversion) {
+    if (setversion && setversion != mailbox->i.minor_version) {
+        int oldversion = mailbox->i.minor_version;
         /* need to re-set the version! */
         int r = mailbox_setversion(mailbox, setversion);
         if (r) {
             printf("FAILED TO REPACK %s with new version %s\n", extname, error_message(r));
         }
         else {
-            printf("Repacked %s to version %d\n", extname, setversion);
+            printf("Converted %s version %d to %d\n", extname, oldversion, setversion);
         }
     }
     mailbox_close(&mailbox);
@@ -580,5 +577,5 @@ static int do_reconstruct(struct findall
 static void do_mboxlist(void)
 {
     fprintf(stderr, "reconstructing mailboxes.db currently not supported\n");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
diff -pruN 3.0.13-5/imap/search_engines.c 3.2.0-3/imap/search_engines.c
--- 3.0.13-5/imap/search_engines.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_engines.c	2020-05-04 03:28:02.000000000 +0000
@@ -62,9 +62,6 @@
 #ifdef USE_SQUAT
 extern const struct search_engine squat_search_engine;
 #endif
-#ifdef USE_SPHINX
-extern const struct search_engine sphinx_search_engine;
-#endif
 #ifdef USE_XAPIAN
 extern const struct search_engine xapian_search_engine;
 #endif
@@ -87,17 +84,13 @@ static const struct search_engine defaul
     NULL
 };
 
-static const struct search_engine *engine(void)
+EXPORTED const struct search_engine *search_engine(void)
 {
     switch (config_getenum(IMAPOPT_SEARCH_ENGINE)) {
 #ifdef USE_XAPIAN
     case IMAP_ENUM_SEARCH_ENGINE_XAPIAN:
         return &xapian_search_engine;
 #endif
-#ifdef USE_SPHINX
-    case IMAP_ENUM_SEARCH_ENGINE_SPHINX:
-        return &sphinx_search_engine;
-#endif
 #ifdef USE_SQUAT
     case IMAP_ENUM_SEARCH_ENGINE_SQUAT:
         return &squat_search_engine;
@@ -116,29 +109,37 @@ EXPORTED const char *search_part_as_stri
     static const char *names[SEARCH_NUM_PARTS] = {
         /* ANY */NULL, "FROM", "TO", "CC",
         "BCC", "SUBJECT", "LISTID", "TYPE",
-        "HEADERS", "BODY", "LOCATION", "ATTACHMENTNAME"
+        "HEADERS", "BODY", "LOCATION", "ATTACHMENTNAME",
+        "ATTACHMENTBODY"
     };
 
     return (part < 0 || part >= SEARCH_NUM_PARTS ? NULL : names[part]);
 }
 
+EXPORTED int search_part_is_body(int part)
+{
+    return part == SEARCH_PART_BODY ||
+           part == SEARCH_PART_LOCATION ||
+           part == SEARCH_PART_ATTACHMENTBODY;
+}
+
 
 EXPORTED search_builder_t *search_begin_search(struct mailbox *mailbox, int opts)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->begin_search ?
             se->begin_search(mailbox, opts) : NULL);
 }
 
 EXPORTED void search_end_search(search_builder_t *bx)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     if (se->end_search) se->end_search(bx);
 }
 
 EXPORTED search_text_receiver_t *search_begin_update(int verbose)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     /* We don't fallback to the default search engine here
      * because the default behaviour is not to index anything */
     return (se->begin_update ? se->begin_update(verbose) : NULL);
@@ -146,7 +147,7 @@ EXPORTED search_text_receiver_t *search_
 
 static int search_batch_size(void)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->flags & SEARCH_FLAG_CAN_BATCH ?
             config_getint(IMAPOPT_SEARCH_BATCHSIZE) : INT_MAX);
 }
@@ -182,7 +183,7 @@ static int flush_batch(search_text_recei
 
     for (i = 0 ; i < batch->count ; i++) {
         message_t *msg = ptrarray_nth(batch, i);
-        if (!r) r = index_getsearchtext(msg, rx, 0);
+        if (!r) r = index_getsearchtext(msg, NULL, rx, 0);
         message_unref(&msg);
     }
     ptrarray_truncate(batch, 0);
@@ -211,7 +212,10 @@ EXPORTED int search_update_mailbox(searc
     r = rx->begin_mailbox(rx, mailbox, flags);
     if (r) goto done;
 
-    struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+    /* we want to index EXPUNGED messages too, because otherwise when we check the
+     * ranges matching the GUID in conversations DB later, we might think we've
+     * indexed it when we actually haven't */
+    struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_UNLINKED);
     if (flags & SEARCH_UPDATE_INCREMENTAL) mailbox_iter_startuid(iter, rx->first_unindexed_uid(rx));
 
     while ((msg = mailbox_iter_step(iter))) {
@@ -246,7 +250,7 @@ EXPORTED int search_update_mailbox(searc
 
 EXPORTED int search_end_update(search_text_receiver_t *rx)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     /* We don't fallback to the default search engine here
      * because the default behaviour is not to index anything */
     return (se->end_update ? se->end_update(rx) : 0);
@@ -258,46 +262,34 @@ EXPORTED search_text_receiver_t *search_
                                                        search_snippet_cb_t proc,
                                                        void *rock)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->begin_snippets ? se->begin_snippets(internalised,
                                     verbose, markup, proc, rock) : NULL);
 }
 
 EXPORTED int search_end_snippets(search_text_receiver_t *rx)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->end_snippets ? se->end_snippets(rx) : 0);
 }
 
 EXPORTED char *search_describe_internalised(void *internalised)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->describe_internalised ?
             se->describe_internalised(internalised) : 0);
 }
 
 EXPORTED void search_free_internalised(void *internalised)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     if (se->free_internalised) se->free_internalised(internalised);
 }
 
-EXPORTED int search_start_daemon(int verbose)
-{
-    const struct search_engine *se = engine();
-    return (se->start_daemon ? se->start_daemon(verbose) : 0);
-}
-
-EXPORTED int search_stop_daemon(int verbose)
-{
-    const struct search_engine *se = engine();
-    return (se->stop_daemon ? se->stop_daemon(verbose) : 0);
-}
-
 EXPORTED int search_list_files(const char *userid,
                                strarray_t *files)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->list_files ? se->list_files(userid, files) : 0);
 }
 
@@ -307,16 +299,22 @@ EXPORTED int search_compact(const char *
                             const char *desttier,
                             int flags)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->compact ? se->compact(userid, tempdir, srctiers, desttier, flags) : 0);
 }
 
 EXPORTED int search_deluser(const char *userid)
 {
-    const struct search_engine *se = engine();
+    const struct search_engine *se = search_engine();
     return (se->deluser ? se->deluser(userid) : 0);
 }
 
+EXPORTED int search_check_config(char **errstr)
+{
+    const struct search_engine *se = search_engine();
+    return (se->check_config ? se->check_config(errstr) : 0);
+}
+
 const char *search_op_as_string(int op)
 {
     static char buf[33];
diff -pruN 3.0.13-5/imap/search_engines.h 3.2.0-3/imap/search_engines.h
--- 3.0.13-5/imap/search_engines.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_engines.h	2020-04-24 02:03:00.000000000 +0000
@@ -47,11 +47,19 @@
 #include "message_guid.h"
 #include "util.h"
 #include "strarray.h"
+#include "bitvector.h"
 
+#include "search_expr.h"
 #include "search_part.h"
+#include "search_sort.h"
 
 typedef int (*search_hit_cb_t)(const char *mboxname, uint32_t uidvalidity,
-                               uint32_t uid, void *rock);
+                               uint32_t uid, const strarray_t *partids,
+                               void *rock);
+
+typedef int (*search_hitguid_cb_t)(const conv_guidrec_t *rec, size_t nguids,
+                                   void *rock);
+
 typedef int (*search_snippet_cb_t)(struct mailbox *, uint32_t uid,
                                    /* SEARCH_PART_* constants */int part,
                                    const char *snippet, void *rock);
@@ -60,14 +68,20 @@ typedef struct search_builder search_bui
 struct search_builder {
 /* These values are carefully chosen a) not to clash with the
  * SEARCH_PART_* constants, and b) to reflect operator precedence */
+/* Values > 1024 are reserved for search engine implementations */
 #define SEARCH_OP_AND       101
 #define SEARCH_OP_OR        102
 #define SEARCH_OP_NOT       103
+#define SEARCH_OP_TRUE      104
+#define SEARCH_OP_FALSE     105
     void (*begin_boolean)(search_builder_t *, int op);
     void (*end_boolean)(search_builder_t *, int op);
     void (*match)(search_builder_t *, int part, const char *str);
+    void (*matchlist)(search_builder_t *, int part, const strarray_t *items);
     void *(*get_internalised)(search_builder_t *);
     int (*run)(search_builder_t *, search_hit_cb_t proc, void *rock);
+    /* XXX - guidsearch is a hack for speeding up JMAP email queries */
+    int (*run_guidsearch)(search_builder_t *, search_hitguid_cb_t proc, void *rock);
 };
 
 typedef struct search_snippet_markup {
@@ -81,7 +95,7 @@ extern search_snippet_markup_t default_s
 /* The functions in search_text_receiver_t get called at least once for each part of every message.
    The invocations form a sequence:
        begin_message(message_t)
-       receiver->begin_part(<part1>)
+       receiver->begin_part(<part1>, <contentid>)
        receiver->append_text(<text>)     (1 or more times)
        receiver->end_part(<part1>)
        ...
@@ -93,6 +107,7 @@ extern search_snippet_markup_t default_s
    The parts need not arrive in any particular order, but each part
    can only participate in one begin_part ... append_text ... end_part
    sequence, and the sequences for different parts cannot be interleaved.
+   Multiple parts can share the same <contentid>.
 */
 typedef struct search_text_receiver search_text_receiver_t;
 struct search_text_receiver {
@@ -101,16 +116,25 @@ struct search_text_receiver {
     uint32_t (*first_unindexed_uid)(search_text_receiver_t *);
     int (*is_indexed)(search_text_receiver_t *, message_t *msg);
     int (*begin_message)(search_text_receiver_t *, message_t *msg);
-    void (*begin_part)(search_text_receiver_t *, int part);
+    void (*begin_part)(search_text_receiver_t *, int part,
+                       const struct message_guid *content_guid);
     void (*append_text)(search_text_receiver_t *, const struct buf *);
     void (*end_part)(search_text_receiver_t *, int part);
     int (*end_message)(search_text_receiver_t *);
     int (*end_mailbox)(search_text_receiver_t *,
                        struct mailbox *);
     int (*flush)(search_text_receiver_t *);
+    int (*audit_mailbox)(search_text_receiver_t *, bitvector_t *unindexed);
+    int (*index_charset_flags)(int base_flags);
+};
+
+struct search_lang_stats {
+    char *iso_lang;
+    double weight; // of total indexed docs
 };
 
-#define SEARCH_FLAG_CAN_BATCH   (1<<0)
+#define SEARCH_FLAG_CAN_BATCH      (1<<0)
+#define SEARCH_FLAG_CAN_GUIDSEARCH (1<<1)
 struct search_engine {
     const char *name;
     unsigned int flags;
@@ -118,13 +142,14 @@ struct search_engine {
 #define SEARCH_VERBOSE(v)       ((v)&_SEARCH_VERBOSE_MASK)
 #define SEARCH_MULTIPLE         (1<<3)  /* return results from
                                          * multiple folders */
-#define SEARCH_UNINDEXED        (1<<4)  /* return unindexed messages
-                                         * as hits (doesn't work
-                                         * with MULTIPLE) */
+// DEPRECATED: #define SEARCH_UNINDEXED   (1<<4)
 #define SEARCH_COMPACT_COPYONE  (1<<5)  /* if only one source, just copy */
 #define SEARCH_COMPACT_FILTER   (1<<6)  /* filter resulting DB for
                                          * expunged records */
 #define SEARCH_COMPACT_REINDEX  (1<<7)  /* re-index all matching messages */
+#define SEARCH_COMPACT_ONLYUPGRADE (1<<8) /* only compact if reindexing */
+#define SEARCH_COMPACT_XAPINDEXED (1<<9) /* use XAPIAN index */
+#define SEARCH_ATTACHMENTS_IN_ANY (1<<10) /* search attachments in ANY part */
     search_builder_t *(*begin_search)(struct mailbox *, int opts);
     void (*end_search)(search_builder_t *);
     search_text_receiver_t *(*begin_update)(int verbose);
@@ -137,15 +162,18 @@ struct search_engine {
     int (*end_snippets)(search_text_receiver_t *);
     char *(*describe_internalised)(void *);
     void (*free_internalised)(void *);
-    int (*start_daemon)(int verbose);
-    int (*stop_daemon)(int verbose);
     int (*list_files)(const char *userid, strarray_t *);
     int (*compact)(const char *userid, const char *tempdir,
                    const strarray_t *srctiers, const char *desttier,
                    int flags);
     int (*deluser)(const char *userid);
+    int (*check_config)(char **errstr);
+    int (*list_lang_stats)(const char *userid, ptrarray_t *counts);
 };
 
+/* Returns the configured search engine */
+extern const struct search_engine *search_engine();
+
 /*
  * Search for messages which could match the query built with the
  * search_builder_t.  Calls 'proc' once for each hit found.  If 'single'
@@ -159,11 +187,24 @@ extern void search_end_search(search_bui
 #define SEARCH_UPDATE_INCREMENTAL (1<<0)
 #define SEARCH_UPDATE_NONBLOCKING (1<<1)
 #define SEARCH_UPDATE_BATCH (1<<2)
+#define SEARCH_UPDATE_XAPINDEXED (1<<3)
+#define SEARCH_UPDATE_AUDIT (1<<4)
+#define SEARCH_UPDATE_REINDEX_PARTS (1<<5)
 search_text_receiver_t *search_begin_update(int verbose);
 int search_update_mailbox(search_text_receiver_t *rx,
                           struct mailbox *mailbox,
                           int flags);
 int search_end_update(search_text_receiver_t *rx);
+
+/* Create a search text receiver for snippets. For each non-empty
+ * snippet generated from a message search part, callback proc is called.
+ *
+ * The callback is called in ascending order of SEARCH_PART definitions,
+ * where higher valued search parts are more costly to generate snippets.
+ * The callback may return 0 to continue snippet generation for the
+ * message, or return IMAP_OK_COMPLETED to indicate that it does not
+ * require more snippets for this message. It still must be prepared
+ * to receive more snippets for this message. */
 search_text_receiver_t *search_begin_snippets(void *internalised,
                                               int verbose,
                                               search_snippet_markup_t *markup,
@@ -174,15 +215,16 @@ int search_end_snippets(search_text_rece
  * be free()d by the caller.  Only useful for whitebox testing.  */
 char *search_describe_internalised(void *internalised);
 void search_free_internalised(void *internalised);
-int search_start_daemon(int verbose);
-int search_stop_daemon(int verbose);
 int search_list_files(const char *userid, strarray_t *);
 int search_compact(const char *userid, const char *tempdir,
                    const strarray_t *srctiers, const char *desttier, int verbose);
 int search_deluser(const char *userid);
+int search_check_config(char **errstr);
 
 
 /* for debugging */
 extern const char *search_op_as_string(int op);
 
+
+
 #endif
diff -pruN 3.0.13-5/imap/search_expr.c 3.2.0-3/imap/search_expr.c
--- 3.0.13-5/imap/search_expr.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_expr.c	2020-05-04 03:28:02.000000000 +0000
@@ -104,18 +104,18 @@ static search_expr_t *detachp(search_exp
     return child;
 }
 
-static search_expr_t *detach(search_expr_t *parent, search_expr_t *child)
+EXPORTED void search_expr_detach(search_expr_t *parent, search_expr_t *child)
 {
     search_expr_t **prevp;
 
     for (prevp = &parent->children ; *prevp && *prevp != child; prevp = &(*prevp)->next)
         ;
-    return detachp(prevp);
+    detachp(prevp);
 }
 
 /*
  * Detach the node '*prevp' from the tree, and reparent its children to
- * '*prevp' parent, preseving '*prevp's location and its children's
+ * '*prevp' parent, preserving '*prevp's location and its children's
  * order.
  *
  * Apparently this operation is called "splat" but I think that's
@@ -187,13 +187,16 @@ EXPORTED void search_expr_append(search_
 
 /*
  * Recursively free a search expression tree including the given node
- * and all descendant nodes.
+ * and all descendent nodes.
  */
 EXPORTED void search_expr_free(search_expr_t *e)
 {
     if (!e) return;
-    while (e->children)
-        search_expr_free(detach(e, e->children));
+    while (e->children) {
+        search_expr_t *child = e->children;
+        search_expr_detach(e, child);
+        search_expr_free(child);
+    }
     if (e->attr) {
         if (e->attr->internalise) e->attr->internalise(NULL, NULL, &e->internalised);
         if (e->attr->free) e->attr->free(&e->value);
@@ -627,17 +630,40 @@ static void setnext(void *p, void *next)
     ((search_expr_t *)p)->next = next;
 }
 
+static int maxcost(const search_expr_t *e, hashu64_table *costcache)
+{
+    if (!e) return 0;
+
+    if (costcache) {
+        intptr_t cost = (intptr_t) hashu64_lookup((uint64_t) e, costcache);
+        assert(cost > INT_MIN && cost < INT_MAX);
+        if (cost) return cost > 0 ? cost : 0;
+    }
+
+    int cost = e->attr ? e->attr->cost : 0;
+    search_expr_t *child;
+    for (child = e->children ; child ; child = child->next) {
+        int childcost = maxcost(child, costcache);
+        if (childcost > cost) cost = childcost;
+    }
+
+    if (costcache) {
+        hashu64_insert((uint64_t) e, (void*)((intptr_t)(cost ? cost : -1)), costcache);
+    }
+    return cost;
+}
+
 static int compare(void *p1, void *p2, void *calldata)
 {
     const search_expr_t *e1 = p1;
     const search_expr_t *e2 = p2;
-    int r;
+    int r = 0;
 
-    r = dnf_depth(e2) - dnf_depth(e1);
+    if (!r)
+        r = maxcost(e1, calldata) - maxcost(e2, calldata);
 
     if (!r)
-        r = (e1->attr ? e1->attr->cost : 0)
-          - (e2->attr ? e2->attr->cost : 0);
+        r = dnf_depth(e2) - dnf_depth(e1);
 
     if (!r)
         r = strcasecmp(e1->attr ? e1->attr->name : "zzz",
@@ -668,14 +694,33 @@ static int compare(void *p1, void *p2, v
     return r;
 }
 
+static void sort_children_internal(search_expr_t *e, hashu64_table *costcache)
+{
+    search_expr_t *child;
+
+    for (child = e->children ; child ; child = child->next)
+        sort_children_internal(child, costcache);
+
+    e->children = lsort(e->children, getnext, setnext, compare, costcache);
+}
+
 static void sort_children(search_expr_t *e)
 {
     search_expr_t *child;
+    hashu64_table maxcostcache = HASHU64_TABLE_INITIALIZER;
+    construct_hashu64_table(&maxcostcache, 512, 0);
+    hashu64_table *costcache = &maxcostcache;
+
+    if (sizeof(uint64_t) < sizeof(search_expr_t*)) {
+        costcache = NULL; // woot?
+    }
 
     for (child = e->children ; child ; child = child->next)
-        sort_children(child);
+        sort_children_internal(child, costcache);
+
+    e->children = lsort(e->children, getnext, setnext, compare, costcache);
 
-    e->children = lsort(e->children, getnext, setnext, compare, NULL);
+    free_hashu64_table(&maxcostcache, NULL);
 }
 
 /*
@@ -757,6 +802,60 @@ EXPORTED void search_expr_internalise(st
     search_expr_apply(e, internalise, state);
 }
 
+/* result:
+ * -1 definitely false (regardless of message)
+ *  0 depends on message
+ * +1 definitely true (regardless of message)
+ */
+EXPORTED int search_expr_always_same(const search_expr_t *e)
+{
+    search_expr_t *child;
+
+    switch (e->op) {
+    case SEOP_UNKNOWN:
+         assert(0); // fatally bad
+         return 0;
+    case SEOP_TRUE:
+         return 1;
+    case SEOP_FALSE:
+         return -1;
+    case SEOP_LT:
+    case SEOP_LE:
+    case SEOP_GT:
+    case SEOP_GE:
+    case SEOP_FUZZYMATCH:
+    case SEOP_MATCH:
+        return 0;
+    case SEOP_AND:
+        {
+            int res = 1;
+            for (child = e->children ; child ; child = child->next) {
+                int cres = search_expr_always_same(child);
+                if (cres == -1) return -1;
+                if (cres == 0) res = 0; // could still be a definite no
+            }
+            return res;
+        }
+    case SEOP_OR:
+        {
+            int res = -1;
+            for (child = e->children ; child ; child = child->next) {
+                int cres = search_expr_always_same(child);
+                if (cres == 1) return 1;
+                if (cres == 0) res = 0; // could still be a definite yes
+            }
+            return res;
+        }
+    case SEOP_NOT:
+        {
+            assert(e->children);
+            // reverse the result only
+            return 0 - search_expr_always_same(e->children);
+        }
+    }
+    return 0;
+}
+
 /*
  * Evaluate the given search expression for the given message,
  * Returns nonzero if the expression is true, 0 otherwise.
@@ -1092,24 +1191,16 @@ static void split(search_expr_t *e,
              * to all folders */
             cb(NULL, NULL, e, rock);
         }
-        else if (nfolders == 1) {
-            /* Exactly one positive folder match: remainder of expression
-             * applies to this specific folder */
+        else {
+            /* One or more folder matches; Extract the first folder
+             * to split the expression. Any remaining folder matches
+             * will be evaluated in the subtree. */
             child = detachp(folder_prevp);
-            /* normalise the remaining subtree - the top node might be
-             * trivial now that we've detached the folder match */
+            /* normalise the remaining subtree */
             search_expr_normalise(&e);
             cb(child->value.s, NULL, e, rock);
             search_expr_free(child);
         }
-        else {
-            /* Two or more positive folder matches; this expression
-             * will never match any messages because messages belong
-             * to exactly one folder, so just delete it.
-             * TODO need to uniquify the (match folder) nodes
-             * before this will work properly */
-            search_expr_free(e);
-        }
     }
     else if (is_folder_node(e)) {
         cb(e->value.s, NULL, search_expr_new(NULL, SEOP_TRUE), rock);
@@ -1125,17 +1216,101 @@ static void split(search_expr_t *e,
 
 /* ====================================================================== */
 
-static int search_string_match(message_t *m, const union search_value *v,
-                                void *internalised, void *data1)
+static int search_list_match(message_t *m,
+                             const union search_value *v __attribute__((unused)),
+                             void *internalised,
+                             void *data1)
 {
     int r;
     struct buf buf = BUF_INITIALIZER;
     int (*getter)(message_t *, struct buf *) = (int(*)(message_t *, struct buf *))data1;
-    comp_pat *pat = (comp_pat *)internalised;
+    strarray_t *internal = internalised;
+
+    // XXX - this should never happen
+
+    r = getter(m, &buf);
+    if (!r && buf.len) {
+        const char *val = buf_cstring(&buf);
+        r = (strarray_find(internal, val, 0) >= 0) ? 1 : 0;
+    }
+    else
+        r = 0;
+    buf_free(&buf);
+
+    return r;
+}
+
+static void search_list_serialise(struct buf *b, const union search_value *v)
+{
+    buf_putc(b, '(');
+    int i;
+    for (i = 0; i < strarray_size(v->list); i++) {
+        if (i) buf_putc(b, ' ');
+        buf_putc(b, '"');
+        buf_appendcstr(b, strarray_nth(v->list, i));
+        buf_putc(b, '"');
+    }
+    buf_putc(b, ')');
+}
+
+static int search_list_unserialise(struct protstream *prot, union search_value *v)
+{
+    int c;
+    char tmp[1024];
+
+    c = prot_getc(prot);
+    if (c != '(') return EOF;
+
+    v->list = strarray_new();
+    do {
+        c = getseword(prot, tmp, sizeof(tmp));
+        strarray_append(v->list, tmp);
+    } while (c == ' ');
+
+    if (c != ')') return EOF;
+
+    return prot_getc(prot);
+}
+
+static void search_list_internalise(struct index_state *state __attribute__((unused)),
+                                      const union search_value *v, void **internalisedp)
+{
+    if (*internalisedp) *internalisedp = NULL;
+    if (v) *internalisedp = v->list;
+}
+
+static void search_list_duplicate(union search_value *new,
+                                  const union search_value *old)
+{
+    new->list = strarray_dup(old->list);
+}
+
+static void search_list_free(union search_value *v)
+{
+    strarray_free(v->list);
+    v->list = NULL;
+}
+
+/* ====================================================================== */
+
+struct search_string_internal {
+    comp_pat *pat;
+    char *s;
+};
+
+static int search_string_match(message_t *m,
+                                const union search_value *v __attribute__((unused)),
+                                void *internalised,
+                                void *data1)
+{
+    int r;
+    struct buf buf = BUF_INITIALIZER;
+    int (*getter)(message_t *, struct buf *) = (int(*)(message_t *, struct buf *))data1;
+    struct search_string_internal *internal = internalised;
 
     r = getter(m, &buf);
     if (!r && buf.len)
-        r = charset_searchstring(v->s, pat, buf.s, buf.len, charset_flags);
+        r = charset_searchstring(internal->s, internal->pat, buf.s, buf.len, charset_flags);
     else
         r = 0;
     buf_free(&buf);
@@ -1162,11 +1337,19 @@ static void search_string_internalise(st
                                       const union search_value *v, void **internalisedp)
 {
     if (*internalisedp) {
-        charset_freepat(*internalisedp);
+        struct search_string_internal *internal = *internalisedp;
+        charset_freepat(internal->pat);
+        free(internal->s);
+        free(internal);
         *internalisedp = NULL;
     }
     if (v) {
-        *internalisedp = charset_compilepat(v->s);
+        struct search_string_internal *internal = xzmalloc(sizeof(struct search_string_internal));
+        charset_t utf8 = charset_lookupname("utf8");
+        internal->s = charset_convert(v->s, utf8, charset_flags);
+        internal->pat = charset_compilepat(internal->s);
+        charset_free(&utf8);
+        *internalisedp = internal;
     }
 }
 
@@ -1253,19 +1436,23 @@ out:
 /* ====================================================================== */
 
 static int search_header_match(message_t *m, const union search_value *v,
-                               void *internalised, void *data1)
+                               void *internalised,
+                               void *data1)
 {
     int r;
     struct buf buf = BUF_INITIALIZER;
     const char *field = (const char *)data1;
-    comp_pat *pat = (comp_pat *)internalised;
+    struct search_string_internal *internal = internalised;
 
+    /* XXX MESSAGE_MULTIPLE is not actually implemented, but we still
+     * XXX search all the values because it always returns all the values!
+     */
     r = message_get_field(m, field,
                           MESSAGE_DECODED|MESSAGE_APPEND|MESSAGE_MULTIPLE,
                           &buf);
     if (!r) {
         if (*v->s) {
-            r = charset_searchstring(v->s, pat, buf.s, buf.len, charset_flags);
+            r = charset_searchstring(internal->s, internal->pat, buf.s, buf.len, charset_flags);
         }
         else {
             /* RFC3501: If the string to search is zero-length, this matches
@@ -1604,7 +1791,8 @@ static void search_folder_internalise(st
 
 static int search_folder_match(message_t *m __attribute__((unused)),
                                const union search_value *v __attribute__((unused)),
-                               void *internalised, void *data1 __attribute__((unused)))
+                               void *internalised,
+                               void *data1 __attribute__((unused)))
 {
     return (int)(unsigned long)internalised;
 }
@@ -1666,8 +1854,43 @@ static void _search_annot_callback(const
     }
 }
 
+static int search_emailid_match(message_t *m, const union search_value *v,
+                              void *internalised __attribute__((unused)),
+                              void *data1 __attribute__((unused)))
+{
+    const struct message_guid *guid = NULL;
+    char emailid[26];
+
+    int r = message_get_guid(m, &guid);
+    if (r) return 0;
+
+    emailid[0] = 'M';
+    memcpy(emailid+1, message_guid_encode(guid), 24);
+    emailid[25] = '\0';
+
+    return !strcmp(v->s, emailid);
+}
+
+static int search_threadid_match(message_t *m, const union search_value *v,
+                                 void *internalised __attribute__((unused)),
+                                 void *data1 __attribute__((unused)))
+{
+    conversation_id_t cid = 0;
+    char threadid[18];
+
+    int r = message_get_cid(m, &cid);
+    if (r) return 0;
+
+    threadid[0] = 'T';
+    memcpy(threadid+1, conversation_id_encode(cid), 16);
+    threadid[17] = '\0';
+
+    return !strcmp(v->s, threadid);
+}
+
 static int search_annotation_match(message_t *m, const union search_value *v,
-                                   void *internalised, void *data1 __attribute__((unused)))
+                                   void *internalised,
+                                   void *data1 __attribute__((unused)))
 {
     struct mailbox *mailbox = (struct mailbox *)internalised;
     struct searchannot *sa = v->annot;
@@ -1756,7 +1979,7 @@ static void search_annotation_duplicate(
     new->annot = (struct searchannot *)xmemdup(old->annot, sizeof(*old->annot));
     new->annot->entry = xstrdup(new->annot->entry);
     new->annot->attrib = xstrdup(new->annot->attrib);
-    buf_init(&new->annot->value);
+    memset(&new->annot->value, 0, sizeof(struct buf));
     buf_append(&new->annot->value, &old->annot->value);
 }
 
@@ -1796,8 +2019,12 @@ static void search_convflags_internalise
         conv_rock_new(state->mailbox, rockp);
         rock = *rockp;
         if (rock->cstate) {
-            if (!strcasecmp(v->s, "\\Seen"))
+            if (!strcasecmp(v->s, "\\Seen")) {
                 rock->num = 0;
+            }
+            else if (!rock->cstate->counted_flags) {
+                rock->num = -1;
+            }
             else {
                 rock->num = strarray_find_case(rock->cstate->counted_flags, v->s, 0);
                 /* rock->num might be -1 invalid */
@@ -1815,21 +2042,46 @@ static int search_convflags_match(messag
 {
     struct conv_rock *rock = (struct conv_rock *)internalised;
     conversation_id_t cid = NULLCONVERSATION;
-    conversation_t *conv = NULL;
+    conversation_t conv = CONVERSATION_INIT;
+    int r = 0; /* invalid flag name */
+
+    if (!rock->cstate) return 0;
+
+    message_get_cid(m, &cid);
+    if (conversation_load_advanced(rock->cstate, cid, &conv, /*flags*/0)) return 0;
+    if (!conv.exists) return 0;
+
+    if (rock->num == 0)
+        r = (conv.unseen != conv.exists);
+    else if (rock->num > 0)
+        r = !!conv.counts[rock->num-1];
+
+    conversation_fini(&conv);
+    return r;
+}
+
+static int search_allconvflags_match(message_t *m,
+                                     const union search_value *v __attribute__((unused)),
+                                     void *internalised,
+                                     void *data1 __attribute__((unused)))
+{
+    struct conv_rock *rock = (struct conv_rock *)internalised;
+    conversation_id_t cid = NULLCONVERSATION;
+    conversation_t conv = CONVERSATION_INIT;
     int r = 0; /* invalid flag name */
 
     if (!rock->cstate) return 0;
 
     message_get_cid(m, &cid);
-    if (conversation_load(rock->cstate, cid, &conv)) return 0;
-    if (!conv) return 0;
+    if (conversation_load_advanced(rock->cstate, cid, &conv, /*flags*/0)) return 0;
+    if (!conv.exists) return 0;
 
     if (rock->num == 0)
-        r = !conv->unseen;
+        r = !conv.unseen;
     else if (rock->num > 0)
-        r = !!conv->counts[rock->num-1];
+        r = (conv.counts[rock->num-1] == conv.exists);
 
-    conversation_free(conv);
+    conversation_fini(&conv);
     return r;
 }
 
@@ -1854,22 +2106,23 @@ static void search_convmodseq_internalis
 }
 
 static int search_convmodseq_match(message_t *m, const union search_value *v,
-                                   void *internalised, void *data1 __attribute__((unused)))
+                                   void *internalised,
+                                   void *data1 __attribute__((unused)))
 {
     struct conv_rock *rock = (struct conv_rock *)internalised;
     conversation_id_t cid = NULLCONVERSATION;
-    conversation_t *conv = NULL;
+    conversation_t conv = CONVERSATION_INIT;
     int r;
 
     if (!rock->cstate) return 0;
 
     message_get_cid(m, &cid);
-    if (conversation_load(rock->cstate, cid, &conv)) return 0;
-    if (!conv) return 0;
+    if (conversation_load_advanced(rock->cstate, cid, &conv, /*flags*/0)) return 0;
+    if (!conv.exists) return 0;
 
-    r = (v->u == conv->modseq);
+    r = (v->u == conv.modseq);
 
-    conversation_free(conv);
+    conversation_fini(&conv);
     return r;
 }
 
@@ -1880,7 +2133,7 @@ static void conv_rock_new(struct mailbox
 
     rock->cstate = conversations_get_mbox(mailbox->name);
     if (!rock->cstate) {
-        if (conversations_open_mbox(mailbox->name, &rock->cstate))
+        if (conversations_open_mbox(mailbox->name, 1/*shared*/, &rock->cstate))
             rock->num = -1;         /* invalid */
         else
             rock->cstate_is_ours = 1;
@@ -1991,6 +2244,8 @@ static int searchmsg_cb(int isbody, char
                         const struct param *type_params __attribute__((unused)),
                         const char *disposition __attribute__((unused)),
                         const struct param *disposition_params __attribute__((unused)),
+                        const struct message_guid *content_guid __attribute__((unused)),
+                        const char *part __attribute__((unused)),
                         struct buf *data, void *rock)
 {
     struct searchmsg_rock *sr = (struct searchmsg_rock *)rock;
@@ -2015,13 +2270,16 @@ static int searchmsg_cb(int isbody, char
     return 0;
 }
 
-static int search_text_match(message_t *m, const union search_value *v,
-                             void *internalised, void *data1)
+static int search_text_match(message_t *m,
+                             const union search_value *v __attribute__((unused)),
+                             void *internalised,
+                             void *data1)
 {
     struct searchmsg_rock sr;
+    struct search_string_internal *internal = internalised;
 
-    sr.substr = v->s;
-    sr.pat = (comp_pat *)internalised;
+    sr.substr = internal->s;
+    sr.pat = internal->pat;
     sr.skipheader = (int)(unsigned long)data1;
     sr.result = 0;
     message_foreach_section(m, searchmsg_cb, &sr);
@@ -2032,14 +2290,18 @@ static int search_text_match(message_t *
 
 static hash_table attrs_by_name = HASH_TABLE_INITIALIZER;
 
-enum search_cost {
-    SEARCH_COST_NONE = 0,
-    SEARCH_COST_INDEX,
-    SEARCH_COST_CONV,
-    SEARCH_COST_ANNOT,
-    SEARCH_COST_CACHE,
-    SEARCH_COST_BODY
-};
+static int search_attr_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    /* do nothing */
+}
+
+static void init_internal() {
+    if (!search_attr_initialized) {
+        search_attr_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
 
 /*
  * Call search_attr_init() before doing any work with search
@@ -2051,6 +2313,62 @@ EXPORTED void search_attr_init(void)
 
     static const search_attr_t attrs[] = {
         {
+            "bcclist",
+            SEA_FUZZABLE|SEA_ISLIST,
+            SEARCH_PART_BCC,
+            SEARCH_COST_CACHE,
+            search_list_internalise,
+            /*cmp*/NULL,
+            search_list_match,
+            search_list_serialise,
+            search_list_unserialise,
+            /*get_countability*/NULL,
+            search_list_duplicate,
+            search_list_free,
+            (void *)message_get_bcc
+        },{
+            "cclist",
+            SEA_FUZZABLE|SEA_ISLIST,
+            SEARCH_PART_CC,
+            SEARCH_COST_CACHE,
+            search_list_internalise,
+            /*cmp*/NULL,
+            search_list_match,
+            search_list_serialise,
+            search_list_unserialise,
+            /*get_countability*/NULL,
+            search_list_duplicate,
+            search_list_free,
+            (void *)message_get_cc
+        },{
+            "fromlist",
+            SEA_FUZZABLE|SEA_ISLIST,
+            SEARCH_PART_FROM,
+            SEARCH_COST_CACHE,
+            search_list_internalise,
+            /*cmp*/NULL,
+            search_list_match,
+            search_list_serialise,
+            search_list_unserialise,
+            /*get_countability*/NULL,
+            search_list_duplicate,
+            search_list_free,
+            (void *)message_get_from
+        },{
+            "tolist",
+            SEA_FUZZABLE|SEA_ISLIST,
+            SEARCH_PART_TO,
+            SEARCH_COST_CACHE,
+            search_list_internalise,
+            /*cmp*/NULL,
+            search_list_match,
+            search_list_serialise,
+            search_list_unserialise,
+            /*get_countability*/NULL,
+            search_list_duplicate,
+            search_list_free,
+            (void *)message_get_to
+        },{
             "bcc",
             SEA_FUZZABLE,
             SEARCH_PART_BCC,
@@ -2247,6 +2565,20 @@ EXPORTED void search_attr_init(void)
             search_string_free,
             NULL
         },{
+            "allconvflags",
+            SEA_MUTABLE,
+            SEARCH_PART_NONE,
+            SEARCH_COST_CONV,
+            search_convflags_internalise,
+            /*cmp*/NULL,
+            search_allconvflags_match,
+            search_string_serialise,
+            search_string_unserialise,
+            search_convflags_get_countability,
+            search_string_duplicate,
+            search_string_free,
+            NULL
+        },{
             "convmodseq",
             SEA_MUTABLE,
             SEARCH_PART_NONE,
@@ -2289,6 +2621,34 @@ EXPORTED void search_attr_init(void)
             /*free*/NULL,
             (void *)message_get_cid
         },{
+            "emailid",
+            /* flags */0,
+            SEARCH_PART_NONE,
+            SEARCH_COST_INDEX,
+            /*internalise*/NULL,
+            /*cmp*/ NULL,
+            search_emailid_match,
+            search_string_serialise,
+            search_string_unserialise,
+            /*get_countability*/NULL,
+            search_string_duplicate,
+            search_string_free,
+            (void *)NULL
+        },{
+            "threadid",
+            /* flags */0,
+            SEARCH_PART_NONE,
+            SEARCH_COST_INDEX,
+            /*internalise*/NULL,
+            /*cmp*/ NULL,
+            search_threadid_match,
+            search_string_serialise,
+            search_string_unserialise,
+            /*get_countability*/NULL,
+            search_string_duplicate,
+            search_string_free,
+            (void *)NULL
+        },{
             "folder",
             /*flags*/0,
             SEARCH_PART_NONE,
@@ -2345,6 +2705,34 @@ EXPORTED void search_attr_init(void)
             /*free*/NULL,
             (void *)message_get_internaldate
         },{
+            "savedate",
+            /*flags*/0,
+            SEARCH_PART_NONE,
+            SEARCH_COST_INDEX,
+            /*internalise*/NULL,
+            search_time_t_cmp,
+            search_time_t_match,
+            search_time_t_serialise,
+            search_time_t_unserialise,
+            /*get_countability*/NULL,
+            /*duplicate*/NULL,
+            /*free*/NULL,
+            (void *)message_get_savedate
+        },{
+            "indexversion",
+            /*flags*/0,
+            SEARCH_PART_NONE,
+            SEARCH_COST_NONE,
+            /*internalise*/NULL,
+            search_uint32_cmp,
+            search_uint32_match,
+            search_uint32_serialise,
+            search_uint32_unserialise,
+            /*get_countability*/NULL,
+            /*duplicate*/NULL,
+            /*free*/NULL,
+            (void *)message_get_indexversion
+        },{
             "sentdate",
             /*flags*/0,
             SEARCH_PART_NONE,
@@ -2442,12 +2830,28 @@ EXPORTED void search_attr_init(void)
             search_string_duplicate,
             search_string_free,
             (void *)0
+        },{
+            "attachmentbody",
+            SEA_FUZZABLE,
+            SEARCH_PART_ATTACHMENTBODY,
+            SEARCH_COST_BODY,
+            search_string_internalise,
+            /*cmp*/NULL,
+            search_text_match,
+            search_string_serialise,
+            search_string_unserialise,
+            /*get_countability*/NULL,
+            search_string_duplicate,
+            search_string_free,
+            (void *)0       /* skipheader flag */
         }
     };
 
     construct_hash_table(&attrs_by_name, VECTOR_SIZE(attrs), 0);
     for (i = 0 ; i < VECTOR_SIZE(attrs) ; i++)
         hash_insert(attrs[i].name, (void *)&attrs[i], &attrs_by_name);
+
+    search_attr_initialized = 1;
 }
 
 /*
@@ -2460,6 +2864,8 @@ EXPORTED const search_attr_t *search_att
 {
     char tmp[128];
 
+    init_internal();
+
     strlcpy(tmp, name, sizeof(tmp));
     lcase(tmp);
     return hash_lookup(tmp, &attrs_by_name);
@@ -2492,6 +2898,8 @@ EXPORTED const search_attr_t *search_att
         NULL
     };
 
+    init_internal();
+
     /* some header fields can be reduced to search terms */
     if (!strcasecmp(field, "bcc") ||
         !strcasecmp(field, "cc") ||
@@ -2531,3 +2939,8 @@ EXPORTED int search_attr_is_fuzzable(con
             (attr->flags & SEA_FUZZABLE));
 }
 
+EXPORTED enum search_cost search_attr_cost(const search_attr_t *attr)
+{
+    return attr->cost;
+}
+
diff -pruN 3.0.13-5/imap/search_expr.h 3.2.0-3/imap/search_expr.h
--- 3.0.13-5/imap/search_expr.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_expr.h	2020-04-24 02:03:00.000000000 +0000
@@ -77,12 +77,14 @@ union search_value {
     uint64_t u;
     char *s;
     struct searchannot *annot;
+    strarray_t *list;
 };
 
 /* search_attr.flags */
 enum {
     SEA_MUTABLE =       (1<<0),
     SEA_FUZZABLE =      (1<<1),
+    SEA_ISLIST =        (1<<2),
 };
 
 typedef struct search_attr search_attr_t;
@@ -127,6 +129,7 @@ enum {
 extern search_expr_t *search_expr_new(search_expr_t *parent,
                                       enum search_op);
 extern void search_expr_append(search_expr_t *parent, search_expr_t *child);
+extern void search_expr_detach(search_expr_t *parent, search_expr_t *child);
 extern void search_expr_free(search_expr_t *);
 extern search_expr_t *search_expr_duplicate(const search_expr_t *e);
 extern int search_expr_apply(search_expr_t *e,
@@ -136,6 +139,7 @@ extern char *search_expr_serialise(const
 extern search_expr_t *search_expr_unserialise(const char *s);
 extern int search_expr_normalise(search_expr_t **);
 extern void search_expr_internalise(struct index_state *, search_expr_t *);
+extern int search_expr_always_same(const search_expr_t *);
 extern int search_expr_evaluate(message_t *m, const search_expr_t *);
 extern int search_expr_uses_attr(const search_expr_t *, const char *);
 extern int search_expr_is_mutable(const search_expr_t *);
@@ -148,9 +152,19 @@ extern void search_expr_split_by_folder_
                                                    void *rock),
                                         void *rock);
 
+enum search_cost {
+    SEARCH_COST_NONE = 0,
+    SEARCH_COST_INDEX,
+    SEARCH_COST_CONV,
+    SEARCH_COST_ANNOT,
+    SEARCH_COST_CACHE,
+    SEARCH_COST_BODY
+};
+
 extern void search_attr_init(void);
 extern const search_attr_t *search_attr_find(const char *);
 extern const search_attr_t *search_attr_find_field(const char *field);
 extern int search_attr_is_fuzzable(const search_attr_t *);
+extern enum search_cost search_attr_cost(const search_attr_t *);
 
 #endif
diff -pruN 3.0.13-5/imap/search_part.h 3.2.0-3/imap/search_part.h
--- 3.0.13-5/imap/search_part.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_part.h	2020-05-04 03:28:02.000000000 +0000
@@ -58,9 +58,12 @@
 #define SEARCH_PART_BODY            9
 #define SEARCH_PART_LOCATION        10
 #define SEARCH_PART_ATTACHMENTNAME  11
-#define SEARCH_NUM_PARTS            12
+#define SEARCH_PART_ATTACHMENTBODY  12
+#define SEARCH_NUM_PARTS            13
 
 /* Implemented in search_engines.c */
 extern const char *search_part_as_string(int part);
 
+extern int search_part_is_body(int part);
+
 #endif
diff -pruN 3.0.13-5/imap/search_query.c 3.2.0-3/imap/search_query.c
--- 3.0.13-5/imap/search_query.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_query.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-/* search_result.c -- search result data structure
+/* search_query.c -- search query routines
  *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -60,6 +60,7 @@
 #include "bsearch.h"
 #include "xstrlcpy.h"
 #include "xmalloc.h"
+#include "statuscache.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
@@ -83,13 +84,19 @@ EXPORTED search_query_t *search_query_ne
     return query;
 }
 
+static void folder_free_partids(void *data)
+{
+    strarray_free((strarray_t*)data);
+}
+
 static void folder_free(void *data)
 {
     search_folder_t *folder = data;
 
     free(folder->mboxname);
-    bv_free(&folder->uids);
-    bv_free(&folder->unchecked_uids);
+    bv_fini(&folder->uids);
+    bv_fini(&folder->found_uids);
+    free_hashu64_table(&folder->partids, folder_free_partids);
     free(folder);
 }
 
@@ -153,7 +160,7 @@ EXPORTED void search_folder_use_msn(sear
         if (index_getuid(state, msgno) == (unsigned)uid)
             bv_set(&msns, msgno);
     }
-    bv_free(&folder->uids);
+    bv_fini(&folder->uids);
     folder->uids = msns;
 }
 
@@ -261,21 +268,26 @@ static search_folder_t *query_get_valid_
                                                uint32_t uidvalidity)
 {
     search_folder_t *folder;
+    uint32_t have_mbtype = 0;
 
-    if (mboxname_isdeletedmailbox(mboxname, 0) &&
-        !(query->want_mbtype & MBTYPE_DELETED)) {
+    // check if we want to process this mailbox
+    if (query->checkfolder &&
+        !query->checkfolder(mboxname, query->checkfolderrock)) {
         return NULL;
     }
 
-    if (mboxname_iscalendarmailbox(mboxname, 0) &&
-       !(query->want_mbtype & MBTYPE_CALENDAR)) {
-        return NULL;
-    }
+    if (mboxname_isdeletedmailbox(mboxname, 0))
+        have_mbtype = MBTYPE_DELETED;
+
+    if (mboxname_iscalendarmailbox(mboxname, 0))
+        have_mbtype = MBTYPE_CALENDAR;
 
-    if (mboxname_isaddressbookmailbox(mboxname, 0) &&
-       !(query->want_mbtype & MBTYPE_ADDRESSBOOK)) {
+    if (mboxname_isaddressbookmailbox(mboxname, 0))
+        have_mbtype = MBTYPE_ADDRESSBOOK;
+
+    /* not the type we want?  Abort now */
+    if (have_mbtype != query->want_mbtype)
         return NULL;
-    }
 
     folder = query_get_folder(query, mboxname);
     if (uidvalidity) {
@@ -289,7 +301,7 @@ static search_folder_t *query_get_valid_
             * remember the uidvalidity for later */
             if (folder->uidvalidity) {
                 bv_clearall(&folder->uids);
-                bv_clearall(&folder->unchecked_uids);
+                bv_clearall(&folder->found_uids);
             }
             folder->uidvalidity = uidvalidity;
         }
@@ -330,6 +342,7 @@ static int query_begin_index(search_quer
         init.out = query->state->out;
         init.want_expunged = query->want_expunged;
         init.want_mbtype = query->want_mbtype;
+        init.examine_mode = 1;
 
         r = index_open(mboxname, &init, statep);
         if (r == IMAP_PERMISSION_DENIED) r = IMAP_MAILBOX_NONEXISTENT;
@@ -351,7 +364,7 @@ static int query_begin_index(search_quer
         if (r) goto out;
     }
 
-    r = cmd_cancelled();
+    r = cmd_cancelled(!query->ignore_timer);
 
 out:
     return r;
@@ -442,16 +455,17 @@ static void query_load_msgdata(search_qu
 struct subquery_rock {
     search_query_t *query;
     search_subquery_t *sub;
+    int is_excluded;
 };
 
 /*
  * After an indexed subquery is run, we have accumulated a number of
- * unchecked UID hits in folders.  Here we check those UIDs for a) not
+ * found UID hits in folders.  Here we check those UIDs for a) not
  * being deleted since indexing and b) matching any unindexed scan
  * expression.  We also take advantage of having an open index_state to
  * load some MsgData objects and save them to query->merged_msgdata.
  */
-static void subquery_post_indexed(const char *key, void *data, void *rock)
+static void subquery_post_enginesearch(const char *key, void *data, void *rock)
 {
     const char *mboxname = key;
     search_folder_t *folder = data;
@@ -465,7 +479,7 @@ static void subquery_post_indexed(const
     int r = 0;
 
     if (query->error) return;
-    if (!folder->unchecked_dirty) return;
+    if (!folder->found_dirty) return;
 
     if (sub->expr && query->verbose) {
         char *s = search_expr_serialise(sub->expr);
@@ -501,19 +515,23 @@ static void subquery_post_indexed(const
     for (msgno = 1 ; msgno <= state->exists ; msgno++) {
         struct index_map *im = &state->map[msgno-1];
 
-        r = cmd_cancelled();
-        if (r) goto out;
+        if (!(msgno % 128)) {
+            r = cmd_cancelled(!query->ignore_timer);
+            if (r) goto out;
+        }
 
-        /* we only want to look at unchecked UIDs */
-        if (!bv_isset(&folder->unchecked_uids, im->uid))
+        /* we only want to look at found UIDs */
+        if ((!qr->is_excluded && !bv_isset(&folder->found_uids, im->uid)) ||
+             (qr->is_excluded && bv_isset(&folder->found_uids, im->uid))) {
             continue;
+        }
 
         /* moot if already in the uids set */
         if (bv_isset(&folder->uids, im->uid))
             continue;
 
         /* can happen if we didn't "tellchanges" yet */
-        if ((im->system_flags & FLAG_EXPUNGED) && !query->want_expunged)
+        if ((im->internal_flags & FLAG_INTERNAL_EXPUNGED) && !query->want_expunged)
             continue;
 
         /* run the search program */
@@ -536,7 +554,7 @@ static void subquery_post_indexed(const
     if (query->sortcrit && nmsgs)
         query_load_msgdata(query, folder, state, msgno_list, nmsgs);
 
-    folder->unchecked_dirty = 0;
+    folder->found_dirty = 0;
     r = 0;
 
 out:
@@ -545,6 +563,28 @@ out:
     if (r) query->error = r;
 }
 
+static int subquery_post_excluded(const mbentry_t *mbentry, void *rock)
+{
+    struct subquery_rock *qr = rock;
+    search_folder_t *folder;
+
+    folder = query_get_valid_folder(qr->query, mbentry->name, 0);
+    if (folder) {
+        folder->found_dirty = 1;
+        subquery_post_enginesearch(mbentry->name, folder, rock);
+    }
+
+    return 0;
+}
+
+static void subquery_clear_found(const char *key __attribute__((unused)),
+                                     void *data,
+                                     void *rock __attribute__((unused)))
+{
+    search_folder_t *folder = data;
+    bv_clearall(&folder->found_uids);
+}
+
 EXPORTED void search_build_query(search_builder_t *bx, search_expr_t *e)
 {
     search_expr_t *child;
@@ -566,7 +606,11 @@ EXPORTED void search_build_query(search_
 
     case SEOP_FUZZYMATCH:
         if (e->attr && e->attr->part >= 0) {
-            bx->match(bx, e->attr->part, e->value.s);
+            if (e->attr->flags & SEA_ISLIST) {
+                bx->matchlist(bx, e->attr->part, e->value.list);
+            } else {
+                bx->match(bx, e->attr->part, e->value.s);
+            }
         }
         return;
 
@@ -583,14 +627,29 @@ EXPORTED void search_build_query(search_
     }
 }
 
-static int add_unchecked_uid(const char *mboxname, uint32_t uidvalidity,
-                             uint32_t uid, void *rock)
+static int add_found_uid(const char *mboxname, uint32_t uidvalidity,
+                             uint32_t uid, const strarray_t *partids,
+                             void *rock)
 {
-    search_query_t *query = rock;
-    search_folder_t *folder = query_get_valid_folder(query, mboxname, uidvalidity);
+    struct subquery_rock *qr = rock;
+    search_folder_t *folder = query_get_valid_folder(qr->query, mboxname, uidvalidity);
     if (folder) {
-        bv_set(&folder->unchecked_uids, uid);
-        folder->unchecked_dirty = 1;
+        bv_set(&folder->found_uids, uid);
+        folder->found_dirty = 1;
+        if (partids && !qr->is_excluded) {
+            if (!folder->partids.size) {
+                if (!construct_hashu64_table(&folder->partids, 4096, 0))
+                    return IMAP_INTERNAL;
+            }
+            strarray_t *have_partids = hashu64_lookup(uid, &folder->partids);
+            if (have_partids) {
+                int i;
+                for (i = 0; i < strarray_size(partids); i++) {
+                    strarray_add(have_partids, strarray_nth(partids, i));
+                }
+            }
+            else hashu64_insert(uid, strarray_dup(partids), &folder->partids);
+        }
     }
     return 0;
 }
@@ -601,6 +660,7 @@ static void subquery_run_indexed(const c
 //     const char *mboxname = key;
     search_subquery_t *sub = data;
     search_query_t *query = rock;
+    search_expr_t *excluded = NULL;
     search_builder_t *bx;
     struct subquery_rock qr;
     int r;
@@ -613,26 +673,94 @@ static void subquery_run_indexed(const c
         free(s);
     }
 
-    bx = search_begin_search(query->state->mailbox,
-                             (query->multiple ? SEARCH_MULTIPLE : 0)|
-                             SEARCH_VERBOSE(query->verbose));
+    int opts = SEARCH_VERBOSE(query->verbose);
+    if (query->multiple) opts |= SEARCH_MULTIPLE;
+    if (query->attachments_in_any) opts |= SEARCH_ATTACHMENTS_IN_ANY;
+
+    /* If the subquery is NOT(x) or AND(NOT(x)..(NOT(y))) then
+     * it's likely that we will get lots of results to look up
+     * in conversations.db. We mitigate that by running the
+     * inverse query on the index, and check any uids that do
+     * _not_ match the query result. */
+    if (sub->indexed->op == SEOP_AND) {
+        search_expr_t *child = sub->indexed->children;
+        while (child && child->op == SEOP_NOT) {
+            child = child->next;
+        }
+        if (!child) {
+            excluded = search_expr_new(NULL, SEOP_OR);
+            search_expr_t *dupl = search_expr_duplicate(sub->indexed);
+            child = dupl->children;
+            while (child) {
+                search_expr_t *expr = child->children;
+                search_expr_detach(child, expr);
+                search_expr_append(excluded, expr);
+                child = child->next;
+            }
+            search_expr_free(dupl);
+        }
+    }
+    else if (sub->indexed->op == SEOP_NOT) {
+        excluded = search_expr_duplicate(sub->indexed->children);
+    }
+
+    bx = search_begin_search(query->state->mailbox, opts);
     if (!bx) {
         r = IMAP_INTERNAL;
         goto out;
     }
-    search_build_query(bx, sub->indexed);
-    r = bx->run(bx, add_unchecked_uid, query);
-    search_end_search(bx);
-    if (r) goto out;
 
     qr.query = query;
     qr.sub = sub;
-    hash_enumerate(&query->folders_by_name, subquery_post_indexed, &qr);
+    qr.is_excluded = excluded != NULL;
+    search_build_query(bx, excluded ? excluded : sub->indexed);
+    r = bx->run(bx, add_found_uid, &qr);
+
+    search_end_search(bx);
+    if (r) goto out;
+
+    if (excluded) {
+        if (query->multiple) {
+            char *userid = mboxname_to_userid(index_mboxname(query->state));
+            r = mboxlist_usermboxtree(userid, NULL, subquery_post_excluded,
+                    &qr, /*flags*/0);
+            free(userid);
+        }
+        else {
+            mbentry_t *mbentry = NULL;
+            r = mboxlist_lookup(index_mboxname(query->state), &mbentry, NULL);
+            if (!r) r = subquery_post_excluded(mbentry, &qr);
+            mboxlist_entry_free(&mbentry);
+        }
+    }
+    else hash_enumerate(&query->folders_by_name, subquery_post_enginesearch, &qr);
+    hash_enumerate(&query->folders_by_name, subquery_clear_found, NULL);
 
 out:
+    search_expr_free(excluded);
     if (r) query->error = r;
 }
 
+static modseq_t _get_sincemodseq(search_expr_t *e)
+{
+    const search_attr_t *modseq_attr = search_attr_find("modseq");
+
+    if (e->op == SEOP_AND) {
+        search_expr_t *child;
+
+        for (child = e->children ; child ; child = child->next) {
+            modseq_t res = _get_sincemodseq(child);
+            if (res) return res;
+        }
+    }
+    if (e->op == SEOP_GT && e->attr == modseq_attr) {
+        return e->value.u;
+    }
+
+    return 0;
+}
+
+
 static int subquery_run_one_folder(search_query_t *query,
                                    const char *mboxname,
                                    search_expr_t *e)
@@ -657,6 +785,21 @@ static int subquery_run_one_folder(searc
         free(s);
     }
 
+    // check if we want to process this mailbox
+    if (query->checkfolder &&
+        !query->checkfolder(mboxname, query->checkfolderrock)) {
+        goto out;
+    }
+
+    modseq_t sincemodseq = _get_sincemodseq(e);
+    if (sincemodseq) {
+        struct statusdata sdata = STATUSDATA_INIT;
+        int r = status_lookup_mboxname(mboxname, query->state->userid,
+                                       STATUS_HIGHESTMODSEQ, &sdata);
+        // if unchangedsince, then we can skip the index query
+        if (!r && sdata.highestmodseq <= sincemodseq) goto out;
+    }
+
     r = query_begin_index(query, mboxname, &state);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
         /* Silently swallow mailboxes which have been deleted, renamed,
@@ -678,11 +821,13 @@ static int subquery_run_one_folder(searc
     for (msgno = 1 ; msgno <= state->exists ; msgno++) {
         struct index_map *im = &state->map[msgno-1];
 
-        r = cmd_cancelled();
-        if (r) goto out;
+        if (!(msgno % 128)) {
+            r = cmd_cancelled(!query->ignore_timer);
+            if (r) goto out;
+        }
 
         /* can happen if we didn't "tellchanges" yet */
-        if ((im->system_flags & FLAG_EXPUNGED) && !query->want_expunged)
+        if ((im->internal_flags & FLAG_INTERNAL_EXPUNGED) && !query->want_expunged)
             continue;
 
         /* run the search program */
@@ -718,7 +863,7 @@ static int subquery_run_one_folder(searc
     r = 0;
 
 out:
-    query_end_index(query, &state);
+    if (state) query_end_index(query, &state);
     free(msgno_list);
     return r;
 }
@@ -857,7 +1002,8 @@ EXPORTED int search_query_run(search_que
          * Walk over every folder, applying the scan expression. */
         if (query->multiple) {
             char *userid = mboxname_to_userid(index_mboxname(query->state));
-            r = mboxlist_usermboxtree(userid, subquery_run_global_cb, query, /*flags*/0);
+            r = mboxlist_usermboxtree(userid, NULL, subquery_run_global_cb,
+                                      query, /*flags*/0);
             free(userid);
         }
         else {
@@ -898,3 +1044,46 @@ out:
 }
 
 /* ====================================================================== */
+
+static int is_mutable_sort(struct sortcrit *sortcrit)
+{
+    int i;
+
+    if (!sortcrit) return 0;
+
+    for (i = 0; sortcrit[i].key; i++) {
+        switch (sortcrit[i].key) {
+            /* these are the mutable fields */
+            case SORT_ANNOTATION:
+            case SORT_MODSEQ:
+            case SORT_HASFLAG:
+            case SORT_CONVMODSEQ:
+            case SORT_CONVEXISTS:
+            case SORT_CONVSIZE:
+            case SORT_HASCONVFLAG:
+                return 1;
+            default:
+                break;
+        }
+    }
+
+    return 0;
+}
+
+/* This function will return 2 if the search criteria are mutable
+ * but the sort is not,
+ * 1 if the sort is mutable but the search isn't, 3 if both, and
+ * zero if nither are mutable.
+ * i.e. the user can/can't take actions which will change the order
+ * in which the results are returned.  For example, the base
+ * case of UID sort and all messages is NOT mutable */
+EXPORTED int search_is_mutable(struct sortcrit *sortcrit, search_expr_t *expr)
+{
+    int res = 0;
+    if (search_expr_is_mutable(expr))
+        res |= 2;
+    if (is_mutable_sort(sortcrit))
+        res |= 1;
+    return res;
+}
+
diff -pruN 3.0.13-5/imap/search_query.h 3.2.0-3/imap/search_query.h
--- 3.0.13-5/imap/search_query.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_query.h	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-/* search_result.h -- search result data structure
+/* search_query.h -- search query routines
  *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -65,8 +65,9 @@ struct search_folder {
     uint64_t last_modseq; /* of returned messages, not the folder */
     int id;
     bitvector_t uids;
-    bitvector_t unchecked_uids;
-    int unchecked_dirty;
+    bitvector_t found_uids;
+    int found_dirty;
+    hashu64_table partids; /* maps uid to starray_t* of part ids */
 };
 
 struct search_subquery {
@@ -92,6 +93,9 @@ struct search_query {
      * double-opening it.
      */
     struct index_state *state;
+
+    int (*checkfolder)(const char *mboxname, void *rock);
+    void *checkfolderrock;
     /*
      * Input parameters of the query.  Set these after
      * search_query_new() and before search_query_run().
@@ -104,6 +108,8 @@ struct search_query {
     int want_expunged;
     uint32_t want_mbtype;
     int verbose;
+    int ignore_timer;
+    int attachments_in_any;
 
     /*
      * A query comprises multiple sub-queries logically ORed together.
@@ -180,4 +186,7 @@ extern uint64_t search_folder_get_last_m
 
 extern void search_build_query(search_builder_t *bx, search_expr_t *e);
 
+extern int search_is_mutable(struct sortcrit *sortcrit, search_expr_t *e);
+
+
 #endif /* __CYRUS_SEARCH_RESULT_H__ */
diff -pruN 3.0.13-5/imap/search_sort.h 3.2.0-3/imap/search_sort.h
--- 3.0.13-5/imap/search_sort.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/imap/search_sort.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,100 @@
+/* search_sort.h --  Sort criteria definition for search
+ *
+ * Copyright (c) 1994-2020 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef __CYRUS_SEARCH_SORT_H__
+#define __CYRUS_SEARCH_SORT_H__
+
+/* Sort criterion */
+struct sortcrit {
+    unsigned key;               /* sort key */
+    int flags;                  /* key modifiers as defined below */
+    union {                     /* argument(s) to the sort key */
+        struct {
+            char *entry;
+            char *userid;
+        } annot;
+        struct {
+            char *name;
+        } flag;
+        struct {
+            char *id;
+        } mailbox;
+    } args;
+};
+
+/* Values for sort keys */
+enum {
+    SORT_SEQUENCE = 0,
+    SORT_ARRIVAL,       /* RFC 5256 */
+    SORT_CC,            /* RFC 5256 */
+    SORT_DATE,          /* RFC 5256 */
+    SORT_DISPLAYFROM,   /* RFC 5957 */
+    SORT_DISPLAYTO,     /* RFC 5957 */
+    SORT_FROM,          /* RFC 5256 */
+    SORT_SIZE,          /* RFC 5256 */
+    SORT_SUBJECT,       /* RFC 5256 */
+    SORT_TO,            /* RFC 5256 */
+    SORT_ANNOTATION,    /* RFC 5257 */
+    SORT_MODSEQ,        /* nonstandard */
+    SORT_UID,           /* nonstandard */
+    SORT_HASFLAG,       /* nonstandard */
+    SORT_CONVMODSEQ,    /* nonstandard */
+    SORT_CONVEXISTS,    /* nonstandard */
+    SORT_CONVSIZE,      /* nonstandard */
+    SORT_HASCONVFLAG,   /* nonstandard */
+    SORT_FOLDER,        /* nonstandard */
+    SORT_RELEVANCY,     /* RFC 6203 */
+    SORT_SPAMSCORE,     /* nonstandard */
+    SORT_GUID,          /* nonstandard */
+    SORT_EMAILID,       /* nonstandard */
+    SORT_THREADID,      /* nonstandard */
+    SORT_SAVEDATE,      /* nonstandard */
+    SORT_SNOOZEDUNTIL,  /* nonstandard */
+    SORT_CREATEDMODSEQ, /* nonstandard */
+    /* values > 255 are reserved for internal use */
+};
+
+/* Sort key modifier flag bits */
+#define SORT_REVERSE            (1<<0)      /* RFC 5256 */
+
+
+#endif /* __CYRUS_SEARCH_SORT_H__ */
diff -pruN 3.0.13-5/imap/search_sphinx.c 3.2.0-3/imap/search_sphinx.c
--- 3.0.13-5/imap/search_sphinx.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_sphinx.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2398 +0,0 @@
-/* search_sphinx.c -- glue code for searching with Sphinx
- *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-#include <config.h>
-
-#include <errno.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <fcntl.h>
-#include <stdlib.h>
-#include <syslog.h>
-#include <string.h>
-#ifdef HAVE_UNISTD_H
-#include <unistd.h>
-#endif
-
-#include "index.h"
-#include "global.h"
-#include "retry.h"
-#include "command.h"
-#include "xmalloc.h"
-#include "xstrlcpy.h"
-#include "xstrlcat.h"
-#include "ptrarray.h"
-#include "bitvector.h"
-#include "mboxlist.h"
-#include "xstats.h"
-#include "search_engines.h"
-#include "cyr_lock.h"
-
-/* generated headers are not necessarily in current directory */
-#include "imap/imap_err.h"
-#include "imap/imap_err.h"
-
-#include <mysql/mysql.h>
-
-struct connection
-{
-    MYSQL *mysql;
-};
-#define CONNECTION_INITIALIZER  { 0 }
-
-struct latestdb
-{
-    struct db *db;
-    char *path;
-};
-#define LATESTDB_INITIALIZER { 0, 0 }
-#define LATESTDB_VERSION        1
-#define LATESTDB_FNAME          "/latest.db"
-#define LATESTDB_LASTID_KEY     "LASTID"
-
-#define SPHINX_CONFIG       "/sphinx.conf"
-#define SEARCHD             "/usr/bin/searchd"
-
-#define INDEXING_LOCK_SUFFIX    ".indexing.lock"
-
-static int open_latest(struct mailbox *, struct latestdb *);
-static void close_latest(struct latestdb *);
-static int read_latest(struct latestdb *, struct mailbox *, uint32_t *, int);
-static int write_latest(struct latestdb *, struct mailbox *, uint32_t, int);
-static int doquery(struct connection *, int, const struct buf *);
-static int sphinx_basedir(const struct mailbox *mailbox, char **basedirp, char **indexnamep);
-static int sphinx_setup(const struct mailbox *mailbox, int verbose, int create);
-
-/* Name of columns */
-#define COL_CYRUSID     "cyrusid"
-static const char * const column_by_part[SEARCH_NUM_PARTS] = {
-    NULL,
-    "header_from",
-    "header_to",
-    "header_cc",
-    "header_bcc",
-    "header_subject",
-    "header_listid",
-    "header_type",
-    "headers",
-    "body",
-    "location",
-    "attachmentname"
-};
-
-static void close_connection(struct connection *conn)
-{
-    if (conn->mysql) {
-        xstats_inc(SPHINX_CLOSE);
-        mysql_close(conn->mysql);
-        conn->mysql = NULL;
-        mysql_library_end();
-    }
-}
-
-static int get_connection(struct connection *conn)
-{
-    MYSQL *c = NULL;
-    const char *socket_path = config_getstring(IMAPOPT_SPHINX_SOCKET);
-
-    if (conn->mysql) return 0;      /* already open */
-
-    close_connection(conn);
-
-    xstats_inc(SPHINX_CONNECT);
-    c = mysql_init(NULL);
-
-    if (!mysql_real_connect(c,
-                           /*host*/NULL,
-                           /*user*/"", /*password*/"",
-                           /*database*/NULL,
-                           /*port*/0, socket_path,
-                           /*client_flag*/0)) {
-        syslog(LOG_ERR, "IOERROR: failed to connect to Sphinx: %s",
-               mysql_error(c));
-        mysql_close(c);
-        mysql_library_end();
-        return IMAP_IOERROR;
-    }
-
-    conn->mysql = c;
-    return 0;
-}
-
-static int parse_cyrusid(const char *cyrusid,
-                         const char **mboxnamep,
-                         unsigned int *uidvalidityp,
-                         unsigned int *uidp)
-{
-    // user.cassandane.1320711192.196715
-    static struct buf buf = BUF_INITIALIZER;
-    char *p;
-
-    buf_reset(&buf);
-    buf_appendcstr(&buf, cyrusid);
-
-    p = strrchr(buf_cstring(&buf), '.');
-    if (!p)
-        return 0;
-    *p++ = '\0';
-    *uidp = strtoul(p, NULL, 10);
-
-    p = strrchr(buf.s, '.');
-    if (!p)
-        return 0;
-    *p++ = '\0';
-    *uidvalidityp = strtoul(p, NULL, 10);
-
-    *mboxnamep = buf.s;
-
-    return 1;
-}
-
-static const struct buf *make_cyrusid(struct mailbox *mailbox, uint32_t uid)
-{
-    static struct buf buf = BUF_INITIALIZER;
-    // user.cassandane.1320711192.196715
-    buf_reset(&buf);
-    buf_printf(&buf, "%s.%u.%u",
-                     mailbox->name,
-                     mailbox->i.uidvalidity,
-                     uid);
-    return &buf;
-}
-
-/*
- * Escape a string for MySQL.  Note that mysql_real_escape_string
- * requires a live connection, and we now want to be able to build a
- * query string before we have a connection.  From the MySQL
- * documentation:
- *
- *      Strictly speaking, MySQL requires only that backslash and
- *      the quote character used to quote the string in the query
- *      be escaped. mysql_real_escape_string() quotes the other
- *      characters to make them easier to read in log files.
- *
- * Note that we need to escape a number of SphinxQL extended query
- * syntax metacharacters like ^ and $.
- */
-static void append_escaped_map(struct buf *buf,
-                               const char *base, unsigned int len,
-                               int quote)
-{
-    static const char metacharacters[] = "!\"$'-/<=@[\\]^|~";
-    buf_ensure(buf, len+1);
-
-    buf_putc(buf, quote);
-    for ( ; len ; len--, base++) {
-        int c = *(unsigned char *)base;
-        if (strchr(metacharacters, c))
-            buf_putc(buf, '\\');
-        buf_putc(buf, c);
-    }
-    buf_putc(buf, quote);
-    buf_cstring(buf);
-}
-
-static void append_escaped(struct buf *to, const struct buf *from, int quote)
-{
-    append_escaped_map(to, from->s, from->len, quote);
-}
-
-static void append_escaped_cstr(struct buf *to, const char *str, int quote)
-{
-    if (str)
-        append_escaped_map(to, str, strlen(str), quote);
-}
-
-struct opnode {
-    int op;     /* SEARCH_OP_* or SEARCH_PART_* constant */
-    char *arg;
-    struct opnode *next;
-    struct opnode *children;
-};
-
-typedef struct sphinx_builder sphinx_builder_t;
-struct sphinx_builder {
-    search_builder_t super;
-    struct mailbox *mailbox;
-    char *indexname;
-    int opts;
-    struct opnode *root;
-    ptrarray_t stack;       /* points to opnode* */
-};
-
-static struct opnode *opnode_new(int op, const char *arg)
-{
-    struct opnode *on = xzmalloc(sizeof(struct opnode));
-    on->op = op;
-    on->arg = xstrdupnull(arg);
-    return on;
-}
-
-static void opnode_delete(struct opnode *on)
-{
-    struct opnode *child;
-    struct opnode *next;
-
-    for (child = on->children ; child ; child = next) {
-        next = child->next;
-        opnode_delete(child);
-    }
-    free(on->arg);
-    free(on);
-}
-
-static void opnode_detach_child(struct opnode *parent, struct opnode *child)
-{
-    struct opnode **prevp;
-
-    for (prevp = &parent->children ; *prevp ; prevp = &((*prevp)->next)) {
-        if (*prevp == child) {
-            *prevp = child->next;
-            child->next = NULL;
-            return;
-        }
-    }
-}
-
-static void opnode_append_child(struct opnode *parent, struct opnode *child)
-{
-    struct opnode **tailp;
-
-    for (tailp = &parent->children ; *tailp ; tailp = &((*tailp)->next))
-        ;
-    *tailp = child;
-    child->next = NULL;
-}
-
-static void opnode_insert_child(struct opnode *parent __attribute__((unused)),
-                                struct opnode *after,
-                                struct opnode *child)
-{
-    child->next = after->next;
-    after->next = child;
-}
-
-static void begin_boolean(search_builder_t *bx, int op)
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-    struct opnode *top = ptrarray_tail(&bb->stack);
-    struct opnode *on = opnode_new(op, NULL);
-    if (top)
-        opnode_append_child(top, on);
-    else
-        bb->root = on;
-    ptrarray_push(&bb->stack, on);
-    if (SEARCH_VERBOSE(bb->opts))
-        syslog(LOG_INFO, "begin_boolean(op=%s)", search_op_as_string(op));
-}
-
-static void end_boolean(search_builder_t *bx, int op __attribute__((unused)))
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-    if (SEARCH_VERBOSE(bb->opts))
-        syslog(LOG_INFO, "end_boolean");
-    ptrarray_pop(&bb->stack);
-}
-
-static void match(search_builder_t *bx, int part, const char *str)
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-    struct opnode *top = ptrarray_tail(&bb->stack);
-    struct opnode *on;
-
-    if (!str) return;
-    if (SEARCH_VERBOSE(bb->opts))
-        syslog(LOG_INFO, "match(part=%s, str=\"%s\")",
-               search_part_as_string(part), str);
-
-    xstats_inc(SPHINX_MATCH);
-
-    on = opnode_new(part, str);
-    if (top)
-        opnode_append_child(top, on);
-    else
-        bb->root = on;
-}
-
-static void optimise_nodes(struct opnode *parent, struct opnode *on)
-{
-    struct opnode *child;
-    struct opnode *next;
-
-    switch (on->op) {
-    case SEARCH_OP_NOT:
-    case SEARCH_OP_OR:
-    case SEARCH_OP_AND:
-        for (child = on->children ; child ; child = next) {
-            next = child->next;
-            optimise_nodes(on, child);
-        }
-        if (parent) {
-            if (!on->children) {
-                /* empty node - remove it */
-                opnode_detach_child(parent, on);
-                opnode_delete(on);
-            }
-            else if (on->op != SEARCH_OP_NOT && !on->children->next) {
-                /* logical AND or OR with only one child - replace
-                 * the node with its child */
-                struct opnode *child = on->children;
-                opnode_detach_child(on, child);
-                opnode_insert_child(parent, on, child);
-                opnode_detach_child(parent, on);
-                opnode_delete(on);
-            }
-        }
-        break;
-    }
-}
-
-/* Sphinx extended query syntax, not SphinxQL */
-static void generate_query(struct buf *query,
-                           struct opnode *on,
-                           struct opnode *parent)
-{
-    struct opnode *child;
-    struct buf arg = BUF_INITIALIZER;
-    int need_paren;
-    int sep;
-
-    buf_init_ro_cstr(&arg, on->arg);
-
-    switch (on->op) {
-
-    case SEARCH_OP_NOT:
-        if (on->children) buf_appendcstr(query, "!");
-        /* fall through - note we treat multiple children to a NOT
-         * node as if they were ANDed together because that's the
-         * closest match to IMAP semantics. */
-    case SEARCH_OP_OR:
-    case SEARCH_OP_AND:
-
-        need_paren = 0;
-        if (parent && parent->op > on->op)
-            need_paren = 1;
-        if (on->op == SEARCH_OP_NOT)
-            need_paren = 1;
-        /* Note that we might have 0, 1, or >1 children, the caller will
-         * not have optimised the silly cases out. */
-        if (!on->children || !on->children->next)
-            need_paren = 0;
-
-        sep = (on->op == SEARCH_OP_OR ? '|' : ' ');
-
-        if (need_paren) buf_putc(query, '(');
-        for (child = on->children ; child ; child = child->next) {
-            generate_query(query, child, on);
-            if (child->next) buf_putc(query, sep);
-        }
-        if (need_paren) buf_putc(query, ')');
-        break;
-
-    case SEARCH_PART_ANY:
-        assert(on->children == NULL);
-        if (config_getswitch(IMAPOPT_SPHINX_TEXT_EXCLUDES_ODD_HEADERS)) {
-            /* This horrible hack makes TEXT searches match FROM, TO, CC, BCC
-             * and SUBJECT but not any other random headers, which is more
-             * like what users expect. */
-            int i;
-            const char *sep = "(";
-            buf_appendcstr(query, "@");
-            for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-                if (column_by_part[i] && i != SEARCH_PART_HEADERS) {
-                    buf_appendcstr(query, sep);
-                    buf_appendcstr(query, column_by_part[i]);
-                    sep = ",";
-                }
-            }
-            buf_appendcstr(query, ") ");
-        }
-        append_escaped(query, &arg, '"');
-        break;
-
-    default:
-        /* other SEARCH_PART_* constants */
-        assert(on->op >= 0 && on->op < SEARCH_NUM_PARTS);
-        assert(on->children == NULL);
-        buf_appendcstr(query, "@");
-        buf_appendcstr(query, column_by_part[on->op]);
-        buf_appendcstr(query, " ");
-        append_escaped(query, &arg, '"');
-        break;
-    }
-
-    buf_free(&arg);
-}
-
-static void *get_internalised(search_builder_t *bx)
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-    struct opnode *on = bb->root;
-    bb->root = NULL;
-    optimise_nodes(NULL, on);
-    return on;
-}
-
-static char *describe_internalised(void *internalised)
-{
-    struct opnode *on = (struct opnode *)internalised;
-    struct buf buf = BUF_INITIALIZER;
-
-    generate_query(&buf, on, NULL);
-    return buf_release(&buf);
-}
-
-static void free_internalised(void *internalised)
-{
-    struct opnode *on = (struct opnode *)internalised;
-    if (on) opnode_delete(on);
-}
-
-static int run(search_builder_t *bx, search_hit_cb_t proc, void *rock);
-
-static search_builder_t *begin_search(struct mailbox *mailbox, int opts)
-{
-    sphinx_builder_t *bb;
-    int r;
-
-    bb = xzmalloc(sizeof(sphinx_builder_t));
-    bb->super.begin_boolean = begin_boolean;
-    bb->super.end_boolean = end_boolean;
-    bb->super.match = match;
-    bb->super.get_internalised = get_internalised;
-    bb->super.run = run;
-
-    bb->mailbox = mailbox;
-    bb->opts = opts;
-
-    r = sphinx_basedir(mailbox, NULL, &bb->indexname);
-    if (r) {
-        free(bb);
-        return NULL;
-    }
-
-    if ((opts & SEARCH_MULTIPLE))
-        xstats_inc(SPHINX_MULTIPLE);
-    else
-        xstats_inc(SPHINX_SINGLE);
-
-    return &bb->super;
-}
-
-static int run(search_builder_t *bx, search_hit_cb_t proc, void *rock)
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-    struct connection conn = CONNECTION_INITIALIZER;
-    struct buf query = BUF_INITIALIZER; /* SphinxQL query */
-    struct buf inner_query = BUF_INITIALIZER;   /* Sphinx extended match syntax  */
-    MYSQL_RES *res = NULL;
-    MYSQL_ROW row;
-    uint32_t uid;
-    uint32_t latest = 0;
-    int r = 0;
-
-    r = sphinx_setup(bb->mailbox, SEARCH_VERBOSE(bb->opts), /*create*/0);
-    if (r == IMAP_NOTFOUND) {
-        /* there's no index for this user */
-        r = 0;
-        goto out;
-    }
-    if (r) goto out;
-
-    r = get_connection(&conn);
-    if (r) goto out;
-
-    if ((bb->opts & SEARCH_UNINDEXED)) {
-        /* To avoid races, we want the 'latest' uid we use to be
-         * an underestimate, because the caller can handle false
-         * positives but not false negatives.  So we fetch it
-         * first before the main query. */
-        struct latestdb ldb = LATESTDB_INITIALIZER;
-        r = open_latest(bb->mailbox, &ldb);
-        if (!r) goto out;
-        r = read_latest(&ldb, bb->mailbox, &latest,
-                        SEARCH_VERBOSE(bb->opts));
-        close_latest(&ldb);
-        if (r) goto out;
-    }
-
-    optimise_nodes(NULL, bb->root);
-    generate_query(&inner_query, bb->root, NULL);
-
-    buf_printf(&query, "SELECT "COL_CYRUSID" FROM %s WHERE MATCH(", bb->indexname);
-    append_escaped(&query, &inner_query, '\'');
-    buf_appendcstr(&query, ")");
-    // get sphinx to sort by most recent date first
-    buf_appendcstr(&query, " ORDER BY "COL_CYRUSID" DESC "
-                               " LIMIT " SPHINX_MAX_MATCHES
-                               " OPTION max_matches=" SPHINX_MAX_MATCHES);
-    buf_cstring(&query);
-
-    if (SEARCH_VERBOSE(bb->opts))
-        syslog(LOG_NOTICE, "Sphinx query %s", query.s);
-    xstats_inc(SPHINX_QUERY);
-
-    r = mysql_real_query(conn.mysql, query.s, query.len);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: Sphinx query %s failed: %s",
-               query.s, mysql_error(conn.mysql));
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    res = mysql_use_result(conn.mysql);
-    while ((row = mysql_fetch_row(res))) {
-        const char *mboxname;
-        unsigned int uidvalidity;
-        unsigned int uid;
-        if (SEARCH_VERBOSE(bb->opts) > 1)
-            syslog(LOG_NOTICE, "Sphinx row cyrusid=%s", row[0]);
-        xstats_inc(SPHINX_ROW);
-        if (!parse_cyrusid(row[0], &mboxname, &uidvalidity, &uid))
-            // TODO: whine
-            continue;
-        if (!(bb->opts & SEARCH_MULTIPLE)) {
-            if (strcmp(mboxname, bb->mailbox->name))
-                continue;
-            if (uidvalidity != bb->mailbox->i.uidvalidity)
-                continue;
-        }
-        xstats_inc(SPHINX_RESULT);
-        r = proc(mboxname, uidvalidity, uid, rock);
-        if (r) goto out;
-    }
-    r = 0;
-
-    if ((bb->opts & SEARCH_UNINDEXED)) {
-        /* add in the unindexed uids as false positives */
-        for (uid = latest+1 ; uid <= bb->mailbox->i.last_uid ; uid++) {
-            xstats_inc(SPHINX_UNINDEXED);
-            r = proc(bb->mailbox->name, bb->mailbox->i.uidvalidity, uid, rock);
-            if (r) goto out;
-        }
-    }
-
-out:
-    if (res) mysql_free_result(res);
-    close_connection(&conn);
-    buf_free(&query);
-    buf_free(&inner_query);
-    return r;
-}
-
-static void end_search(search_builder_t *bx)
-{
-    sphinx_builder_t *bb = (sphinx_builder_t *)bx;
-
-    ptrarray_fini(&bb->stack);
-    if (bb->root) opnode_delete(bb->root);
-    free(bb->indexname);
-    free(bx);
-}
-
-/* base class for both update and snippet receivers */
-typedef struct sphinx_receiver sphinx_receiver_t;
-struct sphinx_receiver
-{
-    search_text_receiver_t super;
-    int verbose;
-    struct mailbox *mailbox;
-    char *indexname;
-    uint32_t uid;
-    int part;
-    unsigned int parts_total;
-    int truncate_warning;
-    struct buf parts[SEARCH_NUM_PARTS];
-    struct buf tmp;             /* SphinxQL query */
-};
-
-/* receiver used for updating the index */
-typedef struct sphinx_update_receiver sphinx_update_receiver_t;
-struct sphinx_update_receiver
-{
-    sphinx_receiver_t super;
-    struct connection conn;
-    int indexing_lock_fd;
-    unsigned int uncommitted;
-    uint32_t latest;
-    struct latestdb latestdb;
-    uint32_t lastid;        /* largest document ID in the 'tr' table,
-                             * used to assign new document IDs when
-                             * INSERTing into the table */
-};
-
-/* receiver used for extracting snippets after a search */
-typedef struct sphinx_snippet_receiver sphinx_snippet_receiver_t;
-struct sphinx_snippet_receiver
-{
-    sphinx_receiver_t super;
-    struct connection conn;
-    struct opnode *root;
-    search_snippet_cb_t proc;
-    void *rock;
-};
-
-/* Maximum size of a query, determined empirically, is a little bit
- * under 8MB.  That seems like more than enough, so let's limit the
- * total amount of parts text to 4 MB. */
-#define MAX_PARTS_SIZE      (4*1024*1024)
-
-static const char *describe_query(struct buf *desc,
-                                  const struct buf *query,
-                                  unsigned maxlen)
-{
-    buf_reset(desc);
-    buf_appendcstr(desc, "Sphinx query ");
-    if (maxlen && query->len > maxlen) {
-        buf_appendmap(desc, query->s, maxlen);
-        buf_appendcstr(desc, "...");
-    }
-    else {
-        buf_append(desc, query);
-    }
-    return buf_cstring(desc);
-}
-
-static int doquery(struct connection *conn, int verbose, const struct buf *query)
-{
-    int r;
-    struct buf desc = BUF_INITIALIZER;
-    unsigned int maxlen = verbose > 2 ? /*unlimited*/0 : 128;
-
-    if (verbose > 1)
-        syslog(LOG_NOTICE, "%s", describe_query(&desc, query, maxlen));
-
-    r = mysql_real_query(conn->mysql, query->s, query->len);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: %s failed: %s",
-                        describe_query(&desc, query, maxlen),
-                        mysql_error(conn->mysql));
-        r = IMAP_IOERROR;
-    }
-
-    buf_free(&desc);
-    return r;
-}
-
-#if 0
-/* Dump a result which has had mysql_store_result() called on it */
-static void dump_result(MYSQL_RES *res)
-{
-    uint64_t nrows = mysql_num_rows(res);
-    unsigned int nfields = mysql_num_fields(res);
-    unsigned int i;
-    unsigned int j;
-    MYSQL_FIELD *fields = mysql_fetch_fields(res);
-    MYSQL_ROW *row;
-    struct buf buf = BUF_INITIALIZER;
-
-    syslog(LOG_NOTICE, "Sphinx result: %u rows", (unsigned int)nrows);
-    i = 0;
-    while ((row = mysql_fetch_row(res))) {
-        buf_reset(&buf);
-        for (j = 0 ; j < nfields ; j++)
-            buf_printf(&buf, " %s=\"%s\"", fields[j].name, row[j]);
-        syslog(LOG_NOTICE, "    [%u]%s", ++i, buf_cstring(&buf));
-    }
-
-    buf_free(&buf);
-    mysql_data_seek(res, 0);    /* rewind */
-}
-#endif
-
-static const char *sphinx_config_file(void)
-{
-    static const char *config_file = NULL;
-
-    if (!config_file)
-        config_file = strconcat(config_dir, SPHINX_CONFIG, (char *)NULL);
-    return config_file;
-}
-
-static const char *sphinx_rootdir(const char *partition)
-{
-    char *confkey;
-    const char *root;
-    if (!partition)
-        partition = config_getstring(IMAPOPT_DEFAULTPARTITION);
-    confkey = strconcat("searchpartition-", partition, NULL);
-    root = config_getoverflowstring(confkey, NULL);
-    free(confkey);
-    return root;
-}
-
-/* When building an index name we need to escape any @ or . characters
- * in the username.  We're slightly more general than that.  */
-static void z_escape(struct buf *buf, const char *s)
-{
-    for ( ; *s ; s++) {
-        if (*s == 'Z' || !Uisalnum(*s))
-            buf_printf(buf, "Z%02X", *(const unsigned char *)s);
-        else
-            buf_putc(buf, *s);
-    }
-}
-
-/* Returns in *basedir and *indexname new strings which must be free()d */
-static int sphinx_basedir(const struct mailbox *mailbox,
-                          char **basedirp,
-                          char **indexnamep)
-{
-    const char *root;
-    char *basedir = NULL;
-    struct buf indexname = BUF_INITIALIZER;
-    struct mboxname_parts parts;
-    char c[2], d[2];
-    int r;
-
-    mboxname_init_parts(&parts);
-
-    root = sphinx_rootdir(mailbox->part);
-    if (!root) {
-        r = IMAP_PARTITION_UNKNOWN;
-        goto out;
-    }
-
-    r = mboxname_to_parts(mailbox->name, &parts);
-    if (r) goto out;
-    if (!parts.userid) {
-        r = IMAP_PARTITION_UNKNOWN;
-        goto out;
-    }
-
-    if (parts.domain)
-        basedir = strconcat(root,
-                            FNAME_DOMAINDIR,
-                            dir_hash_b(parts.domain, config_fulldirhash, d),
-                            "/", parts.domain,
-                            FNAME_USERDIR,
-                            dir_hash_b(parts.userid, config_fulldirhash, c),
-                            "/", parts.userid,
-                            (char *)NULL);
-    else
-        basedir = strconcat(root,
-                            FNAME_USERDIR,
-                            dir_hash_b(parts.userid, config_fulldirhash, c),
-                            "/", parts.userid,
-                            (char *)NULL);
-
-    buf_appendcstr(&indexname, "X");
-    z_escape(&indexname, parts.userid);
-    if (parts.domain) {
-        z_escape(&indexname, "@");
-        z_escape(&indexname, parts.domain);
-    }
-
-    r = 0;
-
-out:
-    if (!r && indexnamep)
-        *indexnamep = buf_release(&indexname);
-    buf_free(&indexname);
-    if (!r && basedirp)
-        *basedirp = basedir;
-    else
-        free(basedir);
-    mboxname_free_parts(&parts);
-    return r;
-}
-
-static const char *sphinx_syslog_prefix(void)
-{
-    static const char *prefix = NULL;
-
-    if (!prefix) {
-        prefix = config_getstring(IMAPOPT_SYSLOG_PREFIX);
-        if (!prefix)
-            prefix = "cyrus";
-    }
-    return prefix;
-}
-
-static int check_directory(const char *dir, int verbose, int create)
-{
-    int r;
-    char *dummyfile = NULL;
-    struct stat sb;
-
-    r = stat(dir, &sb);
-    if (r < 0) {
-        if (r != ENOENT) {
-            /* something went wrong - permissions problem most likely */
-            syslog(LOG_ERR, "IOERROR: unable to stat %s: %m", dir);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-        /* the directory is just missing */
-        if (!create) {
-            /* caller doesn't care that much */
-            r = IMAP_NOTFOUND;
-            goto out;
-        }
-        if (verbose)
-            syslog(LOG_INFO, "Building directory %s", dir);
-        dummyfile = strconcat(dir, "/dummy", (char *)NULL);
-        cyrus_mkdir(dummyfile, 0700);
-        r = stat(dir, &sb);
-        if (r < 0) {
-            /* something went wrong - permissions problem most likely */
-            syslog(LOG_ERR, "IOERROR: unable to stat %s: %m", dir);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-    }
-
-out:
-    free(dummyfile);
-    return r;
-}
-
-static int sphinx_signal(int sig, int verbose)
-{
-    const char *pidfile = config_getstring(IMAPOPT_SPHINX_PIDFILE);
-    int fd = -1;
-    pid_t pid;
-    int r;
-    char buf[33];
-
-    fd = open(pidfile, O_RDONLY, 0);
-    if (fd < 0) {
-        if (fd == ENOENT) {
-            r = IMAP_NOTFOUND;
-        }
-        else {
-            syslog(LOG_ERR, "IOERROR: unable to open %s for reading: %m", pidfile);
-            r = IMAP_IOERROR;
-        }
-        goto out;
-    }
-
-    memset(buf, 0, sizeof(buf));
-    r = read(fd, buf, sizeof(buf)-1);
-    if (r < 0) {
-        syslog(LOG_ERR, "IOERROR: unable to read %s: %m", pidfile);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-    if (r == 0) {
-        syslog(LOG_ERR, "IOERROR: short file %s", pidfile);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    pid = strtoul(buf, NULL, 10);
-    if (pid <= 0) {
-        syslog(LOG_ERR, "IOERROR: invalid contents of %s", pidfile);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    if (verbose)
-        syslog(LOG_INFO, "Sending signal %d to pid %d from %s",
-                sig, (int)pid, pidfile);
-
-    r = kill(pid, sig);
-    if (r < 0) {
-        if (r == ESRCH) {
-            r = IMAP_NOTFOUND;
-        }
-        else {
-            syslog(LOG_ERR, "IOERROR: failed to send signal %d "
-                            "to searchd pid %d: %m",
-                            sig, (int)pid);
-            r = IMAP_SYS_ERROR;
-        }
-        goto out;
-    }
-
-    r = 0;
-
-out:
-    if (fd >= 0) close(fd);
-    return r;
-}
-
-
-static int sphinx_setup(const struct mailbox *mailbox, int verbose, int create)
-{
-    static const char user_config[] =
-        "index $indexname\n"
-        "{\n"
-        "    type = rt\n"
-        "    path = $basedir/rt\n"
-        "    morphology = stem_en\n"
-        "    charset_type = utf-8\n"
-        "    charset_table = 0..9, A..Z->a..z, _, a..z, \\\n"
-        /* Support for Cyrillic from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cyrillic */
-        "       U+0400->U+0435, U+0401->U+0435, U+0402->U+0452, U+0452, \\\n"
-        "       U+0403->U+0433, U+0404->U+0454, U+0454, U+0405->U+0455, \\\n"
-        "       U+0455, U+0406->U+0456, U+0407->U+0456, U+0457->U+0456, \\\n"
-        "       U+0456, U+0408..U+040B->U+0458..U+045B, U+0458..U+045B, \\\n"
-        "       U+040C->U+043A, U+040D->U+0438, U+040E->U+0443, U+040F->U+045F, \\\n"
-        "       U+045F, U+0450->U+0435, U+0451->U+0435, U+0453->U+0433, \\\n"
-        "       U+045C->U+043A, U+045D->U+0438, U+045E->U+0443, U+0460->U+0461, \\\n"
-        "       U+0461, U+0462->U+0463, U+0463, U+0464->U+0465, U+0465, \\\n"
-        "       U+0466->U+0467, U+0467, U+0468->U+0469, U+0469, U+046A->U+046B, \\\n"
-        "       U+046B, U+046C->U+046D, U+046D, U+046E->U+046F, U+046F, \\\n"
-        "       U+0470->U+0471, U+0471, U+0472->U+0473, U+0473, U+0474->U+0475, \\\n"
-        "       U+0476->U+0475, U+0477->U+0475, U+0475, U+0478->U+0479, U+0479, \\\n"
-        "       U+047A->U+047B, U+047B, U+047C->U+047D, U+047D, U+047E->U+047F, \\\n"
-        "       U+047F, U+0480->U+0481, U+0481, U+048A->U+0438, U+048B->U+0438, \\\n"
-        "       U+048C->U+044C, U+048D->U+044C, U+048E->U+0440, U+048F->U+0440, \\\n"
-        "       U+0490->U+0433, U+0491->U+0433, U+0490->U+0433, U+0491->U+0433, \\\n"
-        "       U+0492->U+0433, U+0493->U+0433, U+0494->U+0433, U+0495->U+0433, \\\n"
-        "       U+0496->U+0436, U+0497->U+0436, U+0498->U+0437, U+0499->U+0437, \\\n"
-        "       U+049A->U+043A, U+049B->U+043A, U+049C->U+043A, U+049D->U+043A, \\\n"
-        "       U+049E->U+043A, U+049F->U+043A, U+04A0->U+043A, U+04A1->U+043A, \\\n"
-        "       U+04A2->U+043D, U+04A3->U+043D, U+04A4->U+043D, U+04A5->U+043D, \\\n"
-        "       U+04A6->U+043F, U+04A7->U+043F, U+04A8->U+04A9, U+04A9, \\\n"
-        "       U+04AA->U+0441, U+04AB->U+0441, U+04AC->U+0442, U+04AD->U+0442, \\\n"
-        "       U+04AE->U+0443, U+04AF->U+0443, U+04B0->U+0443, U+04B1->U+0443, \\\n"
-        "       U+04B2->U+0445, U+04B3->U+0445, U+04B4->U+04B5, U+04B5, \\\n"
-        "       U+04B6->U+0447, U+04B7->U+0447, U+04B8->U+0447, U+04B9->U+0447, \\\n"
-        "       U+04BA->U+04BB, U+04BB, U+04BC->U+04BD, U+04BE->U+04BD, \\\n"
-        "       U+04BF->U+04BD, U+04BD, U+04C0->U+04CF, U+04CF, U+04C1->U+0436, \\\n"
-        "       U+04C2->U+0436, U+04C3->U+043A, U+04C4->U+043A, U+04C5->U+043B, \\\n"
-        "       U+04C6->U+043B, U+04C7->U+043D, U+04C8->U+043D, U+04C9->U+043D, \\\n"
-        "       U+04CA->U+043D, U+04CB->U+0447, U+04CC->U+0447, U+04CD->U+043C, \\\n"
-        "       U+04CE->U+043C, U+04D0->U+0430, U+04D1->U+0430, U+04D2->U+0430, \\\n"
-        "       U+04D3->U+0430, U+04D4->U+00E6, U+04D5->U+00E6, U+04D6->U+0435, \\\n"
-        "       U+04D7->U+0435, U+04D8->U+04D9, U+04DA->U+04D9, U+04DB->U+04D9, \\\n"
-        "       U+04D9, U+04DC->U+0436, U+04DD->U+0436, U+04DE->U+0437, \\\n"
-        "       U+04DF->U+0437, U+04E0->U+04E1, U+04E1, U+04E2->U+0438, \\\n"
-        "       U+04E3->U+0438, U+04E4->U+0438, U+04E5->U+0438, U+04E6->U+043E, \\\n"
-        "       U+04E7->U+043E, U+04E8->U+043E, U+04E9->U+043E, U+04EA->U+043E, \\\n"
-        "       U+04EB->U+043E, U+04EC->U+044D, U+04ED->U+044D, U+04EE->U+0443, \\\n"
-        "       U+04EF->U+0443, U+04F0->U+0443, U+04F1->U+0443, U+04F2->U+0443, \\\n"
-        "       U+04F3->U+0443, U+04F4->U+0447, U+04F5->U+0447, U+04F6->U+0433, \\\n"
-        "       U+04F7->U+0433, U+04F8->U+044B, U+04F9->U+044B, U+04FA->U+0433, \\\n"
-        "       U+04FB->U+0433, U+04FC->U+0445, U+04FD->U+0445, U+04FE->U+0445, \\\n"
-        "       U+04FF->U+0445, U+0410..U+0418->U+0430..U+0438, U+0419->U+0438, \\\n"
-        "       U+0430..U+0438, U+041A..U+042F->U+043A..U+044F, U+043A..U+044F,\\\n"
-        /* and this one was missing dammit */
-        "       U+0418->U+0438, U+0439->U+0438, \\\n"
-        /* Sumerian cuneiform which is fun for testing but seems
-         * to be broken in Spinx. */
-        /*
-        "       U+12000..U+1237F, \\\n"
-        */
-        /* Support for Chinese/Japanese/Korean, from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cjk */
-        "       U+F900->U+8C48, U+F901->U+66F4, U+F902->U+8ECA, U+F903->U+8CC8, \\\n"
-        "       U+F904->U+6ED1, U+F905->U+4E32, U+F906->U+53E5, U+F907->U+9F9C, \\\n"
-        "       U+F908->U+9F9C, U+F909->U+5951, U+F90A->U+91D1, U+F90B->U+5587, \\\n"
-        "       U+F90C->U+5948, U+F90D->U+61F6, U+F90E->U+7669, U+F90F->U+7F85, \\\n"
-        "       U+F910->U+863F, U+F911->U+87BA, U+F912->U+88F8, U+F913->U+908F, \\\n"
-        "       U+F914->U+6A02, U+F915->U+6D1B, U+F916->U+70D9, U+F917->U+73DE, \\\n"
-        "       U+F918->U+843D, U+F919->U+916A, U+F91A->U+99F1, U+F91B->U+4E82, \\\n"
-        "       U+F91C->U+5375, U+F91D->U+6B04, U+F91E->U+721B, U+F91F->U+862D, \\\n"
-        "       U+F920->U+9E1E, U+F921->U+5D50, U+F922->U+6FEB, U+F923->U+85CD, \\\n"
-        "       U+F924->U+8964, U+F925->U+62C9, U+F926->U+81D8, U+F927->U+881F, \\\n"
-        "       U+F928->U+5ECA, U+F929->U+6717, U+F92A->U+6D6A, U+F92B->U+72FC, \\\n"
-        "       U+F92C->U+90CE, U+F92D->U+4F86, U+F92E->U+51B7, U+F92F->U+52DE, \\\n"
-        "       U+F930->U+64C4, U+F931->U+6AD3, U+F932->U+7210, U+F933->U+76E7, \\\n"
-        "       U+F934->U+8001, U+F935->U+8606, U+F936->U+865C, U+F937->U+8DEF, \\\n"
-        "       U+F938->U+9732, U+F939->U+9B6F, U+F93A->U+9DFA, U+F93B->U+788C, \\\n"
-        "       U+F93C->U+797F, U+F93D->U+7DA0, U+F93E->U+83C9, U+F93F->U+9304, \\\n"
-        "       U+F940->U+9E7F, U+F941->U+8AD6, U+F942->U+58DF, U+F943->U+5F04, \\\n"
-        "       U+F944->U+7C60, U+F945->U+807E, U+F946->U+7262, U+F947->U+78CA, \\\n"
-        "       U+F948->U+8CC2, U+F949->U+96F7, U+F94A->U+58D8, U+F94B->U+5C62, \\\n"
-        "       U+F94C->U+6A13, U+F94D->U+6DDA, U+F94E->U+6F0F, U+F94F->U+7D2F, \\\n"
-        "       U+F950->U+7E37, U+F951->U+964B, U+F952->U+52D2, U+F953->U+808B, \\\n"
-        "       U+F954->U+51DC, U+F955->U+51CC, U+F956->U+7A1C, U+F957->U+7DBE, \\\n"
-        "       U+F958->U+83F1, U+F959->U+9675, U+F95A->U+8B80, U+F95B->U+62CF, \\\n"
-        "       U+F95C->U+6A02, U+F95D->U+8AFE, U+F95E->U+4E39, U+F95F->U+5BE7, \\\n"
-        "       U+F960->U+6012, U+F961->U+7387, U+F962->U+7570, U+F963->U+5317, \\\n"
-        "       U+F964->U+78FB, U+F965->U+4FBF, U+F966->U+5FA9, U+F967->U+4E0D, \\\n"
-        "       U+F968->U+6CCC, U+F969->U+6578, U+F96A->U+7D22, U+F96B->U+53C3, \\\n"
-        "       U+F96C->U+585E, U+F96D->U+7701, U+F96E->U+8449, U+F96F->U+8AAA, \\\n"
-        "       U+F970->U+6BBA, U+F971->U+8FB0, U+F972->U+6C88, U+F973->U+62FE, \\\n"
-        "       U+F974->U+82E5, U+F975->U+63A0, U+F976->U+7565, U+F977->U+4EAE, \\\n"
-        "       U+F978->U+5169, U+F979->U+51C9, U+F97A->U+6881, U+F97B->U+7CE7, \\\n"
-        "       U+F97C->U+826F, U+F97D->U+8AD2, U+F97E->U+91CF, U+F97F->U+52F5, \\\n"
-        "       U+F980->U+5442, U+F981->U+5973, U+F982->U+5EEC, U+F983->U+65C5, \\\n"
-        "       U+F984->U+6FFE, U+F985->U+792A, U+F986->U+95AD, U+F987->U+9A6A, \\\n"
-        "       U+F988->U+9E97, U+F989->U+9ECE, U+F98A->U+529B, U+F98B->U+66C6, \\\n"
-        "       U+F98C->U+6B77, U+F98D->U+8F62, U+F98E->U+5E74, U+F98F->U+6190, \\\n"
-        "       U+F990->U+6200, U+F991->U+649A, U+F992->U+6F23, U+F993->U+7149, \\\n"
-        "       U+F994->U+7489, U+F995->U+79CA, U+F996->U+7DF4, U+F997->U+806F, \\\n"
-        "       U+F998->U+8F26, U+F999->U+84EE, U+F99A->U+9023, U+F99B->U+934A, \\\n"
-        "       U+F99C->U+5217, U+F99D->U+52A3, U+F99E->U+54BD, U+F99F->U+70C8, \\\n"
-        "       U+F9A0->U+88C2, U+F9A1->U+8AAA, U+F9A2->U+5EC9, U+F9A3->U+5FF5, \\\n"
-        "       U+F9A4->U+637B, U+F9A5->U+6BAE, U+F9A6->U+7C3E, U+F9A7->U+7375, \\\n"
-        "       U+F9A8->U+4EE4, U+F9A9->U+56F9, U+F9AA->U+5BE7, U+F9AB->U+5DBA, \\\n"
-        "       U+F9AC->U+601C, U+F9AD->U+73B2, U+F9AE->U+7469, U+F9AF->U+7F9A, \\\n"
-        "       U+F9B0->U+8046, U+F9B1->U+9234, U+F9B2->U+96F6, U+F9B3->U+9748, \\\n"
-        "       U+F9B4->U+9818, U+F9B5->U+4F8B, U+F9B6->U+79AE, U+F9B7->U+91B4, \\\n"
-        "       U+F9B8->U+96B8, U+F9B9->U+60E1, U+F9BA->U+4E86, U+F9BB->U+50DA, \\\n"
-        "       U+F9BC->U+5BEE, U+F9BD->U+5C3F, U+F9BE->U+6599, U+F9BF->U+6A02, \\\n"
-        "       U+F9C0->U+71CE, U+F9C1->U+7642, U+F9C2->U+84FC, U+F9C3->U+907C, \\\n"
-        "       U+F9C4->U+9F8D, U+F9C5->U+6688, U+F9C6->U+962E, U+F9C7->U+5289, \\\n"
-        "       U+F9C8->U+677B, U+F9C9->U+67F3, U+F9CA->U+6D41, U+F9CB->U+6E9C, \\\n"
-        "       U+F9CC->U+7409, U+F9CD->U+7559, U+F9CE->U+786B, U+F9CF->U+7D10, \\\n"
-        "       U+F9D0->U+985E, U+F9D1->U+516D, U+F9D2->U+622E, U+F9D3->U+9678, \\\n"
-        "       U+F9D4->U+502B, U+F9D5->U+5D19, U+F9D6->U+6DEA, U+F9D7->U+8F2A, \\\n"
-        "       U+F9D8->U+5F8B, U+F9D9->U+6144, U+F9DA->U+6817, U+F9DB->U+7387, \\\n"
-        "       U+F9DC->U+9686, U+F9DD->U+5229, U+F9DE->U+540F, U+F9DF->U+5C65, \\\n"
-        "       U+F9E0->U+6613, U+F9E1->U+674E, U+F9E2->U+68A8, U+F9E3->U+6CE5, \\\n"
-        "       U+F9E4->U+7406, U+F9E5->U+75E2, U+F9E6->U+7F79, U+F9E7->U+88CF, \\\n"
-        "       U+F9E8->U+88E1, U+F9E9->U+91CC, U+F9EA->U+96E2, U+F9EB->U+533F, \\\n"
-        "       U+F9EC->U+6EBA, U+F9ED->U+541D, U+F9EE->U+71D0, U+F9EF->U+7498, \\\n"
-        "       U+F9F0->U+85FA, U+F9F1->U+96A3, U+F9F2->U+9C57, U+F9F3->U+9E9F, \\\n"
-        "       U+F9F4->U+6797, U+F9F5->U+6DCB, U+F9F6->U+81E8, U+F9F7->U+7ACB, \\\n"
-        "       U+F9F8->U+7B20, U+F9F9->U+7C92, U+F9FA->U+72C0, U+F9FB->U+7099, \\\n"
-        "       U+F9FC->U+8B58, U+F9FD->U+4EC0, U+F9FE->U+8336, U+F9FF->U+523A, \\\n"
-        "       U+FA00->U+5207, U+FA01->U+5EA6, U+FA02->U+62D3, U+FA03->U+7CD6, \\\n"
-        "       U+FA04->U+5B85, U+FA05->U+6D1E, U+FA06->U+66B4, U+FA07->U+8F3B, \\\n"
-        "       U+FA08->U+884C, U+FA09->U+964D, U+FA0A->U+898B, U+FA0B->U+5ED3, \\\n"
-        "       U+FA0C->U+5140, U+FA0D->U+55C0, U+FA10->U+585A, U+FA12->U+6674, \\\n"
-        "       U+FA15->U+51DE, U+FA16->U+732A, U+FA17->U+76CA, U+FA18->U+793C, \\\n"
-        "       U+FA19->U+795E, U+FA1A->U+7965, U+FA1B->U+798F, U+FA1C->U+9756, \\\n"
-        "       U+FA1D->U+7CBE, U+FA1E->U+7FBD, U+FA20->U+8612, U+FA22->U+8AF8, \\\n"
-        "       U+FA25->U+9038, U+FA26->U+90FD, U+FA2A->U+98EF, U+FA2B->U+98FC, \\\n"
-        "       U+FA2C->U+9928, U+FA2D->U+9DB4, U+FA30->U+4FAE, U+FA31->U+50E7, \\\n"
-        "       U+FA32->U+514D, U+FA33->U+52C9, U+FA34->U+52E4, U+FA35->U+5351, \\\n"
-        "       U+FA36->U+559D, U+FA37->U+5606, U+FA38->U+5668, U+FA39->U+5840, \\\n"
-        "       U+FA3A->U+58A8, U+FA3B->U+5C64, U+FA3C->U+5C6E, U+FA3D->U+6094, \\\n"
-        "       U+FA3E->U+6168, U+FA3F->U+618E, U+FA40->U+61F2, U+FA41->U+654F, \\\n"
-        "       U+FA42->U+65E2, U+FA43->U+6691, U+FA44->U+6885, U+FA45->U+6D77, \\\n"
-        "       U+FA46->U+6E1A, U+FA47->U+6F22, U+FA48->U+716E, U+FA49->U+722B, \\\n"
-        "       U+FA4A->U+7422, U+FA4B->U+7891, U+FA4C->U+793E, U+FA4D->U+7949, \\\n"
-        "       U+FA4E->U+7948, U+FA4F->U+7950, U+FA50->U+7956, U+FA51->U+795D, \\\n"
-        "       U+FA52->U+798D, U+FA53->U+798E, U+FA54->U+7A40, U+FA55->U+7A81, \\\n"
-        "       U+FA56->U+7BC0, U+FA57->U+7DF4, U+FA58->U+7E09, U+FA59->U+7E41, \\\n"
-        "       U+FA5A->U+7F72, U+FA5B->U+8005, U+FA5C->U+81ED, U+FA5D->U+8279, \\\n"
-        "       U+FA5E->U+8279, U+FA5F->U+8457, U+FA60->U+8910, U+FA61->U+8996, \\\n"
-        "       U+FA62->U+8B01, U+FA63->U+8B39, U+FA64->U+8CD3, U+FA65->U+8D08, \\\n"
-        "       U+FA66->U+8FB6, U+FA67->U+9038, U+FA68->U+96E3, U+FA69->U+97FF, \\\n"
-        "       U+FA6A->U+983B, U+FA70->U+4E26, U+FA71->U+51B5, U+FA72->U+5168, \\\n"
-        "       U+FA73->U+4F80, U+FA74->U+5145, U+FA75->U+5180, U+FA76->U+52C7, \\\n"
-        "       U+FA77->U+52FA, U+FA78->U+559D, U+FA79->U+5555, U+FA7A->U+5599, \\\n"
-        "       U+FA7B->U+55E2, U+FA7C->U+585A, U+FA7D->U+58B3, U+FA7E->U+5944, \\\n"
-        "       U+FA7F->U+5954, U+FA80->U+5A62, U+FA81->U+5B28, U+FA82->U+5ED2, \\\n"
-        "       U+FA83->U+5ED9, U+FA84->U+5F69, U+FA85->U+5FAD, U+FA86->U+60D8, \\\n"
-        "       U+FA87->U+614E, U+FA88->U+6108, U+FA89->U+618E, U+FA8A->U+6160, \\\n"
-        "       U+FA8B->U+61F2, U+FA8C->U+6234, U+FA8D->U+63C4, U+FA8E->U+641C, \\\n"
-        "       U+FA8F->U+6452, U+FA90->U+6556, U+FA91->U+6674, U+FA92->U+6717, \\\n"
-        "       U+FA93->U+671B, U+FA94->U+6756, U+FA95->U+6B79, U+FA96->U+6BBA, \\\n"
-        "       U+FA97->U+6D41, U+FA98->U+6EDB, U+FA99->U+6ECB, U+FA9A->U+6F22, \\\n"
-        "       U+FA9B->U+701E, U+FA9C->U+716E, U+FA9D->U+77A7, U+FA9E->U+7235, \\\n"
-        "       U+FA9F->U+72AF, U+FAA0->U+732A, U+FAA1->U+7471, U+FAA2->U+7506, \\\n"
-        "       U+FAA3->U+753B, U+FAA4->U+761D, U+FAA5->U+761F, U+FAA6->U+76CA, \\\n"
-        "       U+FAA7->U+76DB, U+FAA8->U+76F4, U+FAA9->U+774A, U+FAAA->U+7740, \\\n"
-        "       U+FAAB->U+78CC, U+FAAC->U+7AB1, U+FAAD->U+7BC0, U+FAAE->U+7C7B, \\\n"
-        "       U+FAAF->U+7D5B, U+FAB0->U+7DF4, U+FAB1->U+7F3E, U+FAB2->U+8005, \\\n"
-        "       U+FAB3->U+8352, U+FAB4->U+83EF, U+FAB5->U+8779, U+FAB6->U+8941, \\\n"
-        "       U+FAB7->U+8986, U+FAB8->U+8996, U+FAB9->U+8ABF, U+FABA->U+8AF8, \\\n"
-        "       U+FABB->U+8ACB, U+FABC->U+8B01, U+FABD->U+8AFE, U+FABE->U+8AED, \\\n"
-        "       U+FABF->U+8B39, U+FAC0->U+8B8A, U+FAC1->U+8D08, U+FAC2->U+8F38, \\\n"
-        "       U+FAC3->U+9072, U+FAC4->U+9199, U+FAC5->U+9276, U+FAC6->U+967C, \\\n"
-        "       U+FAC7->U+96E3, U+FAC8->U+9756, U+FAC9->U+97DB, U+FACA->U+97FF, \\\n"
-        "       U+FACB->U+980B, U+FACC->U+983B, U+FACD->U+9B12, U+FACE->U+9F9C, \\\n"
-        "       U+FACF->U+2284A, U+FAD0->U+22844, U+FAD1->U+233D5, U+FAD2->U+3B9D, \\\n"
-        "       U+FAD3->U+4018, U+FAD4->U+4039, U+FAD5->U+25249, U+FAD6->U+25CD0, \\\n"
-        "       U+FAD7->U+27ED3, U+FAD8->U+9F43, U+FAD9->U+9F8E, U+2F800->U+4E3D, \\\n"
-        "       U+2F801->U+4E38, U+2F802->U+4E41, U+2F803->U+20122, U+2F804->U+4F60, \\\n"
-        "       U+2F805->U+4FAE, U+2F806->U+4FBB, U+2F807->U+5002, U+2F808->U+507A, \\\n"
-        "       U+2F809->U+5099, U+2F80A->U+50E7, U+2F80B->U+50CF, U+2F80C->U+349E, \\\n"
-        "       U+2F80D->U+2063A, U+2F80E->U+514D, U+2F80F->U+5154, U+2F810->U+5164, \\\n"
-        "       U+2F811->U+5177, U+2F812->U+2051C, U+2F813->U+34B9, U+2F814->U+5167, \\\n"
-        "       U+2F815->U+518D, U+2F816->U+2054B, U+2F817->U+5197, U+2F818->U+51A4, \\\n"
-        "       U+2F819->U+4ECC, U+2F81A->U+51AC, U+2F81B->U+51B5, U+2F81C->U+291DF, \\\n"
-        "       U+2F81D->U+51F5, U+2F81E->U+5203, U+2F81F->U+34DF, U+2F820->U+523B, \\\n"
-        "       U+2F821->U+5246, U+2F822->U+5272, U+2F823->U+5277, U+2F824->U+3515, \\\n"
-        "       U+2F825->U+52C7, U+2F826->U+52C9, U+2F827->U+52E4, U+2F828->U+52FA, \\\n"
-        "       U+2F829->U+5305, U+2F82A->U+5306, U+2F82B->U+5317, U+2F82C->U+5349, \\\n"
-        "       U+2F82D->U+5351, U+2F82E->U+535A, U+2F82F->U+5373, U+2F830->U+537D, \\\n"
-        "       U+2F831->U+537F, U+2F832->U+537F, U+2F833->U+537F, U+2F834->U+20A2C, \\\n"
-        "       U+2F835->U+7070, U+2F836->U+53CA, U+2F837->U+53DF, U+2F838->U+20B63, \\\n"
-        "       U+2F839->U+53EB, U+2F83A->U+53F1, U+2F83B->U+5406, U+2F83C->U+549E, \\\n"
-        "       U+2F83D->U+5438, U+2F83E->U+5448, U+2F83F->U+5468, U+2F840->U+54A2, \\\n"
-        "       U+2F841->U+54F6, U+2F842->U+5510, U+2F843->U+5553, U+2F844->U+5563, \\\n"
-        "       U+2F845->U+5584, U+2F846->U+5584, U+2F847->U+5599, U+2F848->U+55AB, \\\n"
-        "       U+2F849->U+55B3, U+2F84A->U+55C2, U+2F84B->U+5716, U+2F84C->U+5606, \\\n"
-        "       U+2F84D->U+5717, U+2F84E->U+5651, U+2F84F->U+5674, U+2F850->U+5207, \\\n"
-        "       U+2F851->U+58EE, U+2F852->U+57CE, U+2F853->U+57F4, U+2F854->U+580D, \\\n"
-        "       U+2F855->U+578B, U+2F856->U+5832, U+2F857->U+5831, U+2F858->U+58AC, \\\n"
-        "       U+2F859->U+214E4, U+2F85A->U+58F2, U+2F85B->U+58F7, U+2F85C->U+5906, \\\n"
-        "       U+2F85D->U+591A, U+2F85E->U+5922, U+2F85F->U+5962, U+2F860->U+216A8, \\\n"
-        "       U+2F861->U+216EA, U+2F862->U+59EC, U+2F863->U+5A1B, U+2F864->U+5A27, \\\n"
-        "       U+2F865->U+59D8, U+2F866->U+5A66, U+2F867->U+36EE, U+2F868->U+36FC, \\\n"
-        "       U+2F869->U+5B08, U+2F86A->U+5B3E, U+2F86B->U+5B3E, U+2F86C->U+219C8, \\\n"
-        "       U+2F86D->U+5BC3, U+2F86E->U+5BD8, U+2F86F->U+5BE7, U+2F870->U+5BF3, \\\n"
-        "       U+2F871->U+21B18, U+2F872->U+5BFF, U+2F873->U+5C06, U+2F874->U+5F53, \\\n"
-        "       U+2F875->U+5C22, U+2F876->U+3781, U+2F877->U+5C60, U+2F878->U+5C6E, \\\n"
-        "       U+2F879->U+5CC0, U+2F87A->U+5C8D, U+2F87B->U+21DE4, U+2F87C->U+5D43, \\\n"
-        "       U+2F87D->U+21DE6, U+2F87E->U+5D6E, U+2F87F->U+5D6B, U+2F880->U+5D7C, \\\n"
-        "       U+2F881->U+5DE1, U+2F882->U+5DE2, U+2F883->U+382F, U+2F884->U+5DFD, \\\n"
-        "       U+2F885->U+5E28, U+2F886->U+5E3D, U+2F887->U+5E69, U+2F888->U+3862, \\\n"
-        "       U+2F889->U+22183, U+2F88A->U+387C, U+2F88B->U+5EB0, U+2F88C->U+5EB3, \\\n"
-        "       U+2F88D->U+5EB6, U+2F88E->U+5ECA, U+2F88F->U+2A392, U+2F890->U+5EFE, \\\n"
-        "       U+2F891->U+22331, U+2F892->U+22331, U+2F893->U+8201, U+2F894->U+5F22, \\\n"
-        "       U+2F895->U+5F22, U+2F896->U+38C7, U+2F897->U+232B8, U+2F898->U+261DA, \\\n"
-        "       U+2F899->U+5F62, U+2F89A->U+5F6B, U+2F89B->U+38E3, U+2F89C->U+5F9A, \\\n"
-        "       U+2F89D->U+5FCD, U+2F89E->U+5FD7, U+2F89F->U+5FF9, U+2F8A0->U+6081, \\\n"
-        "       U+2F8A1->U+393A, U+2F8A2->U+391C, U+2F8A3->U+6094, U+2F8A4->U+226D4, \\\n"
-        "       U+2F8A5->U+60C7, U+2F8A6->U+6148, U+2F8A7->U+614C, U+2F8A8->U+614E, \\\n"
-        "       U+2F8A9->U+614C, U+2F8AA->U+617A, U+2F8AB->U+618E, U+2F8AC->U+61B2, \\\n"
-        "       U+2F8AD->U+61A4, U+2F8AE->U+61AF, U+2F8AF->U+61DE, U+2F8B0->U+61F2, \\\n"
-        "       U+2F8B1->U+61F6, U+2F8B2->U+6210, U+2F8B3->U+621B, U+2F8B4->U+625D, \\\n"
-        "       U+2F8B5->U+62B1, U+2F8B6->U+62D4, U+2F8B7->U+6350, U+2F8B8->U+22B0C, \\\n"
-        "       U+2F8B9->U+633D, U+2F8BA->U+62FC, U+2F8BB->U+6368, U+2F8BC->U+6383, \\\n"
-        "       U+2F8BD->U+63E4, U+2F8BE->U+22BF1, U+2F8BF->U+6422, U+2F8C0->U+63C5, \\\n"
-        "       U+2F8C1->U+63A9, U+2F8C2->U+3A2E, U+2F8C3->U+6469, U+2F8C4->U+647E, \\\n"
-        "       U+2F8C5->U+649D, U+2F8C6->U+6477, U+2F8C7->U+3A6C, U+2F8C8->U+654F, \\\n"
-        "       U+2F8C9->U+656C, U+2F8CA->U+2300A, U+2F8CB->U+65E3, U+2F8CC->U+66F8, \\\n"
-        "       U+2F8CD->U+6649, U+2F8CE->U+3B19, U+2F8CF->U+6691, U+2F8D0->U+3B08, \\\n"
-        "       U+2F8D1->U+3AE4, U+2F8D2->U+5192, U+2F8D3->U+5195, U+2F8D4->U+6700, \\\n"
-        "       U+2F8D5->U+669C, U+2F8D6->U+80AD, U+2F8D7->U+43D9, U+2F8D8->U+6717, \\\n"
-        "       U+2F8D9->U+671B, U+2F8DA->U+6721, U+2F8DB->U+675E, U+2F8DC->U+6753, \\\n"
-        "       U+2F8DD->U+233C3, U+2F8DE->U+3B49, U+2F8DF->U+67FA, U+2F8E0->U+6785, \\\n"
-        "       U+2F8E1->U+6852, U+2F8E2->U+6885, U+2F8E3->U+2346D, U+2F8E4->U+688E, \\\n"
-        "       U+2F8E5->U+681F, U+2F8E6->U+6914, U+2F8E7->U+3B9D, U+2F8E8->U+6942, \\\n"
-        "       U+2F8E9->U+69A3, U+2F8EA->U+69EA, U+2F8EB->U+6AA8, U+2F8EC->U+236A3, \\\n"
-        "       U+2F8ED->U+6ADB, U+2F8EE->U+3C18, U+2F8EF->U+6B21, U+2F8F0->U+238A7, \\\n"
-        "       U+2F8F1->U+6B54, U+2F8F2->U+3C4E, U+2F8F3->U+6B72, U+2F8F4->U+6B9F, \\\n"
-        "       U+2F8F5->U+6BBA, U+2F8F6->U+6BBB, U+2F8F7->U+23A8D, U+2F8F8->U+21D0B, \\\n"
-        "       U+2F8F9->U+23AFA, U+2F8FA->U+6C4E, U+2F8FB->U+23CBC, U+2F8FC->U+6CBF, \\\n"
-        "       U+2F8FD->U+6CCD, U+2F8FE->U+6C67, U+2F8FF->U+6D16, U+2F900->U+6D3E, \\\n"
-        "       U+2F901->U+6D77, U+2F902->U+6D41, U+2F903->U+6D69, U+2F904->U+6D78, \\\n"
-        "       U+2F905->U+6D85, U+2F906->U+23D1E, U+2F907->U+6D34, U+2F908->U+6E2F, \\\n"
-        "       U+2F909->U+6E6E, U+2F90A->U+3D33, U+2F90B->U+6ECB, U+2F90C->U+6EC7, \\\n"
-        "       U+2F90D->U+23ED1, U+2F90E->U+6DF9, U+2F90F->U+6F6E, U+2F910->U+23F5E, \\\n"
-        "       U+2F911->U+23F8E, U+2F912->U+6FC6, U+2F913->U+7039, U+2F914->U+701E, \\\n"
-        "       U+2F915->U+701B, U+2F916->U+3D96, U+2F917->U+704A, U+2F918->U+707D, \\\n"
-        "       U+2F919->U+7077, U+2F91A->U+70AD, U+2F91B->U+20525, U+2F91C->U+7145, \\\n"
-        "       U+2F91D->U+24263, U+2F91E->U+719C, U+2F91F->U+243AB, U+2F920->U+7228, \\\n"
-        "       U+2F921->U+7235, U+2F922->U+7250, U+2F923->U+24608, U+2F924->U+7280, \\\n"
-        "       U+2F925->U+7295, U+2F926->U+24735, U+2F927->U+24814, U+2F928->U+737A, \\\n"
-        "       U+2F929->U+738B, U+2F92A->U+3EAC, U+2F92B->U+73A5, U+2F92C->U+3EB8, \\\n"
-        "       U+2F92D->U+3EB8, U+2F92E->U+7447, U+2F92F->U+745C, U+2F930->U+7471, \\\n"
-        "       U+2F931->U+7485, U+2F932->U+74CA, U+2F933->U+3F1B, U+2F934->U+7524, \\\n"
-        "       U+2F935->U+24C36, U+2F936->U+753E, U+2F937->U+24C92, U+2F938->U+7570, \\\n"
-        "       U+2F939->U+2219F, U+2F93A->U+7610, U+2F93B->U+24FA1, U+2F93C->U+24FB8, \\\n"
-        "       U+2F93D->U+25044, U+2F93E->U+3FFC, U+2F93F->U+4008, U+2F940->U+76F4, \\\n"
-        "       U+2F941->U+250F3, U+2F942->U+250F2, U+2F943->U+25119, U+2F944->U+25133, \\\n"
-        "       U+2F945->U+771E, U+2F946->U+771F, U+2F947->U+771F, U+2F948->U+774A, \\\n"
-        "       U+2F949->U+4039, U+2F94A->U+778B, U+2F94B->U+4046, U+2F94C->U+4096, \\\n"
-        "       U+2F94D->U+2541D, U+2F94E->U+784E, U+2F94F->U+788C, U+2F950->U+78CC, \\\n"
-        "       U+2F951->U+40E3, U+2F952->U+25626, U+2F953->U+7956, U+2F954->U+2569A, \\\n"
-        "       U+2F955->U+256C5, U+2F956->U+798F, U+2F957->U+79EB, U+2F958->U+412F, \\\n"
-        "       U+2F959->U+7A40, U+2F95A->U+7A4A, U+2F95B->U+7A4F, U+2F95C->U+2597C, \\\n"
-        "       U+2F95D->U+25AA7, U+2F95E->U+25AA7, U+2F95F->U+7AEE, U+2F960->U+4202, \\\n"
-        "       U+2F961->U+25BAB, U+2F962->U+7BC6, U+2F963->U+7BC9, U+2F964->U+4227, \\\n"
-        "       U+2F965->U+25C80, U+2F966->U+7CD2, U+2F967->U+42A0, U+2F968->U+7CE8, \\\n"
-        "       U+2F969->U+7CE3, U+2F96A->U+7D00, U+2F96B->U+25F86, U+2F96C->U+7D63, \\\n"
-        "       U+2F96D->U+4301, U+2F96E->U+7DC7, U+2F96F->U+7E02, U+2F970->U+7E45, \\\n"
-        "       U+2F971->U+4334, U+2F972->U+26228, U+2F973->U+26247, U+2F974->U+4359, \\\n"
-        "       U+2F975->U+262D9, U+2F976->U+7F7A, U+2F977->U+2633E, U+2F978->U+7F95, \\\n"
-        "       U+2F979->U+7FFA, U+2F97A->U+8005, U+2F97B->U+264DA, U+2F97C->U+26523, \\\n"
-        "       U+2F97D->U+8060, U+2F97E->U+265A8, U+2F97F->U+8070, U+2F980->U+2335F, \\\n"
-        "       U+2F981->U+43D5, U+2F982->U+80B2, U+2F983->U+8103, U+2F984->U+440B, \\\n"
-        "       U+2F985->U+813E, U+2F986->U+5AB5, U+2F987->U+267A7, U+2F988->U+267B5, \\\n"
-        "       U+2F989->U+23393, U+2F98A->U+2339C, U+2F98B->U+8201, U+2F98C->U+8204, \\\n"
-        "       U+2F98D->U+8F9E, U+2F98E->U+446B, U+2F98F->U+8291, U+2F990->U+828B, \\\n"
-        "       U+2F991->U+829D, U+2F992->U+52B3, U+2F993->U+82B1, U+2F994->U+82B3, \\\n"
-        "       U+2F995->U+82BD, U+2F996->U+82E6, U+2F997->U+26B3C, U+2F998->U+82E5, \\\n"
-        "       U+2F999->U+831D, U+2F99A->U+8363, U+2F99B->U+83AD, U+2F99C->U+8323, \\\n"
-        "       U+2F99D->U+83BD, U+2F99E->U+83E7, U+2F99F->U+8457, U+2F9A0->U+8353, \\\n"
-        "       U+2F9A1->U+83CA, U+2F9A2->U+83CC, U+2F9A3->U+83DC, U+2F9A4->U+26C36, \\\n"
-        "       U+2F9A5->U+26D6B, U+2F9A6->U+26CD5, U+2F9A7->U+452B, U+2F9A8->U+84F1, \\\n"
-        "       U+2F9A9->U+84F3, U+2F9AA->U+8516, U+2F9AB->U+273CA, U+2F9AC->U+8564, \\\n"
-        "       U+2F9AD->U+26F2C, U+2F9AE->U+455D, U+2F9AF->U+4561, U+2F9B0->U+26FB1, \\\n"
-        "       U+2F9B1->U+270D2, U+2F9B2->U+456B, U+2F9B3->U+8650, U+2F9B4->U+865C, \\\n"
-        "       U+2F9B5->U+8667, U+2F9B6->U+8669, U+2F9B7->U+86A9, U+2F9B8->U+8688, \\\n"
-        "       U+2F9B9->U+870E, U+2F9BA->U+86E2, U+2F9BB->U+8779, U+2F9BC->U+8728, \\\n"
-        "       U+2F9BD->U+876B, U+2F9BE->U+8786, U+2F9BF->U+45D7, U+2F9C0->U+87E1, \\\n"
-        "       U+2F9C1->U+8801, U+2F9C2->U+45F9, U+2F9C3->U+8860, U+2F9C4->U+8863, \\\n"
-        "       U+2F9C5->U+27667, U+2F9C6->U+88D7, U+2F9C7->U+88DE, U+2F9C8->U+4635, \\\n"
-        "       U+2F9C9->U+88FA, U+2F9CA->U+34BB, U+2F9CB->U+278AE, U+2F9CC->U+27966, \\\n"
-        "       U+2F9CD->U+46BE, U+2F9CE->U+46C7, U+2F9CF->U+8AA0, U+2F9D0->U+8AED, \\\n"
-        "       U+2F9D1->U+8B8A, U+2F9D2->U+8C55, U+2F9D3->U+27CA8, U+2F9D4->U+8CAB, \\\n"
-        "       U+2F9D5->U+8CC1, U+2F9D6->U+8D1B, U+2F9D7->U+8D77, U+2F9D8->U+27F2F, \\\n"
-        "       U+2F9D9->U+20804, U+2F9DA->U+8DCB, U+2F9DB->U+8DBC, U+2F9DC->U+8DF0, \\\n"
-        "       U+2F9DD->U+208DE, U+2F9DE->U+8ED4, U+2F9DF->U+8F38, U+2F9E0->U+285D2, \\\n"
-        "       U+2F9E1->U+285ED, U+2F9E2->U+9094, U+2F9E3->U+90F1, U+2F9E4->U+9111, \\\n"
-        "       U+2F9E5->U+2872E, U+2F9E6->U+911B, U+2F9E7->U+9238, U+2F9E8->U+92D7, \\\n"
-        "       U+2F9E9->U+92D8, U+2F9EA->U+927C, U+2F9EB->U+93F9, U+2F9EC->U+9415, \\\n"
-        "       U+2F9ED->U+28BFA, U+2F9EE->U+958B, U+2F9EF->U+4995, U+2F9F0->U+95B7, \\\n"
-        "       U+2F9F1->U+28D77, U+2F9F2->U+49E6, U+2F9F3->U+96C3, U+2F9F4->U+5DB2, \\\n"
-        "       U+2F9F5->U+9723, U+2F9F6->U+29145, U+2F9F7->U+2921A, U+2F9F8->U+4A6E, \\\n"
-        "       U+2F9F9->U+4A76, U+2F9FA->U+97E0, U+2F9FB->U+2940A, U+2F9FC->U+4AB2, \\\n"
-        "       U+2F9FD->U+29496, U+2F9FE->U+980B, U+2F9FF->U+980B, U+2FA00->U+9829, \\\n"
-        "       U+2FA01->U+295B6, U+2FA02->U+98E2, U+2FA03->U+4B33, U+2FA04->U+9929, \\\n"
-        "       U+2FA05->U+99A7, U+2FA06->U+99C2, U+2FA07->U+99FE, U+2FA08->U+4BCE, \\\n"
-        "       U+2FA09->U+29B30, U+2FA0A->U+9B12, U+2FA0B->U+9C40, U+2FA0C->U+9CFD, \\\n"
-        "       U+2FA0D->U+4CCE, U+2FA0E->U+4CED, U+2FA0F->U+9D67, U+2FA10->U+2A0CE, \\\n"
-        "       U+2FA11->U+4CF8, U+2FA12->U+2A105, U+2FA13->U+2A20E, U+2FA14->U+2A291, \\\n"
-        "       U+2FA15->U+9EBB, U+2FA16->U+4D56, U+2FA17->U+9EF9, U+2FA18->U+9EFE, \\\n"
-        "       U+2FA19->U+9F05, U+2FA1A->U+9F0F, U+2FA1B->U+9F16, U+2FA1C->U+9F3B, \\\n"
-        "       U+2FA1D->U+2A600, U+2F00->U+4E00, U+2F01->U+4E28, U+2F02->U+4E36, \\\n"
-        "       U+2F03->U+4E3F, U+2F04->U+4E59, U+2F05->U+4E85, U+2F06->U+4E8C, \\\n"
-        "       U+2F07->U+4EA0, U+2F08->U+4EBA, U+2F09->U+513F, U+2F0A->U+5165, \\\n"
-        "       U+2F0B->U+516B, U+2F0C->U+5182, U+2F0D->U+5196, U+2F0E->U+51AB, \\\n"
-        "       U+2F0F->U+51E0, U+2F10->U+51F5, U+2F11->U+5200, U+2F12->U+529B, \\\n"
-        "       U+2F13->U+52F9, U+2F14->U+5315, U+2F15->U+531A, U+2F16->U+5338, \\\n"
-        "       U+2F17->U+5341, U+2F18->U+535C, U+2F19->U+5369, U+2F1A->U+5382, \\\n"
-        "       U+2F1B->U+53B6, U+2F1C->U+53C8, U+2F1D->U+53E3, U+2F1E->U+56D7, \\\n"
-        "       U+2F1F->U+571F, U+2F20->U+58EB, U+2F21->U+5902, U+2F22->U+590A, \\\n"
-        "       U+2F23->U+5915, U+2F24->U+5927, U+2F25->U+5973, U+2F26->U+5B50, \\\n"
-        "       U+2F27->U+5B80, U+2F28->U+5BF8, U+2F29->U+5C0F, U+2F2A->U+5C22, \\\n"
-        "       U+2F2B->U+5C38, U+2F2C->U+5C6E, U+2F2D->U+5C71, U+2F2E->U+5DDB, \\\n"
-        "       U+2F2F->U+5DE5, U+2F30->U+5DF1, U+2F31->U+5DFE, U+2F32->U+5E72, \\\n"
-        "       U+2F33->U+5E7A, U+2F34->U+5E7F, U+2F35->U+5EF4, U+2F36->U+5EFE, \\\n"
-        "       U+2F37->U+5F0B, U+2F38->U+5F13, U+2F39->U+5F50, U+2F3A->U+5F61, \\\n"
-        "       U+2F3B->U+5F73, U+2F3C->U+5FC3, U+2F3D->U+6208, U+2F3E->U+6236, \\\n"
-        "       U+2F3F->U+624B, U+2F40->U+652F, U+2F41->U+6534, U+2F42->U+6587, \\\n"
-        "       U+2F43->U+6597, U+2F44->U+65A4, U+2F45->U+65B9, U+2F46->U+65E0, \\\n"
-        "       U+2F47->U+65E5, U+2F48->U+66F0, U+2F49->U+6708, U+2F4A->U+6728, \\\n"
-        "       U+2F4B->U+6B20, U+2F4C->U+6B62, U+2F4D->U+6B79, U+2F4E->U+6BB3, \\\n"
-        "       U+2F4F->U+6BCB, U+2F50->U+6BD4, U+2F51->U+6BDB, U+2F52->U+6C0F, \\\n"
-        "       U+2F53->U+6C14, U+2F54->U+6C34, U+2F55->U+706B, U+2F56->U+722A, \\\n"
-        "       U+2F57->U+7236, U+2F58->U+723B, U+2F59->U+723F, U+2F5A->U+7247, \\\n"
-        "       U+2F5B->U+7259, U+2F5C->U+725B, U+2F5D->U+72AC, U+2F5E->U+7384, \\\n"
-        "       U+2F5F->U+7389, U+2F60->U+74DC, U+2F61->U+74E6, U+2F62->U+7518, \\\n"
-        "       U+2F63->U+751F, U+2F64->U+7528, U+2F65->U+7530, U+2F66->U+758B, \\\n"
-        "       U+2F67->U+7592, U+2F68->U+7676, U+2F69->U+767D, U+2F6A->U+76AE, \\\n"
-        "       U+2F6B->U+76BF, U+2F6C->U+76EE, U+2F6D->U+77DB, U+2F6E->U+77E2, \\\n"
-        "       U+2F6F->U+77F3, U+2F70->U+793A, U+2F71->U+79B8, U+2F72->U+79BE, \\\n"
-        "       U+2F73->U+7A74, U+2F74->U+7ACB, U+2F75->U+7AF9, U+2F76->U+7C73, \\\n"
-        "       U+2F77->U+7CF8, U+2F78->U+7F36, U+2F79->U+7F51, U+2F7A->U+7F8A, \\\n"
-        "       U+2F7B->U+7FBD, U+2F7C->U+8001, U+2F7D->U+800C, U+2F7E->U+8012, \\\n"
-        "       U+2F7F->U+8033, U+2F80->U+807F, U+2F81->U+8089, U+2F82->U+81E3, \\\n"
-        "       U+2F83->U+81EA, U+2F84->U+81F3, U+2F85->U+81FC, U+2F86->U+820C, \\\n"
-        "       U+2F87->U+821B, U+2F88->U+821F, U+2F89->U+826E, U+2F8A->U+8272, \\\n"
-        "       U+2F8B->U+8278, U+2F8C->U+864D, U+2F8D->U+866B, U+2F8E->U+8840, \\\n"
-        "       U+2F8F->U+884C, U+2F90->U+8863, U+2F91->U+897E, U+2F92->U+898B, \\\n"
-        "       U+2F93->U+89D2, U+2F94->U+8A00, U+2F95->U+8C37, U+2F96->U+8C46, \\\n"
-        "       U+2F97->U+8C55, U+2F98->U+8C78, U+2F99->U+8C9D, U+2F9A->U+8D64, \\\n"
-        "       U+2F9B->U+8D70, U+2F9C->U+8DB3, U+2F9D->U+8EAB, U+2F9E->U+8ECA, \\\n"
-        "       U+2F9F->U+8F9B, U+2FA0->U+8FB0, U+2FA1->U+8FB5, U+2FA2->U+9091, \\\n"
-        "       U+2FA3->U+9149, U+2FA4->U+91C6, U+2FA5->U+91CC, U+2FA6->U+91D1, \\\n"
-        "       U+2FA7->U+9577, U+2FA8->U+9580, U+2FA9->U+961C, U+2FAA->U+96B6, \\\n"
-        "       U+2FAB->U+96B9, U+2FAC->U+96E8, U+2FAD->U+9751, U+2FAE->U+975E, \\\n"
-        "       U+2FAF->U+9762, U+2FB0->U+9769, U+2FB1->U+97CB, U+2FB2->U+97ED, \\\n"
-        "       U+2FB3->U+97F3, U+2FB4->U+9801, U+2FB5->U+98A8, U+2FB6->U+98DB, \\\n"
-        "       U+2FB7->U+98DF, U+2FB8->U+9996, U+2FB9->U+9999, U+2FBA->U+99AC, \\\n"
-        "       U+2FBB->U+9AA8, U+2FBC->U+9AD8, U+2FBD->U+9ADF, U+2FBE->U+9B25, \\\n"
-        "       U+2FBF->U+9B2F, U+2FC0->U+9B32, U+2FC1->U+9B3C, U+2FC2->U+9B5A, \\\n"
-        "       U+2FC3->U+9CE5, U+2FC4->U+9E75, U+2FC5->U+9E7F, U+2FC6->U+9EA5, \\\n"
-        "       U+2FC7->U+9EBB, U+2FC8->U+9EC3, U+2FC9->U+9ECD, U+2FCA->U+9ED1, \\\n"
-        "       U+2FCB->U+9EF9, U+2FCC->U+9EFD, U+2FCD->U+9F0E, U+2FCE->U+9F13, \\\n"
-        "       U+2FCF->U+9F20, U+2FD0->U+9F3B, U+2FD1->U+9F4A, U+2FD2->U+9F52, \\\n"
-        "       U+2FD3->U+9F8D, U+2FD4->U+9F9C, U+2FD5->U+9FA0, U+3042->U+3041, \\\n"
-        "       U+3044->U+3043, U+3046->U+3045, U+3048->U+3047, U+304A->U+3049, \\\n"
-        "       U+304C->U+304B, U+304E->U+304D, U+3050->U+304F, U+3052->U+3051, \\\n"
-        "       U+3054->U+3053, U+3056->U+3055, U+3058->U+3057, U+305A->U+3059, \\\n"
-        "       U+305C->U+305B, U+305E->U+305D, U+3060->U+305F, U+3062->U+3061, \\\n"
-        "       U+3064->U+3063, U+3065->U+3063, U+3067->U+3066, U+3069->U+3068, \\\n"
-        "       U+3070->U+306F, U+3071->U+306F, U+3073->U+3072, U+3074->U+3072, \\\n"
-        "       U+3076->U+3075, U+3077->U+3075, U+3079->U+3078, U+307A->U+3078, \\\n"
-        "       U+307C->U+307B, U+307D->U+307B, U+3084->U+3083, U+3086->U+3085, \\\n"
-        "       U+3088->U+3087, U+308F->U+308E, U+3094->U+3046, U+3095->U+304B, \\\n"
-        "       U+3096->U+3051, U+30A2->U+30A1, U+30A4->U+30A3, U+30A6->U+30A5, \\\n"
-        "       U+30A8->U+30A7, U+30AA->U+30A9, U+30AC->U+30AB, U+30AE->U+30AD, \\\n"
-        "       U+30B0->U+30AF, U+30B2->U+30B1, U+30B4->U+30B3, U+30B6->U+30B5, \\\n"
-        "       U+30B8->U+30B7, U+30BA->U+30B9, U+30BC->U+30BB, U+30BE->U+30BD, \\\n"
-        "       U+30C0->U+30BF, U+30C2->U+30C1, U+30C5->U+30C4, U+30C7->U+30C6, \\\n"
-        "       U+30C9->U+30C8, U+30D0->U+30CF, U+30D1->U+30CF, U+30D3->U+30D2, \\\n"
-        "       U+30D4->U+30D2, U+30D6->U+30D5, U+30D7->U+30D5, U+30D9->U+30D8, \\\n"
-        "       U+30DA->U+30D8, U+30DC->U+30DB, U+30DD->U+30DB, U+30E4->U+30E3, \\\n"
-        "       U+30E6->U+30E5, U+30E8->U+30E7, U+30EF->U+30EE, U+30F4->U+30A6, \\\n"
-        "       U+30AB->U+30F5, U+30B1->U+30F6, U+30F7->U+30EF, U+30F8->U+30F0, \\\n"
-        "       U+30F9->U+30F1, U+30FA->U+30F2, U+30AF->U+31F0, U+30B7->U+31F1, \\\n"
-        "       U+30B9->U+31F2, U+30C8->U+31F3, U+30CC->U+31F4, U+30CF->U+31F5, \\\n"
-        "       U+30D2->U+31F6, U+30D5->U+31F7, U+30D8->U+31F8, U+30DB->U+31F9, \\\n"
-        "       U+30E0->U+31FA, U+30E9->U+31FB, U+30EA->U+31FC, U+30EB->U+31FD, \\\n"
-        "       U+30EC->U+31FE, U+30ED->U+31FF, U+FF66->U+30F2, U+FF67->U+30A1, \\\n"
-        "       U+FF68->U+30A3, U+FF69->U+30A5, U+FF6A->U+30A7, U+FF6B->U+30A9, \\\n"
-        "       U+FF6C->U+30E3, U+FF6D->U+30E5, U+FF6E->U+30E7, U+FF6F->U+30C3, \\\n"
-        "       U+FF71->U+30A1, U+FF72->U+30A3, U+FF73->U+30A5, U+FF74->U+30A7, \\\n"
-        "       U+FF75->U+30A9, U+FF76->U+30AB, U+FF77->U+30AD, U+FF78->U+30AF, \\\n"
-        "       U+FF79->U+30B1, U+FF7A->U+30B3, U+FF7B->U+30B5, U+FF7C->U+30B7, \\\n"
-        "       U+FF7D->U+30B9, U+FF7E->U+30BB, U+FF7F->U+30BD, U+FF80->U+30BF, \\\n"
-        "       U+FF81->U+30C1, U+FF82->U+30C3, U+FF83->U+30C6, U+FF84->U+30C8, \\\n"
-        "       U+FF85->U+30CA, U+FF86->U+30CB, U+FF87->U+30CC, U+FF88->U+30CD, \\\n"
-        "       U+FF89->U+30CE, U+FF8A->U+30CF, U+FF8B->U+30D2, U+FF8C->U+30D5, \\\n"
-        "       U+FF8D->U+30D8, U+FF8E->U+30DB, U+FF8F->U+30DE, U+FF90->U+30DF, \\\n"
-        "       U+FF91->U+30E0, U+FF92->U+30E1, U+FF93->U+30E2, U+FF94->U+30E3, \\\n"
-        "       U+FF95->U+30E5, U+FF96->U+30E7, U+FF97->U+30E9, U+FF98->U+30EA, \\\n"
-        "       U+FF99->U+30EB, U+FF9A->U+30EC, U+FF9B->U+30ED, U+FF9C->U+30EF, \\\n"
-        "       U+FF9D->U+30F3, U+FFA0->U+3164, U+FFA1->U+3131, U+FFA2->U+3132, \\\n"
-        "       U+FFA3->U+3133, U+FFA4->U+3134, U+FFA5->U+3135, U+FFA6->U+3136, \\\n"
-        "       U+FFA7->U+3137, U+FFA8->U+3138, U+FFA9->U+3139, U+FFAA->U+313A, \\\n"
-        "       U+FFAB->U+313B, U+FFAC->U+313C, U+FFAD->U+313D, U+FFAE->U+313E, \\\n"
-        "       U+FFAF->U+313F, U+FFB0->U+3140, U+FFB1->U+3141, U+FFB2->U+3142, \\\n"
-        "       U+FFB3->U+3143, U+FFB4->U+3144, U+FFB5->U+3145, U+FFB6->U+3146, \\\n"
-        "       U+FFB7->U+3147, U+FFB8->U+3148, U+FFB9->U+3149, U+FFBA->U+314A, \\\n"
-        "       U+FFBB->U+314B, U+FFBC->U+314C, U+FFBD->U+314D, U+FFBE->U+314E, \\\n"
-        "       U+FFC2->U+314F, U+FFC3->U+3150, U+FFC4->U+3151, U+FFC5->U+3152, \\\n"
-        "       U+FFC6->U+3153, U+FFC7->U+3154, U+FFCA->U+3155, U+FFCB->U+3156, \\\n"
-        "       U+FFCC->U+3157, U+FFCD->U+3158, U+FFCE->U+3159, U+FFCF->U+315A, \\\n"
-        "       U+FFD2->U+315B, U+FFD3->U+315C, U+FFD4->U+315D, U+FFD5->U+315E, \\\n"
-        "       U+FFD6->U+315F, U+FFD7->U+3160, U+FFDA->U+3161, U+FFDB->U+3162, \\\n"
-        "       U+FFDC->U+3163, U+3131->U+1100, U+3132->U+1101, U+3133->U+11AA, \\\n"
-        "       U+3134->U+1102, U+3135->U+11AC, U+3136->U+11AD, U+3137->U+1103, \\\n"
-        "       U+3138->U+1104, U+3139->U+1105, U+313A->U+11B0, U+313B->U+11B1, \\\n"
-        "       U+313C->U+11B2, U+313D->U+11B3, U+313E->U+11B4, U+313F->U+11B5, \\\n"
-        "       U+3140->U+111A, U+3141->U+1106, U+3142->U+1107, U+3143->U+1108, \\\n"
-        "       U+3144->U+1121, U+3145->U+1109, U+3146->U+110A, U+3147->U+110B, \\\n"
-        "       U+3148->U+110C, U+3149->U+110D, U+314A->U+110E, U+314B->U+110F, \\\n"
-        "       U+314C->U+1110, U+314D->U+1111, U+314E->U+1112, U+314F->U+1161, \\\n"
-        "       U+3150->U+1162, U+3151->U+1163, U+3152->U+1164, U+3153->U+1165, \\\n"
-        "       U+3154->U+1166, U+3155->U+1167, U+3156->U+1168, U+3157->U+1169, \\\n"
-        "       U+3158->U+116A, U+3159->U+116B, U+315A->U+116C, U+315B->U+116D, \\\n"
-        "       U+315C->U+116E, U+315D->U+116F, U+315E->U+1170, U+315F->U+1171, \\\n"
-        "       U+3160->U+1172, U+3161->U+1173, U+3162->U+1174, U+3163->U+1175, \\\n"
-        "       U+3165->U+1114, U+3166->U+1115, U+3167->U+11C7, U+3168->U+11C8, \\\n"
-        "       U+3169->U+11CC, U+316A->U+11CE, U+316B->U+11D3, U+316C->U+11D7, \\\n"
-        "       U+316D->U+11D9, U+316E->U+111C, U+316F->U+11DD, U+3170->U+11DF, \\\n"
-        "       U+3171->U+111D, U+3172->U+111E, U+3173->U+1120, U+3174->U+1122, \\\n"
-        "       U+3175->U+1123, U+3176->U+1127, U+3177->U+1129, U+3178->U+112B, \\\n"
-        "       U+3179->U+112C, U+317A->U+112D, U+317B->U+112E, U+317C->U+112F, \\\n"
-        "       U+317D->U+1132, U+317E->U+1136, U+317F->U+1140, U+3180->U+1147, \\\n"
-        "       U+3181->U+114C, U+3182->U+11F1, U+3183->U+11F2, U+3184->U+1157, \\\n"
-        "       U+3185->U+1158, U+3186->U+1159, U+3187->U+1184, U+3188->U+1185, \\\n"
-        "       U+3189->U+1188, U+318A->U+1191, U+318B->U+1192, U+318C->U+1194, \\\n"
-        "       U+318D->U+119E, U+318E->U+11A1, U+A490->U+A408, U+A491->U+A1B9, \\\n"
-        "       U+4E00..U+9FBB, U+3400..U+4DB5, U+20000..U+2A6D6, U+FA0E, U+FA0F, \\\n"
-        "       U+FA11, U+FA13, U+FA14, U+FA1F, U+FA21, U+FA23, U+FA24, U+FA27, U+FA28, \\\n"
-        "       U+FA29, U+3105..U+312C, U+31A0..U+31B7, U+3041, U+3043, U+3045, U+3047, \\\n"
-        "       U+3049, U+304B, U+304D, U+304F, U+3051, U+3053, U+3055, U+3057, U+3059, \\\n"
-        "       U+305B, U+305D, U+305F, U+3061, U+3063, U+3066, U+3068, U+306A..U+306F, \\\n"
-        "       U+3072, U+3075, U+3078, U+307B, U+307E..U+3083, U+3085, U+3087, \\\n"
-        "       U+3089..U+308E, U+3090..U+3093, U+30A1, U+30A3, U+30A5, U+30A7, U+30A9, \\\n"
-        "       U+30AD, U+30AF, U+30B3, U+30B5, U+30BB, U+30BD, U+30BF, U+30C1, U+30C3, \\\n"
-        "       U+30C4, U+30C6, U+30CA, U+30CB, U+30CD, U+30CE, U+30DE, U+30DF, U+30E1, \\\n"
-        "       U+30E2, U+30E3, U+30E5, U+30E7, U+30EE, U+30F0..U+30F3, U+30F5, U+30F6, \\\n"
-        "       U+31F0, U+31F1, U+31F2, U+31F3, U+31F4, U+31F5, U+31F6, U+31F7, U+31F8, \\\n"
-        "       U+31F9, U+31FA, U+31FB, U+31FC, U+31FD, U+31FE, U+31FF, U+AC00..U+D7A3, \\\n"
-        "       U+1100..U+1159, U+1161..U+11A2, U+11A8..U+11F9, U+A000..U+A48C, \\\n"
-        "       U+A492..U+A4C6\n"
-        "       ngram_chars = \\\n"
-        /* Support for Chinese/Japanese/Korean, from
-         * http://sphinxsearch.com/wiki/doku.php?id=charset_tables#cjk */
-        "       U+4E00..U+9FBB, U+3400..U+4DB5, U+20000..U+2A6D6, U+FA0E, U+FA0F, \\\n"
-        "       U+FA11, U+FA13, U+FA14, U+FA1F, U+FA21, U+FA23, U+FA24, U+FA27, U+FA28, \\\n"
-        "       U+FA29, U+3105..U+312C, U+31A0..U+31B7, U+3041, U+3043, U+3045, U+3047, \\\n"
-        "       U+3049, U+304B, U+304D, U+304F, U+3051, U+3053, U+3055, U+3057, U+3059, \\\n"
-        "       U+305B, U+305D, U+305F, U+3061, U+3063, U+3066, U+3068, U+306A..U+306F, \\\n"
-        "       U+3072, U+3075, U+3078, U+307B, U+307E..U+3083, U+3085, U+3087, \\\n"
-        "       U+3089..U+308E, U+3090..U+3093, U+30A1, U+30A3, U+30A5, U+30A7, U+30A9, \\\n"
-        "       U+30AD, U+30AF, U+30B3, U+30B5, U+30BB, U+30BD, U+30BF, U+30C1, U+30C3, \\\n"
-        "       U+30C4, U+30C6, U+30CA, U+30CB, U+30CD, U+30CE, U+30DE, U+30DF, U+30E1, \\\n"
-        "       U+30E2, U+30E3, U+30E5, U+30E7, U+30EE, U+30F0..U+30F3, U+30F5, U+30F6, \\\n"
-        "       U+31F0, U+31F1, U+31F2, U+31F3, U+31F4, U+31F5, U+31F6, U+31F7, U+31F8, \\\n"
-        "       U+31F9, U+31FA, U+31FB, U+31FC, U+31FD, U+31FE, U+31FF, U+AC00..U+D7A3, \\\n"
-        "       U+1100..U+1159, U+1161..U+11A2, U+11A8..U+11F9, U+A000..U+A48C, \\\n"
-        "       U+A492..U+A4C6\n"
-        "       ngram_len = 1\n"
-        "\n"
-        "    rt_attr_string = cyrusid\n"
-        "    rt_field = header_from\n"
-        "    rt_field = header_to\n"
-        "    rt_field = header_cc\n"
-        "    rt_field = header_bcc\n"
-        "    rt_field = header_subject\n"
-        "    rt_field = header_listid\n"
-        "    rt_field = header_type\n"
-        "    rt_field = headers\n"
-        "    rt_field = body\n"
-        "}\n"
-        "\n";
-    static const char global_config[] =
-        "searchd\n"
-        "{\n"
-        "    listen = $socket:mysql41\n"
-        "    log = syslog\n"
-        "    pid_file = $pidfile\n"
-        "    binlog_path = $rootdir/binlog\n"
-        "    compat_sphinxql_magics = 0\n"
-        "    workers = threads\n"
-        "    max_matches = " SPHINX_MAX_MATCHES "\n"
-        "}\n"
-        /* This index exists only to allow the searchd to start before
-         * any real user indexes have been added */
-        "index dummy\n"
-        "{\n"
-        "    type = rt\n"
-        "    path = $rootdir/dummy\n"
-        "    rt_field = dummy\n"
-        "}\n";
-    const char *rootdir = NULL;
-    char *basedir = NULL;
-    char *binlogdir = NULL;
-    char *indexname = NULL;
-    const char *config_file = NULL;
-    char *new_config_file = NULL;
-    int fd = -1;
-    struct buf bits = BUF_INITIALIZER;
-    struct buf user = BUF_INITIALIZER;
-    struct buf global = BUF_INITIALIZER;
-    int changed = 0;
-    int r;
-
-    config_file = sphinx_config_file();
-    if (verbose) {
-        if (mailbox)
-            syslog(LOG_INFO, "Sphinx setting up config file %s for mailbox %s",
-                    config_file, mailbox->name);
-        else
-            syslog(LOG_INFO, "Sphinx setting up config file %s",
-                    config_file);
-    }
-
-    /* Read the old file */
-    fd = open(config_file, O_RDONLY, 0);
-    if (fd >= 0) {
-        struct stat sb;
-
-        r = fstat(fd, &sb);
-        if (r < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to fstat %s: %m",
-                   config_file);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-        buf_ensure(&bits, sb.st_size+1);
-        bits.len = sb.st_size;
-        r = retry_read(fd, bits.s, bits.len);
-        buf_cstring(&bits);
-        if (r < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to read %s: %m",
-                   config_file);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-        close(fd);
-        fd = -1;
-
-        if (verbose)
-            syslog(LOG_INFO, "Sphinx read %ld bytes of config file %s",
-                    bits.len, config_file);
-    }
-    else if (fd != ENOENT) {
-        /* it's ok to be missing the file - we build it from scratch */
-        syslog(LOG_ERR, "IOERROR: unable to open %s for reading: %m",
-               config_file);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    /* adjust the file contents */
-    if (buf_findline(&bits, global_config) < 0) {
-
-        /* See if the root directory already exists */
-        rootdir = sphinx_rootdir(NULL);
-        binlogdir = strconcat(rootdir, "/binlog", (char *)NULL);
-        r = check_directory(binlogdir, verbose, create);
-        if (r) goto out;
-
-        buf_init_ro_cstr(&global, global_config);
-        buf_replace_all(&global, "$socket", config_getstring(IMAPOPT_SPHINX_SOCKET));
-        buf_replace_all(&global, "$pidfile", config_getstring(IMAPOPT_SPHINX_PIDFILE));
-        buf_replace_all(&global, "$rootdir", rootdir);
-        buf_append(&bits, &global);
-        changed++;
-        if (verbose)
-            syslog(LOG_INFO, "Sphinx adding section \"searchd\"");
-    }
-
-    if (mailbox) {
-
-        r = sphinx_basedir(mailbox, &basedir, &indexname);
-        if (r) {
-            syslog(LOG_ERR, "IOERROR: unable to name sphinx basedir for %s: %s",
-                   mailbox->name, error_message(r));
-            r = IMAP_IOERROR;
-            goto out;
-        }
-
-        /* see if the base directory already exists */
-        r = check_directory(basedir, verbose, create);
-        if (r) goto out;
-
-        buf_init_ro_cstr(&user, user_config);
-        buf_replace_all(&user, "$indexname", indexname);
-        if (buf_findline(&bits, user.s) < 0) {
-            buf_replace_all(&user, "$basedir", basedir);
-            buf_append(&bits, &user);
-            changed++;
-            if (verbose)
-                syslog(LOG_INFO, "Sphinx adding section \"index %s\"", indexname);
-        }
-    }
-
-    if (changed) {
-
-        /* Write the new config file back */
-        /* TODO: locking so multiple imapds don't all try to do this
-         * at the same time */
-
-        new_config_file = strconcat(config_file, ".new", (char *)NULL);
-        if (verbose)
-            syslog(LOG_INFO, "Sphinx writing new config file %s", new_config_file);
-
-        fd = open(new_config_file, O_WRONLY|O_CREAT|O_TRUNC, 0600);
-        if (fd < 0) {
-            /* build the directory and retry */
-            cyrus_mkdir(new_config_file, 0700);
-            fd = open(new_config_file, O_WRONLY|O_CREAT|O_TRUNC, 0600);
-        }
-        if (fd < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to open %s for writing: %m",
-                   new_config_file);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-
-        r = retry_write(fd, bits.s, bits.len);
-        if (r < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to write %s: %m",
-                   new_config_file);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-
-        close(fd);
-        fd = -1;
-
-        if (verbose)
-            syslog(LOG_INFO, "Sphinx renaming config file %s into place", config_file);
-
-        r = rename(new_config_file, config_file);
-        if (r < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to rename %s to %s: %m",
-                   new_config_file, config_file);
-            r = IMAP_IOERROR;
-            goto out;
-        }
-    }
-
-    r = sphinx_signal(changed ? SIGHUP : 0, verbose);
-    if (r == IMAP_NOTFOUND) {
-        /* searchd not running, start it */
-        if (verbose)
-            syslog(LOG_INFO, "Sphinx starting searchd");
-
-        r = run_command(SEARCHD, "--config", config_file,
-                        "--syslog-prefix", sphinx_syslog_prefix(), (char *)NULL);
-        if (r)
-            syslog(LOG_ERR, "Failed to start searchd: %s", error_message(r));
-    }
-
-out:
-    if (fd >= 0) close(fd);
-    if (new_config_file) unlink(new_config_file);
-    free(new_config_file);
-    free(basedir);
-    free(indexname);
-    free(binlogdir);
-    buf_free(&bits);
-    buf_free(&user);
-    buf_free(&global);
-    return r;
-}
-
-
-static int open_latest(struct mailbox *mailbox, struct latestdb *ldb)
-{
-    char *basedir = NULL;
-    char *path = NULL;
-    int r;
-
-    r = sphinx_basedir(mailbox, &basedir, NULL);
-    if (r) return r;
-    path = strconcat(basedir, LATESTDB_FNAME, NULL);
-    free(basedir);
-
-    if (!strcmpsafe(path, ldb->path)) {
-        free(path);
-        return 0;
-    }
-
-    /* need to open a new DB */
-
-    close_latest(ldb);
-
-    r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
-                     path, CYRUSDB_CREATE, &ldb->db);
-    if (r) {
-        syslog(LOG_ERR, "DBERROR: opening %s: %s",
-               path, cyrusdb_strerror(r));
-        r = IMAP_IOERROR;
-    }
-
-    if (r) {
-        free(path);
-    }
-    else {
-        ldb->path = path;
-    }
-    return r;
-}
-
-static void close_latest(struct latestdb *ldb)
-{
-    free(ldb->path);
-    ldb->path = NULL;
-
-    if (ldb->db) {
-        cyrusdb_close(ldb->db);
-        ldb->db = NULL;
-    }
-}
-
-/*
- * Read the most recently indexed UID for the current mailboxfrom the
- * 'latest' DB in the Sphinx directory.
- * Returns 0 on success or an IMAP error code.
- */
-static int read_latest(struct latestdb *ldb,
-                       struct mailbox *mailbox,
-                       uint32_t *latestp,
-                       int verbose)
-{
-    struct buf key = BUF_INITIALIZER;
-    struct buf buf = BUF_INITIALIZER;
-    const char *data = NULL;
-    size_t datalen = 0;
-    int r = 0;
-    unsigned int version = 0;
-    unsigned int uid = 0;
-
-    *latestp = 0;
-    if (verbose > 1)
-        syslog(LOG_INFO, "read_latest db=%s mailbox=%s uidvalidity=%u",
-               ldb->path, mailbox->name, mailbox->i.uidvalidity);
-
-    buf_printf(&key, "%s.%u", mailbox->name, mailbox->i.uidvalidity);
-
-    r = cyrusdb_fetch(ldb->db,
-                      key.s, key.len,
-                      &data, &datalen,
-                      (struct txn **)NULL);
-    if (r == CYRUSDB_NOTFOUND) {
-        if (verbose > 1) syslog(LOG_INFO, "read_latest defaults to 0");
-        r = 0;
-        goto out;
-    }
-    if (r) goto out;
-    buf_init_ro(&buf, data, datalen);
-    buf_cstring(&buf);
-
-    r = sscanf(buf.s, "%u %u", &version, &uid);
-    if (r != 2 || version != LATESTDB_VERSION) {
-        r = IMAP_MAILBOX_BADFORMAT;
-        goto out;
-    }
-
-    if (verbose > 1) syslog(LOG_INFO, "read_latest uid=%u", uid);
-    *latestp = uid;
-    r = 0;
-
-out:
-    buf_free(&key);
-    buf_free(&buf);
-    return r;
-}
-
-static int write_latest(struct latestdb *ldb,
-                        struct mailbox *mailbox,
-                        uint32_t uid,
-                        int verbose)
-{
-    struct buf key = BUF_INITIALIZER;
-    struct buf data = BUF_INITIALIZER;
-    struct txn *txn = NULL;
-    int r = 0;
-
-    if (verbose)
-        syslog(LOG_INFO, "write_latest db=%s mailbox=%s uidvalidity=%u uid=%u",
-               ldb->path, mailbox->name, mailbox->i.uidvalidity, uid);
-
-    buf_printf(&key, "%s.%u", mailbox->name, mailbox->i.uidvalidity);
-    buf_printf(&data, "%u %u", LATESTDB_VERSION, uid);
-
-    do {
-        r = cyrusdb_store(ldb->db,
-                          key.s, key.len,
-                          data.s, data.len,
-                          &txn);
-    } while (r == CYRUSDB_AGAIN);
-    if (!r)
-        r = cyrusdb_commit(ldb->db, txn);
-    else
-        cyrusdb_abort(ldb->db, txn);
-
-    buf_free(&data);
-    buf_free(&key);
-    return r;
-}
-
-/*
- * Read the last document ID from the "latest" DB.  This is a
- * temporary measure until we can get autoincrement behaviour
- * working for Sphinx.
- *
- * Returns: 0 on success or an IMAP error code.
- */
-static int read_lastid(struct latestdb *ldb,
-                       uint32_t *lastidp,
-                       int verbose)
-{
-    struct buf key = BUF_INITIALIZER;
-    struct buf buf = BUF_INITIALIZER;
-    const char *data = NULL;
-    size_t datalen = 0;
-    int r = 0;
-    unsigned int version = 0;
-    unsigned int id = 0;
-
-    *lastidp = 0;
-    if (verbose > 1) syslog(LOG_INFO, "read_lastid db=%s", ldb->path);
-
-    buf_init_ro_cstr(&key, LATESTDB_LASTID_KEY);
-
-    r = cyrusdb_fetch(ldb->db,
-                      key.s, key.len,
-                      &data, &datalen,
-                      (struct txn **)NULL);
-    if (r == CYRUSDB_NOTFOUND) {
-        if (verbose > 1) syslog(LOG_INFO, "read_lastid defaults to 0");
-        r = 0;
-        goto out;
-    }
-    if (r) goto out;
-    buf_init_ro(&buf, data, datalen);
-    buf_cstring(&buf);
-
-    r = sscanf(buf.s, "%u %u", &version, &id);
-    if (r != 2 || version != LATESTDB_VERSION) {
-        r = IMAP_MAILBOX_BADFORMAT;
-        goto out;
-    }
-
-    if (verbose > 1) syslog(LOG_INFO, "read_lastid id=%u", id);
-    *lastidp = id;
-    r = 0;
-
-out:
-    buf_free(&key);
-    buf_free(&buf);
-    return r;
-}
-
-static int write_lastid(struct latestdb *ldb,
-                        uint32_t lastid,
-                        int verbose)
-{
-    struct buf key = BUF_INITIALIZER;
-    struct buf data = BUF_INITIALIZER;
-    struct txn *txn = NULL;
-    int r = 0;
-
-    if (verbose > 1)
-        syslog(LOG_INFO, "write_lastid db=%s lastid=%u", ldb->path, lastid);
-
-    buf_init_ro_cstr(&key, LATESTDB_LASTID_KEY);
-    buf_printf(&data, "%u %u", LATESTDB_VERSION, lastid);
-
-    do {
-        r = cyrusdb_store(ldb->db,
-                          key.s, key.len,
-                          data.s, data.len,
-                          &txn);
-    } while (r == CYRUSDB_AGAIN);
-    if (!r)
-        r = cyrusdb_commit(ldb->db, txn);
-    else
-        cyrusdb_abort(ldb->db, txn);
-
-
-    buf_free(&data);
-    buf_free(&key);
-    return r;
-}
-
-static int flush(search_text_receiver_t *rx)
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-    int r = 0;
-
-    if (!tr->uncommitted) return 0;
-
-    /* We write the lastid out first, to avoid a future instance
-     * allocating a duplicate Sphinx document id should we crash */
-    r = write_lastid(&tr->latestdb, tr->lastid, tr->super.verbose);
-    if (r) return r;
-
-    if (tr->super.verbose > 1)
-        syslog(LOG_NOTICE, "Sphinx committing %u updates",
-                tr->uncommitted);
-
-    r = mysql_commit(tr->conn.mysql);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: Sphinx COMMIT failed for "
-                        "mailbox %s, %u messages ending at uid %u: %s",
-                        tr->super.mailbox->name,
-                        tr->uncommitted,
-                        tr->super.uid,
-                        mysql_error(tr->conn.mysql));
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    /* We write out the latestid for the mailbox only after successfully
-     * updating the index, to avoid a future instance not realising that
-     * there are unindexed messages should we fail to index */
-    r = write_latest(&tr->latestdb, tr->super.mailbox, tr->latest,
-                     tr->super.verbose);
-    if (r) goto out;
-
-    tr->uncommitted = 0;
-    buf_reset(&tr->super.tmp);
-
-out:
-    return r;
-}
-
-static int begin_message(search_text_receiver_t *rx, message_t *msg)
-{
-    sphinx_receiver_t *tr = (sphinx_receiver_t *)rx;
-    int i;
-
-    message_get_uid(msg, &tr->uid);
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++)
-        buf_reset(&tr->parts[i]);
-    tr->parts_total = 0;
-    tr->truncate_warning = 0;
-}
-
-static void begin_part(search_text_receiver_t *rx, int part)
-{
-    sphinx_receiver_t *tr = (sphinx_receiver_t *)rx;
-
-    tr->part = part;
-}
-
-static void append_text(search_text_receiver_t *rx,
-                        const struct buf *text)
-{
-    sphinx_receiver_t *tr = (sphinx_receiver_t *)rx;
-
-    if (tr->part) {
-        unsigned len = text->len;
-        if (tr->parts_total + len > MAX_PARTS_SIZE) {
-            if (!tr->truncate_warning++)
-                syslog(LOG_ERR, "Sphinx: truncating text from "
-                                "message mailbox %s uid %u",
-                                tr->mailbox->name, tr->uid);
-            len = MAX_PARTS_SIZE - tr->parts_total;
-        }
-        if (len) {
-            tr->parts_total += len;
-            buf_appendmap(&tr->parts[tr->part], text->s, len);
-        }
-    }
-}
-
-static void end_part(search_text_receiver_t *rx,
-                     int part __attribute__((unused)))
-{
-    sphinx_receiver_t *tr = (sphinx_receiver_t *)rx;
-
-    if (tr->verbose > 1)
-        syslog(LOG_NOTICE, "Sphinx: %ld bytes in part %s",
-               tr->parts[tr->part].len, search_part_as_string(tr->part));
-
-    tr->part = 0;
-}
-
-static void log_keywords(sphinx_update_receiver_t *tr)
-{
-    int i;
-    int r;
-    struct buf query = BUF_INITIALIZER;
-    MYSQL_RES *res = NULL;
-    MYSQL_ROW row = NULL;
-
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-        if (!tr->super.parts[i].len) continue;
-        buf_reset(&query);
-        buf_appendcstr(&query, "CALL KEYWORDS(");
-        append_escaped(&query, &tr->super.parts[i], '\'');
-        buf_appendcstr(&query, ", ");
-        append_escaped_cstr(&query, tr->super.indexname, '\'');
-        buf_appendcstr(&query, ",0)");
-        r = doquery(&tr->conn, tr->super.verbose, &query);
-
-        res = mysql_use_result(tr->conn.mysql);
-        if (!res) continue;
-
-        while ((row = mysql_fetch_row(res)))
-            syslog(LOG_INFO, "keyword %s\n", row[0]);
-        mysql_free_result(res);
-    }
-    buf_free(&query);
-}
-
-static int end_message_update(search_text_receiver_t *rx)
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-    struct buf *query = &tr->super.tmp;
-    int i;
-    int r;
-
-    if (!tr->conn.mysql) return IMAP_INTERNAL;
-
-    buf_reset(query);
-    buf_printf(query, "INSERT INTO %s (id,"COL_CYRUSID, tr->super.indexname);
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-        if (tr->super.parts[i].len) {
-            buf_appendcstr(query, ",");
-            buf_appendcstr(query, column_by_part[i]);
-        }
-    }
-    buf_appendcstr(query, ") VALUES (");
-    buf_printf(query, "%u,", ++tr->lastid);
-    append_escaped(query, make_cyrusid(tr->super.mailbox, tr->super.uid), '\'');
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-        if (tr->super.parts[i].len) {
-            buf_appendcstr(query, ",");
-            append_escaped(query, &tr->super.parts[i], '\'');
-        }
-    }
-    /* apparently Sphinx doesn't let you explicitly INSERT a NULL */
-    buf_appendcstr(query, ")");
-
-    r = doquery(&tr->conn, tr->super.verbose, query);
-    if (r) goto out; /* TODO: propagate error to the user */
-
-    if (tr->super.verbose > 3) log_keywords(tr);
-
-    ++tr->uncommitted;
-    tr->latest = tr->super.uid;
-
-out:
-    tr->super.uid = 0;
-    return r;
-}
-
-static const char *indexing_lockpath(struct mailbox *mailbox)
-{
-    char *userid = mboxname_to_userid(mailbox->name);
-    char *usermbox = mboxname_user_mbox(userid, NULL);
-    const char *lockpath = mboxname_lockpath_suffix(usermbox, INDEXING_LOCK_SUFFIX);
-    free(usermbox);
-    free(userid);
-    return lockpath;
-}
-
-static void indexing_unlock(int *fdp)
-{
-    if (*fdp >= 0) {
-        close(*fdp);
-        *fdp = -1;
-    }
-}
-
-static int indexing_lock(struct mailbox *mailbox, int *fdp)
-{
-    const char *lockpath = indexing_lockpath(mailbox);
-    int fd;
-    int r;
-
-    indexing_unlock(fdp);
-
-    fd = open(lockpath, O_WRONLY|O_CREAT, 0600);
-    if (fd < 0) {
-        if (cyrus_mkdir(lockpath, 0755) < 0) {
-            syslog(LOG_ERR, "IOERROR: unable to cyrus_mkdir %s: %m", lockpath);
-            return IMAP_IOERROR;
-        }
-        fd = open(lockpath, O_WRONLY|O_CREAT, 0600);
-    }
-    if (fd < 0) {
-        syslog(LOG_ERR, "IOERROR: unable to create %s: %m", lockpath);
-        return IMAP_IOERROR;
-    }
-
-    r = lock_blocking(fd, lockpath);
-    if (r < 0) {
-        syslog(LOG_ERR, "IOERROR: unable to lock %s: %m",
-                lockpath);
-        close(fd);
-        return IMAP_IOERROR;
-    }
-
-    *fdp = fd;
-    return 0;
-}
-
-static int begin_mailbox_update(search_text_receiver_t *rx,
-                                struct mailbox *mailbox,
-                                int incremental __attribute__((unused)))
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-    int r;
-
-    r = sphinx_setup(mailbox, tr->super.verbose, /*create*/1);
-    if (r) return r;
-
-    r = sphinx_basedir(mailbox, NULL, &tr->super.indexname);
-    if (r) return r;
-
-    r = get_connection(&tr->conn);
-    if (r) return r;
-
-    tr->super.mailbox = mailbox;
-
-    r = indexing_lock(mailbox, &tr->indexing_lock_fd);
-    if (r) return r;
-
-    r = open_latest(mailbox, &tr->latestdb);
-    if (r) return r;
-
-    r = read_lastid(&tr->latestdb, &tr->lastid, tr->super.verbose);
-    if (r) return r;
-
-    r = read_latest(&tr->latestdb, mailbox, &tr->latest, tr->super.verbose);
-    if (r) return r;
-
-    return 0;
-}
-
-static uint32_t first_unindexed_uid(search_text_receiver_t *rx)
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-
-    return tr->latest+1;
-}
-
-static int is_indexed(search_text_receiver_t *rx, uint32_t uid)
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-
-    return (uid <= tr->latest);
-}
-
-static int end_mailbox_update(search_text_receiver_t *rx,
-                              struct mailbox *mailbox
-                            __attribute__((unused)))
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-    int r = 0;
-
-    if (tr->conn.mysql)
-        r = flush(rx);
-
-    tr->super.mailbox = NULL;
-    free(tr->super.indexname);
-    tr->super.indexname = NULL;
-
-    return r;
-}
-
-static search_text_receiver_t *begin_update(int verbose)
-{
-    sphinx_update_receiver_t *tr;
-
-    tr = xzmalloc(sizeof(sphinx_update_receiver_t));
-    tr->super.super.begin_mailbox = begin_mailbox_update;
-    tr->super.super.first_unindexed_uid = first_unindexed_uid;
-    tr->super.super.is_indexed = is_indexed;
-    tr->super.super.begin_message = begin_message;
-    tr->super.super.begin_part = begin_part;
-    tr->super.super.append_text = append_text;
-    tr->super.super.end_part = end_part;
-    tr->super.super.end_message = end_message_update;
-    tr->super.super.end_mailbox = end_mailbox_update;
-    tr->super.super.flush = flush;
-
-    tr->indexing_lock_fd = -1;
-    tr->super.verbose = verbose;
-
-    return &tr->super.super;
-}
-
-static int free_receiver(sphinx_receiver_t *tr)
-{
-    int i;
-    int r = 0;
-
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++)
-        buf_free(&tr->parts[i]);
-    buf_free(&tr->tmp);
-    free(tr->indexname);
-
-    free(tr);
-
-    return r;
-}
-
-static int end_update(search_text_receiver_t *rx)
-{
-    sphinx_update_receiver_t *tr = (sphinx_update_receiver_t *)rx;
-
-    close_latest(&tr->latestdb);
-    close_connection(&tr->conn);
-    indexing_unlock(&tr->indexing_lock_fd);
-    return free_receiver(&tr->super);
-}
-
-static int begin_mailbox_snippets(search_text_receiver_t *rx,
-                                  struct mailbox *mailbox,
-                                  int incremental __attribute__((unused)))
-{
-    sphinx_snippet_receiver_t *tr = (sphinx_snippet_receiver_t *)rx;
-    int r;
-
-    r = get_connection(&tr->conn);
-    if (r) return r;
-
-    r = sphinx_basedir(mailbox, NULL, &tr->super.indexname);
-    if (r) return r;
-
-    tr->super.mailbox = mailbox;
-
-    return 0;
-}
-
-/* Generate Sphinx extended query syntax, not SphinxQL, customised for
- * using CALL SNIPPETS.  This differs from the regular query because
- * CALL SNIPPETS will silently ignore @field modifiers instead of
- * enforcing them.  So we have to emit one CALL SNIPPETS for every
- * field that may be mentioned in the original query, with a munged
- * query that contains a disjunction of all the search terms that
- * might apply to that part.  Thanks heaps Sphinx. [IRIS-2038] */
-static void generate_snippet_query(struct buf *query,
-                                   int part,
-                                   struct opnode *on)
-{
-    struct opnode *child;
-    struct buf arg = BUF_INITIALIZER;
-
-    buf_init_ro_cstr(&arg, on->arg);
-
-    switch (on->op) {
-
-    case SEARCH_OP_NOT:
-    case SEARCH_OP_OR:
-    case SEARCH_OP_AND:
-        for (child = on->children ; child ; child = child->next)
-            generate_snippet_query(query, part, child);
-        break;
-
-    case SEARCH_PART_ANY:
-        assert(on->children == NULL);
-        if (part != SEARCH_PART_HEADERS ||
-            !config_getswitch(IMAPOPT_SPHINX_TEXT_EXCLUDES_ODD_HEADERS)) {
-            if (query->len) buf_putc(query, '|');
-            append_escaped(query, &arg, '"');
-        }
-        break;
-
-    default:
-        /* other SEARCH_PART_* constants */
-        assert(on->op >= 0 && on->op < SEARCH_NUM_PARTS);
-        assert(on->children == NULL);
-        if (part == on->op) {
-            if (query->len) buf_putc(query, '|');
-            append_escaped(query, &arg, '"');
-        }
-        break;
-    }
-
-    buf_free(&arg);
-}
-
-static int end_message_snippets(search_text_receiver_t *rx)
-{
-    sphinx_snippet_receiver_t *tr = (sphinx_snippet_receiver_t *)rx;
-    struct buf query = BUF_INITIALIZER;
-    struct buf inner_query = BUF_INITIALIZER;
-    MYSQL_RES *res = NULL;
-    MYSQL_ROW row;
-    int i;
-    int r;
-
-    if (!tr->conn.mysql) {
-        r = IMAP_INTERNAL;          /* need to call begin_mailbox() */
-        goto out;
-    }
-    if (!tr->root) {
-        r = 0;
-        goto out;
-    }
-
-    for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-        if (res) {
-            mysql_free_result(res);
-            res = NULL;
-        }
-        if (i == SEARCH_PART_ANY) continue;
-
-        if (!tr->super.parts[i].len) continue;
-
-        buf_reset(&inner_query);
-        generate_snippet_query(&inner_query, i, tr->root);
-        if (!inner_query.len) continue;
-
-        buf_reset(&query);
-        buf_appendcstr(&query, "CALL SNIPPETS(");
-        append_escaped(&query, &tr->super.parts[i], '\'');
-        buf_appendcstr(&query, ", ");
-        append_escaped_cstr(&query, tr->super.indexname, '\'');
-        buf_appendcstr(&query, ", ");
-        append_escaped(&query, &inner_query, '\'');
-        buf_appendcstr(&query, ", 1 AS query_mode, 1 AS allow_empty)");
-
-        r = doquery(&tr->conn, tr->super.verbose, &query);
-        if (r) goto out;
-
-        res = mysql_store_result(tr->conn.mysql);
-        if (!res) continue;
-
-        row = mysql_fetch_row(res);
-        if (!row) continue;
-
-        if (tr->super.verbose > 1)
-            syslog(LOG_ERR, "snippet [%d] \"%s\"", i, row[0]);
-
-        if (!row[0][0]) continue;
-        r = tr->proc(tr->super.mailbox, tr->super.uid, i, row[0], tr->rock);
-        if (r) break;
-    }
-
-out:
-    if (res) mysql_free_result(res);
-    buf_free(&query);
-    buf_free(&inner_query);
-    return r;
-}
-
-static int end_mailbox_snippets(search_text_receiver_t *rx,
-                                struct mailbox *mailbox
-                                    __attribute__((unused)))
-{
-    sphinx_snippet_receiver_t *tr = (sphinx_snippet_receiver_t *)rx;
-
-    tr->super.mailbox = NULL;
-    free(tr->super.indexname);
-    tr->super.indexname = NULL;
-
-    return 0;
-}
-
-static search_text_receiver_t *begin_snippets(void *internalised,
-                                              int verbose,
-                                              search_snippet_markup_t *m __attribute__((unused)),
-                                              search_snippet_cb_t proc,
-                                              void *rock)
-{
-    sphinx_snippet_receiver_t *tr;
-
-    tr = xzmalloc(sizeof(sphinx_snippet_receiver_t));
-    tr->super.super.begin_mailbox = begin_mailbox_snippets;
-    tr->super.super.begin_message = begin_message;
-    tr->super.super.begin_part = begin_part;
-    tr->super.super.append_text = append_text;
-    tr->super.super.end_part = end_part;
-    tr->super.super.end_message = end_message_snippets;
-    tr->super.super.end_mailbox = end_mailbox_snippets;
-
-    tr->super.verbose = verbose;
-    tr->root = (struct opnode *)internalised;
-    tr->proc = proc;
-    tr->rock = rock;
-
-    return &tr->super.super;
-}
-
-static int end_snippets(search_text_receiver_t *rx)
-{
-    sphinx_snippet_receiver_t *tr = (sphinx_snippet_receiver_t *)rx;
-
-    close_connection(&tr->conn);
-    return free_receiver(&tr->super);
-}
-
-static int start_daemon(int verbose)
-{
-    return sphinx_setup(NULL, verbose, /*create*/1);
-}
-
-static int stop_daemon(int verbose)
-{
-    int r;
-
-    if (verbose)
-        syslog(LOG_INFO, "Sphinx stopping searchd");
-
-    r = run_command(SEARCHD, "--config", sphinx_config_file(),
-                    "--syslog-prefix", sphinx_syslog_prefix(),
-                    "--stopwait", (char *)NULL);
-    if (r)
-        syslog(LOG_ERR, "Failed to stop searchd: %s", error_message(r));
-    return r;
-}
-
-const struct search_engine sphinx_search_engine = {
-    "Sphinx",
-    SEARCH_FLAG_CAN_BATCH,
-    begin_search,
-    end_search,
-    begin_update,
-    end_update,
-    begin_snippets,
-    end_snippets,
-    describe_internalised,
-    free_internalised,
-    start_daemon,
-    stop_daemon,
-    /* list_files */NULL,   /* XXX: fixme */
-    /* compact */NULL,
-    /* deluser */NULL   /* XXX: fixme */
-};
-
diff -pruN 3.0.13-5/imap/search_squat.c 3.2.0-3/imap/search_squat.c
--- 3.0.13-5/imap/search_squat.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_squat.c	2020-04-24 02:03:00.000000000 +0000
@@ -102,7 +102,8 @@ static const char * const doctypes_by_pa
     "h",
     "m",
     "o",
-    "a"
+    "a",
+    "ab"
 };
 
 /* The document name is of the form
@@ -239,7 +240,7 @@ static void opstack_pop(SquatBuilderData
         parent->valid = 1;
     }
 
-    bv_free(&child->msg_vector);
+    bv_fini(&child->msg_vector);
 
 #if DEBUG
     if (bb->verbose > 1)
@@ -310,8 +311,12 @@ static void match(search_builder_t *bx,
     top = opstack_push(bb, /*doesn't matter*/0);
     bb->part_types = doctypes_by_part[part];
 
-    r = squat_search_execute(bb->index, str, strlen(str),
+    charset_t utf8 = charset_lookupname("utf-8");
+    char *mystr = charset_convert(str, utf8, charset_flags);
+    r = squat_search_execute(bb->index, mystr, strlen(mystr),
                              fill_with_hits, bb);
+    free(mystr);
+    charset_free(&utf8);
     if (r != SQUAT_OK) {
         if (squat_get_last_error() == SQUAT_ERR_SEARCH_STRING_TOO_SHORT)
             goto out; /* The rest of the search is still viable */
@@ -444,7 +449,7 @@ static int run(search_builder_t *bx, sea
         if (bv_isset(&bb->stack[0].msg_vector, uid)) {
             r = proc(bb->mailbox->name,
                      bb->mailbox->i.uidvalidity,
-                     uid, rock);
+                     uid, NULL, rock);
             if (r) goto out;
         }
     }
@@ -572,7 +577,6 @@ static int begin_message(search_text_rec
     message_get_uid(msg, &d->uid);
     d->doc_is_open = 0;
     d->doc_name[0] = '\0';
-    buf_init(&d->pending_text);
 
     d->mailbox_stats.indexed_messages++;
     d->total_stats.indexed_messages++;
@@ -580,7 +584,8 @@ static int begin_message(search_text_rec
     return 0;
 }
 
-static void begin_part(search_text_receiver_t *rx, int part)
+static void begin_part(search_text_receiver_t *rx, int part,
+                       const struct message_guid *content_guid __attribute__((unused)))
 {
     SquatReceiverData *d = (SquatReceiverData *) rx;
     char part_char = 0;
@@ -964,6 +969,11 @@ out:
     return r;
 }
 
+static int squat_charset_flags(int flags)
+{
+    return flags & ~CHARSET_KEEPCASE;
+}
+
 static search_text_receiver_t *begin_update(int verbose)
 {
     SquatReceiverData *d;
@@ -978,6 +988,7 @@ static search_text_receiver_t *begin_upd
     d->super.end_part = end_part;
     d->super.end_message = end_message;
     d->super.end_mailbox = end_mailbox;
+    d->super.index_charset_flags = squat_charset_flags;
 
     d->fd = -1;
     d->verbose = verbose;
@@ -996,7 +1007,7 @@ static int end_update(search_text_receiv
         print_stats("Total", &d->total_stats);
     }
 
-    bv_free(&d->indexed);
+    bv_fini(&d->indexed);
     free(d);
     return 0;
 }
@@ -1012,10 +1023,10 @@ const struct search_engine squat_search_
     /* end_snippets */NULL,
     /* describe_internalised */NULL,
     /* free_internalised */NULL,
-    /* start_daemon */NULL,
-    /* stop_daemon */NULL,
     /* list_files */NULL,
     /* compact */NULL,
-    /* deluser */NULL
+    /* deluser */NULL,
+    /* check_config */NULL,
+    /* list_lang_stats */NULL
 };
 
diff -pruN 3.0.13-5/imap/search_test.c 3.2.0-3/imap/search_test.c
--- 3.0.13-5/imap/search_test.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_test.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/stat.h>
@@ -53,14 +54,12 @@
 /* cyrus includes */
 #include "assert.h"
 #include "bsearch.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "index.h"
 #include "search_engines.h"
 #include "search_expr.h"
 #include "search_query.h"
 #include "message.h"
-#include "sysexits.h"
 #include "util.h"
 #include "xmalloc.h"
 
@@ -298,10 +297,6 @@ int main(int argc, char **argv)
     cyrus_init(alt_config, "search_test",
                CYRUSINIT_PERROR, CONFIG_NEED_PARTITION_DATA);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-    search_attr_init();
-
     char *freeme = NULL;
 
     switch (mode) {
@@ -322,9 +317,6 @@ int main(int argc, char **argv)
         break;
     }
 
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return r;
@@ -333,7 +325,7 @@ int main(int argc, char **argv)
 static int usage(const char *name)
 {
     fprintf(stderr, "usage: %s [format-options] -m mailbox -u userid searchprogram...\n", name);
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 void fatal(const char* s, int code)
diff -pruN 3.0.13-5/imap/search_xapian.c 3.2.0-3/imap/search_xapian.c
--- 3.0.13-5/imap/search_xapian.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/search_xapian.c	2020-05-04 03:28:02.000000000 +0000
@@ -65,6 +65,7 @@
 #include "xstrlcat.h"
 #include "mappedfile.h"
 #include "mboxlist.h"
+#include "mboxname.h"
 #include "xstats.h"
 #include "search_engines.h"
 #include "sequence.h"
@@ -79,40 +80,49 @@
 #define INDEXEDDB_FNAME         "/cyrus.indexed.db"
 #define XAPIAN_DIRNAME          "/xapian"
 #define ACTIVEFILE_METANAME     "xapianactive"
+#define XAPIAN_NAME_LOCK_PREFIX "$XAPIAN$"
 
 /* Name of columns */
 #define COL_CYRUSID     "cyrusid"
 
+/* Document types */
+#define SEARCH_XAPIAN_DOCTYPE_MSG  'G'
+#define SEARCH_XAPIAN_DOCTYPE_PART 'P'
+
 struct segment
 {
     int part;
+    struct message_guid guid;
+    char doctype;
     int sequence;       /* forces stable sort order JIC */
     int is_finished;
     struct buf text;
 };
 
-
 static const char *xapian_rootdir(const char *tier, const char *partition);
 static int xapian_basedir(const char *tier, const char *mboxname, const char *part,
                           const char *root, char **basedir);
 
 /* ====================================================================== */
-static int check_config(void)
+static int check_config(char **errstr)
 {
-    int r = 0;
     const char *s;
 
     if (!config_getswitch(IMAPOPT_CONVERSATIONS)) {
         syslog(LOG_ERR, "ERROR: conversations required but not enabled");
+        if (errstr)
+            *errstr = xstrdup("xapian: conversations required but not enabled");
         return IMAP_NOTFOUND;
     }
     s = config_getstring(IMAPOPT_DEFAULTSEARCHTIER);
     if (!s || !strlen(s)) {
         syslog(LOG_ERR, "ERROR: no default search tier configured");
-        r = IMAP_PARTITION_UNKNOWN;
+        if (errstr)
+            *errstr = xstrdup("xapian: no default search tier configured");
+        return IMAP_PARTITION_UNKNOWN;
     }
 
-    return r;
+    return 0;
 }
 
 /* ====================================================================== */
@@ -131,6 +141,11 @@ struct activeitem {
     int generation;
 };
 
+enum LockType {
+    AF_LOCK_READ = 0,
+    AF_LOCK_WRITE = 1,
+};
+
 static struct activeitem *activeitem_parse(const char *input)
 {
     struct activeitem *res = NULL;
@@ -155,8 +170,12 @@ static void activeitem_free(struct activ
 char *activeitem_generate(const char *tier, int generation)
 {
     struct buf buf = BUF_INITIALIZER;
+    char *ret;
     buf_printf(&buf, "%s:%d", tier, generation);
-    return buf_release(&buf);
+    ret = buf_release(&buf);
+    buf_free(&buf);
+
+    return ret;
 }
 
 /* calculate the next name for this tier, by incrementing the generation
@@ -300,7 +319,7 @@ static void _activefile_init(const char
 }
 
 static strarray_t *activefile_open(const char *mboxname, const char *partition,
-                                   struct mappedfile **activefile, int write)
+                                   struct mappedfile **activefile, enum LockType type)
 {
     char *fname = activefile_fname(mboxname);
     int r;
@@ -317,7 +336,7 @@ static strarray_t *activefile_open(const
 
     /* take the requested lock (a better helper API would allow this to be
      * specified as part of the open call, but here's where we are */
-    if (write) r = mappedfile_writelock(*activefile);
+    if (type == AF_LOCK_WRITE) r = mappedfile_writelock(*activefile);
     else r = mappedfile_readlock(*activefile);
     if (r) return NULL;
 
@@ -393,17 +412,32 @@ out:
 }
 
 /* convert an array of activefile items to an array of database paths,
- * optionally stripping records where the path doesn't exist */
+ * optionally stripping records where the path doesn't exist. If itemsptr
+ * is not NULL, it stores the unparsed items for which database paths
+ * exist in order and cardinality of the returned string array value.
+ */
 static strarray_t *activefile_resolve(const char *mboxname, const char *part,
-                                        const strarray_t *items, int dostat)
+                                      const strarray_t *items, int dostat,
+                                      strarray_t **itemsptr)
+
 {
     strarray_t *result = strarray_new();
     int i;
 
+    if (itemsptr) {
+        *itemsptr = strarray_new();
+    }
+
     for (i = 0; i < items->count; i++) {
         int statthis = (dostat == 1 || (dostat == 2 && i));
-        char *dir = activefile_path(mboxname, part, strarray_nth(items, i), statthis);
-        if (dir) strarray_appendm(result, dir);
+        const char *item = strarray_nth(items, i);
+        char *dir = activefile_path(mboxname, part, item, statthis);
+        if (dir) {
+            strarray_appendm(result, dir);
+            if (itemsptr) {
+                strarray_append(*itemsptr, item);
+            }
+        }
     }
 
     return result;
@@ -533,19 +567,183 @@ static struct seqset *parse_indexed(cons
     return NULL;
 }
 
+static int tierexists_cb(void *rock, const char *key, size_t keylen,
+                         const char *data __attribute__((unused)),
+                         size_t datalen __attribute__((unused)))
+{
+    const int *verbose = rock;
+    if (*verbose > 1) {
+        syslog(LOG_INFO, "tierexists_cb: found tier key %.*s", (int) keylen, key);
+    }
+    return CYRUSDB_DONE;
+}
+
+struct cachetier_rock {
+    struct buf *buf;
+    struct db *dst_db;
+    struct txn *txn;
+};
+
+static int cachetier_cb(void *rock, const char *key, size_t keylen,
+                        const char *data, size_t datalen)
+{
+    if (*key == '#') {
+        /* Ignore cache entries */
+        return 0;
+    }
+
+    struct cachetier_rock *mr = rock;
+    size_t prefix_len = buf_len(mr->buf);
+    int r = 0;
+
+    buf_appendmap(mr->buf, key, keylen);
+    r = cyrusdb_store(mr->dst_db, buf_base(mr->buf), buf_len(mr->buf),
+                      data, datalen, &mr->txn);
+    buf_truncate(mr->buf, prefix_len);
+    if (r) {
+        syslog(LOG_ERR, "cachetier_cb: could not save key %.*s for tier %s: %s",
+                (int) keylen, key, buf_cstring(mr->buf), cyrusdb_strerror(r));
+    }
+    return r;
+}
+
 /*
- * Read the most indexed UIDs sequence for the current mailbox
- * from the cyrus.indexed DB in each xapian directory and join
- * them into a single result.
- * Returns 0 on success or an IMAP error code.
+ * Merge the indexed.db of all search tiers activetiers[1..n] into the
+ * indexed.db of the top tier.
+ *
+ * Any entries in indexed.dbs located at activedirs[1..n] are cached into
+ * the indexed.db located at activedirs[0] (created if not exists), using
+ * a special prefix:
+ *
+ * The keys from merged entries are formatted as
+ *
+ *     '#c'.<tiername:tiergen>'#'<key>
+ *
+ * and any keys starting with '#' are ignored during the merge.
+ *
+ * Returns 0 on success or a cyrusdb error code.
  */
-static int read_indexed(const strarray_t *paths,
+static int cache_indexed(const strarray_t *activedirs,
+                         const strarray_t *activetiers,
+                         int verbose)
+{
+    struct db *src_db = NULL;
+    struct db *dst_db = NULL;
+    struct buf path = BUF_INITIALIZER;
+    struct buf key = BUF_INITIALIZER;
+    int r = 0;
+    int i;
+
+    assert(activedirs->count == activetiers->count);
+
+    if (!activedirs->count) {
+        return 0;
+    }
+
+    /* Open destination database */
+    buf_printf(&path, "%s%s", strarray_nth(activedirs, 0), INDEXEDDB_FNAME);
+    r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
+                     buf_cstring(&path), CYRUSDB_CREATE, &dst_db);
+    if (r) {
+        syslog(LOG_ERR, "cache_indexed: can't open destination db %s: %s",
+                buf_cstring(&path), cyrusdb_strerror(r));
+        goto out;
+    }
+
+    for (i = 1; i < activedirs->count; i++) {
+        /* Reset state */
+        if (src_db) {
+            cyrusdb_close(src_db);
+        }
+        src_db = NULL;
+        buf_reset(&path);
+        buf_reset(&key);
+
+        /* Check if the tier is already merged. We assume a tier is merged
+         * if at least one entry with its tier prefix exists. */
+        buf_printf(&key, "#c.%s#", strarray_nth(activetiers, i));
+        r = cyrusdb_foreach(dst_db, buf_base(&key), buf_len(&key),
+                            NULL, tierexists_cb, &verbose, NULL);
+        if (r == CYRUSDB_DONE) {
+            if (verbose) {
+                syslog(LOG_INFO, "cache_indexed: tier %s is already merged",
+                       strarray_nth(activetiers, i));
+            }
+            r = 0;
+            continue;
+        }
+        else if (r) goto out;
+
+        /* Open source database */
+        buf_printf(&path, "%s%s", strarray_nth(activedirs, i), INDEXEDDB_FNAME);
+        r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
+                         buf_cstring(&path), 0, &src_db);
+        if (r == CYRUSDB_NOTFOUND) {
+            if (verbose) {
+                syslog(LOG_INFO, "cache_indexed: no db found at %s",
+                       buf_cstring(&path));
+            }
+            r = 0;
+            continue;
+        }
+        else if (r) goto out;
+
+        /* Merge the entries from source into destination. The first
+         * store in the callback will create a write transaction. */
+        struct cachetier_rock rock = { &key, dst_db, NULL };
+        r = cyrusdb_foreach(src_db, NULL, 0, NULL, cachetier_cb, &rock, NULL);
+        cyrusdb_close(src_db);
+        src_db = NULL;
+        if (r) {
+            cyrusdb_abort(dst_db, rock.txn);
+            goto out;
+        }
+        cyrusdb_commit(dst_db, rock.txn);
+    }
+
+out:
+    if (dst_db) {
+        cyrusdb_close(dst_db);
+    }
+    if (src_db) {
+        cyrusdb_close(src_db);
+    }
+    buf_free(&key);
+    buf_free(&path);
+
+    return r;
+}
+
+/*
+ * Read the indexed UIDs sequence for mailbox mboxname
+ * from the activetiers located at activedirs and join
+ * them into a single result res.
+ *
+ * If do_cache is true, any activetiers[1..n] that are not
+ * already cached in the top tier (activetiers[0]) are
+ * cached before looking up their sequence sets in the
+ * cache. Caller must guarantee an exlusive write lock on
+ * activetier[0].
+ *
+ * If do_cache is zero, the sequence sets are constructed
+ * by looking up first any already cached indexes in the
+ * top tier, followed by looking up entries in any non-
+ * cached activetiers[1..n]. Since no writes are done,
+ * this operation is safe without exclusively locking
+ * the top tier.
+ *
+ * Returns 0 on success or a cyrusdb error code.
+ */
+static int read_indexed(const strarray_t *activedirs,
+                       const strarray_t *activetiers,
                        const char *mboxname,
                        uint32_t uidvalidity,
                        struct seqset *res,
+                       int do_cache,
                        int verbose)
 {
     struct db *db = NULL;
+    struct db *srcdb = NULL;
     struct buf path = BUF_INITIALIZER;
     struct buf key = BUF_INITIALIZER;
     const char *data = NULL;
@@ -553,57 +751,102 @@ static int read_indexed(const strarray_t
     int r = 0;
     int i;
 
-    buf_printf(&key, "%s.%u", mboxname, uidvalidity);
+    assert(activedirs->count == activetiers->count);
 
-    for (i = 0; i < paths->count; i++) {
-        struct seqset *seq;
-        buf_reset(&path);
-        buf_printf(&path, "%s%s", strarray_nth(paths, i), INDEXEDDB_FNAME);
-        if (verbose > 1)
-            syslog(LOG_INFO, "read_indexed db=%s mailbox=%s uidvalidity=%u",
-                   buf_cstring(&path), mboxname, uidvalidity);
+    if (!activedirs->count) {
+        return 0;
+    }
 
-        r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
-                         buf_cstring(&path), 0, &db);
-        if (r == CYRUSDB_NOTFOUND) {
-            r = 0;
-            if (verbose > 1)
-                syslog(LOG_INFO, "read_indexed no db for %s",
-                       buf_cstring(&path));
-            continue;
+    if (do_cache) {
+        /* Merge search tiers first */
+        r = cache_indexed(activedirs, activetiers, verbose);
+        if (r) return r;
+    }
+
+    /* Open database */
+    buf_printf(&path, "%s%s", strarray_nth(activedirs, 0), INDEXEDDB_FNAME);
+    r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
+                     buf_cstring(&path), CYRUSDB_CREATE, &db);
+    if (r) {
+        syslog(LOG_ERR, "read_indexed: can't open db %s: %s",
+                buf_cstring(&path), cyrusdb_strerror(r));
+        goto out;
+    }
+
+    /* Lookup entry in top tier */
+    buf_printf(&key, "%s.%u", mboxname, uidvalidity);
+    r = cyrusdb_fetch(db, key.s, key.len, &data, &datalen, (struct txn **)NULL);
+    if (r && r != CYRUSDB_NOTFOUND) {
+        goto out;
+    }
+    else if (!r) {
+        struct seqset *seq = parse_indexed(data, datalen);
+        if (seq) {
+            seqset_join(res, seq);
+            seqset_free(seq);
+            if (verbose > 1) {
+                syslog(LOG_INFO, "read_indexed: top tier seq=%.*s", (int)datalen, data);
+            }
+        }
+    }
+    r = 0;
+
+    /* Lookup entries from lower tiers */
+    for (i = 1; i < activedirs->count; i++) {
+        buf_reset(&key);
+        if (srcdb) {
+            cyrusdb_close(srcdb);
+            srcdb = NULL;
+        }
+
+        /* First look in the cached tiers in the top tier database. */
+        buf_printf(&key, "#c.%s#%s.%u", strarray_nth(activetiers, i), mboxname, uidvalidity);
+        r = cyrusdb_fetch(db, key.s, key.len, &data, &datalen, (struct txn **)NULL);
+
+        /* Fall back to the lower tiers if we haven't merged all tiers. */
+        if (r == CYRUSDB_NOTFOUND && !do_cache) {
+            buf_reset(&path);
+            buf_printf(&path, "%s%s", strarray_nth(activedirs, i), INDEXEDDB_FNAME);
+            r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
+                             buf_cstring(&path), 0, &srcdb);
+            if (r) {
+                syslog(LOG_ERR, "read_indexed: can't open db %s: %s",
+                        buf_cstring(&path), cyrusdb_strerror(r));
+                goto out;
+            }
+            buf_reset(&key);
+            buf_printf(&key, "%s.%u", mboxname, uidvalidity);
+            r = cyrusdb_fetch(srcdb, key.s, key.len, &data, &datalen, (struct txn **)NULL);
+        }
+        if (r && r != CYRUSDB_NOTFOUND) {
+            goto out;
         }
-        if (r) goto out;
 
-        r = cyrusdb_fetch(db,
-                          key.s, key.len,
-                          &data, &datalen,
-                          (struct txn **)NULL);
+        /* No entry found */
         if (r == CYRUSDB_NOTFOUND) {
             r = 0;
-            cyrusdb_close(db);
-            db = NULL;
-            if (verbose > 1)
-                syslog(LOG_INFO, "read_indexed no record for %s: %.*s",
-                       buf_cstring(&path), (int)key.len, key.s);
             continue;
         }
-        if (r) goto out;
 
-        seq = parse_indexed(data, datalen);
+        /* Parse and join the sequence sets */
+        struct seqset *seq = parse_indexed(data, datalen);
         if (seq) {
             seqset_join(res, seq);
             seqset_free(seq);
-            if (verbose > 1)
-                syslog(LOG_INFO, "read_indexed seq=%.*s", (int)datalen, data);
+            if (verbose > 1) {
+                syslog(LOG_INFO, "read_indexed: tier %s seq=%.*s",
+                        strarray_nth(activetiers, i), (int)datalen, data);
+            }
         }
-
-        cyrusdb_close(db);
-        db = NULL;
     }
 
 out:
-    if (db)
+    if (db) {
         cyrusdb_close(db);
+    }
+    if (srcdb) {
+        cyrusdb_close(srcdb);
+    }
     buf_free(&key);
     buf_free(&path);
 
@@ -697,66 +940,147 @@ out:
 
 /* ====================================================================== */
 
-/* FIXME remove when legacy cyrusid are deprecated */
-static int parse_legacy_cyrusid(const char *cyrusid,
-                                const char **mboxnamep,
-                                unsigned int *uidvalidityp,
-                                unsigned int *uidp)
-{
-    // user.cassandane.1320711192.196715
-    static struct buf buf = BUF_INITIALIZER;
-    char *p;
+/* XXX - replace with cyrus_mkdir and cyrus_copyfile */
+static void remove_dir(const char *dir)
+{
+    run_command(RM_BIN, "-rf", dir, (char *)NULL);
+}
 
-    buf_reset(&buf);
-    buf_appendcstr(&buf, cyrusid);
+static int copy_files(const char *fromdir, const char *todir)
+{
+    char *fromdir2 = strconcat(fromdir, "/", (char *)NULL);
+    int r = run_command(RSYNC_BIN, "-a", fromdir2, todir, (char *)NULL);
 
-    p = strrchr(buf_cstring(&buf), '.');
-    if (!p)
-        return 0;
-    *p++ = '\0';
-    *uidp = strtoul(p, NULL, 10);
+    free(fromdir2);
+    return r;
+}
 
-    p = strrchr(buf.s, '.');
-    if (!p)
-        return 0;
-    *p++ = '\0';
-    *uidvalidityp = strtoul(p, NULL, 10);
+/* ====================================================================== */
 
-    *mboxnamep = buf.s;
+/* shared lock for xapian dbs */
+struct xapiandb_lock {
+    struct mappedfile *activefile;
+    struct mboxlock *namelock;
+    strarray_t *activedirs;
+    strarray_t *activetiers;
+    xapian_db_t *db;
+};
 
-    return 1;
-}
+#define XAPIANDB_LOCK_INITIALIZER { NULL, NULL, NULL, NULL, NULL }
 
-static const char *make_cyrusid(const struct message_guid *guid)
+static void xapiandb_lock_release(struct xapiandb_lock *lock)
 {
-    static struct buf buf = BUF_INITIALIZER;
-    // *G*<encoded message guid>
-    buf_setcstr(&buf, "*G*");
-    buf_appendcstr(&buf, message_guid_encode(guid));
-    return buf_cstring(&buf);
+    if (lock->db) xapian_db_close(lock->db);
+
+    /* now that the databases are closed, it's safe to unlock
+     * the active file */
+    if (lock->activefile) {
+        mappedfile_unlock(lock->activefile);
+        mappedfile_close(&lock->activefile);
+    }
+    if (lock->namelock) {
+        mboxname_release(&lock->namelock);
+    }
+
+    strarray_free(lock->activedirs);
+    strarray_free(lock->activetiers);
+
+    memset(lock, 0, sizeof(struct xapiandb_lock));
 }
 
-/* XXX - replace with cyrus_mkdir and cyrus_copyfile */
-static void remove_dir(const char *dir)
+/*
+ * This function builds a lockfilename of the format:
+ *  $XAPIAN$<userid>
+ * example:
+ *  If the userid is `foo@bar.com` then the lockfilename is
+ *  $XAPIAN$foo@bar^com
+ *
+ * It replaces '.' in a string with a '^' into a struct buf
+ */
+static char *xapiandb_namelock_fname_from_userid(const char *userid)
 {
-    run_command(RM_BIN, "-rf", dir, (char *)NULL);
+    const char *p;
+    struct buf buf = BUF_INITIALIZER;
+
+    buf_setcstr(&buf, XAPIAN_NAME_LOCK_PREFIX);
+
+    for (p = userid; *p; p++) {
+        switch(*p) {
+            case '.':
+                buf_putc(&buf, '^');
+                break;
+            default:
+                buf_putc(&buf, *p);
+                break;
+        }
+    }
+
+    char *ret = buf_release(&buf);
+
+    buf_free(&buf);
+
+    return ret;
 }
 
-static int copy_files(const char *fromdir, const char *todir)
+
+static int xapiandb_lock_open(struct mailbox *mailbox, struct xapiandb_lock *lock)
 {
-    char *fromdir2 = strconcat(fromdir, "/", (char *)NULL);
-    int r = run_command(RSYNC_BIN, "-a", fromdir2, todir, (char *)NULL);
+    strarray_t *active = NULL;
+    char *namelock_fname = NULL;
+    char *userid = NULL;
+    int r = 0;
 
-    free(fromdir2);
+    assert(lock->namelock == NULL);
+    assert(lock->activefile == NULL);
+    assert(lock->activedirs == NULL);
+    assert(lock->activetiers == NULL);
+
+    /* Do nothing if there is no userid */
+    userid = mboxname_to_userid(mailbox->name);
+    if (!userid) goto out;
+
+    namelock_fname = xapiandb_namelock_fname_from_userid(userid);
+
+    /* Get a shared lock */
+    r = mboxname_lock(namelock_fname, &lock->namelock, LOCK_SHARED);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+                namelock_fname);
+        goto out;
+    }
+
+    /* need to hold a read-only lock on the activefile file
+     * to ensure no databases are deleted out from under us */
+    active = activefile_open(mailbox->name, mailbox->part, &lock->activefile, AF_LOCK_READ);
+    if (!active) goto out;
+
+    /* only try to open directories with databases in them */
+    lock->activedirs = activefile_resolve(mailbox->name, mailbox->part, active,
+            /*dostat*/1, &lock->activetiers);
+
+    /* open the databases */
+    if (lock->activedirs->count) {
+        const char **paths = (const char **) lock->activedirs->data;
+        r = xapian_db_open(paths, &lock->db);
+        if (r) goto out;
+    }
+
+out:
+    if (r) xapiandb_lock_release(lock);
+    strarray_free(active);
+    free(namelock_fname);
+    free(userid);
     return r;
 }
 
 /* ====================================================================== */
 
+#define XAPIAN_SEARCH_OP_DOCTYPE 1025
+
 struct opnode
 {
-    int op;     /* SEARCH_OP_* or SEARCH_PART_* constant */
-    char *arg;
+    int op;     /* SEARCH_OP_* or SEARCH_PART_* or XAPIAN_SEARCH_OP_* */
+    strarray_t *items;
     struct opnode *next;
     struct opnode *children;
 };
@@ -764,22 +1088,22 @@ struct opnode
 typedef struct xapian_builder xapian_builder_t;
 struct xapian_builder {
     search_builder_t super;
-    struct mappedfile *activefile;
+    struct xapiandb_lock lock;
     struct seqset *indexed;
     struct mailbox *mailbox;
-    xapian_db_t *db;
     int opts;
     struct opnode *root;
     ptrarray_t stack;       /* points to opnode* */
-    int (*proc)(const char *, uint32_t, uint32_t, void *);
+    int (*proc)(const char *, uint32_t, uint32_t, const strarray_t *, void *);
+    int (*proc_guidsearch)(const conv_guidrec_t*,size_t,void*);
     void *rock;
 };
 
-static struct opnode *opnode_new(int op, const char *arg)
+static struct opnode *opnode_new(int op, const strarray_t *arg)
 {
     struct opnode *on = xzmalloc(sizeof(struct opnode));
     on->op = op;
-    on->arg = xstrdupnull(arg);
+    on->items = strarray_dup(arg);
     return on;
 }
 
@@ -792,7 +1116,7 @@ static void opnode_delete(struct opnode
         next = child->next;
         opnode_delete(child);
     }
-    free(on->arg);
+    strarray_free(on->items);
     free(on);
 }
 
@@ -826,6 +1150,70 @@ static void opnode_insert_child(struct o
     child->next = after->next;
     after->next = child;
 }
+static struct opnode *opnode_deep_copy(const struct opnode *on)
+{
+    if (!on) return NULL;
+
+    struct opnode *clone = opnode_new(on->op, on->items);
+    const struct opnode *child;
+    for (child = on->children; child; child = child->next) {
+        opnode_append_child(clone, opnode_deep_copy(child));
+    }
+    return clone;
+}
+
+static const char *opnode_serialise(struct buf *buf, const struct opnode *on)
+{
+    if (!on) return "";
+
+    buf_putc(buf, '(');
+
+    if (on->op < SEARCH_NUM_PARTS) {
+        buf_appendcstr(buf, "MATCH");
+        buf_putc(buf, ' ');
+        const char *part = search_part_as_string(on->op);
+        buf_appendcstr(buf, part ? part : "ANY");
+    }
+    else if (on->op == SEARCH_OP_AND)
+        buf_appendcstr(buf, "AND");
+    else if (on->op == SEARCH_OP_OR)
+        buf_appendcstr(buf, "OR");
+    else if (on->op == SEARCH_OP_NOT)
+        buf_appendcstr(buf, "NOT");
+    else if (on->op == SEARCH_OP_TRUE)
+        buf_appendcstr(buf, "TRUE");
+    else if (on->op == SEARCH_OP_FALSE)
+        buf_appendcstr(buf, "FALSE");
+    else if (on->op == XAPIAN_SEARCH_OP_DOCTYPE)
+        buf_appendcstr(buf, "DOCTYPE");
+    else
+        buf_appendcstr(buf, "UNKNOWN");
+
+    if (on->items) {
+        buf_putc(buf, ' ');
+        buf_putc(buf, '(');
+        int i = 0;
+        for (i = 0; i < strarray_size(on->items); i++) {
+            if (i) buf_putc(buf, ' ');
+            buf_putc(buf, '"');
+            buf_appendcstr(buf, strarray_nth(on->items, i));
+            buf_putc(buf, '"');
+        }
+        buf_putc(buf, ')');
+    }
+
+    if (on->children) {
+        buf_putc(buf, ' ');
+        const struct opnode *child;
+        for (child = on->children ; child ; child = child->next) {
+            opnode_serialise(buf, child);
+        }
+    }
+
+    buf_putc(buf, ')');
+
+    return buf_cstring(buf);
+}
 
 static void optimise_nodes(struct opnode *parent, struct opnode *on)
 {
@@ -860,22 +1248,30 @@ static void optimise_nodes(struct opnode
     }
 }
 
-static xapian_query_t *opnode_to_query(const xapian_db_t *db, struct opnode *on)
+static xapian_query_t *opnode_to_query(const xapian_db_t *db, struct opnode *on, int opts)
 {
     struct opnode *child;
     xapian_query_t *qq = NULL;
-    int i;
+    int i, j;
     ptrarray_t childqueries = PTRARRAY_INITIALIZER;
 
+    if (!on) return xapian_query_new_matchall(db);
+
     switch (on->op) {
+    case SEARCH_OP_TRUE:
+        qq = xapian_query_new_matchall(db);
+        break;
+    case SEARCH_OP_FALSE:
+        qq = xapian_query_new_not(db, xapian_query_new_matchall(db));
+        break;
     case SEARCH_OP_NOT:
         if (on->children)
-            qq = xapian_query_new_not(db, opnode_to_query(db, on->children));
+            qq = xapian_query_new_not(db, opnode_to_query(db, on->children, opts));
         break;
     case SEARCH_OP_OR:
     case SEARCH_OP_AND:
         for (child = on->children ; child ; child = child->next) {
-            qq = opnode_to_query(db, child);
+            qq = opnode_to_query(db, child, opts);
             if (qq) ptrarray_push(&childqueries, qq);
         }
         qq = NULL;
@@ -887,131 +1283,671 @@ static xapian_query_t *opnode_to_query(c
     case SEARCH_PART_ANY:
         /* Xapian does not have a convenient way of search for "any
          * field"; instead we fake it by explicitly searching for
-         * all of the available prefixes */
+          * all of the available prefixes */
         for (i = 0 ; i < SEARCH_NUM_PARTS ; i++) {
-            void *q = xapian_query_new_match(db, i, on->arg);
-            if (q) ptrarray_push(&childqueries, q);
+            if (i == SEARCH_PART_ATTACHMENTBODY &&
+                !(opts & SEARCH_ATTACHMENTS_IN_ANY)) {
+                continue;
+            }
+            for (j = 0; j < strarray_size(on->items); j++) {
+                void *q = xapian_query_new_match(db, i, strarray_nth(on->items, j));
+                if (q) ptrarray_push(&childqueries, q);
+            }
         }
         qq = xapian_query_new_compound(db, /*is_or*/1,
                                        (xapian_query_t **)childqueries.data,
                                        childqueries.count);
         break;
+    case XAPIAN_SEARCH_OP_DOCTYPE:
+        assert(on->items != NULL && strarray_size(on->items));
+        const char *val = strarray_nth(on->items, 0);
+        qq = xapian_query_new_has_doctype(db, val[0], NULL);
+        break;
     default:
-        assert(on->arg != NULL);
+        assert(on->items != NULL);
         assert(on->children == NULL);
-        qq = xapian_query_new_match(db, on->op, on->arg);
+        if (strarray_size(on->items) > 1) {
+            for (j = 0; j < strarray_size(on->items); j++) {
+                void *q = xapian_query_new_match(db, on->op, strarray_nth(on->items, j));
+                if (q) ptrarray_push(&childqueries, q);
+            }
+            qq = xapian_query_new_compound(db, /*is_or*/1,
+                                           (xapian_query_t **)childqueries.data,
+                                           childqueries.count);
+        }
+        else {
+            qq = xapian_query_new_match(db, on->op, strarray_nth(on->items, 0));
+        }
         break;
     }
     ptrarray_fini(&childqueries);
     return qq;
 }
 
-static int xapian_run_guid_cb(const conv_guidrec_t *rec, void *rock)
+static int is_dnfclause(const struct opnode *on)
 {
-    xapian_builder_t *bb = (xapian_builder_t *)rock;
+    if (on->op < SEARCH_NUM_PARTS) {
+        return 1;
+    }
 
-    /* we only want full message matches here */
-    if (rec->part) return 0;
+    if (on->op == SEARCH_OP_TRUE || on->op == SEARCH_OP_FALSE) {
+        return 1;
+    }
+
+    if (on->op == SEARCH_OP_NOT) {
+        const struct opnode *child;
+        for (child = on->children; child; child = child->next) {
+            if (child->op >= SEARCH_NUM_PARTS)
+                return 0;
+        }
+        return 1;
+    }
+
+    if (on->op == SEARCH_OP_AND) {
+        const struct opnode *child;
+        for (child = on->children; child; child = child->next) {
+            if (child->op < SEARCH_NUM_PARTS ||
+                child->op == SEARCH_OP_TRUE ||
+                child->op == SEARCH_OP_FALSE) {
+                continue;
+            }
+            else if (child->op == SEARCH_OP_NOT) {
+                const struct opnode *gchild;
+                for (gchild = child->children; gchild; gchild = gchild->next) {
+                    if (gchild->op >= SEARCH_NUM_PARTS &&
+                        gchild->op < XAPIAN_SEARCH_OP_DOCTYPE) {
+                        return 0;
+                    }
+                }
+                continue;
+            }
+            else return 0;
+        }
+        return 1;
+    }
+
+    return 0;
+}
+
+static int is_orclause(const struct opnode *on)
+{
+    if (on->op != SEARCH_OP_OR) {
+        return 0;
+    }
+
+    const struct opnode *child;
+    for (child = on->children; child; child = child->next) {
+        if (child->op < SEARCH_NUM_PARTS ||
+                child->op >= XAPIAN_SEARCH_OP_DOCTYPE) {
+            // A MATCH or our own extensions are OK.
+            continue;
+        }
+        else if (child->op != SEARCH_OP_OR) {
+            // Not an OR operator.
+            return 0;
+        }
+        else if (!is_orclause(child)) {
+            // Not a pure OR subclause.
+            return 0;
+        }
+    }
+
+    return 1;
+}
+
+static int normalise_dnfclause(const struct opnode *expr, struct opnode **normalised)
+{
+    /* Normalise DNF clause expr to an AND clause, with each child
+     * expression being a part MATCH or single-valued NOT. */
+
+    struct opnode *root = opnode_deep_copy(expr);
+
+    if (root->op == SEARCH_OP_NOT) {
+        /* Convert NOT(x,y) to AND(NOT(x),NOT(y)) */
+        struct opnode *newroot = opnode_new(SEARCH_OP_AND, NULL);
+        while (root->children) {
+            struct opnode *child = root->children;
+            opnode_detach_child(root, child);
+            struct opnode *notchild = opnode_new(SEARCH_OP_NOT, NULL);
+            opnode_append_child(notchild, child);
+            opnode_append_child(newroot, notchild);
+        }
+        opnode_delete(root);
+        root = newroot;
+    }
+    else if (root->op < SEARCH_NUM_PARTS) {
+        /* Convert MATCH to AND(MATCH) */
+        struct opnode *newroot = opnode_new(SEARCH_OP_AND, NULL);
+        opnode_append_child(newroot, root);
+        root = newroot;
+    }
+
+    struct opnode *child = root->children;
+    while (child) {
+        /* Convert AND(NOT(x,y)) to AND(NOT(x),NOT(y)) */
+        if (child->op != SEARCH_OP_NOT) {
+            child = child->next;
+            continue;
+        }
+        if (!child->children || !child->children->next) {
+            child = child->next;
+            continue;
+        }
+        while (child->children) {
+            struct opnode *grandchild = child->children;
+            opnode_detach_child(child, grandchild);
+            struct opnode *notgrandchild = opnode_new(SEARCH_OP_NOT, NULL);
+            opnode_append_child(notgrandchild, grandchild);
+            opnode_append_child(root, notgrandchild);
+        }
+        struct opnode *next = child->next;
+        opnode_detach_child(root, child);
+        opnode_delete(child);
+        child = next;
+    }
+
+    *normalised = root;
+    return 0;
+}
+
+static int split_legacyv4_query(xapian_builder_t *bb,
+                                const struct opnode *expr,
+                                ptrarray_t *clauses)
+{
+    struct opnode *root = NULL;
+    int r = normalise_dnfclause(expr, &root);
+    if (r) return r;
+
+    assert(root->op == SEARCH_OP_AND);
+
+    /* Split clause into subclauses for top-level guid
+     * search, body part search and any part. */
+
+    struct opnode *qguid = opnode_new(SEARCH_OP_AND, NULL);
+    struct opnode *qpart = opnode_new(SEARCH_OP_AND, NULL);
+    struct opnode *qany = opnode_new(SEARCH_OP_AND, NULL);
+
+    struct opnode *child = root->children;
+    while (child) {
+        struct opnode *next = child->next;
+        opnode_detach_child(root, child);
+
+        int part = child->op == SEARCH_OP_NOT ? child->children->op : child->op;
+
+        if (child->op == SEARCH_OP_NOT && part == SEARCH_PART_ANY) {
+            struct opnode *clone = opnode_deep_copy(child);
+            opnode_append_child(qguid, child);
+            opnode_append_child(qpart, clone);
+        }
+        else {
+            switch (part) {
+                /* Map search parts to their document type queries.
+                 * It's annoying that this mapping must be kept in
+                 * sync with the search part indexing in index.c */
+                case SEARCH_PART_ANY:
+                    opnode_append_child(qany, child);
+                    break;
+                case SEARCH_PART_FROM:
+                case SEARCH_PART_TO:
+                case SEARCH_PART_CC:
+                case SEARCH_PART_BCC:
+                case SEARCH_PART_SUBJECT:
+                case SEARCH_PART_LISTID:
+                case SEARCH_PART_TYPE:
+                case SEARCH_PART_HEADERS:
+                case SEARCH_PART_ATTACHMENTNAME:
+                    opnode_append_child(qguid, child);
+                    break;
+                case SEARCH_PART_BODY:
+                case SEARCH_PART_LOCATION:
+                case SEARCH_PART_ATTACHMENTBODY:
+                    opnode_append_child(qpart, child);
+                    break;
+                default:
+                    syslog(LOG_ERR, "search_xapian: ignoring unexpected part: %s",
+                                     search_part_as_string(part));
+                    opnode_delete(child);
+                    child = NULL;
+            }
+        }
+        child = next;
+    }
+
+    /* Create Xapian queries for each subquery */
+
+    if (qguid->children) {
+        optimise_nodes(NULL, qguid);
+        xapian_query_t *xq = opnode_to_query(bb->lock.db, qguid, bb->opts);
+        if (xq) xq = xapian_query_new_has_doctype(bb->lock.db, SEARCH_XAPIAN_DOCTYPE_MSG, xq);
+        if (xq) ptrarray_append(clauses, xq);
+    }
+    if (qpart->children) {
+        optimise_nodes(NULL, qpart);
+        xapian_query_t *xq = opnode_to_query(bb->lock.db, qpart, bb->opts);
+        if (xq) xq = xapian_query_new_has_doctype(bb->lock.db, SEARCH_XAPIAN_DOCTYPE_PART, xq);
+        if (xq) ptrarray_append(clauses, xq);
+    }
+
+    for (child = qany->children; child; child = child->next) {
+        optimise_nodes(NULL, child);
+        xapian_query_t *xq = opnode_to_query(bb->lock.db, child, bb->opts);
+        if (xq) ptrarray_append(clauses, xq);
+    }
+
+    /* Clean up */
+
+    opnode_delete(qguid);
+    opnode_delete(qpart);
+    opnode_delete(qany);
+    opnode_delete(root);
+    return 0;
+}
+
+struct xapian_match {
+    bitvector_t uids;
+    hashu64_table partids_by_uid;
+};
+
+static void xapian_match_free_partids(uint64_t key __attribute__((unused)),
+                                      void *data,
+                                      void *rock __attribute__((unused)))
+{
+    strarray_free((strarray_t*)data);
+}
+
+static void xapian_match_reset(struct xapian_match *match)
+{
+    bv_fini(&match->uids);
+    if (match->partids_by_uid.size) {
+        hashu64_enumerate(&match->partids_by_uid, xapian_match_free_partids, NULL);
+    }
+    free_hashu64_table(&match->partids_by_uid, NULL);
+}
+
+struct xapian_run_rock {
+    xapian_builder_t *bb;
+    struct xapian_match *matches;
+};
+
+static int xapian_run_guid_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct xapian_run_rock *xrock = rock;
+    xapian_builder_t *bb = xrock->bb;
+    struct xapian_match *matches = xrock->matches;
 
     if (!(bb->opts & SEARCH_MULTIPLE)) {
         if (strcmp(rec->mboxname, bb->mailbox->name))
             return 0;
     }
 
-    xstats_inc(SPHINX_RESULT);
-    return bb->proc(rec->mboxname, /*uidvalidity*/0, rec->uid, bb->rock);
+    struct xapian_match *match = matches + rec->foldernum;
+    bv_set(&match->uids, rec->uid);
+    if (rec->part) {
+        if (!match->partids_by_uid.size) {
+            construct_hashu64_table(&match->partids_by_uid, 1024, 0);
+        }
+        strarray_t *partids = hashu64_lookup(rec->uid, &match->partids_by_uid);
+        if (!partids) {
+            partids = strarray_new();
+            hashu64_insert(rec->uid, partids, &match->partids_by_uid);
+        }
+        strarray_add(partids, rec->part);
+    }
+
+    return 0;
 }
 
-static int xapian_run_cb(const char *cyrusid, void *rock)
+
+static int memcmp40(const void *a, const void *b)
 {
-    xapian_builder_t *bb = (xapian_builder_t *)rock;
+    return memcmp(a, b, 40);
+}
 
-    int r = cmd_cancelled();
+static int xapian_run_cb(void *data, size_t nmemb, void *rock)
+{
+    struct xapian_run_rock *xrock = rock;
+    xapian_builder_t *bb = xrock->bb;
+
+    int r = cmd_cancelled(/*insearch*/1);
     if (r) return r;
 
-    if (!strncmp(cyrusid, "*G*", 3)) {
-        /* Current cyrus ids: *G*<encoded message guid> */
-        struct conversations_state *cstate;
-        const char *guid = cyrusid + 3;
+    struct conversations_state *cstate = mailbox_get_cstate(bb->mailbox);
+    if (!cstate) return IMAP_NOTFOUND;
 
-        cstate = mailbox_get_cstate(bb->mailbox);
-        if (!cstate) {
-            syslog(LOG_INFO, "search_xapian: can't open conversations for %s",
-                    bb->mailbox->name);
-            return IMAP_NOTFOUND;
+    qsort(data, nmemb, 41, memcmp40); // byte 41 is always zero
+
+    return conversations_iterate_searchset(cstate, data, nmemb, xapian_run_guid_cb, xrock);
+}
+
+struct xapian_run_guidsearch_rock {
+    xapian_builder_t *bb;
+    size_t total;
+};
+
+static int xapian_run_guidsearch_guid_cb(const conv_guidrec_t *rec, void *rock)
+{
+    struct xapian_run_guidsearch_rock *xrock = rock;
+    xapian_builder_t *bb = xrock->bb;
+    return bb->proc_guidsearch(rec, xrock->total, bb->rock);
+}
+
+static int xapian_run_guidsearch_cb(void *data, size_t nmemb, void *rock)
+{
+    xapian_builder_t *bb = rock;
+
+    int r = cmd_cancelled(/*insearch*/1);
+    if (r) return r;
+
+    struct conversations_state *cstate = mailbox_get_cstate(bb->mailbox);
+    if (!cstate) return IMAP_NOTFOUND;
+
+    qsort(data, nmemb, 41, memcmp40); // byte 41 is always zero
+
+    struct xapian_run_guidsearch_rock xrock = { bb, nmemb };
+    return conversations_iterate_searchset(cstate, data, nmemb,
+                                    xapian_run_guidsearch_guid_cb, &xrock);
+}
+
+static int run_legacy_v4_query(xapian_builder_t *bb)
+{
+    int i, r = 0;
+    struct conversations_state *cstate = mailbox_get_cstate(bb->mailbox);
+    if (!cstate) {
+        syslog(LOG_INFO, "search_xapian: can't open conversations for %s",
+                bb->mailbox->name);
+        return IMAP_NOTFOUND;
+    }
+    uint32_t num_folders = conversations_num_folders(cstate);
+    struct xapian_match *result = NULL;
+    ptrarray_t clauses = PTRARRAY_INITIALIZER;
+
+    if (is_dnfclause(bb->root)) {
+        /* Split into sub queries for each document type */
+        r = split_legacyv4_query(bb, bb->root, &clauses);
+        if (r) goto out;
+    }
+    else if (is_orclause(bb->root)) {
+        xapian_query_t *xq = opnode_to_query(bb->lock.db, bb->root, bb->opts);
+        ptrarray_append(&clauses, xq);
+    }
+    else {
+        struct buf buf = BUF_INITIALIZER;
+        opnode_serialise(&buf, bb->root);
+        syslog(LOG_ERR, "search_xapian: expected DNF or OR clause, got %s",
+                         buf_cstring(&buf));
+        buf_free(&buf);
+        r = IMAP_INTERNAL;
+        goto out;
+    }
+
+    /* Run clauses and intersect results */
+    for (i = 0; i < ptrarray_size(&clauses); i++) {
+        struct xapian_match *matches = xzmalloc(sizeof(struct xapian_match) * num_folders);
+
+        struct xapian_run_rock xrock = { bb, matches };
+        xapian_query_t *xq = ptrarray_nth(&clauses, i);
+        // sort the response by GUID for more efficient later handling
+        r = xapian_query_run(bb->lock.db, xq, /*is_legacy*/1,
+                             xapian_run_cb, &xrock);
+        if (r) {
+            uint32_t j;
+            for (j = 0; j < num_folders; j++) {
+                xapian_match_reset(matches + j);
+            }
+            free(matches);
+            goto out;
         }
 
-        r = conversations_guid_foreach(cstate, guid, xapian_run_guid_cb, bb);
-        return r;
+        /* First clause, use as initial result */
+        if (result == NULL) {
+            result = matches;
+            continue;
+        }
 
-    } else {
-        /* FIXME remove block when legacy cyrusid are deprecated */
-        /* Legacy cyrus ids: user.cassandane.1320711192.196715 */
-        const char *mboxname;
-        unsigned int uidvalidity;
-        unsigned int uid;
+        /* Intersect mailbox names */
+        uint32_t j;
+        for (j = 0; j < num_folders; j++) {
+            if (!bv_count(&matches[j].uids)) {
+                xapian_match_reset(result + j);
+            }
+        }
 
-        r = parse_legacy_cyrusid(cyrusid, &mboxname, &uidvalidity, &uid);
-        if (!r) {
-            syslog(LOG_ERR, "IOERROR: Cannot parse \"%s\" as cyrusid", cyrusid);
-            return IMAP_IOERROR;
+        /* Intersect UIDs */
+        for (j = 0; j < num_folders; j++) {
+            struct xapian_match *result_match = result + j;
+            struct xapian_match *clause_match = matches + j;
+            if (bv_count(&result_match->uids)) {
+                bv_andeq(&result_match->uids, &clause_match->uids);
+                if (result_match->partids_by_uid.size && clause_match->partids_by_uid.size) {
+                    /* Intersect partids */
+                    int uid;
+                    for (uid = bv_next_set(&result_match->uids, 0); uid != -1;
+                            uid = bv_next_set(&result_match->uids, uid+1)) {
+                        strarray_t *result_partids = hashu64_lookup(uid, &result_match->partids_by_uid);
+                        strarray_t *clause_partids = hashu64_lookup(uid, &clause_match->partids_by_uid);
+                        if (result_partids && clause_partids) {
+                            int i = 0, newlen = 0;
+                            for (i = 0; i < strarray_size(result_partids); i++) {
+                                const char *partid = strarray_nth(result_partids, i);
+                                if (strarray_find(clause_partids, partid, 0) >= 0) {
+                                    strarray_swap(result_partids, i, newlen);
+                                    newlen++;
+                                }
+                            }
+                            if (newlen) {
+                                strarray_truncate(result_partids, newlen);
+                            }
+                            else {
+                                hashu64_del(uid, &result_match->partids_by_uid);
+                                strarray_free(result_partids);
+                            }
+                        }
+                    }
+                }
+            }
+            xapian_match_reset(clause_match);
         }
+        free(matches);
+    }
 
-        if (!(bb->opts & SEARCH_MULTIPLE)) {
-            if (strcmp(mboxname, bb->mailbox->name))
-                return 0;
-            if (uidvalidity != bb->mailbox->i.uidvalidity)
-                return 0;
+    /* Return results */
+    if (result) {
+        r = 0;
+        uint32_t j;
+        for (j = 0; j < num_folders; j++) {
+            struct xapian_match *match = result + j;
+            if (bv_count(&match->uids)) {
+                const char *mboxname = conversations_folder_name(cstate, j);
+                int uid;
+                for (uid = bv_next_set(&match->uids, 0); uid != -1;
+                        uid = bv_next_set(&match->uids, uid+1)) {
+                    strarray_t *partids = NULL;
+                    if (match->partids_by_uid.size) {
+                        partids = hashu64_lookup(uid, &match->partids_by_uid);
+                    }
+                    r = bb->proc(mboxname, /*uidvalidity*/0, uid, partids, bb->rock);
+                    if (r) break;
+                }
+            }
         }
+        if (r) goto out;
+    }
 
-        xstats_inc(SPHINX_RESULT);
-        r = bb->proc(mboxname, uidvalidity, uid, bb->rock);
-        return r;
+out:
+    if (result) {
+        uint32_t j;
+        for (j = 0; j < num_folders; j++) {
+            xapian_match_reset(result + j);
+        }
+        free(result);
     }
+    if (ptrarray_size(&clauses)) {
+        xapian_query_t *xq;
+        while ((xq = ptrarray_pop(&clauses))) xapian_query_free(xq);
+    }
+    ptrarray_fini(&clauses);
+    return r;
 }
 
-static int run(search_builder_t *bx, search_hit_cb_t proc, void *rock)
+static int run_query(xapian_builder_t *bb)
 {
-    xapian_builder_t *bb = (xapian_builder_t *)bx;
-    xapian_query_t *qq = NULL;
+    struct opnode *root = NULL;
+    xapian_query_t *xq = NULL;
     int r = 0;
 
-    if (bb->db == NULL) {
-        syslog(LOG_ERR, "search_xapian: can't find index for mailbox: %s",
-                bb->mailbox ?  bb->mailbox->name : "<unknown>");
-        return IMAP_NOTFOUND;       /* there's no index for this user */
+    if (bb->proc_guidsearch) {
+        xq = opnode_to_query(bb->lock.db, bb->root, bb->opts);
+        if (!xq) goto out;
+
+        r = xapian_query_run(bb->lock.db, xq, /*is_legacy*/0,
+                             xapian_run_guidsearch_cb, bb);
+        goto out;
     }
 
-    /* Validate config */
-    r = check_config();
-    if (r) return r;
+    /* Fallback to UID search */
 
-    optimise_nodes(NULL, bb->root);
-    qq = opnode_to_query(bb->db, bb->root);
-    if (!qq) goto out;
+    if (bb->root && is_dnfclause(bb->root)) {
+        struct opnode *norm = NULL;
+        r = normalise_dnfclause(bb->root, &norm);
+        if (r) return r;
+
+        assert(norm->op == SEARCH_OP_AND);
+
+        /* Exclude P doctypes from matches for headers or ANY */
+        root = opnode_new(SEARCH_OP_AND, NULL);
+        while (norm->children) {
+            struct opnode *child = norm->children;
+            opnode_detach_child(norm, child);
+            if (child->op != SEARCH_OP_NOT) {
+                opnode_append_child(root, child);
+                continue;
+            }
+            struct opnode *expr = child->children;
+            if (expr->op >= SEARCH_NUM_PARTS) {
+                opnode_append_child(root, child);
+                continue;
+            }
+            if (!search_part_is_body(expr->op) || expr->op == SEARCH_PART_ANY) {
+                /* Transform NOT(MATCH) to AND(NOT(MATCH),NOT(DOCTYPE==P)) */
+                struct opnode *notdp = opnode_new(SEARCH_OP_NOT, NULL);
+                strarray_t ar = STRARRAY_INITIALIZER;
+                strarray_append(&ar, "P");
+                opnode_append_child(notdp, opnode_new(XAPIAN_SEARCH_OP_DOCTYPE, &ar));
+                strarray_fini(&ar);
+                struct opnode *node = opnode_new(SEARCH_OP_AND, NULL);
+                opnode_append_child(node, child);
+                opnode_append_child(node, notdp);
+                opnode_append_child(root, node);
+            }
+        }
+        opnode_delete(norm);
+    }
+    else if (bb->root && is_orclause(bb->root)) {
+        root = bb->root;
+    }
+    else if (bb->root) {
+        struct buf buf = BUF_INITIALIZER;
+        opnode_serialise(&buf, bb->root);
+        syslog(LOG_ERR, "search_xapian: expected DNF or OR clause, got %s",
+                buf_cstring(&buf));
+        buf_free(&buf);
+        r = IMAP_INTERNAL;
+        goto out;
+    }
 
-    bb->proc = proc;
-    bb->rock = rock;
+    xq = opnode_to_query(bb->lock.db, root, bb->opts);
+    if (!xq) goto out;
 
-    r = xapian_query_run(bb->db, qq, xapian_run_cb, bb);
-    if (r) goto out;
+    struct conversations_state *cstate = mailbox_get_cstate(bb->mailbox);
+    if (!cstate) {
+        syslog(LOG_INFO, "search_xapian: can't open conversations for %s",
+                bb->mailbox->name);
+        r = IMAP_NOTFOUND;
+        goto out;
+    }
+    uint32_t num_folders = conversations_num_folders(cstate);
+    struct xapian_match *result = xzmalloc(sizeof(struct xapian_match) * num_folders);
+    struct xapian_run_rock xrock = { bb, result };
+    // sort the response by GUID for more efficient later handling
+    r = xapian_query_run(bb->lock.db, xq, /*is_legacy*/0,
+                         xapian_run_cb, &xrock);
 
-    /* add in the unindexed uids as false positives */
-    if ((bb->opts & SEARCH_UNINDEXED)) {
-        uint32_t uid;
-        for (uid = seqset_firstnonmember(bb->indexed);
-             uid <= bb->mailbox->i.last_uid ; uid++) {
-            xstats_inc(SPHINX_UNINDEXED);
-            r = proc(bb->mailbox->name, bb->mailbox->i.uidvalidity, uid, rock);
-            if (r) goto out;
+    if (result) {
+        r = 0;
+        uint32_t j;
+        for (j = 0; j < num_folders; j++) {
+            struct xapian_match *match = result + j;
+            if (bv_count(&match->uids)) {
+                const char *mboxname = conversations_folder_name(cstate, j);
+                int uid;
+                for (uid = bv_next_set(&match->uids, 0); uid != -1;
+                        uid = bv_next_set(&match->uids, uid+1)) {
+                    strarray_t *partids = NULL;
+                    if (match->partids_by_uid.size) {
+                        partids = hashu64_lookup(uid, &match->partids_by_uid);
+                    }
+                    r = bb->proc(mboxname, /*uidvalidity*/0, uid, partids, bb->rock);
+                    if (r) break;
+                }
+            }
+            xapian_match_reset(match);
         }
     }
 
+    free(result);
+out:
+    if (root && root != bb->root) opnode_delete(root);
+    xapian_query_free(xq);
+    return r;
+}
+
+static int run_internal(xapian_builder_t *bb)
+{
+    int r = 0;
+
+    /* Sanity check builder */
+    assert((bb->proc == NULL) != (bb->proc_guidsearch == NULL));
+
+    if (!bb->lock.db) goto out; // no index for this user
+
+    /* Validate config */
+    r = check_config(NULL);
+    if (r) return r;
+
+    if (bb->root) optimise_nodes(NULL, bb->root);
+
+    /* A database can contain sub-databases of multiple versions */
+    if (xapian_db_has_otherthan_v4_index(bb->lock.db)) {
+        // all but version 4 databases index header and body together
+        r = run_query(bb);
+        if (r) goto out;
+    }
+    if (xapian_db_has_legacy_v4_index(bb->lock.db)) {
+        // legacy version 4 databases index headers and body separately
+        r = run_legacy_v4_query(bb);
+        if (r) goto out;
+    }
+
 out:
-    if (qq) xapian_query_free(qq);
     return r;
 }
 
+static int run(search_builder_t *bx, search_hit_cb_t proc, void *rock)
+{
+    xapian_builder_t *bb = (xapian_builder_t *)bx;
+    bb->proc = proc;
+    bb->rock = rock;
+    return run_internal(bb);
+}
+
+static int run_guidsearch(search_builder_t *bx, search_hitguid_cb_t proc, void *rock)
+{
+    xapian_builder_t *bb = (xapian_builder_t *)bx;
+    bb->proc_guidsearch = proc;
+    bb->rock = rock;
+    return run_internal(bb);
+}
+
 static void begin_boolean(search_builder_t *bx, int op)
 {
     xapian_builder_t *bb = (xapian_builder_t *)bx;
@@ -1034,26 +1970,35 @@ static void end_boolean(search_builder_t
     ptrarray_pop(&bb->stack);
 }
 
-static void match(search_builder_t *bx, int part, const char *str)
+static void matchlist(search_builder_t *bx, int part, const strarray_t *vals)
 {
     xapian_builder_t *bb = (xapian_builder_t *)bx;
     struct opnode *top = ptrarray_tail(&bb->stack);
     struct opnode *on;
 
-    if (!str) return;
-    if (SEARCH_VERBOSE(bb->opts))
+    if (!vals) return;
+    if (SEARCH_VERBOSE(bb->opts)) {
+        char *item = strarray_join(vals, ",");
         syslog(LOG_INFO, "match(part=%s, str=\"%s\")",
-               search_part_as_string(part), str);
-
-    xstats_inc(SPHINX_MATCH);
+               search_part_as_string(part), item);
+        free(item);
+    }
 
-    on = opnode_new(part, str);
+    on = opnode_new(part, vals);
     if (top)
         opnode_append_child(top, on);
     else
         bb->root = on;
 }
 
+static void match(search_builder_t *bx, int part, const char *val)
+{
+    strarray_t items = STRARRAY_INITIALIZER;
+    strarray_append(&items, val);
+    matchlist(bx, part, &items);
+    strarray_fini(&items);
+}
+
 static void *get_internalised(search_builder_t *bx)
 {
     xapian_builder_t *bb = (xapian_builder_t *)bx;
@@ -1076,51 +2021,34 @@ static void free_internalised(void *inte
 
 static search_builder_t *begin_search(struct mailbox *mailbox, int opts)
 {
-    xapian_builder_t *bb;
-    strarray_t *dirs = NULL;
-    strarray_t *active = NULL;
-    int r;
-
-    r = check_config();
+    int r = check_config(NULL);
     if (r) return NULL;
 
-    bb = xzmalloc(sizeof(xapian_builder_t));
+    xapian_builder_t *bb = xzmalloc(sizeof(xapian_builder_t));
     bb->super.begin_boolean = begin_boolean;
     bb->super.end_boolean = end_boolean;
     bb->super.match = match;
+    bb->super.matchlist = matchlist;
     bb->super.get_internalised = get_internalised;
     bb->super.run = run;
+    bb->super.run_guidsearch = run_guidsearch;
 
     bb->mailbox = mailbox;
     bb->opts = opts;
 
-    /* need to hold a read-only lock on the activefile file until the search
-     * has completed to ensure no databases are deleted out from under us */
-    active = activefile_open(mailbox->name, mailbox->part, &bb->activefile, /*write*/0);
-    if (!active) goto out;
-
-    /* only try to open directories with databases in them */
-    dirs = activefile_resolve(mailbox->name, mailbox->part, active, /*dostat*/1);
-    if (!dirs || !dirs->count) goto out;
-
-    /* if there are directories, open the databases */
-    r = xapian_db_open((const char **)dirs->data, &bb->db);
+    r = xapiandb_lock_open(mailbox, &bb->lock);
     if (r) goto out;
+    if (!bb->lock.activedirs || !bb->lock.activedirs->count) goto out;
 
     /* read the list of all indexed messages to allow (optional) false positives
      * for unindexed messages */
+    // TODO also handle for guidsearch
     bb->indexed = seqset_init(0, SEQ_MERGE);
-    r = read_indexed(dirs, mailbox->name, mailbox->i.uidvalidity, bb->indexed, /*verbose*/0);
+    r = read_indexed(bb->lock.activedirs, bb->lock.activetiers, mailbox->name,
+                     mailbox->i.uidvalidity, bb->indexed, /*do_cache*/0, /*verbose*/0);
     if (r) goto out;
 
-    if ((opts & SEARCH_MULTIPLE))
-        xstats_inc(SPHINX_MULTIPLE);
-    else
-        xstats_inc(SPHINX_SINGLE);
-
 out:
-    strarray_free(dirs);
-    strarray_free(active);
     /* XXX - error return? */
     return &bb->super;
 }
@@ -1129,18 +2057,11 @@ static void end_search(search_builder_t
 {
     xapian_builder_t *bb = (xapian_builder_t *)bx;
 
-    seqset_free(bb->indexed);
+    if (bb->indexed) seqset_free(bb->indexed);
     ptrarray_fini(&bb->stack);
     if (bb->root) opnode_delete(bb->root);
 
-    if (bb->db) xapian_db_close(bb->db);
-
-    /* now that the databases are closed, it's safe to unlock
-     * the active file */
-    if (bb->activefile) {
-        mappedfile_unlock(bb->activefile);
-        mappedfile_close(&bb->activefile);
-    }
+    xapiandb_lock_release(&bb->lock);
 
     free(bx);
 }
@@ -1156,7 +2077,9 @@ struct xapian_receiver
     struct mailbox *mailbox;
     struct message_guid guid;
     uint32_t uid;
+    time_t internaldate;
     int part;
+    const struct message_guid *part_guid;
     unsigned int parts_total;
     int truncate_warning;
     ptrarray_t segs;
@@ -1169,11 +2092,16 @@ struct xapian_update_receiver
     xapian_receiver_t super;
     xapian_dbw_t *dbw;
     struct mappedfile *activefile;
+    struct mboxlock *xapiandb_namelock;
     unsigned int uncommitted;
     unsigned int commits;
     struct seqset *oldindexed;
     struct seqset *indexed;
     strarray_t *activedirs;
+    strarray_t *activetiers;
+    hash_table cached_seqs;
+    int mode;
+    int reindex_parts;
 };
 
 /* receiver used for extracting snippets after a search */
@@ -1185,6 +2113,8 @@ struct xapian_snippet_receiver
     struct opnode *root;
     search_snippet_cb_t proc;
     void *rock;
+    struct xapiandb_lock lock;
+    const search_snippet_markup_t *markup;
 };
 
 /* Maximum size of a query, determined empirically, is a little bit
@@ -1339,6 +2269,48 @@ out:
     return r;
 }
 
+static int audit_mailbox(search_text_receiver_t *rx, bitvector_t *unindexed)
+{
+    xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
+    struct mailbox_iter *iter = NULL;
+    const message_t *msg = NULL;
+    int r = 0;
+
+    if (tr->mode != XAPIAN_DBW_XAPINDEXED) {
+        syslog(LOG_ERR, "search_xapian: require XAPIAN_DBW_XAPINDEXED mode");
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+
+    iter = mailbox_iter_init(tr->super.mailbox, 0, ITER_SKIP_UNLINKED);
+
+    while ((msg = mailbox_iter_step(iter))) {
+        uint32_t uid;
+        r = message_get_uid((message_t*) msg, &uid);
+        if (r) goto done;
+
+        if (!seqset_ismember(tr->oldindexed, uid)) {
+            if (tr->super.verbose)
+                syslog(LOG_INFO, "search_xapian: ignoring %s:%d during audit",
+                        tr->super.mailbox->name, uid);
+            continue;
+        }
+
+        const struct message_guid *guid;
+        r = message_get_guid((message_t*) msg, &guid);
+        if (r) goto done;
+
+        // XXX check for all parts of that message?
+        if (!xapian_dbw_is_indexed(tr->dbw, guid, SEARCH_XAPIAN_DOCTYPE_MSG)) {
+            bv_set(unindexed, uid);
+        }
+    }
+
+done:
+    mailbox_iter_done(&iter);
+    return r;
+}
+
 static void free_segments(xapian_receiver_t *tr)
 {
     int i;
@@ -1354,14 +2326,14 @@ static void free_segments(xapian_receive
 
 static int begin_message(search_text_receiver_t *rx, message_t *msg)
 {
-    xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
-
-    uint32_t uid = 0;
+    xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
     const struct message_guid *guid = NULL;
-    message_get_uid(msg, &uid);
-    message_get_guid(msg, &guid);
 
-    tr->super.uid = uid;
+    int r = message_get_uid(msg, &tr->super.uid);
+    if (!r) r = message_get_guid(msg, &guid);
+    if (!r) r = message_get_internaldate(msg, &tr->super.internaldate);
+    if (r) return r;
+
     message_guid_copy(&tr->super.guid, guid);
     free_segments((xapian_receiver_t *)tr);
     tr->super.parts_total = 0;
@@ -1369,11 +2341,13 @@ static int begin_message(search_text_rec
     return 0;
 }
 
-static void begin_part(search_text_receiver_t *rx, int part)
+static void begin_part(search_text_receiver_t *rx, int part,
+                       const struct message_guid *content_guid)
 {
     xapian_receiver_t *tr = (xapian_receiver_t *)rx;
 
     tr->part = part;
+    tr->part_guid = content_guid;
 }
 
 static void append_text(search_text_receiver_t *rx,
@@ -1391,6 +2365,7 @@ static void append_text(search_text_rece
                                 tr->mailbox->name, tr->uid);
             len = MAX_PARTS_SIZE - tr->parts_total;
         }
+
         if (len) {
             tr->parts_total += len;
 
@@ -1399,6 +2374,13 @@ static void append_text(search_text_rece
                 seg = (struct segment *)xzmalloc(sizeof(*seg));
                 seg->sequence = tr->segs.count;
                 seg->part = tr->part;
+                if (tr->part_guid) {
+                    message_guid_copy(&seg->guid, tr->part_guid);
+                    seg->doctype = SEARCH_XAPIAN_DOCTYPE_PART;
+                } else {
+                    message_guid_copy(&seg->guid, &tr->guid);
+                    seg->doctype = SEARCH_XAPIAN_DOCTYPE_MSG;
+                }
                 ptrarray_append(&tr->segs, seg);
             }
             buf_appendmap(&seg->text, text->s, len);
@@ -1424,13 +2406,28 @@ static void end_part(search_text_receive
     tr->part = 0;
 }
 
+static int doctype_cmp(char doctype1, char doctype2)
+{
+    if (doctype1 == SEARCH_XAPIAN_DOCTYPE_MSG &&
+        doctype2 != SEARCH_XAPIAN_DOCTYPE_MSG) return -1;
+
+    if (doctype1 != SEARCH_XAPIAN_DOCTYPE_MSG &&
+        doctype2 == SEARCH_XAPIAN_DOCTYPE_MSG) return 1;
+
+    return doctype1 - doctype2;
+}
+
 static int compare_segs(const void **v1, const void **v2)
 {
     const struct segment *s1 = *(const struct segment **)v1;
     const struct segment *s2 = *(const struct segment **)v2;
     int r;
 
-    r = s1->part - s2->part;
+    r = doctype_cmp(s1->doctype, s2->doctype);
+    if (!r)
+        r = message_guid_cmp(&s1->guid, &s2->guid);
+    if (!r)
+        r = s1->part - s2->part;
     if (!r)
         r = s1->sequence - s2->sequence;
     return r;
@@ -1443,34 +2440,78 @@ static int end_message_update(search_tex
     struct segment *seg;
     int r = 0;
 
-    if (!tr->dbw) return IMAP_INTERNAL;
+    if (!ptrarray_size(&tr->super.segs)) goto out;
 
-    r = xapian_dbw_begin_doc(tr->dbw, make_cyrusid(&tr->super.guid));
-    if (r) goto out;
+    if (!tr->dbw) {
+        r = xapian_dbw_open((const char **)tr->activedirs->data, &tr->dbw, tr->mode);
+        if (r) goto out;
+    }
 
     ptrarray_sort(&tr->super.segs, compare_segs);
 
+    // index headers and body parts with message guid
+    if (!tr->uncommitted) {
+        r = xapian_dbw_begin_txn(tr->dbw);
+        if (r) goto out;
+    }
+    r = xapian_dbw_begin_doc(tr->dbw, &tr->super.guid, SEARCH_XAPIAN_DOCTYPE_MSG);
+    if (r) goto out;
     for (i = 0 ; i < tr->super.segs.count ; i++) {
         seg = (struct segment *)ptrarray_nth(&tr->super.segs, i);
         r = xapian_dbw_doc_part(tr->dbw, &seg->text, seg->part);
         if (r) goto out;
     }
-
-    if (!tr->uncommitted) {
-        r = xapian_dbw_begin_txn(tr->dbw);
-        if (r) goto out;
-    }
     r = xapian_dbw_end_doc(tr->dbw);
     if (r) goto out;
-
     ++tr->uncommitted;
 
+    if (config_getswitch(IMAPOPT_SEARCH_INDEX_PARTS)) {
+        // index body parts with content guid
+        const struct message_guid *last_guid = NULL;
+        for (i = 0 ; i < tr->super.segs.count ; i++) {
+            seg = (struct segment *)ptrarray_nth(&tr->super.segs, i);
+            if (seg->doctype == SEARCH_XAPIAN_DOCTYPE_MSG) continue;
+
+            if (!last_guid || message_guid_cmp(last_guid, &seg->guid)) {
+                if (last_guid) {
+                    r = xapian_dbw_end_doc(tr->dbw);
+                    if (r) goto out;
+                    ++tr->uncommitted;
+                }
+
+                last_guid = &seg->guid;
+                // TODO which internaldate, if any?
+                r = xapian_dbw_begin_doc(tr->dbw, &seg->guid, seg->doctype);
+                if (r) goto out;
+            }
+            r = xapian_dbw_doc_part(tr->dbw, &seg->text, seg->part);
+            if (r) goto out;
+        }
+        if (last_guid) {
+            r = xapian_dbw_end_doc(tr->dbw);
+            if (r) goto out;
+            ++tr->uncommitted;
+        }
+    }
+
 out:
     tr->super.uid = 0;
     message_guid_set_null(&tr->super.guid);
+    tr->super.internaldate = 0;
     return r;
 }
 
+static int _starts_with_tier(const strarray_t *active, const char *tier)
+{
+    if (!active) return 0;
+    if (!active->count) return 0;
+    const char *candidate = strarray_nth(active, 0);
+    struct activeitem *item = activeitem_parse(candidate);
+    int res = !strcmp(item->tier, tier);
+    activeitem_free(item);
+    return res;
+}
+
 static int begin_mailbox_update(search_text_receiver_t *rx,
                                 struct mailbox *mailbox,
                                 int flags)
@@ -1479,6 +2520,8 @@ static int begin_mailbox_update(search_t
     char *fname = activefile_fname(mailbox->name);
     strarray_t *active = NULL;
     int r = IMAP_IOERROR;
+    char *namelock_fname = NULL;
+    char *userid = NULL;
 
     /* not an indexable mailbox, fine - return a code to avoid
      * trying to index each message as well */
@@ -1487,12 +2530,19 @@ static int begin_mailbox_update(search_t
         goto out;
     }
 
-    /* XXX - there's an annoying lock inversion going on here.  We have to release
-     * the mailbox lock and then re-establish it after we have the xapianactive file
-     * open.  We should really just get an mboxname passed down to this layer, but
-     * that's a much bigger rewrite due to disparate actions being squeezed into an
-     * identical API */
-    mailbox_unlock_index(mailbox, NULL);
+    /* Do nothing if there is no userid */
+    userid = mboxname_to_userid(mailbox->name);
+    if (!userid) goto out;
+
+    /* Get a shared namelock */
+    namelock_fname = xapiandb_namelock_fname_from_userid(userid);
+
+    r = mboxname_lock(namelock_fname, &tr->xapiandb_namelock, LOCK_SHARED);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
 
     /* we're using "not incremental" to mean "check that the GUID of every message
      * in the mailbox is present in an index rather than trusting the UID ranges */
@@ -1516,43 +2566,62 @@ static int begin_mailbox_update(search_t
      *  and will be going away in the future, but it's not too hard to design
      *  to avoid it happening at least."
      */
-    active = activefile_open(mailbox->name, mailbox->part, &tr->activefile, /*write*/1);
-    if (!active || !active->count) {
-        goto out;
-    }
+    const char *deftier = config_getstring(IMAPOPT_DEFAULTSEARCHTIER);
+    active = activefile_open(mailbox->name, mailbox->part, &tr->activefile, AF_LOCK_WRITE);
+    if (!active) active = strarray_new();
 
-    /* doesn't matter if the first one doesn't exist yet, we'll create it */
-    tr->activedirs = activefile_resolve(mailbox->name, mailbox->part, active, /*dostat*/2);
-    if (!tr->activedirs || !tr->activedirs->count) {
-        goto out;
+    // make sure we're indexing to the default tier
+    while (!_starts_with_tier(active, deftier)) {
+        char *newstart = activefile_nextname(active, config_getstring(IMAPOPT_DEFAULTSEARCHTIER));
+        syslog(LOG_NOTICE, "create new search tier %s for %s", newstart, mailbox->name);
+        strarray_unshiftm(active, newstart);
+        r = activefile_write(tr->activefile, active);
+        mappedfile_close(&tr->activefile);
+        active = activefile_open(mailbox->name, mailbox->part, &tr->activefile, AF_LOCK_WRITE);
     }
 
+    assert(active->count);
+
+    tr->mode = (flags & (SEARCH_UPDATE_XAPINDEXED|SEARCH_UPDATE_AUDIT)) ?
+        XAPIAN_DBW_XAPINDEXED : XAPIAN_DBW_CONVINDEXED;
+
+    /* doesn't matter if the first one doesn't exist yet, we'll create it. Only stat the others if we're going
+     * to be opening them */
+    int dostat = tr->mode == XAPIAN_DBW_XAPINDEXED ? 2 : 0;
+    tr->activedirs = activefile_resolve(mailbox->name, mailbox->part, active, dostat, &tr->activetiers);
+    // this should never be able to fail here, because the first item will always exist!
+    assert(tr->activedirs && tr->activedirs->count);
+
     /* create the directory if needed */
     r = check_directory(strarray_nth(tr->activedirs, 0), tr->super.verbose, /*create*/1);
     if (r) goto out;
 
-    /* open the DB */
-    r = xapian_dbw_open((const char **)tr->activedirs->data, &tr->dbw);
-    if (r) goto out;
+    if (tr->mode == XAPIAN_DBW_XAPINDEXED) {
+        /* open the DB now, we need it to check if messages are indexed */
+        r = xapian_dbw_open((const char **)tr->activedirs->data, &tr->dbw, tr->mode);
+        if (r) goto out;
+    }
 
     /* read the indexed data from every directory so know what still needs indexing */
     tr->oldindexed = seqset_init(0, SEQ_MERGE);
 
-    if ((flags & SEARCH_UPDATE_INCREMENTAL)) {
-        r = read_indexed(tr->activedirs, mailbox->name, mailbox->i.uidvalidity,
-                         tr->oldindexed, tr->super.verbose);
+    if ((flags & (SEARCH_UPDATE_INCREMENTAL|SEARCH_UPDATE_AUDIT))) {
+        r = read_indexed(tr->activedirs, tr->activetiers, mailbox->name, mailbox->i.uidvalidity,
+                        tr->oldindexed, /*do_cache*/1, tr->super.verbose);
         if (r) goto out;
     }
 
-    /* XXX - and of course we have to lock again! (XXX - no support for the nonblocking bit
-     * on this second lock... *sigh*)  We don't have the flags to know that we wanted it */
-    r = mailbox_lock_index(mailbox, LOCK_SHARED);
-    if (r) goto out;
+    /* purge any stale cache for this mailbox index sequences */
+    struct seqset *seq = hash_del(mailbox->name, &tr->cached_seqs);
+    if (seq) seqset_free(seq);
 
     tr->super.mailbox = mailbox;
+    tr->reindex_parts = flags & SEARCH_UPDATE_REINDEX_PARTS;
 
 out:
     free(fname);
+    free(userid);
+    free(namelock_fname);
     strarray_free(active);
     return r;
 }
@@ -1561,29 +2630,114 @@ static uint32_t first_unindexed_uid(sear
 {
     xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
 
-    if (!tr->oldindexed)
-        return 1;
+   return seqset_firstnonmember(tr->oldindexed);
+}
+
+static int is_indexed_cb(const conv_guidrec_t *rec, void *rock)
+{
+    xapian_update_receiver_t *tr = rock;
+
+    if (rec->part) return 0;
+
+    /* Is this GUID record in the mailbox we are currently indexing? */
+    if (!strcmp(tr->super.mailbox->name, rec->mboxname)) {
+        if (seqset_ismember(tr->indexed, rec->uid) ||
+            seqset_ismember(tr->oldindexed, rec->uid)) {
+            return CYRUSDB_DONE;
+        }
+        return 0;
+    }
+
+    /* Is this GUID record in an already cached sequence set? */
+    struct seqset *seq = hash_lookup(rec->mboxname, &tr->cached_seqs);
+    if (seq) {
+        return seqset_ismember(seq, rec->uid) ? CYRUSDB_DONE : 0;
+    }
+
+    /* Read the index cache for this mailbox */
+    mbentry_t *mb = NULL;
+    seq = seqset_init(0, SEQ_MERGE);
+    int r = 0;
+
+    r = mboxlist_lookup(rec->mboxname, &mb, NULL);
+    if (r) {
+        syslog(LOG_ERR, "is_indexed_cb: mboxlist_lookup %s failed: %s",
+                rec->mboxname, error_message(r));
+        goto out;
+    }
+    r = read_indexed(tr->activedirs, tr->activetiers, mb->name, mb->uidvalidity,
+                    seq, /*do_cache*/1, tr->super.verbose);
+    if (r) {
+        syslog(LOG_ERR, "is_indexed_cb: read_indexed %s failed: %s",
+                rec->mboxname, error_message(r));
+        goto out;
+    }
+    hash_insert(rec->mboxname, seq, &tr->cached_seqs);
 
-    return seqset_firstnonmember(tr->oldindexed);
+out:
+    mboxlist_entry_free(&mb);
+    if (r) {
+        seqset_free(seq);
+        return 0;
+    }
+    return seqset_ismember(seq, rec->uid) ? CYRUSDB_DONE : 0;
 }
 
 static int is_indexed(search_text_receiver_t *rx, message_t *msg)
 {
+    /* XXX caveat: this function returns non-zero if msg already
+     * has been indexed _and marks msg as indexed in any case_.
+     * The current squatter implementation relies on this and
+     * we should probably change this. */
     xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
 
     uint32_t uid = 0;
     message_get_uid(msg, &uid);
 
-    if (seqset_ismember(tr->indexed, uid)) return 3;
-    if (seqset_ismember(tr->oldindexed, uid)) return 2;
+    /* bail early if we've already indexed this message in THIS run */
+    if (seqset_ismember(tr->indexed, uid))
+        return 1;
 
-    if (!tr->indexed) tr->indexed = seqset_init(0, SEQ_MERGE);
-    seqset_add(tr->indexed, uid, 1);
+    int ret = 0;
 
     const struct message_guid *guid = NULL;
     message_get_guid(msg, &guid);
 
-    return xapian_dbw_is_indexed(tr->dbw, make_cyrusid(guid)) ? 1 : 0;
+    if (tr->mode == XAPIAN_DBW_CONVINDEXED) {
+        /* Determine if msg is already indexed */
+        struct conversations_state *cstate = mailbox_get_cstate(tr->super.mailbox);
+        if (!cstate) {
+            syslog(LOG_INFO, "search_xapian: can't open conversations for %s",
+                    tr->super.mailbox->name);
+            return 0;
+        }
+
+        char *guidrep = xstrdup(message_guid_encode(guid));
+        int r = conversations_guid_foreach(cstate, guidrep, is_indexed_cb, tr);
+        if (r == CYRUSDB_DONE) ret = 1;
+        else if (r) {
+            syslog(LOG_ERR, "is_indexed %s:%d: unexpected return code: %d (%s)",
+                   tr->super.mailbox->name, uid, r, cyrusdb_strerror(r));
+        }
+        free(guidrep);
+    }
+    else if (tr->mode == XAPIAN_DBW_XAPINDEXED) {
+        // XXX check for all parts of that message?
+        if (xapian_dbw_is_indexed(tr->dbw, guid, SEARCH_XAPIAN_DOCTYPE_MSG))
+            ret = 1;
+    }
+
+    /* start the range back at the first unindexed if necessary */
+    if (!tr->indexed) {
+        tr->indexed = seqset_init(0, SEQ_MERGE);
+        /* we want to say that we indexed the entire gap from last time
+         * up until this first message as well, so our indexed range
+         * isn't gappy */
+        seqset_add(tr->indexed, seqset_firstnonmember(tr->oldindexed), 1);
+    }
+    seqset_add(tr->indexed, uid, 1);
+
+    return ret;
 }
 
 static int end_mailbox_update(search_text_receiver_t *rx,
@@ -1606,6 +2760,7 @@ static int end_mailbox_update(search_tex
     }
 
     tr->super.mailbox = NULL;
+    tr->reindex_parts = 0;
 
     if (tr->dbw) {
         xapian_dbw_close(tr->dbw);
@@ -1619,19 +2774,34 @@ static int end_mailbox_update(search_tex
         tr->activefile = NULL;
     }
 
+    /* Release xapian db named lock */
+    if (tr->xapiandb_namelock) {
+        mboxname_release(&tr->xapiandb_namelock);
+        tr->xapiandb_namelock = NULL;
+    }
+
     if (tr->activedirs) {
         strarray_free(tr->activedirs);
         tr->activedirs = NULL;
     }
+    if (tr->activetiers) {
+        strarray_free(tr->activetiers);
+        tr->activetiers = NULL;
+    }
 
     return r;
 }
 
+static int xapian_charset_flags(int flags)
+{
+    return flags | CHARSET_KEEPCASE;
+}
+
 static search_text_receiver_t *begin_update(int verbose)
 {
     xapian_update_receiver_t *tr;
 
-    if (check_config()) return NULL;
+    if (check_config(NULL)) return NULL;
 
     tr = xzmalloc(sizeof(xapian_update_receiver_t));
     tr->super.super.begin_mailbox = begin_mailbox_update;
@@ -1644,9 +2814,13 @@ static search_text_receiver_t *begin_upd
     tr->super.super.end_message = end_message_update;
     tr->super.super.end_mailbox = end_mailbox_update;
     tr->super.super.flush = flush;
+    tr->super.super.audit_mailbox = audit_mailbox;
+    tr->super.super.index_charset_flags = xapian_charset_flags;
 
     tr->super.verbose = verbose;
 
+    construct_hash_table(&tr->cached_seqs, 128, 0);
+
     return &tr->super.super;
 }
 
@@ -1660,6 +2834,7 @@ static void free_receiver(xapian_receive
 static int end_update(search_text_receiver_t *rx)
 {
     xapian_update_receiver_t *tr = (xapian_update_receiver_t *)rx;
+    free_hash_table(&tr->cached_seqs, (void(*)(void*))seqset_free);
 
     free_receiver(&tr->super);
 
@@ -1674,7 +2849,15 @@ static int begin_mailbox_snippets(search
 
     tr->super.mailbox = mailbox;
 
-    return 0;
+    int r = xapiandb_lock_open(mailbox, &tr->lock);
+    if (r) goto out;
+    if (!tr->lock.activedirs || !tr->lock.activedirs->count) goto out;
+
+    tr->snipgen = xapian_snipgen_new(tr->lock.db, tr->markup->hi_start,
+                                     tr->markup->hi_end, tr->markup->omit);
+
+out:
+    return r;
 }
 
 /* Find match terms for the given part and add them to the Xapian
@@ -1684,9 +2867,15 @@ static void generate_snippet_terms(xapia
                                    struct opnode *on)
 {
     struct opnode *child;
+    int i;
 
     switch (on->op) {
 
+    case SEARCH_OP_TRUE:
+    case SEARCH_OP_FALSE:
+        // ignore
+        break;
+
     case SEARCH_OP_NOT:
     case SEARCH_OP_OR:
     case SEARCH_OP_AND:
@@ -1696,70 +2885,77 @@ static void generate_snippet_terms(xapia
 
     case SEARCH_PART_ANY:
         assert(on->children == NULL);
-        if (part != SEARCH_PART_HEADERS ||
-            !config_getswitch(IMAPOPT_SPHINX_TEXT_EXCLUDES_ODD_HEADERS)) {
-            xapian_snipgen_add_match(snipgen, on->arg);
+        if (part != SEARCH_PART_HEADERS) {
+            for (i = 0; i < strarray_size(on->items); i++)
+                xapian_snipgen_add_match(snipgen, strarray_nth(on->items, i));
         }
         break;
-
     default:
         /* other SEARCH_PART_* constants */
-        assert(on->op >= 0 && on->op < SEARCH_NUM_PARTS);
-        assert(on->children == NULL);
-        if (part == on->op) {
-            xapian_snipgen_add_match(snipgen, on->arg);
+        if (on->op >= 0 && on->op < SEARCH_NUM_PARTS) {
+            assert(on->children == NULL);
+            if (part == on->op) {
+                for (i = 0; i < strarray_size(on->items); i++)
+                    xapian_snipgen_add_match(snipgen, strarray_nth(on->items, i));
+            }
         }
         break;
     }
 }
 
-static int end_message_snippets(search_text_receiver_t *rx)
+static int flush_snippets(search_text_receiver_t *rx)
 {
     xapian_snippet_receiver_t *tr = (xapian_snippet_receiver_t *)rx;
     struct buf snippets = BUF_INITIALIZER;
-    unsigned int context_length;
     int i;
     struct segment *seg;
     int last_part = -1;
-    int r;
+    int r = 0;
 
-    if (!tr->snipgen) {
-        r = IMAP_INTERNAL;          /* need to call begin_mailbox() */
+    if (!tr->root) {
         goto out;
     }
-    if (!tr->root) {
-        r = 0;
+
+    if (!tr->lock.activedirs || !tr->lock.activedirs->count) {
+        goto out;
+    }
+
+    if (!tr->snipgen) {
+        r = IMAP_INTERNAL;          /* need to call begin_mailbox() */
         goto out;
     }
 
     ptrarray_sort(&tr->super.segs, compare_segs);
 
+    const struct message_guid *last_guid = NULL;
+
     for (i = 0 ; i < tr->super.segs.count ; i++) {
         seg = (struct segment *)ptrarray_nth(&tr->super.segs, i);
 
-        if (seg->part != last_part) {
+        if (!last_guid || message_guid_cmp(last_guid, &seg->guid) || seg->part != last_part) {
+            /* In contrast to the update code, we start and end a document
+             * for each search part of the same message. This is due to
+             * the way the snippet callbacks are implemented. */
+            r = xapian_snipgen_end_doc(tr->snipgen, &snippets);
 
-            if (last_part != -1) {
-                r = xapian_snipgen_end_doc(tr->snipgen, &snippets);
-                if (!r && snippets.len)
-                    r = tr->proc(tr->super.mailbox, tr->super.uid, last_part, snippets.s, tr->rock);
-                if (r) break;
-            }
+            if (!r && snippets.len)
+                r = tr->proc(tr->super.mailbox, tr->super.uid, last_part, snippets.s, tr->rock);
+            if (r) goto out;
 
-            /* TODO: UINT_MAX doesn't behave as expected, which is probably
-             * a bug, but really any value larger than a reasonable Subject
-             * length will do */
-            context_length = (seg->part == SEARCH_PART_HEADERS || seg->part == SEARCH_PART_BODY ? 5 : 1000000);
-            r = xapian_snipgen_begin_doc(tr->snipgen, context_length);
+            if (config_getswitch(IMAPOPT_SEARCH_INDEX_PARTS))
+                r = xapian_snipgen_begin_doc(tr->snipgen, &seg->guid, seg->doctype);
+            else
+                r = xapian_snipgen_begin_doc(tr->snipgen, &tr->super.guid, SEARCH_XAPIAN_DOCTYPE_MSG);
             if (r) break;
-
             generate_snippet_terms(tr->snipgen, seg->part, tr->root);
+
+            last_guid = &seg->guid;
+            last_part = -1;
         }
 
         r = xapian_snipgen_doc_part(tr->snipgen, &seg->text, seg->part);
-        if (r) break;
-
         last_part = seg->part;
+        if (r) break;
     }
 
     if (last_part != -1) {
@@ -1768,18 +2964,28 @@ static int end_message_snippets(search_t
             r = tr->proc(tr->super.mailbox, tr->super.uid, last_part, snippets.s, tr->rock);
     }
 
+    free_segments(&tr->super);
+
 out:
     buf_free(&snippets);
     return r;
 }
 
+static int end_message_snippets(search_text_receiver_t *rx)
+{
+    return flush_snippets(rx);
+}
+
 static int end_mailbox_snippets(search_text_receiver_t *rx,
                                 struct mailbox *mailbox
                                     __attribute__((unused)))
 {
     xapian_snippet_receiver_t *tr = (xapian_snippet_receiver_t *)rx;
 
+    xapiandb_lock_release(&tr->lock);
     tr->super.mailbox = NULL;
+    xapian_snipgen_free(tr->snipgen);
+    tr->snipgen = NULL;
 
     return 0;
 }
@@ -1792,7 +2998,7 @@ static search_text_receiver_t *begin_sni
 {
     xapian_snippet_receiver_t *tr;
 
-    if (check_config()) return NULL;
+    if (check_config(NULL)) return NULL;
 
     tr = xzmalloc(sizeof(xapian_snippet_receiver_t));
     tr->super.super.begin_mailbox = begin_mailbox_snippets;
@@ -1802,12 +3008,14 @@ static search_text_receiver_t *begin_sni
     tr->super.super.end_part = end_part;
     tr->super.super.end_message = end_message_snippets;
     tr->super.super.end_mailbox = end_mailbox_snippets;
+    tr->super.super.flush = flush_snippets;
+    tr->super.super.index_charset_flags = xapian_charset_flags;
 
     tr->super.verbose = verbose;
     tr->root = (struct opnode *)internalised;
-    tr->snipgen = xapian_snipgen_new(m->hi_start, m->hi_end, m->omit);
     tr->proc = proc;
     tr->rock = rock;
+    tr->markup = m;
 
     return &tr->super.super;
 }
@@ -1834,6 +3042,8 @@ static int list_files(const char *userid
     strarray_t *active = NULL;
     strarray_t *dirs = NULL;
     struct mappedfile *activefile = NULL;
+    struct mboxlock *xapiandb_namelock = NULL;
+    char *namelock_fname = NULL;
     int r;
     int i;
 
@@ -1848,9 +3058,20 @@ static int list_files(const char *userid
         goto out;
     }
 
-    active = activefile_open(mboxname, mbentry->partition, &activefile, /*write*/0);
+    /* Get a shared namelock */
+    namelock_fname = xapiandb_namelock_fname_from_userid(userid);
+
+    r = mboxname_lock(namelock_fname, &xapiandb_namelock, LOCK_SHARED);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
+
+    /* Get a readlock on the activefile */
+    active = activefile_open(mboxname, mbentry->partition, &activefile, AF_LOCK_READ);
     if (!active) goto out;
-    dirs = activefile_resolve(mboxname, mbentry->partition, active, /*dostat*/1);
+    dirs = activefile_resolve(mboxname, mbentry->partition, active, /*dostat*/1, NULL/*resultitems*/);
 
     for (i = 0; i < dirs->count; i++) {
         const char *basedir = strarray_nth(dirs, i);
@@ -1878,9 +3099,16 @@ out:
         mappedfile_unlock(activefile);
         mappedfile_close(&activefile);
     }
+
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
     strarray_free(active);
     strarray_free(dirs);
     free(fname);
+    free(namelock_fname);
     mboxlist_entry_free(&mbentry);
     free(mboxname);
 
@@ -1893,6 +3121,7 @@ struct mbfilter {
     struct db *indexeddb;
     struct txn **tid;
     const strarray_t *destpaths;
+    const strarray_t *desttiers;
     int flags;
 };
 
@@ -1907,6 +3136,12 @@ static int copyindexed_cb(void *rock,
                          const char *key, size_t keylen,
                          const char *data, size_t datalen)
 {
+    /* Ignore cached index entries */
+    if (*key == '#') {
+        return 0;
+    }
+
+    /* Copy the record */
     struct mbfilter *filter = (struct mbfilter *)rock;
     struct seqset *seq = parse_indexed(data, datalen);
     int r = 0;
@@ -1921,25 +3156,26 @@ static int mbdata_exists_cb(const char *
 {
     struct mbfilter *filter = (struct mbfilter *)rock;
 
-    /* we can't get here without GUID keys */
-    assert(!strncmp(cyrusid, "*G*", 3));
+    if (strncmp(cyrusid, "*G*", 3) && strncmp(cyrusid, "*P*", 3)) return 0;
 
-    return bloom_check(&filter->bloom, cyrusid+3, strlen(cyrusid+3));
+    return bloom_check(&filter->bloom, cyrusid+3, 40);
 }
 
 static int bloomadd_cb(void *rock,
-                       const char *key, size_t keylen,
+                       const char *key,
+                       size_t keylen __attribute__((unused)),
                        const char *data __attribute__((unused)),
                        size_t datalen __attribute__((unused)))
 {
     struct bloom *bloom = (struct bloom *)rock;
-    if (keylen > 41 && !memchr(key+41, '[', keylen-41))
-        bloom_add(bloom, key+1, 40);
+    bloom_add(bloom, key+1, 40);
     return 0;
 }
 
 static int create_filter(const strarray_t *srcpaths, const strarray_t *destpaths,
-                         const char *userid, int flags, struct mbfilter *filter, int bloom)
+                         const strarray_t *desttiers,
+                         const char *userid, int flags, struct mbfilter *filter,
+                         int bloom)
 {
     struct buf buf = BUF_INITIALIZER;
     int r = 0;
@@ -1948,6 +3184,7 @@ static int create_filter(const strarray_
 
     memset(filter, 0, sizeof(struct mbfilter));
     filter->destpaths = destpaths;
+    filter->desttiers = desttiers;
     filter->userid = userid;
     filter->flags = flags;
 
@@ -1955,6 +3192,7 @@ static int create_filter(const strarray_
 
     buf_reset(&buf);
     buf_printf(&buf, "%s%s", strarray_nth(destpaths, 0), INDEXEDDB_FNAME);
+
     r = cyrusdb_open(config_getstring(IMAPOPT_SEARCH_INDEXED_DB),
                      buf_cstring(&buf), CYRUSDB_CREATE, &filter->indexeddb);
     if (r) {
@@ -1988,7 +3226,7 @@ static int create_filter(const strarray_
         /* assume a 4 million maximum records */
         bloom_init(&filter->bloom, 4000000, 0.01);
 
-        r = conversations_open_user(userid, &cstate);
+        r = conversations_open_user(userid, 1/*shared*/, &cstate);
         if (r) {
             printf("ERROR: failed to open conversations for %s\n", userid);
             goto done;
@@ -1999,18 +3237,19 @@ static int create_filter(const strarray_
 
 done:
     conversations_commit(&cstate);
+    buf_free(&buf);
 
     return r;
 }
 
 static int search_filter(const char *userid, const strarray_t *srcpaths,
-                         const strarray_t *destpaths, int flags)
+                         const strarray_t *destpaths, const strarray_t *desttiers, int flags)
 {
     struct mbfilter filter;
     int verbose = SEARCH_VERBOSE(flags);
     int r;
 
-    r = create_filter(srcpaths, destpaths, userid, flags, &filter, 1);
+    r = create_filter(srcpaths, destpaths, desttiers, userid, flags, &filter, 1);
     if (r) goto done;
 
     if (verbose)
@@ -2061,11 +3300,21 @@ static int reindex_mb(void *rock,
 
     /* open the DB */
     tr = (xapian_update_receiver_t *)begin_update(verbose);
-    r = xapian_dbw_open((const char **)filter->destpaths->data, &tr->dbw);
+    tr->mode = XAPIAN_DBW_XAPINDEXED; // always use XAPINDEXED for reindex, so we reindex the same emails
+    r = xapian_dbw_open((const char **)filter->destpaths->data, &tr->dbw, tr->mode);
     if (r) goto done;
     tr->super.mailbox = mailbox;
+    tr->reindex_parts = 1; /* force re-indexing body parts */
+
+    tr->activedirs = strarray_dup(filter->destpaths);
+    tr->activetiers = strarray_dup(filter->desttiers);
 
-    struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+    struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_UNLINKED);
+    mailbox_iter_startuid(iter, seqset_first(seq));
+
+    /* initialise here so it doesn't add firstunindexed
+     * from oldindexed in is_indexed */
+    tr->indexed = seqset_init(0, SEQ_MERGE);
 
     const message_t *msg;
     while ((msg = mailbox_iter_step(iter))) {
@@ -2081,6 +3330,9 @@ static int reindex_mb(void *rock,
             ptrarray_append(&batch, msg);
         else
             message_unref(&msg);
+
+        if (record->uid > seqset_last(seq))
+            break;
     }
 
     mailbox_iter_done(&iter);
@@ -2106,7 +3358,7 @@ static int reindex_mb(void *rock,
         /* index the messages */
         for (i = 0 ; i < batch.count ; i++) {
             message_t *msg = ptrarray_nth(&batch, i);
-            r = index_getsearchtext(msg, &tr->super.super, 0);
+            r = index_getsearchtext(msg, NULL, &tr->super.super, 0);
             if (r) goto done;
             message_unref(&msg);
         }
@@ -2118,6 +3370,8 @@ static int reindex_mb(void *rock,
 
 done:
     if (tr) {
+        strarray_free(tr->activedirs);
+        strarray_free(tr->activetiers);
         if (tr->indexed) seqset_free(tr->indexed);
         if (tr->dbw) xapian_dbw_close(tr->dbw);
         free_receiver(&tr->super);
@@ -2130,14 +3384,14 @@ done:
 }
 
 static int search_reindex(const char *userid, const strarray_t *srcpaths,
-                          const strarray_t *destpaths, int flags)
+                          const strarray_t *destpaths, const strarray_t *desttiers, int flags)
 {
     struct buf buf = BUF_INITIALIZER;
     struct mbfilter filter;
     int verbose = SEARCH_VERBOSE(flags);
     int r;
 
-    r = create_filter(srcpaths, destpaths, userid, flags, &filter, 0);
+    r = create_filter(srcpaths, destpaths, desttiers, userid, flags, &filter, 0);
     if (r) goto done;
 
     if (verbose)
@@ -2159,14 +3413,14 @@ done:
 }
 
 static int search_compress(const char *userid, const strarray_t *srcpaths,
-                           const strarray_t *destpaths, int flags)
+                           const strarray_t *destpaths, const strarray_t *desttiers, int flags)
 {
     struct buf buf = BUF_INITIALIZER;
     struct mbfilter filter;
     int verbose = SEARCH_VERBOSE(flags);
     int r;
 
-    r = create_filter(srcpaths, destpaths, userid, flags, &filter, 0);
+    r = create_filter(srcpaths, destpaths, desttiers, userid, flags, &filter, 0);
     if (r) goto done;
 
     if (verbose)
@@ -2187,13 +3441,49 @@ done:
     return r;
 }
 
+static void cleanup_xapiandirs(const char *mboxname, const char *partition, strarray_t *active, int verbose)
+{
+    int i;
+    strarray_t found = STRARRAY_INITIALIZER;
+    strarray_t bogus = STRARRAY_INITIALIZER;
+
+    inspect_filesystem(mboxname, partition, &found, &bogus);
+
+    for (i = 0; i < strarray_size(active); i++) {
+        const char *item = strarray_nth(active, i);
+        strarray_remove_all(&found, item);
+    }
+
+    for (i = 0; i < strarray_size(&found); i++) {
+        const char *item = strarray_nth(&found, i);
+        char *path = activefile_path(mboxname, partition, item, /*dostat*/0);
+        if (verbose)
+            printf("Removing unreferenced item %s (%s)\n", item, path);
+        remove_dir(path);
+        free(path);
+    }
+
+    for (i = 0; i < strarray_size(&bogus); i++) {
+        const char *path = strarray_nth(&bogus, i);
+        if (verbose)
+            printf("Removing bogus path %s\n", path);
+        remove_dir(path);
+    }
+
+    strarray_fini(&found);
+    strarray_fini(&bogus);
+}
+
 static int compact_dbs(const char *userid, const char *tempdir,
-                       const strarray_t *srctiers, const char *desttier, int flags)
+                       const strarray_t *srctiers, const char *desttier,
+                       int flags)
 {
     char *mboxname = mboxname_user_mbox(userid, NULL);
     struct mboxlist_entry *mbentry = NULL;
     struct mappedfile *activefile = NULL;
+    struct mboxlock *xapiandb_namelock = NULL;
     strarray_t *srcdirs = NULL;
+    strarray_t *newdirs = NULL;
     strarray_t *active = NULL;
     strarray_t *tochange = NULL;
     strarray_t *orig = NULL;
@@ -2203,9 +3493,11 @@ static int compact_dbs(const char *useri
     char *destdir = NULL;
     char *tempdestdir = NULL;
     char *tempreindexdir = NULL;
+    strarray_t *newtiers = NULL;
     struct buf mytempdir = BUF_INITIALIZER;
-    struct buf buf = BUF_INITIALIZER;
+    char *namelock_fname = NULL;
     int verbose = SEARCH_VERBOSE(flags);
+    int created_something = 0;
     int r = 0;
     int i;
 
@@ -2220,11 +3512,28 @@ static int compact_dbs(const char *useri
         goto out;
     }
 
-    r = check_config();
+    r = check_config(NULL);
     if (r) goto out;
 
+    if (!xapian_rootdir(desttier, mbentry->partition)) {
+        if (verbose)
+            printf("INVALID: unknown tier %s\n", desttier);
+        goto out;
+    }
+
+    /* Generated the namelock filename */
+    namelock_fname = xapiandb_namelock_fname_from_userid(userid);
+
+    /* Get an exclusive namelock */
+    r = mboxname_lock(namelock_fname, &xapiandb_namelock, LOCK_EXCLUSIVE);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
+
     /* take an exclusive lock on the activefile file */
-    active = activefile_open(mboxname, mbentry->partition, &activefile, /*write*/1);
+    active = activefile_open(mboxname, mbentry->partition, &activefile, AF_LOCK_WRITE);
     if (!active || !active->count) goto out;
 
     orig = strarray_dup(active);
@@ -2243,7 +3552,7 @@ static int compact_dbs(const char *useri
     }
 
     /* find out which items actually exist from the set to be compressed - first pass */
-    srcdirs = activefile_resolve(mboxname, mbentry->partition, tochange, /*dostat*/1);
+    srcdirs = activefile_resolve(mboxname, mbentry->partition, tochange, /*dostat*/1, NULL/*resultitems*/);
     if (!srcdirs || !srcdirs->count) goto out;
     /* NOTE: it's safe to keep this list even over the unlock/relock because we
      * always write out a new first item if necessary, so these will never be
@@ -2281,6 +3590,20 @@ static int compact_dbs(const char *useri
     activefile_write(activefile, active);
     mappedfile_unlock(activefile);
 
+    /* Release the exclusive named lock */
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
+    /* Get a shared name lock */
+    r = mboxname_lock(namelock_fname, &xapiandb_namelock, LOCK_SHARED);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
+
     /* take a shared lock */
     mappedfile_readlock(activefile);
 
@@ -2298,6 +3621,11 @@ static int compact_dbs(const char *useri
         strarray_free(newactive);
     }
 
+    /* release the sharedlock on the active file, compcating is safe
+     * without locking activefile.
+     */
+    mappedfile_unlock(activefile);
+
     if (tempdir) {
         /* run the compress to tmpfs */
         buf_printf(&mytempdir, "%s/xapian.%d", tempdir, getpid());
@@ -2321,7 +3649,9 @@ static int compact_dbs(const char *useri
         }
         cyrus_mkdir(tempdestdir, 0755);
         remove_dir(tempdestdir);
-        r = copy_files(srcdirs->data[0], tempdestdir);
+        r = copy_files(strarray_nth(srcdirs, 0), tempdestdir);
+        if (r) goto out;
+        created_something = 1;
     }
     else if (srcdirs->count) {
         if (verbose) {
@@ -2332,9 +3662,11 @@ static int compact_dbs(const char *useri
         strarray_t *existing = strarray_dup(orig);
         for (i = 0; i < tochange->count; i++)
             strarray_remove_all(existing, strarray_nth(tochange, i));
-        strarray_t *newdirs = activefile_resolve(mboxname, mbentry->partition, existing, /*dostat*/1);
+        newdirs = activefile_resolve(mboxname, mbentry->partition, existing, /*dostat*/1, &newtiers);
         strarray_free(existing);
-        /* we'll be prepending the final target directory to newdirs before compacting */
+        /* we'll be prepending the final target directory to newdirs before compacting,
+         * so also add the new tier so the indexes match up */
+        strarray_unshift(newtiers, newdest);
 
         toreindex = strarray_new();
         tocompact = strarray_new();
@@ -2343,7 +3675,7 @@ static int compact_dbs(const char *useri
             strarray_cat(toreindex, srcdirs);
         }
         else {
-            xapian_check_if_needs_reindex(srcdirs, toreindex);
+            xapian_check_if_needs_reindex(srcdirs, toreindex, flags & SEARCH_COMPACT_ONLYUPGRADE);
             for (i = 0; i < srcdirs->count; i++) {
                 const char *thisdir = strarray_nth(srcdirs, i);
                 if (strarray_find(toreindex, thisdir, 0) < 0)
@@ -2351,63 +3683,91 @@ static int compact_dbs(const char *useri
             }
         }
 
+        if (!toreindex->count && (flags & SEARCH_COMPACT_ONLYUPGRADE)) {
+            /* nothing to reindex, so bail now.  Since we don't set 'r', we will just
+             * abort with no change other than a new tmp location which compresses down
+             * soon enough */
+            goto out;
+        }
+
+        // first, we'll reindex anything that needs reindexing to a temporary directory
         if (toreindex->count) {
             tempreindexdir = strconcat(buf_cstring(&mytempdir), ".REINDEX", (char *)NULL);
             // add this directory to the repack target as the first entry point
             strarray_unshift(newdirs, tempreindexdir);
-            r = search_reindex(userid, toreindex, newdirs, flags);
+            r = search_reindex(userid, toreindex, newdirs, newtiers, flags);
             if (r) {
-                printf("ERROR: failed to reindex to %s", buf_cstring(&mytempdir));
+                printf("ERROR: failed to reindex to %s", tempreindexdir);
+                remove_dir(tempreindexdir);
                 goto out;
             }
             // remove tempreindexdir from newdirs again, it's going to be compacted instead
             free(strarray_shift(newdirs));
 
-            // add it to the to-compact list if there's something there to reindex
+            // and then add the temporary directory to the to-compact list if anything was indexed into it
             if (!xapstat(tempreindexdir))
                 strarray_unshift(tocompact, tempreindexdir);
         }
 
-        // nothing left to compress
-        if (!tocompact->count)
-            goto out;
-
-        // and now we're ready to compact to the real tempdir
-        strarray_unshift(newdirs, buf_cstring(&mytempdir));
-
-        if (flags & SEARCH_COMPACT_FILTER) {
-            r = search_filter(userid, tocompact, newdirs, flags);
-            if (r) {
-                printf("ERROR: failed to filter to %s", buf_cstring(&mytempdir));
-                goto out;
+        // then we'll compact together all the source databases
+        if (tocompact->count) {
+            // and now we're ready to compact to the real tempdir
+            strarray_unshift(newdirs, buf_cstring(&mytempdir));
+
+            if (flags & SEARCH_COMPACT_FILTER) {
+                r = search_filter(userid, tocompact, newdirs, newtiers, flags);
+                if (r) {
+                    printf("ERROR: failed to filter to %s", buf_cstring(&mytempdir));
+                    goto out;
+                }
             }
-        }
-        else {
-            r = search_compress(userid, tocompact, newdirs, flags);
-            if (r) {
-                printf("ERROR: failed to compact to %s", buf_cstring(&mytempdir));
-                goto out;
+            else {
+                r = search_compress(userid, tocompact, newdirs, newtiers, flags);
+                if (r) {
+                    printf("ERROR: failed to compact to %s", buf_cstring(&mytempdir));
+                    goto out;
+                }
             }
-        }
 
-        /* move the tmpfs files to a temporary name in our target directory */
-        if (tempdir) {
-            if (verbose) {
-                printf("copying from tempdir to destination\n");
-            }
-            cyrus_mkdir(tempdestdir, 0755);
-            remove_dir(tempdestdir);
-            r = copy_files(buf_cstring(&mytempdir), tempdestdir);
-            if (r) {
-                printf("Failed to rsync from %s to %s", buf_cstring(&mytempdir), tempdestdir);
-                goto out;
+            if (!xapstat(buf_cstring(&mytempdir))) {
+                /* move the tmpfs files to a temporary name in our target directory */
+                if (tempdir) {
+                    if (verbose) {
+                        printf("copying from tempdir to destination\n");
+                    }
+                    cyrus_mkdir(tempdestdir, 0755);
+                    remove_dir(tempdestdir);
+                    r = copy_files(buf_cstring(&mytempdir), tempdestdir);
+                    remove_dir(buf_cstring(&mytempdir));
+                    if (r) {
+                        printf("Failed to rsync from %s to %s", buf_cstring(&mytempdir), tempdestdir);
+                        goto out;
+                    }
+                }
+                created_something = 1;
             }
         }
+
+        if (tempreindexdir) {
+            remove_dir(tempreindexdir);
+            free(tempreindexdir);
+            tempreindexdir = NULL;
+        }
     }
 
-    /* release and take an exclusive lock on activefile */
-    mappedfile_unlock(activefile);
-    mappedfile_writelock(activefile);
+    /* Release the shared named lock */
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
+    /* Get an exclusive namelock */
+    r = mboxname_lock(namelock_fname, &xapiandb_namelock, LOCK_EXCLUSIVE);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
 
     /* check that we still have 'directory zero'.  If not, delete all
      * temporary files and abort */
@@ -2423,11 +3783,8 @@ static int compact_dbs(const char *useri
         strarray_free(newactive);
     }
 
-    if (srcdirs->count) {
-        /* create a new target name one greater than the highest in the
-         * activefile file for our target directory.  Rename our DB to
-         * that path, then rewrite activefile removing all the source
-         * items */
+    if (created_something) {
+        /* rename the destination data into place */
         if (verbose) {
             printf("renaming tempdir into place\n");
         }
@@ -2448,45 +3805,56 @@ static int compact_dbs(const char *useri
     for (i = 0; i < tochange->count; i++)
         strarray_remove_all(active, strarray_nth(tochange, i));
 
+    /* Get an exclusive lock on the activefile */
+    mappedfile_writelock(activefile);
+
     activefile_write(activefile, active);
 
     /* release the lock */
     mappedfile_unlock(activefile);
 
+    /* And finally remove all directories on disk of the source dbs */
+    for (i = 0; i < srcdirs->count; i++)
+        remove_dir(strarray_nth(srcdirs, i));
+
+    /* remove any other files that are still lying around! */
+    cleanup_xapiandirs(mboxname, mbentry->partition, active, verbose);
+
+    /* Release the exclusive named lock */
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
     if (verbose) {
         char *alist = strarray_join(active, ",");
         printf("finished compact of %s (active %s)\n", mboxname, alist);
         free(alist);
     }
 
-    /* finally remove all directories on disk of the source dbs */
-    for (i = 0; i < srcdirs->count; i++)
-        remove_dir(strarray_nth(srcdirs, i));
-
-    /* XXX - readdir and remove other directories as well */
-
 out:
-    // cleanup all our work locations
-    if (tempdestdir)
-        remove_dir(tempdestdir);
-    if (tempreindexdir)
-        remove_dir(tempreindexdir);
-    if (mytempdir.len)
-        remove_dir(buf_cstring(&mytempdir));
-
     strarray_free(orig);
     strarray_free(active);
     strarray_free(srcdirs);
+    strarray_free(newdirs);
+    strarray_free(newtiers);
     strarray_free(toreindex);
     strarray_free(tochange);
+    strarray_free(tocompact);
     buf_free(&mytempdir);
-    buf_free(&buf);
+    free(namelock_fname);
     free(newdest);
     free(destdir);
     free(tempdestdir);
     free(tempreindexdir);
     mappedfile_unlock(activefile);
     mappedfile_close(&activefile);
+
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
     mboxlist_entry_free(&mbentry);
     free(mboxname);
 
@@ -2519,8 +3887,20 @@ static int delete_user(const char *useri
     char *mboxname = mboxname_user_mbox(userid, /*subfolder*/NULL);
     char *activename = activefile_fname(mboxname);
     struct mappedfile *activefile = NULL;
+    struct mboxlock *xapiandb_namelock = NULL;
+    char *namelock_fname = NULL;
     int r = 0;
 
+
+    /* Get an exclusive namelock */
+    namelock_fname = xapiandb_namelock_fname_from_userid(userid);
+    r = mboxname_lock(namelock_fname, &xapiandb_namelock, LOCK_EXCLUSIVE);
+    if (r) {
+        syslog(LOG_ERR, "Could not acquire shared namelock on %s\n",
+               namelock_fname);
+        goto out;
+    }
+
     /* grab an exclusive lock on activefile: that way we won't delete
      * it out from under something else (such as squatter)
      */
@@ -2538,16 +3918,42 @@ out:
         mappedfile_close(&activefile);
     }
 
+    if (xapiandb_namelock) {
+        mboxname_release(&xapiandb_namelock);
+        xapiandb_namelock = NULL;
+    }
+
+    free(namelock_fname);
     free(activename);
     free(mboxname);
 
     return r;
 }
 
+static int list_lang_stats(const char *userid, ptrarray_t *lstats)
+{
+    struct mailbox *mailbox = NULL;
+    char *inboxname = mboxname_user_mbox(userid, NULL);
+    struct xapiandb_lock lock = XAPIANDB_LOCK_INITIALIZER;
+
+    int r = mailbox_open_irl(inboxname, &mailbox);
+    if (r) goto out;
+
+    r = xapiandb_lock_open(mailbox, &lock);
+    if (r) goto out;
+
+    r = xapian_list_lang_stats(lock.db, lstats);
+
+out:
+    xapiandb_lock_release(&lock);
+    mailbox_close(&mailbox);
+    free(inboxname);
+    return r;
+}
 
 const struct search_engine xapian_search_engine = {
     "Xapian",
-    SEARCH_FLAG_CAN_BATCH,
+    SEARCH_FLAG_CAN_BATCH | SEARCH_FLAG_CAN_GUIDSEARCH,
     begin_search,
     end_search,
     begin_update,
@@ -2556,10 +3962,10 @@ const struct search_engine xapian_search
     end_snippets,
     describe_internalised,
     free_internalised,
-    /*start_daemon*/NULL,
-    /*stop_daemon*/NULL,
     list_files,
     compact_dbs,
-    delete_user  /* XXX: fixme */
+    delete_user,  /* XXX: fixme */
+    check_config,
+    list_lang_stats
 };
 
diff -pruN 3.0.13-5/imap/seen_db.c 3.2.0-3/imap/seen_db.c
--- 3.0.13-5/imap/seen_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/seen_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -271,7 +271,7 @@ EXPORTED int seen_read(struct seen *seen
     return seen_readit(seendb, uniqueid, sd, 0);
 }
 
-HIDDEN int seen_lockread(struct seen *seendb, const char *uniqueid, struct seendata *sd)
+EXPORTED int seen_lockread(struct seen *seendb, const char *uniqueid, struct seendata *sd)
 {
     if (SEEN_DEBUG) {
         syslog(LOG_DEBUG, "seen_db: seen_lockread %s (%s)",
diff -pruN 3.0.13-5/imap/sequence.c 3.2.0-3/imap/sequence.c
--- 3.0.13-5/imap/sequence.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sequence.c	2020-05-04 03:28:02.000000000 +0000
@@ -44,7 +44,7 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <stdio.h>
-#include "exitcodes.h"
+#include <sysexits.h>
 #include "sequence.h"
 #include "string.h"
 #include "util.h"
@@ -75,7 +75,7 @@ EXPORTED struct seqset *seqset_init(unsi
     /* make sure flags are sane - be explicit about what
      * sort of list we're building */
     if (flags != SEQ_SPARSE && flags != SEQ_MERGE)
-        fatal("invalid flags", EC_SOFTWARE);
+        fatal("invalid flags", EX_SOFTWARE);
 
     seq->maxval = maxval;
     seq->flags = flags;
@@ -92,8 +92,14 @@ EXPORTED void seqset_add(struct seqset *
 {
     if (!seq) return;
 
+    /* there are some cases where we want to make sure something is added
+     * as an initial value and then re-add it again later, so if we get
+     * the same number multiple times, that's OK */
+    if (ismember && num == seq->prev && seq->len && seq->set[seq->len-1].high == num)
+        return;
+
     if (num <= seq->prev)
-        fatal("numbers out of order", EC_SOFTWARE);
+        fatal("numbers out of order", EX_SOFTWARE);
 
     if (!ismember) {
         seq->prev = num;
@@ -159,46 +165,43 @@ EXPORTED unsigned int seq_lastnum(const
 
 /* Comparator function that sorts ranges by the low value,
    and coalesces intersecting ranges to have the same high value */
-static int comp_coalesce(const void *v1, const void *v2)
+static int comp_rangesort(const void *v1, const void *v2)
 {
     struct seq_range *r1 = (struct seq_range *) v1;
     struct seq_range *r2 = (struct seq_range *) v2;
 
-    /* If ranges don't intersect, we're done */
-    if (r1->high < r2->low) return -1;
-    if (r1->low > r2->high) return 1;
-
-    /* Ranges intersect, coalesce them */
-    r1->high = r2->high = MAX(r1->high, r2->high);
-
-    return r1->low - r2->low;;
+    int ret = r1->low - r2->low;
+    if (ret) return ret;
+    return r1->high - r2->high;
 }
 
-static void seqset_simplify(struct seqset *set)
+static void seqset_simplify(struct seqset *seq)
 {
-    int out = 0;
+    unsigned out = 0;
     unsigned i;
 
     /* nothing to simplify */
-    if (!set->len)
+    if (!seq->len)
         return;
 
     /* Sort the ranges using our special comparator */
-    qsort(set->set, set->len, sizeof(struct seq_range), comp_coalesce);
+    qsort(seq->set, seq->len, sizeof(struct seq_range), comp_rangesort);
 
     /* Merge intersecting/adjacent ranges */
-    for (i = 1; i < set->len; i++) {
-        if ((int)(set->set[i].low - set->set[out].high) <= 1) {
-            set->set[out].high = set->set[i].high;
-        } else {
+    for (i = 1; i < seq->len; i++) {
+        if (seq->set[out].high + 1 < seq->set[i].low) {
+            /* these are disjoint */
             out++;
-            set->set[out].low = set->set[i].low;
-            set->set[out].high = set->set[i].high;
+            if (out != i)
+                seq->set[out] = seq->set[i];
+        }
+        else if (seq->set[out].high < seq->set[i].high) {
+            seq->set[out].high = seq->set[i].high;
         }
     }
 
     /* final length */
-    set->len = out+1;
+    seq->len = out+1;
 }
 
 static int read_num(const char **input, unsigned maxval, unsigned *res)
@@ -241,11 +244,11 @@ EXPORTED struct seqset *seqset_parse(con
 
     while (*sequence) {
         if (read_num(&sequence, maxval, &start))
-            fatal("invalid sequence", EC_SOFTWARE);
+            fatal("invalid sequence", EX_SOFTWARE);
         if (*sequence == ':') {
             sequence++;
             if (read_num(&sequence, maxval, &end))
-                fatal("invalid sequence", EC_SOFTWARE);
+                fatal("invalid sequence", EX_SOFTWARE);
         }
         else
             end = start;
@@ -350,6 +353,7 @@ EXPORTED unsigned seqset_last(const stru
  * the first element */
 EXPORTED unsigned seqset_firstnonmember(const struct seqset *seq)
 {
+    if (!seq) return 1;
     if (!seq->len) return 1;
     if (seq->set[0].low != 1) return 1;
     return seq->set[0].high + 1;
diff -pruN 3.0.13-5/imap/setproctitle.c 3.2.0-3/imap/setproctitle.c
--- 3.0.13-5/imap/setproctitle.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/setproctitle.c	2020-04-24 02:03:00.000000000 +0000
@@ -209,6 +209,7 @@ typedef unsigned int    *pt_entry_t;
 
 /*VARARGS1*/
 HIDDEN void
+__attribute__((format(printf, 1, 2)))
 #if SPT_TYPE != SPT_NONE
 setproctitle(const char *fmt, ...)
 #else
diff -pruN 3.0.13-5/imap/smmapd.c 3.2.0-3/imap/smmapd.c
--- 3.0.13-5/imap/smmapd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/smmapd.c	2020-05-04 03:28:02.000000000 +0000
@@ -81,18 +81,17 @@
 #endif
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 
 #include "acl.h"
 #include "append.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "mboxlist.h"
 #include "mupdate-client.h"
 #include "proc.h"
 #include "quota.h"
-#include "sync_log.h"
 #include "util.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -147,14 +146,6 @@ void shut_down(int code)
 
     smmapd_reset();
 
-    sync_log_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
     cyrus_done();
     exit(code);
 }
@@ -181,7 +172,7 @@ int service_init(int argc, char **argv,
 {
     int r;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
 
     setproctitle_init(argc, argv, envp);
 
@@ -191,21 +182,10 @@ int service_init(int argc, char **argv,
     BB = config_getstring(IMAPOPT_POSTUSER);
     forcedowncase = config_getswitch(IMAPOPT_LMTP_DOWNCASE_RCPT);
 
-    /* so we can do mboxlist operations */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* so we can check the quotas */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* so we can log sync information on closing mailboxes */
-    sync_log_init();
-
     /* Set namespace */
     if ((r = mboxname_init_namespace(&map_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     return 0;
@@ -305,7 +285,7 @@ static int verify_user(const char *key,
 
         /* proxy the request to the real backend server to
          * check the quota.  if this fails, just return 0
-         * (asuume under quota)
+         * (assume under quota)
          */
 
         syslog(LOG_ERR, "verify_user(%s) proxying to host %s",
diff -pruN 3.0.13-5/imap/smtpclient.c 3.2.0-3/imap/smtpclient.c
--- 3.0.13-5/imap/smtpclient.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/smtpclient.c	2020-04-24 02:03:00.000000000 +0000
@@ -40,6 +40,7 @@
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+#include <assert.h>
 #include <config.h>
 
 #ifdef HAVE_UNISTD_H
@@ -48,78 +49,942 @@
 #include <stdio.h>
 #include <sys/types.h>
 #include <sys/wait.h>
+#include <sysexits.h>
+#include <syslog.h>
 
+#include "backend.h"
 #include "xmalloc.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "smtpclient.h"
+#include "telemetry.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
 
-EXPORTED pid_t open_sendmail(const char *argv[], FILE **sm)
+typedef struct {
+    char code[3];
+    struct buf text; /* Zero-terminated reply text, excluding CRLF. OK to overwrite. */
+    int is_last;
+} smtp_resp_t;
+
+struct smtpclient {
+    /* SMTP backend. Client implementations can store
+     * their context data in backend->context. */
+    struct backend *backend;
+
+    /* Client implementations can free their context
+     * stored in backend->context. */
+    int (*free_context)(void *ctx);
+
+    /* Telemetry log */
+    int logfd;
+
+    /* Internal state */
+    hash_table *have_exts;
+    struct buf buf;
+    char *authid;
+    char *notify;
+    char *ret;
+    char *by;
+    unsigned long msgsize;
+    smtp_resp_t resp;
+};
+
+enum {
+    SMTPCLIENT_CAPA_DSN       = (1 << 3),
+    SMTPCLIENT_CAPA_DELIVERBY = (1 << 4),
+    SMTPCLIENT_CAPA_SIZE      = (1 << 5),
+    SMTPCLIENT_CAPA_STATUS    = (1 << 6),
+    SMTPCLIENT_CAPA_FUTURE    = (1 << 7),
+    SMTPCLIENT_CAPA_PRIORITY  = (1 << 8),
+    SMTPCLIENT_CAPA_SENDCHECK = (1 << 9)
+};
+
+static struct protocol_t smtp_protocol =
+{ "smtp", "smtp", TYPE_STD,
+  { { { 0, "220 " },
+      { "EHLO", "localhost", "250 ", NULL,
+        CAPAF_ONE_PER_LINE|CAPAF_SKIP_FIRST_WORD|CAPAF_DASH_STUFFING,
+        { { "AUTH", CAPA_AUTH },
+          { "STARTTLS", CAPA_STARTTLS },
+          { "DSN", SMTPCLIENT_CAPA_DSN },
+          { "DELIVERYBY", SMTPCLIENT_CAPA_DELIVERBY },
+          { "SIZE", SMTPCLIENT_CAPA_SIZE },
+          { "ENHANCEDSTATUSCODES", SMTPCLIENT_CAPA_STATUS },
+          { "FUTURERELEASE", SMTPCLIENT_CAPA_FUTURE },
+          { "MT-PRIORITY", SMTPCLIENT_CAPA_PRIORITY },
+          { "SENDCHECK", SMTPCLIENT_CAPA_SENDCHECK },
+          { NULL, 0 } } },
+      { "STARTTLS", "220", "454", 0 },
+      { "AUTH", 512, 0, "235", "5", "334 ", "*", NULL, 0 },
+      { NULL, NULL, NULL },
+      { "NOOP", NULL, "250" },
+      { "QUIT", NULL, "221" } } }
+};
+
+
+/* SMTP protocol implementation */
+
+typedef int smtp_readcb_t(smtpclient_t *sm, void *rock);
+
+static int smtpclient_read(smtpclient_t *sm, smtp_readcb_t *cb, void *rock);
+
+static int smtpclient_writebuf(smtpclient_t *sm, struct buf *buf, int flush);
+static int smtpclient_ehlo(smtpclient_t *sm);
+static int smtpclient_rset(smtpclient_t *sm);
+static int smtpclient_quit(smtpclient_t *sm);
+static int smtpclient_from(smtpclient_t *sm, smtp_addr_t *addr);
+static int smtpclient_rcpt_to(smtpclient_t *sm, ptrarray_t *rcpt);
+static int smtpclient_data(smtpclient_t *sm, struct protstream *data);
+static void smtpclient_logerror(smtpclient_t *sm, const char *cmd, int r);
+
+EXPORTED int smtpclient_open(smtpclient_t **smp)
 {
-    int fds[2];
-    FILE *ret;
-    pid_t p;
+    int r = 0;
+    const char *backend = config_getstring(IMAPOPT_SMTP_BACKEND);
 
-    if (pipe(fds)) {
-        printf("451 lmtpd: didn't start pipe()?!?\r\n");
-        fatal("couldn't start pipe()", EC_OSERR);
+    if (!strcmp(backend, "sendmail")) {
+        r = smtpclient_open_sendmail(smp);
+    }
+    else if (!strcmp(backend, "host")) {
+        r = smtpclient_open_host(config_getstring(IMAPOPT_SMTP_HOST), smp);
     }
-    if ((p = fork()) == 0) {
-        /* i'm the child! run sendmail! */
-        close(fds[1]);
-        /* make the pipe be stdin */
-        dup2(fds[0], 0);
-        execv(config_getstring(IMAPOPT_SENDMAIL), (char **) argv);
+    else {
+        syslog(LOG_ERR, "smtpclient_open: unknown backend: %s", backend);
+        r = IMAP_INTERNAL;
+    }
+    return r;
+}
 
-        /* if we're here we suck */
-        printf("451 lmtpd: didn't exec() sendmail?!?\r\n");
-        exit(EXIT_FAILURE);
+EXPORTED int smtpclient_close(smtpclient_t **smp)
+{
+    if (!smp || !*smp) {
+        return 0;
     }
 
-    if (p < 0) {
-        /* failure */
-        *sm = NULL;
-        return p;
+    int r = 0;
+    smtpclient_t *sm = *smp;
+
+    /* Close backend */
+    backend_disconnect(sm->backend);
+    if (sm->free_context) {
+        r = sm->free_context(sm->backend->context);
     }
+    free(sm->backend);
+    sm->backend = NULL;
 
-    /* parent */
-    close(fds[0]);
-    ret = fdopen(fds[1], "w");
-    *sm = ret;
+    /* Close log */
+    if (sm->logfd != -1) {
+        close(sm->logfd);
+    }
+    sm->logfd = -1;
 
-    return p;
+    /* Free internal state */
+    if (sm->have_exts) {
+        free_hash_table(sm->have_exts, free);
+        free(sm->have_exts);
+        sm->have_exts = NULL;
+    }
+    buf_free(&sm->buf);
+    free(sm->by);
+    free(sm->ret);
+    free(sm->notify);
+    free(sm->authid);
+    buf_free(&sm->resp.text);
+
+    free(sm);
+    *smp = NULL;
+    return r;
 }
 
-/* sendmail_errstr.  create a descriptive message given 'sm_stat':
-   the exit code from wait() from sendmail.
+/* Match the response code to an expected return code defined in rock.
+ *
+ * rock->code must be a zero-terminated string up to length 3 (excluding the
+ * NUL byte). Matching is performed by string matching the SMTP return
+ * code to the expected code, stopping at the zero byte.
+ *
+ * E.g. return code "250", "251" both would match a "2" or "25" rock->code.
+ *
+ * Also see Daniel Bernstein's site https://cr.yp.to/smtp/request.html:
+ * "I recommend that clients avoid looking past the first digit of the
+ * code, either 2, 3, 4, or 5. The other two digits and the text are
+ * primarily for human consumption. (Exception: See EHLO.)"
+ *
+ * Return IMAP_PROTOCOL_ERROR on mismatch, 0 on success.
+ *
+ * rock->cmd should describe the command whose response you're checking.
+ * If set, it'll be included in the error log on mismatch.
+ *
+ */
+struct expect_code_rock {
+    const char *cmd;
+    const char *code;
+};
 
-   not thread safe, but probably ok */
-EXPORTED char *sendmail_errstr(int sm_stat)
+static int expect_code_cb(smtpclient_t *sm, void *rock)
 {
-    static char errstr[200];
+    size_t i;
+    const struct expect_code_rock *ecrock = (const struct expect_code_rock *) rock;
+    smtp_resp_t *resp = &sm->resp;
+
+    for (i = 0; i < 3 && ecrock->code[i]; i++) {
+        if (ecrock->code[i] != resp->code[i]) {
+            const char *text = buf_cstring(&resp->text);
+
+            syslog(LOG_ERR, "smtpclient: unexpected response%s%s: code=%c%c%c text=%s",
+                   ecrock->cmd ? " to " : "",
+                   ecrock->cmd ? ecrock->cmd : "",
+                   resp->code[0], resp->code[1], resp->code[2], text);
+
+            /* Try to glean specific error from response */
+            if (CAPA(sm->backend, SMTPCLIENT_CAPA_STATUS)) {
+                if (text[2] == '1' && text[4] >= '1' && text[4] <= '3')
+                    return IMAP_MAILBOX_NONEXISTENT;
+                else if (text[2] == '3' && text[4] == '4')
+                    return IMAP_MESSAGE_TOO_LARGE;
+                else if (text[2] == '5' && text[4] == '3')
+                    return IMAP_MAILBOX_DISABLED;
+                else if (text[2] == '3' && text[4] == '0')
+                    return IMAP_REMOTE_DENIED;
+            }
+            else {
+                switch (atoi(resp->code)) {
+                case 421:
+                case 451:
+                case 554:
+                    return IMAP_REMOTE_DENIED;
+                case 450:
+                case 550:
+                    return IMAP_MAILBOX_DISABLED;
+                case 452:
+                case 552:
+                    return IMAP_MESSAGE_TOO_LARGE;
+                case 553:
+                    return IMAP_MAILBOX_NONEXISTENT;
+                }
+            }
 
-    if (WIFEXITED(sm_stat)) {
-        snprintf(errstr, sizeof errstr,
-                 "Sendmail process terminated normally, exit status %d\n",
-                 WEXITSTATUS(sm_stat));
-    } else if (WIFSIGNALED(sm_stat)) {
-        snprintf(errstr, sizeof errstr,
-                "Sendmail process terminated abnormally, signal = %d %s\n",
-                WTERMSIG(sm_stat),
-#ifdef WCOREDUMP
-                WCOREDUMP(sm_stat) ? " -- core file generated" :
-#endif
-                "");
-    } else if (WIFSTOPPED(sm_stat)) {
-        snprintf(errstr, sizeof errstr,
-                 "Sendmail process stopped, signal = %d\n",
-                WTERMSIG(sm_stat));
+            return IMAP_PROTOCOL_ERROR;
+        }
+    }
+    return 0;
+}
+
+static int smtpclient_read(smtpclient_t *sm, smtp_readcb_t *cb, void *rock)
+{
+    char buf[513]; /* Maximum length of reply line, see RFC 5321, 4.5.3.1.5. */
+    int r = IMAP_IOERROR;
+
+    do {
+        /* Read next reply line. */
+        if (!prot_fgets(buf, 513, sm->backend->in)) {
+            r = IMAP_IOERROR;
+            return r;
+        }
+        buf[512] = '\0';
+
+        /* Parse reply line. */
+        if (!isdigit(buf[0]) || !isdigit(buf[1]) || !isdigit(buf[2])) {
+            return IMAP_PROTOCOL_ERROR;
+        }
+        if (buf[3] != '-' && !isspace(buf[3])) {
+            return IMAP_PROTOCOL_ERROR;
+        }
+        char *p = memchr(buf + 4, '\n', 508);
+        if (p == NULL) {
+            return IMAP_PROTOCOL_ERROR;
+        }
+        if (*(p-1) == '\r') {
+            --p;
+        }
+        *p = '\0';
+
+        /* Call callback. */
+        memcpy(sm->resp.code, buf, 3);
+        buf_setcstr(&sm->resp.text, buf + 4);
+        sm->resp.is_last = isspace(buf[3]);
+        r = cb(sm, rock);
+    } while (!r && !sm->resp.is_last);
+
+    return r;
+}
+
+static int ehlo_cb(smtpclient_t *sm, void *rock __attribute__((unused)))
+{
+    smtp_resp_t *resp = &sm->resp;
+
+    /* Is this the first response line? */
+    if (sm->have_exts == NULL) {
+        sm->have_exts = xzmalloc(sizeof(struct hash_table));
+        construct_hash_table(sm->have_exts, 16, 0);
+        return 0;
+    }
+
+    /* Add the extension */
+    const char *p = buf_cstring(&resp->text);
+    while (*p && !isspace(*p)) {
+        p++;
+    }
+    const char *args = isspace(*p) ? p + 1 : "";
+    buf_truncate(&resp->text, p - buf_base(&resp->text));
+    hash_insert(buf_cstring(&resp->text), xstrdup(args), sm->have_exts);
+
+    return 0;
+}
+
+static int smtpclient_writebuf(smtpclient_t *sm, struct buf *buf, int flush)
+{
+    if (prot_putbuf(sm->backend->out, buf)) {
+        return IMAP_IOERROR;
+    }
+    if (flush && prot_flush(sm->backend->out)) {
+        return IMAP_IOERROR;
+    }
+    return 0;
+}
+
+static void smtpclient_logerror(smtpclient_t *sm, const char *cmd, int r)
+{
+    if (r == IMAP_IOERROR) {
+        /* try to dig a more specific error out of the prot streams */
+        const char *errstr = prot_error(sm->backend->out);
+        if (!errstr) errstr = prot_error(sm->backend->in);
+        if (!errstr) errstr = error_message(r);
+        syslog(LOG_ERR, "smtpclient: %s during %s", errstr, cmd);
+    }
+    else {
+        syslog(LOG_ERR, "smtpclient: %s during %s", error_message(r), cmd);
+    }
+}
+
+static int smtpclient_ehlo(smtpclient_t *sm)
+{
+    int r = 0;
+
+    /* Say EHLO */
+    buf_setcstr(&sm->buf, "EHLO localhost\r\n");
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+
+    /* Process response */
+    r = smtpclient_read(sm, ehlo_cb, NULL);
+
+done:
+    if (r) smtpclient_logerror(sm, "EHLO", r);
+    return r;
+}
+
+static int smtpclient_rset(smtpclient_t *sm)
+{
+    int r = 0;
+
+    /* Say RSET */
+    buf_setcstr(&sm->buf, "RSET\r\n");
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+
+    /* Process response */
+    struct expect_code_rock rock = { "RSET", "2" };
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+
+done:
+    if (r) smtpclient_logerror(sm, "RSET", r);
+    return r;
+}
+
+static int smtpclient_schk(smtpclient_t *sm)
+{
+    int r = 0;
+
+    /* Say SCHK */
+    buf_setcstr(&sm->buf, "SCHK\r\n");
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+
+    /* Process response */
+    struct expect_code_rock rock = { "SCHK", "2" };
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+
+done:
+    if (r) smtpclient_logerror(sm, "SCHK", r);
+    return r;
+}
+
+__attribute__((unused)) static int smtpclient_quit(smtpclient_t *sm)
+{
+    int r = 0;
+
+    /* Say QUIT */
+    buf_setcstr(&sm->buf, "QUIT\r\n");
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+
+    /* Don't insist on an answer */
+    struct expect_code_rock rock = { "QUIT", "2" };
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+    if (r) {
+        syslog(LOG_INFO, "smtpclient: QUIT without reply: %s", error_message(r));
+        return r;
+    }
+
+done:
+    if (r) smtpclient_logerror(sm, "QUIT", r);
+    return r;
+}
+
+static int write_addr(smtpclient_t *sm,
+                      const char *cmd,
+                      const smtp_addr_t *addr,
+                      const ptrarray_t *extra_params)
+{
+    int i, r = 0;
+
+    buf_reset(&sm->buf);
+    buf_printf(&sm->buf, "%s:<%s>", cmd, addr->addr);
+    for (i = 0; i < addr->params.count; i++) {
+        smtp_param_t *param = ptrarray_nth(&addr->params, i);
+        buf_appendcstr(&sm->buf, " ");
+        buf_appendcstr(&sm->buf, param->key);
+        if (!param->val) {
+            continue;
+        }
+        buf_appendcstr(&sm->buf, "=");
+        buf_appendcstr(&sm->buf, param->val);
+    }
+    for (i = 0; i < extra_params->count; i++) {
+        smtp_param_t *param = ptrarray_nth(extra_params, i);
+        buf_appendcstr(&sm->buf, " ");
+        buf_appendcstr(&sm->buf, param->key);
+        if (!param->val) {
+            continue;
+        }
+        buf_appendcstr(&sm->buf, "=");
+        buf_appendcstr(&sm->buf, param->val);
+    }
+    buf_appendcstr(&sm->buf, "\r\n");
+
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+
+    struct expect_code_rock rock = { cmd, "2" };
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+    if (r) goto done;
+
+done:
+    if (r) smtpclient_logerror(sm, cmd, r);
+    buf_reset(&sm->buf);
+    return r;
+}
+
+/* Add key/value to extra, if it isn't defined in params */
+static void smtp_params_set_extra(ptrarray_t *params, ptrarray_t *extra,
+                                  const char *key, const char *val)
+{
+    int i;
+    for (i = 0; i < params->count; i++) {
+        smtp_param_t *param = ptrarray_nth(params, i);
+        if (!strcasecmp(param->key, key)) {
+            break;
+        }
+    }
+    if (i == params->count) {
+        smtp_param_t *param = xzmalloc(sizeof(smtp_param_t));
+        param->key = xstrdup(key);
+        param->val = xstrdup(val);
+        ptrarray_add(extra, param);
+    }
+}
+
+static void smtp_params_fini(ptrarray_t *params)
+{
+    int i;
+    for (i = 0; i < params->count; i++) {
+        smtp_param_t *param = ptrarray_nth(params, i);
+        free(param->key);
+        free(param->val);
+        free(param);
+    }
+    ptrarray_fini(params);
+}
+
+/* Write a MAIL FROM command for address addr. */
+static int smtpclient_from(smtpclient_t *sm, smtp_addr_t *addr)
+{
+    ptrarray_t extra_params = PTRARRAY_INITIALIZER;
+    if (sm->authid && CAPA(sm->backend, CAPA_AUTH)) {
+        smtp_params_set_extra(&addr->params, &extra_params, "AUTH", sm->authid);
+    }
+    if (sm->ret && CAPA(sm->backend, SMTPCLIENT_CAPA_DSN)) {
+        smtp_params_set_extra(&addr->params, &extra_params, "RET", sm->ret);
+    }
+    if (sm->by && CAPA(sm->backend, SMTPCLIENT_CAPA_DELIVERBY)) {
+        smtp_params_set_extra(&addr->params, &extra_params, "BY", sm->by);
+    }
+    if (sm->msgsize && CAPA(sm->backend, SMTPCLIENT_CAPA_SIZE)) {
+        char szbuf[21];
+        snprintf(szbuf, sizeof(szbuf), "%lu", sm->msgsize);
+        smtp_params_set_extra(&addr->params, &extra_params, "SIZE", szbuf);
+    }
+    int r = write_addr(sm, "MAIL FROM", addr, &extra_params);
+    if (r) smtpclient_logerror(sm, "MAIL FROM", r);
+    smtp_params_fini(&extra_params);
+    return r;
+}
+
+/* Write a RCPT TO command for all addresses in rcpt. */
+static int smtpclient_rcpt_to(smtpclient_t *sm, ptrarray_t *rcpts)
+{
+    int i, r = 0;
+
+    for (i = 0; i < rcpts->count; i++) {
+        smtp_addr_t *addr = ptrarray_nth(rcpts, i);
+        ptrarray_t extra_params = PTRARRAY_INITIALIZER;
+        if (sm->notify && CAPA(sm->backend, SMTPCLIENT_CAPA_DSN)) {
+            smtp_params_set_extra(&addr->params, &extra_params, "NOTIFY", sm->notify);
+        }
+        int r1 = write_addr(sm, "RCPT TO", addr, &extra_params);
+        smtp_params_fini(&extra_params);
+        if (!r1) addr->completed = 1;
+        else if (!r) r = r1;
+    }
+
+    if (r) smtpclient_logerror(sm, "RCPT TO", r);
+    return r;
+}
+
+/* Write a DATA command using data as input. Data is dot-escaped
+ * before it is written to the SMTP backend. */
+static int smtpclient_data(smtpclient_t *sm, struct protstream *data)
+{
+    int r = 0;
+
+    /* Write DATA */
+    buf_setcstr(&sm->buf, "DATA\r\n");
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+
+    /* Expect Start Input */
+    struct expect_code_rock rock = { "DATA", "3" };
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+    if (r) goto done;
+
+    /* Write message, escaping dot characters. */
+    buf_ensure(&sm->buf, 4096);
+    int c;
+    int prev1 = 256, prev2 = 256;
+    int at_start = 1;
+    const char *eot = "\r\n.\r\n";
+    while ((c = prot_getc(data)) != EOF) {
+        if (c == '.' && at_start) {
+            prot_ungetc(c, data);
+            c = '.';
+        }
+        at_start = 0;
+        sm->buf.s[sm->buf.len++] = (unsigned char) c;
+        if (sm->buf.len == 4096) {
+            r = smtpclient_writebuf(sm, &sm->buf, 0);
+            if (r) goto done;
+            buf_reset(&sm->buf);
+        }
+        if (c == '\n') {
+            at_start = 1;
+        }
+        prev2 = prev1;
+        prev1 = c;
+    }
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+    /* If message ends with CRLF, omit pre-dot CRLF. */
+    if (prev2 == '\r' && prev1 == '\n')
+        eot = ".\r\n";
+
+    /* Write end-of-text. */
+    buf_setcstr(&sm->buf, eot);
+    r = smtpclient_writebuf(sm, &sm->buf, 1);
+    if (r) goto done;
+    buf_reset(&sm->buf);
+
+    /* Expect OK */
+    rock.cmd = "EOT";
+    rock.code = "2";
+    r = smtpclient_read(sm, expect_code_cb, &rock);
+    if (r) goto done;
+
+done:
+    if (r) smtpclient_logerror(sm, "DATA", r);
+    return r;
+}
+
+static int validate_envelope_params(ptrarray_t *params)
+{
+    if (!params) return 0;
+
+    int i;
+    for (i = 0; i < ptrarray_size(params); i++) {
+        smtp_param_t *param = ptrarray_nth(params, i);
+        if (!smtp_is_valid_esmtp_keyword(param->key)) {
+            syslog(LOG_ERR, "smtpclient: invalid estmp keyword: \"%s\"", param->key);
+            return IMAP_PROTOCOL_ERROR;
+        }
+        if (!strcasecmp(param->key, "AUTH")) {
+            syslog(LOG_ERR, "smptclient: rejecting AUTH parameter in envelope");
+            return IMAP_PERMISSION_DENIED;
+        }
+        if (param->val && !smtp_is_valid_esmtp_value(param->val)) {
+            syslog(LOG_ERR, "smtpclient: invalid estmp value: \"%s\"", param->val);
+            return IMAP_PROTOCOL_ERROR;
+        }
+    }
+
+    return 0;
+}
+
+static int validate_envelope(smtp_envelope_t *env)
+{
+    int i, r;
+
+    if (!env->from.addr) {
+        syslog(LOG_ERR, "smtpclient: envelope missing sender");
+        return IMAP_PROTOCOL_ERROR;
+    }
+    r = validate_envelope_params(&env->from.params);
+    if (r) return r;
+
+    if (!env->rcpts.count) {
+        syslog(LOG_ERR, "smtpclient: envelope missing recipients");
+        return IMAP_PROTOCOL_ERROR;
+    }
+    for (i = 0; i < env->rcpts.count; i++) {
+        smtp_addr_t *addr = ptrarray_nth(&env->rcpts, i);
+        if (!addr->addr) {
+            syslog(LOG_ERR, "smtpclient: invalid recipient at position %d", i);
+            return IMAP_PROTOCOL_ERROR;
+        }
+        r = validate_envelope_params(&addr->params);
+        if (r) return r;
+    }
+
+    return 0;
+}
+
+EXPORTED int smtpclient_sendprot(smtpclient_t *sm, smtp_envelope_t *env, struct protstream *data)
+{
+    int r = 0;
+
+    if (sm->msgsize) {
+        unsigned long maxsize = smtpclient_get_maxsize(sm);
+
+        if (maxsize && maxsize < sm->msgsize) {
+            r = IMAP_MESSAGE_TOO_LARGE;
+            goto done;
+        }
+    }
+
+    r = validate_envelope(env);
+    if (r) goto done;
+
+    r = smtpclient_from(sm, &env->from);
+    if (r) goto done;
+
+    r = smtpclient_rcpt_to(sm, &env->rcpts);
+    if (r) goto done;
+
+    if (data) {
+        r = smtpclient_data(sm, data);
+        if (r) goto done;
+    }
+    else {
+        /* simply pre-flighting the envelope */
+        if (CAPA(sm->backend, SMTPCLIENT_CAPA_SENDCHECK)) {
+            r = smtpclient_schk(sm);
+        }
+        else {
+            r = smtpclient_rset(sm);
+        }
+        if (r) goto done;
+    }
+
+done:
+    return r;
+}
+
+EXPORTED int smtpclient_send(smtpclient_t *sm, smtp_envelope_t *env, struct buf *data)
+{
+    struct protstream *p = prot_readmap(buf_base(data), buf_len(data));
+    smtpclient_set_size(sm, buf_len(data));
+    int r = smtpclient_sendprot(sm, env, p);
+    prot_free(p);
+    return r;
+}
+
+EXPORTED void smtpclient_set_auth(smtpclient_t *sm, const char *authid)
+{
+    free(sm->authid);
+    sm->authid = xstrdupnull(authid);
+}
+
+EXPORTED void smtpclient_set_notify(smtpclient_t *sm, const char *value)
+{
+    free(sm->notify);
+    sm->notify = xstrdupnull(value);
+}
+
+EXPORTED void smtpclient_set_ret(smtpclient_t *sm, const char *value)
+{
+    free(sm->ret);
+    sm->ret = xstrdupnull(value);
+}
+
+EXPORTED void smtpclient_set_by(smtpclient_t *sm, const char *value)
+{
+    free(sm->by);
+    sm->by = xstrdupnull(value);
+}
+
+EXPORTED void smtpclient_set_size(smtpclient_t *sm, unsigned long value)
+{
+    sm->msgsize = value;
+}
+
+EXPORTED unsigned long smtpclient_get_maxsize(smtpclient_t *sm)
+{
+    unsigned long maxsize = 0;
+
+    if (CAPA(sm->backend, SMTPCLIENT_CAPA_SIZE)) {
+        const char *sizestr = smtpclient_has_ext(sm, "SIZE");
+        if (sizestr) maxsize = strtoul(sizestr, NULL, 10);
+    }
+
+    return maxsize;
+}
+
+EXPORTED const char *smtpclient_get_resp_text(smtpclient_t *sm)
+{
+    return buf_cstring(&sm->resp.text);
+}
+
+/* SMTP backend implementations */
+
+static int smtpclient_new(smtpclient_t **smp,
+                          struct backend *backend,
+                          int (*freectx)(void *), int logfd)
+{
+    smtpclient_t *sm = xzmalloc(sizeof(smtpclient_t));
+    sm->backend = backend;
+    sm->free_context = freectx;
+    sm->logfd = logfd;
+    *smp = sm;
+    return 0;
+}
+
+EXPORTED const char *smtpclient_has_ext(smtpclient_t *sm, const char *name)
+{
+    if (!sm->have_exts) {
+        int r = smtpclient_ehlo(sm);
+        if (r) {
+            syslog(LOG_ERR, "smtpclient: can't EHLO for extensions: %s",
+                    error_message(r));
+            return NULL;
+        }
+    }
+    return hash_lookup(name, sm->have_exts);
+}
+
+/* TCP host backend */
+
+typedef struct {
+    int sockfd;
+} smtpclient_host_t;
+
+EXPORTED int smtpclient_open_host(const char *addr, smtpclient_t **smp)
+{
+    struct backend *bk = NULL;
+    int r = 0;
+    char *myaddr = NULL;
+    int logfd = -1;
+
+    /* Setup SASL for authentication, if any */
+    sasl_callback_t *sasl_cb = NULL;
+    if (config_getstring(IMAPOPT_SMTP_AUTH_AUTHNAME)) {
+        sasl_cb = mysasl_callbacks(NULL /*userid*/,
+                config_getstring(IMAPOPT_SMTP_AUTH_AUTHNAME),
+                config_getstring(IMAPOPT_SMTP_AUTH_REALM),
+                config_getstring(IMAPOPT_SMTP_AUTH_PASSWORD));
     } else {
-        return NULL;
+        myaddr = strconcat(addr, "/noauth", NULL);
+    }
+
+    logfd = telemetry_log("smtpclient.host", NULL, NULL, 0);
+
+    /* Connect to backend */
+    const char *host = myaddr ? myaddr : addr;
+    syslog(LOG_DEBUG, "smtpclient_open: connecting to host: %s", host);
+    bk = backend_connect(NULL, host, &smtp_protocol, NULL, sasl_cb, NULL, logfd);
+    if (sasl_cb) free_callbacks(sasl_cb);
+    if (!bk) {
+        syslog(LOG_ERR, "smptclient_open: can't connect to host: %s", host);
+        if (logfd != -1) close(logfd);
+        r = IMAP_INTERNAL;
+        goto done;
+    }
+    r = smtpclient_new(smp, bk, /*freectx*/NULL, logfd);
+
+done:
+    free(myaddr);
+    return r;
+}
+
+EXPORTED int smtp_is_valid_esmtp_keyword(const char *val)
+{
+    if (!isascii(*val) || !isalnum(*val)) {
+        return 0;
+    }
+    for (val = val + 1; *val; val++) {
+        if (!isascii(*val) || (*val != '-' && !isalnum(*val))) {
+            return 0;
+        }
+    }
+    return 1;
+}
+
+EXPORTED int smtp_is_valid_esmtp_value(const char *val)
+{
+    if (*val == '\0') return 0;
+    for ( ; *val; val++) {
+        if (*val == '=' || *val < '!' || *val > '~') {
+            return 0;
+        }
+    }
+    return 1;
+}
+
+
+EXPORTED smtp_addr_t *smtp_envelope_set_from(smtp_envelope_t *env, const char *addr)
+{
+    smtp_params_fini(&env->from.params);
+    free(env->from.addr);
+    env->from.addr = xstrdup(addr);
+    return &env->from;
+}
+
+EXPORTED smtp_addr_t *smtp_envelope_add_rcpt(smtp_envelope_t *env, const char *addr)
+{
+    smtp_addr_t *rcpt = xzmalloc(sizeof(smtp_addr_t));
+    rcpt->addr = xstrdup(addr);
+    ptrarray_append(&env->rcpts, rcpt);
+    return rcpt;
+}
+
+EXPORTED void smtp_envelope_fini(smtp_envelope_t *env)
+{
+    smtp_params_fini(&env->from.params);
+    free(env->from.addr);
+
+    smtp_addr_t *a;
+    while ((a = ptrarray_pop(&env->rcpts))) {
+        smtp_params_fini(&a->params);
+        free(a->addr);
+        free(a);
+    }
+    ptrarray_fini(&env->rcpts);
+}
+
+/* Sendmail process backend */
+
+typedef struct {
+    int infd;
+    int outfd;
+    pid_t pid;
+} smtpclient_sendmail_ctx_t;
+
+static int smtpclient_sendmail_freectx(smtpclient_sendmail_ctx_t *ctx)
+{
+    if (!ctx) return 0;
+
+    if (ctx->pid && waitpid(ctx->pid, NULL, 0) < 0) {
+        syslog(LOG_ERR, "waitpid(): %m");
+    }
+
+    if (ctx->infd >= 0)
+        close(ctx->infd);
+
+    if (ctx->outfd >= 0)
+        close(ctx->outfd);
+
+    free(ctx);
+    return 0;
+}
+
+EXPORTED int smtpclient_open_sendmail(smtpclient_t **smp)
+{
+    struct backend *bk = NULL;
+    int r = 0;
+    int p_child[2];
+    int p_parent[2];
+    int logfd = -1;
+
+    /* Create the pipes and fork */
+    r = pipe(p_child);
+    if (!r) {
+        r = pipe(p_parent);
+    }
+    if (r < 0) {
+        syslog(LOG_ERR, "smtpclient_open: can't create pipe: %m");
+        r = IMAP_SYS_ERROR;
+        goto done;
+    }
+    pid_t pid = fork();
+    if (pid < 0) {
+        syslog(LOG_ERR, "smtpclient_open: can't fork: %m");
+        r = IMAP_SYS_ERROR;
+        goto done;
+    }
+
+    if (pid == 0) {
+        /* child process */
+        close(p_child[1]);
+        dup2(p_child[0], STDIN_FILENO);
+        close(p_child[0]);
+
+        close(p_parent[0]);
+        dup2(p_parent[1], STDOUT_FILENO);
+        close(p_parent[1]);
+
+        execl(config_getstring(IMAPOPT_SENDMAIL), "sendmail", "-bs", (char *)NULL);
+        syslog(LOG_ERR, "smtpclient_open: can't exec sendmail: %m");
+        exit(1);
+    }
+
+    /* parent process */
+    close(p_child[0]);
+    p_child[0] = -1;
+    close(p_parent[1]);
+    p_parent[1] = -1;
+
+    smtpclient_sendmail_ctx_t *ctx = xmalloc(sizeof(smtpclient_sendmail_ctx_t));
+    ctx->infd  = p_parent[0]; /* reader */
+    ctx->outfd = p_child[1];  /* writer */
+    ctx->pid   = pid;
+
+    logfd = telemetry_log("smtpclient.sendmail", NULL, NULL, 0);
+
+    /* Create backend and setup context */
+    bk = backend_connect_pipe(ctx->infd, ctx->outfd, &smtp_protocol, 0, logfd);
+    if (!bk) {
+        syslog(LOG_ERR, "smptclient_open: can't open sendmail backend");
+        r = IMAP_INTERNAL;
+        smtpclient_sendmail_freectx(ctx);
+        if (logfd != -1) close(logfd);
+        goto done;
     }
+    bk->context = ctx;
+    r = smtpclient_new(smp, bk, (int (*)(void *)) smtpclient_sendmail_freectx, logfd);
 
-    return errstr;
+done:
+    return r;
 }
diff -pruN 3.0.13-5/imap/smtpclient.h 3.2.0-3/imap/smtpclient.h
--- 3.0.13-5/imap/smtpclient.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/imap/smtpclient.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,7 +43,132 @@
 #ifndef INCLUDED_SMTPCLIENT_H
 #define INCLUDED_SMTPCLIENT_H
 
-pid_t open_sendmail(const char *argv[], FILE **sm);
-char *sendmail_errstr(int sm_stat);
+#include "prot.h"
+#include "ptrarray.h"
+#include "util.h"
+
+/* A parameter for SMTP envelope address, identified by key.
+ * The value val may be NULL. */
+typedef struct {
+    char *key;
+    char *val;
+} smtp_param_t;
+
+/* A SMTP envelope address with address addr. The params
+ * array contains the optional address parameters for the
+ * MAIL FROM and RCPT TO commands. */
+typedef struct {
+    char *addr;
+    ptrarray_t params; /* Array of smtp_param_t */
+    int completed;
+} smtp_addr_t;
+
+/* A SMTP envelope with the MAIL FROM address and one
+ * or more RCPT TO recipient addresses. */
+typedef struct {
+    smtp_addr_t from;
+    ptrarray_t rcpts; /* Array of smtp_addr_t */
+} smtp_envelope_t;
+
+/* The empty SMTP envelope */
+#define SMTP_ENVELOPE_INITIALIZER { { NULL, PTRARRAY_INITIALIZER, 0 }, PTRARRAY_INITIALIZER }
+
+/* Return non-zero if val is a valid esmtp-keyword
+ * as defined in RFC 5321, section 4.1.2. */
+extern int smtp_is_valid_esmtp_keyword(const char *val);
+
+/* Return non-zero if val is a valid esmtp-value
+ * as defined in RFC 5321, section 4.1.2. */
+extern int smtp_is_valid_esmtp_value(const char *val);
+
+/* Set the MAIL FROM address in env and return the new value.
+ * Any existing address is deallocated. */
+extern smtp_addr_t *smtp_envelope_set_from(smtp_envelope_t *env, const char *addr);
+
+/* Add a RCPT TO address to the recipients of env and return the new value. */
+extern smtp_addr_t *smtp_envelope_add_rcpt(smtp_envelope_t *env, const char *addr);
+
+/* Free all memory of pointers and arrays in env */
+extern void smtp_envelope_fini(smtp_envelope_t *env);
+
+/* Opaque SMTP client type */
+typedef struct smtpclient smtpclient_t;
+
+/* Open a SMTP client to the default SMTP backend */
+extern int smtpclient_open(smtpclient_t **smp);
+
+/* Open a SMTP client to the sendmail process */
+extern int smtpclient_open_sendmail(smtpclient_t **smp);
+
+/* Open a SMTP client to the host at addr, formatted as host[:port] */
+extern int smtpclient_open_host(const char *addr, smtpclient_t **smp);
+
+/* Send message data with SMTP envelope env. Data is dot-escaped
+ * before it is written to the SMTP backend. */
+extern int smtpclient_send(smtpclient_t *sm, smtp_envelope_t *env, struct buf *data);
+extern int smtpclient_sendprot(smtpclient_t *sm, smtp_envelope_t *env, struct protstream *data);
+
+/* Close the SMTP client and free its memory */
+extern int smtpclient_close(smtpclient_t **smp);
+
+/* Add the AUTH=userid parameter to MAIL FROM commands, if the
+ * SMTP backend advertised support for the RFC 4954 AUTH extension.
+ *
+ * An AUTH parameter in the SMTP envelope of the smtpclient_send
+ * function overrides this value, regardless of advertised extensions.
+ *
+ * Setting this to NULL resets userid. */
+extern void smtpclient_set_auth(smtpclient_t *sm, const char *userid);
+
+/* Add the NOTIFY=value parameter to RCPT TO commands, if the
+ * SMTP backend advertised support for the RFC 3461 DSN extension.
+ *
+ * A NOTIFY parameter in the SMTP envelope of the smtpclient_send
+ * function overrides this value, regardless of advertised extensions.
+ *
+ * Setting this to NULL resets the value. */
+extern void smtpclient_set_notify(smtpclient_t *sm, const char *value);
+
+/* Add the RET=value parameter to MAIL FROM commands, if the
+ * SMTP backend advertised support for the RFC 3461 DSN extension.
+ *
+ * A RET parameter in the SMTP envelope of the smtpclient_from
+ * function overrides this value, regardless of advertised extensions.
+ *
+ * Setting this to NULL resets the value. */
+extern void smtpclient_set_ret(smtpclient_t *sm, const char *value);
+
+/* Add the BY=value parameter to MAIL FROM commands, if the
+ * SMTP backend advertised support for the RFC 2852 DELIVERYBY extension.
+ *
+ * A BY parameter in the SMTP envelope of the smtpclient_from
+ * function overrides this value, regardless of advertised extensions.
+ *
+ * Setting this to NULL resets the value. */
+extern void smtpclient_set_by(smtpclient_t *sm, const char *value);
+
+/* Add the SIZE=value parameter to MAIL FROM commands, if the
+ * SMTP backend advertised support for the RFC 1870 SIZE extension.
+ *
+ * A SIZE parameter in the SMTP envelope of the smtpclient_from
+ * function overrides this value, regardless of advertised extensions.
+ *
+ * Setting this to 0 resets the value. */
+extern void smtpclient_set_size(smtpclient_t *sm, unsigned long value);
+
+/* Return the SIZE SMTP extension value.
+ *
+ * Return 0 if the extension has no value or is not supported. */
+extern unsigned long smtpclient_get_maxsize(smtpclient_t *sm);
+
+/* Return the argument string of SMTP extension 'name' as returned
+ * in response to the EHLO command, excluding the extension name.
+ * This may be the empty string.
+ * Return NULL if the extension is not supported. */
+extern const char *smtpclient_has_ext(smtpclient_t *sm, const char *name);
+
+/* Return the text of the last SMTP response */
+extern const char *smtpclient_get_resp_text(smtpclient_t *sm);
+
 
 #endif
diff -pruN 3.0.13-5/imap/sphinxmgr_client.c 3.2.0-3/imap/sphinxmgr_client.c
--- 3.0.13-5/imap/sphinxmgr_client.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sphinxmgr_client.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,164 +0,0 @@
-/* sphinxmgr_client.c - client for talking to the cyr_sphinxmgr daemon
- *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-#include <config.h>
-
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <sys/un.h>
-#include <fcntl.h>
-#include <stdlib.h>
-#include <syslog.h>
-#include <string.h>
-#ifdef HAVE_UNISTD_H
-#include <unistd.h>
-#endif
-
-#include "global.h"
-#include "retry.h"
-#include "xmalloc.h"
-#include "xstrlcpy.h"
-#include "xstrlcat.h"
-
-/* generated headers are not necessarily in current directory */
-#include "imap/imap_err.h"
-
-static int sphinxmgr_request(const char *req, size_t reqsize,
-                             char *reply, size_t maxreply)
-{
-    const char *sockname = config_getstring(IMAPOPT_SPHINXMGR_SOCKET);
-    struct sockaddr_un asun;
-    int r;
-    int s = -1;
-
-    memset(&asun, 0, sizeof(asun));
-    asun.sun_family = AF_UNIX;
-    strlcpy(asun.sun_path, sockname, sizeof(asun.sun_path));
-
-    s = socket(PF_UNIX, SOCK_STREAM, 0);
-    if (s < 0) {
-        syslog(LOG_ERR, "socket(PF_UNIX): %m");
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    r = connect(s, (struct sockaddr *)&asun, sizeof(asun));
-    if (r < 0) {
-        syslog(LOG_ERR, "connect to %s failed: %m", sockname);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    r = retry_write(s, req, reqsize);
-    if (r < 0) {
-        syslog(LOG_ERR, "write to %s failed: %m", sockname);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-
-    r = read(s, reply, maxreply-1);
-    if (r < 0) {
-        syslog(LOG_ERR, "read from %s failed: %m", sockname);
-        r = IMAP_IOERROR;
-        goto out;
-    }
-    reply[r] = '\0';
-    r = 0;
-
-out:
-    if (s >= 0) close(s);
-    return r;
-}
-
-int sphinxmgr_getsock(const char *mboxname, char **socknamep)
-{
-    int r;
-    char *p;
-    char buf[1024];
-
-    snprintf(buf, sizeof(buf),  "GETSOCK %s\n", mboxname);
-    r = sphinxmgr_request(buf, strlen(buf), buf, sizeof(buf));
-    if (r) return r;
-    if (strncmp(buf, "OK ", 3)) {
-        syslog(LOG_ERR, "sphinxmgr returned failure: %s", buf);
-        return IMAP_IOERROR;
-    }
-    p = strpbrk(buf+3, " \t\n\r");
-    if (p) *p = '\0';
-    *socknamep = xstrdup(buf+3);
-    return 0;
-}
-
-int sphinxmgr_getconf(const char *mboxname, char **configp)
-{
-    int r;
-    char *p;
-    char buf[1024];
-
-    snprintf(buf, sizeof(buf),  "GETCONF %s\n", mboxname);
-    r = sphinxmgr_request(buf, strlen(buf), buf, sizeof(buf));
-    if (r) return r;
-    if (strncmp(buf, "OK ", 3)) {
-        syslog(LOG_ERR, "sphinxmgr returned failure: %s", buf);
-        return IMAP_IOERROR;
-    }
-    p = strpbrk(buf+3, " \t\n\r");
-    if (p) *p = '\0';
-    *configp = xstrdup(buf+3);
-    return 0;
-}
-
-int sphinxmgr_stop(const char *mboxname)
-{
-    int r;
-    char buf[1024];
-
-    snprintf(buf, sizeof(buf),  "STOP %s\n", mboxname);
-    r = sphinxmgr_request(buf, strlen(buf), buf, sizeof(buf));
-    if (r) return r;
-    if (strncmp(buf, "OK ", 3)) {
-        syslog(LOG_ERR, "sphinxmgr returned failure: %s", buf);
-        return IMAP_IOERROR;
-    }
-    return 0;
-}
-
diff -pruN 3.0.13-5/imap/sphinxmgr_client.h 3.2.0-3/imap/sphinxmgr_client.h
--- 3.0.13-5/imap/sphinxmgr_client.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sphinxmgr_client.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,54 +0,0 @@
-/* sphinxmgr_client.h - client for talking to the cyr_sphinxmgr daemon
- *
- * Copyright (c) 1994-2012 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-#ifndef __CYRUS_SPHINXMGR_CLIENT_H__
-#define __CYRUS_SPHINXMGR_CLIENT_H__
-
-#include <sys/socket.h>
-#include <sys/un.h>
-#include "mailbox.h"
-
-int sphinxmgr_getsock(const char *mboxname, char **socknamep);
-int sphinxmgr_getconf(const char *mboxname, char **configp);
-int sphinxmgr_stop(const char *mboxname);
-
-#endif
diff -pruN 3.0.13-5/imap/spool.c 3.2.0-3/imap/spool.c
--- 3.0.13-5/imap/spool.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/spool.c	2020-04-24 02:03:00.000000000 +0000
@@ -53,15 +53,37 @@
 #include "util.h"
 #include "xmalloc.h"
 #include "global.h"
-#include "strarray.h"
+#include "ptrarray.h"
+#include "hash.h"
 
 /* generated headers are not necessarily in current directory */
 #include "imap/imap_err.h"
 
-hdrcache_t spool_new_hdrcache(void)
+struct header_t {
+    char *name;
+    char *body;
+    char *raw;
+    struct header_t *next;
+    struct header_t *prev;
+};
+
+struct hdrcache_t {
+    hash_table cache;       /* hash table of headers for quick retrieval     */
+    struct header_t *head;  /* head of double-linked list of ordered headers */
+    struct header_t *tail;  /* tail of double-linked list of ordered headers */
+    ptrarray_t getheader_cache;  /* header bodies returned by spool_getheader()   */
+};
+
+EXPORTED hdrcache_t spool_new_hdrcache(void)
 {
-    hash_table *ht = xmalloc(sizeof(*ht));
-    return construct_hash_table(ht, 4000, 0);
+    hdrcache_t cache = xzmalloc(sizeof(struct hdrcache_t));
+
+    if (!construct_hash_table(&cache->cache, 4000, 0)) {
+        free(cache);
+        cache = NULL;
+    }
+
+    return cache;
 }
 
 /* take a list of headers, pull the first one out and return it in
@@ -89,11 +111,13 @@ typedef enum {
 */
 static int parseheader(struct protstream *fin, FILE *fout,
                        char **headname, char **contents,
+                       char **rawvalue,
                        const char **skipheaders)
 {
     int c;
     static struct buf name = BUF_INITIALIZER;
     static struct buf body = BUF_INITIALIZER;
+    static struct buf raw = BUF_INITIALIZER;
     state s = NAME_START;
     int r = 0;
     int reject8bit = config_getswitch(IMAPOPT_REJECT8BIT);
@@ -102,6 +126,7 @@ static int parseheader(struct protstream
 
     buf_reset(&name);
     buf_reset(&body);
+    buf_reset(&raw);
 
     /* there are two ways out of this loop, both via gotos:
        either we successfully read a header (got_header)
@@ -154,7 +179,7 @@ static int parseheader(struct protstream
                      skip && *skip && strcasecmp(name.s, *skip); skip++);
                 if (!skip || !*skip) {
                     /* write the header name to the output */
-                    if (fout) fputs(name.s, fout);
+                    buf_appendcstr(&raw, name.s);
                     skip = NULL;
                 }
                 s = (c == ':' ? BODY_START : COLON);
@@ -173,7 +198,7 @@ static int parseheader(struct protstream
             } else if (c != ' ' && c != '\t') {
                 /* i want to avoid confusing dot-stuffing later */
                 while (c == '.') {
-                    if (fout && !skip) fputc(c, fout);
+                    if (!skip) buf_putc(&raw, c);
                     c = prot_getc(fin);
                 }
                 r = IMAP_MESSAGE_BADHEADER;
@@ -194,19 +219,17 @@ static int parseheader(struct protstream
 
                 peek = prot_getc(fin);
 
-                if (fout && !skip) {
-                    fputc('\r', fout);
-                    fputc('\n', fout);
-                }
+                if (!skip) buf_appendcstr(&raw, "\r\n");
                 /* we should peek ahead to see if it's folded whitespace */
                 if (c == '\r' && peek == '\n') {
                     c = prot_getc(fin);
                 } else {
-                    c = peek; /* single newline seperator */
+                    c = peek; /* single newline separator */
                 }
                 if (c != ' ' && c != '\t') {
                     /* this is the end of the header */
                     buf_cstring(&body);
+                    buf_cstring(&raw);
                     prot_ungetc(c, fin);
                     goto got_header;
                 }
@@ -228,90 +251,176 @@ static int parseheader(struct protstream
         }
 
         /* copy this to the output */
-        if (fout && s != NAME && !skip) fputc(c, fout);
+        if (s != NAME && !skip) buf_putc(&raw, c);
     }
 
     /* if we fall off the end of the loop, we hit some sort of error
        condition */
 
  ph_error:
+    /* we still output on error */
+    if (fout) fputs(buf_cstring(&raw), fout);
+
     /* put the last character back; we'll copy it later */
     if (c != EOF) prot_ungetc(c, fin);
 
     /* and we didn't get a header */
     if (headname != NULL) *headname = NULL;
     if (contents != NULL) *contents = NULL;
+    if (rawvalue != NULL) *rawvalue = NULL;
+
     return r;
 
  got_header:
+    if (fout) fputs(buf_cstring(&raw), fout);
+
     /* Note: xstrdup()ing the string ensures we return
      * a minimal length string with no allocation slack
      * at the end */
     if (headname != NULL) *headname = xstrdup(name.s);
     if (contents != NULL) *contents = xstrdup(body.s);
+    if (rawvalue != NULL) *rawvalue = xstrdup(raw.s);
 
     return 0;
 }
 
-EXPORTED void spool_cache_header(char *name, char *body, hdrcache_t cache)
+static struct header_t *__spool_cache_header(char *name, char *body, char *raw,
+                                             hash_table *table)
 {
-    strarray_t *contents;
+    ptrarray_t *contents;
+    struct header_t *hdr = xzmalloc(sizeof(struct header_t));
 
-    lcase(name);
+    hdr->name = name;
+    hdr->body = body;
+    hdr->raw = raw;
 
-    contents = (strarray_t *)hash_lookup(name, cache);
-    if (!contents)
-        contents = hash_insert(name, strarray_new(), cache);
-    strarray_appendm(contents, body);
-    free(name);
+    /* add header to hash table */
+    char *lcname = lcase(xstrdup(name));
+    contents = (ptrarray_t *) hash_lookup(lcname, table);
+
+    if (!contents) contents = hash_insert(lcname, ptrarray_new(), table);
+    ptrarray_append(contents, hdr);
+
+    free(lcname);
+
+    return hdr;
+}
+
+EXPORTED void spool_prepend_header_raw(char *name, char *body, char *raw, hdrcache_t cache)
+{
+    struct header_t *hdr = __spool_cache_header(name, body, raw, &cache->cache);
+
+    /* link header at head of list */
+    hdr->next = cache->head;
+
+    if (cache->head) cache->head->prev = hdr;
+    else cache->tail = hdr;
+
+    cache->head = hdr;
+}
+
+
+EXPORTED void spool_prepend_header(char *name, char *body, hdrcache_t cache)
+{
+    spool_prepend_header_raw(name, body, NULL, cache);
+}
+
+EXPORTED void spool_append_header_raw(char *name, char *body, char *raw, hdrcache_t cache)
+{
+    struct header_t *hdr = __spool_cache_header(name, body, raw, &cache->cache);
+
+    /* link header at tail of list */
+    hdr->prev = cache->tail;
+
+    if (cache->tail) cache->tail->next = hdr;
+    else cache->head = hdr;
+
+    cache->tail = hdr;
+}
+
+EXPORTED void spool_append_header(char *name, char *body, hdrcache_t cache)
+{
+    spool_append_header_raw(name, body, NULL, cache);
 }
 
 EXPORTED void spool_replace_header(char *name, char *body, hdrcache_t cache)
 {
-    strarray_t *contents;
+    spool_remove_header(xstrdup(name), cache);
+    spool_append_header(name, body, cache);
+}
+
+static void __spool_remove_header(char *name, int first, int last,
+                                  hdrcache_t cache)
+{
+    ptrarray_t *contents =
+        (ptrarray_t *) hash_lookup(lcase(name), &cache->cache);
 
-    lcase(name);
+    if (contents) {
+        int idx;
+
+        /* normalize indices */
+        if (first < 0) first += ptrarray_size(contents);
+        if (last < 0) {
+            last += ptrarray_size(contents);
+            if (last < 0) first = 0;
+        }
+        else if (last >= ptrarray_size(contents)) first = last + 1;
+
+        for (idx = last; idx >= first; idx--) {
+            /* remove header from ptrarray */
+            struct header_t *hdr = ptrarray_remove(contents, idx);
+
+            /* unlink header from list */
+            if (hdr->prev) hdr->prev->next = hdr->next;
+            else cache->head = hdr->next;
+            if (hdr->next) hdr->next->prev = hdr->prev;
+            else cache->tail = hdr->prev;
+
+            /* free header_t */
+            free(hdr->name);
+            free(hdr->body);
+            free(hdr->raw);
+            free(hdr);
+        }
+    }
 
-    contents = (strarray_t *)hash_lookup(name, cache);
-    if (!contents)
-        contents = hash_insert(name, strarray_new(), cache);
-    else
-        strarray_truncate(contents, 0);
-    strarray_appendm(contents, body);
     free(name);
 }
 
 EXPORTED void spool_remove_header(char *name, hdrcache_t cache)
 {
-    strarray_t *contents;
+    __spool_remove_header(name, 0, -1, cache);
+}
 
-    lcase(name);
+EXPORTED void spool_remove_header_instance(char *name, int n, hdrcache_t cache)
+{
+    if (!n) return;
+    if (n > 0) n--; /* normalize to zero */
 
-    contents = (strarray_t *)hash_del(name, cache);
-    if (contents) strarray_free(contents);
-    free(name);
+    __spool_remove_header(name, n, n, cache);
 }
 
-EXPORTED int spool_fill_hdrcache(struct protstream *fin, FILE *fout, hdrcache_t cache,
-                        const char **skipheaders)
+EXPORTED int spool_fill_hdrcache(struct protstream *fin, FILE *fout,
+                                 hdrcache_t cache, const char **skipheaders)
 {
     int r = 0;
 
     /* let's fill that header cache */
     for (;;) {
-        char *name = NULL, *body = NULL;
+        char *name = NULL, *body = NULL, *raw = NULL;
 
-        if ((r = parseheader(fin, fout, &name, &body, skipheaders)) < 0) {
+        if ((r = parseheader(fin, fout, &name, &body, &raw, skipheaders)) < 0) {
             break;
         }
         if (!name) {
             /* reached the end of headers */
             free(body);
+            free(raw);
             break;
         }
 
         /* put it in the hash table */
-        spool_cache_header(name, body, cache);
+        spool_append_header_raw(name, body, raw, cache);
     }
 
     return r;
@@ -320,7 +429,7 @@ EXPORTED int spool_fill_hdrcache(struct
 EXPORTED const char **spool_getheader(hdrcache_t cache, const char *phead)
 {
     char *head;
-    strarray_t *contents;
+    ptrarray_t *contents;
 
     assert(cache && phead);
 
@@ -328,50 +437,72 @@ EXPORTED const char **spool_getheader(hd
     lcase(head);
 
     /* check the cache */
-    contents = (strarray_t *)hash_lookup(head, cache);
+    contents = (ptrarray_t *) hash_lookup(head, &cache->cache);
 
     free(head);
 
-    return contents ? (const char **)contents->data : NULL;
+    if (contents && ptrarray_size(contents)) {
+        strarray_t *array = strarray_new();
+        /* build read-only array of header bodies */
+
+        int i;
+        for (i = 0; i < ptrarray_size(contents); i++) {
+            struct header_t *hdr = ptrarray_nth(contents, i);
+            strarray_append(array, hdr->body);
+        }
+
+        /* cache the response so we clean it up later */
+        ptrarray_append(&cache->getheader_cache, array);
+
+        return (const char **) array->data;
+    }
+
+    return NULL;
 }
 
-EXPORTED void spool_free_hdrcache(hdrcache_t cache)
+static void __spool_free_hdrcache(ptrarray_t *pa)
 {
-    if (!cache) return;
+    int idx;
 
-    free_hash_table(cache, (void (*)(void *))strarray_free);
-    free(cache);
-}
+    for (idx = ptrarray_size(pa) - 1; idx >= 0; idx--) {
+        struct header_t *hdr = ptrarray_nth(pa, idx);
 
-struct spool_enum_rock {
-    void (*proc)(const char *, const char *, void *);
-    void *rock;
-};
+        free(hdr->name);
+        free(hdr->body);
+        free(hdr->raw);
+        free(hdr);
+    }
+    ptrarray_free(pa);
+}
 
-static void spool_enum_cb(const char *key, void *data, void *rock)
+EXPORTED void spool_free_hdrcache(hdrcache_t cache)
 {
-    struct spool_enum_rock *c = (struct spool_enum_rock *)rock;
-    strarray_t *d = (strarray_t *)data;
     int i;
 
-    for (i = 0; i < d->count; i++) {
-        const char *val = strarray_nth(d, i);
-        c->proc(key, val, c->rock);
+    if (!cache) return;
+
+    free_hash_table(&cache->cache, (void (*)(void *)) __spool_free_hdrcache);
+
+    for (i = 0; i < cache->getheader_cache.count; i++) {
+        strarray_t *item = ptrarray_nth(&cache->getheader_cache, i);
+        strarray_free(item);
     }
+    ptrarray_fini(&cache->getheader_cache);
+
+    free(cache);
 }
 
 EXPORTED void spool_enum_hdrcache(hdrcache_t cache,
-                         void (*proc)(const char *, const char *, void *),
+                         void (*proc)(const char *, const char *, const char *, void *),
                          void *rock)
 {
-    struct spool_enum_rock cbrock;
+    struct header_t *hdr;
 
     if (!cache) return;
 
-    cbrock.proc = proc;
-    cbrock.rock = rock;
-
-    hash_enumerate(cache, spool_enum_cb, &cbrock);
+    for (hdr = cache->head; hdr; hdr = hdr->next) {
+        proc(hdr->name, hdr->body, hdr->raw, rock);
+    }
 }
 
 /* copies the message from fin to fout, massaging accordingly:
diff -pruN 3.0.13-5/imap/spool.h 3.2.0-3/imap/spool.h
--- 3.0.13-5/imap/spool.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/spool.h	2020-04-24 02:03:00.000000000 +0000
@@ -45,20 +45,26 @@
 
 #include <stdio.h>
 #include "prot.h"
-#include "hash.h"
 
-typedef hash_table *hdrcache_t;
+typedef struct hdrcache_t *hdrcache_t;
 
 hdrcache_t spool_new_hdrcache(void);
-void spool_cache_header(char *name, char *body, hdrcache_t cache);
+void spool_prepend_header(char *name, char *body, hdrcache_t cache);
+void spool_prepend_header_raw(char *name, char *body, char *raw, hdrcache_t cache);
+void spool_append_header(char *name, char *body, hdrcache_t cache);
+void spool_append_header_raw(char *name, char *body, char *raw, hdrcache_t cache);
+#define spool_cache_header(n, b, c) spool_append_header(n, b, c)
 void spool_replace_header(char *name, char *newvalue, hdrcache_t cache);
+/* remove all instances of header 'name' */
 void spool_remove_header(char *name, hdrcache_t cache);
+/* remove nth instance of header 'name'.  1 = first, -1 = last */
+void spool_remove_header_instance(char *name, int n, hdrcache_t cache);
 int spool_fill_hdrcache(struct protstream *fin, FILE *fout, hdrcache_t cache,
                         const char **skipheaders);
 const char **spool_getheader(hdrcache_t cache, const char *phead);
 void spool_free_hdrcache(hdrcache_t cache);
 void spool_enum_hdrcache(hdrcache_t cache,
-                         void (*proc)(const char *, const char *, void *),
+                         void (*proc)(const char *, const char *, const char *, void *),
                          void *rock);
 int spool_copy_msg(struct protstream *fin, FILE *fout);
 
diff -pruN 3.0.13-5/imap/squat_build.c 3.2.0-3/imap/squat_build.c
--- 3.0.13-5/imap/squat_build.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/squat_build.c	2020-04-24 02:03:00.000000000 +0000
@@ -115,7 +115,6 @@ typedef struct {
 
 static int init_write_buffer(SquatWriteBuffer* b, int buf_size, int fd)
 {
-    buf_init(&b->buf);
     buf_ensure(&b->buf, buf_size);
     b->fd = fd;
     b->total_output_bytes = 0;
@@ -419,7 +418,7 @@ int squat_index_add_existing(SquatIndex
 
 /* ====================================================================== */
 
-/* Initally, before we see a document, there are no words for the document. */
+/* Initially, before we see a document, there are no words for the document. */
 static SquatWordTable *word_table_new(void)
 {
     SquatWordTable *ret =
@@ -442,7 +441,7 @@ SquatIndex *squat_index_init(int fd, con
 
     squat_set_last_error(SQUAT_ERR_OK);
 
-    index = (SquatIndex *) xmalloc(sizeof(SquatIndex));
+    index = (SquatIndex *) xzmalloc(sizeof(SquatIndex));
 
     /* Copy processed options into the SquatIndex */
     if (options != NULL
@@ -478,7 +477,6 @@ SquatIndex *squat_index_init(int fd, con
 
     /* Finish initializing the SquatIndex */
     for (i = 0; i < VECTOR_SIZE(index->index_buffers); i++) {
-        buf_init(&index->index_buffers[i].buf);
         index->index_buffers[i].fd = -1;
     }
 
diff -pruN 3.0.13-5/imap/squat_dump.c 3.2.0-3/imap/squat_dump.c
--- 3.0.13-5/imap/squat_dump.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/squat_dump.c	2020-04-24 02:03:00.000000000 +0000
@@ -60,12 +60,12 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 
 #include "assert.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "xstrlcat.h"
@@ -87,7 +87,7 @@ static int usage(const char *name)
             "usage: %s [-C <alt_config>] mailbox [...]\n",
             name);
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 static const char *squat_strerror(int err)
@@ -197,18 +197,12 @@ int main(int argc, char **argv)
 
     cyrus_init(alt_config, "squat_dump", 0, CONFIG_NEED_PARTITION_DATA);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
     if (optind == argc)
         usage(argv[0]);
 
     for (i = optind; i < argc; i++)
         dump_one(argv[i]);
 
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     return 0;
diff -pruN 3.0.13-5/imap/squatter.c 3.2.0-3/imap/squatter.c
--- 3.0.13-5/imap/squatter.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/squatter.c	2020-04-24 02:03:00.000000000 +0000
@@ -59,15 +59,16 @@
 #include <sys/poll.h>
 #include <errno.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 
 #include "annotate.h"
 #include "assert.h"
+#include "bitvector.h"
 #include "bsearch.h"
 #include "mboxlist.h"
 #include "global.h"
-#include "exitcodes.h"
 #include "search_engines.h"
 #include "sync_log.h"
 #include "mailbox.h"
@@ -97,9 +98,10 @@ const int SKIP_FUZZ = 60;
 static int verbose = 0;
 static int incremental_mode = 0;
 static int batch_mode = 0;
+static int xapindexed_mode = 0;
+static int reindex_parts_mode = 0;
 static int recursive_flag = 0;
 static int annotation_flag = 0;
-static int running_daemon = 0;
 static int sleepmicroseconds = 0;
 static const char *temp_root_dir = NULL;
 static search_text_receiver_t *rx = NULL;
@@ -108,7 +110,7 @@ static const char *name_starts_from = NU
 
 static void shut_down(int code) __attribute__((noreturn));
 
-static int usage(const char *name)
+__attribute__((noreturn)) static int usage(const char *name)
 {
     fprintf(stderr,
             "usage: %s [mode] [options] [source]\n"
@@ -118,14 +120,16 @@ static int usage(const char *name)
             "  -a          index [source] using /squat annotations\n"
             "  -r          index [source] recursively\n"
             "  -f file     index from synclog file\n"
-            "  -I file     index mbox/uids in file\n"
             "  -R          start rolling indexer\n"
             "  -z tier     compact to tier\n"
+            "  -l          list paths\n"
             "\n"
             "Index mode options:\n"
             "  -i          index incrementally\n"
             "  -N name     index mailbox names starting with name\n"
             "  -S seconds  sleep seconds between indexing mailboxes\n"
+            "  -P          reindex body parts\n"
+            "  -Z          Xapian: use internal index rather than cyrus.indexed.db\n"
             "\n"
             "Index sources:\n"
             "  none        all mailboxes (default)\n"
@@ -140,16 +144,16 @@ static int usage(const char *name)
             "  -t tier...  compact from tiers\n"
             "  -F          filter during compaction\n"
             "  -T dir      use temporary directory dir during compaction\n"
-            "  -X          reindex during compaction\n"
-            "  -U          reindex tiers having deprecated stems or prefixes\n"
+            "  -X          reindex during compaction (including body parts)\n"
             "  -o          copy db rather compacting\n"
+            "  -U          only compact if re-indexing\n"
             "\n"
             "General options:\n"
             "  -v          be verbose\n"
             "  -h          show usage\n",
         name);
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /* ====================================================================== */
@@ -166,9 +170,9 @@ static void become_daemon(void)
         perror("/dev/null");
         exit(1);
     }
-    dup2(nullfd, 0);
-    dup2(nullfd, 1);
-    dup2(nullfd, 2);
+    dup2(nullfd, STDIN_FILENO);
+    dup2(nullfd, STDOUT_FILENO);
+    dup2(nullfd, STDERR_FILENO);
     for (fd = 3 ; fd < nfds ; fd++)
         close(fd);          /* this will close nullfd too */
 
@@ -182,27 +186,14 @@ static void become_daemon(void)
         exit(0); /* parent */
 }
 
-/* ====================================================================== */
-
-/* This is called once for each mailbox we're told to index. */
-static int index_one(const char *name, int blocking)
+static int should_index(const char *name)
 {
     mbentry_t *mbentry = NULL;
-    struct mailbox *mailbox = NULL;
-    int r;
-    int flags = 0;
-
-    if (incremental_mode)
-        flags |= SEARCH_UPDATE_INCREMENTAL;
-    if (batch_mode)
-        flags |= SEARCH_UPDATE_BATCH;
-
-    /* Convert internal name to external */
-    char *extname = mboxname_to_external(name, &squat_namespace, NULL);
-
     /* Skip remote mailboxes */
-    r = mboxlist_lookup(name, &mbentry, NULL);
+    int r = mboxlist_lookup(name, &mbentry, NULL);
     if (r) {
+        /* Convert internal name to external */
+        char *extname = mboxname_to_external(name, &squat_namespace, NULL);
         if (verbose) {
             printf("error looking up %s: %s\n",
                    extname, error_message(r));
@@ -211,15 +202,51 @@ static int index_one(const char *name, i
                extname, error_message(r));
 
         free(extname);
-        return r;
+        return 0;
     }
-    if (mbentry->mbtype & MBTYPE_REMOTE) {
+
+    // skip remote or not-real mailboxes
+    if (mbentry->mbtype & (MBTYPE_REMOTE|MBTYPE_DELETED|MBTYPE_INTERMEDIATE)) {
+        mboxlist_entry_free(&mbentry);
+        return 0;
+    }
+
+    // skip email submissions
+    if (mboxname_issubmissionmailbox(mbentry->name, mbentry->mbtype)) {
+        mboxlist_entry_free(&mbentry);
+        return 0;
+    }
+
+    // skip COLLECTION mailboxes (just files)
+    if (mbentry->mbtype & MBTYPE_COLLECTION) {
         mboxlist_entry_free(&mbentry);
-        free(extname);
         return 0;
     }
 
     mboxlist_entry_free(&mbentry);
+    return 1;
+}
+
+/* ====================================================================== */
+
+/* This is called once for each mailbox we're told to index. */
+static int index_one(const char *name, int blocking)
+{
+    struct mailbox *mailbox = NULL;
+    int r;
+    int flags = 0;
+
+    if (incremental_mode)
+        flags |= SEARCH_UPDATE_INCREMENTAL;
+    if (batch_mode)
+        flags |= SEARCH_UPDATE_BATCH;
+    if (xapindexed_mode)
+        flags |= SEARCH_UPDATE_XAPINDEXED;
+    if (reindex_parts_mode)
+        flags |= SEARCH_UPDATE_REINDEX_PARTS;
+
+    /* Convert internal name to external */
+    char *extname = mboxname_to_external(name, &squat_namespace, NULL);
 
     /* make sure the mailbox (or an ancestor) has
        /vendor/cmu/cyrus-imapd/squat set to "true" */
@@ -327,7 +354,7 @@ static void expand_mboxnames(strarray_t
 
     for (i = 0; i < nmboxnames; i++) {
         if (user_mode) {
-            mboxlist_usermboxtree(mboxnames[i], addmbox, sa, 0);
+            mboxlist_usermboxtree(mboxnames[i], NULL, addmbox, sa, 0);
         }
         else {
             /* Translate any separators in mailboxname */
@@ -339,7 +366,7 @@ static void expand_mboxnames(strarray_t
     }
 }
 
-static int do_indexer(const strarray_t *sa)
+static int do_indexer(const strarray_t *mboxnames)
 {
     int r = 0;
     int i;
@@ -348,8 +375,10 @@ static int do_indexer(const strarray_t *
     if (rx == NULL)
         return 0;       /* no indexer defined */
 
-    for (i = 0 ; i < sa->count ; i++) {
-        r = index_one(sa->data[i], /*blocking*/1);
+    for (i = 0 ; i < strarray_size(mboxnames) ; i++) {
+        const char *mboxname = strarray_nth(mboxnames, i);
+        if (!should_index(mboxname)) continue;
+        r = index_one(mboxname, /*blocking*/1);
         if (r == IMAP_MAILBOX_NONEXISTENT)
             r = 0;
         if (r == IMAP_MAILBOX_LOCKED)
@@ -364,108 +393,6 @@ static int do_indexer(const strarray_t *
     return r;
 }
 
-static int index_single_message(const char *mboxname, uint32_t uid)
-{
-    int r;
-    struct mailbox *mailbox = NULL;
-    message_t *msg = NULL;
-    int begun = 0;
-    struct index_record record;
-
-    r = mailbox_open_irl(mboxname, &mailbox);
-    if (r) goto out;
-
-    r = rx->begin_mailbox(rx, mailbox, SEARCH_UPDATE_INCREMENTAL);
-    if (r) goto out;
-    begun = 1;
-
-    r = mailbox_find_index_record(mailbox, uid, &record);
-    if (r) goto out;
-
-    if (record.system_flags & (FLAG_EXPUNGED|FLAG_UNLINKED)) goto out;
-
-    msg = message_new_from_record(mailbox, &record);
-    if (!msg) goto out;
-
-    if (rx->is_indexed(rx, msg))
-        goto out;
-
-    if (verbose) fprintf(stderr, "squatter: indexing mailbox:%s uid:%u\n",
-                         mboxname, uid);
-
-    r = index_getsearchtext(msg, rx, 0);
-
-out:
-    if (begun) {
-        int r2 = rx->end_mailbox(rx, mailbox);
-        if (r2 && !r) r = r2;
-    }
-    message_unref(&msg);
-    mailbox_close(&mailbox);
-    return r;
-}
-
-static int do_indexfrom(const char *fromfile)
-{
-    int r;
-    FILE *fp;
-    unsigned lineno = 0;
-    const char *p;
-    tok_t tok;
-    const char *mboxname;
-    uint32_t uid;
-    char buf[MAX_MAILBOX_BUFFER+128];
-
-    rx = search_begin_update(verbose);
-    if (rx == NULL) /* no indexer defined */
-        return 0;
-
-    fp = fopen(fromfile, "r");
-    if (!fp) {
-        r = errno;
-        perror(fromfile);
-        goto out;
-    }
-
-    while (fgets(buf, sizeof(buf), fp)) {
-        lineno++;
-        if (buf[0] == '#') continue;
-        tok_initm(&tok, buf, "\t", TOK_EMPTY|TOK_TRIMRIGHT);
-
-        /* first token is an mboxname */
-        mboxname = tok_next(&tok);
-        if (!mboxname) {
-syntax_error:
-            fprintf(stderr, "%s:%u: syntax error, skipping\n",
-                    fromfile, lineno);
-            continue;
-        }
-
-        /* 2nd token is a uid */
-        p = tok_next(&tok);
-        if (!p) goto syntax_error;
-        uid = strtoul(p, NULL, 0);
-        if (!uid) goto syntax_error;
-
-        /* no more tokens on the line */
-        p = tok_next(&tok);
-        if (p) goto syntax_error;
-
-        r = index_single_message(mboxname, uid);
-        if (r) {
-            fprintf(stderr, "Failed to index mailbox \"%s\" uid %u: %s\n",
-                    mboxname, uid, error_message(r));
-            /* ignore errors */
-            r = 0;
-        }
-    }
-
-out:
-    if (fp) fclose(fp);
-    search_end_update(rx);
-    return r;
-}
-
 static int squatter_build_query(search_builder_t *bx, const char *query)
 {
     tok_t tok = TOK_INITIALIZER(query, NULL, 0);
@@ -547,7 +474,9 @@ error:
 }
 
 static int print_search_hit(const char *mboxname, uint32_t uidvalidity,
-                            uint32_t uid, void *rock)
+                            uint32_t uid,
+                            const strarray_t *partids __attribute__((unused)),
+                            void *rock)
 {
     int single = *(int *)rock;
 
@@ -558,6 +487,45 @@ static int print_search_hit(const char *
     return 0;
 }
 
+static int do_list(const strarray_t *mboxnames)
+{
+    char *prev_userid = NULL;
+    strarray_t files = STRARRAY_INITIALIZER;
+    int i;
+    int r = 0;
+
+    for (i = 0; i < strarray_size(mboxnames); i++) {
+        const char *mboxname = strarray_nth(mboxnames, i);
+        char *userid = mboxname_to_userid(mboxname);
+        if (!userid) continue;
+
+        if (!strcmpsafe(prev_userid, userid)) {
+            free(userid);
+            continue;
+        }
+
+        r = search_list_files(userid, &files);
+        if (r) break;
+
+        int j;
+        for (j = 0; j < strarray_size(&files); j++) {
+            printf("%s\n", strarray_nth(&files, j));
+        }
+
+        strarray_truncate(&files, 0);
+
+        free(prev_userid);
+        prev_userid = userid;
+
+        if (sleepmicroseconds)
+            usleep(sleepmicroseconds);
+    }
+
+    strarray_fini(&files);
+    free(prev_userid);
+    return r;
+}
+
 static int compact_mbox(const char *userid, const strarray_t *srctiers,
                         const char *desttier, int flags)
 {
@@ -569,10 +537,10 @@ static int do_compact(const strarray_t *
 {
     char *prev_userid = NULL;
     int i;
-    int r = 0;
 
-    for (i = 0 ; i < mboxnames->count ; i++) {
-        char *userid = mboxname_to_userid(mboxnames->data[i]);
+    for (i = 0; i < strarray_size(mboxnames); i++) {
+        const char *mboxname = strarray_nth(mboxnames, i);
+        char *userid = mboxname_to_userid(mboxname);
         if (!userid) continue;
 
         if (!strcmpsafe(prev_userid, userid)) {
@@ -580,8 +548,13 @@ static int do_compact(const strarray_t *
             continue;
         }
 
-        r = compact_mbox(userid, srctiers, desttier, flags);
-        if (r) break;
+        int retry;
+        for (retry = 1; retry <= 3; retry++) {
+            int r = compact_mbox(userid, srctiers, desttier, flags);
+            if (!r) break;
+            syslog(LOG_ERR, "IOERROR: failed to compact %s (%d): %s",
+                   userid, retry, error_message(r));
+        }
 
         free(prev_userid);
         prev_userid = userid;
@@ -591,7 +564,7 @@ static int do_compact(const strarray_t *
     }
 
     free(prev_userid);
-    return r;
+    return 0;
 }
 
 static int do_search(const char *query, int single, const strarray_t *mboxnames)
@@ -607,6 +580,7 @@ static int do_search(const char *query,
 
     for (i = 0 ; i < mboxnames->count ; i++) {
         const char *mboxname = mboxnames->data[i];
+        if (!should_index(mboxname)) continue;
 
         r = mailbox_open_irl(mboxname, &mailbox);
         if (r) {
@@ -634,23 +608,23 @@ static int do_search(const char *query,
 static strarray_t *read_sync_log_items(sync_log_reader_t *slr)
 {
     const char *args[3];
-    strarray_t *folders = strarray_new();
+    strarray_t *mboxnames = strarray_new();
 
     while (sync_log_reader_getitem(slr, args) == 0) {
         if (!strcmp(args[0], "APPEND")) {
             if (!mboxname_isdeletedmailbox(args[1], NULL))
-                strarray_add(folders, args[1]);
+                strarray_add(mboxnames, args[1]);
         }
         else if (!strcmp(args[0], "USER"))
-            mboxlist_usermboxtree(args[1], addmbox, folders, /*flags*/0);
+            mboxlist_usermboxtree(args[1], NULL, addmbox, mboxnames, /*flags*/0);
     }
 
-    return folders;
+    return mboxnames;
 }
 
 static int do_synclogfile(const char *synclogfile)
 {
-    strarray_t *folders = NULL;
+    strarray_t *mboxnames = NULL;
     sync_log_reader_t *slr;
     int nskipped = 0;
     int i;
@@ -659,11 +633,11 @@ static int do_synclogfile(const char *sy
     slr = sync_log_reader_create_with_filename(synclogfile);
     r = sync_log_reader_begin(slr);
     if (r) goto out;
-    folders = read_sync_log_items(slr);
+    mboxnames = read_sync_log_items(slr);
     sync_log_reader_end(slr);
 
-    /* sort folders for locality of reference in file processing mode */
-    strarray_sort(folders, cmpstringp_raw);
+    /* sort mboxnames for locality of reference in file processing mode */
+    strarray_sort(mboxnames, cmpstringp_raw);
 
     signals_poll();
 
@@ -673,8 +647,9 @@ static int do_synclogfile(const char *sy
         r = 1;
         goto out;
     }
-    for (i = 0; i < folders->count; i++) {
-        const char *mboxname = strarray_nth(folders, i);
+    for (i = 0; i < strarray_size(mboxnames); i++) {
+        const char *mboxname = strarray_nth(mboxnames, i);
+        if (!should_index(mboxname)) continue;
         if (verbose > 1)
             syslog(LOG_INFO, "do_synclogfile: indexing %s", mboxname);
         r = index_one(mboxname, /*blocking*/1);
@@ -688,7 +663,7 @@ static int do_synclogfile(const char *sy
             }
             r = 0;
             /* try again at the end */
-            strarray_append(folders, mboxname);
+            strarray_append(mboxnames, mboxname);
         }
         if (r) {
             syslog(LOG_ERR, "IOERROR: failed to index %s: %s",
@@ -702,14 +677,14 @@ static int do_synclogfile(const char *sy
     rx = NULL;
 
 out:
-    strarray_free(folders);
+    strarray_free(mboxnames);
     sync_log_reader_free(slr);
     return r;
 }
 
 static void do_rolling(const char *channel)
 {
-    strarray_t *folders = NULL;
+    strarray_t *mboxnames = NULL;
     sync_log_reader_t *slr;
     int i;
     int r;
@@ -717,9 +692,16 @@ static void do_rolling(const char *chann
     slr = sync_log_reader_create_with_channel(channel);
 
     for (;;) {
-        signals_poll();
+        int sig = signals_poll();
+
+        if (sig == SIGHUP && getenv("CYRUS_ISDAEMON")) {
+            syslog(LOG_DEBUG, "received SIGHUP, shutting down gracefully\n");
+            sync_log_reader_end(slr);
+            shut_down(0);
+        }
+
         if (shutdown_file(NULL, 0))
-            shut_down(EC_TEMPFAIL);
+            shut_down(EX_TEMPFAIL);
 
         r = sync_log_reader_begin(slr);
         if (r) { /* including IMAP_AGAIN */
@@ -727,22 +709,23 @@ static void do_rolling(const char *chann
             continue;
         }
 
-        folders = read_sync_log_items(slr);
+        mboxnames = read_sync_log_items(slr);
 
-        if (folders->count) {
+        if (mboxnames->count) {
             /* have some due items in the queue, try to index them */
             rx = search_begin_update(verbose);
             if (NULL == rx) {
                 /* XXX if xapian, probably don't have conversations enabled? */
-                fatal("could not construct search text receiver", EC_CONFIG);
+                fatal("could not construct search text receiver", EX_CONFIG);
             }
-            for (i = 0; i < folders->count; i++) {
-                const char *mboxname = strarray_nth(folders, i);
+            for (i = 0; i < strarray_size(mboxnames); i++) {
+                const char *mboxname = strarray_nth(mboxnames, i);
+                if (!should_index(mboxname)) continue;
                 if (verbose > 1)
                     syslog(LOG_INFO, "do_rolling: indexing %s", mboxname);
                 r = index_one(mboxname, /*blocking*/0);
                 if (r == IMAP_AGAIN || r == IMAP_MAILBOX_LOCKED) {
-                    /* XXX: alternative, just append to strarray_t *folders ... */
+                    /* XXX: alternative, just append to strarray_t *mboxnames ... */
                     sync_log_channel_append(channel, mboxname);
                 }
                 if (sleepmicroseconds)
@@ -752,59 +735,91 @@ static void do_rolling(const char *chann
             rx = NULL;
         }
 
-        strarray_free(folders);
-        folders = NULL;
+        strarray_free(mboxnames);
+        mboxnames = NULL;
     }
 
     /* XXX - we don't really get here... */
-    strarray_free(folders);
+    strarray_free(mboxnames);
     sync_log_reader_free(slr);
 }
 
-/*
- * Run a search daemon in such a way that the natural shutdown
- * mechanism for Cyrus (sending a SIGTERM to the master process)
- * will cleanly shut down the search daemon too.  For Sphinx
- * this currently means running a loop in a forked process whose
- * job it is to live in the master process' process group and thus
- * receive the SIGTERM that master re-sends.
- */
-static void do_run_daemon(void)
+static int audit_one(const char *mboxname, bitvector_t *unindexed)
 {
-    int r;
+    int r2, r = 0;
+    struct mailbox *mailbox = NULL;
 
-    /* We start the daemon before forking.  This eliminates a
-     * race condition during slot startup by ensuring that
-     * Sphinx is fully running before the rolling squatter
-     * tries to use it. */
-    r = search_start_daemon(verbose);
-    if (r) exit(EC_TEMPFAIL);
-
-    /* tell shut_down() to shut down the searchd too */
-    running_daemon = 1;
-
-    become_daemon();
-    signals_set_shutdown(&shut_down);
-    signals_add_handlers(0);
+    r = mailbox_open_irl(mboxname, &mailbox);
+    if (r) goto done;
 
-    for (;;) {
-        signals_poll();         /* will call shut_down() after SIGTERM */
-        poll(NULL, 0, -1);      /* sleeps until signalled */
+    r = rx->begin_mailbox(rx, mailbox, SEARCH_UPDATE_AUDIT);
+    if (r) goto done;
+
+    r = rx->audit_mailbox(rx, unindexed);
+    if (r) goto done;
+
+done:
+    r2 = rx->end_mailbox(rx, mailbox);
+    mailbox_close(&mailbox);
+    if (!r) r = r2;
+    return r;
+}
+
+
+static int do_audit(const strarray_t *mboxnames)
+{
+    rx = search_begin_update(verbose);
+    if (rx == NULL)
+        return 0;       /* no indexer defined */
+
+    int r = 0;
+    if (!rx->audit_mailbox) {
+        syslog(LOG_ERR, "squatter: indexer does not support audits");
+        r = IMAP_INTERNAL;
+        goto done;
     }
+
+    bitvector_t unindexed = BV_INITIALIZER;
+    int i;
+    for (i = 0 ; i < mboxnames->count ; i++) {
+        const char *mboxname = strarray_nth(mboxnames, i);
+        if (!should_index(mboxname)) continue;
+        r = audit_one(mboxname, &unindexed);
+        if (r == IMAP_MAILBOX_NONEXISTENT)
+            r = 0;
+        if (r == IMAP_MAILBOX_LOCKED)
+            r = 0; /* XXX - try again? */
+        if (r) break;
+        if (sleepmicroseconds)
+            usleep(sleepmicroseconds);
+
+        if (bv_count(&unindexed)) {
+            printf("Unindexed message(s) in %s: ", mboxname);
+            int uid;
+            for (uid = bv_next_set(&unindexed, 0);
+                 uid != -1;
+                 uid = bv_next_set(&unindexed, uid+1)) {
+                printf("%d ", uid);
+            }
+            printf("\n");
+        }
+        bv_clearall(&unindexed);
+    }
+    bv_fini(&unindexed);
+
+done:
+    search_end_update(rx);
+    return r;
 }
 
 static void shut_down(int code)
 {
-    if (running_daemon)
-        search_stop_daemon(verbose);
     seen_done();
-    mboxlist_close();
-    mboxlist_done();
-    annotatemore_close();
-    annotate_done();
 
     cyrus_done();
 
+    index_text_extractor_destroy();
+
     exit(code);
 }
 
@@ -822,16 +837,21 @@ int main(int argc, char **argv)
     int multi_folder = 0;
     int user_mode = 0;
     int compact_flags = 0;
-    const char *fromfile = NULL;
     strarray_t *srctiers = NULL;
     const char *desttier = NULL;
-    enum { UNKNOWN, INDEXER, INDEXFROM, SEARCH, ROLLING, SYNCLOG,
-           START_DAEMON, STOP_DAEMON, RUN_DAEMON, COMPACT } mode = UNKNOWN;
+    char *errstr = NULL;
+    enum { UNKNOWN, INDEXER, SEARCH, ROLLING, SYNCLOG,
+           COMPACT, AUDIT, LIST } mode = UNKNOWN;
 
     setbuf(stdout, NULL);
 
-    while ((opt = getopt(argc, argv, "C:I:N:RXT:S:Fc:de:f:mn:riavz:t:ouh")) != EOF) {
+    while ((opt = getopt(argc, argv, "C:N:RUXPZT:S:Fde:f:mn:riavAz:t:ouhl")) != EOF) {
         switch (opt) {
+        case 'A':
+            if (mode != UNKNOWN) usage(argv[0]);
+            mode = AUDIT;
+            break;
+
         case 'C':               /* alt config file */
             alt_config = optarg;
             break;
@@ -844,14 +864,19 @@ int main(int argc, char **argv)
             compact_flags |= SEARCH_COMPACT_REINDEX;
             break;
 
-        case 'N':
-            name_starts_from = optarg;
+        case 'P':
+            reindex_parts_mode = 1;
+            break;
+
+        case 'Z':
+            /* we have two different flag types for the two different modes,
+             * set both of them even though only one will be used */
+            xapindexed_mode = 1;
+            compact_flags |= SEARCH_COMPACT_XAPINDEXED;
             break;
 
-        case 'I':               /* indexer, using specified mbox/uids in file */
-            if (mode != UNKNOWN && mode != INDEXFROM) usage(argv[0]);
-            fromfile = optarg;
-            mode = INDEXFROM;
+        case 'N':
+            name_starts_from = optarg;
             break;
 
         case 'R':               /* rolling indexer */
@@ -861,6 +886,11 @@ int main(int argc, char **argv)
             batch_mode = 1;
             break;
 
+        case 'l':               /* list paths */
+            if (mode != UNKNOWN) usage(argv[0]);
+            mode = LIST;
+            break;
+
         case 'S':               /* sleep time in seconds */
             sleepmicroseconds = (atof(optarg) * 1000000);
             break;
@@ -869,19 +899,6 @@ int main(int argc, char **argv)
             temp_root_dir = optarg;
             break;
 
-        /* This option is deliberately undocumented, for testing only */
-        case 'c':               /* daemon control mode */
-            if (mode != UNKNOWN) usage(argv[0]);
-            if (!strcmp(optarg, "start"))
-                mode = START_DAEMON;
-            else if (!strcmp(optarg, "stop"))
-                mode = STOP_DAEMON;
-            else if (!strcmp(optarg, "run"))
-                mode = RUN_DAEMON;
-            else
-                usage(argv[0]);
-            break;
-
         case 'd':               /* foreground (with -R) */
             background = 0;
             break;
@@ -913,14 +930,18 @@ int main(int argc, char **argv)
             compact_flags |= SEARCH_COMPACT_COPYONE;
             break;
 
+        case 'U':
+            compact_flags |= SEARCH_COMPACT_ONLYUPGRADE;
+            break;
+
         case 'v':               /* verbose */
             verbose++;
             break;
 
         case 'r':               /* recurse */
-            if (mode != UNKNOWN && mode != INDEXER) usage(argv[0]);
+            if (mode != UNKNOWN && mode != INDEXER && mode != AUDIT) usage(argv[0]);
             recursive_flag = 1;
-            mode = INDEXER;
+            if (mode == UNKNOWN) mode = INDEXER;
             break;
 
         case 'i':               /* incremental mode */
@@ -960,12 +981,6 @@ int main(int argc, char **argv)
     if (mode == UNKNOWN)
         mode = INDEXER;
 
-    /* fork and close fds if required */
-    if (mode == ROLLING && background && !getenv("CYRUS_ISDAEMON")) {
-        become_daemon();
-        init_flags &= ~CYRUSINIT_PERROR;
-    }
-
     if (mode == COMPACT && (!desttier || !srctiers)) {
         /* need both src and dest for compact */
         usage("squatter");
@@ -975,20 +990,24 @@ int main(int argc, char **argv)
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&squat_namespace, 1)) != 0) {
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
-    mboxlist_init(0);
-    mboxlist_open(NULL);
+    /* make sure we're correctly configured */
+    if ((r = search_check_config(&errstr))) {
+        if (errstr)
+            fatal(errstr, EX_CONFIG);
+        else
+            fatal(error_message(r), EX_CONFIG);
+    }
 
     if (mode == ROLLING || mode == SYNCLOG) {
         signals_set_shutdown(&shut_down);
         signals_add_handlers(0);
     }
 
+    index_text_extractor_init(NULL);
+
     switch (mode) {
     case UNKNOWN:
         break;
@@ -1000,42 +1019,37 @@ int main(int argc, char **argv)
         r = do_indexer(&mboxnames);
         syslog(LOG_NOTICE, "done indexing mailboxes");
         break;
-    case INDEXFROM:
-        syslog(LOG_NOTICE, "indexing messages");
-        r = do_indexfrom(fromfile);
-        syslog(LOG_NOTICE, "done indexing messages");
-        break;
     case SEARCH:
         if (recursive_flag && optind == argc) usage(argv[0]);
         expand_mboxnames(&mboxnames, argc-optind, (const char **)argv+optind, user_mode);
         r = do_search(query, !multi_folder, &mboxnames);
         break;
     case ROLLING:
+        if (background && !getenv("CYRUS_ISDAEMON"))
+            become_daemon();
         do_rolling(channel);
         /* never returns */
         break;
     case SYNCLOG:
         r = do_synclogfile(synclogfile);
         break;
-    case START_DAEMON:
-        if (optind != argc) usage("squatter");
-        search_start_daemon(verbose);
-        break;
-    case STOP_DAEMON:
-        if (optind != argc) usage("squatter");
-        search_stop_daemon(verbose);
-        break;
-    case RUN_DAEMON:
-        if (optind != argc) usage("squatter");
-        do_run_daemon();
-        break;
     case COMPACT:
         if (recursive_flag && optind == argc) usage(argv[0]);
         expand_mboxnames(&mboxnames, argc-optind, (const char **)argv+optind, user_mode);
         r = do_compact(&mboxnames, srctiers, desttier, compact_flags);
         break;
+    case AUDIT:
+        if (recursive_flag && optind == argc) usage(argv[0]);
+        expand_mboxnames(&mboxnames, argc-optind, (const char **)argv+optind, user_mode);
+        r = do_audit(&mboxnames);
+        break;
+    case LIST:
+        if (recursive_flag && optind == argc) usage(argv[0]);
+        expand_mboxnames(&mboxnames, argc-optind, (const char **)argv+optind, user_mode);
+        r = do_list(&mboxnames);
+        break;
     }
 
     strarray_fini(&mboxnames);
-    shut_down(r ? EC_TEMPFAIL : 0);
+    shut_down(r ? EX_TEMPFAIL : 0);
 }
diff -pruN 3.0.13-5/imap/statuscache_db.c 3.2.0-3/imap/statuscache_db.c
--- 3.0.13-5/imap/statuscache_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/statuscache_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -72,241 +72,367 @@
 
 #define DB config_statuscache_db
 
-static struct db *statuscachedb;
-static int statuscache_dbopen = 0;
+static struct db *statuscachedb = NULL;
+static int _initted = 0;
 
-char *statuscache_filename(void)
-{
-    const char *fname = config_getstring(IMAPOPT_STATUSCACHE_DB_PATH);
-
-    if (fname)
-        return xstrdup(fname);
-
-    /* create db file name */
-    return strconcat(config_dir, FNAME_STATUSCACHEDB, (char *)NULL);
-}
+/********************* CACHE METHODS ***********************/
 
-EXPORTED void statuscache_open(void)
+static void statuscache_open(void)
 {
-    char *fname = statuscache_filename();
-    int ret;
+    if (!config_getswitch(IMAPOPT_STATUSCACHE))
+        return;
+
+    char *fname = xstrdupnull(config_getstring(IMAPOPT_STATUSCACHE_DB_PATH));
+    if (!fname)
+        fname = strconcat(config_dir, FNAME_STATUSCACHEDB, (char *)NULL);
 
-    ret = cyrusdb_open(DB, fname, CYRUSDB_CREATE, &statuscachedb);
-    if (ret != 0) {
+    int r = cyrusdb_open(DB, fname, CYRUSDB_CREATE, &statuscachedb);
+    if (r) {
         syslog(LOG_ERR, "DBERROR: opening %s: %s", fname,
-               cyrusdb_strerror(ret));
+               cyrusdb_strerror(r));
         syslog(LOG_ERR, "statuscache in degraded mode");
-        goto out;
+        statuscachedb = NULL;
     }
 
-    statuscache_dbopen = 1;
-out:
     free(fname);
 }
 
-EXPORTED void statuscache_close(void)
+static void statuscache_close(void)
 {
-    int r;
+    if (!statuscachedb) return;
 
-    if (statuscache_dbopen) {
-        r = cyrusdb_close(statuscachedb);
-        if (r) {
-            syslog(LOG_ERR, "DBERROR: error closing statuscache: %s",
-                   cyrusdb_strerror(r));
-        }
-        statuscache_dbopen = 0;
+    int r = cyrusdb_close(statuscachedb);
+    if (r) {
+        syslog(LOG_ERR, "DBERROR: error closing statuscache: %s",
+              cyrusdb_strerror(r));
     }
+
+    statuscachedb = NULL;
 }
 
-HIDDEN void statuscache_fill(struct statusdata *sdata, const char *userid,
-                      struct mailbox *mailbox, unsigned statusitems,
-                      unsigned numrecent, unsigned numunseen)
+static void done_cb(void *rock __attribute__((unused)))
 {
-    assert(sdata);
-    assert(mailbox);
-
-    sdata->userid = userid;
-    sdata->statusitems = statusitems;
+    statuscache_close();
+}
 
-    sdata->messages = mailbox->i.exists;
-    sdata->recent = numrecent;
-    sdata->uidnext = mailbox->i.last_uid+1;
-    sdata->uidvalidity = mailbox->i.uidvalidity;
-    sdata->unseen = numunseen;
-    sdata->highestmodseq = mailbox->i.highestmodseq;
+static void init_internal()
+{
+    if (_initted) return;
+    statuscache_open();
+    cyrus_modules_add(done_cb, NULL);
+    _initted = 1;
 }
 
-EXPORTED void statuscache_done(void)
+static void statuscache_buildkey(const char *mboxname, const char *userid,
+                                 struct buf *buf)
 {
-    /* DB->done() handled by cyrus_done() */
+    buf_setcstr(buf, mboxname);
+    /* double % is a safe separator, it can't exist in a mailboxname */
+    buf_putc(buf, '%');
+    if (userid) {
+        buf_putc(buf, '%');
+        buf_appendcstr(buf, userid);
+    }
 }
 
-static char *statuscache_buildkey(const char *mailboxname, const char *userid,
-                                  size_t *keylen)
+static void statuscache_read_index(const char *mboxname, struct statusdata *sdata)
 {
-    static char key[MAX_MAILBOX_BUFFER];
-    size_t len;
+    struct buf keybuf = BUF_INITIALIZER;
+    const char *data = NULL;
+    size_t datalen = 0;
 
-    /* Build statuscache key */
-    len = strlcpy(key, mailboxname, sizeof(key));
-    /* double % is a safe separator, it can't exist in a mailboxname */
-    key[len++] = '%';
-    key[len++] = '%';
-    if (userid)
-        len += strlcpy(key + len, userid, sizeof(key) - len);
+    /* Don't access DB if it hasn't been opened */
+    if (!statuscachedb)
+        return;
+
+    /* Check if there is an entry in the database */
+    statuscache_buildkey(mboxname, NULL, &keybuf);
+    int r = cyrusdb_fetch(statuscachedb, keybuf.s, keybuf.len, &data, &datalen, NULL);
+    buf_free(&keybuf);
 
-    *keylen = len;
+    if (r || !data || !datalen)
+        return;
+
+    const char *dend = data + datalen;
+
+    char *p = (char *)data;
+    if (*p++ != 'I') return;
+    if (*p++ != ' ') return;
+
+    unsigned version = (unsigned) strtoul(p, &p, 10);
+    if (version != (unsigned) STATUSCACHE_VERSION) {
+        /* Wrong version */
+        return;
+    }
+
+    if (*p++ != ' ') return;
+    if (*p++ != '(') return;
+
+    // read the matched items
+    if (p < dend) sdata->messages = strtoul(p, &p, 10);
+    if (p < dend) sdata->uidnext = strtoul(p, &p, 10);
+    if (p < dend) sdata->uidvalidity = strtoul(p, &p, 10);
+    if (p < dend) sdata->mboptions = strtoul(p, &p, 10);
+    if (p < dend) sdata->size = strtoull(p, &p, 10);
+    if (p < dend) sdata->createdmodseq = strtoull(p, &p, 10);
+    if (p < dend) sdata->highestmodseq = strtoull(p, &p, 10);
+
+    if (*p++ != ')') return;
+
+    /* Sanity check the data */
+    if (!sdata->highestmodseq)
+        return;
 
-    return key;
+    sdata->statusitems |= STATUS_INDEXITEMS | STATUS_UIDVALIDITY;
 }
 
-/*
- * Performs a STATUS command - note: state MAY be NULL here.
- */
-EXPORTED int status_lookup(const char *mboxname, const char *userid,
-                  unsigned statusitems, struct statusdata *sdata)
+static void statuscache_read_seen(const char *mboxname, const char *userid,
+                                  struct statusdata *sdata)
 {
-    struct mailbox *mailbox = NULL;
-    unsigned numrecent = 0;
-    unsigned numunseen = 0;
-    unsigned c_statusitems;
-    int r;
+    struct buf keybuf = BUF_INITIALIZER;
+    const char *data = NULL;
+    size_t datalen = 0;
 
-    /* Check status cache if possible */
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        /* Do actual lookup of cache item. */
-        r = statuscache_lookup(mboxname, userid, statusitems, sdata);
+    if (!userid)
+        return;
 
-        /* Seen/recent status uses "push" invalidation events from
-         * seen_db.c.   This avoids needing to open cyrus.header to get
-         * the mailbox uniqueid to open the seen db and get the
-         * unseen_mtime and recentuid.
-         */
+    // if no messages, other counts must also be zero
+    if (!sdata->messages) {
+        sdata->recent = 0;
+        sdata->unseen = 0;
+        sdata->userid = userid;
+        sdata->statusitems |= STATUS_SEENITEMS;
+        return;
+    }
 
-        if (!r) {
-            syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'yes'",
-                   mboxname, userid, statusitems);
-            return 0;
-        }
+    /* Don't access DB if it hasn't been opened */
+    if (!statuscachedb)
+        return;
 
-        syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'no'",
-               mboxname, userid, statusitems);
-    }
+    // we must have a HIGHESTMODSEQ to compare against
+    if (!(sdata->statusitems & STATUS_HIGHESTMODSEQ))
+        return;
 
-    /* Missing or invalid cache entry */
-    r = mailbox_open_irl(mboxname, &mailbox);
-    if (r) return r;
+    /* Check if there is an entry in the database */
+    statuscache_buildkey(mboxname, userid, &keybuf);
+    int r = cyrusdb_fetch(statuscachedb, keybuf.s, keybuf.len, &data, &datalen, NULL);
+    buf_free(&keybuf);
+
+    if (r || !data || !datalen)
+        return;
+
+    const char *dend = data + datalen;
+    char *p = (char *)data;
+    if (*p++ != 'S') return;
+    if (*p++ != ' ') return;
 
-    /* We always have message count, uidnext,
-       uidvalidity, and highestmodseq for cache */
-    c_statusitems = STATUS_MESSAGES | STATUS_UIDNEXT |
-                    STATUS_UIDVALIDITY | STATUS_HIGHESTMODSEQ;
-
-    if (!mailbox->i.exists) {
-        /* no messages, so these two must also be zero */
-        c_statusitems |= STATUS_RECENT | STATUS_UNSEEN;
+    unsigned version = (unsigned) strtoul(p, &p, 10);
+    if (version != (unsigned) STATUSCACHE_VERSION) {
+        /* Wrong version */
+        return;
     }
-    else if (statusitems & (STATUS_RECENT | STATUS_UNSEEN)) {
-        /* Read \Seen state */
-        struct seqset *seq = NULL;
-        int internalseen = mailbox_internal_seen(mailbox, userid);
-        unsigned recentuid;
 
-        if (internalseen) {
-            recentuid = mailbox->i.recentuid;
-        } else {
-            struct seen *seendb = NULL;
-            struct seendata sd = SEENDATA_INITIALIZER;
+    if (*p++ != ' ') return;
+    if (*p++ != '(') return;
 
-            r = seen_open(userid, SEEN_CREATE, &seendb);
-            if (!r) r = seen_read(seendb, mailbox->uniqueid, &sd);
-            seen_close(&seendb);
-            if (r) goto done;
+    // read the matched items
+    if (p < dend) sdata->recent = strtoul(p, &p, 10);
+    if (p < dend) sdata->unseen = strtoul(p, &p, 10);
+    modseq_t highestmodseq = strtoull(p, &p, 10);
 
-            recentuid = sd.lastuid;
-            seq = seqset_parse(sd.seenuids, NULL, recentuid);
-            seen_freedata(&sd);
-        }
+    if (*p++ != ')') return;
 
-        struct mailbox_iter *iter = mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
-        const message_t *msg;
-        while ((msg = mailbox_iter_step(iter))) {
-            const struct index_record *record = msg_record(msg);
-            if (record->uid > recentuid)
-                numrecent++;
-            if (internalseen) {
-                if (!(record->system_flags & FLAG_SEEN))
-                    numunseen++;
-            }
-            else {
-                if (!seqset_ismember(seq, record->uid))
-                    numunseen++;
-            }
+    // doesn't match non-unseen key
+    if (highestmodseq != sdata->highestmodseq)
+        return;
+
+    sdata->userid = userid;
+    sdata->statusitems |= STATUS_SEENITEMS;
+}
+
+static int statuscache_lookup(const char *mboxname, const char *userid,
+                       unsigned statusitems, struct statusdata *sdata)
+{
+    // nothing to read!
+    if (!(statusitems & (STATUS_INDEXITEMS|STATUS_SEENITEMS)))
+        return 0;
+
+    init_internal();
+
+    statuscache_read_index(mboxname, sdata);
+    if (statusitems & STATUS_SEENITEMS)
+        statuscache_read_seen(mboxname, userid, sdata);
+
+    // did we get everything we wanted?
+    if ((sdata->statusitems & statusitems) != statusitems)
+        return IMAP_NO_NOSUCHMSG;
+
+    return 0;
+}
+
+static int statuscache_store(const char *mboxname,
+                             struct statusdata *sdata,
+                             struct txn **tidptr)
+{
+    struct buf keybuf = BUF_INITIALIZER;
+    struct buf databuf = BUF_INITIALIZER;
+    int r = 0;
+
+    statuscache_buildkey(mboxname, /*userid*/NULL, &keybuf);
+
+    /* if we don't have a full index, just nuke the key */
+    if (!sdata || (sdata->statusitems & STATUS_INDEXITEMS) != STATUS_INDEXITEMS) {
+        r = cyrusdb_delete(statuscachedb, keybuf.s, keybuf.len, tidptr, 1);
+        if (r != CYRUSDB_OK) {
+            syslog(LOG_ERR, "DBERROR: error deleting statuscache for: %s (%s)",
+                   mboxname, cyrusdb_strerror(r));
         }
-        mailbox_iter_done(&iter);
-        seqset_free(seq);
+        goto done;
+    }
 
-        /* we've calculated the correct values for both */
-        c_statusitems |= STATUS_RECENT | STATUS_UNSEEN;
+
+    buf_printf(&databuf,
+                       "I %u (%u %u %u %u %llu " MODSEQ_FMT " " MODSEQ_FMT ")",
+                       STATUSCACHE_VERSION,
+                       sdata->messages, sdata->uidnext,
+                       sdata->uidvalidity, sdata->mboptions, sdata->size,
+                       sdata->createdmodseq, sdata->highestmodseq);
+
+    r = cyrusdb_store(statuscachedb, keybuf.s, keybuf.len, databuf.s, databuf.len, tidptr);
+
+    if (r != CYRUSDB_OK) {
+        syslog(LOG_ERR, "DBERROR: error updating database: %s (%s)",
+               mboxname, cyrusdb_strerror(r));
+        goto done;
     }
 
-    statuscache_fill(sdata, userid, mailbox, c_statusitems,
-                     numrecent, numunseen);
+    if ((sdata->statusitems & STATUS_SEENITEMS) != STATUS_SEENITEMS)
+        goto done;
 
-    /* cache the new value while unlocking */
-    mailbox_unlock_index(mailbox, sdata);
+    // if there's no userid, we don't store this stuff
+    if (!sdata->userid)
+        goto done;
 
-  done:
-    mailbox_close(&mailbox);
+    statuscache_buildkey(mboxname, sdata->userid, &keybuf);
+
+    /* The trailing whitespace is necessary because we
+     * use non-length-based functions to parse the values.
+     * Any non-digit char would be fine, but whitespace
+     * looks less ugly in dbtool output */
+    buf_reset(&databuf);
+    buf_printf(&databuf,
+                       "S %u (%u %u " MODSEQ_FMT ")",
+                       STATUSCACHE_VERSION,
+                       sdata->recent, sdata->unseen,
+                       sdata->highestmodseq);
+
+    r = cyrusdb_store(statuscachedb, keybuf.s, keybuf.len, databuf.s, databuf.len, tidptr);
+
+    if (r != CYRUSDB_OK) {
+        syslog(LOG_ERR, "DBERROR: error updating database: %s (%s)",
+               mboxname, cyrusdb_strerror(r));
+        goto done;
+    }
+
+done:
+    buf_free(&keybuf);
+    buf_free(&databuf);
     return r;
 }
 
-/*
- * Performs a STATUS command on an open mailbox - note: state MAY be NULL here.
- */
-EXPORTED int status_lookup_mailbox(struct mailbox *mailbox, const char *userid,
-                                  unsigned statusitems, struct statusdata *sdata)
+HIDDEN int statuscache_invalidate(const char *mboxname, struct statusdata *sdata)
 {
-    /* XXX Apart from not opening mailbox, this is a copy of status_lookup.
-     If it is here to stay, then refactor with status_lookup. */
-    unsigned numrecent = 0;
-    unsigned numunseen = 0;
-    unsigned c_statusitems;
-    int r = 0;
-
-    /* Check status cache if possible */
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        /* Do actual lookup of cache item. */
-        r = statuscache_lookup(mailbox->name, userid, statusitems, sdata);
+    int doclose = 0;
+    struct txn *tid = NULL;
 
-        /* Seen/recent status uses "push" invalidation events from
-         * seen_db.c.   This avoids needing to open cyrus.header to get
-         * the mailbox uniqueid to open the seen db and get the
-         * unseen_mtime and recentuid.
-         */
+    /* if it's disabled then skip */
+    if (!config_getswitch(IMAPOPT_STATUSCACHE))
+        return 0;
 
-        if (!r) {
-            syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'yes'",
-                   mailbox->name, userid, statusitems);
+    /* if it's not already open, open and close it for just this */
+    if (!statuscachedb) {
+        statuscache_open();
+        // failed to open, oh well
+        if (!statuscachedb)
             return 0;
-        }
-
-        syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'no'",
-               mailbox->name, userid, statusitems);
+        doclose = 1;
     }
 
-    r = 0;
+    int r = statuscache_store(mboxname, sdata, &tid);
 
-    /* We always have message count, uidnext,
-       uidvalidity, and highestmodseq for cache */
-    c_statusitems = STATUS_MESSAGES | STATUS_UIDNEXT |
-                    STATUS_UIDVALIDITY | STATUS_HIGHESTMODSEQ;
-
-    if (!mailbox->i.exists) {
-        /* no messages, so these two must also be zero */
-        c_statusitems |= STATUS_RECENT | STATUS_UNSEEN;
+    if (!r) {
+        cyrusdb_commit(statuscachedb, tid);
+    }
+    else {
+        syslog(LOG_NOTICE, "DBERROR: failed to store statuscache data for %s", mboxname);
+        if (tid) cyrusdb_abort(statuscachedb, tid);
     }
-    else if (statusitems & (STATUS_RECENT | STATUS_UNSEEN)) {
+
+    // if we opened the DB, close it now
+    if (doclose)
+        statuscache_close();
+
+    return 0;
+}
+
+
+
+/****************** STATUSDATA FILLING METHODS ************************/
+
+HIDDEN void status_fill_mbentry(const mbentry_t *mbentry, struct statusdata *sdata)
+{
+    assert(mbentry);
+    assert(sdata);
+
+    sdata->uidvalidity = mbentry->uidvalidity;
+    sdata->mailboxid = mbentry->uniqueid;
+
+    sdata->statusitems |= STATUS_MBENTRYITEMS;
+}
+
+HIDDEN void status_fill_mailbox(struct mailbox *mailbox, struct statusdata *sdata)
+{
+    assert(mailbox);
+    assert(sdata);
+
+    sdata->messages = mailbox->i.exists;
+    sdata->uidnext = mailbox->i.last_uid+1;
+    sdata->mboptions = mailbox->i.options;
+    sdata->size = mailbox->i.quota_mailbox_used;
+    sdata->createdmodseq = mailbox->i.createdmodseq;
+    sdata->highestmodseq = mailbox->i.highestmodseq;
+
+    // mbentry items are also available from an open mailbox
+    sdata->uidvalidity = mailbox->i.uidvalidity;
+    sdata->mailboxid = mailbox->uniqueid;
+
+    sdata->statusitems |= STATUS_INDEXITEMS | STATUS_MBENTRYITEMS;
+}
+
+HIDDEN void status_fill_seen(const char *userid, struct statusdata *sdata,
+                                  unsigned numrecent, unsigned numunseen)
+{
+    assert(userid);
+    assert(sdata);
+
+    // we need a matching parent record to exist for these values to be valid
+    assert(sdata->statusitems & STATUS_HIGHESTMODSEQ);
+
+    sdata->userid = userid;
+    sdata->recent = numrecent;
+    sdata->unseen = numunseen;
+
+    sdata->statusitems |= STATUS_SEENITEMS;
+}
+
+static int status_load_mailbox(struct mailbox *mailbox, const char *userid,
+                               unsigned statusitems, struct statusdata *sdata)
+{
+    status_fill_mailbox(mailbox, sdata);
+
+    if ((statusitems & STATUS_SEENITEMS) && mailbox->i.exists) {
+        unsigned numrecent = 0;
+        unsigned numunseen = 0;
         /* Read \Seen state */
         struct seqset *seq = NULL;
         int internalseen = mailbox_internal_seen(mailbox, userid);
@@ -318,10 +444,10 @@ EXPORTED int status_lookup_mailbox(struc
             struct seen *seendb = NULL;
             struct seendata sd = SEENDATA_INITIALIZER;
 
-            r = seen_open(userid, SEEN_CREATE, &seendb);
+            int r = seen_open(userid, SEEN_CREATE, &seendb);
             if (!r) r = seen_read(seendb, mailbox->uniqueid, &sd);
             seen_close(&seendb);
-            if (r) goto done;
+            if (r) return r;
 
             recentuid = sd.lastuid;
             seq = seqset_parse(sd.seenuids, NULL, recentuid);
@@ -344,184 +470,122 @@ EXPORTED int status_lookup_mailbox(struc
             }
         }
         mailbox_iter_done(&iter);
+        seqset_free(seq);
 
-        /* we've calculated the correct values for both */
-        c_statusitems |= STATUS_RECENT | STATUS_UNSEEN;
+        status_fill_seen(userid, sdata, numrecent, numunseen);
     }
 
-    statuscache_fill(sdata, userid, mailbox, c_statusitems,
-                     numrecent, numunseen);
+    statuscache_invalidate(mailbox->name, sdata);
 
-  done:
-    return r;
+    return 0;
 }
 
-
-
-EXPORTED int statuscache_lookup(const char *mboxname, const char *userid,
-                       unsigned statusitems, struct statusdata *sdata)
+static int status_lookup_internal(const char *mboxname, const char *userid,
+                                  unsigned statusitems, struct statusdata *sdata)
 {
-    size_t keylen, datalen;
+    struct mailbox *mailbox = NULL;
     int r = 0;
-    const char *data = NULL, *dend;
-    char *p, *key = statuscache_buildkey(mboxname, userid, &keylen);
-    unsigned version;
 
-    /* Don't access DB if it hasn't been opened */
-    if (!statuscache_dbopen)
-        return IMAP_NO_NOSUCHMSG;
-
-    /* Check if there is an entry in the database */
-    do {
-        r = cyrusdb_fetch(statuscachedb, key, keylen, &data, &datalen, NULL);
-    } while (r == CYRUSDB_AGAIN);
+    /* Check status cache if possible */
+    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
+        /* Do actual lookup of cache item. */
+        r = statuscache_lookup(mboxname, userid, statusitems, sdata);
 
-    if (r || !data || ((size_t) datalen < sizeof(unsigned))) {
-        return IMAP_NO_NOSUCHMSG;
-    }
+        /* Seen/recent status uses "push" invalidation events from
+         * seen_db.c.   This avoids needing to open cyrus.header to get
+         * the mailbox uniqueid to open the seen db and get the
+         * unseen_mtime and recentuid.
+         */
 
-    dend = data + datalen;
+        if (!r) {
+            syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'yes'",
+                   mboxname, userid, statusitems);
+            return 0;
+        }
 
-    version = (unsigned) strtoul(data, &p, 10);
-    if (version != (unsigned) STATUSCACHE_VERSION) {
-        /* Wrong version */
-        return IMAP_NO_NOSUCHMSG;
+        syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'no'",
+               mboxname, userid, statusitems);
     }
 
-    if (p < dend) sdata->statusitems = strtoul(p, &p, 10);
-    if (p < dend) sdata->messages = strtoul(p, &p, 10);
-    if (p < dend) sdata->recent = strtoul(p, &p, 10);
-    if (p < dend) sdata->uidnext = strtoul(p, &p, 10);
-    if (p < dend) sdata->uidvalidity = strtoul(p, &p, 10);
-    if (p < dend) sdata->unseen = strtoul(p, &p, 10);
-    if (p < dend) sdata->highestmodseq = strtoull(p, &p, 10);
+    /* Missing or invalid cache entry */
+    r = mailbox_open_irl(mboxname, &mailbox);
+    if (r) return r;
 
-    /* Sanity check the data */
-    if (!sdata->statusitems || !sdata->uidnext || !sdata->uidvalidity) {
-        return IMAP_NO_NOSUCHMSG;
-    }
+    r = status_load_mailbox(mailbox, userid, statusitems, sdata);
 
-    if ((sdata->statusitems & statusitems) != statusitems) {
-        /* Don't have all of the requested information */
-        return IMAP_NO_NOSUCHMSG;
-    }
+    /* cache the new value while unlocking */
+    if (!r) mailbox_unlock_index(mailbox, sdata);
+    mailbox_close(&mailbox);
 
-    return 0;
+    return r;
 }
 
-static int statuscache_store(const char *mboxname,
-                             struct statusdata *sdata,
-                             struct txn **tidptr)
+EXPORTED int status_lookup_mbentry(const mbentry_t *mbentry, const char *userid,
+                                  unsigned statusitems, struct statusdata *sdata)
 {
-    char data[250];  /* enough room for 11*(UULONG + SP) */
-    size_t keylen, datalen;
-    char *key = statuscache_buildkey(mboxname, sdata->userid, &keylen);
-    int r;
-
-    /* Don't access DB if it hasn't been opened */
-    if (!statuscache_dbopen)
+    // check if we can get everything we need from the mbentry
+    status_fill_mbentry(mbentry, sdata);
+    if ((sdata->statusitems & statusitems) == statusitems)
         return 0;
 
-    /* The trailing whitespace is necessary because we
-     * use non-length-based functions to parse the values.
-     * Any non-digit char would be fine, but whitespace
-     * looks less ugly in dbtool output */
-    datalen = snprintf(data, sizeof(data),
-                       "%u %u %u %u %u %u %u " MODSEQ_FMT " ",
-                       STATUSCACHE_VERSION,
-                       sdata->statusitems, sdata->messages,
-                       sdata->recent, sdata->uidnext,
-                       sdata->uidvalidity, sdata->unseen,
-                       sdata->highestmodseq);
-
-    r = cyrusdb_store(statuscachedb, key, keylen, data, datalen, tidptr);
+    return status_lookup_internal(mbentry->name, userid, statusitems, sdata);
+}
 
-    if (r != CYRUSDB_OK) {
-        syslog(LOG_ERR, "DBERROR: error updating database: %s (%s)",
-               mboxname, cyrusdb_strerror(r));
+EXPORTED int status_lookup_mboxname(const char *mboxname, const char *userid,
+                                    unsigned statusitems, struct statusdata *sdata)
+{
+    // we want an mbentry first, just in case we can get everything from there
+    if (statusitems & STATUS_MAILBOXID) {
+        mbentry_t *mbentry = NULL;
+        int r = mboxlist_lookup_allow_all(mboxname, &mbentry, NULL);
+        if (r) return r;
+        r = status_lookup_mbentry(mbentry, userid, statusitems, sdata);
+        mboxlist_entry_free(&mbentry);
+        return r;
     }
 
-    return r;
+    return status_lookup_internal(mboxname, userid, statusitems, sdata);
 }
 
-struct statuscache_deleterock {
-    struct db *db;
-    struct txn *tid;
-};
-
-static int delete_cb(void *rockp,
-                     const char *key, size_t keylen,
-                     const char *data __attribute__((unused)),
-                     size_t datalen __attribute__((unused)))
-{
-    int r;
-    char buf[4096];
-    struct statuscache_deleterock *rp = (struct statuscache_deleterock *)rockp;
-
-    /* error if it's too big */
-    if (keylen > 4096)
-        return 1;
-
-    /* we need to cache a copy, because the delete might re-map
-     * the mmap space */
-    memcpy(buf, key, keylen);
 
-    /* Delete db entry */
-    r = cyrusdb_delete(rp->db, buf, keylen, &rp->tid, 1);
-    if (r != CYRUSDB_OK) {
-        syslog(LOG_ERR, "DBERROR: error deleting from database: %s",
-               cyrusdb_strerror(r));
-    }
-
-    return 0;
+// this one has literally no smarts at all
+EXPORTED int status_lookup_mbname(const mbname_t *mbname, const char *userid,
+                                  unsigned statusitems, struct statusdata *sdata)
+{
+    return status_lookup_mboxname(mbname_intname(mbname), userid, statusitems, sdata);
 }
 
-HIDDEN int statuscache_invalidate(const char *mboxname, struct statusdata *sdata)
+/*
+ * Performs a STATUS command on an open mailbox
+ */
+EXPORTED int status_lookup_mailbox(struct mailbox *mailbox, const char *userid,
+                                   unsigned statusitems, struct statusdata *sdata)
 {
-    size_t keylen;
-    char *key;
-    int r;
-    int doclose = 0;
-    struct statuscache_deleterock drock;
-
-    /* if it's disabled then skip */
-    if (!config_getswitch(IMAPOPT_STATUSCACHE))
+    // check if we already have all the data we need (includes any possible mbentry)
+    status_fill_mailbox(mailbox, sdata);
+    if ((sdata->statusitems & statusitems) == statusitems)
         return 0;
 
-    /* Open DB if it hasn't been opened */
-    if (!statuscache_dbopen) {
-        statuscache_open();
-        doclose = 1;
-    }
-
-    drock.db = statuscachedb;
-    drock.tid = NULL;
-
-    key = statuscache_buildkey(mboxname, /*userid*/NULL, &keylen);
-
-    r = cyrusdb_foreach(drock.db, key, keylen, NULL, delete_cb,
-                    &drock, &drock.tid);
+    /* Check status cache if possible */
+    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
+        /* Do actual lookup of cache item. */
+        int r = statuscache_lookup(mailbox->name, userid, statusitems, sdata);
 
-    if (r != CYRUSDB_OK) {
-        syslog(LOG_ERR, "DBERROR: error invalidating: %s (%s)",
-               mboxname, cyrusdb_strerror(r));
-    }
+        /* Seen/recent status uses "push" invalidation events from
+         * seen_db.c.   This avoids needing to open cyrus.header to get
+         * the mailbox uniqueid to open the seen db and get the
+         * unseen_mtime and recentuid.
+         */
 
-    if (!r && sdata) {
-        r = statuscache_store(mboxname, sdata, &drock.tid);
-    }
+        if (!r) {
+            syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'yes'",
+                   mailbox->name, userid, statusitems);
+            return 0;
+        }
 
-    if (r == CYRUSDB_OK) {
-        cyrusdb_commit(drock.db, drock.tid);
-    }
-    else {
-        syslog(LOG_NOTICE, "DBERROR: failed to store statuscace data for %s", mboxname);
-        if (drock.tid) cyrusdb_abort(drock.db, drock.tid);
+        syslog(LOG_DEBUG, "statuscache, '%s', '%s', '0x%02x', 'no'",
+               mailbox->name, userid, statusitems);
     }
 
-    if (doclose)
-        statuscache_close();
-
-    return 0;
+    return status_load_mailbox(mailbox, userid, statusitems, sdata);
 }
-
diff -pruN 3.0.13-5/imap/statuscache.h 3.2.0-3/imap/statuscache.h
--- 3.0.13-5/imap/statuscache.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/statuscache.h	2020-04-24 02:03:00.000000000 +0000
@@ -44,44 +44,31 @@
 #define STATUSCACHE_H
 
 #include "mailbox.h"
+#include "mboxlist.h"
 
 /* name of the statuscache database */
 #define FNAME_STATUSCACHEDB "/statuscache.db"
-#define STATUSCACHE_VERSION 4
-
-/* Return the filename of the statuscache database,
- * used for XWARMUP.  Returns a new string which must
- * be free()d by the caller. */
-extern char *statuscache_filename(void);
-
-/* open the statuscache db */
-extern void statuscache_open(void);
+#define STATUSCACHE_VERSION 8
 
 /* fill a statuscache entry */
-extern void statuscache_fill(struct statusdata *sdata, const char *userid,
-                             struct mailbox *mailbox, unsigned statusitems,
+extern void status_fill_mbentry(const mbentry_t *mbentry, struct statusdata *sdata);
+extern void status_fill_mailbox(struct mailbox *mailbox, struct statusdata *sdata);
+extern void status_fill_seen(const char *userid, struct statusdata *sdata,
                              unsigned numrecent, unsigned numunseen);
 
-/* lookup a single statuscache entry or open the mailbox and caluclate it */
-extern int status_lookup(const char *mboxname, const char *userid,
-                         unsigned statusitems, struct statusdata *sdata);
+/* lookup a single statuscache entry or open the mailbox and calculate it */
+extern int status_lookup_mboxname(const char *mboxname, const char *userid,
+                                  unsigned statusitems, struct statusdata *sdata);
+extern int status_lookup_mbname(const mbname_t *mbname, const char *userid,
+                                unsigned statusitems, struct statusdata *sdata);
+extern int status_lookup_mbentry(const mbentry_t *mbentry, const char *userid,
+                                 unsigned statusitems, struct statusdata *sdata);
 extern int status_lookup_mailbox(struct mailbox *mailbox, const char *userid,
-                         unsigned statusitems, struct statusdata *sdata);
-
-/* lookup a single statuscache entry and return result, or error if it
-   doesn't exist or doesn't have the fields we need */
-extern int statuscache_lookup(const char *mboxname, const char *userid,
-                              unsigned statusitems, struct statusdata *sdata);
+                                 unsigned statusitems, struct statusdata *sdata);
 
 /* invalidate (delete) statuscache entry for the mailbox,
    optionally writing the data for one user in the same transaction */
 extern int statuscache_invalidate(const char *mboxname,
                                   struct statusdata *sdata);
 
-/* close the database */
-extern void statuscache_close(void);
-
-/* done with database stuff */
-extern void statuscache_done(void);
-
 #endif /* STATUSCACHE_H */
diff -pruN 3.0.13-5/imap/sync_client.c 3.2.0-3/imap/sync_client.c
--- 3.0.13-5/imap/sync_client.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_client.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* sync_client.c -- Cyrus synchonization client
+/* sync_client.c -- Cyrus synchronization client
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
@@ -54,6 +54,7 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/wait.h>
@@ -64,7 +65,6 @@
 #include "global.h"
 #include "append.h"
 #include "mboxlist.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "quota.h"
 #include "xmalloc.h"
@@ -118,22 +118,18 @@ static void shut_down(int code)
     in_shutdown = 1;
 
     seen_done();
-    annotatemore_close();
-    annotate_done();
-    quotadb_close();
-    quotadb_done();
-    mboxlist_close();
-    mboxlist_done();
     cyrus_done();
     exit(code);
 }
 
-static int usage(const char *name)
+static int usage(const char *name, const char *message)
 {
+    if (message)
+        fprintf(stderr, "%s\n\n", message);
     fprintf(stderr,
-            "usage: %s -S <servername> [-C <alt_config>] [-r] [-v] mailbox...\n", name);
+            "Usage: %s -S <servername> [-C <alt_config>] [-r] [-v] mailbox...\n", name);
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 EXPORTED void fatal(const char *s, int code)
@@ -209,6 +205,7 @@ static int do_unmailbox(const char *mbox
     struct mailbox *mailbox = NULL;
     int r;
 
+    /* XXX - this should be looking for an explicit tombstone record locally */
     r = mailbox_open_irl(mboxname, &mailbox);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
         r = sync_folder_delete(mboxname, sync_be, flags);
@@ -372,9 +369,6 @@ static int do_sync(sync_log_reader_t *sl
 
     /* And then run tasks. */
 
-    /* we want to be able to defer items to the subsequent sync log */
-    sync_log_init();
-
     for (action = quota_list->head; action; action = action->next) {
         if (!action->active)
             continue;
@@ -456,6 +450,9 @@ static int do_sync(sync_log_reader_t *sl
         }
     }
 
+    /* XXX - need to process this in sets of users at a time, such that we never split
+     * on a user boundary.  This will require a data structure change to carry the list
+     * of mailboxes in per-user sets */
     for (action = mailbox_list->head; action; action = action->next) {
         if (!action->active)
             continue;
@@ -478,6 +475,15 @@ static int do_sync(sync_log_reader_t *sl
     r = do_restart();
     if (r) goto cleanup;
 
+    /* XXX - is unmailbox used much anyway - we need to see if it's logged for a rename,
+     * e.g.
+     * RENAME A B:
+     *  MAILBOX A
+     *  MAILBOX B
+     *  UNMAILBOX A
+     *
+     * suggestion: PROMOTE ALL UNMAILBOX on user accounts to USER foo
+     */
     for (action = unmailbox_list->head; action; action = action->next) {
         if (!action->active)
             continue;
@@ -540,8 +546,6 @@ static int do_sync(sync_log_reader_t *sl
         syslog(LOG_ERR, "Error in do_sync(): bailing out! %s", error_message(r));
     }
 
-    sync_log_done();
-
     sync_action_list_free(&user_list);
     sync_action_list_free(&unuser_list);
     sync_action_list_free(&meta_list);
@@ -741,7 +745,7 @@ static void replica_connect(const char *
         prot_flush(sync_backend->out);
 
         if (sync_parse_response("COMPRESS", sync_backend->in, NULL)) {
-            if (do_compress) fatal("Failed to enable compression, aborting", EC_SOFTWARE);
+            if (do_compress) fatal("Failed to enable compression, aborting", EX_SOFTWARE);
             syslog(LOG_NOTICE, "Failed to enable compression, continuing uncompressed");
         }
         else {
@@ -749,7 +753,7 @@ static void replica_connect(const char *
             prot_setcompress(sync_backend->out);
         }
     }
-    else if (do_compress) fatal("Backend does not support compression, aborting", EC_SOFTWARE);
+    else if (do_compress) fatal("Backend does not support compression, aborting", EX_SOFTWARE);
 #endif
 
     /* links to sockets */
@@ -762,7 +766,7 @@ static void replica_connect(const char *
     }
 
     /* Set inactivity timer */
-    timeout = config_getint(IMAPOPT_SYNC_TIMEOUT);
+    timeout = config_getduration(IMAPOPT_SYNC_TIMEOUT, 's');
     if (timeout < 3) timeout = 3;
     prot_settimeout(sync_in, timeout);
 
@@ -951,31 +955,31 @@ int main(int argc, char **argv)
 
         case 'R':
             if (mode != MODE_UNKNOWN)
-                fatal("Mutually exclusive options defined", EC_USAGE);
+                usage("sync_client", "Mutually exclusive options defined");
             mode = MODE_REPEAT;
             break;
 
         case 'A':
             if (mode != MODE_UNKNOWN)
-                fatal("Mutually exclusive options defined", EC_USAGE);
+                usage("sync_client", "Mutually exclusive options defined");
             mode = MODE_ALLUSER;
             break;
 
         case 'u':
             if (mode != MODE_UNKNOWN)
-                fatal("Mutually exclusive options defined", EC_USAGE);
+                usage("sync_client", "Mutually exclusive options defined");
             mode = MODE_USER;
             break;
 
         case 'm':
             if (mode != MODE_UNKNOWN)
-                fatal("Mutually exclusive options defined", EC_USAGE);
+                usage("sync_client", "Mutually exclusive options defined");
             mode = MODE_MAILBOX;
             break;
 
         case 's':
             if (mode != MODE_UNKNOWN)
-                fatal("Mutually exclusive options defined", EC_USAGE);
+                usage("sync_client", "Mutually exclusive options defined");
             mode = MODE_META;
             break;
 
@@ -984,7 +988,7 @@ int main(int argc, char **argv)
             do_compress = 1;
 #else
             do_compress = 0;
-            fatal("Compress not available without zlib compiled in", EC_SOFTWARE);
+            fatal("Compress not available without zlib compiled in", EX_SOFTWARE);
 #endif
             break;
 
@@ -998,12 +1002,12 @@ int main(int argc, char **argv)
             break;
 
         default:
-            usage("sync_client");
+            usage("sync_client", NULL);
         }
     }
 
     if (mode == MODE_UNKNOWN)
-        fatal("No replication mode specified", EC_USAGE);
+        usage("sync_client", "No replication mode specified");
 
     if (verbose) flags |= SYNC_FLAG_VERBOSE;
     if (verbose_logging) flags |= SYNC_FLAG_LOGGING;
@@ -1032,7 +1036,7 @@ int main(int argc, char **argv)
         servername = sync_get_config(channel, "sync_host");
 
     if (!servername)
-        fatal("sync_host not defined", EC_SOFTWARE);
+        fatal("sync_host not defined", EX_SOFTWARE);
 
     /* Just to help with debugging, so we have time to attach debugger */
     if (wait > 0) {
@@ -1042,20 +1046,9 @@ int main(int argc, char **argv)
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&sync_namespace, 1)) != 0) {
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
-
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for real work */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* open the annotation db */
-    annotate_init(NULL, NULL);
-    annotatemore_open();
+    mboxevent_setnamespace(&sync_namespace);
 
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
@@ -1195,7 +1188,7 @@ int main(int argc, char **argv)
                 sync_shutdown_file = sync_get_config(channel, "sync_shutdown_file");
 
             if (!min_delta)
-                min_delta = sync_get_intconfig(channel, "sync_repeat_interval");
+                min_delta = sync_get_durationconfig(channel, "sync_repeat_interval", 's');
 
             do_daemon(channel, sync_shutdown_file, timeout, min_delta);
         }
diff -pruN 3.0.13-5/imap/sync_log.c 3.2.0-3/imap/sync_log.c
--- 3.0.13-5/imap/sync_log.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_log.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* sync_log.c -- Cyrus synchonization logging functions
+/* sync_log.c -- Cyrus synchronization logging functions
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
@@ -54,11 +54,11 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <errno.h>
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "sync_log.h"
 #include "global.h"
 #include "cyr_lock.h"
@@ -75,12 +75,24 @@ static int sync_log_suppressed = 0;
 static strarray_t *channels = NULL;
 static strarray_t *unsuppressable = NULL;
 
+static int sync_log_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    sync_log_done();
+}
+
+static void init_internal() {
+    if (!sync_log_initialized) {
+        sync_log_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
+
 EXPORTED void sync_log_init(void)
 {
     const char *conf;
     int i;
 
-
     /* sync_log_init() may be called more than once */
     if (channels) strarray_free(channels);
 
@@ -102,6 +114,8 @@ EXPORTED void sync_log_init(void)
     conf = config_getstring(IMAPOPT_SYNC_LOG_UNSUPPRESSABLE_CHANNELS);
     if (conf)
         unsuppressable = strarray_split(conf, " ", 0);
+
+    sync_log_initialized = 1;
 }
 
 EXPORTED void sync_log_suppress(void)
@@ -116,6 +130,8 @@ EXPORTED void sync_log_done(void)
 
     strarray_free(unsuppressable);
     unsuppressable = NULL;
+
+    sync_log_initialized = 0;
 }
 
 static char *sync_log_fname(const char *channel)
@@ -218,7 +234,7 @@ static const char *sync_quote_name(const
     for (src = 0; name[src]; src++) {
         c = name[src];
         if ((c == '\r') || (c == '\n'))
-            fatal("Illegal line break in folder name", EC_IOERR);
+            fatal("Illegal line break in folder name", EX_IOERR);
 
         /* quoteable characters */
         if ((c == '\\') || (c == '\"') || (c == '{') || (c == '}')) {
@@ -234,7 +250,7 @@ static const char *sync_quote_name(const
         buf[dst++] = c;
 
         if (dst > MAX_MAILBOX_BUFFER)
-            fatal("word too long", EC_IOERR);
+            fatal("word too long", EX_IOERR);
     }
 
 end:
@@ -293,6 +309,8 @@ EXPORTED void sync_log(const char *fmt,
     const char *val;
     int i;
 
+    init_internal();
+
     if (!channels) return;
 
     va_start(ap, fmt);
@@ -311,6 +329,8 @@ EXPORTED void sync_log_channel(const cha
     va_list ap;
     const char *val;
 
+    init_internal();
+
     va_start(ap, fmt);
     val = va_format(fmt, ap);
     va_end(ap);
@@ -457,8 +477,7 @@ EXPORTED int sync_log_reader_begin(sync_
                "Reprocessing sync log file %s", slr->work_file);
     }
     else if (!slr->log_file) {
-        syslog(LOG_ERR, "Failed to stat %s: %m",
-               slr->log_file);
+        syslog(LOG_ERR, "No sync log filename");
         return IMAP_IOERROR;
     }
     else {
diff -pruN 3.0.13-5/imap/sync_log.h 3.2.0-3/imap/sync_log.h
--- 3.0.13-5/imap/sync_log.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_log.h	2020-05-04 03:28:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* sync_log.c -- Cyrus synchonization logging functions
+/* sync_log.c -- Cyrus synchronization logging functions
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
diff -pruN 3.0.13-5/imap/sync_reset.c 3.2.0-3/imap/sync_reset.c
--- 3.0.13-5/imap/sync_reset.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_reset.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,6 +50,7 @@
 #endif
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <time.h>
 #include <sys/stat.h>
 #include <sys/types.h>
@@ -60,7 +61,6 @@
 
 #include "global.h"
 #include "mboxlist.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "seen.h"
 #include "mboxname.h"
@@ -95,19 +95,11 @@ static void shut_down(int code)
 {
     in_shutdown = 1;
 
-    annotatemore_close();
-    annotate_done();
-
     if (sync_userid)    free(sync_userid);
     if (sync_authstate) auth_freestate(sync_authstate);
 
     seen_done();
 
-    quotadb_close();
-    quotadb_done();
-
-    mboxlist_close();
-    mboxlist_done();
     exit(code);
 }
 
@@ -116,7 +108,7 @@ static int usage(const char *name)
     fprintf(stderr,
             "usage: %s [-C <alt_config>] [-v] [-f] user...\n", name);
 
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 EXPORTED void fatal(const char* s, int code)
@@ -131,6 +123,7 @@ static int reset_single(const char *user
 {
     int r = 0;
     int i;
+    struct mboxlock *namespacelock = user_namespacelock(userid);
 
     /* XXX: adding an entry to userdeny_db here would avoid the need to
      * protect against new logins with external proxy rules - Cyrus could
@@ -148,13 +141,13 @@ static int reset_single(const char *user
         (void)mboxlist_changesub(name, userid, sync_authstate, 0, 0, 0);
     }
 
-    r = mboxlist_usermboxtree(userid, addmbox_cb, mblist, MBOXTREE_DELETED);
+    r = mboxlist_usermboxtree(userid, NULL, addmbox_cb, mblist, MBOXTREE_DELETED);
     if (r) goto fail;
 
     for (i = mblist->count; i; i--) {
         const char *name = strarray_nth(mblist, i-1);
         r = mboxlist_deletemailbox(name, 1, sync_userid,
-                                   sync_authstate, NULL, 0, 1, 1);
+                                   sync_authstate, NULL, 0, 1, 1, 0);
         if (r == IMAP_MAILBOX_NONEXISTENT) {
             printf("skipping already removed mailbox %s\n", name);
         }
@@ -168,6 +161,7 @@ static int reset_single(const char *user
     r = user_deletedata(userid, 1);
 
  fail:
+    mboxname_release(&namespacelock);
     strarray_free(mblist);
     strarray_free(sublist);
 
@@ -216,25 +210,15 @@ main(int argc, char **argv)
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(sync_namespacep, 1)) != 0) {
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    /* open the mboxlist and quotadb, we'll need them for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    quotadb_init(0);
-    quotadb_open(NULL);
-
     signals_set_shutdown(&shut_down);
     signals_add_handlers(0);
 
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
     if (!force) {
         fprintf(stderr, "Usage: sync_reset -f user user user ...\n");
-        fprintf(stderr, "         -f [force] is obligitory for safety\n");
+        fprintf(stderr, "         -f [force] is obligatory for safety\n");
         shut_down(0);
     }
 
diff -pruN 3.0.13-5/imap/sync_server.c 3.2.0-3/imap/sync_server.c
--- 3.0.13-5/imap/sync_server.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_server.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* sync_server.c -- Cyrus synchonization server
+/* sync_server.c -- Cyrus synchronization server
  *
  * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
  *
@@ -58,6 +58,7 @@
 #include <sys/types.h>
 #include <sys/wait.h>
 #include <sys/param.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <netdb.h>
 #include <sys/socket.h>
@@ -75,12 +76,9 @@
 #include "append.h"
 #include "auth.h"
 #ifdef WITH_DAV
-#include "caldav_db.h"
-#include "carddav_db.h"
 #include "dav_db.h"
 #endif /* WITH_DAV */
 #include "dlist.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "hash.h"
 #include "imparse.h"
@@ -92,7 +90,6 @@
 #include "prot.h"
 #include "quota.h"
 #include "seen.h"
-#include "statuscache.h"
 #include "sync_log.h"
 #include "telemetry.h"
 #include "tls.h"
@@ -162,12 +159,7 @@ extern int saslserver(sasl_conn_t *conn,
                       struct protstream *pin, struct protstream *pout,
                       int *sasl_result, char **success_data);
 
-static struct {
-    char *ipremoteport;
-    char *iplocalport;
-    sasl_ssf_t ssf;
-    char *authid;
-} saslprops = {NULL,NULL,0,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 /* the sasl proxy policy context */
 static struct proxy_context sync_proxyctx = {
@@ -228,19 +220,7 @@ static void sync_reset(void)
     sync_starttls_done = 0;
     sync_compress_done = 0;
 
-    if(saslprops.iplocalport) {
-       free(saslprops.iplocalport);
-       saslprops.iplocalport = NULL;
-    }
-    if(saslprops.ipremoteport) {
-       free(saslprops.ipremoteport);
-       saslprops.ipremoteport = NULL;
-    }
-    if(saslprops.authid) {
-       free(saslprops.authid);
-       saslprops.authid = NULL;
-    }
-    saslprops.ssf = 0;
+    saslprops_reset(&saslprops);
 }
 
 /*
@@ -253,7 +233,7 @@ int service_init(int argc __attribute__(
 {
     int opt, r;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -278,31 +258,9 @@ int service_init(int argc __attribute__(
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(sync_namespacep, 1)) != 0) {
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
-    /* open the mboxlist, we'll need it for real work */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    /* open the quota db, we'll need it for real work */
-    quotadb_init(0);
-    quotadb_open(NULL);
-
-    /* Initialize the annotatemore extention */
-    annotate_init(NULL, NULL);
-    annotatemore_open();
-
-    /* Open the statuscache so we can invalidate seen states */
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        statuscache_open();
-    }
-
-#ifdef WITH_DAV
-    caldav_init();
-    carddav_init();
-#endif
-
     return 0;
 }
 
@@ -335,7 +293,7 @@ static void dobanner(void)
 
     prot_printf(sync_out,
                 "* OK %s Cyrus sync server %s\r\n",
-                config_servername, cyrus_version());
+                config_servername, CYRUS_VERSION);
 
     prot_flush(sync_out);
 }
@@ -368,29 +326,25 @@ int service_main(int argc __attribute__(
         sync_userisadmin = 1;
     }
     else {
+        if (localip && remoteip) {
+            buf_setcstr(&saslprops.ipremoteport, remoteip);
+            buf_setcstr(&saslprops.iplocalport, localip);
+        }
+
         /* other params should be filled in */
-        if (sasl_server_new("csync", config_servername, NULL, NULL, NULL,
+        if (sasl_server_new("csync", config_servername, NULL,
+                            buf_cstringnull_ifempty(&saslprops.iplocalport),
+                            buf_cstringnull_ifempty(&saslprops.ipremoteport),
                             NULL, 0, &sync_saslconn) != SASL_OK)
-            fatal("SASL failed initializing: sasl_server_new()",EC_TEMPFAIL);
+            fatal("SASL failed initializing: sasl_server_new()",EX_TEMPFAIL);
 
         /* will always return something valid */
         secprops = mysasl_secprops(SASL_SEC_NOANONYMOUS);
         if (sasl_setprop(sync_saslconn, SASL_SEC_PROPS, secprops) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
+            fatal("Failed to set SASL property", EX_TEMPFAIL);
 
         if (sasl_setprop(sync_saslconn, SASL_SSF_EXTERNAL, &extprops_ssf) != SASL_OK)
-            fatal("Failed to set SASL property", EC_TEMPFAIL);
-
-        if (localip) {
-            sasl_setprop(sync_saslconn, SASL_IPLOCALPORT, localip);
-            saslprops.iplocalport = xstrdup(localip);
-        }
-
-        if (remoteip) {
-            if (sasl_setprop(sync_saslconn, SASL_IPREMOTEPORT, remoteip) != SASL_OK)
-                fatal("failed to set sasl property", EC_TEMPFAIL);
-            saslprops.ipremoteport = xstrdup(remoteip);
-        }
+            fatal("Failed to set SASL property", EX_TEMPFAIL);
 
         tcp_disable_nagle(1); /* XXX magic fd */
     }
@@ -398,7 +352,7 @@ int service_main(int argc __attribute__(
     proc_register(config_ident, sync_clienthost, NULL, NULL, NULL);
 
     /* Set inactivity timer */
-    timeout = config_getint(IMAPOPT_SYNC_TIMEOUT);
+    timeout = config_getduration(IMAPOPT_SYNC_TIMEOUT, 's');
     if (timeout < 3) timeout = 3;
     prot_settimeout(sync_in, timeout);
 
@@ -430,7 +384,7 @@ static void usage(void)
 {
     prot_printf(sync_out, "* usage: sync_server [-C <alt_config>]\r\n");
     prot_flush(sync_out);
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 /*
@@ -442,25 +396,7 @@ void shut_down(int code)
 
     proc_cleanup();
 
-#ifdef WITH_DAV
-    carddav_done();
-    caldav_done();
-#endif
-
-    if (config_getswitch(IMAPOPT_STATUSCACHE)) {
-        statuscache_close();
-        statuscache_done();
-    }
-
     seen_done();
-    mboxlist_close();
-    mboxlist_done();
-
-    quotadb_close();
-    quotadb_done();
-
-    annotatemore_close();
-    annotate_done();
 
     partlist_local_done();
 
@@ -479,6 +415,8 @@ void shut_down(int code)
     tls_shutdown_serverengine();
 #endif
 
+    saslprops_free(&saslprops);
+
     cyrus_done();
 
     exit(code);
@@ -510,20 +448,12 @@ static int reset_saslconn(sasl_conn_t **
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new("csync", config_servername,
-                         NULL, NULL, NULL,
-                         NULL, 0, conn);
-    if (ret != SASL_OK) return ret;
-
-    if (saslprops.ipremoteport)
-       ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                          saslprops.ipremoteport);
+    ret = sasl_server_new("csync", config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                          NULL, 0, conn);
     if (ret != SASL_OK) return ret;
 
-    if (saslprops.iplocalport)
-       ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                          saslprops.iplocalport);
-    if (ret != SASL_OK) return ret;
     secprops = mysasl_secprops(SASL_SEC_NOANONYMOUS);
     ret = sasl_setprop(*conn, SASL_SEC_PROPS, secprops);
     if (ret != SASL_OK) return ret;
@@ -531,17 +461,12 @@ static int reset_saslconn(sasl_conn_t **
 
     /* If we have TLS/SSL info, set it */
     if (saslprops.ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &saslprops.ssf);
+        ret = saslprops_set_tls(&saslprops, *conn);
     } else {
         ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &extprops_ssf);
     }
 
     if (ret != SASL_OK) return ret;
-
-    if (saslprops.authid) {
-       ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, saslprops.authid);
-       if(ret != SASL_OK) return ret;
-    }
     /* End TLS/SSL Info */
 
     return SASL_OK;
@@ -769,6 +694,7 @@ static void cmd_authenticate(char *mech,
 
     if (r) {
         const char *errorstring = NULL;
+        const char *userid = "-notset-";
 
         switch (r) {
         case IMAP_SASL_CANCEL:
@@ -786,10 +712,13 @@ static void cmd_authenticate(char *mech,
             /* failed authentication */
             errorstring = sasl_errstring(sasl_result, NULL, NULL);
 
-            syslog(LOG_NOTICE, "badlogin: %s %s [%s]",
-                   sync_clienthost, mech, sasl_errdetail(sync_saslconn));
+            if (r != SASL_NOUSER)
+                sasl_getprop(sync_saslconn, SASL_USERNAME, (const void **) &userid);
+
+            syslog(LOG_NOTICE, "badlogin: %s %s (%s) [%s]",
+                   sync_clienthost, mech, userid, sasl_errdetail(sync_saslconn));
 
-            failedloginpause = config_getint(IMAPOPT_FAILEDLOGINPAUSE);
+            failedloginpause = config_getduration(IMAPOPT_FAILEDLOGINPAUSE, 's');
             if (failedloginpause != 0) {
                 sleep(failedloginpause);
             }
@@ -858,9 +787,6 @@ static void cmd_authenticate(char *mech,
 static void cmd_starttls(void)
 {
     int result;
-    int *layerp;
-    sasl_ssf_t ssf;
-    char *auth_id;
 
     if (sync_starttls_done == 1) {
         prot_printf(sync_out, "NO %s\r\n",
@@ -868,9 +794,6 @@ static void cmd_starttls(void)
         return;
     }
 
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
-
     result=tls_init_serverengine("csync",
                                  5,        /* depth to verify */
                                  1,        /* can client auth? */
@@ -889,8 +812,7 @@ static void cmd_starttls(void)
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                180, /* 3 minutes */
-                               layerp,
-                               &auth_id,
+                               &saslprops,
                                &tls_conn);
 
     /* if error */
@@ -901,22 +823,10 @@ static void cmd_starttls(void)
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(sync_saslconn, SASL_SSF_EXTERNAL, &ssf);
+    result = saslprops_set_tls(&saslprops, sync_saslconn);
     if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
-    }
-    saslprops.ssf = ssf;
-
-    result = sasl_setprop(sync_saslconn, SASL_AUTH_EXTERNAL, auth_id);
-    if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
-    }
-    if (saslprops.authid) {
-        free(saslprops.authid);
-        saslprops.authid = NULL;
+        fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
     }
-    if (auth_id)
-        saslprops.authid = xstrdup(auth_id);
 
     /* tell the prot layer about our new layers */
     prot_settls(sync_in, tls_conn);
@@ -929,7 +839,7 @@ static void cmd_starttls(void)
 #else
 static void cmd_starttls(void)
 {
-    fatal("cmd_starttls() called, but no OpenSSL", EC_SOFTWARE);
+    fatal("cmd_starttls() called, but no OpenSSL", EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
 
diff -pruN 3.0.13-5/imap/sync_support.c 3.2.0-3/imap/sync_support.c
--- 3.0.13-5/imap/sync_support.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_support.c	2020-05-04 03:28:02.000000000 +0000
@@ -51,6 +51,7 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <sys/wait.h>
@@ -63,7 +64,6 @@
 #include "global.h"
 #include "imap_proxy.h"
 #include "mboxlist.h"
-#include "exitcodes.h"
 #include "mailbox.h"
 #include "quota.h"
 #include "xmalloc.h"
@@ -237,13 +237,13 @@ EXPORTED const char *sync_get_config(con
         else if (!strcmp(val, "sync_shutdown_file"))
             response = config_getstring(IMAPOPT_SYNC_SHUTDOWN_FILE);
         else
-            fatal("unknown config variable requested", EC_SOFTWARE);
+            fatal("unknown config variable requested", EX_SOFTWARE);
     }
 
     return response;
 }
 
-EXPORTED int sync_get_intconfig(const char *channel, const char *val)
+EXPORTED int sync_get_durationconfig(const char *channel, const char *val, int defunit)
 {
     int response = -1;
 
@@ -252,12 +252,13 @@ EXPORTED int sync_get_intconfig(const ch
         char name[MAX_MAILBOX_NAME]; /* crazy long, but hey */
         snprintf(name, MAX_MAILBOX_NAME, "%s_%s", channel, val);
         result = config_getoverflowstring(name, NULL);
-        if (result) response = atoi(result);
+        if (result)
+            config_parseduration(result, defunit, &response);
     }
 
     if (response == -1) {
         if (!strcmp(val, "sync_repeat_interval"))
-            response = config_getint(IMAPOPT_SYNC_REPEAT_INTERVAL);
+            response = config_getduration(IMAPOPT_SYNC_REPEAT_INTERVAL, defunit);
     }
 
     return response;
@@ -296,6 +297,8 @@ char *sync_encode_options(int options)
         buf[i++] = 'S';
     if (options & OPT_IMAP_DUPDELIVER)
         buf[i++] = 'D';
+    if (options & OPT_IMAP_HAS_ALARMS)
+        buf[i++] = 'A';
     buf[i] = '\0';
 
     return buf;
@@ -319,6 +322,9 @@ int sync_parse_options(const char *optio
         case 'D':
             res |= OPT_IMAP_DUPDELIVER;
             break;
+        case 'A':
+            res |= OPT_IMAP_HAS_ALARMS;
+            break;
         }
         p++;
     }
@@ -346,126 +352,12 @@ static int sync_getline(struct protstrea
             return c;
         }
         if (buf->len > config_maxword)
-            fatal("word too long", EC_IOERR);
+            fatal("word too long", EX_IOERR);
         buf_putc(buf, c);
     }
     return c;
 }
 
-/* ====================================================================== */
-
-void sync_print_flags(struct dlist *kl,
-                      struct mailbox *mailbox,
-                      const struct index_record *record)
-{
-    int flag;
-    struct dlist *fl = dlist_newlist(kl, "FLAGS");
-
-    if (record->system_flags & FLAG_DELETED)
-        dlist_setflag(fl, "FLAG", "\\Deleted");
-    if (record->system_flags & FLAG_ANSWERED)
-        dlist_setflag(fl, "FLAG", "\\Answered");
-    if (record->system_flags & FLAG_FLAGGED)
-        dlist_setflag(fl, "FLAG", "\\Flagged");
-    if (record->system_flags & FLAG_DRAFT)
-        dlist_setflag(fl, "FLAG", "\\Draft");
-    if (record->system_flags & FLAG_EXPUNGED)
-        dlist_setflag(fl, "FLAG", "\\Expunged");
-    if (record->system_flags & FLAG_SEEN)
-        dlist_setflag(fl, "FLAG", "\\Seen");
-
-    /* print user flags in mailbox order */
-    for (flag = 0; flag < MAX_USER_FLAGS; flag++) {
-        if (!mailbox->flagname[flag])
-            continue;
-        if (!(record->user_flags[flag/32] & (1<<(flag&31))))
-            continue;
-        dlist_setflag(fl, "FLAG", mailbox->flagname[flag]);
-    }
-}
-
-int sync_getflags(struct dlist *kl,
-                  struct mailbox *mailbox,
-                  struct index_record *record)
-{
-    struct dlist *ki;
-    int userflag;
-
-    for (ki = kl->head; ki; ki = ki->next) {
-        char *s = xstrdup(ki->sval);
-
-        if (s[0] == '\\') {
-            /* System flags */
-            lcase(s);
-            if (!strcmp(s, "\\seen")) {
-                record->system_flags |= FLAG_SEEN;
-            } else if (!strcmp(s, "\\expunged")) {
-                record->system_flags |= FLAG_EXPUNGED;
-            } else if (!strcmp(s, "\\answered")) {
-                record->system_flags |= FLAG_ANSWERED;
-            } else if (!strcmp(s, "\\flagged")) {
-                record->system_flags |= FLAG_FLAGGED;
-            } else if (!strcmp(s, "\\deleted")) {
-                record->system_flags |= FLAG_DELETED;
-            } else if (!strcmp(s, "\\draft")) {
-                record->system_flags |= FLAG_DRAFT;
-            } else {
-                syslog(LOG_ERR, "Unknown system flag: %s", s);
-            }
-        }
-        else {
-            if (mailbox_user_flag(mailbox, s, &userflag, /*allow all*/2)) {
-                syslog(LOG_ERR, "Unable to record user flag: %s", s);
-                free(s);
-                return IMAP_IOERROR;
-            }
-            record->user_flags[userflag/32] |= 1<<(userflag&31);
-        }
-
-        free(s);
-    }
-
-    return 0;
-}
-
-int parse_upload(struct dlist *kr, struct mailbox *mailbox,
-                 struct index_record *record,
-                 struct sync_annot_list **salp)
-{
-    struct dlist *fl;
-    struct message_guid *tmpguid;
-    int r;
-
-    memset(record, 0, sizeof(struct index_record));
-
-    if (!dlist_getnum32(kr, "UID", &record->uid))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getnum64(kr, "MODSEQ", &record->modseq))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getdate(kr, "LAST_UPDATED", &record->last_updated))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getlist(kr, "FLAGS", &fl))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getdate(kr, "INTERNALDATE", &record->internaldate))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getnum32(kr, "SIZE", &record->size))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getguid(kr, "GUID", &tmpguid))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-
-    record->guid = *tmpguid;
-
-    /* parse the flags */
-    r = sync_getflags(fl, mailbox, record);
-    if (r) return r;
-
-    /* the ANNOTATIONS list is optional too */
-    if (salp && dlist_getlist(kr, "ANNOTATIONS", &fl))
-        decode_annotations(fl, salp, record);
-
-    return 0;
-}
-
 
 /* ====================================================================== */
 
@@ -655,6 +547,8 @@ struct sync_folder *sync_folder_list_add
                                          time_t pop3_show_after,
                                          struct sync_annot_list *annots,
                                          modseq_t xconvmodseq,
+                                         modseq_t raclmodseq,
+                                         modseq_t foldermodseq,
                                          int ispartial)
 {
     struct sync_folder *result = xzmalloc(sizeof(struct sync_folder));
@@ -685,6 +579,8 @@ struct sync_folder *sync_folder_list_add
     result->pop3_show_after = pop3_show_after;
     result->annots = annots; /* NOTE: not a copy! */
     result->xconvmodseq = xconvmodseq;
+    result->raclmodseq = raclmodseq;
+    result->foldermodseq = foldermodseq;
     result->ispartial = ispartial;
 
     result->mark     = 0;
@@ -1151,7 +1047,7 @@ int sync_sieve_activate(const char *user
     const char *sieve_path = user_sieve_path(userid);
     char target[2048];
     char active[2048];
-    char tmp[2048];
+    char tmp[2048+4];  /* +4 for ".NEW" */
 
     snprintf(target, sizeof(target), "%s", name);
     snprintf(active, sizeof(active), "%s/%s", sieve_path, "defaultbc");
@@ -1187,7 +1083,7 @@ int sync_sieve_deactivate(const char *us
     const char *sieve_path = user_sieve_path(userid);
     char active[2048];
 
-    snprintf(active, sizeof(active), "%s/%s", sieve_path, "defaultbc");
+    snprintf(active, sizeof(active), "%s/defaultbc", sieve_path);
     unlink(active);
 
     sync_log_sieve(userid);
@@ -1383,7 +1279,8 @@ struct sync_annot_list *sync_annot_list_
 
 void sync_annot_list_add(struct sync_annot_list *l,
                          const char *entry, const char *userid,
-                         const struct buf *value)
+                         const struct buf *value,
+                         modseq_t modseq)
 {
     struct sync_annot *item = xzmalloc(sizeof(struct sync_annot));
 
@@ -1391,6 +1288,7 @@ void sync_annot_list_add(struct sync_ann
     item->userid = xstrdupnull(userid);
     buf_copy(&item->value, value);
     item->mark = 0;
+    item->modseq = modseq;
 
     if (l->tail)
         l->tail = l->tail->next = item;
@@ -1484,92 +1382,523 @@ void sync_action_list_free(struct sync_a
     *lp = NULL;
 }
 
-/* NOTE - we don't prot_flush here, as we always send an OK at the
- * end of a response anyway */
-void sync_send_response(struct dlist *kl, struct protstream *out)
-{
-    prot_printf(out, "* ");
-    dlist_print(kl, 1, out);
-    prot_printf(out, "\r\n");
-}
+/* ====================================================================== */
 
-static const char *sync_gentag(struct buf *tag)
+static int read_one_annot(const char *mailbox __attribute__((unused)),
+                          uint32_t uid __attribute__((unused)),
+                          const char *entry,
+                          const char *userid,
+                          const struct buf *value,
+                          const struct annotate_metadata *mdata,
+                          void *rock)
 {
-    static unsigned cmdcnt = 0;
+    struct sync_annot_list **salp = (struct sync_annot_list **)rock;
 
-    buf_reset(tag);
-    buf_printf(tag, "S%d", cmdcnt++);
-    return buf_cstring(tag);
+    if (!*salp)
+        *salp = sync_annot_list_create();
+    sync_annot_list_add(*salp, entry, userid, value, mdata->modseq);
+    return 0;
 }
 
-/* these are one-shot commands for get and apply, so flush the stream
- * after sending */
-void sync_send_apply(struct dlist *kl, struct protstream *out)
+/*
+ * Read all the annotations in the local annotations database
+ * for the message given by @mailbox and @record, returning them
+ * as a new sync_annot_list.  The caller should free the new
+ * list with sync_annot_list_free().
+ * If record is NULL, return the mailbox annotations
+ * If since_modseq is greated than zero, return annotations
+ * add or changed since modseq (exclusively since_modseq).
+ * If flags is set to ANNOTATE_TOMBSTONES, also return
+ * deleted annotations. Deleted annotations have a zero value.
+ *
+ * Returns: non-zero on error,
+ *          resulting sync_annot_list in *@resp
+ */
+int read_annotations(const struct mailbox *mailbox,
+                     const struct index_record *record,
+                     struct sync_annot_list **resp,
+                     modseq_t since_modseq __attribute__((unused)),
+                     int flags)
 {
-    if (out->userdata) {
-        /* IMAP flavor (w/ tag) */
-        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
-    }
-    prot_printf(out, "APPLY ");
-    dlist_print(kl, 1, out);
-    prot_printf(out, "\r\n");
-    prot_flush(out);
+    *resp = NULL;
+    return annotatemore_findall(mailbox->name, record ? record->uid : 0,
+                                /* all entries*/"*", /*XXX since_modseq*/0,
+                                read_one_annot, (void *)resp, flags);
 }
 
-void sync_send_lookup(struct dlist *kl, struct protstream *out)
+/*
+ * Encode the given list of annotations @sal as a dlist
+ * structure with the given @parent.
+ */
+void encode_annotations(struct dlist *parent,
+                        struct mailbox *mailbox,
+                        const struct index_record *record,
+                        const struct sync_annot_list *sal)
 {
-    if (out->userdata) {
-        /* IMAP flavor (w/ tag) */
-        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    const struct sync_annot *sa;
+    struct dlist *annots = NULL;
+    struct dlist *aa;
+
+    if (sal) {
+        for (sa = sal->head ; sa ; sa = sa->next) {
+            if (!annots)
+                annots = dlist_newlist(parent, "ANNOTATIONS");
+
+            aa = dlist_newkvlist(annots, NULL);
+            dlist_setatom(aa, "ENTRY", sa->entry);
+            dlist_setatom(aa, "USERID", sa->userid);
+            dlist_setnum64(aa, "MODSEQ", sa->modseq);
+            dlist_setmap(aa, "VALUE", sa->value.s, sa->value.len);
+        }
     }
-    prot_printf(out, "GET ");
-    dlist_print(kl, 1, out);
-    prot_printf(out, "\r\n");
-    prot_flush(out);
-}
 
-void sync_send_restart(struct protstream *out)
-{
-    if (out->userdata) {
-        /* IMAP flavor (w/ tag) */
-        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    if (record && record->cid && mailbox->i.minor_version >= 13) {
+        if (!annots)
+            annots = dlist_newlist(parent, "ANNOTATIONS");
+        aa = dlist_newkvlist(annots, NULL);
+        dlist_setatom(aa, "ENTRY", IMAP_ANNOT_NS "thrid");
+        dlist_setatom(aa, "USERID", "");
+        dlist_setnum64(aa, "MODSEQ", 0);
+        dlist_sethex64(aa, "VALUE", record->cid);
     }
-    prot_printf(out, "RESTART\r\n");
-    prot_flush(out);
-}
 
-void sync_send_restore(struct dlist *kl, struct protstream *out)
-{
-    if (out->userdata) {
-        /* IMAP flavor (w/ tag) */
-        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    if (record && record->savedate && mailbox->i.minor_version >= 15) {
+        if (!annots)
+            annots = dlist_newlist(parent, "ANNOTATIONS");
+        aa = dlist_newkvlist(annots, NULL);
+        dlist_setatom(aa, "ENTRY", IMAP_ANNOT_NS "savedate");
+        dlist_setatom(aa, "USERID", "");
+        dlist_setnum64(aa, "MODSEQ", 0);
+        dlist_setnum32(aa, "VALUE", record->savedate);
+    }
+
+    if (record && record->createdmodseq && mailbox->i.minor_version >= 16) {
+        if (!annots)
+            annots = dlist_newlist(parent, "ANNOTATIONS");
+        aa = dlist_newkvlist(annots, NULL);
+        dlist_setatom(aa, "ENTRY", IMAP_ANNOT_NS "createdmodseq");
+        dlist_setatom(aa, "USERID", "");
+        dlist_setnum64(aa, "MODSEQ", 0);
+        dlist_setnum64(aa, "VALUE", record->createdmodseq);
     }
-    prot_printf(out, "RESTORE ");
-    dlist_print(kl, 1, out);
-    prot_printf(out, "\r\n");
-    prot_flush(out);
 }
 
-struct dlist *sync_parseline(struct protstream *in)
+/*
+ * Decode the given list of encoded annotations @annots and create
+ * a new sync_annot_list in *@salp, which the caller should free
+ * with sync_annot_list_free().
+ *
+ * Returns: zero on success or Cyrus error code.
+ */
+int decode_annotations(/*const*/struct dlist *annots,
+                       struct sync_annot_list **salp,
+                       struct mailbox *mailbox,
+                       struct index_record *record)
 {
-    struct dlist *dl = NULL;
-    int c;
-
-    c = dlist_parse(&dl, 1, 0, in);
-
-    /* end line - or fail */
-    if (c == '\r') c = prot_getc(in);
-    if (c == '\n') return dl;
+    struct dlist *aa;
+    const char *entry;
+    const char *userid;
+    modseq_t modseq;
 
-    dlist_free(&dl);
-    eatline(in, c);
-    return NULL;
-}
+    *salp = NULL;
+    if (strcmp(annots->name, "ANNOTATIONS"))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
 
-static int sync_send_file(struct mailbox *mailbox,
-                          const char *topart,
-                          const struct index_record *record,
-                          struct sync_msgid_list *part_list,
+    for (aa = annots->head ; aa ; aa = aa->next) {
+        struct buf value = BUF_INITIALIZER;
+        if (!*salp)
+            *salp = sync_annot_list_create();
+        if (!dlist_getatom(aa, "ENTRY", &entry))
+            return IMAP_PROTOCOL_BAD_PARAMETERS;
+        if (!dlist_getatom(aa, "USERID", &userid))
+            return IMAP_PROTOCOL_BAD_PARAMETERS;
+        if (!dlist_getnum64(aa, "MODSEQ", &modseq))
+            return IMAP_PROTOCOL_BAD_PARAMETERS;
+        if (!dlist_getbuf(aa, "VALUE", &value))
+            return IMAP_PROTOCOL_BAD_PARAMETERS;
+        if (!strcmp(entry, IMAP_ANNOT_NS "thrid") &&
+            record && mailbox->i.minor_version >= 13) {
+            const char *p = buf_cstring(&value);
+            parsehex(p, &p, 16, &record->cid);
+        }
+        else if (!strcmp(entry, IMAP_ANNOT_NS "savedate") &&
+                 record && mailbox->i.minor_version >= 15) {
+            const char *p = buf_cstring(&value);
+            bit64 newval;
+            parsenum(p, &p, 0, &newval);
+            record->savedate = newval;
+        }
+        else if (!strcmp(entry, IMAP_ANNOT_NS "createdmodseq") &&
+                 record && mailbox->i.minor_version >= 16) {
+            const char *p = buf_cstring(&value);
+            bit64 newval;
+            parsenum(p, &p, 0, &newval);
+            record->createdmodseq = newval;
+        }
+        else if (!strcmp(entry, IMAP_ANNOT_NS "basethrid") && record) {
+            /* this might double-apply the annotation, but oh well.  It does mean that
+             * basethrid is paired in here when we do a comparison against new values
+             * from the replica later! */
+            const char *p = buf_cstring(&value);
+            parsehex(p, &p, 16, &record->basecid);
+            /* XXX - check on p? */
+
+            /* "basethrid" is special, since it is written during mailbox
+             * appends and rewrites, using whatever modseq the index_record
+             * has at this moment. This might differ from the modseq we
+             * just parsed here, causing master and replica annotations
+             * to get out of sync.
+             * The fix is to set the basecid field both on the index
+             * record *and* adding the annotation to the annotation list.
+             * That way the local modseq of basethrid always gets over-
+             * written by whoever wins to be master of this annotation */
+            sync_annot_list_add(*salp, entry, userid, &value, modseq);
+        }
+        else {
+            sync_annot_list_add(*salp, entry, userid, &value, modseq);
+        }
+        buf_free(&value);
+    }
+    return 0;
+}
+
+/*
+ * Merge a local and remote list of annotations, and apply the resulting
+ * list of annotations to the local annotation database, storing new values
+ * or deleting old values as necessary.  Manages its own annotations
+ * transaction.
+ * Record may be null, to process mailbox annotations.
+ */
+
+static int diff_annotation(const struct sync_annot *a,
+                           const struct sync_annot *b,
+                           int diff_value)
+{
+    int diff = 0;
+
+    if (!a && !b) return 0;
+
+    if (a)
+        diff--;
+    if (b)
+        diff++;
+
+    if (!diff)
+        diff = strcmpnull(a->entry, b->entry);
+    if (!diff)
+        diff = strcmpnull(a->userid, b->userid);
+    if (!diff && diff_value)
+        diff = buf_cmp(&a->value, &b->value);
+
+    return diff;
+}
+
+int diff_annotations(const struct sync_annot_list *local_annots,
+                     const struct sync_annot_list *remote_annots)
+{
+    const struct sync_annot *local = (local_annots ? local_annots->head : NULL);
+    const struct sync_annot *remote = (remote_annots ? remote_annots->head : NULL);
+    while (local || remote) {
+        int r = diff_annotation(local, remote, 1);
+        if (r) return r;
+        if (local) local = local->next;
+        if (remote) remote = remote->next;
+    }
+
+    return 0;
+}
+
+int apply_annotations(struct mailbox *mailbox,
+                      const struct index_record *record,
+                      const struct sync_annot_list *local_annots,
+                      const struct sync_annot_list *remote_annots,
+                      int local_wins)
+{
+    const struct sync_annot *local = (local_annots ? local_annots->head : NULL);
+    const struct sync_annot *remote = (remote_annots ? remote_annots->head : NULL);
+    const struct sync_annot *chosen;
+    static const struct buf novalue = BUF_INITIALIZER;
+    const struct buf *value;
+    int r = 0;
+    int diff;
+    annotate_state_t *astate = NULL;
+
+    if (record) {
+        r = mailbox_get_annotate_state(mailbox, record->uid, &astate);
+    }
+    else {
+        astate = annotate_state_new();
+        r = annotate_state_set_mailbox(astate, mailbox);
+    }
+    if (r) goto out;
+
+    /*
+     * We rely here on the database scan order resulting in lists
+     * of annotations that are ordered lexically on entry then userid.
+     * We walk over both lists at once, choosing an annotation from
+     * either the local list only (diff < 0), the remote list only
+     * (diff > 0), or both lists (diff == 0).
+     */
+    while (local || remote) {
+        diff = diff_annotation(local, remote, 0);
+        chosen = 0;
+        if (diff < 0) {
+            chosen = local;
+            value = (local_wins ? &local->value : &novalue);
+            local = local->next;
+        }
+        else if (diff > 0) {
+            chosen = remote;
+            value = (local_wins ? &novalue : &remote->value);
+            remote = remote->next;
+        }
+        else {
+            chosen = remote;
+            value = (local_wins ? &local->value : &remote->value);
+            diff = buf_cmp(&local->value, &remote->value);
+            local = local->next;
+            remote = remote->next;
+            if (!diff)
+                continue;   /* same value, skip */
+        }
+
+        /* Replicate the modseq of this record from master */
+        struct annotate_metadata mdata = {
+            chosen->modseq, /* modseq */
+            0               /* flags - is determined by value */
+        };
+        r = annotate_state_writemdata(astate, chosen->entry,
+                                      chosen->userid, value, &mdata);
+        if (r)
+            break;
+    }
+
+out:
+
+    if (record) {
+#ifdef USE_CALALARMD
+        if (mailbox->mbtype & MBTYPE_CALENDAR) {
+            // NOTE: this is because we don't pass the annotations through
+            // with the record as we create it, so we can't update the alarm
+            // database properly.  Instead, we don't set anything when we append
+            // by checking for .silent, and instead update the database by touching
+            // the alarm AFTER writing the record.
+            caldav_alarm_sync_nextcheck(mailbox, record);
+        }
+#endif
+    }
+    else {
+        /* need to manage our own txn for the global db */
+        if (!r)
+            r = annotate_state_commit(&astate);
+        else
+            annotate_state_abort(&astate);
+    }
+    /* else, the struct mailbox manages it for us */
+
+    return r;
+}
+
+/* =========================================================================== */
+
+void sync_print_flags(struct dlist *kl,
+                      struct mailbox *mailbox,
+                      const struct index_record *record)
+{
+    int flag;
+    struct dlist *fl = dlist_newlist(kl, "FLAGS");
+
+    if (record->system_flags & FLAG_DELETED)
+        dlist_setflag(fl, "FLAG", "\\Deleted");
+    if (record->system_flags & FLAG_ANSWERED)
+        dlist_setflag(fl, "FLAG", "\\Answered");
+    if (record->system_flags & FLAG_FLAGGED)
+        dlist_setflag(fl, "FLAG", "\\Flagged");
+    if (record->system_flags & FLAG_DRAFT)
+        dlist_setflag(fl, "FLAG", "\\Draft");
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED)
+        dlist_setflag(fl, "FLAG", "\\Expunged");
+    if (record->system_flags & FLAG_SEEN)
+        dlist_setflag(fl, "FLAG", "\\Seen");
+
+    /* print user flags in mailbox order */
+    for (flag = 0; flag < MAX_USER_FLAGS; flag++) {
+        if (!mailbox->flagname[flag])
+            continue;
+        if (!(record->user_flags[flag/32] & (1<<(flag&31))))
+            continue;
+        dlist_setflag(fl, "FLAG", mailbox->flagname[flag]);
+    }
+}
+
+int sync_getflags(struct dlist *kl,
+                  struct mailbox *mailbox,
+                  struct index_record *record)
+{
+    struct dlist *ki;
+    int userflag;
+
+    for (ki = kl->head; ki; ki = ki->next) {
+        char *s = xstrdup(ki->sval);
+
+        if (s[0] == '\\') {
+            /* System flags */
+            lcase(s);
+            if (!strcmp(s, "\\seen")) {
+                record->system_flags |= FLAG_SEEN;
+            } else if (!strcmp(s, "\\expunged")) {
+                record->internal_flags |= FLAG_INTERNAL_EXPUNGED;
+            } else if (!strcmp(s, "\\answered")) {
+                record->system_flags |= FLAG_ANSWERED;
+            } else if (!strcmp(s, "\\flagged")) {
+                record->system_flags |= FLAG_FLAGGED;
+            } else if (!strcmp(s, "\\deleted")) {
+                record->system_flags |= FLAG_DELETED;
+            } else if (!strcmp(s, "\\draft")) {
+                record->system_flags |= FLAG_DRAFT;
+            } else {
+                syslog(LOG_ERR, "Unknown system flag: %s", s);
+            }
+        }
+        else {
+            if (mailbox_user_flag(mailbox, s, &userflag, /*allow all*/2)) {
+                syslog(LOG_ERR, "Unable to record user flag: %s", s);
+                free(s);
+                return IMAP_IOERROR;
+            }
+            record->user_flags[userflag/32] |= 1<<(userflag&31);
+        }
+
+        free(s);
+    }
+
+    return 0;
+}
+
+int parse_upload(struct dlist *kr, struct mailbox *mailbox,
+                 struct index_record *record,
+                 struct sync_annot_list **salp)
+{
+    struct dlist *fl;
+    struct message_guid *tmpguid;
+    int r;
+
+    memset(record, 0, sizeof(struct index_record));
+
+    if (!dlist_getnum32(kr, "UID", &record->uid))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getnum64(kr, "MODSEQ", &record->modseq))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getdate(kr, "LAST_UPDATED", &record->last_updated))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getlist(kr, "FLAGS", &fl))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getdate(kr, "INTERNALDATE", &record->internaldate))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getnum32(kr, "SIZE", &record->size))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getguid(kr, "GUID", &tmpguid))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+
+    record->guid = *tmpguid;
+
+    /* parse the flags */
+    r = sync_getflags(fl, mailbox, record);
+    if (r) return r;
+
+    /* the ANNOTATIONS list is optional too */
+    if (salp && dlist_getlist(kr, "ANNOTATIONS", &fl))
+        r = decode_annotations(fl, salp, mailbox, record);
+
+    return r;
+}
+
+/* NOTE - we don't prot_flush here, as we always send an OK at the
+ * end of a response anyway */
+void sync_send_response(struct dlist *kl, struct protstream *out)
+{
+    prot_printf(out, "* ");
+    dlist_print(kl, 1, out);
+    prot_printf(out, "\r\n");
+}
+
+static const char *sync_gentag(struct buf *tag)
+{
+    static unsigned cmdcnt = 0;
+
+    buf_reset(tag);
+    buf_printf(tag, "S%d", cmdcnt++);
+    return buf_cstring(tag);
+}
+
+/* these are one-shot commands for get and apply, so flush the stream
+ * after sending */
+void sync_send_apply(struct dlist *kl, struct protstream *out)
+{
+    if (out->userdata) {
+        /* IMAP flavor (w/ tag) */
+        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    }
+    prot_printf(out, "APPLY ");
+    dlist_print(kl, 1, out);
+    prot_printf(out, "\r\n");
+    prot_flush(out);
+}
+
+void sync_send_lookup(struct dlist *kl, struct protstream *out)
+{
+    if (out->userdata) {
+        /* IMAP flavor (w/ tag) */
+        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    }
+    prot_printf(out, "GET ");
+    dlist_print(kl, 1, out);
+    prot_printf(out, "\r\n");
+    prot_flush(out);
+}
+
+void sync_send_restart(struct protstream *out)
+{
+    if (out->userdata) {
+        /* IMAP flavor (w/ tag) */
+        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    }
+    prot_printf(out, "RESTART\r\n");
+    prot_flush(out);
+}
+
+void sync_send_restore(struct dlist *kl, struct protstream *out)
+{
+    if (out->userdata) {
+        /* IMAP flavor (w/ tag) */
+        prot_printf(out, "%s SYNC", sync_gentag((struct buf *) out->userdata));
+    }
+    prot_printf(out, "RESTORE ");
+    dlist_print(kl, 1, out);
+    prot_printf(out, "\r\n");
+    prot_flush(out);
+}
+
+struct dlist *sync_parseline(struct protstream *in)
+{
+    struct dlist *dl = NULL;
+    int c;
+
+    c = dlist_parse(&dl, 1, 0, in);
+
+    /* end line - or fail */
+    if (c == '\r') c = prot_getc(in);
+    if (c == '\n') return dl;
+
+    dlist_free(&dl);
+    eatline(in, c);
+    return NULL;
+}
+
+static int sync_send_file(struct mailbox *mailbox,
+                          const char *topart,
+                          const struct index_record *record,
+                          struct sync_msgid_list *part_list,
                           struct dlist *kupload)
 {
     struct sync_msgid *msgid;
@@ -1593,7 +1922,7 @@ static int sync_send_file(struct mailbox
     msgid->size = record->size;
     if (!msgid->fname) msgid->fname = xstrdup(fname);
     msgid->need_upload = 0;
-    msgid->is_archive = record->system_flags & FLAG_ARCHIVED ? 1 : 0;
+    msgid->is_archive = (record->internal_flags & FLAG_INTERNAL_ARCHIVED) ? 1 : 0;
     part_list->toupload--;
 
     return 0;
@@ -1605,7 +1934,7 @@ static int sync_prepare_dlists(struct ma
                                const char *topart,
                                struct sync_msgid_list *part_list,
                                struct dlist *kl, struct dlist *kupload,
-                               int printrecords)
+                               int printrecords, int fullannots, int sendsince)
 {
     struct sync_annot_list *annots = NULL;
     struct mailbox_iter *iter = NULL;
@@ -1633,6 +1962,8 @@ static int sync_prepare_dlists(struct ma
         dlist_setdate(kl, "POP3_SHOW_AFTER", remote ? remote->pop3_show_after : 0);
         if (remote && remote->xconvmodseq)
             dlist_setnum64(kl, "XCONVMODSEQ", remote->xconvmodseq);
+        if (remote && remote->raclmodseq)
+            dlist_setnum64(kl, "RACLMODSEQ", remote->raclmodseq);
     }
     else {
         struct synccrcs synccrcs = mailbox_synccrcs(mailbox, /*force*/0);
@@ -1650,6 +1981,9 @@ static int sync_prepare_dlists(struct ma
             if (!r && xconvmodseq)
                 dlist_setnum64(kl, "XCONVMODSEQ", xconvmodseq);
         }
+        modseq_t raclmodseq = mboxname_readraclmodseq(mailbox->name);
+        if (raclmodseq)
+            dlist_setnum64(kl, "RACLMODSEQ", raclmodseq);
     }
     dlist_setnum32(kl, "UIDVALIDITY", mailbox->i.uidvalidity);
     dlist_setatom(kl, "PARTITION", topart);
@@ -1658,13 +1992,25 @@ static int sync_prepare_dlists(struct ma
     if (mailbox->quotaroot)
         dlist_setatom(kl, "QUOTAROOT", mailbox->quotaroot);
 
+    if (mailbox->i.createdmodseq)
+        dlist_setnum64(kl, "CREATEDMODSEQ", mailbox->i.createdmodseq);
+
+    if (mailbox->foldermodseq)
+        dlist_setnum64(kl, "FOLDERMODSEQ", mailbox->foldermodseq);
+
     /* always send mailbox annotations */
-    r = read_annotations(mailbox, NULL, &annots);
+    r = read_annotations(mailbox, NULL, &annots, 0, 0);
     if (r) goto done;
 
-    encode_annotations(kl, NULL, annots);
+    encode_annotations(kl, mailbox, NULL, annots);
     sync_annot_list_free(&annots);
 
+    if (sendsince && remote && remote->highestmodseq) {
+        dlist_setnum64(kl, "SINCE_MODSEQ", remote->highestmodseq);
+        dlist_setnum32(kl, "SINCE_CRC", remote->synccrcs.basic);
+        dlist_setnum32(kl, "SINCE_CRC_ANNOT", remote->synccrcs.annot);
+    }
+
     if (printrecords) {
         const message_t *msg;
         struct dlist *rl = dlist_newlist(kl, "RECORD");
@@ -1673,6 +2019,8 @@ static int sync_prepare_dlists(struct ma
         iter = mailbox_iter_init(mailbox, modseq, 0);
         while ((msg = mailbox_iter_step(iter))) {
             const struct index_record *record = msg_record(msg);
+            modseq_t since_modseq = fullannots ? 0 : modseq;
+
             /* stop early for partial sync */
             modseq_t mymodseq = record->modseq;
             if (ispartial) {
@@ -1688,6 +2036,7 @@ static int sync_prepare_dlists(struct ma
                 }
             }
 
+
             /* start off thinking we're sending the file too */
             int send_file = 1;
 
@@ -1700,7 +2049,7 @@ static int sync_prepare_dlists(struct ma
                 send_file = 0;
 
             /* if we don't HAVE the file we can't send it */
-            if (record->system_flags & FLAG_UNLINKED)
+            if (record->internal_flags & FLAG_INTERNAL_UNLINKED)
                 send_file = 0;
 
             if (send_file) {
@@ -1718,10 +2067,11 @@ static int sync_prepare_dlists(struct ma
             dlist_setnum32(il, "SIZE", record->size);
             dlist_setatom(il, "GUID", message_guid_encode(&record->guid));
 
-            r = read_annotations(mailbox, record, &annots);
+            r = read_annotations(mailbox, record, &annots, since_modseq,
+                                /*XXX ANNOTATE_TOMBSTONES*/0);
             if (r) goto done;
 
-            encode_annotations(il, record, annots);
+            encode_annotations(il, mailbox, record, annots);
             sync_annot_list_free(&annots);
         }
     }
@@ -1791,12 +2141,18 @@ int sync_parse_response(const char *cmd,
         else if (!strncmp(errmsg.s, "IMAP_MAILBOX_LOCKED ",
                           strlen("IMAP_MAILBOX_LOCKED ")))
             return IMAP_MAILBOX_LOCKED;
+        else if (!strncmp(errmsg.s, "IMAP_MAILBOX_MOVED ",
+                          strlen("IMAP_MAILBOX_MOVED ")))
+            return IMAP_MAILBOX_MOVED;
         else if (!strncmp(errmsg.s, "IMAP_MAILBOX_NOTSUPPORTED ",
                           strlen("IMAP_MAILBOX_NOTSUPPORTED ")))
             return IMAP_MAILBOX_NOTSUPPORTED;
         else if (!strncmp(errmsg.s, "IMAP_SYNC_CHECKSUM ",
                           strlen("IMAP_SYNC_CHECKSUM ")))
             return IMAP_SYNC_CHECKSUM;
+        else if (!strncmp(errmsg.s, "IMAP_SYNC_CHANGED ",
+                          strlen("IMAP_SYNC_CHANGED ")))
+            return IMAP_SYNC_CHANGED;
         else if (!strncmp(errmsg.s, "IMAP_SYNC_BADSIEVE ",
                           strlen("IMAP_SYNC_BADSIEVE ")))
             return IMAP_SYNC_BADSIEVE;
@@ -1837,304 +2193,59 @@ int sync_append_copyfile(struct mailbox
     else
         r = message_parse(item->fname, record);
 
-    if (r) {
-        /* deal with unlinked master records */
-        if (record->system_flags & FLAG_EXPUNGED) {
-            /* no need to set 'needs cleanup' here, it's already expunged */
-            record->system_flags |= FLAG_UNLINKED;
-            goto just_write;
-        }
-        syslog(LOG_ERR, "IOERROR: failed to parse %s: %s",
-               message_guid_encode(&record->guid),
-               error_message(r));
-        return r;
-    }
-
-    /* record->guid was rewritten in the parse, see if it changed */
-    if (!message_guid_equal(&tmp_guid, &record->guid)) {
-        syslog(LOG_ERR, "IOERROR: guid mismatch on parse %s (%s)",
-               item->fname, message_guid_encode(&record->guid));
-        return IMAP_IOERROR;
-    }
-
-    /* put back to archive if original was archived, gain single instance store  */
-    if (item->is_archive)
-        record->system_flags |= FLAG_ARCHIVED;
-
-    /* push it to archive if it should be archived now anyway */
-    if (mailbox_should_archive(mailbox, record, NULL))
-        record->system_flags |= FLAG_ARCHIVED;
-
-    destname = mailbox_record_fname(mailbox, record);
-    cyrus_mkdir(destname, 0755);
-    r = mailbox_copyfile(item->fname, destname, 0);
-    if (r) {
-        syslog(LOG_ERR, "IOERROR: Failed to copy %s to %s",
-               item->fname, destname);
-        return r;
-    }
-
- just_write:
-    r = mailbox_append_index_record(mailbox, record);
-    if (r) return r;
-
-    /* apply the remote annotations */
-    r = apply_annotations(mailbox, record, NULL, annots, 0);
-    if (r) {
-        syslog(LOG_ERR, "Failed to apply annotations: %s",
-               error_message(r));
-    }
-
-    return r;
-}
-
-/* ====================================================================== */
-
-static int read_one_annot(const char *mailbox __attribute__((unused)),
-                          uint32_t uid __attribute__((unused)),
-                          const char *entry,
-                          const char *userid,
-                          const struct buf *value,
-                          void *rock)
-{
-    struct sync_annot_list **salp = (struct sync_annot_list **)rock;
-
-    if (!*salp)
-        *salp = sync_annot_list_create();
-    sync_annot_list_add(*salp, entry, userid, value);
-    return 0;
-}
-
-/*
- * Read all the annotations in the local annotations database
- * for the message given by @mailbox and @record, returning them
- * as a new sync_annot_list.  The caller should free the new
- * list with sync_annot_list_free().
- * If record is NULL, return the mailbox annotations
- *
- * Returns: non-zero on error,
- *          resulting sync_annot_list in *@resp
- */
-int read_annotations(const struct mailbox *mailbox,
-                     const struct index_record *record,
-                     struct sync_annot_list **resp)
-{
-    *resp = NULL;
-    return annotatemore_findall(mailbox->name, record ? record->uid : 0,
-                                /* all entries*/"*",
-                                read_one_annot, (void *)resp);
-}
-
-/*
- * Encode the given list of annotations @sal as a dlist
- * structure with the given @parent.
- */
-void encode_annotations(struct dlist *parent,
-                        const struct index_record *record,
-                        const struct sync_annot_list *sal)
-{
-    const struct sync_annot *sa;
-    struct dlist *annots = NULL;
-    struct dlist *aa;
-
-    if (sal) {
-        for (sa = sal->head ; sa ; sa = sa->next) {
-            if (!annots)
-                annots = dlist_newlist(parent, "ANNOTATIONS");
-
-            aa = dlist_newkvlist(annots, NULL);
-            dlist_setatom(aa, "ENTRY", sa->entry);
-            dlist_setatom(aa, "USERID", sa->userid);
-            dlist_setmap(aa, "VALUE", sa->value.s, sa->value.len);
-        }
-    }
-
-    if (record && record->cid) {
-        if (!annots)
-            annots = dlist_newlist(parent, "ANNOTATIONS");
-        aa = dlist_newkvlist(annots, NULL);
-        dlist_setatom(aa, "ENTRY", IMAP_ANNOT_NS "thrid");
-        dlist_setatom(aa, "USERID", NULL);
-        dlist_sethex64(aa, "VALUE", record->cid);
-    }
-}
-
-/*
- * Decode the given list of encoded annotations @annots and create
- * a new sync_annot_list in *@salp, which the caller should free
- * with sync_annot_list_free().
- *
- * Returns: zero on success or Cyrus error code.
- */
-int decode_annotations(/*const*/struct dlist *annots,
-                       struct sync_annot_list **salp,
-                       struct index_record *record)
-{
-    struct dlist *aa;
-    const char *entry;
-    const char *userid;
-
-    *salp = NULL;
-    if (strcmp(annots->name, "ANNOTATIONS"))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
-
-    for (aa = annots->head ; aa ; aa = aa->next) {
-        struct buf value = BUF_INITIALIZER;
-        if (!*salp)
-            *salp = sync_annot_list_create();
-        if (!dlist_getatom(aa, "ENTRY", &entry))
-            return IMAP_PROTOCOL_BAD_PARAMETERS;
-        if (!dlist_getatom(aa, "USERID", &userid))
-            return IMAP_PROTOCOL_BAD_PARAMETERS;
-        if (!dlist_getbuf(aa, "VALUE", &value))
-            return IMAP_PROTOCOL_BAD_PARAMETERS;
-        if (!strcmp(entry, IMAP_ANNOT_NS "thrid")) {
-            if (record) {
-                const char *p = buf_cstring(&value);
-                parsehex(p, &p, 16, &record->cid);
-                /* XXX - check on p? */
-            }
-        }
-        else {
-            sync_annot_list_add(*salp, entry, userid, &value);
-        }
-        buf_free(&value);
-    }
-    return 0;
-}
-
-/*
- * Merge a local and remote list of annotations, and apply the resulting
- * list of annotations to the local annotation database, storing new values
- * or deleting old values as necessary.  Manages its own annotations
- * transaction.
- * Record may be null, to process mailbox annotations.
- */
-
-static int diff_annotation(const struct sync_annot *a,
-                           const struct sync_annot *b,
-                           int diff_value)
-{
-    int diff = 0;
-
-    if (!a && !b) return 0;
-
-    if (a)
-        diff--;
-    if (b)
-        diff++;
-
-    if (!diff)
-        diff = strcmpnull(a->entry, b->entry);
-    if (!diff)
-        diff = strcmpnull(a->userid, b->userid);
-    if (!diff && diff_value)
-        diff = buf_cmp(&a->value, &b->value);
-
-    return diff;
-}
-
-int diff_annotations(const struct sync_annot_list *local_annots,
-                     const struct sync_annot_list *remote_annots)
-{
-    const struct sync_annot *local = (local_annots ? local_annots->head : NULL);
-    const struct sync_annot *remote = (remote_annots ? remote_annots->head : NULL);
-    while (local || remote) {
-        int r = diff_annotation(local, remote, 1);
-        if (r) return r;
-        if (local) local = local->next;
-        if (remote) remote = remote->next;
-    }
-
-    return 0;
-}
-
-int apply_annotations(struct mailbox *mailbox,
-                      const struct index_record *record,
-                      const struct sync_annot_list *local_annots,
-                      const struct sync_annot_list *remote_annots,
-                      int local_wins)
-{
-    const struct sync_annot *local = (local_annots ? local_annots->head : NULL);
-    const struct sync_annot *remote = (remote_annots ? remote_annots->head : NULL);
-    const struct sync_annot *chosen;
-    static const struct buf novalue = BUF_INITIALIZER;
-    const struct buf *value;
-    int r = 0;
-    int diff;
-    annotate_state_t *astate = NULL;
-
-    if (record) {
-        r = mailbox_get_annotate_state(mailbox, record->uid, &astate);
+    if (r) {
+        /* deal with unlinked master records */
+        if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
+            /* no need to set 'needs cleanup' here, it's already expunged */
+            record->internal_flags |= FLAG_INTERNAL_UNLINKED;
+            goto just_write;
+        }
+        syslog(LOG_ERR, "IOERROR: failed to parse %s: %s",
+               message_guid_encode(&record->guid),
+               error_message(r));
+        return r;
     }
-    else {
-        astate = annotate_state_new();
-        r = annotate_state_set_mailbox(astate, mailbox);
+
+    /* record->guid was rewritten in the parse, see if it changed */
+    if (!message_guid_equal(&tmp_guid, &record->guid)) {
+        syslog(LOG_ERR, "IOERROR: guid mismatch on parse %s (%s)",
+               item->fname, message_guid_encode(&record->guid));
+        return IMAP_IOERROR;
     }
-    if (r) goto out;
 
-    /*
-     * We rely here on the database scan order resulting in lists
-     * of annotations that are ordered lexically on entry then userid.
-     * We walk over both lists at once, choosing an annotation from
-     * either the local list only (diff < 0), the remote list only
-     * (diff > 0), or both lists (diff == 0).
-     */
-    while (local || remote) {
-        diff = diff_annotation(local, remote, 0);
-        chosen = 0;
-        if (diff < 0) {
-            chosen = local;
-            value = (local_wins ? &local->value : &novalue);
-            local = local->next;
-        }
-        else if (diff > 0) {
-            chosen = remote;
-            value = (local_wins ? &novalue : &remote->value);
-            remote = remote->next;
-        }
-        else {
-            chosen = remote;
-            value = (local_wins ? &local->value : &remote->value);
-            diff = buf_cmp(&local->value, &remote->value);
-            local = local->next;
-            remote = remote->next;
-            if (!diff)
-                continue;   /* same value, skip */
-        }
+    /* put back to archive if original was archived, gain single instance store  */
+    if (item->is_archive)
+        record->internal_flags |= FLAG_INTERNAL_ARCHIVED;
 
-        r = annotate_state_write(astate, chosen->entry,
-                                 chosen->userid, value);
-        if (r)
-            break;
+    /* push it to archive if it should be archived now anyway */
+    if (mailbox_should_archive(mailbox, record, NULL))
+        record->internal_flags |= FLAG_INTERNAL_ARCHIVED;
+
+    destname = mailbox_record_fname(mailbox, record);
+    cyrus_mkdir(destname, 0755);
+    r = mailbox_copyfile(item->fname, destname, 0);
+    if (r) {
+        syslog(LOG_ERR, "IOERROR: Failed to copy %s to %s",
+               item->fname, destname);
+        return r;
     }
 
-out:
+ just_write:
+    r = mailbox_append_index_record(mailbox, record);
+    if (r) return r;
 
-    if (record) {
-#ifdef USE_CALALARMD
-        if (mailbox->mbtype & MBTYPE_CALENDAR) {
-            // NOTE: this is because we don't pass the annotations through
-            // with the record as we create it, so we can't update the alarm
-            // database properly.  Instead, we don't set anything when we append
-            // by checking for .silent, and instead update the database by touching
-            // the alarm AFTER writing the record.
-            caldav_alarm_touch_record(mailbox, record);
-        }
-#endif
-    }
-    else {
-        /* need to manage our own txn for the global db */
-        if (!r)
-            r = annotate_state_commit(&astate);
-        else
-            annotate_state_abort(&astate);
+    /* apply the remote annotations */
+    r = apply_annotations(mailbox, record, NULL, annots, 0);
+    if (r) {
+        syslog(LOG_ERR, "Failed to apply annotations: %s",
+               error_message(r));
     }
-    /* else, the struct mailbox manages it for us */
 
     return r;
 }
 
+/* ==================================================================== */
+
 int sync_mailbox_version_check(struct mailbox **mailboxp)
 {
     int r = 0;
@@ -2205,7 +2316,8 @@ redo:
 
         /* Attempt to reserve this message */
         mailbox_msg_path = mailbox_record_fname(mailbox, record);
-        stage_msg_path = dlist_reserve_path(part, record->system_flags & FLAG_ARCHIVED, 0, &record->guid);
+        stage_msg_path = dlist_reserve_path(part, record->internal_flags & FLAG_INTERNAL_ARCHIVED,
+                                            0, &record->guid);
 
         /* check that the sha1 of the file on disk is correct */
         struct index_record record2;
@@ -2230,7 +2342,7 @@ redo:
 
         item->size = record->size;
         item->fname = xstrdup(stage_msg_path); /* track the correct location */
-        item->is_archive = record->system_flags & FLAG_ARCHIVED ? 1 : 0;
+        item->is_archive = (record->internal_flags & FLAG_INTERNAL_ARCHIVED) ? 1 : 0;
         item->need_upload = 0;
         part_list->toupload--;
         num_reserved++;
@@ -2349,12 +2461,16 @@ int sync_apply_quota(struct dlist *kin,
     if (!dlist_getatom(kin, "ROOT", &root))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
     sync_decode_quota_limits(kin, limits);
-    return mboxlist_setquotas(root, limits, 1);
+
+    modseq_t modseq = 0;
+    dlist_getnum64(kin, "MODSEQ", &modseq);
+
+    return mboxlist_setquotas(root, limits, modseq, 1);
 }
 
 /* ====================================================================== */
 
-static int mailbox_compare_update(struct mailbox *mailbox,
+static int sync_mailbox_compare_update(struct mailbox *mailbox,
                                   struct dlist *kr, int doupdate,
                                   struct sync_msgid_list *part_list)
 {
@@ -2393,14 +2509,14 @@ static int mailbox_compare_update(struct
         /* found a match, check for updates */
         if (rrecord && rrecord->uid == mrecord.uid) {
             /* if they're both EXPUNGED then ignore everything else */
-            if ((mrecord.system_flags & FLAG_EXPUNGED) &&
-                (rrecord->system_flags & FLAG_EXPUNGED))
+            if (mrecord.internal_flags & FLAG_INTERNAL_EXPUNGED &&
+                rrecord->internal_flags & FLAG_INTERNAL_EXPUNGED)
                 continue;
 
             /* GUID mismatch is an error straight away, it only ever happens if we
              * had a split brain - and it will take a full sync to sort out the mess */
             if (!message_guid_equal(&mrecord.guid, &rrecord->guid)) {
-                syslog(LOG_ERR, "SYNCERROR: guid mismatch %s %u",
+                syslog(LOG_ERR, "SYNCNOTICE: guid mismatch %s %u",
                        mailbox->name, mrecord.uid);
                 r = IMAP_SYNC_CHECKSUM;
                 goto out;
@@ -2413,7 +2529,7 @@ static int mailbox_compare_update(struct
                            mailbox->name, mrecord.uid, rrecord->modseq, mrecord.modseq);
                 }
                 else {
-                    syslog(LOG_ERR, "SYNCERROR: higher modseq on replica %s %u (" MODSEQ_FMT " > " MODSEQ_FMT ")",
+                    syslog(LOG_ERR, "SYNCNOTICE: higher modseq on replica %s %u (" MODSEQ_FMT " > " MODSEQ_FMT ")",
                            mailbox->name, mrecord.uid, rrecord->modseq, mrecord.modseq);
                     r = IMAP_SYNC_CHECKSUM;
                     goto out;
@@ -2422,9 +2538,9 @@ static int mailbox_compare_update(struct
 
             /* if it's already expunged on the replica, but alive on the master,
              * that's bad */
-            if (!(mrecord.system_flags & FLAG_EXPUNGED) &&
-                 (rrecord->system_flags & FLAG_EXPUNGED)) {
-                syslog(LOG_ERR, "SYNCERROR: expunged on replica %s %u",
+            if (!(mrecord.internal_flags & FLAG_INTERNAL_EXPUNGED) &&
+                (rrecord->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+                syslog(LOG_ERR, "SYNCNOTICE: expunged on replica %s %u",
                        mailbox->name, mrecord.uid);
                 r = IMAP_SYNC_CHECKSUM;
                 goto out;
@@ -2435,15 +2551,24 @@ static int mailbox_compare_update(struct
 
             struct index_record copy = *rrecord;
             copy.cid = mrecord.cid;
+            copy.basecid = mrecord.basecid;
             copy.modseq = mrecord.modseq;
             copy.last_updated = mrecord.last_updated;
             copy.internaldate = mrecord.internaldate;
-            copy.system_flags = (mrecord.system_flags & FLAGS_GLOBAL) |
-                                (rrecord->system_flags & FLAGS_LOCAL);
+            copy.savedate = mrecord.savedate;
+            copy.createdmodseq = mrecord.createdmodseq;
+            copy.system_flags = mrecord.system_flags;
+            /* FLAG_INTERNAL_EXPUNGED is a syncable flag, but it's internal.
+             * The `internal_flags` contain replica's internal_flags for
+             * non-EXPUNGED, but master's internal_flags for EXPUNGED */
+            copy.internal_flags = rrecord->internal_flags & ~FLAG_INTERNAL_EXPUNGED;
+            copy.internal_flags |= mrecord.internal_flags & FLAG_INTERNAL_EXPUNGED;
+
             for (i = 0; i < MAX_USER_FLAGS/32; i++)
                 copy.user_flags[i] = mrecord.user_flags[i];
 
-            r = read_annotations(mailbox, &copy, &rannots);
+            r = read_annotations(mailbox, &copy, &rannots, rrecord->modseq,
+                                 /*XXX ANNOTATE_TOMBSTONES*/0);
             if (r) {
                 syslog(LOG_ERR, "Failed to read local annotations %s %u: %s",
                        mailbox->name, rrecord->recno, error_message(r));
@@ -2469,7 +2594,7 @@ static int mailbox_compare_update(struct
         /* not found and less than LAST_UID, bogus */
         else if (mrecord.uid <= mailbox->i.last_uid) {
             /* Expunged, just skip it */
-            if (!(mrecord.system_flags & FLAG_EXPUNGED)) {
+            if (!(mrecord.internal_flags & FLAG_INTERNAL_EXPUNGED)) {
                 r = IMAP_SYNC_CHECKSUM;
                 goto out;
             }
@@ -2504,18 +2629,6 @@ out:
     return r;
 }
 
-/* if either CRC is zero for a field, then we consider it to match.
- * this lets us bootstrap the case where CRCs weren't being calculated,
- * and also allows a client with incomplete local information to request
- * a change be made on a sync_server without having to fetch all the
- * data first just to calculate the CRC */
-static int crceq(struct synccrcs a, struct synccrcs b)
-{
-    if (a.basic && b.basic && a.basic != b.basic) return 0;
-    if (a.annot && b.annot && a.annot != b.annot) return 0;
-    return 1;
-}
-
 int sync_apply_mailbox(struct dlist *kin,
                        struct sync_reserve_list *reserve_list,
                        struct sync_state *sstate)
@@ -2535,6 +2648,7 @@ int sync_apply_mailbox(struct dlist *kin
     time_t pop3_last_login;
     time_t pop3_show_after = 0; /* optional */
     uint32_t uidvalidity;
+    modseq_t foldermodseq = 0;
     const char *acl;
     const char *options_str;
     struct synccrcs synccrcs = { 0, 0 };
@@ -2543,6 +2657,12 @@ int sync_apply_mailbox(struct dlist *kin
 
     /* optional fields */
     modseq_t xconvmodseq = 0;
+    modseq_t raclmodseq = 0;
+    modseq_t createdmodseq = 0;
+
+    /* previous state markers */
+    modseq_t since_modseq = 0;
+    struct synccrcs since_crcs = { 0, 0 };
 
     struct mailbox *mailbox = NULL;
     struct dlist *kr;
@@ -2556,14 +2676,38 @@ int sync_apply_mailbox(struct dlist *kin
 
     if (!dlist_getatom(kin, "UNIQUEID", &uniqueid))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getatom(kin, "PARTITION", &partition))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
     if (!dlist_getatom(kin, "MBOXNAME", &mboxname))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
-    if (!dlist_getnum32(kin, "LAST_UID", &last_uid))
-        return IMAP_PROTOCOL_BAD_PARAMETERS;
     if (!dlist_getnum64(kin, "HIGHESTMODSEQ", &highestmodseq))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
+
+    dlist_getnum64(kin, "CREATEDMODSEQ", &createdmodseq);
+
+    dlist_getatom(kin, "MBOXTYPE", &mboxtype);
+    mbtype = mboxlist_string_to_mbtype(mboxtype);
+
+    if (mbtype & (MBTYPE_INTERMEDIATE|MBTYPE_DELETED)) {
+        // XXX - make sure what's already there is either nothing or compatible...
+        mbentry_t *newmbentry = NULL;
+
+        newmbentry = mboxlist_entry_create();
+        newmbentry->name = xstrdupnull(mboxname);
+        newmbentry->mbtype = mbtype;
+        newmbentry->uniqueid = xstrdupnull(uniqueid);
+        newmbentry->foldermodseq = highestmodseq;
+        newmbentry->createdmodseq = createdmodseq;
+
+        r = mboxlist_update(newmbentry, /*localonly*/1);
+        mboxlist_entry_free(&newmbentry);
+
+        return r;
+    }
+
+
+    if (!dlist_getatom(kin, "PARTITION", &partition))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
+    if (!dlist_getnum32(kin, "LAST_UID", &last_uid))
+        return IMAP_PROTOCOL_BAD_PARAMETERS;
     if (!dlist_getnum32(kin, "RECENTUID", &recentuid))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
     if (!dlist_getdate(kin, "RECENTTIME", &recenttime))
@@ -2584,27 +2728,50 @@ int sync_apply_mailbox(struct dlist *kin
     /* optional */
     dlist_getlist(kin, "ANNOTATIONS", &ka);
     dlist_getdate(kin, "POP3_SHOW_AFTER", &pop3_show_after);
-    dlist_getatom(kin, "MBOXTYPE", &mboxtype);
     dlist_getnum64(kin, "XCONVMODSEQ", &xconvmodseq);
+    dlist_getnum64(kin, "RACLMODSEQ", &raclmodseq);
+    dlist_getnum64(kin, "FOLDERMODSEQ", &foldermodseq);
 
     /* Get the CRCs */
     dlist_getnum32(kin, "SYNC_CRC", &synccrcs.basic);
     dlist_getnum32(kin, "SYNC_CRC_ANNOT", &synccrcs.annot);
 
+    /* Get the previous state for this delta */
+    dlist_getnum64(kin, "SINCE_MODSEQ", &since_modseq);
+    dlist_getnum32(kin, "SINCE_CRC", &since_crcs.basic);
+    dlist_getnum32(kin, "SINCE_CRC_ANNOT", &since_crcs.annot);
+
     options = sync_parse_options(options_str);
-    mbtype = mboxlist_string_to_mbtype(mboxtype);
 
     r = mailbox_open_iwl(mboxname, &mailbox);
     if (!r) r = sync_mailbox_version_check(&mailbox);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
-        r = mboxlist_createsync(mboxname, mbtype, partition,
-                                sstate->userid, sstate->authstate,
-                                options, uidvalidity,
-                                highestmodseq, acl,
-                                uniqueid, sstate->local_only, &mailbox);
-        /* set a highestmodseq of 0 so ALL changes are future
-         * changes and get applied */
-        if (!r) mailbox->i.highestmodseq = 0;
+        struct mboxlock *namespacelock = mboxname_usernamespacelock(mboxname);
+        // try again under lock
+        r = mailbox_open_iwl(mboxname, &mailbox);
+        if (!r) r = sync_mailbox_version_check(&mailbox);
+        if (r == IMAP_MAILBOX_NONEXISTENT) { // did we win a race?
+            char *oldname = mboxlist_find_uniqueid(uniqueid, NULL, NULL);
+            // if they have the same name it's probably an intermediate being
+            // promoted.  Intermediates, the gift that keeps on giving.
+            if (oldname && strcmp(oldname, mboxname)) {
+                syslog(LOG_ERR, "SYNCNOTICE: failed to create mailbox %s with uniqueid %s (already used by %s)",
+                       mboxname, uniqueid, oldname);
+                free(oldname);
+                r = IMAP_MAILBOX_MOVED;
+            }
+            else {
+                r = mboxlist_createsync(mboxname, mbtype, partition,
+                                            sstate->userid, sstate->authstate,
+                                            options, uidvalidity, createdmodseq,
+                                            highestmodseq, foldermodseq, acl,
+                                            uniqueid, sstate->local_only, 0, &mailbox);
+            }
+            /* set a highestmodseq of 0 so ALL changes are future
+             * changes and get applied */
+            if (!r) mailbox->i.highestmodseq = 0;
+        }
+        mboxname_release(&namespacelock);
     }
     if (r) {
         syslog(LOG_ERR, "Failed to open mailbox %s to update: %s",
@@ -2612,6 +2779,22 @@ int sync_apply_mailbox(struct dlist *kin
         goto done;
     }
 
+    // immediate bail if we have an old state to compare
+    if (since_modseq) {
+        struct synccrcs mycrcs = mailbox_synccrcs(mailbox, 0);
+        if (since_modseq != mailbox->i.highestmodseq ||
+            !mailbox_crceq(since_crcs, mycrcs)) {
+            syslog(LOG_ERR, "SYNCNOTICE: mailbox sync mismatch %s "
+                            "hms (m=%llu,r=%llu) crcs (m=%u/%u,r=%u/%u)",
+                   mailbox->name,
+                   since_modseq, mailbox->i.highestmodseq,
+                   since_crcs.basic, since_crcs.annot,
+                   mycrcs.basic, mycrcs.annot);
+            r = IMAP_SYNC_CHANGED;
+            goto done;
+        }
+    }
+
     if (mailbox->mbtype != mbtype) {
         syslog(LOG_ERR, "INVALID MAILBOX TYPE %s (%d, %d)", mailbox->name, mailbox->mbtype, mbtype);
         /* is this even possible? */
@@ -2637,7 +2820,7 @@ int sync_apply_mailbox(struct dlist *kin
             mailbox->header_dirty = 1;
         }
         else {
-            syslog(LOG_ERR, "Mailbox uniqueid changed %s (%s => %s) - retry",
+            syslog(LOG_ERR, "SYNCNOTICE: Mailbox uniqueid changed %s (%s => %s) - retry",
                    mboxname, mailbox->uniqueid, uniqueid);
             r = IMAP_MAILBOX_MOVED;
             goto done;
@@ -2688,6 +2871,13 @@ int sync_apply_mailbox(struct dlist *kin
         }
     }
 
+    /* skip out now, it's going to mismatch for sure! */
+    /* 0 is the default case, and should always be overwritten with the real value */
+    if (createdmodseq > mailbox->i.createdmodseq && mailbox->i.createdmodseq != 0) {
+        syslog(LOG_NOTICE, "SYNCNOTICE: lower createdmodseq on replica %s - %llu > %llu",
+               mboxname, createdmodseq, mailbox->i.createdmodseq);
+    }
+
     /* NOTE - this is optional */
     if (mailbox_has_conversations(mailbox) && xconvmodseq) {
         modseq_t ourxconvmodseq = 0;
@@ -2714,7 +2904,7 @@ int sync_apply_mailbox(struct dlist *kin
         }
     }
 
-    r = mailbox_compare_update(mailbox, kr, 0, part_list);
+    r = sync_mailbox_compare_update(mailbox, kr, 0, part_list);
     if (r) goto done;
 
     /* now we're committed to writing something no matter what happens! */
@@ -2724,18 +2914,16 @@ int sync_apply_mailbox(struct dlist *kin
     mailbox->silentchanges = 1;
 
     /* always take the ACL from the master, it's not versioned */
-    if (strcmp(mailbox->acl, acl)) {
-        mailbox_set_acl(mailbox, acl, 0);
-        r = mboxlist_sync_setacls(mboxname, acl);
-        if (r) goto done;
-    }
+    r = mboxlist_sync_setacls(mboxname, acl, foldermodseq ? foldermodseq : highestmodseq);
+    if (!r) r = mailbox_set_acl(mailbox, acl);
+    if (r) goto done;
 
     /* take all mailbox (not message) annotations - aka metadata,
      * they're not versioned either */
     if (ka)
-        decode_annotations(ka, &mannots, NULL);
+        decode_annotations(ka, &mannots, mailbox, NULL);
 
-    r = read_annotations(mailbox, NULL, &rannots);
+    r = read_annotations(mailbox, NULL, &rannots, 0, 0);
     if (!r) r = apply_annotations(mailbox, NULL, rannots, mannots, 0);
 
     if (r) {
@@ -2744,7 +2932,7 @@ int sync_apply_mailbox(struct dlist *kin
         goto done;
     }
 
-    r = mailbox_compare_update(mailbox, kr, 1, part_list);
+    r = sync_mailbox_compare_update(mailbox, kr, 1, part_list);
     if (r) {
         abort();
         return r;
@@ -2760,6 +2948,7 @@ int sync_apply_mailbox(struct dlist *kin
     mailbox->i.last_appenddate = last_appenddate;
     mailbox->i.pop3_last_login = pop3_last_login;
     mailbox->i.pop3_show_after = pop3_show_after;
+    mailbox->i.createdmodseq = createdmodseq;
     /* only alter the syncable options */
     mailbox->i.options = (options & MAILBOX_OPTIONS_MASK) |
                          (mailbox->i.options & ~MAILBOX_OPTIONS_MASK);
@@ -2779,14 +2968,18 @@ int sync_apply_mailbox(struct dlist *kin
         r = mailbox_update_xconvmodseq(mailbox, xconvmodseq, opt_force);
     }
 
+    if (config_getswitch(IMAPOPT_REVERSEACLS) && raclmodseq) {
+        mboxname_setraclmodseq(mailbox->name, raclmodseq);
+    }
+
 done:
     sync_annot_list_free(&mannots);
     sync_annot_list_free(&rannots);
 
     /* check the CRC too */
-    if (!r && !crceq(synccrcs, mailbox_synccrcs(mailbox, 0))) {
+    if (!r && !mailbox_crceq(synccrcs, mailbox_synccrcs(mailbox, 0))) {
         /* try forcing a recalculation */
-        if (!crceq(synccrcs, mailbox_synccrcs(mailbox, 1)))
+        if (!mailbox_crceq(synccrcs, mailbox_synccrcs(mailbox, 1)))
             r = IMAP_SYNC_CHECKSUM;
     }
 
@@ -2801,6 +2994,7 @@ static int getannotation_cb(const char *
                             uint32_t uid __attribute__((unused)),
                             const char *entry, const char *userid,
                             const struct buf *value,
+                            const struct annotate_metadata *mdata __attribute__((unused)),
                             void *rock)
 {
     struct protstream *pout = (struct protstream *)rock;
@@ -2820,8 +3014,9 @@ static int getannotation_cb(const char *
 int sync_get_annotation(struct dlist *kin, struct sync_state *sstate)
 {
     const char *mboxname = kin->sval;
-    return annotatemore_findall(mboxname, 0, "*", &getannotation_cb,
-                                (void *) sstate->pout);
+    return annotatemore_findall(mboxname, 0, "*", /*modseq*/0,
+                                &getannotation_cb, (void *) sstate->pout,
+                                /*flags*/0);
 }
 
 static void print_quota(struct quota *q, struct protstream *pout)
@@ -2831,6 +3026,7 @@ static void print_quota(struct quota *q,
     kl = dlist_newkvlist(NULL, "QUOTA");
     dlist_setatom(kl, "ROOT", q->root);
     sync_encode_quota_limits(kl, q->limits);
+    dlist_setnum64(kl, "MODSEQ", q->modseq);
     sync_send_response(kl, pout);
     dlist_free(&kl);
 }
@@ -2857,7 +3053,7 @@ struct mbox_rock {
     struct sync_name_list *qrl;
 };
 
-static int mailbox_byname(const char *name, void *rock)
+static int sync_mailbox_byname(const char *name, void *rock)
 {
     struct mbox_rock *mrock = (struct mbox_rock *) rock;
     struct sync_name_list *qrl = mrock->qrl;
@@ -2866,10 +3062,7 @@ static int mailbox_byname(const char *na
     annotate_state_t *astate = NULL;
     int r;
 
-    /* XXX - we don't write anything, but there's no interface
-     * to safely get read-only access to the annotation and
-     * other "side" databases here */
-    r = mailbox_open_iwl(name, &mailbox);
+    r = mailbox_open_irl(name, &mailbox);
     if (!r) r = sync_mailbox_version_check(&mailbox);
     /* doesn't exist?  Probably not finished creating or removing yet */
     if (r == IMAP_MAILBOX_NONEXISTENT ||
@@ -2890,7 +3083,10 @@ static int mailbox_byname(const char *na
          !sync_name_lookup(qrl, mailbox->quotaroot))
         sync_name_list_add(qrl, mailbox->quotaroot);
 
-    r = sync_prepare_dlists(mailbox, NULL, NULL, NULL, NULL, kl, NULL, 0);
+    r = sync_prepare_dlists(mailbox, NULL, NULL, NULL, NULL, kl, NULL, 0,
+                            /*XXX fullannots*/1, 0);
+
+
     if (!r) sync_send_response(kl, mrock->pout);
 
 out:
@@ -2900,9 +3096,17 @@ out:
     return r;
 }
 
+static int sync_mailbox_byuniqueid(const char *uniqueid, void *rock)
+{
+    char *name = mboxlist_find_uniqueid(uniqueid, NULL, NULL);
+    int r = sync_mailbox_byname(name, rock);
+    free(name);
+    return r;
+}
+
 static int mailbox_cb(const mbentry_t *mbentry, void *rock)
 {
-    return mailbox_byname(mbentry->name, rock);
+    return sync_mailbox_byname(mbentry->name, rock);
 }
 
 int sync_get_fullmailbox(struct dlist *kin, struct sync_state *sstate)
@@ -2911,14 +3115,12 @@ int sync_get_fullmailbox(struct dlist *k
     struct dlist *kl = dlist_newkvlist(NULL, "MAILBOX");
     int r;
 
-    /* XXX again - this is a read-only request, but we
-     * don't have a good way to express that, so we use
-     * write locks anyway */
-    r = mailbox_open_iwl(kin->sval, &mailbox);
+    r = mailbox_open_irl(kin->sval, &mailbox);
     if (!r) r = sync_mailbox_version_check(&mailbox);
     if (r) goto out;
 
-    r = sync_prepare_dlists(mailbox, NULL, NULL, NULL, NULL, kl, NULL, 1);
+    r = sync_prepare_dlists(mailbox, NULL, NULL, NULL, NULL, kl, NULL, 1,
+                            /*XXX fullannots*/1, 0);
     if (r) goto out;
 
     sync_send_response(kl, sstate->pout);
@@ -2935,7 +3137,18 @@ int sync_get_mailboxes(struct dlist *kin
     struct mbox_rock mrock = { sstate->pout, NULL };
 
     for (ki = kin->head; ki; ki = ki->next)
-        mailbox_byname(ki->sval, &mrock);
+        sync_mailbox_byname(ki->sval, &mrock);
+
+    return 0;
+}
+
+int sync_get_uniqueids(struct dlist *kin, struct sync_state *sstate)
+{
+    struct dlist *ki;
+    struct mbox_rock mrock = { sstate->pout, NULL };
+
+    for (ki = kin->head; ki; ki = ki->next)
+        sync_mailbox_byuniqueid(ki->sval, &mrock);
 
     return 0;
 }
@@ -3044,7 +3257,7 @@ int sync_get_user(struct dlist *kin, str
     mrock.qrl = quotaroots;
     mrock.pout = sstate->pout;
 
-    r = mboxlist_usermboxtree(userid, mailbox_cb, &mrock, MBOXTREE_DELETED);
+    r = mboxlist_usermboxtree(userid, NULL, mailbox_cb, &mrock, MBOXTREE_DELETED);
     if (r) goto bail;
 
     for (qr = quotaroots->head; qr; qr = qr->next) {
@@ -3068,10 +3281,17 @@ int sync_apply_unmailbox(struct dlist *k
 {
     const char *mboxname = kin->sval;
 
-    /* Delete with admin priveleges */
-    return mboxlist_deletemailbox(mboxname, sstate->userisadmin,
-                                  sstate->userid, sstate->authstate,
-                                  NULL, 0, sstate->local_only, 1);
+    struct mboxlock *namespacelock = mboxname_usernamespacelock(mboxname);
+
+    /* Delete with admin privileges */
+    int r = mboxlist_deletemailbox_full(mboxname, sstate->userisadmin,
+                                        sstate->userid, sstate->authstate,
+                                        NULL, 0, sstate->local_only, 1, 0,
+                                        /*silent*/1);
+
+    mboxname_release(&namespacelock);
+
+    return r;
 }
 
 int sync_apply_rename(struct dlist *kin, struct sync_state *sstate)
@@ -3080,6 +3300,8 @@ int sync_apply_rename(struct dlist *kin,
     const char *newmboxname;
     const char *partition;
     uint32_t uidvalidity = 0;
+    mbentry_t *mbentry = NULL;
+    int r;
 
     if (!dlist_getatom(kin, "OLDMBOXNAME", &oldmboxname))
         return IMAP_PROTOCOL_BAD_PARAMETERS;
@@ -3091,9 +3313,34 @@ int sync_apply_rename(struct dlist *kin,
     /* optional */
     dlist_getnum32(kin, "UIDVALIDITY", &uidvalidity);
 
-    return mboxlist_renamemailbox(oldmboxname, newmboxname, partition,
-                                  uidvalidity, 1, sstate->userid,
-                                  sstate->authstate, NULL, sstate->local_only, 1, 1);
+    struct mboxlock *oldlock = NULL;
+    struct mboxlock *newlock = NULL;
+
+    /* make sure we grab these locks in a stable order! */
+    if (strcmpsafe(oldmboxname, newmboxname) < 0) {
+        oldlock = mboxname_usernamespacelock(oldmboxname);
+        newlock = mboxname_usernamespacelock(newmboxname);
+    }
+    else {
+        // doesn't hurt to double lock, it's refcounted
+        newlock = mboxname_usernamespacelock(newmboxname);
+        oldlock = mboxname_usernamespacelock(oldmboxname);
+    }
+
+    r = mboxlist_lookup(oldmboxname, &mbentry, 0);
+
+    if (!r) r = mboxlist_renamemailbox(mbentry, newmboxname, partition,
+                                       uidvalidity, 1, sstate->userid,
+                                       sstate->authstate, NULL, sstate->local_only, 1, 1,
+                                       0/*keep_intermediaries*/,
+                                       0/*move_subscription*/,
+                                       1/*silent*/);
+
+    mboxlist_entry_free(&mbentry);
+    mboxname_release(&oldlock);
+    mboxname_release(&newlock);
+
+    return r;
 }
 
 int sync_apply_changesub(struct dlist *kin, struct sync_state *sstate)
@@ -3164,6 +3411,7 @@ done:
 
     mailbox_close(&mailbox);
 
+    buf_free(&value);
     freeentryatts(entryatts);
     free(name);
 
@@ -3334,6 +3582,8 @@ int sync_apply_unuser(struct dlist *kin,
         return 0;
     }
 
+    struct mboxlock *namespacelock = user_namespacelock(userid);
+
     /* Nuke subscriptions */
     /* ignore failures here - the subs file gets deleted soon anyway */
     strarray_t *list = mboxlist_sublist(userid);
@@ -3343,7 +3593,7 @@ int sync_apply_unuser(struct dlist *kin,
     }
 
     strarray_truncate(list, 0);
-    r = mboxlist_usermboxtree(userid, addmbox_cb, list, MBOXTREE_DELETED);
+    r = mboxlist_usermboxtree(userid, NULL, addmbox_cb, list, MBOXTREE_DELETED);
     if (r) goto done;
 
     /* delete in reverse so INBOX is last */
@@ -3351,13 +3601,14 @@ int sync_apply_unuser(struct dlist *kin,
         const char *name = strarray_nth(list, i-1);
         r = mboxlist_deletemailbox(name, sstate->userisadmin,
                                    sstate->userid, sstate->authstate,
-                                   NULL, 0, sstate->local_only, 1);
+                                   NULL, 0, sstate->local_only, 1, 0);
         if (r) goto done;
     }
 
     r = user_deletedata(userid, 1);
 
  done:
+    mboxname_release(&namespacelock);
     strarray_free(list);
 
     return r;
@@ -3465,7 +3716,7 @@ int sync_apply_expunge(struct dlist *kin
         struct index_record oldrecord;
         r = mailbox_find_index_record(mailbox, dlist_num(ui), &oldrecord);
         if (r) continue; /* skip */
-        oldrecord.system_flags |= FLAG_EXPUNGED;
+        oldrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
         oldrecord.silent = 1; /* so the next sync will succeed */
         r = mailbox_rewrite_index_record(mailbox, &oldrecord);
         if (r) goto done;
@@ -3491,7 +3742,7 @@ int sync_apply_message(struct dlist *kin
         const char *fname;
 
         /* XXX - complain more? */
-        if (!dlist_tofile(ki, &part, &guid, (ulong *) &size, &fname))
+        if (!dlist_tofile(ki, &part, &guid, (unsigned long *) &size, &fname))
             continue;
 
         part_list = sync_reserve_partlist(reserve_list, part);
@@ -3526,6 +3777,8 @@ int sync_restore_mailbox(struct dlist *k
     struct dlist *kr = NULL;
     struct dlist *ka = NULL;
     modseq_t xconvmodseq = 0;
+    modseq_t createdmodseq = 0;
+    modseq_t foldermodseq = 0;
 
     /* derived fields */
     uint32_t options = 0;
@@ -3584,6 +3837,8 @@ int sync_restore_mailbox(struct dlist *k
         dlist_getatom(kin, "UNIQUEID", &uniqueid);
         dlist_getnum64(kin, "HIGHESTMODSEQ", &highestmodseq);
         dlist_getnum32(kin, "UIDVALIDITY", &uidvalidity);
+        dlist_getnum64(kin, "CREATEDMODSEQ", &createdmodseq);
+        dlist_getnum64(kin, "FOLDERMODSEQ", &foldermodseq);
 
         /* if any of these three weren't set, disregard the others too */
         if (!uniqueid || !highestmodseq || !uidvalidity) {
@@ -3592,15 +3847,21 @@ int sync_restore_mailbox(struct dlist *k
             uidvalidity = 0;
         }
 
-        r = mboxlist_createsync(mboxname, mbtype, partition,
-                                sstate->userid, sstate->authstate,
-                                options, uidvalidity,
-                                highestmodseq, acl,
-                                uniqueid, sstate->local_only, &mailbox);
-        syslog(LOG_DEBUG, "%s: mboxlist_createsync %s: %s",
-            __func__, mboxname, error_message(r));
-
-        is_new_mailbox = 1;
+        struct mboxlock *namespacelock = mboxname_usernamespacelock(mboxname);
+        // try again under lock
+        r = mailbox_open_iwl(mboxname, &mailbox);
+        if (!r) r = sync_mailbox_version_check(&mailbox);
+        if (r == IMAP_MAILBOX_NONEXISTENT) { // did we win a race?
+            r = mboxlist_createsync(mboxname, mbtype, partition,
+                                    sstate->userid, sstate->authstate,
+                                    options, uidvalidity, createdmodseq,
+                                    highestmodseq, foldermodseq, acl,
+                                    uniqueid, sstate->local_only, 0, &mailbox);
+            syslog(LOG_DEBUG, "%s: mboxlist_createsync %s: %s",
+                __func__, mboxname, error_message(r));
+            is_new_mailbox = 1;
+        }
+        mboxname_release(&namespacelock);
     }
     if (r) {
         syslog(LOG_ERR, "Failed to open mailbox %s to restore: %s",
@@ -3638,9 +3899,9 @@ int sync_restore_mailbox(struct dlist *k
         struct sync_annot_list *restore_annots = NULL;
         struct sync_annot_list *mailbox_annots = NULL;
 
-        r = decode_annotations(ka, &restore_annots, NULL);
+        r = decode_annotations(ka, &restore_annots, mailbox, NULL);
 
-        if (!r) r = read_annotations(mailbox, NULL, &mailbox_annots);
+        if (!r) r = read_annotations(mailbox, NULL, &mailbox_annots, 0, 0);
 
         if (!r) r = apply_annotations(mailbox, NULL,
                                       mailbox_annots, restore_annots,
@@ -3727,12 +3988,18 @@ static const char *sync_response(int r)
     case IMAP_MAILBOX_LOCKED:
         resp = "NO IMAP_MAILBOX_LOCKED Mailbox locked";
         break;
+    case IMAP_MAILBOX_MOVED:
+        resp = "NO IMAP_MAILBOX_MOVED Mailbox exists with another name or uniqueid";
+        break;
     case IMAP_MAILBOX_NOTSUPPORTED:
         resp = "NO IMAP_MAILBOX_NOTSUPPORTED Operation is not supported on mailbox";
         break;
     case IMAP_SYNC_CHECKSUM:
         resp = "NO IMAP_SYNC_CHECKSUM Checksum Failure";
         break;
+    case IMAP_SYNC_CHANGED:
+        resp = "NO IMAP_SYNC_CHANGED Changed since last sync";
+        break;
     case IMAP_SYNC_BADSIEVE:
         resp = "NO IMAP_SYNC_BADSIEVE Sieve script compilation failure";
         break;
@@ -3833,11 +4100,7 @@ static int find_reserve_all(struct sync_
 
     /* Find messages we want to upload that are available on server */
     for (mbox = mboxname_list->head; mbox; mbox = mbox->next) {
-        /* XXX - now this kinda sucks - we use a write lock here
-         * purely for conversations modseq - but we never actually
-         * USE the value... the whole "add to master folders" actually
-         * looks a bit pointless... */
-        r = mailbox_open_iwl(mbox->name, &mailbox);
+        r = mailbox_open_irl(mbox->name, &mailbox);
         if (!r) r = sync_mailbox_version_check(&mailbox);
 
         /* Quietly skip over folders which have been deleted since we
@@ -3862,6 +4125,7 @@ static int find_reserve_all(struct sync_
                 goto bail;
             }
         }
+        modseq_t raclmodseq = mboxname_readraclmodseq(mbox->name);
 
         /* mailbox is open from here, no exiting without closing it! */
 
@@ -3892,7 +4156,7 @@ static int find_reserve_all(struct sync_
                              mailbox->i.recentuid, mailbox->i.recenttime,
                              mailbox->i.pop3_last_login,
                              mailbox->i.pop3_show_after, NULL, xconvmodseq,
-                             ispartial);
+                             raclmodseq, mailbox->foldermodseq, ispartial);
 
 
         part_list = sync_reserve_partlist(reserve_list, topart ? topart : mailbox->part);
@@ -4114,6 +4378,8 @@ int sync_response_parse(struct protstrea
             struct dlist *al = NULL;
             struct sync_annot_list *annots = NULL;
             modseq_t xconvmodseq = 0;
+            modseq_t raclmodseq = 0;
+            modseq_t foldermodseq = 0;
 
             if (!folder_list) goto parse_err;
             if (!dlist_getatom(kl, "UNIQUEID", &uniqueid)) goto parse_err;
@@ -4133,9 +4399,11 @@ int sync_response_parse(struct protstrea
             dlist_getnum32(kl, "SYNC_CRC", &synccrcs.basic);
             dlist_getnum32(kl, "SYNC_CRC_ANNOT", &synccrcs.annot);
             dlist_getnum64(kl, "XCONVMODSEQ", &xconvmodseq);
+            dlist_getnum64(kl, "RACLMODSEQ", &raclmodseq);
+            dlist_getnum64(kl, "FOLDERMODSEQ", &foldermodseq);
 
             if (dlist_getlist(kl, "ANNOTATIONS", &al))
-                decode_annotations(al, &annots, NULL);
+                decode_annotations(al, &annots, NULL, NULL);
 
 
             sync_folder_list_add(folder_list, uniqueid, mboxname,
@@ -4147,7 +4415,8 @@ int sync_response_parse(struct protstrea
                                  recentuid, recenttime,
                                  pop3_last_login,
                                  pop3_show_after, annots,
-                                 xconvmodseq, /*ispartial*/0);
+                                 xconvmodseq, raclmodseq,
+                                 foldermodseq, /*ispartial*/0);
         }
         else
             goto parse_err;
@@ -4163,25 +4432,6 @@ int sync_response_parse(struct protstrea
     return IMAP_PROTOCOL_BAD_PARAMETERS;
 }
 
-static int user_reset(const char *userid,
-                      struct backend *sync_be, unsigned flags)
-{
-    const char *cmd = "UNUSER";
-    struct dlist *kl;
-
-    if (flags & SYNC_FLAG_VERBOSE)
-        printf("%s %s\n", cmd, userid);
-
-    if (flags & SYNC_FLAG_LOGGING)
-        syslog(LOG_INFO, "%s %s", cmd, userid);
-
-    kl = dlist_setatom(NULL, cmd, userid);
-    sync_send_apply(kl, sync_be->out);
-    dlist_free(&kl);
-
-    return sync_parse_response(cmd, sync_be->in, NULL);
-}
-
 static int folder_rename(const char *oldname, const char *newname,
                          const char *partition, unsigned uidvalidity,
                          struct backend *sync_be, unsigned flags)
@@ -4454,6 +4704,7 @@ static int update_quota_work(struct quot
     kl = dlist_newkvlist(NULL, cmd);
     dlist_setatom(kl, "ROOT", client->root);
     sync_encode_quota_limits(kl, client->limits);
+    dlist_setnum64(kl, "MODSEQ", client->modseq);
     sync_send_apply(kl, sync_be->out);
     dlist_free(&kl);
 
@@ -4503,7 +4754,7 @@ static int copy_local(struct mailbox *ma
     if (r) return r;
 
     /* and expunge the old record */
-    oldrecord.system_flags |= FLAG_EXPUNGED;
+    oldrecord.internal_flags |= FLAG_INTERNAL_EXPUNGED;
     r = mailbox_rewrite_index_record(mailbox, &oldrecord);
 
     /* done - return */
@@ -4546,7 +4797,7 @@ static int fetch_file(struct mailbox *ma
         return r;
     }
 
-    if (!dlist_tofile(kin->head, NULL, &guid, (ulong *) &size, &fname)) {
+    if (!dlist_tofile(kin->head, NULL, &guid, (unsigned long *) &size, &fname)) {
         r = IMAP_MAILBOX_NONEXISTENT;
         syslog(LOG_ERR, "IOERROR: fetch_file failed tofile %s", error_message(r));
         goto done;
@@ -4612,7 +4863,7 @@ static int copyback_one_record(struct ma
     int r;
 
     /* don't want to copy back expunged records! */
-    if (rp->system_flags & FLAG_EXPUNGED)
+    if (rp->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return 0;
 
     /* if the UID is lower than master's last_uid,
@@ -4655,7 +4906,7 @@ static int renumber_one_record(const str
                                struct dlist *kaction)
 {
     /* don't want to renumber expunged records */
-    if (mp->system_flags & FLAG_EXPUNGED)
+    if (mp->internal_flags & FLAG_INTERNAL_EXPUNGED)
         return 0;
 
     if (kaction)
@@ -4686,7 +4937,7 @@ static const char *make_flags(struct mai
         snprintf(buf, 4096, "%s\\Draft", sep);
         sep = " ";
     }
-    if (record->system_flags & FLAG_EXPUNGED) {
+    if (record->internal_flags & FLAG_INTERNAL_EXPUNGED) {
         snprintf(buf, 4096, "%s\\Expunged", sep);
         sep = " ";
     }
@@ -4748,7 +4999,8 @@ static int compare_one_record(struct mai
      * moving the message up.  I guess we could force UNLINK immediately
      * too... hmm.  Not today. */
 
-    if ((mp->system_flags & FLAG_EXPUNGED) && (rp->system_flags & FLAG_EXPUNGED))
+    if ((mp->internal_flags & FLAG_INTERNAL_EXPUNGED) &&
+        (rp->internal_flags & FLAG_INTERNAL_EXPUNGED))
         return 0;
 
     /* first of all, check that GUID matches.  If not, we have had a split
@@ -4784,10 +5036,19 @@ static int compare_one_record(struct mai
         goto diff;
     if (mp->internaldate != rp->internaldate)
         goto diff;
-    if ((mp->system_flags & FLAGS_GLOBAL) != rp->system_flags)
+    if (mp->system_flags != rp->system_flags)
+        goto diff;
+    if ((mp->internal_flags & FLAG_INTERNAL_EXPUNGED) !=
+        (rp->internal_flags & FLAG_INTERNAL_EXPUNGED))
         goto diff;
     if (mp->cid != rp->cid)
         goto diff;
+    if (mp->basecid != rp->basecid)
+        goto diff;
+    if (mp->savedate != rp->savedate)
+        goto diff;
+    if (mp->createdmodseq != rp->createdmodseq)
+        goto diff;
     if (diff_annotations(mannots, rannots))
         goto diff;
     for (i = 0; i < MAX_USER_FLAGS/32; i++) {
@@ -4803,14 +5064,14 @@ static int compare_one_record(struct mai
      * so that regular replication will cause an update */
 
     /* interesting case - expunged locally */
-    if (mp->system_flags & FLAG_EXPUNGED) {
+    if (mp->internal_flags & FLAG_INTERNAL_EXPUNGED) {
         /* if expunged, fall through - the rewrite will lift
          * the modseq to force the change to stick */
     }
-    else if (rp->system_flags & FLAG_EXPUNGED) {
+    else if (rp->internal_flags & FLAG_INTERNAL_EXPUNGED) {
         /* mark expunged - rewrite will cause both sides to agree
          * again */
-        mp->system_flags |= FLAG_EXPUNGED;
+        mp->internal_flags |= FLAG_INTERNAL_EXPUNGED;
     }
 
     /* otherwise, is the replica "newer"?  Better grab those flags */
@@ -4819,8 +5080,10 @@ static int compare_one_record(struct mai
             rp->last_updated >= mp->last_updated) {
             log_mismatch("more recent on replica", mailbox, mp, rp);
             /* then copy all the flag data over from the replica */
-            mp->system_flags = (rp->system_flags & FLAGS_GLOBAL) |
-                               (mp->system_flags & FLAGS_LOCAL);
+            mp->system_flags = rp->system_flags;
+            mp->internal_flags &= ~FLAG_INTERNAL_EXPUNGED;
+            mp->internal_flags |= rp->internal_flags & FLAG_INTERNAL_EXPUNGED;
+
             mp->cid = rp->cid;
             for (i = 0; i < MAX_USER_FLAGS/32; i++)
                 mp->user_flags[i] = rp->user_flags[i];
@@ -4864,13 +5127,14 @@ static int mailbox_update_loop(struct ma
 
         /* most common case - both a master AND a replica record exist */
         if (ki && mrecord) {
-            r = read_annotations(mailbox, mrecord, &mannots);
+            r = read_annotations(mailbox, mrecord, &mannots, 0, 0);
             if (r) goto out;
             r = parse_upload(ki, mailbox, &rrecord, &rannots);
             if (r) goto out;
 
             /* same UID - compare the records */
             if (rrecord.uid == mrecord->uid) {
+                mailbox_read_basecid(mailbox, mrecord);
                 r = compare_one_record(mailbox,
                                        (struct index_record *)mrecord, &rrecord,
                                        mannots, rannots,
@@ -4884,8 +5148,8 @@ static int mailbox_update_loop(struct ma
             }
             else if (rrecord.uid > mrecord->uid) {
                 /* record only exists on the master */
-                if (!(mrecord->system_flags & FLAG_EXPUNGED)) {
-                    syslog(LOG_ERR, "SYNCERROR: only exists on master %s %u (%s)",
+                if (!(mrecord->internal_flags & FLAG_INTERNAL_EXPUNGED)) {
+                    syslog(LOG_ERR, "SYNCNOTICE: only exists on master %s %u (%s)",
                            mailbox->name, mrecord->uid,
                            message_guid_encode(&mrecord->guid));
                     r = renumber_one_record(mrecord, kaction);
@@ -4897,9 +5161,9 @@ static int mailbox_update_loop(struct ma
             }
             else {
                 /* record only exists on the replica */
-                if (!(rrecord.system_flags & FLAG_EXPUNGED)) {
+                if (!(rrecord.internal_flags & FLAG_INTERNAL_EXPUNGED)) {
                     if (kaction)
-                        syslog(LOG_ERR, "SYNCERROR: only exists on replica %s %u (%s)",
+                        syslog(LOG_ERR, "SYNCNOTICE: only exists on replica %s %u (%s)",
                                mailbox->name, rrecord.uid,
                                message_guid_encode(&rrecord.guid));
                     r = copyback_one_record(mailbox, &rrecord, rannots, kaction, part_list, sync_be);
@@ -4972,6 +5236,7 @@ static int mailbox_full_update(struct sy
     struct dlist *kaction = NULL;
     struct dlist *kexpunge = NULL;
     modseq_t highestmodseq;
+    modseq_t foldermodseq = 0;
     uint32_t uidvalidity;
     uint32_t last_uid;
     struct sync_annot_list *mannots = NULL;
@@ -5031,6 +5296,7 @@ static int mailbox_full_update(struct sy
 
     /* optional */
     dlist_getnum64(kl, "XCONVMODSEQ", &xconvmodseq);
+    dlist_getnum64(kl, "FOLDERMODSEQ", &foldermodseq);
 
     /* we'll be updating it! */
     if (local->mailbox) {
@@ -5089,6 +5355,13 @@ static int mailbox_full_update(struct sy
         if (r) goto done;
     }
 
+    if (foldermodseq) {
+        // by writing the same ACL with the updated foldermodseq, this will bounce it
+        // if needed
+        r = mboxlist_sync_setacls(mailbox->name, mailbox->acl, foldermodseq);
+        if (r) goto done;
+    }
+
     kaction = dlist_newlist(NULL, "ACTION");
     r = mailbox_update_loop(mailbox, kr->head, last_uid,
                             highestmodseq, kaction, part_list, sync_be);
@@ -5104,8 +5377,8 @@ static int mailbox_full_update(struct sy
     /* ugly variable reuse */
     dlist_getlist(kl, "ANNOTATIONS", &ka);
 
-    if (ka) decode_annotations(ka, &rannots, NULL);
-    r = read_annotations(mailbox, NULL, &mannots);
+    if (ka) decode_annotations(ka, &rannots, mailbox, NULL);
+    r = read_annotations(mailbox, NULL, &mannots, 0, 0);
     if (r) goto cleanup;
     r = apply_annotations(mailbox, NULL, mannots, rannots,
                           !remote_modseq_was_higher);
@@ -5183,8 +5456,15 @@ static int is_unchanged(struct mailbox *
     if (remote->pop3_last_login != mailbox->i.pop3_last_login) return 0;
     if (remote->pop3_show_after != mailbox->i.pop3_show_after) return 0;
     if (remote->options != options) return 0;
+    if (remote->foldermodseq && remote->foldermodseq != mailbox->foldermodseq) return 0;
     if (strcmp(remote->acl, mailbox->acl)) return 0;
 
+    if (config_getswitch(IMAPOPT_REVERSEACLS)) {
+        modseq_t raclmodseq = mboxname_readraclmodseq(mailbox->name);
+        // don't bail if either are zero, that could be version skew
+        if (raclmodseq && remote->raclmodseq && remote->raclmodseq != raclmodseq) return 0;
+    }
+
     if (mailbox_has_conversations(mailbox)) {
         int r = mailbox_get_xconvmodseq(mailbox, &xconvmodseq);
         if (r) return 0;
@@ -5195,7 +5475,7 @@ static int is_unchanged(struct mailbox *
     /* compare annotations */
     {
         struct sync_annot_list *mannots = NULL;
-        int r = read_annotations(mailbox, NULL, &mannots);
+        int r = read_annotations(mailbox, NULL, &mannots, 0, 0);
         if (r) return 0;
 
         if (diff_annotations(mannots, remote->annots)) {
@@ -5206,8 +5486,8 @@ static int is_unchanged(struct mailbox *
     }
 
     /* if we got here then we should force check the CRCs */
-    if (!crceq(remote->synccrcs, mailbox_synccrcs(mailbox, /*force*/0)))
-        if (!crceq(remote->synccrcs, mailbox_synccrcs(mailbox, /*force*/1)))
+    if (!mailbox_crceq(remote->synccrcs, mailbox_synccrcs(mailbox, /*force*/0)))
+        if (!mailbox_crceq(remote->synccrcs, mailbox_synccrcs(mailbox, /*force*/1)))
             return 0;
 
     /* otherwise it's unchanged! */
@@ -5217,6 +5497,7 @@ static int is_unchanged(struct mailbox *
 /* XXX kind of nasty having this here, but i think it probably
  * shouldn't be in .h with the rest of them */
 #define SYNC_FLAG_ISREPEAT      (1<<15)
+#define SYNC_FLAG_FULLANNOTS    (1<<16)
 
 static int update_mailbox_once(struct sync_folder *local,
                                struct sync_folder *remote,
@@ -5275,12 +5556,16 @@ static int update_mailbox_once(struct sy
             r = IMAP_AGAIN;
             goto done;
         }
-        /* need a full sync to fix uidvalidity issues so we get a
-         * writelocked mailbox */
-        if (mailbox->i.uidvalidity < remote->uidvalidity) {
-            r = IMAP_AGAIN;
-            goto done;
-        }
+    }
+
+    /* if local UIDVALIDITY is lower, copy from remote, otherwise
+     * remote will copy ours when we sync */
+    if (remote && mailbox->i.uidvalidity < remote->uidvalidity) {
+        syslog(LOG_NOTICE, "SYNCNOTICE: uidvalidity higher on replica %s"
+               ", updating %u => %u",
+               mailbox->name, mailbox->i.uidvalidity, remote->uidvalidity);
+        mailbox_index_dirty(mailbox);
+        mailbox->i.uidvalidity = mboxname_setuidvalidity(mailbox->name, remote->uidvalidity);
     }
 
     /* make sure CRC is updated if we're retrying */
@@ -5289,13 +5574,25 @@ static int update_mailbox_once(struct sy
         if (r) goto done;
     }
 
+    /* bump the raclmodseq if it's higher on the replica */
+    if (remote && remote->raclmodseq) {
+        mboxname_setraclmodseq(mailbox->name, remote->raclmodseq);
+    }
+
+    /* bump the foldermodseq if it's higher on the replica */
+    if (remote && remote->foldermodseq > mailbox->foldermodseq) {
+        mboxlist_sync_setacls(mailbox->name, mailbox->acl, remote->foldermodseq);
+        mailbox->foldermodseq = remote->foldermodseq;
+    }
+
     /* nothing changed - nothing to send */
     if (is_unchanged(mailbox, remote))
         goto done;
 
     if (!topart) topart = mailbox->part;
     part_list = sync_reserve_partlist(reserve_list, topart);
-    r = sync_prepare_dlists(mailbox, local, remote, topart, part_list, kl, kupload, 1);
+    r = sync_prepare_dlists(mailbox, local, remote, topart, part_list, kl,
+                            kupload, 1, /*XXX flags & SYNC_FLAG_FULLANNOTS*/1, !(flags & SYNC_FLAG_ISREPEAT));
     if (r) goto done;
 
     /* keep the mailbox locked for shorter time! Unlock the index now
@@ -5343,11 +5640,17 @@ int sync_update_mailbox(struct sync_fold
     int r = update_mailbox_once(local, remote, topart,
                                 reserve_list, sync_be, flags);
 
+    flags |= SYNC_FLAG_ISREPEAT;
+
+    if (r == IMAP_SYNC_CHECKSUM) {
+        syslog(LOG_NOTICE, "SYNC_NOTICE: CRC failure on sync %s, recalculating counts and trying again", local->name);
+        r = update_mailbox_once(local, remote, topart,
+                                reserve_list, sync_be, flags);
+    }
+
     /* never retry - other end should always sync cleanly */
     if (flags & SYNC_FLAG_NO_COPYBACK) return r;
 
-    flags |= SYNC_FLAG_ISREPEAT;
-
     if (r == IMAP_AGAIN) {
         local->ispartial = 0; /* don't batch the re-update, means sync to 2.4 will still work after fullsync */
         r = mailbox_full_update(local, reserve_list, sync_be, flags);
@@ -5359,7 +5662,8 @@ int sync_update_mailbox(struct sync_fold
                local->name);
         r = mailbox_full_update(local, reserve_list, sync_be, flags);
         if (!r) r = update_mailbox_once(local, remote, topart,
-                                        reserve_list, sync_be, flags);
+                                        reserve_list, sync_be,
+                                        flags|SYNC_FLAG_FULLANNOTS);
     }
 
     return r;
@@ -5433,11 +5737,13 @@ int sync_do_quota(const char *root, stru
 static int do_annotation_cb(const char *mailbox __attribute__((unused)),
                             uint32_t uid __attribute__((unused)),
                             const char *entry, const char *userid,
-                            const struct buf *value, void *rock)
+                            const struct buf *value,
+                            const struct annotate_metadata *mdata,
+                            void *rock)
 {
     struct sync_annot_list *l = (struct sync_annot_list *) rock;
 
-    sync_annot_list_add(l, entry, userid, value);
+    sync_annot_list_add(l, entry, userid, value, mdata->modseq);
 
     return 0;
 }
@@ -5447,20 +5753,24 @@ static int parse_annotation(struct dlist
 {
     struct dlist *kl;
     const char *entry;
-    const char *userid;
+    const char *userid = "";
     const char *valmap = NULL;
     size_t vallen = 0;
     struct buf value = BUF_INITIALIZER;
+    modseq_t modseq = 0;
 
     for (kl = kin->head; kl; kl = kl->next) {
         if (!dlist_getatom(kl, "ENTRY", &entry))
             return IMAP_PROTOCOL_BAD_PARAMETERS;
-        if (!dlist_getatom(kl, "USERID", &userid))
-            return IMAP_PROTOCOL_BAD_PARAMETERS;
         if (!dlist_getmap(kl, "VALUE", &valmap, &vallen))
             return IMAP_PROTOCOL_BAD_PARAMETERS;
+
+        dlist_getatom(kl, "USERID", &userid); /* optional */
+        dlist_getnum64(kl, "MODSEQ", &modseq); /* optional */
+
         buf_init_ro(&value, valmap, vallen);
-        sync_annot_list_add(replica_annot, entry, userid, &value);
+        sync_annot_list_add(replica_annot, entry, userid, &value, modseq);
+        buf_free(&value);
     }
 
     return 0;
@@ -5500,7 +5810,8 @@ int sync_do_annotation(char *mboxname, s
     r = do_getannotation(mboxname, replica_annot, sync_be);
     if (r) goto bail;
 
-    r = annotatemore_findall(mboxname, 0, "*", &do_annotation_cb, master_annot);
+    r = annotatemore_findall(mboxname, 0, "*", /*modseq*/0, &do_annotation_cb,
+                             master_annot, /*flags*/0);
     if (r) {
         syslog(LOG_ERR, "IOERROR: fetching annotations for %s", mboxname);
         r = IMAP_IOERROR;
@@ -5558,13 +5869,47 @@ static int do_folders(struct sync_name_l
                       const char **channelp,
                       unsigned flags)
 {
-    int r;
+    int r = 0;
     struct sync_folder_list *master_folders;
     struct sync_rename_list *rename_folders;
     struct sync_reserve_list *reserve_list;
     struct sync_folder *mfolder, *rfolder;
     const char *part;
     uint32_t batchsize = 0;
+    struct sync_name *mbox;
+
+    /* Look for intermediate mailboxes */
+    for (mbox = mboxname_list->head; !r && mbox; mbox = mbox->next) {
+        mbentry_t *mbentry = NULL;
+
+        if (mboxlist_lookup_allow_all(mbox->name, &mbentry, NULL))
+            continue;
+
+        if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+            struct dlist *kl = dlist_newkvlist(NULL, "MAILBOX");
+
+            dlist_setatom(kl, "UNIQUEID", mbentry->uniqueid);
+            dlist_setatom(kl, "MBOXNAME", mbentry->name);
+            dlist_setatom(kl, "MBOXTYPE",
+                          mboxlist_mbtype_to_string(mbentry->mbtype));
+            dlist_setnum64(kl, "HIGHESTMODSEQ", mbentry->foldermodseq);
+            dlist_setnum64(kl, "CREATEDMODSEQ", mbentry->createdmodseq);
+            dlist_setnum64(kl, "FOLDERMODSEQ", mbentry->foldermodseq);
+
+            sync_send_apply(kl, sync_be->out);
+            r = sync_parse_response("MAILBOX", sync_be->in, NULL);
+
+            dlist_free(&kl);
+        }
+
+        mboxlist_entry_free(&mbentry);
+
+        if (r) {
+            syslog(LOG_ERR, "apply intermediates: failed: %s", error_message(r));
+            goto bail;
+        }
+    }
+
 
     if (channelp) {
         batchsize = config_getint(IMAPOPT_SYNC_BATCHSIZE);
@@ -5598,6 +5943,9 @@ static int do_folders(struct sync_name_l
         }
     }
 
+    /* XXX - sync_log_channel_user on any issue here rather than trying to solve,
+     * and remove all entries related to that user from both lists */
+
     /* Delete folders on server which no longer exist on client */
     if (flags & SYNC_FLAG_DELETE_REMOTE) {
         for (rfolder = replica_folders->head; rfolder; rfolder = rfolder->next) {
@@ -5743,6 +6091,11 @@ static int do_mailbox_info(const mbentry
 
     /* XXX - check for deleted? */
 
+    if (mbentry->mbtype & MBTYPE_INTERMEDIATE) {
+        sync_name_list_add(info->mboxlist, mbentry->name);
+        return 0;
+    }
+
     r = mailbox_open_irl(mbentry->name, &mailbox);
     if (!r) r = sync_mailbox_version_check(&mailbox);
     /* doesn't exist?  Probably not finished creating or removing yet */
@@ -5811,7 +6164,7 @@ static int do_user_main(const char *user
     info.mboxlist = sync_name_list_create();
     info.quotalist = sync_name_list_create();
 
-    r = mboxlist_usermboxtree(user, do_mailbox_info, &info, MBOXTREE_DELETED);
+    r = mboxlist_usermboxtree(user, NULL, do_mailbox_info, &info, MBOXTREE_DELETED);
 
     /* we know all the folders present on the master, so it's safe to delete
      * anything not mentioned here on the replica - at least until we get
@@ -5839,7 +6192,7 @@ int sync_do_user_sub(const char *userid,
     int r = 0;
     int i;
 
-    /* Includes subsiduary nodes automatically */
+    /* Includes subsidiary nodes automatically */
     strarray_t *msubs = mboxlist_sublist(userid);
     if (!msubs) {
         syslog(LOG_ERR, "IOERROR: fetching subscriptions for %s", userid);
@@ -6026,14 +6379,19 @@ int sync_do_user(const char *userid, con
     if (r == IMAP_MAILBOX_NONEXISTENT) r = 0;
     if (r) goto done;
 
+    /* check that the inbox exists locally to be allowed to sync this user at all */
     char *inbox = mboxname_user_mbox(userid, NULL);
     r = mailbox_open_irl(inbox, &mailbox);
     if (!r) r = sync_mailbox_version_check(&mailbox);
     free(inbox);
     if (r == IMAP_MAILBOX_NONEXISTENT) {
-        /* user has been removed, RESET server */
-        syslog(LOG_ERR, "Inbox missing on master for %s", userid);
-        r = user_reset(userid, sync_be, flags);
+        if (flags & SYNC_FLAG_VERBOSE)
+            printf("Does not exist locally %s\n", userid);
+        if (flags & SYNC_FLAG_LOGGING)
+            syslog(LOG_INFO, "Does not exist locally %s", userid);
+
+        // just skip this user.  XXX - tombstone for user -> sync_reset?
+        r = 0;
         goto done;
     }
     if (r) goto done;
@@ -6183,6 +6541,8 @@ EXPORTED const char *sync_get(struct dli
         r = sync_get_fullmailbox(kin, state);
     else if (!strcmp(kin->name, "MAILBOXES"))
         r = sync_get_mailboxes(kin, state);
+    else if (!strcmp(kin->name, "UNIQUEIDS"))
+        r = sync_get_uniqueids(kin, state);
     else if (!strcmp(kin->name, "META"))
         r = sync_get_meta(kin, state);
     else if (!strcmp(kin->name, "QUOTA"))
diff -pruN 3.0.13-5/imap/sync_support.h 3.2.0-3/imap/sync_support.h
--- 3.0.13-5/imap/sync_support.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/sync_support.h	2020-05-04 03:28:02.000000000 +0000
@@ -59,26 +59,10 @@ extern struct protocol_t csync_protocol;
 #define SYNC_MESSAGE_LIST_HASH_SIZE      (65536)
 #define SYNC_MESSAGE_LIST_MAX_OPEN_FILES (64)
 
-void sync_printdate(struct protstream *out, time_t time);
-time_t sync_parsedate(const char *s);
-int sync_getflags(struct dlist *kl,
-                  struct mailbox *mailbox,
-                  struct index_record *record);
-
-void sync_print_flags(struct dlist *kl,
-                      struct mailbox *mailbox,
-                      const struct index_record *record);
-
 const char *sync_get_config(const char *channel, const char *val);
-int sync_get_intconfig(const char *channel, const char *val);
+int sync_get_durationconfig(const char *channel, const char *val, int defunit);
 int sync_get_switchconfig(const char *channel, const char *val);
 
-char *sync_encode_options(int options);
-int sync_parse_options(const char *source);
-
-char *sync_encode_type(int type);
-int sync_parse_type(const char *source);
-
 /* ====================================================================== */
 
 int sync_parse_response(const char *name, struct protstream *in,
@@ -162,6 +146,8 @@ struct sync_folder {
     time_t pop3_show_after;
     struct sync_annot_list *annots;
     modseq_t xconvmodseq;
+    modseq_t raclmodseq;
+    modseq_t foldermodseq;
     int ispartial;
     struct quota quota;
     int   mark;
@@ -190,6 +176,8 @@ struct sync_folder *sync_folder_list_add
                                          time_t pop3_show_after,
                                          struct sync_annot_list *annot,
                                          modseq_t xconvmodseq,
+                                         modseq_t raclmodseq,
+                                         modseq_t foldermodseq,
                                          int ispartial);
 
 struct sync_folder *sync_folder_lookup(struct sync_folder_list *l,
@@ -364,6 +352,7 @@ struct sync_annot {
     char *userid;
     struct buf value;
     int mark;
+    modseq_t modseq;
 };
 
 struct sync_annot_list {
@@ -376,7 +365,8 @@ struct sync_annot_list *sync_annot_list_
 
 void sync_annot_list_add(struct sync_annot_list *l,
                          const char *entry, const char *userid,
-                         const struct buf *value);
+                         const struct buf *value,
+                         modseq_t modseq);
 
 void sync_annot_list_free(struct sync_annot_list **lp);
 
@@ -428,20 +418,9 @@ int sync_append_copyfile(struct mailbox
 
 int read_annotations(const struct mailbox *,
                      const struct index_record *,
-                     struct sync_annot_list **);
-void encode_annotations(struct dlist *parent,
-                        const struct index_record *record,
-                        const struct sync_annot_list *);
-int decode_annotations(/*const*/struct dlist *,
-                       struct sync_annot_list **,
-                       struct index_record *);
-int apply_annotations(struct mailbox *mailbox,
-                      const struct index_record *record,
-                      const struct sync_annot_list *local_annots,
-                      const struct sync_annot_list *remote_annots,
-                      int local_wins);
-int diff_annotations(const struct sync_annot_list *local_annots,
-                     const struct sync_annot_list *remote_annots);
+                     struct sync_annot_list **,
+                     modseq_t since_modseq,
+                     int flags);
 
 /* ====================================================================== */
 
diff -pruN 3.0.13-5/imap/telemetry.c 3.2.0-3/imap/telemetry.c
--- 3.0.13-5/imap/telemetry.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/telemetry.c	2020-04-24 02:03:00.000000000 +0000
@@ -99,8 +99,8 @@ EXPORTED int telemetry_log(const char *u
         if (r < 0)
             syslog(LOG_ERR, "IOERROR: unable to write to telemetry log %s: %m", buf);
 
-        prot_setlog(pin, fd);
-        prot_setlog(pout, fd);
+        if (pin) prot_setlog(pin, fd);
+        if (pout) prot_setlog(pout, fd);
     }
 
     return fd;
diff -pruN 3.0.13-5/imap/tls.c 3.2.0-3/imap/tls.c
--- 3.0.13-5/imap/tls.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/tls.c	2020-04-24 02:03:00.000000000 +0000
@@ -86,7 +86,7 @@
 *
 * xxx we need to offer a callback to do peer issuer certification.
 *     data that should be available for inspection:
-*       If the peer offered a certifcate _and_ the certificate could be
+*       If the peer offered a certificate _and_ the certificate could be
 *       verified successfully, part of the certificate data are available as:
 *       tls_peer_subject X509v3-oneline with the DN of the peer
 *       pfixlts_peer_CN extracted CommonName of the peer
@@ -270,12 +270,14 @@ static DH *get_dh1024(void)
     return NULL;
 }
 
-static DH *load_dh_param(const char *keyfile, const char *certfile)
+static DH *load_dh_param(const char *dhfile, const char *keyfile, const char *certfile)
 {
     DH *ret=NULL;
     BIO *bio = NULL;
 
-    if (keyfile) bio = BIO_new_file(keyfile, "r");
+    if (dhfile) bio = BIO_new_file(dhfile, "r");
+
+    if ((bio == NULL) && keyfile) bio = BIO_new_file(keyfile, "r");
 
     if ((bio == NULL) && certfile) bio = BIO_new_file(certfile,"r");
 
@@ -336,6 +338,8 @@ static int verify_callback(int ok, X509_
     case X509_V_ERR_ERROR_IN_CERT_NOT_AFTER_FIELD:
         syslog(LOG_NOTICE, "cert has expired");
         break;
+    case X509_V_ERR_CERT_REVOKED:
+        syslog(LOG_NOTICE, "cert has been revoked");
     }
 
     return (ok);
@@ -449,36 +453,89 @@ static int tls_dump(const char *s, int l
 static int set_cert_stuff(SSL_CTX * ctx,
                           const char *cert_file, const char *key_file)
 {
+    int err;
     if (cert_file != NULL) {
+        char *cf1 = xstrdup(cert_file), *kf1 = xstrdupnull(key_file);
+        char *cf2 = strchr(cf1, ','), *kf2 = NULL;
         /* SSL_CTX_use_certificate_chain_file() requires an empty error stack.
          * To make sure there is no error from previous op, we clear it here...
          */
         ERR_clear_error();
-        if (SSL_CTX_use_certificate_chain_file(ctx, cert_file) <= 0) {
-            syslog(LOG_ERR, "unable to get certificate from '%s'", cert_file);
-            return (0);
+        if (cf2) {
+            /* two comma-separated files provided in cert_file */
+            *cf2++ = '\0';
+            if (key_file && (kf2 = strchr(kf1, ',')))
+                /* two comma-separated files provided in key_file */
+                *kf2++ = '\0';
+        }
+        if (SSL_CTX_use_certificate_chain_file(ctx, cf1) <= 0) {
+            err = ERR_get_error();
+            syslog(LOG_ERR, "unable to get certificate from '%s': %s", cf1, ERR_reason_error_string(err));
+            free(cf1);
+            free(kf1);
+            return 0;
         }
         if (key_file == NULL)
-            key_file = cert_file;
-        if (SSL_CTX_use_PrivateKey_file(ctx, key_file,
+            kf1 = cf1;
+        if (SSL_CTX_use_PrivateKey_file(ctx, kf1,
                                         SSL_FILETYPE_PEM) <= 0) {
-            syslog(LOG_ERR, "unable to get private key from '%s'", key_file);
-            return (0);
+            err = ERR_get_error();
+            syslog(LOG_ERR, "unable to get private key from '%s': %s", kf1, ERR_reason_error_string(err));
+            if (kf1 != cf1) free(kf1);
+            free(cf1);
+            return 0;
         }
         /* Now we know that a key and cert have been set against
          * the SSL context */
         if (!SSL_CTX_check_private_key(ctx)) {
+            err = ERR_get_error();
             syslog(
                     LOG_ERR,
-                    "Private key '%s' does not match public key '%s'",
-                    cert_file,
-                    key_file
-                );
-
-            return (0);
+                    "Private key '%s' does not match public key '%s': %s",
+                    kf1, cf1, ERR_reason_error_string(err));
+            if (kf1 != cf1) free(kf1);
+            free(cf1);
+            return 0;
         }
+
+        if (cf2) {
+            /* Load second certificate */
+            if (SSL_CTX_use_certificate_chain_file(ctx, cf2) <= 0) {
+                err = ERR_get_error();
+                syslog(LOG_ERR, "unable to get certificate from '%s': %s", cf2, ERR_reason_error_string(err));
+                if (kf1 != cf1) free(kf1);
+                free(cf1);
+                return 0;
+            }
+            if (kf2 == NULL)
+                kf2 = cf2;
+            if (SSL_CTX_use_PrivateKey_file(ctx, kf2,
+                                            SSL_FILETYPE_PEM) <= 0) {
+                err = ERR_get_error();
+                syslog(LOG_ERR, "unable to get private key from '%s': %s", kf2, ERR_reason_error_string(err));
+                if (kf1 != cf1) free(kf1);
+                free(cf1);
+                return 0;
+            }
+            /* Now we know that a key and cert have been set against
+             * the SSL context */
+            if (!SSL_CTX_check_private_key(ctx)) {
+                err = ERR_get_error();
+                syslog(
+                        LOG_ERR,
+                        "Private key '%s' does not match public key '%s': %s",
+                        kf2, cf2, ERR_reason_error_string(err));
+                if (kf1 != cf1) free(kf1);
+                free(cf1);
+                return 0;
+            }
+
+       if (kf1 != cf1) free(kf1);
+       free(cf1);
+       }
     }
-    return (1);
+
+    return 1;
 }
 
 /*
@@ -693,7 +750,9 @@ EXPORTED int     tls_init_serverengine(c
     const char   *client_ca_file;
     const char   *server_ca_file;
     const char   *server_cert_file;
+    const char   *server_dhparam_file;
     const char   *server_key_file;
+    const char   *crl_file_path;
     enum enum_value tls_client_certs;
     int server_cipher_order;
     int timeout;
@@ -835,6 +894,7 @@ EXPORTED int     tls_init_serverengine(c
 
     server_ca_file = config_getstring(IMAPOPT_TLS_SERVER_CA_FILE);
     server_cert_file = config_getstring(IMAPOPT_TLS_SERVER_CERT);
+    server_dhparam_file = config_getstring(IMAPOPT_TLS_SERVER_DHPARAM);
     server_key_file = config_getstring(IMAPOPT_TLS_SERVER_KEY);
 
     if (config_debug) {
@@ -902,7 +962,7 @@ EXPORTED int     tls_init_serverengine(c
 
 #if (OPENSSL_VERSION_NUMBER >= 0x0090800fL)
     /* Load DH params for DHE-* key exchanges */
-    dh_params = load_dh_param(server_key_file, server_cert_file);
+    dh_params = load_dh_param(server_dhparam_file, server_key_file, server_cert_file);
     SSL_CTX_set_tmp_dh(s_ctx, dh_params);
 #endif
 
@@ -952,6 +1012,29 @@ EXPORTED int     tls_init_serverengine(c
         }
     }
 
+    /* Set CRL */
+    crl_file_path = config_getstring(IMAPOPT_TLS_CRL_FILE);
+    if (crl_file_path != NULL) {
+        X509_STORE *store = SSL_CTX_get_cert_store(s_ctx);
+        X509_CRL *crl;
+        BIO *crl_file = BIO_new_file(crl_file_path, "r");
+
+        if (crl_file) {
+            while ((crl = PEM_read_bio_X509_CRL(crl_file, NULL, NULL, NULL))) {
+                X509_STORE_add_crl(store, crl);
+                X509_CRL_free(crl);
+            }
+
+            X509_STORE_set_flags(store,
+                                 X509_V_FLAG_CRL_CHECK |
+                                 X509_V_FLAG_CRL_CHECK_ALL);
+        } else {
+            syslog(LOG_ERR, "Can't load CRL file %s.", crl_file_path);
+        }
+
+        BIO_free(crl_file);
+    } /* crl_file_path */
+
     SSL_CTX_set_verify(s_ctx, verify_flags, verify_callback);
 
 #if (OPENSSL_VERSION_NUMBER >= 0x0090806fL)
@@ -964,10 +1047,10 @@ EXPORTED int     tls_init_serverengine(c
                                    SSL_SESS_CACHE_NO_AUTO_CLEAR |
                                    SSL_SESS_CACHE_NO_INTERNAL_LOOKUP);
 
-    /* Get the session timeout from the config file (in minutes) */
-    timeout = config_getint(IMAPOPT_TLS_SESSION_TIMEOUT);
+    /* Get the session timeout from the config file */
+    timeout = config_getduration(IMAPOPT_TLS_SESSION_TIMEOUT, 'm');
     if (timeout < 0) timeout = 0;
-    if (timeout > 1440) timeout = 1440; /* 24 hours max */
+    if (timeout > 24 * 60 * 60) timeout = 24 * 60 * 60; /* 24 hours max */
 
     /* A timeout of zero disables session caching */
     if (timeout) {
@@ -978,8 +1061,8 @@ EXPORTED int     tls_init_serverengine(c
         /* Set the context for session reuse -- use the service ident */
         SSL_CTX_set_session_id_context(s_ctx, (void*) ident, strlen(ident));
 
-        /* Set the timeout for the internal/external cache (in seconds) */
-        SSL_CTX_set_timeout(s_ctx, timeout*60);
+        /* Set the timeout for the internal/external cache */
+        SSL_CTX_set_timeout(s_ctx, timeout);
 
         /* Set the callback functions for the external session cache */
         SSL_CTX_sess_set_new_cb(s_ctx, new_session_cb);
@@ -997,7 +1080,7 @@ EXPORTED int     tls_init_serverengine(c
         r = cyrusdb_open(DB, fname, CYRUSDB_CREATE, &sessdb);
         if (r != 0) {
             syslog(LOG_ERR, "DBERROR: opening %s: %s",
-                   fname, cyrusdb_strerror(ret));
+                   fname, cyrusdb_strerror(r));
         }
         else
             sess_dbopen = 1;
@@ -1049,7 +1132,7 @@ static long bio_dump_cb(BIO * bio, int c
   * on success.
   */
 EXPORTED int tls_start_servertls(int readfd, int writefd, int timeout,
-                        int *layerbits, char **authid, SSL **ret)
+                                 struct saslprops_t *saslprops, SSL **ret)
 {
     int     sts;
     unsigned int n;
@@ -1070,7 +1153,7 @@ EXPORTED int tls_start_servertls(int rea
     if (var_imapd_tls_loglevel >= 1)
         syslog(LOG_DEBUG, "setting up TLS connection");
 
-    if (authid) *authid = NULL;
+    saslprops_reset(saslprops);
 
     tls_conn = (SSL *) SSL_new(s_ctx);
     if (tls_conn == NULL) {
@@ -1220,9 +1303,9 @@ EXPORTED int tls_start_servertls(int rea
 
         /* xxx verify that we like the peer_issuer/issuer_CN */
 
-        if (authid != NULL) {
+        if (peer_CN[0]) {
             /* save the peer id for our caller */
-            *authid = peer_CN[0] ? xstrdup(peer_CN) : NULL;
+            buf_setcstr(&saslprops->authid, peer_CN);
         }
         X509_free(peer);
     }
@@ -1231,9 +1314,23 @@ EXPORTED int tls_start_servertls(int rea
     tls_cipher_name = SSL_CIPHER_get_name(cipher);
     tls_cipher_usebits = SSL_CIPHER_get_bits(cipher, &tls_cipher_algbits);
 
-    if (layerbits != NULL) {
-        *layerbits = tls_cipher_usebits;
+    saslprops->ssf = (sasl_ssf_t) tls_cipher_usebits;
+
+#if (OPENSSL_VERSION_NUMBER >= 0x0090800fL)
+    if (SSL_session_reused(tls_conn)) {
+        saslprops->cbinding.len = SSL_get_finished(tls_conn,
+                                                   saslprops->tls_finished,
+                                                   MAX_FINISHED_LEN);
     }
+    else {
+        saslprops->cbinding.len = SSL_get_peer_finished(tls_conn,
+                                                        saslprops->tls_finished,
+                                                        MAX_FINISHED_LEN);
+    }
+
+    saslprops->cbinding.name = "tls-unique";
+    saslprops->cbinding.data = saslprops->tls_finished;
+#endif /* (OPENSSL_VERSION_NUMBER >= 0x0090800fL) */
 
 #if OPENSSL_VERSION_NUMBER >= 0x10002000L
     SSL_get0_alpn_selected(tls_conn, &alpn, &alpn_len);
@@ -1244,8 +1341,8 @@ EXPORTED int tls_start_servertls(int rea
                tls_cipher_usebits, tls_cipher_algbits,
                SSL_session_reused(tls_conn) ? "reused" : "new");
 
-    if (authid && *authid) {
-        buf_printf(&log, "authenticated as %s", *authid);
+    if (buf_len(&saslprops->authid)) {
+        buf_printf(&log, "authenticated as %s", buf_cstring(&saslprops->authid));
     }
     else {
         buf_appendcstr(&log, "no authentication");
diff -pruN 3.0.13-5/imap/tls.h 3.2.0-3/imap/tls.h
--- 3.0.13-5/imap/tls.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/tls.h	2020-04-24 02:03:00.000000000 +0000
@@ -57,6 +57,8 @@ int tls_enabled(void);
 
 #include <openssl/ssl.h>
 
+#include "global.h" /* for saslprops_t */
+
 /* init tls */
 int tls_init_serverengine(const char *ident,
                           int verifydepth, /* depth to verify */
@@ -69,7 +71,7 @@ int tls_init_clientengine(int verifydept
 
 /* start tls negotiation */
 int tls_start_servertls(int readfd, int writefd, int timeout,
-                        int *layerbits, char **authid, SSL **ret);
+                        struct saslprops_t *saslprops, SSL **ret);
 
 int tls_start_clienttls(int readfd, int writefd,
                         int *layerbits, char **authid, SSL **ret,
diff -pruN 3.0.13-5/imap/tls_prune.c 3.2.0-3/imap/tls_prune.c
--- 3.0.13-5/imap/tls_prune.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/tls_prune.c	2020-04-24 02:03:00.000000000 +0000
@@ -43,9 +43,9 @@
 #include <config.h>
 
 #include <stdio.h>
+#include <sysexits.h>
 #include <unistd.h>
 
-#include "exitcodes.h"
 #include "global.h"
 #include "tls.h"
 #include "util.h"
diff -pruN 3.0.13-5/imap/tz_err.et 3.2.0-3/imap/tz_err.et
--- 3.0.13-5/imap/tz_err.et	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/tz_err.et	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-# timezone_err.et -- Error codes for the Cyrus Timezone Service
+# tz_err.et -- Error codes for the Cyrus Timezone Service
 #
 # Copyright (c) 1994-2014 Carnegie Mellon University.  All rights reserved.
 #
diff -pruN 3.0.13-5/imap/unexpunge.c 3.2.0-3/imap/unexpunge.c
--- 3.0.13-5/imap/unexpunge.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/unexpunge.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,11 +50,11 @@
 #include <string.h>
 #include <fcntl.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 
 #include "annotate.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "index.h"
 #include "libcyr_cfg.h"
@@ -121,7 +121,7 @@ static void list_expunged(const char *mb
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
         /* still active */
-        if (!(record->system_flags & FLAG_EXPUNGED))
+        if (!(record->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         /* pre-allocate more space */
@@ -186,7 +186,7 @@ static int restore_expunged(struct mailb
     while ((msg = mailbox_iter_step(iter))) {
         const struct index_record *record = msg_record(msg);
         /* still active */
-        if (!(record->system_flags & FLAG_EXPUNGED))
+        if (!(record->internal_flags & FLAG_INTERNAL_EXPUNGED))
             continue;
 
         if (mode == MODE_UID) {
@@ -213,7 +213,7 @@ static int restore_expunged(struct mailb
 
         /* bump the UID, strip the flags */
         newrecord.uid = mailbox->i.last_uid + 1;
-        newrecord.system_flags &= ~FLAG_EXPUNGED;
+        newrecord.internal_flags &= ~FLAG_INTERNAL_EXPUNGED;
         if (unsetdeleted)
             newrecord.system_flags &= ~FLAG_DELETED;
 
@@ -252,7 +252,8 @@ static int restore_expunged(struct mailb
 
         /* mark the old one unlinked so we don't see it again */
         struct index_record oldrecord = *record;
-        oldrecord.system_flags |= FLAG_UNLINKED | FLAG_NEEDS_CLEANUP;
+        oldrecord.internal_flags |= FLAG_INTERNAL_UNLINKED |
+            FLAG_INTERNAL_NEEDS_CLEANUP;
         r = mailbox_rewrite_index_record(mailbox, &oldrecord);
         if (r) break;
 
@@ -353,23 +354,17 @@ int main(int argc, char *argv[])
 
     cyrus_init(alt_config, "unexpunge", 0, 0);
 
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    quotadb_init(0);
-    quotadb_open(NULL);
-
     sync_log_init();
 
     if (addflag && addflag[0] == '\\') {
         syslog(LOG_ERR, "can't set a system flag");
-        fatal("can't set a system flag", EC_SOFTWARE);
+        fatal("can't set a system flag", EX_SOFTWARE);
     }
 
     /* Set namespace -- force standard (internal) */
     if ((r = mboxname_init_namespace(&unex_namespace, 1)) != 0) {
         syslog(LOG_ERR, "%s", error_message(r));
-        fatal(error_message(r), EC_CONFIG);
+        fatal(error_message(r), EX_CONFIG);
     }
 
     /* Translate mailboxname */
@@ -422,12 +417,6 @@ done:
     free(extname);
     sync_log_done();
 
-    quotadb_close();
-    quotadb_done();
-
-    mboxlist_close();
-    mboxlist_done();
-
     cyrus_done();
 
     exit(r);
diff -pruN 3.0.13-5/imap/user.c 3.2.0-3/imap/user.c
--- 3.0.13-5/imap/user.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/user.c	2020-04-24 02:03:00.000000000 +0000
@@ -69,6 +69,7 @@
 # endif
 #endif
 
+#include "assert.h"
 #include "global.h"
 #include "mailbox.h"
 #include "mboxkey.h"
@@ -193,6 +194,8 @@ EXPORTED int user_deletedata(const char
 {
     char *fname;
 
+    assert(user_isnamespacelocked(userid));
+
     /* delete seen state and mbox keys */
     if(wipe_user) {
         seen_delete_user(userid);
@@ -423,7 +426,7 @@ EXPORTED int user_copyquotaroot(const ch
     quota_init(&q, oldname);
     r = quota_read(&q, NULL, 0);
     if (!r)
-        mboxlist_setquotas(newname, q.limits, 0);
+        mboxlist_setquotas(newname, q.limits, 0, 0);
     quota_free(&q);
 
     return r;
@@ -450,7 +453,7 @@ static int find_cb(void *rockp __attribu
     int r;
 
     root = xstrndup(key, keylen);
-    r = quota_deleteroot(root);
+    r = quota_deleteroot(root, 0);
     free(root);
 
     return r;
@@ -459,11 +462,8 @@ static int find_cb(void *rockp __attribu
 int user_deletequotaroots(const char *userid)
 {
     char *inbox = mboxname_user_mbox(userid, NULL);
-    int r = cyrusdb_foreach(qdb, inbox, strlen(inbox),
-                            &find_p, &find_cb, inbox, NULL);
-
+    int r = quotadb_foreach(inbox, strlen(inbox), &find_p, &find_cb, inbox);
     free(inbox);
-
     return r;
 }
 
@@ -484,3 +484,40 @@ HIDDEN char *user_hash_subs(const char *
 {
     return user_hash_meta(userid, FNAME_SUBSSUFFIX);
 }
+
+static const char *_namelock_name_from_userid(const char *userid)
+{
+    const char *p;
+    static struct buf buf = BUF_INITIALIZER;
+    if (!userid) userid = ""; // no userid == global lock
+
+    buf_setcstr(&buf, "*U*");
+
+    for (p = userid; *p; p++) {
+        switch(*p) {
+            case '.':
+                buf_putc(&buf, '^');
+                break;
+            default:
+                buf_putc(&buf, *p);
+                break;
+        }
+    }
+
+    return buf_cstring(&buf);
+}
+
+EXPORTED struct mboxlock *user_namespacelock(const char *userid)
+{
+    struct mboxlock *namelock;
+    const char *name = _namelock_name_from_userid(userid);
+    int r = mboxname_lock(name, &namelock, LOCK_EXCLUSIVE);
+    if (r) return NULL;
+    return namelock;
+}
+
+EXPORTED int user_isnamespacelocked(const char *userid)
+{
+    const char *name = _namelock_name_from_userid(userid);
+    return mboxname_islocked(name);
+}
diff -pruN 3.0.13-5/imap/userdeny_db.c 3.2.0-3/imap/userdeny_db.c
--- 3.0.13-5/imap/userdeny_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/userdeny_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -68,6 +68,10 @@
 
 static struct db *denydb;
 
+static int denydb_initialized = 0;
+
+static void init_internal();
+
 static const char default_message[] = "Access to this service has been blocked";
 
 /* parse the data */
@@ -120,6 +124,8 @@ EXPORTED int userdeny(const char *user,
     char *pat;
     int not;
 
+    init_internal();
+
     if (!denydb) denydb_open(/*create*/0);
     if (!denydb) return 0;
 
@@ -195,6 +201,8 @@ EXPORTED int denydb_set(const char *user
     struct buf data = BUF_INITIALIZER;
     int r = 0;
 
+    init_internal();
+
     if (!denydb) {
         r = IMAP_INTERNAL;
         goto out;
@@ -248,6 +256,8 @@ EXPORTED int denydb_delete(const char *u
     struct txn *txn = NULL;
     int r = 0;
 
+    init_internal();
+
     if (!denydb) return 0;
 
     if (!user) return r;
@@ -315,6 +325,8 @@ EXPORTED int denydb_foreach(denydb_proc_
 {
     struct denydb_rock dr;
 
+    init_internal();
+
     if (!denydb) return 0;
 
     dr.proc = proc;
@@ -325,12 +337,32 @@ EXPORTED int denydb_foreach(denydb_proc_
                            /* txn */NULL);
 }
 
+static void done_cb(void*rock __attribute__((unused)))
+{
+    if (denydb) {
+        denydb_close();
+    }
+    denydb_done();
+}
+
+static void init_internal()
+{
+    if (!denydb_initialized) {
+        denydb_init(0);
+        cyrus_modules_add(done_cb, NULL);
+    }
+    if (!denydb) {
+        denydb_open(0);
+    }
+}
+
 /* must be called after cyrus_init */
 EXPORTED void denydb_init(int myflags)
 {
     if (myflags & DENYDB_SYNC) {
         cyrusdb_sync(DENYDB);
     }
+    denydb_initialized = 1;
 }
 
 /*
@@ -384,4 +416,5 @@ EXPORTED void denydb_close(void)
 EXPORTED void denydb_done(void)
 {
     /* DB->done() handled by cyrus_done() */
+    denydb_initialized = 0;
 }
diff -pruN 3.0.13-5/imap/user.h 3.2.0-3/imap/user.h
--- 3.0.13-5/imap/user.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/user.h	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,7 @@
 #define INCLUDED_USER_H
 
 #include "auth.h"
+#include "mboxname.h"
 
 /* path to user's sieve directory */
 const char *user_sieve_path(const char *user);
@@ -76,4 +77,7 @@ char *user_hash_subs(const char *user);
 /* find any sort of file for the user */
 char *user_hash_meta(const char *userid, const char *suffix);
 
+struct mboxlock *user_namespacelock(const char *userid);
+int user_isnamespacelocked(const char *userid);
+
 #endif
diff -pruN 3.0.13-5/imap/vcard_support.c 3.2.0-3/imap/vcard_support.c
--- 3.0.13-5/imap/vcard_support.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/vcard_support.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,7 +48,7 @@
 
 #include "global.h"
 
-struct vparse_card *vcard_parse_string(const char *str, int repair)
+EXPORTED struct vparse_card *vcard_parse_string(const char *str, int repair)
 {
     struct vparse_state vparser;
     struct vparse_card *vcard = NULL;
@@ -62,6 +62,7 @@ struct vparse_card *vcard_parse_string(c
     vparse_set_multival(&vparser, "n", ';');
     vparse_set_multival(&vparser, "nickname", ',');
     vparse_set_multival(&vparser, "categories", ',');
+    vparse_set_multiparam(&vparser, "type");
     vparser.ctrl = repair ? VPARSE_CTRL_SKIP : VPARSE_CTRL_REJECT;
     vr = vparse_parse(&vparser, 0);
     if (vr) {
@@ -97,13 +98,13 @@ struct vparse_card *vcard_parse_string(c
     return vcard;
 }
 
-struct vparse_card *vcard_parse_buf(const struct buf *buf)
+EXPORTED struct vparse_card *vcard_parse_buf(const struct buf *buf)
 {
     int repair = config_getswitch(IMAPOPT_CARDDAV_REPAIR_VCARD);
     return vcard_parse_string(buf_cstring(buf), repair);
 }
 
-struct buf *vcard_as_buf(struct vparse_card *vcard)
+EXPORTED struct buf *vcard_as_buf(struct vparse_card *vcard)
 {
     struct buf *buf = buf_new();
 
@@ -112,7 +113,7 @@ struct buf *vcard_as_buf(struct vparse_c
     return buf;
 }
 
-struct vparse_card *record_to_vcard(struct mailbox *mailbox,
+EXPORTED struct vparse_card *record_to_vcard(struct mailbox *mailbox,
                                     const struct index_record *record)
 {
     struct buf buf = BUF_INITIALIZER;
@@ -126,3 +127,62 @@ struct vparse_card *record_to_vcard(stru
 
     return vcard;
 }
+
+/* Decode a base64-encoded binary vCard property and calculate a GUID.
+
+   XXX  This currently assumes vCard v3.
+*/
+EXPORTED size_t vcard_prop_decode_value(struct vparse_entry *prop,
+                                        struct buf *value,
+                                        char **content_type,
+                                        struct message_guid *guid)
+{
+    struct vparse_param *param;
+    size_t size = 0;
+
+    if (!prop) return 0;
+
+    /* Make sure value=binary (default) and encoding=b (base64) */
+    if ((!(param = vparse_get_param(prop, "value")) ||
+         !strcasecmp("binary", param->value)) &&
+        ((param = vparse_get_param(prop, "encoding")) &&
+         !strcasecmp("b", param->value))) {
+
+        char *decbuf = NULL;
+
+        /* Decode property value */
+        if (charset_decode_mimebody(prop->v.value, strlen(prop->v.value),
+                                    ENCODING_BASE64,
+                                    &decbuf, &size) == prop->v.value) return 0;
+
+        if (content_type) {
+            struct vparse_param *type = vparse_get_param(prop, "type");
+
+            if (!type) *content_type = NULL;
+            else {
+                struct buf buf = BUF_INITIALIZER;
+
+                lcase(type->value);
+                if (strncmp(type->value, "image/", 6))
+                    buf_setcstr(&buf, "image/");
+                buf_appendcstr(&buf, type->value);
+
+                *content_type = buf_release(&buf);
+            }
+        }
+
+        if (guid) {
+            /* Generate GUID from decoded property value */
+            message_guid_generate(guid, decbuf, size);
+        }
+
+        if (value) {
+            /* Return the value in the specified buffer */
+            buf_setmap(value, decbuf, size);
+        }
+        free(decbuf);
+    }
+
+    return size;
+}
+
diff -pruN 3.0.13-5/imap/vcard_support.h 3.2.0-3/imap/vcard_support.h
--- 3.0.13-5/imap/vcard_support.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/vcard_support.h	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include "vparse.h"
 
 #include "mailbox.h"
+#include "message_guid.h"
 #include "util.h"
 
 extern struct vparse_card *vcard_parse_string(const char *str, int repair);
@@ -58,4 +59,9 @@ extern struct buf *vcard_as_buf(struct v
 extern struct vparse_card *record_to_vcard(struct mailbox *mailbox,
                                            const struct index_record *record);
 
+extern size_t vcard_prop_decode_value(struct vparse_entry *prop,
+                                      struct buf *value,
+                                      char **content_type,
+                                      struct message_guid *guid);
+
 #endif /* VCARD_SUPPORT_H */
diff -pruN 3.0.13-5/imap/version.c 3.2.0-3/imap/version.c
--- 3.0.13-5/imap/version.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/version.c	2020-04-24 02:03:00.000000000 +0000
@@ -65,22 +65,6 @@
 static char id_resp_command[MAXIDVALUELEN];
 static char id_resp_arguments[MAXIDVALUELEN] = "";
 
-/* EXTRA_IDENT is a hack to add some version information for which compile
- * was used to build this version (at CMU, but we don't care what you do with
- * it).
- */
-
-#ifdef EXTRA_IDENT
-#define CYRUS_VERSION PACKAGE_VERSION "-" EXTRA_IDENT
-#else
-#define CYRUS_VERSION PACKAGE_VERSION
-#endif
-
-EXPORTED const char *cyrus_version(void)
-{
-    return CYRUS_VERSION;
-}
-
 /*
  * Grab the command line args for the ID response.
  */
diff -pruN 3.0.13-5/imap/version.h 3.2.0-3/imap/version.h
--- 3.0.13-5/imap/version.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/imap/version.h	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,8 @@
 #define _CYRUS_VERSION_H
 
 #include "prot.h"
+#include "util.h"
+
 /* Values for ID processing */
 enum {
     MAXIDFIELDLEN = 30,
@@ -51,7 +53,6 @@ enum {
     MAXIDPAIRS = 30,
 };
 
-const char *cyrus_version(void);
 extern void id_getcmdline(int argc, char **argv);
 extern void id_response(struct protstream *pout);
 
diff -pruN 3.0.13-5/imap/webdav_db.c 3.2.0-3/imap/webdav_db.c
--- 3.0.13-5/imap/webdav_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/webdav_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -88,16 +88,32 @@ struct webdav_db {
     unsigned ref_count;
 };
 
+static int webdav_initialized = 0;
+
+static void done_cb(void *rock __attribute__((unused))) {
+    webdav_done();
+}
+
+static void init_internal() {
+    if (!webdav_initialized) {
+        webdav_init();
+        cyrus_modules_add(done_cb, NULL);
+    }
+}
 
 EXPORTED int webdav_init(void)
 {
-    return sqldb_init();
+    int r = sqldb_init();
+    if (!r) webdav_initialized = 1;
+    return r;
 }
 
 
 EXPORTED int webdav_done(void)
 {
-    return sqldb_done();
+    int r = sqldb_done();
+    if (!r) webdav_initialized = 0;
+    return r;
 }
 
 /* Open DAV DB corresponding to userid */
@@ -105,6 +121,8 @@ EXPORTED struct webdav_db *webdav_open_u
 {
     struct webdav_db *webdavdb = NULL;
 
+    init_internal();
+
     sqldb_t *db = dav_open_userid(userid);
     if (!db) return NULL;
 
@@ -121,6 +139,8 @@ EXPORTED struct webdav_db *webdav_open_m
     struct webdav_db *webdavdb = NULL;
     char *userid = mboxname_to_userid(mailbox->name);
 
+    init_internal();
+
     if (userid) {
         webdavdb = webdav_open_userid(userid);
         free(userid);
@@ -181,7 +201,7 @@ struct read_rock {
     struct webdav_db *db;
     struct webdav_data *wdata;
     int tombstones;
-    int (*cb)(void *rock, void *data);
+    webdav_cb_t *cb;
     void *rock;
 };
 
@@ -205,6 +225,8 @@ static int read_cb(sqlite3_stmt *stmt, v
     memset(wdata, 0, sizeof(struct webdav_data));
 
     wdata->dav.alive = sqlite3_column_int(stmt, 14);
+    wdata->dav.modseq = sqlite3_column_int64(stmt, 15);
+    wdata->dav.createdmodseq = sqlite3_column_int64(stmt, 16);
     if (!rrock->tombstones && !wdata->dav.alive)
         return 0;
 
@@ -266,7 +288,8 @@ static int read_cb(sqlite3_stmt *stmt, v
 #define CMD_GETFIELDS                                                   \
     "SELECT rowid, creationdate, mailbox, resource, imap_uid,"          \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
-    "  filename, type, subtype, res_uid, ref_count, alive"              \
+    "  filename, type, subtype, res_uid, ref_count, alive,"             \
+    "  modseq, createdmodseq"                                           \
     " FROM dav_objs"                                                    \
 
 
@@ -295,6 +318,34 @@ EXPORTED int webdav_lookup_resource(stru
 }
 
 
+#define CMD_SELIMAPUID CMD_GETFIELDS \
+    " WHERE mailbox = :mailbox AND imap_uid = :imap_uid;"
+
+EXPORTED int webdav_lookup_imapuid(struct webdav_db *webdavdb,
+                                    const char *mailbox, int imap_uid,
+                                    struct webdav_data **result,
+                                    int tombstones)
+{
+    struct sqldb_bindval bval[] = {
+        { ":mailbox",  SQLITE_TEXT,    { .s = mailbox       } },
+        { ":imap_uid", SQLITE_INTEGER, { .i = imap_uid      } },
+        { NULL,        SQLITE_NULL,    { .s = NULL          } } };
+    static struct webdav_data wdata;
+    struct read_rock rrock = { webdavdb, &wdata, tombstones, NULL, NULL };
+    int r;
+
+    *result = memset(&wdata, 0, sizeof(struct webdav_data));
+
+    r = sqldb_exec(webdavdb->db, CMD_SELIMAPUID, bval, &read_cb, &rrock);
+    if (!r && !wdata.dav.rowid) r = CYRUSDB_NOTFOUND;
+
+    wdata.dav.mailbox = mailbox;
+    wdata.dav.imap_uid = imap_uid;
+
+    return r;
+}
+
+
 #define CMD_SELUID CMD_GETFIELDS                                        \
     " WHERE res_uid = :res_uid AND alive = 1;"
 
@@ -321,7 +372,7 @@ EXPORTED int webdav_lookup_uid(struct we
     " WHERE mailbox = :mailbox AND alive = 1;"
 
 EXPORTED int webdav_foreach(struct webdav_db *webdavdb, const char *mailbox,
-                            int (*cb)(void *rock, void *data),
+                            int (*cb)(void *rock, struct webdav_data *data),
                             void *rock)
 {
     struct sqldb_bindval bval[] = {
@@ -337,10 +388,12 @@ EXPORTED int webdav_foreach(struct webda
 #define CMD_INSERT                                                      \
     "INSERT INTO dav_objs ("                                            \
     "  creationdate, mailbox, resource, imap_uid, modseq,"              \
+    "  createdmodseq,"                                                  \
     "  lock_token, lock_owner, lock_ownerid, lock_expire,"              \
     "  filename, type, subtype, res_uid, ref_count, alive )"            \
     " VALUES ("                                                         \
     "  :creationdate, :mailbox, :resource, :imap_uid, :modseq,"         \
+    "  :createdmodseq,"                                                 \
     "  :lock_token, :lock_owner, :lock_ownerid, :lock_expire,"          \
     "  :filename, :type, :subtype, :res_uid, :ref_count, :alive );"
 
@@ -348,6 +401,7 @@ EXPORTED int webdav_foreach(struct webda
     "UPDATE dav_objs SET"               \
     "  imap_uid     = :imap_uid,"       \
     "  modseq       = :modseq,"         \
+    "  createdmodseq = :createdmodseq," \
     "  lock_token   = :lock_token,"     \
     "  lock_owner   = :lock_owner,"     \
     "  lock_ownerid = :lock_ownerid,"   \
@@ -365,6 +419,7 @@ EXPORTED int webdav_write(struct webdav_
     struct sqldb_bindval bval[] = {
         { ":imap_uid",     SQLITE_INTEGER, { .i = wdata->dav.imap_uid     } },
         { ":modseq",       SQLITE_INTEGER, { .i = wdata->dav.modseq       } },
+        { ":createdmodseq", SQLITE_INTEGER, { .i = wdata->dav.createdmodseq } },
         { ":lock_token",   SQLITE_TEXT,    { .s = wdata->dav.lock_token   } },
         { ":lock_owner",   SQLITE_TEXT,    { .s = wdata->dav.lock_owner   } },
         { ":lock_ownerid", SQLITE_TEXT,    { .s = wdata->dav.lock_ownerid } },
@@ -385,22 +440,22 @@ EXPORTED int webdav_write(struct webdav_
     if (wdata->dav.rowid) {
         cmd = CMD_UPDATE;
 
-        bval[12].name = ":rowid";
-        bval[12].type = SQLITE_INTEGER;
-        bval[12].val.i = wdata->dav.rowid;
+        bval[13].name = ":rowid";
+        bval[13].type = SQLITE_INTEGER;
+        bval[13].val.i = wdata->dav.rowid;
     }
     else {
         cmd = CMD_INSERT;
 
-        bval[12].name = ":creationdate";
-        bval[12].type = SQLITE_INTEGER;
-        bval[12].val.i = wdata->dav.creationdate;
-        bval[13].name = ":mailbox";
-        bval[13].type = SQLITE_TEXT;
-        bval[13].val.s = wdata->dav.mailbox;
-        bval[14].name = ":resource";
+        bval[13].name = ":creationdate";
+        bval[13].type = SQLITE_INTEGER;
+        bval[13].val.i = wdata->dav.creationdate;
+        bval[14].name = ":mailbox";
         bval[14].type = SQLITE_TEXT;
-        bval[14].val.s = wdata->dav.resource;
+        bval[14].val.s = wdata->dav.mailbox;
+        bval[15].name = ":resource";
+        bval[15].type = SQLITE_TEXT;
+        bval[15].val.s = wdata->dav.resource;
     }
 
     r = sqldb_exec(webdavdb->db, cmd, bval, NULL, NULL);
@@ -438,6 +493,38 @@ EXPORTED int webdav_delmbox(struct webda
     return r;
 }
 
+EXPORTED int webdav_get_updates(struct webdav_db *webdavdb,
+                                modseq_t oldmodseq, const char *mboxname,
+                                int kind __attribute__((unused)), int limit,
+                                int (*cb)(void *rock, struct webdav_data *wdata),
+                                void *rock)
+{
+    struct sqldb_bindval bval[] = {
+        { ":mailbox",      SQLITE_TEXT,    { .s = mboxname  } },
+        { ":modseq",       SQLITE_INTEGER, { .i = oldmodseq } },
+        /* SQLite interprets a negative limit as unbounded. */
+        { ":limit",        SQLITE_INTEGER, { .i = limit > 0 ? limit : -1 } },
+        { NULL,            SQLITE_NULL,    { .s = NULL      } }
+    };
+    static struct webdav_data wdata;
+    struct read_rock rrock = { webdavdb, &wdata, 1 /* tombstones */, cb, rock };
+    struct buf sqlbuf = BUF_INITIALIZER;
+    int r;
+
+    buf_setcstr(&sqlbuf, CMD_GETFIELDS " WHERE");
+    if (mboxname) buf_appendcstr(&sqlbuf, " mailbox = :mailbox AND");
+    if (!oldmodseq) buf_appendcstr(&sqlbuf, " alive = 1 AND");
+    buf_appendcstr(&sqlbuf, " modseq > :modseq ORDER BY modseq LIMIT :limit;");
+
+    r = sqldb_exec(webdavdb->db, buf_cstring(&sqlbuf), bval, &read_cb, &rrock);
+    buf_free(&sqlbuf);
+
+    if (r) {
+        syslog(LOG_ERR, "webdav error %s", error_message(r));
+    }
+    return r;
+}
+
 #else
 
 EXPORTED int webdav_init(void)
diff -pruN 3.0.13-5/imap/webdav_db.h 3.2.0-3/imap/webdav_db.h
--- 3.0.13-5/imap/webdav_db.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/webdav_db.h	2020-04-24 02:03:00.000000000 +0000
@@ -70,6 +70,8 @@ struct webdav_data {
     unsigned ref_count;
 };
 
+typedef int webdav_cb_t(void *rock, struct webdav_data *wdata);
+
 /* get a database handle corresponding to userid */
 struct webdav_db *webdav_open_userid(const char *userid);
 
@@ -86,6 +88,13 @@ int webdav_lookup_resource(struct webdav
                            struct webdav_data **result,
                            int tombstones);
 
+/* lookup an entry from 'webdavdb' by mailbox and IMAP uid
+   (optionally inside a transaction for updates) */
+int webdav_lookup_imapuid(struct webdav_db *webdavdb,
+                          const char *mailbox, int uid,
+                          struct webdav_data **result,
+                          int tombstones);
+
 /* lookup an entry from 'webdavdb' by resource UID
    (optionally inside a transaction for updates) */
 int webdav_lookup_uid(struct webdav_db *webdavdb, const char *res_uid,
@@ -93,7 +102,7 @@ int webdav_lookup_uid(struct webdav_db *
 
 /* process each entry for 'mailbox' in 'webdavdb' with cb() */
 int webdav_foreach(struct webdav_db *webdavdb, const char *mailbox,
-                   int (*cb)(void *rock, void *data),
+                   int (*cb)(void *rock, struct webdav_data *data),
                    void *rock);
 
 /* write an entry to 'webdavdb' */
@@ -114,6 +123,15 @@ int webdav_commit(struct webdav_db *webd
 /* abort transaction */
 int webdav_abort(struct webdav_db *webdavdb);
 
+/* Process each entry for 'webdavdb' with a modseq higher than oldmodseq,
+ * in ascending order of modseq.
+ * If mailbox is not NULL, only process entries of this mailbox.
+ * If kind is non-negative, only process entries of this kind.
+ * If max_records is positive, only call cb for at most this entries. */
+int webdav_get_updates(struct webdav_db *webdavdb,
+                       modseq_t oldmodseq, const char *mboxname, int kind,
+                       int max_records, webdav_cb_t *cb, void *rock);
+
 #endif /* WITH_DAV */
 
 #endif /* WEBDAV_DB_H */
diff -pruN 3.0.13-5/imap/xapian_wrap.cpp 3.2.0-3/imap/xapian_wrap.cpp
--- 3.0.13-5/imap/xapian_wrap.cpp	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/xapian_wrap.cpp	2020-05-04 03:28:02.000000000 +0000
@@ -1,4 +1,3 @@
-
 #include <errno.h>
 #include <config.h>
 #include <string.h>
@@ -7,10 +6,14 @@
 
 #include <fstream>
 #include <sstream>
+#include <algorithm>
+#include <memory>
 
 extern "C" {
 #include <assert.h>
 #include "libconfig.h"
+#include "util.h"
+#include "search_engines.h"
 #include "search_part.h"
 #include "xmalloc.h"
 #include "xapian_wrap.h"
@@ -22,8 +25,15 @@ extern "C" {
 #include "imap/imap_err.h"
 };
 
+#include <unicode/unistr.h>
+#include <unicode/locid.h>
+
 #include <xapian.h>
 
+#ifdef HAVE_CLD2
+#include <cld2/compact_lang_det.h>
+#endif
+
 // from global.h
 extern int charset_flags;
 
@@ -31,57 +41,227 @@ extern int charset_flags;
 
 /* ====================================================================== */
 
-static Xapian::Stopper *get_stopper()
+static void make_cyrusid(struct buf *dst, const struct message_guid *guid, char doctype)
+{
+    buf_reset(dst);
+    buf_putc(dst, '*');
+    buf_putc(dst, doctype);
+    buf_putc(dst, '*');
+    buf_appendcstr(dst, message_guid_encode(guid));
+}
+
+/* ====================================================================== */
+
+// Process-scoped, thread-unsafe cache of stoppers by ISO 639-1 code.
+static std::map<std::string, std::unique_ptr<Xapian::Stopper>> stoppers;
+
+static const Xapian::Stopper* get_stopper(const std::string& iso)
 {
-    Xapian::Stopper *stopper = NULL;
+    // Lookup cached entry.
+    try {
+        stoppers.at(iso).get();
+    } catch (const std::out_of_range&) {};
 
+    // Lookup language name by ISO code.
+    std::string lang_name;
+    icu::Locale loc(iso.c_str());
+    if (loc.isBogus()) return NULL;
+    icu::UnicodeString ulang_name;
+    loc.getDisplayLanguage(icu::Locale("en"), ulang_name);
+    ulang_name.toLower();
+    ulang_name.toUTF8String(lang_name);
+
+    // Read stopper file and add to cache.
     const char *swpath = config_getstring(IMAPOPT_SEARCH_STOPWORD_PATH);
-    if (swpath) {
-        // Set path to stopword file
-        struct buf buf = BUF_INITIALIZER;
-        buf_setcstr(&buf, swpath);
-        // XXX doesn't play nice with WIN32 paths
-        buf_appendcstr(&buf, "/english.list");
-
-        // Open the stopword file
-        errno = 0;
-        std::ifstream inFile (buf_cstring(&buf));
-        if (inFile.fail()) {
-            syslog(LOG_ERR, "Xapian: could not open stopword file %s: %s",
-                   buf_cstring(&buf), errno ? strerror(errno) : "unknown error");
-            exit(1);
-        }
+    if (!swpath) return NULL;
 
-        // Create the Xapian stopper
-        stopper = new Xapian::SimpleStopper(
+    // Open stopword file
+    // XXX doesn't play nice with WIN32 paths
+    std::string fname(std::string(swpath) + "/" + lang_name + ".txt");
+    errno = 0;
+    std::ifstream inFile (fname);
+    if (inFile.fail()) {
+        syslog(LOG_DEBUG, "Xapian: could not open stopword file %s: %s",
+                fname.c_str(), errno ? strerror(errno) : "unknown error");
+        return NULL;
+    }
+
+    // Create and store the Xapian stopper
+    stoppers[iso].reset(new Xapian::SimpleStopper(
                 std::istream_iterator<std::string>(inFile),
-                std::istream_iterator<std::string>());
+                std::istream_iterator<std::string>()));
+    return stoppers[iso].get();
+}
+
+/* ====================================================================== */
+
+class CyrusSearchStemmer : public Xapian::StemImplementation
+{
+    charset_t utf8 {charset_lookupname("utf-8")};
+    std::map<const std::string, std::string> cache;
+    Xapian::Stem stem {"en"};
+
+    public:
+    virtual ~CyrusSearchStemmer() { charset_free(&utf8); }
+
+    virtual std::string operator() (const std::string &word) override {
+        // Is this word already in the cache?
+        try {
+            return cache.at(word);
+        } catch (const std::out_of_range&) {}
+
+        // Convert the word to search form
+        std::unique_ptr<char, decltype(std::free)*> q {charset_convert(word.c_str(), utf8, charset_flags), std::free};
+        if (!q) {
+            return stem(word);
+        }
+
+        // Store the normalized word in the cache
+        return cache[word] = stem(Xapian::Unicode::tolower(q.get()));
+    }
+
+    virtual std::string get_description () const override {
+        return "Cyrus";
+    }
+};
+
+/* ====================================================================== */
+
+/*
+ * A brief history of Xapian db versions:
+ * Version 0: uses STEM_ALL for all terms, term prefixes don't start with 'X'
+ * Version 1: term prefixes start with 'X'
+ * Version 2: uses STEM_SOME for some terms
+ * Version 3: removes all use of STEM_ALL
+ * Version 4: indexes headers and bodies in separate documents
+ * Version 5: indexes headers and bodies together and stems by language
+ */
+#define XAPIAN_DB_CURRENT_VERSION 5
+#define XAPIAN_DB_MIN_SUPPORTED_VERSION 2
+
+static std::set<int> get_db_versions(const Xapian::Database &database)
+{
+    std::set<int> versions;
+
+    // db_version is a comma-separated list of version numbers
+    std::string val = database.get_metadata("cyrus.db_version");
+    if (!val.empty()) {
+        strarray_t *vstr = strarray_split(val.c_str(), ",", 0);
+        for (int i = 0; i < strarray_size(vstr); i++) {
+            int version = std::atoi(strarray_nth(vstr, i));
+            if (version) versions.insert(version);
+        }
+        strarray_free(vstr);
+    }
+    // Up to version 3 this was named stem version.
+    val = database.get_metadata("cyrus.stem-version");
+    if (!val.empty()) {
+        versions.insert(std::stoi(val));
+    }
+
+    return versions;
+}
+
+static void set_db_versions(Xapian::WritableDatabase &database, std::set<int> &versions)
+{
+    std::ostringstream val;
+    for (std::set<int>::iterator it = versions.begin(); it != versions.end(); ++it) {
+        if (it != versions.begin()) val << ",";
+        val << *it;
+    }
+    database.set_metadata("cyrus.db_version", val.str());
+    database.set_metadata("cyrus.stem-version", "");
+}
+
+
+/* ====================================================================== */
+
+#define XAPIAN_LANG_COUNT_KEYPREFIX "lang.count"
+#define XAPIAN_LANG_DOC_KEYPREFIX "lang.doc"
+
+static std::string make_lang_prefix(const std::string& iso_lang, const char *prefix)
+{
+    return "XI" + iso_lang + ":" + prefix;
+}
+
+static std::string make_lang_cyrusid_key(int num_part, const char *cyrusid)
+{
+    std::string key(XAPIAN_LANG_DOC_KEYPREFIX);
+    if (const char *partname = search_part_as_string(num_part)) {
+        std::string lstr(partname);
+        std::transform(lstr.begin(), lstr.end(), lstr.begin(), ::tolower);
+        key += '.' + lstr;
+    }
+    return key + '.' + cyrusid;
+}
 
-        // Clean up
-        buf_free(&buf);
+static std::string make_lang_count_key(int num_part, const std::string& iso_lang)
+{
+    const char *partname = NULL;
+    if (num_part != SEARCH_PART_NONE && num_part != SEARCH_PART_ANY)
+        partname = search_part_as_string(num_part);
+    std::string key(XAPIAN_LANG_COUNT_KEYPREFIX);
+    if (partname) {
+        std::string lstr(partname);
+        std::transform(lstr.begin(), lstr.end(), lstr.begin(), ::tolower);
+        key += '.' + lstr;
+    }
+    if (!iso_lang.empty()) {
+        key += '.' + iso_lang;
     }
-    return stopper;
+    return key;
 }
 
+
 /* ====================================================================== */
 
 int xapian_compact_dbs(const char *dest, const char **sources)
 {
     int r = 0;
     Xapian::Database db;
+    const char *thispath = "(unknown path)";
+    std::map<std::string, unsigned> lang_counts;
+    std::set<int> db_versions;
 
     try {
         while (*sources) {
+            thispath = *sources;
             Xapian::Database subdb(*sources++);
             db.add_database(subdb);
+
+            // Aggregate db versions.
+            std::set<int> subdb_versions = get_db_versions(subdb);
+            db_versions.insert(subdb_versions.begin(), subdb_versions.end());
+
+            // Aggregate language counts across databases.
+            if (db_versions.lower_bound(5) != db_versions.end()) {
+                for (Xapian::TermIterator it = subdb.metadata_keys_begin(XAPIAN_LANG_COUNT_KEYPREFIX);
+                        it != subdb.metadata_keys_end(XAPIAN_LANG_COUNT_KEYPREFIX); ++it) {
+                    lang_counts[*it] += std::stol(subdb.get_metadata(*it));
+                }
+            }
+            else lang_counts[XAPIAN_LANG_COUNT_KEYPREFIX ".en"] += subdb.get_doccount();
         }
+        thispath = "(unknown path)";
 
         /* FULLER because we never write to compression targets again */
         db.compact(dest, Xapian::Compactor::FULLER | Xapian::DBCOMPACT_MULTIPASS);
+
+        Xapian::WritableDatabase newdb(dest);
+        set_db_versions(newdb, db_versions);
+
+        // Replace all language counts with aggregated counts.
+        for (Xapian::TermIterator it = newdb.metadata_keys_begin(XAPIAN_LANG_COUNT_KEYPREFIX);
+                it != newdb.metadata_keys_end(XAPIAN_LANG_COUNT_KEYPREFIX); ++it) {
+            newdb.set_metadata(*it, "");
+        }
+        for (const std::pair<std::string, unsigned>& it : lang_counts) {
+            newdb.set_metadata(it.first, std::to_string(it.second));
+        }
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
-                    err.get_context().c_str(), err.get_description().c_str());
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception compact_dbs: %s: %s (%s)",
+                err.get_context().c_str(), err.get_description().c_str(), thispath);
         r = IMAP_IOERROR;
     }
 
@@ -90,29 +270,24 @@ int xapian_compact_dbs(const char *dest,
 
 /* ====================================================================== */
 
-#define XAPIAN_STEM_VERSIONS_NUM 3
-#define XAPIAN_STEM_CURRENT_VERSION (XAPIAN_STEM_VERSIONS_NUM-1)
-#define XAPIAN_STEM_VERSION_KEY "cyrus.stem-version"
-
-static const char * const
-stem_prefixes[XAPIAN_STEM_VERSIONS_NUM][SEARCH_NUM_PARTS] = {
-    // Version 0: Initial version
-    {
-        NULL,
-        "F",                /* FROM */
-        "T",                /* TO */
-        "C",                /* CC */
-        "B",                /* BCC */
-        "S",                /* SUBJECT */
-        "L",                /* LISTID */
-        "Y",                /* TYPE */
-        "H",                /* HEADERS */
-        "D",                /* BODY */
-        "O",                /* LOCATION */
-        "A"                 /* ATTACHMENTNAME */
-    },
-    // Version 1: Stem using STEM_SOME with stopwords
-    {
+static const char *get_term_prefix(int db_version, int partnum)
+{
+    /*
+     * We use term prefixes to store terms per search part.
+     * In addition, each Xapian document contains a special
+     * prefix to indicate its document type, e.g. 'G' for
+     * a message, or 'P' for a MIME part. This allow to query
+     * search results by both search part queries and filter
+     * by document type.
+     *
+     * The prefix "XE" is reserved for the document type and
+     * MUST not be used for any search part.
+     *
+     * The prefix "XI" is reserved for language stemming
+     * (also see make_lang_prefix).
+     *
+     */
+    static const char * const term_prefixes[SEARCH_NUM_PARTS] = {
         NULL,
         "XF",                /* FROM */
         "XT",                /* TO */
@@ -124,78 +299,50 @@ stem_prefixes[XAPIAN_STEM_VERSIONS_NUM][
         "XH",                /* HEADERS */
         "",                  /* BODY */
         "XO",                /* LOCATION */
-        "XA"                 /* ATTACHMENTNAME */
-    },
-    // Version 2: Use STEM_NONE for headers, STEM_SOME for free text
-    {
+        "XA",                /* ATTACHMENTNAME */
+        "XAB"                /* ATTACHMENTBODY */
+    };
+
+    static const char * const term_prefixes_v0[SEARCH_NUM_PARTS] = {
         NULL,
-        "XF",                /* FROM */
-        "XT",                /* TO */
-        "XC",                /* CC */
-        "XB",                /* BCC */
-        "XS",                /* SUBJECT */
-        "XL",                /* LISTID */
-        "XY",                /* TYPE */
-        "XH",                /* HEADERS */
-        "",                  /* BODY */
-        "XO",                /* LOCATION */
-        "XA"                 /* ATTACHMENTNAME */
-    }
-};
+        "F",                /* FROM */
+        "T",                /* TO */
+        "C",                /* CC */
+        "B",                /* BCC */
+        "S",                /* SUBJECT */
+        "L",                /* LISTID */
+        "Y",                /* TYPE */
+        "H",                /* HEADERS */
+        "D",                /* BODY */
+        "O",                /* LOCATION */
+        "A",                /* ATTACHMENTNAME */
+        "AB"                /* ATTACHMENTBODY */
+    };
 
-static Xapian::QueryParser::stem_strategy
-qp_stem_strategies[XAPIAN_STEM_VERSIONS_NUM][SEARCH_NUM_PARTS] = {
-    // Version 0: Initial version
-    {
-        Xapian::QueryParser::STEM_NONE,
-        Xapian::QueryParser::STEM_ALL,   /* FROM */
-        Xapian::QueryParser::STEM_ALL,   /* TO */
-        Xapian::QueryParser::STEM_ALL,   /* CC */
-        Xapian::QueryParser::STEM_ALL,   /* BCC */
-        Xapian::QueryParser::STEM_ALL,   /* SUBJECT */
-        Xapian::QueryParser::STEM_ALL,   /* LISTID */
-        Xapian::QueryParser::STEM_ALL,   /* TYPE */
-        Xapian::QueryParser::STEM_ALL,   /* HEADERS */
-        Xapian::QueryParser::STEM_ALL,   /* BODY */
-        Xapian::QueryParser::STEM_ALL,   /* LOCATION */
-        Xapian::QueryParser::STEM_NONE   /* ATTACHMENTNAME */
-    },
-    // Version 1: Stem bodies using STEM_SOME with stopwords
-    {
-        Xapian::QueryParser::STEM_NONE,
-        Xapian::QueryParser::STEM_ALL,   /* FROM */
-        Xapian::QueryParser::STEM_ALL,   /* TO */
-        Xapian::QueryParser::STEM_ALL,   /* CC */
-        Xapian::QueryParser::STEM_ALL,   /* BCC */
-        Xapian::QueryParser::STEM_ALL,   /* SUBJECT */
-        Xapian::QueryParser::STEM_ALL,   /* LISTID */
-        Xapian::QueryParser::STEM_ALL,   /* TYPE */
-        Xapian::QueryParser::STEM_ALL,   /* HEADERS */
-        Xapian::QueryParser::STEM_SOME,  /* BODY */
-        Xapian::QueryParser::STEM_SOME,  /* LOCATION */
-        Xapian::QueryParser::STEM_NONE   /* ATTACHMENTNAME */
-    },
-    // Version 2: Use STEM_NONE for headers, STEM_SOME for free text
-    {
-        Xapian::QueryParser::STEM_NONE,
-        Xapian::QueryParser::STEM_NONE,  /* FROM */
-        Xapian::QueryParser::STEM_NONE,  /* TO */
-        Xapian::QueryParser::STEM_NONE,  /* CC */
-        Xapian::QueryParser::STEM_NONE,  /* BCC */
-        Xapian::QueryParser::STEM_SOME,  /* SUBJECT */
-        Xapian::QueryParser::STEM_NONE,  /* LISTID */
-        Xapian::QueryParser::STEM_NONE,  /* TYPE */
-        Xapian::QueryParser::STEM_NONE,  /* HEADERS */
-        Xapian::QueryParser::STEM_SOME,  /* BODY */
-        Xapian::QueryParser::STEM_SOME,  /* LOCATION */
-        Xapian::QueryParser::STEM_NONE   /* ATTACHMENTNAME */
-    }
-};
+    return db_version > 0 ? term_prefixes[partnum] : term_prefixes_v0[partnum];
+}
 
-static Xapian::TermGenerator::stem_strategy
-tg_stem_strategies[XAPIAN_STEM_VERSIONS_NUM][SEARCH_NUM_PARTS] = {
-    // Version 0: Initial version
-    {
+static Xapian::TermGenerator::stem_strategy get_stem_strategy(int db_version, int partnum)
+{
+    static Xapian::TermGenerator::stem_strategy stem_strategy[SEARCH_NUM_PARTS] = {
+        // Version 2 and higher
+        Xapian::TermGenerator::STEM_NONE,
+        Xapian::TermGenerator::STEM_NONE,  /* FROM */
+        Xapian::TermGenerator::STEM_NONE,  /* TO */
+        Xapian::TermGenerator::STEM_NONE,  /* CC */
+        Xapian::TermGenerator::STEM_NONE,  /* BCC */
+        Xapian::TermGenerator::STEM_SOME,  /* SUBJECT */
+        Xapian::TermGenerator::STEM_NONE,  /* LISTID */
+        Xapian::TermGenerator::STEM_NONE,  /* TYPE */
+        Xapian::TermGenerator::STEM_NONE,  /* HEADERS */
+        Xapian::TermGenerator::STEM_SOME,  /* BODY */
+        Xapian::TermGenerator::STEM_SOME,  /* LOCATION */
+        Xapian::TermGenerator::STEM_NONE,  /* ATTACHMENTNAME */
+        Xapian::TermGenerator::STEM_SOME   /* ATTACHMENTBODY */
+    };
+
+    static Xapian::TermGenerator::stem_strategy stem_strategy_v1[SEARCH_NUM_PARTS] = {
+        // Version 1: Stem bodies using STEM_SOME with stopwords
         Xapian::TermGenerator::STEM_NONE,
         Xapian::TermGenerator::STEM_ALL,   /* FROM */
         Xapian::TermGenerator::STEM_ALL,   /* TO */
@@ -205,11 +352,14 @@ tg_stem_strategies[XAPIAN_STEM_VERSIONS_
         Xapian::TermGenerator::STEM_ALL,   /* LISTID */
         Xapian::TermGenerator::STEM_ALL,   /* TYPE */
         Xapian::TermGenerator::STEM_ALL,   /* HEADERS */
-        Xapian::TermGenerator::STEM_ALL,   /* BODY */
-        Xapian::TermGenerator::STEM_ALL    /* LOCATION */
-    },
-    // Version 1: Stem bodies using STEM_SOME with stopwords
-    {
+        Xapian::TermGenerator::STEM_SOME,  /* BODY */
+        Xapian::TermGenerator::STEM_SOME,  /* LOCATION */
+        Xapian::TermGenerator::STEM_NONE,  /* ATTACHMENTNAME */
+        Xapian::TermGenerator::STEM_SOME   /* ATTACHMENTBODY */
+    };
+
+    static Xapian::TermGenerator::stem_strategy stem_strategy_v0[SEARCH_NUM_PARTS] = {
+        // Version 0: Initial version
         Xapian::TermGenerator::STEM_NONE,
         Xapian::TermGenerator::STEM_ALL,   /* FROM */
         Xapian::TermGenerator::STEM_ALL,   /* TO */
@@ -219,67 +369,35 @@ tg_stem_strategies[XAPIAN_STEM_VERSIONS_
         Xapian::TermGenerator::STEM_ALL,   /* LISTID */
         Xapian::TermGenerator::STEM_ALL,   /* TYPE */
         Xapian::TermGenerator::STEM_ALL,   /* HEADERS */
-        Xapian::TermGenerator::STEM_SOME,  /* BODY */
-        Xapian::TermGenerator::STEM_SOME   /* LOCATION */
-    },
-    // Version 2: Use STEM_NONE for headers, STEM_SOME for free text
-    {
-        Xapian::TermGenerator::STEM_NONE,
-        Xapian::TermGenerator::STEM_NONE,  /* FROM */
-        Xapian::TermGenerator::STEM_NONE,  /* TO */
-        Xapian::TermGenerator::STEM_NONE,  /* CC */
-        Xapian::TermGenerator::STEM_NONE,  /* BCC */
-        Xapian::TermGenerator::STEM_SOME,  /* SUBJECT */
-        Xapian::TermGenerator::STEM_NONE,  /* LISTID */
-        Xapian::TermGenerator::STEM_NONE,  /* TYPE */
-        Xapian::TermGenerator::STEM_NONE,  /* HEADERS */
-        Xapian::TermGenerator::STEM_SOME,  /* BODY */
-        Xapian::TermGenerator::STEM_SOME   /* LOCATION */
-    }
-};
-
-static int stem_version_get(Xapian::Database *database)
-{
-    std::string val = database->get_metadata(XAPIAN_STEM_VERSION_KEY);
-    if (val.empty()) {
-        // Absence of the key indicates the legacy stem prefix scheme
-        return 0;
-    }
-    char *err = NULL;
-    long version = strtol(val.c_str(), &err, 10);
-    if ((err && *err) || version < 0 || version > INT_MAX) {
-        // That's just bogus data
-        return -1;
-    }
-    if (version > XAPIAN_STEM_CURRENT_VERSION) {
-        // This could indicate an issue with versioning. Probably a more
-        // recent squatter wrote the database than the current instance?
-        return -2;
+        Xapian::TermGenerator::STEM_ALL,   /* BODY */
+        Xapian::TermGenerator::STEM_ALL,   /* LOCATION */
+        Xapian::TermGenerator::STEM_ALL,   /* ATTACHMENTNAME */
+        Xapian::TermGenerator::STEM_ALL    /* ATTACHMENTBODY */
+    };
+
+    switch (db_version) {
+        case 0:
+            return stem_strategy_v0[partnum];
+        case 1:
+            return stem_strategy_v1[partnum];
+        default:
+            return stem_strategy[partnum];
     }
-    return version;
 }
 
-static void stem_version_set(Xapian::WritableDatabase *database, int version)
-{
-    std::ostringstream convert;
-    convert << version;
-    database->set_metadata(XAPIAN_STEM_VERSION_KEY, convert.str());
-}
-
-/* For all db paths in sources that are not using the latest stem
+/* For all db paths in sources that are not using the latest database
  * version or not readable, report their paths in toreindex */
-void xapian_check_if_needs_reindex(const strarray_t *sources, strarray_t *toreindex)
+void xapian_check_if_needs_reindex(const strarray_t *sources, strarray_t *toreindex, int always_upgrade)
 {
-    int i;
-
-    // Check the stem version of all dbs in sources
-    for (i = 0; i < sources->count; i++) {
+    // Check the version of all dbs in sources
+    for (int i = 0; i < sources->count; i++) {
         const char *thispath = strarray_nth(sources, i);
         try {
-            Xapian::Database database = Xapian::Database(thispath);
-            int stem_version = stem_version_get(&database);
-            if (stem_version != XAPIAN_STEM_CURRENT_VERSION) {
-                strarray_add(toreindex, thispath);
+            for (const int& it: get_db_versions(Xapian::Database{thispath})) {
+                if (it < XAPIAN_DB_MIN_SUPPORTED_VERSION ||
+                        (always_upgrade && (it != XAPIAN_DB_CURRENT_VERSION))) {
+                    strarray_add(toreindex, thispath);
+                }
             }
         }
         catch (const Xapian::Error &err) {
@@ -296,50 +414,60 @@ struct xapian_dbw
     Xapian::Stem *stemmer;
     Xapian::TermGenerator *term_generator;
     Xapian::Document *document;
+    char doctype;
     Xapian::Stopper *stopper;
     ptrarray_t otherdbs;
-    int stem_version;
     char *cyrusid;
+    Xapian::Stem *default_stemmer;
+    const Xapian::Stopper* default_stopper;
+    bool is_inmemory;
 };
 
-int xapian_dbw_open(const char **paths, xapian_dbw_t **dbwp)
+
+static int xapian_dbw_init(xapian_dbw_t *dbw)
+{
+    dbw->default_stemmer = new Xapian::Stem(new CyrusSearchStemmer);
+    dbw->default_stopper = get_stopper("en");
+    dbw->term_generator = new Xapian::TermGenerator;
+    /* Always enable CJK word tokenization */
+#ifdef USE_XAPIAN_CJK_WORDS
+    dbw->term_generator->set_flags(Xapian::TermGenerator::FLAG_CJK_WORDS,
+            ~Xapian::TermGenerator::FLAG_CJK_WORDS);
+#else
+    dbw->term_generator->set_flags(Xapian::TermGenerator::FLAG_CJK_NGRAM,
+            ~Xapian::TermGenerator::FLAG_CJK_NGRAM);
+#endif
+    dbw->term_generator->set_stopper(dbw->stopper);
+    return 0;
+}
+
+int xapian_dbw_open(const char **paths, xapian_dbw_t **dbwp, int mode)
 {
     xapian_dbw_t *dbw = (xapian_dbw_t *)xzmalloc(sizeof(xapian_dbw_t));
     int r = 0;
+    const char *thispath = *paths++;
 
-    const char *path = *paths++;
+    std::set<int> db_versions;
     try {
         /* Determine the sterm version of an existing database, or create a
          * new one with the latest one. Never implicitly upgrade. */
         try {
-            dbw->database = new Xapian::WritableDatabase(path, Xapian::DB_OPEN);
-            dbw->stem_version = stem_version_get(dbw->database);
-            if (dbw->stem_version < 0) {
-                syslog(LOG_ERR, "xapian_wrapper: Invalid stem version %d in %s",
-                        dbw->stem_version, path);
-                r = IMAP_IOERROR;
-            }
+            dbw->database = new Xapian::WritableDatabase{thispath, Xapian::DB_OPEN};
+            db_versions = get_db_versions(*dbw->database);
         } catch (Xapian::DatabaseOpeningError &e) {
             /* It's OK not to atomically create or open, since we can assume
              * the xapianactive file items to be locked. */
-            dbw->database = new Xapian::WritableDatabase(path, Xapian::DB_CREATE|Xapian::DB_BACKEND_GLASS);
-            dbw->stem_version = XAPIAN_STEM_CURRENT_VERSION;
-            stem_version_set(dbw->database, dbw->stem_version);
+            dbw->database = new Xapian::WritableDatabase{thispath, Xapian::DB_CREATE|Xapian::DB_BACKEND_GLASS};
         }
 
-        dbw->term_generator = new Xapian::TermGenerator();
-        dbw->stemmer = new Xapian::Stem("en");
-        dbw->stopper = get_stopper();
-        dbw->term_generator->set_stemmer(*dbw->stemmer);
-        /* Always enable CJK word tokenization */
-#ifdef USE_XAPIAN_CJK_WORDS
-        dbw->term_generator->set_flags(Xapian::TermGenerator::FLAG_CJK_WORDS,
-                ~Xapian::TermGenerator::FLAG_CJK_WORDS);
-#else
-        dbw->term_generator->set_flags(Xapian::TermGenerator::FLAG_CJK_NGRAM,
-                ~Xapian::TermGenerator::FLAG_CJK_NGRAM);
-#endif
-        dbw->term_generator->set_stopper(dbw->stopper);
+        if (db_versions.find(XAPIAN_DB_CURRENT_VERSION) == db_versions.end()) {
+            // Always index using latest database version.
+            db_versions.insert(XAPIAN_DB_CURRENT_VERSION);
+            set_db_versions(*dbw->database, db_versions);
+        }
+
+        r = xapian_dbw_init(dbw);
+
     }
     catch (const Xapian::DatabaseLockError &err) {
         /* somebody else is already indexing this user.  They may be doing a different
@@ -347,8 +475,8 @@ int xapian_dbw_open(const char **paths,
         r = IMAP_MAILBOX_LOCKED;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
-                    err.get_context().c_str(), err.get_description().c_str());
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception dbw_open: %s: %s (%s)",
+                    err.get_context().c_str(), err.get_description().c_str(), thispath);
         r = IMAP_IOERROR;
     }
 
@@ -358,19 +486,40 @@ int xapian_dbw_open(const char **paths,
     }
 
     /* open the read-only databases */
-    while (*paths) {
-        try {
-            Xapian::Database *database = new Xapian::Database(*paths++);
-            ptrarray_append(&dbw->otherdbs, database);
-        }
-        catch (const Xapian::Error &err) {
-            syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
-                        err.get_context().c_str(), err.get_description().c_str());
+    if (mode == XAPIAN_DBW_XAPINDEXED) {
+        while (*paths) {
+            try {
+                thispath = *paths;
+                ptrarray_append(&dbw->otherdbs, new Xapian::Database{*paths++});
+            }
+            catch (const Xapian::Error &err) {
+                syslog(LOG_ERR, "IOERROR: Xapian: caught exception dbw_open read: %s: %s (%s)",
+                            err.get_context().c_str(), err.get_description().c_str(), thispath);
+            }
         }
     }
 
     *dbwp = dbw;
 
+    return 0;
+}
+
+int xapian_dbw_openmem(struct xapian_dbw **dbwp)
+{
+    xapian_dbw_t *dbw = (xapian_dbw_t *)xzmalloc(sizeof(xapian_dbw_t));
+    dbw->is_inmemory = true;
+
+    dbw->database = new Xapian::WritableDatabase{"", Xapian::DB_BACKEND_INMEMORY};
+    std::set<int> db_versions {XAPIAN_DB_CURRENT_VERSION};
+    set_db_versions(*dbw->database, db_versions);
+
+    int r = xapian_dbw_init(dbw);
+    if (r) {
+        xapian_dbw_close(dbw);
+        dbw = NULL;
+    }
+
+    *dbwp = dbw;
     return r;
 }
 
@@ -383,21 +532,20 @@ void xapian_dbw_close(xapian_dbw_t *dbw)
         delete dbw->stemmer;
         delete dbw->stopper;
         delete dbw->document;
+        delete dbw->default_stemmer;
         for (int i = 0; i < dbw->otherdbs.count; i++) {
-            Xapian::Database *database = (Xapian::Database *)ptrarray_nth(&dbw->otherdbs, i);
-            delete database;
+            delete (Xapian::Database *)ptrarray_nth(&dbw->otherdbs, i);
         }
         ptrarray_fini(&dbw->otherdbs);
         if (dbw->cyrusid) free(dbw->cyrusid);
         free(dbw);
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception dbw_close: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
     }
 }
 
-
 int xapian_dbw_begin_txn(xapian_dbw_t *dbw)
 {
     int r = 0;
@@ -405,7 +553,7 @@ int xapian_dbw_begin_txn(xapian_dbw_t *d
         dbw->database->begin_transaction();
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception begin_txn: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
@@ -419,7 +567,7 @@ int xapian_dbw_commit_txn(xapian_dbw_t *
         dbw->database->commit_transaction();
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception commit_txn: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
@@ -433,29 +581,33 @@ int xapian_dbw_cancel_txn(xapian_dbw_t *
         dbw->database->cancel_transaction();
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception cancel_txn: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
     return r;
 }
 
-int xapian_dbw_begin_doc(xapian_dbw_t *dbw, const char *cyrusid)
+int xapian_dbw_begin_doc(xapian_dbw_t *dbw, const struct message_guid *guid, char doctype)
 {
     int r = 0;
+
     try {
-        if (dbw->document) {
-            delete dbw->document;
-            dbw->document = 0;
-        }
-        dbw->document = new Xapian::Document();
-        dbw->document->add_value(SLOT_CYRUSID, cyrusid);
-        dbw->cyrusid = xstrdup(cyrusid);
+        delete dbw->document;
+        dbw->document = new Xapian::Document;
+        dbw->doctype = doctype;
+        /* Set document id and type */
+        struct buf buf = BUF_INITIALIZER;
+        make_cyrusid(&buf, guid, doctype);
+        dbw->document->add_value(SLOT_CYRUSID, buf_cstring(&buf));
+        dbw->cyrusid = buf_release(&buf);
+        dbw->document->add_boolean_term(std::string("XE") + doctype);
+        /* Initialize term generator */
         dbw->term_generator->set_document(*dbw->document);
         dbw->term_generator->set_termpos(1);
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception begin_doc: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
@@ -465,23 +617,74 @@ int xapian_dbw_begin_doc(xapian_dbw_t *d
 int xapian_dbw_doc_part(xapian_dbw_t *dbw, const struct buf *part, int num_part)
 {
     int r = 0;
-    const char *prefix;
 
-    prefix = stem_prefixes[dbw->stem_version][num_part];
+    const char *prefix = get_term_prefix(XAPIAN_DB_CURRENT_VERSION, num_part);
     if (!prefix) {
         syslog(LOG_ERR, "xapian_wrapper: no prefix for num_part %d", num_part);
         return IMAP_INTERNAL;
     }
 
     try {
-        Xapian::TermGenerator::stem_strategy stem;
-        stem = tg_stem_strategies[dbw->stem_version][num_part];
-        dbw->term_generator->set_stemming_strategy(stem);
+        Xapian::TermGenerator::stem_strategy stem_strategy =
+            get_stem_strategy(XAPIAN_DB_CURRENT_VERSION, num_part);
+        dbw->term_generator->set_stemming_strategy(stem_strategy);
+
+        // Index text.
+        if (stem_strategy != Xapian::TermGenerator::STEM_NONE) {
+            std::string iso_lang("en"); // Default stemmer language ISO code.
+#ifdef HAVE_CLD2
+            if (config_getswitch(IMAPOPT_SEARCH_INDEX_LANGUAGE)) {
+                // Determine text language.
+                bool reliable = false;
+                CLD2::Language lang = CLD2::DetectLanguage(part->s, part->len, 1, &reliable);
+                if (reliable && lang != CLD2::UNKNOWN_LANGUAGE) {
+                    // English stemmer is the default, no need to stem twice.
+                    if (strcasecmp(CLD2::LanguageCode(lang), "en")) {
+                        try {
+                            iso_lang = CLD2::LanguageCode(lang);
+                            // Index with detected language stemmer.
+                            dbw->term_generator->set_stemmer(Xapian::Stem(iso_lang));
+                            dbw->term_generator->set_stopper(get_stopper(iso_lang));
+                            dbw->term_generator->index_text(Xapian::Utf8Iterator(part->s, part->len), 1,
+                                    make_lang_prefix(iso_lang, prefix));
+                            // Keep track of stemmer language by document id and part.
+                            std::string key = make_lang_cyrusid_key(num_part, dbw->cyrusid);
+                            dbw->database->set_metadata(key, iso_lang);
+                        } catch (const Xapian::InvalidArgumentError &err) {
+                            syslog(LOG_DEBUG, "Xapian: no stemmer for language %s",
+                                    iso_lang.c_str());
+                        }
+                    }
+                }
+            }
+#endif
+            // Keep track of stemmer language counts by search part.
+            // We only count stemmer language once per document and part,
+            // either the detected language or the default (English).
+            // We still index them using both stemmers.
+            if ((!config_getswitch(IMAPOPT_SEARCH_INDEX_PARTS)) ||
+                (dbw->doctype == 'G' && !search_part_is_body(num_part)) ||
+                (dbw->doctype != 'G' &&  search_part_is_body(num_part))) {
+                std::string key = make_lang_count_key(num_part, iso_lang);
+                std::string val = dbw->database->get_metadata(key);
+                dbw->database->set_metadata(key, val.empty() ? "1" : std::to_string(std::stoi(val) + 1));
+            }
+
+            // Index with default stemmer.
+            dbw->term_generator->set_stemmer(*dbw->default_stemmer);
+            dbw->term_generator->set_stopper(dbw->default_stopper);
+        } else {
+            // Index with no stemming.
+            dbw->term_generator->set_stemmer(Xapian::Stem());
+            dbw->term_generator->set_stopper(NULL);
+        }
         dbw->term_generator->index_text(Xapian::Utf8Iterator(part->s, part->len), 1, prefix);
+
+        // Finalize index.
         dbw->term_generator->increase_termpos();
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception doc_part: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
@@ -496,20 +699,24 @@ int xapian_dbw_end_doc(xapian_dbw_t *dbw
         dbw->database->set_metadata("cyrusid." + std::string(dbw->cyrusid), "1");
         delete dbw->document;
         dbw->document = 0;
+        dbw->doctype = 0;
         if (dbw->cyrusid) free(dbw->cyrusid);
         dbw->cyrusid = NULL;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception end_doc: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         r = IMAP_IOERROR;
     }
     return r;
 }
 
-int xapian_dbw_is_indexed(xapian_dbw_t *dbw, const char *cyrusid)
+int xapian_dbw_is_indexed(xapian_dbw_t *dbw, const struct message_guid *guid, char doctype)
 {
-    std::string key = "cyrusid." + std::string(cyrusid);
+    struct buf buf = BUF_INITIALIZER;
+    make_cyrusid(&buf, guid, doctype);
+    std::string key = "cyrusid." + std::string(buf_cstring(&buf));
+    buf_free(&buf);
 
     /* indexed in the current DB? */
     if (!dbw->database->get_metadata(key).empty())
@@ -530,13 +737,81 @@ int xapian_dbw_is_indexed(xapian_dbw_t *
 struct xapian_db
 {
     std::string *paths;
-    Xapian::Database *database;
-    Xapian::Stem *stemmer;
+    Xapian::Database *database; // all but version 4 databases
+    Xapian::Database *legacydbv4; // version 4 databases
+    std::vector<Xapian::Database> *shards; // all database shards
+    Xapian::Stem *default_stemmer;
+    const Xapian::Stopper* default_stopper;
+    std::map<std::string, double> *stem_language_weights;
     Xapian::QueryParser *parser;
-    Xapian::Stopper *stopper;
-    std::set<int> *stem_versions;
+    std::set<int> *db_versions;
+    xapian_dbw_t *dbw;
 };
 
+static int xapian_db_init(xapian_db_t *db, bool is_inmemory)
+{
+    int r = 0;
+    double total_stemmed_docs_count = 0;
+    const std::string lang_count_prefix{XAPIAN_LANG_COUNT_KEYPREFIX "."};
+    constexpr size_t lang_count_prefix_length = strlen(XAPIAN_LANG_COUNT_KEYPREFIX ".");
+
+
+    try {
+        for (const Xapian::Database& subdb : *db->shards) {
+            std::set<int> db_versions = get_db_versions(subdb);
+
+            // Determine weight per stemmed language. This currently is quite
+            // simplistic: we count each occurrence of a language, regardless
+            // of search part. An email with a German subject and a German text
+            // body will count twice. Since we  store the language count per
+            // search part in the database, we can make weights more clever
+            // later, if necessary.
+            // XXX Xapian in-memory db does not support metadata iterators
+            if (db->db_versions->lower_bound(4) != db->db_versions->end() && !is_inmemory) {
+                if (!db->stem_language_weights)
+                    db->stem_language_weights = new std::map<std::string, double>;
+
+                for (Xapian::TermIterator it = subdb.metadata_keys_begin(lang_count_prefix);
+                        it != subdb.metadata_keys_end(lang_count_prefix); ++it) {
+                    double count = (double) std::stol(subdb.get_metadata(*it));
+                    total_stemmed_docs_count += count;
+                    std::string iso_lang = (*it).substr(lang_count_prefix_length);
+                    // A lang count prefix optionally includes a part name, so
+                    // both "lang.count.en" and "lang.count.body.en" are valid.
+                    size_t dotpos = iso_lang.find('.');
+                    if (dotpos != std::string::npos) {
+                        iso_lang = iso_lang.substr(dotpos+1);
+                    }
+                    if (iso_lang.compare("en")) {
+                        // Add count. We'll normalize to [0,1] later.
+                        (*(db->stem_language_weights))[iso_lang] += count;
+                    }
+                }
+            } else total_stemmed_docs_count += subdb.get_doccount();
+        }
+
+        db->parser = new Xapian::QueryParser;
+        db->parser->set_default_op(Xapian::Query::OP_AND);
+        db->parser->set_database(db->database ? *db->database : *db->legacydbv4);
+        db->default_stemmer = new Xapian::Stem(new CyrusSearchStemmer);
+        db->default_stopper = get_stopper("en");
+
+        if (db->stem_language_weights) {
+            // Determine language weights
+            for (std::pair<const std::string, double>& it : *db->stem_language_weights) {
+                it.second /= total_stemmed_docs_count;
+            }
+        }
+    }
+    catch (const Xapian::Error &err) {
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception db_open: %s: %s",
+                "<inmemory>", err.get_description().c_str());
+        r = IMAP_IOERROR;
+    }
+
+    return r;
+}
+
 int xapian_db_open(const char **paths, xapian_db_t **dbp)
 {
     xapian_db_t *db = (xapian_db_t *)xzmalloc(sizeof(xapian_db_t));
@@ -544,41 +819,48 @@ int xapian_db_open(const char **paths, x
     int r = 0;
 
     try {
-        db->paths = new std::string();
-        db->database = new Xapian::Database();
-        while (*paths) {
+        db->paths = new std::string;
+        while (paths && *paths) {
             thispath = *paths++;
-            Xapian::Database database = Xapian::Database(thispath);
-            int stem_version = stem_version_get(&database);
-            if (stem_version < 0) {
-                syslog(LOG_ERR, "xapian_wrapper: Invalid prefix version %d in %s",
-                        stem_version, thispath);
+            Xapian::Database subdb {thispath};
+            std::set<int> db_versions = get_db_versions(subdb);
+            if (db_versions.empty()) {
+                syslog(LOG_ERR, "xapian_wrapper: invalid db version in %s", thispath);
                 r = IMAP_INTERNAL;
                 goto done;
             }
-            if (!db->stem_versions)
-                db->stem_versions = new std::set<int>();
-            db->stem_versions->insert(stem_version);
-            /* we have some mixed version databases, but only Chert, so we've
-             * just made them return zero for the version, and we'll add 1 to
-             * the set for them as well */
-            if (!stem_version)
-                db->stem_versions->insert(1);
-            db->database->add_database(database);
-            db->paths->append(thispath);
-            db->paths->append(" ");
-            thispath = "(unknown)";
+            if (!db->db_versions)
+                db->db_versions = new std::set<int>;
+            db->db_versions->insert(db_versions.begin(), db_versions.end());
+            // Databases with version 4 split indexing by doctype.
+            if (db_versions.find(4) != db_versions.end()) {
+                if (!db->legacydbv4) db->legacydbv4 = new Xapian::Database;
+                db->legacydbv4->add_database(subdb);
+            }
+            // Databases with any but version 4 are regular dbs.
+            if (db_versions.size() > 1 || db_versions.find(4) == db_versions.end()) {
+                if (!db->database) db->database = new Xapian::Database;
+                db->database->add_database(subdb);
+            }
+
+            // Xapian database has no API to access shards.
+            if (!db->shards) db->shards = new std::vector<Xapian::Database>;
+            db->shards->push_back(subdb);
+
+            db->paths->append(thispath).push_back(' ');
         }
-        db->stemmer = new Xapian::Stem("en");
-        db->parser = new Xapian::QueryParser;
-        db->stopper = get_stopper();
-        db->parser->set_stemmer(*db->stemmer);
-        db->parser->set_default_op(Xapian::Query::OP_AND);
-        db->parser->set_database(*db->database);
-        db->parser->set_stopper(db->stopper);
+        thispath = "(unknown)";
+
+        if (!db->database && !db->legacydbv4) {
+            r = IMAP_NOTFOUND;
+            goto done;
+        }
+
+        r = xapian_db_init(db, /*is_inmemory*/false);
+        if (r) goto done;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception db_open: %s: %s",
                     thispath, err.get_description().c_str());
         r = IMAP_IOERROR;
     }
@@ -592,143 +874,174 @@ done:
     return r;
 }
 
+int xapian_db_opendbw(struct xapian_dbw *dbw, xapian_db_t **dbp)
+{
+    xapian_db_t *db = (xapian_db_t *)xzmalloc(sizeof(xapian_db_t));
+
+    db->dbw = dbw;
+    db->database = dbw->database;
+    db->db_versions = new std::set<int>();
+    std::set<int> dbw_versions = get_db_versions(*dbw->database);
+    db->db_versions->insert(dbw_versions.begin(), dbw_versions.end());
+    db->shards = new std::vector<Xapian::Database>;
+    db->shards->push_back(*dbw->database);
+
+    int r = xapian_db_init(db, dbw->is_inmemory);
+    if (r) {
+        xapian_db_close(db);
+        db = NULL;
+    }
+
+    *dbp = db;
+    return r;
+}
+
 void xapian_db_close(xapian_db_t *db)
 {
+    if (!db) return;
     try {
-        delete db->database;
-        delete db->stemmer;
+        if (!db->dbw) delete db->database;
+        delete db->legacydbv4;
         delete db->parser;
-        delete db->stopper;
         delete db->paths;
-        delete db->stem_versions;
+        delete db->db_versions;
+        delete db->default_stemmer;
+        delete db->stem_language_weights;
+        delete db->shards;
         free(db);
     }
     catch (const Xapian::Error &err) {
         /* XXX - memory leak? */
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception db_close: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
     }
 }
 
+int xapian_db_has_otherthan_v4_index(const xapian_db_t *db)
+{
+    return db->database != NULL;
+}
 
-static xapian_query_t *
-xapian_query_new_match_internal(const xapian_db_t *db, int stem_version,
-                                int num_part, const char *str)
+int xapian_db_has_legacy_v4_index(const xapian_db_t *db)
 {
-    try {
-        // We don't use FLAG_BOOLEAN because Cyrus is doing boolean for us
-        // TODO: FLAG_AUTO_SYNONYMS
-        int has_highbit = 0;
-        const unsigned char *p;
-        const char *prefix = stem_prefixes[stem_version][num_part];
+    return db->legacydbv4 != NULL;
+}
 
-        if (!prefix) {
-            // Imitating the legacy prefix handling code, this is not an error
-            return NULL;
+static Xapian::Query *make_stem_match_query(const xapian_db_t *db,
+                                            const char *match,
+                                            const char *prefix,
+                                            Xapian::TermGenerator::stem_strategy tg_stem_strategy)
+{
+    unsigned flags = Xapian::QueryParser::FLAG_PHRASE |
+                     Xapian::QueryParser::FLAG_LOVEHATE |
+                     Xapian::QueryParser::FLAG_WILDCARD;
+
+    if (tg_stem_strategy != Xapian::TermGenerator::STEM_NONE) {
+        Xapian::Query* q = new Xapian::Query;
+
+        // STEM_SOME doesn't work for terms starting with upper case,
+        // which will break for languages such as German. We also can't use
+        // STEM_ALL_Z, as this would force-stem phrase queries. Best guess
+        // is to lower case the query and risk stemming proper nouns.
+        std::string lmatch(match);
+        std::transform(lmatch.begin(), lmatch.end(), lmatch.begin(), ::tolower);
+
+        // Stem query for each language detected in the index.
+        if (db->stem_language_weights && config_getswitch(IMAPOPT_SEARCH_QUERY_LANGUAGE)) {
+            for (const std::pair<std::string, double>& it : *db->stem_language_weights) {
+
+                // Ignore rarely used languages.
+                if (it.second < 0.05) continue;
+
+                const std::string& iso_lang = it.first;
+                try {
+                    db->parser->set_stemmer(Xapian::Stem(iso_lang));
+                    const Xapian::Stopper *stopper = get_stopper(iso_lang);
+                    db->parser->set_stopper(stopper);
+                    if (stopper && (*stopper)(lmatch)) {
+                        // Don't stem stopwords
+                        db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_NONE);
+                    }
+                    else if (tg_stem_strategy == Xapian::TermGenerator::STEM_ALL) {
+                        db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_ALL);
+                    }
+                    else {
+                        db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_SOME);
+                    }
+                    *q |= db->parser->parse_query(lmatch, flags, make_lang_prefix(iso_lang, prefix));
+                } catch (const Xapian::InvalidArgumentError &err) {
+                    syslog(LOG_INFO, "Xapian: no stemmer for language %s", iso_lang.c_str());
+                }
+            }
         }
 
-        for (p = (const unsigned char *)str; *p; p++)
-            if (*p > 205) has_highbit = 1;
-
-        if (has_highbit) {
-            // anything from greek (codepage from 0380) isn't english parsable
-            // so don't try stemming it!
+        // Query with default stemmer.
+        db->parser->set_stemmer(*db->default_stemmer);
+        db->parser->set_stopper(db->default_stopper);
+        if (db->default_stopper && (*db->default_stopper)(lmatch)) {
+            // Don't stem stopwords.
             db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_NONE);
-            std::string sstr = std::string("") + str;
-            Xapian::Query query = db->parser->parse_query(
-                                    sstr,
-#ifdef USE_XAPIAN_CJK_WORDS
-                                    Xapian::QueryParser::FLAG_CJK_WORDS,
-#else
-                                    Xapian::QueryParser::FLAG_CJK_NGRAM,
-#endif
-                                    std::string(prefix));
-            return (xapian_query_t *)new Xapian::Query(query);
         }
-
-        // Determine the stem strategy for this prefix and message part
-        Xapian::QueryParser::stem_strategy stem;
-        stem = qp_stem_strategies[stem_version][num_part];
-        db->parser->set_stemming_strategy(stem);
-
-        // Prepare the search term
-        std::string search;
-        switch (stem) {
-            case Xapian::QueryParser::STEM_ALL:
-                // quote the query for phrase management. This is for
-                // backward compatibility, but shouldn't hurt anyways.
-                search = std::string("\"") + str + "\"";
-                break;
-            case Xapian::QueryParser::STEM_SOME:
-                // Cyrus canonical search form is all upper case, but STEM_SOME
-                // doesn't work for terms starting with upper case. Best guess
-                // is to lower case and risk stemming proper nouns
-                search = Xapian::Unicode::tolower(str);
-                break;
-            default:
-                search = std::string(str);
+        else {
+            db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_SOME);
         }
+        *q |= db->parser->parse_query(lmatch, flags, prefix);
 
-        // Finally, run the query
-        Xapian::Query query = db->parser->parse_query(
-                search,
-                (Xapian::QueryParser::FLAG_PHRASE |
-                 Xapian::QueryParser::FLAG_LOVEHATE |
-                 Xapian::QueryParser::FLAG_WILDCARD),
-                std::string(prefix));
-        return (xapian_query_t *)new Xapian::Query(query);
+        return q;
     }
-    catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
-                    err.get_context().c_str(), err.get_description().c_str());
-        return 0;
+    else {
+        // Query without any stemmer.
+        db->parser->set_stemmer(Xapian::Stem());
+        db->parser->set_stopper(NULL);
+        db->parser->set_stemming_strategy(Xapian::QueryParser::STEM_NONE);
+        return new Xapian::Query {db->parser->parse_query(match, flags, prefix)};
     }
+
 }
 
 xapian_query_t *
-xapian_query_new_match(const xapian_db_t *db, int num_part,const char *str)
+xapian_query_new_match(const xapian_db_t *db, int partnum, const char *str)
 {
-    std::set<int> *versions = db->stem_versions;
-
-    // at least one database must be open
-    assert(versions);
-    assert(versions->size());
-
-    if (versions->size() == 1) {
-        // All database are using the same stemming scheme. Great!
-        int version = *(versions->begin());
-
-        if (!stem_prefixes[version][num_part])
-            return NULL;
-
-        return (xapian_query_t *)
-            xapian_query_new_match_internal(db, version, num_part, str);
-    }
-
-    // At least two prefix schemes are used in the open databases. Since db
-    // fans out to n databases, let's OR queries for each stem version
-    std::vector<Xapian::Query*> v;
-    // No 'auto' before C++0x... :(
-    for (std::set<int>::iterator it = versions->begin(); it != versions->end(); ++it) {
-        if (stem_prefixes[*it][num_part]) {
-            v.push_back((Xapian::Query *)
-                    xapian_query_new_match_internal(db, *it, num_part, str));
-        }
+    if (db->shards->empty()) {
+        // no database to query
+        return NULL;
     }
-    if (v.empty()) {
+    const char *prefix = get_term_prefix(XAPIAN_DB_CURRENT_VERSION, partnum);
+    if (!prefix) {
+        // Legacy prefix handling code, this is not an error
         return NULL;
     }
 
-    Xapian::Query *compound =
-        new Xapian::Query(Xapian::Query::OP_OR, v.begin(), v.end());
+    try {
+        int min_version = *db->db_versions->begin();
+        if (min_version < XAPIAN_DB_MIN_SUPPORTED_VERSION) {
+            syslog(LOG_ERR, "Xapian: db versions < %d are deprecated. Reindex your dbs.",
+                    XAPIAN_DB_MIN_SUPPORTED_VERSION);
+        }
 
-    // 'compound' owns a refcount on each child.  We need to
-    // drop the one we got when we allocated the children
-    for (std::vector<Xapian::Query*>::iterator it = v.begin(); it != v.end(); ++it) {
-        delete *(it);
-    }
+        // Don't stem queries for Thaana codepage (0780) or higher.
+        for (const unsigned char *p = (const unsigned char *)str; *p; p++) {
+            if (*p > 221) //has highbit
+                return (xapian_query_t *) new Xapian::Query {db->parser->parse_query(
+                    str,
+#ifdef USE_XAPIAN_CJK_WORDS
+                    Xapian::QueryParser::FLAG_CJK_WORDS,
+#else
+                    Xapian::QueryParser::FLAG_CJK_NGRAM,
+#endif
+                    prefix)};
+        }
+
+        // Regular codepage. Stem by language.
+        Xapian::TermGenerator::stem_strategy stem_strategy =
+            get_stem_strategy(XAPIAN_DB_CURRENT_VERSION, partnum);
+        return (xapian_query_t *) make_stem_match_query(db, str, prefix, stem_strategy);
 
-    return (xapian_query_t *)compound;
+    } catch (const Xapian::Error &err) {
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception match_internal: %s: %s",
+                err.get_context().c_str(), err.get_description().c_str());
+        return 0;
+    }
 }
 
 
@@ -738,20 +1051,26 @@ xapian_query_t *xapian_query_new_compoun
     try {
         // I want to use std::initializer_list<Xapian::Query*> here
         // but that requires "experimental" gcc C++0x support :(
-        std::vector<Xapian::Query*> v;
-        for (int i = 0 ; i < n ; i++)
-            v.push_back((Xapian::Query *)children[i]);
-        Xapian::Query *compound = new Xapian::Query(
-                                    is_or ?  Xapian::Query::OP_OR : Xapian::Query::OP_AND,
-                                    v.begin(), v.end());
         // 'compound' owns a refcount on each child.  We need to
         // drop the one we got when we allocated the children
-        for (int i = 0 ; i < n ; i++)
-            delete (Xapian::Query *)children[i];
+        Xapian::Query* compound = new Xapian::Query;
+        if (is_or)
+            for (int i = 0 ; i < n ; i++) {
+                *compound |= *(Xapian::Query*)children[i];
+                delete (Xapian::Query*)children[i];
+            }
+        else
+            for (int i = 0 ; i < n ; i++) {
+                if (compound->empty())
+                    *compound = *(Xapian::Query*)children[i];
+                else
+                    *compound &= *(Xapian::Query*)children[i];
+                delete (Xapian::Query*)children[i];
+            }
         return (xapian_query_t *)compound;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception new_compound: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         return 0;
     }
@@ -773,7 +1092,32 @@ xapian_query_t *xapian_query_new_not(con
         return (xapian_query_t *)qq;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception new_not: %s: %s",
+                    err.get_context().c_str(), err.get_description().c_str());
+        return 0;
+    }
+}
+
+xapian_query_t *xapian_query_new_matchall(const xapian_db_t *db __attribute__((unused)))
+{
+    return (xapian_query_t *) new Xapian::Query(Xapian::Query::MatchAll);
+}
+
+xapian_query_t *xapian_query_new_has_doctype(const xapian_db_t *db __attribute__((unused)),
+                                             char doctype, xapian_query_t *child)
+{
+    try {
+        Xapian::Query *qq = new Xapian::Query(
+                                        Xapian::Query::OP_FILTER,
+                                        child ? *(Xapian::Query *)child : Xapian::Query::MatchAll,
+                                        std::string("XE") + doctype);
+        // 'compound' owns a refcount on each child.  We need to
+        // drop the one we got when we allocated the children
+        delete (Xapian::Query *)child;
+        return (xapian_query_t *)qq;
+    }
+    catch (const Xapian::Error &err) {
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception new_filter_doctype: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
         return 0;
     }
@@ -782,138 +1126,148 @@ xapian_query_t *xapian_query_new_not(con
 void xapian_query_free(xapian_query_t *qq)
 {
     try {
-        Xapian::Query *query = (Xapian::Query *)qq;
-        delete query;
+        delete (Xapian::Query *)qq;
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception query_free: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
     }
 }
 
-int xapian_query_run(const xapian_db_t *db, const xapian_query_t *qq,
-                     int (*cb)(const char *cyrusid, void *rock), void *rock)
+int xapian_query_run(const xapian_db_t *db, const xapian_query_t *qq, int is_legacy,
+                     int (*cb)(void *data, size_t n, void *rock), void *rock)
 {
     const Xapian::Query *query = (const Xapian::Query *)qq;
-    int r = 0;
+    void *data = NULL;
+    size_t n = 0;
+
+    if ((is_legacy && !db->legacydbv4) || (!is_legacy && !db->database)) return 0;
 
     try {
-        Xapian::Enquire enquire(*db->database);
+        Xapian::Database *database = is_legacy ? db->legacydbv4 : db->database;
+        Xapian::Enquire enquire(*database);
         enquire.set_query(*query);
-        Xapian::MSet matches = enquire.get_mset(0, db->database->get_doccount());
+        enquire.set_sort_by_value(0, false); // sort by cyrusid ascending
+        Xapian::MSet matches = enquire.get_mset(0, database->get_doccount());
+        size_t size = matches.size();
+        if (size) data = xzmalloc(size * 41);
         for (Xapian::MSetIterator i = matches.begin() ; i != matches.end() ; ++i) {
-            Xapian::Document d = i.get_document();
-            std::string cyrusid = d.get_value(SLOT_CYRUSID);
+            const Xapian::Document& d = i.get_document();
+            const std::string& cyrusid = d.get_value(SLOT_CYRUSID);
+
             /* ignore documents with no cyrusid.  Shouldn't happen, but has been seen */
-            if (cyrusid.length() == 0) {
+            if (cyrusid.length() != 43) {
                 syslog(LOG_ERR, "IOERROR: Xapian: zero length cyrusid for document id %u in index files %s",
                                 d.get_docid(), db->paths->c_str());
                 continue;
             }
-            r = cb(cyrusid.c_str(), rock);
-            if (r) break;
+            const char *cstr = cyrusid.c_str();
+            if (cstr[0] != '*' || !isalpha(cstr[1]) || cstr[2] != '*') {
+                syslog(LOG_ERR, "IOERROR: Xapian: invalid cyrusid %s for document id %u in index files %s",
+                                cstr, d.get_docid(), db->paths->c_str());
+                continue;
+            }
+            if (n >= size) throw Xapian::DatabaseError("Too many records in MSet");
+            char *entry = (char *) data + (41*n);
+            memcpy(entry, cstr+3, 40);
+            entry[40] = '\0';
+            ++n;
         }
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception query_run: %s: %s",
                     err.get_context().c_str(), err.get_description().c_str());
-        r = IMAP_IOERROR;
+        free(data);
+        return IMAP_IOERROR;
     }
 
+    if (!n) {
+        free(data);
+        return 0;
+    }
+
+    int r = cb(data, n, rock);
+    free(data);
     return r;
 }
 
+int xapian_list_lang_stats(xapian_db_t *db, ptrarray_t* lstats)
+{
+    struct search_lang_stats *stat;
+    double cummulated_weight = 0;
+
+    if (db && db->stem_language_weights) {
+        for (const std::pair<std::string, double>& it : *db->stem_language_weights) {
+            stat = (struct search_lang_stats *) xzmalloc(sizeof(struct search_lang_stats));
+            stat->iso_lang = xstrdup(it.first.c_str());
+            stat->weight = it.second;
+            ptrarray_append(lstats, stat);
+            cummulated_weight += stat->weight;
+        }
+    }
+
+    stat = (struct search_lang_stats *) xzmalloc(sizeof(struct search_lang_stats));
+    stat->iso_lang = xstrdup("en");
+    stat->weight = 1.0 - cummulated_weight;
+    ptrarray_append(lstats, stat);
+
+    return 0;
+}
+
+/* ====================================================================== */
+
 struct xapian_snipgen
 {
-    Xapian::Stem *stemmer;
-    Xapian::Database *db;
+    Xapian::Stem *default_stemmer;
+    xapian_db_t *db;
+    Xapian::Database *memdb;
     std::vector<std::string> *loose_terms;
     std::vector<std::string> *queries;
+    char *cyrusid;
     struct buf *buf;
     const char *hi_start;
     const char *hi_end;
     const char *omit;
-    int partnum;
-};
-
-class CharsetStemmer : public Xapian::StemImplementation
-{
-    charset_t utf8;
-    std::map<const std::string, std::string> cache;
-    Xapian::Stem stem;
-
-    public:
-    CharsetStemmer(Xapian::Stem s) : utf8(charset_lookupname("utf-8")),
-                                     stem(s) { }
-
-    virtual ~CharsetStemmer() { charset_free(&utf8); }
-
-    virtual std::string operator() (const std::string &word) {
-        char *q;
-        std::string res;
-
-        // Is this word already in the cache?
-        std::map<const std::string, std::string>::iterator it = cache.find(word);
-        if (it != cache.end()) {
-            return it->second;
-        }
-
-        // Convert the word to search form
-        q = charset_convert(word.c_str(), utf8, charset_flags);
-        if (!q) {
-            return stem(word);
-        }
-
-        // Store the normalized word in the cache
-        res = stem(Xapian::Unicode::tolower(q));
-        cache[word] = res;
-        free(q);
-        return res;
-    }
-
-    virtual std::string get_description () const {
-        return "Cyrus search form";
-    }
+    size_t max_len;
 };
 
-xapian_snipgen_t *xapian_snipgen_new(const char *hi_start, const char *hi_end,
+xapian_snipgen_t *xapian_snipgen_new(xapian_db_t *db,
+                                     const char *hi_start,
+                                     const char *hi_end,
                                      const char *omit)
 {
-    xapian_snipgen_t *snipgen = NULL;
-    CharsetStemmer *stem = new CharsetStemmer(Xapian::Stem("en"));
-
-    snipgen = (xapian_snipgen_t *)xzmalloc(sizeof(xapian_snipgen_t));
-    snipgen->stemmer = new Xapian::Stem(stem);
-    snipgen->db = new Xapian::WritableDatabase(std::string(), Xapian::DB_BACKEND_INMEMORY);
+    xapian_snipgen_t *snipgen = (xapian_snipgen_t *)xzmalloc(sizeof(xapian_snipgen_t));
+    snipgen->default_stemmer = new Xapian::Stem(new CyrusSearchStemmer);
+    snipgen->db = db;
+    snipgen->memdb = new Xapian::WritableDatabase(std::string(), Xapian::DB_BACKEND_INMEMORY);
     snipgen->buf = buf_new();
     snipgen->hi_start = hi_start;
     snipgen->hi_end = hi_end;
     snipgen->omit = omit;
-    snipgen->partnum = -1;
+    snipgen->max_len = (size_t) config_getint(IMAPOPT_SEARCH_SNIPPET_LENGTH);
 
     return snipgen;
 }
 
 void xapian_snipgen_free(xapian_snipgen_t *snipgen)
 {
-    snipgen->db->close();
-    delete snipgen->stemmer;
+    delete snipgen->default_stemmer;
     delete snipgen->loose_terms;
     delete snipgen->queries;
-    delete snipgen->db;
+    delete snipgen->memdb;
+    free(snipgen->cyrusid);
     buf_destroy(snipgen->buf);
     free(snipgen);
 }
 
-Xapian::Query xapian_snipgen_build_query(xapian_snipgen_t *snipgen)
+static Xapian::Query xapian_snipgen_build_query(xapian_snipgen_t *snipgen, Xapian::Stem& stemmer)
 {
-    std::vector<std::string> terms;
     Xapian::TermGenerator term_generator;
-    std::vector<Xapian::Query> v;
+    Xapian::Query q;
 
     if (snipgen->loose_terms) {
         /* Add loose query terms */
-        term_generator.set_stemmer(*snipgen->stemmer);
+        term_generator.set_stemmer(stemmer);
 #ifdef USE_XAPIAN_CJK_WORDS
         term_generator.set_flags(Xapian::TermGenerator::FLAG_CJK_WORDS,
                 ~Xapian::TermGenerator::FLAG_CJK_WORDS);
@@ -924,21 +1278,11 @@ Xapian::Query xapian_snipgen_build_query
 
         for(size_t i = 0; i < snipgen->loose_terms->size(); ++i)
         {
-            std::string match = snipgen->loose_terms->at(i);
-            term_generator.index_text(Xapian::Utf8Iterator(match.c_str()));
-        }
-
-        const Xapian::Document & doc = term_generator.get_document();
-        Xapian::TermIterator it = doc.termlist_begin();
-        while (it != doc.termlist_end()) {
-            terms.push_back(*it);
-            it++;
+            term_generator.index_text(Xapian::Utf8Iterator((*snipgen->loose_terms)[i]));
         }
 
-        for(size_t i = 0; i < terms.size(); ++i)
-        {
-            v.push_back(Xapian::Query(terms[i]));
-        }
+        const Xapian::Document& doc = term_generator.get_document();
+        q = Xapian::Query(Xapian::Query::OP_OR, doc.termlist_begin(), doc.termlist_end());
     }
 
     if (snipgen->queries) {
@@ -951,117 +1295,144 @@ Xapian::Query xapian_snipgen_build_query
                          Xapian::QueryParser::FLAG_CJK_NGRAM;
 #endif
         Xapian::QueryParser queryparser;
-        queryparser.set_stemmer(*snipgen->stemmer);
+        queryparser.set_stemmer(stemmer);
         for(size_t i = 0; i < snipgen->queries->size(); ++i) {
-            std::string phrase = snipgen->queries->at(i);
-            v.push_back(queryparser.parse_query(phrase, flags));
+            q |= queryparser.parse_query((*snipgen->queries)[i], flags);;
         }
     }
 
-    return Xapian::Query(Xapian::Query::OP_OR, v.begin(), v.end());
+    return q;
 }
 
 int xapian_snipgen_add_match(xapian_snipgen_t *snipgen, const char *match)
 {
-    int r = 0;
-
     size_t len = strlen(match);
-    int is_query = len > 1 && ((match[0] == '"' && match[len-1] == '"') ||
-                               (strchr(match, '*') != NULL));
+    bool is_query = len > 1 && ((match[0] == '"' && match[len-1] == '"') ||
+                                (strchr(match, '*') != NULL));
 
     if (is_query) {
         if (!snipgen->queries) {
-            snipgen->queries = new std::vector<std::string>();
+            snipgen->queries = new std::vector<std::string>;
         }
-        snipgen->queries->push_back(std::string(match));
+        snipgen->queries->push_back(match);
     } else {
         if (!snipgen->loose_terms) {
-            snipgen->loose_terms = new std::vector<std::string>();
+            snipgen->loose_terms = new std::vector<std::string>;
         }
-        snipgen->loose_terms->push_back(std::string(match));
+        snipgen->loose_terms->push_back(match);
     }
 
-    return r;
+    return 0;
 }
 
 int xapian_snipgen_begin_doc(xapian_snipgen_t *snipgen,
-                             unsigned int context_length __attribute__((unused)))
+                             const struct message_guid *guid, char doctype)
 {
+    struct buf buf = BUF_INITIALIZER;
+    make_cyrusid(&buf, guid, doctype);
+    snipgen->cyrusid = buf_release(&buf);
+    buf_free(&buf);
+
     buf_reset(snipgen->buf);
     return 0;
 }
 
-int xapian_snipgen_doc_part(xapian_snipgen_t *snipgen, const struct buf *part,
-		            int partnum)
+int xapian_snipgen_make_snippet(xapian_snipgen_t *snipgen,
+                                const struct buf *part,
+                                Xapian::Stem* stemmer)
 {
-    if (buf_len(snipgen->buf)) {
-        // XXX hackish: the original snippet generator passed down
-        // boundaries using termpos++. But now it's all text, so encode
-        // part gaps using the 'omit' signifier
-        buf_appendcstr(snipgen->buf, snipgen->omit);
+    int r = 0;
+    try {
+        std::string text {buf_base(part), buf_len(part)};
+        Xapian::Enquire enquire(*snipgen->memdb);
+        enquire.set_query(xapian_snipgen_build_query(snipgen, *stemmer));
+
+        unsigned flags = Xapian::MSet::SNIPPET_EXHAUSTIVE |
+                         Xapian::MSet::SNIPPET_EMPTY_WITHOUT_MATCH;
+#ifdef USE_XAPIAN_CJK_WORDS
+        flags |= Xapian::MSet::SNIPPET_CJK_WORDS;
+#endif
+
+        const std::string snippet = enquire.get_mset(0, 0).snippet(text,
+                snipgen->max_len - buf_len(snipgen->buf),
+                *stemmer, flags,
+                snipgen->hi_start,
+                snipgen->hi_end,
+                snipgen->omit);
+        if (!snippet.empty()) {
+            if (buf_len(snipgen->buf)) {
+                buf_appendoverlap(snipgen->buf, snipgen->omit);
+            }
+            buf_appendcstr(snipgen->buf, snippet.c_str());
+        }
+    } catch (const Xapian::Error &err) {
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception doc_part: %s: %s",
+                err.get_context().c_str(), err.get_description().c_str());
+        r = IMAP_IOERROR;
     }
-    buf_append(snipgen->buf, part);
-    snipgen->partnum = partnum;
-    return 0;
+    return r;
 }
 
-int xapian_snipgen_end_doc(xapian_snipgen_t *snipgen, struct buf *buf)
+int xapian_snipgen_doc_part(xapian_snipgen_t *snipgen, const struct buf *part,
+		                    int partnum)
 {
-    int r = 0;
+    // Ignore empty queries.
+    if (!snipgen->loose_terms && !snipgen->queries) return 0;
 
-    if (!snipgen->loose_terms && !snipgen->queries) {
-        buf_reset(snipgen->buf);
-        buf_reset(buf);
-        buf_cstring(buf);
-        return 0;
-    }
+    // Don't exceed allowed snippet length.
+    if (buf_len(snipgen->buf) >= snipgen->max_len) return 0;
 
-    try {
-        std::string snippet;
-        std::string text = std::string(buf_base(snipgen->buf), buf_len(snipgen->buf));
-        Xapian::Enquire enquire(*snipgen->db);
-        enquire.set_query(xapian_snipgen_build_query(snipgen));
-
-        unsigned flags = Xapian::MSet::SNIPPET_EXHAUSTIVE;
-
-#ifdef USE_XAPIAN_CYRUS_EXTENSIONS
-        flags |= Xapian::MSet::SNIPPET_EMPTY_WITHOUT_MATCH;
-        if (snipgen->partnum != SEARCH_PART_BODY) {
-            flags |= Xapian::MSet::SNIPPET_START_AT_NONSPACE;
+    // Lookup stemmer language for this document part, if any.
+    Xapian::Stem *stemmer = NULL;
+    if (snipgen->db->database && snipgen->cyrusid) {
+        std::string key = make_lang_cyrusid_key(partnum, snipgen->cyrusid);
+        for (const Xapian::Database& dbit : *snipgen->db->shards) {
+            std::string iso_lang = dbit.get_metadata(key);
+            if (!iso_lang.empty()) {
+                try {
+                    stemmer = new Xapian::Stem(iso_lang);
+                } catch (const Xapian::InvalidArgumentError &err) {
+                    syslog(LOG_INFO, "Xapian: no stemmer for language %s", iso_lang.c_str());
+                }
+                break;
+            }
         }
-#endif
+    }
+    if (!stemmer) stemmer = snipgen->default_stemmer;
 
-        snippet = enquire.get_mset(0, 0).snippet(text,
-                config_getint(IMAPOPT_SEARCH_SNIPPET_LENGTH),
-                *snipgen->stemmer,
-                flags,
-                snipgen->hi_start,
-                snipgen->hi_end,
-                snipgen->omit
-#ifdef USE_XAPIAN_CYRUS_EXTENSIONS
-                , Xapian::TermGenerator::FLAG_CJK_WORDS
-#endif
-        );
+    size_t prev_size = buf_len(snipgen->buf);
+    int r = xapian_snipgen_make_snippet(snipgen, part, stemmer);
+    if (stemmer != snipgen->default_stemmer) {
+        delete stemmer;
+        if (!r && prev_size == buf_len(snipgen->buf)) {
+            /* Using a custom stemmer did not generate a snippet.
+             * This could be because the query matched using the
+             * default stemmer, so try generating a snippet with
+             * that stemmer instead.*/
+            r = xapian_snipgen_make_snippet(snipgen, part, snipgen->default_stemmer);
+        }
+    }
 
+    return r;
+}
 
-        buf_setcstr(buf, snippet.c_str());
-        buf_cstring(buf);
+int xapian_snipgen_end_doc(xapian_snipgen_t *snipgen, struct buf *buf)
+{
+    buf_reset(buf);
+    buf_copy(buf, snipgen->buf);
+    buf_cstring(buf);
+    buf_reset(snipgen->buf);
 
-        delete snipgen->loose_terms;
-        snipgen->loose_terms = NULL;
+    delete snipgen->loose_terms;
+    snipgen->loose_terms = NULL;
 
-        delete snipgen->queries;
-        snipgen->queries = NULL;
+    delete snipgen->queries;
+    snipgen->queries = NULL;
 
-    } catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s: %s",
-                err.get_context().c_str(), err.get_description().c_str());
-        r = IMAP_IOERROR;
-    }
+    free(snipgen->cyrusid);
+    snipgen->cyrusid = NULL;
 
-    buf_reset(snipgen->buf);
-    snipgen->partnum = -1;
-    return r;
+    return 0;
 }
 
 /* cb returns true if document should be copied, false if not */
@@ -1070,36 +1441,120 @@ int xapian_filter(const char *dest, cons
                   void *rock)
 {
     int r = 0;
+    const char *thispath = "(unknown path)";
+    std::set<int> db_versions;
+    std::map<std::string, unsigned> lang_counts; // XXX: this never cleans up counts!
 
     try {
         /* create a destination database */
-        Xapian::WritableDatabase destdb = Xapian::WritableDatabase(dest, Xapian::DB_CREATE|Xapian::DB_BACKEND_GLASS);
+        Xapian::WritableDatabase destdb {dest, Xapian::DB_CREATE|Xapian::DB_BACKEND_GLASS};
 
         /* With multiple databases as above, the docids are interleaved, so it
          * might be worth trying to open each source and copy its documents to
          * destdb in turn for better locality of reference, and so better cache
          * use. -- Olly on the mailing list */
         while (*sources) {
-            Xapian::Database srcdb = Xapian::Database(*sources++);
+            thispath = *sources++;
+            const Xapian::Database srcdb {thispath};
+
+            // Aggregate db versions.
+            std::set<int> srcdb_versions = get_db_versions(srcdb);
+            db_versions.insert(srcdb_versions.begin(), srcdb_versions.end());
+
+            // Aggregate language counts across databases.
+            if (db_versions.lower_bound(5) != db_versions.end()) {
+                for (Xapian::TermIterator it = srcdb.metadata_keys_begin(XAPIAN_LANG_COUNT_KEYPREFIX);
+                        it != srcdb.metadata_keys_end(XAPIAN_LANG_COUNT_KEYPREFIX); ++it) {
+                    lang_counts[*it] += std::stol(srcdb.get_metadata(*it));
+                }
+            }
+            else lang_counts[XAPIAN_LANG_COUNT_KEYPREFIX ".en"] += srcdb.get_doccount();
 
             /* copy all matching documents to the new DB */
             for (Xapian::ValueIterator it = srcdb.valuestream_begin(SLOT_CYRUSID);
-                                       it != srcdb.valuestream_end(SLOT_CYRUSID); it++) {
-                if (cb((*it).c_str(), rock)) {
-                    destdb.add_document(srcdb.get_document(it.get_docid()));
+                                       it != srcdb.valuestream_end(SLOT_CYRUSID); ++it) {
+                const char *cyrusid = (*it).c_str();
+                if (cb(cyrusid, rock)) {
+                    /* is it already indexed? */
+                    std::string key {"cyrusid." + *it};
+                    if (destdb.get_metadata(key).empty()) {
+                        destdb.add_document(srcdb.get_document(it.get_docid()));
+                        destdb.set_metadata(key, "1");
+                    }
                 }
             }
         }
 
+        thispath = "(unknown path)";
+
+        // set the versions to match the source databases
+        set_db_versions(destdb, db_versions);
+
+        // and set the language counts (sadly, they'll all be too high)
+        for (std::pair<const std::string, unsigned>& it : lang_counts) {
+            destdb.set_metadata(it.first, std::to_string(it.second));
+        }
+
         /* commit all changes explicitly */
         destdb.commit();
     }
     catch (const Xapian::Error &err) {
-        syslog(LOG_ERR, "IOERROR: Xapian: caught exception: %s",
-               err.get_description().c_str());
+        syslog(LOG_ERR, "IOERROR: Xapian: caught exception filter: %s (%s)",
+               err.get_description().c_str(), thispath);
         r = IMAP_IOERROR;
     }
 
     return r;
 }
 
+const char *xapian_version_string()
+{
+    return Xapian::version_string();
+}
+
+struct xapian_doc {
+    Xapian::TermGenerator *termgen;
+    Xapian::Document *doc;
+};
+
+xapian_doc_t *xapian_doc_new(void)
+{
+    xapian_doc_t *doc = (xapian_doc_t *) xzmalloc(sizeof(struct xapian_doc));
+    doc->doc = new Xapian::Document;
+    doc->termgen = new Xapian::TermGenerator;
+    doc->termgen->set_document(*doc->doc);
+    return doc;
+}
+
+void xapian_doc_index_text(xapian_doc_t *doc, const char *text, size_t len)
+{
+    doc->termgen->index_text(Xapian::Utf8Iterator(text, len));
+}
+
+size_t xapian_doc_termcount(xapian_doc_t *doc)
+{
+    return doc->doc->termlist_count();
+}
+
+int xapian_doc_foreach_term(xapian_doc_t *doc, int(*cb)(const char*, void*), void *rock)
+{
+    for (Xapian::TermIterator ti = doc->doc->termlist_begin();
+            ti != doc->doc->termlist_end(); ++ti) {
+        int r = cb((*ti).c_str(), rock);
+        if (r) return r;
+    }
+    return 0;
+}
+
+void xapian_doc_reset(xapian_doc_t *doc)
+{
+    doc->doc->clear_values();
+}
+extern void xapian_doc_close(xapian_doc_t *termgen);
+
+void xapian_doc_close(xapian_doc_t *doc)
+{
+    delete doc->termgen;
+    delete doc->doc;
+    free(doc);
+}
diff -pruN 3.0.13-5/imap/xapian_wrap.h 3.2.0-3/imap/xapian_wrap.h
--- 3.0.13-5/imap/xapian_wrap.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/xapian_wrap.h	2020-05-04 03:28:02.000000000 +0000
@@ -43,44 +43,53 @@
 #ifndef __CYRUS_IMAP_XAPIAN_WRAP__
 #define __CYRUS_IMAP_XAPIAN_WRAP__
 
+#include "message_guid.h"
 #include "util.h"
 #include "strarray.h"
+#include "ptrarray.h"
 
 typedef struct xapian_dbw xapian_dbw_t;
 typedef struct xapian_db xapian_db_t;
 typedef struct xapian_query xapian_query_t;
 typedef struct xapian_snipgen xapian_snipgen_t;
+typedef struct xapian_doc xapian_doc_t;
 
 /* compaction interface */
 extern int xapian_compact_dbs(const char *dest, const char **sources);
-extern void xapian_check_if_needs_reindex(const strarray_t *sources, strarray_t *toreindex);
+extern void xapian_check_if_needs_reindex(const strarray_t *sources, strarray_t *toreindex, int always_upgrade);
 
 /* write-side interface */
-extern int xapian_dbw_open(const char **paths, xapian_dbw_t **dbwp);
+#define XAPIAN_DBW_CONVINDEXED 0
+#define XAPIAN_DBW_XAPINDEXED 1
+extern int xapian_dbw_open(const char **paths, xapian_dbw_t **dbwp, int mode);
+extern int xapian_dbw_openmem(xapian_dbw_t **dbwp);
 extern void xapian_dbw_close(xapian_dbw_t *dbw);
 extern int xapian_dbw_begin_txn(xapian_dbw_t *dbw);
 extern int xapian_dbw_commit_txn(xapian_dbw_t *dbw);
 extern int xapian_dbw_cancel_txn(xapian_dbw_t *dbw);
-extern int xapian_dbw_begin_doc(xapian_dbw_t *dbw, const char *cyrusid);
+extern int xapian_dbw_begin_doc(xapian_dbw_t *dbw, const struct message_guid *guid, char doctype);
 extern int xapian_dbw_doc_part(xapian_dbw_t *dbw, const struct buf *part, int num_part);
 extern int xapian_dbw_end_doc(xapian_dbw_t *dbw);
-extern int xapian_dbw_is_indexed(xapian_dbw_t *dbw, const char *cyrusid);
+extern int xapian_dbw_is_indexed(xapian_dbw_t *dbw, const struct message_guid *guid, char doctype);
+
 
 /* query-side interface */
 extern int xapian_db_open(const char **paths, xapian_db_t **dbp);
+extern int xapian_db_opendbw(struct xapian_dbw *dbw, xapian_db_t **dbp);
 extern void xapian_db_close(xapian_db_t *);
 extern xapian_query_t *xapian_query_new_match(const xapian_db_t *, int num_part, const char *term);
 extern xapian_query_t *xapian_query_new_compound(const xapian_db_t *, int is_or, xapian_query_t **children, int n);
+extern xapian_query_t *xapian_query_new_matchall(const xapian_db_t *);
 extern xapian_query_t *xapian_query_new_not(const xapian_db_t *, xapian_query_t *);
+extern xapian_query_t *xapian_query_new_has_doctype(const xapian_db_t *, char doctype, xapian_query_t *);
 extern void xapian_query_free(xapian_query_t *);
-extern int xapian_query_run(const xapian_db_t *, const xapian_query_t *,
-                            int (*cb)(const char *cyrusid, void *rock), void *rock);
-
+extern int xapian_query_run(const xapian_db_t *, const xapian_query_t *query, int is_legacy,
+                            int (*cb)(void *base, size_t n, void *rock), void *rock);
 /* snippets interface */
-extern xapian_snipgen_t *xapian_snipgen_new(const char *hi_start, const char *hi_end, const char *omit);
+extern xapian_snipgen_t *xapian_snipgen_new(xapian_db_t *db, const char *hi_start, const char *hi_end, const char *omit);
 extern void xapian_snipgen_free(xapian_snipgen_t *);
 extern int xapian_snipgen_add_match(xapian_snipgen_t *snipgen, const char *match);
-extern int xapian_snipgen_begin_doc(xapian_snipgen_t *snipgen, unsigned context_length);
+extern int xapian_snipgen_begin_doc(xapian_snipgen_t *snipgen, const struct message_guid *guid, char doctype);
 extern int xapian_snipgen_doc_part(xapian_snipgen_t *snipgen, const struct buf *part, int partnum);
 extern int xapian_snipgen_end_doc(xapian_snipgen_t *snipgen, struct buf *);
 
@@ -88,5 +97,21 @@ extern int xapian_snipgen_end_doc(xapian
 extern int xapian_filter(const char *dest, const char **sources,
                          int (*cb)(const char *cyrusid, void *rock),
                          void *rock);
+/* XXX legacy version 4 DB support */
+extern int xapian_db_has_legacy_v4_index(const xapian_db_t *);
+extern int xapian_db_has_otherthan_v4_index(const xapian_db_t *);
+
+/* Language indexing support */
+extern int xapian_list_lang_stats(xapian_db_t*, ptrarray_t*);
+
+/* Document interface */
+extern xapian_doc_t *xapian_doc_new(void);
+extern void xapian_doc_index_text(xapian_doc_t *doc, const char *text, size_t len);
+extern size_t xapian_doc_termcount(xapian_doc_t *doc);
+extern int xapian_doc_foreach_term(xapian_doc_t *doc, int(*cb)(const char*, void*), void *rock);
+extern void xapian_doc_reset(xapian_doc_t *doc);
+extern void xapian_doc_close(xapian_doc_t *doc);
+
+extern const char *xapian_version_string();
 
 #endif
diff -pruN 3.0.13-5/imap/xcal.c 3.2.0-3/imap/xcal.c
--- 3.0.13-5/imap/xcal.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/xcal.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,6 +50,7 @@
 #include <libxml/tree.h>
 
 #include "httpd.h"
+#include "ical_support.h"
 #include "tok.h"
 #include "util.h"
 #include "version.h"
@@ -255,11 +256,9 @@ static xmlNodePtr icalparameter_as_xml_e
         kind_string = icalparameter_get_xname(param);
         break;
 
-#ifdef HAVE_IANA_PARAMS
     case ICAL_IANA_PARAMETER:
         kind_string = icalparameter_get_iana_name(param);
         break;
-#endif
 
     default:
         kind_string = icalparameter_kind_to_string(kind);
@@ -731,7 +730,7 @@ static icalvalue *xml_element_to_icalval
                     buf_printf(vals, ",%s", (char *) content);
                 }
                 else {
-                    /* create new list with this valiue */
+                    /* create new list with this value */
                     vals = xzmalloc(sizeof(struct buf));
                     buf_setcstr(vals, (char *) content);
                     hash_insert((char *) node->name, vals, &byrules);
@@ -1094,23 +1093,44 @@ icalcomponent *xcal_string_as_icalcompon
 }
 
 
-const char *begin_xcal(struct buf *buf)
+const char *begin_xcal(struct buf *buf, struct mailbox *mailbox,
+                       const char *prodid, const char *name,
+                       const char *desc, const char *color)
 {
+    icalcomponent *ical;
+    icalproperty *prop;
+    xmlDocPtr doc;
+    xmlNodePtr props;
+    xmlBufferPtr xmlbuf;
+
+    /* Add toplevel properties */
+    ical = icalcomponent_new_stream(mailbox, prodid, name, desc, color);
+    doc = xmlNewDoc(BAD_CAST "1.0");
+    props = xmlNewNode(NULL, BAD_CAST "properties");
+    xmlDocSetRootElement(doc, props);
+
+    for (prop = icalcomponent_get_first_property(ical, ICAL_ANY_PROPERTY);
+         prop;
+         prop = icalcomponent_get_next_property(ical, ICAL_ANY_PROPERTY)) {
+
+        xmlAddChild(props, icalproperty_as_xml_element(prop));
+    }
+    icalcomponent_free(ical);
+
+
+    /* Dump XML node into buffer */
+    xmlbuf = xmlBufferCreate();
+    xmlNodeDump(xmlbuf, doc, props, 1, config_httpprettytelemetry);
+    xmlFreeDoc(doc);
+
     /* Begin xCal stream */
-    buf_reset(buf);
-    buf_printf_markup(buf, 0, "<?xml version=\"1.0\" encoding=\"utf-8\"?>");
-    buf_printf_markup(buf, 0, "<icalendar xmlns=\"%s\">", XML_NS_ICALENDAR);
-    buf_printf_markup(buf, 1, "<vcalendar>");
-    buf_printf_markup(buf, 2, "<properties>");
-    buf_printf_markup(buf, 3, "<prodid>");
-    buf_printf_markup(buf, 4, "<text>-//CyrusIMAP.org/Cyrus %s//EN</text>",
-                      cyrus_version());
-    buf_printf_markup(buf, 3, "</prodid>");
-    buf_printf_markup(buf, 3, "<version>");
-    buf_printf_markup(buf, 4, "<text>2.0</text>");
-    buf_printf_markup(buf, 3, "</version>");
-    buf_printf_markup(buf, 2, "</properties>");
-    buf_printf_markup(buf, 2, "<components>");
+    buf_setcstr(buf, "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n");
+    buf_printf(buf, "<icalendar xmlns=\"%s\">\r\n", XML_NS_ICALENDAR);
+    buf_appendcstr(buf, "<vcalendar>\r\n  ");
+    buf_appendmap(buf,
+                  (char *) xmlBufferContent(xmlbuf), xmlBufferLength(xmlbuf));
+    buf_appendcstr(buf, "\r\n<components>\r\n");
+    xmlBufferFree(xmlbuf);
 
     return "";
 }
@@ -1119,8 +1139,5 @@ const char *begin_xcal(struct buf *buf)
 void end_xcal(struct buf *buf)
 {
     /* End xCal stream */
-    buf_reset(buf);
-    buf_printf_markup(buf, 2, "</components>");
-    buf_printf_markup(buf, 1, "</vcalendar>");
-    buf_printf_markup(buf, 0, "</icalendar>");
+    buf_setcstr(buf, "\r\n</components>\r\n</vcalendars>\r\n</icalendar>");
 }
diff -pruN 3.0.13-5/imap/xcal.h 3.2.0-3/imap/xcal.h
--- 3.0.13-5/imap/xcal.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/xcal.h	2020-04-24 02:03:00.000000000 +0000
@@ -50,11 +50,6 @@
 
 #include "util.h"
 
-#ifndef HAVE_VPOLL
-/* Allow us to compile without #ifdef HAVE_VPOLL everywhere */
-#define ICAL_POLLPROPERTIES_PROPERTY  ICAL_NO_PROPERTY
-#endif
-
 #define XML_NS_ICALENDAR        "urn:ietf:params:xml:ns:icalendar-2.0"
 
 extern const char *icalproperty_value_kind_as_string(icalproperty *prop);
@@ -74,7 +69,9 @@ icalrecur_add_rule(struct icalrecurrence
 
 extern struct buf *icalcomponent_as_xcal_string(icalcomponent* comp);
 extern icalcomponent *xcal_string_as_icalcomponent(const struct buf *buf);
-extern const char *begin_xcal(struct buf *buf);
+extern const char *begin_xcal(struct buf *buf, struct mailbox *mailbox,
+                              const char *prodid, const char *name,
+                              const char *desc, const char *color);
 extern void end_xcal(struct buf *buf);
 
 #endif /* XCAL_H */
diff -pruN 3.0.13-5/imap/xstats_metrics.h 3.2.0-3/imap/xstats_metrics.h
--- 3.0.13-5/imap/xstats_metrics.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/xstats_metrics.h	2020-04-24 02:03:00.000000000 +0000
@@ -51,12 +51,3 @@ X(SEARCH_CACHE_HEADER),
 X(SEARCH_BODY),
 X(SEARCH_TRIVIAL),
 X(SEARCH_RESULT),
-X(SPHINX_MULTIPLE),
-X(SPHINX_SINGLE),
-X(SPHINX_MATCH),
-X(SPHINX_CONNECT),
-X(SPHINX_CLOSE),
-X(SPHINX_QUERY),
-X(SPHINX_ROW),
-X(SPHINX_RESULT),
-X(SPHINX_UNINDEXED),
diff -pruN 3.0.13-5/imap/zoneinfo_db.c 3.2.0-3/imap/zoneinfo_db.c
--- 3.0.13-5/imap/zoneinfo_db.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/zoneinfo_db.c	2020-04-24 02:03:00.000000000 +0000
@@ -51,11 +51,11 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "assert.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "global.h"
 #include "tok.h"
 #include "util.h"
diff -pruN 3.0.13-5/imap/zoneinfo_db.h 3.2.0-3/imap/zoneinfo_db.h
--- 3.0.13-5/imap/zoneinfo_db.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imap/zoneinfo_db.h	2020-04-24 02:03:00.000000000 +0000
@@ -48,9 +48,6 @@
 
 #include "annotate.h" /* for strlist functionality */
 
-/* name of the zoneinfo directory */
-#define FNAME_ZONEINFODIR "/zoneinfo"
-
 /* name of the NIST leap seconds file (provided with IANA tzdata) */
 #define FNAME_LEAPSECFILE "/leap-seconds.list"
 
diff -pruN 3.0.13-5/imtest/imtest.c 3.2.0-3/imtest/imtest.c
--- 3.0.13-5/imtest/imtest.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/imtest/imtest.c	2020-04-24 02:03:00.000000000 +0000
@@ -144,7 +144,11 @@ static sasl_callback_t callbacks[] = {
     }, {
         SASL_CB_PASS, NULL, NULL
     }, {
-      SASL_CB_GETOPT, (int (*)(void))&mysasl_config, NULL
+#if GCC_VERSION >= 80000
+        SASL_CB_GETOPT, (void*)&mysasl_config, NULL
+#else
+        SASL_CB_GETOPT, (int (*)(void))&mysasl_config, NULL
+#endif
     }, {
         SASL_CB_LIST_END, NULL, NULL
     }
@@ -167,7 +171,7 @@ struct capa_cmd_t {
     char *auth;         /* [OPTIONAL] AUTH (SASL) capability string */
     char *compress;     /* [OPTIONAL] COMPRESS capability string */
     void (*parse_mechlist)(struct buf *list, const char *str,
-                           struct protocol_t *prot, unsigned long *capabilties);
+                           struct protocol_t *prot, unsigned long *capabilities);
                         /* [OPTIONAL] parse capability string,
                            returns space-separated list of mechs */
 };
@@ -222,6 +226,7 @@ struct protocol_t {
                         /* [OPTIONAL] perform protocol-specific authentication;
                            based on rock, login_enabled, mech, mechlist */
     struct logout_cmd_t logout_cmd;
+    char *unauth_cmd;
 
     /* these 3 are used for maintaining connection state */
     void *(*init_conn)(void); /* generate a context (if needed). This context
@@ -239,8 +244,9 @@ struct protocol_t {
 };
 
 
-static void imtest_fatal(const char *msg, ...) __attribute__((noreturn));
-static void imtest_fatal(const char *msg, ...)
+static void
+__attribute__((noreturn, format(printf, 1, 2)))
+imtest_fatal(const char *msg, ...)
 {
     struct stat sbuf;
     if (output_socket && output_socket_opened &&
@@ -262,7 +268,7 @@ static void imtest_fatal(const char *msg
 /* libcyrus makes us define this */
 EXPORTED void fatal(const char *msg, int code __attribute__((unused)))
 {
-    imtest_fatal(msg);
+    imtest_fatal("%s", msg);
 }
 
 int mysasl_config(void *context __attribute__((unused)),
@@ -758,7 +764,7 @@ static void do_starttls(int ssl, char *k
                 imtest_fatal("TLS negotiation failed!\n");
         }
 
-    /* TLS negotiation suceeded */
+    /* TLS negotiation succeeded */
     tls_sess = SSL_get_session(tls_conn); /* Save the session for reuse */
 
     /* tell SASL about the negotiated layer */
@@ -774,6 +780,27 @@ static void do_starttls(int ssl, char *k
     if (result!=SASL_OK)
         imtest_fatal("Error setting SASL property (external auth_id)");
 
+#if (OPENSSL_VERSION_NUMBER >= 0x0090800fL)
+    static unsigned char finished[EVP_MAX_MD_SIZE];
+    static struct sasl_channel_binding cbinding;
+
+    if (SSL_session_reused(tls_conn)) {
+        cbinding.len = SSL_get_peer_finished(tls_conn,
+                                             finished, sizeof(finished));
+    }
+    else {
+        cbinding.len = SSL_get_finished(tls_conn, finished, sizeof(finished));
+    }
+
+    cbinding.name = "tls-unique";
+    cbinding.critical = 0;
+    cbinding.data = finished;
+
+    result = sasl_setprop(conn, SASL_CHANNEL_BINDING, &cbinding);
+    if (result!=SASL_OK)
+        imtest_fatal("Error setting SASL property (channel binding)");
+#endif /* (OPENSSL_VERSION_NUMBER >= 0x0090800fL) */
+
     prot_settls (pin,  tls_conn);
     prot_settls (pout, tls_conn);
 }
@@ -825,6 +852,10 @@ static int init_sasl(char *service, char
 
 
     /* client new connection */
+#if defined(SASL_NEED_HTTP) && defined(SASL_HTTP_REQUEST)
+    if (!strcasecmp(service, "HTTP")) flags |= SASL_NEED_HTTP;
+#endif
+
     saslresult=sasl_client_new(service,
                                serverFQDN,
                                localip,
@@ -1323,6 +1354,7 @@ static void interactive(struct protocol_
     signal(SIGINT, sigint_handler);
 
     /* loop reading from network and from stdin as applicable */
+    int unauth = 0;
     while (1) {
         rset = read_set;
         wset = write_set;
@@ -1352,6 +1384,14 @@ static void interactive(struct protocol_
                     count++;
                 }
                 prot_write(pout, buf, count);
+
+                if (protocol->unauth_cmd) {
+                    /* Check if unauthenticate command was sent */
+                    char *p = stristr(buf, protocol->unauth_cmd);
+
+                    if (p && !strcmp("\r\n", p + strlen(protocol->unauth_cmd)))
+                        unauth = 1;
+                }
             }
             prot_flush(pout);
         } else if (FD_ISSET(sock, &rset) && (FD_ISSET(fd_out, &wset))) {
@@ -1378,6 +1418,23 @@ static void interactive(struct protocol_
                     buf[count] = '\0';
                     printf("%s", buf);
                 }
+
+                if (unauth) {
+                    /* Reset auth and connection state (other than TLS) */
+                    sasl_dispose(&conn);
+                    if (init_sasl(protocol->service, NULL,
+                                  0, 128, 0) != IMTEST_OK) {
+                        imtest_fatal("SASL initialization");
+                    }
+                    unauth = 0;
+
+#ifdef HAVE_ZLIB
+                    prot_unsetcompress(pout);
+                    prot_unsetcompress(pin);
+#endif
+                    prot_unsetsasl(pout);
+                    prot_unsetsasl(pin);
+                }
             } while (haveinput(pin) > 0);
         } else if ((FD_ISSET(fd, &rset)) && (FD_ISSET(sock, &wset))
                    && (donewritingfile == 0)) {
@@ -2357,15 +2414,25 @@ static int auth_http_sasl(const char *se
     int saslresult;
     const char *out = NULL;
     unsigned int outlen = 0;
-    char *in;
+    char *in, *sid = NULL;
     int inlen;
     const char *mechusing;
     char buf[BASE64_BUF_SIZE+1], *base64 = buf;
-    int initial_response = 1, do_base64 = 1;
+    int initial_response = 1, do_base64 = 1, use_params = 0;;
     imt_stat status;
     char *username;
     unsigned int userlen;
 
+#ifdef SASL_HTTP_REQUEST
+    /* Set HTTP request (REQUIRED) */
+    sasl_http_request_t httpreq = { "OPTIONS",      /* Method */
+                                    "*",            /* URI */
+                                    (u_char *) "",  /* Empty body */
+                                    0,              /* Zero-length body */
+                                    1 };            /* Persistent cxn? */
+    sasl_setprop(conn, SASL_HTTP_REQUEST, &httpreq);
+#endif
+
     interaction(SASL_CB_USER, NULL, "Username", &username, &userlen);
 
     do { /* start authentication */
@@ -2387,6 +2454,9 @@ static int auth_http_sasl(const char *se
     else if (!strcmp(mechusing, "GSS-SPNEGO")) {
         mechusing = "Negotiate";
     }
+    else if (!strncmp(mechusing, "SCRAM-", 6)) {
+        use_params = 1;
+    }
 
     do {
         /* build the auth command */
@@ -2420,6 +2490,14 @@ static int auth_http_sasl(const char *se
                 }
 
                 /* send response to server */
+                if (use_params) {
+                    if (sid) {
+                        printf("sid=%s,", sid);
+                        prot_printf(pout, "sid=%s,", sid);
+                    }
+                    printf("data=");
+                    prot_puts(pout, "data=");
+                }
                 printf("%.*s", outlen, out);
                 prot_write(pout, out, outlen);
             }
@@ -2465,7 +2543,60 @@ static int auth_http_sasl(const char *se
                     !strncmp(scheme, mechusing, len)) {
                     in = scheme + len;
                     while (strchr(" \t", *++in)); /* trim optional whitespace */
-                    inlen = strcspn(in, "\r\n");  /* end of challenge */
+
+                    if (use_params) {
+                        /* Parse parameters */
+                        const char *token = in;
+
+                        in = NULL;
+                        while (token && *token) {
+                            size_t tok_len, val_len;
+                            char *value;
+
+                            /* Trim leading and trailing BWS */
+                            while (strchr(", \t", *token)) token++;
+                            tok_len = strcspn(token, "= \t");
+
+                            /* Find value */
+                            value = strchr(token + tok_len, '=');
+                            if (!value) {
+                                printf("Missing value for '%.*s'"
+                                       " parameter in challenge\n",
+                                       (int) tok_len, token);
+                                return IMTEST_FAIL;
+                            }
+
+                            /* Trim leading and trailing BWS */
+                            while (strchr(" \t", *++value));
+                            val_len = strcspn(value, ", \t");
+
+                            /* Check known parameters */
+                            if (!strncmp("sid", token, tok_len)) {
+                                if (!sid) sid = xstrndup(value, val_len);
+                                else if (val_len != strlen(sid) ||
+                                         strncmp(sid, value, val_len)) {
+                                    printf("Incorrect session ID parameter\n");
+                                    return IMTEST_FAIL;
+                                }
+                            }
+                            else if (!strncmp("data", token, tok_len)) {
+                                in = value;
+                                inlen = val_len;
+                            }
+
+                            /* Find next token */
+                            token = strchr(value + val_len, ',');
+                        }
+                        if (!in) {
+                            printf("Missing 'data' parameter in challenge\n");
+                            return IMTEST_FAIL;
+                        }
+                    }
+                    else {
+                        /* token68 */
+                        inlen = strcspn(in, " \t\r\n");  /* end of challenge */
+                    }
+
                     in = xstrndup(in, inlen);
                 }
             }
@@ -2505,6 +2636,8 @@ static int auth_http_sasl(const char *se
         }
     } while (out);
 
+    free(sid);
+
     return (status == STAT_OK) ? IMTEST_OK : IMTEST_FAIL;
 }
 
@@ -2515,18 +2648,23 @@ static int http_do_auth(struct sasl_cmd_
     int result = IMTEST_OK;
 
     if (mech) {
-        if (!strcasecmp(mech, "basic")) {
+        if (!strcasecmp(mech, "basic") || !strcasecmp(mech, "plain")) {
             if (!basic_enabled) {
                 printf("[Server did not advertise HTTP Basic]\n");
                 result = IMTEST_FAIL;
             } else {
                 result = auth_http_basic(servername);
             }
-        } else if (!mechlist || !stristr(mechlist, mech)) {
-            printf("[Server did not advertise HTTP %s]\n", ucase(mech));
-            result = IMTEST_FAIL;
         } else {
-            result = auth_http_sasl(servername, mech);
+            if (!strcasecmp(mech, "digest")) mech = "DIGEST-MD5";
+            else if (!strcasecmp(mech, "negotiate")) mech = "GSS-SPNEGO";
+
+            if (!mechlist || !stristr(mechlist, mech)) {
+                printf("[Server did not advertise HTTP %s]\n", ucase(mech));
+                result = IMTEST_FAIL;
+            } else {
+                result = auth_http_sasl(servername, mech);
+            }
         }
     } else {
         if (mechlist) {
@@ -2562,7 +2700,7 @@ static void usage(char *prog, char *prot
     else if (!strcasecmp(prot, "nntp"))
         printf("             (\"user\" for AUTHINFO USER/PASS\n");
     else if (!strcasecmp(prot, "http"))
-        printf("             (\"basic\" for HTTP Basic\n");
+        printf("             (\"basic\", \"digest\", \"negotiate\", \"ntlm\")\n");
     printf("  -f file  : pipe file into connection after authentication\n");
     printf("  -r realm : realm\n");
 #ifdef HAVE_SSL
@@ -2585,7 +2723,7 @@ static void usage(char *prog, char *prot
     printf("  -n       : number of auth attempts (default=1)\n");
     printf("  -I file  : output my PID to (file) (useful with -X)\n");
     printf("  -x file  : open the named socket for the interactive portion\n");
-    printf("  -X file  : same as -X, except close all file descriptors & dameonize\n");
+    printf("  -X file  : same as -X, except close all file descriptors & daemonize\n");
 
     exit(1);
 }
@@ -2600,7 +2738,7 @@ static struct protocol_t protocols[] = {
       { "A01 AUTHENTICATE", 0,  /* no init resp until SASL-IR advertised */
         0, "A01 OK", "A01 NO", "+ ", "*", NULL, 0 },
       { "Z01 COMPRESS DEFLATE", "Z01 OK", "Z01 NO" },
-      &imap_do_auth, { "Q01 LOGOUT", "Q01 " },
+      &imap_do_auth, { "Q01 LOGOUT", "Q01 " }, " UNAUTHENTICATE",
       &imap_init_conn, &generic_pipe, &imap_reset
     },
     { "pop3", "pop3s", "pop", 0,   /* USER unavailable until advertised */
@@ -2609,7 +2747,7 @@ static struct protocol_t protocols[] = {
       { "STLS", "+OK", "-ERR", 0 },
       { "AUTH", 255, 0, "+OK", "-ERR", "+ ", "*", NULL, 0 },
       { NULL, NULL, NULL, },
-      &pop3_do_auth, { "QUIT", "+OK" }, NULL, NULL, NULL
+      &pop3_do_auth, { "QUIT", "+OK" }, NULL, NULL, NULL, NULL
     },
     { "nntp", "nntps", "nntp", 0,  /* AUTHINFO USER unavail until advertised */
       { 0, "20", NULL },
@@ -2619,7 +2757,7 @@ static struct protocol_t protocols[] = {
       { "AUTHINFO SASL", 512, 0, "28", "48", "383 ", "*",
         &nntp_parse_success, 0 },
       { "COMPRESS DEFLATE", "206", "403", },
-      &nntp_do_auth, { "QUIT", "205" }, NULL, NULL, NULL
+      &nntp_do_auth, { "QUIT", "205" }, NULL, NULL, NULL, NULL
     },
     { "lmtp", NULL, "lmtp", 0,
       { 0, "220 ", NULL },
@@ -2627,7 +2765,7 @@ static struct protocol_t protocols[] = {
       { "STARTTLS", "220", "454", 0 },
       { "AUTH", 512, 0, "235", "5", "334 ", "*", NULL, 0 },
       { NULL, NULL, NULL, },
-      &xmtp_do_auth, { "QUIT", "221" },
+      &xmtp_do_auth, { "QUIT", "221" }, NULL,
       &xmtp_init_conn, &generic_pipe, &xmtp_reset
     },
     { "smtp", "smtps", "smtp", 0,
@@ -2636,7 +2774,7 @@ static struct protocol_t protocols[] = {
       { "STARTTLS", "220", "454", 0 },
       { "AUTH", 512, 0, "235", "5", "334 ", "*", NULL, 0 },
       { NULL, NULL, NULL, },
-      &xmtp_do_auth, { "QUIT", "221" },
+      &xmtp_do_auth, { "QUIT", "221" }, NULL,
       &xmtp_init_conn, &generic_pipe, &xmtp_reset
     },
     { "mupdate", NULL, "mupdate", 0,
@@ -2645,7 +2783,7 @@ static struct protocol_t protocols[] = {
       { "S01 STARTTLS", "S01 OK", "S01 NO", 1 },
       { "A01 AUTHENTICATE", USHRT_MAX, 1, "A01 OK", "A01 NO", "", "*", NULL, 0 },
       { "Z01 COMPRESS \"DEFLATE\"", "Z01 OK", "Z01 NO" },
-      NULL, { "Q01 LOGOUT", "Q01 " }, NULL, NULL, NULL
+      NULL, { "Q01 LOGOUT", "Q01 " }, NULL, NULL, NULL, NULL
     },
     { "sieve", NULL, SIEVE_SERVICE_NAME, 0,
       { 1, "OK", NULL },
@@ -2654,7 +2792,7 @@ static struct protocol_t protocols[] = {
       { "AUTHENTICATE", USHRT_MAX, 1, "OK", "NO", NULL, "*",
         &sieve_parse_success, 1 },
       { NULL, NULL, NULL, },
-      NULL, { "LOGOUT", "OK" }, NULL, NULL, NULL
+      NULL, { "LOGOUT", "OK" }, "UNAUTHENTICATE", NULL, NULL, NULL
     },
     { "csync", NULL, "csync", 0,
       { 1, "* OK", NULL },
@@ -2662,7 +2800,7 @@ static struct protocol_t protocols[] = {
       { "STARTTLS", "OK", "NO", 1 },
       { "AUTHENTICATE", USHRT_MAX, 0, "OK", "NO", "+ ", "*", NULL, 0 },
       { "COMPRESS DEFLATE", "OK", "NO" },
-      NULL, { "EXIT", "OK" }, NULL, NULL, NULL
+      NULL, { "EXIT", "OK" }, NULL, NULL, NULL, NULL
     },
     { "http", "https", "HTTP", 0,  /* Basic unavail until advertised */
       { 0, NULL, NULL },
@@ -2671,7 +2809,7 @@ static struct protocol_t protocols[] = {
       { HTTP_STARTTLS, HTTP_101, HTTP_5xx, 1 },
       { NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 0 },
       { NULL, NULL, NULL, },
-      &http_do_auth, { NULL, NULL }, NULL, NULL, NULL
+      &http_do_auth, { NULL, NULL }, NULL, NULL, NULL, NULL
     },
     { NULL, NULL, NULL, 0,
       { 0, NULL, NULL },
@@ -2679,7 +2817,7 @@ static struct protocol_t protocols[] = {
       { NULL, NULL, NULL, 0 },
       { NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 0 },
       { NULL, NULL, NULL, },
-      NULL, { NULL, NULL }, NULL, NULL, NULL
+      NULL, { NULL, NULL }, NULL, NULL, NULL, NULL
     }
 };
 
@@ -2928,6 +3066,8 @@ int main(int argc, char **argv)
 
     conn = NULL;
     do {
+        unsigned flags = 0;
+
         if (conn) {
             /* send LOGOUT */
             logout(&protocol->logout_cmd, 1);
@@ -2954,9 +3094,11 @@ int main(int argc, char **argv)
                          servername, port);
         }
 
-        if (init_sasl(protocol->service, servername, minssf, maxssf,
-                      protocol->sasl_cmd.parse_success ?
-                      SASL_SUCCESS_DATA : 0) != IMTEST_OK) {
+        if (username && strcmpnull(authname, username)) flags += SASL_NEED_PROXY;
+        if (protocol->sasl_cmd.parse_success) flags += SASL_SUCCESS_DATA;
+
+        if (init_sasl(protocol->service, servername,
+                      minssf, maxssf, flags) != IMTEST_OK) {
             imtest_fatal("SASL initialization");
         }
 
diff -pruN 3.0.13-5/lib/arrayu64.c 3.2.0-3/lib/arrayu64.c
--- 3.0.13-5/lib/arrayu64.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/arrayu64.c	2020-05-04 03:28:02.000000000 +0000
@@ -117,7 +117,7 @@ static inline int adjust_index_rw(arrayu
          * outside the current bounds, plus perhaps @grow */
         ensure_alloc(au, idx+grow);
     } else if (idx < 0) {
-        /* adjust Perl-style negative indeces */
+        /* adjust Perl-style negative indices */
         idx += au->count;
         if (idx >= 0 && grow)
             ensure_alloc(au, au->count+grow);
@@ -246,8 +246,8 @@ EXPORTED uint64_t arrayu64_max(const arr
 
 static int _numeric_sort(const void *a, const void *b)
 {
-    uint64_t *av = (uint64_t *)a;
-    uint64_t *bv = (uint64_t *)b;
+    uint64_t av = *((uint64_t *)a);
+    uint64_t bv = *((uint64_t *)b);
 
     if (av == bv)
         return 0;
diff -pruN 3.0.13-5/lib/assert.c 3.2.0-3/lib/assert.c
--- 3.0.13-5/lib/assert.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/assert.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,9 +42,9 @@
 
 #include <config.h>
 #include <stdio.h>
+#include <sysexits.h>
 
 #include "xmalloc.h"
-#include "exitcodes.h"
 #include "assert.h"
 
 EXPORTED void
@@ -54,5 +54,5 @@ assertionfailed(const char *file, int li
 
     snprintf(buf, sizeof(buf), "Internal error: assertion failed: %s: %d%s%s",
             file, line, expr ? ": " : "", expr ? expr : "");
-    fatal(buf, EC_SOFTWARE);
+    fatal(buf, EX_SOFTWARE);
 }
diff -pruN 3.0.13-5/lib/auth.c 3.2.0-3/lib/auth.c
--- 3.0.13-5/lib/auth.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,9 +42,9 @@
 #include <config.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 
 #include "auth.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "xmalloc.h"
 
@@ -77,7 +77,7 @@ static struct auth_mech *auth_fromname(v
         char errbuf[1024];
         snprintf(errbuf, sizeof(errbuf),
                  "Authorization mechanism %s not supported", name);
-        fatal(errbuf, EC_CONFIG);
+        fatal(errbuf, EX_CONFIG);
     }
 
     return auth;
@@ -110,3 +110,10 @@ EXPORTED void auth_freestate(struct auth
 
     if (auth_state) auth->freestate(auth_state);
 }
+
+EXPORTED strarray_t *auth_groups(const struct auth_state *auth_state)
+{
+    struct auth_mech *auth = auth_fromname();
+
+    return auth->groups(auth_state);
+}
diff -pruN 3.0.13-5/lib/auth.h 3.2.0-3/lib/auth.h
--- 3.0.13-5/lib/auth.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,6 +43,8 @@
 #ifndef INCLUDED_AUTH_H
 #define INCLUDED_AUTH_H
 
+#include "lib/strarray.h"
+
 struct auth_state;
 
 struct auth_mech {
@@ -53,6 +55,7 @@ struct auth_mech {
              const char *identifier);
     struct auth_state *(*newstate)(const char *identifier);
     void (*freestate)(struct auth_state *auth_state);
+    strarray_t *(*groups)(const struct auth_state *auth_state);
 };
 
 extern struct auth_mech *auth_mechs[];
@@ -75,5 +78,6 @@ int auth_memberof(const struct auth_stat
          const char *identifier);
 struct auth_state *auth_newstate(const char *identifier);
 void auth_freestate(struct auth_state *auth_state);
+strarray_t *auth_groups(const struct auth_state *auth_state);
 
 #endif /* INCLUDED_AUTH_H */
diff -pruN 3.0.13-5/lib/auth_krb5.c 3.2.0-3/lib/auth_krb5.c
--- 3.0.13-5/lib/auth_krb5.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth_krb5.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,9 +42,10 @@
 
 #include <config.h>
 #include <stdlib.h>
+#include <sysexits.h>
+#include <syslog.h>
 
 #include "auth.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 
 #ifdef HAVE_GSSAPI_H
@@ -196,13 +197,19 @@ static void myfreestate(struct auth_stat
     free(auth_state);
 }
 
+static strarray_t *mygroups(const struct auth_state *auth_state __attribute__((unused)))
+{
+    syslog(LOG_WARNING, "Authentication mechanism (krb) does not support groups");
+    return NULL;
+}
+
 #else /* HAVE_GSSAPI_H */
 
 static int mymemberof(
     const struct auth_state *auth_state __attribute__((unused)),
     const char *identifier __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb5) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb5) not compiled in", EX_CONFIG);
         return 0;
 }
 
@@ -210,21 +217,27 @@ static const char *mycanonifyid(
     const char *identifier __attribute__((unused)),
     size_t len __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb5) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb5) not compiled in", EX_CONFIG);
         return NULL;
 }
 
 static struct auth_state *mynewstate(
     const char *identifier __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb5) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb5) not compiled in", EX_CONFIG);
         return NULL;
 }
 
 static void myfreestate(
     struct auth_state *auth_state __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb5) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb5) not compiled in", EX_CONFIG);
+}
+
+static strarray_t *mygroups(
+    const struct auth_state *auth_state __attribute__((unused)))
+{
+        fatal("Authentication mechanism (krb5) not compiled in", EX_CONFIG);
 }
 
 #endif
@@ -237,4 +250,5 @@ HIDDEN struct auth_mech auth_krb5 =
     &mymemberof,
     &mynewstate,
     &myfreestate,
+    &mygroups,
 };
diff -pruN 3.0.13-5/lib/auth_krb.c 3.2.0-3/lib/auth_krb.c
--- 3.0.13-5/lib/auth_krb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth_krb.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,9 +42,9 @@
 
 #include <config.h>
 #include <stdlib.h>
+#include <sysexits.h>
 
 #include "auth.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 #include "util.h"
 
@@ -330,13 +330,73 @@ static void myfreestate(struct auth_stat
     free((char *)auth_state);
 }
 
+static char *make_krb_wildcard(const char *aname, const char *inst, const char *realm)
+{
+    return strconcat(
+        (aname ? aname : "*"),
+        ".",
+        (inst ? inst : "*"),
+        "@",
+        (realm ? realm : "*"),
+        NULL
+    );
+}
+
+/* KRB4 groups are just principals with wildcarded components.
+ * XXX This hasn't even been so much as compile-tested for lack of
+ * a kerberos test environment!  If you use this, please provide
+ * feedback.
+ */
+static strarray_t *mygroups(const struct auth_state *auth_state)
+{
+    strarray_t *sa = strarray_new();
+    char *tmp = NULL;
+
+    /* *.*@* */
+    tmp = make_krb_wildcard(NULL, NULL, NULL);
+    strarray_appendm(sa, tmp);
+
+    /* *.*@realm */
+    if (auth_state->realm) {
+        tmp = make_krb_wildcard(NULL, NULL, auth_state->realm);
+        strarray_appendm(sa, tmp);
+    }
+
+    /* *.inst@* */
+    if (auth_state->inst) {
+        tmp = make_krb_wildcard(NULL, auth_state->inst, NULL);
+        strarray_appendm(sa, tmp);
+        if (auth_state->realm) {
+            tmp = make_krb_wildcard(NULL, auth_state->inst, auth_state->realm);
+            strarray_appendm(sa, tmp);
+        }
+    }
+
+    /* aname.*@* */
+    if (auth_state->aname) {
+        tmp = make_krb_wildcard(auth_state->aname, NULL, NULL);
+        strarray_appendm(sa, tmp);
+        if (auth_state->realm) {
+            tmp = make_krb_wildcard(auth_state->aname, NULL, auth_state->realm);
+            strarray_appendm(sa, tmp);
+        }
+        if (auth_state->inst) {
+            tmp = make_krb_wildcard(auth_state->aname, auth_state->inst, NULL);
+            strarray_appendm(sa, tmp);
+        }
+        /* n.b. non-wildcard "aname.inst@realm" is NOT a group! */
+    }
+
+    return sa;
+}
+
 #else /* HAVE_KRB */
 
 static int mymemberof(
     const struct auth_state *auth_state __attribute__((unused)),
     const char *identifier __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb) not compiled in", EX_CONFIG);
         return 0;
 }
 
@@ -344,21 +404,27 @@ static const char *mycanonifyid(
     const char *identifier __attribute__((unused)),
     size_t len __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb) not compiled in", EX_CONFIG);
         return NULL;
 }
 
 static struct auth_state *mynewstate(
     const char *identifier __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb) not compiled in", EX_CONFIG);
         return NULL;
 }
 
 static void myfreestate(
     struct auth_state *auth_state __attribute__((unused)))
 {
-        fatal("Authentication mechanism (krb) not compiled in", EC_CONFIG);
+        fatal("Authentication mechanism (krb) not compiled in", EX_CONFIG);
+}
+
+static strarray_t *mygroups(
+    const struct auth_state *auth_state __attribute__((unused)))
+{
+        fatal("Authentication mechanism (krb) not compiled in", EX_CONFIG);
 }
 
 #endif
@@ -371,4 +437,5 @@ HIDDEN struct auth_mech auth_krb =
     &mymemberof,
     &mynewstate,
     &myfreestate,
+    &mygroups,
 };
diff -pruN 3.0.13-5/lib/auth_pts.c 3.2.0-3/lib/auth_pts.c
--- 3.0.13-5/lib/auth_pts.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth_pts.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <errno.h>
 #include <sys/types.h>
@@ -55,7 +56,6 @@
 
 #include "auth_pts.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "retry.h"
 #include "strhash.h"
@@ -352,7 +352,7 @@ static int ptload(const char *identifier
     }
 
     if(!state || *state) {
-        fatal("bad state pointer passed to ptload()", EC_TEMPFAIL);
+        fatal("bad state pointer passed to ptload()", EX_TEMPFAIL);
     }
 
     fname = libcyrus_config_getstring(CYRUSOPT_PTSCACHE_DB_PATH);
@@ -364,7 +364,7 @@ static int ptload(const char *identifier
     r = cyrusdb_open(the_ptscache_db, fname, CYRUSDB_CREATE, &ptdb);
     if (r != 0) {
         syslog(LOG_ERR, "DBERROR: opening %s: %s", fname,
-               cyrusdb_strerror(ret));
+               cyrusdb_strerror(r));
         free(tofree);
         *state = NULL;
         return -1;
@@ -390,7 +390,7 @@ static int ptload(const char *identifier
         goto done;
     }
 
-    /* if it's expired (or nonexistant),
+    /* if it's expired (or nonexistent),
      * ask the ptloader to reload it and reread it */
     fetched = (struct auth_state *) data;
 
@@ -434,7 +434,7 @@ static int ptload(const char *identifier
 
     memset((char *)&srvaddr, 0, sizeof(srvaddr));
     srvaddr.sun_family = AF_UNIX;
-    strcpy(srvaddr.sun_path, fname);
+    strlcpy(srvaddr.sun_path, fname, sizeof(srvaddr.sun_path));
     r = nb_connect(s, (struct sockaddr *)&srvaddr, sizeof(srvaddr), PT_TIMEOUT_SEC);
     free(tofree);
 
@@ -469,6 +469,7 @@ static int ptload(const char *identifier
       if (n < 1) break;
       start += n;
     }
+    response[sizeof(response)-1] = '\0';
 
     close(s);
     syslog(LOG_DEBUG, "ptload read data back");
@@ -523,6 +524,23 @@ static void myfreestate(struct auth_stat
     free(auth_state);
 }
 
+static strarray_t *mygroups(const struct auth_state *auth_state)
+{
+    strarray_t *sa;
+    int i;
+
+    if (!auth_state->ngroups)
+        return NULL;
+
+    sa = strarray_new();
+    strarray_truncate(sa, auth_state->ngroups);
+    for (i = 0; i < auth_state->ngroups; i++) {
+        strarray_append(sa, auth_state->groups[i].id);
+    }
+
+    return sa;
+}
+
 HIDDEN struct auth_mech auth_pts =
 {
     "pts",              /* name */
@@ -531,4 +549,5 @@ HIDDEN struct auth_mech auth_pts =
     &mymemberof,
     &mynewstate,
     &myfreestate,
+    &mygroups,
 };
diff -pruN 3.0.13-5/lib/auth_unix.c 3.2.0-3/lib/auth_unix.c
--- 3.0.13-5/lib/auth_unix.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/auth_unix.c	2020-04-24 02:03:00.000000000 +0000
@@ -236,7 +236,7 @@ static struct auth_state *mynewstate(con
         groupids = (gid_t *)xrealloc((gid_t *)groupids,
                                      ngroups * sizeof(gid_t));
 
-        oldngroups = ngroups; /* copy of ngroups for comparision */
+        oldngroups = ngroups; /* copy of ngroups for comparison */
         ret = getgrouplist(identifier, gid, groupids, &ngroups);
         /*
          * This is tricky. We do this as long as getgrouplist tells us to
@@ -280,6 +280,10 @@ static void myfreestate(struct auth_stat
     free(auth_state);
 }
 
+static strarray_t *mygroups(const struct auth_state *auth_state)
+{
+    return strarray_dup(&auth_state->groups);
+}
 
 HIDDEN struct auth_mech auth_unix =
 {
@@ -289,4 +293,5 @@ HIDDEN struct auth_mech auth_unix =
     &mymemberof,
     &mynewstate,
     &myfreestate,
+    &mygroups,
 };
diff -pruN 3.0.13-5/lib/bitvector.c 3.2.0-3/lib/bitvector.c
--- 3.0.13-5/lib/bitvector.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/bitvector.c	2020-04-24 02:03:00.000000000 +0000
@@ -145,11 +145,11 @@ EXPORTED void bv_andeq(bitvector_t *a, c
     bv_ensure(a, b->length);
     if (!a->length)
         return;
-    n = vlen(b->length+1);
-    for (i = 0 ; i <= n ; i++)
+    n = vlen(b->length);
+    for (i = 0; i < n; i++)
         a->bits[i] &= b->bits[i];
     n = vlen(a->length);
-    for ( ; i <= n ; i++)
+    for ( ; i < n ; i++)
         a->bits[i] = 0;
     a->length = MAX(a->length, b->length);
 }
@@ -160,8 +160,8 @@ EXPORTED void bv_oreq(bitvector_t *a, co
     unsigned int i;
 
     bv_ensure(a, b->length);
-    n = vlen(b->length+1);
-    for (i = 0 ; i <= n ; i++)
+    n = vlen(b->length);
+    for (i = 0 ; i < n ; i++)
         a->bits[i] |= b->bits[i];
     a->length = MAX(a->length, b->length);
 }
@@ -299,7 +299,7 @@ EXPORTED char *bv_cstring(const bitvecto
     return buf_release(&buf);
 }
 
-EXPORTED void bv_free(bitvector_t *bv)
+EXPORTED void bv_fini(bitvector_t *bv)
 {
     if (bv->alloc)
         free(bv->bits);
diff -pruN 3.0.13-5/lib/bitvector.h 3.2.0-3/lib/bitvector.h
--- 3.0.13-5/lib/bitvector.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/bitvector.h	2020-04-24 02:03:00.000000000 +0000
@@ -77,6 +77,6 @@ extern int bv_first_set(const bitvector_
 extern int bv_last_set(const bitvector_t *);
 extern unsigned bv_count(const bitvector_t *);
 extern char *bv_cstring(const bitvector_t *);
-extern void bv_free(bitvector_t *);
+extern void bv_fini(bitvector_t *);
 
 #endif /* __CYRUS_LIB_BITVECTOR_H__ */
diff -pruN 3.0.13-5/lib/bsearch.c 3.2.0-3/lib/bsearch.c
--- 3.0.13-5/lib/bsearch.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/bsearch.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,18 +47,16 @@
 #include "util.h"
 
 /* Case-dependent comparison converter.
- * Treats \t and \n as end-of-string and treats '.' lower than
+ * Treats \r and \t as end-of-string and treats '.' lower than
  * everything else.
  */
 #define TOCOMPARE(c) (convert_to_compare[(unsigned char)(c)])
 static unsigned char convert_to_compare[256] = {
     0x00, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
-/*        \t    \n                                  */
     0x0a, 0x01, 0x01, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
     0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
     0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f,
     0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
-/*                                      .           */
     0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x02, 0x2f,
     0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
     0x38, 0x39, 0x3a, 0x3b, 0x3c, 0x3d, 0x3e, 0x3f,
@@ -216,6 +214,50 @@ HIDDEN int bsearch_ncompare_mbox(const c
     }
 }
 
+HIDDEN int bsearch_uncompare_mbox(const unsigned char *s1, size_t l1,
+                                  const unsigned char *s2, size_t l2)
+{
+    ssize_t min = l1 < l2 ? l1 : l2;
+    int cmp = 0;
+
+    while (min-- > 0 && (cmp = TOCOMPARE(*s1) - TOCOMPARE(*s2)) == 0) {
+        s1++;
+        s2++;
+    }
+    if (min >= 0) {
+        return cmp;
+    } else {
+        if (l2 > l1) return -1;
+        else if (l1 > l2) return 1;
+        else return 0;
+    }
+}
+
+HIDDEN int bsearch_memtree_mbox(const unsigned char *s1, size_t l1,
+                                const unsigned char *s2, size_t l2)
+{
+    size_t min = l1 < l2 ? l1 : l2;
+    int cmp = 0;
+
+    while ((min-- >0) &&
+           (cmp = (TOCOMPARE(*s1) - TOCOMPARE(*s2))) == 0) {
+        s1++;
+        s2++;
+    }
+
+    /* found a mismatch */
+    if (cmp) return cmp;
+
+    /* Walked off the end of one (or both strings), in which case one
+     * (or both) of these will be zero, and the string with bytes remaining
+     * is the greater.
+     * XXX Arguably we don't need to TOCOMPARE() them here cause it's
+     * always a comparison against zero, but if this turns into a perf
+     * problem we can always optimise it then!
+     */
+    return TOCOMPARE(*s1) - TOCOMPARE(*s2);
+}
+
 /* direct from the qsort manpage */
 EXPORTED int cmpstringp_raw(const void *p1, const void *p2)
 {
@@ -237,9 +279,18 @@ EXPORTED int cmpstringp_mbox(const void
         s2++;
     }
 
-    return cmp;
-}
+    /* found a mismatch */
+    if (cmp) return cmp;
 
+    /* Walked off the end of one (or both strings), in which case one
+     * (or both) of these will be zero, and the string with bytes remaining
+     * is the greater.
+     * XXX Arguably we don't need to TOCOMPARE() them here cause it's
+     * always a comparison against zero, but if this turns into a perf
+     * problem we can always optimise it then!
+     */
+    return TOCOMPARE(*s1) - TOCOMPARE(*s2);
+}
 
 HIDDEN int bsearch_ncompare_raw(const char *s1, int l1, const char *s2, int l2)
 {
diff -pruN 3.0.13-5/lib/bsearch.h 3.2.0-3/lib/bsearch.h
--- 3.0.13-5/lib/bsearch.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/bsearch.h	2020-04-24 02:03:00.000000000 +0000
@@ -51,6 +51,10 @@ extern int bsearch_mem_mbox(const char *
 extern int bsearch_compare_mbox(const char *s1, const char *s2);
 
 extern int bsearch_ncompare_mbox(const char *s1, int l1, const char *s2, int l2);
+extern int bsearch_uncompare_mbox(const unsigned char *s1, size_t l1,
+                                  const unsigned char *s2, size_t l2);
+extern int bsearch_memtree_mbox(const unsigned char *s1, size_t l1,
+                                const unsigned char *s2, size_t l2);
 
 extern int bsearch_ncompare_raw(const char *s1, int l1, const char *s2, int l2);
 
diff -pruN 3.0.13-5/lib/charset/aliases.txt 3.2.0-3/lib/charset/aliases.txt
--- 3.0.13-5/lib/charset/aliases.txt	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/charset/aliases.txt	2020-04-24 02:03:00.000000000 +0000
@@ -11,31 +11,37 @@ ANSI_X3.4-1968      us-ascii
 usascii             us-ascii
 
 # Yes, the world does contain a lot of rubbish
-# ways of saying iso-8859-1
-ISO_8859_1          iso-8859-1
-ISO_8859-1          iso-8859-1
-ISO_8859            iso-8859-1
-ISO-8859            iso-8859-1
-8859_1              iso-8859-1
-iso--8859-1         iso-8859-1
-so-8859-1           iso-8859-1
-x-mac-roman         iso-8859-1
-macintosh           iso-8859-1
-mac                 iso-8859-1
-en_GB               iso-8859-1
-auto                iso-8859-1
-unknown             iso-8859-1
-unknown-8bit        iso-8859-1
-x-unknown           iso-8859-1
-x-user-defined      iso-8859-1
-x-europa            iso-8859-1
-none                iso-8859-1
-latin1              iso-8859-1
-ISO8859-1           iso-8859-1
-8859-1              iso-8859-1
-es-iso-8859-1       iso-8859-1
-DISPLAY             iso-8859-1
-Any                 iso-8859-1
+# ways of saying iso-8859-1.
+# And according to WHATWG Encoding they mean
+# windows-1252 for websites and emails:
+# https://encoding.spec.whatwg.org/#names-and-labels
+iso-8859-1          windows-1252
+ISO_8859_1          windows-1252
+ISO_8859-1          windows-1252
+ISO_8859            windows-1252
+ISO-8859            windows-1252
+8859_1              windows-1252
+iso--8859-1         windows-1252
+so-8859-1           windows-1252
+en_GB               windows-1252
+auto                windows-1252
+unknown             windows-1252
+unknown-8bit        windows-1252
+x-unknown           windows-1252
+x-user-defined      windows-1252
+x-europa            windows-1252
+none                windows-1252
+latin1              windows-1252
+ISO8859-1           windows-1252
+8859-1              windows-1252
+es-windows-1252     windows-1252
+DISPLAY             windows-1252
+Any                 windows-1252
+
+x-mac-roman         macintosh
+mac                 macintosh
+csmacintosh         macintosh
+
 
 # sort-of - see Filter::Trigraph
 646                 iso-8859-1
diff -pruN 3.0.13-5/lib/charset/us-ascii.t 3.2.0-3/lib/charset/us-ascii.t
--- 3.0.13-5/lib/charset/us-ascii.t	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/lib/charset/us-ascii.t	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,7 @@
 13 0013 DEVICE CONTROL THREE (DC3)
 14 0014 DEVICE CONTROL FOUR (DC4)
 15 0015 NEGATIVE ACKNOWLEDGE (NAK)
-16 0016 SYNCRONOUS IDLE (SYN)
+16 0016 SYNCHRONOUS IDLE (SYN)
 17 0017 END OF TRANSMISSION BLOCK (ETB)
 18 0018 CANCEL (CAN)
 19 0019 END OF MEDIUM (EM)
diff -pruN 3.0.13-5/lib/charset.c 3.2.0-3/lib/charset.c
--- 3.0.13-5/lib/charset.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/charset.c	2020-04-24 02:03:00.000000000 +0000
@@ -54,6 +54,10 @@
 #include "htmlchar.h"
 #include "util.h"
 
+#include <unicode/ustring.h>
+#include <unicode/unorm2.h>
+#include <unicode/utf8.h>
+
 #define U_REPLACEMENT   0xfffd
 
 #define unicode_isvalid(c) \
@@ -154,15 +158,18 @@ struct striphtml_state {
     enum html_state stack[2];
 };
 
-#define CHARSET_ICUBUF_MAXSIZE 4096
-#define CHARSET_ICUBUF_MINSIZE 8
+#define CHARSET_ICUBUF_BUFFER_SIZE 4096
 
 struct charset_converter {
     /* An open ICU converter for ICU backed converters. Or NULL.  */
     UConverter *conv;
 
-    /* The charset name for this converter. Might differ from ICU name. */
-    char *name;
+    /* Cyrus-canonical charset name for this converter.
+     * Might differ from ICU name.*/
+    char *canon_name;
+
+    /* Alias name of as provided by caller in charset_lookupname */
+    char *alias_name;
 
     /* The numeric charset identifier for table converters. Or -1 */
     int num;
@@ -189,7 +196,7 @@ struct charset_converter {
 
 struct convert_rock;
 
-static void icu_reset(struct convert_rock *rock, size_t len, int to_uni);
+static void icu_reset(struct convert_rock *rock, int to_uni);
 static void icu_flush(struct convert_rock *rock);
 static void icu_free(struct convert_rock *rock);
 
@@ -244,7 +251,7 @@ static const char index_64[256] = {
     XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
     XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
     XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,62, XX,XX,XX,63,
-    52,53,54,55, 56,57,58,59, 60,61,XX,XX, XX,XX,XX,XX,
+    52,53,54,55, 56,57,58,59, 60,61,XX,XX, XX,64,XX,XX,
     XX, 0, 1, 2,  3, 4, 5, 6,  7, 8, 9,10, 11,12,13,14,
     15,16,17,18, 19,20,21,22, 23,24,25,XX, XX,XX,XX,XX,
     XX,26,27,28, 29,30,31,32, 33,34,35,36, 37,38,39,40,
@@ -262,14 +269,22 @@ static const char index_64[256] = {
 
 EXPORTED int encoding_lookupname(const char *s)
 {
+    if (!s) return ENCODING_NONE;
+
     switch (s[0]) {
     case '7':
         if (!strcasecmp(s, "7BIT"))
             return ENCODING_NONE;
+        // non-standard stuff seen in the wild
+        if (!strcasecmp(s, "7-BIT"))
+            return ENCODING_NONE;
         break;
     case '8':
         if (!strcasecmp(s, "8BIT"))
             return ENCODING_NONE;
+        // non-standard stuff seen in the wild
+        if (!strcasecmp(s, "8-BIT"))
+            return ENCODING_NONE;
         break;
     case 'B':
     case 'b':
@@ -278,11 +293,23 @@ EXPORTED int encoding_lookupname(const c
         if (!strcasecmp(s, "BINARY"))
             return ENCODING_NONE;
         break;
+    case 'N':
+        if (!strcasecmp(s, "NONE"))
+            return ENCODING_NONE;
+        break;
     case 'Q':
     case 'q':
         if (!strcasecmp(s, "QUOTED-PRINTABLE"))
             return ENCODING_QP;
         break;
+    case 'u':
+    case 'U':
+        // this is rubbish, but it's been seen in the wild
+        if (!strcasecmp(s, "UTF-8"))
+            return ENCODING_NONE;
+        if (!strcasecmp(s, "UTF8"))
+            return ENCODING_NONE;
+        break;
     }
     return ENCODING_UNKNOWN;
 }
@@ -420,6 +447,13 @@ static void b64_2byte(struct convert_roc
     /* could just be whitespace, ignore it */
     if (b == XX) return;
 
+    /* the padding character, reset state */
+    if (b == 64) {
+        s->codepoint = 0;
+        s->bytesleft = 0;
+        return;
+    }
+
     switch (s->bytesleft) {
     case 0:
         s->codepoint = b;
@@ -637,7 +671,7 @@ static void byte2search(struct convert_r
         if (cur < i)
             s->starts[cur] = s->starts[i];
 
-        /* check that the substring is still maching */
+        /* check that the substring is still matching */
         if (b == s->substr[s->offset - s->starts[i]]) {
             if (s->offset - s->starts[i] == s->patlen - 1) {
                 /* we're there! */
@@ -1528,6 +1562,13 @@ static char *buffer_cstring(struct conve
     return buf_release(buf);
 }
 
+static void buffer_trim(struct convert_rock *rock)
+{
+    struct buf *buf = (struct buf *)rock->state;
+
+    buf_trim(buf);
+}
+
 static inline int search_havematch(struct convert_rock *rock)
 {
     struct search_state *s = (struct search_state *)rock->state;
@@ -1560,18 +1601,15 @@ static void icu_flush(struct convert_roc
 static void icu_free(struct convert_rock *rock)
 {
     if (rock) {
-        if (rock->state) icu_reset(rock, 0 /*don't care*/, -1 /*don't care*/);
+        if (rock->state) icu_reset(rock, -1 /*don't care*/);
         free(rock);
     }
 }
 
-static void icu_reset(struct convert_rock *rock, size_t len, int to_uni)
+static void icu_reset(struct convert_rock *rock, int to_uni)
 {
     struct charset_converter *s = (struct charset_converter *)rock->state;
-    size_t buf_size = CHARSET_ICUBUF_MAXSIZE;
-
-    if (len && len < buf_size) buf_size = len;
-    if (buf_size < CHARSET_ICUBUF_MINSIZE) buf_size = CHARSET_ICUBUF_MINSIZE;
+    size_t buf_size = CHARSET_ICUBUF_BUFFER_SIZE;
 
     if (s->buf_size < buf_size) {
         s->buf = xrealloc(s->buf, buf_size * 2);
@@ -1624,16 +1662,14 @@ static void table_reset(struct convert_r
 static void convert_switch(struct convert_rock *rock, charset_t to, int to_uni)
 {
     struct charset_converter *s = (struct charset_converter *) rock->state;
-    size_t buf_size = 0;
 
     /* make sure that the new state is sane */
     assert((to->conv == NULL) != (to->num == -1));
 
     /* flush any cached bytes in the ICU converter */
     if (s->conv) {
-        buf_size = s->buf_size;
         icu_flush(rock);
-        icu_reset(rock, 0 /*don't care*/, to_uni);
+        icu_reset(rock, to_uni);
     } else {
         table_reset(rock, to_uni);
     }
@@ -1641,7 +1677,7 @@ static void convert_switch(struct conver
     /* how the new state in the pipeline */
     rock->state = to;
     if (to->conv) {
-        icu_reset(rock, buf_size, to_uni);
+        icu_reset(rock, to_uni);
     } else {
         table_reset(rock, to_uni);
     }
@@ -1734,7 +1770,7 @@ static struct convert_rock *canon_init(i
     struct convert_rock *rock = xzmalloc(sizeof(struct convert_rock));
     struct canon_state *s = xzmalloc(sizeof(struct canon_state));
     s->flags = flags;
-    if ((flags & CHARSET_SNIPPET))
+    if ((flags & CHARSET_KEEPCASE))
         rock->f = uni2html;
     else
         rock->f = uni2searchform;
@@ -1745,7 +1781,6 @@ static struct convert_rock *canon_init(i
 
 static struct convert_rock *convert_init(struct charset_converter *s,
                                          int to_uni,
-                                         size_t len,
                                          struct convert_rock *next)
 {
     struct convert_rock *rock;
@@ -1758,7 +1793,7 @@ static struct convert_rock *convert_init
 
     /* Initialize rock based on the converter type */
     if (s->conv) {
-        icu_reset(rock, len, to_uni);
+        icu_reset(rock, to_uni);
     } else {
         table_reset(rock, to_uni);
     } 
@@ -1791,11 +1826,13 @@ static struct convert_rock *search_init(
     return rock;
 }
 
-static struct convert_rock *buffer_init(void)
+static struct convert_rock *buffer_init(size_t hint)
 {
     struct convert_rock *rock = xzmalloc(sizeof(struct convert_rock));
     struct buf *buf = xzmalloc(sizeof(struct buf));
 
+    if (hint) buf_ensure(buf, hint);
+
     rock->f = byte2buffer;
     rock->cleanup = buffer_free;
     rock->state = (void *)buf;
@@ -1835,7 +1872,7 @@ static char* convert_to_name(const char
     size_t n;
 
     /* determine the name of the source encoding */
-    from = charset_name(charset);
+    from = charset_canon_name(charset);
 
     /* allocate the target buffer */
     /* we preflight to compromise between memory and runtime efficiency */
@@ -1862,29 +1899,72 @@ static charset_t lookup_buf(const char *
     return cs;
 }
 
+/* RFC2047: In this case the set of characters that may be used in a “Q”-encoded
+  ‘encoded-word’ is restricted to: <upper and lower case ASCII
+  letters, decimal digits, "!", "*", "+", "-", "/", "=", and "_" */
+/* of course = and _ are not included in the set, because they themselves
+   need to be quoted it’s just saying they can be present in the Q wordi
+   itself, because they’re part of the quoting system */
+char QPMIMEPHRASESAFECHAR[256] = {
+/* control chars are unsafe */
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+/* ASCII map... */
+/*     !  "  #  $  %  &  '  (  )  *  +  ,  -  .  /  */
+    0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 1,
+/*  0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ?  */
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,
+/*  @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  */
+    0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+/*  P  Q  R  S  T  U  V  W  X  Y  Z  [ \\  ]  ^  _  */
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
+/*  `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  */
+    0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+/*  p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~ DEL */
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
+/* all high bits are unsafe */
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
 
 /* API */
 
+EXPORTED const char *charset_alias_name(charset_t cs) {
+    if (cs && cs->alias_name) {
+        return cs->alias_name;
+    }
+    return charset_canon_name(cs);
+}
+
 /*
  * Return the name of the given character set number, or "unknown" if
  * not known.
  */
-EXPORTED const char *charset_name(charset_t charset)
+EXPORTED const char *charset_canon_name(charset_t cs)
 {
-    const char *name;
+    if (!cs)
+            goto done;
 
-    if (charset->name)
-        return charset->name;
+    if (cs->canon_name)
+        return cs->canon_name;
 
-    if (charset->conv) {
+    if (cs->conv) {
         UErrorCode err = U_ZERO_ERROR;
-        name = ucnv_getName(charset->conv, &err);
+        const char *name = ucnv_getName(cs->conv, &err);
         if (U_SUCCESS(err))
             return name;
-    } else if (charset->num >= 0 && charset->num < chartables_num_charsets) {
-        return chartables_charset_table[charset->num].name;
+    } else if (cs->num >= 0 && cs->num < chartables_num_charsets) {
+        return chartables_charset_table[cs->num].name;
     }
 
+done:
     return "unknown";
 }
 
@@ -1895,49 +1975,61 @@ EXPORTED const char *charset_name(charse
 EXPORTED charset_t charset_lookupname(const char *name)
 {
     int i;
-    struct charset_converter *s;
+    struct charset_converter *cs;
     UErrorCode err;
     UConverter *conv;
 
     /* create the converter */
-    s = xzmalloc(sizeof(struct charset_converter));
-    s->num = -1;
+    cs = xzmalloc(sizeof(struct charset_converter));
+    cs->num = -1;
 
     if (!name) {
-        s->num = 0; // us-ascii
-        return s;
+        cs->num = 0; // us-ascii
+        return cs;
     }
+    cs->alias_name = xstrdup(name);
 
-    /* translate to canonical name */
+    /* translate alias to canonical name */
     for (i = 0; charset_aliases[i].name; i++) {
-        if (!strcasecmp(name, charset_aliases[i].name) ||
-            !strcasecmp(name, charset_aliases[i].canon_name)) {
-            name = charset_aliases[i].canon_name;
-            s->name = xstrdup(name);
+        if (!strcasecmp(name, charset_aliases[i].name)) {
+            cs->canon_name = xstrdup(charset_aliases[i].canon_name);
             break;
         }
     }
+    if (!cs->canon_name) {
+        /* otherwise use canonical name, if defined */
+        for (i = 0; charset_aliases[i].name; i++) {
+            if (!strcasecmp(name, charset_aliases[i].canon_name)) {
+                cs->canon_name = xstrdup(charset_aliases[i].canon_name);
+                break;
+            }
+        }
+    }
 
     /* Is it a table based lookup, or UTF-8? */
-    for (i = 0; i < chartables_num_charsets; i++) {
-        if (!strcasecmp(name, chartables_charset_table[i].name)) {
-            if ((chartables_charset_table[i].table) || !strcmp(name, "utf-8")) {
-                s->num = i;
-                return s;
+    if (cs->canon_name) {
+        for (i = 0; i < chartables_num_charsets; i++) {
+            if (!strcasecmp(cs->canon_name, chartables_charset_table[i].name)) {
+                if ((chartables_charset_table[i].table) || !strcmp(cs->canon_name, "utf-8")) {
+                    cs->num = i;
+                    return cs;
+                }
             }
         }
     }
 
     /* Otherwise, let's see if we can fallback to ICU */
     err = U_ZERO_ERROR;
-    conv = ucnv_open(name, &err);
+    conv = ucnv_open(cs->canon_name ? cs->canon_name : name, &err);
     if (U_SUCCESS(err)) {
-        s->conv = conv;
-        return s;
+        cs->conv = conv;
+        return cs;
     }
 
     /* Still here? This means we don't know this charset name */
-    free(s);
+    free(cs->alias_name);
+    free(cs->canon_name);
+    free(cs);
     return CHARSET_UNKNOWN_CHARSET;
 }
 
@@ -1949,7 +2041,8 @@ EXPORTED void charset_free(charset_t *ch
         if (s->conv) ucnv_close(s->conv);
         /* Free up memory. */
         if (s->buf) free(s->buf);
-        if (s->name) free(s->name);
+        free(s->alias_name);
+        free(s->canon_name);
         /* Release the converter */
         free(s);
         *charsetp = CHARSET_UNKNOWN_CHARSET;
@@ -1984,10 +2077,10 @@ EXPORTED char *charset_convert(const cha
     utf8 = charset_lookupname("utf-8");
 
     /* set up the conversion path */
-    tobuffer = buffer_init();
-    input = convert_init(utf8, 0/*to_uni*/, 0, tobuffer);
+    tobuffer = buffer_init(0);
+    input = convert_init(utf8, 0/*to_uni*/, tobuffer);
     input = canon_init(flags, input);
-    input = convert_init(charset, 1/*to_uni*/, 0, input);
+    input = convert_init(charset, 1/*to_uni*/, input);
 
     /* do the conversion */
     convert_cat(input, s);
@@ -2012,7 +2105,7 @@ EXPORTED char *charset_to_imaputf7(const
     /* Initialize character set mapping */
     if (charset == CHARSET_UNKNOWN_CHARSET) return 0;
 
-    /* check for trivial search */
+    /* check for trivial case */
     if (len == 0)
         return xstrdup("");
 
@@ -2022,9 +2115,9 @@ EXPORTED char *charset_to_imaputf7(const
 
     /* set up the conversion path */
     imaputf7 = charset_lookupname("imap-mailbox-name");
-    tobuffer = buffer_init();
-    input = convert_init(imaputf7, 0/*to_uni*/, len, tobuffer);
-    input = convert_init(charset, 1/*to_uni*/, len, input);
+    tobuffer = buffer_init(len);
+    input = convert_init(imaputf7, 0/*to_uni*/, tobuffer);
+    input = convert_init(charset, 1/*to_uni*/, input);
 
     /* choose encoding extraction if needed */
     switch (encoding) {
@@ -2070,6 +2163,93 @@ EXPORTED char *charset_utf8_to_searchfor
     return ret;
 }
 
+EXPORTED char *charset_utf8_normalize(const char *src)
+{
+    int32_t srclen = strlen(src);
+    UChar *uni = NULL;
+    int32_t unilen = 0;
+    UChar *nfc = NULL;
+    int32_t nfclen = 0;
+    char *ret = NULL;
+    int32_t retlen = 0;
+
+    /* Fast-path for ASCII.
+     * Unicode Standard Annex #15, section 1.3: "Text exclusively
+     * containing ASCII characters (U+0000..U+007F) is left
+     * unaffected by all of the Normalization Forms."
+     * See http://www.unicode.org/reports/tr15/#Description_Norm
+     * */
+    const char *p;
+    for (p = src; *p && isascii(*p); p++) {}
+    if (*p == '\0') {
+        return xstrdup(src);
+    }
+
+    /* Convert the UTF-8 string to UChar */
+    UErrorCode err = U_ZERO_ERROR;
+    u_strFromUTF8(uni, unilen, &unilen, src, srclen, &err);
+    if (U_FAILURE(err) && err != U_BUFFER_OVERFLOW_ERROR) {
+        goto done;
+    }
+    err = U_ZERO_ERROR;
+    unilen++;
+    uni = xzmalloc(unilen * sizeof(UChar));
+    u_strFromUTF8(uni, unilen, &unilen, src, srclen, &err);
+    if (U_FAILURE(err)) {
+        goto done;
+    }
+
+    /* Normalize the UChars to NFC */
+    err = U_ZERO_ERROR;
+    const UNormalizer2 *norm = unorm2_getNFCInstance(&err);
+    if (!norm || U_FAILURE(err)) {
+        goto done;
+    }
+    /* Quick-check if the Unicode string requires normalization.
+     * Skip normalization only if libicu is certain not to need
+     * to do anything. */
+    if (unorm2_quickCheck(norm, uni, unilen, &err) == UNORM_YES) {
+        nfc = uni;
+        nfclen = unilen;
+        uni = NULL;
+    }
+    else {
+        err = U_ZERO_ERROR;
+        nfclen = unorm2_normalize(norm, uni, unilen, nfc, 0, &err) + 1;
+        if (U_FAILURE(err) && err != U_BUFFER_OVERFLOW_ERROR) {
+            goto done;
+        }
+        err = U_ZERO_ERROR;
+        nfclen++;
+        nfc = xzmalloc(nfclen * sizeof(UChar));
+        unorm2_normalize(norm, uni, unilen, nfc, nfclen, &err);
+        if (U_FAILURE(err)) {
+            goto done;
+        }
+        free(uni);
+        uni = NULL;
+    }
+
+    /* Convert the NFC UChars back to UTF-8 */
+    err = U_ZERO_ERROR;
+    u_strToUTF8(ret, 0, &retlen, nfc, nfclen, &err);
+    if (U_FAILURE(err) && err != U_BUFFER_OVERFLOW_ERROR) {
+        goto done;
+    }
+    err = U_ZERO_ERROR;
+    retlen++;
+    ret = xzmalloc(retlen);
+    u_strToUTF8(ret, retlen, &retlen, nfc, nfclen, &err);
+    if (U_FAILURE(err) && err != U_BUFFER_OVERFLOW_ERROR) {
+        goto done;
+    }
+
+done:
+    free(uni);
+    free(nfc);
+    return ret;
+}
+
 /* Convert from a given charset and encoding into utf8 */
 EXPORTED char *charset_to_utf8(const char *msg_base, size_t len, charset_t charset, int encoding)
 {
@@ -2090,9 +2270,9 @@ EXPORTED char *charset_to_utf8(const cha
 
     /* set up the conversion path */
     utf8 = charset_lookupname("utf-8");
-    tobuffer = buffer_init();
-    input = convert_init(utf8, 0/*to_uni*/, len, tobuffer);
-    input = convert_init(charset, 1/*to_uni*/, len, input);
+    tobuffer = buffer_init(len);
+    input = convert_init(utf8, 0/*to_uni*/, tobuffer);
+    input = convert_init(charset, 1/*to_uni*/, input);
 
     /* choose encoding extraction if needed */
     switch (encoding) {
@@ -2139,7 +2319,7 @@ EXPORTED int charset_decode(struct buf *
     }
 
     /* set up the conversion path */
-    input = buffer_init();
+    input = buffer_init(len);
     buffer_setbuf(input, dst);
 
     /* choose encoding extraction if needed */
@@ -2181,13 +2361,20 @@ static void mimeheader_cat(struct conver
 
     if (!s) return;
 
+    /* Keep track of the decoding pipeline before the current
+     * encoded-word. This allows to share decoding state for
+     * multi-octet characters that are broken across words. */
+    int lastenc = ENCODING_UNKNOWN;
+    charset_t lastcs = CHARSET_UNKNOWN_CHARSET;
+    struct convert_rock *extract = NULL;
+
     /* set up the conversion path */
     if (flags & CHARSET_MIME_UTF8) {
         defaultcs = charset_lookupname("utf-8");
     } else {
         defaultcs = charset_lookupname("us-ascii");
     }
-    input = convert_init(defaultcs, 1/*to_uni*/, 0, target);
+    input = convert_init(defaultcs, 1/*to_uni*/, target);
 
     /* note: we assume the caller of this function has already
      * determined that all newlines are followed by whitespace */
@@ -2197,15 +2384,28 @@ static void mimeheader_cat(struct conver
     while ((start = (const char*) strchr(start, '=')) != 0) {
         start++;
         if (*start != '?') continue;
-        encoding = (const char*) strchr(start+1, '?');
-        if (!encoding) continue;
-        endcharset =
-            (const char*) strchr(start+1, '*'); /* Language code delimiter */
-        if (!endcharset || endcharset > encoding) endcharset = encoding;
-        if (encoding[1] != 'b' && encoding[1] != 'B' &&
-            encoding[1] != 'q' && encoding[1] != 'Q') continue;
-        if (encoding[2] != '?') continue;
-        end = (const char*) strchr(encoding+3, '?');
+        endcharset = NULL;
+        for (p = start + 1; *p && *p != '=' && *p != '?'; ++p)
+            if ('*' == *p && !endcharset) endcharset = p;
+        if (*p != '?') {
+            start = p;
+            continue;
+        }
+        encoding = p;
+        if (!endcharset) endcharset = p;
+        if ((encoding[1] != 'b' && encoding[1] != 'B' &&
+             encoding[1] != 'q' && encoding[1] != 'Q')
+            || (encoding[2] != '?')) {
+            start = p;
+            continue;
+        }
+        for (p = encoding + 3; *p && *p != '?'; ++p)
+            if ('=' == *p && '?' == p[1] && '=' != p[2]) break;
+        if (*p != '?' || p[1] != '=') {
+            start = p;
+            continue;
+        }
+        end = p;
         if (!end || end[1] != '=') continue;
 
         /*
@@ -2222,6 +2422,13 @@ static void mimeheader_cat(struct conver
             len = start - s - 1;
             convert_switch(input, defaultcs, 1/*to_uni*/);
             convert_catn(unfold, s, len);
+
+            /* Reset decoder pipeline */
+            charset_free(&lastcs);
+            lastcs = CHARSET_UNKNOWN_CHARSET;
+            lastenc = ENCODING_UNKNOWN;
+            basic_free(extract);
+            extract = NULL;
         }
 
         /*
@@ -2229,16 +2436,38 @@ static void mimeheader_cat(struct conver
          */
         start++;
         cs = lookup_buf(start, endcharset-start);
+        int enc = encoding[1] == 'q' || encoding[1] == 'Q' ? ENCODING_QP : ENCODING_BASE64;
+
         if (cs == CHARSET_UNKNOWN_CHARSET) {
             /* Unrecognized charset, nothing will match here */
             convert_putc(input, U_REPLACEMENT); /* unknown character */
+            charset_free(&cs);
+            convert_switch(input, defaultcs, 1 /*to_uni*/);
+
+            /* Reset decoder pipeline */
+            charset_free(&lastcs);
+            lastcs = CHARSET_UNKNOWN_CHARSET;
+            lastenc = ENCODING_UNKNOWN;
+            basic_free(extract);
+            extract = NULL;
+        }
+        else if (!strcmp(charset_canon_name(cs), charset_canon_name(lastcs)) &&
+                  enc == lastenc && enc) {
+            /* Reuse the previous decoder */
+            charset_free(&cs);
+            p = encoding+3;
+            convert_catn(extract, p, end - p);
         }
         else {
-            struct convert_rock *extract;
+            /* Reset the previous decoder and start a new decoding pipeline */
             convert_switch(input, cs, 1/*to_uni*/);
-
+            charset_free(&lastcs);
+            lastcs = CHARSET_UNKNOWN_CHARSET;
+            lastenc = ENCODING_UNKNOWN;
+            basic_free(extract);
+            extract = NULL;
             /* choose decoder */
-            if (encoding[1] == 'q' || encoding[1] == 'Q') {
+            if (enc == ENCODING_QP) {
                 extract = qp_init(1, input);
             }
             else {
@@ -2247,11 +2476,9 @@ static void mimeheader_cat(struct conver
             /* convert */
             p = encoding+3;
             convert_catn(extract, p, end - p);
-            /* clean up */
-            basic_free(extract);
+            lastcs = cs;
+            lastenc = enc;
         }
-        convert_switch(input, defaultcs, 1 /*to_uni*/);
-        charset_free(&cs);
 
         /* Prepare for the next iteration */
         s = start = end+2;
@@ -2268,11 +2495,13 @@ static void mimeheader_cat(struct conver
     basic_free(unfold);
     convert_nfree(input, 1);
     charset_free(&defaultcs);
+    charset_free(&lastcs);
+    basic_free(extract);
 }
 
 /*
  * Decode MIME strings (per RFC 2047) in 's'.  Returns a newly allocated
- * string, contining 's' in canonical searching form, which must be
+ * string, containing 's' in canonical searching form, which must be
  * free()d by the caller.
  */
 EXPORTED char *charset_decode_mimeheader(const char *s, int flags)
@@ -2284,8 +2513,8 @@ EXPORTED char *charset_decode_mimeheader
     if (!s) return NULL;
 
     utf8 = charset_lookupname("utf-8");
-    tobuffer = buffer_init();
-    input = convert_init(utf8, 0/*to_uni*/, 0, tobuffer);
+    tobuffer = buffer_init(0);
+    input = convert_init(utf8, 0/*to_uni*/, tobuffer);
     input = canon_init(flags, input);
 
     mimeheader_cat(input, s, flags);
@@ -2300,7 +2529,7 @@ EXPORTED char *charset_decode_mimeheader
 
 /*
  * Unfold len bytes of string s into a new string, which must be freed()
- * by the caller. Unfolding removes any CRLF that is mmediately followed
+ * by the caller. Unfolding removes any CRLF that is immediately followed
  * by a tab or space character. If flags sets CHARSET_UNFOLD_SKIPWS, then
  * the whitespace character is also omitted.
  */
@@ -2311,7 +2540,7 @@ EXPORTED char *charset_unfold(const char
 
     if (!s) return NULL;
 
-    tobuffer = buffer_init();
+    tobuffer = buffer_init(len);
     input = unfold_init(flags&CHARSET_UNFOLD_SKIPWS, tobuffer);
 
     convert_catn(input, s, len);
@@ -2337,11 +2566,14 @@ EXPORTED char *charset_parse_mimeheader(
     if (!s) return NULL;
 
     utf8 = charset_lookupname("utf-8");
-    tobuffer = buffer_init();
-    input = convert_init(utf8, 0/*to_uni*/, 0, tobuffer);
+    tobuffer = buffer_init(0);
+    input = convert_init(utf8, 0/*to_uni*/, tobuffer);
 
     mimeheader_cat(input, s, flags);
 
+    if (flags & CHARSET_TRIMWS)
+        buffer_trim(tobuffer);
+
     res = buffer_cstring(tobuffer);
 
     convert_free(input);
@@ -2350,6 +2582,90 @@ EXPORTED char *charset_parse_mimeheader(
     return res;
 }
 
+/* Decode extended MIME values (per RFC 2231). Returns a newly allocated UTF-8
+ * encoded string, containing the decoded string, which must be free()d by the
+ * caller.
+ *
+ * If lang is not NULL, sets the buffer contents to the 'language' * field as
+ * encoded in the MIME value.
+ *
+ * If s can't be decoded to an extended value as defined in RFC 2231, then
+ * return NULL. E.g. it does not attempt to decode the value as RFC 2047 MIME
+ * header, nor returns the value verbatim. */
+EXPORTED char *charset_parse_mimexvalue(const char *s, struct buf *lang)
+{
+    if (!s) return NULL;
+    const char *p, *q;
+    struct buf buf = BUF_INITIALIZER;
+    charset_t cs;
+    char *ret = NULL;
+
+    /* Determine charset */
+    p = s;
+    q = strchr(p, '\'');
+    if (!q) return NULL;
+
+    buf_setmap(&buf, p, q - p);
+    cs = charset_lookupname(buf_cstring(&buf));
+    if (cs == CHARSET_UNKNOWN_CHARSET) goto done;
+
+    /* Determine language */
+    p = q + 1;
+    q = strchr(p, '\'');
+    if (!q) goto done;
+    if (lang) {
+        buf_setmap(lang, p, q - p);
+    }
+
+    /* Decode octects */
+    buf_reset(&buf);
+    p = q + 1;
+    while (*p) {
+        if (*p == '%') {
+            char c;
+            if (*(p+1) == 0 || *(p+2) == 0)
+                goto done;
+            if (hex_to_bin(p+1, 2, &c) == -1)
+                goto done;
+            buf_appendmap(&buf, &c, 1);
+            p += 3;
+        } else {
+            buf_appendmap(&buf, p++, 1);
+        }
+    }
+    ret = charset_to_utf8(buf_base(&buf), buf_len(&buf), cs, 0);
+
+done:
+    charset_free(&cs);
+    buf_free(&buf);
+    return ret;
+}
+
+/* Encode UTF-8 encoded string s as extended MIME RFC 2231 value.
+ * If lang is non-NULL, set the extended value language property
+ * accordingly. The returned string must be free()d by caller. */
+EXPORTED char *charset_encode_mimexvalue(const char *s, const char *lang)
+{
+    const unsigned char *p;
+    struct buf buf = BUF_INITIALIZER;
+
+    if (!s) return NULL;
+
+    buf_printf(&buf, "utf-8'%s'", lang ? lang : "");
+    for (p = (const unsigned char*) s; *p; p++) {
+        if ((*p >= '0' && *p <= '9') ||
+            (*p >= 'a' && *p <= 'z') ||
+            (*p >= 'A' && *p <= 'Z') ||
+            (strchr("!#$&+-.^_`|~", *p))) {
+            // Safe attr char
+            buf_putc(&buf, *p);
+        }
+        else buf_printf(&buf, "%%%X%X", *p >> 4, *p & 0xf);
+    }
+
+    return buf_release(&buf);
+}
+
 EXPORTED int charset_search_mimeheader(const char *substr, comp_pat *pat,
                               const char *s, int flags)
 {
@@ -2358,7 +2674,7 @@ EXPORTED int charset_search_mimeheader(c
     charset_t utf8 = charset_lookupname("utf-8");
 
     tosearch = search_init(substr, pat);
-    input = convert_init(utf8, 0/*to_uni*/, 0, tosearch);
+    input = convert_init(utf8, 0/*to_uni*/, tosearch);
     input = canon_init(flags, input);
 
     mimeheader_cat(input, s, flags);
@@ -2381,7 +2697,7 @@ EXPORTED comp_pat *charset_compilepat(co
 {
     struct comp_pat_s *pat = xzmalloc(sizeof(struct comp_pat_s));
     const char *p = s;
-    /* count occurances */
+    /* count occurrences */
     while (*p) {
         if (*p == *s) pat->max_start++;
         pat->patlen++;
@@ -2422,9 +2738,9 @@ EXPORTED int charset_searchstring(const
     tosearch = search_init(substr, pat);
 
     /* and the input stream */
-    input = convert_init(utf8to, 0/*to_uni*/, len, tosearch);
+    input = convert_init(utf8to, 0/*to_uni*/, tosearch);
     input = canon_init(flags, input);
-    input = convert_init(utf8from, 1/*to_uni*/, len, input);
+    input = convert_init(utf8from, 1/*to_uni*/, input);
 
     /* feed the handler */
     while (len-- > 0) {
@@ -2469,9 +2785,9 @@ EXPORTED int charset_searchfile(const ch
     /* set up the conversion path */
     utf8 = charset_lookupname("utf-8");
     tosearch = search_init(substr, pat);
-    input = convert_init(utf8, 0/*to_uni*/, len, tosearch);
+    input = convert_init(utf8, 0/*to_uni*/, tosearch);
     input = canon_init(flags, input);
-    input = convert_init(charset, 1/*to_uni*/, len, input);
+    input = convert_init(charset, 1/*to_uni*/, input);
 
     /* choose encoding extraction if needed */
     switch (encoding) {
@@ -2530,8 +2846,8 @@ EXPORTED int charset_extract(void (*cb)(
 
     /* set up the conversion path */
     utf8 = charset_lookupname("utf-8");
-    tobuffer = buffer_init();
-    input = convert_init(utf8, 0/*to_uni*/, 0, tobuffer);
+    tobuffer = buffer_init(buf_len(data));
+    input = convert_init(utf8, 0/*to_uni*/, tobuffer);
     input = canon_init(flags, input);
 
     if (!strcmpsafe(subtype, "HTML")) {
@@ -2543,10 +2859,12 @@ EXPORTED int charset_extract(void (*cb)(
         }
         /* this is text/html data, so we can make ourselves useful by
          * stripping html tags, css and js. */
-        input = striphtml_init(input);
+        if (!(flags & CHARSET_KEEPHTML)) {
+            input = striphtml_init(input);
+        }
     }
 
-    input = convert_init(charset, 1/*to_uni*/, 0, input);
+    input = convert_init(charset, 1/*to_uni*/, input);
 
     switch (encoding) {
     case ENCODING_NONE:
@@ -2618,12 +2936,12 @@ EXPORTED const char *charset_decode_mime
         return msg_base;
 
     case ENCODING_QP:
-        tobuffer = buffer_init();
+        tobuffer = buffer_init(len);
         input = qp_init(0, tobuffer);
         break;
 
     case ENCODING_BASE64:
-        tobuffer = buffer_init();
+        tobuffer = buffer_init(len);
         input = b64_init(tobuffer);
         break;
 
@@ -2652,6 +2970,10 @@ EXPORTED const char *charset_decode_mime
     return *decbuf;
 }
 
+/* Maximum octect length of base64 or QP-encoded text lines, excluding
+ * terminating CR LF and encoding-specific padding/footer. */
+#define ENCODED_MAX_LINE_LEN  72
+
 /*
  * Base64 encode the MIME body part (per RFC 2045) of 'len' bytes located at
  * 'msg_base'.  Encodes into 'retval' which must large enough to
@@ -2661,13 +2983,12 @@ EXPORTED const char *charset_decode_mime
  * May be called with 'msg_base' as NULL to get the number of encoded
  * bytes for allocating 'retval' of the proper size.
  */
-#define BASE64_MAX_LINE_LEN  72
-
 static char base_64[] =
     "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
 
 EXPORTED char *charset_encode_mimebody(const char *msg_base, size_t len,
-    char *retval, size_t *outlen, int *outlines)
+                                       char *retval, size_t *outlen,
+                                       int *outlines, int wrap)
 {
     const unsigned char *s;
     unsigned char s0, s1, s2;
@@ -2675,10 +2996,13 @@ EXPORTED char *charset_encode_mimebody(c
     int b64_len, b64_lines, cnt;
 
     b64_len = ((len + 2) / 3) * 4;
-    b64_lines = (b64_len + BASE64_MAX_LINE_LEN - 1) / BASE64_MAX_LINE_LEN;
+    if (wrap) {
+        b64_lines = (b64_len + ENCODED_MAX_LINE_LEN - 1) / ENCODED_MAX_LINE_LEN;
 
-    /* account for CRLF added to each line */
-    b64_len += 2 * b64_lines;
+        /* account for CRLF added to each line */
+        b64_len += 2 * b64_lines;
+    }
+    else b64_lines = 1;
 
     if (outlen) *outlen = b64_len;
     if (outlines) *outlines = b64_lines;
@@ -2687,7 +3011,7 @@ EXPORTED char *charset_encode_mimebody(c
 
     for (s = (const unsigned char*) msg_base, d = retval, cnt = 0; len;
          s += 3, d += 4, cnt += 4) { /* process tuplets */
-        if (cnt == BASE64_MAX_LINE_LEN) {
+        if (wrap && cnt == ENCODED_MAX_LINE_LEN) {
             /* reset line len count, add CRLF */
             cnt = 0;
             *d++ = '\r';
@@ -2718,9 +3042,11 @@ EXPORTED char *charset_encode_mimebody(c
         }
     }
 
-    /* add final CRLF */
-    *d++ = '\r';
-    *d++ = '\n';
+    if (wrap) {
+        /* add final CRLF */
+        *d++ = '\r';
+        *d++ = '\n';
+    }
 
     return (b64_len ? retval : NULL);
 }
@@ -2733,27 +3059,40 @@ EXPORTED char *charset_encode_mimebody(c
  * Returns the number of encoded bytes in 'outlen'.
  */
 static char *qp_encode(const char *data, size_t len, int isheader,
-                       size_t *outlen)
+                       int force_quote, size_t *outlen)
 {
     struct buf buf = BUF_INITIALIZER;
     size_t n;
-    int need_quote = 0;
+    int need_quote = 0, need_fold = 0;
 
-    for (n = 0; n < len; n++) {
-        unsigned char this = data[n];
-        unsigned char next = (n < len - 1) ? data[n+1] : '\0';
+    if (!force_quote) {
+        size_t prev_lf = 0;
+        for (n = 0; n < len; n++) {
+            unsigned char this = data[n];
+            unsigned char next = (n < len - 1) ? data[n+1] : '\0';
 
-        if (QPSAFECHAR[this] || this == '=' || this == ' ' || this == '\t') {
-            /* per RFC 5322: printable ASCII (decimal 33 - 126), SP, HTAB */
-            continue;
-        }
-        else if (!isheader && this == '\r' && next == '\n') {
-            /* line break (CRLF) */
-            n++;
-            continue;
+            if (QPSAFECHAR[this] || this == '=' || this == ' ' || this == '\t') {
+                /* per RFC 5322: printable ASCII (decimal 33 - 126), SP, HTAB */
+                /* but only if the line doesn't exceed the 76 octet limit */
+                if (n - prev_lf <= 74) continue;
+
+                if (isheader) {
+                    need_fold = 1;
+                    continue;
+                }
+            }
+            else if (!isheader && this == '\r' && next == '\n') {
+                /* line break (CRLF) */
+                n++;
+                prev_lf = n;
+                continue;
+            }
+            need_quote = 1;
+            break;
         }
+    }
+    else {
         need_quote = 1;
-        break;
     }
 
     if (need_quote) {
@@ -2778,12 +3117,12 @@ static char *qp_encode(const char *data,
                 else if (this < 0xf0) needbytes = 6;
                 else if (this < 0xf8) needbytes = 9;
                 else needbytes = 0; // impossible UTF-8 encoding
-                if (cnt + needbytes >= BASE64_MAX_LINE_LEN) {
+                if (cnt + needbytes >= ENCODED_MAX_LINE_LEN) {
                     buf_appendcstr(&buf, "?=\r\n =?UTF-8?Q?");
                     cnt = 11;
                 }
             }
-            else if (cnt >= BASE64_MAX_LINE_LEN) {
+            else if (cnt >= ENCODED_MAX_LINE_LEN) {
                 /* add soft line break to body */
                 buf_appendcstr(&buf, "=\r\n");
                 cnt = 0;
@@ -2833,6 +3172,22 @@ static char *qp_encode(const char *data,
 
         if (isheader) buf_appendcstr(&buf, "?=");
     }
+    else if (need_fold) {
+        /* fold header every 78 characters (if possible) */
+        size_t i = 0, j = 0, last_wsp = 0;
+
+        while ((len - i > 78) && (j < len)) {
+            j += strcspn(data + j, " \t");
+
+            if (last_wsp && (j - i > 78)) {
+                buf_appendmap(&buf, data + i, last_wsp - i);
+                buf_appendcstr(&buf, "\r\n");
+                i = last_wsp;
+            }
+            last_wsp = j++;
+        }
+        buf_appendcstr(&buf, data + i);
+    }
     else {
         buf_setmap(&buf, data, len);
     }
@@ -2849,11 +3204,11 @@ static char *qp_encode(const char *data,
  * Returns the number of encoded bytes in 'outlen'.
  */
 EXPORTED char *charset_qpencode_mimebody(const char *msg_base, size_t len,
-                                         size_t *outlen)
+                                         int force_quote, size_t *outlen)
 {
     if (!msg_base) return NULL;
 
-    return qp_encode(msg_base, len, 0, outlen);
+    return qp_encode(msg_base, len, 0, force_quote, outlen);
 }
 
 
@@ -2861,12 +3216,155 @@ EXPORTED char *charset_qpencode_mimebody
  * located at 'header'.
  * Returns a buffer which the caller must free.
  */
-EXPORTED char *charset_encode_mimeheader(const char *header, size_t len)
+EXPORTED char *charset_encode_mimeheader(const char *header, size_t len, int force_quote)
 {
     if (!header) return NULL;
 
     if (!len) len = strlen(header);
 
-    return qp_encode(header, len, 1, NULL);
+    return qp_encode(header, len, 1, force_quote, NULL);
+}
+
+/*
+ * If 'isheader' is non-zero "Q" encode (per RFC 2047), otherwise
+ * quoted-printable encode (per RFC 2045), the 'data' of 'len' bytes.
+ * Returns a buffer which the caller must free.
+ * Returns the number of encoded bytes in 'outlen'.
+ */
+EXPORTED char *charset_encode_mimephrase(const char *data)
+{
+    struct buf buf = BUF_INITIALIZER;
+    size_t n;
+
+    buf_setcstr(&buf, "=?UTF-8?Q?");
+    int cnt = 10;
+
+    for (n = 0; data[n]; n++) {
+        unsigned char this = data[n];
+
+        /* RFC2047 forbids splitting multi-octet characters */
+        int needbytes;
+        if (this < 0x80) needbytes = 0;
+        else if (this < 0xc0) needbytes = 0; // UTF-8 continuation
+        else if (this < 0xe0) needbytes = 3;
+        else if (this < 0xf0) needbytes = 6;
+        else if (this < 0xf8) needbytes = 9;
+        else needbytes = 0; // impossible UTF-8 encoding
+        if (cnt + needbytes >= ENCODED_MAX_LINE_LEN) {
+            buf_appendcstr(&buf, "?=\r\n =?UTF-8?Q?");
+            cnt = 11;
+        }
+
+        if (QPMIMEPHRASESAFECHAR[this]) {
+            /* literal representation */
+            buf_putc(&buf, (char)this);
+            cnt++;
+        }
+        else if (this == ' ') {
+            /* per RFC 2047: represent SP in header as '_' for legibility */
+            buf_putc(&buf, '_');
+            cnt++;
+        }
+        else {
+            /* 8-bit representation */
+            buf_printf(&buf, "=%02X", this);
+            cnt += 3;
+        }
+    }
+
+    buf_appendcstr(&buf, "?=");
+
+    return buf_release(&buf);
+}
+
+static void extract_plain_cb(const struct buf *buf, void *rock)
+{
+    struct buf *dst = (struct buf*) rock;
+    const char *p;
+    int seenspace = 0;
+
+    /* Just merge multiple space into one. That's similar to
+     * charset_extract's MERGE_SPACE but since we don't want
+     * it to canonify the text into search form */
+    for (p = buf_base(buf); p < buf_base(buf) + buf_len(buf) && *p; p++) {
+        if (*p == ' ') {
+            if (seenspace) continue;
+            seenspace = 1;
+        } else {
+            seenspace = 0;
+        }
+        buf_appendmap(dst, p, 1);
+    }
+}
+
+EXPORTED char *charset_extract_plain(const char *html) {
+    struct buf src = BUF_INITIALIZER;
+    struct buf dst = BUF_INITIALIZER;
+    charset_t utf8 = charset_lookupname("utf8");
+    char *text;
+    char *tmp, *q;
+    const char *p;
+
+    /* Replace <br> and <p> with newlines */
+    q = tmp = xstrdup(html);
+    p = html;
+    while (*p) {
+        if (!strncmp(p, "<br>", 4) || !strncmp(p, "</p>", 4)) {
+            *q++ = '\n';
+            p += 4;
+        }
+        else if (!strncmp(p, "p>", 3)) {
+            p += 3;
+        } else {
+            *q++ = *p++;
+        }
+    }
+    *q = 0;
+
+    /* Strip html tags */
+    buf_init_ro(&src, tmp, q - tmp);
+    buf_setcstr(&dst, "");
+    charset_extract(&extract_plain_cb, &dst,
+            &src, utf8, ENCODING_NONE, "HTML", CHARSET_KEEPCASE);
+    buf_cstring(&dst);
+
+    /* Trim text */
+    buf_trim(&dst);
+    text = buf_releasenull(&dst);
+    if (!strlen(text)) {
+        free(text);
+        text = NULL;
+    }
+
+    buf_free(&src);
+    free(tmp);
+    charset_free(&utf8);
+
+    return text;
 }
 
+EXPORTED struct char_counts charset_count_validutf8(const char *data, size_t datalen)
+{
+
+    if (datalen > INT32_MAX) {
+        datalen = INT32_MAX;
+    }
+
+    struct char_counts counts = { 0, 0, 0 };
+    int32_t i = 0;
+    int32_t length = (int32_t) datalen;
+    const uint8_t *data8 = (const uint8_t *) data;
+
+    while (i < length) {
+        UChar32 c;
+        U8_NEXT(data8, i, length, c);
+        if (c == 0xfffd)
+            counts.replacement++;
+        else if (c >= 0)
+            counts.valid++;
+        else
+            counts.invalid++;
+    }
+
+    return counts;
+}
diff -pruN 3.0.13-5/lib/charset.h 3.2.0-3/lib/charset.h
--- 3.0.13-5/lib/charset.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/charset.h	2020-04-24 02:03:00.000000000 +0000
@@ -51,10 +51,12 @@
 #define CHARSET_SKIPSPACE (1<<1)
 #define CHARSET_MERGESPACE (1<<2)
 #define CHARSET_SKIPHTML (1<<3)
-#define CHARSET_SNIPPET (1<<4)
+#define CHARSET_KEEPCASE (1<<4)
 #define CHARSET_UNFOLD_SKIPWS (1<<5)
 #define CHARSET_MIME_UTF8 (1<<6)
 #define CHARSET_ESCAPEHTML (1<<8)
+#define CHARSET_KEEPHTML (1<<9)
+#define CHARSET_TRIMWS (1<<10)
 
 #define CHARSET_UNKNOWN_CHARSET (NULL)
 
@@ -68,7 +70,7 @@ typedef int comp_pat;
  *
  * Caveats:
  * * Two instances for the same character encoding are not pointer-equal.
- *   Use string comparison of the charset_name to test for equality.
+ *   Use string comparison of the charset_canon_name to test for equality.
  * * Instances are not safe to use for two simultaneous conversions. It is safe
  *   (and recommended) to reuse an instance for consecutive conversions.
  */
@@ -81,14 +83,30 @@ extern const char *encoding_name(int);
 extern char *charset_convert(const char *s, charset_t charset, int flags);
 extern char *charset_decode_mimeheader(const char *s, int flags);
 extern char *charset_parse_mimeheader(const char *s, int flags);
+extern char *charset_parse_mimexvalue(const char *s, struct buf *language);
+extern char *charset_encode_mimexvalue(const char *s,const char *language);
 extern char *charset_utf8_to_searchform(const char *s, int flags);
 
+/* Normalize the zero-terminted UTF-8 string s to Unicode NFC
+ * normal form.
+ *
+ * Does not enforce CR LF line ending or omission of control
+ * characters as defined in RFC 5198.
+ *
+ * Also see http://www.unicode.org/reports/tr15/ and RFC 5198 */
+extern char *charset_utf8_normalize(const char *s);
 
 extern charset_t charset_lookupname(const char *name);
 extern charset_t charset_lookupnumid(int id);
 extern void charset_free(charset_t *charset);
 
-extern const char *charset_name(charset_t);
+/* Return the canonical charset name. */
+extern const char *charset_canon_name(charset_t);
+
+/* Returns the name as provided in lookupname, if any.
+ * Falls back to returning the canonical name. */
+extern const char *charset_alias_name(charset_t);
+
 extern comp_pat *charset_compilepat(const char *s);
 extern void charset_freepat(comp_pat *pat);
 extern int charset_searchstring(const char *substr, comp_pat *pat,
@@ -101,15 +119,16 @@ extern const char *charset_decode_mimebo
                                            size_t *outlen);
 extern char *charset_encode_mimebody(const char *msg_base, size_t len,
                                      char *retval, size_t *outlen,
-                                     int *outlines);
+                                     int *outlines, int wrap);
 extern char *charset_qpencode_mimebody(const char *msg_base, size_t len,
-                                       size_t *outlen);
+                                       int force_quote, size_t *outlen);
 extern char *charset_to_utf8(const char *msg_base, size_t len, charset_t charset, int encoding);
 extern char *charset_to_imaputf7(const char *msg_base, size_t len, charset_t charset, int encoding);
 
 extern int charset_search_mimeheader(const char *substr, comp_pat *pat, const char *s, int flags);
 
-extern char *charset_encode_mimeheader(const char *header, size_t len);
+extern char *charset_encode_mimeheader(const char *header, size_t len, int force_quote);
+extern char *charset_encode_mimephrase(const char *header);
 
 extern char *charset_unfold(const char *s, size_t len, int flags);
 
@@ -125,4 +144,18 @@ extern int charset_extract(void (*cb)(co
                            charset_t charset, int encoding,
                            const char *subtype, int flags);
 
+/* Extract plain text from HTML, converting <p> and <br>
+ * to newlines and trimming space left by HTML-only lines. */
+EXPORTED char *charset_extract_plain(const char *html);
+
+struct char_counts {
+    size_t valid;
+    size_t replacement;
+    size_t invalid;
+};
+
+/* Count the number of valid, invalid and replacement UTF-8 characters
+ * in the first INT32_MAX bytes of data. */
+extern struct char_counts charset_count_validutf8(const char *data, size_t datalen);
+
 #endif /* INCLUDED_CHARSET_H */
diff -pruN 3.0.13-5/lib/command.c 3.2.0-3/lib/command.c
--- 3.0.13-5/lib/command.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/command.c	2020-04-24 02:03:00.000000000 +0000
@@ -103,7 +103,8 @@ out:
 #define PIPE_READ       0
 #define PIPE_WRITE      1
 
-EXPORTED int command_popen(struct command **cmdp, const char *mode, const char *argv0, ...)
+EXPORTED int command_popen(struct command **cmdp, const char *mode,
+                           const char *cwd, const char *argv0, ...)
 {
     va_list va;
     const char *p;
@@ -161,6 +162,11 @@ EXPORTED int command_popen(struct comman
             close(stdout_pipe[PIPE_WRITE]);
         }
 
+        if (cwd) {
+            r = chdir(cwd);
+            if (r) syslog(LOG_ERR, "Failed to chdir(%s): %m", cwd);
+        }
+
         r = execv(argv0, argv.data);
         syslog(LOG_ERR, "Failed to execute %s: %m", argv0);
         exit(1);
diff -pruN 3.0.13-5/lib/command.h 3.2.0-3/lib/command.h
--- 3.0.13-5/lib/command.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/command.h	2020-04-24 02:03:00.000000000 +0000
@@ -59,7 +59,8 @@ struct command {
 };
 
 extern int run_command(const char *argv0, ...);
-extern int command_popen(struct command **cmdp, const char *mode, const char *argv0, ...);
+extern int command_popen(struct command **cmdp, const char *mode,
+                         const char *cwd, const char *argv0, ...);
 extern int command_pclose(struct command **cmdp);
 extern int command_done_stdin(struct command *);
 
diff -pruN 3.0.13-5/lib/crc32.c 3.2.0-3/lib/crc32.c
--- 3.0.13-5/lib/crc32.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/crc32.c	2020-05-04 03:28:02.000000000 +0000
@@ -615,7 +615,7 @@ static const uint32_t crc32_lookup[16][2
 /* swap endianness */
 static uint32_t swap(uint32_t x)
 {
-#if defined(__GNUC__) || defined(__clang__)
+#if defined(__builtin_bswap32)
     return __builtin_bswap32(x);
 #else
     return (x >> 24) |
diff -pruN 3.0.13-5/lib/crc32c.c 3.2.0-3/lib/crc32c.c
--- 3.0.13-5/lib/crc32c.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/crc32c.c	2020-04-24 02:03:00.000000000 +0000
@@ -595,7 +595,7 @@ static const uint32_t crc32c_lookup[4][2
 /* swap endianness */
 static uint32_t swap(uint32_t x)
 {
-#if defined(__GNUC__) || defined(__clang__)
+#if defined(__builtin_bswap32)
     return __builtin_bswap32(x);
 #else
     return (x >> 24) |
diff -pruN 3.0.13-5/lib/cyr_lock.h 3.2.0-3/lib/cyr_lock.h
--- 3.0.13-5/lib/cyr_lock.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyr_lock.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,17 +43,11 @@
 #ifndef INCLUDED_LOCK_H
 #define INCLUDED_LOCK_H
 
-#ifndef P
-#ifdef __STDC__
-#define P(x) x
-#else
-#define P(x) ()
-#endif
-#endif
-
 #include <sys/stat.h>
 
-extern const char *lock_method_desc;
+extern const char lock_method_desc[];
+
+extern double debug_locks_longer_than;
 
 extern int lock_reopen_ex(int fd, const char *filename,
                           struct stat *sbuf, const char **failaction,
@@ -61,8 +55,8 @@ extern int lock_reopen_ex(int fd, const
 #define lock_reopen(fd, filename, sbuf, failaction) \
         lock_reopen_ex(fd, filename, sbuf, failaction, NULL)
 
-extern int lock_setlock (int fd, int ex, int nb, const char *filename);
-extern int lock_unlock (int fd, const char *filename);
+extern int lock_setlock(int fd, int ex, int nb, const char *filename);
+extern int lock_unlock(int fd, const char *filename);
 
 /* compatibility defines for the older API */
 #define lock_blocking(fd, fn) \
diff -pruN 3.0.13-5/lib/cyr_qsort_r.c 3.2.0-3/lib/cyr_qsort_r.c
--- 3.0.13-5/lib/cyr_qsort_r.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/lib/cyr_qsort_r.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,38 @@
+#include "cyr_qsort_r.h"
+
+#ifdef HAVE_FUNCTION_NESTING
+
+EXPORTED void cyr_qsort_r(void *base, size_t nmemb, size_t size,
+                          int (*compar)(const void *, const void *, void *),
+                          void *thunk)
+{
+    int compar_func(const void *a, const void *b)
+    {
+        return compar(a, b, thunk);
+    }
+    qsort(base, nmemb, size, compar_func);
+}
+
+#else
+
+// NOTE: this is kinda ugly, but it's OK if you're not multithreaded
+
+static void *qsort_r_thunk;
+static int (*qsort_r_compar)(const void *, const void *, void *);
+static int qsort_r_compar_func(const void *a, const void *b)
+{
+    return qsort_r_compar(a, b, qsort_r_thunk);
+}
+
+EXPORTED void cyr_qsort_r(void *base, size_t nmemb, size_t size,
+                          int (*compar)(const void *, const void *, void *),
+                          void *thunk)
+{
+    qsort_r_thunk = thunk;
+    qsort_r_compar = compar;
+    qsort(base, nmemb, size, qsort_r_compar_func);
+    qsort_r_thunk = NULL;
+    qsort_r_compar = NULL;
+}
+
+#endif
diff -pruN 3.0.13-5/lib/cyr_qsort_r.h 3.2.0-3/lib/cyr_qsort_r.h
--- 3.0.13-5/lib/cyr_qsort_r.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/lib/cyr_qsort_r.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,56 @@
+/* cyr_qsort_r.h -- Cyrus compatibility header for qsort_r
+ *
+ * Always use the QSORT_R_COMPAR_ARGS macro to declare the
+ * comparison function, e.g.
+ *
+ *     int mysort QSORT_R_COMPAR_ARGS(const void *pa,
+ *                                    const void *pb,
+ *                                    void *arg)
+ *     {
+ *          ... your code here ...
+ *     }
+ *
+ */
+#ifndef INCLUDED_CYR_QSORT_R_H
+#define INCLUDED_CYR_QSORT_R_H
+
+#include "config.h"
+
+#include <stdlib.h>
+
+#if defined(_GNU_SOURCE) && defined (__GLIBC__) && \
+	((__GLIBC__ > 2) || ((__GLIBC__ == 2) && (__GLIBC_MINOR__ >=0)))
+#define HAVE_GLIBC_QSORT_R
+#endif
+
+#if defined(__NEWLIB__) && \
+	((__NEWLIB__ > 2) || ((__NEWLIB__ == 2) && (__NEWLIB_MINOR__ >= 2)))
+#if defined(_GNU_SOURCE)
+#define HAVE_GLIBC_QSORT_R
+#else
+#define HAVE_BSD_QSORT_R
+#endif
+#endif
+
+#if !defined(HAVE_GLIBC_QSORT_R) && \
+	(defined(__FreeBSD__) || defined(__DragonFly__) || defined(__APPLE__))
+#define HAVE_BSD_QSORT_R
+#endif
+
+#ifdef HAVE_BSD_QSORT_R
+#define QSORT_R_COMPAR_ARGS(a,b,c) (c,a,b)
+#define cyr_qsort_r(base, nmemb, size, compar, thunk) qsort_r(base, nmemb, size, thunk, compar)
+#else
+#define QSORT_R_COMPAR_ARGS(a,b,c) (a,b,c)
+#  if defined(HAVE_GLIBC_QSORT_R)
+#define cyr_qsort_r(base, nmemb, size, compar, thunk) qsort_r(base, nmemb, size, compar, thunk)
+#  elif defined(__GNUC__)
+extern void cyr_qsort_r(void *base, size_t nmemb, size_t size,
+                        int (*compar)(const void *, const void *, void *),
+                        void *thunk);
+#  else
+#    error No qsort_r support
+#  endif
+#endif
+
+#endif /* INCLUDED_CYR_QSORT_R_H */
diff -pruN 3.0.13-5/lib/cyrusdb.c 3.2.0-3/lib/cyrusdb.c
--- 3.0.13-5/lib/cyrusdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb.c	2020-05-04 03:28:02.000000000 +0000
@@ -47,15 +47,17 @@
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <unistd.h>
 #include <fcntl.h>
 
+#include "assert.h"
+#include "bsearch.h"
 #include "cyrusdb.h"
 #include "util.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -67,7 +69,7 @@ extern struct cyrusdb_backend cyrusdb_sk
 extern struct cyrusdb_backend cyrusdb_quotalegacy;
 extern struct cyrusdb_backend cyrusdb_sql;
 extern struct cyrusdb_backend cyrusdb_twoskip;
-extern struct cyrusdb_backend cyrusdb_lmdb;
+extern struct cyrusdb_backend cyrusdb_zeroskip;
 
 static struct cyrusdb_backend *_backends[] = {
     &cyrusdb_flat,
@@ -77,8 +79,8 @@ static struct cyrusdb_backend *_backends
     &cyrusdb_sql,
 #endif
     &cyrusdb_twoskip,
-#if defined HAVE_LMDB
-    &cyrusdb_lmdb,
+#if defined HAVE_ZEROSKIP
+    &cyrusdb_zeroskip,
 #endif
     NULL };
 
@@ -103,7 +105,7 @@ static struct cyrusdb_backend *cyrusdb_f
         char errbuf[1024];
         snprintf(errbuf, sizeof(errbuf),
                  "cyrusdb backend %s not supported", name);
-        fatal(errbuf, EC_CONFIG);
+        fatal(errbuf, EX_CONFIG);
     }
 
     return db;
@@ -119,6 +121,17 @@ static int _myopen(const char *backend,
     if (!backend) backend = DEFAULT_BACKEND; /* not used yet, later */
     db->backend = cyrusdb_fromname(backend);
 
+    /* Check if shared lock is requested */
+    if (flags & CYRUSDB_SHARED) {
+        assert(tid && *tid == NULL);
+        if (flags & CYRUSDB_CONVERT) {
+            syslog(LOG_ERR, "DBERROR: CONVERT and SHARED are mutually exclusive, "
+                    "won't open db %s (backend %s)", fname, backend);
+            r = CYRUSDB_INTERNAL;
+            goto done;
+        }
+    }
+
     /* This whole thing is a fricking critical section.  We don't have the API
      * in place for a safe rename of a locked database, so the choices are
      * basically:
@@ -324,6 +337,8 @@ EXPORTED int cyrusdb_compar(struct db *d
                    const char *a, int alen,
                    const char *b, int blen)
 {
+    if (!db->backend->compar)
+        return bsearch_ncompare_raw(a, alen, b, blen);
     return db->backend->compar(db->engine, a, alen, b, blen);
 }
 
@@ -550,9 +565,6 @@ EXPORTED const char *cyrusdb_detect(cons
     if (!strncmp(buf, "\241\002\213\015twoskip file\0\0\0\0", 16))
         return "twoskip";
 
-    if (!strncmp(buf+16, "\xde\xc0\xef\xbe", 4))
-        return "lmdb";
-
     /* unable to detect SQLite databases or flat files explicitly here */
     return NULL;
 }
@@ -662,3 +674,60 @@ HIDDEN int cyrusdb_generic_unlink(const
     return 0;
 }
 
+EXPORTED const char *cyrusdb_strerror(int r)
+{
+    const char *err = "unknown error";
+
+    switch (r) {
+    case CYRUSDB_OK:
+        err = "not an error";
+        break;
+
+    case CYRUSDB_DONE:
+        err = "done";
+        break;
+
+    case CYRUSDB_IOERROR:
+        err = "IO error";
+        break;
+
+    case CYRUSDB_AGAIN:
+        err = "again";
+        break;
+
+    case CYRUSDB_EXISTS:
+        err = "item exists";
+        break;
+
+    case CYRUSDB_INTERNAL:
+        err = "internal error";
+        break;
+
+    case CYRUSDB_NOTFOUND:
+        err = "item not found";
+        break;
+
+    case CYRUSDB_LOCKED:
+        err = "locked";
+        break;
+
+    case CYRUSDB_NOTIMPLEMENTED:
+        err = "action not implemented";
+        break;
+
+    case CYRUSDB_FULL:
+        err = "no space available";
+        break;
+
+    case CYRUSDB_READONLY:
+        err = "database is readonly";
+        break;
+
+    default:
+        err = "not a cyrusdb error";
+        break;
+    }
+
+    return err;
+}
+
diff -pruN 3.0.13-5/lib/cyrusdb.h 3.2.0-3/lib/cyrusdb.h
--- 3.0.13-5/lib/cyrusdb.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb.h	2020-04-24 02:03:00.000000000 +0000
@@ -58,11 +58,10 @@ enum cyrusdb_ret {
     CYRUSDB_NOTFOUND = -5,
     CYRUSDB_LOCKED = -6,
     CYRUSDB_NOTIMPLEMENTED = -7,
-    CYRUSDB_FULL = -8
+    CYRUSDB_FULL = -8,
+    CYRUSDB_READONLY = -9
 };
 
-#define cyrusdb_strerror(c) ("cyrusdb error")
-
 enum cyrusdb_initflags {
     CYRUSDB_RECOVER = 0x01
 };
@@ -75,7 +74,8 @@ enum cyrusdb_openflags {
     CYRUSDB_CREATE    = 0x01,    /* Create the database if not existant */
     CYRUSDB_MBOXSORT  = 0x02,    /* Use mailbox sort order ('.' sorts 1st) */
     CYRUSDB_CONVERT   = 0x04,    /* Convert to the named format if not already */
-    CYRUSDB_NOCOMPACT = 0x08     /* Don't run any database compaction routines */
+    CYRUSDB_NOCOMPACT = 0x08,    /* Don't run any database compaction routines */
+    CYRUSDB_SHARED    = 0x10     /* Open in shared lock mode */
 };
 
 typedef int foreach_p(void *rock,
@@ -91,6 +91,7 @@ typedef int cyrusdb_archiver(const strar
 
 struct dbengine;
 
+
 struct cyrusdb_backend {
     const char *name;
 
@@ -313,4 +314,6 @@ int cyrusdb_generic_archive(const strarr
 int cyrusdb_generic_noarchive(const strarray_t *fnames, const char *dirname);
 int cyrusdb_generic_unlink(const char *fname, int flags);
 
+extern const char *cyrusdb_strerror(int r);
+
 #endif /* INCLUDED_CYRUSDB_H */
diff -pruN 3.0.13-5/lib/cyrusdb_lmdb.c 3.2.0-3/lib/cyrusdb_lmdb.c
--- 3.0.13-5/lib/cyrusdb_lmdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_lmdb.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,955 +0,0 @@
-/*  cyrusdb_lmdb: a backend built on Lightning Memory-Mapped Database (LMDB)
- *
- * Copyright (c) 2016 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-/*
- * This backend implements the Cyrus DB API on top of the Lightning
- * Memory-Mapped Database (LMDB).
- *
- * These two APIs work together nicely most of the time, but there are
- * a few caveats:
- *
- * - LMDB requires database environments to be set to a (user-configurable)
- *   maximum size. This backend sets a reasonable high default size (see
- *   maxdbsize). Cyrus installations may override this by setting the
- *   environment variable CYRUSDB_LMDB_MAXSIZE. The value of this variable
- *   must be an integer, optionally followed (without space) by "mb" or "gb"
- *   to define the maximum size in bytes, megabytes or gigabytes. The size
- *   should be a multiple of the OS page size.
- *
- * - Callbacks within foreach might call a database engine without a
- *   transaction, although the foreach operates within an existing or
- *   newly created transaction. But LMDB only allows one unnested
- *   transaction per thread.
- *   As a consequence, the database engine has to keep track of the
- *   current transaction and reuses that one if no transaction has been
- *   supplied by caller. This is similar to the inner workings of the
- *   skiplist and twoskip backends.
- *
- * - Callbacks within foreach might update the currently seeked data
- *   item. To protect the database from corruption, the cursor is
- *   invalidated and reseeked after the operation, causing foreach()
- *   performance degrade to O(m*log n), where m denotes the iteration
- *   count and n the number of items in the database.
- *
- * - LMDB transactions operate on database environments and database
- *   environments may contain multiple databases. A single writer
- *   locks all other operations within this environment. To avoid
- *   (already observed) deadlocks between multiple open databases
- *   of Cyrus DB callers, this backend creates an unique environment
- *   for each database.
- *
- */
-
-/* TODO:
- * - support optional resize in myopen: e.g. resize if DB is >80% full
- */
-
-#include <config.h>
-
-#include <assert.h>
-#include <errno.h>
-#include <syslog.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <unistd.h>
-
-#include "bsearch.h"
-#include "cyrusdb.h"
-#include "hash.h"
-#include "xstrlcpy.h"
-#include "util.h"
-
-#include "lmdb.h"
-
-struct txn {
-    MDB_dbi dbi;
-    MDB_txn *mtxn;
-};
-
-struct dbengine {
-    MDB_env *env;     /* mdb environment, one per database */
-    char *fname;      /* external filename of the database */
-    int flags;        /* create flags */
-    void *data;       /* allocated buffer for fetched data */
-    size_t datalen;   /* bytes allocated in data */
-    struct txn *tid;  /* master transaction, if any. See begin_txn. */
-    MDB_cursor *mcur; /* current cursor of foreach(), if any */
-};
-
-struct dblist {
-    struct dbengine *db;
-    struct dblist *next;
-};
-
-/* Default environment size is 512MB */
-static size_t maxdbsize = 1 << 29;
-
-#define DEBUG 0
-
-#if DEBUG
-#    define PDEBUG(fmt, args...) syslog(LOG_DEBUG, fmt, ## args)
-#else
-#    define PDEBUG(fmt, args...) /* do nothing */
-#endif
-
-/* Global list of open dbs for internal bookkeeping */
-static struct dblist *dbs = NULL;
-
-static void register_db(struct dbengine *db)
-{
-    struct dblist *l = xzmalloc(sizeof(struct dblist));
-    assert(db);
-    l->db = db;
-    l->next = dbs;
-    dbs = l;
-}
-
-static void unregister_db(struct dbengine *db)
-{
-    /* Caller must make sure that memory pointed to by db is freed */
-    struct dblist *l = dbs;
-    assert(db && dbs);
-
-    if (dbs->db == db) {
-        /* Reset head of list */
-        dbs = l->next;
-        free(l);
-        return;
-    }
-    while (l->next) {
-        /* Purge db from list */
-        if (l->next->db == db) {
-            struct dblist *tmp = l->next;
-            l->next = l->next->next;
-            free(tmp);
-            return;
-        }
-        l = l->next;
-    }
-    /* Should never be reached */
-    assert(0);
-}
-
-static int my_mdberror(int mr) {
-    switch (mr) {
-        case MDB_MAP_FULL:
-            return CYRUSDB_FULL;
-        case MDB_NOTFOUND:
-            return CYRUSDB_NOTFOUND;
-        case MDB_MAP_RESIZED:
-            /* Should be CYRUSDB_AGAIN, but resize requires to reopen env */
-            return CYRUSDB_IOERROR;
-        case MDB_SUCCESS:
-            return CYRUSDB_OK;
-        default:
-            return CYRUSDB_INTERNAL;
-    }
-}
-
-static int mboxcmp(const MDB_val *a, const MDB_val *b);
-
-static int bufferval(struct dbengine *db, MDB_val val, const char **dst, size_t *dstlen)
-{
-    assert(db && val.mv_data);
-
-    /* Allocate at least 1 byte so data never points to NULL */
-    db->data = xrealloc(db->data, val.mv_size + 1);
-    memcpy(db->data, val.mv_data, val.mv_size);
-    *dst = db->data;
-    *dstlen = val.mv_size;
-    db->datalen = val.mv_size;
-
-    return CYRUSDB_OK;
-}
-
-static int commit_txn(struct dbengine *db, struct txn *tid)
-{
-    int mr;
-
-    assert(db && tid);
-
-    PDEBUG("cyrusdb_lmdb(%s)[commit_txn] tid=%p", db->fname, tid);
-
-    mr = mdb_txn_commit(tid->mtxn);
-    free(tid);
-    if (tid == db->tid) db->tid = NULL;
-
-    if (mr) syslog(LOG_ERR, "lmdb: %s", mdb_strerror(mr));
-    return mr ? my_mdberror(mr) : CYRUSDB_OK;
-}
-
-static int abort_txn(struct dbengine *db, struct txn *tid)
-{
-    assert(db && tid);
-
-    PDEBUG("cyrusdb_lmdb(%s)[abort_txn] tid=%p", db->fname, tid);
-
-    mdb_txn_abort(tid->mtxn);
-    free(tid);
-    if (tid == db->tid) db->tid = NULL;
-
-    return CYRUSDB_OK;
-}
-
-static int begin_txn(struct dbengine *db, struct txn **tidptr, int readonly)
-{
-    struct txn *tid = xzmalloc(sizeof(struct txn));
-    int mflags, mr, r;
-    struct MDB_txn *parent = NULL;
-
-    assert(db && tidptr);
-
-    PDEBUG("cyrusdb_lmdb(%s)[begin_txn] readonly=%d tidptr=%p *tidptr=%p",
-            db->fname, readonly, tidptr, tidptr ? *tidptr : NULL);
-
-    /* Read-only transactions may only be master transactions and do
-     * not allow nested transactions. */
-    readonly = !db->tid ? readonly : 0;
-
-    /*
-     * Hacky workaround, similar to skiplist
-     *
-     * If no transaction was passed, but we're in a transaction,
-     * then create a nested exception within the current main
-     * transaction.
-     *
-     * Note that transactions are always either the main transaction,
-     * or a direct descendant of it. There are no deeper transaction
-     * levels supported (although LMDB supports them).
-     */
-    if (db->tid) {
-        parent = db->tid->mtxn;
-    }
-
-    /* Begin a new LMDB transaction */
-    mr = mdb_txn_begin(db->env, parent, readonly ? MDB_RDONLY : 0, &tid->mtxn);
-    if (mr) goto fail;
-
-    /* Open the database */
-    mflags = db->flags & CYRUSDB_CREATE ? MDB_CREATE : 0;
-    mr = mdb_dbi_open(tid->mtxn, NULL /*name*/, mflags, &tid->dbi);
-    if (mr) goto fail;
-
-    if (db->flags & CYRUSDB_MBOXSORT) {
-        /* Set mboxsort order */
-        mr = mdb_set_compare(tid->mtxn, tid->dbi, mboxcmp);
-        if (mr) goto fail;
-    }
-
-    if (!db->tid) {
-        /* Set the master transaction */
-        db->tid = tid;
-    }
-    *tidptr = tid;
-    return CYRUSDB_OK;
-
-fail:
-    r = my_mdberror(mr);
-    if (tid->mtxn) abort_txn(db, tid);
-    syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-    return r;
-}
-
-/*
- * Get or create an existing transaction from tidptr, and store it in _tidptr.
- */
-static int getorset_txn(struct dbengine *db,
-                        struct txn **tidptr,
-                        struct txn **_tidptr,
-                        int readonly)
-{
-    struct txn *tid;
-    int r;
-
-    assert(_tidptr);
-    tid = *_tidptr;
-
-    if (!tidptr || !*tidptr) {
-        /* Create a new transaction */
-        if ((r = begin_txn(db, &tid, readonly))) {
-            *_tidptr = NULL;
-            return r;
-        }
-    } else {
-        /* Reuse the existing transaction */
-        tid = *tidptr;
-    }
-    if (tidptr) {
-        /* Refresh tidptr */
-        *tidptr = tid;
-    }
-    /* Return the transaction */
-    *_tidptr = tid;
-
-    PDEBUG("cyrusdb_lmdb(%s)[getorset_txn] tidptr=%p *tidptr=%p _tidptr=%p *_tidptr=%p ",
-            db->fname, tidptr, tidptr ? *tidptr : NULL, _tidptr, _tidptr ? *_tidptr : NULL);
-
-    return CYRUSDB_OK;
-}
-
-static int mboxcmp(const MDB_val *a, const MDB_val *b)
-{
-    return bsearch_ncompare_mbox((const char *) a->mv_data, a->mv_size,
-                                 (const char *) b->mv_data, b->mv_size);
-}
-
-static int my_mkparentdir(const char *fname)
-{
-    struct buf buf = BUF_INITIALIZER;
-    int r;
-
-    buf_setcstr(&buf, fname);
-    r = cyrus_mkdir(buf_cstring(&buf), 0755);
-    buf_free(&buf);
-    return r;
-}
-
-static int my_stat(const char *fname)
-{
-    struct stat sb;
-    int r;
-
-    r = stat(fname, &sb);
-    if (r < 0)
-        r = -errno;
-    return r;
-}
-
-static int myopen(const char *fname, int flags, struct dbengine **ret,
-                  struct txn **tidptr)
-{
-    struct dbengine *db;
-    int r, mr = 0;
-
-    PDEBUG("cyrusdb_lmdb(%s)[open] flags=0x%x tidptr=%p *tidptr=%p",
-            fname, flags, tidptr, tidptr ? *tidptr : NULL);
-    assert(fname && ret);
-
-    /* Create a new database engine */
-    db = (struct dbengine *) xzmalloc(sizeof(struct dbengine));
-    db->fname = xstrdup(fname);
-    db->flags = flags;
-
-    /* Assert that either the parent directory or the database exists */
-    r = flags & CYRUSDB_CREATE ? my_mkparentdir(fname) : my_stat(fname);
-    if (r) {
-        /* Both my_stat and my_mkparentdir preserve errno */
-        r = errno == ENOENT ? CYRUSDB_NOTFOUND : CYRUSDB_IOERROR;
-        goto fail;
-    }
-
-    /* Create the environment for this database */
-    mr = mdb_env_create(&db->env);
-    if (mr) {
-        r = CYRUSDB_INTERNAL;
-        goto fail;
-    }
-
-    /* Size (or resize) the environment */
-    mr = mdb_env_set_mapsize(db->env, maxdbsize);
-    if (mr) {
-        r = CYRUSDB_INTERNAL;
-        goto fail;
-    }
-
-    /* Open the environment */
-    mr = mdb_env_open(db->env, fname, MDB_NOSUBDIR, 0600);
-    if (mr) {
-        r = CYRUSDB_IOERROR;
-        goto fail;
-    }
-
-    /* Lock the database, if requested */
-    if (tidptr) {
-        r = begin_txn(db, tidptr, 0);
-        if (r) goto fail;
-    }
-
-    /* Keep database for internal bookkeeping */
-    register_db(db);
-
-    /* Return the database handle */
-    *ret = db;
-    return CYRUSDB_OK;
-
-fail:
-    if (mr)
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-    if (db->env)
-        mdb_env_close(db->env);
-    free(db->fname);
-    free(db);
-    return r;
-}
-
-static void close_db(struct dbengine *db)
-{
-    assert(db);
-
-    if (db->tid) {
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): stray transaction %p",
-                db->fname, db->tid);
-        abort_txn(db, db->tid);
-    }
-    if (db->env) {
-        mdb_env_close(db->env);
-    }
-    if (db->data) {
-        free(db->data);
-    }
-    free(db->fname);
-    free(db);
-}
-
-static int myclose(struct dbengine *db)
-{
-    assert(db);
-
-    if (db->mcur) {
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): close within foreach", db->fname);
-        return CYRUSDB_INTERNAL;
-    }
-
-    PDEBUG("cyrusdb_lmdb(%s)[close]", db->fname);
-    close_db(db);
-    unregister_db(db);
-    return CYRUSDB_OK;
-}
-
-static int fetch(struct dbengine *db, const char *key, size_t keylen,
-                 const char **data, size_t *datalen, struct txn **tidptr)
-{
-    MDB_val mkey, mval;
-    struct txn *tid;
-    int r, r2 = 0, mr;
-
-    PDEBUG("cyrusdb_lmdb(%s)[fetch] tidptr=%p *tidptr=%p key='%.*s'",
-            db->fname, tidptr, tidptr ? *tidptr : NULL, (int) keylen, key);
-    assert(db && key);
-
-    mkey.mv_data = (void*) key;
-    mkey.mv_size = keylen;
-
-    /* Open or reuse transaction */
-    r = getorset_txn(db, tidptr, &tid, !tidptr /*readonly*/);
-    if (r) goto fail;
-
-    mr = mdb_get(tid->mtxn, tid->dbi, &mkey, &mval);
-    if (mr == MDB_NOTFOUND) {
-        /* That's not an error */
-        r = CYRUSDB_NOTFOUND;
-        if (datalen) *datalen = 0;
-        if (data) *data = NULL;
-    } else if (mr) {
-        /* That's an error */
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-        r = CYRUSDB_INTERNAL;
-        goto fail;
-    } else if (data && datalen) {
-        /* Cache the fetched data from LMDB memory in own buffer */
-        r = bufferval(db, mval, data, datalen);
-        if (r) goto fail;
-    }
-
-    /* Commit or export the transaction */
-    if (!tidptr) {
-        r2 = commit_txn(db, tid);
-        if (r2) goto fail;
-    } else {
-        *tidptr = tid;
-        r2 = CYRUSDB_OK;
-    }
-
-    return r ? r : r2;
-
-fail:
-    if (tid && (!tidptr || !*tidptr)) abort_txn(db, tid);
-    return r ? r : r2;
-}
-
-static int foreach(struct dbengine *db, const char *prefix, size_t prefixlen,
-                   foreach_p *p, foreach_cb *cb, void *rock, struct txn **tidptr)
-{
-    int r, r2, mr = 0;
-    struct txn *tid = NULL;
-    MDB_val mkey, mval;
-    enum MDB_cursor_op op;
-    struct buf cur = BUF_INITIALIZER;
-
-    PDEBUG("cyrusdb_lmdb(%s)[foreach] tidptr=%p *tidptr=%p prefix='%.*s'",
-            db->fname, tidptr, tidptr ? *tidptr : NULL, (int) prefixlen, prefix);
-    assert(db);
-
-    /* Open or reuse transaction */
-    r = getorset_txn(db, tidptr, &tid, 0);
-    if (r) goto fail;
-
-    mr = mdb_cursor_open(tid->mtxn, tid->dbi, &db->mcur);
-    if (mr) goto fail;
-
-    /* Normalize and set prefix for search */
-    if (prefix && !prefixlen) {
-        prefix = NULL;
-    }
-
-    /* Initialize cursor */
-    mkey.mv_data = (void*) prefix;
-    mkey.mv_size = prefix ? prefixlen : 0;
-    op = prefix ? MDB_SET_RANGE : MDB_FIRST;
-    mr = mdb_cursor_get(db->mcur, &mkey, &mval, op);
-
-    /* Iterate cursor until no records or out of range */
-    while (!mr) {
-        if (prefixlen && (mkey.mv_size < prefixlen))
-            break;
-
-        if (prefix && memcmp(mkey.mv_data, prefix, prefixlen))
-            break;
-
-        if (!p || p(rock, mkey.mv_data, mkey.mv_size, mval.mv_data, mval.mv_size)) {
-            /* Cache the current position in local memory */
-            buf_setmap(&cur, mkey.mv_data, mkey.mv_size);
-
-            r = cb(rock, cur.s, cur.len, mval.mv_data, mval.mv_size);
-            if (r) break;
-
-            if (db->mcur == NULL) {
-                /* An update has invalidated the cursor. Reseek cursor. */
-                mr = mdb_cursor_open(tid->mtxn, tid->dbi, &db->mcur);
-                if (mr) break;
-
-                mkey.mv_data = cur.s;
-                mkey.mv_size = cur.len;
-                mr = mdb_cursor_get(db->mcur, &mkey, &mval, MDB_SET_RANGE);
-                if (mr) break;
-
-                if (mkey.mv_size != cur.len || memcmp(mkey.mv_data, cur.s, cur.len)) {
-                    /* The current position has been deleted. */
-                    continue;
-                }
-            }
-        }
-
-        /* Advance cursor */
-        mr = mdb_cursor_get(db->mcur, &mkey, &mval, MDB_NEXT);
-    }
-
-    if (mr && mr != MDB_NOTFOUND)
-        goto fail;
-
-    if (db->mcur) {
-        mdb_cursor_close(db->mcur);
-        db->mcur = NULL;
-    }
-    buf_free(&cur);
-
-    /* Export or commit transaction */
-    r2 = tidptr ? CYRUSDB_OK : commit_txn(db, tid);
-
-    return r ? r : r2;
-
-fail:
-    if (db->mcur) {
-        mdb_cursor_close(db->mcur);
-        db->mcur = NULL;
-    }
-    buf_free(&cur);
-
-    if (tid && (!tidptr || !*tidptr))
-        abort_txn(db, tid);
-    if (mr) {
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-        r = my_mdberror(mr);
-    }
-    return r;
-}
-
-static int put(struct dbengine *db, const char *key, size_t keylen,
-               const char *data, size_t datalen, struct txn **tidptr, int mflags)
-{
-    MDB_val mkey, mval;
-    struct txn *tid;
-    int r, mr;
-
-    mkey.mv_data = (void*) key;
-    mkey.mv_size = keylen;
-    mval.mv_data = (void*) data;
-    mval.mv_size = datalen;
-
-    /* Invalidate cursor */
-    if (db->mcur) {
-        mdb_cursor_close(db->mcur);
-        db->mcur = NULL;
-    }
-
-    /* Open or reuse transaction */
-    r = getorset_txn(db, tidptr, &tid, 0);
-    if (r) goto fail;
-
-    mr = mdb_put(tid->mtxn, tid->dbi, &mkey, &mval, mflags);
-    if (mr) {
-        /* Return the appropriate error code for existing key overwrites */
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-        r = (mr == MDB_KEYEXIST && (mflags & MDB_NOOVERWRITE)) ? \
-            CYRUSDB_EXISTS : CYRUSDB_INTERNAL;
-        goto fail;
-    }
-
-    /* Commit or export the transaction */
-    if (!tidptr) {
-        r = commit_txn(db, tid);
-        if (r) goto fail;
-    } else {
-        *tidptr = tid;
-    }
-
-    return CYRUSDB_OK;
-
-fail:
-    if (tid && (!tidptr || !*tidptr)) abort_txn(db, tid);
-    return r;
-}
-
-static int create(struct dbengine *db, const char *key, size_t keylen,
-                  const char *data, size_t datalen, struct txn **tidptr)
-{
-
-    PDEBUG("cyrusdb_lmdb(%s)[create] tidptr=%p *tidptr=%p key='%.*s' data='%.*s'",
-            db->fname, tidptr, tidptr ? *tidptr : NULL,
-            (int) keylen, key, (int) datalen, data);
-    return put(db, key, keylen, data, datalen, tidptr, MDB_NOOVERWRITE);
-}
-
-static int store(struct dbengine *db, const char *key, size_t keylen,
-                  const char *data, size_t datalen, struct txn **tidptr)
-{
-    PDEBUG("cyrusdb_lmdb(%s)[store] tidptr=%p *tidptr=%p key='%.*s' data='%.*s'",
-            db->fname, tidptr, tidptr ? *tidptr : NULL,
-            (int) keylen, key, (int) datalen, data);
-    return put(db, key, keylen, data, datalen, tidptr, 0);
-}
-
-static int delete(struct dbengine *db, const char *key, size_t keylen,
-                  struct txn **tidptr, int force)
-{
-    MDB_val mkey;
-    struct txn *tid;
-    int r, mr;
-
-    PDEBUG("cyrusdb_lmdb(%s)[delete] tidptr=%p *tidptr=%p",
-            db->fname, tidptr, tidptr ? *tidptr : NULL);
-
-    mkey.mv_data = (void*) key;
-    mkey.mv_size = keylen;
-
-    /* Invalidate cursor */
-    if (db->mcur) {
-        mdb_cursor_close(db->mcur);
-        db->mcur = NULL;
-    }
-
-    /* Open or reuse transaction */
-    r = getorset_txn(db, tidptr, &tid, 0);
-    if (r) goto fail;
-
-    mr = mdb_del(tid->mtxn, tid->dbi, &mkey, NULL);
-    if (mr == MDB_NOTFOUND) {
-        /* Force deleting an inexistent key is not an error */
-        r = force ? CYRUSDB_OK : CYRUSDB_NOTFOUND;
-        if (r) goto fail;
-    } else if (mr) {
-        syslog(LOG_ERR, "cyrusdb_lmdb(%s): %s", db->fname, mdb_strerror(mr));
-        r = CYRUSDB_INTERNAL;
-        goto fail;
-    }
-
-    /* Commit or export the transaction */
-    if (!tidptr) {
-        r = commit_txn(db, tid);
-        if (r) goto fail;
-    } else {
-        *tidptr = tid;
-    }
-
-    return CYRUSDB_OK;
-
-fail:
-    if (tid && (!tidptr || !*tidptr)) abort_txn(db, tid);
-    return r;
-}
-
-static int mycompar(struct dbengine *db, const char *a, int alen,
-                    const char *b, int blen)
-{
-    int cmp;
-    struct txn *tid = NULL;
-    MDB_val ma, mb;
-    int use_mboxcmp = db->flags & CYRUSDB_MBOXSORT;
-
-    assert(db && a && b);
-
-    /* LMDB internal order requires a transaction to operate on */
-    if (!use_mboxcmp && begin_txn(db, &tid, 1 /*readonly*/)) {
-        syslog(LOG_ERR, "lmdb_compar(%s): internal error", db->fname);
-        return -1;
-    }
-
-    ma.mv_data = (void *) a;
-    ma.mv_size = alen;
-    mb.mv_data = (void *) b;
-    mb.mv_size = blen;
-
-    /* Compare values using appropriate comparator */
-    cmp = use_mboxcmp ? mboxcmp(&ma, &mb) : mdb_cmp(tid->mtxn, tid->dbi, &ma, &mb);
-
-    /* Discard LMDB-owned transaction, if any */
-    if (!use_mboxcmp && abort_txn(db, tid)) {
-        syslog(LOG_ERR, "lmdb_compar(%s): internal error", db->fname);
-        return -1;
-    }
-
-    return cmp;
-}
-
-static int init(const char *dbdir __attribute__((unused)),
-                int myflags __attribute__((unused)))
-{
-    PDEBUG("cyrusdb_lmdb(%s)[init]", dbdir);
-
-    char *val = getenv("CYRUSDB_LMDB_MAXSIZE");
-    int pagesize;
-
-    if (val) {
-        /* Parse user-defined maximum database size */
-        char *endptr = NULL;
-        long size;
-        int myerrno;
-        size_t guard, factor = 1;
-
-        /* Convert and keep conversion error */
-        size = strtol(val, &endptr, 10);
-        myerrno = errno;
-        if (endptr) {
-            /* Be nice to humans: parse 1gb, 3mb or byte size */
-            if (!strcasecmp(endptr, "mb")) {
-                factor = 1024 * 1024;
-            } else if (!strcasecmp(endptr, "gb")) {
-                factor = 1024 * 1024 * 1024;
-            } else if (*endptr) {
-                factor = 0;
-            }
-        }
-        /* Check for overflows */
-        guard = (size_t) size * factor;
-        if (factor != 0 && guard/factor != (size_t) size) myerrno = ERANGE;
-
-        /* Validate input */
-        if (factor == 0 || myerrno == ERANGE || size < 0) {
-            syslog(LOG_ERR, "cyrusdb_lmdb: invalid CYRUSDB_LMDB_MAXSIZE: %s", val);
-            return CYRUSDB_INTERNAL;
-        }
-        /* Use user-defined value */
-        maxdbsize = guard;
-        PDEBUG("cyrusdb_lmdb: set maximum db size to %zu bytes", maxdbsize);
-    }
-    /* Warn about sub-par configuration */
-    pagesize = getpagesize();
-    if ((maxdbsize % pagesize) != 0) {
-        syslog(LOG_ERR,
-                "cyrusdb_lmdb: db size %zu isn't a multiple of pagesize %d",
-                maxdbsize, pagesize);
-    }
-    return CYRUSDB_OK;
-}
-
-static int done(void)
-{
-    struct dblist *l;
-
-    PDEBUG("cyrusdb_lmdb[done]");
-    l = dbs;
-    while (l) {
-        struct dblist *tmp;
-        syslog(LOG_ERR, "cyrusdb_lmdb: closing stray database %s", l->db->fname);
-        close_db(l->db);
-        tmp = l;
-        l = l->next;
-        free(tmp);
-    }
-    dbs = NULL;
-    return CYRUSDB_OK;
-}
-
-static int mysync(void)
-{
-    int r, mr;
-    struct dblist *l;
-
-    r = CYRUSDB_OK;
-    for (l = dbs; l; l = l->next) {
-        PDEBUG("cyrusdb_lmdb(%s)[sync]", l->db->fname);
-        mr = mdb_env_sync(l->db->env, 1 /*force*/);
-        if (mr) {
-            syslog(LOG_ERR, "cyrusdb_lmdb(%s): sync: %s", l->db->fname, mdb_strerror(mr));
-            r = CYRUSDB_INTERNAL;
-            break;
-        }
-    }
-    return r;
-}
-
-static int archive(const strarray_t *fnames, const char *dirname)
-{
-    struct hash_table want = HASH_TABLE_INITIALIZER;
-    struct dblist *l = dbs;
-    char dstname[1024], *dp;
-    size_t length, rest, n;
-    int i, r, init = 1;
-
-    PDEBUG("cyrusdb_lmdb[archive]");
-
-    if (!strarray_size(fnames))
-        return 0;
-
-    construct_hash_table(&want, strarray_size(fnames), 0);
-    for (i = 0; i < fnames->count; i++) {
-        hash_insert(strarray_nth(fnames, i), (void*) 1, &want);
-    }
-
-    /* Prepare filename buffer */
-    n = strlcpy(dstname, dirname, sizeof(dstname));
-    if (n == sizeof(dstname)) {
-        syslog(LOG_ERR, "cyrusdb_lmdb: archive: long dirname %s", dirname);
-        r = CYRUSDB_IOERROR;
-        goto fail;
-    }
-    length = strlen(dstname);
-    dp = dstname + length;
-    rest = sizeof(dstname) - length;
-
-    r = CYRUSDB_OK;
-    for(l = dbs; l; l = l->next) {
-        char *base;
-        int mr;
-
-        /* Skip unwanted databases */
-        if (!hash_lookup(l->db->fname, &want)) {
-            continue;
-        }
-
-        /* Append the basename of the source database file to dirname.
-         * This flattens all fnames into the same target directory, which
-         * isn't entirely safe but replicates the generic archiver */
-        base = strrchr(l->db->fname, '/');
-        base = base ? base : l->db->fname;
-        if (strlen(base) + length > sizeof(dstname)) {
-            syslog(LOG_ERR, "cyrusdb_lmdb: archive: long filename %s/%s", dirname, base);
-            r = CYRUSDB_IOERROR;
-            break;
-        }
-        strlcpy(dp, base, rest);
-
-        /* If this is the first archival, make sure that dirname exists */
-        if (init) {
-            r = my_mkparentdir(dstname);
-            if (r) {
-                syslog(LOG_ERR, "cyrusdb_lmdb(%s): archive: %s", dirname, strerror(errno));
-                r = CYRUSDB_IOERROR;
-                break;
-            }
-            init = 0;
-        }
-
-        /* Archive the current database */
-        PDEBUG("cyrusdb_lmdb(%s): archiving to %s", l->db->fname, dstname);
-        if ((mr = mdb_env_copy(l->db->env, dstname))) {
-            syslog(LOG_ERR, "cyrusdb_lmdb(%s): archive: %s", dstname, mdb_strerror(mr));
-            r = mr == EEXIST ? CYRUSDB_EXISTS : CYRUSDB_INTERNAL;
-            break;
-        }
-    }
-
-fail:
-    free_hash_table(&want, NULL);
-    return r;
-}
-
-static int myunlink(const char *fname, int flags __attribute__((unused)))
-{
-    /* XXX: smart lock checks? */
-    char *lockname = strconcat(fname, "-lock", (char *)NULL);
-    unlink(fname);
-    unlink(lockname);
-    free(lockname);
-    return 0;
-}
-
-EXPORTED struct cyrusdb_backend cyrusdb_lmdb =
-{
-    "lmdb",                     /* name */
-
-    &init,
-    &done,
-    &mysync,
-    &archive,
-    &myunlink,
-
-    &myopen,
-    &myclose,
-
-    &fetch,
-    &fetch, /* fetchlock */
-    NULL,   /* fetchnext */
-
-    &foreach,
-    &create,
-    &store,
-    &delete,
-
-    &commit_txn,
-    &abort_txn,
-
-    NULL, /* dump */
-    NULL, /* consistent */
-    NULL, /* repack */
-    &mycompar
-};
diff -pruN 3.0.13-5/lib/cyrusdb_quotalegacy.c 3.2.0-3/lib/cyrusdb_quotalegacy.c
--- 3.0.13-5/lib/cyrusdb_quotalegacy.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_quotalegacy.c	2020-04-24 02:03:00.000000000 +0000
@@ -56,6 +56,7 @@
 #endif
 #include <stdio.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <errno.h>
@@ -84,7 +85,6 @@
 #include "assert.h"
 #include "bsearch.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "hash.h"
 #include "map.h"
 #include "libcyr_cfg.h"
@@ -162,7 +162,7 @@ static void hash_quota(char *buf, size_t
     unsigned len;
 
     if ((len = snprintf(buf, size, "%s", path)) >= size) {
-        fatal("insufficient buffer size in hash_quota", EC_TEMPFAIL);
+        fatal("insufficient buffer size in hash_quota", EX_TEMPFAIL);
     }
     buf += len;
     size -= len;
@@ -172,7 +172,7 @@ static void hash_quota(char *buf, size_t
         c = (char) dir_hash_c(qr, config_fulldirhash);
         if ((len = snprintf(buf, size, "%s%c/%s",
                             FNAME_DOMAINDIR, c, qr)) >= size) {
-            fatal("insufficient buffer size in hash_quota", EC_TEMPFAIL);
+            fatal("insufficient buffer size in hash_quota", EX_TEMPFAIL);
         }
         *p++ = '!';  /* reassemble domain!qr */
         qr = p;
@@ -183,7 +183,7 @@ static void hash_quota(char *buf, size_t
             /* quota for entire domain */
             if (snprintf(buf, size, "%sroot", FNAME_QUOTADIR) >= (int) size) {
                 fatal("insufficient buffer size in hash_quota",
-                      EC_TEMPFAIL);
+                      EX_TEMPFAIL);
             }
             return;
         }
@@ -192,7 +192,7 @@ static void hash_quota(char *buf, size_t
     c = name_to_hashchar(qr, 0);
 
     if (snprintf(buf, size, "%s%c/%s", FNAME_QUOTADIR, c, qr) >= (int) size) {
-        fatal("insufficient buffer size in hash_quota", EC_TEMPFAIL);
+        fatal("insufficient buffer size in hash_quota", EX_TEMPFAIL);
     }
 }
 
diff -pruN 3.0.13-5/lib/cyrusdb_skiplist.c 3.2.0-3/lib/cyrusdb_skiplist.c
--- 3.0.13-5/lib/cyrusdb_skiplist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_skiplist.c	2020-04-24 02:03:00.000000000 +0000
@@ -83,7 +83,7 @@
  * is taken and the intent log is replayed on it.  the index file is
  * regenerated from scratch.
  *
- * during operation ckecpoints will compress the data.  the data file
+ * during operation checkpoints will compress the data.  the data file
  * is locked.  then a checkpoint rewrites the data file in order,
  * removing any unused records.  this is written and fsync'd to
  * dfile.NEW and stored for use during recovery.
@@ -1105,7 +1105,7 @@ static int fetchlock(struct dbengine *db
     return myfetch(db, key, keylen, data, datalen, tidptr);
 }
 
-/* foreach allows for subsidary mailbox operations in 'cb'.
+/* foreach allows for subsidiary mailbox operations in 'cb'.
    if there is a txn, 'cb' must make use of it.
 */
 static int myforeach(struct dbengine *db,
diff -pruN 3.0.13-5/lib/cyrusdb_sql.c 3.2.0-3/lib/cyrusdb_sql.c
--- 3.0.13-5/lib/cyrusdb_sql.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_sql.c	2020-04-24 02:03:00.000000000 +0000
@@ -41,6 +41,7 @@
 
 #include <config.h>
 
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <stdlib.h>
@@ -49,7 +50,6 @@
 #include "assert.h"
 #include "bsearch.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "libcyr_cfg.h"
 #include "xmalloc.h"
 #include "util.h"
@@ -443,7 +443,7 @@ static int init(const char *dbdir __attr
         char errbuf[1024];
         snprintf(errbuf, sizeof(errbuf),
                  "SQL engine %s not supported", engine_name);
-        fatal(errbuf, EC_CONFIG);
+        fatal(errbuf, EX_CONFIG);
     }
 
     if (!engine_name) {
diff -pruN 3.0.13-5/lib/cyrusdb_twoskip.c 3.2.0-3/lib/cyrusdb_twoskip.c
--- 3.0.13-5/lib/cyrusdb_twoskip.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_twoskip.c	2020-05-04 03:28:02.000000000 +0000
@@ -293,6 +293,10 @@
 #define DELETE '-'
 #define COMMIT '$'
 
+/* magic 8-byte pad - space for type, easy to read on hexdump
+ * and with both low and high bits to be unlikely in real data */
+#define BLANK " BLANK\x07\xa0"
+
 /********** DATA STRUCTURES *************/
 
 /* A single "record" in the twoskip file.  This could be a
@@ -356,18 +360,13 @@ struct skiploc {
     size_t end;
 };
 
-enum {
-    UNLOCKED = 0,
-    READLOCKED = 1,
-    WRITELOCKED = 2,
-};
-
 #define DIRTY (1<<0)
 
 struct txn {
     /* logstart is where we start changes from on commit, where we truncate
        to on abort */
     int num;
+    int shared;
 };
 
 struct db_header {
@@ -422,6 +421,9 @@ enum {
 #define HEADER_SIZE 64
 #define DUMMY_OFFSET HEADER_SIZE
 #define MAXRECORDHEAD ((MAXLEVEL + 5)*8)
+// NOTE: MAXLEVEL should be chosen so that MAXRECORDHEAD always
+// fits within BLOCKSIZE so header rewrites are atomic.
+#define BLOCKSIZE 512
 
 /* mount a scratch monkey */
 static union skipwritebuf {
@@ -732,6 +734,36 @@ static int rewrite_record(struct dbengin
     return 0;
 }
 
+/* Add BLANK padding sets of 8 bytes until the entire header will write
+ * in a single disk block for safety.
+ * This ONLY works if the header is small enough obviously (should always be)
+ * the algorithm checks if the end % BLOCKSIZE is smaller than the start % BLOCKSIZE
+ * in which case we've wrapped a block */
+static int add_padding(struct dbengine *db, size_t iolen) {
+    // if it will always span a block, there's no point padding (and besides the
+    // algorithm won't work)
+    if (iolen > BLOCKSIZE - 8) return 0;
+
+    // start with 8 byte offset, because the first 8 bytes never get rewritten
+    // and end with 8 before, because if it fits exactly that's OK too
+    // consider 480 bytes in, 32 bytes to write
+    // 480+8 == 488, 480 - 8 + 32 == 504, so no padding
+    // consider 488 bytes in:
+    // 488+8 == 496, 488 - 8 + 32 == 512 -> 0 so we pad
+    // 496+8 == 504 to 8, so we pad again
+    // 504+8 == 512 -> 0, so we don't pad any more!
+    // we write the new record from 504 onwards, with the header line before the
+    // block boundary, maximising use of space!
+
+    while (((db->end + 8) % BLOCKSIZE) > ((db->end - 8 + iolen) % BLOCKSIZE)) {
+        int n = mappedfile_pwrite(db->mf, BLANK, 8, db->end);
+        if (n < 0) return CYRUSDB_IOERROR;
+        db->end += 8;
+    }
+
+    return 0;
+}
+
 /* you can only write records at the end */
 static int write_record(struct dbengine *db, struct skiprecord *record,
                         const char *key, const char *val)
@@ -741,6 +773,7 @@ static int write_record(struct dbengine
     size_t iolen = 0;
     struct iovec io[4];
     int n;
+    int r;
 
     assert(!record->offset);
 
@@ -767,6 +800,10 @@ static int write_record(struct dbengine
     io[0].iov_base = scratchspace.s;
     io[0].iov_len = iolen;
 
+    /* ensure that the record header be contained within a single disk block */
+    r = add_padding(db, iolen);
+    if (r) return r;
+
     /* write to the mapped file, getting the offset updated */
     n = mappedfile_pwritev(db->mf, io, 4, db->end);
     if (n < 0) return CYRUSDB_IOERROR;
@@ -1232,24 +1269,27 @@ static int read_lock(struct dbengine *db
     return 0;
 }
 
-static int newtxn(struct dbengine *db, struct txn **tidptr)
+static int newtxn(struct dbengine *db, int shared, struct txn **tidptr)
 {
     int r;
 
     assert(!db->current_txn);
     assert(!*tidptr);
 
-    /* grab a r/w lock */
-    r = write_lock(db);
+    /* grab a lock */
+    r = shared ? read_lock(db) : write_lock(db);
     if (r) return r;
 
-    /* create the transaction */
     db->txn_num++;
-    db->current_txn = xmalloc(sizeof(struct txn));
-    db->current_txn->num = db->txn_num;
+
+    /* create the transaction */
+    struct txn *txn = xzmalloc(sizeof(struct txn));
+    txn->num = db->txn_num;
+    txn->shared = shared;
+    db->current_txn = txn;
 
     /* pass it back out */
-    *tidptr = db->current_txn;
+    *tidptr = txn;
 
     return 0;
 }
@@ -1367,7 +1407,7 @@ static int opendb(const char *fname, int
     *ret = db;
 
     if (mytid) {
-        r = newtxn(db, mytid);
+        r = newtxn(db, flags & CYRUSDB_SHARED, mytid);
         if (r) goto done;
     }
 
@@ -1385,10 +1425,16 @@ static int myopen(const char *fname, int
     /* do we already have this DB open? */
     for (ent = open_twoskip; ent; ent = ent->next) {
         if (strcmp(FNAME(ent->db), fname)) continue;
-        if (ent->db->current_txn)
+        if (ent->db->current_txn) {
+            /* XXX we could gracefully handle attempts to open
+             * a shared-lock database multiple times.e.g by
+             * ref-counting transactions. But it's likely that
+             * multiple open attempts are a bug in the caller's
+             * logic, so error out here */
             return CYRUSDB_LOCKED;
+        }
         if (mytid) {
-            r = newtxn(ent->db, mytid);
+            r = newtxn(ent->db, flags & CYRUSDB_SHARED, mytid);
             if (r) return r;
         }
         ent->refcount++;
@@ -1464,7 +1510,7 @@ static int myfetch(struct dbengine *db,
 
     if (tidptr) {
         if (!*tidptr) {
-            r = newtxn(db, tidptr);
+            r = newtxn(db, 0/*shared*/, tidptr);
             if (r) return r;
         }
     } else {
@@ -1505,7 +1551,7 @@ done:
     return r;
 }
 
-/* foreach allows for subsidary mailbox operations in 'cb'.
+/* foreach allows for subsidiary mailbox operations in 'cb'.
    if there is a txn, 'cb' must make use of it.
 */
 static int myforeach(struct dbengine *db,
@@ -1534,7 +1580,7 @@ static int myforeach(struct dbengine *db
         tidptr = &db->current_txn;
     if (tidptr) {
         if (!*tidptr) {
-            r = newtxn(db, tidptr);
+            r = newtxn(db, 0/*shared*/, tidptr);
             if (r) return r;
         }
     } else {
@@ -1676,10 +1722,14 @@ static int mycommit(struct dbengine *db,
     assert(db);
     assert(tid == db->current_txn);
 
-    /* no need to abort if we're not dirty */
+    /* no need to commit if we're not dirty */
     if (!(db->header.flags & DIRTY))
         goto done;
 
+    assert(db->current_txn);
+
+    if (db->current_txn->shared) goto done;
+
     /* build a commit record */
     memset(&newrecord, 0, sizeof(struct skiprecord));
     newrecord.type = COMMIT;
@@ -1711,7 +1761,8 @@ static int mycommit(struct dbengine *db,
         }
     }
     else {
-        if (!(db->open_flags & CYRUSDB_NOCOMPACT)
+        if (db->current_txn && !db->current_txn->shared
+            && !(db->open_flags & CYRUSDB_NOCOMPACT)
             && db->header.current_size > MINREWRITE
             && db->header.current_size > 2 * db->header.repack_size) {
             int r2 = mycheckpoint(db);
@@ -1766,13 +1817,17 @@ static int mystore(struct dbengine *db,
     assert(db);
     assert(key && keylen);
 
+    /* reject store for shared locks */
+    if (tidptr && *tidptr && (*tidptr)->shared)
+        return CYRUSDB_READONLY;
+
     /* not keeping the transaction, just create one local to
      * this function */
     if (!tidptr) tidptr = &localtid;
 
     /* make sure we're write locked and up to date */
     if (!*tidptr) {
-        r = newtxn(db, tidptr);
+        r = newtxn(db, 0/*shared*/, tidptr);
         if (r) return r;
     }
 
@@ -1851,11 +1906,13 @@ static int mycheckpoint(struct dbengine
     r = mycommit(cr.db, cr.tid);
     if (r) goto err;
 
+    cr.tid = NULL;  /* avoid later errors trying to call abort, it's too late! */
+
     /* move new file to original file name */
     r = mappedfile_rename(cr.db->mf, FNAME(db));
     if (r) goto err;
 
-    /* OK, we're commmitted now - clean up */
+    /* OK, we're committed now - clean up */
     unlock(db);
 
     /* gotta clean it all up */
@@ -1890,7 +1947,7 @@ static int mycheckpoint(struct dbengine
    if detail == 2, also dump pointers for active records.
    if detail == 3, dump all records/all pointers.
 */
-static int dump(struct dbengine *db, int detail __attribute__((unused)))
+static int dump(struct dbengine *db, int detail)
 {
     struct skiprecord record;
     struct buf scratch = BUF_INITIALIZER;
@@ -1908,6 +1965,13 @@ static int dump(struct dbengine *db, int
     while (offset < db->header.current_size) {
         printf("%08llX ", (LLU)offset);
 
+        // skip over blanks
+        if (!memcmp(BASE(db) + offset, BLANK, 8)) {
+            printf("BLANK\n");
+            offset += 8;
+            continue;
+        }
+
         r = read_onerecord(db, offset, &record);
 
         if (r) {
@@ -1939,6 +2003,11 @@ static int dump(struct dbengine *db, int
                     printf("\n\t");
             }
             printf("\n");
+            if (detail > 2) {
+                buf_setmap(&scratch, VAL(db, &record), record.vallen);
+                buf_replace_char(&scratch, '\0', '-');
+                printf("\tv=(%s)\n", buf_cstring(&scratch));
+            }
             break;
         }
 
@@ -2045,28 +2114,37 @@ static int _copy_commit(struct dbengine
 {
     struct txn *tid = NULL;
     struct skiprecord record;
-    const char *val;
     size_t offset;
     int r = 0;
 
     for (offset = commit->nextloc[0]; offset < commit->offset; offset += record.len) {
+        // skip over blanks
+        if (!memcmp(BASE(db) + offset, BLANK, 8)) {
+            record.len = 8;
+            continue;
+        }
+
         r = read_onerecord(db, offset, &record);
         if (r) goto err;
+
         switch (record.type) {
         case DELETE:
-            val = NULL;
+            /* find the record we are deleting */
+            r = read_onerecord(db, record.nextloc[0], &record);
+            if (r) goto err;
+            /* and delete it from the new DB */
+            r = mystore(newdb, KEY(db, &record), record.keylen, NULL, 0, &tid, 1);
+            if (r) goto err;
             break;
         case RECORD:
-            val = VAL(db, &record);
+            /* store into the new DB */
+            r = mystore(newdb, KEY(db, &record), record.keylen, VAL(db, &record), record.vallen, &tid, 1);
+            if (r) goto err;
             break;
         default:
             r = CYRUSDB_IOERROR;
             goto err;
         }
-
-        /* store into the new DB */
-        r = mystore(newdb, KEY(db, &record), record.keylen, val, record.vallen, &tid, 1);
-        if (r) goto err;
     }
 
     if (tid) r = mycommit(newdb, tid);
@@ -2102,20 +2180,32 @@ static int recovery2(struct dbengine *db
     newdb->header.generation = db->header.generation + 1;
 
     /* start with the dummy */
+    int dirty = 0;
     for (offset = DUMMY_OFFSET; offset < SIZE(db); offset += record.len) {
+        // skip over blanks
+        if (!memcmp(BASE(db) + offset, BLANK, 8)) {
+            record.len = 8;
+            continue;
+        }
+        // if this record fails to read, keep looking ahead for a commit,
+        // and mark this entire transaction as dirty
         r = read_onerecord(db, offset, &record);
         if (r) {
-            syslog(LOG_ERR, "DBERROR: %s failed to read at %08llX in recovery2, truncating",
+            dirty++;
+            syslog(LOG_ERR, "DBERROR: %s failed to read at %08llX in recovery2, continuing",
                    FNAME(db), (LLU)offset);
-            break;
+            record.len = 8;
+            continue;
         }
         if (record.type == COMMIT) {
-            r = _copy_commit(db, newdb, &record);
-            if (r) {
-                syslog(LOG_ERR, "DBERROR: %s failed to apply commit at %08llX in recovery2, truncating",
-                      FNAME(db), (LLU)offset);
-                break;
+            if (!dirty) {
+                r = _copy_commit(db, newdb, &record);
+                if (r) {
+                    syslog(LOG_ERR, "DBERROR: %s failed to apply commit at %08llX in recovery2, continuing",
+                           FNAME(db), (LLU)offset);
+                }
             }
+            dirty = 0;
         }
     }
 
@@ -2135,7 +2225,7 @@ static int recovery2(struct dbengine *db
     r = mappedfile_rename(newdb->mf, FNAME(db));
     if (r) goto err;
 
-    /* OK, we're commmitted now - clean up */
+    /* OK, we're committed now - clean up */
     unlock(db);
 
     /* gotta clean it all up */
@@ -2174,12 +2264,12 @@ static int recovery1(struct dbengine *db
     int cmp;
     int i;
 
-    assert(mappedfile_iswritelocked(db->mf));
-
     /* no need to run recovery if we're consistent */
     if (db_is_clean(db))
         return 0;
 
+    assert(mappedfile_iswritelocked(db->mf));
+
     /* we can't recovery a file that's not created yet */
     assert(db->header.current_size > HEADER_SIZE);
 
@@ -2215,7 +2305,7 @@ static int recovery1(struct dbengine *db
         r = read_onerecord(db, nextoffset, &record);
         if (r) return r;
 
-        /* just skip over delele records */
+        /* just skip over delete records */
         if (record.type == DELETE) {
             nextoffset = record.nextloc[0];
             continue;
diff -pruN 3.0.13-5/lib/cyrusdb_zeroskip.c 3.2.0-3/lib/cyrusdb_zeroskip.c
--- 3.0.13-5/lib/cyrusdb_zeroskip.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/lib/cyrusdb_zeroskip.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,604 @@
+/* cyrusdb_zeroskip.c - Support for Zeroskip
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include <config.h>
+
+#include <errno.h>
+#include <limits.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <sys/types.h>
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+#include "assert.h"
+#include "bsearch.h"
+#include "cyrusdb.h"
+#include "util.h"
+#include "xmalloc.h"
+
+#include <libzeroskip/zeroskip.h>
+#include <libzeroskip/memtree.h>
+
+struct txn {
+    struct zsdb_txn *t;
+};
+
+
+struct dbengine {
+    struct zsdb *db;
+    struct zsdb_txn **curent_txn;
+};
+
+
+struct dblist {
+    struct dbengine *db;
+    struct dblist *next;
+};
+
+/****** INTERNAL FUNCTIONS ******/
+static int create_or_reuse_txn(struct dbengine *db,
+                               struct txn **curtidptr,
+                               struct txn **newtidptr)
+{
+    struct txn *tid = NULL;
+
+    assert(newtidptr);
+    tid = *newtidptr;
+
+    if (!curtidptr || !*curtidptr) {
+        /* New transaction */
+        int r;
+
+        tid = xcalloc(1, sizeof(struct txn));
+        r = zsdb_transaction_begin(db->db, &tid->t);
+        if (r != ZS_OK) {
+            free(tid);
+            tid = NULL;
+            *newtidptr = NULL;
+            return CYRUSDB_INTERNAL;
+        }
+    } else {
+        /* Existing transaction */
+        tid = *curtidptr;
+    }
+
+    if (curtidptr)
+        *curtidptr = tid;
+
+    *newtidptr = tid;
+
+    return CYRUSDB_OK;
+}
+
+memtree_memcmp_fn(
+  mbox,
+  ,
+  bsearch_memtree_mbox(k, keylen, b, blen)
+)
+/****** CYRUS DB API ******/
+
+HIDDEN int cyrusdb_zeroskip_init(const char *dbdir __attribute__((unused)),
+                                 int myflags __attribute__((unused)))
+{
+    return CYRUSDB_OK;
+}
+
+HIDDEN int cyrusdb_zeroskip_done(void)
+{
+    return CYRUSDB_OK;
+}
+
+HIDDEN int cyrusdb_zeroskip_sync(void)
+{
+    return CYRUSDB_OK;
+}
+
+HIDDEN int cyrusdb_zeroskip_archive(const strarray_t *fnames __attribute__((unused)),
+                                    const char *dirname __attribute__((unused)))
+{
+    return CYRUSDB_OK;
+}
+
+
+HIDDEN int cyrusdb_zeroskip_unlink(const char *fname __attribute__((unused)),
+                                   int flags __attribute__((unused)))
+{
+    return CYRUSDB_OK;
+}
+
+static int cyrusdb_zeroskip_open(const char *fname,
+                                 int flags,
+                                 struct dbengine **ret,
+                                 struct txn **mytid)
+{
+    struct dbengine *dbe;
+    int r = CYRUSDB_OK;
+    int zsdbflags = MODE_RDWR;
+    zsdb_cmp_fn dbcmpfn = NULL;
+    memtree_search_cb_t btcmpfn = NULL;
+
+    dbe = (struct dbengine *) xzmalloc(sizeof(struct dbengine));
+
+    if (flags & CYRUSDB_CREATE)
+        zsdbflags = MODE_CREATE;
+
+    if (flags & CYRUSDB_MBOXSORT) {
+        zsdbflags |= MODE_CUSTOMSEARCH;
+        dbcmpfn = bsearch_uncompare_mbox;
+        btcmpfn = memtree_memcmp_mbox;
+    }
+
+    if (zsdb_init(&dbe->db, dbcmpfn, btcmpfn) != ZS_OK) {
+        r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+    r = zsdb_open(dbe->db, fname, zsdbflags);
+    if (r) {
+        if (r == ZS_NOTFOUND) r = CYRUSDB_NOTFOUND;
+        else r = CYRUSDB_IOERROR;
+        goto finalise_db;
+    }
+
+    *ret = dbe;
+
+    if (mytid) {
+        *mytid = xmalloc(sizeof(struct txn));
+        r = zsdb_transaction_begin(dbe->db, &(*mytid)->t);
+        if (r != ZS_OK) {
+            r = CYRUSDB_INTERNAL;
+            goto close_db;
+        }
+    }
+
+    r = CYRUSDB_OK;
+    goto done;
+
+ close_db:
+    zsdb_close(dbe->db);
+ finalise_db:
+    zsdb_final(&dbe->db);
+    free(dbe);
+
+ done:
+    return r;
+}
+
+static int cyrusdb_zeroskip_close(struct dbengine *dbe)
+{
+    int r = CYRUSDB_OK;
+
+    assert(dbe);
+    assert(dbe->db);
+
+    r = zsdb_close(dbe->db);
+    if (r) {
+        r = CYRUSDB_INTERNAL;
+        goto done;
+    }
+
+    zsdb_final(&dbe->db);
+
+    free(dbe);
+    dbe = NULL;
+
+ done:
+    return r;
+}
+
+static int cyrusdb_zeroskip_fetch(struct dbengine *db,
+                                  const char *key, size_t keylen,
+                                  const char **data, size_t *datalen,
+                                  struct txn **tidptr)
+{
+    int r = CYRUSDB_OK;
+    struct txn *tid = NULL;
+
+    assert(db);
+    assert(key);
+    assert(keylen);
+
+    if (datalen) assert(data);
+
+    if (data) *data = NULL;
+    if (datalen) *datalen = 0;
+
+    r = create_or_reuse_txn(db, tidptr, &tid);
+    if (r)
+        goto done;
+
+    r = zsdb_fetch(db->db, (const unsigned char *)key, keylen,
+                   (const unsigned char **)data, datalen,
+                   tidptr ? &tid->t : NULL);
+    if (r == ZS_NOTFOUND){
+        r = CYRUSDB_NOTFOUND;
+        if (data) *data = NULL;
+        if (datalen) *datalen = 0;
+
+        goto done;
+
+    } else if (r) {
+        r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+    if (tidptr) {
+        *tidptr = tid;
+    }
+
+    r = CYRUSDB_OK;
+
+ done:
+    if (tid && (!tidptr || !*tidptr)) {
+        zsdb_transaction_end(&tid->t);
+        free(tid);
+        tid = NULL;
+    }
+
+    return r;
+}
+
+static int cyrusdb_zeroskip_fetchlock(struct dbengine *db,
+                                      const char *key, size_t keylen,
+                                      const char **data, size_t *datalen,
+                                      struct txn **tidptr)
+{
+    assert(key);
+    assert(keylen);
+
+    /* TODO: LOCK??? */
+    return cyrusdb_zeroskip_fetch(db, key, keylen,
+                                  data, datalen,
+                                  tidptr);
+}
+
+static int cyrusdb_zeroskip_fetchnext(struct dbengine *db,
+                                      const char *key, size_t keylen,
+                                      const char **foundkey, size_t *fklen,
+                                      const char **data, size_t *datalen,
+                                      struct txn **tidptr __attribute__((unused)))
+{
+    int r = CYRUSDB_OK;
+    struct txn *tid = NULL;
+
+    assert(db);
+
+    r = zsdb_fetchnext(db->db, (const unsigned char *)key, keylen,
+                       (const unsigned char **)foundkey, fklen,
+                       (const unsigned char **)data, datalen,
+                       &tid->t);
+    if (r != ZS_OK) {
+        if (r == ZS_NOTFOUND) r = CYRUSDB_NOTFOUND;
+        else                  r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+ done:
+    return r;
+}
+
+static int cyrusdb_zeroskip_foreach(struct dbengine *db,
+                                    const char *prefix, size_t prefixlen,
+                                    foreach_p *goodp,
+                                    foreach_cb *cb, void *rock,
+                                    struct txn **tidptr)
+{
+    int r = CYRUSDB_OK;
+    struct txn *tid = NULL;
+
+    assert(db);
+    assert(cb);
+
+    if (prefixlen) assert(prefix);
+
+    r = create_or_reuse_txn(db, tidptr, &tid);
+    if (r)
+        goto done;
+
+    /* FIXME: The *ugly* typecasts  be removed as soon as we * update the
+     * CyrusDB interfaces to support `unsigned char *` instead of * `char *`.
+     */
+    r = zsdb_foreach(db->db, (unsigned char *)prefix, prefixlen,
+                     (int (*)(void*, const unsigned char *, size_t , const unsigned char *, size_t))goodp,
+                     (int (*)(void*, const unsigned char *, size_t , const unsigned char *, size_t))cb,
+                     rock, tidptr ? &tid->t : NULL);
+    if (r != ZS_OK) {
+        r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+    if (tidptr) {
+        *tidptr = tid;
+    }
+
+    r = CYRUSDB_OK;
+
+ done:
+    if (tid && (!tidptr || !*tidptr)) {
+        zsdb_transaction_end(&tid->t);
+        free(tid);
+        tid = NULL;
+    }
+
+    return r;
+}
+
+static int cyrusdb_zeroskip_create(struct dbengine *db __attribute__((unused)),
+                                   const char *key __attribute__((unused)),
+                                   size_t keylen __attribute__((unused)),
+                                   const char *data, size_t datalen,
+                                   struct txn **tidptr __attribute__((unused)))
+{
+    if (datalen) assert(data);
+
+    return 0;
+}
+
+static int cyrusdb_zeroskip_store(struct dbengine *db,
+                                  const char *key, size_t keylen,
+                                  const char *data, size_t datalen,
+                                  struct txn **tidptr)
+{
+    struct txn *tid = NULL;
+    int r = 0;
+
+    if (datalen) assert(data);
+
+    assert(db);
+    assert(key && keylen);
+
+    r = create_or_reuse_txn(db, tidptr, &tid);
+    if (r)
+        goto done;
+
+    /* Acquire write lock */
+    zsdb_write_lock_acquire(db->db, 0);
+
+    r = zsdb_add(db->db, (const unsigned char *)key, keylen,
+                 (const unsigned char *)data, datalen,
+                 tidptr ? &tid->t : NULL);
+    if (r == ZS_NOTFOUND) {
+        r = CYRUSDB_NOTFOUND;
+        goto done;
+    } else if (r) {
+        zsdb_abort(db->db, &tid->t);
+        r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+    if (tidptr) {
+        *tidptr = tid;
+    }
+
+    if (r) r = CYRUSDB_IOERROR;
+    else   r = CYRUSDB_OK;
+
+ done:
+    /* Release write lock */
+    zsdb_write_lock_release(db->db);
+
+    if (tid && (!tidptr || !*tidptr)) {
+        zsdb_transaction_end(&tid->t);
+        free(tid);
+        tid = NULL;
+    }
+
+    return r;
+}
+
+static int cyrusdb_zeroskip_delete(struct dbengine *db,
+                                   const char *key, size_t keylen,
+                                   struct txn **tidptr,
+                                   int force __attribute__((unused)))
+{
+    struct txn *tid = NULL;
+    int r = 0;
+
+    if (keylen) assert(key);
+
+    assert(db);
+
+    r = create_or_reuse_txn(db, tidptr, &tid);
+    if (r)
+        goto done;
+
+    /* Acquire write lock */
+    zsdb_write_lock_acquire(db->db, 0);
+
+    r = zsdb_remove(db->db, (const unsigned char *)key, keylen, &tid->t);
+    if (r == ZS_NOTFOUND) {
+        r = CYRUSDB_NOTFOUND;
+        goto done;
+    } else if (r) {
+        r = CYRUSDB_INTERNAL;
+        goto done;
+    }
+
+    if (tidptr) {
+        *tidptr = tid;
+    }
+
+    if (r) r = CYRUSDB_IOERROR;
+    else   r = CYRUSDB_OK;
+
+ done:
+    /* Release write lock */
+    zsdb_write_lock_release(db->db);
+
+    if (tid && (!tidptr || !*tidptr)) {
+        zsdb_transaction_end(&tid->t);
+        free(tid);
+        tid = NULL;
+    }
+
+    return r;
+}
+
+
+static int cyrusdb_zeroskip_commit(struct dbengine *db, struct txn *tid)
+{
+    int r = 0;
+    struct zsdb_txn *t;
+
+    assert(db);
+
+    t = tid ? tid->t : NULL;
+
+    r = zsdb_commit(db->db, &t);
+    if (r)
+        r = CYRUSDB_IOERROR;
+    else
+        r = CYRUSDB_OK;
+
+    if (tid)
+        free(tid);
+
+    return r;
+}
+
+static int cyrusdb_zeroskip_abort(struct dbengine *db, struct txn *tid)
+{
+    assert(db);
+    assert(tid);
+
+    zsdb_abort(db->db, &tid->t);
+    free(tid);
+    tid = NULL;
+
+    return CYRUSDB_OK;
+}
+
+/* cyrusdb_zeroskip_dump:
+   if detail == 1, dump all records.
+   if detail == 2, dump active records only
+*/
+static int cyrusdb_zeroskip_dump(struct dbengine *db,
+                                 int detail)
+{
+    int r = 0;
+
+    assert(db);
+
+    r = zsdb_dump(db->db, (detail == 1) ? DB_DUMP_ALL : DB_DUMP_ACTIVE);
+    if (r)
+        r = CYRUSDB_IOERROR;
+    else
+        r = CYRUSDB_OK;
+
+    return r;
+}
+
+static int cyrusdb_zeroskip_consistent(struct dbengine *db __attribute__((unused)))
+{
+    return 0;
+}
+
+static int cyrusdb_zeroskip_checkpoint(struct dbengine *db)
+{
+    int r = 0;
+
+    assert(db);
+
+    if (zsdb_pack_lock_acquire(db->db, 0) != ZS_OK) {
+        r = CYRUSDB_IOERROR;
+        goto done;
+    }
+
+    r = zsdb_repack(db->db);
+    if (r)
+        r = CYRUSDB_IOERROR;
+    else
+        r = CYRUSDB_OK;
+
+    if (zsdb_pack_lock_release(db->db) != ZS_OK) {
+        r = CYRUSDB_IOERROR;
+    }
+
+done:
+    return r;
+}
+
+static int cyrusdb_zeroskip_compar(struct dbengine *db __attribute__((unused)),
+                                   const char *a __attribute__((unused)),
+                                   int alen __attribute__((unused)),
+                                   const char *b __attribute__((unused)),
+                                   int blen __attribute__((unused)))
+{
+    /* return db->compar(a, alen, b, blen); */
+    return 0;
+}
+
+
+HIDDEN struct cyrusdb_backend cyrusdb_zeroskip =
+{
+    "zeroskip",                  /* name */
+
+    &cyrusdb_zeroskip_init,
+    &cyrusdb_zeroskip_done,
+    &cyrusdb_zeroskip_sync,
+    &cyrusdb_zeroskip_archive,
+    &cyrusdb_zeroskip_unlink,
+
+    &cyrusdb_zeroskip_open,
+    &cyrusdb_zeroskip_close,
+
+    &cyrusdb_zeroskip_fetch,
+    &cyrusdb_zeroskip_fetchlock,
+    &cyrusdb_zeroskip_fetchnext,
+
+    &cyrusdb_zeroskip_foreach,
+    &cyrusdb_zeroskip_create,
+    &cyrusdb_zeroskip_store,
+    &cyrusdb_zeroskip_delete,
+
+    &cyrusdb_zeroskip_commit,
+    &cyrusdb_zeroskip_abort,
+
+    &cyrusdb_zeroskip_dump,
+    &cyrusdb_zeroskip_consistent,
+    &cyrusdb_zeroskip_checkpoint,
+    &cyrusdb_zeroskip_compar
+};
+
diff -pruN 3.0.13-5/lib/exitcodes.h 3.2.0-3/lib/exitcodes.h
--- 3.0.13-5/lib/exitcodes.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/exitcodes.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,86 +0,0 @@
-/* exitcodes.h -- wrapper around sysextis.h
- *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-/* Sendmail has some weird ideas on what constitutes permenant failure.  On
-   more than one occasion, we have gotten burned by this moving users around
-   through various inadvisable means, screwing up the mailboxes file,
-   whatever.
-
-   We don't want to fail out permenantly on things like EX_USAGE, EX_SOFTWARE,
-   etc., because that generally means someone was just screwing with the mail
-   store and we don't want to lose mail.
-
-   Instead, we map these EC_* codes to EX_* codes, thereby lying to Sendmail,
-   since we don't derive any benefit from Sendmail knowing what the error was.
-   We just want it to retry all the time anyway.  This way, should sendmail's
-   behavior be different and we start deriving benefit from Sendmail knowing
-   stuff, we can easily change it back.
-
-   So other code uses the EC_* error, then we maybe change it to TEMPFAIL if
-   we don't agree on whether the error should be permenant or not.
-
-   Comments below stolen from sysexits.h.  */
-
-#ifndef INCLUDED_EXITCODES_H
-#define INCLUDED_EXITCODES_H
-
-#include <sysexits.h>
-
-#define EC_OK          0                /* successful termination */
-
-#define EC_USAGE       EX_TEMPFAIL      /* command line usage error */
-#define EC_DATAERR     EX_DATAERR       /* data format error */
-#define EC_NOINPUT     EX_TEMPFAIL      /* cannot open input */
-#define EC_NOUSER      EX_NOUSER        /* addressee unknown */
-#define EC_NOHOST      EX_TEMPFAIL      /* host name unknown */
-#define EC_UNAVAILABLE EX_TEMPFAIL      /* service unavailable */
-#define EC_SOFTWARE    EX_TEMPFAIL      /* internal software error */
-#define EC_OSERR       EX_TEMPFAIL      /* system error (e.g., can't fork) */
-#define EC_OSFILE      EX_TEMPFAIL      /* critical OS file missing */
-#define EC_CANTCREAT   EX_TEMPFAIL      /* can't create (user) output file */
-#define EC_IOERR       EX_TEMPFAIL      /* input/output error */
-#define EC_TEMPFAIL    EX_TEMPFAIL      /* user is invited to retry */
-#define EC_PROTOCOL    EX_TEMPFAIL      /* remote error in protocol */
-#define EC_NOPERM      EX_NOPERM        /* permission denied */
-#define EC_CONFIG      EX_TEMPFAIL      /* configuration error */
-
-#endif /* INCLUDED_EXITCODES_H */
diff -pruN 3.0.13-5/lib/gai.h 3.2.0-3/lib/gai.h
--- 3.0.13-5/lib/gai.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/gai.h	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * Mar  8, 2000 by Hajimu UMEMOTO <ume@mahoroba.org>
  *
- * This module is besed on ssh-1.2.27-IPv6-1.5 written by
+ * This module is based on ssh-1.2.27-IPv6-1.5 written by
  * KIKUCHI Takahiro <kick@kyoto.wide.ad.jp>
  */
 /*
diff -pruN 3.0.13-5/lib/getaddrinfo.c 3.2.0-3/lib/getaddrinfo.c
--- 3.0.13-5/lib/getaddrinfo.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/getaddrinfo.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * Mar  8, 2000 by Hajimu UMEMOTO <ume@mahoroba.org>
  *
- * This module is besed on ssh-1.2.27-IPv6-1.5 written by
+ * This module is based on ssh-1.2.27-IPv6-1.5 written by
  * KIKUCHI Takahiro <kick@kyoto.wide.ad.jp>
  */
 /*
@@ -48,10 +48,10 @@
  * fake library for ssh
  *
  * This file includes getaddrinfo(), freeaddrinfo() and gai_strerror().
- * These funtions are defined in rfc2133.
+ * These functions are defined in rfc2133.
  *
  * But these functions are not implemented correctly. The minimum subset
- * is implemented for ssh use only. For exapmle, this routine assumes
+ * is implemented for ssh use only. For example, this routine assumes
  * that ai_family is AF_INET. Don't use it for another purpose.
  *
  * In the case not using 'configure --enable-ipv6', this getaddrinfo.c
diff -pruN 3.0.13-5/lib/getnameinfo.c 3.2.0-3/lib/getnameinfo.c
--- 3.0.13-5/lib/getnameinfo.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/getnameinfo.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * Mar  8, 2000 by Hajimu UMEMOTO <ume@mahoroba.org>
  *
- * This module is besed on ssh-1.2.27-IPv6-1.5 written by
+ * This module is based on ssh-1.2.27-IPv6-1.5 written by
  * KIKUCHI Takahiro <kick@kyoto.wide.ad.jp>
  */
 /*
@@ -48,10 +48,10 @@
  * fake library for ssh
  *
  * This file includes getnameinfo().
- * These funtions are defined in rfc2133.
+ * These functions are defined in rfc2133.
  *
  * But these functions are not implemented correctly. The minimum subset
- * is implemented for ssh use only. For exapmle, this routine assumes
+ * is implemented for ssh use only. For example, this routine assumes
  * that ai_family is AF_INET. Don't use it for another purpose.
  *
  * In the case not using 'configure --enable-ipv6', this getnameinfo.c
diff -pruN 3.0.13-5/lib/hash.c 3.2.0-3/lib/hash.c
--- 3.0.13-5/lib/hash.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/hash.c	2020-04-24 02:03:00.000000000 +0000
@@ -58,7 +58,7 @@ EXPORTED hash_table *construct_hash_tabl
           table->table = xmalloc(sizeof(bucket *) * size);
       }
 
-      /* Allocate the table and initilize it */
+      /* Allocate the table and initialize it */
       memset(table->table, 0, sizeof(bucket *) * size);
 
       return table;
@@ -153,9 +153,14 @@ EXPORTED void *hash_insert(const char *k
 
 EXPORTED void *hash_lookup(const char *key, hash_table *table)
 {
-      unsigned val = strhash(key) % table->size;
+      unsigned val;
       bucket *ptr;
 
+      if (!table->size)
+          return NULL;
+
+      val = strhash(key) % table->size;
+
       if (!(table->table)[val])
             return NULL;
 
@@ -255,6 +260,8 @@ EXPORTED void free_hash_table(hash_table
       unsigned i;
       bucket *ptr, *temp;
 
+      if (!table) return;
+
       /* If we have a function to free the data, apply it everywhere */
       /* We also need to traverse this anyway if we aren't using a memory
        * pool */
@@ -347,3 +354,87 @@ EXPORTED int hash_numrecords(hash_table
 
     return count;
 }
+
+EXPORTED void hash_enumerate_sorted(hash_table *table, void (*func)(const char *, void *, void *),
+                    void *rock, strarray_cmp_fn_t *cmp)
+{
+    strarray_t *sa = hash_keys(table);
+    strarray_sort(sa, cmp);
+    int i;
+    for (i = 0; i < strarray_size(sa); i++) {
+        const char *key = strarray_nth(sa, i);
+        void *val = hash_lookup(key, table);
+        func(key, val, rock);
+    }
+    strarray_free(sa);
+}
+
+
+struct hash_iter {
+    hash_table *table;
+    size_t i;
+    bucket *peek;
+    bucket *curr;
+};
+
+EXPORTED hash_iter *hash_table_iter(hash_table *table)
+{
+    hash_iter *iter = xzmalloc(sizeof(struct hash_iter));
+    iter->table = table;
+    hash_iter_reset(iter);
+    return iter;
+}
+
+EXPORTED void hash_iter_reset(hash_iter *iter)
+{
+    hash_table *table = iter->table;
+    iter->curr = NULL;
+    iter->peek = NULL;
+    for (iter->i = 0; iter->i < table->size; iter->i++) {
+        if ((iter->peek = table->table[iter->i])) {
+            break;
+        }
+    }
+}
+
+EXPORTED int hash_iter_has_next(hash_iter *iter)
+{
+    return iter->peek != NULL;
+}
+
+EXPORTED const char *hash_iter_next(hash_iter *iter)
+{
+    hash_table *table = iter->table;
+    iter->curr = iter->peek;
+    iter->peek = NULL;
+    if (iter->curr == NULL)
+        return NULL;
+    else if (iter->curr->next)
+        iter->peek = iter->curr->next;
+    else if (iter->i < table->size) {
+        for (iter->i = iter->i + 1; iter->i < table->size; iter->i++) {
+            if ((iter->peek = table->table[iter->i])) {
+                break;
+            }
+        }
+    }
+    return iter->curr->key;
+}
+
+EXPORTED const char *hash_iter_key(hash_iter *iter)
+{
+    return iter->curr->key;
+}
+
+EXPORTED void *hash_iter_val(hash_iter *iter)
+{
+    return iter->curr->data;
+}
+
+EXPORTED void hash_iter_free(hash_iter **iterptr)
+{
+    if (iterptr) {
+        free(*iterptr);
+        *iterptr = NULL;
+    }
+}
diff -pruN 3.0.13-5/lib/hash.h 3.2.0-3/lib/hash.h
--- 3.0.13-5/lib/hash.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/hash.h	2020-04-24 02:03:00.000000000 +0000
@@ -73,10 +73,14 @@ void *hash_del(const char *key,hash_tabl
 ** for each node that has been inserted.  The function is passed
 ** a pointer to the key, a pointer to the data associated
 ** with it and 'rock'.
+** the "sorted" version sorts the keys first and then iterates them in
+** sorted order.  It's slower but consistent
 */
 
 void hash_enumerate(hash_table *table,void (*func)(const char *,void *,void *),
                     void *rock);
+void hash_enumerate_sorted(hash_table *table,void (*func)(const char *,void *,void *),
+                    void *rock, strarray_cmp_fn_t *cmp);
 
 /* gets all the keys from the hashtable */
 strarray_t *hash_keys(hash_table *table);
@@ -99,4 +103,33 @@ int hash_numrecords(hash_table *table);
 
 void free_hash_table(hash_table *table, void (*func)(void *));
 
+/*
+** An iterator for a hash table. Inserting or deleting entries
+** the hash table is not safe while iterating. The entries are
+** iterated in arbitrary order. */
+typedef struct hash_iter hash_iter;
+
+/* Creates an iterator for the hash table. The iterator points
+ * *before* the first entry, if any. */
+hash_iter *hash_table_iter(hash_table *table);
+
+/* Returns non-zero if the iterator has more entries. */
+int hash_iter_has_next(hash_iter *iter);
+
+/* Forwards the iterator to the next entry and returns its key.
+** If there is no more entry, the return value is NULL. */
+const char *hash_iter_next(hash_iter *iter);
+
+/* Returns the key of the current entry. */
+const char *hash_iter_key(hash_iter *iter);
+
+/* Returns the value of the current entry.*/
+void *hash_iter_val(hash_iter *iter);
+
+/* Resets the iterator to point before the first entry. */
+void hash_iter_reset(hash_iter *);
+
+/* Frees the iterator. */
+void hash_iter_free(hash_iter **iterptr);
+
 #endif /* HASH__H */
diff -pruN 3.0.13-5/lib/hashset.c 3.2.0-3/lib/hashset.c
--- 3.0.13-5/lib/hashset.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/lib/hashset.c	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,127 @@
+/* hashset.c -- library for building a set of hashed keys (evenly distributed)
+ *
+ * Copyright (c) 2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "assert.h"
+#include "hashset.h"
+#include "xmalloc.h"
+#include "util.h"
+
+EXPORTED struct hashset *hashset_new(size_t bytesize)
+{
+    assert(bytesize > 2);
+    assert(bytesize <= 128);
+    struct hashset *hs = xzmalloc(sizeof(struct hashset));
+    hs->recsize = bytesize + 4;
+    hs->bytesize = bytesize;
+    return hs;
+}
+
+// returns 1 if added, 0 if already there
+EXPORTED int hashset_add(struct hashset *hs, const void *value)
+{
+    assert(hs);
+    uint32_t *pos = &hs->starts[*((uint16_t *)value)];
+    uint32_t *base = pos;
+    size_t offset = 0;
+    while (*pos) {
+        offset = hs->recsize * (*pos - 1);
+        if (!memcmp(hs->data+offset, value, hs->bytesize))
+            return 0; // found it
+        pos = hs->data + offset + hs->bytesize;
+    }
+
+    // make space
+    if (hs->alloc <= hs->count) {
+        if (!hs->alloc) {
+            hs->alloc = 1024;
+            hs->data = xmalloc(hs->alloc * hs->recsize);
+        }
+        else {
+            hs->alloc *= 2;  // double the allocation each time
+            hs->data = xrealloc(hs->data, hs->alloc * hs->recsize);
+
+            // relocate after realloc if necessary
+            if (pos != base)
+                pos = hs->data + offset + hs->bytesize;
+        }
+
+    }
+
+    offset = hs->recsize * hs->count;
+    memcpy(hs->data + offset, value, hs->bytesize);
+    memset(hs->data + offset + hs->bytesize, 0, 4);
+
+    // make pointers start at 1 so the value is never zero
+    hs->count++;
+    *pos = hs->count;
+
+    return 1; // added it
+}
+
+// returns 1 if present, 0 if not
+EXPORTED int hashset_exists(struct hashset *hs, const void *data)
+{
+    if (!hs) return 0;
+
+    uint32_t pos = hs->starts[*((uint16_t *)data)];
+    while (pos) {
+        size_t offset = hs->recsize * (pos - 1);
+        if (!memcmp(hs->data+offset, data, hs->bytesize))
+            return 1; // found it
+        pos = *(uint32_t *) (hs->data + offset + hs->bytesize);
+    }
+
+    return 0; // not found
+}
+
+EXPORTED void hashset_free(struct hashset **hsp)
+{
+    xfree((*hsp)->data);
+    xzfree(*hsp);
+}
diff -pruN 3.0.13-5/lib/hashset.h 3.2.0-3/lib/hashset.h
--- 3.0.13-5/lib/hashset.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/lib/hashset.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,29 @@
+#ifndef __CYRUS_HASHSET_H__
+#define __CYRUS_HASHSET_H__
+
+#include <stddef.h>           /* For size_t */
+#include <stdint.h>           /* For uint32_t */
+
+struct hashset {
+    uint32_t starts[65536];
+    size_t bytesize;
+    size_t recsize;
+    size_t alloc;
+    size_t count;
+    void *data;
+};
+
+struct hashset *hashset_new(size_t bytesize);
+
+// returns 1 if added, 0 if not added (already there)
+int hashset_add(struct hashset *hs, const void *data);
+
+// returns 1 if exists, 0 if not present
+int hashset_exists(struct hashset *hs, const void *data);
+
+// XXX: add iterator and foreacher
+//void hashset_foreach(struct hashset *hs, int (*)(void *, void *), void *rock);
+
+void hashset_free(struct hashset **hsp);
+
+#endif /* __CYRUS_HASHSET_H__ */
diff -pruN 3.0.13-5/lib/hashu64.c 3.2.0-3/lib/hashu64.c
--- 3.0.13-5/lib/hashu64.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/hashu64.c	2020-04-24 02:03:00.000000000 +0000
@@ -62,7 +62,7 @@ EXPORTED hashu64_table *construct_hashu6
           table->table = xmalloc(sizeof(bucketu64 *) * size);
       }
 
-      /* Allocate the table and initilize it */
+      /* Allocate the table and initialize it */
       memset(table->table, 0, sizeof(bucketu64 *) * size);
 
       return table;
@@ -209,7 +209,7 @@ EXPORTED void *hashu64_del(uint64_t key,
                   data = ptr -> data;
                   last -> next = ptr -> next;
                   if(!table->pool) {
-                      free(ptr);
+                      xfree(ptr);
                   }
                   return data;
               }
@@ -227,7 +227,7 @@ EXPORTED void *hashu64_del(uint64_t key,
                   data = ptr->data;
                   (table->table)[val] = ptr->next;
                   if(!table->pool) {
-                      free(ptr);
+                      xfree(ptr);
                   }
                   return data;
               }
@@ -271,7 +271,7 @@ EXPORTED void free_hashu64_table(hashu64
                   if (func)
                       func(temp->data);
                   if(!table->pool) {
-                      free(temp);
+                      xfree(temp);
                   }
               }
           }
@@ -282,7 +282,7 @@ EXPORTED void free_hashu64_table(hashu64
           free_mpool(table->pool);
           table->pool = NULL;
       } else {
-          free(table->table);
+          xfree(table->table);
       }
       table->table = NULL;
       table->size = 0;
@@ -315,3 +315,17 @@ EXPORTED void hashu64_enumerate(hashu64_
       }
 }
 
+EXPORTED size_t hashu64_count(hashu64_table *table)
+{
+    size_t count = 0;
+    unsigned i;
+
+    for (i = 0; i < table->size; i++) {
+        bucketu64 *temp;
+        for (temp = (table->table)[i]; temp; temp = temp->next)
+             count++;
+    }
+
+    return count;
+}
+
diff -pruN 3.0.13-5/lib/hashu64.h 3.2.0-3/lib/hashu64.h
--- 3.0.13-5/lib/hashu64.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/hashu64.h	2020-04-24 02:03:00.000000000 +0000
@@ -76,6 +76,10 @@ void *hashu64_del(uint64_t key,hashu64_t
 void hashu64_enumerate(hashu64_table *table,void (*func)(uint64_t ,void *,void *),
                     void *rock);
 
+
+/* just count how many items are in the table */
+size_t hashu64_count(hashu64_table *table);
+
 /*
 ** Frees a hash table.  For each node that was inserted in the table,
 ** it calls the function whose address it was passed, with a pointer
diff -pruN 3.0.13-5/lib/imapoptions 3.2.0-3/lib/imapoptions
--- 3.0.13-5/lib/imapoptions	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/imapoptions	2020-05-04 03:28:02.000000000 +0000
@@ -83,6 +83,15 @@ Blank lines and lines beginning with ``#
 For boolean and enumerated options, the values ``yes'', ``on'', ``t'',
 ``true'' and ``1'' turn the option on, the values ``no'', ``off'',
 ``f'', ``false'' and ``0'' turn the option off.
+.PP
+Duration options take the form of a number followed by a unit, for example
+\fB32m\fR (32 minutes).  Units are \fBd\fR (days), \fBh\fR (hours), \fBm\fR
+(minutes) and \fBs\fR (seconds).  Multiple units can be combined and will
+be summed together, for example \fB1h30m\fR is equivalent to \fB90m\fR.  If
+no unit is specified, an option-specific backward-compatible default unit
+is assumed (documented on an option-by-option basis).  These are simple time
+units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+etc are not considered).
 .SH FIELD DESCRIPTIONS
 .PP
 The sections below detail options that can be placed in the
@@ -94,13 +103,13 @@ are listed with ``<none>''.
 
 # OPTIONS
 
-{ "addressbookprefix", "#addressbooks", STRING }
+{ "addressbookprefix", "#addressbooks", STRING, "2.5.0" }
 /* The prefix for the addressbook mailboxes hierarchies.  The hierarchy
    delimiter will be automatically appended.  The public addressbook
    hierarchy will be at the toplevel of the shared namespace.  A
    user's personal addressbook hierarchy will be a child of their Inbox. */
 
-{ "admins", "", STRING }
+{ "admins", "", STRING, "2.3.17" }
 /* The list of userids with administrative rights.  Separate each userid
    with a space.  Sites using Kerberos authentication may use
    separate "admin" instances.
@@ -112,16 +121,16 @@ are listed with ``<none>''.
    administrators to create top-level mailboxes visible to users,
    but not writable by users. */
 
-{ "afspts_localrealms", NULL, STRING }
+{ "afspts_localrealms", NULL, STRING, "2.3.17" }
 /* The list of realms which are to be treated as local, and thus stripped
    during identifier canonicalization (for the AFSPTS ptloader module).
    This is different from loginrealms in that it occurs later in the
    authorization process (as the user id is canonified for PTS lookup) */
 
-{ "afspts_mycell", NULL, STRING }
+{ "afspts_mycell", NULL, STRING, "2.3.17" }
 /* Cell to use for AFS PTS lookups.  Defaults to the local cell. */
 
-{ "allowallsubscribe", 0, SWITCH }
+{ "allowallsubscribe", 0, SWITCH, "2.3.17" }
 /* Allow subscription to nonexistent mailboxes.  This option is
    typically used on backend servers in a Murder so that users can
    subscribe to mailboxes that don't reside on their "home" server.
@@ -129,11 +138,11 @@ are listed with ``<none>''.
    don't play well with nonexistent or unselectable mailboxes (e.g.,
    Microsoft Outlook). */
 
-{ "allowanonymouslogin", 0, SWITCH }
+{ "allowanonymouslogin", 0, SWITCH, "2.3.17" }
 /* Permit logins by the user "anonymous" using any password.  Also
    allows use of the SASL ANONYMOUS mechanism. */
 
-{ "allowapop", 1, SWITCH }
+{ "allowapop", 1, SWITCH, "2.3.17" }
 /* Allow use of the POP3 APOP authentication command.
 .PP
   Note that this command requires that SASL is compiled with APOP
@@ -141,13 +150,16 @@ are listed with ``<none>''.
   backend (e.g., sasldb), and that the system can provide enough entropy
   (e.g., from /dev/urandom) to create a challenge in the banner. */
 
-{ "allownewnews", 0, SWITCH }
+{ "allowdeleted", 0, SWITCH, "3.1.8" }
+/* Allow access to deleted and expunged data via vendor.cmu-* access */
+
+{ "allownewnews", 0, SWITCH, "2.3.17" }
 /* Allow use of the NNTP NEWNEWS command.
 .PP
   Note that this is a very expensive command and should only be
   enabled when absolutely necessary. */
 
-{ "allowplaintext", 0, SWITCH }
+{ "allowplaintext", 0, SWITCH, "3.0.0" }
 /* If enabled, allows the use of cleartext passwords on the wire.
 .PP
   By default, the use of cleartext passwords requires a TLS/SSL
@@ -156,7 +168,11 @@ are listed with ``<none>''.
   TLS/SSL encryption layer to be negotiated prior to ANY
   authentication, see the \fItls_required\fR option. */
 
-{ "allowusermoves", 0, SWITCH }
+{ "allowsetacl", 1, SWITCH, "3.1.8" }
+/* Defaults to enabled.  If disabled, disallows the use of the SETACL
+   command at all via IMAP. */
+
+{ "allowusermoves", 0, SWITCH, "2.3.17" }
 /* Allow moving user accounts (with associated meta-data) via RENAME
    or XFER.
 .PP
@@ -165,7 +181,7 @@ are listed with ``<none>''.
   to do so may result in the user's meta-data (seen state,
   subscriptions, etc) being corrupted or out of date. */
 
-{ "altnamespace", 1, SWITCH }
+{ "altnamespace", 1, SWITCH, "3.0.0" }
 /* Use the alternate IMAP namespace, where personal folders reside at the
    same level in the hierarchy as INBOX.
 .PP
@@ -176,28 +192,28 @@ are listed with ``<none>''.
    affect LMTP delivery of messages directly to mailboxes via
    plus-addressing.  The default changed in 3.0 from off to on. */
 
-{ "altprefix", "Alt Folders", STRING }
+{ "altprefix", "Alt Folders", STRING, "3.0.0" }
 /* Alternative INBOX spellings that can't be accessed in altnamespace
    otherwise go under here */
 
-{ "annotation_db", "twoskip", STRINGLIST("skiplist", "twoskip", "lmdb")}
+{ "annotation_db", "twoskip", STRINGLIST("skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for mailbox annotations. */
 
-{ "annotation_db_path", NULL, STRING }
+{ "annotation_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the annotations db file.  If not specified,
    will be configdirectory/annotations.db */
 
-{ "anyoneuseracl", 1, SWITCH }
+{ "anyoneuseracl", 1, SWITCH, "2.3.17" }
 /* Should non-admin users be allowed to set ACLs for the 'anyone'
    user on their mailboxes?  In a large organization this can cause
    support problems, but it's enabled by default. */
 
-{ "annotation_allow_undefined", 0, SWITCH }
+{ "annotation_allow_undefined", 0, SWITCH, "2.5.0" }
 /* Allow clients to store values for entries which are not
    defined either by Cyrus or in the annotations_definitions
    file. */
 
-{ "annotation_definitions", NULL, STRING }
+{ "annotation_definitions", NULL, STRING, "2.5.0" }
 /* File containing external (third-party) annotation definitions.
 .PP
 Each line of the file specifies the properties of an annotation and
@@ -267,40 +283,54 @@ particular the \fBa\fP permission bit do
 Blank lines and lines beginning with ``#'' are ignored.
 */
 
-{ "annotation_callout", NULL, STRING }
+{ "annotation_callout", NULL, STRING, "2.5.0" }
 /* The pathname of a callout to be used to automatically add annotations
    or flags to a message when it is appended to a mailbox.  The path can
    be either an executable (including a script), or a UNIX domain
    socket.  */
+{ "annotation_callout_disable_append", 0, SWITCH, "3.1.2" }
+/* Disables annotations on append with xrunannotator */
+{ "annotation_enable_legacy_commands", 0, SWITCH, "3.1.6" }
+/* Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+   These commands are deprecated and will be removed in the future,
+   but might be useful in the meantime for supporting old clients that
+   do not implement the RFC5464 IMAP METADATA extension. */
 
-{ "aps_topic", NULL, STRING }
+{ "aps_topic", NULL, STRING, "3.0.0" }
 /* Topic for Apple Push Service registration. */
-{ "aps_topic_caldav", NULL, STRING }
+{ "aps_topic_caldav", NULL, STRING, "3.0.0" }
 /* Topic for Apple Push Service registration for CalDAV. */
-{ "aps_topic_carddav", NULL, STRING }
+{ "aps_topic_carddav", NULL, STRING, "3.0.0" }
 /* Topic for Apple Push Service registration for CardDAV. */
 
-{ "archive_enabled", 0, SWITCH }
+{ "archive_enabled", 0, SWITCH, "3.0.0" }
 /* Is archiving enabled for this server.  You also need to have an
    archivepartition for the mailbox.  Archiving allows older email
    to be stored on slower, cheaper disks - even within the same
    mailbox, as distinct from partitions. */
 
-{ "archive_days", 7, INT }
-/* The number of days after which to move messages to the archive partition
-   if archiving is enabled */
+{ "archive_days", NULL, DURATION, "3.1.8", "3.1.8", "archive_after" }
+/* Deprecated in favour of \fIarchive_after\fR. */
 
-{ "archive_maxsize", 1024, INT }
+{ "archive_after", "7d", DURATION, "3.1.8" }
+/* The duration after which to move messages to the archive partition
+   if archiving is enabled.
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed.  */
+*/
+
+{ "archive_maxsize", 1024, INT, "3.0.0" }
 /* The size in kilobytes of the largest message that won't be archived
    immediately.  Default is 1Mb */
 
-{ "archive_keepflagged", 0, SWITCH }
+{ "archive_keepflagged", 0, SWITCH, "3.0.0" }
 /* If set, messages with the \\Flagged system flag won't be archived,
    provided they are smaller than \fBarchive_maxsize\fR. */
 
 # Commented out - there's no such thing as "archivepartition-name",
 # but we need this for the man page
-# { "archivepartition-name", NULL, STRING }
+# { "archivepartition-name", NULL, STRING, "3.0.0" }
 /* The pathname of the archive partition \fIname\fR, corresponding to
    spool partition \fBpartition-name\fR.  For any mailbox residing in
    a directory on \fBpartition-name\fR, the archived messages will be
@@ -309,42 +339,59 @@ Blank lines and lines beginning with ``#
    to have a corresponding \fBarchivepartition-name\fR option, but that
    without one there's no benefit to enabling archiving. */
 
-{ "auditlog", 0, SWITCH }
+{ "auditlog", 0, SWITCH, "2.4.0" }
 /* Should cyrus output log entries for every action taken on a message
    file or mailboxes list entry?  It's noisy so disabled by default, but
    can be very useful for tracking down what happened if things look strange */
 
-{ "auth_mech", "unix", STRINGLIST("unix", "pts", "krb", "krb5")}
+{ "auth_mech", "unix", STRINGLIST("unix", "pts", "krb", "krb5"), "2.3.17" }
 /* The authorization mechanism to use. */
 
-{ "autocreateinboxfolders", NULL, STRING, "2.5.0", "autocreate_inbox_folders" }
+{ "autocreateinboxfolders", NULL, STRING, "2.5.0", "2.5.0", "autocreate_inbox_folders" }
 /* Deprecated in favor of \fIautocreate_inbox_folders\fR. */
 
-{ "autocreatequota", 0, INT, "2.5.0", "autocreate_quota" }
+{ "autocreatequota", 0, INT, "2.5.0", "2.5.0", "autocreate_quota" }
 /* Deprecated in favor of \fIautocreate_quota\fR. */
 
-{ "autocreatequotamsg", -1, INT, "2.5.0", "autocreate_quota_messages" }
+{ "autocreatequotamsg", -1, INT, "2.5.0", "2.5.0", "autocreate_quota_messages" }
 /* Deprecated in favor of \fIautocreate_quota_messages\fR. */
 
-{ "autosievefolders", NULL, STRING, "2.5.0", "autocreate_sieve_folders" }
+{ "autosievefolders", NULL, STRING, "2.5.0", "2.5.0", "autocreate_sieve_folders" }
 /* Deprecated in favor of \fIautocreate_sieve_folders\fR. */
 
-{ "generate_compiled_sieve_script", 0, SWITCH, "2.5.0", "autocreate_sieve_script_compile" }
+{ "generate_compiled_sieve_script", 0, SWITCH, "2.5.0", "2.5.0", "autocreate_sieve_script_compile" }
 /* Deprecated in favor of \fIautocreate_sieve_script_compile\fR. */
 
-{ "autocreate_sieve_compiled_script", NULL, STRING, "2.5.0", "autocreate_sieve_script_compiled" }
+{ "autocreate_sieve_compiled_script", NULL, STRING, "2.5.0", "2.5.0", "autocreate_sieve_script_compiled" }
 /* Deprecated in favor of \fIautocreate_sieve_script_compiled\fR. */
 
-{ "autosubscribeinboxfolders", NULL, STRING, "2.5.0", "autocreate_subscribe_folders" }
+{ "autosubscribeinboxfolders", NULL, STRING, "2.5.0", "2.5.0", "autocreate_subscribe_folders" }
 /* Deprecated in favor of \fIautocreate_subscribe_folders\fR. */
 
-{ "autosubscribesharedfolders", NULL, STRING, "2.5.0", "autocreate_subscribe_sharedfolders" }
+{ "autosubscribesharedfolders", NULL, STRING, "2.5.0", "2.5.0", "autocreate_subscribe_sharedfolders" }
 /* Deprecated in favor of \fIautocreate_subscribe_sharedfolders\fR. */
 
-{ "autosubscribe_all_sharedfolders", 0, SWITCH, "2.5.0", "autocreate_subscribe_sharedfolders_all" }
+{ "autosubscribe_all_sharedfolders", 0, SWITCH, "2.5.0", "2.5.0", "autocreate_subscribe_sharedfolders_all" }
 /* Deprecated in favor of \fIautocreate_subscribe_sharedfolders_all\fR. */
 
-{ "autocreate_inbox_folders", NULL, STRING }
+# Commented out - there's no single setting "autocreate_acl",
+# but we need this for the man page
+# { "autocreate_acl", NULL, STRING, "3.1.10" }
+/* If folders are to be created by \fIautocreate_inbox_folders\R, this
+   setting can be used to apply additional ACLs to the autocreated
+   folders.  The syntax is "autocreate_acl folder identifier rights",
+   where \fIfolder\fR must match one of the \fIautocreate_inbox_folders\fR
+   folders, \fIidentifier\fR must be a valid cyrus identifier, and
+   \fIrights\fR must be a valid cyrus rights string.  Multiple
+   identifier|rights pairs can be assigned to a single folder by providing
+   this setting multiple times.
+.PP
+   For example, "autocreate_acl Plus anyone p" would allow lmtp delivery
+   to a folder named "Plus".
+   */
+
+
+{ "autocreate_inbox_folders", NULL, STRING, "2.5.0" }
 /* If a user does not have an INBOX already, and the INBOX is to be
    created, create the list of folders in this setting as well.
    \fIautocreate_inbox_folders\fR is a list of INBOX's subfolders
@@ -366,12 +413,12 @@ Blank lines and lines beginning with ``#
 .PP
  */
 
-{ "autocreate_post", 0, SWITCH }
+{ "autocreate_post", 0, SWITCH, "2.5.0" }
 /* If enabled, when \fIlmtpd(8)\fR receives an incoming mail for an
    INBOX that does not exist, then the INBOX is automatically created
    by \fIlmtpd(8)\fR and delivery of the message continues. */
 
-{ "autocreate_quota", -1, INT }
+{ "autocreate_quota", -1, INT, "2.5.0" }
 /* If set to a value of zero or higher, users have their INBOX folders
    created upon a successful login event or upon \fIlmtpd(8)\fR
    message delivery if \fIautocreate_post\fR is enabled, provided their
@@ -382,7 +429,7 @@ Blank lines and lines beginning with ``#
 .PP
    Note that quota is specified in kilobytes. */
 
-{ "autocreate_quota_messages", -1, INT }
+{ "autocreate_quota_messages", -1, INT, "3.0.0" }
 /* If set to a value of zero or higher, users who have their INBOX
    folders created upon a successful login event (see
    \fIautocreate_quota\fR), or upon \fIlmtpd(8)\fR message delivery if
@@ -394,7 +441,7 @@ Blank lines and lines beginning with ``#
    For consistency with \fIautocreate_quota\fR, a value of zero is treated
    as unlimited message quota, rather than a message quota of zero. */
 
-{ "autocreate_sieve_folders", NULL, STRING }
+{ "autocreate_sieve_folders", NULL, STRING, "2.5.0" }
 /* A "|" separated list of subfolders of INBOX that will be
    automatically created, if requested by a sieve filter, through the
    "fileinto" action. The default is to create no folders
@@ -404,86 +451,96 @@ Blank lines and lines beginning with ``#
    setting of "Junk | Trash" will create two folders: "Junk" and
    "Trash". */
 
-{ "autocreate_sieve_script", NULL, STRING }
+{ "autocreate_sieve_script", NULL, STRING, "2.5.0" }
 /* The full path of a file that contains a sieve script. This script
    automatically becomes a user's initial default sieve filter script.
 .PP
     When this option is not defined, no default sieve filter is created.
     The file must be readable by the Cyrus daemon. */
 
-{ "autocreate_sieve_script_compile", 0, SWITCH }
+{ "autocreate_sieve_script_compile", 0, SWITCH, "2.5.0" }
 /* If set to yes and no compiled sieve script file exists, the sieve script which is
    compiled on the fly will be saved in the file name that autocreate_sieve_compiledscript
    option points to. In order a compiled script to be generated, autocreate_sieve_script and
    autocreate_sieve_compiledscript must have valid values */
 
-{ "autocreate_sieve_script_compiled", NULL, STRING }
+{ "autocreate_sieve_script_compiled", NULL, STRING, "2.5.0" }
 /* The full path of a file that contains a compiled in bytecode sieve script. This script
    automatically becomes a user's initial default sieve filter script.  If this option is
    not specified, or the filename doesn't exist then the script defined by
    autocreate_sieve_script is compiled on the fly and installed as the user's default
    sieve script */
 
-{ "autocreate_subscribe_folders", NULL, STRING }
+{ "autocreate_subscribe_folders", NULL, STRING, "2.5.0" }
 /* A list of folder names, separated by "|", that the users get automatically subscribed to,
    when their INBOX is created. These folder names must have been included in the
    autocreateinboxfolders option of the imapd.conf. */
 
-{ "autocreate_subscribe_sharedfolders", NULL, STRING }
+{ "autocreate_subscribe_sharedfolders", NULL, STRING, "2.5.0" }
 /* A list of shared folders (bulletin boards), separated by "|", that the users get
    automatically subscribed to, after their INBOX is created. The shared folder must
    have been created and the user must have the required permissions to get subscribed
    to it. Otherwise, subscribing to the shared folder fails. */
 
-{ "autocreate_subscribe_sharedfolders_all", 0, SWITCH }
+{ "autocreate_subscribe_sharedfolders_all", 0, SWITCH, "2.5.0" }
 /* If set to yes, the user is automatically subscribed to all shared folders, one has permission
    to subscribe to. */
 
-{ "autocreate_users", "anyone", STRING }
+{ "autocreate_users", "anyone", STRING, "2.5.0" }
 /* A space separated list of users and/or groups that are allowed their INBOX to be
    automatically created. */
 
+{ "autoexpunge", 0, SWITCH, "3.1.7" }
+/* If set to yes, then all \Deleted messages will be automatically expunged whenever
+   an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect */
+
 # Commented out - there's no such thing as "backuppartition-name",
 # but we need this for the man page
-# { "backuppartition-name", NULL, STRING }
+# { "backuppartition-name", NULL, STRING, "3.0.0" }
 /* The pathname of the backup partition \fIname\fR.  At least one backup
    partition pathname MUST be specified if backups are in use.  Note that
    there is no relationship between spool partitions and backup partitions. */
 
-{ "backup_compact_minsize", 0, INT }
+{ "backup_compact_minsize", 0, INT, "3.0.0" }
 /* The minimum size in kilobytes of chunks in each backup.  The compact tool
    will try to combine adjacent chunks that are smaller than this.
 .PP
    Setting this value to zero or negative disables combining of chunks. */
 
-{ "backup_compact_maxsize", 0, INT }
+{ "backup_compact_maxsize", 0, INT, "3.0.0" }
 /* The maximum size in kilobytes of chunks in each backup.  The compact tool
    will try to split chunks larger than this into smaller chunks.
 .PP
    Setting this value to zero or negative disables splitting of chunks. */
 
-{ "backup_compact_work_threshold", 1, INT }
+{ "backup_compact_work_threshold", 1, INT, "3.0.0" }
 /* The number of chunks that must obviously need compaction before the compact
    tool will go ahead with the compaction.  If set to less than one, the value
    is treated as being one. */
 
-{ "backup_staging_path", NULL, STRING }
+{ "backup_staging_path", NULL, STRING, "3.0.0" }
 /* The absolute path of the backup staging area.  If not specified,
    will be temp_path/backup */
 
-{ "backup_retention_days", 7, INT }
-/* The number of days to keep content in backup after it has been deleted
+{ "backup_retention_days", NULL, DURATION, "3.1.8", "3.1.8", "backup_retention" }
+/* Deprecated in favor of \fIbackup_retention\fR. */
+
+{ "backup_retention", "7d", DURATION, "3.1.0" }
+/* How long to keep content in backup after it has been deleted
    from the source.  If set to a negative value or zero, deleted content
-   will be kept indefinitely. */
+   will be kept indefinitely.
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed.  */
 
-{ "backup_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "lmdb")}
+{ "backup_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the backup locations database. */
 
-{ "backup_db_path", NULL, STRING }
+{ "backup_db_path", NULL, STRING, "3.0.0" }
 /* The absolute path to the backup db file.  If not specified,
    will be configdirectory/backups.db */
 
-{ "backup_keep_previous", 0, SWITCH }
+{ "backup_keep_previous", 0, SWITCH, "3.0.0" }
 /* Whether the \fBctl_backups compact\fR and \fBctl_backups reindex\fR
    commands should preserve the original file.  The original file will
    be named with a timestamped suffix.  This is mostly useful for
@@ -493,30 +550,44 @@ Blank lines and lines beginning with ``#
    increase the disk used by it (because there will now be an extra
    copy: the original version, and the compacted version). */
 
-{ "boundary_limit", 1000, INT }
+{ "boundary_limit", 1000, INT, "2.5.0" }
 /* messages are parsed recursively and a deep enough MIME structure
    can cause a stack overflow.  Do not parse deeper than this many
    layers of MIME structure.  The default of 1000 is much higher
    than any sane message should have. */
 
-{ "caldav_allowattach", 1, SWITCH }
-/* Enable managed attachments support on the caldav server. */
+{ "caldav_allowattach", 1, SWITCH, "3.0.0" }
+/* Enable managed attachments support on the CalDAV server. */
+
+{ "caldav_allowcalendaradmin", 0, SWITCH, "3.1.2" }
+/* Enable per-user calendar administration web UI on the CalDAV server. */
 
-{ "caldav_allowscheduling", "on", ENUM("off", "on", "apple") }
+{ "caldav_allowscheduling", "on", ENUM("off", "on", "apple"), "2.5.0" }
 /* Enable calendar scheduling operations. If set to "apple", the
    server will emulate Apple CalendarServer behavior as closely as
    possible. */
 
-{ "caldav_create_attach", 1, SWITCH }
-/* Create the 'Attachments' calendar if it doesn't already exist */
+{ "caldav_create_attach", 1, SWITCH, "3.0.0" }
+/* Create the 'Attachments' collection if it doesn't already exist */
 
-{ "caldav_create_default", 1, SWITCH }
+{ "caldav_create_default", 1, SWITCH, "3.0.0" }
 /* Create the 'Default' calendar if it doesn't already exist */
 
-{ "caldav_create_sched", 1, SWITCH }
+{ "caldav_create_sched", 1, SWITCH, "3.0.0" }
 /* Create the 'Inbox' and 'Outbox' calendars if they don't already exist */
 
-{ "caldav_maxdatetime", "20380119T031407Z", STRING }
+{ "caldav_historical_age", "7d", DURATION, "3.1.8" }
+/* How long after an occurrence of event or task has concluded
+   that it is considered 'historical'.  Changes to historical
+   occurrences of events or tasks WILL NOT have invite or reply
+   messages sent for them.  A negative value means that events
+   and tasks are NEVER considered historical.
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed.  */
+*/
+
+{ "caldav_maxdatetime", "20380119T031407Z", STRING, "2.5.0" }
 /* The latest date and time accepted by the server (ISO format).  This
    value is also used for expanding non-terminating recurrence rules.
 .PP
@@ -525,39 +596,52 @@ Blank lines and lines beginning with ``#
    utility in order to see its effect on serer-side time-based
    queries. */
 
-{ "caldav_mindatetime", "19011213T204552Z", STRING }
+{ "caldav_mindatetime", "19011213T204552Z", STRING, "2.5.0" }
 /* The earliest date and time accepted by the server (ISO format). */
 
-{ "caldav_realm", NULL, STRING }
+{ "caldav_realm", NULL, STRING, "2.5.0" }
 /* The realm to present for HTTP authentication of CalDAV resources.
    If not set (the default), the value of the "servername" option will
    be used.*/
 
-{ "calendarprefix", "#calendars", STRING }
+{ "calendarprefix", "#calendars", STRING, "2.5.0" }
 /* The prefix for the calendar mailboxes hierarchies.  The hierarchy
    delimiter will be automatically appended.  The public calendar
    hierarchy will be at the toplevel of the shared namespace.  A
    user's personal calendar hierarchy will be a child of their Inbox. */
 
-{ "calendar_user_address_set", NULL, STRING }
+{ "calendar_user_address_set", NULL, STRING, "2.5.0" }
 /* Space-separated list of domains corresponding to calendar user
    addresses for which the server is responsible.  If not set (the
    default), the value of the "servername" option will be used. */
 
-{ "carddav_realm", NULL, STRING }
+{ "calendar_component_set", "VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL", BITFIELD("VEVENT", "VTODO", "VJOURNAL", "VFREEBUSY", "VAVAILABILITY", "VPOLL"), "3.1.7" }
+/* Space-separated list of iCalendar component types that calendar
+   object resources may contain in a calendar collection.
+   This restriction is only set at calendar creation time and only
+   if the CalDAV client hasn't specified a restriction in the creation
+   request. */
+
+{ "carddav_allowaddmember", 0, SWITCH, "3.1.3" }
+/* Enable support for POST add-member on the CardDAV server. */
+
+{ "carddav_allowaddressbookadmin", 0, SWITCH, "3.1.2" }
+/* Enable per-user addressbook administration web UI on the CardDAV server. */
+
+{ "carddav_realm", NULL, STRING, "2.5.0" }
 /* The realm to present for HTTP authentication of CardDAV resources.
    If not set (the default), the value of the "servername" option will
    be used.*/
 
-{ "carddav_repair_vcard", 0, SWITCH }
+{ "carddav_repair_vcard", 0, SWITCH, "3.0.0" }
 /* If enabled, VCARDs with invalid content are attempted to be repaired
    during creation. */
 
-{ "chatty", 0, SWITCH }
+{ "chatty", 0, SWITCH, "2.5.0" }
 /* If yes, syslog tags and commands for every IMAP command, mailboxes
    for every lmtp connection, every POP3 command, etc */
 
-{ "client_bind", 0, SWITCH }
+{ "client_bind", 0, SWITCH, "3.0.0" }
 /* If enabled, a specific IP will be bound when performing a client
    connection.  \fBclient_bind_name\fR is used if it is set, otherwise
    \fBservername\fR is used.  This is useful on multi-homed servers where
@@ -566,94 +650,116 @@ Blank lines and lines beginning with ``#
    If not enabled (the default), no bind will be performed.  Client
    connections will use an IP chosen by the operating system. */
 
-{ "client_bind_name", NULL, STRING }
+{ "client_bind_name", NULL, STRING, "3.0.0" }
 /* IPv4, IPv6 address or hostname to bind for client connections when
    \fBclient_bind\fR is enabled.  If not set (the default),
    \fRservername\fR will be used. */
 
-{ "client_timeout", 10, INT }
-/* Number of seconds to wait before returning a timeout failure when
-   performing a client connection (e.g., in a murder environment) */
+{ "client_timeout", "10s", DURATION, "3.1.8" }
+/* Time to wait before returning a timeout failure when performing a
+   client connection (e.g. in a murder environment).
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed.  */
 
-{ "commandmintimer", NULL, STRING }
+{ "commandmintimer", NULL, STRING, "2.4.0" }
 /* Time in seconds. Any imap command that takes longer than this
    time is logged. */
 
-{ "configdirectory", NULL, STRING }
+{ "configdirectory", NULL, STRING, "2.3.17" }
 /* The pathname of the IMAP configuration directory.  This field is
    required. */
 
-{ "createonpost", 0, SWITCH, "2.5.0", "autocreate_post" }
+{ "createonpost", 0, SWITCH, "2.5.0", "2.5.0", "autocreate_post" }
 /* Deprecated in favor of \fIautocreate_post\fR. */
 
-{ "conversations", 0, SWITCH }
+{ "conversations", 0, SWITCH, "3.0.0" }
 /* Enable the XCONVERSATIONS extensions.  Extract conversation
    tracking information from incoming messages and track them
    in per-user databases. */
 
-{ "conversations_counted_flags", NULL, STRING }
+{ "conversations_counted_flags", NULL, STRING, "3.0.0" }
 /* space-separated list of flags for which per-conversation counts
    will be kept.  Note that you need to reconstruct the conversations
    database with ctl_conversationsdb if you change this option on a
    running server, or the counts will be wrong.  */
 
-{ "conversations_db", "skiplist", STRINGLIST("skiplist", "sql", "twoskip", "lmdb")}
+{ "conversations_db", "skiplist", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the per-user conversations database. */
 
-{ "conversations_expire_days", 90, INT }
+{ "conversations_expire_days", NULL, DURATION, "3.1.8", "3.1.8", "conversations_expire_after" }
+/* Deprecated in favor of \fIconversations_expire_after\fR. */
+
+{ "conversations_expire_after", "90d", DURATION, "3.1.8" }
 /* How long the conversations database keeps the message tracking
    information needed for receiving new messages in existing
-   conversations, in days. */
+   conversations.
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed. */
+
+{ "conversations_max_thread", 100, INT, "3.1.1" }
+/* maximum size for a single thread.  Threads will split if they have this many
+ * messages in them and another message arrives */
 
-{ "crossdomains", 0, SWITCH }
+{ "crossdomains", 0, SWITCH, "3.0.0" }
 /* Enable cross domain sharing.  This works best with alt namespace and
    unix hierarchy separators on, so you get Other Users/foo@example.com/... */
 
-{ "crossdomains_onlyother", 0, SWITCH }
+{ "crossdomains_onlyother", 0, SWITCH, "3.0.0" }
 /* only show the domain for users in other domains than your own (for
    backwards compatibility if you're already sharing */
 
-{ "cyrus_group", NULL, STRING }
+{ "cyrus_group", NULL, STRING, "3.1.7" }
 /* The name of the group Cyrus services will run as.  If not configured, the
    primary group of cyrus_user will be used. Can be further overridden by
    setting the $CYRUS_GROUP environment variable. */
 
-{ "cyrus_user", NULL, STRING }
+{ "cyrus_user", NULL, STRING, "3.0.0" }
 /* The username to use as the 'cyrus' user.  If not configured, the compile
    time default will be used. Can be further overridden by setting the
    $CYRUS_USER environment variable. */
 
-{ "davdriveprefix", "#drive", STRING }
+{ "davdriveprefix", "#drive", STRING, "3.0.0" }
 /* The prefix for the DAV storage mailboxes hierarchies.  The hierarchy
    delimiter will be automatically appended.  The public storage
    hierarchy will be at the toplevel of the shared namespace.  A
    user's personal storage hierarchy will be a child of their Inbox. */
 
-{ "davnotificationsprefix", "#notifications", STRING }
+{ "davnotificationsprefix", "#notifications", STRING, "3.0.0" }
 /* The prefix for the DAV notifications hierarchy.  The hierarchy
    delimiter will be automatically appended.  The public notifications
    hierarchy will be at the toplevel of the shared namespace.  A
    user's personal notifications hierarchy will be a child of their Inbox. */
 
-{ "dav_realm", NULL, STRING }
+{ "dav_realm", NULL, STRING, "2.5.0" }
 /* The realm to present for HTTP authentication of generic DAV
    resources (principals).  If not set (the default), the value of the
    "servername" option will be used.*/
 
-{ "debug_command", NULL, STRING }
+{ "dav_lock_timeout", "20s", DURATION, "3.1.8" }
+/* The maximum time to wait for a write lock on the per-user DAV database
+   before timeout. For HTTP requests, the HTTP status code 503 is returned
+   if the lock can not be obtained within this time.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+
+{ "debug_command", NULL, STRING, "2.3.17" }
 /* Debug command to be used by processes started with -D option.  The string
    is a C format string that gets 3 options: the first is the name of the
-   executable (without path).  The second is the pid (integer) and the third
-   is the service ID.  Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d */
+   executable (as specified in the cmd parameter in cyrus.conf). The second
+   is the pid (integer) and the third is the service ID.
+   Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d */
 
-{ "defaultacl", "anyone lrs", STRING }
+{ "defaultacl", "anyone lrs", STRING, "2.3.17" }
 /* The Access Control List (ACL) placed on a newly-created (non-user)
    mailbox that does not have a parent mailbox. */
 
-{ "defaultdomain", "internal", STRING }
+{ "defaultdomain", "internal", STRING, "3.0.0" }
 /* The default domain for virtual domain support */
 
-{ "defaultpartition", NULL, STRING }
+{ "defaultpartition", NULL, STRING, "2.3.17" }
 /* The partition name used by default for new mailboxes.  If not
    specified, the partition with the most free space will be used for
    new mailboxes.
@@ -662,7 +768,7 @@ Blank lines and lines beginning with ``#
    specified as \fIpartition-name\fR, where you substitute 'name'
    for the alphanumeric string you set \fIdefaultpartition\fR to. */
 
-{ "defaultsearchtier", "", STRING }
+{ "defaultsearchtier", "", STRING, "3.0.0" }
 /* Name of the default tier that messages will be indexed to. Search
    indexes can be organized in tiers to allow index storage in different
    directories and physical media. See the man page of squatter for
@@ -671,12 +777,12 @@ Blank lines and lines beginning with ``#
 .PP
    This option MUST be specified for xapian search. */
 
-{ "defaultserver", NULL, STRING }
+{ "defaultserver", NULL, STRING, "2.3.17" }
 /* The backend server name used by default for new mailboxes.  If not
    specified, the server with the most free space will be used for new
    mailboxes. */
 
-{ "deletedprefix", "DELETED", STRING }
+{ "deletedprefix", "DELETED", STRING, "2.3.17" }
 /*  With \fBdelete_mode\fR set to \fIdelayed\fR, the
     \fBdeletedprefix\fR setting defines the prefix for the hierarchy of
     deleted mailboxes.
@@ -684,7 +790,7 @@ Blank lines and lines beginning with ``#
     The hierarchy delimiter will be automatically appended.
 */
 
-{ "delete_mode", "delayed", ENUM("immediate", "delayed") }
+{ "delete_mode", "delayed", ENUM("immediate", "delayed"), "2.5.0" }
 /*  The manner in which mailboxes are deleted. In the default
     \fIdelayed\fR mode, mailboxes that are being deleted are renamed to
     a special mailbox hierarchy under the \fBdeletedprefix\fR, to be
@@ -694,60 +800,63 @@ Blank lines and lines beginning with ``#
     immediately.
 */
 
-{ "delete_unsubscribe", 0, SWITCH }
+{ "delete_unsubscribe", 0, SWITCH, "3.0.0" }
 /* Whether to also unsubscribe from mailboxes when they are deleted.
    Note that this behaviour contravenes RFC 3501 section 6.3.9, but
    may be useful for avoiding user/client software confusion.
    The default is 'no'. */
 
-{ "deleteright", "c", STRING }
+{ "deleteright", "c", STRING, "2.3.17" }
 /* Deprecated - only used for backwards compatibility with existing
    installations.  Lists the old RFC 2086 right which was used to
    grant the user the ability to delete a mailbox.  If a user has this
    right, they will automatically be given the new 'x' right. */
 
-{ "disable_user_namespace", 0, SWITCH }
+{ "disable_user_namespace", 0, SWITCH, "2.5.0" }
 /* Preclude list command on user namespace.  If set to 'yes', the
    LIST response will never include any other user's mailbox.  Admin
    users will always see all mailboxes.  The default is 'no' */
 
-{ "disable_shared_namespace", 0, SWITCH }
+{ "disable_shared_namespace", 0, SWITCH, "2.5.0" }
 /* Preclude list command on shared namespace.  If set to 'yes', the
    LIST response will never include any non-user mailboxes.  Admin
    users will always see all mailboxes.  The default is 'no' */
 
-{ "disconnect_on_vanished_mailbox", 0, SWITCH }
+{ "disconnect_on_vanished_mailbox", 0, SWITCH, "2.3.17" }
 /* If enabled, IMAP/POP3/NNTP clients will be disconnected by the
    server if the currently selected mailbox is (re)moved by another
    session.  Otherwise, the missing mailbox is treated as empty while
    in use by the client.*/
 
-{ "ischedule_dkim_domain", NULL, STRING }
+{ "ischedule_dkim_domain", NULL, STRING, "2.5.0" }
 /* The domain to be reported as doing iSchedule DKIM signing. */
 
-{ "ischedule_dkim_key_file", NULL, STRING }
+{ "ischedule_dkim_key_file", NULL, STRING, "2.5.0" }
 /* File containing the private key for iSchedule DKIM signing. */
 
-{ "ischedule_dkim_selector", NULL, STRING }
+{ "ischedule_dkim_required", 1, SWITCH, "3.1.4" }
+/* A DKIM signature is required on received iSchedule requests. */
+
+{ "ischedule_dkim_selector", NULL, STRING, "2.5.0" }
 /* Name of the selector subdividing the domain namespace.  This
    specifies the actual key used for iSchedule DKIM signing within the
    domain. */
 
-{ "duplicate_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "lmdb")}
+{ "duplicate_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the duplicate delivery suppression
    and sieve. */
 
-{ "duplicate_db_path", NULL, STRING }
+{ "duplicate_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the duplicate db file.  If not specified,
    will be configdirectory/deliver.db */
 
-{ "duplicatesuppression", 1, SWITCH }
+{ "duplicatesuppression", 1, SWITCH, "2.3.17" }
 /* If enabled, lmtpd will suppress delivery of a message to a mailbox if
    a message with the same message-id (or resent-message-id) is recorded
    as having already been delivered to the mailbox.  Records the mailbox
    and message-id/resent-message-id of all successful deliveries. */
 
-{ "event_content_inclusion_mode", "standard", ENUM("standard", "message", "header", "body", "headerbody") }
+{ "event_content_inclusion_mode", "standard", ENUM("standard", "message", "header", "body", "headerbody"), "2.5.0" }
 /* The mode in which message content may be included with MessageAppend and
    MessageNew. "standard" mode is the default behavior in which message is
    included up to a size with the notification. In "message" mode, the message
@@ -756,62 +865,64 @@ Blank lines and lines beginning with ``#
    to a size. In "headerbody" mode, it includes full headers and body truncated
    to a size */
 
-{ "event_content_size", 0, INT }
+{ "event_content_size", 0, INT, "2.5.0" }
 /* Truncate the message content that may be included with MessageAppend and
    MessageNew. Set 0 to include the entire message itself */
 
-{ "event_exclude_flags", NULL, STRING }
+{ "event_exclude_flags", NULL, STRING, "2.5.0" }
 /* Don't send event notification for given IMAP flag(s) */
 
-{ "event_exclude_specialuse", "\\Junk", STRING }
+{ "event_exclude_specialuse", "\\Junk", STRING, "2.5.0" }
 /* Don't send event notification for folder with given special-use attributes.
    Set ALL for any folder */
 
-{ "event_extra_params", "timestamp", BITFIELD("bodyStructure", "clientAddress", "diskUsed", "flagNames", "messageContent", "messageSize", "messages", "modseq", "service", "timestamp", "uidnext", "vnd.cmu.midset", "vnd.cmu.unseenMessages", "vnd.cmu.envelope", "vnd.cmu.sessionId", "vnd.cmu.mailboxACL", "vnd.cmu.mbtype", "vnd.cmu.davFilename", "vnd.cmu.davUid", "vnd.fastmail.clientId", "vnd.fastmail.sessionId", "vnd.fastmail.convExists", "vnd.fastmail.convUnseen", "vnd.fastmail.cid", "vnd.fastmail.counters") }
+{ "event_extra_params", "timestamp", BITFIELD("bodyStructure", "clientAddress", "diskUsed", "flagNames", "messageContent", "messageSize", "messages", "modseq", "service", "timestamp", "uidnext", "vnd.cmu.midset", "vnd.cmu.unseenMessages", "vnd.cmu.envelope", "vnd.cmu.sessionId", "vnd.cmu.mailboxACL", "vnd.cmu.mbtype", "vnd.cmu.davFilename", "vnd.cmu.davUid", "vnd.fastmail.clientId", "vnd.fastmail.sessionId", "vnd.fastmail.convExists", "vnd.fastmail.convUnseen", "vnd.fastmail.cid", "vnd.fastmail.counters", "vnd.cmu.emailid", "vnd.cmu.threadid"), "3.1.6" }
 /* Space-separated list of extra parameters to add to any appropriated event. */
 
-{ "event_groups", "message mailbox", BITFIELD("message", "quota", "flags", "access", "mailbox", "subscription", "calendar", "applepushservice" ) }
+{ "event_groups", "message mailbox", BITFIELD("message", "quota", "flags", "access", "mailbox", "subscription", "calendar", "applepushservice" ), "3.0.0" }
 /* Space-separated list of groups of related events to turn on notification */
 
-{ "event_notifier", NULL, STRING }
+{ "event_notifier", NULL, STRING, "2.5.0" }
 /* Notifyd(8) method to use for "EVENT" notifications which are based on
    the RFC 5423.  If not set, "EVENT" notifications are disabled. */
 
-{ "expunge_mode", "delayed", ENUM("default", "immediate", "delayed") }
+{ "expunge_mode", "delayed", ENUM("immediate", "semidelayed", "delayed"), "3.1.1" }
 /* The mode in which messages (and their corresponding cache entries)
-   are expunged.  "default" mode is the old behavior in which the
+   are expunged.  "semidelayed" mode is the old behavior in which the
    message files are purged at the time of the EXPUNGE, but index
-   and cache records are retained to facilitate QRESYNC.  (Note that
-   this behaviour is no longer the default, but is so named for historical
-   reasons.)  In "delayed" mode, which is the default since Cyrus 2.5.0,
+   and cache records are retained to facilitate QRESYNC.
+   In "delayed" mode, which is the default since Cyrus 2.5.0,
    the message files are also retained, allowing unexpunge to
    rescue them.  In "immediate" mode, both the message files and the
    index records are removed as soon as possible.  In all cases,
    nothing will be finally purged until all other processes have
    closed the mailbox to ensure they never see data disappear under
-   them.  In "default" or "delayed" mode, a later run of "cyr_expire"
+   them.  In "semidelayed" or "delayed" mode, a later run of "cyr_expire"
    will clean out the retained records (and possibly message files).
    This reduces the amount of I/O that takes place at the time of
    EXPUNGE and should result in greater responsiveness for the client,
    especially when expunging a large number of messages. */
 
-{ "failedloginpause", 3, INT }
-/* Number of seconds to pause after a failed login. */
+{ "failedloginpause", "3s", DURATION, "3.1.8" }
+/* Time to pause after a failed login.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "flushseenstate", 1, SWITCH, "2.5.0" }
+{ "flushseenstate", 1, SWITCH, "2.5.0", "2.5.0" }
 /* Deprecated. No longer used */
 
-{ "foolstupidclients", 0, SWITCH }
+{ "foolstupidclients", 0, SWITCH, "2.3.17" }
 /* If enabled, only list the personal namespace when a LIST "*" is performed
    (it changes the request to a LIST "INBOX*"). */
 
-{ "force_sasl_client_mech", NULL, STRING }
+{ "force_sasl_client_mech", NULL, STRING, "2.3.17" }
 /* Force preference of a given SASL mechanism for client side operations
    (e.g., murder environments).  This is separate from (and overridden by)
    the ability to use the <host shortname>_mechs option to set preferred
    mechanisms for a specific host */
 
-{ "fulldirhash", 0, SWITCH }
+{ "fulldirhash", 0, SWITCH, "2.3.17" }
 /* If enabled, uses an improved directory hashing scheme which hashes
    on the entire username instead of using just the first letter as
    the hash.  This changes hash algorithm used for quota and user
@@ -822,17 +933,17 @@ Blank lines and lines beginning with ``#
    server must be quiesced and then the directories moved with the
    \fBrehash\fR utility. */
 
-{ "hashimapspool", 0, SWITCH }
+{ "hashimapspool", 0, SWITCH, "2.3.17" }
 /* If enabled, the partitions will also be hashed, in addition to the
    hashing done on configuration directories.  This is recommended if
    one partition has a very bushy mailbox tree. */
 
-{ "debug", 0, SWITCH }
+{ "debug", 0, SWITCH, "2.5.0" }
 /* If enabled, allow syslog() to pass LOG_DEBUG messages. */
 
 # Commented out - there's no such thing as "hostname_mechs", but we need
 # this for the man page
-# { "hostname_mechs", NULL, STRING }
+# { "hostname_mechs", NULL, STRING, "2.3.17" }
 /* Force a particular list of SASL mechanisms to be used when authenticating
    to the backend server hostname (where hostname is the short hostname of
    the server in question). If it is not specified it will query the server
@@ -840,17 +951,17 @@ Blank lines and lines beginning with ``#
 
 # Commented out - there's no such thing as "hostname_password", but we need
 # this for the man page
-# { "hostname_password", NULL, STRING }
+# { "hostname_password", NULL, STRING, "2.3.17" }
 /* The password to use for authentication to the backend server hostname
    (where hostname is the short hostname of the server) - Cyrus Murder */
 
-{ "httpallowcompress", 1, SWITCH }
+{ "httpallowcompress", 1, SWITCH, "2.5.0" }
 /* If enabled, the server will compress response payloads if the client
    indicates that it can accept them.  Note that the compressed data
    will appear in telemetry logs, leaving only the response headers as
    human-readable.*/
 
-{ "httpallowcors", NULL, STRING }
+{ "httpallowcors", NULL, STRING, "2.5.0" }
 /* A wildmat pattern specifying a list of origin URIs ( scheme "://"
    host [ ":" port ] ) that are allowed to make Cross-Origin Resource
    Sharing (CORS) requests on the server.  By default, CORS requests
@@ -861,12 +972,12 @@ Blank lines and lines beginning with ``#
    443 for https), and there should be no trailing '/' (e.g.:
    "http://www.example.com:8080", "https://example.org"). */
 
-{ "httpallowtrace", 0, SWITCH }
+{ "httpallowtrace", 0, SWITCH, "2.5.0" }
 /* Allow use of the TRACE method.
 .PP
    Note that sensitive data might be disclosed by the response. */
 
-{ "httpallowedurls", NULL, STRING }
+{ "httpallowedurls", NULL, STRING, "2.5.0" }
 /* Space-separated list of relative URLs (paths) rooted at
    "httpdocroot" (see below) to be served by httpd.  If set, this
    option will limit served static content to only those paths specified
@@ -876,27 +987,30 @@ Blank lines and lines beginning with ``#
    Note that any path specified by "rss_feedlist_template" is an
    exception to this rule.*/
 
-{ "httpcontentmd5", 0, SWITCH }
+{ "httpcontentmd5", 0, SWITCH, "2.5.0" }
 /* If enabled, HTTP responses will include a Content-MD5 header for
    the purpose of providing an end-to-end message integrity check
    (MIC) of the payload body.  Note that enabling this option will
    use additional CPU to generate the MD5 digest, which may be ignored
    by clients anyways. */
 
-{ "httpdocroot", NULL, STRING }
+{ "httpdocroot", NULL, STRING, "2.5.0" }
 /* If set, http will serve the static content (html/text/jpeg/gif
    files, etc) rooted at this directory.  Otherwise, httpd will not
    serve any static content. */
 
-{ "httpkeepalive", 20, INT }
-/* Set the length of the HTTP server's keepalive heartbeat in seconds.
-   The default is 20.  The minimum value is 0, which will disable the
-   keepalive heartbeat.  When enabled, if a request takes longer than
-   \fIhttpkeepalive\fR seconds to process, the server will send the client
-   provisional responses every \fIhttpkeepalive\fR seconds until the
-   final response can be sent */
+{ "httpkeepalive", "20s", DURATION, "3.1.8" }
+/* Set the length of the HTTP server's keepalive heartbeat.  The
+   default is 20 seconds.  The minimum value is 0, which will disable
+   the keepalive heartbeat.  When enabled, if a request takes longer
+   than \fIhttpkeepalive\fR to process, the server will send the client
+   provisional responses every \fIhttpkeepalive\fR until the final
+   response can be sent.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "httpmodules", "", BITFIELD("admin", "caldav", "carddav", "domainkey", "freebusy", "ischedule", "rss", "tzdist", "webdav") }
+{ "httpmodules", "", BITFIELD("admin", "caldav", "carddav", "cgi", "domainkey", "freebusy", "ischedule", "jmap", "prometheus", "rss", "tzdist", "webdav"), "3.1.7" }
 /* Space-separated list of HTTP modules that will be enabled in
    httpd(8).  This option has no effect on modules that are disabled
    at compile time due to missing dependencies (e.g. libical).
@@ -905,57 +1019,63 @@ Blank lines and lines beginning with ``#
    that both "freebusy" and "ischedule" depend on "caldav" being
    enabled. */
 
-{ "httpprettytelemetry", 0, SWITCH }
+{ "httpprettytelemetry", 0, SWITCH, "2.5.0" }
 /* If enabled, HTTP response payloads including server-generated
    markup languages (HTML, XML) will utilize line breaks and
    indentation to promote better human-readability in telemetry logs.
    Note that enabling this option will increase the amount of data
    sent across the wire. */
 
-{ "httptimeout", 5, INT }
-/* Set the length of the HTTP server's inactivity autologout timer,
-   in minutes.  The default is 5.  The minimum value is 0, which will
-   disable persistent connections. */
+{ "httptimeout", "5m", DURATION, "3.1.8" }
+/* Set the length of the HTTP server's inactivity autologout timer.
+   The default is 5 minutes.  The minimum value is 0, which will
+   disable persistent connections.
+.PP
+   For backwards compatibility, if no unit is specified, minutes
+   is assumed. */
 
-{ "idlesocket", "{configdirectory}/socket/idle", STRING }
+{ "idlesocket", "{configdirectory}/socket/idle", STRING, "2.3.17" }
 /* Unix domain socket that idled listens on. */
 
-{ "ignorereference", 0, SWITCH }
+{ "ignorereference", 0, SWITCH, "2.3.17" }
 /* For backwards compatibility with Cyrus 1.5.10 and earlier -- ignore
   the reference argument in LIST or LSUB commands. */
 
-{ "imapidlepoll", 60, INT }
-/* The interval (in seconds) for polling for mailbox changes and
-   ALERTs while running the IDLE command.  This option is used when
-   idled is not enabled or cannot be contacted.  The minimum value is
-   1.  A value of 0 will disable IDLE. */
+{ "imapidlepoll", "60s", DURATION, "3.1.8" }
+/* The interval for polling for mailbox changes and ALERTs while running
+   the IDLE command.  This option is used when idled is not enabled or
+   cannot be contacted.  The minimum value is 1 second.  A value of 0
+   will disable IDLE.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "imapidresponse", 1, SWITCH }
+{ "imapidresponse", 1, SWITCH, "2.3.17" }
 /* If enabled, the server responds to an ID command with a parameter
    list containing: version, vendor, support-url, os, os-version,
    command, arguments, environment.  Otherwise the server returns NIL. */
 
-{ "imapmagicplus", 0, SWITCH }
+{ "imapmagicplus", 0, SWITCH, "2.3.17" }
 /* Only list a restricted set of mailboxes via IMAP by using
    userid+namespace syntax as the authentication/authorization id.
    Using userid+ (with an empty namespace) will list only subscribed
    mailboxes. */
 
-{ "imipnotifier", NULL, STRING }
+{ "imipnotifier", NULL, STRING, "3.0.0" }
 /* Notifyd(8) method to use for "IMIP" notifications which are based on
    the RFC 6047.  If not set, "IMIP" notifications are disabled. */
 
-{ "implicit_owner_rights", "lkxa", STRING }
+{ "implicit_owner_rights", "lkxan", STRING, "3.1.2" }
 /* The implicit Access Control List (ACL) for the owner of a mailbox. */
 
 # Commented out - there's no such thing as "@include", but we need
 # this for the man page
-# { "@include", NULL, STRING }
+# { "@include", NULL, STRING, "2.3.17" }
 /* Directive which includes the specified file as part of the
    configuration.  If the path to the file is not absolute, CYRUS_PATH
    is prepended. */
 
-{ "improved_mboxlist_sort", 0, SWITCH }
+{ "improved_mboxlist_sort", 0, SWITCH, "2.3.17" }
 /* If enabled, a special comparator will be used which will correctly
    sort mailbox names that contain characters such as ' ' and '-'.
 .PP
@@ -966,44 +1086,159 @@ Blank lines and lines beginning with ``#
    the same has to be done (cyr_dbtool) for each subscription database
    See improved_mboxlist_sort.html.*/
 
-{ "internaldate_heuristic", "standard", ENUM("standard", "receivedheader") }
-/* Mechanism to determine email internaldates on delivery/reconstruct.
-   "standard" uses time() when delivering a message, mtime on reconstruct.
-   "receivedheader" looks at the top most Received header
-   or time/mtime otherwise */
+{ "jmap_emailsearch_db_path", NULL, STRING, "3.1.6" }
+/* The absolute path to the JMAP email search cache file.  If not
+   specified, JMAP Email/query and Email/queryChanges will not
+   cache email search results. */
+
+{ "jmap_preview_annot", NULL, STRING, "3.1.1" }
+/* The name of the per-message annotation, if any, to store message
+   previews. */
+
+{ "jmap_imagesize_annot", NULL, STRING, "3.1.1" }
+/* The name of the per-message annotation, if any, that stores a
+   JSON object, mapping message part numbers of MIME image types
+   to an array of their image dimensions. The array must have at
+   least two entries, where the first entry denotes the width
+   and the second entry the height of the image. Any additional
+   values are ignored.
+
+   For example, if message part 1.2 contains an image of width 300
+   and height 200, then the value of this annotation would be:
 
-{ "iolog", 0, SWITCH }
+   { "1.2" : [ 300, 200 ] }
+   */
+
+{ "jmap_inlinedcids_annot", NULL, STRING, "3.1.1" }
+/* The name of the per-message annotation, if any, that stores a
+   JSON object, mapping RFC2392 Content-IDs referenced in HTML bodies
+   to the respective HTML body part number.
+
+   For example, if message part 1.2 contains HTML and references an
+   inlined image at "cid:foo", then the value of this annotation
+   would be:
+
+   { "<foo>" : "1.2" }
+
+   Note that the Content-ID key must be URL-unescaped and enclosed in
+   angular brackets, as defined in RFC2392. */
+
+{ "jmap_preview_length", 64, INT, "3.1.1" }
+/* The maximum byte length of dynamically generated message previews. Previews
+   stored in jmap_preview_annot take precedence. */
+
+{ "jmap_max_size_upload", 1048576, INT, "3.1.6" }
+/* The maximum size (in kilobytes) that the JMAP API accepts
+   for blob uploads. Returned as the maxSizeUpload property
+   value of the JMAP \"urn:ietf:params:jmap:core\" capabilities object.
+   Default is 1Gb. */
+
+{ "jmap_max_concurrent_upload", 5, INT, "3.1.6" }
+/* The value to return for the maxConcurrentUpload property of
+   the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+   implementation does not enforce this rate-limit. */
+
+{ "jmap_max_size_request", 10240, INT, "3.1.6" }
+/* The maximum size (in kilobytes) that the JMAP API accepts
+   for requests at the API endpoint. Returned as the
+   maxSizeRequest property value of the JMAP \"urn:ietf:params:jmap:core\"
+   capabilities object. Default is 10Mb. */
+
+{ "jmap_max_concurrent_requests", 5, INT, "3.1.6" }
+/* The value to return for the maxConcurrentRequests property of
+   the JMAP \"urn:ietf:params:jmap:core\" capabilities object. The Cyrus JMAP
+   implementation does not enforce this rate-limit. */
+
+{ "jmap_max_calls_in_request", 50, INT, "3.1.6" }
+/* The maximum number of calls per JMAP request object.
+   Returned as the maxCallsInRequest property value of the
+   JMAP \"urn:ietf:params:jmap:core\" capabilities object. */
+
+{ "jmap_max_delayed_send", "512d", DURATION, "3.1.8" }
+/* The value to return for the maxDelayedSend property of
+   the JMAP \"urn:ietf:params:jmap:emailsubmission\" capabilities object.
+   The Cyrus JMAP implementation does not enforce this limit.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+
+{ "jmap_max_objects_in_get", 4096, INT, "3.1.6" }
+/* The maximum number of ids that a JMAP client may request in
+   a single \"/get\" type method call. The actual number
+   of returned objects in the response may exceed this number
+   if the JMAP object type supports unbounded \"/get\" calls.
+   Returned as the maxObjectsInGet property value of the
+   JMAP \"urn:ietf:params:jmap:core\" capabilities object. */
+
+{ "jmap_max_objects_in_set", 4096, INT, "3.1.6" }
+/* The maximum number of objects a JMAP client may send to create,
+   update or destroy in a single /set type method call.
+   Returned as the maxObjectsInSet property value of the
+   JMAP \"urn:ietf:params:jmap:core\" capabilities object. */
+
+{ "jmap_mail_max_size_attachments_per_email", 10240, INT, "3.1.6" }
+/* The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+   property of the JMAP \"urn:ietf:params:jmap:mail\" capabilities object. The Cyrus
+   JMAP implementation does not enforce this size limit. Default is 10 Mb.*/
+
+{ "jmap_nonstandard_extensions", 0, SWITCH, "3.1.9" }
+/* If enabled, support non-standard JMAP extensions.  If not enabled,
+   only IETF standard JMAP functionality is supported. */
+
+{ "jmap_set_has_attachment", 1, SWITCH, "3.1.5" }
+/* If enabled, the $hasAttachment flag is determined and set for new messages
+   created with the JMAP Email/set or Email/import methods. This option should
+   typically be enabled, but installations using Cyrus-external message
+   annatotors to determine the $hasAttachment flag might want to disable it. */
+
+{ "jmap_vacation", 1, SWITCH, "3.1.8" }
+/* If enabled, support the JMAP vacation extension */
+
+{ "jmapuploadfolder", "#jmap", STRING, "3.1.1" }
+/* the name of the folder for JMAP uploads (#jmap) */
+
+{ "jmapsubmission_deleteonsend", 1, SWITCH, "3.1.8" }
+/* If enabled (the default) then delete the EmailSubmission as soon as the email
+ * has been sent */
+
+{ "jmapsubmissionfolder", "#jmapsubmission", STRING, "3.1.8" }
+/* the name of the folder for JMAP Submissions (#jmapsubmission) */
+
+{ "jmappushsubscriptionfolder", "#jmappushsubscription", STRING, "3.1.8" }
+/* the name of the folder for JMAP Push Subscriptions (#jmappushsubscription) */
+
+{ "iolog", 0, SWITCH, "2.5.0" }
 /* Should cyrus output I/O log entries */
 
-{ "ldap_authz", NULL, STRING }
+{ "ldap_authz", NULL, STRING, "2.3.17" }
 /* SASL authorization ID for the LDAP server */
 
-{ "ldap_base", "", STRING }
+{ "ldap_base", "", STRING, "2.3.17" }
 /* Contains the LDAP base dn for the LDAP ptloader module */
 
-{ "ldap_bind_dn", NULL, STRING }
+{ "ldap_bind_dn", NULL, STRING, "2.3.17" }
 /* Bind DN for the connection to the LDAP server (simple bind).
    Do not use for anonymous simple binds */
 
-{ "ldap_deref", "never", STRINGLIST("search", "find", "always", "never") }
+{ "ldap_deref", "never", STRINGLIST("search", "find", "always", "never"), "2.3.17" }
 /* Specify how aliases dereferencing is handled during search. */
 
-{ "ldap_domain_base_dn", "", STRING }
+{ "ldap_domain_base_dn", "", STRING, "2.5.0" }
 /* Base DN to search for domain name spaces. */
 
-{ "ldap_domain_filter", "(&(objectclass=domainrelatedobject)(associateddomain=%s))", STRING }
+{ "ldap_domain_filter", "(&(objectclass=domainrelatedobject)(associateddomain=%s))", STRING, "2.5.0" }
 /* Filter to use searching for domains */
 
-{ "ldap_domain_name_attribute", "associateddomain", STRING }
+{ "ldap_domain_name_attribute", "associateddomain", STRING, "2.5.0" }
 /* The attribute name for domains. */
 
-{ "ldap_domain_scope", "sub", STRINGLIST("sub", "one", "base") }
+{ "ldap_domain_scope", "sub", STRINGLIST("sub", "one", "base"), "2.5.0" }
 /* Search scope */
 
-{ "ldap_domain_result_attribute", "inetdomainbasedn", STRING }
+{ "ldap_domain_result_attribute", "inetdomainbasedn", STRING, "2.5.0" }
 /* Result attribute */
 
-{ "ldap_filter", "(uid=%u)", STRING }
+{ "ldap_filter", "(uid=%u)", STRING, "2.3.17" }
 /* Specify a filter that searches user identifiers.  The following tokens can be
    used in the filter string:
 
@@ -1011,268 +1246,302 @@ Blank lines and lines beginning with ``#
    %u   = user
    %U   = user portion of %u (%U = test when %u = test@domain.tld)
    %d   = domain portion of %u if available (%d = domain.tld when %u =
-          %test@domain.tld), otherwise same as %r
+          test@domain.tld), otherwise same as %R
+   %R   = domain portion of %u starting with @ (%R = @domain.tld
+          when %u = test@domain.tld)
    %D   = user dn.  (use when ldap_member_method: filter)
    %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
 
    ldap_filter is not used when ldap_sasl is enabled. */
 
-{ "ldap_group_base", "", STRING }
+{ "ldap_group_base", "", STRING, "2.3.17" }
 /* LDAP base dn for ldap_group_filter. */
 
-{ "ldap_group_filter", "(cn=%u)", STRING }
+{ "ldap_group_filter", "(cn=%u)", STRING, "2.3.17" }
 /* Specify a filter that searches for group identifiers.
    See ldap_filter for more options. */
 
-{ "ldap_group_scope", "sub", STRINGLIST("sub", "one", "base") }
+{ "ldap_group_scope", "sub", STRINGLIST("sub", "one", "base"), "2.3.17" }
 /* Specify search scope for ldap_group_filter. */
 
-{ "ldap_id", NULL, STRING }
+{ "ldap_id", NULL, STRING, "2.3.17" }
 /* SASL authentication ID for the LDAP server */
 
-{ "ldap_mech", NULL, STRING }
+{ "ldap_mech", NULL, STRING, "2.3.17" }
 /* SASL mechanism for LDAP authentication */
 
-{ "ldap_user_attribute", NULL, STRING }
+{ "ldap_user_attribute", NULL, STRING, "2.5.0" }
 /* Specify LDAP attribute to use as canonical user id */
 
-{ "ldap_member_attribute", NULL, STRING }
+{ "ldap_member_attribute", NULL, STRING, "2.3.17" }
 /* See ldap_member_method. */
 
-{ "ldap_member_base", "", STRING }
+{ "ldap_member_base", "", STRING, "2.3.17" }
 /* LDAP base dn for ldap_member_filter. */
 
-{ "ldap_member_filter", "(member=%D)", STRING }
+{ "ldap_member_filter", "(member=%D)", STRING, "2.3.17" }
 /* Specify a filter for "ldap_member_method: filter".
    See ldap_filter for more options. */
 
-{ "ldap_member_method", "attribute", STRINGLIST("attribute", "filter") }
+{ "ldap_member_method", "attribute", STRINGLIST("attribute", "filter"), "2.3.17" }
 /* Specify a group method.  The "attribute" method retrieves groups from
    a multi-valued attribute specified in ldap_member_attribute.
 
    The "filter" method uses a filter, specified by ldap_member_filter, to find
    groups; ldap_member_attribute is a single-value attribute group name. */
 
-{ "ldap_member_scope", "sub", STRINGLIST("sub", "one", "base") }
+{ "ldap_member_scope", "sub", STRINGLIST("sub", "one", "base"), "2.3.17" }
 /* Specify search scope for ldap_member_filter. */
 
-{ "ldap_password", NULL, STRING }
+{ "ldap_password", NULL, STRING, "2.3.17" }
 /* Password for the connection to the LDAP server (SASL and simple bind).
    Do not use for anonymous simple binds */
 
-{ "ldap_realm", NULL, STRING }
+{ "ldap_realm", NULL, STRING, "2.3.17" }
 /* SASL realm for LDAP authentication */
 
-{ "ldap_referrals", 0, SWITCH }
+{ "ldap_referrals", 0, SWITCH, "2.3.17" }
 /* Specify whether or not the client should follow referrals. */
 
-{ "ldap_restart", 1, SWITCH }
+{ "ldap_restart", 1, SWITCH, "2.3.17" }
 /* Specify whether or not LDAP I/O operations are automatically restarted
    if they abort prematurely. */
 
-{ "ldap_sasl", 1, SWITCH }
+{ "ldap_sasl", 1, SWITCH, "2.3.17" }
 /* Use SASL for LDAP binds in the LDAP PTS module. */
 
-{ "ldap_sasl_authc", NULL, STRING, "2.5.0", "ldap_id" }
+{ "ldap_sasl_authc", NULL, STRING, "2.5.0", "2.5.0", "ldap_id" }
 /* Deprecated.  Use ldap_id */
 
-{ "ldap_sasl_authz", NULL, STRING, "2.5.0", "ldap_authz" }
+{ "ldap_sasl_authz", NULL, STRING, "2.5.0", "2.5.0", "ldap_authz" }
 /* Deprecated.  Use ldap_authz */
 
-{ "ldap_sasl_mech", NULL, STRING, "2.5.0", "ldap_mech" }
+{ "ldap_sasl_mech", NULL, STRING, "2.5.0", "2.5.0", "ldap_mech" }
 /* Deprecated.  Use ldap_mech */
 
-{ "ldap_sasl_password", NULL, STRING, "2.5.0", "ldap_password" }
+{ "ldap_sasl_password", NULL, STRING, "2.5.0", "2.5.0", "ldap_password" }
 /* Deprecated.  User ldap_password */
 
-{ "ldap_sasl_realm", NULL, STRING, "2.5.0", "ldap_realm" }
+{ "ldap_sasl_realm", NULL, STRING, "2.5.0", "2.5.0", "ldap_realm" }
 /* Deprecated.  Use ldap_realm */
 
-{ "ldap_scope", "sub", STRINGLIST("sub", "one", "base") }
+{ "ldap_scope", "sub", STRINGLIST("sub", "one", "base"), "2.3.17" }
 /* Specify search scope. */
 
-{ "ldap_servers", "ldap://localhost/", STRING, "2.5.0", "ldap_uri" }
+{ "ldap_servers", "ldap://localhost/", STRING, "2.5.0", "2.5.0", "ldap_uri" }
 /* Deprecated.  Use ldap_uri */
 
-{ "ldap_size_limit", 1, INT }
+{ "ldap_size_limit", 1, INT, "2.3.17" }
 /* Specify a number of entries for a search request to return. */
 
-{ "ldap_start_tls", 0, SWITCH }
+{ "ldap_start_tls", 0, SWITCH, "2.3.17" }
 /* Use transport layer security for ldap:// using STARTTLS. Do not use
    ldaps:// in 'ldap_uri' with this option enabled. */
 
-{ "ldap_time_limit", 5, INT }
-/* Specify a number of seconds for a search request to complete. */
+{ "ldap_time_limit", "5s", DURATION, "3.1.8" }
+/* How long to wait for a search request to complete.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "ldap_timeout", 5, INT }
-/* Specify a number of seconds a search can take before timing out. */
+{ "ldap_timeout", "5s", DURATION, "3.1.8" }
+/* How long a search can take before timing out.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "ldap_ca_dir", NULL, STRING }
+{ "ldap_ca_dir", NULL, STRING, "2.5.0" }
 /* Path to a directory with CA (Certificate Authority) certificates. */
 
-{ "ldap_ca_file", NULL, STRING }
+{ "ldap_ca_file", NULL, STRING, "2.5.0" }
 /* Patch to a file containing CA (Certificate Authority) certificate(s). */
 
-{ "ldap_ciphers", NULL, STRING }
+{ "ldap_ciphers", NULL, STRING, "2.5.0" }
 /* List of SSL/TLS ciphers to allow.  The format of the string is
    described in ciphers(1). */
 
-{ "ldap_client_cert", NULL, STRING }
+{ "ldap_client_cert", NULL, STRING, "2.5.0" }
 /* File containing the client certificate. */
 
-{ "ldap_client_key", NULL, STRING }
+{ "ldap_client_key", NULL, STRING, "2.5.0" }
 /* File containing the private client key. */
 
-{ "ldap_verify_peer", 0, SWITCH }
+{ "ldap_verify_peer", 0, SWITCH, "2.5.0" }
 /* Require and verify server certificate.  If this option is yes,
    you must specify ldap_ca_file or ldap_ca_dir. */
 
-{ "ldap_tls_cacert_dir", NULL, STRING, "2.5.0", "ldap_ca_dir" }
+{ "ldap_tls_cacert_dir", NULL, STRING, "2.5.0", "2.5.0", "ldap_ca_dir" }
 /* Deprecated in favor of \fIldap_ca_dir\fR. */
 
-{ "ldap_tls_cacert_file", NULL, STRING, "2.5.0", "ldap_ca_file" }
+{ "ldap_tls_cacert_file", NULL, STRING, "2.5.0", "2.5.0", "ldap_ca_file" }
 /* Deprecated in favor of \fIldap_ca_file\fR. */
 
-{ "ldap_tls_cert", NULL, STRING, "2.5.0", "ldap_client_cert" }
+{ "ldap_tls_cert", NULL, STRING, "2.5.0", "2.5.0", "ldap_client_cert" }
 /* Deprecated in favor of \fIldap_client_cert\fR. */
 
-{ "ldap_tls_key", NULL, STRING, "2.5.0", "ldap_client_key" }
+{ "ldap_tls_key", NULL, STRING, "2.5.0", "2.5.0", "ldap_client_key" }
 /* Deprecated in favor of \fIldap_client_key\fR. */
 
-{ "ldap_tls_check_peer", 0, SWITCH, "2.5.0", "ldap_verify_peer" }
+{ "ldap_tls_check_peer", 0, SWITCH, "2.5.0", "2.5.0", "ldap_verify_peer" }
 /* Deprecated in favor of \fIldap_verify_peer\fR. */
 
-{ "ldap_tls_ciphers", NULL, STRING, "2.5.0", "ldap_ciphers" }
+{ "ldap_tls_ciphers", NULL, STRING, "2.5.0", "2.5.0", "ldap_ciphers" }
 /* Deprecated in favor of \fIldap_ciphers\fR. */
 
-{ "ldap_uri", NULL, STRING }
+{ "ldap_uri", NULL, STRING, "2.3.17" }
 /* Contains a list of the URLs of all the LDAP servers when using the
    LDAP PTS module. */
 
-{ "ldap_version", 3, INT }
+{ "ldap_version", 3, INT, "2.3.17" }
 /* Specify the LDAP protocol version.  If ldap_start_tls and/or
    ldap_use_sasl are enabled, ldap_version will be automatically
    set to 3. */
 
-{ "literalminus", 0, SWITCH }
+{ "literalminus", 0, SWITCH, "3.0.0" }
 /* if enabled, CAPABILITIES will reply with LITERAL- rather than
    LITERAL+ (RFC 7888).  Doesn't actually size-restrict uploads though */
 
-{ "lmtp_downcase_rcpt", 1, SWITCH }
+{ "lmtp_downcase_rcpt", 1, SWITCH, "2.5.0" }
 /* If enabled, lmtpd will convert the recipient addresses to lowercase
    (up to a '+' character, if present). */
 
-{ "lmtp_fuzzy_mailbox_match", 0, SWITCH }
+{ "lmtp_exclude_specialuse", "\\Snoozed", STRING, "3.1.8" }
+/* Don't allow delivery to folders with given special-use attributes.
+.PP
+   Note that "snoozing" of emails can currently only be done via the
+   JMAP protocol, so delivery directly to the \Snoozed mailbox is
+   prohibited by default as it will not be moved back into INBOX
+   automatically. */
+
+{ "lmtp_fuzzy_mailbox_match", 0, SWITCH, "2.3.17" }
 /* If enabled, and the mailbox specified in the detail part of the
    recipient (everything after the '+') does not exist, lmtpd will try
    to find the closest match (ignoring case, ignoring whitespace,
    falling back to parent) to the specified mailbox name. */
 
-{ "lmtp_over_quota_perm_failure", 0, SWITCH }
+{ "lmtp_over_quota_perm_failure", 0, SWITCH, "2.3.17" }
 /* If enabled, lmtpd returns a permanent failure code when a user's
    mailbox is over quota.  By default, the failure is temporary,
    causing the MTA to queue the message and retry later. */
 
-{ "lmtp_strict_quota", 0, SWITCH }
+{ "lmtp_strict_quota", 0, SWITCH, "2.3.17" }
 /* If enabled, lmtpd returns a failure code when the incoming message
    will cause the user's mailbox to exceed its quota.  By default, the
    failure won't occur until the mailbox is already over quota. */
 
-{ "lmtp_strict_rfc2821", 1, SWITCH }
+{ "lmtp_strict_rfc2821", 1, SWITCH, "2.5.0" }
 /* By default, lmtpd will be strict (per RFC 2821) with regards to which
    envelope addresses are allowed.  If this option is set to false, 8bit
    characters in the local-part of envelope addresses are changed to 'X'
    instead.  This is useful to avoid generating backscatter with
    certain MTAs like Postfix or Exim which accept such messages. */
 
-{ "lmtpsocket", "{configdirectory}/socket/lmtp", STRING }
+{ "lmtpsocket", "{configdirectory}/socket/lmtp", STRING, "2.3.17" }
 /* Unix domain socket that lmtpd listens on, used by deliver(8). This should
    match the path specified in cyrus.conf(5). */
 
-{ "lmtptxn_timeout", 300, INT }
-/* Timeout (in seconds) used during a lmtp transaction to a remote backend
-   (e.g. in a murder environment).  Can be used to prevent hung lmtpds
-   on proxy hosts when a backend server becomes unresponsive during a
-   lmtp transaction.  The default is 300 - change to zero for infinite. */
+{ "lmtptxn_timeout", "5m", DURATION, "3.1.8" }
+/* Timeout used during a lmtp transaction to a remote backend (e.g. in a
+   murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+   when a backend server becomes unresponsive during a lmtp transaction.
+   The default is 5 minutes - change to zero for infinite.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+
+{ "lock_debugtime", NULL, STRING, "3.1.4" }
+/* A floating point number of seconds.  If set, time how long we wait for
+   any lock, and syslog the filename and time if it's longer than this
+   value.  The default of NULL means not to time locks. */
 
 # xxx how does this tie into virtual domains?
-{ "loginrealms", "", STRING }
+{ "loginrealms", "", STRING, "2.3.17" }
 /* The list of remote realms whose users may authenticate using cross-realm
    authentication identifiers.  Separate each realm name by a space.  (A
    cross-realm identity is considered any identity returned by SASL
    with an "@" in it.). */
 
-{ "loginuseacl", 0, SWITCH }
+{ "loginuseacl", 0, SWITCH, "2.3.17" }
 /* If enabled, any authentication identity which has \fBa\fR rights on a
    user's INBOX may log in as that user. */
 
-{ "logtimestamps", 0, SWITCH }
+{ "logtimestamps", 0, SWITCH, "2.3.17" }
 /* Include notations in the protocol telemetry logs indicating the number of
    seconds since the last command or response. */
 
-{ "mailbox_default_options", 0, INT }
+{ "mailbox_default_options", 0, INT, "2.3.17" }
 /* Default "options" field for the mailbox on create.  You'll want to know
    what you're doing before setting this, but it can apply some default
    annotations like duplicate suppression */
 
-{ "mailbox_initial_flags", NULL, STRING }
+{ "mailbox_initial_flags", NULL, STRING, "2.5.0" }
 /* space-separated list of permanent flags which will be pre-set in every
    newly created mailbox.  If you know you will require particular
    flag names then this avoids a possible race condition against a client
    that fills the entire 128 available slots.  Default is NULL, which is
    no flags.  Example: $Label1 $Label2 $Label3 NotSpam Spam */
 
-{ "mailnotifier", NULL, STRING }
+{ "mailnotifier", NULL, STRING, "2.3.17" }
 /* Notifyd(8) method to use for "MAIL" notifications.  If not set, "MAIL"
    notifications are disabled. */
 
-{ "maxheaderlines", 1000, INT }
+{ "master_bind_errors_fatal", 0, SWITCH, "3.1.10" }
+/* If enabled, failure to bind a port during startup is treated as a fatal
+   error, causing master to shut down immediately.  The default is to keep
+   running, with the affected service disabled until the next SIGHUP causes
+   it to retry.
+.PP
+   Note that this only applies during startup.  New services that fail to
+   come up in response to a reconfig+SIGHUP will just be logged and disabled
+   like the default behaviour, without causing master to exit. */
+
+{ "maxheaderlines", 1000, INT, "2.3.17" }
 /* Maximum number of lines of header that will be processed into cache
    records.  Default 1000.  If set to zero, it is unlimited.
    If a message hits the limit, an error will be logged and the rest of
    the lines in the header will be skipped.  This is to avoid malformed
    messages causing giant cache records */
 
-{ "maxlogins_per_host", 0, INT }
+{ "maxlogins_per_host", 0, INT, "2.5.0" }
 /* Maximum number of logged in sessions allowed per host,
    zero means no limit */
 
-{ "maxlogins_per_user", 0, INT }
+{ "maxlogins_per_user", 0, INT, "2.5.0" }
 /* Maximum number of logged in sessions allowed per user,
    zero means no limit */
 
-{ "maxmessagesize", 0, INT }
+{ "maxmessagesize", 0, INT, "2.3.17" }
 /* Maximum incoming LMTP message size.  If non-zero, lmtpd will reject
    messages larger than \fImaxmessagesize\fR bytes.  If set to 0, this
    will allow messages of any size (the default). */
 
-{ "maxquoted", 131072, INT }
+{ "maxquoted", 131072, INT, "2.3.17" }
 /* Maximum size of a single quoted string for the parser.  Default 128k */
 
-{ "maxword", 131072, INT }
+{ "maxword", 131072, INT, "2.3.17" }
 /* Maximum size of a single word for the parser.  Default 128k */
 
-{ "mboxkey_db", "twoskip", STRINGLIST("skiplist", "twoskip", "lmdb") }
+{ "mboxkey_db", "twoskip", STRINGLIST("skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for mailbox keys. */
 
-{ "mboxlist_db", "twoskip", STRINGLIST("flat", "skiplist", "sql", "twoskip", "lmdb")}
+{ "mboxlist_db", "twoskip", STRINGLIST("flat", "skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the mailbox list. */
 
-{ "mboxlist_db_path", NULL, STRING }
+{ "mboxlist_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the mailboxes db file.  If not specified
    will be configdirectory/mailboxes.db */
 
-{ "mboxname_lockpath", NULL, STRING }
+{ "mboxname_lockpath", NULL, STRING, "2.4.0" }
 /* Path to mailbox name lock files (default $conf/lock) */
 
-{ "metapartition_files", "", BITFIELD("header", "index", "cache", "expunge", "squat", "annotations", "lock", "dav", "archivecache") }
+{ "metapartition_files", "", BITFIELD("header", "index", "cache", "expunge", "squat", "annotations", "lock", "dav", "archivecache"), "3.0.0" }
 /* Space-separated list of metadata files to be stored on a
    \fImetapartition\fR rather than in the mailbox directory on a spool
    partition. */
 
 # Commented out - there's no such thing as "metapartition-name",
 # but we need this for the man page
-# { "metapartition-name", NULL, STRING }
+# { "metapartition-name", NULL, STRING, "2.3.17" }
 /* The pathname of the metadata partition \fIname\fR, corresponding to
    spool partition \fBpartition-name\fR.  For any mailbox residing in
    a directory on \fBpartition-name\fR, the metadata files listed in
@@ -1282,11 +1551,11 @@ Blank lines and lines beginning with ``#
    \fBmetapartition-name\fR option, so that you can selectively choose
    which spool partitions will have separate metadata partitions. */
 
-{ "mupdate_authname", NULL, STRING }
+{ "mupdate_authname", NULL, STRING, "2.3.17" }
 /* The SASL username (Authentication Name) to use when authenticating to the
    mupdate server (if needed). */
 
-{ "mupdate_config", "standard", ENUM("standard", "unified", "replicated") }
+{ "mupdate_config", "standard", ENUM("standard", "unified", "replicated"), "2.3.17" }
 /* The configuration of the mupdate servers in the Cyrus Murder.
    The "standard" config is one in which there are discreet frontend
    (proxy) and backend servers.  The "unified" config is one in which
@@ -1295,7 +1564,7 @@ Blank lines and lines beginning with ``#
    mailspool, but each have their own "replicated" copy of
    mailboxes.db. */
 
-{ "munge8bit", 1, SWITCH }
+{ "munge8bit", 1, SWITCH, "2.3.17" }
 /* If enabled, lmtpd munges messages with 8-bit characters in the
    headers.  The 8-bit characters are changed to `X'.  If
    \fBreject8bit\fR is enabled, setting \fBmunge8bit\fR has no effect.
@@ -1303,50 +1572,50 @@ Blank lines and lines beginning with ``#
    RFC 2047 and its predecessors.) */
 
 # xxx badly worded
-{ "mupdate_connections_max", 128, INT }
+{ "mupdate_connections_max", 128, INT, "2.3.17" }
 /* The max number of connections that a mupdate process will allow, this
    is related to the number of file descriptors in the mupdate process.
    Beyond this number connections will be immediately issued a BYE response. */
 
-{ "mupdate_password", NULL, STRING }
+{ "mupdate_password", NULL, STRING, "2.3.17" }
 /* The SASL password (if needed) to use when authenticating to the
    mupdate server. */
 
-{ "mupdate_port", 3905, INT }
+{ "mupdate_port", 3905, INT, "2.3.17" }
 /* The port of the mupdate server for the Cyrus Murder */
 
-{ "mupdate_realm", NULL, STRING }
+{ "mupdate_realm", NULL, STRING, "2.3.17" }
 /* The SASL realm (if needed) to use when authenticating to the mupdate
    server. */
 
-{ "mupdate_retry_delay", 20, INT }
+{ "mupdate_retry_delay", 20, INT, "2.3.17" }
 /* The base time to wait between connection retries to the mupdate server. */
 
-{ "mupdate_server", NULL, STRING }
+{ "mupdate_server", NULL, STRING, "2.3.17" }
 /* The mupdate server for the Cyrus Murder */
 
-{ "mupdate_username", "", STRING }
+{ "mupdate_username", "", STRING, "2.3.17" }
 /* The SASL username (Authorization Name) to use when authenticating to
    the mupdate server */
 
-{ "mupdate_workers_max", 50, INT }
+{ "mupdate_workers_max", 50, INT, "2.3.17" }
 /* The maximum number of mupdate worker threads (overall) */
 
-{ "mupdate_workers_maxspare", 10, INT }
+{ "mupdate_workers_maxspare", 10, INT, "2.3.17" }
 /* The maximum number of idle mupdate worker threads */
 
-{ "mupdate_workers_minspare", 2, INT }
+{ "mupdate_workers_minspare", 2, INT, "2.3.17" }
 /* The minimum number of idle mupdate worker threads */
 
-{ "mupdate_workers_start", 5, INT }
+{ "mupdate_workers_start", 5, INT, "2.3.17" }
 /* The number of mupdate worker threads to start */
 
-{ "netscapeurl", NULL, STRING }
+{ "netscapeurl", NULL, STRING, "2.3.17" }
 /* If enabled at compile time, this specifies a URL to reply when
    Netscape asks the server where the mail administration HTTP server
    is.  Administrators should set this to a local resource. */
 
-{ "newsaddheaders", "to", BITFIELD("to", "replyto") }
+{ "newsaddheaders", "to", BITFIELD("to", "replyto"), "2.5.0" }
 /* Space-separated list of headers to be added to incoming usenet
    articles.  Added \fITo:\fR headers will contain email
    delivery addresses corresponding to each newsgroup in the
@@ -1360,7 +1629,7 @@ Blank lines and lines beginning with ``#
    This option applies if and only if the \fBnewspostuser\fR option is
    set. */
 
-{ "newsgroups", "*", STRING }
+{ "newsgroups", "*", STRING, "2.4.0" }
 /* A wildmat pattern specifying which mailbox hierarchies should be
    treated as newsgroups.  Only mailboxes matching the wildmat will
    accept and/or serve articles via NNTP.  If not set, a default
@@ -1368,7 +1637,7 @@ Blank lines and lines beginning with ``#
    \fInewsprefix\fR option is also set, the default wildmat will be
    translated to "<newsprefix>.*" */
 
-{ "newsmaster", "news", STRING }
+{ "newsmaster", "news", STRING, "2.3.17" }
 /* Userid that is used for checking access controls when executing
    Usenet control messages.  For instance, to allow articles to be
    automatically deleted by cancel messages, give the "news" user
@@ -1377,7 +1646,7 @@ Blank lines and lines beginning with ``#
    control messages, give the "news" user the 'c' right on the desired
    mailbox hierarchies. */
 
-{ "newspeer", NULL, STRING }
+{ "newspeer", NULL, STRING, "2.3.17" }
 /* A list of whitespace-separated news server specifications to which
    articles should be fed.  Each server specification is a string of
    the form [user[:pass]@]host[:port][/wildmat] where 'host' is the fully
@@ -1399,7 +1668,7 @@ Blank lines and lines beginning with ``#
    peer.example.com.  In the case of cross-posting to local groups,
    these articles would not be fed. */
 
-{ "newspostuser", NULL, STRING }
+{ "newspostuser", NULL, STRING, "2.5.0" }
 /* Userid used to deliver usenet articles to newsgroup folders
    (usually via lmtp2nntp).  For example, if set to "post", email sent
    to "post+comp.mail.imap" would be delivered to the "comp.mail.imap"
@@ -1412,26 +1681,29 @@ Blank lines and lines beginning with ``#
    corresponding to each relevant newsgroup.  If not set, no headers
    are added to usenet articles. */
 
-{ "newsprefix", NULL, STRING }
+{ "newsprefix", NULL, STRING, "2.3.17" }
 /* Prefix to be prepended to newsgroup names to make the corresponding
    IMAP mailbox names. */
 
-{ "newsrc_db_path", NULL, STRING }
+{ "newsrc_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the newsrc db file.  If not specified,
    will be configdirectory/fetchnews.db */
 
-{ "nntptimeout", 3, INT }
-/* Set the length of the NNTP server's inactivity autologout timer,
-   in minutes.  The minimum value is 3, the default. */
+{ "nntptimeout", "3m", DURATION, "3.1.8" }
+/* Set the length of the NNTP server's inactivity autologout timer.
+   The minimum value is 3 minutes, also the default.
+.PP
+   For backward compatibility, if no unit is specified, minutes is
+   assumed. */
 
-{ "notesmailbox", NULL, STRING }
+{ "notesmailbox", NULL, STRING, "3.0.0" }
 /* The top level mailbox in each user's account which is used to store
  * Apple-style Notes.  Default is blank (disabled) */
 
-{ "notifysocket", "{configdirectory}/socket/notify", STRING }
+{ "notifysocket", "{configdirectory}/socket/notify", STRING, "2.3.17" }
 /* Unix domain socket that the mail notification daemon listens on. */
 
-{ "notify_external", NULL, STRING }
+{ "notify_external", NULL, STRING, "2.4.0" }
 /* Path to the external program that notifyd(8) will call to send mail
    notifications.
 .PP
@@ -1455,17 +1727,14 @@ And the notification message will be ava
 
 # Commented out - there's no such thing as "partition-name", but we need
 # this for the man page
-# { "partition-name", NULL, STRING }
+# { "partition-name", NULL, STRING, "2.3.17" }
 /* The pathname of the partition \fIname\fR.  At least one partition
    pathname MUST be specified.  If the \fBdefaultpartition\fR option is
    used, then its pathname MUST be specified.  For example, if the
    value of the \fBdefaultpartion\fR option is \fBpart1\fR, then the
    \fBpartition-part1\fR field is required. */
 
-{ "outbox_sendlater", 0, SWITCH }
-/* If enabled, any message with a \Draft flag will be sent at the time of its INTERNALDATE */
-
-{ "partition_select_mode", "freespace-most", STRINGLIST("random", "freespace-most", "freespace-percent-most", "freespace-percent-weighted", "freespace-percent-weighted-delta") }
+{ "partition_select_mode", "freespace-most", STRINGLIST("random", "freespace-most", "freespace-percent-most", "freespace-percent-weighted", "freespace-percent-weighted-delta"), "2.5.0" }
 /* Partition selection mode.
 .PP
 .IP \fIrandom\fR 5
@@ -1490,48 +1759,59 @@ Note that actually even the most used pa
 selected, and those chances increase when other partitions get closer
  */
 
-{ "partition_select_exclude", NULL, STRING }
+{ "partition_select_exclude", NULL, STRING, "2.5.0" }
 /* List of partitions to exclude from selection mode. */
 
-{ "partition_select_usage_reinit", 0, INT }
+{ "partition_select_usage_reinit", 0, INT, "2.5.0" }
 /* For a given session, number of \fBoperations\fR (e.g. partition selection)
    for which partitions usage data are cached. */
 
-{ "partition_select_soft_usage_limit", 0, INT }
+{ "partition_select_soft_usage_limit", 0, INT, "2.5.0" }
 /* Limit of partition usage (%): if a partition is over that limit, it is
    automatically excluded from selection mode.
 .PP
 If all partitions are over that limit, this feature is not used anymore.
  */
 
-{ "plaintextloginpause", 0, INT }
-/* Number of seconds to pause after a successful plaintext login.  For
-   systems that support strong authentication, this permits users to
-   perceive a cost of using plaintext passwords.  (This does not
-   affect the use of PLAIN in SASL authentications.) */
+{ "plaintextloginpause", NULL, DURATION, "3.1.8" }
+/* Time to pause after a successful plaintext login.  For systems that
+   support strong authentication, this permits users to perceive a cost
+   of using plaintext passwords.  (This does not affect the use of PLAIN
+   in SASL authentications.)
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "plaintextloginalert", NULL, STRING }
+{ "plaintextloginalert", NULL, STRING, "2.3.17" }
 /* Message to send to client after a successful plaintext login. */
 
-{ "popexpiretime", -1, INT }
-/* The number of days advertised as being the minimum a message may be
+{ "popexpiretime", "-1", DURATION, "3.1.8" }
+/* The duration advertised as being the minimum a message may be
    left on the POP server before it is deleted (via the CAPA command,
    defined in the POP3 Extension Mechanism, which some clients may
-   support).  "NEVER", the default, may be specified with a negative
-   number.  The Cyrus POP3 server never deletes mail, no matter what
-   the value of this parameter is.  However, if a site implements a
-   less liberal policy, it needs to change this parameter
-   accordingly. */
+   support).  This duration has a granularity of whole days, with partial
+   days truncated (so e.g. "45m" is effectively "0d").  "NEVER", the
+   default, may be specified with a negative number.
+.PP
+   The Cyrus POP3 server never deletes mail, no matter what the value of
+   this parameter is.  However, if a site implements a less liberal policy,
+   it needs to change this parameter accordingly.
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed. */
 
-{ "popminpoll", 0, INT }
+{ "popminpoll", NULL, DURATION, "3.1.8" }
 /* Set the minimum amount of time the server forces users to wait
-   between successive POP logins, in minutes. */
+   between successive POP logins.
+.PP
+   For backward compatibility, if no unit is specified, minutes is
+   assumed. */
 
-{ "popsubfolders", 0, SWITCH }
+{ "popsubfolders", 0, SWITCH, "2.3.17" }
 /* Allow access to subfolders of INBOX via POP3 by using
    userid+subfolder syntax as the authentication/authorization id. */
 
-{ "poppollpadding", 1, INT }
+{ "poppollpadding", 1, INT, "2.3.17" }
 /* Create a softer minimum poll restriction.  Allows \fIpoppollpadding\fR
    connections before the minpoll restriction is triggered.  Additionally,
    one padding entry is recovered every \fIpopminpoll\fR minutes.
@@ -1547,11 +1827,14 @@ If all partitions are over that limit, t
    user waits a sufficient amount of time, they will get back many or all
    of the slots. */
 
-{ "poptimeout", 10, INT }
-/* Set the length of the POP server's inactivity autologout timer,
-   in minutes.  The minimum value is 10, the default. */
+{ "poptimeout", "10m", DURATION, "3.1.8" }
+/* Set the length of the POP server's inactivity autologout timer.
+   The minimum value is 10 minutes, the default.
+.PP
+   For backward compatibility, if no unit is specified, minutes is
+   assumed. */
 
-{ "popuseacl", 0, SWITCH }
+{ "popuseacl", 0, SWITCH, "2.3.17" }
 /* Enforce IMAP ACLs in the pop server.  Due to the nature of the POP3
    protocol, the only rights which are used by the pop server are 'r',
    't', and 's' for the owner of the mailbox.  The 'r' right allows the
@@ -1560,34 +1843,54 @@ If all partitions are over that limit, t
    retrieved by the user to have the \\Seen flag set (only if
    \fIpopuseimapflags\fR is also enabled). */
 
-{ "popuseimapflags", 0, SWITCH }
+{ "popuseimapflags", 0, SWITCH, "2.3.17" }
 /* If enabled, the pop server will set and obey IMAP flags.  Messages
    having the \\Deleted flag are ignored as if they do not exist.
    Messages that are retrieved by the client will have the \\Seen flag
    set.  All messages will have the \\Recent flag unset. */
 
-{ "postmaster", "postmaster", STRING }
+{ "postmaster", "postmaster", STRING, "2.3.17" }
 /* Username that is used as the 'From' address in rejection MDNs produced
    by sieve. */
 
-{ "postspec", NULL, STRING }
+{ "postspec", NULL, STRING, "2.3.17" }
 
-{ "postuser", "", STRING }
+{ "postuser", "", STRING, "2.3.17" }
 /* Userid used to deliver messages to shared folders.  For example, if
    set to "bb", email sent to "bb+shared.blah" would be delivered to
    the "shared.blah" folder.  By default, an email address of
    "+shared.blah" would be used. */
 
-{ "proc_path", NULL, STRING }
+{ "proc_path", NULL, STRING, "2.5.0" }
 /* Path to proc directory.  Default is NULL - must be an absolute path
    if specified.  If not specified, the path $configdirectory/proc/ will be
    used. */
 
-{ "proxy_authname", "proxy", STRING }
+{ "prometheus_enabled", 0, SWITCH, "3.1.2" }
+/* Whether tracking of service metrics for Prometheus is enabled. */
+
+{ "prometheus_need_auth", "admin", STRINGLIST("none", "user", "admin"), "3.1.2" }
+/* Authentication level required to fetch Prometheus metrics. */
+
+{ "prometheus_update_freq", "10s", DURATION, "3.1.8" }
+/* Frequency in at which promstatsd should re-collate its statistics
+   report.  The minimum value is 1 second, the default is 10 seconds.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+   */
+
+{ "prometheus_stats_dir", NULL, STRING, "3.1.2" }
+/* Directory to use for gathering prometheus statistics.  If specified,
+   must be an absolute path.  If not specified, the default path
+   $configdirectory/stats/ will be used.  It may be advantageous to locate this
+   directory on ephemeral storage. */
+
+{ "proxy_authname", "proxy", STRING, "2.3.17" }
 /* The authentication name to use when authenticating to a backend server
    in the Cyrus Murder. */
 
-{ "proxy_compress", 0, SWITCH }
+{ "proxy_compress", 0, SWITCH, "2.3.17" }
 /* Try to enable protocol-specific compression when performing a client
    connection to a backend server in the Cyrus Murder.
 .PP
@@ -1595,108 +1898,111 @@ If all partitions are over that limit, t
   connections.  Also note that currently only IMAP and MUPDATE support
   compression. */
 
-{ "proxy_password", NULL, STRING }
+{ "proxy_password", NULL, STRING, "2.3.17" }
 /* The default password to use when authenticating to a backend server
    in the Cyrus Murder.  May be overridden on a host-specific basis using
    the hostname_password option. */
 
-{ "proxy_realm", NULL, STRING }
+{ "proxy_realm", NULL, STRING, "2.3.17" }
 /* The authentication realm to use when authenticating to a backend server
    in the Cyrus Murder */
 
-{ "proxyd_allow_status_referral", 0, SWITCH }
+{ "proxyd_allow_status_referral", 0, SWITCH, "2.3.17" }
 /* Set to true to allow proxyd to issue referrals to clients that support it
    when answering the STATUS command.  This is disabled by default since
    some clients issue many STATUS commands in a row, and do not cache the
    connections that these referrals would cause, thus resulting in a higher
    authentication load on the respective backend server. */
 
-{ "proxyd_disable_mailbox_referrals", 0, SWITCH }
+{ "proxyd_disable_mailbox_referrals", 0, SWITCH, "2.3.17" }
 /* Set to true to disable the use of mailbox-referrals on the
    proxy servers. */
 
-{ "proxyservers", NULL, STRING }
+{ "proxyservers", NULL, STRING, "2.3.17" }
 /* A list of users and groups that are allowed to proxy for other
    users, separated by spaces.  Any user listed in this will be
    allowed to login for any other user: use with caution.
    In a standard murder this option should ONLY be set on backends.
    DO NOT SET on frontends or things won't work properly. */
 
-{ "pts_module", "afskrb", STRINGLIST("afskrb", "ldap") }
+{ "pts_module", "afskrb", STRINGLIST("afskrb", "ldap"), "2.3.17" }
 /* The PTS module to use. */
 
-{ "ptloader_sock", NULL, STRING }
+{ "ptloader_sock", NULL, STRING, "2.3.17" }
 /* Unix domain socket that ptloader listens on.
    (defaults to configdirectory/ptclient/ptsock) */
 
-{ "ptscache_db", "twoskip", STRINGLIST("skiplist", "twoskip", "lmdb")}
+{ "ptscache_db", "twoskip", STRINGLIST("skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the pts cache. */
 
-{ "ptscache_db_path", NULL, STRING }
+{ "ptscache_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the ptscache db file.  If not specified,
    will be configdirectory/ptscache.db */
 
-{ "ptscache_timeout", 10800, INT }
-/* The timeout (in seconds) for the PTS cache database when using the
-   auth_krb_pts authorization method (default: 3 hours). */
+{ "ptscache_timeout", "3h", DURATION, "3.1.8" }
+/* The timeout for the PTS cache database when using the auth_krb_pts
+   authorization method (default: 3 hours).
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "ptskrb5_convert524", 1, SWITCH }
+{ "ptskrb5_convert524", 1, SWITCH, "2.3.16" }
 /* When using the AFSKRB ptloader module with Kerberos 5 canonicalization,
    do the final 524 conversion to get a n AFS style name (using '.' instead
    of '/', and using short names */
 
-{ "ptskrb5_strip_default_realm", 1, SWITCH }
+{ "ptskrb5_strip_default_realm", 1, SWITCH, "2.3.17" }
 /* When using the AFSKRB ptloader module with Kerberos 5 canonicalization,
    strip the default realm from the userid (this does not affect the stripping
    of realms specified by the afspts_localrealms option) */
 
-{ "qosmarking", "cs0", ENUM("cs0", "cs1", "cs2", "cs3", "cs4", "cs5", "cs6", "cs7", "af11", "af12", "af13", "af21", "af22", "af23", "af31", "af32", "af33", "af41", "af42", "af43", "ef") }
+{ "qosmarking", "cs0", ENUM("cs0", "cs1", "cs2", "cs3", "cs4", "cs5", "cs6", "cs7", "af11", "af12", "af13", "af21", "af22", "af23", "af31", "af32", "af33", "af41", "af42", "af43", "ef"), "2.5.0" }
 /* This specifies the Class Selector or Differentiated Services Code Point
    designation on IP headers (in the ToS field). */
 
-{ "quota_db", "quotalegacy", STRINGLIST("flat", "skiplist", "sql", "quotalegacy", "twoskip", "lmdb")}
+{ "quota_db", "quotalegacy", STRINGLIST("flat", "skiplist", "sql", "quotalegacy", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for quotas. */
 
-{ "quota_db_path", NULL, STRING }
+{ "quota_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path for the quota database (if you choose a single-file
    quota DB type - or the base path if you choose quotalegacy).  If
    not specified will be configdirectory/quotas.db or configdirectory/quota/ */
 
-{ "quotawarn", 90, INT }
+{ "quotawarn", 90, INT, "2.3.17" }
 /* The percent of quota utilization over which the server generates
    warnings. */
 
-{ "quotawarnkb", 0, INT }
+{ "quotawarnkb", 0, INT, "2.3.17" }
 /* The maximum amount of free space (in kB) at which to give a quota
    warning (if this value is 0, or if the quota is smaller than this
    amount, then warnings are always given). */
 
-{ "quotawarnmsg", 0, INT }
+{ "quotawarnmsg", 0, INT, "2.5.0" }
 /* The maximum amount of messages at which to give a quota warning
    (if this value is 0, or if the quota is smaller than this
    amount, then warnings are always given). */
 
-{ "reject8bit", 0, SWITCH }
+{ "reject8bit", 0, SWITCH, "2.3.17" }
 /* If enabled, lmtpd rejects messages with 8-bit characters in the
    headers. */
 
-{ "restore_authname", NULL, STRING }
+{ "restore_authname", NULL, STRING, "3.0.0" }
 /* The authentication used by the restore tool when authenticating
    to an IMAP/sync server. */
 
-{ "restore_password", NULL, STRING }
+{ "restore_password", NULL, STRING, "3.0.0" }
 /* The password used by the restore tool when authenticating to an
    IMAP/sync server. */
 
-{ "restore_realm", NULL, STRING }
+{ "restore_realm", NULL, STRING, "3.0.0" }
 /* The authentication realm used by the restore tool when
    authenticating to an IMAP/sync server. */
 
-{ "reverseacls", 0, SWITCH }
+{ "reverseacls", 0, SWITCH, "3.0.0" }
 /* At startup time, ctl_cyrusdb -r will check this value and it
    will either add or remove reverse ACL pointers from mailboxes.db */
 
-{ "rfc2046_strict", 0, SWITCH }
+{ "rfc2046_strict", 0, SWITCH, "2.3.17" }
 /* If enabled, imapd will be strict (per RFC 2046) when matching MIME
    boundary strings.  This means that boundaries containing other
    boundaries as substrings will be treated as identical.  Since
@@ -1704,7 +2010,7 @@ If all partitions are over that limit, t
    (and earlier), it is recommended that it be left disabled unless
    there is good reason to do otherwise. */
 
-{ "rfc2047_utf8", 0, SWITCH }
+{ "rfc2047_utf8", 0, SWITCH, "3.0.0" }
 /* If enabled, imapd will parse any non-encoded character sequence in
    MIME header values as UTF8. This is useful for installations that
    either advertise the UTF8SMTP (RFC 5335) extension or receive mails
@@ -1712,7 +2018,7 @@ If all partitions are over that limit, t
    this option is left disabled unless there is good reason to do
    otherwise. */
 
-{ "rfc3028_strict", 1, SWITCH }
+{ "rfc3028_strict", 1, SWITCH, "2.3.17" }
 /* If enabled, Sieve will be strict (per RFC 3028) with regards to
    which headers are allowed to be used in address and envelope tests.
    This means that only those headers which are defined to contain addresses
@@ -1720,7 +2026,7 @@ If all partitions are over that limit, t
    allowed in envelope tests.  When disabled, ANY grammatically correct header
    will be allowed. */
 
-{ "rss_feedlist_template", NULL, STRING }
+{ "rss_feedlist_template", NULL, STRING, "2.5.0" }
 /* File containing HTML that will be used as a template for displaying
    the list of available RSS feeds.  A single instance of the variable
    %RSS_FEEDLIST% should appear in the file, which will be replaced by
@@ -1730,79 +2036,133 @@ If all partitions are over that limit, t
    feeds based on the HTML template will be accessible at the "/rss"
    URL on the server. */
 
-{ "rss_feeds", "*", STRING }
+{ "rss_feeds", "*", STRING, "2.5.0" }
 /* A wildmat pattern specifying which mailbox hierarchies should be
    treated as RSS feeds.  Only mailboxes matching the wildmat will
    have their messages available via RSS.  If not set, a default
    wildmat of "*" (ALL mailboxes) will be used. */
 
-{ "rss_maxage", 0, INT }
-/* Maximum age (in days) of items to display in an RSS channel.  If
-   non-zero, httpd will only display items received within the last
-   \fIrss_maxage\fR days.  If set to 0, all available items will be
-   displayed (the default). */
+{ "rss_maxage", NULL, DURATION, "3.1.8" }
+/* Maximum age of items to display in an RSS channel.  If non-zero,
+   httpd will only display items received within this time period.
+   If set to 0, all available items will be displayed (the default).
+.PP
+   For backward compatibility, if no unit is specified, days is
+   assumed. */
 
-{ "rss_maxitems", 0, INT }
+{ "rss_maxitems", 0, INT, "2.5.0" }
 /* Maximum number of items to display in an RSS channel.  If non-zero,
    httpd will display no more than the \fIrss_maxitems\fR most recent
    items.  If set to 0, all available items will be displayed (the
    default). */
 
-{ "rss_maxsynopsis", 0, INT }
+{ "rss_maxsynopsis", 0, INT, "2.5.0" }
 /* Maximum RSS item synopsis length.  If non-zero, httpd will display
    no more than the first \fIrss_maxsynopsis\fR characters of an
    item's synopsis.  If set to 0, the entire synopsis will be
    displayed (the default). */
 
-{ "rss_realm", NULL, STRING }
+{ "rss_realm", NULL, STRING, "2.5.0" }
 /* The realm to present for HTTP authentication of RSS feeds.  If not
    set (the default), the value of the "servername" option will be
    used.*/
 
 # Commented out - used by libsasl
-# { "sasl_auto_transition", 0, SWITCH }
+# { "sasl_auto_transition", 0, SWITCH, "2.3.17" }
 /* If enabled, the SASL library will automatically create authentication
    secrets when given a plaintext password.  See the SASL documentation. */
 
-{ "sasl_maximum_layer", 256, INT }
+{ "sasl_maximum_layer", 256, INT, "2.3.17" }
 /* Maximum SSF (security strength factor) that the server will allow a
    client to negotiate. */
 
-{ "sasl_minimum_layer", 0, INT }
+{ "sasl_minimum_layer", 0, INT, "2.3.17" }
 /* The minimum SSF that the server will allow a client to negotiate.
    A value of 1 requires integrity protection; any higher value
    requires some amount of encryption. */
 
 # Commented out - used by libsasl
-# { "sasl_option", 0, STRING }
+# { "sasl_option", 0, STRING, "2.3.17" }
 /* Any SASL option can be set by preceding it with \fBsasl_\fR.  This
    file overrides the SASL configuration file. */
 
 # Commented out - used by libsasl
-# { "sasl_pwcheck_method", NULL, STRING }
+# { "sasl_pwcheck_method", NULL, STRING, "2.3.17" }
 /* The mechanism used by the server to verify plaintext passwords.
    Possible values include "auxprop", "saslauthd", and "pwcheck". */
 
-{ "search_batchsize", 20, INT }
+{ "search_batchsize", 20, INT, "3.0.0" }
 /* The number of messages to be indexed in one batch (default 20).
    Note that long batches may delay user commands or mail delivery. */
 
-{ "search_normalisation_max", 1000, INT }
+{ "search_attachment_extractor_url", NULL, STRING, "3.1.7" }
+/* A HTTP or HTTPS URL to extract search text from rich text attachments
+   and other media during search indexing. The server at this URL must
+   implement the following protocol:
+
+   1. For each attachment of an email, Cyrus sends a GET request to the
+   URL <extractor-url>/<cyrus-id>, where <extractor-url> is the
+   configured URL and <cyrus-id> is a Cyrus-chosen path segment that
+   uniquely identifies this attachment.
+
+   2. If the extractor already has a cached plain text extract of the
+   attachment identified by <cyrus-id> then it may return HTTP status
+   code 200 (OK) and the plain text extract with a Content-Type
+   "text/plain" header. Otherwise it must return HTTP status 404 (Not Found).
+
+   3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+   a PUT request to the same URL as previously. The PUT request body
+   contains the decoded, binary body of the attachment. The Content-Type
+   request header has the same value as declared in the MIME part
+   headers, including any type parameters.
+
+   4. The extractor must return the plain text extract with either HTTP status
+   200 (OK) or 201 (Created) and a Content-Type "text/plain" header.
+   If no text can be extracted, then the extractor may return any return code
+   in the range 4xx, or 200 and an empty response body.
+
+   Any other HTTP status code is treated as an error. For performance
+   reasons, the Cyrus indexer attempts to keep-alive the TCP connection
+   to the extractor. */
+
+{ "search_index_language", 0, SWITCH, "3.1.7" }
+/*
+  If enabled, then message bodies and subjects are indexed by their
+  detected language, if the cld2 dependency is built into Cyrus.
+  Regardless of this flag, bodies and subjects are always indexed and
+  searched using the default stemmer.
+ */
+
+{ "search_index_parts", 0, SWITCH, "3.1.7" }
+/*
+  If enabled, then message parts are each indexed separately into Xapian
+  so that matches can be done by part.
+ */
+
+{ "search_query_language", 0, SWITCH, "3.1.7" }
+/*
+  If enabled, then message bodies and subjects searched by their language
+  that got detected during indexing, if any.
+  Regardless of this flag, bodies and subjects are always searched using
+  the default stemmer.
+ */
+
+{ "search_normalisation_max", 1000, INT, "3.0.0" }
 /* A resource bound for the combinatorial explosion of search expression
    tree complexity caused by normalising expressions with many OR nodes.
    These can use more CPU time to optimise than they save IO time in scanning
    folders. */
 
-{ "search_engine", "none", ENUM("none", "squat", "sphinx", "xapian") }
+{ "search_engine", "none", ENUM("none", "squat", "xapian"), "3.1.2" }
 /* The indexing engine used to speed up searching.  */
 
-{ "search_fuzzy_always", 0, SWITCH }
+{ "search_fuzzy_always", 0, SWITCH, "3.1.5" }
 /* Whether to enable RFC 6203 FUZZY search for all IMAP SEARCH. If turned
    on, search attributes will be searched using FUZZY search by default.
    If turned off, clients have to explicitly use the FUZZY search key to
    enable fuzzy search for regular SEARCH commands. */
 
-{ "search_index_headers", 1, SWITCH }
+{ "search_index_headers", 1, SWITCH, "3.0.0" }
 /* Whether to index headers other than From, To, Cc, Bcc, and Subject.
    Experiment shows that some headers such as Received and DKIM-Signature
    can contribute up to 2/3rds of the index size but almost nothing to
@@ -1810,24 +2170,29 @@ If all partitions are over that limit, t
    headers can still be searched, the searches will just be slower.
  */
 
-{ "search_indexed_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "lmdb")}
-/* The cyrusdb backend to use for the search latest indexed uid state. */
+{ "search_indexed_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "zeroskip"), "3.1.6" }
+/* The cyrusdb backend to use for the search latest indexed uid state.  Xapian only. */
 
-{ "search_maxtime", NULL, STRING }
+{ "search_maxtime", NULL, STRING, "3.0.0" }
 /* The maximum number of seconds to run a search for before aborting.  Default
    of no value means search "forever" until other timeouts. */
 
-{ "search_skipdiacrit", 1, SWITCH }
+{ "search_queryscan", 5000, INT, "3.1.7" }
+/* The minimum number of records require to do a direct scan of all G keys
+ * rather than indexed lookups.  A value of 0 means always do indexed lookups.
+ */
+
+{ "search_skipdiacrit", 1, SWITCH, "2.5.0" }
 /* When searching, should diacriticals be stripped from the search
    terms.  The default is "true", a search for "hav" will match
    "Håvard".  This is not RFC5051 compliant, but it backwards
    compatible, and may be preferred by some sites. */
 
-{ "search_skiphtml", 0, SWITCH }
+{ "search_skiphtml", 0, SWITCH, "3.0.0" }
 /* If enabled, HTML parts of messages are skipped, i.e. not indexed and
    not searchable.  Otherwise, they're indexed.  */
 
-{ "search_whitespace", "merge", ENUM("skip", "merge", "keep") }
+{ "search_whitespace", "merge", ENUM("skip", "merge", "keep"), "2.5.0" }
 /* When searching, how whitespace should be handled.  Options are:
    "skip" (default in 2.3 and earlier series) - where a search for
    "equi" would match "the quick brown fox".  "merge" - the default,
@@ -1836,20 +2201,20 @@ If all partitions are over that limit, t
    recommended for most cases - it's a good compromise which
    keeps words separate. */
 
-{ "search_snippet_length", 255, INT }
+{ "search_snippet_length", 255, INT, "3.0.0" }
 /* The maximum byte length of a snippet generated by the XSNIPPETS
    command. Only supported by the Xapian search backend, which
    attempts to always fill search_snippet_length bytes in the
    generated snippet. */
 
-{ "search_stopword_path", NULL, STRING }
+{ "search_stopword_path", NULL, STRING, "3.1.7" }
 /* The absolute base path to the search stopword lists. If not specified,
    no stopwords will be taken into account during search indexing. Currently,
-   the only supported and default stop word file is english.list. */
+   the only supported and default stop word file is english.txt. */
 
 # Commented out - there's no such thing as "searchpartition-name",
 # but we need this for the man page
-# { "searchpartition-name", NULL, STRING }
+# { "searchpartition-name", NULL, STRING, "3.1.4" }
 /* The pathname where to store the xapian search indexes of \fIsearchtier\fR
    for mailboxes of partition \fIname\fR. This must be configured for the
    \fIdefaultsearchtier\fR and any additional search tier (see squatter for
@@ -1862,19 +2227,25 @@ If all partitions are over that limit, t
 .PP
    This option MUST be specified for xapian search. */
 
-{ "seenstate_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "lmdb")}
+{ "seenstate_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the seen state. */
 
-{ "sendmail", "/usr/lib/sendmail", STRING }
+{ "sendmail", "/usr/lib/sendmail", STRING, "2.3.17" }
 /* The pathname of the sendmail executable.  Sieve invokes sendmail
    for sending rejections, redirects and vacation responses. */
 
-{ "serverlist", NULL, STRING }
+{ "sendmail_auth_id", "CYRUS_SENDMAIL_AUTH_ID", STRING, "3.1.3" }
+/* The name of an environment variable to set when invoking sendmail.
+   The value of this environment variable will contain the user id
+   of the currently authenticated user. If no user is authenticated
+   the environment variable is not set. */
+
+{ "serverlist", NULL, STRING, "2.3.17" }
 /* Whitespace separated list of backend server names.  Used for
    finding server with the most available free space for proxying
    CREATE. */
 
-{ "serverlist_select_mode", "freespace-most", STRINGLIST("random", "freespace-most", "freespace-percent-most", "freespace-percent-weighted", "freespace-percent-weighted-delta") }
+{ "serverlist_select_mode", "freespace-most", STRINGLIST("random", "freespace-most", "freespace-percent-most", "freespace-percent-weighted", "freespace-percent-weighted-delta"), "2.5.0" }
 /* Server selection mode.
 .PP
 .IP \fIrandom\fR 5
@@ -1896,18 +2267,18 @@ partition of each backend.
 .PP
  */
 
-{ "serverlist_select_usage_reinit", 0, INT }
+{ "serverlist_select_usage_reinit", 0, INT, "2.5.0" }
 /* For a given session, number of \fBoperations\fR (e.g. backend selection)
    for which backend usage data are cached. */
 
-{ "serverlist_select_soft_usage_limit", 0, INT }
+{ "serverlist_select_soft_usage_limit", 0, INT, "2.5.0" }
 /* Limit of backend usage (%): if a backend is over that limit, it is
    automatically excluded from selection mode.
 .PP
 If all backends are over that limit, this feature is not used anymore.
  */
 
-{ "servername", NULL, STRING }
+{ "servername", NULL, STRING, "2.3.17" }
 /* This is the hostname visible in the greeting messages of the POP,
    IMAP and LMTP daemons. If it is unset, then the result returned
    from gethostname(2) is used.  This is also the value used by murder
@@ -1917,7 +2288,7 @@ If all backends are over that limit, thi
    the same on each copy and the DNS name should also be moved to
    the new master on failover. */
 
-{ "serverinfo", "on", ENUM("off", "min", "on") }
+{ "serverinfo", "on", ENUM("off", "min", "on"), "2.3.17" }
 /* The server information to display in the greeting and capability
    responses. Information is displayed as follows:
 
@@ -1931,17 +2302,24 @@ product version in the capabilities
 .PP
 */
 
-{ "sharedprefix", "Shared Folders", STRING }
+{ "sharedprefix", "Shared Folders", STRING, "2.3.17" }
 /* If using the alternate IMAP namespace, the prefix for the shared
    namespace.  The hierarchy delimiter will be automatically appended.
 */
 
-{ "sieve_allowreferrals", 1, SWITCH }
+{ "sieve_allowreferrals", 1, SWITCH, "2.3.17" }
 /* If enabled, timsieved will issue referrals to clients when the
    user's scripts reside on a remote server (in a Murder).
    Otherwise, timsieved will proxy traffic to the remote server. */
 
-{ "sieve_extensions", "fileinto reject vacation vacation-seconds imapflags notify envelope relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables", BITFIELD("fileinto", "reject", "vacation", "vacation-seconds", "imapflags", "notify", "include", "envelope", "body", "relational", "regex", "subaddress", "copy", "date", "index", "imap4flags", "mailbox", "mboxmetadata", "servermetadata", "variables") }
+{ "sieve_duplicate_max_expiration", "90d", DURATION, "3.1.8" }
+/* Maximum expiration time for duplicate message tracking records.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+*/
+
+{ "sieve_extensions", "fileinto reject vacation vacation-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special-use redirect-dsn redirect-deliverby mailboxid x-cyrus-log x-cyrus-jmapquery x-cyrus-snooze", BITFIELD("fileinto", "reject", "vacation", "vacation-seconds", "imapflags", "notify", "include", "envelope", "environment", "body", "relational", "regex", "subaddress", "copy", "date", "index", "imap4flags", "mailbox", "mboxmetadata", "servermetadata", "variables", "editheader", "extlists", "duplicate", "ihave", "fcc", "special-use", "redirect-dsn", "redirect-deliverby", "mailboxid", "x-cyrus-log", "x-cyrus-jmapquery", "x-cyrus-snooze"), "3.1.8" }
 /* Space-separated list of Sieve extensions allowed to be used in
    sieve scripts, enforced at submission by timsieved(8).  Any
    previously installed script will be unaffected by this option and
@@ -1949,170 +2327,240 @@ product version in the capabilities
    option has no effect on options that are disabled at compile time
    (e.g., "regex"). */
 
-{ "sieve_maxscriptsize", 32, INT }
+{ "sieve_maxscriptsize", 32, INT, "2.3.17" }
 /* Maximum size (in kilobytes) any sieve script can be, enforced at
    submission by timsieved(8). */
 
-{ "sieve_maxscripts", 5, INT }
+{ "sieve_maxscripts", 5, INT, "2.3.17" }
 /* Maximum number of sieve scripts any user may have, enforced at
    submission by timsieved(8). */
 
-{ "sieve_utf8fileinto", 0, SWITCH }
+{ "sieve_utf8fileinto", 0, SWITCH, "2.3.17" }
 /* If enabled, the sieve engine expects folder names for the
    \fIfileinto\fR action in scripts to use UTF8 encoding.  Otherwise,
    modified UTF7 encoding should be used. */
 
-{ "sieve_sasl_send_unsolicited_capability", 0, SWITCH }
+{ "sieve_sasl_send_unsolicited_capability", 0, SWITCH, "2.3.17" }
 /* If enabled, timsieved will emit a capability response after a successful
    SASL authentication, per draft-martin-managesieve-12.txt . */
 
-{ "sieve_vacation_min_response", 259200 /* 3 days */, INT }
-/* Minimum time interval (in seconds) between consecutive vacation responses,
-   per draft-ietf-vacation-seconds.txt . */
-
-{ "sieve_vacation_max_response", 7776000 /* 90 days */, INT }
-/* Maximum time interval (in seconds) between consecutive vacation responses,
-   per draft-ietf-vacation-seconds.txt . */
+{ "sieve_use_lmtp_reject", 1, SWITCH, "3.1.1" }
+/* Enabled by default.  If reject can be done via LMTP, then return a 550
+   rather than generating the bounce message in Cyrus. */
+
+{ "sieve_vacation_min_response", "3d", DURATION, "3.1.8" }
+/* Minimum time interval between consecutive vacation responses, per
+   draft-ietf-vacation-seconds.txt.  The default is 3 days.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
+
+{ "sieve_vacation_max_response", "90d", DURATION, "3.1.8" }
+/* Maximum time interval between consecutive vacation responses, per
+   draft-ietf-vacation-seconds.txt.  The default is 90 days.  The
+   minimum is 7 days.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "sievedir", "/usr/sieve", STRING }
+{ "sievedir", "/usr/sieve", STRING, "2.3.17" }
 /* If sieveusehomedir is false, this directory is searched for Sieve
    scripts. */
 
-{ "sievenotifier", NULL, STRING }
+{ "sievenotifier", NULL, STRING, "2.3.17" }
 /* Notifyd(8) method to use for "SIEVE" notifications.  If not set, "SIEVE"
    notifications are disabled.
 .PP
    This method is only used when no method is specified in the script. */
 
-{ "sieveusehomedir", 0, SWITCH }
+{ "sieveusehomedir", 0, SWITCH, "2.3.17" }
 /* If enabled, lmtpd will look for Sieve scripts in user's home
    directories: ~user/.sieve. */
 
-{ "anysievefolder", 0, SWITCH }
+{ "anysievefolder", 0, SWITCH, "2.5.0" }
 /* It must be "yes" in order to permit the autocreation of any INBOX subfolder
    requested by a sieve filter, through the "fileinto" action. (default = no) */
 
-{ "singleinstancestore", 1, SWITCH }
+{ "singleinstancestore", 1, SWITCH, "2.3.17" }
 /* If enabled, imapd, lmtpd and nntpd attempt to only write one copy
    of a message per partition and create hard links, resulting in a
    potentially large disk savings. */
 
-{ "skiplist_always_checkpoint", 1, SWITCH }
+{ "skiplist_always_checkpoint", 1, SWITCH, "2.3.17" }
 /* If enabled, this option forces the skiplist cyrusdb backend to
    always checkpoint when doing a recovery.  This causes slightly
    more IO, but on the other hand leads to more efficient databases,
    and the entire file is already "hot". */
 
-{ "skiplist_unsafe", 0, SWITCH }
+{ "skiplist_unsafe", 0, SWITCH, "2.3.17" }
 /* If enabled, this option forces the skiplist cyrusdb backend to
    not sync writes to the disk.  Enabling this option is NOT RECOMMENDED. */
 
-{ "soft_noauth", 1, SWITCH }
+
+{ "smtp_backend", "sendmail", STRINGLIST("host", "sendmail"), "3.1.4" }
+/* The SMTP backend to use for sending email.
+
+   The \"host\" backend sends message submissions via
+   a TCP socket to the SMTP host defined in the config
+   option smtp_host.
+
+   The \"sendmail\" backend forks the Cyrus process into
+   the executable defined in the config option sendmail.
+   The executable must accept \"-bs\" as command line
+   argument, read from stdin and must implement the minimum
+   SMTP protocol as defined in section 4.5.1 of RFC 5321.
+
+   If the SMTP EHLO command reports AUTH (RFC 4954) as a
+   supported extension, then the MAIL FROM command includes
+   the AUTH parameter, with its value set to the name of any
+   authenticated user which triggered the email. The AUTH
+   parameter is omitted if the user is unknown to the calling
+   process.
+
+   If the directory
+   \fIconfigdirectory\fR/log/smtpclient.\ \fIsmtp_backend\fR
+   exists, then telemetry logs for outgoing SMTP sessions will
+   be created in this directory.
+   */
+
+{ "smtp_host", "localhost:587", STRING, "3.1.4" }
+/* The SMTP host to use for sending mail (also see the
+   smtp_backend option). The value of this option must
+   the name or IP address of a TCP host, followed optionally
+   by a colon and the port or service to use. The default
+   port is 587. TLS may be activated by appending \"/tls\"
+   to the value. Authentication is enabled if smtp_auth_authname
+   is set. Authentication can be explicitly disabled by appending
+   \"/noauth\" to the host address. */
+
+{ "smtp_auth_authname", NULL, STRING, "3.1.4" }
+/* The authentication name to use when authenticating to the SMTP
+   server defined in smtp_host. */
+
+{ "smtp_auth_password", NULL, STRING, "3.1.4" }
+/* The password to use when authenticating to the SMTP server defined
+   in smtp_host. */
+
+{ "smtp_auth_realm", NULL, STRING, "3.1.4" }
+/* The authentication SASL realm to use when authenticating to a SMTP
+   server. */
+
+{ "soft_noauth", 1, SWITCH, "2.3.17" }
 /* If enabled, lmtpd returns temporary failures if the client does not
    successfully authenticate.  Otherwise lmtpd returns permanent failures
    (causing the mail to bounce immediately). */
 
-{ "sortcache_db", "twoskip", STRINGLIST("skiplist", "twoskip", "lmdb")}
+{ "sortcache_db", "twoskip", STRINGLIST("skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for caching sort results (currently only
    used for xconvmultisort) */
 
-{ "specialuse_extra", NULL, STRING }
+{ "specialuse_extra", NULL, STRING, "2.5.0" }
 /* Whitespace separated list of extra special-use attributes
    that can be set on a mailbox. RFC 6154 currently lists
    what special-use attributes can be set. This allows
    extending that list in the future or adding your own
    if needed. */
 
-{ "specialusealways", 0, SWITCH }
+{ "specialuse_protect", "\\Archive \\Drafts \\Important \\Junk \\Sent \\Trash", STRING, "3.1.7" }
+/* Whitespace separated list of special-use attributes
+   to protect the mailboxes for.  If set, don't allow
+   mailboxes with these special use attributes to be deleted
+   or renamed to have a different parent. Default is the built-in list*/
+
+{ "specialusealways", 1, SWITCH, "3.1.1" }
 /* If enabled, this option causes LIST and LSUB output to always include
    the XLIST "special-use" flags */
 
-{ "sphinx_text_excludes_odd_headers", 0, SWITCH }
-/* If enabled, Sphinx will perform a TEXT search as if it matches
-   FROM, TO, CC, BCC or SUBJECT but not any other headers.  This
-   is contrary to the RFC but a more useful behaviour for most
-   users.  Default: disabled. */
-
-{ "sphinx_socket", "{configdirectory}/socket/sphinx", STRING }
-/* Unix domain socket that the Sphinx searchd
-   daemons listens on. */
-
-{ "sphinx_pidfile", "/var/run/sphinx.pid", STRING }
-/* File where the Sphinx searchd daemon writes its pid. */
-
-{ "sql_database", NULL, STRING }
+{ "sql_database", NULL, STRING, "2.3.17" }
 /* Name of the database which contains the cyrusdb table(s). */
 
-{ "sql_engine", NULL, STRINGLIST("mysql", "pgsql", "sqlite") }
+{ "sql_engine", NULL, STRINGLIST("mysql", "pgsql", "sqlite"), "2.3.17" }
 /* Name of the SQL engine to use. */
 
-{ "sql_hostnames", "", STRING }
+{ "sql_hostnames", "", STRING, "2.3.17" }
 /* Comma separated list of SQL servers (in host[:port] format). */
 
-{ "sql_passwd", NULL, STRING }
+{ "sql_passwd", NULL, STRING, "2.3.17" }
 /* Password to use for authentication to the SQL server. */
 
-{ "sql_user", NULL, STRING }
+{ "sql_user", NULL, STRING, "2.3.17" }
 /* Username to use for authentication to the SQL server. */
 
-{ "sql_usessl", 0, SWITCH }
+{ "sql_usessl", 0, SWITCH, "2.3.17" }
 /* If enabled, a secure connection will be made to the SQL server. */
 
-{ "srvtab", "", STRING }
+{ "srs_alwaysrewrite", 0,  SWITCH, "2.5.0" }
+/* If true, perform SRS rewriting for ALL forwarding, even when not required. */
+
+{ "srs_domain", NULL, STRING, "3.1.2" }
+/* The domain to use in rewritten addresses. This must point only to machines
+   which know the encoding secret used by this system. When present, SRS is
+   enabled. */
+
+{ "srs_hashlength", 0, INT, "3.1.2" }
+/* The hash length to generate in a rewritten address. */
+
+{ "srs_secrets", NULL, STRING, "3.1.2" }
+/* A list of secrets with which to generate addresses. */
+
+{ "srs_separator", NULL, STRING, "3.1.2" }
+/* The separator to appear immediately after SRS[01] in rewritten addresses. */
+
+{ "srvtab", "", STRING, "2.3.17" }
 /* The pathname of \fIsrvtab\fR file containing the server's private
    key.  This option is passed to the SASL library and overrides its
    default setting. */
 
-{ "submitservers", NULL, STRING }
+{ "submitservers", NULL, STRING, "2.3.17" }
 /* A list of users and groups that are allowed to resolve "urlauth=submit+"
    IMAP URLs, separated by spaces.  Any user listed in this will be
    allowed to fetch the contents of any valid "urlauth=submit+" IMAP URL:
    use with caution. */
 
-{ "subscription_db", "flat", STRINGLIST("flat", "skiplist", "twoskip", "lmdb")}
+{ "subscription_db", "flat", STRINGLIST("flat", "skiplist", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the subscriptions list. */
 
-{ "suppress_capabilities", NULL, STRING }
+{ "suppress_capabilities", NULL, STRING, "3.0.0" }
 /* Suppress the named capabilities from any capability response.  Use the
    exact case as it appears in the response, e.g.
    "suppress_capabilities: ESEARCH QRESYNC WITHIN XLIST LIST-EXTENDED"
    if you have a murder with 2.3.x backends and don't want clients being
    confused by new capabilities that some backends don't support. */
 
-{ "statuscache", 0, SWITCH }
+{ "statuscache", 0, SWITCH, "2.3.17" }
 /* Enable/disable the imap status cache. */
 
-{ "statuscache_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "lmdb") }
+{ "statuscache_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the imap status cache. */
 
-{ "statuscache_db_path", NULL, STRING }
+{ "statuscache_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the statuscache db file.  If not specified,
    will be configdirectory/statuscache.db */
 
-{ "sync_authname", NULL, STRING }
+{ "sync_authname", NULL, STRING, "2.5.0" }
 /* The authentication name to use when authenticating to a sync server.
    Prefix with a channel name to only apply for that channel */
 
-{ "sync_batchsize", 8192, INT }
+{ "sync_batchsize", 8192, INT, "3.0.0" }
 /* the number of messages to upload in a single mailbox replication.
    Default is 8192.  If there are more than this many messages appended
    to the mailbox, generate a synthetic partial state and send that. */
 
-{ "sync_host", NULL, STRING }
+{ "sync_host", NULL, STRING, "2.5.0" }
 /* Name of the host (replica running sync_server(8)) to which
    replication actions will be sent by sync_client(8).
    Prefix with a channel name to only apply for that channel */
 
-{ "sync_log", 0, SWITCH }
+{ "sync_log", 0, SWITCH, "2.3.17" }
 /* Enable replication action logging by lmtpd(8), imapd(8), pop3d(8),
    and nntpd(8).  The log {configdirectory}/sync/log is used by
    sync_client(8) for "rolling" replication. */
 
-{ "sync_log_chain", 0, SWITCH }
+{ "sync_log_chain", 0, SWITCH, "2.4.0" }
 /* Enable replication action logging by sync_server as well, allowing
    chaining of replicas.  Use this on 'B' for A => B => C replication layout */
 
-{ "sync_log_channels", NULL, STRING }
+{ "sync_log_channels", NULL, STRING, "2.5.0" }
 /* If specified, log all events to multiple log files in directories
    specified by each "channel".  Each channel can then be processed
    separately, such as by multiple sync_client(8)s in a mesh replication
@@ -2121,17 +2569,17 @@ product version in the capabilities
    You can use "" (the two-character string U+22 U+22) to mean the
    default sync channel. */
 
-{ "sync_log_unsuppressable_channels", "squatter", STRING }
+{ "sync_log_unsuppressable_channels", "squatter", STRING, "2.5.0" }
 /* If specified, the named channels are exempt from the effect of setting
    sync_log_chain:off, i.e. they are always logged to by the sync_server
    process.  This is only really useful to allow rolling search indexing
    on a replica. */
 
-{ "sync_password", NULL, STRING }
+{ "sync_password", NULL, STRING, "2.5.0" }
 /* The default password to use when authenticating to a sync server.
    Prefix with a channel name to only apply for that channel */
 
-{ "sync_port", NULL, STRING }
+{ "sync_port", NULL, STRING, "3.0.0" }
 /* Name of the service (or port number) of the replication service on
    replica host.  Prefix with a channel name to only apply for that
    channel.  If not specified, and if sync_try_imap is set to "yes"
@@ -2139,89 +2587,114 @@ product version in the capabilities
    (port 143) to check if imapd supports replication.  otherwise it
    will default to "csync" (usually port 2005). */
 
-{ "sync_realm", NULL, STRING }
+{ "sync_realm", NULL, STRING, "2.5.0" }
 /* The authentication realm to use when authenticating to a sync server.
    Prefix with a channel name to only apply for that channel */
 
-{ "sync_repeat_interval", 1, INT }
-/* Minimum interval (in seconds) between replication runs in rolling
-   replication mode. If a replication run takes longer than this
-   time, we repeat immediately.
-   Prefix with a channel name to only apply for that channel */
+{ "sync_repeat_interval", "1s", DURATION, "3.1.8" }
+/* Minimum interval between replication runs in rolling replication
+   mode. If a replication run takes longer than this time, we repeat
+   immediately.  Prefix with a channel name to only apply for that
+   channel.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "sync_shutdown_file", NULL, STRING }
+{ "sync_shutdown_file", NULL, STRING, "2.5.0" }
 /* Simple latch used to tell sync_client(8) that it should shut down at the
    next opportunity. Safer than sending signals to running processes.
    Prefix with a channel name to only apply for that channel */
 
-{ "sync_timeout", 1800, INT }
-/* Number of seconds to wait for a response before returning a timeout
-   failure when talking to a replication peer (client or server). */
+{ "sync_timeout", "30m", DURATION, "3.1.8" }
+/* How long to wait for a response before returning a timeout failure
+   when talking to a replication peer (client or server).  The minimum
+   duration is 3 seconds, the default is 30 minutes.
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "sync_try_imap", 1, SWITCH }
+{ "sync_try_imap", 1, SWITCH, "3.0.0" }
 /* Whether sync_client should try to perform an IMAP connection
    before falling back to csync.  If this is set to "no",
    sync_client will only use csync.  Prefix with a channel name to
    apply only for that channel */
 
-{ "syslog_prefix", NULL, STRING }
-/* String to be prepended to the process name in syslog entries. */
+{ "syslog_prefix", NULL, STRING, "3.1.8" }
+/* String to be prepended to the process name in syslog entries. Can
+   be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+   variable.
+.PP
+   Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+   advantage that it can be set before the \fBimapd.conf\fR is read, so
+   errors while reading the config file can be syslogged with the correct
+   prefix. */
 
-{ "syslog_facility", NULL, STRING }
+{ "syslog_facility", NULL, STRING, "2.5.0" }
 /* Configure a syslog facility.  The default is whatever is compiled
    in.  Allowed values are: DAEMON, MAIL, NEWS, USER, and LOCAL0
    through to LOCAL7 */
 
-{ "tcp_keepalive", 0, SWITCH }
+{ "tcp_keepalive", 0, SWITCH, "2.4.0" }
 /* Enable keepalive on TCP connections */
 
-{ "tcp_keepalive_cnt", 0, INT }
+{ "tcp_keepalive_cnt", 0, INT, "2.4.0" }
 /* Number of TCP keepalive probes to send before declaring the
    connection dead (0 == system default) */
 
-{ "tcp_keepalive_idle", 0, INT }
-/* Number of seconds a connection must be idle before keepalive
-   probes are sent (0 == system default) */
+{ "tcp_keepalive_idle", "0", DURATION, "3.1.8" }
+/* How long a connection must be idle before keepalive probes are sent
+   (0 == system default).
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "tcp_keepalive_intvl", 0, INT }
-/* Number of seconds between keepalive probes (0 == system default) */
+{ "tcp_keepalive_intvl", "0", DURATION, "3.1.8" }
+/* Time between keepalive probes (0 == system default).
+.PP
+   For backward compatibility, if no unit is specified, seconds is
+   assumed. */
 
-{ "temp_path", "/tmp", STRING }
+{ "temp_path", "/tmp", STRING, "2.3.17" }
 /* The pathname to store temporary files in */
 
-{ "telemetry_bysessionid", 0, SWITCH }
+{ "telemetry_bysessionid", 0, SWITCH, "3.0.0" }
 /* If true, log by sessionid instead of PID for telemetry */
 
-{ "timeout", 32, INT }
-/* The length of the IMAP server's inactivity autologout timer,
-   in minutes.  The minimum value is 30.  The default is 32 to
-   allow a bit of leeway for clients that try to NOOP every 30
-   minutes. */
-
-{ "imapidletimeout", 0, INT }
-/* Timeout for idling clients (RFC 2177) in minutes. If set to
-   zero (the default) or less, the value of "timeout" will be
-   used instead. */
+{ "timeout", "32m", DURATION, "3.1.8" }
+/* The length of the IMAP server's inactivity autologout timer.
+   The minimum value is 30 minutes.  The default is 32 minutes,
+   to allow a bit of leeway for clients that try to NOOP every
+   30 minutes.
+.PP
+   For backward compatibility, if no unit is specified, minutes
+   is assumed. */
+
+{ "imapidletimeout", NULL, DURATION, "3.1.8" }
+/* Timeout for idling clients (RFC 2177).  If not set (the default),
+   the value of "timeout" will be used instead.
+.PP
+   For backward compatibility, if no unit is specified, minutes
+   is assumed. */
 
-{ "tls_ca_file", NULL, STRING, "2.5.0", "tls_client_ca_file" }
+{ "tls_ca_file", NULL, STRING, "2.5.0", "2.5.0", "tls_client_ca_file" }
 /* Deprecated in favor of \fItls_client_ca_file\fR. */
 
-{ "tls_ca_path", NULL, STRING, "2.5.0", "tls_client_ca_dir" }
+{ "tls_ca_path", NULL, STRING, "2.5.0", "2.5.0", "tls_client_ca_dir" }
 /* Deprecated in favor of \fItls_client_ca_dir\fR. */
 
-{ "tlscache_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "lmdb"), "2.5.0", "tls_sessions_db" }
+{ "tlscache_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "2.5.0", "2.5.0", "tls_sessions_db" }
 /* Deprecated in favor of \fItls_sessions_db\fR. */
 
-{ "tlscache_db_path", NULL, STRING, "2.5.0", "tls_sessions_db_path" }
+{ "tlscache_db_path", NULL, STRING, "2.5.0", "2.5.0", "tls_sessions_db_path" }
 /* Deprecated in favor of \fItls_sessions_db_path\fR. */
 
-{ "tls_cert_file", NULL, STRING, "2.5.0", "tls_server_cert" }
+{ "tls_cert_file", NULL, STRING, "2.5.0", "2.5.0", "tls_server_cert" }
 /* Deprecated in favor of \fItls_server_cert\fR. */
 
-{ "tls_cipher_list", "DEFAULT", STRING, "2.5.0", "tls_ciphers" }
+{ "tls_cipher_list", "DEFAULT", STRING, "2.5.0", "2.5.0", "tls_ciphers" }
 /* Deprecated in favor of \fItls_ciphers\fR. */
 
-{ "tls_ciphers", "DEFAULT", STRING }
+{ "tls_ciphers", "DEFAULT", STRING, "2.5.0" }
 /* The list of SSL/TLS ciphers to allow.  The format of the string
    (and definition of "DEFAULT") is described in \fBciphers(1)\fR.
 .PP
@@ -2229,116 +2702,130 @@ product version in the capabilities
 .PP
    https://wiki.mozilla.org/Security/Server_Side_TLS */
 
-{ "tls_client_ca_dir", NULL, STRING }
+{ "tls_crl_file", NULL, STRING, "3.1.2" }
+/* Path to a file containing the Certificate Revocation List */
+
+{ "tls_client_ca_dir", NULL, STRING, "2.5.0" }
 /* Path to a directory containing the CA certificates used to verify
    client SSL certificates used for authentication. */
 
-{ "tls_client_ca_file", NULL, STRING }
+{ "tls_client_ca_file", NULL, STRING, "2.5.0" }
 /* Path to a file containing the CA certificate(s) used to verify
    client SSL certificates used for authentication. */
 
-{ "tls_client_cert", NULL, STRING }
+{ "tls_client_cert", NULL, STRING, "2.5.0" }
 /* File containing the certificate presented to a server for authentication
    during STARTTLS. A value of "disabled" will disable this server's use
    of certificate-based authentication. */
 
-{ "tls_client_certs", "optional", ENUM("off", "optional", "require") }
+{ "tls_client_certs", "optional", ENUM("off", "optional", "require"), "2.5.0" }
 /* Disable ("off"), allow ("optional", default) or require ("require") the
    use of SSL certificates by clients to authenticate themselves. */
 
-{ "tls_client_key", NULL, STRING }
+{ "tls_client_key", NULL, STRING, "2.5.0" }
 /* File containing the private key belonging to the tls_client_cert
    certificate. A value of "disabled" will disable this server's use
    of certificate-based authentication. */
 
-{ "tls_eccurve", "prime256v1", STRING }
+{ "tls_eccurve", "prime256v1", STRING, "2.5.0" }
 /* The elliptic curve used for ECDHE. Default is NIST Suite B prime256.
    See 'openssl ecparam -list_curves' for possible values. */
 
-{ "tls_key_file", NULL, STRING, "2.5.0", "tls_server_key" }
+{ "tls_key_file", NULL, STRING, "2.5.0", "2.5.0", "tls_server_key" }
 /* Deprecated in favor of \fItls_server_key\fR. */
 
-{ "tls_required", 0, SWITCH }
+{ "tls_required", 0, SWITCH, "3.0.0" }
 /* If enabled, require a TLS/SSL encryption layer to be negotiated
    prior to ANY authentication mechanisms being advertised or allowed. */
 
-{ "tls_prefer_server_ciphers", 0, SWITCH }
+{ "tls_prefer_server_ciphers", 0, SWITCH, "2.5.0" }
 /* Prefer the ciphers on the server side instead of client side. */
 
-{ "tls_server_ca_dir", NULL, STRING }
+{ "tls_server_ca_dir", NULL, STRING, "2.5.0" }
 /* Path to a directory with CA certificates used to verify certificates
    offered by the server, when cyrus acts as client. This directory must
    have filenames with the hashed value of the certificates (see
    openssl(1)). */
 
-{ "tls_server_ca_file", NULL, STRING }
+{ "tls_server_ca_file", NULL, STRING, "2.5.0" }
 /* Path to a file containing CA certificates used to verify certificates
    offered by the server, when cyrus acts as client. */
 
-{ "tls_server_cert", NULL, STRING }
-/* File containing the certificate, including the full chain, presented to clients. */
+{ "tls_server_cert", NULL, STRING, "3.1.8" }
+/* File containing the certificate, including the full chain, presented to clients.
+   Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+   comma without spaces. */
 
-{ "tls_server_key", NULL, STRING }
-/* File containing the private key belonging to the certificate in
+{ "tls_server_dhparam", NULL, STRING, "3.1.4" }
+/* File containing the DH parameters belonging to the certificate in
    tls_server_cert. */
 
-{ "tls_sessions_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "lmdb")}
+{ "tls_server_key", NULL, STRING, "3.1.8" }
+/* File containing the private key belonging to the certificate in
+   tls_server_cert.  If not set, tls_server_cert must contain both private and
+   public key.  Two files with keys can be set, if two certifates are used, in
+   which case the files must be separated with comma without spaces */
+
+{ "tls_sessions_db", "twoskip", STRINGLIST("skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the TLS cache. */
 
-{ "tls_sessions_db_path", NULL, STRING }
+{ "tls_sessions_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the TLS sessions db file. If not specified,
    will be configdirectory/tls_sessions.db */
 
-{ "tls_session_timeout", 1440, INT }
-/* The length of time (in minutes) that a TLS session will be cached
-   for later reuse.  The maximum value is 1440 (24 hours), the
-   default.  A value of 0 will disable session caching. */
+{ "tls_session_timeout", "24h", DURATION, "3.1.8" }
+/* The length of time that a TLS session will be cached for later
+   reuse.  The maximum value is 24 hours, also the default.  A
+   value of 0 will disable session caching.
+.PP
+   For backward compatibility, if no unit is specified, minutes is
+   assumed. */
 
-{ "tls_versions", "tls1_0 tls1_1 tls1_2 tls1_3", STRING }
+{ "tls_versions", "tls1_0 tls1_1 tls1_2 tls1_3", STRING, "3.1.8" }
 /* A list of SSL/TLS versions to not disable. Cyrus IMAP SSL/TLS starts
    with all protocols, and subtracts protocols not in this list. Newer
    versions of SSL/TLS will need to be added here to allow them to get
    disabled. */
 
-{ "uidl_format", "cyrus", ENUM("uidonly", "cyrus", "dovecot", "courier") }
+{ "uidl_format", "cyrus", ENUM("uidonly", "cyrus", "dovecot", "courier"), "3.0.0" }
 /* Choose the format for UIDLs in pop3.  Possible values are "uidonly",
    "cyrus", "dovecot" and "courier".  "uidonly" forces the old default
    of UID, "cyrus" is UIDVALIDITY.UID.  Dovecot is 8 digits of leading
    hex (lower case) each UID UIDVALIDITY. Courier is UIDVALIDITY-UID. */
 
-{ "umask", "077", STRING }
+{ "umask", "077", STRING, "2.3.17" }
 /* The umask value used by various Cyrus IMAP programs. */
 
-{ "userdeny_db", "flat", STRINGLIST("flat", "skiplist", "sql", "twoskip", "lmdb")}
+{ "userdeny_db", "flat", STRINGLIST("flat", "skiplist", "sql", "twoskip", "zeroskip"), "3.1.6" }
 /* The cyrusdb backend to use for the user access list. */
 
-{ "userdeny_db_path", NULL, STRING }
+{ "userdeny_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the userdeny db file.  If not specified,
    will be configdirectory/user_deny.db */
 
-{ "username_tolower", 1, SWITCH }
+{ "username_tolower", 1, SWITCH, "2.3.17" }
 /* Convert usernames to all lowercase before login/authentication.  This
    is useful with authentication backends which ignore case during
    username lookups (such as LDAP).  */
 
-{ "userprefix", "Other Users", STRING }
+{ "userprefix", "Other Users", STRING, "2.3.17" }
 /* If using the alternate IMAP namespace, the prefix for the other users
    namespace.  The hierarchy delimiter will be automatically appended. */
 
 # xxx badly worded
-{ "unix_group_enable", 1, SWITCH }
+{ "unix_group_enable", 1, SWITCH, "2.3.17" }
 /* Should we look up groups when using auth_unix (disable this if you are
    not using groups in ACLs for your IMAP server, and you are using auth_unix
    with a backend (such as LDAP) that can make getgrent() calls very
    slow) */
 
-{ "unixhierarchysep", 1, SWITCH }
+{ "unixhierarchysep", 1, SWITCH, "3.0.0" }
 /* Use the UNIX separator character '/' for delimiting levels of
    mailbox hierarchy.  Turn off to use the netnews separator
    character '.'. Note that with the newnews separator, no dots may
    occur in mailbox names.  The default switched in 3.0 from off to on. */
 
-{ "virtdomains", "off", ENUM("off", "userid", "on") }
+{ "virtdomains", "off", ENUM("off", "userid", "on"), "3.1.8" }
 /* Configure virtual domain support.
 .PP
 .IP off
@@ -2361,14 +2848,24 @@ of the incoming network interface, or if
 .PP
     */
 
-{ "xbackup_enabled", 0, SWITCH }
+{ "virusscan_notification_subject", "Automatically deleted mail", STRING, "3.1.8" }
+/* The text used in the subject of email notifications created by
+   \fBcyr_virusscan(8)\fR when deleting infected mail. */
+
+{ "virusscan_notification_template", NULL, STRING, "3.1.8" }
+/* The absolute path to a file containing a template to use to describe
+   infected messages that have been deleted by \fBcyr_virusscan(8)\fR.
+   See \fBcyr_virusscan(8)\fR for specification of the format of this file.
+   If not specified, the builtin default template will be used. */
+
+{ "xbackup_enabled", 0, SWITCH, "3.0.0" }
 /* Enable support for the XBACKUP command in imapd.  If enabled, admin
    users can use this command to provoke a replication of specified users
    to the named backup channel. */
 
 # Commented out - there's no such thing as "xlist-flag", but we need
 # this for the man page
-# { "xlist-flag", NULL, STRING }
+# { "xlist-flag", NULL, STRING, "3.0.0" }
 /* Set the special-use flag \fIflag\fR on the specified folder when it
    is autocreated (see the \fIautocreate_inbox_folders\fR option).  For
    example, if \fBxlist-junk: Spam\fR is set, and the folder \fBSpam\fR
@@ -2378,51 +2875,61 @@ of the incoming network interface, or if
    files.)
    */
 
-{ "lmtp_catchall_mailbox", NULL, STRING }
+{ "lmtp_catchall_mailbox", NULL, STRING, "2.5.0" }
 /* Mail sent to mailboxes which do not exist, will be delivered to
    this user.  NOTE: This must be an existing local user name with an
    INBOX, NOT an email address! */
 
-{ "zoneinfo_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "lmdb")}
-/* The cyrusdb backend to use for zoneinfo. */
+{ "zoneinfo_db", "twoskip", STRINGLIST("flat", "skiplist", "twoskip", "zeroskip"), "3.1.6" }
+/* The cyrusdb backend to use for zoneinfo.  This database is used by the
+   "tzdist" \fIhttp_modules\fR, and is managed by \fBctl_zoneinfo(8)\fR.*/
 
-{ "zoneinfo_db_path", NULL, STRING }
+{ "zoneinfo_db_path", NULL, STRING, "2.5.0" }
 /* The absolute path to the zoneinfo db file.  If not specified,
    will be configdirectory/zoneinfo.db */
 
-{ "object_storage_enabled", 0, SWITCH }
+{ "zoneinfo_dir", NULL, STRING, "3.2.0" }
+/* The absolute path to the zoneinfo directory, containing timezone
+   definitions as generated by the vzic tool.  If not specified, whatever
+   definitions libical finds will be used.
+.PP
+   If you are providing a Time Zone Data Distribution Service (i.e. you have
+   "tzdist" listed in \fIhttp_modules\fR), then this configuration option MUST
+   be specified. */
+
+{ "object_storage_enabled", 0, SWITCH, "3.0.0" }
 /* Is Object storage enabled for this server.  You also need to have
    archiving enabled and archivepartition for the mailbox.
    Only email files will be stored on object Storage archive partition will be
    used to store any other files */
 
-{ "object_storage_dummy_spool", NULL, STRING }
+{ "object_storage_dummy_spool", NULL, STRING, "3.0.0" }
 /* Dummy object storage spool; this is for test only.
    Spool where user directory (container) will be created to store all emails
    in a flat structure  */
 
-{ "openio_namespace", NULL, STRING }
+{ "openio_namespace", NULL, STRING, "3.0.0" }
 /* The OpenIO namespace used to store archived email messages. A namespace
    identifies the physical platform cyrus must contact. This directive is used
    by the OpenIO's SDK to locate its platform entry point. */
 
-{ "openio_account", NULL, STRING }
+{ "openio_account", NULL, STRING, "3.0.0" }
 /* The OpenIO account used to account for stored emails. Accounts are unique
    in their namespace. They provides virtual partitions, with quotas and QoS
    features. */
 
-{ "openio_rawx_timeout", 30, INT }
+{ "openio_rawx_timeout", "30s", DURATION, "3.1.8" }
 /* The OpenIO timeout to query to the RAWX services (default 30 sec). */
 
-{ "openio_proxy_timeout", 5, INT }
+{ "openio_proxy_timeout", "5s", DURATION, "3.1.8" }
 /* The OpenIO timeout to query to the PROXY services (default 5 sec). */
 
-{ "openio_autocreate", 0, SWITCH }
+{ "openio_autocreate", 0, SWITCH, "3.0.0" }
 /* Allow the OpenIO SDK to autocreate containers. Mainly destined to be turned
    on development environments. In production, the container should have been
    provisioned with the mailboxes. */
 
-{ "openio_verbosity", NULL, STRING }
+{ "openio_verbosity", NULL, STRING, "3.0.0" }
 /* Sets the logging verbosity of the OpenIO's internal behavior. Admissible
    values are: "warning", "notice", "info", "debug", "trace", "quiet".
    The default verbosity is "warning". Set to "notice" for a few lines on a
@@ -2432,16 +2939,16 @@ of the incoming network interface, or if
    the cyrus to be set in debug mode. The special "quiet" value disables all
    kinds of logging at the GLib level. */
 
-{ "caringo_hostname", NULL, STRING }
+{ "caringo_hostname", NULL, STRING, "3.0.0" }
 /* The Caringo hostname used to store archived email messages. A hostname
    identifies the physical platform cyrus must contact. This directive is used
    by the Caringo's SDK (CastorSDK: Caringo Simple Content Storage Protocol (SCSP)
    on HTTP 1.1 using a RESTful architecture  */
 
-{ "caringo_port", 80, INT }
+{ "caringo_port", 80, INT, "3.0.0" }
 /* The port of the caringo server (caringo_hostname); default is 80. */
 
-{ "fastmailsharing", 0, SWITCH }
+{ "fastmailsharing", 0, SWITCH, "3.0.0" }
 /* If enabled, use FastMail style sharing (oldschool full server paths) */
 
 /*
diff -pruN 3.0.13-5/lib/imclient.c 3.2.0-3/lib/imclient.c
--- 3.0.13-5/lib/imclient.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/imclient.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,6 +49,7 @@
 #include <unistd.h>
 #endif
 #include <stdarg.h>
+#include <sysexits.h>
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
@@ -71,7 +72,6 @@
 #endif /* HAVE_SSL */
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
 #include "strarray.h"
@@ -150,7 +150,7 @@ struct imclient {
 #ifdef HAVE_SSL
     SSL_CTX *tls_ctx;
     SSL *tls_conn;
-    int tls_on; /* wheather we are under a layer or not */
+    int tls_on; /* whether we are under a layer or not */
 #endif /* HAVE_SSL */
 };
 
@@ -506,7 +506,7 @@ imclient_send(struct imclient *imclient,
 
         default:
             fatal("internal error: invalid format specifier in imclient_send",
-                  EC_SOFTWARE);
+                  EX_SOFTWARE);
         }
         fmt = percent + 1;
     }
@@ -1146,10 +1146,10 @@ EXPORTED void fillin_interactions(struct
 
 /*
  * Params:
- *  mechlist: list of mechanisms seperated by spaces
+ *  mechlist: list of mechanisms separated by spaces
  *
  * Returns:
- *  0 - sucess
+ *  0 - success
  *  1 - failure
  *  2 - severe failure?
  */
@@ -1881,7 +1881,7 @@ EXPORTED int tls_start_clienttls(struct
     }
 
     /*
-     * Lets see, whether a peer certificate is availabe and what is
+     * Lets see, whether a peer certificate is available and what is
      * the actual information. We want to save it for later use.
      */
     peer = SSL_get_peer_certificate(imclient->tls_conn);
diff -pruN 3.0.13-5/lib/libconfig.c 3.2.0-3/lib/libconfig.c
--- 3.0.13-5/lib/libconfig.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/libconfig.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,13 +47,13 @@
 #include <stdlib.h>
 #include <string.h>
 #include <ctype.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <netinet/in.h>
 #include <sys/stat.h>
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "hash.h"
 #include "libconfig.h"
 #include "xmalloc.h"
@@ -87,15 +87,39 @@ EXPORTED unsigned config_maxquoted;
 EXPORTED int config_qosmarking;
 EXPORTED int config_debug;
 
+static int config_loaded;
+
 extern void fatal(const char *fatal_message, int fatal_code)
    __attribute__ ((noreturn));
 
 /* prototype to allow for sane function ordering */
 static void config_read_file(const char *filename);
 
+static void assert_not_deprecated(enum imapopt opt)
+{
+    if (imapopts[opt].deprecated_since) {
+        char errbuf[1024];
+        enum imapopt popt = imapopts[opt].preferred_opt;
+        if (popt != IMAPOPT_ZERO) {
+            snprintf(errbuf, sizeof(errbuf),
+                    "Option '%s' is deprecated in favor of '%s' since version %s.",
+                    imapopts[opt].optname, imapopts[popt].optname,
+                    imapopts[opt].deprecated_since);
+        }
+        else {
+            snprintf(errbuf, sizeof(errbuf),
+                    "Option '%s' is deprecated in version %s.",
+                    imapopts[opt].optname, imapopts[opt].deprecated_since);
+        }
+        fatal(errbuf, EX_SOFTWARE);
+    }
+}
+
 EXPORTED const char *config_getstring(enum imapopt opt)
 {
+    assert(config_loaded);
     assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert_not_deprecated(opt);
     assert((imapopts[opt].t == OPT_STRING) ||
            (imapopts[opt].t == OPT_STRINGLIST));
 
@@ -104,7 +128,9 @@ EXPORTED const char *config_getstring(en
 
 EXPORTED int config_getint(enum imapopt opt)
 {
+    assert(config_loaded);
     assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert_not_deprecated(opt);
     assert(imapopts[opt].t == OPT_INT);
 #if (SIZEOF_LONG != 4)
     if ((imapopts[opt].val.i > 0x7fffffff)||
@@ -118,7 +144,9 @@ EXPORTED int config_getint(enum imapopt
 
 EXPORTED int config_getswitch(enum imapopt opt)
 {
+    assert(config_loaded);
     assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert_not_deprecated(opt);
     assert(imapopts[opt].t == OPT_SWITCH);
 #if (SIZEOF_LONG != 4)
     if ((imapopts[opt].val.b > 0x7fffffff)||
@@ -132,7 +160,9 @@ EXPORTED int config_getswitch(enum imapo
 
 EXPORTED enum enum_value config_getenum(enum imapopt opt)
 {
+    assert(config_loaded);
     assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert_not_deprecated(opt);
     assert(imapopts[opt].t == OPT_ENUM);
 
     return imapopts[opt].val.e;
@@ -140,12 +170,123 @@ EXPORTED enum enum_value config_getenum(
 
 EXPORTED unsigned long config_getbitfield(enum imapopt opt)
 {
+    assert(config_loaded);
     assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert_not_deprecated(opt);
     assert(imapopts[opt].t == OPT_BITFIELD);
 
     return imapopts[opt].val.x;
 }
 
+/* Parse a duration value, converted to seconds.
+ *
+ * defunit is one of 'd', 'h', 'm', 's' and determines how
+ * unitless values are parsed.
+ *
+ * On success, 0 is returned and the duration in seconds is written to
+ * out_duration (if provided).
+
+ * On error, -1 is returned and out_duration is unchanged.
+ */
+EXPORTED int config_parseduration(const char *str, int defunit, int *out_duration)
+{
+    assert(strchr("dhms", defunit) != NULL); /* n.b. also permits \0 */
+
+    const size_t len = strlen(str);
+    const char *p;
+    int accum = 0, duration = 0, neg = 0, sawdigit = 0, r = 0;
+    char *copy = NULL;
+
+    /* the default default unit is seconds */
+    if (!defunit) defunit = 's';
+
+    /* make a copy and append the default unit if necessary */
+    copy = xzmalloc(len + 2);
+    strlcpy(copy, str, len + 2);
+    if (cyrus_isdigit(copy[len-1]))
+        copy[len] = defunit;
+
+    p = copy;
+    if (*p == '-') {
+        neg = 1;
+        p++;
+    }
+    for (; *p; p++) {
+        if (cyrus_isdigit(*p)) {
+            accum *= 10;
+            accum += (*p - '0');
+            sawdigit = 1;
+        }
+        else {
+            if (!sawdigit) {
+                syslog(LOG_DEBUG, "%s: no digit before '%c' in '%s'",
+                                  __func__, *p, str);
+                r = -1;
+                goto done;
+            }
+            sawdigit = 0;
+            switch (*p) {
+            case 'd':
+                accum *= 24;
+                /* fall through */
+            case 'h':
+                accum *= 60;
+                /* fall through */
+            case 'm':
+                accum *= 60;
+                /* fall through */
+            case 's':
+                duration += accum;
+                accum = 0;
+                break;
+            default:
+                syslog(LOG_DEBUG, "%s: bad unit '%c' in %s",
+                                  __func__, *p, str);
+                r = -1;
+                goto done;
+            }
+        }
+    }
+
+    /* we shouldn't have anything left in the accumulator */
+    assert(accum == 0);
+
+    if (neg) duration = -duration;
+    if (out_duration) *out_duration = duration;
+
+done:
+    if (copy) free(copy);
+    return r;
+}
+
+/* Get a duration value, converted to seconds.
+ *
+ * defunit is one of 'd', 'h', 'm', 's' and determines how
+ * unitless values are parsed.
+ */
+EXPORTED int config_getduration(enum imapopt opt, int defunit)
+{
+    int duration;
+
+    assert(opt > IMAPOPT_ZERO && opt < IMAPOPT_LAST);
+    assert(imapopts[opt].t == OPT_DURATION);
+    assert_not_deprecated(opt);
+    assert(strchr("dhms", defunit) != NULL); /* n.b. also permits \0 */
+
+    if (imapopts[opt].val.s == NULL) return 0;
+
+    if (config_parseduration(imapopts[opt].val.s, defunit, &duration)) {
+        /* should have been rejected by config_read_file, but just in case */
+        char errbuf[1024];
+        snprintf(errbuf, sizeof(errbuf),
+                 "%s: %s: couldn't parse duration '%s'",
+                 __func__, imapopts[opt].optname, imapopts[opt].val.s);
+        fatal(errbuf, EX_CONFIG);
+    }
+
+    return duration;
+}
+
 EXPORTED const char *config_getoverflowstring(const char *key, const char *def)
 {
     char buf[256];
@@ -158,7 +299,7 @@ EXPORTED const char *config_getoverflows
 
     if (config_ident) {
         if (snprintf(buf,sizeof(buf),"%s_%s",config_ident,key) == -1)
-            fatal("key too long in config_getoverflowstring", EC_TEMPFAIL);
+            fatal("key too long in config_getoverflowstring", EX_TEMPFAIL);
 
         lcase(buf);
         ret = hash_lookup(buf, &confighash);
@@ -218,10 +359,13 @@ EXPORTED const char *config_archiveparti
 {
     char buf[80];
 
+    if (!config_getswitch(IMAPOPT_ARCHIVE_ENABLED))
+        return NULL;
+
     if(strlcpy(buf, "archivepartition-", sizeof(buf)) >= sizeof(buf))
-        return 0;
+        return NULL;
     if(strlcat(buf, partition, sizeof(buf)) >= sizeof(buf))
-        return 0;
+        return NULL;
 
     const char *dir = config_getoverflowstring(buf, NULL);
     if (!dir)
@@ -294,6 +438,7 @@ static void config_option_deprecate(cons
 
     case OPT_STRINGLIST:
     case OPT_STRING:
+    case OPT_DURATION:
         imapopts[opt].val.s = imapopts[dopt].val.s;
         imapopts[dopt].val.s = NULL;
         break;
@@ -368,16 +513,18 @@ EXPORTED void config_read(const char *al
     char *p;
     int ival;
 
+    config_loaded = 1;
+
     /* xxx this is leaked, this may be able to be better in 2.2 (cyrus_done) */
     if (alt_config) config_filename = xstrdup(alt_config);
     else config_filename = xstrdup(CONFIG_FILENAME);
 
     if (!construct_hash_table(&confighash, CONFIGHASHSIZE, 1)) {
-        fatal("could not construct configuration hash table", EC_CONFIG);
+        fatal("could not construct configuration hash table", EX_CONFIG);
     }
 
     if (!construct_hash_table(&includehash, INCLUDEHASHSIZE, 1)) {
-        fatal("could not construct include file  hash table", EC_CONFIG);
+        fatal("could not construct include file  hash table", EX_CONFIG);
     }
 
     config_read_file(config_filename);
@@ -387,7 +534,7 @@ EXPORTED void config_read(const char *al
     /* Check configdirectory config option */
     if (!config_dir) {
         fatal("configdirectory option not specified in configuration file",
-              EC_CONFIG);
+              EX_CONFIG);
     }
 
     for (opt = IMAPOPT_ZERO; opt < IMAPOPT_LAST; opt++) {
@@ -445,7 +592,7 @@ EXPORTED void config_read(const char *al
             syslog(LOG_ERR, "INVALID defaultpartition: %s",
                    config_defpartition);
             fatal("defaultpartition option contains non-alnum character",
-                  EC_CONFIG);
+                  EX_CONFIG);
         }
         if (Uisupper(*p)) *p = tolower((unsigned char) *p);
     }
@@ -476,7 +623,7 @@ EXPORTED void config_read(const char *al
             snprintf(buf, sizeof(buf),
                      "partition-%s option not specified in configuration file",
                      config_defpartition ? config_defpartition : "<name>");
-            fatal(buf, EC_CONFIG);
+            fatal(buf, EX_CONFIG);
         }
     }
 
@@ -520,6 +667,19 @@ EXPORTED void config_read(const char *al
 
 #define GROWSIZE 4096
 
+static void config_add_overflowstring(const char *key, const char *value, int lineno)
+{
+    char *newval = xstrdup(value);
+    if (newval != hash_insert(key, newval, &confighash)) {
+        char errbuf[1024];
+        snprintf(errbuf, sizeof(errbuf),
+                "option '%s' was specified twice in config file "
+                "(second occurrence on line %d)",
+                key, lineno);
+        fatal(errbuf, EX_CONFIG);
+    }
+}
+
 static void config_read_file(const char *filename)
 {
     FILE *infile = NULL;
@@ -528,7 +688,7 @@ static void config_read_file(const char
     char *buf, errbuf[1024];
     const char *cyrus_path;
     unsigned bufsize, len;
-    char *p, *q, *key, *fullkey, *srvkey, *val, *newval;
+    char *p, *q, *key, *fullkey, *srvkey;
     int service_specific;
     int idlen = (config_ident ? strlen(config_ident) : 0);
 
@@ -550,14 +710,14 @@ static void config_read_file(const char
     if (!infile) {
         snprintf(buf, bufsize, "can't open configuration file %s: %s",
                  filename, strerror(errno));
-        fatal(buf, EC_CONFIG);
+        fatal(buf, EX_CONFIG);
     }
 
     /* check to see if we've already read this file */
     if (hash_lookup(filename, &includehash)) {
         snprintf(buf, bufsize, "configuration file %s included twice",
                  filename);
-        fatal(buf, EC_CONFIG);
+        fatal(buf, EX_CONFIG);
     }
     else {
         hash_insert(filename, (void*) 0xDEADBEEF, &includehash);
@@ -606,7 +766,7 @@ static void config_read_file(const char
             snprintf(errbuf, sizeof(errbuf),
                     "invalid option name on line %d of configuration file %s",
                     lineno, filename);
-            fatal(errbuf, EC_CONFIG);
+            fatal(errbuf, EX_CONFIG);
         }
         *p++ = '\0';
 
@@ -622,7 +782,7 @@ static void config_read_file(const char
             snprintf(errbuf, sizeof(errbuf),
                     "empty option value on line %d of configuration file",
                     lineno);
-            fatal(errbuf, EC_CONFIG);
+            fatal(errbuf, EX_CONFIG);
         }
 
         srvkey = NULL;
@@ -637,7 +797,7 @@ static void config_read_file(const char
                 snprintf(errbuf, sizeof(errbuf),
                          "invalid directive on line %d of configuration file %s",
                          lineno, filename);
-                fatal(errbuf, EC_CONFIG);
+                fatal(errbuf, EX_CONFIG);
             }
         }
 
@@ -689,7 +849,7 @@ static void config_read_file(const char
                 sprintf(errbuf,
                         "option '%s' was specified twice in config file (second occurrence on line %d)",
                         fullkey, lineno);
-                fatal(errbuf, EC_CONFIG);
+                fatal(errbuf, EX_CONFIG);
 
             } else if (imapopts[opt].seen == 2 && !service_specific) {
                 continue;
@@ -705,6 +865,14 @@ static void config_read_file(const char
             else
                 imapopts[opt].seen = 1;
 
+            /* If this is a deprecated option, save a copy of its value to the
+             * overflow hash.  If we need to look up the deprecated name for
+             * some reason, we can do so with config_getoverflowstring().
+             */
+            if (imapopts[opt].deprecated_since) {
+                config_add_overflowstring(fullkey, p, lineno);
+            }
+
             /* this is a known option */
             switch (imapopts[opt].t) {
             case OPT_STRING:
@@ -726,7 +894,7 @@ static void config_read_file(const char
                     /* error during conversion */
                     sprintf(errbuf, "non-integer value for %s in line %d",
                             imapopts[opt].optname, lineno);
-                    fatal(errbuf, EC_CONFIG);
+                    fatal(errbuf, EX_CONFIG);
                 }
 
                 imapopts[opt].val.i = val;
@@ -746,7 +914,7 @@ static void config_read_file(const char
                     /* error during conversion */
                     sprintf(errbuf, "non-switch value for %s in line %d",
                             imapopts[opt].optname, lineno);
-                    fatal(errbuf, EC_CONFIG);
+                    fatal(errbuf, EX_CONFIG);
                 }
                 break;
             }
@@ -789,7 +957,7 @@ static void config_read_file(const char
                         /* error during conversion */
                         sprintf(errbuf, "invalid value '%s' for %s in line %d",
                                 p, imapopts[opt].optname, lineno);
-                        fatal(errbuf, EC_CONFIG);
+                        fatal(errbuf, EX_CONFIG);
                     }
                     else if (imapopts[opt].t == OPT_STRINGLIST)
                         imapopts[opt].val.s = e->name;
@@ -805,6 +973,22 @@ static void config_read_file(const char
 
                 break;
             }
+            case OPT_DURATION:
+            {
+                /* make sure it's parseable, though we don't know the default units */
+                if (config_parseduration(p, '\0', NULL)) {
+                    snprintf(errbuf, sizeof(errbuf),
+                             "unparsable duration '%s' for %s in line %d",
+                             p, imapopts[opt].optname, lineno);
+                    fatal(errbuf, EX_CONFIG);
+                }
+
+                /* but then store it unparsed, it will be parsed again by
+                 * config_getduration() where the caller knows the appropriate
+                 * default units */
+                imapopts[opt].val.s = xstrdup(p);
+                break;
+            }
             case OPT_NOTOPT:
             default:
                 abort();
@@ -822,19 +1006,12 @@ static void config_read_file(const char
                 sprintf(errbuf,
                         "option '%s' is unknown on line %d of config file",
                         fullkey, lineno);
-                fatal(errbuf, EC_CONFIG);
+                fatal(errbuf, EX_CONFIG);
             }
 */
 
             /* Put it in the overflow hash table */
-            newval = xstrdup(p);
-            val = hash_insert(key, newval, &confighash);
-            if (val != newval) {
-                snprintf(errbuf, sizeof(errbuf),
-                        "option '%s' was specified twice in config file (second occurrence on line %d)",
-                        fullkey, lineno);
-                fatal(errbuf, EC_CONFIG);
-            }
+            config_add_overflowstring(key, p, lineno);
         }
     }
 
diff -pruN 3.0.13-5/lib/libconfig.h 3.2.0-3/lib/libconfig.h
--- 3.0.13-5/lib/libconfig.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/libconfig.h	2020-04-24 02:03:00.000000000 +0000
@@ -54,6 +54,7 @@ extern int config_getint(enum imapopt op
 extern int config_getswitch(enum imapopt opt);
 extern enum enum_value config_getenum(enum imapopt opt);
 extern unsigned long config_getbitfield(enum imapopt opt);
+extern int config_getduration(enum imapopt opt, int defunit);
 
 /* these work on additional strings that are not defined in the
  * imapoptions table */
@@ -66,6 +67,10 @@ extern const char *config_archivepartiti
 
 extern const char *config_backupstagingpath(void);
 
+/* for parsing a duration-format string obtained elsewhere,
+ * such as from an overflow string */
+extern int config_parseduration(const char *str, int defunit, int *out_duration);
+
 /* cached configuration variables accessable to external world */
 extern const char *config_filename;
 extern const char *config_dir;
diff -pruN 3.0.13-5/lib/lock_fcntl.c 3.2.0-3/lib/lock_fcntl.c
--- 3.0.13-5/lib/lock_fcntl.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/lock_fcntl.c	2020-04-24 02:03:00.000000000 +0000
@@ -49,7 +49,12 @@
 
 #include "cyr_lock.h"
 
-EXPORTED const char *lock_method_desc = "fcntl";
+#include <syslog.h>
+#include <time.h>
+
+EXPORTED const char lock_method_desc[] = "fcntl";
+
+EXPORTED double debug_locks_longer_than = 0.0;
 
 /*
  * Block until we obtain an exclusive lock on the file descriptor 'fd',
@@ -73,6 +78,10 @@ EXPORTED int lock_reopen_ex(int fd, cons
     struct flock fl;
     struct stat sbuffile, sbufspare;
     int newfd;
+    struct timeval starttime;
+    if (debug_locks_longer_than)
+        gettimeofday(&starttime, 0);
+
 
     if (!sbuf) sbuf = &sbufspare;
 
@@ -96,7 +105,17 @@ EXPORTED int lock_reopen_ex(int fd, cons
             return -1;
         }
 
-        if (sbuf->st_ino == sbuffile.st_ino) return 0;
+        if (sbuf->st_ino == sbuffile.st_ino) {
+            if (debug_locks_longer_than) {
+                struct timeval endtime;
+                gettimeofday(&endtime, 0);
+                double locktime = (double)(endtime.tv_sec - starttime.tv_sec) +
+                                  (double)(endtime.tv_usec - starttime.tv_usec)/1000000.0;
+                if (locktime > debug_locks_longer_than) /* 10ms */
+                    syslog(LOG_NOTICE, "locktimer: reopen %s (%0.2fs)", filename, locktime);
+            }
+            return 0;
+        }
 
         if (changed) *changed = 1;
 
@@ -121,12 +140,15 @@ EXPORTED int lock_reopen_ex(int fd, cons
  * appropriate error code.
  */
 EXPORTED int lock_setlock(int fd, int exclusive, int nonblock,
-                          const char *filename  __attribute__((unused)))
+                          const char *filename)
 {
     int r;
     struct flock fl;
     int type = (exclusive ? F_WRLCK : F_RDLCK);
     int cmd = (nonblock ? F_SETLK : F_SETLKW);
+    struct timeval starttime;
+    if (debug_locks_longer_than)
+        gettimeofday(&starttime, 0);
 
     for (;;) {
         fl.l_type= type;
@@ -134,7 +156,17 @@ EXPORTED int lock_setlock(int fd, int ex
         fl.l_start = 0;
         fl.l_len = 0;
         r = fcntl(fd, cmd, &fl);
-        if (r != -1) return 0;
+        if (r != -1) {
+            if (debug_locks_longer_than) {
+                struct timeval endtime;
+                gettimeofday(&endtime, 0);
+                double locktime = (double)(endtime.tv_sec - starttime.tv_sec) +
+                                  (double)(endtime.tv_usec - starttime.tv_usec)/1000000.0;
+                if (locktime > debug_locks_longer_than)
+                    syslog(LOG_NOTICE, "locktimer: reopen %s (%0.2fs)", filename, locktime);
+            }
+            return 0;
+        }
         if (errno == EINTR) continue;
         return -1;
     }
diff -pruN 3.0.13-5/lib/lock_flock.c 3.2.0-3/lib/lock_flock.c
--- 3.0.13-5/lib/lock_flock.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/lock_flock.c	2020-04-24 02:03:00.000000000 +0000
@@ -51,7 +51,7 @@
 
 #include "cyr_lock.h"
 
-EXPORTED const char *lock_method_desc = "flock";
+EXPORTED const char lock_method_desc[] = "flock";
 
 /*
  * Block until we obtain an exclusive lock on the file descriptor 'fd',
diff -pruN 3.0.13-5/lib/map.h 3.2.0-3/lib/map.h
--- 3.0.13-5/lib/map.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/map.h	2020-04-24 02:03:00.000000000 +0000
@@ -45,7 +45,7 @@
 
 #define MAP_UNKNOWN_LEN ((unsigned long)-1)
 
-extern const char *map_method_desc;
+extern const char map_method_desc[];
 
 /* Create a memory map
  *
diff -pruN 3.0.13-5/lib/map_nommap.c 3.2.0-3/lib/map_nommap.c
--- 3.0.13-5/lib/map_nommap.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/map_nommap.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,15 +45,15 @@
 #include <sys/types.h>
 #include <unistd.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "xmalloc.h"
 #include "map.h"
-#include "exitcodes.h"
 
 #define SLOP (4*1024)
 
-EXPORTED const char *map_method_desc = "nommap";
+EXPORTED const char map_method_desc[] = "nommap";
 
 /*
  * Create/refresh mapping of file
@@ -73,7 +73,7 @@ EXPORTED map_refresh(int fd, int onceonl
             syslog(LOG_ERR, "IOERROR: fstating %s file%s%s: %m", name,
                    mboxname ? " for " : "", mboxname ? mboxname : "");
             snprintf(buf, sizeof(buf), "failed to fstat %s file", name);
-            fatal(buf, EC_IOERR);
+            fatal(buf, EX_IOERR);
         }
         newlen = sbuf.st_size;
     }
@@ -103,7 +103,7 @@ EXPORTED map_refresh(int fd, int onceonl
                        mboxname ? " for " : "", mboxname ? mboxname : "");
             }
             snprintf(buf, sizeof(buf), "failed to read %s file", name);
-            fatal(buf, EC_IOERR);
+            fatal(buf, EX_IOERR);
         }
         p += n;
         left -= n;
diff -pruN 3.0.13-5/lib/mappedfile.c 3.2.0-3/lib/mappedfile.c
--- 3.0.13-5/lib/mappedfile.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/mappedfile.c	2020-04-24 02:03:00.000000000 +0000
@@ -79,27 +79,6 @@
 #include "util.h"
 #include "xmalloc.h"
 
-#define MF_UNLOCKED 0
-#define MF_READLOCKED 1
-#define MF_WRITELOCKED 2
-
-struct mappedfile {
-    char *fname;
-
-    /* obviously you will need 64 bit size_t for 64 bit files... */
-    struct buf map_buf;
-    size_t map_size;
-
-    /* the file itself */
-    int fd;
-
-    /* tracking */
-    int lock_status;
-    int dirty;
-    int was_resized;
-    int is_rw;
-};
-
 static void _ensure_mapped(struct mappedfile *mf, size_t offset, int update)
 {
     /* we may be rewriting inside a file, so don't shrink, only extend */
@@ -111,7 +90,7 @@ static void _ensure_mapped(struct mapped
     }
 
     /* always give refresh another go, we may be map_nommap */
-    buf_init_mmap(&mf->map_buf, /*onceonly*/0, mf->fd, mf->fname,
+    buf_refresh_mmap(&mf->map_buf, /*onceonly*/0, mf->fd, mf->fname,
                   offset, /*mboxname*/NULL);
 
     mf->map_size = offset;
@@ -240,6 +219,7 @@ EXPORTED int mappedfile_readlock(struct
     }
 
     mf->lock_status = MF_READLOCKED;
+    gettimeofday(&mf->starttime, 0);
 
     _ensure_mapped(mf, sbuf.st_size, /*update*/0);
 
@@ -264,6 +244,7 @@ EXPORTED int mappedfile_writelock(struct
         return r;
     }
     mf->lock_status = MF_WRITELOCKED;
+    gettimeofday(&mf->starttime, 0);
 
     if (changed) buf_free(&mf->map_buf);
 
@@ -274,6 +255,9 @@ EXPORTED int mappedfile_writelock(struct
 
 EXPORTED int mappedfile_unlock(struct mappedfile *mf)
 {
+    struct timeval endtime;
+    double timediff;
+
     int r;
 
     /* make this safe to call multiple times */
@@ -290,6 +274,12 @@ EXPORTED int mappedfile_unlock(struct ma
     }
 
     mf->lock_status = MF_UNLOCKED;
+    gettimeofday(&endtime, 0);
+    timediff = timesub(&mf->starttime, &endtime);
+    if (timediff > 1.0) {
+        syslog(LOG_NOTICE, "mappedfile: longlock %s for %0.1f seconds",
+               mf->fname, timediff);
+    }
 
     return 0;
 }
@@ -323,7 +313,7 @@ EXPORTED int mappedfile_commit(struct ma
 }
 
 EXPORTED ssize_t mappedfile_pwrite(struct mappedfile *mf,
-                                   const char *base, size_t len,
+                                   const void *base, size_t len,
                                    off_t offset)
 {
     ssize_t written;
@@ -470,46 +460,3 @@ EXPORTED int mappedfile_rename(struct ma
     free(copy);
     return r;
 }
-
-
-EXPORTED int mappedfile_islocked(const struct mappedfile *mf)
-{
-    return (mf->lock_status != MF_UNLOCKED);
-}
-
-//FIXME this function is nowhere used
-EXPORTED int mappedfile_isreadlocked(const struct mappedfile *mf)
-{
-    return (mf->lock_status == MF_READLOCKED);
-}
-
-EXPORTED int mappedfile_iswritelocked(const struct mappedfile *mf)
-{
-    return (mf->lock_status == MF_WRITELOCKED);
-}
-
-EXPORTED int mappedfile_iswritable(const struct mappedfile *mf)
-{
-    return !!mf->is_rw;
-}
-
-EXPORTED const char *mappedfile_base(const struct mappedfile *mf)
-{
-    /* XXX - require locked? */
-    return mf->map_buf.s;
-}
-
-EXPORTED size_t mappedfile_size(const struct mappedfile *mf)
-{
-    return mf->map_size;
-}
-
-EXPORTED const struct buf *mappedfile_buf(const struct mappedfile *mf)
-{
-    return &mf->map_buf;
-}
-
-EXPORTED const char *mappedfile_fname(const struct mappedfile *mf)
-{
-    return mf->fname;
-}
diff -pruN 3.0.13-5/lib/mappedfile.h 3.2.0-3/lib/mappedfile.h
--- 3.0.13-5/lib/mappedfile.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/mappedfile.h	2020-04-24 02:03:00.000000000 +0000
@@ -48,11 +48,32 @@
 #include <sys/types.h>
 #include <sys/uio.h>
 
-struct mappedfile;
+struct mappedfile {
+    char *fname;
+
+    /* obviously you will need 64 bit size_t for 64 bit files... */
+    struct buf map_buf;
+    size_t map_size;
+
+    /* the file itself */
+    int fd;
+
+    /* tracking */
+    int lock_status;
+    int dirty;
+    int was_resized;
+    int is_rw;
+
+    struct timeval starttime;
+};
 
 #define MAPPEDFILE_CREATE (1<<0)
 #define MAPPEDFILE_RW     (1<<1)
 
+#define MF_UNLOCKED 0
+#define MF_READLOCKED 1
+#define MF_WRITELOCKED 2
+
 extern int mappedfile_open(struct mappedfile **mfp,
                            const char *fname, int flags);
 extern int mappedfile_close(struct mappedfile **mfp);
@@ -63,7 +84,7 @@ extern int mappedfile_unlock(struct mapp
 
 extern int mappedfile_commit(struct mappedfile *mf);
 extern ssize_t mappedfile_pwrite(struct mappedfile *mf,
-                                 const char *base, size_t len,
+                                 const void *base, size_t len,
                                  off_t offset);
 extern ssize_t mappedfile_pwritebuf(struct mappedfile *mf,
                                     const struct buf *buf,
@@ -75,16 +96,14 @@ extern int mappedfile_truncate(struct ma
 
 extern int mappedfile_rename(struct mappedfile *mf, const char *newname);
 
-extern int mappedfile_islocked(const struct mappedfile *mf);
-extern int mappedfile_isreadlocked(const struct mappedfile *mf);
-extern int mappedfile_iswritelocked(const struct mappedfile *mf);
-extern int mappedfile_iswritable(const struct mappedfile *mf);
-
-extern const char *mappedfile_base(const struct mappedfile *mf);
-extern size_t mappedfile_size(const struct mappedfile *mf);
-extern const struct buf *mappedfile_buf(const struct mappedfile *mf);
-
-extern const char *mappedfile_fname(const struct mappedfile *mf);
+#define mappedfile_islocked(mf) ((mf)->lock_status != MF_UNLOCKED)
+#define mappedfile_isreadlocked(mf) ((mf)->lock_status == MF_READLOCKED)
+#define mappedfile_iswritelocked(mf) ((mf)->lock_status == MF_WRITELOCKED)
+#define mappedfile_iswritable(mf) (!!(mf)->is_rw)
+#define mappedfile_base(mf) ((const char *)((mf)->map_buf.s))
+#define mappedfile_size(mf) ((mf)->map_size)
+#define mappedfile_buf(mf) ((const struct buf *)(&((mf)->map_buf)))
+#define mappedfile_fname(mf) ((const char *)((mf)->fname))
 
 
 #endif /* _MAPPEDFILE_H */
diff -pruN 3.0.13-5/lib/map_shared.c 3.2.0-3/lib/map_shared.c
--- 3.0.13-5/lib/map_shared.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/map_shared.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,15 +45,15 @@
 #include <sys/types.h>
 #include <sys/mman.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "map.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 
 #define SLOP (8*1024)
 
-EXPORTED const char *map_method_desc = "shared";
+EXPORTED const char map_method_desc[] = "shared";
 
 /*
  * Create/refresh mapping of file
@@ -70,7 +70,7 @@ EXPORTED void map_refresh(int fd, int on
             syslog(LOG_ERR, "IOERROR: fstating %s file%s%s: %m", name,
                    mboxname ? " for " : "", mboxname ? mboxname : "");
             snprintf(buf, sizeof(buf), "failed to fstat %s file", name);
-            fatal(buf, EC_IOERR);
+            fatal(buf, EX_IOERR);
         }
         newlen = sbuf.st_size;
     }
@@ -96,7 +96,7 @@ EXPORTED void map_refresh(int fd, int on
         syslog(LOG_ERR, "IOERROR: mapping %s file%s%s: %m", name,
                mboxname ? " for " : "", mboxname ? mboxname : "");
         snprintf(buf, sizeof(buf), "failed to mmap %s file", name);
-        fatal(buf, EC_IOERR);
+        fatal(buf, EX_IOERR);
     }
     *len = newlen;
 }
diff -pruN 3.0.13-5/lib/map_stupidshared.c 3.2.0-3/lib/map_stupidshared.c
--- 3.0.13-5/lib/map_stupidshared.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/map_stupidshared.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,14 +45,13 @@
 #include <sys/types.h>
 #include <sys/mman.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 
-#include "xmalloc.h"
 #include "map.h"
-#include "exitcodes.h"
 #include "xmalloc.h"
 
-EXPORTED const char *map_method_desc = "stupidshared";
+EXPORTED const char map_method_desc[] = "stupidshared";
 
 #ifndef MAP_FAILED
 #define MAP_FAILED ((void *)-1)
@@ -76,7 +75,7 @@ EXPORTED map_refresh(int fd, int onceonl
             syslog(LOG_ERR, "IOERROR: fstating %s file%s%s: %m", name,
                    mboxname ? " for " : "", mboxname ? mboxname : "");
             snprintf(buf, sizeof(buf), "failed to fstat %s file", name);
-            fatal(buf, EC_IOERR);
+            fatal(buf, EX_IOERR);
         }
         newlen = sbuf.st_size;
     }
@@ -99,7 +98,7 @@ EXPORTED map_refresh(int fd, int onceonl
         syslog(LOG_ERR, "IOERROR: mapping %s file%s%s: %m", name,
                mboxname ? " for " : "", mboxname ? mboxname : "");
         snprintf(buf, sizeof(buf), "failed to mmap %s file", name);
-        fatal(buf, EC_IOERR);
+        fatal(buf, EX_IOERR);
     }
     *len = newlen;
 }
diff -pruN 3.0.13-5/lib/mkgmtime.h 3.2.0-3/lib/mkgmtime.h
--- 3.0.13-5/lib/mkgmtime.h	2019-12-06 06:02:55.000000000 +0000
+++ 3.2.0-3/lib/mkgmtime.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,16 +43,8 @@
 #ifndef INCLUDED_MKGMTIME_H
 #define INCLUDED_MKGMTIME_H
 
-#ifndef P
-#ifdef __STDC__
-#define P(x) x
-#else
-#define P(x) ()
-#endif
-#endif
-
 #include <time.h>
 
-extern time_t mkgmtime P((struct tm * const tmp));
+extern time_t mkgmtime(struct tm * const tmp);
 
 #endif /* INCLUDED_MKGMTIME_H */
diff -pruN 3.0.13-5/lib/mpool.c 3.2.0-3/lib/mpool.c
--- 3.0.13-5/lib/mpool.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/mpool.c	2020-04-24 02:03:00.000000000 +0000
@@ -50,10 +50,10 @@
 #include <string.h>
 #include <signal.h>
 #include <stdlib.h>
+#include <sysexits.h>
 
 #include "mpool.h"
 #include "xmalloc.h"
-#include "exitcodes.h"
 
 struct mpool
 {
@@ -98,7 +98,7 @@ EXPORTED void free_mpool(struct mpool *p
 
     if (!pool) return;
     if (!pool->blob) {
-        fatal("memory pool without a blob", EC_TEMPFAIL);
+        fatal("memory pool without a blob", EX_TEMPFAIL);
         return;
     }
 
@@ -130,7 +130,7 @@ EXPORTED void *mpool_malloc(struct mpool
     size_t remain;
 
     if(!pool || !pool->blob) {
-        fatal("mpool_malloc called without a valid pool", EC_TEMPFAIL);
+        fatal("mpool_malloc called without a valid pool", EX_TEMPFAIL);
     }
     if(!size) {
         /* This is legal under ANSI C, so we should allow it too */
diff -pruN 3.0.13-5/lib/nonblock_fcntl.c 3.2.0-3/lib/nonblock_fcntl.c
--- 3.0.13-5/lib/nonblock_fcntl.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/nonblock_fcntl.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,9 +44,9 @@
 #include <sys/types.h>
 #include <sys/file.h>
 #include <fcntl.h>
+#include <sysexits.h>
 
 #include "xmalloc.h"
-#include "exitcodes.h"
 #include "nonblock.h"
 
 #ifndef FNDELAY
@@ -59,7 +59,7 @@
 #define NON_BLOCKING_MODE FNDELAY
 #endif
 
-EXPORTED const char *nonblock_method_desc = "fcntl";
+EXPORTED const char nonblock_method_desc[] = "fcntl";
 
 /*
  * Modifies the non-blocking mode on the file descriptor 'fd'.  If
@@ -71,7 +71,7 @@ EXPORTED void nonblock(int fd, int mode)
     int flags;
 
     flags = fcntl(fd, F_GETFL, 0);
-    if (flags < 0) fatal("Internal error: fcntl F_GETFL failed", EC_IOERR);
+    if (flags < 0) fatal("Internal error: fcntl F_GETFL failed", EX_IOERR);
     if (mode) {
         flags |= NON_BLOCKING_MODE;
     }
diff -pruN 3.0.13-5/lib/nonblock.h 3.2.0-3/lib/nonblock.h
--- 3.0.13-5/lib/nonblock.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/lib/nonblock.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,7 +43,7 @@
 #ifndef INCLUDED_NONBLOCK_H
 #define INCLUDED_NONBLOCK_H
 
-extern const char *nonblock_method_desc;
+extern const char nonblock_method_desc[];
 
 extern void nonblock(int fd, int mode);
 
diff -pruN 3.0.13-5/lib/nonblock_ioctl.c 3.2.0-3/lib/nonblock_ioctl.c
--- 3.0.13-5/lib/nonblock_ioctl.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/nonblock_ioctl.c	2020-04-24 02:03:00.000000000 +0000
@@ -42,14 +42,14 @@
 
 #include <config.h>
 #include <sys/ioctl.h>
+#include <sysexits.h>
 
 #include "nonblock.h"
 
 /* for fatal */
 #include "xmalloc.h"
-#include "exitcodes.h"
 
-EXPORTED const char *nonblock_method_desc = "ioctl";
+EXPORTED const char nonblock_method_desc[] = "ioctl";
 
 /*
  * Modifies the non-blocking mode on the file descriptor 'fd'.  If
@@ -61,6 +61,6 @@ EXPORTED void nonblock(int fd, int mode)
     mode = mode ? 1 : 0;
 
     if (ioctl(fd, FIONBIO, (char *)&mode) < 0) {
-        fatal("Internal error: ioctl FIONBIO failed", EC_SOFTWARE);
+        fatal("Internal error: ioctl FIONBIO failed", EX_SOFTWARE);
     }
 }
diff -pruN 3.0.13-5/lib/parseaddr.c 3.2.0-3/lib/parseaddr.c
--- 3.0.13-5/lib/parseaddr.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/parseaddr.c	2020-04-24 02:03:00.000000000 +0000
@@ -239,6 +239,13 @@ static int parseaddr_phrase(char **inp,
         if (c == '"') {
             while ((c = *src)) {
                 src++;
+                if (c == '\\' && *src == '\r' && *(src+1) == '\n') {
+                    /* Ignore quote right in front of CR+LF. There's no
+                     * point in accepting lone CR or stray LF, and there's
+                     * clients out there that produce these bogus addresses. */
+                    c = *src;
+                    src++;
+                }
                 if (c == '\r' && *src == '\n') {
                     /* CR+LF combination */
                     src++;
diff -pruN 3.0.13-5/lib/prot.c 3.2.0-3/lib/prot.c
--- 3.0.13-5/lib/prot.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/prot.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,6 +44,7 @@
 #include <stdio.h>
 #include <errno.h>
 #include <string.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <signal.h>
 #include <stdarg.h>
@@ -58,7 +59,6 @@
 #endif
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "imparse.h"
 #include "libcyr_cfg.h"
 #include "map.h"
@@ -68,7 +68,7 @@
 #include "util.h"
 #include "xmalloc.h"
 
-/* Transparant protgroup structure */
+/* Transparent protgroup structure */
 struct protgroup
 {
     size_t nalloced; /* Number of nodes in the group */
@@ -417,6 +417,21 @@ error:
     return EOF;
 }
 
+EXPORTED void prot_unsetcompress(struct protstream *s)
+{
+    if (s->zstrm) {
+        if (s->write) deflateEnd(s->zstrm);
+        else inflateEnd(s->zstrm);
+
+        free(s->zstrm);
+        s->zstrm = NULL;
+    }
+    if (s->zbuf) {
+        free(s->zbuf);
+        s->zbuf = NULL;
+    }
+}
+
 /* Table of incompressible file type signatures */
 static struct file_sig {
     const char *type;
@@ -1146,7 +1161,7 @@ int prot_flush_internal(struct protstrea
                     syslog(LOG_ERR, "write to protstream buffer failed: %s",
                            strerror(errno));
 
-                    fatal("write to big buffer failed", EC_OSFILE);
+                    fatal("write to big buffer failed", EX_OSFILE);
                 }
                 if (n > 0) {
                     ptr += n;
@@ -1157,7 +1172,7 @@ int prot_flush_internal(struct protstrea
             /* We did a write to the bigbuffer, refresh the memory map */
             if (fstat(s->big_buffer, &sbuf) == -1) {
                 syslog(LOG_ERR, "IOERROR: fstating temp protlayer buffer: %m");
-                fatal("failed to fstat protlayer buffer", EC_IOERR);
+                fatal("failed to fstat protlayer buffer", EX_IOERR);
             }
 
             s->bigbuf_len = sbuf.st_size;
@@ -1166,7 +1181,7 @@ int prot_flush_internal(struct protstrea
                         s->bigbuf_len, "temp protlayer buffer", NULL);
         }
 
-    } /* end of blocking/nonblocking if statment */
+    } /* end of blocking/nonblocking if statement */
 
     /* Reset the memory buffer -- should be done on EOF or on success. */
     s->ptr = s->buf;
@@ -1377,6 +1392,12 @@ EXPORTED int prot_printamap(struct prots
 
     if (!s) return prot_printf(out, "NIL");
 
+    if (!n) {
+        prot_putc('"', out);
+        prot_putc('"', out);
+        return 2;
+    }
+
     if (imparse_isnatom(s, n) && (n != 3 || memcmp(s, "NIL", 3)))
         return prot_write(out, s, n);
 
@@ -1740,8 +1761,10 @@ EXPORTED struct protstream *protgroup_ge
     return group->group[element];
 }
 
+#ifdef HAVE_DECLARE_OPTIMIZE
 EXPORTED inline int prot_getc(struct protstream *s)
     __attribute__((always_inline,optimize("-O3")));
+#endif
 EXPORTED inline int prot_getc(struct protstream *s)
 {
     assert(!s->write);
@@ -1756,21 +1779,51 @@ EXPORTED inline int prot_getc(struct pro
     return prot_fill(s);
 }
 
-EXPORTED int prot_ungetc(int c, struct protstream *s)
+EXPORTED size_t prot_lookahead(struct protstream *s,
+                               const char *str,
+                               size_t len,
+                               int *sep)
+{
+    assert(!s->write);
+    int short_match = 0;
+
+    if (prot_peek(s) == EOF) return 0;
+
+    if (len >= s->cnt) {
+        len = s->cnt;
+        short_match = 1;
+    }
+
+    if (0 == memcmp(str, s->ptr, len)) {
+        if (!short_match) {
+            *sep = (int) s->ptr[len];
+            return len + 1;
+        }
+        return len;
+    }
+
+    return 0;
+}
+
+#ifdef HAVE_DECLARE_OPTIMIZE
+EXPORTED inline int prot_ungetc(int c, struct protstream *s)
+    __attribute__((always_inline,optimize("-O3")));
+#endif
+EXPORTED inline int prot_ungetc(int c, struct protstream *s)
 {
     assert(!s->write);
 
     if (c == EOF) return EOF;
 
     if (!s->can_unget)
-        fatal("Can't unwind any more", EC_SOFTWARE);
+        fatal("Can't unwind any more", EX_SOFTWARE);
 
     s->cnt++;
     s->can_unget--;
     s->bytes_in--;
     s->ptr--;
     if (*s->ptr != c)
-        fatal("Trying to unput wrong character", EC_SOFTWARE);
+        fatal("Trying to unput wrong character", EX_SOFTWARE);
 
     return c;
 }
diff -pruN 3.0.13-5/lib/prot.h 3.2.0-3/lib/prot.h
--- 3.0.13-5/lib/prot.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/prot.h	2020-04-24 02:03:00.000000000 +0000
@@ -166,6 +166,30 @@ extern int prot_getc(struct protstream *
 extern int prot_ungetc(int c, struct protstream *s);
 extern int prot_putc(int c, struct protstream *s);
 
+#define prot_peek(s) (prot_ungetc(prot_getc(s), s))
+
+/* prot_lookahead checks whether the next several buffered bytes match
+ * the string str (of length len).
+ *
+ * If there are enough buffered bytes available, and they match, then
+ * sep will be set to the first byte following str, and the return
+ * value will be equal to len+1.
+ *
+ * If there are not enough buffered bytes available, but those that
+ * are there match, then sep will remain unset, and the return value
+ * will be within 0 < x <= len, depending on how many matching bytes
+ * were available.
+ *
+ * If there is no match, sep will remain unset and the return value
+ * will be zero, regardless of how many bytes were available.
+ *
+ * The internal buffer will ONLY be filled if it is currently empty.
+ */
+extern size_t prot_lookahead(struct protstream *s,
+                             const char *str,
+                             size_t len,
+                             int *sep);
+
 /* The following two macros control the blocking nature of
  * the protstream.
  *
@@ -223,6 +247,9 @@ int prot_setisclient(struct protstream *
 #ifdef HAVE_ZLIB
 /* Enable (de)compression for a given protstream */
 int prot_setcompress(struct protstream *s);
+
+/* Disable (de)compression for a given protstream */
+void prot_unsetcompress(struct protstream *s);
 #endif /* HAVE_ZLIB */
 
 /* Tell the protstream that the type of data is about to change. */
@@ -235,7 +262,7 @@ extern int prot_settimeout(struct protst
 extern int prot_resettimeout(struct protstream *s);
 
 /* Connect two streams so that when you block on reading s, the layer
- * will automaticly flush flushs */
+ * will automatically flush flushs */
 extern int prot_setflushonread(struct protstream *s,
                                struct protstream *flushs);
 
@@ -262,13 +289,10 @@ extern int prot_flush(struct protstream
 extern int prot_write(struct protstream *s, const char *buf, unsigned len);
 extern int prot_putbuf(struct protstream *s, struct buf *buf);
 extern int prot_puts(struct protstream *s, const char *str);
-extern int prot_vprintf(struct protstream *, const char *, va_list);
+extern int prot_vprintf(struct protstream *, const char *, va_list)
+    __attribute__((format(printf, 2, 0)));
 extern int prot_printf(struct protstream *, const char *, ...)
-#ifdef __GNUC__
-    __attribute__ ((format (printf, 2, 3)));
-#else
-    ;
-#endif
+    __attribute__((format(printf, 2, 3)));
 extern int prot_printliteral(struct protstream *out, const char *s,
                              size_t size);
 extern int prot_printstring(struct protstream *out, const char *s);
diff -pruN 3.0.13-5/lib/ptrarray.c 3.2.0-3/lib/ptrarray.c
--- 3.0.13-5/lib/ptrarray.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/ptrarray.c	2020-04-24 02:03:00.000000000 +0000
@@ -197,6 +197,7 @@ EXPORTED void **ptrarray_takevf(ptrarray
 
 EXPORTED int ptrarray_find(const ptrarray_t *pa, void *match, int starting)
 {
+    if (!pa) return -1;
     int i;
 
     for (i = starting ; i < pa->count ; i++)
@@ -208,11 +209,13 @@ EXPORTED int ptrarray_find(const ptrarra
 EXPORTED void ptrarray_sort(ptrarray_t *pa,
                             int (*compare)(const void **, const void **))
 {
+    if (!pa) return;
     qsort(pa->data, pa->count, sizeof(void*),
             (int (*)(const void *, const void *))compare);
 }
 
 EXPORTED int ptrarray_size(const ptrarray_t *pa)
 {
+    if (!pa) return 0;
     return pa->count;
 }
diff -pruN 3.0.13-5/lib/retry.c 3.2.0-3/lib/retry.c
--- 3.0.13-5/lib/retry.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/retry.c	2020-05-04 03:28:02.000000000 +0000
@@ -44,11 +44,11 @@
 #include <errno.h>
 #include <sys/types.h>
 #include <sys/uio.h>
+#include <sysexits.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
 
-#include "exitcodes.h"
 #include "retry.h"
 #include "xmalloc.h"
 
@@ -159,7 +159,7 @@ EXPORTED ssize_t retry_writev(int fd, co
             n -= iov[i].iov_len;
             iov++;
             iovcnt--;
-            if (!iovcnt) fatal("ran out of iov", EC_SOFTWARE);
+            if (!iovcnt) fatal("ran out of iov", EX_SOFTWARE);
         }
 
         n = writev(fd, iov, iovcnt > iov_max ? iov_max : iovcnt);
diff -pruN 3.0.13-5/lib/retry.h 3.2.0-3/lib/retry.h
--- 3.0.13-5/lib/retry.h	2019-12-06 06:02:55.000000000 +0000
+++ 3.2.0-3/lib/retry.h	2020-04-24 02:03:00.000000000 +0000
@@ -43,20 +43,12 @@
 #ifndef INCLUDED_RETRY_H
 #define INCLUDED_RETRY_H
 
-#ifndef P
-#ifdef __STDC__
-#define P(x) x
-#else
-#define P(x) ()
-#endif
-#endif
-
 #include <sys/types.h>
 #include <sys/uio.h>
 
-extern ssize_t retry_read P((int fd, void *buf, size_t nbyte));
-extern ssize_t retry_write P((int fd, const void *buf, size_t nbyte));
-extern ssize_t retry_writev P((int fd, const struct iovec *iov, int iovcnt));
+extern ssize_t retry_read(int fd, void *buf, size_t nbyte);
+extern ssize_t retry_write(int fd, const void *buf, size_t nbyte);
+extern ssize_t retry_writev(int fd, const struct iovec *iov, int iovcnt);
 
 /* add a buffer 's' of length 'len' to iovec 'iov' */
 #define WRITEV_ADD_TO_IOVEC(iov, num_iov, s, len) \
diff -pruN 3.0.13-5/lib/signals.c 3.2.0-3/lib/signals.c
--- 3.0.13-5/lib/signals.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/signals.c	2020-04-24 02:03:00.000000000 +0000
@@ -45,13 +45,14 @@
 #include <stdlib.h>
 #include <unistd.h>
 #include <signal.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <string.h>
 #include <errno.h>
 
+#include "assert.h"
 #include "signals.h"
 #include "xmalloc.h"
-#include "exitcodes.h"
 #include "util.h"
 
 #ifndef _NSIG
@@ -91,18 +92,18 @@ EXPORTED void signals_add_handlers(int a
 
     /* SIGALRM used as a syscall timeout, so we don't set SA_RESTART */
     if (alarm && sigaction(SIGALRM, &action, NULL) < 0) {
-        fatal("unable to install signal handler for SIGALRM", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGALRM", EX_TEMPFAIL);
     }
 
     /* no restartable SIGQUIT thanks */
     if (sigaction(SIGQUIT, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGQUIT", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGQUIT", EX_TEMPFAIL);
     if (sigaction(SIGINT, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGINT", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGINT", EX_TEMPFAIL);
     if (sigaction(SIGTERM, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGTERM", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGTERM", EX_TEMPFAIL);
     if (sigaction(SIGUSR2, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGUSR2", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGUSR2", EX_TEMPFAIL);
 
     signals_reset_sighup_handler(1);
 }
@@ -124,7 +125,7 @@ EXPORTED void signals_reset_sighup_handl
     action.sa_flags |= SA_SIGINFO;
 
     if (sigaction(SIGHUP, &action, NULL) < 0)
-        fatal("unable to install signal handler for SIGHUP", EC_TEMPFAIL);
+        fatal("unable to install signal handler for SIGHUP", EX_TEMPFAIL);
 }
 
 static shutdownfn *shutdown_cb = NULL;
@@ -198,9 +199,9 @@ static int signals_poll_mask(sigset_t *o
             sigprocmask(SIG_SETMASK, oldmaskp, NULL);
         if (shutdown_cb) {
             signals_in_shutdown = 1;
-            shutdown_cb(EC_TEMPFAIL);
+            shutdown_cb(EX_TEMPFAIL);
         }
-        else exit(EC_TEMPFAIL);
+        else exit(EX_TEMPFAIL);
     }
     for (sig = 1 ; sig < _NSIG ; sig++) {
         if (sig == SIGUSR2) continue; /* only ever polled explicitly */
@@ -224,6 +225,11 @@ EXPORTED int signals_poll(void)
 EXPORTED int signals_select(int nfds, fd_set *rfds, fd_set *wfds,
                             fd_set *efds, struct timeval *tout)
 {
+    if (nfds > 0.9 * FD_SETSIZE) {
+        syslog(LOG_WARNING, "signals_select: nfds = %d/%d", nfds, FD_SETSIZE);
+        assert(nfds < FD_SETSIZE);
+    }
+
 #if HAVE_PSELECT
     /* pselect() closes the race between SIGCHLD arriving
     * and select() sleeping for up to 10 seconds. */
diff -pruN 3.0.13-5/lib/sqldb.c 3.2.0-3/lib/sqldb.c
--- 3.0.13-5/lib/sqldb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/sqldb.c	2020-04-24 02:03:00.000000000 +0000
@@ -110,7 +110,8 @@ static int _version_cb(void *rock, int n
 
 /* Open DAV DB corresponding in file */
 EXPORTED sqldb_t *sqldb_open(const char *fname, const char *initsql,
-                             int version, const struct sqldb_upgrade *upgrade)
+                             int version, const struct sqldb_upgrade *upgrade,
+                             int timeout_ms)
 {
     int rc = SQLITE_OK;
     struct stat sbuf;
@@ -145,7 +146,7 @@ EXPORTED sqldb_t *sqldb_open(const char
     sqlite3_extended_result_codes(open->db, 1);
     sqlite3_trace(open->db, _debug, open->fname);
 
-    sqlite3_busy_timeout(open->db, 20*1000); /* 20 seconds is an eternity */
+    sqlite3_busy_timeout(open->db, timeout_ms);
 
     rc = sqlite3_exec(open->db, "PRAGMA foreign_keys = ON;", NULL, NULL, NULL);
     if (rc != SQLITE_OK) {
@@ -167,9 +168,21 @@ EXPORTED sqldb_t *sqldb_open(const char
         return NULL;
     }
 
+    /* https://sqlite.org/pragma.html#pragma_temp_store
+     * When temp_store is MEMORY (2) temporary tables and indices are
+     * kept in as if they were pure in-memory databases memory.
+     */
+    rc = sqlite3_exec(open->db, "PRAGMA temp_store = 2;", NULL, NULL, NULL);
+    if (rc != SQLITE_OK) {
+        syslog(LOG_ERR, "DBERROR: sqldb_open(%s) enable foreign_keys: %s",
+               open->fname, sqlite3_errmsg(open->db));
+        _free_open(open);
+        return NULL;
+    }
+
     rc = sqlite3_exec(open->db, "PRAGMA user_version;", _version_cb, &open->version, NULL);
     if (rc != SQLITE_OK) {
-        syslog(LOG_ERR, "sqldb_open(%s) get user_version: %s",
+        syslog(LOG_ERR, "DBERROR: sqldb_open(%s) get user_version: %s",
             open->fname, sqlite3_errmsg(open->db));
         _free_open(open);
         return NULL;
@@ -186,7 +199,7 @@ EXPORTED sqldb_t *sqldb_open(const char
         return NULL;
     }
 
-    rc = sqlite3_exec(open->db, "BEGIN IMMEDIATE;", NULL, NULL, NULL);
+    rc = sqlite3_exec(open->db, "BEGIN EXCLUSIVE;", NULL, NULL, NULL);
     if (rc != SQLITE_OK) {
         syslog(LOG_ERR, "DBERROR: sqldb_open(%s) begin: %s",
                open->fname, sqlite3_errmsg(open->db));
@@ -340,7 +353,8 @@ EXPORTED int sqldb_exec(sqldb_t *open, c
     sqlite3_clear_bindings(stmt);
 
     if (!r && rc != SQLITE_DONE) {
-        syslog(LOG_ERR, "sqldb_exec() step: %s", sqlite3_errmsg(open->db));
+        syslog(LOG_ERR, "DBERROR: sqldb_exec() step: %s for (%s: %s)",
+               sqlite3_errmsg(open->db), open->fname, cmd);
         r = -1;
     }
 
@@ -358,7 +372,9 @@ static int _onecmd(sqldb_t *open, const
 EXPORTED int sqldb_begin(sqldb_t *open, const char *name)
 {
     if (!name) name = "DUMMY";
-    int r = _onecmd(open, "SAVEPOINT", name);
+    int r = 0;
+    if (!open->writelock) r = sqldb_writelock(open);
+    if (!r) r = _onecmd(open, "SAVEPOINT", name);
     if (!r) strarray_push(&open->trans, name);
     return r;
 }
@@ -371,6 +387,7 @@ EXPORTED int sqldb_commit(sqldb_t *open,
     int r = _onecmd(open, "RELEASE SAVEPOINT", prev);
     if (r) strarray_push(&open->trans, prev);
     free(prev);
+    if (!r && !open->trans.count) r = sqldb_writecommit(open);
     return r;
 }
 
@@ -381,6 +398,10 @@ EXPORTED int sqldb_rollback(sqldb_t *ope
     if (name) assert(!strcmp(prev, name));
     int r = _onecmd(open, "ROLLBACK TO SAVEPOINT", prev);
     if (r) strarray_push(&open->trans, prev);
+    // it's still commit here even if we rolled back THIS savepoint,
+    // because other savepoints may have committed, so we want to
+    // commit the wrapping transaction
+    if (!r && !open->trans.count) r = sqldb_writecommit(open);
     free(prev);
     return r;
 }
@@ -451,3 +472,28 @@ EXPORTED int sqldb_close(sqldb_t **dbp)
 
     return _free_open(open);
 }
+
+EXPORTED int sqldb_attach(sqldb_t *open, const char *fname)
+{
+    if (open->attached) return SQLITE_MISUSE;
+    struct sqldb_bindval bval[] = {
+        { ":fname",  SQLITE_TEXT, { .s = fname         } },
+        { NULL,      SQLITE_NULL, { .s = NULL          } } };
+
+    struct stat sbuf;
+    if (stat(fname, &sbuf)) return SQLITE_NOTFOUND;
+
+    int r = sqldb_exec(open, "ATTACH DATABASE :fname AS other;", bval, NULL, NULL);
+    if (r) return r;
+    open->attached = 1;
+    return 0;
+}
+
+EXPORTED int sqldb_detach(sqldb_t *open)
+{
+    if (!open->attached) return SQLITE_MISUSE;
+    int r = sqldb_exec(open, "DETACH DATABASE other;", NULL, NULL, NULL);
+    if (r) return r;
+    open->attached = 0;
+    return 0;
+}
diff -pruN 3.0.13-5/lib/sqldb.h 3.2.0-3/lib/sqldb.h
--- 3.0.13-5/lib/sqldb.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/sqldb.h	2020-04-24 02:03:00.000000000 +0000
@@ -65,6 +65,7 @@ struct sqldb {
     int version;
     int refcount;
     int writelock;
+    int attached;
     strarray_t trans;
     ptrarray_t stmts;
     struct sqldb *next;
@@ -84,8 +85,14 @@ int sqldb_init(void);
 /* done with all SQL operations for this process */
 int sqldb_done(void);
 
+#define SQLDB_DEFAULT_TIMEOUT  20000 /* 20 seconds is an eternity */
+
 sqldb_t *sqldb_open(const char *fname, const char *initsql,
-                   int version, const struct sqldb_upgrade *upgradesql);
+                   int version, const struct sqldb_upgrade *upgradesql,
+                   int timeout_ms);
+
+int sqldb_attach(sqldb_t *open, const char *fname);
+int sqldb_detach(sqldb_t *open);
 
 /* execute 'cmd' and process results with 'cb'
    'cmd' is prepared as 'stmt' with 'bval' as bound values */
diff -pruN 3.0.13-5/lib/strarray.c 3.2.0-3/lib/strarray.c
--- 3.0.13-5/lib/strarray.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/strarray.c	2020-04-24 02:03:00.000000000 +0000
@@ -60,11 +60,9 @@ EXPORTED void strarray_fini(strarray_t *
     if (!sa)
         return;
     for (i = 0 ; i < sa->count ; i++) {
-        free(sa->data[i]);
-        sa->data[i] = NULL;
+        xzfree(sa->data[i]);
     }
-    free(sa->data);
-    sa->data = NULL;
+    xzfree(sa->data);
     sa->count = 0;
     sa->alloc = 0;
 }
@@ -91,7 +89,7 @@ static void ensure_alloc(strarray_t *sa,
         return;
     newalloc = ((newalloc + QUANTUM) / QUANTUM) * QUANTUM;
     sa->data = xrealloc(sa->data, sizeof(char *) * newalloc);
-    memset(sa->data+sa->alloc, 0, sizeof(char *) * (newalloc-sa->alloc));
+    memset(sa->data + sa->alloc, 0, sizeof(char *) * (newalloc - sa->alloc));
     sa->alloc = newalloc;
 }
 
@@ -128,7 +126,7 @@ static inline int adjust_index_rw(strarr
          * outside the current bounds, plus perhaps @grow */
         ensure_alloc(sa, idx+grow);
     } else if (idx < 0) {
-        /* adjust Perl-style negative indeces */
+        /* adjust Perl-style negative indices */
         idx += sa->count;
         if (idx >= 0 && grow)
             ensure_alloc(sa, sa->count+grow);
@@ -148,13 +146,13 @@ EXPORTED strarray_t *strarray_dup(const
 
     strarray_truncate(new, sa->count);
     for (i = 0 ; i < sa->count ; i++)
-        new->data[i] = xstrdup(sa->data[i]);
+        new->data[i] = xstrdupnull(sa->data[i]);
     return new;
 }
 
 EXPORTED int strarray_append(strarray_t *sa, const char *s)
 {
-    return strarray_appendm(sa, xstrdup(s));
+    return strarray_appendm(sa, xstrdupnull(s));
 }
 
 EXPORTED void strarray_cat(strarray_t *dest, const strarray_t *src)
@@ -189,7 +187,7 @@ EXPORTED int strarray_appendm(strarray_t
 
 static void _strarray_set(strarray_t *sa, int idx, char *s)
 {
-    free(sa->data[idx]);
+    xfree(sa->data[idx]);
     sa->data[idx] = s;
     /* adjust the count if we just sparsely expanded the array */
     if (s && idx >= sa->count)
@@ -223,7 +221,7 @@ EXPORTED void strarray_insert(strarray_t
 {
     if ((idx = adjust_index_rw(sa, idx, 1)) < 0)
         return;
-    _strarray_insert(sa, idx, xstrdup(s));
+    _strarray_insert(sa, idx, xstrdupnull(s));
 }
 
 EXPORTED void strarray_insertm(strarray_t *sa, int idx, char *s)
@@ -258,6 +256,14 @@ EXPORTED void strarray_remove_all(strarr
     }
 }
 
+EXPORTED void strarray_subtract_complement(strarray_t *sa, const strarray_t *sb)
+{
+    int i;
+    for (i = 0; i < sb->count; i++)
+        strarray_remove_all(sa, strarray_nth(sb, i));
+}
+
+
 EXPORTED void strarray_remove_all_case(strarray_t *sa, const char *s)
 {
     int i = 0;
@@ -281,13 +287,24 @@ EXPORTED void strarray_truncate(strarray
         ensure_alloc(sa, newlen);
     } else {
         for (i = newlen ; i < sa->count ; i++) {
-            free(sa->data[i]);
-            sa->data[i] = NULL;
+            xzfree(sa->data[i]);
         }
     }
     sa->count = newlen;
 }
 
+EXPORTED void strarray_swap(strarray_t *sa, int idxa, int idxb)
+{
+    if (idxa < 0 || idxa >= sa->count)
+        return;
+    if (idxb < 0 || idxb >= sa->count)
+        return;
+
+    char *tmp = sa->data[idxa];
+    sa->data[idxa] = sa->data[idxb];
+    sa->data[idxb] = tmp;
+}
+
 EXPORTED const char *strarray_nth(const strarray_t *sa, int idx)
 {
     if ((idx = adjust_index_ro(sa, idx)) < 0)
@@ -381,6 +398,12 @@ EXPORTED char **strarray_takevf(strarray
     return d;
 }
 
+EXPORTED char **strarray_safetakevf(strarray_t *sa)
+{
+    ensure_alloc(sa, 1); // never return NULL
+    return strarray_takevf(sa);
+}
+
 EXPORTED void strarray_sort(strarray_t *sa, strarray_cmp_fn_t *cmp)
 {
     qsort(sa->data, sa->count, sizeof(char *), cmp);
@@ -419,8 +442,27 @@ EXPORTED int strarray_find_case(const st
     return strarray_findg(sa, match, starting, strcasecmpsafe);
 }
 
+EXPORTED int strarray_intersect(const strarray_t *sa, const strarray_t *sb)
+{
+    int i;
+    for (i = 0; i < sa->count; i++)
+        if (strarray_find(sb, strarray_nth(sa, i), 0) >= 0)
+            return 1;
+    return 0;
+}
+
+EXPORTED int strarray_intersect_case(const strarray_t *sa, const strarray_t *sb)
+{
+    int i;
+    for (i = 0; i < sa->count; i++)
+        if (strarray_find_case(sb, strarray_nth(sa, i), 0) >= 0)
+            return 1;
+    return 0;
+}
+
 EXPORTED int strarray_size(const strarray_t *sa)
 {
+    if (!sa) return 0;
     return sa->count;
 }
 
@@ -440,3 +482,16 @@ EXPORTED int strarray_cmp(const strarray
 
     return 0;
 }
+
+EXPORTED void strarray_addfirst(strarray_t *sa, const char *s)
+{
+    strarray_remove_all(sa, s);
+    strarray_unshift(sa, s);
+
+}
+
+EXPORTED void strarray_addfirst_case(strarray_t *sa, const char *s)
+{
+    strarray_remove_all_case(sa, s);
+    strarray_unshift(sa, s);
+}
diff -pruN 3.0.13-5/lib/strarray.h 3.2.0-3/lib/strarray.h
--- 3.0.13-5/lib/strarray.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/strarray.h	2020-04-24 02:03:00.000000000 +0000
@@ -79,6 +79,10 @@ const char *strarray_safenth(const strar
 void strarray_truncate(strarray_t *sa, int newlen);
 strarray_t *strarray_dup(const strarray_t *);
 void strarray_cat(strarray_t *dest, const strarray_t *src);
+void strarray_swap(strarray_t *, int, int);
+void strarray_addfirst(strarray_t *, const char *);
+void strarray_addfirst_case(strarray_t *, const char *);
+void strarray_subtract_complement(strarray_t *sa, const strarray_t *sb);
 
 #define strarray_shift(sa)          strarray_remove((sa), 0)
 #define strarray_unshift(sa, s)     strarray_insert((sa), 0, (s))
@@ -100,6 +104,7 @@ void strarray_sort(strarray_t *, strarra
 
 void strarray_uniq(strarray_t *);
 
+char **strarray_safetakevf(strarray_t *sa);
 char **strarray_takevf(strarray_t *sa);
 
 int strarray_find(const strarray_t *sa, const char *match,
@@ -107,6 +112,9 @@ int strarray_find(const strarray_t *sa,
 int strarray_find_case(const strarray_t *sa, const char *match,
                        int starting);
 
+int strarray_intersect(const strarray_t *sa, const strarray_t *b);
+int strarray_intersect_case(const strarray_t *sa, const strarray_t *b);
+
 int strarray_size(const strarray_t *sa);
 
 int strarray_cmp(const strarray_t *a, const strarray_t *b);
diff -pruN 3.0.13-5/lib/sysexits.h 3.2.0-3/lib/sysexits.h
--- 3.0.13-5/lib/sysexits.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/sysexits.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-/*
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The name "Carnegie Mellon University" must not be used to
- *    endorse or promote products derived from this software without
- *    prior written permission. For permission or any legal
- *    details, please contact
- *      Carnegie Mellon University
- *      Center for Technology Transfer and Enterprise Creation
- *      4615 Forbes Avenue
- *      Suite 302
- *      Pittsburgh, PA  15213
- *      (412) 268-7393, fax: (412) 268-7395
- *      innovation@andrew.cmu.edu
- *
- * 4. Redistributions of any form whatsoever must retain the following
- *    acknowledgment:
- *    "This product includes software developed by Computing Services
- *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
- *
- * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
- * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
- * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
- * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
- * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-/*
- * Copyright (c) 1987, 1993
- *      The Regents of the University of California.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *      This product includes software developed by the University of
- *      California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- *      @(#)sysexits.h  8.1 (Berkeley) 6/2/93
- */
-
-#ifndef _SYSEXITS_H_
-#define _SYSEXITS_H_
-
-/*
- *  SYSEXITS.H -- Exit status codes for system programs.
- *
- *      This include file attempts to categorize possible error
- *      exit statuses for system programs, notably delivermail
- *      and the Berkeley network.
- *
- *      Error numbers begin at EX__BASE to reduce the possibility of
- *      clashing with other exit statuses that random programs may
- *      already return.  The meaning of the codes is approximately
- *      as follows:
- *
- *      EX_USAGE -- The command was used incorrectly, e.g., with
- *              the wrong number of arguments, a bad flag, a bad
- *              syntax in a parameter, or whatever.
- *      EX_DATAERR -- The input data was incorrect in some way.
- *              This should only be used for user's data & not
- *              system files.
- *      EX_NOINPUT -- An input file (not a system file) did not
- *              exist or was not readable.  This could also include
- *              errors like "No message" to a mailer (if it cared
- *              to catch it).
- *      EX_NOUSER -- The user specified did not exist.  This might
- *              be used for mail addresses or remote logins.
- *      EX_NOHOST -- The host specified did not exist.  This is used
- *              in mail addresses or network requests.
- *      EX_UNAVAILABLE -- A service is unavailable.  This can occur
- *              if a support program or file does not exist.  This
- *              can also be used as a catchall message when something
- *              you wanted to do doesn't work, but you don't know
- *              why.
- *      EX_SOFTWARE -- An internal software error has been detected.
- *              This should be limited to non-operating system related
- *              errors as possible.
- *      EX_OSERR -- An operating system error has been detected.
- *              This is intended to be used for such things as "cannot
- *              fork", "cannot create pipe", or the like.  It includes
- *              things like getuid returning a user that does not
- *              exist in the passwd file.
- *      EX_OSFILE -- Some system file (e.g., /etc/passwd, /etc/utmp,
- *              etc.) does not exist, cannot be opened, or has some
- *              sort of error (e.g., syntax error).
- *      EX_CANTCREAT -- A (user specified) output file cannot be
- *              created.
- *      EX_IOERR -- An error occurred while doing I/O on some file.
- *      EX_TEMPFAIL -- temporary failure, indicating something that
- *              is not really an error.  In sendmail, this means
- *              that a mailer (e.g.) could not create a connection,
- *              and the request should be reattempted later.
- *      EX_PROTOCOL -- the remote system returned something that
- *              was "not possible" during a protocol exchange.
- *      EX_NOPERM -- You did not have sufficient permission to
- *              perform the operation.  This is not intended for
- *              file system problems, which should use NOINPUT or
- *              CANTCREAT, but rather for higher level permissions.
- */
-
-#define EX_OK           0       /* successful termination */
-
-#define EX__BASE        64      /* base value for error messages */
-
-#define EX_USAGE        64      /* command line usage error */
-#define EX_DATAERR      65      /* data format error */
-#define EX_NOINPUT      66      /* cannot open input */
-#define EX_NOUSER       67      /* addressee unknown */
-#define EX_NOHOST       68      /* host name unknown */
-#define EX_UNAVAILABLE  69      /* service unavailable */
-#define EX_SOFTWARE     70      /* internal software error */
-#define EX_OSERR        71      /* system error (e.g., can't fork) */
-#define EX_OSFILE       72      /* critical OS file missing */
-#define EX_CANTCREAT    73      /* can't create (user) output file */
-#define EX_IOERR        74      /* input/output error */
-#define EX_TEMPFAIL     75      /* temp failure; user is invited to retry */
-#define EX_PROTOCOL     76      /* remote error in protocol */
-#define EX_NOPERM       77      /* permission denied */
-#define EX_CONFIG       78      /* configuration error */
-
-#define EX__MAX 78      /* maximum listed value */
-
-#endif /* !_SYSEXITS_H_ */
diff -pruN 3.0.13-5/lib/test/cyrusdb.c 3.2.0-3/lib/test/cyrusdb.c
--- 3.0.13-5/lib/test/cyrusdb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/test/cyrusdb.c	2020-04-24 02:03:00.000000000 +0000
@@ -65,7 +65,7 @@ int main(int argc, char *argv[])
     int txnp = 0;
     int r;
 
-    printf("Initing enviornment in '.'...\n");
+    printf("Initing environment in '.'...\n");
     TRY(DB->init(".", 0));
     printf("Ready!\n");
 
diff -pruN 3.0.13-5/lib/times.c 3.2.0-3/lib/times.c
--- 3.0.13-5/lib/times.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/times.c	2020-04-24 02:03:00.000000000 +0000
@@ -52,15 +52,56 @@
 #include "gmtoff.h"
 #include "mkgmtime.h"
 
-static const char * const monthname[12] = {
+EXPORTED const char monthname[][4] = {
     "Jan", "Feb", "Mar", "Apr", "May", "Jun",
     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
 };
-static const char * const wday[7] = {
+EXPORTED const char wday[][4] = {
     "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
 };
 
 
+#define EOB (-1)            /* End Of Buffer */
+
+static const char rfc5322_special[256] = {
+    [' ']  = 1,
+    ['\t'] = 1,
+    ['\r'] = 1,
+    ['\n'] = 1,
+};
+
+static const char rfc5322_separators[256] = {
+    [' ']  = 1,
+    [',']  = 1,
+    ['-']  = 1,
+    ['+']  = 1,
+    [':']  = 1,
+};
+
+enum {
+    Alpha = 1,              /* Alphabet */
+    UAlpha = 2,             /* Uppercase Alphabet */
+    LAlpha = 4,             /* Lowercase Alphabet */
+    Digit = 8,              /* Digits/Numbers */
+    TZSign = 16,            /* Timzone sign +/- */
+};
+
+static const long rfc5322_usascii_charset[257] = {
+    ['0' + 1 ... '9' + 1] = Digit,
+    ['A' + 1 ... 'Z' + 1] = Alpha | UAlpha,
+    ['a' + 1 ... 'z' + 1] = Alpha | LAlpha,
+    ['+' + 1] = TZSign,
+    ['-' + 1] = TZSign
+};
+
+struct rfc5322dtbuf {
+    const char *str;
+    int len;
+    int offset;
+};
+
+#define isleap(year) (!((year) % 4) && (((year) % 100) || !((year) % 400)))
+
 static int monthdays(int year/*since 1900*/, int month/*0-based*/)
 {
     int leapday;
@@ -69,12 +110,32 @@ static int monthdays(int year/*since 190
         31, 31, 30, 31, 30, 31
     };
 
-#define isleap(year) (!((year) % 4) && (((year) % 100) || !((year) % 400)))
     leapday = (month == 1 && isleap(year+1900));
     return mdays[month] + leapday;
-#undef isleap
 }
 
+static int dayofyear(int year/*since 1900*/, int month/*0-based*/, int day)
+{
+    static const int ydays[2][13] = {
+        {0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334},
+        {0, 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335}
+    };
+    return ydays[isleap(year+1900)][month+1] + day;
+}
+
+#undef isleap
+
+static int dayofweek(int year/*since 1900*/, int month/*0-based*/, int day)
+{
+    /* Uses Zeller's congruence for the Gregorian calendar
+     * https://en.wikipedia.org/wiki/Zeller%27s_congruence
+     * h is the day of the week with Saturday = 0 */
+    int q = day; // day of month
+    int m = month <= 1 ? month + 13 : month + 1; // month, (3 = March, 4 = April, ..., 14 = February)
+    int Y = month <= 1 ? 1900 + year - 1 : 1900 + year; // year
+    int h = (q + ((13 * (m + 1)) / 5) + Y + (Y / 4) - (Y / 100) + (Y / 400)) % 7;
+    return (h + 6) % 7;
+}
 
 /* 'buf' must be at least 80 characters */
 EXPORTED int time_to_rfc822(time_t t, char *buf, size_t len)
@@ -384,22 +445,38 @@ EXPORTED int day_from_rfc822(const char
     return parse_rfc822(s, tp, 1);
 }
 
+static int offsettime_normalize(struct offsettime *t)
+{
+    /* sanity check the date/time (including leap day & second) */
+    if (t->tm.tm_mon < 0 || t->tm.tm_mon > 11 ||
+        t->tm.tm_mday < 1 ||
+        t->tm.tm_mday > monthdays(t->tm.tm_year, t->tm.tm_mon) ||
+        t->tm.tm_hour > 23 || t->tm.tm_min > 59 || t->tm.tm_sec > 60) {
+        return 0;
+    }
+    /* Set day of week and year fields */
+    t->tm.tm_wday = dayofweek(t->tm.tm_year, t->tm.tm_mon, t->tm.tm_mday);
+    t->tm.tm_yday = dayofyear(t->tm.tm_year, t->tm.tm_mon, t->tm.tm_mday);
+    t->tm.tm_isdst = -1;
+    return 1;
+}
+
 /*
- * Parse an RFC 3339 = ISO 8601 format date-time string.
+ * Parse an RFC 3339 = ISO 8601 format date-time string,
+ * preserving the zone offset.
  * Returns: number of characters in @s consumed, or -1 on error.
  */
-EXPORTED int time_from_iso8601(const char *s, time_t *tp)
+EXPORTED int offsettime_from_iso8601(const char *s, struct offsettime *t)
 {
     const char *origs = s;
-    struct tm exp;
-    int n, tm_off;
+    int n;
 
     /* parse the ISO 8601 date/time */
     /* XXX should use strptime ? */
-    memset(&exp, 0, sizeof(struct tm));
+    memset(t, 0, sizeof(struct offsettime));
     n = sscanf(s, "%4d-%2d-%2dT%2d:%2d:%2d",
-               &exp.tm_year, &exp.tm_mon, &exp.tm_mday,
-               &exp.tm_hour, &exp.tm_min, &exp.tm_sec);
+               &t->tm.tm_year, &t->tm.tm_mon, &t->tm.tm_mday,
+               &t->tm.tm_hour, &t->tm.tm_min, &t->tm.tm_sec);
     if (n != 6)
         return -1;
 
@@ -411,48 +488,58 @@ EXPORTED int time_from_iso8601(const cha
 
     /* handle offset */
     switch (*s++) {
-    case 'Z': tm_off = 0; break;
-    case '-': tm_off = -1; break;
-    case '+': tm_off = 1; break;
+    case 'Z': t->tm_off = 0; break;
+    case '-': t->tm_off = -1; break;
+    case '+': t->tm_off = 1; break;
     default: return -1;
     }
-    if (tm_off) {
+    if (t->tm_off) {
         int tm_houroff, tm_minoff;
 
         n = sscanf(s, "%2d:%2d", &tm_houroff, &tm_minoff);
         if (n != 2)
             return -1;
-        tm_off *= 60 * (60 * tm_houroff + tm_minoff);
+        t->tm_off *= 60 * (60 * tm_houroff + tm_minoff);
         s += 5;
     }
 
-    exp.tm_year -= 1900; /* normalize to years since 1900 */
-    exp.tm_mon--; /* normalize to months since January */
+    t->tm.tm_year -= 1900; /* normalize to years since 1900 */
+    t->tm.tm_mon--; /* normalize to months since January */
 
-    /* sanity check the date/time (including leap day & second) */
-    if (exp.tm_year < 70 || exp.tm_mon < 0 || exp.tm_mon > 11 ||
-        exp.tm_mday < 1 ||
-        exp.tm_mday > monthdays(exp.tm_year, exp.tm_mon) ||
-        exp.tm_hour > 23 || exp.tm_min > 59 || exp.tm_sec > 60) {
+    if (!offsettime_normalize(t))
         return -1;
-    }
 
-    /* normalize to GMT */
-    *tp = mkgmtime(&exp) - tm_off;
     return s - origs;
 }
 
+
+/*
+ * Parse an RFC 3339 = ISO 8601 format date-time string.
+ * Returns: number of characters in @s consumed, or -1 on error.
+ */
+EXPORTED int time_from_iso8601(const char *s, time_t *tp)
+{
+    struct offsettime ot;
+
+    int r = offsettime_from_iso8601(s, &ot);
+    if (r < 0) return r;
+
+    /* normalize to GMT */
+    *tp = mkgmtime(&ot.tm) - ot.tm_off;
+    return r;
+}
+
 static int breakdown_time_to_iso8601(const struct timeval *t, struct tm *tm,
                                      enum timeval_precision tv_precision,
-                                     char *buf, size_t len, int withsep)
+                                     long gmtoff, char *buf, size_t len,
+                                     int withsep)
 {
-    long gmtoff = gmtoff_of(tm, t->tv_sec);
     int gmtnegative = 0;
     size_t rlen;
     const char *datefmt = withsep ? "%Y-%m-%dT%H:%M:%S" : "%Y%m%dT%H%M%S";
 
     /*assert(date > 0); - it turns out these can happen, annoyingly enough */
-    assert(tm->tm_year >= 69);
+    /*assert(tm->tm_year >= 69);*/
 
     if (gmtoff < 0) {
         gmtoff = -gmtoff;
@@ -493,8 +580,15 @@ EXPORTED int time_to_iso8601(time_t t, c
 {
     struct tm *tm = (struct tm *) gmtime(&t);
     struct timeval tv = { t, 0 };
+    long gmtoff = gmtoff_of(tm, tv.tv_sec);
 
-    return breakdown_time_to_iso8601(&tv, tm, timeval_s, buf, len, withsep);
+    return breakdown_time_to_iso8601(&tv, tm, timeval_s, gmtoff, buf, len, withsep);
+}
+
+EXPORTED int offsettime_to_iso8601(struct offsettime *t, char *buf, size_t len, int withsep)
+{
+    struct timeval tv = { mktime(&t->tm), 0 };
+    return breakdown_time_to_iso8601(&tv, &t->tm, timeval_s, t->tm_off, buf, len, withsep);
 }
 
 /*
@@ -507,14 +601,15 @@ EXPORTED int timeval_to_iso8601(const st
                        char *buf, size_t len)
 {
     struct tm *tm = localtime(&(tv->tv_sec));
-    return breakdown_time_to_iso8601(tv, tm, tv_prec, buf, len, 1);
+    long gmtoff = gmtoff_of(tm, tv->tv_sec);
+    return breakdown_time_to_iso8601(tv, tm, tv_prec, gmtoff, buf, len, 1);
 }
 
 EXPORTED int time_to_rfc3339(time_t t, char *buf, size_t len)
 {
     struct tm *tm = gmtime(&t);
 
-    return snprintf(buf, len, "%4d-%02d-%02dT%02d:%02d:%02dZ",
+    return snprintf(buf, len, "%04d-%02d-%02dT%02d:%02d:%02dZ",
                     tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
                     tm->tm_hour, tm->tm_min, tm->tm_sec);
 }
@@ -560,12 +655,12 @@ EXPORTED int time_to_rfc3501(time_t date
  *
  *  "dd-mmm-yyyy HH:MM:SS zzzzz"
  *  " d-mmm-yyyy HH:MM:SS zzzzz"
- *  "dd-mmm-yy HH:MM:SS-z"
- *  " d-mmm-yy HH:MM:SS-z"
- *  "dd-mmm-yy HH:MM:SS-zz"
- *  " d-mmm-yy HH:MM:SS-zz"
- *  "dd-mmm-yy HH:MM:SS-zzz"
- *  " d-mmm-yy HH:MM:SS-zzz"
+ *  "dd-mmm-yy HH:MM:SS z"
+ *  " d-mmm-yy HH:MM:SS z"
+ *  "dd-mmm-yy HH:MM:SS zz"
+ *  " d-mmm-yy HH:MM:SS zz"
+ *  "dd-mmm-yy HH:MM:SS zzz"
+ *  " d-mmm-yy HH:MM:SS zzz"
  *
  * where:
  *  dd  is the day-of-month between 1 and 31 inclusive.
@@ -748,7 +843,7 @@ EXPORTED int time_from_rfc3501(const cha
 
     /* Time zone */
     if (old_format) {
-        if (c != '-')
+        if (c != ' ')
             goto baddate;
         c = *s++;
 
@@ -854,3 +949,513 @@ baddate:
     return -1;
 }
 
+/**
+ ** Support functions for time_from_rfc5322()
+ **/
+static inline int get_next_char(struct rfc5322dtbuf *buf)
+{
+    int c;
+
+    if (buf->offset < buf->len) {
+        buf->offset++;
+        c = buf->str[buf->offset];
+        return c;
+    }
+
+    return EOB;
+}
+
+static inline int get_current_char(struct rfc5322dtbuf *buf)
+{
+    int offset = buf->offset;
+
+    if (offset < buf->len)
+        return buf->str[offset];
+    else
+        return EOB;
+}
+
+/*
+  TODO: Support comments as per RFC.
+*/
+static int skip_ws(struct rfc5322dtbuf *buf,
+                   int skipcomment __attribute__((unused)))
+{
+    int c = buf->str[buf->offset];
+
+    while (c != EOB) {
+        if (rfc5322_special[c]) {
+            c = get_next_char(buf);
+            continue;
+        }
+
+        break;
+    }
+
+    return 1;
+}
+
+static int get_next_token(struct rfc5322dtbuf *buf, char **str, int *len)
+{
+    int c, ret = 1;
+    long ch;
+    static char cache[RFC5322_DATETIME_MAX];
+
+    memset(cache, 1, RFC5322_DATETIME_MAX);
+
+    c = get_current_char(buf);
+    if (c == EOB) {
+        ret = 0;
+        goto failed;
+    }
+
+    *len = 0;
+    for (;;) {
+        if (rfc5322_special[c] || rfc5322_separators[c])
+            break;
+
+        ch = rfc5322_usascii_charset[c + 1];
+        if (!(ch & (Alpha | Digit)))
+            break;
+
+        if (*len >= RFC5322_DATETIME_MAX)
+            break;
+
+        cache[*len] = c;
+        *len += 1;
+
+        c = get_next_char(buf);
+        if (c == EOB) {
+            ret = 0;
+            break;
+        }
+    }
+
+ failed:
+    *str = cache;
+
+    return ret;
+}
+
+static inline int to_int(char *str, int len)
+{
+    int i, num = 0;
+
+    for (i = 0; i < len; i++) {
+        if (rfc5322_usascii_charset[str[i] + 1] & Digit)
+            num = num * 10 + (str[i] - '0');
+        else {
+            num = -9999;
+            break;
+        }
+    }
+
+    return num;
+}
+
+static inline int to_upper(char ch)
+{
+    if (rfc5322_usascii_charset[ch + 1] & LAlpha)
+        ch =  ch - 32;
+
+    return ch;
+}
+
+static inline int to_lower(char ch)
+{
+    if (rfc5322_usascii_charset[ch + 1] & UAlpha)
+        ch = ch + 32;
+
+    return ch;
+}
+
+static int compute_tzoffset(char *str, int len, int sign)
+{
+    int offset = 0;
+
+    if (len == 1) {         /* Military timezone */
+        int ch;
+        ch = to_upper(str[0]);
+        if (ch < 'J')
+            return (str[0] - 'A' + 1) * 60;
+        if (ch == 'J')
+            return 0;
+        if (ch <= 'M')
+            return (str[0] - 'A') * 60;;
+        if (ch < 'Z')
+            return ('M' - str[0]) * 60;
+
+        return 0;
+    }
+
+    if (len == 2 &&
+        to_upper(str[0]) == 'U' &&
+        to_upper(str[1]) == 'T') {         /* Universal Time zone (UT) */
+        return 0;
+    }
+
+    if (len == 3) {
+        char *p;
+
+        if (to_upper(str[2]) != 'T')
+            return 0;
+
+        p = strchr("AECMPYHB", to_upper(str[0]));
+        if (!p)
+            return 0;
+        offset = (strlen(p) - 12) *  60;
+
+        if (to_upper(str[1]) == 'D')
+            return offset + 60;
+        if (to_upper(str[1]) == 'S')
+            return offset;
+    }
+
+    if (len == 4) {         /* The number timezone offset */
+        int i;
+
+        for (i = 0; i < len; i++) {
+            if (!(rfc5322_usascii_charset[str[i] + 1] & Digit))
+                return 0;
+        }
+
+        offset = ((str[0] - '0') * 10 + (str[1] - '0')) * 60 +
+            (str[2] - '0') * 10 +
+            (str[3] - '0');
+
+        return (sign == '+') ? offset : -offset;
+    }
+
+    return 0;
+}
+
+/*
+ *  Date Format as per https://tools.ietf.org/html/rfc5322#section-3.3:
+ *
+ * date-time = [ ([FWS] day-name) "," ]
+ *             ([FWS] 1*2DIGIT FWS)
+ *             month
+ *             (FWS 4*DIGIT FWS)
+ *             2DIGIT ":" 2DIGIT [ ":" 2DIGIT ]
+ *             (FWS ( "+" / "-" ) 4DIGIT)
+ *             [CFWS]
+ *
+ * day-name = "Mon" / "Tue" / "Wed" / "Thu" / "Fri" / "Sat" / "Sun"
+ * month = "Jan" / "Feb" / "Mar" / "Apr" / "May" / "Jun" / "Jul" / "Aug" /
+ *         "Sep" / "Oct" / "Nov" / "Dec"
+ *
+ */
+
+static int tokenise_str_and_create_tm(struct rfc5322dtbuf *buf, struct tm *tm,
+                                      long *tz_offset,
+                                      enum datetime_parse_mode mode)
+{
+    long ch;
+    int c, i, len;
+    char *str_token = NULL;
+
+
+    /* Skip leading WS, if any */
+    skip_ws(buf, 0);
+
+    c = get_current_char(buf);
+    if (c == EOB)
+        goto failed;
+
+    ch = rfc5322_usascii_charset[c + 1];
+    if (ch & Alpha) {       /* Most likely a weekday at the start. */
+        if (!get_next_token(buf, &str_token, &len))
+            goto failed;
+
+        /* We might have a weekday token here */
+        if (len != 3)
+            goto failed;
+
+        /* Determine week day */
+        int i ;
+        for (i = 0; i < 7; i++) {
+            if (!strncasecmp(wday[i], str_token, len)) {
+                tm->tm_wday = i;
+                break;
+            }
+        }
+
+        /* The weekday is followed by a ',', consume that. */
+        if (get_current_char(buf) == ',')
+            get_next_char(buf);
+        else
+            goto failed;
+
+        skip_ws(buf, 0);
+    }
+
+    /** DATE **/
+    /* date (1 or 2 digits) */
+    if (!get_next_token(buf, &str_token, &len))
+        goto failed;
+
+    if (len < 1 || len > 2 ||
+        !(rfc5322_usascii_charset[str_token[0] + 1] & Digit))
+        goto failed;
+
+    tm->tm_mday = to_int(str_token, len);
+    if (tm->tm_mday == -9999)
+        goto failed;
+
+    /* the separator here is either '-' or FWS */
+    c = get_next_char(buf);
+    if (rfc5322_special[c])
+        skip_ws(buf, 0);
+
+    /* month name */
+    if (!get_next_token(buf, &str_token, &len) ||
+        len != 3 ||
+        !(rfc5322_usascii_charset[str_token[0] + 1] & Alpha))
+        goto failed;
+
+    str_token[0] = to_upper(str_token[0]);
+    str_token[1] = to_lower(str_token[1]);
+    str_token[2] = to_lower(str_token[2]);
+    for (i = 0; i < 12; i++) {
+        if (memcmp(monthname[i], str_token, 3) == 0) {
+            tm->tm_mon = i;
+            break;
+        }
+    }
+    if (i == 12)
+        goto failed;
+
+    /* the separator here is either '-' or FWS */
+    c = get_next_char(buf);
+    if (rfc5322_special[c])
+        skip_ws(buf, 0);
+
+    /* year 2, 4 or >4 digits */
+    if (!get_next_token(buf, &str_token, &len))
+        goto failed;
+
+    tm->tm_year = to_int(str_token, len);
+    if (tm->tm_year == -9999)
+        goto failed;
+
+    if (len == 2) {
+        /* A 2 digit year */
+        if (tm->tm_year < 70)
+            tm->tm_year += 100;
+    } else {
+        if (tm->tm_year < 1900)
+            goto failed;
+        tm->tm_year -= 1900;
+    }
+
+    if (mode == DATETIME_DATE_ONLY) {
+        *tz_offset = 0;
+        goto done;
+    }
+
+    /** TIME **/
+    skip_ws(buf, 0);
+    /* hour */
+    if (!get_next_token(buf, &str_token, &len))
+        goto failed;
+
+    if (len < 1 || len > 2 ||
+        !(rfc5322_usascii_charset[str_token[0] + 1] & Digit))
+        goto failed;
+
+    tm->tm_hour = to_int(str_token, len);
+    if (tm->tm_hour == -9999)
+        goto failed;
+
+    /* minutes */
+    if (get_current_char(buf) == ':' ||
+        get_current_char(buf) == '.')
+        get_next_char(buf); /* Consume ':'/'.' */
+    else
+        goto failed;    /* Something is broken */
+
+    if (!get_next_token(buf, &str_token, &len))
+        goto failed;
+
+    if (len < 1 || len > 2 ||
+        !(rfc5322_usascii_charset[str_token[0] + 1] & Digit))
+        goto failed;
+
+    tm->tm_min = to_int(str_token, len);
+    if (tm->tm_min == -9999)
+        goto failed;
+
+
+    /* seconds[optional] */
+    if (get_current_char(buf) == ':' ||
+        get_current_char(buf) == '.') {
+        get_next_char(buf); /* Consume ':'/'.' */
+
+        if (!get_next_token(buf, &str_token, &len))
+            goto failed;
+
+        if (len < 1 || len > 2 ||
+            !(rfc5322_usascii_charset[str_token[0] + 1] & Digit))
+            goto failed;
+
+        tm->tm_sec = to_int(str_token, len);
+        if (tm->tm_sec == -9999)
+            goto failed;
+
+    }
+
+    /* timezone */
+    skip_ws(buf, 0);
+    c = get_current_char(buf);
+    if (c == '+' || c == '-') {    /* the '+' or '-' in the timezone */
+        get_next_char(buf);        /* consume '+' or '-' */
+    }
+
+    if (!get_next_token(buf, &str_token, &len)) {
+        *tz_offset = 0;
+    } else {
+        *tz_offset = compute_tzoffset(str_token, len, c);
+    }
+
+ done:
+    /* dst */
+    tm->tm_isdst = -1;
+    *tz_offset *= 60;
+    return buf->offset;
+
+ failed:
+    return -1;
+}
+
+
+/*
+ * time_from_rfc5322()
+ * This is meant to be the replacement function for time_from_rfc822() and
+ * time_from_rfc3501() functions.
+ *
+ * The argument `mode` is set to `DATETIME_DATE_ONLY` when we don't want to
+ * parse the time and timezone parts of the RFC5322 date-time string. This is
+ * a hack designed to support the Cyrus implementation of the IMAP SEARCH
+ * command.
+ * For all other cases, the mode should be set to `DATETIME_FULL`.
+ *
+ * Returns: Number of characters consumed from @s on success,
+ *          or -1 on error.
+ */
+EXPORTED int time_from_rfc5322(const char *s, time_t *date,
+                               enum datetime_parse_mode mode)
+{
+    struct rfc5322dtbuf buf;
+    struct tm tm;
+    time_t tmp_time;
+    long tzone_offset = 0;
+
+    if (!s)
+        goto baddate;
+
+    memset(&tm, 0, sizeof(struct tm));
+    *date = 0;
+
+    buf.str = s;
+    buf.len = strlen(s);
+    buf.offset = 0;
+
+    if (tokenise_str_and_create_tm(&buf, &tm, &tzone_offset, mode) == -1)
+        goto baddate;
+
+    if (mode == DATETIME_DATE_ONLY)
+        tmp_time = mktime(&tm);
+    else
+        tmp_time = mkgmtime(&tm);
+
+    if (tmp_time == -1)
+        goto baddate;
+
+    *date = tmp_time - tzone_offset;
+
+    return buf.offset;
+
+ baddate:
+    return -1;
+}
+
+/*
+ * Parse a RFC 5322 timestamp into an offset time.
+ * Wrong week days are ignored.
+ *
+ * Returns: Number of characters consumed from @s on success,
+ *          or -1 on error.
+ */
+EXPORTED int offsettime_from_rfc5322(const char *s, struct offsettime *t,
+                                     enum datetime_parse_mode mode)
+{
+    struct rfc5322dtbuf buf;
+
+    if (!s)
+        goto baddate;
+
+    memset(t, 0, sizeof(struct offsettime));
+
+    buf.str = s;
+    buf.len = strlen(s);
+    buf.offset = 0;
+
+    if (tokenise_str_and_create_tm(&buf, &t->tm, &t->tm_off, mode) == -1)
+        goto baddate;
+
+    if (!offsettime_normalize(t))
+        goto baddate;
+
+    return buf.offset;
+
+ baddate:
+    return -1;
+}
+
+/*
+ * time_to_rfc5322()
+ * Convert a time_t date to an IMAP-style date.
+ * `buf` which is the buffer this function is going to write into, needs to
+ * be atleast RFC5322_DATETIME_MAX (32), if not more.
+ *
+ */
+EXPORTED int time_to_rfc5322(time_t date, char *buf, size_t len)
+{
+    struct tm *tm = localtime(&date);
+    long gmtoff = gmtoff_of(tm, date);
+    int gmtnegative = 0;
+
+    if (gmtoff < 0) {
+        gmtoff = -gmtoff;
+        gmtnegative = 1;
+    }
+
+    gmtoff /= 60;
+
+    return snprintf(buf, len,
+             "%s, %02d %s %04d %02d:%02d:%02d %c%02lu%02lu",
+             wday[tm->tm_wday],
+             tm->tm_mday, monthname[tm->tm_mon], tm->tm_year + 1900,
+             tm->tm_hour, tm->tm_min, tm->tm_sec,
+             gmtnegative ? '-' : '+', gmtoff/60, gmtoff%60);
+}
+
+EXPORTED int offsettime_to_rfc5322(struct offsettime *t, char *buf, size_t len)
+{
+    long gmtoff = t->tm_off;
+    int gmtnegative = 0;
+
+    if (gmtoff < 0) {
+        gmtoff = -gmtoff;
+        gmtnegative = 1;
+    }
+
+    gmtoff /= 60;
+
+    return snprintf(buf, len,
+             "%s, %02d %s %04d %02d:%02d:%02d %c%02lu%02lu",
+             wday[t->tm.tm_wday],
+             t->tm.tm_mday, monthname[t->tm.tm_mon], t->tm.tm_year + 1900,
+             t->tm.tm_hour, t->tm.tm_min, t->tm.tm_sec,
+             gmtnegative ? '-' : '+', gmtoff/60, gmtoff%60);
+}
diff -pruN 3.0.13-5/lib/times.h 3.2.0-3/lib/times.h
--- 3.0.13-5/lib/times.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/times.h	2020-04-24 02:03:00.000000000 +0000
@@ -49,10 +49,19 @@
 /* Factor for converting days to seconds. */
 #define DAY2SEC (24 * 60 * 60)
 
+extern const char monthname[][4];
+extern const char wday[][4];
+
 /* Default precision to print timeval is millisecond (timeval_ms)
  * change to timeval_us in times.c to print microsecond. */
 enum timeval_precision { timeval_s, timeval_ms, timeval_us };
 
+/* Date-time value with offset time */
+struct offsettime {
+    struct tm tm;
+    long tm_off;  /* offset in seconds */
+};
+
 /*
  * RFC822 datetime format
  */
@@ -71,6 +80,8 @@ int time_from_iso8601(const char *s, tim
 int time_to_iso8601(time_t t, char *buf, size_t len, int withsep);
 int timeval_to_iso8601(const struct timeval *t, enum timeval_precision tv_prec,
                        char *buf, size_t len);
+int offsettime_from_iso8601(const char *s, struct offsettime *);
+int offsettime_to_iso8601(struct offsettime *t, char *buf, size_t len, int withsep);
 
 /*
  * RFC3501 datetime format
@@ -85,4 +96,17 @@ int time_from_rfc3501(const char *s, tim
 #define RFC3339_DATETIME_MAX 21
 int time_to_rfc3339(time_t t, char *buf, size_t len);
 
+/*
+ * RFC5322 datetime format
+ */
+enum datetime_parse_mode {
+    DATETIME_DATE_ONLY = 0,
+    DATETIME_FULL,
+};
+#define RFC5322_DATETIME_MAX 32 /* 32 because we support 5 digit year format */
+int time_from_rfc5322(const char *s, time_t *date, enum datetime_parse_mode mode);
+int time_to_rfc5322(time_t date, char *buf, size_t len);
+int offsettime_from_rfc5322(const char *s, struct offsettime *t, enum datetime_parse_mode mode);
+int offsettime_to_rfc5322(struct offsettime *t, char *buf, size_t len);
+
 #endif /* __CYRUS__TIME_H__ */
diff -pruN 3.0.13-5/lib/util.c 3.2.0-3/lib/util.c
--- 3.0.13-5/lib/util.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/util.c	2020-05-04 03:28:02.000000000 +0000
@@ -50,6 +50,7 @@
 #include <pwd.h>
 #include <string.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -63,13 +64,13 @@
 #ifdef HAVE_STDINT_H
 #include <stdint.h>
 #endif
+#include <time.h>
 
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netinet/tcp.h>
 
 #include "byteorder64.h"
-#include "exitcodes.h"
 #include "libconfig.h"
 #include "map.h"
 #include "retry.h"
@@ -79,9 +80,6 @@
 #ifdef HAVE_ZLIB
 #include "zlib.h"
 #endif
-#ifdef HAVE_LIBUUID
-#include <uuid/uuid.h>
-#endif
 
 
 #define BEAUTYBUFSIZE 4096
@@ -175,6 +173,84 @@ const unsigned char convert_to_uppercase
     0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff
 };
 
+static const uint16_t lchexchars[256] = {
+#if BYTE_ORDER == LITTLE_ENDIAN
+    0x3030, 0x3130, 0x3230, 0x3330, 0x3430, 0x3530, 0x3630, 0x3730,
+    0x3830, 0x3930, 0x6130, 0x6230, 0x6330, 0x6430, 0x6530, 0x6630,
+    0x3031, 0x3131, 0x3231, 0x3331, 0x3431, 0x3531, 0x3631, 0x3731,
+    0x3831, 0x3931, 0x6131, 0x6231, 0x6331, 0x6431, 0x6531, 0x6631,
+    0x3032, 0x3132, 0x3232, 0x3332, 0x3432, 0x3532, 0x3632, 0x3732,
+    0x3832, 0x3932, 0x6132, 0x6232, 0x6332, 0x6432, 0x6532, 0x6632,
+    0x3033, 0x3133, 0x3233, 0x3333, 0x3433, 0x3533, 0x3633, 0x3733,
+    0x3833, 0x3933, 0x6133, 0x6233, 0x6333, 0x6433, 0x6533, 0x6633,
+    0x3034, 0x3134, 0x3234, 0x3334, 0x3434, 0x3534, 0x3634, 0x3734,
+    0x3834, 0x3934, 0x6134, 0x6234, 0x6334, 0x6434, 0x6534, 0x6634,
+    0x3035, 0x3135, 0x3235, 0x3335, 0x3435, 0x3535, 0x3635, 0x3735,
+    0x3835, 0x3935, 0x6135, 0x6235, 0x6335, 0x6435, 0x6535, 0x6635,
+    0x3036, 0x3136, 0x3236, 0x3336, 0x3436, 0x3536, 0x3636, 0x3736,
+    0x3836, 0x3936, 0x6136, 0x6236, 0x6336, 0x6436, 0x6536, 0x6636,
+    0x3037, 0x3137, 0x3237, 0x3337, 0x3437, 0x3537, 0x3637, 0x3737,
+    0x3837, 0x3937, 0x6137, 0x6237, 0x6337, 0x6437, 0x6537, 0x6637,
+    0x3038, 0x3138, 0x3238, 0x3338, 0x3438, 0x3538, 0x3638, 0x3738,
+    0x3838, 0x3938, 0x6138, 0x6238, 0x6338, 0x6438, 0x6538, 0x6638,
+    0x3039, 0x3139, 0x3239, 0x3339, 0x3439, 0x3539, 0x3639, 0x3739,
+    0x3839, 0x3939, 0x6139, 0x6239, 0x6339, 0x6439, 0x6539, 0x6639,
+    0x3061, 0x3161, 0x3261, 0x3361, 0x3461, 0x3561, 0x3661, 0x3761,
+    0x3861, 0x3961, 0x6161, 0x6261, 0x6361, 0x6461, 0x6561, 0x6661,
+    0x3062, 0x3162, 0x3262, 0x3362, 0x3462, 0x3562, 0x3662, 0x3762,
+    0x3862, 0x3962, 0x6162, 0x6262, 0x6362, 0x6462, 0x6562, 0x6662,
+    0x3063, 0x3163, 0x3263, 0x3363, 0x3463, 0x3563, 0x3663, 0x3763,
+    0x3863, 0x3963, 0x6163, 0x6263, 0x6363, 0x6463, 0x6563, 0x6663,
+    0x3064, 0x3164, 0x3264, 0x3364, 0x3464, 0x3564, 0x3664, 0x3764,
+    0x3864, 0x3964, 0x6164, 0x6264, 0x6364, 0x6464, 0x6564, 0x6664,
+    0x3065, 0x3165, 0x3265, 0x3365, 0x3465, 0x3565, 0x3665, 0x3765,
+    0x3865, 0x3965, 0x6165, 0x6265, 0x6365, 0x6465, 0x6565, 0x6665,
+    0x3066, 0x3166, 0x3266, 0x3366, 0x3466, 0x3566, 0x3666, 0x3766,
+    0x3866, 0x3966, 0x6166, 0x6266, 0x6366, 0x6466, 0x6566, 0x6666
+#else
+    0x3030, 0x3031, 0x3032, 0x3033, 0x3034, 0x3035, 0x3036, 0x3037,
+    0x3038, 0x3039, 0x3061, 0x3062, 0x3063, 0x3064, 0x3065, 0x3066,
+    0x3130, 0x3131, 0x3132, 0x3133, 0x3134, 0x3135, 0x3136, 0x3137,
+    0x3138, 0x3139, 0x3161, 0x3162, 0x3163, 0x3164, 0x3165, 0x3166,
+    0x3230, 0x3231, 0x3232, 0x3233, 0x3234, 0x3235, 0x3236, 0x3237,
+    0x3238, 0x3239, 0x3261, 0x3262, 0x3263, 0x3264, 0x3265, 0x3266,
+    0x3330, 0x3331, 0x3332, 0x3333, 0x3334, 0x3335, 0x3336, 0x3337,
+    0x3338, 0x3339, 0x3361, 0x3362, 0x3363, 0x3364, 0x3365, 0x3366,
+    0x3430, 0x3431, 0x3432, 0x3433, 0x3434, 0x3435, 0x3436, 0x3437,
+    0x3438, 0x3439, 0x3461, 0x3462, 0x3463, 0x3464, 0x3465, 0x3466,
+    0x3530, 0x3531, 0x3532, 0x3533, 0x3534, 0x3535, 0x3536, 0x3537,
+    0x3538, 0x3539, 0x3561, 0x3562, 0x3563, 0x3564, 0x3565, 0x3566,
+    0x3630, 0x3631, 0x3632, 0x3633, 0x3634, 0x3635, 0x3636, 0x3637,
+    0x3638, 0x3639, 0x3661, 0x3662, 0x3663, 0x3664, 0x3665, 0x3666,
+    0x3730, 0x3731, 0x3732, 0x3733, 0x3734, 0x3735, 0x3736, 0x3737,
+    0x3738, 0x3739, 0x3761, 0x3762, 0x3763, 0x3764, 0x3765, 0x3766,
+    0x3830, 0x3831, 0x3832, 0x3833, 0x3834, 0x3835, 0x3836, 0x3837,
+    0x3838, 0x3839, 0x3861, 0x3862, 0x3863, 0x3864, 0x3865, 0x3866,
+    0x3930, 0x3931, 0x3932, 0x3933, 0x3934, 0x3935, 0x3936, 0x3937,
+    0x3938, 0x3939, 0x3961, 0x3962, 0x3963, 0x3964, 0x3965, 0x3966,
+    0x6130, 0x6131, 0x6132, 0x6133, 0x6134, 0x6135, 0x6136, 0x6137,
+    0x6138, 0x6139, 0x6161, 0x6162, 0x6163, 0x6164, 0x6165, 0x6166,
+    0x6230, 0x6231, 0x6232, 0x6233, 0x6234, 0x6235, 0x6236, 0x6237,
+    0x6238, 0x6239, 0x6261, 0x6262, 0x6263, 0x6264, 0x6265, 0x6266,
+    0x6330, 0x6331, 0x6332, 0x6333, 0x6334, 0x6335, 0x6336, 0x6337,
+    0x6338, 0x6339, 0x6361, 0x6362, 0x6363, 0x6364, 0x6365, 0x6366,
+    0x6430, 0x6431, 0x6432, 0x6433, 0x6434, 0x6435, 0x6436, 0x6437,
+    0x6438, 0x6439, 0x6461, 0x6462, 0x6463, 0x6464, 0x6465, 0x6466,
+    0x6530, 0x6531, 0x6532, 0x6533, 0x6534, 0x6535, 0x6536, 0x6537,
+    0x6538, 0x6539, 0x6561, 0x6562, 0x6563, 0x6564, 0x6565, 0x6566,
+    0x6630, 0x6631, 0x6632, 0x6633, 0x6634, 0x6635, 0x6636, 0x6637,
+    0x6638, 0x6639, 0x6661, 0x6662, 0x6663, 0x6664, 0x6665, 0x6666
+#endif
+};
+
+
+#ifdef EXTRA_IDENT
+#define CYRUS_VERSION_STR PACKAGE_VERSION "-" EXTRA_IDENT
+#else
+#define CYRUS_VERSION_STR PACKAGE_VERSION
+#endif
+EXPORTED const char CYRUS_VERSION[sizeof(CYRUS_VERSION_STR)] = CYRUS_VERSION_STR;
+
 /* convert string to all lower case
  */
 EXPORTED char *lcase(char* str)
@@ -362,20 +438,20 @@ EXPORTED void cyrus_reset_stdio(void)
     int devnull = open("/dev/null", O_RDWR, 0);
 
     if (devnull == -1) {
-        fatal("open() on /dev/null failed", EC_TEMPFAIL);
+        fatal("open() on /dev/null failed", EX_TEMPFAIL);
     }
 
     /* stdin */
     shutdown(0, SHUT_RD);
-    dup2(devnull, 0);
+    dup2(devnull, STDIN_FILENO);
 
     /* stdout */
     shutdown(1, SHUT_RD);
-    dup2(devnull, 1);
+    dup2(devnull, STDOUT_FILENO);
 
     /* stderr */
     shutdown(2, SHUT_RD);
-    dup2(devnull, 2);
+    dup2(devnull, STDERR_FILENO);
 
     if (devnull > 2) close(devnull);
 }
@@ -442,6 +518,7 @@ static int _copyfile_helper(const char *
     int n;
     int r = 0;
     int nolink = flags & COPYFILE_NOLINK;
+    int keeptime = flags & COPYFILE_KEEPTIME;
 
     /* try to hard link, but don't fail - fall back to regular copy */
     if (!nolink) {
@@ -493,6 +570,16 @@ static int _copyfile_helper(const char *
         goto done;
     }
 
+    if (keeptime) {
+        struct timeval tv[2];
+        TIMESPEC_TO_TIMEVAL(&tv[0], &sbuf.st_atim);
+        TIMESPEC_TO_TIMEVAL(&tv[1], &sbuf.st_mtim);
+        if (futimes(destfd, tv)) {
+            syslog(LOG_ERR, "IOERROR: setting times on %s: %m", to);
+            r = -1;
+        }
+    }
+
 done:
     map_free(&src_base, &src_size);
 
@@ -579,7 +666,7 @@ EXPORTED int set_caps(int stage __attrib
 }
 #endif
 
-static int cap_setuid(int uid, int is_master)
+static int cyrus_cap_setuid(int uid, int is_master)
 {
     int r;
 
@@ -599,7 +686,7 @@ EXPORTED int become_cyrus(int is_master)
     int result;
     static uid_t uid = 0;
 
-    if (uid) return cap_setuid(uid, is_master);
+    if (uid) return cyrus_cap_setuid(uid, is_master);
 
     const char *cyrus = cyrus_user();
     const char *mail = cyrus_group();
@@ -645,7 +732,7 @@ EXPORTED int become_cyrus(int is_master)
         return -1;
     }
 
-    result = cap_setuid(newuid, is_master);
+    result = cyrus_cap_setuid(newuid, is_master);
 
     /* Only set static uid if successful, else future calls won't reset gid */
     if (result == 0)
@@ -673,7 +760,7 @@ static int cmdtime_enabled = 0;
 static struct timeval cmdtime_start, cmdtime_end, nettime_start, nettime_end;
 static double totaltime, cmdtime, nettime, search_maxtime;
 
-double timeval_get_double(const struct timeval *tv)
+EXPORTED double timeval_get_double(const struct timeval *tv)
 {
     return (double)tv->tv_sec + (double)tv->tv_usec/1000000.0;
 }
@@ -695,6 +782,19 @@ EXPORTED double timesub(const struct tim
            (double)(end->tv_usec - start->tv_usec)/1000000.0;
 }
 
+EXPORTED int64_t now_ms(void)
+{
+    struct timespec ts;
+
+    if (clock_gettime(CLOCK_REALTIME, &ts) == 0) {
+        return (ts.tv_sec * 1000) + (ts.tv_nsec / 1000000);
+    }
+    else {
+        syslog(LOG_WARNING, "clock_gettime(): %m");
+        return time(NULL) * 1000;
+    }
+}
+
 EXPORTED void cmdtime_settimer(int enable)
 {
     cmdtime_enabled = enable;
@@ -778,8 +878,9 @@ EXPORTED int parseint32(const char *p, c
 
     /* INT_MAX == 2147483647 */
     while (cyrus_isdigit(*p)) {
-        if (result > 214748364 || (result == 214748364 && (*p > '7')))
-            fatal("num too big", EC_IOERR);
+        if (result > 214748364 || (result == 214748364 && (*p > '7'))) {
+            return -1;
+        }
         result = result * 10 + *p++ - '0';
         gotchar = 1;
     }
@@ -801,8 +902,9 @@ EXPORTED int parseuint32(const char *p,
 
     /* UINT_MAX == 4294967295U */
     while (cyrus_isdigit(*p)) {
-        if (result > 429496729 || (result == 429496729 && (*p > '5')))
-            fatal("num too big", EC_IOERR);
+        if (result > 429496729 || (result == 429496729 && (*p > '5'))) {
+            return -1;
+        }
         result = result * 10 + *p++ - '0';
         gotchar = 1;
     }
@@ -822,14 +924,15 @@ EXPORTED int parsenum(const char *p, con
     int cval;
 
     /* ULLONG_MAX == 18446744073709551615ULL
-     * - and I don't care about those last 5
      */
     for (n = 0; !maxlen || n < maxlen; n++) {
         if (!cyrus_isdigit(p[n]))
             break;
-        if (result > 1844674407370955161ULL)
-            fatal("num too big", EC_IOERR);
         cval = p[n] - '0';
+        if (result >= 1844674407370955161ULL) {
+            if (result > 1844674407370955161ULL || cval > 5)
+                return -1;
+        }
         result = result * 10 + cval;
     }
 
@@ -859,11 +962,13 @@ EXPORTED int parsehex(const char *p, con
     int cval;
 
     /* ULLONG_MAX == 18446744073709551615ULL
-     * - and I don't care about those last 5
+     * so if we're greater or equal to (ULLONG_MAX+1)/16
+     * then we will overflow
      */
     for (n = 0; !maxlen || n < maxlen; n++) {
-        if (result > 1844674407370955161ULL)
-            fatal("num too big", EC_IOERR);
+        if (result >= 1152921504606846976ULL) {
+            return -1;
+        }
         cval = unxdigit[(int)p[n]];
         if (cval == 0xff) break;
         result = result * 16 + cval;
@@ -880,8 +985,10 @@ EXPORTED int parsehex(const char *p, con
 
 /* buffer handling functions */
 
+#ifdef HAVE_DECLARE_OPTIMIZE
 static inline size_t roundup(size_t size)
     __attribute__((pure, always_inline, optimize("-O3")));
+#endif
 static inline size_t roundup(size_t size)
 {
     if (size < 32)
@@ -894,7 +1001,7 @@ static inline size_t roundup(size_t size
         return 256;
     if (size < 512)
         return 512;
-    return ((size + 1024) & ~1023);
+    return ((size * 2) & ~1023);
 }
 
 /* this function has a side-effect of always leaving the buffer writable */
@@ -952,7 +1059,9 @@ EXPORTED char *buf_newcstring(struct buf
 EXPORTED char *buf_release(struct buf *buf)
 {
     char *ret = (char *)buf_cstring(buf);
-    buf_init(buf);
+    buf->alloc = 0;
+    buf->s = NULL;
+    buf_free(buf);
     return ret;
 }
 
@@ -962,10 +1071,18 @@ EXPORTED const char *buf_cstringnull(con
     return buf_cstring(buf);
 }
 
+EXPORTED const char *buf_cstringnull_ifempty(const struct buf *buf)
+{
+    if (!buf->len) return NULL;
+    return buf_cstring(buf);
+}
+
 EXPORTED char *buf_releasenull(struct buf *buf)
 {
     char *ret = (char *)buf_cstringnull(buf);
-    buf_init(buf);
+    buf->alloc = 0;
+    buf->s = NULL;
+    buf_free(buf);
     return ret;
 }
 
@@ -999,15 +1116,19 @@ EXPORTED int buf_getline(struct buf *buf
     return (!(buf->len == 0 && c == EOF));
 }
 
+#ifdef HAVE_DECLARE_OPTIMIZE
 EXPORTED inline size_t buf_len(const struct buf *buf)
     __attribute__((always_inline, optimize("-O3")));
+#endif
 EXPORTED inline size_t buf_len(const struct buf *buf)
 {
     return buf->len;
 }
 
+#ifdef HAVE_DECLARE_OPTIMIZE
 EXPORTED inline const char *buf_base(const struct buf *buf)
     __attribute__((always_inline, optimize("-O3")));
+#endif
 EXPORTED inline const char *buf_base(const struct buf *buf)
 {
     return buf->s;
@@ -1066,6 +1187,30 @@ EXPORTED void buf_appendcstr(struct buf
     buf_appendmap(buf, str, strlen(str));
 }
 
+/* Append str to buf, omitting any byte sequence at the start
+ * of str that matches the exact same byte sequence at the
+ * end of buf. E.g. if buf="fooxyz" and str="xyzbar" then the
+ * result is "fooxyzbar". */
+EXPORTED void buf_appendoverlap(struct buf *buf, const char *str)
+{
+    const char *t = buf_cstring(buf);
+    size_t matchlen = strlen(str);
+    if (matchlen < buf_len(buf)) {
+        t += buf_len(buf) - matchlen;
+    } else {
+        matchlen = buf_len(buf);
+    }
+
+    while (*t && matchlen && strncasecmp(t, str, matchlen)) {
+        t++; matchlen--;
+    }
+
+    if (*t && matchlen) {
+        buf_truncate(buf, buf_len(buf) - matchlen);
+    }
+    buf_appendcstr(buf, str);
+}
+
 EXPORTED void buf_appendbit32(struct buf *buf, bit32 num)
 {
     bit32 item = htonl(num);
@@ -1290,6 +1435,7 @@ EXPORTED void buf_insertcstr(struct buf
     struct buf str_buf = BUF_INITIALIZER;
     buf_init_ro_cstr(&str_buf, str);
     buf_replace_buf(dst, off, 0, &str_buf);
+    buf_free(&str_buf);
 }
 
 EXPORTED void buf_insertmap(struct buf *dst, unsigned int off,
@@ -1298,12 +1444,14 @@ EXPORTED void buf_insertmap(struct buf *
     struct buf map_buf = BUF_INITIALIZER;
     buf_init_ro(&map_buf, base, len);
     buf_replace_buf(dst, off, 0, &map_buf);
+    buf_free(&map_buf);
 }
 
 EXPORTED void buf_remove(struct buf *dst, unsigned int off, unsigned int len)
 {
     struct buf empty_buf = BUF_INITIALIZER;
     buf_replace_buf(dst, off, len, &empty_buf);
+    buf_free(&empty_buf);
 }
 
 /*
@@ -1328,14 +1476,6 @@ EXPORTED int buf_cmp(const struct buf *a
     return r;
 }
 
-EXPORTED void buf_init(struct buf *buf)
-{
-    buf->alloc = 0;
-    buf->len = 0;
-    buf->flags = 0;
-    buf->s = NULL;
-}
-
 /*
  * Initialise a struct buf to point to read-only data.  The key here is
  * setting buf->alloc=0 which indicates CoW is in effect, i.e. the data
@@ -1343,10 +1483,9 @@ EXPORTED void buf_init(struct buf *buf)
  */
 EXPORTED void buf_init_ro(struct buf *buf, const char *base, size_t len)
 {
-    buf->alloc = 0;
-    buf->len = len;
-    buf->flags = 0;
+    buf_free(buf);
     buf->s = (char *)base;
+    buf->len = len;
 }
 
 /*
@@ -1356,9 +1495,9 @@ EXPORTED void buf_init_ro(struct buf *bu
  */
 EXPORTED void buf_initm(struct buf *buf, char *base, int len)
 {
-    buf->alloc = buf->len = len;
-    buf->flags = 0;
+    buf_free(buf);
     buf->s = base;
+    buf->alloc = buf->len = len;
 }
 
 /*
@@ -1366,10 +1505,9 @@ EXPORTED void buf_initm(struct buf *buf,
  */
 EXPORTED void buf_init_ro_cstr(struct buf *buf, const char *str)
 {
-    buf->alloc = 0;
-    buf->len = (str ? strlen(str) : 0);
-    buf->flags = 0;
+    buf_free(buf);
     buf->s = (char *)str;
+    buf->len = (str ? strlen(str) : 0);
 }
 
 /*
@@ -1377,25 +1515,21 @@ EXPORTED void buf_init_ro_cstr(struct bu
  * This buf is CoW, and if written to the data will be freed
  * using map_free().
  */
-EXPORTED void buf_init_mmap(struct buf *buf, int onceonly, int fd,
+EXPORTED void buf_refresh_mmap(struct buf *buf, int onceonly, int fd,
                             const char *fname, size_t size, const char *mboxname)
 {
+    assert(!buf->alloc);
     buf->flags = BUF_MMAP;
     map_refresh(fd, onceonly, (const char **)&buf->s, &buf->len,
                 size, fname, mboxname);
 }
 
-static void _buf_free_data(struct buf *buf)
+EXPORTED void buf_free(struct buf *buf)
 {
     if (buf->alloc)
         free(buf->s);
     else if (buf->flags & BUF_MMAP)
         map_free((const char **)&buf->s, &buf->len);
-}
-
-EXPORTED void buf_free(struct buf *buf)
-{
-    _buf_free_data(buf);
     buf->alloc = 0;
     buf->s = NULL;
     buf->len = 0;
@@ -1404,9 +1538,9 @@ EXPORTED void buf_free(struct buf *buf)
 
 EXPORTED void buf_move(struct buf *dst, struct buf *src)
 {
-    _buf_free_data(dst);
+    buf_free(dst);
     *dst = *src;
-    buf_init(src);
+    memset(src, 0, sizeof(struct buf));
 }
 
 EXPORTED int buf_findchar(const struct buf *buf, unsigned int off, int c)
@@ -1494,6 +1628,34 @@ EXPORTED const char *buf_lcase(struct bu
     return buf->s;
 }
 
+EXPORTED const char *buf_ucase(struct buf *buf)
+{
+    buf_cstring(buf);
+    ucase(buf->s);
+    return buf->s;
+}
+
+EXPORTED const char *buf_tocrlf(struct buf *buf)
+{
+    size_t i;
+
+    buf_cstring(buf);
+
+    for (i = 0; i < buf->len; i++) {
+        if (buf->s[i] == '\r' && buf->s[i+1] != '\n') {
+            /* bare \r: add a \n after it */
+            buf_insertcstr(buf, i+1, "\n");
+        }
+        else if (buf->s[i] == '\n') {
+            if (i == 0 || buf->s[i-1] != '\r') {
+                buf_insertcstr(buf, i, "\r");
+            }
+        }
+    }
+
+    return buf->s;
+}
+
 EXPORTED void buf_trim(struct buf *buf)
 {
     size_t i;
@@ -1537,6 +1699,17 @@ EXPORTED int bin_to_hex(const void *bin,
     return p-hex;
 }
 
+EXPORTED int bin_to_lchex(const void *bin, size_t binlen, char *hex)
+{
+    uint16_t *p = (void *)hex;
+    const unsigned char *v = bin;
+    size_t i;
+    for (i = 0; i < binlen; i++)
+        *p++ = lchexchars[*v++];
+    hex[binlen*2] = '\0';
+    return 2 * binlen;
+}
+
 EXPORTED int hex_to_bin(const char *hex, size_t hexlen, void *bin)
 {
     unsigned char *v = bin, msn, lsn;
@@ -1736,8 +1909,8 @@ EXPORTED int warmup_file(const char *fil
 EXPORTED const char *makeuuid()
 {
     /* 36 bytes of uuid plus \0 */
-    static char res[37];
-    memset(res, 0, 37);
+    static char res[UUID_STR_LEN];
+    memset(res, 0, UUID_STR_LEN);
 #ifdef HAVE_LIBUUID
     uuid_t uu;
     uuid_clear(uu); /* Just In Case */
@@ -1811,7 +1984,7 @@ EXPORTED void tcp_enable_keepalive(int f
         }
 #endif
 #ifdef TCP_KEEPIDLE
-        optval = config_getint(IMAPOPT_TCP_KEEPALIVE_IDLE);
+        optval = config_getduration(IMAPOPT_TCP_KEEPALIVE_IDLE, 's');
         if (optval) {
             r = setsockopt(fd, proto->p_proto, TCP_KEEPIDLE, &optval, optlen);
             if (r < 0) {
@@ -1820,7 +1993,7 @@ EXPORTED void tcp_enable_keepalive(int f
         }
 #endif
 #ifdef TCP_KEEPINTVL
-        optval = config_getint(IMAPOPT_TCP_KEEPALIVE_INTVL);
+        optval = config_getduration(IMAPOPT_TCP_KEEPALIVE_INTVL, 's');
         if (optval) {
             r = setsockopt(fd, proto->p_proto, TCP_KEEPINTVL, &optval, optlen);
             if (r < 0) {
diff -pruN 3.0.13-5/lib/util.h 3.2.0-3/lib/util.h
--- 3.0.13-5/lib/util.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/util.h	2020-04-24 02:03:00.000000000 +0000
@@ -54,8 +54,22 @@
 #include <stdint.h>
 #include <stdio.h>
 
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+#ifndef STDIN_FILENO
+/* Standard file descriptors.  */
+#define	STDIN_FILENO	0	/* Standard input.  */
+#define	STDOUT_FILENO	1	/* Standard output.  */
+#define	STDERR_FILENO	2	/* Standard error output.  */
+#endif
+
 #include "xmalloc.h"
 
+/* version string printable in gdb tracking */
+extern const char CYRUS_VERSION[];
+
 #ifdef ENABLE_REGEX
 # ifdef HAVE_PCREPOSIX_H
 #  include <pcre.h>
@@ -69,6 +83,13 @@
 # endif /* HAVE_PCREPOSIX_H */
 #endif /* ENABLE_REGEX */
 
+#ifdef HAVE_LIBUUID
+#include <uuid/uuid.h>
+#endif
+#ifndef UUID_STR_LEN
+#define UUID_STR_LEN  37
+#endif
+
 #define BIT32_MAX 4294967295U
 
 #if UINT_MAX == BIT32_MAX
@@ -86,6 +107,12 @@ typedef unsigned long long int modseq_t;
 #define MODSEQ_FMT "%llu"
 #define atomodseq_t(s) strtoull(s, NULL, 10)
 
+#if SIZEOF_LONG >= 8
+#define INT64_FMT "%ld"
+#else
+#define INT64_FMT "%lld"
+#endif
+
 #define Uisalnum(c) isalnum((int)((unsigned char)(c)))
 #define Uisalpha(c) isalpha((int)((unsigned char)(c)))
 #define Uisascii(c) isascii((int)((unsigned char)(c)))
@@ -190,7 +217,8 @@ extern int cyrus_mkdir(const char *path,
 enum {
     COPYFILE_NOLINK = (1<<0),
     COPYFILE_MKDIR  = (1<<1),
-    COPYFILE_RENAME = (1<<2)
+    COPYFILE_RENAME = (1<<2),
+    COPYFILE_KEEPTIME = (1<<3)
 };
 
 extern int cyrus_copyfile(const char *from, const char *to, int flags);
@@ -230,6 +258,7 @@ extern double timeval_get_double(const s
 extern void timeval_set_double(struct timeval *tv, double d);
 extern void timeval_add_double(struct timeval *tv, double delta);
 extern double timesub(const struct timeval *start, const struct timeval *end);
+extern int64_t now_ms(void);
 
 extern clock_t sclock(void);
 
@@ -251,6 +280,7 @@ struct buf {
 void _buf_ensure(struct buf *buf, size_t len);
 const char *buf_cstring(const struct buf *buf);
 const char *buf_cstringnull(const struct buf *buf);
+const char *buf_cstringnull_ifempty(const struct buf *buf);
 char *buf_release(struct buf *buf);
 char *buf_newcstring(struct buf *buf);
 char *buf_releasenull(struct buf *buf);
@@ -265,6 +295,7 @@ void buf_setmap(struct buf *buf, const c
 void buf_copy(struct buf *dst, const struct buf *src);
 void buf_append(struct buf *dst, const struct buf *src);
 void buf_appendcstr(struct buf *buf, const char *str);
+void buf_appendoverlap(struct buf *buf, const char *str);
 void buf_appendbit32(struct buf *buf, bit32 num);
 void buf_appendbit64(struct buf *buf, bit64 num);
 void buf_appendmap(struct buf *buf, const char *base, size_t len);
@@ -273,9 +304,10 @@ void buf_cowappendfree(struct buf *buf,
 void buf_insert(struct buf *dst, unsigned int off, const struct buf *src);
 void buf_insertcstr(struct buf *buf, unsigned int off, const char *str);
 void buf_insertmap(struct buf *buf, unsigned int off, const char *base, int len);
-void buf_vprintf(struct buf *buf, const char *fmt, va_list args);
+void buf_vprintf(struct buf *buf, const char *fmt, va_list args)
+                __attribute__((format(printf, 2, 0)));
 void buf_printf(struct buf *buf, const char *fmt, ...)
-                __attribute__((format(printf,2,3)));
+                __attribute__((format(printf, 2, 3)));
 int buf_replace_all(struct buf *buf, const char *match,
                     const char *replace);
 int buf_replace_char(struct buf *buf, char match, char replace);
@@ -289,21 +321,22 @@ void buf_remove(struct buf *buf, unsigne
 int buf_cmp(const struct buf *, const struct buf *);
 int buf_findchar(const struct buf *, unsigned int off, int c);
 int buf_findline(const struct buf *buf, const char *line);
-void buf_init(struct buf *buf);
 void buf_init_ro(struct buf *buf, const char *base, size_t len);
 void buf_initm(struct buf *buf, char *base, int len);
 void buf_init_ro_cstr(struct buf *buf, const char *str);
-void buf_init_mmap(struct buf *buf, int onceonly, int fd,
+void buf_refresh_mmap(struct buf *buf, int onceonly, int fd,
                    const char *fname, size_t size, const char *mboxname);
 void buf_free(struct buf *buf);
 void buf_move(struct buf *dst, struct buf *src);
 const char *buf_lcase(struct buf *buf);
+const char *buf_ucase(struct buf *buf);
+const char *buf_tocrlf(struct buf *buf);
 void buf_trim(struct buf *buf);
 
 /*
  * Given a list of strings, terminated by (char *)NULL,
  * return a newly allocated string containing the
- * concatention of all the argument strings.  The
+ * concatenation of all the argument strings.  The
  * caller must free the returned string using free().
  *
  * This API idea based on glib's g_strconcat() which
@@ -317,6 +350,7 @@ char *strconcat(const char *s1, ...);
 #define BH_SEPARATOR(c)     (_BH_SEP|((c)&0x7f))
 #define _BH_GETSEP(flags)   (flags & _BH_SEP ? (char)(flags & 0x7f) : '\0')
 int bin_to_hex(const void *bin, size_t binlen, char *hex, int flags);
+int bin_to_lchex(const void *bin, size_t binlen, char *hex);
 int hex_to_bin(const char *hex, size_t hexlen, void *bin);
 
 /* use getpassphrase on machines which support it */
@@ -352,13 +386,13 @@ int buf_deflate(struct buf *buf, int com
  * string is always NUL-terminated.  Yes, I know we have an
  * implementation of the BSD strlcpy() which has this semantic,
  * but that isn't a highly optimised libc or compiler provided
- * function like strncpy(), and we can trivially and eficiently
+ * function like strncpy(), and we can trivially and efficiently
  * add the NUL termination semantic on top of strncpy(). */
 #define xstrncpy(d, s, n) \
     do { \
         char *_d = (d); \
         size_t _n = (n); \
-        strncpy(_d, (s), _n); \
+        strncpy(_d, (s), _n-1); \
         _d[_n-1] = '\0'; \
     } while(0)
 
diff -pruN 3.0.13-5/lib/vparse.c 3.2.0-3/lib/vparse.c
--- 3.0.13-5/lib/vparse.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/vparse.c	2020-04-24 02:03:00.000000000 +0000
@@ -5,7 +5,6 @@
 #include <stdio.h>
 #include <fcntl.h>
 
-#include "xmalloc.h"
 #include "vparse.h"
 #include "xmalloc.h"
 
@@ -202,7 +201,7 @@ repeat:
     r = _parse_param_key(state, &haseq);
     if (r) return r;
 
-    if (state->multiparam && strarray_find(state->multiparam, state->param->name, 0))
+    if (state->multiparam && strarray_find_case(state->multiparam, state->param->name, 0) >= 0)
         multiparam = 1;
 
     /* now get the value */
@@ -818,7 +817,7 @@ static void _checkwrap(unsigned char c,
     buf_putc(tgt->buf, ' ');
 }
 
-static void _value_to_tgt(const char *value, struct vparse_target *tgt, char multivalsep)
+static void _value_to_tgt(const char *value, struct vparse_target *tgt)
 {
     if (!value) return; /* null fields or array items are empty string */
     for (; *value; value++) {
@@ -837,15 +836,6 @@ static void _value_to_tgt(const char *va
             buf_putc(tgt->buf, 'n');
             break;
         case ';':
-            /* this doesn't need to be quoted, but , does. yay. So special case this one */
-            if (multivalsep == ';') {
-                buf_putc(tgt->buf, '\\');
-                buf_putc(tgt->buf, *value);
-            }
-            else {
-                buf_putc(tgt->buf, *value);
-            }
-            break;
         case ',':
         case '\\':
             buf_putc(tgt->buf, '\\');
@@ -944,11 +934,11 @@ static void _entry_to_tgt(const struct v
         int i;
         for (i = 0; i < entry->v.values->count; i++) {
             if (i) buf_putc(tgt->buf, entry->multivaluesep);
-            _value_to_tgt(strarray_nth(entry->v.values, i), tgt, entry->multivaluesep);
+            _value_to_tgt(strarray_nth(entry->v.values, i), tgt);
         }
     }
     else {
-        _value_to_tgt(entry->v.value, tgt, '\0');
+        _value_to_tgt(entry->v.value, tgt);
     }
 
     _endline(tgt);
@@ -1022,10 +1012,22 @@ EXPORTED struct vparse_entry *vparse_get
 
 EXPORTED void vparse_replace_entry(struct vparse_card *card, const char *group, const char *name, const char *value)
 {
-    struct vparse_entry *res = vparse_get_entry(card, group, name);
-    if (!res) res = vparse_add_entry(card, group, name, NULL);
-    free(res->v.value);
-    res->v.value = xstrdupnull(value);
+    struct vparse_entry *entry = vparse_get_entry(card, group, name);
+    if (entry) {
+        if (entry->multivaluesep) {
+            /* FN isn't allowed to be a multi-value, but let's
+             * rather check than deal with corrupt memory */
+            strarray_free(entry->v.values);
+            entry->v.values = NULL;
+        } else {
+            free(entry->v.value);
+        }
+        entry->v.value = xstrdupnull(value);
+        entry->multivaluesep = '\0';
+    }
+    else {
+        vparse_add_entry(card, group, name, value);
+    }
 }
 
 EXPORTED void vparse_delete_entries(struct vparse_card *card, const char *group, const char *name)
@@ -1081,6 +1083,63 @@ EXPORTED void vparse_delete_params(struc
     }
 }
 
+static const struct {
+    const char *name;  /* property name */
+    struct {
+        unsigned min;  /* mandatory minimum number of occurrences */
+        unsigned max;  /* allowed maximum number of occurrences */
+    } version[3];      /* 1 min/max per vCard version */
+} restrictions[] = {
+    { "VERSION",     { { 1,  1 }, { 1,  1 }, { 1,  1 } } },
+    { "ANNIVERSARY", { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "BDAY",        { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "FN",          { { 0, -1 }, { 1, -1 }, { 1, -1 } } },
+    { "GENDER",      { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "KIND",        { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "N",           { { 1,  1 }, { 1,  1 }, { 0,  1 } } },
+    { "PRODID",      { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "REV",         { { 0,  1 }, { 0,  1 }, { 0,  1 } } },
+    { "UID",         { { 0,  1 }, { 0,  1 }, { 0,  1 } } }
+};
+
+#define NUM_CHECK_PROPS 10
+
+EXPORTED int vparse_restriction_check(struct vparse_card *card)
+{
+    enum { VER_2_1 = 0, VER_3_0, VER_4_0 };
+    struct vparse_entry *entry = NULL;
+    unsigned counts[NUM_CHECK_PROPS];
+    unsigned i, ver = VER_3_0;
+
+    /* Zero property counts */
+    memset(counts, 0, NUM_CHECK_PROPS * sizeof(unsigned));
+
+    /* Count interesting properties */
+    for (entry = card->properties; entry; entry = entry->next) {
+        for (i = 0; i < NUM_CHECK_PROPS; i++) {
+            if (!strcasecmpsafe(entry->name, restrictions[i].name)) {
+                counts[i]++;
+
+                if (i == 0) {
+                    /* VERSION */
+                    if (!strcmp(entry->v.value, "2.1")) ver = VER_2_1;
+                    else if (!strcmp(entry->v.value, "3.0")) ver = VER_3_0;
+                    else if (!strcmp(entry->v.value, "4.0")) ver = VER_4_0;
+                    else return 0;
+                }
+            }
+        }
+    }
+
+    /* Check property counts against restrictions */
+    for (i = 0; i < NUM_CHECK_PROPS; i++) {
+        if (counts[i] < restrictions[i].version[ver].min) return 0;
+        if (counts[i] > restrictions[i].version[ver].max) return 0;
+    }
+
+    return 1;
+}
+
 #if DEBUG
 static int _dump_card(struct vparse_card *card)
 {
diff -pruN 3.0.13-5/lib/vparse.h 3.2.0-3/lib/vparse.h
--- 3.0.13-5/lib/vparse.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/vparse.h	2020-04-24 02:03:00.000000000 +0000
@@ -110,6 +110,7 @@ extern struct vparse_param *vparse_get_p
 extern struct vparse_param *vparse_add_param(struct vparse_entry *entry, const char *name, const char *value);
 
 extern void vparse_tobuf(const struct vparse_card *card, struct buf *buf);
+extern int vparse_restriction_check(struct vparse_card *card);
 
 #endif /* VCARDFAST_H */
 
diff -pruN 3.0.13-5/lib/xmalloc.c 3.2.0-3/lib/xmalloc.c
--- 3.0.13-5/lib/xmalloc.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/xmalloc.c	2020-04-24 02:03:00.000000000 +0000
@@ -44,9 +44,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <sysexits.h>
 #include "xmalloc.h"
 
-#include "exitcodes.h"
 
 EXPORTED void* xmalloc(size_t size)
 {
@@ -55,22 +55,15 @@ EXPORTED void* xmalloc(size_t size)
     ret = malloc(size);
     if (ret != NULL) return ret;
 
-    fatal("Virtual memory exhausted", EC_TEMPFAIL);
+    fatal("Virtual memory exhausted", EX_TEMPFAIL);
     return 0; /*NOTREACHED*/
 }
 
 EXPORTED void* xzmalloc(size_t size)
 {
-    void *ret;
-
-    ret = malloc(size);
-    if (ret != NULL) {
-        memset(ret, 0, size);
-        return ret;
-    }
-
-    fatal("Virtual memory exhausted", EC_TEMPFAIL);
-    return 0; /*NOTREACHED*/
+    void *ret = xmalloc(size);
+    memset(ret, 0, size);
+    return ret;
 }
 
 EXPORTED void *xcalloc(size_t nmemb, size_t size)
@@ -86,7 +79,7 @@ EXPORTED void *xrealloc (void* ptr, size
     ret = (!ptr ? malloc (size) : realloc (ptr, size));
     if (ret != NULL) return ret;
 
-    fatal("Virtual memory exhausted", EC_TEMPFAIL);
+    fatal("Virtual memory exhausted", EX_TEMPFAIL);
     return 0; /*NOTREACHED*/
 }
 
diff -pruN 3.0.13-5/lib/xmalloc.h 3.2.0-3/lib/xmalloc.h
--- 3.0.13-5/lib/xmalloc.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/lib/xmalloc.h	2020-04-24 02:03:00.000000000 +0000
@@ -58,6 +58,16 @@ extern char *xstrdupsafe (const char *st
 extern char *xstrndup (const char *str, size_t len);
 extern void *xmemdup (const void *ptr, size_t size);
 
+// this can be used on lvalues (e.g. function returns)
+#define xfree(ptr) do { \
+  void *x = ptr; if (x) { free(x); } \
+} while (0)
+
+// NOTE - can not be used on things that can't be lvalues :)
+#define xzfree(ptr) do { \
+  if (ptr) { free(ptr); ptr = NULL; } \
+} while (0)
+
 /* Functions using xmalloc.h must provide a function called fatal() conforming
    to the following: */
 extern void fatal(const char *fatal_message, int fatal_code)
diff -pruN 3.0.13-5/Makefile.am 3.2.0-3/Makefile.am
--- 3.0.13-5/Makefile.am	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/Makefile.am	2020-05-04 03:28:02.000000000 +0000
@@ -76,17 +76,14 @@ AM_DISTCHECK_CONFIGURE_FLAGS = \
     --enable-nntp \
     --enable-murder \
     --enable-idled \
-    --enable-event-notification \
     --enable-sieve \
     --enable-autocreate \
     --enable-backup \
-    --with-lmdb \
     --enable-xapian \
     --enable-jmap \
     --with-ldap
 
 BUILT_SOURCES = \
-	imap/imap_err.c \
 	lib/imapopts.c \
 	lib/imapopts.h
 
@@ -96,19 +93,29 @@ CLEANFILES = \
 	lib/imapopts.h
 
 DISTCLEANFILES = \
+	com_err/et/compile_et \
+	imap/http_caldav_js.h \
+	imap/http_carddav_js.h \
+	imap/http_err.c \
+	imap/http_err.h \
 	imap/imap_err.c \
 	imap/imap_err.h \
+	imap/jmap_err.c \
+	imap/jmap_err.h \
+	imap/lmtp_err.c \
+	imap/lmtp_err.h \
+	imap/lmtpstats.c \
+	imap/lmtpstats.h \
 	imap/mupdate_err.c \
 	imap/mupdate_err.h \
 	imap/nntp_err.c \
 	imap/nntp_err.h \
-	imap/http_caldav_js.h \
-	imap/http_carddav_js.h \
-	imap/http_err.c \
-	imap/http_err.h \
+	imap/promdata.c \
+	imap/promdata.h \
+	imap/pushstats.c \
+	imap/pushstats.h \
 	imap/tz_err.c \
 	imap/tz_err.h \
-	com_err/et/compile_et \
 	perl/sieve/scripts/installsieve \
 	perl/sieve/scripts/sieveshell \
 	sieve/sieve_err.c \
@@ -119,8 +126,6 @@ MAINTAINERCLEANFILES = \
 	doc/legacy/netnews.png \
 	man/imapd.conf.5 \
 	man/sieveshell.1 \
-	imap/lmtpstats.h \
-	imap/pushstats.h \
 	sieve/addr.h \
 	sieve/sieve.h
 
@@ -128,16 +133,12 @@ SUBDIRS = .
 DIST_SUBDIRS = . perl/annotator perl/imap perl/sieve/managesieve
 dist_sysconf_DATA =
 lib_LTLIBRARIES = lib/libcyrus_min.la lib/libcyrus.la
-EXTRA_PROGRAMS =
 check_PROGRAMS =
 libexec_PROGRAMS =
 sbin_PROGRAMS =
 noinst_HEADERS =
 noinst_LTLIBRARIES =
 noinst_PROGRAMS =
-EXTRA_DIST = \
-	$(wildcard tools/vzic/*) \
-	VERSION
 
 if COM_ERR
 COMPILE_ET_DEP = com_err/et/compile_et
@@ -149,14 +150,25 @@ bin_PROGRAMS = imtest/imtest
 
 if SERVER
 BUILT_SOURCES += \
-	imap/mupdate_err.c \
-	imap/nntp_err.c \
+	imap/http_err.c \
+	imap/http_err.h \
+	imap/imap_err.c \
+	imap/imap_err.h \
+	imap/lmtp_err.c \
+	imap/lmtp_err.h \
 	imap/lmtpstats.c \
+	imap/lmtpstats.h \
+	imap/mupdate_err.c \
+	imap/mupdate_err.h \
 	imap/pushstats.c \
+	imap/pushstats.h \
+	imap/promdata.c \
+	imap/promdata.h \
 	lib/htmlchar.c \
 	lib/htmlchar.h \
 	imap/rfc822_header.c \
-	imap/rfc822_header.h
+	imap/rfc822_header.h \
+	imap/mailbox_header_cache.h
 
 lib_LTLIBRARIES += imap/libcyrus_imap.la
 
@@ -165,6 +177,7 @@ libexec_PROGRAMS += \
 	imap/imapd \
 	imap/lmtpd \
 	imap/pop3d \
+	imap/promstatsd \
 	imap/smmapd
 
 sbin_PROGRAMS += \
@@ -199,10 +212,6 @@ noinst_PROGRAMS += \
 	imap/message_test \
 	imap/search_test
 
-if USE_SPHINX
-sbin_PROGRAMS += imap/cyr_sphinxmgr
-endif
-
 if USE_SQUAT
 noinst_PROGRAMS += imap/squat_dump
 endif
@@ -214,6 +223,7 @@ endif
 if NNTPD
 libexec_PROGRAMS += imap/nntpd
 sbin_PROGRAMS += imap/fetchnews
+BUILT_SOURCES += imap/nntp_err.c
 endif # NNTPD
 
 libexec_PROGRAMS += imap/fud
@@ -226,30 +236,28 @@ if MURDER
 libexec_PROGRAMS += imap/mupdate
 endif # MURDER
 
-if NNTPD
-libexec_PROGRAMS += imap/nntpd
-endif
-
 if CALALARMD
 libexec_PROGRAMS += imap/calalarmd
 endif
 
 if HTTPD
+
 AM_CPPFLAGS += $(HTTP_CPPFLAGS)
+
 AM_LDFLAGS += $(HTTP_LIBS)
 
 BUILT_SOURCES += \
 	imap/http_caldav_js.h \
 	imap/http_carddav_js.h \
-	imap/http_err.c \
-	imap/http_err.h \
 	imap/tz_err.c \
 	imap/tz_err.h
 
 libexec_PROGRAMS += imap/httpd
+check_PROGRAMS += imap/ical_apply_patch
 sbin_PROGRAMS += \
 	imap/ctl_zoneinfo \
 	imap/dav_reconstruct
+
 endif # HTTPD
 
 if REPLICATION
@@ -274,24 +282,6 @@ if SIEVE
 check_PROGRAMS += notifyd/notifytest
 libexec_PROGRAMS += notifyd/notifyd
 endif # SIEVE
-
-else # SERVER
-EXTRA_DIST += \
-    imap/mupdate_err.c \
-    imap/nntp_err.c \
-    imap/lmtpstats.c \
-    imap/pushstats.c \
-    imap/rfc822_header.c \
-    imap/rfc822_header.h
-
-if !HTTPD
-EXTRA_DIST += \
-	imap/http_err.c \
-	imap/http_err.h \
-	imap/tz_err.c \
-	imap/tz_err.h
-endif # HTTPD
-
 endif # SERVER
 
 if CMULOCAL
@@ -320,7 +310,7 @@ endif # PERL
 BUILT_SOURCES += sieve/addr.c sieve/sieve.c sieve/sieve_err.c
 noinst_LTLIBRARIES += sieve/libcyrus_sieve_lex.la
 lib_LTLIBRARIES += sieve/libcyrus_sieve.la
-check_PROGRAMS += sieve/test
+check_PROGRAMS += sieve/test sieve/test_mailbox
 sbin_PROGRAMS += sieve/sievec sieve/sieved
 
 if SERVER
@@ -329,17 +319,16 @@ endif # SERVER
 
 endif # SIEVE
 
-EXTRA_DIST += \
+EXTRA_DIST = \
 	COPYING \
 	README.md \
-	SMakefile \
+	VERSION \
 	com_err/et/et_c.awk \
 	com_err/et/et_h.awk \
 	com_err/et/test1.et \
 	com_err/et/test2.et \
 	com_err/et/test_et.c \
-	contrib/drac_auth.patch \
-	contrib/sieve-spamasssassin \
+	contrib/sieve-spamassassin \
 	contrib/fud-client.c \
 	contrib/deliver-notify-zephyr.patch \
 	contrib/add-cyrus-user \
@@ -375,15 +364,16 @@ EXTRA_DIST += \
 	doc/legacy/netnews.png \
 	doc \
 	docsrc \
-	imap/dav_util.h \
-	imap/http_caldav_js.h \
 	imap/http_caldav.js \
-	imap/http_carddav_js.h \
 	imap/http_carddav.js \
 	imap/http_err.et \
 	imap/imap_err.et \
+	imap/jmap_err.et \
+	imap/lmtp_err.et \
+	imap/mailbox_header_cache.gperf \
 	imap/mupdate_err.et \
 	imap/nntp_err.et \
+	imap/promdata.p \
 	imap/rfc822_header.st \
 	imap/tz_err.et \
 	lib/charset/aliases.txt \
@@ -531,6 +521,7 @@ dist_noinst_SCRIPTS = \
 	com_err/et/config_script \
 	imap/lmtpstats.snmp \
 	imap/pushstats.snmp \
+	imap/promdatagen \
 	lib/mkchartable.pl \
 	lib/test/run \
 	perl/sieve/scripts/installsieve.pl \
@@ -538,7 +529,6 @@ dist_noinst_SCRIPTS = \
 	tools/arbitronsort.pl \
 	tools/compile_st.pl \
 	tools/config2header \
-	tools/config2man \
 	tools/config2rst \
 	tools/config2sample \
 	tools/fixsearchpath.pl \
@@ -547,6 +537,7 @@ dist_noinst_SCRIPTS = \
 	tools/masssievec \
 	tools/mkimap \
 	tools/mknewsgroups \
+	tools/perl2rst \
 	tools/rehash \
 	tools/translatesieve \
 	snmp/snmpgen
@@ -610,6 +601,18 @@ endif
 
 # ----
 
+if USE_LIBCHARDET
+AM_LDFLAGS += $(LIBCHARDET_LIBS)
+AM_CPPFLAGS += $(LIBCHARDET_CFLAGS)
+LD_SERVER_ADD += $(LIBCHARDET_LIBS)
+endif
+
+if USE_JANSSON
+AM_LDFLAGS += $(JANSSON_LIBS)
+AM_CPPFLAGS += $(JANSSON_CFLAGS)
+LD_SERVER_ADD += $(JANSSON_LIBS)
+endif
+
 if CUNIT
 
 CUNIT_PROJECT = cunit/default.cunit
@@ -619,7 +622,7 @@ check_PROGRAMS += cunit/unit
 
 cunit_FRAMEWORK = \
 	cunit/unit.c \
-	cunit/cunit.h \
+	cunit/cyrunit.h \
 	cunit/syslog.c \
 	cunit/cunit-syslog.h \
 	cunit/timeout.c \
@@ -640,6 +643,7 @@ cunit_TESTS = \
 	cunit/charset.testc \
 	cunit/command.testc \
 	cunit/conversations.testc \
+	cunit/cyr_qsort_r.testc \
 	cunit/crc32.testc \
 	cunit/dlist.testc \
 	cunit/duplicate.testc \
@@ -647,7 +651,9 @@ cunit_TESTS = \
 	cunit/glob.testc \
 	cunit/guid.testc \
 	cunit/hash.testc \
+	cunit/hashset.testc \
 	cunit/imapurl.testc \
+	cunit/imparse.testc \
 	cunit/libconfig.testc \
 	cunit/mboxname.testc \
 	cunit/md5.testc \
@@ -681,6 +687,8 @@ cunit_unit_LDADD = $(LD_SIEVE_ADD) $(LD_
 
 CUNIT_PL = $(top_srcdir)/cunit/cunit.pl --project $(CUNIT_PROJECT)
 
+
+
 # don't discard the temporary source file if building with coverage
 if HAVE_COVERAGE
     CUNIT_RM = true
@@ -746,11 +754,12 @@ include_HEADERS = \
 	lib/crc32.h \
 	lib/crc32c.h \
 	lib/cyr_lock.h \
+	lib/cyr_qsort_r.h \
 	lib/cyrusdb.h \
-	lib/exitcodes.h \
 	lib/glob.h \
 	lib/gmtoff.h \
 	lib/hash.h \
+	lib/hashset.h \
 	lib/hashu64.h \
 	lib/imapurl.h \
 	lib/imclient.h \
@@ -773,7 +782,6 @@ include_HEADERS = \
 	lib/strarray.h \
 	lib/strhash.h \
 	lib/stristr.h \
-	lib/sysexits.h \
 	lib/times.h \
 	lib/tok.h \
 	lib/vparse.h \
@@ -833,9 +841,10 @@ backup_ctl_backups_SOURCES = \
 backup_ctl_backups_LDADD = backup/libcyrus_backup.la $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
 
 backup_cyr_backup_SOURCES = \
+    imap/json_support.h \
     imap/mutex_fake.c \
     backup/cyr_backup.c
-backup_cyr_backup_LDADD = backup/libcyrus_backup.la $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+backup_cyr_backup_LDADD = backup/libcyrus_backup.la $(LD_UTILITY_ADD)
 
 backup_restore_SOURCES = \
     imap/mutex_fake.c \
@@ -862,6 +871,9 @@ imap_ctl_deliver_LDADD = $(LD_UTILITY_AD
 imap_ctl_mboxlist_SOURCES = imap/cli_fatal.c imap/ctl_mboxlist.c imap/mutex_fake.c
 imap_ctl_mboxlist_LDADD = $(LD_UTILITY_ADD)
 
+imap_ctl_zoneinfo_SOURCES = imap/cli_fatal.c imap/ctl_zoneinfo.c imap/mutex_fake.c imap/zoneinfo_db.c
+imap_ctl_zoneinfo_LDADD = $(LD_UTILITY_ADD)
+
 imap_cvt_cyrusdb_SOURCES = imap/cli_fatal.c imap/cvt_cyrusdb.c imap/mutex_fake.c
 imap_cvt_cyrusdb_LDADD = $(LD_UTILITY_ADD)
 
@@ -884,7 +896,7 @@ imap_cyr_info_SOURCES = imap/cli_fatal.c
 imap_cyr_info_LDADD = $(LD_UTILITY_ADD)
 
 imap_cyr_buildinfo_SOURCES = imap/cli_fatal.c imap/cyr_buildinfo.c imap/mutex_fake.c master/masterconf.c
-imap_cyr_buildinfo_LDADD = $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+imap_cyr_buildinfo_LDADD = $(LD_UTILITY_ADD)
 
 imap_cyr_sequence_SOURCES = imap/cli_fatal.c imap/cyr_sequence.c imap/mutex_fake.c
 imap_cyr_sequence_LDADD = $(LD_UTILITY_ADD)
@@ -895,24 +907,19 @@ imap_cyr_synclog_LDADD = $(LD_UTILITY_AD
 imap_cyr_userseen_SOURCES = imap/cli_fatal.c imap/cyr_userseen.c imap/mutex_fake.c
 imap_cyr_userseen_LDADD = $(LD_UTILITY_ADD)
 
-imap_cyr_sphinxmgr_SOURCES = imap/cli_fatal.c imap/cyr_sphinxmgr.c imap/mutex_fake.c
-imap_cyr_sphinxmgr_LDADD = $(LD_UTILITY_ADD)
-
 imap_cyr_virusscan_SOURCES = imap/cli_fatal.c imap/cyr_virusscan.c imap/mutex_fake.c
 imap_cyr_virusscan_CFLAGS = $(AM_CFLAGS) $(CLAMAV_CFLAGS) $(CFLAG_VISIBILITY)
 imap_cyr_virusscan_LDADD = $(LD_UTILITY_ADD) $(CLAMAV_LIBS)
 
-imap_ctl_zoneinfo_SOURCES = imap/cli_fatal.c imap/ctl_zoneinfo.c imap/mutex_fake.c imap/zoneinfo_db.c
-imap_ctl_zoneinfo_LDADD = $(LD_UTILITY_ADD)
-
 imap_deliver_SOURCES = \
 	imap/deliver.c \
 	imap/lmtpengine.c \
-	imap/lmtpstats.c \
 	imap/mutex_fake.c \
 	imap/proxy.c \
 	imap/spool.c
 
+nodist_imap_deliver_SOURCES = imap/lmtp_err.c imap/lmtpstats.c
+
 imap_deliver_LDADD = $(LD_UTILITY_ADD)
 
 imap_fetchnews_SOURCES = imap/cli_fatal.c imap/fetchnews.c imap/mutex_fake.c
@@ -933,14 +940,14 @@ imap_imapd_SOURCES = \
 	imap/imapd.c \
 	imap/imapd.h \
 	imap/mutex_fake.c \
-	imap/pushstats.c \
-	imap/pushstats.h \
 	imap/proxy.c \
 	imap/proxy.h \
 	imap/sync_support.c \
 	imap/sync_support.h \
 	master/service.c
 
+nodist_imap_imapd_SOURCES = imap/pushstats.c
+
 if AUTOCREATE
 imap_imapd_SOURCES += \
 	imap/autocreate.h \
@@ -953,21 +960,23 @@ imap_ipurge_SOURCES = imap/cli_fatal.c i
 imap_ipurge_LDADD = $(LD_UTILITY_ADD)
 
 nodist_imap_libcyrus_imap_la_SOURCES = \
+	imap/http_err.c \
+	imap/http_err.h \
 	imap/imap_err.c \
+	imap/imap_err.h \
 	imap/mupdate_err.c \
-	imap/mupdate_err.h
-
-dist_imap_libcyrus_imap_la_SOURCES =
+	imap/mupdate_err.h \
+	imap/promdata.c \
+	imap/promdata.h
 
 imap_libcyrus_imap_la_LIBADD = \
     $(COM_ERR_LIBS) \
     $(LIB_UUID) \
     $(GCOV_LIBS) \
-    $(JANSSON_LIBS) \
     lib/libcyrus_min.la \
     lib/libcyrus.la
 
-imap_libcyrus_imap_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY) $(JANSSON_CFLAGS)
+imap_libcyrus_imap_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 imap_libcyrus_imap_la_CXXFLAGS = $(AM_CXXFLAGS)
 
 imap_libcyrus_imap_la_SOURCES = \
@@ -987,6 +996,8 @@ imap_libcyrus_imap_la_SOURCES = \
 	imap/duplicate.h \
 	imap/global.c \
 	imap/global.h \
+	imap/http_client.c \
+	imap/http_client.h \
 	imap/idle.c \
 	imap/idle.h \
 	imap/idlemsg.c \
@@ -995,6 +1006,7 @@ imap_libcyrus_imap_la_SOURCES = \
 	imap/imapparse.h \
 	imap/index.c \
 	imap/index.h \
+	imap/json_support.h \
 	imap/mailbox.c \
 	imap/mailbox.h \
 	imap/mbdump.c \
@@ -1012,6 +1024,8 @@ imap_libcyrus_imap_la_SOURCES = \
 	imap/message.c \
 	imap/message.h \
 	imap/message_priv.h \
+	imap/msgrecord.c \
+	imap/msgrecord.h \
 	imap/mupdate-client.c \
 	imap/mupdate-client.h \
 	imap/mutex.h \
@@ -1021,10 +1035,13 @@ imap_libcyrus_imap_la_SOURCES = \
 	imap/partlist.h \
 	imap/proc.c \
 	imap/proc.h \
+	imap/prometheus.c \
+	imap/prometheus.h \
 	imap/protocol.h \
 	imap/quota_db.c \
 	imap/rfc822_header.c \
 	imap/rfc822_header.h \
+	imap/mailbox_header_cache.h \
 	imap/saslclient.c \
 	imap/saslclient.h \
 	imap/saslserver.c \
@@ -1035,11 +1052,14 @@ imap_libcyrus_imap_la_SOURCES = \
 	imap/search_query.c \
 	imap/search_query.h \
 	imap/search_part.h \
+	imap/search_sort.h \
 	imap/seen.h \
 	imap/seen_db.c \
 	imap/sequence.c \
 	imap/sequence.h \
 	imap/setproctitle.c \
+	imap/spool.c \
+	imap/spool.h \
 	imap/statuscache.h \
 	imap/statuscache_db.c \
 	imap/sync_log.c \
@@ -1088,13 +1108,6 @@ imap_libcyrus_imap_la_SOURCES += \
 	imap/squat_internal.h
 endif
 
-if USE_SPHINX
-imap_libcyrus_imap_la_SOURCES += \
-	imap/search_sphinx.c \
-	imap/sphinxmgr_client.c \
-	imap/sphinxmgr_client.h
-endif
-
 if HTTPD
 imap_libcyrus_imap_la_SOURCES += \
 	imap/caldav_alarm.c \
@@ -1109,6 +1122,8 @@ imap_libcyrus_imap_la_SOURCES += \
 	imap/dav_util.h \
 	imap/ical_support.c \
 	imap/ical_support.h \
+	imap/icu_wrap.h \
+	imap/icu_wrap.cpp \
 	imap/vcard_support.c \
 	imap/vcard_support.h \
 	imap/webdav_db.c \
@@ -1116,6 +1131,12 @@ imap_libcyrus_imap_la_SOURCES += \
 
 endif # HTTPD
 
+if JMAP
+imap_libcyrus_imap_la_SOURCES += \
+	imap/smtpclient.c \
+	imap/smtpclient.h
+endif
+
 if USE_XAPIAN
 imap_libcyrus_imap_la_SOURCES += \
 	imap/search_xapian.c \
@@ -1123,6 +1144,12 @@ imap_libcyrus_imap_la_SOURCES += \
 	imap/xapian_wrap.cpp
 imap_libcyrus_imap_la_LIBADD += $(XAPIAN_LIBS)
 imap_libcyrus_imap_la_CXXFLAGS += $(XAPIAN_CXXFLAGS)
+
+if HAVE_CLD2
+imap_libcyrus_imap_la_LIBADD += $(CLD2_LIBS)
+imap_libcyrus_imap_la_CXXFLAGS += $(CLD2_CFLAGS)
+endif
+
 endif
 
 imap_lmtpd_SOURCES = \
@@ -1130,13 +1157,13 @@ imap_lmtpd_SOURCES = \
 	imap/lmtpd.h \
 	imap/lmtpengine.c \
 	imap/lmtpengine.h \
-	imap/lmtpstats.c \
-	imap/lmtpstats.h \
 	imap/mutex_fake.c \
 	imap/proxy.c \
 	imap/spool.c \
 	master/service.c
 
+nodist_imap_lmtpd_SOURCES = imap/lmtp_err.c imap/lmtpstats.c
+
 if AUTOCREATE
 imap_lmtpd_SOURCES += \
 	imap/autocreate.c \
@@ -1145,16 +1172,18 @@ endif # AUTOCREATE
 
 if SIEVE
 imap_lmtpd_SOURCES += imap/lmtp_sieve.c imap/lmtp_sieve.h imap/smtpclient.c
+
+if JMAP
+imap_lmtpd_SOURCES += imap/jmap_util.c imap/jmap_mail_query.c
+endif # JMAP
+
 endif # SIEVE
 
 imap_lmtpd_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
 
 SNMPGEN = $(abs_top_srcdir)/snmp/snmpgen
 
-imap/lmtpstats.c: imap/lmtpstats.snmp $(SNMPGEN)
-	$(AM_V_GEN)(cd $(@D) && $(SNMPGEN) $(realpath $<))
-
-imap/pushstats.c: imap/pushstats.snmp $(SNMPGEN)
+imap/%stats.h imap/%stats.c: imap/%stats.snmp $(SNMPGEN)
 	$(AM_V_GEN)(cd $(@D) && $(SNMPGEN) $(realpath $<))
 
 imap_mbexamine_SOURCES = imap/cli_fatal.c imap/mbexamine.c imap/mutex_fake.c
@@ -1179,9 +1208,8 @@ imap_mupdate_SOURCES = \
 imap_mupdate_LDADD = $(LD_SERVER_ADD) -lpthread
 imap_mupdate_CFLAGS =  $(AM_CFLAGS) -pthread
 
-nodist_imap_nntpd_SOURCES = \
-	imap/nntp_err.c \
-	imap/nntp_err.h
+nodist_imap_nntpd_SOURCES = imap/nntp_err.c
+
 imap_nntpd_SOURCES = \
 	imap/mutex_fake.c \
 	imap/nntpd.c \
@@ -1196,35 +1224,41 @@ imap_nntpd_LDADD = $(LD_SERVER_ADD)
 nodist_imap_httpd_SOURCES = \
 	imap/http_caldav_js.h \
 	imap/http_carddav_js.h \
-	imap/http_err.c \
-	imap/http_err.h \
 	imap/tz_err.c \
 	imap/tz_err.h
 
 imap_httpd_SOURCES = \
-	imap/caldav_db.c \
+	imap/css3_color.c \
+	imap/css3_color.h \
 	imap/http_admin.c \
 	imap/http_applepush.c \
 	imap/http_caldav.c \
 	imap/http_caldav.h \
+	imap/http_caldav_js.h \
 	imap/http_caldav_sched.c \
 	imap/http_caldav_sched.h \
 	imap/http_carddav.c \
 	imap/http_carddav.h \
-	imap/http_client.c \
-	imap/http_client.h \
+	imap/http_carddav_js.h \
+	imap/http_cgi.c \
 	imap/http_dav.c \
 	imap/http_dav.h \
+	imap/http_dav_sharing.c \
+	imap/http_dav_sharing.h \
 	imap/http_dblookup.c \
+	imap/http_h2.c \
+	imap/http_h2.h \
 	imap/http_ischedule.c \
+	imap/http_prometheus.c \
 	imap/http_proxy.c \
 	imap/http_proxy.h \
 	imap/http_rss.c \
 	imap/http_tzdist.c \
 	imap/http_webdav.c \
+	imap/http_ws.c \
+	imap/http_ws.h \
 	imap/httpd.c \
 	imap/httpd.h \
-	imap/ical_support.c \
 	imap/jcal.c \
 	imap/jcal.h \
 	imap/json_support.h \
@@ -1232,7 +1266,6 @@ imap_httpd_SOURCES = \
 	imap/proxy.c \
 	imap/smtpclient.c \
 	imap/spool.c \
-	imap/vcard_support.c \
 	imap/xcal.c \
 	imap/xcal.h \
 	imap/xml_support.c \
@@ -1244,6 +1277,53 @@ imap_httpd_SOURCES = \
 
 imap_httpd_LDADD = $(LD_SERVER_ADD)
 
+if JMAP
+BUILT_SOURCES += \
+	imap/jmap_err.c \
+	imap/jmap_err.h
+
+imap_httpd_SOURCES += \
+	imap/http_jmap.c \
+	imap/http_jmap.h \
+	imap/jmap_api.c \
+	imap/jmap_api.h \
+	imap/jmap_calendar.c \
+	imap/jmap_contact.c \
+	imap/jmap_core.c \
+	imap/jmap_ical.c \
+	imap/jmap_ical.h \
+	imap/jmap_mail.c \
+	imap/jmap_mail.h \
+	imap/jmap_mail_query.c \
+	imap/jmap_mail_query.h \
+	imap/jmap_mail_submission.c \
+	imap/jmap_mailbox.c \
+	imap/jmap_util.c \
+	imap/jmap_util.h \
+	imap/jmap_vacation.c \
+	imap/sync_support.c \
+        imap/sync_support.h
+
+nodist_imap_httpd_SOURCES += \
+	imap/jmap_err.c \
+	imap/jmap_err.h
+
+imap_libcyrus_imap_la_SOURCES += \
+	imap/jmap_util.c \
+	imap/jmap_util.h \
+	imap/json_support.c \
+	imap/json_support.h
+
+imap_httpd_LDADD += $(LD_SIEVE_ADD)
+
+if CUNIT
+
+cunit_TESTS += cunit/jmap_util.testc
+
+endif # CUNIT
+
+endif # JMAP
+
 imap_pop3d_SOURCES = \
 	imap/mutex_fake.c \
 	imap/pop3d.c \
@@ -1258,8 +1338,19 @@ endif # AUTOCREATE
 
 imap_pop3d_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
 
+PROMDATAGEN = $(abs_top_srcdir)/imap/promdatagen
+
+imap/promdata.c: imap/promdata.p $(PROMDATAGEN)
+	$(AM_V_GEN)$(PROMDATAGEN) -c $@.NEW $< && mv $@.NEW $@
+
+imap/promdata.h: imap/promdata.p $(PROMDATAGEN)
+	$(AM_V_GEN)$(PROMDATAGEN) -h $@.NEW $< && mv $@.NEW $@
+
+imap_promstatsd_SOURCES = imap/promstatsd.c imap/mutex_fake.c
+imap_promstatsd_LDADD = $(LD_UTILITY_ADD)
+
 imap_quota_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/quota.c imap/quota.h
-imap_quota_LDADD = $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+imap_quota_LDADD = $(LD_UTILITY_ADD)
 
 imap_reconstruct_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/reconstruct.c
 imap_reconstruct_LDADD = $(LD_UTILITY_ADD)
@@ -1267,6 +1358,9 @@ imap_reconstruct_LDADD = $(LD_UTILITY_AD
 imap_dav_reconstruct_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/dav_reconstruct.c
 imap_dav_reconstruct_LDADD = $(LD_UTILITY_ADD)
 
+imap_ical_apply_patch_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/ical_apply_patch.c
+imap_ical_apply_patch_LDADD = $(LD_UTILITY_ADD)
+
 imap_search_test_SOURCES = imap/search_test.c imap/mutex_fake.c
 imap_search_test_LDADD = $(LD_UTILITY_ADD)
 
@@ -1296,30 +1390,15 @@ imap_unexpunge_LDADD = $(LD_UTILITY_ADD)
 
 # $(COMPILE_ET) creates its output files in the directory it's run from,
 # so do a tricky directory change
-imap/imap_err.h imap/imap_err.c: imap/imap_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/mupdate_err.h imap/mupdate_err.c: imap/mupdate_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/nntp_err.h imap/nntp_err.c: imap/nntp_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/http_err.h imap/http_err.c: imap/http_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/tz_err.h imap/tz_err.c: imap/tz_err.et $(COMPILE_ET_DEP)
+%_err.h %_err.c: %_err.et $(COMPILE_ET_DEP)
 	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
 
 # xxd cannot have path details in its input filename, otherwise it junks up
 # the variable names in the output file.  so do a tricky directory change.
 # the /dev/null redirection on cd is to prevent shell environments with
 # CDPATH echoing the path change on stdout and consequently into the .h file
-imap/http_caldav_js.h: imap/http_caldav.js
-	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@
-
-imap/http_carddav_js.h: imap/http_carddav.js
-	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@
+%_js.h: %.js
+	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@.NEW && mv $@.NEW $@
 
 if MAINTAINER_MODE
 imap/rfc822_header.c: imap/rfc822_header.st
@@ -1333,6 +1412,9 @@ lib/htmlchar.c: lib/htmlchar.st
 
 lib/htmlchar.h: lib/htmlchar.st
 	$(AM_V_GEN)${top_srcdir}/tools/compile_st.pl -h $< > $@.NEW && mv $@.NEW $@
+
+imap/mailbox_header_cache.h: imap/mailbox_header_cache.gperf
+	$(AM_V_GEN)gperf --ignore-case --initializer-suffix=,0 -p -j1 -i 1 -g -o -t -H mailbox_header_cache_hash -N mailbox_header_cache_lookup -k1,3,$$ $< > $@.NEW && mv $@.NEW $@
 endif
 
 imtest_imtest_SOURCES = imtest/imtest.c
@@ -1353,6 +1435,7 @@ lib_libcyrus_la_SOURCES = \
 	lib/bsearch.c \
 	lib/charset.c \
 	lib/command.c \
+	lib/cyr_qsort_r.c \
 	lib/cyrusdb.c \
 	lib/cyrusdb_flat.c \
 	lib/cyrusdb_quotalegacy.c \
@@ -1383,9 +1466,6 @@ lib_libcyrus_la_SOURCES = \
 if USE_CYRUSDB_SQL
 lib_libcyrus_la_SOURCES += lib/cyrusdb_sql.c
 endif
-if USE_CYRUSDB_LMDB
-lib_libcyrus_la_SOURCES += lib/cyrusdb_lmdb.c
-endif
 if USE_SQLITE
 lib_libcyrus_la_SOURCES += lib/sqldb.c
 endif
@@ -1400,11 +1480,15 @@ else
 lib_libcyrus_la_SOURCES += lib/nonblock_ioctl.c
 endif
 lib_libcyrus_la_LIBADD = libcrc32.la ${LIB_SASL} $(SSL_LIBS) $(GCOV_LIBS)
-if USE_CYRUSDB_LMDB
-lib_libcyrus_la_LIBADD += -llmdb
-endif
 lib_libcyrus_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 
+if USE_ZEROSKIP
+lib_libcyrus_la_SOURCES += lib/cyrusdb_zeroskip.c
+lib_libcyrus_la_LIBADD += $(ZEROSKIP_LIBS)
+lib_libcyrus_la_CFLAGS += $(ZEROSKIP_CFLAGS)
+AM_CPPFLAGS += $(ZEROSKIP_CFLAGS)
+endif
+
 noinst_LTLIBRARIES += libcrc32.la
 libcrc32_la_SOURCES = lib/crc32.c lib/crc32c.c
 libcrc32_la_CFLAGS = -O3 $(AM_CFLAGS) $(CFLAG_VISIBILITY)
@@ -1418,6 +1502,7 @@ lib_libcyrus_min_la_SOURCES = \
 	lib/bufarray.c \
 	lib/byteorder64.c \
 	lib/hash.c \
+	lib/hashset.c \
 	lib/hashu64.c \
 	lib/libconfig.c \
 	lib/mpool.c \
@@ -1453,7 +1538,7 @@ else
 lib_libcyrus_min_la_SOURCES += lib/map_nommap.c
 endif
 endif
-lib_libcyrus_min_la_LIBADD = $(LTLIBOBJS) $(LIB_UUID) $(GCOV_LIBS)
+lib_libcyrus_min_la_LIBADD = $(LTLIBOBJS) $(LIB_UUID) $(GCOV_LIBS) $(LIBCAP_LIBS)
 lib_libcyrus_min_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 
 # n.b. the order of the -m arguments to mkchartable.pl is important,
@@ -1537,49 +1622,31 @@ dist_man8_MANS = \
 if SQUATTER
 dist_man8_MANS += \
 	man/squatter.8
-
-else
-EXTRA_DIST += \
-	man/squatter.8
-
 endif # SQUATTER
 
 if NNTPD
 dist_man8_MANS += \
 	man/fetchnews.8 \
 	man/nntpd.8
-
-else # NNTPD
-EXTRA_DIST += \
-	man/fetchnews.8 \
-	man/nntpd.8
-
 endif # NNTPD
 
 if HTTPD
 dist_man8_MANS += \
 	man/ctl_zoneinfo.8 \
 	man/httpd.8
-
-else # HTTPD
-EXTRA_DIST += \
-	man/ctl_zoneinfo.8 \
-	man/httpd.8
-
 endif # HTTPD
 
+if BENCH
+check_PROGRAMS += bench/cyrdbbench
+bench_cyrdbbench_SOURCES = bench/cyrdbbench.c imap/mutex_fake.c
+bench_cyrdbbench_LDADD = $(LD_BASIC_ADD)
+endif # BENCH
+
 if REPLICATION
 dist_man8_MANS += \
 	man/sync_client.8 \
 	man/sync_reset.8 \
 	man/sync_server.8
-
-else
-EXTRA_DIST += \
-	man/sync_client.8 \
-	man/sync_reset.8 \
-	man/sync_server.8
-
 endif
 
 master_master_SOURCES = \
@@ -1686,6 +1753,8 @@ sieve_libcyrus_sieve_la_SOURCES = \
 	sieve/bc_emit.c \
 	sieve/bc_eval.c \
 	sieve/bc_generate.c \
+	sieve/bc_parse.c \
+	sieve/bc_parse.h \
 	sieve/comparator.c \
 	sieve/comparator.h \
 	sieve/flags.c \
@@ -1706,6 +1775,13 @@ sieve_libcyrus_sieve_la_SOURCES = \
 	sieve/variables.h \
 	sieve/varlist.c \
 	sieve/varlist.h
+
+if JMAP
+sieve_libcyrus_sieve_la_SOURCES += \
+	imap/json_support.c \
+	imap/json_support.h
+endif
+
 sieve_libcyrus_sieve_la_LIBADD = \
     sieve/libcyrus_sieve_lex.la \
     $(COM_ERR_LIBS) \
@@ -1716,12 +1792,15 @@ sieve_libcyrus_sieve_la_CFLAGS = $(AM_CF
 sieve_sievec_LDADD = $(LD_SIEVE_ADD)
 sieve_sieved_LDADD = $(LD_SIEVE_ADD)
 
-sieve/sieve_err.h sieve/sieve_err.c: sieve/sieve_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
 sieve_test_SOURCES = sieve/test.c imap/mutex_fake.c
+if JMAP
+sieve_test_SOURCES += imap/jmap_util.c imap/jmap_mail_query.c
+endif
 sieve_test_LDADD = $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
 
+sieve_test_mailbox_SOURCES = sieve/test_mailbox.c imap/mutex_fake.c
+sieve_test_mailbox_LDADD = $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
+
 timsieved_timsieved_SOURCES = \
 	imap/mutex_fake.c \
 	imap/proxy.c \
@@ -1751,7 +1830,7 @@ snapshot::
 
 docsrc/imap/reference/manpages/systemcommands/cyradm.rst: $(top_srcdir)/perl/imap/IMAP/Shell.pm
 	@$(MKDIR_P) $(@D)
-	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst cyradm < $< > $@
+	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst cyradm < $< > $@.NEW && mv $@.NEW $@
 
 docsrc/imap/reference/manpages/configs/imapd.conf.rst: $(top_srcdir)/tools/config2rst $(top_srcdir)/lib/imapoptions
 	@$(MKDIR_P) $(@D)
@@ -1763,7 +1842,7 @@ doc/examples/imapd_conf/imapd.conf.sampl
 
 docsrc/imap/reference/manpages/usercommands/sieveshell.rst: $(top_srcdir)/perl/sieve/scripts/sieveshell.pl
 	@$(MKDIR_P) $(@D)
-	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst sieveshell < $< > $@
+	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst sieveshell < $< > $@.NEW && mv $@.NEW $@
 
 %.1: man/.sphinx-build.stamp
 	@$(MKDIR_P) $(@D)
@@ -1789,16 +1868,13 @@ clean-sphinx-cache:
 	@$(RM) -r $(SPHINX_CACHE)
 
 if HAVE_SPHINX_BUILD
-GENERATED_RSTS = docsrc/imap/reference/manpages/configs/imapd.conf.rst \
-                 docsrc/imap/reference/manpages/systemcommands/cyradm.rst \
-                 docsrc/imap/reference/manpages/usercommands/sieveshell.rst
 
 SPHINX_OPTS = -d $(SPHINX_CACHE) -n -q
 
 ## detect when source directory is not build directory (i.e. VPATH
 ## build), and clone the docsrc tree into the build directory, so
 ## that we have a single "source directory" for sphinx-build to use.
-docsrc/.sphinx-build.stamp:
+docsrc/.sphinx-build.stamp: docsrc/imap/reference/manpages/configs/imapd.conf.rst docsrc/imap/reference/manpages/systemcommands/cyradm.rst docsrc/imap/reference/manpages/usercommands/sieveshell.rst
 	$(AM_V_GEN)test x"$(top_srcdir)" = x"$(top_builddir)" || \
         (cd $(top_srcdir) && tar cf - --mode=gu+w docsrc doc/examples) | tar xf -
 	@touch $@
@@ -1808,7 +1884,7 @@ clean-docsrc:
 		$(RM) -r $(top_builddir)/docsrc $(top_builddir)/doc/examples
 
 ## XXX doesn't detect if other rst sources are updated...
-man/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+man/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b cyrman $(top_builddir)/docsrc $(top_builddir)/man
 	@touch $@
 
@@ -1816,12 +1892,12 @@ clean-man:
 	@$(RM) -r man
 
 ## XXX doesn't detect if other rst sources are updated...
-doc/html/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+doc/html/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b html $(top_builddir)/docsrc $(top_builddir)/doc/html
 	@touch $@
 
 ## XXX doesn't detect if other rst sources are updated...
-doc/text/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+doc/text/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b text $(top_builddir)/docsrc $(top_builddir)/doc/text
 	@touch $@
 else
@@ -1873,32 +1949,24 @@ doc-text: doc-text-force doc/text/.sphin
 clean-doc-text:
 	@$(RM) -r doc/text
 
+GENERATED_EXAMPLES = doc/examples/imapd_conf/imapd.conf.sample
+
+.PHONY: doc-examples doc-examples-force clean-doc-examples
+doc-examples-force:
+
+doc-examples: doc-examples-force $(GENERATED_EXAMPLES)
+
+clean-doc-examples:
+	@$(RM) $(GENERATED_EXAMPLES)
+
 .PHONY: doc clean-doc
-doc: man doc-html doc-text
+doc: man doc-html doc-text doc-examples
 
-clean-doc: clean-man clean-doc-html clean-doc-text
+clean-doc: clean-man clean-doc-html clean-doc-text clean-doc-examples
 
 .PHONY: clean-local
 clean-local: clean-doc clean-sphinx-cache clean-docsrc
 
-dist-old:: distgit
-	@echo "creating configure"
-	@cd dist/cyrus-imapd-$(PACKAGE_VERSION) ; sh SMakefile
-	@for d in $(DIST_SUBDIRS); \
-	do \
-	(cd dist/cyrus-imapd-$(PACKAGE_VERSION)/$$d; \
-	if [ -f Makefile.dist ]; then \
-	echo "### Making" dist "in" `pwd`; \
-	$(MAKE) $(MFLAGS) YACC='$(YACC)' LEX='$(LEX)' \
-	COMPILE_ET='$(COMPILE_ET)' -f Makefile.dist dist ; \
-	fi) || exit 1; \
-	done
-	@echo "creating tarfile"
-	@cd dist ; tar cf - cyrus-imapd-$(PACKAGE_VERSION) | \
-	gzip -9 > ../cyrus-imapd-$(PACKAGE_VERSION).tar.gz
-	rm -f distgit
-	rm -rf dist
-
 distgit:
 	$(MKDIR_P) dist
 	@echo "checking out the distribution from tag $(PACKAGE_NAME)-$(PACKAGE_VERSION)"
@@ -1907,6 +1975,7 @@ distgit:
 
 dist-hook:
 	find $(top_distdir) -type f -name .sphinx-build.stamp -delete
+	find $(top_distdir) -type f -name .gitignore -delete
 	rm -rf $(top_distdir)/$(SPHINX_CACHE)
 
 VERSION: tools/git-version.sh
@@ -1979,6 +2048,7 @@ install-binsymlinks:
 SUFFIXES = .fig.png
 
 .fig.png:
+	mkdir -p $(@D)
 	fig2dev -L png $< $@
 
 valgrind:
diff -pruN 3.0.13-5/Makefile.in 3.2.0-3/Makefile.in
--- 3.0.13-5/Makefile.in	2019-12-16 04:15:47.000000000 +0000
+++ 3.2.0-3/Makefile.in	2020-05-04 04:10:17.000000000 +0000
@@ -137,30 +137,40 @@ build_triplet = @build@
 host_triplet = @host@
 target_triplet = @target@
 @HAVE_LDAP_TRUE@am__append_1 = $(LDAP_CPPFLAGS)
-EXTRA_PROGRAMS =
-check_PROGRAMS = $(am__EXEEXT_1) $(am__EXEEXT_2) $(am__EXEEXT_3)
-libexec_PROGRAMS = $(am__EXEEXT_4) $(am__EXEEXT_5) $(am__EXEEXT_6) \
-	$(am__EXEEXT_7) $(am__EXEEXT_8) $(am__EXEEXT_5) \
+check_PROGRAMS = $(am__EXEEXT_1) $(am__EXEEXT_2) $(am__EXEEXT_3) \
+	$(am__EXEEXT_4) $(am__EXEEXT_5)
+libexec_PROGRAMS = $(am__EXEEXT_6) $(am__EXEEXT_7) $(am__EXEEXT_8) \
 	$(am__EXEEXT_9) $(am__EXEEXT_10) $(am__EXEEXT_11) \
 	$(am__EXEEXT_12) $(am__EXEEXT_13) $(am__EXEEXT_14) \
-	$(am__EXEEXT_15)
-sbin_PROGRAMS = $(am__EXEEXT_18) $(am__EXEEXT_19) $(am__EXEEXT_20) \
-	$(am__EXEEXT_21) $(am__EXEEXT_22) $(am__EXEEXT_23) \
-	$(am__EXEEXT_24) $(am__EXEEXT_25) $(am__EXEEXT_26) \
-	$(am__EXEEXT_27) $(am__EXEEXT_28) $(am__EXEEXT_29)
-noinst_PROGRAMS = $(am__EXEEXT_16) $(am__EXEEXT_17)
+	$(am__EXEEXT_15) $(am__EXEEXT_16) $(am__EXEEXT_17)
+sbin_PROGRAMS = $(am__EXEEXT_20) $(am__EXEEXT_21) $(am__EXEEXT_22) \
+	$(am__EXEEXT_23) $(am__EXEEXT_24) $(am__EXEEXT_25) \
+	$(am__EXEEXT_26) $(am__EXEEXT_27) $(am__EXEEXT_28) \
+	$(am__EXEEXT_29) $(am__EXEEXT_30)
+noinst_PROGRAMS = $(am__EXEEXT_18) $(am__EXEEXT_19)
 @COM_ERR_TRUE@am__append_2 = com_err/et/compile_et com_err/et/libcyrus_com_err.la
 @COM_ERR_TRUE@am__append_3 = com_err/et/libcyrus_com_err.la
 bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @SERVER_TRUE@am__append_4 = \
-@SERVER_TRUE@	imap/mupdate_err.c \
-@SERVER_TRUE@	imap/nntp_err.c \
+@SERVER_TRUE@	imap/http_err.c \
+@SERVER_TRUE@	imap/http_err.h \
+@SERVER_TRUE@	imap/imap_err.c \
+@SERVER_TRUE@	imap/imap_err.h \
+@SERVER_TRUE@	imap/lmtp_err.c \
+@SERVER_TRUE@	imap/lmtp_err.h \
 @SERVER_TRUE@	imap/lmtpstats.c \
+@SERVER_TRUE@	imap/lmtpstats.h \
+@SERVER_TRUE@	imap/mupdate_err.c \
+@SERVER_TRUE@	imap/mupdate_err.h \
 @SERVER_TRUE@	imap/pushstats.c \
+@SERVER_TRUE@	imap/pushstats.h \
+@SERVER_TRUE@	imap/promdata.c \
+@SERVER_TRUE@	imap/promdata.h \
 @SERVER_TRUE@	lib/htmlchar.c \
 @SERVER_TRUE@	lib/htmlchar.h \
 @SERVER_TRUE@	imap/rfc822_header.c \
-@SERVER_TRUE@	imap/rfc822_header.h
+@SERVER_TRUE@	imap/rfc822_header.h \
+@SERVER_TRUE@	imap/mailbox_header_cache.h
 
 @SERVER_TRUE@am__append_5 = imap/libcyrus_imap.la
 @SERVER_TRUE@am__append_6 = \
@@ -168,6 +178,7 @@ bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @SERVER_TRUE@	imap/imapd \
 @SERVER_TRUE@	imap/lmtpd \
 @SERVER_TRUE@	imap/pop3d \
+@SERVER_TRUE@	imap/promstatsd \
 @SERVER_TRUE@	imap/smmapd
 
 @SERVER_TRUE@am__append_7 = \
@@ -202,28 +213,26 @@ bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @SERVER_TRUE@	imap/message_test \
 @SERVER_TRUE@	imap/search_test
 
-@SERVER_TRUE@@USE_SPHINX_TRUE@am__append_9 = imap/cyr_sphinxmgr
-@SERVER_TRUE@@USE_SQUAT_TRUE@am__append_10 = imap/squat_dump
+@SERVER_TRUE@@USE_SQUAT_TRUE@am__append_9 = imap/squat_dump
 # Despite the name, the squatter program handles any search engine
-@SERVER_TRUE@@SQUATTER_TRUE@am__append_11 = imap/squatter
-@NNTPD_TRUE@@SERVER_TRUE@am__append_12 = imap/nntpd
-@NNTPD_TRUE@@SERVER_TRUE@am__append_13 = imap/fetchnews
+@SERVER_TRUE@@SQUATTER_TRUE@am__append_10 = imap/squatter
+@NNTPD_TRUE@@SERVER_TRUE@am__append_11 = imap/nntpd
+@NNTPD_TRUE@@SERVER_TRUE@am__append_12 = imap/fetchnews
+@NNTPD_TRUE@@SERVER_TRUE@am__append_13 = imap/nntp_err.c
 @SERVER_TRUE@am__append_14 = imap/fud
 @IDLED_TRUE@@SERVER_TRUE@am__append_15 = imap/idled
 @MURDER_TRUE@@SERVER_TRUE@am__append_16 = imap/mupdate
-@NNTPD_TRUE@@SERVER_TRUE@am__append_17 = imap/nntpd
-@CALALARMD_TRUE@@SERVER_TRUE@am__append_18 = imap/calalarmd
-@HTTPD_TRUE@@SERVER_TRUE@am__append_19 = $(HTTP_CPPFLAGS)
-@HTTPD_TRUE@@SERVER_TRUE@am__append_20 = $(HTTP_LIBS)
-@HTTPD_TRUE@@SERVER_TRUE@am__append_21 = \
+@CALALARMD_TRUE@@SERVER_TRUE@am__append_17 = imap/calalarmd
+@HTTPD_TRUE@@SERVER_TRUE@am__append_18 = $(HTTP_CPPFLAGS)
+@HTTPD_TRUE@@SERVER_TRUE@am__append_19 = $(HTTP_LIBS)
+@HTTPD_TRUE@@SERVER_TRUE@am__append_20 = \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/http_caldav_js.h \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/http_carddav_js.h \
-@HTTPD_TRUE@@SERVER_TRUE@	imap/http_err.c \
-@HTTPD_TRUE@@SERVER_TRUE@	imap/http_err.h \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/tz_err.c \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/tz_err.h
 
-@HTTPD_TRUE@@SERVER_TRUE@am__append_22 = imap/httpd
+@HTTPD_TRUE@@SERVER_TRUE@am__append_21 = imap/httpd
+@HTTPD_TRUE@@SERVER_TRUE@am__append_22 = imap/ical_apply_patch
 @HTTPD_TRUE@@SERVER_TRUE@am__append_23 = \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/ctl_zoneinfo \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/dav_reconstruct
@@ -238,53 +247,47 @@ bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @SERVER_TRUE@am__append_31 = imap/unexpunge
 @SERVER_TRUE@@SIEVE_TRUE@am__append_32 = notifyd/notifytest
 @SERVER_TRUE@@SIEVE_TRUE@am__append_33 = notifyd/notifyd
-@SERVER_FALSE@am__append_34 = \
-@SERVER_FALSE@    imap/mupdate_err.c \
-@SERVER_FALSE@    imap/nntp_err.c \
-@SERVER_FALSE@    imap/lmtpstats.c \
-@SERVER_FALSE@    imap/pushstats.c \
-@SERVER_FALSE@    imap/rfc822_header.c \
-@SERVER_FALSE@    imap/rfc822_header.h
-
-@HTTPD_FALSE@@SERVER_FALSE@am__append_35 = \
-@HTTPD_FALSE@@SERVER_FALSE@	imap/http_err.c \
-@HTTPD_FALSE@@SERVER_FALSE@	imap/http_err.h \
-@HTTPD_FALSE@@SERVER_FALSE@	imap/tz_err.c \
-@HTTPD_FALSE@@SERVER_FALSE@	imap/tz_err.h
-
-@CMULOCAL_TRUE@am__append_36 = depot/rc.local.imap depot/rc.local.ptclient
-@CMULOCAL_TRUE@am__append_37 = netnews/remotepurge
-@PTCLIENT_TRUE@am__append_38 = ptclient/ptdump ptclient/ptexpire
-@PTCLIENT_TRUE@am__append_39 = \
+@CMULOCAL_TRUE@am__append_34 = depot/rc.local.imap depot/rc.local.ptclient
+@CMULOCAL_TRUE@am__append_35 = netnews/remotepurge
+@PTCLIENT_TRUE@am__append_36 = ptclient/ptdump ptclient/ptexpire
+@PTCLIENT_TRUE@am__append_37 = \
 @PTCLIENT_TRUE@	ptclient/ptloader
 
-@PERL_TRUE@am__append_40 = perl/annotator perl/imap
-@PERL_TRUE@am__append_41 = perl/libcyrus.la perl/libcyrus_min.la
-@PERL_TRUE@@SIEVE_TRUE@am__append_42 = perl/sieve/managesieve
-@PERL_TRUE@@SIEVE_TRUE@am__append_43 = perl/sieve/lib/libisieve.la
-@SIEVE_TRUE@am__append_44 = sieve/addr.c sieve/sieve.c sieve/sieve_err.c
-@SIEVE_TRUE@am__append_45 = sieve/libcyrus_sieve_lex.la
-@SIEVE_TRUE@am__append_46 = sieve/libcyrus_sieve.la
-@SIEVE_TRUE@am__append_47 = sieve/test
-@SIEVE_TRUE@am__append_48 = sieve/sievec sieve/sieved
-@SERVER_TRUE@@SIEVE_TRUE@am__append_49 = timsieved/timsieved
-@CUNIT_TRUE@am__append_50 = cunit/registers.h $(CUNIT_PROJECT)
-@CUNIT_TRUE@am__append_51 = cunit/registers.h $(CUNIT_PROJECT)
-@CUNIT_TRUE@am__append_52 = cunit/unit
-@CUNIT_TRUE@@SIEVE_TRUE@am__append_53 = cunit/sieve.testc
-@AUTOCREATE_TRUE@am__append_54 = \
+@PERL_TRUE@am__append_38 = perl/annotator perl/imap
+@PERL_TRUE@am__append_39 = perl/libcyrus.la perl/libcyrus_min.la
+@PERL_TRUE@@SIEVE_TRUE@am__append_40 = perl/sieve/managesieve
+@PERL_TRUE@@SIEVE_TRUE@am__append_41 = perl/sieve/lib/libisieve.la
+@SIEVE_TRUE@am__append_42 = sieve/addr.c sieve/sieve.c sieve/sieve_err.c
+@SIEVE_TRUE@am__append_43 = sieve/libcyrus_sieve_lex.la
+@SIEVE_TRUE@am__append_44 = sieve/libcyrus_sieve.la
+@SIEVE_TRUE@am__append_45 = sieve/test sieve/test_mailbox
+@SIEVE_TRUE@am__append_46 = sieve/sievec sieve/sieved
+@SERVER_TRUE@@SIEVE_TRUE@am__append_47 = timsieved/timsieved
+
+# ----
+@USE_LIBCHARDET_TRUE@am__append_48 = $(LIBCHARDET_LIBS)
+@USE_LIBCHARDET_TRUE@am__append_49 = $(LIBCHARDET_CFLAGS)
+@USE_LIBCHARDET_TRUE@am__append_50 = $(LIBCHARDET_LIBS)
+@USE_JANSSON_TRUE@am__append_51 = $(JANSSON_LIBS)
+@USE_JANSSON_TRUE@am__append_52 = $(JANSSON_CFLAGS)
+@USE_JANSSON_TRUE@am__append_53 = $(JANSSON_LIBS)
+@CUNIT_TRUE@am__append_54 = cunit/registers.h $(CUNIT_PROJECT)
+@CUNIT_TRUE@am__append_55 = cunit/registers.h $(CUNIT_PROJECT)
+@CUNIT_TRUE@am__append_56 = cunit/unit
+@CUNIT_TRUE@@SIEVE_TRUE@am__append_57 = cunit/sieve.testc
+@AUTOCREATE_TRUE@am__append_58 = \
 @AUTOCREATE_TRUE@	imap/autocreate.h \
 @AUTOCREATE_TRUE@	imap/autocreate.c
 
-@OBJECTSTORE_TRUE@am__append_55 = \
+@OBJECTSTORE_TRUE@am__append_59 = \
 @OBJECTSTORE_TRUE@    imap/objectstore_db.c \
 @OBJECTSTORE_TRUE@    imap/objectstore_db.h \
 @OBJECTSTORE_TRUE@    imap/objectstore.h
 
-@OBJECTSTORE_TRUE@@WITH_OPENIO_TRUE@am__append_56 = imap/objectstore_openio.c
-@OBJECTSTORE_TRUE@@WITH_CARINGO_TRUE@@WITH_OPENIO_FALSE@am__append_57 = imap/objectstore_caringo.c
-@OBJECTSTORE_TRUE@@WITH_CARINGO_FALSE@@WITH_OBJSTR_DUMMY_TRUE@@WITH_OPENIO_FALSE@am__append_58 = imap/objectstore_dummy.c
-@USE_SQUAT_TRUE@am__append_59 = \
+@OBJECTSTORE_TRUE@@WITH_OPENIO_TRUE@am__append_60 = imap/objectstore_openio.c
+@OBJECTSTORE_TRUE@@WITH_CARINGO_TRUE@@WITH_OPENIO_FALSE@am__append_61 = imap/objectstore_caringo.c
+@OBJECTSTORE_TRUE@@WITH_CARINGO_FALSE@@WITH_OBJSTR_DUMMY_TRUE@@WITH_OPENIO_FALSE@am__append_62 = imap/objectstore_dummy.c
+@USE_SQUAT_TRUE@am__append_63 = \
 @USE_SQUAT_TRUE@	imap/search_squat.c \
 @USE_SQUAT_TRUE@	imap/squat.c \
 @USE_SQUAT_TRUE@	imap/squat.h \
@@ -292,12 +295,7 @@ bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @USE_SQUAT_TRUE@	imap/squat_internal.c \
 @USE_SQUAT_TRUE@	imap/squat_internal.h
 
-@USE_SPHINX_TRUE@am__append_60 = \
-@USE_SPHINX_TRUE@	imap/search_sphinx.c \
-@USE_SPHINX_TRUE@	imap/sphinxmgr_client.c \
-@USE_SPHINX_TRUE@	imap/sphinxmgr_client.h
-
-@HTTPD_TRUE@am__append_61 = \
+@HTTPD_TRUE@am__append_64 = \
 @HTTPD_TRUE@	imap/caldav_alarm.c \
 @HTTPD_TRUE@	imap/caldav_alarm.h \
 @HTTPD_TRUE@	imap/caldav_db.c \
@@ -310,87 +308,127 @@ bin_PROGRAMS = imtest/imtest$(EXEEXT)
 @HTTPD_TRUE@	imap/dav_util.h \
 @HTTPD_TRUE@	imap/ical_support.c \
 @HTTPD_TRUE@	imap/ical_support.h \
+@HTTPD_TRUE@	imap/icu_wrap.h \
+@HTTPD_TRUE@	imap/icu_wrap.cpp \
 @HTTPD_TRUE@	imap/vcard_support.c \
 @HTTPD_TRUE@	imap/vcard_support.h \
 @HTTPD_TRUE@	imap/webdav_db.c \
 @HTTPD_TRUE@	imap/webdav_db.h
 
-@USE_XAPIAN_TRUE@am__append_62 = \
+@JMAP_TRUE@am__append_65 = \
+@JMAP_TRUE@	imap/smtpclient.c \
+@JMAP_TRUE@	imap/smtpclient.h
+
+@USE_XAPIAN_TRUE@am__append_66 = \
 @USE_XAPIAN_TRUE@	imap/search_xapian.c \
 @USE_XAPIAN_TRUE@	imap/xapian_wrap.h \
 @USE_XAPIAN_TRUE@	imap/xapian_wrap.cpp
 
-@USE_XAPIAN_TRUE@am__append_63 = $(XAPIAN_LIBS)
-@USE_XAPIAN_TRUE@am__append_64 = $(XAPIAN_CXXFLAGS)
-@AUTOCREATE_TRUE@am__append_65 = \
+@USE_XAPIAN_TRUE@am__append_67 = $(XAPIAN_LIBS)
+@USE_XAPIAN_TRUE@am__append_68 = $(XAPIAN_CXXFLAGS)
+@HAVE_CLD2_TRUE@@USE_XAPIAN_TRUE@am__append_69 = $(CLD2_LIBS)
+@HAVE_CLD2_TRUE@@USE_XAPIAN_TRUE@am__append_70 = $(CLD2_CFLAGS)
+@AUTOCREATE_TRUE@am__append_71 = \
 @AUTOCREATE_TRUE@	imap/autocreate.c \
 @AUTOCREATE_TRUE@	imap/autocreate.h
 
-@SIEVE_TRUE@am__append_66 = imap/lmtp_sieve.c imap/lmtp_sieve.h imap/smtpclient.c
-@AUTOCREATE_TRUE@am__append_67 = \
+@SIEVE_TRUE@am__append_72 = imap/lmtp_sieve.c imap/lmtp_sieve.h imap/smtpclient.c
+@JMAP_TRUE@@SIEVE_TRUE@am__append_73 = imap/jmap_util.c imap/jmap_mail_query.c
+@JMAP_TRUE@am__append_74 = \
+@JMAP_TRUE@	imap/jmap_err.c \
+@JMAP_TRUE@	imap/jmap_err.h
+
+@JMAP_TRUE@am__append_75 = \
+@JMAP_TRUE@	imap/http_jmap.c \
+@JMAP_TRUE@	imap/http_jmap.h \
+@JMAP_TRUE@	imap/jmap_api.c \
+@JMAP_TRUE@	imap/jmap_api.h \
+@JMAP_TRUE@	imap/jmap_calendar.c \
+@JMAP_TRUE@	imap/jmap_contact.c \
+@JMAP_TRUE@	imap/jmap_core.c \
+@JMAP_TRUE@	imap/jmap_ical.c \
+@JMAP_TRUE@	imap/jmap_ical.h \
+@JMAP_TRUE@	imap/jmap_mail.c \
+@JMAP_TRUE@	imap/jmap_mail.h \
+@JMAP_TRUE@	imap/jmap_mail_query.c \
+@JMAP_TRUE@	imap/jmap_mail_query.h \
+@JMAP_TRUE@	imap/jmap_mail_submission.c \
+@JMAP_TRUE@	imap/jmap_mailbox.c \
+@JMAP_TRUE@	imap/jmap_util.c \
+@JMAP_TRUE@	imap/jmap_util.h \
+@JMAP_TRUE@	imap/jmap_vacation.c \
+@JMAP_TRUE@	imap/sync_support.c \
+@JMAP_TRUE@        imap/sync_support.h
+
+@JMAP_TRUE@am__append_76 = \
+@JMAP_TRUE@	imap/jmap_err.c \
+@JMAP_TRUE@	imap/jmap_err.h
+
+@JMAP_TRUE@am__append_77 = \
+@JMAP_TRUE@	imap/jmap_util.c \
+@JMAP_TRUE@	imap/jmap_util.h \
+@JMAP_TRUE@	imap/json_support.c \
+@JMAP_TRUE@	imap/json_support.h
+
+@JMAP_TRUE@am__append_78 = $(LD_SIEVE_ADD)
+@CUNIT_TRUE@@JMAP_TRUE@am__append_79 = cunit/jmap_util.testc
+@AUTOCREATE_TRUE@am__append_80 = \
 @AUTOCREATE_TRUE@	imap/autocreate.c \
 @AUTOCREATE_TRUE@	imap/autocreate.h
 
-@USE_CYRUSDB_SQL_TRUE@am__append_68 = lib/cyrusdb_sql.c
-@USE_CYRUSDB_LMDB_TRUE@am__append_69 = lib/cyrusdb_lmdb.c
-@USE_SQLITE_TRUE@am__append_70 = lib/sqldb.c
-@GMTOFF_TM_TRUE@am__append_71 = lib/gmtoff_tm.c
-@GMTOFF_TM_FALSE@am__append_72 = lib/gmtoff_gmtime.c
-@NONBLOCK_FCNTL_TRUE@am__append_73 = lib/nonblock_fcntl.c
-@NONBLOCK_FCNTL_FALSE@am__append_74 = lib/nonblock_ioctl.c
-@USE_CYRUSDB_LMDB_TRUE@am__append_75 = -llmdb
-@HAVE_SSL_FALSE@am__append_76 = lib/xsha1.c
-@IPV6_noGETADDRINFO_TRUE@am__append_77 = lib/getaddrinfo.c
-@IPV6_noGETNAMEINFO_TRUE@am__append_78 = lib/getnameinfo.c
-@LOCK_FCNTL_TRUE@am__append_79 = lib/lock_fcntl.c
-@LOCK_FCNTL_FALSE@am__append_80 = lib/lock_flock.c
-@MAP_SHARED_TRUE@am__append_81 = lib/map_shared.c
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__append_82 = lib/map_stupidshared.c
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__append_83 = lib/map_nommap.c
-@SQUATTER_TRUE@am__append_84 = \
+@USE_CYRUSDB_SQL_TRUE@am__append_81 = lib/cyrusdb_sql.c
+@USE_SQLITE_TRUE@am__append_82 = lib/sqldb.c
+@GMTOFF_TM_TRUE@am__append_83 = lib/gmtoff_tm.c
+@GMTOFF_TM_FALSE@am__append_84 = lib/gmtoff_gmtime.c
+@NONBLOCK_FCNTL_TRUE@am__append_85 = lib/nonblock_fcntl.c
+@NONBLOCK_FCNTL_FALSE@am__append_86 = lib/nonblock_ioctl.c
+@USE_ZEROSKIP_TRUE@am__append_87 = lib/cyrusdb_zeroskip.c
+@USE_ZEROSKIP_TRUE@am__append_88 = $(ZEROSKIP_LIBS)
+@USE_ZEROSKIP_TRUE@am__append_89 = $(ZEROSKIP_CFLAGS)
+@USE_ZEROSKIP_TRUE@am__append_90 = $(ZEROSKIP_CFLAGS)
+@HAVE_SSL_FALSE@am__append_91 = lib/xsha1.c
+@IPV6_noGETADDRINFO_TRUE@am__append_92 = lib/getaddrinfo.c
+@IPV6_noGETNAMEINFO_TRUE@am__append_93 = lib/getnameinfo.c
+@LOCK_FCNTL_TRUE@am__append_94 = lib/lock_fcntl.c
+@LOCK_FCNTL_FALSE@am__append_95 = lib/lock_flock.c
+@MAP_SHARED_TRUE@am__append_96 = lib/map_shared.c
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__append_97 = lib/map_stupidshared.c
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__append_98 = lib/map_nommap.c
+@SQUATTER_TRUE@am__append_99 = \
 @SQUATTER_TRUE@	man/squatter.8
 
-@SQUATTER_FALSE@am__append_85 = \
-@SQUATTER_FALSE@	man/squatter.8
-
-@NNTPD_TRUE@am__append_86 = \
+@NNTPD_TRUE@am__append_100 = \
 @NNTPD_TRUE@	man/fetchnews.8 \
 @NNTPD_TRUE@	man/nntpd.8
 
-@NNTPD_FALSE@am__append_87 = \
-@NNTPD_FALSE@	man/fetchnews.8 \
-@NNTPD_FALSE@	man/nntpd.8
-
-@HTTPD_TRUE@am__append_88 = \
+@HTTPD_TRUE@am__append_101 = \
 @HTTPD_TRUE@	man/ctl_zoneinfo.8 \
 @HTTPD_TRUE@	man/httpd.8
 
-@HTTPD_FALSE@am__append_89 = \
-@HTTPD_FALSE@	man/ctl_zoneinfo.8 \
-@HTTPD_FALSE@	man/httpd.8
-
-@REPLICATION_TRUE@am__append_90 = \
+@BENCH_TRUE@am__append_102 = bench/cyrdbbench
+@REPLICATION_TRUE@am__append_103 = \
 @REPLICATION_TRUE@	man/sync_client.8 \
 @REPLICATION_TRUE@	man/sync_reset.8 \
 @REPLICATION_TRUE@	man/sync_server.8
 
-@REPLICATION_FALSE@am__append_91 = \
-@REPLICATION_FALSE@	man/sync_client.8 \
-@REPLICATION_FALSE@	man/sync_reset.8 \
-@REPLICATION_FALSE@	man/sync_server.8
-
-@ZEPHYR_TRUE@am__append_92 = notifyd/notify_zephyr.c notifyd/notify_zephyr.h
-@HAVE_LDAP_TRUE@am__append_93 = ptclient/ldap.c
-@HAVE_LDAP_TRUE@am__append_94 = $(LDAP_LIBS)
-@HAVE_LDAP_TRUE@am__append_95 = $(LDAP_LDFLAGS)
-@USE_AFSKRB_TRUE@am__append_96 = ptclient/afskrb.c
-@USE_AFSKRB_TRUE@am__append_97 = $(AFS_LIBS)
-@USE_AFSKRB_TRUE@am__append_98 = $(AFS_LDFLAGS)
+@ZEPHYR_TRUE@am__append_104 = notifyd/notify_zephyr.c notifyd/notify_zephyr.h
+@HAVE_LDAP_TRUE@am__append_105 = ptclient/ldap.c
+@HAVE_LDAP_TRUE@am__append_106 = $(LDAP_LIBS)
+@HAVE_LDAP_TRUE@am__append_107 = $(LDAP_LDFLAGS)
+@USE_AFSKRB_TRUE@am__append_108 = ptclient/afskrb.c
+@USE_AFSKRB_TRUE@am__append_109 = $(AFS_LIBS)
+@USE_AFSKRB_TRUE@am__append_110 = $(AFS_LDFLAGS)
+@JMAP_TRUE@am__append_111 = \
+@JMAP_TRUE@	imap/json_support.c \
+@JMAP_TRUE@	imap/json_support.h
+
+@JMAP_TRUE@am__append_112 = imap/jmap_util.c imap/jmap_mail_query.c
 subdir = .
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 am__aclocal_m4_deps =  \
 	$(top_srcdir)/cmulocal/ax_cxx_compile_stdcxx_11.m4 \
 	$(top_srcdir)/cmulocal/ax_prog_perl_modules.m4 \
+	$(top_srcdir)/cmulocal/ax_python_module.m4 \
 	$(top_srcdir)/cmulocal/bsd_sockets.m4 \
 	$(top_srcdir)/cmulocal/common.m4 \
 	$(top_srcdir)/cmulocal/cyrus.m4 $(top_srcdir)/cmulocal/ipv6.m4 \
@@ -499,49 +537,56 @@ com_err_et_libcyrus_com_err_la_LINK = $(
 @COM_ERR_TRUE@am_com_err_et_libcyrus_com_err_la_rpath = -rpath \
 @COM_ERR_TRUE@	$(libdir)
 @USE_XAPIAN_TRUE@am__DEPENDENCIES_3 = $(am__DEPENDENCIES_1)
+@HAVE_CLD2_TRUE@@USE_XAPIAN_TRUE@am__DEPENDENCIES_4 =  \
+@HAVE_CLD2_TRUE@@USE_XAPIAN_TRUE@	$(am__DEPENDENCIES_1)
 imap_libcyrus_imap_la_DEPENDENCIES = $(am__DEPENDENCIES_1) \
 	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1) lib/libcyrus_min.la lib/libcyrus.la \
-	$(am__DEPENDENCIES_3)
+	lib/libcyrus_min.la lib/libcyrus.la $(am__DEPENDENCIES_3) \
+	$(am__DEPENDENCIES_4)
 am__imap_libcyrus_imap_la_SOURCES_DIST = imap/annotate.c \
 	imap/annotate.h imap/append.c imap/append.h imap/backend.c \
 	imap/backend.h imap/conversations.c imap/conversations.h \
 	imap/convert_code.c imap/convert_code.h imap/dlist.c \
 	imap/dlist.h imap/duplicate.c imap/duplicate.h imap/global.c \
-	imap/global.h imap/idle.c imap/idle.h imap/idlemsg.c \
-	imap/idlemsg.h imap/imapparse.c imap/imapparse.h imap/index.c \
-	imap/index.h imap/mailbox.c imap/mailbox.h imap/mbdump.c \
-	imap/mbdump.h imap/mboxkey.c imap/mboxkey.h imap/mboxlist.c \
-	imap/mboxlist.h imap/mboxevent.c imap/mboxevent.h \
-	imap/mboxname.c imap/mboxname.h imap/message_guid.c \
-	imap/message_guid.h imap/message.c imap/message.h \
-	imap/message_priv.h imap/mupdate-client.c \
-	imap/mupdate-client.h imap/mutex.h imap/notify.c imap/notify.h \
-	imap/partlist.c imap/partlist.h imap/proc.c imap/proc.h \
-	imap/protocol.h imap/quota_db.c imap/rfc822_header.c \
-	imap/rfc822_header.h imap/saslclient.c imap/saslclient.h \
-	imap/saslserver.c imap/search_engines.c imap/search_engines.h \
-	imap/search_expr.c imap/search_expr.h imap/search_query.c \
-	imap/search_query.h imap/search_part.h imap/seen.h \
-	imap/seen_db.c imap/sequence.c imap/sequence.h \
-	imap/setproctitle.c imap/statuscache.h imap/statuscache_db.c \
-	imap/sync_log.c imap/sync_log.h imap/telemetry.c \
-	imap/telemetry.h imap/tls.c imap/tls.h imap/tls_th-lock.c \
-	imap/tls_th-lock.h imap/user.c imap/user.h imap/userdeny_db.c \
-	imap/userdeny.h imap/version.c imap/version.h imap/xstats.c \
-	imap/xstats.h imap/xstats_metrics.h imap/objectstore_db.c \
+	imap/global.h imap/http_client.c imap/http_client.h \
+	imap/idle.c imap/idle.h imap/idlemsg.c imap/idlemsg.h \
+	imap/imapparse.c imap/imapparse.h imap/index.c imap/index.h \
+	imap/json_support.h imap/mailbox.c imap/mailbox.h \
+	imap/mbdump.c imap/mbdump.h imap/mboxkey.c imap/mboxkey.h \
+	imap/mboxlist.c imap/mboxlist.h imap/mboxevent.c \
+	imap/mboxevent.h imap/mboxname.c imap/mboxname.h \
+	imap/message_guid.c imap/message_guid.h imap/message.c \
+	imap/message.h imap/message_priv.h imap/msgrecord.c \
+	imap/msgrecord.h imap/mupdate-client.c imap/mupdate-client.h \
+	imap/mutex.h imap/notify.c imap/notify.h imap/partlist.c \
+	imap/partlist.h imap/proc.c imap/proc.h imap/prometheus.c \
+	imap/prometheus.h imap/protocol.h imap/quota_db.c \
+	imap/rfc822_header.c imap/rfc822_header.h \
+	imap/mailbox_header_cache.h imap/saslclient.c \
+	imap/saslclient.h imap/saslserver.c imap/search_engines.c \
+	imap/search_engines.h imap/search_expr.c imap/search_expr.h \
+	imap/search_query.c imap/search_query.h imap/search_part.h \
+	imap/search_sort.h imap/seen.h imap/seen_db.c imap/sequence.c \
+	imap/sequence.h imap/setproctitle.c imap/spool.c imap/spool.h \
+	imap/statuscache.h imap/statuscache_db.c imap/sync_log.c \
+	imap/sync_log.h imap/telemetry.c imap/telemetry.h imap/tls.c \
+	imap/tls.h imap/tls_th-lock.c imap/tls_th-lock.h imap/user.c \
+	imap/user.h imap/userdeny_db.c imap/userdeny.h imap/version.c \
+	imap/version.h imap/xstats.c imap/xstats.h \
+	imap/xstats_metrics.h imap/objectstore_db.c \
 	imap/objectstore_db.h imap/objectstore.h \
 	imap/objectstore_openio.c imap/objectstore_caringo.c \
 	imap/objectstore_dummy.c imap/search_squat.c imap/squat.c \
 	imap/squat.h imap/squat_build.c imap/squat_internal.c \
-	imap/squat_internal.h imap/search_sphinx.c \
-	imap/sphinxmgr_client.c imap/sphinxmgr_client.h \
-	imap/caldav_alarm.c imap/caldav_alarm.h imap/caldav_db.c \
-	imap/caldav_db.h imap/carddav_db.c imap/carddav_db.h \
-	imap/dav_db.c imap/dav_db.h imap/dav_util.c imap/dav_util.h \
-	imap/ical_support.c imap/ical_support.h imap/vcard_support.c \
+	imap/squat_internal.h imap/caldav_alarm.c imap/caldav_alarm.h \
+	imap/caldav_db.c imap/caldav_db.h imap/carddav_db.c \
+	imap/carddav_db.h imap/dav_db.c imap/dav_db.h imap/dav_util.c \
+	imap/dav_util.h imap/ical_support.c imap/ical_support.h \
+	imap/icu_wrap.h imap/icu_wrap.cpp imap/vcard_support.c \
 	imap/vcard_support.h imap/webdav_db.c imap/webdav_db.h \
-	imap/search_xapian.c imap/xapian_wrap.h imap/xapian_wrap.cpp
+	imap/smtpclient.c imap/smtpclient.h imap/search_xapian.c \
+	imap/xapian_wrap.h imap/xapian_wrap.cpp imap/jmap_util.c \
+	imap/jmap_util.h imap/json_support.c
 @OBJECTSTORE_TRUE@am__objects_1 = imap/imap_libcyrus_imap_la-objectstore_db.lo
 @OBJECTSTORE_TRUE@@WITH_OPENIO_TRUE@am__objects_2 = imap/imap_libcyrus_imap_la-objectstore_openio.lo
 @OBJECTSTORE_TRUE@@WITH_CARINGO_TRUE@@WITH_OPENIO_FALSE@am__objects_3 = imap/imap_libcyrus_imap_la-objectstore_caringo.lo
@@ -551,21 +596,22 @@ am__imap_libcyrus_imap_la_SOURCES_DIST =
 @USE_SQUAT_TRUE@	imap/imap_libcyrus_imap_la-squat.lo \
 @USE_SQUAT_TRUE@	imap/imap_libcyrus_imap_la-squat_build.lo \
 @USE_SQUAT_TRUE@	imap/imap_libcyrus_imap_la-squat_internal.lo
-@USE_SPHINX_TRUE@am__objects_6 =  \
-@USE_SPHINX_TRUE@	imap/imap_libcyrus_imap_la-search_sphinx.lo \
-@USE_SPHINX_TRUE@	imap/imap_libcyrus_imap_la-sphinxmgr_client.lo
-@HTTPD_TRUE@am__objects_7 =  \
+@HTTPD_TRUE@am__objects_6 =  \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-caldav_alarm.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-caldav_db.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-carddav_db.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-dav_db.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-dav_util.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-ical_support.lo \
+@HTTPD_TRUE@	imap/imap_libcyrus_imap_la-icu_wrap.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-vcard_support.lo \
 @HTTPD_TRUE@	imap/imap_libcyrus_imap_la-webdav_db.lo
+@JMAP_TRUE@am__objects_7 = imap/imap_libcyrus_imap_la-smtpclient.lo
 @USE_XAPIAN_TRUE@am__objects_8 =  \
 @USE_XAPIAN_TRUE@	imap/imap_libcyrus_imap_la-search_xapian.lo \
 @USE_XAPIAN_TRUE@	imap/imap_libcyrus_imap_la-xapian_wrap.lo
+@JMAP_TRUE@am__objects_9 = imap/imap_libcyrus_imap_la-jmap_util.lo \
+@JMAP_TRUE@	imap/imap_libcyrus_imap_la-json_support.lo
 am_imap_libcyrus_imap_la_OBJECTS =  \
 	imap/imap_libcyrus_imap_la-annotate.lo \
 	imap/imap_libcyrus_imap_la-append.lo \
@@ -575,6 +621,7 @@ am_imap_libcyrus_imap_la_OBJECTS =  \
 	imap/imap_libcyrus_imap_la-dlist.lo \
 	imap/imap_libcyrus_imap_la-duplicate.lo \
 	imap/imap_libcyrus_imap_la-global.lo \
+	imap/imap_libcyrus_imap_la-http_client.lo \
 	imap/imap_libcyrus_imap_la-idle.lo \
 	imap/imap_libcyrus_imap_la-idlemsg.lo \
 	imap/imap_libcyrus_imap_la-imapparse.lo \
@@ -587,10 +634,12 @@ am_imap_libcyrus_imap_la_OBJECTS =  \
 	imap/imap_libcyrus_imap_la-mboxname.lo \
 	imap/imap_libcyrus_imap_la-message_guid.lo \
 	imap/imap_libcyrus_imap_la-message.lo \
+	imap/imap_libcyrus_imap_la-msgrecord.lo \
 	imap/imap_libcyrus_imap_la-mupdate-client.lo \
 	imap/imap_libcyrus_imap_la-notify.lo \
 	imap/imap_libcyrus_imap_la-partlist.lo \
 	imap/imap_libcyrus_imap_la-proc.lo \
+	imap/imap_libcyrus_imap_la-prometheus.lo \
 	imap/imap_libcyrus_imap_la-quota_db.lo \
 	imap/imap_libcyrus_imap_la-rfc822_header.lo \
 	imap/imap_libcyrus_imap_la-saslclient.lo \
@@ -601,6 +650,7 @@ am_imap_libcyrus_imap_la_OBJECTS =  \
 	imap/imap_libcyrus_imap_la-seen_db.lo \
 	imap/imap_libcyrus_imap_la-sequence.lo \
 	imap/imap_libcyrus_imap_la-setproctitle.lo \
+	imap/imap_libcyrus_imap_la-spool.lo \
 	imap/imap_libcyrus_imap_la-statuscache_db.lo \
 	imap/imap_libcyrus_imap_la-sync_log.lo \
 	imap/imap_libcyrus_imap_la-telemetry.lo \
@@ -612,39 +662,39 @@ am_imap_libcyrus_imap_la_OBJECTS =  \
 	imap/imap_libcyrus_imap_la-xstats.lo $(am__objects_1) \
 	$(am__objects_2) $(am__objects_3) $(am__objects_4) \
 	$(am__objects_5) $(am__objects_6) $(am__objects_7) \
-	$(am__objects_8)
-dist_imap_libcyrus_imap_la_OBJECTS =
+	$(am__objects_8) $(am__objects_9)
 nodist_imap_libcyrus_imap_la_OBJECTS =  \
+	imap/imap_libcyrus_imap_la-http_err.lo \
 	imap/imap_libcyrus_imap_la-imap_err.lo \
-	imap/imap_libcyrus_imap_la-mupdate_err.lo
+	imap/imap_libcyrus_imap_la-mupdate_err.lo \
+	imap/imap_libcyrus_imap_la-promdata.lo
 imap_libcyrus_imap_la_OBJECTS = $(am_imap_libcyrus_imap_la_OBJECTS) \
-	$(dist_imap_libcyrus_imap_la_OBJECTS) \
 	$(nodist_imap_libcyrus_imap_la_OBJECTS)
 imap_libcyrus_imap_la_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CXX \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CXXLD) \
 	$(imap_libcyrus_imap_la_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) \
 	$(LDFLAGS) -o $@
 @SERVER_TRUE@am_imap_libcyrus_imap_la_rpath = -rpath $(libdir)
+@USE_ZEROSKIP_TRUE@am__DEPENDENCIES_5 = $(am__DEPENDENCIES_1)
 lib_libcyrus_la_DEPENDENCIES = libcrc32.la $(am__DEPENDENCIES_1) \
 	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1)
+	$(am__DEPENDENCIES_5)
 am__lib_libcyrus_la_SOURCES_DIST = lib/acl.c lib/acl_afs.c lib/auth.c \
 	lib/auth_krb.c lib/auth_krb5.c lib/auth_pts.c lib/auth_unix.c \
 	lib/bitvector.c lib/bloom.c lib/bsearch.c lib/charset.c \
-	lib/command.c lib/cyrusdb.c lib/cyrusdb_flat.c \
-	lib/cyrusdb_quotalegacy.c lib/cyrusdb_skiplist.c \
-	lib/cyrusdb_twoskip.c lib/glob.c lib/htmlchar.c lib/htmlchar.h \
-	lib/imapurl.c lib/imclient.c lib/imparse.c lib/iostat.c \
-	lib/iptostring.c lib/libcyr_cfg.c lib/lsort.c lib/mappedfile.c \
-	lib/murmurhash.c lib/mkgmtime.c lib/parseaddr.c lib/prot.c \
-	lib/ptrarray.c lib/rfc822tok.c lib/signals.c lib/stristr.c \
-	lib/times.c lib/tok.c lib/wildmat.c lib/cyrusdb_sql.c \
-	lib/cyrusdb_lmdb.c lib/sqldb.c lib/gmtoff_tm.c \
-	lib/gmtoff_gmtime.c lib/nonblock_fcntl.c lib/nonblock_ioctl.c
-@USE_CYRUSDB_SQL_TRUE@am__objects_9 =  \
+	lib/command.c lib/cyr_qsort_r.c lib/cyrusdb.c \
+	lib/cyrusdb_flat.c lib/cyrusdb_quotalegacy.c \
+	lib/cyrusdb_skiplist.c lib/cyrusdb_twoskip.c lib/glob.c \
+	lib/htmlchar.c lib/htmlchar.h lib/imapurl.c lib/imclient.c \
+	lib/imparse.c lib/iostat.c lib/iptostring.c lib/libcyr_cfg.c \
+	lib/lsort.c lib/mappedfile.c lib/murmurhash.c lib/mkgmtime.c \
+	lib/parseaddr.c lib/prot.c lib/ptrarray.c lib/rfc822tok.c \
+	lib/signals.c lib/stristr.c lib/times.c lib/tok.c \
+	lib/wildmat.c lib/cyrusdb_sql.c lib/sqldb.c lib/gmtoff_tm.c \
+	lib/gmtoff_gmtime.c lib/nonblock_fcntl.c lib/nonblock_ioctl.c \
+	lib/cyrusdb_zeroskip.c
+@USE_CYRUSDB_SQL_TRUE@am__objects_10 =  \
 @USE_CYRUSDB_SQL_TRUE@	lib/lib_libcyrus_la-cyrusdb_sql.lo
-@USE_CYRUSDB_LMDB_TRUE@am__objects_10 =  \
-@USE_CYRUSDB_LMDB_TRUE@	lib/lib_libcyrus_la-cyrusdb_lmdb.lo
 @USE_SQLITE_TRUE@am__objects_11 = lib/lib_libcyrus_la-sqldb.lo
 @GMTOFF_TM_TRUE@am__objects_12 = lib/lib_libcyrus_la-gmtoff_tm.lo
 @GMTOFF_TM_FALSE@am__objects_13 =  \
@@ -653,6 +703,8 @@ am__lib_libcyrus_la_SOURCES_DIST = lib/a
 @NONBLOCK_FCNTL_TRUE@	lib/lib_libcyrus_la-nonblock_fcntl.lo
 @NONBLOCK_FCNTL_FALSE@am__objects_15 =  \
 @NONBLOCK_FCNTL_FALSE@	lib/lib_libcyrus_la-nonblock_ioctl.lo
+@USE_ZEROSKIP_TRUE@am__objects_16 =  \
+@USE_ZEROSKIP_TRUE@	lib/lib_libcyrus_la-cyrusdb_zeroskip.lo
 am_lib_libcyrus_la_OBJECTS = lib/lib_libcyrus_la-acl.lo \
 	lib/lib_libcyrus_la-acl_afs.lo lib/lib_libcyrus_la-auth.lo \
 	lib/lib_libcyrus_la-auth_krb.lo \
@@ -661,7 +713,9 @@ am_lib_libcyrus_la_OBJECTS = lib/lib_lib
 	lib/lib_libcyrus_la-auth_unix.lo \
 	lib/lib_libcyrus_la-bitvector.lo lib/lib_libcyrus_la-bloom.lo \
 	lib/lib_libcyrus_la-bsearch.lo lib/lib_libcyrus_la-charset.lo \
-	lib/lib_libcyrus_la-command.lo lib/lib_libcyrus_la-cyrusdb.lo \
+	lib/lib_libcyrus_la-command.lo \
+	lib/lib_libcyrus_la-cyr_qsort_r.lo \
+	lib/lib_libcyrus_la-cyrusdb.lo \
 	lib/lib_libcyrus_la-cyrusdb_flat.lo \
 	lib/lib_libcyrus_la-cyrusdb_quotalegacy.lo \
 	lib/lib_libcyrus_la-cyrusdb_skiplist.lo \
@@ -679,9 +733,9 @@ am_lib_libcyrus_la_OBJECTS = lib/lib_lib
 	lib/lib_libcyrus_la-rfc822tok.lo \
 	lib/lib_libcyrus_la-signals.lo lib/lib_libcyrus_la-stristr.lo \
 	lib/lib_libcyrus_la-times.lo lib/lib_libcyrus_la-tok.lo \
-	lib/lib_libcyrus_la-wildmat.lo $(am__objects_9) \
-	$(am__objects_10) $(am__objects_11) $(am__objects_12) \
-	$(am__objects_13) $(am__objects_14) $(am__objects_15)
+	lib/lib_libcyrus_la-wildmat.lo $(am__objects_10) \
+	$(am__objects_11) $(am__objects_12) $(am__objects_13) \
+	$(am__objects_14) $(am__objects_15) $(am__objects_16)
 nodist_lib_libcyrus_la_OBJECTS = lib/lib_libcyrus_la-chartable.lo
 lib_libcyrus_la_OBJECTS = $(am_lib_libcyrus_la_OBJECTS) \
 	$(nodist_lib_libcyrus_la_OBJECTS)
@@ -691,31 +745,32 @@ lib_libcyrus_la_LINK = $(LIBTOOL) $(AM_V
 	-o $@
 LIBOBJDIR = lib/
 lib_libcyrus_min_la_DEPENDENCIES = $(LTLIBOBJS) $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1)
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 am__lib_libcyrus_min_la_SOURCES_DIST = lib/arrayu64.c lib/assert.c \
-	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashu64.c \
-	lib/libconfig.c lib/mpool.c lib/retry.c lib/strarray.c \
-	lib/strhash.c lib/util.c lib/vparse.c lib/xmalloc.c \
-	lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c lib/xsha1.c \
-	lib/getaddrinfo.c lib/getnameinfo.c lib/lock_fcntl.c \
-	lib/lock_flock.c lib/map_shared.c lib/map_stupidshared.c \
-	lib/map_nommap.c
-@HAVE_SSL_FALSE@am__objects_16 = lib/lib_libcyrus_min_la-xsha1.lo
-@IPV6_noGETADDRINFO_TRUE@am__objects_17 = lib/lib_libcyrus_min_la-getaddrinfo.lo
-@IPV6_noGETNAMEINFO_TRUE@am__objects_18 = lib/lib_libcyrus_min_la-getnameinfo.lo
-@LOCK_FCNTL_TRUE@am__objects_19 =  \
+	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashset.c \
+	lib/hashu64.c lib/libconfig.c lib/mpool.c lib/retry.c \
+	lib/strarray.c lib/strhash.c lib/util.c lib/vparse.c \
+	lib/xmalloc.c lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c \
+	lib/xsha1.c lib/getaddrinfo.c lib/getnameinfo.c \
+	lib/lock_fcntl.c lib/lock_flock.c lib/map_shared.c \
+	lib/map_stupidshared.c lib/map_nommap.c
+@HAVE_SSL_FALSE@am__objects_17 = lib/lib_libcyrus_min_la-xsha1.lo
+@IPV6_noGETADDRINFO_TRUE@am__objects_18 = lib/lib_libcyrus_min_la-getaddrinfo.lo
+@IPV6_noGETNAMEINFO_TRUE@am__objects_19 = lib/lib_libcyrus_min_la-getnameinfo.lo
+@LOCK_FCNTL_TRUE@am__objects_20 =  \
 @LOCK_FCNTL_TRUE@	lib/lib_libcyrus_min_la-lock_fcntl.lo
-@LOCK_FCNTL_FALSE@am__objects_20 =  \
+@LOCK_FCNTL_FALSE@am__objects_21 =  \
 @LOCK_FCNTL_FALSE@	lib/lib_libcyrus_min_la-lock_flock.lo
-@MAP_SHARED_TRUE@am__objects_21 =  \
+@MAP_SHARED_TRUE@am__objects_22 =  \
 @MAP_SHARED_TRUE@	lib/lib_libcyrus_min_la-map_shared.lo
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__objects_22 = lib/lib_libcyrus_min_la-map_stupidshared.lo
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__objects_23 = lib/lib_libcyrus_min_la-map_nommap.lo
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__objects_23 = lib/lib_libcyrus_min_la-map_stupidshared.lo
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__objects_24 = lib/lib_libcyrus_min_la-map_nommap.lo
 am_lib_libcyrus_min_la_OBJECTS = lib/lib_libcyrus_min_la-arrayu64.lo \
 	lib/lib_libcyrus_min_la-assert.lo \
 	lib/lib_libcyrus_min_la-bufarray.lo \
 	lib/lib_libcyrus_min_la-byteorder64.lo \
 	lib/lib_libcyrus_min_la-hash.lo \
+	lib/lib_libcyrus_min_la-hashset.lo \
 	lib/lib_libcyrus_min_la-hashu64.lo \
 	lib/lib_libcyrus_min_la-libconfig.lo \
 	lib/lib_libcyrus_min_la-mpool.lo \
@@ -727,10 +782,10 @@ am_lib_libcyrus_min_la_OBJECTS = lib/lib
 	lib/lib_libcyrus_min_la-xmalloc.lo \
 	lib/lib_libcyrus_min_la-xstrlcat.lo \
 	lib/lib_libcyrus_min_la-xstrlcpy.lo \
-	lib/lib_libcyrus_min_la-xstrnchr.lo $(am__objects_16) \
-	$(am__objects_17) $(am__objects_18) $(am__objects_19) \
-	$(am__objects_20) $(am__objects_21) $(am__objects_22) \
-	$(am__objects_23)
+	lib/lib_libcyrus_min_la-xstrnchr.lo $(am__objects_17) \
+	$(am__objects_18) $(am__objects_19) $(am__objects_20) \
+	$(am__objects_21) $(am__objects_22) $(am__objects_23) \
+	$(am__objects_24)
 nodist_lib_libcyrus_min_la_OBJECTS =  \
 	lib/lib_libcyrus_min_la-imapopts.lo
 lib_libcyrus_min_la_OBJECTS = $(am_lib_libcyrus_min_la_OBJECTS) \
@@ -746,81 +801,82 @@ libcrc32_la_OBJECTS = $(am_libcrc32_la_O
 libcrc32_la_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(libcrc32_la_CFLAGS) \
 	$(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
-am__DEPENDENCIES_4 = libcrc32.la $(am__DEPENDENCIES_1) \
+am__DEPENDENCIES_6 = libcrc32.la $(am__DEPENDENCIES_1) \
 	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1)
-perl_libcyrus_la_DEPENDENCIES = $(am__DEPENDENCIES_4)
+	$(am__DEPENDENCIES_5)
+perl_libcyrus_la_DEPENDENCIES = $(am__DEPENDENCIES_6)
 am__perl_libcyrus_la_SOURCES_DIST = lib/acl.c lib/acl_afs.c lib/auth.c \
 	lib/auth_krb.c lib/auth_krb5.c lib/auth_pts.c lib/auth_unix.c \
 	lib/bitvector.c lib/bloom.c lib/bsearch.c lib/charset.c \
-	lib/command.c lib/cyrusdb.c lib/cyrusdb_flat.c \
-	lib/cyrusdb_quotalegacy.c lib/cyrusdb_skiplist.c \
-	lib/cyrusdb_twoskip.c lib/glob.c lib/htmlchar.c lib/htmlchar.h \
-	lib/imapurl.c lib/imclient.c lib/imparse.c lib/iostat.c \
-	lib/iptostring.c lib/libcyr_cfg.c lib/lsort.c lib/mappedfile.c \
-	lib/murmurhash.c lib/mkgmtime.c lib/parseaddr.c lib/prot.c \
-	lib/ptrarray.c lib/rfc822tok.c lib/signals.c lib/stristr.c \
-	lib/times.c lib/tok.c lib/wildmat.c lib/cyrusdb_sql.c \
-	lib/cyrusdb_lmdb.c lib/sqldb.c lib/gmtoff_tm.c \
-	lib/gmtoff_gmtime.c lib/nonblock_fcntl.c lib/nonblock_ioctl.c
-@USE_CYRUSDB_SQL_TRUE@am__objects_24 = lib/cyrusdb_sql.lo
-@USE_CYRUSDB_LMDB_TRUE@am__objects_25 = lib/cyrusdb_lmdb.lo
+	lib/command.c lib/cyr_qsort_r.c lib/cyrusdb.c \
+	lib/cyrusdb_flat.c lib/cyrusdb_quotalegacy.c \
+	lib/cyrusdb_skiplist.c lib/cyrusdb_twoskip.c lib/glob.c \
+	lib/htmlchar.c lib/htmlchar.h lib/imapurl.c lib/imclient.c \
+	lib/imparse.c lib/iostat.c lib/iptostring.c lib/libcyr_cfg.c \
+	lib/lsort.c lib/mappedfile.c lib/murmurhash.c lib/mkgmtime.c \
+	lib/parseaddr.c lib/prot.c lib/ptrarray.c lib/rfc822tok.c \
+	lib/signals.c lib/stristr.c lib/times.c lib/tok.c \
+	lib/wildmat.c lib/cyrusdb_sql.c lib/sqldb.c lib/gmtoff_tm.c \
+	lib/gmtoff_gmtime.c lib/nonblock_fcntl.c lib/nonblock_ioctl.c \
+	lib/cyrusdb_zeroskip.c
+@USE_CYRUSDB_SQL_TRUE@am__objects_25 = lib/cyrusdb_sql.lo
 @USE_SQLITE_TRUE@am__objects_26 = lib/sqldb.lo
 @GMTOFF_TM_TRUE@am__objects_27 = lib/gmtoff_tm.lo
 @GMTOFF_TM_FALSE@am__objects_28 = lib/gmtoff_gmtime.lo
 @NONBLOCK_FCNTL_TRUE@am__objects_29 = lib/nonblock_fcntl.lo
 @NONBLOCK_FCNTL_FALSE@am__objects_30 = lib/nonblock_ioctl.lo
-am__objects_31 = lib/acl.lo lib/acl_afs.lo lib/auth.lo lib/auth_krb.lo \
+@USE_ZEROSKIP_TRUE@am__objects_31 = lib/cyrusdb_zeroskip.lo
+am__objects_32 = lib/acl.lo lib/acl_afs.lo lib/auth.lo lib/auth_krb.lo \
 	lib/auth_krb5.lo lib/auth_pts.lo lib/auth_unix.lo \
 	lib/bitvector.lo lib/bloom.lo lib/bsearch.lo lib/charset.lo \
-	lib/command.lo lib/cyrusdb.lo lib/cyrusdb_flat.lo \
-	lib/cyrusdb_quotalegacy.lo lib/cyrusdb_skiplist.lo \
-	lib/cyrusdb_twoskip.lo lib/glob.lo lib/htmlchar.lo \
-	lib/imapurl.lo lib/imclient.lo lib/imparse.lo lib/iostat.lo \
-	lib/iptostring.lo lib/libcyr_cfg.lo lib/lsort.lo \
+	lib/command.lo lib/cyr_qsort_r.lo lib/cyrusdb.lo \
+	lib/cyrusdb_flat.lo lib/cyrusdb_quotalegacy.lo \
+	lib/cyrusdb_skiplist.lo lib/cyrusdb_twoskip.lo lib/glob.lo \
+	lib/htmlchar.lo lib/imapurl.lo lib/imclient.lo lib/imparse.lo \
+	lib/iostat.lo lib/iptostring.lo lib/libcyr_cfg.lo lib/lsort.lo \
 	lib/mappedfile.lo lib/murmurhash.lo lib/mkgmtime.lo \
 	lib/parseaddr.lo lib/prot.lo lib/ptrarray.lo lib/rfc822tok.lo \
 	lib/signals.lo lib/stristr.lo lib/times.lo lib/tok.lo \
-	lib/wildmat.lo $(am__objects_24) $(am__objects_25) \
-	$(am__objects_26) $(am__objects_27) $(am__objects_28) \
-	$(am__objects_29) $(am__objects_30)
-am_perl_libcyrus_la_OBJECTS = $(am__objects_31)
-am__objects_32 = lib/chartable.lo
-nodist_perl_libcyrus_la_OBJECTS = $(am__objects_32)
+	lib/wildmat.lo $(am__objects_25) $(am__objects_26) \
+	$(am__objects_27) $(am__objects_28) $(am__objects_29) \
+	$(am__objects_30) $(am__objects_31)
+am_perl_libcyrus_la_OBJECTS = $(am__objects_32)
+am__objects_33 = lib/chartable.lo
+nodist_perl_libcyrus_la_OBJECTS = $(am__objects_33)
 perl_libcyrus_la_OBJECTS = $(am_perl_libcyrus_la_OBJECTS) \
 	$(nodist_perl_libcyrus_la_OBJECTS)
 @PERL_TRUE@am_perl_libcyrus_la_rpath =
-am__DEPENDENCIES_5 = $(LTLIBOBJS) $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1)
-perl_libcyrus_min_la_DEPENDENCIES = $(am__DEPENDENCIES_5)
+am__DEPENDENCIES_7 = $(LTLIBOBJS) $(am__DEPENDENCIES_1) \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
+perl_libcyrus_min_la_DEPENDENCIES = $(am__DEPENDENCIES_7)
 am__perl_libcyrus_min_la_SOURCES_DIST = lib/arrayu64.c lib/assert.c \
-	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashu64.c \
-	lib/libconfig.c lib/mpool.c lib/retry.c lib/strarray.c \
-	lib/strhash.c lib/util.c lib/vparse.c lib/xmalloc.c \
-	lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c lib/xsha1.c \
-	lib/getaddrinfo.c lib/getnameinfo.c lib/lock_fcntl.c \
-	lib/lock_flock.c lib/map_shared.c lib/map_stupidshared.c \
-	lib/map_nommap.c
-@HAVE_SSL_FALSE@am__objects_33 = lib/xsha1.lo
-@IPV6_noGETADDRINFO_TRUE@am__objects_34 = lib/getaddrinfo.lo
-@IPV6_noGETNAMEINFO_TRUE@am__objects_35 = lib/getnameinfo.lo
-@LOCK_FCNTL_TRUE@am__objects_36 = lib/lock_fcntl.lo
-@LOCK_FCNTL_FALSE@am__objects_37 = lib/lock_flock.lo
-@MAP_SHARED_TRUE@am__objects_38 = lib/map_shared.lo
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__objects_39 = lib/map_stupidshared.lo
-@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__objects_40 =  \
+	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashset.c \
+	lib/hashu64.c lib/libconfig.c lib/mpool.c lib/retry.c \
+	lib/strarray.c lib/strhash.c lib/util.c lib/vparse.c \
+	lib/xmalloc.c lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c \
+	lib/xsha1.c lib/getaddrinfo.c lib/getnameinfo.c \
+	lib/lock_fcntl.c lib/lock_flock.c lib/map_shared.c \
+	lib/map_stupidshared.c lib/map_nommap.c
+@HAVE_SSL_FALSE@am__objects_34 = lib/xsha1.lo
+@IPV6_noGETADDRINFO_TRUE@am__objects_35 = lib/getaddrinfo.lo
+@IPV6_noGETNAMEINFO_TRUE@am__objects_36 = lib/getnameinfo.lo
+@LOCK_FCNTL_TRUE@am__objects_37 = lib/lock_fcntl.lo
+@LOCK_FCNTL_FALSE@am__objects_38 = lib/lock_flock.lo
+@MAP_SHARED_TRUE@am__objects_39 = lib/map_shared.lo
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_TRUE@am__objects_40 = lib/map_stupidshared.lo
+@MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@am__objects_41 =  \
 @MAP_SHARED_FALSE@@MAP_STUPIDSHARED_FALSE@	lib/map_nommap.lo
-am__objects_41 = lib/arrayu64.lo lib/assert.lo lib/bufarray.lo \
-	lib/byteorder64.lo lib/hash.lo lib/hashu64.lo lib/libconfig.lo \
-	lib/mpool.lo lib/retry.lo lib/strarray.lo lib/strhash.lo \
-	lib/util.lo lib/vparse.lo lib/xmalloc.lo lib/xstrlcat.lo \
-	lib/xstrlcpy.lo lib/xstrnchr.lo $(am__objects_33) \
+am__objects_42 = lib/arrayu64.lo lib/assert.lo lib/bufarray.lo \
+	lib/byteorder64.lo lib/hash.lo lib/hashset.lo lib/hashu64.lo \
+	lib/libconfig.lo lib/mpool.lo lib/retry.lo lib/strarray.lo \
+	lib/strhash.lo lib/util.lo lib/vparse.lo lib/xmalloc.lo \
+	lib/xstrlcat.lo lib/xstrlcpy.lo lib/xstrnchr.lo \
 	$(am__objects_34) $(am__objects_35) $(am__objects_36) \
 	$(am__objects_37) $(am__objects_38) $(am__objects_39) \
-	$(am__objects_40)
-am_perl_libcyrus_min_la_OBJECTS = $(am__objects_41)
-am__objects_42 = lib/imapopts.lo
-nodist_perl_libcyrus_min_la_OBJECTS = $(am__objects_42)
+	$(am__objects_40) $(am__objects_41)
+am_perl_libcyrus_min_la_OBJECTS = $(am__objects_42)
+am__objects_43 = lib/imapopts.lo
+nodist_perl_libcyrus_min_la_OBJECTS = $(am__objects_43)
 perl_libcyrus_min_la_OBJECTS = $(am_perl_libcyrus_min_la_OBJECTS) \
 	$(nodist_perl_libcyrus_min_la_OBJECTS)
 @PERL_TRUE@am_perl_libcyrus_min_la_rpath =
@@ -832,11 +888,24 @@ perl_sieve_lib_libisieve_la_OBJECTS =  \
 @PERL_TRUE@@SIEVE_TRUE@am_perl_sieve_lib_libisieve_la_rpath =
 sieve_libcyrus_sieve_la_DEPENDENCIES = sieve/libcyrus_sieve_lex.la \
 	$(am__DEPENDENCIES_1) lib/libcyrus_min.la lib/libcyrus.la
+am__sieve_libcyrus_sieve_la_SOURCES_DIST = sieve/bytecode.h \
+	sieve/addr.y sieve/bc_emit.c sieve/bc_eval.c \
+	sieve/bc_generate.c sieve/bc_parse.c sieve/bc_parse.h \
+	sieve/comparator.c sieve/comparator.h sieve/flags.c \
+	sieve/flags.h sieve/grammar.c sieve/grammar.h sieve/interp.c \
+	sieve/interp.h sieve/message.c sieve/message.h sieve/rebuild.c \
+	sieve/script.c sieve/script.h sieve/sieve.y sieve/tree.c \
+	sieve/tree.h sieve/variables.c sieve/variables.h \
+	sieve/varlist.c sieve/varlist.h imap/json_support.c \
+	imap/json_support.h
+@JMAP_TRUE@am__objects_44 =  \
+@JMAP_TRUE@	imap/sieve_libcyrus_sieve_la-json_support.lo
 am_sieve_libcyrus_sieve_la_OBJECTS =  \
 	sieve/sieve_libcyrus_sieve_la-addr.lo \
 	sieve/sieve_libcyrus_sieve_la-bc_emit.lo \
 	sieve/sieve_libcyrus_sieve_la-bc_eval.lo \
 	sieve/sieve_libcyrus_sieve_la-bc_generate.lo \
+	sieve/sieve_libcyrus_sieve_la-bc_parse.lo \
 	sieve/sieve_libcyrus_sieve_la-comparator.lo \
 	sieve/sieve_libcyrus_sieve_la-flags.lo \
 	sieve/sieve_libcyrus_sieve_la-grammar.lo \
@@ -847,7 +916,7 @@ am_sieve_libcyrus_sieve_la_OBJECTS =  \
 	sieve/sieve_libcyrus_sieve_la-sieve.lo \
 	sieve/sieve_libcyrus_sieve_la-tree.lo \
 	sieve/sieve_libcyrus_sieve_la-variables.lo \
-	sieve/sieve_libcyrus_sieve_la-varlist.lo
+	sieve/sieve_libcyrus_sieve_la-varlist.lo $(am__objects_44)
 nodist_sieve_libcyrus_sieve_la_OBJECTS =  \
 	sieve/sieve_libcyrus_sieve_la-sieve_err.lo
 sieve_libcyrus_sieve_la_OBJECTS =  \
@@ -869,28 +938,32 @@ sieve_libcyrus_sieve_lex_la_LINK = $(LIB
 	$(sieve_libcyrus_sieve_lex_la_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) \
 	$(LDFLAGS) -o $@
 @SIEVE_TRUE@am_sieve_libcyrus_sieve_lex_la_rpath =
-@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_1 = notifyd/notifytest$(EXEEXT)
-@SIEVE_TRUE@am__EXEEXT_2 = sieve/test$(EXEEXT)
-@CUNIT_TRUE@am__EXEEXT_3 = cunit/unit$(EXEEXT)
-@SERVER_TRUE@am__EXEEXT_4 = master/master$(EXEEXT) imap/imapd$(EXEEXT) \
+@HTTPD_TRUE@@SERVER_TRUE@am__EXEEXT_1 =  \
+@HTTPD_TRUE@@SERVER_TRUE@	imap/ical_apply_patch$(EXEEXT)
+@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_2 = notifyd/notifytest$(EXEEXT)
+@SIEVE_TRUE@am__EXEEXT_3 = sieve/test$(EXEEXT) \
+@SIEVE_TRUE@	sieve/test_mailbox$(EXEEXT)
+@CUNIT_TRUE@am__EXEEXT_4 = cunit/unit$(EXEEXT)
+@BENCH_TRUE@am__EXEEXT_5 = bench/cyrdbbench$(EXEEXT)
+@SERVER_TRUE@am__EXEEXT_6 = master/master$(EXEEXT) imap/imapd$(EXEEXT) \
 @SERVER_TRUE@	imap/lmtpd$(EXEEXT) imap/pop3d$(EXEEXT) \
-@SERVER_TRUE@	imap/smmapd$(EXEEXT)
-@NNTPD_TRUE@@SERVER_TRUE@am__EXEEXT_5 = imap/nntpd$(EXEEXT)
-@SERVER_TRUE@am__EXEEXT_6 = imap/fud$(EXEEXT)
-@IDLED_TRUE@@SERVER_TRUE@am__EXEEXT_7 = imap/idled$(EXEEXT)
-@MURDER_TRUE@@SERVER_TRUE@am__EXEEXT_8 = imap/mupdate$(EXEEXT)
-@CALALARMD_TRUE@@SERVER_TRUE@am__EXEEXT_9 = imap/calalarmd$(EXEEXT)
-@HTTPD_TRUE@@SERVER_TRUE@am__EXEEXT_10 = imap/httpd$(EXEEXT)
-@REPLICATION_TRUE@@SERVER_TRUE@am__EXEEXT_11 =  \
+@SERVER_TRUE@	imap/promstatsd$(EXEEXT) imap/smmapd$(EXEEXT)
+@NNTPD_TRUE@@SERVER_TRUE@am__EXEEXT_7 = imap/nntpd$(EXEEXT)
+@SERVER_TRUE@am__EXEEXT_8 = imap/fud$(EXEEXT)
+@IDLED_TRUE@@SERVER_TRUE@am__EXEEXT_9 = imap/idled$(EXEEXT)
+@MURDER_TRUE@@SERVER_TRUE@am__EXEEXT_10 = imap/mupdate$(EXEEXT)
+@CALALARMD_TRUE@@SERVER_TRUE@am__EXEEXT_11 = imap/calalarmd$(EXEEXT)
+@HTTPD_TRUE@@SERVER_TRUE@am__EXEEXT_12 = imap/httpd$(EXEEXT)
+@REPLICATION_TRUE@@SERVER_TRUE@am__EXEEXT_13 =  \
 @REPLICATION_TRUE@@SERVER_TRUE@	imap/sync_server$(EXEEXT)
-@BACKUP_TRUE@@SERVER_TRUE@am__EXEEXT_12 = backup/backupd$(EXEEXT)
-@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_13 = notifyd/notifyd$(EXEEXT)
-@PTCLIENT_TRUE@am__EXEEXT_14 = ptclient/ptloader$(EXEEXT)
-@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_15 = timsieved/timsieved$(EXEEXT)
-@SERVER_TRUE@am__EXEEXT_16 = imap/message_test$(EXEEXT) \
+@BACKUP_TRUE@@SERVER_TRUE@am__EXEEXT_14 = backup/backupd$(EXEEXT)
+@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_15 = notifyd/notifyd$(EXEEXT)
+@PTCLIENT_TRUE@am__EXEEXT_16 = ptclient/ptloader$(EXEEXT)
+@SERVER_TRUE@@SIEVE_TRUE@am__EXEEXT_17 = timsieved/timsieved$(EXEEXT)
+@SERVER_TRUE@am__EXEEXT_18 = imap/message_test$(EXEEXT) \
 @SERVER_TRUE@	imap/search_test$(EXEEXT)
-@SERVER_TRUE@@USE_SQUAT_TRUE@am__EXEEXT_17 = imap/squat_dump$(EXEEXT)
-@SERVER_TRUE@am__EXEEXT_18 = imap/arbitron$(EXEEXT) \
+@SERVER_TRUE@@USE_SQUAT_TRUE@am__EXEEXT_19 = imap/squat_dump$(EXEEXT)
+@SERVER_TRUE@am__EXEEXT_20 = imap/arbitron$(EXEEXT) \
 @SERVER_TRUE@	imap/chk_cyrus$(EXEEXT) \
 @SERVER_TRUE@	imap/ctl_conversationsdb$(EXEEXT) \
 @SERVER_TRUE@	imap/ctl_cyrusdb$(EXEEXT) \
@@ -909,24 +982,22 @@ sieve_libcyrus_sieve_lex_la_LINK = $(LIB
 @SERVER_TRUE@	imap/mbpath$(EXEEXT) imap/mbtool$(EXEEXT) \
 @SERVER_TRUE@	imap/quota$(EXEEXT) imap/reconstruct$(EXEEXT) \
 @SERVER_TRUE@	imap/cvt_xlist_specialuse$(EXEEXT)
-@SERVER_TRUE@@USE_SPHINX_TRUE@am__EXEEXT_19 =  \
-@SERVER_TRUE@@USE_SPHINX_TRUE@	imap/cyr_sphinxmgr$(EXEEXT)
-@SERVER_TRUE@@SQUATTER_TRUE@am__EXEEXT_20 = imap/squatter$(EXEEXT)
-@NNTPD_TRUE@@SERVER_TRUE@am__EXEEXT_21 = imap/fetchnews$(EXEEXT)
-@HTTPD_TRUE@@SERVER_TRUE@am__EXEEXT_22 = imap/ctl_zoneinfo$(EXEEXT) \
+@SERVER_TRUE@@SQUATTER_TRUE@am__EXEEXT_21 = imap/squatter$(EXEEXT)
+@NNTPD_TRUE@@SERVER_TRUE@am__EXEEXT_22 = imap/fetchnews$(EXEEXT)
+@HTTPD_TRUE@@SERVER_TRUE@am__EXEEXT_23 = imap/ctl_zoneinfo$(EXEEXT) \
 @HTTPD_TRUE@@SERVER_TRUE@	imap/dav_reconstruct$(EXEEXT)
-@REPLICATION_TRUE@@SERVER_TRUE@am__EXEEXT_23 =  \
+@REPLICATION_TRUE@@SERVER_TRUE@am__EXEEXT_24 =  \
 @REPLICATION_TRUE@@SERVER_TRUE@	imap/sync_client$(EXEEXT) \
 @REPLICATION_TRUE@@SERVER_TRUE@	imap/sync_reset$(EXEEXT)
-@BACKUP_TRUE@@SERVER_TRUE@am__EXEEXT_24 = backup/ctl_backups$(EXEEXT) \
+@BACKUP_TRUE@@SERVER_TRUE@am__EXEEXT_25 = backup/ctl_backups$(EXEEXT) \
 @BACKUP_TRUE@@SERVER_TRUE@	backup/cyr_backup$(EXEEXT) \
 @BACKUP_TRUE@@SERVER_TRUE@	backup/restore$(EXEEXT)
-@HAVE_SSL_TRUE@@SERVER_TRUE@am__EXEEXT_25 = imap/tls_prune$(EXEEXT)
-@SERVER_TRUE@am__EXEEXT_26 = imap/unexpunge$(EXEEXT)
-@CMULOCAL_TRUE@am__EXEEXT_27 = netnews/remotepurge$(EXEEXT)
-@PTCLIENT_TRUE@am__EXEEXT_28 = ptclient/ptdump$(EXEEXT) \
+@HAVE_SSL_TRUE@@SERVER_TRUE@am__EXEEXT_26 = imap/tls_prune$(EXEEXT)
+@SERVER_TRUE@am__EXEEXT_27 = imap/unexpunge$(EXEEXT)
+@CMULOCAL_TRUE@am__EXEEXT_28 = netnews/remotepurge$(EXEEXT)
+@PTCLIENT_TRUE@am__EXEEXT_29 = ptclient/ptdump$(EXEEXT) \
 @PTCLIENT_TRUE@	ptclient/ptexpire$(EXEEXT)
-@SIEVE_TRUE@am__EXEEXT_29 = sieve/sievec$(EXEEXT) \
+@SIEVE_TRUE@am__EXEEXT_30 = sieve/sievec$(EXEEXT) \
 @SIEVE_TRUE@	sieve/sieved$(EXEEXT)
 PROGRAMS = $(bin_PROGRAMS) $(libexec_PROGRAMS) $(noinst_PROGRAMS) \
 	$(sbin_PROGRAMS)
@@ -934,170 +1005,179 @@ am_backup_backupd_OBJECTS = imap/mutex_f
 	imap/sync_support.$(OBJEXT) master/service.$(OBJEXT) \
 	backup/backupd.$(OBJEXT)
 backup_backupd_OBJECTS = $(am_backup_backupd_OBJECTS)
-@SIEVE_TRUE@am__DEPENDENCIES_6 = sieve/libcyrus_sieve.la \
+@SIEVE_TRUE@am__DEPENDENCIES_8 = sieve/libcyrus_sieve.la \
 @SIEVE_TRUE@	$(am__DEPENDENCIES_2)
-am__DEPENDENCIES_7 = imap/libcyrus_imap.la $(am__DEPENDENCIES_2) \
+am__DEPENDENCIES_9 = imap/libcyrus_imap.la $(am__DEPENDENCIES_2) \
 	$(am__DEPENDENCIES_1)
-am__DEPENDENCIES_8 = $(am__DEPENDENCIES_7) $(am__DEPENDENCIES_1)
+@USE_LIBCHARDET_TRUE@am__DEPENDENCIES_10 = $(am__DEPENDENCIES_1)
+@USE_JANSSON_TRUE@am__DEPENDENCIES_11 = $(am__DEPENDENCIES_1)
+am__DEPENDENCIES_12 = $(am__DEPENDENCIES_9) $(am__DEPENDENCIES_1) \
+	$(am__DEPENDENCIES_10) $(am__DEPENDENCIES_11)
 backup_backupd_DEPENDENCIES = backup/libcyrus_backup.la \
-	$(am__DEPENDENCIES_6) $(am__DEPENDENCIES_8)
+	$(am__DEPENDENCIES_8) $(am__DEPENDENCIES_12)
 am_backup_ctl_backups_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/sync_support.$(OBJEXT) backup/ctl_backups.$(OBJEXT)
 backup_ctl_backups_OBJECTS = $(am_backup_ctl_backups_OBJECTS)
 backup_ctl_backups_DEPENDENCIES = backup/libcyrus_backup.la \
-	$(am__DEPENDENCIES_6) $(am__DEPENDENCIES_7)
+	$(am__DEPENDENCIES_8) $(am__DEPENDENCIES_9)
 am_backup_cyr_backup_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	backup/cyr_backup.$(OBJEXT)
 backup_cyr_backup_OBJECTS = $(am_backup_cyr_backup_OBJECTS)
 backup_cyr_backup_DEPENDENCIES = backup/libcyrus_backup.la \
-	$(am__DEPENDENCIES_7) $(am__DEPENDENCIES_1)
+	$(am__DEPENDENCIES_9)
 am_backup_restore_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/sync_support.$(OBJEXT) backup/restore.$(OBJEXT)
 backup_restore_OBJECTS = $(am_backup_restore_OBJECTS)
 backup_restore_DEPENDENCIES = backup/libcyrus_backup.la \
-	$(am__DEPENDENCIES_6) $(am__DEPENDENCIES_7)
-am__cunit_unit_SOURCES_DIST = cunit/unit.c cunit/cunit.h \
+	$(am__DEPENDENCIES_8) $(am__DEPENDENCIES_9)
+am__bench_cyrdbbench_SOURCES_DIST = bench/cyrdbbench.c \
+	imap/mutex_fake.c
+@BENCH_TRUE@am_bench_cyrdbbench_OBJECTS = bench/cyrdbbench.$(OBJEXT) \
+@BENCH_TRUE@	imap/mutex_fake.$(OBJEXT)
+bench_cyrdbbench_OBJECTS = $(am_bench_cyrdbbench_OBJECTS)
+@BENCH_TRUE@bench_cyrdbbench_DEPENDENCIES = $(am__DEPENDENCIES_2)
+am__cunit_unit_SOURCES_DIST = cunit/unit.c cunit/cyrunit.h \
 	cunit/syslog.c cunit/cunit-syslog.h cunit/timeout.c \
 	cunit/timeout.h cunit/timezones.c cunit/timezones.h \
 	cunit/timeofday.c cunit/timeofday.h cunit/aaa-db.testc \
 	cunit/annotate.testc cunit/backend.testc cunit/binhex.testc \
 	cunit/bitvector.testc cunit/buf.testc cunit/byteorder64.testc \
 	cunit/charset.testc cunit/command.testc \
-	cunit/conversations.testc cunit/crc32.testc cunit/dlist.testc \
-	cunit/duplicate.testc cunit/getxstring.testc cunit/glob.testc \
-	cunit/guid.testc cunit/hash.testc cunit/imapurl.testc \
-	cunit/libconfig.testc cunit/mboxname.testc cunit/md5.testc \
-	cunit/message.testc cunit/msgid.testc cunit/parseaddr.testc \
-	cunit/parse.testc cunit/prot.testc cunit/ptrarray.testc \
-	cunit/quota.testc cunit/rfc822tok.testc \
+	cunit/conversations.testc cunit/cyr_qsort_r.testc \
+	cunit/crc32.testc cunit/dlist.testc cunit/duplicate.testc \
+	cunit/getxstring.testc cunit/glob.testc cunit/guid.testc \
+	cunit/hash.testc cunit/hashset.testc cunit/imapurl.testc \
+	cunit/imparse.testc cunit/libconfig.testc cunit/mboxname.testc \
+	cunit/md5.testc cunit/message.testc cunit/msgid.testc \
+	cunit/parseaddr.testc cunit/parse.testc cunit/prot.testc \
+	cunit/ptrarray.testc cunit/quota.testc cunit/rfc822tok.testc \
 	cunit/search_expr.testc cunit/seqset.testc cunit/sieve.testc \
 	cunit/spool.testc cunit/squat.testc cunit/strarray.testc \
 	cunit/strconcat.testc cunit/times.testc cunit/tok.testc \
-	cunit/vparse.testc imap/mutex_fake.c imap/spool.c
-@CUNIT_TRUE@am__objects_43 = cunit/unit.$(OBJEXT) \
+	cunit/vparse.testc cunit/jmap_util.testc imap/mutex_fake.c \
+	imap/spool.c
+@CUNIT_TRUE@am__objects_45 = cunit/unit.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/syslog.$(OBJEXT) cunit/timeout.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/timezones.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/timeofday.$(OBJEXT)
-@CUNIT_TRUE@@SIEVE_TRUE@am__objects_44 = cunit/sieve.$(OBJEXT)
-@CUNIT_TRUE@am__objects_45 = cunit/aaa-db.$(OBJEXT) \
+@CUNIT_TRUE@@SIEVE_TRUE@am__objects_46 = cunit/sieve.$(OBJEXT)
+@CUNIT_TRUE@@JMAP_TRUE@am__objects_47 = cunit/jmap_util.$(OBJEXT)
+@CUNIT_TRUE@am__objects_48 = cunit/aaa-db.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/annotate.$(OBJEXT) cunit/backend.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/binhex.$(OBJEXT) cunit/bitvector.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/buf.$(OBJEXT) cunit/byteorder64.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/charset.$(OBJEXT) cunit/command.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/conversations.$(OBJEXT) \
-@CUNIT_TRUE@	cunit/crc32.$(OBJEXT) cunit/dlist.$(OBJEXT) \
-@CUNIT_TRUE@	cunit/duplicate.$(OBJEXT) \
+@CUNIT_TRUE@	cunit/cyr_qsort_r.$(OBJEXT) cunit/crc32.$(OBJEXT) \
+@CUNIT_TRUE@	cunit/dlist.$(OBJEXT) cunit/duplicate.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/getxstring.$(OBJEXT) cunit/glob.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/guid.$(OBJEXT) cunit/hash.$(OBJEXT) \
-@CUNIT_TRUE@	cunit/imapurl.$(OBJEXT) cunit/libconfig.$(OBJEXT) \
+@CUNIT_TRUE@	cunit/hashset.$(OBJEXT) cunit/imapurl.$(OBJEXT) \
+@CUNIT_TRUE@	cunit/imparse.$(OBJEXT) cunit/libconfig.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/mboxname.$(OBJEXT) cunit/md5.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/message.$(OBJEXT) cunit/msgid.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/parseaddr.$(OBJEXT) cunit/parse.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/prot.$(OBJEXT) cunit/ptrarray.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/quota.$(OBJEXT) cunit/rfc822tok.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/search_expr.$(OBJEXT) cunit/seqset.$(OBJEXT) \
-@CUNIT_TRUE@	$(am__objects_44) cunit/spool.$(OBJEXT) \
+@CUNIT_TRUE@	$(am__objects_46) cunit/spool.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/squat.$(OBJEXT) cunit/strarray.$(OBJEXT) \
 @CUNIT_TRUE@	cunit/strconcat.$(OBJEXT) cunit/times.$(OBJEXT) \
-@CUNIT_TRUE@	cunit/tok.$(OBJEXT) cunit/vparse.$(OBJEXT)
-@CUNIT_TRUE@am_cunit_unit_OBJECTS = $(am__objects_43) \
-@CUNIT_TRUE@	$(am__objects_45) imap/mutex_fake.$(OBJEXT) \
+@CUNIT_TRUE@	cunit/tok.$(OBJEXT) cunit/vparse.$(OBJEXT) \
+@CUNIT_TRUE@	$(am__objects_47)
+@CUNIT_TRUE@am_cunit_unit_OBJECTS = $(am__objects_45) \
+@CUNIT_TRUE@	$(am__objects_48) imap/mutex_fake.$(OBJEXT) \
 @CUNIT_TRUE@	imap/spool.$(OBJEXT)
 cunit_unit_OBJECTS = $(am_cunit_unit_OBJECTS)
-@CUNIT_TRUE@cunit_unit_DEPENDENCIES = $(am__DEPENDENCIES_6) \
-@CUNIT_TRUE@	$(am__DEPENDENCIES_7)
+@CUNIT_TRUE@cunit_unit_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+@CUNIT_TRUE@	$(am__DEPENDENCIES_9)
 am_imap_arbitron_OBJECTS = imap/arbitron.$(OBJEXT) \
 	imap/cli_fatal.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_arbitron_OBJECTS = $(am_imap_arbitron_OBJECTS)
-imap_arbitron_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_arbitron_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_calalarmd_OBJECTS = imap/calalarmd.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT)
 imap_calalarmd_OBJECTS = $(am_imap_calalarmd_OBJECTS)
-imap_calalarmd_DEPENDENCIES = $(am__DEPENDENCIES_8)
+imap_calalarmd_DEPENDENCIES = $(am__DEPENDENCIES_12)
 am_imap_chk_cyrus_OBJECTS = imap/chk_cyrus.$(OBJEXT) \
 	imap/cli_fatal.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_chk_cyrus_OBJECTS = $(am_imap_chk_cyrus_OBJECTS)
-imap_chk_cyrus_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_chk_cyrus_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_ctl_conversationsdb_OBJECTS =  \
 	imap/ctl_conversationsdb.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_ctl_conversationsdb_OBJECTS =  \
 	$(am_imap_ctl_conversationsdb_OBJECTS)
-imap_ctl_conversationsdb_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ctl_conversationsdb_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_ctl_cyrusdb_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/ctl_cyrusdb.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_ctl_cyrusdb_OBJECTS = $(am_imap_ctl_cyrusdb_OBJECTS)
-imap_ctl_cyrusdb_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ctl_cyrusdb_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_ctl_deliver_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/ctl_deliver.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_ctl_deliver_OBJECTS = $(am_imap_ctl_deliver_OBJECTS)
-imap_ctl_deliver_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ctl_deliver_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_ctl_mboxlist_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/ctl_mboxlist.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_ctl_mboxlist_OBJECTS = $(am_imap_ctl_mboxlist_OBJECTS)
-imap_ctl_mboxlist_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ctl_mboxlist_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_ctl_zoneinfo_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/ctl_zoneinfo.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
 	imap/zoneinfo_db.$(OBJEXT)
 imap_ctl_zoneinfo_OBJECTS = $(am_imap_ctl_zoneinfo_OBJECTS)
-imap_ctl_zoneinfo_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ctl_zoneinfo_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cvt_cyrusdb_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cvt_cyrusdb.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cvt_cyrusdb_OBJECTS = $(am_imap_cvt_cyrusdb_OBJECTS)
-imap_cvt_cyrusdb_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cvt_cyrusdb_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cvt_xlist_specialuse_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/cvt_xlist_specialuse.$(OBJEXT)
 imap_cvt_xlist_specialuse_OBJECTS =  \
 	$(am_imap_cvt_xlist_specialuse_OBJECTS)
-imap_cvt_xlist_specialuse_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cvt_xlist_specialuse_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_buildinfo_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_buildinfo.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
 	master/masterconf.$(OBJEXT)
 imap_cyr_buildinfo_OBJECTS = $(am_imap_cyr_buildinfo_OBJECTS)
-imap_cyr_buildinfo_DEPENDENCIES = $(am__DEPENDENCIES_7) \
-	$(am__DEPENDENCIES_1)
+imap_cyr_buildinfo_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_dbtool_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_dbtool.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_dbtool_OBJECTS = $(am_imap_cyr_dbtool_OBJECTS)
-imap_cyr_dbtool_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_dbtool_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_deny_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_deny.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_deny_OBJECTS = $(am_imap_cyr_deny_OBJECTS)
-imap_cyr_deny_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_deny_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_df_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_df.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_df_OBJECTS = $(am_imap_cyr_df_OBJECTS)
-imap_cyr_df_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_df_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_expire_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_expire.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_expire_OBJECTS = $(am_imap_cyr_expire_OBJECTS)
-imap_cyr_expire_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_expire_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_info_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_info.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
 	master/masterconf.$(OBJEXT)
 imap_cyr_info_OBJECTS = $(am_imap_cyr_info_OBJECTS)
-imap_cyr_info_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_info_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_sequence_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_sequence.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_sequence_OBJECTS = $(am_imap_cyr_sequence_OBJECTS)
-imap_cyr_sequence_DEPENDENCIES = $(am__DEPENDENCIES_7)
-am_imap_cyr_sphinxmgr_OBJECTS = imap/cli_fatal.$(OBJEXT) \
-	imap/cyr_sphinxmgr.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
-imap_cyr_sphinxmgr_OBJECTS = $(am_imap_cyr_sphinxmgr_OBJECTS)
-imap_cyr_sphinxmgr_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_sequence_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_synclog_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_synclog.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_synclog_OBJECTS = $(am_imap_cyr_synclog_OBJECTS)
-imap_cyr_synclog_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_synclog_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_userseen_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyr_userseen.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyr_userseen_OBJECTS = $(am_imap_cyr_userseen_OBJECTS)
-imap_cyr_userseen_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyr_userseen_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_cyr_virusscan_OBJECTS =  \
 	imap/imap_cyr_virusscan-cli_fatal.$(OBJEXT) \
 	imap/imap_cyr_virusscan-cyr_virusscan.$(OBJEXT) \
 	imap/imap_cyr_virusscan-mutex_fake.$(OBJEXT)
 imap_cyr_virusscan_OBJECTS = $(am_imap_cyr_virusscan_OBJECTS)
-imap_cyr_virusscan_DEPENDENCIES = $(am__DEPENDENCIES_7) \
+imap_cyr_virusscan_DEPENDENCIES = $(am__DEPENDENCIES_9) \
 	$(am__DEPENDENCIES_1)
 imap_cyr_virusscan_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
@@ -1106,99 +1186,150 @@ imap_cyr_virusscan_LINK = $(LIBTOOL) $(A
 am_imap_cyrdump_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/cyrdump.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_cyrdump_OBJECTS = $(am_imap_cyrdump_OBJECTS)
-imap_cyrdump_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_cyrdump_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_dav_reconstruct_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/dav_reconstruct.$(OBJEXT)
 imap_dav_reconstruct_OBJECTS = $(am_imap_dav_reconstruct_OBJECTS)
-imap_dav_reconstruct_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_dav_reconstruct_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_deliver_OBJECTS = imap/deliver.$(OBJEXT) \
-	imap/lmtpengine.$(OBJEXT) imap/lmtpstats.$(OBJEXT) \
-	imap/mutex_fake.$(OBJEXT) imap/proxy.$(OBJEXT) \
-	imap/spool.$(OBJEXT)
-imap_deliver_OBJECTS = $(am_imap_deliver_OBJECTS)
-imap_deliver_DEPENDENCIES = $(am__DEPENDENCIES_7)
+	imap/lmtpengine.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
+	imap/proxy.$(OBJEXT) imap/spool.$(OBJEXT)
+nodist_imap_deliver_OBJECTS = imap/lmtp_err.$(OBJEXT) \
+	imap/lmtpstats.$(OBJEXT)
+imap_deliver_OBJECTS = $(am_imap_deliver_OBJECTS) \
+	$(nodist_imap_deliver_OBJECTS)
+imap_deliver_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_fetchnews_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/fetchnews.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_fetchnews_OBJECTS = $(am_imap_fetchnews_OBJECTS)
-imap_fetchnews_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_fetchnews_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_fud_OBJECTS = imap/fud.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
 	master/service.$(OBJEXT)
 imap_fud_OBJECTS = $(am_imap_fud_OBJECTS)
-imap_fud_DEPENDENCIES = $(am__DEPENDENCIES_8)
-am_imap_httpd_OBJECTS = imap/caldav_db.$(OBJEXT) \
+imap_fud_DEPENDENCIES = $(am__DEPENDENCIES_12)
+am__imap_httpd_SOURCES_DIST = imap/css3_color.c imap/css3_color.h \
+	imap/http_admin.c imap/http_applepush.c imap/http_caldav.c \
+	imap/http_caldav.h imap/http_caldav_js.h \
+	imap/http_caldav_sched.c imap/http_caldav_sched.h \
+	imap/http_carddav.c imap/http_carddav.h imap/http_carddav_js.h \
+	imap/http_cgi.c imap/http_dav.c imap/http_dav.h \
+	imap/http_dav_sharing.c imap/http_dav_sharing.h \
+	imap/http_dblookup.c imap/http_h2.c imap/http_h2.h \
+	imap/http_ischedule.c imap/http_prometheus.c imap/http_proxy.c \
+	imap/http_proxy.h imap/http_rss.c imap/http_tzdist.c \
+	imap/http_webdav.c imap/http_ws.c imap/http_ws.h imap/httpd.c \
+	imap/httpd.h imap/jcal.c imap/jcal.h imap/json_support.h \
+	imap/mutex_fake.c imap/proxy.c imap/smtpclient.c imap/spool.c \
+	imap/xcal.c imap/xcal.h imap/xml_support.c imap/xml_support.h \
+	imap/zoneinfo_db.c imap/zoneinfo_db.h master/masterconf.c \
+	master/service.c imap/http_jmap.c imap/http_jmap.h \
+	imap/jmap_api.c imap/jmap_api.h imap/jmap_calendar.c \
+	imap/jmap_contact.c imap/jmap_core.c imap/jmap_ical.c \
+	imap/jmap_ical.h imap/jmap_mail.c imap/jmap_mail.h \
+	imap/jmap_mail_query.c imap/jmap_mail_query.h \
+	imap/jmap_mail_submission.c imap/jmap_mailbox.c \
+	imap/jmap_util.c imap/jmap_util.h imap/jmap_vacation.c \
+	imap/sync_support.c imap/sync_support.h
+@JMAP_TRUE@am__objects_49 = imap/http_jmap.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_api.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_calendar.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_contact.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_core.$(OBJEXT) imap/jmap_ical.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_mail.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_mail_query.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_mail_submission.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_mailbox.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_util.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_vacation.$(OBJEXT) \
+@JMAP_TRUE@	imap/sync_support.$(OBJEXT)
+am_imap_httpd_OBJECTS = imap/css3_color.$(OBJEXT) \
 	imap/http_admin.$(OBJEXT) imap/http_applepush.$(OBJEXT) \
 	imap/http_caldav.$(OBJEXT) imap/http_caldav_sched.$(OBJEXT) \
-	imap/http_carddav.$(OBJEXT) imap/http_client.$(OBJEXT) \
-	imap/http_dav.$(OBJEXT) imap/http_dblookup.$(OBJEXT) \
-	imap/http_ischedule.$(OBJEXT) imap/http_proxy.$(OBJEXT) \
-	imap/http_rss.$(OBJEXT) imap/http_tzdist.$(OBJEXT) \
-	imap/http_webdav.$(OBJEXT) imap/httpd.$(OBJEXT) \
-	imap/ical_support.$(OBJEXT) imap/jcal.$(OBJEXT) \
-	imap/mutex_fake.$(OBJEXT) imap/proxy.$(OBJEXT) \
-	imap/smtpclient.$(OBJEXT) imap/spool.$(OBJEXT) \
-	imap/vcard_support.$(OBJEXT) imap/xcal.$(OBJEXT) \
+	imap/http_carddav.$(OBJEXT) imap/http_cgi.$(OBJEXT) \
+	imap/http_dav.$(OBJEXT) imap/http_dav_sharing.$(OBJEXT) \
+	imap/http_dblookup.$(OBJEXT) imap/http_h2.$(OBJEXT) \
+	imap/http_ischedule.$(OBJEXT) imap/http_prometheus.$(OBJEXT) \
+	imap/http_proxy.$(OBJEXT) imap/http_rss.$(OBJEXT) \
+	imap/http_tzdist.$(OBJEXT) imap/http_webdav.$(OBJEXT) \
+	imap/http_ws.$(OBJEXT) imap/httpd.$(OBJEXT) \
+	imap/jcal.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
+	imap/proxy.$(OBJEXT) imap/smtpclient.$(OBJEXT) \
+	imap/spool.$(OBJEXT) imap/xcal.$(OBJEXT) \
 	imap/xml_support.$(OBJEXT) imap/zoneinfo_db.$(OBJEXT) \
-	master/masterconf.$(OBJEXT) master/service.$(OBJEXT)
-nodist_imap_httpd_OBJECTS = imap/http_err.$(OBJEXT) \
-	imap/tz_err.$(OBJEXT)
+	master/masterconf.$(OBJEXT) master/service.$(OBJEXT) \
+	$(am__objects_49)
+@JMAP_TRUE@am__objects_50 = imap/jmap_err.$(OBJEXT)
+nodist_imap_httpd_OBJECTS = imap/tz_err.$(OBJEXT) $(am__objects_50)
 imap_httpd_OBJECTS = $(am_imap_httpd_OBJECTS) \
 	$(nodist_imap_httpd_OBJECTS)
-imap_httpd_DEPENDENCIES = $(am__DEPENDENCIES_8)
+@JMAP_TRUE@am__DEPENDENCIES_13 = $(am__DEPENDENCIES_8)
+imap_httpd_DEPENDENCIES = $(am__DEPENDENCIES_12) \
+	$(am__DEPENDENCIES_13)
+am_imap_ical_apply_patch_OBJECTS = imap/cli_fatal.$(OBJEXT) \
+	imap/mutex_fake.$(OBJEXT) imap/ical_apply_patch.$(OBJEXT)
+imap_ical_apply_patch_OBJECTS = $(am_imap_ical_apply_patch_OBJECTS)
+imap_ical_apply_patch_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_idled_OBJECTS = imap/idled.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_idled_OBJECTS = $(am_imap_idled_OBJECTS)
-imap_idled_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_idled_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am__imap_imapd_SOURCES_DIST = imap/imap_proxy.c imap/imap_proxy.h \
-	imap/imapd.c imap/imapd.h imap/mutex_fake.c imap/pushstats.c \
-	imap/pushstats.h imap/proxy.c imap/proxy.h imap/sync_support.c \
-	imap/sync_support.h master/service.c imap/autocreate.h \
-	imap/autocreate.c
-@AUTOCREATE_TRUE@am__objects_46 = imap/autocreate.$(OBJEXT)
+	imap/imapd.c imap/imapd.h imap/mutex_fake.c imap/proxy.c \
+	imap/proxy.h imap/sync_support.c imap/sync_support.h \
+	master/service.c imap/autocreate.h imap/autocreate.c
+@AUTOCREATE_TRUE@am__objects_51 = imap/autocreate.$(OBJEXT)
 am_imap_imapd_OBJECTS = imap/imap_proxy.$(OBJEXT) imap/imapd.$(OBJEXT) \
-	imap/mutex_fake.$(OBJEXT) imap/pushstats.$(OBJEXT) \
-	imap/proxy.$(OBJEXT) imap/sync_support.$(OBJEXT) \
-	master/service.$(OBJEXT) $(am__objects_46)
-imap_imapd_OBJECTS = $(am_imap_imapd_OBJECTS)
-imap_imapd_DEPENDENCIES = $(am__DEPENDENCIES_6) $(am__DEPENDENCIES_8)
+	imap/mutex_fake.$(OBJEXT) imap/proxy.$(OBJEXT) \
+	imap/sync_support.$(OBJEXT) master/service.$(OBJEXT) \
+	$(am__objects_51)
+nodist_imap_imapd_OBJECTS = imap/pushstats.$(OBJEXT)
+imap_imapd_OBJECTS = $(am_imap_imapd_OBJECTS) \
+	$(nodist_imap_imapd_OBJECTS)
+imap_imapd_DEPENDENCIES = $(am__DEPENDENCIES_8) $(am__DEPENDENCIES_12)
 am_imap_ipurge_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/ipurge.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_ipurge_OBJECTS = $(am_imap_ipurge_OBJECTS)
-imap_ipurge_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_ipurge_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am__imap_lmtpd_SOURCES_DIST = imap/lmtpd.c imap/lmtpd.h \
-	imap/lmtpengine.c imap/lmtpengine.h imap/lmtpstats.c \
-	imap/lmtpstats.h imap/mutex_fake.c imap/proxy.c imap/spool.c \
-	master/service.c imap/autocreate.c imap/autocreate.h \
-	imap/lmtp_sieve.c imap/lmtp_sieve.h imap/smtpclient.c
-@SIEVE_TRUE@am__objects_47 = imap/lmtp_sieve.$(OBJEXT) \
+	imap/lmtpengine.c imap/lmtpengine.h imap/mutex_fake.c \
+	imap/proxy.c imap/spool.c master/service.c imap/autocreate.c \
+	imap/autocreate.h imap/lmtp_sieve.c imap/lmtp_sieve.h \
+	imap/smtpclient.c imap/jmap_util.c imap/jmap_mail_query.c
+@SIEVE_TRUE@am__objects_52 = imap/lmtp_sieve.$(OBJEXT) \
 @SIEVE_TRUE@	imap/smtpclient.$(OBJEXT)
+@JMAP_TRUE@@SIEVE_TRUE@am__objects_53 = imap/jmap_util.$(OBJEXT) \
+@JMAP_TRUE@@SIEVE_TRUE@	imap/jmap_mail_query.$(OBJEXT)
 am_imap_lmtpd_OBJECTS = imap/lmtpd.$(OBJEXT) imap/lmtpengine.$(OBJEXT) \
-	imap/lmtpstats.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
-	imap/proxy.$(OBJEXT) imap/spool.$(OBJEXT) \
-	master/service.$(OBJEXT) $(am__objects_46) $(am__objects_47)
-imap_lmtpd_OBJECTS = $(am_imap_lmtpd_OBJECTS)
-imap_lmtpd_DEPENDENCIES = $(am__DEPENDENCIES_6) $(am__DEPENDENCIES_8)
+	imap/mutex_fake.$(OBJEXT) imap/proxy.$(OBJEXT) \
+	imap/spool.$(OBJEXT) master/service.$(OBJEXT) \
+	$(am__objects_51) $(am__objects_52) $(am__objects_53)
+nodist_imap_lmtpd_OBJECTS = imap/lmtp_err.$(OBJEXT) \
+	imap/lmtpstats.$(OBJEXT)
+imap_lmtpd_OBJECTS = $(am_imap_lmtpd_OBJECTS) \
+	$(nodist_imap_lmtpd_OBJECTS)
+imap_lmtpd_DEPENDENCIES = $(am__DEPENDENCIES_8) $(am__DEPENDENCIES_12)
 am_imap_mbexamine_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mbexamine.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_mbexamine_OBJECTS = $(am_imap_mbexamine_OBJECTS)
-imap_mbexamine_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_mbexamine_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_mbpath_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mbpath.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_mbpath_OBJECTS = $(am_imap_mbpath_OBJECTS)
-imap_mbpath_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_mbpath_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_mbtool_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mbtool.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
 imap_mbtool_OBJECTS = $(am_imap_mbtool_OBJECTS)
-imap_mbtool_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_mbtool_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_message_test_OBJECTS = imap/message_test.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT)
 imap_message_test_OBJECTS = $(am_imap_message_test_OBJECTS)
-imap_message_test_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_message_test_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_mupdate_OBJECTS = imap/imap_mupdate-mupdate.$(OBJEXT) \
 	imap/imap_mupdate-mupdate-slave.$(OBJEXT) \
 	imap/imap_mupdate-mutex_pthread.$(OBJEXT) \
 	imap/imap_mupdate-tls_th-lock.$(OBJEXT) \
 	master/imap_mupdate-service-thread.$(OBJEXT)
 imap_mupdate_OBJECTS = $(am_imap_mupdate_OBJECTS)
-imap_mupdate_DEPENDENCIES = $(am__DEPENDENCIES_8)
+imap_mupdate_DEPENDENCIES = $(am__DEPENDENCIES_12)
 imap_mupdate_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(imap_mupdate_CFLAGS) \
 	$(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
@@ -1208,64 +1339,68 @@ am_imap_nntpd_OBJECTS = imap/mutex_fake.
 nodist_imap_nntpd_OBJECTS = imap/nntp_err.$(OBJEXT)
 imap_nntpd_OBJECTS = $(am_imap_nntpd_OBJECTS) \
 	$(nodist_imap_nntpd_OBJECTS)
-imap_nntpd_DEPENDENCIES = $(am__DEPENDENCIES_8)
+imap_nntpd_DEPENDENCIES = $(am__DEPENDENCIES_12)
 am__imap_pop3d_SOURCES_DIST = imap/mutex_fake.c imap/pop3d.c \
 	imap/proxy.c master/service.c imap/autocreate.c \
 	imap/autocreate.h
 am_imap_pop3d_OBJECTS = imap/mutex_fake.$(OBJEXT) imap/pop3d.$(OBJEXT) \
 	imap/proxy.$(OBJEXT) master/service.$(OBJEXT) \
-	$(am__objects_46)
+	$(am__objects_51)
 imap_pop3d_OBJECTS = $(am_imap_pop3d_OBJECTS)
-imap_pop3d_DEPENDENCIES = $(am__DEPENDENCIES_6) $(am__DEPENDENCIES_8)
+imap_pop3d_DEPENDENCIES = $(am__DEPENDENCIES_8) $(am__DEPENDENCIES_12)
+am_imap_promstatsd_OBJECTS = imap/promstatsd.$(OBJEXT) \
+	imap/mutex_fake.$(OBJEXT)
+imap_promstatsd_OBJECTS = $(am_imap_promstatsd_OBJECTS)
+imap_promstatsd_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_quota_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/quota.$(OBJEXT)
 imap_quota_OBJECTS = $(am_imap_quota_OBJECTS)
-imap_quota_DEPENDENCIES = $(am__DEPENDENCIES_7) $(am__DEPENDENCIES_1)
+imap_quota_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_reconstruct_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/reconstruct.$(OBJEXT)
 imap_reconstruct_OBJECTS = $(am_imap_reconstruct_OBJECTS)
-imap_reconstruct_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_reconstruct_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_search_test_OBJECTS = imap/search_test.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT)
 imap_search_test_OBJECTS = $(am_imap_search_test_OBJECTS)
-imap_search_test_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_search_test_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_smmapd_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/proxy.$(OBJEXT) imap/smmapd.$(OBJEXT) \
 	master/service.$(OBJEXT)
 imap_smmapd_OBJECTS = $(am_imap_smmapd_OBJECTS)
-imap_smmapd_DEPENDENCIES = $(am__DEPENDENCIES_8)
+imap_smmapd_DEPENDENCIES = $(am__DEPENDENCIES_12)
 am_imap_squat_dump_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/squat_dump.$(OBJEXT)
 imap_squat_dump_OBJECTS = $(am_imap_squat_dump_OBJECTS)
-imap_squat_dump_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_squat_dump_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_squatter_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/squatter.$(OBJEXT)
 imap_squatter_OBJECTS = $(am_imap_squatter_OBJECTS)
-imap_squatter_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_squatter_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_sync_client_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/sync_client.$(OBJEXT) imap/sync_support.$(OBJEXT)
 imap_sync_client_OBJECTS = $(am_imap_sync_client_OBJECTS)
-imap_sync_client_DEPENDENCIES = $(am__DEPENDENCIES_6) \
-	$(am__DEPENDENCIES_7)
+imap_sync_client_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+	$(am__DEPENDENCIES_9)
 am_imap_sync_reset_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/sync_reset.$(OBJEXT) imap/sync_support.$(OBJEXT)
 imap_sync_reset_OBJECTS = $(am_imap_sync_reset_OBJECTS)
-imap_sync_reset_DEPENDENCIES = $(am__DEPENDENCIES_6) \
-	$(am__DEPENDENCIES_7)
+imap_sync_reset_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+	$(am__DEPENDENCIES_9)
 am_imap_sync_server_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/sync_server.$(OBJEXT) imap/sync_support.$(OBJEXT) \
 	master/service.$(OBJEXT)
 imap_sync_server_OBJECTS = $(am_imap_sync_server_OBJECTS)
-imap_sync_server_DEPENDENCIES = $(am__DEPENDENCIES_6) \
-	$(am__DEPENDENCIES_8)
+imap_sync_server_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+	$(am__DEPENDENCIES_12)
 am_imap_tls_prune_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/tls_prune.$(OBJEXT)
 imap_tls_prune_OBJECTS = $(am_imap_tls_prune_OBJECTS)
-imap_tls_prune_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_tls_prune_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imap_unexpunge_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) imap/unexpunge.$(OBJEXT)
 imap_unexpunge_OBJECTS = $(am_imap_unexpunge_OBJECTS)
-imap_unexpunge_DEPENDENCIES = $(am__DEPENDENCIES_7)
+imap_unexpunge_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_imtest_imtest_OBJECTS = imtest/imtest_imtest-imtest.$(OBJEXT)
 imtest_imtest_OBJECTS = $(am_imtest_imtest_OBJECTS)
 imtest_imtest_DEPENDENCIES = $(am__DEPENDENCIES_2)
@@ -1288,14 +1423,14 @@ am__notifyd_notifyd_SOURCES_DIST = imap/
 	notifyd/notify_null.c notifyd/notify_null.h notifyd/notifyd.c \
 	notifyd/notifyd.h notifyd/notify_zephyr.c \
 	notifyd/notify_zephyr.h
-@ZEPHYR_TRUE@am__objects_48 = notifyd/notify_zephyr.$(OBJEXT)
+@ZEPHYR_TRUE@am__objects_54 = notifyd/notify_zephyr.$(OBJEXT)
 am_notifyd_notifyd_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	master/service.$(OBJEXT) notifyd/notify_external.$(OBJEXT) \
 	notifyd/notify_log.$(OBJEXT) notifyd/notify_mailto.$(OBJEXT) \
 	notifyd/notify_null.$(OBJEXT) notifyd/notifyd.$(OBJEXT) \
-	$(am__objects_48)
+	$(am__objects_54)
 notifyd_notifyd_OBJECTS = $(am_notifyd_notifyd_OBJECTS)
-notifyd_notifyd_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+notifyd_notifyd_DEPENDENCIES = $(am__DEPENDENCIES_12) \
 	$(am__DEPENDENCIES_1)
 am_notifyd_notifytest_OBJECTS = notifyd/notifytest.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT)
@@ -1304,44 +1439,54 @@ notifyd_notifytest_DEPENDENCIES = $(am__
 am_ptclient_ptdump_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) ptclient/ptdump.$(OBJEXT)
 ptclient_ptdump_OBJECTS = $(am_ptclient_ptdump_OBJECTS)
-ptclient_ptdump_DEPENDENCIES = $(am__DEPENDENCIES_7)
+ptclient_ptdump_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am_ptclient_ptexpire_OBJECTS = imap/cli_fatal.$(OBJEXT) \
 	imap/mutex_fake.$(OBJEXT) ptclient/ptexpire.$(OBJEXT)
 ptclient_ptexpire_OBJECTS = $(am_ptclient_ptexpire_OBJECTS)
-ptclient_ptexpire_DEPENDENCIES = $(am__DEPENDENCIES_7)
+ptclient_ptexpire_DEPENDENCIES = $(am__DEPENDENCIES_9)
 am__ptclient_ptloader_SOURCES_DIST = imap/mutex_fake.c \
 	ptclient/ptloader.c ptclient/ptloader.h \
 	master/service-thread.c ptclient/ldap.c ptclient/afskrb.c
-@HAVE_LDAP_TRUE@am__objects_49 = ptclient/ldap.$(OBJEXT)
-@USE_AFSKRB_TRUE@am__objects_50 = ptclient/afskrb.$(OBJEXT)
+@HAVE_LDAP_TRUE@am__objects_55 = ptclient/ldap.$(OBJEXT)
+@USE_AFSKRB_TRUE@am__objects_56 = ptclient/afskrb.$(OBJEXT)
 am_ptclient_ptloader_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	ptclient/ptloader.$(OBJEXT) master/service-thread.$(OBJEXT) \
-	$(am__objects_49) $(am__objects_50)
+	$(am__objects_55) $(am__objects_56)
 ptclient_ptloader_OBJECTS = $(am_ptclient_ptloader_OBJECTS)
-@HAVE_LDAP_TRUE@am__DEPENDENCIES_9 = $(am__DEPENDENCIES_1)
-@USE_AFSKRB_TRUE@am__DEPENDENCIES_10 = $(am__DEPENDENCIES_1)
-ptclient_ptloader_DEPENDENCIES = $(am__DEPENDENCIES_8) \
-	$(am__DEPENDENCIES_9) $(am__DEPENDENCIES_10)
+@HAVE_LDAP_TRUE@am__DEPENDENCIES_14 = $(am__DEPENDENCIES_1)
+@USE_AFSKRB_TRUE@am__DEPENDENCIES_15 = $(am__DEPENDENCIES_1)
+ptclient_ptloader_DEPENDENCIES = $(am__DEPENDENCIES_12) \
+	$(am__DEPENDENCIES_14) $(am__DEPENDENCIES_15)
 ptclient_ptloader_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
 	$(AM_CFLAGS) $(CFLAGS) $(ptclient_ptloader_LDFLAGS) $(LDFLAGS) \
 	-o $@
 sieve_sievec_SOURCES = sieve/sievec.c
 sieve_sievec_OBJECTS = sieve/sievec.$(OBJEXT)
-sieve_sievec_DEPENDENCIES = $(am__DEPENDENCIES_6)
+sieve_sievec_DEPENDENCIES = $(am__DEPENDENCIES_8)
 sieve_sieved_SOURCES = sieve/sieved.c
 sieve_sieved_OBJECTS = sieve/sieved.$(OBJEXT)
-sieve_sieved_DEPENDENCIES = $(am__DEPENDENCIES_6)
-am_sieve_test_OBJECTS = sieve/test.$(OBJEXT) imap/mutex_fake.$(OBJEXT)
+sieve_sieved_DEPENDENCIES = $(am__DEPENDENCIES_8)
+am__sieve_test_SOURCES_DIST = sieve/test.c imap/mutex_fake.c \
+	imap/jmap_util.c imap/jmap_mail_query.c
+@JMAP_TRUE@am__objects_57 = imap/jmap_util.$(OBJEXT) \
+@JMAP_TRUE@	imap/jmap_mail_query.$(OBJEXT)
+am_sieve_test_OBJECTS = sieve/test.$(OBJEXT) imap/mutex_fake.$(OBJEXT) \
+	$(am__objects_57)
 sieve_test_OBJECTS = $(am_sieve_test_OBJECTS)
-sieve_test_DEPENDENCIES = $(am__DEPENDENCIES_6) $(am__DEPENDENCIES_7)
+sieve_test_DEPENDENCIES = $(am__DEPENDENCIES_8) $(am__DEPENDENCIES_9)
+am_sieve_test_mailbox_OBJECTS = sieve/test_mailbox.$(OBJEXT) \
+	imap/mutex_fake.$(OBJEXT)
+sieve_test_mailbox_OBJECTS = $(am_sieve_test_mailbox_OBJECTS)
+sieve_test_mailbox_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+	$(am__DEPENDENCIES_9)
 am_timsieved_timsieved_OBJECTS = imap/mutex_fake.$(OBJEXT) \
 	imap/proxy.$(OBJEXT) master/service.$(OBJEXT) \
 	timsieved/actions.$(OBJEXT) timsieved/lex.$(OBJEXT) \
 	timsieved/parser.$(OBJEXT) timsieved/timsieved.$(OBJEXT)
 timsieved_timsieved_OBJECTS = $(am_timsieved_timsieved_OBJECTS)
-timsieved_timsieved_DEPENDENCIES = $(am__DEPENDENCIES_6) \
-	$(am__DEPENDENCIES_8)
+timsieved_timsieved_DEPENDENCIES = $(am__DEPENDENCIES_8) \
+	$(am__DEPENDENCIES_12)
 SCRIPTS = $(dist_noinst_SCRIPTS)
 AM_V_P = $(am__v_P_@AM_V@)
 am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
@@ -1417,7 +1562,6 @@ am__v_YACC_1 =
 SOURCES = $(backup_libcyrus_backup_la_SOURCES) \
 	$(com_err_et_libcyrus_com_err_la_SOURCES) \
 	$(imap_libcyrus_imap_la_SOURCES) \
-	$(dist_imap_libcyrus_imap_la_SOURCES) \
 	$(nodist_imap_libcyrus_imap_la_SOURCES) \
 	$(lib_libcyrus_la_SOURCES) $(nodist_lib_libcyrus_la_SOURCES) \
 	$(lib_libcyrus_min_la_SOURCES) \
@@ -1431,9 +1575,9 @@ SOURCES = $(backup_libcyrus_backup_la_SO
 	$(sieve_libcyrus_sieve_lex_la_SOURCES) \
 	$(backup_backupd_SOURCES) $(backup_ctl_backups_SOURCES) \
 	$(backup_cyr_backup_SOURCES) $(backup_restore_SOURCES) \
-	$(cunit_unit_SOURCES) $(imap_arbitron_SOURCES) \
-	$(imap_calalarmd_SOURCES) $(imap_chk_cyrus_SOURCES) \
-	$(imap_ctl_conversationsdb_SOURCES) \
+	$(bench_cyrdbbench_SOURCES) $(cunit_unit_SOURCES) \
+	$(imap_arbitron_SOURCES) $(imap_calalarmd_SOURCES) \
+	$(imap_chk_cyrus_SOURCES) $(imap_ctl_conversationsdb_SOURCES) \
 	$(imap_ctl_cyrusdb_SOURCES) $(imap_ctl_deliver_SOURCES) \
 	$(imap_ctl_mboxlist_SOURCES) $(imap_ctl_zoneinfo_SOURCES) \
 	$(imap_cvt_cyrusdb_SOURCES) \
@@ -1441,18 +1585,20 @@ SOURCES = $(backup_libcyrus_backup_la_SO
 	$(imap_cyr_buildinfo_SOURCES) $(imap_cyr_dbtool_SOURCES) \
 	$(imap_cyr_deny_SOURCES) $(imap_cyr_df_SOURCES) \
 	$(imap_cyr_expire_SOURCES) $(imap_cyr_info_SOURCES) \
-	$(imap_cyr_sequence_SOURCES) $(imap_cyr_sphinxmgr_SOURCES) \
-	$(imap_cyr_synclog_SOURCES) $(imap_cyr_userseen_SOURCES) \
-	$(imap_cyr_virusscan_SOURCES) $(imap_cyrdump_SOURCES) \
-	$(imap_dav_reconstruct_SOURCES) $(imap_deliver_SOURCES) \
+	$(imap_cyr_sequence_SOURCES) $(imap_cyr_synclog_SOURCES) \
+	$(imap_cyr_userseen_SOURCES) $(imap_cyr_virusscan_SOURCES) \
+	$(imap_cyrdump_SOURCES) $(imap_dav_reconstruct_SOURCES) \
+	$(imap_deliver_SOURCES) $(nodist_imap_deliver_SOURCES) \
 	$(imap_fetchnews_SOURCES) $(imap_fud_SOURCES) \
 	$(imap_httpd_SOURCES) $(nodist_imap_httpd_SOURCES) \
-	$(imap_idled_SOURCES) $(imap_imapd_SOURCES) \
+	$(imap_ical_apply_patch_SOURCES) $(imap_idled_SOURCES) \
+	$(imap_imapd_SOURCES) $(nodist_imap_imapd_SOURCES) \
 	$(imap_ipurge_SOURCES) $(imap_lmtpd_SOURCES) \
-	$(imap_mbexamine_SOURCES) $(imap_mbpath_SOURCES) \
-	$(imap_mbtool_SOURCES) $(imap_message_test_SOURCES) \
-	$(imap_mupdate_SOURCES) $(imap_nntpd_SOURCES) \
-	$(nodist_imap_nntpd_SOURCES) $(imap_pop3d_SOURCES) \
+	$(nodist_imap_lmtpd_SOURCES) $(imap_mbexamine_SOURCES) \
+	$(imap_mbpath_SOURCES) $(imap_mbtool_SOURCES) \
+	$(imap_message_test_SOURCES) $(imap_mupdate_SOURCES) \
+	$(imap_nntpd_SOURCES) $(nodist_imap_nntpd_SOURCES) \
+	$(imap_pop3d_SOURCES) $(imap_promstatsd_SOURCES) \
 	$(imap_quota_SOURCES) $(imap_reconstruct_SOURCES) \
 	$(imap_search_test_SOURCES) $(imap_smmapd_SOURCES) \
 	$(imap_squat_dump_SOURCES) $(imap_squatter_SOURCES) \
@@ -1463,20 +1609,21 @@ SOURCES = $(backup_libcyrus_backup_la_SO
 	$(notifyd_notifyd_SOURCES) $(notifyd_notifytest_SOURCES) \
 	$(ptclient_ptdump_SOURCES) $(ptclient_ptexpire_SOURCES) \
 	$(ptclient_ptloader_SOURCES) sieve/sievec.c sieve/sieved.c \
-	$(sieve_test_SOURCES) $(timsieved_timsieved_SOURCES)
+	$(sieve_test_SOURCES) $(sieve_test_mailbox_SOURCES) \
+	$(timsieved_timsieved_SOURCES)
 DIST_SOURCES = $(backup_libcyrus_backup_la_SOURCES) \
 	$(com_err_et_libcyrus_com_err_la_SOURCES) \
 	$(am__imap_libcyrus_imap_la_SOURCES_DIST) \
-	$(dist_imap_libcyrus_imap_la_SOURCES) \
 	$(am__lib_libcyrus_la_SOURCES_DIST) \
 	$(am__lib_libcyrus_min_la_SOURCES_DIST) $(libcrc32_la_SOURCES) \
 	$(am__perl_libcyrus_la_SOURCES_DIST) \
 	$(am__perl_libcyrus_min_la_SOURCES_DIST) \
 	$(perl_sieve_lib_libisieve_la_SOURCES) \
-	$(sieve_libcyrus_sieve_la_SOURCES) \
+	$(am__sieve_libcyrus_sieve_la_SOURCES_DIST) \
 	$(sieve_libcyrus_sieve_lex_la_SOURCES) \
 	$(backup_backupd_SOURCES) $(backup_ctl_backups_SOURCES) \
 	$(backup_cyr_backup_SOURCES) $(backup_restore_SOURCES) \
+	$(am__bench_cyrdbbench_SOURCES_DIST) \
 	$(am__cunit_unit_SOURCES_DIST) $(imap_arbitron_SOURCES) \
 	$(imap_calalarmd_SOURCES) $(imap_chk_cyrus_SOURCES) \
 	$(imap_ctl_conversationsdb_SOURCES) \
@@ -1487,30 +1634,31 @@ DIST_SOURCES = $(backup_libcyrus_backup_
 	$(imap_cyr_buildinfo_SOURCES) $(imap_cyr_dbtool_SOURCES) \
 	$(imap_cyr_deny_SOURCES) $(imap_cyr_df_SOURCES) \
 	$(imap_cyr_expire_SOURCES) $(imap_cyr_info_SOURCES) \
-	$(imap_cyr_sequence_SOURCES) $(imap_cyr_sphinxmgr_SOURCES) \
-	$(imap_cyr_synclog_SOURCES) $(imap_cyr_userseen_SOURCES) \
-	$(imap_cyr_virusscan_SOURCES) $(imap_cyrdump_SOURCES) \
-	$(imap_dav_reconstruct_SOURCES) $(imap_deliver_SOURCES) \
-	$(imap_fetchnews_SOURCES) $(imap_fud_SOURCES) \
-	$(imap_httpd_SOURCES) $(imap_idled_SOURCES) \
+	$(imap_cyr_sequence_SOURCES) $(imap_cyr_synclog_SOURCES) \
+	$(imap_cyr_userseen_SOURCES) $(imap_cyr_virusscan_SOURCES) \
+	$(imap_cyrdump_SOURCES) $(imap_dav_reconstruct_SOURCES) \
+	$(imap_deliver_SOURCES) $(imap_fetchnews_SOURCES) \
+	$(imap_fud_SOURCES) $(am__imap_httpd_SOURCES_DIST) \
+	$(imap_ical_apply_patch_SOURCES) $(imap_idled_SOURCES) \
 	$(am__imap_imapd_SOURCES_DIST) $(imap_ipurge_SOURCES) \
 	$(am__imap_lmtpd_SOURCES_DIST) $(imap_mbexamine_SOURCES) \
 	$(imap_mbpath_SOURCES) $(imap_mbtool_SOURCES) \
 	$(imap_message_test_SOURCES) $(imap_mupdate_SOURCES) \
 	$(imap_nntpd_SOURCES) $(am__imap_pop3d_SOURCES_DIST) \
-	$(imap_quota_SOURCES) $(imap_reconstruct_SOURCES) \
-	$(imap_search_test_SOURCES) $(imap_smmapd_SOURCES) \
-	$(imap_squat_dump_SOURCES) $(imap_squatter_SOURCES) \
-	$(imap_sync_client_SOURCES) $(imap_sync_reset_SOURCES) \
-	$(imap_sync_server_SOURCES) $(imap_tls_prune_SOURCES) \
-	$(imap_unexpunge_SOURCES) $(imtest_imtest_SOURCES) \
-	$(master_master_SOURCES) $(netnews_remotepurge_SOURCES) \
+	$(imap_promstatsd_SOURCES) $(imap_quota_SOURCES) \
+	$(imap_reconstruct_SOURCES) $(imap_search_test_SOURCES) \
+	$(imap_smmapd_SOURCES) $(imap_squat_dump_SOURCES) \
+	$(imap_squatter_SOURCES) $(imap_sync_client_SOURCES) \
+	$(imap_sync_reset_SOURCES) $(imap_sync_server_SOURCES) \
+	$(imap_tls_prune_SOURCES) $(imap_unexpunge_SOURCES) \
+	$(imtest_imtest_SOURCES) $(master_master_SOURCES) \
+	$(netnews_remotepurge_SOURCES) \
 	$(am__notifyd_notifyd_SOURCES_DIST) \
 	$(notifyd_notifytest_SOURCES) $(ptclient_ptdump_SOURCES) \
 	$(ptclient_ptexpire_SOURCES) \
 	$(am__ptclient_ptloader_SOURCES_DIST) sieve/sievec.c \
-	sieve/sieved.c $(sieve_test_SOURCES) \
-	$(timsieved_timsieved_SOURCES)
+	sieve/sieved.c $(am__sieve_test_SOURCES_DIST) \
+	$(sieve_test_mailbox_SOURCES) $(timsieved_timsieved_SOURCES)
 RECURSIVE_TARGETS = all-recursive check-recursive cscopelist-recursive \
 	ctags-recursive dvi-recursive html-recursive info-recursive \
 	install-data-recursive install-dvi-recursive \
@@ -1662,6 +1810,8 @@ CFLAGS = @CFLAGS@
 CFLAG_VISIBILITY = @CFLAG_VISIBILITY@
 CLAMAV_CFLAGS = @CLAMAV_CFLAGS@
 CLAMAV_LIBS = @CLAMAV_LIBS@
+CLD2_CFLAGS = @CLD2_CFLAGS@
+CLD2_LIBS = @CLD2_LIBS@
 CMU_LIB_SUBDIR = @CMU_LIB_SUBDIR@
 COMPILE_ET = @COMPILE_ET@
 COM_ERR_CPPFLAGS = @COM_ERR_CPPFLAGS@
@@ -1686,6 +1836,8 @@ ECHO_C = @ECHO_C@
 ECHO_N = @ECHO_N@
 ECHO_T = @ECHO_T@
 EGREP = @EGREP@
+ENABLE_SHARED = @ENABLE_SHARED@
+ENABLE_STATIC = @ENABLE_STATIC@
 EXEEXT = @EXEEXT@
 FGREP = @FGREP@
 GCOV_CFLAGS = @GCOV_CFLAGS@
@@ -1701,8 +1853,6 @@ HTTP_CPPFLAGS = @HTTP_CPPFLAGS@
 HTTP_LIBS = @HTTP_LIBS@
 ICAL_CFLAGS = @ICAL_CFLAGS@
 ICAL_LIBS = @ICAL_LIBS@
-ICU4C_CFLAGS = @ICU4C_CFLAGS@
-ICU4C_LIBS = @ICU4C_LIBS@
 ICU_CFLAGS = @ICU_CFLAGS@
 ICU_LIBS = @ICU_LIBS@
 INSTALL = @INSTALL@
@@ -1720,6 +1870,9 @@ LDFLAGS = @LDFLAGS@
 LEX = @LEX@
 LEXLIB = @LEXLIB@
 LEX_OUTPUT_ROOT = @LEX_OUTPUT_ROOT@
+LIBCAP_LIBS = @LIBCAP_LIBS@
+LIBCHARDET_CFLAGS = @LIBCHARDET_CFLAGS@
+LIBCHARDET_LIBS = @LIBCHARDET_LIBS@
 LIBOBJS = @LIBOBJS@
 LIBS = @LIBS@
 LIBTOOL = @LIBTOOL@
@@ -1784,6 +1937,8 @@ SSL_CPPFLAGS = @SSL_CPPFLAGS@
 SSL_LIBS = @SSL_LIBS@
 STRIP = @STRIP@
 VERSION = @VERSION@
+WSLAY_CFLAGS = @WSLAY_CFLAGS@
+WSLAY_LIBS = @WSLAY_LIBS@
 XAPIAN_CONFIG = @XAPIAN_CONFIG@
 XAPIAN_CXXFLAGS = @XAPIAN_CXXFLAGS@
 XAPIAN_LIBS = @XAPIAN_LIBS@
@@ -1793,7 +1948,11 @@ XML2_LIBS = @XML2_LIBS@
 YACC = @YACC@
 YFLAGS = @YFLAGS@
 ZEPHYR_LIBS = @ZEPHYR_LIBS@
+ZEROSKIP_CFLAGS = @ZEROSKIP_CFLAGS@
+ZEROSKIP_LIBS = @ZEROSKIP_LIBS@
 ZLIB = @ZLIB@
+ZSTD_CFLAGS = @ZSTD_CFLAGS@
+ZSTD_LIBS = @ZSTD_LIBS@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
 abs_top_builddir = @abs_top_builddir@
@@ -1863,8 +2022,10 @@ AM_CPPFLAGS = $(COM_ERR_CPPFLAGS) -I${to
 	-DLIBEXEC_DIR=\"$(libexecdir)\" -DSBIN_DIR=\"$(sbindir)\" \
 	-DSYSCONF_DIR=\"$(sysconfdir)\" ${DEFS} ${LOCALDEFS} \
 	$(SASLFLAGS) $(SSL_CPPFLAGS) $(ICU_CFLAGS) $(am__append_1) \
-	$(am__append_19)
-AM_LDFLAGS = $(COV_LDFLAGS) $(ICU_LIBS) $(am__append_20)
+	$(am__append_18) $(am__append_49) $(am__append_52) \
+	$(am__append_90)
+AM_LDFLAGS = $(COV_LDFLAGS) $(ICU_LIBS) $(am__append_19) \
+	$(am__append_48) $(am__append_51)
 
 # have distcheck try to build with all optional components enabled, to aid
 # detection of missing files for these components
@@ -1876,34 +2037,42 @@ AM_DISTCHECK_CONFIGURE_FLAGS = \
     --enable-nntp \
     --enable-murder \
     --enable-idled \
-    --enable-event-notification \
     --enable-sieve \
     --enable-autocreate \
     --enable-backup \
-    --with-lmdb \
     --enable-xapian \
     --enable-jmap \
     --with-ldap
 
-BUILT_SOURCES = imap/imap_err.c lib/imapopts.c lib/imapopts.h \
-	$(am__append_2) $(am__append_4) $(am__append_21) \
-	$(am__append_44) $(am__append_50)
+BUILT_SOURCES = lib/imapopts.c lib/imapopts.h $(am__append_2) \
+	$(am__append_4) $(am__append_13) $(am__append_20) \
+	$(am__append_42) $(am__append_54) $(am__append_74)
 CLEANFILES = lib/chartable.c lib/imapopts.c lib/imapopts.h \
-	$(am__append_51)
+	$(am__append_55)
 DISTCLEANFILES = \
+	com_err/et/compile_et \
+	imap/http_caldav_js.h \
+	imap/http_carddav_js.h \
+	imap/http_err.c \
+	imap/http_err.h \
 	imap/imap_err.c \
 	imap/imap_err.h \
+	imap/jmap_err.c \
+	imap/jmap_err.h \
+	imap/lmtp_err.c \
+	imap/lmtp_err.h \
+	imap/lmtpstats.c \
+	imap/lmtpstats.h \
 	imap/mupdate_err.c \
 	imap/mupdate_err.h \
 	imap/nntp_err.c \
 	imap/nntp_err.h \
-	imap/http_caldav_js.h \
-	imap/http_carddav_js.h \
-	imap/http_err.c \
-	imap/http_err.h \
+	imap/promdata.c \
+	imap/promdata.h \
+	imap/pushstats.c \
+	imap/pushstats.h \
 	imap/tz_err.c \
 	imap/tz_err.h \
-	com_err/et/compile_et \
 	perl/sieve/scripts/installsieve \
 	perl/sieve/scripts/sieveshell \
 	sieve/sieve_err.c \
@@ -1914,28 +2083,34 @@ MAINTAINERCLEANFILES = \
 	doc/legacy/netnews.png \
 	man/imapd.conf.5 \
 	man/sieveshell.1 \
-	imap/lmtpstats.h \
-	imap/pushstats.h \
 	sieve/addr.h \
 	sieve/sieve.h
 
-SUBDIRS = . $(am__append_40) $(am__append_42)
+SUBDIRS = . $(am__append_38) $(am__append_40)
 DIST_SUBDIRS = . perl/annotator perl/imap perl/sieve/managesieve
-dist_sysconf_DATA = $(am__append_36)
+dist_sysconf_DATA = $(am__append_34)
 lib_LTLIBRARIES = lib/libcyrus_min.la lib/libcyrus.la $(am__append_3) \
-	$(am__append_5) $(am__append_46)
+	$(am__append_5) $(am__append_44)
 noinst_HEADERS = $(am__append_27) lib/byteorder64.h lib/gai.h \
 	lib/libconfig.h lib/md5.h lib/prot.h lib/ptrarray.h lib/util.h \
 	lib/xsha1.h lib/xstrlcat.h lib/xstrlcpy.h lib/xstrnchr.h
-noinst_LTLIBRARIES = $(am__append_26) $(am__append_41) \
-	$(am__append_43) $(am__append_45) libcrc32.la
-EXTRA_DIST = $(wildcard tools/vzic/*) VERSION $(am__append_34) \
-	$(am__append_35) COPYING README.md SMakefile \
-	com_err/et/et_c.awk com_err/et/et_h.awk com_err/et/test1.et \
-	com_err/et/test2.et com_err/et/test_et.c \
-	contrib/drac_auth.patch contrib/sieve-spamasssassin \
-	contrib/fud-client.c contrib/deliver-notify-zephyr.patch \
-	contrib/add-cyrus-user contrib/README \
+noinst_LTLIBRARIES = $(am__append_26) $(am__append_39) \
+	$(am__append_41) $(am__append_43) libcrc32.la
+@COM_ERR_TRUE@COMPILE_ET_DEP = com_err/et/compile_et
+EXTRA_DIST = \
+	COPYING \
+	README.md \
+	VERSION \
+	com_err/et/et_c.awk \
+	com_err/et/et_h.awk \
+	com_err/et/test1.et \
+	com_err/et/test2.et \
+	com_err/et/test_et.c \
+	contrib/sieve-spamassassin \
+	contrib/fud-client.c \
+	contrib/deliver-notify-zephyr.patch \
+	contrib/add-cyrus-user \
+	contrib/README \
 	contrib/cyrus-graphtools.1.0 \
 	contrib/cyrus-graphtools.1.0/cgi-bin/cyrus_master.pl \
 	contrib/cyrus-graphtools.1.0/cgi-bin/graph_cyrus_db.pl \
@@ -1946,39 +2121,85 @@ EXTRA_DIST = $(wildcard tools/vzic/*) VE
 	contrib/cyrus-graphtools.1.0/script \
 	contrib/cyrus-graphtools.1.0/script/cyrus.pl \
 	contrib/cyrus-graphtools.1.0/script/run \
-	contrib/cyrus-graphtools.1.0/script/cyrusrc contrib/cyrusv2.mc \
-	contrib/dkim_canon_ischedule.patch contrib/notify_unix/notify \
+	contrib/cyrus-graphtools.1.0/script/cyrusrc \
+	contrib/cyrusv2.mc \
+	contrib/dkim_canon_ischedule.patch \
+	contrib/notify_unix/notify \
 	contrib/notify_unix/net-server-prefork-0.01.tgz \
-	contrib/notify_unix/README contrib/notify_unix/sql_notify.pl \
-	contrib/notify_unix/simple_notify.pl contrib/squatrunner.pl \
-	contrib/mupdate-test.pl contrib/squatrunner.txt \
-	cunit/cacert.pem cunit/cert.pem cunit/cunit.pl \
-	cunit/cunit-to-junit.pl cunit/key.pem cunit/vg.supp \
-	doc/legacy/murder.png doc/legacy/netnews.png doc docsrc \
-	imap/dav_util.h imap/http_caldav_js.h imap/http_caldav.js \
-	imap/http_carddav_js.h imap/http_carddav.js imap/http_err.et \
-	imap/imap_err.et imap/mupdate_err.et imap/nntp_err.et \
-	imap/rfc822_header.st imap/tz_err.et lib/charset/aliases.txt \
-	lib/charset/UnicodeData.txt lib/charset/unifix.txt \
-	lib/charset/us-ascii.t lib/htmlchar.st lib/imapoptions \
-	lib/test/cyrusdb.c lib/test/cyrusdb.INPUT \
-	lib/test/cyrusdblong.INPUT lib/test/cyrusdblong.OUTPUT \
-	lib/test/cyrusdb.OUTPUT lib/test/cyrusdbtxn.INPUT \
-	lib/test/cyrusdbtxn.OUTPUT lib/test/pool.c lib/test/rnddb.c \
-	master/CYRUS-MASTER.mib master/README netnews/inn.diffs \
-	perl/annotator/Daemon.pm perl/annotator/Makefile.PL \
-	perl/annotator/Makefile.PL.in perl/annotator/MANIFEST \
-	perl/annotator/MANIFEST.in perl/annotator/Message.pm \
-	perl/annotator/README perl/imap/Changes perl/imap/cyradm.sh \
-	perl/imap/cyrperl.h perl/imap/examples/auditmbox.pl \
-	perl/imap/examples/imapcollate.pl perl/imap/examples/imapdu.pl \
-	perl/imap/examples/test-imsp.pl perl/imap/IMAP/Admin.pm \
-	perl/imap/IMAP/IMSP.pm perl/imap/IMAP/Shell.pm \
-	perl/imap/IMAP.pm perl/imap/IMAP.xs perl/imap/Makefile.PL \
-	perl/imap/Makefile.PL.in perl/imap/MANIFEST \
-	perl/imap/MANIFEST.in perl/imap/README \
-	perl/imap/t/01-imclient.t perl/imap/t/02-admin.t \
-	perl/imap/typemap perl/imap/xsutil.c \
+	contrib/notify_unix/README \
+	contrib/notify_unix/sql_notify.pl \
+	contrib/notify_unix/simple_notify.pl \
+	contrib/squatrunner.pl \
+	contrib/mupdate-test.pl \
+	contrib/squatrunner.txt \
+	cunit/cacert.pem \
+	cunit/cert.pem \
+	cunit/cunit.pl \
+	cunit/cunit-to-junit.pl \
+	cunit/key.pem \
+	cunit/vg.supp \
+	doc/legacy/murder.png \
+	doc/legacy/netnews.png \
+	doc \
+	docsrc \
+	imap/http_caldav.js \
+	imap/http_carddav.js \
+	imap/http_err.et \
+	imap/imap_err.et \
+	imap/jmap_err.et \
+	imap/lmtp_err.et \
+	imap/mailbox_header_cache.gperf \
+	imap/mupdate_err.et \
+	imap/nntp_err.et \
+	imap/promdata.p \
+	imap/rfc822_header.st \
+	imap/tz_err.et \
+	lib/charset/aliases.txt \
+	lib/charset/UnicodeData.txt \
+	lib/charset/unifix.txt \
+	lib/charset/us-ascii.t \
+	lib/htmlchar.st \
+	lib/imapoptions \
+	lib/test/cyrusdb.c \
+	lib/test/cyrusdb.INPUT \
+	lib/test/cyrusdblong.INPUT \
+	lib/test/cyrusdblong.OUTPUT \
+	lib/test/cyrusdb.OUTPUT \
+	lib/test/cyrusdbtxn.INPUT \
+	lib/test/cyrusdbtxn.OUTPUT \
+	lib/test/pool.c \
+	lib/test/rnddb.c \
+	master/CYRUS-MASTER.mib \
+	master/README \
+	netnews/inn.diffs \
+	perl/annotator/Daemon.pm \
+	perl/annotator/Makefile.PL \
+	perl/annotator/Makefile.PL.in \
+	perl/annotator/MANIFEST \
+	perl/annotator/MANIFEST.in \
+	perl/annotator/Message.pm \
+	perl/annotator/README \
+	perl/imap/Changes \
+	perl/imap/cyradm.sh \
+	perl/imap/cyrperl.h \
+	perl/imap/examples/auditmbox.pl \
+	perl/imap/examples/imapcollate.pl \
+	perl/imap/examples/imapdu.pl \
+	perl/imap/examples/test-imsp.pl \
+	perl/imap/IMAP/Admin.pm \
+	perl/imap/IMAP/IMSP.pm \
+	perl/imap/IMAP/Shell.pm \
+	perl/imap/IMAP.pm \
+	perl/imap/IMAP.xs \
+	perl/imap/Makefile.PL \
+	perl/imap/Makefile.PL.in \
+	perl/imap/MANIFEST \
+	perl/imap/MANIFEST.in \
+	perl/imap/README \
+	perl/imap/t/01-imclient.t \
+	perl/imap/t/02-admin.t \
+	perl/imap/typemap \
+	perl/imap/xsutil.c \
 	perl/sieve/managesieve/Makefile.PL \
 	perl/sieve/managesieve/Makefile.PL.in \
 	perl/sieve/managesieve/managesieve.h \
@@ -1986,8 +2207,13 @@ EXTRA_DIST = $(wildcard tools/vzic/*) VE
 	perl/sieve/managesieve/managesieve.xs \
 	perl/sieve/managesieve/MANIFEST \
 	perl/sieve/managesieve/MANIFEST.in \
-	perl/sieve/managesieve/typemap ptclient/README ptclient/test.c \
-	ptclient/test2.c sieve/addr.h sieve/sieve.h sieve/sieve_err.et \
+	perl/sieve/managesieve/typemap \
+	ptclient/README \
+	ptclient/test.c \
+	ptclient/test2.c \
+	sieve/addr.h \
+	sieve/sieve.h \
+	sieve/sieve_err.et \
 	sieve/tests/testExtension \
 	sieve/tests/testExtension/uberExtensionTestScript.key \
 	sieve/tests/testExtension/testm \
@@ -2007,7 +2233,9 @@ EXTRA_DIST = $(wildcard tools/vzic/*) VE
 	sieve/tests/testExtension/serverm/uetmail-areg \
 	sieve/tests/testExtension/serverm/uetmail-count \
 	sieve/tests/testExtension/uberExtensionTestScript.s \
-	sieve/tests/README sieve/tests/action sieve/tests/action/testm \
+	sieve/tests/README \
+	sieve/tests/action \
+	sieve/tests/action/testm \
 	sieve/tests/action/testm/uatest-keep \
 	sieve/tests/action/testm/uatest-redirect \
 	sieve/tests/action/testm/uatest-discard \
@@ -2020,13 +2248,17 @@ EXTRA_DIST = $(wildcard tools/vzic/*) VE
 	sieve/tests/action/serverm/uamail-keep \
 	sieve/tests/action/serverm/uamail-discard \
 	sieve/tests/action/uberActionScript.key \
-	sieve/tests/action/uberActionScript.s sieve/tests/test \
-	sieve/tests/test/uberTestScript.key sieve/tests/test/testm \
+	sieve/tests/action/uberActionScript.s \
+	sieve/tests/test \
+	sieve/tests/test/uberTestScript.key \
+	sieve/tests/test/testm \
 	sieve/tests/test/testm/utest-header \
-	sieve/tests/test/testm/utest-address sieve/tests/test/serverm \
+	sieve/tests/test/testm/utest-address \
+	sieve/tests/test/serverm \
 	sieve/tests/test/serverm/utmail-address \
 	sieve/tests/test/serverm/utmail-header \
-	sieve/tests/test/uberTestScript.s sieve/tests/actionExtensions \
+	sieve/tests/test/uberTestScript.s \
+	sieve/tests/actionExtensions \
 	sieve/tests/actionExtensions/uberExtensionActionScript.s \
 	sieve/tests/actionExtensions/testm \
 	sieve/tests/actionExtensions/testm/ueatest-flag4 \
@@ -2059,15 +2291,15 @@ EXTRA_DIST = $(wildcard tools/vzic/*) VE
 	sieve/tests/actionExtensions/serverm/ueamail-flag5 \
 	sieve/tests/actionExtensions/serverm/ueamail-notify2 \
 	sieve/tests/actionExtensions/serverm/ueamail-vacation \
-	timsieved/TODO $(am__append_85) $(am__append_87) \
-	$(am__append_89) $(am__append_91)
-@COM_ERR_TRUE@COMPILE_ET_DEP = com_err/et/compile_et
+	timsieved/TODO
+
 TEXINFO_TEX = com_err/et/texinfo.tex
 dist_noinst_SCRIPTS = \
 	com_err/et/compile_et.sh \
 	com_err/et/config_script \
 	imap/lmtpstats.snmp \
 	imap/pushstats.snmp \
+	imap/promdatagen \
 	lib/mkchartable.pl \
 	lib/test/run \
 	perl/sieve/scripts/installsieve.pl \
@@ -2075,7 +2307,6 @@ dist_noinst_SCRIPTS = \
 	tools/arbitronsort.pl \
 	tools/compile_st.pl \
 	tools/config2header \
-	tools/config2man \
 	tools/config2rst \
 	tools/config2sample \
 	tools/fixsearchpath.pl \
@@ -2084,6 +2315,7 @@ dist_noinst_SCRIPTS = \
 	tools/masssievec \
 	tools/mkimap \
 	tools/mknewsgroups \
+	tools/perl2rst \
 	tools/rehash \
 	tools/translatesieve \
 	snmp/snmpgen
@@ -2128,7 +2360,8 @@ LD_UTILITY_ADD = imap/libcyrus_imap.la $
 # Note that the code is horribly intertwingled e.g. in imap/global.c
 # so that even utilities which never open a socket need to link against
 # the SASL library.
-LD_SERVER_ADD = $(LD_UTILITY_ADD) $(LIB_WRAP)
+LD_SERVER_ADD = $(LD_UTILITY_ADD) $(LIB_WRAP) $(am__append_50) \
+	$(am__append_53)
 @SIEVE_FALSE@LD_SIEVE_ADD = 
 
 # SIEVE is the libraries that sieve-using components need to link with
@@ -2136,12 +2369,10 @@ LD_SERVER_ADD = $(LD_UTILITY_ADD) $(LIB_
 # This is empty if sieve is not enabled, so it can be used unconditionally
 # elsewhere.
 @SIEVE_TRUE@LD_SIEVE_ADD = sieve/libcyrus_sieve.la $(LD_BASIC_ADD)
-
-# ----
 @CUNIT_TRUE@CUNIT_PROJECT = cunit/default.cunit
 @CUNIT_TRUE@cunit_FRAMEWORK = \
 @CUNIT_TRUE@	cunit/unit.c \
-@CUNIT_TRUE@	cunit/cunit.h \
+@CUNIT_TRUE@	cunit/cyrunit.h \
 @CUNIT_TRUE@	cunit/syslog.c \
 @CUNIT_TRUE@	cunit/cunit-syslog.h \
 @CUNIT_TRUE@	cunit/timeout.c \
@@ -2156,20 +2387,23 @@ LD_SERVER_ADD = $(LD_UTILITY_ADD) $(LIB_
 @CUNIT_TRUE@	cunit/bitvector.testc cunit/buf.testc \
 @CUNIT_TRUE@	cunit/byteorder64.testc cunit/charset.testc \
 @CUNIT_TRUE@	cunit/command.testc cunit/conversations.testc \
-@CUNIT_TRUE@	cunit/crc32.testc cunit/dlist.testc \
-@CUNIT_TRUE@	cunit/duplicate.testc cunit/getxstring.testc \
-@CUNIT_TRUE@	cunit/glob.testc cunit/guid.testc cunit/hash.testc \
-@CUNIT_TRUE@	cunit/imapurl.testc cunit/libconfig.testc \
+@CUNIT_TRUE@	cunit/cyr_qsort_r.testc cunit/crc32.testc \
+@CUNIT_TRUE@	cunit/dlist.testc cunit/duplicate.testc \
+@CUNIT_TRUE@	cunit/getxstring.testc cunit/glob.testc \
+@CUNIT_TRUE@	cunit/guid.testc cunit/hash.testc \
+@CUNIT_TRUE@	cunit/hashset.testc cunit/imapurl.testc \
+@CUNIT_TRUE@	cunit/imparse.testc cunit/libconfig.testc \
 @CUNIT_TRUE@	cunit/mboxname.testc cunit/md5.testc \
 @CUNIT_TRUE@	cunit/message.testc cunit/msgid.testc \
 @CUNIT_TRUE@	cunit/parseaddr.testc cunit/parse.testc \
 @CUNIT_TRUE@	cunit/prot.testc cunit/ptrarray.testc \
 @CUNIT_TRUE@	cunit/quota.testc cunit/rfc822tok.testc \
 @CUNIT_TRUE@	cunit/search_expr.testc cunit/seqset.testc \
-@CUNIT_TRUE@	$(am__append_53) cunit/spool.testc \
+@CUNIT_TRUE@	$(am__append_57) cunit/spool.testc \
 @CUNIT_TRUE@	cunit/squat.testc cunit/strarray.testc \
 @CUNIT_TRUE@	cunit/strconcat.testc cunit/times.testc \
-@CUNIT_TRUE@	cunit/tok.testc cunit/vparse.testc
+@CUNIT_TRUE@	cunit/tok.testc cunit/vparse.testc \
+@CUNIT_TRUE@	$(am__append_79)
 @CUNIT_TRUE@cunit_unit_SOURCES = $(cunit_FRAMEWORK) $(cunit_TESTS) \
 @CUNIT_TRUE@		imap/mutex_fake.c imap/spool.c
 
@@ -2198,11 +2432,12 @@ include_HEADERS = \
 	lib/crc32.h \
 	lib/crc32c.h \
 	lib/cyr_lock.h \
+	lib/cyr_qsort_r.h \
 	lib/cyrusdb.h \
-	lib/exitcodes.h \
 	lib/glob.h \
 	lib/gmtoff.h \
 	lib/hash.h \
+	lib/hashset.h \
 	lib/hashu64.h \
 	lib/imapurl.h \
 	lib/imclient.h \
@@ -2225,7 +2460,6 @@ include_HEADERS = \
 	lib/strarray.h \
 	lib/strhash.h \
 	lib/stristr.h \
-	lib/sysexits.h \
 	lib/times.h \
 	lib/tok.h \
 	lib/vparse.h \
@@ -2271,10 +2505,11 @@ backup_ctl_backups_SOURCES = \
 
 backup_ctl_backups_LDADD = backup/libcyrus_backup.la $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
 backup_cyr_backup_SOURCES = \
+    imap/json_support.h \
     imap/mutex_fake.c \
     backup/cyr_backup.c
 
-backup_cyr_backup_LDADD = backup/libcyrus_backup.la $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+backup_cyr_backup_LDADD = backup/libcyrus_backup.la $(LD_UTILITY_ADD)
 backup_restore_SOURCES = \
     imap/mutex_fake.c \
     imap/sync_support.c \
@@ -2294,6 +2529,8 @@ imap_ctl_deliver_SOURCES = imap/cli_fata
 imap_ctl_deliver_LDADD = $(LD_UTILITY_ADD)
 imap_ctl_mboxlist_SOURCES = imap/cli_fatal.c imap/ctl_mboxlist.c imap/mutex_fake.c
 imap_ctl_mboxlist_LDADD = $(LD_UTILITY_ADD)
+imap_ctl_zoneinfo_SOURCES = imap/cli_fatal.c imap/ctl_zoneinfo.c imap/mutex_fake.c imap/zoneinfo_db.c
+imap_ctl_zoneinfo_LDADD = $(LD_UTILITY_ADD)
 imap_cvt_cyrusdb_SOURCES = imap/cli_fatal.c imap/cvt_cyrusdb.c imap/mutex_fake.c
 imap_cvt_cyrusdb_LDADD = $(LD_UTILITY_ADD)
 imap_cyrdump_SOURCES = imap/cli_fatal.c imap/cyrdump.c imap/mutex_fake.c
@@ -2309,28 +2546,24 @@ imap_cyr_expire_LDADD = $(LD_UTILITY_ADD
 imap_cyr_info_SOURCES = imap/cli_fatal.c imap/cyr_info.c imap/mutex_fake.c master/masterconf.c
 imap_cyr_info_LDADD = $(LD_UTILITY_ADD)
 imap_cyr_buildinfo_SOURCES = imap/cli_fatal.c imap/cyr_buildinfo.c imap/mutex_fake.c master/masterconf.c
-imap_cyr_buildinfo_LDADD = $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+imap_cyr_buildinfo_LDADD = $(LD_UTILITY_ADD)
 imap_cyr_sequence_SOURCES = imap/cli_fatal.c imap/cyr_sequence.c imap/mutex_fake.c
 imap_cyr_sequence_LDADD = $(LD_UTILITY_ADD)
 imap_cyr_synclog_SOURCES = imap/cli_fatal.c imap/cyr_synclog.c imap/mutex_fake.c
 imap_cyr_synclog_LDADD = $(LD_UTILITY_ADD)
 imap_cyr_userseen_SOURCES = imap/cli_fatal.c imap/cyr_userseen.c imap/mutex_fake.c
 imap_cyr_userseen_LDADD = $(LD_UTILITY_ADD)
-imap_cyr_sphinxmgr_SOURCES = imap/cli_fatal.c imap/cyr_sphinxmgr.c imap/mutex_fake.c
-imap_cyr_sphinxmgr_LDADD = $(LD_UTILITY_ADD)
 imap_cyr_virusscan_SOURCES = imap/cli_fatal.c imap/cyr_virusscan.c imap/mutex_fake.c
 imap_cyr_virusscan_CFLAGS = $(AM_CFLAGS) $(CLAMAV_CFLAGS) $(CFLAG_VISIBILITY)
 imap_cyr_virusscan_LDADD = $(LD_UTILITY_ADD) $(CLAMAV_LIBS)
-imap_ctl_zoneinfo_SOURCES = imap/cli_fatal.c imap/ctl_zoneinfo.c imap/mutex_fake.c imap/zoneinfo_db.c
-imap_ctl_zoneinfo_LDADD = $(LD_UTILITY_ADD)
 imap_deliver_SOURCES = \
 	imap/deliver.c \
 	imap/lmtpengine.c \
-	imap/lmtpstats.c \
 	imap/mutex_fake.c \
 	imap/proxy.c \
 	imap/spool.c
 
+nodist_imap_deliver_SOURCES = imap/lmtp_err.c imap/lmtpstats.c
 imap_deliver_LDADD = $(LD_UTILITY_ADD)
 imap_fetchnews_SOURCES = imap/cli_fatal.c imap/fetchnews.c imap/mutex_fake.c
 imap_fetchnews_LDADD = $(LD_UTILITY_ADD)
@@ -2341,56 +2574,67 @@ imap_idled_LDADD = $(LD_UTILITY_ADD)
 imap_calalarmd_SOURCES = imap/calalarmd.c imap/mutex_fake.c
 imap_calalarmd_LDADD = $(LD_SERVER_ADD)
 imap_imapd_SOURCES = imap/imap_proxy.c imap/imap_proxy.h imap/imapd.c \
-	imap/imapd.h imap/mutex_fake.c imap/pushstats.c \
-	imap/pushstats.h imap/proxy.c imap/proxy.h imap/sync_support.c \
-	imap/sync_support.h master/service.c $(am__append_54)
+	imap/imapd.h imap/mutex_fake.c imap/proxy.c imap/proxy.h \
+	imap/sync_support.c imap/sync_support.h master/service.c \
+	$(am__append_58)
+nodist_imap_imapd_SOURCES = imap/pushstats.c
 imap_imapd_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
 imap_ipurge_SOURCES = imap/cli_fatal.c imap/ipurge.c imap/mutex_fake.c
 imap_ipurge_LDADD = $(LD_UTILITY_ADD)
 nodist_imap_libcyrus_imap_la_SOURCES = \
+	imap/http_err.c \
+	imap/http_err.h \
 	imap/imap_err.c \
+	imap/imap_err.h \
 	imap/mupdate_err.c \
-	imap/mupdate_err.h
+	imap/mupdate_err.h \
+	imap/promdata.c \
+	imap/promdata.h
 
-dist_imap_libcyrus_imap_la_SOURCES = 
 imap_libcyrus_imap_la_LIBADD = $(COM_ERR_LIBS) $(LIB_UUID) \
-	$(GCOV_LIBS) $(JANSSON_LIBS) lib/libcyrus_min.la \
-	lib/libcyrus.la $(am__append_63)
-imap_libcyrus_imap_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY) $(JANSSON_CFLAGS)
-imap_libcyrus_imap_la_CXXFLAGS = $(AM_CXXFLAGS) $(am__append_64)
+	$(GCOV_LIBS) lib/libcyrus_min.la lib/libcyrus.la \
+	$(am__append_67) $(am__append_69)
+imap_libcyrus_imap_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
+imap_libcyrus_imap_la_CXXFLAGS = $(AM_CXXFLAGS) $(am__append_68) \
+	$(am__append_70)
 imap_libcyrus_imap_la_SOURCES = imap/annotate.c imap/annotate.h \
 	imap/append.c imap/append.h imap/backend.c imap/backend.h \
 	imap/conversations.c imap/conversations.h imap/convert_code.c \
 	imap/convert_code.h imap/dlist.c imap/dlist.h imap/duplicate.c \
-	imap/duplicate.h imap/global.c imap/global.h imap/idle.c \
-	imap/idle.h imap/idlemsg.c imap/idlemsg.h imap/imapparse.c \
-	imap/imapparse.h imap/index.c imap/index.h imap/mailbox.c \
-	imap/mailbox.h imap/mbdump.c imap/mbdump.h imap/mboxkey.c \
-	imap/mboxkey.h imap/mboxlist.c imap/mboxlist.h \
+	imap/duplicate.h imap/global.c imap/global.h \
+	imap/http_client.c imap/http_client.h imap/idle.c imap/idle.h \
+	imap/idlemsg.c imap/idlemsg.h imap/imapparse.c \
+	imap/imapparse.h imap/index.c imap/index.h imap/json_support.h \
+	imap/mailbox.c imap/mailbox.h imap/mbdump.c imap/mbdump.h \
+	imap/mboxkey.c imap/mboxkey.h imap/mboxlist.c imap/mboxlist.h \
 	imap/mboxevent.c imap/mboxevent.h imap/mboxname.c \
 	imap/mboxname.h imap/message_guid.c imap/message_guid.h \
 	imap/message.c imap/message.h imap/message_priv.h \
-	imap/mupdate-client.c imap/mupdate-client.h imap/mutex.h \
-	imap/notify.c imap/notify.h imap/partlist.c imap/partlist.h \
-	imap/proc.c imap/proc.h imap/protocol.h imap/quota_db.c \
-	imap/rfc822_header.c imap/rfc822_header.h imap/saslclient.c \
+	imap/msgrecord.c imap/msgrecord.h imap/mupdate-client.c \
+	imap/mupdate-client.h imap/mutex.h imap/notify.c imap/notify.h \
+	imap/partlist.c imap/partlist.h imap/proc.c imap/proc.h \
+	imap/prometheus.c imap/prometheus.h imap/protocol.h \
+	imap/quota_db.c imap/rfc822_header.c imap/rfc822_header.h \
+	imap/mailbox_header_cache.h imap/saslclient.c \
 	imap/saslclient.h imap/saslserver.c imap/search_engines.c \
 	imap/search_engines.h imap/search_expr.c imap/search_expr.h \
 	imap/search_query.c imap/search_query.h imap/search_part.h \
-	imap/seen.h imap/seen_db.c imap/sequence.c imap/sequence.h \
-	imap/setproctitle.c imap/statuscache.h imap/statuscache_db.c \
-	imap/sync_log.c imap/sync_log.h imap/telemetry.c \
-	imap/telemetry.h imap/tls.c imap/tls.h imap/tls_th-lock.c \
-	imap/tls_th-lock.h imap/user.c imap/user.h imap/userdeny_db.c \
-	imap/userdeny.h imap/version.c imap/version.h imap/xstats.c \
-	imap/xstats.h imap/xstats_metrics.h $(am__append_55) \
-	$(am__append_56) $(am__append_57) $(am__append_58) \
-	$(am__append_59) $(am__append_60) $(am__append_61) \
-	$(am__append_62)
+	imap/search_sort.h imap/seen.h imap/seen_db.c imap/sequence.c \
+	imap/sequence.h imap/setproctitle.c imap/spool.c imap/spool.h \
+	imap/statuscache.h imap/statuscache_db.c imap/sync_log.c \
+	imap/sync_log.h imap/telemetry.c imap/telemetry.h imap/tls.c \
+	imap/tls.h imap/tls_th-lock.c imap/tls_th-lock.h imap/user.c \
+	imap/user.h imap/userdeny_db.c imap/userdeny.h imap/version.c \
+	imap/version.h imap/xstats.c imap/xstats.h \
+	imap/xstats_metrics.h $(am__append_59) $(am__append_60) \
+	$(am__append_61) $(am__append_62) $(am__append_63) \
+	$(am__append_64) $(am__append_65) $(am__append_66) \
+	$(am__append_77)
 imap_lmtpd_SOURCES = imap/lmtpd.c imap/lmtpd.h imap/lmtpengine.c \
-	imap/lmtpengine.h imap/lmtpstats.c imap/lmtpstats.h \
-	imap/mutex_fake.c imap/proxy.c imap/spool.c master/service.c \
-	$(am__append_65) $(am__append_66)
+	imap/lmtpengine.h imap/mutex_fake.c imap/proxy.c imap/spool.c \
+	master/service.c $(am__append_71) $(am__append_72) \
+	$(am__append_73)
+nodist_imap_lmtpd_SOURCES = imap/lmtp_err.c imap/lmtpstats.c
 imap_lmtpd_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
 SNMPGEN = $(abs_top_srcdir)/snmp/snmpgen
 imap_mbexamine_SOURCES = imap/cli_fatal.c imap/mbexamine.c imap/mutex_fake.c
@@ -2411,10 +2655,7 @@ imap_mupdate_SOURCES = \
 
 imap_mupdate_LDADD = $(LD_SERVER_ADD) -lpthread
 imap_mupdate_CFLAGS = $(AM_CFLAGS) -pthread
-nodist_imap_nntpd_SOURCES = \
-	imap/nntp_err.c \
-	imap/nntp_err.h
-
+nodist_imap_nntpd_SOURCES = imap/nntp_err.c
 imap_nntpd_SOURCES = \
 	imap/mutex_fake.c \
 	imap/nntpd.c \
@@ -2426,65 +2667,40 @@ imap_nntpd_SOURCES = \
 	master/service.c
 
 imap_nntpd_LDADD = $(LD_SERVER_ADD)
-nodist_imap_httpd_SOURCES = \
-	imap/http_caldav_js.h \
-	imap/http_carddav_js.h \
-	imap/http_err.c \
-	imap/http_err.h \
-	imap/tz_err.c \
-	imap/tz_err.h
-
-imap_httpd_SOURCES = \
-	imap/caldav_db.c \
-	imap/http_admin.c \
-	imap/http_applepush.c \
-	imap/http_caldav.c \
-	imap/http_caldav.h \
-	imap/http_caldav_sched.c \
-	imap/http_caldav_sched.h \
-	imap/http_carddav.c \
-	imap/http_carddav.h \
-	imap/http_client.c \
-	imap/http_client.h \
-	imap/http_dav.c \
-	imap/http_dav.h \
-	imap/http_dblookup.c \
-	imap/http_ischedule.c \
-	imap/http_proxy.c \
-	imap/http_proxy.h \
-	imap/http_rss.c \
-	imap/http_tzdist.c \
-	imap/http_webdav.c \
-	imap/httpd.c \
-	imap/httpd.h \
-	imap/ical_support.c \
-	imap/jcal.c \
-	imap/jcal.h \
-	imap/json_support.h \
-	imap/mutex_fake.c \
-	imap/proxy.c \
-	imap/smtpclient.c \
-	imap/spool.c \
-	imap/vcard_support.c \
-	imap/xcal.c \
-	imap/xcal.h \
-	imap/xml_support.c \
-	imap/xml_support.h \
-	imap/zoneinfo_db.c \
-	imap/zoneinfo_db.h \
-	master/masterconf.c \
-	master/service.c
-
-imap_httpd_LDADD = $(LD_SERVER_ADD)
+nodist_imap_httpd_SOURCES = imap/http_caldav_js.h \
+	imap/http_carddav_js.h imap/tz_err.c imap/tz_err.h \
+	$(am__append_76)
+imap_httpd_SOURCES = imap/css3_color.c imap/css3_color.h \
+	imap/http_admin.c imap/http_applepush.c imap/http_caldav.c \
+	imap/http_caldav.h imap/http_caldav_js.h \
+	imap/http_caldav_sched.c imap/http_caldav_sched.h \
+	imap/http_carddav.c imap/http_carddav.h imap/http_carddav_js.h \
+	imap/http_cgi.c imap/http_dav.c imap/http_dav.h \
+	imap/http_dav_sharing.c imap/http_dav_sharing.h \
+	imap/http_dblookup.c imap/http_h2.c imap/http_h2.h \
+	imap/http_ischedule.c imap/http_prometheus.c imap/http_proxy.c \
+	imap/http_proxy.h imap/http_rss.c imap/http_tzdist.c \
+	imap/http_webdav.c imap/http_ws.c imap/http_ws.h imap/httpd.c \
+	imap/httpd.h imap/jcal.c imap/jcal.h imap/json_support.h \
+	imap/mutex_fake.c imap/proxy.c imap/smtpclient.c imap/spool.c \
+	imap/xcal.c imap/xcal.h imap/xml_support.c imap/xml_support.h \
+	imap/zoneinfo_db.c imap/zoneinfo_db.h master/masterconf.c \
+	master/service.c $(am__append_75)
+imap_httpd_LDADD = $(LD_SERVER_ADD) $(am__append_78)
 imap_pop3d_SOURCES = imap/mutex_fake.c imap/pop3d.c imap/proxy.c \
-	master/service.c $(am__append_67)
+	master/service.c $(am__append_80)
 imap_pop3d_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
+PROMDATAGEN = $(abs_top_srcdir)/imap/promdatagen
+imap_promstatsd_SOURCES = imap/promstatsd.c imap/mutex_fake.c
+imap_promstatsd_LDADD = $(LD_UTILITY_ADD)
 imap_quota_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/quota.c imap/quota.h
-imap_quota_LDADD = $(LD_UTILITY_ADD) $(JANSSON_LIBS)
+imap_quota_LDADD = $(LD_UTILITY_ADD)
 imap_reconstruct_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/reconstruct.c
 imap_reconstruct_LDADD = $(LD_UTILITY_ADD)
 imap_dav_reconstruct_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/dav_reconstruct.c
 imap_dav_reconstruct_LDADD = $(LD_UTILITY_ADD)
+imap_ical_apply_patch_SOURCES = imap/cli_fatal.c imap/mutex_fake.c imap/ical_apply_patch.c
+imap_ical_apply_patch_LDADD = $(LD_UTILITY_ADD)
 imap_search_test_SOURCES = imap/search_test.c imap/mutex_fake.c
 imap_search_test_LDADD = $(LD_UTILITY_ADD)
 imap_smmapd_SOURCES = imap/mutex_fake.c imap/proxy.c imap/smmapd.c master/service.c
@@ -2510,33 +2726,35 @@ nodist_lib_libcyrus_la_SOURCES = lib/cha
 lib_libcyrus_la_SOURCES = lib/acl.c lib/acl_afs.c lib/auth.c \
 	lib/auth_krb.c lib/auth_krb5.c lib/auth_pts.c lib/auth_unix.c \
 	lib/bitvector.c lib/bloom.c lib/bsearch.c lib/charset.c \
-	lib/command.c lib/cyrusdb.c lib/cyrusdb_flat.c \
-	lib/cyrusdb_quotalegacy.c lib/cyrusdb_skiplist.c \
-	lib/cyrusdb_twoskip.c lib/glob.c lib/htmlchar.c lib/htmlchar.h \
-	lib/imapurl.c lib/imclient.c lib/imparse.c lib/iostat.c \
-	lib/iptostring.c lib/libcyr_cfg.c lib/lsort.c lib/mappedfile.c \
-	lib/murmurhash.c lib/mkgmtime.c lib/parseaddr.c lib/prot.c \
-	lib/ptrarray.c lib/rfc822tok.c lib/signals.c lib/stristr.c \
-	lib/times.c lib/tok.c lib/wildmat.c $(am__append_68) \
-	$(am__append_69) $(am__append_70) $(am__append_71) \
-	$(am__append_72) $(am__append_73) $(am__append_74)
+	lib/command.c lib/cyr_qsort_r.c lib/cyrusdb.c \
+	lib/cyrusdb_flat.c lib/cyrusdb_quotalegacy.c \
+	lib/cyrusdb_skiplist.c lib/cyrusdb_twoskip.c lib/glob.c \
+	lib/htmlchar.c lib/htmlchar.h lib/imapurl.c lib/imclient.c \
+	lib/imparse.c lib/iostat.c lib/iptostring.c lib/libcyr_cfg.c \
+	lib/lsort.c lib/mappedfile.c lib/murmurhash.c lib/mkgmtime.c \
+	lib/parseaddr.c lib/prot.c lib/ptrarray.c lib/rfc822tok.c \
+	lib/signals.c lib/stristr.c lib/times.c lib/tok.c \
+	lib/wildmat.c $(am__append_81) $(am__append_82) \
+	$(am__append_83) $(am__append_84) $(am__append_85) \
+	$(am__append_86) $(am__append_87)
 lib_libcyrus_la_LIBADD = libcrc32.la ${LIB_SASL} $(SSL_LIBS) \
-	$(GCOV_LIBS) $(am__append_75)
-lib_libcyrus_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
+	$(GCOV_LIBS) $(am__append_88)
+lib_libcyrus_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY) \
+	$(am__append_89)
 libcrc32_la_SOURCES = lib/crc32.c lib/crc32c.c
 libcrc32_la_CFLAGS = -O3 $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 nodist_lib_libcyrus_min_la_SOURCES = \
 	lib/imapopts.c
 
 lib_libcyrus_min_la_SOURCES = lib/arrayu64.c lib/assert.c \
-	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashu64.c \
-	lib/libconfig.c lib/mpool.c lib/retry.c lib/strarray.c \
-	lib/strhash.c lib/util.c lib/vparse.c lib/xmalloc.c \
-	lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c $(am__append_76) \
-	$(am__append_77) $(am__append_78) $(am__append_79) \
-	$(am__append_80) $(am__append_81) $(am__append_82) \
-	$(am__append_83)
-lib_libcyrus_min_la_LIBADD = $(LTLIBOBJS) $(LIB_UUID) $(GCOV_LIBS)
+	lib/bufarray.c lib/byteorder64.c lib/hash.c lib/hashset.c \
+	lib/hashu64.c lib/libconfig.c lib/mpool.c lib/retry.c \
+	lib/strarray.c lib/strhash.c lib/util.c lib/vparse.c \
+	lib/xmalloc.c lib/xstrlcat.c lib/xstrlcpy.c lib/xstrnchr.c \
+	$(am__append_91) $(am__append_92) $(am__append_93) \
+	$(am__append_94) $(am__append_95) $(am__append_96) \
+	$(am__append_97) $(am__append_98)
+lib_libcyrus_min_la_LIBADD = $(LTLIBOBJS) $(LIB_UUID) $(GCOV_LIBS) $(LIBCAP_LIBS)
 lib_libcyrus_min_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 imap_cvt_xlist_specialuse_SOURCES = imap/mutex_fake.c imap/cvt_xlist_specialuse.c
 imap_cvt_xlist_specialuse_LDADD = $(LD_UTILITY_ADD)
@@ -2570,8 +2788,10 @@ dist_man8_MANS = man/arbitron.8 man/back
 	man/mbexamine.8 man/mbpath.8 man/mbtool.8 man/notifyd.8 \
 	man/pop3d.8 man/quota.8 man/reconstruct.8 man/restore.8 \
 	man/smmapd.8 man/timsieved.8 man/tls_prune.8 man/unexpunge.8 \
-	$(am__append_84) $(am__append_86) $(am__append_88) \
-	$(am__append_90)
+	$(am__append_99) $(am__append_100) $(am__append_101) \
+	$(am__append_103)
+@BENCH_TRUE@bench_cyrdbbench_SOURCES = bench/cyrdbbench.c imap/mutex_fake.c
+@BENCH_TRUE@bench_cyrdbbench_LDADD = $(LD_BASIC_ADD)
 master_master_SOURCES = \
 	master/cyrusMasterMIB.c \
 	master/cyrusMasterMIB.h \
@@ -2594,7 +2814,7 @@ notifyd_notifyd_SOURCES = imap/mutex_fak
 	notifyd/notify_log.c notifyd/notify_log.h \
 	notifyd/notify_mailto.c notifyd/notify_mailto.h \
 	notifyd/notify_null.c notifyd/notify_null.h notifyd/notifyd.c \
-	notifyd/notifyd.h $(am__append_92)
+	notifyd/notifyd.h $(am__append_104)
 notifyd_notifyd_LDADD = $(LD_SERVER_ADD) $(ZEPHYR_LIBS)
 notifyd_notifytest_SOURCES = notifyd/notifytest.c imap/mutex_fake.c
 notifyd_notifytest_LDADD = $(LD_BASIC_ADD)
@@ -2618,11 +2838,11 @@ ptclient_ptdump_LDADD = $(LD_UTILITY_ADD
 ptclient_ptexpire_SOURCES = imap/cli_fatal.c imap/mutex_fake.c ptclient/ptexpire.c
 ptclient_ptexpire_LDADD = $(LD_UTILITY_ADD)
 ptclient_ptloader_SOURCES = imap/mutex_fake.c ptclient/ptloader.c \
-	ptclient/ptloader.h master/service-thread.c $(am__append_93) \
-	$(am__append_96)
-ptclient_ptloader_LDFLAGS = $(am__append_95) $(am__append_98)
-ptclient_ptloader_LDADD = $(LD_SERVER_ADD) $(am__append_94) \
-	$(am__append_97)
+	ptclient/ptloader.h master/service-thread.c $(am__append_105) \
+	$(am__append_108)
+ptclient_ptloader_LDFLAGS = $(am__append_107) $(am__append_110)
+ptclient_ptloader_LDADD = $(LD_SERVER_ADD) $(am__append_106) \
+	$(am__append_109)
 
 # Each new version of flex seems to generate new sign-comparison
 # warnings, while they switch code around between int/yy_size_t.
@@ -2643,33 +2863,15 @@ nodist_sieve_libcyrus_sieve_la_SOURCES =
 	sieve/sieve_err.c \
 	sieve/sieve_err.h
 
-sieve_libcyrus_sieve_la_SOURCES = \
-	sieve/bytecode.h \
-	sieve/addr.y \
-	sieve/bc_emit.c \
-	sieve/bc_eval.c \
-	sieve/bc_generate.c \
-	sieve/comparator.c \
-	sieve/comparator.h \
-	sieve/flags.c \
-	sieve/flags.h \
-	sieve/grammar.c \
-	sieve/grammar.h \
-	sieve/interp.c \
-	sieve/interp.h \
-	sieve/message.c \
-	sieve/message.h \
-	sieve/rebuild.c \
-	sieve/script.c \
-	sieve/script.h \
-	sieve/sieve.y \
-	sieve/tree.c \
-	sieve/tree.h \
-	sieve/variables.c \
-	sieve/variables.h \
-	sieve/varlist.c \
-	sieve/varlist.h
-
+sieve_libcyrus_sieve_la_SOURCES = sieve/bytecode.h sieve/addr.y \
+	sieve/bc_emit.c sieve/bc_eval.c sieve/bc_generate.c \
+	sieve/bc_parse.c sieve/bc_parse.h sieve/comparator.c \
+	sieve/comparator.h sieve/flags.c sieve/flags.h sieve/grammar.c \
+	sieve/grammar.h sieve/interp.c sieve/interp.h sieve/message.c \
+	sieve/message.h sieve/rebuild.c sieve/script.c sieve/script.h \
+	sieve/sieve.y sieve/tree.c sieve/tree.h sieve/variables.c \
+	sieve/variables.h sieve/varlist.c sieve/varlist.h \
+	$(am__append_111)
 sieve_libcyrus_sieve_la_LIBADD = \
     sieve/libcyrus_sieve_lex.la \
     $(COM_ERR_LIBS) \
@@ -2679,8 +2881,10 @@ sieve_libcyrus_sieve_la_LIBADD = \
 sieve_libcyrus_sieve_la_CFLAGS = $(AM_CFLAGS) $(CFLAG_VISIBILITY)
 sieve_sievec_LDADD = $(LD_SIEVE_ADD)
 sieve_sieved_LDADD = $(LD_SIEVE_ADD)
-sieve_test_SOURCES = sieve/test.c imap/mutex_fake.c
+sieve_test_SOURCES = sieve/test.c imap/mutex_fake.c $(am__append_112)
 sieve_test_LDADD = $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
+sieve_test_mailbox_SOURCES = sieve/test_mailbox.c imap/mutex_fake.c
+sieve_test_mailbox_LDADD = $(LD_SIEVE_ADD) $(LD_UTILITY_ADD)
 timsieved_timsieved_SOURCES = \
 	imap/mutex_fake.c \
 	imap/proxy.c \
@@ -2696,11 +2900,8 @@ timsieved_timsieved_SOURCES = \
 
 timsieved_timsieved_LDADD = $(LD_SIEVE_ADD) $(LD_SERVER_ADD)
 SPHINX_CACHE = docsrc/.doctrees
-@HAVE_SPHINX_BUILD_TRUE@GENERATED_RSTS = docsrc/imap/reference/manpages/configs/imapd.conf.rst \
-@HAVE_SPHINX_BUILD_TRUE@                 docsrc/imap/reference/manpages/systemcommands/cyradm.rst \
-@HAVE_SPHINX_BUILD_TRUE@                 docsrc/imap/reference/manpages/usercommands/sieveshell.rst
-
 @HAVE_SPHINX_BUILD_TRUE@SPHINX_OPTS = -d $(SPHINX_CACHE) -n -q
+GENERATED_EXAMPLES = doc/examples/imapd_conf/imapd.conf.sample
 SUFFIXES = .fig.png
 all: $(BUILT_SOURCES) config.h
 	$(MAKE) $(AM_MAKEFLAGS) all-recursive
@@ -2901,6 +3102,8 @@ imap/imap_libcyrus_imap_la-duplicate.lo:
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-global.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-http_client.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-idle.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-idlemsg.lo: imap/$(am__dirstamp) \
@@ -2925,6 +3128,8 @@ imap/imap_libcyrus_imap_la-message_guid.
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-message.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-msgrecord.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-mupdate-client.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-notify.lo: imap/$(am__dirstamp) \
@@ -2933,6 +3138,8 @@ imap/imap_libcyrus_imap_la-partlist.lo:
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-proc.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-prometheus.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-quota_db.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-rfc822_header.lo: imap/$(am__dirstamp) \
@@ -2953,6 +3160,8 @@ imap/imap_libcyrus_imap_la-sequence.lo:
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-setproctitle.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-spool.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-statuscache_db.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-sync_log.lo: imap/$(am__dirstamp) \
@@ -2987,10 +3196,6 @@ imap/imap_libcyrus_imap_la-squat_build.l
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-squat_internal.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/imap_libcyrus_imap_la-search_sphinx.lo: imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
-imap/imap_libcyrus_imap_la-sphinxmgr_client.lo: imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-caldav_alarm.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-caldav_db.lo: imap/$(am__dirstamp) \
@@ -3003,18 +3208,30 @@ imap/imap_libcyrus_imap_la-dav_util.lo:
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-ical_support.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-icu_wrap.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-vcard_support.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-webdav_db.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-smtpclient.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-search_xapian.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-xapian_wrap.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-jmap_util.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-json_support.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-http_err.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-imap_err.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imap_libcyrus_imap_la-mupdate_err.lo: imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/imap_libcyrus_imap_la-promdata.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 
 imap/libcyrus_imap.la: $(imap_libcyrus_imap_la_OBJECTS) $(imap_libcyrus_imap_la_DEPENDENCIES) $(EXTRA_imap_libcyrus_imap_la_DEPENDENCIES) imap/$(am__dirstamp)
 	$(AM_V_CXXLD)$(imap_libcyrus_imap_la_LINK) $(am_imap_libcyrus_imap_la_rpath) $(imap_libcyrus_imap_la_OBJECTS) $(imap_libcyrus_imap_la_LIBADD) $(LIBS)
@@ -3042,6 +3259,8 @@ lib/lib_libcyrus_la-charset.lo: lib/$(am
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-command.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
+lib/lib_libcyrus_la-cyr_qsort_r.lo: lib/$(am__dirstamp) \
+	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-cyrusdb.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-cyrusdb_flat.lo: lib/$(am__dirstamp) \
@@ -3096,8 +3315,6 @@ lib/lib_libcyrus_la-wildmat.lo: lib/$(am
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-cyrusdb_sql.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
-lib/lib_libcyrus_la-cyrusdb_lmdb.lo: lib/$(am__dirstamp) \
-	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-sqldb.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-gmtoff_tm.lo: lib/$(am__dirstamp) \
@@ -3108,6 +3325,8 @@ lib/lib_libcyrus_la-nonblock_fcntl.lo: l
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-nonblock_ioctl.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
+lib/lib_libcyrus_la-cyrusdb_zeroskip.lo: lib/$(am__dirstamp) \
+	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_la-chartable.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
 
@@ -3123,6 +3342,8 @@ lib/lib_libcyrus_min_la-byteorder64.lo:
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_min_la-hash.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
+lib/lib_libcyrus_min_la-hashset.lo: lib/$(am__dirstamp) \
+	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_min_la-hashu64.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/lib_libcyrus_min_la-libconfig.lo: lib/$(am__dirstamp) \
@@ -3187,6 +3408,7 @@ lib/bloom.lo: lib/$(am__dirstamp) lib/$(
 lib/bsearch.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/charset.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/command.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
+lib/cyr_qsort_r.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/cyrusdb.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/cyrusdb_flat.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/cyrusdb_quotalegacy.lo: lib/$(am__dirstamp) \
@@ -3217,7 +3439,6 @@ lib/times.lo: lib/$(am__dirstamp) lib/$(
 lib/tok.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/wildmat.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/cyrusdb_sql.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
-lib/cyrusdb_lmdb.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/sqldb.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/gmtoff_tm.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/gmtoff_gmtime.lo: lib/$(am__dirstamp) \
@@ -3226,6 +3447,8 @@ lib/nonblock_fcntl.lo: lib/$(am__dirstam
 	lib/$(DEPDIR)/$(am__dirstamp)
 lib/nonblock_ioctl.lo: lib/$(am__dirstamp) \
 	lib/$(DEPDIR)/$(am__dirstamp)
+lib/cyrusdb_zeroskip.lo: lib/$(am__dirstamp) \
+	lib/$(DEPDIR)/$(am__dirstamp)
 lib/chartable.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 perl/$(am__dirstamp):
 	@$(MKDIR_P) perl
@@ -3238,6 +3461,7 @@ lib/assert.lo: lib/$(am__dirstamp) lib/$
 lib/bufarray.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/byteorder64.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/hash.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
+lib/hashset.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/hashu64.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/libconfig.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
 lib/mpool.lo: lib/$(am__dirstamp) lib/$(DEPDIR)/$(am__dirstamp)
@@ -3292,6 +3516,8 @@ sieve/sieve_libcyrus_sieve_la-bc_eval.lo
 	sieve/$(DEPDIR)/$(am__dirstamp)
 sieve/sieve_libcyrus_sieve_la-bc_generate.lo: sieve/$(am__dirstamp) \
 	sieve/$(DEPDIR)/$(am__dirstamp)
+sieve/sieve_libcyrus_sieve_la-bc_parse.lo: sieve/$(am__dirstamp) \
+	sieve/$(DEPDIR)/$(am__dirstamp)
 sieve/sieve_libcyrus_sieve_la-comparator.lo: sieve/$(am__dirstamp) \
 	sieve/$(DEPDIR)/$(am__dirstamp)
 sieve/sieve_libcyrus_sieve_la-flags.lo: sieve/$(am__dirstamp) \
@@ -3314,6 +3540,8 @@ sieve/sieve_libcyrus_sieve_la-variables.
 	sieve/$(DEPDIR)/$(am__dirstamp)
 sieve/sieve_libcyrus_sieve_la-varlist.lo: sieve/$(am__dirstamp) \
 	sieve/$(DEPDIR)/$(am__dirstamp)
+imap/sieve_libcyrus_sieve_la-json_support.lo: imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 sieve/sieve_libcyrus_sieve_la-sieve_err.lo: sieve/$(am__dirstamp) \
 	sieve/$(DEPDIR)/$(am__dirstamp)
 
@@ -3527,6 +3755,18 @@ backup/restore.$(OBJEXT): backup/$(am__d
 backup/restore$(EXEEXT): $(backup_restore_OBJECTS) $(backup_restore_DEPENDENCIES) $(EXTRA_backup_restore_DEPENDENCIES) backup/$(am__dirstamp)
 	@rm -f backup/restore$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(backup_restore_OBJECTS) $(backup_restore_LDADD) $(LIBS)
+bench/$(am__dirstamp):
+	@$(MKDIR_P) bench
+	@: > bench/$(am__dirstamp)
+bench/$(DEPDIR)/$(am__dirstamp):
+	@$(MKDIR_P) bench/$(DEPDIR)
+	@: > bench/$(DEPDIR)/$(am__dirstamp)
+bench/cyrdbbench.$(OBJEXT): bench/$(am__dirstamp) \
+	bench/$(DEPDIR)/$(am__dirstamp)
+
+bench/cyrdbbench$(EXEEXT): $(bench_cyrdbbench_OBJECTS) $(bench_cyrdbbench_DEPENDENCIES) $(EXTRA_bench_cyrdbbench_DEPENDENCIES) bench/$(am__dirstamp)
+	@rm -f bench/cyrdbbench$(EXEEXT)
+	$(AM_V_CCLD)$(LINK) $(bench_cyrdbbench_OBJECTS) $(bench_cyrdbbench_LDADD) $(LIBS)
 cunit/$(am__dirstamp):
 	@$(MKDIR_P) cunit
 	@: > cunit/$(am__dirstamp)
@@ -3563,6 +3803,8 @@ cunit/command.$(OBJEXT): cunit/$(am__dir
 	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/conversations.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
+cunit/cyr_qsort_r.$(OBJEXT): cunit/$(am__dirstamp) \
+	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/crc32.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/dlist.$(OBJEXT): cunit/$(am__dirstamp) \
@@ -3577,8 +3819,12 @@ cunit/guid.$(OBJEXT): cunit/$(am__dirsta
 	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/hash.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
+cunit/hashset.$(OBJEXT): cunit/$(am__dirstamp) \
+	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/imapurl.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
+cunit/imparse.$(OBJEXT): cunit/$(am__dirstamp) \
+	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/libconfig.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/mboxname.$(OBJEXT): cunit/$(am__dirstamp) \
@@ -3621,6 +3867,8 @@ cunit/tok.$(OBJEXT): cunit/$(am__dirstam
 	cunit/$(DEPDIR)/$(am__dirstamp)
 cunit/vparse.$(OBJEXT): cunit/$(am__dirstamp) \
 	cunit/$(DEPDIR)/$(am__dirstamp)
+cunit/jmap_util.$(OBJEXT): cunit/$(am__dirstamp) \
+	cunit/$(DEPDIR)/$(am__dirstamp)
 imap/spool.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 
@@ -3735,12 +3983,6 @@ imap/cyr_sequence.$(OBJEXT): imap/$(am__
 imap/cyr_sequence$(EXEEXT): $(imap_cyr_sequence_OBJECTS) $(imap_cyr_sequence_DEPENDENCIES) $(EXTRA_imap_cyr_sequence_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/cyr_sequence$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(imap_cyr_sequence_OBJECTS) $(imap_cyr_sequence_LDADD) $(LIBS)
-imap/cyr_sphinxmgr.$(OBJEXT): imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
-
-imap/cyr_sphinxmgr$(EXEEXT): $(imap_cyr_sphinxmgr_OBJECTS) $(imap_cyr_sphinxmgr_DEPENDENCIES) $(EXTRA_imap_cyr_sphinxmgr_DEPENDENCIES) imap/$(am__dirstamp)
-	@rm -f imap/cyr_sphinxmgr$(EXEEXT)
-	$(AM_V_CCLD)$(LINK) $(imap_cyr_sphinxmgr_OBJECTS) $(imap_cyr_sphinxmgr_LDADD) $(LIBS)
 imap/cyr_synclog.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 
@@ -3779,10 +4021,12 @@ imap/deliver.$(OBJEXT): imap/$(am__dirst
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/lmtpengine.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/lmtpstats.$(OBJEXT): imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
 imap/proxy.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/lmtp_err.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/lmtpstats.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 
 imap/deliver$(EXEEXT): $(imap_deliver_OBJECTS) $(imap_deliver_DEPENDENCIES) $(EXTRA_imap_deliver_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/deliver$(EXEEXT)
@@ -3799,7 +4043,7 @@ imap/fud.$(OBJEXT): imap/$(am__dirstamp)
 imap/fud$(EXEEXT): $(imap_fud_OBJECTS) $(imap_fud_DEPENDENCIES) $(EXTRA_imap_fud_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/fud$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(imap_fud_OBJECTS) $(imap_fud_LDADD) $(LIBS)
-imap/caldav_db.$(OBJEXT): imap/$(am__dirstamp) \
+imap/css3_color.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_admin.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
@@ -3811,14 +4055,20 @@ imap/http_caldav_sched.$(OBJEXT): imap/$
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_carddav.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/http_client.$(OBJEXT): imap/$(am__dirstamp) \
+imap/http_cgi.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_dav.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/http_dav_sharing.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_dblookup.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/http_h2.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_ischedule.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/http_prometheus.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_proxy.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_rss.$(OBJEXT): imap/$(am__dirstamp) \
@@ -3827,28 +4077,56 @@ imap/http_tzdist.$(OBJEXT): imap/$(am__d
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/http_webdav.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/httpd.$(OBJEXT): imap/$(am__dirstamp) \
+imap/http_ws.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/ical_support.$(OBJEXT): imap/$(am__dirstamp) \
+imap/httpd.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/jcal.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/smtpclient.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/vcard_support.$(OBJEXT): imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
 imap/xcal.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/xml_support.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/http_err.$(OBJEXT): imap/$(am__dirstamp) \
+imap/http_jmap.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_api.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_calendar.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_contact.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_core.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_ical.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_mail.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_mail_query.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_mail_submission.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_mailbox.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_util.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_vacation.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/tz_err.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/jmap_err.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 
 imap/httpd$(EXEEXT): $(imap_httpd_OBJECTS) $(imap_httpd_DEPENDENCIES) $(EXTRA_imap_httpd_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/httpd$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(imap_httpd_OBJECTS) $(imap_httpd_LDADD) $(LIBS)
+imap/ical_apply_patch.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+
+imap/ical_apply_patch$(EXEEXT): $(imap_ical_apply_patch_OBJECTS) $(imap_ical_apply_patch_DEPENDENCIES) $(EXTRA_imap_ical_apply_patch_DEPENDENCIES) imap/$(am__dirstamp)
+	@rm -f imap/ical_apply_patch$(EXEEXT)
+	$(AM_V_CCLD)$(LINK) $(imap_ical_apply_patch_OBJECTS) $(imap_ical_apply_patch_LDADD) $(LIBS)
 imap/idled.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 
@@ -3859,10 +4137,10 @@ imap/imap_proxy.$(OBJEXT): imap/$(am__di
 	imap/$(DEPDIR)/$(am__dirstamp)
 imap/imapd.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
-imap/pushstats.$(OBJEXT): imap/$(am__dirstamp) \
-	imap/$(DEPDIR)/$(am__dirstamp)
 imap/autocreate.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
+imap/pushstats.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
 
 imap/imapd$(EXEEXT): $(imap_imapd_OBJECTS) $(imap_imapd_DEPENDENCIES) $(EXTRA_imap_imapd_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/imapd$(EXEEXT)
@@ -3933,6 +4211,12 @@ imap/pop3d.$(OBJEXT): imap/$(am__dirstam
 imap/pop3d$(EXEEXT): $(imap_pop3d_OBJECTS) $(imap_pop3d_DEPENDENCIES) $(EXTRA_imap_pop3d_DEPENDENCIES) imap/$(am__dirstamp)
 	@rm -f imap/pop3d$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(imap_pop3d_OBJECTS) $(imap_pop3d_LDADD) $(LIBS)
+imap/promstatsd.$(OBJEXT): imap/$(am__dirstamp) \
+	imap/$(DEPDIR)/$(am__dirstamp)
+
+imap/promstatsd$(EXEEXT): $(imap_promstatsd_OBJECTS) $(imap_promstatsd_DEPENDENCIES) $(EXTRA_imap_promstatsd_DEPENDENCIES) imap/$(am__dirstamp)
+	@rm -f imap/promstatsd$(EXEEXT)
+	$(AM_V_CCLD)$(LINK) $(imap_promstatsd_OBJECTS) $(imap_promstatsd_LDADD) $(LIBS)
 imap/quota.$(OBJEXT): imap/$(am__dirstamp) \
 	imap/$(DEPDIR)/$(am__dirstamp)
 
@@ -4109,6 +4393,12 @@ sieve/test.$(OBJEXT): sieve/$(am__dirsta
 sieve/test$(EXEEXT): $(sieve_test_OBJECTS) $(sieve_test_DEPENDENCIES) $(EXTRA_sieve_test_DEPENDENCIES) sieve/$(am__dirstamp)
 	@rm -f sieve/test$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(sieve_test_OBJECTS) $(sieve_test_LDADD) $(LIBS)
+sieve/test_mailbox.$(OBJEXT): sieve/$(am__dirstamp) \
+	sieve/$(DEPDIR)/$(am__dirstamp)
+
+sieve/test_mailbox$(EXEEXT): $(sieve_test_mailbox_OBJECTS) $(sieve_test_mailbox_DEPENDENCIES) $(EXTRA_sieve_test_mailbox_DEPENDENCIES) sieve/$(am__dirstamp)
+	@rm -f sieve/test_mailbox$(EXEEXT)
+	$(AM_V_CCLD)$(LINK) $(sieve_test_mailbox_OBJECTS) $(sieve_test_mailbox_LDADD) $(LIBS)
 timsieved/$(am__dirstamp):
 	@$(MKDIR_P) timsieved
 	@: > timsieved/$(am__dirstamp)
@@ -4132,6 +4422,7 @@ mostlyclean-compile:
 	-rm -f *.$(OBJEXT)
 	-rm -f backup/*.$(OBJEXT)
 	-rm -f backup/*.lo
+	-rm -f bench/*.$(OBJEXT)
 	-rm -f com_err/et/*.$(OBJEXT)
 	-rm -f com_err/et/*.lo
 	-rm -f cunit/*.$(OBJEXT)
@@ -4168,6 +4459,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@backup/$(DEPDIR)/lcb_sqlconsts.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@backup/$(DEPDIR)/lcb_verify.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@backup/$(DEPDIR)/restore.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@bench/$(DEPDIR)/cyrdbbench.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@com_err/et/$(DEPDIR)/com_err_et_libcyrus_com_err_la-com_err.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@com_err/et/$(DEPDIR)/com_err_et_libcyrus_com_err_la-error_message.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@com_err/et/$(DEPDIR)/com_err_et_libcyrus_com_err_la-et_name.Plo@am__quote@
@@ -4180,9 +4472,9 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/arbitron.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/autocreate.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/calalarmd.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/caldav_db.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/chk_cyrus.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cli_fatal.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/css3_color.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ctl_conversationsdb.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ctl_cyrusdb.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ctl_deliver.Po@am__quote@
@@ -4197,7 +4489,6 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_expire.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_info.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_sequence.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_sphinxmgr.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_synclog.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyr_userseen.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/cyrdump.Po@am__quote@
@@ -4210,17 +4501,21 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_caldav.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_caldav_sched.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_carddav.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_client.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_cgi.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_dav.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_dav_sharing.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_dblookup.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_err.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_h2.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_ischedule.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_jmap.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_prometheus.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_proxy.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_rss.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_tzdist.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_webdav.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/http_ws.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/httpd.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ical_support.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ical_apply_patch.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/idled.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_cyr_virusscan-cli_fatal.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_cyr_virusscan-cyr_virusscan.Po@am__quote@
@@ -4238,12 +4533,17 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-dlist.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-duplicate.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-global.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-http_client.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-http_err.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-ical_support.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-icu_wrap.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-idle.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-idlemsg.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-imap_err.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-imapparse.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-index.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-jmap_util.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-json_support.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mailbox.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mbdump.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mboxevent.Plo@am__quote@
@@ -4252,6 +4552,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mboxname.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-message.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-message_guid.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-msgrecord.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mupdate-client.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-mupdate_err.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-notify.Plo@am__quote@
@@ -4261,6 +4562,8 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-objectstore_openio.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-partlist.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-proc.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-promdata.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-prometheus.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-quota_db.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-rfc822_header.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-saslclient.Plo@am__quote@
@@ -4268,13 +4571,13 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_engines.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_expr.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_query.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_sphinx.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_squat.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-search_xapian.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-seen_db.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-sequence.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-setproctitle.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-sphinxmgr_client.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-smtpclient.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-spool.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-squat.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-squat_build.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imap_libcyrus_imap_la-squat_internal.Plo@am__quote@
@@ -4298,6 +4601,19 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/imapd.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/ipurge.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jcal.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_api.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_calendar.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_contact.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_core.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_err.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_ical.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_mail.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_mail_query.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_mail_submission.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_mailbox.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_util.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/jmap_vacation.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/lmtp_err.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/lmtp_sieve.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/lmtpd.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/lmtpengine.Po@am__quote@
@@ -4310,11 +4626,13 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/nntp_err.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/nntpd.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/pop3d.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/promstatsd.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/proxy.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/pushstats.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/quota.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/reconstruct.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/search_test.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/sieve_libcyrus_sieve_la-json_support.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/smmapd.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/smtpclient.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/spool.Po@am__quote@
@@ -4327,7 +4645,6 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/tls_prune.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/tz_err.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/unexpunge.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/vcard_support.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/xcal.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/xml_support.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@imap/$(DEPDIR)/zoneinfo_db.Po@am__quote@
@@ -4349,13 +4666,14 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/charset.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/chartable.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/command.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyr_qsort_r.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_flat.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_lmdb.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_quotalegacy.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_skiplist.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_sql.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_twoskip.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/cyrusdb_zeroskip.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/ftruncate.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/getaddrinfo.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/getdtablesize.Plo@am__quote@
@@ -4365,6 +4683,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/gmtoff_tm.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/gzuncat.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/hash.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/hashset.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/hashu64.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/htmlchar.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/imapopts.Plo@am__quote@
@@ -4386,13 +4705,14 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-charset.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-chartable.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-command.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyr_qsort_r.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_flat.Plo@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_lmdb.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_quotalegacy.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_skiplist.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_sql.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_twoskip.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_zeroskip.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-glob.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-gmtoff_gmtime.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_la-gmtoff_tm.Plo@am__quote@
@@ -4426,6 +4746,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-getaddrinfo.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-getnameinfo.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-hash.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-hashset.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-hashu64.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-imapopts.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@lib/$(DEPDIR)/lib_libcyrus_min_la-libconfig.Plo@am__quote@
@@ -4514,6 +4835,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_emit.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_eval.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_generate.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_parse.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-comparator.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-flags.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-grammar.Plo@am__quote@
@@ -4531,6 +4853,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sievec.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/sieved.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/test.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@sieve/$(DEPDIR)/test_mailbox.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@timsieved/$(DEPDIR)/actions.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@timsieved/$(DEPDIR)/lex.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@timsieved/$(DEPDIR)/parser.Po@am__quote@
@@ -4644,6 +4967,13 @@ imap/imap_libcyrus_imap_la-global.lo: im
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-global.lo `test -f 'imap/global.c' || echo '$(srcdir)/'`imap/global.c
 
+imap/imap_libcyrus_imap_la-http_client.lo: imap/http_client.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-http_client.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-http_client.Tpo -c -o imap/imap_libcyrus_imap_la-http_client.lo `test -f 'imap/http_client.c' || echo '$(srcdir)/'`imap/http_client.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-http_client.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-http_client.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/http_client.c' object='imap/imap_libcyrus_imap_la-http_client.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-http_client.lo `test -f 'imap/http_client.c' || echo '$(srcdir)/'`imap/http_client.c
+
 imap/imap_libcyrus_imap_la-idle.lo: imap/idle.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-idle.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-idle.Tpo -c -o imap/imap_libcyrus_imap_la-idle.lo `test -f 'imap/idle.c' || echo '$(srcdir)/'`imap/idle.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-idle.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-idle.Plo
@@ -4728,6 +5058,13 @@ imap/imap_libcyrus_imap_la-message.lo: i
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-message.lo `test -f 'imap/message.c' || echo '$(srcdir)/'`imap/message.c
 
+imap/imap_libcyrus_imap_la-msgrecord.lo: imap/msgrecord.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-msgrecord.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-msgrecord.Tpo -c -o imap/imap_libcyrus_imap_la-msgrecord.lo `test -f 'imap/msgrecord.c' || echo '$(srcdir)/'`imap/msgrecord.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-msgrecord.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-msgrecord.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/msgrecord.c' object='imap/imap_libcyrus_imap_la-msgrecord.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-msgrecord.lo `test -f 'imap/msgrecord.c' || echo '$(srcdir)/'`imap/msgrecord.c
+
 imap/imap_libcyrus_imap_la-mupdate-client.lo: imap/mupdate-client.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-mupdate-client.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-mupdate-client.Tpo -c -o imap/imap_libcyrus_imap_la-mupdate-client.lo `test -f 'imap/mupdate-client.c' || echo '$(srcdir)/'`imap/mupdate-client.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-mupdate-client.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-mupdate-client.Plo
@@ -4756,6 +5093,13 @@ imap/imap_libcyrus_imap_la-proc.lo: imap
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-proc.lo `test -f 'imap/proc.c' || echo '$(srcdir)/'`imap/proc.c
 
+imap/imap_libcyrus_imap_la-prometheus.lo: imap/prometheus.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-prometheus.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-prometheus.Tpo -c -o imap/imap_libcyrus_imap_la-prometheus.lo `test -f 'imap/prometheus.c' || echo '$(srcdir)/'`imap/prometheus.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-prometheus.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-prometheus.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/prometheus.c' object='imap/imap_libcyrus_imap_la-prometheus.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-prometheus.lo `test -f 'imap/prometheus.c' || echo '$(srcdir)/'`imap/prometheus.c
+
 imap/imap_libcyrus_imap_la-quota_db.lo: imap/quota_db.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-quota_db.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-quota_db.Tpo -c -o imap/imap_libcyrus_imap_la-quota_db.lo `test -f 'imap/quota_db.c' || echo '$(srcdir)/'`imap/quota_db.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-quota_db.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-quota_db.Plo
@@ -4826,6 +5170,13 @@ imap/imap_libcyrus_imap_la-setproctitle.
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-setproctitle.lo `test -f 'imap/setproctitle.c' || echo '$(srcdir)/'`imap/setproctitle.c
 
+imap/imap_libcyrus_imap_la-spool.lo: imap/spool.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-spool.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-spool.Tpo -c -o imap/imap_libcyrus_imap_la-spool.lo `test -f 'imap/spool.c' || echo '$(srcdir)/'`imap/spool.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-spool.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-spool.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/spool.c' object='imap/imap_libcyrus_imap_la-spool.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-spool.lo `test -f 'imap/spool.c' || echo '$(srcdir)/'`imap/spool.c
+
 imap/imap_libcyrus_imap_la-statuscache_db.lo: imap/statuscache_db.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-statuscache_db.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-statuscache_db.Tpo -c -o imap/imap_libcyrus_imap_la-statuscache_db.lo `test -f 'imap/statuscache_db.c' || echo '$(srcdir)/'`imap/statuscache_db.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-statuscache_db.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-statuscache_db.Plo
@@ -4945,20 +5296,6 @@ imap/imap_libcyrus_imap_la-squat_interna
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-squat_internal.lo `test -f 'imap/squat_internal.c' || echo '$(srcdir)/'`imap/squat_internal.c
 
-imap/imap_libcyrus_imap_la-search_sphinx.lo: imap/search_sphinx.c
-@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-search_sphinx.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-search_sphinx.Tpo -c -o imap/imap_libcyrus_imap_la-search_sphinx.lo `test -f 'imap/search_sphinx.c' || echo '$(srcdir)/'`imap/search_sphinx.c
-@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-search_sphinx.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-search_sphinx.Plo
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/search_sphinx.c' object='imap/imap_libcyrus_imap_la-search_sphinx.lo' libtool=yes @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-search_sphinx.lo `test -f 'imap/search_sphinx.c' || echo '$(srcdir)/'`imap/search_sphinx.c
-
-imap/imap_libcyrus_imap_la-sphinxmgr_client.lo: imap/sphinxmgr_client.c
-@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-sphinxmgr_client.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-sphinxmgr_client.Tpo -c -o imap/imap_libcyrus_imap_la-sphinxmgr_client.lo `test -f 'imap/sphinxmgr_client.c' || echo '$(srcdir)/'`imap/sphinxmgr_client.c
-@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-sphinxmgr_client.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-sphinxmgr_client.Plo
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/sphinxmgr_client.c' object='imap/imap_libcyrus_imap_la-sphinxmgr_client.lo' libtool=yes @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-sphinxmgr_client.lo `test -f 'imap/sphinxmgr_client.c' || echo '$(srcdir)/'`imap/sphinxmgr_client.c
-
 imap/imap_libcyrus_imap_la-caldav_alarm.lo: imap/caldav_alarm.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-caldav_alarm.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-caldav_alarm.Tpo -c -o imap/imap_libcyrus_imap_la-caldav_alarm.lo `test -f 'imap/caldav_alarm.c' || echo '$(srcdir)/'`imap/caldav_alarm.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-caldav_alarm.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-caldav_alarm.Plo
@@ -5015,6 +5352,13 @@ imap/imap_libcyrus_imap_la-webdav_db.lo:
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-webdav_db.lo `test -f 'imap/webdav_db.c' || echo '$(srcdir)/'`imap/webdav_db.c
 
+imap/imap_libcyrus_imap_la-smtpclient.lo: imap/smtpclient.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-smtpclient.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-smtpclient.Tpo -c -o imap/imap_libcyrus_imap_la-smtpclient.lo `test -f 'imap/smtpclient.c' || echo '$(srcdir)/'`imap/smtpclient.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-smtpclient.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-smtpclient.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/smtpclient.c' object='imap/imap_libcyrus_imap_la-smtpclient.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-smtpclient.lo `test -f 'imap/smtpclient.c' || echo '$(srcdir)/'`imap/smtpclient.c
+
 imap/imap_libcyrus_imap_la-search_xapian.lo: imap/search_xapian.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-search_xapian.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-search_xapian.Tpo -c -o imap/imap_libcyrus_imap_la-search_xapian.lo `test -f 'imap/search_xapian.c' || echo '$(srcdir)/'`imap/search_xapian.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-search_xapian.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-search_xapian.Plo
@@ -5022,6 +5366,27 @@ imap/imap_libcyrus_imap_la-search_xapian
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-search_xapian.lo `test -f 'imap/search_xapian.c' || echo '$(srcdir)/'`imap/search_xapian.c
 
+imap/imap_libcyrus_imap_la-jmap_util.lo: imap/jmap_util.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-jmap_util.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-jmap_util.Tpo -c -o imap/imap_libcyrus_imap_la-jmap_util.lo `test -f 'imap/jmap_util.c' || echo '$(srcdir)/'`imap/jmap_util.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-jmap_util.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-jmap_util.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/jmap_util.c' object='imap/imap_libcyrus_imap_la-jmap_util.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-jmap_util.lo `test -f 'imap/jmap_util.c' || echo '$(srcdir)/'`imap/jmap_util.c
+
+imap/imap_libcyrus_imap_la-json_support.lo: imap/json_support.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-json_support.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-json_support.Tpo -c -o imap/imap_libcyrus_imap_la-json_support.lo `test -f 'imap/json_support.c' || echo '$(srcdir)/'`imap/json_support.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-json_support.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-json_support.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/json_support.c' object='imap/imap_libcyrus_imap_la-json_support.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-json_support.lo `test -f 'imap/json_support.c' || echo '$(srcdir)/'`imap/json_support.c
+
+imap/imap_libcyrus_imap_la-http_err.lo: imap/http_err.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-http_err.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-http_err.Tpo -c -o imap/imap_libcyrus_imap_la-http_err.lo `test -f 'imap/http_err.c' || echo '$(srcdir)/'`imap/http_err.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-http_err.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-http_err.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/http_err.c' object='imap/imap_libcyrus_imap_la-http_err.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-http_err.lo `test -f 'imap/http_err.c' || echo '$(srcdir)/'`imap/http_err.c
+
 imap/imap_libcyrus_imap_la-imap_err.lo: imap/imap_err.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-imap_err.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-imap_err.Tpo -c -o imap/imap_libcyrus_imap_la-imap_err.lo `test -f 'imap/imap_err.c' || echo '$(srcdir)/'`imap/imap_err.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-imap_err.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-imap_err.Plo
@@ -5036,6 +5401,13 @@ imap/imap_libcyrus_imap_la-mupdate_err.l
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-mupdate_err.lo `test -f 'imap/mupdate_err.c' || echo '$(srcdir)/'`imap/mupdate_err.c
 
+imap/imap_libcyrus_imap_la-promdata.lo: imap/promdata.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -MT imap/imap_libcyrus_imap_la-promdata.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-promdata.Tpo -c -o imap/imap_libcyrus_imap_la-promdata.lo `test -f 'imap/promdata.c' || echo '$(srcdir)/'`imap/promdata.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-promdata.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-promdata.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/promdata.c' object='imap/imap_libcyrus_imap_la-promdata.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CFLAGS) $(CFLAGS) -c -o imap/imap_libcyrus_imap_la-promdata.lo `test -f 'imap/promdata.c' || echo '$(srcdir)/'`imap/promdata.c
+
 lib/lib_libcyrus_la-acl.lo: lib/acl.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-acl.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-acl.Tpo -c -o lib/lib_libcyrus_la-acl.lo `test -f 'lib/acl.c' || echo '$(srcdir)/'`lib/acl.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-acl.Tpo lib/$(DEPDIR)/lib_libcyrus_la-acl.Plo
@@ -5120,6 +5492,13 @@ lib/lib_libcyrus_la-command.lo: lib/comm
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-command.lo `test -f 'lib/command.c' || echo '$(srcdir)/'`lib/command.c
 
+lib/lib_libcyrus_la-cyr_qsort_r.lo: lib/cyr_qsort_r.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-cyr_qsort_r.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-cyr_qsort_r.Tpo -c -o lib/lib_libcyrus_la-cyr_qsort_r.lo `test -f 'lib/cyr_qsort_r.c' || echo '$(srcdir)/'`lib/cyr_qsort_r.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-cyr_qsort_r.Tpo lib/$(DEPDIR)/lib_libcyrus_la-cyr_qsort_r.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='lib/cyr_qsort_r.c' object='lib/lib_libcyrus_la-cyr_qsort_r.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-cyr_qsort_r.lo `test -f 'lib/cyr_qsort_r.c' || echo '$(srcdir)/'`lib/cyr_qsort_r.c
+
 lib/lib_libcyrus_la-cyrusdb.lo: lib/cyrusdb.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-cyrusdb.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb.Tpo -c -o lib/lib_libcyrus_la-cyrusdb.lo `test -f 'lib/cyrusdb.c' || echo '$(srcdir)/'`lib/cyrusdb.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb.Tpo lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb.Plo
@@ -5309,13 +5688,6 @@ lib/lib_libcyrus_la-cyrusdb_sql.lo: lib/
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-cyrusdb_sql.lo `test -f 'lib/cyrusdb_sql.c' || echo '$(srcdir)/'`lib/cyrusdb_sql.c
 
-lib/lib_libcyrus_la-cyrusdb_lmdb.lo: lib/cyrusdb_lmdb.c
-@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-cyrusdb_lmdb.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_lmdb.Tpo -c -o lib/lib_libcyrus_la-cyrusdb_lmdb.lo `test -f 'lib/cyrusdb_lmdb.c' || echo '$(srcdir)/'`lib/cyrusdb_lmdb.c
-@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_lmdb.Tpo lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_lmdb.Plo
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='lib/cyrusdb_lmdb.c' object='lib/lib_libcyrus_la-cyrusdb_lmdb.lo' libtool=yes @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-cyrusdb_lmdb.lo `test -f 'lib/cyrusdb_lmdb.c' || echo '$(srcdir)/'`lib/cyrusdb_lmdb.c
-
 lib/lib_libcyrus_la-sqldb.lo: lib/sqldb.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-sqldb.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-sqldb.Tpo -c -o lib/lib_libcyrus_la-sqldb.lo `test -f 'lib/sqldb.c' || echo '$(srcdir)/'`lib/sqldb.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-sqldb.Tpo lib/$(DEPDIR)/lib_libcyrus_la-sqldb.Plo
@@ -5351,6 +5723,13 @@ lib/lib_libcyrus_la-nonblock_ioctl.lo: l
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-nonblock_ioctl.lo `test -f 'lib/nonblock_ioctl.c' || echo '$(srcdir)/'`lib/nonblock_ioctl.c
 
+lib/lib_libcyrus_la-cyrusdb_zeroskip.lo: lib/cyrusdb_zeroskip.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-cyrusdb_zeroskip.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_zeroskip.Tpo -c -o lib/lib_libcyrus_la-cyrusdb_zeroskip.lo `test -f 'lib/cyrusdb_zeroskip.c' || echo '$(srcdir)/'`lib/cyrusdb_zeroskip.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_zeroskip.Tpo lib/$(DEPDIR)/lib_libcyrus_la-cyrusdb_zeroskip.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='lib/cyrusdb_zeroskip.c' object='lib/lib_libcyrus_la-cyrusdb_zeroskip.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_la-cyrusdb_zeroskip.lo `test -f 'lib/cyrusdb_zeroskip.c' || echo '$(srcdir)/'`lib/cyrusdb_zeroskip.c
+
 lib/lib_libcyrus_la-chartable.lo: lib/chartable.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_la-chartable.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_la-chartable.Tpo -c -o lib/lib_libcyrus_la-chartable.lo `test -f 'lib/chartable.c' || echo '$(srcdir)/'`lib/chartable.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_la-chartable.Tpo lib/$(DEPDIR)/lib_libcyrus_la-chartable.Plo
@@ -5393,6 +5772,13 @@ lib/lib_libcyrus_min_la-hash.lo: lib/has
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_min_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_min_la-hash.lo `test -f 'lib/hash.c' || echo '$(srcdir)/'`lib/hash.c
 
+lib/lib_libcyrus_min_la-hashset.lo: lib/hashset.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_min_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_min_la-hashset.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_min_la-hashset.Tpo -c -o lib/lib_libcyrus_min_la-hashset.lo `test -f 'lib/hashset.c' || echo '$(srcdir)/'`lib/hashset.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_min_la-hashset.Tpo lib/$(DEPDIR)/lib_libcyrus_min_la-hashset.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='lib/hashset.c' object='lib/lib_libcyrus_min_la-hashset.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_min_la_CFLAGS) $(CFLAGS) -c -o lib/lib_libcyrus_min_la-hashset.lo `test -f 'lib/hashset.c' || echo '$(srcdir)/'`lib/hashset.c
+
 lib/lib_libcyrus_min_la-hashu64.lo: lib/hashu64.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(lib_libcyrus_min_la_CFLAGS) $(CFLAGS) -MT lib/lib_libcyrus_min_la-hashu64.lo -MD -MP -MF lib/$(DEPDIR)/lib_libcyrus_min_la-hashu64.Tpo -c -o lib/lib_libcyrus_min_la-hashu64.lo `test -f 'lib/hashu64.c' || echo '$(srcdir)/'`lib/hashu64.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) lib/$(DEPDIR)/lib_libcyrus_min_la-hashu64.Tpo lib/$(DEPDIR)/lib_libcyrus_min_la-hashu64.Plo
@@ -5582,6 +5968,13 @@ sieve/sieve_libcyrus_sieve_la-bc_generat
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -c -o sieve/sieve_libcyrus_sieve_la-bc_generate.lo `test -f 'sieve/bc_generate.c' || echo '$(srcdir)/'`sieve/bc_generate.c
 
+sieve/sieve_libcyrus_sieve_la-bc_parse.lo: sieve/bc_parse.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -MT sieve/sieve_libcyrus_sieve_la-bc_parse.lo -MD -MP -MF sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_parse.Tpo -c -o sieve/sieve_libcyrus_sieve_la-bc_parse.lo `test -f 'sieve/bc_parse.c' || echo '$(srcdir)/'`sieve/bc_parse.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_parse.Tpo sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-bc_parse.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='sieve/bc_parse.c' object='sieve/sieve_libcyrus_sieve_la-bc_parse.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -c -o sieve/sieve_libcyrus_sieve_la-bc_parse.lo `test -f 'sieve/bc_parse.c' || echo '$(srcdir)/'`sieve/bc_parse.c
+
 sieve/sieve_libcyrus_sieve_la-comparator.lo: sieve/comparator.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -MT sieve/sieve_libcyrus_sieve_la-comparator.lo -MD -MP -MF sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-comparator.Tpo -c -o sieve/sieve_libcyrus_sieve_la-comparator.lo `test -f 'sieve/comparator.c' || echo '$(srcdir)/'`sieve/comparator.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-comparator.Tpo sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-comparator.Plo
@@ -5659,6 +6052,13 @@ sieve/sieve_libcyrus_sieve_la-varlist.lo
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -c -o sieve/sieve_libcyrus_sieve_la-varlist.lo `test -f 'sieve/varlist.c' || echo '$(srcdir)/'`sieve/varlist.c
 
+imap/sieve_libcyrus_sieve_la-json_support.lo: imap/json_support.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -MT imap/sieve_libcyrus_sieve_la-json_support.lo -MD -MP -MF imap/$(DEPDIR)/sieve_libcyrus_sieve_la-json_support.Tpo -c -o imap/sieve_libcyrus_sieve_la-json_support.lo `test -f 'imap/json_support.c' || echo '$(srcdir)/'`imap/json_support.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/sieve_libcyrus_sieve_la-json_support.Tpo imap/$(DEPDIR)/sieve_libcyrus_sieve_la-json_support.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='imap/json_support.c' object='imap/sieve_libcyrus_sieve_la-json_support.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -c -o imap/sieve_libcyrus_sieve_la-json_support.lo `test -f 'imap/json_support.c' || echo '$(srcdir)/'`imap/json_support.c
+
 sieve/sieve_libcyrus_sieve_la-sieve_err.lo: sieve/sieve_err.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(sieve_libcyrus_sieve_la_CFLAGS) $(CFLAGS) -MT sieve/sieve_libcyrus_sieve_la-sieve_err.lo -MD -MP -MF sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-sieve_err.Tpo -c -o sieve/sieve_libcyrus_sieve_la-sieve_err.lo `test -f 'sieve/sieve_err.c' || echo '$(srcdir)/'`sieve/sieve_err.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-sieve_err.Tpo sieve/$(DEPDIR)/sieve_libcyrus_sieve_la-sieve_err.Plo
@@ -5830,6 +6230,13 @@ imtest/imtest_imtest-imtest.obj: imtest/
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(AM_V_CXX@am__nodep@)$(LTCXXCOMPILE) -c -o $@ $<
 
+imap/imap_libcyrus_imap_la-icu_wrap.lo: imap/icu_wrap.cpp
+@am__fastdepCXX_TRUE@	$(AM_V_CXX)$(LIBTOOL) $(AM_V_lt) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CXXFLAGS) $(CXXFLAGS) -MT imap/imap_libcyrus_imap_la-icu_wrap.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-icu_wrap.Tpo -c -o imap/imap_libcyrus_imap_la-icu_wrap.lo `test -f 'imap/icu_wrap.cpp' || echo '$(srcdir)/'`imap/icu_wrap.cpp
+@am__fastdepCXX_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-icu_wrap.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-icu_wrap.Plo
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(AM_V_CXX)source='imap/icu_wrap.cpp' object='imap/imap_libcyrus_imap_la-icu_wrap.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(AM_V_CXX@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CXXFLAGS) $(CXXFLAGS) -c -o imap/imap_libcyrus_imap_la-icu_wrap.lo `test -f 'imap/icu_wrap.cpp' || echo '$(srcdir)/'`imap/icu_wrap.cpp
+
 imap/imap_libcyrus_imap_la-xapian_wrap.lo: imap/xapian_wrap.cpp
 @am__fastdepCXX_TRUE@	$(AM_V_CXX)$(LIBTOOL) $(AM_V_lt) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(imap_libcyrus_imap_la_CXXFLAGS) $(CXXFLAGS) -MT imap/imap_libcyrus_imap_la-xapian_wrap.lo -MD -MP -MF imap/$(DEPDIR)/imap_libcyrus_imap_la-xapian_wrap.Tpo -c -o imap/imap_libcyrus_imap_la-xapian_wrap.lo `test -f 'imap/xapian_wrap.cpp' || echo '$(srcdir)/'`imap/xapian_wrap.cpp
 @am__fastdepCXX_TRUE@	$(AM_V_at)$(am__mv) imap/$(DEPDIR)/imap_libcyrus_imap_la-xapian_wrap.Tpo imap/$(DEPDIR)/imap_libcyrus_imap_la-xapian_wrap.Plo
@@ -5849,6 +6256,7 @@ mostlyclean-libtool:
 clean-libtool:
 	-rm -rf .libs _libs
 	-rm -rf backup/.libs backup/_libs
+	-rm -rf bench/.libs bench/_libs
 	-rm -rf com_err/et/.libs com_err/et/_libs
 	-rm -rf cunit/.libs cunit/_libs
 	-rm -rf imap/.libs imap/_libs
@@ -6505,6 +6913,8 @@ distclean-generic:
 	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
 	-rm -f backup/$(DEPDIR)/$(am__dirstamp)
 	-rm -f backup/$(am__dirstamp)
+	-rm -f bench/$(DEPDIR)/$(am__dirstamp)
+	-rm -f bench/$(am__dirstamp)
 	-rm -f com_err/et/$(DEPDIR)/$(am__dirstamp)
 	-rm -f com_err/et/$(am__dirstamp)
 	-rm -f cunit/$(DEPDIR)/$(am__dirstamp)
@@ -6550,7 +6960,7 @@ clean-am: clean-binPROGRAMS clean-checkP
 
 distclean: distclean-recursive
 	-rm -f $(am__CONFIG_DISTCLEAN_FILES)
-	-rm -rf backup/$(DEPDIR) com_err/et/$(DEPDIR) cunit/$(DEPDIR) imap/$(DEPDIR) imtest/$(DEPDIR) lib/$(DEPDIR) master/$(DEPDIR) netnews/$(DEPDIR) notifyd/$(DEPDIR) perl/sieve/lib/$(DEPDIR) ptclient/$(DEPDIR) sieve/$(DEPDIR) timsieved/$(DEPDIR)
+	-rm -rf backup/$(DEPDIR) bench/$(DEPDIR) com_err/et/$(DEPDIR) cunit/$(DEPDIR) imap/$(DEPDIR) imtest/$(DEPDIR) lib/$(DEPDIR) master/$(DEPDIR) netnews/$(DEPDIR) notifyd/$(DEPDIR) perl/sieve/lib/$(DEPDIR) ptclient/$(DEPDIR) sieve/$(DEPDIR) timsieved/$(DEPDIR)
 	-rm -f Makefile
 distclean-am: clean-am distclean-compile distclean-generic \
 	distclean-hdr distclean-libtool distclean-tags
@@ -6605,7 +7015,7 @@ installcheck-am:
 maintainer-clean: maintainer-clean-recursive
 	-rm -f $(am__CONFIG_DISTCLEAN_FILES)
 	-rm -rf $(top_srcdir)/autom4te.cache
-	-rm -rf backup/$(DEPDIR) com_err/et/$(DEPDIR) cunit/$(DEPDIR) imap/$(DEPDIR) imtest/$(DEPDIR) lib/$(DEPDIR) master/$(DEPDIR) netnews/$(DEPDIR) notifyd/$(DEPDIR) perl/sieve/lib/$(DEPDIR) ptclient/$(DEPDIR) sieve/$(DEPDIR) timsieved/$(DEPDIR)
+	-rm -rf backup/$(DEPDIR) bench/$(DEPDIR) com_err/et/$(DEPDIR) cunit/$(DEPDIR) imap/$(DEPDIR) imtest/$(DEPDIR) lib/$(DEPDIR) master/$(DEPDIR) netnews/$(DEPDIR) notifyd/$(DEPDIR) perl/sieve/lib/$(DEPDIR) ptclient/$(DEPDIR) sieve/$(DEPDIR) timsieved/$(DEPDIR)
 	-rm -f Makefile
 maintainer-clean-am: distclean-am maintainer-clean-generic
 
@@ -6716,38 +7126,26 @@ com_err/et/compile_et: com_err/et/compil
 @CUNIT_TRUE@		retval=$$? ; \
 @CUNIT_TRUE@		exit $$retval
 
-imap/lmtpstats.c: imap/lmtpstats.snmp $(SNMPGEN)
+imap/%stats.h imap/%stats.c: imap/%stats.snmp $(SNMPGEN)
 	$(AM_V_GEN)(cd $(@D) && $(SNMPGEN) $(realpath $<))
 
-imap/pushstats.c: imap/pushstats.snmp $(SNMPGEN)
-	$(AM_V_GEN)(cd $(@D) && $(SNMPGEN) $(realpath $<))
+imap/promdata.c: imap/promdata.p $(PROMDATAGEN)
+	$(AM_V_GEN)$(PROMDATAGEN) -c $@.NEW $< && mv $@.NEW $@
+
+imap/promdata.h: imap/promdata.p $(PROMDATAGEN)
+	$(AM_V_GEN)$(PROMDATAGEN) -h $@.NEW $< && mv $@.NEW $@
 
 # $(COMPILE_ET) creates its output files in the directory it's run from,
 # so do a tricky directory change
-imap/imap_err.h imap/imap_err.c: imap/imap_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/mupdate_err.h imap/mupdate_err.c: imap/mupdate_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/nntp_err.h imap/nntp_err.c: imap/nntp_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/http_err.h imap/http_err.c: imap/http_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
-imap/tz_err.h imap/tz_err.c: imap/tz_err.et $(COMPILE_ET_DEP)
+%_err.h %_err.c: %_err.et $(COMPILE_ET_DEP)
 	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
 
 # xxd cannot have path details in its input filename, otherwise it junks up
 # the variable names in the output file.  so do a tricky directory change.
 # the /dev/null redirection on cd is to prevent shell environments with
 # CDPATH echoing the path change on stdout and consequently into the .h file
-imap/http_caldav_js.h: imap/http_caldav.js
-	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@
-
-imap/http_carddav_js.h: imap/http_carddav.js
-	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@
+%_js.h: %.js
+	$(AM_V_GEN)(cd $(<D) > /dev/null && xxd -i $(<F)) > $@.NEW && mv $@.NEW $@
 
 @MAINTAINER_MODE_TRUE@imap/rfc822_header.c: imap/rfc822_header.st
 @MAINTAINER_MODE_TRUE@	$(AM_V_GEN)${top_srcdir}/tools/compile_st.pl -c $< > $@.NEW && mv $@.NEW $@
@@ -6761,6 +7159,9 @@ imap/http_carddav_js.h: imap/http_cardda
 @MAINTAINER_MODE_TRUE@lib/htmlchar.h: lib/htmlchar.st
 @MAINTAINER_MODE_TRUE@	$(AM_V_GEN)${top_srcdir}/tools/compile_st.pl -h $< > $@.NEW && mv $@.NEW $@
 
+@MAINTAINER_MODE_TRUE@imap/mailbox_header_cache.h: imap/mailbox_header_cache.gperf
+@MAINTAINER_MODE_TRUE@	$(AM_V_GEN)gperf --ignore-case --initializer-suffix=,0 -p -j1 -i 1 -g -o -t -H mailbox_header_cache_hash -N mailbox_header_cache_lookup -k1,3,$$ $< > $@.NEW && mv $@.NEW $@
+
 # n.b. the order of the -m arguments to mkchartable.pl is important,
 # in particular ellie believes unifix.txt must be before UnicodeData.txt
 lib/chartable.c: lib/mkchartable.pl lib/charset/unifix.txt \
@@ -6777,9 +7178,6 @@ lib/imapopts.c: lib/imapoptions tools/co
 
 @SET_MAKE@
 
-sieve/sieve_err.h sieve/sieve_err.c: sieve/sieve_err.et $(COMPILE_ET_DEP)
-	$(AM_V_GEN)(cd $(@D) && $(COMPILE_ET) $(realpath $<))
-
 # The lex-fix rule is now obsolete, but let's leave a crumb here for a
 # while so that custom build scripts that expect it to exist don't choke.
 lex-fix:
@@ -6794,7 +7192,7 @@ snapshot::
 
 docsrc/imap/reference/manpages/systemcommands/cyradm.rst: $(top_srcdir)/perl/imap/IMAP/Shell.pm
 	@$(MKDIR_P) $(@D)
-	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst cyradm < $< > $@
+	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst cyradm < $< > $@.NEW && mv $@.NEW $@
 
 docsrc/imap/reference/manpages/configs/imapd.conf.rst: $(top_srcdir)/tools/config2rst $(top_srcdir)/lib/imapoptions
 	@$(MKDIR_P) $(@D)
@@ -6806,7 +7204,7 @@ doc/examples/imapd_conf/imapd.conf.sampl
 
 docsrc/imap/reference/manpages/usercommands/sieveshell.rst: $(top_srcdir)/perl/sieve/scripts/sieveshell.pl
 	@$(MKDIR_P) $(@D)
-	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst sieveshell < $< > $@
+	$(AM_V_GEN)$(top_srcdir)/tools/perl2rst sieveshell < $< > $@.NEW && mv $@.NEW $@
 
 %.1: man/.sphinx-build.stamp
 	@$(MKDIR_P) $(@D)
@@ -6828,7 +7226,7 @@ docsrc/imap/reference/manpages/usercomma
 clean-sphinx-cache:
 	@$(RM) -r $(SPHINX_CACHE)
 
-@HAVE_SPHINX_BUILD_TRUE@docsrc/.sphinx-build.stamp:
+@HAVE_SPHINX_BUILD_TRUE@docsrc/.sphinx-build.stamp: docsrc/imap/reference/manpages/configs/imapd.conf.rst docsrc/imap/reference/manpages/systemcommands/cyradm.rst docsrc/imap/reference/manpages/usercommands/sieveshell.rst
 @HAVE_SPHINX_BUILD_TRUE@	$(AM_V_GEN)test x"$(top_srcdir)" = x"$(top_builddir)" || \
 @HAVE_SPHINX_BUILD_TRUE@        (cd $(top_srcdir) && tar cf - --mode=gu+w docsrc doc/examples) | tar xf -
 @HAVE_SPHINX_BUILD_TRUE@	@touch $@
@@ -6837,18 +7235,18 @@ clean-sphinx-cache:
 @HAVE_SPHINX_BUILD_TRUE@	test x"$(top_srcdir)" = x"$(top_builddir)" || \
 @HAVE_SPHINX_BUILD_TRUE@		$(RM) -r $(top_builddir)/docsrc $(top_builddir)/doc/examples
 
-@HAVE_SPHINX_BUILD_TRUE@man/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+@HAVE_SPHINX_BUILD_TRUE@man/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 @HAVE_SPHINX_BUILD_TRUE@	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b cyrman $(top_builddir)/docsrc $(top_builddir)/man
 @HAVE_SPHINX_BUILD_TRUE@	@touch $@
 
 @HAVE_SPHINX_BUILD_TRUE@clean-man:
 @HAVE_SPHINX_BUILD_TRUE@	@$(RM) -r man
 
-@HAVE_SPHINX_BUILD_TRUE@doc/html/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+@HAVE_SPHINX_BUILD_TRUE@doc/html/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 @HAVE_SPHINX_BUILD_TRUE@	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b html $(top_builddir)/docsrc $(top_builddir)/doc/html
 @HAVE_SPHINX_BUILD_TRUE@	@touch $@
 
-@HAVE_SPHINX_BUILD_TRUE@doc/text/.sphinx-build.stamp: $(GENERATED_RSTS) docsrc/.sphinx-build.stamp
+@HAVE_SPHINX_BUILD_TRUE@doc/text/.sphinx-build.stamp: docsrc/.sphinx-build.stamp
 @HAVE_SPHINX_BUILD_TRUE@	$(AM_V_GEN)DOCSRC=$(top_builddir)/docsrc $(SPHINX_BUILD) $(SPHINX_OPTS) -b text $(top_builddir)/docsrc $(top_builddir)/doc/text
 @HAVE_SPHINX_BUILD_TRUE@	@touch $@
 @HAVE_SPHINX_BUILD_FALSE@clean-docsrc:
@@ -6895,32 +7293,22 @@ doc-text: doc-text-force doc/text/.sphin
 clean-doc-text:
 	@$(RM) -r doc/text
 
+.PHONY: doc-examples doc-examples-force clean-doc-examples
+doc-examples-force:
+
+doc-examples: doc-examples-force $(GENERATED_EXAMPLES)
+
+clean-doc-examples:
+	@$(RM) $(GENERATED_EXAMPLES)
+
 .PHONY: doc clean-doc
-doc: man doc-html doc-text
+doc: man doc-html doc-text doc-examples
 
-clean-doc: clean-man clean-doc-html clean-doc-text
+clean-doc: clean-man clean-doc-html clean-doc-text clean-doc-examples
 
 .PHONY: clean-local
 clean-local: clean-doc clean-sphinx-cache clean-docsrc
 
-dist-old:: distgit
-	@echo "creating configure"
-	@cd dist/cyrus-imapd-$(PACKAGE_VERSION) ; sh SMakefile
-	@for d in $(DIST_SUBDIRS); \
-	do \
-	(cd dist/cyrus-imapd-$(PACKAGE_VERSION)/$$d; \
-	if [ -f Makefile.dist ]; then \
-	echo "### Making" dist "in" `pwd`; \
-	$(MAKE) $(MFLAGS) YACC='$(YACC)' LEX='$(LEX)' \
-	COMPILE_ET='$(COMPILE_ET)' -f Makefile.dist dist ; \
-	fi) || exit 1; \
-	done
-	@echo "creating tarfile"
-	@cd dist ; tar cf - cyrus-imapd-$(PACKAGE_VERSION) | \
-	gzip -9 > ../cyrus-imapd-$(PACKAGE_VERSION).tar.gz
-	rm -f distgit
-	rm -rf dist
-
 distgit:
 	$(MKDIR_P) dist
 	@echo "checking out the distribution from tag $(PACKAGE_NAME)-$(PACKAGE_VERSION)"
@@ -6929,6 +7317,7 @@ distgit:
 
 dist-hook:
 	find $(top_distdir) -type f -name .sphinx-build.stamp -delete
+	find $(top_distdir) -type f -name .gitignore -delete
 	rm -rf $(top_distdir)/$(SPHINX_CACHE)
 
 VERSION: tools/git-version.sh
@@ -6986,6 +7375,7 @@ install-binsymlinks:
 	for prog in $(libexec_PROGRAMS); do $(LN_S) -f $(libexecdir)/`basename $$prog` $(DESTDIR)$(bindir)/; done
 
 .fig.png:
+	mkdir -p $(@D)
 	fig2dev -L png $< $@
 
 valgrind:
diff -pruN 3.0.13-5/man/arbitron.8 3.2.0-3/man/arbitron.8
--- 3.0.13-5/man/arbitron.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/arbitron.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "ARBITRON" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "ARBITRON" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 arbitron \- Cyrus IMAP documentation
 .
@@ -173,6 +173,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/backupd.8 3.2.0-3/man/backupd.8
--- 3.0.13-5/man/backupd.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/backupd.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "BACKUPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "BACKUPD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 backupd \- Cyrus IMAP documentation
 .
@@ -110,6 +110,6 @@ sync_client(8)
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/chk_cyrus.8 3.2.0-3/man/chk_cyrus.8
--- 3.0.13-5/man/chk_cyrus.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/chk_cyrus.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CHK_CYRUS" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CHK_CYRUS" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 chk_cyrus \- Cyrus IMAP documentation
 .
@@ -106,6 +106,6 @@ imapd.conf(5), master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_backups.8 3.2.0-3/man/ctl_backups.8
--- 3.0.13-5/man/ctl_backups.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ctl_backups.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CTL_BACKUPS" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CTL_BACKUPS" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ctl_backups \- Cyrus IMAP documentation
 .
@@ -177,6 +177,11 @@ With this option, the verification step
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-j
+Produce output in JSON format.  The default is plain text.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Increase the verbosity.  Can be specified multiple times.
 .UNINDENT
@@ -297,6 +302,6 @@ imapd.conf(5),
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_conversationsdb.8 3.2.0-3/man/ctl_conversationsdb.8
--- 3.0.13-5/man/ctl_conversationsdb.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ctl_conversationsdb.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CTL_CONVERSATIONSDB" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CTL_CONVERSATIONSDB" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ctl_conversationsdb \- Cyrus IMAP documentation
 .
@@ -126,6 +126,13 @@ the conversations database for user \fIu
 subset of \fB\-b\fP; in particular it does not create conversations or
 assign messages to conversations.
 .UNINDENT
+.INDENT 0.0
+.TP
+.B \-S
+If given with \fB\-b\fP, allows splitting of conversations during the
+rewrite.   Only do this is changing the maximum conversation size
+and you need to split those existing conversations.
+.UNINDENT
 .SH EXAMPLES
 .sp
 [NB: Examples needed]
@@ -141,6 +148,6 @@ imapd.conf(5), master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_cyrusdb.8 3.2.0-3/man/ctl_cyrusdb.8
--- 3.0.13-5/man/ctl_cyrusdb.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ctl_cyrusdb.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CTL_CYRUSDB" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CTL_CYRUSDB" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ctl_cyrusdb \- Cyrus IMAP documentation
 .
@@ -61,6 +61,12 @@ the associated mailbox files).
 All mailbox files are also checked to make sure the file format
 matches the configured database type in imapd.conf.  If not, the
 file is automatically converted using the same logic as cvt_cyrusdb.
+.sp
+If the \fBreverseacls\fP option in imapd.conf(5) is enabled,
+and the RACL entries do not exist in the database, they will be
+generated.  Conversely, if RACL entries do exist in the database,
+but the \fBreverseacls\fP option is disabled, then the entries will be
+cleaned up.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -119,6 +125,6 @@ cyrus.conf(5), imapd.conf(5), master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_deliver.8 3.2.0-3/man/ctl_deliver.8
--- 3.0.13-5/man/ctl_deliver.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ctl_deliver.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CTL_DELIVER" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CTL_DELIVER" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ctl_deliver \- Cyrus IMAP documentation
 .
@@ -91,6 +91,6 @@ imapd.conf(5), master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_mboxlist.8 3.2.0-3/man/ctl_mboxlist.8
--- 3.0.13-5/man/ctl_mboxlist.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ctl_mboxlist.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CTL_MBOXLIST" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CTL_MBOXLIST" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ctl_mboxlist \- Cyrus IMAP documentation
 .
@@ -35,7 +35,7 @@ Perform operations on the mailbox list d
 .SH SYNOPSIS
 .sp
 .nf
-\fBctl_mboxlist\fP [ \fB\-C\fP \fIconfig\-file\fP ] \fB\-d\fP [ \fB\-x\fP ] [ \fB\-p\fP \fIpartition\fP ] [ \fB\-f\fP \fIfilename\fP ]
+\fBctl_mboxlist\fP [ \fB\-C\fP \fIconfig\-file\fP ] \fB\-d\fP [ \fB\-x\fP ] [\fB\-y\fP] [ \fB\-p\fP \fIpartition\fP ] [ \fB\-f\fP \fIfilename\fP ]
 \fBctl_mboxlist\fP [ \fB\-C\fP \fIconfig\-file\fP ] \fB\-u\fP [ \fB\-f\fP \fIfilename\fP ]
 \fBctl_mboxlist\fP [ \fB\-C\fP \fIconfig\-file\fP ] \fB\-m\fP [ \fB\-a\fP ] [ \fB\-w\fP ] [ \fB\-i\fP ] [ \fB\-f\fP \fIfilename\fP ]
 \fBctl_mboxlist\fP [ \fB\-C\fP \fIconfig\-file\fP ] \fB\-v\fP [ \fB\-f\fP \fIfilename\fP ]
@@ -70,8 +70,14 @@ list (mostly useful when specified with
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-y
+When performing a dump, also list intermediary mailboxes which would
+be hidden from IMAP.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-p partition
-When performing a dump, dump only thise mailboxes that live on
+When performing a dump, dump only those mailboxes that live on
 \fIpartition\fP\&.
 .UNINDENT
 .INDENT 0.0
@@ -103,7 +109,7 @@ mailbox list file with the MUPDATE serve
 .INDENT 0.0
 .TP
 .B \-a
-When used with \fB\-m\fP, assume the local mailboxes file is authoritiative,
+When used with \fB\-m\fP, assume the local mailboxes file is authoritative,
 that is, only change the mupdate server, do not delete any local
 mailboxes.
 .UNINDENT
@@ -215,6 +221,6 @@ imapd.conf(5), master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ctl_zoneinfo.8 3.2.0-3/man/ctl_zoneinfo.8
--- 3.0.13-5/man/ctl_zoneinfo.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/ctl_zoneinfo.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,86 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "CTL_ZONEINFO" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-ctl_zoneinfo \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-perform operations on the zoneinfo database
-.SH SYNOPSIS
-.sp
-.nf
-\fBctl_zoneinfo\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] \fB\-r\fP \fIversion\-string\fP
-.fi
-.SH DESCRIPTION
-.sp
-\fBctl_zoneinfo\fP is used to perform various administrative operations on
-the zoneinfo database.
-.sp
-\fBctl_zoneinfo\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-v
-Enable verbose output.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-r version\-string
-Rebuild the zoneinfo database based on the directory structure of
-\fIconfigdirectory\fP/\fBzoneinfo\fP\&.  The database to be rebuilt will be
-in the default location of \fIconfigdirectory\fP/\fBzoneinfo.db\fP unless
-otherwise specified by the \fIzoneinfo_db_path\fP option in
-imapd.conf(5)\&.  The \fIversion\-string\fP should describe the
-source of the timezone data (e.g. "Olson 2013h") and will be used
-by the \fItimezone\fP module of \fBhttpd(8)\fP\&.
-.UNINDENT
-.SH EXAMPLES
-.sp
-[NB: Examples needed]
-.SH HISTORY
-.sp
-This command was introduced in version 2.5
-.SH FILES
-.sp
-/etc/imapd.conf,
-<configdirectory>/zoneinfo.db
-.SH SEE ALSO
-.sp
-imapd.conf(5), \fBhttpd(8)\fP, master(8)
-.SH AUTHOR
-The Cyrus Team, Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/cvt_cyrusdb.8 3.2.0-3/man/cvt_cyrusdb.8
--- 3.0.13-5/man/cvt_cyrusdb.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cvt_cyrusdb.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CVT_CYRUSDB" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CVT_CYRUSDB" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cvt_cyrusdb \- Cyrus IMAP documentation
 .
@@ -89,6 +89,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_backup.8 3.2.0-3/man/cyr_backup.8
--- 3.0.13-5/man/cyr_backup.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_backup.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_BACKUP" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_BACKUP" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_backup \- Cyrus IMAP documentation
 .
@@ -166,6 +166,6 @@ restore(8)
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_buildinfo.8 3.2.0-3/man/cyr_buildinfo.8
--- 3.0.13-5/man/cyr_buildinfo.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_buildinfo.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_BUILDINFO" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_BUILDINFO" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_buildinfo \- Cyrus IMAP documentation
 .
@@ -66,6 +66,6 @@ Specify one of the following:
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_dbtool.8 3.2.0-3/man/cyr_dbtool.8
--- 3.0.13-5/man/cyr_dbtool.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_dbtool.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_DBTOOL" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_DBTOOL" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_dbtool \- Cyrus IMAP documentation
 .
@@ -125,7 +125,8 @@ is typically a Cyrus "flat" format datab
 database version number (currently 2), a list of "wildmat" patterns
 specifying Cyrus services to be denied, and a text message to be
 displayed to the user upon denial. The service names to be matched are
-those as used in cyrus.conf(5)\&.
+those as used in cyrus.conf(5)\&.  cyr_deny(8)
+provides more convenient way to manage \fIuser_deny.db\fP\&.
 .sp
 \fBNOTE:\fP
 .INDENT 0.0
@@ -173,6 +174,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_deny.8 3.2.0-3/man/cyr_deny.8
--- 3.0.13-5/man/cyr_deny.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_deny.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_DENY" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_DENY" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_deny \- Cyrus IMAP documentation
 .
@@ -45,7 +45,8 @@ deny users access to Cyrus services
 The first synopsis denies user \fIuser\fP access to Cyrus services, the
 second synopsis allows access again.  \fBcyr_deny\fP works by adding an
 entry to the Cyrus \fBuser_deny.db\fP database; the third synopsis lists
-the entries in the database.
+the entries in the database.  The service names to be matched are those
+as used in cyrus.conf(5)\&.
 .sp
 \fBcyr_deny\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
 .SH OPTIONS
@@ -93,6 +94,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_df.8 3.2.0-3/man/cyr_df.8
--- 3.0.13-5/man/cyr_df.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_df.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_DF" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_DF" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_df \- Cyrus IMAP documentation
 .
@@ -73,6 +73,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_expire.8 3.2.0-3/man/cyr_expire.8
--- 3.0.13-5/man/cyr_expire.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_expire.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_EXPIRE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_EXPIRE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_expire \- Cyrus IMAP documentation
 .
@@ -54,14 +54,26 @@ cleanse mailboxes of partially expunged
 .IP \(bu 2
 remove deleted mailboxes (when using the "delayed" delete mode), and
 .IP \(bu 2
-expire entries from conversations databases.
+expire entries from conversations databases, and
+.IP \(bu 2
+archive messages from mailbox.
+.UNINDENT
+.sp
+There are various annotations that \fBcyr_expire\fP respects:
+.INDENT 0.0
+.IP \(bu 2
+\fB/vendor/cmu/cyrus\-imapd/expire\fP which controls the expirations of
+messages
+.IP \(bu 2
+\fB/vendor/cmu/cyrus\-imapd/archive\fP which controls the archival of
+messages
+.IP \(bu 2
+\fB/vendor/cmu/cyrus\-imapd/delete\fP which controls the deletion of
+messages
 .UNINDENT
 .sp
-The expiration of messages is controlled by the
-\fB/vendor/cmu/cyrus\-imapd/expire\fP mailbox annotation which specifies
-the age (in days) of messages in the given mailbox that should be
-deleted.  A value of 0 means that no expiration is to be performed on
-that mailbox.
+These mailbox annotations specify the age(in days) of messages in the
+given mailbox that should be expired/archived/deleted.
 .sp
 The value of the \fB/vendor/cmu/cyrus\-imapd/expire\fP annotation is
 inherited by all children of the mailbox on which it is set, so an
@@ -76,7 +88,8 @@ cyradm(8), and modified using the \fBmbo
 .sp
 Expiration of duplicate delivery database entries for a given mailbox
 is also controlled by the \fB/vendor/cmu/cyrus\-imapd/expire\fP annotation
-which applies to that mailbox.  Unlike message expiration, if no
+which applies to that mailbox.  A value of 0 on the annotation means
+that no expiration is to be performed on that mailbox. Unlike message expiration, if no
 annotation applies to the mailbox then duplicate database entries are
 expired using the value given to the \fB\-E\fP option.
 .sp
@@ -103,6 +116,8 @@ Archive non\-flagged messages older than
 archive partition, allowing mailbox messages to be split between fast
 storage and slow large storage.  Only does anything if
 \fBarchivepartition\-*\fP has been set in your config.
+This value is only used for entries which do not have a
+corresponding \fB/vendonr/cmu/cyrus\-imapd/archive\fP mailbox annotation.
 .sp
 This feature was introduced in version 3.0.
 .UNINDENT
@@ -115,6 +130,8 @@ The value can be a floating point number
 specify the unit of time.  If no suffix, the value is number of days.
 Valid suffixes are \fBd\fP (days), \fBh\fP (hours), \fBm\fP (minutes) and
 \fBs\fP (seconds).
+This value is only used for entries which do not have a
+corresponding \fB/verdor/cmu/cyrus\-imapd/delete\fP mailbox annotation.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -213,6 +230,6 @@ imapd.conf(5), master(8), cyradm(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_info.8 3.2.0-3/man/cyr_info.8
--- 3.0.13-5/man/cyr_info.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_info.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_INFO" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_INFO" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_info \- Cyrus IMAP documentation
 .
@@ -53,19 +53,29 @@ configuring Cyrus easier.
 .INDENT 0.0
 .TP
 .B conf
-Print only the configuration options which are not the same as
-default (regardless of whether you have specified them or not).
+Print the configuration options which have been set to a value
+other than their default, and their value.
+.sp
+With \fB\-s version\fP, configuration options whose behaviour has
+changed since \fIversion\fP will be highlighted.
 .UNINDENT
 .INDENT 0.0
 .TP
-.B conf\-default
-Print all default configuration options, ignoring those set locally.
+.B conf\-all
+Print ALL configuration options and their configured values (including
+those using their default value).  This command shows which options
+will be in effect at runtime.
+.sp
+With \fB\-s version\fP, configuration options which have been added or
+whose behaviour has changed since \fIversion\fP will be highlighted.
 .UNINDENT
 .INDENT 0.0
 .TP
-.B conf\-all
-Print ALL configuration options \- including default options.  This
-command shows which options will be in effect at runtime.
+.B conf\-default
+Print the default values for all available configuration options.
+.sp
+With \fB\-s version\fP, configuration options which have been added or
+whose behaviour has changed since \fIversion\fP will be highlighted.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -96,6 +106,16 @@ Read service specifications from \fIconf
 .B \-n servicename
 Read the configuration as if for the service named \fIname\fP\&.
 .UNINDENT
+.INDENT 0.0
+.TP
+.B \-s version
+Highlight configuration options that have been added or whose behaviour
+has been modified since \fIversion\fP\&.  Use this option after a server upgrade,
+specifying your previous version, to find which options you need to review
+and maybe change before starting up the upgraded server.
+.sp
+For use with the \fBconf\fP, \fBconf\-all\fP, and \fBconf\-default\fP sub\-commands.
+.UNINDENT
 .SH EXAMPLES
 .sp
 .nf
@@ -128,6 +148,6 @@ imapd.conf(5), cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_synclog.8 3.2.0-3/man/cyr_synclog.8
--- 3.0.13-5/man/cyr_synclog.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_synclog.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_SYNCLOG" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_SYNCLOG" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_synclog \- Cyrus IMAP documentation
 .
@@ -149,6 +149,6 @@ imapd.conf(5), sync_client(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyrus.conf.5 3.2.0-3/man/cyrus.conf.5
--- 3.0.13-5/man/cyrus.conf.5	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyrus.conf.5	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYRUS.CONF" "5" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYRUS.CONF" "5" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyrus.conf \- Cyrus IMAP documentation
 .
@@ -161,7 +161,7 @@ interface, and \fIport\fP is either a po
 (as listed in \fB/etc/services\fP).
 .sp
 If \fIhost\fP is missing, 0.0.0.0 (all interfaces) is assumed.  Use
-localhost or 127.0.0.1 to restict access, i.e. when a proxy
+localhost or 127.0.0.1 to restrict access, i.e. when a proxy
 on the same host is front\-ending Cyrus.
 .sp
 Note that on most systems UNIX socket paths are limited to around
@@ -272,8 +272,10 @@ set to 1440. This string argument is opt
 .SS DAEMON
 .sp
 This section lists long running daemons to start before any
-\fBSERVICES\fP are spawned.  They will be shutdown when
-master(8) is exiting.
+\fBSERVICES\fP are spawned.  master(8)  will ensure that
+these processes are running, restarting any process which dies or
+forks. All listed processes will be shutdown when master(8)
+is exiting.
 .sp
 .nf
 \fBcmd=\fP<no default>
@@ -325,6 +327,7 @@ master(8),
 imapd(8),
 pop3d(8),
 lmtpd(8),
+smmapd(8),
 timsieved(8),
 idled(8),
 notifyd(8),
@@ -335,6 +338,6 @@ tls_prune(8),
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/cyr_virusscan.8 3.2.0-3/man/cyr_virusscan.8
--- 3.0.13-5/man/cyr_virusscan.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/cyr_virusscan.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "CYR_VIRUSSCAN" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "CYR_VIRUSSCAN" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 cyr_virusscan \- Cyrus IMAP documentation
 .
@@ -54,9 +54,10 @@ A table of infected messages will be out
 To remove infected messages, use the \fB\-r\fP flag. Infected messages will be expunged
 from the user\(aqs mailbox.
 .sp
-With the notify flag, \fB\-n\fP, notifications will be appended to the inbox of the mailbox owner,
-containing message digest information for the affected mail.  This
-flag is only works in combination with \fB\-r\fP\&.
+With the notify flag, \fB\-n\fP, notifications will be appended to the inbox of
+the mailbox owner, containing message digest information for the affected mail.
+This flag only works in combination with \fB\-r\fP\&.  The notification message
+can by customised by template, for details see \fI\%Notifications\fP below.
 .sp
 \fBcyr_virusscan\fP can be configured to run periodically by cron(8)
 via crontab(5) or your preferred method (i.e. /etc/cron.hourly), or by
@@ -95,6 +96,44 @@ criteria will be treated as infected.
 .B \-v
 Produce more verbose output
 .UNINDENT
+.SH NOTIFICATIONS
+.sp
+When the \fB\-n\fP flag is provided, notifications are sent to mailbox owners
+when infected messages are removed.  One notification is sent per owner,
+containing a digest of each message that was deleted from any of their
+mailboxes.
+.sp
+The default notification subject is "Automatically deleted mail", which
+can be overridden by setting \fBvirusscan_notification_subject\fP in
+imapd.conf(5) to a UTF\-8 value.
+.sp
+Each infected message will be described according to the following template:
+.sp
+.nf
+The following message was deleted from mailbox \(aq%MAILBOX%\(aq
+because it was infected with virus \(aq%VIRUS%\(aq
+
+    Message\-ID: %MSG_ID%
+    Date: %MSG_DATE%
+    From: %MSG_FROM%
+    Subject: %MSG_SUBJECT%
+    IMAP UID: %MSG_UID%
+.fi
+.sp
+To use a custom template, create a UTF\-8 file containing your desired text
+and using the same %\-delimited substitutions as above, and set the
+\fBvirusscan_notification_template\fP option in imapd.conf(5) to
+its path.
+.sp
+The notification message will be properly MIME\-encoded at delivery. Do not
+pre\-encode the template file or the subject!
+.sp
+When \fBcyr_virusscan\fP starts up, if notifications have been requested (with
+the \fB\-n\fP flag), a basic sanity check of the template will be performed
+prior to initialising the antivirus engine.  If it appears that the
+resultant notifications would be undeliverable for some reason,
+\fBcyr_virusscan\fP will exit immediately with an error, rather than risk
+deleting messages without notifying.
 .SH EXAMPLES
 .sp
 .nf
@@ -113,7 +152,7 @@ remove infected messages.
 .INDENT 0.0
 .INDENT 3.5
 Scan mailbox \fIuser/bovik\fP, removing infected messages and append
-notifications to bovik\(aqs inbox.
+notifications to Bovik\(aqs inbox.
 .UNINDENT
 .UNINDENT
 .sp
@@ -139,6 +178,6 @@ imapd.conf(5), master(8), \fI\%ClamAV\fP
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/deliver.8 3.2.0-3/man/deliver.8
--- 3.0.13-5/man/deliver.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/deliver.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "DELIVER" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "DELIVER" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 deliver \- Cyrus IMAP documentation
 .
@@ -120,6 +120,6 @@ lmtpd(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/fetchnews.8 3.2.0-3/man/fetchnews.8
--- 3.0.13-5/man/fetchnews.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/fetchnews.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,109 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "FETCHNEWS" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-fetchnews \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-Retrieve new articles from peer and feed to Cyrus
-.SH SYNOPSIS
-.sp
-.nf
-\fBfetchnews\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-s\fP \fIservername\fP[:\fIport\fP]]
-    [ \fB\-n\fP ] [ \fB\-y\fP ] [ \fB\-w\fP \fIwildmat\fP ] [ \fB\-f\fP \fItstampfile\fP ]
-    [ \fB\-a\fP \fIauthname\fP [ \fB\-p\fP \fIpassword\fP ]] \fIpeername\fP
-.fi
-.SH DESCRIPTION
-.sp
-\fBfetchnews\fP retrieves news articles from a peer news server and
-feeds them to a Cyrus server. \fBfetchnews\fP connects to the peer
-specified by \fIpeername\fP, requests new articles since the time stored in
-\fItstampfile\fP and feeds them to \fIservername\fP\&.
-.sp
-\fBfetchnews\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-s  servername
-Hostname of the Cyrus server (with optional port) to which articles
-should be fed.  Defaults to "localhost:nntp".
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-n
-Don\(aqt use the NEWNEWS command. \fBfetchnews\fP will keep track of the
-high and low water marks for each group and use them to fetch new
-articles.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-y
-Use 4 instead of 2 digits for year. 2\-digits are \fI\%RFC 977\fP \- but not
-y2k\-compliant.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-w  wildmat
-Wildmat pattern specifying which newsgroups to search for new
-articles.  Defaults to "*".
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-f  tstampfile
-File in which to read/write the timestamp of when articles were
-last retrieved.  Defaults to \fB<configdirectory>/newsstamp\fP as
-specified by the configuration options.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-a  authname
-Userid to use for authentication.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p  password
-Password to use for authentication.
-.UNINDENT
-.SH FILES
-.sp
-/etc/imapd.conf
-.SH SEE ALSO
-.sp
-manpage:\fIimapd.conf(5)\fP
-.SH AUTHOR
-The Cyrus Team, Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/fud.8 3.2.0-3/man/fud.8
--- 3.0.13-5/man/fud.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/fud.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "FUD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "FUD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 fud \- Cyrus IMAP documentation
 .
@@ -139,6 +139,6 @@ cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/httpd.8 3.2.0-3/man/httpd.8
--- 3.0.13-5/man/httpd.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/httpd.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,131 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "HTTPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-httpd \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-HTTP server process
-.SH SYNOPSIS
-.sp
-.nf
-\fBhttpd\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-U\fP \fIuses\fP ] [ \fB\-T\fP \fItimeout\fP ] [ \fB\-D\fP ]
-    [ \fB\-s\fP ] [ \fB\-p\fP \fIssf\fP ] [ \fB\-q\fP ]
-.fi
-.SH DESCRIPTION
-.sp
-\fBhttpd\fP is an HTTP server. It accepts commands on its standard input
-and responds on its standard output. It MUST be invoked by
-master(8) with those descriptors attached to a remote client
-connection.
-.sp
-\fBhttpd\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.sp
-If the directory \fB<configdirectory>/log/\fP\fIuser\fP exists, then
-\fBhttpd\fP will create protocol telemetry logs for sessions
-authenticating as \fIuser\fP\&. The telemetry logs will be stored in the
-\fBlog/\fP\fIuser\fP directory with a filename of the \fBhttpd\fP process\-id.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-U  uses
-The maximum number of times that the process should be used for new
-connections before shutting down.  The default is 250.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-T  timeout
-The number of seconds that the process will wait for a new
-connection before shutting down.  Note that a value of 0 (zero)
-will disable the timeout.  The default is 60.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-D
-Run external debugger specified in debug_command.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-s
-Serve HTTP over SSL (https).  All data to and from \fBhttpd\fP
-is encrypted using the Secure Sockets Layer.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p  ssf
-Tell \fBhttpd\fP that an external layer exists.  An \fISSF\fP (security
-strength factor) of 1 means an integrity protection layer exists.
-Any higher SSF implies some form of privacy protection.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-q
-Ignore quotas on DAV appends. This feature was introduced in version 3.0.
-.UNINDENT
-.SH EXAMPLES
-.sp
-\fBhttpd\fP is commonly included in the SERVICES section of
-cyrus.conf(5) like so:
-.sp
-.nf
-SERVICES {
-    imap        cmd="imapd \-U 30" listen="imap" prefork=0
-    imaps       cmd="imapd \-s \-U 30" listen="imaps" prefork=0 maxchild=100
-    lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
-    sieve       cmd="timsieved" listen="sieve" prefork=0
-    notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-    \fBhttpd       cmd="httpd" listen=8080 prefork=1 maxchild=20\fP
-}
-.fi
-.SH HISTORY
-.sp
-A beta release of \fBhttpd\fP was first introduced in the \fIcaldav\fP branch
-of Cyrus in version 2.4.17, and was included in the mainline releases
-beginning in version 2.5.0.
-.sp
-The quota override option, \fB\-q\fP, was introduced with Cyrus version
-3.0.
-.SH FILES
-.sp
-/etc/imapd.conf
-.SH SEE ALSO
-.sp
-imapd.conf(5),
-master(8)
-.SH AUTHOR
-The Cyrus Team, Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/httptest.1 3.2.0-3/man/httptest.1
--- 3.0.13-5/man/httptest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/httptest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "HTTPTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "HTTPTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 httptest \- Cyrus IMAP documentation
 .
@@ -32,24 +32,28 @@ level margin: \\n[rst2man-indent\\n[rst2
 ..
 .sp
 Interactive HTTP test program.
+.sp
+This is actually installed as a hard linked copy of imtest(1)\&.
+.sp
+It allows you to authenticate and send HTTP commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBhttptest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ]
-    [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ]
-    [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+    [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-This is actually installed as a hard linked copy of imtest(1)\&.
-.sp
-\fBhttptest\fP is a utility that allows you to authenticate to a
-HTTP server and interactively issue requests to it. Once
-authenticated you may issue any HTTP request by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an http server. Also those developing HTTP clients
-find it useful.
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -61,23 +65,23 @@ authentication.
 .INDENT 0.0
 .TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBhttp\fP as
-defined in \fB/etc/services\fP\&.
+Port to connect to. If left off this defaults to \fBimap\fP as defined
+in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBhttptest\fP to use \fImechanism\fP for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify one of \fIBasic\fP, \fIDigest\fP, \fINTLM\fP, or
-\fINegotiate\fP (GSS\-SPNEGO).
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
+specified the strongest authentication mechanism supported by the
+server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
+of AUTHENTICATE.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-a  userid
 Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
+This is the userid whose password or credentials will be presented to
+the server for verification.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -85,6 +89,14 @@ to the server for verification.
 Userid to use for authorization; defaults to the current user.
 This is the userid whose identity will be assumed after
 authentication.
+.sp
+\fBNOTE:\fP
+.INDENT 7.0
+.INDENT 3.5
+This is only used with SASL mechanisms that allow proxying
+(e.g. PLAIN, DIGEST\-MD5).
+.UNINDENT
+.UNINDENT
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -121,14 +133,19 @@ attempt to do SSL/TLS session reuse and/
 .INDENT 0.0
 .TP
 .B \-s
-Enable HTTP over SSL (https).
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-q
+Enable IMAP COMPRESSion (after authentication).
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
+Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one\-time password instead of the secret pass\-phrase
+(library generates the correct response).
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -138,12 +155,33 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
-.B \-w
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
 .INDENT 0.0
@@ -154,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 httpd(8)
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/idled.8 3.2.0-3/man/idled.8
--- 3.0.13-5/man/idled.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/idled.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IDLED" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IDLED" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 idled \- Cyrus IMAP documentation
 .
@@ -73,6 +73,6 @@ master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/imapd.8 3.2.0-3/man/imapd.8
--- 3.0.13-5/man/imapd.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/imapd.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IMAPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IMAPD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 imapd \- Cyrus IMAP documentation
 .
@@ -136,6 +136,6 @@ master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/imapd.conf.5 3.2.0-3/man/imapd.conf.5
--- 3.0.13-5/man/imapd.conf.5	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/imapd.conf.5	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IMAPD.CONF" "5" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IMAPD.CONF" "5" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 imapd.conf \- Cyrus IMAP documentation
 .
@@ -77,6 +77,15 @@ Blank lines and lines beginning with \(g
 For boolean and enumerated options, the values \(ga\(gayes\(aq\(aq, \(ga\(gaon\(aq\(aq, \(ga\(gat\(aq\(aq,
 \(ga\(gatrue\(aq\(aq and \(ga\(ga1\(aq\(aq turn the option on, the values \(ga\(gano\(aq\(aq, \(ga\(gaoff\(aq\(aq,
 \(ga\(gaf\(aq\(aq, \(ga\(gafalse\(aq\(aq and \(ga\(ga0\(aq\(aq turn the option off.
+.sp
+Duration options take the form of a number followed by a unit, for example
+\fB32m\fP (32 minutes).  Units are \fBd\fP (days), \fBh\fP (hours), \fBm\fP
+(minutes) and \fBs\fP (seconds).  Multiple units can be combined and will
+be summed together, for example \fB1h30m\fP is equivalent to \fB90m\fP\&.  If
+no unit is specified, an option\-specific backward\-compatible default unit
+is assumed (documented on an option\-by\-option basis).  These are simple time
+units: 1d=24h, 1h=60m, 1m=60s (daylight savings, timezones, leap adjustments,
+etc are not considered).
 .UNINDENT
 .UNINDENT
 .SH FIELD DESCRIPTIONS
@@ -163,6 +172,13 @@ backend (e.g., sasldb), and that the sys
 .UNINDENT
 .UNINDENT
 .sp
+\fBallowdeleted:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Allow access to deleted and expunged data via vendor.cmu\-* access
+.UNINDENT
+.UNINDENT
+.sp
 \fBallownewnews:\fP 0
 .INDENT 0.0
 .INDENT 3.5
@@ -186,6 +202,14 @@ authentication, see the \fItls_required\
 .UNINDENT
 .UNINDENT
 .sp
+\fBallowsetacl:\fP 1
+.INDENT 0.0
+.INDENT 3.5
+Defaults to enabled.  If disabled, disallows the use of the SETACL
+command at all via IMAP.
+.UNINDENT
+.UNINDENT
+.sp
 \fBallowusermoves:\fP 0
 .INDENT 0.0
 .INDENT 3.5
@@ -227,7 +251,7 @@ otherwise go under here
 .INDENT 3.5
 The cyrusdb backend to use for mailbox annotations.
 .sp
-Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -347,6 +371,23 @@ socket.
 .UNINDENT
 .UNINDENT
 .sp
+\fBannotation_callout_disable_append:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Disables annotations on append with xrunannotator
+.UNINDENT
+.UNINDENT
+.sp
+\fBannotation_enable_legacy_commands:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Whether to enable the legacy GETANNOTATION/SETANNOTATION commands.
+These commands are deprecated and will be removed in the future,
+but might be useful in the meantime for supporting old clients that
+do not implement the \fI\%RFC 5464\fP IMAP METADATA extension.
+.UNINDENT
+.UNINDENT
+.sp
 \fBaps_topic:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -378,11 +419,21 @@ mailbox, as distinct from partitions.
 .UNINDENT
 .UNINDENT
 .sp
-\fBarchive_days:\fP 7
+\fBarchive_days:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+Deprecated in favour of \fIarchive_after\fP\&.
+.UNINDENT
+.UNINDENT
+.sp
+\fBarchive_after:\fP 7d
 .INDENT 0.0
 .INDENT 3.5
-The number of days after which to move messages to the archive partition
-if archiving is enabled
+The duration after which to move messages to the archive partition
+if archiving is enabled.
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -496,6 +547,23 @@ Deprecated in favor of \fIautocreate_sub
 .UNINDENT
 .UNINDENT
 .sp
+\fBautocreate_acl:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+If folders are to be created by \fIautocreate_inbox_foldersR, this
+setting can be used to apply additional ACLs to the autocreated
+folders.  The syntax is "autocreate_acl folder identifier rights",
+where **folder\fP must match one of the \fIautocreate_inbox_folders\fP
+folders, \fIidentifier\fP must be a valid cyrus identifier, and
+\fIrights\fP must be a valid cyrus rights string.  Multiple
+identifier|rights pairs can be assigned to a single folder by providing
+this setting multiple times.
+.sp
+For example, "autocreate_acl Plus anyone p" would allow lmtp delivery
+to a folder named "Plus".
+.UNINDENT
+.UNINDENT
+.sp
 \fBautocreate_inbox_folders:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -641,6 +709,14 @@ automatically created.
 .UNINDENT
 .UNINDENT
 .sp
+\fBautoexpunge:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If set to yes, then all Deleted messages will be automatically expunged whenever
+an index is closed, whether CLOSE, UNSELECT, SELECT or on disconnect
+.UNINDENT
+.UNINDENT
+.sp
 \fBbackuppartition\-name:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -687,12 +763,22 @@ will be temp_path/backup
 .UNINDENT
 .UNINDENT
 .sp
-\fBbackup_retention_days:\fP 7
+\fBbackup_retention_days:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+Deprecated in favor of \fIbackup_retention\fP\&.
+.UNINDENT
+.UNINDENT
+.sp
+\fBbackup_retention:\fP 7d
 .INDENT 0.0
 .INDENT 3.5
-The number of days to keep content in backup after it has been deleted
+How long to keep content in backup after it has been deleted
 from the source.  If set to a negative value or zero, deleted content
 will be kept indefinitely.
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -701,7 +787,7 @@ will be kept indefinitely.
 .INDENT 3.5
 The cyrusdb backend to use for the backup locations database.
 .sp
-Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -740,7 +826,14 @@ than any sane message should have.
 \fBcaldav_allowattach:\fP 1
 .INDENT 0.0
 .INDENT 3.5
-Enable managed attachments support on the caldav server.
+Enable managed attachments support on the CalDAV server.
+.UNINDENT
+.UNINDENT
+.sp
+\fBcaldav_allowcalendaradmin:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Enable per\-user calendar administration web UI on the CalDAV server.
 .UNINDENT
 .UNINDENT
 .sp
@@ -757,7 +850,7 @@ Allowed values: \fIoff\fP, \fIon\fP, \fI
 \fBcaldav_create_attach:\fP 1
 .INDENT 0.0
 .INDENT 3.5
-Create the \(aqAttachments\(aq calendar if it doesn\(aqt already exist
+Create the \(aqAttachments\(aq collection if it doesn\(aqt already exist
 .UNINDENT
 .UNINDENT
 .sp
@@ -775,6 +868,20 @@ Create the \(aqInbox\(aq and \(aqOutbox\
 .UNINDENT
 .UNINDENT
 .sp
+\fBcaldav_historical_age:\fP 7d
+.INDENT 0.0
+.INDENT 3.5
+How long after an occurrence of event or task has concluded
+that it is considered \(aqhistorical\(aq.  Changes to historical
+occurrences of events or tasks WILL NOT have invite or reply
+messages sent for them.  A negative value means that events
+and tasks are NEVER considered historical.
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
 \fBcaldav_maxdatetime:\fP 20380119T031407Z
 .INDENT 0.0
 .INDENT 3.5
@@ -823,6 +930,32 @@ default), the value of the "servername"
 .UNINDENT
 .UNINDENT
 .sp
+\fBcalendar_component_set:\fP VEVENT VTODO VJOURNAL VFREEBUSY VAVAILABILITY VPOLL
+.INDENT 0.0
+.INDENT 3.5
+Space\-separated list of iCalendar component types that calendar
+object resources may contain in a calendar collection.
+This restriction is only set at calendar creation time and only
+if the CalDAV client hasn\(aqt specified a restriction in the creation
+request.
+Allowed values: \fIVEVENT\fP, \fIVTODO\fP, \fIVJOURNAL\fP, \fIVFREEBUSY\fP, \fIVAVAILABILITY\fP, \fIVPOLL\fP
+.UNINDENT
+.UNINDENT
+.sp
+\fBcarddav_allowaddmember:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Enable support for POST add\-member on the CardDAV server.
+.UNINDENT
+.UNINDENT
+.sp
+\fBcarddav_allowaddressbookadmin:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Enable per\-user addressbook administration web UI on the CardDAV server.
+.UNINDENT
+.UNINDENT
+.sp
 \fBcarddav_realm:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -870,11 +1003,14 @@ servername will be used.
 .UNINDENT
 .UNINDENT
 .sp
-\fBclient_timeout:\fP 10
+\fBclient_timeout:\fP 10s
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds to wait before returning a timeout failure when
-performing a client connection (e.g., in a murder environment)
+Time to wait before returning a timeout failure when performing a
+client connection (e.g. in a murder environment).
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -925,16 +1061,34 @@ running server, or the counts will be wr
 .INDENT 3.5
 The cyrusdb backend to use for the per\-user conversations database.
 .sp
-Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
-\fBconversations_expire_days:\fP 90
+\fBconversations_expire_days:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+Deprecated in favor of \fIconversations_expire_after\fP\&.
+.UNINDENT
+.UNINDENT
+.sp
+\fBconversations_expire_after:\fP 90d
 .INDENT 0.0
 .INDENT 3.5
 How long the conversations database keeps the message tracking
 information needed for receiving new messages in existing
-conversations, in days.
+conversations.
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBconversations_max_thread:\fP 100
+.INDENT 0.0
+.INDENT 3.5
+maximum size for a single thread.  Threads will split if they have this many
+* messages in them and another message arrives
 .UNINDENT
 .UNINDENT
 .sp
@@ -1001,13 +1155,26 @@ resources (principals).  If not set (the
 .UNINDENT
 .UNINDENT
 .sp
+\fBdav_lock_timeout:\fP 20s
+.INDENT 0.0
+.INDENT 3.5
+The maximum time to wait for a write lock on the per\-user DAV database
+before timeout. For HTTP requests, the HTTP status code 503 is returned
+if the lock can not be obtained within this time.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
 \fBdebug_command:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
 Debug command to be used by processes started with \-D option.  The string
 is a C format string that gets 3 options: the first is the name of the
-executable (without path).  The second is the pid (integer) and the third
-is the service ID.  Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d
+executable (as specified in the cmd parameter in cyrus.conf). The second
+is the pid (integer) and the third is the service ID.
+Example: /usr/local/bin/gdb /usr/cyrus/bin/%s %d
 .UNINDENT
 .UNINDENT
 .sp
@@ -1149,6 +1316,13 @@ File containing the private key for iSch
 .UNINDENT
 .UNINDENT
 .sp
+\fBischedule_dkim_required:\fP 1
+.INDENT 0.0
+.INDENT 3.5
+A DKIM signature is required on received iSchedule requests.
+.UNINDENT
+.UNINDENT
+.sp
 \fBischedule_dkim_selector:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -1163,7 +1337,7 @@ domain.
 .INDENT 3.5
 The cyrusdb backend to use for the duplicate delivery suppression
 and sieve.
-Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -1227,7 +1401,7 @@ Set ALL for any folder
 .INDENT 3.5
 Space\-separated list of extra parameters to add to any appropriated event.
 .sp
-Allowed values: \fIbodyStructure\fP, \fIclientAddress\fP, \fIdiskUsed\fP, \fIflagNames\fP, \fImessageContent\fP, \fImessageSize\fP, \fImessages\fP, \fImodseq\fP, \fIservice\fP, \fItimestamp\fP, \fIuidnext\fP, \fIvnd.cmu.midset\fP, \fIvnd.cmu.unseenMessages\fP, \fIvnd.cmu.envelope\fP, \fIvnd.cmu.sessionId\fP, \fIvnd.cmu.mailboxACL\fP, \fIvnd.cmu.mbtype\fP, \fIvnd.cmu.davFilename\fP, \fIvnd.cmu.davUid\fP, \fIvnd.fastmail.clientId\fP, \fIvnd.fastmail.sessionId\fP, \fIvnd.fastmail.convExists\fP, \fIvnd.fastmail.convUnseen\fP, \fIvnd.fastmail.cid\fP, \fIvnd.fastmail.counters\fP
+Allowed values: \fIbodyStructure\fP, \fIclientAddress\fP, \fIdiskUsed\fP, \fIflagNames\fP, \fImessageContent\fP, \fImessageSize\fP, \fImessages\fP, \fImodseq\fP, \fIservice\fP, \fItimestamp\fP, \fIuidnext\fP, \fIvnd.cmu.midset\fP, \fIvnd.cmu.unseenMessages\fP, \fIvnd.cmu.envelope\fP, \fIvnd.cmu.sessionId\fP, \fIvnd.cmu.mailboxACL\fP, \fIvnd.cmu.mbtype\fP, \fIvnd.cmu.davFilename\fP, \fIvnd.cmu.davUid\fP, \fIvnd.fastmail.clientId\fP, \fIvnd.fastmail.sessionId\fP, \fIvnd.fastmail.convExists\fP, \fIvnd.fastmail.convUnseen\fP, \fIvnd.fastmail.cid\fP, \fIvnd.fastmail.counters\fP, \fIvnd.cmu.emailid\fP, \fIvnd.cmu.threadid\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -1252,29 +1426,31 @@ the \fI\%RFC 5423\fP\&.  If not set, "EV
 .INDENT 0.0
 .INDENT 3.5
 The mode in which messages (and their corresponding cache entries)
-are expunged.  "default" mode is the old behavior in which the
+are expunged.  "semidelayed" mode is the old behavior in which the
 message files are purged at the time of the EXPUNGE, but index
-and cache records are retained to facilitate QRESYNC.  (Note that
-this behaviour is no longer the default, but is so named for historical
-reasons.)  In "delayed" mode, which is the default since Cyrus 2.5.0,
+and cache records are retained to facilitate QRESYNC.
+In "delayed" mode, which is the default since Cyrus 2.5.0,
 the message files are also retained, allowing unexpunge to
 rescue them.  In "immediate" mode, both the message files and the
 index records are removed as soon as possible.  In all cases,
 nothing will be finally purged until all other processes have
 closed the mailbox to ensure they never see data disappear under
-them.  In "default" or "delayed" mode, a later run of "cyr_expire"
+them.  In "semidelayed" or "delayed" mode, a later run of "cyr_expire"
 will clean out the retained records (and possibly message files).
 This reduces the amount of I/O that takes place at the time of
 EXPUNGE and should result in greater responsiveness for the client,
 especially when expunging a large number of messages.
-Allowed values: \fIdefault\fP, \fIimmediate\fP, \fIdelayed\fP
+Allowed values: \fIimmediate\fP, \fIsemidelayed\fP, \fIdelayed\fP
 .UNINDENT
 .UNINDENT
 .sp
-\fBfailedloginpause:\fP 3
+\fBfailedloginpause:\fP 3s
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds to pause after a failed login.
+Time to pause after a failed login.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -1420,15 +1596,18 @@ serve any static content.
 .UNINDENT
 .UNINDENT
 .sp
-\fBhttpkeepalive:\fP 20
+\fBhttpkeepalive:\fP 20s
 .INDENT 0.0
 .INDENT 3.5
-Set the length of the HTTP server\(aqs keepalive heartbeat in seconds.
-The default is 20.  The minimum value is 0, which will disable the
-keepalive heartbeat.  When enabled, if a request takes longer than
-\fIhttpkeepalive\fP seconds to process, the server will send the client
-provisional responses every \fIhttpkeepalive\fP seconds until the
-final response can be sent
+Set the length of the HTTP server\(aqs keepalive heartbeat.  The
+default is 20 seconds.  The minimum value is 0, which will disable
+the keepalive heartbeat.  When enabled, if a request takes longer
+than \fIhttpkeepalive\fP to process, the server will send the client
+provisional responses every \fIhttpkeepalive\fP until the final
+response can be sent.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -1442,7 +1621,7 @@ at compile time due to missing dependenc
 Note that "domainkey" depends on "ischedule" being enabled, and
 that both "freebusy" and "ischedule" depend on "caldav" being
 enabled.
-Allowed values: \fIadmin\fP, \fIcaldav\fP, \fIcarddav\fP, \fIdomainkey\fP, \fIfreebusy\fP, \fIischedule\fP, \fIrss\fP, \fItzdist\fP, \fIwebdav\fP
+Allowed values: \fIadmin\fP, \fIcaldav\fP, \fIcarddav\fP, \fIcgi\fP, \fIdomainkey\fP, \fIfreebusy\fP, \fIischedule\fP, \fIjmap\fP, \fIprometheus\fP, \fIrss\fP, \fItzdist\fP, \fIwebdav\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -1457,12 +1636,15 @@ sent across the wire.
 .UNINDENT
 .UNINDENT
 .sp
-\fBhttptimeout:\fP 5
+\fBhttptimeout:\fP 5m
 .INDENT 0.0
 .INDENT 3.5
-Set the length of the HTTP server\(aqs inactivity autologout timer,
-in minutes.  The default is 5.  The minimum value is 0, which will
+Set the length of the HTTP server\(aqs inactivity autologout timer.
+The default is 5 minutes.  The minimum value is 0, which will
 disable persistent connections.
+.sp
+For backwards compatibility, if no unit is specified, minutes
+is assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -1481,13 +1663,16 @@ the reference argument in LIST or LSUB c
 .UNINDENT
 .UNINDENT
 .sp
-\fBimapidlepoll:\fP 60
+\fBimapidlepoll:\fP 60s
 .INDENT 0.0
 .INDENT 3.5
-The interval (in seconds) for polling for mailbox changes and
-ALERTs while running the IDLE command.  This option is used when
-idled is not enabled or cannot be contacted.  The minimum value is
-1.  A value of 0 will disable IDLE.
+The interval for polling for mailbox changes and ALERTs while running
+the IDLE command.  This option is used when idled is not enabled or
+cannot be contacted.  The minimum value is 1 second.  A value of 0
+will disable IDLE.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -1518,7 +1703,7 @@ the \fI\%RFC 6047\fP\&.  If not set, "IM
 .UNINDENT
 .UNINDENT
 .sp
-\fBimplicit_owner_rights:\fP lkxa
+\fBimplicit_owner_rights:\fP lkxan
 .INDENT 0.0
 .INDENT 3.5
 The implicit Access Control List (ACL) for the owner of a mailbox.
@@ -1549,14 +1734,207 @@ See improved_mboxlist_sort.html.
 .UNINDENT
 .UNINDENT
 .sp
-\fBinternaldate_heuristic:\fP standard
+\fBjmap_emailsearch_db_path:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The absolute path to the JMAP email search cache file.  If not
+specified, JMAP Email/query and Email/queryChanges will not
+cache email search results.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_preview_annot:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The name of the per\-message annotation, if any, to store message
+previews.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_imagesize_annot:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The name of the per\-message annotation, if any, that stores a
+JSON object, mapping message part numbers of MIME image types
+to an array of their image dimensions. The array must have at
+least two entries, where the first entry denotes the width
+and the second entry the height of the image. Any additional
+values are ignored.
+.sp
+For example, if message part 1.2 contains an image of width 300
+and height 200, then the value of this annotation would be:
+.sp
+{ "1.2" : [ 300, 200 ] }
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_inlinedcids_annot:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The name of the per\-message annotation, if any, that stores a
+JSON object, mapping \fI\%RFC 2392\fP Content\-IDs referenced in HTML bodies
+to the respective HTML body part number.
+.sp
+For example, if message part 1.2 contains HTML and references an
+inlined image at "\fI\%cid:foo\fP", then the value of this annotation
+would be:
+.sp
+{ "<foo>" : "1.2" }
+.sp
+Note that the Content\-ID key must be URL\-unescaped and enclosed in
+angular brackets, as defined in \fI\%RFC 2392\fP\&.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_preview_length:\fP 64
+.INDENT 0.0
+.INDENT 3.5
+The maximum byte length of dynamically generated message previews. Previews
+stored in jmap_preview_annot take precedence.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_size_upload:\fP 1048576
+.INDENT 0.0
+.INDENT 3.5
+The maximum size (in kilobytes) that the JMAP API accepts
+for blob uploads. Returned as the maxSizeUpload property
+value of the JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object.
+Default is 1Gb.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_concurrent_upload:\fP 5
+.INDENT 0.0
+.INDENT 3.5
+The value to return for the maxConcurrentUpload property of
+the JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object. The Cyrus JMAP
+implementation does not enforce this rate\-limit.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_size_request:\fP 10240
+.INDENT 0.0
+.INDENT 3.5
+The maximum size (in kilobytes) that the JMAP API accepts
+for requests at the API endpoint. Returned as the
+maxSizeRequest property value of the JMAP "\fI\%urn:ietf:params:jmap:core\fP"
+capabilities object. Default is 10Mb.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_concurrent_requests:\fP 5
+.INDENT 0.0
+.INDENT 3.5
+The value to return for the maxConcurrentRequests property of
+the JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object. The Cyrus JMAP
+implementation does not enforce this rate\-limit.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_calls_in_request:\fP 50
+.INDENT 0.0
+.INDENT 3.5
+The maximum number of calls per JMAP request object.
+Returned as the maxCallsInRequest property value of the
+JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_delayed_send:\fP 512d
+.INDENT 0.0
+.INDENT 3.5
+The value to return for the maxDelayedSend property of
+the JMAP "\fI\%urn:ietf:params:jmap:emailsubmission\fP" capabilities object.
+The Cyrus JMAP implementation does not enforce this limit.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_objects_in_get:\fP 4096
+.INDENT 0.0
+.INDENT 3.5
+The maximum number of ids that a JMAP client may request in
+a single "/get" type method call. The actual number
+of returned objects in the response may exceed this number
+if the JMAP object type supports unbounded "/get" calls.
+Returned as the maxObjectsInGet property value of the
+JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_max_objects_in_set:\fP 4096
+.INDENT 0.0
+.INDENT 3.5
+The maximum number of objects a JMAP client may send to create,
+update or destroy in a single /set type method call.
+Returned as the maxObjectsInSet property value of the
+JMAP "\fI\%urn:ietf:params:jmap:core\fP" capabilities object.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_mail_max_size_attachments_per_email:\fP 10240
+.INDENT 0.0
+.INDENT 3.5
+The value (in kilobytes) to return for the maxSizeAttachmentsPerEmail
+property of the JMAP "\fI\%urn:ietf:params:jmap:mail\fP" capabilities object. The Cyrus
+JMAP implementation does not enforce this size limit. Default is 10 Mb.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_nonstandard_extensions:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If enabled, support non\-standard JMAP extensions.  If not enabled,
+only IETF standard JMAP functionality is supported.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_set_has_attachment:\fP 1
+.INDENT 0.0
+.INDENT 3.5
+If enabled, the $hasAttachment flag is determined and set for new messages
+created with the JMAP Email/set or Email/import methods. This option should
+typically be enabled, but installations using Cyrus\-external message
+annatotors to determine the $hasAttachment flag might want to disable it.
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmap_vacation:\fP 1
+.INDENT 0.0
+.INDENT 3.5
+If enabled, support the JMAP vacation extension
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmapuploadfolder:\fP #jmap
+.INDENT 0.0
+.INDENT 3.5
+the name of the folder for JMAP uploads (#jmap)
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmapsubmission_deleteonsend:\fP 1
+.INDENT 0.0
+.INDENT 3.5
+If enabled (the default) then delete the EmailSubmission as soon as the email
+* has been sent
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmapsubmissionfolder:\fP #jmapsubmission
 .INDENT 0.0
 .INDENT 3.5
-Mechanism to determine email internaldates on delivery/reconstruct.
-"standard" uses time() when delivering a message, mtime on reconstruct.
-"receivedheader" looks at the top most Received header
-or time/mtime otherwise
-Allowed values: \fIstandard\fP, \fIreceivedheader\fP
+the name of the folder for JMAP Submissions (#jmapsubmission)
+.UNINDENT
+.UNINDENT
+.sp
+\fBjmappushsubscriptionfolder:\fP #jmappushsubscription
+.INDENT 0.0
+.INDENT 3.5
+the name of the folder for JMAP Push Subscriptions (#jmappushsubscription)
 .UNINDENT
 .UNINDENT
 .sp
@@ -1645,7 +2023,9 @@ used in the filter string:
 %u   = user
 %U   = user portion of %u (%U = test when %u = \fI\%test@domain.tld\fP)
 %d   = domain portion of %u if available (%d = domain.tld when %u =
-\fI\%%test@domain.tld\fP), otherwise same as %r
+\fI\%test@domain.tld\fP), otherwise same as %R
+%R   = domain portion of %u starting with @ (%R = @domain.tld
+when %u = \fI\%test@domain.tld\fP)
 %D   = user dn.  (use when ldap_member_method: filter)
 %1\-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
 .sp
@@ -1844,17 +2224,23 @@ ldaps:// in \(aqldap_uri\(aq with this o
 .UNINDENT
 .UNINDENT
 .sp
-\fBldap_time_limit:\fP 5
+\fBldap_time_limit:\fP 5s
 .INDENT 0.0
 .INDENT 3.5
-Specify a number of seconds for a search request to complete.
+How long to wait for a search request to complete.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
-\fBldap_timeout:\fP 5
+\fBldap_timeout:\fP 5s
 .INDENT 0.0
 .INDENT 3.5
-Specify a number of seconds a search can take before timing out.
+How long a search can take before timing out.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -1977,6 +2363,18 @@ If enabled, lmtpd will convert the recip
 .UNINDENT
 .UNINDENT
 .sp
+\fBlmtp_exclude_specialuse:\fP \eSnoozed
+.INDENT 0.0
+.INDENT 3.5
+Don\(aqt allow delivery to folders with given special\-use attributes.
+.sp
+Note that "snoozing" of emails can currently only be done via the
+JMAP protocol, so delivery directly to the Snoozed mailbox is
+prohibited by default as it will not be moved back into INBOX
+automatically.
+.UNINDENT
+.UNINDENT
+.sp
 \fBlmtp_fuzzy_mailbox_match:\fP 0
 .INDENT 0.0
 .INDENT 3.5
@@ -2024,13 +2422,25 @@ match the path specified in cyrus.conf(5
 .UNINDENT
 .UNINDENT
 .sp
-\fBlmtptxn_timeout:\fP 300
+\fBlmtptxn_timeout:\fP 5m
 .INDENT 0.0
 .INDENT 3.5
-Timeout (in seconds) used during a lmtp transaction to a remote backend
-(e.g. in a murder environment).  Can be used to prevent hung lmtpds
-on proxy hosts when a backend server becomes unresponsive during a
-lmtp transaction.  The default is 300 \- change to zero for infinite.
+Timeout used during a lmtp transaction to a remote backend (e.g. in a
+murder environment).  Can be used to prevent hung lmtpds on proxy hosts
+when a backend server becomes unresponsive during a lmtp transaction.
+The default is 5 minutes \- change to zero for infinite.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBlock_debugtime:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+A floating point number of seconds.  If set, time how long we wait for
+any lock, and syslog the filename and time if it\(aqs longer than this
+value.  The default of NULL means not to time locks.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2088,6 +2498,20 @@ notifications are disabled.
 .UNINDENT
 .UNINDENT
 .sp
+\fBmaster_bind_errors_fatal:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If enabled, failure to bind a port during startup is treated as a fatal
+error, causing master to shut down immediately.  The default is to keep
+running, with the affected service disabled until the next SIGHUP causes
+it to retry.
+.sp
+Note that this only applies during startup.  New services that fail to
+come up in response to a reconfig+SIGHUP will just be logged and disabled
+like the default behaviour, without causing master to exit.
+.UNINDENT
+.UNINDENT
+.sp
 \fBmaxheaderlines:\fP 1000
 .INDENT 0.0
 .INDENT 3.5
@@ -2143,7 +2567,7 @@ Maximum size of a single word for the pa
 .INDENT 3.5
 The cyrusdb backend to use for mailbox keys.
 .sp
-Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -2152,7 +2576,7 @@ Allowed values: \fIskiplist\fP, \fItwosk
 .INDENT 3.5
 The cyrusdb backend to use for the mailbox list.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -2419,11 +2843,14 @@ will be configdirectory/fetchnews.db
 .UNINDENT
 .UNINDENT
 .sp
-\fBnntptimeout:\fP 3
+\fBnntptimeout:\fP 3m
 .INDENT 0.0
 .INDENT 3.5
-Set the length of the NNTP server\(aqs inactivity autologout timer,
-in minutes.  The minimum value is 3, the default.
+Set the length of the NNTP server\(aqs inactivity autologout timer.
+The minimum value is 3 minutes, also the default.
+.sp
+For backward compatibility, if no unit is specified, minutes is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2486,13 +2913,6 @@ value of the \fBdefaultpartion\fP option
 .UNINDENT
 .UNINDENT
 .sp
-\fBoutbox_sendlater:\fP 0
-.INDENT 0.0
-.INDENT 3.5
-If enabled, any message with a Draft flag will be sent at the time of its INTERNALDATE
-.UNINDENT
-.UNINDENT
-.sp
 \fBpartition_select_mode:\fP freespace\-most
 .INDENT 0.0
 .INDENT 3.5
@@ -2550,13 +2970,16 @@ If all partitions are over that limit, t
 .UNINDENT
 .UNINDENT
 .sp
-\fBplaintextloginpause:\fP 0
+\fBplaintextloginpause:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds to pause after a successful plaintext login.  For
-systems that support strong authentication, this permits users to
-perceive a cost of using plaintext passwords.  (This does not
-affect the use of PLAIN in SASL authentications.)
+Time to pause after a successful plaintext login.  For systems that
+support strong authentication, this permits users to perceive a cost
+of using plaintext passwords.  (This does not affect the use of PLAIN
+in SASL authentications.)
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2570,22 +2993,30 @@ Message to send to client after a succes
 \fBpopexpiretime:\fP \-1
 .INDENT 0.0
 .INDENT 3.5
-The number of days advertised as being the minimum a message may be
+The duration advertised as being the minimum a message may be
 left on the POP server before it is deleted (via the CAPA command,
 defined in the POP3 Extension Mechanism, which some clients may
-support).  "NEVER", the default, may be specified with a negative
-number.  The Cyrus POP3 server never deletes mail, no matter what
-the value of this parameter is.  However, if a site implements a
-less liberal policy, it needs to change this parameter
-accordingly.
+support).  This duration has a granularity of whole days, with partial
+days truncated (so e.g. "45m" is effectively "0d").  "NEVER", the
+default, may be specified with a negative number.
+.sp
+The Cyrus POP3 server never deletes mail, no matter what the value of
+this parameter is.  However, if a site implements a less liberal policy,
+it needs to change this parameter accordingly.
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
-\fBpopminpoll:\fP 0
+\fBpopminpoll:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
 Set the minimum amount of time the server forces users to wait
-between successive POP logins, in minutes.
+between successive POP logins.
+.sp
+For backward compatibility, if no unit is specified, minutes is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2616,11 +3047,14 @@ of the slots.
 .UNINDENT
 .UNINDENT
 .sp
-\fBpoptimeout:\fP 10
+\fBpoptimeout:\fP 10m
 .INDENT 0.0
 .INDENT 3.5
-Set the length of the POP server\(aqs inactivity autologout timer,
-in minutes.  The minimum value is 10, the default.
+Set the length of the POP server\(aqs inactivity autologout timer.
+The minimum value is 10 minutes, the default.
+.sp
+For backward compatibility, if no unit is specified, minutes is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2674,6 +3108,43 @@ used.
 .UNINDENT
 .UNINDENT
 .sp
+\fBprometheus_enabled:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+Whether tracking of service metrics for Prometheus is enabled.
+.UNINDENT
+.UNINDENT
+.sp
+\fBprometheus_need_auth:\fP admin
+.INDENT 0.0
+.INDENT 3.5
+Authentication level required to fetch Prometheus metrics.
+.sp
+Allowed values: \fInone\fP, \fIuser\fP, \fIadmin\fP
+.UNINDENT
+.UNINDENT
+.sp
+\fBprometheus_update_freq:\fP 10s
+.INDENT 0.0
+.INDENT 3.5
+Frequency in at which promstatsd should re\-collate its statistics
+report.  The minimum value is 1 second, the default is 10 seconds.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBprometheus_stats_dir:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+Directory to use for gathering prometheus statistics.  If specified,
+must be an absolute path.  If not specified, the default path
+$configdirectory/stats/ will be used.  It may be advantageous to locate this
+directory on ephemeral storage.
+.UNINDENT
+.UNINDENT
+.sp
 \fBproxy_authname:\fP proxy
 .INDENT 0.0
 .INDENT 3.5
@@ -2763,7 +3234,7 @@ Unix domain socket that ptloader listens
 .INDENT 3.5
 The cyrusdb backend to use for the pts cache.
 .sp
-Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -2775,11 +3246,14 @@ will be configdirectory/ptscache.db
 .UNINDENT
 .UNINDENT
 .sp
-\fBptscache_timeout:\fP 10800
+\fBptscache_timeout:\fP 3h
 .INDENT 0.0
 .INDENT 3.5
-The timeout (in seconds) for the PTS cache database when using the
-auth_krb_pts authorization method (default: 3 hours).
+The timeout for the PTS cache database when using the auth_krb_pts
+authorization method (default: 3 hours).
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -2815,7 +3289,7 @@ Allowed values: \fIcs0\fP, \fIcs1\fP, \f
 .INDENT 3.5
 The cyrusdb backend to use for quotas.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fIquotalegacy\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fIquotalegacy\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -2954,13 +3428,15 @@ wildmat of "*" (ALL mailboxes) will be u
 .UNINDENT
 .UNINDENT
 .sp
-\fBrss_maxage:\fP 0
+\fBrss_maxage:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
-Maximum age (in days) of items to display in an RSS channel.  If
-non\-zero, httpd will only display items received within the last
-\fIrss_maxage\fP days.  If set to 0, all available items will be
-displayed (the default).
+Maximum age of items to display in an RSS channel.  If non\-zero,
+httpd will only display items received within this time period.
+If set to 0, all available items will be displayed (the default).
+.sp
+For backward compatibility, if no unit is specified, days is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3042,6 +3518,68 @@ Note that long batches may delay user co
 .UNINDENT
 .UNINDENT
 .sp
+\fBsearch_attachment_extractor_url:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+A HTTP or HTTPS URL to extract search text from rich text attachments
+and other media during search indexing. The server at this URL must
+implement the following protocol:
+.sp
+1. For each attachment of an email, Cyrus sends a GET request to the
+URL <extractor\-url>/<cyrus\-id>, where <extractor\-url> is the
+configured URL and <cyrus\-id> is a Cyrus\-chosen path segment that
+uniquely identifies this attachment.
+.sp
+2. If the extractor already has a cached plain text extract of the
+attachment identified by <cyrus\-id> then it may return HTTP status
+code 200 (OK) and the plain text extract with a Content\-Type
+"text/plain" header. Otherwise it must return HTTP status 404 (Not Found).
+.sp
+3. If Cyrus receives the HTTP status code 404 (Not Found), then it sends
+a PUT request to the same URL as previously. The PUT request body
+contains the decoded, binary body of the attachment. The Content\-Type
+request header has the same value as declared in the MIME part
+headers, including any type parameters.
+.sp
+4. The extractor must return the plain text extract with either HTTP status
+200 (OK) or 201 (Created) and a Content\-Type "text/plain" header.
+If no text can be extracted, then the extractor may return any return code
+in the range 4xx, or 200 and an empty response body.
+.sp
+Any other HTTP status code is treated as an error. For performance
+reasons, the Cyrus indexer attempts to keep\-alive the TCP connection
+to the extractor.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsearch_index_language:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If enabled, then message bodies and subjects are indexed by their
+detected language, if the cld2 dependency is built into Cyrus.
+Regardless of this flag, bodies and subjects are always indexed and
+searched using the default stemmer.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsearch_index_parts:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If enabled, then message parts are each indexed separately into Xapian
+so that matches can be done by part.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsearch_query_language:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If enabled, then message bodies and subjects searched by their language
+that got detected during indexing, if any.
+Regardless of this flag, bodies and subjects are always searched using
+the default stemmer.
+.UNINDENT
+.UNINDENT
+.sp
 \fBsearch_normalisation_max:\fP 1000
 .INDENT 0.0
 .INDENT 3.5
@@ -3057,7 +3595,7 @@ folders.
 .INDENT 3.5
 The indexing engine used to speed up searching.
 .sp
-Allowed values: \fInone\fP, \fIsquat\fP, \fIsphinx\fP, \fIxapian\fP
+Allowed values: \fInone\fP, \fIsquat\fP, \fIxapian\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3085,9 +3623,9 @@ headers can still be searched, the searc
 \fBsearch_indexed_db:\fP twoskip
 .INDENT 0.0
 .INDENT 3.5
-The cyrusdb backend to use for the search latest indexed uid state.
+The cyrusdb backend to use for the search latest indexed uid state.  Xapian only.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3099,6 +3637,14 @@ of no value means search "forever" until
 .UNINDENT
 .UNINDENT
 .sp
+\fBsearch_queryscan:\fP 5000
+.INDENT 0.0
+.INDENT 3.5
+The minimum number of records require to do a direct scan of all G keys
+* rather than indexed lookups.  A value of 0 means always do indexed lookups.
+.UNINDENT
+.UNINDENT
+.sp
 \fBsearch_skipdiacrit:\fP 1
 .INDENT 0.0
 .INDENT 3.5
@@ -3146,7 +3692,7 @@ generated snippet.
 .INDENT 3.5
 The absolute base path to the search stopword lists. If not specified,
 no stopwords will be taken into account during search indexing. Currently,
-the only supported and default stop word file is english.list.
+the only supported and default stop word file is english.txt.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3172,7 +3718,7 @@ This option MUST be specified for xapian
 .INDENT 3.5
 The cyrusdb backend to use for the seen state.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3184,6 +3730,16 @@ for sending rejections, redirects and va
 .UNINDENT
 .UNINDENT
 .sp
+\fBsendmail_auth_id:\fP CYRUS_SENDMAIL_AUTH_ID
+.INDENT 0.0
+.INDENT 3.5
+The name of an environment variable to set when invoking sendmail.
+The value of this environment variable will contain the user id
+of the currently authenticated user. If no user is authenticated
+the environment variable is not set.
+.UNINDENT
+.UNINDENT
+.sp
 \fBserverlist:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -3290,7 +3846,17 @@ Otherwise, timsieved will proxy traffic
 .UNINDENT
 .UNINDENT
 .sp
-\fBsieve_extensions:\fP fileinto reject vacation vacation\-seconds imapflags notify envelope relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables
+\fBsieve_duplicate_max_expiration:\fP 90d
+.INDENT 0.0
+.INDENT 3.5
+Maximum expiration time for duplicate message tracking records.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsieve_extensions:\fP fileinto reject vacation vacation\-seconds imapflags notify include envelope environment body relational regex subaddress copy date index imap4flags mailbox mboxmetadata servermetadata variables editheader extlists duplicate ihave fcc special\-use redirect\-dsn redirect\-deliverby mailboxid x\-cyrus\-log x\-cyrus\-jmapquery x\-cyrus\-snooze
 .INDENT 0.0
 .INDENT 3.5
 Space\-separated list of Sieve extensions allowed to be used in
@@ -3299,7 +3865,7 @@ previously installed script will be unaf
 will continue to execute regardless of the extensions used.  This
 option has no effect on options that are disabled at compile time
 (e.g., "regex").
-Allowed values: \fIfileinto\fP, \fIreject\fP, \fIvacation\fP, \fIvacation\-seconds\fP, \fIimapflags\fP, \fInotify\fP, \fIinclude\fP, \fIenvelope\fP, \fIbody\fP, \fIrelational\fP, \fIregex\fP, \fIsubaddress\fP, \fIcopy\fP, \fIdate\fP, \fIindex\fP, \fIimap4flags\fP, \fImailbox\fP, \fImboxmetadata\fP, \fIservermetadata\fP, \fIvariables\fP
+Allowed values: \fIfileinto\fP, \fIreject\fP, \fIvacation\fP, \fIvacation\-seconds\fP, \fIimapflags\fP, \fInotify\fP, \fIinclude\fP, \fIenvelope\fP, \fIenvironment\fP, \fIbody\fP, \fIrelational\fP, \fIregex\fP, \fIsubaddress\fP, \fIcopy\fP, \fIdate\fP, \fIindex\fP, \fIimap4flags\fP, \fImailbox\fP, \fImboxmetadata\fP, \fIservermetadata\fP, \fIvariables\fP, \fIeditheader\fP, \fIextlists\fP, \fIduplicate\fP, \fIihave\fP, \fIfcc\fP, \fIspecial\-use\fP, \fIredirect\-dsn\fP, \fIredirect\-deliverby\fP, \fImailboxid\fP, \fIx\-cyrus\-log\fP, \fIx\-cyrus\-jmapquery\fP, \fIx\-cyrus\-snooze\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3336,19 +3902,34 @@ SASL authentication, per draft\-martin\-
 .UNINDENT
 .UNINDENT
 .sp
-\fBsieve_vacation_min_response:\fP 259200 /* 3 days */
+\fBsieve_use_lmtp_reject:\fP 1
 .INDENT 0.0
 .INDENT 3.5
-Minimum time interval (in seconds) between consecutive vacation responses,
-per draft\-ietf\-vacation\-seconds.txt .
+Enabled by default.  If reject can be done via LMTP, then return a 550
+rather than generating the bounce message in Cyrus.
 .UNINDENT
 .UNINDENT
 .sp
-\fBsieve_vacation_max_response:\fP 7776000 /* 90 days */
+\fBsieve_vacation_min_response:\fP 3d
 .INDENT 0.0
 .INDENT 3.5
-Maximum time interval (in seconds) between consecutive vacation responses,
-per draft\-ietf\-vacation\-seconds.txt .
+Minimum time interval between consecutive vacation responses, per
+draft\-ietf\-vacation\-seconds.txt.  The default is 3 days.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsieve_vacation_max_response:\fP 90d
+.INDENT 0.0
+.INDENT 3.5
+Maximum time interval between consecutive vacation responses, per
+draft\-ietf\-vacation\-seconds.txt.  The default is 90 days.  The
+minimum is 7 days.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3413,6 +3994,75 @@ not sync writes to the disk.  Enabling t
 .UNINDENT
 .UNINDENT
 .sp
+\fBsmtp_backend:\fP sendmail
+.INDENT 0.0
+.INDENT 3.5
+The SMTP backend to use for sending email.
+.sp
+The "host" backend sends message submissions via
+a TCP socket to the SMTP host defined in the config
+option smtp_host.
+.sp
+The "sendmail" backend forks the Cyrus process into
+the executable defined in the config option sendmail.
+The executable must accept "\-bs" as command line
+argument, read from stdin and must implement the minimum
+SMTP protocol as defined in section 4.5.1 of \fI\%RFC 5321\fP\&.
+.sp
+If the SMTP EHLO command reports AUTH (\fI\%RFC 4954\fP) as a
+supported extension, then the MAIL FROM command includes
+the AUTH parameter, with its value set to the name of any
+authenticated user which triggered the email. The AUTH
+parameter is omitted if the user is unknown to the calling
+process.
+.sp
+If the directory
+\fIconfigdirectory\fP/log/smtpclient.\fIsmtp_backend\fP
+exists, then telemetry logs for outgoing SMTP sessions will
+be created in this directory.
+.sp
+Allowed values: \fIhost\fP, \fIsendmail\fP
+.UNINDENT
+.UNINDENT
+.sp
+\fBsmtp_host:\fP localhost:587
+.INDENT 0.0
+.INDENT 3.5
+The SMTP host to use for sending mail (also see the
+smtp_backend option). The value of this option must
+the name or IP address of a TCP host, followed optionally
+by a colon and the port or service to use. The default
+port is 587. TLS may be activated by appending "/tls"
+to the value. Authentication is enabled if smtp_auth_authname
+is set. Authentication can be explicitly disabled by appending
+"/noauth" to the host address.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsmtp_auth_authname:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The authentication name to use when authenticating to the SMTP
+server defined in smtp_host.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsmtp_auth_password:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The password to use when authenticating to the SMTP server defined
+in smtp_host.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsmtp_auth_realm:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The authentication SASL realm to use when authenticating to a SMTP
+server.
+.UNINDENT
+.UNINDENT
+.sp
 \fBsoft_noauth:\fP 1
 .INDENT 0.0
 .INDENT 3.5
@@ -3427,7 +4077,7 @@ successfully authenticate.  Otherwise lm
 .INDENT 3.5
 The cyrusdb backend to use for caching sort results (currently only
 used for xconvmultisort)
-Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3442,36 +4092,21 @@ if needed.
 .UNINDENT
 .UNINDENT
 .sp
-\fBspecialusealways:\fP 0
-.INDENT 0.0
-.INDENT 3.5
-If enabled, this option causes LIST and LSUB output to always include
-the XLIST "special\-use" flags
-.UNINDENT
-.UNINDENT
-.sp
-\fBsphinx_text_excludes_odd_headers:\fP 0
-.INDENT 0.0
-.INDENT 3.5
-If enabled, Sphinx will perform a TEXT search as if it matches
-FROM, TO, CC, BCC or SUBJECT but not any other headers.  This
-is contrary to the RFC but a more useful behaviour for most
-users.  Default: disabled.
-.UNINDENT
-.UNINDENT
-.sp
-\fBsphinx_socket:\fP {configdirectory}/socket/sphinx
+\fBspecialuse_protect:\fP \eArchive \eDrafts \eImportant \eJunk \eSent \eTrash
 .INDENT 0.0
 .INDENT 3.5
-Unix domain socket that the Sphinx searchd
-daemons listens on.
+Whitespace separated list of special\-use attributes
+to protect the mailboxes for.  If set, don\(aqt allow
+mailboxes with these special use attributes to be deleted
+or renamed to have a different parent. Default is the built\-in list
 .UNINDENT
 .UNINDENT
 .sp
-\fBsphinx_pidfile:\fP /var/run/sphinx.pid
+\fBspecialusealways:\fP 1
 .INDENT 0.0
 .INDENT 3.5
-File where the Sphinx searchd daemon writes its pid.
+If enabled, this option causes LIST and LSUB output to always include
+the XLIST "special\-use" flags
 .UNINDENT
 .UNINDENT
 .sp
@@ -3519,6 +4154,43 @@ If enabled, a secure connection will be
 .UNINDENT
 .UNINDENT
 .sp
+\fBsrs_alwaysrewrite:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+If true, perform SRS rewriting for ALL forwarding, even when not required.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsrs_domain:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The domain to use in rewritten addresses. This must point only to machines
+which know the encoding secret used by this system. When present, SRS is
+enabled.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsrs_hashlength:\fP 0
+.INDENT 0.0
+.INDENT 3.5
+The hash length to generate in a rewritten address.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsrs_secrets:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+A list of secrets with which to generate addresses.
+.UNINDENT
+.UNINDENT
+.sp
+\fBsrs_separator:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The separator to appear immediately after SRS[01] in rewritten addresses.
+.UNINDENT
+.UNINDENT
+.sp
 \fBsrvtab:\fP <empty string>
 .INDENT 0.0
 .INDENT 3.5
@@ -3543,7 +4215,7 @@ use with caution.
 .INDENT 3.5
 The cyrusdb backend to use for the subscriptions list.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3570,7 +4242,7 @@ Enable/disable the imap status cache.
 .INDENT 3.5
 The cyrusdb backend to use for the imap status cache.
 .sp
-Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3676,13 +4348,16 @@ Prefix with a channel name to only apply
 .UNINDENT
 .UNINDENT
 .sp
-\fBsync_repeat_interval:\fP 1
+\fBsync_repeat_interval:\fP 1s
 .INDENT 0.0
 .INDENT 3.5
-Minimum interval (in seconds) between replication runs in rolling
-replication mode. If a replication run takes longer than this
-time, we repeat immediately.
-Prefix with a channel name to only apply for that channel
+Minimum interval between replication runs in rolling replication
+mode. If a replication run takes longer than this time, we repeat
+immediately.  Prefix with a channel name to only apply for that
+channel.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3695,11 +4370,15 @@ Prefix with a channel name to only apply
 .UNINDENT
 .UNINDENT
 .sp
-\fBsync_timeout:\fP 1800
+\fBsync_timeout:\fP 30m
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds to wait for a response before returning a timeout
-failure when talking to a replication peer (client or server).
+How long to wait for a response before returning a timeout failure
+when talking to a replication peer (client or server).  The minimum
+duration is 3 seconds, the default is 30 minutes.
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3716,7 +4395,14 @@ apply only for that channel
 \fBsyslog_prefix:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
-String to be prepended to the process name in syslog entries.
+String to be prepended to the process name in syslog entries. Can
+be further overridden by setting the $CYRUS_SYSLOG_PREFIX environment
+variable.
+.sp
+Using the $CYRUS_SYSLOG_PREFIX environment variable has the additional
+advantage that it can be set before the \fBimapd.conf\fP is read, so
+errors while reading the config file can be syslogged with the correct
+prefix.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3747,15 +4433,21 @@ connection dead (0 == system default)
 \fBtcp_keepalive_idle:\fP 0
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds a connection must be idle before keepalive
-probes are sent (0 == system default)
+How long a connection must be idle before keepalive probes are sent
+(0 == system default).
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
 \fBtcp_keepalive_intvl:\fP 0
 .INDENT 0.0
 .INDENT 3.5
-Number of seconds between keepalive probes (0 == system default)
+Time between keepalive probes (0 == system default).
+.sp
+For backward compatibility, if no unit is specified, seconds is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3773,22 +4465,27 @@ If true, log by sessionid instead of PID
 .UNINDENT
 .UNINDENT
 .sp
-\fBtimeout:\fP 32
+\fBtimeout:\fP 32m
 .INDENT 0.0
 .INDENT 3.5
-The length of the IMAP server\(aqs inactivity autologout timer,
-in minutes.  The minimum value is 30.  The default is 32 to
-allow a bit of leeway for clients that try to NOOP every 30
-minutes.
+The length of the IMAP server\(aqs inactivity autologout timer.
+The minimum value is 30 minutes.  The default is 32 minutes,
+to allow a bit of leeway for clients that try to NOOP every
+30 minutes.
+.sp
+For backward compatibility, if no unit is specified, minutes
+is assumed.
 .UNINDENT
 .UNINDENT
 .sp
-\fBimapidletimeout:\fP 0
+\fBimapidletimeout:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
-Timeout for idling clients (\fI\%RFC 2177\fP) in minutes. If set to
-zero (the default) or less, the value of "timeout" will be
-used instead.
+Timeout for idling clients (\fI\%RFC 2177\fP).  If not set (the default),
+the value of "timeout" will be used instead.
+.sp
+For backward compatibility, if no unit is specified, minutes
+is assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3846,6 +4543,13 @@ See also Mozilla\(aqs server\-side TLS r
 .UNINDENT
 .UNINDENT
 .sp
+\fBtls_crl_file:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+Path to a file containing the Certificate Revocation List
+.UNINDENT
+.UNINDENT
+.sp
 \fBtls_client_ca_dir:\fP <none>
 .INDENT 0.0
 .INDENT 3.5
@@ -3941,6 +4645,16 @@ offered by the server, when cyrus acts a
 .INDENT 0.0
 .INDENT 3.5
 File containing the certificate, including the full chain, presented to clients.
+Two certificates can be set, e.g RSA and EC, if the filenames are separated with
+comma without spaces.
+.UNINDENT
+.UNINDENT
+.sp
+\fBtls_server_dhparam:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+File containing the DH parameters belonging to the certificate in
+tls_server_cert.
 .UNINDENT
 .UNINDENT
 .sp
@@ -3948,7 +4662,9 @@ File containing the certificate, includi
 .INDENT 0.0
 .INDENT 3.5
 File containing the private key belonging to the certificate in
-tls_server_cert.
+tls_server_cert.  If not set, tls_server_cert must contain both private and
+public key.  Two files with keys can be set, if two certifates are used, in
+which case the files must be separated with comma without spaces
 .UNINDENT
 .UNINDENT
 .sp
@@ -3957,7 +4673,7 @@ tls_server_cert.
 .INDENT 3.5
 The cyrusdb backend to use for the TLS cache.
 .sp
-Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -3969,12 +4685,15 @@ will be configdirectory/tls_sessions.db
 .UNINDENT
 .UNINDENT
 .sp
-\fBtls_session_timeout:\fP 1440
+\fBtls_session_timeout:\fP 24h
 .INDENT 0.0
 .INDENT 3.5
-The length of time (in minutes) that a TLS session will be cached
-for later reuse.  The maximum value is 1440 (24 hours), the
-default.  A value of 0 will disable session caching.
+The length of time that a TLS session will be cached for later
+reuse.  The maximum value is 24 hours, also the default.  A
+value of 0 will disable session caching.
+.sp
+For backward compatibility, if no unit is specified, minutes is
+assumed.
 .UNINDENT
 .UNINDENT
 .sp
@@ -4011,7 +4730,7 @@ The umask value used by various Cyrus IM
 .INDENT 3.5
 The cyrusdb backend to use for the user access list.
 .sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIlmdb\fP
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fIsql\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -4088,6 +4807,24 @@ Allowed values: \fIoff\fP, \fIuserid\fP,
 .UNINDENT
 .UNINDENT
 .sp
+\fBvirusscan_notification_subject:\fP Automatically deleted mail
+.INDENT 0.0
+.INDENT 3.5
+The text used in the subject of email notifications created by
+\fBcyr_virusscan(8)\fP when deleting infected mail.
+.UNINDENT
+.UNINDENT
+.sp
+\fBvirusscan_notification_template:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The absolute path to a file containing a template to use to describe
+infected messages that have been deleted by \fBcyr_virusscan(8)\fP\&.
+See \fBcyr_virusscan(8)\fP for specification of the format of this file.
+If not specified, the builtin default template will be used.
+.UNINDENT
+.UNINDENT
+.sp
 \fBxbackup_enabled:\fP 0
 .INDENT 0.0
 .INDENT 3.5
@@ -4122,9 +4859,9 @@ INBOX, NOT an email address!
 \fBzoneinfo_db:\fP twoskip
 .INDENT 0.0
 .INDENT 3.5
-The cyrusdb backend to use for zoneinfo.
-.sp
-Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIlmdb\fP
+The cyrusdb backend to use for zoneinfo.  This database is used by the
+"tzdist" \fIhttp_modules\fP, and is managed by \fBctl_zoneinfo(8)\fP\&.
+Allowed values: \fIflat\fP, \fIskiplist\fP, \fItwoskip\fP, \fIzeroskip\fP
 .UNINDENT
 .UNINDENT
 .sp
@@ -4136,6 +4873,19 @@ will be configdirectory/zoneinfo.db
 .UNINDENT
 .UNINDENT
 .sp
+\fBzoneinfo_dir:\fP <none>
+.INDENT 0.0
+.INDENT 3.5
+The absolute path to the zoneinfo directory, containing timezone
+definitions as generated by the vzic tool.  If not specified, whatever
+definitions libical finds will be used.
+.sp
+If you are providing a Time Zone Data Distribution Service (i.e. you have
+"tzdist" listed in \fIhttp_modules\fP), then this configuration option MUST
+be specified.
+.UNINDENT
+.UNINDENT
+.sp
 \fBobject_storage_enabled:\fP 0
 .INDENT 0.0
 .INDENT 3.5
@@ -4173,14 +4923,14 @@ features.
 .UNINDENT
 .UNINDENT
 .sp
-\fBopenio_rawx_timeout:\fP 30
+\fBopenio_rawx_timeout:\fP 30s
 .INDENT 0.0
 .INDENT 3.5
 The OpenIO timeout to query to the RAWX services (default 30 sec).
 .UNINDENT
 .UNINDENT
 .sp
-\fBopenio_proxy_timeout:\fP 5
+\fBopenio_proxy_timeout:\fP 5s
 .INDENT 0.0
 .INDENT 3.5
 The OpenIO timeout to query to the PROXY services (default 5 sec).
@@ -4246,6 +4996,6 @@ If enabled, use FastMail style sharing (
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/imclient.3 3.2.0-3/man/imclient.3
--- 3.0.13-5/man/imclient.3	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/imclient.3	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IMCLIENT" "3" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IMCLIENT" "3" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 imclient \- Cyrus IMAP documentation
 .
@@ -312,6 +312,6 @@ IMAP, ACAP, IMSP, Kerberos, Authenticati
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/imtest.1 3.2.0-3/man/imtest.1
--- 3.0.13-5/man/imtest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/imtest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IMTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IMTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 imtest \- Cyrus IMAP documentation
 .
@@ -31,7 +31,7 @@ level margin: \\n[rst2man-indent\\n[rst2
 .in \\n[rst2man-indent\\n[rst2man-indent-level]]u
 ..
 .sp
-Interactive IMAP test program
+Interactive IMAP test program.
 .SH SYNOPSIS
 .sp
 .nf
@@ -129,7 +129,7 @@ attempt to do SSL/TLS session reuse and/
 .INDENT 0.0
 .TP
 .B \-s
-Enable IMAP over SSL (imaps).
+Enable SSL over chosen protocol.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -192,6 +192,6 @@ imapd(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/installsieve.1 3.2.0-3/man/installsieve.1
--- 3.0.13-5/man/installsieve.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/installsieve.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "INSTALLSIEVE" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "INSTALLSIEVE" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 installsieve \- Cyrus IMAP documentation
 .
@@ -75,9 +75,7 @@ defined in \fB/etc/services\fP\&.
 .B \-i  file
 Install a file onto the server. If a script with the same name
 already exists on the server it is overwritten. Upon successfully
-putting the script on the server the script is set active. If
-\fIfile\fP has the extension .script it is chopped when put on the
-server since sieve names may not contain a \(aq.\(aq.
+putting the script on the server the script is set active.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -125,6 +123,6 @@ sieveshell(1)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/ipurge.8 3.2.0-3/man/ipurge.8
--- 3.0.13-5/man/ipurge.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/ipurge.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "IPURGE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "IPURGE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 ipurge \- Cyrus IMAP documentation
 .
@@ -35,7 +35,7 @@ Delete mail from IMAP mailbox or partiti
 .SH SYNOPSIS
 .sp
 .nf
-\fBipurge\fP [ \fB\-f\fP ] [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-x\fP ] [ \fB\-X\fP ] [ \fB\-i\fP ] [ \fB\-s\fP ] [ \fB\-o\fP ] [ \fB\-n\fP ] [ \fB\-v\fP ]
+\fBipurge\fP [ \fB\-f\fP ] [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-x\fP ] [ \fB\-M\fP ] [ \fB\-X\fP ] [ \fB\-i\fP ] [ \fB\-s\fP ] [ \fB\-o\fP ] [ \fB\-n\fP ] [ \fB\-v\fP ]
         [ \fB\-d\fP \fIdays\fP | \fB\-b\fP \fIbytes\fP | \fB\-k\fP \fIKbytes\fP | \fB\-m\fP \fIMbytes\fP ]
         [ \fImailbox\-pattern\fP\&... ]
 .fi
@@ -52,7 +52,7 @@ of \fB\-d\fP, \fB\-b\fP, \fB\-k\fP or \f
 \fIIpurge\fP by default only deletes mail below shared folders, which means
 that mails in mailbox(es) below INBOX.* and user.* stay untouched. Use
 the option \fB\-f\fP to also delete mail in mailbox(es) below these
-folders.
+folders. Use the \fB\-M\fP option to not recurse into the mailboxes.
 .sp
 \fIipurge\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
 .SH OPTIONS
@@ -134,6 +134,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/krb.equiv.5 3.2.0-3/man/krb.equiv.5
--- 3.0.13-5/man/krb.equiv.5	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/krb.equiv.5	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "KRB.EQUIV" "5" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "KRB.EQUIV" "5" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 krb.equiv \- Cyrus IMAP documentation
 .
@@ -67,6 +67,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/lmtpd.8 3.2.0-3/man/lmtpd.8
--- 3.0.13-5/man/lmtpd.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/lmtpd.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "LMTPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "LMTPD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 lmtpd \- Cyrus IMAP documentation
 .
@@ -101,6 +101,6 @@ master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/lmtptest.1 3.2.0-3/man/lmtptest.1
--- 3.0.13-5/man/lmtptest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/lmtptest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "LMTPTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "LMTPTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 lmtptest \- Cyrus IMAP documentation
 .
@@ -32,25 +32,28 @@ level margin: \\n[rst2man-indent\\n[rst2
 ..
 .sp
 Interactive LMTP test program
+.sp
+This is actually installed as a hard link to imtest(1)\&.
+.sp
+It allows you to authenticate and send LMTP commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBlmtptest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
     [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
-    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ]
-    [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-This is actually installed as a hard link to imtest(1)\&.
-.sp
-\fBlmtptest\fP is a utility that allows you to authenticate to a LMTP server
-and interactively issue commands to it. Once authenticated you may
-issue any LMTP command by simply typing it in. It is capable
-of multiple SASL authentication mechanisms and handles encryption
-layers transparently. This utility is often used for testing the
-operation of a lmtp server. Also those developing LMTP clients
-find it useful.
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -62,13 +65,13 @@ authentication.
 .INDENT 0.0
 .TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBlmtp\fP as defined
+Port to connect to. If left off this defaults to \fBimap\fP as defined
 in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBlmtptest\fP to use \fImechanism\fP for authentication. If not
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
 specified the strongest authentication mechanism supported by the
 server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
 of AUTHENTICATE.
@@ -129,6 +132,16 @@ attempt to do SSL/TLS session reuse and/
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-s
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-q
+Enable IMAP COMPRESSion (after authentication).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-c
 Enable challenge prompt callbacks.  This will cause the OTP mechanism
 to ask for the the one\-time password instead of the secret pass\-phrase
@@ -142,11 +155,32 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
@@ -158,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 lmtpd(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/master.8 3.2.0-3/man/master.8
--- 3.0.13-5/man/master.8	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/master.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "MASTER" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "MASTER" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 master \- Cyrus IMAP documentation
 .
@@ -44,8 +44,8 @@ The Cyrus IMAP master process.
 .sp
 \fBmaster\fP is the process that controls all of the Cyrus
 processes. This process is responsible for creating all imapd, pop3d,
-lmtpd and timsieved child processes. This process also initializes the
-Berkeley DB code and performs scheduled cleanup/maintenance.
+lmtpd and sieved child processes. This process also performs scheduled
+cleanup/maintenance.
 .sp
 If this process dies, then no new sessions will be started.
 .sp
@@ -158,6 +158,6 @@ idled(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/mbexamine.8 3.2.0-3/man/mbexamine.8
--- 3.0.13-5/man/mbexamine.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/mbexamine.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "MBEXAMINE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "MBEXAMINE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 mbexamine \- Cyrus IMAP documentation
 .
@@ -129,6 +129,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/mbpath.8 3.2.0-3/man/mbpath.8
--- 3.0.13-5/man/mbpath.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/mbpath.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "MBPATH" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "MBPATH" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 mbpath \- Cyrus IMAP documentation
 .
@@ -35,15 +35,17 @@ Translate mailbox names to filesystem pa
 .SH SYNOPSIS
 .sp
 .nf
-\fBmbpath\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-q\fP ] [ \fB\-s\fP ] [ \fB\-m\fP ] [ \fImailbox\-names\fP\&... ]
+\fBmbpath\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-l\fP ] [ \fB\-m\fP ] [ \fB\-q\fP ] [ \fB\-s\fP ] [ \fB\-u\fP ] [ \fB\-a\fP | \fB\-A\fP | \fB\-M\fP | \fB\-S\fP | \fB\-U\fP ] [ \fImailbox\-names\fP\&... ]
 .fi
 .SH DESCRIPTION
 .sp
 Given a mailbox name or a space separated list of mailbox names,
-\fBmbpath\fP outputs the filesystem path to the mailbox.
+\fBmbpath\fP outputs the filesystem path(s) of the mailbox.  By default,
+the mailboxes\(aq data partition paths are shown (same as \fB\-D\fP).
+See \fI\%Selectors\fP for selecting which filesystem path(s) to output.
 .sp
 \fBmbpath\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&. It uses <configdirectory>/mailboxes.db
-to locate the mailbox on disk.
+to locate the mailboxes on disk.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -52,6 +54,17 @@ Use the specified configuration file \fI
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-l
+Local mailboxes only (exits with error for remote or nonexistent mailboxes)
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-m
+Output the path to the metadata files (if different from the
+message files).  Legacy, use \fB\-M\fP\&.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-q
 Suppress any error output.
 .UNINDENT
@@ -62,9 +75,39 @@ If any error occurs, stop processing the
 .UNINDENT
 .INDENT 0.0
 .TP
-.B \-m
-Output the path to the metadata files (if different from the
-message files).
+.B \-u
+The specified \fImailbox\-names\fP are users, not mailboxes.
+.UNINDENT
+.SH SELECTORS
+.INDENT 0.0
+.TP
+.B \-A
+Show the mailbox archive path
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-D
+Show the mailbox data path (\fIdefault\fP)
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-M
+Show the mailbox metadata path (same as \fB\-m\fP)
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-S
+Show the user sieve scripts path
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-U
+Show the user files path (seen, sub, etc)
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-a
+Show all paths, as if all selectors were specified
 .UNINDENT
 .SH EXAMPLES
 .sp
@@ -73,18 +116,27 @@ message files).
 .fi
 .INDENT 0.0
 .INDENT 3.5
-Display the path for mailbox \fIuser.jsmith\fP\&.
+Display the data path for mailbox \fIuser.jsmith\fP\&.
 .UNINDENT
 .UNINDENT
 .sp
 .nf
-\fBmbpath \-m\fP \fIuser.jsmith\fP
+\fBmbpath \-M\fP \fIuser.jsmith\fP
 .fi
 .INDENT 0.0
 .INDENT 3.5
 Display the metadata path for mailbox \fIuser.jsmith\fP\&.
 .UNINDENT
 .UNINDENT
+.sp
+.nf
+\fBmbpath \-u \-S\fP \fIjsmith\fP
+.fi
+.INDENT 0.0
+.INDENT 3.5
+Display the sieve scripts path for user \fIjsmith\fP\&.
+.UNINDENT
+.UNINDENT
 .SH FILES
 .sp
 /etc/imapd.conf,
@@ -95,6 +147,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/mbtool.8 3.2.0-3/man/mbtool.8
--- 3.0.13-5/man/mbtool.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/mbtool.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "MBTOOL" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "MBTOOL" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 mbtool \- Cyrus IMAP documentation
 .
@@ -100,6 +100,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/mupdatetest.1 3.2.0-3/man/mupdatetest.1
--- 3.0.13-5/man/mupdatetest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/mupdatetest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "MUPDATETEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "MUPDATETEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 mupdatetest \- Cyrus IMAP documentation
 .
@@ -32,33 +32,46 @@ level margin: \\n[rst2man-indent\\n[rst2
 ..
 .sp
 Interactive MUPDATE test program
+.sp
+This is actually installed as a hard linked copy of imtest(1)\&.
+.sp
+It allows you to authenticate and send MUPDATE commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBmupdatetest\fP [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ]
-    [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ]
-    [ \fB\-q\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+    [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-\fBmupdatetest\fP is a utility that allows you to authenticate to a
-MUPDATE server and interactively issue commands to it. Once
-authenticated you may issue any MUPDATE command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of a mupdate server. Note that you must be an admin in
-order to authenticate to an mupdate server.
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
+.B \-t  keyfile
+Enable TLS.  \fIkeyfile\fP contains the TLS public and private keys.
+Specify \fB""\fP to negotiate a TLS encryption layer but not use TLS
+authentication.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBmupdate\fP as
-defined in \fB/etc/services\fP\&.
+Port to connect to. If left off this defaults to \fBimap\fP as defined
+in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBmupdatetest\fP to use \fImechanism\fP for authentication. If not
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
 specified the strongest authentication mechanism supported by the
 server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
 of AUTHENTICATE.
@@ -67,8 +80,8 @@ of AUTHENTICATE.
 .TP
 .B \-a  userid
 Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
+This is the userid whose password or credentials will be presented to
+the server for verification.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -119,15 +132,20 @@ attempt to do SSL/TLS session reuse and/
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-s
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-q
-Enable MUPDATE COMPRESSion (after authentication).
+Enable IMAP COMPRESSion (after authentication).
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
+Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one\-time password instead of the secret pass\-phrase
+(library generates the correct response).
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -137,11 +155,32 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
@@ -153,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 mupdate(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/nntpd.8 3.2.0-3/man/nntpd.8
--- 3.0.13-5/man/nntpd.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/nntpd.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,130 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "NNTPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-nntpd \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-NNTP server process
-.SH SYNOPSIS
-.sp
-.nf
-\fBnntpd\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-U\fP \fIuses\fP ] [ \fB\-T\fP \fItimeout\fP ] [ \fB\-D\fP ]
-    [ \fB\-s\fP ] [ \fB\-r\fP ] [ \fB\-f\fP ] [ \fB\-p\fP \fIssf\fP ]
-.fi
-.SH DESCRIPTION
-.sp
-\fBnntpd\fP is an NNTP server. It accepts commands on its standard input
-and responds on its standard output. It MUST invoked by
-master(8) with those descriptors attached to a remote client
-connection.
-.sp
-\fBnntpd\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.  The optional \fBnewsprefix\fP setting
-specifies a prefix to be prepended to newsgroup names to make the
-corresponding IMAP mailbox names.  The optional \fBnewspostuser\fP
-setting specifies the special userid to be used when constructing the
-\fITo:\fP header address for following up to articles when read via IMAP.
-The optional \fBnewspeer\fP setting specifies the fully qualified hostname
-of the upstream news server to which articles are fed.  The optional
-\fBallownewnews\fP setting enables the NNTP NEWNEWS command.
-.sp
-\fBNOTE:\fP
-.INDENT 0.0
-.INDENT 3.5
-For servers with a large volume of articles, the NEWNEWS command can
-be expensive.
-.UNINDENT
-.UNINDENT
-.sp
-If the directory \fB<configdirectory>/log/\fP\fIuser\fP exists, then
-\fBnntpd\fP will create protocol telemetry logs for sessions
-authenticating as \fIuser\fP\&. The telemetry logs will be stored in the
-\fBlog/\fP\fIuser\fP directory with a filename of the \fBnntpd\fP process\-id.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-U  uses
-The maximum number of times that the process should be used for new
-connections before shutting down.  The default is 250.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-T  timeout
-The number of seconds that the process will wait for a new
-connection before shutting down.  Note that a value of 0 (zero)
-will disable the timeout.  The default is 60.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-D
-Run external debugger specified in debug_command.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-s
-Serve NNTP over SSL (https).  All data to and from \fBnntpd\fP
-is encrypted using the Secure Sockets Layer.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-r
-Only allow NNTP reader commands.  Permitted clients will only be
-allowed to read/post articles.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-f
-Only allow NNTP feeder commands.  Permitted clients will only be
-allowed to feed articles (no reading).
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p  ssf
-Tell \fBnntpd\fP that an external layer exists.  An \fISSF\fP (security
-strength factor) of 1 means an integrity protection layer exists.
-Any higher SSF implies some form of privacy protection.
-.UNINDENT
-.SH FILES
-.sp
-/etc/imapd.conf
-.SH SEE ALSO
-.sp
-imapd.conf(5),
-master(8)
-.SH AUTHOR
-The Cyrus Team, Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/nntptest.1 3.2.0-3/man/nntptest.1
--- 3.0.13-5/man/nntptest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/nntptest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "NNTPTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "NNTPTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 nntptest \- Cyrus IMAP documentation
 .
@@ -31,145 +31,16 @@ level margin: \\n[rst2man-indent\\n[rst2
 .in \\n[rst2man-indent\\n[rst2man-indent-level]]u
 ..
 .sp
-Interactive NNTP test program
-.SH SYNOPSIS
+Interactive NNTP test program.
 .sp
-.nf
-\fBnntptest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ]
-    [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ]
-    [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-q\fP ]
-    [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
-.fi
-.SH DESCRIPTION
+This is actually installed as a hard linked copy of imtest(1)\&.
 .sp
-\fBnntptest\fP is a utility that allows you to authenticate to a
-NNTP server and interactively issue commands to it. Once
-authenticated you may issue any NNTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
-encryption layers transparently. This utility is often used for testing
-the operation of an nntp server. Also those developing NNTP clients
-find it useful.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-t  keyfile
-Enable TLS.  \fIkeyfile\fP contains the TLS public and private keys.
-Specify \fB""\fP to negotiate a TLS encryption layer but not use TLS
-authentication.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p  port
-Port to connect to. If left off this defaults to \fBnntp\fP as
-defined in \fB/etc/services\fP\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-m  mechanism
-Force \fBnntptest\fP to use \fImechanism\fP for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify \fIuser\fP to use the AUTHINFO USER/PASS
-commands instead of AUTHINFO SASL.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-a  userid
-Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-u  userid
-Userid to use for authorization; defaults to the current user.
-This is the userid whose identity will be assumed after
-authentication.
-.sp
-\fBNOTE:\fP
-.INDENT 7.0
-.INDENT 3.5
-This is only used with SASL mechanisms that allow proxying
-(e.g. PLAIN, DIGEST\-MD5).
-.UNINDENT
-.UNINDENT
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-k  num
-Minimum protection layer required.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-l  num
-Maximum protection layer to use (\fB0\fP=none; \fB1\fP=integrity;
-etc).  For example if you are using the KERBEROS_V4 authentication
-mechanism specifying \fB0\fP will force imtest to not use any layer
-and specifying \fB1\fP will force it to use the integrity layer.  By
-default the maximum supported protection layer will be used.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-r  realm
-Specify the \fIrealm\fP to use. Certain authentication mechanisms
-(e.g. DIGEST\-MD5) may require one to specify the realm.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-f  file
-Pipe \fIfile\fP into connection after authentication.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-n  num
-Number of authentication attempts; default = 1.  The client will
-attempt to do SSL/TLS session reuse and/or fast reauth
-(e.g. DIGEST\-MD5), if possible.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-s
-Enable NNTP over SSL (nntps).
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-q
-Enable NNTP COMPRESSion (after authentication)
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-i
-Don\(aqt send an initial client response for SASL mechanisms, even if
-the protocol supports it.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-v
-Verbose. Print out more information than usual.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-w passwd
-Password to use (if not supplied, we will prompt).
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-o  option=value
-Set the SASL \fIoption\fP to \fIvalue\fP\&.
-.UNINDENT
-.SH EXAMPLES
-.SH SEE ALSO
+It allows you to authenticate and send NNTP commands to the server.
 .sp
 nntpd(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/notifyd.8 3.2.0-3/man/notifyd.8
--- 3.0.13-5/man/notifyd.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/notifyd.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "NOTIFYD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "NOTIFYD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 notifyd \- Cyrus IMAP documentation
 .
@@ -128,6 +128,6 @@ cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/pop3d.8 3.2.0-3/man/pop3d.8
--- 3.0.13-5/man/pop3d.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/pop3d.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "POP3D" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "POP3D" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 pop3d \- Cyrus IMAP documentation
 .
@@ -122,6 +122,6 @@ master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/pop3test.1 3.2.0-3/man/pop3test.1
--- 3.0.13-5/man/pop3test.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/pop3test.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "POP3TEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "POP3TEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 pop3test \- Cyrus IMAP documentation
 .
@@ -32,24 +32,28 @@ level margin: \\n[rst2man-indent\\n[rst2
 ..
 .sp
 Interactive POP3 test program.
+.sp
+This is actually installed as a hard linked copy of imtest(1)\&.
+.sp
+It allows you to authenticate and send POP commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBpop3test\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ]
-    [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ]
-    [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+    [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-This is actually installed as a hard linked copy of imtest(1)\&.
-.sp
-\fBpop3test\fP is a utility that allows you to authenticate to a
-POP3 server and interactively issue commands to it. Once
-authenticated you may issue any POP3 command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an pop3 server. Also those developing POP3 clients
-find it useful.
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -61,23 +65,23 @@ authentication.
 .INDENT 0.0
 .TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBpop3\fP as
-defined in \fB/etc/services\fP\&.
+Port to connect to. If left off this defaults to \fBimap\fP as defined
+in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBpop3test\fP to use \fImechanism\fP for authentication. If not
-specified, the strongest authentication mechanism supported by the
-server is chosen.  Specify \fIuser\fP to use the USER/PASS commands
-or \fIapop\fP to use the APOP command instead of AUTH.
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
+specified the strongest authentication mechanism supported by the
+server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
+of AUTHENTICATE.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-a  userid
 Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
+This is the userid whose password or credentials will be presented to
+the server for verification.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -129,14 +133,19 @@ attempt to do SSL/TLS session reuse and/
 .INDENT 0.0
 .TP
 .B \-s
-Enable POP3 over SSL (pop3s).
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-q
+Enable IMAP COMPRESSion (after authentication).
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
+Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one\-time password instead of the secret pass\-phrase
+(library generates the correct response).
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -146,11 +155,32 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
@@ -162,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 pop3d(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/quota.8 3.2.0-3/man/quota.8
--- 3.0.13-5/man/quota.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/quota.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "QUOTA" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "QUOTA" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 quota \- Cyrus IMAP documentation
 .
@@ -35,7 +35,7 @@ Report and optionally fix storage and me
 .SH SYNOPSIS
 .sp
 .nf
-\fBquota\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-d\fP \fIdomain\fP ] [ \fB\-f\fP ] [ \fImailbox\-prefix\fP\&... ]
+\fBquota\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-d\fP \fIdomain\fP ] [ \fB\-f\fP ] [ \fB\-u\fP ] [ \fImailbox\-spec\fP\&... ]
 .fi
 .SH DESCRIPTION
 .sp
@@ -50,14 +50,17 @@ If an optional \fIdomain\fP is specified
 listing (and any inconsistency fixing) is performed only in that domain
 rather than all mailboxes.
 .sp
-If one or more \fImailbox\-prefix\fP arguments are specified, the quota
-listing (and inconsistency fixing) is limited to quota roots with names
-that start with one of the given prefixes.
+If one or more \fImailbox\-spec\fP arguments are specified, these are interpreted
+as mailbox prefixes, and the quota listing (and inconsistency fixing) is
+limited to quota roots with names that start with one of the given prefixes.
+If the \fB\-u\fP is provided, \fImailbox\-spec\fP arguments are instead interpreted
+as userids, and the quota listing (and inconsistency fixing) is limited to
+quota roots for only the specified users.
 .sp
 \fBWARNING:\fP
 .INDENT 0.0
 .INDENT 3.5
-Running \fBquota\fP with both the \fB\-f\fP option and \fImailbox\-prefix\fP
+Running \fBquota\fP with both the \fB\-f\fP option and \fImailbox\-spec\fP
 arguments is not recommended.
 .UNINDENT
 .UNINDENT
@@ -82,6 +85,12 @@ report.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-n
+Check for any inconsistencies in the quota subsystem but don\(aqt actually
+fix them.  Use with \fB\-f\fP and \fB\-q\fP to only see what\(aqs incorrect.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-q
 Operate quietly. If \fB\-f\fP is specified, then don\(aqt print the quota
 values, only print messages when things are changed.
@@ -93,9 +102,15 @@ Output the quota values as JSON for auto
 .UNINDENT
 .INDENT 0.0
 .TP
-.B mailbox\-prefix
-Only report and/or fix quota in mailboxes starting with the
-specified \fImailbox\-prefix\fP\&.
+.B \-u
+Interpret \fImailbox\-spec\fP arguments as userids.  The default is to
+interpret them as mailbox prefixes
+.UNINDENT
+.INDENT 0.0
+.TP
+.B mailbox\-spec
+Only report and/or fix quota in mailboxes matching the specified
+\fImailbox\-spec\fP arguments.  See also \fB\-u\fP\&.
 .UNINDENT
 .SH EXAMPLES
 .sp
@@ -116,6 +131,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Jeroen van Meeuwen (Kolab Systems), Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/reconstruct.8 3.2.0-3/man/reconstruct.8
--- 3.0.13-5/man/reconstruct.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/reconstruct.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "RECONSTRUCT" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "RECONSTRUCT" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 reconstruct \- Cyrus IMAP documentation
 .
@@ -37,7 +37,7 @@ Reconstruct mailboxes
 .nf
 \fBreconstruct\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-p\fP \fIpartition\fP ] [ \fB\-x\fP ] [ \fB\-r\fP ]
     [ \fB\-f\fP ] [ \fB\-U\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ] [ \fB\-G\fP ] [ \fB\-R\fP ] [ \fB\-o\fP ]
-    [ \fB\-O\fP ] [ \fB\-M\fP ] \fImailbox\fP\&...
+    [ \fB\-O\fP ] [ \fB\-M\fP ] [ \fB\-V\fP \fIversion\fP ] \fImailbox\fP\&...
 
 \fBreconstruct\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-p\fP \fIpartition\fP ] [ \fB\-x\fP ] [ \fB\-r\fP ]
     [ \fB\-f\fP ] [ \fB\-U\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ] [ \fB\-G\fP ] [ \fB\-R\fP ] [ \fB\-o\fP ]
@@ -114,7 +114,7 @@ restoring mailboxes from backups.
 .B \-s
 Don\(aqt stat underlying files.  This makes reconstruct run faster, at
 the expense of not noticing some issues (like zero byte files or
-size mistmatches).  "\fBreconstruct \-s\fP" should be quite fast.
+size mismatches).  "\fBreconstruct \-s\fP" should be quite fast.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -232,7 +232,7 @@ files.
 .fi
 .INDENT 0.0
 .INDENT 3.5
-Recusively reconstruct all mailboxes belonging to \fIjsmith\fP,
+Recursively reconstruct all mailboxes belonging to \fIjsmith\fP,
 restoring any directories containing \fBcyrus.header\fP files.
 .UNINDENT
 .UNINDENT
@@ -253,6 +253,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/restore.8 3.2.0-3/man/restore.8
--- 3.0.13-5/man/restore.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/restore.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "RESTORE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "RESTORE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 restore \- Cyrus IMAP documentation
 .
@@ -270,6 +270,6 @@ sync_server(8)
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/sieveshell.1 3.2.0-3/man/sieveshell.1
--- 3.0.13-5/man/sieveshell.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/sieveshell.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "SIEVESHELL" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "SIEVESHELL" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 sieveshell \- Cyrus IMAP documentation
 .
@@ -62,15 +62,16 @@ The following commands are recognized:
 \fB\-u\fP \fIuser\fP, \fB\-\-user\fP=\fIuser\fP
 .INDENT 0.0
 .INDENT 3.5
-The authorization name to request; by default, derived from the
-authentication credentials.
+The user whose mailboxes you want to work on. If not specified, it uses the same
+as \-a.
 .UNINDENT
 .UNINDENT
 .sp
 \fB\-a\fP \fIauthname\fP, \fB\-\-authname\fP=\fIauthname\fP
 .INDENT 0.0
 .INDENT 3.5
-The user to use for authentication (defaults to current user).
+The user to use for authentication. If not specified, it defaults to the
+current login user.
 .UNINDENT
 .UNINDENT
 .sp
@@ -91,8 +92,7 @@ exit when done.
 .SH REFERENCES
 .sp
 [MANAGESIEVE] Martin, T.; "A Protocol for Remotely Managing Sieve
-Scripts", draft\-ietf\-managesieve\-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.
+Scripts", RFC 5804; May 2001
 .SH AUTHOR
 .sp
 Tim Martin <\fI\%tmartin@mirapoint.com\fP>, and the rest of the Cyrus
@@ -100,6 +100,6 @@ team.
 .SH AUTHOR
 The Cyrus Team
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/sivtest.1 3.2.0-3/man/sivtest.1
--- 3.0.13-5/man/sivtest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/sivtest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "SIVTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "SIVTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 sivtest \- Cyrus IMAP documentation
 .
@@ -31,23 +31,29 @@ level margin: \\n[rst2man-indent\\n[rst2
 .in \\n[rst2man-indent\\n[rst2man-indent-level]]u
 ..
 .sp
-Interactive MANAGESIEVE test program
+Interactive MANAGESIEVE test program.
+.sp
+This is actually installed as a hard linked copy of imtest(1)\&.
+.sp
+It allows you to authenticate and send MANAGESIEVE commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBsivtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ]
-    [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ]
-    [ \fB\-n\fP \fInum\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+    [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-\fBsivtest\fP is a utility that allows you to authenticate to a
-MANAGESIEVE server and interactively issue commands to it. Once
-authenticated you may issue any MANAGESIEVE command by simply typing it
-in. It is capable of multiple SASL authentication mechanisms and
-handles encryption layers transparently. This utility is often used for
-testing the operation of a timsieved(8) server. Also those
-developing MANAGESIEVE clients find it useful.
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
+encryption layers transparently. This utility is often used for testing
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -59,14 +65,14 @@ authentication.
 .INDENT 0.0
 .TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBsieve\fP as
-defined in \fB/etc/services\fP\&.
+Port to connect to. If left off this defaults to \fBimap\fP as defined
+in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBsivtest\fP to use \fImechanism\fP for authentication. If not
-specified, the strongest authentication mechanism supported by the
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
+specified the strongest authentication mechanism supported by the
 server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
 of AUTHENTICATE.
 .UNINDENT
@@ -74,8 +80,8 @@ of AUTHENTICATE.
 .TP
 .B \-a  userid
 Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
+This is the userid whose password or credentials will be presented to
+the server for verification.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -126,10 +132,20 @@ attempt to do SSL/TLS session reuse and/
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-s
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-q
+Enable IMAP COMPRESSion (after authentication).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
+Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one\-time password instead of the secret pass\-phrase
+(library generates the correct response).
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -139,11 +155,32 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
@@ -155,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 timsieved(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/smmapd.8 3.2.0-3/man/smmapd.8
--- 3.0.13-5/man/smmapd.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/smmapd.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "SMMAPD" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "SMMAPD" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 smmapd \- Cyrus IMAP documentation
 .
@@ -71,6 +71,21 @@ will disable the timeout.  The default i
 Run external debugger specified in debug_command.
 .UNINDENT
 .SH EXAMPLES
+.sp
+\fBsmmapd\fP is commonly included in the SERVICES section of
+cyrus.conf(5) like so:
+.sp
+.nf
+SERVICES {
+    imap        cmd="imapd \-U 30" listen="imap" prefork=0
+    imaps       cmd="imapd \-s \-U 30" listen="imaps" prefork=0 maxchild=100
+    lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
+    \fBsmmap       cmd="smmapd" listen="/var/run/cyrus/socket/smmap" prefork=0\fP
+    sieve       cmd="timsieved" listen="sieve" prefork=0
+    notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
+    httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
+}
+.fi
 .SH FILES
 .sp
 /etc/imapd.conf,
@@ -82,6 +97,6 @@ cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/smtptest.1 3.2.0-3/man/smtptest.1
--- 3.0.13-5/man/smtptest.1	2019-12-16 04:19:11.000000000 +0000
+++ 3.2.0-3/man/smtptest.1	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "SMTPTEST" "1" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "SMTPTEST" "1" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 smtptest \- Cyrus IMAP documentation
 .
@@ -31,23 +31,29 @@ level margin: \\n[rst2man-indent\\n[rst2
 .in \\n[rst2man-indent\\n[rst2man-indent-level]]u
 ..
 .sp
-Interactive SMTP test program
+Interactive SMTP test program.
+.sp
+This is actually installed as a hard linked copy of imtest(1)\&.
+.sp
+It allows you to authenticate and send SMTP commands to the server.
 .SH SYNOPSIS
 .sp
 .nf
-\fBsmtptest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ] [ \fB\-a\fP \fIuserid\fP ]
-    [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ] [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ]
-    [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-v\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
+\fBimtest\fP [ \fB\-t\fP \fIkeyfile\fP ] [ \fB\-p\fP \fIport\fP ] [ \fB\-m\fP \fImechanism\fP ]
+    [ \fB\-a\fP \fIuserid\fP ] [ \fB\-u\fP \fIuserid\fP ] [ \fB\-k\fP \fInum\fP ] [ \fB\-l\fP \fInum\fP ]
+    [ \fB\-r\fP \fIrealm\fP ] [ \fB\-f\fP \fIfile\fP ] [ \fB\-n\fP \fInum\fP ] [ \fB\-s\fP ] [ \fB\-q\fP ]
+    [ \fB\-c\fP ] [ \fB\-i\fP ] [ \fB\-z\fP ] [ \fB\-v\fP ] [ \fB\-I\fP \fIfile\fP ] [ \fB\-x\fP \fIfile\fP ]
+    [ \fB\-X\fP \fIfile\fP ] [ \fB\-w\fP \fIpasswd\fP ] [ \fB\-o\fP \fIoption\fP=\fIvalue\fP ] \fIhostname\fP
 .fi
 .SH DESCRIPTION
 .sp
-\fBsmtptest\fP is a utility that allows you to authenticate to an
-SMTP server and interactively issue commands to it. Once
-authenticated you may issue any SMTP command by simply typing it in.
-It is capable of multiple SASL authentication mechanisms and handles
+\fBimtest\fP is a utility that allows you to authenticate to a IMAP or
+IMSP server and interactively issue commands to it. Once authenticated
+you may issue any IMAP or IMSP command by simply typing it in. It is
+capable of multiple SASL authentication mechanisms and handles
 encryption layers transparently. This utility is often used for testing
-the operation of an SMTP server. Also those developing SMTP clients
-find it useful.
+the operation of a imsp or imap server. Also those developing IMAP
+clients find it useful.
 .SH OPTIONS
 .INDENT 0.0
 .TP
@@ -59,14 +65,14 @@ authentication.
 .INDENT 0.0
 .TP
 .B \-p  port
-Port to connect to. If left off this defaults to \fBsmtp\fP as
-defined in \fB/etc/services\fP\&.
+Port to connect to. If left off this defaults to \fBimap\fP as defined
+in \fB/etc/services\fP\&.
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-m  mechanism
-Force \fBsmtptest\fP to use \fImechanism\fP for authentication. If not
-specified, the strongest authentication mechanism supported by the
+Force \fBimtest\fP to use \fImechanism\fP for authentication. If not
+specified the strongest authentication mechanism supported by the
 server is chosen.  Specify \fIlogin\fP to use the LOGIN command instead
 of AUTHENTICATE.
 .UNINDENT
@@ -74,8 +80,8 @@ of AUTHENTICATE.
 .TP
 .B \-a  userid
 Userid to use for authentication; defaults to the current user.
-This is the userid whose password or credentials will be presented
-to the server for verification.
+This is the userid whose password or credentials will be presented to
+the server for verification.
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -127,14 +133,19 @@ attempt to do SSL/TLS session reuse and/
 .INDENT 0.0
 .TP
 .B \-s
-Enable SMTP over SSL (smtps).
+Enable SSL over chosen protocol.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-q
+Enable IMAP COMPRESSion (after authentication).
 .UNINDENT
 .INDENT 0.0
 .TP
 .B \-c
-Enable challenge prompt callbacks.  This will cause the OTP
-mechanism to ask for the the one\-time password instead of the
-secret pass\-phrase (library generates the correct response).
+Enable challenge prompt callbacks.  This will cause the OTP mechanism
+to ask for the the one\-time password instead of the secret pass\-phrase
+(library generates the correct response).
 .UNINDENT
 .INDENT 0.0
 .TP
@@ -144,11 +155,32 @@ the protocol supports it.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-I  file
+Echo the PID of the running process into \fIfile\fP (This can be useful
+with \-X).
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Verbose. Print out more information than usual.
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-z
+Timing test.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-x  file
+Open the named socket for the interactive portion.
+.UNINDENT
+.INDENT 0.0
+.TP
+.B \-X  file
+Like \-x, only close all file descriptors & daemonize the process.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-w passwd
 Password to use (if not supplied, we will prompt).
 .UNINDENT
@@ -160,10 +192,12 @@ Set the SASL \fIoption\fP to \fIvalue\fP
 .SH EXAMPLES
 .SH SEE ALSO
 .sp
+imapd(8)
+.sp
 \fBsendmail(8)\fP
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/squatter.8 3.2.0-3/man/squatter.8
--- 3.0.13-5/man/squatter.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/squatter.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "SQUATTER" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "SQUATTER" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 squatter \- Cyrus IMAP documentation
 .
@@ -39,13 +39,12 @@ general:
 \fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [\fBmode\fP] [\fBoptions\fP] [\fBsource\fP]
 
 i.e.:
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-S\fP \fIseconds\fP ]
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-i\fP ] [ \fB\-N\fP \fIname\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-r\fP ]  \fImailbox\fP\&...
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-i\fP ] [ \fB\-N\fP \fIname\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-r\fP ]  \fB\-u\fP \fIuser\fP\&...
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] \fB\-R\fP [ \fB\-n\fP \fIchannel\fP ] [ \fB\-d\fP ] [ \fB\-S\fP \fIseconds\fP ]
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] \fB\-f\fP \fIsynclogfile\fP [ \fB\-S\fP \fIseconds\fP ]
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] \fB\-I\fP \fIfile\fP
-\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] \fB\-t\fP \fIsrctier(s)\fP\&... \fB\-z\fP \fIdesttier\fP [ \fB\-F\fP ] [ \fB\-T\fP \fIdir\fP ] [ \fB\-X\fP ] [ \fB\-o\fP ]  [ \fB\-S\fP \fIseconds\fP ] [ \fB\-u\fP \fIuser\fP\&... ]
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-Z\fP ]
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-i\fP ] [ \fB\-N\fP \fIname\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-r\fP ] [ \fB\-Z\fP ] \fImailbox\fP\&...
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] [ \fB\-i\fP ] [ \fB\-N\fP \fIname\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-r\fP ] [ \fB\-Z\fP ] \fB\-u\fP \fIuser\fP\&...
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] \fB\-R\fP [ \fB\-n\fP \fIchannel\fP ] [ \fB\-d\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-Z\fP ]
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-a\fP ] \fB\-f\fP \fIsynclogfile\fP [ \fB\-S\fP \fIseconds\fP ] [ \fB\-Z\fP ]
+\fBsquatter\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] \fB\-t\fP \fIsrctier(s)\fP\&... \fB\-z\fP \fIdesttier\fP [ \fB\-F\fP ] [ \fB\-U\fP ] [ \fB\-T\fP \fIdir\fP ] [ \fB\-X\fP ] [ \fB\-o\fP ] [ \fB\-S\fP \fIseconds\fP ] [ \fB\-u\fP \fIuser\fP\&... ]
 .fi
 .SH DESCRIPTION
 .sp
@@ -68,7 +67,7 @@ The index is a unified index of all of t
 of each message in a given mailbox.  This index is used to significantly
 reduce IMAP SEARCH times on a mailbox.
 .sp
-\fBmode\fP is one of indexer, indexfrom (\-I), search, rolling, synclog or compact.
+\fBmode\fP is one of indexer, search, rolling, synclog, compact or audit.
 .sp
 By default, \fBsquatter\fP creates an index of ALL messages in the
 mailbox, not just those since the last time that it was run.  The
@@ -103,20 +102,27 @@ In the fifth synopsis, \fBsquatter\fP re
 performs incremental indexing on the mailbox(es) listed therein.  This
 is sometimes useful for cleaning up after problems with rolling mode.
 .sp
-In the sixth synopsis, \fBsquatter\fP reads \fIfile\fP containing \fImailbox\fP
-\fIuid\fP tuples and performs indexing on the specified messages.
-.sp
-In the seventh synopsis, \fBsquatter\fP will compact indices from
+In the sixth synopsis, \fBsquatter\fP will compact indices from
 \fIsrctier(s)\fP to \fIdesttier\fP, optionally reindexing (\fB\-X\fP) or filtering
-expunged records (\fB\-F\fP) in the process.  The optional \fB\-T\fP flag may
-be used to specify a directory to use for temporary files.  The \fB\-o\fP
-flag may be used to direct that a single index be copied, rather than
-compacted, from \fIsrctier\fP to \fIdesttier\fP\&.  The \fB\-u\fP flag may be used
-to restrict operation to the specified user(s).
+expunged records (\fB\-F\fP) in the process.  The optional \fB\-T\fP flag may be
+used to specify a directory to use for temporary files.  These files are
+eventually copied with \fIrsync \-a\fP and then removed by \fIrm\fP\&.
+\fIrsync\fP can increase the load average of the system, especially when the
+temporary directory is on \fItmpfs\fP\&.  To throttle \fIrsync\fP it is possible to
+modify the call in \fIimap/search_xapian.c\fP and pass \fI\-\e\-bwlimit=<number>\fP as further
+parameter.  The \fB\-o\fP flag may be used to direct that a single index be
+copied, rather than compacted, from \fIsrctier\fP to \fIdesttier\fP\&.  The \fB\-u\fP flag
+may be used to restrict operation to the specified user(s).
 .sp
-For all modes, the \fB\-S\fP option may be specified, causing squatter to
+For all modes, the \fB\-S\fP option may be specified, causing \fBsquatter\fP to
 pause \fIseconds\fP seconds after each mailbox, to smooth loads.
 .sp
+When using the Xapian engine the \fB\-Z\fP option may be specified, for
+the indexing modes.  This tells \fBsquatter\fP to consult the Xapian
+internally indexed GUIDs, rather than relying on what\(aqs stored in
+\fIcyrus.indexed.db\fP, allowing for recovery from broken
+\fIcyrus.indexed.db\fP at the sacrifice of efficiency.
+.sp
 \fBNOTE:\fP
 .INDENT 0.0
 .INDENT 3.5
@@ -158,6 +164,12 @@ implicit value of \fI/vendor/cmu/cyrus\-
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-A
+Missing documentation, starts audit mode.
+This feature is only available on the master branch.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-d
 In rolling mode, don\(aqt background and do emit log messages on
 standard error.  Useful for debugging.
@@ -185,12 +197,6 @@ Display this usage information.
 .UNINDENT
 .INDENT 0.0
 .TP
-.B \-I file
-Read from \fIfile\fP and index individual messages described by
-mailbox/uid tuples contained therein.
-.UNINDENT
-.INDENT 0.0
-.TP
 .B \-i
 Incremental updates where indexes already exist.
 .UNINDENT
@@ -218,6 +224,12 @@ This feature was introduced in version 3
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-P
+Missing documentation, reindex parts mode.
+This feature is only available on the master branch.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-R
 Run in rolling mode; \fBsquatter\fP runs as a daemon listening to a
 sync log channel and continuously incrementally indexing mailboxes.
@@ -251,7 +263,7 @@ This feature was introduced in version 3
 .INDENT 0.0
 .TP
 .B \-t srctier...
-In compact mode, the comma separated source tier(s) for the compacted
+In compact mode, the comma\-separated source tier(s) for the compacted
 indices.  At least one source tier must be specified in compact mode.
 Xapian only.
 This feature was introduced in version 3.0.
@@ -265,6 +277,13 @@ This feature was introduced in version 3
 .UNINDENT
 .INDENT 0.0
 .TP
+.B \-U
+In compact mode, only compact if re\-indexing.
+Xapian only.
+This feature is only available on the master branch.
+.UNINDENT
+.INDENT 0.0
+.TP
 .B \-v
 Increase the verbosity of progress/status messages.  Sometimes additional messages
 are emitted on the terminal with this option and the messages are unconditionally sent
@@ -288,6 +307,16 @@ This must be specified in compact mode.
 Xapian only.
 This feature was introduced in version 3.0.
 .UNINDENT
+.INDENT 0.0
+.TP
+.B \-Z
+When indexing messages, use the Xapian internal cyrusid rather than
+referencing the ranges of already indexed messages to know if a
+particular message is indexed.  Useful if the ranges get out of
+sync with the actual messages (e.g. if files on a tier are lost)
+Xapian only.
+This feature is only available on the master branch.
+.UNINDENT
 .SH EXAMPLES
 .sp
 \fBsquatter\fP is typically deployed via entries in
@@ -404,6 +433,6 @@ imapd.conf(5), cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/sync_client.8 3.2.0-3/man/sync_client.8
--- 3.0.13-5/man/sync_client.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/sync_client.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,223 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "SYNC_CLIENT" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-sync_client \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-Client side of the synchronization (replication) engine
-.SH SYNOPSIS
-.sp
-.nf
-\fBsync_client\fP [ \fB\-v\fP ] [ \fB\-l\fP ] [ \fB\-L\fP ] [ \fB\-z\fP ] [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-S\fP \fIserver\-name\fP ]
-    [ \fB\-f\fP \fIinput\-file\fP ] [ \fB\-F\fP \fIshutdown_file\fP ] [ \fB\-w\fP \fIwait_interval\fP ]
-    [ \fB\-t\fP \fItimeout\fP ] [ \fB\-d\fP \fIdelay\fP ] [ \fB\-r\fP ] [ \fB\-n\fP \fIchannel\fP ] [ \fB\-u\fP ] [ \fB\-m\fP ]
-    [ \fB\-p\fP \fIpartition\fP ] [ \fB\-A\fP ] [ \fB\-s\fP ] [ \fB\-O\fP ] \fIobjects\fP\&...
-.fi
-.SH DESCRIPTION
-.sp
-\fBsync_client\fP is the client side of the replication system.  It runs
-on the client (master) system and connects to the target (replica)
-system and generates an appropriate sequence of transactions to
-synchronize the replica system with the master system.
-.sp
-\fBsync_client\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-A
-All users mode.
-Sync every user on the server to the replica (doesn\(aqt do non\-user
-mailboxes at all... this could be considered a bug and maybe it
-should do those mailboxes independently)
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-d delay
-Minimum delay between replication runs in rolling replication mode.
-Larger values provide better efficiency as transactions can be
-merged. Smaller values mean that the replica system is more up to
-date and that you don\(aqt end up with large blocks of replication
-transactions as a single group. Default: 3 seconds.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-f input\-file
-In mailbox or user replication mode: provides list of users or
-mailboxes to replicate.  In rolling replication mode, specifies an
-alternate log file (\fBsync_client\fP will exit after processing the
-log file).
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-F shutdown\-file
-Rolling replication checks for this file at the end of each
-replication cycle and shuts down if it is present. Used to request
-a nice clean shutdown at the first convenient point. The file is
-removed on shutdown. Overrides \fBsync_shutdown_file\fP option in
-imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-l
-Verbose logging mode.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-L
-Perform only local mailbox operations (do not do mupdate operations).
-This feature was introduced in version 3.0.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-m
-Mailbox mode.
-Remaining arguments are list of mailboxes which should be replicated.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-n channel
-Use the named channel for rolling replication mode.  If multiple
-channels are specified in \fBsync_log_channels\fP then use one of them.
-This option is probably best combined with \fB\-S\fP to connect to a
-different server with each channel.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-o
-Only attempt to connect to the backend server once rather than
-waiting up to 1000 seconds before giving up.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-O
-No copyback mode. Replication will stop if the replica reports a CRC
-error, rather than doing a full mailbox sync. Useful if moving users to a
-new server, where you don\(aqt want any errors to cause the source servers
-to change the account.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p partition
-In mailbox or user replication mode: provides the name of the
-partition on the replica to which the mailboxes/users should be
-replicated.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-r
-Rolling (repeat) replication mode. Pick up a list of actions
-recorded by the lmtpd(8), imapd(8),
-pop3d(8) and nntpd(8) daemons from the file
-specified in \fBsync_log_file\fP\&. Repeat until \fBsync_shutdown_file\fP
-appears.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-s
-Sieve mode.
-Remaining arguments are list of users whose Sieve files should be
-replicated. Principally used for debugging purposes: not exposed to
-\fI\%sync_client(8)\fP\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-S servername
-Tells \fBsync_client\fP with which server to communicate.  Overrides
-the \fBsync_host\fP configuration option.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-t timeout
-Timeout for single replication run in rolling replication.
-\fBsync_client\fP will negotiate a restart after this many seconds.
-Default: 600 seconds
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-u
-User mode.
-Remaining arguments are list of users who should be replicated.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-v
-Verbose mode.  Use twice (\fB\-v \-v\fP) to log all protocol traffic to
-stderr.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-w interval
-Wait this long before starting. This option is typically used so
-that we can attach a debugger to one end of the replication system
-or the other.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-z
-Require compression.
-The replication protocol will always try to enable deflate
-compression if both ends support it.  Set this flag when you want
-to abort if compression is not available.
-.UNINDENT
-.SH EXAMPLES
-.sp
-On a replication master, the following would be added to the START
-section of cyrus.conf(5):
-.INDENT 0.0
-.INDENT 3.5
-.sp
-.nf
-syncclient              cmd="/usr/lib/cyrus/bin/sync_client \-r"
-.fi
-.UNINDENT
-.UNINDENT
-.sp
-[NB: More examples needed]
-.SH HISTORY
-.sp
-The \fB\-L\fP feature, local updates only, was added in version 3.0.
-.SH FILES
-.sp
-/etc/imapd.conf
-.SH SEE ALSO
-.sp
-sync_server(8), cyrus.conf(5),
-imapd.conf(5), master(8)
-.SH AUTHOR
-The Cyrus Team, David Carter (dpc22@cam.ac.uk), Ken Murchison (ken@oceana.com), Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/sync_reset.8 3.2.0-3/man/sync_reset.8
--- 3.0.13-5/man/sync_reset.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/sync_reset.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,76 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "SYNC_RESET" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-sync_reset \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-Account reset utility. DANGER.
-.SH SYNOPSIS
-.sp
-.nf
-\fBsync_reset\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-v\fP ] [ \fB\-f\fP ]
-.fi
-.SH DESCRIPTION
-.sp
-\fBsync_reset\fP is a small utility program to destroy user accounts on a
-system.  The only safeguard which is in place is the obligary force
-option.
-.sp
-\fBsync_reset\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-v
-Verbose mode.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-f
-Force operation. Without this flag \fBsync_reset\fP just bails out with
-an error.  Principally here to try and prevent accidents with command
-autorepeat.
-.UNINDENT
-.SH FILES
-.sp
-/etc/imapd.conf
-.SH SEE ALSO
-.sp
-imapd.conf(5)
-.SH AUTHOR
-The Cyrus Team, David Carter (dpc22@cam.ac.uk), Ken Murchison (ken@oceana.com), Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/sync_server.8 3.2.0-3/man/sync_server.8
--- 3.0.13-5/man/sync_server.8	2019-12-16 04:19:13.000000000 +0000
+++ 3.2.0-3/man/sync_server.8	1970-01-01 00:00:00.000000000 +0000
@@ -1,93 +0,0 @@
-.\" Man page generated from reStructuredText.
-.
-.TH "SYNC_SERVER" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
-.SH NAME
-sync_server \- Cyrus IMAP documentation
-.
-.nr rst2man-indent-level 0
-.
-.de1 rstReportMargin
-\\$1 \\n[an-margin]
-level \\n[rst2man-indent-level]
-level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
--
-\\n[rst2man-indent0]
-\\n[rst2man-indent1]
-\\n[rst2man-indent2]
-..
-.de1 INDENT
-.\" .rstReportMargin pre:
-. RS \\$1
-. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
-. nr rst2man-indent-level +1
-.\" .rstReportMargin post:
-..
-.de UNINDENT
-. RE
-.\" indent \\n[an-margin]
-.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.nr rst2man-indent-level -1
-.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
-.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
-..
-.sp
-Server side of the synchronization (replication) engine
-.SH SYNOPSIS
-.sp
-.nf
-\fBsync_server\fP [ \fB\-C\fP \fIconfig\-file\fP ] [ \fB\-p\fP \fIssf\fP]
-.fi
-.SH DESCRIPTION
-.sp
-\fBsync_server\fP is the server side of the the replication system.  It
-runs on the target (replica) system and listens for connections from
-sync_client(8) which provides instructions for synchronizing
-the replica system with the master system.
-.sp
-\fBsync_server\fP reads its configuration options out of the imapd.conf(5) file unless specified otherwise by \fB\-C\fP\&.
-.SH OPTIONS
-.INDENT 0.0
-.TP
-.B \-C config\-file
-Use the specified configuration file \fIconfig\-file\fP rather than the default imapd.conf(5)\&.
-.UNINDENT
-.INDENT 0.0
-.TP
-.B \-p  ssf
-Tell \fBsync_server\fP that an external layer exists.  An SSF (security
-strength factor) of 1 means an integrity protection layer exists.
-Any higher SSF implies some form of privacy protection.
-.UNINDENT
-.SH EXAMPLES
-.sp
-\fBsync_server\fP is commonly included in the SERVICES section of
-cyrus.conf(5) like so:
-.sp
-.nf
-SERVICES {
-    imap        cmd="imapd \-U 30" listen="imap" prefork=0
-    imaps       cmd="imapd \-s \-U 30" listen="imaps" prefork=0 maxchild=100
-    pop3        cmd="pop3d \-U 30" listen="pop3" prefork=0
-    pop3s       cmd="pop3d \-s \-U 30" listen="pop3s" prefork=0 maxchild=100
-    lmtpunix    cmd="lmtpd" listen="/var/run/cyrus/socket/lmtp" prefork=0 maxchild=20
-    sieve       cmd="timsieved" listen="sieve" prefork=0
-    notify      cmd="notifyd" listen="/var/run/cyrus/socket/notify" proto="udp" prefork=1
-    httpd       cmd="httpd" listen=8080 prefork=1 maxchild=20
-    \fBsyncserver  cmd="sync_server" listen="csync"\fP
-}
-.fi
-.SH FILES
-.sp
-/etc/imapd.conf,
-/etc/cyrus.conf
-.SH SEE ALSO
-.sp
-sync_client(8),
-imapd.conf(5),
-cyrus.conf(5)
-.SH AUTHOR
-The Cyrus Team, David Carter (dpc22@cam.ac.uk), Ken Murchison (ken@oceana.com), Nic Bernstein (Onlight)
-.SH COPYRIGHT
-1993-2017, The Cyrus Team
-.\" Generated by docutils manpage writer.
-.
diff -pruN 3.0.13-5/man/timsieved.8 3.2.0-3/man/timsieved.8
--- 3.0.13-5/man/timsieved.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/timsieved.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "TIMSIEVED" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "TIMSIEVED" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 timsieved \- Cyrus IMAP documentation
 .
@@ -84,6 +84,6 @@ cyrus.conf(5)
 .SH AUTHOR
 The Cyrus Team, David Carter (dpc22@cam.ac.uk), Ken Murchison (ken@oceana.com), Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/tls_prune.8 3.2.0-3/man/tls_prune.8
--- 3.0.13-5/man/tls_prune.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/tls_prune.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "TLS_PRUNE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "TLS_PRUNE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 tls_prune \- Cyrus IMAP documentation
 .
@@ -66,6 +66,6 @@ master(8)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/man/unexpunge.8 3.2.0-3/man/unexpunge.8
--- 3.0.13-5/man/unexpunge.8	2019-12-16 04:19:12.000000000 +0000
+++ 3.2.0-3/man/unexpunge.8	2020-05-04 04:11:04.000000000 +0000
@@ -1,6 +1,6 @@
 .\" Man page generated from reStructuredText.
 .
-.TH "UNEXPUNGE" "8" "December 16, 2019" "3.0.13" "Cyrus IMAP"
+.TH "UNEXPUNGE" "8" "May 04, 2020" "3.2.0" "Cyrus IMAP"
 .SH NAME
 unexpunge \- Cyrus IMAP documentation
 .
@@ -185,6 +185,6 @@ imapd.conf(5)
 .SH AUTHOR
 The Cyrus Team, Nic Bernstein (Onlight), Jeroen van Meeuwen (Kolab Systems)
 .SH COPYRIGHT
-1993-2017, The Cyrus Team
+1993-2018, The Cyrus Team
 .\" Generated by docutils manpage writer.
 .
diff -pruN 3.0.13-5/master/master.c 3.2.0-3/master/master.c
--- 3.0.13-5/master/master.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/master/master.c	2020-04-24 02:03:00.000000000 +0000
@@ -43,6 +43,7 @@
 #include <config.h>
 
 #include <stdio.h>
+#include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
 #include <time.h>
@@ -119,6 +120,7 @@
 #include "service.h"
 
 #include "cyr_lock.h"
+#include "retry.h"
 #include "util.h"
 #include "xmalloc.h"
 #include "strarray.h"
@@ -143,6 +145,9 @@ const char *MASTER_CONFIG_FILENAME = DEF
 #define MAX_READY_FAILS              5
 #define MAX_READY_FAIL_INTERVAL     10  /* 10 seconds */
 
+#define FNAME_PROM_STATS_DIR        "/stats" /* keep in sync with prometheus.h */
+#define FNAME_PROM_MASTER_REPORT    "master.txt"
+
 struct service *Services = NULL;
 static int allocservices = 0;
 int nservices = 0;
@@ -185,7 +190,14 @@ static int janitor_frequency = 1;
 static int janitor_position;            /* Entry to begin at in next sweep */
 static struct timeval janitor_mark;     /* Last time janitor did a sweep */
 
+static int prom_enabled = 0;
+static int prom_frequency = 0;
+static struct timeval prom_prev_report = { 0, 0 };
+static char *prom_report_fname = NULL;
+
+#ifdef HAVE_SETRLIMIT
 static void limit_fds(rlim_t);
+#endif
 static void schedule_event(struct event *a);
 static void child_sighandler_setup(void);
 
@@ -285,7 +297,7 @@ static void get_statsock(int filedes[2])
         fatalf(1, "unable to set close-on-exec: %m");
 }
 
-static int cap_bind(int socket, struct sockaddr *addr, socklen_t length)
+static int cyrus_cap_bind(int socket, struct sockaddr *addr, socklen_t length)
 {
     int r;
 
@@ -375,7 +387,7 @@ static void centry_set_state(struct cent
 /*
  * Parse the "listen" parameter as one of the forms:
  *
- * hostname
+ * port
  * hostname ':' port
  * ipv4-address
  * ipv4-address ':' port
@@ -474,7 +486,7 @@ static struct service *service_add(const
     return s;
 }
 
-static void service_create(struct service *s)
+static void service_create(struct service *s, int is_startup)
 {
     struct service service0, service;
     struct addrinfo hints, *res0, *res;
@@ -605,6 +617,14 @@ static void service_create(struct servic
 
         s->socket = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
         if (s->socket < 0) {
+            int e = errno;
+            if (is_startup && config_getswitch(IMAPOPT_MASTER_BIND_ERRORS_FATAL)) {
+                struct buf buf = BUF_INITIALIZER;
+                buf_printf(&buf, "unable to open %s/%s socket: %s",
+                                 s->name, s->familyname, strerror(e));
+                fatal(buf_cstring(&buf), EX_UNAVAILABLE);
+            }
+
             syslog(LOG_ERR, "unable to open %s/%s socket: %m",
                 s->name, s->familyname);
             continue;
@@ -643,9 +663,17 @@ static void service_create(struct servic
 #endif
 
         oldumask = umask((mode_t) 0); /* for linux */
-        r = cap_bind(s->socket, res->ai_addr, res->ai_addrlen);
+        r = cyrus_cap_bind(s->socket, res->ai_addr, res->ai_addrlen);
         umask(oldumask);
         if (r < 0) {
+            int e = errno;
+            if (is_startup && config_getswitch(IMAPOPT_MASTER_BIND_ERRORS_FATAL)) {
+                struct buf buf = BUF_INITIALIZER;
+                buf_printf(&buf, "unable to bind to %s/%s socket: %s",
+                                 s->name, s->familyname, strerror(e));
+                fatal(buf_cstring(&buf), EX_UNAVAILABLE);
+            }
+
             syslog(LOG_ERR, "unable to bind to %s/%s socket: %m",
                 s->name, s->familyname);
             xclose(s->socket);
@@ -661,6 +689,14 @@ static void service_create(struct servic
         if ((!strcmp(s->proto, "tcp") || !strcmp(s->proto, "tcp4")
              || !strcmp(s->proto, "tcp6"))
             && listen(s->socket, listen_queue_backlog) < 0) {
+            int e = errno;
+            if (is_startup && config_getswitch(IMAPOPT_MASTER_BIND_ERRORS_FATAL)) {
+                struct buf buf = BUF_INITIALIZER;
+                buf_printf(&buf, "unable to listen to %s/%s socket: %s",
+                                 s->name, s->familyname, strerror(e));
+                fatal(buf_cstring(&buf), EX_UNAVAILABLE);
+            }
+
             syslog(LOG_ERR, "unable to listen to %s/%s socket: %m",
                 s->name, s->familyname);
             xclose(s->socket);
@@ -698,6 +734,9 @@ static int decode_wait_status(struct cen
         if (!WEXITSTATUS(status)) {
             syslog(LOG_DEBUG, "%s exited normally", desc);
         }
+        else if (WEXITSTATUS(status) == EX_TEMPFAIL) {
+            syslog(LOG_DEBUG, "%s was killed", desc);
+        }
         else {
             syslog(LOG_ERR, "%s exited, status %d",
                    desc, WEXITSTATUS(status));
@@ -746,8 +785,6 @@ static void run_startup(const char *name
 
         child_sighandler_setup();
 
-        limit_fds(256);
-
         syslog(LOG_DEBUG, "about to exec %s", path);
         execv(path, cmd->data);
         fatalf(EX_OSERR, "can't exec %s for startup: %m", path);
@@ -882,7 +919,9 @@ static void spawn_service(int si)
             snprintf(name_env3, sizeof(name_env3), "CYRUS_ISDAEMON=1");
             putenv(name_env3);
         }
-        limit_fds(s->maxfds);
+#ifdef HAVE_SETRLIMIT
+        if (s->maxfds) limit_fds(s->maxfds);
+#endif
 
         /* close all listeners */
         for (i = 0; i < nservices; i++) {
@@ -989,7 +1028,6 @@ static void spawn_schedule(struct timeva
                     xclose(Services[i].stat[0]);
                     xclose(Services[i].stat[1]);
                 }
-                limit_fds(256);
 
                 syslog(LOG_DEBUG, "about to exec %s", path);
                 execv(path, a->exec->data);
@@ -1473,7 +1511,7 @@ static void process_msg(int si, struct n
             break;
 
         case SERVICE_STATE_UNKNOWN:
-            /* since state is unknwon, error in non-DoS way, i.e.
+            /* since state is unknown, error in non-DoS way, i.e.
              * we don't increment ready_workers */
             syslog(LOG_DEBUG,
                    "service %s/%s pid %d in UNKNOWN state: now available and in READY state",
@@ -1644,7 +1682,7 @@ static void add_daemon(const char *name,
 {
     int ignore_err = rock ? 1 : 0;
     char *cmd = xstrdup(masterconf_getstring(e, "cmd", ""));
-    rlim_t maxfds = (rlim_t) masterconf_getint(e, "maxfds", 256);
+    rlim_t maxfds = (rlim_t) masterconf_getint(e, "maxfds", 0);
     int maxforkrate = masterconf_getint(e, "maxforkrate", 0);
     int reconfig = 0;
     int i;
@@ -1735,7 +1773,7 @@ static void add_service(const char *name
     char *listen = xstrdup(masterconf_getstring(e, "listen", ""));
     char *proto = xstrdup(masterconf_getstring(e, "proto", "tcp"));
     char *max = xstrdup(masterconf_getstring(e, "maxchild", "-1"));
-    rlim_t maxfds = (rlim_t) masterconf_getint(e, "maxfds", 256);
+    rlim_t maxfds = (rlim_t) masterconf_getint(e, "maxfds", 0);
     int reconfig = 0;
     int i, j;
 
@@ -1955,11 +1993,190 @@ static void limit_fds(rlim_t x)
                rl.rlim_cur);
     }
 }
-#else
-static void limit_fds(rlim_t x)
+#endif /* HAVE_SETRLIMIT */
+
+/* minimal-dependency prometheus text report */
+static void init_prom_report(struct timeval now)
 {
+    struct buf buf = BUF_INITIALIZER;
+    struct event *evt;
+    const char *tmp;
+
+    prom_enabled = config_getswitch(IMAPOPT_PROMETHEUS_ENABLED);
+    prom_frequency = config_getduration(IMAPOPT_PROMETHEUS_UPDATE_FREQ, 's');
+
+    if (prom_frequency < 1) prom_enabled = 0;
+    if (!prom_enabled) return;
+
+    prom_prev_report.tv_sec = now.tv_sec - prom_frequency; /* next report asap */
+    prom_prev_report.tv_usec = 0;
+
+    if ((tmp = config_getstring(IMAPOPT_PROMETHEUS_STATS_DIR))) {
+        if (tmp[0] == '/' && tmp[1] != '\0') {
+            buf_setcstr(&buf, tmp);
+            if (buf.s[buf.len-1] != '/')
+                buf_putc(&buf, '/');
+            buf_appendcstr(&buf, FNAME_PROM_MASTER_REPORT);
+        }
+    }
+    else if ((tmp = config_getstring(IMAPOPT_CONFIGDIRECTORY))) {
+        buf_setcstr(&buf, tmp);
+        buf_appendcstr(&buf, FNAME_PROM_STATS_DIR);
+        buf_putc(&buf, '/');
+        buf_appendcstr(&buf, FNAME_PROM_MASTER_REPORT);
+    }
+
+    if (!buf_len(&buf)) {
+        syslog(LOG_NOTICE, "couldn't find somewhere to write prometheus report to"
+                           " - disabling master prometheus report until next reload");
+        prom_enabled = 0;
+        buf_free(&buf);
+        return;
+    }
+
+    if (prom_report_fname) free(prom_report_fname);
+    prom_report_fname = buf_release(&buf);
+    cyrus_mkdir(prom_report_fname, 0755);
+
+    evt = xzmalloc(sizeof(*evt));
+    evt->name = xstrdup("master prometheus report periodic wakeup call");
+    evt->period = prom_frequency;
+    evt->periodic = 1;
+    evt->mark = now;
+    schedule_event(evt);
+
+    syslog(LOG_DEBUG, "updating %s every %d seconds", prom_report_fname, prom_frequency);
+}
+
+static void do_prom_report(struct timeval now)
+{
+    struct buf report = BUF_INITIALIZER;
+    int fd, i, r;
+    int64_t last_updated;
+
+    if (!prom_enabled || timesub(&prom_prev_report, &now) + 0.5 < prom_frequency)
+        return;
+
+    /* open and grab the lock -- but if we would block, just skip this time */
+    fd = open(prom_report_fname, O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);
+    if (fd == -1) {
+        syslog(LOG_ERR, "open(%s): %m - %s",
+                        prom_report_fname,
+                        "disabling master prometheus report until next reload");
+        prom_enabled = 0;
+        return;
+    }
+    r = lock_setlock(fd, /*ex*/ 1, /*nb*/ 1, prom_report_fname);
+    if (r == -1) {
+        if (errno != EWOULDBLOCK) {
+            syslog(LOG_ERR, "lock_setlock(%s): %m - %s",
+                            prom_report_fname,
+                            "disabling master prometheus report until next reload");
+            prom_enabled = 0;
+        }
+        return;
+    }
+
+    /* okay, now prepare the report */
+    syslog(LOG_DEBUG, "updating prometheus report for master process");
+    last_updated = now_ms();
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_ready_workers",
+                        "The number of ready workers");
+    buf_appendcstr(&report, "# TYPE cyrus_master_ready_workers gauge\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_ready_workers{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %d %" PRId64 "\n",
+                            s->ready_workers, last_updated);
+    }
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_forks_total",
+                        "The number of children spawned");
+    buf_appendcstr(&report, "# TYPE cyrus_master_forks_total counter\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_forks_total{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %d %" PRId64 "\n",
+                            s->nforks, last_updated);
+    }
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_active_children",
+                        "The number of children servicing clients");
+    buf_appendcstr(&report, "# TYPE cyrus_master_active_children gauge\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_active_children{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %d %" PRId64 "\n",
+                            s->nactive, last_updated);
+    }
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_max_children",
+                        "The maximum number of child processes");
+    buf_appendcstr(&report, "# TYPE cyrus_master_max_children gauge\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_max_children{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %d %" PRId64 "\n",
+                            s->max_workers, last_updated);
+    }
+
+    /* XXX what is nconnections? */
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_forks_per_second",
+                        "The rate at which we're spawning children");
+    buf_appendcstr(&report, "# TYPE cyrus_master_forks_per_second gauge\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_forks_per_second{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %g %" PRId64 "\n",
+                            s->forkrate, last_updated);
+    }
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_max_forks_per_second",
+                        "The maximum rate at which we will spawn children");
+    buf_appendcstr(&report, "# TYPE cyrus_master_max_forks_per_second gauge\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_max_forks_per_second{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %u %" PRId64 "\n",
+                            s->maxforkrate, last_updated);
+    }
+
+    buf_printf(&report, "# HELP %s %s\n",
+                        "cyrus_master_ready_fails_total",
+                        "The number of failures in READY state");
+    buf_appendcstr(&report, "# TYPE cyrus_master_ready_fails_total counter\n");
+    for (i = 0; i < nservices; i++) {
+        const struct service *s = &Services[i];
+        buf_printf(&report, "cyrus_master_ready_fails_total{service=\"%s\",family=\"%s\"}",
+                            s->name, s->familyname);
+        buf_printf(&report, " %d %" PRId64 "\n",
+                            s->nreadyfails, last_updated);
+    }
+
+    /* write it out */
+    retry_write(fd, buf_cstring(&report), buf_len(&report));
+    ftruncate(fd, buf_len(&report));
+    lock_unlock(fd, prom_report_fname);
+    close(fd);
+
+    prom_prev_report = now;
+
+    buf_free(&report);
 }
-#endif /* HAVE_SETRLIMIT */
 
 static void reread_conf(struct timeval now)
 {
@@ -2020,7 +2237,7 @@ static void reread_conf(struct timeval n
         else if (Services[i].exec && (Services[i].socket < 0)) {
             /* initialize new services */
 
-            service_create(&Services[i]);
+            service_create(&Services[i], 0);
             if (verbose > 2)
                 syslog(LOG_DEBUG, "init: service %s/%s socket %d pipe %d %d",
                        Services[i].name, Services[i].familyname,
@@ -2043,6 +2260,9 @@ static void reread_conf(struct timeval n
     /* reinit child janitor */
     init_janitor(now);
 
+    /* reinit prom report */
+    init_prom_report(now);
+
     /* send some feedback to admin */
     syslog(LOG_NOTICE,
             "Services reconfigured. %d out of %d (max %d) services structures are now in use",
@@ -2130,15 +2350,7 @@ int main(int argc, char **argv)
             break;
         case 'V':
             /* print version information and exit */
-            /* XXX can't just call cyrus_version() because that would require
-             * XXX linking against libcyrus_imap */
-            printf("%s %s%s\n", PACKAGE_NAME, PACKAGE_VERSION,
-#ifdef EXTRA_IDENT
-                   "-" EXTRA_IDENT
-#else
-                   ""
-#endif
-            );
+            printf("%s %s\n", PACKAGE_NAME, CYRUS_VERSION);
             return 0;
         default:
             break;
@@ -2148,9 +2360,9 @@ int main(int argc, char **argv)
     if (daemon_mode && !close_std)
         fatal("Unable to be both debug and daemon mode", EX_CONFIG);
 
-    /* we reserve fds 3 and 4 for children to communicate with us, so they
+    /* we reserve fds for children to communicate with us, so they
        better be available. */
-    for (fd = 3; fd < 5; fd++) {
+    for (fd = STATUS_FD; fd <= LISTEN_FD; fd++) {
         close(fd);
         if (dup(0) != fd) fatalf(2, "couldn't dup fd 0: %m");
     }
@@ -2215,8 +2427,9 @@ int main(int argc, char **argv)
                 if (path == NULL)
                         path = "/tmp";
         }
-        (void) chdir(path);
-        (void) chdir("cores");
+        if (chdir(path))
+            fatalf(2, "couldn't chdir to %s: %m", path);
+        r = chdir("cores");
 
         do {
             pid = fork();
@@ -2264,8 +2477,6 @@ int main(int argc, char **argv)
         }
     }
 
-    limit_fds(1024);
-
     /* Write out the pidfile */
     pidfd = open(pidfile, O_CREAT|O_RDWR, 0644);
     if(pidfd == -1) {
@@ -2389,7 +2600,7 @@ int main(int argc, char **argv)
 
     /* initialize services */
     for (i = 0; i < nservices; i++) {
-        service_create(&Services[i]);
+        service_create(&Services[i], 1);
         if (verbose > 2)
             syslog(LOG_DEBUG, "init: service %s/%s socket %d pipe %d %d",
                    Services[i].name, Services[i].familyname,
@@ -2408,6 +2619,9 @@ int main(int argc, char **argv)
     gettimeofday(&now, 0);
     init_janitor(now);
 
+    /* init prom report */
+    init_prom_report(now);
+
     /* ok, we're going to start spawning like mad now */
     syslog(LOG_DEBUG, "ready for work");
 
@@ -2620,6 +2834,7 @@ int main(int argc, char **argv)
 
         gettimeofday(&now, 0);
         child_janitor(now);
+        do_prom_report(now);
 
 #ifdef HAVE_NETSNMP
         if (ready_fds == 0)
diff -pruN 3.0.13-5/master/masterconf.c 3.2.0-3/master/masterconf.c
--- 3.0.13-5/master/masterconf.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/master/masterconf.c	2020-04-24 02:03:00.000000000 +0000
@@ -86,35 +86,39 @@ void fatalf(int code, const char *fmt, .
 
 int masterconf_init(const char *ident, const char *alt_config)
 {
-    char *buf;
+    char *buf = NULL;
     const char *prefix;
 
-    /* Open the log file with the appropriate facility so we
-     * correctly log any config errors */
-    openlog(ident, LOG_PID, SYSLOG_FACILITY);
+    /* If our prefix is configured in the environment we can set it early */
+    if ((prefix = getenv("CYRUS_SYSLOG_PREFIX"))) {
+        buf = strconcat(prefix, "/", ident, NULL);
+        openlog(buf, LOG_PID, SYSLOG_FACILITY);
+    }
+    else {
+        openlog(ident, LOG_PID, SYSLOG_FACILITY);
+    }
 
     config_ident = ident;
     config_read(alt_config, 0);
 
-    prefix = config_getstring(IMAPOPT_SYSLOG_PREFIX);
-
-    if (prefix) {
-        int size = strlen(prefix) + 1 + strlen(ident) + 1;
-        buf = xmalloc(size);
-        strlcpy(buf, prefix, size);
-        strlcat(buf, "/", size);
-        strlcat(buf, ident, size);
+    /* If we didn't already get the syslog prefix from the environment,
+     * check config. */
+    if (!buf) {
+        prefix = config_getstring(IMAPOPT_SYSLOG_PREFIX);
+        /* XXX master ignores IMAPOPT_SYSLOG_FACILITY */
+
+        if (prefix)
+            buf = strconcat(prefix, "/", ident, NULL);
+        else
+            buf = xstrdup(ident);
 
         /* Reopen the log with the new prefix */
         closelog();
         openlog(buf, LOG_PID, SYSLOG_FACILITY);
-
-        /* don't free the openlog() string! */
-    } else {
-        closelog();
-        openlog(ident, LOG_PID, SYSLOG_FACILITY);
     }
 
+    /* don't free 'buf', syslog needs it for the lifetime of the process */
+
     /* drop debug messages locally */
     if (!config_debug)
         setlogmask(~LOG_MASK(LOG_DEBUG));
diff -pruN 3.0.13-5/master/README 3.2.0-3/master/README
--- 3.0.13-5/master/README	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/master/README	2020-04-24 02:03:00.000000000 +0000
@@ -17,6 +17,9 @@ SERVICES {
   lmtp          cmd="lmtpd" listen="lmtp" prefork=0
 #  lmtpunix     cmd="lmtpd" listen="/lmtp" prefork=0
 
+  # this is requied if using socketmap
+#  smmap        cmd="smmapd" listen="/smmap" prefork=0
+
   # this is only necessary if using notifications
 #  notify       cmd="notifyd" listen="/notify" proto="udp" prefork=1
 }
diff -pruN 3.0.13-5/master/service.c 3.2.0-3/master/service.c
--- 3.0.13-5/master/service.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/master/service.c	2020-04-24 02:03:00.000000000 +0000
@@ -405,8 +405,18 @@ int main(int argc, char **argv, char **e
         int ret;
         const char *debugger = config_getstring(IMAPOPT_DEBUG_COMMAND);
         if (debugger) {
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-nonliteral"
+#pragma GCC diagnostic ignored "-Wformat-security"
+            /* This is exactly the kind of usage that -Wformat is designed to
+             * complain about (using user-supplied string as format argument),
+             * but in this case the "user" is the server administrator, and
+             * they're about to attach a debugger, so worrying about leaking
+             * contents of memory here is a little silly! :)
+             */
             snprintf(debugbuf, sizeof(debugbuf), debugger,
                      argv[0], getpid(), service);
+#pragma GCC diagnostic pop
             syslog(LOG_DEBUG, "running external debugger: %s", debugbuf);
             ret = system(debugbuf); /* run debugger */
             syslog(LOG_DEBUG, "debugger returned exit status: %d", ret);
@@ -611,22 +621,25 @@ int main(int argc, char **argv, char **e
         notify_master(STATUS_FD, MASTER_SERVICE_UNAVAILABLE);
         syslog(LOG_DEBUG, "accepted connection");
 
-        if (fd != 0 && dup2(fd, 0) < 0) {
+        if (fd != STDIN_FILENO && dup2(fd, STDIN_FILENO) < 0) {
             syslog(LOG_ERR, "can't duplicate accepted socket: %m");
             service_abort(EX_OSERR);
         }
-        if (fd != 1 && dup2(fd, 1) < 0) {
+        if (fd != STDOUT_FILENO && dup2(fd, STDOUT_FILENO) < 0) {
             syslog(LOG_ERR, "can't duplicate accepted socket: %m");
             service_abort(EX_OSERR);
         }
-        if (fd != 2 && dup2(fd, 2) < 0) {
+#if 0  /* XXX  This appears to have no valid use (and breaks wire protocols).
+          We should look into capturing stderr and sending it to syslog. */
+        if (fd != STDERR_FILENO && dup2(fd, STDERR_FILENO) < 0) {
             syslog(LOG_ERR, "can't duplicate accepted socket: %m");
             service_abort(EX_OSERR);
         }
+#endif
 
         /* tcp only */
         if(soctype == SOCK_STREAM) {
-            if (fd > 2) close(fd);
+            if (fd > STDERR_FILENO) close(fd);
         }
 
         notify_master(STATUS_FD, MASTER_SERVICE_CONNECTION);
diff -pruN 3.0.13-5/master/service-thread.c 3.2.0-3/master/service-thread.c
--- 3.0.13-5/master/service-thread.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/master/service-thread.c	2020-04-24 02:03:00.000000000 +0000
@@ -226,8 +226,18 @@ int main(int argc, char **argv, char **e
         int ret;
         const char *debugger = config_getstring(IMAPOPT_DEBUG_COMMAND);
         if (debugger) {
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-nonliteral"
+#pragma GCC diagnostic ignored "-Wformat-security"
+            /* This is exactly the kind of usage that -Wformat is designed to
+             * complain about (using user-supplied string as format argument),
+             * but in this case the "user" is the server administrator, and
+             * they're about to attach a debugger, so worrying about leaking
+             * contents of memory here is a little silly! :)
+             */
             snprintf(debugbuf, sizeof(debugbuf), debugger,
                      argv[0], getpid(), service);
+#pragma GCC diagnostic pop
             syslog(LOG_DEBUG, "running external debugger: %s", debugbuf);
             ret = system(debugbuf); /* run debugger */
             syslog(LOG_DEBUG, "debugger returned exit status: %d", ret);
diff -pruN 3.0.13-5/netnews/inn.diffs 3.2.0-3/netnews/inn.diffs
--- 3.0.13-5/netnews/inn.diffs	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/netnews/inn.diffs	2020-04-24 02:03:00.000000000 +0000
@@ -457,7 +457,7 @@ polarbear:/afs/andrew/system/src/host/in
 +
 +     Host myHost ;                   /* the host who owns the connection */
 +
-+     time_t timeCon ;                /* the time the connect happened (last auth suceeded) */
++     time_t timeCon ;                /* the time the connect happened (last auth succeeded) */
 +
 +     int issue_quit;                 /* Three states:
 +                                    *   0 - don't do anything
@@ -468,16 +468,16 @@ polarbear:/afs/andrew/system/src/host/in
 +                                    */
 +
 +     /* Statistics */
-+     int lmtp_suceeded;
++     int lmtp_succeeded;
 +     int lmtp_failed;
 +
-+     int cancel_suceeded;
++     int cancel_succeeded;
 +     int cancel_failed;
 +
-+     int create_suceeded;
++     int create_succeeded;
 +     int create_failed;
 +
-+     int remove_suceeded;
++     int remove_succeeded;
 +     int remove_failed;
 +
 +
@@ -703,7 +703,7 @@ polarbear:/afs/andrew/system/src/host/in
 +  *            For example a cancel message canceling a message in multiple
 +  *            newsgroups will create >1 queue item but we only want it to count
 +  *            once towards the queue
-+  *  must    - wheather we must take it even though it may put us over our max size
++  *  must    - whether we must take it even though it may put us over our max size
 +  */
 +
 + static conn_ret AddToQueue(Q_t *q, void *item, control_type_t type, int addsmsg, bool must)
@@ -758,7 +758,7 @@ polarbear:/afs/andrew/system/src/host/in
 +  * Pop an item from the queue
 +  *
 +  * q    - the queue to pop from
-+  * item - where the item shall be placed upon sucess
++  * item - where the item shall be placed upon success
 +  *
 +  */
 +
@@ -826,14 +826,14 @@ polarbear:/afs/andrew/system/src/host/in
 +
 +
 + /*
-+  * Forget about an item. Tells host object if we suceeded/failed/etc with the message
++  * Forget about an item. Tells host object if we succeeded/failed/etc with the message
 +  *
 +  * cxn    - connection object
 +  * item   - item
 +  * failed - type of failure (see below)
 +  *
 +  * failed:
-+  *   0 - suceeded delivering message
++  *   0 - succeeded delivering message
 +  *   1 - failed delivering message
 +  *   2 - Try to give back to host
 +  *   3 - Article missing (i.e. can't find on disk)
@@ -1383,10 +1383,10 @@ polarbear:/afs/andrew/system/src/host/in
 +            QueueItems(&(cxn->lmtp_todeliver_q)));
 +     d_printf(1,"imap state = %s\n",imap_stateToString(cxn->imap_state));
 +     d_printf(1,"lmtp state = %s\n",lmtp_stateToString(cxn->lmtp_state));
-+     d_printf(1,"delivered:  yes: %d no: %d\n",cxn->lmtp_suceeded, cxn->lmtp_failed);
-+     d_printf(1,"control:    yes: %d no: %d\n",cxn->cancel_suceeded, cxn->cancel_failed);
-+     d_printf(1,"create:     yes: %d no: %d\n",cxn->create_suceeded, cxn->create_failed);
-+     d_printf(1,"remove:     yes: %d no: %d\n",cxn->remove_suceeded, cxn->remove_failed);
++     d_printf(1,"delivered:  yes: %d no: %d\n",cxn->lmtp_succeeded, cxn->lmtp_failed);
++     d_printf(1,"control:    yes: %d no: %d\n",cxn->cancel_succeeded, cxn->cancel_failed);
++     d_printf(1,"create:     yes: %d no: %d\n",cxn->create_succeeded, cxn->create_failed);
++     d_printf(1,"remove:     yes: %d no: %d\n",cxn->remove_succeeded, cxn->remove_failed);
 + }
 +
 + /**************************** SASL helper functions ******************************/
@@ -1893,7 +1893,7 @@ polarbear:/afs/andrew/system/src/host/in
 + }
 +
 + /*
-+  * This is called when the timeout for the reponse from the remote
++  * This is called when the timeout for the response from the remote
 +  * goes off. We tear down the connection and notify our host.
 +  */
 + static void imap_readTimeoutCbk (TimeoutId id, void *data)
@@ -1906,7 +1906,7 @@ polarbear:/afs/andrew/system/src/host/in
 +   peerName = hostPeerName (cxn->myHost) ;
 +
 +   syslog (LOG_WARNING, RESPONSE_TIMEOUT, peerName, cxn->ident) ;
-+   d_printf (0,"%s:%d shutting down non-repsonsive imap connection\n",
++   d_printf (0,"%s:%d shutting down non-responsive imap connection\n",
 +            hostPeerName (cxn->myHost), cxn->ident) ;
 +
 +   cxnLogStats (cxn,true) ;
@@ -2071,7 +2071,7 @@ polarbear:/afs/andrew/system/src/host/in
 + }
 +
 + /*
-+  * This is called when the timeout for the reponse from the remote
++  * This is called when the timeout for the response from the remote
 +  * goes off. We tear down the connection and notify our host.
 +  */
 + static void lmtp_readTimeoutCbk (TimeoutId id, void *data)
@@ -2084,7 +2084,7 @@ polarbear:/afs/andrew/system/src/host/in
 +   peerName = hostPeerName (cxn->myHost) ;
 +
 +   syslog (LOG_WARNING, RESPONSE_TIMEOUT, peerName, cxn->ident) ;
-+   d_printf (0,"%s:%d shutting down non-repsonsive lmtp connection\n",
++   d_printf (0,"%s:%d shutting down non-responsive lmtp connection\n",
 +            hostPeerName (cxn->myHost), cxn->ident) ;
 +
 +   cxnLogStats (cxn,true) ;
@@ -2494,7 +2494,7 @@ polarbear:/afs/andrew/system/src/host/in
 +                               &out,
 +                               &outlen);
 +
-+     /* check if sasl suceeded */
++     /* check if sasl succeeded */
 +     if (saslresult != SASL_OK && saslresult != SASL_CONTINUE) {
 +
 +       d_printf(0,"sasl_client_step failed with %s\n",
@@ -3095,7 +3095,7 @@ polarbear:/afs/andrew/system/src/host/in
 +                   if (okno==1) {
 +
 +                       d_printf(1,"Create successful\n");
-+                       cxn->create_suceeded++;
++                       cxn->create_succeeded++;
 +
 +                       /* we can delete article now */
 +                       QueueForgetAbout(cxn, cxn->current_control,0);
@@ -3116,7 +3116,7 @@ polarbear:/afs/andrew/system/src/host/in
 +                   if (okno==1) {
 +
 +                       d_printf(1,"Delete successful\n");
-+                       cxn->remove_suceeded++;
++                       cxn->remove_succeeded++;
 +
 +                       /* we can delete article now */
 +                       QueueForgetAbout(cxn, cxn->current_control,0);
@@ -3194,7 +3194,7 @@ polarbear:/afs/andrew/system/src/host/in
 +                       /* we can delete article now */
 +                       QueueForgetAbout(cxn, cxn->current_control,0);
 +
-+                       cxn->cancel_suceeded++;
++                       cxn->cancel_succeeded++;
 +
 +                       if (imap_sendClose(cxn) != RET_OK)
 +                           imap_Disconnect(cxn);
@@ -3402,7 +3402,7 @@ polarbear:/afs/andrew/system/src/host/in
 +
 +       case LMTP_READING_LHLO:
 +
-+           /* recieve the response(s) */
++           /* receive the response(s) */
 +           response_code = ask_code(str);
 +
 +           if (response_code != 250) /* was none */
@@ -3502,7 +3502,7 @@ polarbear:/afs/andrew/system/src/host/in
 +
 +                   free(in);
 +
-+                   /* check if sasl suceeded */
++                   /* check if sasl succeeded */
 +                   if (saslresult != SASL_OK && saslresult != SASL_CONTINUE) {
 +
 +                       d_printf(0,"sasl_client_step returned error (%s)\n",
@@ -3586,7 +3586,7 @@ polarbear:/afs/andrew/system/src/host/in
 +               return;
 +           }
 +
-+           /* we pipelined so next we recieve the rcpt's */
++           /* we pipelined so next we receive the rcpt's */
 +           cxn->lmtp_state = LMTP_READING_RCPTTO;
 +
 +           goto reset;
@@ -3663,7 +3663,7 @@ polarbear:/afs/andrew/system/src/host/in
 +           }
 +
 +           /*
-+            * current_rcpts_okayed is number that suceeded
++            * current_rcpts_okayed is number that succeeded
 +            *
 +            */
 +
@@ -3674,7 +3674,7 @@ polarbear:/afs/andrew/system/src/host/in
 +           } else {
 +
 +               cxn->lmtp_state = LMTP_AUTHED_IDLE;
-+               cxn->lmtp_suceeded++;
++               cxn->lmtp_succeeded++;
 +               d_printf(1,"Woohoo! message accepted\n");
 +           }
 +
@@ -4229,7 +4229,7 @@ polarbear:/afs/andrew/system/src/host/in
 +                         double lowPassFilter)
 + {
 +     Connection cxn;
-+     /* check arguements */
++     /* check arguments */
 +
 +     /* allocate connection structure */
 +     cxn = CALLOC (connection_t, 1) ;
@@ -4335,7 +4335,7 @@ polarbear:/afs/andrew/system/src/host/in
 +     QuitIfIdle(cxn);
 + }
 +
-+   /* Blow away the connection gracelessly and immedately clean up */
++   /* Blow away the connection gracelessly and immediately clean up */
 + void cxnNuke (Connection cxn)
 + {
 +     d_printf(0,"%s:%d Nuking connection\n",cxn->ServerName, cxn->ident);
@@ -4431,23 +4431,23 @@ polarbear:/afs/andrew/system/src/host/in
 +         "Host: %s:%d  status: %s  time: %d  Delivered (%d of %d) Cancelled (%d of %d) Created (%d of %d) Deleted (%d of %d)",
 +         peerName, cxn->ident,
 +           (final ? "final" : "checkpoint"), (long) (now - cxn->timeCon),
-+         cxn->lmtp_suceeded, cxn->lmtp_suceeded + cxn->lmtp_failed,
-+         cxn->cancel_suceeded, cxn->cancel_suceeded + cxn->cancel_failed,
-+         cxn->create_suceeded, cxn->create_suceeded + cxn->create_failed,
-+         cxn->remove_suceeded, cxn->remove_suceeded + cxn->remove_failed);
++         cxn->lmtp_succeeded, cxn->lmtp_succeeded + cxn->lmtp_failed,
++         cxn->cancel_succeeded, cxn->cancel_succeeded + cxn->cancel_failed,
++         cxn->create_succeeded, cxn->create_succeeded + cxn->create_failed,
++         cxn->remove_succeeded, cxn->remove_succeeded + cxn->remove_failed);
 +
 +   show_stats(cxn);
 +
 +   if (final)
 +   {
-+       cxn->lmtp_suceeded   = 0;
-+       cxn->lmtp_failed     = 0;
-+       cxn->cancel_suceeded = 0;
-+       cxn->cancel_failed   = 0;
-+       cxn->create_suceeded = 0;
-+       cxn->create_failed   = 0;
-+       cxn->remove_suceeded = 0;
-+       cxn->remove_failed   = 0;
++       cxn->lmtp_succeeded   = 0;
++       cxn->lmtp_failed      = 0;
++       cxn->cancel_succeeded = 0;
++       cxn->cancel_failed    = 0;
++       cxn->create_succeeded = 0;
++       cxn->create_failed    = 0;
++       cxn->remove_succeeded = 0;
++       cxn->remove_failed    = 0;
 +
 +       if (cxn->timeCon > 0)
 +         cxn->timeCon = theTime() ;
@@ -4531,21 +4531,21 @@ polarbear:/afs/andrew/system/src/host/in
 +   fprintf (fp,"%s    time-connected (imap) : %ld\n",indent,(long) cxn->imap_timeCon) ;
 +   fprintf (fp,"%s    time-connected (lmtp) : %ld\n",indent,(long) cxn->lmtp_timeCon) ;
 +   fprintf (fp,"%s    articles from INN : %d\n",indent,
-+          cxn->lmtp_suceeded+
++          cxn->lmtp_succeeded+
 +          cxn->lmtp_failed+
-+          cxn->cancel_suceeded+
++          cxn->cancel_succeeded+
 +          cxn->cancel_failed+
-+          cxn->create_suceeded+
++          cxn->create_succeeded+
 +          cxn->create_failed+
-+          cxn->remove_suceeded+
++          cxn->remove_succeeded+
 +          cxn->remove_failed+
 +          QueueSpace(&(cxn->lmtp_todeliver_q))+
 +          QueueSpace(&(cxn->imap_controlMsg_q))
 +          );
-+   fprintf(fp,"%s    LMTP STATS: yes: %d no: %d\n",cxn->lmtp_suceeded, cxn->lmtp_failed);
-+   fprintf(fp,"%s    control:    yes: %d no: %d\n",cxn->cancel_suceeded, cxn->cancel_failed);
-+   fprintf(fp,"%s    create:     yes: %d no: %d\n",cxn->create_suceeded, cxn->create_failed);
-+   fprintf(fp,"%s    remove:     yes: %d no: %d\n",cxn->remove_suceeded, cxn->remove_failed);
++   fprintf(fp,"%s    LMTP STATS: yes: %d no: %d\n",cxn->lmtp_succeeded, cxn->lmtp_failed);
++   fprintf(fp,"%s    control:    yes: %d no: %d\n",cxn->cancel_succeeded, cxn->cancel_failed);
++   fprintf(fp,"%s    create:     yes: %d no: %d\n",cxn->create_succeeded, cxn->create_failed);
++   fprintf(fp,"%s    remove:     yes: %d no: %d\n",cxn->remove_succeeded, cxn->remove_failed);
 +
 +   fprintf (fp,"%s    response-timeout : %d\n",indent,cxn->imap_readTimeout) ;
 +   fprintf (fp,"%s    response-callback : %d\n",indent,cxn->imap_readBlockedTimerId) ;
diff -pruN 3.0.13-5/netnews/remotepurge.c 3.2.0-3/netnews/remotepurge.c
--- 3.0.13-5/netnews/remotepurge.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/netnews/remotepurge.c	2020-04-24 02:03:00.000000000 +0000
@@ -61,16 +61,17 @@
 #include <netdb.h>
 #include <sys/socket.h>
 #include <sys/file.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include <pwd.h>
 
 #include "prot.h"
+#include "lib/times.h"
 
 #include "imclient.h"
 #include "util.h"
 #include "xmalloc.h"
-#include "exitcodes.h"
 
 #include "readconfig.h"
 
@@ -152,11 +153,11 @@ EXPORTED void fatal(const char *s, int c
 /***********************
  * Parse a mech list of the form: ... AUTH=foo AUTH=bar ...
  *
- * Return: string with mechs seperated by spaces
+ * Return: string with mechs separated by spaces
  *
  ***********************/
 
-typedef struct capabilies_s {
+typedef struct capabilities_s {
 
   char *mechs;
 
@@ -331,7 +332,7 @@ static int send_delete(const char *mbox,
                mbox, cmd_resp ? cmd_resp : "");
         return -1;
     }
-    else fatal("marking message deleted", EC_TEMPFAIL);
+    else fatal("marking message deleted", EX_TEMPFAIL);
 }
 
 static void mark_all_deleted(const char *mbox, uid_list_t *list, mbox_stats_t *stats)
@@ -392,26 +393,6 @@ static void mark_all_deleted(const char
     }
 }
 
-static char *month_string(int mon)
-{
-    switch(mon)
-        {
-            case 0: return "Jan";
-            case 1: return "Feb";
-            case 2: return "Mar";
-            case 3: return "Apr";
-            case 4: return "May";
-            case 5: return "Jun";
-            case 6: return "Jul";
-            case 7: return "Aug";
-            case 8: return "Sep";
-            case 9: return "Oct";
-            case 10: return "Nov";
-            case 11: return "Dec";
-        default: return "BAD";
-        }
-}
-
 /* we don't check what comes in on matchlen and category, should we? */
 static int purge_me(char *name, time_t when)
 {
@@ -427,7 +408,7 @@ static int purge_me(char *name, time_t w
     snprintf(search_string,sizeof(search_string),
              "BEFORE %d-%s-%d",
              my_tm->tm_mday,
-             month_string(my_tm->tm_mon),
+             monthname[my_tm->tm_mon],
              1900+my_tm->tm_year);
 
     if (noop) {
@@ -458,7 +439,7 @@ static int purge_me(char *name, time_t w
         syslog(LOG_ERR, "unable to select %s: %s", name, cmd_resp);
         return 0;
     } else if (cmd_done != IMAP_OK) {
-        fatal("selecting mailbox", EC_TEMPFAIL);
+        fatal("selecting mailbox", EX_TEMPFAIL);
     }
 
     stats.total = current_mbox_exists;
@@ -484,7 +465,7 @@ static int purge_me(char *name, time_t w
             imclient_processoneevent(imclient_conn);
         }
         if (cmd_done != IMAP_OK) {
-            fatal("UID Search failed", EC_TEMPFAIL);
+            fatal("UID Search failed", EX_TEMPFAIL);
         }
 
         if (uidlist.size > 0) {
@@ -503,7 +484,7 @@ static int purge_me(char *name, time_t w
     }
 
     if (cmd_done != IMAP_OK) {
-        fatal("unable to CLOSE mailbox", EC_TEMPFAIL);
+        fatal("unable to CLOSE mailbox", EX_TEMPFAIL);
     }
 
     if(current_mbox_exists) {
@@ -548,7 +529,7 @@ static void do_list(char *matchstr)
         imclient_processoneevent(imclient_conn);
     }
 
-    if (cmd_done!=IMAP_OK) fatal("unable to LIST mailboxes", EC_TEMPFAIL);
+    if (cmd_done!=IMAP_OK) fatal("unable to LIST mailboxes", EX_TEMPFAIL);
 }
 
 /*
@@ -602,7 +583,7 @@ static void remote_purge(char *configpat
         configstream = fopen(name,"r");
 
         if (configstream == NULL)
-            fatal("unable to open config file", EC_CONFIG);
+            fatal("unable to open config file", EX_CONFIG);
 
         EXPreadfile(configstream);
         /* ret val */
@@ -630,7 +611,7 @@ static void usage(void)
 
   printf("  -d days  : purge all message <days> old\n");
 
-  exit(EC_USAGE);
+  exit(EX_USAGE);
 }
 
 int main(int argc, char **argv)
@@ -708,7 +689,7 @@ int main(int argc, char **argv)
     r = imclient_connect (&imclient_conn, servername, port, NULL);
 
     if (r!=0) {
-        fatal("imclient_connect()", EC_TEMPFAIL);
+        fatal("imclient_connect()", EX_TEMPFAIL);
     }
 
     spew(0, "connected");
@@ -735,7 +716,7 @@ int main(int argc, char **argv)
                               maxssf);
 
     if (r!=0) {
-        fatal("imclient_authenticate()\n", EC_CONFIG);
+        fatal("imclient_authenticate()\n", EX_CONFIG);
     }
 
     spew(0, "authenticated");
diff -pruN 3.0.13-5/notifyd/notifyd.c 3.2.0-3/notifyd/notifyd.c
--- 3.0.13-5/notifyd/notifyd.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/notifyd/notifyd.c	2020-04-24 02:03:00.000000000 +0000
@@ -47,6 +47,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <errno.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/types.h>
 #include <sys/socket.h>
@@ -60,9 +61,9 @@
 
 #include "notifyd.h"
 
-#include "exitcodes.h"
 #include "imap/global.h"
 #include "libconfig.h"
+#include "imap/notify.h"
 #include "xmalloc.h"
 #include "strarray.h"
 
@@ -95,8 +96,6 @@ static char *fetch_arg(char *head, char*
     return (cp == tail ? NULL : cp + 1);
 }
 
-#define NOTIFY_MAXSIZE 8192
-
 static int do_notify(void)
 {
     struct sockaddr_un sun_data;
@@ -109,6 +108,19 @@ static int do_notify(void)
     char *reply;
     char *fname;
     notifymethod_t *nmethod;
+    unsigned bufsiz;
+    socklen_t optlen;
+
+    /* Get receive buffer size */
+    optlen = sizeof(bufsiz);
+    r = getsockopt(soc, SOL_SOCKET, SO_RCVBUF, &bufsiz, &optlen);
+    if (r == -1) {
+        syslog(LOG_ERR, "unable to getsockopt(SO_RCVBUF) on notify socket: %m");
+        return (errno);
+    }
+
+    /* Use minimum of 1/10 of receive buffer size (-overhead) NOTIFY_MAXSIZE */
+    bufsiz = MIN(bufsiz / 10 - 32, NOTIFY_MAXSIZE);
 
     while (1) {
         method = class = priority = user = mailbox = message = reply = NULL;
@@ -118,7 +130,7 @@ static int do_notify(void)
             /* caught a SIGHUP, return */
             return 0;
         }
-        r = recvfrom(soc, buf, NOTIFY_MAXSIZE, 0,
+        r = recvfrom(soc, buf, bufsiz, 0,
                      (struct sockaddr *) &sun_data, &sunlen);
         if (r == -1) {
             return (errno);
@@ -177,7 +189,7 @@ static int do_notify(void)
         else {
             reply = strdup("NO unknown notification method");
             if (!reply) {
-                fatal("strdup failed", EC_OSERR);
+                fatal("strdup failed", EX_OSERR);
             }
         }
 #endif
@@ -208,7 +220,7 @@ EXPORTED void fatal(const char *s, int c
 static void usage(void)
 {
     syslog(LOG_ERR, "usage: notifyd [-C <alt_config>]");
-    exit(EC_USAGE);
+    exit(EX_USAGE);
 }
 
 EXPORTED int service_init(int argc, char **argv, char **envp __attribute__((unused)))
@@ -216,7 +228,7 @@ EXPORTED int service_init(int argc, char
     int opt;
     char *method = "null";
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
 
     while ((opt = getopt(argc, argv, "m:")) != EOF) {
         switch(opt) {
@@ -234,7 +246,7 @@ EXPORTED int service_init(int argc, char
         default_method++;
     }
 
-    if (!default_method) fatal("unknown notification method %s", EC_USAGE);
+    if (!default_method) fatal("unknown notification method %s", EX_USAGE);
 
     signals_set_shutdown(&shut_down);
 
diff -pruN 3.0.13-5/notifyd/notify_external.c 3.2.0-3/notifyd/notify_external.c
--- 3.0.13-5/notifyd/notify_external.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/notifyd/notify_external.c	2020-04-24 02:03:00.000000000 +0000
@@ -98,7 +98,7 @@ char* notify_external(const char *class,
         /* i'm the child! run notify */
         close(fds[1]);
         /* make the pipe be stdin */
-        dup2(fds[0], 0);
+        dup2(fds[0], STDIN_FILENO);
         execv(notify, (char **) buf);
 
         /* should never reach here */
diff -pruN 3.0.13-5/notifyd/notify_mailto.c 3.2.0-3/notifyd/notify_mailto.c
--- 3.0.13-5/notifyd/notify_mailto.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/notifyd/notify_mailto.c	2020-04-24 02:03:00.000000000 +0000
@@ -73,7 +73,7 @@ char* notify_mailto(const char *class,
     char outmsgid[256];
     int sm_stat;
     time_t t;
-    char datestr[RFC822_DATETIME_MAX+1];
+    char datestr[RFC5322_DATETIME_MAX+1];
     pid_t sm_pid;
     int fds[2];
 
@@ -96,7 +96,7 @@ char* notify_mailto(const char *class,
         /* i'm the child! run sendmail! */
         close(fds[1]);
         /* make the pipe be stdin */
-        dup2(fds[0], 0);
+        dup2(fds[0], STDIN_FILENO);
         execv(config_getstring(IMAPOPT_SENDMAIL), (char **) smbuf);
 
         /* if we're here we suck */
@@ -115,7 +115,7 @@ char* notify_mailto(const char *class,
 
     fprintf(sm, "Message-ID: %s\r\n", outmsgid);
 
-    time_to_rfc822(t, datestr, sizeof(datestr));
+    time_to_rfc5322(t, datestr, sizeof(datestr));
     fprintf(sm, "Date: %s\r\n", datestr);
 
     fprintf(sm, "X-Sieve: %s\r\n", SIEVE_VERSION);
diff -pruN 3.0.13-5/notifyd/notifytest.c 3.2.0-3/notifyd/notifytest.c
--- 3.0.13-5/notifyd/notifytest.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/notifyd/notifytest.c	2020-04-24 02:03:00.000000000 +0000
@@ -110,7 +110,7 @@ static int notify(const char *notifyd_pa
 
     memset((char *)&sun, 0, sizeof(sun));
     sun.sun_family = AF_UNIX;
-    strncpy(sun.sun_path, notifyd_path, sizeof(sun.sun_path));
+    xstrncpy(sun.sun_path, notifyd_path, sizeof(sun.sun_path));
 
     /*
      * build request of the form:
diff -pruN 3.0.13-5/perl/annotator/Daemon.pm 3.2.0-3/perl/annotator/Daemon.pm
--- 3.0.13-5/perl/annotator/Daemon.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/annotator/Daemon.pm	2020-04-24 02:03:00.000000000 +0000
@@ -91,7 +91,7 @@ to add annotations or flags to messages
 Cyrus mail server.
 
 To use Cyrus::Annotator::Daemon, write a Perl script which creates an
-object derived from it; see the Synposis above.  Run this script as
+object derived from it; see the Synopsis above.  Run this script as
 root, and it will daemonize itself.  Then add this line to the
 imapd.conf file
 
diff -pruN 3.0.13-5/perl/annotator/Message.pm 3.2.0-3/perl/annotator/Message.pm
--- 3.0.13-5/perl/annotator/Message.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/annotator/Message.pm	2020-04-24 02:03:00.000000000 +0000
@@ -275,7 +275,7 @@ following items are defined for all body
 
 =item * Content-Description
 
-=item * Content-Dispositon
+=item * Content-Disposition
 
 =item * Content-Language
 
diff -pruN 3.0.13-5/perl/annotator/README 3.2.0-3/perl/annotator/README
--- 3.0.13-5/perl/annotator/README	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/perl/annotator/README	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,5 @@
 
-This is a Perl framework which enables site adminstrators to easily
+This is a Perl framework which enables site administrators to easily
 write custom daemons which automate the setting of annotations and flags
 on newly arrived messages.  See the perldoc for instructions on how to
 use it.
diff -pruN 3.0.13-5/perl/imap/cyradm.sh 3.2.0-3/perl/imap/cyradm.sh
--- 3.0.13-5/perl/imap/cyradm.sh	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/cyradm.sh	2020-04-24 02:03:00.000000000 +0000
@@ -150,9 +150,15 @@ last command will be used if one is not
 
 Show help for C<command> or all commands.
 
+=item C<getmetadata> [I<mailbox>]
+
+=item C<getmd> [I<mailbox>]
+
+Display mailbox/server metadata
+
 =item C<info> [I<mailbox>]
 
-Display the mailbox/server metadata.
+Display the mailbox/server annotations.
 
 =item C<listaclmailbox> I<mailbox>
 
@@ -382,6 +388,37 @@ them (unless overridden by a mailbox ann
 
 =back
 
+=item C<setmetadata> [--private] mailbox [I<annotation>] I<value>
+
+=item C<setmd> [--private] mailbox [I<annotation>] I<value>
+
+Set metadata on mailbox, where <annotation> is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/<explicit annotation>].
+
+Note that flags with a leading backslash must be escaped with an
+additional backslash.  For example:
+
+=over 4
+
+  setmetadata --private Spam specialuse "\\Junk"
+
+=back
+
+Note, too, that "private" annotations are private to the user currently
+authenticated as, not necessarily the owner of the mailbox.  To set
+annotations for another user you must authorize as that user.
+
+In addition to the use of optional flag B<--private>, one may use a more
+explicit syntax, prefixing the annotation with '/shared/' or '/private/'
+as in this example:
+
+=over 4
+
+  setmetadata Spam /private/specialuse "\\Junk"
+
+=back
+
 =item C<setquota> I<root> I<resource> I<value> [I<resource> I<value> ...]
 
 =item C<sq> I<root> I<resource> I<value> [I<resource> I<value> ...]
diff -pruN 3.0.13-5/perl/imap/Cyrus/CacheFile.pm 3.2.0-3/perl/imap/Cyrus/CacheFile.pm
--- 3.0.13-5/perl/imap/Cyrus/CacheFile.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/Cyrus/CacheFile.pm	2020-04-24 02:03:00.000000000 +0000
@@ -30,7 +30,7 @@ See examples/index_uids.pl for some usag
 # /* CACHE_ITEM_BIT32: Convert to host byte order */
 # /* CACHE_ITEM_LEN: Get the length out */
 # /* CACHE_ITEM_NEXT: Return a pointer to the next entry.  Sizes are
-#  * 4-byte aligned, so round up to the next 4 byte boundry */
+#  * 4-byte aligned, so round up to the next 4 byte boundary */
 #  #define CACHE_ITEM_BIT32(ptr) (ntohl(*((bit32 *)(ptr))))
 #  #define CACHE_ITEM_LEN(ptr) CACHE_ITEM_BIT32(ptr)
 #  #define CACHE_ITEM_NEXT(ptr) ((ptr)+4+((3+CACHE_ITEM_LEN(ptr))&~3))
diff -pruN 3.0.13-5/perl/imap/Cyrus/IndexFile.pm 3.2.0-3/perl/imap/Cyrus/IndexFile.pm
--- 3.0.13-5/perl/imap/Cyrus/IndexFile.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/Cyrus/IndexFile.pm	2020-04-24 02:03:00.000000000 +0000
@@ -1,5 +1,4 @@
 #!/usr/bin/perl -c
-
 package Cyrus::IndexFile;
 
 use strict;
@@ -211,12 +210,12 @@ SKIPPED VERSION 11 - Fastmail internal o
  19: FirstExpunged         time_t 4
  20: LastCleanup           time_t 4
  21: HeaderFileCRC         int32  4
- 22: SyncCRC               int32  4
+ 22: SyncCRCsBasic         int32  4
  23: RecentUid             int32  4
  24: RecentTime            time_t 4
- 25: Spare0                int32  4
- 26: Spare1                int32  4
- 27: Spare2                int32  4
+ 25: Pop3ShowAfter         int32  4
+ 26: QuotaAnnotUsed        int32  4
+ 27: SyncCRCsAnnot         int32  4
  28: HeaderCRC             int32  4
 
  Record:
@@ -238,6 +237,128 @@ SKIPPED VERSION 11 - Fastmail internal o
  15: CacheCRC              int32  4
  16: RecordCRC             int32  4
 
+ Version 14:
+ ===========
+
+ Header:
+  0: Generation            int32  4
+  1: Format                int32  4
+  2: MinorVersion          int32  4
+  3: StartOffset           int32  4
+  4: RecordSize            int32  4
+  5: Exists                int32  4
+  6: LastAppenddate        time_t 4
+  7: LastUid               int32  4
+  8: QuotaUsed             int64  8
+  9: Pop3LastLogin         time_t 4
+ 10: UidValidity           int32  4
+ 11: Deleted               int32  4
+ 12: Answered              int32  4
+ 13: Flagged               int32  4
+ 14: Options               bitmap 4
+ 15: LeakedCache           int32  4
+ 16: HighestModseq         int64  8
+ 17: DeletedModseq         int64  8
+ 18: Exists                int32  4
+ 19: FirstExpunged         time_t 4
+ 20: LastCleanup           time_t 4
+ 21: HeaderFileCRC         int32  4
+ 22: SyncCRC               int32  4
+ 23: RecentUid             int32  4
+ 24: RecentTime            time_t 4
+ 25: Pop3ShowAfter         int32  4
+ 26: QuotaAnnotUsed        int32  4
+ 27: SyncCRCsAnnot         int32  4
+ 28: Unseen                int32  4
+ 29: Spare0                int32  4
+ 30: Spare1                int32  4
+ 31: Spare2                int32  4
+ 32: Spare3                int32  4
+ 33: Spare4                int32  4
+ 34: Spare5                int32  4
+ 34: Spare6                int32  4
+ 35: HeaderCRC             int32  4
+
+ Record:
+  0: Uid                   int32  4
+  1: InternalDate          time_t 4
+  2: SentDate              time_t 4
+  3: Size                  int32  4
+  4: HeaderSize            int32  4
+  5: GmTime                time_t  4
+  6: CacheOffset           int32  4
+  7: LastUpdated           time_t 4
+  8: SystemFlags           bitmap 4
+  9: UserFlags             bitmap 16
+ 10: ContentLines          int32  4
+ 11: CacheVersion          int32  4
+ 12: MessageGuid           hex    20
+ 13: Modseq                int64  8
+ 14: CID                   hex    8
+ 15: CacheCRC              int32  4
+ 16: RecordCRC             int32  4
+
+ Version 15:
+ ===========
+
+ Header:
+  0: Generation            int32  4
+  1: Format                int32  4
+  2: MinorVersion          int32  4
+  3: StartOffset           int32  4
+  4: RecordSize            int32  4
+  5: Exists                int32  4
+  6: LastAppenddate        time_t 4
+  7: LastUid               int32  4
+  8: QuotaUsed             int64  8
+  9: Pop3LastLogin         time_t 4
+ 10: UidValidity           int32  4
+ 11: Deleted               int32  4
+ 12: Answered              int32  4
+ 13: Flagged               int32  4
+ 14: Options               bitmap 4
+ 15: LeakedCache           int32  4
+ 16: HighestModseq         int64  8
+ 17: DeletedModseq         int64  8
+ 18: Exists                int32  4
+ 19: FirstExpunged         time_t 4
+ 20: LastCleanup           time_t 4
+ 21: HeaderFileCRC         int32  4
+ 22: SyncCRC               int32  4
+ 23: RecentUid             int32  4
+ 24: RecentTime            time_t 4
+ 25: Pop3ShowAfter         int32  4
+ 26: QuotaAnnotUsed        int32  4
+ 27: SyncCRCsAnnot         int32  4
+ 28: Unseen                int32  4
+ 29: Spare0                int32  4
+ 30: Spare1                int32  4
+ 31: Spare2                int32  4
+ 32: Spare3                int32  4
+ 33: Spare4                int32  4
+ 34: Spare5                int32  4
+ 34: Spare6                int32  4
+ 35: HeaderCRC             int32  4
+
+ Record:
+  0: Uid                   int32  4
+  1: InternalDate          time_t 4
+  2: SentDate              time_t 4
+  3: Size                  int32  4
+  4: HeaderSize            int32  4
+  5: GmTime                time_t  4
+  6: CacheOffset           int32  4
+  7: LastUpdated           time_t 4
+  8: SystemFlags           bitmap 4
+  9: UserFlags             bitmap 16
+ 10: SaveDate              time_t  4
+ 11: CacheVersion          int32  4
+ 12: MessageGuid           hex    20
+ 13: Modseq                int64  8
+ 14: CID                   hex    8
+ 15: CacheCRC              int32  4
+ 16: RecordCRC             int32  4
+
 =cut
 
 # Set up header and record formatting information {{{
@@ -456,12 +577,74 @@ Exists                int32  4
 FirstExpunged         time_t 4
 LastCleanup           time_t 4
 HeaderFileCRC         int32  4
-SyncCRC               int32  4
+SyncCRCsBasic         int32  4
+RecentUid             int32  4
+RecentTime            time_t 4
+Pop3ShowAfter         int32  4
+QuotaAnnotUsed        int32  4
+SyncCRCsAnnot         int32  4
+HeaderCrc             int32  4
+EOF
+    RecordSize => 104, # defined in file too, check it!
+    _make_fields('Record', <<EOF),
+Uid                   int32  4
+InternalDate          time_t 4
+SentDate              time_t 4
+Size                  int32  4
+HeaderSize            int32  4
+GmTime                time_t 4
+CacheOffset           int32  4
+LastUpdated           time_t 4
+SystemFlags           bitmap 4
+UserFlags             bitmap 16
+ContentLines          int32  4
+CacheVersion          int32  4
+MessageGuid           hex    20
+Modseq                int64  8
+CID                   hex    8
+CacheCrc              int32  4
+RecordCrc             int32  4
+EOF
+  },
+  14 => {
+    HeaderSize => 160,
+    _make_fields('Header',<<EOF),
+Generation            int32  4
+Format                int32  4
+MinorVersion          int32  4
+StartOffset           int32  4
+RecordSize            int32  4
+NumRecords            int32  4
+LastAppenddate        time_t 4
+LastUid               int32  4
+QuotaUsed             int64  8
+Pop3LastLogin         time_t 4
+UidValidity           int32  4
+Deleted               int32  4
+Answered              int32  4
+Flagged               int32  4
+Options               bitmap 4
+LeakedCache           int32  4
+HighestModseq         int64  8
+DeletedModseq         int64  8
+Exists                int32  4
+FirstExpunged         time_t 4
+LastCleanup           time_t 4
+HeaderFileCRC         int32  4
+SyncCRCsBasic         int32  4
 RecentUid             int32  4
 RecentTime            time_t 4
 Pop3ShowAfter         int32  4
 QuotaAnnotUsed        int32  4
-SyncCRCVersion        int32  4
+SyncCRCsAnnot         int32  4
+Unseen                int32  4
+Spare0                int32  4
+Spare1                int32  4
+Spare2                int32  4
+Spare3                int32  4
+Spare4                int32  4
+Spare5                int32  4
+Spare6                int32  4
 HeaderCrc             int32  4
 EOF
     RecordSize => 104, # defined in file too, check it!
@@ -485,6 +668,69 @@ CacheCrc              int32  4
 RecordCrc             int32  4
 EOF
   },
+  15 => {
+    HeaderSize => 160,
+    _make_fields('Header',<<EOF),
+Generation            int32  4
+Format                int32  4
+MinorVersion          int32  4
+StartOffset           int32  4
+RecordSize            int32  4
+NumRecords            int32  4
+LastAppenddate        time_t 4
+LastUid               int32  4
+QuotaUsed             int64  8
+Pop3LastLogin         time_t 4
+UidValidity           int32  4
+Deleted               int32  4
+Answered              int32  4
+Flagged               int32  4
+Options               bitmap 4
+LeakedCache           int32  4
+HighestModseq         int64  8
+DeletedModseq         int64  8
+Exists                int32  4
+FirstExpunged         time_t 4
+LastCleanup           time_t 4
+HeaderFileCRC         int32  4
+SyncCRCsBasic         int32  4
+RecentUid             int32  4
+RecentTime            time_t 4
+Pop3ShowAfter         int32  4
+QuotaAnnotUsed        int32  4
+SyncCRCsAnnot         int32  4
+Unseen                int32  4
+Spare0                int32  4
+Spare1                int32  4
+Spare2                int32  4
+Spare3                int32  4
+Spare4                int32  4
+Spare5                int32  4
+Spare6                int32  4
+HeaderCrc             int32  4
+EOF
+    RecordSize => 104, # defined in file too, check it!
+    _make_fields('Record', <<EOF),
+Uid                   int32  4
+InternalDate          time_t 4
+SentDate              time_t 4
+Size                  int32  4
+HeaderSize            int32  4
+GmTime                time_t 4
+CacheOffset           int32  4
+LastUpdated           time_t 4
+SystemFlags           bitmap 4
+UserFlags             bitmap 16
+SaveDate              time_t 4
+CacheVersion          int32  4
+MessageGuid           hex    20
+Modseq                int64  8
+CID                   hex    8
+CacheCrc              int32  4
+RecordCrc             int32  4
+EOF
+
+  },
 };
 
 my %SystemFlagMap = (
@@ -493,6 +739,8 @@ my %SystemFlagMap = (
    2 => "\\Deleted",
    3 => "\\Draft",
    4 => "\\Seen",
+  27 => "[SPLITCONVERSATION]",
+  28 => "[NEEDS-CLEANUP]",
   29 => "[ARCHIVED]",
   30 => "[UNLINKED]",
   31 => "[EXPUNGED]",
@@ -551,8 +799,6 @@ sub _make_pack {
 
 =head1 PUBLIC API
 
-=over
-
 =item Cyrus::IndexFile->new($fh)
 
 Build a new Cyrus::IndexFile object from a filehandle.  The handle is not
@@ -915,34 +1161,6 @@ sub record {
   return $record;
 }
 
-sub record_hash {
-  my $Self = shift;
-  unless (exists $Self->{record}{hash}) {
-    $Self->{record}{hash} = $Self->_record_a2h($Self->record_array(@_));
-  }
-  return $Self->{record}{hash};
-}
-
-sub record_array {
-  my $Self = shift;
-  unless (exists $Self->{record}{array}) {
-    $Self->{record}{array} = $Self->_record_b2a($Self->{rawrecord});
-  }
-  return $Self->{record}{array};
-}
-
-sub record_raw {
-   my $Self = shift;
-   return $Self->{rawrecord};
-}
-
-=item $index->system_flags([$Key])
-
-Returns a hash of the system flags set on the current record, or just the
-named flag if a Key is passed.
-
-=cut
-
 sub system_flags {
   my $Self = shift;
   my $Field = shift;
@@ -961,12 +1179,7 @@ sub system_flags {
   return wantarray ? %hash : \%hash;
 }
 
-=item $index->flagslist($Header)
-
-Given a Cyrus::HeaderFile object to name the UserFlags, return an array of all
-flags, both SystemFlags and UserFlags set on the record.
-
-=cut
+# arg is a Cyrus::HeaderFile to give us names for user flags
 sub flagslist {
   my $Self = shift;
   my $Header = shift;
@@ -993,6 +1206,27 @@ sub flagslist {
   return wantarray ? @flags : \@flags;
 }
 
+sub record_hash {
+  my $Self = shift;
+  unless (exists $Self->{record}{hash}) {
+    $Self->{record}{hash} = $Self->_record_a2h($Self->record_array(@_));
+  }
+  return $Self->{record}{hash};
+}
+
+sub record_array {
+  my $Self = shift;
+  unless (exists $Self->{record}{array}) {
+    $Self->{record}{array} = $Self->_record_b2a($Self->{rawrecord});
+  }
+  return $Self->{record}{array};
+}
+
+sub record_raw {
+   my $Self = shift;
+   return $Self->{rawrecord};
+}
+
 =item $index->field_number($Field)
 
 Return the field number in a record array for the named field, or die
@@ -1459,11 +1693,9 @@ sub _record_h2a {
   return \@array;
 }
 
-=back
-
-=head1 AUTHOR AND COPYRIGHT
+=item AUTHOR AND COPYRIGHT
 
-Bron Gondwana <brong@fastmail.fm> - Copyright 2008 FastMail
+Bron Gondwana <brong@fastmailteam.com> - Copyright 2018 FastMail
 
 Licenced under the same terms as Cyrus IMAPd.
 
diff -pruN 3.0.13-5/perl/imap/IMAP/Admin.pm 3.2.0-3/perl/imap/IMAP/Admin.pm
--- 3.0.13-5/perl/imap/IMAP/Admin.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/IMAP/Admin.pm	2020-04-24 02:03:00.000000000 +0000
@@ -370,6 +370,8 @@ sub listmailbox {
     } else {
       $list_cmd = 'RLIST';
     }
+  } else {
+    $list_cmd = 'LIST';
   }
 
   if(defined ($$opts{'-sel-special-use'}) && !$self->{support_list_special_use}) {
@@ -826,125 +828,6 @@ sub _attribname2access {
   }
 }
 
-sub getinfo {
-  my $self = shift;
-  my $box = shift;
-  my @entries = @_;
-
-  if(!defined($box)) {
-    $box = "";
-  }
-
-  if(!$self->{support_annotatemore}) {
-    $self->{error} = "Remote does not support ANNOTATEMORE.";
-    return undef;
-  }
-
-  my %info = ();
-  $self->addcallback({-trigger => 'ANNOTATION',
-                      -callback => sub {
-                        my %d = @_;
-                        my $text = $d{-text};
-
-                        # There were several draft iterations of this,
-                        # but since we send only the latest form command,
-                        # this is the only possible response.
-
-                        # Regex 1 (Shared-Folder, user folder looks similar):
-                        # cyrus imapd 2.5.0
-                        # folder "/vendor/cmu/cyrus-imapd/expire" ("value.shared" "90")
-                        # 1      2                                 3              4
-                        # folder "/vendor/cmu/cyrus-imapd/pop3showafter" ("value.shared" NIL)
-                        # 1      2                                        3              4
-                        # folder "/specialuse" ("value.priv" NIL "value.shared" NIL)
-                        # 1      2              3            4   5              6
-
-                        # cyrus imapd 2.4.17
-                        # "folder" "/vendor/cmu/cyrus-imapd/partition" ("value.shared" "default")
-                        # 1        2                                    3              4
-
-                        # cyrus imapd 2.2.13
-                        # "folder" "/vendor/cmu/cyrus-imapd/expire" ("value.shared" "90")
-                        # 1        2                                 3              4
-
-                        # Regex 1: server info
-                        # cyrus imapd 2.5.0
-                        # "" "/comment" ("value.shared" "test")
-                        # 1  2           3              4
-                        # "" "/motd" ("value.shared" NIL)
-                        # 1  2        3              4
-                        # "" "/vendor/cmu/cyrus-imapd/expire" ("value.priv" NIL "value.shared" NIL)
-                        # 1  2                                 3            4   5              6
-
-                        # cyrus imapd 2.4.17
-                        # "" "/vendor/cmu/cyrus-imapd/freespace" ("value.shared" "3122744")
-                        # 1  2                                    3              4
-
-                        # Regex 2
-                        # cyrus imapd 2.5.0 (user folder, authorized as user)
-                        # Note: two lines
-                        # INBOX.Sent "/specialuse" ("value.priv" {5}\r\n
-                        # \Sent)>
-                        # 1          2              3            4\r\n
-                        # 5
-
-                        if ($text =~
-                               /^\s*\"?([^"]*)"?\s+"?([^"]*)"?\s+\(\"?([^"\{]*)\"?\s+\"?([^"\{]*)\"?(?:\s+\"?([^"\{]*)\"?\s+\"?([^"\{]*)\"?)?\)/) {
-                          my $key;
-                          if($1 ne "") {
-                                $key = "/mailbox/$2";
-                          } else {
-                                $key = "/server/$2";
-                          }
-                          $d{-rock}->{"$1"}->{_attribname2access($3)}->{$key} = $4;
-                          $d{-rock}->{"$1"}->{_attribname2access($5)}->{$key} = $6 if (defined ($5) && defined ($6));
-                        }  elsif ($text =~
-                               /^\s*"([^"]*)"\s+"([^"]*)"\s+\("([^"\{]*)"\s+\{(.*)\}\r\n/ ||
-                           $text =~
-                               /^\s*([^\s]+)\s+"([^"]*)"\s+\("([^"\{]*)"\s+\{(.*)\}\r\n/) {
-                          my $len = $4;
-                          $text =~ s/^\s*"*([^"\s]*)"*\s+"([^"]*)"\s+\("([^"\{]*)"\s+\{(.*)\}\r\n//s;
-                          $text = substr($text, 0, $len);
-                          # Single annotation (literal style),
-                          # possibly multiple values -- multiple
-                          # values not tested.
-
-                          my $key;
-                          if($1 ne "") {
-                                $key = "/mailbox/$2";
-                          } else {
-                                $key = "/server$2";
-                          }
-                          $d{-rock}{"$1"}->{_attribname2access($3)}->{$key} = $text;
-                        } else {
-                          ; # XXX: unrecognized line, how to notify caller?
-                        }
-                      },
-                      -rock => \%info});
-
-  # send getannotation "/mailbox/name/* or /server/*"
-  my($rc, $msg);
-  if(scalar(@entries)) {
-    foreach my $annot (@entries) {
-      ($rc, $msg) = $self->send('', '', 'GETANNOTATION %s %q ("value.priv" "value.shared")',
-                                $box, $annot);
-      last if($rc ne 'OK');
-    }
-  } else {
-    ($rc, $msg) = $self->send('', '', 'GETANNOTATION %s "*" ("value.priv" "value.shared")',
-                              $box);
-  }
-  $self->addcallback({-trigger => 'ANNOTATION'});
-  if ($rc eq 'OK') {
-    $self->{error} = undef;
-    %info;
-  } else {
-    $self->{error} = $msg;
-    ();
-  }
-}
-*info = *getinfo;
-
 sub mboxconfig {
   my ($self, $mailbox, $entry, $value, $private) = @_;
 
@@ -956,8 +839,8 @@ sub mboxconfig {
                  "squat" => "/vendor/cmu/cyrus-imapd/squat",
                  "pop3showafter" => "/vendor/cmu/cyrus-imapd/pop3showafter" );
 
-  if(!$self->{support_annotatemore}) {
-    $self->{error} = "Remote does not support ANNOTATEMORE.";
+  if(!$self->{support_metadata}) {
+    $self->{error} = "Remote does not support METADATA.";
     return undef;
   }
 
@@ -970,21 +853,20 @@ sub mboxconfig {
   my ($rc, $msg);
 
   $value = undef if($value eq "none");
-  my $attribname;
   if (defined ($private)) {
-    $attribname = "value.priv";
+    $entry = "/private" . $entry;
   } else {
-    $attribname = "value.shared";
+    $entry = "/shared" . $entry;
   }
 
   if(defined($value)) {
     ($rc, $msg) = $self->send('', '',
-                              'SETANNOTATION %q %q (%q %q)',
-                              $mailbox, $entry, $attribname, $value);
+                              'SETMETADATA %q (%q %q)',
+                              $mailbox, $entry, $value);
   } else {
     ($rc, $msg) = $self->send('', '',
-                              'SETANNOTATION %q %q (%q NIL)',
-                              $mailbox, $entry, $attribname);
+                              'SETMETADATA %q (%q NIL)',
+                              $mailbox, $entry);
   }
 
   if ($rc eq 'OK') {
@@ -1020,8 +902,8 @@ sub mboxconfig {
 sub setinfoserver {
   my ($self, $entry, $value) = @_;
 
-  if(!$self->{support_annotatemore}) {
-    $self->{error} = "Remote does not support ANNOTATEMORE.";
+  if(!$self->{support_metadata}) {
+    $self->{error} = "Remote does not support METADATA.";
     return undef;
   }
 
@@ -1038,13 +920,15 @@ sub setinfoserver {
 
   my ($rc, $msg);
 
+  $entry = "/shared" . $entry;
+
   if(defined($value)) {
     ($rc, $msg) = $self->send('', '',
-                              "SETANNOTATION \"\" %q (\"value.shared\" %q)",
+                              "SETMETADATA \"\" (%q %q)",
                               $entry, $value);
   } else {
     ($rc, $msg) = $self->send('', '',
-                              "SETANNOTATION \"\" %q (\"value.shared\" NIL)",
+                              "SETMETADATA \"\" (%q NIL)",
                               $entry);
   }
 
@@ -1079,10 +963,38 @@ sub getmetadata {
                         my $text = $d{-text};
 
                         # There were several draft iterations of this,
-                        # but since we send only the latest form command,
-                        # this is the only possible response.
-
+                        # but we only support the latest form command.
+                        # Still, we might encounter entry-value pairs
+                        # with nstring or literal8 values, possibly
+                        # mixed in the same response.
+                        # XXX Known bug:
+                        # We support single nstring and literal8 entry
+                        # value pairs, but only multiple nstring pairs.
                         if ($text =~
+                                /^\s*\"?([^\(]*?)\"?\s+\(((\"?[^"\{]+\"?\s+\"?[^"\)\{]+\"?\s*)+)\)/) {
+                            my $mdbox = $1;
+                            my $pairs = $2;
+                            while ($pairs =~ /\"?([^"\{]+)\"?\s+\"?([^"\)\{]+)\"?/g) {
+                                my $mdkey = $1;
+                                my $mdvalue = $2;
+                                if($mdbox ne "") {
+                                    $mdkey = "/mailbox/$mdkey";
+                                    if ($mdkey =~ /private/) {
+                                        $d{-rock}->{"$mdbox"}->{'private'}->{$mdkey} = $mdvalue;
+                                    } elsif ($mdkey =~ /shared/) {
+                                        $d{-rock}->{"$mdbox"}->{'shared'}->{$mdkey} = $mdvalue;
+                                    }
+                                } else {
+                                    $mdkey = "/server/$mdkey";
+                                    if ($mdkey =~ /private/) {
+                                        $d{-rock}->{"$mdbox"}->{'private'}->{$mdkey} = $mdvalue;
+                                    } elsif ($mdkey =~ /shared/) {
+                                        $d{-rock}->{"$mdbox"}->{'shared'}->{$mdkey} = $mdvalue;
+                                    }
+                                }
+                            }
+                        }
+                        elsif ($text =~
                                 /^\s*\"?([^\(]*?)\"?\s+\(\"?([^"\{]*)\"?\s+\"?([^"\)\{]*)\"?\)/) {
                             my $mdbox = $1;
                             my $mdkey = $2;
@@ -1138,14 +1050,14 @@ sub getmetadata {
   my($rc, $msg);
   if(scalar(@entries)) {
     foreach my $annot (@entries) {
-      ($rc, $msg) = $self->send('', '', "GETMETADATA %s (%q)",
+      ($rc, $msg) = $self->send('', '', "GETMETADATA %q (%q)",
                                 $box, $annot);
       last if($rc ne 'OK');
     }
   } else {
-    ($rc, $msg) = $self->send('', '', "GETMETADATA %s (\"/private/*\")",
+    ($rc, $msg) = $self->send('', '', "GETMETADATA %q (\"/private/*\")",
                               $box);
-    ($rc, $msg) = $self->send('', '', "GETMETADATA %s (\"/shared/*\")",
+    ($rc, $msg) = $self->send('', '', "GETMETADATA %q (\"/shared/*\")",
                               $box);
   }
   $self->addcallback({-trigger => 'METADATA'});
@@ -1159,6 +1071,23 @@ sub getmetadata {
 }
 *info = *getmetadata;
 
+sub getinfo {
+  my $self = shift;
+  my $box = shift;
+  my @entries = @_;
+  my @myentries;
+
+  if(scalar(@entries)) {
+      foreach my $annot (@entries) {
+          push @myentries, '/private' . $annot;
+          push @myentries, '/shared' . $annot;
+      }
+  }
+  return $self->getmetadata($box, @myentries);
+}
+*info = *getinfo;
+
+
 sub setmetadata {
   my ($self, $mailbox, $entry, $value, $private) = @_;
 
diff -pruN 3.0.13-5/perl/imap/IMAP/Shell.pm 3.2.0-3/perl/imap/IMAP/Shell.pm
--- 3.0.13-5/perl/imap/IMAP/Shell.pm	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/IMAP/Shell.pm	2020-04-24 02:03:00.000000000 +0000
@@ -511,7 +511,7 @@ Usage: cyradm [args] server
   --userrc <file>       Use user configuration <file>
   --port <port>         Connect to server on <port>
   --auth <mechanism>    Authenticate with <mechanism>
-  --tlskey <keyfile>    Use certicate with keyfile to authenticate with server
+  --tlskey <keyfile>    Use certificate with keyfile to authenticate with server
   --notls               Disable StartTLS negotiation
   --cafile <cacertfile> Use CA certificate file to validate server certificate
   --cadir <cacertdirectory> Use CA certificate directory to validate
@@ -640,7 +640,7 @@ sub _sc_list {
 
   if ($subscribed) {
     if (scalar (keys %opts) > 0 ) {
-      # LIST + LIST-EXTENED
+      # LIST + LIST-EXTENDED
       $opts{'-sel-subscribed'} = 1;
     } else {
       # LSUB
@@ -1857,8 +1857,8 @@ corresponding user.
 
 Note that in the above example, the C<unixhierarchysep> setting in
 imapd.conf is set to C<0>. When using the UNIX
-hierarchy seperator, the C</> (forward slash) character would be
-used as the hierarchy seperator, and the example would look as
+hierarchy separator, the C</> (forward slash) character would be
+used as the hierarchy separator, and the example would look as
 follows:
 
 =item Example Usage with C<unixhierarchysep: 1>
@@ -1941,13 +1941,23 @@ Show help for C<command> or all commands
 
 aliases: C<?>
 
+=for pod2rst .. _imap-reference-manpages-systemcommands-cyradm-getmetadata:
+
+=head2 getmetadata
+
+B<getmetadata> [I<mailbox>]
+
+Display mailbox/server metadata
+
+aliases: C<getmd>
+
 =for pod2rst .. _imap-reference-manpages-systemcommands-cyradm-info:
 
 =head2 info
 
 B<info> [I<mailbox>]
 
-Display the mailbox/server metadata.
+Display the mailbox/server annotations.
 
 =for pod2rst .. _imap-reference-manpages-systemcommands-cyradm-listaclmailbox:
 
@@ -2199,6 +2209,41 @@ them (unless overridden by a mailbox ann
 
 =back
 
+=for pod2rst .. _imap-reference-manpages-systemcommands-cyradm-setmetadata:
+
+=head2 setmetadata
+
+B<setmetadata> [--private] mailbox [I<annotation>] I<value>
+
+Set metadata on mailbox, where I<annotation> is one of
+[comment|expire|news2mail|pop3showafter|sharedseen|sieve|specialuse|
+squat|/<explicit annotation>].
+
+Note that I<value> with a leading backslash must be escaped with an
+additional backslash.  For example:
+
+=over 4
+
+  setmetadata --private Spam specialuse "\\Junk"
+
+=back
+
+Note, too, that "private" annotations are private to the user currently
+authenticated as, not necessarily the owner of the mailbox.  To set
+annotations for another user you must authorize as that user.
+
+In addition to the use of optional flag B<--private>, one may use a more
+explicit syntax, prefixing the annotation with '/shared/' or '/private/'
+as in this example:
+
+=over 4
+
+  setmetadata Spam /private/specialuse "\\Junk"
+
+=back
+
+aliases: C<setmd>
+
 =for pod2rst .. _imap-reference-manpages-systemcommands-cyradm-setquota:
 
 =head2 setquota
diff -pruN 3.0.13-5/perl/imap/Makefile.PL 3.2.0-3/perl/imap/Makefile.PL
--- 3.0.13-5/perl/imap/Makefile.PL	2019-12-16 04:16:06.000000000 +0000
+++ 3.2.0-3/perl/imap/Makefile.PL	2020-05-04 04:10:32.000000000 +0000
@@ -80,7 +80,7 @@ installcheck:
 EOT
 }
 
-WriteMakefile( 
+WriteMakefile(
     'NAME'	=> 'Cyrus::IMAP',
     'ABSTRACT'  => 'Cyrus administrative interface',
     'VERSION_FROM' => "../../perl/imap/IMAP.pm", # finds $VERSION
@@ -88,11 +88,12 @@ WriteMakefile(
 		    'IMCLIENT_LIBS' => '',	# hack
 		},
     'clean'	=> {'FILES' => 'libcyrperl.a cyradm'},
+    'LD'       => $Config{ld} . ' ',
     'OBJECT'    => 'IMAP.o',
     'MYEXTLIB'  => '../../perl/.libs/libcyrus.a ../../perl/.libs/libcyrus_min.a',
-    'LIBS'	=> [ "$LIB_SASL -lssl -lcrypto -lssl -lcrypto  -luuid -lz"],
-    'DEFINE'	=> '-DPERL_POLLUTE',    # e.g., '-DHAVE_SOMETHING' 
-    'INC'	=> "-I../.. -I../../com_err/et   -I../../perl/imap", 
+    'LIBS'	=> [ "$LIB_SASL -lssl -lcrypto -lssl -lcrypto  -luuid -lz  "],
+    'DEFINE'	=> '-DPERL_POLLUTE',    # e.g., '-DHAVE_SOMETHING'
+    'INC'	=> "-I../.. -I../../com_err/et    -I../../perl/imap",
     'EXE_FILES' => [cyradm],
     # This is a disgusting hack to effectively disable the stupid
     # behaviour of the generated Makefile which moves itself aside
diff -pruN 3.0.13-5/perl/imap/Makefile.PL.in 3.2.0-3/perl/imap/Makefile.PL.in
--- 3.0.13-5/perl/imap/Makefile.PL.in	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/imap/Makefile.PL.in	2020-04-24 02:03:00.000000000 +0000
@@ -80,7 +80,7 @@ installcheck:
 EOT
 }
 
-WriteMakefile( 
+WriteMakefile(
     'NAME'	=> 'Cyrus::IMAP',
     'ABSTRACT'  => 'Cyrus administrative interface',
     'VERSION_FROM' => "@top_srcdir@/perl/imap/IMAP.pm", # finds $VERSION
@@ -88,11 +88,12 @@ WriteMakefile(
 		    'IMCLIENT_LIBS' => '',	# hack
 		},
     'clean'	=> {'FILES' => 'libcyrperl.a cyradm'},
+    'LD'       => $Config{ld} . ' @GCOV_LDFLAGS@',
     'OBJECT'    => 'IMAP.o',
     'MYEXTLIB'  => '@top_builddir@/perl/.libs/libcyrus.a @top_builddir@/perl/.libs/libcyrus_min.a',
-    'LIBS'	=> [ "$LIB_SASL @SSL_LIBS@ @LIB_UUID@ @ZLIB@"],
-    'DEFINE'	=> '-DPERL_POLLUTE',    # e.g., '-DHAVE_SOMETHING' 
-    'INC'	=> "-I@top_srcdir@ -I@top_srcdir@/com_err/et @SASLFLAGS@ @SSL_CPPFLAGS@ -I@top_srcdir@/perl/imap", 
+    'LIBS'	=> [ "$LIB_SASL @SSL_LIBS@ @LIB_UUID@ @ZLIB@ @GCOV_LIBS@ @LIBCAP_LIBS@"],
+    'DEFINE'	=> '-DPERL_POLLUTE',    # e.g., '-DHAVE_SOMETHING'
+    'INC'	=> "-I@top_srcdir@ -I@top_srcdir@/com_err/et @SASLFLAGS@ @SSL_CPPFLAGS@ @GCOV_CFLAGS@ -I@top_srcdir@/perl/imap",
     'EXE_FILES' => [cyradm],
     # This is a disgusting hack to effectively disable the stupid
     # behaviour of the generated Makefile which moves itself aside
diff -pruN 3.0.13-5/perl/sieve/lib/isieve.c 3.2.0-3/perl/sieve/lib/isieve.c
--- 3.0.13-5/perl/sieve/lib/isieve.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/sieve/lib/isieve.c	2020-04-24 02:03:00.000000000 +0000
@@ -53,6 +53,7 @@
 #include <unistd.h>
 
 #include "iptostring.h"
+#include "util.h"
 #include "xmalloc.h"
 #include "perl/sieve/lib/isieve.h"
 #include "perl/sieve/lib/lex.h"
@@ -195,14 +196,7 @@ int init_sasl(isieve_t *obj,
   addrsize=sizeof(struct sockaddr_storage);
   if (getsockname(obj->sock,(struct sockaddr *)&saddr_l,&addrsize)!=0)
       return -1;
-#if 0
-  /* XXX  The following line causes problems with KERBEROS_V4 decoding.
-   * We're not sure why its an issue, but this code isn't used in any of
-   * our other client code (imtest.c, backend.c), so we're removing it.
-   */
-  /* set the port manually since getsockname is stupid and doesn't */
-  ((struct sockaddr_in *)&saddr_l)->sin_port = htons(obj->port);
-#endif
+
   if (iptostring((struct sockaddr *)&saddr_r, addrsize, remoteip, 60))
       return -1;
 
@@ -437,7 +431,7 @@ int auth_sasl(char *mechlist, isieve_t *
         fillin_interactions(client_interact); /* fill in prompts */
     }
 
-    /* check if sasl suceeded */
+    /* check if sasl succeeded */
     if (saslresult<SASL_OK)
     {
         /* send cancel notice */
@@ -571,11 +565,19 @@ static int do_referral(isieve_t *obj, ch
 
             switch (callbacks[n].id) {
             case SASL_CB_USER:
+#if GCC_VERSION >= 80000
+                callbacks[n].proc = (void*)&refer_simple_cb;
+#else
                 callbacks[n].proc = (int (*)(void))&refer_simple_cb;
+#endif
                 callbacks[n].context = userid ? userid : authid;
                 break;
             case SASL_CB_AUTHNAME:
+#if GCC_VERSION >= 80000
+                callbacks[n].proc = (void*)&refer_simple_cb;
+#else
                 callbacks[n].proc = (int (*)(void))&refer_simple_cb;
+#endif
                 callbacks[n].context = authid;
                 break;
             default:
diff -pruN 3.0.13-5/perl/sieve/lib/request.c 3.2.0-3/perl/sieve/lib/request.c
--- 3.0.13-5/perl/sieve/lib/request.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/sieve/lib/request.c	2020-04-24 02:03:00.000000000 +0000
@@ -279,11 +279,6 @@ static char *getsievename(char *filename
 
   strcpy(ret, ptr);
 
-  if ( strcmp( ret + strlen(ret) - 7,".script")==0)
-  {
-    ret[ strlen(ret) - 7] = '\0';
-  }
-
   return ret;
 }
 
@@ -377,65 +372,6 @@ int installafile(int version,struct prot
   return 0;
 }
 
-
-/*
-int showlist(int version, struct protstream *pout, struct protstream *pin,
-             char **refer_to)
-{
-  lexstate_t state;
-  int end=0;
-  int res;
-  int ret = 0;
-
-  printf("You have the following scripts on the server:\n");
-
-  prot_printf(pout, "LISTSCRIPTS\r\n");
-  prot_flush(pout);
-
-  do {
-
-    if ((res=yylex(&state, pin))==STRING)
-    {
-      char *str=state.str;
-
-      if (yylex(&state, pin)==' ')
-      {
-          if (yylex(&state, pin)!=TOKEN_ACTIVE)
-              printf("Expected ACTIVE\n");
-          if (yylex(&state, pin)!=EOL)
-              printf("Expected EOL\n");
-
-          printf("  %s  <- Active Sieve Script\n",str);
-      } else {
-
-          // in old version we had that '*' means active script thing
-          if (version == OLD_VERSION) {
-
-              if (str[strlen(str)-1]=='*') {
-                  str[strlen(str)-1]='\0';
-                  printf("  %s  <- Active Sieve Script\n",str);
-              } else {
-                  printf("  %s\n",str);
-              }
-
-          } else { // NEW_VERSION
-              // assume it's a EOL
-              printf("  %s\n",str);
-          }
-      }
-
-    } else {
-
-        ret = handle_response(res,version,pin,refer_to,NULL);
-
-        end=1;
-    }
-  } while (end==0);
-
-  return ret;
-}
-*/
-
 int list_wcb(int version, struct protstream *pout,
              struct protstream *pin,isieve_listcb_t *cb ,void *rock,
              char **refer_to)
@@ -520,87 +456,6 @@ int setscriptactive(int version, struct
   return 0;
 }
 
-#if 0
-static int viewafile(const char *data, char *name __attribute__((unused)))
-{
-  printf("%s\r\n", data);
-
-  return 0;
-}
-#endif
-
-#if 0
-static int writefile(const char *data, const char *name, char **errstrp)
-{
-  FILE *stream;
-
-  char *scrname;
-
-  scrname = strconcat(name, ".script", (char *)NULL);
-
-  stream=fopen(scrname,"w");
-
-  free(scrname);
-
-  if (stream==NULL) {
-      *errstrp = strconcat(
-                    "writefile: unable to open ",
-                    name,
-                    " for writing",
-                    (char *)NULL);
-      return -1;
-  }
-
-  fwrite(data, 1, strlen(data), stream);
-
-  fclose(stream);
-
-  return 0;
-}
-#endif
-
-/*
-int getscript(int version, struct protstream *pout,
-              struct protstream *pin, const char *name, int save,
-              char **refer_to, char **errstrp)
-{
-  int res;
-  char *errstr=NULL;
-  lexstate_t state;
-  int ret = 0;
-
-  prot_printf(pout,"GETSCRIPT \"%s\"\r\n",name);
-  prot_flush(pout);
-
-  res=yylex(&state,pin);
-
-  if (res==STRING)
-  {
-
-    if (save==1)
-      writefile(state.str, name, errstrp);
-    else
-      viewafile(state.str, name);
-
-    if (yylex(&state, pin)!=EOL)
-      parseerror("EOL");
-
-    res=yylex(&state,pin);
-  }
-
-  ret = handle_response(res, version, pin, refer_to, &errstr);
-
-  // if command failed
-  if(ret == -2 && *refer_to) {
-      return -2;
-  } else if (ret!=0) {
-      *errstrp = errstr;
-  }
-
-  return ret;
-}
-*/
-
 int getscriptvalue(int version, struct protstream *pout,
                    struct protstream *pin, char *name, char **data,
                    char **refer_to, char **errstrp)
diff -pruN 3.0.13-5/perl/sieve/lib/request.h 3.2.0-3/perl/sieve/lib/request.h
--- 3.0.13-5/perl/sieve/lib/request.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/sieve/lib/request.h	2020-04-24 02:03:00.000000000 +0000
@@ -78,7 +78,7 @@ int setscriptactive(int version, struct
                     char *name, char **refer_to, char **errstr);
 
 /*
- * Getscript. Save {0,1} wheather to save to disk or display on screen
+ * Getscript. Save {0,1} whether to save to disk or display on screen
  */
 
 //int getscript(int version, struct protstream *pout, struct protstream *pin,
diff -pruN 3.0.13-5/perl/sieve/managesieve/managesieve.xs 3.2.0-3/perl/sieve/managesieve/managesieve.xs
--- 3.0.13-5/perl/sieve/managesieve/managesieve.xs	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/sieve/managesieve/managesieve.xs	2020-03-09 03:19:23.000000000 +0000
@@ -296,7 +296,7 @@ sieve_get_handle(char *servername, SV *u
            check if SASL mech list changed */
         if (detect_mitm(obj, mechlist)) {
             globalerr = "possible MITM attack: "
-                "list of available SASL mechamisms changed";
+                "list of available SASL mechanisms changed";
             free(ret);
             free(mechlist);
             XSRETURN_UNDEF;
diff -pruN 3.0.13-5/perl/sieve/scripts/sieveshell.pl 3.2.0-3/perl/sieve/scripts/sieveshell.pl
--- 3.0.13-5/perl/sieve/scripts/sieveshell.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/perl/sieve/scripts/sieveshell.pl	2020-04-24 02:03:00.000000000 +0000
@@ -1,8 +1,6 @@
-#! /bin/sh
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
+#!/usr/bin/perl
 #
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+# Copyright (c) 1994-2020 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -42,6 +40,9 @@ exec perl -x -S $0 ${1+"$@"} # -*-perl-*
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 #
 
+use strict;
+use warnings;
+
 use Cyrus::SIEVE::managesieve;
 use Getopt::Long;
 use strict;
@@ -323,12 +324,13 @@ B<deactivate> deactivate all scripts.
 
 =item B<-u> I<user>, B<--user>=I<user>
 
-The authorization name to request; by default, derived from the
-authentication credentials.
+The user whose mailboxes you want to work on. If not specified, it uses the same
+as -a.
 
 =item B<-a> I<authname>, B<--authname>=I<authname>
 
-The user to use for authentication (defaults to current user).
+The user to use for authentication. If not specified, it defaults to the
+current login user.
 
 =item B<-r> I<realm>, B<--realm>=I<realm>
 
@@ -344,8 +346,7 @@ exit when done.
 =head1 REFERENCES
 
 [MANAGESIEVE] Martin, T.; "A Protocol for Remotely Managing Sieve
-Scripts", draft-ietf-managesieve-03.txt, Mirapoint, Inc.; May 2001,
-work in progress.
+Scripts", RFC 5804; May 2001
 
 =head1 AUTHOR
 
diff -pruN 3.0.13-5/ptclient/afskrb.c 3.2.0-3/ptclient/afskrb.c
--- 3.0.13-5/ptclient/afskrb.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/ptclient/afskrb.c	2020-04-24 02:03:00.000000000 +0000
@@ -39,11 +39,11 @@
  * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
+#include <config.h>
 #include <ctype.h>
+#include <sysexits.h>
 #include <syslog.h>
-#include <config.h>
 #include "ptloader.h"
-#include "exitcodes.h"
 #include "util.h"
 #include "xmalloc.h"
 
@@ -445,7 +445,7 @@ static void myinit(void)
     int r = pr_Initialize (1L, AFSCONF_CLIENTNAME, config_getstring(IMAPOPT_AFSPTS_MYCELL));
     if (r) {
         syslog(LOG_DEBUG, "pr_Initialize failed: %d", r);
-        fatal("pr_initialize failed", EC_TEMPFAIL);
+        fatal("pr_initialize failed", EX_TEMPFAIL);
     }
 
     localrealms = config_getstring(IMAPOPT_AFSPTS_LOCALREALMS);
@@ -484,7 +484,7 @@ static struct auth_state *myauthstate(co
         rc = pr_Initialize (1L, AFSCONF_CLIENTNAME, config_getstring(IMAPOPT_AFSPTS_MYCELL));
         if (rc) {
             syslog(LOG_DEBUG, "pr_Initialize failed: %d", rc);
-            fatal("pr_Initialize failed", EC_TEMPFAIL);
+            fatal("pr_Initialize failed", EX_TEMPFAIL);
         }
         /* Okay, rerun it now */
         rc = pr_ListMembers(canon_id_tmp, &groups);
@@ -507,9 +507,10 @@ static struct auth_state *myauthstate(co
        authentication problem, and cache only for a minute.
        Should negative cache time be configurable? */
     if (rc == PRPERM) {
-        newstate->mark = time(0) + 60 -
-            (config_getint(IMAPOPT_PTSCACHE_TIMEOUT) > 60)?
-            config_getint(IMAPOPT_PTSCACHE_TIMEOUT) : 60;
+        int ptscache_timeout = config_getduration(IMAPOPT_PTSCACHE_TIMEOUT, 's');
+        if (ptscache_timeout < 60)
+            ptscache_timeout = 60;
+        newstate->mark = time(0) + 60 - ptscache_timeout;
     } else
         newstate->mark = time(0);
 
@@ -535,7 +536,7 @@ static struct auth_state *myauthstate(co
 
 static void myinit(void)
 {
-        fatal("PTS module (afskrb) not compiled in", EC_CONFIG);
+        fatal("PTS module (afskrb) not compiled in", EX_CONFIG);
 }
 
 static struct auth_state *myauthstate(
@@ -544,7 +545,7 @@ static struct auth_state *myauthstate(
     const char **reply __attribute__((unused)),
     int *dsize __attribute__((unused)))
 {
-        fatal("PTS module (afskrb) not compiled in", EC_CONFIG);
+        fatal("PTS module (afskrb) not compiled in", EX_CONFIG);
         return NULL;
 }
 
diff -pruN 3.0.13-5/ptclient/ldap.c 3.2.0-3/ptclient/ldap.c
--- 3.0.13-5/ptclient/ldap.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/ptclient/ldap.c	2020-04-24 02:03:00.000000000 +0000
@@ -40,10 +40,10 @@
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+#include <sysexits.h>
 #include <syslog.h>
 #include <config.h>
 #include "ptloader.h"
-#include "exitcodes.h"
 #include "util.h"
 #include "assert.h"
 
@@ -454,14 +454,13 @@ static void myinit(void)
 
     ptsm = xmalloc(sizeof(t_ptsm));
     if (ptsm == NULL) {
-        fatal("xmalloc() failed", EC_CONFIG);
+        fatal("xmalloc() failed", EX_CONFIG);
     }
 
-    ptsm->uri = (config_getstring(IMAPOPT_LDAP_URI) ?
-        config_getstring(IMAPOPT_LDAP_URI) : config_getstring(IMAPOPT_LDAP_SERVERS));
+    ptsm->uri = config_getstring(IMAPOPT_LDAP_URI);
 
     ptsm->version = (config_getint(IMAPOPT_LDAP_VERSION) == 2 ? LDAP_VERSION2 : LDAP_VERSION3);
-    ptsm->timeout.tv_sec = config_getint(IMAPOPT_LDAP_TIMEOUT);
+    ptsm->timeout.tv_sec = config_getduration(IMAPOPT_LDAP_TIMEOUT, 's');
     ptsm->timeout.tv_usec = 0;
     ptsm->restart = config_getswitch(IMAPOPT_LDAP_RESTART);
 
@@ -479,7 +478,7 @@ static void myinit(void)
 
     ptsm->referrals = config_getswitch(IMAPOPT_LDAP_REFERRALS);
     ptsm->size_limit = config_getint(IMAPOPT_LDAP_SIZE_LIMIT);
-    ptsm->time_limit = config_getint(IMAPOPT_LDAP_TIME_LIMIT);
+    ptsm->time_limit = config_getduration(IMAPOPT_LDAP_TIME_LIMIT, 's');
 
     p = config_getstring(IMAPOPT_LDAP_SCOPE);
 
@@ -493,21 +492,11 @@ static void myinit(void)
 
     ptsm->bind_dn = config_getstring(IMAPOPT_LDAP_BIND_DN);
     ptsm->sasl = config_getswitch(IMAPOPT_LDAP_SASL);
-    ptsm->id = (config_getstring(IMAPOPT_LDAP_ID) ?
-        config_getstring(IMAPOPT_LDAP_ID) : config_getstring(IMAPOPT_LDAP_SASL_AUTHC));
-
-    ptsm->authz = (config_getstring(IMAPOPT_LDAP_AUTHZ) ?
-        config_getstring(IMAPOPT_LDAP_AUTHZ) : config_getstring(IMAPOPT_LDAP_SASL_AUTHZ));
-
-    ptsm->mech = (config_getstring(IMAPOPT_LDAP_MECH) ?
-        config_getstring(IMAPOPT_LDAP_MECH) : config_getstring(IMAPOPT_LDAP_SASL_MECH));
-
-    ptsm->realm = (config_getstring(IMAPOPT_LDAP_REALM) ?
-        config_getstring(IMAPOPT_LDAP_REALM) : config_getstring(IMAPOPT_LDAP_SASL_REALM));
-
-    ptsm->password = (config_getstring(IMAPOPT_LDAP_PASSWORD) ?
-        config_getstring(IMAPOPT_LDAP_PASSWORD) : config_getstring(IMAPOPT_LDAP_SASL_PASSWORD));
-
+    ptsm->id = config_getstring(IMAPOPT_LDAP_ID);
+    ptsm->authz = config_getstring(IMAPOPT_LDAP_AUTHZ);
+    ptsm->mech = config_getstring(IMAPOPT_LDAP_MECH);
+    ptsm->realm = config_getstring(IMAPOPT_LDAP_REALM);
+    ptsm->password = config_getstring(IMAPOPT_LDAP_PASSWORD);
     ptsm->start_tls = config_getswitch(IMAPOPT_LDAP_START_TLS);
     ptsm->tls_check_peer = config_getswitch(IMAPOPT_LDAP_VERIFY_PEER);
     ptsm->tls_cacert_file = config_getstring(IMAPOPT_LDAP_CA_FILE);
@@ -723,7 +712,7 @@ static int ptsmodule_tokenize_domains(
  *   %%   = %
  *   %u   = user
  *   %U   = user part of %u
- *   %d   = domain part of %u if available, othwise same as %r
+ *   %d   = domain part of %u if available, otherwise same as %R
  *   %R   = prepend '@' to domain
  *   %1-9 = domain tokens (%1 = tld, %2 = domain when %d = domain.tld)
  *   %D   = user DN
@@ -937,7 +926,13 @@ static int ptsmodule_get_dn(
         if (ptsm->domain_base_dn && ptsm->domain_base_dn[0] != '\0' && (strrchr(canon_id, '@') == NULL)) {
             syslog(LOG_DEBUG, "collecting all domains from %s", ptsm->domain_base_dn);
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-nonliteral"
+            /* Format string comes from imapd.conf.  Not ideal, but it's what
+             * we've got...
+             */
             snprintf(domain_filter, sizeof(domain_filter), ptsm->domain_filter, "*");
+#pragma GCC diagnostic pop
 
             syslog(LOG_DEBUG, "Domain filter: %s", domain_filter);
 
@@ -1000,7 +995,13 @@ static int ptsmodule_get_dn(
             /* Strip the first character which is a '@' */
             domain = domain+1;
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-nonliteral"
+            /* Format string comes from imapd.conf.  Not ideal, but it's what
+             * we've got...
+             */
             snprintf(domain_filter, sizeof(domain_filter), ptsm->domain_filter, domain);
+#pragma GCC diagnostic pop
 
             syslog(LOG_DEBUG, "Domain filter: %s", domain_filter);
 
@@ -1438,7 +1439,13 @@ static int ptsmodule_make_authstate_grou
 
         syslog(LOG_DEBUG, "(groups) Input domain would be %s", domain);
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wformat-nonliteral"
+            /* Format string comes from imapd.conf.  Not ideal, but it's what
+             * we've got...
+             */
         snprintf(domain_filter, sizeof(domain_filter), ptsm->domain_filter, domain);
+#pragma GCC diagnostic pop
 
         syslog(LOG_DEBUG, "(groups) Domain filter: %s", domain_filter);
 
@@ -1586,7 +1593,7 @@ retry:;
 
 static void myinit(void)
 {
-    fatal("PTS module (ldap) not compiled in", EC_CONFIG);
+    fatal("PTS module (ldap) not compiled in", EX_CONFIG);
 }
 
 static struct auth_state *myauthstate(
@@ -1595,7 +1602,7 @@ static struct auth_state *myauthstate(
     const char **reply __attribute__((unused)),
     int *dsize __attribute__((unused)))
 {
-    fatal("PTS module (ldap) not compiled in", EC_CONFIG);
+    fatal("PTS module (ldap) not compiled in", EX_CONFIG);
 }
 
 #endif /* HAVE_LDAP */
diff -pruN 3.0.13-5/ptclient/ptexpire.c 3.2.0-3/ptclient/ptexpire.c
--- 3.0.13-5/ptclient/ptexpire.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/ptclient/ptexpire.c	2020-04-24 02:03:00.000000000 +0000
@@ -60,11 +60,11 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
+#include <sysexits.h>
 #include <syslog.h>
 
 #include "auth_pts.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "imap/global.h"
 #include "libconfig.h"
 #include "xmalloc.h"
diff -pruN 3.0.13-5/ptclient/ptloader.c 3.2.0-3/ptclient/ptloader.c
--- 3.0.13-5/ptclient/ptloader.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/ptclient/ptloader.c	2020-04-24 02:03:00.000000000 +0000
@@ -46,6 +46,7 @@
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <sys/stat.h>
 #include <sys/types.h>
@@ -57,7 +58,6 @@
 
 #include "auth_pts.h"
 #include "cyrusdb.h"
-#include "exitcodes.h"
 #include "imap/global.h"
 #include "libconfig.h"
 #include "retry.h"
@@ -94,7 +94,7 @@ static struct pts_module *pts_fromname()
         char errbuf[1024];
         snprintf(errbuf, sizeof(errbuf),
                  "PTS module %s not supported", name);
-        fatal(errbuf, EC_CONFIG);
+        fatal(errbuf, EX_CONFIG);
     }
 
     return pts;
@@ -130,7 +130,7 @@ int service_init(int argc, char *argv[],
     const char *fname;
     char *tofree = NULL;
 
-    if (geteuid() == 0) fatal("must run as the Cyrus user", EC_USAGE);
+    if (geteuid() == 0) fatal("must run as the Cyrus user", EX_USAGE);
     setproctitle_init(argc, argv, envp);
 
     /* set signal handlers */
@@ -162,8 +162,8 @@ int service_init(int argc, char *argv[],
     r = cyrusdb_open(config_ptscache_db, fname, CYRUSDB_CREATE, &ptsdb);
     if (r != 0) {
         syslog(LOG_ERR, "DBERROR: opening %s: %s", fname,
-               cyrusdb_strerror(ret));
-        fatal("can't read pts database", EC_TEMPFAIL);
+               cyrusdb_strerror(r));
+        fatal("can't read pts database", EX_TEMPFAIL);
     }
 
     if (tofree) free(tofree);
diff -pruN 3.0.13-5/README.md 3.2.0-3/README.md
--- 3.0.13-5/README.md	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/README.md	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,8 @@
-[![Build Status:master](https://api.travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=master)](https://travis-ci.org/cyrusimap/cyrus-imapd)
-[![Build Status:3.x](https://api.travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0)](https://travis-ci.org/cyrusimap/cyrus-imapd)
+<sup>master: </sup>[![Build Status:master](https://api.travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=master)](https://travis-ci.org/cyrusimap/cyrus-imapd)
+<sup> stable(3.0): </sup>[![Build Status:3.x](https://api.travis-ci.org/cyrusimap/cyrus-imapd.svg?branch=cyrus-imapd-3.0)](https://travis-ci.org/cyrusimap/cyrus-imapd)
 [![IRC](https://img.shields.io/badge/IRC-%23cyrus-1e72ff.svg?style=flat)](http://webchat.freenode.net/?channels=cyrus)
 
+-----
 
 Welcome
 =======
@@ -44,7 +45,7 @@ How to get Cyrus
 
 Cyrus comes in three flavours: 
 
-1. Our release source tarballs from ftp://ftp.cyrusimap.org/cyrus-imapd/
+1. Our release source tarballs from https://github.com/cyrusimap/cyrus-imapd/releases
     * Recommended for most users.
     * These are packaged by the Cyrus team.
     * The docs are pre-built for you in doc/html.
diff -pruN 3.0.13-5/sieve/bc_emit.c 3.2.0-3/sieve/bc_emit.c
--- 3.0.13-5/sieve/bc_emit.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/bc_emit.c	2020-04-24 02:03:00.000000000 +0000
@@ -1,8 +1,9 @@
 /* bc_emit.c -- sieve bytecode - pass 2 of the compiler
  * Rob Siemborski
  * Jen Smith
+ * Ken Murchison
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -54,15 +55,16 @@
 #include <syslog.h>
 #include <sys/types.h>
 #include <unistd.h>
+#include <assert.h>
 
 
 #if DUMPCODE
 void dump(bytecode_info_t *d, int level);
 #endif
 
-static inline int write_int (int fd, int x)
+static inline int write_int(int fd, int x)
 {
-    int y=htonl(x);
+    int y = htonl(x);
     return (write(fd, &y, sizeof(int)));
 }
 
@@ -74,21 +76,54 @@ static int align_string(int fd, int stri
     /* Keep in mind that we always want to pad a string with *at least*
      * one zero, that's why sometimes we have to pad with 4 */
     int needed = sizeof(int) - (string_len % sizeof(int));
-    if (needed>= 0 && needed <=4)
-    {
+    if (needed >= 0 && needed <= 4) {
         if (write(fd, "\0\0\0\0", needed) == -1) return -1;
     }
     return needed;
 }
 
-/*all functions keep codep up to date as they use it.
-  the amount that has been written to the file is maintained by the
-  filelen variable in bc_action_emit
-  the other bc_xxx_emit funtions keep track of how much they (and any functions
-  they call) have written and return this value
+/* all functions keep codep up to date as they use it.
+   the amount that has been written to the file is maintained by the
+   filelen variable in bc_action_emit
+   the other bc_xxx_emit functions keep track of how much they (and any functions
+   they call) have written and return this value
 */
 
 
+/* Write out a string to a given file descriptor.
+ * return # of bytes written on success and -1 on error
+
+ * <string:(size)(aligned string)>
+ */
+static int bc_string_emit(int fd, int *codep, bytecode_info_t *bc)
+{
+    int len = bc->data[*codep].u.str ? (int) strlen(bc->data[*codep].u.str) : -1;
+    int wrote = 0;
+
+    /* Write string length */
+    if (write_int(fd, len) == -1) return -1;
+
+    wrote += sizeof(int);
+
+    if (len == -1) {
+        /* This is a nil string */
+        /* Skip the null pointer and make up for it
+         * by adjusting the offset */
+        (*codep)++;
+    }
+    else {
+        /* Write string */
+        if (write(fd, bc->data[(*codep)++].u.str, len) == -1) return -1;
+
+        int ret = align_string(fd, len);
+        if (ret < 0) return -1;
+
+        wrote += len + ret;
+    }
+
+    return wrote;
+}
+
 /* Write out a stringlist to a given file descriptor.
  * return # of bytes written on success and -1 on error */
 
@@ -98,7 +133,7 @@ static int align_string(int fd, int stri
 */
 static int bc_stringlist_emit(int fd, int *codep, bytecode_info_t *bc)
 {
-    int len = bc->data[(*codep)++].len;
+    int len = bc->data[(*codep)++].u.listlen;
     int i;
     int ret;
     int wrote = 2*sizeof(int);
@@ -108,52 +143,129 @@ static int bc_stringlist_emit(int fd, in
     if (write_int(fd, len)== -1) return -1 ;
 
     /* skip one spot end of list position*/
-    begin=lseek(fd,0,SEEK_CUR);
-    lseek(fd,sizeof(int),SEEK_CUR);
+    begin = lseek(fd, 0, SEEK_CUR);
+    lseek(fd, sizeof(int), SEEK_CUR);
 
     /* Loop through all the items of the list, writing out length and string
      * in sequence */
-    for(i=0; i < len; i++)
-    {
-        int datalen = bc->data[(*codep)++].len;
+    for (i = 0; i < len; i++) {
+        ret = bc_string_emit(fd, codep, bc);
+        if (ret == -1) return -1;
+
+        wrote += ret;
+    }
+    end = lseek(fd, 0, SEEK_CUR);
+    if (end < 0) return -1;
+
+    /* go back and write end of list position */
+    lseek(fd, begin, SEEK_SET);
+    if (write_int(fd, end) == -1) return -1;
 
-        if(write_int(fd, datalen) == -1) return -1;
-        wrote += sizeof(int);
+    /* return to the end */
+    lseek(fd, end, SEEK_SET);
+    return wrote;
+}
+
+/* Write out a valuelist to a given file descriptor.
+ * return # of bytes written on success and -1 on error */
 
-        if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-        wrote += datalen;
+/* valuelist: <# listitems>
+              <pos of listend (bytes)>
+              <int value>
+*/
+static int bc_vallist_emit(int fd, int *codep, bytecode_info_t *bc)
+{
+    int len = bc->data[(*codep)++].u.listlen;
+    int i;
+    int ret;
+    int wrote = 2*sizeof(int);
+    int begin,end;
 
-        ret = align_string(fd,datalen);
-        if(ret == -1) return -1;
+    /* Write out number of items in the list */
+    if (write_int(fd, len)== -1) return -1 ;
 
-        wrote+=ret;
+    /* skip one spot end of list position*/
+    begin = lseek(fd, 0, SEEK_CUR);
+    lseek(fd, sizeof(int), SEEK_CUR);
+
+    /* Loop through all the items of the list, writing out length and string
+     * in sequence */
+    for (i = 0; i < len; i++) {
+        ret = write_int(fd, bc->data[(*codep)++].u.value);
+        if (ret == -1) return -1;
+
+        wrote += ret;
     }
-    end=lseek(fd,0,SEEK_CUR);
+    end = lseek(fd, 0, SEEK_CUR);
     if (end < 0) return -1;
 
     /* go back and write end of list position */
-    lseek(fd,begin,SEEK_SET);
-    if(write_int(fd, end) == -1) return -1;
+    lseek(fd, begin, SEEK_SET);
+    if (write_int(fd, end) == -1) return -1;
 
     /* return to the end */
-    lseek(fd,end,SEEK_SET);
+    lseek(fd, end, SEEK_SET);
     return wrote;
 }
 
-static int bc_test_emit(int fd, int *codep, bytecode_info_t *bc);
+static int bc_params_emit(int fd, int *codep, int stopcodep, bytecode_info_t *bc)
+{
+    int ret;
+    int wrote = 0;
+
+    while (*codep < stopcodep) {
+        switch (bc->data[*codep].type) {
+        case BT_OPCODE:
+        case BT_JUMP:
+            /* Next command (end of parameters) */
+            return wrote;
+
+        case BT_VALUE:
+            ret = write_int(fd, bc->data[(*codep)++].u.value);
+            break;
+
+        case BT_STR:
+            ret = bc_string_emit(fd, codep, bc);
+            break;
+
+        case BT_STRLISTLEN:
+            ret = bc_stringlist_emit(fd, codep, bc);
+            break;
+
+        case BT_VALLISTLEN:
+            ret = bc_vallist_emit(fd, codep, bc);
+            break;
+
+        default:
+            /* Should never get here */
+            ret = -1;
+            break;
+        }
+
+        if (ret < 0) return -1;
+
+        wrote += ret;
+    }
+
+    return wrote;
+}
+
+static int bc_test_emit(int fd, int *codep, int stopcodep, bytecode_info_t *bc);
 
 /* Write out a testlist to a given file descriptor.
  * return # of bytes written on success and -1 on error */
 static int bc_testlist_emit(int fd, int *codep, bytecode_info_t *bc)
 {
-    int len = bc->data[(*codep)++].len;
+    assert(bc->data[*codep].type == BT_STRLISTLEN);
+
+    int len = bc->data[(*codep)++].u.listlen;
     int i;
     int ret;
     int begin, end;
     int wrote = 2*sizeof(int);
 
     /* Write out number of items in the list */
-    if(write_int(fd, len)== -1) return -1;
+    if (write_int(fd, len)== -1) return -1;
 
     /* skip one spot for end of list position*/
     begin = lseek(fd, 0, SEEK_CUR);
@@ -161,431 +273,99 @@ static int bc_testlist_emit(int fd, int
 
     /* Loop through all the items of the list, writing out each
      * test as we reach it in sequence. */
-    for(i=0; i < len; i++) {
-        int nextcodep = bc->data[(*codep)++].jump;
+    for (i = 0; i < len; i++) {
+        assert(bc->data[*codep].type == BT_JUMP);
+
+        int nextcodep = bc->data[(*codep)++].u.jump;
 
-        ret = bc_test_emit(fd, codep, bc);
-        if(ret < 0 ) return -1;
+        ret = bc_test_emit(fd, codep, nextcodep, bc);
+        if (ret < 0 ) return -1;
 
-        wrote+=ret;
+        wrote += ret;
         *codep = nextcodep;
     }
     end = lseek(fd, 0, SEEK_CUR);
     if (end < 0) return -1;
 
     /* go back and write the end of list position */
-    lseek(fd,begin,SEEK_SET);
-    if(write_int(fd, end) == -1) return -1;
+    lseek(fd, begin, SEEK_SET);
+    if (write_int(fd, end) == -1) return -1;
 
     /*return to the end */
-    lseek(fd,end,SEEK_SET);
+    lseek(fd, end, SEEK_SET);
 
     return wrote;
 }
 
 /* emit the bytecode for a test.  returns -1 on failure or size of
  * emitted bytecode on success */
-static int bc_test_emit(int fd, int *codep, bytecode_info_t *bc)
+static int bc_test_emit(int fd, int *codep, int stopcodep, bytecode_info_t *bc)
 {
     int opcode;
-    int wrote=0;/* Relative offset to account for interleaved strings */
+    int wrote = 0;/* Relative offset to account for interleaved strings */
 
     int ret; /* Temporary Return Value Variable */
 
+    assert(bc->data[*codep].type == BT_OPCODE);
+
     /* Output this opcode */
-    opcode = bc->data[(*codep)++].op;
-    if(write_int(fd, opcode) == -1)
-        return -1;
-    wrote += sizeof(int);
+    opcode = bc->data[(*codep)++].u.op;
+    ret = write_int(fd, opcode);
+    if (ret < 0) return -1;
 
-    switch(opcode) {
-    case BC_TRUE:
-    case BC_FALSE:
-        /* No parameter opcodes */
-        break;
+    wrote += ret;
 
+    switch (opcode) {
     case BC_NOT:
-    {
         /* Single parameter: another test */
-        ret = bc_test_emit(fd, codep, bc);
-        if(ret < 0)
-            return -1;
-        else
-            wrote+=ret;
+        ret = bc_test_emit(fd, codep, stopcodep, bc);
         break;
-    }
 
     case BC_ALLOF:
     case BC_ANYOF:
-        /*where we jump to?*/
         /* Just drop a testlist */
         ret = bc_testlist_emit(fd, codep, bc);
-        if(ret < 0)
-            return -1;
-        else
-            wrote+=ret;
         break;
 
+    case BC_TRUE:
+    case BC_FALSE:
     case BC_SIZE:
-        /* Drop tag and number */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        if(write_int(fd, bc->data[(*codep)+1].value) == -1)
-            return -1;
-
-        wrote += 2 * sizeof(int);
-        (*codep) += 2;
-        break;
-
     case BC_EXISTS:
-    {
-        int ret;
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote += ret;
-        break;
-    }
-
+    case BC_IHAVE:
+    case BC_VALIDEXTLIST:
+    case BC_VALIDNOTIFYMETHOD:
+    case BC_NOTIFYMETHODCAPABILITY:
     case BC_HEADER:
     case BC_HASFLAG:
     case BC_STRING:
-    {
-        int ret;
-        if (BC_HEADER == opcode) {
-        /* drop index */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        }
-        /* Drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop relation*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /* Now drop haystacks */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        /* Now drop needles */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        break;
-    }
-
     case BC_ADDRESS:
-        /* drop index */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* fall-through */
     case BC_ENVELOPE:
-    {
-        int ret;
-        /* Drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop relation*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop address part*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /* Now drop headers */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        /* Now drop data */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        break;
-    }
-
     case BC_BODY:
-    {
-        int ret;
-        /* Drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop relation*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop transform*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop offset*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop content-types*/
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        /* Now drop data */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-        break;
-    }
-
     case BC_MAILBOXEXISTS:
-    {
-        int ret;
-
-        /* drop keylist */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
-        break;
-    }
+    case BC_MAILBOXIDEXISTS:
     case BC_METADATA:
-    {
-        int ret;
-        int datalen;
-
-        /* Drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop relation*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop extname */
-        datalen = bc->data[(*codep)++].len;
-
-        if(write_int(fd, datalen) == -1) return -1;
-        wrote += sizeof(int);
-
-        if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-        wrote += datalen;
-        ret = align_string(fd,datalen);
-        if(ret == -1) return -1;
-        wrote+=ret;
-
-        /* drop keyname */
-        datalen = bc->data[(*codep)++].len;
-
-        if(write_int(fd, datalen) == -1) return -1;
-        wrote += sizeof(int);
-
-        if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-        wrote += datalen;
-        ret = align_string(fd,datalen);
-        if(ret == -1) return -1;
-        wrote+=ret;
-
-        /* drop keylist */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
-        break;
-    }
     case BC_METADATAEXISTS:
-    {
-        int ret;
-        int datalen;
-
-        /* drop extname */
-        datalen = bc->data[(*codep)++].len;
-
-        if(write_int(fd, datalen) == -1) return -1;
-        wrote += sizeof(int);
-
-        if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-        wrote += datalen;
-        ret = align_string(fd,datalen);
-        if(ret == -1) return -1;
-        wrote+=ret;
-
-        /* drop keylist */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
-        break;
-    }
+    case BC_SPECIALUSEEXISTS:
     case BC_SERVERMETADATA:
-    {
-        int ret;
-        int datalen;
-
-        /* Drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*now drop relation*/
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-        /*drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop keyname */
-        datalen = bc->data[(*codep)++].len;
-
-        if(write_int(fd, datalen) == -1) return -1;
-        wrote += sizeof(int);
-
-        if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-        wrote += datalen;
-        ret = align_string(fd,datalen);
-        if(ret == -1) return -1;
-        wrote+=ret;
-
-        /* drop keylist */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
-        break;
-    }
+    case BC_ENVIRONMENT:
     case BC_SERVERMETADATAEXISTS:
-    {
-        int ret;
-
-        /* drop keylist */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
-        break;
-    }
-
     case BC_DATE:
     case BC_CURRENTDATE:
-    {
-        int ret;
-        int datalen;
-        int tmp;
-
-        /* drop index */
-        if(BC_DATE == opcode) {
-                if(write_int(fd, bc->data[(*codep)].value) == -1)
-                    return -1;
-                wrote += sizeof(int);
-                (*codep)++;
-        }
-
-        /* drop zone tag */
-        tmp = bc->data[(*codep)].value;
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop timezone offset */
-        if (tmp == B_TIMEZONE) {
-                if(write_int(fd, bc->data[(*codep)].value) == -1)
-                    return -1;
-                wrote += sizeof(int);
-                (*codep)++;
-        }
-
-        /* drop match type */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop relation */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop comparator */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        /* drop date-part */
-        if(write_int(fd, bc->data[(*codep)].value) == -1)
-            return -1;
-        wrote += sizeof(int);
-        (*codep)++;
-
-        if (BC_DATE == opcode) {
-                /* drop header-name */
-                datalen = bc->data[(*codep)++].len;
-
-                if(write_int(fd, datalen) == -1) return -1;
-                wrote += sizeof(int);
-
-                if(write(fd, bc->data[(*codep)++].str, datalen) == -1) return -1;
-                wrote += datalen;
-
-                ret = align_string(fd,datalen);
-                if(ret == -1) return -1;
-
-                wrote+=ret;
-        }
-
-        /* drop keywords */
-        ret = bc_stringlist_emit(fd, codep, bc);
-        if(ret < 0) return -1;
-        wrote+=ret;
-
+    case BC_DUPLICATE:
+    case BC_JMAPQUERY:
+        ret = bc_params_emit(fd, codep, stopcodep, bc);
         break;
-    }
 
     default:
         /* Unknown testcode? */
-        return -1;
+        ret = -1;
+        break;
     }
+
+    if (ret < 0) return -1;
+
+    wrote += ret;
+
     return wrote;
 }
 
@@ -596,10 +376,8 @@ static int bc_test_emit(int fd, int *cod
 static int bc_action_emit(int fd, int codep, int stopcodep,
                           bytecode_info_t *bc, int filelen)
 {
-    int len; /* Temporary Length Variable */
     int ret; /* Temporary Return Value Variable */
     int start_filelen = filelen;
-    int i;
 
     /*debugging variable to check filelen*/
     /*int location;*/
@@ -607,22 +385,24 @@ static int bc_action_emit(int fd, int co
     syslog(LOG_DEBUG, "entered bc_action_emit with filelen: %d", filelen);
 
     /* All non-string data MUST be sizeof(int)
-       byte alligned so the end of each string may require a pad */
+       byte aligned so the end of each string may require a pad */
     /*
      * Note that for purposes of jumps you must multiply codep by sizeof(int)
      */
     while(codep < stopcodep) {
+        assert(bc->data[codep].type == BT_OPCODE);
+
         /* Output this opcode */
-        if(write_int(fd, bc->data[codep].op) == -1)
-            return -1;
+        if (write_int(fd, bc->data[codep].u.op) == -1) return -1;
 
-        filelen+=sizeof(int);
+        filelen += sizeof(int);
 
-        switch(bc->data[codep++].op) {
+        switch (bc->data[codep++].u.op) {
 
         case B_IF:
         {
             /* IF
+             *  pos of testend (bytes)
              *  test
              *  jump (false condition)
              *  then
@@ -630,494 +410,129 @@ static int bc_action_emit(int fd, int co
              * (if there is an else) else
              */
 
-            int testEndLoc=-1;
+            int testEndLoc = -1;
             int testdist, thendist, elsedist;
             int c;
 
-            int jumpFalseLoc=-1;/*this is the location that is being reserved
-                                  for the first jump command
-                                  we jump to the false condition of the test*/
-
-            int jumpEndLoc=-1; /* this is the location that is being reserved
-                                  for the optional jump command
-                                  it jumps over the else statement to the end*/
-            int jumpto=-1;
-            int jumpop= B_JUMP;
+            int jumpFalseLoc = -1;/* this is the location that is being reserved
+                                     for the first jump command
+                                     we jump to the false condition of the test */
+
+            int jumpEndLoc = -1; /* this is the location that is being reserved
+                                    for the optional jump command
+                                    it jumps over the else statement to the end */
+            int jumpto = -1;
+            int jumpop = B_JUMP;
 
-            /*leave space to store the location of end of the test*/
+            /* leave space to store the location of end of the test */
             ret = lseek(fd, sizeof(int), SEEK_CUR);
-            if(ret == -1) return ret;
+            if (ret == -1) return ret;
 
-            testEndLoc=filelen;
-            filelen+=sizeof(int);
+            testEndLoc = filelen;
+            filelen += sizeof(int);
 
             /* spew the test */
 
-            c=codep+3;
-            testdist = bc_test_emit(fd, &c, bc);
-            if(testdist == -1)return -1;
-            filelen +=testdist;
-
-            /*store the location for the end of the test
-             *this is important for short circuiting of allof/anyof*/
-            jumpto=filelen/4;
-            if(lseek(fd, testEndLoc, SEEK_SET) == -1)
-                return -1;
-            if(write_int(fd,jumpto) == -1)
-                return -1;
+            c = codep+3;
+            testdist = bc_test_emit(fd, &c, bc->data[codep].u.jump, bc);
+            if (testdist == -1) return -1;
+            filelen += testdist;
+
+            /* store the location for the end of the test
+             * this is important for short circuiting of allof/anyof */
+            jumpto = filelen/4;
+            if (lseek(fd, testEndLoc, SEEK_SET) == -1) return -1;
+            if (write_int(fd, jumpto) == -1) return -1;
 
-            if(lseek(fd,filelen,SEEK_SET) == -1)
-                return -1;
+            if (lseek(fd, filelen, SEEK_SET) == -1) return -1;
 
             /* leave space for jump */
-            if(write_int(fd, jumpop) == -1)
-                return -1;
+            if (write_int(fd, jumpop) == -1) return -1;
             ret = lseek(fd, sizeof(int), SEEK_CUR);
-            if(ret == -1)
-                return ret;
-            jumpFalseLoc=filelen+sizeof(int);
+            if (ret == -1) return ret;
+            jumpFalseLoc = filelen + sizeof(int);
 
-            filelen +=2*sizeof(int); /*jumpop + jump*/
+            filelen += 2*sizeof(int); /* jumpop + jump */
 
             /* spew the then code */
-            thendist = bc_action_emit(fd, bc->data[codep].value,
-                                      bc->data[codep+1].value, bc,
+            thendist = bc_action_emit(fd, bc->data[codep].u.jump,
+                                      bc->data[codep+1].u.jump, bc,
                                       filelen);
 
-            filelen+=thendist;
+            filelen += thendist;
 
             /* there is an else case */
-            if(bc->data[codep+2].value != -1)
-            {
+            if (bc->data[codep+2].u.jump != -1) {
                 /* leave space for jump */
-                if(write_int(fd, jumpop) == -1)
-                    return -1;
+                if (write_int(fd, jumpop) == -1) return -1;
                 ret = lseek(fd, sizeof(int), SEEK_CUR);
-                if(ret == -1)
-                    return ret;
+                if (ret == -1) return ret;
 
-                jumpEndLoc=filelen+sizeof(int);
-                filelen+=2*sizeof(int);/*jumpop + jump*/
+                jumpEndLoc = filelen + sizeof(int);
+                filelen += 2*sizeof(int); /* jumpop + jump */
             }
 
-            /*put previous jump to the end of the then code,
-             *or the end of the jump if there is an else case */
-            jumpto=filelen/4;
-            if(lseek(fd, jumpFalseLoc, SEEK_SET) == -1)
-                return -1;
-            if(write_int(fd,jumpto) == -1)
-                return -1;
-            if(lseek(fd,filelen,SEEK_SET) == -1)
-                return -1;
+            /* put previous jump to the end of the then code,
+             * or the end of the jump if there is an else case */
+            jumpto = filelen/4;
+            if (lseek(fd, jumpFalseLoc, SEEK_SET) == -1) return -1;
+            if (write_int(fd, jumpto) == -1) return -1;
+            if (lseek(fd, filelen, SEEK_SET) == -1) return -1;
 
             /* there is an else case */
-            if(bc->data[codep+2].value != -1) {
+            if (bc->data[codep+2].u.jump != -1) {
                 /* spew the else code */
-                elsedist = bc_action_emit(fd, bc->data[codep+1].value,
-                                         bc->data[codep+2].value, bc,
-                                         filelen);
-
-                filelen+=elsedist;
-
-                /*put jump to the end of the else code*/
-                jumpto=filelen/4;
-                if(lseek(fd, jumpEndLoc, SEEK_SET) == -1)
-                    return -1;
-                if(write_int(fd,jumpto) == -1)
-                    return -1;
-                if(lseek(fd,filelen,SEEK_SET) == -1)
-                    return -1;
+                elsedist = bc_action_emit(fd, bc->data[codep+1].u.jump,
+                                          bc->data[codep+2].u.jump, bc,
+                                          filelen);
+
+                filelen += elsedist;
+
+                /* put jump to the end of the else code */
+                jumpto = filelen/4;
+                if (lseek(fd, jumpEndLoc, SEEK_SET) == -1) return -1;
+                if (write_int(fd, jumpto) == -1) return -1;
+                if (lseek(fd, filelen, SEEK_SET) == -1) return -1;
 
-                codep = bc->data[codep+2].value;
+                codep = bc->data[codep+2].u.jump;
             } else {
-                codep = bc->data[codep+1].value;
+                codep = bc->data[codep+1].u.jump;
             }
 
             break;
         }
 
         case B_KEEP:
-            /* Flags Stringlist, Copy (word) */
-
-            /* Dump a stringlist of flags */
-            ret = bc_stringlist_emit(fd, &codep, bc);
-            if(ret < 0)
-                return -1;
-            filelen += ret;
-
-            if(write_int(fd,bc->data[codep++].value) == -1)
-                return -1;
-
-            filelen += sizeof(int);
-            break;
-
         case B_FILEINTO:
-            /* Create (word), Flags Stringlist, Copy (word), Folder String */
-
-            /* Write create */
-            if(write_int(fd,bc->data[codep++].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-
-            /* Dump a stringlist of flags */
-            ret = bc_stringlist_emit(fd, &codep, bc);
-            if(ret < 0)
-                return -1;
-            filelen += ret;
-
-            /* Write Copy */
-            if(write_int(fd,bc->data[codep++].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-
-            /* Write string length of Folder */
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            /* Write Folder */
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            break;
-
         case B_REDIRECT:
-            /* Copy (word), Address String */
-
-            if(write_int(fd,bc->data[codep++].value) == -1)
-                return -1;
-
-            filelen += sizeof(int);
-
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            break;
-
         case B_REJECT:
-            /*just a string*/
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            break;
-
+        case B_EREJECT:
+        case B_ERROR:
         case B_SETFLAG:
         case B_ADDFLAG:
         case B_REMOVEFLAG:
-            /* Variablename String, Flags Stringlist */
-
-            /* Write string length of Variablename */
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            /* Write Folder */
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            ret = bc_stringlist_emit(fd, &codep, bc);
-            if(ret < 0)
-                return -1;
-            filelen += ret;
-            break;
-
+        case B_ENOTIFY:
         case B_NOTIFY:
-            /* method string, id string, options string list,
-               priotity, Message String */
-            /*method and id*/
-            for(i=0; i<2; i++) {
-                len = bc->data[codep++].len;
-                if(write_int(fd,len) == -1)
-                    return -1;
-                filelen += sizeof(int);
-                if(len == -1)
-                {
-                    /* this will probably only happen for the id */
-                    /* this is a nil string */
-                    /* skip the null pointer and make up for it
-                     * by adjusting the offset */
-                    codep++;
-                }
-                else
-                {
-                    if(write(fd,bc->data[codep++].str,len) == -1)
-                        return -1;
-
-                    ret = align_string(fd, len);
-                    if(ret == -1)
-                        return -1;
-
-                    filelen += len + ret;
-                }
-
-            }
-            /*options */
-            ret = bc_stringlist_emit(fd, &codep, bc);
-            if(ret < 0)
-                return -1;
-            filelen+=ret;
-
-            /*priority*/
-            if(write_int(fd, bc->data[codep].value) == -1)
-                return -1;
-            codep++;
-            filelen += sizeof(int);
-
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-            filelen += sizeof(int);
-
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1) return -1;
-
-            filelen += len + ret;
-            break;
-
-
         case B_DENOTIFY:
-            /* priority num,comptype  num,relat num, comp string*/
-
-            /* priority*/
-            if(write_int(fd, bc->data[codep].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-            codep++;
-            /* comptype */
-            if(write_int(fd, bc->data[codep].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-            codep++;
-            /* relational*/
-            if(write_int(fd, bc->data[codep].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-            codep++;
-            /* comp string*/
-
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-            filelen += sizeof(int);
-
-            if(len == -1)
-            {
-                /* this is a nil string */
-                /* skip the null pointer and make up for it
-                 * by adjusting the offset */
-                codep++;
-            }
-            else
-            {
-                if(write(fd,bc->data[codep++].str,len) == -1)
-                    return -1;
-
-                ret = align_string(fd, len);
-                if(ret == -1) return -1;
-
-                filelen += len + ret;
-            }
-                    break;
         case B_VACATION:
-            /* Address list, Subject String, Message String,
-               Seconds (word), Mime (word), From String, Handle String */
-
-                /*new code-this might be broken*/
-            ret = bc_stringlist_emit(fd, &codep, bc);
-            if(ret < 0) return -1;
-            filelen += ret;
-            /*end of new code*/
-
-            for(i=0; i<2; i++) {/*writing strings*/
-
-                /*write length of string*/
-                len = bc->data[codep++].len;
-                if(write_int(fd,len) == -1)
-                    return -1;
-                filelen += sizeof(int);
-
-                if(len == -1)
-                {
-                    /* this is a nil string */
-                    /* skip the null pointer and make up for it
-                     * by adjusting the offset */
-                    codep++;
-                }
-                else
-                {
-                    /*write string*/
-                    if(write(fd,bc->data[codep++].str,len) == -1)
-                        return -1;
-
-                    ret = align_string(fd, len);
-                    if(ret == -1) return -1;
-
-                    filelen += len + ret;
-                }
-
-            }
-            /* Seconds*/
-            if(write_int(fd,bc->data[codep].value) == -1)
-                return -1;
-            codep++;
-            filelen += sizeof(int);
-            /*Mime */
-            if(write_int(fd,bc->data[codep].value) == -1)
-                return -1;
-            codep++;
-
-            for(i=0; i<2; i++) {/*writing strings*/
-
-                /*write length of string*/
-                len = bc->data[codep++].len;
-                if(write_int(fd,len) == -1)
-                    return -1;
-                filelen += sizeof(int);
-
-                if(len == -1)
-                {
-                    /* this is a nil string */
-                    /* skip the null pointer and make up for it
-                     * by adjusting the offset */
-                    codep++;
-                }
-                else
-                {
-                    /*write string*/
-                    if(write(fd,bc->data[codep++].str,len) == -1)
-                        return -1;
-
-                    ret = align_string(fd, len);
-                    if(ret == -1) return -1;
-
-                    filelen += len + ret;
-                }
-
-            }
-            filelen += sizeof(int);
-
-            break;
         case B_INCLUDE:
-            /* Location + (Once<<6) + (Optional<<7) (word), Filename String */
-
-            /* Location + (Once<<6) + (Optional<<7) */
-            if(write_int(fd, bc->data[codep].value) == -1)
-                return -1;
-            filelen += sizeof(int);
-            codep++;
-            /* Filename */
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen += sizeof(int);
-
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1) return -1;
-
-            filelen += len + ret;
-            break;
-
         case B_SET:
-            /* BITFIELD modifiers
-               STRING variable
-               STRING value
-            */
-            /* write modifiers */
-            if(write_int(fd,bc->data[codep++].value) == -1)
-                return -1;
-
-            filelen += sizeof(int);
-
-            /* write string length of variable */
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            /* write variable */
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            /* write string length of value */
-            len = bc->data[codep++].len;
-            if(write_int(fd,len) == -1)
-                return -1;
-
-            filelen+=sizeof(int);
-
-            /* write value */
-            if(write(fd,bc->data[codep++].str,len) == -1)
-                return -1;
-
-            ret = align_string(fd, len);
-            if(ret == -1)
-                return -1;
-
-            filelen += len + ret;
-
-            break;
-
+        case B_ADDHEADER:
+        case B_DELETEHEADER:
+        case B_LOG:
         case B_NULL:
         case B_STOP:
         case B_DISCARD:
         case B_MARK:
         case B_UNMARK:
         case B_RETURN:
-            /* No Parameters! */
+        case B_SNOOZE:
+            /* Spew the action parameters */
+            ret = bc_params_emit(fd, &codep, stopcodep, bc);
+            if (ret < 0) return -1;
+
+            filelen += ret;
+
             break;
 
         default:
@@ -1137,13 +552,12 @@ EXPORTED int sieve_emit_bytecode(int fd,
     int data = BYTECODE_VERSION;
 
     /*this is a string, so it is happy*/
-    if(write(fd, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN) == -1)
-        return -1;
+    if (write(fd, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN) == -1) return -1;
 
-    if(write_int(fd, data) == -1) return -1;
+    if (write_int(fd, data) == -1) return -1;
 
     /* write extensions bitfield */
-    if (write_int(fd, bc->data[codep++].value) == -1) return -1;
+    if (write_int(fd, bc->data[codep++].u.value) == -1) return -1;
 
 #if DUMPCODE
     dump(bc, 0);
@@ -1155,4 +569,3 @@ EXPORTED int sieve_emit_bytecode(int fd,
     return bc_action_emit(fd, codep, bc->scriptend, bc,
                           2*sizeof(int) + BYTECODE_MAGIC_LEN);
 }
-
diff -pruN 3.0.13-5/sieve/bc_eval.c 3.2.0-3/sieve/bc_eval.c
--- 3.0.13-5/sieve/bc_eval.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/bc_eval.c	2020-05-04 03:28:02.000000000 +0000
@@ -45,14 +45,17 @@
 #endif
 
 #include "sieve_interface.h"
+#include "grammar.h"
 #include "interp.h"
 #include "message.h"
 #include "script.h"
 #include "parseaddr.h"
 #include "flags.h"
 #include "variables.h"
+#include "varlist.h"
 
 #include "bytecode.h"
+#include "bc_parse.h"
 
 #include "charset.h"
 #include "xmalloc.h"
@@ -71,68 +74,16 @@
 /**************************************************************************/
 /**************************************************************************/
 
-/* Given a bytecode_input_t at the beginning of a string (the len block),
- * return the string, the length, and the bytecode index of the NEXT
- * item */
-EXPORTED int unwrap_string(bytecode_input_t *bc, int pos, const char **str, int *len)
-{
-    int local_len = ntohl(bc[pos].value);
-
-    pos++;
-
-    if(local_len == -1) {
-        /* -1 length indicates NULL */
-        *str = NULL;
-    } else {
-        /* This cast is ugly, but necessary */
-        *str = (const char *)&bc[pos].str;
-
-        /* Compute the next index */
-        pos += ((ROUNDUP(local_len+1))/sizeof(bytecode_input_t));
-    }
-
-    if(len) *len = local_len;
-
-    return pos;
-}
-
-
-/* this is used by notify to pass the options list to do_notify
- * do_notify needs null-terminated (char *)[],
- *  we have a stringlist, the beginning of which is pointed at by pos */
-static const char ** bc_makeArray(bytecode_input_t *bc, int *pos)
-{
-    int i;
-    const char** array;
-    int len = ntohl(bc[*pos].value);
-
-    (*pos)+=2; /* Skip # Values and Total Byte Length */
-
-    array=(const char **)xmalloc((len+1) * sizeof(char *));
-
-    for (i=0; i<len; i++) {
-        *pos = unwrap_string(bc, *pos, &(array[i]), NULL);
-    }
-
-    array[i] = NULL;
-
-    return array;
-}
-
 /* Compile a regular expression for use during parsing */
 static regex_t * bc_compile_regex(const char *s, int ctag,
                                   char *errmsg, size_t errsiz)
 {
     int ret;
-    regex_t *reg = (regex_t *) xmalloc(sizeof(regex_t));
+    regex_t *reg = (regex_t *) xzmalloc(sizeof(regex_t));
 
-#ifdef HAVE_PCREPOSIX_H
-    /* support UTF8 comparisons */
-    ctag |= REG_UTF8;
-#endif
-    if ( (ret=regcomp(reg, s, ctag)) != 0)
-    {
+    if ((ret = regcomp(reg, s, ctag)) != 0) {
         (void) regerror(ret, reg, errmsg, errsiz);
+        regfree(reg);
         free(reg);
         return NULL;
     }
@@ -161,13 +112,13 @@ static int sysaddr(const char *addr)
 }
 
 /* look for myaddr and myaddrs in the body of a header - return the match */
-static char* look_for_me(char *myaddr, int numaddresses,
-			       bytecode_input_t *bc, int i, const char **body,
+static char* look_for_me(char *myaddr, strarray_t *addresses, const char **body,
 			       variable_list_t *variables, int requires)
 {
+    int numaddresses = strarray_size(addresses);
     char *found = NULL;
     int l;
-    int curra,x ;
+    int x;
 
     /* loop through each TO header */
     for (l = 0; body[l] != NULL && !found; l++) {
@@ -187,14 +138,11 @@ static char* look_for_me(char *myaddr, i
                 break;
             }
 
-            curra=i;
-
-            for(x=0; x<numaddresses; x++)
-            {
+            for(x = 0; x < numaddresses; x++) {
                 char *altaddr;
                 const char *str;
 
-                curra = unwrap_string(bc, curra, &str, NULL);
+                str = strarray_nth(addresses, x);
 
                 if (requires & BFE_VARIABLES) {
                     str = parse_string(str, variables);
@@ -220,14 +168,14 @@ static char* look_for_me(char *myaddr, i
 
 /* Determine if we should respond to a vacation message */
 static int shouldRespond(void * m, sieve_interp_t *interp,
-                         int numaddresses, bytecode_input_t* bc,
-			 int i, char **from, char **to,
+                         strarray_t *addresses, char **from, char **to,
 			 variable_list_t *variables, int requires)
 {
+    int numaddresses = strarray_size(addresses);
     const char **body;
     char *myaddr = NULL;
     int l = SIEVE_DONE, j;
-    int curra, x;
+    int x;
     char *found = NULL;
     char *reply_to = NULL;
     static const char * const list_fields[] = {
@@ -312,11 +260,10 @@ static int shouldRespond(void * m, sieve
 
     /* ok, is it any of the other addresses i've
        specified? */
-    curra=i;
-    for(x=0; x<numaddresses; x++) {
+    for(x = 0; x < numaddresses; x++) {
         const char *address;
 
-        curra = unwrap_string(bc, curra, &address, NULL);
+        address = strarray_nth(addresses, x);
 
         if (requires & BFE_VARIABLES) {
             address = parse_string(address, variables);
@@ -334,22 +281,23 @@ static int shouldRespond(void * m, sieve
        but is this message to me?  that is, is my address
        in the [Resent]-To, [Resent]-Cc or [Resent]-Bcc fields? */
     if (interp->getheader(m, "to", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses, bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses, body, variables, requires);
     if (!found && interp->getheader(m, "cc", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses, bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses, body, variables, requires);
     if (!found && interp->getheader(m, "bcc", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses, bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses, body, variables, requires);
     if (!found && interp->getheader(m, "resent-to", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses ,bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses ,body, variables, requires);
     if (!found && interp->getheader(m, "resent-cc", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses, bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses, body, variables, requires);
     if (!found && interp->getheader(m, "resent-bcc", &body) == SIEVE_OK)
-	found = look_for_me(myaddr, numaddresses, bc, i, body, variables, requires);
+	found = look_for_me(myaddr, addresses, body, variables, requires);
     if (found)
         l = SIEVE_OK;
 
     /* ok, ok, if we got here maybe we should reply */
 out:
+    free(strarray_takevf(addresses));
     free(myaddr);
     if (l == SIEVE_OK) {
         *from = found;
@@ -367,126 +315,189 @@ static int regcomp_flags(int comparator,
 {
     int cflags = REG_EXTENDED;
 
-    if (comparator == B_ASCIICASEMAP) cflags |= REG_ICASE;
-    if (!(requires & BFE_VARIABLES))  cflags |= REG_NOSUB;
+#ifdef HAVE_PCREPOSIX_H
+    /* support UTF8 comparisons */
+    cflags |= REG_UTF8;
+#endif
+
+    if (comparator == B_ASCIICASEMAP) {
+        /* case-insensitive matches */
+        cflags |= REG_ICASE;
+    }
+    if (!(requires & BFE_VARIABLES)) {
+        /* do NOT need position of matches */
+        cflags |= REG_NOSUB;
+    }
 
     return cflags;
 }
 
+static int do_comparison(const char *needle, const char *hay,
+                         comparator_t *comp, void *comprock, int ctag,
+                         variable_list_t *variables, strarray_t *match_vars)
+{
+    int res;
+
+    if (variables) {
+        needle = parse_string(needle, variables);
+    }
+
+    if (ctag) {
+        char errbuf[100]; /* Basically unused, as regex is tested at compile */
+        regex_t *reg = bc_compile_regex(needle, ctag, errbuf, sizeof(errbuf));
+
+        if (!reg) {
+            /* Oops */
+            res = SIEVE_NOMEM;
+        }
+        else {
+            res = comp(hay, strlen(hay),
+                       (const char *) reg, match_vars, comprock);
+            regfree(reg);
+            free(reg);
+        }
+    } else {
+#if VERBOSE
+        printf("%s compared to %s (from script)\n", hay, needle);
+#endif
+        res = comp(hay, strlen(hay), needle, match_vars, comprock);
+    }
+
+    return res;
+}
+
+static int do_comparisons(strarray_t *needles, const char *hay,
+                          comparator_t *comp, void *comprock, int ctag,
+                          variable_list_t *variables, strarray_t *match_vars)
+{
+    int n, res = 0, numneedles = strarray_size(needles);
+
+    for (n = 0; n < numneedles && !res; n++) {
+        const char *needle = strarray_nth(needles, n);
+
+        if (variables) {
+            needle = parse_string(needle, variables);
+        }
+
+        int tmp = do_comparison(needle, hay,
+                                comp, comprock, ctag, variables, match_vars);
+        if (tmp < 0) res = tmp;
+        else res |= tmp;
+    }
+
+    return res;
+}
+
 /* Evaluate a bytecode test */
 static int eval_bc_test(sieve_interp_t *interp, void* m, void *sc,
                         bytecode_input_t * bc, int * ip,
-			variable_list_t *variables, int version, int requires)
+			variable_list_t *variables,
+                        duptrack_list_t *duptrack_list,
+                        int version, int requires)
 {
-    int res=0;
-    int i=*ip;
-    int x,y,z;/* loop variable */
+    test_t test;
+    int res = 0;
+    int i = *ip;
+    int x, y, z;  /* loop variable */
     int list_len; /* for allof/anyof/exists */
     int list_end; /* for allof/anyof/exists */
-    int address=0;/*to differentiate between address and envelope*/
-    int has_index=0;/* used to differentiate between pre and post index tests */
-    int is_string = 0; /* differentiate between string and hasflag tests */
-    comparator_t * comp=NULL;
-    void * comprock=NULL;
-    int op= ntohl(bc[i].op);
+    comparator_t *comp = NULL;
+    void *comprock = NULL;
+    strarray_t *match_vars = NULL;
+    int op;
     #define SCOUNT_SIZE 20
     char scount[SCOUNT_SIZE];
 
-    switch(op)
-    {
-    case BC_FALSE:/*0*/
-        res=0; i++; break;
+    i = bc_test_parse(bc, i, version, &test);
+    op = test.type;
+
+    switch (op) {
+    case BC_FALSE:
+        res = 0;
+        break;
 
-    case BC_TRUE:/*1*/
-        res=1; i++; break;
+    case BC_TRUE:
+        res = 1;
+        break;
 
-    case BC_NOT:/*2*/
-        i+=1;
-        res = eval_bc_test(interp, m, sc, bc, &i, variables, version, requires);
-        if(res >= 0) res = !res; /* Only invert in non-error case */
+    case BC_NOT:
+        res = eval_bc_test(interp, m, sc, bc, &i, variables,
+                           duptrack_list, version, requires);
+        if (res >= 0) res = !res; /* Only invert in non-error case */
         break;
 
-    case BC_EXISTS:/*3*/
+    case BC_EXISTS:
     {
-        int headersi=i+1;
-        const char** val;
-        int currh;
-
-        res=1;
+        const char **val;
 
-        list_len=ntohl(bc[headersi].len);
-        list_end=ntohl(bc[headersi+1].value)/4;
+        res = 1;
 
-        currh=headersi+2;
+        list_len = strarray_size(test.u.sl);
 
-        for(x=0; x<list_len && res; x++)
-        {
+        for (x = 0; x < list_len && res; x++) {
             const char *str;
 
-            currh = unwrap_string(bc, currh, &str, NULL);
+            str = strarray_nth(test.u.sl, x);
 
             if (requires & BFE_VARIABLES) {
                 str = parse_string(str, variables);
             }
 
-            if(interp->getheader(m,str, &val) != SIEVE_OK)
-                res = 0;
+            if (interp->getheader(m, str, &val) != SIEVE_OK) res = 0;
         }
 
-        i=list_end; /* adjust for short-circuit */
+        free(strarray_takevf(test.u.sl));
         break;
     }
-    case BC_SIZE:/*4*/
+
+    case BC_SIZE:
     {
         int s;
-        int sizevar=ntohl(bc[i+1].value);
-        int x=ntohl(bc[i+2].value);
+        int sizevar = test.u.sz.t;
+        int x = test.u.sz.n;
 
-        if (interp->getsize(m, &s) != SIEVE_OK)
-            break;
+        if (interp->getsize(m, &s) != SIEVE_OK) break;
 
-        if (sizevar ==B_OVER) {
+        if (sizevar == B_OVER) {
             /* over */
-            res= s > x;
+            res = s > x;
         } else {
             /* under */
-            res= s < x;
+            res = s < x;
         }
-        i+=3;
         break;
     }
-    case BC_ANYOF:/*5*/
+
+    case BC_ANYOF:
         res = 0;
-        list_len=ntohl(bc[i+1].len);
-        list_end=ntohl(bc[i+2].len)/4;
-        i+=3;
+        list_len = test.u.aa.ntests;
+        list_end = test.u.aa.endtests;
 
-        /* need to process all of them, to ensure our instruction pointer stays
-         * in the right place */
-        for (x=0; x<list_len && !res; x++) {
-            int tmp;
-            tmp = eval_bc_test(interp, m, sc, bc, &i, variables, version, requires);
-            if(tmp < 0) {
+        /* return 0 unless you find one that is true, then return 1 */
+        for (x = 0; x < list_len && !res; x++) {
+            int tmp = eval_bc_test(interp, m, sc, bc, &i, variables,
+                                   duptrack_list, version, requires);
+            if (tmp < 0) {
                 res = tmp;
                 break;
             }
             res = res || tmp;
         }
 
-        i = list_end; /* handle short-circuting */
+        i = list_end; /* handle short-circuiting */
 
         break;
-    case BC_ALLOF:/*6*/
+
+    case BC_ALLOF:
         res = 1;
-        list_len=ntohl(bc[i+1].len);
-        list_end=ntohl(bc[i+2].len)/4;
-        i+=3;
+        list_len = test.u.aa.ntests;
+        list_end = test.u.aa.endtests;
 
         /* return 1 unless you find one that isn't true, then return 0 */
-        for (x=0; x<list_len && res; x++) {
-            int tmp;
-            tmp = eval_bc_test(interp, m, sc, bc, &i, variables, version, requires);
-            if(tmp < 0) {
+        for (x = 0; x < list_len && res; x++) {
+            int tmp =  eval_bc_test(interp, m, sc, bc, &i, variables,
+                                    duptrack_list, version, requires);
+            if (tmp < 0) {
                 res = tmp;
                 break;
             }
@@ -496,108 +507,71 @@ static int eval_bc_test(sieve_interp_t *
         i = list_end; /* handle short-circuiting */
 
         break;
-    case BC_ADDRESS:/*13*/
-        has_index=1;
-        /* fall through */
-    case BC_ADDRESS_PRE_INDEX:/*7*/
-        address=1;
-        if (0x07 == version && BC_ADDRESS_PRE_INDEX == op) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * argument.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(bc[i+2].value)) {
-            case B_IS:
-            case B_CONTAINS:
-            case B_MATCHES:
-            case B_REGEX:
-            case B_COUNT:
-            case B_VALUE:
-                has_index = 1;
-                break;
-            default:
-                has_index = 0;
-            }
-        }
-        /* fall through */
-    case BC_ENVELOPE:/*8*/
+
+    case BC_ADDRESS:
+    case BC_ADDRESS_PRE_INDEX:
+    case BC_ENVELOPE:
     {
-        const char ** val;
+        const char **val;
         struct address_itr ai;
         const struct address *a;
         char *addr;
 
-        int headersi=has_index+i+5;/* the i value for the beginning of the headers */
-        int datai=(ntohl(bc[headersi+1].value)/4);
-
-        int numheaders=ntohl(bc[headersi].len);
-        int numdata=ntohl(bc[datai].len);
-
-        int currh, currd; /* current header, current data */
+        int numheaders = strarray_size(test.u.ae.sl);
 
         int header_count;
-        int index=has_index ? ntohl(bc[i+1].value) : 0; // used for address only
-        int match=ntohl(bc[has_index+i+1].value);
-        int relation=ntohl(bc[has_index+i+2].value);
-        int comparator=ntohl(bc[has_index+i+3].value);
-        int apart=ntohl(bc[has_index+i+4].value);
-        int count=0;
-        int isReg = (match==B_REGEX);
+        int index = test.u.ae.comp.index; // used for address only
+        int match = test.u.ae.comp.match;
+        int relation = test.u.ae.comp.relation;
+        int comparator = test.u.ae.comp.collation;
+        int apart = test.u.ae.addrpart;
+        int count = 0;
         int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, as regexps are tested at compile */
 
         /* set up variables needed for compiling regex */
-        if (isReg) {
+        if (match == B_REGEX) {
             ctag = regcomp_flags(comparator, requires);
         }
 
-        /*find the correct comparator fcn*/
-        comp = lookup_comp(comparator, match, relation, &comprock);
+        /* find the correct comparator fcn */
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
 
-        if(!comp) {
+        if (!comp) {
             res = SIEVE_RUN_ERROR;
             break;
         }
-        if (!comprock) {
-            comprock = varlist_select(variables, VL_MATCH_VARS)->var;
-        }
+        match_vars = varlist_select(variables, VL_MATCH_VARS)->var;
 
-        /*loop through all the headers*/
-        currh=headersi+2;
+        /* loop through all the headers */
 #if VERBOSE
         printf("about to process %d headers\n", numheaders);
 #endif
-        for (x=0; x<numheaders && !res; x++)
-        {
+        for (x = 0; x < numheaders && !res; x++) {
             const char *this_header;
             int reverse_path = 0;
 
-            currh = unwrap_string(bc, currh, &this_header, NULL);
+            this_header = strarray_nth(test.u.ae.sl, x);
 
             if (requires & BFE_VARIABLES) {
                 this_header = parse_string(this_header, variables);
             }
 
             /* Try the next string if we don't have this one */
-            if(address) {
-                /* Header */
-                if(interp->getheader(m, this_header, &val) != SIEVE_OK)
-                    continue;
-#if VERBOSE
-                printf(" [%d] header %s is %s\n", x, this_header, val[0]);
-#endif
-            } else {
+            if (op == BC_ENVELOPE) {
                 /* Envelope */
-                if(interp->getenvelope(m, this_header, &val) != SIEVE_OK)
+                if (interp->getenvelope(m, this_header, &val) != SIEVE_OK)
                     continue;
 
                 if (!strcmp(this_header, "from")) reverse_path = 1;
             }
-
+            else {
+                /* Address Header */
+                if (interp->getheader(m, this_header, &val) != SIEVE_OK)
+                    continue;
+#if VERBOSE
+                printf(" [%d] address header %s is %s\n", x, this_header, val[0]);
+#endif
+            }
             /* count results */
             header_count = 0;
             while (val[header_count] != NULL) {
@@ -608,22 +582,22 @@ static int eval_bc_test(sieve_interp_t *
             if (index > 0) {
                 --index;
                 if (index >= header_count) {
-                        res = 0;
-                        break;
+                    res = 0;
+                    break;
                 }
                 header_count = index + 1;
             }
             else if (index < 0) {
                 index += header_count;
                 if (index < 0) {
-                        res = 0;
-                        break;
+                    res = 0;
+                    break;
                 }
                 header_count = index + 1;
             }
 
-            /*header exists, now to test it*/
-            /*search through all the headers that match*/
+            /* header exists, now to test it */
+            /* search through all the headers that match */
 
             for (y = index; y < header_count && !res; y++) {
 #if VERBOSE
@@ -636,9 +610,8 @@ static int eval_bc_test(sieve_interp_t *
 #if VERBOSE
                     printf("working addr %s\n", (addr ? addr : "[nil]"));
 #endif
-                    /*find the part of the address that we want*/
-                    switch(apart)
-                    {
+                    /* find the part of the address that we want */
+                    switch(apart) {
                     case B_ALL:
                         addr = address_get_all(a, /*canon_domain*/0);
                         break;
@@ -665,40 +638,15 @@ static int eval_bc_test(sieve_interp_t *
                     if (match == B_COUNT) {
                         count++;
                     } else {
-                        /*search through all the data*/
-                        currd=datai+2;
-                        for (z=0; z<numdata && !res; z++)
-                        {
-                            const char *data_val;
-
-                            currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                            if (requires & BFE_VARIABLES) {
-                                data_val = parse_string(data_val, variables);
-                            }
-
-                            if (isReg) {
-                                reg = bc_compile_regex(data_val, ctag,
-                                                       errbuf, sizeof(errbuf));
-                                if (!reg) {
-                                    /* Oops */
-                                    free(addr);
-                                    res=-1;
-                                    goto alldone;
-                                }
-
-                                res |= comp(addr, strlen(addr),
-                                            (const char *)reg, comprock);
-                                free(reg);
-                            } else {
-#if VERBOSE
-                                printf("%s compared to %s(from script)\n",
-                                       addr, data_val);
-#endif
-                                res |= comp(addr, strlen(addr),
-                                            data_val, comprock);
-                            }
-                        } /* For each data */
+                        /* search through all the data */
+                        res = do_comparisons(test.u.ae.pl, addr,
+                                             comp, comprock, ctag,
+                                             (requires & BFE_VARIABLES) ?
+                                             variables : NULL, match_vars);
+                        if (res < 0) {
+                            free(addr);
+                            goto envelope_err;
+                        }
                     }
                     free(addr);
                 } /* For each address */
@@ -711,109 +659,63 @@ static int eval_bc_test(sieve_interp_t *
 #endif
         } /* For each script header */
 
-        if  (match == B_COUNT)
-        {
+        if (match == B_COUNT) {
             snprintf(scount, SCOUNT_SIZE, "%u", count);
             /* search through all the data */
-            currd=datai+2;
-            for (z=0; z<numdata && !res; z++)
-            {
-                const char *data_val;
-
-                currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                if (requires & BFE_VARIABLES) {
-                    data_val = parse_string(data_val, variables);
-                }
-
-                res |= comp(scount, strlen(scount), data_val, comprock);
-            }
+            res = do_comparisons(test.u.ae.pl, scount,
+                                 comp, comprock, 0 /* regex */,
+                                 (requires & BFE_VARIABLES) ? variables : NULL,
+                                 match_vars);
         }
 
-        /* Update IP */
-        i=(ntohl(bc[datai+1].value)/4);
-
 envelope_err:
+        free(strarray_takevf(test.u.ae.sl));
+        free(strarray_takevf(test.u.ae.pl));
         break;
     }
-    case BC_HEADER:/*14*/
-        has_index=1;
-        /* fall through */
-    case BC_HEADER_PRE_INDEX:/*9*/
-        if (0x07 == version && BC_HEADER_PRE_INDEX == op) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * argument.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(bc[i+2].value)) {
-            case B_IS:
-            case B_CONTAINS:
-            case B_MATCHES:
-            case B_REGEX:
-            case B_COUNT:
-            case B_VALUE:
-                    has_index = 1;
-                    break;
-            default:
-                    has_index = 0;
-            }
-        }
-    {
-        const char** val;
-
-        int headersi=has_index+i+4;/*the i value for the beginning of the headers*/
-        int datai=(ntohl(bc[headersi+1].value)/4);
 
-        int numheaders=ntohl(bc[headersi].len);
-        int numdata=ntohl(bc[datai].len);
+    case BC_HEADER:
+    case BC_HEADER_PRE_INDEX:
+    {
+        const char **val;
 
-        int currh, currd; /*current header, current data*/
+        int numheaders = strarray_size(test.u.hhs.sl);
 
         int header_count;
-        int index=has_index ? ntohl(bc[i+1].value) : 0;
-        int match=ntohl(bc[has_index+i+1].value);
-        int relation=ntohl(bc[has_index+i+2].value);
-        int comparator=ntohl(bc[has_index+i+3].value);
-        int count=0;
-        int isReg = (match==B_REGEX);
+        int index = test.u.hhs.comp.index;
+        int match = test.u.hhs.comp.match;
+        int relation = test.u.hhs.comp.relation;
+        int comparator = test.u.hhs.comp.collation;
+        int count = 0;
         int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, regexps tested at compile */
         char *decoded_header;
 
         /* set up variables needed for compiling regex */
-        if (isReg) {
+        if (match == B_REGEX) {
             ctag = regcomp_flags(comparator, requires);
         }
 
-        /*find the correct comparator fcn*/
-        comp=lookup_comp(comparator, match, relation, &comprock);
+        /* find the correct comparator fcn */
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
 
-        if(!comp) {
+        if (!comp) {
             res = SIEVE_RUN_ERROR;
             break;
         }
-        if (!comprock) {
-            comprock = varlist_select(variables, VL_MATCH_VARS)->var;
-        }
+        match_vars = varlist_select(variables, VL_MATCH_VARS)->var;
 
-        /*search through all the flags for the header*/
-        currh=headersi+2;
-        for(x=0; x<numheaders && !res; x++)
-        {
+        /* search through all the flags for the header */
+        for (x = 0; x < numheaders && !res; x++) {
             const char *this_header;
 
-            currh = unwrap_string(bc, currh, &this_header, NULL);
+            this_header = strarray_nth(test.u.hhs.sl, x);
 
             if (requires & BFE_VARIABLES) {
                 this_header = parse_string(this_header, variables);
             }
 
-            if(interp->getheader(m, this_header, &val) != SIEVE_OK) {
-                continue; /*this header does not exist, search the next*/
+            if (interp->getheader(m, this_header, &val) != SIEVE_OK) {
+                continue; /* this header does not exist, search the next */
             }
 #if VERBOSE
             printf ("val %s %s %s\n", val[0], val[1], val[2]);
@@ -829,145 +731,95 @@ envelope_err:
             if (index > 0) {
                 --index;
                 if (index >= header_count) {
-                        res = 0;
-                        break;
+                    res = 0;
+                    break;
                 }
                 header_count = index + 1;
             }
             else if (index < 0) {
                 index += header_count;
                 if (index < 0) {
-                        res = 0;
-                        break;
+                    res = 0;
+                    break;
                 }
                 header_count = index + 1;
             }
 
             /* search through all the headers that match */
 
-            for (y = index; y < header_count && !res; y++)
-            {
-                if  (match == B_COUNT) {
+            for (y = index; y < header_count && !res; y++) {
+                if (match == B_COUNT) {
                     count++;
                 } else {
-                    decoded_header = charset_parse_mimeheader(val[y], 0 /*flags*/);
-                    /*search through all the data*/
-                    currd=datai+2;
-                    for (z=0; z<numdata && !res; z++)
-                    {
-                        const char *data_val;
-
-                        currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                        if (requires & BFE_VARIABLES) {
-                            data_val = parse_string(data_val, variables);
-                        }
-
-                        if (isReg) {
-                            reg= bc_compile_regex(data_val, ctag, errbuf,
-                                                  sizeof(errbuf));
-                            if (!reg)
-                            {
-                                /* Oops */
-                                res=-1;
-                                goto alldone;
-                            }
-
-                            res |= comp(decoded_header, strlen(decoded_header),
-                                        (const char *)reg, comprock);
-                            free(reg);
-                        } else {
-                            res |= comp(decoded_header, strlen(decoded_header),
-                                        data_val, comprock);
-                        }
-                    }
+                    /* Per RFC 5228, Section 5.7,
+                       leading and trailing whitespace are ignored */
+                    decoded_header =
+                        charset_parse_mimeheader(val[y],
+                                                 CHARSET_MIME_UTF8 | CHARSET_TRIMWS);
+
+                    res = do_comparisons(test.u.hhs.pl, decoded_header,
+                                         comp, comprock, ctag,
+                                         (requires & BFE_VARIABLES) ?
+                                         variables : NULL, match_vars);
                     free(decoded_header);
+
+                    if (res < 0) goto header_err;
                 }
             }
         }
 
-        if  (match == B_COUNT )
-        {
+        if (match == B_COUNT) {
             snprintf(scount, SCOUNT_SIZE, "%u", count);
-            /*search through all the data*/
-            currd=datai+2;
-            for (z=0; z<numdata && !res; z++)
-            {
-                const char *data_val;
-
-                currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                if (requires & BFE_VARIABLES) {
-                    data_val = parse_string(data_val, variables);
-                }
-
-#if VERBOSE
-                printf("%d, %s \n", count, data_val);
-#endif
-                res |= comp(scount, strlen(scount), data_val, comprock);
-            }
-
+            /* search through all the data */
+            res = do_comparisons(test.u.hhs.pl, scount,
+                                 comp, comprock, 0 /* regex */,
+                                 (requires & BFE_VARIABLES) ? variables : NULL,
+                                 match_vars);
         }
 
-        /* Update IP */
-        i=(ntohl(bc[datai+1].value)/4);
-
+      header_err:
+        free(strarray_takevf(test.u.hhs.sl));
+        free(strarray_takevf(test.u.hhs.pl));
         break;
     }
-    case BC_STRING:/*21*/
-        is_string = 1;
 
-        GCC_FALLTHROUGH
-
-    case BC_HASFLAG:/*15*/
+    case BC_STRING:
+    case BC_HASFLAG:
     {
-        int haystacksi=i+4;/*the i value for the beginning of the variables*/
-        int needlesi=(ntohl(bc[haystacksi+1].value)/4);
-
-        int numhaystacks=ntohl(bc[haystacksi].len); // number of vars to search
-        int numneedles=ntohl(bc[needlesi].len); // number of search flags
+        int numhaystacks = strarray_size(test.u.hhs.sl); // number of vars to search
+        int numneedles = strarray_size(test.u.hhs.pl); // number of search flags
 
-        int currneedle; /* current needle */
-        int currhaystack; /* current needle */
-
-        int match=ntohl(bc[i+1].value);
-        int relation=ntohl(bc[i+2].value);
-        int comparator=ntohl(bc[i+3].value);
-        int count=0;
-        int isReg = (match==B_REGEX);
+        int match = test.u.hhs.comp.match;
+        int relation = test.u.hhs.comp.relation;
+        int comparator = test.u.hhs.comp.collation;
+        int count = 0;
         int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, regexps tested at compile */
 
         /* set up variables needed for compiling regex */
-        if (isReg) {
+        if (match == B_REGEX) {
             ctag = regcomp_flags(comparator, requires);
         }
 
-        /*find the correct comparator fcn*/
-        comp=lookup_comp(comparator, match, relation, &comprock);
+        /* find the correct comparator fcn */
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
 
-        if(!comp) {
+        if (!comp) {
             res = SIEVE_RUN_ERROR;
             break;
         }
-        if (!comprock) {
-            comprock = varlist_select(variables, VL_MATCH_VARS)->var;
-        }
+        match_vars = varlist_select(variables, VL_MATCH_VARS)->var;
 
         /* loop on each haystack */
-        currhaystack = haystacksi+2;
-        for (z = 0; z < (is_string ? numhaystacks :
+        for (z = 0; z < (op == BC_STRING ? numhaystacks :
                          numhaystacks ? numhaystacks : 1); z++) {
-            const char *this_haystack;
+            const char *this_haystack = NULL;
             strarray_t *this_var = NULL;
 
             if (numhaystacks) {
-                currhaystack = unwrap_string(bc, currhaystack, &this_haystack,
-                                             NULL);
+                this_haystack = strarray_nth(test.u.hhs.sl, z);
             }
 
-            if (is_string) {
+            if (op == BC_STRING) {
                 if (requires & BFE_VARIABLES) {
                     this_haystack = parse_string(this_haystack, variables);
                 }
@@ -990,7 +842,7 @@ envelope_err:
             }
 
 	    if (match == B_COUNT) {
-                if (is_string) {
+                if (op == BC_STRING) {
                     if (this_haystack[0] != '\0') {
                         count += 1;
                     }
@@ -1005,140 +857,102 @@ envelope_err:
                 }
 
 		snprintf(scount, SCOUNT_SIZE, "%u", count);
-		/*search through all the data*/
-		currneedle=needlesi+2;
-		for (z=0; z<numneedles && !res; z++) {
-		    const char *this_needle;
-
-		    currneedle = unwrap_string(bc, currneedle, &this_needle,
-                                               NULL);
-
-		    if (requires & BFE_VARIABLES) {
-			this_needle = parse_string(this_needle, variables);
-		    }
-
-#if VERBOSE
-		    printf("%d, %s \n", count, data_val);
-#endif
-		    res |= comp(scount, strlen(scount), this_needle, comprock);
-		}
+		/* search through all the data */
+                res = do_comparisons(test.u.hhs.pl, scount,
+                                     comp, comprock, 0 /* regex */,
+                                     (requires & BFE_VARIABLES) ?
+                                     variables : NULL,
+                                     match_vars);
                 break;
             }
 
             /* search through the haystack for the needles */
-            currneedle=needlesi+2;
-            for(x=0; x<numneedles && !res; x++)
-                {
-                    const char *this_needle;
+            for (x = 0; x < numneedles && !res; x++) {
+                const char *this_needle;
+                int tmp;
 
-                    currneedle = unwrap_string(bc, currneedle, &this_needle, NULL);
+                this_needle = strarray_nth(test.u.hhs.pl, x);
 
-                    if (requires & BFE_VARIABLES) {
-                        this_needle = parse_string(this_needle, variables);
-                    }
+                if (requires & BFE_VARIABLES) {
+                    this_needle = parse_string(this_needle, variables);
+                }
 
 #if VERBOSE
-                    printf ("val %s %s %s\n", val[0], val[1], val[2]);
+                printf ("val %s %s %s\n", val[0], val[1], val[2]);
 #endif
 
-                    if (is_string) {
-                        if (isReg) {
-                            reg = bc_compile_regex(this_needle, ctag, errbuf,
-                                                   sizeof(errbuf));
-                            if (!reg)
-                                {
-                                    /* Oops */
-                                    res=-1;
-                                    goto alldone;
-                                }
+                if (op == BC_STRING) {
+                    tmp = do_comparison(this_needle, this_haystack,
+                                        comp, comprock, ctag,
+                                        NULL /* variables */, match_vars);
+                    if (tmp < 0) {
+                        res = -1;
+                        goto string_err;
+                    }
+
+                    res |= tmp;
+                } else {
+                    /* search through all the flags */
+
+                    for (y = 0; y < this_var->count && !res; y++) {
+                        const char *active_flag;
 
-                            res |= comp(this_haystack, strlen(this_haystack),
-                                        (const char *)reg, comprock);
-                            free(reg);
-                        } else {
-                            res |= comp(this_haystack, strlen(this_haystack),
-                                        this_needle, comprock);
+                        active_flag = this_var->data[y];
+
+                        tmp = do_comparison(this_needle, active_flag,
+                                            comp, comprock, ctag,
+                                            NULL /* variables */, match_vars);
+                        if (tmp < 0) {
+                            res = -1;
+                            goto string_err;
                         }
-                    } else {
-                        /* search through all the flags */
 
-                        for (y=0; y < this_var->count && !res; y++)
-                            {
-                                const char *active_flag;
-
-                                active_flag = this_var->data[y];
-
-                                if (isReg) {
-                                    reg= bc_compile_regex(this_needle, ctag, errbuf,
-                                                          sizeof(errbuf));
-                                    if (!reg)
-                                        {
-                                            /* Oops */
-                                            res=-1;
-                                            goto alldone;
-                                        }
-
-                                    res |= comp(active_flag, strlen(active_flag),
-                                                (const char *)reg, comprock);
-                                    free(reg);
-                                } else {
-                                    res |= comp(active_flag, strlen(active_flag),
-                                                this_needle, comprock);
-                                }
-                            }
-                    } // (is_string) else
+                        res |= tmp;
+                    }
+                } // (op == BC_STRING) else
 
-                } // loop on each item of the current haystack
+            } // loop on each item of the current haystack
 #if VERBOSE
             {
                 /* for debugging purposes only */
                 char *temp;
                 temp = strarray_join(varlist_select(variables, VL_MATCH_VARS)->var,
                                      ", ");
-                printf((!is_string ? "B_hasflag:" : "B_STRING"));
+                printf((op == BC_STRING ? "BC_STRING" : "BC_HASFLAG"));
                 printf(" %s\n\n", temp);
                 free (temp);
             }
 #endif
 	} // loop on each variable or string
 
-        /* Update IP */
-        i=(ntohl(bc[needlesi+1].value)/4);
-
+      string_err:
+        free(strarray_takevf(test.u.hhs.sl));
+        free(strarray_takevf(test.u.hhs.pl));
         break;
     }
-    case BC_BODY:/*10*/
+
+    case BC_BODY:
     {
-        sieve_bodypart_t ** val;
+        sieve_bodypart_t **val;
         const char **content_types = NULL;
 
-        int typesi=i+6;/* the i value for the beginning of the content-types */
-        int datai=(ntohl(bc[typesi+1].value)/4);
-
-        int numdata=ntohl(bc[datai].len);
-
-        int currd; /* current data */
-
-        int match=ntohl(bc[i+1].value);
-        int relation=ntohl(bc[i+2].value);
-        int comparator=ntohl(bc[i+3].value);
-        int transform=ntohl(bc[i+4].value);
-        /* ntohl(bc[i+5].value) is the now unused 'offset' */
-        int count=0;
-        int isReg = (match==B_REGEX);
+        int match = test.u.b.comp.match;
+        int relation = test.u.b.comp.relation;
+        int comparator = test.u.b.comp.collation;
+        int transform = test.u.b.transform;
+        /* test.u.b.offset is now unused */
+        int count = 0;
         int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, as regexps are tested at compile */
 
         /* set up variables needed for compiling regex */
-        if (isReg) {
+        if (match == B_REGEX) {
             ctag = regcomp_flags(comparator, requires);
         }
 
-        /*find the correct comparator fcn*/
-        comp = lookup_comp(comparator, match, relation, &comprock);
+        /* find the correct comparator fcn */
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
 
-        if(!comp) {
+        if (!comp) {
             res = SIEVE_RUN_ERROR;
             break;
         }
@@ -1167,8 +981,8 @@ envelope_err:
              /* break; */
         }
 
-        /*find the part(s) of the body that we want*/
-        content_types = bc_makeArray(bc, &typesi);
+        /* find the part(s) of the body that we want */
+        content_types = (const char **) strarray_safetakevf(test.u.b.content_types);
         res = interp->getbody(m, content_types, &val);
         free(content_types);
 
@@ -1178,38 +992,22 @@ envelope_err:
 
         for (y = 0; val && val[y]; y++) {
 
-            if (match == B_COUNT) {
-                count++;
-            } else if (val[y]->decoded_body) {
-                const char *content = val[y]->decoded_body;
-
-                /* search through all the data */
-                currd=datai+2;
-                for (z=0; z<numdata && !res; z++)
-                {
-                    const char *data_val;
-
-                    currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                    if (requires & BFE_VARIABLES) {
-                        data_val = parse_string(data_val, variables);
-                    }
-
-                    if (isReg) {
-                        reg = bc_compile_regex(data_val, ctag,
-                                               errbuf, sizeof(errbuf));
-                        if (!reg) {
-                            /* should only get here due to a memory issue */
-                            res = SIEVE_NOMEM;
-                            break;
-                        }
+            if (!res) {
+                if (match == B_COUNT) {
+                    count++;
+                } else if (val[y]->decoded_body) {
+                    const char *content = val[y]->decoded_body;
 
-                        res |= comp(content, strlen(content), (const char *)reg, comprock);
-                        free(reg);
-                    } else {
-                        res |= comp(content, strlen(content), data_val, comprock);
+                    /* search through all the data */
+                    res = do_comparisons(test.u.b.pl, content,
+                                        comp, comprock, ctag,
+                                        (requires & BFE_VARIABLES) ?
+                                        variables : NULL, match_vars);
+                    if (res < 0) {
+                        free(val[y]);
+                        goto body_err;
                     }
-                } /* For each data */
+                }
             }
 
             /* free the bodypart */
@@ -1220,103 +1018,22 @@ envelope_err:
         /* free the bodypart array */
         if (val) free(val);
 
-        if  (match == B_COUNT)
-        {
+        if (match == B_COUNT) {
             snprintf(scount, SCOUNT_SIZE, "%u", count);
             /* search through all the data */
-            currd=datai+2;
-            for (z=0; z<numdata && !res; z++)
-            {
-                const char *data_val;
-
-                currd = unwrap_string(bc, currd, &data_val, NULL);
-
-                if (requires & BFE_VARIABLES) {
-                    data_val = parse_string(data_val, variables);
-                }
-
-                res |= comp(scount, strlen(scount), data_val, comprock);
-            }
+            res = do_comparisons(test.u.b.pl, scount,
+                                 comp, comprock, 0 /* regex */,
+                                 (requires & BFE_VARIABLES) ? variables : NULL,
+                                 match_vars);
         }
 
-        /* Update IP */
-        i=(ntohl(bc[datai+1].value)/4);
-
+      body_err:
+        free(strarray_takevf(test.u.b.pl));
         break;
     }
-    case BC_DATE:/*11*/
-        has_index=1;
-        GCC_FALLTHROUGH
 
-    case BC_CURRENTDATE:/*12*/
-        if (0x07 == version) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * or comparator argument.  This will correctly identify whether
-             * the index extension was supported in every case except the case
-             * of a timezone that is 61 minutes offset (since 61 corresponds to
-             * B_ORIGINALZONE).
-             * There was also an unnumbered version of BC_CURRENTDATE that did
-             * allow :index.  This also covers that case.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(bc[i+4].value)) {
-            /* if the 4th parameter is a comparator, we have neither :index nor
-             *  :zone tags.  B_ORIGINALZONE is the first parameter.
-             */
-            case B_ASCIICASEMAP:
-            case B_OCTET:
-            case B_ASCIINUMERIC:
-                has_index = 0;
-                break;
-            default:
-                /* otherwise, we either have a :zone tag, an :index tag, or
-                 * both
-                 */
-                switch (ntohl(bc[i+5].value)) {
-                /* if the 5th paramater is a comparator, we have either :index
-                 * or :zone, but not both.
-                 */
-                case B_ASCIICASEMAP:
-                case B_OCTET:
-                case B_ASCIINUMERIC:
-                    /* The ambiguous case is B_TIMEZONE as 1st parameter and
-                     * B_ORIGINALZONE as second parameter, which could mean
-                     * either ':index 60 :originalzone' or ':zone "+0101"'
-                     */
-                    if (B_TIMEZONE == ntohl(bc[i+1].value) &&
-                            B_ORIGINALZONE == ntohl(bc[i+2].value)) {
-                        /* This is the ambiguous case.  Resolve the ambiguity
-                         * by assuming that there is no :index tag since the
-                         * unnumbered bytecode that shipped with Kolab
-                         * Groupware 3.3 included support for the date
-                         * extension, but not for the index extension.
-                         */
-                        has_index = 0;
-
-                    } else if (B_TIMEZONE == ntohl(bc[i+1].value)) {
-                        /* if the first parameter is B_TIMEZONE, and the above
-                         * test was false, it must be a :zone tag, and we
-                         * don't have :index.
-                         */
-                        has_index = 0;
-                    } else {
-                        /* if the first parameter is not B_TIMEZONE, it must
-                         * be an :index tag, and we don't have :zone.
-                         */
-                        has_index = 1;
-                    }
-                    break;
-                default:
-                    /* if the 5th parameter is not a comparator, the 6th is,
-                     * and we have both :index and :zone
-                     */
-                    has_index = 1;
-                }
-            }
-        }
+    case BC_DATE:
+    case BC_CURRENTDATE:
     {
         char buffer[64];
         const char **headers = NULL;
@@ -1336,126 +1053,116 @@ envelope_err:
         struct tm tm;
         time_t t;
 
-        ++i; /* BC_DATE | BC_CURRENTDATE */
-
         /* index */
-        index = has_index ? ntohl(bc[i++].value) : 0;
+        index = test.u.dt.comp.index;
 
         /* zone tag */
-        zone = ntohl(bc[i++].value);
+        zone = test.u.dt.zonetag;
 
         /* timezone offset */
         if (zone == B_TIMEZONE) {
-                timezone_offset = ntohl(bc[i++].value);
+            timezone_offset = test.u.dt.zone;
         }
 
         /* comparator */
-        match = ntohl(bc[i++].value);
-        relation = ntohl(bc[i++].value);
-        comparator = ntohl(bc[i++].value);
+        match = test.u.dt.comp.match;
+        relation = test.u.dt.comp.relation;
+        comparator = test.u.dt.comp.collation;
 
         /* find comparator function */
-        comp = lookup_comp(comparator, match, relation, &comprock);
-        if(!comp) {
-                res = SIEVE_RUN_ERROR;
-                break;
-        }
-        if (!comprock) {
-            comprock = varlist_select(variables, VL_MATCH_VARS)->var;
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
+        if (!comp) {
+            res = SIEVE_RUN_ERROR;
+            break;
         }
+        match_vars = varlist_select(variables, VL_MATCH_VARS)->var;
 
         /* date-part */
-        date_part = ntohl(bc[i++].value);
+        date_part = test.u.dt.date_part;
 
         if (BC_DATE == op) {
-                /* header name */
-                i = unwrap_string(bc, i, &header_name, NULL);
+            /* header name */
+            header_name = test.u.dt.header_name;
 
-                if (requires & BFE_VARIABLES) {
-                    header_name = parse_string(header_name, variables);
-                }
+            if (requires & BFE_VARIABLES) {
+                header_name = parse_string(header_name, variables);
+            }
 
-                /*
-                 * Process header
-                 */
+            /*
+             * Process header
+             */
 
-                if (interp->getheader(m, header_name, &headers) != SIEVE_OK) {
-                        res = 0;
-                        free(bc_makeArray(bc, &i));
-                        break;
-                }
+            if (interp->getheader(m, header_name, &headers) != SIEVE_OK) {
+                res = 0;
+                break;
+            }
 
-                /* count results */
-                header_count = 0;
-                while (headers[header_count] != NULL) {
-                        ++header_count;
-                }
+            /* count results */
+            header_count = 0;
+            while (headers[header_count] != NULL) {
+                ++header_count;
+            }
 
-                /* convert index argument value to array index */
-                if (index > 0) {
-                        --index;
-                        if (index >= header_count) {
-                                res = 0;
-                                free(bc_makeArray(bc, &i));
-                                break;
-                        }
-                        header_count = index + 1;
-                }
-                else if (index < 0) {
-                        index += header_count;
-                        if (index < 0) {
-                                res = 0;
-                                free(bc_makeArray(bc, &i));
-                                break;
-                        }
-                        header_count = index + 1;
+            /* convert index argument value to array index */
+            if (index > 0) {
+                --index;
+                if (index >= header_count) {
+                    res = 0;
+                    break;
                 }
-
-                /* check if index is out of bounds */
-                if (index < 0 || index >= header_count) {
-                        res = 0;
-                        free(bc_makeArray(bc, &i));
-                        break;
+                header_count = index + 1;
+            }
+            else if (index < 0) {
+                index += header_count;
+                if (index < 0) {
+                    res = 0;
+                    break;
                 }
-                header = headers[index];
+                header_count = index + 1;
+            }
 
-                /* look for separator */
-                header_data = strrchr(header, ';');
-                if (header_data) {
-                        /* separator found, skip character and continue */
-                        ++header_data;
-                }
-                else {
-                        /* separator not found, use full header */
-                        header_data = header;
-                }
+            /* check if index is out of bounds */
+            if (index < 0 || index >= header_count) {
+                res = 0;
+                break;
+            }
+            header = headers[index];
 
-                if (-1 == time_from_rfc822(header_data, &t)) {
-                        res = 0;
-                        free(bc_makeArray(bc, &i));
-                        break;
-                }
+            /* look for separator */
+            header_data = strrchr(header, ';');
+            if (header_data) {
+                /* separator found, skip character and continue */
+                ++header_data;
+            }
+            else {
+                /* separator not found, use full header */
+                header_data = header;
+            }
 
-                /* timezone offset */
-                if (zone == B_ORIGINALZONE) {
-                        char *zone;
-                        char sign;
-                        int hours;
-                        int minutes;
-
-                        zone = strrchr(header, ' ');
-                        if (!zone ||
-                            3 != sscanf(zone + 1, "%c%02d%02d", &sign, &hours, &minutes)) {
-                                res = 0;
-                                free(bc_makeArray(bc, &i));
-                                break;
-                        }
+            if (-1 == time_from_rfc5322(header_data, &t, DATETIME_FULL)) {
+                res = 0;
+                break;
+            }
 
-                        timezone_offset = (sign == '-' ? -1 : 1) * ((hours * 60) + (minutes));
+            /* timezone offset */
+            if (zone == B_ORIGINALZONE) {
+                char *zone;
+                char sign;
+                int hours;
+                int minutes;
+
+                zone = strrchr(header, ' ');
+                if (!zone ||
+                    3 != sscanf(zone + 1, "%c%02d%02d", &sign, &hours, &minutes)) {
+                    res = 0;
+                    break;
                 }
+
+                timezone_offset = (sign == '-' ? -1 : 1) * ((hours * 60) + (minutes));
+            }
         }
         else { /* CURRENTDATE */
-                t = interp->time;
+            t = interp->time;
         }
 
         /* apply timezone_offset (if any) */
@@ -1474,91 +1181,107 @@ envelope_err:
                 goto alldone;
         }
 
-        keylist = bc_makeArray(bc, &i);
+        keylist = (const char **) strarray_safetakevf(test.u.dt.kl);
         for (key = keylist; *key; ++key) {
-                switch (date_part) {
-                case B_YEAR:
-                        snprintf(buffer, sizeof(buffer), "%04d", 1900 + tm.tm_year);
-                        break;
-                case B_MONTH:
-                        snprintf(buffer, sizeof(buffer), "%02d", 1 + tm.tm_mon);
-                        break;
-                case B_DAY:
-                        snprintf(buffer, sizeof(buffer), "%02d", tm.tm_mday);
-                        break;
-                case B_DATE:
-                        snprintf(buffer, sizeof(buffer), "%04d-%02d-%02d",
-                            1900 + tm.tm_year, 1 + tm.tm_mon, tm.tm_mday);
-                        break;
-                case B_JULIAN: {
-                        int month, year;
-                        int c, ya;
-
-                        month = 1 + tm.tm_mon;
-                        year = 1900 + tm.tm_year;
+            switch (date_part) {
+            case B_YEAR:
+                snprintf(buffer, sizeof(buffer), "%04d", 1900 + tm.tm_year);
+                break;
+            case B_MONTH:
+                snprintf(buffer, sizeof(buffer), "%02d", 1 + tm.tm_mon);
+                break;
+            case B_DAY:
+                snprintf(buffer, sizeof(buffer), "%02d", tm.tm_mday);
+                break;
+            case B_DATE:
+                snprintf(buffer, sizeof(buffer), "%04d-%02d-%02d",
+                         1900 + tm.tm_year, 1 + tm.tm_mon, tm.tm_mday);
+                break;
+            case B_JULIAN: {
+                int month, year;
+                int c, ya;
 
-                        if (month > 2) {
-                            month -= 3;
-                        }
-                        else {
-                            month += 9;
-                            --year;
-                        }
-                        c = year / 100;
-                        ya = year - c * 100;
+                month = 1 + tm.tm_mon;
+                year = 1900 + tm.tm_year;
 
-                        snprintf(buffer, sizeof(buffer), "%d",
-                            (c * 146097 / 4 + ya * 1461 / 4 +
-                              (month * 153 + 2) / 5 + tm.tm_mday + 1721119));
-                        } break;
-                case B_HOUR:
-                        snprintf(buffer, sizeof(buffer), "%02d", tm.tm_hour);
-                        break;
-                case B_MINUTE:
-                        snprintf(buffer, sizeof(buffer), "%02d", tm.tm_min);
-                        break;
-                case B_SECOND:
-                        snprintf(buffer, sizeof(buffer), "%02d", tm.tm_sec);
-                        break;
-                case B_TIME:
-                        snprintf(buffer, sizeof(buffer), "%02d:%02d:%02d",
-                            tm.tm_hour, tm.tm_min, tm.tm_sec);
-                        break;
-                case B_ISO8601:
-                        time_to_iso8601(t, buffer, sizeof(buffer), 1);
-                        break;
-                case B_STD11:
-                        time_to_rfc822(t, buffer, sizeof(buffer));
-                        break;
-                case B_ZONE:
-                        snprintf(buffer, sizeof(buffer), "%c%02d%02d",
-                            timezone_offset >= 0 ? '+' : '-',
-                            abs(timezone_offset) / 60,
-                            abs(timezone_offset) % 60);
-                        break;
-                case B_WEEKDAY:
-                        snprintf(buffer, sizeof(buffer), "%1d", tm.tm_wday);
-                        break;
+                if (month > 2) {
+                    month -= 3;
+                }
+                else {
+                    month += 9;
+                    --year;
                 }
+                c = year / 100;
+                ya = year - c * 100;
+
+                snprintf(buffer, sizeof(buffer), "%d",
+                         (c * 146097 / 4 + ya * 1461 / 4 +
+                          (month * 153 + 2) / 5 + tm.tm_mday + 1721119));
+            } break;
+            case B_HOUR:
+                snprintf(buffer, sizeof(buffer), "%02d", tm.tm_hour);
+                break;
+            case B_MINUTE:
+                snprintf(buffer, sizeof(buffer), "%02d", tm.tm_min);
+                break;
+            case B_SECOND:
+                snprintf(buffer, sizeof(buffer), "%02d", tm.tm_sec);
+                break;
+            case B_TIME:
+                snprintf(buffer, sizeof(buffer), "%02d:%02d:%02d",
+                         tm.tm_hour, tm.tm_min, tm.tm_sec);
+                break;
+            case B_ISO8601:
+                time_to_iso8601(t, buffer, sizeof(buffer), 1);
+                break;
+            case B_STD11:
+                time_to_rfc5322(t, buffer, sizeof(buffer));
+                break;
+            case B_ZONE:
+                snprintf(buffer, sizeof(buffer), "%c%02d%02d",
+                         timezone_offset >= 0 ? '+' : '-',
+                         abs(timezone_offset) / 60,
+                         abs(timezone_offset) % 60);
+                break;
+            case B_WEEKDAY:
+                snprintf(buffer, sizeof(buffer), "%1d", tm.tm_wday);
+                break;
+            }
 
-                res |= comp(buffer, strlen(buffer), *key, comprock);
+            res |= comp(buffer, strlen(buffer), *key, match_vars, comprock);
         }
         free(keylist);
         break;
     }
-    case BC_MAILBOXEXISTS:/*16*/
+
+    case BC_IHAVE:
+        res = 1;
+
+        list_len = strarray_size(test.u.sl);
+
+        for (x = 0; x < list_len && res; x++) {
+            const char *str;
+
+            str = strarray_nth(test.u.sl, x);
+
+            if (!extension_isactive(interp, str)) res = 0;
+        }
+
+        free(strarray_takevf(test.u.sl));
+        break;
+
+    case BC_MAILBOXEXISTS:
         res = 0;
-        i++;
-        list_len=ntohl(bc[i++].len);
-        list_end=ntohl(bc[i++].len)/4;
+
+        list_len = strarray_size(test.u.mm.keylist);
 
         /* need to process all of them, to ensure our instruction pointer stays
          * in the right place */
-        for (x=0; x<list_len && !res; x++) {
+        for (x = 0; x < list_len && !res; x++) {
             const char *extname;
 
             /* this is a mailbox name in external namespace */
-            i = unwrap_string(bc, i, &extname, NULL);
+            extname = strarray_nth(test.u.mm.keylist, x);
 
             if (requires & BFE_VARIABLES) {
                 extname = parse_string(extname, variables);
@@ -1568,109 +1291,118 @@ envelope_err:
             if (res) break;
         }
 
-        i = list_end; /* handle short-circuting */
+        free(strarray_takevf(test.u.mm.keylist));
+        break;
+
+    case BC_MAILBOXIDEXISTS:
+        res = 0;
+
+        list_len = strarray_size(test.u.mm.keylist);
+
+        /* need to process all of them, to ensure our instruction pointer stays
+         * in the right place */
+        for (x = 0; x < list_len && !res; x++) {
+            const char *extname;
+
+            /* this is a mailbox name in external namespace */
+            extname = strarray_nth(test.u.mm.keylist, x);
+
+            if (requires & BFE_VARIABLES) {
+                extname = parse_string(extname, variables);
+            }
+
+            res = interp->getmailboxidexists(sc, extname);
+            if (res) break;
+        }
+
+        free(strarray_takevf(test.u.mm.keylist));
         break;
 
-    case BC_METADATA:/*17*/
+    case BC_METADATA:
+    case BC_SERVERMETADATA:
+    case BC_ENVIRONMENT:
+    case BC_NOTIFYMETHODCAPABILITY:
     {
         res = 0;
         const char *extname = NULL;
         const char *keyname = NULL;
         char *val = NULL;
         i++;
-        int match=ntohl(bc[i++].value);
-        int relation=ntohl(bc[i++].value);
-        int comparator=ntohl(bc[i++].value);
-        int isReg = (match==B_REGEX);
+        int match = test.u.mm.comp.match;
+        int relation = test.u.mm.comp.relation;
+        int comparator = test.u.mm.comp.collation;
         int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, regexps tested at compile */
 
         /* set up variables needed for compiling regex */
-        if (isReg) {
+        if (match == B_REGEX) {
             ctag = regcomp_flags(comparator, requires);
         }
 
-        /*find the correct comparator fcn*/
-        comp=lookup_comp(comparator, match, relation, &comprock);
+        /* find the correct comparator fcn */
+        comp = lookup_comp(interp, comparator, match, relation, &comprock);
 
-        if(!comp) {
+        if (!comp) {
             res = SIEVE_RUN_ERROR;
             break;
         }
 
-        i = unwrap_string(bc, i, &extname, NULL);
-        i = unwrap_string(bc, i, &keyname, NULL);
-        /* unpack the world */
-        list_len=ntohl(bc[i++].len);
-        list_end=ntohl(bc[i++].len)/4;
+        if (op == BC_METADATA || op == BC_NOTIFYMETHODCAPABILITY) {
+            extname = test.u.mm.extname;
 
+            if (requires & BFE_VARIABLES) {
+                extname = parse_string(extname, variables);
+            }
+        }
+
+        keyname = test.u.mm.keyname;
         if (requires & BFE_VARIABLES) {
-            extname = parse_string(extname, variables);
             keyname = parse_string(keyname, variables);
         }
 
-        interp->getmetadata(sc, extname, keyname, &val);
-
-        /* need to process all of them, to ensure our instruction pointer stays
-         * in the right place */
-        for (x=0; val && x<list_len; x++) {
-            const char *testval;
-
-            /* this is a mailbox name in external namespace */
-            i = unwrap_string(bc, i, &testval, NULL);
-
-            if (isReg) {
-                reg = bc_compile_regex(testval, ctag,
-                                       errbuf, sizeof(errbuf));
-                if (!reg) {
-                    /* Oops */
-                    free(val);
-                    res=-1;
-                    goto alldone;
-                }
+        if (op == BC_ENVIRONMENT)
+            interp->getenvironment(sc, keyname, &val);
+        else if (op == BC_NOTIFYMETHODCAPABILITY) {
+            if (!strcasecmp(keyname, "online")) val = xstrdup("maybe");
+            else if (!strcasecmp(keyname, "fcc")) val = xstrdup("no");
+        }
+        else
+            interp->getmetadata(sc, extname, keyname, &val);
 
-                res |= comp(val, strlen(val),
-                            (const char *)reg, comprock);
-                free(reg);
-            } else {
-#if VERBOSE
-                printf("%s compared to %s(from script)\n",
-                       val, testval);
-#endif
-                res |= comp(val, strlen(val),
-                            testval, comprock);
-            }
-            if (res) break;
+        if (val) {
+            res = do_comparisons(test.u.mm.keylist, val,
+                                 comp, comprock, ctag,
+                                 (requires & BFE_VARIABLES) ? variables : NULL,
+                                 match_vars);
+            free(val);
         }
 
-        i = list_end; /* handle short-circuting */
-        free(val);
+        free(strarray_takevf(test.u.mm.keylist));
         break;
     }
 
-    case BC_METADATAEXISTS:/*18*/
+    case BC_METADATAEXISTS:
+    case BC_SERVERMETADATAEXISTS:
     {
         res = 1;
+
         const char *extname = NULL;
-        i++;
-        i = unwrap_string(bc, i, &extname, NULL);
-        /* unpack the world */
-        list_len=ntohl(bc[i++].len);
-        list_end=ntohl(bc[i++].len)/4;
 
-        if (requires & BFE_VARIABLES) {
-            extname = parse_string(extname, variables);
+        if (op == BC_METADATAEXISTS) {
+            extname = test.u.mm.extname;
+
+            if (requires & BFE_VARIABLES) {
+                extname = parse_string(extname, variables);
+            }
         }
 
-        /* need to process all of them, to ensure our instruction pointer stays
-         * in the right place */
-        for (x=0; x<list_len; x++) {
+        list_len = strarray_size(test.u.mm.keylist);
+
+        for (x = 0; x < list_len; x++) {
             const char *keyname = NULL;
             char *val = NULL;
 
             /* this is an annotation name */
-            i = unwrap_string(bc, i, &keyname, NULL);
+            keyname = strarray_nth(test.u.mm.keylist, x);
 
             if (requires & BFE_VARIABLES) {
                 keyname = parse_string(keyname, variables);
@@ -1682,107 +1414,140 @@ envelope_err:
             if (!res) break;
         }
 
-        i = list_end; /* handle short-circuting */
+        free(strarray_takevf(test.u.mm.keylist));
         break;
     }
 
-    case BC_SERVERMETADATA:/*19*/
-    {
-        res = 0;
-        const char *keyname = NULL;
-        char *val = NULL;
-        i++;
-        int match=ntohl(bc[i++].value);
-        int relation=ntohl(bc[i++].value);
-        int comparator=ntohl(bc[i++].value);
-        int isReg = (match==B_REGEX);
-        int ctag = 0;
-        regex_t *reg;
-        char errbuf[100]; /* Basically unused, regexps tested at compile */
+    case BC_VALIDEXTLIST:
+        res = 1;
 
-        /* set up variables needed for compiling regex */
-        if (isReg) {
-            ctag = regcomp_flags(comparator, requires);
-        }
+        list_len = strarray_size(test.u.sl);
 
-        /*find the correct comparator fcn*/
-        comp=lookup_comp(comparator, match, relation, &comprock);
+        for (x = 0; x < list_len && res; x++) {
+            const char *str;
 
-        if(!comp) {
-            res = SIEVE_RUN_ERROR;
-            break;
+            str = strarray_nth(test.u.sl, x);
+
+            if (requires & BFE_VARIABLES) {
+                str = parse_string(str, variables);
+            }
+
+            if (interp->isvalidlist(interp->interp_context, str) != SIEVE_OK)
+                res = 0;
         }
-        i = unwrap_string(bc, i, &keyname, NULL);
-        /* unpack the world */
-        list_len=ntohl(bc[i++].len);
-        list_end=ntohl(bc[i++].len)/4;
 
-        interp->getmetadata(sc, NULL, keyname, &val);
+        break;
 
-        /* need to process all of them, to ensure our instruction pointer stays
-         * in the right place */
-        for (x=0; val && x<list_len; x++) {
-            const char *testval;
+    case BC_VALIDNOTIFYMETHOD:
+        res = 1;
 
-            /* this is a mailbox name in external namespace */
-            i = unwrap_string(bc, i, &testval, NULL);
+        list_len = strarray_size(test.u.sl);
 
-            if (isReg) {
-                reg = bc_compile_regex(testval, ctag,
-                                       errbuf, sizeof(errbuf));
-                if (!reg) {
-                    /* Oops */
-                    free(val);
-                    res=-1;
-                    goto alldone;
-                }
+        for (x = 0; x < list_len && res; x++) {
+            const char *str;
 
-                res |= comp(val, strlen(val),
-                            (const char *)reg, comprock);
-                free(reg);
-            } else {
-#if VERBOSE
-                printf("%s compared to %s(from script)\n",
-                       val, testval);
-#endif
-                res |= comp(val, strlen(val),
-                            testval, comprock);
+            str = strarray_nth(test.u.sl, x);
+
+            if (requires & BFE_VARIABLES) {
+                str = parse_string(str, variables);
+                char *p = strchr(str, ':');
+                if (p) p[1] = '\0';
             }
-            if (res) break;
+
+            if (strarray_find_case(interp->notifymethods, str, 0) == -1)
+                res = 0;
         }
 
-        i = list_end; /* handle short-circuting */
-        free(val);
+        break;
+
+    case BC_DUPLICATE:
+    {
+        int type = test.u.dup.idtype;
+        const char *idval, *handle;
+        int last;
+        sieve_duplicate_context_t dc;
+
+        idval = test.u.dup.idval;
+        handle = test.u.dup.handle;
+
+        dc.seconds = test.u.dup.seconds;
+        last = test.u.dup.last;
+
+        res = 1;
+        if (!dc.seconds) res = 0;
+        else if (type == B_HEADER) {
+            /* fetch header body */
+            const char **hdr;
+            if (interp->getheader(m, idval, &hdr) != SIEVE_OK) res = 0;
+            else idval = hdr[0];
+        }
+        else if (requires & BFE_VARIABLES) {
+            /* substitute variables in uniqueid */
+            idval = parse_string(idval, variables);
+        }
+
+        if (res) {
+            struct buf id = BUF_INITIALIZER;
+            const char *errmsg;
+
+            /* prefix the ID with the handle */
+            buf_printf(&id, "%s:%s", handle, idval);
+            dc.id = buf_release(&id);
+
+            res = interp->duplicate->check(&dc, interp->interp_context,
+                                           sc, m, &errmsg);
+            if (!res || last) {
+                /* add tracking record to list
+                   (to be processed iff script executes successfully) */
+                do_duptrack(duptrack_list, &dc);
+            }
+            else free(dc.id);
+        }
         break;
     }
 
-    case BC_SERVERMETADATAEXISTS:/*20*/
+    case BC_SPECIALUSEEXISTS:
     {
         res = 1;
-        /* unpack the world */
-        i++;
-        list_len=ntohl(bc[i++].len);
-        list_end=ntohl(bc[i++].len)/4;
+        const char *extname = NULL;
+        strarray_t uses = STRARRAY_INITIALIZER;
 
-        /* need to process all of them, to ensure our instruction pointer stays
-         * in the right place */
-        for (x=0; x<list_len; x++) {
-            const char *keyname = NULL;
-            char *val = NULL;
+        extname = test.u.mm.extname;
 
-            /* this is an annotation name */
-            i = unwrap_string(bc, i, &keyname, NULL);
+        list_len = strarray_size(test.u.mm.keylist);
 
-            interp->getmetadata(sc, NULL, keyname, &val);
-            if (!val) res = 0;
-            free(val);
-            if (!res) break;
+        if (extname && !(res = interp->getmailboxexists(sc, extname))) {
+            break;
         }
 
-        i = list_end; /* handle short-circuting */
+        for (x = 0; x < list_len; x++) {
+            const char *use = NULL;
+
+            /* this is a special-use flag */
+            use = strarray_nth(test.u.mm.keylist, x);
+            strarray_add_case(&uses, use);
+        }
+
+        res = interp->getspecialuseexists(sc, extname, &uses);
+        strarray_fini(&uses);
+
+        free(strarray_takevf(test.u.mm.keylist));
         break;
     }
 
+    case BC_JMAPQUERY:
+        if (interp->jmapquery) {
+            const char *json = test.u.jquery;
+
+            if (requires & BFE_VARIABLES) {
+                json = parse_string(json, variables);
+            }
+
+            res = interp->jmapquery(sc, m, json);
+        }
+        else res = 0;
+        break;
+
     default:
 #if VERBOSE
         printf("WERT, can't evaluate if statement. %d is not a valid command",
@@ -1794,32 +1559,61 @@ envelope_err:
 
  alldone:
 
-    *ip=i;
+    *ip = i;
     return res;
 }
 
-int sieve_bytecode_version(const sieve_bytecode_t *bc)
+void unwrap_flaglist(strarray_t *strlist, strarray_t **flaglist,
+                     variable_list_t *variables)
 {
-    if (!bc) return 0;
+    if (!strlist) return;
+
+    int len = strarray_size(strlist);
+
+    if (len) {
+        int i;
+
+        if (!*flaglist) *flaglist = strarray_new();
 
-    int version, v_index;
-    const bytecode_input_t *input = (bytecode_input_t *) bc->data;
+        for (i = 0; i < len; i++) {
+            const char *flag;
 
-    v_index = BYTECODE_MAGIC_LEN / sizeof(bytecode_input_t);
-    version = ntohl(input[v_index].op);
+            flag = strarray_nth(strlist, i);
+
+            if (variables) {
+                flag = parse_string(flag, variables);
+            }
+
+            if (flag[0]) {
+                strarray_add_case(*flaglist, flag);
+            }
+        }
+
+        verify_flaglist(*flaglist);
+    }
 
-    /* XXX may need to convert value "1" from host byte order? */
-    return version;
+    free(strarray_takevf(strlist));
 }
 
+const char *priority_to_string(int priority)
+{
+    switch (priority) {
+    case B_LOW:    return "low";
+    case B_NORMAL: return "normal";
+    case B_HIGH:   return "high";
+    case B_ANY:    return "any";
+    default:       return NULL;
+    }
+}
+
+
 /* The entrypoint for bytecode evaluation */
 int sieve_eval_bc(sieve_execute_t *exe, int is_incl, sieve_interp_t *i,
-                  void *sc, void *m,
-                  variable_list_t *variables, action_list_t *actions,
-                  notify_list_t *notify_list, const char **errmsg)
+                  void *sc, void *m, variable_list_t *variables,
+                  action_list_t *actions, notify_list_t *notify_list,
+                  duptrack_list_t *duptrack_list, const char **errmsg)
 {
-    const char *data;
-    int res=0;
+    int res = 0;
     int op;
     int version;
     int requires = 0;
@@ -1838,24 +1632,21 @@ int sieve_eval_bc(sieve_execute_t *exe,
      * a) have bytecode
      * b) it is atleast long enough for the magic number, the version
      *    and one opcode */
-    if(!bc) return SIEVE_FAIL;
-    if(bc_cur->len < (BYTECODE_MAGIC_LEN + 2*sizeof(bytecode_input_t)))
+    if (!bc) return SIEVE_FAIL;
+    if (bc_cur->len < (BYTECODE_MAGIC_LEN + 2*sizeof(bytecode_input_t)))
        return SIEVE_FAIL;
 
-    if(memcmp(bc, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN)) {
+    ip = bc_header_parse(bc, &version, &requires);
+    if (ip < 0) {
         *errmsg = "Not a bytecode file";
         return SIEVE_FAIL;
     }
 
-    ip = BYTECODE_MAGIC_LEN / sizeof(bytecode_input_t);
-
-    version = sieve_bytecode_version(bc_cur);
-
     /* this is because there was a time where integers were not network byte
        order.  all the scripts written then would have version 0x01 written
        in host byte order.*/
 
-     if(version == (int)ntohl(1)) {
+     if (version == (int) ntohl(1)) {
         if(errmsg) {
             *errmsg =
                 "Incorrect Bytecode Version, please recompile (use sievec)";
@@ -1864,8 +1655,8 @@ int sieve_eval_bc(sieve_execute_t *exe,
         return SIEVE_FAIL;
     }
 
-    if((version < BYTECODE_MIN_VERSION) || (version > BYTECODE_VERSION)) {
-        if(errmsg) {
+    if ((version < BYTECODE_MIN_VERSION) || (version > BYTECODE_VERSION)) {
+        if (errmsg) {
             *errmsg =
                 "Incorrect Bytecode Version, please recompile (use sievec)";
         }
@@ -1876,163 +1667,190 @@ int sieve_eval_bc(sieve_execute_t *exe,
     printf("version number %d\n",version);
 #endif
 
-    if (version >= 0x11) {
-        requires = ntohl(bc[++ip].value);
-    }
-
-    for(ip++; ip<ip_max; ) {
-        /* In this loop, when a case is switch'ed to, ip points to the first
-         * parameter of the action.  This makes it easier to add future
-         * extensions.  Extensions that change an existing action should add
-         * any new parameters to the beginning of the particular action's
-         * bytecode.  This will allow the new code to fall through to the
-         * older code, which will then parse the older parameters and should
-         * require only a minimal set of changes to support any new extension.
-         */
-        int copy = 0;
-        int create = 0;
+    while (ip < ip_max) {
+        commandlist_t cmd;
         strarray_t *actionflags = NULL;
         variable_list_t *variable = NULL;
 
-        op=ntohl(bc[ip++].op);
-        switch(op) {
-        case B_STOP:/*0*/
-            res=1;
-            break;
+        ip = bc_action_parse(bc, ip, version, &cmd);
+        op = cmd.type;
 
-        case B_KEEP:/*22*/
-        {
-            int x;
-            int list_len=ntohl(bc[ip].len);
+        switch (op) {
+        case B_STOP:
+            res = 1;
+            break;
 
-            ip+=2; /* skip opcode, list_len, and list data len */
 
-            if (list_len) {
-                actionflags = (varlist_extend(variables))->var;
-            }
-            for (x=0; x<list_len; x++) {
-                const char *flag;
-                ip = unwrap_string(bc, ip, &flag, NULL);
+        case B_KEEP:
+        case B_KEEP_COPY:
+        case B_KEEP_ORIG:
+            unwrap_flaglist(cmd.u.k.flags, &actionflags,
+                            (requires & BFE_VARIABLES) ? variables: NULL);
 
-                if (requires & BFE_VARIABLES) {
-                    flag = parse_string(flag, variables);
-                }
-
-                if (flag[0]) {
-                strarray_add_case(actionflags,flag);
-                }
-            }
-        }
-            copy = ntohl(bc[ip++].value);
-            /* fall through */
-        case B_KEEP_ORIG:/*1*/
-            /* if there's no :flags parameter, use the internal flags var*/
+            /* if there's no :flags parameter, use the internal flags var */
             if (!actionflags) {
-                variable_list_t *temp = varlist_extend(variables);
                 actionflags = strarray_dup(variables->var);
-                strarray_free(temp->var);
-                temp->var = actionflags;
             }
-            verify_flaglist(actionflags);
 
-            res = do_keep(actions, !copy, actionflags);
+            res = do_keep(actions, actionflags);
             if (res == SIEVE_RUN_ERROR)
                 *errmsg = "Keep can not be used with Reject";
+
             actionflags = NULL;
             break;
 
-        case B_DISCARD:/*2*/
-            res=do_discard(actions);
+
+        case B_DISCARD:
+            res = do_discard(actions);
             break;
 
-        case B_REJECT:/*3*/
-            ip = unwrap_string(bc, ip, &data, NULL);
+
+        case B_REJECT:
+        case B_EREJECT:
+        {
+            const char *reason = cmd.u.str;
 
             if (requires & BFE_VARIABLES) {
-                data = parse_string(data, variables);
+                reason = parse_string(reason, variables);
             }
 
-            res = do_reject(actions, data);
+            res = do_reject(actions,
+                            (op == B_EREJECT) ? ACTION_EREJECT : ACTION_REJECT,
+                            reason);
 
             if (res == SIEVE_RUN_ERROR)
-                *errmsg = "Reject can not be used with any other action";
+                *errmsg = "[e]Reject can not be used with any other action";
 
             break;
+        }
 
-        case B_FILEINTO:/*24*/
-            create = ntohl(bc[ip].value);
-            ip+=1;
 
-            /* fall through */
-        case B_FILEINTO_FLAGS:/*23*/
+        case B_FILEINTO:
+        case B_FILEINTO_SPECIALUSE:
+        case B_FILEINTO_CREATE:
+        case B_FILEINTO_FLAGS:
+        case B_FILEINTO_COPY:
+        case B_FILEINTO_ORIG:
         {
-            int x;
-            int list_len=ntohl(bc[ip].len);
+            const char *folder = cmd.u.f.folder;
+            const char *specialuse = cmd.u.f.specialuse;
 
-            ip+=2; /* skip opcode, list_len, and list data len */
-
-            if (list_len) {
-                actionflags = (varlist_extend(variables))->var;
+            if (requires & BFE_VARIABLES) {
+                folder = parse_string(folder, variables);
+                specialuse = parse_string(specialuse, variables);
             }
-            for (x=0; x<list_len; x++) {
-                const char *flag;
-                ip = unwrap_string(bc, ip, &flag, NULL);
 
-                if (requires & BFE_VARIABLES) {
-                    flag = parse_string(flag, variables);
-                }
+            unwrap_flaglist(cmd.u.f.flags, &actionflags,
+                            (requires & BFE_VARIABLES) ? variables: NULL);
 
-                if (flag[0]) {
-                strarray_add_case(actionflags,flag);
-                }
-            }
-        }
-            /* fall through */
-        case B_FILEINTO_COPY:/*19*/
-            copy = ntohl(bc[ip].value);
-            ip+=1;
-
-            /* fall through */
-        case B_FILEINTO_ORIG:/*4*/
-        {
-            /* if there's no :flags parameter, use the internal flags var*/
+            /* if there's no :flags parameter, use the internal flags var */
             if (!actionflags) {
-                variable_list_t *temp = varlist_extend(variables);
                 actionflags = strarray_dup(variables->var);
-                strarray_free(temp->var);
-                temp->var = actionflags;
             }
-            verify_flaglist(actionflags);
 
-            ip = unwrap_string(bc, ip, &data, NULL);
+            res = do_fileinto(actions, folder, specialuse,
+                              !cmd.u.f.copy, cmd.u.f.create, cmd.u.f.mailboxid,
+                              actionflags);
+
+            if (res == SIEVE_RUN_ERROR)
+                *errmsg = "Fileinto can not be used with Reject";
+
+            actionflags = NULL;
+            break;
+        }
+
+
+        case B_SNOOZE:
+        {
+            const char *awaken_mbox = cmd.u.sn.mailbox;
+            strarray_t *addflags = NULL;
+            strarray_t *removeflags = NULL;
 
             if (requires & BFE_VARIABLES) {
-                data = parse_string(data, variables);
+                awaken_mbox = parse_string(awaken_mbox, variables);
             }
 
-            res = do_fileinto(actions, data, !copy, create, actionflags);
+            unwrap_flaglist(cmd.u.sn.addflags, &addflags,
+                            (requires & BFE_VARIABLES) ? variables: NULL);
+            unwrap_flaglist(cmd.u.sn.removeflags, &removeflags,
+                            (requires & BFE_VARIABLES) ? variables: NULL);
+
+            actionflags = strarray_dup(variables->var);
+
+            res = do_snooze(actions, awaken_mbox, cmd.u.sn.is_mboxid,
+                            addflags, removeflags,
+                            cmd.u.sn.days, cmd.u.sn.times, actionflags);
 
             if (res == SIEVE_RUN_ERROR)
-                *errmsg = "Fileinto can not be used with Reject";
+                *errmsg = "Snooze can not be used with Reject";
 
             actionflags = NULL;
             break;
         }
 
-        case B_REDIRECT:/*20*/
-            copy = ntohl(bc[ip].value);
-            ip+=1;
 
-            /* fall through */
-        case B_REDIRECT_ORIG:/*5*/
-        {
-            ip = unwrap_string(bc, ip, &data, NULL);
+        case B_REDIRECT:
+        case B_REDIRECT_LIST:
+        case B_REDIRECT_COPY:
+        case B_REDIRECT_ORIG:
+        {
+            const char *address = cmd.u.r.address;
+            const char *bytime = cmd.u.r.bytime;
+            const char *bymode = cmd.u.r.bymode;
+            const char *dsn_notify = cmd.u.r.dsn_notify;
+            const char *dsn_ret = cmd.u.r.dsn_ret;
+            const char *deliverby = NULL;
 
             if (requires & BFE_VARIABLES) {
-                data = parse_string(data, variables);
+                address = parse_string(address, variables);
+                bytime = parse_string(bytime, variables);
+                bymode = parse_string(bymode, variables);
+                dsn_notify = parse_string(dsn_notify, variables);
+                dsn_ret = parse_string(dsn_ret, variables);
             }
 
-            res = do_redirect(actions, data, !copy);
+            if (bytime) {
+                long sec;
+
+                if (bytime[0] == '+') {
+                    /* Relative time ("+" 1*9DIGIT) */
+                    sec = atol(cmd.u.r.bytime);
+                }
+                else {
+                    /* Absolute time (RFC 3339 date-time) */
+                    time_t t;
+
+                    if (time_from_iso8601(bytime, &t) == -1) {
+                        res = SIEVE_RUN_ERROR;
+                        *errmsg = "Redirect bytimeabsolute value is invalid";
+                    }
+                    sec = t - time(NULL);
+                }
+
+                if (abs((int)sec) > 999999999 /* RFC 2852 */) {
+                    res = SIEVE_RUN_ERROR;
+                    *errmsg = "Redirect bytime value too large";
+                    break;
+                }
+
+                /*
+                  Construct RFC 2852 by-value:
+
+                  by-value = by-time";"by-mode[by-trace]
+                  by-time  = ["-" / "+"]1*9digit ; a <= zero value is not
+                                                 ; allowed with a by-mode of "R"
+                  by-mode  = "N" / "R"           ; "Notify" or "Return"
+                  by-trace = "T"                 ; "Trace"
+                */
+                static char by_value[14];
+                snprintf(by_value, sizeof(by_value), "%+ld;%c%s",
+                         sec, toupper(bymode[0]), cmd.u.r.bytrace ? "T" : "");
+                deliverby = by_value;
+            }
+
+            res = do_redirect(actions, address,
+                              deliverby, dsn_notify, dsn_ret,
+                              cmd.u.r.list, !cmd.u.r.copy);
 
             if (res == SIEVE_RUN_ERROR)
                 *errmsg = "Redirect can not be used with Reject";
@@ -2040,210 +1858,129 @@ int sieve_eval_bc(sieve_execute_t *exe,
             break;
         }
 
-        case B_IF:/*6*/
+
+        case B_IF:
         {
-            int testend=ntohl(bc[ip].value);
+            int testend = cmd.u.i.testend;
             int result;
 
-            ip+=1;
-            result=eval_bc_test(i, m, sc, bc, &ip, variables, version, requires);
+            result = eval_bc_test(i, m, sc, bc, &ip, variables,
+                                duptrack_list, version, requires);
 
-            if (result<0) {
+            if (result < 0) {
                 *errmsg = "Invalid test";
                 return SIEVE_FAIL;
             } else if (result) {
-                /*skip over jump instruction*/
-                testend+=2;
+                /* skip over jump instruction */
+                testend += 2;
             }
-            ip=testend;
 
+            ip = testend;
             break;
         }
 
-        case B_MARK:/*7*/
+
+        case B_MARK:
         {
             int n = i->markflags->count;
+
             while (n) {
                 strarray_add_case(variables->var, i->markflags->data[--n]);
             }
-        }
             break;
-
-        case B_UNMARK:/*8*/
-        {
-            int n = i->markflags->count;
-            while (n) {
-                strarray_remove_all_case(variables->var,
-                        i->markflags->data[--n]);
-            }
         }
-            break;
-
-        case B_ADDFLAG:/*26*/
-            /* get the variable name */
-            ip = unwrap_string(bc, ip, &data, NULL);
-            /* RFC 5229, 3. Interpretation of Strings
-               Strings where no variable substitutions take place are referred to as
-               constant strings.  Future extensions may specify that passing non-
-               constant strings as arguments to its actions or tests is an error.
-
-               The name MUST be a constant string and conform
-               to the syntax of variable-name.
-               (this is done in the parser in sieve.y)
-            */
 
-            /* select or create the variable */
-            variable = varlist_select(variables, data);
-            if (variable) {
-                actionflags = variable->var;
-            } else {
-                actionflags = (variable = varlist_extend(variables))->var;
-                variable->name = xstrdup(data);
-            }
 
-            /* fall through */
-        case B_ADDFLAG_ORIG:/*9*/
+        case B_UNMARK:
         {
-            int x;
-            int list_len=ntohl(bc[ip].len);
-
-            ip+=2; /* skip opcode, list_len, and list data len */
-
-            if (!actionflags) {
-                actionflags = variables->var;
-            }
-
-            for (x=0; x<list_len; x++) {
-                ip = unwrap_string(bc, ip, &data, NULL);
+            int n = i->markflags->count;
 
-                if (requires & BFE_VARIABLES) {
-                    data = parse_string(data, variables);
-                }
-                strarray_add_case(actionflags, data);
+            while (n) {
+                strarray_remove_all_case(variables->var,
+                                         i->markflags->data[--n]);
             }
-            verify_flaglist(actionflags);
             break;
         }
 
-        case B_SETFLAG:/*27*/
-            /* get the variable name */
-            ip = unwrap_string(bc, ip, &data, NULL);
+
+        case B_ADDFLAG:
+        case B_SETFLAG:
+        case B_REMOVEFLAG:
             /* RFC 5229, 3. Interpretation of Strings
-               Strings where no variable substitutions take place are referred to as
-               constant strings.  Future extensions may specify that passing non-
-               constant strings as arguments to its actions or tests is an error.
+               Strings where no variable substitutions take place are
+               referred to as constant strings.  Future extensions may
+               specify that passing non-constant strings as arguments
+               to its actions or tests is an error.
 
-               The name MUST be a constant string and conform
-               to the syntax of variable-name.
+               The name MUST be a constant string and conform to the
+               syntax of variable-name.
                (this is done in the parser in sieve.y)
             */
 
             /* select or create the variable */
-            variable = varlist_select(variables, data);
+            variable = varlist_select(variables, cmd.u.fl.variable);
             if (variable) {
                 actionflags = variable->var;
+            } else if (op == B_REMOVEFLAG) {
+                /* variable doesn't exist, so we're done */
+                break;
             } else {
                 actionflags = (variable = varlist_extend(variables))->var;
-                variable->name = xstrdup(data);
+                variable->name = xstrdup(cmd.u.fl.variable);
             }
 
-            /* fall through */
-        case B_SETFLAG_ORIG:/*10*/
-        {
-            int x;
-            int list_len=ntohl(bc[ip].len);
-
-            ip+=2; /* skip opcode, list_len, and list data len */
+            GCC_FALLTHROUGH
 
+        case B_ADDFLAG_ORIG:
+        case B_SETFLAG_ORIG:
+        case B_REMOVEFLAG_ORIG:
             if (!actionflags) {
                 actionflags = variables->var;
             }
 
-            strarray_fini(actionflags);
+            switch (op) {
+            case B_SETFLAG:
+            case B_SETFLAG_ORIG:
+                strarray_fini(actionflags);
+
+                GCC_FALLTHROUGH
+
+            case B_ADDFLAG:
+            case B_ADDFLAG_ORIG:
+                unwrap_flaglist(cmd.u.fl.flags, &actionflags,
+                                (requires & BFE_VARIABLES) ? variables: NULL);
+                break;
 
-            for (x=0; x<list_len; x++) {
-                ip = unwrap_string(bc, ip, &data, NULL);
+            case B_REMOVEFLAG:
+            case B_REMOVEFLAG_ORIG:
+            {
+                strarray_t *temp = NULL;
+                int x;
 
-                if (requires & BFE_VARIABLES) {
-                    data = parse_string(data, variables);
-                }
+                unwrap_flaglist(cmd.u.fl.flags, &temp,
+                                (requires & BFE_VARIABLES) ? variables: NULL);
 
-                if (data[0]) {
-                    strarray_add_case(actionflags, data);
+                for (x = 0; x < strarray_size(temp); x++) {
+                    strarray_remove_all(actionflags, strarray_nth(temp, x));
                 }
-            }
 
-	    verify_flaglist(actionflags);
-            break;
-        }
-
-        case B_REMOVEFLAG:/*28*/
-            /* get the variable name */
-            ip = unwrap_string(bc, ip, &data, NULL);
-            /* RFC 5229, 3. Interpretation of Strings
-               Strings where no variable substitutions take place are referred to as
-               constant strings.  Future extensions may specify that passing non-
-               constant strings as arguments to its actions or tests is an error.
+                strarray_free(temp);
 
-               The name MUST be a constant string and conform
-               to the syntax of variable-name.
-               (this is done in the parser in sieve.y)
-            */
-
-            /* select or create the variable */
-            variable = varlist_select(variables, data);
-            if (variable) {
-                actionflags = variable->var;
-            } else {
-                /* variable doesn't exist, so we're done */
                 break;
             }
-
-            /* fall through */
-        case B_REMOVEFLAG_ORIG:/*11*/
-        {
-          int x, y;
-            int list_len=ntohl(bc[ip].len);
-            strarray_t temp = STRARRAY_INITIALIZER;
-
-            ip+=2; /* skip opcode, list_len, and list data len */
-
-            if (!actionflags) {
-                actionflags = variables->var;
             }
-	    verify_flaglist(actionflags);
-
-            for (x=0; x<list_len; x++) {
-                ip = unwrap_string(bc, ip, &data, NULL);
-
-                if (requires & BFE_VARIABLES) {
-                    data = parse_string(data, variables);
-                }
-
-                strarray_append(&temp, data);
-                verify_flaglist(&temp);
-
-                for (y = 0; y < temp.count; y++) {
-                    data = temp.data[y];
-                    strarray_remove_all_case(actionflags, data);
-                }
-
-		strarray_fini(&temp);
-	    } 
             break;
-        }
 
-        case B_NOTIFY:/*12*/
+        case B_ENOTIFY:
+        case B_NOTIFY:
         {
-            const char * id;
-            const char * method;
-            const char **options = NULL;
-            const char *priority = NULL;
-            const char * message;
-            int pri;
+            const char *message = cmd.u.n.message;
+            const char *priority = priority_to_string(cmd.u.n.priority);
 
-            /* method */
-            ip = unwrap_string(bc, ip, &method, NULL);
+            if (!priority) {
+                res = SIEVE_RUN_ERROR;
+                break;
+            }
 
             /* RFC 5435 (Sieve Extension: Notifications)
              * Section 8. Security Considerations
@@ -2252,268 +1989,181 @@ int sieve_eval_bc(sieve_execute_t *exe,
              * the "notify" action.
              */
 
-            /* id */
-            ip = unwrap_string(bc, ip, &id, NULL);
-
-	    /* draft-ietf-sieve-notify-12:
-	     * Changes since draft-ietf-sieve-notify-00
-	     * Removed the :id parameter to the notify action. */
-
-            /*options*/
-            options=bc_makeArray(bc, &ip);
-
-            /* priority */
-            pri=ntohl(bc[ip].value);
-            ip++;
-
-            switch (pri)
-            {
-            case B_LOW:
-                priority="low";
-                break;
-            case B_NORMAL:
-                priority="normal";
-                break;
-            case B_HIGH:
-                priority="high";
-                break;
-            case B_ANY:
-                priority="any";
-                break;
-            default:
-                res=SIEVE_RUN_ERROR;
-            }
-
-            /* message */
-            ip = unwrap_string(bc, ip, &message, NULL);
-
             if (requires & BFE_VARIABLES) {
                 message = parse_string(message, variables);
             }
 
-            res = do_notify(notify_list, id, method, options,
+            res = do_notify(notify_list, cmd.u.n.id, cmd.u.n.from, cmd.u.n.method,
+                            (const char **) strarray_safetakevf(cmd.u.n.options),
                             priority, message);
 
             break;
         }
-        case B_DENOTIFY:/*13*/
-        {
-         /*
-          * i really have no idea what the count matchtype should do here.
-          * the sanest thing would be to use 1.
-          * however that would require passing on the match type to do_notify.
-          *  -jsmith2
-          */
 
-            comparator_t *comp = NULL;
 
-            const char *pattern;
-            regex_t *reg;
+        case B_DENOTIFY:
+        {
+            /*
+             * i really have no idea what the count matchtype should do here.
+             * the sanest thing would be to use 1.
+             * however that would require passing on the match type to do_notify.
+             *  -jsmith2
+             */
 
-            const char *priority = NULL;
+            comparator_t *comp = NULL;
+            const char *pattern = cmd.u.d.pattern;
+            const char *priority = priority_to_string(cmd.u.n.priority);
             void *comprock = NULL;
+            strarray_t *match_vars = NULL;
+            int comparator = cmd.u.d.comp.match;
+            regex_t *reg = NULL;
 
-            int comparator;
-            int pri;
-
-            pri=ntohl(bc[ip].value);
-            ip++;
-
-            switch (pri)
-            {
-            case B_LOW:
-                priority="low";
-                break;
-            case B_NORMAL:
-                priority="normal";
-                break;
-            case B_HIGH:
-                priority="high";
-                break;
-            case B_ANY:
-                priority="any";
+            if (!priority) {
+                res = SIEVE_RUN_ERROR;
                 break;
-            default:
-                res=SIEVE_RUN_ERROR;
             }
 
-            if(res == SIEVE_RUN_ERROR)
-                break;
-
-            comparator =ntohl( bc[ip].value);
-            ip++;
-
-            if (comparator == B_ANY)
-            {
-                ip++;/* skip placeholder this has no comparator function */
-                comp=NULL;
+            if (comparator == B_ANY) {
+                comp = NULL;
             } else {
-                int x= ntohl(bc[ip].value);
-                ip++;
-
-                comp=lookup_comp(B_ASCIICASEMAP,comparator,
-                                 x, &comprock);
-                if (!comprock) {
-                    comprock = varlist_select(variables, VL_MATCH_VARS)->var;
-                }
+                comp = lookup_comp(i, B_ASCIICASEMAP, comparator,
+                                   cmd.u.d.comp.relation, &comprock);
+                match_vars = varlist_select(variables, VL_MATCH_VARS)->var;
             }
 
-            ip = unwrap_string(bc, ip, &pattern, NULL);
 
 	    /* draft-ietf-sieve-notify-12:
 	     * Changes since draft-ietf-sieve-notify-00
 	     * Removed denotify action. */
 	  
-            if (comparator == B_REGEX)
-            {
+            if (comparator == B_REGEX) {
                 char errmsg[1024]; /* Basically unused */
 
-                reg=bc_compile_regex(pattern,
-                                     REG_EXTENDED | REG_NOSUB | REG_ICASE,
-                                     errmsg, sizeof(errmsg));
+                reg = bc_compile_regex(pattern,
+                                       REG_EXTENDED | REG_NOSUB | REG_ICASE,
+                                       errmsg, sizeof(errmsg));
                 if (!reg) {
                     res = SIEVE_RUN_ERROR;
-                } else {
-                    res = do_denotify(notify_list, comp, reg,
-                                      comprock, priority);
-                    free(reg);
+                    break;
                 }
-            } else {
-                res = do_denotify(notify_list, comp, pattern,
-                                  comprock, priority);
             }
 
+            res = do_denotify(notify_list, comp, reg,
+                              match_vars, comprock, priority);
+
+            if (reg) {
+                regfree(reg);
+                free(reg);
+            }
             break;
         }
-        case B_VACATION_ORIG:/*14*/
-        case B_VACATION:/*21*/
+
+
+        case B_VACATION_ORIG:
+        case B_VACATION_SEC:
+        case B_VACATION_FCC:
+        case B_VACATION:
         {
             int respond;
+            sieve_fileinto_context_t fcc = {
+                cmd.u.v.fcc.folder,
+                cmd.u.v.fcc.specialuse,
+                NULL,
+                cmd.u.v.fcc.create,
+                /*mailboxid*/0
+            };
             char *fromaddr = NULL; /* relative to message we send */
-            char *toaddr = NULL; /* relative to message we send */
-            const char *handle = NULL;
-            const char *message = NULL;
-            int seconds, mime;
-            char buf[128];
-            char subject[1024];
-            int x;
-
-            x = ntohl(bc[ip].len);
+            char *toaddr = NULL;   /* relative to message we send */
+            const char *from = cmd.u.v.from;
+            const char *handle = cmd.u.v.handle;
+            const char *message = cmd.u.v.message;
+            char *subject = cmd.u.v.subject;
+            int seconds =
+                cmd.u.v.seconds * ((op == B_VACATION_ORIG) ? DAY2SEC : 1);
+            int mime = cmd.u.v.mime;
 
-            respond = shouldRespond(m, i, x, bc, ip+2,
+            respond = shouldRespond(m, i, cmd.u.v.addresses,
 				    &fromaddr, &toaddr, variables, requires);
 
-            ip = ntohl(bc[ip+1].value) / 4;
-            if (respond==SIEVE_OK)
-            {
-                ip = unwrap_string(bc, ip, &data, NULL);
+            if (respond != SIEVE_OK) {
+                if (cmd.u.v.fcc.flags) free(strarray_takevf(cmd.u.v.fcc.flags));
 
-                if (requires & BFE_VARIABLES) {
-                    data = parse_string(data, variables);
+                if (respond != SIEVE_DONE) {
+                    res = SIEVE_RUN_ERROR; /* something is bad */
                 }
+                break;
+            }
 
-                if (!data)
-                {
-                    /* we have to generate a subject */
-                    const char **s;
-                    strlcpy(buf, "subject", sizeof(buf));
-                    if (i->getheader(m, buf, &s) != SIEVE_OK ||
-                        s[0] == NULL) {
-                        strlcpy(subject, "Automated reply", sizeof(subject));
-                    } else {
-                        /* s[0] contains the original subject */
-                        const char *origsubj = s[0];
-                        snprintf(subject, sizeof(subject), "Auto: %s", origsubj);
-                    }
-                } else {
-                    /* user specified subject */
-                    strlcpy(subject, data, sizeof(subject));
-                }
+            if (requires & BFE_VARIABLES) {
+                from = parse_string(from, variables);
+                handle = parse_string(handle, variables);
+                message = parse_string(message, variables);
+                subject = xstrdupnull(parse_string(subject, variables));
 
-                ip = unwrap_string(bc, ip, &message, NULL);
+                fcc.mailbox = parse_string(fcc.mailbox, variables);
+                fcc.specialuse = parse_string(fcc.specialuse, variables);
+            }
 
-                if (requires & BFE_VARIABLES) {
-                    message = parse_string(message, variables);
-                }
+            unwrap_flaglist(cmd.u.v.fcc.flags, &fcc.imapflags,
+                            (requires & BFE_VARIABLES) ? variables : NULL);
+
+            if (!subject) {
+                /* we have to generate a subject */
+                struct buf buf = BUF_INITIALIZER;
+                const char **s;
 
-                seconds = ntohl(bc[ip].value);
-                if (op == B_VACATION_ORIG) {
-                    seconds *= DAY2SEC;
+                if (i->getheader(m, "subject", &s) != SIEVE_OK || s[0] == NULL) {
+                    buf_setcstr(&buf, "Automated reply");
+                } else {
+                    /* s[0] contains the original subject */
+                    const char *origsubj = s[0];
+                    char *decoded_subj =
+                        charset_parse_mimeheader(origsubj, 0 /*flags*/);
+                    buf_initm(&buf, decoded_subj, strlen(decoded_subj));
+                    buf_insertcstr(&buf, 0, "Auto: ");
                 }
-                mime = ntohl(bc[ip+1].value);
 
-                ip+=2;
+                subject = buf_release(&buf);
+            }
 
-                if (version >= 0x05) {
-                    ip = unwrap_string(bc, ip, &data, NULL);
+            if (from) {
+                /* user specified from address */
+                free(fromaddr);
+                fromaddr = xstrdup(from);
+            }
 
-                    if (requires & BFE_VARIABLES) {
-                        data = parse_string(data, variables);
-                    }
+            res = do_vacation(actions, toaddr, fromaddr, subject,
+                              message, seconds, mime, handle, &fcc);
 
-                    if (data) {
-                        /* user specified from address */
-                        free(fromaddr);
-                        fromaddr = xstrdup(data);
-                    }
+            if (res == SIEVE_RUN_ERROR)
+                *errmsg = "Vacation can not be used with Reject or Vacation";
 
-                    ip = unwrap_string(bc, ip, &data, NULL);
+            break;
+        }
 
-                    if (requires & BFE_VARIABLES) {
-                        data = parse_string(data, variables);
-                    }
 
-                    if (data) {
-                        /* user specified handle */
-                        handle = data;
-                    }
-                }
+        case B_NULL:
+            break;
 
-                res = do_vacation(actions, toaddr, fromaddr, xstrdup(subject),
-                                  message, seconds, mime, handle);
 
-                if (res == SIEVE_RUN_ERROR)
-                    *errmsg = "Vacation can not be used with Reject or Vacation";
-            } else if (respond == SIEVE_DONE) {
-                /* skip subject and message */
-
-                ip = unwrap_string(bc, ip, &data, NULL);
-                ip = unwrap_string(bc, ip, &data, NULL);
-
-                ip+=2;/*skip days and mime flag*/
-
-                if (version >= 0x05) {
-                    /* skip from and handle */
-                    ip = unwrap_string(bc, ip, &data, NULL);
-                    ip = unwrap_string(bc, ip, &data, NULL);
-                }
-            } else {
-                res = SIEVE_RUN_ERROR; /* something is bad */
-            }
-
-            break;
-        }
-        case B_NULL:/*15*/
+        case B_JUMP:
+            ip = cmd.u.jump;
             break;
 
-        case B_JUMP:/*16*/
-            ip= ntohl(bc[ip].jump);
-            break;
 
-        case B_INCLUDE:/*17*/
+        case B_INCLUDE:
         {
-            int isglobal = (ntohl(bc[ip].value) & 63) == B_GLOBAL;
-            int once = ntohl(bc[ip].value) & 64 ? 1 : 0;
-            int isoptional = ntohl(bc[ip].value) & 128 ? 1 : 0;
+            const char *script = cmd.u.inc.script;
+            int isglobal = cmd.u.inc.location == B_GLOBAL;
+            int once = cmd.u.inc.once;
+            int isoptional = cmd.u.inc.optional;
             char fpath[4096];
 
-            ip = unwrap_string(bc, ip+1, &data, NULL);
-
             if (requires & BFE_VARIABLES) {
-                data = parse_string(data, variables);
+                script = parse_string(script, variables);
             }
 
-            res = i->getinclude(sc, data, isglobal, fpath, sizeof(fpath));
+            res = i->getinclude(sc, script, isglobal, fpath, sizeof(fpath));
             if (res != SIEVE_OK) {
                 if (isoptional == 0)
                     *errmsg = "Include can not find script";
@@ -2535,25 +2185,26 @@ int sieve_eval_bc(sieve_execute_t *exe,
                 break;
             }
 
-            res = sieve_eval_bc(exe, 1, i,
-				sc, m, variables, actions,
-				notify_list, errmsg);
+            res = sieve_eval_bc(exe, 1, i, sc, m, variables, actions,
+				notify_list, duptrack_list, errmsg);
             break;
         }
 
-        case B_RETURN:/*18*/
+        case B_RETURN:
             if (is_incl)
                 goto done;
             else
-                res=1;
+                res = 1;
             break;
 
-        case B_SET:/*25*/
+
+        case B_SET:
         {
-            int modifiers = ntohl(bc[ip++].value);
+            const char *name = cmd.u.s.variable;
+            const char *value = cmd.u.s.value;
+            int modifiers = cmd.u.s.mod40 | cmd.u.s.mod30 |
+                cmd.u.s.mod20 | cmd.u.s.mod15 | cmd.u.s.mod10;
 
-            /* get the variable name */
-            ip = unwrap_string(bc, ip, &data, NULL);
 	    /* RFC 5229, 3. Interpretation of Strings
                Strings where no variable substitutions take place are referred to as
                constant strings.  Future extensions may specify that passing non-
@@ -2565,21 +2216,18 @@ int sieve_eval_bc(sieve_execute_t *exe,
             */
 
             /* select or create the variable */
-            variable = varlist_select(variables, data);
+            variable = varlist_select(variables, name);
             if (variable) {
                 actionflags = variable->var;
             } else {
                 actionflags = (variable = varlist_extend(variables))->var;
-                variable->name = xstrdup(data);
+                variable->name = xstrdup(name);
             }
 
-            /* get the variable value */
-            ip = unwrap_string(bc, ip, &data, NULL);
-
-            data = parse_string(data, variables);
+            value = parse_string(value, variables);
             strarray_fini(variable->var);
             strarray_appendm(variable->var,
-                             variables_modify_string(data, modifiers));
+                             variables_modify_string(value, modifiers));
 #if VERBOSE
 	    printf("\nB_SET:%s\n\n", strarray_nth(variable->var, -1));
 #endif
@@ -2587,13 +2235,139 @@ int sieve_eval_bc(sieve_execute_t *exe,
             break;
         }
 
+        case B_ADDHEADER:
+        {
+            const char *name = cmd.u.ah.name;
+            const char *value = cmd.u.ah.value;
+            const char *h;
+            int index = cmd.u.ah.index;
+
+            if (requires & BFE_VARIABLES) {
+                name = parse_string(name, variables);
+            }
+
+            /* validate header name */
+            for (h = name; *h; h++) {
+                /* field-name      =       1*ftext
+                   ftext           =       %d33-57 / %d59-126
+                   ; Any character except
+                   ;  controls, SP, and
+                   ;  ":". */
+                if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
+                    *errmsg = "Invalid header field name in Addheader";
+                    return SIEVE_RUN_ERROR;
+                }
+            }
+            
+            if (requires & BFE_VARIABLES) {
+                value = parse_string(value, variables);
+            }
+
+            res = do_addheader(actions, name, value, index);
+            break;
+        }
+
+        case B_DELETEHEADER:
+        {
+            const char *name = cmd.u.dh.name;
+            int index = cmd.u.dh.comp.index;
+            int match = cmd.u.dh.comp.match;
+            int relation = cmd.u.dh.comp.relation;
+            int comparator = cmd.u.dh.comp.collation;
+            comparator_t *comp = NULL;
+            void *comprock = NULL;
+            int npat = strarray_size(cmd.u.dh.values);
+            ptrarray_t *patterns = NULL;
+            int n, cflags = 0;
+
+            /* find comparator function */
+            comp = lookup_comp(i, comparator, match, relation, &comprock);
+            if (!comp) {
+                res = SIEVE_RUN_ERROR;
+                break;
+            }
+
+            if (requires & BFE_VARIABLES) {
+                name = parse_string(name, variables);
+            }
+
+            if (!strcasecmp("Received", name) ||
+                !strcasecmp("Auto-Submitted", name)) {
+                /* MUST NOT delete -- ignore */
+                break;
+            }
+
+            if (match == B_REGEX) {
+                /* set up options needed for compiling regex */
+                cflags = regcomp_flags(comparator, requires);
+            }
+
+            patterns = ptrarray_new();
+
+            for (n = 0; n < npat; n++) {
+                const char *val = strarray_nth(cmd.u.dh.values, n);
+
+                if (requires & BFE_VARIABLES) {
+                    val = parse_string(val, variables);
+                }
+
+                if (match == B_REGEX) {
+                    char errbuf[100]; /* Basically unused,
+                                         as regex is tested at compile */
+
+                    regex_t *reg = bc_compile_regex(val, cflags,
+                                                    errbuf, sizeof(errbuf));
+                    if (!reg) {
+                        /* Oops */
+                        while ((reg = ptrarray_pop(patterns))) {
+                            regfree(reg);
+                            free(reg);
+                        }
+                        ptrarray_free(patterns);
+                        res = SIEVE_NOMEM;
+                        break;
+                    }
+
+                    ptrarray_append(patterns, reg);
+                }
+                else {
+                    ptrarray_append(patterns, xstrdupnull(val));
+                }
+            }
+
+            free(strarray_takevf(cmd.u.dh.values));
+
+            if (!res) {
+                res = do_deleteheader(actions, name, patterns, index,
+                                      match, comp, comprock);
+            }
+            break;
+        }
+
+        case B_LOG:
+            if (i->log) {
+                const char *text = cmd.u.l.text;
+
+                if (requires & BFE_VARIABLES) {
+                    text = parse_string(text, variables);
+                }
+
+                i->log(sc, m, text);
+            }
+            break;
+
+        case B_ERROR:
+            res = SIEVE_RUN_ERROR;
+            *errmsg = cmd.u.str;
+
+            break;
+
         default:
             if(errmsg) *errmsg = "Invalid sieve bytecode";
             return SIEVE_FAIL;
         }
 
-        if (res) /* we've either encountered an error or a stop */
-            break;
+        if (res) break;  /* we've either encountered an error or a stop */
     }
 
   done:
diff -pruN 3.0.13-5/sieve/bc_generate.c 3.2.0-3/sieve/bc_generate.c
--- 3.0.13-5/sieve/bc_generate.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/bc_generate.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,7 +1,8 @@
 /* bc_generate.c -- sieve bytecode- almost flattened bytecode
  * Rob Siemborski
+ * Ken Murchison
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -64,13 +65,21 @@ static int bc_test_generate(int codep, b
 
 static int atleast(bytecode_info_t *arr, size_t len)
 {
-    if(arr->reallen < len) {
+    // This evil line of code exists because people aren't doing good
+    // accounting everywhere.  The "atleast" mechanism is disgusting
+    // and bad and wrong, but it's what we have.  So this means we don't
+    // overrun the end ever.  1024 is also super way more than needed,
+    // but memory is pretty cheap during the sieve script generation,
+    // so I just don't care.
+    len += 1024;
+
+    if (arr->reallen < len) {
         /* too small; double if that's big enough, otherwise increase to the
            requested size. */
         arr->reallen = (len > arr->reallen * 2 ? len : arr->reallen * 2);
-        arr->data = xrealloc(arr->data, arr->reallen*sizeof(bytecode_t));
-        if(!arr->data)
-        { /* out of memory? */
+        arr->data = xrealloc(arr->data, arr->reallen * sizeof(bytecode_t));
+        if (!arr->data) {
+            /* out of memory? */
             return 0;
         }
     }
@@ -92,33 +101,53 @@ static int atleast(bytecode_info_t *arr,
 static int bc_stringlist_generate(int codep, bytecode_info_t *retval,
                                   strarray_t *sa)
 {
-    int len_codep = codep;
-    int strcount = 0;
+    int strcount = sa ? sa->count : 0;
     int i;
 
-    codep++;
-
     /* Bounds check the string list length */
-    if(!atleast(retval,codep+1))
-        return -1;
+    if (!atleast(retval, codep+1)) return -1;
 
-    if (sa) {
-        for (i = 0 ; i < sa->count ; i++) {
-            char *s = sa->data[i];
+    retval->data[codep].type = BT_STRLISTLEN;
+    retval->data[codep++].u.listlen = strcount;
 
-            strcount++;
-            assert(s!=NULL);
+    for (i = 0 ; i < strcount ; i++) {
+        char *s = sa->data[i];
 
-            /* Bounds check for each string before we allocate it */
-            if(!atleast(retval,codep+2))
-                return -1;
+        assert(s != NULL);
 
-            retval->data[codep++].len = strlen(s);
-            retval->data[codep++].str = s;
-        }
+        /* Bounds check for each string before we allocate it */
+        if (!atleast(retval, codep+1)) return -1;
+
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = s;
+    }
+
+    return codep;
+}
+
+
+/* given a location and a value list, compile it into almost-flat form.
+ * <list len> <value><value> etc... */
+static int bc_vallist_generate(int codep, bytecode_info_t *retval,
+                               arrayu64_t *va)
+{
+    int count = va ? va->count : 0;
+    int i;
+
+    /* Bounds check the string list length */
+    if (!atleast(retval, codep+1)) return -1;
+
+    retval->data[codep].type = BT_VALLISTLEN;
+    retval->data[codep++].u.listlen = count;
+
+    for (i = 0 ; i < count ; i++) {
+        /* Bounds check for each string before we allocate it */
+        if (!atleast(retval, codep+1)) return -1;
+
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = arrayu64_nth(va, i);;
     }
 
-    retval->data[len_codep].listlen = strcount;
     return codep;
 }
 
@@ -137,151 +166,154 @@ static int bc_testlist_generate(int code
     codep++;
 
     /* Bounds check the test list length */
-    if(!atleast(retval,codep+1))
-        return -1;
+    if (!atleast(retval,codep+1)) return -1;
 
-    for(cur=tl; cur; cur=cur->next) {
+    for (cur=tl; cur; cur = cur->next) {
         int oldcodep = codep;
 
         /* Make room for tail marker */
-        if(!atleast(retval,codep+1))
-            return -1;
+        if (!atleast(retval, codep+1)) return -1;
 
         testcount++;
         codep = bc_test_generate(codep+1, retval, cur->t);
 
-        retval->data[oldcodep].jump = codep;
+        retval->data[oldcodep].type = BT_JUMP;
+        retval->data[oldcodep].u.jump = codep;
     }
 
-    retval->data[len_codep].listlen = testcount;
+    retval->data[len_codep].type = BT_STRLISTLEN;
+    retval->data[len_codep].u.listlen = testcount;
 
     return codep;
 }
+
 /* output a relation into almost-flat form at codep.
  * returns new codep on success, -1 on failure. */
 static int bc_relation_generate(int codep, bytecode_info_t *retval, int relat)
 {
     if (!atleast(retval, codep + 1)) return -1;
-    switch (relat)
-    {
+
+    retval->data[codep].type = BT_VALUE;
+    switch (relat) {
     case GT:
-        retval->data[codep++].value= B_GT;
+        retval->data[codep++].u.value = B_GT;
         break;
     case GE:
-        retval->data[codep++].value= B_GE;
+        retval->data[codep++].u.value = B_GE;
         break;
     case LT:
-        retval->data[codep++].value= B_LT;
+        retval->data[codep++].u.value = B_LT;
         break;
     case LE:
-        retval->data[codep++].value= B_LE;
+        retval->data[codep++].u.value = B_LE;
         break;
     case EQ:
-        retval->data[codep++].value= B_EQ;
+        retval->data[codep++].u.value = B_EQ;
         break;
     case NE:
-        retval->data[codep++].value= B_NE;
+        retval->data[codep++].u.value = B_NE;
         break;
     default:
         /* comparator has no relational field */
-        retval->data[codep++].value=  -1;
+        retval->data[codep++].u.value = -1;
         break;
     }
     return codep;
 }
+
 /* writes a single comparator into almost-flat form starting at codep.
  * will always write out 3 words
  * returns the next code location or -1 on error. */
 static int bc_comparator_generate(int codep, bytecode_info_t *retval,
-                                  int comptag, int relat,
-                                  const char *comparator)
+                                  int comptag, int relat, int collation)
 {
     assert(retval != NULL);
 
     /* comptag */
     if (!atleast(retval, codep + 1)) return -1;
 
+    retval->data[codep].type = BT_VALUE;
     switch (comptag) {
     case IS:
-        retval->data[codep++].value = B_IS;
+        retval->data[codep++].u.value = B_IS;
         break;
     case CONTAINS:
-        retval->data[codep++].value = B_CONTAINS;
+        retval->data[codep++].u.value = B_CONTAINS;
         break;
     case MATCHES:
-        retval->data[codep++].value = B_MATCHES;
+        retval->data[codep++].u.value = B_MATCHES;
         break;
 #ifdef ENABLE_REGEX
     case REGEX:
-        retval->data[codep++].value = B_REGEX;
+        retval->data[codep++].u.value = B_REGEX;
         break;
 #endif
+    case LIST:
+        retval->data[codep++].u.value = B_LIST;
+        break;
     case COUNT:
-        retval->data[codep++].value = B_COUNT;
+        retval->data[codep++].u.value = B_COUNT;
         break;
     case VALUE:
-        retval->data[codep++].value = B_VALUE;
+        retval->data[codep++].u.value = B_VALUE;
         break;
 
     default:
         return -1;
     }
 
-    /*relation*/
+    /* relation */
     codep = bc_relation_generate(codep, retval, relat);
 
-    if (!comparator) return codep;
+    if (!collation) return codep;
 
-    /* comparator (value specified with :comparator) */
+    /* collation (value specified with :comparator) */
     if (!atleast(retval, codep + 1)) return -1;
 
-    /* xxx perhaps extend comparator.h to have
-       lookup_comp return an index, and then
-       lookup_by_index return the actual comparator?
-
-       we can then eliminate the comptag above, too. */
-
-    if (!strcmp (comparator, "i;octet"))
-        retval->data[codep++].value = B_OCTET;
-    else if (!strcmp (comparator, "i;ascii-casemap"))
-        retval->data[codep++].value = B_ASCIICASEMAP;
-    else if (!strcmp (comparator, "i;ascii-numeric"))
-        retval->data[codep++].value = B_ASCIINUMERIC;
+    retval->data[codep].type = BT_VALUE;
+    switch (collation) {
+    case OCTET:
+        retval->data[codep++].u.value = B_OCTET;
+        break;
+    case ASCIICASEMAP:
+        retval->data[codep++].u.value = B_ASCIICASEMAP;
+        break;
+    case ASCIINUMERIC:
+        retval->data[codep++].u.value = B_ASCIINUMERIC;
+        break;
+
+    default:
+        return -1;
+    }
 
     return codep;
 }
 
 static int bc_zone_generate(int codep, bytecode_info_t *retval,
-                            int zonetag, const char *zone)
+                            int zonetag, int zone)
 {
-        unsigned hours;
-        unsigned minutes;
-        char sign;
+    assert(retval != NULL);
 
-        assert(retval != NULL);
+    /* zonetag */
+    if (!atleast(retval, codep + 1)) return -1;
 
-        /* zonetag */
+    retval->data[codep].type = BT_VALUE;
+    switch (zonetag) {
+    case ZONE:
+        /* time-zone offset in minutes */
+        retval->data[codep++].u.value = B_TIMEZONE;
         if (!atleast(retval, codep + 1)) return -1;
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = zone;
+        break;
+    case ORIGINALZONE:
+        retval->data[codep++].u.value = B_ORIGINALZONE;
+        break;
+    default:
+        return -1;
+    }
 
-        switch (zonetag) {
-        case ZONE:
-                retval->data[codep++].value = B_TIMEZONE;
-
-                /* time-zone offset in minutes */
-                if (!atleast(retval, codep + 1) ||
-                    sscanf(zone, "%c%02u%02u", &sign, &hours, &minutes) != 3)
-                    return -1;
-
-                retval->data[codep++].value = (sign == '-' ? -1 : 1) * (hours * 60) + minutes;
-                break;
-        case ORIGINALZONE:
-                retval->data[codep++].value = B_ORIGINALZONE;
-                break;
-        default:
-                return -1;
-        }
-
-        return codep;
+    return codep;
 }
 
 
@@ -291,47 +323,56 @@ static int bc_zone_generate(int codep, b
  * returns the next code location or -1 on error. */
 static int bc_test_generate(int codep, bytecode_info_t *retval, test_t *t)
 {
-    if(!retval) return -1;
+    if (!retval) return -1;
+
+    if (!atleast(retval, codep+1)) return -1;
+
+    retval->data[codep].type = BT_OPCODE;
     switch(t->type) {
     case STRUE: /* BC_TRUE */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_TRUE;
+        retval->data[codep++].u.op = BC_TRUE;
         break;
     case SFALSE:/* BC_FALSE */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_FALSE;
+        retval->data[codep++].u.op = BC_FALSE;
         break;
     case NOT: /* BC_NOT {subtest : test} */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_NOT;
+        retval->data[codep++].u.op = BC_NOT;
         codep = bc_test_generate(codep, retval, t->u.t);
         if (codep == -1) return -1;
         break;
     case SIZE: /* BC_SIZE (B_OVER | B_UNDER) {size : int} */
-        if(!atleast(retval,codep+3)) return -1;
-        retval->data[codep++].op = BC_SIZE;
-        retval->data[codep++].value = (t->u.sz.t == OVER
-                                       ? B_OVER : B_UNDER);
-        retval->data[codep++].value = t->u.sz.n;
-        break;
-    case EXISTS:/* BC_EXISTS { headers : string list } */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_EXISTS;
-        codep= bc_stringlist_generate(codep, retval, t->u.sl);
+        retval->data[codep++].u.op = BC_SIZE;
+        if(!atleast(retval,codep+2)) return -1;
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value =
+            (t->u.sz.t == OVER ? B_OVER : B_UNDER);
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = t->u.sz.n;
+        break;
+    case EXISTS:       /* BC_EXISTS       { headers    : string list } */
+    case IHAVE:        /* BC_IHAVE        { extensions : string list } */
+    case VALIDEXTLIST: /* BC_VALIDEXTLIST { listnames  : string list } */
+    case VALIDNOTIFYMETHOD: /* BC_VALIDNOTIFYMETHOD { uris  : string list } */
+        switch (t->type) {
+        case EXISTS:       retval->data[codep++].u.op = BC_EXISTS; break;
+        case IHAVE:        retval->data[codep++].u.op = BC_IHAVE; break;
+        case VALIDEXTLIST: retval->data[codep++].u.op = BC_VALIDEXTLIST; break;
+        case VALIDNOTIFYMETHOD:
+            retval->data[codep++].u.op = BC_VALIDNOTIFYMETHOD; break;
+        }
+        codep = bc_stringlist_generate(codep, retval, t->u.sl);
         break;
     case ANYOF:/* BC_ANYOF { tests : test list } */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_ANYOF;
+        retval->data[codep++].u.op = BC_ANYOF;
         codep=bc_testlist_generate(codep, retval, t->u.tl);
         if (codep == -1) return -1;
         break;
     case ALLOF: /* BC_ALLOF { tests : test list } */
-        if(!atleast(retval,codep+1)) return -1;
-        retval->data[codep++].op = BC_ALLOF;
+        retval->data[codep++].u.op = BC_ALLOF;
         codep= bc_testlist_generate(codep, retval, t->u.tl);
         if (codep == -1) return -1;
         break;
-    case HEADER:
+    case HEADERT:
     case HASFLAG:
     case STRINGT:
         /* BC_HEADER { i: index } { c: comparator }
@@ -341,38 +382,38 @@ static int bc_test_generate(int codep, b
          * { haystacks : string list } { patterns : string list }
          */
 
-        if(!atleast(retval,codep + 1)) return -1;
         switch (t->type) {
-        case HEADER:
-            retval->data[codep++].op = BC_HEADER;
+        case HEADERT:
+            retval->data[codep++].u.op = BC_HEADER;
             break;
         case HASFLAG:
-            retval->data[codep++].op = BC_HASFLAG;
+            retval->data[codep++].u.op = BC_HASFLAG;
             break;
         case STRINGT:
-            retval->data[codep++].op = BC_STRING;
+            retval->data[codep++].u.op = BC_STRING;
             break;
         }
 
-        if (t->type == HEADER) {
-        /* index */
-        if(!atleast(retval,codep + 1)) return -1;
-        retval->data[codep++].value = t->u.h.index;
+        if (t->type == HEADERT) {
+            /* index */
+            if (!atleast(retval, codep + 1)) return -1;
+            retval->data[codep].type = BT_VALUE;
+            retval->data[codep++].u.value = t->u.hhs.comp.index;
         }
 
         /* comparator */
         codep = bc_comparator_generate(codep, retval,
-                                       t->u.h.comptag,
-                                       t->u.h.relation,
-                                       t->u.h.comparator);
+                                       t->u.hhs.comp.match,
+                                       t->u.hhs.comp.relation,
+                                       t->u.hhs.comp.collation);
         if (codep == -1) return -1;
 
         /* haystacks */
-        codep = bc_stringlist_generate(codep, retval, t->u.h.sl);
+        codep = bc_stringlist_generate(codep, retval, t->u.hhs.sl);
         if (codep == -1) return -1;
 
         /* pattern */
-        codep = bc_stringlist_generate(codep, retval, t->u.h.pl);
+        codep = bc_stringlist_generate(codep, retval, t->u.hhs.pl);
         if (codep == -1) return -1;
         break;
     case ADDRESS:
@@ -385,94 +426,94 @@ static int bc_test_generate(int codep, b
            (B_ALL | B_LOCALPART | ...) { header : string list }
            { pattern : string list } */
 
-        if(!atleast(retval,codep+1)) return -1;
-
-        retval->data[codep++].op = (t->type == ADDRESS)
-            ? BC_ADDRESS : BC_ENVELOPE;
+        retval->data[codep++].u.op =
+            (t->type == ADDRESS) ? BC_ADDRESS : BC_ENVELOPE;
 
         /* index */
         if (t->type == ADDRESS) {
-                if(!atleast(retval,codep+1)) return -1;
-                retval->data[codep++].value = t->u.ae.index;
+            if (!atleast(retval, codep+1)) return -1;
+            retval->data[codep].type = BT_VALUE;
+            retval->data[codep++].u.value = t->u.ae.comp.index;
         }
 
-        codep = bc_comparator_generate(codep, retval,t->u.ae.comptag,
-                                       t->u.ae.relation,
-                                       t->u.ae.comparator);
+        codep = bc_comparator_generate(codep, retval,t->u.ae.comp.match,
+                                       t->u.ae.comp.relation,
+                                       t->u.ae.comp.collation);
         if (codep == -1) return -1;
 
-        if(!atleast(retval,codep+1)) return -1;
+        if (!atleast(retval, codep+1)) return -1;
 
         /*address part*/
+        retval->data[codep].type = BT_VALUE;
         switch(t->u.ae.addrpart) {
         case ALL:
-            retval->data[codep++].value = B_ALL;
+            retval->data[codep++].u.value = B_ALL;
             break;
         case LOCALPART:
-            retval->data[codep++].value = B_LOCALPART;
+            retval->data[codep++].u.value = B_LOCALPART;
             break;
         case DOMAIN:
-            retval->data[codep++].value = B_DOMAIN;
+            retval->data[codep++].u.value = B_DOMAIN;
             break;
         case USER:
-            retval->data[codep++].value = B_USER;
+            retval->data[codep++].u.value = B_USER;
             break;
         case DETAIL:
-            retval->data[codep++].value = B_DETAIL;
+            retval->data[codep++].u.value = B_DETAIL;
             break;
         default:
             return -1;
         }
 
-        /*headers*/
+        /* headers */
         codep = bc_stringlist_generate(codep, retval, t->u.ae.sl);
         if (codep == -1) return -1;
 
-        /*patterns*/
+        /* patterns */
         codep = bc_stringlist_generate(codep, retval, t->u.ae.pl);
         if (codep == -1) return -1;
 
         break;
     case BODY:
         /* BC_BODY {c : comparator} (B_RAW | B_TEXT | ...)
-           { content-types : stringlist }
            { offset : int }
+           { content-types : stringlist }
            { pattern : string list } */
 
-        if(!atleast(retval,codep+1)) return -1;
+        retval->data[codep++].u.op = BC_BODY;
 
-        retval->data[codep++].op = BC_BODY;
-
-        codep = bc_comparator_generate(codep, retval,t->u.b.comptag,
-                                       t->u.b.relation,
-                                       t->u.b.comparator);
+        codep = bc_comparator_generate(codep, retval,t->u.b.comp.match,
+                                       t->u.b.comp.relation,
+                                       t->u.b.comp.collation);
         if (codep == -1) return -1;
 
-        if(!atleast(retval,codep+2)) return -1;
+        if (!atleast(retval, codep+2)) return -1;
 
-        /*transform*/
+        /* transform */
+        retval->data[codep].type = BT_VALUE;
         switch(t->u.b.transform) {
         case RAW:
-            retval->data[codep++].value = B_RAW;
+            retval->data[codep++].u.value = B_RAW;
             break;
         case TEXT:
-            retval->data[codep++].value = B_TEXT;
+            retval->data[codep++].u.value = B_TEXT;
             break;
         case CONTENT:
-            retval->data[codep++].value = B_CONTENT;
+            retval->data[codep++].u.value = B_CONTENT;
             break;
         default:
             return -1;
         }
 
-        /*offset*/
-        retval->data[codep++].value = t->u.b.offset;
+        /* offset */
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = t->u.b.offset;
 
-        /*content-types*/
+        /* content-types */
         codep = bc_stringlist_generate(codep, retval, t->u.b.content_types);
         if (codep == -1) return -1;
 
-        /*patterns*/
+        /* patterns */
         codep = bc_stringlist_generate(codep, retval, t->u.b.pl);
         if (codep == -1) return -1;
 
@@ -480,20 +521,21 @@ static int bc_test_generate(int codep, b
     case DATE:
     case CURRENTDATE:
         /* BC_DATE { i: index } { time-zone: string} { c: comparator }
-         *         { header-name : string } { date-part: string }
+         *         { date-part: string } { header-name : string }
          *         { key-list : string list }
          *
          * BC_CURRENTDATE { time-zone: string} { c: comparator }
          *         { date-part: string } { key-list : string list }
         */
 
-        if(!atleast(retval,codep + 1)) return -1;
-        retval->data[codep++].op = (DATE == t->type) ? BC_DATE : BC_CURRENTDATE;
+        retval->data[codep++].u.op =
+            (DATE == t->type) ? BC_DATE : BC_CURRENTDATE;
 
         /* index */
         if (DATE == t->type) {
-                if(!atleast(retval,codep + 1)) return -1;
-                retval->data[codep++].value = t->u.dt.index;
+            if(!atleast(retval,codep + 1)) return -1;
+            retval->data[codep].type = BT_VALUE;
+            retval->data[codep++].u.value = t->u.dt.comp.index;
         }
 
         /* zone */
@@ -504,60 +546,61 @@ static int bc_test_generate(int codep, b
 
         /* comparator */
         codep = bc_comparator_generate(codep, retval,
-                                       t->u.dt.comptag,
-                                       t->u.dt.relation,
-                                       t->u.dt.comparator);
+                                       t->u.dt.comp.match,
+                                       t->u.dt.comp.relation,
+                                       t->u.dt.comp.collation);
         if (codep == -1) return -1;
 
         /* date-part */
-        if(!atleast(retval,codep + 1)) return -1;
+        if (!atleast(retval, codep + 1)) return -1;
+        retval->data[codep].type = BT_VALUE;
         switch (t->u.dt.date_part) {
-        case YEAR:
-                retval->data[codep++].value = B_YEAR;
+        case YEARP:
+                retval->data[codep++].u.value = B_YEAR;
                 break;
-        case MONTH:
-                retval->data[codep++].value = B_MONTH;
+        case MONTHP:
+                retval->data[codep++].u.value = B_MONTH;
                 break;
-        case DAY:
-                retval->data[codep++].value = B_DAY;
+        case DAYP:
+                retval->data[codep++].u.value = B_DAY;
                 break;
-        case DATE:
-                retval->data[codep++].value = B_DATE;
+        case DATEP:
+                retval->data[codep++].u.value = B_DATE;
                 break;
         case JULIAN:
-                retval->data[codep++].value = B_JULIAN;
+                retval->data[codep++].u.value = B_JULIAN;
                 break;
-        case HOUR:
-                retval->data[codep++].value = B_HOUR;
+        case HOURP:
+                retval->data[codep++].u.value = B_HOUR;
                 break;
-        case MINUTE:
-                retval->data[codep++].value = B_MINUTE;
+        case MINUTEP:
+                retval->data[codep++].u.value = B_MINUTE;
                 break;
-        case SECOND:
-                retval->data[codep++].value = B_SECOND;
+        case SECONDP:
+                retval->data[codep++].u.value = B_SECOND;
                 break;
-        case TIME:
-                retval->data[codep++].value = B_TIME;
+        case TIMEP:
+                retval->data[codep++].u.value = B_TIME;
                 break;
         case ISO8601:
-                retval->data[codep++].value = B_ISO8601;
+                retval->data[codep++].u.value = B_ISO8601;
                 break;
         case STD11:
-                retval->data[codep++].value = B_STD11;
+                retval->data[codep++].u.value = B_STD11;
                 break;
-        case ZONE:
-                retval->data[codep++].value = B_ZONE;
+        case ZONEP:
+                retval->data[codep++].u.value = B_ZONE;
                 break;
-        case WEEKDAY:
-                retval->data[codep++].value = B_WEEKDAY;
+        case WEEKDAYP:
+                retval->data[codep++].u.value = B_WEEKDAY;
                 break;
         }
 
         if (DATE == t->type) {
-                /* header-name */
-                if(!atleast(retval,codep + 2)) return -1;
-                retval->data[codep++].len = strlen(t->u.dt.header_name);
-                retval->data[codep++].str = t->u.dt.header_name;
+            /* header-name */
+            if (!atleast(retval, codep + 1)) return -1;
+            retval->data[codep].type = BT_STR;
+            retval->data[codep++].u.str = t->u.dt.header_name;
         }
 
         /* keywords */
@@ -567,74 +610,122 @@ static int bc_test_generate(int codep, b
         break;
 
     case MAILBOXEXISTS:
-        if (!atleast(retval, codep+1)) return -1;
-        retval->data[codep++].op = BC_MAILBOXEXISTS;
+        retval->data[codep++].u.op = BC_MAILBOXEXISTS;
         /* XXX ops ? */
-        codep = bc_stringlist_generate(codep,retval,t->u.mbx.keylist);
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
         if (codep == -1) return -1;
 
         break;
 
     case METADATA:
-        if (!atleast(retval, codep+1)) return -1;
-        retval->data[codep++].op = BC_METADATA;
+    case NOTIFYMETHODCAPABILITY:
+        retval->data[codep++].u.op =
+            t->type == METADATA ? BC_METADATA : BC_NOTIFYMETHODCAPABILITY;
 
         /* comparator */
         codep = bc_comparator_generate(codep, retval,
-                                       t->u.mbx.comptag,
-                                       t->u.mbx.relation,
-                                       t->u.mbx.comparator);
+                                       t->u.mm.comp.match,
+                                       t->u.mm.comp.relation,
+                                       t->u.mm.comp.collation);
         if (codep == -1) return -1;
 
-        if (!atleast(retval, codep+4)) return -1;
-        retval->data[codep++].len = t->u.mbx.extname ? (int)strlen(t->u.mbx.extname) : -1;
-        retval->data[codep++].str = t->u.mbx.extname;
-        retval->data[codep++].len = t->u.mbx.keyname ? (int)strlen(t->u.mbx.keyname) : -1;
-        retval->data[codep++].str = t->u.mbx.keyname;
+        if (!atleast(retval, codep+2)) return -1;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.mm.extname;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.mm.keyname;
 
-        codep = bc_stringlist_generate(codep,retval,t->u.mbx.keylist);
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
         if (codep == -1) return -1;
 
         break;
 
     case METADATAEXISTS:
-        if (!atleast(retval, codep+3)) return -1;
-        retval->data[codep++].op = BC_METADATAEXISTS;
-        retval->data[codep++].len = t->u.mbx.extname ? (int)strlen(t->u.mbx.extname) : -1;
-        retval->data[codep++].str = t->u.mbx.extname;
-        codep = bc_stringlist_generate(codep,retval,t->u.mbx.keylist);
+    case SPECIALUSEEXISTS:
+        retval->data[codep++].u.op =
+            t->type == METADATAEXISTS ? BC_METADATAEXISTS : BC_SPECIALUSEEXISTS;
+        if (!atleast(retval, codep+1)) return -1;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.mm.extname;
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
         if (codep == -1) return -1;
 
         break;
 
     case SERVERMETADATA:
-        if (!atleast(retval, codep+1)) return -1;
-        retval->data[codep++].op = BC_SERVERMETADATA;
+    case ENVIRONMENT:
+        retval->data[codep++].u.op =
+            t->type == ENVIRONMENT ? BC_ENVIRONMENT : BC_SERVERMETADATA;
 
         /* comparator */
         codep = bc_comparator_generate(codep, retval,
-                                       t->u.mbx.comptag,
-                                       t->u.mbx.relation,
-                                       t->u.mbx.comparator);
+                                       t->u.mm.comp.match,
+                                       t->u.mm.comp.relation,
+                                       t->u.mm.comp.collation);
         if (codep == -1) return -1;
 
-        if (!atleast(retval, codep+2)) return -1;
-        retval->data[codep++].len = t->u.mbx.keyname ? (int)strlen(t->u.mbx.keyname) : -1;
-        retval->data[codep++].str = t->u.mbx.keyname;
+        if (!atleast(retval, codep+1)) return -1;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.mm.keyname;
 
-        codep = bc_stringlist_generate(codep,retval,t->u.mbx.keylist);
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
         if (codep == -1) return -1;
 
         break;
 
     case SERVERMETADATAEXISTS:
+        retval->data[codep++].u.op = BC_SERVERMETADATAEXISTS;
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
+        if (codep == -1) return -1;
+
+        break;
+
+    case DUPLICATE:
+        /* BC_DUPLICATE { idtype: HEADER | UNIQUEID }
+         *              { hdrname/uniqueid : string }
+         *              { handle: string} { seconds: int } { last: int }
+         */
+        retval->data[codep++].u.op = BC_DUPLICATE;
+
+        if (!atleast(retval, codep+1)) return -1;
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value =
+            (t->u.dup.idtype == UNIQUEID) ? B_UNIQUEID : B_HEADER;
+
+        if (!atleast(retval, codep+1)) return -1;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.dup.idval;
+
         if (!atleast(retval, codep+1)) return -1;
-        retval->data[codep++].op = BC_SERVERMETADATAEXISTS;
-        codep = bc_stringlist_generate(codep,retval,t->u.mbx.keylist);
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.dup.handle;
+
+        if (!atleast(retval, codep+2)) return -1;
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = t->u.dup.seconds;
+        retval->data[codep].type = BT_VALUE;
+        retval->data[codep++].u.value = t->u.dup.last;
+
         if (codep == -1) return -1;
 
         break;
 
+    case MAILBOXIDEXISTS:
+        retval->data[codep++].u.op = BC_MAILBOXIDEXISTS;
+        /* XXX ops ? */
+        codep = bc_stringlist_generate(codep,retval,t->u.mm.keylist);
+        if (codep == -1) return -1;
+
+        break;
+
+    case JMAPQUERY:
+        retval->data[codep++].u.op = BC_JMAPQUERY;
+        if (!atleast(retval, codep+1)) return -1;
+        retval->data[codep].type = BT_STR;
+        retval->data[codep++].u.str = t->u.jquery;
+
+        break;
+
     default:
         return -1;
 
@@ -652,75 +743,70 @@ static int bc_action_generate(int codep,
 {
     int jumploc;
 
-    if (!retval)
-        return -1;
+    if (!retval) return -1;
 
     if (c == NULL) {
         if (!atleast(retval, codep+1)) return -1;
-        retval->data[codep++].op = B_NULL;
+        retval->data[codep].type = BT_OPCODE;
+        retval->data[codep++].u.op = B_NULL;
     }
     else {
         do {
+            if (!atleast(retval, codep+1)) return -1;
+            retval->data[codep].type = BT_OPCODE;
+
             switch(c->type) {
             case STOP:
                 /* STOP (no arguments) */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_STOP;
+                retval->data[codep++].u.op = B_STOP;
                 break;
 
             case DISCARD:
                 /* DISCARD (no arguments) */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_DISCARD;
+                retval->data[codep++].u.op = B_DISCARD;
                 break;
 
             case KEEP:
                 /* KEEP
                    STRINGLIST flags
-                   VALUE copy
                 */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_KEEP;
+                retval->data[codep++].u.op = B_KEEP;
                 codep = bc_stringlist_generate(codep,retval,c->u.k.flags);
                 if (codep == -1) return -1;
-                if(!atleast(retval,codep+1)) return -1;
-                retval->data[codep++].value = c->u.k.copy;
                 break;
 
             case MARK:
                 /* MARK (no arguments) */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_MARK;
+                retval->data[codep++].u.op = B_MARK;
                 break;
 
             case UNMARK:
                 /* UNMARK (no arguments) */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_UNMARK;
+                retval->data[codep++].u.op = B_UNMARK;
                 break;
 
             case RETURN:
                 /* RETURN (no arguments) */
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_RETURN;
+                retval->data[codep++].u.op = B_RETURN;
                 break;
 
             case DENOTIFY:
                 /* DENOTIFY  */
-                if (!atleast(retval, codep+6)) return -1;
-                retval->data[codep++].op = B_DENOTIFY;
+                retval->data[codep++].u.op = B_DENOTIFY;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_VALUE;
                 switch(c->u.d.priority) {
                 case LOW:
-                    retval->data[codep++].value = B_LOW;
+                    retval->data[codep++].u.value = B_LOW;
                     break;
                 case NORMAL:
-                    retval->data[codep++].value = B_NORMAL;
+                    retval->data[codep++].u.value = B_NORMAL;
                     break;
                 case HIGH:
-                    retval->data[codep++].value = B_HIGH;
+                    retval->data[codep++].u.value = B_HIGH;
                     break;
                 case ANY:
-                    retval->data[codep++].value = B_ANY;
+                    retval->data[codep++].u.value = B_ANY;
                     break;
                 default:
                     return -1;
@@ -728,126 +814,170 @@ static int bc_action_generate(int codep,
 
                 /* comparator */
                 codep = bc_comparator_generate(codep, retval,
-                                               c->u.d.comptag,
-                                               c->u.d.relation,
-                                               NULL);
+                                               c->u.d.comp.match,
+                                               c->u.d.comp.relation,
+                                               0);
                 if (codep == -1) return -1;
 
-                if(c->u.d.pattern) {
-                    retval->data[codep++].len = strlen(c->u.d.pattern);
-                    retval->data[codep++].str = c->u.d.pattern;
-                }
-                else {
-                    retval->data[codep++].len = -1;
-                    retval->data[codep++].str = NULL;
-                }
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.d.pattern;
 
                 break;
 
             case REJCT:
-                /* REJECT (STRING: len + dataptr) */
-                if (!atleast(retval, codep+3)) return -1;
-                retval->data[codep++].op = B_REJECT;
-                retval->data[codep++].len = strlen(c->u.reject);
-                retval->data[codep++].str = c->u.reject;
+            case EREJECT:
+            case ERROR:
+                /* (REJECT | EREJECT | ERROR) (STRING: len + dataptr) */
+                switch (c->type) {
+                case REJCT:   retval->data[codep++].u.op = B_REJECT; break;
+                case EREJECT: retval->data[codep++].u.op = B_EREJECT; break;
+                case ERROR:   retval->data[codep++].u.op = B_ERROR; break;
+                }
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.str;
                 break;
 
             case FILEINTO:
                 /* FILEINTO
+                   STRING mailboxid
+                   STRING specialuse
                    VALUE create
                    STRINGLIST flags
                    VALUE copy
                    STRING folder
                 */
+                retval->data[codep++].u.op = B_FILEINTO;
                 if (!atleast(retval, codep+2)) return -1;
-                retval->data[codep++].op = B_FILEINTO;
-                retval->data[codep++].value = c->u.f.create;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.f.mailboxid;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.f.specialuse;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.f.create;
                 codep = bc_stringlist_generate(codep, retval, c->u.f.flags);
-                if(codep == -1) return -1;
-                if (!atleast(retval, codep+3)) return -1;
-                retval->data[codep++].value = c->u.f.copy;
-                retval->data[codep++].len = strlen(c->u.f.folder);
-                retval->data[codep++].str = c->u.f.folder;
+                if (codep == -1) return -1;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.f.copy;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.f.folder;
                 break;
 
             case REDIRECT:
                 /* REDIRECT
+                   STRING bytime
+                   STRING bymode
+                   VALUE bytrace
+                   STRING dsn_notify
+                   STRING dsn_ret
+                   VALUE list
                    VALUE copy
                    STRING address
                 */
-                if (!atleast(retval, codep+4)) return -1;
-                retval->data[codep++].op = B_REDIRECT;
-                retval->data[codep++].value = c->u.r.copy;
-                retval->data[codep++].len = strlen(c->u.r.address);
-                retval->data[codep++].str = c->u.r.address;
+                retval->data[codep++].u.op = B_REDIRECT;
+                if (!atleast(retval, codep+8)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.r.bytime;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.r.bymode;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.r.bytrace;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.r.dsn_notify;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.r.dsn_ret;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.r.list;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.r.copy;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.r.address;
                 break;
 
             case ADDFLAG:
             case SETFLAG:
             case REMOVEFLAG:
                 /* (ADDFLAG | SETFLAG | REMOVEFLAG) string stringlist */
-                if (!atleast(retval, codep+3)) return -1;
                 switch(c->type) {
                 case ADDFLAG:
-                    retval->data[codep++].op = B_ADDFLAG;
+                    retval->data[codep++].u.op = B_ADDFLAG;
                     break;
                 case SETFLAG:
-                    retval->data[codep++].op = B_SETFLAG;
+                    retval->data[codep++].u.op = B_SETFLAG;
                     break;
                 case REMOVEFLAG:
-                    retval->data[codep++].op = B_REMOVEFLAG;
+                    retval->data[codep++].u.op = B_REMOVEFLAG;
                     break;
                 }
-                retval->data[codep++].len = strlen(c->u.fl.variable);
-                retval->data[codep++].str = c->u.fl.variable;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.fl.variable;
                 codep = bc_stringlist_generate(codep,retval,c->u.fl.flags);
                 if (codep == -1) return -1;
                 break;
 
             case NOTIFY:
-                /* NOTIFY
+            case ENOTIFY:
+            {
+                /* (E)NOTIFY
                    (STRING: len + dataptr)
                    (STRING: len + dataptr)
                    stringlist
+                   (VALUE)
                    (STRING: len + dataptr)
-                   (STRING: len + dataptr)
-                   method/id /options list/priority/message
+                   method/(from|id) /options list/priority/message
                 */
+                int op;
+                char *str;
 
-                if (!atleast(retval, codep+5)) return -1;
-                retval->data[codep++].op = B_NOTIFY;
+                if (c->type == ENOTIFY) {
+                    op = B_ENOTIFY;
+                    str = c->u.n.from;
+                }
+                else {
+                    op = B_NOTIFY;
+                    str = c->u.n.id;
+                }
 
-                retval->data[codep++].len = strlen(c->u.n.method);
-                retval->data[codep++].str = c->u.n.method;
+                retval->data[codep++].u.op = op;
 
-                retval->data[codep++].len = c->u.n.id ? (int)strlen(c->u.n.id) : -1;
-                retval->data[codep++].str = c->u.n.id;
+                if (!atleast(retval, codep+2)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.n.method;
+
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = str;
 
                 codep = bc_stringlist_generate(codep,retval,c->u.n.options);
                 if (codep == -1) return -1;
 
-                if (!atleast(retval, codep+3)) return -1;
+                if (!atleast(retval, codep+2)) return -1;
 
+                retval->data[codep].type = BT_VALUE;
                 switch(c->u.n.priority) {
                 case LOW:
-                    retval->data[codep++].value = B_LOW;
+                    retval->data[codep++].u.value = B_LOW;
                     break;
                 case NORMAL:
-                    retval->data[codep++].value = B_NORMAL;
+                    retval->data[codep++].u.value = B_NORMAL;
                     break;
                 case HIGH:
-                    retval->data[codep++].value = B_HIGH;
+                    retval->data[codep++].u.value = B_HIGH;
                     break;
                 case ANY:
-                    retval->data[codep++].value = B_ANY;
+                    retval->data[codep++].u.value = B_ANY;
                     break;
                 default:
                     return -1;
                 }
 
-                retval->data[codep++].len = strlen(c->u.n.message);
-                retval->data[codep++].str = c->u.n.message;
-                break;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.n.message;
+            }
+            break;
 
             case VACATION:
                 /* VACATION
@@ -858,56 +988,54 @@ static int bc_action_generate(int codep,
                    VALUE mime
                    STRING from (if len is -1, then from was NULL)
                    STRING handle (again, len == -1 means handle was NULL)
+                   STRING fcc (again, len == -1 means fcc was NULL)
+                      VALUE create (if and only if fcc != NULL)
+                      STRINGLIST flags (if and only if fcc != NULL)
+                      STRING specialuse (if and only if fcc != NULL)
                 */
 
-                if (!atleast(retval, codep+1)) return -1;
-                retval->data[codep++].op = B_VACATION;
+                retval->data[codep++].u.op = B_VACATION;
 
                 codep = bc_stringlist_generate(codep,retval,c->u.v.addresses);
                 if (codep == -1) return -1;
 
-                if (!atleast(retval, codep+2)) return -1;
-                if (c->u.v.subject) {
-                    retval->data[codep++].len = strlen(c->u.v.subject);
-                    retval->data[codep++].str = c->u.v.subject;
-                }
-                else {
-                    retval->data[codep++].len = -1;
-                    retval->data[codep++].str = NULL;
-                }
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.v.subject;
 
-                if (!atleast(retval, codep+2)) return -1;
-                if (c->u.v.message) {
-                    retval->data[codep++].len = strlen(c->u.v.message);
-                    retval->data[codep++].str = c->u.v.message;
-                }
-                else {
-                    retval->data[codep++].len = -1;
-                    retval->data[codep++].str = NULL;
-                }
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.v.message;
 
                 if (!atleast(retval, codep+2)) return -1;
-                retval->data[codep++].value = c->u.v.seconds;
-                retval->data[codep++].value = c->u.v.mime;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.v.seconds;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.v.mime;
 
-                if (!atleast(retval, codep+2)) return -1;
-                if (c->u.v.from) {
-                    retval->data[codep++].len = strlen(c->u.v.from);
-                    retval->data[codep++].str = c->u.v.from;
-                }
-                else {
-                    retval->data[codep++].len = -1;
-                    retval->data[codep++].str = NULL;
-                }
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.v.from;
 
-                if (!atleast(retval, codep+2)) return -1;
-                if (c->u.v.handle) {
-                    retval->data[codep++].len = strlen(c->u.v.handle);
-                    retval->data[codep++].str = c->u.v.handle;
-                }
-                else {
-                    retval->data[codep++].len = -1;
-                    retval->data[codep++].str = NULL;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.v.handle;
+
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.v.fcc.folder;
+                if (c->u.v.fcc.folder) {
+                    if (!atleast(retval, codep+1)) return -1;
+                    retval->data[codep].type = BT_VALUE;
+                    retval->data[codep++].u.value = c->u.v.fcc.create;
+
+                    codep = bc_stringlist_generate(codep, retval,
+                                                   c->u.v.fcc.flags);
+                    if (codep == -1) return -1;
+
+                    if (!atleast(retval, codep+1)) return -1;
+                    retval->data[codep].type = BT_STR;
+                    retval->data[codep++].u.str = c->u.v.fcc.specialuse;
                 }
 
                 if (codep == -1) return -1;
@@ -917,69 +1045,159 @@ static int bc_action_generate(int codep,
                 /* INCLUDE
                    VALUE location + (once << 6) + (optional << 7)
                    STRING filename */
-                if (!atleast(retval, codep+4)) return -1;
-                retval->data[codep++].op = B_INCLUDE;
+                retval->data[codep++].u.op = B_INCLUDE;
 
+                if (!atleast(retval, codep+3)) return -1;
+                retval->data[codep].type = BT_VALUE;
                 switch(c->u.inc.location) {
                 case PERSONAL:
-                    retval->data[codep].value = B_PERSONAL;
+                    retval->data[codep].u.value = B_PERSONAL;
                     break;
                 case GLOBAL:
-                    retval->data[codep].value = B_GLOBAL;
+                    retval->data[codep].u.value = B_GLOBAL;
                     break;
                 default:
                     return -1;
                 }
 
-                retval->data[codep++].value |= (c->u.inc.once << 6)
-                                            | (c->u.inc.optional << 7);
-                retval->data[codep++].len = strlen(c->u.inc.script);
-                retval->data[codep++].str = c->u.inc.script;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value |=
+                    (c->u.inc.once << 6) | (c->u.inc.optional << 7);
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.inc.script;
                 break;
 
             case SET:
-            {
                 /* SET
                    BITFIELD modifiers
                    STRING variable
                    STRING value
                 */
-                if (!atleast(retval, codep+6)) return -1;
-                retval->data[codep++].op = B_SET;
-                retval->data[codep].value = 0;
+                retval->data[codep++].u.op = B_SET;
+                if (!atleast(retval, codep+3)) return -1;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep].u.value = 0;
                 switch(c->u.s.mod40) {
                 case LOWER:
-                    retval->data[codep].value |= BFV_LOWER;
+                    retval->data[codep].u.value |= BFV_LOWER;
                     break;
                 case UPPER:
-                    retval->data[codep].value |= BFV_UPPER;
+                    retval->data[codep].u.value |= BFV_UPPER;
                     break;
                 }
                 switch(c->u.s.mod30) {
                 case LOWERFIRST:
-                    retval->data[codep].value |= BFV_LOWERFIRST;
+                    retval->data[codep].u.value |= BFV_LOWERFIRST;
                     break;
                 case UPPERFIRST:
-                    retval->data[codep].value |= BFV_UPPERFIRST;
+                    retval->data[codep].u.value |= BFV_UPPERFIRST;
                     break;
                 }
                 switch(c->u.s.mod20) {
                 case QUOTEWILDCARD:
-                    retval->data[codep].value |= BFV_QUOTEWILDCARD;
+                    retval->data[codep].u.value |= BFV_QUOTEWILDCARD;
+                    break;
+                case QUOTEREGEX:
+                    retval->data[codep].u.value |= BFV_QUOTEREGEX;
+                    break;
+                }
+                switch(c->u.s.mod15) {
+                case ENCODEURL:
+                    retval->data[codep].u.value |= BFV_ENCODEURL;
                     break;
                 }
                 switch(c->u.s.mod10) {
                 case LENGTH:
-                    retval->data[codep].value |= BFV_LENGTH;
+                    retval->data[codep].u.value |= BFV_LENGTH;
                     break;
                 }
                 codep++;
-                retval->data[codep++].len = strlen(c->u.s.variable);
-                retval->data[codep++].str = c->u.s.variable;
-                retval->data[codep++].len = strlen(c->u.s.value);
-                retval->data[codep++].str = c->u.s.value;
-            }
-            break;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.s.variable;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.s.value;
+                break;
+
+            case ADDHEADER:
+                /* ADDHEADER
+                   NUMBER index
+                   STRING name
+                   STRING value
+                */
+                retval->data[codep++].u.op = B_ADDHEADER;
+                if (!atleast(retval, codep+3)) return -1;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.ah.index;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.ah.name;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.ah.value;
+                break;
+
+            case DELETEHEADER:
+                /* DELETEHEADER
+                   NUMBER index
+                   COMPARATOR
+                   STRING name
+                   STRINGLIST value-patterns
+                */
+                retval->data[codep++].u.op = B_DELETEHEADER;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_VALUE;
+                retval->data[codep++].u.value = c->u.dh.comp.index;
+
+                codep = bc_comparator_generate(codep, retval,
+                                               c->u.dh.comp.match,
+                                               c->u.dh.comp.relation,
+                                               c->u.dh.comp.collation);
+                if (codep == -1) return -1;
+
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.dh.name;
+
+                codep = bc_stringlist_generate(codep, retval, c->u.dh.values);
+                if (codep == -1) return -1;
+                break;
+
+            case LOG:
+                /* LOG
+                   STRING text
+                */
+                retval->data[codep++].u.op = B_LOG;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.l.text;
+                break;
+
+            case SNOOZE:
+                /* SNOOZE
+                   STRING mailbox / mailboxid
+                   STRINGLIST addflags
+                   STRINGLIST removeflags
+                   VALUE weekdays + (is_mboxid << 7)
+                   VALUELIST times
+                */
+                retval->data[codep++].u.op = B_SNOOZE;
+                if (!atleast(retval, codep+1)) return -1;
+                retval->data[codep].type = BT_STR;
+                retval->data[codep++].u.str = c->u.sn.mailbox;
+                codep = bc_stringlist_generate(codep, retval, c->u.sn.addflags);
+                if (codep == -1) return -1;
+                codep = bc_stringlist_generate(codep, retval, c->u.sn.removeflags);
+                if (codep == -1) return -1;
+                retval->data[codep].type = BT_VALUE;
+                if (c->u.sn.is_mboxid) {
+                    retval->data[codep++].u.value =
+                        c->u.sn.days | SNOOZE_IS_ID_MASK;
+                }
+                else {
+                    retval->data[codep++].u.value =
+                        c->u.sn.days & ~SNOOZE_IS_ID_MASK;
+                }
+                codep = bc_vallist_generate(codep, retval, c->u.sn.times);
+                if (codep == -1) return -1;
+                break;
 
             case IF:
             {
@@ -987,24 +1205,25 @@ static int bc_action_generate(int codep,
                 /* IF
                    (int: begin then block)
                    (int: end then block/begin else block)
-                   (int:end else block) (-1 if no else block)
+                   (int: end else block) (-1 if no else block)
                    (test)
                    (then block)
                    (else block)(optional)
                 */
 
-                /* Allocate operator + jump table offsets */
-                if (!atleast(retval, codep+4)) return -1;
+                retval->data[codep++].u.op = B_IF;
 
-                jumploc = codep+4;
-                retval->data[codep++].op = B_IF;
+                /* Allocate jump table offsets */
+                if (!atleast(retval, codep+3)) return -1;
+                jumploc = codep+3;
 
                 /* beginning of then  code */
                 jumpVal = bc_test_generate(jumploc,retval,c->u.i.t);
                 if (jumpVal == -1)
                     return -1;
                 else {
-                    retval->data[codep].jump = jumpVal;
+                    retval->data[codep].type = BT_JUMP;
+                    retval->data[codep].u.jump = jumpVal;
                     codep++;
                 }
 
@@ -1015,29 +1234,32 @@ static int bc_action_generate(int codep,
                 jumpVal = bc_action_generate(jumpVal,retval, c->u.i.do_then);
                 if (jumpVal == -1)
                     return -1;
-                else
-                    retval->data[codep].jump = jumpVal;
+                else {
+                    retval->data[codep].type = BT_JUMP;
+                    retval->data[codep].u.jump = jumpVal;
+                }
 
                 codep++;
                 /* write else code if its there*/
                 if (c->u.i.do_else) {
                     jumpVal = bc_action_generate(jumpVal,retval, c->u.i.do_else);
-                    if(jumpVal == -1)
-                        return -1;
-                    else
-                        retval->data[codep].jump = jumpVal;
+                    if (jumpVal == -1) return -1;
+                    else {
+                        retval->data[codep].type = BT_JUMP;
+                        retval->data[codep].u.jump = jumpVal;
+                    }
 
                     /* Update code pointer to end of else code */
-                    codep = retval->data[codep].jump;
+                    codep = retval->data[codep].u.jump;
                 } else {
                     /*there is no else block, so its -1*/
-                    retval->data[codep].jump = -1;
+                    retval->data[codep].u.jump = -1;
                     /* Update code pointer to end of then code */
-                    codep = retval->data[codep-1].jump;
+                    codep = retval->data[codep-1].u.jump;
                 }
 
             }
-                break;
+            break;
 
             default:
                 /* no such action known */
@@ -1065,25 +1287,26 @@ EXPORTED int sieve_generate_bytecode(byt
     int requires = 0;
     int codep = 0;
 
-    if(!retval) return -1;
-    if(!s) return -1;
+    if (!retval) return -1;
+    if (!s) return -1;
     c = s->cmds;
     /* if c is NULL, it is handled in bc_action_generate and a script
        with only BC_NULL is returned
     */
 
     /* populate requires field */
-    if (s->support.variables) {
+    if (s->support & SIEVE_CAPA_VARIABLES) {
 	requires |= BFE_VARIABLES;
     }
     
     *retval = xmalloc(sizeof(bytecode_info_t));
-    if(!(*retval)) return -1;
+    if (!(*retval)) return -1;
 
     memset(*retval, 0, sizeof(bytecode_info_t));
 
     if (!atleast(*retval, codep+1)) return -1;
-    (*retval)->data[codep++].value = requires;
+    (*retval)->data[codep].type = BT_VALUE;
+    (*retval)->data[codep++].u.value = requires;
 
     return bc_action_generate(codep, *retval, c);
 }
@@ -1091,8 +1314,8 @@ EXPORTED int sieve_generate_bytecode(byt
 
 EXPORTED void sieve_free_bytecode(bytecode_info_t **p)
 {
-    if(!p || !*p) return;
-    if((*p)->data) free((*p)->data);
+    if (!p || !*p) return;
+    if ((*p)->data) free((*p)->data);
     free(*p);
     *p = NULL;
 }
diff -pruN 3.0.13-5/sieve/bc_parse.c 3.2.0-3/sieve/bc_parse.c
--- 3.0.13-5/sieve/bc_parse.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/sieve/bc_parse.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,648 @@
+/* bc_parse.c -- sieve bytecode - pass 1 of the decompiler
+ * Ken Murchison
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <netinet/in.h>
+#include <string.h>
+
+#include "bc_parse.h"
+#include "strarray.h"
+#include "times.h"
+
+
+/* Given a bytecode_input_t at the beginning of a file,
+ * return the version, the required extensions,
+ * and the bytecode index of the first item */
+EXPORTED int bc_header_parse(bytecode_input_t *bc, int *version, int *requires)
+{
+    int pos = 0;
+
+    *version = 0;
+    if (requires) *requires = 0;
+
+    if (memcmp(bc, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN)) return -1;
+
+    pos = BYTECODE_MAGIC_LEN / sizeof(bytecode_input_t);
+
+    *version = ntohl(bc[pos++].value);
+    if (*version >= 0x11) {
+        int req = ntohl(bc[pos++].value);
+
+        if (requires) *requires = req;
+    }
+
+    return pos;
+}
+
+/* Given a bytecode_input_t at the beginning of a string (the len block),
+ * return the string, the length, and the bytecode index of the NEXT item */
+static int bc_string_parse(bytecode_input_t *bc, int pos, char **str)
+{
+    int len = ntohl(bc[pos++].value);
+
+    if (len == -1) {
+         /* -1 length indicates NULL */
+         *str = NULL;
+    } else {
+        /* This cast is ugly, but necessary */
+        *str = (char *) &bc[pos].str;
+
+        /* Compute the next index */
+        pos += ((ROUNDUP(len+1)) / sizeof(bytecode_input_t));
+    }
+
+    return pos;
+}
+
+/* Given a bytecode_input_t at the beginning of a stringlist (the len block),
+ * return the stringlist, and the bytecode index of the NEXT item */
+static int bc_stringlist_parse(bytecode_input_t *bc, int pos,
+                                  strarray_t **strlist)
+{
+    int len = ntohl(bc[pos++].listlen);
+
+    pos++; /* Skip Total Byte Length */
+
+    *strlist = strarray_new();
+
+    while (len--) {
+        char *str;
+
+        pos = bc_string_parse(bc, pos, &str);
+        strarray_appendm(*strlist, str);
+    }
+
+    return pos;
+}
+
+/* Given a bytecode_input_t at the beginning of a valuelist (the len block),
+ * return the vallist, and the bytecode index of the NEXT item */
+static int bc_vallist_parse(bytecode_input_t *bc, int pos,
+                            arrayu64_t **vallist)
+{
+    int len = ntohl(bc[pos++].listlen);
+
+    pos++; /* Skip Total Byte Length */
+
+    *vallist = arrayu64_new();
+
+    while (len--) {
+        arrayu64_append(*vallist, ntohl(bc[pos++].value));
+    }
+
+    return pos;
+}
+
+static int bc_comparator_parse(bytecode_input_t *bc, int pos, comp_t *comp)
+{
+    comp->match = ntohl(bc[pos++].value);
+    comp->relation = ntohl(bc[pos++].value);
+    comp->collation = ntohl(bc[pos++].value);
+
+    return pos;
+}
+
+EXPORTED int bc_action_parse(bytecode_input_t *bc, int pos, int version,
+                              commandlist_t *cmd)
+{
+    int bits;
+
+    memset(cmd, 0, sizeof(commandlist_t));
+    cmd->type = ntohl(bc[pos++].op);
+
+    /* When a case is switch'ed to, pos points to the first parameter
+     * of the action.  This makes it easier to add future extensions.
+     * Extensions that change an existing action should add any new
+     * parameters to the beginning of the particular action's bytecode.
+     * This will allow the new code to fall through to the  older
+     * code, which will then parse the older parameters and should
+     * require only a minimal set of changes to support any new extension. 
+     */
+    switch (cmd->type) {
+    case B_STOP:            /* 0 */
+        break;
+
+
+    case B_KEEP_ORIG:       /* 1 */
+        break;
+
+    case B_KEEP_COPY:       /* 22 */
+    case B_KEEP:            /* 35 */
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.k.flags);
+
+        if (cmd->type == B_KEEP_COPY) pos++;  /* skip legacy :copy */
+        break;
+
+        
+    case B_DISCARD:         /* 2 */
+        break;
+
+
+    case B_REJECT:          /* 3 */
+    case B_EREJECT:         /* 31 */
+        pos = bc_string_parse(bc, pos, &cmd->u.str);
+        break;
+
+
+    case B_FILEINTO:        /* 41 */
+        pos = bc_string_parse(bc, pos, &cmd->u.f.mailboxid);
+        GCC_FALLTHROUGH
+
+    case B_FILEINTO_SPECIALUSE:        /* 38 */
+        pos = bc_string_parse(bc, pos, &cmd->u.f.specialuse);
+
+        GCC_FALLTHROUGH
+
+    case B_FILEINTO_CREATE: /* 24 */
+        cmd->u.f.create = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case B_FILEINTO_FLAGS:  /* 23 */
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.f.flags);
+
+        GCC_FALLTHROUGH
+
+    case B_FILEINTO_COPY :  /* 19 */
+        cmd->u.f.copy = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case B_FILEINTO_ORIG:   /* 4 */
+        pos = bc_string_parse(bc, pos, &cmd->u.f.folder);
+        break;
+
+
+    case B_REDIRECT:        /* 39 */
+        pos = bc_string_parse(bc, pos, &cmd->u.r.bytime);
+        pos = bc_string_parse(bc, pos, &cmd->u.r.bymode);
+        cmd->u.r.bytrace = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.r.dsn_notify);
+        pos = bc_string_parse(bc, pos, &cmd->u.r.dsn_ret);
+
+        GCC_FALLTHROUGH
+
+    case B_REDIRECT_LIST:   /* 32 */
+        cmd->u.r.list = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case B_REDIRECT_COPY:   /* 20 */
+        cmd->u.r.copy = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case B_REDIRECT_ORIG:   /* 5 */
+        pos = bc_string_parse(bc, pos, &cmd->u.r.address);
+        break;
+
+
+    case B_IF:              /* 6 */
+        cmd->u.i.testend = ntohl(bc[pos++].value);
+        /* Tests are parsed by caller */
+        break;
+
+
+    case B_MARK:            /* 7 */
+    case B_UNMARK:          /* 8 */
+        break;
+
+
+    case B_ADDFLAG:         /* 26 */
+    case B_SETFLAG:         /* 27 */
+    case B_REMOVEFLAG:      /* 28 */
+        pos = bc_string_parse(bc, pos, &cmd->u.fl.variable);
+
+        GCC_FALLTHROUGH
+
+    case B_ADDFLAG_ORIG:    /* 9 */
+    case B_SETFLAG_ORIG:    /* 10 */
+    case B_REMOVEFLAG_ORIG: /* 11 */
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.fl.flags);
+        break;
+
+
+    case B_NOTIFY:          /* 12 */
+    case B_ENOTIFY:         /* 33 */
+        pos = bc_string_parse(bc, pos, &cmd->u.n.method);
+        pos = bc_string_parse(bc, pos, (cmd->type == B_ENOTIFY) ?
+                               &cmd->u.n.from : &cmd->u.n.id);
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.n.options);
+        cmd->u.n.priority = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.n.message);
+        break;
+
+
+    case B_DENOTIFY:        /* 13 */
+        cmd->u.d.priority = ntohl(bc[pos++].value);
+        cmd->u.d.comp.match = ntohl(bc[pos++].value);
+        cmd->u.d.comp.relation = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.d.pattern);
+        break;
+
+
+    case B_VACATION_ORIG:   /* 14 */
+    case B_VACATION_SEC:    /* 21 */
+    case B_VACATION_FCC:    /* 36 */
+    case B_VACATION:        /* 37 */
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.v.addresses);
+        pos = bc_string_parse(bc, pos, &cmd->u.v.subject);
+        pos = bc_string_parse(bc, pos, &cmd->u.v.message);
+        cmd->u.v.seconds = ntohl(bc[pos++].value);
+        cmd->u.v.mime = ntohl(bc[pos++].value);
+
+        if (version >= 0x05) {
+            pos = bc_string_parse(bc, pos, &cmd->u.v.from);
+            pos = bc_string_parse(bc, pos, &cmd->u.v.handle);
+
+            if (cmd->type >= B_VACATION_FCC) {
+                pos = bc_string_parse(bc, pos, &cmd->u.v.fcc.folder);
+
+                if (cmd->u.v.fcc.folder) {
+                    cmd->u.v.fcc.create = ntohl(bc[pos++].value);
+                    pos = bc_stringlist_parse(bc, pos, &cmd->u.v.fcc.flags);
+
+                    if (cmd->type == B_VACATION) {
+                        pos = bc_string_parse(bc, pos,
+                                               &cmd->u.v.fcc.specialuse);
+                    }
+                }
+            }
+        }
+        break;
+
+
+    case B_NULL:            /* 15 */
+        break;
+
+
+    case B_JUMP:            /* 16 */
+        cmd->u.jump = ntohl(bc[pos++].value);
+        break;
+
+
+    case B_INCLUDE:         /* 17 */
+        bits = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.inc.script);
+
+        cmd->u.inc.location = bits & INC_LOCATION_MASK;
+        cmd->u.inc.optional = bits & INC_OPTIONAL_MASK;
+        cmd->u.inc.once     = bits & INC_ONCE_MASK;
+        break;
+
+
+    case B_RETURN:          /* 18 */
+        break;
+
+
+    case B_SET:             /* 25 */
+        bits = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.s.variable);
+        pos = bc_string_parse(bc, pos, &cmd->u.s.value);
+
+        cmd->u.s.mod40 = bits & BFV_MOD40_MASK;
+        cmd->u.s.mod30 = bits & BFV_MOD30_MASK;
+        cmd->u.s.mod20 = bits & BFV_MOD20_MASK;
+        cmd->u.s.mod15 = bits & BFV_MOD15_MASK;
+        cmd->u.s.mod10 = bits & BFV_MOD10_MASK;
+        break;
+
+
+    case B_ADDHEADER:       /* 29 */
+        cmd->u.ah.index = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &cmd->u.ah.name);
+        pos = bc_string_parse(bc, pos, &cmd->u.ah.value);
+        break;
+
+
+    case B_DELETEHEADER:    /* 30 */
+        cmd->u.dh.comp.index = ntohl(bc[pos++].value);
+        pos = bc_comparator_parse(bc, pos, &cmd->u.dh.comp);
+        pos = bc_string_parse(bc, pos, &cmd->u.dh.name);
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.dh.values);
+        break;
+
+
+    case B_LOG:
+        pos = bc_string_parse(bc, pos, &cmd->u.l.text);
+        break;
+
+
+    case B_ERROR:           /* 34 */
+        pos = bc_string_parse(bc, pos, &cmd->u.str);
+        break;
+
+
+    case B_SNOOZE:          /* 42 */
+        pos = bc_string_parse(bc, pos, &cmd->u.sn.mailbox);
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.sn.addflags);
+        pos = bc_stringlist_parse(bc, pos, &cmd->u.sn.removeflags);
+        bits = ntohl(bc[pos++].value);
+        cmd->u.sn.days = (bits & SNOOZE_WDAYS_MASK);
+        cmd->u.sn.is_mboxid = (bits & SNOOZE_IS_ID_MASK);
+        pos = bc_vallist_parse(bc, pos, &cmd->u.sn.times);
+        break;
+
+
+    default:
+        /* Unknown opcode? */
+        pos = -1;
+        break;
+    }
+
+    return pos;
+}
+
+EXPORTED int bc_test_parse(bytecode_input_t *bc, int pos, int version,
+                           test_t *test)
+{
+    int opcode = ntohl(bc[pos++].op);
+    int has_index = 0;
+
+    if (version == 0x07 &&
+        (opcode == BC_ADDRESS_PRE_INDEX || opcode == BC_HEADER_PRE_INDEX)) {
+        /* There was a version of the bytecode that had the index extension
+         * but did not update the bytecode codepoints, nor did it increment
+         * the bytecode version number.  This tests if the index extension
+         * was in the bytecode based on the position of the match-type
+         * argument.
+         * We test for the applicable version number explicitly.
+         */
+        switch (ntohl(bc[pos+1].value)) {
+        case B_IS:
+        case B_CONTAINS:
+        case B_MATCHES:
+        case B_REGEX:
+        case B_COUNT:
+        case B_VALUE:
+            if (opcode == BC_ADDRESS_PRE_INDEX) opcode = BC_ADDRESS;
+            else opcode = BC_HEADER;
+            break;
+        }
+    }
+
+    memset(test, 0, sizeof(test_t));
+    test->type = opcode;
+
+    /* When a case is switch'ed to, pos points to the first parameter
+     * of the test.  This makes it easier to add future extensions.
+     * Extensions that change an existing test should add any new
+     * parameters to the beginning of the particular test's bytecode.
+     * This will allow the new code to fall through to the  older
+     * code, which will then parse the older parameters and should
+     * require only a minimal set of changes to support any new extension. 
+     */
+    switch (opcode) {
+    case BC_FALSE:                /* 0 */
+    case BC_TRUE:                 /* 1 */
+    case BC_NOT:                  /* 2 */
+        break;
+
+
+    case BC_ANYOF:                /* 5 */
+    case BC_ALLOF:                /* 6 */
+        test->u.aa.ntests = ntohl(bc[pos++].listlen);
+        test->u.aa.endtests = ntohl(bc[pos++].value) / sizeof(bytecode_input_t);
+        /* Tests are parsed by caller */
+        break;
+
+
+    case BC_EXISTS:               /* 3 */
+    case BC_VALIDEXTLIST:         /* 22 */
+    case BC_IHAVE:                /* 24 */
+    case BC_VALIDNOTIFYMETHOD:    /* 27 */
+        pos = bc_stringlist_parse(bc, pos, &test->u.sl);
+        break;
+
+
+    case BC_SIZE:                 /* 4 */
+        test->u.sz.t = ntohl(bc[pos++].value);
+        test->u.sz.n = ntohl(bc[pos++].value);
+        break;
+
+
+    case BC_ADDRESS:              /* 13 */
+        test->u.ae.comp.index = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case BC_ADDRESS_PRE_INDEX:    /* 7 */
+    case BC_ENVELOPE:             /* 8 */
+        pos = bc_comparator_parse(bc, pos, &test->u.ae.comp);
+        test->u.ae.addrpart = ntohl(bc[pos++].value);
+        pos = bc_stringlist_parse(bc, pos, &test->u.ae.sl);
+        pos = bc_stringlist_parse(bc, pos, &test->u.ae.pl);
+        break;
+
+
+    case BC_HEADER:               /* 14 */
+        test->u.hhs.comp.index = ntohl(bc[pos++].value);
+
+        GCC_FALLTHROUGH
+
+    case BC_HEADER_PRE_INDEX:     /* 9 */
+    case BC_HASFLAG:              /* 15 */
+    case BC_STRING:               /* 21 */
+        pos = bc_comparator_parse(bc, pos, &test->u.hhs.comp);
+        pos = bc_stringlist_parse(bc, pos, &test->u.hhs.sl);
+        pos = bc_stringlist_parse(bc, pos, &test->u.hhs.pl);
+        break;
+
+
+    case BC_BODY:                 /* 10 */
+        pos = bc_comparator_parse(bc, pos, &test->u.b.comp);
+        test->u.b.transform = ntohl(bc[pos++].value);
+        test->u.b.offset = ntohl(bc[pos++].value);
+        pos = bc_stringlist_parse(bc, pos, &test->u.b.content_types);
+        pos = bc_stringlist_parse(bc, pos, &test->u.b.pl);
+        break;
+
+
+    case BC_DATE:                 /* 11 */
+        has_index = 1;
+
+        GCC_FALLTHROUGH
+
+    case BC_CURRENTDATE:          /* 12 */
+        if (version == 0x07) {
+            /* There was a version of the bytecode that had the index extension
+             * but did not update the bytecode codepoints, nor did it increment
+             * the bytecode version number.  This tests if the index extension
+             * was in the bytecode based on the position of the match-type
+             * or comparator argument.  This will correctly identify whether
+             * the index extension was supported in every case except the case
+             * of a timezone that is 61 minutes offset (since 61 corresponds to
+             * B_ORIGINALZONE).
+             * There was also an unnumbered version of BC_CURRENTDATE that did
+             * allow :index.  This also covers that case.
+             * We test for the applicable version number explicitly.
+             */
+            switch (ntohl(bc[pos+3].value)) {
+                /* if the 3rd parameter is a comparator,
+                 * we have neither :index nor :zone tags.
+                 * B_ORIGINALZONE is the first parameter.
+                 */
+            case B_ASCIICASEMAP:
+            case B_OCTET:
+            case B_ASCIINUMERIC:
+                has_index = 0;
+                break;
+            default:
+                /* otherwise, we either have a :zone tag, an :index tag, or
+                 * both
+                 */
+                switch (ntohl(bc[pos+4].value)) {
+                    /* if the 4th paramater is a comparator,
+                     * we have either :index or :zone, but not both.
+                     */
+                case B_ASCIICASEMAP:
+                case B_OCTET:
+                case B_ASCIINUMERIC:
+                    /* The ambiguous case is B_TIMEZONE as 1st parameter and
+                     * B_ORIGINALZONE as second parameter, which could mean
+                     * either ':index 60 :originalzone' or ':zone "+0101"'
+                     */
+                    if (B_TIMEZONE == ntohl(bc[pos].value) &&
+                        B_ORIGINALZONE == ntohl(bc[pos+1].value)) {
+                        /* This is the ambiguous case.  Resolve the ambiguity
+                         * by assuming that there is no :index tag since the
+                         * unnumbered bytecode that shipped with Kolab
+                         * Groupware 3.3 included support for the date
+                         * extension, but not for the index extension.
+                         */
+                        has_index = 0;
+
+                    } else if (B_TIMEZONE == ntohl(bc[pos].value)) {
+                        /* if the first parameter is B_TIMEZONE, and the above
+                         * test was false, it must be a :zone tag, and we
+                         * don't have :index.
+                         */
+                        has_index = 0;
+                    } else {
+                        /* if the first parameter is not B_TIMEZONE, it must
+                         * be an :index tag, and we don't have :zone.
+                         */
+                        has_index = 1;
+                    }
+                    break;
+                default:
+                    /* if the 4th parameter is not a comparator, the 5th is,
+                     * and we have both :index and :zone
+                     */
+                    has_index = 1;
+                    break;
+                }
+                break;
+            }
+        }
+
+        if (has_index) test->u.dt.comp.index = ntohl(bc[pos++].value);
+
+        test->u.dt.zonetag = ntohl(bc[pos++].value);
+        if (test->u.dt.zonetag == B_TIMEZONE)
+            test->u.dt.zone = ntohl(bc[pos++].value);
+
+        pos = bc_comparator_parse(bc, pos, &test->u.dt.comp);
+        test->u.dt.date_part = ntohl(bc[pos++].value);
+
+        if (opcode == BC_DATE)
+            pos = bc_string_parse(bc, pos, &test->u.dt.header_name);
+        pos = bc_stringlist_parse(bc, pos, &test->u.dt.kl);
+        break;
+
+
+    case BC_METADATAEXISTS:       /* 18 */
+    case BC_SPECIALUSEEXISTS:     /* 25 */
+        pos = bc_string_parse(bc, pos, &test->u.mm.extname);
+
+        GCC_FALLTHROUGH
+
+    case BC_MAILBOXEXISTS:        /* 16 */
+    case BC_SERVERMETADATAEXISTS: /* 20 */
+    case BC_MAILBOXIDEXISTS:      /* 29 */
+        pos = bc_stringlist_parse(bc, pos, &test->u.mm.keylist);
+        break;
+
+
+    case BC_METADATA:             /* 17 */
+    case BC_NOTIFYMETHODCAPABILITY:/* 28 */
+        pos = bc_comparator_parse(bc, pos, &test->u.mm.comp);
+        pos = bc_string_parse(bc, pos, &test->u.mm.extname);
+        pos = bc_string_parse(bc, pos, &test->u.mm.keyname);
+        pos = bc_stringlist_parse(bc, pos, &test->u.mm.keylist);
+        break;
+
+
+    case BC_SERVERMETADATA:       /* 19 */
+    case BC_ENVIRONMENT:          /* 26 */
+        pos = bc_comparator_parse(bc, pos, &test->u.mm.comp);
+        pos = bc_string_parse(bc, pos, &test->u.mm.keyname);
+        pos = bc_stringlist_parse(bc, pos, &test->u.mm.keylist);
+        break;
+
+
+    case BC_DUPLICATE:            /* 23 */
+        test->u.dup.idtype = ntohl(bc[pos++].value);
+        pos = bc_string_parse(bc, pos, &test->u.dup.idval);
+        pos = bc_string_parse(bc, pos, &test->u.dup.handle);
+        test->u.dup.seconds = ntohl(bc[pos++].value);
+        test->u.dup.last = ntohl(bc[pos++].value);
+        break;
+
+
+    case BC_JMAPQUERY:            /* 30 */
+        pos = bc_string_parse(bc, pos, &test->u.jquery);
+        break;
+
+
+    default:
+        /* Unknown opcode? */
+        pos = -1;
+        break;
+    }
+
+    return pos;
+}
diff -pruN 3.0.13-5/sieve/bc_parse.h 3.2.0-3/sieve/bc_parse.h
--- 3.0.13-5/sieve/bc_parse.h	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/sieve/bc_parse.h	2020-04-24 02:03:00.000000000 +0000
@@ -0,0 +1,58 @@
+/* bc_parse.h -- sieve bytecode - pass 1 of the decompiler
+ * Ken Murchison
+ *
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifndef BC_PARSE_H
+#define BC_PARSE_H
+
+#include "bytecode.h"
+#include "tree.h"
+
+
+extern int bc_header_parse(bytecode_input_t *bc, int *version, int *requires);
+
+extern int bc_action_parse(bytecode_input_t *bc, int pos, int version,
+                           commandlist_t *cmd);
+extern int bc_test_parse(bytecode_input_t *bc, int pos, int version,
+                         test_t *test);
+
+#endif
diff -pruN 3.0.13-5/sieve/bytecode.h 3.2.0-3/sieve/bytecode.h
--- 3.0.13-5/sieve/bytecode.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/bytecode.h	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
 /* bytecode.h -- bytecode definition
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -55,20 +55,31 @@
 
 
 /* yes, lots of these are superfluous, it's for clarity */
-typedef union
+typedef struct
 {
-    int op; /* OPTYPE */
-    int value;
+    int type; /* bytecode data type */
 
-    int jump;
+    union {
+        int op; /* OPTYPE */
+        int value;
 
-    int listlen;
+        int jump;
+
+        int listlen;
+        char *str;
+    } u;
 
-    /* store strings (need 2 consecutive bytecodes) */
-    int len;
-    char *str;
 } bytecode_t;
 
+enum bytecode_data_type {
+    BT_OPCODE,
+    BT_JUMP,
+    BT_VALUE,
+    BT_VALLISTLEN,
+    BT_STRLISTLEN,
+    BT_STR
+};
+
 struct bytecode_info
 {
     bytecode_t *data;/* pointer to almost-flat bytecode */
@@ -106,10 +117,30 @@ typedef union
  * version 0x07 scripts implemented updated INCLUDE (:once and :optional)
  * version 0x08 scripts implemented DATE and INDEX extensions
  * version 0x09 scripts implemented IMAP4FLAGS extension
+ * version 0x0a-0x0f skipped by someone who didn't read hex
  * version 0x10 scripts implemented Mailbox and Metadata (RFC5490)
- * version 0x11 scripts implemented Variables extension (RFC5229)
+ * version 0x11 scripts implemented Variables (RFC5229)
+ * version 0x12 scripts implemented Editheader (RFC5293),
+ *                                  eReject (RFC5429),
+ *                                  External Lists (RFC6134),
+ *                                  eNotify (RFC5435),
+ *                                  Duplicate (RFC7352),
+ *                                  Ihave (RFC5463),
+ *                                  updated KEEP (remove :copy)
+ *                                  updated VACATION (:fcc) (RFC 8580)
+ *                                  Special-Use (RFC 8579)
+ * version 0x13 scripts forced an upgrade for broken bytecode generated by a buggy commit
+ * version 0x14 scripts implemented Environment (RFC5183)
+ * version 0x15 scripts implemented Redirect-DeliverBy, Redirect-DSN (RFC6009)
+ * version 0x16 scripts implemented draft-gondwana-sieve-mailboxid-01
+ * version 0x17 scripts implemented x-cyrus-log
+ * version 0x18 scripts implemented x-cyrus-jmapquery
+ * version 0x19 scripts implemented x-cyrus-snooze
+ * version 0x1A scripts store fileinto mailbox names in UTF8 rather than mUTF7
+ * version 0x1B scripts re-implemented x-cyrus-snooze times as HH:MM:SS
+ *                                                    AND :weekdays as [0, 6]
  */
-#define BYTECODE_VERSION 0x11
+#define BYTECODE_VERSION 0x1B
 #define BYTECODE_MIN_VERSION 0x03 /* minimum supported version */
 #define BYTECODE_MAGIC "CyrSBytecode"
 #define BYTECODE_MAGIC_LEN 12 /* Should be multiple of 4 */
@@ -121,7 +152,7 @@ typedef union
 enum bytecode {
     B_STOP,
 
-    B_KEEP_ORIG,        /* legacy keep w/o support for :copy and :flags */
+    B_KEEP_ORIG,        /* legacy keep w/o support for :flags */
     B_DISCARD,
     B_REJECT,           /* require reject */
     B_FILEINTO_ORIG,    /* legacy fileinto w/o support for :copy */
@@ -136,7 +167,7 @@ enum bytecode {
     B_SETFLAG_ORIG,	/* legacy setflag w/o support for variables */
     B_REMOVEFLAG_ORIG,	/* legacy removeflag w/o support for variables */
 
-    B_NOTIFY,           /* require notify */
+    B_NOTIFY,           /* require notify/enotify */
     B_DENOTIFY,         /* require notify */
 
     B_VACATION_ORIG,    /* legacy vacation w/o support for :seconds */
@@ -147,19 +178,45 @@ enum bytecode {
     B_RETURN,           /* require include */
 
     B_FILEINTO_COPY,    /* legacy fileinto w/o support for :flags */
-    B_REDIRECT,
+    B_REDIRECT_COPY,    /* legacy redirect w/o support for :list */
 
-    B_VACATION,         /* require vacation */
+    B_VACATION_SEC,     /* legacy vacation w/o support for :fcc */
 
-    B_KEEP,
+    B_KEEP_COPY,        /* legacy keep with bogus support for :copy */
     B_FILEINTO_FLAGS,   /* legacy fileinto w/o support for :create */
-    B_FILEINTO,         /* require mailbox, imap4flags, copy */
+    B_FILEINTO_CREATE,  /* legacy fileinto w/o support for :specialuse */
+
+    B_SET,              /* require variables */
+
+    B_ADDFLAG,          /* require imap4flags */
+    B_SETFLAG,          /* require imap4flags */
+    B_REMOVEFLAG,       /* require imap4flags */
+
+    B_ADDHEADER,        /* require editheader */
+    B_DELETEHEADER,     /* require editheader */
+
+    B_EREJECT,          /* require ereject */
 
-    B_SET,		/* require variables */
+    B_REDIRECT_LIST,    /* legacy redirect w/o support for :notify or :ret */
 
-    B_ADDFLAG,		/* require imap4flags */
-    B_SETFLAG,		/* require imap4flags */
-    B_REMOVEFLAG	/* require imap4flags */
+    B_ENOTIFY,          /* require enotify */
+
+    B_ERROR,            /* require ihave */
+
+    B_KEEP,
+
+    B_VACATION_FCC,     /* legacy vacation w/o support for :specialuse */
+
+    B_VACATION,         /* require vacation, fcc, specialuse */
+    B_FILEINTO_SPECIALUSE, /* legacy fileinto w/o support for :mailboxid */
+
+    B_REDIRECT,         /* require copy, list, redirect-dsn */
+
+    B_FILEINTO,         /* require mailbox, imap4flags, copy, specialuse, mailboxid */
+
+    B_LOG,              /* require x-cyrus-log */
+
+    B_SNOOZE,           /* require x-cyrus-snooze */
 };
 
 enum bytecode_comps {
@@ -184,7 +241,16 @@ enum bytecode_comps {
     BC_METADATAEXISTS,
     BC_SERVERMETADATA,  /* require servermetadata */
     BC_SERVERMETADATAEXISTS,
-    BC_STRING	        /* require variables */
+    BC_STRING,          /* require variables */
+    BC_VALIDEXTLIST,    /* require extlists */
+    BC_DUPLICATE,       /* require duplicate */
+    BC_IHAVE,           /* require ihave */
+    BC_SPECIALUSEEXISTS,/* require special-use */
+    BC_ENVIRONMENT,     /* require environment */
+    BC_VALIDNOTIFYMETHOD,/* require enotify */
+    BC_NOTIFYMETHODCAPABILITY,
+    BC_MAILBOXIDEXISTS, /* require mailboxid */
+    BC_JMAPQUERY        /* require x-cyrus-jmapquery */
 };
 
 /* currently one enum so as to help determine where values are being misused.
@@ -248,11 +314,11 @@ enum bytecode_tags {
     B_REGEX,            /* require regex */
     B_COUNT,            /* require relational */
     B_VALUE,            /* require relational */
+    B_LIST,             /* require extlists */
 
     B_MATCH_PLACEHOLDER_1,
     B_MATCH_PLACEHOLDER_2,
     B_MATCH_PLACEHOLDER_3,
-    B_MATCH_PLACEHOLDER_4,
 
     /* Body Transforms (46-53) */
     B_RAW,              /* require body */
@@ -299,9 +365,23 @@ enum bytecode_tags {
     B_DATEPART_PLACEHOLDER_1,
     B_DATEPART_PLACEHOLDER_2,
     B_DATEPART_PLACEHOLDER_3,
-    B_DATEPART_PLACEHOLDER_4
+    B_DATEPART_PLACEHOLDER_4,
+
+    /* Duplicate ID Types (81-84) */
+    B_HEADER,
+    B_UNIQUEID,
+
+    B_IDTYPE_PLACEHOLDER_1,
+    B_IDTYPE_PLACEHOLDER_2
 };
 
+#define INC_LOCATION_MASK 0x3F
+#define INC_OPTIONAL_MASK 0x40
+#define INC_ONCE_MASK     0x80
+
+#define SNOOZE_WDAYS_MASK 0x7F
+#define SNOOZE_IS_ID_MASK 0x80
+
 enum bytecode_variables_bitflags {
     BFV_LOWER	        = 1<<0,
     BFV_UPPER	        = 1<<1,
@@ -309,9 +389,16 @@ enum bytecode_variables_bitflags {
     BFV_UPPERFIRST      = 1<<3,
     BFV_QUOTEWILDCARD   = 1<<4,
     BFV_ENCODEURL	= 1<<5,
-    BFV_LENGTH		= 1<<6
+    BFV_LENGTH		= 1<<6,
+    BFV_QUOTEREGEX      = 1<<7
 };
 
+#define BFV_MOD40_MASK (BFV_LOWER         | BFV_UPPER)
+#define BFV_MOD30_MASK (BFV_LOWERFIRST    | BFV_UPPERFIRST)
+#define BFV_MOD20_MASK (BFV_QUOTEWILDCARD | BFV_QUOTEREGEX)
+#define BFV_MOD15_MASK (BFV_ENCODEURL)
+#define BFV_MOD10_MASK (BFV_LENGTH)
+
 enum bytecode_required_extensions {
     BFE_VARIABLES       = 1<<0
 };
diff -pruN 3.0.13-5/sieve/comparator.c 3.2.0-3/sieve/comparator.c
--- 3.0.13-5/sieve/comparator.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/comparator.c	2020-05-04 03:28:02.000000000 +0000
@@ -51,6 +51,7 @@
 #include <string.h>
 
 #include "comparator.h"
+#include "interp.h"
 #include "tree.h"
 #include "sieve/sieve_interface.h"
 #include "sieve/sieve.h"
@@ -66,42 +67,54 @@ typedef int (*compare_t)(const void *, s
 
 /* these are generic wrappers in which 'rock' is the compare function */
 
-static int rel_eq(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_eq(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
     return (compar(text, tlen, pat) == 0);
 }
 
-static int rel_ne(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_ne(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
     return (compar(text, tlen, pat) != 0);
 }
 
-static int rel_gt(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_gt(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
     return (compar(text, tlen, pat) > 0);
 }
 
-static int rel_ge(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_ge(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
     return (compar(text, tlen, pat) >= 0);
 }
 
-static int rel_lt(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_lt(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
     return (compar(text, tlen, pat) < 0);
 }
 
-static int rel_le(const char *text, size_t tlen, const char *pat, void *rock)
+static int rel_le(const char *text, size_t tlen, const char *pat,
+                  strarray_t *match_vars __attribute__((unused)),
+                  void *rock)
 {
     compare_t compar = (compare_t) rock;
 
@@ -135,42 +148,6 @@ static int octet_cmp(const char *text, s
     return octet_cmp_(text, tlen, pat, 0);
 }
 
-/* we implement boyer-moore for hell of it, since this is probably
- not very useful for sieve */
-#if 0
-int boyer_moore(char *text, char *pat)
-{
-    int i, j; /* indexes */
-    int M = strlen(pat); /* length of pattern */
-    int N = strlen(text); /* length of text */
-    int skip[256]; /* table of how much to skip, based on each character */
-
-    /* initialize skip table */
-    for (i = 0; i < 256; i++)
-        skip[i] = M;
-    for (i = 0; i < M; i++)
-        skip[(int) pat[i]] = M-i-1;
-
-    /* look for pat in text */
-    i = j = M-1;
-    do {
-        if (pat[j] == text[i]) {
-            i--;
-            j--;
-        } else {
-            if (M-j > skip[(int) text[i]]) {
-                i = i + M - j;
-            } else {
-                i = i + skip[(int) text[i]];
-            }
-            j = M-1;
-        }
-    } while (!((j < 0) || (i >= N)));
-    /* i+1 is the position of the match if i < N */
-    return (i < N) ? 1 : 0;
-}
-#endif
-
 /* we do a brute force attack */
 static int octet_contains_(const char *text, size_t tlen,
                            const char *pat, int casemap)
@@ -194,18 +171,41 @@ static int octet_contains_(const char *t
 }
 
 static int octet_contains(const char *text, size_t tlen, const char *pat,
+                          strarray_t *match_vars __attribute__((unused)),
                           void *rock __attribute__((unused)))
 {
     return octet_contains_(text, tlen, pat, 0);
 }
 
-static void append_var(int var_num, const char* val_start, const char* val_end,
-                       strarray_t *match_vars)
+static int new_var(strarray_t *match_vars)
 {
+    int size = strarray_size(match_vars);
+
+    if (size-1 > MAX_MATCH_VARS) return size;
+
+    return strarray_append(match_vars, "");
+}
+
+static void set_var(int var_num, const char* val_start, const char* val_end,
+                    strarray_t *match_vars)
+{
+    if (var_num > MAX_MATCH_VARS) return;
+
     char *val = xstrndup(val_start, val_end - val_start);
     strarray_setm(match_vars, var_num, val);
 }
 
+static int append_var(const char* val_start, const char* val_end,
+                       strarray_t *match_vars)
+{
+    int size = strarray_size(match_vars);
+
+    if (size-1 > MAX_MATCH_VARS) return size;
+
+    char *val = xstrndup(val_start, val_end - val_start);
+    return strarray_appendm(match_vars, val);
+}
+
 static int octet_matches_(const char *text, size_t tlen,
                           const char *pat, int casemap, strarray_t *match_vars)
 {
@@ -227,16 +227,16 @@ static int octet_matches_(const char *te
         c = *p++;
         switch (c) {
         case '?':
-            var_num = strarray_append(match_vars, "");
+            var_num = new_var(match_vars);
             val_start = t;
             if (!tlen) {
                 return 0;
             }
             t++; tlen--;
-            append_var(var_num, val_start, t, match_vars);
+            set_var(var_num, val_start, t, match_vars);
             break;
         case '*':
-            var_num = strarray_append(match_vars, "");
+            var_num = new_var(match_vars);
             val_start = t;
             while (*p == '*' || *p == '?') {
                 if (*p == '?') {
@@ -248,11 +248,10 @@ static int octet_matches_(const char *te
                 } else {
                     for (t -= eaten_chars; eaten_chars; eaten_chars--) {
                         t++;
-                        var_num = strarray_append(match_vars, "");
-                        append_var(var_num, val_start, t, match_vars);
+                        var_num = append_var(val_start, t, match_vars);
                         val_start = t;
                     }
-                    var_num = strarray_append(match_vars, "");
+                    var_num = new_var(match_vars);
                     val_start = t;
                 }
                 /* coalesce into a single wildcard */
@@ -262,11 +261,10 @@ static int octet_matches_(const char *te
                 /* wildcard at end of string, any remaining text is ok */
                 t += tlen;
                 t -= eaten_chars;
-                append_var(var_num, val_start, t, match_vars);
+                set_var(var_num, val_start, t, match_vars);
                 for (val_start = t; eaten_chars; eaten_chars--) {
                     t++;
-                    var_num = strarray_append(match_vars, "");
-                    append_var(var_num, val_start, t, match_vars);
+                    var_num = append_var(val_start, t, match_vars);
                     val_start = t;
                 }
                 return 1;
@@ -277,15 +275,17 @@ static int octet_matches_(const char *te
                 if (octet_matches_(t, tlen, p, casemap, &returned_vars)) {
                     int i;
                     t -= eaten_chars;
-                    append_var(var_num, val_start, t, match_vars);
+                    set_var(var_num, val_start, t, match_vars);
                     for (val_start = t; eaten_chars; eaten_chars--) {
                         t++;
-                        var_num = strarray_append(match_vars, "");
-                        append_var(var_num, val_start, t, match_vars);
+                        var_num = append_var(val_start, t, match_vars);
                         val_start = t;
                     }
                     for (i = 0; i < returned_vars.count; i++) {
-                        strarray_append(match_vars, returned_vars.data[i]);
+                        if (var_num < MAX_MATCH_VARS) {
+                            var_num = strarray_append(match_vars,
+                                                      returned_vars.data[i]);
+                        }
                     }
                     strarray_fini(&returned_vars);
                     return 1;
@@ -293,7 +293,7 @@ static int octet_matches_(const char *te
                 strarray_fini(&returned_vars);
                 t++; tlen--;
             }
-            append_var(var_num, val_start, t, match_vars);
+            set_var(var_num, val_start, t, match_vars);
             break;
         case '\\':
             c = *p++;
@@ -312,40 +312,39 @@ static int octet_matches_(const char *te
 }
 
 static int octet_matches(const char *text, size_t tlen, const char *pat,
-                         void *rock)
+                         strarray_t *match_vars,
+                         void *rock __attribute__((unused)))
 {
     int ret;
     int needs_free = 0;
     strarray_t temp = STRARRAY_INITIALIZER;
-    if (rock) {
-        strarray_fini((strarray_t*) rock);
+    if (match_vars) {
+        strarray_fini(match_vars);
     } else {
-        rock = &temp;
+        match_vars = &temp;
         needs_free = 1;
     }
-    strarray_add((strarray_t*) rock, text);
-    ret = octet_matches_(text, tlen, pat, 0, rock);
+    strarray_add(match_vars, text);
+    ret = octet_matches_(text, tlen, pat, 0, match_vars);
     if (!ret || needs_free) {
-        strarray_fini((strarray_t*) rock);
+        strarray_fini(match_vars);
     }
     return ret;
 }
 
 
 #ifdef ENABLE_REGEX
-#define MAX_MATCH 9  /* MUST support ${1} through ${9} per RFC 5229 */
-
 static int octet_regex(const char *text, size_t tlen, const char *pat,
-                       void *rock)
+                       strarray_t *match_vars,
+                       void *rock __attribute__((unused)))
 {
-    strarray_t *match_vars = (strarray_t *) rock;
-    regmatch_t pm[MAX_MATCH+1];
+    regmatch_t pm[MAX_MATCH_VARS+1];
     size_t nmatch = 0;
     int r;
 
     if (match_vars) {
         strarray_fini(match_vars);
-        nmatch = MAX_MATCH+1;
+        nmatch = MAX_MATCH_VARS+1;
         memset(&pm, 0, sizeof(pm));
     }
 
@@ -375,7 +374,7 @@ static int octet_regex(const char *text,
 
             if (m->rm_so < 0) break;
 
-            append_var(var_num, text + m->rm_so, text + m->rm_eo, match_vars);
+            append_var(text + m->rm_so, text + m->rm_eo, match_vars);
         }
     }
     return r;
@@ -393,28 +392,29 @@ static int ascii_casemap_cmp(const char
 
 static int ascii_casemap_contains(const char *text, size_t tlen,
                                   const char *pat,
+                                  strarray_t *match_vars __attribute__((unused)),
                                   void *rock __attribute__((unused)))
 {
     return octet_contains_(text, tlen, pat, 1);
 }
 
 static int ascii_casemap_matches(const char *text, size_t tlen,
-                                 const char *pat,
-                                 void *rock)
+                                 const char *pat, strarray_t *match_vars,
+                                 void *rock __attribute__((unused)))
 {
     int ret;
     int needs_free = 0;
     strarray_t temp = STRARRAY_INITIALIZER;
-    if (rock) {
-        strarray_fini((strarray_t*) rock);
+    if (match_vars) {
+        strarray_fini(match_vars);
     } else {
-        rock = &temp;
+      match_vars = &temp;
         needs_free = 1;
     }
-    strarray_add((strarray_t*) rock, text);
-    ret = octet_matches_(text, tlen, pat, 1, rock);
+    strarray_add(match_vars, text);
+    ret = octet_matches_(text, tlen, pat, 1, match_vars);
     if (!ret || needs_free) {
-        strarray_fini((strarray_t*) rock);
+        strarray_fini(match_vars);
     }
     return ret;
 }
@@ -528,8 +528,8 @@ static comparator_t *lookup_rel(int rela
     return ret;
 }
 
-EXPORTED comparator_t *lookup_comp(int comp, int mode, int relation,
-                          void **comprock)
+EXPORTED comparator_t *lookup_comp(sieve_interp_t *i, int comp, int mode,
+                                   int relation, void **comprock)
 {
     comparator_t *ret;
 
@@ -538,6 +538,11 @@ EXPORTED comparator_t *lookup_comp(int c
 #if VERBOSE
     printf("comp%d mode%d relat%d     \n", comp, mode, relation);
 #endif
+    if (mode == B_LIST) {
+        *comprock = (void **) i->interp_context;
+        return (comparator_t *) i->listcompare;
+    }
+
     switch (comp)
       {
       case B_OCTET:
@@ -577,7 +582,7 @@ EXPORTED comparator_t *lookup_comp(int c
             break;
 #ifdef ENABLE_REGEX
         case B_REGEX:
-            /* the ascii-casemap destinction is made during
+            /* the ascii-casemap distinction is made during
                the compilation of the regex in verify_regex() */
             ret = &octet_regex;
             break;
diff -pruN 3.0.13-5/sieve/comparator.h 3.2.0-3/sieve/comparator.h
--- 3.0.13-5/sieve/comparator.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/comparator.h	2020-04-24 02:03:00.000000000 +0000
@@ -59,12 +59,17 @@
 # endif /* HAVE_PCREPOSIX_H */
 #endif /* ENABLE_REGEX */
 
-/* compares pat to text; returns 1 if it's true, 0 otherwise
-   first arg is text, second arg is pat, third arg is rock */
-typedef int comparator_t(const char *, size_t, const char *, void *);
+#include "sieve_interface.h"
+#include "strarray.h"
+
+#define MAX_MATCH_VARS 9  /* MUST support ${1} through ${9} per RFC 5229 */
+
+/* compares pat to text; returns 1 if it's true, 0 otherwise */
+typedef int comparator_t(const char *text, size_t tlen, const char *pat,
+                         strarray_t *match_vars, void *rock);
 
 /* returns a pointer to a comparator function given it's name */
-comparator_t *lookup_comp(int comp, int mode,
+comparator_t *lookup_comp(sieve_interp_t *i, int comp, int mode,
                           int relation, void **rock);
 
 #endif /* COMPARATOR_H */
diff -pruN 3.0.13-5/sieve/flags.c 3.2.0-3/sieve/flags.c
--- 3.0.13-5/sieve/flags.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/flags.c	2020-04-24 02:03:00.000000000 +0000
@@ -32,7 +32,7 @@ static int verify_flag(char *f)
     return 1;
 }
 
-EXPORTED int verify_flaglist(strarray_t *sl)
+int verify_flaglist(strarray_t *sl)
 {
     int i;
     char *joined;
diff -pruN 3.0.13-5/sieve/grammar.c 3.2.0-3/sieve/grammar.c
--- 3.0.13-5/sieve/grammar.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/grammar.c	2020-04-24 02:03:00.000000000 +0000
@@ -13,7 +13,7 @@
 #include "xmalloc.h"
 
 
-EXPORTED int is_identifier(char *s)
+HIDDEN int is_identifier(char *s)
 {
     /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */
 
@@ -30,7 +30,7 @@ EXPORTED int is_identifier(char *s)
     return 1;
 }
 
-EXPORTED int is_number(char *s)
+static int is_number(char *s)
 {
     char *tail;
 
@@ -41,7 +41,7 @@ EXPORTED int is_number(char *s)
 }
 
 /* TODO: implement parse_string() with a proper yacc/bison lexer/parser */
-EXPORTED char *parse_string(const char *s, variable_list_t *vars)
+HIDDEN char *parse_string(const char *s, variable_list_t *vars)
 {
     /* protect against being called with no string - this is possible in some places */
     if (!s) return NULL;
diff -pruN 3.0.13-5/sieve/grammar.h 3.2.0-3/sieve/grammar.h
--- 3.0.13-5/sieve/grammar.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/grammar.h	2020-04-24 02:03:00.000000000 +0000
@@ -8,11 +8,9 @@
 #ifndef SIEVE_GRAMMAR_H_
 #define SIEVE_GRAMMAR_H_
 
-#include "strarray.h"
 #include "varlist.h"
 
 int is_identifier(char *s);
-int is_number(char *s);
 char *parse_string(const char *s, variable_list_t *vars);
 
 #endif /* SIEVE_GRAMMAR_H_ */
diff -pruN 3.0.13-5/sieve/interp.c 3.2.0-3/sieve/interp.c
--- 3.0.13-5/sieve/interp.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/interp.c	2020-05-04 03:28:02.000000000 +0000
@@ -57,8 +57,6 @@
 #include "times.h"
 #include "util.h"
 
-#define EXT_LEN 4096
-
 /* build a sieve interpreter */
 EXPORTED sieve_interp_t *sieve_interp_alloc(void *interp_context)
 {
@@ -70,96 +68,131 @@ EXPORTED sieve_interp_t *sieve_interp_al
         initonce = 1;
     }
 
-    i = (sieve_interp_t *) xmalloc(sizeof(sieve_interp_t));
-
-    i->redirect = i->discard = i->reject = i->fileinto = i->keep = NULL;
-    i->getsize = NULL;
-    i->getheader = NULL;
-    i->getenvelope = NULL;
-    i->getbody = NULL;
-    i->getinclude = NULL;
-    i->vacation = NULL;
-    i->notify = NULL;
-
-    i->markflags = NULL;
+    i = (sieve_interp_t *) xzmalloc(sizeof(sieve_interp_t));
 
     i->interp_context = interp_context;
-    i->err = NULL;
-    i->lastitem = NULL;
-    i->extensions[0] = '\0';
+    i->extensions = NULL;
 
     i->time = time(NULL);
 
     return i;
 }
 
-EXPORTED const char *sieve_listextensions(sieve_interp_t *i)
+EXPORTED const strarray_t *sieve_listextensions(sieve_interp_t *i)
 {
-    if (i->extensions[0] == '\0') {
+    if (i->extensions == NULL) {
         unsigned long config_sieve_extensions =
             config_getbitfield(IMAPOPT_SIEVE_EXTENSIONS);
+        struct buf buf = BUF_INITIALIZER;
+        int ext_pos;
+
+        /* strarray of ManageSieve capability/value pairs */
+        i->extensions = strarray_new();
+
+        /* Add SIEVE capability */
+        strarray_append(i->extensions, "SIEVE");
+
+        /* Add placeholder for Sieve extensions string */
+        ext_pos = strarray_append(i->extensions, NULL);
+
+        /* Build Sieve extensions string */
 
         /* add comparators */
-        strlcat(i->extensions, "comparator-i;ascii-numeric", EXT_LEN);
+        buf_setcstr(&buf, "comparator-i;ascii-numeric");
 
         /* add actions */
         if (i->fileinto &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_FILEINTO))
-            strlcat(i->extensions, " fileinto", EXT_LEN);
+            buf_appendcstr(&buf, " fileinto");
         if (i->reject &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_REJECT))
-            strlcat(i->extensions, " reject", EXT_LEN);
+            buf_appendcstr(&buf, " reject ereject");
         if (i->vacation &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION_SECONDS))
-            strlcat(i->extensions, " vacation vacation-seconds", EXT_LEN);
+            buf_appendcstr(&buf, " vacation vacation-seconds");
         else if (i->vacation &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION))
-            strlcat(i->extensions, " vacation", EXT_LEN);
+            buf_appendcstr(&buf, " vacation");
         if (i->markflags &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_IMAPFLAGS))
-            strlcat(i->extensions, " imapflags", EXT_LEN);
+            buf_appendcstr(&buf, " imapflags");
         if (i->notify &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_NOTIFY))
-            strlcat(i->extensions, " notify", EXT_LEN);
+            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_NOTIFY)) {
+            buf_appendcstr(&buf, " notify enotify");
+
+            /* Add NOTIFY capability */
+            strarray_append(i->extensions, "NOTIFY");
+            strarray_append(i->extensions, "mailto");
+        }
         if (i->getinclude &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_INCLUDE))
-            strlcat(i->extensions, " include", EXT_LEN);
+            buf_appendcstr(&buf, " include");
+        if (i->addheader &&
+            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_EDITHEADER))
+            buf_appendcstr(&buf, " editheader");
+        if ((config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_IHAVE))
+            buf_appendcstr(&buf, " ihave");
+#if 0  /* Don't advertise this to ManageSieve clients -
+          We probably don't want end users adding this action themselves */
+        if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_X_CYRUS_LOG)
+            buf_appendcstr(&buf, " x-cyrus-log");
+#endif
 
         /* add tests */
         if (i->getenvelope &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_ENVELOPE))
-            strlcat(i->extensions, " envelope", EXT_LEN);
+            buf_appendcstr(&buf, " envelope");
+        if (i->getenvironment &&
+            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_ENVIRONMENT))
+            buf_appendcstr(&buf, " environment");
         if (i->getbody &&
             (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_BODY))
-            strlcat(i->extensions, " body", EXT_LEN);
+            buf_appendcstr(&buf, " body");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_IMAP4FLAGS)
-            strlcat(i->extensions, " imap4flags", EXT_LEN);
+            buf_appendcstr(&buf, " imap4flags");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_DATE)
-            strlcat(i->extensions, " date", EXT_LEN);
+            buf_appendcstr(&buf, " date");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_MAILBOX)
-            strlcat(i->extensions, " mailbox", EXT_LEN);
+            buf_appendcstr(&buf, " mailbox");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_MBOXMETADATA)
-            strlcat(i->extensions, " mboxmetadata", EXT_LEN);
+            buf_appendcstr(&buf, " mboxmetadata");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_SERVERMETADATA)
-            strlcat(i->extensions, " servermetadata", EXT_LEN);
+            buf_appendcstr(&buf, " servermetadata");
+        if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_DUPLICATE)
+            buf_appendcstr(&buf, " duplicate");
+        if (i->jmapquery &&
+            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_X_CYRUS_JMAPQUERY))
+            buf_appendcstr(&buf, " x-cyrus-jmapquery");
 
         /* add match-types */
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_RELATIONAL)
-            strlcat(i->extensions, " relational", EXT_LEN);
+            buf_appendcstr(&buf, " relational");
 #ifdef ENABLE_REGEX
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_REGEX)
-            strlcat(i->extensions, " regex", EXT_LEN);
+            buf_appendcstr(&buf, " regex");
 #endif
+        if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_EXTLISTS) {
+            buf_appendcstr(&buf, " extlists");
+
+            /* Add EXTLISTS capability */
+            strarray_append(i->extensions, "EXTLISTS");
+            strarray_append(i->extensions, "urn:ietf:params:sieve:addrbook");
+        }
 
         /* add misc extensions */
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_SUBADDRESS)
-            strlcat(i->extensions, " subaddress", EXT_LEN);
+            buf_appendcstr(&buf, " subaddress");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_COPY)
-            strlcat(i->extensions, " copy", EXT_LEN);
+            buf_appendcstr(&buf, " copy");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_INDEX)
-            strlcat(i->extensions, " index", EXT_LEN);
+            buf_appendcstr(&buf, " index");
         if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VARIABLES)
-            strlcat(i->extensions, " variables", EXT_LEN);
+            buf_appendcstr(&buf, " variables");
+        if (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_MAILBOXID)
+            buf_appendcstr(&buf, " mailboxid");
+
+        /* Set Sieve extensions string */
+        strarray_setm(i->extensions, ext_pos, buf_release(&buf));
     }
 
     return i->extensions;
@@ -169,6 +202,7 @@ EXPORTED int sieve_interp_free(sieve_int
 {
     if (*interp) {
         free((*interp)->lastitem);
+        strarray_free((*interp)->extensions);
         free(*interp);
         *interp = NULL;
     }
@@ -197,6 +231,11 @@ EXPORTED void sieve_register_fileinto(si
     interp->fileinto = f;
 }
 
+EXPORTED void sieve_register_snooze(sieve_interp_t *interp, sieve_callback *f)
+{
+    interp->snooze = f;
+}
+
 EXPORTED void sieve_register_keep(sieve_interp_t *interp, sieve_callback *f)
 {
     interp->keep = f;
@@ -213,8 +252,17 @@ EXPORTED void sieve_register_imapflags(s
         (mark && mark->data && mark->count) ? mark : &default_mark;
 }
 
-EXPORTED void sieve_register_notify(sieve_interp_t *interp, sieve_callback *f)
+EXPORTED void sieve_register_notify(sieve_interp_t *interp,
+                                    sieve_callback *f, const strarray_t *methods)
 {
+    static strarray_t default_methods = STRARRAY_INITIALIZER;
+
+    if (!default_methods.count)
+        strarray_append(&default_methods, "mailto:");
+
+    interp->notifymethods =
+        (methods && methods->data && methods->count) ? methods : &default_methods;
+
     interp->notify = f;
 }
 
@@ -230,16 +278,36 @@ EXPORTED void sieve_register_mailboxexis
     interp->getmailboxexists = f;
 }
 
+EXPORTED void sieve_register_mailboxidexists(sieve_interp_t *interp, sieve_get_mailboxidexists *f)
+{
+    interp->getmailboxidexists = f;
+}
+
 EXPORTED void sieve_register_metadata(sieve_interp_t *interp, sieve_get_metadata *f)
 {
     interp->getmetadata = f;
 }
 
+EXPORTED void sieve_register_specialuseexists(sieve_interp_t *interp, sieve_get_specialuseexists *f)
+{
+    interp->getspecialuseexists = f;
+}
+
 EXPORTED void sieve_register_header(sieve_interp_t *interp, sieve_get_header *f)
 {
     interp->getheader = f;
 }
 
+EXPORTED void sieve_register_addheader(sieve_interp_t *interp, sieve_add_header *f)
+{
+    interp->addheader = f;
+}
+
+EXPORTED void sieve_register_deleteheader(sieve_interp_t *interp, sieve_delete_header *f)
+{
+    interp->deleteheader = f;
+}
+
 EXPORTED void sieve_register_fname(sieve_interp_t *interp, sieve_get_fname *f)
 {
     interp->getfname = f;
@@ -255,6 +323,17 @@ EXPORTED void sieve_register_include(sie
     interp->getinclude = f;
 }
 
+EXPORTED void sieve_register_logger(sieve_interp_t *interp, sieve_logger *f)
+{
+    interp->log = f;
+}
+
+EXPORTED void sieve_register_environment(sieve_interp_t *interp,
+                                         sieve_get_environment *f)
+{
+    interp->getenvironment = f;
+}
+
 EXPORTED void sieve_register_body(sieve_interp_t *interp, sieve_get_body *f)
 {
     interp->getbody = f;
@@ -267,9 +346,9 @@ EXPORTED int sieve_register_vacation(sie
     }
 
     if (v->min_response == 0)
-        v->min_response = config_getint(IMAPOPT_SIEVE_VACATION_MIN_RESPONSE);
+        v->min_response = config_getduration(IMAPOPT_SIEVE_VACATION_MIN_RESPONSE, 's');
     if (v->max_response == 0)
-        v->max_response = config_getint(IMAPOPT_SIEVE_VACATION_MAX_RESPONSE);
+        v->max_response = config_getduration(IMAPOPT_SIEVE_VACATION_MAX_RESPONSE, 's');
     if (v->min_response < 0 || v->max_response < 7 * DAY2SEC || !v->autorespond
         || !v->send_response) {
         return SIEVE_FAIL;
@@ -279,6 +358,36 @@ EXPORTED int sieve_register_vacation(sie
     return SIEVE_OK;
 }
 
+EXPORTED void sieve_register_extlists(sieve_interp_t *interp,
+                                      sieve_list_validator *v,
+                                      sieve_list_comparator *c)
+{
+    interp->isvalidlist = v;
+    interp->listcompare = c;
+}
+
+EXPORTED int sieve_register_duplicate(sieve_interp_t *interp,
+                                      sieve_duplicate_t *d)
+{
+    if (!interp->getheader) {
+        return SIEVE_NOT_FINALIZED; /* we need header for duplicate! */
+    }
+
+    if (!(d->check && d->track)) {
+        return SIEVE_FAIL;
+    }
+
+    if (d->max_expiration > 7776000) d->max_expiration = 7776000;  /* 90 days */
+
+    interp->duplicate = d;
+    return SIEVE_OK;
+}
+
+EXPORTED void sieve_register_jmapquery(sieve_interp_t *interp, sieve_jmapquery *f)
+{
+    interp->jmapquery = f;
+}
+
 EXPORTED void sieve_register_parse_error(sieve_interp_t *interp, sieve_parse_error *f)
 {
     interp->err = f;
@@ -297,3 +406,325 @@ int interp_verify(sieve_interp_t *i)
         return SIEVE_NOT_FINALIZED;
     }
 }
+
+/* Array of Sieve capabilities */
+static const struct sieve_capa_t {
+    const char *str;
+    unsigned long long flag;
+} sieve_capabilities[] =
+{
+    /* Sieve "base" - RFC 5228 */
+    { "comparator-i;octet",         SIEVE_CAPA_BASE },
+    { "comparator-i;ascii-casemap", SIEVE_CAPA_BASE },
+    { "comparator-i;ascii-numeric", SIEVE_CAPA_COMP_NUMERIC },
+
+    { "encoded-character", SIEVE_CAPA_ENCODED_CHAR },
+    { "envelope",          SIEVE_CAPA_ENVELOPE },
+    { "fileinto",          SIEVE_CAPA_FILEINTO },
+
+    /* Regular Expressions - draft-ietf-sieve-regex */
+    { "regex", SIEVE_CAPA_REGEX },
+
+    /* Copy - RFC 3894 */
+    { "copy", SIEVE_CAPA_COPY },
+
+    /* Body - RFC 5173 */
+    { "body", SIEVE_CAPA_BODY },
+
+    /* Environment - RFC 5183 */
+    { "environment", SIEVE_CAPA_ENVIRONMENT },
+
+    /* Variables - RFC 5229 */
+    { "variables", SIEVE_CAPA_VARIABLES },
+
+    /* Vacation - RFC 5230 */
+    { "vacation", SIEVE_CAPA_VACATION },
+
+    /* Relational - RFC 5231 */
+    { "relational", SIEVE_CAPA_RELATIONAL },
+
+    /* IMAP4 Flags - RFC 5232 */
+    { "imap4flags", SIEVE_CAPA_IMAP4FLAGS },
+    { "imapflags",  SIEVE_CAPA_IMAPFLAGS }, /* draft-melnikov-sieve-imapflags-04 */
+
+    /* Subaddress - RFC 5233 */
+    { "subaddress", SIEVE_CAPA_SUBADDRESS },
+
+    /* Spamtest & Virustest - RFC 5235 */
+    { "spamtest",     SIEVE_CAPA_SPAM },
+    { "spamtestplus", SIEVE_CAPA_SPAMPLUS },
+    { "virustest",    SIEVE_CAPA_VIRUS },
+
+    /* Date & Index - RFC 5260 */
+    { "date",  SIEVE_CAPA_DATE },
+    { "index", SIEVE_CAPA_INDEX },
+
+    /* Editheader - RFC 5293 */
+    { "editheader", SIEVE_CAPA_EDITHEADER },
+
+    /* [Extended] Reject - RFC 5429 */
+    { "ereject", SIEVE_CAPA_EREJECT },
+    { "reject",  SIEVE_CAPA_REJECT },
+
+    /* Notifications - RFC 5435 */
+    { "enotify", SIEVE_CAPA_ENOTIFY },
+    { "notify",  SIEVE_CAPA_NOTIFY }, /* draft-martin-sieve-notify-01 */
+
+    /* Ihave - RFC 5463 */
+    { "ihave", SIEVE_CAPA_IHAVE },
+
+    /* Mailbox & Metadata - RFC 5490 */
+    { "mailbox",        SIEVE_CAPA_MAILBOX },
+    { "mboxmetadata",   SIEVE_CAPA_MBOXMETA },
+    { "servermetadata", SIEVE_CAPA_SERVERMETA },
+
+    /* MIME Part Handling - RFC 5703 */
+    { "enclose",      SIEVE_CAPA_ENCLOSE },
+    { "extracttest",  SIEVE_CAPA_EXTRACT },
+    { "foreverypart", SIEVE_CAPA_FOREVERYPART },
+    { "mime",         SIEVE_CAPA_MIME },
+    { "replace",      SIEVE_CAPA_REPLACE },
+
+    /* DSN & Deliver-By - RFC 6009 */
+    { "envelope-deliverby", SIEVE_CAPA_ENV_DELBY },
+    { "envelope-dsn",       SIEVE_CAPA_ENV_DSN },
+    { "redirect-deliverby", SIEVE_CAPA_REDIR_DELBY },
+    { "redirect-dsn",       SIEVE_CAPA_REDIR_DSN },
+
+    /* Vacation :seconds - RFC 6131 */
+    { "vacation-seconds", SIEVE_CAPA_VACATION_SEC },
+
+    /* External Lists - RFC 6134 */
+    { "extlists", SIEVE_CAPA_EXTLISTS },
+
+    /* Convert - RFC 6558 */
+    { "convert", SIEVE_CAPA_CONVERT },
+
+    /* Include - RFC 6609 */
+    { "include", SIEVE_CAPA_INCLUDE },
+
+    /* IMAP Events - RFC 6785 */
+    { "imapsieve", SIEVE_CAPA_IMAP },
+
+    /* Duplicate - RFC 7352 */
+    { "duplicate", SIEVE_CAPA_DUPLICATE },
+
+    /* Special-Use - RFC 8579 */
+    { "special-use", SIEVE_CAPA_SPECIAL_USE },
+
+    /* Fcc - RFC 8580 */
+    { "fcc", SIEVE_CAPA_FCC },
+
+    /* Mailboxid - draft-gondwana-sieve-mailboxid */
+    { "mailboxid", SIEVE_CAPA_MAILBOXID },
+
+    /* log - x-cyrus-log */
+    { "x-cyrus-log", SIEVE_CAPA_LOG },
+
+    /* JMAP Query - x-cyrus-jmapquery */
+    { "x-cyrus-jmapquery", SIEVE_CAPA_JMAPQUERY },
+
+    /* Snooze - x-cyrus-snooze */
+    { "x-cyrus-snooze", SIEVE_CAPA_SNOOZE },
+
+    { NULL, 0 }
+};
+    
+
+unsigned long long lookup_capability(const char *str)
+{
+    const struct sieve_capa_t *capa;
+
+    for (capa = sieve_capabilities; capa->str; capa++) {
+        if (!strcmp(str, capa->str)) return capa->flag;
+    }
+
+    return 0;
+}
+
+unsigned long long extension_isactive(sieve_interp_t *interp, const char *str)
+{
+    unsigned long config_ext = config_getbitfield(IMAPOPT_SIEVE_EXTENSIONS);
+    unsigned long long capa = lookup_capability(str);
+
+    switch (capa) {
+    case SIEVE_CAPA_BASE:
+    case SIEVE_CAPA_COMP_NUMERIC:
+    case SIEVE_CAPA_ENCODED_CHAR:
+        /* always enabled */
+        break;
+
+    case SIEVE_CAPA_ENVELOPE:
+        if (!(interp->getenvelope &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_ENVELOPE))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_FILEINTO:
+        if (!(interp->fileinto &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_FILEINTO))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_REGEX:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_REGEX)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_COPY:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_COPY)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_ENVIRONMENT:
+        if (!(interp->getenvironment &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_ENVIRONMENT))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_BODY:
+        if (!(interp->getbody &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_BODY))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_VARIABLES:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_VARIABLES)) capa = 0;
+        break;
+        
+    case SIEVE_CAPA_VACATION:
+        if (!(interp->vacation &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_RELATIONAL:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_RELATIONAL)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_IMAP4FLAGS:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_IMAP4FLAGS)) capa = 0;
+        break;
+        
+    case SIEVE_CAPA_IMAPFLAGS:
+        if (!(interp->markflags->count &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_IMAPFLAGS))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_SUBADDRESS:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_SUBADDRESS)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_DATE:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_DATE)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_INDEX:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_INDEX)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_EDITHEADER:
+        if (!(interp->addheader && interp->deleteheader &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_EDITHEADER))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_EREJECT:
+    case SIEVE_CAPA_REJECT:
+        if (!(interp->reject &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_REJECT))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_ENOTIFY:
+    case SIEVE_CAPA_NOTIFY:
+        if (!(interp->notify &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_NOTIFY))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_IHAVE:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_IHAVE)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_MAILBOX:
+        if (!(interp->getmailboxexists &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_MAILBOX))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_MBOXMETA:
+        if (!(interp->getmetadata &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_MBOXMETADATA))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_SERVERMETA:
+        if (!(interp->getmetadata &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_SERVERMETADATA))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_VACATION_SEC:
+        if (!(interp->vacation &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION_SECONDS))) {
+            capa = 0;
+        } else {
+            /* Note that "vacation-seconds" implies "vacation", and a script
+             * with "vacation-seconds" in a "require" list MAY omit "vacation"
+             * from that list. */
+            capa |= SIEVE_CAPA_VACATION;
+        }
+        break;
+
+    case SIEVE_CAPA_EXTLISTS:
+        if (!(interp->isvalidlist && interp->listcompare &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_EXTLISTS) &&
+              (config_getbitfield(IMAPOPT_HTTPMODULES) & IMAP_ENUM_HTTPMODULES_CARDDAV)))
+            capa = 0;
+        break;
+
+    case SIEVE_CAPA_INCLUDE:
+        if (!(interp->getinclude &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_INCLUDE))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_DUPLICATE:
+        if (!(interp->duplicate &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_DUPLICATE))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_SPECIAL_USE:
+        if (!(interp->getspecialuseexists &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_SPECIAL_USE))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_FCC:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_FCC)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_REDIR_DELBY:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_REDIRECT_DELIVERBY))
+            capa = 0;
+        break;
+
+    case SIEVE_CAPA_REDIR_DSN:
+        if (!(config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_REDIRECT_DSN)) capa = 0;
+        break;
+
+    case SIEVE_CAPA_MAILBOXID:
+        if (!(interp->getmailboxidexists &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_MAILBOXID))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_LOG:
+        if (!(interp->log &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_X_CYRUS_LOG))) capa = 0;
+        break;
+
+    case SIEVE_CAPA_JMAPQUERY:
+        if (!(interp->jmapquery &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_X_CYRUS_JMAPQUERY)))
+            capa = 0;
+        break;
+
+    case SIEVE_CAPA_SNOOZE:
+        if (!(interp->snooze &&
+              (config_ext & IMAP_ENUM_SIEVE_EXTENSIONS_X_CYRUS_SNOOZE))) capa = 0;
+        break;
+
+    default:
+        /* not supported */
+        capa = 0;
+        break;
+    }
+
+    return (capa);
+}
diff -pruN 3.0.13-5/sieve/interp.h 3.2.0-3/sieve/interp.h
--- 3.0.13-5/sieve/interp.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/interp.h	2020-05-04 03:28:02.000000000 +0000
@@ -48,36 +48,231 @@
 
 struct sieve_interp {
     /* standard callbacks for actions */
-    sieve_callback *redirect, *discard, *reject, *fileinto, *keep;
+    sieve_callback *redirect, *discard, *reject, *fileinto, *snooze, *keep;
     sieve_callback *notify;
     sieve_vacation_t *vacation;
 
     sieve_get_size *getsize;
     sieve_get_header *getheader;
+    sieve_add_header *addheader;
+    sieve_delete_header *deleteheader;
     sieve_get_envelope *getenvelope;
+    sieve_get_environment *getenvironment;
     sieve_get_body *getbody;
     sieve_get_include *getinclude;
     sieve_get_fname *getfname;
     sieve_get_mailboxexists *getmailboxexists;
+    sieve_get_mailboxidexists *getmailboxidexists;
+    sieve_get_specialuseexists *getspecialuseexists;
     sieve_get_metadata *getmetadata;
 
+    sieve_logger *log;
+
+    sieve_list_validator *isvalidlist;
+    sieve_list_comparator *listcompare;
+
+    sieve_duplicate_t *duplicate;
+    sieve_jmapquery *jmapquery;
+
     sieve_parse_error *err;
 
     /* site-specific imapflags for mark/unmark */
     const strarray_t *markflags;
 
+    const strarray_t *notifymethods;
+
     sieve_execute_error *execute_err;
 
     char *lastitem;
 
     /* context to pass along */
     void *interp_context;
-    char extensions[4096];//the number comes from interp.c EXT_LEN
+    strarray_t *extensions;
 
     /* time when allocated */
     time_t time;
 };
 
+
+/* Sieve capabilities bitmask */
+enum sieve_capa_flag {
+    /* Sieve "base" - RFC 5228 */
+    SIEVE_CAPA_BASE         = 1LL<<0,
+    SIEVE_CAPA_COMP_NUMERIC = 1LL<<1,
+    SIEVE_CAPA_ENCODED_CHAR = 1LL<<2,
+    SIEVE_CAPA_ENVELOPE     = 1LL<<3,
+    SIEVE_CAPA_FILEINTO     = 1LL<<4,
+
+    /* Regular Expressions - draft-ietf-sieve-regex */
+#ifdef ENABLE_REGEX
+    SIEVE_CAPA_REGEX        = 1LL<<5,
+#else
+    SIEVE_CAPA_REGEX        = 0LL<<5, /* disabled at compile-time */
+#endif
+
+    /* Copy - RFC 3894 */
+    SIEVE_CAPA_COPY         = 1LL<<6,
+
+    /* Body - RFC 5173 */
+    SIEVE_CAPA_BODY         = 1LL<<7,
+
+    /* Environment - RFC 5183 */
+    SIEVE_CAPA_ENVIRONMENT  = 1LL<<8,
+
+    /* Variables - RFC 5229 */
+    SIEVE_CAPA_VARIABLES    = 1LL<<9,
+
+    /* Vacation - RFC 5230 */
+    SIEVE_CAPA_VACATION     = 1LL<<10,
+
+    /* Relational - RFC 5231 */
+    SIEVE_CAPA_RELATIONAL   = 1LL<<11,
+
+    /* IMAP4 Flags - RFC 5232 */
+    SIEVE_CAPA_IMAP4FLAGS   = 1LL<<12,
+    SIEVE_CAPA_IMAPFLAGS    = 1LL<<13, /* draft-melnikov-sieve-imapflags-04 */
+
+    /* Subaddress - RFC 5233 */
+    SIEVE_CAPA_SUBADDRESS   = 1LL<<14,
+
+    /* Spamtest & Virustest - RFC 5235 */
+    SIEVE_CAPA_SPAM         = 0LL<<15, /* currently unsupported */
+    SIEVE_CAPA_SPAMPLUS     = 0LL<<16, /* currently unsupported */
+    SIEVE_CAPA_VIRUS        = 0LL<<17, /* currently unsupported */
+
+    /* Date & Index - RFC 5260 */
+    SIEVE_CAPA_DATE         = 1LL<<18,
+    SIEVE_CAPA_INDEX        = 1LL<<19,
+
+    /* Editheader - RFC 5293 */
+    SIEVE_CAPA_EDITHEADER   = 1LL<<20,
+
+    /* [Extended] Reject - RFC 5429 */
+    SIEVE_CAPA_EREJECT      = 1LL<<21,
+    SIEVE_CAPA_REJECT       = 1LL<<22,
+
+    /* Notifications - RFC 5435 */
+    SIEVE_CAPA_ENOTIFY      = 1LL<<23,
+    SIEVE_CAPA_NOTIFY       = 1LL<<24, /* draft-martin-sieve-notify-01 */
+
+    /* Ihave - RFC 5463 */
+    SIEVE_CAPA_IHAVE        = 1LL<<25,
+
+    /* Mailbox & Metadata - RFC 5490 */
+    SIEVE_CAPA_MAILBOX      = 1LL<<26,
+    SIEVE_CAPA_MBOXMETA     = 1LL<<27,
+    SIEVE_CAPA_SERVERMETA   = 1LL<<28,
+
+    /* MIME Part Handling - RFC 5703 */
+    SIEVE_CAPA_ENCLOSE      = 0LL<<29, /* currently unsupported */
+    SIEVE_CAPA_EXTRACT      = 0LL<<30, /* currently unsupported */
+    SIEVE_CAPA_FOREVERYPART = 0LL<<31, /* currently unsupported */
+    SIEVE_CAPA_MIME         = 0LL<<32, /* currently unsupported */
+    SIEVE_CAPA_REPLACE      = 0LL<<33, /* currently unsupported */
+
+    /* DSN & Deliver-By - RFC 6009 */
+    SIEVE_CAPA_ENV_DELBY    = 0LL<<34, /* currently unsupported */
+    SIEVE_CAPA_ENV_DSN      = 0LL<<35, /* currently unsupported */
+    SIEVE_CAPA_REDIR_DELBY  = 1LL<<36,
+    SIEVE_CAPA_REDIR_DSN    = 1LL<<37,
+
+    /* Vacation :seconds - RFC 6131 */
+    SIEVE_CAPA_VACATION_SEC = 1LL<<38,
+
+    /* External Lists - RFC 6134 */
+    SIEVE_CAPA_EXTLISTS     = 1LL<<39,
+
+    /* Convert - RFC 6558 */
+    SIEVE_CAPA_CONVERT      = 0LL<<40, /* currently unsupported */
+
+    /* Include - RFC 6609 */
+    SIEVE_CAPA_INCLUDE      = 1LL<<41,
+
+    /* IMAP Events - RFC 6785 */
+    SIEVE_CAPA_IMAP         = 0LL<<42, /* currently unsupported */
+
+    /* Duplicate - RFC 7352 */
+    SIEVE_CAPA_DUPLICATE    = 1LL<<43,
+
+    /* Special-Use - RFC 8579 */
+    SIEVE_CAPA_SPECIAL_USE  = 1LL<<44,
+
+    /* Fcc - RFC 8580 */
+    SIEVE_CAPA_FCC          = 1LL<<45,
+
+    /* Mailboxid - draft-gondwana-sieve-mailboxid */
+    SIEVE_CAPA_MAILBOXID    = 1LL<<46,
+
+    /* Log - x-cyrus-log */
+    SIEVE_CAPA_LOG          = 1LL<<47,
+
+    /* JMAP Query - x-cyrus-jmapquery */
+#ifdef WITH_JMAP
+    SIEVE_CAPA_JMAPQUERY    = 1LL<<48,
+#else
+    SIEVE_CAPA_JMAPQUERY    = 0LL<<48, /* disabled at compile-time */
+#endif
+
+    /* Snooze - x-cyrus-snooze */
+    SIEVE_CAPA_SNOOZE       = 1LL<<49,
+};
+
+#define SIEVE_CAPA_ALL (SIEVE_CAPA_BASE           \
+                        | SIEVE_CAPA_COMP_NUMERIC \
+                        | SIEVE_CAPA_ENCODED_CHAR \
+                        | SIEVE_CAPA_ENVELOPE     \
+                        | SIEVE_CAPA_FILEINTO     \
+                        | SIEVE_CAPA_REGEX        \
+                        | SIEVE_CAPA_COPY         \
+                        | SIEVE_CAPA_BODY         \
+                        | SIEVE_CAPA_ENVIRONMENT  \
+                        | SIEVE_CAPA_VARIABLES    \
+                        | SIEVE_CAPA_VACATION     \
+                        | SIEVE_CAPA_RELATIONAL   \
+                        | SIEVE_CAPA_IMAP4FLAGS   \
+                        | SIEVE_CAPA_IMAPFLAGS    \
+                        | SIEVE_CAPA_SUBADDRESS   \
+                        | SIEVE_CAPA_SPAM         \
+                        | SIEVE_CAPA_SPAMPLUS     \
+                        | SIEVE_CAPA_VIRUS        \
+                        | SIEVE_CAPA_DATE         \
+                        | SIEVE_CAPA_INDEX        \
+                        | SIEVE_CAPA_EDITHEADER   \
+                        | SIEVE_CAPA_EREJECT      \
+                        | SIEVE_CAPA_REJECT       \
+                        | SIEVE_CAPA_ENOTIFY      \
+                        | SIEVE_CAPA_NOTIFY       \
+                        | SIEVE_CAPA_IHAVE        \
+                        | SIEVE_CAPA_MAILBOX      \
+                        | SIEVE_CAPA_MBOXMETA     \
+                        | SIEVE_CAPA_SERVERMETA   \
+                        | SIEVE_CAPA_ENCLOSE      \
+                        | SIEVE_CAPA_EXTRACT      \
+                        | SIEVE_CAPA_FOREVERYPART \
+                        | SIEVE_CAPA_MIME         \
+                        | SIEVE_CAPA_REPLACE      \
+                        | SIEVE_CAPA_ENV_DELBY    \
+                        | SIEVE_CAPA_ENV_DSN      \
+                        | SIEVE_CAPA_REDIR_DELBY  \
+                        | SIEVE_CAPA_REDIR_DSN    \
+                        | SIEVE_CAPA_VACATION_SEC \
+                        | SIEVE_CAPA_EXTLISTS     \
+                        | SIEVE_CAPA_CONVERT      \
+                        | SIEVE_CAPA_INCLUDE      \
+                        | SIEVE_CAPA_IMAP         \
+                        | SIEVE_CAPA_DUPLICATE    \
+                        | SIEVE_CAPA_SPECIAL_USE  \
+                        | SIEVE_CAPA_FCC          \
+                        | SIEVE_CAPA_MAILBOXID    \
+                        | SIEVE_CAPA_LOG          \
+                        | SIEVE_CAPA_JMAPQUERY    \
+                        | SIEVE_CAPA_SNOOZE       \
+                        )
+
+#define SIEVE_CAPA_IHAVE_INCOMPAT (SIEVE_CAPA_ENCODED_CHAR | SIEVE_CAPA_VARIABLES)
+
+unsigned long long lookup_capability(const char *str);
+unsigned long long extension_isactive(sieve_interp_t *interp, const char *str);
 int interp_verify(sieve_interp_t *interp);
 
 #endif
diff -pruN 3.0.13-5/sieve/message.c 3.2.0-3/sieve/message.c
--- 3.0.13-5/sieve/message.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/message.c	2020-05-04 03:28:02.000000000 +0000
@@ -55,11 +55,11 @@
 #include "xmalloc.h"
 #include "util.h"
 
-/* reject message m with message msg
+/* [e]reject message m with message msg
  *
  * incompatible with: fileinto, redirect
  */
-int do_reject(action_list_t *a, const char *msg)
+int do_reject(action_list_t *a, int action, const char *msg)
 {
     action_list_t *b = NULL;
 
@@ -67,9 +67,11 @@ int do_reject(action_list_t *a, const ch
     while (a != NULL) {
         b = a;
         if (a->a == ACTION_FILEINTO ||
+            a->a == ACTION_SNOOZE ||
             a->a == ACTION_KEEP ||
             a->a == ACTION_REDIRECT ||
             a->a == ACTION_REJECT ||
+            a->a == ACTION_EREJECT ||
             a->a == ACTION_VACATION ||
             a->a == ACTION_SETFLAG ||
             a->a == ACTION_ADDFLAG ||
@@ -82,71 +84,133 @@ int do_reject(action_list_t *a, const ch
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
-    a->a = ACTION_REJECT;
+    a = new_action_list();
+    a->a = action;
     a->cancel_keep = 1;
     a->u.rej.msg = msg;
+    a->u.rej.is_extended = (action == ACTION_EREJECT);
+
     b->next = a;
-    a->next =  NULL;
+
+    return 0;
+}
+
+/* snooze message m
+ *
+ * incompatible with: [e]reject
+ */
+int do_snooze(action_list_t *a, const char *awaken_mbox, int is_mboxid,
+              strarray_t *addflags, strarray_t *removeflags,
+              unsigned char days, arrayu64_t *times,
+              strarray_t *imapflags)
+{
+    action_list_t *b = NULL;
+
+    /* see if this conflicts with any previous actions taken on this message */
+    while (a != NULL) {
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT) {
+            strarray_free(addflags);
+            strarray_free(removeflags);
+            strarray_free(imapflags);
+            arrayu64_free(times);
+            return SIEVE_RUN_ERROR;
+        }
+
+        if (a->a == ACTION_SNOOZE) {
+            /* don't bother doing it twice */
+            /* check that we have a valid action */
+            if (b == NULL) {
+                strarray_free(addflags);
+                strarray_free(removeflags);
+                strarray_free(imapflags);
+                arrayu64_free(times);
+                return SIEVE_INTERNAL_ERROR;
+            }
+
+            /* cut this action out of the list */
+            b->next = a->next;
+            a->next = NULL;
+            free_action_list(a);
+            a = b;
+        }
+
+        b = a;
+        a = a->next;
+    }
+
+    a = new_action_list();
+    a->a = ACTION_SNOOZE;
+    a->cancel_keep = 1;
+    a->u.snz.awaken_mbox = awaken_mbox;
+    a->u.snz.imapflags = imapflags;
+    a->u.snz.addflags = addflags;
+    a->u.snz.removeflags = removeflags;
+    a->u.snz.days = days;
+    a->u.snz.times = times;
+    a->u.snz.is_mboxid = is_mboxid;
+
+    b->next = a;
+
     return 0;
 }
 
 /* fileinto message m into mailbox
  *
- * incompatible with: reject
+ * incompatible with: [e]reject
  */
-int do_fileinto(action_list_t *a, const char *mbox, int cancel_keep, int do_create,
+int do_fileinto(action_list_t *a, const char *mbox, const char *specialuse,
+                int cancel_keep, int do_create, const char *mailboxid,
                 strarray_t *imapflags)
 {
     action_list_t *b = NULL;
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        if (a->a == ACTION_REJECT)
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT) {
+            strarray_free(imapflags);
             return SIEVE_RUN_ERROR;
+        }
+
         if (a->a == ACTION_FILEINTO && !strcmp(a->u.fil.mailbox, mbox)) {
             /* don't bother doing it twice */
             /* check that we have a valid action */
             if (b == NULL) {
+                strarray_free(imapflags);
                 return SIEVE_INTERNAL_ERROR;
             }
+
             /* cut this action out of the list */
             b->next = a->next;
             a->next = NULL;
-            /* find the end of the list */
-            while (b->next != NULL) {
-                b = b-> next;
-            }
-            /* add the action to the end of the list */
-            b->next = a;
-            break;
+            free_action_list(a);
+            a = b;
         }
+
         b = a;
         a = a->next;
     }
 
-    if (a == NULL) {
-        /* add to the action list */
-        a = new_action_list();
-        if (a == NULL)
-            return SIEVE_NOMEM;
-        b->next = a;
-    }
+    a = new_action_list();
     a->a = ACTION_FILEINTO;
     a->cancel_keep |= cancel_keep;
     a->u.fil.mailbox = mbox;
+    a->u.fil.specialuse = specialuse;
     a->u.fil.imapflags = imapflags;
     a->u.fil.do_create = do_create;
+    a->u.fil.mailboxid = mailboxid;
+
+    b->next = a;
+
     return 0;
 }
 
 /* redirect message m to to addr
  *
- * incompatible with: reject
+ * incompatible with: [e]reject
  */
-int do_redirect(action_list_t *a, const char *addr, int cancel_keep)
+int do_redirect(action_list_t *a, const char *addr, const char *deliverby,
+                const char *dsn_notify, const char *dsn_ret,
+                int is_ext_list, int cancel_keep)
 {
     action_list_t *b = NULL;
 
@@ -154,68 +218,68 @@ int do_redirect(action_list_t *a, const
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        b = a;
-        if (a->a == ACTION_REJECT)
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT)
             return SIEVE_RUN_ERROR;
+
+        b = a;
         a = a->next;
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    a = new_action_list();
     a->a = ACTION_REDIRECT;
     a->cancel_keep = cancel_keep;
     a->u.red.addr = addr;
-    a->next = NULL;
+    a->u.red.is_ext_list = is_ext_list;
+    a->u.red.deliverby = deliverby;
+    a->u.red.dsn_notify = dsn_notify;
+    a->u.red.dsn_ret = dsn_ret;
+
     b->next = a;
+
     return 0;
 }
 
 /* keep message
  *
- * incompatible with: reject
+ * incompatible with: [e]reject
  */
-int do_keep(action_list_t *a, int cancel_keep, strarray_t *imapflags)
+int do_keep(action_list_t *a, strarray_t *imapflags)
 {
     action_list_t *b = NULL;
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        if (a->a == ACTION_REJECT)
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT) {
             return SIEVE_RUN_ERROR;
+            strarray_free(imapflags);
+        }
+
         if (a->a == ACTION_KEEP) {
             /* don't bother doing it twice */
             /* check that we have a valid action */
             if (b == NULL) {
+                strarray_free(imapflags);
                 return SIEVE_INTERNAL_ERROR;
             }
             /* cut this action out of the list */
             b->next = a->next;
             a->next = NULL;
-            /* find the end of the list */
-            while (b->next != NULL) {
-                b = b-> next;
-            }
-            /* add the action to the end of the list */
-            b->next = a;
-            break;
+            free_action_list(a);
+            a = b;
         }
+
         b = a;
         a = a->next;
     }
 
-    if(a == NULL) {
-        /* add to the action list */
-        a = new_action_list();
-        if (a == NULL)
-            return SIEVE_NOMEM;
-        a->next = NULL;
-        b->next = a;
-    }
+    a = new_action_list();
     a->a = ACTION_KEEP;
-    a->cancel_keep |= cancel_keep;
+    a->cancel_keep = 1;
     a->u.keep.imapflags = imapflags;
+
+    b->next = a;
+
     return 0;
 }
 
@@ -229,20 +293,20 @@ int do_discard(action_list_t *a)
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        b = a;
         if (a->a == ACTION_DISCARD) /* don't bother doing twice */
             return 0;
+
+        b = a;
         a = a->next;
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    a = new_action_list();
     a->a = ACTION_DISCARD;
     a->cancel_keep = 1;
-    a->next = NULL;
+
     b->next = a;
+
     return 0;
 }
 
@@ -262,43 +326,47 @@ static int makehash(unsigned char hash[]
 
 int do_vacation(action_list_t *a, char *addr, char *fromaddr,
                 char *subj, const char *msg, int seconds,
-                int mime, const char *handle)
+                int mime, const char *handle,
+                const sieve_fileinto_context_t *fcc)
 {
     action_list_t *b = NULL;
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        b = a;
-        if (a->a == ACTION_REJECT ||
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT ||
             a->a == ACTION_VACATION) /* vacation can't be used twice */
             return SIEVE_RUN_ERROR;
+
+        b = a;
         a = a->next;
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    a = new_action_list();
     a->a = ACTION_VACATION;
-    a->cancel_keep = 0;
     a->u.vac.send.addr = addr;
     a->u.vac.send.fromaddr = fromaddr;
     a->u.vac.send.subj = subj;  /* user specified subject */
     a->u.vac.send.msg = msg;
     a->u.vac.send.mime = mime;
+    a->u.vac.send.fcc.mailbox = fcc->mailbox;
+    a->u.vac.send.fcc.specialuse = fcc->specialuse;
+    a->u.vac.send.fcc.do_create = fcc->do_create;
+    a->u.vac.send.fcc.imapflags = fcc->imapflags;
     if (handle)
         makehash(a->u.vac.autoresp.hash, addr, handle, NULL);
     else
         makehash(a->u.vac.autoresp.hash, addr, fromaddr, msg);
     a->u.vac.autoresp.seconds = seconds;
-    a->next = NULL;
+
     b->next = a;
+
     return 0;
 }
 
 /* mark message m
  *
- * incompatible with: reject
+ * incompatible with: [e]reject
  */
 int do_mark(action_list_t *a)
 {
@@ -306,94 +374,93 @@ int do_mark(action_list_t *a)
 
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        b = a;
-        if (a->a == ACTION_REJECT)
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT)
             return SIEVE_RUN_ERROR;
+
+        b = a;
         a = a->next;
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    a = new_action_list();
     a->a = ACTION_MARK;
-    a->cancel_keep = 0;
+
     b->next = a;
-    a->next = NULL;
+
     return 0;
 }
 
 
 /* unmark message m
  *
- * incompatible with: reject
+ * incompatible with: [e]reject
  */
 int do_unmark(action_list_t *a)
 {
 
     action_list_t *b = NULL;
+
     /* see if this conflicts with any previous actions taken on this message */
     while (a != NULL) {
-        b = a;
-        if (a->a == ACTION_REJECT)
+        if (a->a == ACTION_REJECT || a->a == ACTION_EREJECT)
             return SIEVE_RUN_ERROR;
+
+        b = a;
         a = a->next;
     }
 
     /* add to the action list */
-    a = (action_list_t *) xmalloc(sizeof(action_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    a = new_action_list();
     a->a = ACTION_UNMARK;
-    a->cancel_keep = 0;
+
     b->next = a;
-    a->next = NULL;
+
     return 0;
 }
 
-/* notify
+/* (e)notify
  *
  * incompatible with: none
  */
-int do_notify(notify_list_t *a, const char *id,
+int do_notify(notify_list_t *n, const char *id, const char *from,
               const char *method, const char **options,
               const char *priority, const char *message)
 {
     notify_list_t *b = NULL;
 
     /* find the end of the notify list */
-    while (a != NULL) {
-        b = a;
-        a = a->next;
+    while (n != NULL) {
+        b = n;
+        n = n->next;
     }
 
     /* add to the notify list */
-    a = (notify_list_t *) xmalloc(sizeof(notify_list_t));
-    if (a == NULL)
-        return SIEVE_NOMEM;
+    n = new_notify_list();
+    n->isactive = 1;
+    n->id = id;
+    n->from = from;
+    n->method = method;
+    n->options = options;
+    n->priority = priority;
+    n->message = message;
+
+    b->next = n;
 
-    b->next = a;
-    a->isactive = 1;
-    a->id = id;
-    a->method = method;
-    a->options = options;
-    a->priority = priority;
-    a->message = message;
-    a->next = NULL;
     return 0;
 }
 
 /* denotify
  *
- * incomaptible with: none
+ * incompatible with: none
  */
 int do_denotify(notify_list_t *n, comparator_t *comp, const void *pat,
-                void *comprock, const char *priority)
+                strarray_t *match_vars, void *comprock, const char *priority)
 {
     while (n != NULL) {
         if (n->isactive &&
             (!priority || !strcasecmp(n->priority, priority)) &&
-            (!comp || (n->id && comp(n->id, strlen(n->id), pat, comprock)))) {
+            (!comp ||
+             (n->id && comp(n->id, strlen(n->id), pat, match_vars, comprock)))) {
             n->isactive = 0;
         }
         n = n->next;
@@ -402,20 +469,87 @@ int do_denotify(notify_list_t *n, compar
     return 0;
 }
 
-notify_list_t *new_notify_list(void)
+/* add a header to the message
+ *
+ * incompatible with: none
+ */
+int do_addheader(action_list_t *a, const char *name, const char *value,
+                 int index)
 {
-    notify_list_t *ret = xmalloc(sizeof(notify_list_t));
+    action_list_t *b = NULL;
 
-    if (ret != NULL) {
-        ret->isactive = 0;
-        ret->id       = NULL;
-        ret->method   = NULL;
-        ret->options  = NULL;
-        ret->priority = NULL;
-        ret->message  = NULL;
-        ret->next     = NULL;
+    /* see if this conflicts with any previous actions taken on this message */
+    while (a != NULL) {
+        b = a;
+        a = a->next;
     }
-    return ret;
+
+    /* add to the action list */
+    a = new_action_list();
+    a->a = ACTION_ADDHEADER;
+    a->u.addh.name = name;
+    a->u.addh.value = value;
+    a->u.addh.index = index;
+
+    b->next = a;
+
+    return 0;
+}
+
+/* delete a header from the message
+ *
+ * incompatible with: none
+ */
+int do_deleteheader(action_list_t *a, const char *name, void *patterns,
+                    int index, int comptype,
+                    comparator_t *compfunc, void *comprock)
+{
+    action_list_t *b = NULL;
+
+    /* see if this conflicts with any previous actions taken on this message */
+    while (a != NULL) {
+        b = a;
+        a = a->next;
+    }
+
+    /* add to the action list */
+    a = new_action_list();
+    a->a = ACTION_DELETEHEADER;
+    a->u.delh.name = name;
+    a->u.delh.patterns = patterns;
+    a->u.delh.index = index;
+    a->u.delh.comptype = comptype;
+    a->u.delh.compfunc = compfunc;
+    a->u.delh.comprock = comprock;
+
+    b->next = a;
+
+    return 0;
+}
+
+int do_duptrack(duptrack_list_t *d, sieve_duplicate_context_t *dc)
+{
+    duptrack_list_t *b = NULL;
+
+    /* find the end of the duptrack list */
+    while (d != NULL) {
+        b = d;
+        d = d->next;
+    }
+
+    /* add to the duptrack list */
+    d = new_duptrack_list();
+    d->id = dc->id;
+    d->seconds = dc->seconds;
+
+    b->next = d;
+
+    return 0;
+}
+
+notify_list_t *new_notify_list(void)
+{
+    return (notify_list_t *) xzmalloc(sizeof(notify_list_t));
 }
 
 void free_notify_list(notify_list_t *n)
@@ -430,15 +564,7 @@ void free_notify_list(notify_list_t *n)
 
 action_list_t *new_action_list(void)
 {
-    action_list_t *ret = xmalloc(sizeof(action_list_t));
-
-    if (ret != NULL) {
-        ret->a = ACTION_NONE;
-        ret->param = NULL;
-        ret->next = NULL;
-        ret->cancel_keep = 0;
-    }
-    return ret;
+    return (action_list_t *) xzmalloc(sizeof(action_list_t));
 }
 
 void free_action_list(action_list_t *a)
@@ -446,10 +572,35 @@ void free_action_list(action_list_t *a)
     while (a) {
         action_list_t *b = a->next;
 
-        if(a->a == ACTION_VACATION) {
+        switch (a->a) {
+        case ACTION_FILEINTO:
+            strarray_free(a->u.fil.imapflags);
+            break;
+
+        case ACTION_SNOOZE:
+            strarray_free(a->u.snz.imapflags);
+            strarray_free(a->u.snz.addflags);
+            strarray_free(a->u.snz.removeflags);
+            arrayu64_free(a->u.snz.times);
+            break;
+
+        case ACTION_KEEP:
+            strarray_free(a->u.keep.imapflags);
+            break;
+
+        case ACTION_VACATION:
             if(a->u.vac.send.subj) free(a->u.vac.send.subj);
             if(a->u.vac.send.addr) free(a->u.vac.send.addr);
             if(a->u.vac.send.fromaddr) free(a->u.vac.send.fromaddr);
+            strarray_free(a->u.vac.send.fcc.imapflags);
+            break;
+
+        case ACTION_DELETEHEADER:
+            ptrarray_free(a->u.delh.patterns);
+            break;
+
+        default:
+            break;
         }
 
         free(a);
@@ -457,3 +608,17 @@ void free_action_list(action_list_t *a)
     }
 }
 
+duptrack_list_t *new_duptrack_list(void)
+{
+    return (duptrack_list_t *) xzmalloc(sizeof(duptrack_list_t));
+}
+
+void free_duptrack_list(duptrack_list_t *d)
+{
+    while (d) {
+        duptrack_list_t *b = d->next;
+        free(d->id);
+        free(d);
+        d = b;
+    }
+}
diff -pruN 3.0.13-5/sieve/message.h 3.2.0-3/sieve/message.h
--- 3.0.13-5/sieve/message.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/message.h	2020-05-04 03:28:02.000000000 +0000
@@ -46,6 +46,7 @@
 
 #include "sieve_interface.h"    /* for action contexts */
 #include "tree.h"
+#include "ptrarray.h"
 
 typedef struct Action action_list_t;
 
@@ -53,7 +54,9 @@ typedef enum {
     ACTION_NULL = -1,
     ACTION_NONE = 0,
     ACTION_REJECT,
+    ACTION_EREJECT,
     ACTION_FILEINTO,
+    ACTION_SNOOZE,
     ACTION_KEEP,
     ACTION_REDIRECT,
     ACTION_DISCARD,
@@ -63,6 +66,9 @@ typedef enum {
     ACTION_REMOVEFLAG,
     ACTION_MARK,
     ACTION_UNMARK,
+    ACTION_ADDHEADER,
+    ACTION_DELETEHEADER,
+    ACTION_ENOTIFY,
     ACTION_NOTIFY,
     ACTION_DENOTIFY
 } action_t;
@@ -80,6 +86,7 @@ struct Action {
     int cancel_keep;
     union {
         sieve_reject_context_t rej;
+        sieve_snooze_context_t snz;
         sieve_fileinto_context_t fil;
         sieve_keep_context_t keep;
         sieve_redirect_context_t red;
@@ -91,6 +98,19 @@ struct Action {
         struct {
             const char *flag;
         } fla;
+        struct {
+            const char *name;
+            const char *value;
+            int index;
+        } addh;
+        struct {
+            const char *name;
+            ptrarray_t *patterns;
+            int index;
+            int comptype;
+            comparator_t *compfunc;
+            void *comprock;
+        } delh;
     } u;
     char *param;                /* freed! */
     struct Action *next;
@@ -102,6 +122,7 @@ struct Action {
 typedef struct notify_list_s {
     int isactive;
     const char *id;
+    const char *from;
     const char *method;
     const char **options;
     const char *priority;
@@ -112,28 +133,49 @@ typedef struct notify_list_s {
 notify_list_t *new_notify_list(void);
 void free_notify_list(notify_list_t *n);
 
+typedef struct duptrack_list_s {
+    char *id;
+    int seconds;
+    struct duptrack_list_s *next;
+} duptrack_list_t;
+
+duptrack_list_t *new_duptrack_list(void);
+void free_duptrack_list(duptrack_list_t *d);
+
 /* actions; return negative on failure.
  * these don't actually perform the actions, they just add it to the
  * action list */
-int do_reject(action_list_t *m, const char *msg);
-int do_fileinto(action_list_t *m, const char *mbox, int cancel_keep, int do_create,
+int do_reject(action_list_t *m, int action, const char *msg);
+int do_fileinto(action_list_t *m, const char *mbox, const char *specialuse,
+                int cancel_keep, int do_create, const char *mailboxid,
                 strarray_t *imapflags);
-int do_redirect(action_list_t *m, const char *addr, int cancel_keep);
-int do_keep(action_list_t *m, int cancel_keep, strarray_t *imapflags);
+int do_redirect(action_list_t *a, const char *addr, const char *deliverby,
+                const char *dsn_notify, const char *dsn_ret,
+                int is_ext_list, int cancel_keep);
+int do_keep(action_list_t *m, strarray_t *imapflags);
 int do_discard(action_list_t *m);
-int do_vacation(action_list_t *m, char *addr, char *fromaddr,
-                char *subj, const char *msg, int seconds, int mime,
-                const char *handle);
+int do_vacation(action_list_t *m, char *addr, char *fromaddr, char *subj,
+                const char *msg, int seconds, int mime, const char *handle,
+                const sieve_fileinto_context_t *fcc);
 int do_setflag(action_list_t *m);
 int do_addflag(action_list_t *m, const char *flag);
 int do_removeflag(action_list_t *m, const char *flag);
 int do_mark(action_list_t *m);
 int do_unmark(action_list_t *m);
-int do_notify(notify_list_t *n, const char *id,
+int do_notify(notify_list_t *n, const char *id, const char *from,
               const char *method, const char **options,
               const char *priority, const char *message);
 int do_denotify(notify_list_t *n, comparator_t *comp, const void *pat,
-                void *comprock, const char *priority);
-
+                strarray_t *match_vars, void *comprock, const char *priority);
+int do_duptrack(duptrack_list_t *d, sieve_duplicate_context_t *dc);
+int do_snooze(action_list_t *a, const char *awaken_mbox, int is_mboxid,
+              strarray_t *addflags, strarray_t *removeflags,
+              unsigned char days, arrayu64_t *times,
+              strarray_t *imapflags);
+int do_addheader(action_list_t *a, const char *name, const char *value,
+                 int index);
+int do_deleteheader(action_list_t *a, const char *name, void *patterns,
+                    int index, int comptype,
+                    comparator_t *compfunc, void *comprock);
 
 #endif
diff -pruN 3.0.13-5/sieve/rebuild.c 3.2.0-3/sieve/rebuild.c
--- 3.0.13-5/sieve/rebuild.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/rebuild.c	2020-04-24 02:03:00.000000000 +0000
@@ -56,10 +56,11 @@
 #include "imap/mailbox.h"
 
 #include "sieve/bytecode.h"
+#include "sieve/bc_parse.h"
 #include "sieve/script.h"
 #include "sieve/sieve_interface.h"
 
-EXPORTED char *sieve_getbcfname(const char *script_fname)
+static char *sieve_getbcfname(const char *script_fname)
 {
     char tmp[MAX_MAILBOX_PATH + 1];
     char *ext;
@@ -81,7 +82,7 @@ EXPORTED char *sieve_getbcfname(const ch
     return xstrdup(tmp);
 }
 
-EXPORTED char *sieve_getscriptfname(const char *bc_name)
+static char *sieve_getscriptfname(const char *bc_name)
 {
     char tmp[MAX_MAILBOX_PATH + 1];
     char *ext;
@@ -184,15 +185,15 @@ EXPORTED int sieve_rebuild(const char *s
 
         r = fstat(script_fd, &script_stat);
         if (r) {
-            syslog(LOG_DEBUG, "%s: stat %s: %m", __func__, script_fname);
-            r = SIEVE_FAIL;
+            syslog(LOG_ERR, "IOERROR: fstat %s: %m", script_fname);
+            r = IMAP_IOERROR;
             goto done;
         }
 
         r = stat(bc_fname, &bc_stat);
         if (r && errno != ENOENT) {
-            syslog(LOG_DEBUG, "%s: stat %s: %m", __func__, bc_fname);
-            r = SIEVE_FAIL;
+            syslog(LOG_ERR, "IOERROR: stat %s: %m", bc_fname);
+            r = IMAP_IOERROR;
             goto done;
         }
 
@@ -200,11 +201,18 @@ EXPORTED int sieve_rebuild(const char *s
             sieve_execute_t *exe = NULL;
             r = sieve_script_load(bc_fname, &exe);
 
-            if (!r && sieve_bytecode_version(exe->bc_cur) == BYTECODE_VERSION) {
-                syslog(LOG_DEBUG, "%s: %s is up to date\n", __func__, bc_fname);
-                r = SIEVE_OK;
-                sieve_script_unload(&exe);
-                goto done;
+            if (!r) {
+                int version;
+
+                bc_header_parse((bytecode_input_t *) exe->bc_cur->data,
+                                &version, NULL);
+                if (version == BYTECODE_VERSION) {
+                    syslog(LOG_DEBUG,
+                           "%s: %s is up to date\n", __func__, bc_fname);
+                    r = SIEVE_OK;
+                    sieve_script_unload(&exe);
+                    goto done;
+                }
             }
 
             sieve_script_unload(&exe);
@@ -213,14 +221,14 @@ EXPORTED int sieve_rebuild(const char *s
 
     len = strlcpy(new_bc_fname, bc_fname, sizeof(new_bc_fname));
     if (len >= sizeof(new_bc_fname)) {
-        syslog(LOG_DEBUG, "%s: filename too long: %s", __func__, bc_fname);
-        r = SIEVE_FAIL;
+        syslog(LOG_ERR, "IOERROR: filename too long: %s", bc_fname);
+        r = IMAP_IOERROR;
         goto done;
     }
     len = strlcat(new_bc_fname, ".NEW", sizeof(new_bc_fname));
     if (len >= sizeof(new_bc_fname)) {
-        syslog(LOG_DEBUG, "%s: filename too long: %s", __func__, bc_fname);
-        r = SIEVE_FAIL;
+        syslog(LOG_ERR, "IOERROR: filename too long: %s", bc_fname);
+        r = IMAP_IOERROR;
         goto done;
     }
 
@@ -241,28 +249,28 @@ EXPORTED int sieve_rebuild(const char *s
     script_file = fdopen(script_fd, "r");
     if (!script_file) {
         syslog(LOG_ERR, "IOERROR: unable to fdopen %s for reading: %m",
-                          script_fname);
+                        script_fname);
         r = IMAP_IOERROR;
         goto done;
     }
 
     r = sieve_script_parse_only(script_file, &parse_errors, &script);
     if (r != SIEVE_OK) {
-        syslog(LOG_DEBUG, "%s: %s parse failed: %s",
-                          __func__, script_fname, parse_errors);
+        syslog(LOG_ERR, "%s: %s parse failed: %s",
+                        __func__, script_fname, parse_errors);
         goto done;
     }
 
     if (sieve_generate_bytecode(&bc, script) == -1) {
-        syslog(LOG_DEBUG, "%s: %s bytecode generation failed: %s",
-                          __func__, script_fname, "unknown error");
+        syslog(LOG_ERR, "%s: %s bytecode generation failed: %s",
+                        __func__, script_fname, "unknown error");
         r = SIEVE_FAIL;
         goto done;
     }
 
     if (sieve_emit_bytecode(bc_fd, bc) == -1) {
-        syslog(LOG_DEBUG, "%s: unable to emit bytecode to %s: %s",
-                          __func__, bc_fname, "unknown error");
+        syslog(LOG_ERR, "%s: unable to emit bytecode to %s: %s",
+                        __func__, bc_fname, "unknown error");
         r = SIEVE_FAIL;
         goto done;
     }
diff -pruN 3.0.13-5/sieve/script.c 3.2.0-3/sieve/script.c
--- 3.0.13-5/sieve/script.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/script.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,7 +1,7 @@
 /* script.c -- sieve script functions
  * Larry Greenfield
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -67,6 +67,7 @@
 #include "message.h"
 #include "bytecode.h"
 #include "libconfig.h"
+#include "varlist.h"
 
 /* generated by the yacc script */
 int sieveparse(sieve_script_t *script);
@@ -75,167 +76,32 @@ void sieverestart (FILE *input_file);
 #define ERR_BUF_SIZE 1024
 
 /* does this interpreter support this requirement? */
-int script_require(sieve_script_t *s, char *req)
+int script_require(sieve_script_t *s, const char *req)
 {
-    unsigned long config_sieve_extensions =
-        config_getbitfield(IMAPOPT_SIEVE_EXTENSIONS);
+    unsigned long long capa = extension_isactive(&s->interp, req);
 
-    if (!strcmp("fileinto", req)) {
-        if (s->interp.fileinto &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_FILEINTO)) {
-            s->support.fileinto = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("reject", req)) {
-        if (s->interp.reject &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_REJECT)) {
-            s->support.reject = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("envelope", req)) {
-        if (s->interp.getenvelope &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_ENVELOPE)) {
-            s->support.envelope = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("body", req)) {
-        if (s->interp.getbody &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_BODY)) {
-            s->support.body = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("vacation", req)) {
-        if (s->interp.vacation &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION)) {
-            s->support.vacation = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("vacation-seconds", req)) {
-        if (s->interp.vacation &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VACATION_SECONDS)) {
-            /* Note that "vacation-seconds" implies "vacation", and a script
-             * with "vacation-seconds" in a "require" list MAY omit "vacation"
-             * from that list. */
-            s->support.vacation = 1;
-            s->support.vacation_seconds = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("imapflags", req)) {
-        if (s->interp.markflags->count &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_IMAPFLAGS)) {
-            s->support.imapflags = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("imap4flags", req) &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_IMAP4FLAGS)) {
-        s->support.imap4flags = 1;
-        return 1;
-    } else if (!strcmp("variables", req) &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_VARIABLES)) {
-        s->support.variables = 1;
-        return 1;
-    } else if (!strcmp("notify",req)) {
-        if (s->interp.notify &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_NOTIFY)) {
-            s->support.notify = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-    } else if (!strcmp("include", req)) {
-        if (s->interp.getinclude &&
-            (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_INCLUDE)) {
-            s->support.include = 1;
-            return 1;
-        } else {
-            return 0;
-        }
-#ifdef ENABLE_REGEX
-    } else if (!strcmp("regex", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_REGEX)) {
-        s->support.regex = 1;
-        return 1;
-#endif
-    } else if (!strcmp("subaddress", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_SUBADDRESS)) {
-        s->support.subaddress = 1;
-        return 1;
-    } else if (!strcmp("relational", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_RELATIONAL)) {
-        s->support.relational = 1;
-        return 1;
-    } else if (!strcmp("comparator-i;octet", req)) {
-        return 1;
-    } else if (!strcmp("comparator-i;ascii-casemap", req)) {
-        return 1;
-    } else if (!strcmp("comparator-i;ascii-numeric", req)) {
-        s->support.i_ascii_numeric = 1;
-        return 1;
-    } else if (!strcmp("copy", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_COPY)) {
-        s->support.copy = 1;
-        return 1;
-    } else if (!strcmp("date", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_DATE)) {
-        s->support.date = 1;
-        return 1;
-    } else if (!strcmp("index", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_INDEX)) {
-        s->support.index = 1;
-        return 1;
-    } else if (!strcmp("mailbox", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_MAILBOX)) {
-        s->support.mailbox = 1;
-        return 1;
-    } else if (!strcmp("mboxmetadata", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_MBOXMETADATA)) {
-        s->support.mboxmetadata = 1;
-        return 1;
-    } else if (!strcmp("servermetadata", req) &&
-               (config_sieve_extensions & IMAP_ENUM_SIEVE_EXTENSIONS_SERVERMETADATA)) {
-        s->support.servermetadata = 1;
-        return 1;
-    }
+    s->support |= capa;
 
-    return 0;
+    return (capa != 0LL);
 }
 
 /* given an interpreter and a script, produce an executable script */
 EXPORTED int sieve_script_parse(sieve_interp_t *interp, FILE *script,
                        void *script_context, sieve_script_t **ret)
 {
-    sieve_script_t *s;
-    int res = SIEVE_OK;
-
-    res = interp_verify(interp);
+    int res = interp_verify(interp);
     if (res != SIEVE_OK) {
         return res;
     }
 
-    s = (sieve_script_t *) xmalloc(sizeof(sieve_script_t));
+    sieve_script_t *s = (sieve_script_t *) xzmalloc(sizeof(sieve_script_t));
     s->interp = *interp;
     s->script_context = script_context;
-    /* clear all support bits */
-    memset(&s->support, 0, sizeof(struct sieve_support));
 
-    s->err = 0;
+    /* initialize support bits */
+    s->support = SIEVE_CAPA_BASE;
 
     sieverestart(script);
-    s->cmds = NULL;
     extern int sievelineno;
     sievelineno = 1;            /* reset line number */
     if (sieveparse(s)) {
@@ -263,6 +129,12 @@ static sieve_vacation_t stub_vacation =
     (sieve_callback *) &stub_generic,   /* send_response() */
 };
 
+static sieve_duplicate_t stub_duplicate = {
+    0,                                  /* max expiration */
+    (sieve_callback *) &stub_generic,   /* check() */
+    (sieve_callback *) &stub_generic,   /* track() */
+};
+
 static int stub_notify(void *ac __attribute__((unused)),
                        void *interp_context __attribute__((unused)),
                        void *script_context __attribute__((unused)),
@@ -282,14 +154,9 @@ static int stub_parse_error(int lineno,
     return SIEVE_OK;
 }
 
-/* Wrapper for sieve_script_parse using a disposable single-use interpreter.
- * Use when you only want to parse or compile, but not execute, a script. */
-EXPORTED int sieve_script_parse_only(FILE *stream, char **out_errors,
-                                     sieve_script_t **out_script)
+EXPORTED sieve_interp_t *sieve_build_nonexec_interp()
 {
     sieve_interp_t *interpreter = NULL;
-    sieve_script_t *script = NULL;
-    struct buf errors = BUF_INITIALIZER;
     int res;
 
     /* build a single-use interpreter using stub callbacks*/
@@ -301,13 +168,26 @@ EXPORTED int sieve_script_parse_only(FIL
     sieve_register_fileinto(interpreter, (sieve_callback *) &stub_generic);
     sieve_register_keep(interpreter, (sieve_callback *) &stub_generic);
     sieve_register_imapflags(interpreter, NULL);
+    sieve_register_notify(interpreter, &stub_notify, NULL);
     sieve_register_size(interpreter, (sieve_get_size *) &stub_generic);
-    sieve_register_mailboxexists(interpreter, (sieve_get_mailboxexists *) &stub_generic);
+    sieve_register_mailboxexists(interpreter,
+                                 (sieve_get_mailboxexists *) &stub_generic);
+    sieve_register_mailboxidexists(interpreter,
+                                   (sieve_get_mailboxidexists *) &stub_generic);
+    sieve_register_specialuseexists(interpreter,
+                                    (sieve_get_specialuseexists *) &stub_generic);
     sieve_register_metadata(interpreter, (sieve_get_metadata *) &stub_generic);
     sieve_register_header(interpreter, (sieve_get_header *) &stub_generic);
+    sieve_register_addheader(interpreter, (sieve_add_header *) &stub_generic);
+    sieve_register_deleteheader(interpreter,
+                                (sieve_delete_header *) &stub_generic);
+    sieve_register_fname(interpreter, (sieve_get_fname *) &stub_generic);
     sieve_register_envelope(interpreter, (sieve_get_envelope *) &stub_generic);
+    sieve_register_environment(interpreter,
+                               (sieve_get_environment *) &stub_generic);
     sieve_register_body(interpreter, (sieve_get_body *) &stub_generic);
     sieve_register_include(interpreter, (sieve_get_include *) &stub_generic);
+    sieve_register_logger(interpreter, (sieve_logger *) &stub_generic);
 
     res = sieve_register_vacation(interpreter, &stub_vacation);
     if (res != SIEVE_OK) {
@@ -315,9 +195,47 @@ EXPORTED int sieve_script_parse_only(FIL
         goto done;
     }
 
-    sieve_register_notify(interpreter, &stub_notify);
+    res = sieve_register_duplicate(interpreter, &stub_duplicate);
+    if (res != SIEVE_OK) {
+        syslog(LOG_ERR, "sieve_register_duplicate() returns %d\n", res);
+        goto done;
+    }
+
+#ifdef WITH_DAV
+    sieve_register_extlists(interpreter,
+                            (sieve_list_validator *) &stub_generic,
+                            (sieve_list_comparator *) &stub_generic);
+#endif
+#ifdef WITH_JMAP
+    sieve_register_jmapquery(interpreter, (sieve_jmapquery *) &stub_generic);
+#endif
+#ifdef HAVE_JANSSON
+    sieve_register_snooze(interpreter, (sieve_callback *) &stub_generic);
+#endif
+
     sieve_register_parse_error(interpreter, &stub_parse_error);
 
+done:
+    if (res != SIEVE_OK) {
+        sieve_interp_free(&interpreter);
+        interpreter = NULL;
+    }
+
+    return interpreter;
+}
+
+/* Wrapper for sieve_script_parse using a disposable single-use interpreter.
+ * Use when you only want to parse or compile, but not execute, a script. */
+EXPORTED int sieve_script_parse_only(FILE *stream, char **out_errors,
+                                     sieve_script_t **out_script)
+{
+    sieve_interp_t *interpreter = sieve_build_nonexec_interp();
+    sieve_script_t *script = NULL;
+    struct buf errors = BUF_INITIALIZER;
+    int res;
+
+    if (!interpreter) return SIEVE_FAIL;
+
     buf_appendcstr(&errors, "script errors:\r\n");
     *out_errors = NULL;
 
@@ -336,7 +254,6 @@ EXPORTED int sieve_script_parse_only(FIL
         *out_errors = buf_release(&errors);
     }
 
-done:
     sieve_interp_free(&interpreter);
     buf_free(&errors);
     return res;
@@ -345,6 +262,7 @@ done:
 EXPORTED void sieve_script_free(sieve_script_t **s)
 {
     if (*s) {
+        buf_free(&(*s)->sieveerr);
         if ((*s)->cmds)
             free_tree((*s)->cmds);
         free(*s);
@@ -459,9 +377,10 @@ static int send_notify_callback(sieve_in
     nc.options = notify->options ? notify->options : NULL;
     nc.priority = notify->priority;
 
-    if(nc.options && !strcmp(nc.method,"mailto"))
-      if(!strcmp("$env-from$",*nc.options))
-        interp->getenvelope(message_context, "From", &nc.options);
+    if (nc.options && !strcmp(nc.method, "mailto")) {
+        if (!strcmpsafe("$env-from$", *nc.options))
+            interp->getenvelope(message_context, "From", &nc.options);
+    }
 
     build_notify_message(interp, notify->message, message_context,
                          &out);
@@ -491,7 +410,9 @@ static char *action_to_string(action_t a
         case ACTION_NULL: return "NULL";
         case ACTION_NONE: return "None";
         case ACTION_REJECT: return "Reject";
+        case ACTION_EREJECT: return "eReject";
         case ACTION_FILEINTO: return "Fileinto";
+        case ACTION_SNOOZE: return "Snooze";
         case ACTION_KEEP: return "Keep";
         case ACTION_REDIRECT: return "Redirect";
         case ACTION_DISCARD: return "Discard";
@@ -499,6 +420,8 @@ static char *action_to_string(action_t a
         case ACTION_SETFLAG: return "Setflag";
         case ACTION_ADDFLAG: return "Addflag";
         case ACTION_REMOVEFLAG: return "Removeflag";
+        case ACTION_ADDHEADER: return "AddHeader";
+        case ACTION_DELETEHEADER: return "DeleteHeader";
         case ACTION_MARK: return "Mark";
         case ACTION_UNMARK: return "Unmark";
         case ACTION_NOTIFY: return "Notify";
@@ -769,6 +692,7 @@ static int do_action_list(sieve_interp_t
         implicit_keep = implicit_keep && !a->cancel_keep;
         switch (a->a) {
         case ACTION_REJECT:
+        case ACTION_EREJECT:
             if (!interp->reject)
                 return SIEVE_INTERNAL_ERROR;
             ret = interp->reject(&a->u.rej,
@@ -782,7 +706,9 @@ static int do_action_list(sieve_interp_t
             if (ret == SIEVE_OK)
                 snprintf(actions_string+strlen(actions_string),
                          ACTIONS_STRING_LEN-strlen(actions_string),
-                         "Rejected with: %s\n", a->u.rej.msg);
+                         "%s with: %s\n",
+                         (a->a == ACTION_EREJECT) ? "eRejected" : "Rejected",
+                         a->u.rej.msg);
 
             break;
         case ACTION_FILEINTO:
@@ -801,6 +727,22 @@ static int do_action_list(sieve_interp_t
                          ACTIONS_STRING_LEN-strlen(actions_string),
                          "Filed into: %s\n",a->u.fil.mailbox);
             break;
+        case ACTION_SNOOZE:
+            if (!interp->snooze)
+                return SIEVE_INTERNAL_ERROR;
+            ret = interp->snooze(&a->u.snz,
+                                 interp->interp_context,
+                                 script_context,
+                                 message_context,
+                                 &errmsg);
+            free(interp->lastitem);
+            interp->lastitem = NULL;
+
+            if (ret == SIEVE_OK)
+                snprintf(actions_string+strlen(actions_string),
+                         ACTIONS_STRING_LEN-strlen(actions_string),
+                         "Snoozed\n");
+            break;
         case ACTION_KEEP:
             if (!interp->keep)
                 return SIEVE_INTERNAL_ERROR;
@@ -883,6 +825,127 @@ static int do_action_list(sieve_interp_t
                 break;
             }
 
+        case ACTION_ADDHEADER:
+            if (!interp->addheader)
+                return SIEVE_INTERNAL_ERROR;
+            ret = interp->addheader(script_context,
+                                    message_context,
+                                    a->u.addh.name,
+                                    a->u.addh.value,
+                                    a->u.addh.index);
+            free(interp->lastitem);
+            interp->lastitem = xstrdup(a->u.addh.name);
+            if (ret == SIEVE_OK)
+                snprintf(actions_string+strlen(actions_string),
+                         ACTIONS_STRING_LEN-strlen(actions_string),
+                         "Added header %s\n", a->u.addh.name);
+            break;
+
+        case ACTION_DELETEHEADER:
+            if (!interp->deleteheader)
+                return SIEVE_INTERNAL_ERROR;
+
+            if (!ptrarray_size(a->u.delh.patterns)) {
+                ret = interp->deleteheader(script_context,
+                                           message_context,
+                                           a->u.addh.name,
+                                           a->u.addh.index);
+            }
+            else {
+                strarray_t decoded_vals = STRARRAY_INITIALIZER;
+                int v, nval = 0, first_val = 0, index = a->u.addh.index;
+                unsigned long delete_mask = 0;
+                const char **vals;
+                char scount[20];
+
+                /* get the header values */
+                if (interp->getheader(message_context,
+                                      a->u.delh.name, &vals) != SIEVE_OK) {
+                    ret = 0;
+                    break;
+                }
+
+                for (nval = 0; vals[nval]; nval++) {
+                    if (a->u.delh.comptype == B_COUNT) {
+                        /* count only */
+                        continue;
+                    }
+
+                    /* decode header value and add to strarray_t */
+                    strarray_appendm(&decoded_vals,
+                                     charset_parse_mimeheader(vals[nval],
+                                                              0 /*flags*/));
+                }
+
+                if (a->u.delh.comptype == B_COUNT) {
+                    /* convert number of headers to a string.
+                       Note: use of :index restricts count to at most 1 */
+                    snprintf(scount, sizeof(scount), "%u", index ? 1 : nval);
+                }
+
+                if (nval && index) {
+                    /* normalize index */
+                    index += (index < 0) ? nval : -1;  /* 0-based */
+                    if (index < 0 || index >= nval) {
+                        /* index out of range */
+                        nval = 0;
+                    }
+                    else {
+                        /* target single instance */
+                        first_val = index;
+                        nval = index + 1;
+                    }
+                }
+
+                /* get (and optionally compare) each value pattern */
+                void *pat;
+                while ((pat = ptrarray_pop(a->u.delh.patterns))) {
+                    for (v = first_val; v < nval; v++) {
+                        if (!(delete_mask & (1 << v))) {
+                            const char *val;
+
+                            if (a->u.delh.comptype == B_COUNT) {
+                                val = scount;
+                            }
+                            else {
+                                val = strarray_nth(&decoded_vals, v);
+                            }
+                            if (a->u.delh.compfunc(val, strlen(val),
+                                                   pat, NULL/*match_vars*/,
+                                                   a->u.delh.comprock)) {
+                                /* flag the header for deletion */
+                                delete_mask |= (1 << v);
+                            }
+                        }
+                    }
+
+                    if (a->u.delh.comptype == B_REGEX)
+                        regfree(pat);
+                    free(pat);
+                }
+                strarray_fini(&decoded_vals);
+
+                /* delete flagged headers in reverse order
+                   (so indexing is consistent) */
+                for (v = nval - 1; v >= first_val; v--) {
+                    if (delete_mask & (1 << v)) {
+                        ret = interp->deleteheader(script_context,
+                                                   message_context,
+                                                   a->u.addh.name,
+                                                   v+1 /* 1-based */);
+                        if (ret) break;
+                    }
+                }
+            }
+
+            free(interp->lastitem);
+            interp->lastitem = xstrdup(a->u.delh.name);
+            if (ret == SIEVE_OK)
+                snprintf(actions_string+strlen(actions_string),
+                         ACTIONS_STRING_LEN-strlen(actions_string),
+                         "Deleted header %s\n", a->u.delh.name);
+            break;
+
         case ACTION_NONE:
             break;
 
@@ -907,34 +970,39 @@ static int do_action_list(sieve_interp_t
 
 /* execute some bytecode */
 int sieve_eval_bc(sieve_execute_t *exe, int is_incl, sieve_interp_t *i,
-                  void *sc, void *m,
-                  variable_list_t *variables, action_list_t *actions,
-                  notify_list_t *notify_list, const char **errmsg);
+                  void *sc, void *m, variable_list_t *variables,
+                  action_list_t *actions, notify_list_t *notify_list,
+                  duptrack_list_t *duptrack_list, const char **errmsg);
 
 EXPORTED int sieve_execute_bytecode(sieve_execute_t *exe, sieve_interp_t *interp,
                            void *script_context, void *message_context)
 {
     action_list_t *actions = NULL;
     notify_list_t *notify_list = NULL;
+    duptrack_list_t *duptrack_list = NULL;
     /*   notify_action_t *notify_action;*/
     action_t lastaction = -1;
     int ret;
     char actions_string[ACTIONS_STRING_LEN] = "";
     const char *errmsg = NULL;
     strarray_t imapflags = STRARRAY_INITIALIZER;
-    variable_list_t variables = VARIABLE_LIST_INITIALIZER;
-
-    variables.var = &imapflags;
-    variables.name = xstrdup("");
-
-    varlist_extend(&variables)->name = xstrdup(VL_MATCH_VARS);
-    varlist_extend(&variables)->name = xstrdup(VL_PARSED_STRINGS);
 
     if (!interp) return SIEVE_FAIL;
 
+    if (interp->duplicate) {
+        duptrack_list = new_duptrack_list();
+        if (duptrack_list == NULL) {
+            return do_sieve_error(SIEVE_NOMEM, interp,
+                                  script_context, message_context, &imapflags,
+                                  actions, notify_list, lastaction, 0,
+                                  actions_string, errmsg);
+        }
+    }
+
     if (interp->notify) {
         notify_list = new_notify_list();
         if (notify_list == NULL) {
+            if (duptrack_list) free_duptrack_list(duptrack_list);
             return do_sieve_error(SIEVE_NOMEM, interp,
                                   script_context, message_context, &imapflags,
                                   actions, notify_list, lastaction, 0,
@@ -950,9 +1018,17 @@ EXPORTED int sieve_execute_bytecode(siev
                              actions_string, errmsg);
     }
     else {
+        variable_list_t variables = VARIABLE_LIST_INITIALIZER;
+
+        variables.var = &imapflags;
+        variables.name = xstrdup("");
+
+        varlist_extend(&variables)->name = xstrdup(VL_MATCH_VARS);
+        varlist_extend(&variables)->name = xstrdup(VL_PARSED_STRINGS);
+
         ret = sieve_eval_bc(exe, 0, interp,
-                            script_context, message_context,
-                            &variables, actions, notify_list, &errmsg);
+                            script_context, message_context, &variables,
+                            actions, notify_list, duptrack_list, &errmsg);
 
         if (ret < 0) {
             ret = do_sieve_error(SIEVE_RUN_ERROR, interp,
@@ -966,9 +1042,28 @@ EXPORTED int sieve_execute_bytecode(siev
                                  &imapflags, actions, notify_list,
                                  actions_string, errmsg);
         }
+
+        varlist_fini(&variables);
     }
 
-    varlist_fini(&variables);
+    if (duptrack_list) {
+        if (interp->duplicate && ret == SIEVE_OK) {
+            /* Process duplicate tracking records */
+            duptrack_list_t *d;
+
+            for (d = duptrack_list; d != NULL; d = d->next) {
+                if (d->id) {
+                    sieve_duplicate_context_t dc = { d->id, d->seconds };
+
+                    interp->duplicate->track(&dc, interp->interp_context,
+                                             script_context, message_context,
+                                             &errmsg);
+                }
+            }
+        }
+
+        free_duptrack_list(duptrack_list);
+    }
 
     return ret;
 }
diff -pruN 3.0.13-5/sieve/script.h 3.2.0-3/sieve/script.h
--- 3.0.13-5/sieve/script.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/script.h	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 /* script.h -- script definition
  * Larry Greenfield
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -49,41 +49,20 @@
 #include "sieve_interface.h"
 #include "interp.h"
 #include "tree.h"
+#include "util.h"
 
 struct sieve_script {
     sieve_interp_t interp;
 
-    /* was a "require" done for these? */
-    struct sieve_support {
-        int fileinto       : 1;
-        int reject         : 1;
-        int envelope       : 1;
-        int body           : 1;
-        int vacation       : 1;
-        int imapflags      : 1;
-        int notify         : 1;
-        int regex          : 1;
-        int subaddress     : 1;
-        int relational     : 1;
-        int i_ascii_numeric: 1;
-        int include        : 1;
-        int copy           : 1;
-        int date           : 1;
-        int index          : 1;
-        int vacation_seconds: 1;
-        int imap4flags     : 1;
-        int mailbox        : 1;
-        int mboxmetadata   : 1;
-        int servermetadata : 1;
-        int variables      : 1;
-    } support;
+    unsigned long long support; /* bitmask of extensions required by script */
 
     void *script_context;
     commandlist_t *cmds;
 
     int err;
+    int ignore_err;
     char addrerr[500]; /* buffer for address parser error messages */
-    char sieveerr[1024];
+    struct buf sieveerr;
 };
 
 typedef struct sieve_bytecode sieve_bytecode_t;
@@ -104,6 +83,6 @@ struct sieve_execute {
     sieve_bytecode_t *bc_cur;   /* currently active bytecode buffer */
 };
 
-int script_require(sieve_script_t *s, char *req);
+int script_require(sieve_script_t *s, const char *req);
 
-#endif
+#endif /*  SIEVE_SCRIPT_H */
diff -pruN 3.0.13-5/sieve/sieve.c 3.2.0-3/sieve/sieve.c
--- 3.0.13-5/sieve/sieve.c	2019-12-16 04:16:32.000000000 +0000
+++ 3.2.0-3/sieve/sieve.c	2020-05-04 04:11:04.000000000 +0000
@@ -72,8 +72,9 @@
 
 /* sieve.y -- sieve parser
  * Larry Greenfield
+ * Ken Murchison
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -113,6 +114,10 @@
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+/*
+ * Yacc definitions
+ */
+
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
@@ -129,18 +134,18 @@
 #include "sieve/grammar.h"
 #include "sieve/sieve_err.h"
 
-#include "imapurl.h"
 #include "lib/gmtoff.h"
 #include "util.h"
 #include "imparse.h"
 #include "libconfig.h"
 #include "times.h"
+#include "tok.h"
 
 #define ERR_BUF_SIZE 1024
 
-/*
- * Definitions
- */
+int encoded_char = 0;  /* used to send encoded-character feedback to lexer */
+int getdatepart = 0;   /* used to send start state feedback to lexer */
+static comp_t *ctags;  /* used for accessing comp_t* in a test/command union */
 
 extern int addrparse(sieve_script_t*);
 typedef struct yy_buffer_state *YY_BUFFER_STATE;
@@ -149,163 +154,77 @@ extern void addr_delete_buffer(YY_BUFFER
 
 extern int sievelineno;
 
-struct vtags {
-    int seconds;
-    strarray_t *addresses;
-    char *subject;
-    char *from;
-    char *handle;
-    int mime;
-};
-
-struct comptags {
-    int match;
-    int relation;
-    char *comparator;  /* only used where comparator can be defined */
-    int index;         /* only used where index extension is defined */
-};
-
-struct aetags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int addrtag;
-};
-
-struct btags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int transform;
-    int offset;
-    strarray_t *content_types;
-};
-
-struct ntags {
-    char *method;
-    char *id;
-    strarray_t *options;
-    int priority;
-    char *message;
-};
-
-struct dtags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    void *pattern;
-    int priority;
-};
-
-struct itags {
-    int location;
-    int once;
-    int optional;
-};
-
-struct dttags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int zonetag;
-    char *zone;
-};
-
-struct ftags {
-    int copy;
-    int create;
-    strarray_t *flags;
-};
-
-struct stags {
-    int mod40; /* :lower or :upper */
-    int mod30; /* :lowerfirst or :upperfirst */
-    int mod20; /* :quotewildcard */
-    int mod10; /* :length */
-};
+void sieveerror_c(sieve_script_t*, int code, ...);
 
-static char *check_reqs(sieve_script_t *script, strarray_t *sl);
+static int check_reqs(sieve_script_t*, strarray_t *sl);
+static int chk_match_vars(sieve_script_t*, char *s);
 
-static test_t *build_address(int t, struct aetags *ae,
+/* construct/canonicalize action commands */
+static commandlist_t *build_keep(sieve_script_t*, commandlist_t *c);
+static commandlist_t *build_fileinto(sieve_script_t*,
+                                     commandlist_t *c, char *folder);
+static commandlist_t *build_redirect(sieve_script_t*,
+                                     commandlist_t *c, char *addr);
+static commandlist_t *build_rej_err(sieve_script_t*, int t, char *message);
+static commandlist_t *build_vacation(sieve_script_t*, commandlist_t *t, char *s);
+static commandlist_t *build_flag(sieve_script_t*,
+                                 commandlist_t *c, strarray_t *flags);
+static commandlist_t *build_notify(sieve_script_t*, int t,
+                                   commandlist_t *c, char *method);
+static commandlist_t *build_denotify(sieve_script_t*, commandlist_t *c);
+static commandlist_t *build_include(sieve_script_t*, commandlist_t *c, char*);
+static commandlist_t *build_set(sieve_script_t*, commandlist_t *c,
+                                char *variable, char *value);
+static commandlist_t *build_addheader(sieve_script_t*, commandlist_t *c,
+                                      char *name, char *value);
+static commandlist_t *build_deleteheader(sieve_script_t*, commandlist_t *c,
+                                         char *name, strarray_t *values);
+static commandlist_t *build_log(sieve_script_t*, char *text);
+static commandlist_t *build_snooze(sieve_script_t *sscript,
+                                   commandlist_t *c, arrayu64_t *times);
+
+/* construct/canonicalize test commands */
+static test_t *build_anyof(sieve_script_t*, testlist_t *tl);
+static test_t *build_allof(sieve_script_t*, testlist_t *tl);
+static test_t *build_not(sieve_script_t*, test_t *t);
+static test_t *build_address(sieve_script_t*, test_t *t,
                              strarray_t *sl, strarray_t *pl);
-static test_t *build_header(int t, struct comptags *c,
+static test_t *build_envelope(sieve_script_t*, test_t *t,
+                              strarray_t *sl, strarray_t *pl);
+static test_t *build_header(sieve_script_t*, test_t *t,
                             strarray_t *sl, strarray_t *pl);
-static test_t *build_body(int t, struct btags *b, strarray_t *pl);
-static test_t *build_date(int t, struct dttags *dt,
+static test_t *build_body(sieve_script_t*, test_t *t, strarray_t *pl);
+static test_t *build_stringt(sieve_script_t*, test_t *t,
+                             strarray_t *sl, strarray_t *pl);
+static test_t *build_hasflag(sieve_script_t*, test_t *t,
+                             strarray_t *sl, strarray_t *pl);
+static test_t *build_date(sieve_script_t*, test_t *t,
                           char *hn, int part, strarray_t *kl);
-static test_t *build_mailboxtest(int t, struct comptags *c, const char *extname,
-                                 const char *keyname, strarray_t *keylist);
-
-static commandlist_t *build_vacation(int t, struct vtags *h, char *s);
-static commandlist_t *build_notify(int t, struct ntags *n);
-static commandlist_t *build_denotify(int t, struct dtags *n);
-static commandlist_t *build_keep(int t, struct ftags *f);
-static commandlist_t *build_fileinto(int t, struct ftags *f, char *folder);
-static commandlist_t *build_redirect(int t, int c, char *a);
-static commandlist_t *build_include(int, struct itags *, char*);
-static commandlist_t *build_set(int t, struct stags *s,
-                                char *variable, char *value);
-static commandlist_t *build_flag(int t, char *variable, strarray_t *flags);
+static test_t *build_ihave(sieve_script_t*, strarray_t *sa);
+static test_t *build_mbox_meta(sieve_script_t*, test_t *t, char *extname,
+                               char *keyname, strarray_t *keylist);
+static test_t *build_duplicate(sieve_script_t*, test_t *t);
+static test_t *build_jmapquery(sieve_script_t*, test_t *t, const char *json);
 
-static struct aetags *new_aetags(void);
-static struct aetags *canon_aetags(struct aetags *ae);
-static void free_aetags(struct aetags *ae);
-
-static struct comptags *new_comptags(void);
-static struct comptags *init_comptags(struct comptags *c);
-static struct comptags *canon_comptags(struct comptags *c);
-static void free_comptags(struct comptags *c, int destroy);
-
-static struct btags *new_btags(void);
-static struct btags *canon_btags(struct btags *b);
-static void free_btags(struct btags *b);
-
-static struct vtags *new_vtags(void);
-static struct vtags *canon_vtags(sieve_script_t *script, struct vtags *v);
-static void free_vtags(struct vtags *v);
-
-static struct ntags *new_ntags(void);
-static struct ntags *canon_ntags(struct ntags *n);
-static void free_ntags(struct ntags *n);
-
-static struct dtags *new_dtags(void);
-static struct dtags *canon_dtags(struct dtags *d);
-static void free_dtags(struct dtags *d);
-
-static struct itags *new_itags(void);
-
-static struct dttags *new_dttags(void);
-static struct dttags *canon_dttags(struct dttags *dt);
-static void free_dttags(struct dttags *b);
-
-static struct ftags *new_ftags(void);
-static struct ftags *canon_ftags(struct ftags *f);
-static void free_ftags(struct ftags *f);
-
-static struct stags *new_stags(void);
-static struct stags *canon_stags(struct stags *s);
-static void free_stags(struct stags *s);
-
-static int verify_stringlist(sieve_script_t*, strarray_t *sl,
-                             int (*verify)(sieve_script_t*, char *));
-static int verify_patternlist(sieve_script_t *parse_script,
-                              strarray_t *sl, struct comptags *c,
-                              int (*verify)(sieve_script_t*, char *));
-static int verify_mailbox(sieve_script_t*, char *s);
-static int verify_address(sieve_script_t*, char *s);
-static int verify_header(sieve_script_t*, char *s);
-static int verify_addrheader(sieve_script_t*, char *s);
-static int verify_envelope(sieve_script_t*, char *s);
-static int verify_relat(sieve_script_t*, char *s);
-static int verify_zone(sieve_script_t*, char *s);
-static int verify_date_part(sieve_script_t *parse_script, char *dp);
-static int verify_utf8(sieve_script_t*, char *s);
-static int verify_identifier(sieve_script_t*, char *s);
+static int verify_weekday(sieve_script_t *sscript, char *day);
+static int verify_time(sieve_script_t *sscript, char *time);
 
-static void parse_error(sieve_script_t *parse_script, int err, ...);
 void yyerror(sieve_script_t*, const char *msg);
 extern int yylex(void*, sieve_script_t*);
 extern void sieverestart(FILE *f);
 
-#define YYERROR_VERBOSE /* i want better error messages! */
+#define supported(capa) (sscript->support & capa)
+
+#define _verify_flaglist(flags) \
+  (supported(SIEVE_CAPA_VARIABLES) || verify_flaglist(flags))
+
+#define YYERROR_VERBOSE /* I want better error messages! */
 
 /* byacc default is 500, bison default is 10000 - go with the
    larger to support big sieve scripts (see Bug #3461) */
 #define YYSTACKSIZE 10000
 
-#line 309 "sieve/sieve.c" /* yacc.c:339  */
+#line 228 "sieve/sieve.c" /* yacc.c:339  */
 
 # ifndef YY_NULLPTR
 #  if defined __cplusplus && 201103L <= __cplusplus
@@ -345,110 +264,151 @@ extern int sievedebug;
     IF = 260,
     ELSIF = 261,
     ELSE = 262,
-    REJCT = 263,
-    FILEINTO = 264,
-    REDIRECT = 265,
+    REQUIRE = 263,
+    STOP = 264,
+    DISCARD = 265,
     KEEP = 266,
-    STOP = 267,
-    DISCARD = 268,
-    VACATION = 269,
-    REQUIRE = 270,
-    MARK = 271,
-    UNMARK = 272,
-    FLAGS = 273,
-    NOTIFY = 274,
-    DENOTIFY = 275,
-    ANYOF = 276,
-    ALLOF = 277,
-    EXISTS = 278,
-    SFALSE = 279,
-    STRUE = 280,
-    HEADER = 281,
-    NOT = 282,
-    SIZE = 283,
-    ADDRESS = 284,
-    ENVELOPE = 285,
-    BODY = 286,
-    COMPARATOR = 287,
-    IS = 288,
-    CONTAINS = 289,
-    MATCHES = 290,
+    FILEINTO = 267,
+    REDIRECT = 268,
+    ANYOF = 269,
+    ALLOF = 270,
+    EXISTS = 271,
+    NOT = 272,
+    SFALSE = 273,
+    STRUE = 274,
+    SIZE = 275,
+    HEADERT = 276,
+    ADDRESS = 277,
+    ENVELOPE = 278,
+    COMPARATOR = 279,
+    OVER = 280,
+    UNDER = 281,
+    ALL = 282,
+    LOCALPART = 283,
+    DOMAIN = 284,
+    IS = 285,
+    CONTAINS = 286,
+    MATCHES = 287,
+    OCTET = 288,
+    ASCIICASEMAP = 289,
+    ASCIINUMERIC = 290,
     REGEX = 291,
-    COUNT = 292,
-    VALUE = 293,
-    OVER = 294,
-    UNDER = 295,
-    GT = 296,
-    GE = 297,
-    LT = 298,
-    LE = 299,
-    EQ = 300,
-    NE = 301,
-    ALL = 302,
-    LOCALPART = 303,
-    DOMAIN = 304,
-    USER = 305,
-    DETAIL = 306,
-    RAW = 307,
-    TEXT = 308,
-    CONTENT = 309,
-    DAYS = 310,
+    QUOTEREGEX = 292,
+    COPY = 293,
+    BODY = 294,
+    RAW = 295,
+    TEXT = 296,
+    CONTENT = 297,
+    ENVIRONMENT = 298,
+    STRINGT = 299,
+    SET = 300,
+    LOWER = 301,
+    UPPER = 302,
+    LOWERFIRST = 303,
+    UPPERFIRST = 304,
+    QUOTEWILDCARD = 305,
+    LENGTH = 306,
+    VACATION = 307,
+    DAYS = 308,
+    SUBJECT = 309,
+    FROM = 310,
     ADDRESSES = 311,
-    SUBJECT = 312,
-    FROM = 313,
-    HANDLE = 314,
-    MIME = 315,
-    SECONDS = 316,
-    METHOD = 317,
-    ID = 318,
-    OPTIONS = 319,
-    LOW = 320,
-    NORMAL = 321,
-    HIGH = 322,
-    ANY = 323,
-    MESSAGE = 324,
-    INCLUDE = 325,
-    PERSONAL = 326,
-    GLOBAL = 327,
-    RETURN = 328,
-    OPTIONAL = 329,
-    ONCE = 330,
-    COPY = 331,
+    MIME = 312,
+    HANDLE = 313,
+    SECONDS = 314,
+    COUNT = 315,
+    VALUE = 316,
+    GT = 317,
+    GE = 318,
+    LT = 319,
+    LE = 320,
+    EQ = 321,
+    NE = 322,
+    FLAGS = 323,
+    HASFLAG = 324,
+    SETFLAG = 325,
+    ADDFLAG = 326,
+    REMOVEFLAG = 327,
+    MARK = 328,
+    UNMARK = 329,
+    USER = 330,
+    DETAIL = 331,
     DATE = 332,
     CURRENTDATE = 333,
-    INDEX = 334,
-    LAST = 335,
-    ZONE = 336,
-    ORIGINALZONE = 337,
-    MAILBOXEXISTS = 338,
-    CREATE = 339,
-    METADATA = 340,
-    METADATAEXISTS = 341,
-    SERVERMETADATA = 342,
-    SERVERMETADATAEXISTS = 343,
-    YEAR = 344,
-    MONTH = 345,
-    DAY = 346,
-    JULIAN = 347,
-    HOUR = 348,
-    MINUTE = 349,
-    SECOND = 350,
-    TIME = 351,
-    ISO8601 = 352,
-    STD11 = 353,
-    WEEKDAY = 354,
-    STRINGT = 355,
-    SET = 356,
-    LOWER = 357,
-    UPPER = 358,
-    LOWERFIRST = 359,
-    UPPERFIRST = 360,
-    QUOTEWILDCARD = 361,
-    LENGTH = 362,
-    SETFLAG = 363,
-    ADDFLAG = 364,
-    REMOVEFLAG = 365,
-    HASFLAG = 366
+    ORIGINALZONE = 334,
+    ZONE = 335,
+    TIMEZONE = 336,
+    YEARP = 337,
+    MONTHP = 338,
+    DAYP = 339,
+    DATEP = 340,
+    JULIAN = 341,
+    HOURP = 342,
+    MINUTEP = 343,
+    SECONDP = 344,
+    TIMEP = 345,
+    ISO8601 = 346,
+    STD11 = 347,
+    ZONEP = 348,
+    WEEKDAYP = 349,
+    INDEX = 350,
+    LAST = 351,
+    ADDHEADER = 352,
+    DELETEHEADER = 353,
+    REJCT = 354,
+    EREJECT = 355,
+    METHOD = 356,
+    OPTIONS = 357,
+    MESSAGE = 358,
+    IMPORTANCE = 359,
+    VALIDNOTIFYMETHOD = 360,
+    NOTIFYMETHODCAPABILITY = 361,
+    NOTIFY = 362,
+    ENOTIFY = 363,
+    ENCODEURL = 364,
+    DENOTIFY = 365,
+    ID = 366,
+    ANY = 367,
+    LOW = 368,
+    NORMAL = 369,
+    HIGH = 370,
+    IHAVE = 371,
+    ERROR = 372,
+    MAILBOXEXISTS = 373,
+    CREATE = 374,
+    METADATA = 375,
+    METADATAEXISTS = 376,
+    SERVERMETADATA = 377,
+    SERVERMETADATAEXISTS = 378,
+    BYTIMEREL = 379,
+    BYTIMEABS = 380,
+    BYMODE = 381,
+    BYTRACE = 382,
+    DSNNOTIFY = 383,
+    DSNRET = 384,
+    VALIDEXTLIST = 385,
+    LIST = 386,
+    INCLUDE = 387,
+    OPTIONAL = 388,
+    ONCE = 389,
+    RETURN = 390,
+    PERSONAL = 391,
+    GLOBAL = 392,
+    DUPLICATE = 393,
+    HEADER = 394,
+    UNIQUEID = 395,
+    SPECIALUSEEXISTS = 396,
+    SPECIALUSE = 397,
+    FCC = 398,
+    MAILBOXID = 399,
+    MAILBOXIDEXISTS = 400,
+    LOG = 401,
+    JMAPQUERY = 402,
+    SNOOZE = 403,
+    MAILBOX = 404,
+    ADDFLAGS = 405,
+    REMOVEFLAGS = 406,
+    WEEKDAYS = 407
   };
 #endif
 /* Tokens.  */
@@ -457,136 +417,169 @@ extern int sievedebug;
 #define IF 260
 #define ELSIF 261
 #define ELSE 262
-#define REJCT 263
-#define FILEINTO 264
-#define REDIRECT 265
+#define REQUIRE 263
+#define STOP 264
+#define DISCARD 265
 #define KEEP 266
-#define STOP 267
-#define DISCARD 268
-#define VACATION 269
-#define REQUIRE 270
-#define MARK 271
-#define UNMARK 272
-#define FLAGS 273
-#define NOTIFY 274
-#define DENOTIFY 275
-#define ANYOF 276
-#define ALLOF 277
-#define EXISTS 278
-#define SFALSE 279
-#define STRUE 280
-#define HEADER 281
-#define NOT 282
-#define SIZE 283
-#define ADDRESS 284
-#define ENVELOPE 285
-#define BODY 286
-#define COMPARATOR 287
-#define IS 288
-#define CONTAINS 289
-#define MATCHES 290
+#define FILEINTO 267
+#define REDIRECT 268
+#define ANYOF 269
+#define ALLOF 270
+#define EXISTS 271
+#define NOT 272
+#define SFALSE 273
+#define STRUE 274
+#define SIZE 275
+#define HEADERT 276
+#define ADDRESS 277
+#define ENVELOPE 278
+#define COMPARATOR 279
+#define OVER 280
+#define UNDER 281
+#define ALL 282
+#define LOCALPART 283
+#define DOMAIN 284
+#define IS 285
+#define CONTAINS 286
+#define MATCHES 287
+#define OCTET 288
+#define ASCIICASEMAP 289
+#define ASCIINUMERIC 290
 #define REGEX 291
-#define COUNT 292
-#define VALUE 293
-#define OVER 294
-#define UNDER 295
-#define GT 296
-#define GE 297
-#define LT 298
-#define LE 299
-#define EQ 300
-#define NE 301
-#define ALL 302
-#define LOCALPART 303
-#define DOMAIN 304
-#define USER 305
-#define DETAIL 306
-#define RAW 307
-#define TEXT 308
-#define CONTENT 309
-#define DAYS 310
+#define QUOTEREGEX 292
+#define COPY 293
+#define BODY 294
+#define RAW 295
+#define TEXT 296
+#define CONTENT 297
+#define ENVIRONMENT 298
+#define STRINGT 299
+#define SET 300
+#define LOWER 301
+#define UPPER 302
+#define LOWERFIRST 303
+#define UPPERFIRST 304
+#define QUOTEWILDCARD 305
+#define LENGTH 306
+#define VACATION 307
+#define DAYS 308
+#define SUBJECT 309
+#define FROM 310
 #define ADDRESSES 311
-#define SUBJECT 312
-#define FROM 313
-#define HANDLE 314
-#define MIME 315
-#define SECONDS 316
-#define METHOD 317
-#define ID 318
-#define OPTIONS 319
-#define LOW 320
-#define NORMAL 321
-#define HIGH 322
-#define ANY 323
-#define MESSAGE 324
-#define INCLUDE 325
-#define PERSONAL 326
-#define GLOBAL 327
-#define RETURN 328
-#define OPTIONAL 329
-#define ONCE 330
-#define COPY 331
+#define MIME 312
+#define HANDLE 313
+#define SECONDS 314
+#define COUNT 315
+#define VALUE 316
+#define GT 317
+#define GE 318
+#define LT 319
+#define LE 320
+#define EQ 321
+#define NE 322
+#define FLAGS 323
+#define HASFLAG 324
+#define SETFLAG 325
+#define ADDFLAG 326
+#define REMOVEFLAG 327
+#define MARK 328
+#define UNMARK 329
+#define USER 330
+#define DETAIL 331
 #define DATE 332
 #define CURRENTDATE 333
-#define INDEX 334
-#define LAST 335
-#define ZONE 336
-#define ORIGINALZONE 337
-#define MAILBOXEXISTS 338
-#define CREATE 339
-#define METADATA 340
-#define METADATAEXISTS 341
-#define SERVERMETADATA 342
-#define SERVERMETADATAEXISTS 343
-#define YEAR 344
-#define MONTH 345
-#define DAY 346
-#define JULIAN 347
-#define HOUR 348
-#define MINUTE 349
-#define SECOND 350
-#define TIME 351
-#define ISO8601 352
-#define STD11 353
-#define WEEKDAY 354
-#define STRINGT 355
-#define SET 356
-#define LOWER 357
-#define UPPER 358
-#define LOWERFIRST 359
-#define UPPERFIRST 360
-#define QUOTEWILDCARD 361
-#define LENGTH 362
-#define SETFLAG 363
-#define ADDFLAG 364
-#define REMOVEFLAG 365
-#define HASFLAG 366
+#define ORIGINALZONE 334
+#define ZONE 335
+#define TIMEZONE 336
+#define YEARP 337
+#define MONTHP 338
+#define DAYP 339
+#define DATEP 340
+#define JULIAN 341
+#define HOURP 342
+#define MINUTEP 343
+#define SECONDP 344
+#define TIMEP 345
+#define ISO8601 346
+#define STD11 347
+#define ZONEP 348
+#define WEEKDAYP 349
+#define INDEX 350
+#define LAST 351
+#define ADDHEADER 352
+#define DELETEHEADER 353
+#define REJCT 354
+#define EREJECT 355
+#define METHOD 356
+#define OPTIONS 357
+#define MESSAGE 358
+#define IMPORTANCE 359
+#define VALIDNOTIFYMETHOD 360
+#define NOTIFYMETHODCAPABILITY 361
+#define NOTIFY 362
+#define ENOTIFY 363
+#define ENCODEURL 364
+#define DENOTIFY 365
+#define ID 366
+#define ANY 367
+#define LOW 368
+#define NORMAL 369
+#define HIGH 370
+#define IHAVE 371
+#define ERROR 372
+#define MAILBOXEXISTS 373
+#define CREATE 374
+#define METADATA 375
+#define METADATAEXISTS 376
+#define SERVERMETADATA 377
+#define SERVERMETADATAEXISTS 378
+#define BYTIMEREL 379
+#define BYTIMEABS 380
+#define BYMODE 381
+#define BYTRACE 382
+#define DSNNOTIFY 383
+#define DSNRET 384
+#define VALIDEXTLIST 385
+#define LIST 386
+#define INCLUDE 387
+#define OPTIONAL 388
+#define ONCE 389
+#define RETURN 390
+#define PERSONAL 391
+#define GLOBAL 392
+#define DUPLICATE 393
+#define HEADER 394
+#define UNIQUEID 395
+#define SPECIALUSEEXISTS 396
+#define SPECIALUSE 397
+#define FCC 398
+#define MAILBOXID 399
+#define MAILBOXIDEXISTS 400
+#define LOG 401
+#define JMAPQUERY 402
+#define SNOOZE 403
+#define MAILBOX 404
+#define ADDFLAGS 405
+#define REMOVEFLAGS 406
+#define WEEKDAYS 407
 
 /* Value type.  */
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
 
 union YYSTYPE
 {
-#line 238 "sieve/sieve.y" /* yacc.c:355  */
+#line 170 "sieve/sieve.y" /* yacc.c:355  */
 
     int nval;
     char *sval;
+    arrayu64_t *nl;
     strarray_t *sl;
+    comp_t *ctag;
     test_t *test;
     testlist_t *testl;
     commandlist_t *cl;
-    struct vtags *vtag;
-    struct aetags *aetag;
-    struct comptags *ctag;
-    struct btags *btag;
-    struct ntags *ntag;
-    struct dtags *dtag;
-    struct itags *itag;
-    struct dttags *dttag;
-    struct ftags *ftag;
-    struct stags *stag;
 
-#line 590 "sieve/sieve.c" /* yacc.c:355  */
+#line 583 "sieve/sieve.c" /* yacc.c:355  */
 };
 
 typedef union YYSTYPE YYSTYPE;
@@ -596,13 +589,13 @@ typedef union YYSTYPE YYSTYPE;
 
 
 
-int sieveparse (sieve_script_t *parse_script);
+int sieveparse (sieve_script_t *sscript);
 
 #endif /* !YY_SIEVE_SIEVE_SIEVE_H_INCLUDED  */
 
 /* Copy the second part of user declarations.  */
 
-#line 606 "sieve/sieve.c" /* yacc.c:358  */
+#line 599 "sieve/sieve.c" /* yacc.c:358  */
 
 #ifdef short
 # undef short
@@ -842,23 +835,23 @@ union yyalloc
 #endif /* !YYCOPY_NEEDED */
 
 /* YYFINAL -- State number of the termination state.  */
-#define YYFINAL  8
+#define YYFINAL  10
 /* YYLAST -- Last index in YYTABLE.  */
-#define YYLAST   419
+#define YYLAST   722
 
 /* YYNTOKENS -- Number of terminals.  */
-#define YYNTOKENS  120
+#define YYNTOKENS  161
 /* YYNNTS -- Number of nonterminals.  */
-#define YYNNTS  48
+#define YYNNTS  119
 /* YYNRULES -- Number of rules.  */
-#define YYNRULES  167
+#define YYNRULES  321
 /* YYNSTATES -- Number of states.  */
-#define YYNSTATES  244
+#define YYNSTATES  438
 
 /* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
    by yylex, with out-of-bounds checking.  */
 #define YYUNDEFTOK  2
-#define YYMAXUTOK   366
+#define YYMAXUTOK   407
 
 #define YYTRANSLATE(YYX)                                                \
   ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)
@@ -871,15 +864,15 @@ static const yytype_uint8 yytranslate[]
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-     118,   119,     2,     2,   115,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,   112,
+     159,   160,     2,     2,   156,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,   153,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,   113,     2,   114,     2,     2,     2,     2,     2,     2,
+       2,   154,     2,   155,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,   116,     2,   117,     2,     2,     2,     2,
+       2,     2,     2,   157,     2,   158,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
@@ -903,30 +896,50 @@ static const yytype_uint8 yytranslate[]
       75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
       95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
-     105,   106,   107,   108,   109,   110,   111
+     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
+     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
+     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
+     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
+     145,   146,   147,   148,   149,   150,   151,   152
 };
 
 #if YYDEBUG
   /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
 static const yytype_uint16 yyrline[] =
 {
-       0,   314,   314,   315,   318,   319,   322,   333,   334,   337,
-     338,   339,   342,   343,   344,   347,   362,   377,   385,   386,
-     387,   389,   406,   422,   433,   444,   456,   475,   496,   507,
-     525,   526,   527,   530,   531,   552,   553,   563,   573,   608,
-     620,   621,   623,   624,   626,   628,   631,   632,   642,   652,
-     662,   673,   674,   684,   694,   704,   714,   726,   727,   737,
-     752,   753,   754,   757,   758,   768,   784,   798,   811,   824,
-     837,   849,   850,   856,   860,   866,   867,   870,   871,   872,
-     873,   874,   876,   899,   932,   967,   992,  1015,  1044,  1069,
-    1070,  1073,  1101,  1127,  1146,  1165,  1184,  1203,  1222,  1225,
-    1226,  1237,  1238,  1239,  1242,  1243,  1254,  1255,  1261,  1272,
-    1295,  1321,  1344,  1368,  1369,  1370,  1371,  1374,  1375,  1376,
-    1379,  1380,  1381,  1384,  1385,  1386,  1389,  1390,  1401,  1412,
-    1426,  1427,  1430,  1431,  1442,  1443,  1444,  1445,  1448,  1449,
-    1450,  1451,  1457,  1476,  1485,  1486,  1487,  1488,  1498,  1509,
-    1510,  1511,  1512,  1524,  1534,  1547,  1548,  1551,  1563,  1575,
-    1576,  1587,  1598,  1622,  1623,  1636,  1639,  1640
+       0,   358,   358,   359,   363,   364,   369,   370,   374,   375,
+     376,   388,   389,   393,   394,   398,   399,   403,   410,   417,
+     421,   422,   423,   427,   438,   439,   440,   444,   445,   452,
+     453,   454,   455,   456,   458,   461,   465,   467,   470,   474,
+     475,   478,   481,   482,   483,   484,   486,   491,   492,   497,
+     531,   532,   533,   534,   535,   536,   541,   562,   591,   624,
+     662,   663,   664,   676,   683,   693,   707,   720,   732,   748,
+     760,   776,   777,   786,   795,   804,   813,   826,   827,   830,
+     831,   834,   835,   845,   854,   859,   860,   869,   883,   893,
+     904,   915,   924,   934,   938,   964,   965,   966,   971,   972,
+     973,   978,   979,   998,   999,  1004,  1005,  1018,  1019,  1019,
+    1020,  1020,  1021,  1021,  1022,  1022,  1027,  1028,  1039,  1042,
+    1053,  1063,  1066,  1076,  1086,  1097,  1108,  1123,  1124,  1125,
+    1130,  1131,  1141,  1141,  1150,  1151,  1160,  1169,  1182,  1183,
+    1188,  1189,  1199,  1201,  1212,  1223,  1236,  1237,  1241,  1242,
+    1246,  1250,  1251,  1255,  1256,  1260,  1267,  1274,  1278,  1279,
+    1283,  1284,  1285,  1286,  1287,  1288,  1292,  1298,  1301,  1303,
+    1306,  1308,  1312,  1319,  1321,  1325,  1325,  1328,  1330,  1335,
+    1339,  1341,  1348,  1352,  1359,  1363,  1371,  1376,  1378,  1385,
+    1392,  1399,  1404,  1409,  1410,  1415,  1416,  1416,  1417,  1417,
+    1418,  1418,  1419,  1419,  1424,  1433,  1455,  1456,  1457,  1458,
+    1469,  1470,  1475,  1476,  1477,  1478,  1479,  1480,  1485,  1504,
+    1518,  1519,  1520,  1532,  1552,  1576,  1577,  1578,  1578,  1579,
+    1579,  1580,  1580,  1581,  1581,  1586,  1601,  1602,  1603,  1604,
+    1615,  1616,  1621,  1622,  1623,  1623,  1624,  1624,  1625,  1625,
+    1630,  1631,  1631,  1632,  1632,  1637,  1638,  1648,  1661,  1661,
+    1662,  1662,  1667,  1668,  1673,  1674,  1674,  1675,  1675,  1676,
+    1676,  1681,  1682,  1682,  1683,  1683,  1688,  1689,  1690,  1699,
+    1699,  1700,  1700,  1701,  1701,  1706,  1723,  1724,  1725,  1725,
+    1726,  1726,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
+    1739,  1740,  1741,  1742,  1743,  1748,  1749,  1749,  1750,  1750,
+    1755,  1756,  1756,  1757,  1757,  1762,  1763,  1775,  1785,  1794,
+    1807,  1808
 };
 #endif
 
@@ -936,30 +949,47 @@ static const yytype_uint16 yyrline[] =
 static const char *const yytname[] =
 {
   "$end", "error", "$undefined", "NUMBER", "STRING", "IF", "ELSIF",
-  "ELSE", "REJCT", "FILEINTO", "REDIRECT", "KEEP", "STOP", "DISCARD",
-  "VACATION", "REQUIRE", "MARK", "UNMARK", "FLAGS", "NOTIFY", "DENOTIFY",
-  "ANYOF", "ALLOF", "EXISTS", "SFALSE", "STRUE", "HEADER", "NOT", "SIZE",
-  "ADDRESS", "ENVELOPE", "BODY", "COMPARATOR", "IS", "CONTAINS", "MATCHES",
-  "REGEX", "COUNT", "VALUE", "OVER", "UNDER", "GT", "GE", "LT", "LE", "EQ",
-  "NE", "ALL", "LOCALPART", "DOMAIN", "USER", "DETAIL", "RAW", "TEXT",
-  "CONTENT", "DAYS", "ADDRESSES", "SUBJECT", "FROM", "HANDLE", "MIME",
-  "SECONDS", "METHOD", "ID", "OPTIONS", "LOW", "NORMAL", "HIGH", "ANY",
-  "MESSAGE", "INCLUDE", "PERSONAL", "GLOBAL", "RETURN", "OPTIONAL", "ONCE",
-  "COPY", "DATE", "CURRENTDATE", "INDEX", "LAST", "ZONE", "ORIGINALZONE",
-  "MAILBOXEXISTS", "CREATE", "METADATA", "METADATAEXISTS",
-  "SERVERMETADATA", "SERVERMETADATAEXISTS", "YEAR", "MONTH", "DAY",
-  "JULIAN", "HOUR", "MINUTE", "SECOND", "TIME", "ISO8601", "STD11",
-  "WEEKDAY", "STRINGT", "SET", "LOWER", "UPPER", "LOWERFIRST",
-  "UPPERFIRST", "QUOTEWILDCARD", "LENGTH", "SETFLAG", "ADDFLAG",
-  "REMOVEFLAG", "HASFLAG", "';'", "'['", "']'", "','", "'{'", "'}'", "'('",
-  "')'", "$accept", "start", "reqs", "require", "commands", "command",
-  "elsif", "action", "flagaction", "flagtags", "stags", "mod40", "mod30",
-  "mod20", "mod10", "itags", "ntags", "dtags", "priority", "vtags",
-  "stringlist", "strings", "block", "test", "atags", "etags", "matchtags",
-  "comparator", "idxtags", "htags", "strtags", "hftags", "mtags", "btags",
-  "dttags", "cdtags", "zone", "datepart", "addrparttag", "match",
-  "relmatch", "sizetag", "copy", "creat", "ftags", "rtags", "testlist",
-  "tests", YY_NULLPTR
+  "ELSE", "REQUIRE", "STOP", "DISCARD", "KEEP", "FILEINTO", "REDIRECT",
+  "ANYOF", "ALLOF", "EXISTS", "NOT", "SFALSE", "STRUE", "SIZE", "HEADERT",
+  "ADDRESS", "ENVELOPE", "COMPARATOR", "OVER", "UNDER", "ALL", "LOCALPART",
+  "DOMAIN", "IS", "CONTAINS", "MATCHES", "OCTET", "ASCIICASEMAP",
+  "ASCIINUMERIC", "REGEX", "QUOTEREGEX", "COPY", "BODY", "RAW", "TEXT",
+  "CONTENT", "ENVIRONMENT", "STRINGT", "SET", "LOWER", "UPPER",
+  "LOWERFIRST", "UPPERFIRST", "QUOTEWILDCARD", "LENGTH", "VACATION",
+  "DAYS", "SUBJECT", "FROM", "ADDRESSES", "MIME", "HANDLE", "SECONDS",
+  "COUNT", "VALUE", "GT", "GE", "LT", "LE", "EQ", "NE", "FLAGS", "HASFLAG",
+  "SETFLAG", "ADDFLAG", "REMOVEFLAG", "MARK", "UNMARK", "USER", "DETAIL",
+  "DATE", "CURRENTDATE", "ORIGINALZONE", "ZONE", "TIMEZONE", "YEARP",
+  "MONTHP", "DAYP", "DATEP", "JULIAN", "HOURP", "MINUTEP", "SECONDP",
+  "TIMEP", "ISO8601", "STD11", "ZONEP", "WEEKDAYP", "INDEX", "LAST",
+  "ADDHEADER", "DELETEHEADER", "REJCT", "EREJECT", "METHOD", "OPTIONS",
+  "MESSAGE", "IMPORTANCE", "VALIDNOTIFYMETHOD", "NOTIFYMETHODCAPABILITY",
+  "NOTIFY", "ENOTIFY", "ENCODEURL", "DENOTIFY", "ID", "ANY", "LOW",
+  "NORMAL", "HIGH", "IHAVE", "ERROR", "MAILBOXEXISTS", "CREATE",
+  "METADATA", "METADATAEXISTS", "SERVERMETADATA", "SERVERMETADATAEXISTS",
+  "BYTIMEREL", "BYTIMEABS", "BYMODE", "BYTRACE", "DSNNOTIFY", "DSNRET",
+  "VALIDEXTLIST", "LIST", "INCLUDE", "OPTIONAL", "ONCE", "RETURN",
+  "PERSONAL", "GLOBAL", "DUPLICATE", "HEADER", "UNIQUEID",
+  "SPECIALUSEEXISTS", "SPECIALUSE", "FCC", "MAILBOXID", "MAILBOXIDEXISTS",
+  "LOG", "JMAPQUERY", "SNOOZE", "MAILBOX", "ADDFLAGS", "REMOVEFLAGS",
+  "WEEKDAYS", "';'", "'['", "']'", "','", "'{'", "'}'", "'('", "')'",
+  "$accept", "start", "reqs", "commands", "command", "optstringlist",
+  "stringlist", "strings", "string1", "string", "require", "control",
+  "thenelse", "elsif", "block", "action", "ktags", "flags", "ftags",
+  "copy", "create", "specialuse", "mailboxid", "rtags", "delbytags",
+  "dsntags", "stags", "mod40", "mod30", "mod20", "mod15", "mod10", "vtags",
+  "fcctags", "flagaction", "flagtags", "flagmark", "ahtags", "dhtags",
+  "$@1", "$@2", "$@3", "$@4", "reject", "ntags", "priority", "dtags",
+  "$@5", "itags", "location", "sntags", "weekdaylist", "weekdays",
+  "weekday", "timelist", "times", "time1", "time", "testlist", "tests",
+  "test", "$@6", "sizetag", "htags", "$@7", "$@8", "$@9", "$@10",
+  "matchtype", "matchtag", "relmatch", "relation", "listmatch",
+  "comparator", "collation", "idxtags", "atags", "$@11", "$@12", "$@13",
+  "$@14", "addrpart", "addrparttag", "subaddress", "etags", "$@15", "$@16",
+  "$@17", "envtags", "$@18", "$@19", "btags", "$@20", "$@21", "transform",
+  "strtags", "$@22", "$@23", "$@24", "hftags", "$@25", "$@26", "dttags",
+  "$@27", "$@28", "$@29", "zone", "cdtags", "$@30", "$@31", "datepart",
+  "methtags", "$@32", "$@33", "mtags", "$@34", "$@35", "duptags", "idtype", YY_NULLPTR
 };
 #endif
 
@@ -979,16 +1009,21 @@ static const yytype_uint16 yytoknum[] =
      335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
-     365,   366,    59,    91,    93,    44,   123,   125,    40,    41
+     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
+     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
+     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
+     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
+     405,   406,   407,    59,    91,    93,    44,   123,   125,    40,
+      41
 };
 # endif
 
-#define YYPACT_NINF -199
+#define YYPACT_NINF -346
 
 #define yypact_value_is_default(Yystate) \
-  (!!((Yystate) == (-199)))
+  (!!((Yystate) == (-346)))
 
-#define YYTABLE_NINF -73
+#define YYTABLE_NINF -314
 
 #define yytable_value_is_error(Yytable_value) \
   0
@@ -997,83 +1032,135 @@ static const yytype_uint16 yytoknum[] =
      STATE-NUM.  */
 static const yytype_int16 yypact[] =
 {
-      -9,    -2,    13,   195,    -9,  -199,    20,   -82,  -199,   -75,
-     140,    29,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,
-    -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,     9,
-     -72,  -199,  -199,  -199,   -79,  -199,  -199,  -199,   -76,   -76,
-      -2,  -199,  -199,  -199,   140,     7,  -199,  -199,  -199,  -199,
-    -199,    -2,  -199,    47,  -199,    -2,  -199,  -199,   -64,  -199,
-      23,     1,    -3,   297,   350,   301,   245,   176,  -199,  -199,
-      -1,  -199,    51,   140,  -199,  -199,  -199,   220,  -199,  -199,
-    -199,    53,   197,   237,    68,   293,    28,  -199,   308,    -2,
-     344,  -199,   257,   257,    75,    42,  -199,    -2,  -199,  -199,
-    -199,  -199,  -199,  -199,  -199,    54,    -2,    55,    64,    66,
-    -199,    71,    67,    74,    -2,  -199,  -199,  -199,    86,  -199,
-    -199,  -199,  -199,  -199,  -199,  -199,  -199,    89,  -199,    92,
-    -199,  -199,  -199,  -199,  -199,    93,  -199,  -199,  -199,  -199,
-    -199,  -199,  -199,  -199,  -199,  -199,   -14,  -199,  -199,    -7,
-      -6,   110,   113,  -199,    -2,  -199,  -199,  -199,  -199,  -199,
-    -199,  -199,  -199,  -199,    -2,  -199,  -199,  -199,  -199,    -2,
-    -199,  -199,  -199,  -199,  -199,    -2,  -199,  -199,  -199,   119,
-     120,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,
-      -2,   123,  -199,  -199,  -199,    -2,    -2,  -199,  -199,    -2,
-    -199,  -199,  -199,    11,   140,   -64,  -199,  -199,  -199,  -199,
-    -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,
-    -199,   140,  -199,  -199,  -199,  -199,  -199,  -199,  -199,    -2,
-    -199,  -199,    -2,  -199,  -199,  -199,  -199,   -64,  -199,  -199,
-    -199,  -199,    42,  -199
+      29,     1,    13,   430,    29,  -346,    38,  -109,  -346,  -346,
+    -346,  -102,   495,   -80,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,    38,  -346,  -346,    38,  -346,  -346,   270,  -346,   -77,
+    -346,  -346,    38,  -346,   -87,  -346,  -346,  -346,  -346,   -81,
+     -81,     1,   495,  -346,  -346,    76,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,     1,  -346,     1,     1,  -346,
+      38,  -346,     1,     1,  -346,     1,     1,    38,  -346,   -76,
+    -346,    17,    45,   105,   360,   253,     0,     2,   148,   -22,
+     -49,    62,  -346,    23,  -346,  -346,     1,  -346,  -346,    38,
+     495,  -346,  -346,  -346,  -346,  -346,  -346,   104,    -1,     4,
+      11,     6,    37,     5,    30,    32,   561,  -346,    48,  -346,
+    -346,    66,     1,    66,  -346,  -346,   160,  -346,     1,  -346,
+    -346,   349,   119,     1,  -346,  -346,  -346,    38,    38,  -346,
+    -346,  -346,  -346,  -346,  -346,   111,    38,    38,  -346,    38,
+      38,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,    38,  -346,  -346,  -346,  -346,  -346,
+     120,    38,    38,     1,  -346,    38,   134,    38,  -346,  -346,
+    -346,  -346,  -346,  -346,    38,     1,   108,    35,   137,    51,
+      38,    38,     1,    38,   -95,    38,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,   108,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,    38,     1,     1,     3,   174,  -346,  -346,  -346,
+    -346,  -346,    28,  -346,    25,    44,  -346,     1,   108,    35,
+     137,    51,  -346,  -346,  -346,  -346,  -346,     1,   108,    35,
+     137,    51,  -346,  -346,  -346,     1,  -346,   108,    35,   137,
+    -346,  -346,     1,  -346,   108,   137,  -346,     1,   108,   137,
+       1,   108,    35,   137,     1,   108,   137,  -346,   107,  -346,
+     108,   137,    51,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,   108,   137,
+       1,    38,   108,   137,    38,   108,   137,  -346,     1,    38,
+     190,  -346,  -346,  -346,    38,  -346,  -346,    49,   495,   -76,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,   222,  -346,
+    -346,   157,  -346,   199,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,    38,  -346,  -346,  -346,  -346,   216,  -346,  -346,
+      -6,  -346,  -346,   495,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,   616,  -346,  -346,  -346,  -346,  -346,  -346,     1,
+    -346,  -346,     1,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,    56,  -346,  -346,   174,  -346,
+       1,  -346,  -346,  -346,   216,  -346,  -346,  -346
 };
 
   /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
      Performed when YYTABLE does not specify something else to do.  Zero
      means the default is an error.  */
-static const yytype_uint8 yydefact[] =
+static const yytype_uint16 yydefact[] =
 {
-       4,     0,     0,     0,     4,    72,     0,     0,     1,     0,
-       0,     0,   159,   163,   159,    19,    20,    63,    23,    24,
-      51,    57,    46,    28,    35,    31,    30,    32,     3,     0,
-       0,    33,     5,    73,     0,     6,    11,    98,     0,     0,
-       0,    80,    81,   113,     0,     0,    99,   104,   126,   132,
-     138,     0,   123,     0,   123,     0,   117,   120,     0,    15,
-       0,     0,    18,     0,    25,    26,     0,     0,     8,     9,
-       0,    71,     0,     0,    77,    78,    79,     0,    89,   155,
-     156,     0,     0,     0,     0,     0,     0,    93,     0,     0,
-       0,    97,     0,     0,     0,    12,    16,     0,   157,   158,
-     160,   161,    17,   164,    21,     0,     0,     0,     0,     0,
-      70,     0,     0,     0,     0,    60,    61,    62,     0,    55,
-     149,   150,   151,   152,   153,   154,    58,     0,   108,     0,
-      27,    47,    48,    50,    49,     0,    40,    41,    42,    43,
-      44,    45,    36,    37,    38,    39,    34,    22,    74,   166,
-       0,     0,     0,   112,     0,   114,   115,   116,    90,   144,
-     145,   146,   147,   148,     0,   101,   102,   103,   100,     0,
-     106,   107,   105,   127,   128,     0,    88,   130,   131,     0,
-       0,   133,   135,   136,   137,   134,   143,   140,   141,   139,
-       0,     0,   124,   125,    95,     0,     0,   118,   119,    85,
-     121,   122,    76,     0,     0,     0,    10,   162,    64,    66,
-      67,    68,    69,    65,    53,    52,    54,    56,    59,   109,
-      29,     0,   165,   110,   111,    82,    86,    87,   129,     0,
-     142,    92,     0,    96,    83,    84,    75,     0,    14,   167,
-      91,    94,    12,    13
+       4,     0,     0,     0,     4,    18,     0,     0,    13,    17,
+       1,     0,     0,     0,    32,    47,    50,    60,    71,    85,
+      98,    99,   100,   103,   104,   105,   107,   116,   117,   118,
+     130,     0,   134,    46,     0,   140,     3,     0,     8,     0,
+     101,    36,     0,     5,     0,    15,    19,    10,   192,     0,
+       0,     0,     0,   163,   164,     0,   195,   225,   242,   255,
+     250,   264,   271,   276,   286,     0,   305,     0,     0,   310,
+       0,   310,     0,     0,   315,     0,     0,     0,    20,     0,
+      21,    29,     0,     0,     0,     0,     0,   108,    41,   132,
+       0,     0,    44,     0,     7,     9,     0,    39,    14,     0,
+       0,   160,   161,   165,   162,   193,   194,     0,   196,   227,
+     244,   258,   251,   265,   272,   279,   288,   178,   306,   180,
+     181,   311,     0,   311,   185,   186,   187,   188,    17,   190,
+     191,     0,    24,     0,    48,    56,    57,     0,     0,    30,
+      52,    51,    53,    54,    55,     0,     0,     0,    68,     0,
+       0,    62,    31,    61,    63,    64,    82,    77,    78,    79,
+      80,    81,    84,    83,     0,    72,    73,    74,    75,    76,
+       0,     0,     0,     0,    91,     0,     0,     0,    34,    96,
+      95,    97,    93,   106,     0,    11,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,   127,   128,   129,    40,
+     121,   124,   131,     0,    22,   137,   136,   138,   139,    43,
+     135,   156,     0,     0,     0,     0,     0,   142,    45,   151,
+     155,    35,   102,    16,     0,   158,   166,     0,     0,     0,
+       0,     0,   236,   237,   238,   240,   241,     0,     0,     0,
+       0,     0,   226,   235,   239,     0,   243,     0,     0,     0,
+     262,   263,     0,   170,     0,     0,   256,     0,     0,     0,
+       0,     0,     0,     0,   174,     0,     0,   278,     0,   175,
+       0,     0,     0,   277,   292,   293,   294,   295,   296,   297,
+     298,   299,   300,   301,   302,   303,   304,   287,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,   183,     0,     0,
+       0,   319,   320,   321,     0,   189,    28,     0,     0,     0,
+      23,    49,    58,    59,    65,    66,    67,    69,    70,    33,
+      86,    88,    89,    90,    92,    87,    94,    37,    38,    12,
+     206,   207,   208,   209,   210,   211,   109,   204,     0,   218,
+     111,     0,   113,     0,   224,   115,   119,   123,   126,   125,
+     120,   122,     0,   141,   143,   144,   150,     0,   145,   146,
+       0,   153,   157,     0,   167,   197,   199,   201,   203,   168,
+     228,   230,   232,   234,   169,   245,   247,   249,   257,   259,
+     261,   171,   252,   254,   172,   266,   268,   270,   173,   273,
+     275,   285,     0,   280,   282,   284,   289,   291,   177,     0,
+     307,   309,     0,   312,   314,   184,   317,   318,   316,    27,
+      25,    26,   214,   215,   216,   217,   212,   213,   205,   220,
+     221,   222,   219,   223,   133,     0,   148,   152,     0,   159,
+       0,   179,   182,   147,     0,   154,   176,   149
 };
 
   /* YYPGOTO[NTERM-NUM].  */
 static const yytype_int16 yypgoto[] =
 {
-    -199,  -199,   125,  -199,   -25,  -199,  -111,  -199,  -199,  -199,
-    -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,    69,  -199,
-     -39,  -199,  -198,   -10,  -199,  -199,   306,   318,   -74,  -199,
-    -199,  -199,    78,  -199,  -199,  -199,    49,   -46,    56,  -199,
-    -199,  -199,    76,  -199,   124,  -199,   101,   -78
+    -346,  -346,   217,   -26,  -346,  -346,   -51,  -346,   219,    33,
+    -346,  -346,   -86,  -346,   -82,  -346,  -346,   133,  -346,   152,
+     155,   156,   147,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,   153,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,   -88,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -345,  -346,  -346,    26,  -185,   194,  -117,
+     -50,  -346,  -346,  -346,  -346,  -346,  -346,  -346,   332,  -346,
+    -346,  -346,  -174,   426,  -346,  -188,  -346,  -346,  -346,  -346,
+    -346,   138,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
+    -346,  -346,  -346,  -346,  -346,  -346,   139,  -346,  -346,  -346,
+    -139,  -346,  -346,  -346,   183,  -346,  -346,  -346,  -346
 };
 
   /* YYDEFGOTO[NTERM-NUM].  */
 static const yytype_int16 yydefgoto[] =
 {
-      -1,     2,     3,     4,    28,    29,   206,    30,    31,    70,
-      67,   142,   143,   144,   145,    66,    64,    65,   119,    63,
-       7,    34,    95,   149,    82,    83,   192,   193,   157,    77,
-      92,    93,    88,    84,    85,    86,   185,   190,   168,   128,
-     129,    81,   100,   101,    60,    61,    74,   150
+      -1,     2,     3,    36,    37,   328,     7,    44,     8,     9,
+       4,    38,    78,   310,   132,    39,    81,   179,    82,   141,
+     180,   181,   144,    83,   154,   155,    84,   165,   166,   167,
+     168,   169,    85,   182,    40,    96,    41,    86,    87,   186,
+     187,   188,   189,    42,    88,   201,    89,   203,    91,   210,
+      93,   358,   425,   359,   218,   360,   219,   220,   101,   224,
+      79,   392,   107,   108,   228,   229,   230,   231,   336,   337,
+     338,   418,   340,   342,   422,   345,   109,   238,   239,   240,
+     241,   242,   243,   244,   110,   247,   248,   249,   112,   258,
+     259,   111,   254,   255,   256,   113,   261,   262,   263,   114,
+     265,   266,   115,   270,   271,   272,   273,   116,   288,   289,
+     290,   118,   292,   293,   121,   295,   296,   126,   304
 };
 
   /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
@@ -1081,169 +1168,282 @@ static const yytype_int16 yydefgoto[] =
      number is the opposite.  If YYTABLE_NINF, syntax error.  */
 static const yytype_int16 yytable[] =
 {
-      58,    76,     5,   146,    68,   102,     1,   238,   167,    -7,
-       9,   184,    87,     8,    10,    97,    91,    11,    12,    13,
-      14,    15,    16,    17,    33,    18,    19,    96,    20,    21,
-      35,   147,   186,    59,    78,    71,    72,    36,   154,   242,
-      69,    97,    73,   164,   169,   176,    79,    80,   204,   205,
-     194,    89,    94,   196,   199,   148,   158,   208,   207,   210,
-     151,   120,   121,   122,   123,   124,   125,   209,   211,   203,
-     212,   214,     5,    98,   213,   216,     9,    98,   215,    22,
-      10,    99,    23,    11,    12,    13,    14,    15,    16,    17,
-     217,    18,    19,   218,    20,    21,   219,   220,   -72,    98,
-     151,   120,   121,   122,   123,   124,   125,    99,   221,   180,
-      24,     6,     6,   222,   223,   225,   224,    25,    26,    27,
-     173,   174,   175,   186,   230,   226,    -7,   232,   236,    32,
-     227,   243,    90,   229,   126,   189,   228,   103,    62,   172,
-      75,    37,     0,   239,     0,    22,     0,     0,    23,     0,
-       0,   231,     0,     0,     0,     0,   233,   234,     0,     0,
-     235,    38,    39,    40,    41,    42,    43,    44,    45,    46,
-      47,    48,     0,     0,     0,     0,    24,     0,     0,     0,
-     135,     6,     0,    25,    26,    27,     0,     0,     0,     0,
-     240,     0,   202,   241,   237,    -2,     9,     0,     0,     0,
-      10,     5,     0,    11,    12,    13,    14,    15,    16,    17,
-       0,    18,    19,     0,    20,    21,     0,    49,    50,     0,
-       0,     0,     0,    51,     5,    52,    53,    54,    55,   151,
-     120,   121,   122,   123,   124,   125,     0,     0,     0,     0,
-      56,     5,     0,     0,   159,   160,   161,   162,   163,   130,
-       0,    57,   151,   120,   121,   122,   123,   124,   125,     0,
-       0,     5,     0,     0,     0,    22,     0,     0,    23,   151,
-     120,   121,   122,   123,   124,   125,   152,   153,   136,   137,
-     138,   139,   140,   141,   159,   160,   161,   162,   163,   151,
-     120,   121,   122,   123,   124,   125,    24,   179,     0,   152,
-     153,   104,     0,    25,    26,    27,     0,     0,     0,     0,
-       6,     0,   191,     0,     0,     0,   131,   132,     0,   133,
-     134,     0,     0,     0,     0,   151,   120,   121,   122,   123,
-     124,   125,     0,     6,   120,   121,   122,   123,   124,   125,
-     151,   120,   121,   122,   123,   124,   125,     0,   195,     0,
-       6,     0,   105,   106,   107,   108,   109,   110,   111,     0,
-       0,     0,     0,     0,     0,     0,   115,   116,   117,     0,
-       6,   127,   152,   153,   180,   181,   151,   120,   121,   122,
-     123,   124,   125,   155,     0,     0,     0,     0,   165,   170,
-     177,   182,   187,     0,     0,   156,     0,     0,   197,   200,
-     166,   171,   178,   183,   188,     0,     0,     0,     0,     0,
-     198,   201,   112,   113,   114,   115,   116,   117,     0,   118
+     103,   202,   104,     5,     5,     5,     5,   356,     5,     5,
+       5,    94,   426,    10,   117,     5,   119,   120,   196,   197,
+     198,   124,   125,  -200,   127,   129,  -112,   211,  -231,  -269,
+    -260,   232,   233,   234,     5,  -248,     5,     1,   232,   233,
+     234,     5,     5,   368,    46,   221,   250,   251,   252,     5,
+     225,    47,     5,   373,  -274,   366,  -281,   227,   237,   245,
+     253,  -253,   260,   264,    90,   371,     5,    92,    98,    99,
+       5,   297,  -308,    80,   376,    97,    95,   305,   100,   235,
+     236,   131,   311,   135,   395,   133,   235,   236,   386,   437,
+    -313,   196,   197,   198,  -202,  -202,   183,  -114,  -114,  -233,
+    -233,   105,   106,   122,   204,   307,   350,   226,   128,     5,
+     130,   267,   268,   133,   314,   139,   152,   164,   178,   184,
+     185,   199,   323,   320,   209,   308,   309,  -283,  -283,   222,
+    -198,   -42,   223,  -110,   329,  -229,  -267,   325,   330,   331,
+     332,   348,  -246,   135,   333,   257,   343,   344,   269,   427,
+     428,   291,     5,     6,   294,     6,   298,   357,     6,     6,
+       6,   341,   354,   355,   136,     6,   339,   138,   334,   335,
+     312,   313,   212,   213,   214,   215,   364,   216,   211,   315,
+     316,   -17,   317,   318,     6,   362,   369,   137,   391,   138,
+     419,   420,   421,   407,   374,   205,   206,   319,   207,   208,
+     363,   378,   423,   190,   321,   322,   381,   409,   324,   384,
+     326,   433,   434,   388,   134,   140,   133,   327,   299,   300,
+     356,    43,   410,   346,   347,    45,   349,   411,   351,   145,
+     146,   147,   148,   149,   150,   153,   151,   142,   143,   398,
+     217,   200,   361,   435,   102,   353,   429,   405,   246,   191,
+     192,   193,   194,   430,   123,   287,   301,     5,     0,   195,
+       0,   196,   197,   198,     0,     0,     0,   136,     0,     0,
+      -6,    11,     0,     0,     0,    12,     0,     0,     0,    13,
+      14,    15,    16,    17,   412,   413,   414,   415,   416,   417,
+     137,   177,     0,     0,     0,     0,     0,     0,     0,   302,
+     303,     0,     0,     0,     0,     0,   170,   171,   172,   173,
+     174,   175,   176,   225,     0,    18,     0,     0,     0,     0,
+       0,   133,    19,     0,   399,     0,     0,   402,     0,     0,
+       0,     0,   406,     0,     0,     0,     0,   408,     0,     0,
+      20,    21,    22,    23,    24,     0,     0,     0,   431,     0,
+      11,   432,     0,     0,    12,     0,     0,     0,    13,    14,
+      15,    16,    17,     0,     5,     0,     0,    25,    26,    27,
+      28,     0,   136,     0,     0,     0,     0,    29,     0,   436,
+      30,     0,     0,     0,     0,   424,     0,    31,     0,     0,
+       0,     0,     0,     0,    18,   137,   177,   156,     0,     0,
+       0,    19,    32,     0,     0,    33,   157,   158,   159,   160,
+     161,   162,     0,     0,     0,     0,    34,     0,    35,    20,
+      21,    22,    23,    24,     0,     0,     0,     0,    -6,     0,
+      -2,    11,     0,     0,     0,    12,     0,     0,     0,    13,
+      14,    15,    16,    17,     0,     0,    25,    26,    27,    28,
+       0,     0,     0,     0,     0,     0,    29,     0,     0,    30,
+       0,     0,     0,     0,     0,     0,    31,     0,     0,   163,
+       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
+       0,    32,    19,     0,    33,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,    34,    48,    35,     0,     0,
+      20,    21,    22,    23,    24,     0,     0,   306,     0,    49,
+      50,    51,    52,    53,    54,    55,    56,    57,    58,     0,
+       0,     0,     0,     0,     0,     0,     0,    25,    26,    27,
+      28,     0,     0,     0,    59,   352,     0,    29,    60,    61,
+      30,     0,     0,     0,     0,     0,     0,    31,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+     365,     0,    32,     0,    62,    33,     0,     0,     0,     0,
+     370,     0,    63,    64,     0,     0,    34,     0,    35,   375,
+       0,     0,     0,     0,     0,  -290,   379,     0,     0,     0,
+     382,     0,     0,   385,     0,     0,     0,   389,     0,     0,
+      65,    66,   393,     0,     0,     0,     0,     0,     0,     0,
+       0,    67,     0,    68,     0,    69,    70,    71,    72,     0,
+     396,     0,     0,     0,   400,    73,     0,   403,     0,     0,
+       0,     0,     0,    74,     0,     0,    75,     0,     0,     0,
+      76,   268,    77,   274,   275,   276,   277,   278,   279,   280,
+     281,   282,   283,   284,   285,   286,   367,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,   372,     0,     0,     0,
+       0,     0,     0,     0,     0,   377,     0,     0,     0,     0,
+       0,   380,     0,     0,     0,   383,     0,     0,     0,   387,
+       0,     0,   390,     0,     0,     0,     0,   394,   274,   275,
+     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
+     286,     0,     0,     0,     0,   397,     0,     0,     0,   401,
+       0,     0,   404
 };
 
 static const yytype_int16 yycheck[] =
 {
-      10,    40,     4,     4,    29,     4,    15,   205,    82,     0,
-       1,    85,    51,     0,     5,    18,    55,     8,     9,    10,
-      11,    12,    13,    14,     4,    16,    17,     4,    19,    20,
-     112,    70,     4,     4,    44,   114,   115,   112,    77,   237,
-     112,    18,   118,    82,    83,    84,    39,    40,     6,     7,
-      89,     4,   116,    92,    93,     4,     3,     3,    97,     4,
-      32,    33,    34,    35,    36,    37,    38,   106,     4,    94,
-       4,     4,     4,    76,     3,   114,     1,    76,     4,    70,
-       5,    84,    73,     8,     9,    10,    11,    12,    13,    14,
-       4,    16,    17,     4,    19,    20,     4,     4,   112,    76,
-      32,    33,    34,    35,    36,    37,    38,    84,   115,    81,
-     101,   113,   113,   119,     4,   154,     3,   108,   109,   110,
-      52,    53,    54,     4,     4,   164,   117,     4,   117,     4,
-     169,   242,    54,   179,    65,    86,   175,    61,    14,    83,
-      39,     1,    -1,   221,    -1,    70,    -1,    -1,    73,    -1,
-      -1,   190,    -1,    -1,    -1,    -1,   195,   196,    -1,    -1,
-     199,    21,    22,    23,    24,    25,    26,    27,    28,    29,
-      30,    31,    -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,
-       4,   113,    -1,   108,   109,   110,    -1,    -1,    -1,    -1,
-     229,    -1,   117,   232,   204,     0,     1,    -1,    -1,    -1,
-       5,     4,    -1,     8,     9,    10,    11,    12,    13,    14,
-      -1,    16,    17,    -1,    19,    20,    -1,    77,    78,    -1,
-      -1,    -1,    -1,    83,     4,    85,    86,    87,    88,    32,
-      33,    34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,
-     100,     4,    -1,    -1,    47,    48,    49,    50,    51,     4,
-      -1,   111,    32,    33,    34,    35,    36,    37,    38,    -1,
-      -1,     4,    -1,    -1,    -1,    70,    -1,    -1,    73,    32,
-      33,    34,    35,    36,    37,    38,    79,    80,   102,   103,
-     104,   105,   106,   107,    47,    48,    49,    50,    51,    32,
-      33,    34,    35,    36,    37,    38,   101,     4,    -1,    79,
-      80,     4,    -1,   108,   109,   110,    -1,    -1,    -1,    -1,
-     113,    -1,     4,    -1,    -1,    -1,    71,    72,    -1,    74,
-      75,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
-      37,    38,    -1,   113,    33,    34,    35,    36,    37,    38,
-      32,    33,    34,    35,    36,    37,    38,    -1,     4,    -1,
-     113,    -1,    55,    56,    57,    58,    59,    60,    61,    -1,
-      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    67,    -1,
-     113,    65,    79,    80,    81,    82,    32,    33,    34,    35,
-      36,    37,    38,    77,    -1,    -1,    -1,    -1,    82,    83,
-      84,    85,    86,    -1,    -1,    77,    -1,    -1,    92,    93,
-      82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,
-      92,    93,    62,    63,    64,    65,    66,    67,    -1,    69
+      51,    89,    52,     4,     4,     4,     4,     4,     4,     4,
+       4,    37,   357,     0,    65,     4,    67,    68,   113,   114,
+     115,    72,    73,    24,    75,    76,    24,     4,    24,    24,
+      24,    27,    28,    29,     4,    24,     4,     8,    27,    28,
+      29,     4,     4,   231,   153,    96,    40,    41,    42,     4,
+     100,   153,     4,   241,    24,   229,    24,   108,   109,   110,
+     111,    24,   113,   114,    31,   239,     4,    34,   155,   156,
+       4,   122,    24,   153,   248,    42,   153,   128,   159,    75,
+      76,   157,   133,    38,   272,    68,    75,    76,   262,   434,
+      24,   113,   114,   115,    95,    96,    96,    95,    96,    95,
+      96,    25,    26,    70,   153,   131,   194,     3,    75,     4,
+      77,    79,    80,    68,     3,    82,    83,    84,    85,    86,
+      87,    88,   173,     3,    91,     6,     7,    95,    96,    96,
+     131,   153,    99,   131,   185,   131,   131,     3,    30,    31,
+      32,   192,   131,    38,    36,   112,    95,    96,   115,   155,
+     156,   118,     4,   154,   121,   154,   123,   154,   154,   154,
+     154,    24,   213,   214,   119,   154,   131,   144,    60,    61,
+     137,   138,   149,   150,   151,   152,   227,   154,     4,   146,
+     147,   153,   149,   150,   154,   160,   237,   142,    81,   144,
+      33,    34,    35,     3,   245,   133,   134,   164,   136,   137,
+     156,   252,     3,    55,   171,   172,   257,   158,   175,   260,
+     177,   155,   156,   264,    81,    82,    68,   184,    58,    59,
+       4,     4,   308,   190,   191,     6,   193,   309,   195,   124,
+     125,   126,   127,   128,   129,    83,   131,    82,    82,   290,
+      93,    88,   216,   428,    50,   212,   363,   298,   110,   101,
+     102,   103,   104,   392,    71,   116,    96,     4,    -1,   111,
+      -1,   113,   114,   115,    -1,    -1,    -1,   119,    -1,    -1,
+       0,     1,    -1,    -1,    -1,     5,    -1,    -1,    -1,     9,
+      10,    11,    12,    13,    62,    63,    64,    65,    66,    67,
+     142,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
+     140,    -1,    -1,    -1,    -1,    -1,    53,    54,    55,    56,
+      57,    58,    59,   363,    -1,    45,    -1,    -1,    -1,    -1,
+      -1,    68,    52,    -1,   291,    -1,    -1,   294,    -1,    -1,
+      -1,    -1,   299,    -1,    -1,    -1,    -1,   304,    -1,    -1,
+      70,    71,    72,    73,    74,    -1,    -1,    -1,   399,    -1,
+       1,   402,    -1,    -1,     5,    -1,    -1,    -1,     9,    10,
+      11,    12,    13,    -1,     4,    -1,    -1,    97,    98,    99,
+     100,    -1,   119,    -1,    -1,    -1,    -1,   107,    -1,   430,
+     110,    -1,    -1,    -1,    -1,   352,    -1,   117,    -1,    -1,
+      -1,    -1,    -1,    -1,    45,   142,   143,    37,    -1,    -1,
+      -1,    52,   132,    -1,    -1,   135,    46,    47,    48,    49,
+      50,    51,    -1,    -1,    -1,    -1,   146,    -1,   148,    70,
+      71,    72,    73,    74,    -1,    -1,    -1,    -1,   158,    -1,
+       0,     1,    -1,    -1,    -1,     5,    -1,    -1,    -1,     9,
+      10,    11,    12,    13,    -1,    -1,    97,    98,    99,   100,
+      -1,    -1,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,
+      -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,   109,
+      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
+      -1,   132,    52,    -1,   135,    -1,    -1,    -1,    -1,    -1,
+      -1,    -1,    -1,    -1,    -1,   146,     1,   148,    -1,    -1,
+      70,    71,    72,    73,    74,    -1,    -1,   158,    -1,    14,
+      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
+      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,
+     100,    -1,    -1,    -1,    39,   203,    -1,   107,    43,    44,
+     110,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
+      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
+     228,    -1,   132,    -1,    69,   135,    -1,    -1,    -1,    -1,
+     238,    -1,    77,    78,    -1,    -1,   146,    -1,   148,   247,
+      -1,    -1,    -1,    -1,    -1,    24,   254,    -1,    -1,    -1,
+     258,    -1,    -1,   261,    -1,    -1,    -1,   265,    -1,    -1,
+     105,   106,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
+      -1,   116,    -1,   118,    -1,   120,   121,   122,   123,    -1,
+     288,    -1,    -1,    -1,   292,   130,    -1,   295,    -1,    -1,
+      -1,    -1,    -1,   138,    -1,    -1,   141,    -1,    -1,    -1,
+     145,    80,   147,    82,    83,    84,    85,    86,    87,    88,
+      89,    90,    91,    92,    93,    94,   230,    -1,    -1,    -1,
+      -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,
+      -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,
+      -1,   255,    -1,    -1,    -1,   259,    -1,    -1,    -1,   263,
+      -1,    -1,   266,    -1,    -1,    -1,    -1,   271,    82,    83,
+      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
+      94,    -1,    -1,    -1,    -1,   289,    -1,    -1,    -1,   293,
+      -1,    -1,   296
 };
 
   /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
      symbol of state STATE-NUM.  */
-static const yytype_uint8 yystos[] =
+static const yytype_uint16 yystos[] =
 {
-       0,    15,   121,   122,   123,     4,   113,   140,     0,     1,
-       5,     8,     9,    10,    11,    12,    13,    14,    16,    17,
-      19,    20,    70,    73,   101,   108,   109,   110,   124,   125,
-     127,   128,   122,     4,   141,   112,   112,     1,    21,    22,
-      23,    24,    25,    26,    27,    28,    29,    30,    31,    77,
-      78,    83,    85,    86,    87,    88,   100,   111,   143,     4,
-     164,   165,   164,   139,   136,   137,   135,   130,   124,   112,
-     129,   114,   115,   118,   166,   166,   140,   149,   143,    39,
-      40,   161,   144,   145,   153,   154,   155,   140,   152,     4,
-     152,   140,   150,   151,   116,   142,     4,    18,    76,    84,
-     162,   163,     4,   162,     4,    55,    56,    57,    58,    59,
-      60,    61,    62,    63,    64,    65,    66,    67,    69,   138,
-      33,    34,    35,    36,    37,    38,   138,   146,   159,   160,
-       4,    71,    72,    74,    75,     4,   102,   103,   104,   105,
-     106,   107,   131,   132,   133,   134,     4,   140,     4,   143,
-     167,    32,    79,    80,   140,   146,   147,   148,     3,    47,
-      48,    49,    50,    51,   140,   146,   147,   148,   158,   140,
-     146,   147,   158,    52,    53,    54,   140,   146,   147,     4,
-      81,    82,   146,   147,   148,   156,     4,   146,   147,   156,
-     157,     4,   146,   147,   140,     4,   140,   146,   147,   140,
-     146,   147,   117,   124,     6,     7,   126,   140,     3,   140,
-       4,     4,     4,     3,     4,     4,   140,     4,     4,     4,
-       4,   115,   119,     4,     3,   140,   140,   140,   140,   157,
-       4,   140,     4,   140,   140,   140,   117,   143,   142,   167,
-     140,   140,   142,   126
+       0,     8,   162,   163,   171,     4,   154,   167,   169,   170,
+       0,     1,     5,     9,    10,    11,    12,    13,    45,    52,
+      70,    71,    72,    73,    74,    97,    98,    99,   100,   107,
+     110,   117,   132,   135,   146,   148,   164,   165,   172,   176,
+     195,   197,   204,   163,   168,   169,   153,   153,     1,    14,
+      15,    16,    17,    18,    19,    20,    21,    22,    23,    39,
+      43,    44,    69,    77,    78,   105,   106,   116,   118,   120,
+     121,   122,   123,   130,   138,   141,   145,   147,   173,   221,
+     153,   177,   179,   184,   187,   193,   198,   199,   205,   207,
+     170,   209,   170,   211,   164,   153,   196,   170,   155,   156,
+     159,   219,   219,   167,   221,    25,    26,   223,   224,   237,
+     245,   252,   249,   256,   260,   263,   268,   167,   272,   167,
+     167,   275,   170,   275,   167,   167,   278,   167,   170,   167,
+     170,   157,   175,    68,   178,    38,   119,   142,   144,   170,
+     178,   180,   181,   182,   183,   124,   125,   126,   127,   128,
+     129,   131,   170,   180,   185,   186,    37,    46,    47,    48,
+      49,    50,    51,   109,   170,   188,   189,   190,   191,   192,
+      53,    54,    55,    56,    57,    58,    59,   143,   170,   178,
+     181,   182,   194,    96,   170,   170,   200,   201,   202,   203,
+      55,   101,   102,   103,   104,   111,   113,   114,   115,   170,
+     194,   206,   206,   208,   153,   133,   134,   136,   137,   170,
+     210,     4,   149,   150,   151,   152,   154,   183,   215,   217,
+     218,   167,   170,   170,   220,   221,     3,   167,   225,   226,
+     227,   228,    27,    28,    29,    75,    76,   167,   238,   239,
+     240,   241,   242,   243,   244,   167,   242,   246,   247,   248,
+      40,    41,    42,   167,   253,   254,   255,   170,   250,   251,
+     167,   257,   258,   259,   167,   261,   262,    79,    80,   170,
+     264,   265,   266,   267,    82,    83,    84,    85,    86,    87,
+      88,    89,    90,    91,    92,    93,    94,   267,   269,   270,
+     271,   170,   273,   274,   170,   276,   277,   167,   170,    58,
+      59,    96,   139,   140,   279,   167,   158,   164,     6,     7,
+     174,   167,   170,   170,     3,   170,   170,   170,   170,   170,
+       3,   170,   170,   167,   170,     3,   170,   170,   166,   167,
+      30,    31,    32,    36,    60,    61,   229,   230,   231,   131,
+     233,    24,   234,    95,    96,   236,   170,   170,   167,   170,
+     206,   170,   229,   170,   167,   167,     4,   154,   212,   214,
+     216,   217,   160,   156,   167,   229,   233,   234,   236,   167,
+     229,   233,   234,   236,   167,   229,   233,   234,   167,   229,
+     234,   167,   229,   234,   167,   229,   233,   234,   167,   229,
+     234,    81,   222,   229,   234,   236,   229,   234,   167,   170,
+     229,   234,   170,   229,   234,   167,   170,     3,   170,   158,
+     173,   175,    62,    63,    64,    65,    66,    67,   232,    33,
+      34,    35,   235,     3,   170,   213,   214,   155,   156,   220,
+     271,   167,   167,   155,   156,   218,   167,   214
 };
 
   /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
-static const yytype_uint8 yyr1[] =
+static const yytype_uint16 yyr1[] =
 {
-       0,   120,   121,   121,   122,   122,   123,   124,   124,   125,
-     125,   125,   126,   126,   126,   127,   127,   127,   127,   127,
-     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
-     128,   128,   128,   129,   129,   130,   130,   130,   130,   130,
-     131,   131,   132,   132,   133,   134,   135,   135,   135,   135,
-     135,   136,   136,   136,   136,   136,   136,   137,   137,   137,
-     138,   138,   138,   139,   139,   139,   139,   139,   139,   139,
-     139,   140,   140,   141,   141,   142,   142,   143,   143,   143,
-     143,   143,   143,   143,   143,   143,   143,   143,   143,   143,
-     143,   143,   143,   143,   143,   143,   143,   143,   143,   144,
-     144,   144,   144,   144,   145,   145,   145,   145,   146,   146,
-     147,   148,   148,   149,   149,   149,   149,   150,   150,   150,
-     151,   151,   151,   152,   152,   152,   153,   153,   153,   153,
-     153,   153,   154,   154,   154,   154,   154,   154,   155,   155,
-     155,   155,   156,   157,   158,   158,   158,   158,   158,   159,
-     159,   159,   159,   160,   160,   161,   161,   162,   163,   164,
-     164,   164,   164,   165,   165,   166,   167,   167
+       0,   161,   162,   162,   163,   163,   164,   164,   165,   165,
+     165,   166,   166,   167,   167,   168,   168,   169,   170,   171,
+     172,   172,   172,   173,   174,   174,   174,   175,   175,   176,
+     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
+     176,   176,   176,   176,   176,   176,   176,   177,   177,   178,
+     179,   179,   179,   179,   179,   179,   180,   181,   182,   183,
+     184,   184,   184,   184,   184,   185,   185,   185,   185,   186,
+     186,   187,   187,   187,   187,   187,   187,   188,   188,   189,
+     189,   190,   190,   191,   192,   193,   193,   193,   193,   193,
+     193,   193,   193,   193,   194,   194,   194,   194,   195,   195,
+     195,   196,   196,   197,   197,   198,   198,   199,   200,   199,
+     201,   199,   202,   199,   203,   199,   204,   204,   205,   205,
+     205,   205,   205,   205,   205,   205,   205,   206,   206,   206,
+     207,   207,   208,   207,   209,   209,   209,   209,   210,   210,
+     211,   211,   211,   211,   211,   211,   212,   212,   213,   213,
+     214,   215,   215,   216,   216,   217,   218,   219,   220,   220,
+     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
+     221,   221,   221,   221,   221,   222,   221,   221,   221,   221,
+     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
+     221,   221,   221,   223,   223,   224,   225,   224,   226,   224,
+     227,   224,   228,   224,   229,   229,   230,   230,   230,   230,
+     231,   231,   232,   232,   232,   232,   232,   232,   233,   234,
+     235,   235,   235,   236,   236,   237,   237,   238,   237,   239,
+     237,   240,   237,   241,   237,   242,   243,   243,   243,   243,
+     244,   244,   245,   245,   246,   245,   247,   245,   248,   245,
+     249,   250,   249,   251,   249,   252,   252,   252,   253,   252,
+     254,   252,   255,   255,   256,   257,   256,   258,   256,   259,
+     256,   260,   261,   260,   262,   260,   263,   263,   263,   264,
+     263,   265,   263,   266,   263,   267,   268,   268,   269,   268,
+     270,   268,   271,   271,   271,   271,   271,   271,   271,   271,
+     271,   271,   271,   271,   271,   272,   273,   272,   274,   272,
+     275,   276,   275,   277,   275,   278,   278,   278,   278,   278,
+     279,   279
 };
 
   /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
 static const yytype_uint8 yyr2[] =
 {
-       0,     2,     1,     2,     0,     2,     3,     1,     2,     2,
-       4,     2,     0,     4,     2,     2,     3,     3,     2,     1,
-       1,     3,     3,     1,     1,     2,     2,     3,     1,     4,
-       1,     1,     1,     0,     2,     0,     2,     2,     2,     2,
-       1,     1,     1,     1,     1,     1,     0,     2,     2,     2,
-       2,     0,     3,     3,     3,     2,     3,     0,     2,     3,
-       1,     1,     1,     0,     3,     3,     3,     3,     3,     3,
-       2,     3,     1,     1,     3,     3,     2,     2,     2,     2,
-       1,     1,     4,     4,     4,     3,     4,     4,     3,     2,
-       3,     5,     4,     2,     5,     3,     4,     2,     1,     0,
-       2,     2,     2,     2,     0,     2,     2,     2,     1,     2,
-       2,     2,     1,     0,     2,     2,     2,     0,     2,     2,
-       0,     2,     2,     0,     2,     2,     0,     2,     2,     3,
-       2,     2,     0,     2,     2,     2,     2,     2,     0,     2,
-       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
-       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
-       2,     2,     3,     0,     2,     3,     1,     3
+       0,     2,     1,     2,     0,     2,     1,     2,     1,     2,
+       2,     0,     1,     1,     3,     1,     3,     1,     1,     3,
+       2,     2,     3,     3,     0,     2,     2,     3,     2,     2,
+       3,     3,     1,     4,     3,     3,     1,     4,     4,     2,
+       3,     2,     2,     3,     2,     3,     1,     0,     2,     2,
+       0,     2,     2,     2,     2,     2,     1,     1,     2,     2,
+       0,     2,     2,     2,     2,     2,     2,     2,     1,     2,
+       2,     0,     2,     2,     2,     2,     2,     1,     1,     1,
+       1,     1,     1,     1,     1,     0,     3,     3,     3,     3,
+       3,     2,     3,     2,     2,     1,     1,     1,     1,     1,
+       1,     0,     2,     1,     1,     0,     2,     0,     0,     3,
+       0,     3,     0,     3,     0,     3,     1,     1,     0,     3,
+       3,     2,     3,     3,     2,     3,     3,     1,     1,     1,
+       0,     2,     0,     4,     0,     2,     2,     2,     1,     1,
+       0,     3,     2,     3,     3,     3,     1,     3,     1,     3,
+       1,     1,     3,     1,     3,     1,     1,     3,     1,     3,
+       2,     2,     2,     1,     1,     2,     3,     4,     4,     4,
+       3,     4,     4,     4,     3,     0,     6,     4,     2,     5,
+       2,     2,     5,     3,     4,     2,     2,     2,     2,     3,
+       2,     2,     1,     1,     1,     0,     0,     3,     0,     3,
+       0,     3,     0,     3,     1,     2,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
+       1,     1,     1,     2,     1,     0,     2,     0,     3,     0,
+       3,     0,     3,     0,     3,     1,     1,     1,     1,     1,
+       1,     1,     0,     2,     0,     3,     0,     3,     0,     3,
+       0,     0,     3,     0,     3,     0,     2,     3,     0,     3,
+       0,     3,     1,     1,     0,     0,     3,     0,     3,     0,
+       3,     0,     0,     3,     0,     3,     0,     2,     2,     0,
+       3,     0,     3,     0,     3,     2,     0,     2,     0,     3,
+       0,     3,     1,     1,     1,     1,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     0,     0,     3,     0,     3,
+       0,     0,     3,     0,     3,     0,     3,     3,     3,     2,
+       1,     1
 };
 
 
@@ -1271,7 +1471,7 @@ do
     }                                                           \
   else                                                          \
     {                                                           \
-      yyerror (parse_script, YY_("syntax error: cannot back up")); \
+      yyerror (sscript, YY_("syntax error: cannot back up")); \
       YYERROR;                                                  \
     }                                                           \
 while (0)
@@ -1308,7 +1508,7 @@ do {
     {                                                                     \
       YYFPRINTF (stderr, "%s ", Title);                                   \
       yy_symbol_print (stderr,                                            \
-                  Type, Value, parse_script); \
+                  Type, Value, sscript); \
       YYFPRINTF (stderr, "\n");                                           \
     }                                                                     \
 } while (0)
@@ -1319,11 +1519,11 @@ do {
 `----------------------------------------*/
 
 static void
-yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *parse_script)
+yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *sscript)
 {
   FILE *yyo = yyoutput;
   YYUSE (yyo);
-  YYUSE (parse_script);
+  YYUSE (sscript);
   if (!yyvaluep)
     return;
 # ifdef YYPRINT
@@ -1339,12 +1539,12 @@ yy_symbol_value_print (FILE *yyoutput, i
 `--------------------------------*/
 
 static void
-yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *parse_script)
+yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *sscript)
 {
   YYFPRINTF (yyoutput, "%s %s (",
              yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);
 
-  yy_symbol_value_print (yyoutput, yytype, yyvaluep, parse_script);
+  yy_symbol_value_print (yyoutput, yytype, yyvaluep, sscript);
   YYFPRINTF (yyoutput, ")");
 }
 
@@ -1377,7 +1577,7 @@ do {
 `------------------------------------------------*/
 
 static void
-yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, sieve_script_t *parse_script)
+yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, sieve_script_t *sscript)
 {
   unsigned long int yylno = yyrline[yyrule];
   int yynrhs = yyr2[yyrule];
@@ -1391,7 +1591,7 @@ yy_reduce_print (yytype_int16 *yyssp, YY
       yy_symbol_print (stderr,
                        yystos[yyssp[yyi + 1 - yynrhs]],
                        &(yyvsp[(yyi + 1) - (yynrhs)])
-                                              , parse_script);
+                                              , sscript);
       YYFPRINTF (stderr, "\n");
     }
 }
@@ -1399,7 +1599,7 @@ yy_reduce_print (yytype_int16 *yyssp, YY
 # define YY_REDUCE_PRINT(Rule)          \
 do {                                    \
   if (yydebug)                          \
-    yy_reduce_print (yyssp, yyvsp, Rule, parse_script); \
+    yy_reduce_print (yyssp, yyvsp, Rule, sscript); \
 } while (0)
 
 /* Nonzero means print parse trace.  It is left uninitialized so that
@@ -1657,10 +1857,10 @@ yysyntax_error (YYSIZE_T *yymsg_alloc, c
 `-----------------------------------------------*/
 
 static void
-yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, sieve_script_t *parse_script)
+yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, sieve_script_t *sscript)
 {
   YYUSE (yyvaluep);
-  YYUSE (parse_script);
+  YYUSE (sscript);
   if (!yymsg)
     yymsg = "Deleting";
   YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);
@@ -1668,34 +1868,118 @@ yydestruct (const char *yymsg, int yytyp
   YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
   switch (yytype)
     {
-          case 124: /* commands  */
-#line 302 "sieve/sieve.y" /* yacc.c:1257  */
-      { free_tree(((*yyvaluep).cl)); }
-#line 1675 "sieve/sieve.c" /* yacc.c:1257  */
+          case 4: /* STRING  */
+#line 164 "sieve/sieve.y" /* yacc.c:1257  */
+      { free(((*yyvaluep).sval));          }
+#line 1875 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 164: /* commands  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1881 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 165: /* command  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1887 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 166: /* optstringlist  */
+#line 163 "sieve/sieve.y" /* yacc.c:1257  */
+      { strarray_free(((*yyvaluep).sl)); }
+#line 1893 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 167: /* stringlist  */
+#line 163 "sieve/sieve.y" /* yacc.c:1257  */
+      { strarray_free(((*yyvaluep).sl)); }
+#line 1899 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 168: /* strings  */
+#line 163 "sieve/sieve.y" /* yacc.c:1257  */
+      { strarray_free(((*yyvaluep).sl)); }
+#line 1905 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 169: /* string1  */
+#line 163 "sieve/sieve.y" /* yacc.c:1257  */
+      { strarray_free(((*yyvaluep).sl)); }
+#line 1911 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 170: /* string  */
+#line 164 "sieve/sieve.y" /* yacc.c:1257  */
+      { free(((*yyvaluep).sval));          }
+#line 1917 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 172: /* control  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1923 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 173: /* thenelse  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1929 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 174: /* elsif  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1935 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 175: /* block  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1941 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 176: /* action  */
+#line 160 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_tree(((*yyvaluep).cl));     }
+#line 1947 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 215: /* timelist  */
+#line 165 "sieve/sieve.y" /* yacc.c:1257  */
+      { arrayu64_free(((*yyvaluep).nl)); }
+#line 1953 "sieve/sieve.c" /* yacc.c:1257  */
+        break;
+
+    case 216: /* times  */
+#line 165 "sieve/sieve.y" /* yacc.c:1257  */
+      { arrayu64_free(((*yyvaluep).nl)); }
+#line 1959 "sieve/sieve.c" /* yacc.c:1257  */
         break;
 
-    case 125: /* command  */
-#line 302 "sieve/sieve.y" /* yacc.c:1257  */
-      { free_tree(((*yyvaluep).cl)); }
-#line 1681 "sieve/sieve.c" /* yacc.c:1257  */
+    case 217: /* time1  */
+#line 165 "sieve/sieve.y" /* yacc.c:1257  */
+      { arrayu64_free(((*yyvaluep).nl)); }
+#line 1965 "sieve/sieve.c" /* yacc.c:1257  */
         break;
 
-    case 126: /* elsif  */
-#line 302 "sieve/sieve.y" /* yacc.c:1257  */
-      { free_tree(((*yyvaluep).cl)); }
-#line 1687 "sieve/sieve.c" /* yacc.c:1257  */
+    case 219: /* testlist  */
+#line 161 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_testlist(((*yyvaluep).testl)); }
+#line 1971 "sieve/sieve.c" /* yacc.c:1257  */
         break;
 
-    case 127: /* action  */
-#line 302 "sieve/sieve.y" /* yacc.c:1257  */
-      { free_tree(((*yyvaluep).cl)); }
-#line 1693 "sieve/sieve.c" /* yacc.c:1257  */
+    case 220: /* tests  */
+#line 161 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_testlist(((*yyvaluep).testl)); }
+#line 1977 "sieve/sieve.c" /* yacc.c:1257  */
         break;
 
-    case 142: /* block  */
-#line 302 "sieve/sieve.y" /* yacc.c:1257  */
-      { free_tree(((*yyvaluep).cl)); }
-#line 1699 "sieve/sieve.c" /* yacc.c:1257  */
+    case 221: /* test  */
+#line 162 "sieve/sieve.y" /* yacc.c:1257  */
+      { free_test(((*yyvaluep).test));     }
+#line 1983 "sieve/sieve.c" /* yacc.c:1257  */
         break;
 
 
@@ -1713,7 +1997,7 @@ yydestruct (const char *yymsg, int yytyp
 `----------*/
 
 int
-yyparse (sieve_script_t *parse_script)
+yyparse (sieve_script_t *sscript)
 {
 /* The lookahead symbol.  */
 int yychar;
@@ -1882,7 +2166,7 @@ yybackup:
   if (yychar == YYEMPTY)
     {
       YYDPRINTF ((stderr, "Reading a token: "));
-      yychar = yylex (&yylval, parse_script);
+      yychar = yylex (&yylval, sscript);
     }
 
   if (yychar <= YYEOF)
@@ -1961,1729 +2245,2012 @@ yyreduce:
   switch (yyn)
     {
         case 2:
-#line 314 "sieve/sieve.y" /* yacc.c:1646  */
-    { parse_script->cmds = NULL; }
-#line 1967 "sieve/sieve.c" /* yacc.c:1646  */
+#line 358 "sieve/sieve.y" /* yacc.c:1646  */
+    { sscript->cmds = NULL; }
+#line 2251 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 3:
-#line 315 "sieve/sieve.y" /* yacc.c:1646  */
-    { parse_script->cmds = (yyvsp[0].cl); }
-#line 1973 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 6:
-#line 323 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                    char *err = check_reqs(parse_script, (yyvsp[-1].sl));
-                                    if (err) {
-                                        yyerror(parse_script, err);
-                                        free(err);
-                                        YYERROR;
-                                    }
-                                }
-#line 1986 "sieve/sieve.c" /* yacc.c:1646  */
+#line 359 "sieve/sieve.y" /* yacc.c:1646  */
+    { sscript->cmds = (yyvsp[0].cl); }
+#line 2257 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 7:
-#line 333 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = (yyvsp[0].cl); }
-#line 1992 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 8:
-#line 334 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyvsp[-1].cl)->next = (yyvsp[0].cl); (yyval.cl) = (yyvsp[-1].cl); }
-#line 1998 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 9:
-#line 337 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = (yyvsp[-1].cl); }
-#line 2004 "sieve/sieve.c" /* yacc.c:1646  */
+#line 370 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = (yyvsp[-1].cl); (yyval.cl)->next = (yyvsp[0].cl); }
+#line 2263 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 10:
-#line 338 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = new_if((yyvsp[-2].test), (yyvsp[-1].cl), (yyvsp[0].cl)); }
-#line 2010 "sieve/sieve.c" /* yacc.c:1646  */
+#line 376 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     struct buf buf = BUF_INITIALIZER;
+                                     buf_printf(&buf, "%s: line %d",
+                                                error_message(SIEVE_UNSUPP_EXT),
+                                                sievelineno);
+                                     sscript->support |= SIEVE_CAPA_IHAVE;
+                                     (yyval.cl) = build_rej_err(sscript, ERROR,
+                                                        buf_release(&buf));
+                                 }
+#line 2277 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 11:
-#line 339 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = new_command(STOP); }
-#line 2016 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 12:
-#line 342 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = NULL; }
-#line 2022 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 13:
-#line 343 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = new_if((yyvsp[-2].test), (yyvsp[-1].cl), (yyvsp[0].cl)); }
-#line 2028 "sieve/sieve.c" /* yacc.c:1646  */
+#line 388 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.sl) = strarray_new(); }
+#line 2283 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 14:
-#line 344 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = (yyvsp[0].cl); }
-#line 2034 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 15:
-#line 348 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.reject) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "reject");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     (yyval.cl) = new_command(REJCT);
-                                     (yyval.cl)->u.reject = (yyvsp[0].sval);
-                                 }
-#line 2052 "sieve/sieve.c" /* yacc.c:1646  */
+#line 394 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.sl) = (yyvsp[-1].sl); }
+#line 2289 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 16:
-#line 363 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.fileinto) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "fileinto");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_mailbox(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vm should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_fileinto(FILEINTO,
-                                                         canon_ftags((yyvsp[-1].ftag)), (yyvsp[0].sval));
-                                 }
-#line 2070 "sieve/sieve.c" /* yacc.c:1646  */
+#line 399 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.sl) = (yyvsp[-2].sl); strarray_appendm((yyval.sl), (yyvsp[0].sval)); }
+#line 2295 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 17:
-#line 378 "sieve/sieve.y" /* yacc.c:1646  */
+#line 403 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!verify_address(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* va should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_redirect(REDIRECT, (yyvsp[-1].nval), (yyvsp[0].sval));
+                                     (yyval.sl) = strarray_new();
+                                     strarray_appendm((yyval.sl), (yyvsp[0].sval));
                                  }
-#line 2081 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2304 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 18:
-#line 385 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = build_keep(KEEP,canon_ftags((yyvsp[0].ftag))); }
-#line 2087 "sieve/sieve.c" /* yacc.c:1646  */
+#line 410 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.sval) = (yyvsp[0].sval); chk_match_vars(sscript, (yyval.sval)); }
+#line 2310 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 19:
-#line 386 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = new_command(STOP); }
-#line 2093 "sieve/sieve.c" /* yacc.c:1646  */
+#line 417 "sieve/sieve.y" /* yacc.c:1646  */
+    { check_reqs(sscript, (yyvsp[-1].sl)); }
+#line 2316 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 20:
-#line 387 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = new_command(DISCARD); }
-#line 2099 "sieve/sieve.c" /* yacc.c:1646  */
+#line 421 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = (yyvsp[0].cl); }
+#line 2322 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 21:
-#line 390 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.vacation) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "vacation");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (((yyvsp[-1].vtag)->mime == -1) &&
-                                         !verify_utf8(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_vacation(VACATION,
-                                                         canon_vtags(parse_script, (yyvsp[-1].vtag)),
-                                                         (yyvsp[0].sval));
-                                 }
-#line 2119 "sieve/sieve.c" /* yacc.c:1646  */
+#line 422 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(STOP, sscript); }
+#line 2328 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 22:
-#line 407 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!(parse_script->support.imapflags ||
-                                           parse_script->support.imap4flags)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap[4]flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!parse_script->support.variables) {
-                                         verify_flaglist((yyvsp[0].sl));
-                                     }
-                                     if (!(yyvsp[0].sl)->count) strarray_add((yyvsp[0].sl), "");
-                                     (yyval.cl) = build_flag((yyvsp[-2].nval), (yyvsp[-1].sval), (yyvsp[0].sl));
-                                 }
-#line 2138 "sieve/sieve.c" /* yacc.c:1646  */
+#line 423 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_rej_err(sscript, ERROR, (yyvsp[-1].sval)); }
+#line 2334 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 23:
-#line 423 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.imapflags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imapflags");
-                                         YYERROR; /* pe should call yyerror() */
+#line 427 "sieve/sieve.y" /* yacc.c:1646  */
+    { 
+                                     if ((yyvsp[-2].test)->ignore_err) {
+                                         /* end of block - decrement counter */
+                                         sscript->ignore_err--;
                                      }
-                                     (yyval.cl) = new_command(MARK);
+
+                                     (yyval.cl) = new_if((yyvsp[-2].test), (yyvsp[-1].cl), (yyvsp[0].cl));
                                  }
-#line 2152 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2347 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 24:
-#line 434 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.imapflags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imapflags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.cl) = new_command(UNMARK);
-                                 }
-#line 2166 "sieve/sieve.c" /* yacc.c:1646  */
+#line 438 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = NULL; }
+#line 2353 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 25:
-#line 445 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.notify) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "notify");
-                                         (yyval.cl) = new_command(NOTIFY);
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_notify(NOTIFY, canon_ntags((yyvsp[0].ntag)));
-                                 }
-#line 2181 "sieve/sieve.c" /* yacc.c:1646  */
+#line 439 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = (yyvsp[0].cl); }
+#line 2359 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 26:
-#line 457 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.notify) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "notify");
-                                         (yyval.cl) = new_command(DENOTIFY);
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_denotify(DENOTIFY,
-                                                         canon_dtags((yyvsp[0].dtag)));
-                                     if ((yyval.cl) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "denotify action");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                 }
-#line 2203 "sieve/sieve.c" /* yacc.c:1646  */
+#line 440 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = (yyvsp[0].cl); }
+#line 2365 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 27:
-#line 476 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.include) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "include");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     int i;
-                                     for (i = 0; (yyvsp[0].sval)[i] != '\0'; i++) {
-                                         if ((yyvsp[0].sval)[i] == '/') {
-                                             parse_error(parse_script,
-                                                         SIEVE_INVALID_VALUE,
-                                                         "script-name");
-                                             YYERROR; /* pe should call yyerror() */
-                                             break;
-                                         }
-                                     }
-                                     (yyval.cl) = build_include(INCLUDE, (yyvsp[-1].itag), (yyvsp[0].sval));
-                                 }
-#line 2227 "sieve/sieve.c" /* yacc.c:1646  */
+#line 444 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = (yyvsp[-1].cl); }
+#line 2371 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 28:
-#line 497 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.include) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "include");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.cl) = new_command(RETURN);
-                                 }
-#line 2241 "sieve/sieve.c" /* yacc.c:1646  */
+#line 445 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = NULL; }
+#line 2377 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 29:
-#line 508 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_identifier(parse_script, (yyvsp[-1].sval))) {
-                                         YYERROR; /* vi should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     (yyval.cl) = build_set(SET, canon_stags((yyvsp[-2].stag)), (yyvsp[-1].sval), (yyvsp[0].sval));
-                                 }
-#line 2261 "sieve/sieve.c" /* yacc.c:1646  */
+#line 452 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_keep(sscript, (yyvsp[0].cl)); }
+#line 2383 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 30:
+#line 453 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_fileinto(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
+#line 2389 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 31:
+#line 454 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_redirect(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
+#line 2395 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 32:
+#line 455 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(DISCARD, sscript); }
+#line 2401 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 33:
-#line 530 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.sval) = NULL; }
-#line 2267 "sieve/sieve.c" /* yacc.c:1646  */
+#line 457 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_set(sscript, (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sval)); }
+#line 2407 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 34:
-#line 532 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!(parse_script->support.imap4flags)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ((yyvsp[-1].sval)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_ARG,
-                                                     "variablename");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!is_identifier((yyvsp[0].sval))) {
-                                         YYERROR; /* id should call yyerror() */
-                                     }
-                                     (yyval.sval) = (yyvsp[0].sval);
-                                 }
-#line 2290 "sieve/sieve.c" /* yacc.c:1646  */
+#line 458 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_vacation(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
+#line 2413 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 35:
-#line 552 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.stag) = new_stags(); }
-#line 2296 "sieve/sieve.c" /* yacc.c:1646  */
+#line 462 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_flag(sscript, (yyvsp[-1].cl), (yyvsp[0].sl)); }
+#line 2419 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 36:
-#line 554 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.stag)->mod40) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 40 modifier");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.stag)->mod40 = (yyvsp[0].nval);
-                                 }
-#line 2310 "sieve/sieve.c" /* yacc.c:1646  */
+#line 465 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command((yyvsp[0].nval), sscript); }
+#line 2425 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 37:
-#line 564 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.stag)->mod30) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 30 modifier");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.stag)->mod30 = (yyvsp[0].nval);
-                                 }
-#line 2324 "sieve/sieve.c" /* yacc.c:1646  */
+#line 468 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_addheader(sscript,
+                                                        (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sval)); }
+#line 2432 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 38:
-#line 574 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.stag)->mod20) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 20 modifier");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.stag)->mod20 = (yyvsp[0].nval);
-                                 }
-#line 2338 "sieve/sieve.c" /* yacc.c:1646  */
+#line 471 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_deleteheader(sscript,
+                                                           (yyvsp[-2].cl), (yyvsp[-1].sval), (yyvsp[0].sl)); }
+#line 2439 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 39:
-#line 609 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.stag)->mod10) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 10 modifier");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.stag)->mod10 = (yyvsp[0].nval);
-                                 }
-#line 2352 "sieve/sieve.c" /* yacc.c:1646  */
+#line 474 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_rej_err(sscript, (yyvsp[-1].nval), (yyvsp[0].sval)); }
+#line 2445 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 46:
-#line 631 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.itag) = new_itags(); }
-#line 2358 "sieve/sieve.c" /* yacc.c:1646  */
+  case 40:
+#line 475 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_notify(sscript,
+                                                     ENOTIFY, (yyvsp[-1].cl), (yyvsp[0].sval)); }
+#line 2452 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 47:
-#line 633 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.itag)->location != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "location");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.itag)->location = PERSONAL;
-                                 }
-#line 2372 "sieve/sieve.c" /* yacc.c:1646  */
+  case 41:
+#line 478 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_notify(sscript,
+                                                     NOTIFY, (yyvsp[0].cl), NULL); }
+#line 2459 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 48:
-#line 643 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.itag)->location != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "location");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.itag)->location = GLOBAL;
-                                 }
-#line 2386 "sieve/sieve.c" /* yacc.c:1646  */
+  case 42:
+#line 481 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_denotify(sscript, (yyvsp[0].cl)); }
+#line 2465 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 49:
-#line 653 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.itag)->once != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":once");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.itag)->once = 1;
-                                 }
-#line 2400 "sieve/sieve.c" /* yacc.c:1646  */
+  case 43:
+#line 482 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_include(sscript, (yyvsp[-1].cl), (yyvsp[0].sval)); }
+#line 2471 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 50:
-#line 663 "sieve/sieve.y" /* yacc.c:1646  */
-    { if ((yyval.itag)->optional != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":optional");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.itag)->optional = 1;
-                                 }
-#line 2413 "sieve/sieve.c" /* yacc.c:1646  */
+  case 44:
+#line 483 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_log(sscript, (yyvsp[0].sval)); }
+#line 2477 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 51:
-#line 673 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ntag) = new_ntags(); }
-#line 2419 "sieve/sieve.c" /* yacc.c:1646  */
+  case 45:
+#line 485 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = build_snooze(sscript, (yyvsp[-1].cl), (yyvsp[0].nl)); }
+#line 2483 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 52:
-#line 675 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.ntag)->id != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":id");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.ntag)->id = (yyvsp[0].sval);
-                                 }
-#line 2433 "sieve/sieve.c" /* yacc.c:1646  */
+  case 46:
+#line 486 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(RETURN, sscript); }
+#line 2489 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 53:
-#line 685 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.ntag)->method != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":method");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.ntag)->method = (yyvsp[0].sval);
-                                 }
-#line 2447 "sieve/sieve.c" /* yacc.c:1646  */
+  case 47:
+#line 491 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(KEEP, sscript); }
+#line 2495 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 54:
-#line 695 "sieve/sieve.y" /* yacc.c:1646  */
+  case 49:
+#line 497 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.ntag)->options != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":options");
-                                         YYERROR; /* pe should call yyerror() */
+                                     /* $0 refers to ktags, ftags, or vtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+                                     strarray_t **flags = NULL;
+
+                                     switch (c->type) {
+                                     case KEEP:
+                                         flags = &c->u.k.flags; break;
+                                     case FILEINTO:
+                                         flags = &c->u.f.flags; break;
+                                     case VACATION:
+                                         flags = &c->u.v.fcc.flags; break;
+                                     case ENOTIFY:
+                                         flags = &c->u.n.fcc.flags; break;
+                                     }
+
+                                     if (*flags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":flags");
+                                         strarray_free(*flags);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "imap4flags");
                                      }
-                                     else (yyval.ntag)->options = (yyvsp[0].sl);
+
+                                     *flags = (yyvsp[0].sl);
                                  }
-#line 2461 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2530 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 55:
-#line 705 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if ((yyval.ntag)->priority != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "priority");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.ntag)->priority = (yyvsp[0].nval);
-                                 }
-#line 2475 "sieve/sieve.c" /* yacc.c:1646  */
+  case 50:
+#line 531 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(FILEINTO, sscript); }
+#line 2536 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 56:
-#line 715 "sieve/sieve.y" /* yacc.c:1646  */
+#line 541 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.ntag)->message != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":message");
-                                         YYERROR; /* pe should call yyerror() */
+                                     /* $0 refers to ftags or rtags */
+                                     commandlist_t *c = (yyvsp[-1].cl);
+                                     int *copy = (c->type == FILEINTO) ?
+                                         &c->u.f.copy : &c->u.r.copy;
+
+                                     if ((*copy)++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":copy");
+                                     }
+                                     else if (!supported(SIEVE_CAPA_COPY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "copy");
                                      }
-                                     else (yyval.ntag)->message = (yyvsp[0].sval);
                                  }
-#line 2489 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2558 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 57:
-#line 726 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.dtag) = new_dtags(); }
-#line 2495 "sieve/sieve.c" /* yacc.c:1646  */
+#line 562 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     /* $0 refers to ftags or vtags */
+                                     commandlist_t *c = (yyvsp[-1].cl);
+                                     int *create = NULL;
+
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         create = &c->u.f.create; break;
+                                     case VACATION:
+                                         create = &c->u.v.fcc.create; break;
+                                     case ENOTIFY:
+                                         create = &c->u.n.fcc.create; break;
+                                     }
+
+                                     if ((*create)++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":create");
+                                     }
+                                     else if (!supported(SIEVE_CAPA_MAILBOX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "mailbox");
+                                     }
+                                 }
+#line 2588 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 58:
-#line 728 "sieve/sieve.y" /* yacc.c:1646  */
+#line 591 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.dtag)->priority != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "priority");
-                                         YYERROR; /* pe should call yyerror() */
+                                     /* $0 refers to ftags or vtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+                                     char **specialuse = NULL;
+
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         specialuse = &c->u.f.specialuse;
+                                         break;
+                                     case VACATION:
+                                         specialuse = &c->u.v.fcc.specialuse;
+                                         break;
+                                     case ENOTIFY:
+                                         specialuse = &c->u.n.fcc.specialuse;
+                                         break;
+                                     }
+
+                                     if (*specialuse != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":specialuse");
+                                         free(*specialuse);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_SPECIAL_USE)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "special-use");
                                      }
-                                     else (yyval.dtag)->priority = (yyvsp[0].nval);
+
+                                     *specialuse = (yyvsp[0].sval);
                                  }
-#line 2509 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2624 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 59:
-#line 738 "sieve/sieve.y" /* yacc.c:1646  */
+#line 624 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.dtag)->pattern = (yyvsp[0].sval);
-
-                                     strarray_t sa = STRARRAY_INITIALIZER;
-                                     strarray_appendm(&sa, (yyvsp[0].sval));
-                                     if (!verify_patternlist(parse_script, &sa,
-                                                             &((yyval.dtag)->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     /* $0 refers to ftags, sntags or vtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+                                     char **mailboxid = NULL;
+
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         mailboxid = &c->u.f.mailboxid;
+                                         break;
+                                     case SNOOZE:
+                                         mailboxid = &c->u.sn.mailbox;
+                                         break;
+                                     case VACATION:
+                                         mailboxid = &c->u.v.fcc.mailboxid;
+                                         break;
+                                     case ENOTIFY:
+                                         mailboxid = &c->u.n.fcc.mailboxid;
+                                         break;
+                                     }
+
+                                     if (*mailboxid != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mailboxid");
+                                         free(*mailboxid);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_MAILBOXID)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "mailboxid");
                                      }
-                                     strarray_fini(&sa);
+
+                                     *mailboxid = (yyvsp[0].sval);
                                  }
-#line 2526 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2663 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 60:
-#line 752 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = LOW; }
-#line 2532 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
-
-  case 61:
-#line 753 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = NORMAL; }
-#line 2538 "sieve/sieve.c" /* yacc.c:1646  */
+#line 662 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(REDIRECT, sscript); }
+#line 2669 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 62:
-#line 754 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = HIGH; }
-#line 2544 "sieve/sieve.c" /* yacc.c:1646  */
+#line 664 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.r.list++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":list");
+                                     }
+                                     else if (!supported(SIEVE_CAPA_EXTLISTS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "extlists");
+                                     }
+                                 }
+#line 2686 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 63:
-#line 757 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.vtag) = new_vtags(); }
-#line 2550 "sieve/sieve.c" /* yacc.c:1646  */
+#line 676 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (!supported(SIEVE_CAPA_REDIR_DELBY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "redirect-deliverby");
+                                     }
+                                 }
+#line 2698 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 64:
-#line 759 "sieve/sieve.y" /* yacc.c:1646  */
+#line 683 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->seconds != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "period");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (!supported(SIEVE_CAPA_REDIR_DSN)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "redirect-dsn");
                                      }
-                                     else (yyval.vtag)->seconds = (yyvsp[0].nval) * DAY2SEC;
                                  }
-#line 2564 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2710 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 65:
-#line 769 "sieve/sieve.y" /* yacc.c:1646  */
+#line 693 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.vacation_seconds) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "vacation-seconds");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ((yyval.vtag)->seconds != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "period");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.vtag)->seconds = (yyvsp[0].nval);
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+
+                                     if (c->u.r.bytime != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytime*");
+                                     }                                         
+
+                                     struct buf buf = BUF_INITIALIZER;
+                                     buf_printf(&buf, "+%d", (yyvsp[0].nval));
+                                     c->u.r.bytime = buf_release(&buf);
                                  }
-#line 2584 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2729 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 66:
-#line 785 "sieve/sieve.y" /* yacc.c:1646  */
+#line 707 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->addresses != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":addresses");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_stringlist(parse_script, (yyvsp[0].sl),
-                                                            verify_address)) {
-                                         YYERROR;
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+
+                                     if (c->u.r.bytime != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytimerelative"
+                                                      " OR :bytimeabsolute");
                                      }
-                                     (yyval.vtag)->addresses = (yyvsp[0].sl);
+
+                                     c->u.r.bytime = (yyvsp[0].sval);
                                  }
-#line 2602 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2747 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 67:
-#line 799 "sieve/sieve.y" /* yacc.c:1646  */
+#line 720 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->subject != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":subject");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vu should call yyerror() */
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+
+                                     if (c->u.r.bymode != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bymode");
                                      }
-                                     (yyval.vtag)->subject = (yyvsp[0].sval);
+
+                                     c->u.r.bymode = (yyvsp[0].sval);
                                  }
-#line 2619 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2764 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 68:
-#line 812 "sieve/sieve.y" /* yacc.c:1646  */
+#line 732 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->from != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":from");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_address(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* va should call yyerror() */
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-1].cl);
+
+                                     if (c->u.r.bytrace != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytrace");
                                      }
-                                     (yyval.vtag)->from = (yyvsp[0].sval);
+
+                                     c->u.r.bytrace = 1;
                                  }
-#line 2636 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2781 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 69:
-#line 825 "sieve/sieve.y" /* yacc.c:1646  */
+#line 748 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->handle != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":handle");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, (yyvsp[0].sval))) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     (yyval.vtag)->handle = (yyvsp[0].sval);
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+
+                                     if (c->u.r.dsn_notify != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":notify");
+                                     }                                         
+
+                                     c->u.r.dsn_notify = (yyvsp[0].sval);
                                  }
-#line 2653 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2798 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 70:
-#line 838 "sieve/sieve.y" /* yacc.c:1646  */
+#line 760 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if ((yyval.vtag)->mime != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":mime");
-                                         YYERROR; /* pe should call yyerror() */
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+
+                                     if (c->u.r.dsn_ret != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":ret");
                                      }
-                                     (yyval.vtag)->mime = MIME;
+
+                                     c->u.r.dsn_ret = (yyvsp[0].sval);
                                  }
-#line 2667 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2815 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 71:
-#line 849 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.sl) = (yyvsp[-1].sl); }
-#line 2673 "sieve/sieve.c" /* yacc.c:1646  */
+#line 776 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(SET, sscript); }
+#line 2821 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 72:
-#line 850 "sieve/sieve.y" /* yacc.c:1646  */
+#line 777 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                    (yyval.sl) = strarray_new();
-                                    strarray_appendm((yyval.sl), (yyvsp[0].sval));
+                                     if ((yyval.cl)->u.s.mod40) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 40 modifier");
+                                     }
+
+                                     (yyval.cl)->u.s.mod40 = (yyvsp[0].nval);
                                  }
-#line 2682 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2835 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 73:
-#line 856 "sieve/sieve.y" /* yacc.c:1646  */
+#line 786 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                    (yyval.sl) = strarray_new();
-                                    strarray_appendm((yyval.sl), (yyvsp[0].sval));
+                                     if ((yyval.cl)->u.s.mod30) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 30 modifier");
+                                     }
+
+                                     (yyval.cl)->u.s.mod30 = (yyvsp[0].nval);
                                  }
-#line 2691 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2849 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 74:
-#line 860 "sieve/sieve.y" /* yacc.c:1646  */
+#line 795 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                    (yyval.sl) = (yyvsp[-2].sl);
-                                    strarray_appendm((yyval.sl), (yyvsp[0].sval));
+                                     if ((yyval.cl)->u.s.mod20) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 20 modifier");
+                                     }
+
+                                     (yyval.cl)->u.s.mod20 = (yyvsp[0].nval);
                                  }
-#line 2700 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2863 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
   case 75:
-#line 866 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = (yyvsp[-1].cl); }
-#line 2706 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
+#line 804 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.s.mod15) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 15 modifier");
+                                     }
 
-  case 76:
-#line 867 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.cl) = NULL; }
-#line 2712 "sieve/sieve.c" /* yacc.c:1646  */
+                                     (yyval.cl)->u.s.mod15 = (yyvsp[0].nval);
+                                 }
+#line 2877 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 77:
-#line 870 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(ANYOF); (yyval.test)->u.tl = (yyvsp[0].testl); }
-#line 2718 "sieve/sieve.c" /* yacc.c:1646  */
-    break;
+  case 76:
+#line 813 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.s.mod10) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 10 modifier");
+                                     }
 
-  case 78:
-#line 871 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(ALLOF); (yyval.test)->u.tl = (yyvsp[0].testl); }
-#line 2724 "sieve/sieve.c" /* yacc.c:1646  */
+                                     (yyval.cl)->u.s.mod10 = (yyvsp[0].nval);
+                                 }
+#line 2891 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 79:
-#line 872 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(EXISTS); (yyval.test)->u.sl = (yyvsp[0].sl); }
-#line 2730 "sieve/sieve.c" /* yacc.c:1646  */
+  case 82:
+#line 835 "sieve/sieve.y" /* yacc.c:1646  */
+    { 
+                                     if (!supported(SIEVE_CAPA_REGEX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "regex");
+                                     }
+                                 }
+#line 2903 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 80:
-#line 873 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(SFALSE); }
-#line 2736 "sieve/sieve.c" /* yacc.c:1646  */
+  case 83:
+#line 845 "sieve/sieve.y" /* yacc.c:1646  */
+    { 
+                                     if (!supported(SIEVE_CAPA_ENOTIFY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "enotify");
+                                     }
+                                 }
+#line 2915 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 81:
-#line 874 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(STRUE); }
-#line 2742 "sieve/sieve.c" /* yacc.c:1646  */
+  case 85:
+#line 859 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(VACATION, sscript); }
+#line 2921 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 82:
-#line 877 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!verify_stringlist(parse_script,
-                                                            (yyvsp[-1].sl), verify_header)) {
-                                         YYERROR; /* vh should call yyerror() */
-                                     }
-                                     (yyvsp[-2].ctag) = canon_comptags((yyvsp[-2].ctag));
-
-                                     if (!verify_patternlist(parse_script,
-                                                             (yyvsp[0].sl), (yyvsp[-2].ctag),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
+  case 86:
+#line 860 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.v.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":days");
                                      }
 
-                                     (yyval.test) = build_header(HEADER, (yyvsp[-2].ctag), (yyvsp[-1].sl), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "header test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.v.seconds = (yyvsp[0].nval) * DAY2SEC;
                                  }
-#line 2768 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2935 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 83:
-#line 900 "sieve/sieve.y" /* yacc.c:1646  */
+  case 87:
+#line 869 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (!supported(SIEVE_CAPA_VACATION_SEC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "vacation-seconds");
                                      }
-                                     if (!verify_stringlist(parse_script,
-                                                            (yyvsp[-1].sl), verify_utf8)) {
-                                         YYERROR; /* vu should call yyerror() */
+                                     if ((yyval.cl)->u.v.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":seconds");
                                      }
-                                     (yyvsp[-2].ctag) = canon_comptags((yyvsp[-2].ctag));
 
-                                     if (!verify_patternlist(parse_script,
-                                                             (yyvsp[0].sl), (yyvsp[-2].ctag),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.v.seconds = (yyvsp[0].nval);
+                                 }
+#line 2954 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.test) = build_header(STRINGT, (yyvsp[-2].ctag), (yyvsp[-1].sl), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "string test");
-                                         YYERROR; /* pe should call yyerror() */
+  case 88:
+#line 883 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.v.subject != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":subject");
+                                         free((yyval.cl)->u.v.subject);
                                      }
+
+                                     (yyval.cl)->u.v.subject = (yyvsp[0].sval);
                                  }
-#line 2800 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2969 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 84:
-#line 933 "sieve/sieve.y" /* yacc.c:1646  */
+  case 89:
+#line 893 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.v.from != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":from");
+                                         free((yyval.cl)->u.v.from);
                                      }
-                                     if (!verify_stringlist(parse_script, (yyvsp[-1].sl),
-                                                            verify_identifier)) {
-                                         YYERROR; /* vi should call yyerror() */
-                                     }
-                                     (yyvsp[-2].ctag) = canon_comptags((yyvsp[-2].ctag));
 
-                                     if (!verify_patternlist(parse_script,
-                                                             (yyvsp[0].sl), (yyvsp[-2].ctag),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.v.from = (yyvsp[0].sval);
+                                 }
+#line 2984 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.test) = build_header(HASFLAG, (yyvsp[-2].ctag), (yyvsp[-1].sl), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "hasflag test");
-                                         YYERROR; /* pe should call yyerror() */
+  case 90:
+#line 905 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.v.addresses != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":addresses");
+                                         strarray_free((yyval.cl)->u.v.addresses);
                                      }
+
+                                     (yyval.cl)->u.v.addresses = (yyvsp[0].sl);
                                  }
-#line 2838 "sieve/sieve.c" /* yacc.c:1646  */
+#line 2999 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 85:
-#line 968 "sieve/sieve.y" /* yacc.c:1646  */
+  case 91:
+#line 915 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.v.mime != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mime");
                                      }
-                                     (yyvsp[-1].ctag) = canon_comptags((yyvsp[-1].ctag));
 
-                                     if (!verify_patternlist(parse_script,
-                                                             (yyvsp[0].sl), (yyvsp[-1].ctag),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.v.mime = 1;
+                                 }
+#line 3013 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.test) = build_header(HASFLAG, (yyvsp[-1].ctag), NULL, (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "hasflag test");
-                                         YYERROR; /* pe should call yyerror() */
+  case 92:
+#line 924 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.v.handle != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":handle");
+                                         free((yyval.cl)->u.v.handle);
                                      }
+
+                                     (yyval.cl)->u.v.handle = (yyvsp[0].sval);
                                  }
-#line 2866 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3028 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 86:
-#line 993 "sieve/sieve.y" /* yacc.c:1646  */
+  case 94:
+#line 938 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!verify_stringlist(parse_script, (yyvsp[-1].sl),
-                                                            verify_addrheader)) {
-                                         YYERROR; /* vah should call yyerror() */
-                                     }
-                                     (yyvsp[-2].aetag) = canon_aetags((yyvsp[-2].aetag));
+                                     /* $0 refers to vtags or ntags */
+                                     commandlist_t *c = (yyvsp[-2].cl);
+                                     char **folder = NULL;
 
-                                     if (!verify_patternlist(parse_script, (yyvsp[0].sl),
-                                                             &((yyvsp[-2].aetag)->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     switch (c->type) {
+                                     case VACATION:
+                                         folder = &c->u.v.fcc.folder; break;
+                                     case ENOTIFY:
+                                         folder = &c->u.n.fcc.folder; break;
                                      }
 
-                                     (yyval.test) = build_address(ADDRESS, (yyvsp[-2].aetag), (yyvsp[-1].sl), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "address test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (*folder != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":fcc");
+                                         free(*folder);
                                      }
+                                     else if (!supported(SIEVE_CAPA_FCC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "fcc");
+                                     }
+
+                                     *folder = (yyvsp[0].sval);
                                  }
-#line 2892 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3059 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 87:
-#line 1016 "sieve/sieve.y" /* yacc.c:1646  */
+  case 101:
+#line 978 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command((yyvsp[0].nval), sscript); }
+#line 3065 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 102:
+#line 979 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.envelope) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "envelope");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_stringlist(parse_script, (yyvsp[-1].sl),
-                                                            verify_envelope)) {
-                                         YYERROR;
+                                     if ((yyval.cl)->u.fl.variable != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_ARG,
+                                                      "variablename");
+                                         free((yyval.cl)->u.fl.variable);
                                      }
-                                     (yyvsp[-2].aetag) = canon_aetags((yyvsp[-2].aetag));
-
-                                     if (!verify_patternlist(parse_script, (yyvsp[0].sl),
-                                                             &((yyvsp[-2].aetag)->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "imap4flags");
                                      }
 
-                                     (yyval.test) = build_address(ENVELOPE, (yyvsp[-2].aetag), (yyvsp[-1].sl), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "envelope test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.fl.variable = (yyvsp[0].sval);
                                  }
-#line 2924 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3085 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 88:
-#line 1045 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.body) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "body");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyvsp[-1].btag) = canon_btags((yyvsp[-1].btag));
+  case 105:
+#line 1004 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(ADDHEADER, sscript); }
+#line 3091 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     if (!verify_patternlist(parse_script, (yyvsp[0].sl),
-                                                             &((yyvsp[-1].btag)->comptags),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
+  case 106:
+#line 1005 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.ah.index < 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
                                      }
 
-                                     (yyval.test) = build_body(BODY, (yyvsp[-1].btag), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "body test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.ah.index = -1;
                                  }
-#line 2952 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3105 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 89:
-#line 1069 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(NOT); (yyval.test)->u.t = (yyvsp[0].test); }
-#line 2958 "sieve/sieve.c" /* yacc.c:1646  */
+  case 107:
+#line 1018 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(DELETEHEADER, sscript);}
+#line 3111 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 90:
-#line 1070 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = new_test(SIZE); (yyval.test)->u.sz.t = (yyvsp[-1].nval);
-                                   (yyval.test)->u.sz.n = (yyvsp[0].nval); }
-#line 2965 "sieve/sieve.c" /* yacc.c:1646  */
+  case 108:
+#line 1019 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].cl)->u.dh.comp); }
+#line 3117 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 91:
-#line 1074 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.date) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "date");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_header(parse_script, (yyvsp[-2].sval))) {
-                                         YYERROR; /* vh should call yyerror() */
-                                     }
-                                     (yyvsp[-3].dttag) = canon_dttags((yyvsp[-3].dttag));
+  case 110:
+#line 1020 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].cl)->u.dh.comp); }
+#line 3123 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     if (!verify_patternlist(parse_script, (yyvsp[0].sl),
-                                                             &((yyvsp[-3].dttag)->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
+  case 112:
+#line 1021 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].cl)->u.dh.comp); }
+#line 3129 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.test) = build_date(DATE, (yyvsp[-3].dttag), (yyvsp[-2].sval), (yyvsp[-1].nval), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "date test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                 }
-#line 2996 "sieve/sieve.c" /* yacc.c:1646  */
+  case 114:
+#line 1022 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].cl)->u.dh.comp); }
+#line 3135 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 92:
-#line 1102 "sieve/sieve.y" /* yacc.c:1646  */
+  case 118:
+#line 1039 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(ENOTIFY, sscript); }
+#line 3141 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 119:
+#line 1042 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.date) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "date");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.from != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":from");
+                                         free((yyval.cl)->u.n.from);
                                      }
-                                     (yyvsp[-2].dttag) = canon_dttags((yyvsp[-2].dttag));
 
-                                     if (!verify_patternlist(parse_script, (yyvsp[0].sl),
-                                                             &((yyvsp[-2].dttag)->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.from = (yyvsp[0].sval);
+                                 }
+#line 3156 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.test) = build_date(CURRENTDATE,
-                                                     (yyvsp[-2].dttag), NULL, (yyvsp[-1].nval), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "currentdate test");
-                                         YYERROR; /* pe should call yyerror() */
+  case 120:
+#line 1054 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.n.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":importance");
                                      }
+
+                                     (yyval.cl)->u.n.priority = (yyvsp[0].nval);
                                  }
-#line 3025 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3170 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 93:
-#line 1128 "sieve/sieve.y" /* yacc.c:1646  */
+  case 122:
+#line 1066 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.mailbox) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mailbox");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.id != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":id");
+                                         free((yyval.cl)->u.n.id);
                                      }
 
-                                     (yyval.test) = build_mailboxtest(MAILBOXEXISTS, NULL,
-                                                            NULL, NULL, (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "mailboxexists test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.id = (yyvsp[0].sval);
                                  }
-#line 3047 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3185 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 94:
-#line 1147 "sieve/sieve.y" /* yacc.c:1646  */
+  case 123:
+#line 1076 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.mboxmetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mboxmetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.method != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":method");
+                                         free((yyval.cl)->u.n.method);
                                      }
 
-                                     (yyval.test) = build_mailboxtest(METADATA,
-                                                            (yyvsp[-3].ctag), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "metadata test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.method = (yyvsp[0].sval);
                                  }
-#line 3069 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3200 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 95:
-#line 1166 "sieve/sieve.y" /* yacc.c:1646  */
+  case 124:
+#line 1086 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.mboxmetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mboxmetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "priority");
                                      }
 
-                                     (yyval.test) = build_mailboxtest(METADATAEXISTS,
-                                                            NULL, (yyvsp[-1].sval), NULL, (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "metadataexists test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.priority = (yyvsp[0].nval);
                                  }
-#line 3091 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3214 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 96:
-#line 1185 "sieve/sieve.y" /* yacc.c:1646  */
+  case 125:
+#line 1097 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.servermetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "servermetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.message != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":message");
+                                         free((yyval.cl)->u.n.message);
                                      }
 
-                                     (yyval.test) = build_mailboxtest(SERVERMETADATA,
-                                                            (yyvsp[-2].ctag), NULL, (yyvsp[-1].sval), (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "servermetadata test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.message = (yyvsp[0].sval);
                                  }
-#line 3113 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3229 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 97:
-#line 1204 "sieve/sieve.y" /* yacc.c:1646  */
+  case 126:
+#line 1109 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.servermetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "servermetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.n.options != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":options");
+                                         strarray_free((yyval.cl)->u.n.options);
                                      }
 
-                                     (yyval.test) = build_mailboxtest(SERVERMETADATAEXISTS,
-                                                            NULL, NULL, NULL, (yyvsp[0].sl));
-                                     if ((yyval.test) == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "servermetadataexists test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     (yyval.cl)->u.n.options = (yyvsp[0].sl);
                                  }
-#line 3135 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3244 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 98:
-#line 1222 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.test) = NULL; }
-#line 3141 "sieve/sieve.c" /* yacc.c:1646  */
+  case 130:
+#line 1130 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(DENOTIFY, sscript); }
+#line 3250 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 131:
+#line 1131 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.d.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "priority");
+                                     }
+
+                                     (yyval.cl)->u.d.priority = (yyvsp[0].nval);
+                                 }
+#line 3264 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 99:
-#line 1225 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.aetag) = new_aetags(); }
-#line 3147 "sieve/sieve.c" /* yacc.c:1646  */
+  case 132:
+#line 1141 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].cl)->u.d.comp); }
+#line 3270 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 100:
-#line 1227 "sieve/sieve.y" /* yacc.c:1646  */
+  case 133:
+#line 1142 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.aetag) = (yyvsp[-1].aetag);
-                                     if ((yyval.aetag)->addrtag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "address-part");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.aetag)->addrtag = (yyvsp[0].nval);
+                                     if ((yyval.cl)->u.d.pattern) free((yyval.cl)->u.d.pattern);
+                                     (yyval.cl)->u.d.pattern = (yyvsp[0].sval);
                                  }
-#line 3162 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3279 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 104:
-#line 1242 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.aetag) = new_aetags(); }
-#line 3168 "sieve/sieve.c" /* yacc.c:1646  */
+  case 134:
+#line 1150 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(INCLUDE, sscript); }
+#line 3285 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 105:
-#line 1244 "sieve/sieve.y" /* yacc.c:1646  */
+  case 135:
+#line 1151 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.aetag) = (yyvsp[-1].aetag);
-                                     if ((yyval.aetag)->addrtag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "address-part");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.inc.location != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "location");
                                      }
-                                     else (yyval.aetag)->addrtag = (yyvsp[0].nval);
+
+                                     (yyval.cl)->u.inc.location = (yyvsp[0].nval);
                                  }
-#line 3183 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3299 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 108:
-#line 1262 "sieve/sieve.y" /* yacc.c:1646  */
+  case 136:
+#line 1160 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     struct comptags *ctags = (yyvsp[-1].ctag);
-                                     if (ctags->match != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "match-type");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.inc.once != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":once");
                                      }
-                                     else ctags->match = (yyvsp[0].nval);
+
+                                     (yyval.cl)->u.inc.once = 1;
                                  }
-#line 3198 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3313 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 109:
-#line 1273 "sieve/sieve.y" /* yacc.c:1646  */
+  case 137:
+#line 1169 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     struct comptags *ctags = (yyvsp[-2].ctag);
-                                     if (ctags->match != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "match-type");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else {
-                                         ctags->match = (yyvsp[-1].nval);
-                                         ctags->relation =
-                                             verify_relat(parse_script, (yyvsp[0].sval));
-                                         if (ctags->relation == -1) {
-                                             YYERROR; /*vr called yyerror()*/
-                                         }
+                                     if ((yyval.cl)->u.inc.optional != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":optional");
                                      }
+
+                                     (yyval.cl)->u.inc.optional = 1;
                                  }
-#line 3220 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3327 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 110:
-#line 1296 "sieve/sieve.y" /* yacc.c:1646  */
+  case 140:
+#line 1188 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl) = new_command(SNOOZE, sscript); }
+#line 3333 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 141:
+#line 1189 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     struct comptags *ctags = (yyvsp[-2].ctag);
-                                     if (ctags->comparator != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":comparator");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.sn.mailbox != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mailbox");
+                                         free((yyval.cl)->u.sn.mailbox);
                                      }
-                                     else if (!strcmp((yyvsp[0].sval), "i;ascii-numeric") &&
-                                              !parse_script->support.i_ascii_numeric) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "comparator-i;ascii-numeric");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else ctags->comparator = (yyvsp[0].sval);
+
+                                     (yyval.cl)->u.sn.mailbox = (yyvsp[0].sval);
                                  }
-#line 3242 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3348 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 111:
-#line 1322 "sieve/sieve.y" /* yacc.c:1646  */
+  case 142:
+#line 1199 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.cl)->u.sn.is_mboxid = 1; }
+#line 3354 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 143:
+#line 1202 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     struct comptags *ctags = (yyvsp[-2].ctag);
-                                     if (!parse_script->support.index) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (ctags->index != 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ((yyvsp[0].nval) <= 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_INVALID_VALUE,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ((yyval.cl)->u.sn.addflags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":addflags");
+                                         free((yyval.cl)->u.sn.addflags);
                                      }
-                                     else ctags->index = (yyvsp[0].nval);
+
+                                     (yyval.cl)->u.sn.addflags = (yyvsp[0].sl);
                                  }
-#line 3269 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3369 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 112:
-#line 1345 "sieve/sieve.y" /* yacc.c:1646  */
-    { struct comptags *ctags = (yyvsp[-1].ctag);
-                                     if (!parse_script->support.index) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (ctags->index == 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_TAG,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
+  case 144:
+#line 1213 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.sn.removeflags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":removeflags");
+                                         free((yyval.cl)->u.sn.removeflags);
                                      }
-                                     else if (ctags->index < 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":last");
-                                         YYERROR; /* pe should call yyerror() */
+
+                                     (yyval.cl)->u.sn.removeflags = (yyvsp[0].sl);
+                                 }
+#line 3384 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 145:
+#line 1224 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.cl)->u.sn.days != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":weekdays");
                                      }
-                                     else ctags->index *= -1;
+
+                                     (yyval.cl)->u.sn.days = (yyvsp[0].nval);
                                  }
-#line 3295 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3398 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 113:
-#line 1368 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ctag) = new_comptags(); }
-#line 3301 "sieve/sieve.c" /* yacc.c:1646  */
+  case 147:
+#line 1237 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nval) = (yyvsp[-1].nval); }
+#line 3404 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 117:
-#line 1374 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ctag) = new_comptags(); }
-#line 3307 "sieve/sieve.c" /* yacc.c:1646  */
+  case 149:
+#line 1242 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nval) = (yyvsp[-2].nval) | (yyvsp[0].nval); }
+#line 3410 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 120:
-#line 1379 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ctag) = new_comptags(); }
-#line 3313 "sieve/sieve.c" /* yacc.c:1646  */
+  case 150:
+#line 1246 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nval) = verify_weekday(sscript, (yyvsp[0].sval)); }
+#line 3416 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 123:
-#line 1384 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ctag) = new_comptags(); }
-#line 3319 "sieve/sieve.c" /* yacc.c:1646  */
+  case 152:
+#line 1251 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nl) = (yyvsp[-1].nl); }
+#line 3422 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 126:
-#line 1389 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.btag) = new_btags(); }
-#line 3325 "sieve/sieve.c" /* yacc.c:1646  */
+  case 154:
+#line 1256 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nl) = (yyvsp[-2].nl); arrayu64_add((yyval.nl), (yyvsp[0].nval)); }
+#line 3428 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 127:
-#line 1391 "sieve/sieve.y" /* yacc.c:1646  */
+  case 155:
+#line 1260 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.btag) = (yyvsp[-1].btag);
-                                     if ((yyval.btag)->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.btag)->transform = RAW;
+                                     (yyval.nl) = arrayu64_new();
+                                     arrayu64_add((yyval.nl), (yyvsp[0].nval));
                                  }
-#line 3340 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3437 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 128:
-#line 1402 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     (yyval.btag) = (yyvsp[-1].btag);
-                                     if ((yyval.btag)->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.btag)->transform = TEXT;
-                                 }
-#line 3355 "sieve/sieve.c" /* yacc.c:1646  */
+  case 156:
+#line 1267 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.nval) = verify_time(sscript, (yyvsp[0].sval)); }
+#line 3443 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 129:
-#line 1413 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     (yyval.btag) = (yyvsp[-2].btag);
-                                     if ((yyval.btag)->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else {
-                                         (yyval.btag)->transform = CONTENT;
-                                         (yyval.btag)->content_types = (yyvsp[0].sl);
-                                     }
-                                 }
-#line 3373 "sieve/sieve.c" /* yacc.c:1646  */
+  case 157:
+#line 1274 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.testl) = (yyvsp[-1].testl); }
+#line 3449 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 132:
-#line 1430 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.dttag) = new_dttags(); }
-#line 3379 "sieve/sieve.c" /* yacc.c:1646  */
+  case 158:
+#line 1278 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.testl) = new_testlist((yyvsp[0].test), NULL); }
+#line 3455 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 133:
-#line 1432 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     (yyval.dttag) = (yyvsp[-1].dttag);
-                                     if ((yyval.dttag)->zonetag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":originalzone");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.dttag)->zonetag = ORIGINALZONE;
-                                 }
-#line 3394 "sieve/sieve.c" /* yacc.c:1646  */
+  case 159:
+#line 1279 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.testl) = new_testlist((yyvsp[-2].test), (yyvsp[0].testl)); }
+#line 3461 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 138:
-#line 1448 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.dttag) = new_dttags(); }
-#line 3400 "sieve/sieve.c" /* yacc.c:1646  */
+  case 160:
+#line 1283 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_anyof(sscript, (yyvsp[0].testl)); }
+#line 3467 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 142:
-#line 1458 "sieve/sieve.y" /* yacc.c:1646  */
+  case 161:
+#line 1284 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_allof(sscript, (yyvsp[0].testl)); }
+#line 3473 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 162:
+#line 1285 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_not(sscript, (yyvsp[0].test));   }
+#line 3479 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 163:
+#line 1286 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(SFALSE, sscript); }
+#line 3485 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 164:
+#line 1287 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(STRUE, sscript);  }
+#line 3491 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 165:
+#line 1288 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     struct dttags *dttags = (yyvsp[-2].dttag);
-                                     if (dttags->zonetag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":zone");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else if (verify_zone(parse_script, (yyvsp[0].sval)) == -1) {
-                                         YYERROR; /*vr called yyerror()*/
-                                     }
-                                     else {
-                                         dttags->zone = (yyvsp[0].sval);
-                                         dttags->zonetag = ZONE;
-                                     }
+                                     (yyval.test) = new_test(EXISTS, sscript);
+                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                  }
-#line 3421 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3500 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 143:
-#line 1477 "sieve/sieve.y" /* yacc.c:1646  */
+  case 166:
+#line 1292 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.nval) = verify_date_part(parse_script, (yyvsp[0].sval));
-                                     if ((yyval.nval) == -1) {
-                                         YYERROR; /* vdp called yyerror() */
-                                     }
+                                     (yyval.test) = new_test(SIZE, sscript);
+                                     (yyval.test)->u.sz.t = (yyvsp[-1].nval);
+                                     (yyval.test)->u.sz.n = (yyvsp[0].nval);
                                  }
-#line 3432 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3510 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 144:
-#line 1485 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = ALL; }
-#line 3438 "sieve/sieve.c" /* yacc.c:1646  */
+  case 167:
+#line 1299 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_header(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
+#line 3516 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 145:
-#line 1486 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = LOCALPART; }
-#line 3444 "sieve/sieve.c" /* yacc.c:1646  */
+  case 168:
+#line 1302 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_address(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
+#line 3522 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 146:
-#line 1487 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = DOMAIN; }
-#line 3450 "sieve/sieve.c" /* yacc.c:1646  */
+  case 169:
+#line 1304 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_envelope(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
+#line 3528 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 147:
-#line 1489 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.subaddress) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "subaddress");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = USER;
-                                 }
-#line 3464 "sieve/sieve.c" /* yacc.c:1646  */
+  case 170:
+#line 1306 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_body(sscript, (yyvsp[-1].test), (yyvsp[0].sl)); }
+#line 3534 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 148:
-#line 1499 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.subaddress) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "subaddress");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = DETAIL;
-                                 }
-#line 3478 "sieve/sieve.c" /* yacc.c:1646  */
+  case 171:
+#line 1309 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_mbox_meta(sscript,
+                                                        (yyvsp[-2].test), NULL, (yyvsp[-1].sval), (yyvsp[0].sl)); }
+#line 3541 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 149:
-#line 1509 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = IS; }
-#line 3484 "sieve/sieve.c" /* yacc.c:1646  */
+  case 172:
+#line 1313 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_stringt(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
+#line 3547 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 150:
-#line 1510 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = CONTAINS; }
-#line 3490 "sieve/sieve.c" /* yacc.c:1646  */
+  case 173:
+#line 1320 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_hasflag(sscript, (yyvsp[-2].test), (yyvsp[-1].sl), (yyvsp[0].sl)); }
+#line 3553 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 151:
-#line 1511 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = MATCHES; }
-#line 3496 "sieve/sieve.c" /* yacc.c:1646  */
+  case 174:
+#line 1322 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_hasflag(sscript, (yyvsp[-1].test), NULL, (yyvsp[0].sl)); }
+#line 3559 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 152:
-#line 1513 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.regex) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "regex");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = REGEX;
-                                 }
-#line 3510 "sieve/sieve.c" /* yacc.c:1646  */
+  case 175:
+#line 1325 "sieve/sieve.y" /* yacc.c:1646  */
+    { getdatepart = 1; }
+#line 3565 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 153:
-#line 1525 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.relational) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "relational");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = COUNT;
-                                 }
-#line 3524 "sieve/sieve.c" /* yacc.c:1646  */
+  case 176:
+#line 1326 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_date(sscript, (yyvsp[-4].test), (yyvsp[-3].sval), (yyvsp[-1].nval), (yyvsp[0].sl)); }
+#line 3571 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 154:
-#line 1535 "sieve/sieve.y" /* yacc.c:1646  */
+  case 177:
+#line 1329 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_date(sscript, (yyvsp[-2].test), NULL, (yyvsp[-1].nval), (yyvsp[0].sl)); }
+#line 3577 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 178:
+#line 1331 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.relational) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "relational");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = VALUE;
+                                     (yyval.test) = new_test(VALIDNOTIFYMETHOD, sscript);
+                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                  }
-#line 3538 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3586 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 155:
-#line 1547 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = OVER; }
-#line 3544 "sieve/sieve.c" /* yacc.c:1646  */
+  case 179:
+#line 1336 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_mbox_meta(sscript,
+                                                        (yyvsp[-3].test), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl)); }
+#line 3593 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 156:
-#line 1548 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = UNDER; }
-#line 3550 "sieve/sieve.c" /* yacc.c:1646  */
+  case 180:
+#line 1339 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_ihave(sscript, (yyvsp[0].sl)); }
+#line 3599 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 157:
-#line 1552 "sieve/sieve.y" /* yacc.c:1646  */
+  case 181:
+#line 1342 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.copy) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "copy");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = 1;
+                                     (yyval.test) = new_test(MAILBOXEXISTS, sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                  }
-#line 3564 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3609 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 158:
-#line 1564 "sieve/sieve.y" /* yacc.c:1646  */
+  case 182:
+#line 1349 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_mbox_meta(sscript,
+                                                        (yyvsp[-3].test), (yyvsp[-2].sval), (yyvsp[-1].sval), (yyvsp[0].sl)); }
+#line 3616 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 183:
+#line 1353 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     if (!parse_script->support.mailbox) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mailbox");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     (yyval.nval) = 1;
+                                     (yyval.test) = new_test(METADATAEXISTS, sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), (yyvsp[-1].sval), NULL, (yyvsp[0].sl));
                                  }
-#line 3578 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3626 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 159:
-#line 1575 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.ftag) = new_ftags(); }
-#line 3584 "sieve/sieve.c" /* yacc.c:1646  */
+  case 184:
+#line 1360 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_mbox_meta(sscript,
+                                                        (yyvsp[-2].test), NULL, (yyvsp[-1].sval), (yyvsp[0].sl)); }
+#line 3633 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 160:
-#line 1577 "sieve/sieve.y" /* yacc.c:1646  */
+  case 185:
+#line 1364 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.ftag) = (yyvsp[-1].ftag);
-                                     if ((yyval.ftag)->copy) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":copy");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.ftag)->copy = (yyvsp[0].nval);
+                                     (yyval.test) = new_test(SERVERMETADATAEXISTS,
+                                                   sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                  }
-#line 3599 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3644 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 161:
-#line 1588 "sieve/sieve.y" /* yacc.c:1646  */
+  case 186:
+#line 1372 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.ftag) = (yyvsp[-1].ftag);
-                                     if ((yyval.ftag)->create) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":create");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.ftag)->create = (yyvsp[0].nval);
+                                     (yyval.test) = new_test(VALIDEXTLIST, sscript);
+                                     (yyval.test)->u.sl = (yyvsp[0].sl);
                                  }
-#line 3614 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3653 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 162:
-#line 1599 "sieve/sieve.y" /* yacc.c:1646  */
-    {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ((yyval.ftag)->flags != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+  case 187:
+#line 1376 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = build_duplicate(sscript, (yyvsp[0].test)); }
+#line 3659 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-                                     (yyval.ftag) = (yyvsp[-2].ftag);
-                                     if (!parse_script->support.variables) {
-                                         verify_flaglist((yyvsp[0].sl));
-                                     }
-                                     if (!(yyvsp[0].sl)->count) strarray_add((yyvsp[0].sl), "");
-                                     (yyval.ftag)->flags = (yyvsp[0].sl);
+  case 188:
+#line 1379 "sieve/sieve.y" /* yacc.c:1646  */
+    { 
+                                     (yyval.test) = new_test(SPECIALUSEEXISTS, sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                  }
-#line 3640 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3669 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 163:
-#line 1622 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.nval) = 0; }
-#line 3646 "sieve/sieve.c" /* yacc.c:1646  */
+  case 189:
+#line 1386 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     (yyval.test) = new_test(SPECIALUSEEXISTS, sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), (yyvsp[-1].sval), NULL, (yyvsp[0].sl));
+                                 }
+#line 3679 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 164:
-#line 1624 "sieve/sieve.y" /* yacc.c:1646  */
+  case 190:
+#line 1393 "sieve/sieve.y" /* yacc.c:1646  */
     {
-                                     (yyval.nval) = (yyvsp[-1].nval);
-                                     if ((yyval.nval)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":copy");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else (yyval.nval) = (yyvsp[0].nval);
+                                     (yyval.test) = new_test(MAILBOXIDEXISTS, sscript);
+                                     (yyval.test) = build_mbox_meta(sscript,
+                                                          (yyval.test), NULL, NULL, (yyvsp[0].sl));
                                  }
-#line 3661 "sieve/sieve.c" /* yacc.c:1646  */
+#line 3689 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 165:
-#line 1636 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.testl) = (yyvsp[-1].testl); }
-#line 3667 "sieve/sieve.c" /* yacc.c:1646  */
+  case 191:
+#line 1399 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     (yyval.test) = new_test(JMAPQUERY, sscript);
+                                     (yyval.test) = build_jmapquery(sscript, (yyval.test), (yyvsp[0].sval));
+                                 }
+#line 3698 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 166:
-#line 1639 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.testl) = new_testlist((yyvsp[0].test), NULL); }
-#line 3673 "sieve/sieve.c" /* yacc.c:1646  */
+  case 192:
+#line 1404 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(SFALSE, sscript); }
+#line 3704 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
-  case 167:
-#line 1640 "sieve/sieve.y" /* yacc.c:1646  */
-    { (yyval.testl) = new_testlist((yyvsp[-2].test), (yyvsp[0].testl)); }
-#line 3679 "sieve/sieve.c" /* yacc.c:1646  */
+  case 195:
+#line 1415 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(HEADERT, sscript); }
+#line 3710 "sieve/sieve.c" /* yacc.c:1646  */
     break;
 
+  case 196:
+#line 1416 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 3716 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
 
-#line 3683 "sieve/sieve.c" /* yacc.c:1646  */
-      default: break;
-    }
-  /* User semantic actions sometimes alter yychar, and that requires
-     that yytoken be updated with the new translation.  We take the
+  case 198:
+#line 1417 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 3722 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 200:
+#line 1418 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 3728 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 202:
+#line 1419 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 3734 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 204:
+#line 1424 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
+                                     }
+
+                                     ctags->match = (yyvsp[0].nval);
+                                 }
+#line 3748 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 205:
+#line 1434 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->match != COUNT &&
+                                         ctags->match != VALUE &&
+                                         !supported(SIEVE_CAPA_RELATIONAL)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "relational");
+                                     }
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
+                                     }
+
+                                     ctags->match = (yyvsp[-1].nval);
+                                     ctags->relation = (yyvsp[0].nval);
+                                 }
+#line 3770 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 209:
+#line 1458 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (!supported(SIEVE_CAPA_REGEX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "regex");
+                                     }
+                                 }
+#line 3782 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 218:
+#line 1485 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->match != LIST &&
+                                         !supported(SIEVE_CAPA_EXTLISTS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "extlists");
+                                     }
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
+                                     }
+
+                                     ctags->match = LIST;
+                                 }
+#line 3802 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 219:
+#line 1505 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->collation != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":comparator");
+                                     }
+
+                                     ctags->collation = (yyvsp[0].nval);
+                                 }
+#line 3816 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 222:
+#line 1520 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (!supported(SIEVE_CAPA_COMP_NUMERIC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "comparator-"
+                                                      "i;ascii-numeric");
+                                     }
+                                 }
+#line 3829 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 223:
+#line 1532 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->index == INT_MIN) {
+                                         /* :last before :index */
+                                         ctags->index = -(yyvsp[0].nval);
+                                     }
+                                     else if (ctags->index != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":index");
+                                     }
+                                     else {
+                                       if (!supported(SIEVE_CAPA_INDEX)) {
+                                             sieveerror_c(sscript,
+                                                          SIEVE_MISSING_REQUIRE,
+                                                          "index");
+                                         }
+
+                                         ctags->index = (yyvsp[0].nval);
+                                     }
+                                 }
+#line 3854 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 224:
+#line 1552 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (ctags->index > 0) {
+                                         ctags->index *= -1;
+                                     }
+                                     else if (ctags->index < 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
+                                     }
+                                     else if (ctags->index == 0) {
+                                       if (!supported(SIEVE_CAPA_INDEX)) {
+                                             sieveerror_c(sscript,
+                                                          SIEVE_MISSING_REQUIRE,
+                                                          "index");
+                                         }
+
+                                         /* :last before :index */
+                                         ctags->index = INT_MIN;
+                                     }
+                                 }
+#line 3879 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 225:
+#line 1576 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(ADDRESS, sscript); }
+#line 3885 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 227:
+#line 1578 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3891 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 229:
+#line 1579 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3897 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 231:
+#line 1580 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3903 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 233:
+#line 1581 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3909 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 235:
+#line 1586 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     /* $0 refers to a test_t* (ADDR/ENV)*/
+                                     test_t *test = (yyvsp[-1].test);
+
+                                     if (test->u.ae.addrpart != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "address-part");
+                                     }
+
+                                     test->u.ae.addrpart = (yyvsp[0].nval);
+                                 }
+#line 3926 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 239:
+#line 1604 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if (!supported(SIEVE_CAPA_SUBADDRESS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "subaddress");
+                                     }
+                                 }
+#line 3938 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 242:
+#line 1621 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(ENVELOPE, sscript); }
+#line 3944 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 244:
+#line 1623 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3950 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 246:
+#line 1624 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3956 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 248:
+#line 1625 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.ae.comp); }
+#line 3962 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 250:
+#line 1630 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(ENVIRONMENT, sscript); }
+#line 3968 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 251:
+#line 1631 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 3974 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 253:
+#line 1632 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 3980 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 255:
+#line 1637 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(BODY, sscript); }
+#line 3986 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 256:
+#line 1638 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.b.transform != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "transform");
+                                     }
+
+                                     (yyval.test)->u.b.transform = (yyvsp[0].nval);
+                                 }
+#line 4000 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 257:
+#line 1649 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.b.transform != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "transform");
+                                         strarray_free((yyval.test)->u.b.content_types);
+                                     }
+
+                                     (yyval.test)->u.b.transform = CONTENT;
+                                     (yyval.test)->u.b.content_types = (yyvsp[0].sl);
+                                 }
+#line 4016 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 258:
+#line 1661 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.b.comp); }
+#line 4022 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 260:
+#line 1662 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.b.comp); }
+#line 4028 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 264:
+#line 1673 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(STRINGT, sscript); }
+#line 4034 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 265:
+#line 1674 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 4040 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 267:
+#line 1675 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 4046 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 269:
+#line 1676 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 4052 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 271:
+#line 1681 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(HASFLAG, sscript); }
+#line 4058 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 272:
+#line 1682 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 4064 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 274:
+#line 1683 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.hhs.comp); }
+#line 4070 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 276:
+#line 1688 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(DATE, sscript); }
+#line 4076 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 278:
+#line 1690 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.dt.zonetag != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":originalzone");
+                                     }
+
+                                     (yyval.test)->u.dt.zonetag = ORIGINALZONE;
+                                 }
+#line 4090 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 279:
+#line 1699 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.dt.comp); }
+#line 4096 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 281:
+#line 1700 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.dt.comp); }
+#line 4102 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 283:
+#line 1701 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.dt.comp); }
+#line 4108 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 285:
+#line 1706 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     /* $0 refers to a test_t* ([CURRENT]DATE)*/
+                                     test_t *test = (yyvsp[-2].test);
+
+                                     if (test->u.dt.zonetag != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":zone");
+                                     }
+
+                                     test->u.dt.zonetag = ZONE;
+                                     test->u.dt.zone = (yyvsp[0].nval);
+                                 }
+#line 4126 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 286:
+#line 1723 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(CURRENTDATE, sscript); }
+#line 4132 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 288:
+#line 1725 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.dt.comp); }
+#line 4138 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 290:
+#line 1726 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.dt.comp); }
+#line 4144 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 305:
+#line 1748 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(NOTIFYMETHODCAPABILITY, sscript); }
+#line 4150 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 306:
+#line 1749 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 4156 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 308:
+#line 1750 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 4162 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 310:
+#line 1755 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test((yyvsp[0].nval), sscript); }
+#line 4168 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 311:
+#line 1756 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 4174 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 313:
+#line 1757 "sieve/sieve.y" /* yacc.c:1646  */
+    { ctags = &((yyvsp[0].test)->u.mm.comp); }
+#line 4180 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 315:
+#line 1762 "sieve/sieve.y" /* yacc.c:1646  */
+    { (yyval.test) = new_test(DUPLICATE, sscript); }
+#line 4186 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 316:
+#line 1763 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.dup.idtype != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      (yyvsp[-1].nval) == HEADER ?
+                                                      ":header" : ":uniqueid");
+                                         free((yyval.test)->u.dup.idval);
+                                     }
+
+                                     (yyval.test)->u.dup.idtype = (yyvsp[-1].nval);
+                                     (yyval.test)->u.dup.idval = (yyvsp[0].sval);
+                                 }
+#line 4203 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 317:
+#line 1775 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.dup.handle != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":handle");
+                                         free((yyval.test)->u.dup.handle);
+                                     }
+
+                                     (yyval.test)->u.dup.handle = (yyvsp[0].sval);
+                                 }
+#line 4218 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 318:
+#line 1785 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.dup.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":seconds");
+                                     }
+
+                                     (yyval.test)->u.dup.seconds = (yyvsp[0].nval);
+                                 }
+#line 4232 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+  case 319:
+#line 1794 "sieve/sieve.y" /* yacc.c:1646  */
+    {
+                                     if ((yyval.test)->u.dup.last != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
+                                     }
+
+                                     (yyval.test)->u.dup.last = 1;
+                                 }
+#line 4246 "sieve/sieve.c" /* yacc.c:1646  */
+    break;
+
+
+#line 4250 "sieve/sieve.c" /* yacc.c:1646  */
+      default: break;
+    }
+  /* User semantic actions sometimes alter yychar, and that requires
+     that yytoken be updated with the new translation.  We take the
      approach of translating immediately before every use of yytoken.
      One alternative is translating here after every semantic action,
      but that translation would be missed if the semantic action invokes
@@ -3729,7 +4296,7 @@ yyerrlab:
     {
       ++yynerrs;
 #if ! YYERROR_VERBOSE
-      yyerror (parse_script, YY_("syntax error"));
+      yyerror (sscript, YY_("syntax error"));
 #else
 # define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                         yyssp, yytoken)
@@ -3756,7 +4323,7 @@ yyerrlab:
                 yymsgp = yymsg;
               }
           }
-        yyerror (parse_script, yymsgp);
+        yyerror (sscript, yymsgp);
         if (yysyntax_error_status == 2)
           goto yyexhaustedlab;
       }
@@ -3780,7 +4347,7 @@ yyerrlab:
       else
         {
           yydestruct ("Error: discarding",
-                      yytoken, &yylval, parse_script);
+                      yytoken, &yylval, sscript);
           yychar = YYEMPTY;
         }
     }
@@ -3836,7 +4403,7 @@ yyerrlab1:
 
 
       yydestruct ("Error: popping",
-                  yystos[yystate], yyvsp, parse_script);
+                  yystos[yystate], yyvsp, sscript);
       YYPOPSTACK (1);
       yystate = *yyssp;
       YY_STACK_PRINT (yyss, yyssp);
@@ -3873,7 +4440,7 @@ yyabortlab:
 | yyexhaustedlab -- memory exhaustion comes here.  |
 `-------------------------------------------------*/
 yyexhaustedlab:
-  yyerror (parse_script, YY_("memory exhausted"));
+  yyerror (sscript, YY_("memory exhausted"));
   yyresult = 2;
   /* Fall through.  */
 #endif
@@ -3885,7 +4452,7 @@ yyreturn:
          user semantic actions for why this is necessary.  */
       yytoken = YYTRANSLATE (yychar);
       yydestruct ("Cleanup: discarding lookahead",
-                  yytoken, &yylval, parse_script);
+                  yytoken, &yylval, sscript);
     }
   /* Do not reclaim the symbols of the rule whose action triggered
      this YYABORT or YYACCEPT.  */
@@ -3894,7 +4461,7 @@ yyreturn:
   while (yyssp != yyss)
     {
       yydestruct ("Cleanup: popping",
-                  yystos[*yyssp], yyvsp, parse_script);
+                  yystos[*yyssp], yyvsp, sscript);
       YYPOPSTACK (1);
     }
 #ifndef yyoverflow
@@ -3907,918 +4474,1264 @@ yyreturn:
 #endif
   return yyresult;
 }
-#line 1643 "sieve/sieve.y" /* yacc.c:1906  */
+#line 1812 "sieve/sieve.y" /* yacc.c:1906  */
 
 
 
 /*
- * Actions
+ * Yacc actions
  */
 
-void yyerror(sieve_script_t *parse_script, const char *msg)
+void yyerror(sieve_script_t *sscript, const char *msg)
 {
-    parse_script->err++;
-    if (parse_script->interp.err) {
-        parse_script->interp.err(sievelineno, msg,
-                                 parse_script->interp.interp_context,
-                                 parse_script->script_context);
+    if (sscript->ignore_err) return;
+
+    sscript->err++;
+    if (sscript->interp.err) {
+        sscript->interp.err(sievelineno, msg, sscript->interp.interp_context,
+                            sscript->script_context);
     }
 }
 
-static void parse_error(sieve_script_t *parse_script, int err, ...)
-{
-    va_list args;
 
-    va_start(args, err);
-    vsnprintf(parse_script->sieveerr, ERR_BUF_SIZE, error_message(err), args);
-    yyerror(parse_script, parse_script->sieveerr);
-    va_end(args);
+static void
+__attribute__((format(printf, 2, 0)))
+vsieveerror_f(sieve_script_t *sscript,
+              const char *fmt, va_list args)
+{
+    buf_reset(&sscript->sieveerr);
+    buf_vprintf(&sscript->sieveerr, fmt, args);
+    yyerror(sscript, buf_cstring(&sscript->sieveerr));
 }
 
-static char *check_reqs(sieve_script_t *parse_script, strarray_t *sa)
+void
+__attribute__((format(printf, 2, 3)))
+sieveerror_f(sieve_script_t *sscript, const char *fmt, ...)
 {
-    char *s;
-    struct buf errs = BUF_INITIALIZER;
-    char *res;
-
-    while ((s = strarray_shift(sa))) {
-        if (!script_require(parse_script, s)) {
-            if (!errs.len)
-                buf_printf(&errs,
-                           "Unsupported feature(s) in \"require\": \"%s\"", s);
-            else buf_printf(&errs, ", \"%s\"", s);
-        }
-        free(s);
-    }
-    strarray_free(sa);
-
-    res = buf_release(&errs);
-    if (!res[0]) {
-        free(res);
-        return NULL;
-    }
+    va_list args;
 
-    return res;
+    va_start(args, fmt);
+    vsieveerror_f(sscript, fmt, args);
+    va_end(args);
 }
 
-static test_t *build_address(int t, struct aetags *ae,
-                             strarray_t *sl, strarray_t *pl)
+void sieveerror_c(sieve_script_t *sscript, int code, ...)
 {
-    test_t *ret = new_test(t);  /* can be either ADDRESS or ENVELOPE */
-
-    assert((t == ADDRESS) || (t == ENVELOPE));
-
-    if (ret) {
-        ret->u.ae.comptag = ae->comptags.match;
-        ret->u.ae.relation=ae->comptags.relation;
-        ret->u.ae.comparator=xstrdup(ae->comptags.comparator);
-        ret->u.ae.index = ae->comptags.index;
-        ret->u.ae.sl = sl;
-        ret->u.ae.pl = pl;
-        ret->u.ae.addrpart = ae->addrtag;
-        free_aetags(ae);
+    va_list args;
 
-    }
-    return ret;
+    va_start(args, code);
+    vsieveerror_f(sscript, error_message(code), args);
+    va_end(args);
 }
 
-static test_t *build_header(int t, struct comptags *c,
-                            strarray_t *sl, strarray_t *pl)
+/*
+ * variable-ref        =  "${" [namespace] variable-name "}"
+ * namespace           =  identifier "." *sub-namespace
+ * sub-namespace       =  variable-name "."
+ * variable-name       =  num-variable / identifier
+ * num-variable        =  1*DIGIT
+ * identifier          =  (ALPHA / "_") *(ALPHA / DIGIT / "_")
+ */
+static int find_variables(sieve_script_t *sscript, char *s, int find_one)
 {
-    test_t *ret = new_test(t);  /* can be HEADER or HASFLAG or STRINGT */
+    char *p = s;
 
-    assert((t == HEADER) || (t == HASFLAG) || (t == STRINGT));
+    if (!supported(SIEVE_CAPA_VARIABLES)) return !find_one;
 
-    if (ret) {
-        ret->u.h.comptag = c->match;
-        ret->u.h.relation = c->relation;
-        ret->u.h.comparator = xstrdup(c->comparator);
-        ret->u.h.index = c->index;
-        ret->u.h.sl = sl;
-        ret->u.h.pl = pl;
-        free_comptags(c, 1);
-    }
-    return ret;
-}
+    while ((p = strstr(p, "${"))) {
+        long num = 0, is_id = 0;
 
-static test_t *build_body(int t, struct btags *b, strarray_t *pl)
-{
-    test_t *ret = new_test(t);  /* can be BODY */
+        p += 2;  /* skip over beginning of variable-ref */
 
-    assert(t == BODY);
+        do {
+            if (isdigit(*p)) {
+                /* possible num-variable - get value and skip over digits */
+                num = strtol(p, &p, 10);
+            }
+            else if (!find_one) {
+                /* validating match variables - ignoroe identifiers */
+                break;
+            }
+            else if (isalpha(*p) || *p == '_') {
+                /* possible identifier - skip over identifier chars */
+                for (++p; isalnum(*p) || *p == '_'; p++);
+                is_id = 1;
+            }
+            else {
+                /* not a valid variable-name */
+                break;
+            }
 
-    if (ret) {
-        ret->u.b.comptag = b->comptags.match;
-        ret->u.b.relation = b->comptags.relation;
-        ret->u.b.comparator = xstrdup(b->comptags.comparator);
-        ret->u.b.transform = b->transform;
-        ret->u.b.offset = b->offset;
-        ret->u.b.content_types = b->content_types; b->content_types = NULL;
-        ret->u.b.pl = pl;
-        free_btags(b);
-    }
-    return ret;
-}
+            if (*p == '}') {
+                /* end of variable-ref */
+                if (find_one) return 1;
+
+                /* validating match variables */
+                if (!is_id && num > MAX_MATCH_VARS) {
+                    sieveerror_f(sscript, "string '%s':"
+                                 " match variable index > %u unsupported",
+                                 s, MAX_MATCH_VARS);
+                    return 0;
+                }
+            }
 
-static test_t *build_mailboxtest(int t, struct comptags *c,
-                                 const char *extname, const char *keyname,
-                                 strarray_t *keylist)
-{
-    test_t *ret = new_test(t);
-
-    if (ret) {
-        ret->u.mbx.extname = xstrdupnull(extname);
-        ret->u.mbx.keyname = xstrdupnull(keyname);
-        ret->u.mbx.keylist = keylist;
-        if (c) {
-            canon_comptags(c);
-            ret->u.mbx.comptag = c->match;
-            ret->u.mbx.relation = c->relation;
-            ret->u.mbx.comparator = xstrdup(c->comparator);
-            free_comptags(c, 1);
-        }
+        } while (is_id && *p == '.' && *(++p));  /* (sub-)namespace */
     }
 
-    return ret;
+    return !find_one;
 }
 
-static commandlist_t *build_vacation(int t, struct vtags *v, char *reason)
+static int chk_match_vars(sieve_script_t *sscript, char *s)
 {
-    commandlist_t *ret = new_command(t);
-
-    assert(t == VACATION);
-
-    if (ret) {
-        ret->u.v.subject = v->subject; v->subject = NULL;
-        ret->u.v.from = v->from; v->from = NULL;
-        ret->u.v.handle = v->handle; v->handle = NULL;
-        ret->u.v.seconds = v->seconds;
-        ret->u.v.mime = v->mime;
-        ret->u.v.addresses = v->addresses; v->addresses = NULL;
-        free_vtags(v);
-        ret->u.v.message = reason;
-    }
-    return ret;
+    return find_variables(sscript, s, 0 /* find_one */);
 }
 
-static commandlist_t *build_notify(int t, struct ntags *n)
+static int contains_variable(sieve_script_t *sscript, char *s)
 {
-    commandlist_t *ret = new_command(t);
-
-    assert(t == NOTIFY);
-       if (ret) {
-        ret->u.n.method = n->method; n->method = NULL;
-        ret->u.n.id = n->id; n->id = NULL;
-        ret->u.n.options = n->options; n->options = NULL;
-        ret->u.n.priority = n->priority;
-        ret->u.n.message = n->message; n->message = NULL;
-        free_ntags(n);
-    }
-    return ret;
+    return find_variables(sscript, s, 1 /* find_one */);
 }
 
-static commandlist_t *build_denotify(int t, struct dtags *d)
+/*
+ * Valid UTF-8 check (from RFC 2640 Annex B.1)
+ *
+ * The following routine checks if a byte sequence is valid UTF-8. This
+ * is done by checking for the proper tagging of the first and following
+ * bytes to make sure they conform to the UTF-8 format. It then checks
+ * to assure that the data part of the UTF-8 sequence conforms to the
+ * proper range allowed by the encoding. Note: This routine will not
+ * detect characters that have not been assigned and therefore do not
+ * exist.
+ */
+static int verify_utf8(sieve_script_t *sscript, char *s)
 {
-    commandlist_t *ret = new_command(t);
+    const char *buf = s;
+    const char *endbuf = s + strlen(s);
+    unsigned char byte2mask = 0x00, c;
+    int trailing = 0;  /* trailing (continuation) bytes to follow */
 
-    assert(t == DENOTIFY);
+    while (buf != endbuf) {
+        c = *buf++;
+        if (trailing) {
+            if ((c & 0xC0) == 0x80) {           /* Does trailing byte
+                                                   follow UTF-8 format? */
+                if (byte2mask) {                /* Need to check 2nd byte
+                                                   for proper range? */
+                    if (c & byte2mask)          /* Are appropriate bits set? */
+                        byte2mask = 0x00;
+                    else
+                        break;
+                }
+                trailing--;
+            }
+            else
+                break;
+        }
+        else {
+            if ((c & 0x80) == 0x00)             /* valid 1 byte UTF-8 */
+                continue;
+            else if ((c & 0xE0) == 0xC0)        /* valid 2 byte UTF-8 */
+                if (c & 0x1E) {                 /* Is UTF-8 byte
+                                                   in proper range? */
+                    trailing = 1;
+                }
+                else
+                    break;
+            else if ((c & 0xF0) == 0xE0) {      /* valid 3 byte UTF-8 */
+                if (!(c & 0x0F)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x20;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 2;
+            }
+            else if ((c & 0xF8) == 0xF0) {      /* valid 4 byte UTF-8 */
+                if (!(c & 0x07)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x30;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 3;
+            }
+            else if ((c & 0xFC) == 0xF8) {      /* valid 5 byte UTF-8 */
+                if (!(c & 0x03)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x38;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 4;
+            }
+            else if ((c & 0xFE) == 0xFC) {      /* valid 6 byte UTF-8 */
+                if (!(c & 0x01)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x3C;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 5;
+            }
+            else
+                break;
+        }
+    }
 
-    if (ret) {
-        ret->u.d.comptag = d->comptags.match;
-        ret->u.d.relation = d->comptags.relation;
-        ret->u.d.pattern = xstrdupnull(d->pattern);
-        ret->u.d.priority = d->priority;
-        free_dtags(d);
+    if ((buf != endbuf) || trailing) {
+        sieveerror_f(sscript, "string '%s': not valid utf8", s);
+        return 0;
     }
-    return ret;
+
+    return 1;
 }
 
-static commandlist_t *build_keep(int t, struct ftags *f)
+static int verify_stringlist(sieve_script_t *sscript, strarray_t *sa,
+                             int (*verify)(sieve_script_t*, char *))
 {
-    commandlist_t *ret = new_command(t);
-
-    assert(t == KEEP);
+    int i;
 
-    if (ret) {
-        ret->u.k.copy = f->copy;
-        ret->u.k.flags = f->flags; f->flags = NULL;
-        free_ftags(f);
+    for (i = 0 ; i < strarray_size(sa) ; i++) {
+        if (!verify(sscript, (char *) strarray_nth(sa, i))) return 0;
     }
-    return ret;
+    return 1;
 }
 
-static commandlist_t *build_fileinto(int t, struct ftags *f, char *folder)
+#ifdef ENABLE_REGEX
+static int verify_regexlist(sieve_script_t *sscript,
+                            const strarray_t *sa, int collation)
 {
-    commandlist_t *ret = new_command(t);
+    int i, ret = 0;
+    regex_t reg;
+    int cflags = REG_EXTENDED | REG_NOSUB;
 
-    assert(t == FILEINTO);
+#ifdef HAVE_PCREPOSIX_H
+    /* support UTF8 comparisons */
+    cflags |= REG_UTF8;
+#endif
 
-    if (ret) {
-        ret->u.f.copy = f->copy;
-        ret->u.f.create = f->create;
-        ret->u.f.flags = f->flags; f->flags = NULL;
-        if (config_getswitch(IMAPOPT_SIEVE_UTF8FILEINTO)) {
-            ret->u.f.folder = xmalloc(5 * strlen(folder) + 1);
-            UTF8_to_mUTF7(ret->u.f.folder, folder);
-        }
-        else {
-            ret->u.f.folder = xstrdup(folder);
+    if (collation == ASCIICASEMAP) {
+        cflags |= REG_ICASE;
+    }
+
+    for (i = 0 ; !ret && i < strarray_size(sa) ; i++) {
+        const char *s = strarray_nth(sa, i);
+
+        /* Don't try to validate a regex that includes variables */
+        if (supported(SIEVE_CAPA_VARIABLES) && strstr(s, "${")) continue;
+
+        /* Check if the regex will compile */
+        if ((ret = regcomp(&reg, s, cflags)) != 0) {
+            size_t errbuf_size = regerror(ret, &reg, NULL, 0);
+
+            buf_reset(&sscript->sieveerr);
+            buf_ensure(&sscript->sieveerr, errbuf_size);
+            (void) regerror(ret, &reg,
+                            (char *) buf_base(&sscript->sieveerr),
+                            errbuf_size);
+            buf_truncate(&sscript->sieveerr, errbuf_size);
+            yyerror(sscript, buf_cstring(&sscript->sieveerr));
         }
-        free_ftags(f);
+
+        regfree(&reg);
     }
-    return ret;
+
+    return (ret == 0);
 }
+#else
 
-static commandlist_t *build_redirect(int t, int copy, char *address)
+static int verify_regexlist(sieve_script_t *sscript __attribute__((unused)),
+                            const strarray_t *sa __attribute__((unused)),
+                            char *comp __attribute__((unused)))
 {
-    commandlist_t *ret = new_command(t);
+    return 0;
+}
+#endif /* ENABLE_REGEX */
 
-    assert(t == REDIRECT);
+static int verify_patternlist(sieve_script_t *sscript,
+                              strarray_t *sa, comp_t *c,
+                              int (*verify)(sieve_script_t*, char *))
+{
+    if (verify && !verify_stringlist(sscript, sa, verify)) return 0;
 
-    if (ret) {
-        ret->u.r.copy = copy;
-        ret->u.r.address = address;
-    }
-    return ret;
+    canon_comptags(c, sscript);
+
+    return (c->match == REGEX) ?
+        verify_regexlist(sscript, sa, c->collation) : 1;
 }
 
-static commandlist_t *build_include(int t, struct itags *i, char* script)
+static int verify_address(sieve_script_t *sscript, char *s)
 {
-    commandlist_t *ret = new_command(t);
+    if (contains_variable(sscript, s)) return 1;
 
-    assert(t == INCLUDE);
+    YY_BUFFER_STATE buffer = addr_scan_string(s);
+    int r = 1;
 
-    if (i->location == -1) i->location = PERSONAL;
-    if (i->once == -1) i->once = 0;
-    if (i->optional == -1) i->optional = 0;
-
-    if (ret) {
-        ret->u.inc.location = i->location;
-        ret->u.inc.once = i->once;
-        ret->u.inc.optional = i->optional;
-        ret->u.inc.script = script;
-        free(i);
+    sscript->addrerr[0] = '\0';    /* paranoia */
+    if (addrparse(sscript)) {
+        sieveerror_f(sscript, "address '%s': %s", s, sscript->addrerr);
+        r = 0;
     }
-    return ret;
+    addr_delete_buffer(buffer);
+
+    return r;
 }
 
-static test_t *build_date(int t, struct dttags *dt,
-                          char *hn, int part, strarray_t *kl)
+static int verify_mailbox(sieve_script_t *sscript, char *s)
 {
-    test_t *ret = new_test(t);
-    assert(t == DATE || t == CURRENTDATE);
-
-    if (ret) {
-        ret->u.dt.comptag = dt->comptags.match;
-        ret->u.dt.relation = dt->comptags.relation;
-        ret->u.dt.comparator = xstrdup(dt->comptags.comparator);
-        ret->u.dt.index = dt->comptags.index;
-        ret->u.dt.zone = xstrdupnull(dt->zone);
-        ret->u.dt.zonetag = dt->zonetag;
-        ret->u.dt.date_part = part;
-        ret->u.dt.header_name = xstrdupnull(hn);
-        ret->u.dt.kl = kl;
-        free_dttags(dt);
+    if (!verify_utf8(sscript, s)) {
+        sieveerror_f(sscript, "mailbox '%s': not a valid mailbox", s);
+        return 0;
     }
-    return ret;
+
+    return 1;
 }
 
-static commandlist_t *build_set(int t, struct stags *s,
-                                char *variable, char *value)
+static int verify_headername(sieve_script_t *sscript, char *hdr)
 {
-    commandlist_t *ret = new_command(t);
+    char *h = hdr;
+
+    while (*h) {
+        /*
+           field-name      =       1*ftext
+           ftext           =       %d33-57 / %d59-126
+           ; Any character except
+           ;  controls, SP, and
+           ;  ":".
+        */
+        if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
+            sieveerror_f(sscript, "header field name '%s':"
+                         " not a valid header field name"
+                         " per RFC 5322, Section 3.6.8", hdr);
+            return 0;
+        }
+        h++;
+    }
+    return 1;
+}
 
-    assert(t == SET);
+static int verify_headerbody(sieve_script_t *sscript, char *val)
+{
+    char *v = val + strlen(val);
 
-    if (ret) {
-        ret->u.s.mod40 = s->mod40;
-        ret->u.s.mod30 = s->mod30;
-        ret->u.s.mod20 = s->mod20;
-        ret->u.s.mod10 = s->mod10;
-        ret->u.s.variable = xstrdup(variable);
-        ret->u.s.value = xstrdup(value);
+    /* trim any trailing CR/LF */
+    while (--v >= val && (*v == '\r' || *v == '\n')) {
+        *v = '\0';
+    }
 
-        free_stags(s);
+    /* make sure any other CRLF is folding whitespace */
+    for (v = val; *v; v++) {
+        if (*v == '\r' && *++v != '\n') break;
+        if (*v == '\n' && *++v != ' ' && *v != '\t') break;
+    }
+    if (*v != '\0') {
+        sieveerror_f(sscript, "header field body '%s':"
+                     " not a valid header field body"
+                     " per RFC 5322, Section 3.2.5", val);
+        return 0;
     }
 
-    return ret;
+    return verify_utf8(sscript, val);
 }
 
-static commandlist_t *build_flag(int t, char *variable, strarray_t *flags)
+static int verify_addrheader(sieve_script_t *sscript, char *hdr)
 {
-    commandlist_t *ret = new_command(t);
+    const char **h, *hdrs[] = {
+        "from", "sender", "reply-to",   /* RFC5322 originator fields */
+        "to", "cc", "bcc",              /* RFC5322 destination fields */
+        "message-id", "in-reply-to",    /* RFC5322 identification fields */
+        "references"
+        "resent-from", "resent-sender", /* RFC5322 resent fields */
+        "resent-to", "resent-cc", "resent-bcc",
+        "return-path",                  /* RFC5322 trace fields */
+        "disposition-notification-to",  /* RFC8098 MDN request fields */
+        "approved",                     /* RFC5536 moderator/control fields */
+        "delivered-to",                 /* non-standard (loop detection) */
+        NULL
+    };
+
+    if (contains_variable(sscript, hdr)) return 1;
 
-    assert(t == SETFLAG || t == ADDFLAG || t == REMOVEFLAG);
+    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
+        return verify_headername(sscript, hdr);
 
-    if (ret) {
-        ret->u.fl.variable = xstrdup(variable ? variable : "");
-        ret->u.fl.flags = flags;
+    for (lcase(hdr), h = hdrs; *h; h++) {
+        if (!strcmp(*h, hdr)) return 1;
     }
 
-    return ret;
+    sieveerror_f(sscript,
+                 "header '%s': not a valid header for an address test", hdr);
+    return 0;
 }
 
-static struct aetags *new_aetags(void)
+static int verify_envelope(sieve_script_t *sscript, char *env)
 {
-    struct aetags *r = (struct aetags *) xmalloc(sizeof(struct aetags));
+    if (contains_variable(sscript, env)) return 1;
 
-    init_comptags(&r->comptags);
-    r->addrtag = -1;
+    lcase(env);
+    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
+        !strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
+        return 1;
+    }
 
-    return r;
+    sieveerror_f(sscript,
+                 "env-part '%s': not a valid part for an envelope test", env);
+    return 0;
 }
 
-static struct aetags *canon_aetags(struct aetags *ae)
+static int verify_list(sieve_script_t *sscript, char *s)
 {
-    canon_comptags(&ae->comptags);
-    if (ae->addrtag == -1) { ae->addrtag = ALL; }
-    return ae;
-}
+    if (sscript->interp.isvalidlist &&
+        sscript->interp.isvalidlist(sscript->interp.interp_context, s)
+        != SIEVE_OK) {
+        sieveerror_f(sscript, "list '%s': is not valid/supported", s);
+        return 0;
+    }
 
-static void free_aetags(struct aetags *ae)
-{
-    free_comptags(&ae->comptags, 0);
-    free(ae);
+    return 1;
 }
 
-static struct comptags *new_comptags(void)
+static int check_reqs(sieve_script_t *sscript, strarray_t *sa)
 {
-    struct comptags *c = (struct comptags *) xmalloc(sizeof(struct comptags));
+    char *s;
+    struct buf *errs = &sscript->sieveerr;
+    int ret = 1, sep = ':';
+
+    buf_setcstr(errs, "Unsupported feature(s) in \"require\"");
+    while ((s = strarray_shift(sa))) {
+        if (!script_require(sscript, s)) {
+            buf_printf(errs, "%c \"%s\"", sep, s);
+            ret = 0;
+            sep = ',';
+        }
+        free(s);
+    }
+    strarray_free(sa);
 
-    return init_comptags(c);
+    if (ret == 0) yyerror(sscript, buf_cstring(&sscript->sieveerr));
+    else if (supported(SIEVE_CAPA_IHAVE)) {
+        /* mark all allowed extensions as supported */
+        sscript->support |= (SIEVE_CAPA_ALL & ~SIEVE_CAPA_IHAVE_INCOMPAT);
+    }
+
+    encoded_char = supported(SIEVE_CAPA_ENCODED_CHAR);
+
+    return ret;
 }
 
-static struct comptags *init_comptags(struct comptags *c)
+static commandlist_t *build_keep(sieve_script_t *sscript, commandlist_t *c)
 {
-    c->match = c->relation = -1;
-    c->comparator = NULL;
-    c->index = 0;
+    assert(c && c->type == KEEP);
+
+    if (c->u.k.flags && !_verify_flaglist(c->u.k.flags)) {
+        strarray_add(c->u.k.flags, "");
+    }
 
     return c;
 }
 
-static struct comptags *canon_comptags(struct comptags *c)
+static commandlist_t *build_fileinto(sieve_script_t *sscript,
+                                     commandlist_t *c, char *folder)
 {
-    if (c->match == -1) c->match = IS;
-    if (c->comparator == NULL) c->comparator = xstrdup("i;ascii-casemap");
+    assert(c && c->type == FILEINTO);
+
+    if (c->u.f.flags && !_verify_flaglist(c->u.f.flags)) {
+        strarray_add(c->u.f.flags, "");
+    }
+    verify_mailbox(sscript, folder);
+    c->u.f.folder = folder;
+
     return c;
 }
 
-static void free_comptags(struct comptags *c, int destroy)
+static commandlist_t *build_redirect(sieve_script_t *sscript,
+                                     commandlist_t *c, char *address)
 {
-    free(c->comparator);
-    if (destroy) free(c);
-}
+    assert(c && c->type == REDIRECT);
 
-static struct btags *new_btags(void)
-{
-    struct btags *r = (struct btags *) xmalloc(sizeof(struct btags));
+    if (c->u.r.list) verify_list(sscript, address);
+    else verify_address(sscript, address);
+
+    /* Verify DELIVERBY values */
+    if (c->u.r.bytime) {
+        if (!supported(SIEVE_CAPA_VARIABLES)) {
+            time_t t;
+
+            if (c->u.r.bytime[0] != '+' &&
+                time_from_iso8601(c->u.r.bytime, &t) == -1) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DELIVERBY time value",
+                             c->u.r.bytime);
+            }
+            if (c->u.r.bymode &&
+                strcasecmp(c->u.r.bymode, "NOTIFY") &&
+                strcasecmp(c->u.r.bymode, "RETURN")) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DELIVERBY mode value",
+                             c->u.r.bymode);
+            }
+        }
+    }
+    else if (c->u.r.bymode || c->u.r.bytrace) {
+        sieveerror_c(sscript, SIEVE_MISSING_TAG,
+                     ":bytimerelative OR :bytimeabsolute");
+    }
+
+    /* Verify DSN NOTIFY value(s) */
+    if (c->u.r.dsn_notify && !supported(SIEVE_CAPA_VARIABLES)) {
+        tok_t tok =
+            TOK_INITIALIZER(c->u.r.dsn_notify, ",", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+        char *token;
+        int never = 0;
+
+        while ((token = tok_next(&tok))) {
+            if (!strcasecmp(token, "NEVER")) never = 1;
+            else if (never) {
+                sieveerror_f(sscript,
+                             "DSN NOTIFY value 'NEVER' MUST be used by itself");
+                break;
+            }
+            else if (strcasecmp(token, "SUCCESS") &&
+                     strcasecmp(token, "FAILURE") &&
+                     strcasecmp(token, "DELAY")) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DSN NOTIFY value",
+                             token);
+                break;
+            }
+        }
+        tok_fini(&tok);
+    }
 
-    init_comptags(&r->comptags);
-    r->transform = r->offset = -1;
-    r->content_types = NULL;
+    /* Verify DSN RET value */
+    if (c->u.r.dsn_ret && !supported(SIEVE_CAPA_VARIABLES) &&
+        strcasecmp(c->u.r.dsn_ret, "FULL") &&
+        strcasecmp(c->u.r.dsn_ret, "HDRS")) {
+        sieveerror_f(sscript, "string '%s': not a valid DSN RET value",
+                     c->u.r.dsn_ret);
+    }
 
-    return r;
+    c->u.r.address = address;
+
+    return c;
 }
 
-static struct btags *canon_btags(struct btags *b)
+static int verify_identifier(sieve_script_t *sscript, char *s)
 {
-    canon_comptags(&b->comptags);
-    if (b->transform == -1) b->transform = TEXT;
-    if (b->content_types == NULL) {
-        b->content_types = strarray_new();
-        if (b->transform == RAW) strarray_append(b->content_types, "");
-        else strarray_append(b->content_types, "text");
+    /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */
+
+    if (!is_identifier(s)) {
+        sieveerror_f(sscript,
+                     "string '%s': not a valid sieve identifier", s);
+        return 0;
     }
-    if (b->offset == -1) b->offset = 0;
-    return b;
+    return 1;
 }
 
-static void free_btags(struct btags *b)
+static commandlist_t *build_set(sieve_script_t *sscript,
+                                commandlist_t *c, char *variable, char *value)
 {
-    free_comptags(&b->comptags, 0);
-    if (b->content_types) strarray_free(b->content_types);
-    free(b);
-}
+    assert(c && c->type == SET);
 
-static struct vtags *new_vtags(void)
-{
-    struct vtags *r = (struct vtags *) xmalloc(sizeof(struct vtags));
+    verify_identifier(sscript, variable);
+    verify_utf8(sscript, value);
 
-    r->seconds = -1;
-    r->addresses = NULL;
-    r->subject = NULL;
-    r->from = NULL;
-    r->handle = NULL;
-    r->mime = -1;
+    c->u.s.variable = variable;
+    c->u.s.value = value;
 
-    return r;
+    return c;
 }
 
-static struct vtags *canon_vtags(sieve_script_t *parse_script, struct vtags *v)
+static commandlist_t *build_vacation(sieve_script_t *sscript,
+                                     commandlist_t *c, char *message)
 {
-    assert(parse_script->interp.vacation != NULL);
+    int min = sscript->interp.vacation->min_response;
+    int max = sscript->interp.vacation->max_response;
 
-    if (v->seconds == -1) v->seconds = 7 * DAY2SEC;
-    if (v->seconds < parse_script->interp.vacation->min_response)
-        v->seconds = parse_script->interp.vacation->min_response;
-    if (v->seconds > parse_script->interp.vacation->max_response)
-        v->seconds = parse_script->interp.vacation->max_response;
-    if (v->mime == -1) v->mime = 0;
+    assert(c && c->type == VACATION);
 
-    return v;
-}
+    if (c->u.v.handle) verify_utf8(sscript, c->u.v.handle);
+    if (c->u.v.subject) verify_headerbody(sscript, c->u.v.subject);
+    if (c->u.v.from) verify_address(sscript, c->u.v.from);
+    if (c->u.v.addresses)
+        verify_stringlist(sscript, c->u.v.addresses, verify_address);
+    if (c->u.v.mime == -1) {
+        verify_utf8(sscript, message);
+        c->u.v.mime = 0;
+    }
+    if (c->u.v.fcc.folder) {
+        verify_mailbox(sscript, c->u.v.fcc.folder);
+        if (c->u.v.fcc.flags && !_verify_flaglist(c->u.v.fcc.flags)) {
+            strarray_add(c->u.v.fcc.flags, "");
+        }
+    }
+    else if (c->u.v.fcc.create || c->u.v.fcc.flags || c->u.v.fcc.specialuse) {
+        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
+    }
 
-static void free_vtags(struct vtags *v)
-{
-    strarray_free(v->addresses);
-    free(v->subject);
-    free(v->from);
-    free(v->handle);
-    free(v);
+    c->u.v.message = message;
+
+    if (c->u.v.seconds == -1) c->u.v.seconds = 7 * DAY2SEC;
+    if (c->u.v.seconds < min) c->u.v.seconds = min;
+    if (c->u.v.seconds > max) c->u.v.seconds = max;
+
+    return c;
 }
 
-static struct itags *new_itags()
+static commandlist_t *build_flag(sieve_script_t *sscript,
+                                 commandlist_t *c, strarray_t *flags)
 {
-    struct itags *r = (struct itags *) xmalloc(sizeof(struct itags));
+    assert(c &&
+           (c->type == SETFLAG || c->type == ADDFLAG || c->type == REMOVEFLAG));
+
+    if (!_verify_flaglist(flags)) {
+        strarray_add(flags, "");
+    }
+    c->u.fl.flags = flags;
 
-    r->once = -1;
-    r->location = -1;
-    r->optional = -1;
+    if (!c->u.fl.variable) c->u.fl.variable = xstrdup("");
+    else if (!is_identifier(c->u.fl.variable)) {
+        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "variablename");
+    }
 
-    return r;
+    return c;
 }
 
-static struct dttags *new_dttags(void)
+static commandlist_t *build_addheader(sieve_script_t *sscript,
+                                      commandlist_t *c, char *name, char *value)
 {
-    struct dttags *dt = (struct dttags *) xmalloc(sizeof(struct dttags));
+    assert(c && c->type == ADDHEADER);
 
-    init_comptags(&dt->comptags);
-    dt->zonetag = -1;
-    dt->zone = NULL;
-    return dt;
-}
+    verify_headername(sscript, name);
+    verify_headerbody(sscript, value);
 
-static struct dttags *canon_dttags(struct dttags *dt)
-{
-    char zone[14];
-    int gmoffset;
-    int hours;
-    int minutes;
-    struct tm tm;
-    time_t t;
+    if (c->u.ah.index == 0) c->u.ah.index = 1;
+    c->u.ah.name = name;
+    c->u.ah.value = value;
 
-    canon_comptags(&dt->comptags);
-    if (dt->comptags.index == 0) dt->comptags.index = 1;
-    if (dt->zonetag == -1) {
-        t = time(NULL);
-        localtime_r(&t, &tm);
-        gmoffset = gmtoff_of(&tm, t) / 60;
-        hours = abs(gmoffset) / 60;
-        minutes = abs(gmoffset) % 60;
-        snprintf(zone, sizeof(zone), "%c%02d%02d",
-                 (gmoffset >= 0 ? '+' : '-'), hours, minutes);
-        dt->zone = xstrdup(zone);
-        dt->zonetag = ZONE;
-    }
-    return dt;
+    return c;
 }
 
-static void free_dttags(struct dttags *dt)
+static commandlist_t *build_deleteheader(sieve_script_t *sscript,
+                                         commandlist_t *c,
+                                         char *name, strarray_t *values)
 {
-    free_comptags(&dt->comptags, 0);
-    free(dt->zone);
-    free(dt);
-}
+    assert(c && c->type == DELETEHEADER);
 
+    if (!strcasecmp("Received", name) || !strcasecmp("Auto-Submitted", name)) {
+        sieveerror_f(sscript,
+                     "MUST NOT delete Received or Auto-Submitted headers");
+    }
 
-static struct ntags *new_ntags(void)
-{
-    struct ntags *r = (struct ntags *) xmalloc(sizeof(struct ntags));
+    verify_headername(sscript, name);
+    verify_patternlist(sscript, values, &c->u.dh.comp, verify_utf8);
 
-    r->method = NULL;
-    r->id = NULL;
-    r->options = NULL;
-    r->priority = -1;
-    r->message = NULL;
+    c->u.dh.name = name;
+    c->u.dh.values = values;
 
-    return r;
+    return c;
 }
 
-static struct ntags *canon_ntags(struct ntags *n)
-{
-    if (n->priority == -1) n->priority = NORMAL;
-    if (n->message == NULL) n->message = xstrdup("$from$: $subject$");
-    if (n->method == NULL) n->method = xstrdup("default");
-    return n;
-}
-static struct dtags *canon_dtags(struct dtags *d)
+static int verify_weekday(sieve_script_t *sscript, char *day)
 {
-    canon_comptags(&d->comptags);
-    if (d->priority == -1) d->priority = ANY;
-    return d;
-}
+    int n = day[0] - '0';
 
-static void free_ntags(struct ntags *n)
-{
-    free(n->method);
-    free(n->id);
-    strarray_free(n->options);
-    free(n->message);
-    free(n);
+    if (n >= 0 && n <= 6 && day[1] == '\0') {
+        return (1 << n);
+    }
+
+    sieveerror_f(sscript, "'%s': not a valid weekday for snooze", day);
+    return 0;
 }
 
-static struct dtags *new_dtags(void)
+static int verify_time(sieve_script_t *sscript, char *time)
 {
-    struct dtags *r = (struct dtags *) xzmalloc(sizeof(struct dtags));
+    struct tm tm;
+    char *r = strptime(time, "%T", &tm);
 
-    init_comptags(&r->comptags);
-    r->comptags.comparator = xstrdup("i;ascii-casemap");
-    r->priority = -1;
+    if (r && *r == '\0') {
+        return (3600 * tm.tm_hour + 60 * tm.tm_min + tm.tm_sec);
+    }
 
-    return r;
+    sieveerror_f(sscript, "'%s': not a valid time for snooze", time);
+    return 0;
 }
 
-static void free_dtags(struct dtags *d)
+static commandlist_t *build_snooze(sieve_script_t *sscript,
+                                   commandlist_t *c, arrayu64_t *times)
 {
-    if (!d) return;
-    free_comptags(&d->comptags, 0);
-    free(d);
-}
+    assert(c && c->type == SNOOZE);
 
-static struct ftags *new_ftags(void)
-{
-    struct ftags *f = (struct ftags *) xzmalloc(sizeof(struct ftags));
-    return f;
-}
+    if (c->u.sn.mailbox) verify_mailbox(sscript, c->u.sn.mailbox);
+    if (c->u.sn.addflags && !_verify_flaglist(c->u.sn.addflags)) {
+        strarray_add(c->u.sn.addflags, "");
+    }
+    if (c->u.sn.removeflags && !_verify_flaglist(c->u.sn.removeflags)) {
+        strarray_add(c->u.sn.removeflags, "");
+    }
+    if (!c->u.sn.days) c->u.sn.days = 0x7f; /* all days */
 
-static struct ftags *canon_ftags(struct ftags *f)
-{
-    return f;
+    /* Sort times earliest -> latest */
+    arrayu64_sort(times, NULL/*ascending*/);
+    c->u.sn.times = times;
+
+    return c;
 }
 
-static struct stags *new_stags(void)
+static commandlist_t *build_rej_err(sieve_script_t *sscript,
+                                    int t, char *message)
 {
-    struct stags *s = (struct stags *) xmalloc(sizeof(struct stags));
+    commandlist_t *c;
 
-    s->mod40 = 0;
-    s->mod30 = 0;
-    s->mod20 = 0;
-    s->mod10 = 0;
+    assert(t == REJCT || t == EREJECT || t == ERROR);
 
-    return s;
-}
+    verify_utf8(sscript, message);
 
-static struct stags *canon_stags(struct stags *s)
-{
-    return s;
-}
+    c = new_command(t, sscript);
+    c->u.str = message;
 
-static void free_stags(struct stags *s)
-{
-    free(s);
+    return c;
 }
 
-static void free_ftags(struct ftags *f)
+static commandlist_t *build_notify(sieve_script_t *sscript, int t,
+                                   commandlist_t *c, char *method)
 {
-    if (!f) return;
-    strarray_free(f->flags);
-    free(f);
-}
+    assert(c && (t == NOTIFY || t == ENOTIFY));
 
-static int verify_identifier(sieve_script_t *parse_script, char *s)
-{
-    /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */
+    if (t == ENOTIFY) {
+        if (!supported(SIEVE_CAPA_ENOTIFY)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "enotify");
+        }
+        if (c->u.n.id != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":id");
+        }
+        if (c->u.n.method != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":method");
+        }
+        if (c->u.n.fcc.folder) {
+            verify_mailbox(sscript, c->u.n.fcc.folder);
+            if (c->u.n.fcc.flags && !_verify_flaglist(c->u.n.fcc.flags)) {
+                strarray_add(c->u.n.fcc.flags, "");
+            }
+        }
+        else if (c->u.n.fcc.create || c->u.n.fcc.flags || c->u.n.fcc.specialuse) {
+            sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
+        }
 
-    if (!is_identifier(s)) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "string '%s': not a valid sieve identifier", s);
-        yyerror(parse_script, parse_script->sieveerr);
-        return 0;
+        c->u.n.method = method;
     }
-    return 1;
+    else {
+        if (!supported(SIEVE_CAPA_NOTIFY)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "notify");
+        }
+        if (c->u.n.from != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":from");
+        }
+        if (c->u.n.fcc.folder != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":fcc");
+        }
+        if (c->u.n.fcc.create != 0) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":create");
+        }
+        if (c->u.n.fcc.flags != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":flags");
+        }
+        if (c->u.n.fcc.specialuse != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":specialuse");
+        }
+
+        if (!c->u.n.method) c->u.n.method = xstrdup("default");
+    }
+
+    c->type = t;
+    if (c->u.n.priority == -1) c->u.n.priority = NORMAL;
+    if (!c->u.n.message) c->u.n.message = xstrdup("$from$: $subject$");
+
+    return c;
 }
 
-static int verify_stringlist(sieve_script_t *parse_script, strarray_t *sa,
-                             int (*verify)(sieve_script_t*, char *))
+static commandlist_t *build_denotify(sieve_script_t *sscript,
+                                     commandlist_t *t)
 {
-    int i;
+    assert(t && t->type == DENOTIFY);
 
-    for (i = 0 ; i < sa->count ; i++) {
-        if (!verify(parse_script, sa->data[i])) return 0;
+    canon_comptags(&t->u.d.comp, sscript);
+    if (t->u.d.priority == -1) t->u.d.priority = ANY;
+    if (t->u.d.pattern) {
+        strarray_t sa = STRARRAY_INITIALIZER;
+
+        strarray_pushm(&sa, t->u.d.pattern);
+        verify_patternlist(sscript, &sa, &t->u.d.comp, NULL);
+        strarray_pop(&sa);
+        strarray_fini(&sa);
     }
-    return 1;
+
+    return t;
 }
 
-static int verify_address(sieve_script_t *parse_script, char *s)
+static commandlist_t *build_include(sieve_script_t *sscript,
+                                    commandlist_t *c, char *script)
 {
-    parse_script->addrerr[0] = '\0';    /* paranoia */
-    YY_BUFFER_STATE buffer = addr_scan_string(s);
-    if (addrparse(parse_script)) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "address '%s': %s", s, parse_script->addrerr);
-        yyerror(parse_script, parse_script->sieveerr);
-        addr_delete_buffer(buffer);
-        return 0;
+    assert(c && c->type == INCLUDE);
+
+    if (strchr(script, '/')) {
+        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "script-name");
     }
-    addr_delete_buffer(buffer);
-    return 1;
+
+    c->u.inc.script = script;
+    if (c->u.inc.once == -1) c->u.inc.once = 0;
+    if (c->u.inc.location == -1) c->u.inc.location = PERSONAL;
+    if (c->u.inc.optional == -1) c->u.inc.optional = 0;
+
+    return c;
 }
 
-static int verify_mailbox(sieve_script_t *parse_script, char *s)
+static commandlist_t *build_log(sieve_script_t *sscript, char *text)
 {
-    if (!verify_utf8(parse_script, s)) return 0;
+    commandlist_t *c;
 
-    /* xxx if not a mailbox, call yyerror */
-    return 1;
+    if (!supported(SIEVE_CAPA_LOG)) {
+          sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "x-cyrus-log");
+    }
+
+    verify_utf8(sscript, text);
+
+    c = new_command(LOG, sscript);
+    c->u.l.text = text;
+
+    return c;
 }
 
-static int verify_header(sieve_script_t *parse_script, char *hdr)
+static test_t *build_anyof(sieve_script_t *sscript, testlist_t *tl)
 {
-    char *h = hdr;
+    test_t *t;
 
-    while (*h) {
-        /* field-name      =       1*ftext
-           ftext           =       %d33-57 / %d59-126
-           ; Any character except
-           ;  controls, SP, and
-           ;  ":". */
-        if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
-            snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                     "header '%s': not a valid header", hdr);
-            yyerror(parse_script, parse_script->sieveerr);
-            return 0;
+    assert(tl);
+
+    if (tl->next == NULL) {
+        /* collapse single item list into a simple test */
+        t = tl->t;
+        free(tl);
+    }
+    else {
+        test_t *fail = NULL, *maybe = NULL;
+
+        /* create ANYOF test */
+        t = new_test(ANYOF, sscript);
+        t->u.tl = tl;
+
+        /* find first test that did/didn't set ignore_err */
+        for ( ; tl && !fail && !maybe; tl = tl->next) {
+            if (tl->t->ignore_err) {
+                if (!fail) fail = tl->t;
+            }
+            else if (!maybe) maybe = tl->t;
+        }
+
+        if (fail) {
+            if (maybe) {
+                /* test may succeed - backout ignore_err */
+                sscript->ignore_err = --fail->ignore_err;
+            }
+            else {
+                /* test will fail - revert ignore_err to first value */
+                sscript->ignore_err = t->ignore_err = fail->ignore_err;
+            }
         }
-        h++;
     }
-    return 1;
+
+    return t;
 }
 
-static int verify_addrheader(sieve_script_t *parse_script, char *hdr)
+static test_t *build_allof(sieve_script_t *sscript, testlist_t *tl)
 {
-    const char **h, *hdrs[] = {
-        "from", "sender", "reply-to",   /* RFC2822 originator fields */
-        "to", "cc", "bcc",              /* RFC2822 destination fields */
-        "resent-from", "resent-sender", /* RFC2822 resent fields */
-        "resent-to", "resent-cc", "resent-bcc",
-        "return-path",                  /* RFC2822 trace fields */
-        "disposition-notification-to",  /* RFC2298 MDN request fields */
-        "delivered-to",                 /* non-standard (loop detection) */
-        "approved",                     /* RFC1036 moderator/control fields */
-        NULL
-    };
+    test_t *t;
 
-    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
-        return verify_header(parse_script, hdr);
+    assert(tl);
 
-    for (lcase(hdr), h = hdrs; *h; h++) {
-        if (!strcmp(*h, hdr)) return 1;
+    if (tl->next == NULL) {
+        /* collapse single item list into a simple test */
+        t = tl->t;
+        free(tl);
+    }
+    else {
+        /* create ALLOF test */
+        t = new_test(ALLOF, sscript);
+        t->u.tl = tl;
+
+        /* find first test that set ignore_err and revert to that value */
+        for ( ; tl; tl = tl->next) {
+            if (tl->t->ignore_err) {
+                sscript->ignore_err = t->ignore_err = tl->t->ignore_err;
+                break;
+            }
+        }
     }
 
-    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-             "header '%s': not a valid header for an address test", hdr);
-    yyerror(parse_script, parse_script->sieveerr);
-    return 0;
+    return t;
 }
 
-static int verify_envelope(sieve_script_t *parse_script, char *env)
+static test_t *build_not(sieve_script_t *sscript, test_t *t)
 {
-    lcase(env);
-    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
-        !strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
-        return 1;
+    test_t *n;
+
+    assert(t);
+
+    if (t->ignore_err) {
+        /* test will succeed - backout ignore_err */
+        sscript->ignore_err = --t->ignore_err;
     }
 
-    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-             "env-part '%s': not a valid part for an envelope test", env);
-    yyerror(parse_script, parse_script->sieveerr);
-    return 0;
+    n = new_test(NOT, sscript);
+    n->u.t = t;
+
+    return n;
 }
 
-static int verify_relat(sieve_script_t *parse_script, char *r)
+static test_t *build_hhs(sieve_script_t *sscript, test_t *t,
+                         strarray_t *sl, strarray_t *pl)
 {
-    /* this really should have been a token to begin with.*/
-    lcase(r);
-    if (!strcmp(r, "gt")) return GT;
-    else if (!strcmp(r, "ge")) return GE;
-    else if (!strcmp(r, "lt")) return LT;
-    else if (!strcmp(r, "le")) return LE;
-    else if (!strcmp(r, "ne")) return NE;
-    else if (!strcmp(r, "eq")) return EQ;
-    else {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "flag '%s': not a valid relational operation", r);
-        yyerror(parse_script, parse_script->sieveerr);
-        return -1;
-    }
+    assert(t);
+
+    verify_patternlist(sscript, pl, &t->u.hhs.comp, verify_utf8);
+
+    t->u.hhs.sl = sl;
+    t->u.hhs.pl = pl;
+
+    return t;
 }
 
-static int verify_zone(sieve_script_t *parse_script, char *tz)
+static test_t *build_header(sieve_script_t *sscript, test_t *t,
+                            strarray_t *sl, strarray_t *pl)
 {
-    int valid = 0;
-    unsigned hours;
-    unsigned minutes;
-    char sign;
+    assert(t && t->type == HEADERT);
 
-    if (sscanf(tz, "%c%02u%02u", &sign, &hours, &minutes) != 3) {
-        valid |= -1;
-    }
+    verify_stringlist(sscript, sl, verify_headername);
 
-    // test sign
-    switch (sign) {
-    case '+':
-    case '-':
-        break;
+    return build_hhs(sscript, t, sl, pl);
+}
 
-    default:
-        valid |= -1;
-        break;
+static test_t *build_stringt(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
+{
+    assert(t && t->type == STRINGT);
+
+    verify_stringlist(sscript, sl, verify_utf8);
+
+    return build_hhs(sscript, t, sl, pl);
+}
+
+static test_t *build_hasflag(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
+{
+    assert(t && t->type == HASFLAG);
+
+    if (sl) {
+        if (!supported(SIEVE_CAPA_VARIABLES)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "variables");
+        }
+
+        verify_stringlist(sscript, sl, verify_identifier);
     }
 
-    // test minutes
-    if (minutes > 59) {
-            valid |= -1;
-    }
-
-    if (valid != 0) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "flag '%s': not a valid timezone offset", tz);
-        yyerror(parse_script, parse_script->sieveerr);
-    }
-
-    return valid;
-}
-
-static int verify_date_part(sieve_script_t *parse_script, char *dp)
-{
-    lcase(dp);
-    if (!strcmp(dp, "year")) return YEAR;
-    else if (!strcmp(dp, "month")) return MONTH;
-    else if (!strcmp(dp, "day")) return DAY;
-    else if (!strcmp(dp, "date")) return DATE;
-    else if (!strcmp(dp, "julian")) return JULIAN;
-    else if (!strcmp(dp, "hour")) return HOUR;
-    else if (!strcmp(dp, "minute")) return MINUTE;
-    else if (!strcmp(dp, "second")) return SECOND;
-    else if (!strcmp(dp, "time")) return TIME;
-    else if (!strcmp(dp, "iso8601")) return ISO8601;
-    else if (!strcmp(dp, "std11")) return STD11;
-    else if (!strcmp(dp, "zone")) return ZONE;
-    else if (!strcmp(dp, "weekday")) return WEEKDAY;
-    else {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "'%s': not a valid date-part", dp);
-        yyerror(parse_script, parse_script->sieveerr);
+    return build_hhs(sscript, t, sl, pl);
+}
+
+static test_t *build_ae(sieve_script_t *sscript, test_t *t,
+                        strarray_t *sl, strarray_t *pl)
+{
+    assert(t);
+
+    verify_patternlist(sscript, pl, &t->u.ae.comp, NULL);
+
+    if (t->u.ae.addrpart == -1) t->u.ae.addrpart = ALL;
+    t->u.ae.sl = sl;
+    t->u.ae.pl = pl;
+
+    return t;
+}
+
+static test_t *build_address(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
+{
+    assert(t && t->type == ADDRESS);
+
+    verify_stringlist(sscript, sl, verify_addrheader);
+
+    return build_ae(sscript, t, sl, pl);
+}
+
+static test_t *build_envelope(sieve_script_t *sscript, test_t *t,
+                              strarray_t *sl, strarray_t *pl)
+{
+    assert(t && t->type == ENVELOPE);
+
+    verify_stringlist(sscript, sl, verify_envelope);
+
+    return build_ae(sscript, t, sl, pl);
+}
+
+static test_t *build_body(sieve_script_t *sscript,
+                          test_t *t, strarray_t *pl)
+{
+    assert(t && (t->type == BODY));
+
+    verify_patternlist(sscript, pl, &t->u.b.comp, verify_utf8);
+
+    if (t->u.b.offset == -1) t->u.b.offset = 0;
+    if (t->u.b.transform == -1) t->u.b.transform = TEXT;
+    if (t->u.b.content_types == NULL) {
+        t->u.b.content_types = strarray_new();
+        strarray_append(t->u.b.content_types,
+                        (t->u.b.transform == RAW) ? "" : "text");
     }
+    t->u.b.pl = pl;
 
-    return -1;
+    return t;
 }
 
-#ifdef ENABLE_REGEX
-static int verify_regex(sieve_script_t *parse_script, char *s, int cflags)
+static test_t *build_date(sieve_script_t *sscript,
+                          test_t *t, char *hn, int part, strarray_t *kl)
 {
-    int ret;
-    regex_t *reg = (regex_t *) xmalloc(sizeof(regex_t));
+    assert(t && (t->type == DATE || t->type == CURRENTDATE));
 
-    if ((ret = regcomp(reg, s, cflags)) != 0) {
-        (void) regerror(ret, reg, parse_script->sieveerr, ERR_BUF_SIZE);
-        yyerror(parse_script, parse_script->sieveerr);
-        free(reg);
-        return 0;
+    if (hn) verify_headername(sscript, hn);
+    verify_patternlist(sscript, kl, &t->u.dt.comp, NULL);
+
+    if (t->u.dt.comp.index == 0) t->u.dt.comp.index = 1;
+    if (t->u.dt.zonetag == -1) {
+        struct tm tm;
+        time_t now = time(NULL);
+
+        localtime_r(&now, &tm);
+        t->u.dt.zone = gmtoff_of(&tm, now) / 60;
+        t->u.dt.zonetag = ZONE;
     }
-    free(reg);
-    return 1;
+
+    t->u.dt.date_part = part;
+    t->u.dt.header_name = hn;
+    t->u.dt.kl = kl;
+
+    return t;
 }
 
-static int verify_regexs(sieve_script_t *parse_script,
-                         const strarray_t *sa, char *comp)
+static test_t *build_ihave(sieve_script_t *sscript, strarray_t *sa)
 {
+    test_t *t;
     int i;
-    int cflags = REG_EXTENDED | REG_NOSUB;
 
-#ifdef HAVE_PCREPOSIX_H
-    /* support UTF8 comparisons */
-    cflags |= REG_UTF8;
-#endif
+    t = new_test(IHAVE, sscript);
+    t->u.sl = sa;
 
-    if (!strcmp(comp, "i;ascii-casemap")) {
-        cflags |= REG_ICASE;
+    /* check if we support all listed extensions */
+    for (i = 0; i < strarray_size(sa); i++) {
+        unsigned long long capa = lookup_capability(strarray_nth(sa, i));
+
+        if (!capa) {
+            /* need to start ignoring errors immediately in case this ihave
+               is part of a testlist with an unknown test later in the list */
+            if (!t->ignore_err) t->ignore_err = ++sscript->ignore_err;
+        }
+        else if (capa & SIEVE_CAPA_IHAVE_INCOMPAT) {
+            /* incompatible extension used in ihave - parse error */
+            sscript->ignore_err = 0;
+            sieveerror_c(sscript, SIEVE_IHAVE_INCOMPAT, strarray_nth(sa, i));
+            break;
+        }
     }
 
-    for (i = 0 ; i < sa->count ; i++) {
-        if ((verify_regex(parse_script, sa->data[i], cflags)) == 0)
-            return 0;
-    }
-    return 1;
+    return t;
 }
-#else
 
-static int verify_regexs(sieve_script_t *parse_script __attribute__((unused)),
-                         const strarray_t *sa __attribute__((unused)),
-                         char *comp __attribute__((unused)))
+static test_t *build_mbox_meta(sieve_script_t *sscript,
+                               test_t *t, char *extname,
+                               char *keyname, strarray_t *keylist)
 {
-    return 0;
+    assert(t && (t->type == MAILBOXEXISTS || t->type == MAILBOXIDEXISTS ||
+                 t->type == METADATA || t->type == METADATAEXISTS ||
+                 t->type == SERVERMETADATA || t->type == SERVERMETADATAEXISTS ||
+                 t->type == ENVIRONMENT || t->type == SPECIALUSEEXISTS ||
+                 t->type == NOTIFYMETHODCAPABILITY));
+
+    canon_comptags(&t->u.mm.comp, sscript);
+    t->u.mm.extname = extname;
+    t->u.mm.keyname = keyname;
+    t->u.mm.keylist = keylist;
+
+    return t;
 }
-#endif /* ENABLE_REGEX */
 
-static int verify_patternlist(sieve_script_t *parse_script,
-                              strarray_t *sa, struct comptags *c,
-                              int (*verify)(sieve_script_t*, char *))
+static test_t *build_duplicate(sieve_script_t *sscript, test_t *t)
 {
-    if (verify && !verify_stringlist(parse_script, sa, verify)) return 0;
+    assert(t && t->type == DUPLICATE);
 
-    return (c->match == REGEX) ?
-        verify_regexs(parse_script, sa, c->comparator) : 1;
+    switch (t->u.dup.idtype) {
+    case HEADER:
+        verify_headername(sscript, t->u.dup.idval);
+        break;
+
+    case UNIQUEID:
+        verify_utf8(sscript, t->u.dup.idval);
+        break;
+
+    default:
+        t->u.dup.idtype = HEADER;
+        t->u.dup.idval = xstrdup("Message-ID");
+        break;
+    }
+
+    if (!t->u.dup.handle) t->u.dup.handle = xstrdup("");
+    else verify_utf8(sscript, t->u.dup.handle);
+
+    if (t->u.dup.seconds == -1) t->u.dup.seconds = 7 * 86400; /* 7 days */
+
+    return t;
 }
 
-/*
- * Valid UTF-8 check (from RFC 2640 Annex B.1)
- *
- * The following routine checks if a byte sequence is valid UTF-8. This
- * is done by checking for the proper tagging of the first and following
- * bytes to make sure they conform to the UTF-8 format. It then checks
- * to assure that the data part of the UTF-8 sequence conforms to the
- * proper range allowed by the encoding. Note: This routine will not
- * detect characters that have not been assigned and therefore do not
- * exist.
- */
-static int verify_utf8(sieve_script_t *parse_script, char *s)
+#ifdef WITH_JMAP
+#include "imap/json_support.h"
+
+static int jmap_parse_condition(json_t *cond, strarray_t *path)
 {
-    const char *buf = s;
-    const char *endbuf = s + strlen(s);
-    unsigned char byte2mask = 0x00, c;
-    int trailing = 0;  /* trailing (continuation) bytes to follow */
+    json_t *val;
+    const char *field;
 
-    while (buf != endbuf) {
-        c = *buf++;
-        if (trailing) {
-            if ((c & 0xC0) == 0x80) {           /* Does trailing byte
-                                                   follow UTF-8 format? */
-                if (byte2mask) {                /* Need to check 2nd byte
-                                                   for proper range? */
-                    if (c & byte2mask)          /* Are appropriate bits set? */
-                        byte2mask = 0x00;
-                    else
-                        break;
-                }
-                trailing--;
-            }
-            else
-                break;
+    json_object_foreach(cond, field, val) {
+        /* inMailbox* and *InThreadHaveKeywords properties are incompatible */
+        if (!strcmp(field, "before") ||
+            !strcmp(field, "after")) {
+            if (!json_is_utcdate(val)) break;
         }
-        else {
-            if ((c & 0x80) == 0x00)             /* valid 1 byte UTF-8 */
-                continue;
-            else if ((c & 0xE0) == 0xC0)        /* valid 2 byte UTF-8 */
-                if (c & 0x1E) {                 /* Is UTF-8 byte
-                                                   in proper range? */
-                    trailing = 1;
-                }
-                else
-                    break;
-            else if ((c & 0xF0) == 0xE0) {      /* valid 3 byte UTF-8 */
-                if (!(c & 0x0F)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x20;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 2;
-            }
-            else if ((c & 0xF8) == 0xF0) {      /* valid 4 byte UTF-8 */
-                if (!(c & 0x07)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x30;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 3;
-            }
-            else if ((c & 0xFC) == 0xF8) {      /* valid 5 byte UTF-8 */
-                if (!(c & 0x03)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x38;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 4;
-            }
-            else if ((c & 0xFE) == 0xFC) {      /* valid 6 byte UTF-8 */
-                if (!(c & 0x01)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x3C;           /* If not, set mask
-                                                   to check next byte */
+        else if (!strcmp(field, "minSize") ||
+                 !strcmp(field, "maxSize")) {
+            if (!json_is_integer(val)) break;
+        }
+        else if (!strcmp(field, "hasAttachment")) {
+            if (!json_is_boolean(val)) break;
+        }
+        else if (!strcmp(field, "text") ||
+                 !strcmp(field, "from") ||
+                 !strcmp(field, "to") ||
+                 !strcmp(field, "cc") ||
+                 !strcmp(field, "bcc") ||
+                 !strcmp(field, "subject") ||
+                 !strcmp(field, "body")) {
+            if (!json_is_string(val)) break;
+        }
+        else if (!strcmp(field, "header")) {
+            size_t n = json_array_size(val);
+
+            if (n == 0 || n > 2) break;
+
+            do {
+                const char *s = json_string_value(json_array_get(val, --n));
+
+                if (!s || !strlen(s)) {
+                    struct buf buf = BUF_INITIALIZER;
+
+                    buf_printf(&buf, "header[%lu]", n);
+                    strarray_pushm(path, buf_release(&buf));
+                    return 0;
                 }
-                trailing = 5;
-            }
-            else
-                break;
+            } while (n);
+        }
+        /* JMAP Search Extension: https://cyrusimap.org/ns/jmap/search */
+        else if (!strcmp(field, "attachmentBody")) {
+            if (!json_is_string(val)) break;
+        }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "attachmentName") ||
+                 !strcmp(field, "attachmentType")) {
+            if (!json_is_string(val)) break;
+        }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "fromContactGroupId") ||
+                 !strcmp(field, "toContactGroupId") ||
+                 !strcmp(field, "ccContactGroupId") ||
+                 !strcmp(field, "bccContactGroupId")) {
+            if (!json_is_string(val)) break;
         }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "fromAnyContact") ||
+                 !strcmp(field, "toAnyContact") ||
+                 !strcmp(field, "ccAnyContact") ||
+                 !strcmp(field, "bccAnyContact")) {
+            if (!json_is_boolean(val)) break;
+        }
+        else break;
     }
 
-    if ((buf != endbuf) || trailing) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "string '%s': not valid utf8", s);
-        yyerror(parse_script, parse_script->sieveerr);
+    if (field) {
+        strarray_push(path, field);
         return 0;
     }
 
     return 1;
 }
+
+static int jmap_parse_filter(json_t *filter, strarray_t *path)
+{
+    json_t *arg, *val;
+    const char *s;
+    size_t i;
+
+    if (!JNOTNULL(filter) || !json_is_object(filter)) return 0;
+
+    arg = json_object_get(filter, "operator");
+    if (!arg) return jmap_parse_condition(filter, path);
+
+    strarray_push(path, "operator");
+    if (!json_is_string(arg)) return 0;
+
+    s = json_string_value(arg);
+    if (strcmp("AND", s) && strcmp("OR", s) && strcmp("NOT", s)) return 0;
+    free(strarray_pop(path));
+
+    arg = json_object_get(filter, "conditions");
+    if (!json_array_size(arg)) {
+        strarray_push(path, "conditions");
+        return 0;
+    }
+
+    json_array_foreach(arg, i, val) {
+        struct buf buf = BUF_INITIALIZER;
+
+        buf_printf(&buf, "conditions[%lu]", i);
+        strarray_pushm(path, buf_release(&buf));
+        if (!jmap_parse_filter(val, path)) return 0;
+        free(strarray_pop(path));
+    }
+
+    return 1;
+}
+
+static test_t *build_jmapquery(sieve_script_t *sscript,
+                               test_t *t, const char *json)
+{
+    strarray_t path = STRARRAY_INITIALIZER;
+    json_t *jquery;
+    json_error_t jerr;
+
+    assert(t && t->type == JMAPQUERY);
+
+    /* validate query */
+    jquery = json_loads(json, 0, &jerr);
+    if (!jmap_parse_filter(jquery, &path)) {
+        char *s = strarray_join(&path, "/");
+
+        if (s) sieveerror_f(sscript, "invalid jmapquery argument: '%s'", s);
+        else sieveerror_f(sscript, "invalid jmapquery format");
+
+        free(s);
+    }
+    strarray_fini(&path);
+
+    t->u.jquery = json_dumps(jquery, JSON_COMPACT);
+    json_decref(jquery);
+
+    return t;
+}
+#else
+static test_t *build_jmapquery(sieve_script_t *sscript, test_t *t,
+                               const char *json __attribute__((unused)))
+{
+    sieveerror_c(sscript, SIEVE_UNSUPP_EXT, "x-cyrus-jmapquery");
+
+    return t;
+}
+#endif /* WITH_JMAP */
diff -pruN 3.0.13-5/sieve/sievec.c 3.2.0-3/sieve/sievec.c
--- 3.0.13-5/sieve/sievec.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sievec.c	2020-04-24 02:03:00.000000000 +0000
@@ -70,8 +70,8 @@ int main(int argc, char **argv)
 {
     FILE *instream;
     char *err = NULL;
-    sieve_script_t *s;
-    bytecode_info_t *bc;
+    sieve_script_t *s = NULL;
+    bytecode_info_t *bc = NULL;
     int c, fd, usage_error = 0;
     char *alt_config = NULL;
 
@@ -106,6 +106,7 @@ int main(int argc, char **argv)
         } else {
             fprintf(stderr, "Unable to parse script.\n");
         }
+        sieve_script_free(&s);
 
         exit(1);
     }
@@ -113,6 +114,8 @@ int main(int argc, char **argv)
     /* Now, generate the bytecode */
     if(sieve_generate_bytecode(&bc, s) == -1) {
         fprintf(stderr, "bytecode generate failed\n");
+        sieve_free_bytecode(&bc);
+        sieve_script_free(&s);
         exit(1);
     }
 
@@ -120,12 +123,16 @@ int main(int argc, char **argv)
     fd = open(argv[optind], O_CREAT | O_TRUNC | O_WRONLY, 0644);
     if(fd < 0) {
         fprintf(stderr, "couldn't open bytecode output file\n");
+        sieve_free_bytecode(&bc);
+        sieve_script_free(&s);
         exit(1);
     }
 
     /* Now, emit the bytecode */
     if(sieve_emit_bytecode(fd, bc) == -1) {
         fprintf(stderr, "bytecode emit failed\n");
+        sieve_free_bytecode(&bc);
+        sieve_script_free(&s);
         exit(1);
     }
 
diff -pruN 3.0.13-5/sieve/sieved.c 3.2.0-3/sieve/sieved.c
--- 3.0.13-5/sieve/sieved.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sieved.c	2020-05-04 03:28:02.000000000 +0000
@@ -47,6 +47,7 @@
 
 #include "sieve_interface.h"
 
+#include "bc_parse.h"
 #include "bytecode.h"
 #include "script.h"
 
@@ -60,12 +61,9 @@
 #include <string.h>
 
 #include "map.h"
+#include "times.h"
 
 static void dump2(bytecode_input_t *d, int len);
-static int dump2_test(bytecode_input_t * d, int i, int version);
-
-/* from bc_eval.c */
-int unwrap_string(bytecode_input_t *bc, int pos, const char **str, int *len);
 
 /*this is called by xmalloc*/
 EXPORTED void fatal(const char *s, int code)
@@ -128,655 +126,680 @@ int main(int argc, char * argv[])
     }
 }
 
-static int write_list(int list_len, int i, bytecode_input_t * d)
+static void print_string(const char *label, const char *str)
 {
-    int x;
-    i++;
-    for (x=0; x<list_len; x++)
-    {
-        const char *data;
-        int len;
+    size_t len;
+
+    if (str) len = strlen(str);
+    else {
+        str = "[nil]";
+        len = -1;
+    }
+
+    printf("%s({%zd}%s)", label, len, str);
+}
 
-        i = unwrap_string(d, i, &data, &len);
+static void print_stringlist(const char *label, strarray_t *list)
+{
+    int x, list_len = strarray_size(list);
+
+    printf("%s{%d} [", label, list_len);
+
+    for (x = 0; x < list_len; x++) {
+        const char *str = strarray_nth(list, x);
 
-        printf("{%d}%s\n", len, data);
+        if (!(x % 5)) printf("\n\t\t");
+        print_string(" ", str);
     }
-    return i;
+    printf("\n\t]");
+
+    free(strarray_takevf(list));
 }
 
-static int printComparison(bytecode_input_t *d ,int i)
+static void print_time(uint64_t t)
 {
-    printf("Comparison: ");
-    switch(ntohl(d[i].value))
-    {
-    case B_IS: printf("Is"); break;
-    case B_CONTAINS:printf("Contains"); break;
-    case B_MATCHES: printf("Matches"); break;
-    case B_REGEX: printf("Regex"); break;
-    case B_COUNT:
-        printf("Count");
+    printf(" %02lu:%02lu:%02lu", t / 3600, (t % 3600) / 60, t % 60);
+}
 
-        switch(ntohl(d[i+1].value))
-        {
-        case B_GT: printf(" greater than "); break;
-        case B_GE: printf(" greater than or equal "); break;
-        case B_LT: printf(" less than "); break;
-        case B_LE: printf(" less than or equal "); break;
-        case B_NE: printf(" not equal "); break;
-        case B_EQ: printf(" equal "); break;
-        }
+static void print_vallist(const char *label, arrayu64_t *list,
+                          void (*print_cb)(uint64_t))
+{
+    int x, list_len = arrayu64_size(list);
 
-        break;
+    printf("%s{%d} [", label, list_len);
+
+    for (x = 0; x < list_len; x++) {
+        uint64_t i = arrayu64_nth(list, x);
+
+        if (!(x % 5)) printf("\n\t\t");
+        if (print_cb) print_cb(i);
+        else printf(" %lu", i);
+    }
+    printf("\n\t]");
+
+    arrayu64_free(list);
+}
+
+static void print_comparator(comp_t *comp)
+{
+    printf(" COMPARATOR [ ");
+
+    switch (comp->match) {
+    case B_IS:       printf("Is");       break;
+    case B_CONTAINS: printf("Contains"); break;
+    case B_MATCHES:  printf("Matches");  break;
+    case B_REGEX:    printf("Regex");    break;
+    case B_LIST:     printf("List");     break;
+    case B_COUNT:
     case B_VALUE:
-        printf("Value");
+        printf("%s", comp->match == B_COUNT ? "Count" : "Value");
 
-        switch(ntohl(d[i+1].value))
-        {
-        case B_GT: printf(" greater than "); break;
-        case B_GE: printf(" greater than or equal ");break;
-        case B_LT: printf(" less than ");    break;
-        case B_LE: printf(" less than or equal ");break;
-        case B_NE: printf(" not equal ");    break;
-        case B_EQ: printf(" equal ");break;
+        switch (comp->relation) {
+        case B_GT: printf(" >");  break;
+        case B_GE: printf(" >="); break;
+        case B_LT: printf(" <");  break;
+        case B_LE: printf(" <="); break;
+        case B_NE: printf(" !="); break;
+        case B_EQ: printf(" =="); break;
         }
-
         break;
-    default:
-        exit(1);
-    }
 
-    switch (ntohl(d[i+2].value))
-    {
-    case B_ASCIICASEMAP: printf("   (ascii-casemap) "); break;
-    case B_OCTET: printf("    (octet) "); break;
-    case B_ASCIINUMERIC:  printf("   (ascii-numeric) "); break;
     default: exit(1);
     }
 
-    printf("\n");
-    return i+3;
+    switch (comp->collation) {
+    case B_OCTET:        printf(" (octet)");         break;
+    case B_ASCIICASEMAP: printf(" (ascii-casemap)"); break;
+    case B_ASCIINUMERIC: printf(" (ascii-numeric)"); break;
+    }
+
+    printf(" ]");
+}
+
+static const char *addrpart_to_string(int part)
+{
+    switch (part) {
+    case B_ALL:       return "all";
+    case B_LOCALPART: return "localpart";
+    case B_DOMAIN:    return "domain";
+    case B_USER:      return "user";
+    case B_DETAIL:    return "detail";
+    default:          return NULL;
+    }
 }
 
+static const char *transform_to_string(int transform)
+{
+    switch (transform) {
+    case B_RAW:     return "raw";
+    case B_TEXT:    return "text";
+    case B_CONTENT: return "content";
+    default:        return NULL;
+    }
+}
 
-static int dump2_test(bytecode_input_t * d, int i, int version)
+static const char *datepart_to_string(int part)
 {
-    int l,x,index;
-    int opcode;
-    int has_index=0;/* used to differentiate between pre and post index tests */
+    switch (part) {
+    case B_YEAR:    return "year";
+    case B_MONTH:   return "month";
+    case B_DAY:     return "day";
+    case B_DATE:    return "date";
+    case B_JULIAN:  return "julian";
+    case B_HOUR:    return "hour";
+    case B_MINUTE:  return "minute";
+    case B_SECOND:  return "second";
+    case B_TIME:    return "time";
+    case B_ISO8601: return "iso8601";
+    case B_STD11:   return "std11";
+    case B_ZONE:    return "zone";
+    case B_WEEKDAY: return "weekday";
+    default:        return NULL;
+    }
+}
 
-    opcode = ntohl(d[i].value);
-    switch(opcode) {
+static void print_test(test_t *test)
+{
+    switch (test->type) {
     case BC_FALSE:
-        printf("false");
-        i++;
+        printf("FALSE");
         break;
+
     case BC_TRUE:
-        printf("true");
-        i++;
-        break;
-    case BC_NOT:/*2*/
-        /* XXX
-           there is a value being skipped in the second pass...
-           no idea what it does, but it isn't carried to here...
-           see bytecodee.c */
-        printf(" not(");
-        i=dump2_test(d, i+1, version);
-        printf(")\n");
+        printf("TRUE");
         break;
+
     case BC_EXISTS:
-        printf("exists");
-        i=write_list(ntohl(d[i+1].len), i+2, d);
+        print_stringlist("EXISTS", test->u.sl);
         break;
+
     case BC_SIZE:
-        printf("size");
-        if (ntohl(d[i+1].value)==B_OVER) {
-            /* over */
-            printf("over %d", ntohl(d[i+2].value));
-        } else {
-            /* under */
-            printf("under %d", ntohl(d[i+2].value));
-        }
-        i+=3;
+        printf("SIZE %s %d",
+               (test->u.sz.t == B_OVER) ? "over" : "under", test->u.sz.n);
         break;
-    case BC_ANYOF:/*5*/
-        printf("any of \n(");
-        l=ntohl(d[i+1].len);
-        i+=3;
-
-        for (x=0; x<l; x++)
-        {
-            i=dump2_test(d, i, version);
-            if((x+1)<l)
-                printf(" OR ");
+
+    case BC_ADDRESS:
+        printf("ADDRESS");
+        printf(" ADDRPART(%s)", addrpart_to_string(test->u.ae.addrpart));
+        if (test->u.ae.comp.index) {
+            printf(" INDEX(%d %s)", abs(test->u.ae.comp.index),
+                   (test->u.ae.comp.index < 0) ? "[LAST]" : "");
         }
+        print_comparator(&test->u.ae.comp);
+        print_stringlist("\n\tHEADERS", test->u.ae.sl);
+        print_stringlist(" PATTERNS", test->u.ae.pl);
+        break;
 
-        printf(")\n");
+    case BC_ENVELOPE:
+        printf("ENVELOPE");
+        printf(" ADDRPART(%s)", addrpart_to_string(test->u.ae.addrpart));
+        print_comparator(&test->u.ae.comp);
+        print_stringlist("\n\tHEADERS", test->u.ae.sl);
+        print_stringlist(" PATTERNS", test->u.ae.pl);
         break;
-    case BC_ALLOF:/*6*/
-        printf("all of \n(");
-        l=ntohl(d[i+1].len);
-        i+=3;
-
-        for (x=0; x<l; x++)
-        {
-            i=dump2_test(d, i, version);
-            if((x+1)<l)
-                printf(" AND ");
+
+    case BC_HEADER:
+        printf("HEADER");
+        if (test->u.hhs.comp.index) {
+            printf(" INDEX(%d %s)", abs(test->u.hhs.comp.index),
+                   (test->u.hhs.comp.index < 0) ? "[LAST]" : "");
         }
+        print_comparator(&test->u.hhs.comp);
+        print_stringlist("\n\tHEADERS", test->u.hhs.sl);
+        print_stringlist(" PATTERNS", test->u.hhs.pl);
+        break;
 
-        printf(")\n");
+    case BC_BODY:
+        printf("BODY");
+        print_comparator(&test->u.b.comp);
+        printf("\n\tTRANSFORM(%s)", transform_to_string(test->u.b.transform));
+        printf(" OFFSET(%d)", test->u.b.offset);
+        print_stringlist(" CONTENT-TYPES", test->u.b.content_types);
+        print_stringlist(" PATTERNS", test->u.b.pl);
         break;
-    case BC_ADDRESS:/*13*/
-        has_index=1;
-        /*fall-through*/
-    case BC_ADDRESS_PRE_INDEX:/*7*/
-        if (0x07 == version && BC_ADDRESS_PRE_INDEX == opcode) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * argument.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(d[i+2].value)) {
-            case B_IS:
-            case B_CONTAINS:
-            case B_MATCHES:
-            case B_REGEX:
-            case B_COUNT:
-            case B_VALUE:
-                has_index = 1;
-                break;
-            default:
-                has_index = 0;
-            }
-        }
-        printf("Address [");
-        index = has_index ? ntohl(d[++i].value) : 0;
-        i=printComparison(d, i+1);
-        printf("               type: ");
-        switch(ntohl(d[i++].value))
-        {
-        case B_ALL: printf("all"); break;
-        case B_LOCALPART:printf("localpart"); break;
-        case B_DOMAIN:printf("domain"); break;
-        case B_USER:printf("user"); break;
-        case B_DETAIL:printf("detail"); break;
-        }
-        printf("\n");
-        if (index != 0) {
-                printf("              Index: %d %s\n",
-                    abs(index), index < 0 ? "[LAST]" : "");
-        }
-        printf("              Headers:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("              Data:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
-        break;
-    case BC_ENVELOPE:/*8*/
-        printf("Envelope [");
-        i=printComparison(d, i+1);
-        printf("                type: ");
-        switch(ntohl(d[i++].value))
-        {
-        case B_ALL: printf("all"); break;
-        case B_LOCALPART:printf("localpart"); break;
-        case B_DOMAIN:printf("domain"); break;
-        case B_USER:printf("user"); break;
-        case B_DETAIL:printf("detail"); break;
-        }
-        printf("              Headers:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("              Data:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
-        break;
-    case BC_HEADER:/*14*/
-        has_index=1;
-        /*fall-through*/
-    case BC_HEADER_PRE_INDEX:/*9*/
-        if (0x07 == version && BC_HEADER_PRE_INDEX == opcode) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * argument.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(d[i+2].value)) {
-            case B_IS:
-            case B_CONTAINS:
-            case B_MATCHES:
-            case B_REGEX:
-            case B_COUNT:
-            case B_VALUE:
-                    has_index = 1;
-                    break;
-            default:
-                    has_index = 0;
-            }
-        }
-        printf("Header [");
-        index = has_index ? ntohl(d[++i].value) : 0;
-        i= printComparison(d, i+1);
-        if (index != 0) {
-                printf("              Index: %d %s\n",
-                    abs(index), index < 0 ? "[LAST]" : "");
-        }
-        printf("              Headers: ");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("              Data: ");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
-        break;
-    case BC_HASFLAG:/*15*/
-    case BC_STRING:/*21*/
-        if (BC_HASFLAG == opcode) {
-            printf("Hasflag [");
-        } else {
-            printf("String [");
-        }
-        i= printComparison(d, i+1);
-        printf("              Variables: ");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("              Data: ");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
-        break;
-    case BC_BODY:/*10*/
-        printf("Body [");
-        i=printComparison(d, i+1);
-        printf("              Transform: ");
-        switch(ntohl(d[i++].value))
-        {
-        case B_RAW: printf("raw"); break;
-        case B_TEXT:printf("text"); break;
-        case B_CONTENT:printf("content"); break;
-        }
-        printf("\tOffset: %d\n", ntohl(d[i++].value));
-        printf("              Content-Types:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("              Data:");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
-        break;
-    case BC_DATE:/*11*/
-        has_index=1;
-        GCC_FALLTHROUGH
-    case BC_CURRENTDATE:/*12*/
-        if (0x07 == version) {
-            /* There was a version of the bytecode that had the index extension
-             * but did not update the bytecode codepoints, nor did it increment
-             * the bytecode version number.  This tests if the index extension
-             * was in the bytecode based on the position of the match-type
-             * or comparator argument.  This will correctly identify whether
-             * the index extension was supported in every case except the case
-             * of a timezone that is 61 minutes offset (since 61 corresponds to
-             * B_ORIGINALZONE).
-             * There was also an unnumbered version of BC_CURRENTDATE that did
-             * allow :index.  This also covers that case.
-             * We test for the applicable version number explicitly.
-             */
-            switch (ntohl(d[i+4].value)) {
-            /* if the 4th parameter is a comparator, we have neither :index nor
-             *  :zone tags.  B_ORIGINALZONE is the first parameter.
-             */
-            case B_ASCIICASEMAP:
-            case B_OCTET:
-            case B_ASCIINUMERIC:
-                has_index = 0;
-                break;
-            default:
-                /* otherwise, we either have a :zone tag, an :index tag, or
-                 * both
-                 */
-                switch (ntohl(d[i+5].value)) {
-                /* if the 5th paramater is a comparator, we have either :index
-                 * or :zone, but not both.
-                 */
-                case B_ASCIICASEMAP:
-                case B_OCTET:
-                case B_ASCIINUMERIC:
-                    /* The ambiguous case is B_TIMEZONE as 1st parameter and
-                     * B_ORIGINALZONE as second parameter, which could mean
-                     * either ':index 60 :originalzone' or ':zone "+0101"'
-                     */
-                    if (B_TIMEZONE == ntohl(d[i+1].value) &&
-                            B_ORIGINALZONE == ntohl(d[i+2].value)) {
-                        /* This is the ambiguous case.  Resolve the ambiguity
-                         * by assuming that there is no :index tag since the
-                         * unnumbered bytecode that shipped with Kolab
-                         * Groupware 3.3 included support for the date
-                         * extension, but not for the index extension.
-                         */
-                        has_index = 0;
-
-                    } else if (B_TIMEZONE == ntohl(d[i+1].value)) {
-                        /* if the first parameter is B_TIMEZONE, and the above
-                         * test was false, it must be a :zone tag, and we
-                         * don't have :index.
-                         */
-                        has_index = 0;
-                    } else {
-                        /* if the first parameter is not B_TIMEZONE, it must
-                         * be an :index tag, and we don't have :zone.
-                         */
-                        has_index = 1;
-                    }
-                    break;
-                default:
-                    /* if the 5th parameter is not a comparator, the 6th is,
-                     * and we have both :index and :zone
-                     */
-                    has_index = 1;
-                }
-            }
-        }
-        ++i; /* skip opcode */
 
-        if (BC_DATE == opcode) {
-                printf("date [");
-        }
-        else {
-                printf("currentdate [");
+    case BC_DATE:
+        printf("DATE");
+        if (test->u.dt.comp.index) {
+            printf(" INDEX(%d %s)", abs(test->u.dt.comp.index),
+                   (test->u.dt.comp.index < 0) ? "[LAST]" : "");
         }
+        if (test->u.dt.zonetag == B_TIMEZONE)
+            printf(" ZONE(%+dmin)", test->u.dt.zone);
+        else
+            printf(" ZONE(ORIGINAL)");
+        print_comparator(&test->u.dt.comp);
+        printf("\n\tDATEPART(%s)", datepart_to_string(test->u.dt.date_part));
+        print_string(" HEADER", test->u.dt.header_name);
+        print_stringlist(" KEYS", test->u.dt.kl);
+        break;
 
-        /* index */
-        index = has_index ? ntohl(d[i++].value) : 0;
-        if (index != 0) {
-                printf("              Index: %d %s\n",
-                    abs(index), index < 0 ? "[LAST]" : "");
-        }
+    case BC_CURRENTDATE:
+        printf("CURRENTDATE");
+        if (test->u.dt.zonetag == B_TIMEZONE)
+            printf(" ZONE(%+dmin)", test->u.dt.zone);
+        else
+            printf(" ZONE(ORIGINAL)");
+        print_comparator(&test->u.dt.comp);
+        printf("\n\tDATEPART(%s)", datepart_to_string(test->u.dt.date_part));
+        print_stringlist(" KEYS", test->u.dt.kl);
+        break;
 
-        /* zone tag */
-        {
-                printf("Zone-Tag: ");
-                switch (ntohl(d[i++].value)) {
-                case B_TIMEZONE:
-                        printf("Specific timezone: offset by %d minutes.\n", ntohl(d[i++].value));
-                        break;
-                case B_ORIGINALZONE:
-                        printf("Original zone.\n");
-                        break;
-                }
-        }
+    case BC_HASFLAG:
+        printf("HASFLAG");
+        print_comparator(&test->u.hhs.comp);
+        print_stringlist("\n\tVARIABLES", test->u.hhs.sl);
+        print_stringlist(" PATTERNS", test->u.hhs.pl);
+        break;
 
-        i=printComparison(d, i);
+    case BC_MAILBOXEXISTS:
+        print_stringlist("MAILBOXEXISTS", test->u.mm.keylist);
+        break;
 
-        printf("              Date-Type: ");
-        switch(ntohl(d[i++].value))
-        {
-        case B_YEAR: printf("year\n"); break;
-        case B_MONTH: printf("month\n"); break;
-        case B_DAY: printf("day\n"); break;
-        case B_JULIAN: printf("julian\n"); break;
-        case B_HOUR: printf("hour\n"); break;
-        case B_MINUTE: printf("minute\n"); break;
-        case B_SECOND: printf("second\n"); break;
-        case B_TIME: printf("time\n"); break;
-        case B_ISO8601: printf("iso8601\n"); break;
-        case B_STD11: printf("std11\n"); break;
-        case B_ZONE: printf("zone\n"); break;
-        case B_WEEKDAY: printf("weekday\n"); break;
-        }
+    case BC_MAILBOXIDEXISTS:
+        print_stringlist("MAILBOXIDEXISTS", test->u.mm.keylist);
+        break;
 
-        /* header name */
-        if (BC_DATE == opcode) {
-                const char *data;
-                int len;
-                i = unwrap_string(d, i, &data, &len);
-                printf("              Header Name: {%d}%s\n", len, data);
-        }
+    case BC_METADATA:
+        printf("METADATA");
+        print_comparator(&test->u.mm.comp);
+        print_string("\n\tMAILBOX", test->u.mm.extname);
+        print_string(" ANNOTATION", test->u.mm.keyname);
+        print_stringlist(" PATTERNS", test->u.mm.keylist);
+        break;
+
+    case BC_METADATAEXISTS:
+        printf("METAEXISTS");
+        print_string("MAILBOX", test->u.mm.extname);
+        print_stringlist(" ANNOTATIONS", test->u.mm.keylist);
+        break;
+
+    case BC_SERVERMETADATA:
+        printf("SERVERMETADATA");
+        print_comparator(&test->u.mm.comp);
+        print_string("\n\tANNOTATION", test->u.mm.keyname);
+        print_stringlist(" PATTERNS", test->u.mm.keylist);
+        break;
+
+    case BC_SERVERMETADATAEXISTS:
+        print_stringlist("SERVERMETADATAEXISTS", test->u.mm.keylist);
+        break;
+
+    case BC_STRING:
+        printf("STRING");
+        print_comparator(&test->u.hhs.comp);
+        print_stringlist("\n\tVARIABLES", test->u.hhs.sl);
+        print_stringlist(" PATTERNS", test->u.hhs.pl);
+        break;
+
+    case BC_VALIDEXTLIST:
+        print_stringlist("VALIDEXTLIST", test->u.sl);
+        break;
 
-        printf("              Key List: ");
-        i=write_list(ntohl(d[i].len), i+1, d);
-        printf("             ]\n");
+    case BC_VALIDNOTIFYMETHOD:
+        print_stringlist("VALIDNOTIFYMETHOD", test->u.sl);
         break;
+
+    case BC_NOTIFYMETHODCAPABILITY:
+        printf("NOTIFYMETHODCAPABILITY");
+        print_comparator(&test->u.mm.comp);
+        print_string("\n\tURI", test->u.mm.extname);
+        print_string(" CAPABILITY", test->u.mm.keyname);
+        print_stringlist(" KEYS", test->u.mm.keylist);
+        break;
+
+    case BC_DUPLICATE:
+        printf("DUPLICATE");
+        print_string((test->u.dup.idtype == B_UNIQUEID) ?
+                     " UNIQUEID" : " HDRNAME", test->u.dup.idval);
+        print_string(" HANDLE", test->u.dup.handle);
+        printf("\n\tSECONDS(%d) LAST(%d)",
+                     test->u.dup.seconds, test->u.dup.last);
+        break;
+
+    case BC_IHAVE:
+        print_stringlist("IHAVE", test->u.sl);
+        break;
+
+    case BC_SPECIALUSEEXISTS:
+        printf("SPECIALUSEEXISTS");
+        print_string("MAILBOX", test->u.mm.extname);
+        print_stringlist(" FLAGS", test->u.mm.keylist);
+        break;
+
+    case BC_ENVIRONMENT:
+        printf("ENVIRONMENT");
+        print_comparator(&test->u.mm.comp);
+        print_string("\n\tITEM", test->u.mm.keyname);
+        print_stringlist(" KEYS", test->u.mm.keylist);
+        break;
+
+#ifdef WITH_JMAP
+    case BC_JMAPQUERY: {
+        json_error_t jerr;
+        json_t *jquery = json_loads(test->u.jquery, 0, &jerr);
+        char *json = json_dumps(jquery, JSON_INDENT(2));
+
+        printf("JMAPQUERY");
+        print_string(" ", json);
+        json_decref(jquery);
+        free(json);
+        break;
+    }
+#endif
+    }
+
+    printf("\n");
+}
+
+static int dump2_test(bytecode_input_t *d, int i, int version)
+{
+    test_t test;
+    int len;
+
+    /* there is no short circuiting involved here */
+    i = bc_test_parse(d, i, version, &test);
+
+    switch (test.type) {
+    case BC_NOT:
+        printf("NOT ");
+        i = dump2_test(d, i, version);
+        break;
+
+    case BC_ANYOF:
+    case BC_ALLOF:
+        len = test.u.aa.ntests;
+
+        printf("%s({%d}\n\t",
+               (test.type == BC_ANYOF) ? "ANYOF" : "ALLOF", len);
+
+        while (len--) {
+            i = dump2_test(d, i, version);
+            printf("\t");
+        }
+        printf(")\n");
+        break;
+
     default:
-        printf("WERT %d ", ntohl(d[i].value));
+        print_test(&test);
+        break;
     }
+
     return i;
 }
 
 static void dump2(bytecode_input_t *d, int bc_len)
 {
     int i;
-    int version;
-    const char *data;
-    int len;
+    int version, requires;
 
     if (!d) return;
 
-    if (memcmp(d, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN)) {
+    i = bc_header_parse(d, &version, &requires);
+    if (i <  0) {
         printf("not a bytecode file [magic number test failed]\n");
         return;
     }
 
-    i = BYTECODE_MAGIC_LEN / sizeof(bytecode_input_t);
-
-    version = ntohl(d[i].op);
-    printf("Sievecode version %d\n", version);
-    if (version >= 0x11 && ntohl(d[++i].value) & BFE_VARIABLES) {
-        printf("Require Variables\n");
+    printf("Bytecode version: %d\n", version);
+    if (version >= 0x11) {
+        printf("Require:");
+        if (requires & BFE_VARIABLES) printf(" Variables");
+        printf("\n");
     }
-    
-    for(i++; i<bc_len;) 
-    {
-        int op;
-        int copy = 0;
-        int create = 0;
-        int supports_variables = 0;
+    printf("\n");
 
-        printf("%d: ",i);
+    while (i < bc_len) {
+        commandlist_t cmd;
 
-        op = ntohl(d[i++].op);
-        switch (op) {
+        printf("%04d: ", i);
 
-        case B_STOP:/*0*/
-            printf("STOP\n");
-            break;
+        i = bc_action_parse(d, i, version, &cmd);
 
-        case B_KEEP:/*22*/
-            printf("KEEP FLAGS {%d}\n", ntohl(d[i].listlen));
-            i=write_list(ntohl(d[i].listlen), i+1, d);
-            copy = ntohl(d[i++].value);
-            printf("              COPY(%d)\n",copy);
+        switch (cmd.type) {
+        case B_STOP:
+            printf("STOP");
             break;
-        case B_KEEP_ORIG:/*1*/
-            printf("KEEP\n");
+
+            
+        case B_KEEP_ORIG:
+        case B_KEEP_COPY:
+        case B_KEEP:
+            printf("KEEP");
+            if (cmd.type >= B_KEEP_COPY) {
+                print_stringlist(" FLAGS", cmd.u.k.flags);
+            }
             break;
 
-        case B_DISCARD:/*2*/
-            printf("DISCARD\n");
+
+        case B_DISCARD:
+            printf("DISCARD");
             break;
 
-        case B_REJECT:/*3*/
-            i = unwrap_string(d, i, &data, &len);
-            printf("REJECT {%d}%s\n", len, data);
+
+        case B_EREJECT:
+            printf("E");
+
+            GCC_FALLTHROUGH
+
+        case B_REJECT:
+            print_string("REJECT ", cmd.u.str);
             break;
 
-        case B_FILEINTO: /*24*/
-            create = ntohl(d[i++].value);
-            /* fall through */
-        case B_FILEINTO_FLAGS:/*23*/
-            printf("FILEINTO FLAGS {%d}\n", ntohl(d[i].listlen));
-            i=write_list(ntohl(d[i].listlen), i+1, d);
-            copy = ntohl(d[i++].value);
-            i = unwrap_string(d, i, &data, &len);
-            printf("              CREATE(%d) COPY(%d) FOLDER({%d}%s)\n",
-                    create, copy, len, data);
+
+        case B_ERROR:
+            print_string("ERROR ", cmd.u.str);
             break;
 
-        case B_FILEINTO_COPY : /*19*/
-            copy = ntohl(d[i++].value);
-            /* fall through */
-        case B_FILEINTO_ORIG: /*4*/
-            i = unwrap_string(d, i, &data, &len);
-            printf("FILEINTO COPY(%d) CREATE(%d) FOLDER({%d}%s)\n",copy,create,len,data);
+
+        case B_FILEINTO_ORIG:
+        case B_FILEINTO_COPY:
+        case B_FILEINTO_FLAGS:
+        case B_FILEINTO_CREATE:
+        case B_FILEINTO_SPECIALUSE:
+        case B_FILEINTO:
+            printf("FILEINTO");
+            if (cmd.type >= B_FILEINTO_COPY) {
+                printf(" COPY(%d)", cmd.u.f.copy);
+
+                if (cmd.type >= B_FILEINTO_FLAGS) {
+                    print_stringlist(" FLAGS", cmd.u.f.flags);
+
+                    if (cmd.type >= B_FILEINTO_CREATE) {
+                        printf("\n\tCREATE(%d)", cmd.u.f.create);
+
+                        if (cmd.type >= B_FILEINTO_SPECIALUSE) {
+                            print_string(" SPECIALUSE", cmd.u.f.specialuse);
+
+                            if (cmd.type >= B_FILEINTO) {
+                                print_string(" MAILBOXID", cmd.u.f.mailboxid);
+                            }
+                        }
+                    }
+                }
+            }
+            print_string(" FOLDER", cmd.u.f.folder);
             break;
 
-        case B_REDIRECT: /*20*/
-            copy = ntohl(d[i++].value);
-            /* fall through */
-        case B_REDIRECT_ORIG: /*5*/
-            i = unwrap_string(d, i, &data, &len);
-            printf("REDIRECT COPY(%d) ADDRESS({%d}%s)\n",copy,len,data);
+
+        case B_REDIRECT_ORIG:
+        case B_REDIRECT_COPY:
+        case B_REDIRECT_LIST:
+        case B_REDIRECT:
+            printf("REDIRECT");
+            if (cmd.type >= B_REDIRECT_COPY) {
+                printf(" COPY(%d)", cmd.u.r.copy);
+
+                if (cmd.type >= B_REDIRECT_LIST) {
+                    printf( "LIST(%d)", cmd.u.r.list);
+
+                    if (cmd.type >= B_REDIRECT) {
+                        print_string(" BYTIME", cmd.u.r.bytime);
+                        print_string(" BYMODE", cmd.u.r.bymode);
+                        printf(" BYTRACE(%d)", cmd.u.r.bytrace);
+                        print_string("\n\tDSN-NOTIFY", cmd.u.r.dsn_notify);
+                        print_string(" DSN-RET", cmd.u.r.dsn_ret);
+                    }
+                }
+            }
+            print_string(" ADDRESS", cmd.u.r.address);
             break;
 
-        case B_IF:/*6*/
-            printf("IF (ends at %d)", ntohl(d[i].value));
 
-            /* there is no short circuiting involved here*/
-            i = dump2_test(d, i+1, version);
-            printf("\n");
+        case B_IF:
+            printf("IF (ends at %d) ", cmd.u.i.testend);
+            i = dump2_test(d, i, version);
+            break;
+
 
+        case B_MARK:
+            printf("MARK");
             break;
 
-        case B_MARK:/*7*/
-            printf("MARK\n");
+
+        case B_UNMARK:
+            printf("UNMARK");
             break;
 
-        case B_UNMARK:/*8*/
-            printf("UNMARK\n");
+
+        case B_ADDFLAG_ORIG:
+        case B_ADDFLAG:
+            printf("ADDFLAG");
+            if (cmd.type >= B_ADDFLAG)
+                print_string(" VARIABLE", cmd.u.fl.variable);
+            print_stringlist(" FLAGS", cmd.u.fl.flags);
             break;
 
-        case B_ADDFLAG: /*26*/
-        case B_SETFLAG: /*27*/
-        case B_REMOVEFLAG: /*28*/
-            i = unwrap_string(d, i, &data, &len);
-            supports_variables = 1;
-            /* fall through */
-        case B_ADDFLAG_ORIG: /*9*/
-        case B_SETFLAG_ORIG: /*10*/
-        case B_REMOVEFLAG_ORIG: /*11*/
-            switch (op) {
-            case B_ADDFLAG_ORIG:
-            case B_ADDFLAG:
-                printf("ADDFLAG ");
-                break;
-            case B_SETFLAG:
-            case B_SETFLAG_ORIG:
-                printf("SETFLAG ");
-                break;
-            case B_REMOVEFLAG:
-            case B_REMOVEFLAG_ORIG:
-                printf("REMOVEFLAG ");
-                break;
-            }
-            if (supports_variables) {
-                printf("VARIABLE({%d}%s) ", len, data);
-            }
-            printf("FLAGS {%d}\n",ntohl(d[i].len));
-            i=write_list(ntohl(d[i].len),i+1,d);
+
+        case B_SETFLAG_ORIG:
+        case B_SETFLAG:
+            printf("SETFLAG");
+            if (cmd.type >= B_SETFLAG)
+                print_string(" VARIABLE", cmd.u.fl.variable);
+            print_stringlist(" FLAGS", cmd.u.fl.flags);
             break;
 
-        case B_DENOTIFY:/*12*/
-            printf("DENOTIFY\n");
-            printf("            PRIORITY(%d) Comparison type %d (relat %d)\n",
-                   ntohl(d[i].value), ntohl(d[i+1].value), ntohl(d[i+2].value));
-            i+=3;
 
-            i = unwrap_string(d, i, &data, &len);
+        case B_REMOVEFLAG_ORIG:
+        case B_REMOVEFLAG:
+            printf("REMOVEFLAG");
+            if (cmd.type >= B_REMOVEFLAG)
+                print_string(" VARIABLE", cmd.u.fl.variable);
+            print_stringlist(" FLAGS", cmd.u.fl.flags);
+            break;
+
 
-            printf("           ({%d}%s)\n", len, (!data ? "[nil]" : data));
+        case B_DENOTIFY:
+            printf("DENOTIFY PRIORITY(%d)", cmd.u.d.priority);
+            if (cmd.u.d.pattern) {
+                print_comparator(&cmd.u.d.comp);
+                print_string("\n\tPATTERN", cmd.u.d.pattern);
+            }
             break;
 
-        case B_NOTIFY: /*13*/
-            i = unwrap_string(d, i, &data, &len);
 
-            printf("NOTIFY METHOD({%d}%s)\n",len,data);
+        case B_ENOTIFY:
+            printf("E");
 
-            i = unwrap_string(d, i, &data, &len);
+            GCC_FALLTHROUGH
 
-            printf("            ID({%d}%s) OPTIONS ", len,
-                   (!data ? "[nil]" : data));
+        case B_NOTIFY:
+            printf("NOTIFY ");
+            print_string(" METHOD", cmd.u.n.method);
+            if (cmd.type == B_ENOTIFY) {
+                printf(" IMPORTANCE(%d)", cmd.u.n.priority);
+                print_string(" FROM", cmd.u.n.from);
+            }
+            else {
+                printf(" PRIORITY(%d)", cmd.u.n.priority);
+                print_string(" ID", cmd.u.n.id);
+            }
+            print_stringlist(" OPTIONS", cmd.u.n.options);
+            print_string("\n\tMESSAGE", cmd.u.n.message);
+            break;
 
-            i=write_list(ntohl(d[i].len),i+1,d);
 
-            printf("            PRIORITY(%d)\n", ntohl(d[i].value));
-            i++;
+        case B_VACATION_ORIG:
+        case B_VACATION_SEC:
+        case B_VACATION_FCC:
+        case B_VACATION:
+            printf("VACATION");
+            print_stringlist(" ADDR", cmd.u.v.addresses);
+            print_string("\n\tSUBJ", cmd.u.v.subject);
+            print_string("\n\tMESG", cmd.u.v.message);
+            printf("\n\tSECONDS(%d) MIME(%d)",
+                   cmd.u.v.seconds * (cmd.type == B_VACATION_ORIG ? DAY2SEC : 1),
+                   cmd.u.v.mime);
 
-            i = unwrap_string(d, i, &data, &len);
+            if (version >= 0x05) {
+                print_string(" FROM", cmd.u.v.from);
+                print_string(" HANDLE", cmd.u.v.handle);
 
-            printf("            MESSAGE({%d}%s)\n", len, data);
+                if (cmd.type >= B_VACATION_FCC) {
+                    print_string("\n\tFCC", cmd.u.v.fcc.folder);
 
+                    if (cmd.u.v.fcc.folder) {
+                        printf(" CREATE(%d)", cmd.u.v.fcc.create);
+                        print_stringlist(" FLAGS", cmd.u.v.fcc.flags);
+
+                        if (cmd.type >= B_VACATION) {
+                            print_string("\n\tSPECIALUSE",
+                                         cmd.u.v.fcc.specialuse);
+                        }
+                    }
+                }
+            }
             break;
 
-        case B_VACATION_ORIG:/*14*/
-        case B_VACATION:/*22*/
-            printf("VACATION\n");
-            /*add address list here!*/
-            i=write_list(ntohl(d[i].len),i+1,d);
 
-            i = unwrap_string(d, i, &data, &len);
+        case B_NULL:
+            printf("NULL");
+            break;
 
-            printf("%d SUBJ({%d}%s) \n",i, len, (!data ? "[nil]" : data));
 
-            i = unwrap_string(d, i, &data, &len);
+        case B_JUMP:
+            printf("JUMP %d", cmd.u.jump);
+            break;
 
-            printf("%d MESG({%d}%s) \n", i, len, (!data ? "[nil]" : data));
 
-            printf("SECONDS(%d) MIME(%d)\n", ntohl(d[i].value) * (op == B_VACATION ? 1: 24 * 60 * 60 /* 1 day */), ntohl(d[i+1].value));
-            i+=2;
+        case B_INCLUDE:
+            printf("INCLUDE LOCATION(%s) ONCE(%d) OPTIONAL(%d)",
+                   (cmd.u.inc.location = B_PERSONAL) ? "Personal" : "Global",
+                   cmd.u.inc.once, cmd.u.inc.optional);
+            print_string("\n\tSCRIPT", cmd.u.inc.script);
+            break;
 
-            if (version >= 0x05) {
-                i = unwrap_string(d, i, &data, &len);
 
-                printf("%d FROM({%d}%s) \n",i, len, (!data ? "[nil]" : data));
+        case B_SET:
+            printf("SET LOWER(%d) UPPER(%d)",
+                   cmd.u.s.mod40 & BFV_LOWER, cmd.u.s.mod40 & BFV_UPPER);
+            printf(" LOWERFIRST(%d) UPPERFIRST(%d)",
+                   cmd.u.s.mod30 & BFV_LOWERFIRST,
+                   cmd.u.s.mod30 & BFV_UPPERFIRST);
+            printf("\n\tQUOTEWILDCARD(%d) QUOTEREGEX(%d)",
+                   cmd.u.s.mod20 & BFV_QUOTEWILDCARD,
+                   cmd.u.s.mod20 & BFV_QUOTEREGEX);
+            printf(" ENCODEURL(%d) LENGTH(%d)",
+                   cmd.u.s.mod15 & BFV_ENCODEURL, cmd.u.s.mod10 & BFV_LENGTH);
+            print_string("\n\tVARIABLE", cmd.u.s.variable);
+            print_string(" VALUE", cmd.u.s.value);
+            break;
 
-                i = unwrap_string(d, i, &data, &len);
 
-                printf("%d HANDLE({%d}%s) \n",i, len, (!data ? "[nil]" : data));
-            }
+        case B_ADDHEADER:
+            printf("ADDHEADER INDEX(%d)", cmd.u.ah.index);
+            print_string(" NAME", cmd.u.ah.name);
+            print_string(" VALUE", cmd.u.ah.value);
+            break;
+
 
+        case B_DELETEHEADER:
+            printf("DELETEHEADER INDEX(%d)", cmd.u.dh.comp.index);
+            print_comparator(&cmd.u.dh.comp);
+            print_string("\n\tNAME", cmd.u.dh.name);
+            print_stringlist(" VALUES", cmd.u.dh.values);
             break;
-        case B_NULL:/*15*/
-            printf("NULL\n");
+
+
+        case B_LOG:
+            printf("LOG TEXT(%s)", cmd.u.l.text);
             break;
-        case B_JUMP:/*16*/
-            printf("JUMP %d\n", ntohl(d[i].jump));
-            i+=1;
+
+
+        case B_RETURN:
+            printf("RETURN");
             break;
 
-        case B_INCLUDE:/*17*/
-            printf("INCLUDE ");
-            switch (ntohl(d[i].value) & 63) {
-            case B_PERSONAL: printf("Personal"); break;
-            case B_GLOBAL: printf("Global"); break;
+
+        case B_SNOOZE: {
+            const char *sep = "";
+            int i;
+
+            printf("SNOOZE");
+            print_string(cmd.u.sn.is_mboxid ? " MAILBOXID" : " MAILBOX",
+                         cmd.u.sn.mailbox);
+            print_stringlist("\n\tADDFLAGS", cmd.u.sn.addflags);
+            print_stringlist("\n\tREMOVEFLAGS", cmd.u.sn.removeflags);
+            printf("\n\tWEEKDAYS [");
+            for (i = 0; i < 7; i++) {
+                if (cmd.u.sn.days & (1<<i)) {
+                    printf("%s %u", sep, i);
+                    sep = ",";
+                }
             }
-            printf(" once:%s optional:%s",
-                ntohl(d[i].value) & 64 ? "yes" : "no",
-                ntohl(d[i].value) & 128 ? "yes" : "no");
-            i = unwrap_string(d, i+1, &data, &len);
-            printf(" {%d}%s\n", len, data);
-            break;
-
-        case B_SET: /*25*/
-        {
-            int m = ntohl(d[i++].value);
-            i = unwrap_string(d, i, &data, &len);
-            printf("SET ");
-            printf("LOWER(%d) UPPER(%d) LOWERFIRST(%d) UPPERFIRST(%d) "
-                   "QUOTEWILDCARD(%d) LENGTH(%d)\n",
-		   m & BFV_LOWER, m & BFV_UPPER, m & BFV_LOWERFIRST,
-		   m & BFV_UPPERFIRST, m & BFV_QUOTEWILDCARD, m & BFV_LENGTH);
-            printf("              VARS({%d}%s)", len, data);
-            i = unwrap_string(d, i, &data, &len);
-            printf(" VALS({%d}%s)\n", len, data);
-        }
+            printf(" ]");
+            print_vallist("\n\tTIMES", cmd.u.sn.times, &print_time);
             break;
+        }
 
-        case B_RETURN:/*18*/
-            printf("RETURN\n");
-            break;
 
         default:
-            printf("%d (NOT AN OP)\n",ntohl(d[i-1].op));
+            printf("%d (NOT AN OP)\n", cmd.type);
             exit(1);
         }
+
+        printf("\n");
     }
+
     printf("full len is: %d\n", bc_len);
 }
-
-
diff -pruN 3.0.13-5/sieve/sieve_err.et 3.2.0-3/sieve/sieve_err.et
--- 3.0.13-5/sieve/sieve_err.et	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sieve_err.et	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
 # sieve_err.et -- Error codes for the Sieve subsystem
 #
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+# Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -74,6 +74,9 @@ ec SIEVE_MISSING_REQUIRE,
 ec SIEVE_MISSING_TAG,
    "%s tag is required"
 
+ec SIEVE_UNEXPECTED_TAG,
+   "unexpected %s tag"
+
 ec SIEVE_DUPLICATE_TAG,
    "duplicate/conflicting %s tag"
 
@@ -83,7 +86,13 @@ ec SIEVE_DUPLICATE_ARG,
 ec SIEVE_INVALID_VALUE,
    "invalid %s value"
 
-ec SIEVE_BUILD_FAILURE,
-   "unable to build %s"
+ec SIEVE_UNSUPP_EXT,
+    "unsupported extension"
+
+ec SIEVE_IHAVE_INCOMPAT,
+   "\"%s\" extension MUST NOT be used in \"ihave\" test"
+
+ec SIEVE_MATCH_INCOMPAT,
+   "\"%s\" match-type MUST be used with \"%s\" comparator"
 
 end
diff -pruN 3.0.13-5/sieve/sieve.h 3.2.0-3/sieve/sieve.h
--- 3.0.13-5/sieve/sieve.h	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/sieve/sieve.h	2020-05-04 04:11:04.000000000 +0000
@@ -50,110 +50,151 @@ extern int sievedebug;
     IF = 260,
     ELSIF = 261,
     ELSE = 262,
-    REJCT = 263,
-    FILEINTO = 264,
-    REDIRECT = 265,
+    REQUIRE = 263,
+    STOP = 264,
+    DISCARD = 265,
     KEEP = 266,
-    STOP = 267,
-    DISCARD = 268,
-    VACATION = 269,
-    REQUIRE = 270,
-    MARK = 271,
-    UNMARK = 272,
-    FLAGS = 273,
-    NOTIFY = 274,
-    DENOTIFY = 275,
-    ANYOF = 276,
-    ALLOF = 277,
-    EXISTS = 278,
-    SFALSE = 279,
-    STRUE = 280,
-    HEADER = 281,
-    NOT = 282,
-    SIZE = 283,
-    ADDRESS = 284,
-    ENVELOPE = 285,
-    BODY = 286,
-    COMPARATOR = 287,
-    IS = 288,
-    CONTAINS = 289,
-    MATCHES = 290,
+    FILEINTO = 267,
+    REDIRECT = 268,
+    ANYOF = 269,
+    ALLOF = 270,
+    EXISTS = 271,
+    NOT = 272,
+    SFALSE = 273,
+    STRUE = 274,
+    SIZE = 275,
+    HEADERT = 276,
+    ADDRESS = 277,
+    ENVELOPE = 278,
+    COMPARATOR = 279,
+    OVER = 280,
+    UNDER = 281,
+    ALL = 282,
+    LOCALPART = 283,
+    DOMAIN = 284,
+    IS = 285,
+    CONTAINS = 286,
+    MATCHES = 287,
+    OCTET = 288,
+    ASCIICASEMAP = 289,
+    ASCIINUMERIC = 290,
     REGEX = 291,
-    COUNT = 292,
-    VALUE = 293,
-    OVER = 294,
-    UNDER = 295,
-    GT = 296,
-    GE = 297,
-    LT = 298,
-    LE = 299,
-    EQ = 300,
-    NE = 301,
-    ALL = 302,
-    LOCALPART = 303,
-    DOMAIN = 304,
-    USER = 305,
-    DETAIL = 306,
-    RAW = 307,
-    TEXT = 308,
-    CONTENT = 309,
-    DAYS = 310,
+    QUOTEREGEX = 292,
+    COPY = 293,
+    BODY = 294,
+    RAW = 295,
+    TEXT = 296,
+    CONTENT = 297,
+    ENVIRONMENT = 298,
+    STRINGT = 299,
+    SET = 300,
+    LOWER = 301,
+    UPPER = 302,
+    LOWERFIRST = 303,
+    UPPERFIRST = 304,
+    QUOTEWILDCARD = 305,
+    LENGTH = 306,
+    VACATION = 307,
+    DAYS = 308,
+    SUBJECT = 309,
+    FROM = 310,
     ADDRESSES = 311,
-    SUBJECT = 312,
-    FROM = 313,
-    HANDLE = 314,
-    MIME = 315,
-    SECONDS = 316,
-    METHOD = 317,
-    ID = 318,
-    OPTIONS = 319,
-    LOW = 320,
-    NORMAL = 321,
-    HIGH = 322,
-    ANY = 323,
-    MESSAGE = 324,
-    INCLUDE = 325,
-    PERSONAL = 326,
-    GLOBAL = 327,
-    RETURN = 328,
-    OPTIONAL = 329,
-    ONCE = 330,
-    COPY = 331,
+    MIME = 312,
+    HANDLE = 313,
+    SECONDS = 314,
+    COUNT = 315,
+    VALUE = 316,
+    GT = 317,
+    GE = 318,
+    LT = 319,
+    LE = 320,
+    EQ = 321,
+    NE = 322,
+    FLAGS = 323,
+    HASFLAG = 324,
+    SETFLAG = 325,
+    ADDFLAG = 326,
+    REMOVEFLAG = 327,
+    MARK = 328,
+    UNMARK = 329,
+    USER = 330,
+    DETAIL = 331,
     DATE = 332,
     CURRENTDATE = 333,
-    INDEX = 334,
-    LAST = 335,
-    ZONE = 336,
-    ORIGINALZONE = 337,
-    MAILBOXEXISTS = 338,
-    CREATE = 339,
-    METADATA = 340,
-    METADATAEXISTS = 341,
-    SERVERMETADATA = 342,
-    SERVERMETADATAEXISTS = 343,
-    YEAR = 344,
-    MONTH = 345,
-    DAY = 346,
-    JULIAN = 347,
-    HOUR = 348,
-    MINUTE = 349,
-    SECOND = 350,
-    TIME = 351,
-    ISO8601 = 352,
-    STD11 = 353,
-    WEEKDAY = 354,
-    STRINGT = 355,
-    SET = 356,
-    LOWER = 357,
-    UPPER = 358,
-    LOWERFIRST = 359,
-    UPPERFIRST = 360,
-    QUOTEWILDCARD = 361,
-    LENGTH = 362,
-    SETFLAG = 363,
-    ADDFLAG = 364,
-    REMOVEFLAG = 365,
-    HASFLAG = 366
+    ORIGINALZONE = 334,
+    ZONE = 335,
+    TIMEZONE = 336,
+    YEARP = 337,
+    MONTHP = 338,
+    DAYP = 339,
+    DATEP = 340,
+    JULIAN = 341,
+    HOURP = 342,
+    MINUTEP = 343,
+    SECONDP = 344,
+    TIMEP = 345,
+    ISO8601 = 346,
+    STD11 = 347,
+    ZONEP = 348,
+    WEEKDAYP = 349,
+    INDEX = 350,
+    LAST = 351,
+    ADDHEADER = 352,
+    DELETEHEADER = 353,
+    REJCT = 354,
+    EREJECT = 355,
+    METHOD = 356,
+    OPTIONS = 357,
+    MESSAGE = 358,
+    IMPORTANCE = 359,
+    VALIDNOTIFYMETHOD = 360,
+    NOTIFYMETHODCAPABILITY = 361,
+    NOTIFY = 362,
+    ENOTIFY = 363,
+    ENCODEURL = 364,
+    DENOTIFY = 365,
+    ID = 366,
+    ANY = 367,
+    LOW = 368,
+    NORMAL = 369,
+    HIGH = 370,
+    IHAVE = 371,
+    ERROR = 372,
+    MAILBOXEXISTS = 373,
+    CREATE = 374,
+    METADATA = 375,
+    METADATAEXISTS = 376,
+    SERVERMETADATA = 377,
+    SERVERMETADATAEXISTS = 378,
+    BYTIMEREL = 379,
+    BYTIMEABS = 380,
+    BYMODE = 381,
+    BYTRACE = 382,
+    DSNNOTIFY = 383,
+    DSNRET = 384,
+    VALIDEXTLIST = 385,
+    LIST = 386,
+    INCLUDE = 387,
+    OPTIONAL = 388,
+    ONCE = 389,
+    RETURN = 390,
+    PERSONAL = 391,
+    GLOBAL = 392,
+    DUPLICATE = 393,
+    HEADER = 394,
+    UNIQUEID = 395,
+    SPECIALUSEEXISTS = 396,
+    SPECIALUSE = 397,
+    FCC = 398,
+    MAILBOXID = 399,
+    MAILBOXIDEXISTS = 400,
+    LOG = 401,
+    JMAPQUERY = 402,
+    SNOOZE = 403,
+    MAILBOX = 404,
+    ADDFLAGS = 405,
+    REMOVEFLAGS = 406,
+    WEEKDAYS = 407
   };
 #endif
 /* Tokens.  */
@@ -162,136 +203,169 @@ extern int sievedebug;
 #define IF 260
 #define ELSIF 261
 #define ELSE 262
-#define REJCT 263
-#define FILEINTO 264
-#define REDIRECT 265
+#define REQUIRE 263
+#define STOP 264
+#define DISCARD 265
 #define KEEP 266
-#define STOP 267
-#define DISCARD 268
-#define VACATION 269
-#define REQUIRE 270
-#define MARK 271
-#define UNMARK 272
-#define FLAGS 273
-#define NOTIFY 274
-#define DENOTIFY 275
-#define ANYOF 276
-#define ALLOF 277
-#define EXISTS 278
-#define SFALSE 279
-#define STRUE 280
-#define HEADER 281
-#define NOT 282
-#define SIZE 283
-#define ADDRESS 284
-#define ENVELOPE 285
-#define BODY 286
-#define COMPARATOR 287
-#define IS 288
-#define CONTAINS 289
-#define MATCHES 290
+#define FILEINTO 267
+#define REDIRECT 268
+#define ANYOF 269
+#define ALLOF 270
+#define EXISTS 271
+#define NOT 272
+#define SFALSE 273
+#define STRUE 274
+#define SIZE 275
+#define HEADERT 276
+#define ADDRESS 277
+#define ENVELOPE 278
+#define COMPARATOR 279
+#define OVER 280
+#define UNDER 281
+#define ALL 282
+#define LOCALPART 283
+#define DOMAIN 284
+#define IS 285
+#define CONTAINS 286
+#define MATCHES 287
+#define OCTET 288
+#define ASCIICASEMAP 289
+#define ASCIINUMERIC 290
 #define REGEX 291
-#define COUNT 292
-#define VALUE 293
-#define OVER 294
-#define UNDER 295
-#define GT 296
-#define GE 297
-#define LT 298
-#define LE 299
-#define EQ 300
-#define NE 301
-#define ALL 302
-#define LOCALPART 303
-#define DOMAIN 304
-#define USER 305
-#define DETAIL 306
-#define RAW 307
-#define TEXT 308
-#define CONTENT 309
-#define DAYS 310
+#define QUOTEREGEX 292
+#define COPY 293
+#define BODY 294
+#define RAW 295
+#define TEXT 296
+#define CONTENT 297
+#define ENVIRONMENT 298
+#define STRINGT 299
+#define SET 300
+#define LOWER 301
+#define UPPER 302
+#define LOWERFIRST 303
+#define UPPERFIRST 304
+#define QUOTEWILDCARD 305
+#define LENGTH 306
+#define VACATION 307
+#define DAYS 308
+#define SUBJECT 309
+#define FROM 310
 #define ADDRESSES 311
-#define SUBJECT 312
-#define FROM 313
-#define HANDLE 314
-#define MIME 315
-#define SECONDS 316
-#define METHOD 317
-#define ID 318
-#define OPTIONS 319
-#define LOW 320
-#define NORMAL 321
-#define HIGH 322
-#define ANY 323
-#define MESSAGE 324
-#define INCLUDE 325
-#define PERSONAL 326
-#define GLOBAL 327
-#define RETURN 328
-#define OPTIONAL 329
-#define ONCE 330
-#define COPY 331
+#define MIME 312
+#define HANDLE 313
+#define SECONDS 314
+#define COUNT 315
+#define VALUE 316
+#define GT 317
+#define GE 318
+#define LT 319
+#define LE 320
+#define EQ 321
+#define NE 322
+#define FLAGS 323
+#define HASFLAG 324
+#define SETFLAG 325
+#define ADDFLAG 326
+#define REMOVEFLAG 327
+#define MARK 328
+#define UNMARK 329
+#define USER 330
+#define DETAIL 331
 #define DATE 332
 #define CURRENTDATE 333
-#define INDEX 334
-#define LAST 335
-#define ZONE 336
-#define ORIGINALZONE 337
-#define MAILBOXEXISTS 338
-#define CREATE 339
-#define METADATA 340
-#define METADATAEXISTS 341
-#define SERVERMETADATA 342
-#define SERVERMETADATAEXISTS 343
-#define YEAR 344
-#define MONTH 345
-#define DAY 346
-#define JULIAN 347
-#define HOUR 348
-#define MINUTE 349
-#define SECOND 350
-#define TIME 351
-#define ISO8601 352
-#define STD11 353
-#define WEEKDAY 354
-#define STRINGT 355
-#define SET 356
-#define LOWER 357
-#define UPPER 358
-#define LOWERFIRST 359
-#define UPPERFIRST 360
-#define QUOTEWILDCARD 361
-#define LENGTH 362
-#define SETFLAG 363
-#define ADDFLAG 364
-#define REMOVEFLAG 365
-#define HASFLAG 366
+#define ORIGINALZONE 334
+#define ZONE 335
+#define TIMEZONE 336
+#define YEARP 337
+#define MONTHP 338
+#define DAYP 339
+#define DATEP 340
+#define JULIAN 341
+#define HOURP 342
+#define MINUTEP 343
+#define SECONDP 344
+#define TIMEP 345
+#define ISO8601 346
+#define STD11 347
+#define ZONEP 348
+#define WEEKDAYP 349
+#define INDEX 350
+#define LAST 351
+#define ADDHEADER 352
+#define DELETEHEADER 353
+#define REJCT 354
+#define EREJECT 355
+#define METHOD 356
+#define OPTIONS 357
+#define MESSAGE 358
+#define IMPORTANCE 359
+#define VALIDNOTIFYMETHOD 360
+#define NOTIFYMETHODCAPABILITY 361
+#define NOTIFY 362
+#define ENOTIFY 363
+#define ENCODEURL 364
+#define DENOTIFY 365
+#define ID 366
+#define ANY 367
+#define LOW 368
+#define NORMAL 369
+#define HIGH 370
+#define IHAVE 371
+#define ERROR 372
+#define MAILBOXEXISTS 373
+#define CREATE 374
+#define METADATA 375
+#define METADATAEXISTS 376
+#define SERVERMETADATA 377
+#define SERVERMETADATAEXISTS 378
+#define BYTIMEREL 379
+#define BYTIMEABS 380
+#define BYMODE 381
+#define BYTRACE 382
+#define DSNNOTIFY 383
+#define DSNRET 384
+#define VALIDEXTLIST 385
+#define LIST 386
+#define INCLUDE 387
+#define OPTIONAL 388
+#define ONCE 389
+#define RETURN 390
+#define PERSONAL 391
+#define GLOBAL 392
+#define DUPLICATE 393
+#define HEADER 394
+#define UNIQUEID 395
+#define SPECIALUSEEXISTS 396
+#define SPECIALUSE 397
+#define FCC 398
+#define MAILBOXID 399
+#define MAILBOXIDEXISTS 400
+#define LOG 401
+#define JMAPQUERY 402
+#define SNOOZE 403
+#define MAILBOX 404
+#define ADDFLAGS 405
+#define REMOVEFLAGS 406
+#define WEEKDAYS 407
 
 /* Value type.  */
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
 
 union YYSTYPE
 {
-#line 238 "sieve/sieve.y" /* yacc.c:1909  */
+#line 170 "sieve/sieve.y" /* yacc.c:1909  */
 
     int nval;
     char *sval;
+    arrayu64_t *nl;
     strarray_t *sl;
+    comp_t *ctag;
     test_t *test;
     testlist_t *testl;
     commandlist_t *cl;
-    struct vtags *vtag;
-    struct aetags *aetag;
-    struct comptags *ctag;
-    struct btags *btag;
-    struct ntags *ntag;
-    struct dtags *dtag;
-    struct itags *itag;
-    struct dttags *dttag;
-    struct ftags *ftag;
-    struct stags *stag;
 
-#line 295 "sieve/sieve.h" /* yacc.c:1909  */
+#line 369 "sieve/sieve.h" /* yacc.c:1909  */
 };
 
 typedef union YYSTYPE YYSTYPE;
@@ -301,6 +375,6 @@ typedef union YYSTYPE YYSTYPE;
 
 
 
-int sieveparse (sieve_script_t *parse_script);
+int sieveparse (sieve_script_t *sscript);
 
 #endif /* !YY_SIEVE_SIEVE_SIEVE_H_INCLUDED  */
diff -pruN 3.0.13-5/sieve/sieve_interface.h 3.2.0-3/sieve/sieve_interface.h
--- 3.0.13-5/sieve/sieve_interface.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sieve_interface.h	2020-05-04 03:28:02.000000000 +0000
@@ -1,6 +1,6 @@
 /* sieve_interface.h -- interface for deliver
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2018 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -50,10 +50,9 @@
 /* error codes */
 #define SIEVE_OK (0)
 
+#include "arrayu64.h"
 #include "strarray.h"
 #include "sieve/sieve_err.h"
-#include "varlist.h"
-#include "grammar.h"
 
 /* external sieve types */
 typedef struct sieve_interp sieve_interp_t;
@@ -66,16 +65,34 @@ typedef int sieve_callback(void *action_
                            void *message_context, const char **errmsg);
 typedef int sieve_get_size(void *message_context, int *size);
 typedef int sieve_get_mailboxexists(void *interp_context, const char *extname);
-typedef int sieve_get_metadata(void *interp_context, const char *extname, const char *keyname, char **res);
+typedef int sieve_get_mailboxidexists(void *interp_context, const char *extname);
+typedef int sieve_get_specialuseexists(void *interp_context, const char *extname,
+                                       strarray_t *uses);
+typedef int sieve_get_metadata(void *interp_context, const char *extname,
+                               const char *keyname, char **res);
 typedef int sieve_get_header(void *message_context,
                              const char *header,
                              const char ***contents);
+typedef int sieve_add_header(void *script_context, void *message_context,
+                             const char *header, const char *contents, int index);
+typedef int sieve_delete_header(void *script_context, void *message_context,
+                             const char *header, int index);
 typedef int sieve_get_fname(void *message_context, const char **fname);
 typedef int sieve_get_envelope(void *message_context,
                                const char *field,
                                const char ***contents);
+typedef int sieve_get_environment(void *script_context,
+                                  const char *keyname, char **res);
 typedef int sieve_get_include(void *script_context, const char *script,
                               int isglobal, char *fpath, size_t size);
+typedef void sieve_logger(void *script_context, void *message_context,
+                          const char *text);
+typedef int sieve_list_validator(void *interp_context, const char *list);
+typedef int sieve_list_comparator(const char *text, size_t tlen,
+                                  const char *list, strarray_t *match_vars,
+                                  void *rock);
+typedef int sieve_jmapquery(void *script_context, void *message_context,
+                            const char *json);
 
 /* MUST keep this struct sync'd with bodypart in imap/message.h */
 typedef struct sieve_bodypart {
@@ -99,21 +116,44 @@ typedef struct sieve_vacation {
     sieve_callback *send_response;
 } sieve_vacation_t;
 
+typedef struct sieve_duplicate {
+    int max_expiration;           /* 0 -> defaults to 90 days */
+    sieve_callback *check;
+    sieve_callback *track;
+} sieve_duplicate_t;
+
 
 /* sieve_imapflags: NULL -> defaults to \flagged */
 
 typedef struct sieve_redirect_context {
     const char *addr;
+    int is_ext_list :1;
+    const char *deliverby;
+    const char *dsn_notify;
+    const char *dsn_ret;
 } sieve_redirect_context_t;
 
 typedef struct sieve_reject_context {
     const char *msg;
+    int is_extended :1;
 } sieve_reject_context_t;
 
+typedef struct sieve_snooze_context {
+    const char *awaken_mbox;
+    strarray_t *imapflags;
+    strarray_t *addflags;
+    strarray_t *removeflags;
+    unsigned char days;
+    arrayu64_t *times;
+    int is_mboxid : 1;
+} sieve_snooze_context_t;
+
 typedef struct sieve_fileinto_context {
     const char *mailbox;
+    const char *specialuse;
     strarray_t *imapflags;
     int do_create :1;
+    const char *mailboxid;
 } sieve_fileinto_context_t;
 
 typedef struct sieve_keep_context {
@@ -141,34 +181,60 @@ typedef struct sieve_send_response_conte
     const char *msg;
     char *subj;
     int mime;
+    sieve_fileinto_context_t fcc;
 } sieve_send_response_context_t;
 
+typedef struct sieve_duplicate_context {
+    char *id;
+    int seconds;
+} sieve_duplicate_context_t;
+
 /* build a sieve interpreter */
 sieve_interp_t *sieve_interp_alloc(void *interp_context);
 int sieve_interp_free(sieve_interp_t **interp);
 
+sieve_interp_t *sieve_build_nonexec_interp();
+
 /* add the callbacks for actions. undefined behavior results if these
    are called after sieve_script_parse is called! */
 void sieve_register_redirect(sieve_interp_t *interp, sieve_callback *f);
 void sieve_register_discard(sieve_interp_t *interp, sieve_callback *f);
 void sieve_register_reject(sieve_interp_t *interp, sieve_callback *f);
 void sieve_register_fileinto(sieve_interp_t *interp, sieve_callback *f);
+void sieve_register_snooze(sieve_interp_t *interp, sieve_callback *f);
 void sieve_register_keep(sieve_interp_t *interp, sieve_callback *f);
 int sieve_register_vacation(sieve_interp_t *interp, sieve_vacation_t *v);
 void sieve_register_imapflags(sieve_interp_t *interp, const strarray_t *mark);
-void sieve_register_notify(sieve_interp_t *interp, sieve_callback *f);
+void sieve_register_notify(sieve_interp_t *interp,
+                           sieve_callback *f, const strarray_t *methods);
 void sieve_register_include(sieve_interp_t *interp, sieve_get_include *f);
+void sieve_register_logger(sieve_interp_t *interp, sieve_logger *f);
 
 /* add the callbacks for messages. again, undefined if used after
    sieve_script_parse */
 void sieve_register_size(sieve_interp_t *interp, sieve_get_size *f);
-void sieve_register_mailboxexists(sieve_interp_t *interp, sieve_get_mailboxexists *f);
+void sieve_register_mailboxexists(sieve_interp_t *interp,
+                                  sieve_get_mailboxexists *f);
+void sieve_register_mailboxidexists(sieve_interp_t *interp,
+                                    sieve_get_mailboxidexists *f);
+void sieve_register_specialuseexists(sieve_interp_t *interp,
+                                     sieve_get_specialuseexists *f);
 void sieve_register_metadata(sieve_interp_t *interp, sieve_get_metadata *f);
 void sieve_register_header(sieve_interp_t *interp, sieve_get_header *f);
+void sieve_register_addheader(sieve_interp_t *interp, sieve_add_header *f);
+void sieve_register_deleteheader(sieve_interp_t *interp, sieve_delete_header *f);
 void sieve_register_fname(sieve_interp_t *interp, sieve_get_fname *f);
 void sieve_register_envelope(sieve_interp_t *interp, sieve_get_envelope *f);
+void sieve_register_environment(sieve_interp_t *interp, sieve_get_environment *f);
 void sieve_register_body(sieve_interp_t *interp, sieve_get_body *f);
 
+void sieve_register_extlists(sieve_interp_t *interp,
+                             sieve_list_validator *v, sieve_list_comparator *c);
+                                
+int sieve_register_duplicate(sieve_interp_t *interp, sieve_duplicate_t *d);
+
+void sieve_register_jmapquery(sieve_interp_t *interp, sieve_jmapquery *f);
+
 typedef int sieve_parse_error(int lineno, const char *msg,
                               void *interp_context,
                               void *script_context);
@@ -202,7 +268,7 @@ int sieve_execute_bytecode(sieve_execute
                            void *script_context, void *message_context);
 
 /* Get space separated list of extensions supported by the implementation */
-const char *sieve_listextensions(sieve_interp_t *i);
+const strarray_t *sieve_listextensions(sieve_interp_t *i);
 
 /* Create a bytecode structure given a parsed commandlist */
 int sieve_generate_bytecode(bytecode_info_t **retval, sieve_script_t *s);
@@ -213,13 +279,6 @@ int sieve_emit_bytecode(int fd, bytecode
 /* Free a bytecode_info_t */
 void sieve_free_bytecode(bytecode_info_t **p);
 
-/* Convert filenames between .bc and .script extensions.
- * Caller must free returned values
- * Returns NULL if unable to perform conversion
- */
-char *sieve_getbcfname(const char *script_fname);
-char *sieve_getscriptfname(const char *bc_name);
-
 /* Get path of bc file pointed to by defaultbc symlink.
  * Caller must free return value
  * Returns NULL if unable to perform conversion
diff -pruN 3.0.13-5/sieve/sieve-lex.c 3.2.0-3/sieve/sieve-lex.c
--- 3.0.13-5/sieve/sieve-lex.c	2019-12-16 04:16:32.000000000 +0000
+++ 3.2.0-3/sieve/sieve-lex.c	2020-05-04 04:11:04.000000000 +0000
@@ -402,8 +402,8 @@ static void yynoreturn yy_fatal_error (y
 	*yy_cp = '\0'; \
 	(yy_c_buf_p) = yy_cp;
 
-#define YY_NUM_RULES 103
-#define YY_END_OF_BUFFER 104
+#define YY_NUM_RULES 171
+#define YY_END_OF_BUFFER 172
 /* This struct is not used in this scanner,
    but its presence is necessary. */
 struct yy_trans_info
@@ -411,63 +411,111 @@ struct yy_trans_info
 	flex_int32_t yy_verify;
 	flex_int32_t yy_nxt;
 	};
-static yyconst flex_int16_t yy_accept[501] =
+static yyconst flex_int16_t yy_accept[941] =
     {   0,
-        0,    0,    0,    0,    0,    0,  104,  102,   99,   99,
-        8,  100,  102,    9,  102,  102,  102,  102,  102,  102,
-      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
-      102,    3,    3,    3,    6,    6,    4,    6,  100,    0,
-        9,    9,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,   10,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        1,    1,    2,    5,    0,    0,    0,    0,    0,    0,
-
-        0,    0,    0,    0,    0,    0,    0,    0,   40,    0,
-       56,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,  172,  170,  169,  169,
+        7,  168,  170,    8,  170,  170,  170,  170,  170,  170,
+      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
+      170,  170,  170,    5,    5,    5,    3,    5,   32,   32,
+      170,   72,   72,  170,  121,  121,  170,   91,   91,  170,
+      171,  170,  168,    0,    8,    8,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,   22,    0,    0,    0,    0,    0,
-        0,   92,    0,    0,    0,    0,    0,    0,    0,    0,
-      101,    0,   64,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-       43,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-
-        0,    0,   69,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,   21,    0,   79,    0,
-        0,   12,    0,    0,    0,    0,    0,    0,    0,    0,
-       29,    0,   36,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,   23,   31,    0,    0,   17,    0,    0,  101,
-        0,    0,    0,   78,    0,    0,   48,    0,    0,    0,
-       52,    0,    0,   45,    0,   82,    0,    0,    0,    0,
-        0,    0,   54,    0,   76,    0,    0,   62,    0,    0,
-        0,    0,    0,   70,    0,    0,   67,    0,   83,    0,
-        0,   14,   13,    0,    0,    0,   11,    0,    0,   16,
 
+        0,    0,    0,    0,    0,    9,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    2,    2,    1,    4,    0,   36,
+        0,    0,   79,    0,    0,    0,    0,    0,  125,    0,
+        0,    0,    0,   93,    0,    0,  107,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,  128,    0,    0,   37,
         0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,   60,    0,    0,    0,   85,    0,    0,   81,
-        0,    0,   93,    0,    0,    0,    0,    0,    0,    0,
-        0,   59,    0,    0,   63,   94,   61,    0,    0,    0,
-        0,    0,    0,   15,    0,    0,   20,    0,    0,    0,
-       38,    0,   26,    0,    0,   77,    0,    0,   25,    0,
-        7,    7,    0,   37,    0,    0,    0,    0,    0,   87,
-       68,   66,   74,   53,   98,    0,    0,    0,    0,   41,
-       44,    0,    0,    0,    0,    0,    0,    0,   34,   18,
-
-        0,    0,   32,    0,    0,   24,   72,    0,    0,    0,
-        0,   30,    0,   33,    0,    7,    0,    0,    0,    0,
-       71,    0,    0,   58,   46,    0,   42,    0,    0,    0,
-       49,   51,    0,    0,   39,   19,   27,    0,   88,   28,
-        0,    0,    7,   47,    0,    0,   57,    0,    0,   75,
-        0,   73,    0,    0,    0,    0,    0,    0,    0,   50,
-        0,   65,    0,    0,    0,    0,    0,    0,    0,   35,
-        0,   55,   95,    0,    0,   96,   80,    0,    0,    0,
-        0,    0,    0,    0,    0,   84,    0,   86,    0,    0,
-       97,   89,   90,    0,    0,    0,    0,    0,   91,    0
 
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,  160,
+        0,    0,    0,   19,    0,    0,    0,    0,    0,    0,
+       55,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,  122,  123,
+      124,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,  167,    0,   44,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,  157,    0,    0,    0,    0,
+
+        0,    0,    0,    0,    0,    0,    0,    0,  129,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,   50,    0,    0,  145,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,   49,    0,   87,    0,    0,    0,    0,   11,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,   27,    0,   85,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,   23,    0,    0,   13,    0,
+        0,   18,    0,    0,    0,    0,    0,   73,   76,   75,
+       78,   77,   74,    0,    0,    0,    0,    0,    0,    0,
+
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,  167,    0,    0,    0,
+        0,    0,    0,    0,   30,    0,    0,   63,    0,    0,
+        0,    0,   66,    0,    0,    0,  131,    0,    0,  109,
+        0,   42,    0,    0,    0,    0,    0,    0,   68,    0,
+        0,  150,    0,    0,   24,    0,    0,    0,    0,    0,
+        0,    0,   51,    0,    0,    0,   47,    0,    0,   89,
+        0,    0,    0,   15,   14,    0,    0,    0,    0,    0,
+       10,    0,    0,    0,  133,    0,   17,    0,    0,    0,
+      132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,   96,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,   70,    0,    0,    0,    0,   84,    0,
+        0,    0,    0,  108,    0,    0,   56,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,   40,    0,    0,
+        0,    0,   25,    0,   57,   71,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,   16,    0,
+        0,   20,    0,    0,    0,    0,  116,    0,  112,    0,
+
+        0,  151,    0,    0,  162,    0,   54,    0,    6,    6,
+        0,   86,    0,    0,    0,    0,    0,   97,   99,    0,
+        0,    0,    0,    0,    0,    0,  102,    0,   94,  105,
+        0,   99,   97,   94,   94,    0,    0,    0,  142,    0,
+        0,    0,    0,    0,  135,   48,   46,    0,  148,   67,
+      153,    0,   61,    0,    0,    0,    0,    0,  127,  130,
+      144,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,   81,    0,   21,    0,    0,    0,   26,
+        0,    0,    0,  113,    0,   83,  146,    0,    0,    0,
+        0,    0,    0,   12,    0,   80,    0,    0,    6,    0,
+
+        0,    0,    0,    0,   92,    0,    0,    0,   95,    0,
+      104,    0,    0,    0,    0,    0,    0,    0,  143,    0,
+        0,   52,    0,    0,    0,    0,  163,   39,  118,    0,
+      117,    0,    0,    0,    0,    0,   69,    0,   65,    0,
+        0,    0,    0,    0,    0,  126,    0,   22,    0,   28,
+        0,    0,    0,  136,    0,   29,    0,    0,    0,    6,
+       62,    0,    0,    0,    0,    0,   98,  100,  101,    0,
+       98,  164,    0,    0,    0,    0,   38,    0,    0,    0,
+        0,    0,  149,    0,  147,    0,    0,    0,    0,  154,
+        0,  166,  110,    0,    0,  152,    0,  161,    0,    0,
+
+        0,    0,    0,    0,    0,    0,    0,    0,   33,  103,
+      106,   64,    0,    0,    0,  119,    0,   45,    0,  159,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,   82,    0,    0,    0,    0,    0,    0,
+        0,    0,   31,  120,   58,    0,   41,    0,    0,  156,
+       59,   90,    0,   53,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,  165,  111,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,   88,    0,  134,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,   60,    0,  137,    0,
+
+      138,    0,   43,    0,    0,    0,  141,  140,  158,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,  155,    0,   34,   35,    0,    0,    0,
+        0,    0,  115,    0,  139,    0,    0,    0,  114,    0
     } ;
 
 static yyconst YY_CHAR yy_ec[256] =
@@ -476,16 +524,16 @@ static yyconst YY_CHAR yy_ec[256] =
         1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    2,    1,    5,    6,    1,    1,    1,    1,    1,
-        1,    7,    1,    1,    1,    8,    9,   10,   10,   10,
-       10,   10,   10,   10,   10,   10,   10,   11,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-       12,    1,    1,    1,   12,    1,   12,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,   13,    1,    1,    1,    1,   14,   15,   16,   17,
-
-       18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
-       28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
-       38,   39,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    7,    8,    1,    9,   10,   11,   12,   13,   14,
+       15,   16,   16,   17,   18,   19,   18,   20,   21,    1,
+        1,    1,    1,    1,   22,    1,   23,   24,   25,    1,
+       26,   27,   28,   29,   30,   31,   32,   33,   34,    1,
+        1,   35,   36,   37,   38,    1,   39,    1,   40,   41,
+        1,   42,    1,    1,   43,    1,   44,   45,   46,   47,
+
+       48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
+       58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
+       68,   69,    1,   70,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
@@ -502,277 +550,585 @@ static yyconst YY_CHAR yy_ec[256] =
         1,    1,    1,    1,    1
     } ;
 
-static yyconst YY_CHAR yy_meta[40] =
+static yyconst YY_CHAR yy_meta[71] =
     {   0,
         1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1
     } ;
 
-static yyconst flex_uint16_t yy_base[507] =
+static yyconst flex_uint16_t yy_base[951] =
     {   0,
-        0,    0,  534,   37,   38,   39,  536,  538,  538,  538,
-      538,    0,  528,   36,   49,   30,  506,  499,   36,   60,
-       39,   72,   40,  514,   75,  503,  512,   73,   74,  502,
-      514,  538,  538,   95,  538,  538,  538,    0,    0,  520,
-       84,  538,   47,   81,   93,   88,  501,  100,   98,  106,
-      109,  497,  106,  506,  489,  114,   82,  504,  111,  507,
-      492,  502,  493,  479,  499,  484,  481,  486,  480,  479,
-      475,  487,  483,  482,  474,  491,  538,  488,  485,   95,
-      469,  468,  119,  113,  461,  119,  462,  464,  471,  480,
-      538,  492,  538,  538,  487,  144,  476,  467,  128,  473,
-
-      452,  456,  462,  473,  458,  457,  457,  463,  538,  465,
-      538,  449,  453,  123,  446,   69,  452,  446,  460,  442,
-      452,  455,  441,  443,  434,  449,  452,  452,  429,  448,
-      435,  445,  437,  434,  129,  432,  431,  420,  426,  438,
-      427,  438,  143,  435,  420,  419,  432,  430,  431,  422,
-      417,  420,  420,  429,  420,  419,  422,  411,  404,  403,
-      401,  416,  416,  404,  410,  398,  412,  415,  414,  149,
-      538,  396,  538,  397,  392,  386,  396,  408,  389,  406,
-      405,  398,  391,  401,  398,  393,  395,  379,  391,  396,
-      391,  392,  375,  385,  387,  378,  385,  380,  381,  369,
-
-      367,  365,  538,  379,  368,  372,  361,  375,  374,  360,
-      356,  371,  363,  369,  367,  366,  538,  366,  538,  350,
-      368,  538,  362,  355,  346,  360,  355,  351,  357,  340,
-      538,  358,  538,  355,  352,  339,  353,  333,  345,  335,
-      347,  339,  538,  538,  336,  351,  538,  330,  327,  352,
-      340,  343,  149,  538,  323,  322,  538,  332,  331,  320,
-      538,  337,  325,  538,  312,  538,  315,  322,  315,  324,
-      330,  315,  538,  328,  538,  313,  318,  538,  311,  320,
-      300,  309,  317,  538,  303,  302,  538,  314,  538,  317,
-      298,  538,  538,  302,  306,  296,  538,  298,  293,  538,
-
-      297,  309,  291,  304,  292,  305,  280,  299,  283,  297,
-      283,  286,  281,  297,  290,  166,  285,  286,  275,  275,
-      283,  277,  538,  285,  277,  274,  538,  275,  281,  538,
-      277,  268,  277,  277,  274,  276,  267,  264,  263,  262,
-      252,  538,  270,  270,  538,  266,  538,  264,  251,  249,
-      262,  263,  250,  538,  245,  257,  538,  258,  238,  241,
-      538,  257,  538,  253,  253,  538,  244,  249,  538,  171,
-      538,  265,  175,  538,  239,  234,  251,  237,  230,  538,
-      538,  538,  538,  538,  538,  248,  239,  228,  241,  538,
-      538,  150,  244,  243,  234,  223,  221,  231,  538,  538,
-
-      235,  213,  538,  232,  221,  538,  538,  230,  233,  213,
-      220,  538,  226,  538,  177,  180,  216,  224,  208,  208,
-      538,  208,  207,  538,  538,  212,  538,  211,  210,  209,
-      538,  538,  202,  218,  538,  538,  538,  194,  212,  538,
-      215,  195,  538,  538,  195,  198,  538,  192,  192,  538,
-      184,  538,  205,  189,  187,  197,  181,  197,  202,  538,
-      184,  538,  181,  185,  196,  178,  192,  177,  186,  538,
-      190,  538,  538,  179,  191,  538,  538,  171,  171,  188,
-      183,  169,  167,  165,  164,  538,  179,  538,  163,  180,
-      538,  538,  175,  139,  149,  134,   96,   86,  538,  538,
-
-      184,  186,   72,   48,  188,  190
+        0,    0, 1433,   68,   69,   70,  111,    0,   77,   81,
+       85,   89,   93,   97,  101,  105, 1435, 1437, 1437, 1437,
+     1437,    0, 1427,  165,  178,   85, 1375, 1368,   89,  131,
+       91,   90,   95, 1375, 1382, 1371,  101, 1370, 1379,  137,
+      100, 1369, 1381, 1437, 1437,  198, 1437,    0, 1437, 1437,
+      164, 1437, 1437,  198, 1437, 1437,  199, 1437, 1437,  201,
+     1437,  267,    0, 1417,    0, 1437,   92, 1355,   60,  201,
+     1365,  144, 1366,  206,  204,  221,  226, 1362,  223, 1371,
+     1354,  106,  204, 1369,  205, 1372, 1367, 1356, 1366, 1357,
+     1343, 1363, 1348, 1345,  163, 1345, 1347, 1343, 1339,  228,
+
+     1351, 1347, 1346, 1338, 1355, 1437, 1354, 1351, 1352, 1347,
+     1344,  225, 1330, 1329,  268,  220, 1322, 1332, 1341,  229,
+     1321, 1323, 1330,  246, 1437, 1382, 1437, 1437, 1379, 1437,
+      115, 1378, 1437,  251,  292,  293,   71, 1377, 1437, 1376,
+     1375, 1374, 1373, 1437,  297, 1372, 1437,  295,  288,  280,
+      300,  320,  338,  321,  346,  352,  327,  418, 1369,  200,
+     1328, 1319,  271,  288, 1325, 1304, 1308, 1314, 1323, 1322,
+     1323, 1308, 1307, 1307, 1319, 1312, 1437, 1302, 1313, 1437,
+     1297, 1301, 1295,  105,  316,  169, 1300,  299, 1309, 1291,
+     1301, 1304, 1290, 1292, 1283,  303, 1302, 1299, 1301, 1278,
+
+      322, 1285, 1295, 1287, 1293, 1283,  331, 1281, 1280, 1269,
+     1275, 1287, 1286, 1275, 1286, 1276,  335,  336, 1277, 1271,
+     1266, 1265, 1278, 1276, 1277, 1258, 1267, 1262, 1261, 1437,
+     1264, 1264, 1273, 1264, 1263, 1266, 1255, 1248, 1247, 1245,
+     1260, 1260, 1249, 1260, 1246, 1252, 1240, 1254, 1257, 1256,
+     1247,  362, 1293, 1292, 1291, 1290, 1289, 1288, 1437, 1437,
+     1437,  412,  397,  371,  399,  408,  388,  414,  439,  413,
+      391,  427,  443,  480,  472,  474,  481,  482,  484,  550,
+      388, 1437,  349, 1437, 1234,  351, 1232, 1227, 1221, 1231,
+     1243, 1224, 1241, 1240, 1225, 1437, 1232, 1225, 1235, 1232,
+
+     1231, 1226, 1218, 1227, 1211, 1223, 1209, 1227, 1222, 1214,
+     1222, 1205, 1215, 1217, 1208, 1211, 1214, 1209, 1210, 1198,
+     1196, 1194, 1437, 1208, 1197, 1437, 1196, 1207, 1199, 1188,
+     1202, 1189, 1200, 1186, 1182, 1191, 1196, 1188, 1194, 1193,
+     1191, 1190, 1437, 1190, 1437, 1174, 1173, 1191, 1182, 1437,
+     1184, 1177, 1170, 1182, 1168, 1165, 1179, 1174, 1170, 1176,
+     1175, 1158, 1161, 1437, 1175, 1437, 1172, 1169, 1156, 1170,
+     1150, 1162, 1152, 1164, 1156, 1437, 1141, 1157, 1437, 1151,
+     1187, 1437, 1145, 1142, 1157,  402,  444, 1437, 1437, 1437,
+     1437, 1437, 1437,  521,  495, 1198,  541,  486,  493,  525,
+
+      540,  554,  562,  506,  376,  558,  596,  597,  488,  598,
+      604,  625,  624,  651,  654,  720, 1195, 1146, 1152, 1152,
+     1142, 1153, 1152,  513, 1437, 1132, 1131, 1437, 1141, 1140,
+     1144, 1128, 1437, 1145, 1133, 1139, 1437, 1125, 1118, 1437,
+     1121, 1437, 1128, 1121, 1136, 1129, 1135, 1120, 1437, 1133,
+     1127, 1437, 1117, 1122, 1437, 1115, 1124, 1104, 1105, 1112,
+     1116, 1119, 1437, 1105, 1101, 1103, 1437, 1115, 1115, 1437,
+     1117, 1116, 1097, 1437, 1437, 1101, 1109, 1104, 1094, 1108,
+     1437, 1095, 1094, 1105, 1437, 1088, 1437, 1092, 1104, 1086,
+     1437, 1099, 1081, 1086, 1099, 1074, 1093, 1077, 1091, 1077,
+
+     1080, 1075, 1091, 1086, 1089, 1082,  639, 1077, 1078, 1086,
+      514,  212,  691, 1123, 1437, 1122,  563,  631,  679,  630,
+      693,  607,  497, 1121,  666, 1120, 1119,  729,  710,  724,
+      738,  755, 1118, 1117,  821, 1077, 1058, 1071, 1070, 1071,
+     1055, 1063, 1057, 1437, 1065, 1057, 1054, 1062, 1437, 1054,
+     1060, 1046, 1043, 1437, 1054, 1045, 1054, 1044, 1053, 1050,
+     1052, 1043, 1029, 1039, 1038, 1037,  586, 1437, 1045, 1045,
+     1047, 1044, 1437, 1041, 1039, 1437, 1043, 1036, 1038, 1022,
+     1020, 1031, 1032, 1033, 1035, 1019, 1020, 1013, 1437, 1012,
+     1024, 1437, 1025, 1024, 1004, 1007, 1026, 1022, 1437, 1018,
+
+     1018, 1437, 1009, 1014, 1437, 1008, 1437,  794, 1437, 1059,
+      309, 1437, 1003,  357,  527,  632, 1055, 1437, 1437,  496,
+      754,  721, 1054,  780,  783, 1053, 1437,  790, 1437, 1437,
+      797, 1437, 1437, 1437, 1437,  852, 1007,  994, 1437,  126,
+     1007, 1010,  996,  989, 1437, 1437, 1437,  987, 1437, 1437,
+     1437, 1006, 1437, 1005,  996,  980,  984,  997, 1437, 1437,
+     1437,  571, 1000,  999,  994,  989,  991,  977,  983,  974,
+      984,  983,  966, 1437,  985, 1437,  985,  983,  962, 1437,
+      966,  980,  971, 1437,  968, 1437, 1437,  964,  630,  980,
+      967,  959,  966, 1437,  972, 1437,  955,  566,  582,  961,
+
+      950,  958,  617,  665, 1437,  680, 1010, 1009, 1437, 1008,
+     1437,  761,  811,  812,  950,  963,  965,  961, 1437,  945,
+      945, 1437,  945,  948,  943,  942,  950, 1437, 1437,  946,
+     1437,  945,  944,  948,  942,  941, 1437,  931, 1437,  947,
+      932,  930,  930,  946,  945, 1437,  940, 1437,  939, 1437,
+      918,  918,  937,  935,  934, 1437,  937,  917,  917, 1437,
+     1437,  915,  914,  714,  971,  970, 1437, 1437, 1437,  969,
+     1437, 1437,  911,  910,  916,  912, 1437,  914,  922,  904,
+      904,  918, 1437,  895, 1437,  915,  915,  917,  898, 1437,
+      897, 1437, 1437,  878,  893, 1437,  882, 1437,  886,  889,
+
+      869,  872,  884,  889,  884,  888,  877,  747, 1437, 1437,
+     1437, 1437,  870,  883,  865, 1437,  877, 1437,  861, 1437,
+      865,  854,  873,  868,   29,  130,  209,  363,  379,  391,
+      401,  440,  444, 1437,  471,  481,  507,  544,  678,  706,
+      564,  568, 1437, 1437, 1437,  591, 1437,  610,  593, 1437,
+     1437, 1437,  599, 1437,  634,  675,  669,  674,  691,  689,
+      686,  672,  774,  759,  677,  709,  719,  710, 1437, 1437,
+      715,  741,  746,  763,  750,  747,  758,  779,  818,  822,
+      769,  768, 1437,  788, 1437,  774,  776,  796,  796,  790,
+      783,  791,  850,  844,  808,  811, 1437,  799, 1437,  816,
+
+      815,  802, 1437,  821,  866,  868, 1437, 1437, 1437,  831,
+      816,  823,  824,  883,  884,  831,  840,  831,  843,  890,
+      892,  854,  839, 1437,  844, 1437, 1437,  858,  841,  860,
+      856,  849, 1437,  857, 1437,  861,  851,  847, 1437, 1437,
+      942,  915,  916,  944,  946,  948,  950,  952,  954,  956
     } ;
 
-static yyconst flex_int16_t yy_def[507] =
+static yyconst flex_int16_t yy_def[951] =
     {   0,
-      500,    1,  501,  501,  502,  502,  500,  500,  500,  500,
-      500,  503,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  504,  503,  505,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  505,  505,  500,  500,  500,  500,
-
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  505,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  505,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  506,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  506,  506,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,    0,
-
-      500,  500,  500,  500,  500,  500
+      940,    1,  941,  941,  941,  941,    1,    7,    7,    7,
+        7,    7,    7,    7,    7,    7,  940,  940,  940,  940,
+      940,  942,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  943,  940,  940,
+      944,  940,  940,  945,  940,  940,  946,  940,  940,  947,
+      940,  948,  942,  949,   24,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  944,  940,
+      944,  945,  940,  945,  945,  945,  945,  946,  940,  946,
+      946,  946,  947,  940,  947,  948,  940,  948,  948,  948,
+      948,  948,  948,  948,  948,  948,  948,  948,  949,  949,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  944,  945,  945,  945,  945,  945,  945,  940,  940,
+      940,  947,  948,  948,  948,  948,  948,  948,  948,  948,
+      948,  948,  948,  948,  948,  948,  948,  948,  948,  948,
+      949,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  944,  944,  940,  940,  940,
+      940,  940,  940,  947,  948,  948,  948,  948,  948,  948,
+
+      948,  948,  948,  948,  948,  948,  948,  948,  948,  948,
+      948,  948,  948,  948,  948,  948,  949,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      944,  944,  947,  948,  940,  948,  948,  948,  948,  948,
+      948,  948,  948,  948,  948,  948,  948,  948,  948,  948,
+      948,  948,  948,  948,  948,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      950,  940,  940,  940,  944,  944,  947,  940,  940,  948,
+      948,  948,  948,  948,  948,  948,  940,  948,  940,  940,
+      948,  940,  940,  940,  940,  948,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  950,  950,  940,
+
+      940,  940,  944,  944,  940,  948,  948,  948,  940,  948,
+      940,  948,  948,  948,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  944,  944,  948,  940,  940,  940,  948,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940,  944,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  944,  944,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  944,  944,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  944,  944,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  944,  944,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  944,  944,  940,  940,  940,  940,
+      940,  940,  940,  944,  944,  940,  940,  940,  940,  944,
+      944,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,    0,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940
     } ;
 
-static yyconst flex_uint16_t yy_nxt[578] =
+static yyconst flex_uint16_t yy_nxt[1508] =
     {   0,
-        8,    9,   10,    9,   11,   12,    8,    8,   13,   14,
-       15,    8,    8,   16,   17,   18,   19,   20,   21,    8,
-       22,   23,    8,   24,    8,   25,   26,    8,    8,    8,
-       27,   28,   29,   30,   31,    8,    8,    8,    8,   33,
-       36,   36,   37,   37,   34,   41,   62,   42,   94,   67,
-       38,   38,   73,   68,   63,   42,   64,   69,   77,   42,
-       74,   42,   43,   97,   44,   45,   78,   46,   47,   48,
-       49,   98,   39,   50,   51,   52,   53,   54,   55,   56,
-       57,   58,   59,   60,   70,   75,   71,   61,   80,   76,
-       84,   87,   81,   41,   85,   42,   72,   91,   92,  127,
-
-      193,  194,   93,   42,   88,   86,  101,   42,   99,   42,
-      102,  100,  104,  107,  109,  128,  152,  499,  105,  112,
-      103,  108,  115,  113,  110,  153,  116,  125,  498,  111,
-      117,  126,  119,  114,  120,  156,  121,  130,  190,  131,
-      122,  157,  132,  161,  158,  162,  164,  213,  159,  165,
-      170,  160,  171,  174,  175,   96,  176,  250,  191,  214,
-      222,  177,  321,  426,  223,  497,  322,  370,  371,  372,
-      496,  373,  370,  371,  372,  495,  373,  371,  416,  371,
-      416,  427,  443,  416,   32,   32,   35,   35,   95,   95,
-      415,  415,  494,  493,  492,  491,  490,  489,  488,  487,
-
-      486,  485,  484,  483,  482,  481,  480,  479,  478,  477,
-      476,  475,  474,  473,  472,  471,  470,  469,  468,  467,
-      466,  465,  464,  463,  462,  461,  460,  459,  458,  457,
-      456,  455,  454,  453,  452,  451,  450,  449,  448,  447,
-      446,  445,  444,  442,  441,  440,  439,  438,  437,  436,
-      435,  434,  433,  432,  431,  430,  429,  428,  425,  424,
-      423,  422,  421,  420,  419,  418,  417,  371,  414,  413,
-      412,  411,  410,  409,  408,  407,  406,  405,  404,  403,
-      402,  401,  400,  399,  398,  397,  396,  395,  394,  393,
-      392,  391,  390,  389,  388,  387,  386,  385,  384,  383,
-
-      382,  381,  380,  379,  378,  377,  376,  375,  374,  369,
-      368,  367,  366,  365,  364,  363,  362,  361,  360,  359,
-      358,  357,  356,  355,  354,  353,  352,  351,  350,  349,
-      348,  347,  346,  345,  344,  343,  342,  341,  340,  339,
-      338,  337,  336,  335,  334,  333,  332,  331,  330,  329,
-      328,  327,  326,  325,  324,  323,  320,  319,   96,  318,
-      317,  316,  315,  314,  313,  312,  311,  310,  309,  308,
-      307,  306,  305,  304,  303,  302,  301,  300,  299,  298,
-      297,  296,  295,  294,  293,  292,  291,  290,  289,  288,
-      287,  286,  285,  284,  283,  282,  281,  280,  279,  278,
-
-      277,  276,  275,  274,  273,  272,  271,  270,  269,  268,
-      267,  266,  265,  264,  263,  262,  261,  260,  259,  258,
-      257,  256,  255,  254,  253,  252,  251,  249,  248,  247,
-      246,  245,  244,  243,  242,  241,  240,  239,  238,  237,
-      236,  235,  234,  233,  232,  231,  230,  229,  228,  227,
-      226,  225,  224,  221,  220,  219,  218,  217,  216,  215,
-      212,  211,  210,  209,  208,  207,  206,  205,  204,  203,
-      202,  201,  200,  199,  198,  197,  196,  195,  192,  189,
-      188,  187,  186,  185,  184,  183,  182,  181,  180,  179,
-      178,  173,  172,   96,   91,  169,  168,  167,  166,  163,
-
-      155,  154,  151,  150,  149,  148,  147,  146,  145,  144,
-      143,  142,  141,  140,  139,  138,  137,  136,  135,  134,
-      133,  129,  124,  123,  118,  106,   96,   90,   89,   83,
-       82,   79,   66,   65,   40,  500,   33,    7,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500
+       18,   19,   20,   19,   21,   22,   18,   18,   18,   18,
+       23,   24,   24,   24,   24,   24,   24,   24,   24,   25,
+       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
+       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
+       18,   18,   18,   26,   27,   28,   29,   30,   31,   18,
+       32,   33,   34,   35,   36,   37,   38,   18,   18,   18,
+       39,   40,   41,   42,   43,   18,   18,   18,   18,   18,
+       45,   45,   45,   47,   47,  133,  850,   46,   52,   53,
+       52,   54,   52,   53,   52,   54,   55,   56,   55,   57,
+       55,   56,   55,   57,   58,   59,   58,   60,   58,   59,
+
+       58,   60,   18,   61,   18,   62,   18,   61,   18,   62,
+       48,   48,   49,   50,   49,   51,   18,  164,  258,  130,
+      165,   18,   18,   18,   18,   18,   18,   18,   18,   18,
+       18,   89,   94,  104,  102,  252,   95,  105,  161,   90,
+       96,   91,  103,  106,  112,  107,  162,  121,  113,  195,
+      308,  108,   97,  196,   18,   18,   18,   18,   18,   18,
+      122,   18,   18,   18,   18,   18,   18,   18,  130,  717,
+      309,   18,   18,   18,   18,   18,   65,   65,   65,   65,
+       65,   65,   65,   65,  116,   98,  718,   99,  117,  170,
+       66,  100,  851,  118,   66,  119,   66,  101,  171,  120,
+
+      125,  126,  133,  139,  172,  144,  281,  127,  145,  145,
+      282,  140,  141,  142,   66,  131,  130,  213,   66,  214,
+       66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
+      312,  313,   76,   77,   78,   79,   80,   81,   82,   83,
+       84,   85,   86,   87,  166,  134,   88,  135,  167,  174,
+      177,  197,  136,  175,  137,  133,  852,  176,  168,  178,
+      179,  201,  198,  202,  181,  180,  203,  199,  182,  185,
+      145,  147,  183,  186,  616,  219,  231,  187,  184,  189,
+      240,  190,  241,  191,  147,  232,  245,  192,  220,  246,
+      148,  250,  147,  149,  150,  151,  133,  133,  152,  147,
+
+      251,  144,  153,  154,  147,  155,  156,  157,  262,  262,
+      253,  609,  699,  148,  235,  265,  263,  149,  150,  151,
+      236,  264,  152,  237,  147,  147,  285,  238,  153,  154,
+      239,  147,  155,  286,  156,  157,  158,  266,  263,  254,
+      256,  265,  147,  287,  288,  264,  289,  267,  273,  265,
+      147,  290,  324,  268,  255,  257,  147,  264,  325,  315,
+      276,  316,  270,  266,  263,  326,  130,  310,  331,  266,
+      274,  267,  273,  332,  271,  147,  275,  268,  311,  338,
+      147,  339,  350,  352,  276,  270,  351,  353,  523,  269,
+      273,  340,  147,  274,  160,  147,  276,  418,  417,  275,
+
+      271,  147,  421,  147,  701,  386,  130,  272,  398,  419,
+      853,  422,  147,  702,  405,  274,  144,  147,  147,  387,
+      401,  275,  147,  394,  394,  394,  394,  394,  394,  394,
+      394,  147,  399,  395,  398,  404,  396,  405,  400,  263,
+      398,  854,  277,  147,  401,  278,  402,  147,  130,  404,
+      405,  279,  855,  265,  271,  266,  399,  401,  404,  395,
+      405,  263,  400,  511,  396,  277,  397,  856,  399,  278,
+      402,  403,  404,  405,  407,  279,  147,  400,  147,  265,
+      271,  266,  404,  402,  147,  147,  147,  280,  147,  512,
+      147,  857,  147,  409,  858,  403,  406,  147,  407,  147,
+
+      147,  147,  409,  404,  408,  408,  410,  706,  403,  626,
+      147,  517,  407,  407,  401,  409,  413,  859,  130,  514,
+      516,  398,  526,  860,  409,  144,  404,  408,  408,  147,
+      410,  130,  513,  513,  513,  513,  513,  407,  401,  522,
+      413,  409,  514,  410,  147,  515,  516,  398,  526,  408,
+      411,  412,  518,  414,  147,  516,  542,  526,  147,  615,
+      543,  861,  147,  522,  514,  514,  147,  147,  609,  699,
+      523,  409,  404,  405,  408,  522,  518,  519,  703,  620,
+      400,  407,  415,  399,  760,  699,  395,  398,  514,  396,
+      520,  522,  862,  409,  518,  404,  405,  408,  520,  519,
+
+      147,  147,  147,  519,  400,  407,  415,  399,  147,  519,
+      514,  147,  395,  398,  730,  522,  520,  396,  865,  416,
+      524,  130,  527,  520,  520,  519,  525,  522,  147,  147,
+      866,  521,  731,  525,  147,  147,  130,  522,  526,  625,
+      608,  609,  610,  524,  611,  527,  665,  867,  527,  524,
+      525,  666,  621,  868,  869,  147,  623,  525,  147,  870,
+      520,  522,  519,  625,  526,  524,  525,  527,  764,  130,
+      147,  527,  524,  528,  621,  527,  625,  752,  527,  704,
+      623,  753,  130,  147,  147,  516,  520,  520,  519,  628,
+      520,  519,  766,  530,  529,  144,  871,  147,  527,  623,
+
+      621,  527,  617,  617,  617,  617,  617,  617,  617,  617,
+      130,  516,  628,  520,  627,  622,  520,  519,  130,  623,
+      531,  863,  808,  532,  515,  147,  872,  765,  630,  622,
+      873,  874,  523,  629,  875,  628,  876,  877,  517,  878,
+      881,  622,  632,  623,  533,  708,  622,  518,  622,  525,
+      623,  130,  628,  522,  534,  622,  520,  519,  147,  630,
+      882,  625,  624,  130,  623,  147,  883,  533,  708,  864,
+      884,  518,  622,  525,  623,  628,  885,  522,  130,  622,
+      534,  623,  520,  519,  709,  625,  707,  147,  623,  535,
+      708,  622,  839,  623,  147,  608,  609,  610,  631,  611,
+
+      770,  147,  886,  840,  708,  623,  710,  623,  887,  888,
+      707,  712,  889,  890,  880,  769,  771,  622,  712,  891,
+      710,  892,  130,  707,  624,  635,  130,  708,  770,  710,
+      770,  895,  896,  712,  897,  879,  898,  899,  900,  901,
+      712,  902,  621,  710,  628,  903,  904,  623,  130,  708,
+      770,  770,  710,  625,  130,  907,  709,  622,  908,  712,
+      909,  910,  911,  912,  621,  893,  713,  628,  913,  894,
+      130,  623,  130,  712,  916,  710,  708,  625,  770,  770,
+      770,  770,  917,  622,  707,  918,  919,  130,  130,  922,
+      636,  923,  924,  925,  926,  712,  927,  928,  710,  708,
+
+      929,  930,  931,  932,  906,  905,  933,  934,  707,  914,
+      935,  936,  937,  938,  939,   63,  128,  849,  848,  915,
+      847,  714,  846,  845,  844,  843,  842,  841,  838,  921,
+      837,  836,  835,  834,  833,  832,  831,  830,  829,  828,
+      827,  920,   44,   44,  129,  129,  132,  132,  138,  138,
+      143,  143,  146,  146,  159,  159,  698,  698,  826,  825,
+      824,  823,  822,  821,  820,  819,  818,  817,  816,  815,
+      814,  813,  812,  811,  810,  809,  807,  806,  805,  804,
+      803,  802,  801,  800,  799,  798,  797,  796,  795,  794,
+      793,  792,  791,  790,  789,  788,  787,  786,  785,  784,
+
+      783,  782,  781,  780,  779,  778,  777,  776,  775,  774,
+      773,  772,  769,  768,  767,  763,  762,  761,  759,  758,
+      757,  756,  755,  754,  751,  750,  749,  748,  747,  746,
+      745,  744,  743,  742,  741,  740,  739,  738,  737,  736,
+      735,  734,  733,  732,  729,  728,  727,  726,  725,  724,
+      723,  722,  721,  720,  719,  716,  715,  711,  709,  705,
+      700,  609,  697,  696,  695,  694,  693,  692,  691,  690,
+      689,  688,  687,  686,  685,  684,  683,  682,  681,  680,
+      679,  678,  677,  676,  675,  674,  673,  672,  671,  670,
+      669,  668,  667,  664,  663,  662,  661,  660,  659,  658,
+
+      657,  656,  655,  654,  653,  652,  651,  650,  649,  648,
+      647,  646,  645,  644,  643,  642,  641,  640,  639,  638,
+      637,  634,  633,  630,  629,  627,  619,  618,  614,  613,
+      612,  607,  606,  605,  604,  603,  602,  601,  600,  599,
+      598,  597,  596,  595,  594,  593,  592,  591,  590,  589,
+      588,  587,  586,  585,  584,  583,  582,  581,  580,  579,
+      578,  577,  576,  575,  574,  573,  572,  571,  570,  569,
+      568,  567,  566,  565,  564,  563,  562,  561,  560,  559,
+      558,  557,  556,  555,  554,  553,  552,  551,  550,  549,
+      548,  547,  546,  545,  544,  541,  540,  539,  538,  537,
+
+      536,  160,  515,  510,  509,  508,  507,  506,  505,  504,
+      503,  502,  501,  500,  499,  498,  497,  496,  495,  494,
+      493,  492,  491,  490,  489,  488,  487,  486,  485,  484,
+      483,  482,  481,  480,  479,  478,  477,  476,  475,  474,
+      473,  472,  471,  470,  469,  468,  467,  466,  465,  464,
+      463,  462,  461,  460,  459,  458,  457,  456,  455,  454,
+      453,  452,  451,  450,  449,  448,  447,  446,  445,  444,
+      443,  442,  441,  440,  439,  438,  437,  436,  435,  434,
+      433,  432,  431,  430,  429,  428,  427,  426,  425,  424,
+      423,  420,  393,  392,  391,  390,  389,  388,  385,  384,
+
+      383,  382,  381,  380,  379,  378,  377,  376,  375,  374,
+      373,  372,  371,  370,  369,  368,  367,  366,  365,  364,
+      363,  362,  361,  360,  359,  358,  357,  356,  355,  354,
+      349,  348,  347,  346,  345,  344,  343,  342,  341,  337,
+      336,  335,  334,  333,  330,  329,  328,  327,  323,  322,
+      321,  320,  319,  318,  317,  314,  307,  306,  305,  304,
+      303,  302,  301,  300,  299,  298,  297,  296,  295,  294,
+      293,  292,  291,  284,  283,  160,  147,  144,  261,  260,
+      259,  139,  133,  130,  125,  249,  248,  247,  244,  243,
+      242,  234,  233,  230,  229,  228,  227,  226,  225,  224,
+
+      223,  222,  221,  218,  217,  216,  215,  212,  211,  210,
+      209,  208,  207,  206,  205,  204,  200,  194,  193,  188,
+      173,  169,  163,  160,  124,  123,  115,  114,  111,  110,
+      109,   93,   92,   64,  940,   45,   17,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940
     } ;
 
-static yyconst flex_int16_t yy_chk[578] =
+static yyconst flex_int16_t yy_chk[1508] =
     {   0,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    4,
-        5,    6,    5,    6,    4,   14,   16,   14,  504,   19,
-        5,    6,   21,   19,   16,   14,   16,   19,   23,   14,
-       21,   14,   15,   43,   15,   15,   23,   15,   15,   15,
-       15,   43,  503,   15,   15,   15,   15,   15,   15,   15,
-       15,   15,   15,   15,   20,   22,   20,   15,   25,   22,
-       28,   29,   25,   41,   28,   41,   20,   34,   34,   57,
-
-      116,  116,   34,   41,   29,   28,   45,   41,   44,   41,
-       45,   44,   46,   48,   49,   57,   80,  498,   46,   50,
-       45,   48,   51,   50,   49,   80,   51,   56,  497,   49,
-       51,   56,   53,   50,   53,   83,   53,   59,  114,   59,
-       53,   83,   59,   84,   83,   84,   86,  135,   83,   86,
-       96,   83,   96,   99,   99,  170,   99,  170,  114,  135,
-      143,   99,  253,  392,  143,  496,  253,  316,  316,  316,
-      495,  316,  370,  370,  370,  494,  370,  373,  373,  415,
-      415,  392,  416,  416,  501,  501,  502,  502,  505,  505,
-      506,  506,  493,  490,  489,  487,  485,  484,  483,  482,
-
-      481,  480,  479,  478,  475,  474,  471,  469,  468,  467,
-      466,  465,  464,  463,  461,  459,  458,  457,  456,  455,
-      454,  453,  451,  449,  448,  446,  445,  442,  441,  439,
-      438,  434,  433,  430,  429,  428,  426,  423,  422,  420,
-      419,  418,  417,  413,  411,  410,  409,  408,  405,  404,
-      402,  401,  398,  397,  396,  395,  394,  393,  389,  388,
-      387,  386,  379,  378,  377,  376,  375,  372,  368,  367,
-      365,  364,  362,  360,  359,  358,  356,  355,  353,  352,
-      351,  350,  349,  348,  346,  344,  343,  341,  340,  339,
-      338,  337,  336,  335,  334,  333,  332,  331,  329,  328,
-
-      326,  325,  324,  322,  321,  320,  319,  318,  317,  315,
-      314,  313,  312,  311,  310,  309,  308,  307,  306,  305,
-      304,  303,  302,  301,  299,  298,  296,  295,  294,  291,
-      290,  288,  286,  285,  283,  282,  281,  280,  279,  277,
-      276,  274,  272,  271,  270,  269,  268,  267,  265,  263,
-      262,  260,  259,  258,  256,  255,  252,  251,  250,  249,
-      248,  246,  245,  242,  241,  240,  239,  238,  237,  236,
-      235,  234,  232,  230,  229,  228,  227,  226,  225,  224,
-      223,  221,  220,  218,  216,  215,  214,  213,  212,  211,
-      210,  209,  208,  207,  206,  205,  204,  202,  201,  200,
-
-      199,  198,  197,  196,  195,  194,  193,  192,  191,  190,
-      189,  188,  187,  186,  185,  184,  183,  182,  181,  180,
-      179,  178,  177,  176,  175,  174,  172,  169,  168,  167,
-      166,  165,  164,  163,  162,  161,  160,  159,  158,  157,
-      156,  155,  154,  153,  152,  151,  150,  149,  148,  147,
-      146,  145,  144,  142,  141,  140,  139,  138,  137,  136,
-      134,  133,  132,  131,  130,  129,  128,  127,  126,  125,
-      124,  123,  122,  121,  120,  119,  118,  117,  115,  113,
-      112,  110,  108,  107,  106,  105,  104,  103,  102,  101,
-      100,   98,   97,   95,   92,   90,   89,   88,   87,   85,
-
-       82,   81,   79,   78,   76,   75,   74,   73,   72,   71,
-       70,   69,   68,   67,   66,   65,   64,   63,   62,   61,
-       60,   58,   55,   54,   52,   47,   40,   31,   30,   27,
-       26,   24,   18,   17,   13,    7,    3,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
-      500,  500,  500,  500,  500,  500,  500
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        4,    5,    6,    5,    6,  137,  825,    4,    9,    9,
+        9,    9,   10,   10,   10,   10,   11,   11,   11,   11,
+       12,   12,   12,   12,   13,   13,   13,   13,   14,   14,
+
+       14,   14,   15,   15,   15,   15,   16,   16,   16,   16,
+        5,    6,    7,    7,    7,    7,    7,   69,  137,  131,
+       69,    7,    7,    7,    7,    7,    7,    7,    7,    7,
+        7,   26,   29,   32,   31,  131,   29,   32,   67,   26,
+       29,   26,   31,   33,   37,   33,   67,   41,   37,   82,
+      184,   33,   29,   82,    7,    7,    7,    7,    7,    7,
+       41,    7,    7,    7,    7,    7,    7,    7,   51,  640,
+      184,    7,    7,    7,    7,    7,   24,   24,   24,   24,
+       24,   24,   24,   24,   40,   30,  640,   30,   40,   72,
+       24,   30,  826,   40,   24,   40,   24,   30,   72,   40,
+
+       46,   46,   54,   57,   72,   60,  160,   46,   60,   60,
+      160,   57,   57,   57,   24,   51,  512,   95,   24,   95,
+       24,   25,   25,   25,   25,   25,   25,   25,   25,   25,
+      186,  186,   25,   25,   25,   25,   25,   25,   25,   25,
+       25,   25,   25,   25,   70,   54,   25,   54,   70,   74,
+       75,   83,   54,   74,   54,  134,  827,   74,   70,   75,
+       75,   85,   83,   85,   76,   75,   85,   83,   76,   77,
+       60,   62,   76,   77,  512,  100,  112,   77,   76,   79,
+      116,   79,  116,   79,  150,  112,  120,   79,  100,  120,
+       62,  124,  149,   62,   62,   62,  135,  136,   62,  148,
+
+      124,  145,   62,   62,  151,   62,   62,   62,  145,  145,
+      134,  611,  611,   62,  115,  150,  148,   62,   62,   62,
+      115,  149,   62,  115,  152,  154,  163,  115,   62,   62,
+      115,  157,   62,  163,   62,   62,   62,  151,  148,  135,
+      136,  150,  153,  164,  164,  149,  164,  152,  154,  150,
+      155,  164,  196,  152,  135,  136,  156,  149,  196,  188,
+      157,  188,  153,  151,  148,  196,  252,  185,  201,  151,
+      155,  152,  154,  201,  153,  264,  156,  152,  185,  207,
+      405,  207,  217,  218,  157,  153,  217,  218,  405,  152,
+      154,  207,  267,  155,  281,  271,  157,  283,  281,  156,
+
+      153,  263,  286,  265,  614,  252,  386,  153,  264,  283,
+      828,  286,  266,  614,  271,  155,  262,  270,  268,  252,
+      267,  156,  158,  262,  262,  262,  262,  262,  262,  262,
+      262,  272,  265,  263,  264,  270,  263,  271,  266,  158,
+      264,  829,  158,  269,  267,  158,  268,  273,  387,  272,
+      272,  158,  830,  158,  158,  158,  265,  267,  270,  263,
+      271,  158,  266,  386,  263,  158,  263,  831,  265,  158,
+      268,  269,  272,  272,  273,  158,  275,  266,  276,  158,
+      158,  158,  270,  268,  274,  277,  278,  158,  279,  387,
+      398,  832,  409,  275,  833,  269,  272,  399,  273,  395,
+
+      620,  523,  277,  277,  274,  277,  276,  620,  269,  523,
+      404,  399,  273,  278,  278,  275,  279,  835,  511,  395,
+      398,  279,  409,  836,  277,  394,  277,  274,  277,  400,
+      276,  615,  394,  394,  394,  394,  394,  278,  278,  404,
+      279,  275,  395,  276,  401,  397,  398,  279,  409,  274,
+      277,  278,  400,  279,  280,  398,  424,  409,  402,  511,
+      424,  837,  406,  404,  395,  397,  403,  517,  698,  698,
+      406,  280,  280,  280,  280,  404,  400,  401,  615,  517,
+      280,  280,  280,  280,  699,  699,  280,  280,  397,  280,
+      402,  406,  838,  280,  400,  280,  280,  280,  403,  403,
+
+      407,  408,  410,  401,  280,  280,  280,  280,  411,  401,
+      397,  522,  280,  280,  662,  406,  402,  280,  841,  280,
+      407,  703,  410,  402,  403,  403,  408,  406,  413,  412,
+      842,  403,  662,  411,  520,  518,  616,  411,  411,  522,
+      507,  507,  507,  407,  507,  410,  567,  846,  413,  412,
+      408,  567,  518,  848,  849,  414,  520,  411,  415,  853,
+      413,  411,  412,  522,  411,  407,  408,  410,  703,  704,
+      525,  413,  412,  411,  518,  414,  522,  689,  415,  616,
+      520,  689,  839,  519,  706,  414,  413,  414,  412,  525,
+      415,  415,  706,  413,  412,  513,  855,  521,  414,  520,
+
+      518,  415,  513,  513,  513,  513,  513,  513,  513,  513,
+      840,  414,  525,  414,  529,  519,  415,  415,  764,  521,
+      414,  839,  764,  415,  416,  622,  856,  704,  530,  521,
+      857,  858,  416,  528,  859,  525,  860,  861,  416,  862,
+      865,  519,  531,  521,  416,  622,  529,  416,  519,  416,
+      530,  808,  528,  416,  416,  521,  416,  416,  621,  532,
+      866,  528,  521,  864,  531,  712,  867,  416,  622,  840,
+      868,  416,  529,  416,  530,  528,  871,  416,  863,  529,
+      416,  532,  416,  416,  624,  528,  621,  625,  531,  416,
+      622,  532,  808,  530,  628,  608,  608,  608,  528,  608,
+
+      712,  631,  872,  808,  624,  532,  625,  531,  873,  874,
+      621,  628,  875,  876,  864,  713,  714,  532,  631,  877,
+      631,  878,  879,  621,  532,  535,  880,  624,  712,  625,
+      712,  881,  882,  628,  884,  863,  886,  887,  888,  889,
+      631,  890,  535,  631,  535,  891,  892,  535,  894,  624,
+      713,  714,  625,  535,  893,  895,  636,  535,  896,  628,
+      898,  900,  901,  902,  535,  879,  631,  535,  904,  880,
+      905,  535,  906,  636,  910,  636,  636,  535,  713,  714,
+      713,  714,  911,  535,  636,  912,  913,  914,  915,  916,
+      535,  917,  918,  919,  920,  636,  921,  922,  636,  636,
+
+      923,  925,  928,  929,  894,  893,  930,  931,  636,  905,
+      932,  934,  936,  937,  938,  942,  943,  824,  823,  906,
+      822,  636,  821,  819,  817,  815,  814,  813,  807,  915,
+      806,  805,  804,  803,  802,  801,  800,  799,  797,  795,
+      794,  914,  941,  941,  944,  944,  945,  945,  946,  946,
+      947,  947,  948,  948,  949,  949,  950,  950,  791,  789,
+      788,  787,  786,  784,  782,  781,  780,  779,  778,  776,
+      775,  774,  773,  770,  766,  765,  763,  762,  759,  758,
+      757,  755,  754,  753,  752,  751,  749,  747,  745,  744,
+      743,  742,  741,  740,  738,  736,  735,  734,  733,  732,
+
+      730,  727,  726,  725,  724,  723,  721,  720,  718,  717,
+      716,  715,  710,  708,  707,  702,  701,  700,  697,  695,
+      693,  692,  691,  690,  688,  685,  683,  682,  681,  679,
+      678,  677,  675,  673,  672,  671,  670,  669,  668,  667,
+      666,  665,  664,  663,  658,  657,  656,  655,  654,  652,
+      648,  644,  643,  642,  641,  638,  637,  626,  623,  617,
+      613,  610,  606,  604,  603,  601,  600,  598,  597,  596,
+      595,  594,  593,  591,  590,  588,  587,  586,  585,  584,
+      583,  582,  581,  580,  579,  578,  577,  575,  574,  572,
+      571,  570,  569,  566,  565,  564,  563,  562,  561,  560,
+
+      559,  558,  557,  556,  555,  553,  552,  551,  550,  548,
+      547,  546,  545,  543,  542,  541,  540,  539,  538,  537,
+      536,  534,  533,  527,  526,  524,  516,  514,  510,  509,
+      508,  506,  505,  504,  503,  502,  501,  500,  499,  498,
+      497,  496,  495,  494,  493,  492,  490,  489,  488,  486,
+      484,  483,  482,  480,  479,  478,  477,  476,  473,  472,
+      471,  469,  468,  466,  465,  464,  462,  461,  460,  459,
+      458,  457,  456,  454,  453,  451,  450,  448,  447,  446,
+      445,  444,  443,  441,  439,  438,  436,  435,  434,  432,
+      431,  430,  429,  427,  426,  423,  422,  421,  420,  419,
+
+      418,  417,  396,  385,  384,  383,  381,  380,  378,  377,
+      375,  374,  373,  372,  371,  370,  369,  368,  367,  365,
+      363,  362,  361,  360,  359,  358,  357,  356,  355,  354,
+      353,  352,  351,  349,  348,  347,  346,  344,  342,  341,
+      340,  339,  338,  337,  336,  335,  334,  333,  332,  331,
+      330,  329,  328,  327,  325,  324,  322,  321,  320,  319,
+      318,  317,  316,  315,  314,  313,  312,  311,  310,  309,
+      308,  307,  306,  305,  304,  303,  302,  301,  300,  299,
+      298,  297,  295,  294,  293,  292,  291,  290,  289,  288,
+      287,  285,  258,  257,  256,  255,  254,  253,  251,  250,
+
+      249,  248,  247,  246,  245,  244,  243,  242,  241,  240,
+      239,  238,  237,  236,  235,  234,  233,  232,  231,  229,
+      228,  227,  226,  225,  224,  223,  222,  221,  220,  219,
+      216,  215,  214,  213,  212,  211,  210,  209,  208,  206,
+      205,  204,  203,  202,  200,  199,  198,  197,  195,  194,
+      193,  192,  191,  190,  189,  187,  183,  182,  181,  179,
+      178,  176,  175,  174,  173,  172,  171,  170,  169,  168,
+      167,  166,  165,  162,  161,  159,  146,  143,  142,  141,
+      140,  138,  132,  129,  126,  123,  122,  121,  119,  118,
+      117,  114,  113,  111,  110,  109,  108,  107,  105,  104,
+
+      103,  102,  101,   99,   98,   97,   96,   94,   93,   92,
+       91,   90,   89,   88,   87,   86,   84,   81,   80,   78,
+       73,   71,   68,   64,   43,   42,   39,   38,   36,   35,
+       34,   28,   27,   23,   17,    3,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+      940,  940,  940,  940,  940,  940,  940,  940,  940,  940,
+
+      940,  940,  940,  940,  940,  940,  940
     } ;
 
 /* Table of booleans, true if rule could match eol. */
-static yyconst flex_int32_t yy_rule_can_match_eol[104] =
+static yyconst flex_int32_t yy_rule_can_match_eol[172] =
     {   0,
-1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
-    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
+0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 
+    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
+    0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
-    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
-    0, 1, 0, 0,     };
+    0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0,     };
 
 static yy_state_type yy_last_accepting_state;
 static char *yy_last_accepting_cpos;
@@ -792,8 +1148,9 @@ char *sievetext;
 #line 2 "sieve/sieve-lex.l"
 /* sieve.l -- sieve lexer
  * Larry Greenfield
+ * Ken Murchison
  *
- * Copyright (c) 1994-2016 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -837,27 +1194,44 @@ char *sievetext;
 #include <config.h>
 #endif
 
-#include "xmalloc.h"
+#include "util.h"
 
 #include "sieve/tree.h"
 #include "sieve/sieve_interface.h"
 #include "sieve/sieve.h"
 
 #define YY_NO_INPUT
-#define YY_DECL int sievelex(YYSTYPE *yylval,sieve_script_t *parse_script)
+#define YY_DECL int sievelex(YYSTYPE *yylval,sieve_script_t *sscript)
 
-static int tonum(char *c);
-static char *chkstr(char *);
-static char *mlbuf;
-static int mlbufsz, mlcur;
+static struct buf buf;   /* buffer for multi-line text and quoted strings */
+extern int encoded_char; /* used to receive encoded-char feedback from parser */
+extern int getdatepart;  /* used to receive start state feedback from parser */
+
+static unsigned long long tonum(const char *str);
+static int decode_string(struct buf *buf);
 extern void sieveerror(sieve_script_t *, char *);
+extern void sieveerror_f(sieve_script_t *, char *fmt, ...);
+/* linebreak */
+/* non-linebreaking whitespace */
+/* UTC offset of timezone +/-hhmm */
+/* case-insensitive date-parts */
+
+
+
+
+
 
 
-#line 857 "sieve/sieve-lex.c"
+#line 1226 "sieve/sieve-lex.c"
 
 #define INITIAL 0
 #define MULTILINE 1
 #define QSTRING 2
+#define QCOLLATION 3
+#define QRELATION 4
+#define QIMPORTANCE 5
+#define QTIMEZONE 6
+#define QDATEPART 7
 
 #ifndef YY_NO_UNISTD_H
 /* Special case for "unistd.h", since it is non-ANSI. We include it way
@@ -1074,9 +1448,10 @@ YY_DECL
 		}
 
 	{
-#line 77 "sieve/sieve-lex.l"
+#line 106 "sieve/sieve-lex.l"
 
-#line 1080 "sieve/sieve-lex.c"
+    /* dot stuffing */
+#line 1455 "sieve/sieve-lex.c"
 
 	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
 		{
@@ -1104,13 +1479,13 @@ yy_match:
 			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 				{
 				yy_current_state = (int) yy_def[yy_current_state];
-				if ( yy_current_state >= 501 )
+				if ( yy_current_state >= 941 )
 					yy_c = yy_meta[(unsigned int) yy_c];
 				}
 			yy_current_state = yy_nxt[yy_base[yy_current_state] + (flex_int16_t) yy_c];
 			++yy_cp;
 			}
-		while ( yy_base[yy_current_state] != 538 );
+		while ( yy_base[yy_current_state] != 1437 );
 
 yy_find_action:
 		yy_act = yy_accept[yy_current_state];
@@ -1145,554 +1520,1008 @@ do_action:	/* This label is used only to
 			goto yy_find_action;
 
 case 1:
-/* rule 1 can match eol */
 YY_RULE_SETUP
-#line 78 "sieve/sieve-lex.l"
-{ BEGIN INITIAL;
-                          if (mlbuf) mlbuf[mlcur] = '\0';
-                          yylval->sval = chkstr(mlbuf); return STRING; }
+#line 108 "sieve/sieve-lex.l"
+buf_putc(&buf, sievetext[1]);
 	YY_BREAK
+/* end of multi-line text */
 case 2:
-YY_RULE_SETUP
-#line 81 "sieve/sieve-lex.l"
-{ /* dot stuffing! we want one . */ yyless(1); }
-	YY_BREAK
+/* rule 2 can match eol */
+#line 112 "sieve/sieve-lex.l"
+/* end of quoted string */
 case 3:
-/* rule 3 can match eol */
 YY_RULE_SETUP
-#line 82 "sieve/sieve-lex.l"
-{ if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = sievetext[0]; }
-	YY_BREAK
-case YY_STATE_EOF(MULTILINE):
-#line 85 "sieve/sieve-lex.l"
-{ BEGIN INITIAL;
-                     sieveerror(parse_script, "unexpected end of file in string");
-                     if (mlbuf) free(mlbuf);
-                     yyterminate(); }
+#line 114 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  if (encoded_char && !decode_string(&buf)) {
+                                      sieveerror_f(sscript,
+                                                   "invalid unicode encoding: %s",
+                                                   buf_cstring(&buf));
+                                  }
+                                  yylval->sval = buf_release(&buf);
+                                  return STRING;
+                              }
 	YY_BREAK
+/* escaped character */
 case 4:
 YY_RULE_SETUP
-#line 89 "sieve/sieve-lex.l"
-{ BEGIN INITIAL;
-                     if (mlbuf) mlbuf[mlcur] = '\0';
-                     yylval->sval = chkstr(mlbuf); return STRING; }
+#line 126 "sieve/sieve-lex.l"
+buf_putc(&buf, sievetext[1]);
 	YY_BREAK
+/* any character (including LF) */
 case 5:
+/* rule 5 can match eol */
 YY_RULE_SETUP
-#line 92 "sieve/sieve-lex.l"
-{ if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = sievetext[1]; }
+#line 129 "sieve/sieve-lex.l"
+buf_putc(&buf, sievetext[0]);
 	YY_BREAK
+/* premature EOF */
+case YY_STATE_EOF(QSTRING):
+case YY_STATE_EOF(MULTILINE):
+#line 132 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror(sscript,
+                                             "unexpected end of file in string");
+                                  buf_free(&buf);
+                                  yyterminate();
+                              }
+	YY_BREAK
+/* beginning of multi-line text */
 case 6:
 /* rule 6 can match eol */
 YY_RULE_SETUP
-#line 95 "sieve/sieve-lex.l"
-{ if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = sievetext[0]; }
-	YY_BREAK
-case YY_STATE_EOF(QSTRING):
-#line 98 "sieve/sieve-lex.l"
-{ sieveerror(parse_script, "unexpected end of file in string");
-                    if (mlbuf) free(mlbuf);
-                    BEGIN INITIAL;
-                    yyterminate(); }
+#line 141 "sieve/sieve-lex.l"
+{
+                                  BEGIN MULTILINE;
+                                  buf_reset(&buf);
+                              }
 	YY_BREAK
+/* beginning of quoted string */
 case 7:
-/* rule 7 can match eol */
 YY_RULE_SETUP
-#line 102 "sieve/sieve-lex.l"
-{ BEGIN MULTILINE;
-                          mlcur = 0; mlbufsz = 0; mlbuf = NULL; }
+#line 147 "sieve/sieve-lex.l"
+{
+                                  if (getdatepart) {
+                                      BEGIN QDATEPART;
+                                      getdatepart = 0;
+                                      yyless(0);
+                                  }
+                                  else {
+                                      BEGIN QSTRING;
+                                      buf_reset(&buf);
+                                  }
+                              }
 	YY_BREAK
+/* number with optional power of 2 suffix */
 case 8:
 YY_RULE_SETUP
-#line 104 "sieve/sieve-lex.l"
-{ BEGIN QSTRING;
-                    mlcur = 0; mlbufsz = 0; mlbuf = NULL; }
+#line 160 "sieve/sieve-lex.l"
+{
+                                  unsigned long long val = tonum(sievetext);
+                                  if (val > INT_MAX) {
+                                      sieveerror_f(sscript,
+                                                   "number too large %s",
+                                                   sievetext);
+                                  }
+                                  yylval->nval = val;
+                                  return NUMBER;
+                              }
 	YY_BREAK
+/* standard control commands - RFC 5228 */
 case 9:
 YY_RULE_SETUP
-#line 106 "sieve/sieve-lex.l"
-{ yylval->nval = tonum(sievetext); return NUMBER; }
+#line 172 "sieve/sieve-lex.l"
+return IF;
 	YY_BREAK
 case 10:
 YY_RULE_SETUP
-#line 107 "sieve/sieve-lex.l"
-return IF;
+#line 173 "sieve/sieve-lex.l"
+return ELSIF;
 	YY_BREAK
 case 11:
 YY_RULE_SETUP
-#line 108 "sieve/sieve-lex.l"
-return ELSIF;
+#line 174 "sieve/sieve-lex.l"
+return ELSE;
 	YY_BREAK
 case 12:
 YY_RULE_SETUP
-#line 109 "sieve/sieve-lex.l"
-return ELSE;
+#line 175 "sieve/sieve-lex.l"
+return REQUIRE;
 	YY_BREAK
 case 13:
 YY_RULE_SETUP
-#line 110 "sieve/sieve-lex.l"
-return ANYOF;
+#line 176 "sieve/sieve-lex.l"
+return STOP;
 	YY_BREAK
+/* standard tests - RFC 5228 */
 case 14:
 YY_RULE_SETUP
-#line 111 "sieve/sieve-lex.l"
-return ALLOF;
+#line 179 "sieve/sieve-lex.l"
+return ANYOF;
 	YY_BREAK
 case 15:
 YY_RULE_SETUP
-#line 112 "sieve/sieve-lex.l"
-return EXISTS;
+#line 180 "sieve/sieve-lex.l"
+return ALLOF;
 	YY_BREAK
 case 16:
 YY_RULE_SETUP
-#line 113 "sieve/sieve-lex.l"
-return SFALSE;
+#line 181 "sieve/sieve-lex.l"
+return EXISTS;
 	YY_BREAK
 case 17:
 YY_RULE_SETUP
-#line 114 "sieve/sieve-lex.l"
-return STRUE;
+#line 182 "sieve/sieve-lex.l"
+return SFALSE;
 	YY_BREAK
 case 18:
 YY_RULE_SETUP
-#line 115 "sieve/sieve-lex.l"
-return ADDRESS;
+#line 183 "sieve/sieve-lex.l"
+return STRUE;
 	YY_BREAK
 case 19:
 YY_RULE_SETUP
-#line 116 "sieve/sieve-lex.l"
-return ENVELOPE;
+#line 184 "sieve/sieve-lex.l"
+return NOT;
 	YY_BREAK
 case 20:
 YY_RULE_SETUP
-#line 117 "sieve/sieve-lex.l"
-return HEADER;
+#line 185 "sieve/sieve-lex.l"
+return HEADERT;
 	YY_BREAK
 case 21:
 YY_RULE_SETUP
-#line 118 "sieve/sieve-lex.l"
-return BODY;
+#line 186 "sieve/sieve-lex.l"
+return ADDRESS;
 	YY_BREAK
 case 22:
 YY_RULE_SETUP
-#line 119 "sieve/sieve-lex.l"
-return NOT;
+#line 187 "sieve/sieve-lex.l"
+return ENVELOPE;
 	YY_BREAK
 case 23:
 YY_RULE_SETUP
-#line 120 "sieve/sieve-lex.l"
+#line 188 "sieve/sieve-lex.l"
 return SIZE;
 	YY_BREAK
 case 24:
 YY_RULE_SETUP
-#line 121 "sieve/sieve-lex.l"
-return yylval->nval = HASFLAG;
+#line 189 "sieve/sieve-lex.l"
+return yylval->nval = OVER;
 	YY_BREAK
 case 25:
 YY_RULE_SETUP
-#line 122 "sieve/sieve-lex.l"
-return yylval->nval = STRINGT;
+#line 190 "sieve/sieve-lex.l"
+return yylval->nval = UNDER;
 	YY_BREAK
+/* standard action commands - RFC 5228 */
 case 26:
 YY_RULE_SETUP
-#line 123 "sieve/sieve-lex.l"
-return REJCT;
+#line 193 "sieve/sieve-lex.l"
+return DISCARD;
 	YY_BREAK
 case 27:
 YY_RULE_SETUP
-#line 124 "sieve/sieve-lex.l"
-return FILEINTO;
+#line 194 "sieve/sieve-lex.l"
+return KEEP;
 	YY_BREAK
 case 28:
 YY_RULE_SETUP
-#line 125 "sieve/sieve-lex.l"
-return REDIRECT;
+#line 195 "sieve/sieve-lex.l"
+return FILEINTO;
 	YY_BREAK
 case 29:
 YY_RULE_SETUP
-#line 126 "sieve/sieve-lex.l"
-return KEEP;
+#line 196 "sieve/sieve-lex.l"
+return REDIRECT;
 	YY_BREAK
+/* copy - RFC 3894 */
 case 30:
 YY_RULE_SETUP
-#line 127 "sieve/sieve-lex.l"
-return REQUIRE;
+#line 199 "sieve/sieve-lex.l"
+return COPY;
 	YY_BREAK
+/* comparator-types - RFC 5228 */
 case 31:
 YY_RULE_SETUP
-#line 128 "sieve/sieve-lex.l"
-return STOP;
+#line 202 "sieve/sieve-lex.l"
+{ BEGIN QCOLLATION; return COMPARATOR; }
 	YY_BREAK
 case 32:
+/* rule 32 can match eol */
 YY_RULE_SETUP
-#line 129 "sieve/sieve-lex.l"
-return DISCARD;
+#line 204 "sieve/sieve-lex.l"
+;       /* ignore whitespace */
 	YY_BREAK
 case 33:
 YY_RULE_SETUP
-#line 130 "sieve/sieve-lex.l"
-return yylval->nval = SETFLAG;
+#line 205 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  return yylval->nval = OCTET;
+                              }
 	YY_BREAK
 case 34:
 YY_RULE_SETUP
-#line 131 "sieve/sieve-lex.l"
-return yylval->nval = ADDFLAG;
+#line 209 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  return yylval->nval = ASCIICASEMAP;
+                              }
 	YY_BREAK
 case 35:
 YY_RULE_SETUP
-#line 132 "sieve/sieve-lex.l"
-return yylval->nval = REMOVEFLAG;
+#line 213 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  return yylval->nval = ASCIINUMERIC;
+                              }
 	YY_BREAK
 case 36:
+/* rule 36 can match eol */
 YY_RULE_SETUP
-#line 133 "sieve/sieve-lex.l"
-return MARK;
+#line 217 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "unknown comparator-name %s",
+                                               sievetext);
+                              }
 	YY_BREAK
+/* match-types - RFC 5228 */
 case 37:
 YY_RULE_SETUP
-#line 134 "sieve/sieve-lex.l"
-return UNMARK;
+#line 225 "sieve/sieve-lex.l"
+return yylval->nval = IS;
 	YY_BREAK
 case 38:
 YY_RULE_SETUP
-#line 135 "sieve/sieve-lex.l"
-return NOTIFY;
+#line 226 "sieve/sieve-lex.l"
+return yylval->nval = CONTAINS;
 	YY_BREAK
 case 39:
 YY_RULE_SETUP
-#line 136 "sieve/sieve-lex.l"
-return DENOTIFY;
+#line 227 "sieve/sieve-lex.l"
+return yylval->nval = MATCHES;
 	YY_BREAK
+/* regex - draft-ietf-sieve-regex */
 case 40:
 YY_RULE_SETUP
-#line 137 "sieve/sieve-lex.l"
-return ID;
+#line 230 "sieve/sieve-lex.l"
+return yylval->nval = REGEX;
 	YY_BREAK
 case 41:
 YY_RULE_SETUP
-#line 138 "sieve/sieve-lex.l"
-return METHOD;
+#line 231 "sieve/sieve-lex.l"
+return yylval->nval = QUOTEREGEX;
 	YY_BREAK
+/* extlists - RFC 6134 */
 case 42:
 YY_RULE_SETUP
-#line 139 "sieve/sieve-lex.l"
-return OPTIONS;
+#line 234 "sieve/sieve-lex.l"
+return yylval->nval = LIST;
 	YY_BREAK
 case 43:
 YY_RULE_SETUP
-#line 140 "sieve/sieve-lex.l"
-return LOW;
+#line 235 "sieve/sieve-lex.l"
+return VALIDEXTLIST;
 	YY_BREAK
+/* address-parts - RFC 5228 */
 case 44:
 YY_RULE_SETUP
-#line 141 "sieve/sieve-lex.l"
-return NORMAL;
+#line 238 "sieve/sieve-lex.l"
+return yylval->nval = ALL;
 	YY_BREAK
 case 45:
 YY_RULE_SETUP
-#line 142 "sieve/sieve-lex.l"
-return HIGH;
+#line 239 "sieve/sieve-lex.l"
+return yylval->nval = LOCALPART;
 	YY_BREAK
 case 46:
 YY_RULE_SETUP
-#line 143 "sieve/sieve-lex.l"
-return MESSAGE;
+#line 240 "sieve/sieve-lex.l"
+return yylval->nval = DOMAIN;
 	YY_BREAK
+/* subaddress - RFC 5233 */
 case 47:
 YY_RULE_SETUP
-#line 144 "sieve/sieve-lex.l"
-return VACATION;
+#line 243 "sieve/sieve-lex.l"
+return yylval->nval = USER;
 	YY_BREAK
 case 48:
 YY_RULE_SETUP
-#line 145 "sieve/sieve-lex.l"
-return DAYS;
+#line 244 "sieve/sieve-lex.l"
+return yylval->nval = DETAIL;
 	YY_BREAK
+/* body - RFC 5173 */
 case 49:
 YY_RULE_SETUP
-#line 146 "sieve/sieve-lex.l"
-return SECONDS;
+#line 247 "sieve/sieve-lex.l"
+return BODY;
 	YY_BREAK
 case 50:
 YY_RULE_SETUP
-#line 147 "sieve/sieve-lex.l"
-return ADDRESSES;
+#line 248 "sieve/sieve-lex.l"
+return yylval->nval = RAW;
 	YY_BREAK
 case 51:
 YY_RULE_SETUP
-#line 148 "sieve/sieve-lex.l"
-return SUBJECT;
+#line 249 "sieve/sieve-lex.l"
+return yylval->nval = TEXT;
 	YY_BREAK
 case 52:
 YY_RULE_SETUP
-#line 149 "sieve/sieve-lex.l"
-return FROM;
+#line 250 "sieve/sieve-lex.l"
+return yylval->nval = CONTENT;
 	YY_BREAK
+/* environment - RFC 5183 */
 case 53:
 YY_RULE_SETUP
-#line 150 "sieve/sieve-lex.l"
-return HANDLE;
+#line 253 "sieve/sieve-lex.l"
+return ENVIRONMENT;
 	YY_BREAK
+/* variables - RFC 5229 */
 case 54:
 YY_RULE_SETUP
-#line 151 "sieve/sieve-lex.l"
-return MIME;
+#line 256 "sieve/sieve-lex.l"
+return STRINGT;
 	YY_BREAK
 case 55:
 YY_RULE_SETUP
-#line 152 "sieve/sieve-lex.l"
-return COMPARATOR;
+#line 257 "sieve/sieve-lex.l"
+return SET;
 	YY_BREAK
 case 56:
 YY_RULE_SETUP
-#line 153 "sieve/sieve-lex.l"
-return IS;
+#line 258 "sieve/sieve-lex.l"
+return yylval->nval = LOWER;
 	YY_BREAK
 case 57:
 YY_RULE_SETUP
-#line 154 "sieve/sieve-lex.l"
-return CONTAINS;
+#line 259 "sieve/sieve-lex.l"
+return yylval->nval = UPPER;
 	YY_BREAK
 case 58:
 YY_RULE_SETUP
-#line 155 "sieve/sieve-lex.l"
-return MATCHES;
+#line 260 "sieve/sieve-lex.l"
+return yylval->nval = LOWERFIRST;
 	YY_BREAK
 case 59:
 YY_RULE_SETUP
-#line 156 "sieve/sieve-lex.l"
-return REGEX;
+#line 261 "sieve/sieve-lex.l"
+return yylval->nval = UPPERFIRST;
 	YY_BREAK
 case 60:
 YY_RULE_SETUP
-#line 157 "sieve/sieve-lex.l"
-return COUNT;
+#line 262 "sieve/sieve-lex.l"
+return yylval->nval = QUOTEWILDCARD;
 	YY_BREAK
 case 61:
 YY_RULE_SETUP
-#line 158 "sieve/sieve-lex.l"
-return VALUE;
+#line 263 "sieve/sieve-lex.l"
+return yylval->nval = LENGTH;
 	YY_BREAK
+/* vacation - RFC 5230 */
 case 62:
 YY_RULE_SETUP
-#line 159 "sieve/sieve-lex.l"
-return OVER;
+#line 266 "sieve/sieve-lex.l"
+return VACATION;
 	YY_BREAK
 case 63:
 YY_RULE_SETUP
-#line 160 "sieve/sieve-lex.l"
-return UNDER;
+#line 267 "sieve/sieve-lex.l"
+return DAYS;
 	YY_BREAK
 case 64:
 YY_RULE_SETUP
-#line 161 "sieve/sieve-lex.l"
-return ALL;
+#line 268 "sieve/sieve-lex.l"
+return ADDRESSES;
 	YY_BREAK
 case 65:
 YY_RULE_SETUP
-#line 162 "sieve/sieve-lex.l"
-return LOCALPART;
+#line 269 "sieve/sieve-lex.l"
+return SUBJECT;
 	YY_BREAK
 case 66:
 YY_RULE_SETUP
-#line 163 "sieve/sieve-lex.l"
-return DOMAIN;
+#line 270 "sieve/sieve-lex.l"
+return FROM;
 	YY_BREAK
 case 67:
 YY_RULE_SETUP
-#line 164 "sieve/sieve-lex.l"
-return USER;
+#line 271 "sieve/sieve-lex.l"
+return HANDLE;
 	YY_BREAK
 case 68:
 YY_RULE_SETUP
-#line 165 "sieve/sieve-lex.l"
-return DETAIL;
+#line 272 "sieve/sieve-lex.l"
+return MIME;
 	YY_BREAK
+/* vacation-seconds - RFC 6131 */
 case 69:
 YY_RULE_SETUP
-#line 166 "sieve/sieve-lex.l"
-return RAW;
+#line 275 "sieve/sieve-lex.l"
+return SECONDS;
 	YY_BREAK
+/* relational - RFC 5231 */
 case 70:
 YY_RULE_SETUP
-#line 167 "sieve/sieve-lex.l"
-return TEXT;
+#line 278 "sieve/sieve-lex.l"
+{ BEGIN QRELATION; return yylval->nval = COUNT; }
 	YY_BREAK
 case 71:
 YY_RULE_SETUP
-#line 168 "sieve/sieve-lex.l"
-return CONTENT;
+#line 279 "sieve/sieve-lex.l"
+{ BEGIN QRELATION; return yylval->nval = VALUE; }
 	YY_BREAK
 case 72:
+/* rule 72 can match eol */
 YY_RULE_SETUP
-#line 169 "sieve/sieve-lex.l"
-return INCLUDE;
+#line 281 "sieve/sieve-lex.l"
+;        /* ignore whitespace */
 	YY_BREAK
 case 73:
 YY_RULE_SETUP
-#line 170 "sieve/sieve-lex.l"
-return PERSONAL;
+#line 282 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = EQ; }
 	YY_BREAK
 case 74:
 YY_RULE_SETUP
-#line 171 "sieve/sieve-lex.l"
-return GLOBAL;
+#line 283 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = NE; }
 	YY_BREAK
 case 75:
 YY_RULE_SETUP
-#line 172 "sieve/sieve-lex.l"
-return OPTIONAL;
+#line 284 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = GT; }
 	YY_BREAK
 case 76:
 YY_RULE_SETUP
-#line 173 "sieve/sieve-lex.l"
-return ONCE;
+#line 285 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = GE; }
 	YY_BREAK
 case 77:
 YY_RULE_SETUP
-#line 174 "sieve/sieve-lex.l"
-return RETURN;
+#line 286 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = LT; }
 	YY_BREAK
 case 78:
 YY_RULE_SETUP
-#line 175 "sieve/sieve-lex.l"
-return COPY;
+#line 287 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = LE; }
 	YY_BREAK
 case 79:
+/* rule 79 can match eol */
 YY_RULE_SETUP
-#line 176 "sieve/sieve-lex.l"
-return DATE;
+#line 288 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid relational-match %s",
+                                               sievetext);
+                              }
 	YY_BREAK
+/* imap4flags - RFC 5232 */
 case 80:
 YY_RULE_SETUP
-#line 177 "sieve/sieve-lex.l"
-return CURRENTDATE;
+#line 296 "sieve/sieve-lex.l"
+return yylval->nval = SETFLAG;
 	YY_BREAK
 case 81:
 YY_RULE_SETUP
-#line 178 "sieve/sieve-lex.l"
-return INDEX;
+#line 297 "sieve/sieve-lex.l"
+return yylval->nval = ADDFLAG;
 	YY_BREAK
 case 82:
 YY_RULE_SETUP
-#line 179 "sieve/sieve-lex.l"
-return LAST;
+#line 298 "sieve/sieve-lex.l"
+return yylval->nval = REMOVEFLAG;
 	YY_BREAK
 case 83:
 YY_RULE_SETUP
-#line 180 "sieve/sieve-lex.l"
-return ZONE;
+#line 299 "sieve/sieve-lex.l"
+return yylval->nval = HASFLAG;
 	YY_BREAK
 case 84:
 YY_RULE_SETUP
-#line 181 "sieve/sieve-lex.l"
-return ORIGINALZONE;
+#line 300 "sieve/sieve-lex.l"
+return FLAGS;
 	YY_BREAK
+/* imapflags - draft-melnikov-sieve-imapflags-04 */
 case 85:
 YY_RULE_SETUP
-#line 182 "sieve/sieve-lex.l"
-return FLAGS;
+#line 303 "sieve/sieve-lex.l"
+return yylval->nval = MARK;
 	YY_BREAK
 case 86:
 YY_RULE_SETUP
-#line 183 "sieve/sieve-lex.l"
-return MAILBOXEXISTS; /* RFC 5490 */
+#line 304 "sieve/sieve-lex.l"
+return yylval->nval = UNMARK;
 	YY_BREAK
+/* date - RFC 5260 */
 case 87:
 YY_RULE_SETUP
-#line 184 "sieve/sieve-lex.l"
-return CREATE;
+#line 307 "sieve/sieve-lex.l"
+return DATE;
 	YY_BREAK
 case 88:
 YY_RULE_SETUP
-#line 185 "sieve/sieve-lex.l"
-return METADATA;
+#line 308 "sieve/sieve-lex.l"
+return ORIGINALZONE;
 	YY_BREAK
 case 89:
 YY_RULE_SETUP
-#line 186 "sieve/sieve-lex.l"
-return METADATAEXISTS;
+#line 309 "sieve/sieve-lex.l"
+{ BEGIN QTIMEZONE; return ZONE; }
 	YY_BREAK
 case 90:
 YY_RULE_SETUP
-#line 187 "sieve/sieve-lex.l"
-return SERVERMETADATA;
+#line 310 "sieve/sieve-lex.l"
+{ getdatepart = 1; return CURRENTDATE; }
 	YY_BREAK
 case 91:
+/* rule 91 can match eol */
 YY_RULE_SETUP
-#line 188 "sieve/sieve-lex.l"
-return SERVERMETADATAEXISTS;
+#line 312 "sieve/sieve-lex.l"
+;        /* ignore whitespace */
 	YY_BREAK
 case 92:
 YY_RULE_SETUP
-#line 189 "sieve/sieve-lex.l"
-return yylval->nval = SET;
+#line 313 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  int tz = atoi(sievetext+1); /* skip leading " */
+                                  yylval->nval = 60 * (tz / 100) + (tz % 100);
+                                  return TIMEZONE;
+                              }
 	YY_BREAK
 case 93:
+/* rule 93 can match eol */
 YY_RULE_SETUP
-#line 190 "sieve/sieve-lex.l"
-return yylval->nval = LOWER;
+#line 319 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid time-zone %s", sievetext);
+                              }
 	YY_BREAK
 case 94:
 YY_RULE_SETUP
-#line 191 "sieve/sieve-lex.l"
-return yylval->nval = UPPER;
+#line 325 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = YEARP;    }
 	YY_BREAK
 case 95:
 YY_RULE_SETUP
-#line 192 "sieve/sieve-lex.l"
-return yylval->nval = LOWERFIRST;
+#line 326 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = MONTHP;   }
 	YY_BREAK
 case 96:
 YY_RULE_SETUP
-#line 193 "sieve/sieve-lex.l"
-return yylval->nval = UPPERFIRST;
+#line 327 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = DAYP;     }
 	YY_BREAK
 case 97:
 YY_RULE_SETUP
-#line 194 "sieve/sieve-lex.l"
-return yylval->nval = QUOTEWILDCARD;
+#line 328 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = DATEP;    }
 	YY_BREAK
 case 98:
 YY_RULE_SETUP
-#line 195 "sieve/sieve-lex.l"
-return yylval->nval = LENGTH;
+#line 329 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = JULIAN;   }
 	YY_BREAK
 case 99:
-/* rule 99 can match eol */
 YY_RULE_SETUP
-#line 196 "sieve/sieve-lex.l"
-;    /* ignore whitespace */
+#line 330 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = HOURP;    }
 	YY_BREAK
 case 100:
 YY_RULE_SETUP
-#line 197 "sieve/sieve-lex.l"
-;          /* ignore hash comments */
+#line 331 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = MINUTEP;  }
 	YY_BREAK
 case 101:
-/* rule 101 can match eol */
 YY_RULE_SETUP
-#line 198 "sieve/sieve-lex.l"
-;  /* ignore bracket comments */
+#line 332 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = SECONDP;  }
 	YY_BREAK
 case 102:
 YY_RULE_SETUP
-#line 199 "sieve/sieve-lex.l"
-return sievetext[0];
+#line 333 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = TIMEP;    }
 	YY_BREAK
 case 103:
 YY_RULE_SETUP
-#line 201 "sieve/sieve-lex.l"
+#line 334 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = ISO8601;  }
+	YY_BREAK
+case 104:
+YY_RULE_SETUP
+#line 335 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = STD11;    }
+	YY_BREAK
+case 105:
+YY_RULE_SETUP
+#line 336 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = ZONEP;    }
+	YY_BREAK
+case 106:
+YY_RULE_SETUP
+#line 337 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = WEEKDAYP; }
+	YY_BREAK
+case 107:
+/* rule 107 can match eol */
+YY_RULE_SETUP
+#line 338 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid date-part %s", sievetext);
+                              }
+	YY_BREAK
+/* index - RFC 5260 */
+case 108:
+YY_RULE_SETUP
+#line 346 "sieve/sieve-lex.l"
+return INDEX;
+	YY_BREAK
+case 109:
+YY_RULE_SETUP
+#line 347 "sieve/sieve-lex.l"
+return LAST;
+	YY_BREAK
+/* editheader - RFC 5293 */
+case 110:
+YY_RULE_SETUP
+#line 350 "sieve/sieve-lex.l"
+return ADDHEADER;
+	YY_BREAK
+case 111:
+YY_RULE_SETUP
+#line 351 "sieve/sieve-lex.l"
+return DELETEHEADER;
+	YY_BREAK
+/*   :index               defined in 'index' */
+/*   :last                defined in 'index' */
+/* [e]reject - RFC 5429 */
+case 112:
+YY_RULE_SETUP
+#line 356 "sieve/sieve-lex.l"
+return yylval->nval = REJCT;
+	YY_BREAK
+case 113:
+YY_RULE_SETUP
+#line 357 "sieve/sieve-lex.l"
+return yylval->nval = EREJECT;
+	YY_BREAK
+/* enotify - RFC 5435 */
+case 114:
+YY_RULE_SETUP
+#line 360 "sieve/sieve-lex.l"
+return NOTIFYMETHODCAPABILITY;
+	YY_BREAK
+case 115:
+YY_RULE_SETUP
+#line 361 "sieve/sieve-lex.l"
+return VALIDNOTIFYMETHOD;
+	YY_BREAK
+case 116:
+YY_RULE_SETUP
+#line 362 "sieve/sieve-lex.l"
+return NOTIFY;
+	YY_BREAK
+case 117:
+YY_RULE_SETUP
+#line 363 "sieve/sieve-lex.l"
+return OPTIONS;
+	YY_BREAK
+case 118:
+YY_RULE_SETUP
+#line 364 "sieve/sieve-lex.l"
+return MESSAGE;
+	YY_BREAK
+case 119:
+YY_RULE_SETUP
+#line 365 "sieve/sieve-lex.l"
+return yylval->nval = ENCODEURL;
+	YY_BREAK
+case 120:
+YY_RULE_SETUP
+#line 366 "sieve/sieve-lex.l"
+{ BEGIN QIMPORTANCE; return IMPORTANCE; }
+	YY_BREAK
+case 121:
+/* rule 121 can match eol */
+YY_RULE_SETUP
+#line 368 "sieve/sieve-lex.l"
+;      /* ignore whitespace */
+	YY_BREAK
+case 122:
+YY_RULE_SETUP
+#line 369 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = HIGH;   }
+	YY_BREAK
+case 123:
+YY_RULE_SETUP
+#line 370 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = NORMAL; }
+	YY_BREAK
+case 124:
+YY_RULE_SETUP
+#line 371 "sieve/sieve-lex.l"
+{ BEGIN INITIAL; return yylval->nval = LOW;    }
+	YY_BREAK
+case 125:
+/* rule 125 can match eol */
+YY_RULE_SETUP
+#line 372 "sieve/sieve-lex.l"
+{
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid importance %s", sievetext);
+                              }
+	YY_BREAK
+/* notify - draft-martin-sieve-notify-01 */
+case 126:
+YY_RULE_SETUP
+#line 379 "sieve/sieve-lex.l"
+return DENOTIFY;
+	YY_BREAK
+case 127:
+YY_RULE_SETUP
+#line 380 "sieve/sieve-lex.l"
+return METHOD;
+	YY_BREAK
+case 128:
+YY_RULE_SETUP
+#line 381 "sieve/sieve-lex.l"
+return ID;
+	YY_BREAK
+case 129:
+YY_RULE_SETUP
+#line 382 "sieve/sieve-lex.l"
+return yylval->nval = LOW;
+	YY_BREAK
+case 130:
+YY_RULE_SETUP
+#line 383 "sieve/sieve-lex.l"
+return yylval->nval = NORMAL;
+	YY_BREAK
+case 131:
+YY_RULE_SETUP
+#line 384 "sieve/sieve-lex.l"
+return yylval->nval = HIGH;
+	YY_BREAK
+/* ihave - RFC 5463 */
+case 132:
+YY_RULE_SETUP
+#line 387 "sieve/sieve-lex.l"
+return IHAVE;
+	YY_BREAK
+case 133:
+YY_RULE_SETUP
+#line 388 "sieve/sieve-lex.l"
+return ERROR;
+	YY_BREAK
+/* mailbox - RFC 5490 */
+case 134:
+YY_RULE_SETUP
+#line 391 "sieve/sieve-lex.l"
+return MAILBOXEXISTS;
+	YY_BREAK
+case 135:
+YY_RULE_SETUP
+#line 392 "sieve/sieve-lex.l"
+return CREATE;
+	YY_BREAK
+/* mboxmetadata - RFC 5490 */
+case 136:
+YY_RULE_SETUP
+#line 395 "sieve/sieve-lex.l"
+return yylval->nval = METADATA;
+	YY_BREAK
+case 137:
+YY_RULE_SETUP
+#line 396 "sieve/sieve-lex.l"
+return METADATAEXISTS;
+	YY_BREAK
+/* servermetadata - RFC 5490 */
+case 138:
+YY_RULE_SETUP
+#line 399 "sieve/sieve-lex.l"
+return yylval->nval = SERVERMETADATA;
+	YY_BREAK
+case 139:
+YY_RULE_SETUP
+#line 400 "sieve/sieve-lex.l"
+return SERVERMETADATAEXISTS;
+	YY_BREAK
+/* redirect-deliverby - RFC 6009 */
+case 140:
+YY_RULE_SETUP
+#line 403 "sieve/sieve-lex.l"
+return BYTIMEREL;
+	YY_BREAK
+case 141:
+YY_RULE_SETUP
+#line 404 "sieve/sieve-lex.l"
+return BYTIMEABS;
+	YY_BREAK
+case 142:
+YY_RULE_SETUP
+#line 405 "sieve/sieve-lex.l"
+return BYMODE;
+	YY_BREAK
+case 143:
+YY_RULE_SETUP
+#line 406 "sieve/sieve-lex.l"
+return BYTRACE;
+	YY_BREAK
+/* redirect-dsn - RFC 6009 */
+case 144:
+YY_RULE_SETUP
+#line 409 "sieve/sieve-lex.l"
+return DSNNOTIFY;
+	YY_BREAK
+case 145:
+YY_RULE_SETUP
+#line 410 "sieve/sieve-lex.l"
+return DSNRET;
+	YY_BREAK
+/* include - RFC 6609 */
+case 146:
+YY_RULE_SETUP
+#line 413 "sieve/sieve-lex.l"
+return INCLUDE;
+	YY_BREAK
+case 147:
+YY_RULE_SETUP
+#line 414 "sieve/sieve-lex.l"
+return yylval->nval = PERSONAL;
+	YY_BREAK
+case 148:
+YY_RULE_SETUP
+#line 415 "sieve/sieve-lex.l"
+return yylval->nval = GLOBAL;
+	YY_BREAK
+case 149:
+YY_RULE_SETUP
+#line 416 "sieve/sieve-lex.l"
+return OPTIONAL;
+	YY_BREAK
+case 150:
+YY_RULE_SETUP
+#line 417 "sieve/sieve-lex.l"
+return ONCE;
+	YY_BREAK
+case 151:
+YY_RULE_SETUP
+#line 418 "sieve/sieve-lex.l"
+return RETURN;
+	YY_BREAK
+/* duplicate - RFC 7352 */
+case 152:
+YY_RULE_SETUP
+#line 421 "sieve/sieve-lex.l"
+return DUPLICATE;
+	YY_BREAK
+case 153:
+YY_RULE_SETUP
+#line 422 "sieve/sieve-lex.l"
+return yylval->nval = HEADER;
+	YY_BREAK
+case 154:
+YY_RULE_SETUP
+#line 423 "sieve/sieve-lex.l"
+return yylval->nval = UNIQUEID;
+	YY_BREAK
+/*   :handle              defined in 'vacation' */
+/*   :seconds             defined in 'vacation-seconds' */
+/*   :last                defined in 'index' */
+/* special-use - RFC 8579 */
+case 155:
+YY_RULE_SETUP
+#line 429 "sieve/sieve-lex.l"
+return SPECIALUSEEXISTS;
+	YY_BREAK
+case 156:
+YY_RULE_SETUP
+#line 430 "sieve/sieve-lex.l"
+return SPECIALUSE;
+	YY_BREAK
+/* fcc - RFC 8580 */
+case 157:
+YY_RULE_SETUP
+#line 433 "sieve/sieve-lex.l"
+return FCC;
+	YY_BREAK
+/* draft-gondwana-sieve-mailboxid */
+case 158:
+YY_RULE_SETUP
+#line 436 "sieve/sieve-lex.l"
+return MAILBOXIDEXISTS;
+	YY_BREAK
+case 159:
+YY_RULE_SETUP
+#line 437 "sieve/sieve-lex.l"
+return MAILBOXID;
+	YY_BREAK
+/* x-cyrus-log */
+case 160:
+YY_RULE_SETUP
+#line 440 "sieve/sieve-lex.l"
+return LOG;
+	YY_BREAK
+/* x-cyrus-jmapquery */
+case 161:
+YY_RULE_SETUP
+#line 443 "sieve/sieve-lex.l"
+return JMAPQUERY;
+	YY_BREAK
+/* x-cyrus-snooze */
+case 162:
+YY_RULE_SETUP
+#line 446 "sieve/sieve-lex.l"
+return SNOOZE;
+	YY_BREAK
+case 163:
+YY_RULE_SETUP
+#line 447 "sieve/sieve-lex.l"
+return MAILBOX;
+	YY_BREAK
+case 164:
+YY_RULE_SETUP
+#line 448 "sieve/sieve-lex.l"
+return ADDFLAGS;
+	YY_BREAK
+case 165:
+YY_RULE_SETUP
+#line 449 "sieve/sieve-lex.l"
+return REMOVEFLAGS;
+	YY_BREAK
+case 166:
+YY_RULE_SETUP
+#line 450 "sieve/sieve-lex.l"
+return WEEKDAYS;
+	YY_BREAK
+/*   :mailboxid            defined in draft-gondwana-sieve-mailboxid */
+case 167:
+/* rule 167 can match eol */
+YY_RULE_SETUP
+#line 453 "sieve/sieve-lex.l"
+;  /* ignore bracketed comments */
+	YY_BREAK
+case 168:
+YY_RULE_SETUP
+#line 454 "sieve/sieve-lex.l"
+;                /* ignore hash comments */
+	YY_BREAK
+case 169:
+/* rule 169 can match eol */
+YY_RULE_SETUP
+#line 455 "sieve/sieve-lex.l"
+;          /* ignore whitespace */
+	YY_BREAK
+case 170:
+YY_RULE_SETUP
+#line 456 "sieve/sieve-lex.l"
+return sievetext[0];
+	YY_BREAK
+case 171:
+YY_RULE_SETUP
+#line 458 "sieve/sieve-lex.l"
 ECHO;
 	YY_BREAK
-#line 1695 "sieve/sieve-lex.c"
+#line 2519 "sieve/sieve-lex.c"
 case YY_STATE_EOF(INITIAL):
+case YY_STATE_EOF(QCOLLATION):
+case YY_STATE_EOF(QRELATION):
+case YY_STATE_EOF(QIMPORTANCE):
+case YY_STATE_EOF(QTIMEZONE):
+case YY_STATE_EOF(QDATEPART):
 	yyterminate();
 
 	case YY_END_OF_BUFFER:
@@ -1985,7 +2814,7 @@ static int yy_get_next_buffer (void)
 		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 			{
 			yy_current_state = (int) yy_def[yy_current_state];
-			if ( yy_current_state >= 501 )
+			if ( yy_current_state >= 941 )
 				yy_c = yy_meta[(unsigned int) yy_c];
 			}
 		yy_current_state = yy_nxt[yy_base[yy_current_state] + (flex_int16_t) yy_c];
@@ -2013,11 +2842,11 @@ static int yy_get_next_buffer (void)
 	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 		{
 		yy_current_state = (int) yy_def[yy_current_state];
-		if ( yy_current_state >= 501 )
+		if ( yy_current_state >= 941 )
 			yy_c = yy_meta[(unsigned int) yy_c];
 		}
 	yy_current_state = yy_nxt[yy_base[yy_current_state] + (flex_int16_t) yy_c];
-	yy_is_jam = (yy_current_state == 500);
+	yy_is_jam = (yy_current_state == 940);
 
 		return yy_is_jam ? 0 : yy_current_state;
 }
@@ -2665,26 +3494,158 @@ void sievefree (void * ptr )
 
 #define YYTABLES_NAME "yytables"
 
-#line 201 "sieve/sieve-lex.l"
+#line 458 "sieve/sieve-lex.l"
+
 
 
-/*  */
-static int tonum(char *c)
+/* convert numerical string w/units to unsigned long */
+static unsigned long long tonum(const char *str)
 {
-  int val = atoi(c);
-  switch (c[strlen(c)-1]) {
-  case 'K': case 'k': val *= (1 << 10); break;
-  case 'M': case 'm': val *= (1 << 20); break;
-  case 'G': case 'g': val *= (1 << 30); break;
-  default: break;
-  }
-  return val;
+    char *units;
+    unsigned long long val = strtoull(str, &units, 10);
+
+    if (*units && errno != ERANGE) {
+        switch (toupper(*units)) {
+        case 'K': val *= (1ULL << 10); break;
+        case 'M': val *= (1ULL << 20); break;
+        case 'G': val *= (1ULL << 30); break;
+            /* for future use */
+        case 'T': val *= (1ULL << 40); break;
+        case 'P': val *= (1ULL << 50); break;
+        case 'E': val *= (1ULL << 60); break;
+        default: break;
+        }
+    }
+
+    return val;
 }
 
-/* convert NULL strings to "" */
-static char *chkstr(char *str)
+/* convert unicode to sequence of UTF-8 characters */
+static size_t unicode_to_utf8(unsigned char buf[], unsigned int code)
 {
-    if (!str) return xstrdup("");
-    else return str;
+    if (code <= 0x7F) {
+        buf[0] = code;
+        return 1;
+    }
+    if (code <= 0x7FF) {
+        buf[0] = 0xC0 | (code >> 6);            /* 110xxxxx */
+        buf[1] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 2;
+    }
+    if (code < 0xE000 && code > 0xD7FF) return 0;
+    if (code <= 0xFFFF) {
+        buf[0] = 0xE0 | (code >> 12);           /* 1110xxxx */
+        buf[1] = 0x80 | ((code >> 6) & 0x3F);   /* 10xxxxxx */
+        buf[2] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 3;
+    }
+    if (code <= 0x10FFFF) {
+        buf[0] = 0xF0 | (code >> 18);           /* 11110xxx */
+        buf[1] = 0x80 | ((code >> 12) & 0x3F);  /* 10xxxxxx */
+        buf[2] = 0x80 | ((code >> 6) & 0x3F);   /* 10xxxxxx */
+        buf[3] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 4;
+    }
+    return 0;
+}
+
+/*
+  Decode "encoded-character" strings having one of the following two forms:
+
+  encoded-arb-octets   =  "${hex:" hex-pair-seq "}"
+  hex-pair-seq         =  *blank hex-pair *(1*blank hex-pair) *blank
+  hex-pair             =  1*2HEXDIG
+
+  encoded-unicode-char =  "${unicode:" unicode-hex-seq "}"
+  unicode-hex-seq      =  *blank unicode-hex *(1*blank unicode-hex) *blank
+  unicode-hex          =  1*HEXDIG
+   
+  blank                =  WSP / CRLF
+  WSP                  =  SP / HTAB 
+  HEXDIG               =  DIGIT / "A" / "B" / "C" / "D" / "E" / "F"
+*/
+static int decode_string(struct buf *buf)
+{
+    static struct buf decode_buf = BUF_INITIALIZER;
+    const char *cp, *enc_start;
+
+    for (cp = buf_cstring(buf); (enc_start = strstr(cp, "${")); ) {
+        unsigned is_unicode = 0;
+        size_t len;
+
+        cp = enc_start + 2;
+
+        if (!strncasecmp(cp, "hex:", 4)) {
+            cp += 4;
+        }
+        else if (!strncasecmp(cp, "unicode:", 8)) {
+            is_unicode = 1;
+            cp += 8;
+        }
+        else {
+            /* not coded */
+            continue;
+        }
+
+        /* eat leading whitespace */
+        while (isspace(*cp)) cp++;
+
+        /* sanity check "encoded" data (being liberal in accepting 'a' - 'f') */
+        len = strspn(cp, "0123456789ABCDEFabcdef \t\r\n");
+        if (!isxdigit(*cp) || cp[len] != '}') continue;
+
+        /* decode characters */
+        buf_reset(&decode_buf);
+        do {
+            unsigned int ndigits, code;
+
+            for (ndigits = 0, code = 0; isxdigit(*cp); ndigits++, cp++) {
+                unsigned int digit = 
+                    (*cp > '9') ? 10 + toupper(*cp) - 'A' : *cp - '0';
+
+                code = (code << 4) + digit;
+            }
+
+            if (is_unicode) {
+                unsigned char utf8[4];
+
+                len = unicode_to_utf8(utf8, code);
+                if (!len) {
+                    /* invalid UTF-8 encoding - error */
+                    return 0;
+                }
+
+                /* append decoded unicode char(s) to buffer */
+                buf_appendmap(&decode_buf, (char *) utf8, len);
+            }
+            else if (ndigits > 2) {
+                /* too many hex digits - treat as not coded */
+                buf_reset(&decode_buf);
+                cp += len + 1;
+                break;
+            }
+            else {
+                /* append decoded hex char to buffer */
+                buf_putc(&decode_buf, code);
+            }
+
+            /* eat trailing whitespace */
+            while (isspace(*cp)) cp++;
+
+        } while (*cp != '}');
+
+        if ((len = buf_len(&decode_buf))) {
+            /* replace the encoded string with its decoded value */
+            size_t offset = enc_start - buf_base(buf);
+
+            buf_remove(buf, offset, cp - enc_start + 1);
+            buf_insert(buf, offset, &decode_buf);
+
+            /* buffer may have been reallocated - reposition our pointer */
+            cp = buf_cstring(buf) + offset + len;
+        }
+    }
+
+    return 1;
 }
 
diff -pruN 3.0.13-5/sieve/sieve-lex.l 3.2.0-3/sieve/sieve-lex.l
--- 3.0.13-5/sieve/sieve-lex.l	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sieve-lex.l	2020-05-04 03:28:02.000000000 +0000
@@ -1,8 +1,9 @@
 %{
 /* sieve.l -- sieve lexer
  * Larry Greenfield
+ * Ken Murchison
  *
- * Copyright (c) 1994-2016 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -46,20 +47,23 @@
 #include <config.h>
 #endif
 
-#include "xmalloc.h"
+#include "util.h"
 
 #include "sieve/tree.h"
 #include "sieve/sieve_interface.h"
 #include "sieve/sieve.h"
 
 #define YY_NO_INPUT
-#define YY_DECL int yylex(YYSTYPE *yylval, sieve_script_t *parse_script)
+#define YY_DECL int yylex(YYSTYPE *yylval, sieve_script_t *sscript)
 
-static int tonum(char *c);
-static char *chkstr(char *);
-static char *mlbuf;
-static int mlbufsz, mlcur;
+static struct buf buf;   /* buffer for multi-line text and quoted strings */
+extern int encoded_char; /* used to receive encoded-char feedback from parser */
+extern int getdatepart;  /* used to receive start state feedback from parser */
+
+static unsigned long long tonum(const char *str);
+static int decode_string(struct buf *buf);
 extern void sieveerror(sieve_script_t *, char *);
+extern void sieveerror_f(sieve_script_t *, char *fmt, ...);
 %}
 
 %option yylineno
@@ -67,154 +71,539 @@ extern void sieveerror(sieve_script_t *,
 %option nounput
 %option prefix="sieve" outfile="lex.yy.c"
 
-ws              [ \t]+
-ident           [a-zA-Z_][a-zA-Z_0-9]*
+    /* linebreak */
 CRLF            (\r\n|\r|\n)
+    
+    /* non-linebreaking whitespace */
+ws              [ \t]+
+
+    /* UTC offset of timezone +/-hhmm */
+timezone        [-|+][0-1][0-9][0-5][0-9]
+
+    /* case-insensitive date-parts */
+year            [Y|y][E|e][A|a][R|r]
+month           [M|m][O|o][N|n][T|t][H|h]
+day             [D|d][A|a][Y|y]
+date            [D|d][A|a][T|t][E|e]
+julian          [J|j][U|u][L|l][I|i][A|a][N|n]
+hour            [H|h][O|o][U|u][R|r]
+minute          [M|m][I|i][N|n][U|u][T|t][E|e]
+second          [S|s][E|e][C|c][O|o][N|n][D|d]
+time            [T|t][I|i][M|m][E|e]
+iso8601         [I|i][S|s][O|o]8601
+std11           [S|s][T|t][D|d]11
+zone            [Z|z][O|o][N|n][E|e]
+weekday         [W|w][E|e][E|e][K|k][D|d][A|a][Y|y]
 
 %state MULTILINE
 %state QSTRING
+%state QCOLLATION
+%state QRELATION
+%state QIMPORTANCE
+%state QTIMEZONE
+%state QDATEPART
 
 %%
-<MULTILINE>^\.{CRLF}    { BEGIN INITIAL;
-                          if (mlbuf) mlbuf[mlcur] = '\0';
-                          yylval->sval = chkstr(mlbuf); return STRING; }
-<MULTILINE>^\.\.  { /* dot stuffing! we want one . */ yyless(1); }
-<MULTILINE>(.|\n) { if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = yytext[0]; }
-<MULTILINE><<EOF>> { BEGIN INITIAL;
-                     sieveerror(parse_script, "unexpected end of file in string");
-                     if (mlbuf) free(mlbuf);
-                     yyterminate(); }
-<QSTRING>\"        { BEGIN INITIAL;
-                     if (mlbuf) mlbuf[mlcur] = '\0';
-                     yylval->sval = chkstr(mlbuf); return STRING; }
-<QSTRING>\\.      { if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = yytext[1]; }
-<QSTRING>(.|\n)   { if (mlcur == mlbufsz)
-                        mlbuf = xrealloc(mlbuf, 1 + (mlbufsz+=1024));
-                    mlbuf[mlcur++] = yytext[0]; }
-<QSTRING><<EOF>>  { sieveerror(parse_script, "unexpected end of file in string");
-                    if (mlbuf) free(mlbuf);
-                    BEGIN INITIAL;
-                    yyterminate(); }
-<INITIAL>text:{ws}?(#.*)?{CRLF} { BEGIN MULTILINE;
-                          mlcur = 0; mlbufsz = 0; mlbuf = NULL; }
-<INITIAL>\"        { BEGIN QSTRING;
-                    mlcur = 0; mlbufsz = 0; mlbuf = NULL; }
-<INITIAL>[0-9]+[KMGkmg]?        { yylval->nval = tonum(yytext); return NUMBER; }
-<INITIAL>if             return IF;
-<INITIAL>elsif          return ELSIF;
-<INITIAL>else           return ELSE;
-<INITIAL>anyof          return ANYOF;
-<INITIAL>allof          return ALLOF;
-<INITIAL>exists         return EXISTS;
-<INITIAL>false          return SFALSE;
-<INITIAL>true           return STRUE;
-<INITIAL>address        return ADDRESS;
-<INITIAL>envelope       return ENVELOPE;
-<INITIAL>header         return HEADER;
-<INITIAL>body           return BODY;
-<INITIAL>not            return NOT;
-<INITIAL>size           return SIZE;
-<INITIAL>hasflag        return yylval->nval = HASFLAG;
-<INITIAL>string         return yylval->nval = STRINGT;
-<INITIAL>reject         return REJCT;
-<INITIAL>fileinto       return FILEINTO;
-<INITIAL>redirect       return REDIRECT;
-<INITIAL>keep           return KEEP;
-<INITIAL>require        return REQUIRE;
-<INITIAL>stop           return STOP;
-<INITIAL>discard        return DISCARD;
-<INITIAL>setflag        return yylval->nval = SETFLAG;
-<INITIAL>addflag        return yylval->nval = ADDFLAG;
-<INITIAL>removeflag     return yylval->nval = REMOVEFLAG;
-<INITIAL>mark           return MARK;
-<INITIAL>unmark         return UNMARK;
-<INITIAL>notify         return NOTIFY;
-<INITIAL>denotify       return DENOTIFY;
-<INITIAL>:id            return ID;
-<INITIAL>:method        return METHOD;
-<INITIAL>:options       return OPTIONS;
-<INITIAL>:low           return LOW;
-<INITIAL>:normal        return NORMAL;
-<INITIAL>:high          return HIGH;
-<INITIAL>:message       return MESSAGE;
-<INITIAL>vacation       return VACATION;
-<INITIAL>:days          return DAYS;
-<INITIAL>:seconds       return SECONDS;
-<INITIAL>:addresses     return ADDRESSES;
-<INITIAL>:subject       return SUBJECT;
-<INITIAL>:from          return FROM;
-<INITIAL>:handle        return HANDLE;
-<INITIAL>:mime          return MIME;
-<INITIAL>:comparator    return COMPARATOR;
-<INITIAL>:is            return IS;
-<INITIAL>:contains      return CONTAINS;
-<INITIAL>:matches       return MATCHES;
-<INITIAL>:regex         return REGEX;
-<INITIAL>:count         return COUNT;
-<INITIAL>:value         return VALUE;
-<INITIAL>:over          return OVER;
-<INITIAL>:under         return UNDER;
-<INITIAL>:all           return ALL;
-<INITIAL>:localpart     return LOCALPART;
-<INITIAL>:domain        return DOMAIN;
-<INITIAL>:user          return USER;
-<INITIAL>:detail        return DETAIL;
-<INITIAL>:raw           return RAW;
-<INITIAL>:text          return TEXT;
-<INITIAL>:content       return CONTENT;
-<INITIAL>include        return INCLUDE;
-<INITIAL>:personal      return PERSONAL;
-<INITIAL>:global        return GLOBAL;
-<INITIAL>:optional      return OPTIONAL;
-<INITIAL>:once          return ONCE;
-<INITIAL>return         return RETURN;
-<INITIAL>:copy          return COPY;
-<INITIAL>date           return DATE;
-<INITIAL>currentdate    return CURRENTDATE;
-<INITIAL>:index         return INDEX;
-<INITIAL>:last          return LAST;
-<INITIAL>:zone          return ZONE;
-<INITIAL>:originalzone  return ORIGINALZONE;
-<INITIAL>:flags         return FLAGS;
-<INITIAL>mailboxexists  return MAILBOXEXISTS; /* RFC 5490 */
-<INITIAL>:create        return CREATE;
-<INITIAL>metadata       return METADATA;
-<INITIAL>metadataexists return METADATAEXISTS;
-<INITIAL>servermetadata       return SERVERMETADATA;
+    /* dot stuffing */
+<MULTILINE>^\.\.              buf_putc(&buf, yytext[1]);
+
+    /* end of multi-line text */
+<MULTILINE>^\.{CRLF}          |
+
+    /* end of quoted string */
+<QSTRING>\"                   {
+                                  BEGIN INITIAL;
+                                  if (encoded_char && !decode_string(&buf)) {
+                                      sieveerror_f(sscript,
+                                                   "invalid unicode encoding: %s",
+                                                   buf_cstring(&buf));
+                                  }
+                                  yylval->sval = buf_release(&buf);
+                                  return STRING;
+                              }
+
+    /* escaped character */
+<QSTRING>\\.                  buf_putc(&buf, yytext[1]);
+
+    /* any character (including LF) */
+<QSTRING,MULTILINE>(.|\n)     buf_putc(&buf, yytext[0]);
+
+    /* premature EOF */
+<QSTRING,MULTILINE><<EOF>>    {
+                                  BEGIN INITIAL;
+                                  sieveerror(sscript,
+                                             "unexpected end of file in string");
+                                  buf_free(&buf);
+                                  yyterminate();
+                              }
+
+    /* beginning of multi-line text */
+<INITIAL>text:{ws}?(#.*)?{CRLF} {
+                                  BEGIN MULTILINE;
+                                  buf_reset(&buf);
+                              }
+
+    /* beginning of quoted string */
+<INITIAL>\"                   {
+                                  if (getdatepart) {
+                                      BEGIN QDATEPART;
+                                      getdatepart = 0;
+                                      yyless(0);
+                                  }
+                                  else {
+                                      BEGIN QSTRING;
+                                      buf_reset(&buf);
+                                  }
+                              }
+
+    /* number with optional power of 2 suffix */
+<INITIAL>[0-9]+[KMGkmg]?      {
+                                  unsigned long long val = tonum(yytext);
+                                  if (val > INT_MAX) {
+                                      sieveerror_f(sscript,
+                                                   "number too large %s",
+                                                   yytext);
+                                  }
+                                  yylval->nval = val;
+                                  return NUMBER;
+                              }
+
+    /* standard control commands - RFC 5228 */
+<INITIAL>if                   return IF;
+<INITIAL>elsif                return ELSIF;
+<INITIAL>else                 return ELSE;
+<INITIAL>require              return REQUIRE;
+<INITIAL>stop                 return STOP;
+
+    /* standard tests - RFC 5228 */
+<INITIAL>anyof                return ANYOF;
+<INITIAL>allof                return ALLOF;
+<INITIAL>exists               return EXISTS;
+<INITIAL>false                return SFALSE;
+<INITIAL>true                 return STRUE;
+<INITIAL>not                  return NOT;
+<INITIAL>header               return HEADERT;
+<INITIAL>address              return ADDRESS;
+<INITIAL>envelope             return ENVELOPE;
+<INITIAL>size                 return SIZE;
+<INITIAL>:over                return yylval->nval = OVER;
+<INITIAL>:under               return yylval->nval = UNDER;
+
+    /* standard action commands - RFC 5228 */
+<INITIAL>discard              return DISCARD;
+<INITIAL>keep                 return KEEP;
+<INITIAL>fileinto             return FILEINTO;
+<INITIAL>redirect             return REDIRECT;
+
+    /* copy - RFC 3894 */
+<INITIAL>:copy                return COPY;
+
+    /* comparator-types - RFC 5228 */
+<INITIAL>:comparator          { BEGIN QCOLLATION; return COMPARATOR; }
+
+<QCOLLATION>[ \t\n\r] ;       /* ignore whitespace */
+<QCOLLATION>\"i;octet\"       {
+                                  BEGIN INITIAL;
+                                  return yylval->nval = OCTET;
+                              }
+<QCOLLATION>\"i;ascii-casemap\" {
+                                  BEGIN INITIAL;
+                                  return yylval->nval = ASCIICASEMAP;
+                              }
+<QCOLLATION>\"i;ascii-numeric\" {
+                                  BEGIN INITIAL;
+                                  return yylval->nval = ASCIINUMERIC;
+                              }
+<QCOLLATION>\"[^\"]*\"        {
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "unknown comparator-name %s",
+                                               yytext);
+                              }
+
+    /* match-types - RFC 5228 */
+<INITIAL>:is                  return yylval->nval = IS;
+<INITIAL>:contains            return yylval->nval = CONTAINS;
+<INITIAL>:matches             return yylval->nval = MATCHES;
+
+    /* regex - draft-ietf-sieve-regex */
+<INITIAL>:regex               return yylval->nval = REGEX;
+<INITIAL>:quoteregex          return yylval->nval = QUOTEREGEX;
+
+    /* extlists - RFC 6134 */
+<INITIAL>:list                return yylval->nval = LIST;
+<INITIAL>valid_ext_list       return VALIDEXTLIST;
+
+    /* address-parts - RFC 5228 */
+<INITIAL>:all                 return yylval->nval = ALL;
+<INITIAL>:localpart           return yylval->nval = LOCALPART;
+<INITIAL>:domain              return yylval->nval = DOMAIN;
+
+    /* subaddress - RFC 5233 */
+<INITIAL>:user                return yylval->nval = USER;
+<INITIAL>:detail              return yylval->nval = DETAIL;
+
+    /* body - RFC 5173 */
+<INITIAL>body                 return BODY;
+<INITIAL>:raw                 return yylval->nval = RAW;
+<INITIAL>:text                return yylval->nval = TEXT;
+<INITIAL>:content             return yylval->nval = CONTENT;
+
+    /* environment - RFC 5183 */
+<INITIAL>environment          return ENVIRONMENT;
+
+    /* variables - RFC 5229 */
+<INITIAL>string               return STRINGT;
+<INITIAL>set                  return SET;
+<INITIAL>:lower               return yylval->nval = LOWER;
+<INITIAL>:upper	              return yylval->nval = UPPER;
+<INITIAL>:lowerfirst          return yylval->nval = LOWERFIRST;
+<INITIAL>:upperfirst          return yylval->nval = UPPERFIRST;
+<INITIAL>:quotewildcard       return yylval->nval = QUOTEWILDCARD;
+<INITIAL>:length              return yylval->nval = LENGTH;
+
+    /* vacation - RFC 5230 */
+<INITIAL>vacation             return VACATION;
+<INITIAL>:days                return DAYS;
+<INITIAL>:addresses           return ADDRESSES;
+<INITIAL>:subject             return SUBJECT;
+<INITIAL>:from                return FROM;
+<INITIAL>:handle              return HANDLE;
+<INITIAL>:mime                return MIME;
+
+    /* vacation-seconds - RFC 6131 */
+<INITIAL>:seconds             return SECONDS;
+
+    /* relational - RFC 5231 */
+<INITIAL>:count               { BEGIN QRELATION; return yylval->nval = COUNT; }
+<INITIAL>:value               { BEGIN QRELATION; return yylval->nval = VALUE; }
+
+<QRELATION>[ \t\n\r] ;        /* ignore whitespace */
+<QRELATION>\"eq\"             { BEGIN INITIAL; return yylval->nval = EQ; }
+<QRELATION>\"ne\"             { BEGIN INITIAL; return yylval->nval = NE; }
+<QRELATION>\"gt\"             { BEGIN INITIAL; return yylval->nval = GT; }
+<QRELATION>\"ge\"             { BEGIN INITIAL; return yylval->nval = GE; }
+<QRELATION>\"lt\"             { BEGIN INITIAL; return yylval->nval = LT; }
+<QRELATION>\"le\"             { BEGIN INITIAL; return yylval->nval = LE; }
+<QRELATION>\"[^\"]*\"         {
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid relational-match %s",
+                                               yytext);
+                              }
+
+    /* imap4flags - RFC 5232 */
+<INITIAL>setflag              return yylval->nval = SETFLAG;
+<INITIAL>addflag              return yylval->nval = ADDFLAG;
+<INITIAL>removeflag           return yylval->nval = REMOVEFLAG;
+<INITIAL>hasflag              return yylval->nval = HASFLAG;
+<INITIAL>:flags               return FLAGS;
+
+    /* imapflags - draft-melnikov-sieve-imapflags-04 */
+<INITIAL>mark                 return yylval->nval = MARK;
+<INITIAL>unmark               return yylval->nval = UNMARK;
+
+    /* date - RFC 5260 */
+<INITIAL>date                 return DATE;
+<INITIAL>:originalzone        return ORIGINALZONE;
+<INITIAL>:zone                { BEGIN QTIMEZONE; return ZONE; }
+<INITIAL>currentdate          { getdatepart = 1; return CURRENTDATE; }
+
+<QTIMEZONE>[ \t\n\r] ;        /* ignore whitespace */
+<QTIMEZONE>\"{timezone}\"     {
+                                  BEGIN INITIAL;
+                                  int tz = atoi(yytext+1); /* skip leading " */
+                                  yylval->nval = 60 * (tz / 100) + (tz % 100);
+                                  return TIMEZONE;
+                              }
+<QTIMEZONE>\"[^\"]*\"         {
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid time-zone %s", yytext);
+                              }
+
+<QDATEPART>\"{year}\"         { BEGIN INITIAL; return yylval->nval = YEARP;    }
+<QDATEPART>\"{month}\"        { BEGIN INITIAL; return yylval->nval = MONTHP;   }
+<QDATEPART>\"{day}\"          { BEGIN INITIAL; return yylval->nval = DAYP;     }
+<QDATEPART>\"{date}\"         { BEGIN INITIAL; return yylval->nval = DATEP;    }
+<QDATEPART>\"{julian}\"       { BEGIN INITIAL; return yylval->nval = JULIAN;   }
+<QDATEPART>\"{hour}\"         { BEGIN INITIAL; return yylval->nval = HOURP;    }
+<QDATEPART>\"{minute}\"       { BEGIN INITIAL; return yylval->nval = MINUTEP;  }
+<QDATEPART>\"{second}\"       { BEGIN INITIAL; return yylval->nval = SECONDP;  }
+<QDATEPART>\"{time}\"         { BEGIN INITIAL; return yylval->nval = TIMEP;    }
+<QDATEPART>\"{iso8601}\"      { BEGIN INITIAL; return yylval->nval = ISO8601;  }
+<QDATEPART>\"{std11}\"        { BEGIN INITIAL; return yylval->nval = STD11;    }
+<QDATEPART>\"{zone}\"         { BEGIN INITIAL; return yylval->nval = ZONEP;    }
+<QDATEPART>\"{weekday}\"      { BEGIN INITIAL; return yylval->nval = WEEKDAYP; }
+<QDATEPART>\"[^\"]*\"         {
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid date-part %s", yytext);
+                              }
+
+
+    /* index - RFC 5260 */
+<INITIAL>:index               return INDEX;
+<INITIAL>:last                return LAST;
+
+    /* editheader - RFC 5293 */
+<INITIAL>addheader            return ADDHEADER;
+<INITIAL>deleteheader         return DELETEHEADER;
+    /*   :index               defined in 'index' */
+    /*   :last                defined in 'index' */
+
+    /* [e]reject - RFC 5429 */
+<INITIAL>reject               return yylval->nval = REJCT;
+<INITIAL>ereject              return yylval->nval = EREJECT;
+
+    /* enotify - RFC 5435 */
+<INITIAL>notify_method_capability  return NOTIFYMETHODCAPABILITY;
+<INITIAL>valid_notify_method  return VALIDNOTIFYMETHOD;
+<INITIAL>notify               return NOTIFY;
+<INITIAL>:options             return OPTIONS;
+<INITIAL>:message             return MESSAGE;
+<INITIAL>:encodeurl           return yylval->nval = ENCODEURL;
+<INITIAL>:importance          { BEGIN QIMPORTANCE; return IMPORTANCE; }
+
+<QIMPORTANCE>[ \t\n\r] ;      /* ignore whitespace */
+<QIMPORTANCE>\"1\"            { BEGIN INITIAL; return yylval->nval = HIGH;   }
+<QIMPORTANCE>\"2\"            { BEGIN INITIAL; return yylval->nval = NORMAL; }
+<QIMPORTANCE>\"3\"            { BEGIN INITIAL; return yylval->nval = LOW;    }
+<QIMPORTANCE>\"[^\"]*\"       {
+                                  BEGIN INITIAL;
+                                  sieveerror_f(sscript,
+                                               "invalid importance %s", yytext);
+                              }
+
+    /* notify - draft-martin-sieve-notify-01 */
+<INITIAL>denotify             return DENOTIFY;
+<INITIAL>:method              return METHOD;
+<INITIAL>:id                  return ID;
+<INITIAL>:low                 return yylval->nval = LOW;
+<INITIAL>:normal              return yylval->nval = NORMAL;
+<INITIAL>:high                return yylval->nval = HIGH;
+
+    /* ihave - RFC 5463 */
+<INITIAL>ihave                return IHAVE;
+<INITIAL>error                return ERROR;
+
+    /* mailbox - RFC 5490 */
+<INITIAL>mailboxexists        return MAILBOXEXISTS;
+<INITIAL>:create              return CREATE;
+
+    /* mboxmetadata - RFC 5490 */
+<INITIAL>metadata             return yylval->nval = METADATA;
+<INITIAL>metadataexists       return METADATAEXISTS;
+
+    /* servermetadata - RFC 5490 */
+<INITIAL>servermetadata       return yylval->nval = SERVERMETADATA;
 <INITIAL>servermetadataexists return SERVERMETADATAEXISTS;
-<INITIAL>set            return yylval->nval = SET;
-<INITIAL>:lower         return yylval->nval = LOWER;
-<INITIAL>:upper	        return yylval->nval = UPPER;
-<INITIAL>:lowerfirst    return yylval->nval = LOWERFIRST;
-<INITIAL>:upperfirst    return yylval->nval = UPPERFIRST;
-<INITIAL>:quotewildcard return yylval->nval = QUOTEWILDCARD;
-<INITIAL>:length        return yylval->nval = LENGTH;
-<INITIAL>[ \t\n\r] ;    /* ignore whitespace */
-<INITIAL>#.* ;          /* ignore hash comments */
-<INITIAL>"/*"([^\*]|\*[^\/])*\*?"*/" ;  /* ignore bracket comments */
-.                       return yytext[0];
+
+    /* redirect-deliverby - RFC 6009 */
+<INITIAL>:bytimerelative      return BYTIMEREL;
+<INITIAL>:bytimeabsolute      return BYTIMEABS;
+<INITIAL>:bymode              return BYMODE;
+<INITIAL>:bytrace             return BYTRACE;
+
+    /* redirect-dsn - RFC 6009 */
+<INITIAL>:notify              return DSNNOTIFY;
+<INITIAL>:ret                 return DSNRET;
+
+    /* include - RFC 6609 */
+<INITIAL>include              return INCLUDE;
+<INITIAL>:personal            return yylval->nval = PERSONAL;
+<INITIAL>:global              return yylval->nval = GLOBAL;
+<INITIAL>:optional            return OPTIONAL;
+<INITIAL>:once                return ONCE;
+<INITIAL>return               return RETURN;
+
+    /* duplicate - RFC 7352 */
+<INITIAL>duplicate            return DUPLICATE;
+<INITIAL>:header              return yylval->nval = HEADER;
+<INITIAL>:uniqueid            return yylval->nval = UNIQUEID;
+    /*   :handle              defined in 'vacation' */
+    /*   :seconds             defined in 'vacation-seconds' */
+    /*   :last                defined in 'index' */
+
+    /* special-use - RFC 8579 */
+<INITIAL>specialuse_exists     return SPECIALUSEEXISTS;
+<INITIAL>:specialuse           return SPECIALUSE;
+
+    /* fcc - RFC 8580 */
+<INITIAL>:fcc                  return FCC;
+
+    /* draft-gondwana-sieve-mailboxid */
+<INITIAL>mailboxidexists       return MAILBOXIDEXISTS;
+<INITIAL>:mailboxid            return MAILBOXID;
+
+    /* x-cyrus-log */
+<INITIAL>log                   return LOG;
+
+    /* x-cyrus-jmapquery */
+<INITIAL>jmapquery             return JMAPQUERY;
+
+    /* x-cyrus-snooze */
+<INITIAL>snooze                return SNOOZE;
+<INITIAL>:mailbox              return MAILBOX;
+<INITIAL>:addflags             return ADDFLAGS;
+<INITIAL>:removeflags          return REMOVEFLAGS;
+<INITIAL>:weekdays             return WEEKDAYS;
+    /*   :mailboxid            defined in draft-gondwana-sieve-mailboxid */
+
+<INITIAL>"/*"([^\*]|\*[^\/])*\*?"*/" ;  /* ignore bracketed comments */
+<INITIAL>#.* ;                /* ignore hash comments */
+<INITIAL>[ \t\n\r] ;          /* ignore whitespace */
+.                             return yytext[0];
 
 %%
-/*  */
-static int tonum(char *c)
+
+/* convert numerical string w/units to unsigned long */
+static unsigned long long tonum(const char *str)
 {
-  int val = atoi(c);
-  switch (c[strlen(c)-1]) {
-  case 'K': case 'k': val *= (1 << 10); break;
-  case 'M': case 'm': val *= (1 << 20); break;
-  case 'G': case 'g': val *= (1 << 30); break;
-  default: break;
-  }
-  return val;
+    char *units;
+    unsigned long long val = strtoull(str, &units, 10);
+
+    if (*units && errno != ERANGE) {
+        switch (toupper(*units)) {
+        case 'K': val *= (1ULL << 10); break;
+        case 'M': val *= (1ULL << 20); break;
+        case 'G': val *= (1ULL << 30); break;
+            /* for future use */
+        case 'T': val *= (1ULL << 40); break;
+        case 'P': val *= (1ULL << 50); break;
+        case 'E': val *= (1ULL << 60); break;
+        default: break;
+        }
+    }
+
+    return val;
 }
 
-/* convert NULL strings to "" */
-static char *chkstr(char *str)
+/* convert unicode to sequence of UTF-8 characters */
+static size_t unicode_to_utf8(unsigned char buf[], unsigned int code)
 {
-    if (!str) return xstrdup("");
-    else return str;
+    if (code <= 0x7F) {
+        buf[0] = code;
+        return 1;
+    }
+    if (code <= 0x7FF) {
+        buf[0] = 0xC0 | (code >> 6);            /* 110xxxxx */
+        buf[1] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 2;
+    }
+    if (code < 0xE000 && code > 0xD7FF) return 0;
+    if (code <= 0xFFFF) {
+        buf[0] = 0xE0 | (code >> 12);           /* 1110xxxx */
+        buf[1] = 0x80 | ((code >> 6) & 0x3F);   /* 10xxxxxx */
+        buf[2] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 3;
+    }
+    if (code <= 0x10FFFF) {
+        buf[0] = 0xF0 | (code >> 18);           /* 11110xxx */
+        buf[1] = 0x80 | ((code >> 12) & 0x3F);  /* 10xxxxxx */
+        buf[2] = 0x80 | ((code >> 6) & 0x3F);   /* 10xxxxxx */
+        buf[3] = 0x80 | (code & 0x3F);          /* 10xxxxxx */
+        return 4;
+    }
+    return 0;
+}
+
+/*
+  Decode "encoded-character" strings having one of the following two forms:
+
+  encoded-arb-octets   =  "${hex:" hex-pair-seq "}"
+  hex-pair-seq         =  *blank hex-pair *(1*blank hex-pair) *blank
+  hex-pair             =  1*2HEXDIG
+
+  encoded-unicode-char =  "${unicode:" unicode-hex-seq "}"
+  unicode-hex-seq      =  *blank unicode-hex *(1*blank unicode-hex) *blank
+  unicode-hex          =  1*HEXDIG
+   
+  blank                =  WSP / CRLF
+  WSP                  =  SP / HTAB 
+  HEXDIG               =  DIGIT / "A" / "B" / "C" / "D" / "E" / "F"
+*/
+static int decode_string(struct buf *buf)
+{
+    static struct buf decode_buf = BUF_INITIALIZER;
+    const char *cp, *enc_start;
+
+    for (cp = buf_cstring(buf); (enc_start = strstr(cp, "${")); ) {
+        unsigned is_unicode = 0;
+        size_t len;
+
+        cp = enc_start + 2;
+
+        if (!strncasecmp(cp, "hex:", 4)) {
+            cp += 4;
+        }
+        else if (!strncasecmp(cp, "unicode:", 8)) {
+            is_unicode = 1;
+            cp += 8;
+        }
+        else {
+            /* not coded */
+            continue;
+        }
+
+        /* eat leading whitespace */
+        while (isspace(*cp)) cp++;
+
+        /* sanity check "encoded" data (being liberal in accepting 'a' - 'f') */
+        len = strspn(cp, "0123456789ABCDEFabcdef \t\r\n");
+        if (!isxdigit(*cp) || cp[len] != '}') continue;
+
+        /* decode characters */
+        buf_reset(&decode_buf);
+        do {
+            unsigned int ndigits, code;
+
+            for (ndigits = 0, code = 0; isxdigit(*cp); ndigits++, cp++) {
+                unsigned int digit = 
+                    (*cp > '9') ? 10 + toupper(*cp) - 'A' : *cp - '0';
+
+                code = (code << 4) + digit;
+            }
+
+            if (is_unicode) {
+                unsigned char utf8[4];
+
+                len = unicode_to_utf8(utf8, code);
+                if (!len) {
+                    /* invalid UTF-8 encoding - error */
+                    return 0;
+                }
+
+                /* append decoded unicode char(s) to buffer */
+                buf_appendmap(&decode_buf, (char *) utf8, len);
+            }
+            else if (ndigits > 2) {
+                /* too many hex digits - treat as not coded */
+                buf_reset(&decode_buf);
+                cp += len + 1;
+                break;
+            }
+            else {
+                /* append decoded hex char to buffer */
+                buf_putc(&decode_buf, code);
+            }
+
+            /* eat trailing whitespace */
+            while (isspace(*cp)) cp++;
+
+        } while (*cp != '}');
+
+        if ((len = buf_len(&decode_buf))) {
+            /* replace the encoded string with its decoded value */
+            size_t offset = enc_start - buf_base(buf);
+
+            buf_remove(buf, offset, cp - enc_start + 1);
+            buf_insert(buf, offset, &decode_buf);
+
+            /* buffer may have been reallocated - reposition our pointer */
+            cp = buf_cstring(buf) + offset + len;
+        }
+    }
+
+    return 1;
 }
diff -pruN 3.0.13-5/sieve/sieve.y 3.2.0-3/sieve/sieve.y
--- 3.0.13-5/sieve/sieve.y	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/sieve.y	2020-05-04 03:28:02.000000000 +0000
@@ -1,8 +1,9 @@
 %{
 /* sieve.y -- sieve parser
  * Larry Greenfield
+ * Ken Murchison
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -42,6 +43,10 @@
  * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+/*
+ * Yacc definitions
+ */
+
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
@@ -58,18 +63,18 @@
 #include "sieve/grammar.h"
 #include "sieve/sieve_err.h"
 
-#include "imapurl.h"
 #include "lib/gmtoff.h"
 #include "util.h"
 #include "imparse.h"
 #include "libconfig.h"
 #include "times.h"
+#include "tok.h"
 
 #define ERR_BUF_SIZE 1024
 
-/*
- * Definitions
- */
+int encoded_char = 0;  /* used to send encoded-character feedback to lexer */
+int getdatepart = 0;   /* used to send start state feedback to lexer */
+static comp_t *ctags;  /* used for accessing comp_t* in a test/command union */
 
 extern int addrparse(sieve_script_t*);
 typedef struct yy_buffer_state *YY_BUFFER_STATE;
@@ -78,2479 +83,2989 @@ extern void addr_delete_buffer(YY_BUFFER
 
 extern int sievelineno;
 
-struct vtags {
-    int seconds;
-    strarray_t *addresses;
-    char *subject;
-    char *from;
-    char *handle;
-    int mime;
-};
-
-struct comptags {
-    int match;
-    int relation;
-    char *comparator;  /* only used where comparator can be defined */
-    int index;         /* only used where index extension is defined */
-};
-
-struct aetags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int addrtag;
-};
-
-struct btags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int transform;
-    int offset;
-    strarray_t *content_types;
-};
-
-struct ntags {
-    char *method;
-    char *id;
-    strarray_t *options;
-    int priority;
-    char *message;
-};
-
-struct dtags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    void *pattern;
-    int priority;
-};
-
-struct itags {
-    int location;
-    int once;
-    int optional;
-};
-
-struct dttags {
-    struct comptags comptags;  /* MUST be first so we can typecast */
-    int zonetag;
-    char *zone;
-};
-
-struct ftags {
-    int copy;
-    int create;
-    strarray_t *flags;
-};
-
-struct stags {
-    int mod40; /* :lower or :upper */
-    int mod30; /* :lowerfirst or :upperfirst */
-    int mod20; /* :quotewildcard */
-    int mod10; /* :length */
-};
+void sieveerror_c(sieve_script_t*, int code, ...);
 
-static char *check_reqs(sieve_script_t *script, strarray_t *sl);
+static int check_reqs(sieve_script_t*, strarray_t *sl);
+static int chk_match_vars(sieve_script_t*, char *s);
 
-static test_t *build_address(int t, struct aetags *ae,
+/* construct/canonicalize action commands */
+static commandlist_t *build_keep(sieve_script_t*, commandlist_t *c);
+static commandlist_t *build_fileinto(sieve_script_t*,
+                                     commandlist_t *c, char *folder);
+static commandlist_t *build_redirect(sieve_script_t*,
+                                     commandlist_t *c, char *addr);
+static commandlist_t *build_rej_err(sieve_script_t*, int t, char *message);
+static commandlist_t *build_vacation(sieve_script_t*, commandlist_t *t, char *s);
+static commandlist_t *build_flag(sieve_script_t*,
+                                 commandlist_t *c, strarray_t *flags);
+static commandlist_t *build_notify(sieve_script_t*, int t,
+                                   commandlist_t *c, char *method);
+static commandlist_t *build_denotify(sieve_script_t*, commandlist_t *c);
+static commandlist_t *build_include(sieve_script_t*, commandlist_t *c, char*);
+static commandlist_t *build_set(sieve_script_t*, commandlist_t *c,
+                                char *variable, char *value);
+static commandlist_t *build_addheader(sieve_script_t*, commandlist_t *c,
+                                      char *name, char *value);
+static commandlist_t *build_deleteheader(sieve_script_t*, commandlist_t *c,
+                                         char *name, strarray_t *values);
+static commandlist_t *build_log(sieve_script_t*, char *text);
+static commandlist_t *build_snooze(sieve_script_t *sscript,
+                                   commandlist_t *c, arrayu64_t *times);
+
+/* construct/canonicalize test commands */
+static test_t *build_anyof(sieve_script_t*, testlist_t *tl);
+static test_t *build_allof(sieve_script_t*, testlist_t *tl);
+static test_t *build_not(sieve_script_t*, test_t *t);
+static test_t *build_address(sieve_script_t*, test_t *t,
                              strarray_t *sl, strarray_t *pl);
-static test_t *build_header(int t, struct comptags *c,
+static test_t *build_envelope(sieve_script_t*, test_t *t,
+                              strarray_t *sl, strarray_t *pl);
+static test_t *build_header(sieve_script_t*, test_t *t,
                             strarray_t *sl, strarray_t *pl);
-static test_t *build_body(int t, struct btags *b, strarray_t *pl);
-static test_t *build_date(int t, struct dttags *dt,
+static test_t *build_body(sieve_script_t*, test_t *t, strarray_t *pl);
+static test_t *build_stringt(sieve_script_t*, test_t *t,
+                             strarray_t *sl, strarray_t *pl);
+static test_t *build_hasflag(sieve_script_t*, test_t *t,
+                             strarray_t *sl, strarray_t *pl);
+static test_t *build_date(sieve_script_t*, test_t *t,
                           char *hn, int part, strarray_t *kl);
-static test_t *build_mailboxtest(int t, struct comptags *c, const char *extname,
-                                 const char *keyname, strarray_t *keylist);
+static test_t *build_ihave(sieve_script_t*, strarray_t *sa);
+static test_t *build_mbox_meta(sieve_script_t*, test_t *t, char *extname,
+                               char *keyname, strarray_t *keylist);
+static test_t *build_duplicate(sieve_script_t*, test_t *t);
+static test_t *build_jmapquery(sieve_script_t*, test_t *t, const char *json);
 
-static commandlist_t *build_vacation(int t, struct vtags *h, char *s);
-static commandlist_t *build_notify(int t, struct ntags *n);
-static commandlist_t *build_denotify(int t, struct dtags *n);
-static commandlist_t *build_keep(int t, struct ftags *f);
-static commandlist_t *build_fileinto(int t, struct ftags *f, char *folder);
-static commandlist_t *build_redirect(int t, int c, char *a);
-static commandlist_t *build_include(int, struct itags *, char*);
-static commandlist_t *build_set(int t, struct stags *s,
-                                char *variable, char *value);
-static commandlist_t *build_flag(int t, char *variable, strarray_t *flags);
-
-static struct aetags *new_aetags(void);
-static struct aetags *canon_aetags(struct aetags *ae);
-static void free_aetags(struct aetags *ae);
-
-static struct comptags *new_comptags(void);
-static struct comptags *init_comptags(struct comptags *c);
-static struct comptags *canon_comptags(struct comptags *c);
-static void free_comptags(struct comptags *c, int destroy);
-
-static struct btags *new_btags(void);
-static struct btags *canon_btags(struct btags *b);
-static void free_btags(struct btags *b);
-
-static struct vtags *new_vtags(void);
-static struct vtags *canon_vtags(sieve_script_t *script, struct vtags *v);
-static void free_vtags(struct vtags *v);
-
-static struct ntags *new_ntags(void);
-static struct ntags *canon_ntags(struct ntags *n);
-static void free_ntags(struct ntags *n);
-
-static struct dtags *new_dtags(void);
-static struct dtags *canon_dtags(struct dtags *d);
-static void free_dtags(struct dtags *d);
-
-static struct itags *new_itags(void);
-
-static struct dttags *new_dttags(void);
-static struct dttags *canon_dttags(struct dttags *dt);
-static void free_dttags(struct dttags *b);
-
-static struct ftags *new_ftags(void);
-static struct ftags *canon_ftags(struct ftags *f);
-static void free_ftags(struct ftags *f);
-
-static struct stags *new_stags(void);
-static struct stags *canon_stags(struct stags *s);
-static void free_stags(struct stags *s);
-
-static int verify_stringlist(sieve_script_t*, strarray_t *sl,
-                             int (*verify)(sieve_script_t*, char *));
-static int verify_patternlist(sieve_script_t *parse_script,
-                              strarray_t *sl, struct comptags *c,
-                              int (*verify)(sieve_script_t*, char *));
-static int verify_mailbox(sieve_script_t*, char *s);
-static int verify_address(sieve_script_t*, char *s);
-static int verify_header(sieve_script_t*, char *s);
-static int verify_addrheader(sieve_script_t*, char *s);
-static int verify_envelope(sieve_script_t*, char *s);
-static int verify_relat(sieve_script_t*, char *s);
-static int verify_zone(sieve_script_t*, char *s);
-static int verify_date_part(sieve_script_t *parse_script, char *dp);
-static int verify_utf8(sieve_script_t*, char *s);
-static int verify_identifier(sieve_script_t*, char *s);
+static int verify_weekday(sieve_script_t *sscript, char *day);
+static int verify_time(sieve_script_t *sscript, char *time);
 
-static void parse_error(sieve_script_t *parse_script, int err, ...);
 void yyerror(sieve_script_t*, const char *msg);
 extern int yylex(void*, sieve_script_t*);
 extern void sieverestart(FILE *f);
 
-#define YYERROR_VERBOSE /* i want better error messages! */
+#define supported(capa) (sscript->support & capa)
+
+#define _verify_flaglist(flags) \
+  (supported(SIEVE_CAPA_VARIABLES) || verify_flaglist(flags))
+
+#define YYERROR_VERBOSE /* I want better error messages! */
 
 /* byacc default is 500, bison default is 10000 - go with the
    larger to support big sieve scripts (see Bug #3461) */
 #define YYSTACKSIZE 10000
 %}
 
+
+%name-prefix "sieve"
+%defines
+%destructor  { free_tree($$);     } commands command action control thenelse elsif block
+%destructor  { free_testlist($$); } testlist tests
+%destructor  { free_test($$);     } test
+%destructor  { strarray_free($$); } optstringlist stringlist strings string1
+%destructor  { free($$);          } STRING string
+%destructor  { arrayu64_free($$); } timelist times time1
+
+%param   { sieve_script_t *sscript }
+%pure-parser
+
 %union {
     int nval;
     char *sval;
+    arrayu64_t *nl;
     strarray_t *sl;
+    comp_t *ctag;
     test_t *test;
     testlist_t *testl;
     commandlist_t *cl;
-    struct vtags *vtag;
-    struct aetags *aetag;
-    struct comptags *ctag;
-    struct btags *btag;
-    struct ntags *ntag;
-    struct dtags *dtag;
-    struct itags *itag;
-    struct dttags *dttag;
-    struct ftags *ftag;
-    struct stags *stag;
 }
 
 %token <nval> NUMBER
 %token <sval> STRING
-%token IF ELSIF ELSE
-%token REJCT FILEINTO REDIRECT KEEP STOP DISCARD VACATION REQUIRE
-%token MARK UNMARK FLAGS
-%token NOTIFY DENOTIFY
-%token ANYOF ALLOF EXISTS SFALSE STRUE HEADER NOT SIZE ADDRESS ENVELOPE BODY
-%token COMPARATOR IS CONTAINS MATCHES REGEX COUNT VALUE OVER UNDER
-%token GT GE LT LE EQ NE
-%token ALL LOCALPART DOMAIN USER DETAIL
-%token RAW TEXT CONTENT
-%token DAYS ADDRESSES SUBJECT FROM HANDLE MIME SECONDS
-%token METHOD ID OPTIONS LOW NORMAL HIGH ANY MESSAGE
-%token INCLUDE PERSONAL GLOBAL RETURN OPTIONAL ONCE
+%type <sval> string
+%type <sl> optstringlist stringlist strings string1
+%type <cl> commands command action control
+%type <testl> testlist tests
+%type <test> test
+
+/* standard control commands - RFC 5228 */
+%token IF ELSIF ELSE REQUIRE STOP
+%type <cl> thenelse elsif block
+
+/* standard action commands - RFC 5228 */
+%token DISCARD KEEP FILEINTO REDIRECT
+%type <cl> ktags ftags rtags
+
+/* standard tests - RFC 5228 */
+%token ANYOF ALLOF EXISTS NOT SFALSE STRUE SIZE
+%token HEADERT ADDRESS ENVELOPE COMPARATOR
+%token <nval> OVER UNDER
+%token <nval> ALL LOCALPART DOMAIN
+%token <nval> IS CONTAINS MATCHES
+%token <nval> OCTET ASCIICASEMAP ASCIINUMERIC
+%type <test> htags atags etags
+%type <nval> matchtag collation sizetag addrparttag
+
+/* regex - draft-ietf-sieve-regex */
+%token <nval> REGEX QUOTEREGEX
+
+/* copy - RFC 3894 */
 %token COPY
-%token DATE CURRENTDATE INDEX LAST ZONE ORIGINALZONE
-%token MAILBOXEXISTS CREATE
-%token METADATA METADATAEXISTS
-%token SERVERMETADATA SERVERMETADATAEXISTS
-%token YEAR MONTH DAY JULIAN HOUR MINUTE SECOND TIME ISO8601 STD11 WEEKDAY
-%token <nval> STRINGT SET LOWER UPPER LOWERFIRST UPPERFIRST QUOTEWILDCARD LENGTH
-%token <nval> SETFLAG ADDFLAG REMOVEFLAG HASFLAG
 
-%type <cl> commands command action elsif block
-%type <sl> stringlist strings
-%type <test> test
-%type <nval> match relmatch sizetag addrparttag copy rtags creat datepart
-%type <testl> testlist tests
-%type <ctag> htags strtags hftags mtags
-%type <aetag> atags etags
-%type <btag> btags
-%type <vtag> vtags
-%type <ntag> ntags
-%type <dtag> dtags
-%type <itag> itags
-%type <dttag> dttags cdtags
-%type <nval> priority
-%type <ftag> ftags
-%type <stag> stags
+/* body - RFC 5173 */
+%token BODY
+%token <nval> RAW TEXT CONTENT
+%type <test> btags
+%type <nval> transform
+
+/* environment - RFC 5183 */
+%token ENVIRONMENT
+%type <test> envtags
+
+/* variables - RFC 5229 */
+%token STRINGT SET
+%token <nval> LOWER UPPER LOWERFIRST UPPERFIRST QUOTEWILDCARD LENGTH
+%type <test> strtags
+%type <cl> stags
 %type <nval> mod40 mod30 mod20 mod10
-%type <sval> flagtags
+
+/* vacation - RFC 5230 */
+%token VACATION DAYS SUBJECT FROM ADDRESSES MIME HANDLE
+%type <cl> vtags
+
+/* vacation-seconds - RFC 6131 */
+%token SECONDS
+
+ /* relational - RFC 5231 */
+%token <nval> COUNT VALUE GT GE LT LE EQ NE
+%type <nval> relmatch relation
+
+/* imap[4]flags - RFC 5232 */
+%token FLAGS HASFLAG
+%token <nval> SETFLAG ADDFLAG REMOVEFLAG
+%type <test> hftags
+%type <cl> flagtags
 %type <nval> flagaction
 
-%name-prefix "sieve"
-%defines
-%destructor { free_tree($$); } commands command action elsif block
+/* imapflags - draft-melnikov-sieve-imapflags-04 */
+%token <nval> MARK UNMARK
+%type <nval> flagmark
+
+/* subaddress - RFC 5233 */
+%token <nval> USER DETAIL
+%type <nval> subaddress
+
+/* date - RFC 5260 */
+%token DATE CURRENTDATE ORIGINALZONE ZONE
+%token <nval> TIMEZONE
+%token <nval> YEARP MONTHP DAYP DATEP JULIAN
+%token <nval> HOURP MINUTEP SECONDP TIMEP ISO8601 STD11 ZONEP WEEKDAYP
+%type <test> dttags cdtags
+%type <nval> datepart
+
+/* index - RFC 5260 */
+%token INDEX LAST
+
+/* editheader - RFC 5293 */
+%token ADDHEADER DELETEHEADER
+%type <cl> ahtags dhtags
+
+/* [e]reject - RFC 5429 */
+%token <nval> REJCT EREJECT
+%type <nval> reject
+
+/* enotify - RFC 5435 */
+%token METHOD OPTIONS MESSAGE IMPORTANCE VALIDNOTIFYMETHOD NOTIFYMETHODCAPABILITY
+%token <nval> NOTIFY ENOTIFY ENCODEURL
+%type <cl> ntags
+%type <nval> mod15
+%type <test> methtags
+
+/* notify - draft-martin-sieve-notify-01 */
+%token DENOTIFY ID ANY
+%token <nval> LOW NORMAL HIGH
+%type <cl> dtags
+%type <nval> priority
 
-%param { sieve_script_t *parse_script }
-%pure-parser
+/* ihave - RFC 5463 */
+%token IHAVE ERROR
 
+/* mailbox - RFC 5490 */
+%token MAILBOXEXISTS CREATE
+%type <test> mtags
+
+/* mboxmetadata - RFC 5490 */
+%token <nval> METADATA
+%token METADATAEXISTS
+
+/* servermetadata - RFC 5490 */
+%token <nval> SERVERMETADATA
+%token SERVERMETADATAEXISTS
+
+/* redirect-deliveryby - RFC 6009 */
+%token BYTIMEREL BYTIMEABS BYMODE BYTRACE
+
+/* redirect-dsn - RFC 6009 */
+%token DSNNOTIFY DSNRET
+
+/* extlists - RFC 6134 */
+%token VALIDEXTLIST
+%token <nval> LIST
+
+/* include - RFC 6609 */
+%token INCLUDE OPTIONAL ONCE RETURN
+%token <nval> PERSONAL GLOBAL
+%type <cl> itags
+%type <nval> location
+
+/* duplicate - RFC 7352 */
+%token DUPLICATE
+%token <nval> HEADER UNIQUEID
+%type <test> duptags
+%type <nval> idtype
+
+/* special-use - RFC 8579 */
+%token SPECIALUSEEXISTS SPECIALUSE
+
+/* fcc - RFC 8580 */
+%token FCC
+
+/* draft-gondwana-sieve-mailboxid */
+%token MAILBOXID MAILBOXIDEXISTS
+
+/* x-cyrus-log */
+%token LOG
+
+/* x-cyrus-jmapquery */
+%token JMAPQUERY
+
+/* x-cyrus-snooze */
+%token SNOOZE MAILBOX ADDFLAGS REMOVEFLAGS WEEKDAYS
+%type <nval> weekdaylist weekdays weekday time
+%type <nl> timelist times time1
+%type <cl> sntags
 
-/*
- * Rules
- */
 
 %%
 
-start: reqs                     { parse_script->cmds = NULL; }
-        | reqs commands         { parse_script->cmds = $2; }
+/*
+ * Yacc rules
+ *
+ * NOTE: In several place we use the inherited attribute $0,
+ * which gives us access to the symbol to the left of the current rule.
+ * This allows us to pass values "forward" by reference.
+ */
+
+/* Per RFC5228, Section 3.2, ALL require commands MUST appear first */
+start:    reqs                   { sscript->cmds = NULL; }
+        | reqs commands          { sscript->cmds = $2; }
         ;
 
+
 reqs: /* empty */
         | require reqs
         ;
 
-require: REQUIRE stringlist ';'
-                                {
-                                    char *err = check_reqs(parse_script, $2);
-                                    if (err) {
-                                        yyerror(parse_script, err);
-                                        free(err);
-                                        YYERROR;
-                                    }
-                                }
-        ;
-
-commands: command               { $$ = $1; }
-        | command commands      { $1->next = $2; $$ = $1; }
-        ;
-
-command: action ';'             { $$ = $1; }
-        | IF test block elsif   { $$ = new_if($2, $3, $4); }
-        | error ';'             { $$ = new_command(STOP); }
-        ;
 
-elsif: /* empty */               { $$ = NULL; }
-        | ELSIF test block elsif { $$ = new_if($2, $3, $4); }
-        | ELSE block             { $$ = $2; }
+/* Can NOT be empty otherwise we get a shift/reduce conflict */
+commands: command
+        | command commands       { $$ = $1; $$->next = $2; }
         ;
 
-action: REJCT STRING
-                                 {
-                                     if (!parse_script->support.reject) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "reject");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, $2)) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     $$ = new_command(REJCT);
-                                     $$->u.reject = $2;
+
+command:  control
+        | action ';'
+        | error ';'              {
+                                     struct buf buf = BUF_INITIALIZER;
+                                     buf_printf(&buf, "%s: line %d",
+                                                error_message(SIEVE_UNSUPP_EXT),
+                                                sievelineno);
+                                     sscript->support |= SIEVE_CAPA_IHAVE;
+                                     $$ = build_rej_err(sscript, ERROR,
+                                                        buf_release(&buf));
                                  }
+        ;
 
-        | FILEINTO ftags STRING
-                                 {
-                                     if (!parse_script->support.fileinto) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "fileinto");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_mailbox(parse_script, $3)) {
-                                         YYERROR; /* vm should call yyerror() */
-                                     }
-                                     $$ = build_fileinto(FILEINTO,
-                                                         canon_ftags($2), $3);
+
+optstringlist: /* empty */       { $$ = strarray_new(); }
+        | stringlist
+        ;
+
+
+stringlist: string1
+        | '[' strings ']'        { $$ = $2; }
+        ;
+
+
+strings:  string1
+        | strings ',' string     { $$ = $1; strarray_appendm($$, $3); }
+        ;
+
+
+string1: string                  {
+                                     $$ = strarray_new();
+                                     strarray_appendm($$, $1);
                                  }
+        ;
 
-        | REDIRECT rtags STRING
-                                 {
-                                     if (!verify_address(parse_script, $3)) {
-                                         YYERROR; /* va should call yyerror() */
+
+string: STRING                   { $$ = $1; chk_match_vars(sscript, $$); }
+        ;
+
+
+/*
+ * Control commands
+ */
+require: REQUIRE stringlist ';'  { check_reqs(sscript, $2); }
+        ;
+
+
+control:  IF thenelse            { $$ = $2; }
+        | STOP ';'               { $$ = new_command(STOP, sscript); }
+        | ERROR string ';'       { $$ = build_rej_err(sscript, ERROR, $2); }
+        ;
+
+
+thenelse: test block elsif       { 
+                                     if ($1->ignore_err) {
+                                         /* end of block - decrement counter */
+                                         sscript->ignore_err--;
                                      }
-                                     $$ = build_redirect(REDIRECT, $2, $3);
+
+                                     $$ = new_if($1, $2, $3);
                                  }
+        ;
 
-        | KEEP ftags             { $$ = build_keep(KEEP,canon_ftags($2)); }
-        | STOP                   { $$ = new_command(STOP); }
-        | DISCARD                { $$ = new_command(DISCARD); }
 
-        | VACATION vtags STRING
-                                 {
-                                     if (!parse_script->support.vacation) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "vacation");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (($2->mime == -1) &&
-                                         !verify_utf8(parse_script, $3)) {
-                                         YYERROR; /* vu should call yyerror() */
-                                     }
-                                     $$ = build_vacation(VACATION,
-                                                         canon_vtags(parse_script, $2),
-                                                         $3);
-                                 }
+elsif: /* empty */               { $$ = NULL; }
+        | ELSIF thenelse         { $$ = $2; }
+        | ELSE block             { $$ = $2; }
+        ;
+
+
+block: '{' commands '}'          { $$ = $2; }
+        | '{' '}'                { $$ = NULL; }
+        ;
 
+
+/*
+ * Action commands
+ */
+action:   KEEP ktags             { $$ = build_keep(sscript, $2); }
+        | FILEINTO ftags string  { $$ = build_fileinto(sscript, $2, $3); }
+        | REDIRECT rtags string  { $$ = build_redirect(sscript, $2, $3); }
+        | DISCARD                { $$ = new_command(DISCARD, sscript); }
+        | SET stags string string
+                                 { $$ = build_set(sscript, $2, $3, $4); }
+        | VACATION vtags string  { $$ = build_vacation(sscript, $2, $3); }
+
+        /* SET/ADD/REMOVEFLAG */ 
         | flagaction flagtags stringlist
-                                 {
-                                     if (!(parse_script->support.imapflags ||
-                                           parse_script->support.imap4flags)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap[4]flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!parse_script->support.variables) {
-                                         verify_flaglist($3);
-                                     }
-                                     if (!$3->count) strarray_add($3, "");
-                                     $$ = build_flag($1, $2, $3);
-                                 }
+                                 { $$ = build_flag(sscript, $2, $3); }
 
-         | MARK
-                                 {
-                                     if (!parse_script->support.imapflags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imapflags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = new_command(MARK);
-                                 }
+        /* MARK/UNMARK */ 
+        | flagmark               { $$ = new_command($1, sscript); }
 
-         | UNMARK
-                                 {
-                                     if (!parse_script->support.imapflags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imapflags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = new_command(UNMARK);
-                                 }
+        | ADDHEADER ahtags string string
+                                 { $$ = build_addheader(sscript,
+                                                        $2, $3, $4); }
+        | DELETEHEADER dhtags string optstringlist
+                                 { $$ = build_deleteheader(sscript,
+                                                           $2, $3, $4); }
 
-         | NOTIFY ntags
-                                 {
-                                     if (!parse_script->support.notify) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "notify");
-                                         $$ = new_command(NOTIFY);
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = build_notify(NOTIFY, canon_ntags($2));
-                                 }
+        | reject string          { $$ = build_rej_err(sscript, $1, $2); }
+        | NOTIFY ntags string    { $$ = build_notify(sscript,
+                                                     ENOTIFY, $2, $3); }
 
-         | DENOTIFY dtags
-                                 {
-                                     if (!parse_script->support.notify) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "notify");
-                                         $$ = new_command(DENOTIFY);
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = build_denotify(DENOTIFY,
-                                                         canon_dtags($2));
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "denotify action");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                 }
+        | NOTIFY ntags           { $$ = build_notify(sscript,
+                                                     NOTIFY, $2, NULL); }
 
-         | INCLUDE itags STRING
-                                 {
-                                     if (!parse_script->support.include) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "include");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     int i;
-                                     for (i = 0; $3[i] != '\0'; i++) {
-                                         if ($3[i] == '/') {
-                                             parse_error(parse_script,
-                                                         SIEVE_INVALID_VALUE,
-                                                         "script-name");
-                                             YYERROR; /* pe should call yyerror() */
-                                             break;
-                                         }
-                                     }
-                                     $$ = build_include(INCLUDE, $2, $3);
-                                 }
+        | DENOTIFY dtags         { $$ = build_denotify(sscript, $2); }
+        | INCLUDE itags string   { $$ = build_include(sscript, $2, $3); }
+        | LOG string             { $$ = build_log(sscript, $2); }
+        | SNOOZE sntags timelist
+                                 { $$ = build_snooze(sscript, $2, $3); }
+        | RETURN                 { $$ = new_command(RETURN, sscript); }
+        ;
 
-         | RETURN
-                                 {
-                                     if (!parse_script->support.include) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "include");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = new_command(RETURN);
-                                 }
 
-         | SET stags STRING STRING
-                                 {
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
+/* KEEP tagged arguments */
+ktags: /* empty */               { $$ = new_command(KEEP, sscript); }
+        | ktags flags
+        ;
+
+
+/* :flags */
+flags: FLAGS stringlist          {
+                                     /* $0 refers to ktags, ftags, or vtags */
+                                     commandlist_t *c = $<cl>0;
+                                     strarray_t **flags = NULL;
+
+                                     switch (c->type) {
+                                     case KEEP:
+                                         flags = &c->u.k.flags; break;
+                                     case FILEINTO:
+                                         flags = &c->u.f.flags; break;
+                                     case VACATION:
+                                         flags = &c->u.v.fcc.flags; break;
+                                     case ENOTIFY:
+                                         flags = &c->u.n.fcc.flags; break;
                                      }
-                                     if (!verify_identifier(parse_script, $3)) {
-                                         YYERROR; /* vi should call yyerror() */
+
+                                     if (*flags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":flags");
+                                         strarray_free(*flags);
                                      }
-                                     if (!verify_utf8(parse_script, $4)) {
-                                         YYERROR; /* vu should call yyerror() */
+                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "imap4flags");
                                      }
-                                     $$ = build_set(SET, canon_stags($2), $3, $4);
+
+                                     *flags = $2;
                                  }
         ;
 
-flagaction: ADDFLAG
-        | SETFLAG
-        | REMOVEFLAG
+
+/* FILEINTO tagged arguments */
+ftags: /* empty */               { $$ = new_command(FILEINTO, sscript); }
+        | ftags copy
+        | ftags flags
+        | ftags create
+        | ftags specialuse
+        | ftags mailboxid
         ;
 
-flagtags: /* empty */            { $$ = NULL; }
-        | flagtags STRING
-                                 {
-                                     if (!(parse_script->support.imap4flags)) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ($1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_ARG,
-                                                     "variablename");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* :copy */
+copy: COPY                       {
+                                     /* $0 refers to ftags or rtags */
+                                     commandlist_t *c = $<cl>0;
+                                     int *copy = (c->type == FILEINTO) ?
+                                         &c->u.f.copy : &c->u.r.copy;
+
+                                     if ((*copy)++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":copy");
                                      }
-                                     if (!is_identifier($2)) {
-                                         YYERROR; /* id should call yyerror() */
+                                     else if (!supported(SIEVE_CAPA_COPY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "copy");
                                      }
-                                     $$ = $2;
                                  }
         ;
 
-stags: /* empty */               { $$ = new_stags(); }
-        | stags mod40
-                                 {
-                                     if ($$->mod40) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 40 modifier");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* :create */
+create: CREATE                  {
+                                     /* $0 refers to ftags or vtags */
+                                     commandlist_t *c = $<cl>0;
+                                     int *create = NULL;
+
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         create = &c->u.f.create; break;
+                                     case VACATION:
+                                         create = &c->u.v.fcc.create; break;
+                                     case ENOTIFY:
+                                         create = &c->u.n.fcc.create; break;
                                      }
-                                     else $$->mod40 = $2;
-                                 }
-        | stags mod30
-                                 {
-                                     if ($$->mod30) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 30 modifier");
-                                         YYERROR; /* pe should call yyerror() */
+
+                                     if ((*create)++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":create");
                                      }
-                                     else $$->mod30 = $2;
-                                 }
-        | stags mod20
-                                 {
-                                     if ($$->mod20) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 20 modifier");
-                                         YYERROR; /* pe should call yyerror() */
+                                     else if (!supported(SIEVE_CAPA_MAILBOX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "mailbox");
                                      }
-                                     else $$->mod20 = $2;
                                  }
-/* TODO: :encodeurl
-   Requires "enotify" extension, which has not been implemented yet.
+        ;
 
-   RFC 5435 (Sieve Extension: Notifications)
-   6.  Modifier encodeurl to the 'set' Action
 
-   Usage:  ":encodeurl"
+/* :specialuse */
+specialuse: SPECIALUSE string    {
+                                     /* $0 refers to ftags or vtags */
+                                     commandlist_t *c = $<cl>0;
+                                     char **specialuse = NULL;
 
-   When the Sieve script specifies both "variables" [Variables] and
-   "enotify" capabilities in the "require", a new "set" action modifier
-   (see [Variables]) ":encodeurl" becomes available to Sieve scripts.
-   This modifier performs percent-encoding of any octet in the string
-   that doesn't belong to the "unreserved" set (see [URI]).  The
-   percent-encoding procedure is described in [URI].
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         specialuse = &c->u.f.specialuse;
+                                         break;
+                                     case VACATION:
+                                         specialuse = &c->u.v.fcc.specialuse;
+                                         break;
+                                     case ENOTIFY:
+                                         specialuse = &c->u.n.fcc.specialuse;
+                                         break;
+                                     }
 
-   The ":encodeurl" modifier has precedence 15.
+                                     if (*specialuse != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":specialuse");
+                                         free(*specialuse);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_SPECIAL_USE)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "special-use");
+                                     }
 
-   Example 6:
-   require ["enotify", "variables"];
+                                     *specialuse = $2;
+                                 }
+        ;
 
-   set :encodeurl "body_param" "Safe body&evil=evilbody";
+mailboxid: MAILBOXID string      {
+                                     /* $0 refers to ftags, sntags or vtags */
+                                     commandlist_t *c = $<cl>0;
+                                     char **mailboxid = NULL;
 
-   notify "mailto:tim@example.com?body=${body_param}";
+                                     switch (c->type) {
+                                     case FILEINTO:
+                                         mailboxid = &c->u.f.mailboxid;
+                                         break;
+                                     case SNOOZE:
+                                         mailboxid = &c->u.sn.mailbox;
+                                         break;
+                                     case VACATION:
+                                         mailboxid = &c->u.v.fcc.mailboxid;
+                                         break;
+                                     case ENOTIFY:
+                                         mailboxid = &c->u.n.fcc.mailboxid;
+                                         break;
+                                     }
 
-*/
-        | stags mod10
-                                 {
-                                     if ($$->mod10) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "precedence 10 modifier");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (*mailboxid != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mailboxid");
+                                         free(*mailboxid);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_MAILBOXID)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "mailboxid");
                                      }
-                                     else $$->mod10 = $2;
-                                 }
-;
 
-mod40:  LOWER
-        | UPPER
-        ;
-mod30:  LOWERFIRST
-        | UPPERFIRST
-        ;
-mod20:  QUOTEWILDCARD
-        ;
-mod10:  LENGTH
+                                     *mailboxid = $2;
+                                 }
         ;
 
-itags: /* empty */               { $$ = new_itags(); }
-        | itags PERSONAL
-                                 {
-                                     if ($$->location != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "location");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* REDIRECT tagged arguments */
+rtags: /* empty */               { $$ = new_command(REDIRECT, sscript); }
+        | rtags copy
+        | rtags LIST             {
+                                     if ($$->u.r.list++) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":list");
                                      }
-                                     else $$->location = PERSONAL;
-                                 }
-        | itags GLOBAL
-                                 {
-                                     if ($$->location != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "location");
-                                         YYERROR; /* pe should call yyerror() */
+                                     else if (!supported(SIEVE_CAPA_EXTLISTS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "extlists");
                                      }
-                                     else $$->location = GLOBAL;
                                  }
-        | itags ONCE
-                                 {
-                                     if ($$->once != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":once");
-                                         YYERROR; /* pe should call yyerror() */
+        | rtags delbytags        {
+                                     if (!supported(SIEVE_CAPA_REDIR_DELBY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "redirect-deliverby");
                                      }
-                                     else $$->once = 1;
                                  }
-        | itags OPTIONAL
-                                 { if ($$->optional != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":optional");
-                                         YYERROR; /* pe should call yyerror() */
+        | rtags dsntags          {
+                                     if (!supported(SIEVE_CAPA_REDIR_DSN)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "redirect-dsn");
                                      }
-                                     else $$->optional = 1;
                                  }
         ;
 
-ntags: /* empty */               { $$ = new_ntags(); }
-        | ntags ID STRING
-                                 {
-                                     if ($$->id != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":id");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->id = $3;
-                                 }
-        | ntags METHOD STRING
-                                 {
-                                     if ($$->method != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":method");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->method = $3;
+/* REDIRECT-DELIVERBY tagged arguments */
+delbytags: BYTIMEREL NUMBER      {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
+
+                                     if (c->u.r.bytime != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytime*");
+                                     }                                         
+
+                                     struct buf buf = BUF_INITIALIZER;
+                                     buf_printf(&buf, "+%d", $2);
+                                     c->u.r.bytime = buf_release(&buf);
                                  }
-        | ntags OPTIONS stringlist
-                                 {
-                                     if ($$->options != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":options");
-                                         YYERROR; /* pe should call yyerror() */
+        | BYTIMEABS string       {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
+
+                                     if (c->u.r.bytime != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytimerelative"
+                                                      " OR :bytimeabsolute");
                                      }
-                                     else $$->options = $3;
+
+                                     c->u.r.bytime = $2;
                                  }
-        | ntags priority
-                                 {
-                                     if ($$->priority != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "priority");
-                                         YYERROR; /* pe should call yyerror() */
+        | BYMODE string          {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
+
+                                     if (c->u.r.bymode != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bymode");
                                      }
-                                     else $$->priority = $2;
+
+                                     c->u.r.bymode = $2;
                                  }
-        | ntags MESSAGE STRING
-                                 {
-                                     if ($$->message != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":message");
-                                         YYERROR; /* pe should call yyerror() */
+        | BYTRACE                {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
+
+                                     if (c->u.r.bytrace != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":bytrace");
                                      }
-                                     else $$->message = $3;
+
+                                     c->u.r.bytrace = 1;
                                  }
         ;
 
-dtags: /* empty */               { $$ = new_dtags(); }
-        | dtags priority
-                                 {
-                                     if ($$->priority != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "priority");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->priority = $2;
+
+/* REDIRECT-DSN tagged arguments */
+dsntags:  DSNNOTIFY string       {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
+
+                                     if (c->u.r.dsn_notify != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":notify");
+                                     }                                         
+
+                                     c->u.r.dsn_notify = $2;
                                  }
-        | dtags matchtags STRING
-                                 {
-                                     $$->pattern = $3;
+        | DSNRET string          {
+                                     /* $0 refers to rtags */
+                                     commandlist_t *c = $<cl>0;
 
-                                     strarray_t sa = STRARRAY_INITIALIZER;
-                                     strarray_appendm(&sa, $3);
-                                     if (!verify_patternlist(parse_script, &sa,
-                                                             &($$->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     if (c->u.r.dsn_ret != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":ret");
                                      }
-                                     strarray_fini(&sa);
+
+                                     c->u.r.dsn_ret = $2;
                                  }
         ;
 
-priority: LOW                   { $$ = LOW; }
-        | NORMAL                { $$ = NORMAL; }
-        | HIGH                  { $$ = HIGH; }
-        ;
 
-vtags: /* empty */               { $$ = new_vtags(); }
-        | vtags DAYS NUMBER
-                                 {
-                                     if ($$->seconds != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "period");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->seconds = $3 * DAY2SEC;
-                                 }
-        | vtags SECONDS NUMBER
-                                 {
-                                     if (!parse_script->support.vacation_seconds) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "vacation-seconds");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ($$->seconds != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "period");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$->seconds = $3;
-                                 }
-        | vtags ADDRESSES stringlist
-                                 {
-                                     if ($$->addresses != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":addresses");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_stringlist(parse_script, $3,
-                                                            verify_address)) {
-                                         YYERROR;
+/* SET tagged arguments */
+stags: /* empty */               { $$ = new_command(SET, sscript); }
+        | stags mod40            {
+                                     if ($$->u.s.mod40) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 40 modifier");
                                      }
-                                     $$->addresses = $3;
+
+                                     $$->u.s.mod40 = $2;
                                  }
-        | vtags SUBJECT STRING
-                                 {
-                                     if ($$->subject != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":subject");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, $3)) {
-                                         YYERROR; /* vu should call yyerror() */
+        | stags mod30            {
+                                     if ($$->u.s.mod30) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 30 modifier");
                                      }
-                                     $$->subject = $3;
+
+                                     $$->u.s.mod30 = $2;
                                  }
-        | vtags FROM STRING
-                                 {
-                                     if ($$->from != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":from");
-                                         YYERROR; /* pe should call yyerror() */
+        | stags mod20            {
+                                     if ($$->u.s.mod20) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 20 modifier");
                                      }
-                                     if (!verify_address(parse_script, $3)) {
-                                         YYERROR; /* va should call yyerror() */
-                                     }
-                                     $$->from = $3;
+
+                                     $$->u.s.mod20 = $2;
                                  }
-        | vtags HANDLE STRING
-                                 {
-                                     if ($$->handle != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":handle");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_utf8(parse_script, $3)) {
-                                         YYERROR; /* vu should call yyerror() */
+        | stags mod15            {
+                                     if ($$->u.s.mod15) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 15 modifier");
                                      }
-                                     $$->handle = $3;
+
+                                     $$->u.s.mod15 = $2;
                                  }
-        | vtags MIME
-                                 {
-                                     if ($$->mime != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":mime");
-                                         YYERROR; /* pe should call yyerror() */
+        | stags mod10            {
+                                     if ($$->u.s.mod10) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "precedence 10 modifier");
                                      }
-                                     $$->mime = MIME;
+
+                                     $$->u.s.mod10 = $2;
                                  }
         ;
 
-stringlist: '[' strings ']'      { $$ = $2; }
-        | STRING                 {
-                                    $$ = strarray_new();
-                                    strarray_appendm($$, $1);
-                                 }
+
+/* SET modifiers */
+mod40:    LOWER
+        | UPPER
         ;
 
-strings: STRING                  {
-                                    $$ = strarray_new();
-                                    strarray_appendm($$, $1);
+mod30:    LOWERFIRST
+        | UPPERFIRST
+        ;
+
+mod20:    QUOTEWILDCARD
+        | QUOTEREGEX            { 
+                                     if (!supported(SIEVE_CAPA_REGEX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "regex");
+                                     }
                                  }
-        | strings ',' STRING     {
-                                    $$ = $1;
-                                    strarray_appendm($$, $3);
+
+        ;
+
+mod15:    ENCODEURL              { 
+                                     if (!supported(SIEVE_CAPA_ENOTIFY)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "enotify");
+                                     }
                                  }
         ;
 
-block: '{' commands '}'          { $$ = $2; }
-        | '{' '}'                { $$ = NULL; }
+mod10:    LENGTH
         ;
 
-test:     ANYOF testlist         { $$ = new_test(ANYOF); $$->u.tl = $2; }
-        | ALLOF testlist         { $$ = new_test(ALLOF); $$->u.tl = $2; }
-        | EXISTS stringlist      { $$ = new_test(EXISTS); $$->u.sl = $2; }
-        | SFALSE                 { $$ = new_test(SFALSE); }
-        | STRUE                  { $$ = new_test(STRUE); }
 
-        | HEADER htags stringlist stringlist
-                                 {
-                                     if (!verify_stringlist(parse_script,
-                                                            $3, verify_header)) {
-                                         YYERROR; /* vh should call yyerror() */
-                                     }
-                                     $2 = canon_comptags($2);
-
-                                     if (!verify_patternlist(parse_script,
-                                                             $4, $2,
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_header(HEADER, $2, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "header test");
-                                         YYERROR; /* pe should call yyerror() */
+/* VACATION tagged arguments */
+vtags: /* empty */               { $$ = new_command(VACATION, sscript); }
+        | vtags DAYS NUMBER      {
+                                     if ($$->u.v.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":days");
                                      }
-                                 }
 
-        | STRINGT strtags stringlist stringlist
-                                 {
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.v.seconds = $3 * DAY2SEC;
+                                 }
+        | vtags SECONDS NUMBER   {
+                                     if (!supported(SIEVE_CAPA_VACATION_SEC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "vacation-seconds");
                                      }
-                                     if (!verify_stringlist(parse_script,
-                                                            $3, verify_utf8)) {
-                                         YYERROR; /* vu should call yyerror() */
+                                     if ($$->u.v.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":seconds");
                                      }
-                                     $2 = canon_comptags($2);
 
-                                     if (!verify_patternlist(parse_script,
-                                                             $4, $2,
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     $$->u.v.seconds = $3;
+                                 }
+        | vtags SUBJECT string   {
+                                     if ($$->u.v.subject != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":subject");
+                                         free($$->u.v.subject);
                                      }
 
-                                     $$ = build_header(STRINGT, $2, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "string test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     $$->u.v.subject = $3;
                                  }
-
-/* Per RFC 5232, the variables list (penultimate argument) is optional,
-   but defining the grammar this way results in a shift/reduce conflict.
-   Therefore, we have to flatten the grammar into two rules.
-*/
-        | HASFLAG hftags stringlist stringlist
-                                 {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!parse_script->support.variables) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "variables");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_stringlist(parse_script, $3,
-                                                            verify_identifier)) {
-                                         YYERROR; /* vi should call yyerror() */
-                                     }
-                                     $2 = canon_comptags($2);
-
-                                     if (!verify_patternlist(parse_script,
-                                                             $4, $2,
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_header(HASFLAG, $2, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "hasflag test");
-                                         YYERROR; /* pe should call yyerror() */
+        | vtags FROM string      {
+                                     if ($$->u.v.from != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":from");
+                                         free($$->u.v.from);
                                      }
-                                 }
 
-        | HASFLAG hftags stringlist
-                                 {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $2 = canon_comptags($2);
-
-                                     if (!verify_patternlist(parse_script,
-                                                             $3, $2,
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_header(HASFLAG, $2, NULL, $3);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "hasflag test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     $$->u.v.from = $3;
                                  }
 
-        | ADDRESS atags stringlist stringlist
+        | vtags ADDRESSES stringlist
                                  {
-                                     if (!verify_stringlist(parse_script, $3,
-                                                            verify_addrheader)) {
-                                         YYERROR; /* vah should call yyerror() */
-                                     }
-                                     $2 = canon_aetags($2);
-
-                                     if (!verify_patternlist(parse_script, $4,
-                                                             &($2->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_address(ADDRESS, $2, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "address test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.v.addresses != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":addresses");
+                                         strarray_free($$->u.v.addresses);
                                      }
-                                 }
 
-        | ENVELOPE etags stringlist stringlist
-                                 {
-                                     if (!parse_script->support.envelope) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "envelope");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_stringlist(parse_script, $3,
-                                                            verify_envelope)) {
-                                         YYERROR;
+                                     $$->u.v.addresses = $3;
+                                 }
+        | vtags MIME             {
+                                     if ($$->u.v.mime != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mime");
                                      }
-                                     $2 = canon_aetags($2);
 
-                                     if (!verify_patternlist(parse_script, $4,
-                                                             &($2->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
+                                     $$->u.v.mime = 1;
+                                 }
+        | vtags HANDLE string    {
+                                     if ($$->u.v.handle != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":handle");
+                                         free($$->u.v.handle);
                                      }
 
-                                     $$ = build_address(ENVELOPE, $2, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "envelope test");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
+                                     $$->u.v.handle = $3;
                                  }
+        | vtags fcctags
+        ;
 
-        | BODY btags stringlist
-                                 {
-                                     if (!parse_script->support.body) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "body");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $2 = canon_btags($2);
 
-                                     if (!verify_patternlist(parse_script, $3,
-                                                             &($2->comptags),
-                                                             verify_utf8)) {
-                                         YYERROR; /* vp should call yyerror() */
+fcctags: FCC string              {
+                                     /* $0 refers to vtags or ntags */
+                                     commandlist_t *c = $<cl>0;
+                                     char **folder = NULL;
+
+                                     switch (c->type) {
+                                     case VACATION:
+                                         folder = &c->u.v.fcc.folder; break;
+                                     case ENOTIFY:
+                                         folder = &c->u.n.fcc.folder; break;
                                      }
 
-                                     $$ = build_body(BODY, $2, $3);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "body test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (*folder != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":fcc");
+                                         free(*folder);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_FCC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "fcc");
                                      }
+
+                                     *folder = $2;
                                  }
+        | create
+        | flags
+        | specialuse
+        ;
 
-        | NOT test               { $$ = new_test(NOT); $$->u.t = $2; }
-        | SIZE sizetag NUMBER    { $$ = new_test(SIZE); $$->u.sz.t = $2;
-                                   $$->u.sz.n = $3; }
 
-        | DATE dttags STRING datepart stringlist
-                                 {
-                                     if (!parse_script->support.date) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "date");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (!verify_header(parse_script, $3)) {
-                                         YYERROR; /* vh should call yyerror() */
-                                     }
-                                     $2 = canon_dttags($2);
-
-                                     if (!verify_patternlist(parse_script, $5,
-                                                             &($2->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_date(DATE, $2, $3, $4, $5);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "date test");
-                                         YYERROR; /* pe should call yyerror() */
+/* SET/ADD/REMOVEFLAG */
+flagaction: SETFLAG
+        | ADDFLAG
+        | REMOVEFLAG
+        ;
+
+
+/* SET/ADD/REMOVEFLAG tagged arguments - $0 refers to flagaction */
+flagtags: /* empty */            { $$ = new_command($<nval>0, sscript); }
+        | flagtags string        {
+                                     if ($$->u.fl.variable != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_ARG,
+                                                      "variablename");
+                                         free($$->u.fl.variable);
+                                     }
+                                     else if (!supported(SIEVE_CAPA_IMAP4FLAGS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "imap4flags");
                                      }
+
+                                     $$->u.fl.variable = $2;
                                  }
+        ;
 
-        | CURRENTDATE cdtags datepart stringlist
-                                 {
-                                     if (!parse_script->support.date) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "date");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $2 = canon_dttags($2);
-
-                                     if (!verify_patternlist(parse_script, $4,
-                                                             &($2->comptags),
-                                                             NULL)) {
-                                         YYERROR; /* vp should call yyerror() */
-                                     }
-
-                                     $$ = build_date(CURRENTDATE,
-                                                     $2, NULL, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "currentdate test");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* MARK/UNMARK */
+flagmark: MARK
+        | UNMARK
+        ;
+
+
+/* ADDHEADER tagged arguments */
+ahtags: /* empty */              { $$ = new_command(ADDHEADER, sscript); }
+        | ahtags LAST            {
+                                     if ($$->u.ah.index < 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
                                      }
+
+                                     $$->u.ah.index = -1;
                                  }
+        ;
 
-        | MAILBOXEXISTS stringlist
-                                 {
-                                     if (!parse_script->support.mailbox) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mailbox");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
 
-                                     $$ = build_mailboxtest(MAILBOXEXISTS, NULL,
-                                                            NULL, NULL, $2);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "mailboxexists test");
-                                         YYERROR; /* pe should call yyerror() */
+/* DELETEHEADER tagged arguments */
+dhtags: /* empty */              { $$ = new_command(DELETEHEADER, sscript);}
+        | dhtags { ctags = &($1->u.dh.comp); } matchtype
+        | dhtags { ctags = &($1->u.dh.comp); } listmatch
+        | dhtags { ctags = &($1->u.dh.comp); } comparator
+        | dhtags { ctags = &($1->u.dh.comp); } idxtags
+        ;
+
+
+/* REJECT/EREJECT */
+reject:   REJCT
+        | EREJECT
+        ;
+
+
+/* NOTIFY tagged arguments
+ *
+ * Haven't been able to find a way to split the allowed tags for enotify
+ * and legacy notify without creating a shift/reduce conflict, so we
+ * try to police it during parsing.  Note that this allows :importance
+ * and :low/:normal/:high to be used with the incorrect notify flavor.
+ */
+ntags: /* empty */               { $$ = new_command(ENOTIFY, sscript); }
+
+        /* enotify-only tagged arguments */
+        | ntags FROM string      {
+                                     if ($$->u.n.from != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":from");
+                                         free($$->u.n.from);
                                      }
+
+                                     $$->u.n.from = $3;
                                  }
 
-        | METADATA mtags STRING STRING stringlist
+        | ntags IMPORTANCE priority
                                  {
-                                     if (!parse_script->support.mboxmetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mboxmetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.n.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":importance");
                                      }
 
-                                     $$ = build_mailboxtest(METADATA,
-                                                            $2, $3, $4, $5);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "metadata test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.n.priority = $3;
+                                 }
+        | ntags fcctags
+
+        /* legacy-only tagged arguments */
+        | ntags ID string        {
+                                     if ($$->u.n.id != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":id");
+                                         free($$->u.n.id);
                                      }
+
+                                     $$->u.n.id = $3;
                                  }
+        | ntags METHOD string    {
+                                     if ($$->u.n.method != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":method");
+                                         free($$->u.n.method);
+                                     }
 
-        | METADATAEXISTS STRING stringlist
-                                 {
-                                     if (!parse_script->support.mboxmetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mboxmetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.n.method = $3;
+                                 }
+        | ntags priority         {
+                                     if ($$->u.n.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "priority");
                                      }
 
-                                     $$ = build_mailboxtest(METADATAEXISTS,
-                                                            NULL, $2, NULL, $3);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "metadataexists test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.n.priority = $2;
+                                 }
+
+        /* common tagged arguments */
+        | ntags MESSAGE string   {
+                                     if ($$->u.n.message != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":message");
+                                         free($$->u.n.message);
                                      }
+
+                                     $$->u.n.message = $3;
                                  }
 
-        | SERVERMETADATA mtags STRING stringlist
+        | ntags OPTIONS stringlist
                                  {
-                                     if (!parse_script->support.servermetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "servermetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.n.options != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":options");
+                                         strarray_free($$->u.n.options);
                                      }
 
-                                     $$ = build_mailboxtest(SERVERMETADATA,
-                                                            $2, NULL, $3, $4);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "servermetadata test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.n.options = $3;
+                                 }
+        ;
+
+
+/* priority tag or :importance value */
+priority: LOW
+        | NORMAL
+        | HIGH
+        ;
+
+
+/* DENOTIFY tagged arguments */
+dtags: /* empty */               { $$ = new_command(DENOTIFY, sscript); }
+        | dtags priority         {
+                                     if ($$->u.d.priority != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "priority");
                                      }
+
+                                     $$->u.d.priority = $2;
                                  }
 
-        | SERVERMETADATAEXISTS stringlist
+        | dtags { ctags = &($1->u.d.comp); } matchtype string
                                  {
-                                     if (!parse_script->support.servermetadata) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "servermetadata");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.d.pattern) free($$->u.d.pattern);
+                                     $$->u.d.pattern = $4;
+                                 }
+        ;
+
+
+/* INCLUDE tagged arguments */
+itags: /* empty */               { $$ = new_command(INCLUDE, sscript); }
+        | itags location         {
+                                     if ($$->u.inc.location != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "location");
                                      }
 
-                                     $$ = build_mailboxtest(SERVERMETADATAEXISTS,
-                                                            NULL, NULL, NULL, $2);
-                                     if ($$ == NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_BUILD_FAILURE,
-                                                     "servermetadataexists test");
-                                         YYERROR; /* pe should call yyerror() */
+                                     $$->u.inc.location = $2;
+                                 }
+        | itags ONCE             {
+                                     if ($$->u.inc.once != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":once");
                                      }
+
+                                     $$->u.inc.once = 1;
                                  }
+        | itags OPTIONAL         {
+                                     if ($$->u.inc.optional != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":optional");
+                                     }
 
-        | error                  { $$ = NULL; }
+                                     $$->u.inc.optional = 1;
+                                 }
         ;
 
-atags: /* empty */               { $$ = new_aetags(); }
-        | atags addrparttag
-                                 {
-                                     $$ = $1;
-                                     if ($$->addrtag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "address-part");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->addrtag = $2;
-                                 }
-        | atags matchtags
-        | atags comparator
-        | atags idxtags
+
+/* location tags */
+location: PERSONAL
+        | GLOBAL
         ;
 
-etags: /* empty */               { $$ = new_aetags(); }
-        | etags addrparttag
-                                 {
-                                     $$ = $1;
-                                     if ($$->addrtag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "address-part");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->addrtag = $2;
-                                 }
-        | etags matchtags
-        | etags comparator
-        ;
-
-/* $0 is the symbol which precedes comptags (e.g. aetags).
-   We typecast this pointer into struct comptags *
-*/
-matchtags: match
+
+/* SNOOZE tagged arguments */
+sntags: /* empty */              { $$ = new_command(SNOOZE, sscript); }
+        | sntags MAILBOX string  {
+                                     if ($$->u.sn.mailbox != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":mailbox");
+                                         free($$->u.sn.mailbox);
+                                     }
+
+                                     $$->u.sn.mailbox = $3;
+                                 }
+        | sntags mailboxid       { $$->u.sn.is_mboxid = 1; }
+
+        | sntags ADDFLAGS stringlist
                                  {
-                                     struct comptags *ctags = $<ctag>0;
-                                     if (ctags->match != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "match-type");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.sn.addflags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":addflags");
+                                         free($$->u.sn.addflags);
                                      }
-                                     else ctags->match = $1;
+
+                                     $$->u.sn.addflags = $3;
                                  }
-        | relmatch STRING
+        | sntags REMOVEFLAGS stringlist
                                  {
-                                     struct comptags *ctags = $<ctag>0;
-                                     if (ctags->match != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "match-type");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if ($$->u.sn.removeflags != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":removeflags");
+                                         free($$->u.sn.removeflags);
                                      }
-                                     else {
-                                         ctags->match = $1;
-                                         ctags->relation =
-                                             verify_relat(parse_script, $2);
-                                         if (ctags->relation == -1) {
-                                             YYERROR; /*vr called yyerror()*/
-                                         }
+
+                                     $$->u.sn.removeflags = $3;
+                                 }
+        | sntags WEEKDAYS weekdaylist
+                                 {
+                                     if ($$->u.sn.days != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":weekdays");
                                      }
+
+                                     $$->u.sn.days = $3;
                                  }
         ;
 
-/* $0 is the symbol which precedes comparator (e.g. aetags).
-   We typecast this pointer into struct comptags *
-*/
-comparator: COMPARATOR STRING
-                                 {
-                                     struct comptags *ctags = $<ctag>0;
-                                     if (ctags->comparator != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":comparator");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else if (!strcmp($2, "i;ascii-numeric") &&
-                                              !parse_script->support.i_ascii_numeric) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "comparator-i;ascii-numeric");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else ctags->comparator = $2;
-                                 }
+
+weekdaylist: weekday
+        | '[' weekdays ']'       { $$ = $2; }
         ;
 
-/* $0 is the symbol which precedes idxtags (e.g. aetags).
-   We typecast this pointer into struct comptags *
-
-   Note: This rule forces :index to occur before :last
-   even though RFC 5228 states that tagged arguments can appear in any order.
-*/
-idxtags: INDEX NUMBER
-                                 {
-                                     struct comptags *ctags = $<ctag>0;
-                                     if (!parse_script->support.index) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (ctags->index != 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if ($2 <= 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_INVALID_VALUE,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else ctags->index = $2;
-                                 }
-        | LAST
-                                 { struct comptags *ctags = $<ctag>0;
-                                     if (!parse_script->support.index) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     if (ctags->index == 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_TAG,
-                                                     ":index");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else if (ctags->index < 0) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":last");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else ctags->index *= -1;
-                                 }
+
+weekdays:  weekday
+        | weekdays ',' weekday   { $$ = $1 | $3; }
         ;
 
-htags: /* empty */               { $$ = new_comptags(); }
-        | htags matchtags
-        | htags comparator
-        | htags idxtags
+
+weekday: STRING                  { $$ = verify_weekday(sscript, $1); }
         ;
 
-strtags:/* empty */              { $$ = new_comptags(); }
-        | strtags matchtags
-        | strtags comparator
+
+timelist: time1
+        | '[' times ']'          { $$ = $2; }
         ;
 
-hftags:/* empty */               { $$ = new_comptags(); }
-        | hftags matchtags
-        | hftags comparator
+
+times:  time1
+        | times ',' time         { $$ = $1; arrayu64_add($$, $3); }
         ;
 
-mtags: /* empty */               { $$ = new_comptags(); }
-        | mtags matchtags
-        | mtags comparator
+
+time1: time                      {
+                                     $$ = arrayu64_new();
+                                     arrayu64_add($$, $1);
+                                 }
         ;
 
-btags: /* empty */               { $$ = new_btags(); }
-        | btags RAW
-                                 {
-                                     $$ = $1;
-                                     if ($$->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->transform = RAW;
+
+time: STRING                     { $$ = verify_time(sscript, $1); }
+        ;
+
+
+/*
+ * Test commands
+ */
+testlist: '(' tests ')'          { $$ = $2; }
+        ;
+
+
+tests: test                      { $$ = new_testlist($1, NULL); }
+        | test ',' tests         { $$ = new_testlist($1, $3); }
+        ;
+
+
+test:     ANYOF testlist         { $$ = build_anyof(sscript, $2); }
+        | ALLOF testlist         { $$ = build_allof(sscript, $2); }
+        | NOT test               { $$ = build_not(sscript, $2);   }
+        | SFALSE                 { $$ = new_test(SFALSE, sscript); }
+        | STRUE                  { $$ = new_test(STRUE, sscript);  }
+        | EXISTS stringlist      {
+                                     $$ = new_test(EXISTS, sscript);
+                                     $$->u.sl = $2;
+                                 }
+        | SIZE sizetag NUMBER    {
+                                     $$ = new_test(SIZE, sscript);
+                                     $$->u.sz.t = $2;
+                                     $$->u.sz.n = $3;
                                  }
-        | btags TEXT
+
+        | HEADERT htags stringlist stringlist
+                                 { $$ = build_header(sscript, $2, $3, $4); }
+
+        | ADDRESS atags stringlist stringlist
+                                 { $$ = build_address(sscript, $2, $3, $4); }
+        | ENVELOPE etags stringlist stringlist
+                                 { $$ = build_envelope(sscript, $2, $3, $4); }
+
+        | BODY btags stringlist  { $$ = build_body(sscript, $2, $3); }
+
+        | ENVIRONMENT envtags string stringlist
+                                 { $$ = build_mbox_meta(sscript,
+                                                        $2, NULL, $3, $4); }
+
+        | STRINGT strtags stringlist stringlist
+                                 { $$ = build_stringt(sscript, $2, $3, $4); }
+
+        /* Per RFC 5232, the variables list (penultimate argument) is optional,
+         * but defining the grammar this way results in a shift/reduce conflict.
+         * Therefore, we have to flatten the grammar into two rules.
+        */
+        | HASFLAG hftags stringlist stringlist
+                                 { $$ = build_hasflag(sscript, $2, $3, $4); }
+        | HASFLAG hftags stringlist
+                                 { $$ = build_hasflag(sscript, $2, NULL, $3); }
+
+        /* getdatepart variable is used to change the start state of the lexer */
+        | DATE dttags string { getdatepart = 1; } datepart stringlist
+                                 { $$ = build_date(sscript, $2, $3, $5, $6); }
+
+        | CURRENTDATE cdtags datepart stringlist
+                                 { $$ = build_date(sscript, $2, NULL, $3, $4); }
+        | VALIDNOTIFYMETHOD stringlist
                                  {
-                                     $$ = $1;
-                                     if ($$->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->transform = TEXT;
+                                     $$ = new_test(VALIDNOTIFYMETHOD, sscript);
+                                     $$->u.sl = $2;
                                  }
-        | btags CONTENT stringlist
+        | NOTIFYMETHODCAPABILITY methtags string string stringlist
+                                 { $$ = build_mbox_meta(sscript,
+                                                        $2, $3, $4, $5); }
+
+        | IHAVE stringlist       { $$ = build_ihave(sscript, $2); }
+
+        | MAILBOXEXISTS stringlist
                                  {
-                                     $$ = $1;
-                                     if ($$->transform != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     "transform");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else {
-                                         $$->transform = CONTENT;
-                                         $$->content_types = $3;
-                                     }
+                                     $$ = new_test(MAILBOXEXISTS, sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, NULL, NULL, $2);
                                  }
-        | btags matchtags
-        | btags comparator
-        ;
 
-dttags: /* empty */              { $$ = new_dttags(); }
-        | dttags ORIGINALZONE
+        | METADATA mtags string string stringlist
+                                 { $$ = build_mbox_meta(sscript,
+                                                        $2, $3, $4, $5); }
+
+        | METADATAEXISTS string stringlist
                                  {
-                                     $$ = $1;
-                                     if ($$->zonetag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":originalzone");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->zonetag = ORIGINALZONE;
+                                     $$ = new_test(METADATAEXISTS, sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, $2, NULL, $3);
                                  }
-        | dttags zone
-        | dttags matchtags
-        | dttags comparator
-        | dttags idxtags
-        ;
 
-cdtags: /* empty */              { $$ = new_dttags(); }
-        | cdtags zone
-        | cdtags matchtags
-        | cdtags comparator
-        ;
+        | SERVERMETADATA mtags string stringlist
+                                 { $$ = build_mbox_meta(sscript,
+                                                        $2, NULL, $3, $4); }
 
-/* $0 is the symbol which precedes zone (e.g. dttags).
-   We typecast this pointer into struct comptags *
-*/
-zone: ZONE STRING
+        | SERVERMETADATAEXISTS stringlist
                                  {
-                                     struct dttags *dttags = $<dttag>0;
-                                     if (dttags->zonetag != -1) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":zone");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else if (verify_zone(parse_script, $2) == -1) {
-                                         YYERROR; /*vr called yyerror()*/
-                                     }
-                                     else {
-                                         dttags->zone = $2;
-                                         dttags->zonetag = ZONE;
-                                     }
+                                     $$ = new_test(SERVERMETADATAEXISTS,
+                                                   sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, NULL, NULL, $2);
                                  }
-        ;
 
-datepart: STRING
+        | VALIDEXTLIST stringlist
                                  {
-                                     $$ = verify_date_part(parse_script, $1);
-                                     if ($$ == -1) {
-                                         YYERROR; /* vdp called yyerror() */
-                                     }
+                                     $$ = new_test(VALIDEXTLIST, sscript);
+                                     $$->u.sl = $2;
+                                 }
+        | DUPLICATE duptags      { $$ = build_duplicate(sscript, $2); }
+
+        | SPECIALUSEEXISTS stringlist
+                                 { 
+                                     $$ = new_test(SPECIALUSEEXISTS, sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, NULL, NULL, $2);
                                  }
-        ;
 
-addrparttag: ALL                 { $$ = ALL; }
-        | LOCALPART              { $$ = LOCALPART; }
-        | DOMAIN                 { $$ = DOMAIN; }
-        | USER
+        | SPECIALUSEEXISTS string stringlist
                                  {
-                                     if (!parse_script->support.subaddress) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "subaddress");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = USER;
+                                     $$ = new_test(SPECIALUSEEXISTS, sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, $2, NULL, $3);
                                  }
-        | DETAIL
+
+        | MAILBOXIDEXISTS stringlist
                                  {
-                                     if (!parse_script->support.subaddress) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "subaddress");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = DETAIL;
+                                     $$ = new_test(MAILBOXIDEXISTS, sscript);
+                                     $$ = build_mbox_meta(sscript,
+                                                          $$, NULL, NULL, $2);
+                                 }
+
+        | JMAPQUERY string       {
+                                     $$ = new_test(JMAPQUERY, sscript);
+                                     $$ = build_jmapquery(sscript, $$, $2);
                                  }
+
+        | error                  { $$ = new_test(SFALSE, sscript); }
+        ;
+
+
+/* SIZE tagged arguments */
+sizetag:  OVER
+        | UNDER
         ;
-match: IS                        { $$ = IS; }
-        | CONTAINS               { $$ = CONTAINS; }
-        | MATCHES                { $$ = MATCHES; }
-        | REGEX
+
+
+/* HEADER tagged arguments */
+htags: /* empty */               { $$ = new_test(HEADERT, sscript); }
+        | htags { ctags = &($1->u.hhs.comp); } matchtype
+        | htags { ctags = &($1->u.hhs.comp); } listmatch
+        | htags { ctags = &($1->u.hhs.comp); } comparator
+        | htags { ctags = &($1->u.hhs.comp); } idxtags
+        ;
+
+
+/* All match-types except for :list */
+matchtype: matchtag              {
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
+                                     }
+
+                                     ctags->match = $1;
+                                 }
+        | relmatch relation
                                  {
-                                     if (!parse_script->support.regex) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "regex");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (ctags->match != COUNT &&
+                                         ctags->match != VALUE &&
+                                         !supported(SIEVE_CAPA_RELATIONAL)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "relational");
+                                     }
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
                                      }
-                                     $$ = REGEX;
+
+                                     ctags->match = $1;
+                                     ctags->relation = $2;
                                  }
         ;
 
-relmatch: COUNT
-                                 {
-                                     if (!parse_script->support.relational) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "relational");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* match-type tags */
+matchtag: IS
+        | CONTAINS
+        | MATCHES
+        | REGEX                  {
+                                     if (!supported(SIEVE_CAPA_REGEX)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "regex");
                                      }
-                                     $$ = COUNT;
                                  }
+        ;
+
+
+/* Relational match-type tags */
+relmatch: COUNT
         | VALUE
-                                 {
-                                     if (!parse_script->support.relational) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "relational");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     $$ = VALUE;
-                                 }
         ;
 
 
-sizetag: OVER                    { $$ = OVER; }
-        | UNDER                  { $$ = UNDER; }
+/* relational-match */
+relation: EQ
+        | NE
+        | GT
+        | GE
+        | LT
+        | LE
         ;
 
-copy: COPY
-                                 {
-                                     if (!parse_script->support.copy) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "copy");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* :list match-type */
+listmatch: LIST                  {
+                                     if (ctags->match != LIST &&
+                                         !supported(SIEVE_CAPA_EXTLISTS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "extlists");
                                      }
-                                     $$ = 1;
+                                     if (ctags->match != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "match-type");
+                                     }
+
+                                     ctags->match = LIST;
                                  }
         ;
 
-creat:  CREATE
+
+/* :comparator */
+comparator: COMPARATOR collation
                                  {
-                                     if (!parse_script->support.mailbox) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "mailbox");
-                                         YYERROR; /* pe should call yyerror() */
+                                     if (ctags->collation != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":comparator");
                                      }
-                                     $$ = 1;
+
+                                     ctags->collation = $2;
                                  }
         ;
 
-ftags: /* empty */               { $$ = new_ftags(); }
-        | ftags copy
-                                 {
-                                     $$ = $1;
-                                     if ($$->copy) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":copy");
-                                         YYERROR; /* pe should call yyerror() */
-                                     }
-                                     else $$->copy = $2;
-                                 }
-        | ftags creat
-                                 {
-                                     $$ = $1;
-                                     if ($$->create) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":create");
-                                         YYERROR; /* pe should call yyerror() */
+
+/* comparator-types */
+collation: OCTET
+        | ASCIICASEMAP
+        | ASCIINUMERIC           {
+                                     if (!supported(SIEVE_CAPA_COMP_NUMERIC)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "comparator-"
+                                                      "i;ascii-numeric");
                                      }
-                                     else $$->create = $2;
                                  }
-        | ftags FLAGS stringlist
-                                 {
-                                     if (!parse_script->support.imap4flags) {
-                                         parse_error(parse_script,
-                                                     SIEVE_MISSING_REQUIRE,
-                                                     "imap4flags");
-                                         YYERROR; /* pe should call yyerror() */
+        ;
+
+
+/* Index tags */
+idxtags: INDEX NUMBER            {
+                                     if (ctags->index == INT_MIN) {
+                                         /* :last before :index */
+                                         ctags->index = -$2;
                                      }
-                                     if ($$->flags != NULL) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":flags");
-                                         YYERROR; /* pe should call yyerror() */
+                                     else if (ctags->index != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":index");
                                      }
+                                     else {
+                                       if (!supported(SIEVE_CAPA_INDEX)) {
+                                             sieveerror_c(sscript,
+                                                          SIEVE_MISSING_REQUIRE,
+                                                          "index");
+                                         }
 
-                                     $$ = $1;
-                                     if (!parse_script->support.variables) {
-                                         verify_flaglist($3);
+                                         ctags->index = $2;
                                      }
-                                     if (!$3->count) strarray_add($3, "");
-                                     $$->flags = $3;
                                  }
-        ;
+        | LAST                   {
+                                     if (ctags->index > 0) {
+                                         ctags->index *= -1;
+                                     }
+                                     else if (ctags->index < 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
+                                     }
+                                     else if (ctags->index == 0) {
+                                       if (!supported(SIEVE_CAPA_INDEX)) {
+                                             sieveerror_c(sscript,
+                                                          SIEVE_MISSING_REQUIRE,
+                                                          "index");
+                                         }
 
-rtags: /* empty */               { $$ = 0; }
-        | rtags copy
-                                 {
-                                     $$ = $1;
-                                     if ($$) {
-                                         parse_error(parse_script,
-                                                     SIEVE_DUPLICATE_TAG,
-                                                     ":copy");
-                                         YYERROR; /* pe should call yyerror() */
+                                         /* :last before :index */
+                                         ctags->index = INT_MIN;
                                      }
-                                     else $$ = $2;
                                  }
         ;
 
-testlist: '(' tests ')'          { $$ = $2; }
-        ;
 
-tests: test                      { $$ = new_testlist($1, NULL); }
-        | test ',' tests         { $$ = new_testlist($1, $3); }
+/* ADDRESS tagged arguments */
+atags: /* empty */               { $$ = new_test(ADDRESS, sscript); }
+        | atags addrpart
+        | atags { ctags = &($1->u.ae.comp); } matchtype
+        | atags { ctags = &($1->u.ae.comp); } listmatch
+        | atags { ctags = &($1->u.ae.comp); } comparator
+        | atags { ctags = &($1->u.ae.comp); } idxtags
         ;
 
-%%
 
+/* address-part */
+addrpart: addrparttag           {
+                                     /* $0 refers to a test_t* (ADDR/ENV)*/
+                                     test_t *test = $<test>0;
 
-/*
- * Actions
- */
+                                     if (test->u.ae.addrpart != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "address-part");
+                                     }
 
-void yyerror(sieve_script_t *parse_script, const char *msg)
-{
-    parse_script->err++;
-    if (parse_script->interp.err) {
-        parse_script->interp.err(sievelineno, msg,
-                                 parse_script->interp.interp_context,
-                                 parse_script->script_context);
-    }
-}
+                                     test->u.ae.addrpart = $1;
+                                 }
 
-static void parse_error(sieve_script_t *parse_script, int err, ...)
-{
-    va_list args;
 
-    va_start(args, err);
-    vsnprintf(parse_script->sieveerr, ERR_BUF_SIZE, error_message(err), args);
-    yyerror(parse_script, parse_script->sieveerr);
-    va_end(args);
-}
+/* address-part tags */
+addrparttag: ALL
+        | LOCALPART
+        | DOMAIN
+        | subaddress             {
+                                     if (!supported(SIEVE_CAPA_SUBADDRESS)) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_MISSING_REQUIRE,
+                                                      "subaddress");
+                                     }
+                                 }
+        ;
 
-static char *check_reqs(sieve_script_t *parse_script, strarray_t *sa)
-{
-    char *s;
-    struct buf errs = BUF_INITIALIZER;
-    char *res;
 
-    while ((s = strarray_shift(sa))) {
-        if (!script_require(parse_script, s)) {
-            if (!errs.len)
-                buf_printf(&errs,
-                           "Unsupported feature(s) in \"require\": \"%s\"", s);
-            else buf_printf(&errs, ", \"%s\"", s);
-        }
-        free(s);
-    }
-    strarray_free(sa);
+/* subaddress-part tags */
+subaddress: USER
+        | DETAIL
+        ;
 
-    res = buf_release(&errs);
-    if (!res[0]) {
-        free(res);
-        return NULL;
-    }
 
-    return res;
-}
+/* ENVELOPE tagged arguments */
+etags: /* empty */               { $$ = new_test(ENVELOPE, sscript); }
+        | etags addrpart
+        | etags { ctags = &($1->u.ae.comp); } matchtype
+        | etags { ctags = &($1->u.ae.comp); } listmatch
+        | etags { ctags = &($1->u.ae.comp); } comparator
+        ;
 
-static test_t *build_address(int t, struct aetags *ae,
-                             strarray_t *sl, strarray_t *pl)
-{
-    test_t *ret = new_test(t);  /* can be either ADDRESS or ENVELOPE */
 
-    assert((t == ADDRESS) || (t == ENVELOPE));
+/* ENVIRONMENT tagged arguments */
+envtags: /* empty */               { $$ = new_test(ENVIRONMENT, sscript); }
+        | envtags { ctags = &($1->u.mm.comp); } matchtype
+        | envtags { ctags = &($1->u.mm.comp); } comparator
+        ;
 
-    if (ret) {
-        ret->u.ae.comptag = ae->comptags.match;
-        ret->u.ae.relation=ae->comptags.relation;
-        ret->u.ae.comparator=xstrdup(ae->comptags.comparator);
-        ret->u.ae.index = ae->comptags.index;
-        ret->u.ae.sl = sl;
-        ret->u.ae.pl = pl;
-        ret->u.ae.addrpart = ae->addrtag;
-        free_aetags(ae);
 
-    }
-    return ret;
-}
+/* BODY tagged arguments */
+btags: /* empty */               { $$ = new_test(BODY, sscript); }
+        | btags transform        {
+                                     if ($$->u.b.transform != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "transform");
+                                     }
 
-static test_t *build_header(int t, struct comptags *c,
-                            strarray_t *sl, strarray_t *pl)
-{
-    test_t *ret = new_test(t);  /* can be HEADER or HASFLAG or STRINGT */
+                                     $$->u.b.transform = $2;
+                                 }
 
-    assert((t == HEADER) || (t == HASFLAG) || (t == STRINGT));
+        | btags CONTENT stringlist
+                                 {
+                                     if ($$->u.b.transform != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      "transform");
+                                         strarray_free($$->u.b.content_types);
+                                     }
 
-    if (ret) {
-        ret->u.h.comptag = c->match;
-        ret->u.h.relation = c->relation;
-        ret->u.h.comparator = xstrdup(c->comparator);
-        ret->u.h.index = c->index;
-        ret->u.h.sl = sl;
-        ret->u.h.pl = pl;
-        free_comptags(c, 1);
-    }
-    return ret;
-}
+                                     $$->u.b.transform = CONTENT;
+                                     $$->u.b.content_types = $3;
+                                 }
 
-static test_t *build_body(int t, struct btags *b, strarray_t *pl)
-{
-    test_t *ret = new_test(t);  /* can be BODY */
+        | btags { ctags = &($1->u.b.comp); } matchtype
+        | btags { ctags = &($1->u.b.comp); } comparator
+        ;
 
-    assert(t == BODY);
 
-    if (ret) {
-        ret->u.b.comptag = b->comptags.match;
-        ret->u.b.relation = b->comptags.relation;
-        ret->u.b.comparator = xstrdup(b->comptags.comparator);
-        ret->u.b.transform = b->transform;
-        ret->u.b.offset = b->offset;
-        ret->u.b.content_types = b->content_types; b->content_types = NULL;
-        ret->u.b.pl = pl;
-        free_btags(b);
-    }
-    return ret;
-}
+/* body-transform tags */
+transform: RAW
+        | TEXT
+        ;
 
-static test_t *build_mailboxtest(int t, struct comptags *c,
-                                 const char *extname, const char *keyname,
-                                 strarray_t *keylist)
-{
-    test_t *ret = new_test(t);
-
-    if (ret) {
-        ret->u.mbx.extname = xstrdupnull(extname);
-        ret->u.mbx.keyname = xstrdupnull(keyname);
-        ret->u.mbx.keylist = keylist;
-        if (c) {
-            canon_comptags(c);
-            ret->u.mbx.comptag = c->match;
-            ret->u.mbx.relation = c->relation;
-            ret->u.mbx.comparator = xstrdup(c->comparator);
-            free_comptags(c, 1);
-        }
-    }
 
-    return ret;
-}
+/* STRING tagged arguments */
+strtags: /* empty */             { $$ = new_test(STRINGT, sscript); }
+        | strtags { ctags = &($1->u.hhs.comp); } matchtype
+        | strtags { ctags = &($1->u.hhs.comp); } listmatch
+        | strtags { ctags = &($1->u.hhs.comp); } comparator
+        ;
 
-static commandlist_t *build_vacation(int t, struct vtags *v, char *reason)
-{
-    commandlist_t *ret = new_command(t);
 
-    assert(t == VACATION);
+/* HASFLAG tagged arguments */
+hftags: /* empty */              { $$ = new_test(HASFLAG, sscript); }
+        | hftags { ctags = &($1->u.hhs.comp); } matchtype
+        | hftags { ctags = &($1->u.hhs.comp); } comparator
+        ;
 
-    if (ret) {
-        ret->u.v.subject = v->subject; v->subject = NULL;
-        ret->u.v.from = v->from; v->from = NULL;
-        ret->u.v.handle = v->handle; v->handle = NULL;
-        ret->u.v.seconds = v->seconds;
-        ret->u.v.mime = v->mime;
-        ret->u.v.addresses = v->addresses; v->addresses = NULL;
-        free_vtags(v);
-        ret->u.v.message = reason;
-    }
-    return ret;
-}
 
-static commandlist_t *build_notify(int t, struct ntags *n)
-{
-    commandlist_t *ret = new_command(t);
+/* DATE tagged arguments */
+dttags: /* empty */              { $$ = new_test(DATE, sscript); }
+        | dttags zone
+        | dttags ORIGINALZONE    {
+                                     if ($$->u.dt.zonetag != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":originalzone");
+                                     }
+
+                                     $$->u.dt.zonetag = ORIGINALZONE;
+                                 }
+        | dttags { ctags = &($1->u.dt.comp); } matchtype
+        | dttags { ctags = &($1->u.dt.comp); } comparator
+        | dttags { ctags = &($1->u.dt.comp); } idxtags
+        ;
+
+
+/* :zone */
+zone: ZONE TIMEZONE              {
+                                     /* $0 refers to a test_t* ([CURRENT]DATE)*/
+                                     test_t *test = $<test>0;
+
+                                     if (test->u.dt.zonetag != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":zone");
+                                     }
+
+                                     test->u.dt.zonetag = ZONE;
+                                     test->u.dt.zone = $2;
+                                 }
+        ;
+
+
+/* CURRENTDATE tagged arguments */
+cdtags: /* empty */              { $$ = new_test(CURRENTDATE, sscript); }
+        | cdtags zone
+        | cdtags { ctags = &($1->u.dt.comp); } matchtype
+        | cdtags { ctags = &($1->u.dt.comp); } comparator
+        ;
+
+
+/* date-parts */
+datepart: YEARP
+        | MONTHP
+        | DAYP
+        | DATEP
+        | JULIAN
+        | HOURP
+        | MINUTEP
+        | SECONDP
+        | TIMEP
+        | ISO8601
+        | STD11
+        | ZONEP
+        | WEEKDAYP
+        ;
+
+
+/* NOTIFYMETHODCAPABILITY tagged arguments */
+methtags: /* empty */            { $$ = new_test(NOTIFYMETHODCAPABILITY, sscript); }
+        | methtags { ctags = &($1->u.mm.comp); } matchtype
+        | methtags { ctags = &($1->u.mm.comp); } comparator
+        ;
+
+
+/* [SERVER]METADATA tagged arguments - $0 refers to [SERVER]METADATA */
+mtags: /* empty */               { $$ = new_test($<nval>0, sscript); }
+        | mtags { ctags = &($1->u.mm.comp); } matchtype
+        | mtags { ctags = &($1->u.mm.comp); } comparator
+        ;
+
+
+/* DUPLICATE tagged arguments */
+duptags: /* empty */             { $$ = new_test(DUPLICATE, sscript); }
+        | duptags idtype string  {
+                                     if ($$->u.dup.idtype != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      $2 == HEADER ?
+                                                      ":header" : ":uniqueid");
+                                         free($$->u.dup.idval);
+                                     }
+
+                                     $$->u.dup.idtype = $2;
+                                     $$->u.dup.idval = $3;
+                                 }
+        | duptags HANDLE string  {
+                                     if ($$->u.dup.handle != NULL) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":handle");
+                                         free($$->u.dup.handle);
+                                     }
+
+                                     $$->u.dup.handle = $3;
+                                 }
+        | duptags SECONDS NUMBER {
+                                     if ($$->u.dup.seconds != -1) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":seconds");
+                                     }
+
+                                     $$->u.dup.seconds = $3;
+                                 }
+        | duptags LAST           {
+                                     if ($$->u.dup.last != 0) {
+                                         sieveerror_c(sscript,
+                                                      SIEVE_DUPLICATE_TAG,
+                                                      ":last");
+                                     }
+
+                                     $$->u.dup.last = 1;
+                                 }
+        ;
+
+
+/* DUPLICATE idtypes */
+idtype:   HEADER
+        | UNIQUEID
+        ;
+
+
+%%
+
+
+/*
+ * Yacc actions
+ */
 
-    assert(t == NOTIFY);
-       if (ret) {
-        ret->u.n.method = n->method; n->method = NULL;
-        ret->u.n.id = n->id; n->id = NULL;
-        ret->u.n.options = n->options; n->options = NULL;
-        ret->u.n.priority = n->priority;
-        ret->u.n.message = n->message; n->message = NULL;
-        free_ntags(n);
+void yyerror(sieve_script_t *sscript, const char *msg)
+{
+    if (sscript->ignore_err) return;
+
+    sscript->err++;
+    if (sscript->interp.err) {
+        sscript->interp.err(sievelineno, msg, sscript->interp.interp_context,
+                            sscript->script_context);
     }
-    return ret;
 }
 
-static commandlist_t *build_denotify(int t, struct dtags *d)
+
+static void
+__attribute__((format(printf, 2, 0)))
+vsieveerror_f(sieve_script_t *sscript,
+              const char *fmt, va_list args)
 {
-    commandlist_t *ret = new_command(t);
+    buf_reset(&sscript->sieveerr);
+    buf_vprintf(&sscript->sieveerr, fmt, args);
+    yyerror(sscript, buf_cstring(&sscript->sieveerr));
+}
 
-    assert(t == DENOTIFY);
+void
+__attribute__((format(printf, 2, 3)))
+sieveerror_f(sieve_script_t *sscript, const char *fmt, ...)
+{
+    va_list args;
 
-    if (ret) {
-        ret->u.d.comptag = d->comptags.match;
-        ret->u.d.relation = d->comptags.relation;
-        ret->u.d.pattern = xstrdupnull(d->pattern);
-        ret->u.d.priority = d->priority;
-        free_dtags(d);
-    }
-    return ret;
+    va_start(args, fmt);
+    vsieveerror_f(sscript, fmt, args);
+    va_end(args);
 }
 
-static commandlist_t *build_keep(int t, struct ftags *f)
+void sieveerror_c(sieve_script_t *sscript, int code, ...)
 {
-    commandlist_t *ret = new_command(t);
+    va_list args;
 
-    assert(t == KEEP);
+    va_start(args, code);
+    vsieveerror_f(sscript, error_message(code), args);
+    va_end(args);
+}
 
-    if (ret) {
-        ret->u.k.copy = f->copy;
-        ret->u.k.flags = f->flags; f->flags = NULL;
-        free_ftags(f);
+/*
+ * variable-ref        =  "${" [namespace] variable-name "}"
+ * namespace           =  identifier "." *sub-namespace
+ * sub-namespace       =  variable-name "."
+ * variable-name       =  num-variable / identifier
+ * num-variable        =  1*DIGIT
+ * identifier          =  (ALPHA / "_") *(ALPHA / DIGIT / "_")
+ */
+static int find_variables(sieve_script_t *sscript, char *s, int find_one)
+{
+    char *p = s;
+
+    if (!supported(SIEVE_CAPA_VARIABLES)) return !find_one;
+
+    while ((p = strstr(p, "${"))) {
+        long num = 0, is_id = 0;
+
+        p += 2;  /* skip over beginning of variable-ref */
+
+        do {
+            if (isdigit(*p)) {
+                /* possible num-variable - get value and skip over digits */
+                num = strtol(p, &p, 10);
+            }
+            else if (!find_one) {
+                /* validating match variables - ignoroe identifiers */
+                break;
+            }
+            else if (isalpha(*p) || *p == '_') {
+                /* possible identifier - skip over identifier chars */
+                for (++p; isalnum(*p) || *p == '_'; p++);
+                is_id = 1;
+            }
+            else {
+                /* not a valid variable-name */
+                break;
+            }
+
+            if (*p == '}') {
+                /* end of variable-ref */
+                if (find_one) return 1;
+
+                /* validating match variables */
+                if (!is_id && num > MAX_MATCH_VARS) {
+                    sieveerror_f(sscript, "string '%s':"
+                                 " match variable index > %u unsupported",
+                                 s, MAX_MATCH_VARS);
+                    return 0;
+                }
+            }
+
+        } while (is_id && *p == '.' && *(++p));  /* (sub-)namespace */
     }
-    return ret;
+
+    return !find_one;
 }
 
-static commandlist_t *build_fileinto(int t, struct ftags *f, char *folder)
+static int chk_match_vars(sieve_script_t *sscript, char *s)
 {
-    commandlist_t *ret = new_command(t);
+    return find_variables(sscript, s, 0 /* find_one */);
+}
 
-    assert(t == FILEINTO);
+static int contains_variable(sieve_script_t *sscript, char *s)
+{
+    return find_variables(sscript, s, 1 /* find_one */);
+}
 
-    if (ret) {
-        ret->u.f.copy = f->copy;
-        ret->u.f.create = f->create;
-        ret->u.f.flags = f->flags; f->flags = NULL;
-        if (config_getswitch(IMAPOPT_SIEVE_UTF8FILEINTO)) {
-            ret->u.f.folder = xmalloc(5 * strlen(folder) + 1);
-            UTF8_to_mUTF7(ret->u.f.folder, folder);
+/*
+ * Valid UTF-8 check (from RFC 2640 Annex B.1)
+ *
+ * The following routine checks if a byte sequence is valid UTF-8. This
+ * is done by checking for the proper tagging of the first and following
+ * bytes to make sure they conform to the UTF-8 format. It then checks
+ * to assure that the data part of the UTF-8 sequence conforms to the
+ * proper range allowed by the encoding. Note: This routine will not
+ * detect characters that have not been assigned and therefore do not
+ * exist.
+ */
+static int verify_utf8(sieve_script_t *sscript, char *s)
+{
+    const char *buf = s;
+    const char *endbuf = s + strlen(s);
+    unsigned char byte2mask = 0x00, c;
+    int trailing = 0;  /* trailing (continuation) bytes to follow */
+
+    while (buf != endbuf) {
+        c = *buf++;
+        if (trailing) {
+            if ((c & 0xC0) == 0x80) {           /* Does trailing byte
+                                                   follow UTF-8 format? */
+                if (byte2mask) {                /* Need to check 2nd byte
+                                                   for proper range? */
+                    if (c & byte2mask)          /* Are appropriate bits set? */
+                        byte2mask = 0x00;
+                    else
+                        break;
+                }
+                trailing--;
+            }
+            else
+                break;
         }
         else {
-            ret->u.f.folder = xstrdup(folder);
+            if ((c & 0x80) == 0x00)             /* valid 1 byte UTF-8 */
+                continue;
+            else if ((c & 0xE0) == 0xC0)        /* valid 2 byte UTF-8 */
+                if (c & 0x1E) {                 /* Is UTF-8 byte
+                                                   in proper range? */
+                    trailing = 1;
+                }
+                else
+                    break;
+            else if ((c & 0xF0) == 0xE0) {      /* valid 3 byte UTF-8 */
+                if (!(c & 0x0F)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x20;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 2;
+            }
+            else if ((c & 0xF8) == 0xF0) {      /* valid 4 byte UTF-8 */
+                if (!(c & 0x07)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x30;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 3;
+            }
+            else if ((c & 0xFC) == 0xF8) {      /* valid 5 byte UTF-8 */
+                if (!(c & 0x03)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x38;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 4;
+            }
+            else if ((c & 0xFE) == 0xFC) {      /* valid 6 byte UTF-8 */
+                if (!(c & 0x01)) {              /* Is UTF-8 byte
+                                                   in proper range? */
+                    byte2mask = 0x3C;           /* If not, set mask
+                                                   to check next byte */
+                }
+                trailing = 5;
+            }
+            else
+                break;
         }
-        free_ftags(f);
     }
-    return ret;
+
+    if ((buf != endbuf) || trailing) {
+        sieveerror_f(sscript, "string '%s': not valid utf8", s);
+        return 0;
+    }
+
+    return 1;
 }
 
-static commandlist_t *build_redirect(int t, int copy, char *address)
+static int verify_stringlist(sieve_script_t *sscript, strarray_t *sa,
+                             int (*verify)(sieve_script_t*, char *))
 {
-    commandlist_t *ret = new_command(t);
+    int i;
 
-    assert(t == REDIRECT);
+    for (i = 0 ; i < strarray_size(sa) ; i++) {
+        if (!verify(sscript, (char *) strarray_nth(sa, i))) return 0;
+    }
+    return 1;
+}
 
-    if (ret) {
-        ret->u.r.copy = copy;
-        ret->u.r.address = address;
+#ifdef ENABLE_REGEX
+static int verify_regexlist(sieve_script_t *sscript,
+                            const strarray_t *sa, int collation)
+{
+    int i, ret = 0;
+    regex_t reg;
+    int cflags = REG_EXTENDED | REG_NOSUB;
+
+#ifdef HAVE_PCREPOSIX_H
+    /* support UTF8 comparisons */
+    cflags |= REG_UTF8;
+#endif
+
+    if (collation == ASCIICASEMAP) {
+        cflags |= REG_ICASE;
     }
-    return ret;
+
+    for (i = 0 ; !ret && i < strarray_size(sa) ; i++) {
+        const char *s = strarray_nth(sa, i);
+
+        /* Don't try to validate a regex that includes variables */
+        if (supported(SIEVE_CAPA_VARIABLES) && strstr(s, "${")) continue;
+
+        /* Check if the regex will compile */
+        if ((ret = regcomp(&reg, s, cflags)) != 0) {
+            size_t errbuf_size = regerror(ret, &reg, NULL, 0);
+
+            buf_reset(&sscript->sieveerr);
+            buf_ensure(&sscript->sieveerr, errbuf_size);
+            (void) regerror(ret, &reg,
+                            (char *) buf_base(&sscript->sieveerr),
+                            errbuf_size);
+            buf_truncate(&sscript->sieveerr, errbuf_size);
+            yyerror(sscript, buf_cstring(&sscript->sieveerr));
+        }
+
+        regfree(&reg);
+    }
+
+    return (ret == 0);
 }
+#else
 
-static commandlist_t *build_include(int t, struct itags *i, char* script)
+static int verify_regexlist(sieve_script_t *sscript __attribute__((unused)),
+                            const strarray_t *sa __attribute__((unused)),
+                            char *comp __attribute__((unused)))
 {
-    commandlist_t *ret = new_command(t);
+    return 0;
+}
+#endif /* ENABLE_REGEX */
 
-    assert(t == INCLUDE);
+static int verify_patternlist(sieve_script_t *sscript,
+                              strarray_t *sa, comp_t *c,
+                              int (*verify)(sieve_script_t*, char *))
+{
+    if (verify && !verify_stringlist(sscript, sa, verify)) return 0;
 
-    if (i->location == -1) i->location = PERSONAL;
-    if (i->once == -1) i->once = 0;
-    if (i->optional == -1) i->optional = 0;
-
-    if (ret) {
-        ret->u.inc.location = i->location;
-        ret->u.inc.once = i->once;
-        ret->u.inc.optional = i->optional;
-        ret->u.inc.script = script;
-        free(i);
+    canon_comptags(c, sscript);
+
+    return (c->match == REGEX) ?
+        verify_regexlist(sscript, sa, c->collation) : 1;
+}
+
+static int verify_address(sieve_script_t *sscript, char *s)
+{
+    if (contains_variable(sscript, s)) return 1;
+
+    YY_BUFFER_STATE buffer = addr_scan_string(s);
+    int r = 1;
+
+    sscript->addrerr[0] = '\0';    /* paranoia */
+    if (addrparse(sscript)) {
+        sieveerror_f(sscript, "address '%s': %s", s, sscript->addrerr);
+        r = 0;
     }
-    return ret;
+    addr_delete_buffer(buffer);
+
+    return r;
 }
 
-static test_t *build_date(int t, struct dttags *dt,
-                          char *hn, int part, strarray_t *kl)
+static int verify_mailbox(sieve_script_t *sscript, char *s)
 {
-    test_t *ret = new_test(t);
-    assert(t == DATE || t == CURRENTDATE);
+    if (!verify_utf8(sscript, s)) {
+        sieveerror_f(sscript, "mailbox '%s': not a valid mailbox", s);
+        return 0;
+    }
+
+    return 1;
+}
+
+static int verify_headername(sieve_script_t *sscript, char *hdr)
+{
+    char *h = hdr;
 
-    if (ret) {
-        ret->u.dt.comptag = dt->comptags.match;
-        ret->u.dt.relation = dt->comptags.relation;
-        ret->u.dt.comparator = xstrdup(dt->comptags.comparator);
-        ret->u.dt.index = dt->comptags.index;
-        ret->u.dt.zone = xstrdupnull(dt->zone);
-        ret->u.dt.zonetag = dt->zonetag;
-        ret->u.dt.date_part = part;
-        ret->u.dt.header_name = xstrdupnull(hn);
-        ret->u.dt.kl = kl;
-        free_dttags(dt);
+    while (*h) {
+        /*
+           field-name      =       1*ftext
+           ftext           =       %d33-57 / %d59-126
+           ; Any character except
+           ;  controls, SP, and
+           ;  ":".
+        */
+        if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
+            sieveerror_f(sscript, "header field name '%s':"
+                         " not a valid header field name"
+                         " per RFC 5322, Section 3.6.8", hdr);
+            return 0;
+        }
+        h++;
     }
-    return ret;
+    return 1;
+}
+
+static int verify_headerbody(sieve_script_t *sscript, char *val)
+{
+    char *v = val + strlen(val);
+
+    /* trim any trailing CR/LF */
+    while (--v >= val && (*v == '\r' || *v == '\n')) {
+        *v = '\0';
+    }
+
+    /* make sure any other CRLF is folding whitespace */
+    for (v = val; *v; v++) {
+        if (*v == '\r' && *++v != '\n') break;
+        if (*v == '\n' && *++v != ' ' && *v != '\t') break;
+    }
+    if (*v != '\0') {
+        sieveerror_f(sscript, "header field body '%s':"
+                     " not a valid header field body"
+                     " per RFC 5322, Section 3.2.5", val);
+        return 0;
+    }
+
+    return verify_utf8(sscript, val);
 }
 
-static commandlist_t *build_set(int t, struct stags *s,
-                                char *variable, char *value)
+static int verify_addrheader(sieve_script_t *sscript, char *hdr)
 {
-    commandlist_t *ret = new_command(t);
+    const char **h, *hdrs[] = {
+        "from", "sender", "reply-to",   /* RFC5322 originator fields */
+        "to", "cc", "bcc",              /* RFC5322 destination fields */
+        "message-id", "in-reply-to",    /* RFC5322 identification fields */
+        "references"
+        "resent-from", "resent-sender", /* RFC5322 resent fields */
+        "resent-to", "resent-cc", "resent-bcc",
+        "return-path",                  /* RFC5322 trace fields */
+        "disposition-notification-to",  /* RFC8098 MDN request fields */
+        "approved",                     /* RFC5536 moderator/control fields */
+        "delivered-to",                 /* non-standard (loop detection) */
+        NULL
+    };
 
-    assert(t == SET);
+    if (contains_variable(sscript, hdr)) return 1;
 
-    if (ret) {
-        ret->u.s.mod40 = s->mod40;
-        ret->u.s.mod30 = s->mod30;
-        ret->u.s.mod20 = s->mod20;
-        ret->u.s.mod10 = s->mod10;
-        ret->u.s.variable = xstrdup(variable);
-        ret->u.s.value = xstrdup(value);
+    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
+        return verify_headername(sscript, hdr);
 
-        free_stags(s);
+    for (lcase(hdr), h = hdrs; *h; h++) {
+        if (!strcmp(*h, hdr)) return 1;
     }
 
-    return ret;
+    sieveerror_f(sscript,
+                 "header '%s': not a valid header for an address test", hdr);
+    return 0;
 }
 
-static commandlist_t *build_flag(int t, char *variable, strarray_t *flags)
+static int verify_envelope(sieve_script_t *sscript, char *env)
 {
-    commandlist_t *ret = new_command(t);
+    if (contains_variable(sscript, env)) return 1;
+
+    lcase(env);
+    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
+        !strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
+        return 1;
+    }
 
-    assert(t == SETFLAG || t == ADDFLAG || t == REMOVEFLAG);
+    sieveerror_f(sscript,
+                 "env-part '%s': not a valid part for an envelope test", env);
+    return 0;
+}
+
+static int verify_list(sieve_script_t *sscript, char *s)
+{
+    if (sscript->interp.isvalidlist &&
+        sscript->interp.isvalidlist(sscript->interp.interp_context, s)
+        != SIEVE_OK) {
+        sieveerror_f(sscript, "list '%s': is not valid/supported", s);
+        return 0;
+    }
+
+    return 1;
+}
+
+static int check_reqs(sieve_script_t *sscript, strarray_t *sa)
+{
+    char *s;
+    struct buf *errs = &sscript->sieveerr;
+    int ret = 1, sep = ':';
+
+    buf_setcstr(errs, "Unsupported feature(s) in \"require\"");
+    while ((s = strarray_shift(sa))) {
+        if (!script_require(sscript, s)) {
+            buf_printf(errs, "%c \"%s\"", sep, s);
+            ret = 0;
+            sep = ',';
+        }
+        free(s);
+    }
+    strarray_free(sa);
 
-    if (ret) {
-        ret->u.fl.variable = xstrdup(variable ? variable : "");
-        ret->u.fl.flags = flags;
+    if (ret == 0) yyerror(sscript, buf_cstring(&sscript->sieveerr));
+    else if (supported(SIEVE_CAPA_IHAVE)) {
+        /* mark all allowed extensions as supported */
+        sscript->support |= (SIEVE_CAPA_ALL & ~SIEVE_CAPA_IHAVE_INCOMPAT);
     }
 
+    encoded_char = supported(SIEVE_CAPA_ENCODED_CHAR);
+
     return ret;
 }
 
-static struct aetags *new_aetags(void)
+static commandlist_t *build_keep(sieve_script_t *sscript, commandlist_t *c)
 {
-    struct aetags *r = (struct aetags *) xmalloc(sizeof(struct aetags));
+    assert(c && c->type == KEEP);
 
-    init_comptags(&r->comptags);
-    r->addrtag = -1;
+    if (c->u.k.flags && !_verify_flaglist(c->u.k.flags)) {
+        strarray_add(c->u.k.flags, "");
+    }
 
-    return r;
+    return c;
+}
+
+static commandlist_t *build_fileinto(sieve_script_t *sscript,
+                                     commandlist_t *c, char *folder)
+{
+    assert(c && c->type == FILEINTO);
+
+    if (c->u.f.flags && !_verify_flaglist(c->u.f.flags)) {
+        strarray_add(c->u.f.flags, "");
+    }
+    verify_mailbox(sscript, folder);
+    c->u.f.folder = folder;
+
+    return c;
+}
+
+static commandlist_t *build_redirect(sieve_script_t *sscript,
+                                     commandlist_t *c, char *address)
+{
+    assert(c && c->type == REDIRECT);
+
+    if (c->u.r.list) verify_list(sscript, address);
+    else verify_address(sscript, address);
+
+    /* Verify DELIVERBY values */
+    if (c->u.r.bytime) {
+        if (!supported(SIEVE_CAPA_VARIABLES)) {
+            time_t t;
+
+            if (c->u.r.bytime[0] != '+' &&
+                time_from_iso8601(c->u.r.bytime, &t) == -1) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DELIVERBY time value",
+                             c->u.r.bytime);
+            }
+            if (c->u.r.bymode &&
+                strcasecmp(c->u.r.bymode, "NOTIFY") &&
+                strcasecmp(c->u.r.bymode, "RETURN")) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DELIVERBY mode value",
+                             c->u.r.bymode);
+            }
+        }
+    }
+    else if (c->u.r.bymode || c->u.r.bytrace) {
+        sieveerror_c(sscript, SIEVE_MISSING_TAG,
+                     ":bytimerelative OR :bytimeabsolute");
+    }
+
+    /* Verify DSN NOTIFY value(s) */
+    if (c->u.r.dsn_notify && !supported(SIEVE_CAPA_VARIABLES)) {
+        tok_t tok =
+            TOK_INITIALIZER(c->u.r.dsn_notify, ",", TOK_TRIMLEFT|TOK_TRIMRIGHT);
+        char *token;
+        int never = 0;
+
+        while ((token = tok_next(&tok))) {
+            if (!strcasecmp(token, "NEVER")) never = 1;
+            else if (never) {
+                sieveerror_f(sscript,
+                             "DSN NOTIFY value 'NEVER' MUST be used by itself");
+                break;
+            }
+            else if (strcasecmp(token, "SUCCESS") &&
+                     strcasecmp(token, "FAILURE") &&
+                     strcasecmp(token, "DELAY")) {
+                sieveerror_f(sscript,
+                             "string '%s': not a valid DSN NOTIFY value",
+                             token);
+                break;
+            }
+        }
+        tok_fini(&tok);
+    }
+
+    /* Verify DSN RET value */
+    if (c->u.r.dsn_ret && !supported(SIEVE_CAPA_VARIABLES) &&
+        strcasecmp(c->u.r.dsn_ret, "FULL") &&
+        strcasecmp(c->u.r.dsn_ret, "HDRS")) {
+        sieveerror_f(sscript, "string '%s': not a valid DSN RET value",
+                     c->u.r.dsn_ret);
+    }
+
+    c->u.r.address = address;
+
+    return c;
+}
+
+static int verify_identifier(sieve_script_t *sscript, char *s)
+{
+    /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */
+
+    if (!is_identifier(s)) {
+        sieveerror_f(sscript,
+                     "string '%s': not a valid sieve identifier", s);
+        return 0;
+    }
+    return 1;
+}
+
+static commandlist_t *build_set(sieve_script_t *sscript,
+                                commandlist_t *c, char *variable, char *value)
+{
+    assert(c && c->type == SET);
+
+    verify_identifier(sscript, variable);
+    verify_utf8(sscript, value);
+
+    c->u.s.variable = variable;
+    c->u.s.value = value;
+
+    return c;
+}
+
+static commandlist_t *build_vacation(sieve_script_t *sscript,
+                                     commandlist_t *c, char *message)
+{
+    int min = sscript->interp.vacation->min_response;
+    int max = sscript->interp.vacation->max_response;
+
+    assert(c && c->type == VACATION);
+
+    if (c->u.v.handle) verify_utf8(sscript, c->u.v.handle);
+    if (c->u.v.subject) verify_headerbody(sscript, c->u.v.subject);
+    if (c->u.v.from) verify_address(sscript, c->u.v.from);
+    if (c->u.v.addresses)
+        verify_stringlist(sscript, c->u.v.addresses, verify_address);
+    if (c->u.v.mime == -1) {
+        verify_utf8(sscript, message);
+        c->u.v.mime = 0;
+    }
+    if (c->u.v.fcc.folder) {
+        verify_mailbox(sscript, c->u.v.fcc.folder);
+        if (c->u.v.fcc.flags && !_verify_flaglist(c->u.v.fcc.flags)) {
+            strarray_add(c->u.v.fcc.flags, "");
+        }
+    }
+    else if (c->u.v.fcc.create || c->u.v.fcc.flags || c->u.v.fcc.specialuse) {
+        sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
+    }
+
+    c->u.v.message = message;
+
+    if (c->u.v.seconds == -1) c->u.v.seconds = 7 * DAY2SEC;
+    if (c->u.v.seconds < min) c->u.v.seconds = min;
+    if (c->u.v.seconds > max) c->u.v.seconds = max;
+
+    return c;
+}
+
+static commandlist_t *build_flag(sieve_script_t *sscript,
+                                 commandlist_t *c, strarray_t *flags)
+{
+    assert(c &&
+           (c->type == SETFLAG || c->type == ADDFLAG || c->type == REMOVEFLAG));
+
+    if (!_verify_flaglist(flags)) {
+        strarray_add(flags, "");
+    }
+    c->u.fl.flags = flags;
+
+    if (!c->u.fl.variable) c->u.fl.variable = xstrdup("");
+    else if (!is_identifier(c->u.fl.variable)) {
+        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "variablename");
+    }
+
+    return c;
+}
+
+static commandlist_t *build_addheader(sieve_script_t *sscript,
+                                      commandlist_t *c, char *name, char *value)
+{
+    assert(c && c->type == ADDHEADER);
+
+    verify_headername(sscript, name);
+    verify_headerbody(sscript, value);
+
+    if (c->u.ah.index == 0) c->u.ah.index = 1;
+    c->u.ah.name = name;
+    c->u.ah.value = value;
+
+    return c;
 }
 
-static struct aetags *canon_aetags(struct aetags *ae)
+static commandlist_t *build_deleteheader(sieve_script_t *sscript,
+                                         commandlist_t *c,
+                                         char *name, strarray_t *values)
 {
-    canon_comptags(&ae->comptags);
-    if (ae->addrtag == -1) { ae->addrtag = ALL; }
-    return ae;
+    assert(c && c->type == DELETEHEADER);
+
+    if (!strcasecmp("Received", name) || !strcasecmp("Auto-Submitted", name)) {
+        sieveerror_f(sscript,
+                     "MUST NOT delete Received or Auto-Submitted headers");
+    }
+
+    verify_headername(sscript, name);
+    verify_patternlist(sscript, values, &c->u.dh.comp, verify_utf8);
+
+    c->u.dh.name = name;
+    c->u.dh.values = values;
+
+    return c;
 }
 
-static void free_aetags(struct aetags *ae)
+static int verify_weekday(sieve_script_t *sscript, char *day)
 {
-    free_comptags(&ae->comptags, 0);
-    free(ae);
+    int n = day[0] - '0';
+
+    if (n >= 0 && n <= 6 && day[1] == '\0') {
+        return (1 << n);
+    }
+
+    sieveerror_f(sscript, "'%s': not a valid weekday for snooze", day);
+    return 0;
 }
 
-static struct comptags *new_comptags(void)
+static int verify_time(sieve_script_t *sscript, char *time)
 {
-    struct comptags *c = (struct comptags *) xmalloc(sizeof(struct comptags));
+    struct tm tm;
+    char *r = strptime(time, "%T", &tm);
 
-    return init_comptags(c);
+    if (r && *r == '\0') {
+        return (3600 * tm.tm_hour + 60 * tm.tm_min + tm.tm_sec);
+    }
+
+    sieveerror_f(sscript, "'%s': not a valid time for snooze", time);
+    return 0;
 }
 
-static struct comptags *init_comptags(struct comptags *c)
+static commandlist_t *build_snooze(sieve_script_t *sscript,
+                                   commandlist_t *c, arrayu64_t *times)
 {
-    c->match = c->relation = -1;
-    c->comparator = NULL;
-    c->index = 0;
+    assert(c && c->type == SNOOZE);
+
+    if (c->u.sn.mailbox) verify_mailbox(sscript, c->u.sn.mailbox);
+    if (c->u.sn.addflags && !_verify_flaglist(c->u.sn.addflags)) {
+        strarray_add(c->u.sn.addflags, "");
+    }
+    if (c->u.sn.removeflags && !_verify_flaglist(c->u.sn.removeflags)) {
+        strarray_add(c->u.sn.removeflags, "");
+    }
+    if (!c->u.sn.days) c->u.sn.days = 0x7f; /* all days */
+
+    /* Sort times earliest -> latest */
+    arrayu64_sort(times, NULL/*ascending*/);
+    c->u.sn.times = times;
 
     return c;
 }
 
-static struct comptags *canon_comptags(struct comptags *c)
-{
-    if (c->match == -1) c->match = IS;
-    if (c->comparator == NULL) c->comparator = xstrdup("i;ascii-casemap");
+static commandlist_t *build_rej_err(sieve_script_t *sscript,
+                                    int t, char *message)
+{
+    commandlist_t *c;
+
+    assert(t == REJCT || t == EREJECT || t == ERROR);
+
+    verify_utf8(sscript, message);
+
+    c = new_command(t, sscript);
+    c->u.str = message;
+
+    return c;
+}
+
+static commandlist_t *build_notify(sieve_script_t *sscript, int t,
+                                   commandlist_t *c, char *method)
+{
+    assert(c && (t == NOTIFY || t == ENOTIFY));
+
+    if (t == ENOTIFY) {
+        if (!supported(SIEVE_CAPA_ENOTIFY)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "enotify");
+        }
+        if (c->u.n.id != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":id");
+        }
+        if (c->u.n.method != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":method");
+        }
+        if (c->u.n.fcc.folder) {
+            verify_mailbox(sscript, c->u.n.fcc.folder);
+            if (c->u.n.fcc.flags && !_verify_flaglist(c->u.n.fcc.flags)) {
+                strarray_add(c->u.n.fcc.flags, "");
+            }
+        }
+        else if (c->u.n.fcc.create || c->u.n.fcc.flags || c->u.n.fcc.specialuse) {
+            sieveerror_c(sscript, SIEVE_MISSING_TAG, ":fcc");
+        }
+
+        c->u.n.method = method;
+    }
+    else {
+        if (!supported(SIEVE_CAPA_NOTIFY)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "notify");
+        }
+        if (c->u.n.from != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":from");
+        }
+        if (c->u.n.fcc.folder != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":fcc");
+        }
+        if (c->u.n.fcc.create != 0) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":create");
+        }
+        if (c->u.n.fcc.flags != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":flags");
+        }
+        if (c->u.n.fcc.specialuse != NULL) {
+            sieveerror_c(sscript, SIEVE_UNEXPECTED_TAG, ":specialuse");
+        }
+
+        if (!c->u.n.method) c->u.n.method = xstrdup("default");
+    }
+
+    c->type = t;
+    if (c->u.n.priority == -1) c->u.n.priority = NORMAL;
+    if (!c->u.n.message) c->u.n.message = xstrdup("$from$: $subject$");
+
     return c;
 }
 
-static void free_comptags(struct comptags *c, int destroy)
+static commandlist_t *build_denotify(sieve_script_t *sscript,
+                                     commandlist_t *t)
 {
-    free(c->comparator);
-    if (destroy) free(c);
-}
+    assert(t && t->type == DENOTIFY);
 
-static struct btags *new_btags(void)
-{
-    struct btags *r = (struct btags *) xmalloc(sizeof(struct btags));
+    canon_comptags(&t->u.d.comp, sscript);
+    if (t->u.d.priority == -1) t->u.d.priority = ANY;
+    if (t->u.d.pattern) {
+        strarray_t sa = STRARRAY_INITIALIZER;
 
-    init_comptags(&r->comptags);
-    r->transform = r->offset = -1;
-    r->content_types = NULL;
+        strarray_pushm(&sa, t->u.d.pattern);
+        verify_patternlist(sscript, &sa, &t->u.d.comp, NULL);
+        strarray_pop(&sa);
+        strarray_fini(&sa);
+    }
 
-    return r;
+    return t;
 }
 
-static struct btags *canon_btags(struct btags *b)
+static commandlist_t *build_include(sieve_script_t *sscript,
+                                    commandlist_t *c, char *script)
 {
-    canon_comptags(&b->comptags);
-    if (b->transform == -1) b->transform = TEXT;
-    if (b->content_types == NULL) {
-        b->content_types = strarray_new();
-        if (b->transform == RAW) strarray_append(b->content_types, "");
-        else strarray_append(b->content_types, "text");
+    assert(c && c->type == INCLUDE);
+
+    if (strchr(script, '/')) {
+        sieveerror_c(sscript, SIEVE_INVALID_VALUE, "script-name");
     }
-    if (b->offset == -1) b->offset = 0;
-    return b;
-}
 
-static void free_btags(struct btags *b)
-{
-    free_comptags(&b->comptags, 0);
-    if (b->content_types) strarray_free(b->content_types);
-    free(b);
+    c->u.inc.script = script;
+    if (c->u.inc.once == -1) c->u.inc.once = 0;
+    if (c->u.inc.location == -1) c->u.inc.location = PERSONAL;
+    if (c->u.inc.optional == -1) c->u.inc.optional = 0;
+
+    return c;
 }
 
-static struct vtags *new_vtags(void)
+static commandlist_t *build_log(sieve_script_t *sscript, char *text)
 {
-    struct vtags *r = (struct vtags *) xmalloc(sizeof(struct vtags));
+    commandlist_t *c;
 
-    r->seconds = -1;
-    r->addresses = NULL;
-    r->subject = NULL;
-    r->from = NULL;
-    r->handle = NULL;
-    r->mime = -1;
-
-    return r;
-}
+    if (!supported(SIEVE_CAPA_LOG)) {
+          sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "x-cyrus-log");
+    }
 
-static struct vtags *canon_vtags(sieve_script_t *parse_script, struct vtags *v)
-{
-    assert(parse_script->interp.vacation != NULL);
+    verify_utf8(sscript, text);
 
-    if (v->seconds == -1) v->seconds = 7 * DAY2SEC;
-    if (v->seconds < parse_script->interp.vacation->min_response)
-        v->seconds = parse_script->interp.vacation->min_response;
-    if (v->seconds > parse_script->interp.vacation->max_response)
-        v->seconds = parse_script->interp.vacation->max_response;
-    if (v->mime == -1) v->mime = 0;
+    c = new_command(LOG, sscript);
+    c->u.l.text = text;
 
-    return v;
+    return c;
 }
 
-static void free_vtags(struct vtags *v)
+static test_t *build_anyof(sieve_script_t *sscript, testlist_t *tl)
 {
-    strarray_free(v->addresses);
-    free(v->subject);
-    free(v->from);
-    free(v->handle);
-    free(v);
-}
+    test_t *t;
 
-static struct itags *new_itags()
-{
-    struct itags *r = (struct itags *) xmalloc(sizeof(struct itags));
+    assert(tl);
 
-    r->once = -1;
-    r->location = -1;
-    r->optional = -1;
+    if (tl->next == NULL) {
+        /* collapse single item list into a simple test */
+        t = tl->t;
+        free(tl);
+    }
+    else {
+        test_t *fail = NULL, *maybe = NULL;
 
-    return r;
-}
+        /* create ANYOF test */
+        t = new_test(ANYOF, sscript);
+        t->u.tl = tl;
+
+        /* find first test that did/didn't set ignore_err */
+        for ( ; tl && !fail && !maybe; tl = tl->next) {
+            if (tl->t->ignore_err) {
+                if (!fail) fail = tl->t;
+            }
+            else if (!maybe) maybe = tl->t;
+        }
 
-static struct dttags *new_dttags(void)
-{
-    struct dttags *dt = (struct dttags *) xmalloc(sizeof(struct dttags));
+        if (fail) {
+            if (maybe) {
+                /* test may succeed - backout ignore_err */
+                sscript->ignore_err = --fail->ignore_err;
+            }
+            else {
+                /* test will fail - revert ignore_err to first value */
+                sscript->ignore_err = t->ignore_err = fail->ignore_err;
+            }
+        }
+    }
 
-    init_comptags(&dt->comptags);
-    dt->zonetag = -1;
-    dt->zone = NULL;
-    return dt;
+    return t;
 }
 
-static struct dttags *canon_dttags(struct dttags *dt)
+static test_t *build_allof(sieve_script_t *sscript, testlist_t *tl)
 {
-    char zone[14];
-    int gmoffset;
-    int hours;
-    int minutes;
-    struct tm tm;
-    time_t t;
+    test_t *t;
 
-    canon_comptags(&dt->comptags);
-    if (dt->comptags.index == 0) dt->comptags.index = 1;
-    if (dt->zonetag == -1) {
-        t = time(NULL);
-        localtime_r(&t, &tm);
-        gmoffset = gmtoff_of(&tm, t) / 60;
-        hours = abs(gmoffset) / 60;
-        minutes = abs(gmoffset) % 60;
-        snprintf(zone, sizeof(zone), "%c%02d%02d",
-                 (gmoffset >= 0 ? '+' : '-'), hours, minutes);
-        dt->zone = xstrdup(zone);
-        dt->zonetag = ZONE;
+    assert(tl);
+
+    if (tl->next == NULL) {
+        /* collapse single item list into a simple test */
+        t = tl->t;
+        free(tl);
+    }
+    else {
+        /* create ALLOF test */
+        t = new_test(ALLOF, sscript);
+        t->u.tl = tl;
+
+        /* find first test that set ignore_err and revert to that value */
+        for ( ; tl; tl = tl->next) {
+            if (tl->t->ignore_err) {
+                sscript->ignore_err = t->ignore_err = tl->t->ignore_err;
+                break;
+            }
+        }
     }
-    return dt;
-}
 
-static void free_dttags(struct dttags *dt)
-{
-    free_comptags(&dt->comptags, 0);
-    free(dt->zone);
-    free(dt);
+    return t;
 }
 
-
-static struct ntags *new_ntags(void)
+static test_t *build_not(sieve_script_t *sscript, test_t *t)
 {
-    struct ntags *r = (struct ntags *) xmalloc(sizeof(struct ntags));
+    test_t *n;
 
-    r->method = NULL;
-    r->id = NULL;
-    r->options = NULL;
-    r->priority = -1;
-    r->message = NULL;
+    assert(t);
 
-    return r;
-}
+    if (t->ignore_err) {
+        /* test will succeed - backout ignore_err */
+        sscript->ignore_err = --t->ignore_err;
+    }
+
+    n = new_test(NOT, sscript);
+    n->u.t = t;
 
-static struct ntags *canon_ntags(struct ntags *n)
-{
-    if (n->priority == -1) n->priority = NORMAL;
-    if (n->message == NULL) n->message = xstrdup("$from$: $subject$");
-    if (n->method == NULL) n->method = xstrdup("default");
     return n;
 }
-static struct dtags *canon_dtags(struct dtags *d)
-{
-    canon_comptags(&d->comptags);
-    if (d->priority == -1) d->priority = ANY;
-    return d;
-}
 
-static void free_ntags(struct ntags *n)
+static test_t *build_hhs(sieve_script_t *sscript, test_t *t,
+                         strarray_t *sl, strarray_t *pl)
 {
-    free(n->method);
-    free(n->id);
-    strarray_free(n->options);
-    free(n->message);
-    free(n);
-}
+    assert(t);
 
-static struct dtags *new_dtags(void)
-{
-    struct dtags *r = (struct dtags *) xzmalloc(sizeof(struct dtags));
+    verify_patternlist(sscript, pl, &t->u.hhs.comp, verify_utf8);
 
-    init_comptags(&r->comptags);
-    r->comptags.comparator = xstrdup("i;ascii-casemap");
-    r->priority = -1;
+    t->u.hhs.sl = sl;
+    t->u.hhs.pl = pl;
 
-    return r;
+    return t;
 }
 
-static void free_dtags(struct dtags *d)
+static test_t *build_header(sieve_script_t *sscript, test_t *t,
+                            strarray_t *sl, strarray_t *pl)
 {
-    if (!d) return;
-    free_comptags(&d->comptags, 0);
-    free(d);
-}
+    assert(t && t->type == HEADERT);
 
-static struct ftags *new_ftags(void)
-{
-    struct ftags *f = (struct ftags *) xzmalloc(sizeof(struct ftags));
-    return f;
-}
+    verify_stringlist(sscript, sl, verify_headername);
 
-static struct ftags *canon_ftags(struct ftags *f)
-{
-    return f;
+    return build_hhs(sscript, t, sl, pl);
 }
 
-static struct stags *new_stags(void)
+static test_t *build_stringt(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
 {
-    struct stags *s = (struct stags *) xmalloc(sizeof(struct stags));
+    assert(t && t->type == STRINGT);
 
-    s->mod40 = 0;
-    s->mod30 = 0;
-    s->mod20 = 0;
-    s->mod10 = 0;
+    verify_stringlist(sscript, sl, verify_utf8);
 
-    return s;
+    return build_hhs(sscript, t, sl, pl);
 }
 
-static struct stags *canon_stags(struct stags *s)
+static test_t *build_hasflag(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
 {
-    return s;
-}
+    assert(t && t->type == HASFLAG);
 
-static void free_stags(struct stags *s)
-{
-    free(s);
-}
+    if (sl) {
+        if (!supported(SIEVE_CAPA_VARIABLES)) {
+            sieveerror_c(sscript, SIEVE_MISSING_REQUIRE, "variables");
+        }
 
-static void free_ftags(struct ftags *f)
-{
-    if (!f) return;
-    strarray_free(f->flags);
-    free(f);
+        verify_stringlist(sscript, sl, verify_identifier);
+    }
+
+    return build_hhs(sscript, t, sl, pl);
 }
 
-static int verify_identifier(sieve_script_t *parse_script, char *s)
+static test_t *build_ae(sieve_script_t *sscript, test_t *t,
+                        strarray_t *sl, strarray_t *pl)
 {
-    /* identifier         = (ALPHA / "_") *(ALPHA / DIGIT / "_") */
+    assert(t);
 
-    if (!is_identifier(s)) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "string '%s': not a valid sieve identifier", s);
-        yyerror(parse_script, parse_script->sieveerr);
-        return 0;
-    }
-    return 1;
-}
+    verify_patternlist(sscript, pl, &t->u.ae.comp, NULL);
 
-static int verify_stringlist(sieve_script_t *parse_script, strarray_t *sa,
-                             int (*verify)(sieve_script_t*, char *))
-{
-    int i;
+    if (t->u.ae.addrpart == -1) t->u.ae.addrpart = ALL;
+    t->u.ae.sl = sl;
+    t->u.ae.pl = pl;
 
-    for (i = 0 ; i < sa->count ; i++) {
-        if (!verify(parse_script, sa->data[i])) return 0;
-    }
-    return 1;
+    return t;
 }
 
-static int verify_address(sieve_script_t *parse_script, char *s)
+static test_t *build_address(sieve_script_t *sscript, test_t *t,
+                             strarray_t *sl, strarray_t *pl)
 {
-    parse_script->addrerr[0] = '\0';    /* paranoia */
-    YY_BUFFER_STATE buffer = addr_scan_string(s);
-    if (addrparse(parse_script)) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "address '%s': %s", s, parse_script->addrerr);
-        yyerror(parse_script, parse_script->sieveerr);
-        addr_delete_buffer(buffer);
-        return 0;
-    }
-    addr_delete_buffer(buffer);
-    return 1;
+    assert(t && t->type == ADDRESS);
+
+    verify_stringlist(sscript, sl, verify_addrheader);
+
+    return build_ae(sscript, t, sl, pl);
 }
 
-static int verify_mailbox(sieve_script_t *parse_script, char *s)
+static test_t *build_envelope(sieve_script_t *sscript, test_t *t,
+                              strarray_t *sl, strarray_t *pl)
 {
-    if (!verify_utf8(parse_script, s)) return 0;
+    assert(t && t->type == ENVELOPE);
 
-    /* xxx if not a mailbox, call yyerror */
-    return 1;
+    verify_stringlist(sscript, sl, verify_envelope);
+
+    return build_ae(sscript, t, sl, pl);
 }
 
-static int verify_header(sieve_script_t *parse_script, char *hdr)
+static test_t *build_body(sieve_script_t *sscript,
+                          test_t *t, strarray_t *pl)
 {
-    char *h = hdr;
+    assert(t && (t->type == BODY));
 
-    while (*h) {
-        /* field-name      =       1*ftext
-           ftext           =       %d33-57 / %d59-126
-           ; Any character except
-           ;  controls, SP, and
-           ;  ":". */
-        if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
-            snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                     "header '%s': not a valid header", hdr);
-            yyerror(parse_script, parse_script->sieveerr);
-            return 0;
-        }
-        h++;
+    verify_patternlist(sscript, pl, &t->u.b.comp, verify_utf8);
+
+    if (t->u.b.offset == -1) t->u.b.offset = 0;
+    if (t->u.b.transform == -1) t->u.b.transform = TEXT;
+    if (t->u.b.content_types == NULL) {
+        t->u.b.content_types = strarray_new();
+        strarray_append(t->u.b.content_types,
+                        (t->u.b.transform == RAW) ? "" : "text");
     }
-    return 1;
+    t->u.b.pl = pl;
+
+    return t;
 }
 
-static int verify_addrheader(sieve_script_t *parse_script, char *hdr)
+static test_t *build_date(sieve_script_t *sscript,
+                          test_t *t, char *hn, int part, strarray_t *kl)
 {
-    const char **h, *hdrs[] = {
-        "from", "sender", "reply-to",   /* RFC2822 originator fields */
-        "to", "cc", "bcc",              /* RFC2822 destination fields */
-        "resent-from", "resent-sender", /* RFC2822 resent fields */
-        "resent-to", "resent-cc", "resent-bcc",
-        "return-path",                  /* RFC2822 trace fields */
-        "disposition-notification-to",  /* RFC2298 MDN request fields */
-        "delivered-to",                 /* non-standard (loop detection) */
-        "approved",                     /* RFC1036 moderator/control fields */
-        NULL
-    };
+    assert(t && (t->type == DATE || t->type == CURRENTDATE));
 
-    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
-        return verify_header(parse_script, hdr);
+    if (hn) verify_headername(sscript, hn);
+    verify_patternlist(sscript, kl, &t->u.dt.comp, NULL);
 
-    for (lcase(hdr), h = hdrs; *h; h++) {
-        if (!strcmp(*h, hdr)) return 1;
+    if (t->u.dt.comp.index == 0) t->u.dt.comp.index = 1;
+    if (t->u.dt.zonetag == -1) {
+        struct tm tm;
+        time_t now = time(NULL);
+
+        localtime_r(&now, &tm);
+        t->u.dt.zone = gmtoff_of(&tm, now) / 60;
+        t->u.dt.zonetag = ZONE;
     }
 
-    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-             "header '%s': not a valid header for an address test", hdr);
-    yyerror(parse_script, parse_script->sieveerr);
-    return 0;
+    t->u.dt.date_part = part;
+    t->u.dt.header_name = hn;
+    t->u.dt.kl = kl;
+
+    return t;
 }
 
-static int verify_envelope(sieve_script_t *parse_script, char *env)
+static test_t *build_ihave(sieve_script_t *sscript, strarray_t *sa)
 {
-    lcase(env);
-    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
-        !strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
-        return 1;
+    test_t *t;
+    int i;
+
+    t = new_test(IHAVE, sscript);
+    t->u.sl = sa;
+
+    /* check if we support all listed extensions */
+    for (i = 0; i < strarray_size(sa); i++) {
+        unsigned long long capa = lookup_capability(strarray_nth(sa, i));
+
+        if (!capa) {
+            /* need to start ignoring errors immediately in case this ihave
+               is part of a testlist with an unknown test later in the list */
+            if (!t->ignore_err) t->ignore_err = ++sscript->ignore_err;
+        }
+        else if (capa & SIEVE_CAPA_IHAVE_INCOMPAT) {
+            /* incompatible extension used in ihave - parse error */
+            sscript->ignore_err = 0;
+            sieveerror_c(sscript, SIEVE_IHAVE_INCOMPAT, strarray_nth(sa, i));
+            break;
+        }
     }
 
-    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-             "env-part '%s': not a valid part for an envelope test", env);
-    yyerror(parse_script, parse_script->sieveerr);
-    return 0;
+    return t;
 }
 
-static int verify_relat(sieve_script_t *parse_script, char *r)
+static test_t *build_mbox_meta(sieve_script_t *sscript,
+                               test_t *t, char *extname,
+                               char *keyname, strarray_t *keylist)
 {
-    /* this really should have been a token to begin with.*/
-    lcase(r);
-    if (!strcmp(r, "gt")) return GT;
-    else if (!strcmp(r, "ge")) return GE;
-    else if (!strcmp(r, "lt")) return LT;
-    else if (!strcmp(r, "le")) return LE;
-    else if (!strcmp(r, "ne")) return NE;
-    else if (!strcmp(r, "eq")) return EQ;
-    else {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "flag '%s': not a valid relational operation", r);
-        yyerror(parse_script, parse_script->sieveerr);
-        return -1;
-    }
+    assert(t && (t->type == MAILBOXEXISTS || t->type == MAILBOXIDEXISTS ||
+                 t->type == METADATA || t->type == METADATAEXISTS ||
+                 t->type == SERVERMETADATA || t->type == SERVERMETADATAEXISTS ||
+                 t->type == ENVIRONMENT || t->type == SPECIALUSEEXISTS ||
+                 t->type == NOTIFYMETHODCAPABILITY));
+
+    canon_comptags(&t->u.mm.comp, sscript);
+    t->u.mm.extname = extname;
+    t->u.mm.keyname = keyname;
+    t->u.mm.keylist = keylist;
+
+    return t;
 }
 
-static int verify_zone(sieve_script_t *parse_script, char *tz)
+static test_t *build_duplicate(sieve_script_t *sscript, test_t *t)
 {
-    int valid = 0;
-    unsigned hours;
-    unsigned minutes;
-    char sign;
+    assert(t && t->type == DUPLICATE);
 
-    if (sscanf(tz, "%c%02u%02u", &sign, &hours, &minutes) != 3) {
-        valid |= -1;
-    }
+    switch (t->u.dup.idtype) {
+    case HEADER:
+        verify_headername(sscript, t->u.dup.idval);
+        break;
 
-    // test sign
-    switch (sign) {
-    case '+':
-    case '-':
+    case UNIQUEID:
+        verify_utf8(sscript, t->u.dup.idval);
         break;
 
     default:
-        valid |= -1;
+        t->u.dup.idtype = HEADER;
+        t->u.dup.idval = xstrdup("Message-ID");
         break;
     }
 
-    // test minutes
-    if (minutes > 59) {
-            valid |= -1;
-    }
-
-    if (valid != 0) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "flag '%s': not a valid timezone offset", tz);
-        yyerror(parse_script, parse_script->sieveerr);
-    }
-
-    return valid;
-}
-
-static int verify_date_part(sieve_script_t *parse_script, char *dp)
-{
-    lcase(dp);
-    if (!strcmp(dp, "year")) return YEAR;
-    else if (!strcmp(dp, "month")) return MONTH;
-    else if (!strcmp(dp, "day")) return DAY;
-    else if (!strcmp(dp, "date")) return DATE;
-    else if (!strcmp(dp, "julian")) return JULIAN;
-    else if (!strcmp(dp, "hour")) return HOUR;
-    else if (!strcmp(dp, "minute")) return MINUTE;
-    else if (!strcmp(dp, "second")) return SECOND;
-    else if (!strcmp(dp, "time")) return TIME;
-    else if (!strcmp(dp, "iso8601")) return ISO8601;
-    else if (!strcmp(dp, "std11")) return STD11;
-    else if (!strcmp(dp, "zone")) return ZONE;
-    else if (!strcmp(dp, "weekday")) return WEEKDAY;
-    else {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "'%s': not a valid date-part", dp);
-        yyerror(parse_script, parse_script->sieveerr);
-    }
+    if (!t->u.dup.handle) t->u.dup.handle = xstrdup("");
+    else verify_utf8(sscript, t->u.dup.handle);
+
+    if (t->u.dup.seconds == -1) t->u.dup.seconds = 7 * 86400; /* 7 days */
 
-    return -1;
+    return t;
 }
 
-#ifdef ENABLE_REGEX
-static int verify_regex(sieve_script_t *parse_script, char *s, int cflags)
+#ifdef WITH_JMAP
+#include "imap/json_support.h"
+
+static int jmap_parse_condition(json_t *cond, strarray_t *path)
 {
-    int ret;
-    regex_t *reg = (regex_t *) xmalloc(sizeof(regex_t));
+    json_t *val;
+    const char *field;
 
-    if ((ret = regcomp(reg, s, cflags)) != 0) {
-        (void) regerror(ret, reg, parse_script->sieveerr, ERR_BUF_SIZE);
-        yyerror(parse_script, parse_script->sieveerr);
-        free(reg);
+    json_object_foreach(cond, field, val) {
+        /* inMailbox* and *InThreadHaveKeywords properties are incompatible */
+        if (!strcmp(field, "before") ||
+            !strcmp(field, "after")) {
+            if (!json_is_utcdate(val)) break;
+        }
+        else if (!strcmp(field, "minSize") ||
+                 !strcmp(field, "maxSize")) {
+            if (!json_is_integer(val)) break;
+        }
+        else if (!strcmp(field, "hasAttachment")) {
+            if (!json_is_boolean(val)) break;
+        }
+        else if (!strcmp(field, "text") ||
+                 !strcmp(field, "from") ||
+                 !strcmp(field, "to") ||
+                 !strcmp(field, "cc") ||
+                 !strcmp(field, "bcc") ||
+                 !strcmp(field, "subject") ||
+                 !strcmp(field, "body")) {
+            if (!json_is_string(val)) break;
+        }
+        else if (!strcmp(field, "header")) {
+            size_t n = json_array_size(val);
+
+            if (n == 0 || n > 2) break;
+
+            do {
+                const char *s = json_string_value(json_array_get(val, --n));
+
+                if (!s || !strlen(s)) {
+                    struct buf buf = BUF_INITIALIZER;
+
+                    buf_printf(&buf, "header[%lu]", n);
+                    strarray_pushm(path, buf_release(&buf));
+                    return 0;
+                }
+            } while (n);
+        }
+        /* JMAP Search Extension: https://cyrusimap.org/ns/jmap/search */
+        else if (!strcmp(field, "attachmentBody")) {
+            if (!json_is_string(val)) break;
+        }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "attachmentName") ||
+                 !strcmp(field, "attachmentType")) {
+            if (!json_is_string(val)) break;
+        }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "fromContactGroupId") ||
+                 !strcmp(field, "toContactGroupId") ||
+                 !strcmp(field, "ccContactGroupId") ||
+                 !strcmp(field, "bccContactGroupId")) {
+            if (!json_is_string(val)) break;
+        }
+        /* JMAP Mail Extension: https://cyrusimap.org/ns/jmap/mail */
+        else if (!strcmp(field, "fromAnyContact") ||
+                 !strcmp(field, "toAnyContact") ||
+                 !strcmp(field, "ccAnyContact") ||
+                 !strcmp(field, "bccAnyContact")) {
+            if (!json_is_boolean(val)) break;
+        }
+        else break;
+    }
+
+    if (field) {
+        strarray_push(path, field);
         return 0;
     }
-    free(reg);
+
     return 1;
 }
 
-static int verify_regexs(sieve_script_t *parse_script,
-                         const strarray_t *sa, char *comp)
+static int jmap_parse_filter(json_t *filter, strarray_t *path)
 {
-    int i;
-    int cflags = REG_EXTENDED | REG_NOSUB;
+    json_t *arg, *val;
+    const char *s;
+    size_t i;
 
-#ifdef HAVE_PCREPOSIX_H
-    /* support UTF8 comparisons */
-    cflags |= REG_UTF8;
-#endif
+    if (!JNOTNULL(filter) || !json_is_object(filter)) return 0;
 
-    if (!strcmp(comp, "i;ascii-casemap")) {
-        cflags |= REG_ICASE;
-    }
+    arg = json_object_get(filter, "operator");
+    if (!arg) return jmap_parse_condition(filter, path);
 
-    for (i = 0 ; i < sa->count ; i++) {
-        if ((verify_regex(parse_script, sa->data[i], cflags)) == 0)
-            return 0;
+    strarray_push(path, "operator");
+    if (!json_is_string(arg)) return 0;
+
+    s = json_string_value(arg);
+    if (strcmp("AND", s) && strcmp("OR", s) && strcmp("NOT", s)) return 0;
+    free(strarray_pop(path));
+
+    arg = json_object_get(filter, "conditions");
+    if (!json_array_size(arg)) {
+        strarray_push(path, "conditions");
+        return 0;
     }
-    return 1;
-}
-#else
 
-static int verify_regexs(sieve_script_t *parse_script __attribute__((unused)),
-                         const strarray_t *sa __attribute__((unused)),
-                         char *comp __attribute__((unused)))
-{
-    return 0;
-}
-#endif /* ENABLE_REGEX */
+    json_array_foreach(arg, i, val) {
+        struct buf buf = BUF_INITIALIZER;
 
-static int verify_patternlist(sieve_script_t *parse_script,
-                              strarray_t *sa, struct comptags *c,
-                              int (*verify)(sieve_script_t*, char *))
-{
-    if (verify && !verify_stringlist(parse_script, sa, verify)) return 0;
+        buf_printf(&buf, "conditions[%lu]", i);
+        strarray_pushm(path, buf_release(&buf));
+        if (!jmap_parse_filter(val, path)) return 0;
+        free(strarray_pop(path));
+    }
 
-    return (c->match == REGEX) ?
-        verify_regexs(parse_script, sa, c->comparator) : 1;
+    return 1;
 }
 
-/*
- * Valid UTF-8 check (from RFC 2640 Annex B.1)
- *
- * The following routine checks if a byte sequence is valid UTF-8. This
- * is done by checking for the proper tagging of the first and following
- * bytes to make sure they conform to the UTF-8 format. It then checks
- * to assure that the data part of the UTF-8 sequence conforms to the
- * proper range allowed by the encoding. Note: This routine will not
- * detect characters that have not been assigned and therefore do not
- * exist.
- */
-static int verify_utf8(sieve_script_t *parse_script, char *s)
+static test_t *build_jmapquery(sieve_script_t *sscript,
+                               test_t *t, const char *json)
 {
-    const char *buf = s;
-    const char *endbuf = s + strlen(s);
-    unsigned char byte2mask = 0x00, c;
-    int trailing = 0;  /* trailing (continuation) bytes to follow */
+    strarray_t path = STRARRAY_INITIALIZER;
+    json_t *jquery;
+    json_error_t jerr;
+
+    assert(t && t->type == JMAPQUERY);
+
+    /* validate query */
+    jquery = json_loads(json, 0, &jerr);
+    if (!jmap_parse_filter(jquery, &path)) {
+        char *s = strarray_join(&path, "/");
 
-    while (buf != endbuf) {
-        c = *buf++;
-        if (trailing) {
-            if ((c & 0xC0) == 0x80) {           /* Does trailing byte
-                                                   follow UTF-8 format? */
-                if (byte2mask) {                /* Need to check 2nd byte
-                                                   for proper range? */
-                    if (c & byte2mask)          /* Are appropriate bits set? */
-                        byte2mask = 0x00;
-                    else
-                        break;
-                }
-                trailing--;
-            }
-            else
-                break;
-        }
-        else {
-            if ((c & 0x80) == 0x00)             /* valid 1 byte UTF-8 */
-                continue;
-            else if ((c & 0xE0) == 0xC0)        /* valid 2 byte UTF-8 */
-                if (c & 0x1E) {                 /* Is UTF-8 byte
-                                                   in proper range? */
-                    trailing = 1;
-                }
-                else
-                    break;
-            else if ((c & 0xF0) == 0xE0) {      /* valid 3 byte UTF-8 */
-                if (!(c & 0x0F)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x20;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 2;
-            }
-            else if ((c & 0xF8) == 0xF0) {      /* valid 4 byte UTF-8 */
-                if (!(c & 0x07)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x30;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 3;
-            }
-            else if ((c & 0xFC) == 0xF8) {      /* valid 5 byte UTF-8 */
-                if (!(c & 0x03)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x38;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 4;
-            }
-            else if ((c & 0xFE) == 0xFC) {      /* valid 6 byte UTF-8 */
-                if (!(c & 0x01)) {              /* Is UTF-8 byte
-                                                   in proper range? */
-                    byte2mask = 0x3C;           /* If not, set mask
-                                                   to check next byte */
-                }
-                trailing = 5;
-            }
-            else
-                break;
-        }
-    }
+        if (s) sieveerror_f(sscript, "invalid jmapquery argument: '%s'", s);
+        else sieveerror_f(sscript, "invalid jmapquery format");
 
-    if ((buf != endbuf) || trailing) {
-        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
-                 "string '%s': not valid utf8", s);
-        yyerror(parse_script, parse_script->sieveerr);
-        return 0;
+        free(s);
     }
+    strarray_fini(&path);
 
-    return 1;
+    t->u.jquery = json_dumps(jquery, JSON_COMPACT);
+    json_decref(jquery);
+
+    return t;
+}
+#else
+static test_t *build_jmapquery(sieve_script_t *sscript, test_t *t,
+                               const char *json __attribute__((unused)))
+{
+    sieveerror_c(sscript, SIEVE_UNSUPP_EXT, "x-cyrus-jmapquery");
+
+    return t;
 }
+#endif /* WITH_JMAP */
diff -pruN 3.0.13-5/sieve/test.c 3.2.0-3/sieve/test.c
--- 3.0.13-5/sieve/test.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/test.c	2020-05-04 03:28:02.000000000 +0000
@@ -59,6 +59,7 @@
 #include <string.h>
 #include <stdlib.h>
 
+#include "libconfig.h"
 #include "assert.h"
 #include "sieve_interface.h"
 #include "bytecode.h"
@@ -67,6 +68,7 @@
 #include "sieve/sieve.h"
 #include "imap/mailbox.h"
 #include "imap/message.h"
+#include "imap/spool.h"
 #include "util.h"
 #include "xmalloc.h"
 #include "xstrlcat.h"
@@ -83,145 +85,32 @@ typedef struct {
     struct message_content content;
 
     int cache_full;
-    struct hash_table cache;
+    hdrcache_t cache;
     strarray_t *env_from;
     strarray_t *env_to;
 } message_data_t;
 
-/* take a list of headers, pull the first one out and return it in
-   name and contents.
-
-   returns 0 on success, negative on failure */
-typedef enum {
-    HDR_NAME_START,
-    HDR_NAME,
-    COLON,
-    HDR_CONTENT_START,
-    HDR_CONTENT
-} state;
-
-static int parseheader(FILE *f, char **headname, char **contents)
-{
-    int c;
-    static struct buf name = BUF_INITIALIZER;
-    static struct buf body = BUF_INITIALIZER;
-    state s = HDR_NAME_START;
-
-    buf_reset(&name);
-    buf_reset(&body);
-
-    /* there are two ways out of this loop, both via gotos:
-       either we successfully read a character (got_header)
-       or we hit an error (ph_error) */
-    while ((c = getc(f))) {     /* examine each character */
-        switch (s) {
-        case HDR_NAME_START:
-            if (c == '\r' || c == '\n') {
-                /* no header here! */
-                goto ph_error;
-            }
-            if (!isalpha(c))
-                goto ph_error;
-            buf_putc(&name, TOLOWER(c));
-            s = HDR_NAME;
-            break;
-
-        case HDR_NAME:
-            if (c == ' ' || c == '\t' || c == ':') {
-                buf_cstring(&name);
-                s = (c == ':' ? HDR_CONTENT_START : COLON);
-                break;
-            }
-            if (iscntrl(c)) {
-                goto ph_error;
-            }
-            buf_putc(&name, TOLOWER(c));
-            break;
-
-        case COLON:
-            if (c == ':') {
-                s = HDR_CONTENT_START;
-            } else if (c != ' ' && c != '\t') {
-                goto ph_error;
-            }
-            break;
-
-        case HDR_CONTENT_START:
-            if (c == ' ' || c == '\t') /* eat the whitespace */
-                break;
-            buf_reset(&body);
-            s = HDR_CONTENT;
-            /* falls through! */
-        case HDR_CONTENT:
-            if (c == '\r' || c == '\n') {
-                int peek = getc(f);
-
-                /* we should peek ahead to see if it's folded whitespace */
-                if (c == '\r' && peek == '\n') {
-                    c = getc(f);
-                } else {
-                    c = peek; /* single newline seperator */
-                }
-                if (c != ' ' && c != '\t') {
-                    /* this is the end of the header */
-                    buf_cstring(&body);
-                    ungetc(c, f);
-                    goto got_header;
-                }
-                /* http://www.faqs.org/rfcs/rfc2822.html
-                 *
-                 * > Unfolding is accomplished by simply removing any CRLF
-                 * > that is immediately followed by WSP
-                 *
-                 * So keep the actual WSP character
-                 */
-            }
-            /* just an ordinary character */
-            buf_putc(&body, c);
-            break;
-        }
-    }
-
-    /* if we fall off the end of the loop, we hit some sort of error
-       condition */
-
- ph_error:
-    if (headname != NULL) *headname = NULL;
-    if (contents != NULL) *contents = NULL;
-    return -1;
-
- got_header:
-    if (headname != NULL) *headname = xstrdup(name.s);
-    if (contents != NULL) *contents = xstrdup(body.s);
-
-    return 0;
-}
+typedef struct {
+    const char *userid;
+    const char *host;
+    const char *remotehost;
+    const char *remoteip;
+    int edited_header;
+} script_data_t;
 
 static void fill_cache(message_data_t *m)
 {
-    rewind(m->data);
+    struct protstream *pin = prot_new(fileno(m->data), 0);
 
-    /* let's fill that header cache */
-    for (;;) {
-        char *name, *body;
-        strarray_t *contents;
-
-        if (parseheader(m->data, &name, &body) < 0) {
-            break;
-        }
-        /* put it in the hash table */
-        contents = (strarray_t *)hash_lookup(name, &m->cache);
-        if (!contents)
-            contents = hash_insert(name, strarray_new(), &m->cache);
-        strarray_appendm(contents, body);
-        free(name);
-    }
+    prot_rewind(pin);
+    spool_fill_hdrcache(pin, NULL, m->cache, NULL);
+    prot_free(pin);
 
     m->cache_full = 1;
 }
 
 /* we use the temp field in message_data to avoid having to malloc memory
-   to return, and we also can't expose our the receipients to the message */
+   to return, and we also can't expose our the recipients to the message */
 static int getenvelope(void *mc, const char *field, const char ***contents)
 {
     message_data_t *m = (message_data_t *)mc;
@@ -242,8 +131,6 @@ static int getenvelope(void *mc, const c
 static int getheader(void *v, const char *phead, const char ***body)
 {
     message_data_t *m = (message_data_t *) v;
-    strarray_t *contents;
-    char *head;
 
     *body = NULL;
 
@@ -251,16 +138,7 @@ static int getheader(void *v, const char
         fill_cache(m);
     }
 
-    /* copy header parameter so we can mangle it */
-    head = xstrdup(phead);
-    lcase(head);
-
-    /* check the cache */
-    contents = (strarray_t *)hash_lookup(head, &m->cache);
-    if (contents)
-        *body = (const char **) contents->data;
-
-    free(head);
+    *body = spool_getheader(m->cache, phead);
 
     if (*body) {
         return SIEVE_OK;
@@ -269,26 +147,117 @@ static int getheader(void *v, const char
     }
 }
 
+/* adds the header "head" with body "body" to msg */
+static int addheader(void *sc, void *mc,
+                     const char *head, const char *body, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = (message_data_t *) mc;
+
+    if (head == NULL || body == NULL) return SIEVE_FAIL;
+
+    if (index < 0) {
+        printf("appending header '%s: %s'\n", head, body);
+        spool_append_header(xstrdup(head), xstrdup(body), m->cache);
+    }
+    else {
+        printf("prepending header '%s: %s'\n", head, body);
+        spool_prepend_header(xstrdup(head), xstrdup(body), m->cache);
+    }
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+/* deletes (instance "index" of) the header "head" from msg */
+static int deleteheader(void *sc, void *mc, const char *head, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = (message_data_t *) mc;
+
+    if (head == NULL) return SIEVE_FAIL;
+
+    if (!index) {
+        printf("removing all headers '%s'\n", head);
+        spool_remove_header(xstrdup(head), m->cache);
+    }
+    else {
+        printf("removing header '%s[%d]'\n", head, index);
+        spool_remove_header_instance(xstrdup(head), index, m->cache);
+    }
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+static int getenvironment(void *sc, const char *keyname, char **res)
+{
+    script_data_t *sd = (script_data_t *) sc;
+    *res = NULL;
+
+    switch (*keyname) {
+    case 'd':
+        if (!strcmp(keyname, "domain")) {
+            const char *domain = strchr(sd->host, '.');
+
+            if (domain) domain++;
+            else domain = "";
+
+            *res = xstrdup(domain);
+        }
+        break;
+
+    case 'h':
+        if (!strcmp(keyname, "host")) *res = xstrdup(sd->host);
+        break;
+
+    case 'l':
+        if (!strcmp(keyname, "location")) *res = xstrdup("MDA");
+        break;
+
+    case 'n':
+        if (!strcmp(keyname, "name")) *res = xstrdup("Cyrus LMTP");
+        break;
+
+    case 'p':
+        if (!strcmp(keyname, "phase")) *res = xstrdup("during");
+        break;
+
+    case 'r':
+        if (!strncmp(keyname, "remote-", 7)) {
+            if (!strcmp(keyname+7, "host"))
+                *res = xstrdup(sd->remotehost);
+            else if (sd->remoteip && !strcmp(keyname+7, "ip"))
+                *res = xstrdup(sd->remoteip);
+        }
+        break;
+
+    case 'v':
+        if (!strcmp(keyname, "version")) *res = xstrdup(CYRUS_VERSION);
+        break;
+    }
+
+    return (*res ? SIEVE_OK : SIEVE_FAIL);
+}
+
 static message_data_t *new_msg(FILE *msg, int size, const char *name)
 {
     message_data_t *m;
 
-    m = xmalloc(sizeof(message_data_t));
+    m = xzmalloc(sizeof(message_data_t));
     m->data = msg;
     m->size = size;
     m->name = xstrdup(name);
-    m->content.base = NULL;
-    m->content.len = 0;
-    m->content.body = NULL;
-    construct_hash_table(&m->cache, 1000, 0);
-    m->cache_full = 0;
+    m->cache = spool_new_hdrcache();
 
     return m;
 }
 
 static void free_msg(message_data_t *m)
 {
-    free_hash_table(&m->cache, (void(*)(void*))strarray_free);
+    spool_free_hdrcache(m->cache);
     free(m->name);
     free(m);
 }
@@ -309,7 +278,7 @@ static int getbody(void *mc, const char
     if (!m->content.body) {
         /* parse the message body if we haven't already */
         r = message_parse_file(m->data, &m->content.base,
-                               &m->content.len, &m->content.body);
+                               &m->content.len, &m->content.body, NULL);
     }
 
     /* XXX currently struct bodypart as defined in message.h is the same as
@@ -361,7 +330,10 @@ static int reject(void *ac, void *ic, vo
     message_data_t *m = (message_data_t *) mc;
     int *force_fail = (int*) ic;
 
-    printf("rejecting message '%s' with '%s'\n", m->name, rc->msg);
+    if (rc->is_extended)
+        printf("LMTP rejecting message '%s' with '%s'\n", m->name, rc->msg);
+    else
+        printf("rejecting message '%s' with '%s'\n", m->name, rc->msg);
 
     return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
 }
@@ -386,6 +358,61 @@ static int fileinto(void *ac, void *ic,
     return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
 }
 
+static int snooze(void *ac, void *ic, void *sc __attribute__((unused)),
+                  void *mc, const char **errmsg __attribute__((unused)))
+{
+    sieve_snooze_context_t *sn = (sieve_snooze_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    time_t now = time(NULL);
+    struct tm *tm = localtime(&now);
+    int i, day_inc = -1;
+    unsigned t;
+
+    if (sn->days & (1 << tm->tm_wday)) {
+        /* We have times for today - see if a future one is still available */
+        unsigned now_min = 60 * tm->tm_hour + tm->tm_min;
+
+        for (i = 0; i < arrayu64_size(sn->times); i++) {
+            t = arrayu64_nth(sn->times, i);
+            if (t >= now_min) {
+                day_inc = 0;
+                break;
+            }
+        }
+    }
+    if (day_inc == -1) {
+        /* Use first time on next available day */
+        t = arrayu64_nth(sn->times, 0);
+
+        /* Find next available day */
+        for (i = tm->tm_wday+1; i < 14; i++) {
+            if (sn->days & (1 << (i % 7))) {
+                day_inc = i - tm->tm_wday;
+                break;
+            }
+        }
+    }
+
+    tm->tm_mday += day_inc;
+    tm->tm_hour = t / 60;
+    tm->tm_min = t % 60;
+    tm->tm_sec = 0;
+    mktime(tm);
+
+    printf("snoozing message '%s' until %s\n", m->name, asctime(tm));
+    if (sn->imapflags->count) {
+        char *s = strarray_join(sn->imapflags, "' '");
+        if (s) {
+            printf("\twith flags '%s'\n", s);
+            free(s);
+        }
+    }
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
 static int keep(void *ac, void *ic, void *sc __attribute__((unused)),
                 void *mc, const char **errmsg __attribute__((unused)))
 {
@@ -431,6 +458,11 @@ static int notify(void *ac, void *ic, vo
     return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
 }
 
+void sieve_log(void *sc __attribute__((unused)), void *mc __attribute__((unused)), const char *text)
+{
+    printf("sieve log: text=%s\n", text);
+}
+
 static int mysieve_error(int lineno, const char *msg,
                          void *i __attribute__((unused)),
                          void *s __attribute__((unused)))
@@ -460,18 +492,22 @@ static int autorespond(void *ac, void *i
     char yn;
     int i;
 
-    if (vacation_answer)
+    if (vacation_answer) {
         yn = vacation_answer;
-    else {
-    printf("Have I already responded to '");
-    for (i = 0; i < SIEVE_HASHLEN; i++) {
-        printf("%x", arc->hash[i]);
     }
-    if (arc->seconds % DAY2SEC)
-        printf("' in %d seconds? ", arc->seconds);
-    else
-        printf("' in %d days? ", arc->seconds / DAY2SEC);
-    scanf(" %c", &yn);
+    else {
+        printf("Have I already responded to '");
+        for (i = 0; i < SIEVE_HASHLEN; i++) {
+            printf("%x", arc->hash[i]);
+        }
+        if (arc->seconds % DAY2SEC) {
+            printf("' in %d seconds? ", arc->seconds);
+        }
+        else {
+            printf("' in %d days? ", arc->seconds / DAY2SEC);
+        }
+        if (!scanf(" %c", &yn))
+            return SIEVE_FAIL;
     }
 
     if (TOLOWER(yn) == 'y') return SIEVE_DONE;
@@ -480,8 +516,8 @@ static int autorespond(void *ac, void *i
     return SIEVE_FAIL;
 }
 
-static int send_response(void *ac, void *ic, void *sc __attribute__((unused)),
-                         void *mc, const char **errmsg __attribute__((unused)))
+static int send_response(void *ac, void *ic, void *sc,
+                         void *mc, const char **errmsg)
 {
     sieve_send_response_context_t *src = (sieve_send_response_context_t *) ac;
     message_data_t *m = (message_data_t *) mc;
@@ -490,9 +526,54 @@ static int send_response(void *ac, void
     printf("echo '%s' | mail -s '%s' '%s' for message '%s' (from: %s)\n",
            src->msg, src->subj, src->addr, m->name, src->fromaddr);
 
+    if (src->fcc.mailbox) {
+        message_data_t vmc = { .name = "vacation-autoresponse" };
+
+        (void) fileinto(&src->fcc, ic, sc, &vmc, errmsg);
+    }
+
     return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
 }
 
+#ifdef WITH_JMAP
+#include "imap/jmap_mail_query.h"
+#include "imap/mboxname.h"
+
+static int jmapquery(void *sc, void *mc, const char *json)
+{
+    script_data_t *sd = (script_data_t *) sc;
+    message_data_t *md = (message_data_t *) mc;
+    struct buf msg = BUF_INITIALIZER;
+    const char *userid = sd->userid;
+    json_error_t jerr;
+    json_t *jfilter, *err = NULL;
+    int r;
+
+    /* Create filter from json */
+    jfilter = json_loads(json, 0, &jerr);
+    if (!jfilter) return 0;
+
+    /* mmap the staged message file */
+    buf_refresh_mmap(&msg, 1, fileno(md->data), md->name, md->size, NULL);
+
+    /* Run query */
+    r = jmap_email_matchmime(&msg, jfilter, userid, time(NULL), &err);
+
+    if (err) {
+        char *errstr = json_dumps(err, JSON_COMPACT);
+        fprintf(stderr, "sieve: jmapquery: %s\n", errstr);
+
+        free(errstr);
+        r = SIEVE_RUN_ERROR;
+    }
+
+    json_decref(jfilter);
+    buf_free(&msg);
+
+    return r;
+}
+#endif
+
 static sieve_vacation_t vacation = {
     0,                          /* min response */
     0,                          /* max response */
@@ -507,9 +588,13 @@ static int usage(const char *argv0)
     fprintf(stderr, "%s -v script\n", argv0);
     fprintf(stderr, "%s [opts] message script\n", argv0);
     fprintf(stderr, "\n");
+    fprintf(stderr, "   -u userid\n");
     fprintf(stderr, "   -e envelope_from\n");
     fprintf(stderr, "   -t envelope_to\n");
     fprintf(stderr, "   -r y|n - have sent vacation response already? (if required)\n");
+    fprintf(stderr, "   -h local_hostname\n");
+    fprintf(stderr, "   -H remote_hostname\n");
+    fprintf(stderr, "   -I remote_ipaddr\n");
     exit(1);
 }
 
@@ -518,19 +603,26 @@ int main(int argc, char *argv[])
     sieve_interp_t *i;
     sieve_execute_t *exe = NULL;
     message_data_t *m = NULL;
-    char *script = NULL, *message = NULL;
+    char *tmpscript = NULL, *script = NULL, *message = NULL;
     int c, force_fail = 0;
     int fd, res;
     struct stat sbuf;
     static strarray_t mark = STRARRAY_INITIALIZER;
     static strarray_t e_from = STRARRAY_INITIALIZER;
     static strarray_t e_to = STRARRAY_INITIALIZER;
+    char *alt_config = NULL;
+    script_data_t sd = { NULL, NULL, "", NULL, 0 };
+    FILE *f;
+
     /* prevent crashes if -e or -t aren't specified */
     strarray_append(&e_from, "");
     strarray_append(&e_to, "");
 
-    while ((c = getopt(argc, argv, "v:fe:t:r:")) != EOF)
+    while ((c = getopt(argc, argv, "C:v:fe:t:r:h:H:I:u:")) != EOF)
         switch (c) {
+        case 'C': /* alt config file */
+            alt_config = optarg;
+            break;
         case 'v':
             script = optarg;
             break;
@@ -548,6 +640,18 @@ int main(int argc, char *argv[])
         case 'r':
             vacation_answer = optarg[0];
             break;
+        case 'h':
+            sd.host = optarg;
+            break;
+        case 'H':
+            sd.remotehost = optarg;
+            break;
+        case 'I':
+            sd.remoteip = optarg;
+            break;
+        case 'u':
+            sd.userid = optarg;
+            break;
         default:
             usage(argv[0]);
             break;
@@ -562,6 +666,74 @@ int main(int argc, char *argv[])
         }
     }
 
+    /* Load configuration file. */
+    config_read(alt_config, 0);
+
+    if (!sd.host) sd.host = config_servername;
+
+    /* Check if script is bytecode or text */
+    f = fopen(script, "r");
+    if (f == NULL) {
+        fprintf(stderr, "Unable to open %s for reading\n", script);
+        exit(1);
+    }
+    else {
+        char magic[BYTECODE_MAGIC_LEN];
+        char tempname[] = "/tmp/sieve-test-bytecode-XXXXXX";
+        sieve_script_t *s = NULL;
+        bytecode_info_t *bc = NULL;
+        char *err = NULL;
+
+        if (fread(magic, BYTECODE_MAGIC_LEN, 1, f) <= 0 ||
+            memcmp(magic, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN) != 0) {
+            /* Not Sieve bytecode - try to parse as text */
+
+            if (sieve_script_parse_only(f, &err, &s) != SIEVE_OK) {
+                if(err) {
+                    fprintf(stderr, "Unable to parse script: %s\n", err);
+                } else {
+                    fprintf(stderr, "Unable to parse script\n");
+                }
+                sieve_script_free(&s);
+
+                exit(1);
+            }
+
+            /* Now, generate the bytecode */
+            if (sieve_generate_bytecode(&bc, s) == -1) {
+                fprintf(stderr, "bytecode generate failed\n");
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            /* Now, open a temp bytecode file */
+            script = tmpscript = tempname;
+            fd = mkstemp(script);
+            if (fd < 0) {
+                fprintf(stderr, "couldn't open bytecode output file %s\n", script);
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            /* Now, emit the bytecode */
+            if (sieve_emit_bytecode(fd, bc) == -1) {
+                fprintf(stderr, "bytecode emit failed\n");
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            close(fd);
+
+            sieve_free_bytecode(&bc);
+            sieve_script_free(&s);
+        }
+
+        fclose(f);
+    }
+
     i = sieve_interp_alloc(&force_fail);
     assert(i != NULL);
 
@@ -569,12 +741,17 @@ int main(int argc, char *argv[])
     sieve_register_discard(i, discard);
     sieve_register_reject(i, reject);
     sieve_register_fileinto(i, fileinto);
+    sieve_register_snooze(i, snooze);
     sieve_register_keep(i, keep);
     sieve_register_size(i, getsize);
     sieve_register_header(i, getheader);
+    sieve_register_addheader(i, addheader);
+    sieve_register_deleteheader(i, deleteheader);
     sieve_register_envelope(i, getenvelope);
+    sieve_register_environment(i, getenvironment);
     sieve_register_body(i, getbody);
     sieve_register_include(i, getinclude);
+    sieve_register_logger(i, sieve_log);
 
     res = sieve_register_vacation(i, &vacation);
     if (res != SIEVE_OK) {
@@ -585,19 +762,26 @@ int main(int argc, char *argv[])
     strarray_append(&mark, "\\flagged");
     sieve_register_imapflags(i, &mark);
 
-    sieve_register_notify(i, notify);
+    sieve_register_notify(i, notify, NULL);
     sieve_register_parse_error(i, mysieve_error);
     sieve_register_execute_error(i, mysieve_execute_error);
 
+#ifdef WITH_JMAP
+    sieve_register_jmapquery(i, &jmapquery);
+#endif
+
     res = sieve_script_load(script, &exe);
     if (res != SIEVE_OK) {
         printf("sieve_script_load() returns %d\n", res);
         exit(1);
     }
 
-    if (message) {
-        FILE *f;
+    if (tmpscript) {
+        /* Remove temp bytecode file */
+        unlink(tmpscript);
+    }
 
+    if (message) {
         fd = open(message, O_RDONLY);
         res = fstat(fd, &sbuf);
         if (res != 0) {
@@ -614,7 +798,7 @@ int main(int argc, char *argv[])
         m->env_from = &e_from;
         m->env_to = &e_to;
 
-        res = sieve_execute_bytecode(exe, i, NULL, m);
+        res = sieve_execute_bytecode(exe, i, &sd, m);
         if (res != SIEVE_OK) {
             printf("sieve_execute_bytecode() returns %d\n", res);
             exit(1);
diff -pruN 3.0.13-5/sieve/test_mailbox.c 3.2.0-3/sieve/test_mailbox.c
--- 3.0.13-5/sieve/test_mailbox.c	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/sieve/test_mailbox.c	2020-05-04 03:28:02.000000000 +0000
@@ -0,0 +1,796 @@
+/*
+ * test_mailbox.c -- tester for libcyrus_sieve
+ * Ken Murchison
+ *
+ * usage: "test_mailbox mailbox script"
+ */
+/*
+ * Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Carnegie Mellon University
+ *      Center for Technology Transfer and Enterprise Creation
+ *      4615 Forbes Avenue
+ *      Suite 302
+ *      Pittsburgh, PA  15213
+ *      (412) 268-7393, fax: (412) 268-7395
+ *      innovation@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <stdio.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sysexits.h>
+#include <fcntl.h>
+#include <ctype.h>
+#include <string.h>
+#include <stdlib.h>
+#include <syslog.h>
+
+#include "libconfig.h"
+#include "assert.h"
+#include "sieve_interface.h"
+#include "bytecode.h"
+#include "comparator.h"
+#include "tree.h"
+#include "sieve/sieve.h"
+#include "imap/global.h"
+#include "imap/mailbox.h"
+#include "imap/mboxname.h"
+#include "imap/message.h"
+#include "imap/spool.h"
+#include "util.h"
+#include "xmalloc.h"
+#include "xstrlcat.h"
+#include "xstrlcpy.h"
+#include "hash.h"
+#include "times.h"
+
+static char vacation_answer;
+
+/* current namespace */
+static struct namespace test_namespace;
+
+typedef struct {
+    char *name;
+    FILE *data;
+    int size;
+    struct message_content content;
+
+    int cache_full;
+    hdrcache_t cache;
+    strarray_t *env_from;
+    strarray_t *env_to;
+} message_data_t;
+
+typedef struct {
+    const char *host;
+    const char *remotehost;
+    const char *remoteip;
+    int edited_header;
+} script_data_t;
+
+static void fill_cache(message_data_t *m)
+{
+    struct protstream *pin = prot_new(fileno(m->data), 0);
+
+    prot_rewind(pin);
+    spool_fill_hdrcache(pin, NULL, m->cache, NULL);
+    prot_free(pin);
+
+    m->cache_full = 1;
+}
+
+/* we use the temp field in message_data to avoid having to malloc memory
+   to return, and we also can't expose our the recipients to the message */
+static int getenvelope(void *mc, const char *field, const char ***contents)
+{
+    message_data_t *m = (message_data_t *)mc;
+
+    if (!strcasecmp(field, "from")) {
+        *contents = (const char **)m->env_from->data;
+        return SIEVE_OK;
+    } else if (!strcasecmp(field, "to")) {
+        *contents = (const char **)m->env_to->data;
+        return SIEVE_OK;
+    } else {
+        *contents = NULL;
+        return SIEVE_FAIL;
+    }
+}
+
+/* gets the header "head" from msg. */
+static int getheader(void *v, const char *phead, const char ***body)
+{
+    message_data_t *m = (message_data_t *) v;
+
+    *body = NULL;
+
+    if (!m->cache_full) {
+        fill_cache(m);
+    }
+
+    *body = spool_getheader(m->cache, phead);
+
+    if (*body) {
+        return SIEVE_OK;
+    } else {
+        return SIEVE_FAIL;
+    }
+}
+
+/* adds the header "head" with body "body" to msg */
+static int addheader(void *sc, void *mc,
+                     const char *head, const char *body, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = (message_data_t *) mc;
+
+    if (head == NULL || body == NULL) return SIEVE_FAIL;
+
+    if (index < 0) {
+        printf("appending header '%s: %s'\n", head, body);
+        spool_append_header(xstrdup(head), xstrdup(body), m->cache);
+    }
+    else {
+        printf("prepending header '%s: %s'\n", head, body);
+        spool_prepend_header(xstrdup(head), xstrdup(body), m->cache);
+    }
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+/* deletes (instance "index" of) the header "head" from msg */
+static int deleteheader(void *sc, void *mc, const char *head, int index)
+{
+    script_data_t *sd = (script_data_t *)sc;
+    message_data_t *m = (message_data_t *) mc;
+
+    if (head == NULL) return SIEVE_FAIL;
+
+    if (!index) {
+        printf("removing all headers '%s'\n", head);
+        spool_remove_header(xstrdup(head), m->cache);
+    }
+    else {
+        printf("removing header '%s[%d]'\n", head, index);
+        spool_remove_header_instance(xstrdup(head), index, m->cache);
+    }
+
+    sd->edited_header = 1;
+
+    return SIEVE_OK;
+}
+
+static int getenvironment(void *sc, const char *keyname, char **res)
+{
+    script_data_t *sd = (script_data_t *) sc;
+    *res = NULL;
+
+    switch (*keyname) {
+    case 'd':
+        if (!strcmp(keyname, "domain")) {
+            const char *domain = strchr(sd->host, '.');
+
+            if (domain) domain++;
+            else domain = "";
+
+            *res = xstrdup(domain);
+        }
+        break;
+
+    case 'h':
+        if (!strcmp(keyname, "host")) *res = xstrdup(sd->host);
+        break;
+
+    case 'l':
+        if (!strcmp(keyname, "location")) *res = xstrdup("MDA");
+        break;
+
+    case 'n':
+        if (!strcmp(keyname, "name")) *res = xstrdup("Cyrus LMTP");
+        break;
+
+    case 'p':
+        if (!strcmp(keyname, "phase")) *res = xstrdup("during");
+        break;
+
+    case 'r':
+        if (!strncmp(keyname, "remote-", 7)) {
+            if (!strcmp(keyname+7, "host"))
+                *res = xstrdup(sd->remotehost);
+            else if (sd->remoteip && !strcmp(keyname+7, "ip"))
+                *res = xstrdup(sd->remoteip);
+        }
+        break;
+
+    case 'v':
+        if (!strcmp(keyname, "version")) *res = xstrdup(CYRUS_VERSION);
+        break;
+    }
+
+    return (*res ? SIEVE_OK : SIEVE_FAIL);
+}
+
+static message_data_t *new_msg(FILE *msg, int size, const char *name)
+{
+    message_data_t *m;
+
+    m = xzmalloc(sizeof(message_data_t));
+    m->data = msg;
+    m->size = size;
+    m->name = xstrdup(name);
+    m->cache = spool_new_hdrcache();
+
+    return m;
+}
+
+static void free_msg(message_data_t *m)
+{
+    spool_free_hdrcache(m->cache);
+    free(m->name);
+    free(m);
+}
+
+static int getsize(void *mc, int *size)
+{
+    message_data_t *m = (message_data_t *) mc;
+
+    *size = m->size;
+    return SIEVE_OK;
+}
+
+static int getbody(void *mc, const char **content_types, sieve_bodypart_t ***parts)
+{
+    message_data_t *m = (message_data_t *) mc;
+    int r = 0;
+
+    if (!m->content.body) {
+        /* parse the message body if we haven't already */
+        r = message_parse_file(m->data, &m->content.base,
+                               &m->content.len, &m->content.body, NULL);
+    }
+
+    /* XXX currently struct bodypart as defined in message.h is the same as
+       sieve_bodypart_t as defined in sieve_interface.h, so we can typecast */
+    if (!r) message_fetch_part(&m->content, content_types,
+                               (struct bodypart ***) parts);
+    return (!r ? SIEVE_OK : SIEVE_FAIL);
+}
+
+static int getinclude(void *sc __attribute__((unused)),
+                      const char *script,
+                      int isglobal __attribute__((unused)),
+                      char *fpath, size_t size)
+{
+    strlcpy(fpath, script, size);
+    strlcat(fpath, ".bc", size);
+
+    return SIEVE_OK;
+}
+
+static int redirect(void *ac, void *ic, void *sc __attribute__((unused)),
+                    void *mc, const char **errmsg __attribute__((unused)))
+{
+    sieve_redirect_context_t *rc = (sieve_redirect_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    printf("redirecting message '%s' to '%s'\n", m->name, rc->addr);
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static int discard(void *ac __attribute__((unused)),
+                   void *ic, void *sc __attribute__((unused)),
+                   void *mc, const char **errmsg __attribute__((unused)))
+{
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    printf("discarding message '%s'\n", m->name);
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static int reject(void *ac, void *ic, void *sc __attribute__((unused)),
+                  void *mc, const char **errmsg __attribute__((unused)))
+{
+    sieve_reject_context_t *rc = (sieve_reject_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    if (rc->is_extended)
+        printf("LMTP rejecting message '%s' with '%s'\n", m->name, rc->msg);
+    else
+        printf("rejecting message '%s' with '%s'\n", m->name, rc->msg);
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static int fileinto(void *ac, void *ic, void *sc __attribute__((unused)),
+                    void *mc, const char **errmsg __attribute__((unused)))
+{
+    sieve_fileinto_context_t *fc = (sieve_fileinto_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    printf("filing message '%s' into '%s'\n", m->name, fc->mailbox);
+
+    if (fc->imapflags->count) {
+        char *s = strarray_join(fc->imapflags, "' '");
+        if (s) {
+            printf("\twith flags '%s'\n", s);
+            free(s);
+        }
+    }
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static int keep(void *ac, void *ic, void *sc __attribute__((unused)),
+                void *mc, const char **errmsg __attribute__((unused)))
+{
+    sieve_keep_context_t *kc = (sieve_keep_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    printf("keeping message '%s'\n", m->name);
+    if (kc->imapflags->count) {
+        char *s = strarray_join(kc->imapflags, "' '");
+        if (s) {
+            printf("\twith flags '%s'\n", s);
+            free(s);
+        }
+    }
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static int notify(void *ac, void *ic, void *sc __attribute__((unused)),
+                  void *mc __attribute__((unused)),
+                  const char **errmsg __attribute__((unused)))
+{
+    sieve_notify_context_t *nc = (sieve_notify_context_t *) ac;
+    int *force_fail = (int*) ic;
+    int flag = 0;
+
+    printf("notify ");
+    if (nc->method) {
+        const char **opts = nc->options;
+
+        printf("%s(", nc->method);
+        while (opts && *opts) {
+            if (flag) printf(", ");
+            printf("%s", *opts);
+            opts++;
+            flag = 1;
+        }
+        printf("), ");
+    }
+    printf("msg = '%s' with priority = %s\n",nc->message, nc->priority);
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+void sieve_log(void *sc __attribute__((unused)), void *mc __attribute__((unused)), const char *text)
+{
+    printf("sieve log: text=%s\n", text);
+}
+
+static int mysieve_error(int lineno, const char *msg,
+                         void *i __attribute__((unused)),
+                         void *s __attribute__((unused)))
+{
+    fprintf(stderr, "line %d: %s\r\n", lineno, msg);
+
+    return SIEVE_OK;
+}
+
+static int mysieve_execute_error(const char *msg,
+                                 void *i __attribute__((unused)),
+                                 void *s __attribute__((unused)),
+                                 void *m __attribute__((unused)))
+{
+    fprintf(stderr, "%s\r\n", msg);
+
+    return SIEVE_OK;
+}
+
+
+static int autorespond(void *ac, void *ic __attribute__((unused)),
+                       void *sc __attribute__((unused)),
+                       void *mc __attribute__((unused)),
+                       const char **errmsg __attribute__((unused)))
+{
+    sieve_autorespond_context_t *arc = (sieve_autorespond_context_t *) ac;
+    char yn;
+    int i;
+
+    if (vacation_answer) {
+        yn = vacation_answer;
+    }
+    else {
+        printf("Have I already responded to '");
+        for (i = 0; i < SIEVE_HASHLEN; i++) {
+            printf("%x", arc->hash[i]);
+        }
+        if (arc->seconds % DAY2SEC) {
+            printf("' in %d seconds? ", arc->seconds);
+        }
+        else {
+            printf("' in %d days? ", arc->seconds / DAY2SEC);
+        }
+        if (!scanf(" %c", &yn))
+            return SIEVE_FAIL;
+    }
+
+    if (TOLOWER(yn) == 'y') return SIEVE_DONE;
+    if (TOLOWER(yn) == 'n') return SIEVE_OK;
+
+    return SIEVE_FAIL;
+}
+
+static int send_response(void *ac, void *ic, void *sc,
+                         void *mc, const char **errmsg)
+{
+    sieve_send_response_context_t *src = (sieve_send_response_context_t *) ac;
+    message_data_t *m = (message_data_t *) mc;
+    int *force_fail = (int*) ic;
+
+    printf("echo '%s' | mail -s '%s' '%s' for message '%s' (from: %s)\n",
+           src->msg, src->subj, src->addr, m->name, src->fromaddr);
+
+    if (src->fcc.mailbox) {
+        message_data_t vmc = { .name = "vacation-autoresponse" };
+
+        (void) fileinto(&src->fcc, ic, sc, &vmc, errmsg);
+    }
+
+    return (*force_fail ? SIEVE_FAIL : SIEVE_OK);
+}
+
+static sieve_vacation_t vacation = {
+    0,                          /* min response */
+    0,                          /* max response */
+    &autorespond,               /* autorespond() */
+    &send_response              /* send_response() */
+};
+
+static int usage(const char *argv0) __attribute__((noreturn));
+static int usage(const char *argv0)
+{
+    fprintf(stderr, "usage:\n");
+    fprintf(stderr, "%s -v script\n", argv0);
+    fprintf(stderr, "%s [opts] mailbox script\n", argv0);
+    fprintf(stderr, "\n");
+    fprintf(stderr, "   -e envelope_from\n");
+    fprintf(stderr, "   -t envelope_to\n");
+    fprintf(stderr, "   -r y|n - have sent vacation response already? (if required)\n");
+    fprintf(stderr, "   -h local_hostname\n");
+    fprintf(stderr, "   -H remote_hostname\n");
+    fprintf(stderr, "   -I remote_ipaddr\n");
+    exit(1);
+}
+
+static strarray_t e_from = STRARRAY_INITIALIZER;
+static strarray_t e_to = STRARRAY_INITIALIZER;
+
+int process_message(const char *path, sieve_execute_t *exe,
+                    sieve_interp_t *i, script_data_t *sd)
+{
+    message_data_t *m = NULL;
+    struct stat sbuf;
+    int fd, res;
+    FILE *f;
+
+    fd = open(path, O_RDONLY);
+    res = fstat(fd, &sbuf);
+    if (res != 0) {
+        perror("fstat");
+    }
+
+    f = fdopen(fd, "r");
+    if (f) m = new_msg(f, sbuf.st_size, path);
+    if (!f || !m) {
+        printf("can not open message '%s'\n", path);
+        return 1;
+    }
+
+    m->env_from = &e_from;
+    m->env_to = &e_to;
+
+    res = sieve_execute_bytecode(exe, i, sd, m);
+    free_msg(m);
+    fclose(f);
+    close(fd);
+    if (res != SIEVE_OK) {
+        printf("sieve_execute_bytecode() returns %d\n", res);
+        return 1;
+    }
+
+    return 0;
+}
+
+int main(int argc, char *argv[])
+{
+    sieve_interp_t *i;
+    sieve_execute_t *exe = NULL;
+    char *tmpscript = NULL, *script = NULL, *extname = NULL;
+    int c, force_fail = 0;
+    int fd, res, r;
+    static strarray_t mark = STRARRAY_INITIALIZER;
+    char *alt_config = NULL;
+    script_data_t sd = { NULL, "", NULL, 0 };
+    FILE *f;
+    unsigned uid = 0;
+
+    /* prevent crashes if -e or -t aren't specified */
+    strarray_append(&e_from, "");
+    strarray_append(&e_to, "");
+
+    while ((c = getopt(argc, argv, "C:v:fu:e:t:r:h:H:I:")) != EOF)
+        switch (c) {
+        case 'C': /* alt config file */
+            alt_config = optarg;
+            break;
+        case 'v':
+            script = optarg;
+            break;
+        case 'f':
+            force_fail = 1;
+            break;
+        case 'u':
+            uid = strtoul(optarg, NULL, 10);
+            break;
+        case 'e':
+            strarray_fini(&e_from);
+            strarray_append(&e_from, optarg);
+            break;
+        case 't':
+            strarray_fini(&e_to);
+            strarray_append(&e_to, optarg);
+            break;
+        case 'r':
+            vacation_answer = optarg[0];
+            break;
+        case 'h':
+            sd.host = optarg;
+            break;
+        case 'H':
+            sd.remotehost = optarg;
+            break;
+        case 'I':
+            sd.remoteip = optarg;
+            break;
+        default:
+            usage(argv[0]);
+            break;
+        }
+
+    if (!script) {
+        if ((argc - optind) < 2)
+            usage(argv[0]);
+        else {
+            extname = argv[optind];
+            script = argv[optind+1];
+        }
+    }
+
+    cyrus_init(alt_config, "test_mailbox", 0, CONFIG_NEED_PARTITION_DATA);
+    global_sasl_init(1,0,NULL);
+
+    /* Set namespace -- force standard (internal) */
+    if ((r = mboxname_init_namespace(&test_namespace, 1)) != 0) {
+        syslog(LOG_ERR, "%s", error_message(r));
+        fatal(error_message(r), EX_CONFIG);
+    }
+
+    if (!sd.host) sd.host = config_servername;
+
+    /* Check if script is bytecode or text */
+    f = fopen(script, "r");
+    if (f == NULL) {
+        fprintf(stderr, "Unable to open %s for reading\n", script);
+        exit(1);
+    }
+    else {
+        char magic[BYTECODE_MAGIC_LEN];
+        char tempname[] = "/tmp/sieve-test-bytecode-XXXXXX";
+        sieve_script_t *s = NULL;
+        bytecode_info_t *bc = NULL;
+        char *err = NULL;
+
+        if (fread(magic, BYTECODE_MAGIC_LEN, 1, f) <= 0 ||
+            memcmp(magic, BYTECODE_MAGIC, BYTECODE_MAGIC_LEN) != 0) {
+            /* Not Sieve bytecode - try to parse as text */
+
+            if (sieve_script_parse_only(f, &err, &s) != SIEVE_OK) {
+                if(err) {
+                    fprintf(stderr, "Unable to parse script: %s\n", err);
+                } else {
+                    fprintf(stderr, "Unable to parse script\n");
+                }
+                sieve_script_free(&s);
+
+                exit(1);
+            }
+
+            /* Now, generate the bytecode */
+            if (sieve_generate_bytecode(&bc, s) == -1) {
+                fprintf(stderr, "bytecode generate failed\n");
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            /* Now, open a temp bytecode file */
+            script = tmpscript = tempname;
+            fd = mkstemp(script);
+            if (fd < 0) {
+                fprintf(stderr, "couldn't open bytecode output file %s\n", script);
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            /* Now, emit the bytecode */
+            if (sieve_emit_bytecode(fd, bc) == -1) {
+                fprintf(stderr, "bytecode emit failed\n");
+                sieve_free_bytecode(&bc);
+                sieve_script_free(&s);
+                exit(1);
+            }
+
+            close(fd);
+
+            sieve_free_bytecode(&bc);
+            sieve_script_free(&s);
+        }
+
+        fclose(f);
+    }
+
+    i = sieve_interp_alloc(&force_fail);
+    assert(i != NULL);
+
+    sieve_register_redirect(i, redirect);
+    sieve_register_discard(i, discard);
+    sieve_register_reject(i, reject);
+    sieve_register_fileinto(i, fileinto);
+    sieve_register_keep(i, keep);
+    sieve_register_size(i, getsize);
+    sieve_register_header(i, getheader);
+    sieve_register_addheader(i, addheader);
+    sieve_register_deleteheader(i, deleteheader);
+    sieve_register_envelope(i, getenvelope);
+    sieve_register_environment(i, getenvironment);
+    sieve_register_body(i, getbody);
+    sieve_register_include(i, getinclude);
+    sieve_register_logger(i, sieve_log);
+
+    res = sieve_register_vacation(i, &vacation);
+    if (res != SIEVE_OK) {
+        printf("sieve_register_vacation() returns %d\n", res);
+        exit(1);
+    }
+
+    strarray_append(&mark, "\\flagged");
+    sieve_register_imapflags(i, &mark);
+
+    sieve_register_notify(i, notify, NULL);
+    sieve_register_parse_error(i, mysieve_error);
+    sieve_register_execute_error(i, mysieve_execute_error);
+
+    res = sieve_script_load(script, &exe);
+    if (res != SIEVE_OK) {
+        printf("sieve_script_load() returns %d\n", res);
+        exit(1);
+    }
+
+    if (tmpscript) {
+        /* Remove temp bytecode file */
+        unlink(tmpscript);
+    }
+
+    if (extname) {
+        char *intname = mboxname_from_external(extname, &test_namespace, NULL);
+        struct mailbox *mailbox = NULL;
+
+        /* Open/lock header */
+        r = mailbox_open_irl(intname, &mailbox);
+        free(intname);
+        if (r) {
+            printf("can not open mailbox '%s': %s\n", extname, error_message(r));
+            exit(1);
+        }
+
+        if (uid) {
+            const char *path =
+                mboxname_datapath(mailbox->part, mailbox->name,
+                                  mailbox->uniqueid, uid);
+
+            printf("\n\nProcessing UID %u:\n", uid);
+            r = process_message(path, exe, i, &sd);
+        }
+        else {
+            struct mailbox_iter *iter =
+                mailbox_iter_init(mailbox, 0, ITER_SKIP_EXPUNGED);
+            const message_t *msg;
+            while ((msg = mailbox_iter_step(iter))) {
+                const struct index_record *record = msg_record(msg);
+                const char *path =
+                    mboxname_datapath(mailbox->part, mailbox->name,
+                                      mailbox->uniqueid, record->uid);
+
+                printf("\n\nProcessing UID %u:\n", record->uid);
+                r = process_message(path, exe, i, &sd);
+            }
+
+            mailbox_iter_done(&iter);
+        }
+
+        mailbox_close(&mailbox);
+    }
+
+    /*used to be sieve_script_free*/
+    res = sieve_script_unload(&exe);
+    if (res != SIEVE_OK) {
+        printf("sieve_script_unload() returns %d\n", res);
+        exit(1);
+    }
+    res = sieve_interp_free(&i);
+    if (res != SIEVE_OK) {
+        printf("sieve_interp_free() returns %d\n", res);
+        exit(1);
+    }
+
+    strarray_fini(&e_from);
+    strarray_fini(&e_to);
+    strarray_fini(&mark);
+
+    cyrus_done();
+
+    return 0;
+}
+
+EXPORTED void fatal(const char* message, int rc)
+{
+    fprintf(stderr, "fatal error: %s\n", message);
+    exit(rc);
+}
diff -pruN 3.0.13-5/sieve/tests/README 3.2.0-3/sieve/tests/README
--- 3.0.13-5/sieve/tests/README	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/tests/README	2020-04-24 02:03:00.000000000 +0000
@@ -2,13 +2,13 @@ there are four directories
 
 action (sieve actions)
 test (the test cases for if)
-action extension (extensons to sieve that are actions)
+action extension (extensions to sieve that are actions)
 testExtension (extensions to sieve that are tests)
 
 inside these directories is:
 
 XXXXX.s (sieve script)
-XXXXX.key (what this script should do with thest messages
+XXXXX.key (what this script should do with these messages
 serverm (dir of messages- for testing the script using lmtp server)
 testm (dir of messages- for testing the script using sieve test program)
 
diff -pruN 3.0.13-5/sieve/tests/test/uberTestScript.s 3.2.0-3/sieve/tests/test/uberTestScript.s
--- 3.0.13-5/sieve/tests/test/uberTestScript.s	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/tests/test/uberTestScript.s	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 /*using redirect to test if, elsif, and else, along with all of the tests
   that can be inside
 
-  this is still being added to, there are almost certaintly conditions not
+  this is still being added to, there are almost certainly conditions not
   being tested
 
 
@@ -50,7 +50,7 @@ if address :localpart :matches "from" "z
 
 
 #add tests/messages that differentiate between header/address.
-#need to write messages and to tweak tests to make sure everyhting works
+#need to write messages and to tweak tests to make sure everything works
 #as expected
 
 if header :contains "Date" "Feb"
diff -pruN 3.0.13-5/sieve/tests/testExtension/uberExtensionTestScript.s 3.2.0-3/sieve/tests/testExtension/uberExtensionTestScript.s
--- 3.0.13-5/sieve/tests/testExtension/uberExtensionTestScript.s	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/tests/testExtension/uberExtensionTestScript.s	2020-04-24 02:03:00.000000000 +0000
@@ -1,7 +1,7 @@
 require ["regex", "relational", "comparator-i;ascii-numeric", "subaddress",
 	"envelope", "date", "index", "imap4flags", "variables"];
 
-#this is for the extra thigns we have added to sieve
+#this is for the extra things we have added to sieve
 #test extensions
 #envelope regex relational comparators subaddress(user and detail)
 
diff -pruN 3.0.13-5/sieve/tree.c 3.2.0-3/sieve/tree.c
--- 3.0.13-5/sieve/tree.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/tree.c	2020-05-04 03:28:02.000000000 +0000
@@ -1,7 +1,7 @@
 /* tree.c -- abstract syntax tree handling
  * Larry Greenfield
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -49,29 +49,158 @@
 #include "xmalloc.h"
 
 #include "tree.h"
+#include "script.h"
 #include "sieve/sieve_interface.h"
 #include "sieve/sieve.h"
 
-tag_t *new_tag(int type, char *s)
+extern void sieveerror_c(sieve_script_t *parse_script, int code, ...);
+
+static void init_comptags(comp_t *c)
 {
-    tag_t *p = (tag_t *) xzmalloc(sizeof(tag_t));
-    p->type = type;
-    p->arg = s;
-    return p;
+    c->match = c->relation = c->collation = -1;
 }
 
-taglist_t *new_taglist(tag_t *t, taglist_t *n)
+comp_t *canon_comptags(comp_t *c, sieve_script_t *parse_script)
 {
-    taglist_t *p = (taglist_t *) xzmalloc(sizeof(taglist_t));
-    p->t = t;
-    p->next = n;
-    return p;
+    if (c->match == -1) c->match = IS;
+    if (c->collation == -1) c->collation = ASCIICASEMAP;
+    if (c->match == COUNT && c->collation != ASCIINUMERIC) {
+        sieveerror_c(parse_script, SIEVE_MATCH_INCOMPAT,
+                     ":count", "i;ascii-numeric");
+    }
+    return c;
 }
 
-test_t *new_test(int type)
+test_t *new_test(int type, sieve_script_t *parse_script)
 {
     test_t *p = (test_t *) xzmalloc(sizeof(test_t));
+    const char *capability = "";
+    unsigned long long supported = SIEVE_CAPA_BASE;
+
     p->type = type;
+
+    switch (p->type) {
+    case HEADERT:
+        init_comptags(&p->u.hhs.comp);
+        break;
+
+    case HASFLAG:
+        capability = "imap4flags";
+        supported = parse_script->support & SIEVE_CAPA_IMAP4FLAGS;
+
+        init_comptags(&p->u.hhs.comp);
+        break;
+
+    case STRINGT:
+        capability = "variables";
+        supported = parse_script->support & SIEVE_CAPA_VARIABLES;
+
+        init_comptags(&p->u.hhs.comp);
+        break;
+
+    case ENVELOPE:
+        capability = "envelope";
+        supported = parse_script->support & SIEVE_CAPA_ENVELOPE;
+        GCC_FALLTHROUGH
+
+    case ADDRESS:
+        init_comptags(&p->u.ae.comp);
+        p->u.ae.addrpart = -1;
+        break;
+
+    case ENVIRONMENT:
+        capability = "environment";
+        supported = parse_script->support & SIEVE_CAPA_ENVIRONMENT;
+
+        init_comptags(&p->u.mm.comp);
+        break;
+
+    case BODY:
+        capability = "body";
+        supported = parse_script->support & SIEVE_CAPA_BODY;
+
+        init_comptags(&p->u.b.comp);
+        p->u.b.transform = p->u.b.offset = -1;
+        break;
+
+    case DATE:
+    case CURRENTDATE:
+        capability = "date";
+        supported = parse_script->support & SIEVE_CAPA_DATE;
+
+        init_comptags(&p->u.dt.comp);
+        p->u.dt.zonetag = -1;
+        break;
+
+    case NOTIFYMETHODCAPABILITY:
+        init_comptags(&p->u.mm.comp);
+        GCC_FALLTHROUGH
+
+    case VALIDNOTIFYMETHOD:
+        capability = "enotify";
+        supported = parse_script->support & SIEVE_CAPA_ENOTIFY;
+        break;
+
+    case IHAVE:
+        capability = "ihave";
+        supported = parse_script->support & SIEVE_CAPA_IHAVE;
+        break;
+
+    case MAILBOXEXISTS:
+        capability = "mailbox";
+        supported = parse_script->support & SIEVE_CAPA_MAILBOX;
+        break;
+
+    case METADATA:
+        init_comptags(&p->u.mm.comp);
+        GCC_FALLTHROUGH
+
+    case METADATAEXISTS:
+        capability = "mboxmetadata";
+        supported = parse_script->support & SIEVE_CAPA_MBOXMETA;
+        break;
+
+    case SERVERMETADATA:
+        init_comptags(&p->u.mm.comp);
+        GCC_FALLTHROUGH
+
+    case SERVERMETADATAEXISTS:
+        capability = "servermetadata";
+        supported = parse_script->support & SIEVE_CAPA_SERVERMETA;
+        break;
+
+    case VALIDEXTLIST:
+        capability = "extlists";
+        supported = parse_script->support & SIEVE_CAPA_EXTLISTS;
+        break;
+
+    case DUPLICATE:
+        capability = "duplicate";
+        supported = parse_script->support & SIEVE_CAPA_DUPLICATE;
+        p->u.dup.idtype = p->u.dup.seconds = -1;
+        break;
+
+    case SPECIALUSEEXISTS:
+        capability = "special-use";
+        supported = parse_script->support & SIEVE_CAPA_SPECIAL_USE;
+        init_comptags(&p->u.mm.comp);
+        break;
+
+    case MAILBOXIDEXISTS:
+        capability = "mailboxid";
+        supported = parse_script->support & SIEVE_CAPA_MAILBOXID;
+        break;
+
+    case JMAPQUERY:
+        capability = "x-cyrus-jmapquery";
+        supported = parse_script->support & SIEVE_CAPA_JMAPQUERY;
+        break;
+    }
+
+    if (!supported) {
+        sieveerror_c(parse_script, SIEVE_MISSING_REQUIRE, capability);
+    }
+
     return p;
 }
 
@@ -83,28 +212,121 @@ testlist_t *new_testlist(test_t *t, test
     return p;
 }
 
-commandlist_t *new_command(int type)
+commandlist_t *new_command(int type, sieve_script_t *parse_script)
 {
     commandlist_t *p = (commandlist_t *) xzmalloc(sizeof(commandlist_t));
+    const char *capability = "";
+    unsigned long long  supported = SIEVE_CAPA_BASE;
+
     p->type = type;
     p->next = NULL;
+
+    switch (type) {
+    case FILEINTO:
+        capability = "fileinto";
+        supported = parse_script->support & SIEVE_CAPA_FILEINTO;
+        break;
+
+    case REJCT:
+        capability = "reject";
+        supported = parse_script->support & SIEVE_CAPA_REJECT;
+        break;
+
+    case EREJECT:
+        capability = "ereject";
+        supported = parse_script->support & SIEVE_CAPA_EREJECT;
+        break;
+
+    case VACATION:
+        capability = "vacation";
+        supported = parse_script->support & SIEVE_CAPA_VACATION;
+
+        p->u.v.seconds = p->u.v.mime = -1;
+        break;
+
+    case SETFLAG:
+    case ADDFLAG:
+    case REMOVEFLAG:
+        capability = "imap[4]flags";
+        supported =
+            parse_script->support & (SIEVE_CAPA_IMAP4FLAGS | SIEVE_CAPA_IMAPFLAGS);
+        break;
+
+    case MARK:
+    case UNMARK:
+        capability = "imapflags";
+        supported = parse_script->support & SIEVE_CAPA_IMAPFLAGS;
+        break;
+
+    case DENOTIFY:
+        capability = "notify";
+        supported = parse_script->support & SIEVE_CAPA_NOTIFY;
+        init_comptags(&p->u.d.comp);
+        p->u.d.comp.collation = ASCIICASEMAP;
+        p->u.d.priority = -1;
+        break;
+
+    case NOTIFY:
+    case ENOTIFY:
+        /* actual type and availability will be determined by parser */
+        p->u.n.priority = -1;
+        break;
+
+    case ERROR:
+        capability = "ihave";
+        supported = parse_script->support & SIEVE_CAPA_IHAVE;
+        break;
+
+    case INCLUDE:
+        p->u.inc.once = p->u.inc.location = p->u.inc.optional = -1;
+        GCC_FALLTHROUGH
+
+    case RETURN:
+        capability = "include";
+        supported = parse_script->support & SIEVE_CAPA_INCLUDE;
+        break;
+
+    case SET:
+        capability = "variables";
+        supported = parse_script->support & SIEVE_CAPA_VARIABLES;
+        break;
+
+    case DELETEHEADER:
+        init_comptags(&p->u.dh.comp);
+        GCC_FALLTHROUGH
+
+    case ADDHEADER:
+        capability = "editheader";
+        supported = parse_script->support & SIEVE_CAPA_EDITHEADER;
+        break;
+
+    case SNOOZE:
+        capability = "x-cyrus-snooze";
+        supported = parse_script->support & SIEVE_CAPA_SNOOZE;
+        break;
+    }
+
+    if (!supported) {
+        sieveerror_c(parse_script, SIEVE_MISSING_REQUIRE, capability);
+    }
+
     return p;
 }
 
 commandlist_t *new_if(test_t *t, commandlist_t *y, commandlist_t *n)
 {
     commandlist_t *p = (commandlist_t *) xzmalloc(sizeof(commandlist_t));
+
     p->type = IF;
     p->u.i.t = t;
     p->u.i.do_then = y;
     p->u.i.do_else = n;
     p->next = NULL;
+
     return p;
 }
 
-void free_test(test_t *t);
-
-static void free_tl(testlist_t *tl)
+void free_testlist(testlist_t *tl)
 {
     testlist_t *tl2;
 
@@ -125,10 +347,12 @@ void free_test(test_t *t)
     switch (t->type) {
     case ANYOF:
     case ALLOF:
-        free_tl(t->u.tl);
+        free_testlist(t->u.tl);
         break;
 
     case EXISTS:
+    case IHAVE:
+    case VALIDEXTLIST:
         strarray_free(t->u.sl);
         break;
 
@@ -138,21 +362,19 @@ void free_test(test_t *t)
         break;
 
     case HASFLAG:
-    case HEADER:
-        free(t->u.h.comparator);
-        strarray_free(t->u.h.sl);
-        strarray_free(t->u.h.pl);
+    case HEADERT:
+    case STRINGT:
+        strarray_free(t->u.hhs.sl);
+        strarray_free(t->u.hhs.pl);
         break;
 
     case ADDRESS:
     case ENVELOPE:
-        free(t->u.ae.comparator);
         strarray_free(t->u.ae.sl);
         strarray_free(t->u.ae.pl);
         break;
 
     case BODY:
-        free(t->u.b.comparator);
         strarray_free(t->u.b.content_types);
         strarray_free(t->u.b.pl);
         break;
@@ -162,29 +384,45 @@ void free_test(test_t *t)
         break;
 
     case DATE:
-        free(t->u.dt.header_name);
-        /* fall-through */
     case CURRENTDATE:
-        free(t->u.dt.comparator);
-        free(t->u.dt.zone);
+        free(t->u.dt.header_name);
         strarray_free(t->u.dt.kl);
         break;
 
+    case ENVIRONMENT:
     case MAILBOXEXISTS:
+    case MAILBOXIDEXISTS:
     case METADATA:
     case METADATAEXISTS:
     case SERVERMETADATA:
     case SERVERMETADATAEXISTS:
-        free(t->u.mbx.extname);
-        free(t->u.mbx.keyname);
-        strarray_free(t->u.mbx.keylist);
-        free(t->u.mbx.comparator);
+    case SPECIALUSEEXISTS:
+        free(t->u.mm.extname);
+        free(t->u.mm.keyname);
+        strarray_free(t->u.mm.keylist);
+        break;
+
+    case DUPLICATE:
+        free(t->u.dup.idval);
+        free(t->u.dup.handle);
+        break;
+
+    case JMAPQUERY:
+        free(t->u.jquery);
         break;
     }
 
     free(t);
 }
 
+static void free_fileinto(struct Fileinto *f)
+{
+    free(f->folder);
+    free(f->specialuse);
+    free(f->mailboxid);
+    strarray_free(f->flags);
+}
+
 void free_tree(commandlist_t *cl)
 {
     commandlist_t *cl2;
@@ -210,22 +448,30 @@ void free_tree(commandlist_t *cl)
             break;
 
         case FILEINTO:
-            free(cl->u.f.folder);
-            strarray_free(cl->u.f.flags);
+            free_fileinto(&cl->u.f);
             break;
 
         case REDIRECT:
             free(cl->u.r.address);
+            free(cl->u.r.bytime);
+            free(cl->u.r.bymode);
+            free(cl->u.r.dsn_notify);
+            free(cl->u.r.dsn_ret);
             break;
 
         case REJCT:
-            free(cl->u.reject);
+        case EREJECT:
+        case ERROR:
+            free(cl->u.str);
             break;
 
         case VACATION:
             free(cl->u.v.subject);
             strarray_free(cl->u.v.addresses);
             free(cl->u.v.message);
+            free(cl->u.v.from);
+            free(cl->u.v.handle);
+            free_fileinto(&cl->u.v.fcc);
             break;
 
         case KEEP:
@@ -237,22 +483,40 @@ void free_tree(commandlist_t *cl)
         case RETURN:
             break;
 
+        case ENOTIFY:
         case NOTIFY:
-            if (cl->u.n.method) free(cl->u.n.method);
-            if (cl->u.n.id) free(cl->u.n.id);
-            if (cl->u.n.options) strarray_free(cl->u.n.options);
-            if (cl->u.n.message) free(cl->u.n.message);
+            free(cl->u.n.method);
+            free(cl->u.n.id);
+            free(cl->u.n.from);
+            strarray_free(cl->u.n.options);
+            free(cl->u.n.message);
+            free_fileinto(&cl->u.n.fcc);
             break;
 
         case DENOTIFY:
-            if (cl->u.d.pattern) {
-#ifdef ENABLE_REGEX
-                if (cl->u.d.comptag == REGEX) {
-                    regfree((regex_t *) cl->u.d.pattern);
-                }
-#endif
-                free(cl->u.d.pattern);
-            }
+            free(cl->u.d.pattern);
+            break;
+
+        case SET:
+            free(cl->u.s.variable);
+            free(cl->u.s.value);
+            break;
+
+        case ADDHEADER:
+            free(cl->u.ah.name);
+            free(cl->u.ah.value);
+            break;
+
+        case DELETEHEADER:
+            free(cl->u.dh.name);
+            strarray_free(cl->u.dh.values);
+            break;
+
+        case SNOOZE:
+            free(cl->u.sn.mailbox);
+            strarray_free(cl->u.sn.addflags);
+            strarray_free(cl->u.sn.removeflags);
+            arrayu64_free(cl->u.sn.times);
             break;
         }
 
diff -pruN 3.0.13-5/sieve/tree.h 3.2.0-3/sieve/tree.h
--- 3.0.13-5/sieve/tree.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/tree.h	2020-05-04 03:28:02.000000000 +0000
@@ -1,7 +1,7 @@
 /* tree.h -- abstract syntax tree
  * Larry Greenfield
  *
- * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+ * Copyright (c) 1994-2017 Carnegie Mellon University.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -44,84 +44,80 @@
 #ifndef TREE_H
 #define TREE_H
 
+#include <jansson.h>
+
 #include "comparator.h"
 #include "strarray.h"
+#include "arrayu64.h"
 
 /* abstract syntax tree for sieve */
 typedef struct Commandlist commandlist_t;
 typedef struct Test test_t;
 typedef struct Testlist testlist_t;
-typedef struct Tag tag_t;
-typedef struct Taglist taglist_t;
+typedef struct Comp comp_t;
 
-struct Tag {
-    int type;
-    char *arg;
-};
-
-struct Taglist {
-    tag_t *t;
-    taglist_t *next;
+struct Comp {
+    int match;
+    int relation;
+    int collation;  /* only used where :comparator can be defined */
+    int index;      /* only used where index extension is defined */
 };
 
 struct Test {
     int type;
+    int ignore_err;
     union {
-        testlist_t *tl; /* anyof, allof */
-        strarray_t *sl; /* exists */
+        test_t *t; /* not */
+        strarray_t *sl; /* exists, ihave, valid_ext_list */
+        testlist_t *tl; /* anyof, allof (bytecode generation only) */
+        struct { /* anyof, allof (bytecode parsing/eval only) */
+            int ntests;   /* number of tests */
+            int endtests; /* offset to end of tests */
+        } aa;
         struct { /* it's a header or hasflag or string test */
-            int index;
-            int comptag;
-            char * comparator;
-            int relation;
-            void *comprock;
+            comp_t comp;
             strarray_t *sl;
             strarray_t *pl;
-        } h;
+        } hhs;
         struct { /* it's an address or envelope test */
-            int index;
-            int comptag;
-            char * comparator;
-            int relation;
-            void *comprock;
+            comp_t comp;
             strarray_t *sl;
             strarray_t *pl;
             int addrpart;
         } ae;
         struct { /* it's a body test */
-            int comptag;
-            int relation;
-            char * comparator;
-            void *comprock;
+            comp_t comp;
             int transform;
             int offset;
             strarray_t *content_types;
             strarray_t *pl;
         } b;
-        test_t *t; /* not */
         struct { /* size */
             int t; /* tag */
             int n; /* param */
         } sz;
         struct { /* it's a date test */
-            int index;
+            comp_t comp;
             int zonetag;
-            char *zone;
-            int comptag;
-            int relation;
-            char *comparator;
+            int zone;  /* time-zone offset in minutes */
             int date_part;
             char *header_name;
             strarray_t *kl;
         } dt;
-        struct { /* it's one of the mailbox type tests */
+        struct { /* it's a mailbox or metadata or environment test */
+            comp_t comp;
             char *extname;
             char *keyname;
             strarray_t *keylist;
-            int comptag;
-            int relation;
-            char *comparator;
-        } mbx;
+        } mm;
+        struct { /* its a duplicate test */
+            int idtype;
+            char *idval;
+            char *handle;
+            int seconds;
+            int last;
+        } dup;
+        char *jquery; /* jmapquery */
     } u;
 };
 
@@ -130,12 +126,23 @@ struct Testlist {
     testlist_t *next;
 };
 
+struct Fileinto {
+    strarray_t *flags;
+    char *folder;
+    char *specialuse;
+    int copy;
+    int create;
+    char *mailboxid;
+};
+
 struct Commandlist {
     int type;
     union {
-        char *reject; /* its a reject action */
+        int jump; /* bytecode parsing/eval only */
+        char *str; /* its a reject or error action */
         struct { /* it's an if statement */
             test_t *t;
+            int testend; /* offset to end of test (bytecode parsing/eval only) */
             commandlist_t *do_then;
             commandlist_t *do_else;
         } i;
@@ -149,20 +156,15 @@ struct Commandlist {
             int mod40; /* :lower or :upper */
             int mod30; /* :lowerfirst or :upperfirst */
             int mod20; /* :quotewildcard */
+            int mod15; /* :encodeurl */
             int mod10; /* :length */
             char *variable;
             char *value;
         } s;
         struct { /* it's a keep action */
-            int copy;
             strarray_t *flags;
         } k;
-        struct { /* it's a fileinto action */
-            char *folder;
-            int copy;
-            int create;
-            strarray_t *flags;
-        } f;
+        struct Fileinto f; /* it's a fileinto action */
         struct { /* it's a flag action */
             char *variable;
             strarray_t *flags;
@@ -170,6 +172,12 @@ struct Commandlist {
         struct { /* it's a redirect action */
             char *address;
             int copy;
+            int list;
+            char *bytime;
+            char *bymode;
+            int bytrace;
+            char *dsn_notify;
+            char *dsn_ret;
         } r;
         struct { /* it's a vacation action */
             char *subject;
@@ -179,32 +187,55 @@ struct Commandlist {
             char *from;
             char *handle;
             int mime;
+            struct Fileinto fcc;
         } v;
-        struct { /* it's a notify action */
+        struct { /* it's an (e)notify action */
             char *method;
             char *id;
+            char *from;
             strarray_t *options;
             int priority;
             char *message;
+            struct Fileinto fcc;
         } n;
         struct { /* it's a denotify action */
-            int comptag;
-            int relation;
-            void *comprock;
-            void *pattern;
+            comp_t comp;
+            char *pattern;
             int priority;
         } d;
+        struct { /* it's an addheader action */
+            int index;
+            char *name;
+            char *value;
+        } ah;
+        struct { /* it's a deleteheader action */
+            comp_t comp;
+            char *name;
+            strarray_t *values;
+        } dh;
+        struct { /* it's a log action */
+            char *text;
+        } l;
+        struct { /* it's a snooze action */
+            char *mailbox;
+            int is_mboxid;
+            strarray_t *addflags;
+            strarray_t *removeflags;
+            unsigned char days;
+            arrayu64_t *times;
+        } sn;
     } u;
     struct Commandlist *next;
 };
 
-tag_t *new_tag(int type, char *s);
-taglist_t *new_taglist(tag_t *t, taglist_t *n);
-test_t *new_test(int type);
+comp_t *canon_comptags(comp_t *c, sieve_script_t *parse_script);
+
+test_t *new_test(int type, sieve_script_t *parse_script);
 testlist_t *new_testlist(test_t *t, testlist_t *n);
-commandlist_t *new_command(int type);
+commandlist_t *new_command(int type, sieve_script_t *parse_script);
 commandlist_t *new_if(test_t *t, commandlist_t *y, commandlist_t *n);
 
+void free_testlist(testlist_t *tl);
 void free_test(test_t *t);
 void free_tree(commandlist_t *cl);
 
diff -pruN 3.0.13-5/sieve/variables.c 3.2.0-3/sieve/variables.c
--- 3.0.13-5/sieve/variables.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/variables.c	2020-04-24 02:03:00.000000000 +0000
@@ -3,6 +3,8 @@
  *
  *  Created on: Dec 26, 2014
  *      Author: James Cassell
+ *
+ *  Rewritten by Ken Murchison 4/7/17 to use 'struct buf'
  */
 
 #ifdef HAVE_CONFIG_H
@@ -11,30 +13,23 @@
 
 #include "variables.h"
 #include "bytecode.h"
-#include "xmalloc.h"
+#include "util.h"
 
-#include <string.h>
 #include <ctype.h>
 
-EXPORTED char *variables_modify_string (const char *string, int modifiers) {
-    int len, i;
-    char *result;
-    char *working_buffer;
-    len = strlen(string);
-    if (!len) {
-	return (BFV_LENGTH & modifiers) ? xstrdup("0") : xstrdup("");
-    }
-    /* Consider the string '\\\'
-     * length will be doubled with :quotewildcard
-     * length will then be tripled with :encodeurl
-     * so we allocate a buffer to encode the worst
-     * case final string of 2 * 3 = 6 times the length
-     * of the original string
-     */
-    result = xstrdup(string);
-    working_buffer = xstrdup(string);
-    result = xrealloc(result, 2 * 3 * len + 1);
-    working_buffer = xrealloc(working_buffer, 2 * 3 * len + 1);
+#define buf_swap(b1, b2) { struct buf *temp = b1; b1 = b2; b2 = temp; }
+
+EXPORTED char *variables_modify_string(const char *string, int modifiers)
+{
+    struct buf buf1 = BUF_INITIALIZER, buf2 = BUF_INITIALIZER;
+    struct buf *result = &buf1, *working_buffer = &buf2;
+
+    buf_init_ro_cstr(result, string);
+
+    if (!buf_len(result)) {
+	if (BFV_LENGTH & modifiers) buf_printf(result, "%zu", (size_t) 0);
+        return buf_release(result);
+    }
 
     /*
      * +--------------------------------+
@@ -47,151 +42,147 @@ EXPORTED char *variables_modify_string (
      * |                :upperfirst     |
      * +--------------------------------+
      * |     20         :quotewildcard  |
+     * |                :quoteregex     |
      * +--------------------------------+
      * |     15         :encodeurl      |
      * +--------------------------------+
      * |     10         :length         |
      * +--------------------------------+
      */
+
     /* Precedence 40 */
     switch ((BFV_LOWER | BFV_UPPER) & modifiers) {
     case BFV_LOWER:
-        for (i = 0; i < len; i++) {
-            result[i] = tolower(result[i]);
-        }
+        buf_lcase(result);
         break;
+
     case BFV_UPPER:
-        for (i = 0; i < len; i++) {
-            result[i] = tolower(result[i]);
-        }
+        buf_ucase(result);
         break;
     }
+
     /* Precedence 30 */
-    switch ((BFV_LOWERFIRST | BFV_UPPERFIRST) & modifiers) {
-    case BFV_LOWERFIRST:
-        result[0] = tolower(result[0]);
-        break;
-    case BFV_UPPERFIRST:
-        result[0] = toupper(result[0]);
-        break;
+    if ((BFV_LOWERFIRST | BFV_UPPERFIRST) & modifiers) {
+        string = buf_cstring(result);
+
+        buf_reset(working_buffer);
+        buf_printf(working_buffer, "%c%s", (BFV_LOWERFIRST & modifiers) ?
+                   tolower(string[0]) : toupper(string[0]), string + 1);
+        buf_swap(result, working_buffer);
     }
-    /*
-     * 4.1.2.  Modifier ":quotewildcard"
 
-     This modifier adds the necessary quoting to ensure that the expanded
-     text will only match a literal occurrence if used as a parameter to
-     :matches.  Every character with special meaning ("*", "?",  and "\")
-     is prefixed with "\" in the expansion.
-     *
-     */
     /* Precedence 20 */
-    if (BFV_QUOTEWILDCARD & modifiers) {
-        char *original, *quoted;
-        original = result;
-        quoted = working_buffer;
-        while (*original) {
-            switch (*original) {
+    if ((BFV_QUOTEWILDCARD | BFV_QUOTEREGEX) & modifiers) {
+        /*
+          These modifiers add the necessary quoting to ensure that the expanded
+          text will only match a literal occurrence if used as a parameter to
+          :matches or :regex respectively.  Every character with special meaning
+          ("*", "?", "\", etc) is prefixed with "\" in the expansion.
+        */
+        buf_reset(working_buffer);
+
+        for (string = buf_cstring(result); *string; string++) {
+            switch (*string) {
+                /* :regex-ONLY special characters */
+            case '.':
+            case '^':
+            case '$':
+            case '+':
+            case '(':
+            case ')':
+            case '[':
+            case '{':
+            case '|':
+                if (!(BFV_QUOTEREGEX & modifiers)) break;
+                GCC_FALLTHROUGH
+                /* :matches AND :regex special characters */
             case '*':
             case '?':
             case '\\':
-                *quoted = '\\';
-                quoted++;
+                buf_putc(working_buffer, '\\');
                 break;
             }
-            *quoted = *original;
-            quoted++;
-            original++;
-        }
-        *quoted = '\0';
-        {
-            char *temp;
-            temp = result;
-            result = working_buffer;
-            working_buffer = temp;
+
+            buf_putc(working_buffer, *string);
         }
-    }
-    /*
-     *
-     * 2.1. Percent-Encoding
 
-     A percent-encoding mechanism is used to represent a data octet in a
-     component when that octet's corresponding character is outside the
-     allowed set or is being used as a delimiter of, or within, the
-     component.  A percent-encoded octet is encoded as a character
-     triplet, consisting of the percent character "%" followed by the two
-     hexadecimal digits representing that octet's numeric value.  For
-     example, "%20" is the percent-encoding for the binary octet
-     "00100000" (ABNF: %x20), which in US-ASCII corresponds to the space
-     character (SP).  Section 2.4 describes when percent-encoding and
-     decoding is applied.
-
-        pct-encoded = "%" HEXDIG HEXDIG
-
-     The uppercase hexadecimal digits 'A' through 'F' are equivalent to
-     the lowercase digits 'a' through 'f', respectively.  If two URIs
-     differ only in the case of hexadecimal digits used in percent-encoded
-     octets, they are equivalent.  For consistency, URI producers and
-     normalizers should use uppercase hexadecimal digits for all percent-
-     encodings.
-     *
-     * 2.3. Unreserved Characters
-
-     Characters that are allowed in a URI but do not have a reserved
-     purpose are called unreserved.  These include uppercase and lowercase
-     letters, decimal digits, hyphen, period, underscore, and tilde.
-
-        unreserved  = ALPHA / DIGIT / "-" / "." / "_" / "~"
-
-     URIs that differ in the replacement of an unreserved character with
-     its corresponding percent-encoded US-ASCII octet are equivalent: they
-     identify the same resource.  However, URI comparison implementations
-     do not always perform normalization prior to comparison (see Section
-     6).  For consistency, percent-encoded octets in the ranges of ALPHA
-     (%41-%5A and %61-%7A), DIGIT (%30-%39), hyphen (%2D), period (%2E),
-     underscore (%5F), or tilde (%7E) should not be created by URI
-     producers and, when found in a URI, should be decoded to their
-     corresponding unreserved characters by URI normalizers.
+        buf_swap(result, working_buffer);
+    }
 
-    */
     /* Precedence 15 */
     if (BFV_ENCODEURL & modifiers) {
-        char *original, *quoted;
-        original = result;
-        quoted = working_buffer;
+        /*
+          2.1. Percent-Encoding
 
-        while (*original) {
-            switch (*original) {
-            case 'a' ... 'z':
+          A percent-encoding mechanism is used to represent a data octet in a
+          component when that octet's corresponding character is outside the
+          allowed set or is being used as a delimiter of, or within, the
+          component.  A percent-encoded octet is encoded as a character
+          triplet, consisting of the percent character "%" followed by the two
+          hexadecimal digits representing that octet's numeric value.  For
+          example, "%20" is the percent-encoding for the binary octet
+          "00100000" (ABNF: %x20), which in US-ASCII corresponds to the space
+          character (SP).  Section 2.4 describes when percent-encoding and
+          decoding is applied.
+
+             pct-encoded = "%" HEXDIG HEXDIG
+
+          The uppercase hexadecimal digits 'A' through 'F' are equivalent to
+          the lowercase digits 'a' through 'f', respectively.  If two URIs
+          differ only in the case of hexadecimal digits used in percent-encoded
+          octets, they are equivalent.  For consistency, URI producers and
+          normalizers should use uppercase hexadecimal digits for all percent-
+          encodings.
+
+          2.3. Unreserved Characters
+
+          Characters that are allowed in a URI but do not have a reserved
+          purpose are called unreserved.  These include uppercase and lowercase
+          letters, decimal digits, hyphen, period, underscore, and tilde.
+
+             unreserved  = ALPHA / DIGIT / "-" / "." / "_" / "~"
+
+          URIs that differ in the replacement of an unreserved character with
+          its corresponding percent-encoded US-ASCII octet are equivalent: they
+          identify the same resource.  However, URI comparison implementations
+          do not always perform normalization prior to comparison (see Section
+          6).  For consistency, percent-encoded octets in the ranges of ALPHA
+          (%41-%5A and %61-%7A), DIGIT (%30-%39), hyphen (%2D), period (%2E),
+          underscore (%5F), or tilde (%7E) should not be created by URI
+          producers and, when found in a URI, should be decoded to their
+          corresponding unreserved characters by URI normalizers.
+        */
+        buf_reset(working_buffer);
+
+        for (string = buf_cstring(result); *string; string++) {
+            switch (*string) {
             case 'A' ... 'Z':
+            case 'a' ... 'z':
             case '0' ... '9':
-                *quoted = *original;
-                quoted ++;
+            case '-':
+            case '.':
+            case '_':
+            case '~':
+                buf_putc(working_buffer, *string);
                 break;
+
             default:
-                snprintf(quoted, 4, "%%%02X", *original);
-                quoted += 3;
+                buf_printf(working_buffer, "%%%02X", *string);
                 break;
             }
-            original++;
-        }
-        *quoted = '\0';
-        {
-            char *temp;
-            temp = result;
-            result = working_buffer;
-            working_buffer = temp;
         }
+
+        buf_swap(result, working_buffer);
     }
+
     /* Precedence 10 */
     if (BFV_LENGTH & modifiers) {
-        snprintf(working_buffer, strlen(result), "%zu", strlen(result));
-        {
-            char *temp;
-            temp = result;
-            result = working_buffer;
-            working_buffer = temp;
-        }
+        buf_reset(working_buffer);
+        buf_printf(working_buffer, "%zu", buf_len(result));
+        buf_swap(result, working_buffer);
     }
-    free(working_buffer);
-    return result;
+
+    buf_free(working_buffer);
+
+    return buf_release(result);
 }
diff -pruN 3.0.13-5/sieve/varlist.c 3.2.0-3/sieve/varlist.c
--- 3.0.13-5/sieve/varlist.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/varlist.c	2020-04-24 02:03:00.000000000 +0000
@@ -9,24 +9,28 @@
 #include "xmalloc.h"
 
 
-EXPORTED variable_list_t *varlist_new(void) {
+variable_list_t *varlist_new(void)
+{
     variable_list_t *vl;
     vl = xzmalloc(sizeof(variable_list_t));
     vl->var = strarray_new();
     return vl;
 }
 
-EXPORTED variable_list_t *varlist_select(variable_list_t *vl, const char *name) {
+variable_list_t *varlist_select(variable_list_t *vl, const char *name)
+{
     if (!vl) {
         return NULL;
     }
-    if ((!name && !vl->name) || ((name && vl->name) && !strcasecmp(name, vl->name))) {
+    if ((!name && !vl->name) ||
+        ((name && vl->name) && !strcasecmp(name, vl->name))) {
         return vl;
     }
     return varlist_select(vl->next, name);
 }
 
-EXPORTED variable_list_t *varlist_end(variable_list_t *vl) {
+variable_list_t *varlist_end(variable_list_t *vl)
+{
     if (!vl) {
         return NULL;
     }
@@ -37,14 +41,16 @@ EXPORTED variable_list_t *varlist_end(va
 }
 
 
-EXPORTED variable_list_t *varlist_extend(variable_list_t *vl) {
+variable_list_t *varlist_extend(variable_list_t *vl)
+{
     if (!vl) {
         return NULL;
     }
     return (varlist_end(vl))->next = varlist_new();
 }
 
-EXPORTED void varlist_fini(variable_list_t *vl) {
+void varlist_fini(variable_list_t *vl)
+{
     if (!vl) {
         return;
     }
@@ -60,7 +66,8 @@ EXPORTED void varlist_fini(variable_list
     vl->next = NULL;
 }
 
-EXPORTED void varlist_free(variable_list_t *vl) {
+void varlist_free(variable_list_t *vl)
+{
     variable_list_t *next = NULL;
     if (!vl) {
         return;
diff -pruN 3.0.13-5/sieve/varlist.h 3.2.0-3/sieve/varlist.h
--- 3.0.13-5/sieve/varlist.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/sieve/varlist.h	2020-04-24 02:03:00.000000000 +0000
@@ -22,15 +22,15 @@ typedef struct variable_list {
 #define VL_PARSED_STRINGS "@@STRINGS_PARSED@@"
 #define VL_MATCH_VARS "@@MATCH_VARS@@"
 
-EXPORTED variable_list_t *varlist_new(void);
+variable_list_t *varlist_new(void);
 
-EXPORTED void varlist_fini(variable_list_t *vl);
+void varlist_fini(variable_list_t *vl);
 
-EXPORTED void varlist_free(variable_list_t *vl);
+void varlist_free(variable_list_t *vl);
 
-EXPORTED variable_list_t *varlist_extend(variable_list_t *vl);
+variable_list_t *varlist_extend(variable_list_t *vl);
 
-EXPORTED variable_list_t *varlist_select(variable_list_t *vl, const char *name);
-EXPORTED variable_list_t *varlist_end(variable_list_t *vl);
+variable_list_t *varlist_select(variable_list_t *vl, const char *name);
+variable_list_t *varlist_end(variable_list_t *vl);
 
 #endif /* VARLIST_H_ */
diff -pruN 3.0.13-5/SMakefile 3.2.0-3/SMakefile
--- 3.0.13-5/SMakefile	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/SMakefile	1970-01-01 00:00:00.000000000 +0000
@@ -1,136 +0,0 @@
-#
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-#
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in
-#    the documentation and/or other materials provided with the
-#    distribution.
-#
-# 3. The name "Carnegie Mellon University" must not be used to
-#    endorse or promote products derived from this software without
-#    prior written permission. For permission or any legal
-#    details, please contact
-#      Carnegie Mellon University
-#      Center for Technology Transfer and Enterprise Creation
-#      4615 Forbes Avenue
-#      Suite 302
-#      Pittsburgh, PA  15213
-#      (412) 268-7393, fax: (412) 268-7395
-#      innovation@andrew.cmu.edu
-#
-# 4. Redistributions of any form whatsoever must retain the following
-#    acknowledgment:
-#    "This product includes software developed by Computing Services
-#     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
-#
-# CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
-# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
-# AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
-# FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
-# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
-# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
-# OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
-
-NEW_AUTOTOOLS=yes
-export NEW_AUTOTOOLS
-
-if test ! -x configure; then
-# -nt deeply upsets normal sh.
-#        -o configure.ac -nt configure
-#        -o acconfig.h -nt configure -o SMakefile -nt configure; then
-  echo autoreconf
-  autoreconf
-fi
-
-MAKE=gmake
-
-if [ -r /.hostname ]; then
-  # probably an andrew machine
-  VER=`smake -D | sed 's;^.*\/;;'`
-else
-  # anonymous cvs?
-  VER="anoncvs"
-fi
-LOCALDEFS="-DEXTRA_IDENT=\\\"$VER\\\""
-
-# PERL CONFIGURATION
-if perl -e 'exit ($] != 5.006001)'; then
-   PERL_MM_OPT="INSTALLPRIVLIB=${DESTDIR}/usr/local/lib/perl5 INSTALLARCHLIB=${DESTDIR}/usr/local/lib/perl5/5.6.1 INSTALLSITELIB=${DESTDIR}/usr/local/lib/perl5/site_perl/5.6.1 INSTALLSITEARCH=${DESTDIR}/usr/local/lib/perl5/site_perl/5.6.1 INSTALLBIN=${DESTDIR}/usr/local/bin INSTALLSCRIPT=${DESTDIR}/usr/local/bin INSTALLMAN1DIR=${DESTDIR}/usr/local/man/man1 INSTALLMAN3DIR=${DESTDIR}/usr/local/man/man3"
-else
-  if perl -e 'exit ($] < 5.008005)'; then
-    # MakeMaker now supports DESTDIR!
-    PERL_MM_OPT=""
-  else
-    echo "no support for thus perl version in SMakefile"
-  fi
-fi
-export PERL_MM_OPT
-# end perl configuration
-
-# Let's just assume we are using gcc...
-if test "${WASH_CYRUS_INSURE}" = "t"; then
-  CC="insure"
-  CFLAGS="-g"
-else
-  CC="gcc"
-  CFLAGS="${CFLAGS} -g -Wall -W"
-fi
-
-if test "${WASH_CYRUS_DEBUG}" = "t"; then
-    CC="gcc"
-    CFLAGS="-g"
-    LDFLAGS="${LDFLAGS}"
-    DEBUG="--enable-debug"
-fi
-
-case `uname` in
-    Linux)
-        LDFLAGS="${LDFLAGS}"
-        LIBS="-lnsl" # for libwrap
-    ;;
-    SunOS)
-        LDFLAGS="${LDFLAGS} -L/usr/local/lib -Wl,-R,/usr/local/lib"
-        LIBS="-lkstat -ldoor"
-    ;;
-    *)
-        CC=cc
-    ;;
-esac
-
-case `sys` in
-    i386_fc3)
-        LIBS="$LIBS -ldes"
-        OS_CONFIG="--with-krbdes"
-    ;;
-    sun4x_s10)
-        LIBS="$LIBS -ldes"
-        OS_CONFIG="--with-krbdes"
-    ;;
-esac
-
-
-# settings; we have to disable these on some platforms
-DEBUG=""
-SSL_CONFIG="--with-openssl=/usr/local/lib"
-
-# the defaults are good enough for us
-DB_CONFIG=""
-
-# the following is for staticly linking SASL only
-SASL_CONFIG="--with-staticsasl=/usr/local --with-gssapi=/usr/local"
-#KRB_CONFIG="--enable-statickrb --with-krb=/usr/local"
-KRB_CONFIG="--with-krb=/usr/local"
-FEATURE_CONFIG="--enable-murder --enable-cmulocal --enable-nntp --enable-idled --enable-replication"
-EXT_PACKAGE_CONFIG="--with-inn=/usr/news --with-ucdsnmp=/usr/local"
-
-MFCOMMAND="./configure $WITHAUTH $KRB_CONFIG $DB_CONFIG --enable-experiment --with-cyrus-group=staff $FEATURE_CONFIG $EXT_PACKAGE_CONFIG $SASL_CONFIG $DEBUG"
-
-export CFLAGS CC VER LNCOMMAND LOCALDEFS LDFLAGS
-export LIBS
diff -pruN 3.0.13-5/snmp/snmpgen 3.2.0-3/snmp/snmpgen
--- 3.0.13-5/snmp/snmpgen	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/snmp/snmpgen	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,5 @@
-#!/bin/sh
-#
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+#!/usr/bin/perl
+# Copyright (c) 1994-2020 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -39,26 +38,11 @@
 # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-w", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
+#use strict; # XXX doesn't compile with strict :(
+use warnings;
+
 #Tim Martin
 # 2/10/2000
 
diff -pruN 3.0.13-5/timsieved/actions.c 3.2.0-3/timsieved/actions.c
--- 3.0.13-5/timsieved/actions.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/actions.c	2020-05-04 03:28:02.000000000 +0000
@@ -169,20 +169,20 @@ static int scriptname_valid(const struct
           return TIMSIEVE_FAIL;
   }
 
-  return TIMSIEVE_OK;
+  return lup < 1013 ? TIMSIEVE_OK : TIMSIEVE_FAIL;
 }
 
 int capabilities(struct protstream *conn, sasl_conn_t *saslconn,
                  int starttls_done, int authenticated, sasl_ssf_t sasl_ssf)
 {
     const char *sasllist;
-    int mechcount;
+    int mechcount, i;
 
     /* implementation */
     if (config_serverinfo == IMAP_ENUM_SERVERINFO_ON) {
         prot_printf(conn,
                     "\"IMPLEMENTATION\" \"Cyrus timsieved%s %s\"\r\n",
-                    config_mupdate_server ? " (Murder)" : "", cyrus_version());
+                    config_mupdate_server ? " (Murder)" : "", CYRUS_VERSION);
     } else if (config_serverinfo == IMAP_ENUM_SERVERINFO_MIN) {
         prot_printf(conn,
                     "\"IMPLEMENTATION\" \"Cyrus timsieved%s\"\r\n",
@@ -200,11 +200,16 @@ int capabilities(struct protstream *conn
                       &sasllist,
                       NULL, &mechcount) == SASL_OK/* && mechcount > 0*/)
     {
-      prot_printf(conn,"%s",sasllist);
+        prot_printf(conn,"%s",sasllist);
     }
 
     /* Sieve capabilities */
-    prot_printf(conn,"\"SIEVE\" \"%s\"\r\n",sieve_listextensions(interp));
+    const strarray_t *extensions = sieve_listextensions(interp);
+    for (i = 0; i < strarray_size(extensions); i += 2) {
+        /* capability/value pairs */
+        prot_printf(conn,"\"%s\" \"%s\"\r\n",
+                    strarray_nth(extensions, i), strarray_nth(extensions, i+1));
+    }
 
     if (tls_enabled() && !starttls_done && !authenticated) {
         prot_puts(conn, "\"STARTTLS\"\r\n");
@@ -329,7 +334,7 @@ int putscript(struct protstream *conn, c
   char path[1024], p2[1024];
   char bc_path[1024], bc_p2[1024];
   int maxscripts;
-  sieve_script_t *s;
+  sieve_script_t *s = NULL;
 
   result = scriptname_valid(name);
   if (result!=TIMSIEVE_OK)
@@ -399,6 +404,7 @@ int putscript(struct protstream *conn, c
       } else {
           prot_printf(conn, "NO \"parse failed\"\r\n");
       }
+      sieve_script_free(&s);
       buf_free(&errors);
       fclose(stream);
       unlink(path);
@@ -412,7 +418,7 @@ int putscript(struct protstream *conn, c
 
   if (!verify_only) {
       int fd;
-      bytecode_info_t *bc;
+      bytecode_info_t *bc = NULL;
 
       /* Now, generate the bytecode */
       if(sieve_generate_bytecode(&bc, s) == -1) {
@@ -743,7 +749,7 @@ int cmd_havespace(struct protstream *con
 {
     int result;
     int maxscripts;
-    unsigned long maxscriptsize;
+    extern unsigned long maxscriptsize;
 
     result = scriptname_valid(sieve_name);
     if (result!=TIMSIEVE_OK)
@@ -753,9 +759,6 @@ int cmd_havespace(struct protstream *con
     }
 
     /* see if the size of the script is too big */
-    maxscriptsize = config_getint(IMAPOPT_SIEVE_MAXSCRIPTSIZE);
-    maxscriptsize *= 1024;
-
     if (num > maxscriptsize)
     {
         prot_printf(conn,
diff -pruN 3.0.13-5/timsieved/actions.h 3.2.0-3/timsieved/actions.h
--- 3.0.13-5/timsieved/actions.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/actions.h	2020-04-24 02:03:00.000000000 +0000
@@ -119,7 +119,7 @@ int setactive(struct protstream *conn, c
 int actions_init(void);
 
 /*
- * Set user after sucessful authentication
+ * Set user after successful authentication
  *
  */
 
diff -pruN 3.0.13-5/timsieved/lex.c 3.2.0-3/timsieved/lex.c
--- 3.0.13-5/timsieved/lex.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/lex.c	2020-04-24 02:03:00.000000000 +0000
@@ -116,7 +116,7 @@ static int token_lookup(const char *str)
 
 /* current state the lexer is in */
 static int lexer_state = LEXER_STATE_NORMAL;
-static unsigned long maxscriptsize=0;
+HIDDEN unsigned long maxscriptsize = 0;
 static char *buffer;
 
 #define ERR() {                                                         \
@@ -134,14 +134,11 @@ void lex_setrecovering(void)
   lexer_state = LEXER_STATE_RECOVER;
 }
 
-int lex_init(void)
+void lex_init(void)
 {
-  maxscriptsize = config_getint(IMAPOPT_SIEVE_MAXSCRIPTSIZE);
-  maxscriptsize *= 1024;
+  maxscriptsize = config_getint(IMAPOPT_SIEVE_MAXSCRIPTSIZE) * 1024;
 
   buffer = (char *) xmalloc(maxscriptsize);
-
-  return 0;
 }
 
 /**
diff -pruN 3.0.13-5/timsieved/lex.h 3.2.0-3/timsieved/lex.h
--- 3.0.13-5/timsieved/lex.h	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/timsieved/lex.h	2020-04-24 02:03:00.000000000 +0000
@@ -83,7 +83,7 @@
 #define RENAMESCRIPT 413
 
 
-int lex_init(void);
+void lex_init(void);
 
 int timlex(struct buf *outstr, unsigned long *outnum,  struct protstream *stream);
 
diff -pruN 3.0.13-5/timsieved/parser.c 3.2.0-3/timsieved/parser.c
--- 3.0.13-5/timsieved/parser.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/parser.c	2020-04-24 02:03:00.000000000 +0000
@@ -48,6 +48,7 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#include <sysexits.h>
 #include <syslog.h>
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
@@ -57,7 +58,6 @@
 #include <sasl/saslutil.h>
 
 #include "assert.h"
-#include "exitcodes.h"
 #include "libconfig.h"
 #include "xmalloc.h"
 #include "xstrlcpy.h"
@@ -104,7 +104,9 @@ static int cmd_authenticate(struct prots
                             const char *mech, const struct buf *initial_challenge, const char **errmsg);
 static void cmd_unauthenticate(struct protstream *sieved_out,
                                struct protstream *sieved_in);
-static int cmd_starttls(struct protstream *sieved_out, struct protstream *sieved_in);
+static int cmd_starttls(struct protstream *sieved_out,
+                        struct protstream *sieved_in,
+                        struct saslprops_t *saslprops);
 
 static char *sieve_parsesuccess(char *str, const char **status)
 {
@@ -138,7 +140,8 @@ static struct protocol_t sieve_protocol
 };
 
 /* Returns TRUE if we are done */
-int parser(struct protstream *sieved_out, struct protstream *sieved_in)
+int parser(struct protstream *sieved_out, struct protstream *sieved_in,
+           struct saslprops_t *saslprops)
 {
   int token = EOL;
   const char *error_msg = "Generic Error";
@@ -238,11 +241,6 @@ int parser(struct protstream *sieved_out
         goto error;
     }
 
-#if 0 /* XXX - not implemented in sieveshell*/
-    /* referral_host is non-null only once we are authenticated */
-    if(referral_host)
-        goto do_referral;
-#endif
     break;
 
   case CAPABILITY:
@@ -524,7 +522,7 @@ int parser(struct protstream *sieved_out
     if(referral_host)
         goto do_referral;
 
-    cmd_starttls(sieved_out, sieved_in);
+    cmd_starttls(sieved_out, sieved_in, saslprops);
 
     break;
 
@@ -629,20 +627,19 @@ void cmd_logout(struct protstream *sieve
     prot_flush(sieved_out);
 }
 
-static sasl_ssf_t ssf = 0;
-static char *authid = NULL;
-
-extern int reset_saslconn(sasl_conn_t **conn, sasl_ssf_t ssf, char *authid);
+extern int reset_saslconn(sasl_conn_t **conn);
 
 static void cmd_unauthenticate(struct protstream *sieved_out,
                               struct protstream *sieved_in)
 {
+    prot_printf(sieved_out, "OK\r\n");
+    prot_flush(sieved_out);
+
     if (chdir("/tmp/"))
         syslog(LOG_ERR, "Failed to chdir to /tmp/");
-    reset_saslconn(&sieved_saslconn, sieved_in->saslssf, authid);
+    reset_saslconn(&sieved_saslconn);
     prot_unsetsasl(sieved_out);
     prot_unsetsasl(sieved_in);
-    prot_printf(sieved_out, "OK\r\n");
     authenticated = 0;
 }
 
@@ -907,21 +904,19 @@ cleanup:
   return ret;
 
 reset:
-  if(reset_saslconn(&sieved_saslconn, ssf, authid) != SASL_OK)
+  if(reset_saslconn(&sieved_saslconn) != SASL_OK)
       fatal("could not reset the sasl_conn_t after failure",
-            EC_TEMPFAIL);
+            EX_TEMPFAIL);
   ret = FALSE;
   goto cleanup;
 }
 
 #ifdef HAVE_SSL
-static int cmd_starttls(struct protstream *sieved_out, struct protstream *sieved_in)
+static int cmd_starttls(struct protstream *sieved_out,
+                        struct protstream *sieved_in,
+                        struct saslprops_t *saslprops)
 {
     int result;
-    int *layerp;
-
-    /* SASL and openssl have different ideas about whether ssf is signed */
-    layerp = (int *) &ssf;
 
     if (starttls_done == 1)
     {
@@ -950,8 +945,7 @@ static int cmd_starttls(struct protstrea
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                sieved_timeout,
-                               layerp,
-                               &authid,
+                               saslprops,
                                &tls_conn);
 
     /* if error */
@@ -962,16 +956,10 @@ static int cmd_starttls(struct protstrea
     }
 
     /* tell SASL about the negotiated layer */
-    result = sasl_setprop(sieved_saslconn, SASL_SSF_EXTERNAL, &ssf);
-
-    if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
-    }
-
-    result = sasl_setprop(sieved_saslconn, SASL_AUTH_EXTERNAL, authid);
+    result = saslprops_set_tls(saslprops, sieved_saslconn);
 
     if (result != SASL_OK) {
-        fatal("sasl_setprop() failed: cmd_starttls()", EC_TEMPFAIL);
+        fatal("saslprops_set_tls() failed: cmd_starttls()", EX_TEMPFAIL);
     }
 
     /* tell the prot layer about our new layers */
@@ -986,8 +974,9 @@ static int cmd_starttls(struct protstrea
 }
 #else
 static int cmd_starttls(struct protstream *sieved_out __attribute__((unused)),
-                        struct protstream *sieved_in __attribute__((unused)))
+                        struct protstream *sieved_in __attribute__((unused)),
+                        struct saslprops_t *saslprops __attribute__((unused)))
 {
-    fatal("cmd_starttls() called, but no OpenSSL", EC_SOFTWARE);
+    fatal("cmd_starttls() called, but no OpenSSL", EX_SOFTWARE);
 }
 #endif /* HAVE_SSL */
diff -pruN 3.0.13-5/timsieved/parser.h 3.2.0-3/timsieved/parser.h
--- 3.0.13-5/timsieved/parser.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/parser.h	2020-04-24 02:03:00.000000000 +0000
@@ -46,9 +46,10 @@
 #define PARSER_H
 
 #include "prot.h"
+#include "imap/global.h" /* for saslprops_t */
 
 int parser(struct protstream *sieved_out,
-           struct protstream *sieved_in);
+           struct protstream *sieved_in, struct saslprops_t *saslprops);
 
 
 #endif /* PARSER_H */
diff -pruN 3.0.13-5/timsieved/timsieved.c 3.2.0-3/timsieved/timsieved.c
--- 3.0.13-5/timsieved/timsieved.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/timsieved/timsieved.c	2020-04-24 02:03:00.000000000 +0000
@@ -59,11 +59,11 @@
 #include <sys/param.h>
 #include <sys/socket.h>
 #include <sys/stat.h>
+#include <sysexits.h>
 #include <syslog.h>
 #include <unistd.h>
 
 #include "auth.h"
-#include "exitcodes.h"
 #include "libconfig.h"
 #include "xmalloc.h"
 #include "imap/backend.h"
@@ -84,13 +84,8 @@ const int config_need_data = 0;
 int sieved_tls_required = 0;
 
 sieve_interp_t *interp = NULL;
-static int build_sieve_interp(void);
 
-static struct
-{
-    char *ipremoteport;
-    char *iplocalport;
-} saslprops = {NULL,NULL};
+static struct saslprops_t saslprops = SASLPROPS_INITIALIZER;
 
 sasl_conn_t *sieved_saslconn; /* the sasl connection context */
 
@@ -133,10 +128,6 @@ void shut_down(int code)
         free(backend);
     }
 
-    /* close mailboxes */
-    mboxlist_close();
-    mboxlist_done();
-
     /* cleanup */
     if (sieved_out) {
         prot_flush(sieved_out);
@@ -150,6 +141,8 @@ void shut_down(int code)
     tls_shutdown_serverengine();
 #endif
 
+    saslprops_free(&saslprops);
+
     cyrus_done();
 
     cyrus_reset_stdio();
@@ -182,7 +175,7 @@ static void cmdloop(void)
             return;
         }
 
-        ret = parser(sieved_out, sieved_in);
+        ret = parser(sieved_out, sieved_in, &saslprops);
     }
 
     sync_log_done();
@@ -204,7 +197,7 @@ EXPORTED void fatal(const char *s, int c
     prot_printf(sieved_out, "NO Fatal error: %s\r\n", s);
     prot_flush(sieved_out);
 
-    shut_down(EC_TEMPFAIL);
+    shut_down(EX_TEMPFAIL);
 }
 
 static struct sasl_callback mysasl_cb[] = {
@@ -220,11 +213,9 @@ EXPORTED int service_init(int argc __att
 {
     global_sasl_init(1, 1, mysasl_cb);
 
-    /* open mailboxes */
-    mboxlist_init(0);
-    mboxlist_open(NULL);
-
-    if (build_sieve_interp() != TIMSIEVE_OK) shut_down(EX_SOFTWARE);
+    /* build interpreter for compiling */
+    interp = sieve_build_nonexec_interp();
+    if (interp == NULL) shut_down(EX_SOFTWARE);
 
     return 0;
 }
@@ -248,9 +239,8 @@ EXPORTED int service_main(int argc __att
     sieved_in = prot_new(0, 0);
     sieved_out = prot_new(1, 1);
 
-    sieved_timeout = config_getint(IMAPOPT_TIMEOUT);
-    if (sieved_timeout < 10) sieved_timeout = 10;
-    sieved_timeout *= 60;
+    sieved_timeout = config_getduration(IMAPOPT_TIMEOUT, 'm');
+    if (sieved_timeout < 10 * 60) sieved_timeout = 10 * 60;
     prot_settimeout(sieved_in, sieved_timeout);
     prot_setflushonread(sieved_in, sieved_out);
 
@@ -261,21 +251,18 @@ EXPORTED int service_main(int argc __att
     /* Find out name of client host */
     sieved_clienthost = get_clienthost(0, &localip, &remoteip);
 
+    if (localip && remoteip) {
+        buf_setcstr(&saslprops.ipremoteport, remoteip);
+        buf_setcstr(&saslprops.iplocalport, localip);
+    }
+
     /* other params should be filled in */
     if (sasl_server_new(SIEVE_SERVICE_NAME, config_servername, NULL,
-                        NULL, NULL, NULL, SASL_SUCCESS_DATA,
-                        &sieved_saslconn) != SASL_OK)
+                        buf_cstringnull_ifempty(&saslprops.iplocalport),
+                        buf_cstringnull_ifempty(&saslprops.ipremoteport),
+                        NULL, SASL_SUCCESS_DATA, &sieved_saslconn) != SASL_OK)
         fatal("SASL failed initializing: sasl_server_new()", -1);
 
-    if (remoteip) {
-        sasl_setprop(sieved_saslconn, SASL_IPREMOTEPORT, remoteip);
-        saslprops.ipremoteport = xstrdup(remoteip);
-    }
-    if (localip) {
-        sasl_setprop(sieved_saslconn, SASL_IPLOCALPORT, localip);
-        saslprops.iplocalport = xstrdup(localip);
-    }
-
     /* will always return something valid */
     secprops = mysasl_secprops(0);
     sasl_setprop(sieved_saslconn, SASL_SEC_PROPS, secprops);
@@ -288,32 +275,23 @@ EXPORTED int service_main(int argc __att
     cmdloop();
 
     /* never reaches */
-    exit(EC_SOFTWARE);
+    exit(EX_SOFTWARE);
 }
 
 /* Reset the given sasl_conn_t to a sane state */
-int reset_saslconn(sasl_conn_t **conn, sasl_ssf_t ssf, char *authid)
+int reset_saslconn(sasl_conn_t **conn)
 {
     int ret = 0;
     sasl_security_properties_t *secprops = NULL;
 
     sasl_dispose(conn);
     /* do initialization typical of service_main */
-    ret = sasl_server_new(SIEVE_SERVICE_NAME, config_servername,
-                          NULL, NULL, NULL,
+    ret = sasl_server_new(SIEVE_SERVICE_NAME, config_servername, NULL,
+                          buf_cstringnull_ifempty(&saslprops.iplocalport),
+                          buf_cstringnull_ifempty(&saslprops.ipremoteport),
                           NULL, SASL_SUCCESS_DATA, conn);
     if(ret != SASL_OK) return ret;
 
-    if(saslprops.ipremoteport)
-        ret = sasl_setprop(*conn, SASL_IPREMOTEPORT,
-                           saslprops.ipremoteport);
-    if(ret != SASL_OK) return ret;
-
-    if(saslprops.iplocalport)
-        ret = sasl_setprop(*conn, SASL_IPLOCALPORT,
-                           saslprops.iplocalport);
-    if(ret != SASL_OK) return ret;
-
     secprops = mysasl_secprops(0);
     ret = sasl_setprop(*conn, SASL_SEC_PROPS, secprops);
     if(ret != SASL_OK) return ret;
@@ -321,13 +299,8 @@ int reset_saslconn(sasl_conn_t **conn, s
     /* end of service_main initialization excepting SSF */
 
     /* If we have TLS/SSL info, set it */
-    if(ssf) {
-        ret = sasl_setprop(*conn, SASL_SSF_EXTERNAL, &ssf);
-        if(ret != SASL_OK) return ret;
-    }
-
-    if(authid) {
-        ret = sasl_setprop(*conn, SASL_AUTH_EXTERNAL, authid);
+    if(saslprops.ssf) {
+        ret = saslprops_set_tls(&saslprops, *conn);
         if(ret != SASL_OK) return ret;
     }
     /* End TLS/SSL Info */
@@ -367,68 +340,3 @@ static void bitpipe(void)
 
     return;
 }
-
-static void timsieved_generic_cb(void)
-{
-    fatal("stub function called", 0);
-}
-
-static sieve_vacation_t timsieved_vacation_cbs = {
-    0,                                          /* min response */
-    0,                                          /* max response */
-    (sieve_callback *) &timsieved_generic_cb,   /* autorespond() */
-    (sieve_callback *) &timsieved_generic_cb,   /* send_response() */
-};
-
-static int timsieved_notify_cb(void *ac __attribute__((unused)),
-                               void *interp_context __attribute__((unused)),
-                               void *script_context __attribute__((unused)),
-                               void *message_context __attribute__((unused)),
-                               const char **errmsg __attribute__((unused)))
-{
-    fatal("stub function called", 0);
-    return SIEVE_FAIL;
-}
-
-static int timsieved_parse_error_cb(int lineno, const char *msg,
-                                    void *interp_context __attribute__((unused)),
-                                    void *script_context)
-{
-    struct buf *errors = (struct buf *) script_context;
-    buf_printf(errors, "line %d: %s\r\n", lineno, msg);
-    return SIEVE_OK;
-}
-
-/* returns TIMSIEVE_OK or TIMSIEVE_FAIL */
-static int build_sieve_interp(void)
-{
-    int res;
-
-    interp = sieve_interp_alloc(NULL);
-    assert(interp != NULL);
-
-    sieve_register_redirect(interp, (sieve_callback *) &timsieved_generic_cb);
-    sieve_register_discard(interp, (sieve_callback *) &timsieved_generic_cb);
-    sieve_register_reject(interp, (sieve_callback *) &timsieved_generic_cb);
-    sieve_register_fileinto(interp, (sieve_callback *) &timsieved_generic_cb);
-    sieve_register_keep(interp, (sieve_callback *) &timsieved_generic_cb);
-    sieve_register_imapflags(interp, NULL);
-    sieve_register_size(interp, (sieve_get_size *) &timsieved_generic_cb);
-    sieve_register_mailboxexists(interp, (sieve_get_mailboxexists *) &timsieved_generic_cb);
-    sieve_register_metadata(interp, (sieve_get_metadata *) &timsieved_generic_cb);
-    sieve_register_header(interp, (sieve_get_header *) &timsieved_generic_cb);
-    sieve_register_envelope(interp, (sieve_get_envelope *) &timsieved_generic_cb);
-    sieve_register_body(interp, (sieve_get_body *) &timsieved_generic_cb);
-    sieve_register_include(interp, (sieve_get_include *) &timsieved_generic_cb);
-
-    res = sieve_register_vacation(interp, &timsieved_vacation_cbs);
-    if (res != SIEVE_OK) {
-        syslog(LOG_ERR, "sieve_register_vacation() returns %d\n", res);
-        return TIMSIEVE_FAIL;
-    }
-
-    sieve_register_notify(interp, &timsieved_notify_cb);
-    sieve_register_parse_error(interp, &timsieved_parse_error_cb);
-
-    return TIMSIEVE_OK;
-}
diff -pruN 3.0.13-5/tools/config2header 3.2.0-3/tools/config2header
--- 3.0.13-5/tools/config2header	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/config2header	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!/usr/bin/perl
 #
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+# Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -39,34 +39,17 @@
 # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
 use strict;
+use warnings;
 
 my $enum_size = 0;
 my @enum_values = ();
 
 my $CC;
 #
-# Look for CC=xxx "assigments" in the argument list.
+# Look for CC=xxx "assignments" in the argument list.
 #
 while ($#ARGV >= 0) {
         last unless ($ARGV[0] =~ m/^(\S+)=(.*)$/);
@@ -84,6 +67,7 @@ open CFILE, ">$cfile";
 open HFILE, ">$hfile";
 
 my $blank = "";
+# XXX clean up old cvs id cruft!
 my $version = "\$Revision: 1.17 $blank";
 $version =~ s/.Revision: (.*) /$1/;
 print HFILE "/* auto-generated by config2header $version */\n";
@@ -92,10 +76,12 @@ print CFILE "/* auto-generated by config
 print HFILE "#ifndef INCLUDED_IMAPOPTS_H\n";
 print HFILE "#define INCLUDED_IMAPOPTS_H\n";
 print HFILE "\n";
+print HFILE "#include <stdint.h>\n";
+print HFILE "\n";
 
 # prototypes
 my @opttype = ("OPT_NOTOPT","OPT_STRING","OPT_INT","OPT_SWITCH",
-               "OPT_ENUM","OPT_STRINGLIST","OPT_BITFIELD");
+               "OPT_ENUM","OPT_STRINGLIST","OPT_BITFIELD", "OPT_DURATION");
 print HFILE "enum opttype {\n";
 while (my $opt = pop (@opttype)) {
     if ($#opttype == -1) {
@@ -138,10 +124,29 @@ print CFILE <<EOF
 
 EXPORTED struct imapopt_s imapopts[] =
 {
-  { IMAPOPT_ZERO, "", 0, OPT_NOTOPT, NULL, IMAPOPT_ZERO, { NULL }, { NULL }, { { NULL, IMAP_ENUM_ZERO } } },
+  { IMAPOPT_ZERO, "", 0, OPT_NOTOPT, 0, NULL, IMAPOPT_ZERO, { NULL }, { NULL }, { { NULL, IMAP_ENUM_ZERO } } },
 EOF
     ;
 
+sub parse_last_modified
+{
+    my ($version) = @_;
+
+    if ($version =~ m{ ^ (\d+) \. (\d+) \. (\d+) $ }x) {
+        my ($maj, $min, $rev) = (0 + $1, 0 + $2, 0 + $3);
+
+        die "major version too large: $maj" if $maj > 255;
+        die "minor version too large: $min" if $min > 255;
+        die "revision too large: $rev" if $rev > 255;
+
+        return sprintf "0x%2.2X%2.2X%2.2X00", $maj, $min, $rev;
+    }
+    else {
+        die "unparseable version: $version";
+    }
+}
+
+
 # output enumeration
 
 while (<STDIN>) {
@@ -149,16 +154,32 @@ while (<STDIN>) {
     # look for { option, default, type [enums] }
 
     # Note that the code we output has to play interesting games to get
-    # the union to initialize itself in a syntacticly valid manner.
+    # the union to initialize itself in a syntactically valid manner.
     # Namely, we need to initialize the union itself, not the members of
-    # the union, and we need to ensure we are initilizing the union with
+    # the union, and we need to ensure we are initializing the union with
     # something of a type that is in the union.
-    if (m|{\s*\"(.*?)\"\s*,\s*(\"?.*?\"?)\s*,\s*(.*?)\s*(\(.*\))?\s*(,.*)?}|) {
+    if (m|
+            {           # opening curly
+            \s*         # skip leading whitespace
+            \"(.*?)\"   # $1: option name (don't capture quotes)
+            \s*,\s*     # comma, optional whitespace
+            (\"?.*?\"?) # $2: default value (do capture quotes)
+            \s*,\s*     # comma, optional whitespace
+            (.*?)       # $3: option type
+            \s*         # optional whitespace
+            (\(.*\))?   # $4: list of permitted values, n.b. perl syntax!
+            \s*,\s*     # comma, optional whitespace
+            \"([^\"]+)\"# $5: last modified version (don't capture quotes)
+            \s*         # optional whitespace
+            (,.*)?      # $6: deprecation info
+            }           # closing curly
+        |x) {
         my $opt = $1;
         my $def;
         my $depver = "NULL";
         my $newopt = "ZERO";
         my $enums = "";
+        my $lastmod = parse_last_modified($5);
 
         print HFILE "  IMAPOPT_", uc($opt), ",\n";
 
@@ -233,7 +254,7 @@ while (<STDIN>) {
             }
             $e .= "0";
             $def = $use_gcc_extension
-                        ? "U_CFG_V((unsigned long) $e)"
+                        ? "U_CFG_V((unsigned long long) $e)"
                         : "{(void *)($e)}";
 
             # output the enum_options
@@ -244,7 +265,7 @@ while (<STDIN>) {
                 $enums .= " { \"$v\" , $e },\n     ";
 
                 # add the corresponding bit value
-                $e .= " = (1<<$count)";
+                $e .= " = (1LL<<$count)";
 
                 # add this enum to enum_values
                 push(@enum_values, $e);
@@ -254,24 +275,36 @@ while (<STDIN>) {
 
             # [re]set the size of the enum_options array
             if ($count > $enum_size) { $enum_size = $count; }
+        } elsif ($3 eq "DURATION") {
+            $def = $use_gcc_extension
+                        ? "U_CFG_V((const char *) $2)"
+                        : "{(void *)($2)}";
         } else {
             $def = $use_gcc_extension
                         ? "U_CFG_V((long) $2)"
                         : "{(void*)$2}";
         }
 
-        if ($5) {
+        if ($6) {
             # option is deprecated
-            if ($5 =~ m|,\s*(\"[^,]+\")\s*(,\s*\"(.+)\")?|) {
+            if ($6 =~ m|
+                    ,\s*            # comma and optional whitespace
+                    (\"[^,]+\")     # $1: 'deprecated since' version string
+                    \s*             # optional whitespace
+                    (               # $2: (unused)
+                        ,\s*        # comma and optional whitespace
+                        \"(.+)\"    # $3: 'in favour of' option name
+                    )?
+                |x) {
                 $depver = $1;
                 $newopt = $3 if $3;
             } else {
                 #chomp;
-                #print "rejected '$5'\n";
+                #print "rejected '$6'\n";
             }
         }
 
-        print CFILE "  { IMAPOPT_", uc($opt), ", \"$1\", 0, OPT_$3,\n",
+        print CFILE "  { IMAPOPT_", uc($opt), ", \"$1\", 0, OPT_$3, $lastmod,\n",
         "    $depver, IMAPOPT_", uc($newopt), ",\n",
         "    $def,\n    $def,\n    {$enums { NULL, IMAP_ENUM_ZERO } } },\n";
     } else {
@@ -304,11 +337,11 @@ print HFILE <<EOF
 
 union config_value {
     $dummy_field
-    const char *s;      /* OPT_STRING, OPT_STRINGLIST */
+    const char *s;      /* OPT_STRING, OPT_STRINGLIST, OPT_DURATION */
     long i;             /* OPT_INT */
     long b;             /* OPT_SWITCH */
     enum enum_value e;  /* OPT_ENUM */
-    unsigned long x;    /* OPT_BITFIELD */
+    unsigned long long x; /* OPT_BITFIELD */
 };
 
 struct enum_option_s {
@@ -322,6 +355,7 @@ struct imapopt_s {
     const char *optname;
     int seen;
     const enum opttype t;
+    uint32_t last_modified;
     const char *deprecated_since;
     const enum imapopt preferred_opt;
     union config_value val;
@@ -341,7 +375,7 @@ EOF
     ;
 
 print CFILE <<EOF
-  { IMAPOPT_LAST, NULL, 0, OPT_NOTOPT, NULL, IMAPOPT_ZERO, { NULL }, { NULL }, { { NULL, IMAP_ENUM_ZERO } } }
+  { IMAPOPT_LAST, NULL, 0, OPT_NOTOPT, 0, NULL, IMAPOPT_ZERO, { NULL }, { NULL }, { { NULL, IMAP_ENUM_ZERO } } }
 };
 
 /* c code goes here */
diff -pruN 3.0.13-5/tools/config2man 3.2.0-3/tools/config2man
--- 3.0.13-5/tools/config2man	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/config2man	1970-01-01 00:00:00.000000000 +0000
@@ -1,134 +0,0 @@
-#!/bin/sh
-#
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-#
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in
-#    the documentation and/or other materials provided with the
-#    distribution.
-#
-# 3. The name "Carnegie Mellon University" must not be used to
-#    endorse or promote products derived from this software without
-#    prior written permission. For permission or any legal
-#    details, please contact
-#      Carnegie Mellon University
-#      Center for Technology Transfer and Enterprise Creation
-#      4615 Forbes Avenue
-#      Suite 302
-#      Pittsburgh, PA  15213
-#      (412) 268-7393, fax: (412) 268-7395
-#      innovation@andrew.cmu.edu
-#
-# 4. Redistributions of any form whatsoever must retain the following
-#    acknowledgment:
-#    "This product includes software developed by Computing Services
-#     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
-#
-# CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
-# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
-# AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
-# FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
-# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
-# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
-# OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
-
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
-require 5;
-
-use strict;
-
-sub print_values {
-    my @values = eval $_[0];
-    my $v;
-    my $sep = " ";
-
-    print "\nAllowed values:";
-    foreach $v (@values) {
-        print "$sep\\fI$v\\fR";
-        $sep = ", ";
-    }
-    print "\n";
-}
-
-my $mode = 0;
-my $save = "";
-my $enums = "";
-my $opt;
-
-my $blank = "";
-my $version = "\$Revision: 1.6 $blank";
-$version =~ s/.Revision: (.*) /$1/;
-print ".\\\" -*- nroff -*-\n";
-print ".\\\" auto-generated by config2man $version\n";
-
-while (<>) {
-    if ($mode == 0) {
-        # look for { option, default, type [enums] }; don't output until we
-        # hit a comment
-        if (m|{\s*\"(.*?)\"\s*,\s*\"?(.*?)\"?\s*,\s*(.*?)\s*(\(.*\))?\s*}|) {
-            $opt = $1;
-            my $def = $2 eq "NULL" ? "<none>" : $2;
-            if ($def eq "") { $def = "<empty string>" }
-            $save = ".IP \"\\fB$1:\\fR $def\" 5\n";
-            $enums = $4;
-        }
-
-        # look for single-line comment
-        elsif (m|/\*\s*(.*)\s*\*/|) {
-            print $save; $save = "";
-            print "$1\n";
-            if ($enums) { print_values($enums); }
-            $opt = undef;
-        }
-
-        # look for /* to shift into passthrough mode; print current
-        # cached option header if any
-        elsif (m|/\*\s*(.*)|) {
-            print $save; $save = "";
-            if (defined $opt) { print ".RS 5\n"; }
-            print $1;
-            print "\n"; # add LF so lines don't run together
-            $mode = 1;
-        }
-        else {
-            chomp;
-            #print "ignoring '$_'\n";
-        }
-    } elsif ($mode == 1) {
-        # passthru; look for */ to end
-        if (m|\s*(.*)\*/|) {
-            print $1;
-            print "\n";
-            if ($enums) { print_values($enums); }
-            $mode = 0; # back to search mode
-            if (defined $opt) { print ".RE\n"; }
-            $opt = undef;
-        } elsif (m|\s*(.*)\s*|) {
-            print "$1\n";
-        }
-    }
-}
diff -pruN 3.0.13-5/tools/config2rst 3.2.0-3/tools/config2rst
--- 3.0.13-5/tools/config2rst	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/config2rst	2020-04-24 02:03:00.000000000 +0000
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!/usr/bin/perl
 #
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+# Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -42,25 +42,6 @@
 #
 # Copyright (c) 2017 Nic Bernstein, Onlight, Inc.
 #
-
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
 package config2rst;
@@ -90,6 +71,7 @@ our $inl = 0;
 our $section = 0;
 
 my $blank = "rst";
+# XXX get rid of cvs id cruft
 my $version = "\$Revision: 1.6 $blank";
 
 sub print_values {
@@ -189,10 +171,10 @@ sub print_man2rst {
     # Title
     if (/^\.TH\s+(\S+).*$/) {
         $file = lc $1;
-        my $headlen = length $file;
+        my $headlen = 4 + length $file;
         my $header = "\n\n.. cyrusman:: $file(5)\n\n";
         $header .= ".. _imap-reference-manpages-configs-$file:\n\n";
-        $header .= '=' x $headlen . "\n$file\n" . '=' x $headlen . "\n";
+        $header .= '=' x $headlen . "\n**$file**\n" . '=' x $headlen . "\n";
         $_ = $header;
     }
     # Section Header, zero all of our special indenters
@@ -322,7 +304,22 @@ while (<>) {
     if ($mode == 0) {
         # look for { option, default, type [enums] }; don't output until we
         # hit a comment
-        if (m|{\s*\"(.*?)\"\s*,\s*\"?(.*?)\"?\s*,\s*(.*?)\s*(\(.*\))?\s*}|) {
+        # n.b. we explicitly do not match deprecated options here
+        if (m|
+                {           # opening curly
+                \s*         # skip leading whitespace
+                \"(.*?)\"   # $1: option name (don't capture quotes)
+                \s*,\s*     # comma, optional whitespace
+                \"?(.*?)\"? # $2: default value (don't capture quotes)
+                \s*,\s*     # comma, optional whitespace
+                (.*?)       # $3: option type
+                \s*         # optional whitespace
+                (\(.*\))?   # $4: list of permitted values, n.b. perl syntax!
+                \s*,\s*     # comma, optional whitespace
+                \"([^\"]+)\" # $5: last modified version (don't capture quotes)
+                \s*         # optional whitespace
+                }           # closing curly
+            |x) {
             $opt = $1;
             my $def = $2 eq "NULL" ? "<none>" : $2;
             if ($def eq "") { $def = "<empty string>" }
@@ -330,6 +327,7 @@ while (<>) {
             # later, from an include directive.
             $save = "\n    .. startblob $opt\n\n";
             $save .= print_man2rst('\fC' . $opt . ':\fR ' . $def . "\n");
+            # XXX report version this option was last modified by
             $enums = $4;
         }
 
@@ -369,7 +367,7 @@ while (<>) {
             $opt = '';
         } elsif (m|\s*(.*)\s*|) {
             my $stripped = $1;
-	    chomp($stripped);
+            chomp($stripped);
             print print_man2rst($stripped);
         }
     }
diff -pruN 3.0.13-5/tools/config2sample 3.2.0-3/tools/config2sample
--- 3.0.13-5/tools/config2sample	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/config2sample	2020-04-24 02:03:00.000000000 +0000
@@ -1,8 +1,6 @@
-#!/bin/sh
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
+#!/usr/bin/perl
 #
-# Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
+# Copyright (c) 1994-2019 Carnegie Mellon University.  All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -67,6 +65,7 @@ our $inl = 0;
 our $section = 0;
 
 my $blank = "rst";
+# XXX get rid of cvs id cruft
 my $version = "\$Revision: 1.6 $blank";
 
 sub print_values {
@@ -291,7 +290,22 @@ while (<>) {
     if ($mode == 0) {
         # look for { option, default, type [enums] }; don't output until we
         # hit a comment
-        if (m|{\s*\"(.*?)\"\s*,\s*\"?(.*?)\"?\s*,\s*(.*?)\s*(\(.*\))?\s*}|) {
+        # n.b. we explicitly do not match deprecated options here
+        if (m|
+                {           # opening curly
+                \s*         # skip leading whitespace
+                \"(.*?)\"   # $1: option name (don't capture quotes)
+                \s*,\s*     # comma, optional whitespace
+                \"?(.*?)\"? # $2: default value (don't capture quotes)
+                \s*,\s*     # comma, optional whitespace
+                (.*?)       # $3: option type
+                \s*         # optional whitespace
+                (\(.*\))?   # $4: list of permitted values, n.b. perl syntax!
+                \s*,\s*     # comma, optional whitespace
+                \"[^\"]+\"  # last modified version
+                \s*         # optional whitespace
+                }           # closing curly
+            |x) {
             $opt = $1;
             my $def = $2 eq "NULL" ? "<none>" : $2;
             if ($def eq "") { $def = "<empty string>" }
diff -pruN 3.0.13-5/tools/fixsearchpath.pl 3.2.0-3/tools/fixsearchpath.pl
--- 3.0.13-5/tools/fixsearchpath.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/fixsearchpath.pl	2020-04-24 02:03:00.000000000 +0000
@@ -75,8 +75,9 @@ my @dirvars = (
 
 my $boilerplate = << 'EOT'
 ## Boilerplate added by Cyrus fixsearchpath.pl
-my $__cyrus_destdir = '';
+my $__cyrus_destdir;
 BEGIN {
+    $__cyrus_destdir = '';
     if ($0 =~ m/\//) {
         my $d = $0;
 EOT
diff -pruN 3.0.13-5/tools/git-version.sh 3.2.0-3/tools/git-version.sh
--- 3.0.13-5/tools/git-version.sh	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/tools/git-version.sh	2020-04-24 02:03:00.000000000 +0000
@@ -46,7 +46,7 @@ test -s VERSION &&
     exec head -1 VERSION
 
 # first try: based on annotated git tags (real releases)
-version=$(git describe --dirty=-dirty 2>/dev/null)
+version=$(git describe --dirty=-dirty --match 'cyrus-imapd-*' 2>/dev/null)
 test -n "$version" &&
     version=$(echo "$version" | sed -e 's/^cyrus-imapd-//')
 
diff -pruN 3.0.13-5/tools/jenkins-build.sh 3.2.0-3/tools/jenkins-build.sh
--- 3.0.13-5/tools/jenkins-build.sh	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/jenkins-build.sh	2020-04-24 02:03:00.000000000 +0000
@@ -103,7 +103,6 @@ CONFIGURE_ARGS="\
     --with-cyrus-prefix=/usr/cyrus \
     --with-ldap \
     --with-openssl \
-    --disable-event-notification \
     --enable-sieve \
     --enable-idled \
     --enable-nntp \
diff -pruN 3.0.13-5/tools/masssievec 3.2.0-3/tools/masssievec
--- 3.0.13-5/tools/masssievec	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/masssievec	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/usr/bin/perl
 #
 # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
 #
@@ -39,28 +39,11 @@
 # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-#
-# Script for mass compilation of sieve scripts.
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
+#use strict; # XXX does not compile with strict :(
+use warnings;
+
 $| = 1;
 
 die "must not run as root" if ($< == 0);
@@ -100,7 +83,6 @@ sub read_conf {
             push @configs, $1;
         }
         if (/^sieveusehomedir:\s+(1|t|yes|on)/) {
-            $nosievedir = 1;
             print "you are storing sieve scripts in user's home directories, this script cannot deal with that\n";
             exit;
         }
@@ -141,7 +123,7 @@ while (defined($s = readdir TOP)) {
                 symlink "$dest.bc", "defaultbc" || warn "can't symlink $dest.bc to defaultbc: $!";
                 unlink ("default");
             } elsif ($u eq "default.bc" && -l $u) {
-                # slightly different upgrade foramt
+                # slightly different upgrade format
                 $dest = readlink $u;
                 next unless($dest =~ m/\.bc$/ && $dest ne "default.bc");
                 symlink "$dest", "defaultbc" || warn "can't symlink $dest to defaultbc: $!";
@@ -160,7 +142,7 @@ while (defined($s = readdir TOP)) {
                 } elsif (defined $pid) {
                     # child
                     exec $SIEVEC, $u, "$out.bc";
-                    die "souldn't be here";
+                    die "shouldn't be here";
                 } elsif ($! =~ /No more process/) {
                     # EAGAIN
                     sleep 5; redo FORK;
diff -pruN 3.0.13-5/tools/mkimap 3.2.0-3/tools/mkimap
--- 3.0.13-5/tools/mkimap	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/mkimap	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/usr/bin/perl
 #
 # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
 #
@@ -39,26 +39,11 @@
 # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
+#use strict; # XXX does not compile with strict :(
+use warnings;
+
 sub read_conf {
     my $file = shift;
 
diff -pruN 3.0.13-5/tools/mknewsgroups 3.2.0-3/tools/mknewsgroups
--- 3.0.13-5/tools/mknewsgroups	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/mknewsgroups	2020-04-24 02:03:00.000000000 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/usr/bin/perl
 #
 # Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
 #
@@ -39,29 +39,11 @@
 # AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 # OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-exec perl -x -S $0 ${1+"$@"} # -*-perl-*-
-#!perl -w
-#
-# Create newsgroups on imap server
-# Based on the make_fromactive.pl script by Tim Martin
-
-if ($] !~ /^5\..*/) {
-  # uh-oh. this isn't perl 5.
-  foreach (split(/:/, $ENV{PATH})) { # try to find "perl5".
-    exec("$_/perl5", "-x", "-S", $0, @ARGV) if (-x "$_/perl5");
-  }
-  # we failed. bail.
-  die "Your perl is too old; I need perl 5.\n";
-}
-
-# load the real script. this is isolated in an 'eval' so perl4 won't
-# choke on the perl5-isms.
-eval join("\n", <DATA>);
-if ($@) { die "$@"; }
-
-__END__
 require 5;
 
+#use strict; # XXX does not compile with strict :(
+use warnings;
+
 use Getopt::Long;
 use Cyrus::IMAP;
 use Cyrus::IMAP::Admin;
@@ -112,7 +94,7 @@ while ($acl =~ /^\s*([^\s]+)\s+([^\s]+)/
     $acl =~ s/^\s*([^\s]+)\s+([^\s]+)//;        # skip this id/rights pair
 }
 
-my ($newsprefix, $unixhiersep) = (undef, 0);
+my ($newsprefix, $unixhierarchysep) = (undef, 0);
 
 open CONF, $config or die "can't open $config";
 print "reading configure file...\n";
@@ -125,7 +107,7 @@ while (<CONF>) {
         print "you are using \"$newsprefix\" as your news prefix.\n";
     }
     if (/^unixhierarchysep:\s+(1|t|yes|on)/) {
-        $unixhiersep = 1;
+        $unixhierarchysep = 1;
         print "i will deal with unix hierarchy separator.\n";
     }
 }
@@ -163,8 +145,8 @@ while( <INPUT> )
             # add newsprefix if necessary
             $mbox = $newsprefix . "." . $mbox if (defined($newsprefix));
 
-            # switch to unixhiersep if necessary
-            $mbox =~ s^\.^/^g if ($unixhiersep);
+            # switch to unixhierarchysep if necessary
+            $mbox =~ s^\.^/^g if ($unixhierarchysep);
 
             if ($noop) {
                 $part = "" if (!defined($part));
diff -pruN 3.0.13-5/tools/perl2rst 3.2.0-3/tools/perl2rst
--- 3.0.13-5/tools/perl2rst	1970-01-01 00:00:00.000000000 +0000
+++ 3.2.0-3/tools/perl2rst	2019-11-15 03:25:39.000000000 +0000
@@ -0,0 +1,37 @@
+#!/usr/bin/perl -w
+
+use strict;
+use warnings;
+
+use Pod::POM::View::Restructured;
+
+{
+    no warnings 'redefine';
+    *Pod::POM::View::Restructured::view_for = sub {
+        my ($self, $node) = @_;
+
+        my $fmt = $node->format();
+
+        #print STDERR "got for: fmt='$fmt', text='" . $node->text() . "'\n";
+
+        if ($fmt eq 'pod2rst') {
+            my $text = $node->text();
+            if ($text =~ /\A\s*next-code-block\s*:\s*(\S+)/) {
+                my $lang = $1;
+                $self->{next_code_block} = $lang;
+                return '';
+            }
+
+            return "\n" . $text . "\n";
+        }
+
+        return $self->SUPER::view_for($node);
+    };
+}
+
+my $title = shift || die "Usage: $0 title < in > out";
+
+my $conv = Pod::POM::View::Restructured->new;
+my $output = $conv->convert_file(\*STDIN, "**$title**", \*STDOUT);
+
+
diff -pruN 3.0.13-5/tools/translatesieve 3.2.0-3/tools/translatesieve
--- 3.0.13-5/tools/translatesieve	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/translatesieve	2020-04-24 02:03:00.000000000 +0000
@@ -110,7 +110,7 @@ usage: $0 [-v] [-n] [-u] [-a] [-C imapd.
 
 NOTE: if imapd.conf is not provided, it will be read from the default
 location.  On a normal system this will be /etc/imapd.conf.  The *new*
-settings for unixhierarcysep and altnamespace will be read from the
+settings for unixhierarchysep and altnamespace will be read from the
 provided imapd.conf.
 
 WARNING: By default, this utility assumes that the OLD configuration
diff -pruN 3.0.13-5/tools/vzic/ChangeLog 3.2.0-3/tools/vzic/ChangeLog
--- 3.0.13-5/tools/vzic/ChangeLog	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/ChangeLog	1970-01-01 00:00:00.000000000 +0000
@@ -1,57 +0,0 @@
-2006-03-18  Damon Chaplin  <damon@gnome.org>
-
-        * Released Vzic 1.3
-
-2006-03-18  Damon Chaplin  <damon@gnome.org>
-
-        * vzic-output.c (expand_tzname): added special case for America/Nome.
-        (output_rrule): made hacks a bit more general, to handle Asia/Gaza
-        which now has a day=4 rule. At some point we should check what newer
-        versions of Outlook can handle so we can be more accurate.
-
-        * vzic-dump.c (dump_time_zone_names): try looking for timezone info
-        using original and linked name.
-
-        * README, *.c: fixed spelling 'compatable' -> 'compatible'.
-
-        * vzic.c: patch from Jonathan Guthrie to support a --olson-dir option.
-
-2003-10-25  Damon Chaplin  <damon@gnome.org>
-
-        * Released Vzic 1.2
-
-2003-10-25  Damon Chaplin  <damon@gnome.org>
-
-        * vzic-output.c:
-        * Makefile: moved the PRODUCT_ID and TZID_PREFIX settings to the
-        Makefile and changed the default so people don't accidentally use
-        the same IDs as Evolution.
-
-        * vzic-parse.c (parse_time): substitute 23:59:59 when we read a time
-        of 24:00:00. This is a bit of a kludge to avoid problems, since
-        24:00:00 is not a valid iCalendar time. Since 24:00:00 is only used
-        for a few timezones in the 1930s it doesn't matter too much.
-
-        To write a correct fix we'd need to review all the code that deals
-        with times to see if it would be affected, e.g. a time of 24:00 on
-        one day should be considered equal to 0:00 the next day.
-
-        We'd also need to adjust the output times to use 0:00 the next day
-        rather than 24:00. If we need to output recurrence rules that would
-        be a problem, since 'last saturday at 24:00' can't be easily
-        converted to another rule that uses 0:00 instead.
-
-2003-10-22  Damon Chaplin  <damon@gnome.org>
-
-        * Released Vzic 1.1
-
-2003-10-22  Damon Chaplin  <damon@gnome.org>
-
-        * vzic-parse.c (parse_time): allow a time of 24:00, as used in
-        the America/Montreal and America/Toronto rules in the 1930s!
-        I'm not 100% sure the rest of the code will handle this OK, but
-        it only affects the 'pure' output.
-
-2003-09-01  Damon Chaplin  <damon@gnome.org>
-
-        * Released Vzic 1.0
diff -pruN 3.0.13-5/tools/vzic/Makefile 3.2.0-3/tools/vzic/Makefile
--- 3.0.13-5/tools/vzic/Makefile	2019-12-16 03:57:37.000000000 +0000
+++ 3.2.0-3/tools/vzic/Makefile	1970-01-01 00:00:00.000000000 +0000
@@ -1,94 +0,0 @@
-
-#
-# You will need to set this to the directory that the Olson timezone data
-# files are in.
-#
-OLSON_DIR = .
-
-
-# This is used as the PRODID property on the iCalendar files output.
-# It identifies the product which created the iCalendar objects.
-# So you need to substitute your own organization name and product.
-PRODUCT_ID = -//CyrusIMAP.org//Cyrus %s//EN
-
-# This is what libical-evolution uses.
-#PRODUCT_ID = -//Ximian//NONSGML Evolution Olson-VTIMEZONE Converter//EN
-
-
-# This is used to create unique IDs for each VTIMEZONE component.
-# The prefix is put before each timezone city name. It should start and end
-# with a '/'. The first part, i.e. 'myorganization.org' below, should be
-# a unique vendor ID, e.g. use a hostname. The part after that can be
-# anything you want. We use a date and version number for libical. The %D
-# gets expanded to today's date. There is also a vzic-merge.pl which can be
-# used to merge changes into a master set of VTIMEZONEs. If a VTIMEZONE has
-# changed, it bumps the version number on the end of this prefix. */
-#TZID_PREFIX = /myorganization.org/%D_1/
-TZID_PREFIX =
-
-# This is what libical-evolution uses.
-#TZID_PREFIX = /softwarestudio.org/Olson_%D_1/
-
-
-# Set any -I include directories to find the libical header files, and the
-# libical library to link with. You only need these if you want to run the
-# tests. You may need to change the '#include <ical.h>' line at the top of
-# test-vzic.c as well.
-LIBICAL_CFLAGS =
-LIBICAL_LDADD = -lical
-
-
-#
-# You shouldn't need to change the rest of the file.
-#
-
-GLIB_CFLAGS = `pkg-config --cflags glib-2.0`
-GLIB_LDADD = `pkg-config --libs glib-2.0`
-
-CFLAGS = -g -I../.. -DOLSON_DIR=\"$(OLSON_DIR)\" -DPRODUCT_ID='"$(PRODUCT_ID)"' -DTZID_PREFIX='"$(TZID_PREFIX)"' $(GLIB_CFLAGS) $(LIBICAL_CFLAGS)
-
-OBJECTS = vzic.o vzic-parse.o vzic-dump.o vzic-output.o
-
-all: vzic
-
-vzic: $(OBJECTS)
-	$(CC) $(OBJECTS) $(GLIB_LDADD) -o vzic
-
-test-vzic: test-vzic.o
-	$(CC) test-vzic.o $(LIBICAL_LDADD) -o test-vzic
-
-# Dependencies.
-$(OBJECTS): vzic.h
-vzic.o vzic-parse.o: vzic-parse.h
-vzic.o vzic-dump.o: vzic-dump.h
-vzic.o vzic-output.o: vzic-output.h
-
-test-parse: vzic
-	./vzic-dump.pl $(OLSON_DIR)
-	./vzic --dump --pure
-	@echo
-	@echo "#"
-	@echo "# If either of these diff commands outputs anything there may be a problem."
-	@echo "#"
-	diff -ru zoneinfo/ZonesPerl zoneinfo/ZonesVzic
-	diff -ru zoneinfo/RulesPerl zoneinfo/RulesVzic
-
-test-changes: vzic test-vzic
-	./test-vzic --dump-changes
-	./vzic --dump-changes --pure
-	@echo
-	@echo "#"
-	@echo "# If this diff command outputs anything there may be a problem."
-	@echo "#"
-	diff -ru zoneinfo/ChangesVzic test-output
-
-check:
-
-clean:
-	-rm -rf vzic $(OBJECTS) *~ ChangesVzic RulesVzic ZonesVzic RulesPerl ZonesPerl test-vzic test-vzic.o
-
-install:
-
-.PHONY: clean perl-dump test-parse check
-
-
diff -pruN 3.0.13-5/tools/vzic/README 3.2.0-3/tools/vzic/README
--- 3.0.13-5/tools/vzic/README	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,202 +0,0 @@
-
-
-VZIC README
-===========
-
-This is 'vzic', a program to convert the Olson timezone database files into
-VTIMEZONE files compatible with the iCalendar specification (RFC2445).
-
-(The name is based on the 'zic' program which converts the Olson files into
-time zone information files used by several Unix C libraries, including
-glibc. See zic(8) and tzfile(5).)
-
-
-
-REQUIREMENTS
-============
-
-You need the Olson timezone database files, which  can be found at:
-
-  ftp://elsie.nci.nih.gov/pub/
-
-  (Old versions can be found at ftp://munnari.oz.au/pub/oldtz/)
-
-
-Vzic also uses the GLib library (for hash tables, dynamic arrays, and date
-calculations). You need version 2.0 or higher. You can get this from:
-
-  http://www.gtk.org
-
-
-
-BUILDING
-========
-
-Edit the Makefile to set the OLSON_DIR, PRODUCT_ID and TZID_PREFIX variables.
-
-Then run 'make'.
-
-
-
-RUNNING
-=======
-
-Run 'vzic'.
-
-The output is placed in the zoneinfo subdirectory by default,
-but you can use the --output-dir options to set another toplevel output
-directory.
-
-By default it outputs VTIMEZONEs that try to be compatible with Outlook
-(2000, at least). Outlook can't handle certain iCalendar constructs in
-VTIMEZONEs, such as RRULEs using BYMONTHDAY, so it has to adjust the RRULEs
-slightly to get Outlook to parse them. Unfortunately this means they are
-slightly wrong. If given the --pure option, vzic outputs the exact data,
-without worrying about compatibility.
-
-NOTE: We don't convert all the Olson files. We skip 'backward', 'etcetera',
-'leapseconds', 'pacificnew', 'solar87', 'solar88' and 'solar89', 'factory'
-and 'systemv', since these don't really provide any useful timezones.
-See vzic.c.
-
-
-
-MERGING CHANGES INTO A MASTER SET OF VTIMEZONES
-===============================================
-
-The Olson timezone files are updated fairly often, so we need to build new
-sets of VTIMEZONE files. Though we have to be careful to ensure that the TZID
-of updated timezones is also updated, since it must remain unique.
-
-We use a version number on the end of the TZID prefix (see the TZIDPrefix
-variable in vzic-output.c) to ensure this uniqueness.
-
-But we don't want to update the version numbers of VTIMEZONEs which have not
-changed. So we use the vzic-merge.pl Perl script. This merges in the new set
-of VTIMEZONEs with a 'master' set. It compares each new VTIMEZONE file with
-the one in the master set (ignoring changes to the TZID). If the new
-VTIMEZONE file is different, it copies it to the master set and sets the
-version number to the old VTIMEZONE's version number + 1.
-
-To use vzic-merge.pl you must change the $MASTER_ZONEINFO_DIR and
-$NEW_ZONEINFO_DIR variables at the top of the file to point to your 2 sets of
-VTIMEZONEs. You then just run the script. (I recommend you keep a backup of
-the old master VTIMEZONE files, and use diff to compare the new master set
-with the old one, in case anything goes wrong.)
-
-You must merge in changes to the zones.tab file by hand.
-
-Note that some timezones are renamed or removed occasionally, so applications
-should be able to cope with this.
-
-
-
-COMPATABILITY NOTES
-===================
-
-It seems that Microsoft Outlook is very picky about the iCalendar files it
-will accept. (I've been testing with Outlook 2000. I hope the other versions
-are no worse.) Here's a few problems we've had with the VTIMEZONEs:
-
- o Outlook doesn't like any years before 1600. We were using '1st Jan 0001'
-   in all VTIMEZONEs to specify the first UTC offset known for the timezone.
-   (The Olson data does not give a start date for this.)
-
-   Now we just skip this first component for most timezones. The UTC offset
-   can still be found from the TZOFFSETFROM property of the first component.
-
-   Though some timezones only specify one UTC offset that applies forever,
-   so in these cases we output '1st Jan 1970' (Indian/Cocos,
-   Pacific/Johnston).
-
- o Outlook doesn't like the BYMONTHDAY specifier in RRULEs.
-
-   We have changed most of the VTIMEZONEs to use things like 'BYDAY=2SU'
-   rather than 'BYMONTHDAY=8,9,10,11,12,13,14;BYDAY=SU', though some of
-   them were impossible to convert correctly so they are not always correct.
-
- o Outlook doesn't like TZOFFSETFROM/TZOFFSETTO properties which include a
-   seconds component, e.g. 'TZOFFSETFROM:+110628'.
-   Quite a lot of the Olson timezones include seconds in their UTC offsets,
-   though no timezones currently have a UTC offset that uses the seconds
-   value.
-
-   We've rounded all UTC offsets to the nearest minute. Since all timezone
-   offsets currently used have '00' as the seconds offset, this doesn't lose
-   us much.
-
- o Outlook doesn't like lines being split in certain places, even though
-   the iCalendar spec says they can be split anywhere.
-
- o Outlook can only handle one RDATE or a pair of RRULEs. So we had to remove
-   all historical data.
-
-
-TESTING
-=======
-
-Do a 'make test-vic', then run ./test-vic.
-
-The test-vzic program compares our libical code and VTIMEZONE data against
-the Unix functions like mktime(). It steps over a period of time (1970-2037)
-converting from UTC to a given timezone and back again every 15 minutes.
-Any differences are output into the test-output directory.
-
-The output matches for all of the timezones, except in a few places where the
-result can't be determined. So I think we can be fairly confident that the
-VTIMEZONEs are correct.
-
-Note that you must use the same Olson data in libical that the OS is using
-for mktime() etc. For example, I am using RedHat 9 which uses tzdata2002d,
-so I converted this to VTIMEZONE files and installed it into the libical
-timezone data directory before testing. (You need to use '--pure' when
-creating the VTIMEZONE files as well.)
-
-
-Testing the Parsing Code
-------------------------
-
-Run 'make test-parse'.
-
-This runs 'vzic --dump' and 'perl-dump' and compares the output. The diff
-commands should not produce any output.
-
-'vzic --dump' dumps all the parsed data out in the original Olson format,
-but without comments. The files are written into the ZonesVzic and RulesVzic
-subdirectories of the zoneinfo directory.
-
-'make perl-dump' runs the vzic-dump.pl perl script which outputs the files
-in the same format as 'vzic --dump' in the ZonesPerl and RulesPerl
-subdirectories. The perl script doesn't actually parse the fields; it only
-strips comments and massages the fields so we have the same output format.
-
-Currently they both produce exactly the same output so we know the parsing
-code is OK.
-
-
-Testing the VTIMEZONE Files
----------------------------
-
-Run 'make test-changes'.
-
-This runs 'vzic --dump-changes' and 'test-vzic --dump-changes' and compares
-the output. The diff command should not produce any output.
-
-Both commands output timezone changes for each zone up to a specific year
-(2030) into files for each timezone. It outputs the timezone changes in a
-list in this format:
-
-  Timezone Name        Date and Time of Change in UTC   New Offset from UTC
-
-  America/Dawson        26 Oct 1986      2:00:00        -0800
-
-Unfortunately there are some differences here, but they all happen before
-1970 so it doesn't matter too much. It looks like the libical code has
-problems determining things like 'last Sunday of the month' before 1970.
-This is because it uses mktime() etc. which can't really handle dates
-before 1970.
-
-
-
-Damon Chaplin <damon@gnome.org>, 25 Oct 2003.
-
diff -pruN 3.0.13-5/tools/vzic/test-vzic.c 3.2.0-3/tools/vzic/test-vzic.c
--- 3.0.13-5/tools/vzic/test-vzic.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/test-vzic.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,422 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-/*
- * test-vzic.c - test vzic + libical against mktime() and friends.
- *
- * Note that when we output VCALENDAR data compatible with Outlook the
- * results aren't all correct.
- *
- * We have to modify some RRULEs which makes these timezones incorrect:
- *
- *   Africa/Cairo
- *   America/Godthab
- *   America/Santiago
- *   Antarctica/Palmer
- *   Asia/Baghdad
- *   Asia/Damascus
- *   Asia/Jerusalem
- *
- * Also, we can only output one RDATE or a pair of RRULEs which may make some
- * other timezones incorrect sometimes (e.g. if they change).
- */
-
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <unistd.h>
-#include <errno.h>
-
-#include <ical.h>
-/*#include <evolution/ical.h>*/
-
-#define CHANGES_MAX_YEAR 2030
-
-/* These are the years between which we test against the Unix timezone
-   functions, inclusive. When using 'vzic --pure' you can test the full
-   range from 1970 to 2037 and it should match against mktime() etc.
-   (assuming you are using the same Olson timezone data for both).
-
-   But when using VTIMEZONE's that are compatible with Outlook, it is only
-   worth testing times in the future. There will be lots of differences in
-   the past, since we can't include any historical changes in the files. */
-#if 1
-#define DUMP_START_YEAR 2003
-#define DUMP_END_YEAR   2038
-#else
-#define DUMP_START_YEAR 1970
-#define DUMP_END_YEAR   2038
-#endif
-
-/* The maximum size of any complete pathname. */
-#define PATHNAME_BUFFER_SIZE    1024
-
-#ifndef FALSE
-#define FALSE   (0)
-#endif
-
-#ifndef TRUE
-#define TRUE    (!FALSE)
-#endif
-
-int VzicDumpChanges             = FALSE;
-
-/* We output beneath the current directory for now. */
-char *directory = "test-output";
-
-static void     usage                           (void);
-static int      parse_zone_name                 (char           *name,
-                                                 char          **directory,
-                                                 char          **subdirectory,
-                                                 char          **filename);
-static void     ensure_directory_exists         (char           *directory);
-static void     dump_local_times                (icaltimezone   *zone,
-                                                 FILE           *fp);
-
-
-int main(int argc, char* argv[])
-{
-  icalarray *zones;
-  icaltimezone *zone;
-  char *zone_directory, *zone_subdirectory, *zone_filename, *location;
-  char output_directory[PATHNAME_BUFFER_SIZE];
-  char filename[PATHNAME_BUFFER_SIZE];
-  FILE *fp;
-  int i;
-  int skipping = TRUE;
-
-  /*
-   * Command-Line Option Parsing.
-   */
-  for (i = 1; i < argc; i++) {
-    /* --dump-changes: Dumps a list of times when each timezone changed,
-       and the new local time offset from UTC. */
-    if (!strcmp (argv[i], "--dump-changes"))
-      VzicDumpChanges = TRUE;
-
-    else
-      usage ();
-  }
-
-
-  zones = icaltimezone_get_builtin_timezones ();
-
-  ensure_directory_exists (directory);
-
-  for (i = 0; i < zones->num_elements; i++) {
-    zone = icalarray_element_at (zones, i);
-
-    location = icaltimezone_get_location (zone);
-
-#if 0
-    /* Use this to start at a certain zone. */
-    if (skipping && strcmp (location, "America/Boise"))
-      continue;
-#endif
-
-    skipping = FALSE;
-
-    /* Use this to only output data for certain timezones. */
-#if 0
-    if (strcmp (location, "America/Cancun")
-        && strcmp (location, "Asia/Baku")
-        && strcmp (location, "Asia/Nicosia")
-        && strcmp (location, "Asia/Novosibirsk")
-        && strcmp (location, "Asia/Samarkand")
-        && strcmp (location, "Asia/Tashkent")
-        && strcmp (location, "Asia/Tbilisi")
-        && strcmp (location, "Asia/Yerevan")
-        && strcmp (location, "Australia/Broken_Hill")
-        && strcmp (location, "Europe/Simferopol")
-        && strcmp (location, "Europe/Tallinn")
-        && strcmp (location, "Europe/Zaporozhye")
-        )
-      continue;
-#endif
-
-#if 0
-    printf ("%s\n", location);
-#endif
-
-    parse_zone_name (location, &zone_directory, &zone_subdirectory,
-                     &zone_filename);
-
-    sprintf (output_directory, "%s/%s", directory, zone_directory);
-    ensure_directory_exists (output_directory);
-    sprintf (filename, "%s/%s", output_directory, zone_filename);
-
-    if (zone_subdirectory) {
-      sprintf (output_directory, "%s/%s/%s", directory, zone_directory,
-               zone_subdirectory);
-      ensure_directory_exists (output_directory);
-      sprintf (filename, "%s/%s", output_directory, zone_filename);
-    }
-
-    fp = fopen (filename, "w");
-    if (!fp) {
-      fprintf (stderr, "Couldn't create file: %s\n", filename);
-      exit (1);
-    }
-
-    /* We can run 2 different tests - output all changes for each zone, or
-       test against mktime()/localtime(). Should have a command-line option
-       or something. */
-    if (VzicDumpChanges)
-      icaltimezone_dump_changes (zone, CHANGES_MAX_YEAR, fp);
-    else
-      dump_local_times (zone, fp);
-
-    if (ferror (fp)) {
-      fprintf (stderr, "Error writing file: %s\n", filename);
-      exit (1);
-    }
-
-    fclose (fp);
-  }
-
-  return 0;
-}
-
-
-static void
-usage                           (void)
-{
-  fprintf (stderr, "Usage: test-vzic [--dump-changes]\n");
-
-  exit (1);
-}
-
-
-/* This checks that the Zone name only uses the characters in [-+_/a-zA-Z0-9],
-   and outputs a warning if it isn't. */
-static int
-parse_zone_name                 (char           *name,
-                                 char          **directory,
-                                 char          **subdirectory,
-                                 char          **filename)
-{
-  static int invalid_zone_num = 1;
-
-  char *p, ch, *first_slash_pos = NULL, *second_slash_pos = NULL;
-  int invalid = FALSE;
-
-  for (p = name; (ch = *p) != 0; p++) {
-    if ((ch < 'a' || ch > 'z') && (ch < 'A' || ch > 'Z')
-        && (ch < '0' || ch > '9') && ch != '/' && ch != '_'
-        && ch != '-' && ch != '+') {
-      fprintf (stderr, "Warning: Unusual Zone name: %s\n", name);
-      invalid = TRUE;
-      break;
-    }
-
-    if (ch == '/') {
-      if (!first_slash_pos) {
-        first_slash_pos = p;
-      } else if (!second_slash_pos) {
-        second_slash_pos = p;
-      } else {
-        fprintf (stderr, "Warning: More than 2 '/' characters in Zone name: %s\n", name);
-        invalid = TRUE;
-        break;
-      }
-    }
-  }
-
-  if (!first_slash_pos) {
-        fprintf (stderr, "No '/' character in Zone name: %s. Skipping.\n", name);
-        return FALSE;
-  }
-
-  if (invalid) {
-    fprintf (stderr, "Invalid zone name: %s\n", name);
-    exit (0);
-  } else {
-    *first_slash_pos = '\0';
-    *directory = icalmemory_strdup (name);
-    *first_slash_pos = '/';
-
-    if (second_slash_pos) {
-      *second_slash_pos = '\0';
-      *subdirectory = icalmemory_strdup (first_slash_pos + 1);
-      *second_slash_pos = '/';
-
-      *filename = icalmemory_strdup (second_slash_pos + 1);
-    } else {
-      *subdirectory = NULL;
-      *filename = icalmemory_strdup (first_slash_pos + 1);
-    }
-  }
-}
-
-
-static void
-ensure_directory_exists         (char           *directory)
-{
-  struct stat filestat;
-
-  if (stat (directory, &filestat) != 0) {
-    /* If the directory doesn't exist, try to create it. */
-    if (errno == ENOENT) {
-      if (mkdir (directory, 0777) != 0) {
-        fprintf (stderr, "Can't create directory: %s\n", directory);
-        exit (1);
-      }
-    } else {
-      fprintf (stderr, "Error calling stat() on directory: %s\n", directory);
-      exit (1);
-    }
-  } else if (!S_ISDIR (filestat.st_mode)) {
-    fprintf (stderr, "Can't create directory, already exists: %s\n",
-             directory);
-    exit (1);
-  }
-}
-
-
-static void
-dump_local_times (icaltimezone *zone, FILE *fp)
-{
-  static char *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-  icaltimezone *utc_timezone;
-  struct icaltimetype tt, tt_copy;
-  struct tm tm, local_tm;
-  time_t t;
-  char tzstring[256], *location;
-  int last_year_output = 0;
-  int total_error = 0, total_error2 = 0;
-
-  utc_timezone = icaltimezone_get_utc_timezone ();
-
-  /* This is our UTC time that we will use to iterate over the period. */
-  tt.year = DUMP_START_YEAR;
-  tt.month = 1;
-  tt.day = 1;
-  tt.hour = 0;
-  tt.minute = 0;
-  tt.second = 0;
-  tt.is_utc = 0;
-  tt.is_date = 0;
-  tt.zone = "";
-
-  tm.tm_year = tt.year - 1900;
-  tm.tm_mon = tt.month - 1;
-  tm.tm_mday = tt.day;
-  tm.tm_hour = tt.hour;
-  tm.tm_min = tt.minute;
-  tm.tm_sec = tt.second;
-  tm.tm_isdst = -1;
-
-  /* Convert it to a time_t by saying it is in UTC. */
-  putenv ("TZ=UTC");
-  t = mktime (&tm);
-
-  location = icaltimezone_get_location (zone);
-  sprintf (tzstring, "TZ=%s", location);
-
-  /*printf ("Zone: %s\n", location);*/
-  putenv (tzstring);
-
-  /* Loop around converting the UTC time to local time, outputting it, and
-     then adding on 15 minutes to the UTC time. */
-  while (tt.year <= DUMP_END_YEAR) {
-    if (tt.year > last_year_output) {
-      last_year_output = tt.year;
-#if 0
-      printf ("  %i\n", last_year_output);
-      fprintf (fp, "  %i\n", last_year_output);
-#endif
-    }
-
-#if 1
-    /* First use the Unix functions. */
-    /* Now convert it to a local time in the given timezone. */
-    local_tm = *localtime (&t);
-#endif
-
-#if 1
-    /* Now use libical. */
-    tt_copy = tt;
-    icaltimezone_convert_time (&tt_copy, utc_timezone, zone);
-#endif
-
-#if 1
-    if (local_tm.tm_year + 1900 != tt_copy.year
-        || local_tm.tm_mon + 1 != tt_copy.month
-        || local_tm.tm_mday != tt_copy.day
-        || local_tm.tm_hour != tt_copy.hour
-        || local_tm.tm_min != tt_copy.minute
-        || local_tm.tm_sec != tt_copy.second) {
-
-      /* The error format is:
-
-     ERROR: Original-UTC-Time  Local-Time-From-mktime  Local-Time-From-Libical
-
-      */
-
-      total_error++;
-
-      fprintf (fp, "ERROR:%2i %s %04i %2i:%02i:%02i UTC",
-               tt.day, months[tt.month - 1], tt.year,
-               tt.hour, tt.minute, tt.second);
-      fprintf (fp, " ->%2i %s %04i %2i:%02i:%02i",
-               local_tm.tm_mday, months[local_tm.tm_mon],
-               local_tm.tm_year + 1900,
-               local_tm.tm_hour, local_tm.tm_min, local_tm.tm_sec);
-      fprintf (fp, " Us:%2i %s %04i %2i:%02i:%02i\n",
-               tt_copy.day, months[tt_copy.month - 1], tt_copy.year,
-               tt_copy.hour, tt_copy.minute, tt_copy.second);
-    }
-#endif
-
-    /* Now convert it back, and check we get the original time. */
-    icaltimezone_convert_time (&tt_copy, zone, utc_timezone);
-    if (tt.year != tt_copy.year
-        || tt.month != tt_copy.month
-        || tt.day != tt_copy.day
-        || tt.hour != tt_copy.hour
-        || tt.minute != tt_copy.minute
-        || tt.second != tt_copy.second) {
-
-      total_error2++;
-
-      fprintf (fp, "ERROR 2: %2i %s %04i %2i:%02i:%02i UTC",
-               tt.day, months[tt.month - 1], tt.year,
-               tt.hour, tt.minute, tt.second);
-      fprintf (fp, " Us:%2i %s %04i %2i:%02i:%02i UTC\n",
-               tt_copy.day, months[tt_copy.month - 1], tt_copy.year,
-               tt_copy.hour, tt_copy.minute, tt_copy.second);
-    }
-
-
-    /* Increment the time. */
-    icaltime_adjust (&tt, 0, 0, 15, 0);
-
-    /* We assume leap seconds are not included in time_t values, which should
-       be true on POSIX systems. */
-    t += 15 * 60;
-  }
-
-  printf ("Zone: %40s  Errors: %i (%i)\n", icaltimezone_get_location (zone),
-          total_error, total_error2);
-}
diff -pruN 3.0.13-5/tools/vzic/vzic.c 3.2.0-3/tools/vzic/vzic.c
--- 3.0.13-5/tools/vzic/vzic.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,324 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-
-#include "vzic.h"
-#include "vzic-parse.h"
-#include "vzic-dump.h"
-#include "vzic-output.h"
-
-
-/*
- * Global command-line options.
- */
-
-/* By default we output Outlook-compatible output. If --pure is used we
-   output pure output, with no changes to be compatible with Outlook. */
-gboolean VzicPureOutput                 = FALSE;
-
-gboolean VzicDumpOutput                 = FALSE;
-gboolean VzicDumpChanges                = FALSE;
-gboolean VzicDumpZoneNamesAndCoords     = TRUE;
-gboolean VzicDumpZoneTranslatableStrings= FALSE;
-gboolean VzicNoRRules                   = FALSE;
-gboolean VzicNoRDates                   = FALSE;
-char*    VzicOutputDir                  = "zoneinfo";
-char*    VzicUrlPrefix                  = NULL;
-char*    VzicOlsonDir                   = OLSON_DIR;
-
-GList*   VzicTimeZoneNames              = NULL;
-
-static void     convert_olson_file              (char           *olson_file,
-                                                 GHashTable     *zones_hash);
-
-static void     usage                           (void);
-
-static void     free_zone_data                  (GArray         *zone_data);
-static void     free_rule_array                 (gpointer        key,
-                                                 gpointer        value,
-                                                 gpointer        data);
-static void     free_link_data                  (gpointer        key,
-                                                 gpointer        value,
-                                                 gpointer        data);
-
-
-int
-main                            (int             argc,
-                                 char           *argv[])
-{
-  int i;
-  char directory[PATHNAME_BUFFER_SIZE];
-  char filename[PATHNAME_BUFFER_SIZE];
-  GHashTable *zones_hash;
-
-  /*
-   * Command-Line Option Parsing.
-   */
-  for (i = 1; i < argc; i++) {
-    /*
-     * User Options.
-     */
-
-    /* --pure: Output the perfect VCALENDAR data, which Outlook won't parse
-       as it has problems with certain iCalendar constructs. */
-    if (!strcmp (argv[i], "--pure"))
-      VzicPureOutput = TRUE;
-
-    /* --output-dir: specify where to output all the files beneath. The
-       default is the current directory. */
-    else if (argc > i + 1 && !strcmp (argv[i], "--output-dir"))
-      VzicOutputDir = argv[++i];
-
-    /* --url-prefix: Used as the base for the TZURL property in each
-       VTIMEZONE. The default is to not output TZURL properties. */
-    else if (argc > i + 1 && !strcmp (argv[i], "--url-prefix")) {
-      int length;
-      VzicUrlPrefix = argv[++i];
-      /* remove the trailing '/' if there is one */
-      length = strlen (VzicUrlPrefix);
-      if (VzicUrlPrefix[length - 1] == '/')
-          VzicUrlPrefix[length - 1] = '\0';
-    }
-
-    else if (argc > i + 1 && !strcmp (argv[i], "--olson-dir")) {
-      VzicOlsonDir = argv[++i];
-    }
-
-    /*
-     * Debugging Options.
-     */
-
-    /* --dump: Dump the Rule and Zone data that we parsed from the Olson
-       timezone files. This is used to test the parsing code. */
-    else if (!strcmp (argv[i], "--dump"))
-      VzicDumpOutput = TRUE;
-
-    /* --dump-changes: Dumps a list of times when each timezone changed,
-       and the new local time offset from UTC. */
-    else if (!strcmp (argv[i], "--dump-changes"))
-      VzicDumpChanges = TRUE;
-
-    /* --no-rrules: Don't output RRULE properties in the VTIMEZONEs. Instead
-       it will just output RDATEs for each year up to a certain year. */
-    else if (!strcmp (argv[i], "--no-rrules"))
-      VzicNoRRules = TRUE;
-
-    /* --no-rdates: Don't output multiple RDATEs in a single VTIMEZONE
-       component. Instead they will be output separately. */
-    else if (!strcmp (argv[i], "--no-rdates"))
-      VzicNoRDates = TRUE;
-
-    else
-      usage ();
-  }
-
-  /*
-   * Create any necessary directories.
-   */
-  ensure_directory_exists (VzicOutputDir);
-
-  if (VzicDumpOutput) {
-    /* Create the directories for the dump output, if they don't exist. */
-    sprintf (directory, "%s/ZonesVzic", VzicOutputDir);
-    ensure_directory_exists (directory);
-    sprintf (directory, "%s/RulesVzic", VzicOutputDir);
-    ensure_directory_exists (directory);
-  }
-
-  if (VzicDumpChanges) {
-    /* Create the directory for the changes output, if it doesn't exist. */
-    sprintf (directory, "%s/ChangesVzic", VzicOutputDir);
-    ensure_directory_exists (directory);
-  }
-
-  sprintf (filename, "%s/zone.tab", VzicOlsonDir);
-  zones_hash = parse_zone_tab (filename);
-
-  /*
-   * Convert the Olson timezone files.
-   */
-  convert_olson_file ("africa", zones_hash);
-  convert_olson_file ("antarctica", zones_hash);
-  convert_olson_file ("asia", zones_hash);
-  convert_olson_file ("australasia", zones_hash);
-  convert_olson_file ("europe", zones_hash);
-  convert_olson_file ("northamerica", zones_hash);
-  convert_olson_file ("southamerica", zones_hash);
-
-  /* These are backwards-compatibility and weird stuff. */
-  convert_olson_file ("backward", zones_hash);
-  convert_olson_file ("etcetera", zones_hash);
-#if 0
-  convert_olson_file ("leapseconds", zones_hash);
-  convert_olson_file ("pacificnew", zones_hash);
-  convert_olson_file ("solar87", zones_hash);
-  convert_olson_file ("solar88", zones_hash);
-  convert_olson_file ("solar89", zones_hash);
-#endif
-
-  /* This doesn't really do anything and it messes up vzic-dump.pl so we
-     don't bother. */
-#if 0
-  convert_olson_file ("factory", zones_hash);
-#endif
-
-  /* This is old System V stuff, which we don't currently support since it
-     uses 'min' as a Rule FROM value which messes up our algorithm, making
-     it too slow and use too much memory. */
-#if 0
-  convert_olson_file ("systemv", zones_hash);
-#endif
-
-  /* Output the timezone names and coordinates in a zone.tab file, and
-     the translatable strings to feed to gettext. */
-  if (VzicDumpZoneNamesAndCoords) {
-    dump_time_zone_names (VzicTimeZoneNames, VzicOutputDir, zones_hash);
-  }
-
-  return 0;
-}
-
-
-static void
-convert_olson_file              (char           *olson_file,
-                                 GHashTable     *zones_hash)
-{
-
-  char input_filename[PATHNAME_BUFFER_SIZE];
-  GArray *zone_data;
-  GHashTable *rule_data, *link_data;
-  char dump_filename[PATHNAME_BUFFER_SIZE];
-  ZoneData *zone;
-  int i, max_until_year;
-
-  sprintf (input_filename, "%s/%s", VzicOlsonDir, olson_file);
-
-  parse_olson_file (input_filename, &zone_data, &rule_data, &link_data,
-                    &max_until_year);
-
-  if (VzicDumpOutput) {
-    sprintf (dump_filename, "%s/ZonesVzic/%s", VzicOutputDir, olson_file);
-    dump_zone_data (zone_data, dump_filename);
-
-    sprintf (dump_filename, "%s/RulesVzic/%s", VzicOutputDir, olson_file);
-    dump_rule_data (rule_data, dump_filename);
-  }
-
-  output_vtimezone_files (VzicOutputDir, zone_data, rule_data, link_data,
-                          zones_hash, max_until_year);
-
-  free_zone_data (zone_data);
-  g_hash_table_foreach (rule_data, free_rule_array, NULL);
-  g_hash_table_destroy (rule_data);
-  g_hash_table_foreach (link_data, free_link_data, NULL);
-  g_hash_table_destroy (link_data);
-}
-
-
-static void
-usage                           (void)
-{
-  fprintf (stderr, "Usage: vzic [--dump] [--dump-changes] [--no-rrules] [--no-rdates] [--pure] [--output-dir <directory>] [--url-prefix <url>] [--olson-dir <directory>]\n");
-
-  exit (1);
-}
-
-
-
-
-/*
- * Functions to free the data structures.
- */
-
-static void
-free_zone_data                  (GArray         *zone_data)
-{
-  ZoneData *zone;
-  ZoneLineData *zone_line;
-  int i, j;
-
-  for (i = 0; i < zone_data->len; i++) {
-    zone = &g_array_index (zone_data, ZoneData, i);
-
-    g_free (zone->zone_name);
-
-    for (j = 0; j < zone->zone_line_data->len; j++) {
-      zone_line = &g_array_index (zone->zone_line_data, ZoneLineData, j);
-
-      g_free (zone_line->rules);
-      g_free (zone_line->format);
-    }
-
-    g_array_free (zone->zone_line_data, TRUE);
-  }
-
-  g_array_free (zone_data, TRUE);
-}
-
-
-static void
-free_rule_array                 (gpointer        key,
-                                 gpointer        value,
-                                 gpointer        data)
-{
-  char *name = key;
-  GArray *rule_array = value;
-  RuleData *rule;
-  int i;
-
-  for (i = 0; i < rule_array->len; i++) {
-    rule = &g_array_index (rule_array, RuleData, i);
-
-    if (!rule->is_shallow_copy) {
-      g_free (rule->type);
-      g_free (rule->letter_s);
-    }
-  }
-
-  g_array_free (rule_array, TRUE);
-
-  g_free (name);
-}
-
-
-static void
-free_link_data                  (gpointer        key,
-                                 gpointer        value,
-                                 gpointer        data)
-{
-  GList *link = data;
-
-  g_free (key);
-
-  while (link) {
-    g_free (link->data);
-    link = link->next;
-  }
-
-  g_list_free (data);
-}
-
diff -pruN 3.0.13-5/tools/vzic/vzic-dump.c 3.2.0-3/tools/vzic/vzic-dump.c
--- 3.0.13-5/tools/vzic/vzic-dump.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-dump.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,409 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-/*
- * These functions are for dumping all the parsed Zones and Rules to
- * files, to be compared with the output of vzic-dump.pl to check our parsing
- * code is OK. Some of the functions are also used for producing debugging
- * output.
- */
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-
-#include "vzic.h"
-#include "vzic-dump.h"
-
-
-static void     dump_add_rule                   (char           *name,
-                                                 GArray         *rule_array,
-                                                 GPtrArray      *name_array);
-static int      dump_compare_strings            (const void     *arg1,
-                                                 const void     *arg2);
-
-
-void
-dump_zone_data                  (GArray         *zone_data,
-                                 char           *filename)
-{
-  static char *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-  FILE *fp;
-  ZoneData *zone;
-  ZoneLineData *zone_line;
-  int i, j;
-  gboolean output_month, output_day, output_time;
-
-  fp = fopen (filename, "w");
-  if (!fp) {
-    fprintf (stderr, "Couldn't create file: %s\n", filename);
-    exit (1);
-  }
-
-  for (i = 0; i < zone_data->len; i++) {
-    zone = &g_array_index (zone_data, ZoneData, i);
-
-    fprintf (fp, "Zone\t%s\t", zone->zone_name);
-
-    for (j = 0; j < zone->zone_line_data->len; j++) {
-      zone_line = &g_array_index (zone->zone_line_data, ZoneLineData, j);
-
-      if (j != 0)
-        fprintf (fp, "\t\t\t");
-
-      fprintf (fp, "%s\t", dump_time (zone_line->stdoff_seconds, TIME_WALL,
-                                      FALSE));
-
-      if (zone_line->rules)
-        fprintf (fp, "%s\t", zone_line->rules);
-      else if (zone_line->save_seconds != 0)
-        fprintf (fp, "%s\t", dump_time (zone_line->save_seconds, TIME_WALL,
-                                        FALSE));
-      else
-        fprintf (fp, "-\t");
-
-      fprintf (fp, "%s\t", zone_line->format ? zone_line->format : "-");
-
-      if (zone_line->until_set) {
-        fprintf (fp, "%s\t", dump_year (zone_line->until_year));
-
-        output_month = output_day = output_time = FALSE;
-
-        if (zone_line->until_time_code != TIME_WALL
-            || zone_line->until_time_seconds != 0)
-          output_month = output_day = output_time = TRUE;
-        else if (zone_line->until_day_code != DAY_SIMPLE
-                 || zone_line->until_day_number != 1)
-          output_month = output_day = TRUE;
-        else if (zone_line->until_month != 0)
-          output_month = TRUE;
-
-        if (output_month)
-          fprintf (fp, "%s", months[zone_line->until_month]);
-
-        fprintf (fp, "\t");
-
-        if (output_day)
-          fprintf (fp, "%s", dump_day_coded (zone_line->until_day_code,
-                                             zone_line->until_day_number,
-                                             zone_line->until_day_weekday));
-
-        fprintf (fp, "\t");
-
-        if (output_time)
-          fprintf (fp, "%s", dump_time (zone_line->until_time_seconds,
-                                        zone_line->until_time_code, FALSE));
-
-      } else {
-        fprintf (fp, "\t\t\t");
-      }
-
-      fprintf (fp, "\n");
-    }
-  }
-
-  fclose (fp);
-}
-
-
-void
-dump_rule_data                  (GHashTable     *rule_data,
-                                 char           *filename)
-{
-  FILE *fp;
-  GPtrArray *name_array;
-  GArray *rule_array;
-  int i;
-  char *name;
-
-  fp = fopen (filename, "w");
-  if (!fp) {
-    fprintf (stderr, "Couldn't create file: %s\n", filename);
-    exit (1);
-  }
-
-  /* We need to sort the rules by their names, so they are in the same order
-     as the Perl output. So we place all the names in a temporary GPtrArray,
-     sort it, then output them. */
-  name_array = g_ptr_array_new ();
-  g_hash_table_foreach (rule_data, (GHFunc) dump_add_rule, name_array);
-  qsort (name_array->pdata, name_array->len, sizeof (char*),
-         dump_compare_strings);
-
-  for (i = 0; i < name_array->len; i++) {
-    name = g_ptr_array_index (name_array, i);
-    rule_array = g_hash_table_lookup (rule_data, name);
-    if (!rule_array) {
-      fprintf (stderr, "Couldn't access rules: %s\n", name);
-      exit (1);
-    }
-    dump_rule_array (name, rule_array, fp);
-  }
-
-  g_ptr_array_free (name_array, TRUE);
-
-  fclose (fp);
-}
-
-
-static void
-dump_add_rule                   (char           *name,
-                                 GArray         *rule_array,
-                                 GPtrArray      *name_array)
-{
-  g_ptr_array_add (name_array, name);
-}
-
-
-static int
-dump_compare_strings            (const void     *arg1,
-                                 const void     *arg2)
-{
-  char **a, **b;
-
-  a = (char**) arg1;
-  b = (char**) arg2;
-
-  return strcmp (*a, *b);
-}
-
-
-void
-dump_rule_array                 (char           *name,
-                                 GArray         *rule_array,
-                                 FILE           *fp)
-{
-  static char *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-
-  RuleData *rule;
-  int i;
-
-#if 0
-  fprintf (fp, "\n# Rule        NAME    FROM    TO      TYPE    IN      ON      AT      SAVE    LETTER/S");
-#endif
-
-  for (i = 0; i < rule_array->len; i++) {
-    rule = &g_array_index (rule_array, RuleData, i);
-
-    fprintf (fp, "Rule\t%s\t%s\t", name, dump_year (rule->from_year));
-
-    if (rule->to_year == rule->from_year)
-      fprintf (fp, "only\t");
-    else
-      fprintf (fp, "%s\t", dump_year (rule->to_year));
-
-    fprintf (fp, "%s\t", rule->type ? rule->type : "-");
-
-    fprintf (fp, "%s\t", months[rule->in_month]);
-
-    fprintf (fp, "%s\t",
-             dump_day_coded (rule->on_day_code, rule->on_day_number,
-                             rule->on_day_weekday));
-
-    fprintf (fp, "%s\t", dump_time (rule->at_time_seconds, rule->at_time_code,
-                                    FALSE));
-
-    fprintf (fp, "%s\t", dump_time (rule->save_seconds, TIME_WALL, TRUE));
-
-    fprintf (fp, "%s", rule->letter_s ? rule->letter_s : "-");
-
-    fprintf (fp, "\n");
-  }
-}
-
-
-char*
-dump_time                       (int             seconds,
-                                 TimeCode        time_code,
-                                 gboolean        use_zero)
-{
-  static char buffer[256], *sign;
-  int hours, minutes;
-  char *code;
-
-  if (time_code == TIME_STANDARD)
-    code = "s";
-  else if (time_code == TIME_UNIVERSAL)
-    code = "u";
-  else
-    code = "";
-
-  if (seconds < 0) {
-    seconds = -seconds;
-    sign = "-";
-  } else {
-    sign = "";
-  }
-
-  hours = seconds / 3600;
-  minutes = (seconds % 3600) / 60;
-  seconds = seconds % 60;
-
-  if (use_zero && hours == 0 && minutes == 0 && seconds == 0)
-    return "0";
-  else if (seconds == 0)
-    sprintf (buffer, "%s%i:%02i%s", sign, hours, minutes, code);
-  else
-    sprintf (buffer, "%s%i:%02i:%02i%s", sign, hours, minutes, seconds, code);
-
-  return buffer;
-}
-
-
-char*
-dump_day_coded                  (DayCode        day_code,
-                                 int            day_number,
-                                 int            day_weekday)
-{
-  static char buffer[256];
-  static char *weekdays[] = { "Sun", "Mon", "Tue", "Wed",
-                              "Thu", "Fri", "Sat" };
-
-  switch (day_code) {
-  case DAY_SIMPLE:
-    sprintf (buffer, "%i", day_number);
-    break;
-  case DAY_WEEKDAY_ON_OR_AFTER:
-    sprintf (buffer, "%s>=%i", weekdays[day_weekday], day_number);
-    break;
-  case DAY_WEEKDAY_ON_OR_BEFORE:
-    sprintf (buffer, "%s<=%i", weekdays[day_weekday], day_number);
-    break;
-  case DAY_LAST_WEEKDAY:
-    sprintf (buffer, "last%s", weekdays[day_weekday]);
-    break;
-  default:
-    fprintf (stderr, "Invalid day code: %i\n", day_code);
-    exit (1);
-  }
-
-  return buffer;
-}
-
-
-char*
-dump_year                       (int            year)
-{
-  static char buffer[256];
-
-  if (year == YEAR_MINIMUM)
-    return "min";
-  if (year == YEAR_MAXIMUM)
-    return "max";
-
-  sprintf (buffer, "%i", year);
-  return buffer;
-}
-
-
-void
-dump_time_zone_names            (GList          *names,
-                                 char           *output_dir,
-                                 GHashTable     *zones_hash)
-{
-  char filename[PATHNAME_BUFFER_SIZE], *zone_name, *zone_name_in_hash = NULL;
-  char strings_filename[PATHNAME_BUFFER_SIZE];
-  FILE *fp, *strings_fp = NULL;
-  GList *elem;
-  ZoneDescription *zone_desc;
-
-  sprintf (filename, "%s/zones.tab", output_dir);
-  sprintf (strings_filename, "%s/zones.h", output_dir);
-
-  fp = fopen (filename, "w");
-  if (!fp) {
-    fprintf (stderr, "Couldn't create file: %s\n", filename);
-    exit (1);
-  }
-
-  if (VzicDumpZoneTranslatableStrings) {
-    strings_fp = fopen (strings_filename, "w");
-    if (!strings_fp) {
-      fprintf (stderr, "Couldn't create file: %s\n", strings_filename);
-      exit (1);
-    }
-  }
-
-  names = g_list_sort (names, (GCompareFunc) strcmp);
-
-  elem = names;
-  while (elem) {
-    zone_name = (char*) elem->data;
-
-    zone_desc = g_hash_table_lookup (zones_hash, zone_name);
-
-    /* SPECIAL CASES: These timezones are links from other zones and are
-       almost exactly the same - they are basically there so users can find
-       them a bit easier. But they don't have entries in the zone.tab file,
-       so we use the entry from the timezone linked from. */
-    if (!zone_desc) {
-      if (!strcmp (zone_name, "America/Indiana/Indianapolis"))
-        zone_name_in_hash = "America/Indianapolis";
-      else if (!strcmp (zone_name, "America/Kentucky/Louisville"))
-        zone_name_in_hash = "America/Louisville";
-      else if (!strcmp (zone_name, "Asia/Istanbul"))
-        zone_name_in_hash = "Europe/Istanbul";
-      else if (!strcmp (zone_name, "Europe/Nicosia"))
-        zone_name_in_hash = "Asia/Nicosia";
-
-      if (zone_name_in_hash)
-        zone_desc = g_hash_table_lookup (zones_hash, zone_name_in_hash);
-    }
-
-    if (zone_desc) {
-      fprintf (fp, "%+04i%02i%02i %+04i%02i%02i %s\n",
-               zone_desc->latitude[0], zone_desc->latitude[1],
-               zone_desc->latitude[2],
-               zone_desc->longitude[0], zone_desc->longitude[1],
-               zone_desc->longitude[2],
-               zone_name);
-    } else {
-      g_print ("Zone description not found for: %s\n", zone_name);
-      fprintf (fp, "%s\n", zone_name);
-    }
-
-
-    if (VzicDumpZoneTranslatableStrings) {
-#if 0
-      char zone_name_buffer[1024], *src, *dest;
-
-      for (src = zone_name, dest = zone_name_buffer; *src; src++, dest++)
-        *dest = (*src == '_') ? ' ' : *src;
-      *dest = '\0';
-#endif
-
-      fprintf (strings_fp, "N_(\"%s\");\n", zone_name);
-    }
-
-    elem = elem->next;
-  }
-
-  fclose (fp);
-
-  if (VzicDumpZoneTranslatableStrings)
-    fclose (strings_fp);
-}
-
diff -pruN 3.0.13-5/tools/vzic/vzic-dump.h 3.2.0-3/tools/vzic/vzic-dump.h
--- 3.0.13-5/tools/vzic/vzic-dump.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-dump.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,58 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-/*
- * These functions are for dumping all the parsed Zones and Rules to
- * files, to be compared with the output of vzic-dump.pl to check our parsing
- * code is OK. Some of the functions are also used for producing debugging
- * output.
- */
-
-#ifndef _VZIC_DUMP_H_
-#define _VZIC_DUMP_H_
-
-#include <glib.h>
-
-void            dump_zone_data                  (GArray         *zone_data,
-                                                 char           *filename);
-void            dump_rule_data                  (GHashTable     *rule_data,
-                                                 char           *filename);
-
-void            dump_rule_array                 (char           *name,
-                                                 GArray         *rule_array,
-                                                 FILE           *fp);
-
-char*           dump_year                       (int            year);
-char*           dump_day_coded                  (DayCode        day_code,
-                                                 int            day_number,
-                                                 int            day_weekday);
-char*           dump_time                       (int             seconds,
-                                                 TimeCode        time_code,
-                                                 gboolean        use_zero);
-
-void            dump_time_zone_names            (GList          *names,
-                                                 char           *output_dir,
-                                                 GHashTable     *zones_hash);
-
-#endif /* _VZIC_DUMP_H_ */
diff -pruN 3.0.13-5/tools/vzic/vzic-dump.pl 3.2.0-3/tools/vzic/vzic-dump.pl
--- 3.0.13-5/tools/vzic/vzic-dump.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-dump.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,222 +0,0 @@
-#!/usr/bin/perl -w
-
-#
-# Vzic - a program to convert Olson timezone database files into VZTIMEZONE
-# files compatible with the iCalendar specification (RFC2445).
-#
-# Copyright (C) 2000-2001 Ximian, Inc.
-# Copyright (C) 2003 Damon Chaplin.
-#
-# Author: Damon Chaplin <damon@gnome.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
-#
-
-#
-# This reads the Olson timezone files, strips any comments, and outputs them
-# in a very simple format with tab-separated fields. It is used to compare
-# with the output of dump_zone_data() and dump_rule_data() to double-check
-# that we have parsed the files correctly.
-#
-
-my $zones_fh = "zonesfile";
-my $rules_fh = "rulesfile";
-
-my %Rules;
-
-if ($#ARGV != 0) {
-    die "Usage: $0 <OlsonDirectory>";
-}
-
-my $OLSON_DIR = $ARGV[0];
-
-# We place output in subdirectories of the current directory.
-my $OUTPUT_DIR = "zoneinfo";
-
-if (! -d "$OUTPUT_DIR") {
-    mkdir ("$OUTPUT_DIR", 0777)
-        || die "Can't create directory: $OUTPUT_DIR";
-}
-if (! -d "$OUTPUT_DIR/ZonesPerl") {
-    mkdir ("$OUTPUT_DIR/ZonesPerl", 0777)
-        || die "Can't create directory: $OUTPUT_DIR/ZonesPerl";
-}
-if (! -d "$OUTPUT_DIR/RulesPerl") {
-    mkdir ("$OUTPUT_DIR/RulesPerl", 0777)
-        || die "Can't create directory: $OUTPUT_DIR/RulesPerl";
-}
-
-
-&ReadOlsonFile ("africa");
-&ReadOlsonFile ("antarctica");
-&ReadOlsonFile ("asia");
-&ReadOlsonFile ("australasia");
-&ReadOlsonFile ("europe");
-&ReadOlsonFile ("northamerica");
-&ReadOlsonFile ("southamerica");
-
-# These are backwards-compatibility and weird stuff.
-#&ReadOlsonFile ("backward");
-#&ReadOlsonFile ("etcetera");
-#&ReadOlsonFile ("leapseconds");
-#&ReadOlsonFile ("pacificnew");
-#&ReadOlsonFile ("solar87");
-#&ReadOlsonFile ("solar88");
-#&ReadOlsonFile ("solar89");
-
-# We don't do this one since it is not useful and the use of '"' in the Zone
-# line messes up our split() command.
-#&ReadOlsonFile ("factory");
-
-# We don't do this since the vzic program can't do it.
-#&ReadOlsonFile ("systemv");
-
-
-
-
-1;
-
-
-sub ReadOlsonFile {
-    my ($file) = @_;
-
-#    print ("Reading olson file: $file\n");
-
-    open (OLSONFILE, "$OLSON_DIR/$file")
-        || die "Can't open file: $file";
-
-    open ($zones_fh, ">$OUTPUT_DIR/ZonesPerl/$file")
-        || die "Can't open file: $OUTPUT_DIR/ZonesPerl/$file";
-
-    open ($rules_fh, ">$OUTPUT_DIR/RulesPerl/$file")
-        || die "Can't open file: $OUTPUT_DIR/RulesPerl/$file";
-
-    %Rules = ();
-
-    my $zone_continues = 0;
-
-    while (<OLSONFILE>) {
-        next if (m/^#/);
-
-        # '#' characters can appear in strings, but the Olson files don't use
-        # that feature at present so we treat all '#' as comments for now.
-        s/#.*//;
-
-        next if (m/^\s*$/);
-
-        if ($zone_continues) {
-            $zone_continues = &ReadZoneContinuationLine;
-
-        } elsif (m/^Rule\s/) {
-            &ReadRuleLine;
-
-        } elsif (m/^Zone\s/) {
-            $zone_continues = &ReadZoneLine;
-
-        } elsif (m/^Link\s/) {
-#           print "Link: $link_from, $link_to\n";
-
-        } elsif (m/^Leap\s/) {
-#           print "Leap\n";
-
-        } else {
-            die "Invalid line: $_";
-        }
-    }
-
-#    print ("Read olson file: $file\n");
-
-    foreach $key (sort (keys (%Rules))) {
-        print $rules_fh "$Rules{$key}"
-    }
-
-    close ($zones_fh);
-    close ($rules_fh);
-    close (OLSONFILE);
-}
-
-
-sub ReadZoneLine {
-    my ($zone, $name, $gmtoff, $rules_save, $format,
-        $until_year, $until_month, $until_day, $until_time, $remainder)
-        = split ' ', $_, 10;
-
-    return &ReadZoneLineCommon ($zone, $name, $gmtoff, $rules_save, $format,
-                                $until_year, $until_month, $until_day,
-                                $until_time);
-}
-
-
-sub ReadZoneContinuationLine {
-    my ($gmtoff, $rules_save, $format,
-        $until_year, $until_month, $until_day, $until_time, $remainder)
-        = split ' ', $_, 8;
-
-    return &ReadZoneLineCommon ("", "", $gmtoff, $rules_save, $format,
-                                $until_year, $until_month, $until_day,
-                                $until_time);
-}
-
-
-sub ReadZoneLineCommon {
-    my ($zone, $name, $gmtoff, $rules_save, $format,
-        $until_year, $until_month, $until_day, $until_time) = @_;
-
-    if (!defined ($until_year)) { $until_year = ""; }
-    if (!defined ($until_month)) { $until_month = ""; }
-    if (!defined ($until_day)) { $until_day = ""; }
-    if (!defined ($until_time)) { $until_time = ""; }
-
-    # A few of the gmtoffsets have an unnecessary :00 seconds.
-    $gmtoff =~ s/(\d+):(\d+):00/$1:$2/;
-
-    # Make sure the gmtoff does have minutes.
-    $gmtoff =~ s/^(-?\d+)$/$1:00/;
-
-    # Fix a few other bits so they all use the same format.
-    if ($gmtoff eq "0") { $gmtoff = "0:00"; }
-    $until_time =~ s/^0(\d):/$1:/;
-    if ($until_time eq "0:00") { $until_time = ""; }
-    if ($until_day eq "1" && $until_time eq "") { $until_day = ""; }
-    if ($until_month eq "Jan" && $until_day eq "" && $until_time eq "") {
-        $until_month = "";
-    }
-
-    # For Zone continuation lines we need to insert an extra TAB.
-    if (!$zone) { $zone = "\t" };
-
-    print $zones_fh "$zone\t$name\t$gmtoff\t$rules_save\t$format\t$until_year\t$until_month\t$until_day\t$until_time\n";
-
-    if (defined ($until_year) && $until_year) {
-        return 1;
-    } else {
-        return 0;
-    }
-}
-
-
-sub ReadRuleLine {
-    my ($rule, $name, $from, $to, $type, $in, $on, $at, $save, $letter_s,
-        $remainder) = split;
-
-    $at =~ s/(\d+:\d+):00/$1/;
-    $save =~ s/(\d+:\d+):00/$1/;
-    if ($save eq "0:00") { $save = "0"; }
-
-    $Rules{$name} .= "$rule\t$name\t$from\t$to\t$type\t$in\t$on\t$at\t$save\t$letter_s\n";
-
-#    print $rules_fh "$rule\t$name\t$from\t$to\t$type\t$in\t$on\t$at\t$save\t$letter_s\n";
-}
-
diff -pruN 3.0.13-5/tools/vzic/vzic.h 3.2.0-3/tools/vzic/vzic.h
--- 3.0.13-5/tools/vzic/vzic.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,197 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-#ifndef _VZIC_H_
-#define _VZIC_H_
-
-#include <glib.h>
-
-
-/*
- * Global command-line options.
- */
-
-/* By default we output Outlook-compatible output. If --pure is used we output
-   pure output, with no changes to be compatible with Outlook. */
-extern gboolean VzicPureOutput;
-
-extern gboolean VzicDumpOutput;
-extern gboolean VzicDumpChanges;
-extern gboolean VzicDumpZoneNamesAndCoords;
-extern gboolean VzicDumpZoneTranslatableStrings;
-extern gboolean VzicNoRRules;
-extern gboolean VzicNoRDates;
-extern char*    VzicUrlPrefix;
-extern char*    VzicOutputDir;
-
-extern GList*   VzicTimeZoneNames;
-
-/* The minimum & maximum years we can use. */
-#define YEAR_MINIMUM    G_MININT
-#define YEAR_MAXIMUM    G_MAXINT
-
-/* The maximum size of any complete pathname. */
-#define PATHNAME_BUFFER_SIZE    1024
-
-/* Days can be expressed either as a simple month day number, 1-31, or a rule
-   such as the last Sunday, or the first Monday on or after the 8th. */
-typedef enum
-{
-  DAY_SIMPLE,
-  DAY_WEEKDAY_ON_OR_AFTER,
-  DAY_WEEKDAY_ON_OR_BEFORE,
-  DAY_LAST_WEEKDAY
-} DayCode;
-
-
-/* Times can be given either as universal time (UTC), local standard time
-   (without daylight-saving adjustments) or wall clock time (local standard
-   time plus daylight-saving adjustments, i.e. what you would see on a clock
-   on the wall!). */
-typedef enum
-{
-  TIME_WALL,
-  TIME_STANDARD,
-  TIME_UNIVERSAL
-} TimeCode;
-
-
-/* This represents one timezone, e.g. "Africa/Algiers".
-   It contains the timezone name, and an array of ZoneLineData structs which
-   hold data from each Zone line, including the continuation lines. */
-typedef struct _ZoneData ZoneData;
-struct _ZoneData
-{
-  char *zone_name;
-
-  /* An array of ZoneLineData, one for each Zone & Zone continuation line
-     read in. */
-  GArray *zone_line_data;
-};
-
-
-typedef struct _ZoneLineData ZoneLineData;
-struct _ZoneLineData
-{
-  /* The amount of time to add to UTC to get local standard time for the
-     current time range, in seconds. */
-  int           stdoff_seconds;
-
-  /* Either rules is set to the name of a set of rules, or rules is NULL and
-     save is set to the time to add to local standard time to get wall time, in
-     seconds. If save is 0 as well, then standard time always applies. */
-  char         *rules;
-  int           save_seconds;
-
-  /* The format to use for the abbreviated timezone name, e.g. WE%sT.
-     The %s is replaced by variable part of the name. (See the letter_s field
-     in the RuleData struct below). */
-  char         *format;
-
-  /* TRUE if an UNTIL time is given. */
-  gboolean      until_set;
-
-  /* The UNTIL year, e.g. 2000. */
-  int           until_year;
-
-  /* The UNTIL month 0 (Jan) to 11 (Dec). */
-  int           until_month;
-
-  /* The UNTIL day, either a simple month day number, 1-31, or a rule such as
-     the last Sunday, or the first Monday on or after the 8th. */
-  DayCode       until_day_code;
-  int           until_day_number;       /* 1 to 31. */
-  int           until_day_weekday;      /* 0 (Sun) to 6 (Sat). */
-
-  /* The UNTIL time, in seconds from midnight. The code specifies whether the
-     time is a wall clock time, local standard time, or universal time. */
-  int           until_time_seconds;
-  TimeCode      until_time_code;
-};
-
-
-typedef struct _RuleData RuleData;
-struct _RuleData
-{
-  /* The first year that the rule applies to, e.g. 1996.
-     Can also be YEAR_MINIMUM. */
-  int           from_year;
-
-  /* The last year that the rule applies to, e.g. 1996.
-     Can also be YEAR_MAXIMUM. */
-  int           to_year;
-
-  /* A string used to only match certain years between from and to.
-     The rule only applies to the years which match. If type is NULL the rule
-     applies to all years betweeen from and to.
-     zic uses an external program called yearistype to check the string.
-     Currently it is not used in the Olson database. */
-  char         *type;
-
-  /* The month of the rule 0 (Jan) to 11 (Dec). */
-  int           in_month;
-
-  /* The day, either a simple month day number, 1-31, or a rule such as
-     the last Sunday, or the first Monday on or after the 8th. */
-  DayCode       on_day_code;
-  int           on_day_number;
-  int           on_day_weekday;         /* 0 (Sun) to 6 (Sat). */
-
-  /* The time, in seconds from midnight. The code specifies whether the
-     time is a wall clock time, local standard time, or universal time. */
-  int           at_time_seconds;
-  TimeCode      at_time_code;
-
-  /* The amount of time to add to local standard time when the rule is in
-     effect, in seconds. If this is not 0 then it must be a daylight-saving
-     time. */
-  int           save_seconds;
-
-  /* The letter(s) to use as the variable part in the abbreviated timezone
-     name. If this is NULL then no variable part is used. (See the format field
-     in the ZoneLineData struct above.) */
-  char         *letter_s;
-
-
-  /* This is set to TRUE if this element is a shallow copy of another one,
-     in which case we don't free any of the fields. */
-  gboolean      is_shallow_copy;
-};
-
-
-typedef struct _ZoneDescription ZoneDescription;
-struct _ZoneDescription
-{
-  /* 2-letter ISO 3166 country code. */
-  char          country_code[2];
-
-  /* latitude and longitude in degrees, minutes & seconds. The degrees value
-     holds the sign of the entire latitude/longitude. */
-  int           latitude[3];
-  int           longitude[3];
-
-  char         *comment;
-};
-
-#endif /* _VZIC_H_ */
diff -pruN 3.0.13-5/tools/vzic/vzic-merge.pl 3.2.0-3/tools/vzic/vzic-merge.pl
--- 3.0.13-5/tools/vzic/vzic-merge.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-merge.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,177 +0,0 @@
-#!/usr/bin/perl -w
-
-#
-# Vzic - a program to convert Olson timezone database files into VZTIMEZONE
-# files compatible with the iCalendar specification (RFC2445).
-#
-# Copyright (C) 2001 Ximian, Inc.
-# Copyright (C) 2003 Damon Chaplin.
-#
-# Author: Damon Chaplin <damon@gnome.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
-#
-
-#
-# This merges in a new set of VTIMEZONE files with the 'master' set. It only
-# updates the files in the master set if the VTIMEZONE component has really
-# been changes. Note that the TZID normally includes the date the VTIMEZONE
-# file was generated on, so we have to ignore this when comparing the files.
-#
-
-# Set these to the toplevel directories of the 2 sets of VTIMEZONE files.
-$NEW_ZONEINFO_DIR = "zoneinfo";
-
-# Set this to 1 if you have version numbers in the TZID like libical.
-$LIBICAL_VERSIONING = 0;
-
-# Set this to 0 for dry-runs, and 1 to actually update.
-$DO_UPDATES = 1;
-
-# Save this so we can restore it later.
-$input_record_separator = $/;
-
-sub read_conf {
-    my $file = shift;
-
-    open CONF, $file or die "can't open $file";
-    while (<CONF>) {
-        if (/^#/) {
-            next;
-        }
-        if (/\@include:\s+(.*)$/) {
-            push @configs, $1;
-        }
-        if (/^configdirectory:\s+(.*)$/) {
-            $confdir = $1;
-        }
-    }
-    close CONF;
-}
-
-$imapdconf = shift || "/etc/imapd.conf";
-
-push @configs, $imapdconf;
-
-while ($conf = shift @configs) {
-    read_conf($conf);
-}
-
-if (! $confdir) { $confdir = "/var/imap"; }
-
-$MASTER_ZONEINFO_DIR = $confdir . "/zoneinfo";
-
-
-chdir $NEW_ZONEINFO_DIR
-    || die "Can't cd to $NEW_ZONEINFO_DIR";
-
-foreach $new_file (`find -name "*.ics"`) {
-    # Get rid of './' at start and whitespace at end.
-    $new_file =~ s/^\.\///;
-    $new_file =~ s/\s+$//;
-
-#    print "File: $new_file\n";
-
-    open (NEWZONEFILE, "$new_file")
-        || die "Can't open file: $NEW_ZONEINFO_DIR/$new_file";
-    undef $/;
-    $new_contents = <NEWZONEFILE>;
-    $/ = $input_record_separator;
-    close (NEWZONEFILE);
-
-    $master_file = $MASTER_ZONEINFO_DIR . "/$new_file";
-
-#    print "Master File: $master_file\n";
-
-    $copy_to_master = 0;
-
-    # If the ics file exists in the master copy we have to compare them,
-    # otherwise we can just copy the new file into the master directory.
-    if (-l $new_file) {
-        $link_to = readlink($new_file);
-
-        if (! -e $master_file || ! -l $master_file ||
-            (readlink($master_file) ne $link_to)) {
-
-            print "Linking $new_file to $link_to...\n";
-
-            if ($DO_UPDATES) {
-                unlink($master_file);
-                symlink($link_to, $master_file);
-            }
-        }
-    } elsif (-e $master_file) {
-        open (MASTERZONEFILE, "$master_file")
-            || die "Can't open file: $master_file";
-        undef $/;
-        $master_contents = <MASTERZONEFILE>;
-        $/ = $input_record_separator;
-        close (MASTERZONEFILE);
-
-        $new_contents_copy = $new_contents;
-
-        # Strip the TZID from both contents.
-#       $new_contents_copy =~ s/^TZID:\S+\r$//m;
-#       $new_tzid = $&;
-#       $master_contents =~ s/^TZID:\S+\r$//m;
-#       $master_tzid = $&;
-
-        # Strip the PRODID from both contents.
-        $new_contents_copy =~ s/^PRODID:.*$//m;
-        $master_contents =~ s/^PRODID:.*$//m;
-
-        # Strip the LAST-MODIFIED from both contents.
-        $new_contents_copy =~ s/^LAST-MODIFIED:(\S+)\r$//m;
-        $master_contents =~ s/^LAST-MODIFIED:(\S+)\r$//m;
-
-#       print "Matched: $master_tzid\n";
-
-
-        if ($new_contents_copy ne $master_contents) {
-            print "$new_file has changed. Updating...\n";
-            $copy_to_master = 1;
-
-            if ($LIBICAL_VERSIONING) {
-                # We bump the version number in the new file.
-#               $master_tzid =~ m%_(\d+)/%;
-                $version_num = $1;
-#               print "Version: $version_num\n";
-
-                $version_num++;
-                $new_tzid =~ s%_(\d+)/%_$version_num/%;
-
-#               print "New TZID: $new_tzid\n";
-                $new_contents =~ s/^TZID:\S+$/$new_tzid/m;
-            }
-        }
-
-    } else {
-        print "$new_file doesn't exist in master directory. Copying...\n";
-        $copy_to_master = 1;
-    }
-
-    if ($copy_to_master) {
-#       print "Updating: $new_file\n";
-
-        if ($DO_UPDATES) {
-            open (MASTERZONEFILE, ">$master_file")
-                || die "Can't create file: $master_file";
-            print MASTERZONEFILE $new_contents;
-            close (MASTERZONEFILE);
-        }
-    }
-
-}
-
diff -pruN 3.0.13-5/tools/vzic/vzic-output.c 3.2.0-3/tools/vzic/vzic-output.c
--- 3.0.13-5/tools/vzic/vzic-output.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-output.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2499 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-/* ALGORITHM:
- *
- * First we expand all the Rule arrays, so that each element only represents 1
- * year. If a Rule extends to infinity we expand it up to a few years past the
- * maximum UNTIL year used in any of the timezones. We do this to make sure
- * that the last of the expanded Rules (which may be infinite) is only used
- * in the last of the time periods (i.e. the last Zone line).
- *
- * The Rule arrays are also sorted by the start time (FROM + IN + ON + AT).
- * Doing all this makes it much easier to find which rules apply to which
- * periods.
- *
- * For each timezone (i.e. ZoneData element), we step through each of the
- * time periods, the ZoneLineData elements (which represent each Zone line
- * from the Olson file.)
- *
- * We calculate the start & end time of the period.
- * - For the first line the start time is -infinity.
- * - For the last line the end time is +infinity.
- * - The end time of each line is also the start time of the next.
- *
- * We create an array of time changes which occur in this period, including
- * the one implied by the Zone line itself (though this is later taken out
- * if it is found to be at exactly the same time as the first Rule).
- *
- * Now we iterate over the time changes, outputting them as STANDARD or
- * DAYLIGHT components. We also try to merge them together into RRULEs or
- * use RDATEs.
- */
-
-#include <config.h>
-
-#include <errno.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <time.h>
-#include <sys/stat.h>
-#include <unistd.h>
-
-#include "vzic.h"
-#include "vzic-output.h"
-
-#include "vzic-dump.h"
-
-
-/* These come from the Makefile. See the comments there. */
-char *ProductID = PRODUCT_ID;
-char *TZIDPrefix = TZID_PREFIX;
-
-/* We expand the TZIDPrefix, replacing %D with the date, in here. */
-char TZIDPrefixExpanded[1024];
-
-
-/* We only use RRULEs if there are at least MIN_RRULE_OCCURRENCES occurrences,
-   since otherwise RDATEs are more efficient. Actually, I've set this high
-   so we only use RRULEs for infinite recurrences. Since expanding RRULEs is
-   very time-consuming, this seems sensible. */
-#define MIN_RRULE_OCCURRENCES   2
-
-
-/* The year we go up to when dumping the list of timezone changes (used
-   for testing & debugging). */
-#define MAX_CHANGES_YEAR        2030
-
-/* This is the maximum year that time_t value can typically hold on 32-bit
-   systems. */
-#define MAX_TIME_T_YEAR         2038
-
-
-/* The year we use to start RRULEs. */
-#define RRULE_START_YEAR        1970
-
-/* The year we use for RDATEs. */
-#define RDATE_YEAR              1970
-
-
-static char *WeekDays[] = { "SU", "MO", "TU", "WE", "TH", "FR", "SA" };
-static int DaysInMonth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
-
-char *CurrentZoneName;
-
-
-typedef struct _VzicTime VzicTime;
-struct _VzicTime
-{
-  /* Normal years, e.g. 2001. */
-  int year;
-
-  /* 0 (Jan) to 11 (Dec). */
-  int month;
-
-  /* The day, either a simple month day number, 1-31, or a rule such as
-     the last Sunday, or the first Monday on or after the 8th. */
-  DayCode       day_code;
-  int           day_number;             /* 1 to 31. */
-  int           day_weekday;            /* 0 (Sun) to 6 (Sat). */
-
-  /* The time, in seconds from midnight. The code specifies whether the
-     time is a wall clock time, local standard time, or universal time. */
-  int           time_seconds;
-  TimeCode      time_code;
-
-  /* The offset from UTC for local standard time. */
-  int           stdoff;
-
-  /* The offset from UTC for local wall clock time. If this is different to
-     stdoff then this is a DAYLIGHT component. This is TZOFFSETTO. */
-  int           walloff;
-
-  /* TRUE if the time change recurs every year to infinity. */
-  gboolean      is_infinite;
-
-  /* The last instance of a recurring time change, if not infinite */
-  VzicTime      *until;
-
-  /* TRUE if the change has already been output. */
-  gboolean      output;
-
-  /* These are the offsets of the previous VzicTime, and are used when
-     calculating the time of the change. We place them here in
-     output_zone_components() to simplify the output code. */
-  int           prev_stdoff;
-  int           prev_walloff;
-
-  /* The abbreviated form of the timezone name. Note that this may not be
-     unique. */
-  char         *tzname;
-};
-
-
-static void     expand_and_sort_rule_array      (gpointer        key,
-                                                 gpointer        value,
-                                                 gpointer        data);
-static int      rule_sort_func                  (const void     *arg1,
-                                                 const void     *arg2);
-static void     output_zone                     (char           *directory,
-                                                 ZoneData       *zone,
-                                                 char           *zone_name,
-                                                 ZoneDescription *zone_desc,
-                                                 GHashTable     *rule_data);
-static gboolean parse_zone_name                 (char           *name,
-                                                 char          **directory,
-                                                 char          **subdirectory,
-                                                 char          **filename);
-static void     output_zone_to_files            (ZoneData       *zone,
-                                                 char           *zone_name,
-                                                 ZoneDescription *zone_desc,
-                                                 GHashTable     *rule_data,
-                                                 FILE           *fp,
-                                                 FILE           *changes_fp);
-static gboolean add_rule_changes                (ZoneLineData   *zone_line,
-                                                 char           *zone_name,
-                                                 GArray         *changes,
-                                                 GHashTable     *rule_data,
-                                                 VzicTime       *start,
-                                                 VzicTime       *end,
-                                                 char          **start_letter_s,
-                                                 int            *save_seconds);
-static char*    expand_tzname                   (char           *zone_name,
-                                                 char           *format,
-                                                 gboolean        have_letter_s,
-                                                 char           *letter_s,
-                                                 gboolean        is_daylight);
-static int      compare_times                   (VzicTime       *time1,
-                                                 int             stdoff1,
-                                                 int             walloff1,
-                                                 VzicTime       *time2,
-                                                 int             stdoff2,
-                                                 int             walloff2);
-static gboolean times_match                     (VzicTime       *time1,
-                                                 int             stdoff1,
-                                                 int             walloff1,
-                                                 VzicTime       *time2,
-                                                 int             stdoff2,
-                                                 int             walloff2);
-static void     output_zone_components          (FILE           *fp,
-                                                 char           *name,
-                                                 ZoneDescription *zone_desc,
-                                                 GArray         *changes);
-static void     set_previous_offsets            (GArray         *changes);
-static gboolean check_for_recurrence            (FILE           *fp,
-                                                 GArray         *changes,
-                                                 int             idx);
-static void     check_for_rdates                (FILE           *fp,
-                                                 GArray         *changes,
-                                                 int             idx);
-static gboolean timezones_match                 (char           *tzname1,
-                                                 char           *tzname2);
-static int      output_component_start          (char           *buffer,
-                                                 VzicTime       *vzictime,
-                                                 gboolean        output_rdate,
-                                                 gboolean        use_same_tz_offset);
-static void     output_component_end            (FILE           *fp,
-                                                 VzicTime       *vzictime);
-
-static void     vzictime_init                   (VzicTime       *vzictime);
-static int      calculate_actual_time           (VzicTime       *vzictime,
-                                                 TimeCode        time_code,
-                                                 int             stdoff,
-                                                 int             walloff);
-static int      calculate_wall_time             (int             time,
-                                                 TimeCode        time_code,
-                                                 int             stdoff,
-                                                 int             walloff,
-                                                 int            *day_offset);
-static int      calculate_until_time            (int             time,
-                                                 TimeCode        time_code,
-                                                 int             stdoff,
-                                                 int             walloff,
-                                                 int            *year,
-                                                 int            *month,
-                                                 int            *day);
-static void     fix_time_overflow               (int            *year,
-                                                 int            *month,
-                                                 int            *day,
-                                                 int             day_offset);
-
-static char*    format_time                     (int             year,
-                                                 int             month,
-                                                 int             day,
-                                                 int             time);
-static char*    format_tz_offset                (int             tz_offset,
-                                                 gboolean        round_seconds);
-static gboolean output_rrule                    (char           *rrule_buffer,
-                                                 int             month,
-                                                 DayCode         day_code,
-                                                 int             day_number,
-                                                 int             day_weekday,
-                                                 int             day_offset,
-                                                 char           *until);
-static gboolean output_rrule_2                  (char           *buffer,
-                                                 int             month,
-                                                 int             day_number,
-                                                 int             day_weekday);
-
-static char*    format_vzictime                 (VzicTime       *vzictime);
-
-static void     dump_changes                    (FILE           *fp,
-                                                 char           *zone_name,
-                                                 GArray         *changes);
-static void     dump_change                     (FILE           *fp,
-                                                 char           *zone_name,
-                                                 VzicTime       *vzictime,
-                                                 int             year);
-
-static void     expand_tzid_prefix              (void);
-
-
-void
-output_vtimezone_files          (char           *directory,
-                                 GArray         *zone_data,
-                                 GHashTable     *rule_data,
-                                 GHashTable     *link_data,
-                                 GHashTable     *zones_hash,
-                                 int             max_until_year)
-{
-  ZoneData *zone;
-  ZoneDescription *zone_desc;
-  GList *links;
-  char *link_to;
-  int i;
-
-  /* Insert today's date into the TZIDs we output. */
-  expand_tzid_prefix ();
-
-  /* Expand the rule data so that each entry specifies only one year, and
-     sort it so we can easily find the rules applicable to each Zone span. */
-  g_hash_table_foreach (rule_data, expand_and_sort_rule_array,
-                        GINT_TO_POINTER (max_until_year));
-
-  /* Output each timezone. */
-  for (i = 0; i < zone_data->len; i++) {
-    zone = &g_array_index (zone_data, ZoneData, i);
-    zone_desc = g_hash_table_lookup (zones_hash, zone->zone_name);
-    output_zone (directory, zone, zone->zone_name, zone_desc, rule_data);
-
-    /* Look for any links from this zone. */
-    links = g_hash_table_lookup (link_data, zone->zone_name);
-
-    while (links) {
-      link_to = links->data;
-
-      /* We ignore Links that don't have a '/' in them (things like 'EST5EDT').
-       */
-      if (strchr (link_to, '/')) {
-        output_zone (directory, zone, link_to, NULL, rule_data);
-      }
-
-      links = links->next;
-    }
-  }
-}
-
-
-static void
-expand_and_sort_rule_array      (gpointer        key,
-                                 gpointer        value,
-                                 gpointer        data)
-{
-  char *name = key;
-  GArray *rule_array = value;
-  RuleData *rule, tmp_rule;
-  int len, max_year, i, from, to, year;
-  gboolean is_infinite;
-
-  /* We expand the rule data to a year greater than any year used in a Zone
-     UNTIL value. This is so that we can easily get parts of the array to
-     use for each Zone line. */
-  max_year = GPOINTER_TO_INT (data) + 2;
-
-  /* If any of the rules apply to several years, we turn it into a single rule
-     for each year. If the Rule is infinite we go up to max_year.
-     We change the FROM field in the copies of the Rule, setting it to each
-     of the years, and set TO to FROM, except if TO was YEAR_MAXIMUM we set
-     the last TO to YEAR_MAXIMUM, so we still know the Rule is infinite. */
-  len = rule_array->len;
-  for (i = 0; i < len; i++) {
-    rule = &g_array_index (rule_array, RuleData, i);
-
-    /* None of the Rules currently use the TYPE field, but we'd better check.
-     */
-    if (rule->type) {
-      fprintf (stderr, "Rules %s has a TYPE: %s\n", name, rule->type);
-      exit (1);
-    }
-
-    if (rule->from_year != rule->to_year) {
-      from = rule->from_year;
-      to = rule->to_year;
-
-      tmp_rule = *rule;
-
-      /* Flag that this is a shallow copy so we don't free anything twice. */
-      tmp_rule.is_shallow_copy = TRUE;
-
-      /* See if it is an infinite Rule. */
-      if (to == YEAR_MAXIMUM) {
-        is_infinite = TRUE;
-        to = max_year;
-        if (from < to)
-          rule->to_year = rule->from_year;
-      } else {
-        is_infinite = FALSE;
-      }
-
-      /* Create a copy of the Rule for each year. */
-      for (year = from + 1; year <= to; year++) {
-        tmp_rule.from_year = year;
-
-        /* If the Rule is infinite, mark the last copy as infinite. */
-        if (year == to && is_infinite)
-          tmp_rule.to_year = YEAR_MAXIMUM;
-        else
-          tmp_rule.to_year = year;
-
-        g_array_append_val (rule_array, tmp_rule);
-      }
-    }
-  }
-
-  /* Now sort the rules. */
-  qsort (rule_array->data, rule_array->len, sizeof (RuleData), rule_sort_func);
-
-#if 0
-  dump_rule_array (name, rule_array, stdout);
-#endif
-}
-
-
-/* This is used to sort the rules, after the rules have all been expanded so
-   that each one is only for one year. */
-static int
-rule_sort_func                  (const void     *arg1,
-                                 const void     *arg2)
-{
-  RuleData *rule1, *rule2;
-  int time1_year, time1_month, time1_day;
-  int time2_year, time2_month, time2_day;
-  int month_diff, result;
-  VzicTime t1, t2;
-
-  rule1 = (RuleData*) arg1;
-  rule2 = (RuleData*) arg2;
-
-  time1_year = rule1->from_year;
-  time1_month = rule1->in_month;
-  time2_year = rule2->from_year;
-  time2_month = rule2->in_month;
-
-  /* If there is more that one month difference we don't need to calculate
-     the day or time. */
-  month_diff = (time1_year - time2_year) * 12 + time1_month - time2_month;
-
-  if (month_diff > 1)
-    return 1;
-  if (month_diff < -1)
-    return -1;
-
-  /* Now we have to calculate the day and time of the Rule start and the
-     VzicTime, using the given offsets. */
-  t1.year = time1_year;
-  t1.month = time1_month;
-  t1.day_code = rule1->on_day_code;
-  t1.day_number = rule1->on_day_number;
-  t1.day_weekday = rule1->on_day_weekday;
-  t1.time_code = rule1->at_time_code;
-  t1.time_seconds = rule1->at_time_seconds;
-
-  t2.year = time2_year;
-  t2.month = time2_month;
-  t2.day_code = rule2->on_day_code;
-  t2.day_number = rule2->on_day_number;
-  t2.day_weekday = rule2->on_day_weekday;
-  t2.time_code = rule2->at_time_code;
-  t2.time_seconds = rule2->at_time_seconds;
-
-  /* FIXME: We don't know the offsets yet, but I don't think any Rules are
-     close enough together that the offsets can make a difference. Should
-     check this. */
-  calculate_actual_time (&t1, TIME_WALL, 0, 0);
-  calculate_actual_time (&t2, TIME_WALL, 0, 0);
-
-  /* Now we can compare the entire time. */
-  if (t1.year > t2.year)
-    result = 1;
-  else if (t1.year < t2.year)
-    result = -1;
-
-  else if (t1.month > t2.month)
-    result = 1;
-  else if (t1.month < t2.month)
-    result = -1;
-
-  else if (t1.day_number > t2.day_number)
-    result = 1;
-  else if (t1.day_number < t2.day_number)
-    result = -1;
-
-  else if (t1.time_seconds > t2.time_seconds)
-    result = 1;
-  else if (t1.time_seconds < t2.time_seconds)
-    result = -1;
-
-  else {
-    printf ("WARNING: Rule dates matched.\n");
-    result = 0;
-  }
-
-  return result;
-}
-
-
-static void
-output_zone                     (char           *directory,
-                                 ZoneData       *zone,
-                                 char           *zone_name,
-                                 ZoneDescription *zone_desc,
-                                 GHashTable     *rule_data)
-{
-  FILE *fp, *changes_fp = NULL;
-  char output_directory[PATHNAME_BUFFER_SIZE];
-  char filename[PATHNAME_BUFFER_SIZE];
-  char changes_filename[PATHNAME_BUFFER_SIZE];
-  char *zone_directory, *zone_subdirectory, *zone_filename;
-
-  /* Set a global for the zone_name, to be used only for debug messages. */
-  CurrentZoneName = zone_name;
-
-  /* Use this to only output a particular zone. */
-#if 0
-  if (strcmp (zone_name, "Atlantic/Azores"))
-    return;
-#endif
-
-#if 0
-  printf ("Outputting Zone: %s\n", zone_name);
-#endif
-
-  if (!parse_zone_name (zone_name, &zone_directory, &zone_subdirectory,
-                        &zone_filename))
-    return;
-
-  if (VzicDumpZoneNamesAndCoords) {
-    VzicTimeZoneNames = g_list_prepend (VzicTimeZoneNames,
-                                        g_strdup (zone_name));
-  }
-
-  if (zone_subdirectory) {
-    sprintf (output_directory, "%s/%s/%s", directory, zone_directory,
-             zone_subdirectory);
-    ensure_directory_exists (output_directory);
-    sprintf (filename, "%s/%s.ics", output_directory, zone_filename);
-
-    if (VzicDumpChanges) {
-      sprintf (output_directory, "%s/ChangesVzic/%s/%s", directory,
-               zone_directory, zone_subdirectory);
-      ensure_directory_exists (output_directory);
-      sprintf (changes_filename, "%s/%s", output_directory, zone_filename);
-    }
-  }
-  else if (zone_directory) {
-    sprintf (output_directory, "%s/%s", directory, zone_directory);
-    ensure_directory_exists (output_directory);
-    sprintf (filename, "%s/%s.ics", output_directory, zone_filename);
-
-    if (VzicDumpChanges) {
-      sprintf (output_directory, "%s/ChangesVzic/%s", directory, zone_directory);
-      ensure_directory_exists (output_directory);
-      sprintf (changes_filename, "%s/%s", output_directory, zone_filename);
-    }
-  }
-  else {
-    sprintf (output_directory, "%s", directory);
-    ensure_directory_exists (output_directory);
-    sprintf (filename, "%s/%s.ics", output_directory, zone_filename);
-
-    if (VzicDumpChanges) {
-      sprintf (output_directory, "%s/ChangesVzic", directory);
-      ensure_directory_exists (output_directory);
-      sprintf (changes_filename, "%s/%s", output_directory, zone_filename);
-    }
-  }
-
-
-  /* Create the files. */
-  fp = fopen (filename, "w");
-  if (!fp) {
-    fprintf (stderr, "Couldn't create file: %s\n", filename);
-    exit (1);
-  }
-
-  if (VzicDumpChanges) {
-    changes_fp = fopen (changes_filename, "w");
-    if (!changes_fp) {
-      fprintf (stderr, "Couldn't create file: %s\n", changes_filename);
-      exit (1);
-    }
-  }
-
-  fprintf (fp, "BEGIN:VCALENDAR\r\nPRODID:");
-  fprintf (fp, ProductID, PACKAGE_VERSION);
-  fprintf (fp, "\r\nVERSION:2.0\r\n");
-
-
-  output_zone_to_files (zone, zone_name, zone_desc, rule_data, fp, changes_fp);
-
-  if (ferror (fp)) {
-    fprintf (stderr, "Error writing file: %s\n", filename);
-    exit (1);
-  }
-
-  fprintf (fp, "END:VCALENDAR\r\n");
-
-  fclose (fp);
-
-  g_free (zone_directory);
-  g_free (zone_subdirectory);
-  g_free (zone_filename);
-}
-
-
-/* This checks that the Zone name only uses the characters in [-+_/a-zA-Z0-9],
-   and outputs a warning if it isn't. */
-static gboolean
-parse_zone_name                 (char           *name,
-                                 char          **directory,
-                                 char          **subdirectory,
-                                 char          **filename)
-{
-  static int invalid_zone_num = 1;
-
-  char *p, ch, *first_slash_pos = NULL, *second_slash_pos = NULL;
-  gboolean invalid = FALSE;
-
-  for (p = name; (ch = *p) != 0; p++) {
-    if ((ch < 'a' || ch > 'z') && (ch < 'A' || ch > 'Z')
-        && (ch < '0' || ch > '9') && ch != '/' && ch != '_'
-        && ch != '-' && ch != '+') {
-      fprintf (stderr, "WARNING: Unusual Zone name: %s\n", name);
-      invalid = TRUE;
-      break;
-    }
-
-    if (ch == '/') {
-      if (!first_slash_pos) {
-        first_slash_pos = p;
-      } else if (!second_slash_pos) {
-        second_slash_pos = p;
-      } else {
-        fprintf (stderr, "WARNING: More than 2 '/' characters in Zone name: %s\n", name);
-        invalid = TRUE;
-        break;
-      }
-    }
-  }
-#if 0
-  if (!first_slash_pos) {
-#if 0
-        fprintf (stderr, "No '/' character in Zone name: %s. Skipping.\n", name);
-#endif
-        return FALSE;
-  }
-#endif
-  if (invalid) {
-    *directory = g_strdup ("Invalid");
-    *filename = g_strdup_printf ("Zone%i", invalid_zone_num++);
-  } else if (!first_slash_pos) {
-      *directory = NULL;
-      *subdirectory = NULL;
-      *filename = g_strdup (name);
-  } else {
-    *first_slash_pos = '\0';
-    *directory = g_strdup (name);
-    *first_slash_pos = '/';
-
-    if (second_slash_pos) {
-      *second_slash_pos = '\0';
-      *subdirectory = g_strdup (first_slash_pos + 1);
-      *second_slash_pos = '/';
-
-      *filename = g_strdup (second_slash_pos + 1);
-    } else {
-      *subdirectory = NULL;
-      *filename = g_strdup (first_slash_pos + 1);
-    }
-  }
-
-  return invalid ? FALSE : TRUE;
-}
-
-
-static void
-output_zone_to_files            (ZoneData       *zone,
-                                 char           *zone_name,
-                                 ZoneDescription *zone_desc,
-                                 GHashTable     *rule_data,
-                                 FILE           *fp,
-                                 FILE           *changes_fp)
-{
-  ZoneLineData *zone_line;
-  GArray *changes;
-  int i, stdoff, walloff, start_index, save_seconds;
-  VzicTime start, end, *vzictime_start, *vzictime, *vzictime_first_rule_change;
-  gboolean is_daylight, found_letter_s;
-  char *start_letter_s;
-
-  changes = g_array_new (FALSE, FALSE, sizeof (VzicTime));
-
-  vzictime_init (&start);
-  vzictime_init (&end);
-
-  /* The first period starts at -infinity. */
-  start.year = YEAR_MINIMUM;
-
-  for (i = 0; i < zone->zone_line_data->len; i++) {
-    zone_line = &g_array_index (zone->zone_line_data, ZoneLineData, i);
-
-    if (i == 0) start.is_infinite = (zone_line->rules == NULL);
-
-    /* This is the local standard time offset from GMT for this period. */
-    start.stdoff = stdoff = zone_line->stdoff_seconds;
-    start.walloff = walloff = stdoff + zone_line->save_seconds;
-
-    if (zone_line->until_set) {
-      end.year = zone_line->until_year;
-      end.month = zone_line->until_month;
-      end.day_code = zone_line->until_day_code;
-      end.day_number = zone_line->until_day_number;
-      end.day_weekday = zone_line->until_day_weekday;
-      end.time_seconds = zone_line->until_time_seconds;
-      end.time_code = zone_line->until_time_code;
-    } else {
-      /* The last period ends at +infinity. */
-      end.year = YEAR_MAXIMUM;
-    }
-
-    /* Add a time change for the start of the period. This may be removed
-       later if one of the rules expands to exactly the same time. */
-    start_index = changes->len;
-    g_array_append_val (changes, start);
-
-    /* If there are Rules associated with this period, add all the relevant
-       time changes. */
-    save_seconds = 0;
-    if (zone_line->rules)
-      found_letter_s = add_rule_changes (zone_line, zone_name, changes,
-                                         rule_data, &start, &end,
-                                         &start_letter_s, &save_seconds);
-    else
-      found_letter_s = FALSE;
-
-    /* FIXME: I'm not really sure what to do about finding a LETTER_S for the
-       first part of the period (i.e. before the first Rule comes into effect).
-       Currently we try to use the same LETTER_S as the first Rule of the
-       period which is in local standard time. */
-    if (zone_line->save_seconds)
-      save_seconds = zone_line->save_seconds;
-    is_daylight = save_seconds ? TRUE : FALSE;
-    vzictime_start = &g_array_index (changes, VzicTime, start_index);
-    walloff = vzictime_start->walloff = stdoff + save_seconds;
-
-    /* TEST: See if the first Rule time is exactly the same as the change from
-       the Zone line. In which case we can remove the Zone line change. */
-    if (changes->len > start_index + 1) {
-      int prev_stdoff, prev_walloff;
-
-      if (start_index > 0) {
-        VzicTime *v = &g_array_index (changes, VzicTime, start_index - 1);
-        prev_stdoff = v->stdoff;
-        prev_walloff = v->walloff;
-      } else {
-        prev_stdoff = 0;
-        prev_walloff = 0;
-      }
-      vzictime_first_rule_change = &g_array_index (changes, VzicTime,
-                                                   start_index + 1);
-      if (times_match (vzictime_start, prev_stdoff, prev_walloff,
-                       vzictime_first_rule_change, stdoff, walloff)) {
-#if 0
-        printf ("Removing zone-line change (using new offsets)\n");
-#endif
-        g_array_remove_index (changes, start_index);
-        vzictime_start = NULL;
-      } else if (times_match (vzictime_start, prev_stdoff, prev_walloff,
-                              vzictime_first_rule_change, prev_stdoff, prev_walloff)) {
-#if 0
-        printf ("Removing zone-line change (using previous offsets)\n");
-#endif
-        g_array_remove_index (changes, start_index);
-        vzictime_start = NULL;
-      }
-    }
-
-
-    if (vzictime_start) {
-      vzictime_start->tzname = expand_tzname (zone_name, zone_line->format,
-                                              found_letter_s,
-                                              start_letter_s, is_daylight);
-    }
-
-    /* The start of the next Zone line is the end time of this one. */
-    start = end;
-  }
-
-  set_previous_offsets (changes);
-
-  output_zone_components (fp, zone_name, zone_desc, changes);
-
-  if (VzicDumpChanges)
-    dump_changes (changes_fp, zone_name, changes);
-
-  /* Free all the TZNAME fields. */
-  for (i = 0; i < changes->len; i++) {
-    vzictime = &g_array_index (changes, VzicTime, i);
-    g_free (vzictime->tzname);
-  }
-
-  g_array_free (changes, TRUE);
-}
-
-
-/* This appends any timezone changes specified by the rules associated with
-   the timezone, that happen between the start and end times.
-   It returns the letter_s field of the first STANDARD rule found in the
-   search. We need this to fill in any %s in the FORMAT field of the first
-   component of the time period (the Zone line). */
-static gboolean
-add_rule_changes                        (ZoneLineData   *zone_line,
-                                         char           *zone_name,
-                                         GArray         *changes,
-                                         GHashTable     *rule_data,
-                                         VzicTime       *start,
-                                         VzicTime       *end,
-                                         char          **start_letter_s,
-                                         int            *save_seconds)
-{
-  GArray *rule_array;
-  RuleData *rule, *prev_rule = NULL;
-  int stdoff, walloff, i, prev_stdoff, prev_walloff;
-  VzicTime vzictime;
-  gboolean is_daylight, found_start_letter_s = FALSE;
-  gboolean checked_for_previous = FALSE;
-
-  *save_seconds = 0;
-
-  rule_array = g_hash_table_lookup (rule_data, zone_line->rules);
-  if (!rule_array) {
-    fprintf (stderr, "Couldn't access rules: %s\n", zone_line->rules);
-    exit (1);
-  }
-
-  /* The stdoff is the same for all the rules. */
-  stdoff = start->stdoff;
-
-  /* The walloff changes as we go through the rules. */
-  walloff = start->walloff;
-
-  /* Get the stdoff & walloff from the last change before this period. */
-  if (changes->len >= 2) {
-    VzicTime *change = &g_array_index (changes, VzicTime, changes->len - 2);
-    prev_stdoff = change->stdoff;
-    prev_walloff = change->walloff;
-  } else {
-    prev_stdoff = prev_walloff = 0;
-  }
-
-
-  for (i = 0; i < rule_array->len; i++) {
-    int r;
-
-    rule = &g_array_index (rule_array, RuleData, i);
-
-    is_daylight = rule->save_seconds != 0 ? TRUE : FALSE;
-
-    vzictime_init (&vzictime);
-    vzictime.year = rule->from_year;
-    vzictime.month = rule->in_month;
-    vzictime.day_code = rule->on_day_code;
-    vzictime.day_number = rule->on_day_number;
-    vzictime.day_weekday = rule->on_day_weekday;
-    vzictime.time_seconds = rule->at_time_seconds;
-    vzictime.time_code = rule->at_time_code;
-    vzictime.stdoff = stdoff;
-    vzictime.walloff = stdoff + rule->save_seconds;
-    vzictime.is_infinite = (rule->to_year == YEAR_MAXIMUM) ? TRUE : FALSE;
-
-    /* If the rule time is before or on the given start time, skip it. */
-    r = compare_times (&vzictime, stdoff, walloff,
-                       start, prev_stdoff, prev_walloff);
-    if (r <= 0) {
-      /* Our next rule may start while this one is in effect
-         so we keep track of its name.
-
-         This seems to eliminate the need to guess in expand_tzname()
-         but hasn't had enough testing to prove foolproof as of yet. */
-      found_start_letter_s = TRUE;
-      *start_letter_s = rule->letter_s;
-
-      if (r == 0 && vzictime.time_code != start->time_code) {
-        /* Rule time is on the given start time.
-           We want to keep the rule time (for the time_code) but we need to
-           adjust the time to be based on the last change before this period */
-        if (vzictime.time_code == TIME_WALL) {
-          /* Adjust for rule possibly starting during DST */
-          vzictime.time_seconds += prev_walloff - walloff;
-        }
-        else if (vzictime.time_code == TIME_STANDARD) {
-          /* Adjust for rule possibly starting at UTC change */
-          vzictime.time_seconds += prev_stdoff - stdoff;
-        }
-      }
-      else continue;
-    }
-
-    /* If the previous Rule was a daylight Rule, then we may want to use the
-       walloff from that. */
-    if (!checked_for_previous) {
-      checked_for_previous = TRUE;
-      if (i > 0) {
-        prev_rule = &g_array_index (rule_array, RuleData, i - 1);
-        if (prev_rule->save_seconds) {
-          walloff = start->walloff = stdoff + prev_rule->save_seconds;
-          *save_seconds = prev_rule->save_seconds;
-          found_start_letter_s = TRUE;
-          *start_letter_s = prev_rule->letter_s;
-#if 0
-          printf ("Could use save_seconds from previous Rule: %s\n",
-                  zone_name);
-#endif
-        }
-      }
-    }
-
-    /* If an end time has been given, then if the rule time is on or after it
-       break out of the loop. */
-    if (end->year != YEAR_MAXIMUM
-        && compare_times (&vzictime, stdoff, walloff,
-                          end, stdoff, walloff) >= 0)
-      break;
-
-    vzictime.tzname = expand_tzname (zone_name, zone_line->format, TRUE,
-                                     rule->letter_s, is_daylight);
-
-    g_array_append_val (changes, vzictime);
-
-    /* When we find the first STANDARD time we set letter_s. */
-    if (!found_start_letter_s && !is_daylight) {
-      found_start_letter_s = TRUE;
-      *start_letter_s = rule->letter_s;
-    }
-
-    /* Now that we have added the Rule, the new walloff comes into effect
-       for any following Rules. */
-    walloff = vzictime.walloff;
-  }
-
-  /* If last Rule is terminating, flag it */
-  if (end->year == YEAR_MAXIMUM &&
-      rule->to_year >= 2037 && rule->to_year < YEAR_MAXIMUM) {
-    VzicTime *v = &g_array_index (changes, VzicTime, changes->len - 1);
-    v->until = v;
-  }
-
-  return found_start_letter_s;
-}
-
-
-/* This expands the Zone line FORMAT field, using the given LETTER_S from a
-   Rule line. There are 3 types of FORMAT field:
-   1. a string with an %s in, e.g. "WE%sT". The %s is replaced with LETTER_S.
-   2. a string with an '/' in, e.g. "CAT/CAWT". The first part is used for
-      standard time and the second part for when daylight-saving is in effect.
-   3. a plain string, e.g. "LMT", which we leave as-is.
-   Note that (1) is the only type in which letter_s is required.
-*/
-static char*
-expand_tzname                           (char           *zone_name,
-                                         char           *format,
-                                         gboolean        have_letter_s,
-                                         char           *letter_s,
-                                         gboolean        is_daylight)
-{
-  char *p, buffer[256], *guess = NULL;
-  int len;
-
-#if 0
-  printf ("Expanding %s with %s\n", format, letter_s);
-#endif
-
-  if (!format || !format[0]) {
-    fprintf (stderr, "Missing FORMAT\n");
-    exit (1);
-  }
-
-  /* 1. Look for a "%s". */
-  p = strchr (format, '%');
-  if (p && *(p + 1) == 's') {
-    if (!have_letter_s) {
-
-      /* NOTE: These are a few hard-coded TZNAMEs that I've looked up myself.
-         These are needed in a few places where a Zone line comes into effect
-         but no Rule has been found, so we have no LETTER_S to use.
-         I've tried to use whatever is the normal LETTER_S in the Rules for
-         the particular zone, in local standard time. */
-      if (!strcmp (zone_name, "Asia/Macao")
-          && !strcmp (format, "C%sT"))
-        guess = "CST";
-      else if (!strcmp (zone_name, "Asia/Macau")
-               && !strcmp (format, "C%sT"))
-        guess = "CST";
-      else if (!strcmp (zone_name, "Asia/Ashgabat")
-               && !strcmp (format, "ASH%sT"))
-        guess = "ASHT";
-      else if (!strcmp (zone_name, "Asia/Ashgabat")
-               && !strcmp (format, "TM%sT"))
-        guess = "TMT";
-      else if (!strcmp (zone_name, "Asia/Samarkand")
-               && !strcmp (format, "TAS%sT"))
-        guess = "TAST";
-      else if (!strcmp (zone_name, "Atlantic/Azores")
-               && !strcmp (format, "WE%sT"))
-        guess = "WET";
-      else if (!strcmp (zone_name, "Europe/Paris")
-               && !strcmp (format, "WE%sT"))
-        guess = "WET";
-      else if (!strcmp (zone_name, "Europe/Warsaw")
-               && !strcmp (format, "CE%sT"))
-        guess = "CET";
-      else if (!strcmp (zone_name, "America/Phoenix")
-               && !strcmp (format, "M%sT"))
-        guess = "MST";
-      else if (!strcmp (zone_name, "America/Nome")
-               && !strcmp (format, "Y%sT"))
-        guess = "YST";
-
-      if (guess) {
-#if 0
-        fprintf (stderr,
-                 "WARNING: Couldn't find a LETTER_S to use in FORMAT: %s in Zone: %s Guessing: %s\n",
-                 format, zone_name, guess);
-#endif
-        return g_strdup (guess);
-      }
-
-#if 1
-      fprintf (stderr,
-               "WARNING: Couldn't find a LETTER_S to use in FORMAT: %s in Zone: %s Leaving TZNAME empty\n",
-               format, zone_name);
-#endif
-
-#if 0
-      /* This is useful to spot exactly which component had a problem. */
-      sprintf (buffer, "FIXME: %s", format);
-      return g_strdup (buffer);
-#else
-      /* We give up and don't output a TZNAME. */
-      return NULL;
-#endif
-    }
-
-    sprintf (buffer, format, letter_s ? letter_s : "");
-    return g_strdup (buffer);
-  }
-
-  /* 2. Look for a "/". */
-  p = strchr (format, '/');
-  if (p) {
-    if (is_daylight) {
-      return g_strdup (p + 1);
-    } else {
-      len = p - format;
-      strncpy (buffer, format, len);
-      buffer[len] = '\0';
-      return g_strdup (buffer);
-    }
-  }
-
-  /* 3. Just use format as it is. */
-  return g_strdup (format);
-}
-
-
-/* Compares 2 VzicTimes, returning strcmp()-like values, i.e. 0 if equal,
-   1 if the 1st is after the 2nd and -1 if the 1st is before the 2nd. */
-static int
-compare_times                           (VzicTime       *time1,
-                                         int             stdoff1,
-                                         int             walloff1,
-                                         VzicTime       *time2,
-                                         int             stdoff2,
-                                         int             walloff2)
-{
-  VzicTime t1, t2;
-  int result;
-
-  t1 = *time1;
-  t2 = *time2;
-
-  calculate_actual_time (&t1, TIME_UNIVERSAL, stdoff1, walloff1);
-  calculate_actual_time (&t2, TIME_UNIVERSAL, stdoff2, walloff2);
-
-  /* Now we can compare the entire time. */
-  if (t1.year > t2.year)
-    result = 1;
-  else if (t1.year < t2.year)
-    result = -1;
-
-  else if (t1.month > t2.month)
-    result = 1;
-  else if (t1.month < t2.month)
-    result = -1;
-
-  else if (t1.day_number > t2.day_number)
-    result = 1;
-  else if (t1.day_number < t2.day_number)
-    result = -1;
-
-  else if (t1.time_seconds > t2.time_seconds)
-    result = 1;
-  else if (t1.time_seconds < t2.time_seconds)
-    result = -1;
-
-  else
-    result = 0;
-
-#if 0
-  printf ("%i/%i/%i %i <=> %i/%i/%i %i  -> %i\n",
-          t1.day_number, t1.month + 1, t1.year, t1.time_seconds,
-          t2.day_number, t2.month + 1, t2.year, t2.time_seconds,
-          result);
-#endif
-
-  return result;
-}
-
-
-/* Returns TRUE if the 2 times are exactly the same. It will calculate the
-   actual day, but doesn't convert times. */
-static gboolean
-times_match                             (VzicTime       *time1,
-                                         int             stdoff1,
-                                         int             walloff1,
-                                         VzicTime       *time2,
-                                         int             stdoff2,
-                                         int             walloff2)
-{
-  VzicTime t1, t2;
-
-  t1 = *time1;
-  t2 = *time2;
-
-  calculate_actual_time (&t1, TIME_UNIVERSAL, stdoff1, walloff1);
-  calculate_actual_time (&t2, TIME_UNIVERSAL, stdoff2, walloff2);
-
-  if (t1.year == t2.year
-      && t1.month == t2.month
-      && t1.day_number == t2.day_number
-      && t1.time_seconds == t2.time_seconds)
-    return TRUE;
-
-  return FALSE;
-}
-
-
-/* Convert degrees-minutes-seconds into decimal degrees */
-static float
-dms_to_dd                               (int dms[])
-{
-  return dms[0] + dms[1]/60.0 + dms[2]/3600.0;
-}
-
-
-static void
-output_zone_components                  (FILE           *fp,
-                                         char           *name,
-                                         ZoneDescription *zone_desc,
-                                         GArray         *changes)
-{
-  VzicTime *vzictime;
-  int i, start_index = 0;
-  gboolean only_one_change = FALSE;
-  char start_buffer[1024];
-  time_t now = time(0);
-  struct tm *tm = gmtime(&now);
-
-  fprintf (fp, "BEGIN:VTIMEZONE\r\nTZID:%s%s\r\n", TZIDPrefixExpanded, name);
-
-  vzictime = &g_array_index (changes, VzicTime, changes->len - 1);
-  if (vzictime->until) {
-    /* Add TZUNTIL */
-    VzicTime until = *vzictime->until;
-
-    until.time_seconds++;  /* TZUNTIL is exclusive */
-    calculate_actual_time(&until, TIME_UNIVERSAL,
-                          until.prev_stdoff, until.prev_walloff);
-    fprintf (fp, "TZUNTIL:%sZ\r\n", format_time(until.year, until.month,
-                                                until.day_number,
-                                                until.time_seconds));
-    vzictime->until = NULL;
-  }
-
-  if (zone_desc) {
-    /* Add COMMENT */
-    fprintf (fp, "COMMENT:[%.2s] ", zone_desc->country_code);
-    if (zone_desc->comment) {
-      const char *p;
-
-      for (p = zone_desc->comment; *p; p++) {
-        switch (*p) {
-        case '\\':
-        case ',':
-        case ';':
-          fprintf (fp, "\\");
-          break;
-        }
-
-        fprintf (fp, "%c", *p);
-      }
-    }
-    fprintf (fp, "\r\n");
-
-#if 0
-    /* Add GEO */
-    fprintf (fp, "GEO:%+.6f,%+.6f\r\n",
-             dms_to_dd(zone_desc->latitude), dms_to_dd(zone_desc->longitude));
-#endif
-  }
-
-  /* Use current time as LAST-MODIFIED */
-  fprintf (fp, "LAST-MODIFIED:%04i%02i%02iT%02i%02i%02iZ\r\n",
-           tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
-           tm->tm_hour, tm->tm_min, tm->tm_sec);
-
-  if (VzicUrlPrefix != NULL)
-      fprintf (fp, "TZURL:%s/%s\r\n", VzicUrlPrefix, name);
-
-  /* We use an 'X-' property to place the city name in. */
-  fprintf (fp, "X-LIC-LOCATION:%s\r\n", name);
-
-  /* We use an 'X-' property to place the proleptic tzname in. */
-  vzictime = &g_array_index (changes, VzicTime, 0);
-  if (vzictime->tzname) {
-    fputs("X-PROLEPTIC-TZNAME", fp);
-    if (!vzictime->is_infinite) fputs(";X-NO-BIG-BANG=TRUE", fp);
-    fprintf(fp, ":%s\r\n", vzictime->tzname);
-  }
-
-  /* We try to find any recurring components first, or they may get output
-     as lots of RDATES instead. */
-  if (!VzicNoRRules) {
-    int num_rrules_output = 0;
-
-    for (i = 1; i < changes->len; i++) {
-      if (check_for_recurrence (fp, changes, i)) {
-        num_rrules_output++;
-      }
-    }
-
-#if 0
-    printf ("Zone: %s had %i infinite RRULEs\n", CurrentZoneName,
-            num_rrules_output);
-#endif
-
-    if (!VzicPureOutput && num_rrules_output == 2) {
-#if 0
-      printf ("Zone: %s using 2 RRULEs\n", CurrentZoneName);
-#endif
-      fprintf (fp, "END:VTIMEZONE\r\n");
-      return;
-    }
-  }
-
-  /* We skip the first change, which starts at -infinity, unless it is the only
-     change for the timezone. */
-  if (changes->len > 1)
-    start_index = 1;
-  else
-    only_one_change = TRUE;
-
-  /* For pure output, we start at the start of the array and step through it
-     outputting RDATEs. For Outlook-compatible output we start at the end
-     and step backwards to find the first STANDARD time to output. */
-  if (VzicPureOutput)
-    i = start_index - 1;
-  else
-    i = changes->len;
-
-  for (;;) {
-    if (VzicPureOutput)
-      i++;
-    else
-      i--;
-
-    if (VzicPureOutput) {
-      if (i >= changes->len)
-        break;
-    } else {
-      if (i < start_index)
-        break;
-    }
-
-    vzictime = &g_array_index (changes, VzicTime, i);
-
-    /* If this has been flagged as an RRULE, then output it now */
-    if (vzictime->until) {
-      char until[256], rrule_buffer[2048];
-      VzicTime vzictime_start_copy;
-      int day_offset;
-
-      if (vzictime->until->is_infinite) {
-        until[0] = '\0';
-      } else {
-        VzicTime t1 = *vzictime->until;
-
-        calculate_actual_time (&t1, TIME_UNIVERSAL, vzictime->prev_stdoff,
-                               vzictime->prev_walloff);
-
-        /* Output UNTIL, in UTC. */
-        sprintf (until, ";UNTIL=%sZ", format_time (t1.year, t1.month,
-                                                   t1.day_number,
-                                                   t1.time_seconds));
-      }
-
-      /* Change the year to our minimum start year. */
-      vzictime_start_copy = *vzictime;
-      if (!VzicPureOutput)
-        vzictime_start_copy.year = RRULE_START_YEAR;
-
-      day_offset = output_component_start (start_buffer, &vzictime_start_copy,
-                                           FALSE, FALSE);
-      fprintf (fp, "%s", start_buffer);
-
-      if (output_rrule (rrule_buffer, vzictime_start_copy.month,
-                        vzictime_start_copy.day_code,
-                        vzictime_start_copy.day_number,
-                        vzictime_start_copy.day_weekday, day_offset, until)) {
-        fprintf (fp, "%s", rrule_buffer);
-      }
-
-      output_component_end (fp, vzictime);
-
-      continue;
-    }
-
-    /* If we have already output this component as part of an RRULE or RDATE,
-       then we skip it. */
-    if (vzictime->output)
-      continue;
-
-    /* For Outlook-compatible output we only want to output the last STANDARD
-       time as a DTSTART, so skip any DAYLIGHT changes. */
-    if (!VzicPureOutput && vzictime->stdoff != vzictime->walloff) {
-      printf ("Skipping DAYLIGHT change\n");
-      continue;
-    }
-
-#if 0
-    printf ("Zone: %s using DTSTART Year: %i\n", CurrentZoneName,
-            vzictime->year);
-#endif
-
-    if (VzicPureOutput) {
-      output_component_start (start_buffer, vzictime, TRUE, only_one_change);
-    } else {
-    /* For Outlook compatibility we don't output the RDATE and use the same
-       TZOFFSET for TZOFFSETFROM and TZOFFSETTO. */
-      vzictime->year         = RDATE_YEAR;
-      vzictime->month        = 0;
-      vzictime->day_code     = DAY_SIMPLE;
-      vzictime->day_number   = 1;
-      vzictime->time_code    = TIME_WALL;
-      vzictime->time_seconds = 0;
-
-      output_component_start (start_buffer, vzictime, FALSE, TRUE);
-    }
-
-    fprintf (fp, "%s", start_buffer);
-
-    /* This will look for matching components and output them as RDATEs
-       instead of separate components. */
-    if (VzicPureOutput && !VzicNoRDates)
-      check_for_rdates (fp, changes, i);
-
-    output_component_end (fp, vzictime);
-
-    vzictime->output = TRUE;
-
-    if (!VzicPureOutput)
-      break;
-  }
-
-  fprintf (fp, "END:VTIMEZONE\r\n");
-}
-
-
-/* This sets the prev_stdoff and prev_walloff (i.e. the TZOFFSETFROM) of each
-   VzicTime, using the stdoff and walloff of the previous VzicTime. It makes
-   the rest of the code much simpler. */
-static void
-set_previous_offsets            (GArray         *changes)
-{
-  VzicTime *vzictime, *prev_vzictime;
-  int i;
-
-  prev_vzictime = &g_array_index (changes, VzicTime, 0);
-  prev_vzictime->prev_stdoff = 0;
-  prev_vzictime->prev_walloff = 0;
-
-  for (i = 1; i < changes->len; i++) {
-    vzictime = &g_array_index (changes, VzicTime, i);
-
-    if (vzictime->stdoff == prev_vzictime->stdoff &&
-        vzictime->walloff == prev_vzictime->walloff &&
-        vzictime->time_code == prev_vzictime->time_code &&
-        !strcmp(vzictime->tzname, prev_vzictime->tzname)) {
-      /* Ignore no-op transitions */
-      vzictime->output = TRUE;
-      continue;
-    }
-
-    vzictime->prev_stdoff = prev_vzictime->stdoff;
-    vzictime->prev_walloff = prev_vzictime->walloff;
-
-    prev_vzictime = vzictime;
-  }
-}
-
-
-/* Returns TRUE if we output an infinite recurrence. */
-static gboolean
-check_for_recurrence            (FILE           *fp,
-                                 GArray         *changes,
-                                 int             idx)
-{
-  VzicTime *vzictime_start, *vzictime;
-  gboolean is_daylight_start, is_daylight;
-  int last_match, i, next_year;
-  GList *matching_elements = NULL, *elem;
-
-  vzictime_start = &g_array_index (changes, VzicTime, idx);
-
-  /* If this change has already been output, skip it. */
-  if (vzictime_start->output)
-    return FALSE;
-
-  /* There can't possibly be an RRULE starting from YEAR_MINIMUM. */
-  if (vzictime_start->year == YEAR_MINIMUM)
-    return FALSE;
-
-  is_daylight_start = (vzictime_start->stdoff != vzictime_start->walloff)
-    ? TRUE : FALSE;
-
-#if 0
-  printf ("\nChecking: %s OFFSETFROM: %i %s\n",
-          format_vzictime (vzictime_start), vzictime_start->prev_walloff,
-          is_daylight_start ? "DAYLIGHT" : "");
-#endif
-
-  /* If this is an infinitely recurring change, output the RRULE and return.
-     There won't be any changes after it that we could merge. */
-  if (vzictime_start->is_infinite) {
-    vzictime_start->until = vzictime_start;
-    vzictime_start->output = TRUE;
-    return TRUE;
-  }
-
-  last_match = idx;
-  next_year = vzictime_start->year + 1;
-  for (i = idx + 1; i < changes->len; i++) {
-    vzictime = &g_array_index (changes, VzicTime, i);
-
-    is_daylight = (vzictime->stdoff != vzictime->walloff) ? TRUE : FALSE;
-
-    if (vzictime->output)
-      continue;
-
-#if 0
-    printf ("          %s OFFSETFROM: %i %s\n",
-            format_vzictime (vzictime), vzictime->prev_walloff,
-            is_daylight ? "DAYLIGHT" : "");
-#endif
-
-    /* If it is more than one year ahead, we are finished, since we want
-       consecutive years. */
-    if (vzictime->year > next_year) {
-      break;
-    }
-
-    /* It must be the same type of component - STANDARD or DAYLIGHT. */
-    if (is_daylight != is_daylight_start) {
-      continue;
-    }
-
-    /* It must be the following year, with the same month, day & time.
-       It is possible that the time has a different code but does in fact
-       match when normalized, but we don't care (for now at least). */
-    if (vzictime->year != next_year
-        || vzictime->month != vzictime_start->month
-        || vzictime->day_code != vzictime_start->day_code
-        || vzictime->day_number != vzictime_start->day_number
-        || vzictime->day_weekday != vzictime_start->day_weekday
-        || vzictime->time_seconds != vzictime_start->time_seconds
-        || vzictime->time_code != vzictime_start->time_code) {
-      continue;
-    }
-
-    /* The TZOFFSETFROM and TZOFFSETTO must match. */
-    if (vzictime->prev_walloff != vzictime_start->prev_walloff) {
-      continue;
-    }
-
-    if (vzictime->walloff != vzictime_start->walloff) {
-      continue;
-    }
-
-    /* TZNAME must match. */
-    if (!timezones_match (vzictime->tzname, vzictime_start->tzname)) {
-      continue;
-    }
-
-    /* We have a match. */
-    last_match = i;
-    next_year = vzictime->year + 1;
-
-    matching_elements = g_list_prepend (matching_elements, vzictime);
-  }
-
-  if (last_match == idx)
-    return FALSE;
-
-#if 0
-  printf ("Found recurrence %i - %i!!!\n", vzictime_start->year,
-          next_year - 1);
-#endif
-
-  vzictime = &g_array_index (changes, VzicTime, last_match);
-
-/* We only use RRULEs if there are at least MIN_RRULE_OCCURRENCES occurrences,
-   since otherwise RDATEs are more efficient. */
-  if (!vzictime->is_infinite) {
-    int years = vzictime->year - vzictime_start->year + 1;
-#if 0
-    printf ("RRULE Years: %i\n", years);
-#endif
-    if (years < MIN_RRULE_OCCURRENCES)
-      return FALSE;
-  }
-
-  vzictime_start->until = vzictime;
-
-  /* Mark all the changes as output. */
-  vzictime_start->output = TRUE;
-  for (elem = matching_elements; elem; elem = elem->next) {
-    vzictime = elem->data;
-    vzictime->output = TRUE;
-  }
-
-  g_list_free (matching_elements);
-
-  return TRUE;
-}
-
-
-static void
-check_for_rdates                (FILE           *fp,
-                                 GArray         *changes,
-                                 int             idx)
-{
-  VzicTime *vzictime_start, *vzictime, tmp_vzictime;
-  gboolean is_daylight_start, is_daylight;
-  int i, year, month, day, time;
-
-  vzictime_start = &g_array_index (changes, VzicTime, idx);
-
-  is_daylight_start = (vzictime_start->stdoff != vzictime_start->walloff)
-    ? TRUE : FALSE;
-
-#if 0
-  printf ("\nChecking: %s OFFSETFROM: %i %s\n",
-          format_vzictime (vzictime_start), vzictime_start->prev_walloff,
-          is_daylight_start ? "DAYLIGHT" : "");
-#endif
-
-  /* We want to go backwards through the array now, for Outlook compatibility.
-     (It only looks at the first DTSTART/RDATE.) */
-  for (i = idx + 1; i < changes->len; i++) {
-    vzictime = &g_array_index (changes, VzicTime, i);
-
-    is_daylight = (vzictime->stdoff != vzictime->walloff) ? TRUE : FALSE;
-
-    if (vzictime->output)
-      continue;
-
-#if 0
-    printf ("          %s OFFSETFROM: %i %s\n", format_vzictime (vzictime),
-            vzictime->prev_walloff, is_daylight ? "DAYLIGHT" : "");
-#endif
-
-    /* It must be the same type of component - STANDARD or DAYLIGHT. */
-    if (is_daylight != is_daylight_start) {
-      continue;
-    }
-
-    /* The TZOFFSETFROM and TZOFFSETTO must match. */
-    if (vzictime->prev_walloff != vzictime_start->prev_walloff) {
-      continue;
-    }
-
-    if (vzictime->walloff != vzictime_start->walloff) {
-      continue;
-    }
-
-    /* TZNAME must match. */
-    if (!timezones_match (vzictime->tzname, vzictime_start->tzname)) {
-      continue;
-    }
-
-    /* We have a match. */
-
-    tmp_vzictime = *vzictime;
-    calculate_actual_time (&tmp_vzictime, TIME_WALL, vzictime->prev_stdoff,
-                           vzictime->prev_walloff);
-
-    fputs ("RDATE", fp);
-    if (vzictime->time_code != TIME_WALL) {
-      fprintf (fp, ";X-OBSERVED-AT=%c",
-               vzictime->time_code == TIME_UNIVERSAL ? 'Z' : 'S');
-    }
-    fprintf (fp, ":%s\r\n", format_time (tmp_vzictime.year,
-                                         tmp_vzictime.month,
-                                         tmp_vzictime.day_number,
-                                         tmp_vzictime.time_seconds));
-
-    vzictime->output = TRUE;
-  }
-}
-
-
-static gboolean
-timezones_match                         (char           *tzname1,
-                                         char           *tzname2)
-{
-  if (tzname1 && tzname2 && !strcmp (tzname1, tzname2))
-    return TRUE;
-
-  if (!tzname1 && !tzname2)
-    return TRUE;
-
-  return FALSE;
-}
-
-
-/* Outputs the start of a VTIMEZONE component, with the BEGIN line,
-   the DTSTART, TZOFFSETFROM, TZOFFSETTO & TZNAME properties. */
-static int
-output_component_start                  (char           *buffer,
-                                         VzicTime       *vzictime,
-                                         gboolean        output_rdate,
-                                         gboolean        use_same_tz_offset)
-{
-  gboolean is_daylight, skip_day_offset = FALSE;
-  gint year, month, day, time, day_offset = 0;
-  GDate old_date, new_date;
-  char *formatted_time;
-  char line1[1024], line2[1024], line3[1024];
-  char line4[1024], line5[1024], line6[1024];
-  VzicTime tmp_vzictime;
-  int prev_walloff, n;
-
-  is_daylight = (vzictime->stdoff != vzictime->walloff) ? TRUE : FALSE;
-
-  tmp_vzictime = *vzictime;
-  day_offset = calculate_actual_time (&tmp_vzictime, TIME_WALL,
-                                      vzictime->prev_stdoff,
-                                      vzictime->prev_walloff);
-
-  sprintf (line1, "BEGIN:%s\r\n", is_daylight ? "DAYLIGHT" : "STANDARD");
-
-  /* If the timezone only has one change, that means it uses the same offset
-     forever, so we use the same TZOFFSETFROM as the TZOFFSETTO. (If the zone
-     has more than one change, we don't output the first one.) */
-  if (use_same_tz_offset)
-    prev_walloff = vzictime->walloff;
-  else
-    prev_walloff = vzictime->prev_walloff;
-
-  if (vzictime->tzname)
-    sprintf (line2, "TZNAME:%s\r\n", vzictime->tzname);
-  else
-    line2[0] = '\0';
-
-  sprintf (line3, "TZOFFSETFROM:%s\r\n",
-           format_tz_offset (prev_walloff, !VzicPureOutput));
-
-  sprintf (line4, "TZOFFSETTO:%s\r\n",
-           format_tz_offset (vzictime->walloff, !VzicPureOutput));
-
-  formatted_time = format_time (tmp_vzictime.year, tmp_vzictime.month,
-                                tmp_vzictime.day_number,
-                                tmp_vzictime.time_seconds);
-  n = sprintf (line5, "DTSTART");
-  if (vzictime->time_code != TIME_WALL) {
-    n += sprintf (line5+n, ";X-OBSERVED-AT=%c",
-                  vzictime->time_code == TIME_UNIVERSAL ? 'Z' : 'S');
-  }
-  sprintf (line5+n, ":%s\r\n", formatted_time);
-#if 0  /* The RDATE matching DTSTART is unnecessary */
-  if (output_rdate)
-    sprintf (line6, "RDATE:%s\r\n", formatted_time);
-  else
-#endif
-    line6[0] = '\0';
-
-  sprintf (buffer, "%s%s%s%s%s%s", line1, line2, line3, line4, line5, line6);
-
-  return day_offset;
-}
-
-
-/* Outputs the END line of the VTIMEZONE component. */
-static void
-output_component_end                    (FILE           *fp,
-                                         VzicTime       *vzictime)
-{
-  gboolean is_daylight;
-
-  is_daylight = (vzictime->stdoff != vzictime->walloff) ? TRUE : FALSE;
-
-  fprintf (fp, "END:%s\r\n", is_daylight ? "DAYLIGHT" : "STANDARD");
-}
-
-
-/* Initializes a VzicTime to 1st Jan in YEAR_MINIMUM at midnight, with all
-   offsets set to 0. */
-static void
-vzictime_init                           (VzicTime       *vzictime)
-{
-  vzictime->year = YEAR_MINIMUM;
-  vzictime->month = 0;
-  vzictime->day_code = DAY_SIMPLE;
-  vzictime->day_number = 1;
-  vzictime->day_weekday = 0;
-  vzictime->time_seconds = 0;
-  vzictime->time_code = TIME_UNIVERSAL;
-  vzictime->stdoff = 0;
-  vzictime->walloff = 0;
-  vzictime->is_infinite = FALSE;
-  vzictime->until = NULL;
-  vzictime->output = FALSE;
-  vzictime->prev_stdoff = 0;
-  vzictime->prev_walloff = 0;
-  vzictime->tzname = NULL;
-}
-
-
-/* This calculates the actual local time that a change will occur, given
-   the offsets from standard and wall-clock time. It returns -1 or 1 if it
-   had to move backwards or forwards one day while converting to local time.
-   If it does this then we need to change the RRULEs we output. */
-static int
-calculate_actual_time           (VzicTime       *vzictime,
-                                 TimeCode        time_code,
-                                 int             stdoff,
-                                 int             walloff)
-{
-  GDate date;
-  gint day_offset, days_in_month, weekday, offset, result;
-
-  vzictime->time_seconds = calculate_wall_time (vzictime->time_seconds,
-                                                vzictime->time_code,
-                                                stdoff, walloff, &day_offset);
-
-  if (vzictime->day_code != DAY_SIMPLE) {
-    if (vzictime->year == YEAR_MINIMUM || vzictime->year == YEAR_MAXIMUM) {
-      fprintf (stderr, "In calculate_actual_time: invalid year\n");
-      exit (0);
-    }
-
-    g_date_clear (&date, 1);
-    days_in_month = g_date_days_in_month (vzictime->month + 1, vzictime->year);
-
-  /* Note that the day_code refers to the date before we convert it to
-     a wall-clock date and time. So we find the day it was referring to,
-     then make any adjustments needed due to converting the time. */
-    if (vzictime->day_code == DAY_LAST_WEEKDAY) {
-      /* Find out what day the last day of the month is. */
-      g_date_set_dmy (&date, days_in_month, vzictime->month + 1,
-                      vzictime->year);
-      weekday = g_date_weekday (&date) % 7;
-
-      /* Calculate how many days we have to go back to get to day_weekday. */
-      offset = (weekday + 7 - vzictime->day_weekday) % 7;
-
-      vzictime->day_number = days_in_month - offset;
-    } else {
-      /* Find out what day day_number actually is. */
-      g_date_set_dmy (&date, vzictime->day_number, vzictime->month + 1,
-                      vzictime->year);
-      weekday = g_date_weekday (&date) % 7;
-
-      if (vzictime->day_code == DAY_WEEKDAY_ON_OR_AFTER)
-        offset = (vzictime->day_weekday + 7 - weekday) % 7;
-      else
-        offset = - ((weekday + 7 - vzictime->day_weekday) % 7);
-
-      vzictime->day_number = vzictime->day_number + offset;
-    }
-
-    vzictime->day_code = DAY_SIMPLE;
-
-    if (vzictime->day_number > days_in_month) {
-      vzictime->month++;
-      vzictime->day_number -= days_in_month;
-    }
-
-    if (vzictime->day_number <= 0) {
-      fprintf (stderr, "Day overflow: %i\n", vzictime->day_number);
-      exit (1);
-    }
-  }
-
-#if 0
-  fprintf (stderr, "%s -> %i/%i/%i\n",
-           dump_day_coded (vzictime->day_code, vzictime->day_number,
-                           vzictime->day_weekday),
-           vzictime->day_number, vzictime->month + 1, vzictime->year);
-#endif
-
-  fix_time_overflow (&vzictime->year, &vzictime->month,
-                     &vzictime->day_number, day_offset);
-
-  /* If we want UTC time, we have to convert it now. */
-  if (time_code == TIME_UNIVERSAL) {
-    vzictime->time_seconds = calculate_until_time (vzictime->time_seconds,
-                                                   TIME_WALL, stdoff, walloff,
-                                                   &vzictime->year,
-                                                   &vzictime->month,
-                                                   &vzictime->day_number);
-  }
-
-  return day_offset;
-}
-
-
-/* This converts the given time into universal time (UTC), to be used in
-   the UNTIL property. */
-static int
-calculate_until_time                    (int             time,
-                                         TimeCode        time_code,
-                                         int             stdoff,
-                                         int             walloff,
-                                         int            *year,
-                                         int            *month,
-                                         int            *day)
-{
-  int result, day_offset;
-
-  day_offset = 0;
-
-  switch (time_code) {
-  case TIME_WALL:
-    result = time - walloff;
-    break;
-  case TIME_STANDARD:
-    result = time - stdoff;
-    break;
-  case TIME_UNIVERSAL:
-    return time;
-  default:
-    fprintf (stderr, "Invalid time code\n");
-    exit (1);
-  }
-
-  if (result < 0) {
-    result += 24 * 60 * 60;
-    day_offset = -1;
-  } else if (result >= 24 * 60 * 60) {
-    result -= 24 * 60 * 60;
-    day_offset = 1;
-  }
-
-  /* Sanity check - we shouldn't have an overflow any more. */
-  if (result < 0 || result >= 24 * 60 * 60) {
-    fprintf (stderr, "Time overflow: %i\n", result);
-    abort ();
-  }
-
-  fix_time_overflow (year, month, day, day_offset);
-
-  return result;
-}
-
-
-/* This converts the given time into wall clock time (the local standard time
-   with any adjustment for daylight-saving). */
-static int
-calculate_wall_time                     (int             time,
-                                         TimeCode        time_code,
-                                         int             stdoff,
-                                         int             walloff,
-                                         int            *day_offset)
-{
-  int result;
-
-  *day_offset = 0;
-
-  switch (time_code) {
-  case TIME_WALL:
-    /* We don't just return here so we can handle 24:00:00 below */
-    result = time;
-    break;
-  case TIME_STANDARD:
-    /* We have a local standard time, so we have to subtract stdoff to get
-       back to UTC, then add walloff to get wall time. */
-    result = time - stdoff + walloff;
-    break;
-  case TIME_UNIVERSAL:
-    result = time + walloff;
-    break;
-  default:
-    fprintf (stderr, "Invalid time code\n");
-    exit (1);
-  }
-
-  if (result < 0) {
-    result += 24 * 60 * 60;
-    *day_offset = -1;
-  } else if (result >= 24 * 60 * 60) {
-    result -= 24 * 60 * 60;
-    *day_offset = 1;
-  }
-
-  /* Sanity check - we shouldn't have an overflow any more. */
-  if (result < 0 || result >= 24 * 60 * 60) {
-    fprintf (stderr, "Time overflow: %i\n", result);
-    exit (1);
-  }
-
-#if 0
-  printf ("%s -> ", dump_time (time, time_code, TRUE));
-  printf ("%s (%i)\n", dump_time (result, TIME_WALL, TRUE), *day_offset);
-#endif
-
-  return result;
-}
-
-
-static void
-fix_time_overflow                       (int            *year,
-                                         int            *month,
-                                         int            *day,
-                                         int             day_offset)
-{
-  if (day_offset == -1) {
-    *day = *day - 1;
-
-    if (*day == 0) {
-      *month = *month - 1;
-      if (*month == -1) {
-        *month = 11;
-        *year = *year - 1;
-      }
-      *day = g_date_days_in_month (*month + 1, *year);
-    }
-  } else if (day_offset == 1) {
-    *day = *day + 1;
-
-    if (*day > g_date_days_in_month (*month + 1, *year)) {
-      *month = *month + 1;
-      if (*month == 12) {
-        *month = 0;
-        *year = *year + 1;
-      }
-      *day = 1;
-    }
-  }
-}
-
-
-static char*
-format_time                             (int             year,
-                                         int             month,
-                                         int             day,
-                                         int             time)
-{
-  static char buffer[128];
-  int hour, minute, second;
-
-  /* When we are outputting the first component year will be YEAR_MINIMUM.
-     We used to use 1 when outputting this, but Outlook doesn't like any years
-     less that 1600, so we use 1600 instead. We don't output the first change
-     for most zones now, so it doesn't matter too much. */
-  if (year == YEAR_MINIMUM)
-    year = 1601;
-
-  /* We just use 9999 here, so we keep to 4 characters. But this should only
-     be needed when debugging - it shouldn't be needed in the VTIMEZONEs. */
-  if (year == YEAR_MAXIMUM) {
-    fprintf (stderr, "format_time: YEAR_MAXIMUM used\n");
-    year = 9999;
-  }
-
-  hour = time / 3600;
-  minute = (time % 3600) / 60;
-  second = time % 60;
-
-  sprintf (buffer, "%04i%02i%02iT%02i%02i%02i",
-           year, month + 1, day, hour, minute, second);
-
-  return buffer;
-}
-
-
-/* Outlook doesn't support 6-digit values, i.e. including the seconds, so
-   we round to the nearest minute. No current offsets use the seconds value,
-   so we aren't losing much. */
-static char*
-format_tz_offset                        (int             tz_offset,
-                                         gboolean        round_seconds)
-{
-  static char buffer[128];
-  char *sign = "+";
-  int hours, minutes, seconds;
-
-  if (tz_offset < 0) {
-    tz_offset = -tz_offset;
-    sign = "-";
-  }
-
-  if (round_seconds)
-    tz_offset += 30;
-
-  hours = tz_offset / 3600;
-  minutes = (tz_offset % 3600) / 60;
-  seconds = tz_offset % 60;
-
-  if (round_seconds)
-    seconds = 0;
-
-  /* Sanity check. Standard timezone offsets shouldn't be much more than 12
-     hours, and daylight saving shouldn't change it by more than a few hours.
-     (The maximum offset is 15 hours 56 minutes at present.) */
-  if (hours < 0 || hours >= 24 || minutes < 0 || minutes >= 60
-      || seconds < 0 || seconds >= 60) {
-    fprintf (stderr, "WARNING: Strange timezone offset: H:%i M:%i S:%i\n",
-             hours, minutes, seconds);
-  }
-
-  if (seconds == 0)
-    sprintf (buffer, "%s%02i%02i", sign, hours, minutes);
-  else
-    sprintf (buffer, "%s%02i%02i%02i", sign, hours, minutes, seconds);
-
-  return buffer;
-}
-
-
-static gboolean
-output_rrule                            (char           *rrule_buffer,
-                                         int             month,
-                                         DayCode         day_code,
-                                         int             day_number,
-                                         int             day_weekday,
-                                         int             day_offset,
-                                         char           *until)
-{
-  char buffer[1024], buffer2[1024];
-
-  buffer[0] = '\0';
-
-  if (day_offset > 1 || day_offset < -1) {
-    fprintf (stderr, "Invalid day_offset: %i\n", day_offset);
-      exit (0);
-  }
-
-  /* If the DTSTART time was moved to another day when converting to local
-     time, we need to adjust the RRULE accordingly. e.g. If the original RRULE
-     was on the 19th of the month, but DTSTART was moved 1 day forward, then
-     we output the 20th of the month instead. */
-  if (day_offset == 1) {
-    if (day_code != DAY_LAST_WEEKDAY)
-      day_number++;
-    day_weekday = (day_weekday + 1) % 7;
-
-    /* Check we don't use February 29th. */
-    if (month == 1 && day_number > 28) {
-      fprintf (stderr, "Can't format RRULE - out of bounds. Month: %i Day number: %i\n", month + 1, day_number);
-      exit (0);
-    }
-
-    /* If we go past the end of the month, move to the next month. */
-    if (day_code != DAY_LAST_WEEKDAY && day_number > DaysInMonth[month]) {
-      month++;
-      day_number = 1;
-    }
-
-  } else if (day_offset == -1) {
-    if (day_code != DAY_LAST_WEEKDAY)
-      day_number--;
-    day_weekday = (day_weekday + 6) % 7;
-
-    if (day_code != DAY_LAST_WEEKDAY && day_number < 1)
-      fprintf (stderr, "Month: %i Day number: %i\n", month + 1, day_number);
-  }
-
-  switch (day_code) {
-  case DAY_SIMPLE:
-    /* Outlook (2000) will not parse the simple YEARLY RRULEs in VTIMEZONEs,
-       or BYMONTHDAY, or BYYEARDAY, which makes this option difficult!
-       Currently we use something like BYDAY=1SU, which will be incorrect
-       at times. This only affects Asia/Baghdad, Asia/Gaza, Asia/Jerusalem &
-       Asia/Damascus at present (and Jerusalem doesn't have specific rules
-       at the moment anyway, so that isn't a big loss). */
-    if (!VzicPureOutput) {
-      if (day_number < 8) {
-        printf ("WARNING: %s: Outputting BYDAY=1SU instead of BYMONTHDAY=1-7 for Outlook compatibility\n", CurrentZoneName);
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=1SU",
-                 month + 1);
-      } else if (day_number < 15) {
-        printf ("WARNING: %s: Outputting BYDAY=2SU instead of BYMONTHDAY=8-14 for Outlook compatibility\n", CurrentZoneName);
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=2SU",
-                 month + 1);
-      } else if (day_number < 22) {
-        printf ("WARNING: %s: Outputting BYDAY=3SU instead of BYMONTHDAY=15-21 for Outlook compatibility\n", CurrentZoneName);
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=3SU",
-                 month + 1);
-      } else {
-        printf ("ERROR: %s: Couldn't output RRULE (day=%i) compatible with Outlook\n", CurrentZoneName, day_number);
-        exit (1);
-      }
-    } else {
-        sprintf (buffer, "RRULE:FREQ=YEARLY");
-    }
-    break;
-
-  case DAY_WEEKDAY_ON_OR_AFTER:
-    if (day_number > DaysInMonth[month] - 6) {
-      /* This isn't actually needed at present. */
-#if 0
-      fprintf (stderr, "DAY_WEEKDAY_ON_OR_AFTER: %i %i\n", day_number,
-               month + 1);
-#endif
-
-      if (!VzicPureOutput) {
-        printf ("ERROR: %s: Couldn't output RRULE (day>=x) compatible with Outlook\n", CurrentZoneName);
-        exit (1);
-      } else {
-        /* We do 6 days at the end of this month, and 1 at the start of the
-           next. We can't do this if we want Outlook compatibility, as it
-           needs BYMONTHDAY, which Outlook doesn't support. */
-/*
-        sprintf (buffer,
-                 "RRULE:FREQ=YEARLY;BYMONTH=%i;BYMONTHDAY=%i,%i,%i,%i,%i,%i;BYDAY=%s",
-                 month + 1,
-                 day_number, day_number + 1, day_number + 2, day_number + 3,
-                 day_number + 4, day_number + 5,
-                 WeekDays[day_weekday]);
-
-        sprintf (buffer2,
-                 "RRULE:FREQ=YEARLY;BYMONTH=%i;BYMONTHDAY=1;BYDAY=%s",
-                 (month + 1) % 12 + 1,
-                 WeekDays[day_weekday]);
-
-        sprintf (rrule_buffer, "%s%s\n%s%s\r\n",
-                 buffer, until, buffer2, until);
-*/
-        /* Multiple RRULEs within the component are illegal according to new iCal RFC 5545,
-           so combine the above RRULEs (commented) into a single RRULE using BYYEARDAY */
-        day_number = 0;
-        int i;
-        for (i = month+1; i < 12; i++) {
-          day_number += DaysInMonth[i];
-        }
-        sprintf (rrule_buffer, "RRULE:FREQ=YEARLY;BYYEARDAY=-%i,-%i,-%i,-%i,-%i,-%i,-%i;BYDAY=%s%s\r\n",
-                 day_number, day_number+1, day_number+2, day_number+3,
-                 day_number+4, day_number+5, day_number+6, WeekDays[day_weekday], until);
-
-        return TRUE;
-      }
-    }
-
-    if (!output_rrule_2 (buffer, month, day_number, day_weekday))
-      return FALSE;
-
-    break;
-
-  case DAY_WEEKDAY_ON_OR_BEFORE:
-    if (day_number < 7) {
-      /* FIXME: This is unimplemented, but it isn't needed at present anway. */
-      fprintf (stderr, "DAY_WEEKDAY_ON_OR_BEFORE: %i. Unimplemented. Exiting...\n", day_number);
-      exit (0);
-    }
-
-    if (!output_rrule_2 (buffer, month, day_number - 6, day_weekday))
-      return FALSE;
-
-    break;
-
-  case DAY_LAST_WEEKDAY:
-    if (day_offset == 1) {
-      if (month == 1) {
-        fprintf (stderr, "DAY_LAST_WEEKDAY - day moved, in February - can't fix\n");
-        exit (0);
-      }
-
-      /* This is only used once at present, for Africa/Cairo. */
-#if 0
-      fprintf (stderr, "DAY_LAST_WEEKDAY - day moved\n");
-#endif
-
-      if (!VzicPureOutput) {
-        printf ("WARNING: %s: Modifying RRULE (last weekday) for Outlook compatibility\n", CurrentZoneName);
-        sprintf (buffer,
-                 "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=-1%s",
-                 month + 1, WeekDays[day_weekday]);
-        printf ("  Outputting: %s\n", buffer);
-      } else {
-        /* We do 6 days at the end of this month, and 1 at the start of the
-           next. We can't do this if we want Outlook compatibility, as it needs
-           BYMONTHDAY, which Outlook doesn't support. */
-/*
-        day_number = DaysInMonth[month];
-        sprintf (buffer,
-                 "RRULE:FREQ=YEARLY;BYMONTH=%i;BYMONTHDAY=%i,%i,%i,%i,%i,%i;BYDAY=%s",
-                 month + 1,
-                 day_number - 5, day_number - 4, day_number - 3,
-                 day_number - 2, day_number - 1, day_number,
-                 WeekDays[day_weekday]);
-
-        sprintf (buffer2,
-                 "RRULE:FREQ=YEARLY;BYMONTH=%i;BYMONTHDAY=1;BYDAY=%s",
-                 (month + 1) % 12 + 1,
-                 WeekDays[day_weekday]);
-
-        sprintf (rrule_buffer, "%s%s\r\n%s%s\r\n",
-                 buffer, until, buffer2, until);
-*/
-        /* Multiple RRULEs within the component are illegal according to new iCal RFC 5545,
-           so combine the above RRULEs (commented) into a single RRULE using BYYEARDAY */
-        day_number = 0;
-        int i;
-        for (i = month+1; i < 12; i++) {
-          day_number += DaysInMonth[i];
-        }
-        sprintf (rrule_buffer, "RRULE:FREQ=YEARLY;BYYEARDAY=-%i,-%i,-%i,-%i,-%i,-%i,-%i;BYDAY=%s%s\r\n",
-                 day_number, day_number+1, day_number+2, day_number+3,
-                 day_number+4, day_number+5, day_number+6, WeekDays[day_weekday], until);
-
-        return TRUE;
-      }
-
-    } else if (day_offset == -1) {
-      /* We do 7 days 1 day before the end of this month. */
-      day_number = DaysInMonth[month];
-
-      if (!output_rrule_2 (buffer, month, day_number - 7, day_weekday))
-        return FALSE;
-
-      sprintf (rrule_buffer, "%s%s\r\n", buffer, until);
-      return TRUE;
-    }
-
-    sprintf (buffer,
-             "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=-1%s",
-             month + 1, WeekDays[day_weekday]);
-    break;
-
-  default:
-    fprintf (stderr, "Invalid day code\n");
-    exit (1);
-  }
-
-  sprintf (rrule_buffer, "%s%s\r\n", buffer, until);
-  return TRUE;
-}
-
-
-/* This tries to convert a RRULE like 'BYMONTHDAY=8,9,10,11,12,13,14;BYDAY=FR'
-   into 'BYDAY=2FR'. We need this since Outlook doesn't accept BYMONTHDAY.
-   It returns FALSE if conversion is not possible. */
-static gboolean
-output_rrule_2                          (char           *buffer,
-                                         int             month,
-                                         int             day_number,
-                                         int             day_weekday)
-{
-
-  if (day_number == 1) {
-    /* Convert it to a BYDAY=1SU type of RRULE. */
-    sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=1%s",
-             month + 1, WeekDays[day_weekday]);
-
-  } else if (day_number == 8) {
-    /* Convert it to a BYDAY=2SU type of RRULE. */
-    sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=2%s",
-             month + 1, WeekDays[day_weekday]);
-
-  } else if (day_number == 15) {
-    /* Convert it to a BYDAY=3SU type of RRULE. */
-    sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=3%s",
-             month + 1, WeekDays[day_weekday]);
-
-  } else if (day_number == 22) {
-    /* Convert it to a BYDAY=4SU type of RRULE. (Currently not used.) */
-    sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=4%s",
-             month + 1, WeekDays[day_weekday]);
-
-  } else if (month != 1 && day_number == DaysInMonth[month] - 6) {
-    /* Convert it to a BYDAY=-1SU type of RRULE. (But never for February.) */
-    sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=-1%s",
-             month + 1, WeekDays[day_weekday]);
-
-  } else {
-    /* Can't convert to a correct RRULE. If we want Outlook compatibility we
-       have to use a slightly incorrect RRULE, so the time change will be 1
-       week out every 7 or so years. Alternatively we could possibly move the
-       change by an hour or so so we would always be 1 or 2 hours out, but
-       never 1 week out. Yes, that sounds a better idea. */
-    if (!VzicPureOutput) {
-      printf ("WARNING: %s: Modifying RRULE to be compatible with Outlook (day >= %i, month = %i)\n", CurrentZoneName, day_number, month + 1);
-
-      if (day_number == 2) {
-        /* Convert it to a BYDAY=1SU type of RRULE.
-           This is needed for Asia/Karachi. */
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=1%s",
-                 month + 1, WeekDays[day_weekday]);
-      } else if (day_number == 9) {
-        /* Convert it to a BYDAY=2SU type of RRULE.
-           This is needed for Antarctica/Palmer & America/Santiago. */
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=2%s",
-                 month + 1, WeekDays[day_weekday]);
-      } else if (month != 1 && day_number <= DaysInMonth[month] - 7 && day_number > DaysInMonth[month] - 14) {
-        /* Convert it to a BYDAY=-1SU type of RRULE. (But never for February.)
-           This is needed for America/Godthab. */
-        sprintf (buffer, "RRULE:FREQ=YEARLY;BYMONTH=%i;BYDAY=-1%s",
-                 month + 1, WeekDays[day_weekday]);
-      } else {
-        printf ("ERROR: %s: Couldn't modify RRULE to be compatible with Outlook (day >= %i, month = %i)\n", CurrentZoneName, day_number, month + 1);
-        exit (1);
-      }
-
-    } else {
-      sprintf (buffer,
-               "RRULE:FREQ=YEARLY;BYMONTH=%i;BYMONTHDAY=%i,%i,%i,%i,%i,%i,%i;BYDAY=%s",
-               month + 1,
-               day_number, day_number + 1, day_number + 2, day_number + 3,
-               day_number + 4, day_number + 5, day_number + 6,
-               WeekDays[day_weekday]);
-    }
-  }
-
-  return TRUE;
-}
-
-
-static char*
-format_vzictime                         (VzicTime       *vzictime)
-{
-  static char buffer[1024];
-
-  sprintf (buffer, "%s %2i %s %s %i %i %s",
-           dump_year (vzictime->year), vzictime->month + 1,
-           dump_day_coded (vzictime->day_code, vzictime->day_number,
-                           vzictime->day_weekday),
-           dump_time (vzictime->time_seconds, vzictime->time_code, TRUE),
-           vzictime->stdoff, vzictime->walloff,
-           vzictime->is_infinite ? "INFINITE" : "");
-
-  return buffer;
-}
-
-
-static void
-dump_changes                            (FILE           *fp,
-                                         char           *zone_name,
-                                         GArray         *changes)
-{
-  VzicTime *vzictime, *vzictime2 = NULL;
-  int i, year_offset, year;
-
-  for (i = 0; i < changes->len; i++) {
-    vzictime = &g_array_index (changes, VzicTime, i);
-
-    if (vzictime->year > MAX_CHANGES_YEAR)
-      return;
-
-    dump_change (fp, zone_name, vzictime, vzictime->year);
-  }
-
-  if (changes->len < 2)
-    return;
-
-  /* Now see if the changes array ends with a pair of recurring changes. */
-  vzictime = &g_array_index (changes, VzicTime, changes->len - 2);
-  vzictime2 = &g_array_index (changes, VzicTime, changes->len - 1);
-  if (!vzictime->is_infinite || !vzictime2->is_infinite)
-    return;
-
-  year_offset = 1;
-  for (;;) {
-    year = vzictime->year + year_offset;
-    if (year > MAX_CHANGES_YEAR)
-      break;
-    dump_change (fp, zone_name, vzictime, year);
-
-    year = vzictime2->year + year_offset;
-    if (year > MAX_CHANGES_YEAR)
-      break;
-    dump_change (fp, zone_name, vzictime2, year);
-
-    year_offset++;
-  }
-}
-
-
-static void
-dump_change                             (FILE           *fp,
-                                         char           *zone_name,
-                                         VzicTime       *vzictime,
-                                         int             year)
-{
-  int hour, minute, second;
-  VzicTime tmp_vzictime;
-  static char *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
-                            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
-
-  /* Output format is:
-
-        Zone-Name [tab] Date [tab] Time [tab] UTC-Offset
-
-     The Date and Time fields specify the time change in UTC.
-
-     The UTC Offset is for local (wall-clock) time. It is the amount of time
-     to add to UTC to get local time.
-  */
-
-  fprintf (fp, "%s\t", zone_name);
-
-  if (year == YEAR_MINIMUM) {
-    fprintf (fp, " 1 Jan 0001\t 0:00:00");
-  } else if (year == YEAR_MAXIMUM) {
-    fprintf (stderr, "Maximum year found in change time\n");
-    exit (1);
-  } else {
-    tmp_vzictime = *vzictime;
-    tmp_vzictime.year = year;
-    calculate_actual_time (&tmp_vzictime, TIME_UNIVERSAL,
-                           vzictime->prev_stdoff, vzictime->prev_walloff);
-
-    hour = tmp_vzictime.time_seconds / 3600;
-    minute = (tmp_vzictime.time_seconds % 3600) / 60;
-    second = tmp_vzictime.time_seconds % 60;
-
-    fprintf (fp, "%2i %s %04i\t%2i:%02i:%02i",
-             tmp_vzictime.day_number, months[tmp_vzictime.month],
-             tmp_vzictime.year, hour, minute, second);
-  }
-
-  fprintf (fp, "\t%s", format_tz_offset (vzictime->walloff, FALSE));
-
-  fprintf (fp, "\r\n");
-}
-
-
-void
-ensure_directory_exists         (char           *directory)
-{
-  struct stat filestat;
-
-  if (stat (directory, &filestat) != 0) {
-    /* If the directory doesn't exist, try to create it. */
-    if (errno == ENOENT) {
-      if (mkdir (directory, 0777) != 0) {
-        fprintf (stderr, "Can't create directory: %s\n", directory);
-        exit (1);
-      }
-    } else {
-      fprintf (stderr, "Error calling stat() on directory: %s\n", directory);
-      exit (1);
-    }
-  } else if (!S_ISDIR (filestat.st_mode)) {
-    fprintf (stderr, "Can't create directory, already exists: %s\n",
-             directory);
-    exit (1);
-  }
-}
-
-
-static void
-expand_tzid_prefix              (void)
-{
-  char *src, *dest;
-  char date_buf[16];
-  char ch1, ch2;
-  time_t t;
-  struct tm *tm;
-
-  /* Get today's date as a string in the format "YYYYMMDD". */
-  t = time (NULL);
-  tm = localtime (&t);
-  sprintf (date_buf, "%4i%02i%02i", tm->tm_year + 1900,
-           tm->tm_mon + 1, tm->tm_mday);
-
-  src = TZIDPrefix;
-  dest = TZIDPrefixExpanded;
-
-  while (ch1 = *src++) {
-
-    /* Look for a '%'. */
-    if (ch1 == '%') {
-      ch2 = *src++;
-
-      if (ch2 == 'D') {
-        /* '%D' gets expanded into the date string. */
-        strcpy (dest, date_buf);
-        dest += strlen (dest);
-      } else if (ch2 == '%') {
-        /* '%%' gets converted into one '%'. */
-        *dest++ = '%';
-      } else {
-        /* Anything else is output as is. */
-        *dest++ = '%';
-        *dest++ = ch2;
-      }
-    } else {
-      *dest++ = ch1;
-    }
-  }
-
-#if 0
-  printf ("TZID    : %s\n", TZIDPrefix);
-  printf ("Expanded: %s\n", TZIDPrefixExpanded);
-#endif
-}
diff -pruN 3.0.13-5/tools/vzic/vzic-output.h 3.2.0-3/tools/vzic/vzic-output.h
--- 3.0.13-5/tools/vzic/vzic-output.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-output.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-#ifndef _VZIC_OUTPUT_H_
-#define _VZIC_OUTPUT_H_
-
-#include <glib.h>
-
-void            output_vtimezone_files          (char           *directory,
-                                                 GArray         *zone_data,
-                                                 GHashTable     *rule_data,
-                                                 GHashTable     *link_data,
-                                                 GHashTable     *zones_hash,
-                                                 int             max_until_year);
-
-void            ensure_directory_exists         (char           *directory);
-
-#endif /* _VZIC_OUTPUT_H_ */
diff -pruN 3.0.13-5/tools/vzic/vzic-parse.c 3.2.0-3/tools/vzic/vzic-parse.c
--- 3.0.13-5/tools/vzic/vzic-parse.c	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-parse.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,951 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-#include <ctype.h>
-#include <limits.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <unistd.h>
-#include <libgen.h>
-
-#include "vzic.h"
-#include "vzic-parse.h"
-#include "vzic-output.h"
-
-/* This is the maximum line length we allow. */
-#define MAX_LINE_LEN    1024
-
-/* The maximum number of fields on a line. */
-#define MAX_FIELDS      12
-
-#define CREATE_SYMLINK  1
-
-typedef enum
-{
-  ZONE_ID               = 0,    /* The 'Zone' at the start of the line. */
-  ZONE_NAME             = 1,
-  ZONE_GMTOFF           = 2,
-  ZONE_RULES_SAVE       = 3,
-  ZONE_FORMAT           = 4,
-  ZONE_UNTIL_YEAR       = 5,
-  ZONE_UNTIL_MONTH      = 6,
-  ZONE_UNTIL_DAY        = 7,
-  ZONE_UNTIL_TIME       = 8
-} ZoneFieldNumber;
-
-
-typedef enum
-{
-  RULE_ID               = 0,    /* The 'Rule' at the start of the line. */
-  RULE_NAME             = 1,
-  RULE_FROM             = 2,
-  RULE_TO               = 3,
-  RULE_TYPE             = 4,
-  RULE_IN               = 5,
-  RULE_ON               = 6,
-  RULE_AT               = 7,
-  RULE_SAVE             = 8,
-  RULE_LETTER_S         = 9
-} RuleFieldNumber;
-
-
-typedef enum
-{
-  LINK_ID               = 0,    /* The 'Link' at the start of the line. */
-  LINK_FROM             = 1,
-  LINK_TO               = 2
-} LinkFieldNumber;
-
-
-/* This struct contains information used while parsing the files, and is
-   passed to most parsing functions. */
-typedef struct _ParsingData ParsingData;
-struct _ParsingData
-{
-  /* This is the line being parsed. buffer is a copy that we break into fields
-     and sub-fields as it is parsed. */
-  char  line[MAX_LINE_LEN];
-  char  buffer[MAX_LINE_LEN];
-
-  /* These are pointers to the start of each field in buffer. */
-  char *fields[MAX_FIELDS];
-  int   num_fields;
-
-  /* These are just for producing error messages. */
-  char *filename;
-  int   line_number;
-
-
-  /* This is an array of ZoneData structs, 1 for each timezone read. */
-  GArray *zone_data;
-
-  /* This is a hash table of arrays of RuleData structs. As each Rule line is
-     read in, a new RuleData struct is filled in and appended to the
-     appropriate GArray in the hash table. */
-  GHashTable *rule_data;
-
-  /* A hash containing data on the Link lines. The keys are the timezones
-     where the link is from (i.e. the timezone we will be outputting anyway)
-     and the data is a GList of timezones to link to (where we will copy the
-     timezone data to). */
-  GHashTable *link_data;
-
-  int   max_until_year;
-};
-
-
-/*
- * Parsing functions, used when reading the Olson timezone data file.
- */
-static void     parse_fields                    (ParsingData    *data);
-static gboolean parse_zone_line                 (ParsingData    *data);
-static gboolean parse_zone_continuation_line    (ParsingData    *data);
-static gboolean parse_zone_common               (ParsingData    *data,
-                                                 int             offset);
-static void     parse_rule_line                 (ParsingData    *data);
-static void     parse_link_line                 (ParsingData    *data);
-
-static int      parse_year                      (ParsingData    *data,
-                                                 char           *field,
-                                                 gboolean        accept_only,
-                                                 int             only_value);
-static int      parse_month                     (ParsingData    *data,
-                                                 char           *field);
-static DayCode  parse_day                       (ParsingData    *data,
-                                                 char           *field,
-                                                 int            *day,
-                                                 int            *weekday);
-static int      parse_weekday                   (ParsingData    *data,
-                                                 char           *field);
-static int      parse_time                      (ParsingData    *data,
-                                                 char           *field,
-                                                 TimeCode       *time_code);
-static int      parse_number                    (ParsingData    *data,
-                                                 char          **num);
-static int      parse_rules_save                (ParsingData    *data,
-                                                 char           *field,
-                                                 char          **rules);
-
-static void     parse_coord                     (char           *coord,
-                                                 int             len,
-                                                 int            *result);
-
-void
-parse_olson_file                (char           *filename,
-                                 GArray        **zone_data,
-                                 GHashTable    **rule_data,
-                                 GHashTable    **link_data,
-                                 int            *max_until_year)
-{
-  ParsingData data;
-  FILE *fp;
-  int zone_continues = 0;
-
-  *zone_data = g_array_new (FALSE, FALSE, sizeof (ZoneData));
-  *rule_data = g_hash_table_new (g_str_hash, g_str_equal);
-  *link_data = g_hash_table_new (g_str_hash, g_str_equal);
-
-  fp = fopen (filename, "r");
-  if (!fp) {
-    fprintf (stderr, "Couldn't open file: %s\n", filename);
-    exit (1);
-  }
-
-  data.filename = filename;
-  data.zone_data = *zone_data;
-  data.rule_data = *rule_data;
-  data.link_data = *link_data;
-  data.max_until_year = 0;
-
-  for (data.line_number = 0; ; data.line_number++) {
-    if (fgets (data.line, sizeof (data.line), fp) != data.line)
-      break;
-
-    strcpy (data.buffer, data.line);
-
-    parse_fields (&data);
-    if (data.num_fields == 0)
-      continue;
-
-    if (zone_continues) {
-      zone_continues = parse_zone_continuation_line (&data);
-    } else if (!strcmp (data.fields[0], "Zone")) {
-      zone_continues = parse_zone_line (&data);
-    } else if (!strcmp (data.fields[0], "Rule")) {
-      parse_rule_line (&data);
-    } else if (!strcmp (data.fields[0], "Link")) {
-      parse_link_line (&data);
-    } else if (!strcmp (data.fields[0], "Leap")) {
-      /* We don't care about Leap lines. */
-    } else {
-      fprintf (stderr, "%s:%i: Invalid line.\n%s\n", filename,
-               data.line_number, data.line);
-      exit (1);
-    }
-  }
-
-  if (ferror (fp)) {
-    fprintf (stderr, "Error reading file: %s\n", filename);
-    exit (1);
-  }
-
-  if (zone_continues) {
-    fprintf (stderr, "%s:%i: Zone continuation line expected.\n%s\n",
-             filename, data.line_number, data.line);
-    exit (1);
-  }
-
-  fclose (fp);
-
-#if 0
-  printf ("Max UNTIL year: %i\n", data.max_until_year);
-#endif
-  *max_until_year = data.max_until_year;
-}
-
-
-/* Converts the line into fields. */
-static void
-parse_fields                    (ParsingData    *data)
-{
-  int i;
-  char *p, *s, ch;
-
-  /* Reset all fields to NULL. */
-  for (i = 0; i < MAX_FIELDS; i++)
-    data->fields[i] = 0;
-
-  data->num_fields = 0;
-  p = data->buffer;
-
-  for (;;) {
-    /* Skip whitespace. */
-    while (isspace (*p))
-      p++;
-
-    /* See if we have reached the end of the line or a comment. */
-    if (*p == '\0' || *p == '#')
-      break;
-
-    /* We must have another field, so save the start position. */
-    data->fields[data->num_fields++] = p;
-
-    /* Now find the end of the field. If the field contains '"' characters
-       they are removed and we have to move the rest of the chars back. */
-    s = p;
-    for (;;) {
-      ch = *p;
-      if (ch == '\0' || ch == '#') {
-        /* Don't move p on since this is the end of the line. */
-        *s = '\0';
-        break;
-      } else if (isspace (ch)) {
-        *s = '\0';
-        p++;
-        break;
-      } else if (ch == '"') {
-        p++;
-        for (;;) {
-          ch = *p;
-          if (ch == '\0') {
-            fprintf (stderr,
-                     "%s:%i: Closing quote character ('\"') missing.\n%s\n",
-                     data->filename, data->line_number, data->line);
-            exit (1);
-          } else if (ch == '"') {
-            p++;
-            break;
-          } else {
-            *s++ = ch;
-          }
-          p++;
-        }
-      } else {
-        *s++ = ch;
-      }
-      p++;
-    }
-  }
-
-#if 0
-  printf ("%i fields: ", data->num_fields);
-  for (i = 0; i < data->num_fields; i++)
-    printf ("'%s' ", data->fields[i]);
-  printf ("\n");
-#endif
-}
-
-
-static gboolean
-parse_zone_line                 (ParsingData    *data)
-{
-  ZoneData zone;
-
-  /* All 5 fields up to FORMAT must be present. */
-  if (data->num_fields < 5 || data->num_fields > 9) {
-        fprintf (stderr, "%s:%i: Invalid Zone line - %i fields.\n%s\n",
-                 data->filename, data->line_number, data->num_fields,
-                 data->line);
-        exit (1);
-  }
-
-  zone.zone_name = g_strdup (data->fields[ZONE_NAME]);
-  zone.zone_line_data = g_array_new (FALSE, FALSE, sizeof (ZoneLineData));
-
-  g_array_append_val (data->zone_data, zone);
-
-  return parse_zone_common (data, 0);
-}
-
-
-static gboolean
-parse_zone_continuation_line    (ParsingData    *data)
-{
-  /* All 3 fields up to FORMAT must be present. */
-  if (data->num_fields < 3 || data->num_fields > 7) {
-        fprintf (stderr,
-                 "%s:%i: Invalid Zone continuation line - %i fields.\n%s\n",
-                 data->filename, data->line_number, data->num_fields,
-                 data->line);
-        exit (1);
-  }
-
-  return parse_zone_common (data, -2);
-}
-
-
-static gboolean
-parse_zone_common               (ParsingData    *data,
-                                 int             offset)
-{
-  ZoneData *zone;
-  ZoneLineData zone_line;
-  TimeCode time_code;
-
-  zone_line.stdoff_seconds = parse_time (data,
-                                         data->fields[ZONE_GMTOFF + offset],
-                                         &time_code);
-  zone_line.save_seconds = parse_rules_save (data,
-                                             data->fields[ZONE_RULES_SAVE + offset],
-                                             &zone_line.rules);
-
-  if (!VzicPureOutput) {
-    /* We round the UTC offsets to the nearest minute, to be compatible with
-       Outlook. This also works with -ve numbers, I think.
-       -56 % 60 = -59. -61 % 60 = -1. */
-    if (zone_line.stdoff_seconds >= 0)
-      zone_line.stdoff_seconds += 30;
-    else
-      zone_line.stdoff_seconds -= 29;
-    zone_line.stdoff_seconds -= zone_line.stdoff_seconds % 60;
-
-    if (zone_line.save_seconds >= 0)
-      zone_line.save_seconds += 30;
-    else
-      zone_line.save_seconds -= 29;
-    zone_line.save_seconds -= zone_line.save_seconds % 60;
-  }
-
-  zone_line.format = g_strdup (data->fields[ZONE_FORMAT + offset]);
-
-  if (data->num_fields - offset >= 6) {
-    zone_line.until_set = TRUE;
-    zone_line.until_year = parse_year (data,
-                                       data->fields[ZONE_UNTIL_YEAR + offset],
-                                       FALSE, 0);
-    zone_line.until_month = parse_month (data,
-                                         data->fields[ZONE_UNTIL_MONTH + offset]);
-    zone_line.until_day_code = parse_day (data,
-                                          data->fields[ZONE_UNTIL_DAY + offset],
-                                          &zone_line.until_day_number,
-                                          &zone_line.until_day_weekday);
-    zone_line.until_time_seconds = parse_time (data,
-                                               data->fields[ZONE_UNTIL_TIME + offset],
-                                               &zone_line.until_time_code);
-
-    /* We also want to know the maximum year used in any UNTIL value, so we
-       know where to expand all the infinite Rule data to. */
-    if (zone_line.until_year != YEAR_MAXIMUM
-        && zone_line.until_year != YEAR_MINIMUM)
-      data->max_until_year = MAX (data->max_until_year, zone_line.until_year);
-
-  } else {
-    zone_line.until_set = FALSE;
-  }
-
-  /* Append it to the last Zone, since that is the one we are currently
-     reading. */
-  zone = &g_array_index (data->zone_data, ZoneData, data->zone_data->len - 1);
-  g_array_append_val (zone->zone_line_data, zone_line);
-
-  return zone_line.until_set;
-}
-
-
-static void
-parse_rule_line                 (ParsingData    *data)
-{
-  GArray *rule_array;
-  RuleData rule;
-  char *name;
-  TimeCode time_code;
-
-  /* All 10 fields must be present. */
-  if (data->num_fields != 10) {
-        fprintf (stderr, "%s:%i: Invalid Rule line - %i fields.\n%s\n",
-                 data->filename, data->line_number, data->num_fields,
-                 data->line);
-        exit (1);
-  }
-
-  name = data->fields[RULE_NAME];
-
-  /* Create the GArray and add it to the hash table if it doesn't already
-     exist. */
-  rule_array = g_hash_table_lookup (data->rule_data, name);
-  if (!rule_array) {
-    rule_array = g_array_new (FALSE, FALSE, sizeof (RuleData));
-    g_hash_table_insert (data->rule_data, g_strdup (name), rule_array);
-  }
-
-  rule.from_year = parse_year (data, data->fields[RULE_FROM], FALSE, 0);
-  if (rule.from_year == YEAR_MAXIMUM) {
-    fprintf (stderr, "%s:%i: Invalid Rule FROM value: '%s'\n",
-             data->filename, data->line_number, data->fields[RULE_FROM]);
-    exit (1);
-  }
-
-  rule.to_year = parse_year (data, data->fields[RULE_TO], TRUE,
-                             rule.from_year);
-  if (rule.to_year == YEAR_MINIMUM) {
-    fprintf (stderr, "%s:%i: Invalid Rule TO value: %s\n",
-             data->filename, data->line_number, data->fields[RULE_TO]);
-    exit (1);
-  }
-
-  /* We also want to know the maximum year used in any TO/FROM value, so we
-     know where to expand all the infinite Rule data to. */
-  if (rule.to_year != YEAR_MAXIMUM)
-    data->max_until_year = MAX (data->max_until_year, rule.to_year);
-  else if (rule.from_year != YEAR_MINIMUM)
-    data->max_until_year = MAX (data->max_until_year, rule.from_year);
-
-  if (!strcmp (data->fields[RULE_TYPE], "-"))
-    rule.type = NULL;
-  else {
-    printf ("Type: %s\n", data->fields[RULE_TYPE]);
-    rule.type = g_strdup (data->fields[RULE_TYPE]);
-  }
-
-  rule.in_month = parse_month (data, data->fields[RULE_IN]);
-  rule.on_day_code = parse_day (data, data->fields[RULE_ON],
-                                &rule.on_day_number, &rule.on_day_weekday);
-  rule.at_time_seconds = parse_time (data, data->fields[RULE_AT],
-                                     &rule.at_time_code);
-  rule.save_seconds = parse_time (data, data->fields[RULE_SAVE], &time_code);
-
-  if (!strcmp (data->fields[RULE_LETTER_S], "-")) {
-    rule.letter_s = NULL;
-  } else {
-    rule.letter_s = g_strdup (data->fields[RULE_LETTER_S]);
-  }
-
-  rule.is_shallow_copy = FALSE;
-
-  g_array_append_val (rule_array, rule);
-}
-
-
-static void
-parse_link_line                 (ParsingData    *data)
-{
-  char *from, *to, *old_from;
-  GList *zone_list;
-
-  /* We must have 3 fields for a Link. */
-  if (data->num_fields != 3) {
-        fprintf (stderr, "%s:%i: Invalid Rule line - %i fields.\n%s\n",
-                 data->filename, data->line_number, data->num_fields,
-                 data->line);
-        exit (1);
-  }
-
-  from = data->fields[LINK_FROM];
-  to = data->fields[LINK_TO];
-
-#if 0
-  printf ("LINK FROM: %s\tTO: %s\n", from, to);
-#endif
-
-#if CREATE_SYMLINK
-  {
-      int len = strnlen(to,254);
-      int dirs = 0;
-      int i;
-      for (i = 0; i < len; i++) {
-          dirs += to[i] == '/' ? 1 : 0;
-      }
-      if (dirs >= 0) {
-          char rel_from[255];
-          char to_dir[255];
-          char to_path[255];
-          if (dirs == 0) {
-              sprintf(rel_from, "%s.ics", from);
-          } else if (dirs == 1) {
-              sprintf(rel_from, "../%s.ics", from);
-          } else if (dirs == 2) {
-              sprintf(rel_from, "../../%s.ics", from);
-          } else {
-              return;
-          }
-          sprintf(to_path, "%s/%s.ics", VzicOutputDir, to);
-          strncpy(to_dir, to_path, 254);
-          ensure_directory_exists(dirname(to_dir));
-          //printf("Creating symlink from %s to %s\n", rel_from, to_path);
-          symlink(rel_from, to_path);
-      }
-  }
-#else
-  if (g_hash_table_lookup_extended (data->link_data, from,
-                                    (gpointer) &old_from,
-                                    (gpointer) &zone_list)) {
-    from = old_from;
-  } else {
-    from = g_strdup (from);
-    zone_list = NULL;
-  }
-
-  zone_list = g_list_prepend (zone_list, g_strdup (to));
-
-  g_hash_table_insert (data->link_data, from, zone_list);
-#endif
-}
-
-
-static int
-parse_year                      (ParsingData    *data,
-                                 char           *field,
-                                 gboolean        accept_only,
-                                 int             only_value)
-{
-  int len, year = 0;
-  char *p;
-
-  if (!field) {
-    fprintf (stderr, "%s:%i: Missing year.\n%s\n", data->filename,
-             data->line_number, data->line);
-    exit (1);
-  }
-
-  len = strlen (field);
-  if (accept_only && !strncmp (field, "only", len))
-    return only_value;
-  if (len >= 2) {
-    if (!strncmp (field, "maximum", len))
-      return YEAR_MAXIMUM;
-    else if (!strncmp (field, "minimum", len))
-      return YEAR_MINIMUM;
-  }
-
-  for (p = field; *p; p++) {
-    if (*p < '0' || *p > '9') {
-        fprintf (stderr, "%s:%i: Invalid year: %s\n%s\n", data->filename,
-                 data->line_number, field, data->line);
-        exit (1);
-    }
-
-    year = year * 10 + *p - '0';
-  }
-
-  if (year < 1000 || year > 2100) {
-        fprintf (stderr, "%s:%i: Strange year: %s\n%s\n", data->filename,
-                 data->line_number, field, data->line);
-        exit (1);
-  }
-
-  return year;
-}
-
-
-/* Parses a month name, returning 0 (Jan) to 11 (Dec). */
-static int
-parse_month                     (ParsingData    *data,
-                                 char           *field)
-{
-  static char* months[] = { "january", "february", "march", "april", "may",
-                            "june", "july", "august", "september", "october",
-                            "november", "december" };
-  char *p;
-  int len, i;
-
-  /* If the field is missing, it must be the optional UNTIL month, so we return
-     0 for January. */
-  if (!field)
-    return 0;
-
-  for (p = field, len = 0; *p; p++, len++) {
-    *p = tolower (*p);
-  }
-
-  for (i = 0; i < 12; i++) {
-    if (!strncmp (field, months[i], len))
-      return i;
-  }
-
-  fprintf (stderr, "%s:%i: Invalid month: %s\n%s\n", data->filename,
-           data->line_number, field, data->line);
-  exit (1);
-}
-
-
-/* Parses a day specifier, returning a code representing the type of match
-   together with a day of the month and a weekday number (0=Sun). */
-static DayCode
-parse_day                       (ParsingData    *data,
-                                 char           *field,
-                                 int            *day,
-                                 int            *weekday)
-{
-  char *day_part, *p;
-  DayCode day_code;
-
-  if (!field) {
-    *day = 1;
-    return DAY_SIMPLE;
-  }
-
-  *day = *weekday = 0;
-
-  if (!strncmp (field, "last", 4)) {
-    *weekday = parse_weekday (data, field + 4);
-    /* We set the day to the end of the month to make sorting Rules easy. */
-    *day = 31;
-    return DAY_LAST_WEEKDAY;
-  }
-
-  day_part = field;
-  day_code = DAY_SIMPLE;
-
-  for (p = field; *p; p++) {
-    if (*p == '<' || *p == '>') {
-      if (*(p + 1) == '=') {
-        day_code = (*p == '<') ? DAY_WEEKDAY_ON_OR_BEFORE
-          : DAY_WEEKDAY_ON_OR_AFTER;
-        *p = '\0';
-        *weekday = parse_weekday (data, field);
-        day_part = p + 2;
-        break;
-      }
-
-      fprintf (stderr, "%s:%i: Invalid day: %s\n%s\n", data->filename,
-               data->line_number, field, data->line);
-      exit (1);
-    }
-  }
-
-  for (p = day_part; *p; p++) {
-    if (*p < '0' || *p > '9') {
-        fprintf (stderr, "%s:%i: Invalid day: %s\n%s\n", data->filename,
-                 data->line_number, field, data->line);
-        exit (1);
-    }
-
-    *day = *day * 10 + *p - '0';
-  }
-
-  if (*day < 1 || *day > 31) {
-    fprintf (stderr, "%s:%i: Invalid day: %s\n%s\n", data->filename,
-             data->line_number, field, data->line);
-    exit (1);
-  }
-
-  return day_code;
-}
-
-
-/* Parses a weekday name, returning 0 (Sun) to 6 (Sat). */
-static int
-parse_weekday                   (ParsingData    *data,
-                                 char           *field)
-{
-  static char* weekdays[] = { "sunday", "monday", "tuesday", "wednesday",
-                              "thursday", "friday", "saturday" };
-  char *p;
-  int len, i;
-
-  for (p = field, len = 0; *p; p++, len++) {
-    *p = tolower (*p);
-  }
-
-  for (i = 0; i < 7; i++) {
-    if (!strncmp (field, weekdays[i], len))
-      return i;
-  }
-
-  fprintf (stderr, "%s:%i: Invalid weekday: %s\n%s\n", data->filename,
-           data->line_number, field, data->line);
-  exit (1);
-}
-
-
-/* Parses a time (hour + minute + second) and returns the result in seconds,
-   together with a time code specifying whether it is Wall clock time,
-   local standard time, or universal time.
-   The time can start with a '-' in which case it will be negative. */
-static int
-parse_time                      (ParsingData    *data,
-                                 char           *field,
-                                 TimeCode       *time_code)
-{
-  char *p;
-  int hours = 0, minutes = 0, seconds = 0, result, negative = 0;
-
-  if (!field) {
-    *time_code = TIME_WALL;
-    return 0;
-  }
-
-  p = field;
-  if (*p == '-') {
-    p++;
-    negative = 1;
-  }
-
-  hours = parse_number (data, &p);
-
-  if (*p == ':') {
-    p++;
-    minutes = parse_number (data, &p);
-
-    if (*p == ':') {
-      p++;
-      seconds = parse_number (data, &p);
-    }
-  }
-
-  if (hours < 0 || hours > 24
-      || minutes < 0 || minutes > 59
-      || seconds < 0 || seconds > 59
-      || (hours == 24 && (minutes != 0 || seconds != 0))) {
-    fprintf (stderr, "%s:%i: Invalid time: %s\n%s\n", data->filename,
-             data->line_number, field, data->line);
-    exit (1);
-  }
-
-#if 0
-  /* Hack to work around older libical that doesn't support BYDAY + BYYEARDAY */
-  if (hours == 24) {
-    hours = 23;
-    minutes = 59;
-    seconds = 59;
-  }
-#endif
-
-#if 0
-  printf ("Time: %s -> %i:%02i:%02i\n", field, hours, minutes, seconds);
-#endif
-
-  result = hours * 3600 + minutes * 60 + seconds;
-  if (negative)
-    result = -result;
-
-  if (*p == '\0') {
-    *time_code = TIME_WALL;
-    return result;
-  }
-
-  if (*(p + 1) == '\0') {
-    if (*p == 'w') {
-      *time_code = TIME_WALL;
-      return result;
-    } else if (*p == 's') {
-      *time_code = TIME_STANDARD;
-      return result;
-    } else if (*p == 'u' || *p == 'g' || *p == 'z') {
-      *time_code = TIME_UNIVERSAL;
-      return result;
-    }
-  }
-
-  fprintf (stderr, "%s:%i: Invalid time: %s\n%s\n", data->filename,
-           data->line_number, field, data->line);
-  exit (1);
-}
-
-
-/* Parses a simple number and returns the result. The pointer argument
-   is moved to the first character after the number. */
-static int
-parse_number                    (ParsingData    *data,
-                                 char          **num)
-{
-  char *p;
-  int result;
-
-  p = *num;
-
-#if 0
-  printf ("In parse_number p:%s\n", p);
-#endif
-
-  // potential null value where '-' is specified. assume zero.
-  if (!p || !*p) {
-    return 0;
-  }
-
-  if (*p < '0' || *p > '9') {
-    fprintf (stderr, "%s:%i: Invalid number: %s\n%s\n", data->filename,
-             data->line_number, *num, data->line);
-    exit (1);
-  }
-
-  result = *p++ - '0';
-
-  while (*p >= '0' && *p <= '9')
-    result = result * 10 + *p++ - '0';
-
-  *num = p;
-  return result;
-}
-
-
-static int
-parse_rules_save                (ParsingData    *data,
-                                 char           *field,
-                                 char          **rules)
-{
-  TimeCode time_code;
-
-  *rules = NULL;
-
-  /* Check for just "-". */
-  if (field[0] == '-' && field[1] == '\0')
-    return 0;
-
-  /* Check for a time to add to local standard time. We don't care about a
-     time code here, since it is just an offset. */
-  if (*field == '-' || (*field >= '0' && *field <= '9'))
-    return parse_time (data, field, &time_code);
-
-  /* It must be a rules name. */
-  *rules = g_strdup (field);
-  return 0;
-}
-
-
-
-
-
-GHashTable*
-parse_zone_tab                  (char           *filename)
-{
-  GHashTable *zones_hash;
-  ZoneDescription *zone_desc;
-  FILE *fp;
-  char buf[4096];
-  gchar **fields, *zone_name, *latitude, *longitude, *p;
-
-
-  fp = fopen (filename, "r");
-  if (!fp) {
-    fprintf (stderr, "Couldn't open file: %s\n", filename);
-    exit (1);
-  }
-
-  zones_hash = g_hash_table_new (g_str_hash, g_str_equal);
-
-  while (fgets (buf, sizeof(buf), fp)) {
-    if (*buf == '#') continue;
-
-    g_strchomp (buf);
-    fields = g_strsplit (buf,"\t", 4);
-
-    if (strlen (fields[0]) != 2) {
-      fprintf (stderr, "Invalid zone description line: %s\n", buf);
-      exit (1);
-    }
-
-    zone_name = g_strdup (fields[2]);
-
-    zone_desc = g_new (ZoneDescription, 1);
-    zone_desc->country_code[0] = fields[0][0];
-    zone_desc->country_code[1] = fields[0][1];
-    zone_desc->comment = (fields[3] && fields[3][0]) ? g_strdup (fields[3])
-      : NULL;
-
-    /* Now parse the latitude and longitude. */
-    latitude = fields[1];
-    longitude = latitude + 1;
-    while (*longitude != '+' && *longitude != '-')
-      longitude++;
-
-    parse_coord (latitude, longitude - latitude, zone_desc->latitude);
-    parse_coord (longitude, strlen (longitude), zone_desc->longitude);
-
-    g_hash_table_insert (zones_hash, zone_name, zone_desc);
-
-#if 0
-    g_print ("Found zone: %s %i %02i %02i,%i %02i %02i\n", zone_name,
-             zone_desc->latitude[0], zone_desc->latitude[1],
-             zone_desc->latitude[2],
-             zone_desc->longitude[0], zone_desc->longitude[1],
-             zone_desc->longitude[2]);
-#endif
-  }
-
-  fclose (fp);
-
-  return zones_hash;
-}
-
-
-static void
-parse_coord                     (char           *coord,
-                                 int             len,
-                                 int            *result)
-{
-  int degrees = 0, minutes = 0, seconds = 0;
-
-  if (len == 5)
-    sscanf (coord + 1, "%2d%2d", &degrees, &minutes);
-  else if (len == 6)
-    sscanf (coord + 1, "%3d%2d", &degrees, &minutes);
-  else if (len == 7)
-    sscanf (coord + 1, "%2d%2d%2d", &degrees, &minutes, &seconds);
-  else if (len == 8)
-    sscanf (coord + 1, "%3d%2d%2d", &degrees, &minutes, &seconds);
-  else {
-    fprintf (stderr, "Invalid coordinate: %s\n", coord);
-    exit (1);
-  }
-
-  if (coord[0] == '-')
-    degrees = -degrees;
-
-  result[0] = degrees;
-  result[1] = minutes;
-  result[2] = seconds;
-}
-
diff -pruN 3.0.13-5/tools/vzic/vzic-parse.h 3.2.0-3/tools/vzic/vzic-parse.h
--- 3.0.13-5/tools/vzic/vzic-parse.h	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-parse.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-/*
- * Vzic - a program to convert Olson timezone database files into VZTIMEZONE
- * files compatible with the iCalendar specification (RFC2445).
- *
- * Copyright (C) 2000-2001 Ximian, Inc.
- * Copyright (C) 2003 Damon Chaplin.
- *
- * Author: Damon Chaplin <damon@gnome.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
- */
-
-#ifndef _VZIC_PARSE_H_
-#define _VZIC_PARSE_H_
-
-#include <glib.h>
-
-void            parse_olson_file                (char           *filename,
-                                                 GArray        **zone_data,
-                                                 GHashTable    **rule_data,
-                                                 GHashTable    **link_data,
-                                                 int            *max_until_year);
-
-GHashTable*     parse_zone_tab                  (char           *filename);
-
-#endif /* _VZIC_PARSE_H_ */
diff -pruN 3.0.13-5/tools/vzic/vzic-test.pl 3.2.0-3/tools/vzic/vzic-test.pl
--- 3.0.13-5/tools/vzic/vzic-test.pl	2019-12-16 04:12:05.000000000 +0000
+++ 3.2.0-3/tools/vzic/vzic-test.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,164 +0,0 @@
-#!/usr/bin/perl -w
-
-#
-# Vzic - a program to convert Olson timezone database files into VZTIMEZONE
-# files compatible with the iCalendar specification (RFC2445).
-#
-# Copyright (C) 2001 Ximian, Inc.
-# Copyright (C) 2003 Damon Chaplin.
-#
-# Author: Damon Chaplin <damon@gnome.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
-#
-
-#
-# This outputs an iCalendar file containing one event in each timezone,
-# as well as all the VTIMEZONEs. We use it for testing compatibility with
-# other iCalendar apps like Outlook, by trying to import it there.
-#
-# Currently we have 377 timezones (with tzdata2001d).
-#
-
-# Set this to the toplevel directory of the VTIMEZONE files.
-$ZONEINFO_DIR = "/home/damon/src/zoneinfo";
-
-$output_file = "calendar.ics";
-
-
-# Save this so we can restore it later.
-$input_record_separator = $/;
-
-chdir $ZONEINFO_DIR
-    || die "Can't cd to $ZONEINFO_DIR";
-
-# Create the output file, to contain all the VEVENTs & VTIMEZONEs.
-open (OUTPUTFILE, ">$output_file")
-    || die "Can't create file: $output_file";
-
-# Output the standard header.
-    print OUTPUTFILE <<EOF;
-BEGIN:VCALENDAR
-PRODID:-//Ximian//NONSGML Vzic Test//EN
-VERSION:2.0
-METHOD:PUBLISH
-EOF
-
-$zone_num = 0;
-
-# 365 days in a non-leap year.
-@days_in_month = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
-
-foreach $file (`find -name "*.ics"`) {
-    # Get rid of './' at start and whitespace at end.
-    $file =~ s/^\.\///;
-    $file =~ s/\s+$//;
-
-    if ($file eq $output_file) {
-        next;
-    }
-
-#    print "File: $file\n";
-
-    # Get the VTIMEZONE data.
-    open (ZONEFILE, "$file")
-        || die "Can't open file: $ZONEINFO_DIR/$file";
-    undef $/;
-    $vtimezone = <ZONEFILE>;
-    $/ = $input_record_separator;
-    close (ZONEFILE);
-
-    # Strip the stuff before and after the VTIMEZONE component
-    $vtimezone =~ s/^.*BEGIN:VTIMEZONE/BEGIN:VTIMEZONE/s;
-    $vtimezone =~ s/END:VTIMEZONE.*$/END:VTIMEZONE\n/s;
-
-    print OUTPUTFILE $vtimezone;
-
-    # Find the TZID.
-    $vtimezone =~ m/TZID:(.*)/;
-    $tzid = $1;
-#    print "TZID: $tzid\n";
-
-    # Find the location.
-    $file =~ m/(.*)\.ics/;
-    $location = $1;
-#    print "LOCATION: $location\n";
-
-    # Try to find the current UTC offset that Outlook will use.
-    # If there is an RRULE, we look for the first 2 TZOFFSETTO properties,
-    # else we just get the first one.
-    if ($vtimezone =~ m/RRULE/) {
-        $vtimezone =~ m/TZOFFSETTO:([+-]?\d+)/;
-        $tzoffsetto = $1;
-        $vtimezone =~ m/TZOFFSETFROM:([+-]?\d+)/;
-        $tzoffsetfrom = $1;
-        $tzoffset = "$tzoffsetfrom/$tzoffsetto";
-    } else {
-        $vtimezone =~ m/TZOFFSETTO:([+-]?\d+)/s;
-        $tzoffset = $1;
-    }
-#    print "TZOFFSET: $tzoffset\n";
-
-    # We put each event on a separate day in 2001 and Jan 2002.
-    $day_num = $zone_num;
-    if ($day_num >= 365) {
-        $year = 2002;
-        $day_num -= 365;
-    } else {
-        $year = 2001;
-    }
-    $month = -1;
-    for ($i = 0; $i < 12; $i++) {
-        if ($day_num < $days_in_month[$i]) {
-            $month = $i;
-            last;
-        }
-        $day_num -= $days_in_month[$i]
-    }
-    if ($month == -1) {
-        die "month = -1";
-    }
-
-    $month++;
-    $day_num++;
-    $date = sprintf ("%i%02i%02i", $year, $month, $day_num);
-#    print "Date: $date\n";
-
-    # Output a VEVENT using the timezone.
-    print OUTPUTFILE <<EOF;
-BEGIN:VEVENT
-UID:vzic-test-${zone_num}
-DTSTAMP:20010101T000000Z
-DTSTART;TZID=${tzid}:${date}T120000
-DTEND;TZID=${tzid}:${date}T130000
-RRULE:FREQ=MONTHLY;BYMONTHDAY=${day_num}
-SUMMARY:($tzoffset) ${location} 12:00-13:00 UTC
-SEQUENCE:1
-END:VEVENT
-EOF
-
-    $zone_num++;
-
-    # Use this to stop after a certain number.
-#    last if ($zone_num == 100);
-}
-
-# Output the standard footer.
-    print OUTPUTFILE <<EOF;
-END:VCALENDAR
-EOF
-
-close (OUTPUTFILE);
-
diff -pruN 3.0.13-5/VERSION 3.2.0-3/VERSION
--- 3.0.13-5/VERSION	2019-12-16 04:16:33.000000000 +0000
+++ 3.2.0-3/VERSION	2020-05-04 04:11:04.000000000 +0000
@@ -1 +1 @@
-3.0.13
+3.2.0
